#include "tree_sitter/parser.h"

#if defined(__GNUC__) || defined(__clang__)
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif

#ifdef _MSC_VER
#pragma optimize("", off)
#elif defined(__clang__)
#pragma clang optimize off
#elif defined(__GNUC__)
#pragma GCC optimize ("O0")
#endif

#define LANGUAGE_VERSION 14
#define STATE_COUNT 7557
#define LARGE_STATE_COUNT 2845
#define SYMBOL_COUNT 409
#define ALIAS_COUNT 4
#define TOKEN_COUNT 200
#define EXTERNAL_TOKEN_COUNT 20
#define FIELD_COUNT 21
#define MAX_ALIAS_SEQUENCE_LENGTH 9
#define PRODUCTION_ID_COUNT 62

enum ts_symbol_identifiers {
  sym_identifier = 1,
  anon_sym_namespace = 2,
  anon_sym_module = 3,
  anon_sym_EQ = 4,
  anon_sym_open = 5,
  anon_sym_LBRACK_LT = 6,
  anon_sym_GT_RBRACK = 7,
  anon_sym_COLON = 8,
  anon_sym_assembly = 9,
  anon_sym_return = 10,
  anon_sym_field = 11,
  anon_sym_property = 12,
  anon_sym_param = 13,
  anon_sym_type = 14,
  anon_sym_constructor = 15,
  anon_sym_event = 16,
  anon_sym_do = 17,
  anon_sym_and = 18,
  anon_sym_let = 19,
  anon_sym_let_BANG = 20,
  anon_sym_rec = 21,
  anon_sym_inline = 22,
  anon_sym_mutable = 23,
  aux_sym_access_modifier_token1 = 24,
  anon_sym_as = 25,
  anon_sym_LPAREN = 26,
  anon_sym_RPAREN = 27,
  anon_sym_COMMA = 28,
  anon_sym_null = 29,
  anon_sym__ = 30,
  anon_sym_QMARK = 31,
  anon_sym_COLON_QMARK = 32,
  anon_sym_COLON_COLON = 33,
  anon_sym_PIPE = 34,
  anon_sym_AMP = 35,
  anon_sym_LBRACK = 36,
  anon_sym_RBRACK = 37,
  anon_sym_LBRACK_PIPE = 38,
  anon_sym_PIPE_RBRACK = 39,
  anon_sym_LBRACE = 40,
  anon_sym_RBRACE = 41,
  anon_sym_LT_AT = 42,
  anon_sym_AT_GT = 43,
  anon_sym_LT_AT_AT = 44,
  anon_sym_AT_AT_GT = 45,
  anon_sym_DOT = 46,
  anon_sym_LBRACE_PIPE = 47,
  anon_sym_PIPE_RBRACE = 48,
  anon_sym_new = 49,
  anon_sym_with = 50,
  anon_sym_return_BANG = 51,
  anon_sym_yield = 52,
  anon_sym_yield_BANG = 53,
  anon_sym_lazy = 54,
  anon_sym_assert = 55,
  anon_sym_upcast = 56,
  anon_sym_downcast = 57,
  anon_sym_COLON_GT = 58,
  anon_sym_COLON_QMARK_GT = 59,
  anon_sym_for = 60,
  anon_sym_in = 61,
  anon_sym_to = 62,
  anon_sym_downto = 63,
  anon_sym_done = 64,
  anon_sym_while = 65,
  anon_sym_else = 66,
  anon_sym_then = 67,
  anon_sym_elif = 68,
  anon_sym_if = 69,
  anon_sym_fun = 70,
  anon_sym_DASH_GT = 71,
  anon_sym_try = 72,
  anon_sym_finally = 73,
  anon_sym_match = 74,
  anon_sym_match_BANG = 75,
  anon_sym_function = 76,
  anon_sym_LT_DASH = 77,
  anon_sym_DOT_LBRACK = 78,
  anon_sym_LT = 79,
  anon_sym_GT = 80,
  anon_sym_use = 81,
  anon_sym_use_BANG = 82,
  anon_sym_do_BANG = 83,
  anon_sym_DOT_DOT = 84,
  anon_sym_when = 85,
  anon_sym_begin = 86,
  anon_sym_end = 87,
  anon_sym_LPAREN2 = 88,
  anon_sym_DOT_DOT2 = 89,
  anon_sym_DOT_DOT3 = 90,
  anon_sym_STAR = 91,
  anon_sym_LT2 = 92,
  anon_sym_LBRACK_RBRACK = 93,
  anon_sym_POUND = 94,
  anon_sym_CARET = 95,
  anon_sym_SQUOTE = 96,
  anon_sym_unit = 97,
  anon_sym_struct = 98,
  anon_sym_not = 99,
  anon_sym_enum = 100,
  anon_sym_unmanaged = 101,
  anon_sym_equality = 102,
  anon_sym_comparison = 103,
  anon_sym_delegate = 104,
  anon_sym_default = 105,
  anon_sym_or = 106,
  anon_sym_static = 107,
  anon_sym_member = 108,
  anon_sym_get = 109,
  anon_sym_set = 110,
  anon_sym_interface = 111,
  anon_sym_id = 112,
  anon_sym_exception = 113,
  anon_sym_of = 114,
  anon_sym_class = 115,
  anon_sym_abstract = 116,
  anon_sym_val = 117,
  anon_sym_override = 118,
  anon_sym_inherit = 119,
  anon_sym_EQ2 = 120,
  sym__escape_char = 121,
  sym__non_escape_char = 122,
  sym__unicodegraph_short = 123,
  sym__unicodegraph_long = 124,
  sym__trigraph = 125,
  aux_sym__simple_string_char_token1 = 126,
  aux_sym_char_token1 = 127,
  anon_sym_LBRACE2 = 128,
  anon_sym_DOLLAR_DQUOTE = 129,
  anon_sym_DQUOTE = 130,
  anon_sym_BSLASH = 131,
  aux_sym__verbatim_string_char_token1 = 132,
  anon_sym_AT_DQUOTE = 133,
  anon_sym_DQUOTE2 = 134,
  anon_sym_DQUOTEB = 135,
  anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE = 136,
  anon_sym_DQUOTE_DQUOTE_DQUOTE = 137,
  sym_bool = 138,
  sym_unit = 139,
  anon_sym_LPAREN_PIPE = 140,
  anon_sym_PIPE_RPAREN = 141,
  sym_op_identifier = 142,
  anon_sym_PLUS = 143,
  anon_sym_DASH = 144,
  anon_sym_PLUS_DOT = 145,
  anon_sym_DASH_DOT = 146,
  anon_sym_PERCENT = 147,
  anon_sym_AMP_AMP = 148,
  anon_sym_TILDE = 149,
  aux_sym_prefix_op_token1 = 150,
  aux_sym_infix_op_token1 = 151,
  aux_sym_infix_op_token2 = 152,
  anon_sym_PIPE_PIPE = 153,
  anon_sym_BANG_EQ = 154,
  anon_sym_COLON_EQ = 155,
  anon_sym_DOLLAR = 156,
  anon_sym_QMARK_LT_DASH = 157,
  sym_int = 158,
  sym_xint = 159,
  anon_sym_y = 160,
  anon_sym_uy = 161,
  anon_sym_s = 162,
  anon_sym_us = 163,
  anon_sym_l = 164,
  aux_sym_uint32_token1 = 165,
  anon_sym_n = 166,
  anon_sym_un = 167,
  anon_sym_L = 168,
  aux_sym_uint64_token1 = 169,
  anon_sym_f = 170,
  anon_sym_lf = 171,
  anon_sym_LF = 172,
  aux_sym_bignum_token1 = 173,
  aux_sym_decimal_token1 = 174,
  anon_sym_DOT2 = 175,
  aux_sym_float_token1 = 176,
  anon_sym_LPAREN_STAR = 177,
  anon_sym_STAR_RPAREN = 178,
  sym_line_comment = 179,
  anon_sym_POUNDnowarn = 180,
  anon_sym_POUNDlight = 181,
  anon_sym_POUNDr = 182,
  anon_sym_POUNDload = 183,
  aux_sym_fsi_directive_decl_token1 = 184,
  aux_sym_preproc_line_token1 = 185,
  anon_sym_POUNDif = 186,
  anon_sym_POUNDendif = 187,
  anon_sym_POUNDelse = 188,
  sym__newline = 189,
  sym__indent = 190,
  sym__dedent = 191,
  sym__struct_begin = 192,
  sym__interface_begin = 193,
  sym__triple_quoted_content = 194,
  sym_block_comment_content = 195,
  sym__inside_string_marker = 196,
  sym__newline_not_aligned = 197,
  sym__tuple_marker = 198,
  sym__error_sentinel = 199,
  sym_file = 200,
  sym_namespace = 201,
  sym_attributes = 202,
  sym__attribute_set = 203,
  sym_attribute = 204,
  sym__attribute_target = 205,
  sym__object_construction = 206,
  sym_value_declaration = 207,
  sym_do = 208,
  sym__function_or_value_defns = 209,
  sym_function_or_value_defn = 210,
  sym__function_or_value_defn_body = 211,
  sym_function_declaration_left = 212,
  sym_value_declaration_left = 213,
  sym_access_modifier = 214,
  sym_repeat_pattern = 215,
  sym__pattern = 216,
  sym_optional_pattern = 217,
  sym_type_check_pattern = 218,
  sym_attribute_pattern = 219,
  sym_paren_pattern = 220,
  sym_as_pattern = 221,
  sym_cons_pattern = 222,
  sym_disjunct_pattern = 223,
  sym_conjunct_pattern = 224,
  sym_typed_pattern = 225,
  sym_argument_patterns = 226,
  sym_field_pattern = 227,
  sym__atomic_pattern = 228,
  sym__list_pattern_content = 229,
  sym_list_pattern = 230,
  sym_array_pattern = 231,
  sym_record_pattern = 232,
  sym_named_field = 233,
  sym_named_field_pattern = 234,
  sym_identifier_pattern = 235,
  sym__expression_block = 236,
  sym__expression = 237,
  sym_literal_expression = 238,
  sym_long_identifier_or_op = 239,
  sym_tuple_expression = 240,
  sym_brace_expression = 241,
  sym_anon_record_expression = 242,
  sym_object_expression = 243,
  sym_with_field_expression = 244,
  sym_prefixed_expression = 245,
  sym_typecast_expression = 246,
  sym_for_expression = 247,
  sym_while_expression = 248,
  sym__else_expression = 249,
  sym_elif_expression = 250,
  sym__if_branch = 251,
  sym_if_expression = 252,
  sym_fun_expression = 253,
  sym_try_expression = 254,
  sym_match_expression = 255,
  sym_function_expression = 256,
  sym_mutate_expression = 257,
  sym_index_expression = 258,
  sym_typed_expression = 259,
  sym_declaration_expression = 260,
  sym_do_expression = 261,
  sym__list_elements = 262,
  sym__list_element = 263,
  sym_list_expression = 264,
  sym_array_expression = 265,
  sym_range_expression = 266,
  sym_rule = 267,
  sym_rules = 268,
  sym_begin_end_expression = 269,
  sym_paren_expression = 270,
  sym__high_prec_app = 271,
  sym__low_prec_app = 272,
  sym_application_expression = 273,
  sym_dot_expression = 274,
  sym_infix_expression = 275,
  sym_ce_expression = 276,
  sym_sequential_expression = 277,
  sym__comp_or_range_expression = 278,
  sym_short_comp_expression = 279,
  sym_slice_ranges = 280,
  sym__slice_range_special = 281,
  sym_slice_range = 282,
  sym__type = 283,
  sym_simple_type = 284,
  sym_generic_type = 285,
  sym_paren_type = 286,
  sym_function_type = 287,
  sym_compound_type = 288,
  sym_postfix_type = 289,
  sym_list_type = 290,
  sym_static_type = 291,
  sym_constrained_type = 292,
  sym_flexible_type = 293,
  sym_anon_record_type = 294,
  sym_types = 295,
  sym__static_type_identifier = 296,
  sym__static_parameter = 297,
  sym_named_static_parameter = 298,
  sym_type_attribute = 299,
  sym_type_attributes = 300,
  sym_atomic_type = 301,
  sym_constraint = 302,
  sym_type_argument_constraints = 303,
  sym_type_argument = 304,
  sym_type_argument_defn = 305,
  sym_type_arguments = 306,
  sym_trait_member_constraint = 307,
  sym_member_signature = 308,
  sym_curried_spec = 309,
  sym_argument_spec = 310,
  sym_arguments_spec = 311,
  sym_argument_name_spec = 312,
  sym_static_parameter_value = 313,
  sym_record_fields = 314,
  sym_record_field = 315,
  sym_interface_implementation = 316,
  sym__member_defns = 317,
  sym__object_members = 318,
  sym_member_defn = 319,
  sym_property_or_ident = 320,
  sym__method_defn = 321,
  sym__property_accessor_body = 322,
  sym_property_accessor = 323,
  sym__property_defn = 324,
  sym__val_property_defn = 325,
  sym_method_or_prop_defn = 326,
  sym_additional_constr_defn = 327,
  sym_field_initializer = 328,
  sym_field_initializers = 329,
  sym__simple_string_char = 330,
  sym__string_char = 331,
  sym_char = 332,
  sym_format_string_eval = 333,
  sym_format_string = 334,
  sym__string_literal = 335,
  sym_string = 336,
  sym__verbatim_string_char = 337,
  sym_verbatim_string = 338,
  sym_bytearray = 339,
  sym_verbatim_bytearray = 340,
  sym_format_triple_quoted_string = 341,
  sym_triple_quoted_string = 342,
  sym_const = 343,
  sym_long_identifier = 344,
  sym_active_pattern = 345,
  sym__identifier_or_op = 346,
  sym__infix_or_prefix_op = 347,
  sym_prefix_op = 348,
  sym_infix_op = 349,
  sym_sbyte = 350,
  sym_byte = 351,
  sym_int16 = 352,
  sym_uint16 = 353,
  sym_int32 = 354,
  sym_uint32 = 355,
  sym_nativeint = 356,
  sym_unativeint = 357,
  sym_int64 = 358,
  sym_uint64 = 359,
  sym_ieee32 = 360,
  sym_ieee64 = 361,
  sym_bignum = 362,
  sym_decimal = 363,
  sym_float = 364,
  sym_block_comment = 365,
  sym_compiler_directive_decl = 366,
  sym_fsi_directive_decl = 367,
  sym_preproc_line = 368,
  sym_preproc_if_in_expression = 369,
  sym_preproc_else_in_expression = 370,
  sym_module = 371,
  sym__module_signature_elements = 372,
  sym_value_definition = 373,
  aux_sym_file_repeat1 = 374,
  aux_sym_attributes_repeat1 = 375,
  aux_sym__attribute_set_repeat1 = 376,
  aux_sym__function_or_value_defns_repeat1 = 377,
  aux_sym_repeat_pattern_repeat1 = 378,
  aux_sym_argument_patterns_repeat1 = 379,
  aux_sym__list_pattern_content_repeat1 = 380,
  aux_sym_record_pattern_repeat1 = 381,
  aux_sym_named_field_pattern_repeat1 = 382,
  aux_sym__object_expression_inner_repeat1 = 383,
  aux_sym_if_expression_repeat1 = 384,
  aux_sym__list_elements_repeat1 = 385,
  aux_sym_rules_repeat1 = 386,
  aux_sym_sequential_expression_repeat1 = 387,
  aux_sym_slice_ranges_repeat1 = 388,
  aux_sym_compound_type_repeat1 = 389,
  aux_sym_types_repeat1 = 390,
  aux_sym_type_attributes_repeat1 = 391,
  aux_sym_type_argument_constraints_repeat1 = 392,
  aux_sym_type_argument_repeat1 = 393,
  aux_sym_type_arguments_repeat1 = 394,
  aux_sym_curried_spec_repeat1 = 395,
  aux_sym_arguments_spec_repeat1 = 396,
  aux_sym_record_fields_repeat1 = 397,
  aux_sym__member_defns_repeat1 = 398,
  aux_sym__method_defn_repeat1 = 399,
  aux_sym__property_defn_repeat1 = 400,
  aux_sym_field_initializers_repeat1 = 401,
  aux_sym_format_string_repeat1 = 402,
  aux_sym__string_literal_repeat1 = 403,
  aux_sym_verbatim_string_repeat1 = 404,
  aux_sym_long_identifier_repeat1 = 405,
  aux_sym_active_pattern_repeat1 = 406,
  aux_sym_prefix_op_repeat1 = 407,
  aux_sym_preproc_if_in_expression_repeat1 = 408,
  anon_alias_sym_SEMI = 409,
  alias_sym_active_pattern_op_name = 410,
  alias_sym_wildcard_active_pattern_op = 411,
  alias_sym_wildcard_pattern = 412,
};

static const char * const ts_symbol_names[] = {
  [ts_builtin_sym_end] = "end",
  [sym_identifier] = "identifier",
  [anon_sym_namespace] = "namespace",
  [anon_sym_module] = "module",
  [anon_sym_EQ] = "=",
  [anon_sym_open] = "open",
  [anon_sym_LBRACK_LT] = "[<",
  [anon_sym_GT_RBRACK] = ">]",
  [anon_sym_COLON] = ":",
  [anon_sym_assembly] = "assembly",
  [anon_sym_return] = "return",
  [anon_sym_field] = "field",
  [anon_sym_property] = "property",
  [anon_sym_param] = "param",
  [anon_sym_type] = "type",
  [anon_sym_constructor] = "constructor",
  [anon_sym_event] = "event",
  [anon_sym_do] = "do",
  [anon_sym_and] = "and",
  [anon_sym_let] = "let",
  [anon_sym_let_BANG] = "let!",
  [anon_sym_rec] = "rec",
  [anon_sym_inline] = "inline",
  [anon_sym_mutable] = "mutable",
  [aux_sym_access_modifier_token1] = "access_modifier_token1",
  [anon_sym_as] = "as",
  [anon_sym_LPAREN] = "(",
  [anon_sym_RPAREN] = ")",
  [anon_sym_COMMA] = ",",
  [anon_sym_null] = "null",
  [anon_sym__] = "_",
  [anon_sym_QMARK] = "\?",
  [anon_sym_COLON_QMARK] = ":\?",
  [anon_sym_COLON_COLON] = "::",
  [anon_sym_PIPE] = "|",
  [anon_sym_AMP] = "&",
  [anon_sym_LBRACK] = "[",
  [anon_sym_RBRACK] = "]",
  [anon_sym_LBRACK_PIPE] = "[|",
  [anon_sym_PIPE_RBRACK] = "|]",
  [anon_sym_LBRACE] = "{",
  [anon_sym_RBRACE] = "}",
  [anon_sym_LT_AT] = "<@",
  [anon_sym_AT_GT] = "@>",
  [anon_sym_LT_AT_AT] = "<@@",
  [anon_sym_AT_AT_GT] = "@@>",
  [anon_sym_DOT] = ".",
  [anon_sym_LBRACE_PIPE] = "{|",
  [anon_sym_PIPE_RBRACE] = "|}",
  [anon_sym_new] = "new",
  [anon_sym_with] = "with",
  [anon_sym_return_BANG] = "return!",
  [anon_sym_yield] = "yield",
  [anon_sym_yield_BANG] = "yield!",
  [anon_sym_lazy] = "lazy",
  [anon_sym_assert] = "assert",
  [anon_sym_upcast] = "upcast",
  [anon_sym_downcast] = "downcast",
  [anon_sym_COLON_GT] = ":>",
  [anon_sym_COLON_QMARK_GT] = ":\?>",
  [anon_sym_for] = "for",
  [anon_sym_in] = "in",
  [anon_sym_to] = "to",
  [anon_sym_downto] = "downto",
  [anon_sym_done] = "done",
  [anon_sym_while] = "while",
  [anon_sym_else] = "else",
  [anon_sym_then] = "then",
  [anon_sym_elif] = "elif",
  [anon_sym_if] = "if",
  [anon_sym_fun] = "fun",
  [anon_sym_DASH_GT] = "->",
  [anon_sym_try] = "try",
  [anon_sym_finally] = "finally",
  [anon_sym_match] = "match",
  [anon_sym_match_BANG] = "match!",
  [anon_sym_function] = "function",
  [anon_sym_LT_DASH] = "<-",
  [anon_sym_DOT_LBRACK] = ".[",
  [anon_sym_LT] = "<",
  [anon_sym_GT] = ">",
  [anon_sym_use] = "use",
  [anon_sym_use_BANG] = "use!",
  [anon_sym_do_BANG] = "do!",
  [anon_sym_DOT_DOT] = "..",
  [anon_sym_when] = "when",
  [anon_sym_begin] = "begin",
  [anon_sym_end] = "end",
  [anon_sym_LPAREN2] = "(",
  [anon_sym_DOT_DOT2] = "..",
  [anon_sym_DOT_DOT3] = "..",
  [anon_sym_STAR] = "*",
  [anon_sym_LT2] = "<",
  [anon_sym_LBRACK_RBRACK] = "[]",
  [anon_sym_POUND] = "#",
  [anon_sym_CARET] = "^",
  [anon_sym_SQUOTE] = "'",
  [anon_sym_unit] = "unit",
  [anon_sym_struct] = "struct",
  [anon_sym_not] = "not",
  [anon_sym_enum] = "enum",
  [anon_sym_unmanaged] = "unmanaged",
  [anon_sym_equality] = "equality",
  [anon_sym_comparison] = "comparison",
  [anon_sym_delegate] = "delegate",
  [anon_sym_default] = "default",
  [anon_sym_or] = "or",
  [anon_sym_static] = "static",
  [anon_sym_member] = "member",
  [anon_sym_get] = "get",
  [anon_sym_set] = "set",
  [anon_sym_interface] = "interface",
  [anon_sym_id] = "id",
  [anon_sym_exception] = "exception",
  [anon_sym_of] = "of",
  [anon_sym_class] = "class",
  [anon_sym_abstract] = "abstract",
  [anon_sym_val] = "val",
  [anon_sym_override] = "override",
  [anon_sym_inherit] = "inherit",
  [anon_sym_EQ2] = "=",
  [sym__escape_char] = "_escape_char",
  [sym__non_escape_char] = "_non_escape_char",
  [sym__unicodegraph_short] = "_unicodegraph_short",
  [sym__unicodegraph_long] = "_unicodegraph_long",
  [sym__trigraph] = "_trigraph",
  [aux_sym__simple_string_char_token1] = "_simple_string_char_token1",
  [aux_sym_char_token1] = "char_token1",
  [anon_sym_LBRACE2] = "{",
  [anon_sym_DOLLAR_DQUOTE] = "$\"",
  [anon_sym_DQUOTE] = "\"",
  [anon_sym_BSLASH] = "\\",
  [aux_sym__verbatim_string_char_token1] = "_verbatim_string_char_token1",
  [anon_sym_AT_DQUOTE] = "@\"",
  [anon_sym_DQUOTE2] = "\"",
  [anon_sym_DQUOTEB] = "\"B",
  [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = "$\"\"\"",
  [anon_sym_DQUOTE_DQUOTE_DQUOTE] = "\"\"\"",
  [sym_bool] = "bool",
  [sym_unit] = "unit",
  [anon_sym_LPAREN_PIPE] = "(|",
  [anon_sym_PIPE_RPAREN] = "|)",
  [sym_op_identifier] = "op_identifier",
  [anon_sym_PLUS] = "+",
  [anon_sym_DASH] = "-",
  [anon_sym_PLUS_DOT] = "+.",
  [anon_sym_DASH_DOT] = "-.",
  [anon_sym_PERCENT] = "%",
  [anon_sym_AMP_AMP] = "&&",
  [anon_sym_TILDE] = "~",
  [aux_sym_prefix_op_token1] = "prefix_op_token1",
  [aux_sym_infix_op_token1] = "infix_op_token1",
  [aux_sym_infix_op_token2] = "infix_op_token2",
  [anon_sym_PIPE_PIPE] = "||",
  [anon_sym_BANG_EQ] = "!=",
  [anon_sym_COLON_EQ] = ":=",
  [anon_sym_DOLLAR] = "$",
  [anon_sym_QMARK_LT_DASH] = "\?<-",
  [sym_int] = "int",
  [sym_xint] = "xint",
  [anon_sym_y] = "y",
  [anon_sym_uy] = "uy",
  [anon_sym_s] = "s",
  [anon_sym_us] = "us",
  [anon_sym_l] = "l",
  [aux_sym_uint32_token1] = "uint32_token1",
  [anon_sym_n] = "n",
  [anon_sym_un] = "un",
  [anon_sym_L] = "L",
  [aux_sym_uint64_token1] = "uint64_token1",
  [anon_sym_f] = "f",
  [anon_sym_lf] = "lf",
  [anon_sym_LF] = "LF",
  [aux_sym_bignum_token1] = "bignum_token1",
  [aux_sym_decimal_token1] = "decimal_token1",
  [anon_sym_DOT2] = "float",
  [aux_sym_float_token1] = "float",
  [anon_sym_LPAREN_STAR] = "(*",
  [anon_sym_STAR_RPAREN] = "*)",
  [sym_line_comment] = "line_comment",
  [anon_sym_POUNDnowarn] = "#nowarn",
  [anon_sym_POUNDlight] = "#light",
  [anon_sym_POUNDr] = "#r",
  [anon_sym_POUNDload] = "#load",
  [aux_sym_fsi_directive_decl_token1] = "fsi_directive_decl_token1",
  [aux_sym_preproc_line_token1] = "#line",
  [anon_sym_POUNDif] = "#if",
  [anon_sym_POUNDendif] = "#endif",
  [anon_sym_POUNDelse] = "#else",
  [sym__newline] = "_newline",
  [sym__indent] = "_indent",
  [sym__dedent] = "_dedent",
  [sym__struct_begin] = "struct",
  [sym__interface_begin] = "interface",
  [sym__triple_quoted_content] = "_triple_quoted_content",
  [sym_block_comment_content] = "block_comment_content",
  [sym__inside_string_marker] = "_inside_string_marker",
  [sym__newline_not_aligned] = "_newline_not_aligned",
  [sym__tuple_marker] = "_tuple_marker",
  [sym__error_sentinel] = "_error_sentinel",
  [sym_file] = "file",
  [sym_namespace] = "namespace",
  [sym_attributes] = "attributes",
  [sym__attribute_set] = "_attribute_set",
  [sym_attribute] = "attribute",
  [sym__attribute_target] = "_attribute_target",
  [sym__object_construction] = "_object_construction",
  [sym_value_declaration] = "value_declaration",
  [sym_do] = "do",
  [sym__function_or_value_defns] = "_function_or_value_defns",
  [sym_function_or_value_defn] = "function_or_value_defn",
  [sym__function_or_value_defn_body] = "_function_or_value_defn_body",
  [sym_function_declaration_left] = "function_declaration_left",
  [sym_value_declaration_left] = "value_declaration_left",
  [sym_access_modifier] = "access_modifier",
  [sym_repeat_pattern] = "repeat_pattern",
  [sym__pattern] = "_pattern",
  [sym_optional_pattern] = "optional_pattern",
  [sym_type_check_pattern] = "type_check_pattern",
  [sym_attribute_pattern] = "attribute_pattern",
  [sym_paren_pattern] = "paren_pattern",
  [sym_as_pattern] = "as_pattern",
  [sym_cons_pattern] = "cons_pattern",
  [sym_disjunct_pattern] = "disjunct_pattern",
  [sym_conjunct_pattern] = "conjunct_pattern",
  [sym_typed_pattern] = "typed_pattern",
  [sym_argument_patterns] = "argument_patterns",
  [sym_field_pattern] = "field_pattern",
  [sym__atomic_pattern] = "_atomic_pattern",
  [sym__list_pattern_content] = "_list_pattern_content",
  [sym_list_pattern] = "list_pattern",
  [sym_array_pattern] = "array_pattern",
  [sym_record_pattern] = "record_pattern",
  [sym_named_field] = "named_field",
  [sym_named_field_pattern] = "named_field_pattern",
  [sym_identifier_pattern] = "identifier_pattern",
  [sym__expression_block] = "_expression_block",
  [sym__expression] = "_expression",
  [sym_literal_expression] = "literal_expression",
  [sym_long_identifier_or_op] = "long_identifier_or_op",
  [sym_tuple_expression] = "tuple_expression",
  [sym_brace_expression] = "brace_expression",
  [sym_anon_record_expression] = "anon_record_expression",
  [sym_object_expression] = "object_expression",
  [sym_with_field_expression] = "with_field_expression",
  [sym_prefixed_expression] = "prefixed_expression",
  [sym_typecast_expression] = "typecast_expression",
  [sym_for_expression] = "for_expression",
  [sym_while_expression] = "while_expression",
  [sym__else_expression] = "_else_expression",
  [sym_elif_expression] = "elif_expression",
  [sym__if_branch] = "_if_branch",
  [sym_if_expression] = "if_expression",
  [sym_fun_expression] = "fun_expression",
  [sym_try_expression] = "try_expression",
  [sym_match_expression] = "match_expression",
  [sym_function_expression] = "function_expression",
  [sym_mutate_expression] = "mutate_expression",
  [sym_index_expression] = "index_expression",
  [sym_typed_expression] = "typed_expression",
  [sym_declaration_expression] = "declaration_expression",
  [sym_do_expression] = "do_expression",
  [sym__list_elements] = "_list_elements",
  [sym__list_element] = "_list_element",
  [sym_list_expression] = "list_expression",
  [sym_array_expression] = "array_expression",
  [sym_range_expression] = "range_expression",
  [sym_rule] = "rule",
  [sym_rules] = "rules",
  [sym_begin_end_expression] = "begin_end_expression",
  [sym_paren_expression] = "paren_expression",
  [sym__high_prec_app] = "_high_prec_app",
  [sym__low_prec_app] = "_low_prec_app",
  [sym_application_expression] = "application_expression",
  [sym_dot_expression] = "dot_expression",
  [sym_infix_expression] = "infix_expression",
  [sym_ce_expression] = "ce_expression",
  [sym_sequential_expression] = "sequential_expression",
  [sym__comp_or_range_expression] = "_comp_or_range_expression",
  [sym_short_comp_expression] = "short_comp_expression",
  [sym_slice_ranges] = "slice_ranges",
  [sym__slice_range_special] = "_slice_range_special",
  [sym_slice_range] = "slice_range",
  [sym__type] = "_type",
  [sym_simple_type] = "simple_type",
  [sym_generic_type] = "generic_type",
  [sym_paren_type] = "paren_type",
  [sym_function_type] = "function_type",
  [sym_compound_type] = "compound_type",
  [sym_postfix_type] = "postfix_type",
  [sym_list_type] = "list_type",
  [sym_static_type] = "static_type",
  [sym_constrained_type] = "constrained_type",
  [sym_flexible_type] = "flexible_type",
  [sym_anon_record_type] = "anon_record_type",
  [sym_types] = "types",
  [sym__static_type_identifier] = "_static_type_identifier",
  [sym__static_parameter] = "_static_parameter",
  [sym_named_static_parameter] = "named_static_parameter",
  [sym_type_attribute] = "type_attribute",
  [sym_type_attributes] = "type_attributes",
  [sym_atomic_type] = "atomic_type",
  [sym_constraint] = "constraint",
  [sym_type_argument_constraints] = "type_argument_constraints",
  [sym_type_argument] = "type_argument",
  [sym_type_argument_defn] = "type_argument_defn",
  [sym_type_arguments] = "type_arguments",
  [sym_trait_member_constraint] = "trait_member_constraint",
  [sym_member_signature] = "member_signature",
  [sym_curried_spec] = "curried_spec",
  [sym_argument_spec] = "argument_spec",
  [sym_arguments_spec] = "arguments_spec",
  [sym_argument_name_spec] = "argument_name_spec",
  [sym_static_parameter_value] = "static_parameter_value",
  [sym_record_fields] = "record_fields",
  [sym_record_field] = "record_field",
  [sym_interface_implementation] = "interface_implementation",
  [sym__member_defns] = "_member_defns",
  [sym__object_members] = "_object_members",
  [sym_member_defn] = "member_defn",
  [sym_property_or_ident] = "property_or_ident",
  [sym__method_defn] = "_method_defn",
  [sym__property_accessor_body] = "_property_accessor_body",
  [sym_property_accessor] = "property_accessor",
  [sym__property_defn] = "_property_defn",
  [sym__val_property_defn] = "_val_property_defn",
  [sym_method_or_prop_defn] = "method_or_prop_defn",
  [sym_additional_constr_defn] = "additional_constr_defn",
  [sym_field_initializer] = "field_initializer",
  [sym_field_initializers] = "field_initializers",
  [sym__simple_string_char] = "_simple_string_char",
  [sym__string_char] = "_string_char",
  [sym_char] = "char",
  [sym_format_string_eval] = "format_string_eval",
  [sym_format_string] = "format_string",
  [sym__string_literal] = "_string_literal",
  [sym_string] = "string",
  [sym__verbatim_string_char] = "_verbatim_string_char",
  [sym_verbatim_string] = "verbatim_string",
  [sym_bytearray] = "bytearray",
  [sym_verbatim_bytearray] = "verbatim_bytearray",
  [sym_format_triple_quoted_string] = "format_triple_quoted_string",
  [sym_triple_quoted_string] = "triple_quoted_string",
  [sym_const] = "const",
  [sym_long_identifier] = "long_identifier",
  [sym_active_pattern] = "active_pattern",
  [sym__identifier_or_op] = "_identifier_or_op",
  [sym__infix_or_prefix_op] = "_infix_or_prefix_op",
  [sym_prefix_op] = "prefix_op",
  [sym_infix_op] = "infix_op",
  [sym_sbyte] = "sbyte",
  [sym_byte] = "byte",
  [sym_int16] = "int16",
  [sym_uint16] = "uint16",
  [sym_int32] = "int32",
  [sym_uint32] = "uint32",
  [sym_nativeint] = "nativeint",
  [sym_unativeint] = "unativeint",
  [sym_int64] = "int64",
  [sym_uint64] = "uint64",
  [sym_ieee32] = "ieee32",
  [sym_ieee64] = "ieee64",
  [sym_bignum] = "bignum",
  [sym_decimal] = "decimal",
  [sym_float] = "float",
  [sym_block_comment] = "block_comment",
  [sym_compiler_directive_decl] = "compiler_directive_decl",
  [sym_fsi_directive_decl] = "fsi_directive_decl",
  [sym_preproc_line] = "preproc_line",
  [sym_preproc_if_in_expression] = "preproc_if",
  [sym_preproc_else_in_expression] = "preproc_else",
  [sym_module] = "module",
  [sym__module_signature_elements] = "_module_signature_elements",
  [sym_value_definition] = "value_definition",
  [aux_sym_file_repeat1] = "file_repeat1",
  [aux_sym_attributes_repeat1] = "attributes_repeat1",
  [aux_sym__attribute_set_repeat1] = "_attribute_set_repeat1",
  [aux_sym__function_or_value_defns_repeat1] = "_function_or_value_defns_repeat1",
  [aux_sym_repeat_pattern_repeat1] = "repeat_pattern_repeat1",
  [aux_sym_argument_patterns_repeat1] = "argument_patterns_repeat1",
  [aux_sym__list_pattern_content_repeat1] = "_list_pattern_content_repeat1",
  [aux_sym_record_pattern_repeat1] = "record_pattern_repeat1",
  [aux_sym_named_field_pattern_repeat1] = "named_field_pattern_repeat1",
  [aux_sym__object_expression_inner_repeat1] = "_object_expression_inner_repeat1",
  [aux_sym_if_expression_repeat1] = "if_expression_repeat1",
  [aux_sym__list_elements_repeat1] = "_list_elements_repeat1",
  [aux_sym_rules_repeat1] = "rules_repeat1",
  [aux_sym_sequential_expression_repeat1] = "sequential_expression_repeat1",
  [aux_sym_slice_ranges_repeat1] = "slice_ranges_repeat1",
  [aux_sym_compound_type_repeat1] = "compound_type_repeat1",
  [aux_sym_types_repeat1] = "types_repeat1",
  [aux_sym_type_attributes_repeat1] = "type_attributes_repeat1",
  [aux_sym_type_argument_constraints_repeat1] = "type_argument_constraints_repeat1",
  [aux_sym_type_argument_repeat1] = "type_argument_repeat1",
  [aux_sym_type_arguments_repeat1] = "type_arguments_repeat1",
  [aux_sym_curried_spec_repeat1] = "curried_spec_repeat1",
  [aux_sym_arguments_spec_repeat1] = "arguments_spec_repeat1",
  [aux_sym_record_fields_repeat1] = "record_fields_repeat1",
  [aux_sym__member_defns_repeat1] = "_member_defns_repeat1",
  [aux_sym__method_defn_repeat1] = "_method_defn_repeat1",
  [aux_sym__property_defn_repeat1] = "_property_defn_repeat1",
  [aux_sym_field_initializers_repeat1] = "field_initializers_repeat1",
  [aux_sym_format_string_repeat1] = "format_string_repeat1",
  [aux_sym__string_literal_repeat1] = "_string_literal_repeat1",
  [aux_sym_verbatim_string_repeat1] = "verbatim_string_repeat1",
  [aux_sym_long_identifier_repeat1] = "long_identifier_repeat1",
  [aux_sym_active_pattern_repeat1] = "active_pattern_repeat1",
  [aux_sym_prefix_op_repeat1] = "prefix_op_repeat1",
  [aux_sym_preproc_if_in_expression_repeat1] = "preproc_if_in_expression_repeat1",
  [anon_alias_sym_SEMI] = ";",
  [alias_sym_active_pattern_op_name] = "active_pattern_op_name",
  [alias_sym_wildcard_active_pattern_op] = "wildcard_active_pattern_op",
  [alias_sym_wildcard_pattern] = "wildcard_pattern",
};

static const TSSymbol ts_symbol_map[] = {
  [ts_builtin_sym_end] = ts_builtin_sym_end,
  [sym_identifier] = sym_identifier,
  [anon_sym_namespace] = anon_sym_namespace,
  [anon_sym_module] = anon_sym_module,
  [anon_sym_EQ] = anon_sym_EQ,
  [anon_sym_open] = anon_sym_open,
  [anon_sym_LBRACK_LT] = anon_sym_LBRACK_LT,
  [anon_sym_GT_RBRACK] = anon_sym_GT_RBRACK,
  [anon_sym_COLON] = anon_sym_COLON,
  [anon_sym_assembly] = anon_sym_assembly,
  [anon_sym_return] = anon_sym_return,
  [anon_sym_field] = anon_sym_field,
  [anon_sym_property] = anon_sym_property,
  [anon_sym_param] = anon_sym_param,
  [anon_sym_type] = anon_sym_type,
  [anon_sym_constructor] = anon_sym_constructor,
  [anon_sym_event] = anon_sym_event,
  [anon_sym_do] = anon_sym_do,
  [anon_sym_and] = anon_sym_and,
  [anon_sym_let] = anon_sym_let,
  [anon_sym_let_BANG] = anon_sym_let_BANG,
  [anon_sym_rec] = anon_sym_rec,
  [anon_sym_inline] = anon_sym_inline,
  [anon_sym_mutable] = anon_sym_mutable,
  [aux_sym_access_modifier_token1] = aux_sym_access_modifier_token1,
  [anon_sym_as] = anon_sym_as,
  [anon_sym_LPAREN] = anon_sym_LPAREN,
  [anon_sym_RPAREN] = anon_sym_RPAREN,
  [anon_sym_COMMA] = anon_sym_COMMA,
  [anon_sym_null] = anon_sym_null,
  [anon_sym__] = anon_sym__,
  [anon_sym_QMARK] = anon_sym_QMARK,
  [anon_sym_COLON_QMARK] = anon_sym_COLON_QMARK,
  [anon_sym_COLON_COLON] = anon_sym_COLON_COLON,
  [anon_sym_PIPE] = anon_sym_PIPE,
  [anon_sym_AMP] = anon_sym_AMP,
  [anon_sym_LBRACK] = anon_sym_LBRACK,
  [anon_sym_RBRACK] = anon_sym_RBRACK,
  [anon_sym_LBRACK_PIPE] = anon_sym_LBRACK_PIPE,
  [anon_sym_PIPE_RBRACK] = anon_sym_PIPE_RBRACK,
  [anon_sym_LBRACE] = anon_sym_LBRACE,
  [anon_sym_RBRACE] = anon_sym_RBRACE,
  [anon_sym_LT_AT] = anon_sym_LT_AT,
  [anon_sym_AT_GT] = anon_sym_AT_GT,
  [anon_sym_LT_AT_AT] = anon_sym_LT_AT_AT,
  [anon_sym_AT_AT_GT] = anon_sym_AT_AT_GT,
  [anon_sym_DOT] = anon_sym_DOT,
  [anon_sym_LBRACE_PIPE] = anon_sym_LBRACE_PIPE,
  [anon_sym_PIPE_RBRACE] = anon_sym_PIPE_RBRACE,
  [anon_sym_new] = anon_sym_new,
  [anon_sym_with] = anon_sym_with,
  [anon_sym_return_BANG] = anon_sym_return_BANG,
  [anon_sym_yield] = anon_sym_yield,
  [anon_sym_yield_BANG] = anon_sym_yield_BANG,
  [anon_sym_lazy] = anon_sym_lazy,
  [anon_sym_assert] = anon_sym_assert,
  [anon_sym_upcast] = anon_sym_upcast,
  [anon_sym_downcast] = anon_sym_downcast,
  [anon_sym_COLON_GT] = anon_sym_COLON_GT,
  [anon_sym_COLON_QMARK_GT] = anon_sym_COLON_QMARK_GT,
  [anon_sym_for] = anon_sym_for,
  [anon_sym_in] = anon_sym_in,
  [anon_sym_to] = anon_sym_to,
  [anon_sym_downto] = anon_sym_downto,
  [anon_sym_done] = anon_sym_done,
  [anon_sym_while] = anon_sym_while,
  [anon_sym_else] = anon_sym_else,
  [anon_sym_then] = anon_sym_then,
  [anon_sym_elif] = anon_sym_elif,
  [anon_sym_if] = anon_sym_if,
  [anon_sym_fun] = anon_sym_fun,
  [anon_sym_DASH_GT] = anon_sym_DASH_GT,
  [anon_sym_try] = anon_sym_try,
  [anon_sym_finally] = anon_sym_finally,
  [anon_sym_match] = anon_sym_match,
  [anon_sym_match_BANG] = anon_sym_match_BANG,
  [anon_sym_function] = anon_sym_function,
  [anon_sym_LT_DASH] = anon_sym_LT_DASH,
  [anon_sym_DOT_LBRACK] = anon_sym_DOT_LBRACK,
  [anon_sym_LT] = anon_sym_LT,
  [anon_sym_GT] = anon_sym_GT,
  [anon_sym_use] = anon_sym_use,
  [anon_sym_use_BANG] = anon_sym_use_BANG,
  [anon_sym_do_BANG] = anon_sym_do_BANG,
  [anon_sym_DOT_DOT] = anon_sym_DOT_DOT,
  [anon_sym_when] = anon_sym_when,
  [anon_sym_begin] = anon_sym_begin,
  [anon_sym_end] = anon_sym_end,
  [anon_sym_LPAREN2] = anon_sym_LPAREN,
  [anon_sym_DOT_DOT2] = anon_sym_DOT_DOT,
  [anon_sym_DOT_DOT3] = anon_sym_DOT_DOT,
  [anon_sym_STAR] = anon_sym_STAR,
  [anon_sym_LT2] = anon_sym_LT,
  [anon_sym_LBRACK_RBRACK] = anon_sym_LBRACK_RBRACK,
  [anon_sym_POUND] = anon_sym_POUND,
  [anon_sym_CARET] = anon_sym_CARET,
  [anon_sym_SQUOTE] = anon_sym_SQUOTE,
  [anon_sym_unit] = anon_sym_unit,
  [anon_sym_struct] = anon_sym_struct,
  [anon_sym_not] = anon_sym_not,
  [anon_sym_enum] = anon_sym_enum,
  [anon_sym_unmanaged] = anon_sym_unmanaged,
  [anon_sym_equality] = anon_sym_equality,
  [anon_sym_comparison] = anon_sym_comparison,
  [anon_sym_delegate] = anon_sym_delegate,
  [anon_sym_default] = anon_sym_default,
  [anon_sym_or] = anon_sym_or,
  [anon_sym_static] = anon_sym_static,
  [anon_sym_member] = anon_sym_member,
  [anon_sym_get] = anon_sym_get,
  [anon_sym_set] = anon_sym_set,
  [anon_sym_interface] = anon_sym_interface,
  [anon_sym_id] = anon_sym_id,
  [anon_sym_exception] = anon_sym_exception,
  [anon_sym_of] = anon_sym_of,
  [anon_sym_class] = anon_sym_class,
  [anon_sym_abstract] = anon_sym_abstract,
  [anon_sym_val] = anon_sym_val,
  [anon_sym_override] = anon_sym_override,
  [anon_sym_inherit] = anon_sym_inherit,
  [anon_sym_EQ2] = anon_sym_EQ,
  [sym__escape_char] = sym__escape_char,
  [sym__non_escape_char] = sym__non_escape_char,
  [sym__unicodegraph_short] = sym__unicodegraph_short,
  [sym__unicodegraph_long] = sym__unicodegraph_long,
  [sym__trigraph] = sym__trigraph,
  [aux_sym__simple_string_char_token1] = aux_sym__simple_string_char_token1,
  [aux_sym_char_token1] = aux_sym_char_token1,
  [anon_sym_LBRACE2] = anon_sym_LBRACE,
  [anon_sym_DOLLAR_DQUOTE] = anon_sym_DOLLAR_DQUOTE,
  [anon_sym_DQUOTE] = anon_sym_DQUOTE,
  [anon_sym_BSLASH] = anon_sym_BSLASH,
  [aux_sym__verbatim_string_char_token1] = aux_sym__verbatim_string_char_token1,
  [anon_sym_AT_DQUOTE] = anon_sym_AT_DQUOTE,
  [anon_sym_DQUOTE2] = anon_sym_DQUOTE,
  [anon_sym_DQUOTEB] = anon_sym_DQUOTEB,
  [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
  [anon_sym_DQUOTE_DQUOTE_DQUOTE] = anon_sym_DQUOTE_DQUOTE_DQUOTE,
  [sym_bool] = sym_bool,
  [sym_unit] = sym_unit,
  [anon_sym_LPAREN_PIPE] = anon_sym_LPAREN_PIPE,
  [anon_sym_PIPE_RPAREN] = anon_sym_PIPE_RPAREN,
  [sym_op_identifier] = sym_op_identifier,
  [anon_sym_PLUS] = anon_sym_PLUS,
  [anon_sym_DASH] = anon_sym_DASH,
  [anon_sym_PLUS_DOT] = anon_sym_PLUS_DOT,
  [anon_sym_DASH_DOT] = anon_sym_DASH_DOT,
  [anon_sym_PERCENT] = anon_sym_PERCENT,
  [anon_sym_AMP_AMP] = anon_sym_AMP_AMP,
  [anon_sym_TILDE] = anon_sym_TILDE,
  [aux_sym_prefix_op_token1] = aux_sym_prefix_op_token1,
  [aux_sym_infix_op_token1] = aux_sym_infix_op_token1,
  [aux_sym_infix_op_token2] = aux_sym_infix_op_token2,
  [anon_sym_PIPE_PIPE] = anon_sym_PIPE_PIPE,
  [anon_sym_BANG_EQ] = anon_sym_BANG_EQ,
  [anon_sym_COLON_EQ] = anon_sym_COLON_EQ,
  [anon_sym_DOLLAR] = anon_sym_DOLLAR,
  [anon_sym_QMARK_LT_DASH] = anon_sym_QMARK_LT_DASH,
  [sym_int] = sym_int,
  [sym_xint] = sym_xint,
  [anon_sym_y] = anon_sym_y,
  [anon_sym_uy] = anon_sym_uy,
  [anon_sym_s] = anon_sym_s,
  [anon_sym_us] = anon_sym_us,
  [anon_sym_l] = anon_sym_l,
  [aux_sym_uint32_token1] = aux_sym_uint32_token1,
  [anon_sym_n] = anon_sym_n,
  [anon_sym_un] = anon_sym_un,
  [anon_sym_L] = anon_sym_L,
  [aux_sym_uint64_token1] = aux_sym_uint64_token1,
  [anon_sym_f] = anon_sym_f,
  [anon_sym_lf] = anon_sym_lf,
  [anon_sym_LF] = anon_sym_LF,
  [aux_sym_bignum_token1] = aux_sym_bignum_token1,
  [aux_sym_decimal_token1] = aux_sym_decimal_token1,
  [anon_sym_DOT2] = anon_sym_DOT2,
  [aux_sym_float_token1] = anon_sym_DOT2,
  [anon_sym_LPAREN_STAR] = anon_sym_LPAREN_STAR,
  [anon_sym_STAR_RPAREN] = anon_sym_STAR_RPAREN,
  [sym_line_comment] = sym_line_comment,
  [anon_sym_POUNDnowarn] = anon_sym_POUNDnowarn,
  [anon_sym_POUNDlight] = anon_sym_POUNDlight,
  [anon_sym_POUNDr] = anon_sym_POUNDr,
  [anon_sym_POUNDload] = anon_sym_POUNDload,
  [aux_sym_fsi_directive_decl_token1] = aux_sym_fsi_directive_decl_token1,
  [aux_sym_preproc_line_token1] = aux_sym_preproc_line_token1,
  [anon_sym_POUNDif] = anon_sym_POUNDif,
  [anon_sym_POUNDendif] = anon_sym_POUNDendif,
  [anon_sym_POUNDelse] = anon_sym_POUNDelse,
  [sym__newline] = sym__newline,
  [sym__indent] = sym__indent,
  [sym__dedent] = sym__dedent,
  [sym__struct_begin] = anon_sym_struct,
  [sym__interface_begin] = anon_sym_interface,
  [sym__triple_quoted_content] = sym__triple_quoted_content,
  [sym_block_comment_content] = sym_block_comment_content,
  [sym__inside_string_marker] = sym__inside_string_marker,
  [sym__newline_not_aligned] = sym__newline_not_aligned,
  [sym__tuple_marker] = sym__tuple_marker,
  [sym__error_sentinel] = sym__error_sentinel,
  [sym_file] = sym_file,
  [sym_namespace] = sym_namespace,
  [sym_attributes] = sym_attributes,
  [sym__attribute_set] = sym__attribute_set,
  [sym_attribute] = sym_attribute,
  [sym__attribute_target] = sym__attribute_target,
  [sym__object_construction] = sym__object_construction,
  [sym_value_declaration] = sym_value_declaration,
  [sym_do] = sym_do,
  [sym__function_or_value_defns] = sym__function_or_value_defns,
  [sym_function_or_value_defn] = sym_function_or_value_defn,
  [sym__function_or_value_defn_body] = sym__function_or_value_defn_body,
  [sym_function_declaration_left] = sym_function_declaration_left,
  [sym_value_declaration_left] = sym_value_declaration_left,
  [sym_access_modifier] = sym_access_modifier,
  [sym_repeat_pattern] = sym_repeat_pattern,
  [sym__pattern] = sym__pattern,
  [sym_optional_pattern] = sym_optional_pattern,
  [sym_type_check_pattern] = sym_type_check_pattern,
  [sym_attribute_pattern] = sym_attribute_pattern,
  [sym_paren_pattern] = sym_paren_pattern,
  [sym_as_pattern] = sym_as_pattern,
  [sym_cons_pattern] = sym_cons_pattern,
  [sym_disjunct_pattern] = sym_disjunct_pattern,
  [sym_conjunct_pattern] = sym_conjunct_pattern,
  [sym_typed_pattern] = sym_typed_pattern,
  [sym_argument_patterns] = sym_argument_patterns,
  [sym_field_pattern] = sym_field_pattern,
  [sym__atomic_pattern] = sym__atomic_pattern,
  [sym__list_pattern_content] = sym__list_pattern_content,
  [sym_list_pattern] = sym_list_pattern,
  [sym_array_pattern] = sym_array_pattern,
  [sym_record_pattern] = sym_record_pattern,
  [sym_named_field] = sym_named_field,
  [sym_named_field_pattern] = sym_named_field_pattern,
  [sym_identifier_pattern] = sym_identifier_pattern,
  [sym__expression_block] = sym__expression_block,
  [sym__expression] = sym__expression,
  [sym_literal_expression] = sym_literal_expression,
  [sym_long_identifier_or_op] = sym_long_identifier_or_op,
  [sym_tuple_expression] = sym_tuple_expression,
  [sym_brace_expression] = sym_brace_expression,
  [sym_anon_record_expression] = sym_anon_record_expression,
  [sym_object_expression] = sym_object_expression,
  [sym_with_field_expression] = sym_with_field_expression,
  [sym_prefixed_expression] = sym_prefixed_expression,
  [sym_typecast_expression] = sym_typecast_expression,
  [sym_for_expression] = sym_for_expression,
  [sym_while_expression] = sym_while_expression,
  [sym__else_expression] = sym__else_expression,
  [sym_elif_expression] = sym_elif_expression,
  [sym__if_branch] = sym__if_branch,
  [sym_if_expression] = sym_if_expression,
  [sym_fun_expression] = sym_fun_expression,
  [sym_try_expression] = sym_try_expression,
  [sym_match_expression] = sym_match_expression,
  [sym_function_expression] = sym_function_expression,
  [sym_mutate_expression] = sym_mutate_expression,
  [sym_index_expression] = sym_index_expression,
  [sym_typed_expression] = sym_typed_expression,
  [sym_declaration_expression] = sym_declaration_expression,
  [sym_do_expression] = sym_do_expression,
  [sym__list_elements] = sym__list_elements,
  [sym__list_element] = sym__list_element,
  [sym_list_expression] = sym_list_expression,
  [sym_array_expression] = sym_array_expression,
  [sym_range_expression] = sym_range_expression,
  [sym_rule] = sym_rule,
  [sym_rules] = sym_rules,
  [sym_begin_end_expression] = sym_begin_end_expression,
  [sym_paren_expression] = sym_paren_expression,
  [sym__high_prec_app] = sym__high_prec_app,
  [sym__low_prec_app] = sym__low_prec_app,
  [sym_application_expression] = sym_application_expression,
  [sym_dot_expression] = sym_dot_expression,
  [sym_infix_expression] = sym_infix_expression,
  [sym_ce_expression] = sym_ce_expression,
  [sym_sequential_expression] = sym_sequential_expression,
  [sym__comp_or_range_expression] = sym__comp_or_range_expression,
  [sym_short_comp_expression] = sym_short_comp_expression,
  [sym_slice_ranges] = sym_slice_ranges,
  [sym__slice_range_special] = sym__slice_range_special,
  [sym_slice_range] = sym_slice_range,
  [sym__type] = sym__type,
  [sym_simple_type] = sym_simple_type,
  [sym_generic_type] = sym_generic_type,
  [sym_paren_type] = sym_paren_type,
  [sym_function_type] = sym_function_type,
  [sym_compound_type] = sym_compound_type,
  [sym_postfix_type] = sym_postfix_type,
  [sym_list_type] = sym_list_type,
  [sym_static_type] = sym_static_type,
  [sym_constrained_type] = sym_constrained_type,
  [sym_flexible_type] = sym_flexible_type,
  [sym_anon_record_type] = sym_anon_record_type,
  [sym_types] = sym_types,
  [sym__static_type_identifier] = sym__static_type_identifier,
  [sym__static_parameter] = sym__static_parameter,
  [sym_named_static_parameter] = sym_named_static_parameter,
  [sym_type_attribute] = sym_type_attribute,
  [sym_type_attributes] = sym_type_attributes,
  [sym_atomic_type] = sym_atomic_type,
  [sym_constraint] = sym_constraint,
  [sym_type_argument_constraints] = sym_type_argument_constraints,
  [sym_type_argument] = sym_type_argument,
  [sym_type_argument_defn] = sym_type_argument_defn,
  [sym_type_arguments] = sym_type_arguments,
  [sym_trait_member_constraint] = sym_trait_member_constraint,
  [sym_member_signature] = sym_member_signature,
  [sym_curried_spec] = sym_curried_spec,
  [sym_argument_spec] = sym_argument_spec,
  [sym_arguments_spec] = sym_arguments_spec,
  [sym_argument_name_spec] = sym_argument_name_spec,
  [sym_static_parameter_value] = sym_static_parameter_value,
  [sym_record_fields] = sym_record_fields,
  [sym_record_field] = sym_record_field,
  [sym_interface_implementation] = sym_interface_implementation,
  [sym__member_defns] = sym__member_defns,
  [sym__object_members] = sym__object_members,
  [sym_member_defn] = sym_member_defn,
  [sym_property_or_ident] = sym_property_or_ident,
  [sym__method_defn] = sym__method_defn,
  [sym__property_accessor_body] = sym__property_accessor_body,
  [sym_property_accessor] = sym_property_accessor,
  [sym__property_defn] = sym__property_defn,
  [sym__val_property_defn] = sym__val_property_defn,
  [sym_method_or_prop_defn] = sym_method_or_prop_defn,
  [sym_additional_constr_defn] = sym_additional_constr_defn,
  [sym_field_initializer] = sym_field_initializer,
  [sym_field_initializers] = sym_field_initializers,
  [sym__simple_string_char] = sym__simple_string_char,
  [sym__string_char] = sym__string_char,
  [sym_char] = sym_char,
  [sym_format_string_eval] = sym_format_string_eval,
  [sym_format_string] = sym_format_string,
  [sym__string_literal] = sym__string_literal,
  [sym_string] = sym_string,
  [sym__verbatim_string_char] = sym__verbatim_string_char,
  [sym_verbatim_string] = sym_verbatim_string,
  [sym_bytearray] = sym_bytearray,
  [sym_verbatim_bytearray] = sym_verbatim_bytearray,
  [sym_format_triple_quoted_string] = sym_format_triple_quoted_string,
  [sym_triple_quoted_string] = sym_triple_quoted_string,
  [sym_const] = sym_const,
  [sym_long_identifier] = sym_long_identifier,
  [sym_active_pattern] = sym_active_pattern,
  [sym__identifier_or_op] = sym__identifier_or_op,
  [sym__infix_or_prefix_op] = sym__infix_or_prefix_op,
  [sym_prefix_op] = sym_prefix_op,
  [sym_infix_op] = sym_infix_op,
  [sym_sbyte] = sym_sbyte,
  [sym_byte] = sym_byte,
  [sym_int16] = sym_int16,
  [sym_uint16] = sym_uint16,
  [sym_int32] = sym_int32,
  [sym_uint32] = sym_uint32,
  [sym_nativeint] = sym_nativeint,
  [sym_unativeint] = sym_unativeint,
  [sym_int64] = sym_int64,
  [sym_uint64] = sym_uint64,
  [sym_ieee32] = sym_ieee32,
  [sym_ieee64] = sym_ieee64,
  [sym_bignum] = sym_bignum,
  [sym_decimal] = sym_decimal,
  [sym_float] = sym_float,
  [sym_block_comment] = sym_block_comment,
  [sym_compiler_directive_decl] = sym_compiler_directive_decl,
  [sym_fsi_directive_decl] = sym_fsi_directive_decl,
  [sym_preproc_line] = sym_preproc_line,
  [sym_preproc_if_in_expression] = sym_preproc_if_in_expression,
  [sym_preproc_else_in_expression] = sym_preproc_else_in_expression,
  [sym_module] = sym_module,
  [sym__module_signature_elements] = sym__module_signature_elements,
  [sym_value_definition] = sym_value_definition,
  [aux_sym_file_repeat1] = aux_sym_file_repeat1,
  [aux_sym_attributes_repeat1] = aux_sym_attributes_repeat1,
  [aux_sym__attribute_set_repeat1] = aux_sym__attribute_set_repeat1,
  [aux_sym__function_or_value_defns_repeat1] = aux_sym__function_or_value_defns_repeat1,
  [aux_sym_repeat_pattern_repeat1] = aux_sym_repeat_pattern_repeat1,
  [aux_sym_argument_patterns_repeat1] = aux_sym_argument_patterns_repeat1,
  [aux_sym__list_pattern_content_repeat1] = aux_sym__list_pattern_content_repeat1,
  [aux_sym_record_pattern_repeat1] = aux_sym_record_pattern_repeat1,
  [aux_sym_named_field_pattern_repeat1] = aux_sym_named_field_pattern_repeat1,
  [aux_sym__object_expression_inner_repeat1] = aux_sym__object_expression_inner_repeat1,
  [aux_sym_if_expression_repeat1] = aux_sym_if_expression_repeat1,
  [aux_sym__list_elements_repeat1] = aux_sym__list_elements_repeat1,
  [aux_sym_rules_repeat1] = aux_sym_rules_repeat1,
  [aux_sym_sequential_expression_repeat1] = aux_sym_sequential_expression_repeat1,
  [aux_sym_slice_ranges_repeat1] = aux_sym_slice_ranges_repeat1,
  [aux_sym_compound_type_repeat1] = aux_sym_compound_type_repeat1,
  [aux_sym_types_repeat1] = aux_sym_types_repeat1,
  [aux_sym_type_attributes_repeat1] = aux_sym_type_attributes_repeat1,
  [aux_sym_type_argument_constraints_repeat1] = aux_sym_type_argument_constraints_repeat1,
  [aux_sym_type_argument_repeat1] = aux_sym_type_argument_repeat1,
  [aux_sym_type_arguments_repeat1] = aux_sym_type_arguments_repeat1,
  [aux_sym_curried_spec_repeat1] = aux_sym_curried_spec_repeat1,
  [aux_sym_arguments_spec_repeat1] = aux_sym_arguments_spec_repeat1,
  [aux_sym_record_fields_repeat1] = aux_sym_record_fields_repeat1,
  [aux_sym__member_defns_repeat1] = aux_sym__member_defns_repeat1,
  [aux_sym__method_defn_repeat1] = aux_sym__method_defn_repeat1,
  [aux_sym__property_defn_repeat1] = aux_sym__property_defn_repeat1,
  [aux_sym_field_initializers_repeat1] = aux_sym_field_initializers_repeat1,
  [aux_sym_format_string_repeat1] = aux_sym_format_string_repeat1,
  [aux_sym__string_literal_repeat1] = aux_sym__string_literal_repeat1,
  [aux_sym_verbatim_string_repeat1] = aux_sym_verbatim_string_repeat1,
  [aux_sym_long_identifier_repeat1] = aux_sym_long_identifier_repeat1,
  [aux_sym_active_pattern_repeat1] = aux_sym_active_pattern_repeat1,
  [aux_sym_prefix_op_repeat1] = aux_sym_prefix_op_repeat1,
  [aux_sym_preproc_if_in_expression_repeat1] = aux_sym_preproc_if_in_expression_repeat1,
  [anon_alias_sym_SEMI] = anon_alias_sym_SEMI,
  [alias_sym_active_pattern_op_name] = alias_sym_active_pattern_op_name,
  [alias_sym_wildcard_active_pattern_op] = alias_sym_wildcard_active_pattern_op,
  [alias_sym_wildcard_pattern] = alias_sym_wildcard_pattern,
};

static const TSSymbolMetadata ts_symbol_metadata[] = {
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
  },
  [sym_identifier] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_namespace] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_module] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_open] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_assembly] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_return] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_field] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_property] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_param] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_type] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_constructor] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_event] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_do] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_and] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_let] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_let_BANG] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_rec] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_inline] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_mutable] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_access_modifier_token1] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_as] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COMMA] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_null] = {
    .visible = true,
    .named = false,
  },
  [anon_sym__] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON_QMARK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_AT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_AT_AT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AT_AT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_new] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_with] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_return_BANG] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_yield] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_yield_BANG] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_lazy] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_assert] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_upcast] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_downcast] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON_QMARK_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_for] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_in] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_to] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_downto] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_done] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_while] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_else] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_then] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_elif] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_if] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_fun] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_try] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_finally] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_match] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_match_BANG] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_function] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_use] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_use_BANG] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_do_BANG] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_when] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_begin] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_end] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN2] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT_DOT2] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT_DOT3] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT2] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_POUND] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_unit] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_struct] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_not] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_enum] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_unmanaged] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_equality] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_comparison] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_delegate] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_default] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_or] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_static] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_member] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_get] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_set] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_interface] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_id] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_exception] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_of] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_class] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_abstract] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_val] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_override] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_inherit] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ2] = {
    .visible = true,
    .named = false,
  },
  [sym__escape_char] = {
    .visible = false,
    .named = true,
  },
  [sym__non_escape_char] = {
    .visible = false,
    .named = true,
  },
  [sym__unicodegraph_short] = {
    .visible = false,
    .named = true,
  },
  [sym__unicodegraph_long] = {
    .visible = false,
    .named = true,
  },
  [sym__trigraph] = {
    .visible = false,
    .named = true,
  },
  [aux_sym__simple_string_char_token1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_char_token1] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_LBRACE2] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOLLAR_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASH] = {
    .visible = true,
    .named = false,
  },
  [aux_sym__verbatim_string_char_token1] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_AT_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DQUOTE2] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DQUOTEB] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DQUOTE_DQUOTE_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [sym_bool] = {
    .visible = true,
    .named = true,
  },
  [sym_unit] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_LPAREN_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [sym_op_identifier] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_TILDE] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_prefix_op_token1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_infix_op_token1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_infix_op_token2] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_PIPE_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOLLAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK_LT_DASH] = {
    .visible = true,
    .named = false,
  },
  [sym_int] = {
    .visible = true,
    .named = true,
  },
  [sym_xint] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_y] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_uy] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_s] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_us] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_l] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_uint32_token1] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_n] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_un] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_L] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_uint64_token1] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_f] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_lf] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LF] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_bignum_token1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_decimal_token1] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_DOT2] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_float_token1] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [sym_line_comment] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_POUNDnowarn] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_POUNDlight] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_POUNDr] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_POUNDload] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_fsi_directive_decl_token1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_preproc_line_token1] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_POUNDif] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_POUNDendif] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_POUNDelse] = {
    .visible = true,
    .named = false,
  },
  [sym__newline] = {
    .visible = false,
    .named = true,
  },
  [sym__indent] = {
    .visible = false,
    .named = true,
  },
  [sym__dedent] = {
    .visible = false,
    .named = true,
  },
  [sym__struct_begin] = {
    .visible = true,
    .named = false,
  },
  [sym__interface_begin] = {
    .visible = true,
    .named = false,
  },
  [sym__triple_quoted_content] = {
    .visible = false,
    .named = true,
  },
  [sym_block_comment_content] = {
    .visible = true,
    .named = true,
  },
  [sym__inside_string_marker] = {
    .visible = false,
    .named = true,
  },
  [sym__newline_not_aligned] = {
    .visible = false,
    .named = true,
  },
  [sym__tuple_marker] = {
    .visible = false,
    .named = true,
  },
  [sym__error_sentinel] = {
    .visible = false,
    .named = true,
  },
  [sym_file] = {
    .visible = true,
    .named = true,
  },
  [sym_namespace] = {
    .visible = true,
    .named = true,
  },
  [sym_attributes] = {
    .visible = true,
    .named = true,
  },
  [sym__attribute_set] = {
    .visible = false,
    .named = true,
  },
  [sym_attribute] = {
    .visible = true,
    .named = true,
  },
  [sym__attribute_target] = {
    .visible = false,
    .named = true,
  },
  [sym__object_construction] = {
    .visible = false,
    .named = true,
  },
  [sym_value_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_do] = {
    .visible = true,
    .named = true,
  },
  [sym__function_or_value_defns] = {
    .visible = false,
    .named = true,
  },
  [sym_function_or_value_defn] = {
    .visible = true,
    .named = true,
  },
  [sym__function_or_value_defn_body] = {
    .visible = false,
    .named = true,
  },
  [sym_function_declaration_left] = {
    .visible = true,
    .named = true,
  },
  [sym_value_declaration_left] = {
    .visible = true,
    .named = true,
  },
  [sym_access_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym_repeat_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym__pattern] = {
    .visible = false,
    .named = true,
  },
  [sym_optional_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_type_check_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_attribute_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_paren_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_as_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_cons_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_disjunct_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_conjunct_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_typed_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_argument_patterns] = {
    .visible = true,
    .named = true,
  },
  [sym_field_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym__atomic_pattern] = {
    .visible = false,
    .named = true,
  },
  [sym__list_pattern_content] = {
    .visible = false,
    .named = true,
  },
  [sym_list_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_array_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_record_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_named_field] = {
    .visible = true,
    .named = true,
  },
  [sym_named_field_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_identifier_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym__expression_block] = {
    .visible = false,
    .named = true,
  },
  [sym__expression] = {
    .visible = false,
    .named = true,
  },
  [sym_literal_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_long_identifier_or_op] = {
    .visible = true,
    .named = true,
  },
  [sym_tuple_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_brace_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_anon_record_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_object_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_with_field_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_prefixed_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_typecast_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_for_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_while_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__else_expression] = {
    .visible = false,
    .named = true,
  },
  [sym_elif_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__if_branch] = {
    .visible = false,
    .named = true,
  },
  [sym_if_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_fun_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_try_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_match_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_function_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_mutate_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_index_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_typed_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_declaration_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_do_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__list_elements] = {
    .visible = false,
    .named = true,
  },
  [sym__list_element] = {
    .visible = false,
    .named = true,
  },
  [sym_list_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_array_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_range_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_rule] = {
    .visible = true,
    .named = true,
  },
  [sym_rules] = {
    .visible = true,
    .named = true,
  },
  [sym_begin_end_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_paren_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__high_prec_app] = {
    .visible = false,
    .named = true,
  },
  [sym__low_prec_app] = {
    .visible = false,
    .named = true,
  },
  [sym_application_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_dot_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_infix_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_ce_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_sequential_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__comp_or_range_expression] = {
    .visible = false,
    .named = true,
  },
  [sym_short_comp_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_slice_ranges] = {
    .visible = true,
    .named = true,
  },
  [sym__slice_range_special] = {
    .visible = false,
    .named = true,
  },
  [sym_slice_range] = {
    .visible = true,
    .named = true,
  },
  [sym__type] = {
    .visible = false,
    .named = true,
  },
  [sym_simple_type] = {
    .visible = true,
    .named = true,
  },
  [sym_generic_type] = {
    .visible = true,
    .named = true,
  },
  [sym_paren_type] = {
    .visible = true,
    .named = true,
  },
  [sym_function_type] = {
    .visible = true,
    .named = true,
  },
  [sym_compound_type] = {
    .visible = true,
    .named = true,
  },
  [sym_postfix_type] = {
    .visible = true,
    .named = true,
  },
  [sym_list_type] = {
    .visible = true,
    .named = true,
  },
  [sym_static_type] = {
    .visible = true,
    .named = true,
  },
  [sym_constrained_type] = {
    .visible = true,
    .named = true,
  },
  [sym_flexible_type] = {
    .visible = true,
    .named = true,
  },
  [sym_anon_record_type] = {
    .visible = true,
    .named = true,
  },
  [sym_types] = {
    .visible = true,
    .named = true,
  },
  [sym__static_type_identifier] = {
    .visible = false,
    .named = true,
  },
  [sym__static_parameter] = {
    .visible = false,
    .named = true,
  },
  [sym_named_static_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_type_attribute] = {
    .visible = true,
    .named = true,
  },
  [sym_type_attributes] = {
    .visible = true,
    .named = true,
  },
  [sym_atomic_type] = {
    .visible = true,
    .named = true,
  },
  [sym_constraint] = {
    .visible = true,
    .named = true,
  },
  [sym_type_argument_constraints] = {
    .visible = true,
    .named = true,
  },
  [sym_type_argument] = {
    .visible = true,
    .named = true,
  },
  [sym_type_argument_defn] = {
    .visible = true,
    .named = true,
  },
  [sym_type_arguments] = {
    .visible = true,
    .named = true,
  },
  [sym_trait_member_constraint] = {
    .visible = true,
    .named = true,
  },
  [sym_member_signature] = {
    .visible = true,
    .named = true,
  },
  [sym_curried_spec] = {
    .visible = true,
    .named = true,
  },
  [sym_argument_spec] = {
    .visible = true,
    .named = true,
  },
  [sym_arguments_spec] = {
    .visible = true,
    .named = true,
  },
  [sym_argument_name_spec] = {
    .visible = true,
    .named = true,
  },
  [sym_static_parameter_value] = {
    .visible = true,
    .named = true,
  },
  [sym_record_fields] = {
    .visible = true,
    .named = true,
  },
  [sym_record_field] = {
    .visible = true,
    .named = true,
  },
  [sym_interface_implementation] = {
    .visible = true,
    .named = true,
  },
  [sym__member_defns] = {
    .visible = false,
    .named = true,
  },
  [sym__object_members] = {
    .visible = false,
    .named = true,
  },
  [sym_member_defn] = {
    .visible = true,
    .named = true,
  },
  [sym_property_or_ident] = {
    .visible = true,
    .named = true,
  },
  [sym__method_defn] = {
    .visible = false,
    .named = true,
  },
  [sym__property_accessor_body] = {
    .visible = false,
    .named = true,
  },
  [sym_property_accessor] = {
    .visible = true,
    .named = true,
  },
  [sym__property_defn] = {
    .visible = false,
    .named = true,
  },
  [sym__val_property_defn] = {
    .visible = false,
    .named = true,
  },
  [sym_method_or_prop_defn] = {
    .visible = true,
    .named = true,
  },
  [sym_additional_constr_defn] = {
    .visible = true,
    .named = true,
  },
  [sym_field_initializer] = {
    .visible = true,
    .named = true,
  },
  [sym_field_initializers] = {
    .visible = true,
    .named = true,
  },
  [sym__simple_string_char] = {
    .visible = false,
    .named = true,
  },
  [sym__string_char] = {
    .visible = false,
    .named = true,
  },
  [sym_char] = {
    .visible = true,
    .named = true,
  },
  [sym_format_string_eval] = {
    .visible = true,
    .named = true,
  },
  [sym_format_string] = {
    .visible = true,
    .named = true,
  },
  [sym__string_literal] = {
    .visible = false,
    .named = true,
  },
  [sym_string] = {
    .visible = true,
    .named = true,
  },
  [sym__verbatim_string_char] = {
    .visible = false,
    .named = true,
  },
  [sym_verbatim_string] = {
    .visible = true,
    .named = true,
  },
  [sym_bytearray] = {
    .visible = true,
    .named = true,
  },
  [sym_verbatim_bytearray] = {
    .visible = true,
    .named = true,
  },
  [sym_format_triple_quoted_string] = {
    .visible = true,
    .named = true,
  },
  [sym_triple_quoted_string] = {
    .visible = true,
    .named = true,
  },
  [sym_const] = {
    .visible = true,
    .named = true,
  },
  [sym_long_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_active_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym__identifier_or_op] = {
    .visible = false,
    .named = true,
  },
  [sym__infix_or_prefix_op] = {
    .visible = false,
    .named = true,
  },
  [sym_prefix_op] = {
    .visible = true,
    .named = true,
  },
  [sym_infix_op] = {
    .visible = true,
    .named = true,
  },
  [sym_sbyte] = {
    .visible = true,
    .named = true,
  },
  [sym_byte] = {
    .visible = true,
    .named = true,
  },
  [sym_int16] = {
    .visible = true,
    .named = true,
  },
  [sym_uint16] = {
    .visible = true,
    .named = true,
  },
  [sym_int32] = {
    .visible = true,
    .named = true,
  },
  [sym_uint32] = {
    .visible = true,
    .named = true,
  },
  [sym_nativeint] = {
    .visible = true,
    .named = true,
  },
  [sym_unativeint] = {
    .visible = true,
    .named = true,
  },
  [sym_int64] = {
    .visible = true,
    .named = true,
  },
  [sym_uint64] = {
    .visible = true,
    .named = true,
  },
  [sym_ieee32] = {
    .visible = true,
    .named = true,
  },
  [sym_ieee64] = {
    .visible = true,
    .named = true,
  },
  [sym_bignum] = {
    .visible = true,
    .named = true,
  },
  [sym_decimal] = {
    .visible = true,
    .named = true,
  },
  [sym_float] = {
    .visible = true,
    .named = true,
  },
  [sym_block_comment] = {
    .visible = true,
    .named = true,
  },
  [sym_compiler_directive_decl] = {
    .visible = true,
    .named = true,
  },
  [sym_fsi_directive_decl] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_line] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_if_in_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_else_in_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_module] = {
    .visible = true,
    .named = true,
  },
  [sym__module_signature_elements] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_value_definition] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_file_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_attributes_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__attribute_set_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__function_or_value_defns_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_repeat_pattern_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_argument_patterns_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__list_pattern_content_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_record_pattern_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_named_field_pattern_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__object_expression_inner_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_if_expression_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__list_elements_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_rules_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_sequential_expression_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_slice_ranges_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_compound_type_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_types_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_type_attributes_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_type_argument_constraints_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_type_argument_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_type_arguments_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_curried_spec_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_arguments_spec_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_record_fields_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__member_defns_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__method_defn_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__property_defn_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_field_initializers_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_format_string_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__string_literal_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_verbatim_string_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_long_identifier_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_active_pattern_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_prefix_op_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_preproc_if_in_expression_repeat1] = {
    .visible = false,
    .named = false,
  },
  [anon_alias_sym_SEMI] = {
    .visible = true,
    .named = false,
  },
  [alias_sym_active_pattern_op_name] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_wildcard_active_pattern_op] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_wildcard_pattern] = {
    .visible = true,
    .named = true,
  },
};

enum ts_field_identifiers {
  field_alternative = 1,
  field_args = 2,
  field_assignee = 3,
  field_base = 4,
  field_block = 5,
  field_body = 6,
  field_condition = 7,
  field_constraints = 8,
  field_else = 9,
  field_field = 10,
  field_from = 11,
  field_guard = 12,
  field_in = 13,
  field_index = 14,
  field_instance = 15,
  field_method = 16,
  field_name = 17,
  field_pattern = 18,
  field_then = 19,
  field_to = 20,
  field_value = 21,
};

static const char * const ts_field_names[] = {
  [0] = NULL,
  [field_alternative] = "alternative",
  [field_args] = "args",
  [field_assignee] = "assignee",
  [field_base] = "base",
  [field_block] = "block",
  [field_body] = "body",
  [field_condition] = "condition",
  [field_constraints] = "constraints",
  [field_else] = "else",
  [field_field] = "field",
  [field_from] = "from",
  [field_guard] = "guard",
  [field_in] = "in",
  [field_index] = "index",
  [field_instance] = "instance",
  [field_method] = "method",
  [field_name] = "name",
  [field_pattern] = "pattern",
  [field_then] = "then",
  [field_to] = "to",
  [field_value] = "value",
};

static const TSFieldMapSlice ts_field_map_slices[PRODUCTION_ID_COUNT] = {
  [5] = {.index = 0, .length = 1},
  [6] = {.index = 1, .length = 1},
  [7] = {.index = 2, .length = 1},
  [8] = {.index = 3, .length = 1},
  [11] = {.index = 4, .length = 2},
  [12] = {.index = 6, .length = 1},
  [13] = {.index = 7, .length = 1},
  [14] = {.index = 8, .length = 2},
  [16] = {.index = 10, .length = 2},
  [17] = {.index = 12, .length = 2},
  [18] = {.index = 14, .length = 2},
  [19] = {.index = 16, .length = 3},
  [20] = {.index = 19, .length = 1},
  [21] = {.index = 20, .length = 3},
  [22] = {.index = 23, .length = 3},
  [23] = {.index = 26, .length = 2},
  [24] = {.index = 28, .length = 1},
  [25] = {.index = 29, .length = 1},
  [26] = {.index = 30, .length = 1},
  [27] = {.index = 31, .length = 1},
  [28] = {.index = 32, .length = 1},
  [29] = {.index = 33, .length = 3},
  [30] = {.index = 36, .length = 4},
  [33] = {.index = 40, .length = 1},
  [34] = {.index = 41, .length = 2},
  [35] = {.index = 43, .length = 1},
  [36] = {.index = 44, .length = 2},
  [37] = {.index = 46, .length = 2},
  [38] = {.index = 48, .length = 1},
  [39] = {.index = 49, .length = 2},
  [40] = {.index = 51, .length = 1},
  [41] = {.index = 52, .length = 3},
  [42] = {.index = 55, .length = 5},
  [44] = {.index = 60, .length = 1},
  [45] = {.index = 61, .length = 1},
  [46] = {.index = 62, .length = 2},
  [47] = {.index = 64, .length = 3},
  [48] = {.index = 67, .length = 1},
  [49] = {.index = 68, .length = 3},
  [50] = {.index = 71, .length = 3},
  [51] = {.index = 74, .length = 2},
  [52] = {.index = 76, .length = 2},
  [53] = {.index = 78, .length = 2},
  [54] = {.index = 80, .length = 2},
  [55] = {.index = 82, .length = 1},
  [56] = {.index = 83, .length = 1},
  [57] = {.index = 84, .length = 5},
  [58] = {.index = 89, .length = 1},
  [59] = {.index = 90, .length = 1},
  [60] = {.index = 91, .length = 4},
  [61] = {.index = 95, .length = 4},
};

static const TSFieldMapEntry ts_field_map_entries[] = {
  [0] =
    {field_body, 1, .inherited = true},
  [1] =
    {field_guard, 1},
  [2] =
    {field_in, 1},
  [3] =
    {field_block, 1, .inherited = true},
  [4] =
    {field_block, 3},
    {field_block, 4},
  [6] =
    {field_body, 2, .inherited = true},
  [7] =
    {field_body, 0, .inherited = true},
  [8] =
    {field_from, 0, .inherited = true},
    {field_to, 0, .inherited = true},
  [10] =
    {field_base, 0},
    {field_field, 2},
  [12] =
    {field_assignee, 0},
    {field_value, 2},
  [14] =
    {field_guard, 0, .inherited = true},
    {field_then, 2},
  [16] =
    {field_block, 0},
    {field_block, 1},
    {field_block, 2},
  [19] =
    {field_constraints, 3},
  [20] =
    {field_block, 3},
    {field_block, 4},
    {field_block, 5},
  [23] =
    {field_block, 1},
    {field_block, 2},
    {field_block, 3},
  [26] =
    {field_body, 0, .inherited = true},
    {field_body, 1, .inherited = true},
  [28] =
    {field_body, 2},
  [29] =
    {field_to, 1},
  [30] =
    {field_from, 0},
  [31] =
    {field_condition, 1},
  [32] =
    {field_index, 2},
  [33] =
    {field_else, 3, .inherited = true},
    {field_guard, 0, .inherited = true},
    {field_then, 2},
  [36] =
    {field_block, 0},
    {field_block, 1},
    {field_block, 2},
    {field_block, 3},
  [40] =
    {field_body, 5},
  [41] =
    {field_from, 0},
    {field_to, 2},
  [43] =
    {field_block, 2, .inherited = true},
  [44] =
    {field_field, 0},
    {field_value, 2},
  [46] =
    {field_block, 2},
    {field_pattern, 0},
  [48] =
    {field_in, 4},
  [49] =
    {field_alternative, 3},
    {field_condition, 1},
  [51] =
    {field_else, 1},
  [52] =
    {field_else, 4, .inherited = true},
    {field_guard, 0, .inherited = true},
    {field_then, 2},
  [55] =
    {field_block, 0},
    {field_block, 1},
    {field_block, 2},
    {field_block, 3},
    {field_block, 4},
  [60] =
    {field_body, 6},
  [61] =
    {field_body, 4},
  [62] =
    {field_alternative, 4},
    {field_condition, 1},
  [64] =
    {field_block, 2},
    {field_block, 3},
    {field_block, 4},
  [67] =
    {field_block, 4, .inherited = true},
  [68] =
    {field_block, 4},
    {field_block, 5},
    {field_block, 6},
  [71] =
    {field_block, 4},
    {field_guard, 2},
    {field_pattern, 0},
  [74] =
    {field_guard, 1},
    {field_then, 3},
  [76] =
    {field_args, 1, .inherited = true},
    {field_name, 0},
  [78] =
    {field_block, 1, .inherited = true},
    {field_name, 0},
  [80] =
    {field_instance, 0},
    {field_method, 2},
  [82] =
    {field_args, 0},
  [83] =
    {field_name, 0},
  [84] =
    {field_block, 2},
    {field_block, 3},
    {field_block, 4},
    {field_body, 3, .inherited = true},
    {field_name, 0},
  [89] =
    {field_args, 1},
  [90] =
    {field_name, 1},
  [91] =
    {field_block, 1},
    {field_block, 2},
    {field_block, 3},
    {field_block, 4},
  [95] =
    {field_block, 3},
    {field_block, 4},
    {field_block, 5},
    {field_block, 6},
};

static const TSSymbol ts_alias_sequences[PRODUCTION_ID_COUNT][MAX_ALIAS_SEQUENCE_LENGTH] = {
  [0] = {0},
  [1] = {
    [0] = alias_sym_wildcard_pattern,
  },
  [2] = {
    [1] = sym_string,
  },
  [3] = {
    [0] = anon_sym_DOT2,
  },
  [4] = {
    [2] = sym_string,
  },
  [9] = {
    [1] = alias_sym_active_pattern_op_name,
  },
  [10] = {
    [0] = anon_sym_DOT2,
    [2] = anon_sym_DOT2,
  },
  [15] = {
    [0] = anon_alias_sym_SEMI,
  },
  [31] = {
    [1] = alias_sym_active_pattern_op_name,
    [3] = alias_sym_wildcard_active_pattern_op,
  },
  [32] = {
    [0] = anon_sym_DOT2,
    [2] = anon_sym_DOT2,
    [4] = anon_sym_DOT2,
  },
  [43] = {
    [1] = alias_sym_active_pattern_op_name,
    [4] = alias_sym_wildcard_active_pattern_op,
  },
};

static const uint16_t ts_non_terminal_alias_map[] = {
  sym__string_literal, 2,
    sym__string_literal,
    sym_string,
  0,
};

static const TSStateId ts_primary_state_ids[STATE_COUNT] = {
  [0] = 0,
  [1] = 1,
  [2] = 2,
  [3] = 3,
  [4] = 4,
  [5] = 5,
  [6] = 6,
  [7] = 7,
  [8] = 8,
  [9] = 9,
  [10] = 10,
  [11] = 11,
  [12] = 12,
  [13] = 12,
  [14] = 8,
  [15] = 9,
  [16] = 5,
  [17] = 6,
  [18] = 4,
  [19] = 2,
  [20] = 10,
  [21] = 7,
  [22] = 22,
  [23] = 7,
  [24] = 24,
  [25] = 22,
  [26] = 4,
  [27] = 5,
  [28] = 6,
  [29] = 10,
  [30] = 2,
  [31] = 9,
  [32] = 12,
  [33] = 8,
  [34] = 34,
  [35] = 35,
  [36] = 34,
  [37] = 9,
  [38] = 38,
  [39] = 8,
  [40] = 38,
  [41] = 7,
  [42] = 38,
  [43] = 5,
  [44] = 4,
  [45] = 34,
  [46] = 10,
  [47] = 2,
  [48] = 38,
  [49] = 12,
  [50] = 38,
  [51] = 9,
  [52] = 38,
  [53] = 8,
  [54] = 38,
  [55] = 34,
  [56] = 38,
  [57] = 7,
  [58] = 38,
  [59] = 6,
  [60] = 38,
  [61] = 5,
  [62] = 4,
  [63] = 34,
  [64] = 10,
  [65] = 9,
  [66] = 34,
  [67] = 2,
  [68] = 2,
  [69] = 12,
  [70] = 34,
  [71] = 9,
  [72] = 8,
  [73] = 34,
  [74] = 10,
  [75] = 7,
  [76] = 6,
  [77] = 34,
  [78] = 5,
  [79] = 4,
  [80] = 4,
  [81] = 81,
  [82] = 82,
  [83] = 38,
  [84] = 84,
  [85] = 4,
  [86] = 5,
  [87] = 34,
  [88] = 6,
  [89] = 7,
  [90] = 8,
  [91] = 9,
  [92] = 12,
  [93] = 2,
  [94] = 81,
  [95] = 95,
  [96] = 10,
  [97] = 35,
  [98] = 6,
  [99] = 12,
  [100] = 100,
  [101] = 5,
  [102] = 102,
  [103] = 38,
  [104] = 34,
  [105] = 105,
  [106] = 4,
  [107] = 5,
  [108] = 6,
  [109] = 6,
  [110] = 7,
  [111] = 7,
  [112] = 34,
  [113] = 8,
  [114] = 9,
  [115] = 115,
  [116] = 8,
  [117] = 9,
  [118] = 12,
  [119] = 2,
  [120] = 10,
  [121] = 12,
  [122] = 4,
  [123] = 2,
  [124] = 5,
  [125] = 10,
  [126] = 6,
  [127] = 7,
  [128] = 128,
  [129] = 8,
  [130] = 10,
  [131] = 2,
  [132] = 12,
  [133] = 133,
  [134] = 134,
  [135] = 12,
  [136] = 9,
  [137] = 137,
  [138] = 8,
  [139] = 139,
  [140] = 7,
  [141] = 141,
  [142] = 6,
  [143] = 137,
  [144] = 139,
  [145] = 141,
  [146] = 137,
  [147] = 139,
  [148] = 141,
  [149] = 149,
  [150] = 137,
  [151] = 139,
  [152] = 5,
  [153] = 4,
  [154] = 141,
  [155] = 137,
  [156] = 139,
  [157] = 141,
  [158] = 137,
  [159] = 139,
  [160] = 141,
  [161] = 149,
  [162] = 137,
  [163] = 139,
  [164] = 141,
  [165] = 4,
  [166] = 5,
  [167] = 6,
  [168] = 137,
  [169] = 139,
  [170] = 141,
  [171] = 149,
  [172] = 95,
  [173] = 137,
  [174] = 139,
  [175] = 141,
  [176] = 149,
  [177] = 141,
  [178] = 137,
  [179] = 139,
  [180] = 141,
  [181] = 149,
  [182] = 7,
  [183] = 8,
  [184] = 9,
  [185] = 12,
  [186] = 186,
  [187] = 141,
  [188] = 139,
  [189] = 137,
  [190] = 190,
  [191] = 149,
  [192] = 141,
  [193] = 193,
  [194] = 149,
  [195] = 141,
  [196] = 141,
  [197] = 141,
  [198] = 141,
  [199] = 102,
  [200] = 141,
  [201] = 2,
  [202] = 141,
  [203] = 141,
  [204] = 10,
  [205] = 84,
  [206] = 141,
  [207] = 141,
  [208] = 149,
  [209] = 141,
  [210] = 210,
  [211] = 141,
  [212] = 141,
  [213] = 4,
  [214] = 10,
  [215] = 141,
  [216] = 5,
  [217] = 82,
  [218] = 141,
  [219] = 6,
  [220] = 141,
  [221] = 141,
  [222] = 222,
  [223] = 7,
  [224] = 141,
  [225] = 8,
  [226] = 141,
  [227] = 9,
  [228] = 141,
  [229] = 12,
  [230] = 2,
  [231] = 141,
  [232] = 10,
  [233] = 141,
  [234] = 141,
  [235] = 141,
  [236] = 141,
  [237] = 141,
  [238] = 137,
  [239] = 139,
  [240] = 240,
  [241] = 141,
  [242] = 141,
  [243] = 141,
  [244] = 244,
  [245] = 141,
  [246] = 141,
  [247] = 149,
  [248] = 141,
  [249] = 141,
  [250] = 141,
  [251] = 141,
  [252] = 149,
  [253] = 133,
  [254] = 254,
  [255] = 134,
  [256] = 240,
  [257] = 10,
  [258] = 4,
  [259] = 5,
  [260] = 6,
  [261] = 4,
  [262] = 254,
  [263] = 2,
  [264] = 134,
  [265] = 7,
  [266] = 240,
  [267] = 2,
  [268] = 8,
  [269] = 9,
  [270] = 12,
  [271] = 2,
  [272] = 5,
  [273] = 134,
  [274] = 149,
  [275] = 254,
  [276] = 134,
  [277] = 10,
  [278] = 12,
  [279] = 240,
  [280] = 190,
  [281] = 9,
  [282] = 254,
  [283] = 134,
  [284] = 240,
  [285] = 254,
  [286] = 134,
  [287] = 240,
  [288] = 134,
  [289] = 289,
  [290] = 254,
  [291] = 134,
  [292] = 134,
  [293] = 149,
  [294] = 240,
  [295] = 8,
  [296] = 134,
  [297] = 7,
  [298] = 240,
  [299] = 240,
  [300] = 254,
  [301] = 240,
  [302] = 9,
  [303] = 8,
  [304] = 134,
  [305] = 134,
  [306] = 254,
  [307] = 307,
  [308] = 254,
  [309] = 10,
  [310] = 310,
  [311] = 134,
  [312] = 6,
  [313] = 254,
  [314] = 254,
  [315] = 5,
  [316] = 240,
  [317] = 2,
  [318] = 4,
  [319] = 134,
  [320] = 240,
  [321] = 254,
  [322] = 240,
  [323] = 12,
  [324] = 7,
  [325] = 141,
  [326] = 6,
  [327] = 327,
  [328] = 328,
  [329] = 327,
  [330] = 328,
  [331] = 328,
  [332] = 327,
  [333] = 327,
  [334] = 328,
  [335] = 328,
  [336] = 328,
  [337] = 328,
  [338] = 327,
  [339] = 327,
  [340] = 328,
  [341] = 327,
  [342] = 327,
  [343] = 328,
  [344] = 328,
  [345] = 328,
  [346] = 327,
  [347] = 327,
  [348] = 210,
  [349] = 327,
  [350] = 327,
  [351] = 328,
  [352] = 352,
  [353] = 353,
  [354] = 354,
  [355] = 354,
  [356] = 354,
  [357] = 354,
  [358] = 354,
  [359] = 354,
  [360] = 354,
  [361] = 354,
  [362] = 354,
  [363] = 354,
  [364] = 354,
  [365] = 354,
  [366] = 366,
  [367] = 367,
  [368] = 368,
  [369] = 368,
  [370] = 367,
  [371] = 366,
  [372] = 368,
  [373] = 367,
  [374] = 368,
  [375] = 366,
  [376] = 368,
  [377] = 367,
  [378] = 367,
  [379] = 366,
  [380] = 366,
  [381] = 366,
  [382] = 366,
  [383] = 368,
  [384] = 366,
  [385] = 367,
  [386] = 367,
  [387] = 366,
  [388] = 368,
  [389] = 367,
  [390] = 366,
  [391] = 367,
  [392] = 368,
  [393] = 367,
  [394] = 367,
  [395] = 368,
  [396] = 368,
  [397] = 366,
  [398] = 368,
  [399] = 367,
  [400] = 368,
  [401] = 366,
  [402] = 402,
  [403] = 402,
  [404] = 402,
  [405] = 402,
  [406] = 402,
  [407] = 402,
  [408] = 402,
  [409] = 402,
  [410] = 410,
  [411] = 402,
  [412] = 410,
  [413] = 402,
  [414] = 402,
  [415] = 402,
  [416] = 416,
  [417] = 417,
  [418] = 418,
  [419] = 418,
  [420] = 418,
  [421] = 418,
  [422] = 416,
  [423] = 423,
  [424] = 418,
  [425] = 418,
  [426] = 418,
  [427] = 418,
  [428] = 418,
  [429] = 418,
  [430] = 418,
  [431] = 418,
  [432] = 432,
  [433] = 433,
  [434] = 433,
  [435] = 435,
  [436] = 436,
  [437] = 437,
  [438] = 436,
  [439] = 436,
  [440] = 435,
  [441] = 437,
  [442] = 437,
  [443] = 435,
  [444] = 436,
  [445] = 436,
  [446] = 435,
  [447] = 436,
  [448] = 437,
  [449] = 435,
  [450] = 436,
  [451] = 437,
  [452] = 437,
  [453] = 435,
  [454] = 436,
  [455] = 437,
  [456] = 436,
  [457] = 435,
  [458] = 458,
  [459] = 436,
  [460] = 435,
  [461] = 436,
  [462] = 436,
  [463] = 437,
  [464] = 435,
  [465] = 437,
  [466] = 435,
  [467] = 436,
  [468] = 437,
  [469] = 435,
  [470] = 436,
  [471] = 437,
  [472] = 437,
  [473] = 437,
  [474] = 458,
  [475] = 437,
  [476] = 436,
  [477] = 437,
  [478] = 437,
  [479] = 435,
  [480] = 480,
  [481] = 481,
  [482] = 482,
  [483] = 483,
  [484] = 484,
  [485] = 485,
  [486] = 486,
  [487] = 487,
  [488] = 480,
  [489] = 484,
  [490] = 490,
  [491] = 487,
  [492] = 492,
  [493] = 493,
  [494] = 493,
  [495] = 484,
  [496] = 485,
  [497] = 497,
  [498] = 498,
  [499] = 499,
  [500] = 484,
  [501] = 484,
  [502] = 493,
  [503] = 490,
  [504] = 490,
  [505] = 484,
  [506] = 492,
  [507] = 484,
  [508] = 508,
  [509] = 482,
  [510] = 510,
  [511] = 487,
  [512] = 484,
  [513] = 484,
  [514] = 480,
  [515] = 487,
  [516] = 516,
  [517] = 499,
  [518] = 480,
  [519] = 490,
  [520] = 520,
  [521] = 480,
  [522] = 484,
  [523] = 484,
  [524] = 520,
  [525] = 484,
  [526] = 520,
  [527] = 482,
  [528] = 498,
  [529] = 485,
  [530] = 498,
  [531] = 520,
  [532] = 482,
  [533] = 533,
  [534] = 484,
  [535] = 482,
  [536] = 520,
  [537] = 485,
  [538] = 484,
  [539] = 480,
  [540] = 492,
  [541] = 508,
  [542] = 490,
  [543] = 487,
  [544] = 484,
  [545] = 492,
  [546] = 493,
  [547] = 533,
  [548] = 499,
  [549] = 492,
  [550] = 484,
  [551] = 551,
  [552] = 484,
  [553] = 553,
  [554] = 485,
  [555] = 492,
  [556] = 498,
  [557] = 533,
  [558] = 490,
  [559] = 484,
  [560] = 516,
  [561] = 487,
  [562] = 484,
  [563] = 484,
  [564] = 484,
  [565] = 493,
  [566] = 487,
  [567] = 567,
  [568] = 516,
  [569] = 484,
  [570] = 570,
  [571] = 567,
  [572] = 508,
  [573] = 573,
  [574] = 520,
  [575] = 492,
  [576] = 567,
  [577] = 520,
  [578] = 497,
  [579] = 484,
  [580] = 484,
  [581] = 487,
  [582] = 516,
  [583] = 498,
  [584] = 533,
  [585] = 490,
  [586] = 480,
  [587] = 485,
  [588] = 480,
  [589] = 484,
  [590] = 484,
  [591] = 567,
  [592] = 493,
  [593] = 533,
  [594] = 484,
  [595] = 493,
  [596] = 482,
  [597] = 516,
  [598] = 493,
  [599] = 484,
  [600] = 482,
  [601] = 508,
  [602] = 490,
  [603] = 484,
  [604] = 493,
  [605] = 533,
  [606] = 490,
  [607] = 484,
  [608] = 487,
  [609] = 484,
  [610] = 508,
  [611] = 492,
  [612] = 497,
  [613] = 492,
  [614] = 484,
  [615] = 497,
  [616] = 487,
  [617] = 484,
  [618] = 484,
  [619] = 484,
  [620] = 490,
  [621] = 498,
  [622] = 520,
  [623] = 484,
  [624] = 480,
  [625] = 484,
  [626] = 484,
  [627] = 482,
  [628] = 492,
  [629] = 533,
  [630] = 482,
  [631] = 493,
  [632] = 499,
  [633] = 499,
  [634] = 634,
  [635] = 498,
  [636] = 508,
  [637] = 508,
  [638] = 520,
  [639] = 639,
  [640] = 485,
  [641] = 497,
  [642] = 497,
  [643] = 643,
  [644] = 516,
  [645] = 480,
  [646] = 516,
  [647] = 492,
  [648] = 533,
  [649] = 497,
  [650] = 499,
  [651] = 482,
  [652] = 493,
  [653] = 498,
  [654] = 484,
  [655] = 499,
  [656] = 499,
  [657] = 657,
  [658] = 499,
  [659] = 493,
  [660] = 480,
  [661] = 634,
  [662] = 493,
  [663] = 482,
  [664] = 499,
  [665] = 497,
  [666] = 508,
  [667] = 492,
  [668] = 487,
  [669] = 516,
  [670] = 499,
  [671] = 480,
  [672] = 520,
  [673] = 497,
  [674] = 490,
  [675] = 485,
  [676] = 516,
  [677] = 533,
  [678] = 487,
  [679] = 492,
  [680] = 533,
  [681] = 484,
  [682] = 490,
  [683] = 490,
  [684] = 497,
  [685] = 508,
  [686] = 490,
  [687] = 487,
  [688] = 499,
  [689] = 480,
  [690] = 657,
  [691] = 691,
  [692] = 691,
  [693] = 693,
  [694] = 487,
  [695] = 484,
  [696] = 480,
  [697] = 492,
  [698] = 497,
  [699] = 508,
  [700] = 516,
  [701] = 533,
  [702] = 520,
  [703] = 482,
  [704] = 482,
  [705] = 482,
  [706] = 499,
  [707] = 573,
  [708] = 493,
  [709] = 498,
  [710] = 510,
  [711] = 485,
  [712] = 497,
  [713] = 516,
  [714] = 484,
  [715] = 492,
  [716] = 570,
  [717] = 498,
  [718] = 508,
  [719] = 484,
  [720] = 520,
  [721] = 487,
  [722] = 498,
  [723] = 499,
  [724] = 490,
  [725] = 485,
  [726] = 485,
  [727] = 480,
  [728] = 497,
  [729] = 482,
  [730] = 484,
  [731] = 484,
  [732] = 516,
  [733] = 482,
  [734] = 493,
  [735] = 498,
  [736] = 484,
  [737] = 499,
  [738] = 480,
  [739] = 484,
  [740] = 485,
  [741] = 490,
  [742] = 567,
  [743] = 487,
  [744] = 567,
  [745] = 567,
  [746] = 484,
  [747] = 492,
  [748] = 567,
  [749] = 533,
  [750] = 750,
  [751] = 508,
  [752] = 567,
  [753] = 567,
  [754] = 493,
  [755] = 567,
  [756] = 499,
  [757] = 567,
  [758] = 758,
  [759] = 759,
  [760] = 758,
  [761] = 759,
  [762] = 762,
  [763] = 763,
  [764] = 764,
  [765] = 765,
  [766] = 766,
  [767] = 758,
  [768] = 758,
  [769] = 769,
  [770] = 758,
  [771] = 771,
  [772] = 772,
  [773] = 773,
  [774] = 774,
  [775] = 775,
  [776] = 758,
  [777] = 758,
  [778] = 758,
  [779] = 779,
  [780] = 780,
  [781] = 781,
  [782] = 758,
  [783] = 783,
  [784] = 758,
  [785] = 785,
  [786] = 759,
  [787] = 787,
  [788] = 758,
  [789] = 789,
  [790] = 790,
  [791] = 791,
  [792] = 792,
  [793] = 758,
  [794] = 794,
  [795] = 795,
  [796] = 759,
  [797] = 797,
  [798] = 798,
  [799] = 799,
  [800] = 758,
  [801] = 801,
  [802] = 802,
  [803] = 803,
  [804] = 804,
  [805] = 758,
  [806] = 758,
  [807] = 807,
  [808] = 808,
  [809] = 809,
  [810] = 758,
  [811] = 763,
  [812] = 766,
  [813] = 765,
  [814] = 759,
  [815] = 762,
  [816] = 764,
  [817] = 759,
  [818] = 759,
  [819] = 759,
  [820] = 820,
  [821] = 821,
  [822] = 820,
  [823] = 823,
  [824] = 759,
  [825] = 759,
  [826] = 826,
  [827] = 827,
  [828] = 828,
  [829] = 759,
  [830] = 830,
  [831] = 759,
  [832] = 832,
  [833] = 833,
  [834] = 759,
  [835] = 835,
  [836] = 836,
  [837] = 781,
  [838] = 838,
  [839] = 839,
  [840] = 771,
  [841] = 783,
  [842] = 842,
  [843] = 820,
  [844] = 844,
  [845] = 845,
  [846] = 772,
  [847] = 847,
  [848] = 779,
  [849] = 820,
  [850] = 781,
  [851] = 774,
  [852] = 769,
  [853] = 773,
  [854] = 854,
  [855] = 855,
  [856] = 780,
  [857] = 857,
  [858] = 858,
  [859] = 775,
  [860] = 860,
  [861] = 780,
  [862] = 862,
  [863] = 863,
  [864] = 864,
  [865] = 865,
  [866] = 866,
  [867] = 867,
  [868] = 868,
  [869] = 869,
  [870] = 870,
  [871] = 871,
  [872] = 872,
  [873] = 873,
  [874] = 874,
  [875] = 875,
  [876] = 876,
  [877] = 877,
  [878] = 878,
  [879] = 879,
  [880] = 880,
  [881] = 881,
  [882] = 882,
  [883] = 883,
  [884] = 884,
  [885] = 885,
  [886] = 886,
  [887] = 887,
  [888] = 888,
  [889] = 889,
  [890] = 890,
  [891] = 891,
  [892] = 892,
  [893] = 893,
  [894] = 894,
  [895] = 785,
  [896] = 896,
  [897] = 897,
  [898] = 898,
  [899] = 899,
  [900] = 900,
  [901] = 901,
  [902] = 802,
  [903] = 903,
  [904] = 804,
  [905] = 905,
  [906] = 906,
  [907] = 907,
  [908] = 799,
  [909] = 909,
  [910] = 791,
  [911] = 807,
  [912] = 912,
  [913] = 913,
  [914] = 914,
  [915] = 915,
  [916] = 916,
  [917] = 917,
  [918] = 918,
  [919] = 919,
  [920] = 792,
  [921] = 794,
  [922] = 789,
  [923] = 809,
  [924] = 787,
  [925] = 790,
  [926] = 795,
  [927] = 927,
  [928] = 928,
  [929] = 929,
  [930] = 798,
  [931] = 931,
  [932] = 932,
  [933] = 803,
  [934] = 808,
  [935] = 935,
  [936] = 936,
  [937] = 790,
  [938] = 938,
  [939] = 939,
  [940] = 940,
  [941] = 941,
  [942] = 942,
  [943] = 943,
  [944] = 944,
  [945] = 945,
  [946] = 946,
  [947] = 947,
  [948] = 801,
  [949] = 949,
  [950] = 950,
  [951] = 797,
  [952] = 952,
  [953] = 953,
  [954] = 954,
  [955] = 955,
  [956] = 956,
  [957] = 957,
  [958] = 958,
  [959] = 766,
  [960] = 763,
  [961] = 762,
  [962] = 765,
  [963] = 764,
  [964] = 827,
  [965] = 765,
  [966] = 826,
  [967] = 858,
  [968] = 762,
  [969] = 765,
  [970] = 764,
  [971] = 820,
  [972] = 820,
  [973] = 766,
  [974] = 832,
  [975] = 823,
  [976] = 828,
  [977] = 765,
  [978] = 764,
  [979] = 860,
  [980] = 762,
  [981] = 766,
  [982] = 766,
  [983] = 821,
  [984] = 763,
  [985] = 833,
  [986] = 763,
  [987] = 830,
  [988] = 855,
  [989] = 763,
  [990] = 762,
  [991] = 854,
  [992] = 764,
  [993] = 762,
  [994] = 763,
  [995] = 766,
  [996] = 774,
  [997] = 764,
  [998] = 765,
  [999] = 763,
  [1000] = 857,
  [1001] = 838,
  [1002] = 847,
  [1003] = 820,
  [1004] = 764,
  [1005] = 764,
  [1006] = 772,
  [1007] = 771,
  [1008] = 839,
  [1009] = 765,
  [1010] = 766,
  [1011] = 779,
  [1012] = 836,
  [1013] = 762,
  [1014] = 783,
  [1015] = 766,
  [1016] = 780,
  [1017] = 763,
  [1018] = 835,
  [1019] = 781,
  [1020] = 762,
  [1021] = 845,
  [1022] = 775,
  [1023] = 765,
  [1024] = 781,
  [1025] = 780,
  [1026] = 764,
  [1027] = 765,
  [1028] = 773,
  [1029] = 762,
  [1030] = 762,
  [1031] = 765,
  [1032] = 766,
  [1033] = 769,
  [1034] = 764,
  [1035] = 763,
  [1036] = 766,
  [1037] = 763,
  [1038] = 842,
  [1039] = 820,
  [1040] = 766,
  [1041] = 844,
  [1042] = 918,
  [1043] = 887,
  [1044] = 769,
  [1045] = 956,
  [1046] = 773,
  [1047] = 775,
  [1048] = 862,
  [1049] = 938,
  [1050] = 783,
  [1051] = 955,
  [1052] = 931,
  [1053] = 903,
  [1054] = 791,
  [1055] = 783,
  [1056] = 894,
  [1057] = 775,
  [1058] = 901,
  [1059] = 906,
  [1060] = 772,
  [1061] = 779,
  [1062] = 899,
  [1063] = 889,
  [1064] = 907,
  [1065] = 773,
  [1066] = 794,
  [1067] = 769,
  [1068] = 958,
  [1069] = 866,
  [1070] = 787,
  [1071] = 795,
  [1072] = 905,
  [1073] = 915,
  [1074] = 888,
  [1075] = 909,
  [1076] = 790,
  [1077] = 865,
  [1078] = 891,
  [1079] = 957,
  [1080] = 868,
  [1081] = 919,
  [1082] = 799,
  [1083] = 808,
  [1084] = 882,
  [1085] = 871,
  [1086] = 774,
  [1087] = 881,
  [1088] = 917,
  [1089] = 774,
  [1090] = 869,
  [1091] = 766,
  [1092] = 780,
  [1093] = 876,
  [1094] = 939,
  [1095] = 783,
  [1096] = 870,
  [1097] = 940,
  [1098] = 916,
  [1099] = 873,
  [1100] = 801,
  [1101] = 913,
  [1102] = 781,
  [1103] = 803,
  [1104] = 798,
  [1105] = 774,
  [1106] = 928,
  [1107] = 927,
  [1108] = 785,
  [1109] = 953,
  [1110] = 772,
  [1111] = 863,
  [1112] = 772,
  [1113] = 950,
  [1114] = 771,
  [1115] = 779,
  [1116] = 809,
  [1117] = 880,
  [1118] = 867,
  [1119] = 789,
  [1120] = 914,
  [1121] = 779,
  [1122] = 949,
  [1123] = 875,
  [1124] = 877,
  [1125] = 932,
  [1126] = 771,
  [1127] = 952,
  [1128] = 878,
  [1129] = 879,
  [1130] = 883,
  [1131] = 946,
  [1132] = 874,
  [1133] = 864,
  [1134] = 884,
  [1135] = 912,
  [1136] = 885,
  [1137] = 790,
  [1138] = 886,
  [1139] = 944,
  [1140] = 943,
  [1141] = 890,
  [1142] = 954,
  [1143] = 892,
  [1144] = 893,
  [1145] = 807,
  [1146] = 896,
  [1147] = 897,
  [1148] = 947,
  [1149] = 775,
  [1150] = 774,
  [1151] = 792,
  [1152] = 783,
  [1153] = 797,
  [1154] = 773,
  [1155] = 898,
  [1156] = 872,
  [1157] = 900,
  [1158] = 769,
  [1159] = 929,
  [1160] = 935,
  [1161] = 780,
  [1162] = 945,
  [1163] = 771,
  [1164] = 936,
  [1165] = 781,
  [1166] = 941,
  [1167] = 781,
  [1168] = 804,
  [1169] = 802,
  [1170] = 780,
  [1171] = 942,
  [1172] = 785,
  [1173] = 804,
  [1174] = 799,
  [1175] = 792,
  [1176] = 775,
  [1177] = 769,
  [1178] = 794,
  [1179] = 790,
  [1180] = 769,
  [1181] = 787,
  [1182] = 802,
  [1183] = 808,
  [1184] = 809,
  [1185] = 797,
  [1186] = 790,
  [1187] = 781,
  [1188] = 795,
  [1189] = 807,
  [1190] = 783,
  [1191] = 791,
  [1192] = 785,
  [1193] = 773,
  [1194] = 769,
  [1195] = 827,
  [1196] = 771,
  [1197] = 804,
  [1198] = 801,
  [1199] = 803,
  [1200] = 780,
  [1201] = 773,
  [1202] = 794,
  [1203] = 787,
  [1204] = 808,
  [1205] = 772,
  [1206] = 774,
  [1207] = 808,
  [1208] = 781,
  [1209] = 781,
  [1210] = 775,
  [1211] = 773,
  [1212] = 807,
  [1213] = 787,
  [1214] = 771,
  [1215] = 773,
  [1216] = 794,
  [1217] = 780,
  [1218] = 774,
  [1219] = 771,
  [1220] = 827,
  [1221] = 801,
  [1222] = 780,
  [1223] = 775,
  [1224] = 769,
  [1225] = 781,
  [1226] = 809,
  [1227] = 783,
  [1228] = 769,
  [1229] = 789,
  [1230] = 795,
  [1231] = 780,
  [1232] = 791,
  [1233] = 779,
  [1234] = 798,
  [1235] = 779,
  [1236] = 803,
  [1237] = 781,
  [1238] = 785,
  [1239] = 845,
  [1240] = 772,
  [1241] = 772,
  [1242] = 772,
  [1243] = 790,
  [1244] = 780,
  [1245] = 801,
  [1246] = 803,
  [1247] = 798,
  [1248] = 771,
  [1249] = 779,
  [1250] = 775,
  [1251] = 774,
  [1252] = 775,
  [1253] = 774,
  [1254] = 771,
  [1255] = 809,
  [1256] = 789,
  [1257] = 772,
  [1258] = 807,
  [1259] = 779,
  [1260] = 798,
  [1261] = 783,
  [1262] = 799,
  [1263] = 789,
  [1264] = 799,
  [1265] = 783,
  [1266] = 773,
  [1267] = 799,
  [1268] = 779,
  [1269] = 795,
  [1270] = 802,
  [1271] = 804,
  [1272] = 792,
  [1273] = 797,
  [1274] = 791,
  [1275] = 774,
  [1276] = 783,
  [1277] = 792,
  [1278] = 797,
  [1279] = 802,
  [1280] = 855,
  [1281] = 790,
  [1282] = 801,
  [1283] = 820,
  [1284] = 826,
  [1285] = 792,
  [1286] = 794,
  [1287] = 827,
  [1288] = 799,
  [1289] = 799,
  [1290] = 785,
  [1291] = 842,
  [1292] = 809,
  [1293] = 791,
  [1294] = 830,
  [1295] = 791,
  [1296] = 795,
  [1297] = 792,
  [1298] = 807,
  [1299] = 789,
  [1300] = 804,
  [1301] = 802,
  [1302] = 797,
  [1303] = 809,
  [1304] = 789,
  [1305] = 808,
  [1306] = 854,
  [1307] = 787,
  [1308] = 799,
  [1309] = 820,
  [1310] = 827,
  [1311] = 808,
  [1312] = 792,
  [1313] = 797,
  [1314] = 802,
  [1315] = 804,
  [1316] = 802,
  [1317] = 804,
  [1318] = 798,
  [1319] = 803,
  [1320] = 785,
  [1321] = 807,
  [1322] = 797,
  [1323] = 792,
  [1324] = 804,
  [1325] = 807,
  [1326] = 802,
  [1327] = 860,
  [1328] = 799,
  [1329] = 801,
  [1330] = 790,
  [1331] = 797,
  [1332] = 807,
  [1333] = 794,
  [1334] = 792,
  [1335] = 790,
  [1336] = 795,
  [1337] = 795,
  [1338] = 827,
  [1339] = 803,
  [1340] = 832,
  [1341] = 807,
  [1342] = 789,
  [1343] = 795,
  [1344] = 789,
  [1345] = 809,
  [1346] = 809,
  [1347] = 798,
  [1348] = 855,
  [1349] = 808,
  [1350] = 791,
  [1351] = 785,
  [1352] = 828,
  [1353] = 791,
  [1354] = 790,
  [1355] = 821,
  [1356] = 803,
  [1357] = 787,
  [1358] = 798,
  [1359] = 803,
  [1360] = 808,
  [1361] = 787,
  [1362] = 858,
  [1363] = 801,
  [1364] = 794,
  [1365] = 804,
  [1366] = 787,
  [1367] = 820,
  [1368] = 860,
  [1369] = 801,
  [1370] = 1370,
  [1371] = 785,
  [1372] = 799,
  [1373] = 823,
  [1374] = 794,
  [1375] = 801,
  [1376] = 798,
  [1377] = 802,
  [1378] = 809,
  [1379] = 787,
  [1380] = 795,
  [1381] = 789,
  [1382] = 791,
  [1383] = 785,
  [1384] = 854,
  [1385] = 858,
  [1386] = 827,
  [1387] = 790,
  [1388] = 794,
  [1389] = 842,
  [1390] = 803,
  [1391] = 833,
  [1392] = 842,
  [1393] = 797,
  [1394] = 808,
  [1395] = 820,
  [1396] = 798,
  [1397] = 842,
  [1398] = 842,
  [1399] = 845,
  [1400] = 820,
  [1401] = 827,
  [1402] = 827,
  [1403] = 826,
  [1404] = 826,
  [1405] = 830,
  [1406] = 832,
  [1407] = 830,
  [1408] = 823,
  [1409] = 1409,
  [1410] = 833,
  [1411] = 832,
  [1412] = 823,
  [1413] = 821,
  [1414] = 858,
  [1415] = 855,
  [1416] = 820,
  [1417] = 854,
  [1418] = 828,
  [1419] = 821,
  [1420] = 836,
  [1421] = 835,
  [1422] = 842,
  [1423] = 857,
  [1424] = 838,
  [1425] = 860,
  [1426] = 880,
  [1427] = 860,
  [1428] = 847,
  [1429] = 820,
  [1430] = 844,
  [1431] = 827,
  [1432] = 833,
  [1433] = 820,
  [1434] = 858,
  [1435] = 839,
  [1436] = 858,
  [1437] = 866,
  [1438] = 860,
  [1439] = 855,
  [1440] = 820,
  [1441] = 854,
  [1442] = 827,
  [1443] = 842,
  [1444] = 858,
  [1445] = 781,
  [1446] = 845,
  [1447] = 860,
  [1448] = 855,
  [1449] = 833,
  [1450] = 830,
  [1451] = 833,
  [1452] = 780,
  [1453] = 854,
  [1454] = 855,
  [1455] = 780,
  [1456] = 826,
  [1457] = 830,
  [1458] = 821,
  [1459] = 827,
  [1460] = 820,
  [1461] = 821,
  [1462] = 842,
  [1463] = 823,
  [1464] = 832,
  [1465] = 826,
  [1466] = 781,
  [1467] = 854,
  [1468] = 828,
  [1469] = 828,
  [1470] = 828,
  [1471] = 823,
  [1472] = 820,
  [1473] = 832,
  [1474] = 820,
  [1475] = 839,
  [1476] = 941,
  [1477] = 877,
  [1478] = 820,
  [1479] = 875,
  [1480] = 874,
  [1481] = 842,
  [1482] = 870,
  [1483] = 869,
  [1484] = 868,
  [1485] = 826,
  [1486] = 880,
  [1487] = 860,
  [1488] = 830,
  [1489] = 865,
  [1490] = 866,
  [1491] = 1491,
  [1492] = 847,
  [1493] = 854,
  [1494] = 858,
  [1495] = 833,
  [1496] = 838,
  [1497] = 821,
  [1498] = 857,
  [1499] = 844,
  [1500] = 855,
  [1501] = 832,
  [1502] = 823,
  [1503] = 844,
  [1504] = 880,
  [1505] = 835,
  [1506] = 836,
  [1507] = 847,
  [1508] = 858,
  [1509] = 826,
  [1510] = 845,
  [1511] = 860,
  [1512] = 790,
  [1513] = 830,
  [1514] = 845,
  [1515] = 821,
  [1516] = 823,
  [1517] = 832,
  [1518] = 820,
  [1519] = 854,
  [1520] = 790,
  [1521] = 912,
  [1522] = 1491,
  [1523] = 833,
  [1524] = 838,
  [1525] = 857,
  [1526] = 835,
  [1527] = 830,
  [1528] = 836,
  [1529] = 832,
  [1530] = 826,
  [1531] = 823,
  [1532] = 820,
  [1533] = 839,
  [1534] = 828,
  [1535] = 820,
  [1536] = 878,
  [1537] = 867,
  [1538] = 864,
  [1539] = 820,
  [1540] = 820,
  [1541] = 889,
  [1542] = 866,
  [1543] = 879,
  [1544] = 883,
  [1545] = 884,
  [1546] = 855,
  [1547] = 885,
  [1548] = 780,
  [1549] = 876,
  [1550] = 881,
  [1551] = 882,
  [1552] = 888,
  [1553] = 903,
  [1554] = 886,
  [1555] = 901,
  [1556] = 906,
  [1557] = 907,
  [1558] = 866,
  [1559] = 880,
  [1560] = 909,
  [1561] = 821,
  [1562] = 931,
  [1563] = 914,
  [1564] = 820,
  [1565] = 836,
  [1566] = 927,
  [1567] = 928,
  [1568] = 823,
  [1569] = 832,
  [1570] = 929,
  [1571] = 780,
  [1572] = 828,
  [1573] = 828,
  [1574] = 821,
  [1575] = 854,
  [1576] = 890,
  [1577] = 855,
  [1578] = 866,
  [1579] = 781,
  [1580] = 935,
  [1581] = 936,
  [1582] = 780,
  [1583] = 942,
  [1584] = 946,
  [1585] = 866,
  [1586] = 860,
  [1587] = 781,
  [1588] = 780,
  [1589] = 880,
  [1590] = 947,
  [1591] = 949,
  [1592] = 950,
  [1593] = 842,
  [1594] = 863,
  [1595] = 858,
  [1596] = 953,
  [1597] = 781,
  [1598] = 830,
  [1599] = 826,
  [1600] = 957,
  [1601] = 958,
  [1602] = 956,
  [1603] = 955,
  [1604] = 954,
  [1605] = 892,
  [1606] = 781,
  [1607] = 780,
  [1608] = 944,
  [1609] = 943,
  [1610] = 940,
  [1611] = 939,
  [1612] = 938,
  [1613] = 833,
  [1614] = 860,
  [1615] = 862,
  [1616] = 893,
  [1617] = 932,
  [1618] = 781,
  [1619] = 896,
  [1620] = 866,
  [1621] = 842,
  [1622] = 858,
  [1623] = 913,
  [1624] = 905,
  [1625] = 899,
  [1626] = 1626,
  [1627] = 891,
  [1628] = 897,
  [1629] = 820,
  [1630] = 839,
  [1631] = 1491,
  [1632] = 880,
  [1633] = 898,
  [1634] = 900,
  [1635] = 866,
  [1636] = 828,
  [1637] = 915,
  [1638] = 844,
  [1639] = 916,
  [1640] = 820,
  [1641] = 952,
  [1642] = 847,
  [1643] = 872,
  [1644] = 845,
  [1645] = 871,
  [1646] = 917,
  [1647] = 918,
  [1648] = 894,
  [1649] = 820,
  [1650] = 1491,
  [1651] = 919,
  [1652] = 887,
  [1653] = 880,
  [1654] = 839,
  [1655] = 880,
  [1656] = 820,
  [1657] = 847,
  [1658] = 945,
  [1659] = 833,
  [1660] = 838,
  [1661] = 838,
  [1662] = 857,
  [1663] = 857,
  [1664] = 854,
  [1665] = 835,
  [1666] = 836,
  [1667] = 828,
  [1668] = 833,
  [1669] = 845,
  [1670] = 820,
  [1671] = 855,
  [1672] = 860,
  [1673] = 858,
  [1674] = 820,
  [1675] = 842,
  [1676] = 820,
  [1677] = 855,
  [1678] = 821,
  [1679] = 823,
  [1680] = 832,
  [1681] = 854,
  [1682] = 844,
  [1683] = 830,
  [1684] = 826,
  [1685] = 842,
  [1686] = 845,
  [1687] = 842,
  [1688] = 835,
  [1689] = 873,
  [1690] = 877,
  [1691] = 918,
  [1692] = 870,
  [1693] = 869,
  [1694] = 868,
  [1695] = 865,
  [1696] = 913,
  [1697] = 905,
  [1698] = 880,
  [1699] = 899,
  [1700] = 891,
  [1701] = 872,
  [1702] = 871,
  [1703] = 836,
  [1704] = 835,
  [1705] = 913,
  [1706] = 857,
  [1707] = 839,
  [1708] = 838,
  [1709] = 905,
  [1710] = 899,
  [1711] = 874,
  [1712] = 894,
  [1713] = 891,
  [1714] = 875,
  [1715] = 877,
  [1716] = 878,
  [1717] = 879,
  [1718] = 883,
  [1719] = 884,
  [1720] = 885,
  [1721] = 1721,
  [1722] = 886,
  [1723] = 887,
  [1724] = 873,
  [1725] = 872,
  [1726] = 871,
  [1727] = 890,
  [1728] = 892,
  [1729] = 847,
  [1730] = 844,
  [1731] = 913,
  [1732] = 893,
  [1733] = 905,
  [1734] = 839,
  [1735] = 899,
  [1736] = 894,
  [1737] = 896,
  [1738] = 897,
  [1739] = 891,
  [1740] = 898,
  [1741] = 900,
  [1742] = 915,
  [1743] = 866,
  [1744] = 916,
  [1745] = 917,
  [1746] = 918,
  [1747] = 919,
  [1748] = 866,
  [1749] = 844,
  [1750] = 873,
  [1751] = 873,
  [1752] = 845,
  [1753] = 871,
  [1754] = 945,
  [1755] = 866,
  [1756] = 932,
  [1757] = 862,
  [1758] = 938,
  [1759] = 939,
  [1760] = 940,
  [1761] = 943,
  [1762] = 944,
  [1763] = 954,
  [1764] = 955,
  [1765] = 847,
  [1766] = 956,
  [1767] = 958,
  [1768] = 957,
  [1769] = 953,
  [1770] = 863,
  [1771] = 950,
  [1772] = 949,
  [1773] = 947,
  [1774] = 946,
  [1775] = 942,
  [1776] = 941,
  [1777] = 936,
  [1778] = 935,
  [1779] = 931,
  [1780] = 929,
  [1781] = 928,
  [1782] = 927,
  [1783] = 952,
  [1784] = 914,
  [1785] = 912,
  [1786] = 909,
  [1787] = 907,
  [1788] = 906,
  [1789] = 901,
  [1790] = 894,
  [1791] = 894,
  [1792] = 1721,
  [1793] = 888,
  [1794] = 882,
  [1795] = 881,
  [1796] = 820,
  [1797] = 867,
  [1798] = 876,
  [1799] = 865,
  [1800] = 864,
  [1801] = 868,
  [1802] = 880,
  [1803] = 845,
  [1804] = 869,
  [1805] = 790,
  [1806] = 864,
  [1807] = 870,
  [1808] = 820,
  [1809] = 867,
  [1810] = 872,
  [1811] = 903,
  [1812] = 873,
  [1813] = 872,
  [1814] = 874,
  [1815] = 836,
  [1816] = 780,
  [1817] = 781,
  [1818] = 875,
  [1819] = 835,
  [1820] = 842,
  [1821] = 877,
  [1822] = 857,
  [1823] = 838,
  [1824] = 844,
  [1825] = 878,
  [1826] = 879,
  [1827] = 790,
  [1828] = 839,
  [1829] = 847,
  [1830] = 883,
  [1831] = 884,
  [1832] = 885,
  [1833] = 880,
  [1834] = 1721,
  [1835] = 886,
  [1836] = 1491,
  [1837] = 887,
  [1838] = 890,
  [1839] = 892,
  [1840] = 893,
  [1841] = 896,
  [1842] = 897,
  [1843] = 898,
  [1844] = 876,
  [1845] = 881,
  [1846] = 882,
  [1847] = 900,
  [1848] = 889,
  [1849] = 790,
  [1850] = 820,
  [1851] = 1491,
  [1852] = 915,
  [1853] = 888,
  [1854] = 916,
  [1855] = 917,
  [1856] = 918,
  [1857] = 919,
  [1858] = 865,
  [1859] = 868,
  [1860] = 871,
  [1861] = 869,
  [1862] = 870,
  [1863] = 874,
  [1864] = 1721,
  [1865] = 875,
  [1866] = 945,
  [1867] = 878,
  [1868] = 847,
  [1869] = 879,
  [1870] = 883,
  [1871] = 844,
  [1872] = 884,
  [1873] = 885,
  [1874] = 886,
  [1875] = 839,
  [1876] = 845,
  [1877] = 887,
  [1878] = 890,
  [1879] = 892,
  [1880] = 893,
  [1881] = 880,
  [1882] = 866,
  [1883] = 896,
  [1884] = 897,
  [1885] = 898,
  [1886] = 901,
  [1887] = 906,
  [1888] = 907,
  [1889] = 909,
  [1890] = 900,
  [1891] = 915,
  [1892] = 916,
  [1893] = 790,
  [1894] = 952,
  [1895] = 917,
  [1896] = 912,
  [1897] = 918,
  [1898] = 914,
  [1899] = 919,
  [1900] = 891,
  [1901] = 866,
  [1902] = 899,
  [1903] = 836,
  [1904] = 780,
  [1905] = 1491,
  [1906] = 835,
  [1907] = 905,
  [1908] = 913,
  [1909] = 903,
  [1910] = 781,
  [1911] = 945,
  [1912] = 927,
  [1913] = 928,
  [1914] = 781,
  [1915] = 889,
  [1916] = 929,
  [1917] = 780,
  [1918] = 857,
  [1919] = 932,
  [1920] = 931,
  [1921] = 952,
  [1922] = 935,
  [1923] = 936,
  [1924] = 941,
  [1925] = 942,
  [1926] = 946,
  [1927] = 838,
  [1928] = 880,
  [1929] = 862,
  [1930] = 938,
  [1931] = 939,
  [1932] = 947,
  [1933] = 949,
  [1934] = 950,
  [1935] = 863,
  [1936] = 953,
  [1937] = 940,
  [1938] = 838,
  [1939] = 857,
  [1940] = 943,
  [1941] = 944,
  [1942] = 957,
  [1943] = 839,
  [1944] = 954,
  [1945] = 958,
  [1946] = 956,
  [1947] = 955,
  [1948] = 954,
  [1949] = 955,
  [1950] = 956,
  [1951] = 958,
  [1952] = 957,
  [1953] = 944,
  [1954] = 943,
  [1955] = 835,
  [1956] = 953,
  [1957] = 863,
  [1958] = 889,
  [1959] = 950,
  [1960] = 940,
  [1961] = 939,
  [1962] = 938,
  [1963] = 862,
  [1964] = 836,
  [1965] = 949,
  [1966] = 947,
  [1967] = 946,
  [1968] = 942,
  [1969] = 941,
  [1970] = 932,
  [1971] = 936,
  [1972] = 935,
  [1973] = 931,
  [1974] = 929,
  [1975] = 780,
  [1976] = 928,
  [1977] = 927,
  [1978] = 903,
  [1979] = 838,
  [1980] = 857,
  [1981] = 914,
  [1982] = 912,
  [1983] = 781,
  [1984] = 909,
  [1985] = 907,
  [1986] = 906,
  [1987] = 901,
  [1988] = 845,
  [1989] = 903,
  [1990] = 844,
  [1991] = 835,
  [1992] = 790,
  [1993] = 820,
  [1994] = 836,
  [1995] = 866,
  [1996] = 888,
  [1997] = 847,
  [1998] = 882,
  [1999] = 881,
  [2000] = 867,
  [2001] = 876,
  [2002] = 780,
  [2003] = 864,
  [2004] = 1491,
  [2005] = 889,
  [2006] = 952,
  [2007] = 864,
  [2008] = 867,
  [2009] = 781,
  [2010] = 845,
  [2011] = 820,
  [2012] = 865,
  [2013] = 932,
  [2014] = 868,
  [2015] = 862,
  [2016] = 938,
  [2017] = 939,
  [2018] = 940,
  [2019] = 869,
  [2020] = 870,
  [2021] = 943,
  [2022] = 944,
  [2023] = 954,
  [2024] = 955,
  [2025] = 956,
  [2026] = 958,
  [2027] = 874,
  [2028] = 875,
  [2029] = 957,
  [2030] = 953,
  [2031] = 863,
  [2032] = 945,
  [2033] = 950,
  [2034] = 949,
  [2035] = 947,
  [2036] = 877,
  [2037] = 878,
  [2038] = 946,
  [2039] = 942,
  [2040] = 941,
  [2041] = 936,
  [2042] = 935,
  [2043] = 931,
  [2044] = 879,
  [2045] = 883,
  [2046] = 929,
  [2047] = 876,
  [2048] = 881,
  [2049] = 882,
  [2050] = 928,
  [2051] = 927,
  [2052] = 884,
  [2053] = 1626,
  [2054] = 885,
  [2055] = 886,
  [2056] = 888,
  [2057] = 887,
  [2058] = 890,
  [2059] = 892,
  [2060] = 893,
  [2061] = 896,
  [2062] = 880,
  [2063] = 914,
  [2064] = 912,
  [2065] = 897,
  [2066] = 909,
  [2067] = 907,
  [2068] = 906,
  [2069] = 901,
  [2070] = 898,
  [2071] = 900,
  [2072] = 915,
  [2073] = 916,
  [2074] = 917,
  [2075] = 919,
  [2076] = 887,
  [2077] = 887,
  [2078] = 903,
  [2079] = 872,
  [2080] = 871,
  [2081] = 916,
  [2082] = 912,
  [2083] = 914,
  [2084] = 894,
  [2085] = 889,
  [2086] = 907,
  [2087] = 952,
  [2088] = 945,
  [2089] = 873,
  [2090] = 899,
  [2091] = 906,
  [2092] = 901,
  [2093] = 873,
  [2094] = 894,
  [2095] = 927,
  [2096] = 928,
  [2097] = 929,
  [2098] = 865,
  [2099] = 919,
  [2100] = 868,
  [2101] = 918,
  [2102] = 917,
  [2103] = 914,
  [2104] = 916,
  [2105] = 1491,
  [2106] = 869,
  [2107] = 870,
  [2108] = 915,
  [2109] = 931,
  [2110] = 935,
  [2111] = 936,
  [2112] = 900,
  [2113] = 898,
  [2114] = 897,
  [2115] = 896,
  [2116] = 893,
  [2117] = 892,
  [2118] = 890,
  [2119] = 887,
  [2120] = 886,
  [2121] = 885,
  [2122] = 884,
  [2123] = 883,
  [2124] = 879,
  [2125] = 878,
  [2126] = 877,
  [2127] = 889,
  [2128] = 941,
  [2129] = 1491,
  [2130] = 875,
  [2131] = 874,
  [2132] = 874,
  [2133] = 942,
  [2134] = 946,
  [2135] = 891,
  [2136] = 919,
  [2137] = 918,
  [2138] = 875,
  [2139] = 877,
  [2140] = 905,
  [2141] = 870,
  [2142] = 869,
  [2143] = 917,
  [2144] = 868,
  [2145] = 878,
  [2146] = 879,
  [2147] = 883,
  [2148] = 884,
  [2149] = 885,
  [2150] = 886,
  [2151] = 887,
  [2152] = 865,
  [2153] = 947,
  [2154] = 949,
  [2155] = 932,
  [2156] = 890,
  [2157] = 892,
  [2158] = 862,
  [2159] = 903,
  [2160] = 938,
  [2161] = 893,
  [2162] = 896,
  [2163] = 897,
  [2164] = 939,
  [2165] = 898,
  [2166] = 945,
  [2167] = 940,
  [2168] = 867,
  [2169] = 943,
  [2170] = 944,
  [2171] = 863,
  [2172] = 900,
  [2173] = 953,
  [2174] = 954,
  [2175] = 955,
  [2176] = 956,
  [2177] = 958,
  [2178] = 957,
  [2179] = 864,
  [2180] = 953,
  [2181] = 863,
  [2182] = 871,
  [2183] = 872,
  [2184] = 950,
  [2185] = 949,
  [2186] = 947,
  [2187] = 946,
  [2188] = 912,
  [2189] = 942,
  [2190] = 941,
  [2191] = 936,
  [2192] = 935,
  [2193] = 1721,
  [2194] = 931,
  [2195] = 929,
  [2196] = 928,
  [2197] = 927,
  [2198] = 916,
  [2199] = 903,
  [2200] = 915,
  [2201] = 952,
  [2202] = 914,
  [2203] = 912,
  [2204] = 909,
  [2205] = 907,
  [2206] = 915,
  [2207] = 906,
  [2208] = 901,
  [2209] = 957,
  [2210] = 958,
  [2211] = 956,
  [2212] = 889,
  [2213] = 955,
  [2214] = 954,
  [2215] = 941,
  [2216] = 888,
  [2217] = 882,
  [2218] = 881,
  [2219] = 876,
  [2220] = 913,
  [2221] = 944,
  [2222] = 891,
  [2223] = 899,
  [2224] = 905,
  [2225] = 913,
  [2226] = 876,
  [2227] = 881,
  [2228] = 882,
  [2229] = 864,
  [2230] = 867,
  [2231] = 943,
  [2232] = 872,
  [2233] = 888,
  [2234] = 952,
  [2235] = 950,
  [2236] = 882,
  [2237] = 888,
  [2238] = 881,
  [2239] = 940,
  [2240] = 939,
  [2241] = 938,
  [2242] = 917,
  [2243] = 862,
  [2244] = 889,
  [2245] = 790,
  [2246] = 918,
  [2247] = 876,
  [2248] = 913,
  [2249] = 864,
  [2250] = 932,
  [2251] = 919,
  [2252] = 900,
  [2253] = 932,
  [2254] = 905,
  [2255] = 909,
  [2256] = 898,
  [2257] = 897,
  [2258] = 896,
  [2259] = 893,
  [2260] = 865,
  [2261] = 868,
  [2262] = 903,
  [2263] = 892,
  [2264] = 862,
  [2265] = 938,
  [2266] = 939,
  [2267] = 940,
  [2268] = 899,
  [2269] = 945,
  [2270] = 907,
  [2271] = 890,
  [2272] = 901,
  [2273] = 1721,
  [2274] = 869,
  [2275] = 870,
  [2276] = 943,
  [2277] = 903,
  [2278] = 891,
  [2279] = 906,
  [2280] = 944,
  [2281] = 886,
  [2282] = 907,
  [2283] = 909,
  [2284] = 906,
  [2285] = 912,
  [2286] = 954,
  [2287] = 955,
  [2288] = 2288,
  [2289] = 885,
  [2290] = 884,
  [2291] = 956,
  [2292] = 914,
  [2293] = 883,
  [2294] = 879,
  [2295] = 2295,
  [2296] = 958,
  [2297] = 2297,
  [2298] = 927,
  [2299] = 957,
  [2300] = 2295,
  [2301] = 928,
  [2302] = 877,
  [2303] = 875,
  [2304] = 874,
  [2305] = 873,
  [2306] = 929,
  [2307] = 875,
  [2308] = 953,
  [2309] = 945,
  [2310] = 877,
  [2311] = 863,
  [2312] = 950,
  [2313] = 949,
  [2314] = 913,
  [2315] = 947,
  [2316] = 931,
  [2317] = 871,
  [2318] = 891,
  [2319] = 935,
  [2320] = 790,
  [2321] = 936,
  [2322] = 941,
  [2323] = 942,
  [2324] = 905,
  [2325] = 946,
  [2326] = 878,
  [2327] = 879,
  [2328] = 883,
  [2329] = 790,
  [2330] = 884,
  [2331] = 945,
  [2332] = 885,
  [2333] = 878,
  [2334] = 946,
  [2335] = 899,
  [2336] = 942,
  [2337] = 947,
  [2338] = 949,
  [2339] = 894,
  [2340] = 887,
  [2341] = 890,
  [2342] = 950,
  [2343] = 863,
  [2344] = 936,
  [2345] = 935,
  [2346] = 931,
  [2347] = 953,
  [2348] = 957,
  [2349] = 958,
  [2350] = 956,
  [2351] = 2297,
  [2352] = 955,
  [2353] = 892,
  [2354] = 893,
  [2355] = 929,
  [2356] = 928,
  [2357] = 927,
  [2358] = 954,
  [2359] = 899,
  [2360] = 896,
  [2361] = 944,
  [2362] = 891,
  [2363] = 919,
  [2364] = 918,
  [2365] = 943,
  [2366] = 897,
  [2367] = 874,
  [2368] = 898,
  [2369] = 940,
  [2370] = 939,
  [2371] = 938,
  [2372] = 917,
  [2373] = 862,
  [2374] = 900,
  [2375] = 905,
  [2376] = 932,
  [2377] = 916,
  [2378] = 915,
  [2379] = 894,
  [2380] = 867,
  [2381] = 886,
  [2382] = 790,
  [2383] = 864,
  [2384] = 867,
  [2385] = 900,
  [2386] = 898,
  [2387] = 914,
  [2388] = 897,
  [2389] = 894,
  [2390] = 873,
  [2391] = 872,
  [2392] = 873,
  [2393] = 1721,
  [2394] = 896,
  [2395] = 893,
  [2396] = 892,
  [2397] = 890,
  [2398] = 909,
  [2399] = 886,
  [2400] = 872,
  [2401] = 1721,
  [2402] = 912,
  [2403] = 867,
  [2404] = 885,
  [2405] = 864,
  [2406] = 884,
  [2407] = 883,
  [2408] = 870,
  [2409] = 879,
  [2410] = 878,
  [2411] = 877,
  [2412] = 869,
  [2413] = 915,
  [2414] = 875,
  [2415] = 874,
  [2416] = 932,
  [2417] = 913,
  [2418] = 916,
  [2419] = 870,
  [2420] = 869,
  [2421] = 952,
  [2422] = 862,
  [2423] = 938,
  [2424] = 871,
  [2425] = 868,
  [2426] = 865,
  [2427] = 939,
  [2428] = 940,
  [2429] = 909,
  [2430] = 917,
  [2431] = 943,
  [2432] = 944,
  [2433] = 918,
  [2434] = 919,
  [2435] = 952,
  [2436] = 907,
  [2437] = 906,
  [2438] = 790,
  [2439] = 954,
  [2440] = 955,
  [2441] = 901,
  [2442] = 956,
  [2443] = 876,
  [2444] = 881,
  [2445] = 882,
  [2446] = 958,
  [2447] = 957,
  [2448] = 953,
  [2449] = 888,
  [2450] = 863,
  [2451] = 950,
  [2452] = 949,
  [2453] = 947,
  [2454] = 876,
  [2455] = 946,
  [2456] = 942,
  [2457] = 941,
  [2458] = 936,
  [2459] = 935,
  [2460] = 931,
  [2461] = 881,
  [2462] = 929,
  [2463] = 882,
  [2464] = 888,
  [2465] = 928,
  [2466] = 927,
  [2467] = 889,
  [2468] = 865,
  [2469] = 868,
  [2470] = 871,
  [2471] = 901,
  [2472] = 1721,
  [2473] = 2473,
  [2474] = 2473,
  [2475] = 1721,
  [2476] = 2473,
  [2477] = 2477,
  [2478] = 2478,
  [2479] = 2478,
  [2480] = 2477,
  [2481] = 2481,
  [2482] = 2482,
  [2483] = 2483,
  [2484] = 2481,
  [2485] = 2481,
  [2486] = 2486,
  [2487] = 2486,
  [2488] = 2486,
  [2489] = 2489,
  [2490] = 2482,
  [2491] = 2482,
  [2492] = 2486,
  [2493] = 2483,
  [2494] = 2494,
  [2495] = 2495,
  [2496] = 2494,
  [2497] = 2481,
  [2498] = 2489,
  [2499] = 2494,
  [2500] = 2495,
  [2501] = 2482,
  [2502] = 2483,
  [2503] = 2494,
  [2504] = 2481,
  [2505] = 2482,
  [2506] = 2486,
  [2507] = 2494,
  [2508] = 2482,
  [2509] = 2495,
  [2510] = 2483,
  [2511] = 2481,
  [2512] = 2489,
  [2513] = 2494,
  [2514] = 2483,
  [2515] = 2489,
  [2516] = 2482,
  [2517] = 2495,
  [2518] = 2483,
  [2519] = 2483,
  [2520] = 2489,
  [2521] = 2482,
  [2522] = 2486,
  [2523] = 2486,
  [2524] = 2482,
  [2525] = 2489,
  [2526] = 2489,
  [2527] = 2495,
  [2528] = 2486,
  [2529] = 2486,
  [2530] = 2481,
  [2531] = 2483,
  [2532] = 2483,
  [2533] = 2486,
  [2534] = 2489,
  [2535] = 2482,
  [2536] = 2481,
  [2537] = 2494,
  [2538] = 2495,
  [2539] = 2494,
  [2540] = 2495,
  [2541] = 2495,
  [2542] = 2494,
  [2543] = 2489,
  [2544] = 2495,
  [2545] = 2495,
  [2546] = 2483,
  [2547] = 2483,
  [2548] = 2486,
  [2549] = 2489,
  [2550] = 2494,
  [2551] = 2483,
  [2552] = 2494,
  [2553] = 2489,
  [2554] = 2482,
  [2555] = 2495,
  [2556] = 2495,
  [2557] = 2489,
  [2558] = 2486,
  [2559] = 2481,
  [2560] = 2494,
  [2561] = 2481,
  [2562] = 2482,
  [2563] = 2481,
  [2564] = 2481,
  [2565] = 2565,
  [2566] = 2566,
  [2567] = 2567,
  [2568] = 2568,
  [2569] = 2569,
  [2570] = 2570,
  [2571] = 2571,
  [2572] = 2572,
  [2573] = 2570,
  [2574] = 2570,
  [2575] = 2575,
  [2576] = 2575,
  [2577] = 2575,
  [2578] = 2571,
  [2579] = 2571,
  [2580] = 2569,
  [2581] = 2571,
  [2582] = 2570,
  [2583] = 2570,
  [2584] = 2571,
  [2585] = 2575,
  [2586] = 2570,
  [2587] = 2569,
  [2588] = 2570,
  [2589] = 2570,
  [2590] = 2575,
  [2591] = 2575,
  [2592] = 2575,
  [2593] = 2569,
  [2594] = 2569,
  [2595] = 2570,
  [2596] = 2575,
  [2597] = 2575,
  [2598] = 2569,
  [2599] = 2569,
  [2600] = 2571,
  [2601] = 2569,
  [2602] = 2575,
  [2603] = 2569,
  [2604] = 2604,
  [2605] = 2575,
  [2606] = 2570,
  [2607] = 2570,
  [2608] = 2575,
  [2609] = 2609,
  [2610] = 2570,
  [2611] = 2575,
  [2612] = 2570,
  [2613] = 2569,
  [2614] = 2569,
  [2615] = 758,
  [2616] = 2569,
  [2617] = 2571,
  [2618] = 2569,
  [2619] = 2571,
  [2620] = 2620,
  [2621] = 2621,
  [2622] = 2622,
  [2623] = 2623,
  [2624] = 2624,
  [2625] = 2620,
  [2626] = 2626,
  [2627] = 2621,
  [2628] = 2623,
  [2629] = 2629,
  [2630] = 2630,
  [2631] = 2629,
  [2632] = 2630,
  [2633] = 2620,
  [2634] = 2626,
  [2635] = 2629,
  [2636] = 2630,
  [2637] = 2624,
  [2638] = 2621,
  [2639] = 2620,
  [2640] = 2640,
  [2641] = 2630,
  [2642] = 2629,
  [2643] = 2629,
  [2644] = 2629,
  [2645] = 2626,
  [2646] = 2629,
  [2647] = 2623,
  [2648] = 2621,
  [2649] = 2620,
  [2650] = 2620,
  [2651] = 2629,
  [2652] = 2630,
  [2653] = 2653,
  [2654] = 2621,
  [2655] = 2629,
  [2656] = 2620,
  [2657] = 2629,
  [2658] = 2626,
  [2659] = 2621,
  [2660] = 2620,
  [2661] = 2624,
  [2662] = 2621,
  [2663] = 2623,
  [2664] = 2623,
  [2665] = 2624,
  [2666] = 2623,
  [2667] = 2621,
  [2668] = 2626,
  [2669] = 2669,
  [2670] = 2670,
  [2671] = 2624,
  [2672] = 2626,
  [2673] = 2624,
  [2674] = 2630,
  [2675] = 2624,
  [2676] = 2630,
  [2677] = 2621,
  [2678] = 2678,
  [2679] = 2629,
  [2680] = 2629,
  [2681] = 2681,
  [2682] = 2640,
  [2683] = 2683,
  [2684] = 2626,
  [2685] = 2685,
  [2686] = 2620,
  [2687] = 2629,
  [2688] = 2623,
  [2689] = 2630,
  [2690] = 2629,
  [2691] = 2623,
  [2692] = 2621,
  [2693] = 2693,
  [2694] = 2626,
  [2695] = 2629,
  [2696] = 2626,
  [2697] = 2620,
  [2698] = 2630,
  [2699] = 2630,
  [2700] = 2624,
  [2701] = 2623,
  [2702] = 2626,
  [2703] = 2703,
  [2704] = 2623,
  [2705] = 2624,
  [2706] = 2624,
  [2707] = 759,
  [2708] = 772,
  [2709] = 764,
  [2710] = 775,
  [2711] = 765,
  [2712] = 762,
  [2713] = 773,
  [2714] = 763,
  [2715] = 2715,
  [2716] = 2715,
  [2717] = 2715,
  [2718] = 2715,
  [2719] = 2715,
  [2720] = 2715,
  [2721] = 2715,
  [2722] = 787,
  [2723] = 2715,
  [2724] = 2715,
  [2725] = 2715,
  [2726] = 2715,
  [2727] = 2715,
  [2728] = 2715,
  [2729] = 2715,
  [2730] = 2715,
  [2731] = 2715,
  [2732] = 2715,
  [2733] = 2715,
  [2734] = 2715,
  [2735] = 2715,
  [2736] = 2715,
  [2737] = 2715,
  [2738] = 2715,
  [2739] = 2715,
  [2740] = 2715,
  [2741] = 2715,
  [2742] = 2715,
  [2743] = 2715,
  [2744] = 2715,
  [2745] = 769,
  [2746] = 2746,
  [2747] = 2715,
  [2748] = 808,
  [2749] = 2715,
  [2750] = 781,
  [2751] = 2715,
  [2752] = 2715,
  [2753] = 2715,
  [2754] = 2715,
  [2755] = 2715,
  [2756] = 2715,
  [2757] = 2715,
  [2758] = 780,
  [2759] = 2715,
  [2760] = 2760,
  [2761] = 2715,
  [2762] = 2715,
  [2763] = 2715,
  [2764] = 2715,
  [2765] = 2765,
  [2766] = 2765,
  [2767] = 2765,
  [2768] = 779,
  [2769] = 2765,
  [2770] = 804,
  [2771] = 2765,
  [2772] = 771,
  [2773] = 2765,
  [2774] = 794,
  [2775] = 790,
  [2776] = 2765,
  [2777] = 2765,
  [2778] = 807,
  [2779] = 798,
  [2780] = 801,
  [2781] = 791,
  [2782] = 2782,
  [2783] = 803,
  [2784] = 789,
  [2785] = 795,
  [2786] = 792,
  [2787] = 797,
  [2788] = 802,
  [2789] = 785,
  [2790] = 809,
  [2791] = 827,
  [2792] = 855,
  [2793] = 860,
  [2794] = 858,
  [2795] = 854,
  [2796] = 2796,
  [2797] = 896,
  [2798] = 916,
  [2799] = 915,
  [2800] = 885,
  [2801] = 865,
  [2802] = 903,
  [2803] = 868,
  [2804] = 917,
  [2805] = 869,
  [2806] = 886,
  [2807] = 918,
  [2808] = 887,
  [2809] = 870,
  [2810] = 890,
  [2811] = 892,
  [2812] = 883,
  [2813] = 893,
  [2814] = 879,
  [2815] = 875,
  [2816] = 919,
  [2817] = 884,
  [2818] = 945,
  [2819] = 897,
  [2820] = 889,
  [2821] = 952,
  [2822] = 878,
  [2823] = 898,
  [2824] = 900,
  [2825] = 2825,
  [2826] = 874,
  [2827] = 2827,
  [2828] = 877,
  [2829] = 2829,
  [2830] = 2830,
  [2831] = 2831,
  [2832] = 820,
  [2833] = 2833,
  [2834] = 2834,
  [2835] = 2835,
  [2836] = 2836,
  [2837] = 820,
  [2838] = 2838,
  [2839] = 2839,
  [2840] = 2840,
  [2841] = 2841,
  [2842] = 2833,
  [2843] = 2829,
  [2844] = 2844,
  [2845] = 2845,
  [2846] = 2846,
  [2847] = 2847,
  [2848] = 2848,
  [2849] = 2849,
  [2850] = 2850,
  [2851] = 2851,
  [2852] = 2851,
  [2853] = 2851,
  [2854] = 2851,
  [2855] = 2851,
  [2856] = 2851,
  [2857] = 2851,
  [2858] = 2858,
  [2859] = 2851,
  [2860] = 2851,
  [2861] = 2851,
  [2862] = 2851,
  [2863] = 2863,
  [2864] = 2851,
  [2865] = 758,
  [2866] = 758,
  [2867] = 758,
  [2868] = 758,
  [2869] = 759,
  [2870] = 758,
  [2871] = 759,
  [2872] = 759,
  [2873] = 759,
  [2874] = 759,
  [2875] = 2875,
  [2876] = 775,
  [2877] = 765,
  [2878] = 762,
  [2879] = 2875,
  [2880] = 772,
  [2881] = 764,
  [2882] = 764,
  [2883] = 772,
  [2884] = 773,
  [2885] = 2875,
  [2886] = 775,
  [2887] = 763,
  [2888] = 765,
  [2889] = 762,
  [2890] = 773,
  [2891] = 763,
  [2892] = 2892,
  [2893] = 2893,
  [2894] = 773,
  [2895] = 763,
  [2896] = 765,
  [2897] = 762,
  [2898] = 764,
  [2899] = 773,
  [2900] = 773,
  [2901] = 2892,
  [2902] = 775,
  [2903] = 762,
  [2904] = 787,
  [2905] = 775,
  [2906] = 763,
  [2907] = 769,
  [2908] = 772,
  [2909] = 2893,
  [2910] = 773,
  [2911] = 772,
  [2912] = 772,
  [2913] = 2913,
  [2914] = 773,
  [2915] = 2892,
  [2916] = 808,
  [2917] = 787,
  [2918] = 780,
  [2919] = 762,
  [2920] = 765,
  [2921] = 763,
  [2922] = 2893,
  [2923] = 765,
  [2924] = 808,
  [2925] = 780,
  [2926] = 762,
  [2927] = 764,
  [2928] = 765,
  [2929] = 781,
  [2930] = 775,
  [2931] = 772,
  [2932] = 772,
  [2933] = 775,
  [2934] = 764,
  [2935] = 769,
  [2936] = 763,
  [2937] = 763,
  [2938] = 762,
  [2939] = 2875,
  [2940] = 2875,
  [2941] = 781,
  [2942] = 765,
  [2943] = 764,
  [2944] = 775,
  [2945] = 764,
  [2946] = 779,
  [2947] = 804,
  [2948] = 794,
  [2949] = 773,
  [2950] = 773,
  [2951] = 772,
  [2952] = 808,
  [2953] = 772,
  [2954] = 762,
  [2955] = 775,
  [2956] = 771,
  [2957] = 781,
  [2958] = 765,
  [2959] = 763,
  [2960] = 763,
  [2961] = 808,
  [2962] = 769,
  [2963] = 762,
  [2964] = 2875,
  [2965] = 808,
  [2966] = 804,
  [2967] = 772,
  [2968] = 780,
  [2969] = 775,
  [2970] = 772,
  [2971] = 764,
  [2972] = 775,
  [2973] = 790,
  [2974] = 773,
  [2975] = 769,
  [2976] = 790,
  [2977] = 2913,
  [2978] = 765,
  [2979] = 2892,
  [2980] = 781,
  [2981] = 2913,
  [2982] = 772,
  [2983] = 780,
  [2984] = 2893,
  [2985] = 787,
  [2986] = 2892,
  [2987] = 781,
  [2988] = 780,
  [2989] = 762,
  [2990] = 787,
  [2991] = 780,
  [2992] = 2893,
  [2993] = 808,
  [2994] = 764,
  [2995] = 2892,
  [2996] = 769,
  [2997] = 762,
  [2998] = 765,
  [2999] = 771,
  [3000] = 794,
  [3001] = 765,
  [3002] = 779,
  [3003] = 769,
  [3004] = 775,
  [3005] = 764,
  [3006] = 787,
  [3007] = 773,
  [3008] = 2893,
  [3009] = 787,
  [3010] = 808,
  [3011] = 764,
  [3012] = 763,
  [3013] = 781,
  [3014] = 764,
  [3015] = 769,
  [3016] = 775,
  [3017] = 765,
  [3018] = 763,
  [3019] = 787,
  [3020] = 763,
  [3021] = 762,
  [3022] = 781,
  [3023] = 773,
  [3024] = 780,
  [3025] = 801,
  [3026] = 803,
  [3027] = 787,
  [3028] = 790,
  [3029] = 804,
  [3030] = 807,
  [3031] = 787,
  [3032] = 771,
  [3033] = 785,
  [3034] = 791,
  [3035] = 769,
  [3036] = 804,
  [3037] = 780,
  [3038] = 780,
  [3039] = 794,
  [3040] = 792,
  [3041] = 804,
  [3042] = 797,
  [3043] = 795,
  [3044] = 781,
  [3045] = 797,
  [3046] = 787,
  [3047] = 779,
  [3048] = 808,
  [3049] = 769,
  [3050] = 780,
  [3051] = 771,
  [3052] = 792,
  [3053] = 3053,
  [3054] = 771,
  [3055] = 787,
  [3056] = 804,
  [3057] = 808,
  [3058] = 779,
  [3059] = 781,
  [3060] = 789,
  [3061] = 809,
  [3062] = 794,
  [3063] = 802,
  [3064] = 801,
  [3065] = 804,
  [3066] = 802,
  [3067] = 798,
  [3068] = 763,
  [3069] = 775,
  [3070] = 780,
  [3071] = 794,
  [3072] = 803,
  [3073] = 798,
  [3074] = 807,
  [3075] = 769,
  [3076] = 2913,
  [3077] = 780,
  [3078] = 808,
  [3079] = 795,
  [3080] = 794,
  [3081] = 781,
  [3082] = 787,
  [3083] = 790,
  [3084] = 769,
  [3085] = 808,
  [3086] = 779,
  [3087] = 809,
  [3088] = 790,
  [3089] = 779,
  [3090] = 789,
  [3091] = 771,
  [3092] = 773,
  [3093] = 772,
  [3094] = 781,
  [3095] = 785,
  [3096] = 794,
  [3097] = 764,
  [3098] = 765,
  [3099] = 762,
  [3100] = 790,
  [3101] = 791,
  [3102] = 808,
  [3103] = 769,
  [3104] = 781,
  [3105] = 779,
  [3106] = 790,
  [3107] = 771,
  [3108] = 2913,
  [3109] = 804,
  [3110] = 807,
  [3111] = 771,
  [3112] = 807,
  [3113] = 802,
  [3114] = 779,
  [3115] = 790,
  [3116] = 794,
  [3117] = 797,
  [3118] = 792,
  [3119] = 804,
  [3120] = 795,
  [3121] = 791,
  [3122] = 785,
  [3123] = 789,
  [3124] = 809,
  [3125] = 785,
  [3126] = 798,
  [3127] = 791,
  [3128] = 794,
  [3129] = 795,
  [3130] = 803,
  [3131] = 801,
  [3132] = 804,
  [3133] = 779,
  [3134] = 771,
  [3135] = 790,
  [3136] = 771,
  [3137] = 779,
  [3138] = 771,
  [3139] = 807,
  [3140] = 802,
  [3141] = 801,
  [3142] = 803,
  [3143] = 795,
  [3144] = 779,
  [3145] = 797,
  [3146] = 792,
  [3147] = 789,
  [3148] = 809,
  [3149] = 798,
  [3150] = 803,
  [3151] = 804,
  [3152] = 798,
  [3153] = 791,
  [3154] = 801,
  [3155] = 803,
  [3156] = 798,
  [3157] = 801,
  [3158] = 809,
  [3159] = 789,
  [3160] = 769,
  [3161] = 809,
  [3162] = 789,
  [3163] = 787,
  [3164] = 808,
  [3165] = 792,
  [3166] = 797,
  [3167] = 794,
  [3168] = 795,
  [3169] = 791,
  [3170] = 802,
  [3171] = 807,
  [3172] = 794,
  [3173] = 785,
  [3174] = 790,
  [3175] = 792,
  [3176] = 797,
  [3177] = 794,
  [3178] = 790,
  [3179] = 771,
  [3180] = 785,
  [3181] = 791,
  [3182] = 780,
  [3183] = 795,
  [3184] = 779,
  [3185] = 798,
  [3186] = 809,
  [3187] = 781,
  [3188] = 790,
  [3189] = 804,
  [3190] = 789,
  [3191] = 792,
  [3192] = 797,
  [3193] = 802,
  [3194] = 785,
  [3195] = 807,
  [3196] = 802,
  [3197] = 801,
  [3198] = 803,
  [3199] = 790,
  [3200] = 758,
  [3201] = 809,
  [3202] = 789,
  [3203] = 803,
  [3204] = 792,
  [3205] = 797,
  [3206] = 802,
  [3207] = 807,
  [3208] = 785,
  [3209] = 827,
  [3210] = 791,
  [3211] = 795,
  [3212] = 791,
  [3213] = 795,
  [3214] = 801,
  [3215] = 807,
  [3216] = 802,
  [3217] = 3217,
  [3218] = 798,
  [3219] = 797,
  [3220] = 792,
  [3221] = 809,
  [3222] = 785,
  [3223] = 791,
  [3224] = 795,
  [3225] = 827,
  [3226] = 789,
  [3227] = 809,
  [3228] = 785,
  [3229] = 809,
  [3230] = 789,
  [3231] = 792,
  [3232] = 798,
  [3233] = 803,
  [3234] = 801,
  [3235] = 797,
  [3236] = 797,
  [3237] = 798,
  [3238] = 802,
  [3239] = 807,
  [3240] = 795,
  [3241] = 789,
  [3242] = 785,
  [3243] = 791,
  [3244] = 791,
  [3245] = 785,
  [3246] = 780,
  [3247] = 801,
  [3248] = 795,
  [3249] = 803,
  [3250] = 792,
  [3251] = 803,
  [3252] = 801,
  [3253] = 798,
  [3254] = 797,
  [3255] = 804,
  [3256] = 798,
  [3257] = 809,
  [3258] = 789,
  [3259] = 803,
  [3260] = 802,
  [3261] = 3217,
  [3262] = 807,
  [3263] = 779,
  [3264] = 792,
  [3265] = 3217,
  [3266] = 771,
  [3267] = 794,
  [3268] = 3217,
  [3269] = 3269,
  [3270] = 807,
  [3271] = 801,
  [3272] = 802,
  [3273] = 769,
  [3274] = 781,
  [3275] = 858,
  [3276] = 798,
  [3277] = 803,
  [3278] = 801,
  [3279] = 3279,
  [3280] = 845,
  [3281] = 769,
  [3282] = 809,
  [3283] = 845,
  [3284] = 780,
  [3285] = 789,
  [3286] = 781,
  [3287] = 792,
  [3288] = 797,
  [3289] = 802,
  [3290] = 781,
  [3291] = 860,
  [3292] = 769,
  [3293] = 827,
  [3294] = 807,
  [3295] = 769,
  [3296] = 795,
  [3297] = 780,
  [3298] = 790,
  [3299] = 773,
  [3300] = 775,
  [3301] = 791,
  [3302] = 3302,
  [3303] = 773,
  [3304] = 785,
  [3305] = 860,
  [3306] = 3306,
  [3307] = 3307,
  [3308] = 854,
  [3309] = 827,
  [3310] = 3310,
  [3311] = 780,
  [3312] = 855,
  [3313] = 781,
  [3314] = 775,
  [3315] = 855,
  [3316] = 858,
  [3317] = 854,
  [3318] = 3279,
  [3319] = 854,
  [3320] = 872,
  [3321] = 3321,
  [3322] = 827,
  [3323] = 759,
  [3324] = 845,
  [3325] = 855,
  [3326] = 845,
  [3327] = 3327,
  [3328] = 3279,
  [3329] = 3327,
  [3330] = 855,
  [3331] = 3307,
  [3332] = 860,
  [3333] = 854,
  [3334] = 3334,
  [3335] = 3327,
  [3336] = 3336,
  [3337] = 773,
  [3338] = 3306,
  [3339] = 3327,
  [3340] = 3340,
  [3341] = 775,
  [3342] = 3327,
  [3343] = 858,
  [3344] = 3327,
  [3345] = 3345,
  [3346] = 3346,
  [3347] = 3347,
  [3348] = 3310,
  [3349] = 3310,
  [3350] = 3327,
  [3351] = 3327,
  [3352] = 3307,
  [3353] = 3327,
  [3354] = 3347,
  [3355] = 3355,
  [3356] = 780,
  [3357] = 3355,
  [3358] = 3358,
  [3359] = 3359,
  [3360] = 3306,
  [3361] = 3361,
  [3362] = 3362,
  [3363] = 872,
  [3364] = 769,
  [3365] = 3365,
  [3366] = 773,
  [3367] = 775,
  [3368] = 790,
  [3369] = 787,
  [3370] = 3327,
  [3371] = 3279,
  [3372] = 808,
  [3373] = 3310,
  [3374] = 3307,
  [3375] = 3306,
  [3376] = 860,
  [3377] = 3310,
  [3378] = 3361,
  [3379] = 787,
  [3380] = 3307,
  [3381] = 3359,
  [3382] = 3358,
  [3383] = 3306,
  [3384] = 3384,
  [3385] = 3385,
  [3386] = 3346,
  [3387] = 3345,
  [3388] = 3384,
  [3389] = 3336,
  [3390] = 3390,
  [3391] = 3391,
  [3392] = 858,
  [3393] = 781,
  [3394] = 3327,
  [3395] = 3365,
  [3396] = 790,
  [3397] = 3362,
  [3398] = 3385,
  [3399] = 3390,
  [3400] = 3391,
  [3401] = 808,
  [3402] = 3402,
  [3403] = 3340,
  [3404] = 790,
  [3405] = 3327,
  [3406] = 3406,
  [3407] = 3321,
  [3408] = 918,
  [3409] = 3358,
  [3410] = 873,
  [3411] = 845,
  [3412] = 889,
  [3413] = 889,
  [3414] = 787,
  [3415] = 899,
  [3416] = 3310,
  [3417] = 3417,
  [3418] = 3418,
  [3419] = 3419,
  [3420] = 3307,
  [3421] = 3279,
  [3422] = 3422,
  [3423] = 3423,
  [3424] = 3424,
  [3425] = 3306,
  [3426] = 3426,
  [3427] = 808,
  [3428] = 3428,
  [3429] = 794,
  [3430] = 903,
  [3431] = 3347,
  [3432] = 3355,
  [3433] = 903,
  [3434] = 891,
  [3435] = 3406,
  [3436] = 3436,
  [3437] = 872,
  [3438] = 3438,
  [3439] = 894,
  [3440] = 3440,
  [3441] = 3441,
  [3442] = 919,
  [3443] = 918,
  [3444] = 917,
  [3445] = 916,
  [3446] = 915,
  [3447] = 3321,
  [3448] = 3406,
  [3449] = 905,
  [3450] = 3450,
  [3451] = 3451,
  [3452] = 3362,
  [3453] = 3438,
  [3454] = 3454,
  [3455] = 3455,
  [3456] = 900,
  [3457] = 898,
  [3458] = 891,
  [3459] = 952,
  [3460] = 3424,
  [3461] = 3423,
  [3462] = 3422,
  [3463] = 787,
  [3464] = 897,
  [3465] = 896,
  [3466] = 893,
  [3467] = 892,
  [3468] = 890,
  [3469] = 887,
  [3470] = 886,
  [3471] = 885,
  [3472] = 884,
  [3473] = 883,
  [3474] = 3474,
  [3475] = 3340,
  [3476] = 905,
  [3477] = 945,
  [3478] = 808,
  [3479] = 894,
  [3480] = 879,
  [3481] = 878,
  [3482] = 877,
  [3483] = 875,
  [3484] = 874,
  [3485] = 3426,
  [3486] = 3428,
  [3487] = 913,
  [3488] = 871,
  [3489] = 860,
  [3490] = 3474,
  [3491] = 3391,
  [3492] = 3454,
  [3493] = 872,
  [3494] = 870,
  [3495] = 869,
  [3496] = 3390,
  [3497] = 868,
  [3498] = 865,
  [3499] = 775,
  [3500] = 3451,
  [3501] = 3385,
  [3502] = 3365,
  [3503] = 3450,
  [3504] = 952,
  [3505] = 3441,
  [3506] = 3506,
  [3507] = 3507,
  [3508] = 865,
  [3509] = 868,
  [3510] = 873,
  [3511] = 3361,
  [3512] = 3359,
  [3513] = 3358,
  [3514] = 3346,
  [3515] = 3345,
  [3516] = 3384,
  [3517] = 869,
  [3518] = 3336,
  [3519] = 870,
  [3520] = 3436,
  [3521] = 871,
  [3522] = 790,
  [3523] = 773,
  [3524] = 919,
  [3525] = 945,
  [3526] = 854,
  [3527] = 917,
  [3528] = 899,
  [3529] = 916,
  [3530] = 3336,
  [3531] = 915,
  [3532] = 3532,
  [3533] = 3384,
  [3534] = 3418,
  [3535] = 3345,
  [3536] = 3346,
  [3537] = 3321,
  [3538] = 3347,
  [3539] = 3355,
  [3540] = 3365,
  [3541] = 3385,
  [3542] = 3390,
  [3543] = 3391,
  [3544] = 3507,
  [3545] = 855,
  [3546] = 3506,
  [3547] = 3455,
  [3548] = 3440,
  [3549] = 874,
  [3550] = 875,
  [3551] = 877,
  [3552] = 878,
  [3553] = 879,
  [3554] = 883,
  [3555] = 3362,
  [3556] = 3340,
  [3557] = 884,
  [3558] = 885,
  [3559] = 886,
  [3560] = 3406,
  [3561] = 887,
  [3562] = 794,
  [3563] = 892,
  [3564] = 893,
  [3565] = 896,
  [3566] = 897,
  [3567] = 898,
  [3568] = 900,
  [3569] = 913,
  [3570] = 858,
  [3571] = 890,
  [3572] = 3361,
  [3573] = 3417,
  [3574] = 3359,
  [3575] = 884,
  [3576] = 945,
  [3577] = 892,
  [3578] = 3424,
  [3579] = 3436,
  [3580] = 3423,
  [3581] = 3422,
  [3582] = 3391,
  [3583] = 903,
  [3584] = 3418,
  [3585] = 919,
  [3586] = 3417,
  [3587] = 3507,
  [3588] = 3506,
  [3589] = 885,
  [3590] = 893,
  [3591] = 918,
  [3592] = 3390,
  [3593] = 3385,
  [3594] = 3365,
  [3595] = 3426,
  [3596] = 917,
  [3597] = 3340,
  [3598] = 952,
  [3599] = 916,
  [3600] = 3428,
  [3601] = 915,
  [3602] = 794,
  [3603] = 3406,
  [3604] = 896,
  [3605] = 3440,
  [3606] = 868,
  [3607] = 3441,
  [3608] = 3450,
  [3609] = 897,
  [3610] = 3451,
  [3611] = 3438,
  [3612] = 3454,
  [3613] = 871,
  [3614] = 787,
  [3615] = 898,
  [3616] = 945,
  [3617] = 3336,
  [3618] = 3474,
  [3619] = 913,
  [3620] = 3384,
  [3621] = 889,
  [3622] = 3345,
  [3623] = 905,
  [3624] = 3474,
  [3625] = 3346,
  [3626] = 3358,
  [3627] = 3359,
  [3628] = 3454,
  [3629] = 899,
  [3630] = 3361,
  [3631] = 3451,
  [3632] = 3450,
  [3633] = 3441,
  [3634] = 3438,
  [3635] = 894,
  [3636] = 894,
  [3637] = 3347,
  [3638] = 3355,
  [3639] = 3321,
  [3640] = 3506,
  [3641] = 887,
  [3642] = 3507,
  [3643] = 889,
  [3644] = 883,
  [3645] = 879,
  [3646] = 808,
  [3647] = 878,
  [3648] = 877,
  [3649] = 875,
  [3650] = 873,
  [3651] = 3436,
  [3652] = 874,
  [3653] = 871,
  [3654] = 891,
  [3655] = 872,
  [3656] = 900,
  [3657] = 865,
  [3658] = 868,
  [3659] = 891,
  [3660] = 873,
  [3661] = 900,
  [3662] = 898,
  [3663] = 952,
  [3664] = 3424,
  [3665] = 897,
  [3666] = 896,
  [3667] = 899,
  [3668] = 893,
  [3669] = 905,
  [3670] = 869,
  [3671] = 3418,
  [3672] = 3417,
  [3673] = 870,
  [3674] = 903,
  [3675] = 890,
  [3676] = 892,
  [3677] = 3423,
  [3678] = 865,
  [3679] = 886,
  [3680] = 3455,
  [3681] = 890,
  [3682] = 913,
  [3683] = 3428,
  [3684] = 3455,
  [3685] = 3426,
  [3686] = 870,
  [3687] = 3362,
  [3688] = 869,
  [3689] = 3440,
  [3690] = 874,
  [3691] = 3422,
  [3692] = 919,
  [3693] = 875,
  [3694] = 794,
  [3695] = 887,
  [3696] = 877,
  [3697] = 878,
  [3698] = 879,
  [3699] = 883,
  [3700] = 886,
  [3701] = 884,
  [3702] = 918,
  [3703] = 917,
  [3704] = 916,
  [3705] = 915,
  [3706] = 3706,
  [3707] = 885,
  [3708] = 893,
  [3709] = 868,
  [3710] = 3474,
  [3711] = 3426,
  [3712] = 869,
  [3713] = 3428,
  [3714] = 919,
  [3715] = 3418,
  [3716] = 870,
  [3717] = 903,
  [3718] = 3417,
  [3719] = 3436,
  [3720] = 875,
  [3721] = 918,
  [3722] = 3422,
  [3723] = 3423,
  [3724] = 3424,
  [3725] = 874,
  [3726] = 916,
  [3727] = 877,
  [3728] = 915,
  [3729] = 917,
  [3730] = 889,
  [3731] = 3506,
  [3732] = 3507,
  [3733] = 878,
  [3734] = 871,
  [3735] = 879,
  [3736] = 900,
  [3737] = 873,
  [3738] = 898,
  [3739] = 891,
  [3740] = 897,
  [3741] = 890,
  [3742] = 865,
  [3743] = 896,
  [3744] = 883,
  [3745] = 884,
  [3746] = 894,
  [3747] = 3438,
  [3748] = 885,
  [3749] = 886,
  [3750] = 794,
  [3751] = 887,
  [3752] = 945,
  [3753] = 3440,
  [3754] = 3441,
  [3755] = 3450,
  [3756] = 913,
  [3757] = 952,
  [3758] = 3758,
  [3759] = 905,
  [3760] = 3455,
  [3761] = 3451,
  [3762] = 892,
  [3763] = 3454,
  [3764] = 899,
  [3765] = 3765,
  [3766] = 891,
  [3767] = 913,
  [3768] = 905,
  [3769] = 3769,
  [3770] = 758,
  [3771] = 899,
  [3772] = 3772,
  [3773] = 871,
  [3774] = 3774,
  [3775] = 3775,
  [3776] = 3775,
  [3777] = 3775,
  [3778] = 3775,
  [3779] = 3775,
  [3780] = 3775,
  [3781] = 3775,
  [3782] = 3775,
  [3783] = 3775,
  [3784] = 3784,
  [3785] = 759,
  [3786] = 3775,
  [3787] = 3787,
  [3788] = 3775,
  [3789] = 3775,
  [3790] = 827,
  [3791] = 758,
  [3792] = 3792,
  [3793] = 3793,
  [3794] = 3794,
  [3795] = 3795,
  [3796] = 3796,
  [3797] = 3795,
  [3798] = 3798,
  [3799] = 3799,
  [3800] = 3795,
  [3801] = 3795,
  [3802] = 3802,
  [3803] = 758,
  [3804] = 3795,
  [3805] = 780,
  [3806] = 3802,
  [3807] = 3799,
  [3808] = 3808,
  [3809] = 3809,
  [3810] = 3810,
  [3811] = 3799,
  [3812] = 3812,
  [3813] = 3813,
  [3814] = 3799,
  [3815] = 3813,
  [3816] = 3799,
  [3817] = 3802,
  [3818] = 3799,
  [3819] = 3813,
  [3820] = 3795,
  [3821] = 3799,
  [3822] = 3798,
  [3823] = 3802,
  [3824] = 3799,
  [3825] = 3812,
  [3826] = 3813,
  [3827] = 3813,
  [3828] = 3828,
  [3829] = 3813,
  [3830] = 3802,
  [3831] = 3831,
  [3832] = 3802,
  [3833] = 3833,
  [3834] = 3795,
  [3835] = 3812,
  [3836] = 3793,
  [3837] = 3794,
  [3838] = 3793,
  [3839] = 3799,
  [3840] = 3796,
  [3841] = 3841,
  [3842] = 3798,
  [3843] = 3798,
  [3844] = 3844,
  [3845] = 3802,
  [3846] = 3795,
  [3847] = 3802,
  [3848] = 3848,
  [3849] = 3813,
  [3850] = 3850,
  [3851] = 3812,
  [3852] = 3796,
  [3853] = 3844,
  [3854] = 3844,
  [3855] = 3809,
  [3856] = 3810,
  [3857] = 3802,
  [3858] = 3798,
  [3859] = 3859,
  [3860] = 3860,
  [3861] = 3793,
  [3862] = 3813,
  [3863] = 3799,
  [3864] = 3795,
  [3865] = 3802,
  [3866] = 3796,
  [3867] = 3844,
  [3868] = 3799,
  [3869] = 3799,
  [3870] = 3793,
  [3871] = 3798,
  [3872] = 3833,
  [3873] = 781,
  [3874] = 3799,
  [3875] = 3809,
  [3876] = 3876,
  [3877] = 3795,
  [3878] = 3798,
  [3879] = 3802,
  [3880] = 3813,
  [3881] = 3813,
  [3882] = 3802,
  [3883] = 3799,
  [3884] = 3810,
  [3885] = 3798,
  [3886] = 3886,
  [3887] = 860,
  [3888] = 3813,
  [3889] = 3802,
  [3890] = 3798,
  [3891] = 3795,
  [3892] = 3892,
  [3893] = 3802,
  [3894] = 3813,
  [3895] = 3895,
  [3896] = 3896,
  [3897] = 3802,
  [3898] = 3798,
  [3899] = 3795,
  [3900] = 3798,
  [3901] = 3795,
  [3902] = 3794,
  [3903] = 3795,
  [3904] = 3798,
  [3905] = 3802,
  [3906] = 3795,
  [3907] = 3907,
  [3908] = 3833,
  [3909] = 3799,
  [3910] = 3810,
  [3911] = 3799,
  [3912] = 3796,
  [3913] = 3794,
  [3914] = 3809,
  [3915] = 3813,
  [3916] = 3876,
  [3917] = 3795,
  [3918] = 3799,
  [3919] = 3798,
  [3920] = 3802,
  [3921] = 3813,
  [3922] = 3810,
  [3923] = 3833,
  [3924] = 3812,
  [3925] = 3833,
  [3926] = 3794,
  [3927] = 3795,
  [3928] = 3798,
  [3929] = 3802,
  [3930] = 3802,
  [3931] = 3794,
  [3932] = 3795,
  [3933] = 3798,
  [3934] = 3813,
  [3935] = 3844,
  [3936] = 3936,
  [3937] = 3793,
  [3938] = 3799,
  [3939] = 3799,
  [3940] = 3799,
  [3941] = 3802,
  [3942] = 3844,
  [3943] = 3812,
  [3944] = 3944,
  [3945] = 3795,
  [3946] = 3798,
  [3947] = 3798,
  [3948] = 3798,
  [3949] = 3802,
  [3950] = 3844,
  [3951] = 3794,
  [3952] = 3876,
  [3953] = 3802,
  [3954] = 3813,
  [3955] = 3802,
  [3956] = 3798,
  [3957] = 3795,
  [3958] = 3795,
  [3959] = 769,
  [3960] = 3798,
  [3961] = 3813,
  [3962] = 3795,
  [3963] = 3813,
  [3964] = 3798,
  [3965] = 3802,
  [3966] = 3802,
  [3967] = 3802,
  [3968] = 3798,
  [3969] = 3876,
  [3970] = 858,
  [3971] = 3795,
  [3972] = 3809,
  [3973] = 3973,
  [3974] = 3813,
  [3975] = 3802,
  [3976] = 3812,
  [3977] = 3798,
  [3978] = 3809,
  [3979] = 3798,
  [3980] = 3796,
  [3981] = 3795,
  [3982] = 795,
  [3983] = 3983,
  [3984] = 3813,
  [3985] = 3795,
  [3986] = 791,
  [3987] = 785,
  [3988] = 3844,
  [3989] = 3802,
  [3990] = 3799,
  [3991] = 3798,
  [3992] = 3813,
  [3993] = 3844,
  [3994] = 3798,
  [3995] = 3795,
  [3996] = 3795,
  [3997] = 3997,
  [3998] = 3794,
  [3999] = 3795,
  [4000] = 3796,
  [4001] = 3795,
  [4002] = 3799,
  [4003] = 3795,
  [4004] = 3944,
  [4005] = 3799,
  [4006] = 3809,
  [4007] = 3799,
  [4008] = 3812,
  [4009] = 3997,
  [4010] = 3798,
  [4011] = 3973,
  [4012] = 3813,
  [4013] = 3802,
  [4014] = 3799,
  [4015] = 3799,
  [4016] = 3798,
  [4017] = 3795,
  [4018] = 3798,
  [4019] = 3833,
  [4020] = 4020,
  [4021] = 3844,
  [4022] = 4022,
  [4023] = 3813,
  [4024] = 3793,
  [4025] = 3833,
  [4026] = 3997,
  [4027] = 3802,
  [4028] = 3798,
  [4029] = 3799,
  [4030] = 3833,
  [4031] = 3795,
  [4032] = 3794,
  [4033] = 3799,
  [4034] = 3798,
  [4035] = 855,
  [4036] = 3802,
  [4037] = 3798,
  [4038] = 3802,
  [4039] = 3813,
  [4040] = 3802,
  [4041] = 3833,
  [4042] = 3813,
  [4043] = 3802,
  [4044] = 3810,
  [4045] = 4045,
  [4046] = 3810,
  [4047] = 3809,
  [4048] = 3844,
  [4049] = 3799,
  [4050] = 3802,
  [4051] = 3833,
  [4052] = 3944,
  [4053] = 3798,
  [4054] = 3802,
  [4055] = 3798,
  [4056] = 854,
  [4057] = 3844,
  [4058] = 3795,
  [4059] = 3794,
  [4060] = 3799,
  [4061] = 3798,
  [4062] = 4062,
  [4063] = 3795,
  [4064] = 3798,
  [4065] = 3802,
  [4066] = 3810,
  [4067] = 3799,
  [4068] = 3794,
  [4069] = 3799,
  [4070] = 3802,
  [4071] = 3997,
  [4072] = 3813,
  [4073] = 3997,
  [4074] = 3813,
  [4075] = 3793,
  [4076] = 3944,
  [4077] = 4062,
  [4078] = 3802,
  [4079] = 3997,
  [4080] = 3799,
  [4081] = 3798,
  [4082] = 3799,
  [4083] = 3799,
  [4084] = 3833,
  [4085] = 3795,
  [4086] = 3812,
  [4087] = 3997,
  [4088] = 4088,
  [4089] = 3997,
  [4090] = 3813,
  [4091] = 3833,
  [4092] = 3812,
  [4093] = 3944,
  [4094] = 3813,
  [4095] = 3795,
  [4096] = 3795,
  [4097] = 4097,
  [4098] = 3802,
  [4099] = 3798,
  [4100] = 3794,
  [4101] = 3876,
  [4102] = 3798,
  [4103] = 3799,
  [4104] = 3799,
  [4105] = 3795,
  [4106] = 3799,
  [4107] = 3799,
  [4108] = 3795,
  [4109] = 3798,
  [4110] = 3844,
  [4111] = 4111,
  [4112] = 3796,
  [4113] = 3813,
  [4114] = 3802,
  [4115] = 3799,
  [4116] = 3798,
  [4117] = 3799,
  [4118] = 3944,
  [4119] = 3795,
  [4120] = 3802,
  [4121] = 4121,
  [4122] = 3813,
  [4123] = 3813,
  [4124] = 3799,
  [4125] = 3794,
  [4126] = 3802,
  [4127] = 3798,
  [4128] = 3798,
  [4129] = 3795,
  [4130] = 3799,
  [4131] = 3795,
  [4132] = 3795,
  [4133] = 3833,
  [4134] = 759,
  [4135] = 790,
  [4136] = 3428,
  [4137] = 898,
  [4138] = 759,
  [4139] = 764,
  [4140] = 765,
  [4141] = 4141,
  [4142] = 3422,
  [4143] = 3423,
  [4144] = 3424,
  [4145] = 762,
  [4146] = 4146,
  [4147] = 775,
  [4148] = 913,
  [4149] = 4149,
  [4150] = 865,
  [4151] = 3438,
  [4152] = 868,
  [4153] = 763,
  [4154] = 919,
  [4155] = 918,
  [4156] = 871,
  [4157] = 917,
  [4158] = 916,
  [4159] = 915,
  [4160] = 869,
  [4161] = 945,
  [4162] = 4162,
  [4163] = 4163,
  [4164] = 903,
  [4165] = 874,
  [4166] = 870,
  [4167] = 905,
  [4168] = 889,
  [4169] = 4169,
  [4170] = 773,
  [4171] = 900,
  [4172] = 886,
  [4173] = 897,
  [4174] = 952,
  [4175] = 896,
  [4176] = 3426,
  [4177] = 893,
  [4178] = 892,
  [4179] = 890,
  [4180] = 899,
  [4181] = 875,
  [4182] = 772,
  [4183] = 885,
  [4184] = 884,
  [4185] = 883,
  [4186] = 891,
  [4187] = 879,
  [4188] = 887,
  [4189] = 878,
  [4190] = 877,
  [4191] = 787,
  [4192] = 4192,
  [4193] = 4193,
  [4194] = 781,
  [4195] = 780,
  [4196] = 4196,
  [4197] = 4197,
  [4198] = 4198,
  [4199] = 808,
  [4200] = 769,
  [4201] = 2875,
  [4202] = 772,
  [4203] = 763,
  [4204] = 2892,
  [4205] = 4205,
  [4206] = 2893,
  [4207] = 794,
  [4208] = 762,
  [4209] = 775,
  [4210] = 764,
  [4211] = 779,
  [4212] = 763,
  [4213] = 4213,
  [4214] = 773,
  [4215] = 2875,
  [4216] = 765,
  [4217] = 772,
  [4218] = 790,
  [4219] = 2875,
  [4220] = 4220,
  [4221] = 773,
  [4222] = 775,
  [4223] = 804,
  [4224] = 771,
  [4225] = 764,
  [4226] = 765,
  [4227] = 762,
  [4228] = 2913,
  [4229] = 769,
  [4230] = 781,
  [4231] = 808,
  [4232] = 775,
  [4233] = 789,
  [4234] = 798,
  [4235] = 803,
  [4236] = 773,
  [4237] = 773,
  [4238] = 764,
  [4239] = 765,
  [4240] = 773,
  [4241] = 775,
  [4242] = 762,
  [4243] = 791,
  [4244] = 775,
  [4245] = 801,
  [4246] = 787,
  [4247] = 785,
  [4248] = 792,
  [4249] = 762,
  [4250] = 2892,
  [4251] = 2893,
  [4252] = 795,
  [4253] = 797,
  [4254] = 780,
  [4255] = 780,
  [4256] = 791,
  [4257] = 785,
  [4258] = 772,
  [4259] = 802,
  [4260] = 763,
  [4261] = 781,
  [4262] = 773,
  [4263] = 807,
  [4264] = 765,
  [4265] = 764,
  [4266] = 763,
  [4267] = 773,
  [4268] = 809,
  [4269] = 772,
  [4270] = 762,
  [4271] = 765,
  [4272] = 764,
  [4273] = 772,
  [4274] = 763,
  [4275] = 765,
  [4276] = 763,
  [4277] = 2875,
  [4278] = 764,
  [4279] = 765,
  [4280] = 772,
  [4281] = 762,
  [4282] = 772,
  [4283] = 775,
  [4284] = 762,
  [4285] = 780,
  [4286] = 763,
  [4287] = 808,
  [4288] = 769,
  [4289] = 2875,
  [4290] = 795,
  [4291] = 775,
  [4292] = 769,
  [4293] = 781,
  [4294] = 2893,
  [4295] = 2892,
  [4296] = 787,
  [4297] = 764,
  [4298] = 772,
  [4299] = 787,
  [4300] = 763,
  [4301] = 2892,
  [4302] = 771,
  [4303] = 808,
  [4304] = 779,
  [4305] = 3787,
  [4306] = 790,
  [4307] = 794,
  [4308] = 2893,
  [4309] = 2913,
  [4310] = 790,
  [4311] = 2892,
  [4312] = 762,
  [4313] = 804,
  [4314] = 779,
  [4315] = 772,
  [4316] = 781,
  [4317] = 775,
  [4318] = 762,
  [4319] = 775,
  [4320] = 780,
  [4321] = 780,
  [4322] = 764,
  [4323] = 808,
  [4324] = 765,
  [4325] = 764,
  [4326] = 773,
  [4327] = 2893,
  [4328] = 765,
  [4329] = 762,
  [4330] = 765,
  [4331] = 762,
  [4332] = 764,
  [4333] = 3774,
  [4334] = 775,
  [4335] = 772,
  [4336] = 790,
  [4337] = 794,
  [4338] = 765,
  [4339] = 773,
  [4340] = 764,
  [4341] = 781,
  [4342] = 780,
  [4343] = 781,
  [4344] = 787,
  [4345] = 763,
  [4346] = 804,
  [4347] = 2893,
  [4348] = 2892,
  [4349] = 771,
  [4350] = 769,
  [4351] = 780,
  [4352] = 763,
  [4353] = 781,
  [4354] = 769,
  [4355] = 780,
  [4356] = 763,
  [4357] = 4357,
  [4358] = 772,
  [4359] = 762,
  [4360] = 773,
  [4361] = 808,
  [4362] = 773,
  [4363] = 808,
  [4364] = 765,
  [4365] = 764,
  [4366] = 787,
  [4367] = 781,
  [4368] = 787,
  [4369] = 775,
  [4370] = 787,
  [4371] = 2875,
  [4372] = 769,
  [4373] = 769,
  [4374] = 808,
  [4375] = 2913,
  [4376] = 769,
  [4377] = 773,
  [4378] = 763,
  [4379] = 772,
  [4380] = 775,
  [4381] = 780,
  [4382] = 808,
  [4383] = 771,
  [4384] = 787,
  [4385] = 764,
  [4386] = 765,
  [4387] = 808,
  [4388] = 762,
  [4389] = 772,
  [4390] = 781,
  [4391] = 795,
  [4392] = 804,
  [4393] = 763,
  [4394] = 4394,
  [4395] = 804,
  [4396] = 780,
  [4397] = 791,
  [4398] = 781,
  [4399] = 794,
  [4400] = 781,
  [4401] = 790,
  [4402] = 791,
  [4403] = 779,
  [4404] = 807,
  [4405] = 787,
  [4406] = 802,
  [4407] = 792,
  [4408] = 789,
  [4409] = 858,
  [4410] = 809,
  [4411] = 769,
  [4412] = 780,
  [4413] = 798,
  [4414] = 769,
  [4415] = 785,
  [4416] = 803,
  [4417] = 787,
  [4418] = 794,
  [4419] = 801,
  [4420] = 803,
  [4421] = 808,
  [4422] = 769,
  [4423] = 775,
  [4424] = 2913,
  [4425] = 827,
  [4426] = 771,
  [4427] = 773,
  [4428] = 780,
  [4429] = 779,
  [4430] = 804,
  [4431] = 795,
  [4432] = 785,
  [4433] = 769,
  [4434] = 790,
  [4435] = 781,
  [4436] = 779,
  [4437] = 794,
  [4438] = 773,
  [4439] = 780,
  [4440] = 808,
  [4441] = 3279,
  [4442] = 787,
  [4443] = 771,
  [4444] = 775,
  [4445] = 769,
  [4446] = 794,
  [4447] = 804,
  [4448] = 790,
  [4449] = 779,
  [4450] = 801,
  [4451] = 769,
  [4452] = 771,
  [4453] = 797,
  [4454] = 787,
  [4455] = 2913,
  [4456] = 798,
  [4457] = 781,
  [4458] = 794,
  [4459] = 809,
  [4460] = 804,
  [4461] = 790,
  [4462] = 789,
  [4463] = 779,
  [4464] = 790,
  [4465] = 807,
  [4466] = 808,
  [4467] = 771,
  [4468] = 792,
  [4469] = 797,
  [4470] = 802,
  [4471] = 781,
  [4472] = 780,
  [4473] = 790,
  [4474] = 809,
  [4475] = 798,
  [4476] = 789,
  [4477] = 803,
  [4478] = 801,
  [4479] = 792,
  [4480] = 797,
  [4481] = 802,
  [4482] = 804,
  [4483] = 3384,
  [4484] = 790,
  [4485] = 807,
  [4486] = 3346,
  [4487] = 804,
  [4488] = 4045,
  [4489] = 801,
  [4490] = 803,
  [4491] = 808,
  [4492] = 3841,
  [4493] = 798,
  [4494] = 794,
  [4495] = 809,
  [4496] = 771,
  [4497] = 789,
  [4498] = 801,
  [4499] = 792,
  [4500] = 797,
  [4501] = 802,
  [4502] = 779,
  [4503] = 807,
  [4504] = 803,
  [4505] = 798,
  [4506] = 794,
  [4507] = 771,
  [4508] = 809,
  [4509] = 789,
  [4510] = 790,
  [4511] = 779,
  [4512] = 860,
  [4513] = 787,
  [4514] = 795,
  [4515] = 791,
  [4516] = 785,
  [4517] = 772,
  [4518] = 792,
  [4519] = 763,
  [4520] = 773,
  [4521] = 804,
  [4522] = 764,
  [4523] = 765,
  [4524] = 762,
  [4525] = 797,
  [4526] = 787,
  [4527] = 801,
  [4528] = 775,
  [4529] = 803,
  [4530] = 802,
  [4531] = 792,
  [4532] = 807,
  [4533] = 797,
  [4534] = 779,
  [4535] = 773,
  [4536] = 790,
  [4537] = 854,
  [4538] = 801,
  [4539] = 803,
  [4540] = 798,
  [4541] = 855,
  [4542] = 3336,
  [4543] = 798,
  [4544] = 809,
  [4545] = 785,
  [4546] = 791,
  [4547] = 3358,
  [4548] = 789,
  [4549] = 771,
  [4550] = 795,
  [4551] = 795,
  [4552] = 794,
  [4553] = 791,
  [4554] = 785,
  [4555] = 779,
  [4556] = 794,
  [4557] = 804,
  [4558] = 790,
  [4559] = 3345,
  [4560] = 3359,
  [4561] = 3361,
  [4562] = 795,
  [4563] = 792,
  [4564] = 797,
  [4565] = 771,
  [4566] = 775,
  [4567] = 3886,
  [4568] = 791,
  [4569] = 785,
  [4570] = 790,
  [4571] = 802,
  [4572] = 779,
  [4573] = 807,
  [4574] = 789,
  [4575] = 804,
  [4576] = 794,
  [4577] = 807,
  [4578] = 809,
  [4579] = 785,
  [4580] = 802,
  [4581] = 791,
  [4582] = 795,
  [4583] = 771,
  [4584] = 808,
  [4585] = 794,
  [4586] = 809,
  [4587] = 4587,
  [4588] = 4587,
  [4589] = 809,
  [4590] = 4587,
  [4591] = 789,
  [4592] = 771,
  [4593] = 4587,
  [4594] = 787,
  [4595] = 4595,
  [4596] = 804,
  [4597] = 769,
  [4598] = 807,
  [4599] = 4595,
  [4600] = 4587,
  [4601] = 4595,
  [4602] = 802,
  [4603] = 4587,
  [4604] = 779,
  [4605] = 4595,
  [4606] = 785,
  [4607] = 797,
  [4608] = 792,
  [4609] = 795,
  [4610] = 785,
  [4611] = 791,
  [4612] = 791,
  [4613] = 795,
  [4614] = 795,
  [4615] = 791,
  [4616] = 4587,
  [4617] = 2825,
  [4618] = 785,
  [4619] = 4595,
  [4620] = 4587,
  [4621] = 4595,
  [4622] = 789,
  [4623] = 809,
  [4624] = 791,
  [4625] = 798,
  [4626] = 798,
  [4627] = 4587,
  [4628] = 781,
  [4629] = 803,
  [4630] = 4595,
  [4631] = 801,
  [4632] = 4595,
  [4633] = 4587,
  [4634] = 762,
  [4635] = 4595,
  [4636] = 808,
  [4637] = 4587,
  [4638] = 4595,
  [4639] = 4595,
  [4640] = 4587,
  [4641] = 4587,
  [4642] = 802,
  [4643] = 4643,
  [4644] = 4587,
  [4645] = 780,
  [4646] = 802,
  [4647] = 4595,
  [4648] = 4595,
  [4649] = 808,
  [4650] = 4595,
  [4651] = 797,
  [4652] = 792,
  [4653] = 4587,
  [4654] = 4595,
  [4655] = 765,
  [4656] = 764,
  [4657] = 789,
  [4658] = 2796,
  [4659] = 4587,
  [4660] = 809,
  [4661] = 798,
  [4662] = 4595,
  [4663] = 4595,
  [4664] = 807,
  [4665] = 801,
  [4666] = 801,
  [4667] = 785,
  [4668] = 795,
  [4669] = 792,
  [4670] = 797,
  [4671] = 4587,
  [4672] = 4587,
  [4673] = 801,
  [4674] = 4595,
  [4675] = 807,
  [4676] = 803,
  [4677] = 798,
  [4678] = 803,
  [4679] = 809,
  [4680] = 789,
  [4681] = 792,
  [4682] = 797,
  [4683] = 802,
  [4684] = 807,
  [4685] = 802,
  [4686] = 772,
  [4687] = 787,
  [4688] = 763,
  [4689] = 4595,
  [4690] = 807,
  [4691] = 794,
  [4692] = 4587,
  [4693] = 785,
  [4694] = 791,
  [4695] = 797,
  [4696] = 801,
  [4697] = 803,
  [4698] = 795,
  [4699] = 4595,
  [4700] = 798,
  [4701] = 2827,
  [4702] = 4587,
  [4703] = 4587,
  [4704] = 4587,
  [4705] = 4595,
  [4706] = 792,
  [4707] = 4595,
  [4708] = 803,
  [4709] = 789,
  [4710] = 781,
  [4711] = 4711,
  [4712] = 4711,
  [4713] = 809,
  [4714] = 4711,
  [4715] = 4711,
  [4716] = 4716,
  [4717] = 762,
  [4718] = 3507,
  [4719] = 4716,
  [4720] = 870,
  [4721] = 2830,
  [4722] = 807,
  [4723] = 795,
  [4724] = 4711,
  [4725] = 780,
  [4726] = 3438,
  [4727] = 887,
  [4728] = 4711,
  [4729] = 798,
  [4730] = 794,
  [4731] = 889,
  [4732] = 791,
  [4733] = 803,
  [4734] = 4711,
  [4735] = 801,
  [4736] = 865,
  [4737] = 3454,
  [4738] = 802,
  [4739] = 3451,
  [4740] = 4711,
  [4741] = 785,
  [4742] = 3450,
  [4743] = 858,
  [4744] = 3441,
  [4745] = 4716,
  [4746] = 869,
  [4747] = 4716,
  [4748] = 4748,
  [4749] = 4748,
  [4750] = 4750,
  [4751] = 4751,
  [4752] = 797,
  [4753] = 769,
  [4754] = 792,
  [4755] = 4716,
  [4756] = 4716,
  [4757] = 4711,
  [4758] = 4716,
  [4759] = 4716,
  [4760] = 2829,
  [4761] = 4716,
  [4762] = 763,
  [4763] = 4711,
  [4764] = 769,
  [4765] = 868,
  [4766] = 4716,
  [4767] = 4711,
  [4768] = 4716,
  [4769] = 779,
  [4770] = 4711,
  [4771] = 794,
  [4772] = 2833,
  [4773] = 4773,
  [4774] = 4716,
  [4775] = 3455,
  [4776] = 3440,
  [4777] = 3406,
  [4778] = 3428,
  [4779] = 772,
  [4780] = 903,
  [4781] = 3426,
  [4782] = 780,
  [4783] = 874,
  [4784] = 4711,
  [4785] = 775,
  [4786] = 771,
  [4787] = 4716,
  [4788] = 4716,
  [4789] = 764,
  [4790] = 781,
  [4791] = 875,
  [4792] = 4716,
  [4793] = 820,
  [4794] = 3436,
  [4795] = 4795,
  [4796] = 789,
  [4797] = 945,
  [4798] = 3417,
  [4799] = 4773,
  [4800] = 4800,
  [4801] = 820,
  [4802] = 3418,
  [4803] = 919,
  [4804] = 4711,
  [4805] = 773,
  [4806] = 4806,
  [4807] = 4716,
  [4808] = 877,
  [4809] = 4711,
  [4810] = 4810,
  [4811] = 4811,
  [4812] = 4812,
  [4813] = 4813,
  [4814] = 4711,
  [4815] = 3506,
  [4816] = 765,
  [4817] = 4711,
  [4818] = 4711,
  [4819] = 878,
  [4820] = 879,
  [4821] = 883,
  [4822] = 918,
  [4823] = 900,
  [4824] = 898,
  [4825] = 4825,
  [4826] = 4826,
  [4827] = 4827,
  [4828] = 4716,
  [4829] = 884,
  [4830] = 4830,
  [4831] = 4831,
  [4832] = 917,
  [4833] = 4716,
  [4834] = 952,
  [4835] = 885,
  [4836] = 4711,
  [4837] = 3422,
  [4838] = 4711,
  [4839] = 827,
  [4840] = 886,
  [4841] = 3423,
  [4842] = 4716,
  [4843] = 804,
  [4844] = 890,
  [4845] = 892,
  [4846] = 893,
  [4847] = 896,
  [4848] = 897,
  [4849] = 4711,
  [4850] = 4711,
  [4851] = 790,
  [4852] = 3424,
  [4853] = 916,
  [4854] = 3474,
  [4855] = 4716,
  [4856] = 4716,
  [4857] = 915,
  [4858] = 4716,
  [4859] = 779,
  [4860] = 792,
  [4861] = 2841,
  [4862] = 855,
  [4863] = 4863,
  [4864] = 4864,
  [4865] = 4865,
  [4866] = 4866,
  [4867] = 4867,
  [4868] = 858,
  [4869] = 4869,
  [4870] = 4870,
  [4871] = 787,
  [4872] = 2829,
  [4873] = 827,
  [4874] = 854,
  [4875] = 2833,
  [4876] = 801,
  [4877] = 803,
  [4878] = 4878,
  [4879] = 798,
  [4880] = 4880,
  [4881] = 4881,
  [4882] = 4882,
  [4883] = 3279,
  [4884] = 4825,
  [4885] = 809,
  [4886] = 790,
  [4887] = 4887,
  [4888] = 4888,
  [4889] = 789,
  [4890] = 3774,
  [4891] = 4891,
  [4892] = 4892,
  [4893] = 860,
  [4894] = 4894,
  [4895] = 4895,
  [4896] = 3310,
  [4897] = 769,
  [4898] = 4898,
  [4899] = 771,
  [4900] = 4900,
  [4901] = 785,
  [4902] = 2836,
  [4903] = 4903,
  [4904] = 797,
  [4905] = 791,
  [4906] = 769,
  [4907] = 802,
  [4908] = 4908,
  [4909] = 807,
  [4910] = 4910,
  [4911] = 4911,
  [4912] = 773,
  [4913] = 804,
  [4914] = 3787,
  [4915] = 795,
  [4916] = 4916,
  [4917] = 4917,
  [4918] = 775,
  [4919] = 4919,
  [4920] = 4920,
  [4921] = 4921,
  [4922] = 791,
  [4923] = 785,
  [4924] = 3306,
  [4925] = 781,
  [4926] = 4926,
  [4927] = 781,
  [4928] = 4928,
  [4929] = 780,
  [4930] = 4930,
  [4931] = 790,
  [4932] = 780,
  [4933] = 4933,
  [4934] = 3307,
  [4935] = 4935,
  [4936] = 4920,
  [4937] = 808,
  [4938] = 4938,
  [4939] = 795,
  [4940] = 4935,
  [4941] = 4941,
  [4942] = 4942,
  [4943] = 4942,
  [4944] = 4942,
  [4945] = 773,
  [4946] = 2892,
  [4947] = 4947,
  [4948] = 4942,
  [4949] = 4942,
  [4950] = 4942,
  [4951] = 4951,
  [4952] = 775,
  [4953] = 860,
  [4954] = 4954,
  [4955] = 854,
  [4956] = 855,
  [4957] = 4942,
  [4958] = 4951,
  [4959] = 4942,
  [4960] = 4947,
  [4961] = 4947,
  [4962] = 4942,
  [4963] = 4942,
  [4964] = 4947,
  [4965] = 4951,
  [4966] = 4942,
  [4967] = 4942,
  [4968] = 4947,
  [4969] = 4951,
  [4970] = 4951,
  [4971] = 4942,
  [4972] = 4972,
  [4973] = 4942,
  [4974] = 4942,
  [4975] = 4942,
  [4976] = 4942,
  [4977] = 4942,
  [4978] = 4942,
  [4979] = 4942,
  [4980] = 4947,
  [4981] = 790,
  [4982] = 4951,
  [4983] = 4942,
  [4984] = 4942,
  [4985] = 794,
  [4986] = 4942,
  [4987] = 3306,
  [4988] = 4988,
  [4989] = 4951,
  [4990] = 4942,
  [4991] = 809,
  [4992] = 3307,
  [4993] = 4942,
  [4994] = 4947,
  [4995] = 4942,
  [4996] = 4996,
  [4997] = 4997,
  [4998] = 3310,
  [4999] = 4942,
  [5000] = 4951,
  [5001] = 4947,
  [5002] = 5002,
  [5003] = 772,
  [5004] = 3310,
  [5005] = 5005,
  [5006] = 4942,
  [5007] = 763,
  [5008] = 4942,
  [5009] = 4947,
  [5010] = 4942,
  [5011] = 4951,
  [5012] = 4942,
  [5013] = 4947,
  [5014] = 4951,
  [5015] = 5015,
  [5016] = 764,
  [5017] = 4942,
  [5018] = 3307,
  [5019] = 3306,
  [5020] = 4942,
  [5021] = 765,
  [5022] = 3279,
  [5023] = 4988,
  [5024] = 4947,
  [5025] = 4942,
  [5026] = 4951,
  [5027] = 3362,
  [5028] = 4951,
  [5029] = 5029,
  [5030] = 762,
  [5031] = 808,
  [5032] = 4947,
  [5033] = 3340,
  [5034] = 771,
  [5035] = 4947,
  [5036] = 4951,
  [5037] = 2893,
  [5038] = 787,
  [5039] = 773,
  [5040] = 4951,
  [5041] = 3307,
  [5042] = 4942,
  [5043] = 775,
  [5044] = 779,
  [5045] = 804,
  [5046] = 4954,
  [5047] = 3306,
  [5048] = 4988,
  [5049] = 4951,
  [5050] = 4947,
  [5051] = 4947,
  [5052] = 3361,
  [5053] = 803,
  [5054] = 3359,
  [5055] = 3310,
  [5056] = 3358,
  [5057] = 3346,
  [5058] = 3345,
  [5059] = 3384,
  [5060] = 5060,
  [5061] = 4988,
  [5062] = 3336,
  [5063] = 4951,
  [5064] = 4947,
  [5065] = 790,
  [5066] = 5066,
  [5067] = 4947,
  [5068] = 4954,
  [5069] = 5069,
  [5070] = 4951,
  [5071] = 4951,
  [5072] = 4954,
  [5073] = 4947,
  [5074] = 801,
  [5075] = 3310,
  [5076] = 5076,
  [5077] = 4988,
  [5078] = 3391,
  [5079] = 4947,
  [5080] = 3355,
  [5081] = 4951,
  [5082] = 3390,
  [5083] = 3365,
  [5084] = 3385,
  [5085] = 3365,
  [5086] = 3385,
  [5087] = 3355,
  [5088] = 3347,
  [5089] = 3390,
  [5090] = 4988,
  [5091] = 3391,
  [5092] = 4988,
  [5093] = 4988,
  [5094] = 3321,
  [5095] = 4988,
  [5096] = 4951,
  [5097] = 4988,
  [5098] = 4988,
  [5099] = 4988,
  [5100] = 4988,
  [5101] = 4942,
  [5102] = 4988,
  [5103] = 5103,
  [5104] = 4988,
  [5105] = 4988,
  [5106] = 4988,
  [5107] = 4942,
  [5108] = 5108,
  [5109] = 807,
  [5110] = 5110,
  [5111] = 4988,
  [5112] = 4951,
  [5113] = 4988,
  [5114] = 4942,
  [5115] = 4988,
  [5116] = 4988,
  [5117] = 4954,
  [5118] = 4942,
  [5119] = 4988,
  [5120] = 4988,
  [5121] = 802,
  [5122] = 4942,
  [5123] = 5123,
  [5124] = 4947,
  [5125] = 4988,
  [5126] = 4988,
  [5127] = 4988,
  [5128] = 798,
  [5129] = 4988,
  [5130] = 4988,
  [5131] = 4954,
  [5132] = 5132,
  [5133] = 4988,
  [5134] = 3307,
  [5135] = 4988,
  [5136] = 3306,
  [5137] = 4942,
  [5138] = 4988,
  [5139] = 4988,
  [5140] = 4988,
  [5141] = 4942,
  [5142] = 4988,
  [5143] = 4988,
  [5144] = 4988,
  [5145] = 4988,
  [5146] = 4988,
  [5147] = 4954,
  [5148] = 4942,
  [5149] = 4954,
  [5150] = 789,
  [5151] = 4988,
  [5152] = 5152,
  [5153] = 3362,
  [5154] = 3347,
  [5155] = 4942,
  [5156] = 3406,
  [5157] = 4954,
  [5158] = 4988,
  [5159] = 3321,
  [5160] = 792,
  [5161] = 797,
  [5162] = 4947,
  [5163] = 3340,
  [5164] = 4954,
  [5165] = 4988,
  [5166] = 4951,
  [5167] = 4988,
  [5168] = 5168,
  [5169] = 4988,
  [5170] = 5170,
  [5171] = 4942,
  [5172] = 5172,
  [5173] = 4947,
  [5174] = 5174,
  [5175] = 5175,
  [5176] = 5176,
  [5177] = 5177,
  [5178] = 5178,
  [5179] = 5179,
  [5180] = 808,
  [5181] = 5181,
  [5182] = 787,
  [5183] = 3321,
  [5184] = 5184,
  [5185] = 5175,
  [5186] = 5186,
  [5187] = 3507,
  [5188] = 5175,
  [5189] = 5189,
  [5190] = 787,
  [5191] = 5184,
  [5192] = 5186,
  [5193] = 5193,
  [5194] = 5194,
  [5195] = 5195,
  [5196] = 5177,
  [5197] = 5193,
  [5198] = 5198,
  [5199] = 808,
  [5200] = 5200,
  [5201] = 5201,
  [5202] = 5201,
  [5203] = 945,
  [5204] = 5175,
  [5205] = 5175,
  [5206] = 5206,
  [5207] = 3455,
  [5208] = 3440,
  [5209] = 5194,
  [5210] = 5210,
  [5211] = 5193,
  [5212] = 5177,
  [5213] = 3340,
  [5214] = 5214,
  [5215] = 3428,
  [5216] = 3426,
  [5217] = 5214,
  [5218] = 5194,
  [5219] = 5201,
  [5220] = 3347,
  [5221] = 3355,
  [5222] = 5214,
  [5223] = 792,
  [5224] = 5189,
  [5225] = 797,
  [5226] = 5194,
  [5227] = 5181,
  [5228] = 5175,
  [5229] = 798,
  [5230] = 3306,
  [5231] = 802,
  [5232] = 3307,
  [5233] = 5175,
  [5234] = 5181,
  [5235] = 5193,
  [5236] = 3362,
  [5237] = 5177,
  [5238] = 807,
  [5239] = 5239,
  [5240] = 5214,
  [5241] = 3506,
  [5242] = 5175,
  [5243] = 5201,
  [5244] = 794,
  [5245] = 5194,
  [5246] = 795,
  [5247] = 5175,
  [5248] = 5248,
  [5249] = 5210,
  [5250] = 5189,
  [5251] = 5184,
  [5252] = 791,
  [5253] = 5189,
  [5254] = 5201,
  [5255] = 5175,
  [5256] = 3391,
  [5257] = 3390,
  [5258] = 3385,
  [5259] = 5259,
  [5260] = 5175,
  [5261] = 5189,
  [5262] = 5193,
  [5263] = 5263,
  [5264] = 5194,
  [5265] = 5201,
  [5266] = 5214,
  [5267] = 5177,
  [5268] = 785,
  [5269] = 3365,
  [5270] = 916,
  [5271] = 918,
  [5272] = 917,
  [5273] = 869,
  [5274] = 5177,
  [5275] = 5275,
  [5276] = 3417,
  [5277] = 5181,
  [5278] = 915,
  [5279] = 3886,
  [5280] = 5175,
  [5281] = 5184,
  [5282] = 5177,
  [5283] = 5177,
  [5284] = 900,
  [5285] = 3418,
  [5286] = 5175,
  [5287] = 5184,
  [5288] = 919,
  [5289] = 897,
  [5290] = 896,
  [5291] = 5175,
  [5292] = 893,
  [5293] = 3422,
  [5294] = 892,
  [5295] = 890,
  [5296] = 887,
  [5297] = 5175,
  [5298] = 886,
  [5299] = 5175,
  [5300] = 5175,
  [5301] = 5175,
  [5302] = 5177,
  [5303] = 3347,
  [5304] = 5175,
  [5305] = 3423,
  [5306] = 3355,
  [5307] = 769,
  [5308] = 3424,
  [5309] = 5309,
  [5310] = 5175,
  [5311] = 5177,
  [5312] = 5184,
  [5313] = 5175,
  [5314] = 5210,
  [5315] = 3362,
  [5316] = 885,
  [5317] = 5175,
  [5318] = 5060,
  [5319] = 5210,
  [5320] = 5210,
  [5321] = 5181,
  [5322] = 5322,
  [5323] = 5177,
  [5324] = 5324,
  [5325] = 5210,
  [5326] = 3361,
  [5327] = 5175,
  [5328] = 5328,
  [5329] = 3436,
  [5330] = 3359,
  [5331] = 5331,
  [5332] = 884,
  [5333] = 5181,
  [5334] = 3358,
  [5335] = 3346,
  [5336] = 3345,
  [5337] = 3384,
  [5338] = 5175,
  [5339] = 5339,
  [5340] = 5340,
  [5341] = 883,
  [5342] = 3336,
  [5343] = 879,
  [5344] = 878,
  [5345] = 5175,
  [5346] = 5189,
  [5347] = 877,
  [5348] = 5175,
  [5349] = 875,
  [5350] = 874,
  [5351] = 781,
  [5352] = 4045,
  [5353] = 5175,
  [5354] = 789,
  [5355] = 809,
  [5356] = 5189,
  [5357] = 3310,
  [5358] = 780,
  [5359] = 5184,
  [5360] = 5360,
  [5361] = 5175,
  [5362] = 5210,
  [5363] = 3841,
  [5364] = 3441,
  [5365] = 5175,
  [5366] = 3450,
  [5367] = 5194,
  [5368] = 5201,
  [5369] = 5214,
  [5370] = 3451,
  [5371] = 3438,
  [5372] = 5372,
  [5373] = 3454,
  [5374] = 5198,
  [5375] = 5195,
  [5376] = 5175,
  [5377] = 870,
  [5378] = 5175,
  [5379] = 5181,
  [5380] = 3365,
  [5381] = 5175,
  [5382] = 5175,
  [5383] = 3385,
  [5384] = 5175,
  [5385] = 5189,
  [5386] = 3390,
  [5387] = 3391,
  [5388] = 5214,
  [5389] = 868,
  [5390] = 5175,
  [5391] = 5175,
  [5392] = 5194,
  [5393] = 952,
  [5394] = 3340,
  [5395] = 5201,
  [5396] = 865,
  [5397] = 5184,
  [5398] = 898,
  [5399] = 5175,
  [5400] = 803,
  [5401] = 801,
  [5402] = 5175,
  [5403] = 5210,
  [5404] = 5177,
  [5405] = 5405,
  [5406] = 5181,
  [5407] = 5175,
  [5408] = 903,
  [5409] = 5409,
  [5410] = 5175,
  [5411] = 3321,
  [5412] = 5214,
  [5413] = 889,
  [5414] = 3474,
  [5415] = 3406,
  [5416] = 5175,
  [5417] = 5175,
  [5418] = 5418,
  [5419] = 5177,
  [5420] = 5175,
  [5421] = 5421,
  [5422] = 3426,
  [5423] = 869,
  [5424] = 5424,
  [5425] = 5424,
  [5426] = 5424,
  [5427] = 779,
  [5428] = 5424,
  [5429] = 3507,
  [5430] = 5430,
  [5431] = 3506,
  [5432] = 5424,
  [5433] = 4169,
  [5434] = 3417,
  [5435] = 3347,
  [5436] = 3418,
  [5437] = 3355,
  [5438] = 5424,
  [5439] = 3321,
  [5440] = 5424,
  [5441] = 5424,
  [5442] = 3340,
  [5443] = 5424,
  [5444] = 5424,
  [5445] = 771,
  [5446] = 3441,
  [5447] = 3450,
  [5448] = 3455,
  [5449] = 5424,
  [5450] = 3451,
  [5451] = 5424,
  [5452] = 3454,
  [5453] = 5453,
  [5454] = 790,
  [5455] = 3391,
  [5456] = 3385,
  [5457] = 3365,
  [5458] = 5424,
  [5459] = 5459,
  [5460] = 3474,
  [5461] = 3362,
  [5462] = 794,
  [5463] = 3390,
  [5464] = 5424,
  [5465] = 3436,
  [5466] = 804,
  [5467] = 3440,
  [5468] = 3428,
  [5469] = 3424,
  [5470] = 5470,
  [5471] = 3438,
  [5472] = 3423,
  [5473] = 945,
  [5474] = 865,
  [5475] = 868,
  [5476] = 3422,
  [5477] = 870,
  [5478] = 874,
  [5479] = 5479,
  [5480] = 875,
  [5481] = 877,
  [5482] = 5482,
  [5483] = 878,
  [5484] = 879,
  [5485] = 883,
  [5486] = 884,
  [5487] = 885,
  [5488] = 886,
  [5489] = 887,
  [5490] = 890,
  [5491] = 892,
  [5492] = 893,
  [5493] = 896,
  [5494] = 897,
  [5495] = 898,
  [5496] = 900,
  [5497] = 915,
  [5498] = 916,
  [5499] = 917,
  [5500] = 918,
  [5501] = 919,
  [5502] = 5502,
  [5503] = 952,
  [5504] = 903,
  [5505] = 5200,
  [5506] = 5424,
  [5507] = 889,
  [5508] = 5459,
  [5509] = 794,
  [5510] = 5195,
  [5511] = 5198,
  [5512] = 803,
  [5513] = 5513,
  [5514] = 5514,
  [5515] = 5513,
  [5516] = 5516,
  [5517] = 5517,
  [5518] = 5514,
  [5519] = 5517,
  [5520] = 807,
  [5521] = 801,
  [5522] = 5522,
  [5523] = 5513,
  [5524] = 5517,
  [5525] = 5517,
  [5526] = 5517,
  [5527] = 5513,
  [5528] = 5528,
  [5529] = 5513,
  [5530] = 5195,
  [5531] = 5517,
  [5532] = 5532,
  [5533] = 795,
  [5534] = 791,
  [5535] = 5514,
  [5536] = 785,
  [5537] = 5513,
  [5538] = 5538,
  [5539] = 5514,
  [5540] = 5514,
  [5541] = 5514,
  [5542] = 5514,
  [5543] = 5517,
  [5544] = 5517,
  [5545] = 798,
  [5546] = 5513,
  [5547] = 5513,
  [5548] = 5548,
  [5549] = 5513,
  [5550] = 5513,
  [5551] = 5517,
  [5552] = 5517,
  [5553] = 5513,
  [5554] = 5554,
  [5555] = 5514,
  [5556] = 5514,
  [5557] = 792,
  [5558] = 797,
  [5559] = 5517,
  [5560] = 5514,
  [5561] = 5514,
  [5562] = 5517,
  [5563] = 5517,
  [5564] = 5564,
  [5565] = 809,
  [5566] = 789,
  [5567] = 5514,
  [5568] = 5568,
  [5569] = 802,
  [5570] = 3774,
  [5571] = 5571,
  [5572] = 5195,
  [5573] = 3787,
  [5574] = 5564,
  [5575] = 5568,
  [5576] = 5576,
  [5577] = 5577,
  [5578] = 5578,
  [5579] = 5577,
  [5580] = 5580,
  [5581] = 5577,
  [5582] = 5578,
  [5583] = 5577,
  [5584] = 5584,
  [5585] = 5578,
  [5586] = 5584,
  [5587] = 5577,
  [5588] = 5580,
  [5589] = 5578,
  [5590] = 5580,
  [5591] = 5578,
  [5592] = 5592,
  [5593] = 5580,
  [5594] = 5577,
  [5595] = 5578,
  [5596] = 5578,
  [5597] = 5577,
  [5598] = 5578,
  [5599] = 5599,
  [5600] = 5577,
  [5601] = 5580,
  [5602] = 5577,
  [5603] = 5578,
  [5604] = 5577,
  [5605] = 5577,
  [5606] = 5578,
  [5607] = 5584,
  [5608] = 5584,
  [5609] = 5577,
  [5610] = 5578,
  [5611] = 5584,
  [5612] = 5577,
  [5613] = 5613,
  [5614] = 5577,
  [5615] = 5580,
  [5616] = 5578,
  [5617] = 5580,
  [5618] = 5577,
  [5619] = 5577,
  [5620] = 5577,
  [5621] = 5578,
  [5622] = 5578,
  [5623] = 5578,
  [5624] = 5578,
  [5625] = 5578,
  [5626] = 5584,
  [5627] = 5577,
  [5628] = 5577,
  [5629] = 5578,
  [5630] = 5630,
  [5631] = 5578,
  [5632] = 5578,
  [5633] = 5578,
  [5634] = 5577,
  [5635] = 5584,
  [5636] = 5577,
  [5637] = 5577,
  [5638] = 5578,
  [5639] = 5584,
  [5640] = 5578,
  [5641] = 5577,
  [5642] = 5578,
  [5643] = 5577,
  [5644] = 5577,
  [5645] = 5645,
  [5646] = 5578,
  [5647] = 5577,
  [5648] = 5578,
  [5649] = 5580,
  [5650] = 5577,
  [5651] = 5580,
  [5652] = 5580,
  [5653] = 5578,
  [5654] = 5654,
  [5655] = 5578,
  [5656] = 5578,
  [5657] = 5578,
  [5658] = 5580,
  [5659] = 5577,
  [5660] = 5578,
  [5661] = 5577,
  [5662] = 5577,
  [5663] = 5584,
  [5664] = 5578,
  [5665] = 5577,
  [5666] = 5577,
  [5667] = 5577,
  [5668] = 5577,
  [5669] = 5578,
  [5670] = 5577,
  [5671] = 5580,
  [5672] = 5580,
  [5673] = 5580,
  [5674] = 5578,
  [5675] = 5578,
  [5676] = 5577,
  [5677] = 5577,
  [5678] = 5578,
  [5679] = 5577,
  [5680] = 5578,
  [5681] = 5577,
  [5682] = 5578,
  [5683] = 5578,
  [5684] = 5577,
  [5685] = 5580,
  [5686] = 5580,
  [5687] = 5578,
  [5688] = 5577,
  [5689] = 5577,
  [5690] = 5584,
  [5691] = 5691,
  [5692] = 5577,
  [5693] = 5584,
  [5694] = 5584,
  [5695] = 5580,
  [5696] = 5584,
  [5697] = 5578,
  [5698] = 5578,
  [5699] = 5578,
  [5700] = 5577,
  [5701] = 5577,
  [5702] = 5702,
  [5703] = 5578,
  [5704] = 5578,
  [5705] = 3841,
  [5706] = 830,
  [5707] = 5707,
  [5708] = 5707,
  [5709] = 5709,
  [5710] = 4045,
  [5711] = 5707,
  [5712] = 5707,
  [5713] = 5707,
  [5714] = 5714,
  [5715] = 5715,
  [5716] = 5716,
  [5717] = 5707,
  [5718] = 5718,
  [5719] = 5719,
  [5720] = 821,
  [5721] = 5721,
  [5722] = 832,
  [5723] = 5723,
  [5724] = 823,
  [5725] = 5725,
  [5726] = 5707,
  [5727] = 3886,
  [5728] = 5728,
  [5729] = 5729,
  [5730] = 820,
  [5731] = 3279,
  [5732] = 5732,
  [5733] = 5733,
  [5734] = 826,
  [5735] = 5707,
  [5736] = 5736,
  [5737] = 5737,
  [5738] = 5738,
  [5739] = 820,
  [5740] = 5740,
  [5741] = 5741,
  [5742] = 820,
  [5743] = 5743,
  [5744] = 5744,
  [5745] = 5745,
  [5746] = 2796,
  [5747] = 5747,
  [5748] = 2825,
  [5749] = 5749,
  [5750] = 2827,
  [5751] = 5751,
  [5752] = 5752,
  [5753] = 5749,
  [5754] = 5754,
  [5755] = 5755,
  [5756] = 5737,
  [5757] = 5757,
  [5758] = 3765,
  [5759] = 5759,
  [5760] = 5760,
  [5761] = 5749,
  [5762] = 5762,
  [5763] = 5763,
  [5764] = 5743,
  [5765] = 5745,
  [5766] = 5755,
  [5767] = 5749,
  [5768] = 5768,
  [5769] = 5769,
  [5770] = 5754,
  [5771] = 5737,
  [5772] = 5752,
  [5773] = 5773,
  [5774] = 5749,
  [5775] = 5749,
  [5776] = 5741,
  [5777] = 5747,
  [5778] = 5749,
  [5779] = 5749,
  [5780] = 5780,
  [5781] = 5749,
  [5782] = 5738,
  [5783] = 5749,
  [5784] = 5769,
  [5785] = 5785,
  [5786] = 5737,
  [5787] = 5749,
  [5788] = 5788,
  [5789] = 5788,
  [5790] = 5759,
  [5791] = 5737,
  [5792] = 5754,
  [5793] = 5749,
  [5794] = 5751,
  [5795] = 5752,
  [5796] = 5745,
  [5797] = 3310,
  [5798] = 5798,
  [5799] = 5744,
  [5800] = 5800,
  [5801] = 5759,
  [5802] = 5802,
  [5803] = 5737,
  [5804] = 5749,
  [5805] = 5745,
  [5806] = 5806,
  [5807] = 5807,
  [5808] = 5749,
  [5809] = 5738,
  [5810] = 5759,
  [5811] = 5811,
  [5812] = 5749,
  [5813] = 5749,
  [5814] = 5814,
  [5815] = 5815,
  [5816] = 5798,
  [5817] = 5780,
  [5818] = 5798,
  [5819] = 5737,
  [5820] = 5744,
  [5821] = 5759,
  [5822] = 838,
  [5823] = 5759,
  [5824] = 5749,
  [5825] = 5745,
  [5826] = 5826,
  [5827] = 5738,
  [5828] = 857,
  [5829] = 5769,
  [5830] = 5754,
  [5831] = 5752,
  [5832] = 5832,
  [5833] = 5737,
  [5834] = 5773,
  [5835] = 5835,
  [5836] = 5749,
  [5837] = 5741,
  [5838] = 5788,
  [5839] = 5747,
  [5840] = 5751,
  [5841] = 5749,
  [5842] = 5749,
  [5843] = 5749,
  [5844] = 5751,
  [5845] = 5747,
  [5846] = 5741,
  [5847] = 5759,
  [5848] = 5788,
  [5849] = 5745,
  [5850] = 5737,
  [5851] = 5737,
  [5852] = 5749,
  [5853] = 5853,
  [5854] = 5759,
  [5855] = 5752,
  [5856] = 5798,
  [5857] = 5744,
  [5858] = 5754,
  [5859] = 5773,
  [5860] = 5738,
  [5861] = 5759,
  [5862] = 3307,
  [5863] = 5749,
  [5864] = 5864,
  [5865] = 5865,
  [5866] = 5866,
  [5867] = 5741,
  [5868] = 5747,
  [5869] = 5737,
  [5870] = 5749,
  [5871] = 5745,
  [5872] = 5872,
  [5873] = 836,
  [5874] = 5749,
  [5875] = 5749,
  [5876] = 5747,
  [5877] = 5741,
  [5878] = 5754,
  [5879] = 5744,
  [5880] = 5738,
  [5881] = 5737,
  [5882] = 5752,
  [5883] = 5749,
  [5884] = 5741,
  [5885] = 5759,
  [5886] = 5747,
  [5887] = 5749,
  [5888] = 5749,
  [5889] = 5889,
  [5890] = 5751,
  [5891] = 5891,
  [5892] = 5749,
  [5893] = 5788,
  [5894] = 5749,
  [5895] = 5895,
  [5896] = 5763,
  [5897] = 5759,
  [5898] = 5762,
  [5899] = 5745,
  [5900] = 5900,
  [5901] = 5737,
  [5902] = 5902,
  [5903] = 5749,
  [5904] = 5738,
  [5905] = 5749,
  [5906] = 5744,
  [5907] = 5788,
  [5908] = 5759,
  [5909] = 5760,
  [5910] = 5737,
  [5911] = 5749,
  [5912] = 5745,
  [5913] = 5913,
  [5914] = 5759,
  [5915] = 5802,
  [5916] = 5916,
  [5917] = 5917,
  [5918] = 5738,
  [5919] = 5737,
  [5920] = 5749,
  [5921] = 5921,
  [5922] = 5922,
  [5923] = 5749,
  [5924] = 5769,
  [5925] = 5754,
  [5926] = 5759,
  [5927] = 5752,
  [5928] = 5773,
  [5929] = 5929,
  [5930] = 5738,
  [5931] = 5741,
  [5932] = 5747,
  [5933] = 5749,
  [5934] = 5749,
  [5935] = 5935,
  [5936] = 5798,
  [5937] = 5751,
  [5938] = 5788,
  [5939] = 5737,
  [5940] = 5749,
  [5941] = 5737,
  [5942] = 5942,
  [5943] = 5788,
  [5944] = 5738,
  [5945] = 5751,
  [5946] = 5749,
  [5947] = 5798,
  [5948] = 5744,
  [5949] = 5759,
  [5950] = 5749,
  [5951] = 5747,
  [5952] = 5759,
  [5953] = 5741,
  [5954] = 5741,
  [5955] = 5747,
  [5956] = 5759,
  [5957] = 5752,
  [5958] = 5958,
  [5959] = 5749,
  [5960] = 5749,
  [5961] = 5749,
  [5962] = 5754,
  [5963] = 5963,
  [5964] = 5737,
  [5965] = 5965,
  [5966] = 5738,
  [5967] = 5967,
  [5968] = 5744,
  [5969] = 5969,
  [5970] = 835,
  [5971] = 5749,
  [5972] = 5972,
  [5973] = 5973,
  [5974] = 5759,
  [5975] = 5737,
  [5976] = 5976,
  [5977] = 5749,
  [5978] = 5798,
  [5979] = 3306,
  [5980] = 5749,
  [5981] = 5747,
  [5982] = 5982,
  [5983] = 5741,
  [5984] = 5749,
  [5985] = 5749,
  [5986] = 5986,
  [5987] = 5759,
  [5988] = 5744,
  [5989] = 5798,
  [5990] = 5990,
  [5991] = 5754,
  [5992] = 5749,
  [5993] = 5752,
  [5994] = 5994,
  [5995] = 5741,
  [5996] = 5747,
  [5997] = 5749,
  [5998] = 5751,
  [5999] = 5738,
  [6000] = 5788,
  [6001] = 6001,
  [6002] = 6001,
  [6003] = 6003,
  [6004] = 6004,
  [6005] = 6005,
  [6006] = 6006,
  [6007] = 6004,
  [6008] = 6008,
  [6009] = 6009,
  [6010] = 6010,
  [6011] = 6008,
  [6012] = 6012,
  [6013] = 6013,
  [6014] = 6014,
  [6015] = 6015,
  [6016] = 6016,
  [6017] = 6017,
  [6018] = 6006,
  [6019] = 6009,
  [6020] = 6015,
  [6021] = 6021,
  [6022] = 6022,
  [6023] = 6001,
  [6024] = 6024,
  [6025] = 6025,
  [6026] = 6001,
  [6027] = 6027,
  [6028] = 6024,
  [6029] = 6029,
  [6030] = 6030,
  [6031] = 6001,
  [6032] = 6032,
  [6033] = 6024,
  [6034] = 6034,
  [6035] = 6001,
  [6036] = 6024,
  [6037] = 6004,
  [6038] = 6032,
  [6039] = 6001,
  [6040] = 6024,
  [6041] = 6003,
  [6042] = 6027,
  [6043] = 6043,
  [6044] = 6001,
  [6045] = 6024,
  [6046] = 6010,
  [6047] = 6009,
  [6048] = 6048,
  [6049] = 6049,
  [6050] = 6050,
  [6051] = 6015,
  [6052] = 6022,
  [6053] = 6001,
  [6054] = 6054,
  [6055] = 6024,
  [6056] = 6054,
  [6057] = 6021,
  [6058] = 6017,
  [6059] = 6059,
  [6060] = 6015,
  [6061] = 6016,
  [6062] = 6010,
  [6063] = 6049,
  [6064] = 6064,
  [6065] = 6065,
  [6066] = 6065,
  [6067] = 6006,
  [6068] = 6027,
  [6069] = 6003,
  [6070] = 6070,
  [6071] = 6032,
  [6072] = 6072,
  [6073] = 6073,
  [6074] = 6024,
  [6075] = 6014,
  [6076] = 6003,
  [6077] = 6077,
  [6078] = 6004,
  [6079] = 6079,
  [6080] = 6008,
  [6081] = 6081,
  [6082] = 6022,
  [6083] = 6083,
  [6084] = 6084,
  [6085] = 6085,
  [6086] = 6021,
  [6087] = 6087,
  [6088] = 6006,
  [6089] = 6017,
  [6090] = 6025,
  [6091] = 6049,
  [6092] = 6024,
  [6093] = 6064,
  [6094] = 6016,
  [6095] = 6016,
  [6096] = 6025,
  [6097] = 6001,
  [6098] = 6012,
  [6099] = 6017,
  [6100] = 6021,
  [6101] = 6008,
  [6102] = 6102,
  [6103] = 6004,
  [6104] = 6003,
  [6105] = 6070,
  [6106] = 6073,
  [6107] = 6107,
  [6108] = 6024,
  [6109] = 6014,
  [6110] = 6022,
  [6111] = 6081,
  [6112] = 6112,
  [6113] = 6084,
  [6114] = 6006,
  [6115] = 6115,
  [6116] = 6049,
  [6117] = 6010,
  [6118] = 6118,
  [6119] = 6015,
  [6120] = 6064,
  [6121] = 6001,
  [6122] = 6006,
  [6123] = 6009,
  [6124] = 6070,
  [6125] = 6073,
  [6126] = 6024,
  [6127] = 6014,
  [6128] = 6085,
  [6129] = 6081,
  [6130] = 6025,
  [6131] = 6084,
  [6132] = 6032,
  [6133] = 6027,
  [6134] = 6134,
  [6135] = 6027,
  [6136] = 6085,
  [6137] = 6049,
  [6138] = 6032,
  [6139] = 6012,
  [6140] = 6064,
  [6141] = 6016,
  [6142] = 6001,
  [6143] = 6143,
  [6144] = 6144,
  [6145] = 6017,
  [6146] = 6070,
  [6147] = 6073,
  [6148] = 4097,
  [6149] = 6149,
  [6150] = 6150,
  [6151] = 6024,
  [6152] = 6014,
  [6153] = 6081,
  [6154] = 6154,
  [6155] = 6155,
  [6156] = 6085,
  [6157] = 6021,
  [6158] = 6008,
  [6159] = 6022,
  [6160] = 6084,
  [6161] = 6004,
  [6162] = 6022,
  [6163] = 6021,
  [6164] = 6009,
  [6165] = 6165,
  [6166] = 6017,
  [6167] = 6016,
  [6168] = 6049,
  [6169] = 6003,
  [6170] = 6017,
  [6171] = 6016,
  [6172] = 6064,
  [6173] = 6073,
  [6174] = 6081,
  [6175] = 6010,
  [6176] = 6001,
  [6177] = 6021,
  [6178] = 6070,
  [6179] = 6006,
  [6180] = 6015,
  [6181] = 6070,
  [6182] = 6073,
  [6183] = 6024,
  [6184] = 6014,
  [6185] = 6185,
  [6186] = 6010,
  [6187] = 6022,
  [6188] = 6188,
  [6189] = 6084,
  [6190] = 6085,
  [6191] = 6054,
  [6192] = 6009,
  [6193] = 6081,
  [6194] = 6032,
  [6195] = 6003,
  [6196] = 6027,
  [6197] = 6027,
  [6198] = 6049,
  [6199] = 6064,
  [6200] = 6025,
  [6201] = 6032,
  [6202] = 6085,
  [6203] = 6203,
  [6204] = 6070,
  [6205] = 6008,
  [6206] = 6081,
  [6207] = 6022,
  [6208] = 6025,
  [6209] = 6073,
  [6210] = 6024,
  [6211] = 6211,
  [6212] = 6021,
  [6213] = 6014,
  [6214] = 6085,
  [6215] = 6009,
  [6216] = 6216,
  [6217] = 6017,
  [6218] = 6016,
  [6219] = 6081,
  [6220] = 6025,
  [6221] = 6015,
  [6222] = 6010,
  [6223] = 6008,
  [6224] = 6004,
  [6225] = 6084,
  [6226] = 6081,
  [6227] = 6003,
  [6228] = 6012,
  [6229] = 6004,
  [6230] = 6003,
  [6231] = 6008,
  [6232] = 6232,
  [6233] = 6233,
  [6234] = 6049,
  [6235] = 6235,
  [6236] = 6064,
  [6237] = 6237,
  [6238] = 6001,
  [6239] = 6010,
  [6240] = 6015,
  [6241] = 6021,
  [6242] = 6242,
  [6243] = 6085,
  [6244] = 6084,
  [6245] = 6009,
  [6246] = 6070,
  [6247] = 6073,
  [6248] = 6024,
  [6249] = 6015,
  [6250] = 6014,
  [6251] = 6251,
  [6252] = 6025,
  [6253] = 6001,
  [6254] = 6081,
  [6255] = 6027,
  [6256] = 6006,
  [6257] = 6006,
  [6258] = 6084,
  [6259] = 6032,
  [6260] = 6085,
  [6261] = 6081,
  [6262] = 6262,
  [6263] = 6025,
  [6264] = 6085,
  [6265] = 6081,
  [6266] = 6016,
  [6267] = 6017,
  [6268] = 6049,
  [6269] = 6064,
  [6270] = 2829,
  [6271] = 6001,
  [6272] = 6070,
  [6273] = 6073,
  [6274] = 6024,
  [6275] = 6275,
  [6276] = 6022,
  [6277] = 6025,
  [6278] = 6014,
  [6279] = 6279,
  [6280] = 6085,
  [6281] = 6015,
  [6282] = 6008,
  [6283] = 6022,
  [6284] = 6284,
  [6285] = 6065,
  [6286] = 6021,
  [6287] = 6017,
  [6288] = 6016,
  [6289] = 6004,
  [6290] = 6084,
  [6291] = 6003,
  [6292] = 6010,
  [6293] = 6015,
  [6294] = 6054,
  [6295] = 6295,
  [6296] = 6006,
  [6297] = 6297,
  [6298] = 6009,
  [6299] = 6027,
  [6300] = 6049,
  [6301] = 6032,
  [6302] = 6262,
  [6303] = 6006,
  [6304] = 6064,
  [6305] = 6022,
  [6306] = 6306,
  [6307] = 6032,
  [6308] = 6027,
  [6309] = 6001,
  [6310] = 6021,
  [6311] = 6070,
  [6312] = 6010,
  [6313] = 6073,
  [6314] = 6024,
  [6315] = 6014,
  [6316] = 6064,
  [6317] = 6144,
  [6318] = 6016,
  [6319] = 6017,
  [6320] = 6015,
  [6321] = 6065,
  [6322] = 6027,
  [6323] = 6017,
  [6324] = 6016,
  [6325] = 6004,
  [6326] = 6021,
  [6327] = 6084,
  [6328] = 6154,
  [6329] = 6022,
  [6330] = 6012,
  [6331] = 6015,
  [6332] = 6010,
  [6333] = 6015,
  [6334] = 6049,
  [6335] = 6049,
  [6336] = 6064,
  [6337] = 6032,
  [6338] = 6006,
  [6339] = 6001,
  [6340] = 6340,
  [6341] = 6032,
  [6342] = 6022,
  [6343] = 6070,
  [6344] = 6073,
  [6345] = 6024,
  [6346] = 6003,
  [6347] = 6027,
  [6348] = 6014,
  [6349] = 6349,
  [6350] = 3769,
  [6351] = 6009,
  [6352] = 6004,
  [6353] = 6085,
  [6354] = 6008,
  [6355] = 6065,
  [6356] = 6356,
  [6357] = 6357,
  [6358] = 6008,
  [6359] = 6025,
  [6360] = 6084,
  [6361] = 6009,
  [6362] = 6015,
  [6363] = 6009,
  [6364] = 6364,
  [6365] = 6015,
  [6366] = 6366,
  [6367] = 6010,
  [6368] = 6022,
  [6369] = 6003,
  [6370] = 6004,
  [6371] = 6008,
  [6372] = 6049,
  [6373] = 6373,
  [6374] = 6064,
  [6375] = 6297,
  [6376] = 6001,
  [6377] = 6377,
  [6378] = 6022,
  [6379] = 6379,
  [6380] = 6380,
  [6381] = 3772,
  [6382] = 6070,
  [6383] = 6003,
  [6384] = 6015,
  [6385] = 6073,
  [6386] = 6024,
  [6387] = 820,
  [6388] = 6014,
  [6389] = 6084,
  [6390] = 6027,
  [6391] = 6364,
  [6392] = 2830,
  [6393] = 6393,
  [6394] = 6025,
  [6395] = 2833,
  [6396] = 6054,
  [6397] = 6022,
  [6398] = 6398,
  [6399] = 6399,
  [6400] = 6400,
  [6401] = 6401,
  [6402] = 6402,
  [6403] = 6403,
  [6404] = 6404,
  [6405] = 6405,
  [6406] = 6406,
  [6407] = 6407,
  [6408] = 6408,
  [6409] = 6409,
  [6410] = 6410,
  [6411] = 6411,
  [6412] = 6412,
  [6413] = 6413,
  [6414] = 6414,
  [6415] = 6405,
  [6416] = 6416,
  [6417] = 6417,
  [6418] = 6405,
  [6419] = 6419,
  [6420] = 6405,
  [6421] = 6421,
  [6422] = 6405,
  [6423] = 6405,
  [6424] = 6424,
  [6425] = 6405,
  [6426] = 6401,
  [6427] = 6405,
  [6428] = 6428,
  [6429] = 6429,
  [6430] = 6405,
  [6431] = 6431,
  [6432] = 6432,
  [6433] = 6433,
  [6434] = 6405,
  [6435] = 6435,
  [6436] = 6436,
  [6437] = 6437,
  [6438] = 6438,
  [6439] = 6439,
  [6440] = 6405,
  [6441] = 6441,
  [6442] = 6405,
  [6443] = 6405,
  [6444] = 6405,
  [6445] = 6433,
  [6446] = 6405,
  [6447] = 6447,
  [6448] = 6405,
  [6449] = 6413,
  [6450] = 6412,
  [6451] = 6409,
  [6452] = 6417,
  [6453] = 6405,
  [6454] = 6417,
  [6455] = 6455,
  [6456] = 6406,
  [6457] = 6457,
  [6458] = 6400,
  [6459] = 6405,
  [6460] = 6417,
  [6461] = 6461,
  [6462] = 6402,
  [6463] = 6405,
  [6464] = 6417,
  [6465] = 6403,
  [6466] = 6404,
  [6467] = 6467,
  [6468] = 6405,
  [6469] = 6417,
  [6470] = 6470,
  [6471] = 6410,
  [6472] = 6411,
  [6473] = 6405,
  [6474] = 6417,
  [6475] = 6475,
  [6476] = 6455,
  [6477] = 6447,
  [6478] = 6478,
  [6479] = 6405,
  [6480] = 6480,
  [6481] = 6421,
  [6482] = 6405,
  [6483] = 6455,
  [6484] = 6424,
  [6485] = 6417,
  [6486] = 6401,
  [6487] = 6455,
  [6488] = 6488,
  [6489] = 6429,
  [6490] = 6490,
  [6491] = 6491,
  [6492] = 6432,
  [6493] = 6493,
  [6494] = 6494,
  [6495] = 6495,
  [6496] = 6496,
  [6497] = 6399,
  [6498] = 6478,
  [6499] = 6478,
  [6500] = 6500,
  [6501] = 6501,
  [6502] = 6457,
  [6503] = 6405,
  [6504] = 6413,
  [6505] = 6412,
  [6506] = 6409,
  [6507] = 6417,
  [6508] = 6455,
  [6509] = 6424,
  [6510] = 6510,
  [6511] = 6406,
  [6512] = 6478,
  [6513] = 6400,
  [6514] = 6514,
  [6515] = 6416,
  [6516] = 6516,
  [6517] = 6402,
  [6518] = 6518,
  [6519] = 6405,
  [6520] = 6403,
  [6521] = 6404,
  [6522] = 6494,
  [6523] = 6417,
  [6524] = 6514,
  [6525] = 6455,
  [6526] = 6410,
  [6527] = 6411,
  [6528] = 6528,
  [6529] = 6478,
  [6530] = 6514,
  [6531] = 6421,
  [6532] = 6480,
  [6533] = 6478,
  [6534] = 6534,
  [6535] = 6439,
  [6536] = 6421,
  [6537] = 6405,
  [6538] = 6417,
  [6539] = 6424,
  [6540] = 6416,
  [6541] = 6401,
  [6542] = 6490,
  [6543] = 6543,
  [6544] = 6429,
  [6545] = 6432,
  [6546] = 6455,
  [6547] = 6547,
  [6548] = 6547,
  [6549] = 6416,
  [6550] = 6478,
  [6551] = 6534,
  [6552] = 6514,
  [6553] = 6416,
  [6554] = 6413,
  [6555] = 6412,
  [6556] = 6409,
  [6557] = 6514,
  [6558] = 6405,
  [6559] = 6528,
  [6560] = 6518,
  [6561] = 6406,
  [6562] = 6516,
  [6563] = 6400,
  [6564] = 6510,
  [6565] = 6417,
  [6566] = 6501,
  [6567] = 6402,
  [6568] = 6455,
  [6569] = 6478,
  [6570] = 6403,
  [6571] = 6404,
  [6572] = 6514,
  [6573] = 6416,
  [6574] = 6398,
  [6575] = 6399,
  [6576] = 6410,
  [6577] = 6411,
  [6578] = 6405,
  [6579] = 6417,
  [6580] = 6488,
  [6581] = 6581,
  [6582] = 6398,
  [6583] = 6496,
  [6584] = 6495,
  [6585] = 6585,
  [6586] = 6421,
  [6587] = 6494,
  [6588] = 6470,
  [6589] = 6424,
  [6590] = 6493,
  [6591] = 6401,
  [6592] = 6592,
  [6593] = 6467,
  [6594] = 6429,
  [6595] = 6432,
  [6596] = 6455,
  [6597] = 6491,
  [6598] = 6478,
  [6599] = 6429,
  [6600] = 6514,
  [6601] = 6405,
  [6602] = 6416,
  [6603] = 6490,
  [6604] = 6413,
  [6605] = 6412,
  [6606] = 6409,
  [6607] = 6480,
  [6608] = 6491,
  [6609] = 6405,
  [6610] = 6417,
  [6611] = 6406,
  [6612] = 6612,
  [6613] = 6400,
  [6614] = 6417,
  [6615] = 6615,
  [6616] = 6402,
  [6617] = 6457,
  [6618] = 6455,
  [6619] = 6403,
  [6620] = 6404,
  [6621] = 6493,
  [6622] = 6455,
  [6623] = 6433,
  [6624] = 6417,
  [6625] = 6410,
  [6626] = 6411,
  [6627] = 6514,
  [6628] = 6416,
  [6629] = 6447,
  [6630] = 6433,
  [6631] = 6405,
  [6632] = 6417,
  [6633] = 6439,
  [6634] = 6421,
  [6635] = 6437,
  [6636] = 6455,
  [6637] = 6424,
  [6638] = 6436,
  [6639] = 6401,
  [6640] = 6478,
  [6641] = 6435,
  [6642] = 6429,
  [6643] = 6432,
  [6644] = 6419,
  [6645] = 6514,
  [6646] = 6416,
  [6647] = 6431,
  [6648] = 6437,
  [6649] = 6435,
  [6650] = 6436,
  [6651] = 6431,
  [6652] = 6413,
  [6653] = 6412,
  [6654] = 6409,
  [6655] = 6405,
  [6656] = 6437,
  [6657] = 6439,
  [6658] = 6417,
  [6659] = 6406,
  [6660] = 6419,
  [6661] = 6400,
  [6662] = 6662,
  [6663] = 6455,
  [6664] = 6402,
  [6665] = 6478,
  [6666] = 6436,
  [6667] = 6403,
  [6668] = 6404,
  [6669] = 6514,
  [6670] = 6416,
  [6671] = 6405,
  [6672] = 6672,
  [6673] = 6410,
  [6674] = 6411,
  [6675] = 6405,
  [6676] = 6417,
  [6677] = 6447,
  [6678] = 6455,
  [6679] = 6467,
  [6680] = 6478,
  [6681] = 6495,
  [6682] = 6421,
  [6683] = 6514,
  [6684] = 6496,
  [6685] = 6424,
  [6686] = 6416,
  [6687] = 6401,
  [6688] = 6455,
  [6689] = 6399,
  [6690] = 6429,
  [6691] = 6432,
  [6692] = 6457,
  [6693] = 6693,
  [6694] = 6470,
  [6695] = 6695,
  [6696] = 6432,
  [6697] = 6405,
  [6698] = 6478,
  [6699] = 6417,
  [6700] = 6413,
  [6701] = 6412,
  [6702] = 6409,
  [6703] = 6488,
  [6704] = 6480,
  [6705] = 6490,
  [6706] = 6491,
  [6707] = 6406,
  [6708] = 6493,
  [6709] = 6400,
  [6710] = 6510,
  [6711] = 6455,
  [6712] = 6402,
  [6713] = 6518,
  [6714] = 6501,
  [6715] = 6403,
  [6716] = 6404,
  [6717] = 6494,
  [6718] = 6478,
  [6719] = 6495,
  [6720] = 6514,
  [6721] = 6410,
  [6722] = 6411,
  [6723] = 6416,
  [6724] = 6528,
  [6725] = 6496,
  [6726] = 6534,
  [6727] = 6405,
  [6728] = 6417,
  [6729] = 6416,
  [6730] = 6421,
  [6731] = 6514,
  [6732] = 6455,
  [6733] = 6424,
  [6734] = 6478,
  [6735] = 6401,
  [6736] = 6399,
  [6737] = 6514,
  [6738] = 6429,
  [6739] = 6432,
  [6740] = 6411,
  [6741] = 6416,
  [6742] = 6742,
  [6743] = 6478,
  [6744] = 6744,
  [6745] = 6501,
  [6746] = 6405,
  [6747] = 6413,
  [6748] = 6412,
  [6749] = 6409,
  [6750] = 6417,
  [6751] = 6501,
  [6752] = 6410,
  [6753] = 6478,
  [6754] = 6406,
  [6755] = 6400,
  [6756] = 6478,
  [6757] = 6455,
  [6758] = 6402,
  [6759] = 6478,
  [6760] = 6760,
  [6761] = 6403,
  [6762] = 6404,
  [6763] = 6763,
  [6764] = 6399,
  [6765] = 6514,
  [6766] = 6410,
  [6767] = 6411,
  [6768] = 6416,
  [6769] = 6495,
  [6770] = 6405,
  [6771] = 6417,
  [6772] = 6493,
  [6773] = 6491,
  [6774] = 6490,
  [6775] = 6421,
  [6776] = 6455,
  [6777] = 6480,
  [6778] = 6424,
  [6779] = 6478,
  [6780] = 6401,
  [6781] = 6781,
  [6782] = 6514,
  [6783] = 6429,
  [6784] = 6432,
  [6785] = 6514,
  [6786] = 6416,
  [6787] = 6413,
  [6788] = 6412,
  [6789] = 6409,
  [6790] = 6514,
  [6791] = 6514,
  [6792] = 6405,
  [6793] = 6431,
  [6794] = 6406,
  [6795] = 6400,
  [6796] = 6547,
  [6797] = 6797,
  [6798] = 6402,
  [6799] = 6417,
  [6800] = 6800,
  [6801] = 6403,
  [6802] = 6404,
  [6803] = 6457,
  [6804] = 6455,
  [6805] = 6447,
  [6806] = 6410,
  [6807] = 6411,
  [6808] = 6455,
  [6809] = 6809,
  [6810] = 6416,
  [6811] = 6811,
  [6812] = 6478,
  [6813] = 6417,
  [6814] = 6534,
  [6815] = 6421,
  [6816] = 6416,
  [6817] = 6528,
  [6818] = 6424,
  [6819] = 6433,
  [6820] = 6401,
  [6821] = 6518,
  [6822] = 6516,
  [6823] = 6429,
  [6824] = 6432,
  [6825] = 6510,
  [6826] = 6405,
  [6827] = 6413,
  [6828] = 6412,
  [6829] = 6409,
  [6830] = 6417,
  [6831] = 6488,
  [6832] = 6398,
  [6833] = 6439,
  [6834] = 6406,
  [6835] = 6400,
  [6836] = 6470,
  [6837] = 6467,
  [6838] = 6402,
  [6839] = 6437,
  [6840] = 6436,
  [6841] = 6403,
  [6842] = 6404,
  [6843] = 6843,
  [6844] = 6455,
  [6845] = 6435,
  [6846] = 6410,
  [6847] = 6411,
  [6848] = 6478,
  [6849] = 6514,
  [6850] = 6416,
  [6851] = 6405,
  [6852] = 6417,
  [6853] = 6417,
  [6854] = 6405,
  [6855] = 6421,
  [6856] = 6455,
  [6857] = 6478,
  [6858] = 6424,
  [6859] = 6859,
  [6860] = 6401,
  [6861] = 6514,
  [6862] = 6405,
  [6863] = 6429,
  [6864] = 6432,
  [6865] = 6416,
  [6866] = 6435,
  [6867] = 6413,
  [6868] = 6412,
  [6869] = 6409,
  [6870] = 6405,
  [6871] = 6417,
  [6872] = 6417,
  [6873] = 6398,
  [6874] = 6406,
  [6875] = 6400,
  [6876] = 6419,
  [6877] = 6488,
  [6878] = 6402,
  [6879] = 6510,
  [6880] = 6455,
  [6881] = 6403,
  [6882] = 6404,
  [6883] = 6518,
  [6884] = 6478,
  [6885] = 6514,
  [6886] = 6410,
  [6887] = 6411,
  [6888] = 6416,
  [6889] = 6528,
  [6890] = 6433,
  [6891] = 6534,
  [6892] = 6405,
  [6893] = 6417,
  [6894] = 6435,
  [6895] = 6421,
  [6896] = 6416,
  [6897] = 6436,
  [6898] = 6424,
  [6899] = 6455,
  [6900] = 6401,
  [6901] = 6437,
  [6902] = 6547,
  [6903] = 6429,
  [6904] = 6432,
  [6905] = 6439,
  [6906] = 6514,
  [6907] = 6413,
  [6908] = 6412,
  [6909] = 6409,
  [6910] = 6478,
  [6911] = 6400,
  [6912] = 6514,
  [6913] = 6403,
  [6914] = 6416,
  [6915] = 6501,
  [6916] = 6405,
  [6917] = 6514,
  [6918] = 6424,
  [6919] = 6478,
  [6920] = 6455,
  [6921] = 6429,
  [6922] = 6399,
  [6923] = 6413,
  [6924] = 6412,
  [6925] = 6409,
  [6926] = 6447,
  [6927] = 6400,
  [6928] = 6455,
  [6929] = 6403,
  [6930] = 6478,
  [6931] = 6514,
  [6932] = 6416,
  [6933] = 6457,
  [6934] = 6413,
  [6935] = 6412,
  [6936] = 6409,
  [6937] = 6937,
  [6938] = 6400,
  [6939] = 6496,
  [6940] = 6403,
  [6941] = 6495,
  [6942] = 6493,
  [6943] = 6416,
  [6944] = 6405,
  [6945] = 6413,
  [6946] = 6412,
  [6947] = 6409,
  [6948] = 6480,
  [6949] = 6400,
  [6950] = 6417,
  [6951] = 6491,
  [6952] = 6490,
  [6953] = 6490,
  [6954] = 6413,
  [6955] = 6412,
  [6956] = 6409,
  [6957] = 6491,
  [6958] = 6400,
  [6959] = 6480,
  [6960] = 6960,
  [6961] = 6455,
  [6962] = 6493,
  [6963] = 6413,
  [6964] = 6412,
  [6965] = 6409,
  [6966] = 6494,
  [6967] = 6400,
  [6968] = 6478,
  [6969] = 6514,
  [6970] = 6416,
  [6971] = 6495,
  [6972] = 6413,
  [6973] = 6412,
  [6974] = 6409,
  [6975] = 6496,
  [6976] = 6400,
  [6977] = 6977,
  [6978] = 6431,
  [6979] = 6457,
  [6980] = 6478,
  [6981] = 6413,
  [6982] = 6412,
  [6983] = 6405,
  [6984] = 6400,
  [6985] = 6501,
  [6986] = 6417,
  [6987] = 6413,
  [6988] = 6412,
  [6989] = 6496,
  [6990] = 6400,
  [6991] = 6447,
  [6992] = 6433,
  [6993] = 6413,
  [6994] = 6412,
  [6995] = 6455,
  [6996] = 6400,
  [6997] = 6491,
  [6998] = 6478,
  [6999] = 6514,
  [7000] = 6400,
  [7001] = 6514,
  [7002] = 6416,
  [7003] = 6547,
  [7004] = 6400,
  [7005] = 6510,
  [7006] = 6416,
  [7007] = 7007,
  [7008] = 6400,
  [7009] = 7009,
  [7010] = 6439,
  [7011] = 6534,
  [7012] = 6400,
  [7013] = 6528,
  [7014] = 6518,
  [7015] = 6516,
  [7016] = 6400,
  [7017] = 6404,
  [7018] = 6510,
  [7019] = 6405,
  [7020] = 6400,
  [7021] = 6488,
  [7022] = 6398,
  [7023] = 6417,
  [7024] = 6400,
  [7025] = 7025,
  [7026] = 6470,
  [7027] = 6467,
  [7028] = 6400,
  [7029] = 6437,
  [7030] = 6436,
  [7031] = 6435,
  [7032] = 6400,
  [7033] = 6403,
  [7034] = 6455,
  [7035] = 6491,
  [7036] = 6400,
  [7037] = 6478,
  [7038] = 6405,
  [7039] = 6488,
  [7040] = 6400,
  [7041] = 6416,
  [7042] = 6417,
  [7043] = 6510,
  [7044] = 6400,
  [7045] = 6402,
  [7046] = 6455,
  [7047] = 6419,
  [7048] = 6400,
  [7049] = 6398,
  [7050] = 6417,
  [7051] = 6431,
  [7052] = 6400,
  [7053] = 7053,
  [7054] = 6405,
  [7055] = 6435,
  [7056] = 6400,
  [7057] = 6436,
  [7058] = 6437,
  [7059] = 6439,
  [7060] = 6400,
  [7061] = 6405,
  [7062] = 6455,
  [7063] = 7063,
  [7064] = 6400,
  [7065] = 6534,
  [7066] = 6433,
  [7067] = 7067,
  [7068] = 6400,
  [7069] = 6528,
  [7070] = 6447,
  [7071] = 6455,
  [7072] = 6400,
  [7073] = 6518,
  [7074] = 6457,
  [7075] = 6417,
  [7076] = 6400,
  [7077] = 6398,
  [7078] = 6488,
  [7079] = 6455,
  [7080] = 6400,
  [7081] = 6491,
  [7082] = 6510,
  [7083] = 6478,
  [7084] = 6480,
  [7085] = 7085,
  [7086] = 6490,
  [7087] = 6514,
  [7088] = 6416,
  [7089] = 6400,
  [7090] = 7090,
  [7091] = 6491,
  [7092] = 6493,
  [7093] = 7093,
  [7094] = 6518,
  [7095] = 7095,
  [7096] = 7096,
  [7097] = 7097,
  [7098] = 6510,
  [7099] = 6494,
  [7100] = 6495,
  [7101] = 6403,
  [7102] = 6496,
  [7103] = 7009,
  [7104] = 6399,
  [7105] = 7105,
  [7106] = 6419,
  [7107] = 6478,
  [7108] = 6478,
  [7109] = 6488,
  [7110] = 6501,
  [7111] = 6398,
  [7112] = 6528,
  [7113] = 6534,
  [7114] = 7085,
  [7115] = 6416,
  [7116] = 6615,
  [7117] = 889,
  [7118] = 6405,
  [7119] = 6514,
  [7120] = 6514,
  [7121] = 6417,
  [7122] = 6501,
  [7123] = 6547,
  [7124] = 6977,
  [7125] = 6455,
  [7126] = 6491,
  [7127] = 7095,
  [7128] = 7096,
  [7129] = 7097,
  [7130] = 6416,
  [7131] = 6478,
  [7132] = 6516,
  [7133] = 6478,
  [7134] = 7009,
  [7135] = 6514,
  [7136] = 6416,
  [7137] = 6534,
  [7138] = 6528,
  [7139] = 6518,
  [7140] = 6516,
  [7141] = 6510,
  [7142] = 6399,
  [7143] = 6510,
  [7144] = 7085,
  [7145] = 6510,
  [7146] = 6615,
  [7147] = 6488,
  [7148] = 6398,
  [7149] = 6488,
  [7150] = 6470,
  [7151] = 6467,
  [7152] = 6398,
  [7153] = 6496,
  [7154] = 7095,
  [7155] = 7096,
  [7156] = 7097,
  [7157] = 6495,
  [7158] = 6493,
  [7159] = 6491,
  [7160] = 6490,
  [7161] = 7009,
  [7162] = 6405,
  [7163] = 6406,
  [7164] = 6480,
  [7165] = 6405,
  [7166] = 7166,
  [7167] = 6417,
  [7168] = 7168,
  [7169] = 6457,
  [7170] = 6417,
  [7171] = 7085,
  [7172] = 7172,
  [7173] = 6615,
  [7174] = 6518,
  [7175] = 6433,
  [7176] = 7176,
  [7177] = 6455,
  [7178] = 7095,
  [7179] = 7096,
  [7180] = 7097,
  [7181] = 7181,
  [7182] = 6491,
  [7183] = 6488,
  [7184] = 6398,
  [7185] = 7009,
  [7186] = 6493,
  [7187] = 7187,
  [7188] = 7188,
  [7189] = 7189,
  [7190] = 7190,
  [7191] = 6419,
  [7192] = 6447,
  [7193] = 6478,
  [7194] = 7085,
  [7195] = 6514,
  [7196] = 6615,
  [7197] = 6431,
  [7198] = 6416,
  [7199] = 6435,
  [7200] = 6510,
  [7201] = 7095,
  [7202] = 7096,
  [7203] = 7097,
  [7204] = 6436,
  [7205] = 6437,
  [7206] = 6439,
  [7207] = 6488,
  [7208] = 7009,
  [7209] = 7209,
  [7210] = 6398,
  [7211] = 6470,
  [7212] = 6516,
  [7213] = 6433,
  [7214] = 6439,
  [7215] = 7085,
  [7216] = 6433,
  [7217] = 6615,
  [7218] = 6405,
  [7219] = 6467,
  [7220] = 6437,
  [7221] = 6436,
  [7222] = 7095,
  [7223] = 7096,
  [7224] = 7097,
  [7225] = 6447,
  [7226] = 6455,
  [7227] = 6457,
  [7228] = 6417,
  [7229] = 7009,
  [7230] = 6435,
  [7231] = 6433,
  [7232] = 6480,
  [7233] = 6490,
  [7234] = 6455,
  [7235] = 6491,
  [7236] = 7085,
  [7237] = 6491,
  [7238] = 6615,
  [7239] = 6493,
  [7240] = 6494,
  [7241] = 6495,
  [7242] = 6493,
  [7243] = 7095,
  [7244] = 7096,
  [7245] = 7097,
  [7246] = 6496,
  [7247] = 6399,
  [7248] = 6478,
  [7249] = 6478,
  [7250] = 7009,
  [7251] = 7097,
  [7252] = 6417,
  [7253] = 6501,
  [7254] = 6514,
  [7255] = 6416,
  [7256] = 7256,
  [7257] = 7085,
  [7258] = 6405,
  [7259] = 6615,
  [7260] = 6510,
  [7261] = 7096,
  [7262] = 7095,
  [7263] = 6488,
  [7264] = 7095,
  [7265] = 7096,
  [7266] = 7097,
  [7267] = 6398,
  [7268] = 6405,
  [7269] = 6398,
  [7270] = 7270,
  [7271] = 7009,
  [7272] = 7272,
  [7273] = 6488,
  [7274] = 6417,
  [7275] = 6510,
  [7276] = 6416,
  [7277] = 6528,
  [7278] = 6514,
  [7279] = 6534,
  [7280] = 6433,
  [7281] = 6455,
  [7282] = 7095,
  [7283] = 7096,
  [7284] = 7097,
  [7285] = 6491,
  [7286] = 6493,
  [7287] = 6547,
  [7288] = 6478,
  [7289] = 7009,
  [7290] = 6416,
  [7291] = 7291,
  [7292] = 7292,
  [7293] = 6534,
  [7294] = 6514,
  [7295] = 6528,
  [7296] = 6518,
  [7297] = 6405,
  [7298] = 7298,
  [7299] = 6416,
  [7300] = 7095,
  [7301] = 7096,
  [7302] = 7097,
  [7303] = 7303,
  [7304] = 889,
  [7305] = 6493,
  [7306] = 6491,
  [7307] = 7009,
  [7308] = 6455,
  [7309] = 6510,
  [7310] = 6436,
  [7311] = 6488,
  [7312] = 6510,
  [7313] = 903,
  [7314] = 6398,
  [7315] = 6488,
  [7316] = 6470,
  [7317] = 6398,
  [7318] = 7095,
  [7319] = 7096,
  [7320] = 7097,
  [7321] = 6433,
  [7322] = 6467,
  [7323] = 6514,
  [7324] = 7324,
  [7325] = 7009,
  [7326] = 6405,
  [7327] = 6501,
  [7328] = 6417,
  [7329] = 6478,
  [7330] = 6399,
  [7331] = 6405,
  [7332] = 6496,
  [7333] = 7096,
  [7334] = 6433,
  [7335] = 6407,
  [7336] = 6455,
  [7337] = 6417,
  [7338] = 7096,
  [7339] = 903,
  [7340] = 945,
  [7341] = 7096,
  [7342] = 6518,
  [7343] = 6960,
  [7344] = 6419,
  [7345] = 6491,
  [7346] = 6493,
  [7347] = 6431,
  [7348] = 6495,
  [7349] = 6435,
  [7350] = 6436,
  [7351] = 6437,
  [7352] = 6439,
  [7353] = 6478,
  [7354] = 6493,
  [7355] = 6514,
  [7356] = 6416,
  [7357] = 6433,
  [7358] = 6491,
  [7359] = 6447,
  [7360] = 6455,
  [7361] = 6457,
  [7362] = 6510,
  [7363] = 952,
  [7364] = 6488,
  [7365] = 6480,
  [7366] = 6490,
  [7367] = 6398,
  [7368] = 6491,
  [7369] = 6493,
  [7370] = 6494,
  [7371] = 7371,
  [7372] = 7372,
  [7373] = 7272,
  [7374] = 7270,
  [7375] = 6495,
  [7376] = 7096,
  [7377] = 7256,
  [7378] = 6496,
  [7379] = 6399,
  [7380] = 6478,
  [7381] = 6490,
  [7382] = 6501,
  [7383] = 7063,
  [7384] = 6409,
  [7385] = 6480,
  [7386] = 6457,
  [7387] = 6455,
  [7388] = 6405,
  [7389] = 7372,
  [7390] = 7272,
  [7391] = 7270,
  [7392] = 6447,
  [7393] = 7256,
  [7394] = 6433,
  [7395] = 6412,
  [7396] = 6417,
  [7397] = 7063,
  [7398] = 7372,
  [7399] = 7272,
  [7400] = 7270,
  [7401] = 6413,
  [7402] = 7256,
  [7403] = 6514,
  [7404] = 6439,
  [7405] = 6437,
  [7406] = 7063,
  [7407] = 7372,
  [7408] = 7272,
  [7409] = 7270,
  [7410] = 6547,
  [7411] = 7256,
  [7412] = 6433,
  [7413] = 6416,
  [7414] = 6455,
  [7415] = 7063,
  [7416] = 7372,
  [7417] = 7272,
  [7418] = 7270,
  [7419] = 7419,
  [7420] = 7256,
  [7421] = 6534,
  [7422] = 6491,
  [7423] = 6528,
  [7424] = 7063,
  [7425] = 7372,
  [7426] = 7272,
  [7427] = 7270,
  [7428] = 6493,
  [7429] = 7256,
  [7430] = 6514,
  [7431] = 6478,
  [7432] = 6516,
  [7433] = 7063,
  [7434] = 7372,
  [7435] = 7272,
  [7436] = 7270,
  [7437] = 6510,
  [7438] = 7256,
  [7439] = 6435,
  [7440] = 6488,
  [7441] = 6398,
  [7442] = 7063,
  [7443] = 7372,
  [7444] = 7272,
  [7445] = 7270,
  [7446] = 6514,
  [7447] = 7256,
  [7448] = 6470,
  [7449] = 6467,
  [7450] = 7372,
  [7451] = 7272,
  [7452] = 7270,
  [7453] = 6416,
  [7454] = 7256,
  [7455] = 6510,
  [7456] = 7456,
  [7457] = 7372,
  [7458] = 7272,
  [7459] = 7270,
  [7460] = 6488,
  [7461] = 7256,
  [7462] = 6398,
  [7463] = 6417,
  [7464] = 7372,
  [7465] = 7272,
  [7466] = 7270,
  [7467] = 6417,
  [7468] = 7256,
  [7469] = 7469,
  [7470] = 7372,
  [7471] = 7372,
  [7472] = 6405,
  [7473] = 7372,
  [7474] = 6405,
  [7475] = 7372,
  [7476] = 6398,
  [7477] = 7372,
  [7478] = 7372,
  [7479] = 7372,
  [7480] = 7372,
  [7481] = 7372,
  [7482] = 7372,
  [7483] = 7372,
  [7484] = 7372,
  [7485] = 7372,
  [7486] = 7372,
  [7487] = 7372,
  [7488] = 7372,
  [7489] = 7372,
  [7490] = 7372,
  [7491] = 7372,
  [7492] = 7372,
  [7493] = 7372,
  [7494] = 7372,
  [7495] = 7372,
  [7496] = 7372,
  [7497] = 7372,
  [7498] = 7372,
  [7499] = 7372,
  [7500] = 7372,
  [7501] = 7372,
  [7502] = 7372,
  [7503] = 7372,
  [7504] = 7372,
  [7505] = 6405,
  [7506] = 6488,
  [7507] = 7507,
  [7508] = 7508,
  [7509] = 7007,
  [7510] = 7510,
  [7511] = 6417,
  [7512] = 6510,
  [7513] = 7007,
  [7514] = 7510,
  [7515] = 6417,
  [7516] = 7516,
  [7517] = 7007,
  [7518] = 7510,
  [7519] = 7519,
  [7520] = 7520,
  [7521] = 7007,
  [7522] = 7510,
  [7523] = 6416,
  [7524] = 7524,
  [7525] = 7007,
  [7526] = 7510,
  [7527] = 6433,
  [7528] = 6455,
  [7529] = 7007,
  [7530] = 7510,
  [7531] = 6491,
  [7532] = 6493,
  [7533] = 7007,
  [7534] = 7510,
  [7535] = 6478,
  [7536] = 7371,
  [7537] = 7537,
  [7538] = 7538,
  [7539] = 6514,
  [7540] = 6416,
  [7541] = 6510,
  [7542] = 7542,
  [7543] = 6488,
  [7544] = 7544,
  [7545] = 6398,
  [7546] = 7510,
  [7547] = 6405,
  [7548] = 6417,
  [7549] = 820,
  [7550] = 7550,
  [7551] = 7551,
  [7552] = 7552,
  [7553] = 7553,
  [7554] = 7554,
  [7555] = 7555,
  [7556] = 7556,
};

static TSCharacterRange sym__non_escape_char_character_set_1[] = {
  {0, '!'}, {'#', '&'}, {'(', '`'}, {'c', 'e'}, {'g', 'm'}, {'o', 'q'}, {'s', 's'}, {'u', 'u'},
  {'w', 0x10ffff},
};

static TSCharacterRange aux_sym_infix_op_token2_character_set_1[] = {
  {'%', '\''}, {'*', '+'}, {'-', '-'}, {'/', '/'}, {'<', '<'}, {'>', '>'}, {'@', '@'}, {'^', '^'},
  {'|', '|'},
};

static TSCharacterRange sym_identifier_character_set_1[] = {
  {'A', 'Z'}, {'_', 'z'}, {0xaa, 0xaa}, {0xb5, 0xb5}, {0xba, 0xba}, {0xc0, 0xd6}, {0xd8, 0xf6}, {0xf8, 0x2c1},
  {0x2c6, 0x2d1}, {0x2e0, 0x2e4}, {0x2ec, 0x2ec}, {0x2ee, 0x2ee}, {0x370, 0x374}, {0x376, 0x377}, {0x37b, 0x37d}, {0x37f, 0x37f},
  {0x386, 0x386}, {0x388, 0x38a}, {0x38c, 0x38c}, {0x38e, 0x3a1}, {0x3a3, 0x3f5}, {0x3f7, 0x481}, {0x48a, 0x52f}, {0x531, 0x556},
  {0x559, 0x559}, {0x560, 0x588}, {0x5d0, 0x5ea}, {0x5ef, 0x5f2}, {0x620, 0x64a}, {0x66e, 0x66f}, {0x671, 0x6d3}, {0x6d5, 0x6d5},
  {0x6e5, 0x6e6}, {0x6ee, 0x6ef}, {0x6fa, 0x6fc}, {0x6ff, 0x6ff}, {0x710, 0x710}, {0x712, 0x72f}, {0x74d, 0x7a5}, {0x7b1, 0x7b1},
  {0x7ca, 0x7ea}, {0x7f4, 0x7f5}, {0x7fa, 0x7fa}, {0x800, 0x815}, {0x81a, 0x81a}, {0x824, 0x824}, {0x828, 0x828}, {0x840, 0x858},
  {0x860, 0x86a}, {0x870, 0x887}, {0x889, 0x88e}, {0x8a0, 0x8c9}, {0x904, 0x939}, {0x93d, 0x93d}, {0x950, 0x950}, {0x958, 0x961},
  {0x971, 0x980}, {0x985, 0x98c}, {0x98f, 0x990}, {0x993, 0x9a8}, {0x9aa, 0x9b0}, {0x9b2, 0x9b2}, {0x9b6, 0x9b9}, {0x9bd, 0x9bd},
  {0x9ce, 0x9ce}, {0x9dc, 0x9dd}, {0x9df, 0x9e1}, {0x9f0, 0x9f1}, {0x9fc, 0x9fc}, {0xa05, 0xa0a}, {0xa0f, 0xa10}, {0xa13, 0xa28},
  {0xa2a, 0xa30}, {0xa32, 0xa33}, {0xa35, 0xa36}, {0xa38, 0xa39}, {0xa59, 0xa5c}, {0xa5e, 0xa5e}, {0xa72, 0xa74}, {0xa85, 0xa8d},
  {0xa8f, 0xa91}, {0xa93, 0xaa8}, {0xaaa, 0xab0}, {0xab2, 0xab3}, {0xab5, 0xab9}, {0xabd, 0xabd}, {0xad0, 0xad0}, {0xae0, 0xae1},
  {0xaf9, 0xaf9}, {0xb05, 0xb0c}, {0xb0f, 0xb10}, {0xb13, 0xb28}, {0xb2a, 0xb30}, {0xb32, 0xb33}, {0xb35, 0xb39}, {0xb3d, 0xb3d},
  {0xb5c, 0xb5d}, {0xb5f, 0xb61}, {0xb71, 0xb71}, {0xb83, 0xb83}, {0xb85, 0xb8a}, {0xb8e, 0xb90}, {0xb92, 0xb95}, {0xb99, 0xb9a},
  {0xb9c, 0xb9c}, {0xb9e, 0xb9f}, {0xba3, 0xba4}, {0xba8, 0xbaa}, {0xbae, 0xbb9}, {0xbd0, 0xbd0}, {0xc05, 0xc0c}, {0xc0e, 0xc10},
  {0xc12, 0xc28}, {0xc2a, 0xc39}, {0xc3d, 0xc3d}, {0xc58, 0xc5a}, {0xc5d, 0xc5d}, {0xc60, 0xc61}, {0xc80, 0xc80}, {0xc85, 0xc8c},
  {0xc8e, 0xc90}, {0xc92, 0xca8}, {0xcaa, 0xcb3}, {0xcb5, 0xcb9}, {0xcbd, 0xcbd}, {0xcdd, 0xcde}, {0xce0, 0xce1}, {0xcf1, 0xcf2},
  {0xd04, 0xd0c}, {0xd0e, 0xd10}, {0xd12, 0xd3a}, {0xd3d, 0xd3d}, {0xd4e, 0xd4e}, {0xd54, 0xd56}, {0xd5f, 0xd61}, {0xd7a, 0xd7f},
  {0xd85, 0xd96}, {0xd9a, 0xdb1}, {0xdb3, 0xdbb}, {0xdbd, 0xdbd}, {0xdc0, 0xdc6}, {0xe01, 0xe30}, {0xe32, 0xe32}, {0xe40, 0xe46},
  {0xe81, 0xe82}, {0xe84, 0xe84}, {0xe86, 0xe8a}, {0xe8c, 0xea3}, {0xea5, 0xea5}, {0xea7, 0xeb0}, {0xeb2, 0xeb2}, {0xebd, 0xebd},
  {0xec0, 0xec4}, {0xec6, 0xec6}, {0xedc, 0xedf}, {0xf00, 0xf00}, {0xf40, 0xf47}, {0xf49, 0xf6c}, {0xf88, 0xf8c}, {0x1000, 0x102a},
  {0x103f, 0x103f}, {0x1050, 0x1055}, {0x105a, 0x105d}, {0x1061, 0x1061}, {0x1065, 0x1066}, {0x106e, 0x1070}, {0x1075, 0x1081}, {0x108e, 0x108e},
  {0x10a0, 0x10c5}, {0x10c7, 0x10c7}, {0x10cd, 0x10cd}, {0x10d0, 0x10fa}, {0x10fc, 0x1248}, {0x124a, 0x124d}, {0x1250, 0x1256}, {0x1258, 0x1258},
  {0x125a, 0x125d}, {0x1260, 0x1288}, {0x128a, 0x128d}, {0x1290, 0x12b0}, {0x12b2, 0x12b5}, {0x12b8, 0x12be}, {0x12c0, 0x12c0}, {0x12c2, 0x12c5},
  {0x12c8, 0x12d6}, {0x12d8, 0x1310}, {0x1312, 0x1315}, {0x1318, 0x135a}, {0x1380, 0x138f}, {0x13a0, 0x13f5}, {0x13f8, 0x13fd}, {0x1401, 0x166c},
  {0x166f, 0x167f}, {0x1681, 0x169a}, {0x16a0, 0x16ea}, {0x16ee, 0x16f8}, {0x1700, 0x1711}, {0x171f, 0x1731}, {0x1740, 0x1751}, {0x1760, 0x176c},
  {0x176e, 0x1770}, {0x1780, 0x17b3}, {0x17d7, 0x17d7}, {0x17dc, 0x17dc}, {0x1820, 0x1878}, {0x1880, 0x18a8}, {0x18aa, 0x18aa}, {0x18b0, 0x18f5},
  {0x1900, 0x191e}, {0x1950, 0x196d}, {0x1970, 0x1974}, {0x1980, 0x19ab}, {0x19b0, 0x19c9}, {0x1a00, 0x1a16}, {0x1a20, 0x1a54}, {0x1aa7, 0x1aa7},
  {0x1b05, 0x1b33}, {0x1b45, 0x1b4c}, {0x1b83, 0x1ba0}, {0x1bae, 0x1baf}, {0x1bba, 0x1be5}, {0x1c00, 0x1c23}, {0x1c4d, 0x1c4f}, {0x1c5a, 0x1c7d},
  {0x1c80, 0x1c88}, {0x1c90, 0x1cba}, {0x1cbd, 0x1cbf}, {0x1ce9, 0x1cec}, {0x1cee, 0x1cf3}, {0x1cf5, 0x1cf6}, {0x1cfa, 0x1cfa}, {0x1d00, 0x1dbf},
  {0x1e00, 0x1f15}, {0x1f18, 0x1f1d}, {0x1f20, 0x1f45}, {0x1f48, 0x1f4d}, {0x1f50, 0x1f57}, {0x1f59, 0x1f59}, {0x1f5b, 0x1f5b}, {0x1f5d, 0x1f5d},
  {0x1f5f, 0x1f7d}, {0x1f80, 0x1fb4}, {0x1fb6, 0x1fbc}, {0x1fbe, 0x1fbe}, {0x1fc2, 0x1fc4}, {0x1fc6, 0x1fcc}, {0x1fd0, 0x1fd3}, {0x1fd6, 0x1fdb},
  {0x1fe0, 0x1fec}, {0x1ff2, 0x1ff4}, {0x1ff6, 0x1ffc}, {0x2071, 0x2071}, {0x207f, 0x207f}, {0x2090, 0x209c}, {0x2102, 0x2102}, {0x2107, 0x2107},
  {0x210a, 0x2113}, {0x2115, 0x2115}, {0x2118, 0x211d}, {0x2124, 0x2124}, {0x2126, 0x2126}, {0x2128, 0x2128}, {0x212a, 0x2139}, {0x213c, 0x213f},
  {0x2145, 0x2149}, {0x214e, 0x214e}, {0x2160, 0x2188}, {0x2c00, 0x2ce4}, {0x2ceb, 0x2cee}, {0x2cf2, 0x2cf3}, {0x2d00, 0x2d25}, {0x2d27, 0x2d27},
  {0x2d2d, 0x2d2d}, {0x2d30, 0x2d67}, {0x2d6f, 0x2d6f}, {0x2d80, 0x2d96}, {0x2da0, 0x2da6}, {0x2da8, 0x2dae}, {0x2db0, 0x2db6}, {0x2db8, 0x2dbe},
  {0x2dc0, 0x2dc6}, {0x2dc8, 0x2dce}, {0x2dd0, 0x2dd6}, {0x2dd8, 0x2dde}, {0x3005, 0x3007}, {0x3021, 0x3029}, {0x3031, 0x3035}, {0x3038, 0x303c},
  {0x3041, 0x3096}, {0x309d, 0x309f}, {0x30a1, 0x30fa}, {0x30fc, 0x30ff}, {0x3105, 0x312f}, {0x3131, 0x318e}, {0x31a0, 0x31bf}, {0x31f0, 0x31ff},
  {0x3400, 0x4dbf}, {0x4e00, 0xa48c}, {0xa4d0, 0xa4fd}, {0xa500, 0xa60c}, {0xa610, 0xa61f}, {0xa62a, 0xa62b}, {0xa640, 0xa66e}, {0xa67f, 0xa69d},
  {0xa6a0, 0xa6ef}, {0xa717, 0xa71f}, {0xa722, 0xa788}, {0xa78b, 0xa7ca}, {0xa7d0, 0xa7d1}, {0xa7d3, 0xa7d3}, {0xa7d5, 0xa7d9}, {0xa7f2, 0xa801},
  {0xa803, 0xa805}, {0xa807, 0xa80a}, {0xa80c, 0xa822}, {0xa840, 0xa873}, {0xa882, 0xa8b3}, {0xa8f2, 0xa8f7}, {0xa8fb, 0xa8fb}, {0xa8fd, 0xa8fe},
  {0xa90a, 0xa925}, {0xa930, 0xa946}, {0xa960, 0xa97c}, {0xa984, 0xa9b2}, {0xa9cf, 0xa9cf}, {0xa9e0, 0xa9e4}, {0xa9e6, 0xa9ef}, {0xa9fa, 0xa9fe},
  {0xaa00, 0xaa28}, {0xaa40, 0xaa42}, {0xaa44, 0xaa4b}, {0xaa60, 0xaa76}, {0xaa7a, 0xaa7a}, {0xaa7e, 0xaaaf}, {0xaab1, 0xaab1}, {0xaab5, 0xaab6},
  {0xaab9, 0xaabd}, {0xaac0, 0xaac0}, {0xaac2, 0xaac2}, {0xaadb, 0xaadd}, {0xaae0, 0xaaea}, {0xaaf2, 0xaaf4}, {0xab01, 0xab06}, {0xab09, 0xab0e},
  {0xab11, 0xab16}, {0xab20, 0xab26}, {0xab28, 0xab2e}, {0xab30, 0xab5a}, {0xab5c, 0xab69}, {0xab70, 0xabe2}, {0xac00, 0xd7a3}, {0xd7b0, 0xd7c6},
  {0xd7cb, 0xd7fb}, {0xf900, 0xfa6d}, {0xfa70, 0xfad9}, {0xfb00, 0xfb06}, {0xfb13, 0xfb17}, {0xfb1d, 0xfb1d}, {0xfb1f, 0xfb28}, {0xfb2a, 0xfb36},
  {0xfb38, 0xfb3c}, {0xfb3e, 0xfb3e}, {0xfb40, 0xfb41}, {0xfb43, 0xfb44}, {0xfb46, 0xfbb1}, {0xfbd3, 0xfc5d}, {0xfc64, 0xfd3d}, {0xfd50, 0xfd8f},
  {0xfd92, 0xfdc7}, {0xfdf0, 0xfdf9}, {0xfe71, 0xfe71}, {0xfe73, 0xfe73}, {0xfe77, 0xfe77}, {0xfe79, 0xfe79}, {0xfe7b, 0xfe7b}, {0xfe7d, 0xfe7d},
  {0xfe7f, 0xfefc}, {0xff21, 0xff3a}, {0xff41, 0xff5a}, {0xff66, 0xff9d}, {0xffa0, 0xffbe}, {0xffc2, 0xffc7}, {0xffca, 0xffcf}, {0xffd2, 0xffd7},
  {0xffda, 0xffdc}, {0x10000, 0x1000b}, {0x1000d, 0x10026}, {0x10028, 0x1003a}, {0x1003c, 0x1003d}, {0x1003f, 0x1004d}, {0x10050, 0x1005d}, {0x10080, 0x100fa},
  {0x10140, 0x10174}, {0x10280, 0x1029c}, {0x102a0, 0x102d0}, {0x10300, 0x1031f}, {0x1032d, 0x1034a}, {0x10350, 0x10375}, {0x10380, 0x1039d}, {0x103a0, 0x103c3},
  {0x103c8, 0x103cf}, {0x103d1, 0x103d5}, {0x10400, 0x1049d}, {0x104b0, 0x104d3}, {0x104d8, 0x104fb}, {0x10500, 0x10527}, {0x10530, 0x10563}, {0x10570, 0x1057a},
  {0x1057c, 0x1058a}, {0x1058c, 0x10592}, {0x10594, 0x10595}, {0x10597, 0x105a1}, {0x105a3, 0x105b1}, {0x105b3, 0x105b9}, {0x105bb, 0x105bc}, {0x10600, 0x10736},
  {0x10740, 0x10755}, {0x10760, 0x10767}, {0x10780, 0x10785}, {0x10787, 0x107b0}, {0x107b2, 0x107ba}, {0x10800, 0x10805}, {0x10808, 0x10808}, {0x1080a, 0x10835},
  {0x10837, 0x10838}, {0x1083c, 0x1083c}, {0x1083f, 0x10855}, {0x10860, 0x10876}, {0x10880, 0x1089e}, {0x108e0, 0x108f2}, {0x108f4, 0x108f5}, {0x10900, 0x10915},
  {0x10920, 0x10939}, {0x10980, 0x109b7}, {0x109be, 0x109bf}, {0x10a00, 0x10a00}, {0x10a10, 0x10a13}, {0x10a15, 0x10a17}, {0x10a19, 0x10a35}, {0x10a60, 0x10a7c},
  {0x10a80, 0x10a9c}, {0x10ac0, 0x10ac7}, {0x10ac9, 0x10ae4}, {0x10b00, 0x10b35}, {0x10b40, 0x10b55}, {0x10b60, 0x10b72}, {0x10b80, 0x10b91}, {0x10c00, 0x10c48},
  {0x10c80, 0x10cb2}, {0x10cc0, 0x10cf2}, {0x10d00, 0x10d23}, {0x10e80, 0x10ea9}, {0x10eb0, 0x10eb1}, {0x10f00, 0x10f1c}, {0x10f27, 0x10f27}, {0x10f30, 0x10f45},
  {0x10f70, 0x10f81}, {0x10fb0, 0x10fc4}, {0x10fe0, 0x10ff6}, {0x11003, 0x11037}, {0x11071, 0x11072}, {0x11075, 0x11075}, {0x11083, 0x110af}, {0x110d0, 0x110e8},
  {0x11103, 0x11126}, {0x11144, 0x11144}, {0x11147, 0x11147}, {0x11150, 0x11172}, {0x11176, 0x11176}, {0x11183, 0x111b2}, {0x111c1, 0x111c4}, {0x111da, 0x111da},
  {0x111dc, 0x111dc}, {0x11200, 0x11211}, {0x11213, 0x1122b}, {0x1123f, 0x11240}, {0x11280, 0x11286}, {0x11288, 0x11288}, {0x1128a, 0x1128d}, {0x1128f, 0x1129d},
  {0x1129f, 0x112a8}, {0x112b0, 0x112de}, {0x11305, 0x1130c}, {0x1130f, 0x11310}, {0x11313, 0x11328}, {0x1132a, 0x11330}, {0x11332, 0x11333}, {0x11335, 0x11339},
  {0x1133d, 0x1133d}, {0x11350, 0x11350}, {0x1135d, 0x11361}, {0x11400, 0x11434}, {0x11447, 0x1144a}, {0x1145f, 0x11461}, {0x11480, 0x114af}, {0x114c4, 0x114c5},
  {0x114c7, 0x114c7}, {0x11580, 0x115ae}, {0x115d8, 0x115db}, {0x11600, 0x1162f}, {0x11644, 0x11644}, {0x11680, 0x116aa}, {0x116b8, 0x116b8}, {0x11700, 0x1171a},
  {0x11740, 0x11746}, {0x11800, 0x1182b}, {0x118a0, 0x118df}, {0x118ff, 0x11906}, {0x11909, 0x11909}, {0x1190c, 0x11913}, {0x11915, 0x11916}, {0x11918, 0x1192f},
  {0x1193f, 0x1193f}, {0x11941, 0x11941}, {0x119a0, 0x119a7}, {0x119aa, 0x119d0}, {0x119e1, 0x119e1}, {0x119e3, 0x119e3}, {0x11a00, 0x11a00}, {0x11a0b, 0x11a32},
  {0x11a3a, 0x11a3a}, {0x11a50, 0x11a50}, {0x11a5c, 0x11a89}, {0x11a9d, 0x11a9d}, {0x11ab0, 0x11af8}, {0x11c00, 0x11c08}, {0x11c0a, 0x11c2e}, {0x11c40, 0x11c40},
  {0x11c72, 0x11c8f}, {0x11d00, 0x11d06}, {0x11d08, 0x11d09}, {0x11d0b, 0x11d30}, {0x11d46, 0x11d46}, {0x11d60, 0x11d65}, {0x11d67, 0x11d68}, {0x11d6a, 0x11d89},
  {0x11d98, 0x11d98}, {0x11ee0, 0x11ef2}, {0x11f02, 0x11f02}, {0x11f04, 0x11f10}, {0x11f12, 0x11f33}, {0x11fb0, 0x11fb0}, {0x12000, 0x12399}, {0x12400, 0x1246e},
  {0x12480, 0x12543}, {0x12f90, 0x12ff0}, {0x13000, 0x1342f}, {0x13441, 0x13446}, {0x14400, 0x14646}, {0x16800, 0x16a38}, {0x16a40, 0x16a5e}, {0x16a70, 0x16abe},
  {0x16ad0, 0x16aed}, {0x16b00, 0x16b2f}, {0x16b40, 0x16b43}, {0x16b63, 0x16b77}, {0x16b7d, 0x16b8f}, {0x16e40, 0x16e7f}, {0x16f00, 0x16f4a}, {0x16f50, 0x16f50},
  {0x16f93, 0x16f9f}, {0x16fe0, 0x16fe1}, {0x16fe3, 0x16fe3}, {0x17000, 0x187f7}, {0x18800, 0x18cd5}, {0x18d00, 0x18d08}, {0x1aff0, 0x1aff3}, {0x1aff5, 0x1affb},
  {0x1affd, 0x1affe}, {0x1b000, 0x1b122}, {0x1b132, 0x1b132}, {0x1b150, 0x1b152}, {0x1b155, 0x1b155}, {0x1b164, 0x1b167}, {0x1b170, 0x1b2fb}, {0x1bc00, 0x1bc6a},
  {0x1bc70, 0x1bc7c}, {0x1bc80, 0x1bc88}, {0x1bc90, 0x1bc99}, {0x1d400, 0x1d454}, {0x1d456, 0x1d49c}, {0x1d49e, 0x1d49f}, {0x1d4a2, 0x1d4a2}, {0x1d4a5, 0x1d4a6},
  {0x1d4a9, 0x1d4ac}, {0x1d4ae, 0x1d4b9}, {0x1d4bb, 0x1d4bb}, {0x1d4bd, 0x1d4c3}, {0x1d4c5, 0x1d505}, {0x1d507, 0x1d50a}, {0x1d50d, 0x1d514}, {0x1d516, 0x1d51c},
  {0x1d51e, 0x1d539}, {0x1d53b, 0x1d53e}, {0x1d540, 0x1d544}, {0x1d546, 0x1d546}, {0x1d54a, 0x1d550}, {0x1d552, 0x1d6a5}, {0x1d6a8, 0x1d6c0}, {0x1d6c2, 0x1d6da},
  {0x1d6dc, 0x1d6fa}, {0x1d6fc, 0x1d714}, {0x1d716, 0x1d734}, {0x1d736, 0x1d74e}, {0x1d750, 0x1d76e}, {0x1d770, 0x1d788}, {0x1d78a, 0x1d7a8}, {0x1d7aa, 0x1d7c2},
  {0x1d7c4, 0x1d7cb}, {0x1df00, 0x1df1e}, {0x1df25, 0x1df2a}, {0x1e030, 0x1e06d}, {0x1e100, 0x1e12c}, {0x1e137, 0x1e13d}, {0x1e14e, 0x1e14e}, {0x1e290, 0x1e2ad},
  {0x1e2c0, 0x1e2eb}, {0x1e4d0, 0x1e4eb}, {0x1e7e0, 0x1e7e6}, {0x1e7e8, 0x1e7eb}, {0x1e7ed, 0x1e7ee}, {0x1e7f0, 0x1e7fe}, {0x1e800, 0x1e8c4}, {0x1e900, 0x1e943},
  {0x1e94b, 0x1e94b}, {0x1ee00, 0x1ee03}, {0x1ee05, 0x1ee1f}, {0x1ee21, 0x1ee22}, {0x1ee24, 0x1ee24}, {0x1ee27, 0x1ee27}, {0x1ee29, 0x1ee32}, {0x1ee34, 0x1ee37},
  {0x1ee39, 0x1ee39}, {0x1ee3b, 0x1ee3b}, {0x1ee42, 0x1ee42}, {0x1ee47, 0x1ee47}, {0x1ee49, 0x1ee49}, {0x1ee4b, 0x1ee4b}, {0x1ee4d, 0x1ee4f}, {0x1ee51, 0x1ee52},
  {0x1ee54, 0x1ee54}, {0x1ee57, 0x1ee57}, {0x1ee59, 0x1ee59}, {0x1ee5b, 0x1ee5b}, {0x1ee5d, 0x1ee5d}, {0x1ee5f, 0x1ee5f}, {0x1ee61, 0x1ee62}, {0x1ee64, 0x1ee64},
  {0x1ee67, 0x1ee6a}, {0x1ee6c, 0x1ee72}, {0x1ee74, 0x1ee77}, {0x1ee79, 0x1ee7c}, {0x1ee7e, 0x1ee7e}, {0x1ee80, 0x1ee89}, {0x1ee8b, 0x1ee9b}, {0x1eea1, 0x1eea3},
  {0x1eea5, 0x1eea9}, {0x1eeab, 0x1eebb}, {0x20000, 0x2a6df}, {0x2a700, 0x2b739}, {0x2b740, 0x2b81d}, {0x2b820, 0x2cea1}, {0x2ceb0, 0x2ebe0}, {0x2ebf0, 0x2ee5d},
  {0x2f800, 0x2fa1d}, {0x30000, 0x3134a}, {0x31350, 0x323af},
};

static TSCharacterRange sym_identifier_character_set_2[] = {
  {'\'', '\''}, {'0', '9'}, {'A', 'Z'}, {'_', '_'}, {'a', 'z'}, {0xaa, 0xaa}, {0xb5, 0xb5}, {0xb7, 0xb7},
  {0xba, 0xba}, {0xc0, 0xd6}, {0xd8, 0xf6}, {0xf8, 0x2c1}, {0x2c6, 0x2d1}, {0x2e0, 0x2e4}, {0x2ec, 0x2ec}, {0x2ee, 0x2ee},
  {0x300, 0x374}, {0x376, 0x377}, {0x37b, 0x37d}, {0x37f, 0x37f}, {0x386, 0x38a}, {0x38c, 0x38c}, {0x38e, 0x3a1}, {0x3a3, 0x3f5},
  {0x3f7, 0x481}, {0x483, 0x487}, {0x48a, 0x52f}, {0x531, 0x556}, {0x559, 0x559}, {0x560, 0x588}, {0x591, 0x5bd}, {0x5bf, 0x5bf},
  {0x5c1, 0x5c2}, {0x5c4, 0x5c5}, {0x5c7, 0x5c7}, {0x5d0, 0x5ea}, {0x5ef, 0x5f2}, {0x610, 0x61a}, {0x620, 0x669}, {0x66e, 0x6d3},
  {0x6d5, 0x6dc}, {0x6df, 0x6e8}, {0x6ea, 0x6fc}, {0x6ff, 0x6ff}, {0x710, 0x74a}, {0x74d, 0x7b1}, {0x7c0, 0x7f5}, {0x7fa, 0x7fa},
  {0x7fd, 0x7fd}, {0x800, 0x82d}, {0x840, 0x85b}, {0x860, 0x86a}, {0x870, 0x887}, {0x889, 0x88e}, {0x898, 0x8e1}, {0x8e3, 0x963},
  {0x966, 0x96f}, {0x971, 0x983}, {0x985, 0x98c}, {0x98f, 0x990}, {0x993, 0x9a8}, {0x9aa, 0x9b0}, {0x9b2, 0x9b2}, {0x9b6, 0x9b9},
  {0x9bc, 0x9c4}, {0x9c7, 0x9c8}, {0x9cb, 0x9ce}, {0x9d7, 0x9d7}, {0x9dc, 0x9dd}, {0x9df, 0x9e3}, {0x9e6, 0x9f1}, {0x9fc, 0x9fc},
  {0x9fe, 0x9fe}, {0xa01, 0xa03}, {0xa05, 0xa0a}, {0xa0f, 0xa10}, {0xa13, 0xa28}, {0xa2a, 0xa30}, {0xa32, 0xa33}, {0xa35, 0xa36},
  {0xa38, 0xa39}, {0xa3c, 0xa3c}, {0xa3e, 0xa42}, {0xa47, 0xa48}, {0xa4b, 0xa4d}, {0xa51, 0xa51}, {0xa59, 0xa5c}, {0xa5e, 0xa5e},
  {0xa66, 0xa75}, {0xa81, 0xa83}, {0xa85, 0xa8d}, {0xa8f, 0xa91}, {0xa93, 0xaa8}, {0xaaa, 0xab0}, {0xab2, 0xab3}, {0xab5, 0xab9},
  {0xabc, 0xac5}, {0xac7, 0xac9}, {0xacb, 0xacd}, {0xad0, 0xad0}, {0xae0, 0xae3}, {0xae6, 0xaef}, {0xaf9, 0xaff}, {0xb01, 0xb03},
  {0xb05, 0xb0c}, {0xb0f, 0xb10}, {0xb13, 0xb28}, {0xb2a, 0xb30}, {0xb32, 0xb33}, {0xb35, 0xb39}, {0xb3c, 0xb44}, {0xb47, 0xb48},
  {0xb4b, 0xb4d}, {0xb55, 0xb57}, {0xb5c, 0xb5d}, {0xb5f, 0xb63}, {0xb66, 0xb6f}, {0xb71, 0xb71}, {0xb82, 0xb83}, {0xb85, 0xb8a},
  {0xb8e, 0xb90}, {0xb92, 0xb95}, {0xb99, 0xb9a}, {0xb9c, 0xb9c}, {0xb9e, 0xb9f}, {0xba3, 0xba4}, {0xba8, 0xbaa}, {0xbae, 0xbb9},
  {0xbbe, 0xbc2}, {0xbc6, 0xbc8}, {0xbca, 0xbcd}, {0xbd0, 0xbd0}, {0xbd7, 0xbd7}, {0xbe6, 0xbef}, {0xc00, 0xc0c}, {0xc0e, 0xc10},
  {0xc12, 0xc28}, {0xc2a, 0xc39}, {0xc3c, 0xc44}, {0xc46, 0xc48}, {0xc4a, 0xc4d}, {0xc55, 0xc56}, {0xc58, 0xc5a}, {0xc5d, 0xc5d},
  {0xc60, 0xc63}, {0xc66, 0xc6f}, {0xc80, 0xc83}, {0xc85, 0xc8c}, {0xc8e, 0xc90}, {0xc92, 0xca8}, {0xcaa, 0xcb3}, {0xcb5, 0xcb9},
  {0xcbc, 0xcc4}, {0xcc6, 0xcc8}, {0xcca, 0xccd}, {0xcd5, 0xcd6}, {0xcdd, 0xcde}, {0xce0, 0xce3}, {0xce6, 0xcef}, {0xcf1, 0xcf3},
  {0xd00, 0xd0c}, {0xd0e, 0xd10}, {0xd12, 0xd44}, {0xd46, 0xd48}, {0xd4a, 0xd4e}, {0xd54, 0xd57}, {0xd5f, 0xd63}, {0xd66, 0xd6f},
  {0xd7a, 0xd7f}, {0xd81, 0xd83}, {0xd85, 0xd96}, {0xd9a, 0xdb1}, {0xdb3, 0xdbb}, {0xdbd, 0xdbd}, {0xdc0, 0xdc6}, {0xdca, 0xdca},
  {0xdcf, 0xdd4}, {0xdd6, 0xdd6}, {0xdd8, 0xddf}, {0xde6, 0xdef}, {0xdf2, 0xdf3}, {0xe01, 0xe3a}, {0xe40, 0xe4e}, {0xe50, 0xe59},
  {0xe81, 0xe82}, {0xe84, 0xe84}, {0xe86, 0xe8a}, {0xe8c, 0xea3}, {0xea5, 0xea5}, {0xea7, 0xebd}, {0xec0, 0xec4}, {0xec6, 0xec6},
  {0xec8, 0xece}, {0xed0, 0xed9}, {0xedc, 0xedf}, {0xf00, 0xf00}, {0xf18, 0xf19}, {0xf20, 0xf29}, {0xf35, 0xf35}, {0xf37, 0xf37},
  {0xf39, 0xf39}, {0xf3e, 0xf47}, {0xf49, 0xf6c}, {0xf71, 0xf84}, {0xf86, 0xf97}, {0xf99, 0xfbc}, {0xfc6, 0xfc6}, {0x1000, 0x1049},
  {0x1050, 0x109d}, {0x10a0, 0x10c5}, {0x10c7, 0x10c7}, {0x10cd, 0x10cd}, {0x10d0, 0x10fa}, {0x10fc, 0x1248}, {0x124a, 0x124d}, {0x1250, 0x1256},
  {0x1258, 0x1258}, {0x125a, 0x125d}, {0x1260, 0x1288}, {0x128a, 0x128d}, {0x1290, 0x12b0}, {0x12b2, 0x12b5}, {0x12b8, 0x12be}, {0x12c0, 0x12c0},
  {0x12c2, 0x12c5}, {0x12c8, 0x12d6}, {0x12d8, 0x1310}, {0x1312, 0x1315}, {0x1318, 0x135a}, {0x135d, 0x135f}, {0x1369, 0x1371}, {0x1380, 0x138f},
  {0x13a0, 0x13f5}, {0x13f8, 0x13fd}, {0x1401, 0x166c}, {0x166f, 0x167f}, {0x1681, 0x169a}, {0x16a0, 0x16ea}, {0x16ee, 0x16f8}, {0x1700, 0x1715},
  {0x171f, 0x1734}, {0x1740, 0x1753}, {0x1760, 0x176c}, {0x176e, 0x1770}, {0x1772, 0x1773}, {0x1780, 0x17d3}, {0x17d7, 0x17d7}, {0x17dc, 0x17dd},
  {0x17e0, 0x17e9}, {0x180b, 0x180d}, {0x180f, 0x1819}, {0x1820, 0x1878}, {0x1880, 0x18aa}, {0x18b0, 0x18f5}, {0x1900, 0x191e}, {0x1920, 0x192b},
  {0x1930, 0x193b}, {0x1946, 0x196d}, {0x1970, 0x1974}, {0x1980, 0x19ab}, {0x19b0, 0x19c9}, {0x19d0, 0x19da}, {0x1a00, 0x1a1b}, {0x1a20, 0x1a5e},
  {0x1a60, 0x1a7c}, {0x1a7f, 0x1a89}, {0x1a90, 0x1a99}, {0x1aa7, 0x1aa7}, {0x1ab0, 0x1abd}, {0x1abf, 0x1ace}, {0x1b00, 0x1b4c}, {0x1b50, 0x1b59},
  {0x1b6b, 0x1b73}, {0x1b80, 0x1bf3}, {0x1c00, 0x1c37}, {0x1c40, 0x1c49}, {0x1c4d, 0x1c7d}, {0x1c80, 0x1c88}, {0x1c90, 0x1cba}, {0x1cbd, 0x1cbf},
  {0x1cd0, 0x1cd2}, {0x1cd4, 0x1cfa}, {0x1d00, 0x1f15}, {0x1f18, 0x1f1d}, {0x1f20, 0x1f45}, {0x1f48, 0x1f4d}, {0x1f50, 0x1f57}, {0x1f59, 0x1f59},
  {0x1f5b, 0x1f5b}, {0x1f5d, 0x1f5d}, {0x1f5f, 0x1f7d}, {0x1f80, 0x1fb4}, {0x1fb6, 0x1fbc}, {0x1fbe, 0x1fbe}, {0x1fc2, 0x1fc4}, {0x1fc6, 0x1fcc},
  {0x1fd0, 0x1fd3}, {0x1fd6, 0x1fdb}, {0x1fe0, 0x1fec}, {0x1ff2, 0x1ff4}, {0x1ff6, 0x1ffc}, {0x200c, 0x200d}, {0x203f, 0x2040}, {0x2054, 0x2054},
  {0x2071, 0x2071}, {0x207f, 0x207f}, {0x2090, 0x209c}, {0x20d0, 0x20dc}, {0x20e1, 0x20e1}, {0x20e5, 0x20f0}, {0x2102, 0x2102}, {0x2107, 0x2107},
  {0x210a, 0x2113}, {0x2115, 0x2115}, {0x2118, 0x211d}, {0x2124, 0x2124}, {0x2126, 0x2126}, {0x2128, 0x2128}, {0x212a, 0x2139}, {0x213c, 0x213f},
  {0x2145, 0x2149}, {0x214e, 0x214e}, {0x2160, 0x2188}, {0x2c00, 0x2ce4}, {0x2ceb, 0x2cf3}, {0x2d00, 0x2d25}, {0x2d27, 0x2d27}, {0x2d2d, 0x2d2d},
  {0x2d30, 0x2d67}, {0x2d6f, 0x2d6f}, {0x2d7f, 0x2d96}, {0x2da0, 0x2da6}, {0x2da8, 0x2dae}, {0x2db0, 0x2db6}, {0x2db8, 0x2dbe}, {0x2dc0, 0x2dc6},
  {0x2dc8, 0x2dce}, {0x2dd0, 0x2dd6}, {0x2dd8, 0x2dde}, {0x2de0, 0x2dff}, {0x3005, 0x3007}, {0x3021, 0x302f}, {0x3031, 0x3035}, {0x3038, 0x303c},
  {0x3041, 0x3096}, {0x3099, 0x309a}, {0x309d, 0x309f}, {0x30a1, 0x30ff}, {0x3105, 0x312f}, {0x3131, 0x318e}, {0x31a0, 0x31bf}, {0x31f0, 0x31ff},
  {0x3400, 0x4dbf}, {0x4e00, 0xa48c}, {0xa4d0, 0xa4fd}, {0xa500, 0xa60c}, {0xa610, 0xa62b}, {0xa640, 0xa66f}, {0xa674, 0xa67d}, {0xa67f, 0xa6f1},
  {0xa717, 0xa71f}, {0xa722, 0xa788}, {0xa78b, 0xa7ca}, {0xa7d0, 0xa7d1}, {0xa7d3, 0xa7d3}, {0xa7d5, 0xa7d9}, {0xa7f2, 0xa827}, {0xa82c, 0xa82c},
  {0xa840, 0xa873}, {0xa880, 0xa8c5}, {0xa8d0, 0xa8d9}, {0xa8e0, 0xa8f7}, {0xa8fb, 0xa8fb}, {0xa8fd, 0xa92d}, {0xa930, 0xa953}, {0xa960, 0xa97c},
  {0xa980, 0xa9c0}, {0xa9cf, 0xa9d9}, {0xa9e0, 0xa9fe}, {0xaa00, 0xaa36}, {0xaa40, 0xaa4d}, {0xaa50, 0xaa59}, {0xaa60, 0xaa76}, {0xaa7a, 0xaac2},
  {0xaadb, 0xaadd}, {0xaae0, 0xaaef}, {0xaaf2, 0xaaf6}, {0xab01, 0xab06}, {0xab09, 0xab0e}, {0xab11, 0xab16}, {0xab20, 0xab26}, {0xab28, 0xab2e},
  {0xab30, 0xab5a}, {0xab5c, 0xab69}, {0xab70, 0xabea}, {0xabec, 0xabed}, {0xabf0, 0xabf9}, {0xac00, 0xd7a3}, {0xd7b0, 0xd7c6}, {0xd7cb, 0xd7fb},
  {0xf900, 0xfa6d}, {0xfa70, 0xfad9}, {0xfb00, 0xfb06}, {0xfb13, 0xfb17}, {0xfb1d, 0xfb28}, {0xfb2a, 0xfb36}, {0xfb38, 0xfb3c}, {0xfb3e, 0xfb3e},
  {0xfb40, 0xfb41}, {0xfb43, 0xfb44}, {0xfb46, 0xfbb1}, {0xfbd3, 0xfc5d}, {0xfc64, 0xfd3d}, {0xfd50, 0xfd8f}, {0xfd92, 0xfdc7}, {0xfdf0, 0xfdf9},
  {0xfe00, 0xfe0f}, {0xfe20, 0xfe2f}, {0xfe33, 0xfe34}, {0xfe4d, 0xfe4f}, {0xfe71, 0xfe71}, {0xfe73, 0xfe73}, {0xfe77, 0xfe77}, {0xfe79, 0xfe79},
  {0xfe7b, 0xfe7b}, {0xfe7d, 0xfe7d}, {0xfe7f, 0xfefc}, {0xff10, 0xff19}, {0xff21, 0xff3a}, {0xff3f, 0xff3f}, {0xff41, 0xff5a}, {0xff65, 0xffbe},
  {0xffc2, 0xffc7}, {0xffca, 0xffcf}, {0xffd2, 0xffd7}, {0xffda, 0xffdc}, {0x10000, 0x1000b}, {0x1000d, 0x10026}, {0x10028, 0x1003a}, {0x1003c, 0x1003d},
  {0x1003f, 0x1004d}, {0x10050, 0x1005d}, {0x10080, 0x100fa}, {0x10140, 0x10174}, {0x101fd, 0x101fd}, {0x10280, 0x1029c}, {0x102a0, 0x102d0}, {0x102e0, 0x102e0},
  {0x10300, 0x1031f}, {0x1032d, 0x1034a}, {0x10350, 0x1037a}, {0x10380, 0x1039d}, {0x103a0, 0x103c3}, {0x103c8, 0x103cf}, {0x103d1, 0x103d5}, {0x10400, 0x1049d},
  {0x104a0, 0x104a9}, {0x104b0, 0x104d3}, {0x104d8, 0x104fb}, {0x10500, 0x10527}, {0x10530, 0x10563}, {0x10570, 0x1057a}, {0x1057c, 0x1058a}, {0x1058c, 0x10592},
  {0x10594, 0x10595}, {0x10597, 0x105a1}, {0x105a3, 0x105b1}, {0x105b3, 0x105b9}, {0x105bb, 0x105bc}, {0x10600, 0x10736}, {0x10740, 0x10755}, {0x10760, 0x10767},
  {0x10780, 0x10785}, {0x10787, 0x107b0}, {0x107b2, 0x107ba}, {0x10800, 0x10805}, {0x10808, 0x10808}, {0x1080a, 0x10835}, {0x10837, 0x10838}, {0x1083c, 0x1083c},
  {0x1083f, 0x10855}, {0x10860, 0x10876}, {0x10880, 0x1089e}, {0x108e0, 0x108f2}, {0x108f4, 0x108f5}, {0x10900, 0x10915}, {0x10920, 0x10939}, {0x10980, 0x109b7},
  {0x109be, 0x109bf}, {0x10a00, 0x10a03}, {0x10a05, 0x10a06}, {0x10a0c, 0x10a13}, {0x10a15, 0x10a17}, {0x10a19, 0x10a35}, {0x10a38, 0x10a3a}, {0x10a3f, 0x10a3f},
  {0x10a60, 0x10a7c}, {0x10a80, 0x10a9c}, {0x10ac0, 0x10ac7}, {0x10ac9, 0x10ae6}, {0x10b00, 0x10b35}, {0x10b40, 0x10b55}, {0x10b60, 0x10b72}, {0x10b80, 0x10b91},
  {0x10c00, 0x10c48}, {0x10c80, 0x10cb2}, {0x10cc0, 0x10cf2}, {0x10d00, 0x10d27}, {0x10d30, 0x10d39}, {0x10e80, 0x10ea9}, {0x10eab, 0x10eac}, {0x10eb0, 0x10eb1},
  {0x10efd, 0x10f1c}, {0x10f27, 0x10f27}, {0x10f30, 0x10f50}, {0x10f70, 0x10f85}, {0x10fb0, 0x10fc4}, {0x10fe0, 0x10ff6}, {0x11000, 0x11046}, {0x11066, 0x11075},
  {0x1107f, 0x110ba}, {0x110c2, 0x110c2}, {0x110d0, 0x110e8}, {0x110f0, 0x110f9}, {0x11100, 0x11134}, {0x11136, 0x1113f}, {0x11144, 0x11147}, {0x11150, 0x11173},
  {0x11176, 0x11176}, {0x11180, 0x111c4}, {0x111c9, 0x111cc}, {0x111ce, 0x111da}, {0x111dc, 0x111dc}, {0x11200, 0x11211}, {0x11213, 0x11237}, {0x1123e, 0x11241},
  {0x11280, 0x11286}, {0x11288, 0x11288}, {0x1128a, 0x1128d}, {0x1128f, 0x1129d}, {0x1129f, 0x112a8}, {0x112b0, 0x112ea}, {0x112f0, 0x112f9}, {0x11300, 0x11303},
  {0x11305, 0x1130c}, {0x1130f, 0x11310}, {0x11313, 0x11328}, {0x1132a, 0x11330}, {0x11332, 0x11333}, {0x11335, 0x11339}, {0x1133b, 0x11344}, {0x11347, 0x11348},
  {0x1134b, 0x1134d}, {0x11350, 0x11350}, {0x11357, 0x11357}, {0x1135d, 0x11363}, {0x11366, 0x1136c}, {0x11370, 0x11374}, {0x11400, 0x1144a}, {0x11450, 0x11459},
  {0x1145e, 0x11461}, {0x11480, 0x114c5}, {0x114c7, 0x114c7}, {0x114d0, 0x114d9}, {0x11580, 0x115b5}, {0x115b8, 0x115c0}, {0x115d8, 0x115dd}, {0x11600, 0x11640},
  {0x11644, 0x11644}, {0x11650, 0x11659}, {0x11680, 0x116b8}, {0x116c0, 0x116c9}, {0x11700, 0x1171a}, {0x1171d, 0x1172b}, {0x11730, 0x11739}, {0x11740, 0x11746},
  {0x11800, 0x1183a}, {0x118a0, 0x118e9}, {0x118ff, 0x11906}, {0x11909, 0x11909}, {0x1190c, 0x11913}, {0x11915, 0x11916}, {0x11918, 0x11935}, {0x11937, 0x11938},
  {0x1193b, 0x11943}, {0x11950, 0x11959}, {0x119a0, 0x119a7}, {0x119aa, 0x119d7}, {0x119da, 0x119e1}, {0x119e3, 0x119e4}, {0x11a00, 0x11a3e}, {0x11a47, 0x11a47},
  {0x11a50, 0x11a99}, {0x11a9d, 0x11a9d}, {0x11ab0, 0x11af8}, {0x11c00, 0x11c08}, {0x11c0a, 0x11c36}, {0x11c38, 0x11c40}, {0x11c50, 0x11c59}, {0x11c72, 0x11c8f},
  {0x11c92, 0x11ca7}, {0x11ca9, 0x11cb6}, {0x11d00, 0x11d06}, {0x11d08, 0x11d09}, {0x11d0b, 0x11d36}, {0x11d3a, 0x11d3a}, {0x11d3c, 0x11d3d}, {0x11d3f, 0x11d47},
  {0x11d50, 0x11d59}, {0x11d60, 0x11d65}, {0x11d67, 0x11d68}, {0x11d6a, 0x11d8e}, {0x11d90, 0x11d91}, {0x11d93, 0x11d98}, {0x11da0, 0x11da9}, {0x11ee0, 0x11ef6},
  {0x11f00, 0x11f10}, {0x11f12, 0x11f3a}, {0x11f3e, 0x11f42}, {0x11f50, 0x11f59}, {0x11fb0, 0x11fb0}, {0x12000, 0x12399}, {0x12400, 0x1246e}, {0x12480, 0x12543},
  {0x12f90, 0x12ff0}, {0x13000, 0x1342f}, {0x13440, 0x13455}, {0x14400, 0x14646}, {0x16800, 0x16a38}, {0x16a40, 0x16a5e}, {0x16a60, 0x16a69}, {0x16a70, 0x16abe},
  {0x16ac0, 0x16ac9}, {0x16ad0, 0x16aed}, {0x16af0, 0x16af4}, {0x16b00, 0x16b36}, {0x16b40, 0x16b43}, {0x16b50, 0x16b59}, {0x16b63, 0x16b77}, {0x16b7d, 0x16b8f},
  {0x16e40, 0x16e7f}, {0x16f00, 0x16f4a}, {0x16f4f, 0x16f87}, {0x16f8f, 0x16f9f}, {0x16fe0, 0x16fe1}, {0x16fe3, 0x16fe4}, {0x16ff0, 0x16ff1}, {0x17000, 0x187f7},
  {0x18800, 0x18cd5}, {0x18d00, 0x18d08}, {0x1aff0, 0x1aff3}, {0x1aff5, 0x1affb}, {0x1affd, 0x1affe}, {0x1b000, 0x1b122}, {0x1b132, 0x1b132}, {0x1b150, 0x1b152},
  {0x1b155, 0x1b155}, {0x1b164, 0x1b167}, {0x1b170, 0x1b2fb}, {0x1bc00, 0x1bc6a}, {0x1bc70, 0x1bc7c}, {0x1bc80, 0x1bc88}, {0x1bc90, 0x1bc99}, {0x1bc9d, 0x1bc9e},
  {0x1cf00, 0x1cf2d}, {0x1cf30, 0x1cf46}, {0x1d165, 0x1d169}, {0x1d16d, 0x1d172}, {0x1d17b, 0x1d182}, {0x1d185, 0x1d18b}, {0x1d1aa, 0x1d1ad}, {0x1d242, 0x1d244},
  {0x1d400, 0x1d454}, {0x1d456, 0x1d49c}, {0x1d49e, 0x1d49f}, {0x1d4a2, 0x1d4a2}, {0x1d4a5, 0x1d4a6}, {0x1d4a9, 0x1d4ac}, {0x1d4ae, 0x1d4b9}, {0x1d4bb, 0x1d4bb},
  {0x1d4bd, 0x1d4c3}, {0x1d4c5, 0x1d505}, {0x1d507, 0x1d50a}, {0x1d50d, 0x1d514}, {0x1d516, 0x1d51c}, {0x1d51e, 0x1d539}, {0x1d53b, 0x1d53e}, {0x1d540, 0x1d544},
  {0x1d546, 0x1d546}, {0x1d54a, 0x1d550}, {0x1d552, 0x1d6a5}, {0x1d6a8, 0x1d6c0}, {0x1d6c2, 0x1d6da}, {0x1d6dc, 0x1d6fa}, {0x1d6fc, 0x1d714}, {0x1d716, 0x1d734},
  {0x1d736, 0x1d74e}, {0x1d750, 0x1d76e}, {0x1d770, 0x1d788}, {0x1d78a, 0x1d7a8}, {0x1d7aa, 0x1d7c2}, {0x1d7c4, 0x1d7cb}, {0x1d7ce, 0x1d7ff}, {0x1da00, 0x1da36},
  {0x1da3b, 0x1da6c}, {0x1da75, 0x1da75}, {0x1da84, 0x1da84}, {0x1da9b, 0x1da9f}, {0x1daa1, 0x1daaf}, {0x1df00, 0x1df1e}, {0x1df25, 0x1df2a}, {0x1e000, 0x1e006},
  {0x1e008, 0x1e018}, {0x1e01b, 0x1e021}, {0x1e023, 0x1e024}, {0x1e026, 0x1e02a}, {0x1e030, 0x1e06d}, {0x1e08f, 0x1e08f}, {0x1e100, 0x1e12c}, {0x1e130, 0x1e13d},
  {0x1e140, 0x1e149}, {0x1e14e, 0x1e14e}, {0x1e290, 0x1e2ae}, {0x1e2c0, 0x1e2f9}, {0x1e4d0, 0x1e4f9}, {0x1e7e0, 0x1e7e6}, {0x1e7e8, 0x1e7eb}, {0x1e7ed, 0x1e7ee},
  {0x1e7f0, 0x1e7fe}, {0x1e800, 0x1e8c4}, {0x1e8d0, 0x1e8d6}, {0x1e900, 0x1e94b}, {0x1e950, 0x1e959}, {0x1ee00, 0x1ee03}, {0x1ee05, 0x1ee1f}, {0x1ee21, 0x1ee22},
  {0x1ee24, 0x1ee24}, {0x1ee27, 0x1ee27}, {0x1ee29, 0x1ee32}, {0x1ee34, 0x1ee37}, {0x1ee39, 0x1ee39}, {0x1ee3b, 0x1ee3b}, {0x1ee42, 0x1ee42}, {0x1ee47, 0x1ee47},
  {0x1ee49, 0x1ee49}, {0x1ee4b, 0x1ee4b}, {0x1ee4d, 0x1ee4f}, {0x1ee51, 0x1ee52}, {0x1ee54, 0x1ee54}, {0x1ee57, 0x1ee57}, {0x1ee59, 0x1ee59}, {0x1ee5b, 0x1ee5b},
  {0x1ee5d, 0x1ee5d}, {0x1ee5f, 0x1ee5f}, {0x1ee61, 0x1ee62}, {0x1ee64, 0x1ee64}, {0x1ee67, 0x1ee6a}, {0x1ee6c, 0x1ee72}, {0x1ee74, 0x1ee77}, {0x1ee79, 0x1ee7c},
  {0x1ee7e, 0x1ee7e}, {0x1ee80, 0x1ee89}, {0x1ee8b, 0x1ee9b}, {0x1eea1, 0x1eea3}, {0x1eea5, 0x1eea9}, {0x1eeab, 0x1eebb}, {0x1fbf0, 0x1fbf9}, {0x20000, 0x2a6df},
  {0x2a700, 0x2b739}, {0x2b740, 0x2b81d}, {0x2b820, 0x2cea1}, {0x2ceb0, 0x2ebe0}, {0x2ebf0, 0x2ee5d}, {0x2f800, 0x2fa1d}, {0x30000, 0x3134a}, {0x31350, 0x323af},
  {0xe0100, 0xe01ef},
};

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (eof) ADVANCE(350);
      ADVANCE_MAP(
        '!', 486,
        '"', 462,
        '#', 438,
        '$', 506,
        '%', 480,
        '&', 381,
        '\'', 440,
        '(', 427,
        ')', 369,
        '*', 431,
        '+', 488,
        ',', 370,
        '-', 488,
        '.', 551,
        '/', 219,
        '0', 508,
        ':', 356,
        '<', 419,
        '=', 441,
        '>', 420,
        '?', 372,
        '@', 148,
        'L', 540,
        'M', 549,
        'U', 568,
        '[', 383,
        '\\', 2,
        ']', 387,
        '^', 439,
        '`', 231,
        'a', 586,
        'd', 584,
        'f', 544,
        'i', 581,
        'l', 528,
        'm', 548,
        'n', 536,
        'r', 576,
        's', 523,
        'u', 531,
        'w', 577,
        'y', 518,
        '{', 451,
        '|', 378,
        '}', 392,
        '~', 484,
        'E', 556,
        'e', 556,
        'G', 546,
        'I', 546,
        'N', 546,
        'Q', 546,
        'R', 546,
        'Z', 546,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(509);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          (' ' <= lookahead && lookahead <= ';') ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(343);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(592);
      END_STATE();
    case 1:
      if (lookahead == '\n') ADVANCE(597);
      if (lookahead == '#') ADVANCE(602);
      if (lookahead == '(') ADVANCE(215);
      if (lookahead == '/') ADVANCE(219);
      if (lookahead == '\\') SKIP(48);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(1);
      END_STATE();
    case 2:
      if (lookahead == '\r') SKIP(249);
      if (lookahead == 'n') SKIP(63);
      if (lookahead == 'u') ADVANCE(337);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(325);
      END_STATE();
    case 3:
      ADVANCE_MAP(
        '\r', 443,
        'n', 442,
        'u', 443,
        '"', 442,
        '\'', 442,
        'a', 442,
        'b', 442,
        'f', 442,
        'r', 442,
        't', 442,
        'v', 442,
      );
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(443);
      if (lookahead != 0) ADVANCE(443);
      END_STATE();
    case 4:
      if (lookahead == '\r') SKIP(283);
      if (lookahead == 'n') SKIP(73);
      END_STATE();
    case 5:
      if (lookahead == '\r') SKIP(284);
      if (lookahead == 'n') SKIP(137);
      END_STATE();
    case 6:
      if (lookahead == '\r') SKIP(285);
      if (lookahead == 'n') SKIP(144);
      END_STATE();
    case 7:
      if (lookahead == '\r') SKIP(294);
      if (lookahead == 'n') SKIP(140);
      END_STATE();
    case 8:
      if (lookahead == '\r') SKIP(299);
      if (lookahead == 'n') SKIP(141);
      END_STATE();
    case 9:
      if (lookahead == '\r') SKIP(286);
      if (lookahead == 'n') SKIP(136);
      END_STATE();
    case 10:
      if (lookahead == '\r') SKIP(251);
      if (lookahead == 'n') SKIP(156);
      END_STATE();
    case 11:
      if (lookahead == '\r') SKIP(252);
      if (lookahead == 'n') SKIP(157);
      END_STATE();
    case 12:
      if (lookahead == '\r') SKIP(287);
      if (lookahead == 'n') SKIP(72);
      END_STATE();
    case 13:
      if (lookahead == '\r') SKIP(291);
      if (lookahead == 'n') SKIP(130);
      END_STATE();
    case 14:
      if (lookahead == '\r') SKIP(253);
      if (lookahead == 'n') SKIP(126);
      END_STATE();
    case 15:
      if (lookahead == '\r') SKIP(292);
      if (lookahead == 'n') SKIP(128);
      END_STATE();
    case 16:
      if (lookahead == '\r') SKIP(288);
      if (lookahead == 'n') SKIP(122);
      END_STATE();
    case 17:
      if (lookahead == '\r') SKIP(289);
      if (lookahead == 'n') SKIP(123);
      END_STATE();
    case 18:
      if (lookahead == '\r') SKIP(290);
      if (lookahead == 'n') SKIP(121);
      END_STATE();
    case 19:
      if (lookahead == '\r') SKIP(295);
      if (lookahead == 'n') SKIP(124);
      END_STATE();
    case 20:
      if (lookahead == '\r') SKIP(300);
      if (lookahead == 'n') SKIP(125);
      END_STATE();
    case 21:
      if (lookahead == '\r') SKIP(297);
      if (lookahead == 'n') SKIP(131);
      END_STATE();
    case 22:
      if (lookahead == '\r') SKIP(254);
      if (lookahead == 'n') SKIP(185);
      END_STATE();
    case 23:
      if (lookahead == '\r') SKIP(255);
      if (lookahead == 'n') SKIP(165);
      END_STATE();
    case 24:
      if (lookahead == '\r') SKIP(298);
      if (lookahead == 'n') SKIP(129);
      END_STATE();
    case 25:
      if (lookahead == '\r') SKIP(256);
      if (lookahead == 'n') SKIP(173);
      END_STATE();
    case 26:
      if (lookahead == '\r') SKIP(257);
      if (lookahead == 'n') SKIP(179);
      END_STATE();
    case 27:
      if (lookahead == '\r') SKIP(258);
      if (lookahead == 'n') SKIP(162);
      END_STATE();
    case 28:
      if (lookahead == '\r') SKIP(259);
      if (lookahead == 'n') SKIP(155);
      END_STATE();
    case 29:
      if (lookahead == '\r') SKIP(260);
      if (lookahead == 'n') SKIP(170);
      END_STATE();
    case 30:
      if (lookahead == '\r') SKIP(261);
      if (lookahead == 'n') SKIP(178);
      END_STATE();
    case 31:
      if (lookahead == '\r') SKIP(262);
      if (lookahead == 'n') SKIP(184);
      END_STATE();
    case 32:
      if (lookahead == '\r') SKIP(263);
      if (lookahead == 'n') SKIP(163);
      END_STATE();
    case 33:
      if (lookahead == '\r') SKIP(264);
      if (lookahead == 'n') SKIP(164);
      END_STATE();
    case 34:
      if (lookahead == '\r') SKIP(265);
      if (lookahead == 'n') SKIP(171);
      END_STATE();
    case 35:
      if (lookahead == '\r') SKIP(266);
      if (lookahead == 'n') SKIP(172);
      END_STATE();
    case 36:
      if (lookahead == '\r') SKIP(267);
      if (lookahead == 'n') SKIP(187);
      END_STATE();
    case 37:
      if (lookahead == '\r') SKIP(268);
      if (lookahead == 'n') SKIP(198);
      END_STATE();
    case 38:
      if (lookahead == '\r') SKIP(269);
      if (lookahead == 'n') SKIP(191);
      END_STATE();
    case 39:
      if (lookahead == '\r') SKIP(270);
      if (lookahead == 'n') SKIP(150);
      END_STATE();
    case 40:
      if (lookahead == '\r') SKIP(273);
      if (lookahead == 'n') SKIP(202);
      END_STATE();
    case 41:
      if (lookahead == '\r') SKIP(274);
      if (lookahead == 'n') SKIP(205);
      END_STATE();
    case 42:
      if (lookahead == '\r') SKIP(275);
      if (lookahead == 'n') SKIP(199);
      END_STATE();
    case 43:
      if (lookahead == '\r') SKIP(276);
      if (lookahead == 'n') SKIP(200);
      END_STATE();
    case 44:
      if (lookahead == '\r') SKIP(277);
      if (lookahead == 'n') SKIP(206);
      END_STATE();
    case 45:
      if (lookahead == '\r') SKIP(278);
      if (lookahead == 'n') SKIP(151);
      if (lookahead == 'u') ADVANCE(337);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(325);
      END_STATE();
    case 46:
      if (lookahead == '\r') SKIP(279);
      if (lookahead == 'n') SKIP(203);
      END_STATE();
    case 47:
      if (lookahead == '\r') SKIP(280);
      if (lookahead == 'n') SKIP(207);
      END_STATE();
    case 48:
      if (lookahead == '\r') SKIP(281);
      if (lookahead == 'n') SKIP(1);
      END_STATE();
    case 49:
      if (lookahead == '\r') SKIP(293);
      if (lookahead == 'n') SKIP(76);
      END_STATE();
    case 50:
      if (lookahead == '\r') SKIP(302);
      if (lookahead == 'n') SKIP(143);
      END_STATE();
    case 51:
      if (lookahead == '\r') SKIP(296);
      if (lookahead == 'n') SKIP(75);
      END_STATE();
    case 52:
      if (lookahead == '\r') SKIP(303);
      if (lookahead == 'n') SKIP(138);
      END_STATE();
    case 53:
      if (lookahead == '\r') SKIP(301);
      if (lookahead == 'n') SKIP(74);
      END_STATE();
    case 54:
      if (lookahead == '\r') SKIP(304);
      if (lookahead == 'n') SKIP(134);
      END_STATE();
    case 55:
      if (lookahead == '\r') SKIP(305);
      if (lookahead == 'n') SKIP(132);
      END_STATE();
    case 56:
      if (lookahead == '\r') SKIP(306);
      if (lookahead == 'n') SKIP(142);
      END_STATE();
    case 57:
      if (lookahead == '\r') SKIP(307);
      if (lookahead == 'n') SKIP(127);
      END_STATE();
    case 58:
      if (lookahead == '\r') SKIP(308);
      if (lookahead == 'n') SKIP(145);
      END_STATE();
    case 59:
      if (lookahead == '\r') SKIP(309);
      if (lookahead == 'n') SKIP(133);
      END_STATE();
    case 60:
      if (lookahead == '\r') SKIP(310);
      if (lookahead == 'n') SKIP(135);
      END_STATE();
    case 61:
      if (lookahead == '\r') SKIP(311);
      if (lookahead == 'n') SKIP(139);
      END_STATE();
    case 62:
      if (lookahead == ' ') ADVANCE(212);
      if (lookahead == ')') ADVANCE(469);
      if (('\t' <= lookahead && lookahead <= '\r')) ADVANCE(213);
      if (lookahead == '!' ||
          lookahead == '%' ||
          lookahead == '&' ||
          ('*' <= lookahead && lookahead <= '/') ||
          ('<' <= lookahead && lookahead <= '@') ||
          lookahead == '^' ||
          lookahead == '|' ||
          lookahead == '~') ADVANCE(214);
      END_STATE();
    case 63:
      ADVANCE_MAP(
        '!', 486,
        '"', 453,
        '#', 438,
        '$', 506,
        '%', 480,
        '&', 381,
        '\'', 440,
        '(', 366,
        ')', 369,
        '*', 430,
        '+', 470,
        ',', 370,
        '-', 472,
        '.', 402,
        '/', 219,
        '0', 508,
        ':', 356,
        '<', 434,
        '=', 441,
        '>', 420,
        '?', 372,
        '@', 148,
        '[', 383,
        '\\', 2,
        ']', 387,
        '^', 439,
        '`', 231,
        'a', 586,
        'd', 584,
        'i', 581,
        'l', 572,
        'm', 569,
        'r', 576,
        'u', 587,
        'w', 577,
        'y', 579,
        '{', 391,
        '|', 378,
        '}', 392,
        '~', 484,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(509);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          (' ' <= lookahead && lookahead <= ';') ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(63);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(592);
      END_STATE();
    case 64:
      ADVANCE_MAP(
        '!', 486,
        '"', 454,
        '#', 599,
        '$', 506,
        '%', 481,
        '&', 382,
        '\'', 492,
        '(', 427,
        '*', 432,
        '+', 488,
        ',', 370,
        '-', 488,
        '.', 402,
        '/', 495,
        '0', 508,
        ':', 356,
        '<', 419,
        '=', 351,
        '>', 498,
        '?', 372,
        '@', 491,
        '[', 383,
      );
      if (lookahead == '\\') SKIP(12);
      if (lookahead == ']') ADVANCE(387);
      if (lookahead == '^') ADVANCE(500);
      if (lookahead == '`') ADVANCE(231);
      if (lookahead == 'd') ADVANCE(584);
      if (lookahead == 'l') ADVANCE(572);
      if (lookahead == 'm') ADVANCE(569);
      if (lookahead == 'r') ADVANCE(576);
      if (lookahead == 'u') ADVANCE(587);
      if (lookahead == 'y') ADVANCE(579);
      if (lookahead == '{') ADVANCE(391);
      if (lookahead == '|') ADVANCE(499);
      if (lookahead == '}') ADVANCE(392);
      if (lookahead == '~') ADVANCE(484);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(509);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(72);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(592);
      END_STATE();
    case 65:
      ADVANCE_MAP(
        '!', 486,
        '"', 454,
        '#', 599,
        '$', 506,
        '%', 481,
        '&', 382,
        '\'', 492,
        '(', 427,
        '+', 488,
        ',', 370,
        '-', 488,
        '.', 402,
        '/', 495,
        '0', 508,
        ':', 356,
        '<', 419,
        '=', 351,
        '>', 498,
        '?', 372,
        '@', 491,
        'L', 540,
        'U', 568,
        '[', 384,
      );
      if (lookahead == '\\') SKIP(4);
      if (lookahead == ']') ADVANCE(387);
      if (lookahead == '`') ADVANCE(231);
      if (lookahead == 'd') ADVANCE(584);
      if (lookahead == 'l') ADVANCE(528);
      if (lookahead == 'm') ADVANCE(569);
      if (lookahead == 'n') ADVANCE(536);
      if (lookahead == 'r') ADVANCE(576);
      if (lookahead == 's') ADVANCE(523);
      if (lookahead == 'u') ADVANCE(531);
      if (lookahead == 'y') ADVANCE(518);
      if (lookahead == '{') ADVANCE(391);
      if (lookahead == '|') ADVANCE(499);
      if (lookahead == '}') ADVANCE(392);
      if (lookahead == '~') ADVANCE(484);
      if (lookahead == '*' ||
          lookahead == '^') ADVANCE(500);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(509);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(73);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(592);
      END_STATE();
    case 66:
      ADVANCE_MAP(
        '!', 486,
        '"', 454,
        '#', 599,
        '$', 506,
        '%', 481,
        '&', 382,
        '\'', 492,
        '(', 427,
        '+', 488,
        ',', 370,
        '-', 488,
        '.', 402,
        '/', 495,
        '0', 508,
        ':', 356,
        '<', 419,
        '=', 351,
        '>', 498,
        '?', 372,
        '@', 491,
        'M', 549,
        '[', 384,
      );
      if (lookahead == '\\') SKIP(4);
      if (lookahead == ']') ADVANCE(387);
      if (lookahead == '`') ADVANCE(231);
      if (lookahead == 'd') ADVANCE(584);
      if (lookahead == 'f') ADVANCE(544);
      if (lookahead == 'l') ADVANCE(572);
      if (lookahead == 'm') ADVANCE(548);
      if (lookahead == 'r') ADVANCE(576);
      if (lookahead == 'u') ADVANCE(587);
      if (lookahead == 'y') ADVANCE(579);
      if (lookahead == '{') ADVANCE(391);
      if (lookahead == '|') ADVANCE(499);
      if (lookahead == '}') ADVANCE(392);
      if (lookahead == '~') ADVANCE(484);
      if (lookahead == '*' ||
          lookahead == '^') ADVANCE(500);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(556);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(509);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(73);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(592);
      END_STATE();
    case 67:
      ADVANCE_MAP(
        '!', 486,
        '"', 454,
        '#', 599,
        '$', 506,
        '%', 481,
        '&', 382,
        '\'', 492,
        '(', 427,
        '+', 488,
        ',', 370,
        '-', 488,
        '.', 402,
        '/', 495,
        '0', 508,
        ':', 356,
        '<', 419,
        '=', 351,
        '>', 498,
        '?', 372,
        '@', 491,
        'M', 549,
        '[', 384,
      );
      if (lookahead == '\\') SKIP(4);
      if (lookahead == ']') ADVANCE(387);
      if (lookahead == '`') ADVANCE(231);
      if (lookahead == 'd') ADVANCE(584);
      if (lookahead == 'f') ADVANCE(544);
      if (lookahead == 'l') ADVANCE(572);
      if (lookahead == 'm') ADVANCE(548);
      if (lookahead == 'r') ADVANCE(576);
      if (lookahead == 'u') ADVANCE(587);
      if (lookahead == 'y') ADVANCE(579);
      if (lookahead == '{') ADVANCE(391);
      if (lookahead == '|') ADVANCE(499);
      if (lookahead == '}') ADVANCE(392);
      if (lookahead == '~') ADVANCE(484);
      if (lookahead == '*' ||
          lookahead == '^') ADVANCE(500);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(509);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(73);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(592);
      END_STATE();
    case 68:
      ADVANCE_MAP(
        '!', 486,
        '"', 454,
        '#', 599,
        '$', 506,
        '%', 481,
        '&', 382,
        '\'', 492,
        '(', 427,
        '+', 488,
        ',', 370,
        '-', 488,
        '.', 402,
        '/', 495,
        '0', 508,
        ':', 356,
        '<', 419,
        '=', 351,
        '>', 498,
        '?', 372,
        '@', 491,
        '[', 384,
      );
      if (lookahead == '\\') SKIP(4);
      if (lookahead == ']') ADVANCE(387);
      if (lookahead == '`') ADVANCE(231);
      if (lookahead == 'd') ADVANCE(584);
      if (lookahead == 'l') ADVANCE(572);
      if (lookahead == 'm') ADVANCE(569);
      if (lookahead == 'r') ADVANCE(576);
      if (lookahead == 'u') ADVANCE(587);
      if (lookahead == 'y') ADVANCE(579);
      if (lookahead == '{') ADVANCE(391);
      if (lookahead == '|') ADVANCE(499);
      if (lookahead == '}') ADVANCE(392);
      if (lookahead == '~') ADVANCE(484);
      if (lookahead == '*' ||
          lookahead == '^') ADVANCE(500);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(509);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(73);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(592);
      END_STATE();
    case 69:
      ADVANCE_MAP(
        '!', 486,
        '"', 454,
        '#', 599,
        '$', 506,
        '%', 481,
        '&', 382,
        '\'', 492,
        '(', 427,
        '+', 488,
        ',', 370,
        '-', 488,
        '.', 402,
        '/', 495,
        '0', 508,
        ':', 356,
        '<', 419,
        '=', 351,
        '>', 498,
        '?', 372,
        '@', 491,
        '[', 384,
      );
      if (lookahead == '\\') SKIP(53);
      if (lookahead == ']') ADVANCE(387);
      if (lookahead == '`') ADVANCE(231);
      if (lookahead == 'd') ADVANCE(584);
      if (lookahead == 'l') ADVANCE(572);
      if (lookahead == 'm') ADVANCE(569);
      if (lookahead == 'r') ADVANCE(576);
      if (lookahead == 'u') ADVANCE(587);
      if (lookahead == 'y') ADVANCE(579);
      if (lookahead == '{') ADVANCE(391);
      if (lookahead == '|') ADVANCE(379);
      if (lookahead == '}') ADVANCE(392);
      if (lookahead == '~') ADVANCE(484);
      if (lookahead == '*' ||
          lookahead == '^') ADVANCE(500);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(509);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(74);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(592);
      END_STATE();
    case 70:
      ADVANCE_MAP(
        '!', 486,
        '"', 454,
        '#', 599,
        '$', 506,
        '%', 481,
        '&', 382,
        '\'', 492,
        '(', 427,
        '+', 488,
        ',', 370,
        '-', 488,
        '.', 553,
        '/', 495,
        '0', 508,
        ':', 356,
        '<', 419,
        '=', 351,
        '>', 498,
        '?', 372,
        '@', 491,
        'L', 540,
        'M', 549,
        'U', 568,
        '[', 384,
      );
      if (lookahead == '\\') SKIP(51);
      if (lookahead == ']') ADVANCE(387);
      if (lookahead == '`') ADVANCE(231);
      if (lookahead == 'd') ADVANCE(584);
      if (lookahead == 'l') ADVANCE(528);
      if (lookahead == 'm') ADVANCE(548);
      if (lookahead == 'n') ADVANCE(536);
      if (lookahead == 'r') ADVANCE(576);
      if (lookahead == 's') ADVANCE(523);
      if (lookahead == 'u') ADVANCE(531);
      if (lookahead == 'y') ADVANCE(518);
      if (lookahead == '{') ADVANCE(391);
      if (lookahead == '|') ADVANCE(499);
      if (lookahead == '}') ADVANCE(392);
      if (lookahead == '~') ADVANCE(484);
      if (lookahead == '*' ||
          lookahead == '^') ADVANCE(500);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(556);
      if (lookahead == 'G' ||
          lookahead == 'I' ||
          lookahead == 'N' ||
          lookahead == 'Q' ||
          lookahead == 'R' ||
          lookahead == 'Z') ADVANCE(546);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(509);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(75);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(592);
      END_STATE();
    case 71:
      ADVANCE_MAP(
        '!', 486,
        '"', 454,
        '#', 599,
        '$', 506,
        '%', 481,
        '&', 382,
        '\'', 492,
        '(', 427,
        '+', 488,
        ',', 370,
        '-', 488,
        '.', 403,
        '/', 495,
        '0', 508,
        ':', 356,
        '<', 419,
        '=', 351,
        '>', 498,
        '?', 372,
        '@', 491,
        '[', 384,
      );
      if (lookahead == '\\') SKIP(49);
      if (lookahead == ']') ADVANCE(387);
      if (lookahead == '`') ADVANCE(231);
      if (lookahead == 'd') ADVANCE(584);
      if (lookahead == 'l') ADVANCE(572);
      if (lookahead == 'm') ADVANCE(569);
      if (lookahead == 'r') ADVANCE(576);
      if (lookahead == 'u') ADVANCE(587);
      if (lookahead == 'y') ADVANCE(579);
      if (lookahead == '{') ADVANCE(391);
      if (lookahead == '|') ADVANCE(499);
      if (lookahead == '}') ADVANCE(392);
      if (lookahead == '~') ADVANCE(484);
      if (lookahead == '*' ||
          lookahead == '^') ADVANCE(500);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(509);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(76);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(592);
      END_STATE();
    case 72:
      ADVANCE_MAP(
        '!', 486,
        '"', 454,
        '#', 599,
        '$', 506,
        '%', 481,
        '&', 382,
        '\'', 492,
        '(', 366,
        '*', 432,
        '+', 471,
        ',', 370,
        '-', 474,
        '.', 402,
        '/', 495,
        '0', 508,
        ':', 356,
        '<', 435,
        '=', 351,
        '>', 498,
        '?', 372,
        '@', 491,
        '[', 383,
      );
      if (lookahead == '\\') SKIP(12);
      if (lookahead == ']') ADVANCE(387);
      if (lookahead == '^') ADVANCE(500);
      if (lookahead == '`') ADVANCE(231);
      if (lookahead == 'd') ADVANCE(584);
      if (lookahead == 'l') ADVANCE(572);
      if (lookahead == 'm') ADVANCE(569);
      if (lookahead == 'r') ADVANCE(576);
      if (lookahead == 'u') ADVANCE(587);
      if (lookahead == 'y') ADVANCE(579);
      if (lookahead == '{') ADVANCE(391);
      if (lookahead == '|') ADVANCE(499);
      if (lookahead == '}') ADVANCE(392);
      if (lookahead == '~') ADVANCE(484);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(509);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(72);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(592);
      END_STATE();
    case 73:
      ADVANCE_MAP(
        '!', 486,
        '"', 454,
        '#', 599,
        '$', 506,
        '%', 481,
        '&', 382,
        '\'', 492,
        '(', 366,
        '+', 471,
        ',', 370,
        '-', 475,
        '.', 402,
        '/', 495,
        '0', 508,
        ':', 356,
        '<', 494,
        '=', 351,
        '>', 498,
        '?', 372,
        '@', 491,
        '[', 384,
      );
      if (lookahead == '\\') SKIP(4);
      if (lookahead == ']') ADVANCE(387);
      if (lookahead == '`') ADVANCE(231);
      if (lookahead == 'd') ADVANCE(584);
      if (lookahead == 'l') ADVANCE(572);
      if (lookahead == 'm') ADVANCE(569);
      if (lookahead == 'r') ADVANCE(576);
      if (lookahead == 'u') ADVANCE(587);
      if (lookahead == 'y') ADVANCE(579);
      if (lookahead == '{') ADVANCE(391);
      if (lookahead == '|') ADVANCE(499);
      if (lookahead == '}') ADVANCE(392);
      if (lookahead == '~') ADVANCE(484);
      if (lookahead == '*' ||
          lookahead == '^') ADVANCE(500);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(509);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(73);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(592);
      END_STATE();
    case 74:
      ADVANCE_MAP(
        '!', 486,
        '"', 454,
        '#', 599,
        '$', 506,
        '%', 481,
        '&', 382,
        '\'', 492,
        '(', 366,
        '+', 471,
        ',', 370,
        '-', 475,
        '.', 402,
        '/', 495,
        '0', 508,
        ':', 356,
        '<', 494,
        '=', 351,
        '>', 498,
        '?', 372,
        '@', 491,
        '[', 384,
      );
      if (lookahead == '\\') SKIP(53);
      if (lookahead == ']') ADVANCE(387);
      if (lookahead == '`') ADVANCE(231);
      if (lookahead == 'd') ADVANCE(584);
      if (lookahead == 'l') ADVANCE(572);
      if (lookahead == 'm') ADVANCE(569);
      if (lookahead == 'r') ADVANCE(576);
      if (lookahead == 'u') ADVANCE(587);
      if (lookahead == 'y') ADVANCE(579);
      if (lookahead == '{') ADVANCE(391);
      if (lookahead == '|') ADVANCE(379);
      if (lookahead == '}') ADVANCE(392);
      if (lookahead == '~') ADVANCE(484);
      if (lookahead == '*' ||
          lookahead == '^') ADVANCE(500);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(509);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(74);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(592);
      END_STATE();
    case 75:
      ADVANCE_MAP(
        '!', 486,
        '"', 454,
        '#', 599,
        '$', 506,
        '%', 481,
        '&', 382,
        '\'', 492,
        '(', 366,
        '+', 471,
        ',', 370,
        '-', 475,
        '.', 404,
        '/', 495,
        '0', 508,
        ':', 356,
        '<', 494,
        '=', 351,
        '>', 498,
        '?', 372,
        '@', 491,
        '[', 384,
      );
      if (lookahead == '\\') SKIP(51);
      if (lookahead == ']') ADVANCE(387);
      if (lookahead == '`') ADVANCE(231);
      if (lookahead == 'd') ADVANCE(584);
      if (lookahead == 'l') ADVANCE(572);
      if (lookahead == 'm') ADVANCE(569);
      if (lookahead == 'r') ADVANCE(576);
      if (lookahead == 'u') ADVANCE(587);
      if (lookahead == 'y') ADVANCE(579);
      if (lookahead == '{') ADVANCE(391);
      if (lookahead == '|') ADVANCE(499);
      if (lookahead == '}') ADVANCE(392);
      if (lookahead == '~') ADVANCE(484);
      if (lookahead == '*' ||
          lookahead == '^') ADVANCE(500);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(509);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(75);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(592);
      END_STATE();
    case 76:
      ADVANCE_MAP(
        '!', 486,
        '"', 454,
        '#', 599,
        '$', 506,
        '%', 481,
        '&', 382,
        '\'', 492,
        '(', 366,
        '+', 471,
        ',', 370,
        '-', 475,
        '.', 403,
        '/', 495,
        '0', 508,
        ':', 356,
        '<', 494,
        '=', 351,
        '>', 498,
        '?', 372,
        '@', 491,
        '[', 384,
      );
      if (lookahead == '\\') SKIP(49);
      if (lookahead == ']') ADVANCE(387);
      if (lookahead == '`') ADVANCE(231);
      if (lookahead == 'd') ADVANCE(584);
      if (lookahead == 'l') ADVANCE(572);
      if (lookahead == 'm') ADVANCE(569);
      if (lookahead == 'r') ADVANCE(576);
      if (lookahead == 'u') ADVANCE(587);
      if (lookahead == 'y') ADVANCE(579);
      if (lookahead == '{') ADVANCE(391);
      if (lookahead == '|') ADVANCE(499);
      if (lookahead == '}') ADVANCE(392);
      if (lookahead == '~') ADVANCE(484);
      if (lookahead == '*' ||
          lookahead == '^') ADVANCE(500);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(509);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(76);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(592);
      END_STATE();
    case 77:
      ADVANCE_MAP(
        '!', 486,
        '"', 454,
        '#', 601,
        '$', 506,
        '%', 481,
        '&', 382,
        '\'', 492,
        '(', 427,
        '*', 432,
        '+', 488,
        ',', 370,
        '-', 488,
        '.', 404,
        '/', 495,
        '0', 508,
        ':', 356,
        '<', 419,
        '=', 351,
        '>', 421,
        '?', 372,
        '@', 491,
        '[', 385,
      );
      if (lookahead == '\\') SKIP(18);
      if (lookahead == '^') ADVANCE(500);
      if (lookahead == '`') ADVANCE(231);
      if (lookahead == 'd') ADVANCE(584);
      if (lookahead == 'l') ADVANCE(572);
      if (lookahead == 'm') ADVANCE(569);
      if (lookahead == 'r') ADVANCE(576);
      if (lookahead == 'u') ADVANCE(587);
      if (lookahead == 'y') ADVANCE(579);
      if (lookahead == '{') ADVANCE(391);
      if (lookahead == '|') ADVANCE(499);
      if (lookahead == '~') ADVANCE(484);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(509);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(121);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(592);
      END_STATE();
    case 78:
      ADVANCE_MAP(
        '!', 486,
        '"', 454,
        '#', 601,
        '$', 506,
        '%', 481,
        '&', 382,
        '\'', 492,
        '(', 427,
        '*', 432,
        '+', 488,
        ',', 370,
        '-', 488,
        '.', 404,
        '/', 495,
        '0', 508,
        ':', 356,
        '<', 419,
        '=', 351,
        '?', 372,
        '@', 491,
        '[', 385,
      );
      if (lookahead == '\\') SKIP(16);
      if (lookahead == '`') ADVANCE(231);
      if (lookahead == 'a') ADVANCE(586);
      if (lookahead == 'd') ADVANCE(584);
      if (lookahead == 'l') ADVANCE(572);
      if (lookahead == 'm') ADVANCE(569);
      if (lookahead == 'r') ADVANCE(576);
      if (lookahead == 'u') ADVANCE(587);
      if (lookahead == 'y') ADVANCE(579);
      if (lookahead == '{') ADVANCE(391);
      if (lookahead == '|') ADVANCE(499);
      if (lookahead == '~') ADVANCE(484);
      if (lookahead == '>' ||
          lookahead == '^') ADVANCE(500);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(509);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(122);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(592);
      END_STATE();
    case 79:
      ADVANCE_MAP(
        '!', 486,
        '"', 454,
        '#', 601,
        '$', 506,
        '%', 481,
        '&', 382,
        '\'', 492,
        '(', 427,
        '*', 432,
        '+', 488,
        ',', 370,
        '-', 488,
        '.', 404,
        '/', 495,
        '0', 508,
        ':', 356,
        '<', 419,
        '=', 351,
        '?', 372,
        '@', 489,
        '[', 385,
      );
      if (lookahead == '\\') SKIP(17);
      if (lookahead == '`') ADVANCE(231);
      if (lookahead == 'd') ADVANCE(584);
      if (lookahead == 'l') ADVANCE(572);
      if (lookahead == 'm') ADVANCE(569);
      if (lookahead == 'r') ADVANCE(576);
      if (lookahead == 'u') ADVANCE(587);
      if (lookahead == 'y') ADVANCE(579);
      if (lookahead == '{') ADVANCE(391);
      if (lookahead == '|') ADVANCE(499);
      if (lookahead == '~') ADVANCE(484);
      if (lookahead == '>' ||
          lookahead == '^') ADVANCE(500);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(509);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(123);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(592);
      END_STATE();
    case 80:
      ADVANCE_MAP(
        '!', 486,
        '"', 454,
        '#', 601,
        '$', 506,
        '%', 481,
        '&', 382,
        '\'', 492,
        '(', 427,
        '*', 432,
        '+', 488,
        ',', 370,
        '-', 488,
        '.', 404,
        '/', 495,
        '0', 508,
        ':', 356,
        '<', 419,
        '=', 351,
        '?', 372,
        '@', 490,
        '[', 385,
      );
      if (lookahead == '\\') SKIP(19);
      if (lookahead == '`') ADVANCE(231);
      if (lookahead == 'd') ADVANCE(584);
      if (lookahead == 'l') ADVANCE(572);
      if (lookahead == 'm') ADVANCE(569);
      if (lookahead == 'r') ADVANCE(576);
      if (lookahead == 'u') ADVANCE(587);
      if (lookahead == 'y') ADVANCE(579);
      if (lookahead == '{') ADVANCE(391);
      if (lookahead == '|') ADVANCE(499);
      if (lookahead == '~') ADVANCE(484);
      if (lookahead == '>' ||
          lookahead == '^') ADVANCE(500);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(509);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(124);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(592);
      END_STATE();
    case 81:
      ADVANCE_MAP(
        '!', 486,
        '"', 454,
        '#', 601,
        '$', 506,
        '%', 481,
        '&', 382,
        '\'', 492,
        '(', 427,
        '*', 432,
        '+', 488,
        ',', 370,
        '-', 488,
        '.', 403,
        '/', 495,
        '0', 508,
        ':', 356,
        '<', 419,
        '=', 351,
        '?', 372,
        '@', 491,
        '[', 385,
      );
      if (lookahead == '\\') SKIP(20);
      if (lookahead == '`') ADVANCE(231);
      if (lookahead == 'd') ADVANCE(584);
      if (lookahead == 'l') ADVANCE(572);
      if (lookahead == 'm') ADVANCE(569);
      if (lookahead == 'r') ADVANCE(576);
      if (lookahead == 'u') ADVANCE(587);
      if (lookahead == 'y') ADVANCE(579);
      if (lookahead == '{') ADVANCE(391);
      if (lookahead == '|') ADVANCE(499);
      if (lookahead == '~') ADVANCE(484);
      if (lookahead == '>' ||
          lookahead == '^') ADVANCE(500);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(509);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(125);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(592);
      END_STATE();
    case 82:
      ADVANCE_MAP(
        '!', 486,
        '"', 454,
        '#', 601,
        '$', 506,
        '%', 481,
        '&', 382,
        '\'', 492,
        '(', 427,
        '+', 488,
        ',', 370,
        '-', 488,
        '.', 551,
        '/', 495,
        '0', 508,
        ':', 356,
        '<', 419,
        '=', 351,
        '?', 372,
        '@', 491,
        'L', 540,
        'M', 549,
        'U', 568,
        '[', 386,
      );
      if (lookahead == '\\') SKIP(14);
      if (lookahead == ']') ADVANCE(387);
      if (lookahead == '`') ADVANCE(231);
      if (lookahead == 'd') ADVANCE(584);
      if (lookahead == 'l') ADVANCE(528);
      if (lookahead == 'm') ADVANCE(548);
      if (lookahead == 'n') ADVANCE(536);
      if (lookahead == 'r') ADVANCE(576);
      if (lookahead == 's') ADVANCE(523);
      if (lookahead == 'u') ADVANCE(531);
      if (lookahead == 'y') ADVANCE(518);
      if (lookahead == '{') ADVANCE(391);
      if (lookahead == '|') ADVANCE(499);
      if (lookahead == '~') ADVANCE(484);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(556);
      if (lookahead == '*' ||
          lookahead == '>' ||
          lookahead == '^') ADVANCE(500);
      if (lookahead == 'G' ||
          lookahead == 'I' ||
          lookahead == 'N' ||
          lookahead == 'Q' ||
          lookahead == 'R' ||
          lookahead == 'Z') ADVANCE(546);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(509);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(126);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(592);
      END_STATE();
    case 83:
      ADVANCE_MAP(
        '!', 486,
        '"', 454,
        '#', 601,
        '$', 506,
        '%', 481,
        '&', 382,
        '\'', 492,
        '(', 427,
        '+', 488,
        ',', 370,
        '-', 488,
        '.', 402,
        '/', 495,
        '0', 508,
        ':', 356,
        '<', 419,
        '=', 351,
        '?', 372,
        '@', 491,
        '[', 386,
      );
      if (lookahead == '\\') SKIP(56);
      if (lookahead == '`') ADVANCE(231);
      if (lookahead == 'd') ADVANCE(584);
      if (lookahead == 'l') ADVANCE(572);
      if (lookahead == 'm') ADVANCE(569);
      if (lookahead == 'r') ADVANCE(576);
      if (lookahead == 'u') ADVANCE(587);
      if (lookahead == 'y') ADVANCE(579);
      if (lookahead == '{') ADVANCE(391);
      if (lookahead == '|') ADVANCE(499);
      if (lookahead == '~') ADVANCE(484);
      if (lookahead == '*' ||
          lookahead == '>' ||
          lookahead == '^') ADVANCE(500);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(509);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(142);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(592);
      END_STATE();
    case 84:
      ADVANCE_MAP(
        '!', 486,
        '"', 454,
        '#', 601,
        '$', 506,
        '%', 481,
        '&', 382,
        '\'', 492,
        '(', 427,
        '+', 488,
        ',', 370,
        '-', 488,
        '.', 553,
        '/', 495,
        '0', 508,
        ':', 356,
        '<', 419,
        '=', 351,
        '>', 421,
        '?', 372,
        '@', 491,
        'L', 540,
        'M', 549,
        'U', 568,
        '[', 386,
      );
      if (lookahead == '\\') SKIP(15);
      if (lookahead == '`') ADVANCE(231);
      if (lookahead == 'd') ADVANCE(584);
      if (lookahead == 'l') ADVANCE(528);
      if (lookahead == 'm') ADVANCE(548);
      if (lookahead == 'n') ADVANCE(536);
      if (lookahead == 'r') ADVANCE(576);
      if (lookahead == 's') ADVANCE(523);
      if (lookahead == 'u') ADVANCE(531);
      if (lookahead == 'y') ADVANCE(518);
      if (lookahead == '{') ADVANCE(391);
      if (lookahead == '|') ADVANCE(499);
      if (lookahead == '~') ADVANCE(484);
      if (lookahead == '*' ||
          lookahead == '^') ADVANCE(500);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(556);
      if (lookahead == 'G' ||
          lookahead == 'I' ||
          lookahead == 'N' ||
          lookahead == 'Q' ||
          lookahead == 'R' ||
          lookahead == 'Z') ADVANCE(546);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(509);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(128);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(592);
      END_STATE();
    case 85:
      ADVANCE_MAP(
        '!', 486,
        '"', 454,
        '#', 601,
        '$', 506,
        '%', 481,
        '&', 382,
        '\'', 492,
        '(', 427,
        '+', 488,
        ',', 370,
        '-', 488,
        '.', 553,
        '/', 495,
        '0', 508,
        ':', 356,
        '<', 419,
        '=', 351,
        '?', 372,
        '@', 491,
        'L', 540,
        'M', 549,
        'U', 568,
        '[', 386,
      );
      if (lookahead == '\\') SKIP(13);
      if (lookahead == '`') ADVANCE(231);
      if (lookahead == 'a') ADVANCE(586);
      if (lookahead == 'd') ADVANCE(584);
      if (lookahead == 'l') ADVANCE(528);
      if (lookahead == 'm') ADVANCE(548);
      if (lookahead == 'n') ADVANCE(536);
      if (lookahead == 'r') ADVANCE(576);
      if (lookahead == 's') ADVANCE(523);
      if (lookahead == 'u') ADVANCE(531);
      if (lookahead == 'y') ADVANCE(518);
      if (lookahead == '{') ADVANCE(391);
      if (lookahead == '|') ADVANCE(499);
      if (lookahead == '~') ADVANCE(484);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(556);
      if (lookahead == '*' ||
          lookahead == '>' ||
          lookahead == '^') ADVANCE(500);
      if (lookahead == 'G' ||
          lookahead == 'I' ||
          lookahead == 'N' ||
          lookahead == 'Q' ||
          lookahead == 'R' ||
          lookahead == 'Z') ADVANCE(546);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(509);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(130);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(592);
      END_STATE();
    case 86:
      ADVANCE_MAP(
        '!', 486,
        '"', 454,
        '#', 601,
        '$', 506,
        '%', 481,
        '&', 382,
        '\'', 492,
        '(', 427,
        '+', 488,
        ',', 370,
        '-', 488,
        '.', 553,
        '/', 495,
        '0', 508,
        ':', 356,
        '<', 419,
        '=', 351,
        '?', 372,
        '@', 491,
        'L', 540,
        'M', 549,
        'U', 568,
        '[', 386,
      );
      if (lookahead == '\\') SKIP(50);
      if (lookahead == '`') ADVANCE(231);
      if (lookahead == 'd') ADVANCE(584);
      if (lookahead == 'l') ADVANCE(528);
      if (lookahead == 'm') ADVANCE(548);
      if (lookahead == 'n') ADVANCE(536);
      if (lookahead == 'r') ADVANCE(576);
      if (lookahead == 's') ADVANCE(523);
      if (lookahead == 'u') ADVANCE(531);
      if (lookahead == 'y') ADVANCE(518);
      if (lookahead == '{') ADVANCE(391);
      if (lookahead == '|') ADVANCE(499);
      if (lookahead == '~') ADVANCE(484);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(556);
      if (lookahead == '*' ||
          lookahead == '>' ||
          lookahead == '^') ADVANCE(500);
      if (lookahead == 'G' ||
          lookahead == 'I' ||
          lookahead == 'N' ||
          lookahead == 'Q' ||
          lookahead == 'R' ||
          lookahead == 'Z') ADVANCE(546);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(509);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(143);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(592);
      END_STATE();
    case 87:
      ADVANCE_MAP(
        '!', 486,
        '"', 454,
        '#', 601,
        '$', 506,
        '%', 481,
        '&', 382,
        '\'', 492,
        '(', 427,
        '+', 488,
        ',', 370,
        '-', 488,
        '.', 553,
        '/', 495,
        '0', 508,
        ':', 356,
        '<', 419,
        '=', 351,
        '?', 372,
        '@', 489,
        'L', 540,
        'M', 549,
        'U', 568,
        '[', 386,
      );
      if (lookahead == '\\') SKIP(55);
      if (lookahead == '`') ADVANCE(231);
      if (lookahead == 'd') ADVANCE(584);
      if (lookahead == 'l') ADVANCE(528);
      if (lookahead == 'm') ADVANCE(548);
      if (lookahead == 'n') ADVANCE(536);
      if (lookahead == 'r') ADVANCE(576);
      if (lookahead == 's') ADVANCE(523);
      if (lookahead == 'u') ADVANCE(531);
      if (lookahead == 'y') ADVANCE(518);
      if (lookahead == '{') ADVANCE(391);
      if (lookahead == '|') ADVANCE(499);
      if (lookahead == '~') ADVANCE(484);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(556);
      if (lookahead == '*' ||
          lookahead == '>' ||
          lookahead == '^') ADVANCE(500);
      if (lookahead == 'G' ||
          lookahead == 'I' ||
          lookahead == 'N' ||
          lookahead == 'Q' ||
          lookahead == 'R' ||
          lookahead == 'Z') ADVANCE(546);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(509);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(132);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(592);
      END_STATE();
    case 88:
      ADVANCE_MAP(
        '!', 486,
        '"', 454,
        '#', 601,
        '$', 506,
        '%', 481,
        '&', 382,
        '\'', 492,
        '(', 427,
        '+', 488,
        ',', 370,
        '-', 488,
        '.', 553,
        '/', 495,
        '0', 508,
        ':', 356,
        '<', 419,
        '=', 351,
        '?', 372,
        '@', 490,
        'L', 540,
        'M', 549,
        'U', 568,
        '[', 386,
      );
      if (lookahead == '\\') SKIP(54);
      if (lookahead == '`') ADVANCE(231);
      if (lookahead == 'd') ADVANCE(584);
      if (lookahead == 'l') ADVANCE(528);
      if (lookahead == 'm') ADVANCE(548);
      if (lookahead == 'n') ADVANCE(536);
      if (lookahead == 'r') ADVANCE(576);
      if (lookahead == 's') ADVANCE(523);
      if (lookahead == 'u') ADVANCE(531);
      if (lookahead == 'y') ADVANCE(518);
      if (lookahead == '{') ADVANCE(391);
      if (lookahead == '|') ADVANCE(499);
      if (lookahead == '~') ADVANCE(484);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(556);
      if (lookahead == '*' ||
          lookahead == '>' ||
          lookahead == '^') ADVANCE(500);
      if (lookahead == 'G' ||
          lookahead == 'I' ||
          lookahead == 'N' ||
          lookahead == 'Q' ||
          lookahead == 'R' ||
          lookahead == 'Z') ADVANCE(546);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(509);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(134);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(592);
      END_STATE();
    case 89:
      ADVANCE_MAP(
        '!', 486,
        '"', 454,
        '#', 601,
        '$', 506,
        '%', 481,
        '&', 382,
        '\'', 492,
        '(', 427,
        '+', 488,
        ',', 370,
        '-', 488,
        '.', 404,
        '/', 495,
        '0', 508,
        ':', 356,
        '<', 419,
        '=', 441,
        '?', 372,
        '@', 491,
        '[', 386,
      );
      if (lookahead == '\\') SKIP(57);
      if (lookahead == '`') ADVANCE(231);
      if (lookahead == 'd') ADVANCE(584);
      if (lookahead == 'l') ADVANCE(572);
      if (lookahead == 'm') ADVANCE(569);
      if (lookahead == 'r') ADVANCE(576);
      if (lookahead == 'u') ADVANCE(587);
      if (lookahead == 'y') ADVANCE(579);
      if (lookahead == '{') ADVANCE(391);
      if (lookahead == '|') ADVANCE(499);
      if (lookahead == '~') ADVANCE(484);
      if (lookahead == '*' ||
          lookahead == '>' ||
          lookahead == '^') ADVANCE(500);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(509);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(127);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(592);
      END_STATE();
    case 90:
      ADVANCE_MAP(
        '!', 486,
        '"', 454,
        '#', 601,
        '$', 506,
        '%', 481,
        '&', 382,
        '\'', 492,
        '(', 427,
        '+', 488,
        ',', 370,
        '-', 488,
        '.', 404,
        '/', 495,
        '0', 508,
        ':', 356,
        '<', 419,
        '=', 351,
        '>', 421,
        '?', 372,
        '@', 491,
        'L', 540,
        'U', 568,
        '[', 386,
      );
      if (lookahead == '\\') SKIP(15);
      if (lookahead == '`') ADVANCE(231);
      if (lookahead == 'd') ADVANCE(584);
      if (lookahead == 'l') ADVANCE(528);
      if (lookahead == 'm') ADVANCE(569);
      if (lookahead == 'n') ADVANCE(536);
      if (lookahead == 'r') ADVANCE(576);
      if (lookahead == 's') ADVANCE(523);
      if (lookahead == 'u') ADVANCE(531);
      if (lookahead == 'y') ADVANCE(518);
      if (lookahead == '{') ADVANCE(391);
      if (lookahead == '|') ADVANCE(499);
      if (lookahead == '~') ADVANCE(484);
      if (lookahead == '*' ||
          lookahead == '^') ADVANCE(500);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(509);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(128);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(592);
      END_STATE();
    case 91:
      ADVANCE_MAP(
        '!', 486,
        '"', 454,
        '#', 601,
        '$', 506,
        '%', 481,
        '&', 382,
        '\'', 492,
        '(', 427,
        '+', 488,
        ',', 370,
        '-', 488,
        '.', 404,
        '/', 495,
        '0', 508,
        ':', 356,
        '<', 419,
        '=', 351,
        '>', 421,
        '?', 372,
        '@', 491,
        'M', 549,
        '[', 386,
      );
      if (lookahead == '\\') SKIP(15);
      if (lookahead == '`') ADVANCE(231);
      if (lookahead == 'd') ADVANCE(584);
      if (lookahead == 'f') ADVANCE(544);
      if (lookahead == 'l') ADVANCE(572);
      if (lookahead == 'm') ADVANCE(548);
      if (lookahead == 'r') ADVANCE(576);
      if (lookahead == 'u') ADVANCE(587);
      if (lookahead == 'y') ADVANCE(579);
      if (lookahead == '{') ADVANCE(391);
      if (lookahead == '|') ADVANCE(499);
      if (lookahead == '~') ADVANCE(484);
      if (lookahead == '*' ||
          lookahead == '^') ADVANCE(500);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(556);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(509);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(128);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(592);
      END_STATE();
    case 92:
      ADVANCE_MAP(
        '!', 486,
        '"', 454,
        '#', 601,
        '$', 506,
        '%', 481,
        '&', 382,
        '\'', 492,
        '(', 427,
        '+', 488,
        ',', 370,
        '-', 488,
        '.', 404,
        '/', 495,
        '0', 508,
        ':', 356,
        '<', 419,
        '=', 351,
        '>', 421,
        '?', 372,
        '@', 491,
        'M', 549,
        '[', 386,
      );
      if (lookahead == '\\') SKIP(15);
      if (lookahead == '`') ADVANCE(231);
      if (lookahead == 'd') ADVANCE(584);
      if (lookahead == 'f') ADVANCE(544);
      if (lookahead == 'l') ADVANCE(572);
      if (lookahead == 'm') ADVANCE(548);
      if (lookahead == 'r') ADVANCE(576);
      if (lookahead == 'u') ADVANCE(587);
      if (lookahead == 'y') ADVANCE(579);
      if (lookahead == '{') ADVANCE(391);
      if (lookahead == '|') ADVANCE(499);
      if (lookahead == '~') ADVANCE(484);
      if (lookahead == '*' ||
          lookahead == '^') ADVANCE(500);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(509);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(128);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(592);
      END_STATE();
    case 93:
      ADVANCE_MAP(
        '!', 486,
        '"', 454,
        '#', 601,
        '$', 506,
        '%', 481,
        '&', 382,
        '\'', 492,
        '(', 427,
        '+', 488,
        ',', 370,
        '-', 488,
        '.', 404,
        '/', 495,
        '0', 508,
        ':', 356,
        '<', 419,
        '=', 351,
        '>', 421,
        '?', 372,
        '@', 491,
        '[', 386,
      );
      if (lookahead == '\\') SKIP(24);
      if (lookahead == '`') ADVANCE(231);
      if (lookahead == 'd') ADVANCE(584);
      if (lookahead == 'l') ADVANCE(572);
      if (lookahead == 'm') ADVANCE(569);
      if (lookahead == 'r') ADVANCE(576);
      if (lookahead == 'u') ADVANCE(587);
      if (lookahead == 'y') ADVANCE(579);
      if (lookahead == '{') ADVANCE(391);
      if (lookahead == '|') ADVANCE(379);
      if (lookahead == '~') ADVANCE(484);
      if (lookahead == '*' ||
          lookahead == '^') ADVANCE(500);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(509);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(129);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(592);
      END_STATE();
    case 94:
      ADVANCE_MAP(
        '!', 486,
        '"', 454,
        '#', 601,
        '$', 506,
        '%', 481,
        '&', 382,
        '\'', 492,
        '(', 427,
        '+', 488,
        ',', 370,
        '-', 488,
        '.', 404,
        '/', 495,
        '0', 508,
        ':', 356,
        '<', 419,
        '=', 351,
        '?', 372,
        '@', 491,
        'L', 540,
        'U', 568,
        '[', 386,
      );
      if (lookahead == '\\') SKIP(13);
      if (lookahead == '`') ADVANCE(231);
      if (lookahead == 'a') ADVANCE(586);
      if (lookahead == 'd') ADVANCE(584);
      if (lookahead == 'l') ADVANCE(528);
      if (lookahead == 'm') ADVANCE(569);
      if (lookahead == 'n') ADVANCE(536);
      if (lookahead == 'r') ADVANCE(576);
      if (lookahead == 's') ADVANCE(523);
      if (lookahead == 'u') ADVANCE(531);
      if (lookahead == 'y') ADVANCE(518);
      if (lookahead == '{') ADVANCE(391);
      if (lookahead == '|') ADVANCE(499);
      if (lookahead == '~') ADVANCE(484);
      if (lookahead == '*' ||
          lookahead == '>' ||
          lookahead == '^') ADVANCE(500);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(509);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(130);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(592);
      END_STATE();
    case 95:
      ADVANCE_MAP(
        '!', 486,
        '"', 454,
        '#', 601,
        '$', 506,
        '%', 481,
        '&', 382,
        '\'', 492,
        '(', 427,
        '+', 488,
        ',', 370,
        '-', 488,
        '.', 404,
        '/', 495,
        '0', 508,
        ':', 356,
        '<', 419,
        '=', 351,
        '?', 372,
        '@', 491,
        'M', 549,
        '[', 386,
      );
      if (lookahead == '\\') SKIP(13);
      if (lookahead == '`') ADVANCE(231);
      if (lookahead == 'a') ADVANCE(586);
      if (lookahead == 'd') ADVANCE(584);
      if (lookahead == 'f') ADVANCE(544);
      if (lookahead == 'l') ADVANCE(572);
      if (lookahead == 'm') ADVANCE(548);
      if (lookahead == 'r') ADVANCE(576);
      if (lookahead == 'u') ADVANCE(587);
      if (lookahead == 'y') ADVANCE(579);
      if (lookahead == '{') ADVANCE(391);
      if (lookahead == '|') ADVANCE(499);
      if (lookahead == '~') ADVANCE(484);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(556);
      if (lookahead == '*' ||
          lookahead == '>' ||
          lookahead == '^') ADVANCE(500);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(509);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(130);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(592);
      END_STATE();
    case 96:
      ADVANCE_MAP(
        '!', 486,
        '"', 454,
        '#', 601,
        '$', 506,
        '%', 481,
        '&', 382,
        '\'', 492,
        '(', 427,
        '+', 488,
        ',', 370,
        '-', 488,
        '.', 404,
        '/', 495,
        '0', 508,
        ':', 356,
        '<', 419,
        '=', 351,
        '?', 372,
        '@', 491,
        'M', 549,
        '[', 386,
      );
      if (lookahead == '\\') SKIP(13);
      if (lookahead == '`') ADVANCE(231);
      if (lookahead == 'a') ADVANCE(586);
      if (lookahead == 'd') ADVANCE(584);
      if (lookahead == 'f') ADVANCE(544);
      if (lookahead == 'l') ADVANCE(572);
      if (lookahead == 'm') ADVANCE(548);
      if (lookahead == 'r') ADVANCE(576);
      if (lookahead == 'u') ADVANCE(587);
      if (lookahead == 'y') ADVANCE(579);
      if (lookahead == '{') ADVANCE(391);
      if (lookahead == '|') ADVANCE(499);
      if (lookahead == '~') ADVANCE(484);
      if (lookahead == '*' ||
          lookahead == '>' ||
          lookahead == '^') ADVANCE(500);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(509);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(130);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(592);
      END_STATE();
    case 97:
      ADVANCE_MAP(
        '!', 486,
        '"', 454,
        '#', 601,
        '$', 506,
        '%', 481,
        '&', 382,
        '\'', 492,
        '(', 427,
        '+', 488,
        ',', 370,
        '-', 488,
        '.', 404,
        '/', 495,
        '0', 508,
        ':', 356,
        '<', 419,
        '=', 351,
        '?', 372,
        '@', 491,
        '[', 386,
      );
      if (lookahead == '\\') SKIP(21);
      if (lookahead == '`') ADVANCE(231);
      if (lookahead == 'a') ADVANCE(586);
      if (lookahead == 'd') ADVANCE(584);
      if (lookahead == 'l') ADVANCE(572);
      if (lookahead == 'm') ADVANCE(569);
      if (lookahead == 'r') ADVANCE(576);
      if (lookahead == 'u') ADVANCE(587);
      if (lookahead == 'y') ADVANCE(579);
      if (lookahead == '{') ADVANCE(391);
      if (lookahead == '|') ADVANCE(379);
      if (lookahead == '~') ADVANCE(484);
      if (lookahead == '*' ||
          lookahead == '>' ||
          lookahead == '^') ADVANCE(500);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(509);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(131);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(592);
      END_STATE();
    case 98:
      ADVANCE_MAP(
        '!', 486,
        '"', 454,
        '#', 601,
        '$', 506,
        '%', 481,
        '&', 382,
        '\'', 492,
        '(', 427,
        '+', 488,
        ',', 370,
        '-', 488,
        '.', 404,
        '/', 495,
        '0', 508,
        ':', 356,
        '<', 419,
        '=', 351,
        '?', 372,
        '@', 489,
        'L', 540,
        'U', 568,
        '[', 386,
      );
      if (lookahead == '\\') SKIP(55);
      if (lookahead == '`') ADVANCE(231);
      if (lookahead == 'd') ADVANCE(584);
      if (lookahead == 'l') ADVANCE(528);
      if (lookahead == 'm') ADVANCE(569);
      if (lookahead == 'n') ADVANCE(536);
      if (lookahead == 'r') ADVANCE(576);
      if (lookahead == 's') ADVANCE(523);
      if (lookahead == 'u') ADVANCE(531);
      if (lookahead == 'y') ADVANCE(518);
      if (lookahead == '{') ADVANCE(391);
      if (lookahead == '|') ADVANCE(499);
      if (lookahead == '~') ADVANCE(484);
      if (lookahead == '*' ||
          lookahead == '>' ||
          lookahead == '^') ADVANCE(500);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(509);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(132);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(592);
      END_STATE();
    case 99:
      ADVANCE_MAP(
        '!', 486,
        '"', 454,
        '#', 601,
        '$', 506,
        '%', 481,
        '&', 382,
        '\'', 492,
        '(', 427,
        '+', 488,
        ',', 370,
        '-', 488,
        '.', 404,
        '/', 495,
        '0', 508,
        ':', 356,
        '<', 419,
        '=', 351,
        '?', 372,
        '@', 489,
        'M', 549,
        '[', 386,
      );
      if (lookahead == '\\') SKIP(55);
      if (lookahead == '`') ADVANCE(231);
      if (lookahead == 'd') ADVANCE(584);
      if (lookahead == 'f') ADVANCE(544);
      if (lookahead == 'l') ADVANCE(572);
      if (lookahead == 'm') ADVANCE(548);
      if (lookahead == 'r') ADVANCE(576);
      if (lookahead == 'u') ADVANCE(587);
      if (lookahead == 'y') ADVANCE(579);
      if (lookahead == '{') ADVANCE(391);
      if (lookahead == '|') ADVANCE(499);
      if (lookahead == '~') ADVANCE(484);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(556);
      if (lookahead == '*' ||
          lookahead == '>' ||
          lookahead == '^') ADVANCE(500);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(509);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(132);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(592);
      END_STATE();
    case 100:
      ADVANCE_MAP(
        '!', 486,
        '"', 454,
        '#', 601,
        '$', 506,
        '%', 481,
        '&', 382,
        '\'', 492,
        '(', 427,
        '+', 488,
        ',', 370,
        '-', 488,
        '.', 404,
        '/', 495,
        '0', 508,
        ':', 356,
        '<', 419,
        '=', 351,
        '?', 372,
        '@', 489,
        'M', 549,
        '[', 386,
      );
      if (lookahead == '\\') SKIP(55);
      if (lookahead == '`') ADVANCE(231);
      if (lookahead == 'd') ADVANCE(584);
      if (lookahead == 'f') ADVANCE(544);
      if (lookahead == 'l') ADVANCE(572);
      if (lookahead == 'm') ADVANCE(548);
      if (lookahead == 'r') ADVANCE(576);
      if (lookahead == 'u') ADVANCE(587);
      if (lookahead == 'y') ADVANCE(579);
      if (lookahead == '{') ADVANCE(391);
      if (lookahead == '|') ADVANCE(499);
      if (lookahead == '~') ADVANCE(484);
      if (lookahead == '*' ||
          lookahead == '>' ||
          lookahead == '^') ADVANCE(500);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(509);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(132);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(592);
      END_STATE();
    case 101:
      ADVANCE_MAP(
        '!', 486,
        '"', 454,
        '#', 601,
        '$', 506,
        '%', 481,
        '&', 382,
        '\'', 492,
        '(', 427,
        '+', 488,
        ',', 370,
        '-', 488,
        '.', 404,
        '/', 495,
        '0', 508,
        ':', 356,
        '<', 419,
        '=', 351,
        '?', 372,
        '@', 489,
        '[', 386,
      );
      if (lookahead == '\\') SKIP(59);
      if (lookahead == '`') ADVANCE(231);
      if (lookahead == 'd') ADVANCE(584);
      if (lookahead == 'l') ADVANCE(572);
      if (lookahead == 'm') ADVANCE(569);
      if (lookahead == 'r') ADVANCE(576);
      if (lookahead == 'u') ADVANCE(587);
      if (lookahead == 'y') ADVANCE(579);
      if (lookahead == '{') ADVANCE(391);
      if (lookahead == '|') ADVANCE(379);
      if (lookahead == '~') ADVANCE(484);
      if (lookahead == '*' ||
          lookahead == '>' ||
          lookahead == '^') ADVANCE(500);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(509);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(133);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(592);
      END_STATE();
    case 102:
      ADVANCE_MAP(
        '!', 486,
        '"', 454,
        '#', 601,
        '$', 506,
        '%', 481,
        '&', 382,
        '\'', 492,
        '(', 427,
        '+', 488,
        ',', 370,
        '-', 488,
        '.', 404,
        '/', 495,
        '0', 508,
        ':', 356,
        '<', 419,
        '=', 351,
        '?', 372,
        '@', 490,
        'L', 540,
        'U', 568,
        '[', 386,
      );
      if (lookahead == '\\') SKIP(54);
      if (lookahead == '`') ADVANCE(231);
      if (lookahead == 'd') ADVANCE(584);
      if (lookahead == 'l') ADVANCE(528);
      if (lookahead == 'm') ADVANCE(569);
      if (lookahead == 'n') ADVANCE(536);
      if (lookahead == 'r') ADVANCE(576);
      if (lookahead == 's') ADVANCE(523);
      if (lookahead == 'u') ADVANCE(531);
      if (lookahead == 'y') ADVANCE(518);
      if (lookahead == '{') ADVANCE(391);
      if (lookahead == '|') ADVANCE(499);
      if (lookahead == '~') ADVANCE(484);
      if (lookahead == '*' ||
          lookahead == '>' ||
          lookahead == '^') ADVANCE(500);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(509);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(134);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(592);
      END_STATE();
    case 103:
      ADVANCE_MAP(
        '!', 486,
        '"', 454,
        '#', 601,
        '$', 506,
        '%', 481,
        '&', 382,
        '\'', 492,
        '(', 427,
        '+', 488,
        ',', 370,
        '-', 488,
        '.', 404,
        '/', 495,
        '0', 508,
        ':', 356,
        '<', 419,
        '=', 351,
        '?', 372,
        '@', 490,
        'M', 549,
        '[', 386,
      );
      if (lookahead == '\\') SKIP(54);
      if (lookahead == '`') ADVANCE(231);
      if (lookahead == 'd') ADVANCE(584);
      if (lookahead == 'f') ADVANCE(544);
      if (lookahead == 'l') ADVANCE(572);
      if (lookahead == 'm') ADVANCE(548);
      if (lookahead == 'r') ADVANCE(576);
      if (lookahead == 'u') ADVANCE(587);
      if (lookahead == 'y') ADVANCE(579);
      if (lookahead == '{') ADVANCE(391);
      if (lookahead == '|') ADVANCE(499);
      if (lookahead == '~') ADVANCE(484);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(556);
      if (lookahead == '*' ||
          lookahead == '>' ||
          lookahead == '^') ADVANCE(500);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(509);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(134);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(592);
      END_STATE();
    case 104:
      ADVANCE_MAP(
        '!', 486,
        '"', 454,
        '#', 601,
        '$', 506,
        '%', 481,
        '&', 382,
        '\'', 492,
        '(', 427,
        '+', 488,
        ',', 370,
        '-', 488,
        '.', 404,
        '/', 495,
        '0', 508,
        ':', 356,
        '<', 419,
        '=', 351,
        '?', 372,
        '@', 490,
        'M', 549,
        '[', 386,
      );
      if (lookahead == '\\') SKIP(54);
      if (lookahead == '`') ADVANCE(231);
      if (lookahead == 'd') ADVANCE(584);
      if (lookahead == 'f') ADVANCE(544);
      if (lookahead == 'l') ADVANCE(572);
      if (lookahead == 'm') ADVANCE(548);
      if (lookahead == 'r') ADVANCE(576);
      if (lookahead == 'u') ADVANCE(587);
      if (lookahead == 'y') ADVANCE(579);
      if (lookahead == '{') ADVANCE(391);
      if (lookahead == '|') ADVANCE(499);
      if (lookahead == '~') ADVANCE(484);
      if (lookahead == '*' ||
          lookahead == '>' ||
          lookahead == '^') ADVANCE(500);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(509);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(134);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(592);
      END_STATE();
    case 105:
      ADVANCE_MAP(
        '!', 486,
        '"', 454,
        '#', 601,
        '$', 506,
        '%', 481,
        '&', 382,
        '\'', 492,
        '(', 427,
        '+', 488,
        ',', 370,
        '-', 488,
        '.', 404,
        '/', 495,
        '0', 508,
        ':', 356,
        '<', 419,
        '=', 351,
        '?', 372,
        '@', 490,
        '[', 386,
      );
      if (lookahead == '\\') SKIP(60);
      if (lookahead == '`') ADVANCE(231);
      if (lookahead == 'd') ADVANCE(584);
      if (lookahead == 'l') ADVANCE(572);
      if (lookahead == 'm') ADVANCE(569);
      if (lookahead == 'r') ADVANCE(576);
      if (lookahead == 'u') ADVANCE(587);
      if (lookahead == 'y') ADVANCE(579);
      if (lookahead == '{') ADVANCE(391);
      if (lookahead == '|') ADVANCE(379);
      if (lookahead == '~') ADVANCE(484);
      if (lookahead == '*' ||
          lookahead == '>' ||
          lookahead == '^') ADVANCE(500);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(509);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(135);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(592);
      END_STATE();
    case 106:
      ADVANCE_MAP(
        '!', 486,
        '"', 454,
        '#', 601,
        '$', 506,
        '%', 481,
        '&', 382,
        '\'', 492,
        '(', 427,
        '+', 488,
        ',', 370,
        '-', 488,
        '.', 552,
        '/', 495,
        '0', 508,
        ':', 356,
        '<', 419,
        '=', 351,
        '?', 372,
        '@', 491,
        'L', 540,
        'M', 549,
        'U', 568,
        '[', 386,
      );
      if (lookahead == '\\') SKIP(6);
      if (lookahead == '`') ADVANCE(231);
      if (lookahead == 'd') ADVANCE(584);
      if (lookahead == 'l') ADVANCE(528);
      if (lookahead == 'm') ADVANCE(548);
      if (lookahead == 'n') ADVANCE(536);
      if (lookahead == 'r') ADVANCE(576);
      if (lookahead == 's') ADVANCE(523);
      if (lookahead == 'u') ADVANCE(531);
      if (lookahead == 'y') ADVANCE(518);
      if (lookahead == '{') ADVANCE(391);
      if (lookahead == '|') ADVANCE(499);
      if (lookahead == '~') ADVANCE(484);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(556);
      if (lookahead == '*' ||
          lookahead == '>' ||
          lookahead == '^') ADVANCE(500);
      if (lookahead == 'G' ||
          lookahead == 'I' ||
          lookahead == 'N' ||
          lookahead == 'Q' ||
          lookahead == 'R' ||
          lookahead == 'Z') ADVANCE(546);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(509);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(144);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(592);
      END_STATE();
    case 107:
      ADVANCE_MAP(
        '!', 486,
        '"', 454,
        '#', 601,
        '$', 506,
        '%', 481,
        '&', 382,
        '\'', 492,
        '(', 427,
        '+', 488,
        ',', 370,
        '-', 488,
        '.', 552,
        '/', 495,
        '0', 508,
        ':', 356,
        '<', 419,
        '=', 351,
        '?', 372,
        '@', 491,
        'L', 540,
        'M', 549,
        'U', 568,
        '[', 386,
      );
      if (lookahead == '\\') SKIP(52);
      if (lookahead == '`') ADVANCE(231);
      if (lookahead == 'd') ADVANCE(584);
      if (lookahead == 'l') ADVANCE(528);
      if (lookahead == 'm') ADVANCE(548);
      if (lookahead == 'n') ADVANCE(536);
      if (lookahead == 'r') ADVANCE(576);
      if (lookahead == 's') ADVANCE(523);
      if (lookahead == 'u') ADVANCE(531);
      if (lookahead == 'y') ADVANCE(518);
      if (lookahead == '{') ADVANCE(391);
      if (lookahead == '|') ADVANCE(499);
      if (lookahead == '~') ADVANCE(484);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(556);
      if (lookahead == '*' ||
          lookahead == '>' ||
          lookahead == '^') ADVANCE(500);
      if (lookahead == 'G' ||
          lookahead == 'I' ||
          lookahead == 'N' ||
          lookahead == 'Q' ||
          lookahead == 'R' ||
          lookahead == 'Z') ADVANCE(546);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(509);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(138);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(592);
      END_STATE();
    case 108:
      ADVANCE_MAP(
        '!', 486,
        '"', 454,
        '#', 601,
        '$', 506,
        '%', 481,
        '&', 382,
        '\'', 492,
        '(', 427,
        '+', 488,
        ',', 370,
        '-', 488,
        '.', 403,
        '/', 495,
        '0', 508,
        ':', 356,
        '<', 419,
        '=', 351,
        '>', 421,
        '?', 372,
        '@', 491,
        '[', 386,
      );
      if (lookahead == '\\') SKIP(9);
      if (lookahead == '`') ADVANCE(231);
      if (lookahead == 'd') ADVANCE(584);
      if (lookahead == 'l') ADVANCE(572);
      if (lookahead == 'm') ADVANCE(569);
      if (lookahead == 'r') ADVANCE(576);
      if (lookahead == 'u') ADVANCE(587);
      if (lookahead == 'y') ADVANCE(579);
      if (lookahead == '{') ADVANCE(391);
      if (lookahead == '|') ADVANCE(499);
      if (lookahead == '~') ADVANCE(484);
      if (lookahead == '*' ||
          lookahead == '^') ADVANCE(500);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(509);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(136);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(592);
      END_STATE();
    case 109:
      ADVANCE_MAP(
        '!', 486,
        '"', 454,
        '#', 601,
        '$', 506,
        '%', 481,
        '&', 382,
        '\'', 492,
        '(', 427,
        '+', 488,
        ',', 370,
        '-', 488,
        '.', 403,
        '/', 495,
        '0', 508,
        ':', 356,
        '<', 419,
        '=', 351,
        '?', 372,
        '@', 491,
        'L', 540,
        'U', 568,
        '[', 386,
      );
      if (lookahead == '\\') SKIP(6);
      if (lookahead == '`') ADVANCE(231);
      if (lookahead == 'd') ADVANCE(584);
      if (lookahead == 'l') ADVANCE(528);
      if (lookahead == 'm') ADVANCE(569);
      if (lookahead == 'n') ADVANCE(536);
      if (lookahead == 'r') ADVANCE(576);
      if (lookahead == 's') ADVANCE(523);
      if (lookahead == 'u') ADVANCE(531);
      if (lookahead == 'y') ADVANCE(518);
      if (lookahead == '{') ADVANCE(391);
      if (lookahead == '|') ADVANCE(499);
      if (lookahead == '~') ADVANCE(484);
      if (lookahead == '*' ||
          lookahead == '>' ||
          lookahead == '^') ADVANCE(500);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(509);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(144);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(592);
      END_STATE();
    case 110:
      ADVANCE_MAP(
        '!', 486,
        '"', 454,
        '#', 601,
        '$', 506,
        '%', 481,
        '&', 382,
        '\'', 492,
        '(', 427,
        '+', 488,
        ',', 370,
        '-', 488,
        '.', 403,
        '/', 495,
        '0', 508,
        ':', 356,
        '<', 419,
        '=', 351,
        '?', 372,
        '@', 491,
        'L', 540,
        'U', 568,
        '[', 386,
      );
      if (lookahead == '\\') SKIP(52);
      if (lookahead == '`') ADVANCE(231);
      if (lookahead == 'd') ADVANCE(584);
      if (lookahead == 'l') ADVANCE(528);
      if (lookahead == 'm') ADVANCE(569);
      if (lookahead == 'n') ADVANCE(536);
      if (lookahead == 'r') ADVANCE(576);
      if (lookahead == 's') ADVANCE(523);
      if (lookahead == 'u') ADVANCE(531);
      if (lookahead == 'y') ADVANCE(518);
      if (lookahead == '{') ADVANCE(391);
      if (lookahead == '|') ADVANCE(499);
      if (lookahead == '~') ADVANCE(484);
      if (lookahead == '*' ||
          lookahead == '>' ||
          lookahead == '^') ADVANCE(500);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(509);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(138);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(592);
      END_STATE();
    case 111:
      ADVANCE_MAP(
        '!', 486,
        '"', 454,
        '#', 601,
        '$', 506,
        '%', 481,
        '&', 382,
        '\'', 492,
        '(', 427,
        '+', 488,
        ',', 370,
        '-', 488,
        '.', 403,
        '/', 495,
        '0', 508,
        ':', 356,
        '<', 419,
        '=', 351,
        '?', 372,
        '@', 491,
        'M', 549,
        '[', 386,
      );
      if (lookahead == '\\') SKIP(6);
      if (lookahead == '`') ADVANCE(231);
      if (lookahead == 'd') ADVANCE(584);
      if (lookahead == 'f') ADVANCE(544);
      if (lookahead == 'l') ADVANCE(572);
      if (lookahead == 'm') ADVANCE(548);
      if (lookahead == 'r') ADVANCE(576);
      if (lookahead == 'u') ADVANCE(587);
      if (lookahead == 'y') ADVANCE(579);
      if (lookahead == '{') ADVANCE(391);
      if (lookahead == '|') ADVANCE(499);
      if (lookahead == '~') ADVANCE(484);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(556);
      if (lookahead == '*' ||
          lookahead == '>' ||
          lookahead == '^') ADVANCE(500);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(509);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(144);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(592);
      END_STATE();
    case 112:
      ADVANCE_MAP(
        '!', 486,
        '"', 454,
        '#', 601,
        '$', 506,
        '%', 481,
        '&', 382,
        '\'', 492,
        '(', 427,
        '+', 488,
        ',', 370,
        '-', 488,
        '.', 403,
        '/', 495,
        '0', 508,
        ':', 356,
        '<', 419,
        '=', 351,
        '?', 372,
        '@', 491,
        'M', 549,
        '[', 386,
      );
      if (lookahead == '\\') SKIP(6);
      if (lookahead == '`') ADVANCE(231);
      if (lookahead == 'd') ADVANCE(584);
      if (lookahead == 'f') ADVANCE(544);
      if (lookahead == 'l') ADVANCE(572);
      if (lookahead == 'm') ADVANCE(548);
      if (lookahead == 'r') ADVANCE(576);
      if (lookahead == 'u') ADVANCE(587);
      if (lookahead == 'y') ADVANCE(579);
      if (lookahead == '{') ADVANCE(391);
      if (lookahead == '|') ADVANCE(499);
      if (lookahead == '~') ADVANCE(484);
      if (lookahead == '*' ||
          lookahead == '>' ||
          lookahead == '^') ADVANCE(500);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(509);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(144);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(592);
      END_STATE();
    case 113:
      ADVANCE_MAP(
        '!', 486,
        '"', 454,
        '#', 601,
        '$', 506,
        '%', 481,
        '&', 382,
        '\'', 492,
        '(', 427,
        '+', 488,
        ',', 370,
        '-', 488,
        '.', 403,
        '/', 495,
        '0', 508,
        ':', 356,
        '<', 419,
        '=', 351,
        '?', 372,
        '@', 491,
        'M', 549,
        '[', 386,
      );
      if (lookahead == '\\') SKIP(52);
      if (lookahead == '`') ADVANCE(231);
      if (lookahead == 'd') ADVANCE(584);
      if (lookahead == 'f') ADVANCE(544);
      if (lookahead == 'l') ADVANCE(572);
      if (lookahead == 'm') ADVANCE(548);
      if (lookahead == 'r') ADVANCE(576);
      if (lookahead == 'u') ADVANCE(587);
      if (lookahead == 'y') ADVANCE(579);
      if (lookahead == '{') ADVANCE(391);
      if (lookahead == '|') ADVANCE(499);
      if (lookahead == '~') ADVANCE(484);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(556);
      if (lookahead == '*' ||
          lookahead == '>' ||
          lookahead == '^') ADVANCE(500);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(509);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(138);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(592);
      END_STATE();
    case 114:
      ADVANCE_MAP(
        '!', 486,
        '"', 454,
        '#', 601,
        '$', 506,
        '%', 481,
        '&', 382,
        '\'', 492,
        '(', 427,
        '+', 488,
        ',', 370,
        '-', 488,
        '.', 403,
        '/', 495,
        '0', 508,
        ':', 356,
        '<', 419,
        '=', 351,
        '?', 372,
        '@', 491,
        'M', 549,
        '[', 386,
      );
      if (lookahead == '\\') SKIP(52);
      if (lookahead == '`') ADVANCE(231);
      if (lookahead == 'd') ADVANCE(584);
      if (lookahead == 'f') ADVANCE(544);
      if (lookahead == 'l') ADVANCE(572);
      if (lookahead == 'm') ADVANCE(548);
      if (lookahead == 'r') ADVANCE(576);
      if (lookahead == 'u') ADVANCE(587);
      if (lookahead == 'y') ADVANCE(579);
      if (lookahead == '{') ADVANCE(391);
      if (lookahead == '|') ADVANCE(499);
      if (lookahead == '~') ADVANCE(484);
      if (lookahead == '*' ||
          lookahead == '>' ||
          lookahead == '^') ADVANCE(500);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(509);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(138);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(592);
      END_STATE();
    case 115:
      ADVANCE_MAP(
        '!', 486,
        '"', 454,
        '#', 601,
        '$', 506,
        '%', 481,
        '&', 382,
        '\'', 492,
        '(', 427,
        '+', 488,
        ',', 370,
        '-', 488,
        '.', 403,
        '/', 495,
        '0', 508,
        ':', 356,
        '<', 419,
        '=', 351,
        '?', 372,
        '@', 491,
        '[', 386,
      );
      if (lookahead == '\\') SKIP(5);
      if (lookahead == '`') ADVANCE(231);
      if (lookahead == 'a') ADVANCE(586);
      if (lookahead == 'd') ADVANCE(584);
      if (lookahead == 'l') ADVANCE(572);
      if (lookahead == 'm') ADVANCE(569);
      if (lookahead == 'r') ADVANCE(576);
      if (lookahead == 'u') ADVANCE(587);
      if (lookahead == 'y') ADVANCE(579);
      if (lookahead == '{') ADVANCE(391);
      if (lookahead == '|') ADVANCE(499);
      if (lookahead == '~') ADVANCE(484);
      if (lookahead == '*' ||
          lookahead == '>' ||
          lookahead == '^') ADVANCE(500);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(509);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(137);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(592);
      END_STATE();
    case 116:
      ADVANCE_MAP(
        '!', 486,
        '"', 454,
        '#', 601,
        '$', 506,
        '%', 481,
        '&', 382,
        '\'', 492,
        '(', 427,
        '+', 488,
        ',', 370,
        '-', 488,
        '.', 403,
        '/', 495,
        '0', 508,
        ':', 356,
        '<', 419,
        '=', 351,
        '?', 372,
        '@', 491,
        '[', 386,
      );
      if (lookahead == '\\') SKIP(6);
      if (lookahead == '`') ADVANCE(231);
      if (lookahead == 'd') ADVANCE(584);
      if (lookahead == 'l') ADVANCE(572);
      if (lookahead == 'm') ADVANCE(569);
      if (lookahead == 'r') ADVANCE(576);
      if (lookahead == 'u') ADVANCE(587);
      if (lookahead == 'y') ADVANCE(579);
      if (lookahead == '{') ADVANCE(391);
      if (lookahead == '|') ADVANCE(499);
      if (lookahead == '~') ADVANCE(484);
      if (lookahead == '*' ||
          lookahead == '>' ||
          lookahead == '^') ADVANCE(500);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(509);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(144);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(592);
      END_STATE();
    case 117:
      ADVANCE_MAP(
        '!', 486,
        '"', 454,
        '#', 601,
        '$', 506,
        '%', 481,
        '&', 382,
        '\'', 492,
        '(', 427,
        '+', 488,
        ',', 370,
        '-', 488,
        '.', 403,
        '/', 495,
        '0', 508,
        ':', 356,
        '<', 419,
        '=', 351,
        '?', 372,
        '@', 491,
        '[', 386,
      );
      if (lookahead == '\\') SKIP(58);
      if (lookahead == '`') ADVANCE(231);
      if (lookahead == 'd') ADVANCE(584);
      if (lookahead == 'l') ADVANCE(572);
      if (lookahead == 'm') ADVANCE(569);
      if (lookahead == 'r') ADVANCE(576);
      if (lookahead == 'u') ADVANCE(587);
      if (lookahead == 'y') ADVANCE(579);
      if (lookahead == '{') ADVANCE(391);
      if (lookahead == '|') ADVANCE(379);
      if (lookahead == '~') ADVANCE(484);
      if (lookahead == '*' ||
          lookahead == '>' ||
          lookahead == '^') ADVANCE(500);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(509);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(145);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(592);
      END_STATE();
    case 118:
      ADVANCE_MAP(
        '!', 486,
        '"', 454,
        '#', 601,
        '$', 506,
        '%', 481,
        '&', 382,
        '\'', 492,
        '(', 427,
        '+', 488,
        ',', 370,
        '-', 488,
        '.', 403,
        '/', 495,
        '0', 508,
        ':', 356,
        '<', 419,
        '=', 351,
        '?', 372,
        '@', 491,
        '[', 386,
      );
      if (lookahead == '\\') SKIP(61);
      if (lookahead == '`') ADVANCE(231);
      if (lookahead == 'd') ADVANCE(584);
      if (lookahead == 'l') ADVANCE(572);
      if (lookahead == 'm') ADVANCE(569);
      if (lookahead == 'r') ADVANCE(576);
      if (lookahead == 'u') ADVANCE(587);
      if (lookahead == 'y') ADVANCE(579);
      if (lookahead == '{') ADVANCE(391);
      if (lookahead == '|') ADVANCE(379);
      if (lookahead == '~') ADVANCE(484);
      if (lookahead == '*' ||
          lookahead == '>' ||
          lookahead == '^') ADVANCE(500);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(509);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(139);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(592);
      END_STATE();
    case 119:
      ADVANCE_MAP(
        '!', 486,
        '"', 454,
        '#', 601,
        '$', 506,
        '%', 481,
        '&', 382,
        '\'', 492,
        '(', 427,
        '+', 488,
        ',', 370,
        '-', 488,
        '.', 403,
        '/', 495,
        '0', 508,
        ':', 356,
        '<', 419,
        '=', 351,
        '?', 372,
        '@', 489,
        '[', 386,
      );
      if (lookahead == '\\') SKIP(7);
      if (lookahead == '`') ADVANCE(231);
      if (lookahead == 'd') ADVANCE(584);
      if (lookahead == 'l') ADVANCE(572);
      if (lookahead == 'm') ADVANCE(569);
      if (lookahead == 'r') ADVANCE(576);
      if (lookahead == 'u') ADVANCE(587);
      if (lookahead == 'y') ADVANCE(579);
      if (lookahead == '{') ADVANCE(391);
      if (lookahead == '|') ADVANCE(499);
      if (lookahead == '~') ADVANCE(484);
      if (lookahead == '*' ||
          lookahead == '>' ||
          lookahead == '^') ADVANCE(500);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(509);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(140);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(592);
      END_STATE();
    case 120:
      ADVANCE_MAP(
        '!', 486,
        '"', 454,
        '#', 601,
        '$', 506,
        '%', 481,
        '&', 382,
        '\'', 492,
        '(', 427,
        '+', 488,
        ',', 370,
        '-', 488,
        '.', 403,
        '/', 495,
        '0', 508,
        ':', 356,
        '<', 419,
        '=', 351,
        '?', 372,
        '@', 490,
        '[', 386,
      );
      if (lookahead == '\\') SKIP(8);
      if (lookahead == '`') ADVANCE(231);
      if (lookahead == 'd') ADVANCE(584);
      if (lookahead == 'l') ADVANCE(572);
      if (lookahead == 'm') ADVANCE(569);
      if (lookahead == 'r') ADVANCE(576);
      if (lookahead == 'u') ADVANCE(587);
      if (lookahead == 'y') ADVANCE(579);
      if (lookahead == '{') ADVANCE(391);
      if (lookahead == '|') ADVANCE(499);
      if (lookahead == '~') ADVANCE(484);
      if (lookahead == '*' ||
          lookahead == '>' ||
          lookahead == '^') ADVANCE(500);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(509);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(141);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(592);
      END_STATE();
    case 121:
      ADVANCE_MAP(
        '!', 486,
        '"', 454,
        '#', 601,
        '$', 506,
        '%', 481,
        '&', 382,
        '\'', 492,
        '(', 366,
        '*', 432,
        '+', 471,
        ',', 370,
        '-', 474,
        '.', 404,
        '/', 495,
        '0', 508,
        ':', 356,
        '<', 435,
        '=', 351,
        '>', 421,
        '?', 372,
        '@', 491,
        '[', 385,
      );
      if (lookahead == '\\') SKIP(18);
      if (lookahead == '^') ADVANCE(500);
      if (lookahead == '`') ADVANCE(231);
      if (lookahead == 'd') ADVANCE(584);
      if (lookahead == 'l') ADVANCE(572);
      if (lookahead == 'm') ADVANCE(569);
      if (lookahead == 'r') ADVANCE(576);
      if (lookahead == 'u') ADVANCE(587);
      if (lookahead == 'y') ADVANCE(579);
      if (lookahead == '{') ADVANCE(391);
      if (lookahead == '|') ADVANCE(499);
      if (lookahead == '~') ADVANCE(484);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(509);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(121);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(592);
      END_STATE();
    case 122:
      ADVANCE_MAP(
        '!', 486,
        '"', 454,
        '#', 601,
        '$', 506,
        '%', 481,
        '&', 382,
        '\'', 492,
        '(', 366,
        '*', 432,
        '+', 471,
        ',', 370,
        '-', 474,
        '.', 404,
        '/', 495,
        '0', 508,
        ':', 356,
        '<', 435,
        '=', 351,
        '?', 372,
        '@', 491,
        '[', 385,
      );
      if (lookahead == '\\') SKIP(16);
      if (lookahead == '`') ADVANCE(231);
      if (lookahead == 'a') ADVANCE(586);
      if (lookahead == 'd') ADVANCE(584);
      if (lookahead == 'l') ADVANCE(572);
      if (lookahead == 'm') ADVANCE(569);
      if (lookahead == 'r') ADVANCE(576);
      if (lookahead == 'u') ADVANCE(587);
      if (lookahead == 'y') ADVANCE(579);
      if (lookahead == '{') ADVANCE(391);
      if (lookahead == '|') ADVANCE(499);
      if (lookahead == '~') ADVANCE(484);
      if (lookahead == '>' ||
          lookahead == '^') ADVANCE(500);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(509);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(122);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(592);
      END_STATE();
    case 123:
      ADVANCE_MAP(
        '!', 486,
        '"', 454,
        '#', 601,
        '$', 506,
        '%', 481,
        '&', 382,
        '\'', 492,
        '(', 366,
        '*', 432,
        '+', 471,
        ',', 370,
        '-', 474,
        '.', 404,
        '/', 495,
        '0', 508,
        ':', 356,
        '<', 435,
        '=', 351,
        '?', 372,
        '@', 489,
        '[', 385,
      );
      if (lookahead == '\\') SKIP(17);
      if (lookahead == '`') ADVANCE(231);
      if (lookahead == 'd') ADVANCE(584);
      if (lookahead == 'l') ADVANCE(572);
      if (lookahead == 'm') ADVANCE(569);
      if (lookahead == 'r') ADVANCE(576);
      if (lookahead == 'u') ADVANCE(587);
      if (lookahead == 'y') ADVANCE(579);
      if (lookahead == '{') ADVANCE(391);
      if (lookahead == '|') ADVANCE(499);
      if (lookahead == '~') ADVANCE(484);
      if (lookahead == '>' ||
          lookahead == '^') ADVANCE(500);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(509);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(123);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(592);
      END_STATE();
    case 124:
      ADVANCE_MAP(
        '!', 486,
        '"', 454,
        '#', 601,
        '$', 506,
        '%', 481,
        '&', 382,
        '\'', 492,
        '(', 366,
        '*', 432,
        '+', 471,
        ',', 370,
        '-', 474,
        '.', 404,
        '/', 495,
        '0', 508,
        ':', 356,
        '<', 435,
        '=', 351,
        '?', 372,
        '@', 490,
        '[', 385,
      );
      if (lookahead == '\\') SKIP(19);
      if (lookahead == '`') ADVANCE(231);
      if (lookahead == 'd') ADVANCE(584);
      if (lookahead == 'l') ADVANCE(572);
      if (lookahead == 'm') ADVANCE(569);
      if (lookahead == 'r') ADVANCE(576);
      if (lookahead == 'u') ADVANCE(587);
      if (lookahead == 'y') ADVANCE(579);
      if (lookahead == '{') ADVANCE(391);
      if (lookahead == '|') ADVANCE(499);
      if (lookahead == '~') ADVANCE(484);
      if (lookahead == '>' ||
          lookahead == '^') ADVANCE(500);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(509);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(124);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(592);
      END_STATE();
    case 125:
      ADVANCE_MAP(
        '!', 486,
        '"', 454,
        '#', 601,
        '$', 506,
        '%', 481,
        '&', 382,
        '\'', 492,
        '(', 366,
        '*', 432,
        '+', 471,
        ',', 370,
        '-', 474,
        '.', 403,
        '/', 495,
        '0', 508,
        ':', 356,
        '<', 435,
        '=', 351,
        '?', 372,
        '@', 491,
        '[', 385,
      );
      if (lookahead == '\\') SKIP(20);
      if (lookahead == '`') ADVANCE(231);
      if (lookahead == 'd') ADVANCE(584);
      if (lookahead == 'l') ADVANCE(572);
      if (lookahead == 'm') ADVANCE(569);
      if (lookahead == 'r') ADVANCE(576);
      if (lookahead == 'u') ADVANCE(587);
      if (lookahead == 'y') ADVANCE(579);
      if (lookahead == '{') ADVANCE(391);
      if (lookahead == '|') ADVANCE(499);
      if (lookahead == '~') ADVANCE(484);
      if (lookahead == '>' ||
          lookahead == '^') ADVANCE(500);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(509);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(125);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(592);
      END_STATE();
    case 126:
      ADVANCE_MAP(
        '!', 486,
        '"', 454,
        '#', 601,
        '$', 506,
        '%', 481,
        '&', 382,
        '\'', 492,
        '(', 366,
        '+', 471,
        ',', 370,
        '-', 475,
        '.', 402,
        '/', 495,
        '0', 508,
        ':', 356,
        '<', 494,
        '=', 351,
        '?', 372,
        '@', 491,
        '[', 386,
      );
      if (lookahead == '\\') SKIP(14);
      if (lookahead == ']') ADVANCE(387);
      if (lookahead == '`') ADVANCE(231);
      if (lookahead == 'd') ADVANCE(584);
      if (lookahead == 'l') ADVANCE(572);
      if (lookahead == 'm') ADVANCE(569);
      if (lookahead == 'r') ADVANCE(576);
      if (lookahead == 'u') ADVANCE(587);
      if (lookahead == 'y') ADVANCE(579);
      if (lookahead == '{') ADVANCE(391);
      if (lookahead == '|') ADVANCE(499);
      if (lookahead == '~') ADVANCE(484);
      if (lookahead == '*' ||
          lookahead == '>' ||
          lookahead == '^') ADVANCE(500);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(509);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(126);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(592);
      END_STATE();
    case 127:
      ADVANCE_MAP(
        '!', 486,
        '"', 454,
        '#', 601,
        '$', 506,
        '%', 481,
        '&', 382,
        '\'', 492,
        '(', 366,
        '+', 471,
        ',', 370,
        '-', 475,
        '.', 404,
        '/', 495,
        '0', 508,
        ':', 356,
        '<', 494,
        '=', 441,
        '?', 372,
        '@', 491,
        '[', 386,
      );
      if (lookahead == '\\') SKIP(57);
      if (lookahead == '`') ADVANCE(231);
      if (lookahead == 'd') ADVANCE(584);
      if (lookahead == 'l') ADVANCE(572);
      if (lookahead == 'm') ADVANCE(569);
      if (lookahead == 'r') ADVANCE(576);
      if (lookahead == 'u') ADVANCE(587);
      if (lookahead == 'y') ADVANCE(579);
      if (lookahead == '{') ADVANCE(391);
      if (lookahead == '|') ADVANCE(499);
      if (lookahead == '~') ADVANCE(484);
      if (lookahead == '*' ||
          lookahead == '>' ||
          lookahead == '^') ADVANCE(500);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(509);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(127);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(592);
      END_STATE();
    case 128:
      ADVANCE_MAP(
        '!', 486,
        '"', 454,
        '#', 601,
        '$', 506,
        '%', 481,
        '&', 382,
        '\'', 492,
        '(', 366,
        '+', 471,
        ',', 370,
        '-', 475,
        '.', 404,
        '/', 495,
        '0', 508,
        ':', 356,
        '<', 494,
        '=', 351,
        '>', 421,
        '?', 372,
        '@', 491,
        '[', 386,
      );
      if (lookahead == '\\') SKIP(15);
      if (lookahead == '`') ADVANCE(231);
      if (lookahead == 'd') ADVANCE(584);
      if (lookahead == 'l') ADVANCE(572);
      if (lookahead == 'm') ADVANCE(569);
      if (lookahead == 'r') ADVANCE(576);
      if (lookahead == 'u') ADVANCE(587);
      if (lookahead == 'y') ADVANCE(579);
      if (lookahead == '{') ADVANCE(391);
      if (lookahead == '|') ADVANCE(499);
      if (lookahead == '~') ADVANCE(484);
      if (lookahead == '*' ||
          lookahead == '^') ADVANCE(500);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(509);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(128);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(592);
      END_STATE();
    case 129:
      ADVANCE_MAP(
        '!', 486,
        '"', 454,
        '#', 601,
        '$', 506,
        '%', 481,
        '&', 382,
        '\'', 492,
        '(', 366,
        '+', 471,
        ',', 370,
        '-', 475,
        '.', 404,
        '/', 495,
        '0', 508,
        ':', 356,
        '<', 494,
        '=', 351,
        '>', 421,
        '?', 372,
        '@', 491,
        '[', 386,
      );
      if (lookahead == '\\') SKIP(24);
      if (lookahead == '`') ADVANCE(231);
      if (lookahead == 'd') ADVANCE(584);
      if (lookahead == 'l') ADVANCE(572);
      if (lookahead == 'm') ADVANCE(569);
      if (lookahead == 'r') ADVANCE(576);
      if (lookahead == 'u') ADVANCE(587);
      if (lookahead == 'y') ADVANCE(579);
      if (lookahead == '{') ADVANCE(391);
      if (lookahead == '|') ADVANCE(379);
      if (lookahead == '~') ADVANCE(484);
      if (lookahead == '*' ||
          lookahead == '^') ADVANCE(500);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(509);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(129);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(592);
      END_STATE();
    case 130:
      ADVANCE_MAP(
        '!', 486,
        '"', 454,
        '#', 601,
        '$', 506,
        '%', 481,
        '&', 382,
        '\'', 492,
        '(', 366,
        '+', 471,
        ',', 370,
        '-', 475,
        '.', 404,
        '/', 495,
        '0', 508,
        ':', 356,
        '<', 494,
        '=', 351,
        '?', 372,
        '@', 491,
        '[', 386,
      );
      if (lookahead == '\\') SKIP(13);
      if (lookahead == '`') ADVANCE(231);
      if (lookahead == 'a') ADVANCE(586);
      if (lookahead == 'd') ADVANCE(584);
      if (lookahead == 'l') ADVANCE(572);
      if (lookahead == 'm') ADVANCE(569);
      if (lookahead == 'r') ADVANCE(576);
      if (lookahead == 'u') ADVANCE(587);
      if (lookahead == 'y') ADVANCE(579);
      if (lookahead == '{') ADVANCE(391);
      if (lookahead == '|') ADVANCE(499);
      if (lookahead == '~') ADVANCE(484);
      if (lookahead == '*' ||
          lookahead == '>' ||
          lookahead == '^') ADVANCE(500);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(509);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(130);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(592);
      END_STATE();
    case 131:
      ADVANCE_MAP(
        '!', 486,
        '"', 454,
        '#', 601,
        '$', 506,
        '%', 481,
        '&', 382,
        '\'', 492,
        '(', 366,
        '+', 471,
        ',', 370,
        '-', 475,
        '.', 404,
        '/', 495,
        '0', 508,
        ':', 356,
        '<', 494,
        '=', 351,
        '?', 372,
        '@', 491,
        '[', 386,
      );
      if (lookahead == '\\') SKIP(21);
      if (lookahead == '`') ADVANCE(231);
      if (lookahead == 'a') ADVANCE(586);
      if (lookahead == 'd') ADVANCE(584);
      if (lookahead == 'l') ADVANCE(572);
      if (lookahead == 'm') ADVANCE(569);
      if (lookahead == 'r') ADVANCE(576);
      if (lookahead == 'u') ADVANCE(587);
      if (lookahead == 'y') ADVANCE(579);
      if (lookahead == '{') ADVANCE(391);
      if (lookahead == '|') ADVANCE(379);
      if (lookahead == '~') ADVANCE(484);
      if (lookahead == '*' ||
          lookahead == '>' ||
          lookahead == '^') ADVANCE(500);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(509);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(131);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(592);
      END_STATE();
    case 132:
      ADVANCE_MAP(
        '!', 486,
        '"', 454,
        '#', 601,
        '$', 506,
        '%', 481,
        '&', 382,
        '\'', 492,
        '(', 366,
        '+', 471,
        ',', 370,
        '-', 475,
        '.', 404,
        '/', 495,
        '0', 508,
        ':', 356,
        '<', 494,
        '=', 351,
        '?', 372,
        '@', 489,
        '[', 386,
      );
      if (lookahead == '\\') SKIP(55);
      if (lookahead == '`') ADVANCE(231);
      if (lookahead == 'd') ADVANCE(584);
      if (lookahead == 'l') ADVANCE(572);
      if (lookahead == 'm') ADVANCE(569);
      if (lookahead == 'r') ADVANCE(576);
      if (lookahead == 'u') ADVANCE(587);
      if (lookahead == 'y') ADVANCE(579);
      if (lookahead == '{') ADVANCE(391);
      if (lookahead == '|') ADVANCE(499);
      if (lookahead == '~') ADVANCE(484);
      if (lookahead == '*' ||
          lookahead == '>' ||
          lookahead == '^') ADVANCE(500);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(509);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(132);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(592);
      END_STATE();
    case 133:
      ADVANCE_MAP(
        '!', 486,
        '"', 454,
        '#', 601,
        '$', 506,
        '%', 481,
        '&', 382,
        '\'', 492,
        '(', 366,
        '+', 471,
        ',', 370,
        '-', 475,
        '.', 404,
        '/', 495,
        '0', 508,
        ':', 356,
        '<', 494,
        '=', 351,
        '?', 372,
        '@', 489,
        '[', 386,
      );
      if (lookahead == '\\') SKIP(59);
      if (lookahead == '`') ADVANCE(231);
      if (lookahead == 'd') ADVANCE(584);
      if (lookahead == 'l') ADVANCE(572);
      if (lookahead == 'm') ADVANCE(569);
      if (lookahead == 'r') ADVANCE(576);
      if (lookahead == 'u') ADVANCE(587);
      if (lookahead == 'y') ADVANCE(579);
      if (lookahead == '{') ADVANCE(391);
      if (lookahead == '|') ADVANCE(379);
      if (lookahead == '~') ADVANCE(484);
      if (lookahead == '*' ||
          lookahead == '>' ||
          lookahead == '^') ADVANCE(500);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(509);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(133);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(592);
      END_STATE();
    case 134:
      ADVANCE_MAP(
        '!', 486,
        '"', 454,
        '#', 601,
        '$', 506,
        '%', 481,
        '&', 382,
        '\'', 492,
        '(', 366,
        '+', 471,
        ',', 370,
        '-', 475,
        '.', 404,
        '/', 495,
        '0', 508,
        ':', 356,
        '<', 494,
        '=', 351,
        '?', 372,
        '@', 490,
        '[', 386,
      );
      if (lookahead == '\\') SKIP(54);
      if (lookahead == '`') ADVANCE(231);
      if (lookahead == 'd') ADVANCE(584);
      if (lookahead == 'l') ADVANCE(572);
      if (lookahead == 'm') ADVANCE(569);
      if (lookahead == 'r') ADVANCE(576);
      if (lookahead == 'u') ADVANCE(587);
      if (lookahead == 'y') ADVANCE(579);
      if (lookahead == '{') ADVANCE(391);
      if (lookahead == '|') ADVANCE(499);
      if (lookahead == '~') ADVANCE(484);
      if (lookahead == '*' ||
          lookahead == '>' ||
          lookahead == '^') ADVANCE(500);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(509);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(134);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(592);
      END_STATE();
    case 135:
      ADVANCE_MAP(
        '!', 486,
        '"', 454,
        '#', 601,
        '$', 506,
        '%', 481,
        '&', 382,
        '\'', 492,
        '(', 366,
        '+', 471,
        ',', 370,
        '-', 475,
        '.', 404,
        '/', 495,
        '0', 508,
        ':', 356,
        '<', 494,
        '=', 351,
        '?', 372,
        '@', 490,
        '[', 386,
      );
      if (lookahead == '\\') SKIP(60);
      if (lookahead == '`') ADVANCE(231);
      if (lookahead == 'd') ADVANCE(584);
      if (lookahead == 'l') ADVANCE(572);
      if (lookahead == 'm') ADVANCE(569);
      if (lookahead == 'r') ADVANCE(576);
      if (lookahead == 'u') ADVANCE(587);
      if (lookahead == 'y') ADVANCE(579);
      if (lookahead == '{') ADVANCE(391);
      if (lookahead == '|') ADVANCE(379);
      if (lookahead == '~') ADVANCE(484);
      if (lookahead == '*' ||
          lookahead == '>' ||
          lookahead == '^') ADVANCE(500);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(509);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(135);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(592);
      END_STATE();
    case 136:
      ADVANCE_MAP(
        '!', 486,
        '"', 454,
        '#', 601,
        '$', 506,
        '%', 481,
        '&', 382,
        '\'', 492,
        '(', 366,
        '+', 471,
        ',', 370,
        '-', 475,
        '.', 403,
        '/', 495,
        '0', 508,
        ':', 356,
        '<', 494,
        '=', 351,
        '>', 421,
        '?', 372,
        '@', 491,
        '[', 386,
      );
      if (lookahead == '\\') SKIP(9);
      if (lookahead == '`') ADVANCE(231);
      if (lookahead == 'd') ADVANCE(584);
      if (lookahead == 'l') ADVANCE(572);
      if (lookahead == 'm') ADVANCE(569);
      if (lookahead == 'r') ADVANCE(576);
      if (lookahead == 'u') ADVANCE(587);
      if (lookahead == 'y') ADVANCE(579);
      if (lookahead == '{') ADVANCE(391);
      if (lookahead == '|') ADVANCE(499);
      if (lookahead == '~') ADVANCE(484);
      if (lookahead == '*' ||
          lookahead == '^') ADVANCE(500);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(509);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(136);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(592);
      END_STATE();
    case 137:
      ADVANCE_MAP(
        '!', 486,
        '"', 454,
        '#', 601,
        '$', 506,
        '%', 481,
        '&', 382,
        '\'', 492,
        '(', 366,
        '+', 471,
        ',', 370,
        '-', 475,
        '.', 403,
        '/', 495,
        '0', 508,
        ':', 356,
        '<', 494,
        '=', 351,
        '?', 372,
        '@', 491,
        '[', 386,
      );
      if (lookahead == '\\') SKIP(5);
      if (lookahead == '`') ADVANCE(231);
      if (lookahead == 'a') ADVANCE(586);
      if (lookahead == 'd') ADVANCE(584);
      if (lookahead == 'l') ADVANCE(572);
      if (lookahead == 'm') ADVANCE(569);
      if (lookahead == 'r') ADVANCE(576);
      if (lookahead == 'u') ADVANCE(587);
      if (lookahead == 'y') ADVANCE(579);
      if (lookahead == '{') ADVANCE(391);
      if (lookahead == '|') ADVANCE(499);
      if (lookahead == '~') ADVANCE(484);
      if (lookahead == '*' ||
          lookahead == '>' ||
          lookahead == '^') ADVANCE(500);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(509);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(137);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(592);
      END_STATE();
    case 138:
      ADVANCE_MAP(
        '!', 486,
        '"', 454,
        '#', 601,
        '$', 506,
        '%', 481,
        '&', 382,
        '\'', 492,
        '(', 366,
        '+', 471,
        ',', 370,
        '-', 475,
        '.', 403,
        '/', 495,
        '0', 508,
        ':', 356,
        '<', 494,
        '=', 351,
        '?', 372,
        '@', 491,
        '[', 386,
      );
      if (lookahead == '\\') SKIP(52);
      if (lookahead == '`') ADVANCE(231);
      if (lookahead == 'd') ADVANCE(584);
      if (lookahead == 'l') ADVANCE(572);
      if (lookahead == 'm') ADVANCE(569);
      if (lookahead == 'r') ADVANCE(576);
      if (lookahead == 'u') ADVANCE(587);
      if (lookahead == 'y') ADVANCE(579);
      if (lookahead == '{') ADVANCE(391);
      if (lookahead == '|') ADVANCE(499);
      if (lookahead == '~') ADVANCE(484);
      if (lookahead == '*' ||
          lookahead == '>' ||
          lookahead == '^') ADVANCE(500);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(509);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(138);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(592);
      END_STATE();
    case 139:
      ADVANCE_MAP(
        '!', 486,
        '"', 454,
        '#', 601,
        '$', 506,
        '%', 481,
        '&', 382,
        '\'', 492,
        '(', 366,
        '+', 471,
        ',', 370,
        '-', 475,
        '.', 403,
        '/', 495,
        '0', 508,
        ':', 356,
        '<', 494,
        '=', 351,
        '?', 372,
        '@', 491,
        '[', 386,
      );
      if (lookahead == '\\') SKIP(61);
      if (lookahead == '`') ADVANCE(231);
      if (lookahead == 'd') ADVANCE(584);
      if (lookahead == 'l') ADVANCE(572);
      if (lookahead == 'm') ADVANCE(569);
      if (lookahead == 'r') ADVANCE(576);
      if (lookahead == 'u') ADVANCE(587);
      if (lookahead == 'y') ADVANCE(579);
      if (lookahead == '{') ADVANCE(391);
      if (lookahead == '|') ADVANCE(379);
      if (lookahead == '~') ADVANCE(484);
      if (lookahead == '*' ||
          lookahead == '>' ||
          lookahead == '^') ADVANCE(500);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(509);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(139);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(592);
      END_STATE();
    case 140:
      ADVANCE_MAP(
        '!', 486,
        '"', 454,
        '#', 601,
        '$', 506,
        '%', 481,
        '&', 382,
        '\'', 492,
        '(', 366,
        '+', 471,
        ',', 370,
        '-', 475,
        '.', 403,
        '/', 495,
        '0', 508,
        ':', 356,
        '<', 494,
        '=', 351,
        '?', 372,
        '@', 489,
        '[', 386,
      );
      if (lookahead == '\\') SKIP(7);
      if (lookahead == '`') ADVANCE(231);
      if (lookahead == 'd') ADVANCE(584);
      if (lookahead == 'l') ADVANCE(572);
      if (lookahead == 'm') ADVANCE(569);
      if (lookahead == 'r') ADVANCE(576);
      if (lookahead == 'u') ADVANCE(587);
      if (lookahead == 'y') ADVANCE(579);
      if (lookahead == '{') ADVANCE(391);
      if (lookahead == '|') ADVANCE(499);
      if (lookahead == '~') ADVANCE(484);
      if (lookahead == '*' ||
          lookahead == '>' ||
          lookahead == '^') ADVANCE(500);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(509);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(140);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(592);
      END_STATE();
    case 141:
      ADVANCE_MAP(
        '!', 486,
        '"', 454,
        '#', 601,
        '$', 506,
        '%', 481,
        '&', 382,
        '\'', 492,
        '(', 366,
        '+', 471,
        ',', 370,
        '-', 475,
        '.', 403,
        '/', 495,
        '0', 508,
        ':', 356,
        '<', 494,
        '=', 351,
        '?', 372,
        '@', 490,
        '[', 386,
      );
      if (lookahead == '\\') SKIP(8);
      if (lookahead == '`') ADVANCE(231);
      if (lookahead == 'd') ADVANCE(584);
      if (lookahead == 'l') ADVANCE(572);
      if (lookahead == 'm') ADVANCE(569);
      if (lookahead == 'r') ADVANCE(576);
      if (lookahead == 'u') ADVANCE(587);
      if (lookahead == 'y') ADVANCE(579);
      if (lookahead == '{') ADVANCE(391);
      if (lookahead == '|') ADVANCE(499);
      if (lookahead == '~') ADVANCE(484);
      if (lookahead == '*' ||
          lookahead == '>' ||
          lookahead == '^') ADVANCE(500);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(509);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(141);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(592);
      END_STATE();
    case 142:
      ADVANCE_MAP(
        '!', 486,
        '"', 454,
        '#', 601,
        '$', 506,
        '%', 481,
        '&', 382,
        '\'', 492,
        '(', 366,
        '+', 471,
        ',', 370,
        '-', 474,
        '.', 402,
        '/', 495,
        '0', 508,
        ':', 356,
        '<', 494,
        '=', 351,
        '?', 372,
        '@', 491,
        '[', 386,
      );
      if (lookahead == '\\') SKIP(56);
      if (lookahead == '`') ADVANCE(231);
      if (lookahead == 'd') ADVANCE(584);
      if (lookahead == 'l') ADVANCE(572);
      if (lookahead == 'm') ADVANCE(569);
      if (lookahead == 'r') ADVANCE(576);
      if (lookahead == 'u') ADVANCE(587);
      if (lookahead == 'y') ADVANCE(579);
      if (lookahead == '{') ADVANCE(391);
      if (lookahead == '|') ADVANCE(499);
      if (lookahead == '~') ADVANCE(484);
      if (lookahead == '*' ||
          lookahead == '>' ||
          lookahead == '^') ADVANCE(500);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(509);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(142);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(592);
      END_STATE();
    case 143:
      ADVANCE_MAP(
        '!', 486,
        '"', 454,
        '#', 601,
        '$', 506,
        '%', 481,
        '&', 382,
        '\'', 492,
        '(', 366,
        '+', 471,
        ',', 370,
        '-', 474,
        '.', 404,
        '/', 495,
        '0', 508,
        ':', 356,
        '<', 494,
        '=', 351,
        '?', 372,
        '@', 491,
        '[', 386,
      );
      if (lookahead == '\\') SKIP(50);
      if (lookahead == '`') ADVANCE(231);
      if (lookahead == 'd') ADVANCE(584);
      if (lookahead == 'l') ADVANCE(572);
      if (lookahead == 'm') ADVANCE(569);
      if (lookahead == 'r') ADVANCE(576);
      if (lookahead == 'u') ADVANCE(587);
      if (lookahead == 'y') ADVANCE(579);
      if (lookahead == '{') ADVANCE(391);
      if (lookahead == '|') ADVANCE(499);
      if (lookahead == '~') ADVANCE(484);
      if (lookahead == '*' ||
          lookahead == '>' ||
          lookahead == '^') ADVANCE(500);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(509);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(143);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(592);
      END_STATE();
    case 144:
      ADVANCE_MAP(
        '!', 486,
        '"', 454,
        '#', 601,
        '$', 506,
        '%', 481,
        '&', 382,
        '\'', 492,
        '(', 366,
        '+', 471,
        ',', 370,
        '-', 474,
        '.', 403,
        '/', 495,
        '0', 508,
        ':', 356,
        '<', 494,
        '=', 351,
        '?', 372,
        '@', 491,
        '[', 386,
      );
      if (lookahead == '\\') SKIP(6);
      if (lookahead == '`') ADVANCE(231);
      if (lookahead == 'd') ADVANCE(584);
      if (lookahead == 'l') ADVANCE(572);
      if (lookahead == 'm') ADVANCE(569);
      if (lookahead == 'r') ADVANCE(576);
      if (lookahead == 'u') ADVANCE(587);
      if (lookahead == 'y') ADVANCE(579);
      if (lookahead == '{') ADVANCE(391);
      if (lookahead == '|') ADVANCE(499);
      if (lookahead == '~') ADVANCE(484);
      if (lookahead == '*' ||
          lookahead == '>' ||
          lookahead == '^') ADVANCE(500);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(509);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(144);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(592);
      END_STATE();
    case 145:
      ADVANCE_MAP(
        '!', 486,
        '"', 454,
        '#', 601,
        '$', 506,
        '%', 481,
        '&', 382,
        '\'', 492,
        '(', 366,
        '+', 471,
        ',', 370,
        '-', 474,
        '.', 403,
        '/', 495,
        '0', 508,
        ':', 356,
        '<', 494,
        '=', 351,
        '?', 372,
        '@', 491,
        '[', 386,
      );
      if (lookahead == '\\') SKIP(58);
      if (lookahead == '`') ADVANCE(231);
      if (lookahead == 'd') ADVANCE(584);
      if (lookahead == 'l') ADVANCE(572);
      if (lookahead == 'm') ADVANCE(569);
      if (lookahead == 'r') ADVANCE(576);
      if (lookahead == 'u') ADVANCE(587);
      if (lookahead == 'y') ADVANCE(579);
      if (lookahead == '{') ADVANCE(391);
      if (lookahead == '|') ADVANCE(379);
      if (lookahead == '~') ADVANCE(484);
      if (lookahead == '*' ||
          lookahead == '>' ||
          lookahead == '^') ADVANCE(500);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(509);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(145);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(592);
      END_STATE();
    case 146:
      if (lookahead == '"') ADVANCE(452);
      END_STATE();
    case 147:
      if (lookahead == '"') ADVANCE(459);
      END_STATE();
    case 148:
      if (lookahead == '"') ADVANCE(459);
      if (lookahead == '>') ADVANCE(395);
      if (lookahead == '@') ADVANCE(223);
      END_STATE();
    case 149:
      ADVANCE_MAP(
        '"', 453,
        '#', 602,
        '&', 380,
        '\'', 440,
        '(', 215,
        ')', 369,
        '+', 322,
        ',', 370,
        '-', 225,
        '.', 550,
        '/', 219,
        ':', 355,
        '<', 433,
        '=', 351,
        '>', 420,
        '@', 147,
        'L', 539,
        'U', 227,
      );
      if (lookahead == '\\') SKIP(39);
      if (lookahead == '^') ADVANCE(439);
      if (lookahead == 'a') ADVANCE(314);
      if (lookahead == 'f') ADVANCE(543);
      if (lookahead == 'i') ADVANCE(271);
      if (lookahead == 'l') ADVANCE(527);
      if (lookahead == 'n') ADVANCE(535);
      if (lookahead == 's') ADVANCE(522);
      if (lookahead == 'u') ADVANCE(533);
      if (lookahead == 'w') ADVANCE(245);
      if (lookahead == 'y') ADVANCE(517);
      if (lookahead == '|') ADVANCE(376);
      if (lookahead == '}') ADVANCE(392);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(555);
      if (lookahead == 'M' ||
          lookahead == 'm') ADVANCE(547);
      if (lookahead == 'G' ||
          lookahead == 'I' ||
          lookahead == 'N' ||
          lookahead == 'Q' ||
          lookahead == 'R' ||
          lookahead == 'Z') ADVANCE(545);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(150);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(509);
      END_STATE();
    case 150:
      ADVANCE_MAP(
        '"', 453,
        '#', 602,
        '&', 380,
        '\'', 440,
        '(', 215,
        ')', 369,
        '+', 322,
        ',', 370,
        '-', 225,
        '/', 219,
        ':', 355,
        '<', 433,
        '=', 351,
        '>', 420,
        '@', 147,
      );
      if (lookahead == '\\') SKIP(39);
      if (lookahead == '^') ADVANCE(439);
      if (lookahead == 'a') ADVANCE(314);
      if (lookahead == 'i') ADVANCE(271);
      if (lookahead == 'w') ADVANCE(245);
      if (lookahead == '|') ADVANCE(376);
      if (lookahead == '}') ADVANCE(392);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(150);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(509);
      END_STATE();
    case 151:
      if (lookahead == '"') ADVANCE(453);
      if (lookahead == '#') ADVANCE(602);
      if (lookahead == '(') ADVANCE(215);
      if (lookahead == '/') ADVANCE(219);
      if (lookahead == '\\') ADVANCE(45);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(151);
      END_STATE();
    case 152:
      if (lookahead == '"') ADVANCE(453);
      if (lookahead == '#') ADVANCE(447);
      if (lookahead == '(') ADVANCE(447);
      if (lookahead == '/') ADVANCE(447);
      if (lookahead == '\\') ADVANCE(3);
      if (lookahead == '{') ADVANCE(451);
      if (lookahead == '\t' ||
          (0x0b <= lookahead && lookahead <= '\r')) SKIP(151);
      if (lookahead == '\n' ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) ADVANCE(447);
      if (lookahead != 0 &&
          (lookahead < 0x07 || '\r' < lookahead)) ADVANCE(447);
      END_STATE();
    case 153:
      if (lookahead == '"') ADVANCE(453);
      if (lookahead == '#') ADVANCE(447);
      if (lookahead == '(') ADVANCE(447);
      if (lookahead == '/') ADVANCE(447);
      if (lookahead == '\\') ADVANCE(3);
      if (lookahead == '\t' ||
          (0x0b <= lookahead && lookahead <= '\r')) SKIP(151);
      if (lookahead == '\n' ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) ADVANCE(447);
      if (lookahead != 0 &&
          (lookahead < 0x07 || '\r' < lookahead)) ADVANCE(447);
      END_STATE();
    case 154:
      if (lookahead == '"') ADVANCE(464);
      END_STATE();
    case 155:
      ADVANCE_MAP(
        '"', 454,
        '#', 438,
        '$', 146,
        '\'', 440,
        '(', 367,
        '/', 219,
        '0', 508,
        '>', 420,
        '@', 147,
      );
      if (lookahead == '\\') SKIP(28);
      if (lookahead == '^') ADVANCE(439);
      if (lookahead == '`') ADVANCE(231);
      if (lookahead == '{') ADVANCE(319);
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(322);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(509);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(155);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(592);
      END_STATE();
    case 156:
      ADVANCE_MAP(
        '"', 454,
        '#', 599,
        '$', 146,
        '%', 480,
        '&', 381,
        '\'', 208,
        '(', 366,
        '*', 430,
        '+', 470,
        ',', 370,
        '-', 473,
        '.', 218,
        '/', 219,
        '0', 508,
        '<', 226,
        '>', 420,
        '@', 147,
        '[', 386,
      );
      if (lookahead == '\\') SKIP(10);
      if (lookahead == ']') ADVANCE(387);
      if (lookahead == '`') ADVANCE(231);
      if (lookahead == 'd') ADVANCE(584);
      if (lookahead == 'l') ADVANCE(572);
      if (lookahead == 'm') ADVANCE(569);
      if (lookahead == 'r') ADVANCE(576);
      if (lookahead == 'u') ADVANCE(587);
      if (lookahead == 'y') ADVANCE(579);
      if (lookahead == '{') ADVANCE(391);
      if (lookahead == '~') ADVANCE(484);
      if (lookahead == '!' ||
          lookahead == '?') ADVANCE(487);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(509);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(156);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(592);
      END_STATE();
    case 157:
      ADVANCE_MAP(
        '"', 454,
        '#', 601,
        '$', 146,
        '%', 480,
        '&', 381,
        '\'', 208,
        '(', 366,
        '*', 430,
        '+', 470,
        '-', 472,
        '.', 401,
        '/', 219,
        '0', 508,
        ':', 222,
        '<', 436,
        '>', 230,
        '@', 147,
        '[', 385,
      );
      if (lookahead == '\\') SKIP(11);
      if (lookahead == '`') ADVANCE(231);
      if (lookahead == 'd') ADVANCE(584);
      if (lookahead == 'l') ADVANCE(572);
      if (lookahead == 'm') ADVANCE(569);
      if (lookahead == 'r') ADVANCE(576);
      if (lookahead == 'u') ADVANCE(587);
      if (lookahead == 'y') ADVANCE(579);
      if (lookahead == '{') ADVANCE(391);
      if (lookahead == '~') ADVANCE(484);
      if (lookahead == '!' ||
          lookahead == '?') ADVANCE(487);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(509);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(157);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(592);
      END_STATE();
    case 158:
      ADVANCE_MAP(
        '"', 454,
        '#', 601,
        '$', 146,
        '%', 480,
        '&', 381,
        '\'', 208,
        '(', 366,
        '+', 470,
        ',', 370,
        '-', 473,
        '.', 550,
        '/', 219,
        '0', 508,
        '<', 226,
        '>', 420,
        '@', 147,
        'L', 540,
        'M', 549,
        'U', 568,
        '[', 386,
      );
      if (lookahead == '\\') SKIP(27);
      if (lookahead == '`') ADVANCE(231);
      if (lookahead == 'd') ADVANCE(584);
      if (lookahead == 'l') ADVANCE(528);
      if (lookahead == 'm') ADVANCE(548);
      if (lookahead == 'n') ADVANCE(536);
      if (lookahead == 'r') ADVANCE(576);
      if (lookahead == 's') ADVANCE(523);
      if (lookahead == 'u') ADVANCE(531);
      if (lookahead == 'y') ADVANCE(518);
      if (lookahead == '{') ADVANCE(391);
      if (lookahead == '~') ADVANCE(484);
      if (lookahead == '!' ||
          lookahead == '?') ADVANCE(487);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(556);
      if (lookahead == 'G' ||
          lookahead == 'I' ||
          lookahead == 'N' ||
          lookahead == 'Q' ||
          lookahead == 'R' ||
          lookahead == 'Z') ADVANCE(546);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(509);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(162);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(592);
      END_STATE();
    case 159:
      ADVANCE_MAP(
        '"', 454,
        '#', 601,
        '$', 146,
        '%', 480,
        '&', 381,
        '\'', 208,
        '(', 366,
        '+', 470,
        ',', 370,
        '-', 473,
        '/', 219,
        '0', 508,
        '<', 226,
        '>', 420,
        '@', 147,
        'L', 540,
        'U', 568,
        '[', 386,
      );
      if (lookahead == '\\') SKIP(27);
      if (lookahead == '`') ADVANCE(231);
      if (lookahead == 'd') ADVANCE(584);
      if (lookahead == 'l') ADVANCE(528);
      if (lookahead == 'm') ADVANCE(569);
      if (lookahead == 'n') ADVANCE(536);
      if (lookahead == 'r') ADVANCE(576);
      if (lookahead == 's') ADVANCE(523);
      if (lookahead == 'u') ADVANCE(531);
      if (lookahead == 'y') ADVANCE(518);
      if (lookahead == '{') ADVANCE(391);
      if (lookahead == '~') ADVANCE(484);
      if (lookahead == '!' ||
          lookahead == '?') ADVANCE(487);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(509);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(162);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(592);
      END_STATE();
    case 160:
      ADVANCE_MAP(
        '"', 454,
        '#', 601,
        '$', 146,
        '%', 480,
        '&', 381,
        '\'', 208,
        '(', 366,
        '+', 470,
        ',', 370,
        '-', 473,
        '/', 219,
        '0', 508,
        '<', 226,
        '>', 420,
        '@', 147,
        'M', 549,
        '[', 386,
      );
      if (lookahead == '\\') SKIP(27);
      if (lookahead == '`') ADVANCE(231);
      if (lookahead == 'd') ADVANCE(584);
      if (lookahead == 'f') ADVANCE(544);
      if (lookahead == 'l') ADVANCE(572);
      if (lookahead == 'm') ADVANCE(548);
      if (lookahead == 'r') ADVANCE(576);
      if (lookahead == 'u') ADVANCE(587);
      if (lookahead == 'y') ADVANCE(579);
      if (lookahead == '{') ADVANCE(391);
      if (lookahead == '~') ADVANCE(484);
      if (lookahead == '!' ||
          lookahead == '?') ADVANCE(487);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(556);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(509);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(162);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(592);
      END_STATE();
    case 161:
      ADVANCE_MAP(
        '"', 454,
        '#', 601,
        '$', 146,
        '%', 480,
        '&', 381,
        '\'', 208,
        '(', 366,
        '+', 470,
        ',', 370,
        '-', 473,
        '/', 219,
        '0', 508,
        '<', 226,
        '>', 420,
        '@', 147,
        'M', 549,
        '[', 386,
      );
      if (lookahead == '\\') SKIP(27);
      if (lookahead == '`') ADVANCE(231);
      if (lookahead == 'd') ADVANCE(584);
      if (lookahead == 'f') ADVANCE(544);
      if (lookahead == 'l') ADVANCE(572);
      if (lookahead == 'm') ADVANCE(548);
      if (lookahead == 'r') ADVANCE(576);
      if (lookahead == 'u') ADVANCE(587);
      if (lookahead == 'y') ADVANCE(579);
      if (lookahead == '{') ADVANCE(391);
      if (lookahead == '~') ADVANCE(484);
      if (lookahead == '!' ||
          lookahead == '?') ADVANCE(487);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(509);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(162);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(592);
      END_STATE();
    case 162:
      ADVANCE_MAP(
        '"', 454,
        '#', 601,
        '$', 146,
        '%', 480,
        '&', 381,
        '\'', 208,
        '(', 366,
        '+', 470,
        ',', 370,
        '-', 473,
        '/', 219,
        '0', 508,
        '<', 226,
        '>', 420,
        '@', 147,
        '[', 386,
      );
      if (lookahead == '\\') SKIP(27);
      if (lookahead == '`') ADVANCE(231);
      if (lookahead == 'd') ADVANCE(584);
      if (lookahead == 'l') ADVANCE(572);
      if (lookahead == 'm') ADVANCE(569);
      if (lookahead == 'r') ADVANCE(576);
      if (lookahead == 'u') ADVANCE(587);
      if (lookahead == 'y') ADVANCE(579);
      if (lookahead == '{') ADVANCE(391);
      if (lookahead == '~') ADVANCE(484);
      if (lookahead == '!' ||
          lookahead == '?') ADVANCE(487);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(509);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(162);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(592);
      END_STATE();
    case 163:
      ADVANCE_MAP(
        '"', 454,
        '#', 602,
        '$', 146,
        '&', 380,
        '\'', 208,
        '(', 366,
        ')', 369,
        '*', 430,
        '+', 322,
        ',', 370,
        '-', 225,
        '.', 401,
        '/', 219,
        '0', 508,
        ':', 358,
        '<', 433,
        '=', 351,
        '?', 371,
        '@', 147,
        '[', 383,
      );
      if (lookahead == '\\') SKIP(32);
      if (lookahead == '`') ADVANCE(231);
      if (lookahead == 'a') ADVANCE(586);
      if (lookahead == 'w') ADVANCE(577);
      if (lookahead == '{') ADVANCE(390);
      if (lookahead == '|') ADVANCE(376);
      if (lookahead == '}') ADVANCE(392);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(509);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(163);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(592);
      END_STATE();
    case 164:
      ADVANCE_MAP(
        '"', 454,
        '#', 602,
        '$', 146,
        '&', 380,
        '\'', 208,
        '(', 366,
        ')', 369,
        '*', 430,
        '+', 322,
        ',', 370,
        '-', 225,
        '.', 401,
        '/', 219,
        '0', 508,
        ':', 358,
        '<', 433,
        '=', 351,
        '?', 371,
        '@', 147,
        '[', 383,
      );
      if (lookahead == '\\') SKIP(33);
      if (lookahead == '`') ADVANCE(231);
      if (lookahead == 'a') ADVANCE(586);
      if (lookahead == '{') ADVANCE(390);
      if (lookahead == '|') ADVANCE(376);
      if (lookahead == '}') ADVANCE(392);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(509);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(164);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(592);
      END_STATE();
    case 165:
      ADVANCE_MAP(
        '"', 454,
        '#', 602,
        '$', 146,
        '&', 380,
        '\'', 208,
        '(', 366,
        ')', 369,
        ',', 370,
        '.', 401,
        '/', 219,
        '0', 508,
        ':', 359,
        '<', 433,
        '=', 351,
        '?', 371,
        '@', 147,
        '[', 384,
      );
      if (lookahead == '\\') SKIP(23);
      if (lookahead == '`') ADVANCE(231);
      if (lookahead == 'a') ADVANCE(586);
      if (lookahead == '{') ADVANCE(390);
      if (lookahead == '|') ADVANCE(376);
      if (lookahead == '}') ADVANCE(392);
      if (('+' <= lookahead && lookahead <= '-')) ADVANCE(322);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(509);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(165);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(592);
      END_STATE();
    case 166:
      ADVANCE_MAP(
        '"', 454,
        '#', 602,
        '$', 146,
        '&', 380,
        '\'', 208,
        '(', 366,
        ')', 369,
        ',', 370,
        '.', 550,
        '/', 219,
        '0', 508,
        ':', 359,
        '<', 433,
        '=', 351,
        '?', 371,
        '@', 147,
        'L', 540,
        'U', 568,
        '[', 384,
      );
      if (lookahead == '\\') SKIP(29);
      if (lookahead == '`') ADVANCE(231);
      if (lookahead == 'a') ADVANCE(586);
      if (lookahead == 'l') ADVANCE(529);
      if (lookahead == 'n') ADVANCE(536);
      if (lookahead == 's') ADVANCE(523);
      if (lookahead == 'u') ADVANCE(532);
      if (lookahead == 'y') ADVANCE(519);
      if (lookahead == '{') ADVANCE(390);
      if (lookahead == '|') ADVANCE(376);
      if (lookahead == '}') ADVANCE(392);
      if (('+' <= lookahead && lookahead <= '-')) ADVANCE(322);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(556);
      if (lookahead == 'M' ||
          lookahead == 'm') ADVANCE(549);
      if (lookahead == 'G' ||
          lookahead == 'I' ||
          lookahead == 'N' ||
          lookahead == 'Q' ||
          lookahead == 'R' ||
          lookahead == 'Z') ADVANCE(546);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(509);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(170);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(592);
      END_STATE();
    case 167:
      ADVANCE_MAP(
        '"', 454,
        '#', 602,
        '$', 146,
        '&', 380,
        '\'', 208,
        '(', 366,
        ')', 369,
        ',', 370,
        '/', 219,
        '0', 508,
        ':', 359,
        '<', 433,
        '=', 351,
        '?', 371,
        '@', 147,
        'L', 540,
        'U', 568,
        '[', 384,
      );
      if (lookahead == '\\') SKIP(29);
      if (lookahead == '`') ADVANCE(231);
      if (lookahead == 'a') ADVANCE(586);
      if (lookahead == 'l') ADVANCE(529);
      if (lookahead == 'n') ADVANCE(536);
      if (lookahead == 's') ADVANCE(523);
      if (lookahead == 'u') ADVANCE(532);
      if (lookahead == 'y') ADVANCE(519);
      if (lookahead == '{') ADVANCE(390);
      if (lookahead == '|') ADVANCE(376);
      if (lookahead == '}') ADVANCE(392);
      if (('+' <= lookahead && lookahead <= '-')) ADVANCE(322);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(509);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(170);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(592);
      END_STATE();
    case 168:
      ADVANCE_MAP(
        '"', 454,
        '#', 602,
        '$', 146,
        '&', 380,
        '\'', 208,
        '(', 366,
        ')', 369,
        ',', 370,
        '/', 219,
        '0', 508,
        ':', 359,
        '<', 433,
        '=', 351,
        '?', 371,
        '@', 147,
        '[', 384,
      );
      if (lookahead == '\\') SKIP(29);
      if (lookahead == '`') ADVANCE(231);
      if (lookahead == 'a') ADVANCE(586);
      if (lookahead == 'f') ADVANCE(544);
      if (lookahead == '{') ADVANCE(390);
      if (lookahead == '|') ADVANCE(376);
      if (lookahead == '}') ADVANCE(392);
      if (('+' <= lookahead && lookahead <= '-')) ADVANCE(322);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(556);
      if (lookahead == 'M' ||
          lookahead == 'm') ADVANCE(549);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(509);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(170);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(592);
      END_STATE();
    case 169:
      ADVANCE_MAP(
        '"', 454,
        '#', 602,
        '$', 146,
        '&', 380,
        '\'', 208,
        '(', 366,
        ')', 369,
        ',', 370,
        '/', 219,
        '0', 508,
        ':', 359,
        '<', 433,
        '=', 351,
        '?', 371,
        '@', 147,
        '[', 384,
      );
      if (lookahead == '\\') SKIP(29);
      if (lookahead == '`') ADVANCE(231);
      if (lookahead == 'a') ADVANCE(586);
      if (lookahead == 'f') ADVANCE(544);
      if (lookahead == '{') ADVANCE(390);
      if (lookahead == '|') ADVANCE(376);
      if (lookahead == '}') ADVANCE(392);
      if (('+' <= lookahead && lookahead <= '-')) ADVANCE(322);
      if (lookahead == 'M' ||
          lookahead == 'm') ADVANCE(549);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(509);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(170);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(592);
      END_STATE();
    case 170:
      ADVANCE_MAP(
        '"', 454,
        '#', 602,
        '$', 146,
        '&', 380,
        '\'', 208,
        '(', 366,
        ')', 369,
        ',', 370,
        '/', 219,
        '0', 508,
        ':', 359,
        '<', 433,
        '=', 351,
        '?', 371,
        '@', 147,
        '[', 384,
      );
      if (lookahead == '\\') SKIP(29);
      if (lookahead == '`') ADVANCE(231);
      if (lookahead == 'a') ADVANCE(586);
      if (lookahead == '{') ADVANCE(390);
      if (lookahead == '|') ADVANCE(376);
      if (lookahead == '}') ADVANCE(392);
      if (('+' <= lookahead && lookahead <= '-')) ADVANCE(322);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(509);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(170);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(592);
      END_STATE();
    case 171:
      ADVANCE_MAP(
        '"', 454,
        '#', 602,
        '$', 146,
        '&', 380,
        '\'', 208,
        '(', 366,
        '*', 430,
        '+', 322,
        ',', 370,
        '-', 225,
        '.', 401,
        '/', 219,
        '0', 508,
        ':', 358,
        '<', 433,
        '?', 371,
        '@', 147,
        '[', 383,
      );
      if (lookahead == '\\') SKIP(34);
      if (lookahead == '`') ADVANCE(231);
      if (lookahead == 'a') ADVANCE(586);
      if (lookahead == 'i') ADVANCE(581);
      if (lookahead == 'w') ADVANCE(577);
      if (lookahead == '{') ADVANCE(390);
      if (lookahead == '|') ADVANCE(376);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(509);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(171);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(592);
      END_STATE();
    case 172:
      ADVANCE_MAP(
        '"', 454,
        '#', 602,
        '$', 146,
        '&', 380,
        '\'', 208,
        '(', 366,
        '*', 430,
        '+', 322,
        ',', 370,
        '-', 225,
        '.', 401,
        '/', 219,
        '0', 508,
        ':', 358,
        '<', 433,
        '?', 371,
        '@', 147,
        '[', 383,
      );
      if (lookahead == '\\') SKIP(35);
      if (lookahead == '`') ADVANCE(231);
      if (lookahead == 'a') ADVANCE(586);
      if (lookahead == 'i') ADVANCE(581);
      if (lookahead == '{') ADVANCE(390);
      if (lookahead == '|') ADVANCE(376);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(509);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(172);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(592);
      END_STATE();
    case 173:
      ADVANCE_MAP(
        '"', 454,
        '#', 602,
        '$', 146,
        '&', 380,
        '\'', 208,
        '(', 366,
        '+', 322,
        ',', 370,
        '-', 225,
        '.', 401,
        '/', 219,
        '0', 508,
        ':', 359,
        '<', 433,
        '?', 371,
        '@', 147,
        '[', 384,
      );
      if (lookahead == '\\') SKIP(25);
      if (lookahead == '`') ADVANCE(231);
      if (lookahead == 'a') ADVANCE(586);
      if (lookahead == 'w') ADVANCE(577);
      if (lookahead == '{') ADVANCE(390);
      if (lookahead == '|') ADVANCE(376);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(509);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(173);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(592);
      END_STATE();
    case 174:
      ADVANCE_MAP(
        '"', 454,
        '#', 602,
        '$', 146,
        '&', 380,
        '\'', 208,
        '(', 366,
        '+', 322,
        ',', 370,
        '-', 225,
        '.', 550,
        '/', 219,
        '0', 508,
        ':', 359,
        '?', 371,
        '@', 147,
        'L', 540,
        'U', 568,
        '[', 384,
      );
      if (lookahead == '\\') SKIP(30);
      if (lookahead == '`') ADVANCE(231);
      if (lookahead == 'a') ADVANCE(586);
      if (lookahead == 'l') ADVANCE(529);
      if (lookahead == 'n') ADVANCE(536);
      if (lookahead == 's') ADVANCE(523);
      if (lookahead == 'u') ADVANCE(532);
      if (lookahead == 'w') ADVANCE(577);
      if (lookahead == 'y') ADVANCE(519);
      if (lookahead == '{') ADVANCE(390);
      if (lookahead == '|') ADVANCE(376);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(556);
      if (lookahead == 'M' ||
          lookahead == 'm') ADVANCE(549);
      if (lookahead == 'G' ||
          lookahead == 'I' ||
          lookahead == 'N' ||
          lookahead == 'Q' ||
          lookahead == 'R' ||
          lookahead == 'Z') ADVANCE(546);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(509);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(178);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(592);
      END_STATE();
    case 175:
      ADVANCE_MAP(
        '"', 454,
        '#', 602,
        '$', 146,
        '&', 380,
        '\'', 208,
        '(', 366,
        '+', 322,
        ',', 370,
        '-', 225,
        '/', 219,
        '0', 508,
        ':', 359,
        '?', 371,
        '@', 147,
        'L', 540,
        'U', 568,
        '[', 384,
      );
      if (lookahead == '\\') SKIP(30);
      if (lookahead == '`') ADVANCE(231);
      if (lookahead == 'a') ADVANCE(586);
      if (lookahead == 'l') ADVANCE(529);
      if (lookahead == 'n') ADVANCE(536);
      if (lookahead == 's') ADVANCE(523);
      if (lookahead == 'u') ADVANCE(532);
      if (lookahead == 'w') ADVANCE(577);
      if (lookahead == 'y') ADVANCE(519);
      if (lookahead == '{') ADVANCE(390);
      if (lookahead == '|') ADVANCE(376);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(509);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(178);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(592);
      END_STATE();
    case 176:
      ADVANCE_MAP(
        '"', 454,
        '#', 602,
        '$', 146,
        '&', 380,
        '\'', 208,
        '(', 366,
        '+', 322,
        ',', 370,
        '-', 225,
        '/', 219,
        '0', 508,
        ':', 359,
        '?', 371,
        '@', 147,
        '[', 384,
      );
      if (lookahead == '\\') SKIP(30);
      if (lookahead == '`') ADVANCE(231);
      if (lookahead == 'a') ADVANCE(586);
      if (lookahead == 'f') ADVANCE(544);
      if (lookahead == 'w') ADVANCE(577);
      if (lookahead == '{') ADVANCE(390);
      if (lookahead == '|') ADVANCE(376);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(556);
      if (lookahead == 'M' ||
          lookahead == 'm') ADVANCE(549);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(509);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(178);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(592);
      END_STATE();
    case 177:
      ADVANCE_MAP(
        '"', 454,
        '#', 602,
        '$', 146,
        '&', 380,
        '\'', 208,
        '(', 366,
        '+', 322,
        ',', 370,
        '-', 225,
        '/', 219,
        '0', 508,
        ':', 359,
        '?', 371,
        '@', 147,
        '[', 384,
      );
      if (lookahead == '\\') SKIP(30);
      if (lookahead == '`') ADVANCE(231);
      if (lookahead == 'a') ADVANCE(586);
      if (lookahead == 'f') ADVANCE(544);
      if (lookahead == 'w') ADVANCE(577);
      if (lookahead == '{') ADVANCE(390);
      if (lookahead == '|') ADVANCE(376);
      if (lookahead == 'M' ||
          lookahead == 'm') ADVANCE(549);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(509);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(178);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(592);
      END_STATE();
    case 178:
      ADVANCE_MAP(
        '"', 454,
        '#', 602,
        '$', 146,
        '&', 380,
        '\'', 208,
        '(', 366,
        '+', 322,
        ',', 370,
        '-', 225,
        '/', 219,
        '0', 508,
        ':', 359,
        '?', 371,
        '@', 147,
        '[', 384,
      );
      if (lookahead == '\\') SKIP(30);
      if (lookahead == '`') ADVANCE(231);
      if (lookahead == 'a') ADVANCE(586);
      if (lookahead == 'w') ADVANCE(577);
      if (lookahead == '{') ADVANCE(390);
      if (lookahead == '|') ADVANCE(376);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(509);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(178);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(592);
      END_STATE();
    case 179:
      ADVANCE_MAP(
        '"', 454,
        '#', 602,
        '$', 146,
        '&', 380,
        '\'', 208,
        '(', 366,
        ',', 370,
        '.', 401,
        '/', 219,
        '0', 508,
        ':', 359,
        '<', 433,
        '=', 351,
        '?', 371,
        '@', 147,
        '[', 384,
      );
      if (lookahead == '\\') SKIP(26);
      if (lookahead == '`') ADVANCE(231);
      if (lookahead == 'a') ADVANCE(586);
      if (lookahead == 'i') ADVANCE(581);
      if (lookahead == '{') ADVANCE(390);
      if (lookahead == '|') ADVANCE(376);
      if (('+' <= lookahead && lookahead <= '-')) ADVANCE(322);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(509);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(179);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(592);
      END_STATE();
    case 180:
      ADVANCE_MAP(
        '"', 454,
        '#', 602,
        '$', 146,
        '&', 380,
        '\'', 208,
        '(', 366,
        ',', 370,
        '.', 550,
        '/', 219,
        '0', 508,
        ':', 359,
        '?', 371,
        '@', 147,
        'L', 540,
        'U', 568,
        '[', 384,
      );
      if (lookahead == '\\') SKIP(31);
      if (lookahead == '`') ADVANCE(231);
      if (lookahead == 'a') ADVANCE(586);
      if (lookahead == 'i') ADVANCE(581);
      if (lookahead == 'l') ADVANCE(529);
      if (lookahead == 'n') ADVANCE(536);
      if (lookahead == 's') ADVANCE(523);
      if (lookahead == 'u') ADVANCE(532);
      if (lookahead == 'y') ADVANCE(519);
      if (lookahead == '{') ADVANCE(390);
      if (lookahead == '|') ADVANCE(376);
      if (('+' <= lookahead && lookahead <= '-')) ADVANCE(322);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(556);
      if (lookahead == 'M' ||
          lookahead == 'm') ADVANCE(549);
      if (lookahead == 'G' ||
          lookahead == 'I' ||
          lookahead == 'N' ||
          lookahead == 'Q' ||
          lookahead == 'R' ||
          lookahead == 'Z') ADVANCE(546);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(509);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(184);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(592);
      END_STATE();
    case 181:
      ADVANCE_MAP(
        '"', 454,
        '#', 602,
        '$', 146,
        '&', 380,
        '\'', 208,
        '(', 366,
        ',', 370,
        '/', 219,
        '0', 508,
        ':', 359,
        '?', 371,
        '@', 147,
        'L', 540,
        'U', 568,
        '[', 384,
      );
      if (lookahead == '\\') SKIP(31);
      if (lookahead == '`') ADVANCE(231);
      if (lookahead == 'a') ADVANCE(586);
      if (lookahead == 'i') ADVANCE(581);
      if (lookahead == 'l') ADVANCE(529);
      if (lookahead == 'n') ADVANCE(536);
      if (lookahead == 's') ADVANCE(523);
      if (lookahead == 'u') ADVANCE(532);
      if (lookahead == 'y') ADVANCE(519);
      if (lookahead == '{') ADVANCE(390);
      if (lookahead == '|') ADVANCE(376);
      if (('+' <= lookahead && lookahead <= '-')) ADVANCE(322);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(509);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(184);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(592);
      END_STATE();
    case 182:
      ADVANCE_MAP(
        '"', 454,
        '#', 602,
        '$', 146,
        '&', 380,
        '\'', 208,
        '(', 366,
        ',', 370,
        '/', 219,
        '0', 508,
        ':', 359,
        '?', 371,
        '@', 147,
        '[', 384,
      );
      if (lookahead == '\\') SKIP(31);
      if (lookahead == '`') ADVANCE(231);
      if (lookahead == 'a') ADVANCE(586);
      if (lookahead == 'f') ADVANCE(544);
      if (lookahead == 'i') ADVANCE(581);
      if (lookahead == '{') ADVANCE(390);
      if (lookahead == '|') ADVANCE(376);
      if (('+' <= lookahead && lookahead <= '-')) ADVANCE(322);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(556);
      if (lookahead == 'M' ||
          lookahead == 'm') ADVANCE(549);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(509);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(184);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(592);
      END_STATE();
    case 183:
      ADVANCE_MAP(
        '"', 454,
        '#', 602,
        '$', 146,
        '&', 380,
        '\'', 208,
        '(', 366,
        ',', 370,
        '/', 219,
        '0', 508,
        ':', 359,
        '?', 371,
        '@', 147,
        '[', 384,
      );
      if (lookahead == '\\') SKIP(31);
      if (lookahead == '`') ADVANCE(231);
      if (lookahead == 'a') ADVANCE(586);
      if (lookahead == 'f') ADVANCE(544);
      if (lookahead == 'i') ADVANCE(581);
      if (lookahead == '{') ADVANCE(390);
      if (lookahead == '|') ADVANCE(376);
      if (('+' <= lookahead && lookahead <= '-')) ADVANCE(322);
      if (lookahead == 'M' ||
          lookahead == 'm') ADVANCE(549);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(509);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(184);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(592);
      END_STATE();
    case 184:
      ADVANCE_MAP(
        '"', 454,
        '#', 602,
        '$', 146,
        '&', 380,
        '\'', 208,
        '(', 366,
        ',', 370,
        '/', 219,
        '0', 508,
        ':', 359,
        '?', 371,
        '@', 147,
        '[', 384,
      );
      if (lookahead == '\\') SKIP(31);
      if (lookahead == '`') ADVANCE(231);
      if (lookahead == 'a') ADVANCE(586);
      if (lookahead == 'i') ADVANCE(581);
      if (lookahead == '{') ADVANCE(390);
      if (lookahead == '|') ADVANCE(376);
      if (('+' <= lookahead && lookahead <= '-')) ADVANCE(322);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(509);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(184);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(592);
      END_STATE();
    case 185:
      ADVANCE_MAP(
        '"', 454,
        '#', 602,
        '$', 146,
        '\'', 208,
        '(', 366,
        '.', 401,
        '/', 219,
        '0', 508,
        ':', 361,
        '<', 433,
        '=', 351,
        '?', 371,
        '@', 147,
        '[', 384,
      );
      if (lookahead == '\\') SKIP(22);
      if (lookahead == '`') ADVANCE(231);
      if (lookahead == '{') ADVANCE(390);
      if (lookahead == '|') ADVANCE(376);
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(322);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(509);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(185);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(592);
      END_STATE();
    case 186:
      ADVANCE_MAP(
        '"', 454,
        '#', 602,
        '$', 146,
        '\'', 208,
        '(', 367,
        '*', 210,
        '+', 322,
        '-', 225,
        '.', 550,
        '/', 219,
        '0', 508,
        ':', 354,
        '=', 351,
        '>', 230,
        '@', 147,
        'L', 540,
        'U', 568,
        '[', 386,
      );
      if (lookahead == '\\') SKIP(36);
      if (lookahead == ']') ADVANCE(387);
      if (lookahead == '`') ADVANCE(231);
      if (lookahead == 'l') ADVANCE(529);
      if (lookahead == 'n') ADVANCE(536);
      if (lookahead == 's') ADVANCE(523);
      if (lookahead == 'u') ADVANCE(532);
      if (lookahead == 'y') ADVANCE(519);
      if (lookahead == '{') ADVANCE(390);
      if (lookahead == '|') ADVANCE(229);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(556);
      if (lookahead == 'M' ||
          lookahead == 'm') ADVANCE(549);
      if (lookahead == 'G' ||
          lookahead == 'I' ||
          lookahead == 'N' ||
          lookahead == 'Q' ||
          lookahead == 'R' ||
          lookahead == 'Z') ADVANCE(546);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(509);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(187);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(592);
      END_STATE();
    case 187:
      ADVANCE_MAP(
        '"', 454,
        '#', 602,
        '$', 146,
        '\'', 208,
        '(', 367,
        '+', 322,
        '-', 225,
        '/', 219,
        '0', 508,
        ':', 354,
        '=', 351,
        '>', 230,
        '@', 147,
        '[', 386,
      );
      if (lookahead == '\\') SKIP(36);
      if (lookahead == ']') ADVANCE(387);
      if (lookahead == '`') ADVANCE(231);
      if (lookahead == '{') ADVANCE(390);
      if (lookahead == '|') ADVANCE(229);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(509);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(187);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(592);
      END_STATE();
    case 188:
      ADVANCE_MAP(
        '"', 454,
        '#', 602,
        '$', 146,
        '\'', 208,
        '(', 367,
        '+', 322,
        '-', 225,
        '/', 219,
        '0', 508,
        ':', 354,
        '=', 351,
        '@', 147,
        'L', 540,
        'U', 568,
        '[', 386,
      );
      if (lookahead == '\\') SKIP(38);
      if (lookahead == '`') ADVANCE(231);
      if (lookahead == 'l') ADVANCE(529);
      if (lookahead == 'n') ADVANCE(536);
      if (lookahead == 's') ADVANCE(523);
      if (lookahead == 'u') ADVANCE(532);
      if (lookahead == 'y') ADVANCE(519);
      if (lookahead == '{') ADVANCE(390);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(509);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(191);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(592);
      END_STATE();
    case 189:
      ADVANCE_MAP(
        '"', 454,
        '#', 602,
        '$', 146,
        '\'', 208,
        '(', 367,
        '+', 322,
        '-', 225,
        '/', 219,
        '0', 508,
        ':', 354,
        '=', 351,
        '@', 147,
        '[', 386,
      );
      if (lookahead == '\\') SKIP(38);
      if (lookahead == '`') ADVANCE(231);
      if (lookahead == 'f') ADVANCE(544);
      if (lookahead == '{') ADVANCE(390);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(556);
      if (lookahead == 'M' ||
          lookahead == 'm') ADVANCE(549);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(509);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(191);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(592);
      END_STATE();
    case 190:
      ADVANCE_MAP(
        '"', 454,
        '#', 602,
        '$', 146,
        '\'', 208,
        '(', 367,
        '+', 322,
        '-', 225,
        '/', 219,
        '0', 508,
        ':', 354,
        '=', 351,
        '@', 147,
        '[', 386,
      );
      if (lookahead == '\\') SKIP(38);
      if (lookahead == '`') ADVANCE(231);
      if (lookahead == 'f') ADVANCE(544);
      if (lookahead == '{') ADVANCE(390);
      if (lookahead == 'M' ||
          lookahead == 'm') ADVANCE(549);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(509);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(191);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(592);
      END_STATE();
    case 191:
      ADVANCE_MAP(
        '"', 454,
        '#', 602,
        '$', 146,
        '\'', 208,
        '(', 367,
        '+', 322,
        '-', 225,
        '/', 219,
        '0', 508,
        ':', 354,
        '=', 351,
        '@', 147,
        '[', 386,
      );
      if (lookahead == '\\') SKIP(38);
      if (lookahead == '`') ADVANCE(231);
      if (lookahead == '{') ADVANCE(390);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(509);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(191);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(592);
      END_STATE();
    case 192:
      if (lookahead == '"') ADVANCE(465);
      END_STATE();
    case 193:
      if (lookahead == '"') ADVANCE(455);
      if (lookahead == '#') ADVANCE(447);
      if (lookahead == '(') ADVANCE(447);
      if (lookahead == '/') ADVANCE(447);
      if (lookahead == '\\') ADVANCE(3);
      if (lookahead == '\t' ||
          (0x0b <= lookahead && lookahead <= '\r')) SKIP(151);
      if (lookahead == '\n' ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) ADVANCE(447);
      if (lookahead != 0 &&
          (lookahead < 0x07 || '\r' < lookahead)) ADVANCE(447);
      END_STATE();
    case 194:
      if (lookahead == '"') ADVANCE(461);
      if (lookahead == '#') ADVANCE(447);
      if (lookahead == '(') ADVANCE(447);
      if (lookahead == '/') ADVANCE(447);
      if (lookahead == '\\') ADVANCE(457);
      if (lookahead == '\t' ||
          (0x0b <= lookahead && lookahead <= '\r')) SKIP(197);
      if (lookahead == '\n' ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) ADVANCE(447);
      if (lookahead != 0 &&
          (lookahead < 0x07 || '\r' < lookahead)) ADVANCE(447);
      END_STATE();
    case 195:
      if (lookahead == '"') ADVANCE(458);
      END_STATE();
    case 196:
      if (lookahead == '"') ADVANCE(460);
      if (lookahead == '#') ADVANCE(447);
      if (lookahead == '(') ADVANCE(447);
      if (lookahead == '/') ADVANCE(447);
      if (lookahead == '\\') ADVANCE(457);
      if (lookahead == '\t' ||
          (0x0b <= lookahead && lookahead <= '\r')) SKIP(197);
      if (lookahead == '\n' ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) ADVANCE(447);
      if (lookahead != 0 &&
          (lookahead < 0x07 || '\r' < lookahead)) ADVANCE(447);
      END_STATE();
    case 197:
      if (lookahead == '"') ADVANCE(195);
      if (lookahead == '#') ADVANCE(602);
      if (lookahead == '(') ADVANCE(215);
      if (lookahead == '/') ADVANCE(219);
      if (lookahead == '\\') ADVANCE(456);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(197);
      END_STATE();
    case 198:
      if (lookahead == '#') ADVANCE(438);
      if (lookahead == '\'') ADVANCE(440);
      if (lookahead == '(') ADVANCE(368);
      if (lookahead == '/') ADVANCE(219);
      if (lookahead == '>') ADVANCE(420);
      if (lookahead == '?') ADVANCE(371);
      if (lookahead == '[') ADVANCE(220);
      if (lookahead == '\\') SKIP(37);
      if (lookahead == '^') ADVANCE(439);
      if (lookahead == '`') ADVANCE(231);
      if (lookahead == '{') ADVANCE(319);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(198);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(592);
      END_STATE();
    case 199:
      ADVANCE_MAP(
        '#', 602,
        '&', 380,
        '(', 215,
        ')', 369,
        '*', 430,
        ',', 370,
        '-', 224,
        '.', 401,
        '/', 219,
        ':', 357,
        '<', 433,
        '=', 351,
        '[', 228,
      );
      if (lookahead == '\\') SKIP(42);
      if (lookahead == '`') ADVANCE(231);
      if (lookahead == 'a') ADVANCE(586);
      if (lookahead == 'w') ADVANCE(577);
      if (lookahead == '|') ADVANCE(376);
      if (lookahead == '}') ADVANCE(392);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(199);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(592);
      END_STATE();
    case 200:
      ADVANCE_MAP(
        '#', 602,
        '&', 380,
        '(', 215,
        ')', 369,
        '*', 430,
        ',', 370,
        '-', 224,
        '.', 401,
        '/', 219,
        ':', 357,
        '<', 433,
        '=', 351,
        '[', 228,
      );
      if (lookahead == '\\') SKIP(43);
      if (lookahead == '`') ADVANCE(231);
      if (lookahead == 'a') ADVANCE(586);
      if (lookahead == '|') ADVANCE(376);
      if (lookahead == '}') ADVANCE(392);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(200);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(592);
      END_STATE();
    case 201:
      ADVANCE_MAP(
        '#', 602,
        '&', 380,
        '(', 215,
        ')', 369,
        ',', 370,
        '-', 224,
        '/', 219,
        ':', 355,
        '<', 433,
        '=', 351,
        'L', 540,
        'U', 568,
      );
      if (lookahead == '\\') SKIP(40);
      if (lookahead == '`') ADVANCE(231);
      if (lookahead == 'a') ADVANCE(586);
      if (lookahead == 'i') ADVANCE(581);
      if (lookahead == 'l') ADVANCE(529);
      if (lookahead == 'n') ADVANCE(536);
      if (lookahead == 's') ADVANCE(523);
      if (lookahead == 'u') ADVANCE(532);
      if (lookahead == 'w') ADVANCE(577);
      if (lookahead == 'y') ADVANCE(519);
      if (lookahead == '|') ADVANCE(376);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(202);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(592);
      END_STATE();
    case 202:
      ADVANCE_MAP(
        '#', 602,
        '&', 380,
        '(', 215,
        ')', 369,
        ',', 370,
        '-', 224,
        '/', 219,
        ':', 355,
        '<', 433,
        '=', 351,
      );
      if (lookahead == '\\') SKIP(40);
      if (lookahead == '`') ADVANCE(231);
      if (lookahead == 'a') ADVANCE(586);
      if (lookahead == 'i') ADVANCE(581);
      if (lookahead == 'w') ADVANCE(577);
      if (lookahead == '|') ADVANCE(376);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(202);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(592);
      END_STATE();
    case 203:
      ADVANCE_MAP(
        '#', 602,
        '&', 380,
        '(', 215,
        ')', 369,
        ',', 370,
        '.', 401,
        '/', 219,
        ':', 355,
        '<', 433,
      );
      if (lookahead == '\\') SKIP(46);
      if (lookahead == 'a') ADVANCE(314);
      if (lookahead == '|') ADVANCE(376);
      if (lookahead == '}') ADVANCE(392);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(203);
      END_STATE();
    case 204:
      ADVANCE_MAP(
        '#', 602,
        '&', 380,
        '(', 215,
        ')', 369,
        ',', 370,
        '/', 219,
        ':', 355,
        '=', 441,
        'L', 540,
        'U', 568,
      );
      if (lookahead == '\\') SKIP(41);
      if (lookahead == '`') ADVANCE(231);
      if (lookahead == 'a') ADVANCE(586);
      if (lookahead == 'l') ADVANCE(529);
      if (lookahead == 'n') ADVANCE(536);
      if (lookahead == 's') ADVANCE(523);
      if (lookahead == 'u') ADVANCE(532);
      if (lookahead == 'y') ADVANCE(519);
      if (lookahead == '|') ADVANCE(376);
      if (lookahead == '}') ADVANCE(392);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(205);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(592);
      END_STATE();
    case 205:
      ADVANCE_MAP(
        '#', 602,
        '&', 380,
        '(', 215,
        ')', 369,
        ',', 370,
        '/', 219,
        ':', 355,
        '=', 441,
      );
      if (lookahead == '\\') SKIP(41);
      if (lookahead == '`') ADVANCE(231);
      if (lookahead == 'a') ADVANCE(586);
      if (lookahead == '|') ADVANCE(376);
      if (lookahead == '}') ADVANCE(392);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(205);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(592);
      END_STATE();
    case 206:
      ADVANCE_MAP(
        '#', 602,
        '&', 380,
        '(', 215,
        '*', 430,
        ',', 370,
        '-', 224,
        '.', 401,
        '/', 219,
        ':', 357,
        '<', 433,
        '=', 441,
        '[', 228,
      );
      if (lookahead == '\\') SKIP(44);
      if (lookahead == '`') ADVANCE(231);
      if (lookahead == 'a') ADVANCE(586);
      if (lookahead == 'i') ADVANCE(581);
      if (lookahead == '|') ADVANCE(376);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(206);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(592);
      END_STATE();
    case 207:
      if (lookahead == '#') ADVANCE(602);
      if (lookahead == '(') ADVANCE(215);
      if (lookahead == '/') ADVANCE(219);
      if (lookahead == '[') ADVANCE(220);
      if (lookahead == '\\') SKIP(47);
      if (lookahead == '`') ADVANCE(231);
      if (lookahead == 'l') ADVANCE(572);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(207);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(592);
      END_STATE();
    case 208:
      if (lookahead == '\'') ADVANCE(449);
      if (lookahead == '\\') ADVANCE(317);
      if (lookahead != 0 &&
          (lookahead < 0x07 || '\r' < lookahead)) ADVANCE(209);
      END_STATE();
    case 209:
      if (lookahead == '\'') ADVANCE(450);
      END_STATE();
    case 210:
      if (lookahead == ')') ADVANCE(559);
      END_STATE();
    case 211:
      if (lookahead == ')') ADVANCE(469);
      if (lookahead == '.') ADVANCE(62);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(213);
      if (lookahead == '!' ||
          lookahead == '%' ||
          lookahead == '&' ||
          ('*' <= lookahead && lookahead <= '/') ||
          ('<' <= lookahead && lookahead <= '@') ||
          lookahead == '^' ||
          lookahead == '|' ||
          lookahead == '~') ADVANCE(214);
      END_STATE();
    case 212:
      if (lookahead == ')') ADVANCE(469);
      if (lookahead == '.') ADVANCE(217);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(213);
      END_STATE();
    case 213:
      if (lookahead == ')') ADVANCE(469);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(213);
      END_STATE();
    case 214:
      if (lookahead == ')') ADVANCE(469);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(213);
      if (lookahead == '!' ||
          lookahead == '%' ||
          lookahead == '&' ||
          ('*' <= lookahead && lookahead <= '/') ||
          ('<' <= lookahead && lookahead <= '@') ||
          lookahead == '^' ||
          lookahead == '|' ||
          lookahead == '~') ADVANCE(214);
      END_STATE();
    case 215:
      if (lookahead == '*') ADVANCE(557);
      END_STATE();
    case 216:
      if (lookahead == '.') ADVANCE(211);
      if (lookahead == '?') ADVANCE(213);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(216);
      if (lookahead == '!' ||
          ('$' <= lookahead && lookahead <= '&') ||
          ('*' <= lookahead && lookahead <= '/') ||
          ('<' <= lookahead && lookahead <= '@') ||
          lookahead == '^' ||
          lookahead == '|' ||
          lookahead == '~') ADVANCE(214);
      END_STATE();
    case 217:
      if (lookahead == '.') ADVANCE(213);
      END_STATE();
    case 218:
      if (lookahead == '.') ADVANCE(429);
      END_STATE();
    case 219:
      if (lookahead == '/') ADVANCE(560);
      END_STATE();
    case 220:
      if (lookahead == '<') ADVANCE(352);
      END_STATE();
    case 221:
      if (lookahead == '<') ADVANCE(352);
      if (lookahead == ']') ADVANCE(437);
      END_STATE();
    case 222:
      if (lookahead == '>') ADVANCE(409);
      END_STATE();
    case 223:
      if (lookahead == '>') ADVANCE(399);
      END_STATE();
    case 224:
      if (lookahead == '>') ADVANCE(413);
      END_STATE();
    case 225:
      if (lookahead == '>') ADVANCE(413);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(509);
      END_STATE();
    case 226:
      if (lookahead == '@') ADVANCE(393);
      END_STATE();
    case 227:
      if (lookahead == 'L') ADVANCE(541);
      END_STATE();
    case 228:
      if (lookahead == ']') ADVANCE(437);
      END_STATE();
    case 229:
      if (lookahead == ']') ADVANCE(389);
      if (lookahead == '}') ADVANCE(406);
      END_STATE();
    case 230:
      if (lookahead == ']') ADVANCE(353);
      END_STATE();
    case 231:
      if (lookahead == '`') ADVANCE(339);
      END_STATE();
    case 232:
      if (lookahead == '`') ADVANCE(562);
      END_STATE();
    case 233:
      if (lookahead == '`') ADVANCE(232);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r') ADVANCE(233);
      END_STATE();
    case 234:
      if (lookahead == 'a') ADVANCE(236);
      END_STATE();
    case 235:
      if (lookahead == 'a') ADVANCE(313);
      END_STATE();
    case 236:
      if (lookahead == 'd') ADVANCE(596);
      END_STATE();
    case 237:
      if (lookahead == 'd') ADVANCE(247);
      END_STATE();
    case 238:
      if (lookahead == 'e') ADVANCE(598);
      END_STATE();
    case 239:
      if (lookahead == 'e') ADVANCE(605);
      END_STATE();
    case 240:
      if (lookahead == 'e') ADVANCE(272);
      END_STATE();
    case 241:
      if (lookahead == 'f') ADVANCE(604);
      END_STATE();
    case 242:
      if (lookahead == 'f') ADVANCE(603);
      END_STATE();
    case 243:
      if (lookahead == 'g') ADVANCE(244);
      if (lookahead == 'n') ADVANCE(238);
      END_STATE();
    case 244:
      if (lookahead == 'h') ADVANCE(316);
      END_STATE();
    case 245:
      if (lookahead == 'h') ADVANCE(240);
      END_STATE();
    case 246:
      if (lookahead == 'i') ADVANCE(243);
      if (lookahead == 'o') ADVANCE(234);
      END_STATE();
    case 247:
      if (lookahead == 'i') ADVANCE(241);
      END_STATE();
    case 248:
      if (lookahead == 'l') ADVANCE(315);
      if (lookahead == 'n') ADVANCE(237);
      END_STATE();
    case 249:
      if (lookahead == 'n') SKIP(63);
      END_STATE();
    case 250:
      if (lookahead == 'n') ADVANCE(593);
      END_STATE();
    case 251:
      if (lookahead == 'n') SKIP(156);
      END_STATE();
    case 252:
      if (lookahead == 'n') SKIP(157);
      END_STATE();
    case 253:
      if (lookahead == 'n') SKIP(126);
      END_STATE();
    case 254:
      if (lookahead == 'n') SKIP(185);
      END_STATE();
    case 255:
      if (lookahead == 'n') SKIP(165);
      END_STATE();
    case 256:
      if (lookahead == 'n') SKIP(173);
      END_STATE();
    case 257:
      if (lookahead == 'n') SKIP(179);
      END_STATE();
    case 258:
      if (lookahead == 'n') SKIP(162);
      END_STATE();
    case 259:
      if (lookahead == 'n') SKIP(155);
      END_STATE();
    case 260:
      if (lookahead == 'n') SKIP(170);
      END_STATE();
    case 261:
      if (lookahead == 'n') SKIP(178);
      END_STATE();
    case 262:
      if (lookahead == 'n') SKIP(184);
      END_STATE();
    case 263:
      if (lookahead == 'n') SKIP(163);
      END_STATE();
    case 264:
      if (lookahead == 'n') SKIP(164);
      END_STATE();
    case 265:
      if (lookahead == 'n') SKIP(171);
      END_STATE();
    case 266:
      if (lookahead == 'n') SKIP(172);
      END_STATE();
    case 267:
      if (lookahead == 'n') SKIP(187);
      END_STATE();
    case 268:
      if (lookahead == 'n') SKIP(198);
      END_STATE();
    case 269:
      if (lookahead == 'n') SKIP(191);
      END_STATE();
    case 270:
      if (lookahead == 'n') SKIP(150);
      END_STATE();
    case 271:
      if (lookahead == 'n') ADVANCE(411);
      END_STATE();
    case 272:
      if (lookahead == 'n') ADVANCE(425);
      END_STATE();
    case 273:
      if (lookahead == 'n') SKIP(202);
      END_STATE();
    case 274:
      if (lookahead == 'n') SKIP(205);
      END_STATE();
    case 275:
      if (lookahead == 'n') SKIP(199);
      END_STATE();
    case 276:
      if (lookahead == 'n') SKIP(200);
      END_STATE();
    case 277:
      if (lookahead == 'n') SKIP(206);
      END_STATE();
    case 278:
      if (lookahead == 'n') SKIP(151);
      END_STATE();
    case 279:
      if (lookahead == 'n') SKIP(203);
      END_STATE();
    case 280:
      if (lookahead == 'n') SKIP(207);
      END_STATE();
    case 281:
      if (lookahead == 'n') SKIP(1);
      END_STATE();
    case 282:
      if (lookahead == 'n') ADVANCE(237);
      END_STATE();
    case 283:
      if (lookahead == 'n') SKIP(73);
      END_STATE();
    case 284:
      if (lookahead == 'n') SKIP(137);
      END_STATE();
    case 285:
      if (lookahead == 'n') SKIP(144);
      END_STATE();
    case 286:
      if (lookahead == 'n') SKIP(136);
      END_STATE();
    case 287:
      if (lookahead == 'n') SKIP(72);
      END_STATE();
    case 288:
      if (lookahead == 'n') SKIP(122);
      END_STATE();
    case 289:
      if (lookahead == 'n') SKIP(123);
      END_STATE();
    case 290:
      if (lookahead == 'n') SKIP(121);
      END_STATE();
    case 291:
      if (lookahead == 'n') SKIP(130);
      END_STATE();
    case 292:
      if (lookahead == 'n') SKIP(128);
      END_STATE();
    case 293:
      if (lookahead == 'n') SKIP(76);
      END_STATE();
    case 294:
      if (lookahead == 'n') SKIP(140);
      END_STATE();
    case 295:
      if (lookahead == 'n') SKIP(124);
      END_STATE();
    case 296:
      if (lookahead == 'n') SKIP(75);
      END_STATE();
    case 297:
      if (lookahead == 'n') SKIP(131);
      END_STATE();
    case 298:
      if (lookahead == 'n') SKIP(129);
      END_STATE();
    case 299:
      if (lookahead == 'n') SKIP(141);
      END_STATE();
    case 300:
      if (lookahead == 'n') SKIP(125);
      END_STATE();
    case 301:
      if (lookahead == 'n') SKIP(74);
      END_STATE();
    case 302:
      if (lookahead == 'n') SKIP(143);
      END_STATE();
    case 303:
      if (lookahead == 'n') SKIP(138);
      END_STATE();
    case 304:
      if (lookahead == 'n') SKIP(134);
      END_STATE();
    case 305:
      if (lookahead == 'n') SKIP(132);
      END_STATE();
    case 306:
      if (lookahead == 'n') SKIP(142);
      END_STATE();
    case 307:
      if (lookahead == 'n') SKIP(127);
      END_STATE();
    case 308:
      if (lookahead == 'n') SKIP(145);
      END_STATE();
    case 309:
      if (lookahead == 'n') SKIP(133);
      END_STATE();
    case 310:
      if (lookahead == 'n') SKIP(135);
      END_STATE();
    case 311:
      if (lookahead == 'n') SKIP(139);
      END_STATE();
    case 312:
      if (lookahead == 'o') ADVANCE(318);
      END_STATE();
    case 313:
      if (lookahead == 'r') ADVANCE(250);
      END_STATE();
    case 314:
      if (lookahead == 's') ADVANCE(364);
      END_STATE();
    case 315:
      if (lookahead == 's') ADVANCE(239);
      END_STATE();
    case 316:
      if (lookahead == 't') ADVANCE(594);
      END_STATE();
    case 317:
      ADVANCE_MAP(
        'u', 338,
        '"', 209,
        '\'', 209,
        '\\', 209,
        'a', 209,
        'b', 209,
        'f', 209,
        'n', 209,
        'r', 209,
        't', 209,
        'v', 209,
      );
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(326);
      END_STATE();
    case 318:
      if (lookahead == 'w') ADVANCE(235);
      END_STATE();
    case 319:
      if (lookahead == '|') ADVANCE(405);
      END_STATE();
    case 320:
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(511);
      END_STATE();
    case 321:
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(512);
      END_STATE();
    case 322:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(509);
      END_STATE();
    case 323:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(446);
      END_STATE();
    case 324:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(209);
      END_STATE();
    case 325:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(323);
      END_STATE();
    case 326:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(324);
      END_STATE();
    case 327:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(513);
      END_STATE();
    case 328:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(444);
      END_STATE();
    case 329:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(445);
      END_STATE();
    case 330:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(209);
      END_STATE();
    case 331:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(328);
      END_STATE();
    case 332:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(329);
      END_STATE();
    case 333:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(330);
      END_STATE();
    case 334:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(331);
      END_STATE();
    case 335:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(332);
      END_STATE();
    case 336:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(333);
      END_STATE();
    case 337:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(334);
      END_STATE();
    case 338:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(336);
      END_STATE();
    case 339:
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != '`') ADVANCE(233);
      END_STATE();
    case 340:
      if (eof) ADVANCE(350);
      if (lookahead == '\r') SKIP(347);
      if (lookahead == 'n') SKIP(344);
      END_STATE();
    case 341:
      if (eof) ADVANCE(350);
      if (lookahead == '\r') SKIP(348);
      if (lookahead == 'n') SKIP(346);
      END_STATE();
    case 342:
      if (eof) ADVANCE(350);
      if (lookahead == '\r') SKIP(349);
      if (lookahead == 'n') SKIP(345);
      END_STATE();
    case 343:
      if (eof) ADVANCE(350);
      ADVANCE_MAP(
        '!', 486,
        '"', 453,
        '#', 438,
        '$', 506,
        '%', 480,
        '&', 381,
        '\'', 440,
        '(', 366,
        ')', 369,
        '*', 430,
        '+', 470,
        ',', 370,
        '-', 472,
        '.', 402,
        '/', 219,
        '0', 508,
        ':', 356,
        '<', 434,
        '=', 441,
        '>', 420,
        '?', 372,
        '@', 148,
        '[', 383,
        '\\', 2,
        ']', 387,
        '^', 439,
        '`', 231,
        'a', 586,
        'd', 584,
        'i', 581,
        'l', 572,
        'm', 569,
        'r', 576,
        'u', 587,
        'w', 577,
        'y', 579,
        '{', 391,
        '|', 378,
        '}', 392,
        '~', 484,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(509);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          (' ' <= lookahead && lookahead <= ';') ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(343);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(592);
      END_STATE();
    case 344:
      if (eof) ADVANCE(350);
      ADVANCE_MAP(
        '"', 454,
        '#', 600,
        '$', 146,
        '\'', 208,
        '(', 367,
        ')', 369,
        '*', 430,
        '+', 322,
        ',', 370,
        '-', 225,
        '.', 401,
        '/', 219,
        '0', 508,
        ':', 360,
        '<', 433,
        '=', 351,
        '>', 420,
        '@', 147,
        '[', 384,
      );
      if (lookahead == '\\') SKIP(340);
      if (lookahead == ']') ADVANCE(387);
      if (lookahead == '`') ADVANCE(231);
      if (lookahead == '{') ADVANCE(390);
      if (lookahead == '|') ADVANCE(377);
      if (lookahead == '}') ADVANCE(392);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(509);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(344);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(592);
      END_STATE();
    case 345:
      if (eof) ADVANCE(350);
      ADVANCE_MAP(
        '#', 602,
        '&', 380,
        '(', 215,
        ')', 369,
        '*', 430,
        ',', 370,
        '-', 224,
        '.', 401,
        '/', 219,
        ':', 357,
        '<', 433,
        '=', 351,
        '>', 420,
        '[', 221,
      );
      if (lookahead == '\\') SKIP(342);
      if (lookahead == '`') ADVANCE(231);
      if (lookahead == 'a') ADVANCE(586);
      if (lookahead == 'i') ADVANCE(581);
      if (lookahead == 'w') ADVANCE(577);
      if (lookahead == '|') ADVANCE(376);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(345);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(592);
      END_STATE();
    case 346:
      if (eof) ADVANCE(350);
      ADVANCE_MAP(
        '#', 602,
        '\'', 440,
        '(', 368,
        ')', 369,
        '*', 430,
        ',', 370,
        '-', 224,
        '.', 401,
        '/', 219,
        ':', 360,
        '<', 433,
        '=', 351,
        '>', 420,
        '[', 221,
      );
      if (lookahead == '\\') SKIP(341);
      if (lookahead == '^') ADVANCE(439);
      if (lookahead == '`') ADVANCE(231);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(346);
      if (set_contains(sym_identifier_character_set_1, 667, lookahead)) ADVANCE(592);
      END_STATE();
    case 347:
      if (eof) ADVANCE(350);
      if (lookahead == 'n') SKIP(344);
      END_STATE();
    case 348:
      if (eof) ADVANCE(350);
      if (lookahead == 'n') SKIP(346);
      END_STATE();
    case 349:
      if (eof) ADVANCE(350);
      if (lookahead == 'n') SKIP(345);
      END_STATE();
    case 350:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    case 351:
      ACCEPT_TOKEN(anon_sym_EQ);
      END_STATE();
    case 352:
      ACCEPT_TOKEN(anon_sym_LBRACK_LT);
      END_STATE();
    case 353:
      ACCEPT_TOKEN(anon_sym_GT_RBRACK);
      END_STATE();
    case 354:
      ACCEPT_TOKEN(anon_sym_COLON);
      END_STATE();
    case 355:
      ACCEPT_TOKEN(anon_sym_COLON);
      if (lookahead == ':') ADVANCE(375);
      END_STATE();
    case 356:
      ACCEPT_TOKEN(anon_sym_COLON);
      if (lookahead == ':') ADVANCE(375);
      if (lookahead == '=') ADVANCE(505);
      if (lookahead == '>') ADVANCE(409);
      if (lookahead == '?') ADVANCE(374);
      END_STATE();
    case 357:
      ACCEPT_TOKEN(anon_sym_COLON);
      if (lookahead == ':') ADVANCE(375);
      if (lookahead == '>') ADVANCE(409);
      END_STATE();
    case 358:
      ACCEPT_TOKEN(anon_sym_COLON);
      if (lookahead == ':') ADVANCE(375);
      if (lookahead == '>') ADVANCE(409);
      if (lookahead == '?') ADVANCE(373);
      END_STATE();
    case 359:
      ACCEPT_TOKEN(anon_sym_COLON);
      if (lookahead == ':') ADVANCE(375);
      if (lookahead == '?') ADVANCE(373);
      END_STATE();
    case 360:
      ACCEPT_TOKEN(anon_sym_COLON);
      if (lookahead == '>') ADVANCE(409);
      END_STATE();
    case 361:
      ACCEPT_TOKEN(anon_sym_COLON);
      if (lookahead == '?') ADVANCE(373);
      END_STATE();
    case 362:
      ACCEPT_TOKEN(anon_sym_let);
      if (lookahead == '!') ADVANCE(363);
      if (set_contains(sym_identifier_character_set_2, 777, lookahead)) ADVANCE(592);
      END_STATE();
    case 363:
      ACCEPT_TOKEN(anon_sym_let_BANG);
      END_STATE();
    case 364:
      ACCEPT_TOKEN(anon_sym_as);
      END_STATE();
    case 365:
      ACCEPT_TOKEN(anon_sym_as);
      if (set_contains(sym_identifier_character_set_2, 777, lookahead)) ADVANCE(592);
      END_STATE();
    case 366:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      if (lookahead == ')') ADVANCE(466);
      if (lookahead == '*') ADVANCE(558);
      if (lookahead == '.') ADVANCE(211);
      if (lookahead == '?') ADVANCE(213);
      if (lookahead == '|') ADVANCE(467);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(216);
      if (lookahead == '!' ||
          ('$' <= lookahead && lookahead <= '&') ||
          ('+' <= lookahead && lookahead <= '/') ||
          ('<' <= lookahead && lookahead <= '@') ||
          lookahead == '^' ||
          lookahead == '~') ADVANCE(214);
      END_STATE();
    case 367:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      if (lookahead == ')') ADVANCE(466);
      if (lookahead == '*') ADVANCE(557);
      END_STATE();
    case 368:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      if (lookahead == '*') ADVANCE(557);
      END_STATE();
    case 369:
      ACCEPT_TOKEN(anon_sym_RPAREN);
      END_STATE();
    case 370:
      ACCEPT_TOKEN(anon_sym_COMMA);
      END_STATE();
    case 371:
      ACCEPT_TOKEN(anon_sym_QMARK);
      END_STATE();
    case 372:
      ACCEPT_TOKEN(anon_sym_QMARK);
      if (lookahead == '<') ADVANCE(485);
      if (lookahead == '!' ||
          lookahead == '%' ||
          lookahead == '&' ||
          ('*' <= lookahead && lookahead <= '/') ||
          ('=' <= lookahead && lookahead <= '@') ||
          lookahead == '^' ||
          lookahead == '|' ||
          lookahead == '~') ADVANCE(487);
      END_STATE();
    case 373:
      ACCEPT_TOKEN(anon_sym_COLON_QMARK);
      END_STATE();
    case 374:
      ACCEPT_TOKEN(anon_sym_COLON_QMARK);
      if (lookahead == '>') ADVANCE(410);
      END_STATE();
    case 375:
      ACCEPT_TOKEN(anon_sym_COLON_COLON);
      END_STATE();
    case 376:
      ACCEPT_TOKEN(anon_sym_PIPE);
      END_STATE();
    case 377:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == ')') ADVANCE(468);
      END_STATE();
    case 378:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == ')') ADVANCE(468);
      if (lookahead == ']') ADVANCE(389);
      if (lookahead == '|') ADVANCE(502);
      if (lookahead == '}') ADVANCE(406);
      END_STATE();
    case 379:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '|') ADVANCE(503);
      if (lookahead == '!' ||
          lookahead == '%' ||
          lookahead == '&' ||
          lookahead == '*' ||
          lookahead == '+' ||
          ('-' <= lookahead && lookahead <= '/') ||
          ('<' <= lookahead && lookahead <= '@') ||
          lookahead == '^' ||
          lookahead == '~') ADVANCE(500);
      END_STATE();
    case 380:
      ACCEPT_TOKEN(anon_sym_AMP);
      END_STATE();
    case 381:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&') ADVANCE(482);
      END_STATE();
    case 382:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&') ADVANCE(483);
      if ((set_contains(aux_sym_infix_op_token2_character_set_1, 9, lookahead) ||
          lookahead == '!' ||
          lookahead == '.' ||
          lookahead == '=' ||
          lookahead == '?' ||
          lookahead == '~') &&
          lookahead != '&' &&
          lookahead != '\'') ADVANCE(500);
      END_STATE();
    case 383:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      if (lookahead == '<') ADVANCE(352);
      if (lookahead == ']') ADVANCE(437);
      if (lookahead == '|') ADVANCE(388);
      END_STATE();
    case 384:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      if (lookahead == '<') ADVANCE(352);
      if (lookahead == '|') ADVANCE(388);
      END_STATE();
    case 385:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      if (lookahead == ']') ADVANCE(437);
      if (lookahead == '|') ADVANCE(388);
      END_STATE();
    case 386:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      if (lookahead == '|') ADVANCE(388);
      END_STATE();
    case 387:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      END_STATE();
    case 388:
      ACCEPT_TOKEN(anon_sym_LBRACK_PIPE);
      END_STATE();
    case 389:
      ACCEPT_TOKEN(anon_sym_PIPE_RBRACK);
      END_STATE();
    case 390:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      END_STATE();
    case 391:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      if (lookahead == '|') ADVANCE(405);
      END_STATE();
    case 392:
      ACCEPT_TOKEN(anon_sym_RBRACE);
      END_STATE();
    case 393:
      ACCEPT_TOKEN(anon_sym_LT_AT);
      if (lookahead == '@') ADVANCE(397);
      END_STATE();
    case 394:
      ACCEPT_TOKEN(anon_sym_LT_AT);
      if (lookahead == '@') ADVANCE(398);
      if ((set_contains(aux_sym_infix_op_token2_character_set_1, 9, lookahead) ||
          lookahead == '!' ||
          lookahead == '.' ||
          lookahead == '=' ||
          lookahead == '?' ||
          lookahead == '~') &&
          lookahead != '\'') ADVANCE(500);
      END_STATE();
    case 395:
      ACCEPT_TOKEN(anon_sym_AT_GT);
      END_STATE();
    case 396:
      ACCEPT_TOKEN(anon_sym_AT_GT);
      if ((set_contains(aux_sym_infix_op_token2_character_set_1, 9, lookahead) ||
          lookahead == '!' ||
          lookahead == '.' ||
          lookahead == '=' ||
          lookahead == '?' ||
          lookahead == '~') &&
          lookahead != '\'') ADVANCE(500);
      END_STATE();
    case 397:
      ACCEPT_TOKEN(anon_sym_LT_AT_AT);
      END_STATE();
    case 398:
      ACCEPT_TOKEN(anon_sym_LT_AT_AT);
      if ((set_contains(aux_sym_infix_op_token2_character_set_1, 9, lookahead) ||
          lookahead == '!' ||
          lookahead == '.' ||
          lookahead == '=' ||
          lookahead == '?' ||
          lookahead == '~') &&
          lookahead != '\'') ADVANCE(500);
      END_STATE();
    case 399:
      ACCEPT_TOKEN(anon_sym_AT_AT_GT);
      END_STATE();
    case 400:
      ACCEPT_TOKEN(anon_sym_AT_AT_GT);
      if ((set_contains(aux_sym_infix_op_token2_character_set_1, 9, lookahead) ||
          lookahead == '!' ||
          lookahead == '.' ||
          lookahead == '=' ||
          lookahead == '?' ||
          lookahead == '~') &&
          lookahead != '\'') ADVANCE(500);
      END_STATE();
    case 401:
      ACCEPT_TOKEN(anon_sym_DOT);
      END_STATE();
    case 402:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '.') ADVANCE(428);
      if (lookahead == '[') ADVANCE(418);
      END_STATE();
    case 403:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '.') ADVANCE(424);
      if (lookahead == '[') ADVANCE(418);
      END_STATE();
    case 404:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '[') ADVANCE(418);
      END_STATE();
    case 405:
      ACCEPT_TOKEN(anon_sym_LBRACE_PIPE);
      END_STATE();
    case 406:
      ACCEPT_TOKEN(anon_sym_PIPE_RBRACE);
      END_STATE();
    case 407:
      ACCEPT_TOKEN(anon_sym_return_BANG);
      END_STATE();
    case 408:
      ACCEPT_TOKEN(anon_sym_yield_BANG);
      END_STATE();
    case 409:
      ACCEPT_TOKEN(anon_sym_COLON_GT);
      END_STATE();
    case 410:
      ACCEPT_TOKEN(anon_sym_COLON_QMARK_GT);
      END_STATE();
    case 411:
      ACCEPT_TOKEN(anon_sym_in);
      END_STATE();
    case 412:
      ACCEPT_TOKEN(anon_sym_in);
      if (set_contains(sym_identifier_character_set_2, 777, lookahead)) ADVANCE(592);
      END_STATE();
    case 413:
      ACCEPT_TOKEN(anon_sym_DASH_GT);
      END_STATE();
    case 414:
      ACCEPT_TOKEN(anon_sym_DASH_GT);
      if ((set_contains(aux_sym_infix_op_token2_character_set_1, 9, lookahead) ||
          lookahead == '!' ||
          lookahead == '.' ||
          lookahead == '=' ||
          lookahead == '?' ||
          lookahead == '~') &&
          lookahead != '\'') ADVANCE(500);
      END_STATE();
    case 415:
      ACCEPT_TOKEN(anon_sym_match_BANG);
      END_STATE();
    case 416:
      ACCEPT_TOKEN(anon_sym_LT_DASH);
      END_STATE();
    case 417:
      ACCEPT_TOKEN(anon_sym_LT_DASH);
      if ((set_contains(aux_sym_infix_op_token2_character_set_1, 9, lookahead) ||
          lookahead == '!' ||
          lookahead == '.' ||
          lookahead == '=' ||
          lookahead == '?' ||
          lookahead == '~') &&
          lookahead != '\'') ADVANCE(500);
      END_STATE();
    case 418:
      ACCEPT_TOKEN(anon_sym_DOT_LBRACK);
      END_STATE();
    case 419:
      ACCEPT_TOKEN(anon_sym_LT);
      END_STATE();
    case 420:
      ACCEPT_TOKEN(anon_sym_GT);
      END_STATE();
    case 421:
      ACCEPT_TOKEN(anon_sym_GT);
      if ((set_contains(aux_sym_infix_op_token2_character_set_1, 9, lookahead) ||
          lookahead == '!' ||
          lookahead == '.' ||
          lookahead == '=' ||
          lookahead == '?' ||
          lookahead == '~') &&
          lookahead != '\'') ADVANCE(500);
      END_STATE();
    case 422:
      ACCEPT_TOKEN(anon_sym_use_BANG);
      END_STATE();
    case 423:
      ACCEPT_TOKEN(anon_sym_do_BANG);
      END_STATE();
    case 424:
      ACCEPT_TOKEN(anon_sym_DOT_DOT);
      END_STATE();
    case 425:
      ACCEPT_TOKEN(anon_sym_when);
      END_STATE();
    case 426:
      ACCEPT_TOKEN(anon_sym_when);
      if (set_contains(sym_identifier_character_set_2, 777, lookahead)) ADVANCE(592);
      END_STATE();
    case 427:
      ACCEPT_TOKEN(anon_sym_LPAREN2);
      if (lookahead == ')') ADVANCE(466);
      END_STATE();
    case 428:
      ACCEPT_TOKEN(anon_sym_DOT_DOT2);
      END_STATE();
    case 429:
      ACCEPT_TOKEN(anon_sym_DOT_DOT3);
      END_STATE();
    case 430:
      ACCEPT_TOKEN(anon_sym_STAR);
      END_STATE();
    case 431:
      ACCEPT_TOKEN(anon_sym_STAR);
      if (lookahead == ')') ADVANCE(559);
      END_STATE();
    case 432:
      ACCEPT_TOKEN(anon_sym_STAR);
      if ((set_contains(aux_sym_infix_op_token2_character_set_1, 9, lookahead) ||
          lookahead == '!' ||
          lookahead == '.' ||
          lookahead == '=' ||
          lookahead == '?' ||
          lookahead == '~') &&
          lookahead != '\'') ADVANCE(500);
      END_STATE();
    case 433:
      ACCEPT_TOKEN(anon_sym_LT2);
      END_STATE();
    case 434:
      ACCEPT_TOKEN(anon_sym_LT2);
      if (lookahead == '-') ADVANCE(416);
      if (lookahead == '@') ADVANCE(393);
      END_STATE();
    case 435:
      ACCEPT_TOKEN(anon_sym_LT2);
      if (lookahead == '-') ADVANCE(417);
      if (lookahead == '@') ADVANCE(394);
      if ((set_contains(aux_sym_infix_op_token2_character_set_1, 9, lookahead) ||
          lookahead == '!' ||
          lookahead == '.' ||
          lookahead == '=' ||
          lookahead == '?' ||
          lookahead == '~') &&
          lookahead != '\'') ADVANCE(500);
      END_STATE();
    case 436:
      ACCEPT_TOKEN(anon_sym_LT2);
      if (lookahead == '@') ADVANCE(393);
      END_STATE();
    case 437:
      ACCEPT_TOKEN(anon_sym_LBRACK_RBRACK);
      END_STATE();
    case 438:
      ACCEPT_TOKEN(anon_sym_POUND);
      if (lookahead == 'l') ADVANCE(246);
      if (lookahead == 'n') ADVANCE(312);
      if (lookahead == 'r') ADVANCE(595);
      END_STATE();
    case 439:
      ACCEPT_TOKEN(anon_sym_CARET);
      END_STATE();
    case 440:
      ACCEPT_TOKEN(anon_sym_SQUOTE);
      END_STATE();
    case 441:
      ACCEPT_TOKEN(anon_sym_EQ2);
      END_STATE();
    case 442:
      ACCEPT_TOKEN(sym__escape_char);
      END_STATE();
    case 443:
      ACCEPT_TOKEN(sym__non_escape_char);
      END_STATE();
    case 444:
      ACCEPT_TOKEN(sym__unicodegraph_short);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(335);
      END_STATE();
    case 445:
      ACCEPT_TOKEN(sym__unicodegraph_long);
      END_STATE();
    case 446:
      ACCEPT_TOKEN(sym__trigraph);
      END_STATE();
    case 447:
      ACCEPT_TOKEN(aux_sym__simple_string_char_token1);
      END_STATE();
    case 448:
      ACCEPT_TOKEN(aux_sym_char_token1);
      END_STATE();
    case 449:
      ACCEPT_TOKEN(aux_sym_char_token1);
      if (lookahead == '\'') ADVANCE(450);
      if (lookahead == 'B') ADVANCE(448);
      END_STATE();
    case 450:
      ACCEPT_TOKEN(aux_sym_char_token1);
      if (lookahead == 'B') ADVANCE(448);
      END_STATE();
    case 451:
      ACCEPT_TOKEN(anon_sym_LBRACE2);
      END_STATE();
    case 452:
      ACCEPT_TOKEN(anon_sym_DOLLAR_DQUOTE);
      if (lookahead == '"') ADVANCE(154);
      END_STATE();
    case 453:
      ACCEPT_TOKEN(anon_sym_DQUOTE);
      END_STATE();
    case 454:
      ACCEPT_TOKEN(anon_sym_DQUOTE);
      if (lookahead == '"') ADVANCE(192);
      END_STATE();
    case 455:
      ACCEPT_TOKEN(anon_sym_DQUOTE);
      if (lookahead == 'B') ADVANCE(463);
      END_STATE();
    case 456:
      ACCEPT_TOKEN(anon_sym_BSLASH);
      END_STATE();
    case 457:
      ACCEPT_TOKEN(anon_sym_BSLASH);
      if (lookahead == '\r') ADVANCE(443);
      if ((!eof && set_contains(sym__non_escape_char_character_set_1, 9, lookahead))) ADVANCE(443);
      END_STATE();
    case 458:
      ACCEPT_TOKEN(aux_sym__verbatim_string_char_token1);
      END_STATE();
    case 459:
      ACCEPT_TOKEN(anon_sym_AT_DQUOTE);
      END_STATE();
    case 460:
      ACCEPT_TOKEN(anon_sym_DQUOTE2);
      if (lookahead == '"') ADVANCE(458);
      END_STATE();
    case 461:
      ACCEPT_TOKEN(anon_sym_DQUOTE2);
      if (lookahead == '"') ADVANCE(458);
      if (lookahead == 'B') ADVANCE(463);
      END_STATE();
    case 462:
      ACCEPT_TOKEN(anon_sym_DQUOTE2);
      if (lookahead == 'B') ADVANCE(463);
      END_STATE();
    case 463:
      ACCEPT_TOKEN(anon_sym_DQUOTEB);
      END_STATE();
    case 464:
      ACCEPT_TOKEN(anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE);
      END_STATE();
    case 465:
      ACCEPT_TOKEN(anon_sym_DQUOTE_DQUOTE_DQUOTE);
      END_STATE();
    case 466:
      ACCEPT_TOKEN(sym_unit);
      END_STATE();
    case 467:
      ACCEPT_TOKEN(anon_sym_LPAREN_PIPE);
      if (lookahead == ')') ADVANCE(469);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(213);
      if (lookahead == '!' ||
          lookahead == '%' ||
          lookahead == '&' ||
          ('*' <= lookahead && lookahead <= '/') ||
          ('<' <= lookahead && lookahead <= '@') ||
          lookahead == '^' ||
          lookahead == '|' ||
          lookahead == '~') ADVANCE(214);
      END_STATE();
    case 468:
      ACCEPT_TOKEN(anon_sym_PIPE_RPAREN);
      END_STATE();
    case 469:
      ACCEPT_TOKEN(sym_op_identifier);
      END_STATE();
    case 470:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '.') ADVANCE(476);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(509);
      END_STATE();
    case 471:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '.') ADVANCE(477);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(509);
      if ((set_contains(aux_sym_infix_op_token2_character_set_1, 9, lookahead) ||
          lookahead == '!' ||
          lookahead == '=' ||
          lookahead == '?' ||
          lookahead == '~') &&
          lookahead != '\'') ADVANCE(500);
      END_STATE();
    case 472:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '.') ADVANCE(478);
      if (lookahead == '>') ADVANCE(413);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(509);
      END_STATE();
    case 473:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '.') ADVANCE(478);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(509);
      END_STATE();
    case 474:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '.') ADVANCE(479);
      if (lookahead == '>') ADVANCE(414);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(509);
      if ((set_contains(aux_sym_infix_op_token2_character_set_1, 9, lookahead) ||
          lookahead == '!' ||
          ('=' <= lookahead && lookahead <= '?') ||
          lookahead == '~') &&
          lookahead != '\'') ADVANCE(500);
      END_STATE();
    case 475:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '.') ADVANCE(479);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(509);
      if ((set_contains(aux_sym_infix_op_token2_character_set_1, 9, lookahead) ||
          lookahead == '!' ||
          lookahead == '=' ||
          lookahead == '?' ||
          lookahead == '~') &&
          lookahead != '\'') ADVANCE(500);
      END_STATE();
    case 476:
      ACCEPT_TOKEN(anon_sym_PLUS_DOT);
      END_STATE();
    case 477:
      ACCEPT_TOKEN(anon_sym_PLUS_DOT);
      if ((set_contains(aux_sym_infix_op_token2_character_set_1, 9, lookahead) ||
          lookahead == '!' ||
          lookahead == '.' ||
          lookahead == '=' ||
          lookahead == '?' ||
          lookahead == '~') &&
          lookahead != '\'') ADVANCE(500);
      END_STATE();
    case 478:
      ACCEPT_TOKEN(anon_sym_DASH_DOT);
      END_STATE();
    case 479:
      ACCEPT_TOKEN(anon_sym_DASH_DOT);
      if ((set_contains(aux_sym_infix_op_token2_character_set_1, 9, lookahead) ||
          lookahead == '!' ||
          lookahead == '.' ||
          lookahead == '=' ||
          lookahead == '?' ||
          lookahead == '~') &&
          lookahead != '\'') ADVANCE(500);
      END_STATE();
    case 480:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      END_STATE();
    case 481:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      if ((set_contains(aux_sym_infix_op_token2_character_set_1, 9, lookahead) ||
          lookahead == '!' ||
          lookahead == '.' ||
          lookahead == '=' ||
          lookahead == '?' ||
          lookahead == '~') &&
          lookahead != '\'') ADVANCE(500);
      END_STATE();
    case 482:
      ACCEPT_TOKEN(anon_sym_AMP_AMP);
      END_STATE();
    case 483:
      ACCEPT_TOKEN(anon_sym_AMP_AMP);
      if ((set_contains(aux_sym_infix_op_token2_character_set_1, 9, lookahead) ||
          lookahead == '!' ||
          lookahead == '.' ||
          lookahead == '=' ||
          lookahead == '?' ||
          lookahead == '~') &&
          lookahead != '\'') ADVANCE(500);
      END_STATE();
    case 484:
      ACCEPT_TOKEN(anon_sym_TILDE);
      END_STATE();
    case 485:
      ACCEPT_TOKEN(aux_sym_prefix_op_token1);
      if (lookahead == '-') ADVANCE(507);
      if (lookahead == '!' ||
          lookahead == '%' ||
          lookahead == '&' ||
          ('*' <= lookahead && lookahead <= '/') ||
          ('<' <= lookahead && lookahead <= '@') ||
          lookahead == '^' ||
          lookahead == '|' ||
          lookahead == '~') ADVANCE(487);
      END_STATE();
    case 486:
      ACCEPT_TOKEN(aux_sym_prefix_op_token1);
      if (lookahead == '=') ADVANCE(504);
      if (lookahead == '!' ||
          lookahead == '%' ||
          lookahead == '&' ||
          ('*' <= lookahead && lookahead <= '/') ||
          ('<' <= lookahead && lookahead <= '@') ||
          lookahead == '^' ||
          lookahead == '|' ||
          lookahead == '~') ADVANCE(487);
      END_STATE();
    case 487:
      ACCEPT_TOKEN(aux_sym_prefix_op_token1);
      if (lookahead == '!' ||
          lookahead == '%' ||
          lookahead == '&' ||
          ('*' <= lookahead && lookahead <= '/') ||
          ('<' <= lookahead && lookahead <= '@') ||
          lookahead == '^' ||
          lookahead == '|' ||
          lookahead == '~') ADVANCE(487);
      END_STATE();
    case 488:
      ACCEPT_TOKEN(aux_sym_infix_op_token1);
      END_STATE();
    case 489:
      ACCEPT_TOKEN(aux_sym_infix_op_token2);
      if (lookahead == '"') ADVANCE(459);
      if (lookahead == '>') ADVANCE(396);
      if ((set_contains(aux_sym_infix_op_token2_character_set_1, 9, lookahead) ||
          lookahead == '!' ||
          lookahead == '.' ||
          ('=' <= lookahead && lookahead <= '?') ||
          lookahead == '~') &&
          lookahead != '\'') ADVANCE(500);
      END_STATE();
    case 490:
      ACCEPT_TOKEN(aux_sym_infix_op_token2);
      if (lookahead == '"') ADVANCE(459);
      if (lookahead == '@') ADVANCE(497);
      if ((set_contains(aux_sym_infix_op_token2_character_set_1, 9, lookahead) ||
          lookahead == '!' ||
          lookahead == '.' ||
          lookahead == '=' ||
          lookahead == '?' ||
          lookahead == '~') &&
          lookahead != '\'') ADVANCE(500);
      END_STATE();
    case 491:
      ACCEPT_TOKEN(aux_sym_infix_op_token2);
      if (lookahead == '"') ADVANCE(459);
      if ((set_contains(aux_sym_infix_op_token2_character_set_1, 9, lookahead) ||
          lookahead == '!' ||
          lookahead == '.' ||
          lookahead == '=' ||
          lookahead == '?' ||
          lookahead == '~') &&
          lookahead != '\'') ADVANCE(500);
      END_STATE();
    case 492:
      ACCEPT_TOKEN(aux_sym_infix_op_token2);
      if (lookahead == '\'') ADVANCE(449);
      if (lookahead == '\\') ADVANCE(317);
      if (set_contains(aux_sym_infix_op_token2_character_set_1, 9, lookahead) ||
          lookahead == '!' ||
          lookahead == '.' ||
          lookahead == '=' ||
          lookahead == '?' ||
          lookahead == '~') ADVANCE(493);
      if (lookahead != 0 &&
          (lookahead < 0x07 || '\r' < lookahead)) ADVANCE(209);
      END_STATE();
    case 493:
      ACCEPT_TOKEN(aux_sym_infix_op_token2);
      if (lookahead == '\'') ADVANCE(450);
      if (set_contains(aux_sym_infix_op_token2_character_set_1, 9, lookahead) ||
          lookahead == '!' ||
          lookahead == '.' ||
          lookahead == '=' ||
          lookahead == '?' ||
          lookahead == '~') ADVANCE(500);
      END_STATE();
    case 494:
      ACCEPT_TOKEN(aux_sym_infix_op_token2);
      if (lookahead == '-') ADVANCE(417);
      if (lookahead == '@') ADVANCE(394);
      if ((set_contains(aux_sym_infix_op_token2_character_set_1, 9, lookahead) ||
          lookahead == '!' ||
          lookahead == '.' ||
          lookahead == '=' ||
          lookahead == '?' ||
          lookahead == '~') &&
          lookahead != '\'') ADVANCE(500);
      END_STATE();
    case 495:
      ACCEPT_TOKEN(aux_sym_infix_op_token2);
      if (lookahead == '/') ADVANCE(496);
      if ((set_contains(aux_sym_infix_op_token2_character_set_1, 9, lookahead) ||
          lookahead == '!' ||
          lookahead == '.' ||
          lookahead == '=' ||
          lookahead == '?' ||
          lookahead == '~') &&
          lookahead != '\'') ADVANCE(500);
      END_STATE();
    case 496:
      ACCEPT_TOKEN(aux_sym_infix_op_token2);
      if (lookahead == '/') ADVANCE(496);
      if ((set_contains(aux_sym_infix_op_token2_character_set_1, 9, lookahead) ||
          lookahead == '!' ||
          lookahead == '.' ||
          lookahead == '=' ||
          lookahead == '?' ||
          lookahead == '~') &&
          lookahead != '\'') ADVANCE(501);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r') ADVANCE(561);
      END_STATE();
    case 497:
      ACCEPT_TOKEN(aux_sym_infix_op_token2);
      if (lookahead == '>') ADVANCE(400);
      if ((set_contains(aux_sym_infix_op_token2_character_set_1, 9, lookahead) ||
          lookahead == '!' ||
          lookahead == '.' ||
          ('=' <= lookahead && lookahead <= '?') ||
          lookahead == '~') &&
          lookahead != '\'') ADVANCE(500);
      END_STATE();
    case 498:
      ACCEPT_TOKEN(aux_sym_infix_op_token2);
      if (lookahead == ']') ADVANCE(353);
      if ((set_contains(aux_sym_infix_op_token2_character_set_1, 9, lookahead) ||
          lookahead == '!' ||
          lookahead == '.' ||
          lookahead == '=' ||
          lookahead == '?' ||
          lookahead == '~') &&
          lookahead != '\'') ADVANCE(500);
      END_STATE();
    case 499:
      ACCEPT_TOKEN(aux_sym_infix_op_token2);
      if (lookahead == '|') ADVANCE(503);
      if (lookahead == '!' ||
          lookahead == '%' ||
          lookahead == '&' ||
          lookahead == '*' ||
          lookahead == '+' ||
          ('-' <= lookahead && lookahead <= '/') ||
          ('<' <= lookahead && lookahead <= '@') ||
          lookahead == '^' ||
          lookahead == '~') ADVANCE(500);
      END_STATE();
    case 500:
      ACCEPT_TOKEN(aux_sym_infix_op_token2);
      if ((set_contains(aux_sym_infix_op_token2_character_set_1, 9, lookahead) ||
          lookahead == '!' ||
          lookahead == '.' ||
          lookahead == '=' ||
          lookahead == '?' ||
          lookahead == '~') &&
          lookahead != '\'') ADVANCE(500);
      END_STATE();
    case 501:
      ACCEPT_TOKEN(aux_sym_infix_op_token2);
      if ((set_contains(aux_sym_infix_op_token2_character_set_1, 9, lookahead) ||
          lookahead == '!' ||
          lookahead == '.' ||
          lookahead == '=' ||
          lookahead == '?' ||
          lookahead == '~') &&
          lookahead != '\'') ADVANCE(501);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r') ADVANCE(561);
      END_STATE();
    case 502:
      ACCEPT_TOKEN(anon_sym_PIPE_PIPE);
      END_STATE();
    case 503:
      ACCEPT_TOKEN(anon_sym_PIPE_PIPE);
      if ((set_contains(aux_sym_infix_op_token2_character_set_1, 9, lookahead) ||
          lookahead == '!' ||
          lookahead == '.' ||
          lookahead == '=' ||
          lookahead == '?' ||
          lookahead == '~') &&
          lookahead != '\'') ADVANCE(500);
      END_STATE();
    case 504:
      ACCEPT_TOKEN(anon_sym_BANG_EQ);
      if (lookahead == '!' ||
          lookahead == '%' ||
          lookahead == '&' ||
          ('*' <= lookahead && lookahead <= '/') ||
          ('<' <= lookahead && lookahead <= '@') ||
          lookahead == '^' ||
          lookahead == '|' ||
          lookahead == '~') ADVANCE(487);
      END_STATE();
    case 505:
      ACCEPT_TOKEN(anon_sym_COLON_EQ);
      END_STATE();
    case 506:
      ACCEPT_TOKEN(anon_sym_DOLLAR);
      if (lookahead == '"') ADVANCE(452);
      END_STATE();
    case 507:
      ACCEPT_TOKEN(anon_sym_QMARK_LT_DASH);
      if (lookahead == '!' ||
          lookahead == '%' ||
          lookahead == '&' ||
          ('*' <= lookahead && lookahead <= '/') ||
          ('<' <= lookahead && lookahead <= '@') ||
          lookahead == '^' ||
          lookahead == '|' ||
          lookahead == '~') ADVANCE(487);
      END_STATE();
    case 508:
      ACCEPT_TOKEN(sym_int);
      if (lookahead == '_') ADVANCE(510);
      if (lookahead == 'B' ||
          lookahead == 'b') ADVANCE(320);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(321);
      if (lookahead == 'X' ||
          lookahead == 'x') ADVANCE(327);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(509);
      END_STATE();
    case 509:
      ACCEPT_TOKEN(sym_int);
      if (lookahead == '_') ADVANCE(510);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(509);
      END_STATE();
    case 510:
      ACCEPT_TOKEN(sym_int);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(509);
      END_STATE();
    case 511:
      ACCEPT_TOKEN(sym_xint);
      if (lookahead == '_') ADVANCE(514);
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(511);
      END_STATE();
    case 512:
      ACCEPT_TOKEN(sym_xint);
      if (lookahead == '_') ADVANCE(515);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(512);
      END_STATE();
    case 513:
      ACCEPT_TOKEN(sym_xint);
      if (lookahead == '_') ADVANCE(516);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(513);
      END_STATE();
    case 514:
      ACCEPT_TOKEN(sym_xint);
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(511);
      END_STATE();
    case 515:
      ACCEPT_TOKEN(sym_xint);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(512);
      END_STATE();
    case 516:
      ACCEPT_TOKEN(sym_xint);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(513);
      END_STATE();
    case 517:
      ACCEPT_TOKEN(anon_sym_y);
      END_STATE();
    case 518:
      ACCEPT_TOKEN(anon_sym_y);
      if (lookahead == 'i') ADVANCE(573);
      if (set_contains(sym_identifier_character_set_2, 777, lookahead)) ADVANCE(592);
      END_STATE();
    case 519:
      ACCEPT_TOKEN(anon_sym_y);
      if (set_contains(sym_identifier_character_set_2, 777, lookahead)) ADVANCE(592);
      END_STATE();
    case 520:
      ACCEPT_TOKEN(anon_sym_uy);
      END_STATE();
    case 521:
      ACCEPT_TOKEN(anon_sym_uy);
      if (set_contains(sym_identifier_character_set_2, 777, lookahead)) ADVANCE(592);
      END_STATE();
    case 522:
      ACCEPT_TOKEN(anon_sym_s);
      END_STATE();
    case 523:
      ACCEPT_TOKEN(anon_sym_s);
      if (set_contains(sym_identifier_character_set_2, 777, lookahead)) ADVANCE(592);
      END_STATE();
    case 524:
      ACCEPT_TOKEN(anon_sym_us);
      END_STATE();
    case 525:
      ACCEPT_TOKEN(anon_sym_us);
      if (lookahead == 'e') ADVANCE(564);
      if (set_contains(sym_identifier_character_set_2, 777, lookahead)) ADVANCE(592);
      END_STATE();
    case 526:
      ACCEPT_TOKEN(anon_sym_us);
      if (set_contains(sym_identifier_character_set_2, 777, lookahead)) ADVANCE(592);
      END_STATE();
    case 527:
      ACCEPT_TOKEN(anon_sym_l);
      END_STATE();
    case 528:
      ACCEPT_TOKEN(anon_sym_l);
      if (lookahead == 'e') ADVANCE(588);
      if (set_contains(sym_identifier_character_set_2, 777, lookahead)) ADVANCE(592);
      END_STATE();
    case 529:
      ACCEPT_TOKEN(anon_sym_l);
      if (set_contains(sym_identifier_character_set_2, 777, lookahead)) ADVANCE(592);
      END_STATE();
    case 530:
      ACCEPT_TOKEN(aux_sym_uint32_token1);
      END_STATE();
    case 531:
      ACCEPT_TOKEN(aux_sym_uint32_token1);
      if (lookahead == 'L') ADVANCE(542);
      if (lookahead == 'l') ADVANCE(534);
      if (lookahead == 'n') ADVANCE(538);
      if (lookahead == 's') ADVANCE(525);
      if (lookahead == 'y') ADVANCE(521);
      if (set_contains(sym_identifier_character_set_2, 777, lookahead)) ADVANCE(592);
      END_STATE();
    case 532:
      ACCEPT_TOKEN(aux_sym_uint32_token1);
      if (lookahead == 'L') ADVANCE(542);
      if (lookahead == 'l') ADVANCE(534);
      if (lookahead == 'n') ADVANCE(538);
      if (lookahead == 's') ADVANCE(526);
      if (lookahead == 'y') ADVANCE(521);
      if (set_contains(sym_identifier_character_set_2, 777, lookahead)) ADVANCE(592);
      END_STATE();
    case 533:
      ACCEPT_TOKEN(aux_sym_uint32_token1);
      if (lookahead == 'L') ADVANCE(541);
      if (lookahead == 'l') ADVANCE(530);
      if (lookahead == 'n') ADVANCE(537);
      if (lookahead == 's') ADVANCE(524);
      if (lookahead == 'y') ADVANCE(520);
      END_STATE();
    case 534:
      ACCEPT_TOKEN(aux_sym_uint32_token1);
      if (set_contains(sym_identifier_character_set_2, 777, lookahead)) ADVANCE(592);
      END_STATE();
    case 535:
      ACCEPT_TOKEN(anon_sym_n);
      END_STATE();
    case 536:
      ACCEPT_TOKEN(anon_sym_n);
      if (set_contains(sym_identifier_character_set_2, 777, lookahead)) ADVANCE(592);
      END_STATE();
    case 537:
      ACCEPT_TOKEN(anon_sym_un);
      END_STATE();
    case 538:
      ACCEPT_TOKEN(anon_sym_un);
      if (set_contains(sym_identifier_character_set_2, 777, lookahead)) ADVANCE(592);
      END_STATE();
    case 539:
      ACCEPT_TOKEN(anon_sym_L);
      END_STATE();
    case 540:
      ACCEPT_TOKEN(anon_sym_L);
      if (set_contains(sym_identifier_character_set_2, 777, lookahead)) ADVANCE(592);
      END_STATE();
    case 541:
      ACCEPT_TOKEN(aux_sym_uint64_token1);
      END_STATE();
    case 542:
      ACCEPT_TOKEN(aux_sym_uint64_token1);
      if (set_contains(sym_identifier_character_set_2, 777, lookahead)) ADVANCE(592);
      END_STATE();
    case 543:
      ACCEPT_TOKEN(anon_sym_f);
      END_STATE();
    case 544:
      ACCEPT_TOKEN(anon_sym_f);
      if (set_contains(sym_identifier_character_set_2, 777, lookahead)) ADVANCE(592);
      END_STATE();
    case 545:
      ACCEPT_TOKEN(aux_sym_bignum_token1);
      END_STATE();
    case 546:
      ACCEPT_TOKEN(aux_sym_bignum_token1);
      if (set_contains(sym_identifier_character_set_2, 777, lookahead)) ADVANCE(592);
      END_STATE();
    case 547:
      ACCEPT_TOKEN(aux_sym_decimal_token1);
      END_STATE();
    case 548:
      ACCEPT_TOKEN(aux_sym_decimal_token1);
      if (lookahead == 'a') ADVANCE(589);
      if (set_contains(sym_identifier_character_set_2, 777, lookahead)) ADVANCE(592);
      END_STATE();
    case 549:
      ACCEPT_TOKEN(aux_sym_decimal_token1);
      if (set_contains(sym_identifier_character_set_2, 777, lookahead)) ADVANCE(592);
      END_STATE();
    case 550:
      ACCEPT_TOKEN(anon_sym_DOT2);
      END_STATE();
    case 551:
      ACCEPT_TOKEN(anon_sym_DOT2);
      if (lookahead == '.') ADVANCE(428);
      if (lookahead == '[') ADVANCE(418);
      END_STATE();
    case 552:
      ACCEPT_TOKEN(anon_sym_DOT2);
      if (lookahead == '.') ADVANCE(424);
      if (lookahead == '[') ADVANCE(418);
      END_STATE();
    case 553:
      ACCEPT_TOKEN(anon_sym_DOT2);
      if (lookahead == '[') ADVANCE(418);
      END_STATE();
    case 554:
      ACCEPT_TOKEN(aux_sym_float_token1);
      END_STATE();
    case 555:
      ACCEPT_TOKEN(aux_sym_float_token1);
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(554);
      END_STATE();
    case 556:
      ACCEPT_TOKEN(aux_sym_float_token1);
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(554);
      if (set_contains(sym_identifier_character_set_2, 777, lookahead)) ADVANCE(592);
      END_STATE();
    case 557:
      ACCEPT_TOKEN(anon_sym_LPAREN_STAR);
      END_STATE();
    case 558:
      ACCEPT_TOKEN(anon_sym_LPAREN_STAR);
      if (lookahead == ')') ADVANCE(469);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(213);
      if (lookahead == '!' ||
          lookahead == '%' ||
          lookahead == '&' ||
          ('*' <= lookahead && lookahead <= '/') ||
          ('<' <= lookahead && lookahead <= '@') ||
          lookahead == '^' ||
          lookahead == '|' ||
          lookahead == '~') ADVANCE(214);
      END_STATE();
    case 559:
      ACCEPT_TOKEN(anon_sym_STAR_RPAREN);
      END_STATE();
    case 560:
      ACCEPT_TOKEN(sym_line_comment);
      if (lookahead == '/') ADVANCE(560);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r') ADVANCE(561);
      END_STATE();
    case 561:
      ACCEPT_TOKEN(sym_line_comment);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r') ADVANCE(561);
      END_STATE();
    case 562:
      ACCEPT_TOKEN(sym_identifier);
      END_STATE();
    case 563:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '!') ADVANCE(423);
      if (set_contains(sym_identifier_character_set_2, 777, lookahead)) ADVANCE(592);
      END_STATE();
    case 564:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '!') ADVANCE(422);
      if (set_contains(sym_identifier_character_set_2, 777, lookahead)) ADVANCE(592);
      END_STATE();
    case 565:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '!') ADVANCE(415);
      if (set_contains(sym_identifier_character_set_2, 777, lookahead)) ADVANCE(592);
      END_STATE();
    case 566:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '!') ADVANCE(408);
      if (set_contains(sym_identifier_character_set_2, 777, lookahead)) ADVANCE(592);
      END_STATE();
    case 567:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '!') ADVANCE(407);
      if (set_contains(sym_identifier_character_set_2, 777, lookahead)) ADVANCE(592);
      END_STATE();
    case 568:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'L') ADVANCE(542);
      if (set_contains(sym_identifier_character_set_2, 777, lookahead)) ADVANCE(592);
      END_STATE();
    case 569:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'a') ADVANCE(589);
      if (set_contains(sym_identifier_character_set_2, 777, lookahead)) ADVANCE(592);
      END_STATE();
    case 570:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'c') ADVANCE(578);
      if (set_contains(sym_identifier_character_set_2, 777, lookahead)) ADVANCE(592);
      END_STATE();
    case 571:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'd') ADVANCE(566);
      if (set_contains(sym_identifier_character_set_2, 777, lookahead)) ADVANCE(592);
      END_STATE();
    case 572:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'e') ADVANCE(588);
      if (set_contains(sym_identifier_character_set_2, 777, lookahead)) ADVANCE(592);
      END_STATE();
    case 573:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'e') ADVANCE(580);
      if (set_contains(sym_identifier_character_set_2, 777, lookahead)) ADVANCE(592);
      END_STATE();
    case 574:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'e') ADVANCE(582);
      if (set_contains(sym_identifier_character_set_2, 777, lookahead)) ADVANCE(592);
      END_STATE();
    case 575:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'e') ADVANCE(564);
      if (set_contains(sym_identifier_character_set_2, 777, lookahead)) ADVANCE(592);
      END_STATE();
    case 576:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'e') ADVANCE(590);
      if (set_contains(sym_identifier_character_set_2, 777, lookahead)) ADVANCE(592);
      END_STATE();
    case 577:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'h') ADVANCE(574);
      if (set_contains(sym_identifier_character_set_2, 777, lookahead)) ADVANCE(592);
      END_STATE();
    case 578:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'h') ADVANCE(565);
      if (set_contains(sym_identifier_character_set_2, 777, lookahead)) ADVANCE(592);
      END_STATE();
    case 579:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'i') ADVANCE(573);
      if (set_contains(sym_identifier_character_set_2, 777, lookahead)) ADVANCE(592);
      END_STATE();
    case 580:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'l') ADVANCE(571);
      if (set_contains(sym_identifier_character_set_2, 777, lookahead)) ADVANCE(592);
      END_STATE();
    case 581:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'n') ADVANCE(412);
      if (set_contains(sym_identifier_character_set_2, 777, lookahead)) ADVANCE(592);
      END_STATE();
    case 582:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'n') ADVANCE(426);
      if (set_contains(sym_identifier_character_set_2, 777, lookahead)) ADVANCE(592);
      END_STATE();
    case 583:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'n') ADVANCE(567);
      if (set_contains(sym_identifier_character_set_2, 777, lookahead)) ADVANCE(592);
      END_STATE();
    case 584:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'o') ADVANCE(563);
      if (set_contains(sym_identifier_character_set_2, 777, lookahead)) ADVANCE(592);
      END_STATE();
    case 585:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'r') ADVANCE(583);
      if (set_contains(sym_identifier_character_set_2, 777, lookahead)) ADVANCE(592);
      END_STATE();
    case 586:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 's') ADVANCE(365);
      if (set_contains(sym_identifier_character_set_2, 777, lookahead)) ADVANCE(592);
      END_STATE();
    case 587:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 's') ADVANCE(575);
      if (set_contains(sym_identifier_character_set_2, 777, lookahead)) ADVANCE(592);
      END_STATE();
    case 588:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 't') ADVANCE(362);
      if (set_contains(sym_identifier_character_set_2, 777, lookahead)) ADVANCE(592);
      END_STATE();
    case 589:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 't') ADVANCE(570);
      if (set_contains(sym_identifier_character_set_2, 777, lookahead)) ADVANCE(592);
      END_STATE();
    case 590:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 't') ADVANCE(591);
      if (set_contains(sym_identifier_character_set_2, 777, lookahead)) ADVANCE(592);
      END_STATE();
    case 591:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'u') ADVANCE(585);
      if (set_contains(sym_identifier_character_set_2, 777, lookahead)) ADVANCE(592);
      END_STATE();
    case 592:
      ACCEPT_TOKEN(sym_identifier);
      if (set_contains(sym_identifier_character_set_2, 777, lookahead)) ADVANCE(592);
      END_STATE();
    case 593:
      ACCEPT_TOKEN(anon_sym_POUNDnowarn);
      END_STATE();
    case 594:
      ACCEPT_TOKEN(anon_sym_POUNDlight);
      END_STATE();
    case 595:
      ACCEPT_TOKEN(anon_sym_POUNDr);
      END_STATE();
    case 596:
      ACCEPT_TOKEN(anon_sym_POUNDload);
      END_STATE();
    case 597:
      ACCEPT_TOKEN(aux_sym_fsi_directive_decl_token1);
      if (lookahead == '\n') ADVANCE(597);
      END_STATE();
    case 598:
      ACCEPT_TOKEN(aux_sym_preproc_line_token1);
      END_STATE();
    case 599:
      ACCEPT_TOKEN(aux_sym_preproc_line_token1);
      if (lookahead == 'e') ADVANCE(248);
      if (lookahead == 'i') ADVANCE(242);
      if (lookahead == 'l') ADVANCE(246);
      if (lookahead == 'n') ADVANCE(312);
      if (lookahead == 'r') ADVANCE(595);
      END_STATE();
    case 600:
      ACCEPT_TOKEN(aux_sym_preproc_line_token1);
      if (lookahead == 'e') ADVANCE(282);
      if (lookahead == 'l') ADVANCE(246);
      if (lookahead == 'n') ADVANCE(312);
      if (lookahead == 'r') ADVANCE(595);
      END_STATE();
    case 601:
      ACCEPT_TOKEN(aux_sym_preproc_line_token1);
      if (lookahead == 'i') ADVANCE(242);
      if (lookahead == 'l') ADVANCE(246);
      if (lookahead == 'n') ADVANCE(312);
      if (lookahead == 'r') ADVANCE(595);
      END_STATE();
    case 602:
      ACCEPT_TOKEN(aux_sym_preproc_line_token1);
      if (lookahead == 'l') ADVANCE(246);
      if (lookahead == 'n') ADVANCE(312);
      if (lookahead == 'r') ADVANCE(595);
      END_STATE();
    case 603:
      ACCEPT_TOKEN(anon_sym_POUNDif);
      END_STATE();
    case 604:
      ACCEPT_TOKEN(anon_sym_POUNDendif);
      END_STATE();
    case 605:
      ACCEPT_TOKEN(anon_sym_POUNDelse);
      END_STATE();
    default:
      return false;
  }
}

static bool ts_lex_keywords(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (lookahead == 'L') ADVANCE(1);
      if (lookahead == '\\') SKIP(2);
      if (lookahead == '_') ADVANCE(3);
      if (lookahead == 'a') ADVANCE(4);
      if (lookahead == 'b') ADVANCE(5);
      if (lookahead == 'c') ADVANCE(6);
      if (lookahead == 'd') ADVANCE(7);
      if (lookahead == 'e') ADVANCE(8);
      if (lookahead == 'f') ADVANCE(9);
      if (lookahead == 'g') ADVANCE(10);
      if (lookahead == 'i') ADVANCE(11);
      if (lookahead == 'l') ADVANCE(12);
      if (lookahead == 'm') ADVANCE(13);
      if (lookahead == 'n') ADVANCE(14);
      if (lookahead == 'o') ADVANCE(15);
      if (lookahead == 'p') ADVANCE(16);
      if (lookahead == 'r') ADVANCE(17);
      if (lookahead == 's') ADVANCE(18);
      if (lookahead == 't') ADVANCE(19);
      if (lookahead == 'u') ADVANCE(20);
      if (lookahead == 'v') ADVANCE(21);
      if (lookahead == 'w') ADVANCE(22);
      if (lookahead == 'y') ADVANCE(23);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(24);
      END_STATE();
    case 1:
      if (lookahead == 'F') ADVANCE(25);
      END_STATE();
    case 2:
      if (lookahead == '\r') SKIP(26);
      if (lookahead == 'n') SKIP(24);
      END_STATE();
    case 3:
      ACCEPT_TOKEN(anon_sym__);
      END_STATE();
    case 4:
      if (lookahead == 'b') ADVANCE(27);
      if (lookahead == 'n') ADVANCE(28);
      if (lookahead == 's') ADVANCE(29);
      END_STATE();
    case 5:
      if (lookahead == 'e') ADVANCE(30);
      END_STATE();
    case 6:
      if (lookahead == 'l') ADVANCE(31);
      if (lookahead == 'o') ADVANCE(32);
      END_STATE();
    case 7:
      if (lookahead == 'e') ADVANCE(33);
      if (lookahead == 'o') ADVANCE(34);
      END_STATE();
    case 8:
      if (lookahead == 'l') ADVANCE(35);
      if (lookahead == 'n') ADVANCE(36);
      if (lookahead == 'q') ADVANCE(37);
      if (lookahead == 'v') ADVANCE(38);
      if (lookahead == 'x') ADVANCE(39);
      END_STATE();
    case 9:
      if (lookahead == 'a') ADVANCE(40);
      if (lookahead == 'i') ADVANCE(41);
      if (lookahead == 'o') ADVANCE(42);
      if (lookahead == 'u') ADVANCE(43);
      END_STATE();
    case 10:
      if (lookahead == 'e') ADVANCE(44);
      END_STATE();
    case 11:
      if (lookahead == 'd') ADVANCE(45);
      if (lookahead == 'f') ADVANCE(46);
      if (lookahead == 'n') ADVANCE(47);
      END_STATE();
    case 12:
      if (lookahead == 'a') ADVANCE(48);
      if (lookahead == 'f') ADVANCE(49);
      END_STATE();
    case 13:
      if (lookahead == 'a') ADVANCE(50);
      if (lookahead == 'e') ADVANCE(51);
      if (lookahead == 'o') ADVANCE(52);
      if (lookahead == 'u') ADVANCE(53);
      END_STATE();
    case 14:
      if (lookahead == 'a') ADVANCE(54);
      if (lookahead == 'e') ADVANCE(55);
      if (lookahead == 'o') ADVANCE(56);
      if (lookahead == 'u') ADVANCE(57);
      END_STATE();
    case 15:
      if (lookahead == 'f') ADVANCE(58);
      if (lookahead == 'p') ADVANCE(59);
      if (lookahead == 'r') ADVANCE(60);
      if (lookahead == 'v') ADVANCE(61);
      END_STATE();
    case 16:
      if (lookahead == 'a') ADVANCE(62);
      if (lookahead == 'r') ADVANCE(63);
      if (lookahead == 'u') ADVANCE(64);
      END_STATE();
    case 17:
      if (lookahead == 'e') ADVANCE(65);
      END_STATE();
    case 18:
      if (lookahead == 'e') ADVANCE(66);
      if (lookahead == 't') ADVANCE(67);
      END_STATE();
    case 19:
      if (lookahead == 'h') ADVANCE(68);
      if (lookahead == 'o') ADVANCE(69);
      if (lookahead == 'r') ADVANCE(70);
      if (lookahead == 'y') ADVANCE(71);
      END_STATE();
    case 20:
      if (lookahead == 'n') ADVANCE(72);
      if (lookahead == 'p') ADVANCE(73);
      if (lookahead == 's') ADVANCE(74);
      END_STATE();
    case 21:
      if (lookahead == 'a') ADVANCE(75);
      END_STATE();
    case 22:
      if (lookahead == 'h') ADVANCE(76);
      if (lookahead == 'i') ADVANCE(77);
      END_STATE();
    case 23:
      if (lookahead == 'i') ADVANCE(78);
      END_STATE();
    case 24:
      if (lookahead == '\\') SKIP(2);
      if (lookahead == '_') ADVANCE(3);
      if (lookahead == 'a') ADVANCE(4);
      if (lookahead == 'b') ADVANCE(5);
      if (lookahead == 'c') ADVANCE(6);
      if (lookahead == 'd') ADVANCE(7);
      if (lookahead == 'e') ADVANCE(8);
      if (lookahead == 'f') ADVANCE(9);
      if (lookahead == 'g') ADVANCE(10);
      if (lookahead == 'i') ADVANCE(11);
      if (lookahead == 'l') ADVANCE(79);
      if (lookahead == 'm') ADVANCE(13);
      if (lookahead == 'n') ADVANCE(14);
      if (lookahead == 'o') ADVANCE(15);
      if (lookahead == 'p') ADVANCE(16);
      if (lookahead == 'r') ADVANCE(17);
      if (lookahead == 's') ADVANCE(18);
      if (lookahead == 't') ADVANCE(19);
      if (lookahead == 'u') ADVANCE(20);
      if (lookahead == 'v') ADVANCE(21);
      if (lookahead == 'w') ADVANCE(22);
      if (lookahead == 'y') ADVANCE(23);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(24);
      END_STATE();
    case 25:
      ACCEPT_TOKEN(anon_sym_LF);
      END_STATE();
    case 26:
      if (lookahead == 'n') SKIP(24);
      END_STATE();
    case 27:
      if (lookahead == 's') ADVANCE(80);
      END_STATE();
    case 28:
      if (lookahead == 'd') ADVANCE(81);
      END_STATE();
    case 29:
      if (lookahead == 's') ADVANCE(82);
      END_STATE();
    case 30:
      if (lookahead == 'g') ADVANCE(83);
      END_STATE();
    case 31:
      if (lookahead == 'a') ADVANCE(84);
      END_STATE();
    case 32:
      if (lookahead == 'm') ADVANCE(85);
      if (lookahead == 'n') ADVANCE(86);
      END_STATE();
    case 33:
      if (lookahead == 'f') ADVANCE(87);
      if (lookahead == 'l') ADVANCE(88);
      END_STATE();
    case 34:
      ACCEPT_TOKEN(anon_sym_do);
      if (lookahead == 'n') ADVANCE(89);
      if (lookahead == 'w') ADVANCE(90);
      END_STATE();
    case 35:
      if (lookahead == 'i') ADVANCE(91);
      if (lookahead == 's') ADVANCE(92);
      END_STATE();
    case 36:
      if (lookahead == 'd') ADVANCE(93);
      if (lookahead == 'u') ADVANCE(94);
      END_STATE();
    case 37:
      if (lookahead == 'u') ADVANCE(95);
      END_STATE();
    case 38:
      if (lookahead == 'e') ADVANCE(96);
      END_STATE();
    case 39:
      if (lookahead == 'c') ADVANCE(97);
      END_STATE();
    case 40:
      if (lookahead == 'l') ADVANCE(98);
      END_STATE();
    case 41:
      if (lookahead == 'e') ADVANCE(99);
      if (lookahead == 'n') ADVANCE(100);
      END_STATE();
    case 42:
      if (lookahead == 'r') ADVANCE(101);
      END_STATE();
    case 43:
      if (lookahead == 'n') ADVANCE(102);
      END_STATE();
    case 44:
      if (lookahead == 't') ADVANCE(103);
      END_STATE();
    case 45:
      ACCEPT_TOKEN(anon_sym_id);
      END_STATE();
    case 46:
      ACCEPT_TOKEN(anon_sym_if);
      END_STATE();
    case 47:
      if (lookahead == 'h') ADVANCE(104);
      if (lookahead == 'l') ADVANCE(105);
      if (lookahead == 't') ADVANCE(106);
      END_STATE();
    case 48:
      if (lookahead == 'z') ADVANCE(107);
      END_STATE();
    case 49:
      ACCEPT_TOKEN(anon_sym_lf);
      END_STATE();
    case 50:
      if (lookahead == 't') ADVANCE(108);
      END_STATE();
    case 51:
      if (lookahead == 'm') ADVANCE(109);
      END_STATE();
    case 52:
      if (lookahead == 'd') ADVANCE(110);
      END_STATE();
    case 53:
      if (lookahead == 't') ADVANCE(111);
      END_STATE();
    case 54:
      if (lookahead == 'm') ADVANCE(112);
      END_STATE();
    case 55:
      if (lookahead == 'w') ADVANCE(113);
      END_STATE();
    case 56:
      if (lookahead == 't') ADVANCE(114);
      END_STATE();
    case 57:
      if (lookahead == 'l') ADVANCE(115);
      END_STATE();
    case 58:
      ACCEPT_TOKEN(anon_sym_of);
      END_STATE();
    case 59:
      if (lookahead == 'e') ADVANCE(116);
      END_STATE();
    case 60:
      ACCEPT_TOKEN(anon_sym_or);
      END_STATE();
    case 61:
      if (lookahead == 'e') ADVANCE(117);
      END_STATE();
    case 62:
      if (lookahead == 'r') ADVANCE(118);
      END_STATE();
    case 63:
      if (lookahead == 'i') ADVANCE(119);
      if (lookahead == 'o') ADVANCE(120);
      END_STATE();
    case 64:
      if (lookahead == 'b') ADVANCE(121);
      END_STATE();
    case 65:
      if (lookahead == 'c') ADVANCE(122);
      if (lookahead == 't') ADVANCE(123);
      END_STATE();
    case 66:
      if (lookahead == 't') ADVANCE(124);
      END_STATE();
    case 67:
      if (lookahead == 'a') ADVANCE(125);
      if (lookahead == 'r') ADVANCE(126);
      END_STATE();
    case 68:
      if (lookahead == 'e') ADVANCE(127);
      END_STATE();
    case 69:
      ACCEPT_TOKEN(anon_sym_to);
      END_STATE();
    case 70:
      if (lookahead == 'u') ADVANCE(128);
      if (lookahead == 'y') ADVANCE(129);
      END_STATE();
    case 71:
      if (lookahead == 'p') ADVANCE(130);
      END_STATE();
    case 72:
      if (lookahead == 'i') ADVANCE(131);
      if (lookahead == 'm') ADVANCE(132);
      END_STATE();
    case 73:
      if (lookahead == 'c') ADVANCE(133);
      END_STATE();
    case 74:
      if (lookahead == 'e') ADVANCE(134);
      END_STATE();
    case 75:
      if (lookahead == 'l') ADVANCE(135);
      END_STATE();
    case 76:
      if (lookahead == 'i') ADVANCE(136);
      END_STATE();
    case 77:
      if (lookahead == 't') ADVANCE(137);
      END_STATE();
    case 78:
      if (lookahead == 'e') ADVANCE(138);
      END_STATE();
    case 79:
      if (lookahead == 'a') ADVANCE(48);
      END_STATE();
    case 80:
      if (lookahead == 't') ADVANCE(139);
      END_STATE();
    case 81:
      ACCEPT_TOKEN(anon_sym_and);
      END_STATE();
    case 82:
      if (lookahead == 'e') ADVANCE(140);
      END_STATE();
    case 83:
      if (lookahead == 'i') ADVANCE(141);
      END_STATE();
    case 84:
      if (lookahead == 's') ADVANCE(142);
      END_STATE();
    case 85:
      if (lookahead == 'p') ADVANCE(143);
      END_STATE();
    case 86:
      if (lookahead == 's') ADVANCE(144);
      END_STATE();
    case 87:
      if (lookahead == 'a') ADVANCE(145);
      END_STATE();
    case 88:
      if (lookahead == 'e') ADVANCE(146);
      END_STATE();
    case 89:
      if (lookahead == 'e') ADVANCE(147);
      END_STATE();
    case 90:
      if (lookahead == 'n') ADVANCE(148);
      END_STATE();
    case 91:
      if (lookahead == 'f') ADVANCE(149);
      END_STATE();
    case 92:
      if (lookahead == 'e') ADVANCE(150);
      END_STATE();
    case 93:
      ACCEPT_TOKEN(anon_sym_end);
      END_STATE();
    case 94:
      if (lookahead == 'm') ADVANCE(151);
      END_STATE();
    case 95:
      if (lookahead == 'a') ADVANCE(152);
      END_STATE();
    case 96:
      if (lookahead == 'n') ADVANCE(153);
      END_STATE();
    case 97:
      if (lookahead == 'e') ADVANCE(154);
      END_STATE();
    case 98:
      if (lookahead == 's') ADVANCE(155);
      END_STATE();
    case 99:
      if (lookahead == 'l') ADVANCE(156);
      END_STATE();
    case 100:
      if (lookahead == 'a') ADVANCE(157);
      END_STATE();
    case 101:
      ACCEPT_TOKEN(anon_sym_for);
      END_STATE();
    case 102:
      ACCEPT_TOKEN(anon_sym_fun);
      if (lookahead == 'c') ADVANCE(158);
      END_STATE();
    case 103:
      ACCEPT_TOKEN(anon_sym_get);
      END_STATE();
    case 104:
      if (lookahead == 'e') ADVANCE(159);
      END_STATE();
    case 105:
      if (lookahead == 'i') ADVANCE(160);
      END_STATE();
    case 106:
      if (lookahead == 'e') ADVANCE(161);
      END_STATE();
    case 107:
      if (lookahead == 'y') ADVANCE(162);
      END_STATE();
    case 108:
      if (lookahead == 'c') ADVANCE(163);
      END_STATE();
    case 109:
      if (lookahead == 'b') ADVANCE(164);
      END_STATE();
    case 110:
      if (lookahead == 'u') ADVANCE(165);
      END_STATE();
    case 111:
      if (lookahead == 'a') ADVANCE(166);
      END_STATE();
    case 112:
      if (lookahead == 'e') ADVANCE(167);
      END_STATE();
    case 113:
      ACCEPT_TOKEN(anon_sym_new);
      END_STATE();
    case 114:
      ACCEPT_TOKEN(anon_sym_not);
      END_STATE();
    case 115:
      if (lookahead == 'l') ADVANCE(168);
      END_STATE();
    case 116:
      if (lookahead == 'n') ADVANCE(169);
      END_STATE();
    case 117:
      if (lookahead == 'r') ADVANCE(170);
      END_STATE();
    case 118:
      if (lookahead == 'a') ADVANCE(171);
      END_STATE();
    case 119:
      if (lookahead == 'v') ADVANCE(172);
      END_STATE();
    case 120:
      if (lookahead == 'p') ADVANCE(173);
      END_STATE();
    case 121:
      if (lookahead == 'l') ADVANCE(174);
      END_STATE();
    case 122:
      ACCEPT_TOKEN(anon_sym_rec);
      END_STATE();
    case 123:
      if (lookahead == 'u') ADVANCE(175);
      END_STATE();
    case 124:
      ACCEPT_TOKEN(anon_sym_set);
      END_STATE();
    case 125:
      if (lookahead == 't') ADVANCE(176);
      END_STATE();
    case 126:
      if (lookahead == 'u') ADVANCE(177);
      END_STATE();
    case 127:
      if (lookahead == 'n') ADVANCE(178);
      END_STATE();
    case 128:
      if (lookahead == 'e') ADVANCE(179);
      END_STATE();
    case 129:
      ACCEPT_TOKEN(anon_sym_try);
      END_STATE();
    case 130:
      if (lookahead == 'e') ADVANCE(180);
      END_STATE();
    case 131:
      if (lookahead == 't') ADVANCE(181);
      END_STATE();
    case 132:
      if (lookahead == 'a') ADVANCE(182);
      END_STATE();
    case 133:
      if (lookahead == 'a') ADVANCE(183);
      END_STATE();
    case 134:
      ACCEPT_TOKEN(anon_sym_use);
      END_STATE();
    case 135:
      ACCEPT_TOKEN(anon_sym_val);
      END_STATE();
    case 136:
      if (lookahead == 'l') ADVANCE(184);
      END_STATE();
    case 137:
      if (lookahead == 'h') ADVANCE(185);
      END_STATE();
    case 138:
      if (lookahead == 'l') ADVANCE(186);
      END_STATE();
    case 139:
      if (lookahead == 'r') ADVANCE(187);
      END_STATE();
    case 140:
      if (lookahead == 'm') ADVANCE(188);
      if (lookahead == 'r') ADVANCE(189);
      END_STATE();
    case 141:
      if (lookahead == 'n') ADVANCE(190);
      END_STATE();
    case 142:
      if (lookahead == 's') ADVANCE(191);
      END_STATE();
    case 143:
      if (lookahead == 'a') ADVANCE(192);
      END_STATE();
    case 144:
      if (lookahead == 't') ADVANCE(193);
      END_STATE();
    case 145:
      if (lookahead == 'u') ADVANCE(194);
      END_STATE();
    case 146:
      if (lookahead == 'g') ADVANCE(195);
      END_STATE();
    case 147:
      ACCEPT_TOKEN(anon_sym_done);
      END_STATE();
    case 148:
      if (lookahead == 'c') ADVANCE(196);
      if (lookahead == 't') ADVANCE(197);
      END_STATE();
    case 149:
      ACCEPT_TOKEN(anon_sym_elif);
      END_STATE();
    case 150:
      ACCEPT_TOKEN(anon_sym_else);
      END_STATE();
    case 151:
      ACCEPT_TOKEN(anon_sym_enum);
      END_STATE();
    case 152:
      if (lookahead == 'l') ADVANCE(198);
      END_STATE();
    case 153:
      if (lookahead == 't') ADVANCE(199);
      END_STATE();
    case 154:
      if (lookahead == 'p') ADVANCE(200);
      END_STATE();
    case 155:
      if (lookahead == 'e') ADVANCE(179);
      END_STATE();
    case 156:
      if (lookahead == 'd') ADVANCE(201);
      END_STATE();
    case 157:
      if (lookahead == 'l') ADVANCE(202);
      END_STATE();
    case 158:
      if (lookahead == 't') ADVANCE(203);
      END_STATE();
    case 159:
      if (lookahead == 'r') ADVANCE(204);
      END_STATE();
    case 160:
      if (lookahead == 'n') ADVANCE(205);
      END_STATE();
    case 161:
      if (lookahead == 'r') ADVANCE(206);
      END_STATE();
    case 162:
      ACCEPT_TOKEN(anon_sym_lazy);
      END_STATE();
    case 163:
      if (lookahead == 'h') ADVANCE(207);
      END_STATE();
    case 164:
      if (lookahead == 'e') ADVANCE(208);
      END_STATE();
    case 165:
      if (lookahead == 'l') ADVANCE(209);
      END_STATE();
    case 166:
      if (lookahead == 'b') ADVANCE(210);
      END_STATE();
    case 167:
      if (lookahead == 's') ADVANCE(211);
      END_STATE();
    case 168:
      ACCEPT_TOKEN(anon_sym_null);
      END_STATE();
    case 169:
      ACCEPT_TOKEN(anon_sym_open);
      END_STATE();
    case 170:
      if (lookahead == 'r') ADVANCE(212);
      END_STATE();
    case 171:
      if (lookahead == 'm') ADVANCE(213);
      END_STATE();
    case 172:
      if (lookahead == 'a') ADVANCE(214);
      END_STATE();
    case 173:
      if (lookahead == 'e') ADVANCE(215);
      END_STATE();
    case 174:
      if (lookahead == 'i') ADVANCE(216);
      END_STATE();
    case 175:
      if (lookahead == 'r') ADVANCE(217);
      END_STATE();
    case 176:
      if (lookahead == 'i') ADVANCE(218);
      END_STATE();
    case 177:
      if (lookahead == 'c') ADVANCE(219);
      END_STATE();
    case 178:
      ACCEPT_TOKEN(anon_sym_then);
      END_STATE();
    case 179:
      ACCEPT_TOKEN(sym_bool);
      END_STATE();
    case 180:
      ACCEPT_TOKEN(anon_sym_type);
      END_STATE();
    case 181:
      ACCEPT_TOKEN(anon_sym_unit);
      END_STATE();
    case 182:
      if (lookahead == 'n') ADVANCE(220);
      END_STATE();
    case 183:
      if (lookahead == 's') ADVANCE(221);
      END_STATE();
    case 184:
      if (lookahead == 'e') ADVANCE(222);
      END_STATE();
    case 185:
      ACCEPT_TOKEN(anon_sym_with);
      END_STATE();
    case 186:
      if (lookahead == 'd') ADVANCE(223);
      END_STATE();
    case 187:
      if (lookahead == 'a') ADVANCE(224);
      END_STATE();
    case 188:
      if (lookahead == 'b') ADVANCE(225);
      END_STATE();
    case 189:
      if (lookahead == 't') ADVANCE(226);
      END_STATE();
    case 190:
      ACCEPT_TOKEN(anon_sym_begin);
      END_STATE();
    case 191:
      ACCEPT_TOKEN(anon_sym_class);
      END_STATE();
    case 192:
      if (lookahead == 'r') ADVANCE(227);
      END_STATE();
    case 193:
      if (lookahead == 'r') ADVANCE(228);
      END_STATE();
    case 194:
      if (lookahead == 'l') ADVANCE(229);
      END_STATE();
    case 195:
      if (lookahead == 'a') ADVANCE(230);
      END_STATE();
    case 196:
      if (lookahead == 'a') ADVANCE(231);
      END_STATE();
    case 197:
      if (lookahead == 'o') ADVANCE(232);
      END_STATE();
    case 198:
      if (lookahead == 'i') ADVANCE(233);
      END_STATE();
    case 199:
      ACCEPT_TOKEN(anon_sym_event);
      END_STATE();
    case 200:
      if (lookahead == 't') ADVANCE(234);
      END_STATE();
    case 201:
      ACCEPT_TOKEN(anon_sym_field);
      END_STATE();
    case 202:
      if (lookahead == 'l') ADVANCE(235);
      END_STATE();
    case 203:
      if (lookahead == 'i') ADVANCE(236);
      END_STATE();
    case 204:
      if (lookahead == 'i') ADVANCE(237);
      END_STATE();
    case 205:
      if (lookahead == 'e') ADVANCE(238);
      END_STATE();
    case 206:
      if (lookahead == 'f') ADVANCE(239);
      if (lookahead == 'n') ADVANCE(240);
      END_STATE();
    case 207:
      ACCEPT_TOKEN(anon_sym_match);
      END_STATE();
    case 208:
      if (lookahead == 'r') ADVANCE(241);
      END_STATE();
    case 209:
      if (lookahead == 'e') ADVANCE(242);
      END_STATE();
    case 210:
      if (lookahead == 'l') ADVANCE(243);
      END_STATE();
    case 211:
      if (lookahead == 'p') ADVANCE(244);
      END_STATE();
    case 212:
      if (lookahead == 'i') ADVANCE(245);
      END_STATE();
    case 213:
      ACCEPT_TOKEN(anon_sym_param);
      END_STATE();
    case 214:
      if (lookahead == 't') ADVANCE(246);
      END_STATE();
    case 215:
      if (lookahead == 'r') ADVANCE(247);
      END_STATE();
    case 216:
      if (lookahead == 'c') ADVANCE(248);
      END_STATE();
    case 217:
      if (lookahead == 'n') ADVANCE(249);
      END_STATE();
    case 218:
      if (lookahead == 'c') ADVANCE(250);
      END_STATE();
    case 219:
      if (lookahead == 't') ADVANCE(251);
      END_STATE();
    case 220:
      if (lookahead == 'a') ADVANCE(252);
      END_STATE();
    case 221:
      if (lookahead == 't') ADVANCE(253);
      END_STATE();
    case 222:
      ACCEPT_TOKEN(anon_sym_while);
      END_STATE();
    case 223:
      ACCEPT_TOKEN(anon_sym_yield);
      END_STATE();
    case 224:
      if (lookahead == 'c') ADVANCE(254);
      END_STATE();
    case 225:
      if (lookahead == 'l') ADVANCE(255);
      END_STATE();
    case 226:
      ACCEPT_TOKEN(anon_sym_assert);
      END_STATE();
    case 227:
      if (lookahead == 'i') ADVANCE(256);
      END_STATE();
    case 228:
      if (lookahead == 'u') ADVANCE(257);
      END_STATE();
    case 229:
      if (lookahead == 't') ADVANCE(258);
      END_STATE();
    case 230:
      if (lookahead == 't') ADVANCE(259);
      END_STATE();
    case 231:
      if (lookahead == 's') ADVANCE(260);
      END_STATE();
    case 232:
      ACCEPT_TOKEN(anon_sym_downto);
      END_STATE();
    case 233:
      if (lookahead == 't') ADVANCE(261);
      END_STATE();
    case 234:
      if (lookahead == 'i') ADVANCE(262);
      END_STATE();
    case 235:
      if (lookahead == 'y') ADVANCE(263);
      END_STATE();
    case 236:
      if (lookahead == 'o') ADVANCE(264);
      END_STATE();
    case 237:
      if (lookahead == 't') ADVANCE(265);
      END_STATE();
    case 238:
      ACCEPT_TOKEN(anon_sym_inline);
      END_STATE();
    case 239:
      if (lookahead == 'a') ADVANCE(266);
      END_STATE();
    case 240:
      if (lookahead == 'a') ADVANCE(267);
      END_STATE();
    case 241:
      ACCEPT_TOKEN(anon_sym_member);
      END_STATE();
    case 242:
      ACCEPT_TOKEN(anon_sym_module);
      END_STATE();
    case 243:
      if (lookahead == 'e') ADVANCE(268);
      END_STATE();
    case 244:
      if (lookahead == 'a') ADVANCE(269);
      END_STATE();
    case 245:
      if (lookahead == 'd') ADVANCE(270);
      END_STATE();
    case 246:
      if (lookahead == 'e') ADVANCE(248);
      END_STATE();
    case 247:
      if (lookahead == 't') ADVANCE(271);
      END_STATE();
    case 248:
      ACCEPT_TOKEN(aux_sym_access_modifier_token1);
      END_STATE();
    case 249:
      ACCEPT_TOKEN(anon_sym_return);
      END_STATE();
    case 250:
      ACCEPT_TOKEN(anon_sym_static);
      END_STATE();
    case 251:
      ACCEPT_TOKEN(anon_sym_struct);
      END_STATE();
    case 252:
      if (lookahead == 'g') ADVANCE(272);
      END_STATE();
    case 253:
      ACCEPT_TOKEN(anon_sym_upcast);
      END_STATE();
    case 254:
      if (lookahead == 't') ADVANCE(273);
      END_STATE();
    case 255:
      if (lookahead == 'y') ADVANCE(274);
      END_STATE();
    case 256:
      if (lookahead == 's') ADVANCE(275);
      END_STATE();
    case 257:
      if (lookahead == 'c') ADVANCE(276);
      END_STATE();
    case 258:
      ACCEPT_TOKEN(anon_sym_default);
      END_STATE();
    case 259:
      if (lookahead == 'e') ADVANCE(277);
      END_STATE();
    case 260:
      if (lookahead == 't') ADVANCE(278);
      END_STATE();
    case 261:
      if (lookahead == 'y') ADVANCE(279);
      END_STATE();
    case 262:
      if (lookahead == 'o') ADVANCE(280);
      END_STATE();
    case 263:
      ACCEPT_TOKEN(anon_sym_finally);
      END_STATE();
    case 264:
      if (lookahead == 'n') ADVANCE(281);
      END_STATE();
    case 265:
      ACCEPT_TOKEN(anon_sym_inherit);
      END_STATE();
    case 266:
      if (lookahead == 'c') ADVANCE(282);
      END_STATE();
    case 267:
      if (lookahead == 'l') ADVANCE(248);
      END_STATE();
    case 268:
      ACCEPT_TOKEN(anon_sym_mutable);
      END_STATE();
    case 269:
      if (lookahead == 'c') ADVANCE(283);
      END_STATE();
    case 270:
      if (lookahead == 'e') ADVANCE(284);
      END_STATE();
    case 271:
      if (lookahead == 'y') ADVANCE(285);
      END_STATE();
    case 272:
      if (lookahead == 'e') ADVANCE(286);
      END_STATE();
    case 273:
      ACCEPT_TOKEN(anon_sym_abstract);
      END_STATE();
    case 274:
      ACCEPT_TOKEN(anon_sym_assembly);
      END_STATE();
    case 275:
      if (lookahead == 'o') ADVANCE(287);
      END_STATE();
    case 276:
      if (lookahead == 't') ADVANCE(288);
      END_STATE();
    case 277:
      ACCEPT_TOKEN(anon_sym_delegate);
      END_STATE();
    case 278:
      ACCEPT_TOKEN(anon_sym_downcast);
      END_STATE();
    case 279:
      ACCEPT_TOKEN(anon_sym_equality);
      END_STATE();
    case 280:
      if (lookahead == 'n') ADVANCE(289);
      END_STATE();
    case 281:
      ACCEPT_TOKEN(anon_sym_function);
      END_STATE();
    case 282:
      if (lookahead == 'e') ADVANCE(290);
      END_STATE();
    case 283:
      if (lookahead == 'e') ADVANCE(291);
      END_STATE();
    case 284:
      ACCEPT_TOKEN(anon_sym_override);
      END_STATE();
    case 285:
      ACCEPT_TOKEN(anon_sym_property);
      END_STATE();
    case 286:
      if (lookahead == 'd') ADVANCE(292);
      END_STATE();
    case 287:
      if (lookahead == 'n') ADVANCE(293);
      END_STATE();
    case 288:
      if (lookahead == 'o') ADVANCE(294);
      END_STATE();
    case 289:
      ACCEPT_TOKEN(anon_sym_exception);
      END_STATE();
    case 290:
      ACCEPT_TOKEN(anon_sym_interface);
      END_STATE();
    case 291:
      ACCEPT_TOKEN(anon_sym_namespace);
      END_STATE();
    case 292:
      ACCEPT_TOKEN(anon_sym_unmanaged);
      END_STATE();
    case 293:
      ACCEPT_TOKEN(anon_sym_comparison);
      END_STATE();
    case 294:
      if (lookahead == 'r') ADVANCE(295);
      END_STATE();
    case 295:
      ACCEPT_TOKEN(anon_sym_constructor);
      END_STATE();
    default:
      return false;
  }
}

static const TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0, .external_lex_state = 1},
  [1] = {.lex_state = 344},
  [2] = {.lex_state = 68, .external_lex_state = 2},
  [3] = {.lex_state = 68, .external_lex_state = 2},
  [4] = {.lex_state = 68, .external_lex_state = 2},
  [5] = {.lex_state = 68, .external_lex_state = 2},
  [6] = {.lex_state = 68, .external_lex_state = 2},
  [7] = {.lex_state = 68, .external_lex_state = 2},
  [8] = {.lex_state = 68, .external_lex_state = 2},
  [9] = {.lex_state = 68, .external_lex_state = 2},
  [10] = {.lex_state = 68, .external_lex_state = 2},
  [11] = {.lex_state = 68, .external_lex_state = 2},
  [12] = {.lex_state = 68, .external_lex_state = 2},
  [13] = {.lex_state = 68, .external_lex_state = 3},
  [14] = {.lex_state = 68, .external_lex_state = 3},
  [15] = {.lex_state = 68, .external_lex_state = 3},
  [16] = {.lex_state = 68, .external_lex_state = 3},
  [17] = {.lex_state = 68, .external_lex_state = 3},
  [18] = {.lex_state = 68, .external_lex_state = 3},
  [19] = {.lex_state = 68, .external_lex_state = 3},
  [20] = {.lex_state = 68, .external_lex_state = 3},
  [21] = {.lex_state = 68, .external_lex_state = 3},
  [22] = {.lex_state = 115, .external_lex_state = 2},
  [23] = {.lex_state = 115, .external_lex_state = 2},
  [24] = {.lex_state = 68, .external_lex_state = 2},
  [25] = {.lex_state = 115, .external_lex_state = 3},
  [26] = {.lex_state = 115, .external_lex_state = 2},
  [27] = {.lex_state = 115, .external_lex_state = 2},
  [28] = {.lex_state = 115, .external_lex_state = 2},
  [29] = {.lex_state = 115, .external_lex_state = 2},
  [30] = {.lex_state = 115, .external_lex_state = 2},
  [31] = {.lex_state = 115, .external_lex_state = 2},
  [32] = {.lex_state = 115, .external_lex_state = 2},
  [33] = {.lex_state = 115, .external_lex_state = 2},
  [34] = {.lex_state = 68, .external_lex_state = 3},
  [35] = {.lex_state = 116, .external_lex_state = 3},
  [36] = {.lex_state = 68, .external_lex_state = 3},
  [37] = {.lex_state = 116, .external_lex_state = 3},
  [38] = {.lex_state = 68, .external_lex_state = 3},
  [39] = {.lex_state = 116, .external_lex_state = 3},
  [40] = {.lex_state = 68, .external_lex_state = 3},
  [41] = {.lex_state = 116, .external_lex_state = 3},
  [42] = {.lex_state = 68, .external_lex_state = 3},
  [43] = {.lex_state = 116, .external_lex_state = 3},
  [44] = {.lex_state = 116, .external_lex_state = 3},
  [45] = {.lex_state = 68, .external_lex_state = 3},
  [46] = {.lex_state = 68, .external_lex_state = 2},
  [47] = {.lex_state = 68, .external_lex_state = 2},
  [48] = {.lex_state = 68, .external_lex_state = 3},
  [49] = {.lex_state = 68, .external_lex_state = 2},
  [50] = {.lex_state = 68, .external_lex_state = 3},
  [51] = {.lex_state = 68, .external_lex_state = 2},
  [52] = {.lex_state = 68, .external_lex_state = 3},
  [53] = {.lex_state = 68, .external_lex_state = 2},
  [54] = {.lex_state = 68, .external_lex_state = 3},
  [55] = {.lex_state = 68, .external_lex_state = 3},
  [56] = {.lex_state = 68, .external_lex_state = 3},
  [57] = {.lex_state = 68, .external_lex_state = 2},
  [58] = {.lex_state = 68, .external_lex_state = 3},
  [59] = {.lex_state = 68, .external_lex_state = 2},
  [60] = {.lex_state = 68, .external_lex_state = 3},
  [61] = {.lex_state = 68, .external_lex_state = 2},
  [62] = {.lex_state = 68, .external_lex_state = 2},
  [63] = {.lex_state = 68, .external_lex_state = 3},
  [64] = {.lex_state = 68, .external_lex_state = 3},
  [65] = {.lex_state = 68, .external_lex_state = 4},
  [66] = {.lex_state = 68, .external_lex_state = 3},
  [67] = {.lex_state = 68, .external_lex_state = 3},
  [68] = {.lex_state = 116, .external_lex_state = 3},
  [69] = {.lex_state = 68, .external_lex_state = 3},
  [70] = {.lex_state = 68, .external_lex_state = 3},
  [71] = {.lex_state = 68, .external_lex_state = 3},
  [72] = {.lex_state = 68, .external_lex_state = 3},
  [73] = {.lex_state = 68, .external_lex_state = 3},
  [74] = {.lex_state = 116, .external_lex_state = 3},
  [75] = {.lex_state = 68, .external_lex_state = 3},
  [76] = {.lex_state = 68, .external_lex_state = 3},
  [77] = {.lex_state = 68, .external_lex_state = 3},
  [78] = {.lex_state = 68, .external_lex_state = 3},
  [79] = {.lex_state = 68, .external_lex_state = 3},
  [80] = {.lex_state = 68, .external_lex_state = 5},
  [81] = {.lex_state = 68, .external_lex_state = 3},
  [82] = {.lex_state = 116, .external_lex_state = 3},
  [83] = {.lex_state = 68, .external_lex_state = 3},
  [84] = {.lex_state = 68, .external_lex_state = 4},
  [85] = {.lex_state = 68, .external_lex_state = 2},
  [86] = {.lex_state = 68, .external_lex_state = 2},
  [87] = {.lex_state = 68, .external_lex_state = 3},
  [88] = {.lex_state = 68, .external_lex_state = 2},
  [89] = {.lex_state = 68, .external_lex_state = 2},
  [90] = {.lex_state = 68, .external_lex_state = 2},
  [91] = {.lex_state = 68, .external_lex_state = 2},
  [92] = {.lex_state = 68, .external_lex_state = 2},
  [93] = {.lex_state = 68, .external_lex_state = 2},
  [94] = {.lex_state = 68, .external_lex_state = 2},
  [95] = {.lex_state = 68, .external_lex_state = 2},
  [96] = {.lex_state = 68, .external_lex_state = 2},
  [97] = {.lex_state = 116, .external_lex_state = 3},
  [98] = {.lex_state = 116, .external_lex_state = 3},
  [99] = {.lex_state = 116, .external_lex_state = 3},
  [100] = {.lex_state = 68, .external_lex_state = 2},
  [101] = {.lex_state = 68, .external_lex_state = 5},
  [102] = {.lex_state = 68, .external_lex_state = 4},
  [103] = {.lex_state = 68, .external_lex_state = 3},
  [104] = {.lex_state = 68, .external_lex_state = 3},
  [105] = {.lex_state = 68, .external_lex_state = 2},
  [106] = {.lex_state = 115, .external_lex_state = 3},
  [107] = {.lex_state = 115, .external_lex_state = 3},
  [108] = {.lex_state = 115, .external_lex_state = 3},
  [109] = {.lex_state = 68, .external_lex_state = 5},
  [110] = {.lex_state = 68, .external_lex_state = 5},
  [111] = {.lex_state = 115, .external_lex_state = 3},
  [112] = {.lex_state = 68, .external_lex_state = 3},
  [113] = {.lex_state = 68, .external_lex_state = 5},
  [114] = {.lex_state = 68, .external_lex_state = 5},
  [115] = {.lex_state = 68, .external_lex_state = 5},
  [116] = {.lex_state = 115, .external_lex_state = 3},
  [117] = {.lex_state = 115, .external_lex_state = 3},
  [118] = {.lex_state = 115, .external_lex_state = 3},
  [119] = {.lex_state = 115, .external_lex_state = 3},
  [120] = {.lex_state = 115, .external_lex_state = 3},
  [121] = {.lex_state = 68, .external_lex_state = 5},
  [122] = {.lex_state = 68, .external_lex_state = 4},
  [123] = {.lex_state = 68, .external_lex_state = 5},
  [124] = {.lex_state = 68, .external_lex_state = 4},
  [125] = {.lex_state = 68, .external_lex_state = 5},
  [126] = {.lex_state = 68, .external_lex_state = 4},
  [127] = {.lex_state = 68, .external_lex_state = 4},
  [128] = {.lex_state = 68, .external_lex_state = 5},
  [129] = {.lex_state = 68, .external_lex_state = 4},
  [130] = {.lex_state = 68, .external_lex_state = 4},
  [131] = {.lex_state = 68, .external_lex_state = 4},
  [132] = {.lex_state = 68, .external_lex_state = 4},
  [133] = {.lex_state = 68, .external_lex_state = 3},
  [134] = {.lex_state = 71, .external_lex_state = 3},
  [135] = {.lex_state = 116, .external_lex_state = 3},
  [136] = {.lex_state = 116, .external_lex_state = 3},
  [137] = {.lex_state = 119, .external_lex_state = 3},
  [138] = {.lex_state = 116, .external_lex_state = 3},
  [139] = {.lex_state = 120, .external_lex_state = 3},
  [140] = {.lex_state = 116, .external_lex_state = 3},
  [141] = {.lex_state = 68, .external_lex_state = 2},
  [142] = {.lex_state = 116, .external_lex_state = 3},
  [143] = {.lex_state = 119, .external_lex_state = 3},
  [144] = {.lex_state = 120, .external_lex_state = 3},
  [145] = {.lex_state = 68, .external_lex_state = 2},
  [146] = {.lex_state = 119, .external_lex_state = 3},
  [147] = {.lex_state = 120, .external_lex_state = 3},
  [148] = {.lex_state = 68, .external_lex_state = 2},
  [149] = {.lex_state = 68, .external_lex_state = 3},
  [150] = {.lex_state = 119, .external_lex_state = 3},
  [151] = {.lex_state = 120, .external_lex_state = 3},
  [152] = {.lex_state = 116, .external_lex_state = 3},
  [153] = {.lex_state = 116, .external_lex_state = 3},
  [154] = {.lex_state = 68, .external_lex_state = 2},
  [155] = {.lex_state = 119, .external_lex_state = 3},
  [156] = {.lex_state = 120, .external_lex_state = 3},
  [157] = {.lex_state = 68, .external_lex_state = 2},
  [158] = {.lex_state = 119, .external_lex_state = 3},
  [159] = {.lex_state = 120, .external_lex_state = 3},
  [160] = {.lex_state = 68, .external_lex_state = 2},
  [161] = {.lex_state = 68, .external_lex_state = 3},
  [162] = {.lex_state = 119, .external_lex_state = 3},
  [163] = {.lex_state = 120, .external_lex_state = 3},
  [164] = {.lex_state = 68, .external_lex_state = 2},
  [165] = {.lex_state = 119, .external_lex_state = 3},
  [166] = {.lex_state = 119, .external_lex_state = 3},
  [167] = {.lex_state = 119, .external_lex_state = 3},
  [168] = {.lex_state = 119, .external_lex_state = 3},
  [169] = {.lex_state = 120, .external_lex_state = 3},
  [170] = {.lex_state = 68, .external_lex_state = 2},
  [171] = {.lex_state = 68, .external_lex_state = 3},
  [172] = {.lex_state = 68, .external_lex_state = 2},
  [173] = {.lex_state = 119, .external_lex_state = 3},
  [174] = {.lex_state = 120, .external_lex_state = 3},
  [175] = {.lex_state = 68, .external_lex_state = 2},
  [176] = {.lex_state = 68, .external_lex_state = 3},
  [177] = {.lex_state = 68, .external_lex_state = 2},
  [178] = {.lex_state = 119, .external_lex_state = 3},
  [179] = {.lex_state = 120, .external_lex_state = 3},
  [180] = {.lex_state = 68, .external_lex_state = 2},
  [181] = {.lex_state = 68, .external_lex_state = 3},
  [182] = {.lex_state = 119, .external_lex_state = 3},
  [183] = {.lex_state = 119, .external_lex_state = 3},
  [184] = {.lex_state = 119, .external_lex_state = 3},
  [185] = {.lex_state = 119, .external_lex_state = 3},
  [186] = {.lex_state = 68, .external_lex_state = 2},
  [187] = {.lex_state = 68, .external_lex_state = 2},
  [188] = {.lex_state = 120, .external_lex_state = 3},
  [189] = {.lex_state = 119, .external_lex_state = 3},
  [190] = {.lex_state = 68, .external_lex_state = 3},
  [191] = {.lex_state = 68, .external_lex_state = 3},
  [192] = {.lex_state = 68, .external_lex_state = 2},
  [193] = {.lex_state = 68, .external_lex_state = 3},
  [194] = {.lex_state = 68, .external_lex_state = 3},
  [195] = {.lex_state = 68, .external_lex_state = 2},
  [196] = {.lex_state = 68, .external_lex_state = 2},
  [197] = {.lex_state = 68, .external_lex_state = 2},
  [198] = {.lex_state = 68, .external_lex_state = 2},
  [199] = {.lex_state = 68, .external_lex_state = 6},
  [200] = {.lex_state = 68, .external_lex_state = 2},
  [201] = {.lex_state = 119, .external_lex_state = 3},
  [202] = {.lex_state = 68, .external_lex_state = 2},
  [203] = {.lex_state = 68, .external_lex_state = 2},
  [204] = {.lex_state = 119, .external_lex_state = 3},
  [205] = {.lex_state = 68, .external_lex_state = 6},
  [206] = {.lex_state = 68, .external_lex_state = 2},
  [207] = {.lex_state = 68, .external_lex_state = 2},
  [208] = {.lex_state = 68, .external_lex_state = 3},
  [209] = {.lex_state = 68, .external_lex_state = 2},
  [210] = {.lex_state = 116, .external_lex_state = 3},
  [211] = {.lex_state = 68, .external_lex_state = 2},
  [212] = {.lex_state = 68, .external_lex_state = 2},
  [213] = {.lex_state = 120, .external_lex_state = 3},
  [214] = {.lex_state = 116, .external_lex_state = 3},
  [215] = {.lex_state = 68, .external_lex_state = 2},
  [216] = {.lex_state = 120, .external_lex_state = 3},
  [217] = {.lex_state = 71, .external_lex_state = 3},
  [218] = {.lex_state = 68, .external_lex_state = 2},
  [219] = {.lex_state = 120, .external_lex_state = 3},
  [220] = {.lex_state = 68, .external_lex_state = 2},
  [221] = {.lex_state = 68, .external_lex_state = 2},
  [222] = {.lex_state = 68, .external_lex_state = 2},
  [223] = {.lex_state = 120, .external_lex_state = 3},
  [224] = {.lex_state = 68, .external_lex_state = 2},
  [225] = {.lex_state = 120, .external_lex_state = 3},
  [226] = {.lex_state = 68, .external_lex_state = 2},
  [227] = {.lex_state = 120, .external_lex_state = 3},
  [228] = {.lex_state = 68, .external_lex_state = 2},
  [229] = {.lex_state = 120, .external_lex_state = 3},
  [230] = {.lex_state = 120, .external_lex_state = 3},
  [231] = {.lex_state = 68, .external_lex_state = 2},
  [232] = {.lex_state = 120, .external_lex_state = 3},
  [233] = {.lex_state = 68, .external_lex_state = 2},
  [234] = {.lex_state = 68, .external_lex_state = 2},
  [235] = {.lex_state = 68, .external_lex_state = 2},
  [236] = {.lex_state = 68, .external_lex_state = 2},
  [237] = {.lex_state = 68, .external_lex_state = 2},
  [238] = {.lex_state = 119, .external_lex_state = 3},
  [239] = {.lex_state = 120, .external_lex_state = 3},
  [240] = {.lex_state = 116, .external_lex_state = 3},
  [241] = {.lex_state = 68, .external_lex_state = 2},
  [242] = {.lex_state = 68, .external_lex_state = 2},
  [243] = {.lex_state = 68, .external_lex_state = 2},
  [244] = {.lex_state = 68, .external_lex_state = 2},
  [245] = {.lex_state = 68, .external_lex_state = 2},
  [246] = {.lex_state = 68, .external_lex_state = 2},
  [247] = {.lex_state = 68, .external_lex_state = 3},
  [248] = {.lex_state = 68, .external_lex_state = 2},
  [249] = {.lex_state = 68, .external_lex_state = 2},
  [250] = {.lex_state = 68, .external_lex_state = 2},
  [251] = {.lex_state = 68, .external_lex_state = 2},
  [252] = {.lex_state = 68, .external_lex_state = 3},
  [253] = {.lex_state = 68, .external_lex_state = 2},
  [254] = {.lex_state = 68, .external_lex_state = 2},
  [255] = {.lex_state = 71, .external_lex_state = 3},
  [256] = {.lex_state = 116, .external_lex_state = 3},
  [257] = {.lex_state = 68, .external_lex_state = 6},
  [258] = {.lex_state = 108, .external_lex_state = 3},
  [259] = {.lex_state = 108, .external_lex_state = 3},
  [260] = {.lex_state = 108, .external_lex_state = 3},
  [261] = {.lex_state = 68, .external_lex_state = 6},
  [262] = {.lex_state = 68, .external_lex_state = 2},
  [263] = {.lex_state = 68, .external_lex_state = 6},
  [264] = {.lex_state = 71, .external_lex_state = 3},
  [265] = {.lex_state = 108, .external_lex_state = 3},
  [266] = {.lex_state = 116, .external_lex_state = 3},
  [267] = {.lex_state = 116, .external_lex_state = 3},
  [268] = {.lex_state = 108, .external_lex_state = 3},
  [269] = {.lex_state = 108, .external_lex_state = 3},
  [270] = {.lex_state = 108, .external_lex_state = 3},
  [271] = {.lex_state = 108, .external_lex_state = 3},
  [272] = {.lex_state = 68, .external_lex_state = 6},
  [273] = {.lex_state = 71, .external_lex_state = 3},
  [274] = {.lex_state = 68, .external_lex_state = 3},
  [275] = {.lex_state = 68, .external_lex_state = 2},
  [276] = {.lex_state = 71, .external_lex_state = 3},
  [277] = {.lex_state = 108, .external_lex_state = 3},
  [278] = {.lex_state = 68, .external_lex_state = 6},
  [279] = {.lex_state = 116, .external_lex_state = 3},
  [280] = {.lex_state = 68, .external_lex_state = 2},
  [281] = {.lex_state = 68, .external_lex_state = 6},
  [282] = {.lex_state = 68, .external_lex_state = 2},
  [283] = {.lex_state = 71, .external_lex_state = 3},
  [284] = {.lex_state = 116, .external_lex_state = 3},
  [285] = {.lex_state = 68, .external_lex_state = 2},
  [286] = {.lex_state = 71, .external_lex_state = 3},
  [287] = {.lex_state = 116, .external_lex_state = 3},
  [288] = {.lex_state = 71, .external_lex_state = 3},
  [289] = {.lex_state = 108, .external_lex_state = 3},
  [290] = {.lex_state = 68, .external_lex_state = 2},
  [291] = {.lex_state = 71, .external_lex_state = 3},
  [292] = {.lex_state = 71, .external_lex_state = 3},
  [293] = {.lex_state = 68, .external_lex_state = 3},
  [294] = {.lex_state = 116, .external_lex_state = 3},
  [295] = {.lex_state = 68, .external_lex_state = 6},
  [296] = {.lex_state = 71, .external_lex_state = 3},
  [297] = {.lex_state = 68, .external_lex_state = 6},
  [298] = {.lex_state = 116, .external_lex_state = 3},
  [299] = {.lex_state = 116, .external_lex_state = 3},
  [300] = {.lex_state = 68, .external_lex_state = 2},
  [301] = {.lex_state = 116, .external_lex_state = 3},
  [302] = {.lex_state = 71, .external_lex_state = 3},
  [303] = {.lex_state = 71, .external_lex_state = 3},
  [304] = {.lex_state = 71, .external_lex_state = 3},
  [305] = {.lex_state = 71, .external_lex_state = 3},
  [306] = {.lex_state = 68, .external_lex_state = 2},
  [307] = {.lex_state = 68, .external_lex_state = 3},
  [308] = {.lex_state = 68, .external_lex_state = 2},
  [309] = {.lex_state = 71, .external_lex_state = 3},
  [310] = {.lex_state = 68, .external_lex_state = 3},
  [311] = {.lex_state = 71, .external_lex_state = 3},
  [312] = {.lex_state = 68, .external_lex_state = 6},
  [313] = {.lex_state = 68, .external_lex_state = 2},
  [314] = {.lex_state = 68, .external_lex_state = 2},
  [315] = {.lex_state = 71, .external_lex_state = 3},
  [316] = {.lex_state = 116, .external_lex_state = 3},
  [317] = {.lex_state = 71, .external_lex_state = 3},
  [318] = {.lex_state = 71, .external_lex_state = 3},
  [319] = {.lex_state = 71, .external_lex_state = 3},
  [320] = {.lex_state = 116, .external_lex_state = 3},
  [321] = {.lex_state = 68, .external_lex_state = 2},
  [322] = {.lex_state = 116, .external_lex_state = 3},
  [323] = {.lex_state = 71, .external_lex_state = 3},
  [324] = {.lex_state = 71, .external_lex_state = 3},
  [325] = {.lex_state = 68, .external_lex_state = 2},
  [326] = {.lex_state = 71, .external_lex_state = 3},
  [327] = {.lex_state = 68, .external_lex_state = 3},
  [328] = {.lex_state = 68, .external_lex_state = 3},
  [329] = {.lex_state = 68, .external_lex_state = 3},
  [330] = {.lex_state = 68, .external_lex_state = 3},
  [331] = {.lex_state = 68, .external_lex_state = 3},
  [332] = {.lex_state = 68, .external_lex_state = 3},
  [333] = {.lex_state = 68, .external_lex_state = 3},
  [334] = {.lex_state = 68, .external_lex_state = 3},
  [335] = {.lex_state = 68, .external_lex_state = 3},
  [336] = {.lex_state = 68, .external_lex_state = 3},
  [337] = {.lex_state = 68, .external_lex_state = 3},
  [338] = {.lex_state = 68, .external_lex_state = 3},
  [339] = {.lex_state = 68, .external_lex_state = 3},
  [340] = {.lex_state = 68, .external_lex_state = 3},
  [341] = {.lex_state = 68, .external_lex_state = 3},
  [342] = {.lex_state = 68, .external_lex_state = 3},
  [343] = {.lex_state = 68, .external_lex_state = 3},
  [344] = {.lex_state = 68, .external_lex_state = 3},
  [345] = {.lex_state = 68, .external_lex_state = 3},
  [346] = {.lex_state = 68, .external_lex_state = 3},
  [347] = {.lex_state = 68, .external_lex_state = 3},
  [348] = {.lex_state = 68, .external_lex_state = 3},
  [349] = {.lex_state = 68, .external_lex_state = 3},
  [350] = {.lex_state = 68, .external_lex_state = 3},
  [351] = {.lex_state = 68, .external_lex_state = 3},
  [352] = {.lex_state = 156, .external_lex_state = 3},
  [353] = {.lex_state = 157, .external_lex_state = 3},
  [354] = {.lex_state = 156, .external_lex_state = 7},
  [355] = {.lex_state = 156, .external_lex_state = 7},
  [356] = {.lex_state = 156, .external_lex_state = 7},
  [357] = {.lex_state = 156, .external_lex_state = 7},
  [358] = {.lex_state = 156, .external_lex_state = 7},
  [359] = {.lex_state = 156, .external_lex_state = 7},
  [360] = {.lex_state = 156, .external_lex_state = 7},
  [361] = {.lex_state = 156, .external_lex_state = 7},
  [362] = {.lex_state = 156, .external_lex_state = 7},
  [363] = {.lex_state = 156, .external_lex_state = 7},
  [364] = {.lex_state = 156, .external_lex_state = 7},
  [365] = {.lex_state = 156, .external_lex_state = 7},
  [366] = {.lex_state = 156, .external_lex_state = 7},
  [367] = {.lex_state = 156, .external_lex_state = 4},
  [368] = {.lex_state = 156, .external_lex_state = 4},
  [369] = {.lex_state = 156, .external_lex_state = 4},
  [370] = {.lex_state = 156, .external_lex_state = 4},
  [371] = {.lex_state = 156, .external_lex_state = 7},
  [372] = {.lex_state = 156, .external_lex_state = 4},
  [373] = {.lex_state = 156, .external_lex_state = 4},
  [374] = {.lex_state = 156, .external_lex_state = 4},
  [375] = {.lex_state = 156, .external_lex_state = 7},
  [376] = {.lex_state = 156, .external_lex_state = 4},
  [377] = {.lex_state = 156, .external_lex_state = 4},
  [378] = {.lex_state = 156, .external_lex_state = 4},
  [379] = {.lex_state = 156, .external_lex_state = 7},
  [380] = {.lex_state = 156, .external_lex_state = 7},
  [381] = {.lex_state = 156, .external_lex_state = 7},
  [382] = {.lex_state = 156, .external_lex_state = 7},
  [383] = {.lex_state = 156, .external_lex_state = 4},
  [384] = {.lex_state = 156, .external_lex_state = 7},
  [385] = {.lex_state = 156, .external_lex_state = 4},
  [386] = {.lex_state = 156, .external_lex_state = 4},
  [387] = {.lex_state = 156, .external_lex_state = 7},
  [388] = {.lex_state = 156, .external_lex_state = 4},
  [389] = {.lex_state = 156, .external_lex_state = 4},
  [390] = {.lex_state = 156, .external_lex_state = 7},
  [391] = {.lex_state = 156, .external_lex_state = 4},
  [392] = {.lex_state = 156, .external_lex_state = 4},
  [393] = {.lex_state = 156, .external_lex_state = 4},
  [394] = {.lex_state = 156, .external_lex_state = 4},
  [395] = {.lex_state = 156, .external_lex_state = 4},
  [396] = {.lex_state = 156, .external_lex_state = 4},
  [397] = {.lex_state = 156, .external_lex_state = 7},
  [398] = {.lex_state = 156, .external_lex_state = 4},
  [399] = {.lex_state = 156, .external_lex_state = 4},
  [400] = {.lex_state = 156, .external_lex_state = 4},
  [401] = {.lex_state = 156, .external_lex_state = 7},
  [402] = {.lex_state = 156, .external_lex_state = 7},
  [403] = {.lex_state = 156, .external_lex_state = 7},
  [404] = {.lex_state = 156, .external_lex_state = 7},
  [405] = {.lex_state = 156, .external_lex_state = 7},
  [406] = {.lex_state = 156, .external_lex_state = 7},
  [407] = {.lex_state = 156, .external_lex_state = 7},
  [408] = {.lex_state = 156, .external_lex_state = 7},
  [409] = {.lex_state = 156, .external_lex_state = 7},
  [410] = {.lex_state = 156, .external_lex_state = 7},
  [411] = {.lex_state = 156, .external_lex_state = 7},
  [412] = {.lex_state = 156, .external_lex_state = 7},
  [413] = {.lex_state = 156, .external_lex_state = 7},
  [414] = {.lex_state = 156, .external_lex_state = 7},
  [415] = {.lex_state = 156, .external_lex_state = 7},
  [416] = {.lex_state = 156, .external_lex_state = 4},
  [417] = {.lex_state = 156, .external_lex_state = 6},
  [418] = {.lex_state = 156, .external_lex_state = 7},
  [419] = {.lex_state = 156, .external_lex_state = 7},
  [420] = {.lex_state = 156, .external_lex_state = 7},
  [421] = {.lex_state = 156, .external_lex_state = 7},
  [422] = {.lex_state = 156, .external_lex_state = 6},
  [423] = {.lex_state = 156, .external_lex_state = 6},
  [424] = {.lex_state = 156, .external_lex_state = 7},
  [425] = {.lex_state = 156, .external_lex_state = 7},
  [426] = {.lex_state = 156, .external_lex_state = 7},
  [427] = {.lex_state = 156, .external_lex_state = 7},
  [428] = {.lex_state = 156, .external_lex_state = 7},
  [429] = {.lex_state = 156, .external_lex_state = 7},
  [430] = {.lex_state = 156, .external_lex_state = 7},
  [431] = {.lex_state = 156, .external_lex_state = 7},
  [432] = {.lex_state = 156, .external_lex_state = 7},
  [433] = {.lex_state = 156, .external_lex_state = 7},
  [434] = {.lex_state = 156, .external_lex_state = 8},
  [435] = {.lex_state = 156, .external_lex_state = 7},
  [436] = {.lex_state = 156, .external_lex_state = 7},
  [437] = {.lex_state = 156, .external_lex_state = 9},
  [438] = {.lex_state = 156, .external_lex_state = 7},
  [439] = {.lex_state = 156, .external_lex_state = 7},
  [440] = {.lex_state = 156, .external_lex_state = 7},
  [441] = {.lex_state = 156, .external_lex_state = 9},
  [442] = {.lex_state = 156, .external_lex_state = 9},
  [443] = {.lex_state = 156, .external_lex_state = 7},
  [444] = {.lex_state = 156, .external_lex_state = 7},
  [445] = {.lex_state = 156, .external_lex_state = 7},
  [446] = {.lex_state = 156, .external_lex_state = 7},
  [447] = {.lex_state = 156, .external_lex_state = 7},
  [448] = {.lex_state = 156, .external_lex_state = 9},
  [449] = {.lex_state = 156, .external_lex_state = 7},
  [450] = {.lex_state = 156, .external_lex_state = 7},
  [451] = {.lex_state = 156, .external_lex_state = 9},
  [452] = {.lex_state = 156, .external_lex_state = 9},
  [453] = {.lex_state = 156, .external_lex_state = 7},
  [454] = {.lex_state = 156, .external_lex_state = 7},
  [455] = {.lex_state = 156, .external_lex_state = 9},
  [456] = {.lex_state = 156, .external_lex_state = 7},
  [457] = {.lex_state = 156, .external_lex_state = 7},
  [458] = {.lex_state = 156, .external_lex_state = 7},
  [459] = {.lex_state = 156, .external_lex_state = 7},
  [460] = {.lex_state = 156, .external_lex_state = 7},
  [461] = {.lex_state = 156, .external_lex_state = 7},
  [462] = {.lex_state = 156, .external_lex_state = 7},
  [463] = {.lex_state = 156, .external_lex_state = 9},
  [464] = {.lex_state = 156, .external_lex_state = 7},
  [465] = {.lex_state = 156, .external_lex_state = 9},
  [466] = {.lex_state = 156, .external_lex_state = 7},
  [467] = {.lex_state = 156, .external_lex_state = 7},
  [468] = {.lex_state = 156, .external_lex_state = 9},
  [469] = {.lex_state = 156, .external_lex_state = 7},
  [470] = {.lex_state = 156, .external_lex_state = 7},
  [471] = {.lex_state = 156, .external_lex_state = 9},
  [472] = {.lex_state = 156, .external_lex_state = 9},
  [473] = {.lex_state = 156, .external_lex_state = 9},
  [474] = {.lex_state = 156, .external_lex_state = 7},
  [475] = {.lex_state = 156, .external_lex_state = 9},
  [476] = {.lex_state = 156, .external_lex_state = 7},
  [477] = {.lex_state = 156, .external_lex_state = 9},
  [478] = {.lex_state = 156, .external_lex_state = 9},
  [479] = {.lex_state = 156, .external_lex_state = 7},
  [480] = {.lex_state = 156, .external_lex_state = 7},
  [481] = {.lex_state = 156, .external_lex_state = 7},
  [482] = {.lex_state = 156, .external_lex_state = 7},
  [483] = {.lex_state = 156, .external_lex_state = 7},
  [484] = {.lex_state = 156, .external_lex_state = 7},
  [485] = {.lex_state = 156, .external_lex_state = 7},
  [486] = {.lex_state = 156, .external_lex_state = 7},
  [487] = {.lex_state = 156, .external_lex_state = 7},
  [488] = {.lex_state = 156, .external_lex_state = 7},
  [489] = {.lex_state = 156, .external_lex_state = 7},
  [490] = {.lex_state = 156, .external_lex_state = 7},
  [491] = {.lex_state = 156, .external_lex_state = 7},
  [492] = {.lex_state = 156, .external_lex_state = 7},
  [493] = {.lex_state = 156, .external_lex_state = 7},
  [494] = {.lex_state = 156, .external_lex_state = 7},
  [495] = {.lex_state = 156, .external_lex_state = 7},
  [496] = {.lex_state = 156, .external_lex_state = 7},
  [497] = {.lex_state = 156, .external_lex_state = 7},
  [498] = {.lex_state = 156, .external_lex_state = 7},
  [499] = {.lex_state = 156, .external_lex_state = 7},
  [500] = {.lex_state = 156, .external_lex_state = 7},
  [501] = {.lex_state = 156, .external_lex_state = 7},
  [502] = {.lex_state = 156, .external_lex_state = 7},
  [503] = {.lex_state = 156, .external_lex_state = 7},
  [504] = {.lex_state = 156, .external_lex_state = 7},
  [505] = {.lex_state = 156, .external_lex_state = 7},
  [506] = {.lex_state = 156, .external_lex_state = 7},
  [507] = {.lex_state = 156, .external_lex_state = 7},
  [508] = {.lex_state = 156, .external_lex_state = 7},
  [509] = {.lex_state = 156, .external_lex_state = 7},
  [510] = {.lex_state = 156, .external_lex_state = 7},
  [511] = {.lex_state = 156, .external_lex_state = 7},
  [512] = {.lex_state = 156, .external_lex_state = 7},
  [513] = {.lex_state = 156, .external_lex_state = 7},
  [514] = {.lex_state = 156, .external_lex_state = 7},
  [515] = {.lex_state = 156, .external_lex_state = 7},
  [516] = {.lex_state = 156, .external_lex_state = 7},
  [517] = {.lex_state = 156, .external_lex_state = 7},
  [518] = {.lex_state = 156, .external_lex_state = 7},
  [519] = {.lex_state = 156, .external_lex_state = 7},
  [520] = {.lex_state = 156, .external_lex_state = 7},
  [521] = {.lex_state = 156, .external_lex_state = 7},
  [522] = {.lex_state = 156, .external_lex_state = 7},
  [523] = {.lex_state = 156, .external_lex_state = 7},
  [524] = {.lex_state = 156, .external_lex_state = 7},
  [525] = {.lex_state = 156, .external_lex_state = 7},
  [526] = {.lex_state = 156, .external_lex_state = 7},
  [527] = {.lex_state = 156, .external_lex_state = 7},
  [528] = {.lex_state = 156, .external_lex_state = 7},
  [529] = {.lex_state = 156, .external_lex_state = 7},
  [530] = {.lex_state = 156, .external_lex_state = 7},
  [531] = {.lex_state = 156, .external_lex_state = 7},
  [532] = {.lex_state = 156, .external_lex_state = 7},
  [533] = {.lex_state = 156, .external_lex_state = 7},
  [534] = {.lex_state = 156, .external_lex_state = 7},
  [535] = {.lex_state = 156, .external_lex_state = 7},
  [536] = {.lex_state = 156, .external_lex_state = 7},
  [537] = {.lex_state = 156, .external_lex_state = 7},
  [538] = {.lex_state = 156, .external_lex_state = 7},
  [539] = {.lex_state = 156, .external_lex_state = 7},
  [540] = {.lex_state = 156, .external_lex_state = 7},
  [541] = {.lex_state = 156, .external_lex_state = 7},
  [542] = {.lex_state = 156, .external_lex_state = 7},
  [543] = {.lex_state = 156, .external_lex_state = 7},
  [544] = {.lex_state = 156, .external_lex_state = 7},
  [545] = {.lex_state = 156, .external_lex_state = 7},
  [546] = {.lex_state = 156, .external_lex_state = 7},
  [547] = {.lex_state = 156, .external_lex_state = 7},
  [548] = {.lex_state = 156, .external_lex_state = 7},
  [549] = {.lex_state = 156, .external_lex_state = 7},
  [550] = {.lex_state = 156, .external_lex_state = 7},
  [551] = {.lex_state = 156, .external_lex_state = 7},
  [552] = {.lex_state = 156, .external_lex_state = 7},
  [553] = {.lex_state = 156, .external_lex_state = 7},
  [554] = {.lex_state = 156, .external_lex_state = 7},
  [555] = {.lex_state = 156, .external_lex_state = 7},
  [556] = {.lex_state = 156, .external_lex_state = 7},
  [557] = {.lex_state = 156, .external_lex_state = 7},
  [558] = {.lex_state = 156, .external_lex_state = 7},
  [559] = {.lex_state = 156, .external_lex_state = 7},
  [560] = {.lex_state = 156, .external_lex_state = 7},
  [561] = {.lex_state = 156, .external_lex_state = 7},
  [562] = {.lex_state = 156, .external_lex_state = 7},
  [563] = {.lex_state = 156, .external_lex_state = 7},
  [564] = {.lex_state = 156, .external_lex_state = 7},
  [565] = {.lex_state = 156, .external_lex_state = 7},
  [566] = {.lex_state = 156, .external_lex_state = 7},
  [567] = {.lex_state = 156, .external_lex_state = 7},
  [568] = {.lex_state = 156, .external_lex_state = 7},
  [569] = {.lex_state = 156, .external_lex_state = 7},
  [570] = {.lex_state = 156, .external_lex_state = 7},
  [571] = {.lex_state = 156, .external_lex_state = 7},
  [572] = {.lex_state = 156, .external_lex_state = 7},
  [573] = {.lex_state = 156, .external_lex_state = 7},
  [574] = {.lex_state = 156, .external_lex_state = 7},
  [575] = {.lex_state = 156, .external_lex_state = 7},
  [576] = {.lex_state = 156, .external_lex_state = 7},
  [577] = {.lex_state = 156, .external_lex_state = 7},
  [578] = {.lex_state = 156, .external_lex_state = 7},
  [579] = {.lex_state = 156, .external_lex_state = 7},
  [580] = {.lex_state = 156, .external_lex_state = 7},
  [581] = {.lex_state = 156, .external_lex_state = 7},
  [582] = {.lex_state = 156, .external_lex_state = 7},
  [583] = {.lex_state = 156, .external_lex_state = 7},
  [584] = {.lex_state = 156, .external_lex_state = 7},
  [585] = {.lex_state = 156, .external_lex_state = 7},
  [586] = {.lex_state = 156, .external_lex_state = 7},
  [587] = {.lex_state = 156, .external_lex_state = 7},
  [588] = {.lex_state = 156, .external_lex_state = 7},
  [589] = {.lex_state = 156, .external_lex_state = 7},
  [590] = {.lex_state = 156, .external_lex_state = 7},
  [591] = {.lex_state = 156, .external_lex_state = 7},
  [592] = {.lex_state = 156, .external_lex_state = 7},
  [593] = {.lex_state = 156, .external_lex_state = 7},
  [594] = {.lex_state = 156, .external_lex_state = 7},
  [595] = {.lex_state = 156, .external_lex_state = 7},
  [596] = {.lex_state = 156, .external_lex_state = 7},
  [597] = {.lex_state = 156, .external_lex_state = 7},
  [598] = {.lex_state = 156, .external_lex_state = 7},
  [599] = {.lex_state = 156, .external_lex_state = 7},
  [600] = {.lex_state = 156, .external_lex_state = 7},
  [601] = {.lex_state = 156, .external_lex_state = 7},
  [602] = {.lex_state = 156, .external_lex_state = 7},
  [603] = {.lex_state = 156, .external_lex_state = 7},
  [604] = {.lex_state = 156, .external_lex_state = 7},
  [605] = {.lex_state = 156, .external_lex_state = 7},
  [606] = {.lex_state = 156, .external_lex_state = 7},
  [607] = {.lex_state = 156, .external_lex_state = 7},
  [608] = {.lex_state = 156, .external_lex_state = 7},
  [609] = {.lex_state = 156, .external_lex_state = 7},
  [610] = {.lex_state = 156, .external_lex_state = 7},
  [611] = {.lex_state = 156, .external_lex_state = 7},
  [612] = {.lex_state = 156, .external_lex_state = 7},
  [613] = {.lex_state = 156, .external_lex_state = 7},
  [614] = {.lex_state = 156, .external_lex_state = 7},
  [615] = {.lex_state = 156, .external_lex_state = 7},
  [616] = {.lex_state = 156, .external_lex_state = 7},
  [617] = {.lex_state = 156, .external_lex_state = 7},
  [618] = {.lex_state = 156, .external_lex_state = 7},
  [619] = {.lex_state = 156, .external_lex_state = 7},
  [620] = {.lex_state = 156, .external_lex_state = 7},
  [621] = {.lex_state = 156, .external_lex_state = 7},
  [622] = {.lex_state = 156, .external_lex_state = 7},
  [623] = {.lex_state = 156, .external_lex_state = 7},
  [624] = {.lex_state = 156, .external_lex_state = 7},
  [625] = {.lex_state = 156, .external_lex_state = 7},
  [626] = {.lex_state = 156, .external_lex_state = 7},
  [627] = {.lex_state = 156, .external_lex_state = 7},
  [628] = {.lex_state = 156, .external_lex_state = 7},
  [629] = {.lex_state = 156, .external_lex_state = 7},
  [630] = {.lex_state = 156, .external_lex_state = 7},
  [631] = {.lex_state = 156, .external_lex_state = 7},
  [632] = {.lex_state = 156, .external_lex_state = 7},
  [633] = {.lex_state = 156, .external_lex_state = 7},
  [634] = {.lex_state = 156, .external_lex_state = 7},
  [635] = {.lex_state = 156, .external_lex_state = 7},
  [636] = {.lex_state = 156, .external_lex_state = 7},
  [637] = {.lex_state = 156, .external_lex_state = 7},
  [638] = {.lex_state = 156, .external_lex_state = 7},
  [639] = {.lex_state = 156, .external_lex_state = 7},
  [640] = {.lex_state = 156, .external_lex_state = 7},
  [641] = {.lex_state = 156, .external_lex_state = 7},
  [642] = {.lex_state = 156, .external_lex_state = 7},
  [643] = {.lex_state = 156, .external_lex_state = 7},
  [644] = {.lex_state = 156, .external_lex_state = 7},
  [645] = {.lex_state = 156, .external_lex_state = 7},
  [646] = {.lex_state = 156, .external_lex_state = 7},
  [647] = {.lex_state = 156, .external_lex_state = 7},
  [648] = {.lex_state = 156, .external_lex_state = 7},
  [649] = {.lex_state = 156, .external_lex_state = 7},
  [650] = {.lex_state = 156, .external_lex_state = 7},
  [651] = {.lex_state = 156, .external_lex_state = 7},
  [652] = {.lex_state = 156, .external_lex_state = 7},
  [653] = {.lex_state = 156, .external_lex_state = 7},
  [654] = {.lex_state = 156, .external_lex_state = 7},
  [655] = {.lex_state = 156, .external_lex_state = 7},
  [656] = {.lex_state = 156, .external_lex_state = 7},
  [657] = {.lex_state = 156, .external_lex_state = 7},
  [658] = {.lex_state = 156, .external_lex_state = 7},
  [659] = {.lex_state = 156, .external_lex_state = 7},
  [660] = {.lex_state = 156, .external_lex_state = 7},
  [661] = {.lex_state = 156, .external_lex_state = 7},
  [662] = {.lex_state = 156, .external_lex_state = 7},
  [663] = {.lex_state = 156, .external_lex_state = 7},
  [664] = {.lex_state = 156, .external_lex_state = 7},
  [665] = {.lex_state = 156, .external_lex_state = 7},
  [666] = {.lex_state = 156, .external_lex_state = 7},
  [667] = {.lex_state = 156, .external_lex_state = 7},
  [668] = {.lex_state = 156, .external_lex_state = 7},
  [669] = {.lex_state = 156, .external_lex_state = 7},
  [670] = {.lex_state = 156, .external_lex_state = 7},
  [671] = {.lex_state = 156, .external_lex_state = 7},
  [672] = {.lex_state = 156, .external_lex_state = 7},
  [673] = {.lex_state = 156, .external_lex_state = 7},
  [674] = {.lex_state = 156, .external_lex_state = 7},
  [675] = {.lex_state = 156, .external_lex_state = 7},
  [676] = {.lex_state = 156, .external_lex_state = 7},
  [677] = {.lex_state = 156, .external_lex_state = 7},
  [678] = {.lex_state = 156, .external_lex_state = 7},
  [679] = {.lex_state = 156, .external_lex_state = 7},
  [680] = {.lex_state = 156, .external_lex_state = 7},
  [681] = {.lex_state = 156, .external_lex_state = 7},
  [682] = {.lex_state = 156, .external_lex_state = 7},
  [683] = {.lex_state = 156, .external_lex_state = 7},
  [684] = {.lex_state = 156, .external_lex_state = 7},
  [685] = {.lex_state = 156, .external_lex_state = 7},
  [686] = {.lex_state = 156, .external_lex_state = 7},
  [687] = {.lex_state = 156, .external_lex_state = 7},
  [688] = {.lex_state = 156, .external_lex_state = 7},
  [689] = {.lex_state = 156, .external_lex_state = 7},
  [690] = {.lex_state = 156, .external_lex_state = 7},
  [691] = {.lex_state = 156, .external_lex_state = 7},
  [692] = {.lex_state = 156, .external_lex_state = 7},
  [693] = {.lex_state = 156, .external_lex_state = 7},
  [694] = {.lex_state = 156, .external_lex_state = 7},
  [695] = {.lex_state = 156, .external_lex_state = 7},
  [696] = {.lex_state = 156, .external_lex_state = 7},
  [697] = {.lex_state = 156, .external_lex_state = 7},
  [698] = {.lex_state = 156, .external_lex_state = 7},
  [699] = {.lex_state = 156, .external_lex_state = 7},
  [700] = {.lex_state = 156, .external_lex_state = 7},
  [701] = {.lex_state = 156, .external_lex_state = 7},
  [702] = {.lex_state = 156, .external_lex_state = 7},
  [703] = {.lex_state = 156, .external_lex_state = 7},
  [704] = {.lex_state = 156, .external_lex_state = 7},
  [705] = {.lex_state = 156, .external_lex_state = 7},
  [706] = {.lex_state = 156, .external_lex_state = 7},
  [707] = {.lex_state = 156, .external_lex_state = 7},
  [708] = {.lex_state = 156, .external_lex_state = 7},
  [709] = {.lex_state = 156, .external_lex_state = 7},
  [710] = {.lex_state = 156, .external_lex_state = 7},
  [711] = {.lex_state = 156, .external_lex_state = 7},
  [712] = {.lex_state = 156, .external_lex_state = 7},
  [713] = {.lex_state = 156, .external_lex_state = 7},
  [714] = {.lex_state = 156, .external_lex_state = 7},
  [715] = {.lex_state = 156, .external_lex_state = 7},
  [716] = {.lex_state = 156, .external_lex_state = 7},
  [717] = {.lex_state = 156, .external_lex_state = 7},
  [718] = {.lex_state = 156, .external_lex_state = 7},
  [719] = {.lex_state = 156, .external_lex_state = 7},
  [720] = {.lex_state = 156, .external_lex_state = 7},
  [721] = {.lex_state = 156, .external_lex_state = 7},
  [722] = {.lex_state = 156, .external_lex_state = 7},
  [723] = {.lex_state = 156, .external_lex_state = 7},
  [724] = {.lex_state = 156, .external_lex_state = 7},
  [725] = {.lex_state = 156, .external_lex_state = 7},
  [726] = {.lex_state = 156, .external_lex_state = 7},
  [727] = {.lex_state = 156, .external_lex_state = 7},
  [728] = {.lex_state = 156, .external_lex_state = 7},
  [729] = {.lex_state = 156, .external_lex_state = 7},
  [730] = {.lex_state = 156, .external_lex_state = 7},
  [731] = {.lex_state = 156, .external_lex_state = 7},
  [732] = {.lex_state = 156, .external_lex_state = 7},
  [733] = {.lex_state = 156, .external_lex_state = 7},
  [734] = {.lex_state = 156, .external_lex_state = 7},
  [735] = {.lex_state = 156, .external_lex_state = 7},
  [736] = {.lex_state = 156, .external_lex_state = 7},
  [737] = {.lex_state = 156, .external_lex_state = 7},
  [738] = {.lex_state = 156, .external_lex_state = 7},
  [739] = {.lex_state = 156, .external_lex_state = 7},
  [740] = {.lex_state = 156, .external_lex_state = 7},
  [741] = {.lex_state = 156, .external_lex_state = 7},
  [742] = {.lex_state = 156, .external_lex_state = 7},
  [743] = {.lex_state = 156, .external_lex_state = 7},
  [744] = {.lex_state = 156, .external_lex_state = 7},
  [745] = {.lex_state = 156, .external_lex_state = 7},
  [746] = {.lex_state = 156, .external_lex_state = 7},
  [747] = {.lex_state = 156, .external_lex_state = 7},
  [748] = {.lex_state = 156, .external_lex_state = 7},
  [749] = {.lex_state = 156, .external_lex_state = 7},
  [750] = {.lex_state = 156, .external_lex_state = 7},
  [751] = {.lex_state = 156, .external_lex_state = 7},
  [752] = {.lex_state = 156, .external_lex_state = 7},
  [753] = {.lex_state = 156, .external_lex_state = 7},
  [754] = {.lex_state = 156, .external_lex_state = 7},
  [755] = {.lex_state = 156, .external_lex_state = 7},
  [756] = {.lex_state = 156, .external_lex_state = 7},
  [757] = {.lex_state = 156, .external_lex_state = 7},
  [758] = {.lex_state = 70, .external_lex_state = 2},
  [759] = {.lex_state = 65, .external_lex_state = 2},
  [760] = {.lex_state = 70, .external_lex_state = 3},
  [761] = {.lex_state = 65, .external_lex_state = 3},
  [762] = {.lex_state = 64, .external_lex_state = 2},
  [763] = {.lex_state = 64, .external_lex_state = 2},
  [764] = {.lex_state = 64, .external_lex_state = 2},
  [765] = {.lex_state = 64, .external_lex_state = 2},
  [766] = {.lex_state = 64, .external_lex_state = 2},
  [767] = {.lex_state = 85, .external_lex_state = 2},
  [768] = {.lex_state = 106, .external_lex_state = 3},
  [769] = {.lex_state = 64, .external_lex_state = 2},
  [770] = {.lex_state = 82, .external_lex_state = 3},
  [771] = {.lex_state = 64, .external_lex_state = 2},
  [772] = {.lex_state = 64, .external_lex_state = 2},
  [773] = {.lex_state = 64, .external_lex_state = 2},
  [774] = {.lex_state = 68, .external_lex_state = 10},
  [775] = {.lex_state = 64, .external_lex_state = 2},
  [776] = {.lex_state = 70, .external_lex_state = 5},
  [777] = {.lex_state = 70, .external_lex_state = 4},
  [778] = {.lex_state = 70, .external_lex_state = 2},
  [779] = {.lex_state = 64, .external_lex_state = 2},
  [780] = {.lex_state = 64, .external_lex_state = 2},
  [781] = {.lex_state = 64, .external_lex_state = 2},
  [782] = {.lex_state = 82, .external_lex_state = 2},
  [783] = {.lex_state = 68, .external_lex_state = 10},
  [784] = {.lex_state = 85, .external_lex_state = 3},
  [785] = {.lex_state = 64, .external_lex_state = 2},
  [786] = {.lex_state = 94, .external_lex_state = 2},
  [787] = {.lex_state = 64, .external_lex_state = 2},
  [788] = {.lex_state = 86, .external_lex_state = 3},
  [789] = {.lex_state = 64, .external_lex_state = 2},
  [790] = {.lex_state = 64, .external_lex_state = 2},
  [791] = {.lex_state = 64, .external_lex_state = 2},
  [792] = {.lex_state = 64, .external_lex_state = 2},
  [793] = {.lex_state = 107, .external_lex_state = 3},
  [794] = {.lex_state = 64, .external_lex_state = 2},
  [795] = {.lex_state = 64, .external_lex_state = 2},
  [796] = {.lex_state = 65, .external_lex_state = 2},
  [797] = {.lex_state = 64, .external_lex_state = 2},
  [798] = {.lex_state = 64, .external_lex_state = 2},
  [799] = {.lex_state = 68, .external_lex_state = 10},
  [800] = {.lex_state = 88, .external_lex_state = 3},
  [801] = {.lex_state = 64, .external_lex_state = 2},
  [802] = {.lex_state = 64, .external_lex_state = 2},
  [803] = {.lex_state = 64, .external_lex_state = 2},
  [804] = {.lex_state = 64, .external_lex_state = 2},
  [805] = {.lex_state = 87, .external_lex_state = 3},
  [806] = {.lex_state = 70, .external_lex_state = 6},
  [807] = {.lex_state = 64, .external_lex_state = 2},
  [808] = {.lex_state = 64, .external_lex_state = 2},
  [809] = {.lex_state = 64, .external_lex_state = 2},
  [810] = {.lex_state = 84, .external_lex_state = 3},
  [811] = {.lex_state = 64, .external_lex_state = 3},
  [812] = {.lex_state = 64, .external_lex_state = 3},
  [813] = {.lex_state = 64, .external_lex_state = 3},
  [814] = {.lex_state = 94, .external_lex_state = 3},
  [815] = {.lex_state = 64, .external_lex_state = 3},
  [816] = {.lex_state = 64, .external_lex_state = 3},
  [817] = {.lex_state = 65, .external_lex_state = 4},
  [818] = {.lex_state = 109, .external_lex_state = 3},
  [819] = {.lex_state = 65, .external_lex_state = 5},
  [820] = {.lex_state = 68, .external_lex_state = 10},
  [821] = {.lex_state = 69, .external_lex_state = 2},
  [822] = {.lex_state = 68, .external_lex_state = 2},
  [823] = {.lex_state = 69, .external_lex_state = 2},
  [824] = {.lex_state = 98, .external_lex_state = 3},
  [825] = {.lex_state = 110, .external_lex_state = 3},
  [826] = {.lex_state = 69, .external_lex_state = 2},
  [827] = {.lex_state = 66, .external_lex_state = 2},
  [828] = {.lex_state = 68, .external_lex_state = 10},
  [829] = {.lex_state = 90, .external_lex_state = 3},
  [830] = {.lex_state = 69, .external_lex_state = 2},
  [831] = {.lex_state = 102, .external_lex_state = 3},
  [832] = {.lex_state = 69, .external_lex_state = 2},
  [833] = {.lex_state = 68, .external_lex_state = 10},
  [834] = {.lex_state = 65, .external_lex_state = 6},
  [835] = {.lex_state = 69, .external_lex_state = 2},
  [836] = {.lex_state = 69, .external_lex_state = 2},
  [837] = {.lex_state = 68, .external_lex_state = 2},
  [838] = {.lex_state = 69, .external_lex_state = 2},
  [839] = {.lex_state = 68, .external_lex_state = 2},
  [840] = {.lex_state = 64, .external_lex_state = 3},
  [841] = {.lex_state = 68, .external_lex_state = 11},
  [842] = {.lex_state = 71, .external_lex_state = 2},
  [843] = {.lex_state = 71, .external_lex_state = 2},
  [844] = {.lex_state = 68, .external_lex_state = 2},
  [845] = {.lex_state = 68, .external_lex_state = 2},
  [846] = {.lex_state = 64, .external_lex_state = 3},
  [847] = {.lex_state = 68, .external_lex_state = 2},
  [848] = {.lex_state = 64, .external_lex_state = 3},
  [849] = {.lex_state = 69, .external_lex_state = 2},
  [850] = {.lex_state = 64, .external_lex_state = 3},
  [851] = {.lex_state = 68, .external_lex_state = 11},
  [852] = {.lex_state = 64, .external_lex_state = 3},
  [853] = {.lex_state = 64, .external_lex_state = 3},
  [854] = {.lex_state = 67, .external_lex_state = 2},
  [855] = {.lex_state = 67, .external_lex_state = 2},
  [856] = {.lex_state = 64, .external_lex_state = 3},
  [857] = {.lex_state = 69, .external_lex_state = 2},
  [858] = {.lex_state = 67, .external_lex_state = 2},
  [859] = {.lex_state = 64, .external_lex_state = 3},
  [860] = {.lex_state = 67, .external_lex_state = 2},
  [861] = {.lex_state = 68, .external_lex_state = 2},
  [862] = {.lex_state = 68, .external_lex_state = 2},
  [863] = {.lex_state = 68, .external_lex_state = 2},
  [864] = {.lex_state = 68, .external_lex_state = 2},
  [865] = {.lex_state = 68, .external_lex_state = 2},
  [866] = {.lex_state = 68, .external_lex_state = 2},
  [867] = {.lex_state = 68, .external_lex_state = 2},
  [868] = {.lex_state = 68, .external_lex_state = 2},
  [869] = {.lex_state = 68, .external_lex_state = 2},
  [870] = {.lex_state = 68, .external_lex_state = 2},
  [871] = {.lex_state = 68, .external_lex_state = 2},
  [872] = {.lex_state = 68, .external_lex_state = 2},
  [873] = {.lex_state = 68, .external_lex_state = 2},
  [874] = {.lex_state = 68, .external_lex_state = 2},
  [875] = {.lex_state = 68, .external_lex_state = 2},
  [876] = {.lex_state = 68, .external_lex_state = 2},
  [877] = {.lex_state = 68, .external_lex_state = 2},
  [878] = {.lex_state = 68, .external_lex_state = 2},
  [879] = {.lex_state = 68, .external_lex_state = 2},
  [880] = {.lex_state = 68, .external_lex_state = 2},
  [881] = {.lex_state = 68, .external_lex_state = 2},
  [882] = {.lex_state = 68, .external_lex_state = 2},
  [883] = {.lex_state = 68, .external_lex_state = 2},
  [884] = {.lex_state = 68, .external_lex_state = 2},
  [885] = {.lex_state = 68, .external_lex_state = 2},
  [886] = {.lex_state = 68, .external_lex_state = 2},
  [887] = {.lex_state = 68, .external_lex_state = 2},
  [888] = {.lex_state = 68, .external_lex_state = 2},
  [889] = {.lex_state = 68, .external_lex_state = 2},
  [890] = {.lex_state = 68, .external_lex_state = 2},
  [891] = {.lex_state = 68, .external_lex_state = 2},
  [892] = {.lex_state = 68, .external_lex_state = 2},
  [893] = {.lex_state = 68, .external_lex_state = 2},
  [894] = {.lex_state = 68, .external_lex_state = 2},
  [895] = {.lex_state = 64, .external_lex_state = 3},
  [896] = {.lex_state = 68, .external_lex_state = 2},
  [897] = {.lex_state = 68, .external_lex_state = 2},
  [898] = {.lex_state = 68, .external_lex_state = 2},
  [899] = {.lex_state = 68, .external_lex_state = 2},
  [900] = {.lex_state = 68, .external_lex_state = 2},
  [901] = {.lex_state = 68, .external_lex_state = 2},
  [902] = {.lex_state = 64, .external_lex_state = 3},
  [903] = {.lex_state = 68, .external_lex_state = 2},
  [904] = {.lex_state = 64, .external_lex_state = 3},
  [905] = {.lex_state = 68, .external_lex_state = 2},
  [906] = {.lex_state = 68, .external_lex_state = 2},
  [907] = {.lex_state = 68, .external_lex_state = 2},
  [908] = {.lex_state = 68, .external_lex_state = 11},
  [909] = {.lex_state = 68, .external_lex_state = 2},
  [910] = {.lex_state = 64, .external_lex_state = 3},
  [911] = {.lex_state = 64, .external_lex_state = 3},
  [912] = {.lex_state = 68, .external_lex_state = 2},
  [913] = {.lex_state = 68, .external_lex_state = 2},
  [914] = {.lex_state = 68, .external_lex_state = 2},
  [915] = {.lex_state = 68, .external_lex_state = 2},
  [916] = {.lex_state = 68, .external_lex_state = 2},
  [917] = {.lex_state = 68, .external_lex_state = 2},
  [918] = {.lex_state = 68, .external_lex_state = 2},
  [919] = {.lex_state = 68, .external_lex_state = 2},
  [920] = {.lex_state = 64, .external_lex_state = 3},
  [921] = {.lex_state = 64, .external_lex_state = 3},
  [922] = {.lex_state = 64, .external_lex_state = 3},
  [923] = {.lex_state = 64, .external_lex_state = 3},
  [924] = {.lex_state = 64, .external_lex_state = 3},
  [925] = {.lex_state = 64, .external_lex_state = 3},
  [926] = {.lex_state = 64, .external_lex_state = 3},
  [927] = {.lex_state = 68, .external_lex_state = 2},
  [928] = {.lex_state = 68, .external_lex_state = 2},
  [929] = {.lex_state = 68, .external_lex_state = 2},
  [930] = {.lex_state = 64, .external_lex_state = 3},
  [931] = {.lex_state = 68, .external_lex_state = 2},
  [932] = {.lex_state = 68, .external_lex_state = 2},
  [933] = {.lex_state = 64, .external_lex_state = 3},
  [934] = {.lex_state = 64, .external_lex_state = 3},
  [935] = {.lex_state = 68, .external_lex_state = 2},
  [936] = {.lex_state = 68, .external_lex_state = 2},
  [937] = {.lex_state = 68, .external_lex_state = 2},
  [938] = {.lex_state = 68, .external_lex_state = 2},
  [939] = {.lex_state = 68, .external_lex_state = 2},
  [940] = {.lex_state = 68, .external_lex_state = 2},
  [941] = {.lex_state = 68, .external_lex_state = 2},
  [942] = {.lex_state = 68, .external_lex_state = 2},
  [943] = {.lex_state = 68, .external_lex_state = 2},
  [944] = {.lex_state = 68, .external_lex_state = 2},
  [945] = {.lex_state = 68, .external_lex_state = 2},
  [946] = {.lex_state = 68, .external_lex_state = 2},
  [947] = {.lex_state = 68, .external_lex_state = 2},
  [948] = {.lex_state = 64, .external_lex_state = 3},
  [949] = {.lex_state = 68, .external_lex_state = 2},
  [950] = {.lex_state = 68, .external_lex_state = 2},
  [951] = {.lex_state = 64, .external_lex_state = 3},
  [952] = {.lex_state = 68, .external_lex_state = 2},
  [953] = {.lex_state = 68, .external_lex_state = 2},
  [954] = {.lex_state = 68, .external_lex_state = 2},
  [955] = {.lex_state = 68, .external_lex_state = 2},
  [956] = {.lex_state = 68, .external_lex_state = 2},
  [957] = {.lex_state = 68, .external_lex_state = 2},
  [958] = {.lex_state = 68, .external_lex_state = 2},
  [959] = {.lex_state = 78, .external_lex_state = 2},
  [960] = {.lex_state = 78, .external_lex_state = 2},
  [961] = {.lex_state = 78, .external_lex_state = 2},
  [962] = {.lex_state = 78, .external_lex_state = 2},
  [963] = {.lex_state = 78, .external_lex_state = 2},
  [964] = {.lex_state = 66, .external_lex_state = 3},
  [965] = {.lex_state = 64, .external_lex_state = 4},
  [966] = {.lex_state = 69, .external_lex_state = 3},
  [967] = {.lex_state = 67, .external_lex_state = 3},
  [968] = {.lex_state = 64, .external_lex_state = 5},
  [969] = {.lex_state = 64, .external_lex_state = 5},
  [970] = {.lex_state = 64, .external_lex_state = 5},
  [971] = {.lex_state = 68, .external_lex_state = 3},
  [972] = {.lex_state = 68, .external_lex_state = 11},
  [973] = {.lex_state = 64, .external_lex_state = 4},
  [974] = {.lex_state = 69, .external_lex_state = 3},
  [975] = {.lex_state = 69, .external_lex_state = 3},
  [976] = {.lex_state = 68, .external_lex_state = 11},
  [977] = {.lex_state = 78, .external_lex_state = 3},
  [978] = {.lex_state = 78, .external_lex_state = 3},
  [979] = {.lex_state = 67, .external_lex_state = 3},
  [980] = {.lex_state = 78, .external_lex_state = 3},
  [981] = {.lex_state = 64, .external_lex_state = 5},
  [982] = {.lex_state = 78, .external_lex_state = 3},
  [983] = {.lex_state = 69, .external_lex_state = 3},
  [984] = {.lex_state = 64, .external_lex_state = 5},
  [985] = {.lex_state = 68, .external_lex_state = 11},
  [986] = {.lex_state = 78, .external_lex_state = 3},
  [987] = {.lex_state = 69, .external_lex_state = 3},
  [988] = {.lex_state = 67, .external_lex_state = 3},
  [989] = {.lex_state = 64, .external_lex_state = 4},
  [990] = {.lex_state = 64, .external_lex_state = 4},
  [991] = {.lex_state = 67, .external_lex_state = 3},
  [992] = {.lex_state = 64, .external_lex_state = 4},
  [993] = {.lex_state = 79, .external_lex_state = 3},
  [994] = {.lex_state = 77, .external_lex_state = 3},
  [995] = {.lex_state = 80, .external_lex_state = 3},
  [996] = {.lex_state = 115, .external_lex_state = 10},
  [997] = {.lex_state = 64, .external_lex_state = 6},
  [998] = {.lex_state = 64, .external_lex_state = 6},
  [999] = {.lex_state = 64, .external_lex_state = 6},
  [1000] = {.lex_state = 69, .external_lex_state = 3},
  [1001] = {.lex_state = 69, .external_lex_state = 3},
  [1002] = {.lex_state = 68, .external_lex_state = 3},
  [1003] = {.lex_state = 71, .external_lex_state = 3},
  [1004] = {.lex_state = 79, .external_lex_state = 3},
  [1005] = {.lex_state = 77, .external_lex_state = 3},
  [1006] = {.lex_state = 78, .external_lex_state = 2},
  [1007] = {.lex_state = 78, .external_lex_state = 2},
  [1008] = {.lex_state = 68, .external_lex_state = 3},
  [1009] = {.lex_state = 77, .external_lex_state = 3},
  [1010] = {.lex_state = 81, .external_lex_state = 3},
  [1011] = {.lex_state = 78, .external_lex_state = 2},
  [1012] = {.lex_state = 69, .external_lex_state = 3},
  [1013] = {.lex_state = 64, .external_lex_state = 6},
  [1014] = {.lex_state = 115, .external_lex_state = 10},
  [1015] = {.lex_state = 79, .external_lex_state = 3},
  [1016] = {.lex_state = 78, .external_lex_state = 2},
  [1017] = {.lex_state = 80, .external_lex_state = 3},
  [1018] = {.lex_state = 69, .external_lex_state = 3},
  [1019] = {.lex_state = 78, .external_lex_state = 2},
  [1020] = {.lex_state = 77, .external_lex_state = 3},
  [1021] = {.lex_state = 68, .external_lex_state = 3},
  [1022] = {.lex_state = 78, .external_lex_state = 2},
  [1023] = {.lex_state = 79, .external_lex_state = 3},
  [1024] = {.lex_state = 68, .external_lex_state = 3},
  [1025] = {.lex_state = 68, .external_lex_state = 3},
  [1026] = {.lex_state = 80, .external_lex_state = 3},
  [1027] = {.lex_state = 80, .external_lex_state = 3},
  [1028] = {.lex_state = 78, .external_lex_state = 2},
  [1029] = {.lex_state = 80, .external_lex_state = 3},
  [1030] = {.lex_state = 81, .external_lex_state = 3},
  [1031] = {.lex_state = 81, .external_lex_state = 3},
  [1032] = {.lex_state = 81, .external_lex_state = 3},
  [1033] = {.lex_state = 78, .external_lex_state = 2},
  [1034] = {.lex_state = 81, .external_lex_state = 3},
  [1035] = {.lex_state = 81, .external_lex_state = 3},
  [1036] = {.lex_state = 64, .external_lex_state = 6},
  [1037] = {.lex_state = 79, .external_lex_state = 3},
  [1038] = {.lex_state = 71, .external_lex_state = 3},
  [1039] = {.lex_state = 69, .external_lex_state = 3},
  [1040] = {.lex_state = 77, .external_lex_state = 3},
  [1041] = {.lex_state = 68, .external_lex_state = 3},
  [1042] = {.lex_state = 68, .external_lex_state = 3},
  [1043] = {.lex_state = 68, .external_lex_state = 3},
  [1044] = {.lex_state = 64, .external_lex_state = 4},
  [1045] = {.lex_state = 68, .external_lex_state = 3},
  [1046] = {.lex_state = 64, .external_lex_state = 4},
  [1047] = {.lex_state = 64, .external_lex_state = 4},
  [1048] = {.lex_state = 68, .external_lex_state = 3},
  [1049] = {.lex_state = 68, .external_lex_state = 3},
  [1050] = {.lex_state = 68, .external_lex_state = 12},
  [1051] = {.lex_state = 68, .external_lex_state = 3},
  [1052] = {.lex_state = 68, .external_lex_state = 3},
  [1053] = {.lex_state = 68, .external_lex_state = 3},
  [1054] = {.lex_state = 78, .external_lex_state = 2},
  [1055] = {.lex_state = 68, .external_lex_state = 13},
  [1056] = {.lex_state = 68, .external_lex_state = 3},
  [1057] = {.lex_state = 78, .external_lex_state = 3},
  [1058] = {.lex_state = 68, .external_lex_state = 3},
  [1059] = {.lex_state = 68, .external_lex_state = 3},
  [1060] = {.lex_state = 78, .external_lex_state = 3},
  [1061] = {.lex_state = 78, .external_lex_state = 3},
  [1062] = {.lex_state = 68, .external_lex_state = 3},
  [1063] = {.lex_state = 68, .external_lex_state = 3},
  [1064] = {.lex_state = 68, .external_lex_state = 3},
  [1065] = {.lex_state = 78, .external_lex_state = 3},
  [1066] = {.lex_state = 78, .external_lex_state = 2},
  [1067] = {.lex_state = 78, .external_lex_state = 3},
  [1068] = {.lex_state = 68, .external_lex_state = 3},
  [1069] = {.lex_state = 68, .external_lex_state = 3},
  [1070] = {.lex_state = 78, .external_lex_state = 2},
  [1071] = {.lex_state = 78, .external_lex_state = 2},
  [1072] = {.lex_state = 68, .external_lex_state = 3},
  [1073] = {.lex_state = 68, .external_lex_state = 3},
  [1074] = {.lex_state = 68, .external_lex_state = 3},
  [1075] = {.lex_state = 68, .external_lex_state = 3},
  [1076] = {.lex_state = 68, .external_lex_state = 3},
  [1077] = {.lex_state = 68, .external_lex_state = 3},
  [1078] = {.lex_state = 68, .external_lex_state = 3},
  [1079] = {.lex_state = 68, .external_lex_state = 3},
  [1080] = {.lex_state = 68, .external_lex_state = 3},
  [1081] = {.lex_state = 68, .external_lex_state = 3},
  [1082] = {.lex_state = 115, .external_lex_state = 10},
  [1083] = {.lex_state = 78, .external_lex_state = 2},
  [1084] = {.lex_state = 68, .external_lex_state = 3},
  [1085] = {.lex_state = 68, .external_lex_state = 3},
  [1086] = {.lex_state = 68, .external_lex_state = 13},
  [1087] = {.lex_state = 68, .external_lex_state = 3},
  [1088] = {.lex_state = 68, .external_lex_state = 3},
  [1089] = {.lex_state = 68, .external_lex_state = 12},
  [1090] = {.lex_state = 68, .external_lex_state = 3},
  [1091] = {.lex_state = 64, .external_lex_state = 3},
  [1092] = {.lex_state = 64, .external_lex_state = 5},
  [1093] = {.lex_state = 68, .external_lex_state = 3},
  [1094] = {.lex_state = 68, .external_lex_state = 3},
  [1095] = {.lex_state = 116, .external_lex_state = 11},
  [1096] = {.lex_state = 68, .external_lex_state = 3},
  [1097] = {.lex_state = 68, .external_lex_state = 3},
  [1098] = {.lex_state = 68, .external_lex_state = 3},
  [1099] = {.lex_state = 68, .external_lex_state = 3},
  [1100] = {.lex_state = 78, .external_lex_state = 2},
  [1101] = {.lex_state = 68, .external_lex_state = 3},
  [1102] = {.lex_state = 64, .external_lex_state = 5},
  [1103] = {.lex_state = 78, .external_lex_state = 2},
  [1104] = {.lex_state = 78, .external_lex_state = 2},
  [1105] = {.lex_state = 116, .external_lex_state = 11},
  [1106] = {.lex_state = 68, .external_lex_state = 3},
  [1107] = {.lex_state = 68, .external_lex_state = 3},
  [1108] = {.lex_state = 78, .external_lex_state = 2},
  [1109] = {.lex_state = 68, .external_lex_state = 3},
  [1110] = {.lex_state = 64, .external_lex_state = 4},
  [1111] = {.lex_state = 68, .external_lex_state = 3},
  [1112] = {.lex_state = 64, .external_lex_state = 5},
  [1113] = {.lex_state = 68, .external_lex_state = 3},
  [1114] = {.lex_state = 78, .external_lex_state = 3},
  [1115] = {.lex_state = 64, .external_lex_state = 4},
  [1116] = {.lex_state = 78, .external_lex_state = 2},
  [1117] = {.lex_state = 68, .external_lex_state = 3},
  [1118] = {.lex_state = 68, .external_lex_state = 3},
  [1119] = {.lex_state = 78, .external_lex_state = 2},
  [1120] = {.lex_state = 68, .external_lex_state = 3},
  [1121] = {.lex_state = 64, .external_lex_state = 5},
  [1122] = {.lex_state = 68, .external_lex_state = 3},
  [1123] = {.lex_state = 68, .external_lex_state = 3},
  [1124] = {.lex_state = 68, .external_lex_state = 3},
  [1125] = {.lex_state = 68, .external_lex_state = 3},
  [1126] = {.lex_state = 64, .external_lex_state = 5},
  [1127] = {.lex_state = 68, .external_lex_state = 3},
  [1128] = {.lex_state = 68, .external_lex_state = 3},
  [1129] = {.lex_state = 68, .external_lex_state = 3},
  [1130] = {.lex_state = 68, .external_lex_state = 3},
  [1131] = {.lex_state = 68, .external_lex_state = 3},
  [1132] = {.lex_state = 68, .external_lex_state = 3},
  [1133] = {.lex_state = 68, .external_lex_state = 3},
  [1134] = {.lex_state = 68, .external_lex_state = 3},
  [1135] = {.lex_state = 68, .external_lex_state = 3},
  [1136] = {.lex_state = 68, .external_lex_state = 3},
  [1137] = {.lex_state = 78, .external_lex_state = 2},
  [1138] = {.lex_state = 68, .external_lex_state = 3},
  [1139] = {.lex_state = 68, .external_lex_state = 3},
  [1140] = {.lex_state = 68, .external_lex_state = 3},
  [1141] = {.lex_state = 68, .external_lex_state = 3},
  [1142] = {.lex_state = 68, .external_lex_state = 3},
  [1143] = {.lex_state = 68, .external_lex_state = 3},
  [1144] = {.lex_state = 68, .external_lex_state = 3},
  [1145] = {.lex_state = 78, .external_lex_state = 2},
  [1146] = {.lex_state = 68, .external_lex_state = 3},
  [1147] = {.lex_state = 68, .external_lex_state = 3},
  [1148] = {.lex_state = 68, .external_lex_state = 3},
  [1149] = {.lex_state = 64, .external_lex_state = 5},
  [1150] = {.lex_state = 115, .external_lex_state = 11},
  [1151] = {.lex_state = 78, .external_lex_state = 2},
  [1152] = {.lex_state = 115, .external_lex_state = 11},
  [1153] = {.lex_state = 78, .external_lex_state = 2},
  [1154] = {.lex_state = 64, .external_lex_state = 5},
  [1155] = {.lex_state = 68, .external_lex_state = 3},
  [1156] = {.lex_state = 68, .external_lex_state = 3},
  [1157] = {.lex_state = 68, .external_lex_state = 3},
  [1158] = {.lex_state = 64, .external_lex_state = 5},
  [1159] = {.lex_state = 68, .external_lex_state = 3},
  [1160] = {.lex_state = 68, .external_lex_state = 3},
  [1161] = {.lex_state = 64, .external_lex_state = 4},
  [1162] = {.lex_state = 68, .external_lex_state = 3},
  [1163] = {.lex_state = 64, .external_lex_state = 4},
  [1164] = {.lex_state = 68, .external_lex_state = 3},
  [1165] = {.lex_state = 64, .external_lex_state = 4},
  [1166] = {.lex_state = 68, .external_lex_state = 3},
  [1167] = {.lex_state = 78, .external_lex_state = 3},
  [1168] = {.lex_state = 78, .external_lex_state = 2},
  [1169] = {.lex_state = 78, .external_lex_state = 2},
  [1170] = {.lex_state = 78, .external_lex_state = 3},
  [1171] = {.lex_state = 68, .external_lex_state = 3},
  [1172] = {.lex_state = 64, .external_lex_state = 4},
  [1173] = {.lex_state = 64, .external_lex_state = 4},
  [1174] = {.lex_state = 68, .external_lex_state = 13},
  [1175] = {.lex_state = 78, .external_lex_state = 3},
  [1176] = {.lex_state = 79, .external_lex_state = 3},
  [1177] = {.lex_state = 80, .external_lex_state = 3},
  [1178] = {.lex_state = 64, .external_lex_state = 4},
  [1179] = {.lex_state = 78, .external_lex_state = 3},
  [1180] = {.lex_state = 79, .external_lex_state = 3},
  [1181] = {.lex_state = 64, .external_lex_state = 4},
  [1182] = {.lex_state = 78, .external_lex_state = 3},
  [1183] = {.lex_state = 64, .external_lex_state = 4},
  [1184] = {.lex_state = 64, .external_lex_state = 4},
  [1185] = {.lex_state = 78, .external_lex_state = 3},
  [1186] = {.lex_state = 64, .external_lex_state = 4},
  [1187] = {.lex_state = 80, .external_lex_state = 3},
  [1188] = {.lex_state = 64, .external_lex_state = 5},
  [1189] = {.lex_state = 64, .external_lex_state = 5},
  [1190] = {.lex_state = 119, .external_lex_state = 11},
  [1191] = {.lex_state = 64, .external_lex_state = 5},
  [1192] = {.lex_state = 64, .external_lex_state = 5},
  [1193] = {.lex_state = 80, .external_lex_state = 3},
  [1194] = {.lex_state = 64, .external_lex_state = 6},
  [1195] = {.lex_state = 95, .external_lex_state = 2},
  [1196] = {.lex_state = 79, .external_lex_state = 3},
  [1197] = {.lex_state = 78, .external_lex_state = 3},
  [1198] = {.lex_state = 78, .external_lex_state = 3},
  [1199] = {.lex_state = 78, .external_lex_state = 3},
  [1200] = {.lex_state = 80, .external_lex_state = 3},
  [1201] = {.lex_state = 64, .external_lex_state = 6},
  [1202] = {.lex_state = 64, .external_lex_state = 5},
  [1203] = {.lex_state = 64, .external_lex_state = 5},
  [1204] = {.lex_state = 78, .external_lex_state = 3},
  [1205] = {.lex_state = 79, .external_lex_state = 3},
  [1206] = {.lex_state = 68, .external_lex_state = 14},
  [1207] = {.lex_state = 64, .external_lex_state = 5},
  [1208] = {.lex_state = 79, .external_lex_state = 3},
  [1209] = {.lex_state = 64, .external_lex_state = 6},
  [1210] = {.lex_state = 64, .external_lex_state = 6},
  [1211] = {.lex_state = 79, .external_lex_state = 3},
  [1212] = {.lex_state = 78, .external_lex_state = 3},
  [1213] = {.lex_state = 78, .external_lex_state = 3},
  [1214] = {.lex_state = 81, .external_lex_state = 3},
  [1215] = {.lex_state = 81, .external_lex_state = 3},
  [1216] = {.lex_state = 78, .external_lex_state = 3},
  [1217] = {.lex_state = 64, .external_lex_state = 6},
  [1218] = {.lex_state = 119, .external_lex_state = 11},
  [1219] = {.lex_state = 80, .external_lex_state = 3},
  [1220] = {.lex_state = 66, .external_lex_state = 2},
  [1221] = {.lex_state = 64, .external_lex_state = 4},
  [1222] = {.lex_state = 81, .external_lex_state = 3},
  [1223] = {.lex_state = 81, .external_lex_state = 3},
  [1224] = {.lex_state = 81, .external_lex_state = 3},
  [1225] = {.lex_state = 81, .external_lex_state = 3},
  [1226] = {.lex_state = 78, .external_lex_state = 3},
  [1227] = {.lex_state = 68, .external_lex_state = 14},
  [1228] = {.lex_state = 77, .external_lex_state = 3},
  [1229] = {.lex_state = 78, .external_lex_state = 3},
  [1230] = {.lex_state = 78, .external_lex_state = 3},
  [1231] = {.lex_state = 77, .external_lex_state = 3},
  [1232] = {.lex_state = 78, .external_lex_state = 3},
  [1233] = {.lex_state = 81, .external_lex_state = 3},
  [1234] = {.lex_state = 78, .external_lex_state = 3},
  [1235] = {.lex_state = 80, .external_lex_state = 3},
  [1236] = {.lex_state = 64, .external_lex_state = 4},
  [1237] = {.lex_state = 77, .external_lex_state = 3},
  [1238] = {.lex_state = 78, .external_lex_state = 3},
  [1239] = {.lex_state = 64, .external_lex_state = 3},
  [1240] = {.lex_state = 64, .external_lex_state = 6},
  [1241] = {.lex_state = 81, .external_lex_state = 3},
  [1242] = {.lex_state = 77, .external_lex_state = 3},
  [1243] = {.lex_state = 64, .external_lex_state = 5},
  [1244] = {.lex_state = 79, .external_lex_state = 3},
  [1245] = {.lex_state = 64, .external_lex_state = 5},
  [1246] = {.lex_state = 64, .external_lex_state = 5},
  [1247] = {.lex_state = 64, .external_lex_state = 5},
  [1248] = {.lex_state = 77, .external_lex_state = 3},
  [1249] = {.lex_state = 77, .external_lex_state = 3},
  [1250] = {.lex_state = 80, .external_lex_state = 3},
  [1251] = {.lex_state = 120, .external_lex_state = 11},
  [1252] = {.lex_state = 77, .external_lex_state = 3},
  [1253] = {.lex_state = 108, .external_lex_state = 11},
  [1254] = {.lex_state = 64, .external_lex_state = 6},
  [1255] = {.lex_state = 64, .external_lex_state = 5},
  [1256] = {.lex_state = 64, .external_lex_state = 5},
  [1257] = {.lex_state = 80, .external_lex_state = 3},
  [1258] = {.lex_state = 64, .external_lex_state = 4},
  [1259] = {.lex_state = 64, .external_lex_state = 6},
  [1260] = {.lex_state = 64, .external_lex_state = 4},
  [1261] = {.lex_state = 108, .external_lex_state = 11},
  [1262] = {.lex_state = 116, .external_lex_state = 11},
  [1263] = {.lex_state = 64, .external_lex_state = 4},
  [1264] = {.lex_state = 115, .external_lex_state = 11},
  [1265] = {.lex_state = 71, .external_lex_state = 11},
  [1266] = {.lex_state = 77, .external_lex_state = 3},
  [1267] = {.lex_state = 68, .external_lex_state = 12},
  [1268] = {.lex_state = 79, .external_lex_state = 3},
  [1269] = {.lex_state = 64, .external_lex_state = 4},
  [1270] = {.lex_state = 64, .external_lex_state = 5},
  [1271] = {.lex_state = 64, .external_lex_state = 5},
  [1272] = {.lex_state = 64, .external_lex_state = 4},
  [1273] = {.lex_state = 64, .external_lex_state = 4},
  [1274] = {.lex_state = 64, .external_lex_state = 4},
  [1275] = {.lex_state = 71, .external_lex_state = 11},
  [1276] = {.lex_state = 120, .external_lex_state = 11},
  [1277] = {.lex_state = 64, .external_lex_state = 5},
  [1278] = {.lex_state = 64, .external_lex_state = 5},
  [1279] = {.lex_state = 64, .external_lex_state = 4},
  [1280] = {.lex_state = 96, .external_lex_state = 2},
  [1281] = {.lex_state = 81, .external_lex_state = 3},
  [1282] = {.lex_state = 79, .external_lex_state = 3},
  [1283] = {.lex_state = 115, .external_lex_state = 2},
  [1284] = {.lex_state = 97, .external_lex_state = 2},
  [1285] = {.lex_state = 79, .external_lex_state = 3},
  [1286] = {.lex_state = 80, .external_lex_state = 3},
  [1287] = {.lex_state = 66, .external_lex_state = 4},
  [1288] = {.lex_state = 108, .external_lex_state = 11},
  [1289] = {.lex_state = 71, .external_lex_state = 11},
  [1290] = {.lex_state = 77, .external_lex_state = 3},
  [1291] = {.lex_state = 116, .external_lex_state = 2},
  [1292] = {.lex_state = 77, .external_lex_state = 3},
  [1293] = {.lex_state = 77, .external_lex_state = 3},
  [1294] = {.lex_state = 97, .external_lex_state = 2},
  [1295] = {.lex_state = 80, .external_lex_state = 3},
  [1296] = {.lex_state = 77, .external_lex_state = 3},
  [1297] = {.lex_state = 64, .external_lex_state = 6},
  [1298] = {.lex_state = 80, .external_lex_state = 3},
  [1299] = {.lex_state = 64, .external_lex_state = 6},
  [1300] = {.lex_state = 80, .external_lex_state = 3},
  [1301] = {.lex_state = 80, .external_lex_state = 3},
  [1302] = {.lex_state = 64, .external_lex_state = 6},
  [1303] = {.lex_state = 64, .external_lex_state = 6},
  [1304] = {.lex_state = 77, .external_lex_state = 3},
  [1305] = {.lex_state = 77, .external_lex_state = 3},
  [1306] = {.lex_state = 67, .external_lex_state = 2},
  [1307] = {.lex_state = 77, .external_lex_state = 3},
  [1308] = {.lex_state = 119, .external_lex_state = 11},
  [1309] = {.lex_state = 83, .external_lex_state = 2},
  [1310] = {.lex_state = 111, .external_lex_state = 3},
  [1311] = {.lex_state = 80, .external_lex_state = 3},
  [1312] = {.lex_state = 77, .external_lex_state = 3},
  [1313] = {.lex_state = 77, .external_lex_state = 3},
  [1314] = {.lex_state = 64, .external_lex_state = 6},
  [1315] = {.lex_state = 64, .external_lex_state = 6},
  [1316] = {.lex_state = 77, .external_lex_state = 3},
  [1317] = {.lex_state = 77, .external_lex_state = 3},
  [1318] = {.lex_state = 64, .external_lex_state = 6},
  [1319] = {.lex_state = 64, .external_lex_state = 6},
  [1320] = {.lex_state = 80, .external_lex_state = 3},
  [1321] = {.lex_state = 81, .external_lex_state = 3},
  [1322] = {.lex_state = 80, .external_lex_state = 3},
  [1323] = {.lex_state = 80, .external_lex_state = 3},
  [1324] = {.lex_state = 81, .external_lex_state = 3},
  [1325] = {.lex_state = 77, .external_lex_state = 3},
  [1326] = {.lex_state = 81, .external_lex_state = 3},
  [1327] = {.lex_state = 96, .external_lex_state = 2},
  [1328] = {.lex_state = 120, .external_lex_state = 11},
  [1329] = {.lex_state = 64, .external_lex_state = 6},
  [1330] = {.lex_state = 79, .external_lex_state = 3},
  [1331] = {.lex_state = 81, .external_lex_state = 3},
  [1332] = {.lex_state = 64, .external_lex_state = 6},
  [1333] = {.lex_state = 77, .external_lex_state = 3},
  [1334] = {.lex_state = 81, .external_lex_state = 3},
  [1335] = {.lex_state = 77, .external_lex_state = 3},
  [1336] = {.lex_state = 79, .external_lex_state = 3},
  [1337] = {.lex_state = 80, .external_lex_state = 3},
  [1338] = {.lex_state = 66, .external_lex_state = 5},
  [1339] = {.lex_state = 79, .external_lex_state = 3},
  [1340] = {.lex_state = 97, .external_lex_state = 2},
  [1341] = {.lex_state = 79, .external_lex_state = 3},
  [1342] = {.lex_state = 80, .external_lex_state = 3},
  [1343] = {.lex_state = 64, .external_lex_state = 6},
  [1344] = {.lex_state = 81, .external_lex_state = 3},
  [1345] = {.lex_state = 80, .external_lex_state = 3},
  [1346] = {.lex_state = 81, .external_lex_state = 3},
  [1347] = {.lex_state = 80, .external_lex_state = 3},
  [1348] = {.lex_state = 67, .external_lex_state = 2},
  [1349] = {.lex_state = 81, .external_lex_state = 3},
  [1350] = {.lex_state = 64, .external_lex_state = 6},
  [1351] = {.lex_state = 64, .external_lex_state = 6},
  [1352] = {.lex_state = 115, .external_lex_state = 10},
  [1353] = {.lex_state = 79, .external_lex_state = 3},
  [1354] = {.lex_state = 64, .external_lex_state = 6},
  [1355] = {.lex_state = 97, .external_lex_state = 2},
  [1356] = {.lex_state = 80, .external_lex_state = 3},
  [1357] = {.lex_state = 81, .external_lex_state = 3},
  [1358] = {.lex_state = 81, .external_lex_state = 3},
  [1359] = {.lex_state = 81, .external_lex_state = 3},
  [1360] = {.lex_state = 64, .external_lex_state = 6},
  [1361] = {.lex_state = 79, .external_lex_state = 3},
  [1362] = {.lex_state = 96, .external_lex_state = 2},
  [1363] = {.lex_state = 81, .external_lex_state = 3},
  [1364] = {.lex_state = 81, .external_lex_state = 3},
  [1365] = {.lex_state = 79, .external_lex_state = 3},
  [1366] = {.lex_state = 64, .external_lex_state = 6},
  [1367] = {.lex_state = 115, .external_lex_state = 10},
  [1368] = {.lex_state = 67, .external_lex_state = 2},
  [1369] = {.lex_state = 80, .external_lex_state = 3},
  [1370] = {.lex_state = 64, .external_lex_state = 3},
  [1371] = {.lex_state = 79, .external_lex_state = 3},
  [1372] = {.lex_state = 68, .external_lex_state = 14},
  [1373] = {.lex_state = 97, .external_lex_state = 2},
  [1374] = {.lex_state = 64, .external_lex_state = 6},
  [1375] = {.lex_state = 77, .external_lex_state = 3},
  [1376] = {.lex_state = 79, .external_lex_state = 3},
  [1377] = {.lex_state = 79, .external_lex_state = 3},
  [1378] = {.lex_state = 79, .external_lex_state = 3},
  [1379] = {.lex_state = 80, .external_lex_state = 3},
  [1380] = {.lex_state = 81, .external_lex_state = 3},
  [1381] = {.lex_state = 79, .external_lex_state = 3},
  [1382] = {.lex_state = 81, .external_lex_state = 3},
  [1383] = {.lex_state = 81, .external_lex_state = 3},
  [1384] = {.lex_state = 96, .external_lex_state = 2},
  [1385] = {.lex_state = 67, .external_lex_state = 2},
  [1386] = {.lex_state = 95, .external_lex_state = 3},
  [1387] = {.lex_state = 80, .external_lex_state = 3},
  [1388] = {.lex_state = 79, .external_lex_state = 3},
  [1389] = {.lex_state = 83, .external_lex_state = 2},
  [1390] = {.lex_state = 77, .external_lex_state = 3},
  [1391] = {.lex_state = 115, .external_lex_state = 10},
  [1392] = {.lex_state = 115, .external_lex_state = 2},
  [1393] = {.lex_state = 79, .external_lex_state = 3},
  [1394] = {.lex_state = 79, .external_lex_state = 3},
  [1395] = {.lex_state = 116, .external_lex_state = 2},
  [1396] = {.lex_state = 77, .external_lex_state = 3},
  [1397] = {.lex_state = 68, .external_lex_state = 3},
  [1398] = {.lex_state = 115, .external_lex_state = 3},
  [1399] = {.lex_state = 89, .external_lex_state = 2},
  [1400] = {.lex_state = 116, .external_lex_state = 11},
  [1401] = {.lex_state = 91, .external_lex_state = 3},
  [1402] = {.lex_state = 99, .external_lex_state = 3},
  [1403] = {.lex_state = 69, .external_lex_state = 5},
  [1404] = {.lex_state = 97, .external_lex_state = 3},
  [1405] = {.lex_state = 69, .external_lex_state = 5},
  [1406] = {.lex_state = 69, .external_lex_state = 5},
  [1407] = {.lex_state = 97, .external_lex_state = 3},
  [1408] = {.lex_state = 69, .external_lex_state = 5},
  [1409] = {.lex_state = 185},
  [1410] = {.lex_state = 68, .external_lex_state = 13},
  [1411] = {.lex_state = 97, .external_lex_state = 3},
  [1412] = {.lex_state = 97, .external_lex_state = 3},
  [1413] = {.lex_state = 69, .external_lex_state = 5},
  [1414] = {.lex_state = 96, .external_lex_state = 3},
  [1415] = {.lex_state = 96, .external_lex_state = 3},
  [1416] = {.lex_state = 115, .external_lex_state = 3},
  [1417] = {.lex_state = 96, .external_lex_state = 3},
  [1418] = {.lex_state = 68, .external_lex_state = 12},
  [1419] = {.lex_state = 97, .external_lex_state = 3},
  [1420] = {.lex_state = 97, .external_lex_state = 2},
  [1421] = {.lex_state = 97, .external_lex_state = 2},
  [1422] = {.lex_state = 71, .external_lex_state = 4},
  [1423] = {.lex_state = 97, .external_lex_state = 2},
  [1424] = {.lex_state = 97, .external_lex_state = 2},
  [1425] = {.lex_state = 96, .external_lex_state = 3},
  [1426] = {.lex_state = 115, .external_lex_state = 2},
  [1427] = {.lex_state = 67, .external_lex_state = 4},
  [1428] = {.lex_state = 115, .external_lex_state = 2},
  [1429] = {.lex_state = 97, .external_lex_state = 2},
  [1430] = {.lex_state = 115, .external_lex_state = 2},
  [1431] = {.lex_state = 103, .external_lex_state = 3},
  [1432] = {.lex_state = 68, .external_lex_state = 12},
  [1433] = {.lex_state = 68, .external_lex_state = 13},
  [1434] = {.lex_state = 112, .external_lex_state = 3},
  [1435] = {.lex_state = 115, .external_lex_state = 2},
  [1436] = {.lex_state = 67, .external_lex_state = 4},
  [1437] = {.lex_state = 115, .external_lex_state = 2},
  [1438] = {.lex_state = 67, .external_lex_state = 5},
  [1439] = {.lex_state = 67, .external_lex_state = 4},
  [1440] = {.lex_state = 71, .external_lex_state = 4},
  [1441] = {.lex_state = 67, .external_lex_state = 4},
  [1442] = {.lex_state = 113, .external_lex_state = 3},
  [1443] = {.lex_state = 71, .external_lex_state = 5},
  [1444] = {.lex_state = 67, .external_lex_state = 5},
  [1445] = {.lex_state = 89, .external_lex_state = 2},
  [1446] = {.lex_state = 115, .external_lex_state = 2},
  [1447] = {.lex_state = 112, .external_lex_state = 3},
  [1448] = {.lex_state = 67, .external_lex_state = 5},
  [1449] = {.lex_state = 116, .external_lex_state = 11},
  [1450] = {.lex_state = 69, .external_lex_state = 4},
  [1451] = {.lex_state = 115, .external_lex_state = 11},
  [1452] = {.lex_state = 115, .external_lex_state = 2},
  [1453] = {.lex_state = 67, .external_lex_state = 5},
  [1454] = {.lex_state = 112, .external_lex_state = 3},
  [1455] = {.lex_state = 89, .external_lex_state = 2},
  [1456] = {.lex_state = 69, .external_lex_state = 4},
  [1457] = {.lex_state = 117, .external_lex_state = 3},
  [1458] = {.lex_state = 69, .external_lex_state = 4},
  [1459] = {.lex_state = 66, .external_lex_state = 6},
  [1460] = {.lex_state = 71, .external_lex_state = 5},
  [1461] = {.lex_state = 117, .external_lex_state = 3},
  [1462] = {.lex_state = 68, .external_lex_state = 2},
  [1463] = {.lex_state = 117, .external_lex_state = 3},
  [1464] = {.lex_state = 117, .external_lex_state = 3},
  [1465] = {.lex_state = 117, .external_lex_state = 3},
  [1466] = {.lex_state = 115, .external_lex_state = 2},
  [1467] = {.lex_state = 112, .external_lex_state = 3},
  [1468] = {.lex_state = 115, .external_lex_state = 11},
  [1469] = {.lex_state = 116, .external_lex_state = 11},
  [1470] = {.lex_state = 68, .external_lex_state = 13},
  [1471] = {.lex_state = 69, .external_lex_state = 4},
  [1472] = {.lex_state = 68, .external_lex_state = 12},
  [1473] = {.lex_state = 69, .external_lex_state = 4},
  [1474] = {.lex_state = 115, .external_lex_state = 11},
  [1475] = {.lex_state = 116, .external_lex_state = 3},
  [1476] = {.lex_state = 115, .external_lex_state = 2},
  [1477] = {.lex_state = 115, .external_lex_state = 2},
  [1478] = {.lex_state = 71, .external_lex_state = 6},
  [1479] = {.lex_state = 115, .external_lex_state = 2},
  [1480] = {.lex_state = 115, .external_lex_state = 2},
  [1481] = {.lex_state = 120, .external_lex_state = 3},
  [1482] = {.lex_state = 115, .external_lex_state = 2},
  [1483] = {.lex_state = 115, .external_lex_state = 2},
  [1484] = {.lex_state = 115, .external_lex_state = 2},
  [1485] = {.lex_state = 101, .external_lex_state = 3},
  [1486] = {.lex_state = 68, .external_lex_state = 4},
  [1487] = {.lex_state = 114, .external_lex_state = 3},
  [1488] = {.lex_state = 101, .external_lex_state = 3},
  [1489] = {.lex_state = 115, .external_lex_state = 2},
  [1490] = {.lex_state = 116, .external_lex_state = 3},
  [1491] = {.lex_state = 165},
  [1492] = {.lex_state = 115, .external_lex_state = 3},
  [1493] = {.lex_state = 67, .external_lex_state = 6},
  [1494] = {.lex_state = 114, .external_lex_state = 3},
  [1495] = {.lex_state = 120, .external_lex_state = 11},
  [1496] = {.lex_state = 69, .external_lex_state = 4},
  [1497] = {.lex_state = 105, .external_lex_state = 3},
  [1498] = {.lex_state = 69, .external_lex_state = 4},
  [1499] = {.lex_state = 115, .external_lex_state = 3},
  [1500] = {.lex_state = 67, .external_lex_state = 6},
  [1501] = {.lex_state = 101, .external_lex_state = 3},
  [1502] = {.lex_state = 101, .external_lex_state = 3},
  [1503] = {.lex_state = 116, .external_lex_state = 3},
  [1504] = {.lex_state = 68, .external_lex_state = 2},
  [1505] = {.lex_state = 69, .external_lex_state = 4},
  [1506] = {.lex_state = 69, .external_lex_state = 4},
  [1507] = {.lex_state = 116, .external_lex_state = 3},
  [1508] = {.lex_state = 67, .external_lex_state = 6},
  [1509] = {.lex_state = 93, .external_lex_state = 3},
  [1510] = {.lex_state = 89, .external_lex_state = 3},
  [1511] = {.lex_state = 67, .external_lex_state = 6},
  [1512] = {.lex_state = 89, .external_lex_state = 2},
  [1513] = {.lex_state = 93, .external_lex_state = 3},
  [1514] = {.lex_state = 68, .external_lex_state = 5},
  [1515] = {.lex_state = 101, .external_lex_state = 3},
  [1516] = {.lex_state = 105, .external_lex_state = 3},
  [1517] = {.lex_state = 105, .external_lex_state = 3},
  [1518] = {.lex_state = 108, .external_lex_state = 11},
  [1519] = {.lex_state = 104, .external_lex_state = 3},
  [1520] = {.lex_state = 115, .external_lex_state = 2},
  [1521] = {.lex_state = 115, .external_lex_state = 2},
  [1522] = {.lex_state = 165},
  [1523] = {.lex_state = 68, .external_lex_state = 14},
  [1524] = {.lex_state = 117, .external_lex_state = 3},
  [1525] = {.lex_state = 117, .external_lex_state = 3},
  [1526] = {.lex_state = 117, .external_lex_state = 3},
  [1527] = {.lex_state = 105, .external_lex_state = 3},
  [1528] = {.lex_state = 117, .external_lex_state = 3},
  [1529] = {.lex_state = 93, .external_lex_state = 3},
  [1530] = {.lex_state = 105, .external_lex_state = 3},
  [1531] = {.lex_state = 93, .external_lex_state = 3},
  [1532] = {.lex_state = 69, .external_lex_state = 5},
  [1533] = {.lex_state = 115, .external_lex_state = 3},
  [1534] = {.lex_state = 68, .external_lex_state = 14},
  [1535] = {.lex_state = 97, .external_lex_state = 3},
  [1536] = {.lex_state = 115, .external_lex_state = 2},
  [1537] = {.lex_state = 115, .external_lex_state = 2},
  [1538] = {.lex_state = 115, .external_lex_state = 2},
  [1539] = {.lex_state = 120, .external_lex_state = 3},
  [1540] = {.lex_state = 71, .external_lex_state = 11},
  [1541] = {.lex_state = 115, .external_lex_state = 2},
  [1542] = {.lex_state = 68, .external_lex_state = 2},
  [1543] = {.lex_state = 115, .external_lex_state = 2},
  [1544] = {.lex_state = 115, .external_lex_state = 2},
  [1545] = {.lex_state = 115, .external_lex_state = 2},
  [1546] = {.lex_state = 114, .external_lex_state = 3},
  [1547] = {.lex_state = 115, .external_lex_state = 2},
  [1548] = {.lex_state = 89, .external_lex_state = 3},
  [1549] = {.lex_state = 115, .external_lex_state = 2},
  [1550] = {.lex_state = 115, .external_lex_state = 2},
  [1551] = {.lex_state = 115, .external_lex_state = 2},
  [1552] = {.lex_state = 115, .external_lex_state = 2},
  [1553] = {.lex_state = 115, .external_lex_state = 2},
  [1554] = {.lex_state = 115, .external_lex_state = 2},
  [1555] = {.lex_state = 115, .external_lex_state = 2},
  [1556] = {.lex_state = 115, .external_lex_state = 2},
  [1557] = {.lex_state = 115, .external_lex_state = 2},
  [1558] = {.lex_state = 68, .external_lex_state = 3},
  [1559] = {.lex_state = 115, .external_lex_state = 3},
  [1560] = {.lex_state = 115, .external_lex_state = 2},
  [1561] = {.lex_state = 69, .external_lex_state = 6},
  [1562] = {.lex_state = 115, .external_lex_state = 2},
  [1563] = {.lex_state = 115, .external_lex_state = 2},
  [1564] = {.lex_state = 119, .external_lex_state = 11},
  [1565] = {.lex_state = 97, .external_lex_state = 3},
  [1566] = {.lex_state = 115, .external_lex_state = 2},
  [1567] = {.lex_state = 115, .external_lex_state = 2},
  [1568] = {.lex_state = 69, .external_lex_state = 6},
  [1569] = {.lex_state = 69, .external_lex_state = 6},
  [1570] = {.lex_state = 115, .external_lex_state = 2},
  [1571] = {.lex_state = 68, .external_lex_state = 4},
  [1572] = {.lex_state = 119, .external_lex_state = 11},
  [1573] = {.lex_state = 120, .external_lex_state = 11},
  [1574] = {.lex_state = 93, .external_lex_state = 3},
  [1575] = {.lex_state = 114, .external_lex_state = 3},
  [1576] = {.lex_state = 115, .external_lex_state = 2},
  [1577] = {.lex_state = 104, .external_lex_state = 3},
  [1578] = {.lex_state = 68, .external_lex_state = 2},
  [1579] = {.lex_state = 116, .external_lex_state = 3},
  [1580] = {.lex_state = 115, .external_lex_state = 2},
  [1581] = {.lex_state = 115, .external_lex_state = 2},
  [1582] = {.lex_state = 116, .external_lex_state = 3},
  [1583] = {.lex_state = 115, .external_lex_state = 2},
  [1584] = {.lex_state = 115, .external_lex_state = 2},
  [1585] = {.lex_state = 115, .external_lex_state = 3},
  [1586] = {.lex_state = 100, .external_lex_state = 3},
  [1587] = {.lex_state = 68, .external_lex_state = 5},
  [1588] = {.lex_state = 68, .external_lex_state = 5},
  [1589] = {.lex_state = 116, .external_lex_state = 3},
  [1590] = {.lex_state = 115, .external_lex_state = 2},
  [1591] = {.lex_state = 115, .external_lex_state = 2},
  [1592] = {.lex_state = 115, .external_lex_state = 2},
  [1593] = {.lex_state = 119, .external_lex_state = 3},
  [1594] = {.lex_state = 115, .external_lex_state = 2},
  [1595] = {.lex_state = 104, .external_lex_state = 3},
  [1596] = {.lex_state = 115, .external_lex_state = 2},
  [1597] = {.lex_state = 68, .external_lex_state = 4},
  [1598] = {.lex_state = 69, .external_lex_state = 6},
  [1599] = {.lex_state = 69, .external_lex_state = 6},
  [1600] = {.lex_state = 115, .external_lex_state = 2},
  [1601] = {.lex_state = 115, .external_lex_state = 2},
  [1602] = {.lex_state = 115, .external_lex_state = 2},
  [1603] = {.lex_state = 115, .external_lex_state = 2},
  [1604] = {.lex_state = 115, .external_lex_state = 2},
  [1605] = {.lex_state = 115, .external_lex_state = 2},
  [1606] = {.lex_state = 115, .external_lex_state = 3},
  [1607] = {.lex_state = 115, .external_lex_state = 3},
  [1608] = {.lex_state = 115, .external_lex_state = 2},
  [1609] = {.lex_state = 115, .external_lex_state = 2},
  [1610] = {.lex_state = 115, .external_lex_state = 2},
  [1611] = {.lex_state = 115, .external_lex_state = 2},
  [1612] = {.lex_state = 115, .external_lex_state = 2},
  [1613] = {.lex_state = 119, .external_lex_state = 11},
  [1614] = {.lex_state = 104, .external_lex_state = 3},
  [1615] = {.lex_state = 115, .external_lex_state = 2},
  [1616] = {.lex_state = 115, .external_lex_state = 2},
  [1617] = {.lex_state = 115, .external_lex_state = 2},
  [1618] = {.lex_state = 89, .external_lex_state = 3},
  [1619] = {.lex_state = 115, .external_lex_state = 2},
  [1620] = {.lex_state = 68, .external_lex_state = 5},
  [1621] = {.lex_state = 116, .external_lex_state = 3},
  [1622] = {.lex_state = 100, .external_lex_state = 3},
  [1623] = {.lex_state = 115, .external_lex_state = 2},
  [1624] = {.lex_state = 115, .external_lex_state = 2},
  [1625] = {.lex_state = 115, .external_lex_state = 2},
  [1626] = {.lex_state = 89, .external_lex_state = 2},
  [1627] = {.lex_state = 115, .external_lex_state = 2},
  [1628] = {.lex_state = 115, .external_lex_state = 2},
  [1629] = {.lex_state = 120, .external_lex_state = 11},
  [1630] = {.lex_state = 68, .external_lex_state = 5},
  [1631] = {.lex_state = 165, .external_lex_state = 15},
  [1632] = {.lex_state = 68, .external_lex_state = 3},
  [1633] = {.lex_state = 115, .external_lex_state = 2},
  [1634] = {.lex_state = 115, .external_lex_state = 2},
  [1635] = {.lex_state = 68, .external_lex_state = 4},
  [1636] = {.lex_state = 108, .external_lex_state = 11},
  [1637] = {.lex_state = 115, .external_lex_state = 2},
  [1638] = {.lex_state = 68, .external_lex_state = 5},
  [1639] = {.lex_state = 115, .external_lex_state = 2},
  [1640] = {.lex_state = 116, .external_lex_state = 3},
  [1641] = {.lex_state = 115, .external_lex_state = 2},
  [1642] = {.lex_state = 68, .external_lex_state = 5},
  [1643] = {.lex_state = 115, .external_lex_state = 2},
  [1644] = {.lex_state = 116, .external_lex_state = 3},
  [1645] = {.lex_state = 115, .external_lex_state = 2},
  [1646] = {.lex_state = 115, .external_lex_state = 2},
  [1647] = {.lex_state = 115, .external_lex_state = 2},
  [1648] = {.lex_state = 115, .external_lex_state = 2},
  [1649] = {.lex_state = 69, .external_lex_state = 4},
  [1650] = {.lex_state = 165, .external_lex_state = 15},
  [1651] = {.lex_state = 115, .external_lex_state = 2},
  [1652] = {.lex_state = 115, .external_lex_state = 2},
  [1653] = {.lex_state = 68, .external_lex_state = 5},
  [1654] = {.lex_state = 68, .external_lex_state = 4},
  [1655] = {.lex_state = 68, .external_lex_state = 2},
  [1656] = {.lex_state = 108, .external_lex_state = 3},
  [1657] = {.lex_state = 68, .external_lex_state = 4},
  [1658] = {.lex_state = 115, .external_lex_state = 2},
  [1659] = {.lex_state = 71, .external_lex_state = 11},
  [1660] = {.lex_state = 97, .external_lex_state = 3},
  [1661] = {.lex_state = 69, .external_lex_state = 5},
  [1662] = {.lex_state = 69, .external_lex_state = 5},
  [1663] = {.lex_state = 97, .external_lex_state = 3},
  [1664] = {.lex_state = 100, .external_lex_state = 3},
  [1665] = {.lex_state = 69, .external_lex_state = 5},
  [1666] = {.lex_state = 69, .external_lex_state = 5},
  [1667] = {.lex_state = 71, .external_lex_state = 11},
  [1668] = {.lex_state = 108, .external_lex_state = 11},
  [1669] = {.lex_state = 115, .external_lex_state = 3},
  [1670] = {.lex_state = 117, .external_lex_state = 3},
  [1671] = {.lex_state = 100, .external_lex_state = 3},
  [1672] = {.lex_state = 92, .external_lex_state = 3},
  [1673] = {.lex_state = 92, .external_lex_state = 3},
  [1674] = {.lex_state = 68, .external_lex_state = 14},
  [1675] = {.lex_state = 108, .external_lex_state = 3},
  [1676] = {.lex_state = 119, .external_lex_state = 3},
  [1677] = {.lex_state = 92, .external_lex_state = 3},
  [1678] = {.lex_state = 118, .external_lex_state = 3},
  [1679] = {.lex_state = 118, .external_lex_state = 3},
  [1680] = {.lex_state = 118, .external_lex_state = 3},
  [1681] = {.lex_state = 92, .external_lex_state = 3},
  [1682] = {.lex_state = 68, .external_lex_state = 4},
  [1683] = {.lex_state = 118, .external_lex_state = 3},
  [1684] = {.lex_state = 118, .external_lex_state = 3},
  [1685] = {.lex_state = 116, .external_lex_state = 3},
  [1686] = {.lex_state = 68, .external_lex_state = 4},
  [1687] = {.lex_state = 71, .external_lex_state = 6},
  [1688] = {.lex_state = 97, .external_lex_state = 3},
  [1689] = {.lex_state = 115, .external_lex_state = 2},
  [1690] = {.lex_state = 116, .external_lex_state = 3},
  [1691] = {.lex_state = 68, .external_lex_state = 5},
  [1692] = {.lex_state = 115, .external_lex_state = 3},
  [1693] = {.lex_state = 115, .external_lex_state = 3},
  [1694] = {.lex_state = 115, .external_lex_state = 3},
  [1695] = {.lex_state = 115, .external_lex_state = 3},
  [1696] = {.lex_state = 116, .external_lex_state = 3},
  [1697] = {.lex_state = 116, .external_lex_state = 3},
  [1698] = {.lex_state = 108, .external_lex_state = 3},
  [1699] = {.lex_state = 116, .external_lex_state = 3},
  [1700] = {.lex_state = 116, .external_lex_state = 3},
  [1701] = {.lex_state = 116, .external_lex_state = 3},
  [1702] = {.lex_state = 116, .external_lex_state = 3},
  [1703] = {.lex_state = 118, .external_lex_state = 3},
  [1704] = {.lex_state = 118, .external_lex_state = 3},
  [1705] = {.lex_state = 68, .external_lex_state = 4},
  [1706] = {.lex_state = 118, .external_lex_state = 3},
  [1707] = {.lex_state = 108, .external_lex_state = 3},
  [1708] = {.lex_state = 118, .external_lex_state = 3},
  [1709] = {.lex_state = 68, .external_lex_state = 4},
  [1710] = {.lex_state = 68, .external_lex_state = 4},
  [1711] = {.lex_state = 115, .external_lex_state = 3},
  [1712] = {.lex_state = 116, .external_lex_state = 3},
  [1713] = {.lex_state = 68, .external_lex_state = 4},
  [1714] = {.lex_state = 115, .external_lex_state = 3},
  [1715] = {.lex_state = 115, .external_lex_state = 3},
  [1716] = {.lex_state = 115, .external_lex_state = 3},
  [1717] = {.lex_state = 115, .external_lex_state = 3},
  [1718] = {.lex_state = 115, .external_lex_state = 3},
  [1719] = {.lex_state = 115, .external_lex_state = 3},
  [1720] = {.lex_state = 115, .external_lex_state = 3},
  [1721] = {.lex_state = 165, .external_lex_state = 15},
  [1722] = {.lex_state = 115, .external_lex_state = 3},
  [1723] = {.lex_state = 115, .external_lex_state = 3},
  [1724] = {.lex_state = 116, .external_lex_state = 3},
  [1725] = {.lex_state = 68, .external_lex_state = 4},
  [1726] = {.lex_state = 68, .external_lex_state = 4},
  [1727] = {.lex_state = 115, .external_lex_state = 3},
  [1728] = {.lex_state = 115, .external_lex_state = 3},
  [1729] = {.lex_state = 71, .external_lex_state = 3},
  [1730] = {.lex_state = 71, .external_lex_state = 3},
  [1731] = {.lex_state = 115, .external_lex_state = 3},
  [1732] = {.lex_state = 115, .external_lex_state = 3},
  [1733] = {.lex_state = 115, .external_lex_state = 3},
  [1734] = {.lex_state = 71, .external_lex_state = 3},
  [1735] = {.lex_state = 115, .external_lex_state = 3},
  [1736] = {.lex_state = 68, .external_lex_state = 4},
  [1737] = {.lex_state = 115, .external_lex_state = 3},
  [1738] = {.lex_state = 115, .external_lex_state = 3},
  [1739] = {.lex_state = 115, .external_lex_state = 3},
  [1740] = {.lex_state = 115, .external_lex_state = 3},
  [1741] = {.lex_state = 115, .external_lex_state = 3},
  [1742] = {.lex_state = 115, .external_lex_state = 3},
  [1743] = {.lex_state = 71, .external_lex_state = 3},
  [1744] = {.lex_state = 115, .external_lex_state = 3},
  [1745] = {.lex_state = 115, .external_lex_state = 3},
  [1746] = {.lex_state = 115, .external_lex_state = 3},
  [1747] = {.lex_state = 115, .external_lex_state = 3},
  [1748] = {.lex_state = 108, .external_lex_state = 3},
  [1749] = {.lex_state = 108, .external_lex_state = 3},
  [1750] = {.lex_state = 68, .external_lex_state = 5},
  [1751] = {.lex_state = 68, .external_lex_state = 4},
  [1752] = {.lex_state = 108, .external_lex_state = 3},
  [1753] = {.lex_state = 115, .external_lex_state = 3},
  [1754] = {.lex_state = 115, .external_lex_state = 3},
  [1755] = {.lex_state = 119, .external_lex_state = 3},
  [1756] = {.lex_state = 68, .external_lex_state = 5},
  [1757] = {.lex_state = 68, .external_lex_state = 5},
  [1758] = {.lex_state = 68, .external_lex_state = 5},
  [1759] = {.lex_state = 68, .external_lex_state = 5},
  [1760] = {.lex_state = 68, .external_lex_state = 5},
  [1761] = {.lex_state = 68, .external_lex_state = 5},
  [1762] = {.lex_state = 68, .external_lex_state = 5},
  [1763] = {.lex_state = 68, .external_lex_state = 5},
  [1764] = {.lex_state = 68, .external_lex_state = 5},
  [1765] = {.lex_state = 108, .external_lex_state = 3},
  [1766] = {.lex_state = 68, .external_lex_state = 5},
  [1767] = {.lex_state = 68, .external_lex_state = 5},
  [1768] = {.lex_state = 68, .external_lex_state = 5},
  [1769] = {.lex_state = 68, .external_lex_state = 5},
  [1770] = {.lex_state = 68, .external_lex_state = 5},
  [1771] = {.lex_state = 68, .external_lex_state = 5},
  [1772] = {.lex_state = 68, .external_lex_state = 5},
  [1773] = {.lex_state = 68, .external_lex_state = 5},
  [1774] = {.lex_state = 68, .external_lex_state = 5},
  [1775] = {.lex_state = 68, .external_lex_state = 5},
  [1776] = {.lex_state = 68, .external_lex_state = 5},
  [1777] = {.lex_state = 68, .external_lex_state = 5},
  [1778] = {.lex_state = 68, .external_lex_state = 5},
  [1779] = {.lex_state = 68, .external_lex_state = 5},
  [1780] = {.lex_state = 68, .external_lex_state = 5},
  [1781] = {.lex_state = 68, .external_lex_state = 5},
  [1782] = {.lex_state = 68, .external_lex_state = 5},
  [1783] = {.lex_state = 115, .external_lex_state = 3},
  [1784] = {.lex_state = 68, .external_lex_state = 5},
  [1785] = {.lex_state = 68, .external_lex_state = 5},
  [1786] = {.lex_state = 68, .external_lex_state = 5},
  [1787] = {.lex_state = 68, .external_lex_state = 5},
  [1788] = {.lex_state = 68, .external_lex_state = 5},
  [1789] = {.lex_state = 68, .external_lex_state = 5},
  [1790] = {.lex_state = 115, .external_lex_state = 3},
  [1791] = {.lex_state = 68, .external_lex_state = 5},
  [1792] = {.lex_state = 165},
  [1793] = {.lex_state = 68, .external_lex_state = 5},
  [1794] = {.lex_state = 68, .external_lex_state = 5},
  [1795] = {.lex_state = 68, .external_lex_state = 5},
  [1796] = {.lex_state = 105, .external_lex_state = 3},
  [1797] = {.lex_state = 115, .external_lex_state = 3},
  [1798] = {.lex_state = 68, .external_lex_state = 5},
  [1799] = {.lex_state = 68, .external_lex_state = 4},
  [1800] = {.lex_state = 115, .external_lex_state = 3},
  [1801] = {.lex_state = 68, .external_lex_state = 4},
  [1802] = {.lex_state = 119, .external_lex_state = 3},
  [1803] = {.lex_state = 68, .external_lex_state = 6},
  [1804] = {.lex_state = 68, .external_lex_state = 4},
  [1805] = {.lex_state = 115, .external_lex_state = 3},
  [1806] = {.lex_state = 68, .external_lex_state = 5},
  [1807] = {.lex_state = 68, .external_lex_state = 4},
  [1808] = {.lex_state = 101, .external_lex_state = 3},
  [1809] = {.lex_state = 68, .external_lex_state = 5},
  [1810] = {.lex_state = 68, .external_lex_state = 5},
  [1811] = {.lex_state = 115, .external_lex_state = 3},
  [1812] = {.lex_state = 115, .external_lex_state = 3},
  [1813] = {.lex_state = 115, .external_lex_state = 3},
  [1814] = {.lex_state = 68, .external_lex_state = 4},
  [1815] = {.lex_state = 69, .external_lex_state = 6},
  [1816] = {.lex_state = 71, .external_lex_state = 3},
  [1817] = {.lex_state = 71, .external_lex_state = 3},
  [1818] = {.lex_state = 68, .external_lex_state = 4},
  [1819] = {.lex_state = 69, .external_lex_state = 6},
  [1820] = {.lex_state = 71, .external_lex_state = 3},
  [1821] = {.lex_state = 68, .external_lex_state = 4},
  [1822] = {.lex_state = 69, .external_lex_state = 6},
  [1823] = {.lex_state = 69, .external_lex_state = 6},
  [1824] = {.lex_state = 119, .external_lex_state = 3},
  [1825] = {.lex_state = 68, .external_lex_state = 4},
  [1826] = {.lex_state = 68, .external_lex_state = 4},
  [1827] = {.lex_state = 68, .external_lex_state = 5},
  [1828] = {.lex_state = 119, .external_lex_state = 3},
  [1829] = {.lex_state = 119, .external_lex_state = 3},
  [1830] = {.lex_state = 68, .external_lex_state = 4},
  [1831] = {.lex_state = 68, .external_lex_state = 4},
  [1832] = {.lex_state = 68, .external_lex_state = 4},
  [1833] = {.lex_state = 68, .external_lex_state = 6},
  [1834] = {.lex_state = 165},
  [1835] = {.lex_state = 68, .external_lex_state = 4},
  [1836] = {.lex_state = 165, .external_lex_state = 16},
  [1837] = {.lex_state = 68, .external_lex_state = 4},
  [1838] = {.lex_state = 68, .external_lex_state = 4},
  [1839] = {.lex_state = 68, .external_lex_state = 4},
  [1840] = {.lex_state = 68, .external_lex_state = 4},
  [1841] = {.lex_state = 68, .external_lex_state = 4},
  [1842] = {.lex_state = 68, .external_lex_state = 4},
  [1843] = {.lex_state = 68, .external_lex_state = 4},
  [1844] = {.lex_state = 115, .external_lex_state = 3},
  [1845] = {.lex_state = 115, .external_lex_state = 3},
  [1846] = {.lex_state = 115, .external_lex_state = 3},
  [1847] = {.lex_state = 68, .external_lex_state = 4},
  [1848] = {.lex_state = 115, .external_lex_state = 3},
  [1849] = {.lex_state = 89, .external_lex_state = 3},
  [1850] = {.lex_state = 118, .external_lex_state = 3},
  [1851] = {.lex_state = 173},
  [1852] = {.lex_state = 68, .external_lex_state = 4},
  [1853] = {.lex_state = 115, .external_lex_state = 3},
  [1854] = {.lex_state = 68, .external_lex_state = 4},
  [1855] = {.lex_state = 68, .external_lex_state = 4},
  [1856] = {.lex_state = 68, .external_lex_state = 4},
  [1857] = {.lex_state = 68, .external_lex_state = 4},
  [1858] = {.lex_state = 116, .external_lex_state = 3},
  [1859] = {.lex_state = 116, .external_lex_state = 3},
  [1860] = {.lex_state = 68, .external_lex_state = 5},
  [1861] = {.lex_state = 116, .external_lex_state = 3},
  [1862] = {.lex_state = 116, .external_lex_state = 3},
  [1863] = {.lex_state = 116, .external_lex_state = 3},
  [1864] = {.lex_state = 165, .external_lex_state = 15},
  [1865] = {.lex_state = 116, .external_lex_state = 3},
  [1866] = {.lex_state = 68, .external_lex_state = 4},
  [1867] = {.lex_state = 116, .external_lex_state = 3},
  [1868] = {.lex_state = 68, .external_lex_state = 6},
  [1869] = {.lex_state = 116, .external_lex_state = 3},
  [1870] = {.lex_state = 116, .external_lex_state = 3},
  [1871] = {.lex_state = 68, .external_lex_state = 6},
  [1872] = {.lex_state = 116, .external_lex_state = 3},
  [1873] = {.lex_state = 116, .external_lex_state = 3},
  [1874] = {.lex_state = 116, .external_lex_state = 3},
  [1875] = {.lex_state = 68, .external_lex_state = 6},
  [1876] = {.lex_state = 120, .external_lex_state = 3},
  [1877] = {.lex_state = 116, .external_lex_state = 3},
  [1878] = {.lex_state = 116, .external_lex_state = 3},
  [1879] = {.lex_state = 116, .external_lex_state = 3},
  [1880] = {.lex_state = 116, .external_lex_state = 3},
  [1881] = {.lex_state = 116, .external_lex_state = 3},
  [1882] = {.lex_state = 120, .external_lex_state = 3},
  [1883] = {.lex_state = 116, .external_lex_state = 3},
  [1884] = {.lex_state = 116, .external_lex_state = 3},
  [1885] = {.lex_state = 116, .external_lex_state = 3},
  [1886] = {.lex_state = 115, .external_lex_state = 3},
  [1887] = {.lex_state = 115, .external_lex_state = 3},
  [1888] = {.lex_state = 115, .external_lex_state = 3},
  [1889] = {.lex_state = 115, .external_lex_state = 3},
  [1890] = {.lex_state = 116, .external_lex_state = 3},
  [1891] = {.lex_state = 116, .external_lex_state = 3},
  [1892] = {.lex_state = 116, .external_lex_state = 3},
  [1893] = {.lex_state = 68, .external_lex_state = 4},
  [1894] = {.lex_state = 68, .external_lex_state = 4},
  [1895] = {.lex_state = 116, .external_lex_state = 3},
  [1896] = {.lex_state = 115, .external_lex_state = 3},
  [1897] = {.lex_state = 116, .external_lex_state = 3},
  [1898] = {.lex_state = 115, .external_lex_state = 3},
  [1899] = {.lex_state = 116, .external_lex_state = 3},
  [1900] = {.lex_state = 68, .external_lex_state = 5},
  [1901] = {.lex_state = 68, .external_lex_state = 6},
  [1902] = {.lex_state = 68, .external_lex_state = 5},
  [1903] = {.lex_state = 105, .external_lex_state = 3},
  [1904] = {.lex_state = 120, .external_lex_state = 3},
  [1905] = {.lex_state = 165, .external_lex_state = 16},
  [1906] = {.lex_state = 105, .external_lex_state = 3},
  [1907] = {.lex_state = 68, .external_lex_state = 5},
  [1908] = {.lex_state = 68, .external_lex_state = 5},
  [1909] = {.lex_state = 68, .external_lex_state = 4},
  [1910] = {.lex_state = 108, .external_lex_state = 3},
  [1911] = {.lex_state = 116, .external_lex_state = 3},
  [1912] = {.lex_state = 115, .external_lex_state = 3},
  [1913] = {.lex_state = 115, .external_lex_state = 3},
  [1914] = {.lex_state = 120, .external_lex_state = 3},
  [1915] = {.lex_state = 68, .external_lex_state = 4},
  [1916] = {.lex_state = 115, .external_lex_state = 3},
  [1917] = {.lex_state = 108, .external_lex_state = 3},
  [1918] = {.lex_state = 105, .external_lex_state = 3},
  [1919] = {.lex_state = 116, .external_lex_state = 3},
  [1920] = {.lex_state = 115, .external_lex_state = 3},
  [1921] = {.lex_state = 116, .external_lex_state = 3},
  [1922] = {.lex_state = 115, .external_lex_state = 3},
  [1923] = {.lex_state = 115, .external_lex_state = 3},
  [1924] = {.lex_state = 115, .external_lex_state = 3},
  [1925] = {.lex_state = 115, .external_lex_state = 3},
  [1926] = {.lex_state = 115, .external_lex_state = 3},
  [1927] = {.lex_state = 105, .external_lex_state = 3},
  [1928] = {.lex_state = 120, .external_lex_state = 3},
  [1929] = {.lex_state = 116, .external_lex_state = 3},
  [1930] = {.lex_state = 116, .external_lex_state = 3},
  [1931] = {.lex_state = 116, .external_lex_state = 3},
  [1932] = {.lex_state = 115, .external_lex_state = 3},
  [1933] = {.lex_state = 115, .external_lex_state = 3},
  [1934] = {.lex_state = 115, .external_lex_state = 3},
  [1935] = {.lex_state = 115, .external_lex_state = 3},
  [1936] = {.lex_state = 115, .external_lex_state = 3},
  [1937] = {.lex_state = 116, .external_lex_state = 3},
  [1938] = {.lex_state = 93, .external_lex_state = 3},
  [1939] = {.lex_state = 93, .external_lex_state = 3},
  [1940] = {.lex_state = 116, .external_lex_state = 3},
  [1941] = {.lex_state = 116, .external_lex_state = 3},
  [1942] = {.lex_state = 115, .external_lex_state = 3},
  [1943] = {.lex_state = 120, .external_lex_state = 3},
  [1944] = {.lex_state = 116, .external_lex_state = 3},
  [1945] = {.lex_state = 115, .external_lex_state = 3},
  [1946] = {.lex_state = 115, .external_lex_state = 3},
  [1947] = {.lex_state = 115, .external_lex_state = 3},
  [1948] = {.lex_state = 115, .external_lex_state = 3},
  [1949] = {.lex_state = 116, .external_lex_state = 3},
  [1950] = {.lex_state = 116, .external_lex_state = 3},
  [1951] = {.lex_state = 116, .external_lex_state = 3},
  [1952] = {.lex_state = 116, .external_lex_state = 3},
  [1953] = {.lex_state = 115, .external_lex_state = 3},
  [1954] = {.lex_state = 115, .external_lex_state = 3},
  [1955] = {.lex_state = 93, .external_lex_state = 3},
  [1956] = {.lex_state = 116, .external_lex_state = 3},
  [1957] = {.lex_state = 116, .external_lex_state = 3},
  [1958] = {.lex_state = 68, .external_lex_state = 5},
  [1959] = {.lex_state = 116, .external_lex_state = 3},
  [1960] = {.lex_state = 115, .external_lex_state = 3},
  [1961] = {.lex_state = 115, .external_lex_state = 3},
  [1962] = {.lex_state = 115, .external_lex_state = 3},
  [1963] = {.lex_state = 115, .external_lex_state = 3},
  [1964] = {.lex_state = 93, .external_lex_state = 3},
  [1965] = {.lex_state = 116, .external_lex_state = 3},
  [1966] = {.lex_state = 116, .external_lex_state = 3},
  [1967] = {.lex_state = 116, .external_lex_state = 3},
  [1968] = {.lex_state = 116, .external_lex_state = 3},
  [1969] = {.lex_state = 116, .external_lex_state = 3},
  [1970] = {.lex_state = 115, .external_lex_state = 3},
  [1971] = {.lex_state = 116, .external_lex_state = 3},
  [1972] = {.lex_state = 116, .external_lex_state = 3},
  [1973] = {.lex_state = 116, .external_lex_state = 3},
  [1974] = {.lex_state = 116, .external_lex_state = 3},
  [1975] = {.lex_state = 68, .external_lex_state = 6},
  [1976] = {.lex_state = 116, .external_lex_state = 3},
  [1977] = {.lex_state = 116, .external_lex_state = 3},
  [1978] = {.lex_state = 68, .external_lex_state = 5},
  [1979] = {.lex_state = 101, .external_lex_state = 3},
  [1980] = {.lex_state = 101, .external_lex_state = 3},
  [1981] = {.lex_state = 116, .external_lex_state = 3},
  [1982] = {.lex_state = 116, .external_lex_state = 3},
  [1983] = {.lex_state = 68, .external_lex_state = 6},
  [1984] = {.lex_state = 116, .external_lex_state = 3},
  [1985] = {.lex_state = 116, .external_lex_state = 3},
  [1986] = {.lex_state = 116, .external_lex_state = 3},
  [1987] = {.lex_state = 116, .external_lex_state = 3},
  [1988] = {.lex_state = 71, .external_lex_state = 3},
  [1989] = {.lex_state = 116, .external_lex_state = 3},
  [1990] = {.lex_state = 120, .external_lex_state = 3},
  [1991] = {.lex_state = 101, .external_lex_state = 3},
  [1992] = {.lex_state = 116, .external_lex_state = 3},
  [1993] = {.lex_state = 93, .external_lex_state = 3},
  [1994] = {.lex_state = 101, .external_lex_state = 3},
  [1995] = {.lex_state = 116, .external_lex_state = 3},
  [1996] = {.lex_state = 116, .external_lex_state = 3},
  [1997] = {.lex_state = 120, .external_lex_state = 3},
  [1998] = {.lex_state = 116, .external_lex_state = 3},
  [1999] = {.lex_state = 116, .external_lex_state = 3},
  [2000] = {.lex_state = 68, .external_lex_state = 4},
  [2001] = {.lex_state = 116, .external_lex_state = 3},
  [2002] = {.lex_state = 119, .external_lex_state = 3},
  [2003] = {.lex_state = 68, .external_lex_state = 4},
  [2004] = {.lex_state = 173},
  [2005] = {.lex_state = 116, .external_lex_state = 3},
  [2006] = {.lex_state = 68, .external_lex_state = 5},
  [2007] = {.lex_state = 116, .external_lex_state = 3},
  [2008] = {.lex_state = 116, .external_lex_state = 3},
  [2009] = {.lex_state = 119, .external_lex_state = 3},
  [2010] = {.lex_state = 119, .external_lex_state = 3},
  [2011] = {.lex_state = 69, .external_lex_state = 6},
  [2012] = {.lex_state = 68, .external_lex_state = 5},
  [2013] = {.lex_state = 68, .external_lex_state = 4},
  [2014] = {.lex_state = 68, .external_lex_state = 5},
  [2015] = {.lex_state = 68, .external_lex_state = 4},
  [2016] = {.lex_state = 68, .external_lex_state = 4},
  [2017] = {.lex_state = 68, .external_lex_state = 4},
  [2018] = {.lex_state = 68, .external_lex_state = 4},
  [2019] = {.lex_state = 68, .external_lex_state = 5},
  [2020] = {.lex_state = 68, .external_lex_state = 5},
  [2021] = {.lex_state = 68, .external_lex_state = 4},
  [2022] = {.lex_state = 68, .external_lex_state = 4},
  [2023] = {.lex_state = 68, .external_lex_state = 4},
  [2024] = {.lex_state = 68, .external_lex_state = 4},
  [2025] = {.lex_state = 68, .external_lex_state = 4},
  [2026] = {.lex_state = 68, .external_lex_state = 4},
  [2027] = {.lex_state = 68, .external_lex_state = 5},
  [2028] = {.lex_state = 68, .external_lex_state = 5},
  [2029] = {.lex_state = 68, .external_lex_state = 4},
  [2030] = {.lex_state = 68, .external_lex_state = 4},
  [2031] = {.lex_state = 68, .external_lex_state = 4},
  [2032] = {.lex_state = 68, .external_lex_state = 5},
  [2033] = {.lex_state = 68, .external_lex_state = 4},
  [2034] = {.lex_state = 68, .external_lex_state = 4},
  [2035] = {.lex_state = 68, .external_lex_state = 4},
  [2036] = {.lex_state = 68, .external_lex_state = 5},
  [2037] = {.lex_state = 68, .external_lex_state = 5},
  [2038] = {.lex_state = 68, .external_lex_state = 4},
  [2039] = {.lex_state = 68, .external_lex_state = 4},
  [2040] = {.lex_state = 68, .external_lex_state = 4},
  [2041] = {.lex_state = 68, .external_lex_state = 4},
  [2042] = {.lex_state = 68, .external_lex_state = 4},
  [2043] = {.lex_state = 68, .external_lex_state = 4},
  [2044] = {.lex_state = 68, .external_lex_state = 5},
  [2045] = {.lex_state = 68, .external_lex_state = 5},
  [2046] = {.lex_state = 68, .external_lex_state = 4},
  [2047] = {.lex_state = 68, .external_lex_state = 4},
  [2048] = {.lex_state = 68, .external_lex_state = 4},
  [2049] = {.lex_state = 68, .external_lex_state = 4},
  [2050] = {.lex_state = 68, .external_lex_state = 4},
  [2051] = {.lex_state = 68, .external_lex_state = 4},
  [2052] = {.lex_state = 68, .external_lex_state = 5},
  [2053] = {.lex_state = 89, .external_lex_state = 3},
  [2054] = {.lex_state = 68, .external_lex_state = 5},
  [2055] = {.lex_state = 68, .external_lex_state = 5},
  [2056] = {.lex_state = 68, .external_lex_state = 4},
  [2057] = {.lex_state = 68, .external_lex_state = 5},
  [2058] = {.lex_state = 68, .external_lex_state = 5},
  [2059] = {.lex_state = 68, .external_lex_state = 5},
  [2060] = {.lex_state = 68, .external_lex_state = 5},
  [2061] = {.lex_state = 68, .external_lex_state = 5},
  [2062] = {.lex_state = 71, .external_lex_state = 3},
  [2063] = {.lex_state = 68, .external_lex_state = 4},
  [2064] = {.lex_state = 68, .external_lex_state = 4},
  [2065] = {.lex_state = 68, .external_lex_state = 5},
  [2066] = {.lex_state = 68, .external_lex_state = 4},
  [2067] = {.lex_state = 68, .external_lex_state = 4},
  [2068] = {.lex_state = 68, .external_lex_state = 4},
  [2069] = {.lex_state = 68, .external_lex_state = 4},
  [2070] = {.lex_state = 68, .external_lex_state = 5},
  [2071] = {.lex_state = 68, .external_lex_state = 5},
  [2072] = {.lex_state = 68, .external_lex_state = 5},
  [2073] = {.lex_state = 68, .external_lex_state = 5},
  [2074] = {.lex_state = 68, .external_lex_state = 5},
  [2075] = {.lex_state = 68, .external_lex_state = 5},
  [2076] = {.lex_state = 68, .external_lex_state = 6},
  [2077] = {.lex_state = 119, .external_lex_state = 3},
  [2078] = {.lex_state = 108, .external_lex_state = 3},
  [2079] = {.lex_state = 68, .external_lex_state = 6},
  [2080] = {.lex_state = 68, .external_lex_state = 6},
  [2081] = {.lex_state = 71, .external_lex_state = 3},
  [2082] = {.lex_state = 108, .external_lex_state = 3},
  [2083] = {.lex_state = 108, .external_lex_state = 3},
  [2084] = {.lex_state = 68, .external_lex_state = 6},
  [2085] = {.lex_state = 68, .external_lex_state = 6},
  [2086] = {.lex_state = 108, .external_lex_state = 3},
  [2087] = {.lex_state = 108, .external_lex_state = 3},
  [2088] = {.lex_state = 108, .external_lex_state = 3},
  [2089] = {.lex_state = 68, .external_lex_state = 6},
  [2090] = {.lex_state = 120, .external_lex_state = 3},
  [2091] = {.lex_state = 108, .external_lex_state = 3},
  [2092] = {.lex_state = 108, .external_lex_state = 3},
  [2093] = {.lex_state = 119, .external_lex_state = 3},
  [2094] = {.lex_state = 120, .external_lex_state = 3},
  [2095] = {.lex_state = 108, .external_lex_state = 3},
  [2096] = {.lex_state = 108, .external_lex_state = 3},
  [2097] = {.lex_state = 108, .external_lex_state = 3},
  [2098] = {.lex_state = 71, .external_lex_state = 3},
  [2099] = {.lex_state = 108, .external_lex_state = 3},
  [2100] = {.lex_state = 71, .external_lex_state = 3},
  [2101] = {.lex_state = 108, .external_lex_state = 3},
  [2102] = {.lex_state = 108, .external_lex_state = 3},
  [2103] = {.lex_state = 68, .external_lex_state = 6},
  [2104] = {.lex_state = 108, .external_lex_state = 3},
  [2105] = {.lex_state = 179},
  [2106] = {.lex_state = 71, .external_lex_state = 3},
  [2107] = {.lex_state = 71, .external_lex_state = 3},
  [2108] = {.lex_state = 108, .external_lex_state = 3},
  [2109] = {.lex_state = 108, .external_lex_state = 3},
  [2110] = {.lex_state = 108, .external_lex_state = 3},
  [2111] = {.lex_state = 108, .external_lex_state = 3},
  [2112] = {.lex_state = 108, .external_lex_state = 3},
  [2113] = {.lex_state = 108, .external_lex_state = 3},
  [2114] = {.lex_state = 108, .external_lex_state = 3},
  [2115] = {.lex_state = 108, .external_lex_state = 3},
  [2116] = {.lex_state = 108, .external_lex_state = 3},
  [2117] = {.lex_state = 108, .external_lex_state = 3},
  [2118] = {.lex_state = 108, .external_lex_state = 3},
  [2119] = {.lex_state = 108, .external_lex_state = 3},
  [2120] = {.lex_state = 108, .external_lex_state = 3},
  [2121] = {.lex_state = 108, .external_lex_state = 3},
  [2122] = {.lex_state = 108, .external_lex_state = 3},
  [2123] = {.lex_state = 108, .external_lex_state = 3},
  [2124] = {.lex_state = 108, .external_lex_state = 3},
  [2125] = {.lex_state = 108, .external_lex_state = 3},
  [2126] = {.lex_state = 108, .external_lex_state = 3},
  [2127] = {.lex_state = 119, .external_lex_state = 3},
  [2128] = {.lex_state = 108, .external_lex_state = 3},
  [2129] = {.lex_state = 179},
  [2130] = {.lex_state = 108, .external_lex_state = 3},
  [2131] = {.lex_state = 108, .external_lex_state = 3},
  [2132] = {.lex_state = 71, .external_lex_state = 3},
  [2133] = {.lex_state = 108, .external_lex_state = 3},
  [2134] = {.lex_state = 108, .external_lex_state = 3},
  [2135] = {.lex_state = 120, .external_lex_state = 3},
  [2136] = {.lex_state = 119, .external_lex_state = 3},
  [2137] = {.lex_state = 119, .external_lex_state = 3},
  [2138] = {.lex_state = 71, .external_lex_state = 3},
  [2139] = {.lex_state = 71, .external_lex_state = 3},
  [2140] = {.lex_state = 120, .external_lex_state = 3},
  [2141] = {.lex_state = 108, .external_lex_state = 3},
  [2142] = {.lex_state = 108, .external_lex_state = 3},
  [2143] = {.lex_state = 119, .external_lex_state = 3},
  [2144] = {.lex_state = 108, .external_lex_state = 3},
  [2145] = {.lex_state = 71, .external_lex_state = 3},
  [2146] = {.lex_state = 71, .external_lex_state = 3},
  [2147] = {.lex_state = 71, .external_lex_state = 3},
  [2148] = {.lex_state = 71, .external_lex_state = 3},
  [2149] = {.lex_state = 71, .external_lex_state = 3},
  [2150] = {.lex_state = 71, .external_lex_state = 3},
  [2151] = {.lex_state = 71, .external_lex_state = 3},
  [2152] = {.lex_state = 108, .external_lex_state = 3},
  [2153] = {.lex_state = 108, .external_lex_state = 3},
  [2154] = {.lex_state = 108, .external_lex_state = 3},
  [2155] = {.lex_state = 71, .external_lex_state = 3},
  [2156] = {.lex_state = 71, .external_lex_state = 3},
  [2157] = {.lex_state = 71, .external_lex_state = 3},
  [2158] = {.lex_state = 71, .external_lex_state = 3},
  [2159] = {.lex_state = 68, .external_lex_state = 6},
  [2160] = {.lex_state = 71, .external_lex_state = 3},
  [2161] = {.lex_state = 71, .external_lex_state = 3},
  [2162] = {.lex_state = 71, .external_lex_state = 3},
  [2163] = {.lex_state = 71, .external_lex_state = 3},
  [2164] = {.lex_state = 71, .external_lex_state = 3},
  [2165] = {.lex_state = 71, .external_lex_state = 3},
  [2166] = {.lex_state = 120, .external_lex_state = 3},
  [2167] = {.lex_state = 71, .external_lex_state = 3},
  [2168] = {.lex_state = 119, .external_lex_state = 3},
  [2169] = {.lex_state = 71, .external_lex_state = 3},
  [2170] = {.lex_state = 71, .external_lex_state = 3},
  [2171] = {.lex_state = 108, .external_lex_state = 3},
  [2172] = {.lex_state = 71, .external_lex_state = 3},
  [2173] = {.lex_state = 108, .external_lex_state = 3},
  [2174] = {.lex_state = 71, .external_lex_state = 3},
  [2175] = {.lex_state = 71, .external_lex_state = 3},
  [2176] = {.lex_state = 71, .external_lex_state = 3},
  [2177] = {.lex_state = 71, .external_lex_state = 3},
  [2178] = {.lex_state = 71, .external_lex_state = 3},
  [2179] = {.lex_state = 119, .external_lex_state = 3},
  [2180] = {.lex_state = 71, .external_lex_state = 3},
  [2181] = {.lex_state = 71, .external_lex_state = 3},
  [2182] = {.lex_state = 119, .external_lex_state = 3},
  [2183] = {.lex_state = 119, .external_lex_state = 3},
  [2184] = {.lex_state = 71, .external_lex_state = 3},
  [2185] = {.lex_state = 71, .external_lex_state = 3},
  [2186] = {.lex_state = 71, .external_lex_state = 3},
  [2187] = {.lex_state = 71, .external_lex_state = 3},
  [2188] = {.lex_state = 68, .external_lex_state = 6},
  [2189] = {.lex_state = 71, .external_lex_state = 3},
  [2190] = {.lex_state = 71, .external_lex_state = 3},
  [2191] = {.lex_state = 71, .external_lex_state = 3},
  [2192] = {.lex_state = 71, .external_lex_state = 3},
  [2193] = {.lex_state = 173},
  [2194] = {.lex_state = 71, .external_lex_state = 3},
  [2195] = {.lex_state = 71, .external_lex_state = 3},
  [2196] = {.lex_state = 71, .external_lex_state = 3},
  [2197] = {.lex_state = 71, .external_lex_state = 3},
  [2198] = {.lex_state = 119, .external_lex_state = 3},
  [2199] = {.lex_state = 120, .external_lex_state = 3},
  [2200] = {.lex_state = 119, .external_lex_state = 3},
  [2201] = {.lex_state = 68, .external_lex_state = 6},
  [2202] = {.lex_state = 71, .external_lex_state = 3},
  [2203] = {.lex_state = 71, .external_lex_state = 3},
  [2204] = {.lex_state = 71, .external_lex_state = 3},
  [2205] = {.lex_state = 71, .external_lex_state = 3},
  [2206] = {.lex_state = 71, .external_lex_state = 3},
  [2207] = {.lex_state = 71, .external_lex_state = 3},
  [2208] = {.lex_state = 71, .external_lex_state = 3},
  [2209] = {.lex_state = 108, .external_lex_state = 3},
  [2210] = {.lex_state = 108, .external_lex_state = 3},
  [2211] = {.lex_state = 108, .external_lex_state = 3},
  [2212] = {.lex_state = 108, .external_lex_state = 3},
  [2213] = {.lex_state = 108, .external_lex_state = 3},
  [2214] = {.lex_state = 108, .external_lex_state = 3},
  [2215] = {.lex_state = 120, .external_lex_state = 3},
  [2216] = {.lex_state = 71, .external_lex_state = 3},
  [2217] = {.lex_state = 71, .external_lex_state = 3},
  [2218] = {.lex_state = 71, .external_lex_state = 3},
  [2219] = {.lex_state = 71, .external_lex_state = 3},
  [2220] = {.lex_state = 120, .external_lex_state = 3},
  [2221] = {.lex_state = 108, .external_lex_state = 3},
  [2222] = {.lex_state = 68, .external_lex_state = 6},
  [2223] = {.lex_state = 68, .external_lex_state = 6},
  [2224] = {.lex_state = 68, .external_lex_state = 6},
  [2225] = {.lex_state = 68, .external_lex_state = 6},
  [2226] = {.lex_state = 119, .external_lex_state = 3},
  [2227] = {.lex_state = 119, .external_lex_state = 3},
  [2228] = {.lex_state = 119, .external_lex_state = 3},
  [2229] = {.lex_state = 71, .external_lex_state = 3},
  [2230] = {.lex_state = 71, .external_lex_state = 3},
  [2231] = {.lex_state = 108, .external_lex_state = 3},
  [2232] = {.lex_state = 71, .external_lex_state = 3},
  [2233] = {.lex_state = 108, .external_lex_state = 3},
  [2234] = {.lex_state = 120, .external_lex_state = 3},
  [2235] = {.lex_state = 108, .external_lex_state = 3},
  [2236] = {.lex_state = 108, .external_lex_state = 3},
  [2237] = {.lex_state = 119, .external_lex_state = 3},
  [2238] = {.lex_state = 108, .external_lex_state = 3},
  [2239] = {.lex_state = 108, .external_lex_state = 3},
  [2240] = {.lex_state = 108, .external_lex_state = 3},
  [2241] = {.lex_state = 108, .external_lex_state = 3},
  [2242] = {.lex_state = 71, .external_lex_state = 3},
  [2243] = {.lex_state = 108, .external_lex_state = 3},
  [2244] = {.lex_state = 120, .external_lex_state = 3},
  [2245] = {.lex_state = 119, .external_lex_state = 3},
  [2246] = {.lex_state = 71, .external_lex_state = 3},
  [2247] = {.lex_state = 108, .external_lex_state = 3},
  [2248] = {.lex_state = 108, .external_lex_state = 3},
  [2249] = {.lex_state = 108, .external_lex_state = 3},
  [2250] = {.lex_state = 108, .external_lex_state = 3},
  [2251] = {.lex_state = 71, .external_lex_state = 3},
  [2252] = {.lex_state = 119, .external_lex_state = 3},
  [2253] = {.lex_state = 120, .external_lex_state = 3},
  [2254] = {.lex_state = 108, .external_lex_state = 3},
  [2255] = {.lex_state = 68, .external_lex_state = 6},
  [2256] = {.lex_state = 119, .external_lex_state = 3},
  [2257] = {.lex_state = 119, .external_lex_state = 3},
  [2258] = {.lex_state = 119, .external_lex_state = 3},
  [2259] = {.lex_state = 119, .external_lex_state = 3},
  [2260] = {.lex_state = 120, .external_lex_state = 3},
  [2261] = {.lex_state = 120, .external_lex_state = 3},
  [2262] = {.lex_state = 119, .external_lex_state = 3},
  [2263] = {.lex_state = 119, .external_lex_state = 3},
  [2264] = {.lex_state = 120, .external_lex_state = 3},
  [2265] = {.lex_state = 120, .external_lex_state = 3},
  [2266] = {.lex_state = 120, .external_lex_state = 3},
  [2267] = {.lex_state = 120, .external_lex_state = 3},
  [2268] = {.lex_state = 108, .external_lex_state = 3},
  [2269] = {.lex_state = 68, .external_lex_state = 6},
  [2270] = {.lex_state = 68, .external_lex_state = 6},
  [2271] = {.lex_state = 119, .external_lex_state = 3},
  [2272] = {.lex_state = 119, .external_lex_state = 3},
  [2273] = {.lex_state = 165, .external_lex_state = 16},
  [2274] = {.lex_state = 120, .external_lex_state = 3},
  [2275] = {.lex_state = 120, .external_lex_state = 3},
  [2276] = {.lex_state = 120, .external_lex_state = 3},
  [2277] = {.lex_state = 71, .external_lex_state = 3},
  [2278] = {.lex_state = 108, .external_lex_state = 3},
  [2279] = {.lex_state = 119, .external_lex_state = 3},
  [2280] = {.lex_state = 120, .external_lex_state = 3},
  [2281] = {.lex_state = 119, .external_lex_state = 3},
  [2282] = {.lex_state = 119, .external_lex_state = 3},
  [2283] = {.lex_state = 119, .external_lex_state = 3},
  [2284] = {.lex_state = 68, .external_lex_state = 6},
  [2285] = {.lex_state = 119, .external_lex_state = 3},
  [2286] = {.lex_state = 120, .external_lex_state = 3},
  [2287] = {.lex_state = 120, .external_lex_state = 3},
  [2288] = {.lex_state = 185},
  [2289] = {.lex_state = 119, .external_lex_state = 3},
  [2290] = {.lex_state = 119, .external_lex_state = 3},
  [2291] = {.lex_state = 120, .external_lex_state = 3},
  [2292] = {.lex_state = 119, .external_lex_state = 3},
  [2293] = {.lex_state = 119, .external_lex_state = 3},
  [2294] = {.lex_state = 119, .external_lex_state = 3},
  [2295] = {.lex_state = 185},
  [2296] = {.lex_state = 120, .external_lex_state = 3},
  [2297] = {.lex_state = 185},
  [2298] = {.lex_state = 119, .external_lex_state = 3},
  [2299] = {.lex_state = 120, .external_lex_state = 3},
  [2300] = {.lex_state = 185},
  [2301] = {.lex_state = 119, .external_lex_state = 3},
  [2302] = {.lex_state = 119, .external_lex_state = 3},
  [2303] = {.lex_state = 119, .external_lex_state = 3},
  [2304] = {.lex_state = 120, .external_lex_state = 3},
  [2305] = {.lex_state = 71, .external_lex_state = 3},
  [2306] = {.lex_state = 119, .external_lex_state = 3},
  [2307] = {.lex_state = 120, .external_lex_state = 3},
  [2308] = {.lex_state = 120, .external_lex_state = 3},
  [2309] = {.lex_state = 119, .external_lex_state = 3},
  [2310] = {.lex_state = 120, .external_lex_state = 3},
  [2311] = {.lex_state = 120, .external_lex_state = 3},
  [2312] = {.lex_state = 120, .external_lex_state = 3},
  [2313] = {.lex_state = 120, .external_lex_state = 3},
  [2314] = {.lex_state = 71, .external_lex_state = 3},
  [2315] = {.lex_state = 120, .external_lex_state = 3},
  [2316] = {.lex_state = 119, .external_lex_state = 3},
  [2317] = {.lex_state = 108, .external_lex_state = 3},
  [2318] = {.lex_state = 119, .external_lex_state = 3},
  [2319] = {.lex_state = 119, .external_lex_state = 3},
  [2320] = {.lex_state = 68, .external_lex_state = 6},
  [2321] = {.lex_state = 119, .external_lex_state = 3},
  [2322] = {.lex_state = 119, .external_lex_state = 3},
  [2323] = {.lex_state = 119, .external_lex_state = 3},
  [2324] = {.lex_state = 71, .external_lex_state = 3},
  [2325] = {.lex_state = 119, .external_lex_state = 3},
  [2326] = {.lex_state = 120, .external_lex_state = 3},
  [2327] = {.lex_state = 120, .external_lex_state = 3},
  [2328] = {.lex_state = 120, .external_lex_state = 3},
  [2329] = {.lex_state = 71, .external_lex_state = 3},
  [2330] = {.lex_state = 120, .external_lex_state = 3},
  [2331] = {.lex_state = 71, .external_lex_state = 3},
  [2332] = {.lex_state = 120, .external_lex_state = 3},
  [2333] = {.lex_state = 119, .external_lex_state = 3},
  [2334] = {.lex_state = 120, .external_lex_state = 3},
  [2335] = {.lex_state = 71, .external_lex_state = 3},
  [2336] = {.lex_state = 120, .external_lex_state = 3},
  [2337] = {.lex_state = 119, .external_lex_state = 3},
  [2338] = {.lex_state = 119, .external_lex_state = 3},
  [2339] = {.lex_state = 119, .external_lex_state = 3},
  [2340] = {.lex_state = 120, .external_lex_state = 3},
  [2341] = {.lex_state = 120, .external_lex_state = 3},
  [2342] = {.lex_state = 119, .external_lex_state = 3},
  [2343] = {.lex_state = 119, .external_lex_state = 3},
  [2344] = {.lex_state = 120, .external_lex_state = 3},
  [2345] = {.lex_state = 120, .external_lex_state = 3},
  [2346] = {.lex_state = 120, .external_lex_state = 3},
  [2347] = {.lex_state = 119, .external_lex_state = 3},
  [2348] = {.lex_state = 119, .external_lex_state = 3},
  [2349] = {.lex_state = 119, .external_lex_state = 3},
  [2350] = {.lex_state = 119, .external_lex_state = 3},
  [2351] = {.lex_state = 185},
  [2352] = {.lex_state = 119, .external_lex_state = 3},
  [2353] = {.lex_state = 120, .external_lex_state = 3},
  [2354] = {.lex_state = 120, .external_lex_state = 3},
  [2355] = {.lex_state = 120, .external_lex_state = 3},
  [2356] = {.lex_state = 120, .external_lex_state = 3},
  [2357] = {.lex_state = 120, .external_lex_state = 3},
  [2358] = {.lex_state = 119, .external_lex_state = 3},
  [2359] = {.lex_state = 119, .external_lex_state = 3},
  [2360] = {.lex_state = 120, .external_lex_state = 3},
  [2361] = {.lex_state = 119, .external_lex_state = 3},
  [2362] = {.lex_state = 71, .external_lex_state = 3},
  [2363] = {.lex_state = 68, .external_lex_state = 6},
  [2364] = {.lex_state = 68, .external_lex_state = 6},
  [2365] = {.lex_state = 119, .external_lex_state = 3},
  [2366] = {.lex_state = 120, .external_lex_state = 3},
  [2367] = {.lex_state = 119, .external_lex_state = 3},
  [2368] = {.lex_state = 120, .external_lex_state = 3},
  [2369] = {.lex_state = 119, .external_lex_state = 3},
  [2370] = {.lex_state = 119, .external_lex_state = 3},
  [2371] = {.lex_state = 119, .external_lex_state = 3},
  [2372] = {.lex_state = 68, .external_lex_state = 6},
  [2373] = {.lex_state = 119, .external_lex_state = 3},
  [2374] = {.lex_state = 120, .external_lex_state = 3},
  [2375] = {.lex_state = 119, .external_lex_state = 3},
  [2376] = {.lex_state = 119, .external_lex_state = 3},
  [2377] = {.lex_state = 68, .external_lex_state = 6},
  [2378] = {.lex_state = 68, .external_lex_state = 6},
  [2379] = {.lex_state = 108, .external_lex_state = 3},
  [2380] = {.lex_state = 120, .external_lex_state = 3},
  [2381] = {.lex_state = 120, .external_lex_state = 3},
  [2382] = {.lex_state = 108, .external_lex_state = 3},
  [2383] = {.lex_state = 120, .external_lex_state = 3},
  [2384] = {.lex_state = 108, .external_lex_state = 3},
  [2385] = {.lex_state = 68, .external_lex_state = 6},
  [2386] = {.lex_state = 68, .external_lex_state = 6},
  [2387] = {.lex_state = 120, .external_lex_state = 3},
  [2388] = {.lex_state = 68, .external_lex_state = 6},
  [2389] = {.lex_state = 71, .external_lex_state = 3},
  [2390] = {.lex_state = 120, .external_lex_state = 3},
  [2391] = {.lex_state = 120, .external_lex_state = 3},
  [2392] = {.lex_state = 108, .external_lex_state = 3},
  [2393] = {.lex_state = 165, .external_lex_state = 16},
  [2394] = {.lex_state = 68, .external_lex_state = 6},
  [2395] = {.lex_state = 68, .external_lex_state = 6},
  [2396] = {.lex_state = 68, .external_lex_state = 6},
  [2397] = {.lex_state = 68, .external_lex_state = 6},
  [2398] = {.lex_state = 108, .external_lex_state = 3},
  [2399] = {.lex_state = 68, .external_lex_state = 6},
  [2400] = {.lex_state = 108, .external_lex_state = 3},
  [2401] = {.lex_state = 173},
  [2402] = {.lex_state = 120, .external_lex_state = 3},
  [2403] = {.lex_state = 68, .external_lex_state = 6},
  [2404] = {.lex_state = 68, .external_lex_state = 6},
  [2405] = {.lex_state = 68, .external_lex_state = 6},
  [2406] = {.lex_state = 68, .external_lex_state = 6},
  [2407] = {.lex_state = 68, .external_lex_state = 6},
  [2408] = {.lex_state = 119, .external_lex_state = 3},
  [2409] = {.lex_state = 68, .external_lex_state = 6},
  [2410] = {.lex_state = 68, .external_lex_state = 6},
  [2411] = {.lex_state = 68, .external_lex_state = 6},
  [2412] = {.lex_state = 119, .external_lex_state = 3},
  [2413] = {.lex_state = 120, .external_lex_state = 3},
  [2414] = {.lex_state = 68, .external_lex_state = 6},
  [2415] = {.lex_state = 68, .external_lex_state = 6},
  [2416] = {.lex_state = 68, .external_lex_state = 6},
  [2417] = {.lex_state = 119, .external_lex_state = 3},
  [2418] = {.lex_state = 120, .external_lex_state = 3},
  [2419] = {.lex_state = 68, .external_lex_state = 6},
  [2420] = {.lex_state = 68, .external_lex_state = 6},
  [2421] = {.lex_state = 119, .external_lex_state = 3},
  [2422] = {.lex_state = 68, .external_lex_state = 6},
  [2423] = {.lex_state = 68, .external_lex_state = 6},
  [2424] = {.lex_state = 71, .external_lex_state = 3},
  [2425] = {.lex_state = 68, .external_lex_state = 6},
  [2426] = {.lex_state = 68, .external_lex_state = 6},
  [2427] = {.lex_state = 68, .external_lex_state = 6},
  [2428] = {.lex_state = 68, .external_lex_state = 6},
  [2429] = {.lex_state = 120, .external_lex_state = 3},
  [2430] = {.lex_state = 120, .external_lex_state = 3},
  [2431] = {.lex_state = 68, .external_lex_state = 6},
  [2432] = {.lex_state = 68, .external_lex_state = 6},
  [2433] = {.lex_state = 120, .external_lex_state = 3},
  [2434] = {.lex_state = 120, .external_lex_state = 3},
  [2435] = {.lex_state = 71, .external_lex_state = 3},
  [2436] = {.lex_state = 120, .external_lex_state = 3},
  [2437] = {.lex_state = 120, .external_lex_state = 3},
  [2438] = {.lex_state = 120, .external_lex_state = 3},
  [2439] = {.lex_state = 68, .external_lex_state = 6},
  [2440] = {.lex_state = 68, .external_lex_state = 6},
  [2441] = {.lex_state = 120, .external_lex_state = 3},
  [2442] = {.lex_state = 68, .external_lex_state = 6},
  [2443] = {.lex_state = 68, .external_lex_state = 6},
  [2444] = {.lex_state = 68, .external_lex_state = 6},
  [2445] = {.lex_state = 68, .external_lex_state = 6},
  [2446] = {.lex_state = 68, .external_lex_state = 6},
  [2447] = {.lex_state = 68, .external_lex_state = 6},
  [2448] = {.lex_state = 68, .external_lex_state = 6},
  [2449] = {.lex_state = 68, .external_lex_state = 6},
  [2450] = {.lex_state = 68, .external_lex_state = 6},
  [2451] = {.lex_state = 68, .external_lex_state = 6},
  [2452] = {.lex_state = 68, .external_lex_state = 6},
  [2453] = {.lex_state = 68, .external_lex_state = 6},
  [2454] = {.lex_state = 120, .external_lex_state = 3},
  [2455] = {.lex_state = 68, .external_lex_state = 6},
  [2456] = {.lex_state = 68, .external_lex_state = 6},
  [2457] = {.lex_state = 68, .external_lex_state = 6},
  [2458] = {.lex_state = 68, .external_lex_state = 6},
  [2459] = {.lex_state = 68, .external_lex_state = 6},
  [2460] = {.lex_state = 68, .external_lex_state = 6},
  [2461] = {.lex_state = 120, .external_lex_state = 3},
  [2462] = {.lex_state = 68, .external_lex_state = 6},
  [2463] = {.lex_state = 120, .external_lex_state = 3},
  [2464] = {.lex_state = 120, .external_lex_state = 3},
  [2465] = {.lex_state = 68, .external_lex_state = 6},
  [2466] = {.lex_state = 68, .external_lex_state = 6},
  [2467] = {.lex_state = 71, .external_lex_state = 3},
  [2468] = {.lex_state = 119, .external_lex_state = 3},
  [2469] = {.lex_state = 119, .external_lex_state = 3},
  [2470] = {.lex_state = 120, .external_lex_state = 3},
  [2471] = {.lex_state = 68, .external_lex_state = 6},
  [2472] = {.lex_state = 179},
  [2473] = {.lex_state = 185},
  [2474] = {.lex_state = 185},
  [2475] = {.lex_state = 179},
  [2476] = {.lex_state = 185},
  [2477] = {.lex_state = 185},
  [2478] = {.lex_state = 185},
  [2479] = {.lex_state = 185},
  [2480] = {.lex_state = 185},
  [2481] = {.lex_state = 185},
  [2482] = {.lex_state = 185},
  [2483] = {.lex_state = 185},
  [2484] = {.lex_state = 185},
  [2485] = {.lex_state = 185},
  [2486] = {.lex_state = 185},
  [2487] = {.lex_state = 185},
  [2488] = {.lex_state = 185},
  [2489] = {.lex_state = 185},
  [2490] = {.lex_state = 185},
  [2491] = {.lex_state = 185},
  [2492] = {.lex_state = 185},
  [2493] = {.lex_state = 185},
  [2494] = {.lex_state = 185},
  [2495] = {.lex_state = 185},
  [2496] = {.lex_state = 185},
  [2497] = {.lex_state = 185},
  [2498] = {.lex_state = 185},
  [2499] = {.lex_state = 185},
  [2500] = {.lex_state = 185},
  [2501] = {.lex_state = 185},
  [2502] = {.lex_state = 185},
  [2503] = {.lex_state = 185},
  [2504] = {.lex_state = 185},
  [2505] = {.lex_state = 185},
  [2506] = {.lex_state = 185},
  [2507] = {.lex_state = 185},
  [2508] = {.lex_state = 185},
  [2509] = {.lex_state = 185},
  [2510] = {.lex_state = 185},
  [2511] = {.lex_state = 185},
  [2512] = {.lex_state = 185},
  [2513] = {.lex_state = 185},
  [2514] = {.lex_state = 185},
  [2515] = {.lex_state = 185},
  [2516] = {.lex_state = 185},
  [2517] = {.lex_state = 185},
  [2518] = {.lex_state = 185},
  [2519] = {.lex_state = 185},
  [2520] = {.lex_state = 185},
  [2521] = {.lex_state = 185},
  [2522] = {.lex_state = 185},
  [2523] = {.lex_state = 185},
  [2524] = {.lex_state = 185},
  [2525] = {.lex_state = 185},
  [2526] = {.lex_state = 185},
  [2527] = {.lex_state = 185},
  [2528] = {.lex_state = 185},
  [2529] = {.lex_state = 185},
  [2530] = {.lex_state = 185},
  [2531] = {.lex_state = 185},
  [2532] = {.lex_state = 185},
  [2533] = {.lex_state = 185},
  [2534] = {.lex_state = 185},
  [2535] = {.lex_state = 185},
  [2536] = {.lex_state = 185},
  [2537] = {.lex_state = 185},
  [2538] = {.lex_state = 185},
  [2539] = {.lex_state = 185},
  [2540] = {.lex_state = 185},
  [2541] = {.lex_state = 185},
  [2542] = {.lex_state = 185},
  [2543] = {.lex_state = 185},
  [2544] = {.lex_state = 185},
  [2545] = {.lex_state = 185},
  [2546] = {.lex_state = 185},
  [2547] = {.lex_state = 185},
  [2548] = {.lex_state = 185},
  [2549] = {.lex_state = 185},
  [2550] = {.lex_state = 185},
  [2551] = {.lex_state = 185},
  [2552] = {.lex_state = 185},
  [2553] = {.lex_state = 185},
  [2554] = {.lex_state = 185},
  [2555] = {.lex_state = 185},
  [2556] = {.lex_state = 185},
  [2557] = {.lex_state = 185},
  [2558] = {.lex_state = 185},
  [2559] = {.lex_state = 185},
  [2560] = {.lex_state = 185},
  [2561] = {.lex_state = 185},
  [2562] = {.lex_state = 185},
  [2563] = {.lex_state = 185},
  [2564] = {.lex_state = 185},
  [2565] = {.lex_state = 185},
  [2566] = {.lex_state = 185},
  [2567] = {.lex_state = 185},
  [2568] = {.lex_state = 185},
  [2569] = {.lex_state = 185},
  [2570] = {.lex_state = 185},
  [2571] = {.lex_state = 185},
  [2572] = {.lex_state = 185},
  [2573] = {.lex_state = 185},
  [2574] = {.lex_state = 185},
  [2575] = {.lex_state = 185},
  [2576] = {.lex_state = 185},
  [2577] = {.lex_state = 185},
  [2578] = {.lex_state = 185},
  [2579] = {.lex_state = 185},
  [2580] = {.lex_state = 185},
  [2581] = {.lex_state = 185},
  [2582] = {.lex_state = 185},
  [2583] = {.lex_state = 185},
  [2584] = {.lex_state = 185},
  [2585] = {.lex_state = 185},
  [2586] = {.lex_state = 185},
  [2587] = {.lex_state = 185},
  [2588] = {.lex_state = 185},
  [2589] = {.lex_state = 185},
  [2590] = {.lex_state = 185},
  [2591] = {.lex_state = 185},
  [2592] = {.lex_state = 185},
  [2593] = {.lex_state = 185},
  [2594] = {.lex_state = 185},
  [2595] = {.lex_state = 185},
  [2596] = {.lex_state = 185},
  [2597] = {.lex_state = 185},
  [2598] = {.lex_state = 185},
  [2599] = {.lex_state = 185},
  [2600] = {.lex_state = 185},
  [2601] = {.lex_state = 185},
  [2602] = {.lex_state = 185},
  [2603] = {.lex_state = 185},
  [2604] = {.lex_state = 185, .external_lex_state = 15},
  [2605] = {.lex_state = 185},
  [2606] = {.lex_state = 185},
  [2607] = {.lex_state = 185},
  [2608] = {.lex_state = 185},
  [2609] = {.lex_state = 185},
  [2610] = {.lex_state = 185},
  [2611] = {.lex_state = 185},
  [2612] = {.lex_state = 185},
  [2613] = {.lex_state = 185},
  [2614] = {.lex_state = 185},
  [2615] = {.lex_state = 158, .external_lex_state = 7},
  [2616] = {.lex_state = 185},
  [2617] = {.lex_state = 185},
  [2618] = {.lex_state = 185},
  [2619] = {.lex_state = 185},
  [2620] = {.lex_state = 185},
  [2621] = {.lex_state = 185},
  [2622] = {.lex_state = 185},
  [2623] = {.lex_state = 185},
  [2624] = {.lex_state = 185},
  [2625] = {.lex_state = 185},
  [2626] = {.lex_state = 185},
  [2627] = {.lex_state = 185},
  [2628] = {.lex_state = 185},
  [2629] = {.lex_state = 185},
  [2630] = {.lex_state = 185},
  [2631] = {.lex_state = 185},
  [2632] = {.lex_state = 185},
  [2633] = {.lex_state = 185},
  [2634] = {.lex_state = 185},
  [2635] = {.lex_state = 185},
  [2636] = {.lex_state = 185},
  [2637] = {.lex_state = 185},
  [2638] = {.lex_state = 185},
  [2639] = {.lex_state = 185},
  [2640] = {.lex_state = 185},
  [2641] = {.lex_state = 185},
  [2642] = {.lex_state = 185},
  [2643] = {.lex_state = 185},
  [2644] = {.lex_state = 185},
  [2645] = {.lex_state = 185},
  [2646] = {.lex_state = 185},
  [2647] = {.lex_state = 185},
  [2648] = {.lex_state = 185},
  [2649] = {.lex_state = 185},
  [2650] = {.lex_state = 185},
  [2651] = {.lex_state = 185},
  [2652] = {.lex_state = 185},
  [2653] = {.lex_state = 185},
  [2654] = {.lex_state = 185},
  [2655] = {.lex_state = 185},
  [2656] = {.lex_state = 185},
  [2657] = {.lex_state = 185},
  [2658] = {.lex_state = 185},
  [2659] = {.lex_state = 185},
  [2660] = {.lex_state = 185},
  [2661] = {.lex_state = 185},
  [2662] = {.lex_state = 185},
  [2663] = {.lex_state = 185},
  [2664] = {.lex_state = 185},
  [2665] = {.lex_state = 185},
  [2666] = {.lex_state = 185},
  [2667] = {.lex_state = 185},
  [2668] = {.lex_state = 185},
  [2669] = {.lex_state = 185},
  [2670] = {.lex_state = 185},
  [2671] = {.lex_state = 185},
  [2672] = {.lex_state = 185},
  [2673] = {.lex_state = 185},
  [2674] = {.lex_state = 185},
  [2675] = {.lex_state = 185},
  [2676] = {.lex_state = 185},
  [2677] = {.lex_state = 185},
  [2678] = {.lex_state = 185},
  [2679] = {.lex_state = 185},
  [2680] = {.lex_state = 185},
  [2681] = {.lex_state = 185},
  [2682] = {.lex_state = 185},
  [2683] = {.lex_state = 185},
  [2684] = {.lex_state = 185},
  [2685] = {.lex_state = 185},
  [2686] = {.lex_state = 185},
  [2687] = {.lex_state = 185},
  [2688] = {.lex_state = 185},
  [2689] = {.lex_state = 185},
  [2690] = {.lex_state = 185},
  [2691] = {.lex_state = 185},
  [2692] = {.lex_state = 185},
  [2693] = {.lex_state = 185},
  [2694] = {.lex_state = 185},
  [2695] = {.lex_state = 185},
  [2696] = {.lex_state = 185},
  [2697] = {.lex_state = 185},
  [2698] = {.lex_state = 185},
  [2699] = {.lex_state = 185},
  [2700] = {.lex_state = 185},
  [2701] = {.lex_state = 185},
  [2702] = {.lex_state = 185},
  [2703] = {.lex_state = 185},
  [2704] = {.lex_state = 185},
  [2705] = {.lex_state = 185},
  [2706] = {.lex_state = 185},
  [2707] = {.lex_state = 159, .external_lex_state = 7},
  [2708] = {.lex_state = 157, .external_lex_state = 3},
  [2709] = {.lex_state = 157, .external_lex_state = 3},
  [2710] = {.lex_state = 157, .external_lex_state = 3},
  [2711] = {.lex_state = 157, .external_lex_state = 3},
  [2712] = {.lex_state = 157, .external_lex_state = 3},
  [2713] = {.lex_state = 157, .external_lex_state = 3},
  [2714] = {.lex_state = 157, .external_lex_state = 3},
  [2715] = {.lex_state = 155},
  [2716] = {.lex_state = 155},
  [2717] = {.lex_state = 155},
  [2718] = {.lex_state = 155},
  [2719] = {.lex_state = 155},
  [2720] = {.lex_state = 155},
  [2721] = {.lex_state = 155},
  [2722] = {.lex_state = 157, .external_lex_state = 3},
  [2723] = {.lex_state = 155},
  [2724] = {.lex_state = 155},
  [2725] = {.lex_state = 155},
  [2726] = {.lex_state = 155},
  [2727] = {.lex_state = 155},
  [2728] = {.lex_state = 155},
  [2729] = {.lex_state = 155},
  [2730] = {.lex_state = 155},
  [2731] = {.lex_state = 155},
  [2732] = {.lex_state = 155},
  [2733] = {.lex_state = 155},
  [2734] = {.lex_state = 155},
  [2735] = {.lex_state = 155},
  [2736] = {.lex_state = 155},
  [2737] = {.lex_state = 155},
  [2738] = {.lex_state = 155},
  [2739] = {.lex_state = 155},
  [2740] = {.lex_state = 155},
  [2741] = {.lex_state = 155},
  [2742] = {.lex_state = 155},
  [2743] = {.lex_state = 155},
  [2744] = {.lex_state = 155},
  [2745] = {.lex_state = 157, .external_lex_state = 3},
  [2746] = {.lex_state = 165},
  [2747] = {.lex_state = 155},
  [2748] = {.lex_state = 157, .external_lex_state = 3},
  [2749] = {.lex_state = 155},
  [2750] = {.lex_state = 157, .external_lex_state = 3},
  [2751] = {.lex_state = 155},
  [2752] = {.lex_state = 155},
  [2753] = {.lex_state = 155},
  [2754] = {.lex_state = 155},
  [2755] = {.lex_state = 155},
  [2756] = {.lex_state = 155},
  [2757] = {.lex_state = 155},
  [2758] = {.lex_state = 157, .external_lex_state = 3},
  [2759] = {.lex_state = 155},
  [2760] = {.lex_state = 165},
  [2761] = {.lex_state = 155},
  [2762] = {.lex_state = 155},
  [2763] = {.lex_state = 155},
  [2764] = {.lex_state = 155},
  [2765] = {.lex_state = 155},
  [2766] = {.lex_state = 155},
  [2767] = {.lex_state = 155},
  [2768] = {.lex_state = 157, .external_lex_state = 3},
  [2769] = {.lex_state = 155},
  [2770] = {.lex_state = 157, .external_lex_state = 3},
  [2771] = {.lex_state = 155},
  [2772] = {.lex_state = 157, .external_lex_state = 3},
  [2773] = {.lex_state = 155},
  [2774] = {.lex_state = 157, .external_lex_state = 3},
  [2775] = {.lex_state = 157, .external_lex_state = 3},
  [2776] = {.lex_state = 155},
  [2777] = {.lex_state = 155},
  [2778] = {.lex_state = 157, .external_lex_state = 3},
  [2779] = {.lex_state = 157, .external_lex_state = 3},
  [2780] = {.lex_state = 157, .external_lex_state = 3},
  [2781] = {.lex_state = 157, .external_lex_state = 3},
  [2782] = {.lex_state = 155},
  [2783] = {.lex_state = 157, .external_lex_state = 3},
  [2784] = {.lex_state = 157, .external_lex_state = 3},
  [2785] = {.lex_state = 157, .external_lex_state = 3},
  [2786] = {.lex_state = 157, .external_lex_state = 3},
  [2787] = {.lex_state = 157, .external_lex_state = 3},
  [2788] = {.lex_state = 157, .external_lex_state = 3},
  [2789] = {.lex_state = 157, .external_lex_state = 3},
  [2790] = {.lex_state = 157, .external_lex_state = 3},
  [2791] = {.lex_state = 160, .external_lex_state = 7},
  [2792] = {.lex_state = 161, .external_lex_state = 7},
  [2793] = {.lex_state = 161, .external_lex_state = 7},
  [2794] = {.lex_state = 161, .external_lex_state = 7},
  [2795] = {.lex_state = 161, .external_lex_state = 7},
  [2796] = {.lex_state = 156, .external_lex_state = 17},
  [2797] = {.lex_state = 156, .external_lex_state = 7},
  [2798] = {.lex_state = 156, .external_lex_state = 7},
  [2799] = {.lex_state = 156, .external_lex_state = 7},
  [2800] = {.lex_state = 156, .external_lex_state = 7},
  [2801] = {.lex_state = 156, .external_lex_state = 7},
  [2802] = {.lex_state = 156, .external_lex_state = 7},
  [2803] = {.lex_state = 156, .external_lex_state = 7},
  [2804] = {.lex_state = 156, .external_lex_state = 7},
  [2805] = {.lex_state = 156, .external_lex_state = 7},
  [2806] = {.lex_state = 156, .external_lex_state = 7},
  [2807] = {.lex_state = 156, .external_lex_state = 7},
  [2808] = {.lex_state = 156, .external_lex_state = 7},
  [2809] = {.lex_state = 156, .external_lex_state = 7},
  [2810] = {.lex_state = 156, .external_lex_state = 7},
  [2811] = {.lex_state = 156, .external_lex_state = 7},
  [2812] = {.lex_state = 156, .external_lex_state = 7},
  [2813] = {.lex_state = 156, .external_lex_state = 7},
  [2814] = {.lex_state = 156, .external_lex_state = 7},
  [2815] = {.lex_state = 156, .external_lex_state = 7},
  [2816] = {.lex_state = 156, .external_lex_state = 7},
  [2817] = {.lex_state = 156, .external_lex_state = 7},
  [2818] = {.lex_state = 156, .external_lex_state = 7},
  [2819] = {.lex_state = 156, .external_lex_state = 7},
  [2820] = {.lex_state = 156, .external_lex_state = 7},
  [2821] = {.lex_state = 156, .external_lex_state = 7},
  [2822] = {.lex_state = 156, .external_lex_state = 7},
  [2823] = {.lex_state = 156, .external_lex_state = 7},
  [2824] = {.lex_state = 156, .external_lex_state = 7},
  [2825] = {.lex_state = 156, .external_lex_state = 17},
  [2826] = {.lex_state = 156, .external_lex_state = 7},
  [2827] = {.lex_state = 156, .external_lex_state = 17},
  [2828] = {.lex_state = 156, .external_lex_state = 7},
  [2829] = {.lex_state = 156, .external_lex_state = 17},
  [2830] = {.lex_state = 156, .external_lex_state = 17},
  [2831] = {.lex_state = 156, .external_lex_state = 7},
  [2832] = {.lex_state = 156, .external_lex_state = 17},
  [2833] = {.lex_state = 156, .external_lex_state = 17},
  [2834] = {.lex_state = 156, .external_lex_state = 7},
  [2835] = {.lex_state = 156, .external_lex_state = 7},
  [2836] = {.lex_state = 156, .external_lex_state = 7},
  [2837] = {.lex_state = 156, .external_lex_state = 7},
  [2838] = {.lex_state = 156, .external_lex_state = 7},
  [2839] = {.lex_state = 156, .external_lex_state = 7},
  [2840] = {.lex_state = 156, .external_lex_state = 7},
  [2841] = {.lex_state = 156, .external_lex_state = 7},
  [2842] = {.lex_state = 156, .external_lex_state = 7},
  [2843] = {.lex_state = 156, .external_lex_state = 7},
  [2844] = {.lex_state = 156, .external_lex_state = 7},
  [2845] = {.lex_state = 344},
  [2846] = {.lex_state = 344},
  [2847] = {.lex_state = 344},
  [2848] = {.lex_state = 344},
  [2849] = {.lex_state = 344},
  [2850] = {.lex_state = 344},
  [2851] = {.lex_state = 344},
  [2852] = {.lex_state = 344},
  [2853] = {.lex_state = 344},
  [2854] = {.lex_state = 344},
  [2855] = {.lex_state = 344},
  [2856] = {.lex_state = 344},
  [2857] = {.lex_state = 344},
  [2858] = {.lex_state = 344},
  [2859] = {.lex_state = 344},
  [2860] = {.lex_state = 344},
  [2861] = {.lex_state = 344},
  [2862] = {.lex_state = 344},
  [2863] = {.lex_state = 344},
  [2864] = {.lex_state = 344},
  [2865] = {.lex_state = 166},
  [2866] = {.lex_state = 166, .external_lex_state = 15},
  [2867] = {.lex_state = 166, .external_lex_state = 16},
  [2868] = {.lex_state = 174},
  [2869] = {.lex_state = 167, .external_lex_state = 15},
  [2870] = {.lex_state = 180},
  [2871] = {.lex_state = 167},
  [2872] = {.lex_state = 175},
  [2873] = {.lex_state = 167, .external_lex_state = 16},
  [2874] = {.lex_state = 181},
  [2875] = {.lex_state = 163, .external_lex_state = 15},
  [2876] = {.lex_state = 164, .external_lex_state = 18},
  [2877] = {.lex_state = 164, .external_lex_state = 18},
  [2878] = {.lex_state = 164, .external_lex_state = 18},
  [2879] = {.lex_state = 163},
  [2880] = {.lex_state = 163, .external_lex_state = 15},
  [2881] = {.lex_state = 164, .external_lex_state = 18},
  [2882] = {.lex_state = 163, .external_lex_state = 15},
  [2883] = {.lex_state = 164, .external_lex_state = 18},
  [2884] = {.lex_state = 163, .external_lex_state = 15},
  [2885] = {.lex_state = 163, .external_lex_state = 16},
  [2886] = {.lex_state = 163, .external_lex_state = 15},
  [2887] = {.lex_state = 163, .external_lex_state = 15},
  [2888] = {.lex_state = 163, .external_lex_state = 15},
  [2889] = {.lex_state = 163, .external_lex_state = 15},
  [2890] = {.lex_state = 164, .external_lex_state = 18},
  [2891] = {.lex_state = 164, .external_lex_state = 18},
  [2892] = {.lex_state = 164, .external_lex_state = 18},
  [2893] = {.lex_state = 164, .external_lex_state = 18},
  [2894] = {.lex_state = 164, .external_lex_state = 19},
  [2895] = {.lex_state = 164, .external_lex_state = 15},
  [2896] = {.lex_state = 164, .external_lex_state = 19},
  [2897] = {.lex_state = 163, .external_lex_state = 16},
  [2898] = {.lex_state = 164, .external_lex_state = 15},
  [2899] = {.lex_state = 163, .external_lex_state = 16},
  [2900] = {.lex_state = 164, .external_lex_state = 15},
  [2901] = {.lex_state = 164, .external_lex_state = 19},
  [2902] = {.lex_state = 164, .external_lex_state = 20},
  [2903] = {.lex_state = 164, .external_lex_state = 19},
  [2904] = {.lex_state = 164, .external_lex_state = 18},
  [2905] = {.lex_state = 163},
  [2906] = {.lex_state = 163},
  [2907] = {.lex_state = 164, .external_lex_state = 18},
  [2908] = {.lex_state = 164, .external_lex_state = 19},
  [2909] = {.lex_state = 164, .external_lex_state = 19},
  [2910] = {.lex_state = 163},
  [2911] = {.lex_state = 164, .external_lex_state = 20},
  [2912] = {.lex_state = 163, .external_lex_state = 16},
  [2913] = {.lex_state = 164, .external_lex_state = 15},
  [2914] = {.lex_state = 164, .external_lex_state = 20},
  [2915] = {.lex_state = 164, .external_lex_state = 20},
  [2916] = {.lex_state = 163, .external_lex_state = 15},
  [2917] = {.lex_state = 163, .external_lex_state = 15},
  [2918] = {.lex_state = 163, .external_lex_state = 15},
  [2919] = {.lex_state = 164, .external_lex_state = 20},
  [2920] = {.lex_state = 163, .external_lex_state = 16},
  [2921] = {.lex_state = 164, .external_lex_state = 19},
  [2922] = {.lex_state = 164, .external_lex_state = 20},
  [2923] = {.lex_state = 164, .external_lex_state = 20},
  [2924] = {.lex_state = 164, .external_lex_state = 18},
  [2925] = {.lex_state = 164, .external_lex_state = 18},
  [2926] = {.lex_state = 164, .external_lex_state = 15},
  [2927] = {.lex_state = 164, .external_lex_state = 20},
  [2928] = {.lex_state = 164, .external_lex_state = 15},
  [2929] = {.lex_state = 164, .external_lex_state = 18},
  [2930] = {.lex_state = 163, .external_lex_state = 16},
  [2931] = {.lex_state = 163},
  [2932] = {.lex_state = 164, .external_lex_state = 15},
  [2933] = {.lex_state = 164, .external_lex_state = 15},
  [2934] = {.lex_state = 163, .external_lex_state = 16},
  [2935] = {.lex_state = 163, .external_lex_state = 15},
  [2936] = {.lex_state = 164, .external_lex_state = 20},
  [2937] = {.lex_state = 163, .external_lex_state = 16},
  [2938] = {.lex_state = 163},
  [2939] = {.lex_state = 163},
  [2940] = {.lex_state = 171},
  [2941] = {.lex_state = 163, .external_lex_state = 15},
  [2942] = {.lex_state = 163},
  [2943] = {.lex_state = 163},
  [2944] = {.lex_state = 164, .external_lex_state = 19},
  [2945] = {.lex_state = 164, .external_lex_state = 19},
  [2946] = {.lex_state = 163, .external_lex_state = 15},
  [2947] = {.lex_state = 164, .external_lex_state = 18},
  [2948] = {.lex_state = 163, .external_lex_state = 15},
  [2949] = {.lex_state = 164, .external_lex_state = 16},
  [2950] = {.lex_state = 163, .external_lex_state = 20},
  [2951] = {.lex_state = 164, .external_lex_state = 16},
  [2952] = {.lex_state = 164, .external_lex_state = 15},
  [2953] = {.lex_state = 163, .external_lex_state = 20},
  [2954] = {.lex_state = 163, .external_lex_state = 20},
  [2955] = {.lex_state = 163, .external_lex_state = 20},
  [2956] = {.lex_state = 163, .external_lex_state = 15},
  [2957] = {.lex_state = 163},
  [2958] = {.lex_state = 171},
  [2959] = {.lex_state = 164, .external_lex_state = 16},
  [2960] = {.lex_state = 172, .external_lex_state = 20},
  [2961] = {.lex_state = 163, .external_lex_state = 16},
  [2962] = {.lex_state = 163},
  [2963] = {.lex_state = 171},
  [2964] = {.lex_state = 163},
  [2965] = {.lex_state = 164, .external_lex_state = 20},
  [2966] = {.lex_state = 163, .external_lex_state = 15},
  [2967] = {.lex_state = 172, .external_lex_state = 20},
  [2968] = {.lex_state = 164, .external_lex_state = 20},
  [2969] = {.lex_state = 171},
  [2970] = {.lex_state = 164},
  [2971] = {.lex_state = 171},
  [2972] = {.lex_state = 164},
  [2973] = {.lex_state = 163, .external_lex_state = 15},
  [2974] = {.lex_state = 164},
  [2975] = {.lex_state = 164, .external_lex_state = 15},
  [2976] = {.lex_state = 164, .external_lex_state = 18},
  [2977] = {.lex_state = 164, .external_lex_state = 16},
  [2978] = {.lex_state = 163, .external_lex_state = 20},
  [2979] = {.lex_state = 163, .external_lex_state = 20},
  [2980] = {.lex_state = 164, .external_lex_state = 19},
  [2981] = {.lex_state = 164},
  [2982] = {.lex_state = 171},
  [2983] = {.lex_state = 164, .external_lex_state = 19},
  [2984] = {.lex_state = 163, .external_lex_state = 20},
  [2985] = {.lex_state = 164, .external_lex_state = 20},
  [2986] = {.lex_state = 172, .external_lex_state = 20},
  [2987] = {.lex_state = 164, .external_lex_state = 20},
  [2988] = {.lex_state = 164, .external_lex_state = 15},
  [2989] = {.lex_state = 164},
  [2990] = {.lex_state = 164, .external_lex_state = 19},
  [2991] = {.lex_state = 163},
  [2992] = {.lex_state = 172, .external_lex_state = 20},
  [2993] = {.lex_state = 164, .external_lex_state = 19},
  [2994] = {.lex_state = 163, .external_lex_state = 20},
  [2995] = {.lex_state = 164, .external_lex_state = 20},
  [2996] = {.lex_state = 164, .external_lex_state = 20},
  [2997] = {.lex_state = 172, .external_lex_state = 20},
  [2998] = {.lex_state = 172, .external_lex_state = 20},
  [2999] = {.lex_state = 164, .external_lex_state = 18},
  [3000] = {.lex_state = 164, .external_lex_state = 18},
  [3001] = {.lex_state = 164},
  [3002] = {.lex_state = 164, .external_lex_state = 18},
  [3003] = {.lex_state = 164, .external_lex_state = 19},
  [3004] = {.lex_state = 172, .external_lex_state = 20},
  [3005] = {.lex_state = 164},
  [3006] = {.lex_state = 163},
  [3007] = {.lex_state = 172, .external_lex_state = 20},
  [3008] = {.lex_state = 164, .external_lex_state = 20},
  [3009] = {.lex_state = 163, .external_lex_state = 16},
  [3010] = {.lex_state = 163},
  [3011] = {.lex_state = 172, .external_lex_state = 20},
  [3012] = {.lex_state = 163, .external_lex_state = 20},
  [3013] = {.lex_state = 164, .external_lex_state = 15},
  [3014] = {.lex_state = 164, .external_lex_state = 16},
  [3015] = {.lex_state = 163, .external_lex_state = 16},
  [3016] = {.lex_state = 164, .external_lex_state = 16},
  [3017] = {.lex_state = 164, .external_lex_state = 16},
  [3018] = {.lex_state = 164},
  [3019] = {.lex_state = 164, .external_lex_state = 15},
  [3020] = {.lex_state = 171},
  [3021] = {.lex_state = 164, .external_lex_state = 16},
  [3022] = {.lex_state = 163, .external_lex_state = 16},
  [3023] = {.lex_state = 171},
  [3024] = {.lex_state = 163, .external_lex_state = 16},
  [3025] = {.lex_state = 164, .external_lex_state = 18},
  [3026] = {.lex_state = 163, .external_lex_state = 15},
  [3027] = {.lex_state = 171},
  [3028] = {.lex_state = 163, .external_lex_state = 16},
  [3029] = {.lex_state = 163, .external_lex_state = 16},
  [3030] = {.lex_state = 164, .external_lex_state = 18},
  [3031] = {.lex_state = 164, .external_lex_state = 16},
  [3032] = {.lex_state = 164, .external_lex_state = 20},
  [3033] = {.lex_state = 164, .external_lex_state = 18},
  [3034] = {.lex_state = 164, .external_lex_state = 18},
  [3035] = {.lex_state = 172, .external_lex_state = 20},
  [3036] = {.lex_state = 163},
  [3037] = {.lex_state = 171},
  [3038] = {.lex_state = 164},
  [3039] = {.lex_state = 163, .external_lex_state = 16},
  [3040] = {.lex_state = 163, .external_lex_state = 15},
  [3041] = {.lex_state = 164, .external_lex_state = 15},
  [3042] = {.lex_state = 163, .external_lex_state = 15},
  [3043] = {.lex_state = 164, .external_lex_state = 18},
  [3044] = {.lex_state = 164},
  [3045] = {.lex_state = 164, .external_lex_state = 18},
  [3046] = {.lex_state = 163, .external_lex_state = 20},
  [3047] = {.lex_state = 164, .external_lex_state = 15},
  [3048] = {.lex_state = 164, .external_lex_state = 16},
  [3049] = {.lex_state = 171},
  [3050] = {.lex_state = 164, .external_lex_state = 16},
  [3051] = {.lex_state = 163, .external_lex_state = 16},
  [3052] = {.lex_state = 164, .external_lex_state = 18},
  [3053] = {.lex_state = 344},
  [3054] = {.lex_state = 164, .external_lex_state = 15},
  [3055] = {.lex_state = 172, .external_lex_state = 20},
  [3056] = {.lex_state = 164, .external_lex_state = 20},
  [3057] = {.lex_state = 172, .external_lex_state = 20},
  [3058] = {.lex_state = 163},
  [3059] = {.lex_state = 164, .external_lex_state = 16},
  [3060] = {.lex_state = 164, .external_lex_state = 18},
  [3061] = {.lex_state = 164, .external_lex_state = 18},
  [3062] = {.lex_state = 164, .external_lex_state = 19},
  [3063] = {.lex_state = 163, .external_lex_state = 15},
  [3064] = {.lex_state = 163, .external_lex_state = 15},
  [3065] = {.lex_state = 164, .external_lex_state = 19},
  [3066] = {.lex_state = 164, .external_lex_state = 18},
  [3067] = {.lex_state = 164, .external_lex_state = 18},
  [3068] = {.lex_state = 172},
  [3069] = {.lex_state = 172},
  [3070] = {.lex_state = 163, .external_lex_state = 20},
  [3071] = {.lex_state = 164, .external_lex_state = 20},
  [3072] = {.lex_state = 164, .external_lex_state = 18},
  [3073] = {.lex_state = 163, .external_lex_state = 15},
  [3074] = {.lex_state = 163, .external_lex_state = 15},
  [3075] = {.lex_state = 164},
  [3076] = {.lex_state = 172},
  [3077] = {.lex_state = 172, .external_lex_state = 20},
  [3078] = {.lex_state = 171},
  [3079] = {.lex_state = 163, .external_lex_state = 15},
  [3080] = {.lex_state = 164, .external_lex_state = 15},
  [3081] = {.lex_state = 172, .external_lex_state = 20},
  [3082] = {.lex_state = 164},
  [3083] = {.lex_state = 164, .external_lex_state = 19},
  [3084] = {.lex_state = 164, .external_lex_state = 16},
  [3085] = {.lex_state = 164},
  [3086] = {.lex_state = 163, .external_lex_state = 16},
  [3087] = {.lex_state = 163, .external_lex_state = 15},
  [3088] = {.lex_state = 164, .external_lex_state = 15},
  [3089] = {.lex_state = 164, .external_lex_state = 20},
  [3090] = {.lex_state = 163, .external_lex_state = 15},
  [3091] = {.lex_state = 164, .external_lex_state = 19},
  [3092] = {.lex_state = 172},
  [3093] = {.lex_state = 172},
  [3094] = {.lex_state = 163, .external_lex_state = 20},
  [3095] = {.lex_state = 163, .external_lex_state = 15},
  [3096] = {.lex_state = 163},
  [3097] = {.lex_state = 172},
  [3098] = {.lex_state = 172},
  [3099] = {.lex_state = 172},
  [3100] = {.lex_state = 163},
  [3101] = {.lex_state = 163, .external_lex_state = 15},
  [3102] = {.lex_state = 163, .external_lex_state = 20},
  [3103] = {.lex_state = 163, .external_lex_state = 20},
  [3104] = {.lex_state = 171},
  [3105] = {.lex_state = 164, .external_lex_state = 19},
  [3106] = {.lex_state = 164, .external_lex_state = 20},
  [3107] = {.lex_state = 163},
  [3108] = {.lex_state = 163},
  [3109] = {.lex_state = 164, .external_lex_state = 16},
  [3110] = {.lex_state = 164, .external_lex_state = 15},
  [3111] = {.lex_state = 164},
  [3112] = {.lex_state = 163},
  [3113] = {.lex_state = 163},
  [3114] = {.lex_state = 164},
  [3115] = {.lex_state = 164, .external_lex_state = 16},
  [3116] = {.lex_state = 172, .external_lex_state = 20},
  [3117] = {.lex_state = 163},
  [3118] = {.lex_state = 163},
  [3119] = {.lex_state = 164},
  [3120] = {.lex_state = 163, .external_lex_state = 16},
  [3121] = {.lex_state = 163, .external_lex_state = 16},
  [3122] = {.lex_state = 163, .external_lex_state = 16},
  [3123] = {.lex_state = 163},
  [3124] = {.lex_state = 163},
  [3125] = {.lex_state = 163},
  [3126] = {.lex_state = 163},
  [3127] = {.lex_state = 163},
  [3128] = {.lex_state = 164},
  [3129] = {.lex_state = 163},
  [3130] = {.lex_state = 163},
  [3131] = {.lex_state = 163},
  [3132] = {.lex_state = 171},
  [3133] = {.lex_state = 171},
  [3134] = {.lex_state = 171},
  [3135] = {.lex_state = 164},
  [3136] = {.lex_state = 163, .external_lex_state = 20},
  [3137] = {.lex_state = 164, .external_lex_state = 16},
  [3138] = {.lex_state = 164, .external_lex_state = 16},
  [3139] = {.lex_state = 163, .external_lex_state = 16},
  [3140] = {.lex_state = 163, .external_lex_state = 16},
  [3141] = {.lex_state = 164, .external_lex_state = 15},
  [3142] = {.lex_state = 164, .external_lex_state = 15},
  [3143] = {.lex_state = 164, .external_lex_state = 15},
  [3144] = {.lex_state = 163, .external_lex_state = 20},
  [3145] = {.lex_state = 163, .external_lex_state = 16},
  [3146] = {.lex_state = 163, .external_lex_state = 16},
  [3147] = {.lex_state = 163, .external_lex_state = 16},
  [3148] = {.lex_state = 163, .external_lex_state = 16},
  [3149] = {.lex_state = 163, .external_lex_state = 16},
  [3150] = {.lex_state = 163, .external_lex_state = 16},
  [3151] = {.lex_state = 163, .external_lex_state = 20},
  [3152] = {.lex_state = 164, .external_lex_state = 15},
  [3153] = {.lex_state = 164, .external_lex_state = 15},
  [3154] = {.lex_state = 164, .external_lex_state = 19},
  [3155] = {.lex_state = 164, .external_lex_state = 19},
  [3156] = {.lex_state = 164, .external_lex_state = 19},
  [3157] = {.lex_state = 163, .external_lex_state = 16},
  [3158] = {.lex_state = 164, .external_lex_state = 15},
  [3159] = {.lex_state = 164, .external_lex_state = 15},
  [3160] = {.lex_state = 172},
  [3161] = {.lex_state = 164, .external_lex_state = 19},
  [3162] = {.lex_state = 164, .external_lex_state = 19},
  [3163] = {.lex_state = 172},
  [3164] = {.lex_state = 172},
  [3165] = {.lex_state = 164, .external_lex_state = 19},
  [3166] = {.lex_state = 164, .external_lex_state = 19},
  [3167] = {.lex_state = 171},
  [3168] = {.lex_state = 164, .external_lex_state = 20},
  [3169] = {.lex_state = 164, .external_lex_state = 20},
  [3170] = {.lex_state = 164, .external_lex_state = 19},
  [3171] = {.lex_state = 164, .external_lex_state = 19},
  [3172] = {.lex_state = 163, .external_lex_state = 20},
  [3173] = {.lex_state = 164, .external_lex_state = 20},
  [3174] = {.lex_state = 171},
  [3175] = {.lex_state = 164, .external_lex_state = 15},
  [3176] = {.lex_state = 164, .external_lex_state = 15},
  [3177] = {.lex_state = 164, .external_lex_state = 16},
  [3178] = {.lex_state = 172, .external_lex_state = 20},
  [3179] = {.lex_state = 172, .external_lex_state = 20},
  [3180] = {.lex_state = 164, .external_lex_state = 19},
  [3181] = {.lex_state = 164, .external_lex_state = 19},
  [3182] = {.lex_state = 172},
  [3183] = {.lex_state = 164, .external_lex_state = 19},
  [3184] = {.lex_state = 172, .external_lex_state = 20},
  [3185] = {.lex_state = 164, .external_lex_state = 20},
  [3186] = {.lex_state = 164, .external_lex_state = 20},
  [3187] = {.lex_state = 172},
  [3188] = {.lex_state = 163, .external_lex_state = 20},
  [3189] = {.lex_state = 172, .external_lex_state = 20},
  [3190] = {.lex_state = 164, .external_lex_state = 20},
  [3191] = {.lex_state = 164, .external_lex_state = 20},
  [3192] = {.lex_state = 164, .external_lex_state = 20},
  [3193] = {.lex_state = 164, .external_lex_state = 20},
  [3194] = {.lex_state = 164, .external_lex_state = 15},
  [3195] = {.lex_state = 164, .external_lex_state = 20},
  [3196] = {.lex_state = 164, .external_lex_state = 15},
  [3197] = {.lex_state = 164, .external_lex_state = 20},
  [3198] = {.lex_state = 164, .external_lex_state = 20},
  [3199] = {.lex_state = 172},
  [3200] = {.lex_state = 186},
  [3201] = {.lex_state = 172, .external_lex_state = 20},
  [3202] = {.lex_state = 172, .external_lex_state = 20},
  [3203] = {.lex_state = 164},
  [3204] = {.lex_state = 172, .external_lex_state = 20},
  [3205] = {.lex_state = 172, .external_lex_state = 20},
  [3206] = {.lex_state = 172, .external_lex_state = 20},
  [3207] = {.lex_state = 172, .external_lex_state = 20},
  [3208] = {.lex_state = 163, .external_lex_state = 20},
  [3209] = {.lex_state = 168, .external_lex_state = 15},
  [3210] = {.lex_state = 163, .external_lex_state = 20},
  [3211] = {.lex_state = 163, .external_lex_state = 20},
  [3212] = {.lex_state = 164},
  [3213] = {.lex_state = 164},
  [3214] = {.lex_state = 164},
  [3215] = {.lex_state = 164, .external_lex_state = 16},
  [3216] = {.lex_state = 164, .external_lex_state = 16},
  [3217] = {.lex_state = 198},
  [3218] = {.lex_state = 164},
  [3219] = {.lex_state = 164, .external_lex_state = 16},
  [3220] = {.lex_state = 164, .external_lex_state = 16},
  [3221] = {.lex_state = 163, .external_lex_state = 20},
  [3222] = {.lex_state = 172, .external_lex_state = 20},
  [3223] = {.lex_state = 172, .external_lex_state = 20},
  [3224] = {.lex_state = 172, .external_lex_state = 20},
  [3225] = {.lex_state = 168},
  [3226] = {.lex_state = 164, .external_lex_state = 16},
  [3227] = {.lex_state = 164},
  [3228] = {.lex_state = 164},
  [3229] = {.lex_state = 164, .external_lex_state = 16},
  [3230] = {.lex_state = 164},
  [3231] = {.lex_state = 164},
  [3232] = {.lex_state = 164, .external_lex_state = 16},
  [3233] = {.lex_state = 164, .external_lex_state = 16},
  [3234] = {.lex_state = 164, .external_lex_state = 16},
  [3235] = {.lex_state = 164},
  [3236] = {.lex_state = 171},
  [3237] = {.lex_state = 172, .external_lex_state = 20},
  [3238] = {.lex_state = 164},
  [3239] = {.lex_state = 164},
  [3240] = {.lex_state = 164, .external_lex_state = 16},
  [3241] = {.lex_state = 163, .external_lex_state = 20},
  [3242] = {.lex_state = 171},
  [3243] = {.lex_state = 164, .external_lex_state = 16},
  [3244] = {.lex_state = 171},
  [3245] = {.lex_state = 164, .external_lex_state = 16},
  [3246] = {.lex_state = 165, .external_lex_state = 15},
  [3247] = {.lex_state = 171},
  [3248] = {.lex_state = 171},
  [3249] = {.lex_state = 171},
  [3250] = {.lex_state = 163, .external_lex_state = 20},
  [3251] = {.lex_state = 172, .external_lex_state = 20},
  [3252] = {.lex_state = 172, .external_lex_state = 20},
  [3253] = {.lex_state = 171},
  [3254] = {.lex_state = 163, .external_lex_state = 20},
  [3255] = {.lex_state = 172},
  [3256] = {.lex_state = 163, .external_lex_state = 20},
  [3257] = {.lex_state = 171},
  [3258] = {.lex_state = 171},
  [3259] = {.lex_state = 163, .external_lex_state = 20},
  [3260] = {.lex_state = 163, .external_lex_state = 20},
  [3261] = {.lex_state = 198},
  [3262] = {.lex_state = 163, .external_lex_state = 20},
  [3263] = {.lex_state = 172},
  [3264] = {.lex_state = 171},
  [3265] = {.lex_state = 198},
  [3266] = {.lex_state = 172},
  [3267] = {.lex_state = 172},
  [3268] = {.lex_state = 198},
  [3269] = {.lex_state = 198},
  [3270] = {.lex_state = 171},
  [3271] = {.lex_state = 163, .external_lex_state = 20},
  [3272] = {.lex_state = 171},
  [3273] = {.lex_state = 165, .external_lex_state = 15},
  [3274] = {.lex_state = 165, .external_lex_state = 15},
  [3275] = {.lex_state = 169, .external_lex_state = 15},
  [3276] = {.lex_state = 172},
  [3277] = {.lex_state = 172},
  [3278] = {.lex_state = 172},
  [3279] = {.lex_state = 165},
  [3280] = {.lex_state = 165, .external_lex_state = 15},
  [3281] = {.lex_state = 165, .external_lex_state = 16},
  [3282] = {.lex_state = 172},
  [3283] = {.lex_state = 165},
  [3284] = {.lex_state = 173},
  [3285] = {.lex_state = 172},
  [3286] = {.lex_state = 165, .external_lex_state = 16},
  [3287] = {.lex_state = 172},
  [3288] = {.lex_state = 172},
  [3289] = {.lex_state = 172},
  [3290] = {.lex_state = 165},
  [3291] = {.lex_state = 169},
  [3292] = {.lex_state = 173},
  [3293] = {.lex_state = 176},
  [3294] = {.lex_state = 172},
  [3295] = {.lex_state = 165},
  [3296] = {.lex_state = 172},
  [3297] = {.lex_state = 165, .external_lex_state = 16},
  [3298] = {.lex_state = 165, .external_lex_state = 15},
  [3299] = {.lex_state = 165},
  [3300] = {.lex_state = 165},
  [3301] = {.lex_state = 172},
  [3302] = {.lex_state = 165, .external_lex_state = 15},
  [3303] = {.lex_state = 165, .external_lex_state = 15},
  [3304] = {.lex_state = 172},
  [3305] = {.lex_state = 169, .external_lex_state = 15},
  [3306] = {.lex_state = 165, .external_lex_state = 18},
  [3307] = {.lex_state = 165, .external_lex_state = 18},
  [3308] = {.lex_state = 169},
  [3309] = {.lex_state = 168, .external_lex_state = 16},
  [3310] = {.lex_state = 165, .external_lex_state = 18},
  [3311] = {.lex_state = 165},
  [3312] = {.lex_state = 169},
  [3313] = {.lex_state = 173},
  [3314] = {.lex_state = 165, .external_lex_state = 15},
  [3315] = {.lex_state = 169, .external_lex_state = 15},
  [3316] = {.lex_state = 169},
  [3317] = {.lex_state = 169, .external_lex_state = 15},
  [3318] = {.lex_state = 165, .external_lex_state = 15},
  [3319] = {.lex_state = 177},
  [3320] = {.lex_state = 165},
  [3321] = {.lex_state = 165},
  [3322] = {.lex_state = 182},
  [3323] = {.lex_state = 188},
  [3324] = {.lex_state = 165, .external_lex_state = 16},
  [3325] = {.lex_state = 169, .external_lex_state = 16},
  [3326] = {.lex_state = 173},
  [3327] = {.lex_state = 179},
  [3328] = {.lex_state = 165, .external_lex_state = 16},
  [3329] = {.lex_state = 179},
  [3330] = {.lex_state = 177},
  [3331] = {.lex_state = 165, .external_lex_state = 20},
  [3332] = {.lex_state = 169, .external_lex_state = 16},
  [3333] = {.lex_state = 169, .external_lex_state = 16},
  [3334] = {.lex_state = 198},
  [3335] = {.lex_state = 179},
  [3336] = {.lex_state = 165, .external_lex_state = 20},
  [3337] = {.lex_state = 165, .external_lex_state = 16},
  [3338] = {.lex_state = 165, .external_lex_state = 20},
  [3339] = {.lex_state = 179},
  [3340] = {.lex_state = 165},
  [3341] = {.lex_state = 165, .external_lex_state = 16},
  [3342] = {.lex_state = 179},
  [3343] = {.lex_state = 177},
  [3344] = {.lex_state = 179},
  [3345] = {.lex_state = 165, .external_lex_state = 20},
  [3346] = {.lex_state = 165, .external_lex_state = 20},
  [3347] = {.lex_state = 165, .external_lex_state = 15},
  [3348] = {.lex_state = 165, .external_lex_state = 20},
  [3349] = {.lex_state = 165, .external_lex_state = 19},
  [3350] = {.lex_state = 179},
  [3351] = {.lex_state = 179},
  [3352] = {.lex_state = 165, .external_lex_state = 19},
  [3353] = {.lex_state = 179},
  [3354] = {.lex_state = 165},
  [3355] = {.lex_state = 165},
  [3356] = {.lex_state = 179},
  [3357] = {.lex_state = 165, .external_lex_state = 15},
  [3358] = {.lex_state = 165, .external_lex_state = 20},
  [3359] = {.lex_state = 165, .external_lex_state = 20},
  [3360] = {.lex_state = 165, .external_lex_state = 19},
  [3361] = {.lex_state = 165, .external_lex_state = 20},
  [3362] = {.lex_state = 165, .external_lex_state = 15},
  [3363] = {.lex_state = 165, .external_lex_state = 15},
  [3364] = {.lex_state = 179},
  [3365] = {.lex_state = 165},
  [3366] = {.lex_state = 173},
  [3367] = {.lex_state = 173},
  [3368] = {.lex_state = 165, .external_lex_state = 16},
  [3369] = {.lex_state = 165},
  [3370] = {.lex_state = 179},
  [3371] = {.lex_state = 173},
  [3372] = {.lex_state = 165},
  [3373] = {.lex_state = 165, .external_lex_state = 20},
  [3374] = {.lex_state = 165, .external_lex_state = 20},
  [3375] = {.lex_state = 165, .external_lex_state = 20},
  [3376] = {.lex_state = 177},
  [3377] = {.lex_state = 173, .external_lex_state = 20},
  [3378] = {.lex_state = 165, .external_lex_state = 18},
  [3379] = {.lex_state = 165, .external_lex_state = 15},
  [3380] = {.lex_state = 173, .external_lex_state = 20},
  [3381] = {.lex_state = 165, .external_lex_state = 18},
  [3382] = {.lex_state = 165, .external_lex_state = 18},
  [3383] = {.lex_state = 173, .external_lex_state = 20},
  [3384] = {.lex_state = 165, .external_lex_state = 20},
  [3385] = {.lex_state = 165},
  [3386] = {.lex_state = 165, .external_lex_state = 18},
  [3387] = {.lex_state = 165, .external_lex_state = 18},
  [3388] = {.lex_state = 165, .external_lex_state = 18},
  [3389] = {.lex_state = 165, .external_lex_state = 18},
  [3390] = {.lex_state = 165},
  [3391] = {.lex_state = 165},
  [3392] = {.lex_state = 169, .external_lex_state = 16},
  [3393] = {.lex_state = 179},
  [3394] = {.lex_state = 179},
  [3395] = {.lex_state = 165, .external_lex_state = 15},
  [3396] = {.lex_state = 165},
  [3397] = {.lex_state = 165},
  [3398] = {.lex_state = 165, .external_lex_state = 15},
  [3399] = {.lex_state = 165, .external_lex_state = 15},
  [3400] = {.lex_state = 165, .external_lex_state = 15},
  [3401] = {.lex_state = 165, .external_lex_state = 15},
  [3402] = {.lex_state = 198},
  [3403] = {.lex_state = 165, .external_lex_state = 15},
  [3404] = {.lex_state = 173},
  [3405] = {.lex_state = 179},
  [3406] = {.lex_state = 165, .external_lex_state = 15},
  [3407] = {.lex_state = 165, .external_lex_state = 15},
  [3408] = {.lex_state = 165},
  [3409] = {.lex_state = 165, .external_lex_state = 19},
  [3410] = {.lex_state = 165},
  [3411] = {.lex_state = 179},
  [3412] = {.lex_state = 165},
  [3413] = {.lex_state = 165, .external_lex_state = 15},
  [3414] = {.lex_state = 165, .external_lex_state = 16},
  [3415] = {.lex_state = 165},
  [3416] = {.lex_state = 179, .external_lex_state = 20},
  [3417] = {.lex_state = 165},
  [3418] = {.lex_state = 165},
  [3419] = {.lex_state = 198},
  [3420] = {.lex_state = 179, .external_lex_state = 20},
  [3421] = {.lex_state = 179},
  [3422] = {.lex_state = 165},
  [3423] = {.lex_state = 165},
  [3424] = {.lex_state = 165},
  [3425] = {.lex_state = 179, .external_lex_state = 20},
  [3426] = {.lex_state = 165},
  [3427] = {.lex_state = 165, .external_lex_state = 16},
  [3428] = {.lex_state = 165},
  [3429] = {.lex_state = 165, .external_lex_state = 15},
  [3430] = {.lex_state = 165},
  [3431] = {.lex_state = 173},
  [3432] = {.lex_state = 173},
  [3433] = {.lex_state = 165, .external_lex_state = 15},
  [3434] = {.lex_state = 165, .external_lex_state = 15},
  [3435] = {.lex_state = 165},
  [3436] = {.lex_state = 165},
  [3437] = {.lex_state = 165, .external_lex_state = 16},
  [3438] = {.lex_state = 165, .external_lex_state = 15},
  [3439] = {.lex_state = 165, .external_lex_state = 15},
  [3440] = {.lex_state = 165},
  [3441] = {.lex_state = 165},
  [3442] = {.lex_state = 165, .external_lex_state = 15},
  [3443] = {.lex_state = 165, .external_lex_state = 15},
  [3444] = {.lex_state = 165, .external_lex_state = 15},
  [3445] = {.lex_state = 165, .external_lex_state = 15},
  [3446] = {.lex_state = 165, .external_lex_state = 15},
  [3447] = {.lex_state = 165, .external_lex_state = 16},
  [3448] = {.lex_state = 165, .external_lex_state = 16},
  [3449] = {.lex_state = 165},
  [3450] = {.lex_state = 165},
  [3451] = {.lex_state = 165},
  [3452] = {.lex_state = 173},
  [3453] = {.lex_state = 165},
  [3454] = {.lex_state = 165},
  [3455] = {.lex_state = 165},
  [3456] = {.lex_state = 165, .external_lex_state = 15},
  [3457] = {.lex_state = 165, .external_lex_state = 15},
  [3458] = {.lex_state = 165},
  [3459] = {.lex_state = 165},
  [3460] = {.lex_state = 165, .external_lex_state = 15},
  [3461] = {.lex_state = 165, .external_lex_state = 15},
  [3462] = {.lex_state = 165, .external_lex_state = 15},
  [3463] = {.lex_state = 173},
  [3464] = {.lex_state = 165, .external_lex_state = 15},
  [3465] = {.lex_state = 165, .external_lex_state = 15},
  [3466] = {.lex_state = 165, .external_lex_state = 15},
  [3467] = {.lex_state = 165, .external_lex_state = 15},
  [3468] = {.lex_state = 165, .external_lex_state = 15},
  [3469] = {.lex_state = 165, .external_lex_state = 15},
  [3470] = {.lex_state = 165, .external_lex_state = 15},
  [3471] = {.lex_state = 165, .external_lex_state = 15},
  [3472] = {.lex_state = 165, .external_lex_state = 15},
  [3473] = {.lex_state = 165, .external_lex_state = 15},
  [3474] = {.lex_state = 165},
  [3475] = {.lex_state = 165, .external_lex_state = 16},
  [3476] = {.lex_state = 165, .external_lex_state = 15},
  [3477] = {.lex_state = 165},
  [3478] = {.lex_state = 173},
  [3479] = {.lex_state = 165},
  [3480] = {.lex_state = 165, .external_lex_state = 15},
  [3481] = {.lex_state = 165, .external_lex_state = 15},
  [3482] = {.lex_state = 165, .external_lex_state = 15},
  [3483] = {.lex_state = 165, .external_lex_state = 15},
  [3484] = {.lex_state = 165, .external_lex_state = 15},
  [3485] = {.lex_state = 165, .external_lex_state = 15},
  [3486] = {.lex_state = 165, .external_lex_state = 15},
  [3487] = {.lex_state = 165, .external_lex_state = 15},
  [3488] = {.lex_state = 165},
  [3489] = {.lex_state = 183},
  [3490] = {.lex_state = 165, .external_lex_state = 15},
  [3491] = {.lex_state = 165, .external_lex_state = 16},
  [3492] = {.lex_state = 165, .external_lex_state = 15},
  [3493] = {.lex_state = 173},
  [3494] = {.lex_state = 165, .external_lex_state = 15},
  [3495] = {.lex_state = 165, .external_lex_state = 15},
  [3496] = {.lex_state = 165, .external_lex_state = 16},
  [3497] = {.lex_state = 165, .external_lex_state = 15},
  [3498] = {.lex_state = 165, .external_lex_state = 15},
  [3499] = {.lex_state = 179},
  [3500] = {.lex_state = 165, .external_lex_state = 15},
  [3501] = {.lex_state = 165, .external_lex_state = 16},
  [3502] = {.lex_state = 165, .external_lex_state = 16},
  [3503] = {.lex_state = 165, .external_lex_state = 15},
  [3504] = {.lex_state = 165, .external_lex_state = 15},
  [3505] = {.lex_state = 165, .external_lex_state = 15},
  [3506] = {.lex_state = 165, .external_lex_state = 15},
  [3507] = {.lex_state = 165, .external_lex_state = 15},
  [3508] = {.lex_state = 165},
  [3509] = {.lex_state = 165},
  [3510] = {.lex_state = 165, .external_lex_state = 15},
  [3511] = {.lex_state = 173, .external_lex_state = 20},
  [3512] = {.lex_state = 173, .external_lex_state = 20},
  [3513] = {.lex_state = 173, .external_lex_state = 20},
  [3514] = {.lex_state = 173, .external_lex_state = 20},
  [3515] = {.lex_state = 173, .external_lex_state = 20},
  [3516] = {.lex_state = 173, .external_lex_state = 20},
  [3517] = {.lex_state = 165},
  [3518] = {.lex_state = 173, .external_lex_state = 20},
  [3519] = {.lex_state = 165},
  [3520] = {.lex_state = 165, .external_lex_state = 15},
  [3521] = {.lex_state = 165, .external_lex_state = 15},
  [3522] = {.lex_state = 179},
  [3523] = {.lex_state = 179},
  [3524] = {.lex_state = 165},
  [3525] = {.lex_state = 165, .external_lex_state = 15},
  [3526] = {.lex_state = 183},
  [3527] = {.lex_state = 165},
  [3528] = {.lex_state = 165, .external_lex_state = 15},
  [3529] = {.lex_state = 165},
  [3530] = {.lex_state = 165, .external_lex_state = 19},
  [3531] = {.lex_state = 165},
  [3532] = {.lex_state = 198},
  [3533] = {.lex_state = 165, .external_lex_state = 19},
  [3534] = {.lex_state = 165, .external_lex_state = 15},
  [3535] = {.lex_state = 165, .external_lex_state = 19},
  [3536] = {.lex_state = 165, .external_lex_state = 19},
  [3537] = {.lex_state = 173},
  [3538] = {.lex_state = 165, .external_lex_state = 16},
  [3539] = {.lex_state = 165, .external_lex_state = 16},
  [3540] = {.lex_state = 173},
  [3541] = {.lex_state = 173},
  [3542] = {.lex_state = 173},
  [3543] = {.lex_state = 173},
  [3544] = {.lex_state = 165},
  [3545] = {.lex_state = 183},
  [3546] = {.lex_state = 165},
  [3547] = {.lex_state = 165, .external_lex_state = 15},
  [3548] = {.lex_state = 165, .external_lex_state = 15},
  [3549] = {.lex_state = 165},
  [3550] = {.lex_state = 165},
  [3551] = {.lex_state = 165},
  [3552] = {.lex_state = 165},
  [3553] = {.lex_state = 165},
  [3554] = {.lex_state = 165},
  [3555] = {.lex_state = 165, .external_lex_state = 16},
  [3556] = {.lex_state = 173},
  [3557] = {.lex_state = 165},
  [3558] = {.lex_state = 165},
  [3559] = {.lex_state = 165},
  [3560] = {.lex_state = 173},
  [3561] = {.lex_state = 165},
  [3562] = {.lex_state = 165},
  [3563] = {.lex_state = 165},
  [3564] = {.lex_state = 165},
  [3565] = {.lex_state = 165},
  [3566] = {.lex_state = 165},
  [3567] = {.lex_state = 165},
  [3568] = {.lex_state = 165},
  [3569] = {.lex_state = 165},
  [3570] = {.lex_state = 183},
  [3571] = {.lex_state = 165},
  [3572] = {.lex_state = 165, .external_lex_state = 19},
  [3573] = {.lex_state = 165, .external_lex_state = 15},
  [3574] = {.lex_state = 165, .external_lex_state = 19},
  [3575] = {.lex_state = 165, .external_lex_state = 16},
  [3576] = {.lex_state = 173},
  [3577] = {.lex_state = 165, .external_lex_state = 16},
  [3578] = {.lex_state = 165, .external_lex_state = 16},
  [3579] = {.lex_state = 173},
  [3580] = {.lex_state = 165, .external_lex_state = 16},
  [3581] = {.lex_state = 165, .external_lex_state = 16},
  [3582] = {.lex_state = 179},
  [3583] = {.lex_state = 173},
  [3584] = {.lex_state = 173},
  [3585] = {.lex_state = 173},
  [3586] = {.lex_state = 173},
  [3587] = {.lex_state = 173},
  [3588] = {.lex_state = 173},
  [3589] = {.lex_state = 165, .external_lex_state = 16},
  [3590] = {.lex_state = 165, .external_lex_state = 16},
  [3591] = {.lex_state = 173},
  [3592] = {.lex_state = 179},
  [3593] = {.lex_state = 179},
  [3594] = {.lex_state = 179},
  [3595] = {.lex_state = 165, .external_lex_state = 16},
  [3596] = {.lex_state = 173},
  [3597] = {.lex_state = 179},
  [3598] = {.lex_state = 173},
  [3599] = {.lex_state = 173},
  [3600] = {.lex_state = 165, .external_lex_state = 16},
  [3601] = {.lex_state = 173},
  [3602] = {.lex_state = 165, .external_lex_state = 16},
  [3603] = {.lex_state = 179},
  [3604] = {.lex_state = 165, .external_lex_state = 16},
  [3605] = {.lex_state = 173},
  [3606] = {.lex_state = 165, .external_lex_state = 16},
  [3607] = {.lex_state = 173},
  [3608] = {.lex_state = 173},
  [3609] = {.lex_state = 165, .external_lex_state = 16},
  [3610] = {.lex_state = 173},
  [3611] = {.lex_state = 165, .external_lex_state = 16},
  [3612] = {.lex_state = 173},
  [3613] = {.lex_state = 173},
  [3614] = {.lex_state = 179},
  [3615] = {.lex_state = 165, .external_lex_state = 16},
  [3616] = {.lex_state = 165, .external_lex_state = 16},
  [3617] = {.lex_state = 179, .external_lex_state = 20},
  [3618] = {.lex_state = 173},
  [3619] = {.lex_state = 165, .external_lex_state = 16},
  [3620] = {.lex_state = 179, .external_lex_state = 20},
  [3621] = {.lex_state = 165, .external_lex_state = 16},
  [3622] = {.lex_state = 179, .external_lex_state = 20},
  [3623] = {.lex_state = 165, .external_lex_state = 16},
  [3624] = {.lex_state = 165, .external_lex_state = 16},
  [3625] = {.lex_state = 179, .external_lex_state = 20},
  [3626] = {.lex_state = 179, .external_lex_state = 20},
  [3627] = {.lex_state = 179, .external_lex_state = 20},
  [3628] = {.lex_state = 165, .external_lex_state = 16},
  [3629] = {.lex_state = 165, .external_lex_state = 16},
  [3630] = {.lex_state = 179, .external_lex_state = 20},
  [3631] = {.lex_state = 165, .external_lex_state = 16},
  [3632] = {.lex_state = 165, .external_lex_state = 16},
  [3633] = {.lex_state = 165, .external_lex_state = 16},
  [3634] = {.lex_state = 173},
  [3635] = {.lex_state = 173},
  [3636] = {.lex_state = 165, .external_lex_state = 16},
  [3637] = {.lex_state = 179},
  [3638] = {.lex_state = 179},
  [3639] = {.lex_state = 179},
  [3640] = {.lex_state = 165, .external_lex_state = 16},
  [3641] = {.lex_state = 165, .external_lex_state = 16},
  [3642] = {.lex_state = 165, .external_lex_state = 16},
  [3643] = {.lex_state = 173},
  [3644] = {.lex_state = 165, .external_lex_state = 16},
  [3645] = {.lex_state = 165, .external_lex_state = 16},
  [3646] = {.lex_state = 179},
  [3647] = {.lex_state = 165, .external_lex_state = 16},
  [3648] = {.lex_state = 165, .external_lex_state = 16},
  [3649] = {.lex_state = 165, .external_lex_state = 16},
  [3650] = {.lex_state = 173},
  [3651] = {.lex_state = 165, .external_lex_state = 16},
  [3652] = {.lex_state = 165, .external_lex_state = 16},
  [3653] = {.lex_state = 165, .external_lex_state = 16},
  [3654] = {.lex_state = 165, .external_lex_state = 16},
  [3655] = {.lex_state = 179},
  [3656] = {.lex_state = 165, .external_lex_state = 16},
  [3657] = {.lex_state = 173},
  [3658] = {.lex_state = 173},
  [3659] = {.lex_state = 173},
  [3660] = {.lex_state = 165, .external_lex_state = 16},
  [3661] = {.lex_state = 173},
  [3662] = {.lex_state = 173},
  [3663] = {.lex_state = 165, .external_lex_state = 16},
  [3664] = {.lex_state = 173},
  [3665] = {.lex_state = 173},
  [3666] = {.lex_state = 173},
  [3667] = {.lex_state = 173},
  [3668] = {.lex_state = 173},
  [3669] = {.lex_state = 173},
  [3670] = {.lex_state = 173},
  [3671] = {.lex_state = 165, .external_lex_state = 16},
  [3672] = {.lex_state = 165, .external_lex_state = 16},
  [3673] = {.lex_state = 173},
  [3674] = {.lex_state = 165, .external_lex_state = 16},
  [3675] = {.lex_state = 165, .external_lex_state = 16},
  [3676] = {.lex_state = 173},
  [3677] = {.lex_state = 173},
  [3678] = {.lex_state = 165, .external_lex_state = 16},
  [3679] = {.lex_state = 165, .external_lex_state = 16},
  [3680] = {.lex_state = 165, .external_lex_state = 16},
  [3681] = {.lex_state = 173},
  [3682] = {.lex_state = 173},
  [3683] = {.lex_state = 173},
  [3684] = {.lex_state = 173},
  [3685] = {.lex_state = 173},
  [3686] = {.lex_state = 165, .external_lex_state = 16},
  [3687] = {.lex_state = 179},
  [3688] = {.lex_state = 165, .external_lex_state = 16},
  [3689] = {.lex_state = 165, .external_lex_state = 16},
  [3690] = {.lex_state = 173},
  [3691] = {.lex_state = 173},
  [3692] = {.lex_state = 165, .external_lex_state = 16},
  [3693] = {.lex_state = 173},
  [3694] = {.lex_state = 173},
  [3695] = {.lex_state = 173},
  [3696] = {.lex_state = 173},
  [3697] = {.lex_state = 173},
  [3698] = {.lex_state = 173},
  [3699] = {.lex_state = 173},
  [3700] = {.lex_state = 173},
  [3701] = {.lex_state = 173},
  [3702] = {.lex_state = 165, .external_lex_state = 16},
  [3703] = {.lex_state = 165, .external_lex_state = 16},
  [3704] = {.lex_state = 165, .external_lex_state = 16},
  [3705] = {.lex_state = 165, .external_lex_state = 16},
  [3706] = {.lex_state = 165},
  [3707] = {.lex_state = 173},
  [3708] = {.lex_state = 179},
  [3709] = {.lex_state = 179},
  [3710] = {.lex_state = 179},
  [3711] = {.lex_state = 179},
  [3712] = {.lex_state = 179},
  [3713] = {.lex_state = 179},
  [3714] = {.lex_state = 179},
  [3715] = {.lex_state = 179},
  [3716] = {.lex_state = 179},
  [3717] = {.lex_state = 179},
  [3718] = {.lex_state = 179},
  [3719] = {.lex_state = 179},
  [3720] = {.lex_state = 179},
  [3721] = {.lex_state = 179},
  [3722] = {.lex_state = 179},
  [3723] = {.lex_state = 179},
  [3724] = {.lex_state = 179},
  [3725] = {.lex_state = 179},
  [3726] = {.lex_state = 179},
  [3727] = {.lex_state = 179},
  [3728] = {.lex_state = 179},
  [3729] = {.lex_state = 179},
  [3730] = {.lex_state = 179},
  [3731] = {.lex_state = 179},
  [3732] = {.lex_state = 179},
  [3733] = {.lex_state = 179},
  [3734] = {.lex_state = 179},
  [3735] = {.lex_state = 179},
  [3736] = {.lex_state = 179},
  [3737] = {.lex_state = 179},
  [3738] = {.lex_state = 179},
  [3739] = {.lex_state = 179},
  [3740] = {.lex_state = 179},
  [3741] = {.lex_state = 179},
  [3742] = {.lex_state = 179},
  [3743] = {.lex_state = 179},
  [3744] = {.lex_state = 179},
  [3745] = {.lex_state = 179},
  [3746] = {.lex_state = 179},
  [3747] = {.lex_state = 179},
  [3748] = {.lex_state = 179},
  [3749] = {.lex_state = 179},
  [3750] = {.lex_state = 179},
  [3751] = {.lex_state = 179},
  [3752] = {.lex_state = 179},
  [3753] = {.lex_state = 179},
  [3754] = {.lex_state = 179},
  [3755] = {.lex_state = 179},
  [3756] = {.lex_state = 179},
  [3757] = {.lex_state = 179},
  [3758] = {.lex_state = 198},
  [3759] = {.lex_state = 179},
  [3760] = {.lex_state = 179},
  [3761] = {.lex_state = 179},
  [3762] = {.lex_state = 179},
  [3763] = {.lex_state = 179},
  [3764] = {.lex_state = 179},
  [3765] = {.lex_state = 185},
  [3766] = {.lex_state = 185},
  [3767] = {.lex_state = 185},
  [3768] = {.lex_state = 185},
  [3769] = {.lex_state = 185},
  [3770] = {.lex_state = 149},
  [3771] = {.lex_state = 185},
  [3772] = {.lex_state = 185},
  [3773] = {.lex_state = 185},
  [3774] = {.lex_state = 185},
  [3775] = {.lex_state = 198},
  [3776] = {.lex_state = 198},
  [3777] = {.lex_state = 198},
  [3778] = {.lex_state = 198},
  [3779] = {.lex_state = 198},
  [3780] = {.lex_state = 198},
  [3781] = {.lex_state = 198},
  [3782] = {.lex_state = 198},
  [3783] = {.lex_state = 198},
  [3784] = {.lex_state = 198},
  [3785] = {.lex_state = 201},
  [3786] = {.lex_state = 198},
  [3787] = {.lex_state = 185},
  [3788] = {.lex_state = 198},
  [3789] = {.lex_state = 198},
  [3790] = {.lex_state = 189},
  [3791] = {.lex_state = 149, .external_lex_state = 15},
  [3792] = {.lex_state = 198},
  [3793] = {.lex_state = 198},
  [3794] = {.lex_state = 198},
  [3795] = {.lex_state = 198},
  [3796] = {.lex_state = 198},
  [3797] = {.lex_state = 198},
  [3798] = {.lex_state = 198},
  [3799] = {.lex_state = 198},
  [3800] = {.lex_state = 198},
  [3801] = {.lex_state = 198},
  [3802] = {.lex_state = 198},
  [3803] = {.lex_state = 149, .external_lex_state = 16},
  [3804] = {.lex_state = 198},
  [3805] = {.lex_state = 344},
  [3806] = {.lex_state = 198},
  [3807] = {.lex_state = 198},
  [3808] = {.lex_state = 198},
  [3809] = {.lex_state = 198},
  [3810] = {.lex_state = 198},
  [3811] = {.lex_state = 198},
  [3812] = {.lex_state = 198},
  [3813] = {.lex_state = 198},
  [3814] = {.lex_state = 198},
  [3815] = {.lex_state = 198},
  [3816] = {.lex_state = 198},
  [3817] = {.lex_state = 198},
  [3818] = {.lex_state = 198},
  [3819] = {.lex_state = 198},
  [3820] = {.lex_state = 198},
  [3821] = {.lex_state = 198},
  [3822] = {.lex_state = 198},
  [3823] = {.lex_state = 198},
  [3824] = {.lex_state = 198},
  [3825] = {.lex_state = 198},
  [3826] = {.lex_state = 198},
  [3827] = {.lex_state = 198},
  [3828] = {.lex_state = 198},
  [3829] = {.lex_state = 198},
  [3830] = {.lex_state = 198},
  [3831] = {.lex_state = 198},
  [3832] = {.lex_state = 198},
  [3833] = {.lex_state = 198},
  [3834] = {.lex_state = 198},
  [3835] = {.lex_state = 198},
  [3836] = {.lex_state = 198},
  [3837] = {.lex_state = 198},
  [3838] = {.lex_state = 198},
  [3839] = {.lex_state = 198},
  [3840] = {.lex_state = 198},
  [3841] = {.lex_state = 185},
  [3842] = {.lex_state = 198},
  [3843] = {.lex_state = 198},
  [3844] = {.lex_state = 198},
  [3845] = {.lex_state = 198},
  [3846] = {.lex_state = 198},
  [3847] = {.lex_state = 198},
  [3848] = {.lex_state = 198},
  [3849] = {.lex_state = 198},
  [3850] = {.lex_state = 198},
  [3851] = {.lex_state = 198},
  [3852] = {.lex_state = 198},
  [3853] = {.lex_state = 198},
  [3854] = {.lex_state = 198},
  [3855] = {.lex_state = 198},
  [3856] = {.lex_state = 198},
  [3857] = {.lex_state = 198},
  [3858] = {.lex_state = 198},
  [3859] = {.lex_state = 198},
  [3860] = {.lex_state = 198},
  [3861] = {.lex_state = 198},
  [3862] = {.lex_state = 198},
  [3863] = {.lex_state = 198},
  [3864] = {.lex_state = 198},
  [3865] = {.lex_state = 198},
  [3866] = {.lex_state = 198},
  [3867] = {.lex_state = 198},
  [3868] = {.lex_state = 198},
  [3869] = {.lex_state = 198},
  [3870] = {.lex_state = 198},
  [3871] = {.lex_state = 198},
  [3872] = {.lex_state = 198},
  [3873] = {.lex_state = 344},
  [3874] = {.lex_state = 198},
  [3875] = {.lex_state = 198},
  [3876] = {.lex_state = 198},
  [3877] = {.lex_state = 198},
  [3878] = {.lex_state = 198},
  [3879] = {.lex_state = 198},
  [3880] = {.lex_state = 198},
  [3881] = {.lex_state = 198},
  [3882] = {.lex_state = 198},
  [3883] = {.lex_state = 198},
  [3884] = {.lex_state = 198},
  [3885] = {.lex_state = 198},
  [3886] = {.lex_state = 185},
  [3887] = {.lex_state = 190},
  [3888] = {.lex_state = 198},
  [3889] = {.lex_state = 198},
  [3890] = {.lex_state = 198},
  [3891] = {.lex_state = 198},
  [3892] = {.lex_state = 198},
  [3893] = {.lex_state = 198},
  [3894] = {.lex_state = 198},
  [3895] = {.lex_state = 198},
  [3896] = {.lex_state = 198},
  [3897] = {.lex_state = 198},
  [3898] = {.lex_state = 198},
  [3899] = {.lex_state = 198},
  [3900] = {.lex_state = 198},
  [3901] = {.lex_state = 198},
  [3902] = {.lex_state = 198},
  [3903] = {.lex_state = 198},
  [3904] = {.lex_state = 198},
  [3905] = {.lex_state = 198},
  [3906] = {.lex_state = 198},
  [3907] = {.lex_state = 198},
  [3908] = {.lex_state = 198},
  [3909] = {.lex_state = 198},
  [3910] = {.lex_state = 198},
  [3911] = {.lex_state = 198},
  [3912] = {.lex_state = 198},
  [3913] = {.lex_state = 198},
  [3914] = {.lex_state = 198},
  [3915] = {.lex_state = 198},
  [3916] = {.lex_state = 198},
  [3917] = {.lex_state = 198},
  [3918] = {.lex_state = 198},
  [3919] = {.lex_state = 198},
  [3920] = {.lex_state = 198},
  [3921] = {.lex_state = 198},
  [3922] = {.lex_state = 198},
  [3923] = {.lex_state = 198},
  [3924] = {.lex_state = 198},
  [3925] = {.lex_state = 198},
  [3926] = {.lex_state = 198},
  [3927] = {.lex_state = 198},
  [3928] = {.lex_state = 198},
  [3929] = {.lex_state = 198},
  [3930] = {.lex_state = 198},
  [3931] = {.lex_state = 198},
  [3932] = {.lex_state = 198},
  [3933] = {.lex_state = 198},
  [3934] = {.lex_state = 198},
  [3935] = {.lex_state = 198},
  [3936] = {.lex_state = 198},
  [3937] = {.lex_state = 198},
  [3938] = {.lex_state = 198},
  [3939] = {.lex_state = 198},
  [3940] = {.lex_state = 198},
  [3941] = {.lex_state = 198},
  [3942] = {.lex_state = 198},
  [3943] = {.lex_state = 198},
  [3944] = {.lex_state = 198},
  [3945] = {.lex_state = 198},
  [3946] = {.lex_state = 198},
  [3947] = {.lex_state = 198},
  [3948] = {.lex_state = 198},
  [3949] = {.lex_state = 198},
  [3950] = {.lex_state = 198},
  [3951] = {.lex_state = 198},
  [3952] = {.lex_state = 198},
  [3953] = {.lex_state = 198},
  [3954] = {.lex_state = 198},
  [3955] = {.lex_state = 198},
  [3956] = {.lex_state = 198},
  [3957] = {.lex_state = 198},
  [3958] = {.lex_state = 198},
  [3959] = {.lex_state = 344},
  [3960] = {.lex_state = 198},
  [3961] = {.lex_state = 198},
  [3962] = {.lex_state = 198},
  [3963] = {.lex_state = 198},
  [3964] = {.lex_state = 198},
  [3965] = {.lex_state = 198},
  [3966] = {.lex_state = 198},
  [3967] = {.lex_state = 198},
  [3968] = {.lex_state = 198},
  [3969] = {.lex_state = 198},
  [3970] = {.lex_state = 190},
  [3971] = {.lex_state = 198},
  [3972] = {.lex_state = 198},
  [3973] = {.lex_state = 198},
  [3974] = {.lex_state = 198},
  [3975] = {.lex_state = 198},
  [3976] = {.lex_state = 198},
  [3977] = {.lex_state = 198},
  [3978] = {.lex_state = 198},
  [3979] = {.lex_state = 198},
  [3980] = {.lex_state = 198},
  [3981] = {.lex_state = 198},
  [3982] = {.lex_state = 185},
  [3983] = {.lex_state = 198},
  [3984] = {.lex_state = 198},
  [3985] = {.lex_state = 198},
  [3986] = {.lex_state = 185},
  [3987] = {.lex_state = 185},
  [3988] = {.lex_state = 198},
  [3989] = {.lex_state = 198},
  [3990] = {.lex_state = 198},
  [3991] = {.lex_state = 198},
  [3992] = {.lex_state = 198},
  [3993] = {.lex_state = 198},
  [3994] = {.lex_state = 198},
  [3995] = {.lex_state = 198},
  [3996] = {.lex_state = 198},
  [3997] = {.lex_state = 198},
  [3998] = {.lex_state = 198},
  [3999] = {.lex_state = 198},
  [4000] = {.lex_state = 198},
  [4001] = {.lex_state = 198},
  [4002] = {.lex_state = 198},
  [4003] = {.lex_state = 198},
  [4004] = {.lex_state = 198},
  [4005] = {.lex_state = 198},
  [4006] = {.lex_state = 198},
  [4007] = {.lex_state = 198},
  [4008] = {.lex_state = 198},
  [4009] = {.lex_state = 198},
  [4010] = {.lex_state = 198},
  [4011] = {.lex_state = 198},
  [4012] = {.lex_state = 198},
  [4013] = {.lex_state = 198},
  [4014] = {.lex_state = 198},
  [4015] = {.lex_state = 198},
  [4016] = {.lex_state = 198},
  [4017] = {.lex_state = 198},
  [4018] = {.lex_state = 198},
  [4019] = {.lex_state = 198},
  [4020] = {.lex_state = 198},
  [4021] = {.lex_state = 198},
  [4022] = {.lex_state = 198},
  [4023] = {.lex_state = 198},
  [4024] = {.lex_state = 198},
  [4025] = {.lex_state = 198},
  [4026] = {.lex_state = 198},
  [4027] = {.lex_state = 198},
  [4028] = {.lex_state = 198},
  [4029] = {.lex_state = 198},
  [4030] = {.lex_state = 198},
  [4031] = {.lex_state = 198},
  [4032] = {.lex_state = 198},
  [4033] = {.lex_state = 198},
  [4034] = {.lex_state = 198},
  [4035] = {.lex_state = 190},
  [4036] = {.lex_state = 198},
  [4037] = {.lex_state = 198},
  [4038] = {.lex_state = 198},
  [4039] = {.lex_state = 198},
  [4040] = {.lex_state = 198},
  [4041] = {.lex_state = 198},
  [4042] = {.lex_state = 198},
  [4043] = {.lex_state = 198},
  [4044] = {.lex_state = 198},
  [4045] = {.lex_state = 185},
  [4046] = {.lex_state = 198},
  [4047] = {.lex_state = 198},
  [4048] = {.lex_state = 198},
  [4049] = {.lex_state = 198},
  [4050] = {.lex_state = 198},
  [4051] = {.lex_state = 198},
  [4052] = {.lex_state = 198},
  [4053] = {.lex_state = 198},
  [4054] = {.lex_state = 198},
  [4055] = {.lex_state = 198},
  [4056] = {.lex_state = 190},
  [4057] = {.lex_state = 198},
  [4058] = {.lex_state = 198},
  [4059] = {.lex_state = 198},
  [4060] = {.lex_state = 198},
  [4061] = {.lex_state = 198},
  [4062] = {.lex_state = 198},
  [4063] = {.lex_state = 198},
  [4064] = {.lex_state = 198},
  [4065] = {.lex_state = 198},
  [4066] = {.lex_state = 198},
  [4067] = {.lex_state = 198},
  [4068] = {.lex_state = 198},
  [4069] = {.lex_state = 198},
  [4070] = {.lex_state = 198},
  [4071] = {.lex_state = 198},
  [4072] = {.lex_state = 198},
  [4073] = {.lex_state = 198},
  [4074] = {.lex_state = 198},
  [4075] = {.lex_state = 198},
  [4076] = {.lex_state = 198},
  [4077] = {.lex_state = 198},
  [4078] = {.lex_state = 198},
  [4079] = {.lex_state = 198},
  [4080] = {.lex_state = 198},
  [4081] = {.lex_state = 198},
  [4082] = {.lex_state = 198},
  [4083] = {.lex_state = 198},
  [4084] = {.lex_state = 198},
  [4085] = {.lex_state = 198},
  [4086] = {.lex_state = 198},
  [4087] = {.lex_state = 198},
  [4088] = {.lex_state = 198},
  [4089] = {.lex_state = 198},
  [4090] = {.lex_state = 198},
  [4091] = {.lex_state = 198},
  [4092] = {.lex_state = 198},
  [4093] = {.lex_state = 198},
  [4094] = {.lex_state = 198},
  [4095] = {.lex_state = 198},
  [4096] = {.lex_state = 198},
  [4097] = {.lex_state = 185},
  [4098] = {.lex_state = 198},
  [4099] = {.lex_state = 198},
  [4100] = {.lex_state = 198},
  [4101] = {.lex_state = 198},
  [4102] = {.lex_state = 198},
  [4103] = {.lex_state = 198},
  [4104] = {.lex_state = 198},
  [4105] = {.lex_state = 198},
  [4106] = {.lex_state = 198},
  [4107] = {.lex_state = 198},
  [4108] = {.lex_state = 198},
  [4109] = {.lex_state = 198},
  [4110] = {.lex_state = 198},
  [4111] = {.lex_state = 198},
  [4112] = {.lex_state = 198},
  [4113] = {.lex_state = 198},
  [4114] = {.lex_state = 198},
  [4115] = {.lex_state = 198},
  [4116] = {.lex_state = 198},
  [4117] = {.lex_state = 198},
  [4118] = {.lex_state = 198},
  [4119] = {.lex_state = 198},
  [4120] = {.lex_state = 198},
  [4121] = {.lex_state = 198},
  [4122] = {.lex_state = 198},
  [4123] = {.lex_state = 198},
  [4124] = {.lex_state = 198},
  [4125] = {.lex_state = 198},
  [4126] = {.lex_state = 198},
  [4127] = {.lex_state = 198},
  [4128] = {.lex_state = 198},
  [4129] = {.lex_state = 198},
  [4130] = {.lex_state = 198},
  [4131] = {.lex_state = 198},
  [4132] = {.lex_state = 198},
  [4133] = {.lex_state = 198},
  [4134] = {.lex_state = 204, .external_lex_state = 15},
  [4135] = {.lex_state = 344},
  [4136] = {.lex_state = 344},
  [4137] = {.lex_state = 344},
  [4138] = {.lex_state = 204, .external_lex_state = 16},
  [4139] = {.lex_state = 346, .external_lex_state = 16},
  [4140] = {.lex_state = 346, .external_lex_state = 16},
  [4141] = {.lex_state = 344},
  [4142] = {.lex_state = 344},
  [4143] = {.lex_state = 344},
  [4144] = {.lex_state = 344},
  [4145] = {.lex_state = 346, .external_lex_state = 16},
  [4146] = {.lex_state = 346, .external_lex_state = 16},
  [4147] = {.lex_state = 346, .external_lex_state = 16},
  [4148] = {.lex_state = 344},
  [4149] = {.lex_state = 344},
  [4150] = {.lex_state = 344},
  [4151] = {.lex_state = 344},
  [4152] = {.lex_state = 344},
  [4153] = {.lex_state = 346, .external_lex_state = 16},
  [4154] = {.lex_state = 344},
  [4155] = {.lex_state = 344},
  [4156] = {.lex_state = 344},
  [4157] = {.lex_state = 344},
  [4158] = {.lex_state = 344},
  [4159] = {.lex_state = 344},
  [4160] = {.lex_state = 344},
  [4161] = {.lex_state = 344},
  [4162] = {.lex_state = 346, .external_lex_state = 16},
  [4163] = {.lex_state = 344},
  [4164] = {.lex_state = 344},
  [4165] = {.lex_state = 344},
  [4166] = {.lex_state = 344},
  [4167] = {.lex_state = 344},
  [4168] = {.lex_state = 344},
  [4169] = {.lex_state = 346, .external_lex_state = 16},
  [4170] = {.lex_state = 346, .external_lex_state = 16},
  [4171] = {.lex_state = 344},
  [4172] = {.lex_state = 344},
  [4173] = {.lex_state = 344},
  [4174] = {.lex_state = 344},
  [4175] = {.lex_state = 344},
  [4176] = {.lex_state = 344},
  [4177] = {.lex_state = 344},
  [4178] = {.lex_state = 344},
  [4179] = {.lex_state = 344},
  [4180] = {.lex_state = 344},
  [4181] = {.lex_state = 344},
  [4182] = {.lex_state = 346, .external_lex_state = 16},
  [4183] = {.lex_state = 344},
  [4184] = {.lex_state = 344},
  [4185] = {.lex_state = 344},
  [4186] = {.lex_state = 344},
  [4187] = {.lex_state = 344},
  [4188] = {.lex_state = 344},
  [4189] = {.lex_state = 344},
  [4190] = {.lex_state = 344},
  [4191] = {.lex_state = 346, .external_lex_state = 16},
  [4192] = {.lex_state = 346, .external_lex_state = 16},
  [4193] = {.lex_state = 346, .external_lex_state = 16},
  [4194] = {.lex_state = 346, .external_lex_state = 16},
  [4195] = {.lex_state = 346, .external_lex_state = 16},
  [4196] = {.lex_state = 346, .external_lex_state = 16},
  [4197] = {.lex_state = 346, .external_lex_state = 16},
  [4198] = {.lex_state = 346, .external_lex_state = 16},
  [4199] = {.lex_state = 346, .external_lex_state = 16},
  [4200] = {.lex_state = 346, .external_lex_state = 16},
  [4201] = {.lex_state = 199, .external_lex_state = 15},
  [4202] = {.lex_state = 200, .external_lex_state = 18},
  [4203] = {.lex_state = 200, .external_lex_state = 18},
  [4204] = {.lex_state = 200, .external_lex_state = 18},
  [4205] = {.lex_state = 344, .external_lex_state = 16},
  [4206] = {.lex_state = 200, .external_lex_state = 18},
  [4207] = {.lex_state = 346, .external_lex_state = 16},
  [4208] = {.lex_state = 199, .external_lex_state = 15},
  [4209] = {.lex_state = 200, .external_lex_state = 18},
  [4210] = {.lex_state = 199, .external_lex_state = 15},
  [4211] = {.lex_state = 346, .external_lex_state = 16},
  [4212] = {.lex_state = 199, .external_lex_state = 15},
  [4213] = {.lex_state = 344, .external_lex_state = 16},
  [4214] = {.lex_state = 199, .external_lex_state = 15},
  [4215] = {.lex_state = 199},
  [4216] = {.lex_state = 199, .external_lex_state = 15},
  [4217] = {.lex_state = 199, .external_lex_state = 15},
  [4218] = {.lex_state = 346, .external_lex_state = 16},
  [4219] = {.lex_state = 199, .external_lex_state = 16},
  [4220] = {.lex_state = 344, .external_lex_state = 16},
  [4221] = {.lex_state = 200, .external_lex_state = 18},
  [4222] = {.lex_state = 199, .external_lex_state = 15},
  [4223] = {.lex_state = 346, .external_lex_state = 16},
  [4224] = {.lex_state = 346, .external_lex_state = 16},
  [4225] = {.lex_state = 200, .external_lex_state = 18},
  [4226] = {.lex_state = 200, .external_lex_state = 18},
  [4227] = {.lex_state = 200, .external_lex_state = 18},
  [4228] = {.lex_state = 200, .external_lex_state = 15},
  [4229] = {.lex_state = 199, .external_lex_state = 15},
  [4230] = {.lex_state = 200, .external_lex_state = 18},
  [4231] = {.lex_state = 199, .external_lex_state = 15},
  [4232] = {.lex_state = 200, .external_lex_state = 19},
  [4233] = {.lex_state = 346, .external_lex_state = 16},
  [4234] = {.lex_state = 346, .external_lex_state = 16},
  [4235] = {.lex_state = 346, .external_lex_state = 16},
  [4236] = {.lex_state = 200, .external_lex_state = 19},
  [4237] = {.lex_state = 200, .external_lex_state = 20},
  [4238] = {.lex_state = 200, .external_lex_state = 19},
  [4239] = {.lex_state = 200, .external_lex_state = 19},
  [4240] = {.lex_state = 199, .external_lex_state = 16},
  [4241] = {.lex_state = 200, .external_lex_state = 20},
  [4242] = {.lex_state = 200, .external_lex_state = 19},
  [4243] = {.lex_state = 346, .external_lex_state = 16},
  [4244] = {.lex_state = 199, .external_lex_state = 16},
  [4245] = {.lex_state = 346, .external_lex_state = 16},
  [4246] = {.lex_state = 199, .external_lex_state = 15},
  [4247] = {.lex_state = 346, .external_lex_state = 16},
  [4248] = {.lex_state = 346, .external_lex_state = 16},
  [4249] = {.lex_state = 199, .external_lex_state = 16},
  [4250] = {.lex_state = 200, .external_lex_state = 20},
  [4251] = {.lex_state = 200, .external_lex_state = 20},
  [4252] = {.lex_state = 344},
  [4253] = {.lex_state = 346, .external_lex_state = 16},
  [4254] = {.lex_state = 345},
  [4255] = {.lex_state = 200, .external_lex_state = 18},
  [4256] = {.lex_state = 344},
  [4257] = {.lex_state = 344},
  [4258] = {.lex_state = 200, .external_lex_state = 15},
  [4259] = {.lex_state = 346, .external_lex_state = 16},
  [4260] = {.lex_state = 200, .external_lex_state = 15},
  [4261] = {.lex_state = 345},
  [4262] = {.lex_state = 199},
  [4263] = {.lex_state = 346, .external_lex_state = 16},
  [4264] = {.lex_state = 199, .external_lex_state = 16},
  [4265] = {.lex_state = 199, .external_lex_state = 16},
  [4266] = {.lex_state = 200, .external_lex_state = 19},
  [4267] = {.lex_state = 200, .external_lex_state = 15},
  [4268] = {.lex_state = 346, .external_lex_state = 16},
  [4269] = {.lex_state = 200, .external_lex_state = 19},
  [4270] = {.lex_state = 199},
  [4271] = {.lex_state = 199},
  [4272] = {.lex_state = 199},
  [4273] = {.lex_state = 200, .external_lex_state = 20},
  [4274] = {.lex_state = 200, .external_lex_state = 20},
  [4275] = {.lex_state = 200, .external_lex_state = 15},
  [4276] = {.lex_state = 199},
  [4277] = {.lex_state = 199},
  [4278] = {.lex_state = 200, .external_lex_state = 20},
  [4279] = {.lex_state = 200, .external_lex_state = 20},
  [4280] = {.lex_state = 199},
  [4281] = {.lex_state = 200, .external_lex_state = 20},
  [4282] = {.lex_state = 199, .external_lex_state = 16},
  [4283] = {.lex_state = 199},
  [4284] = {.lex_state = 200, .external_lex_state = 15},
  [4285] = {.lex_state = 199, .external_lex_state = 15},
  [4286] = {.lex_state = 199, .external_lex_state = 16},
  [4287] = {.lex_state = 200, .external_lex_state = 18},
  [4288] = {.lex_state = 200, .external_lex_state = 18},
  [4289] = {.lex_state = 345},
  [4290] = {.lex_state = 346, .external_lex_state = 16},
  [4291] = {.lex_state = 200, .external_lex_state = 15},
  [4292] = {.lex_state = 345},
  [4293] = {.lex_state = 199, .external_lex_state = 15},
  [4294] = {.lex_state = 200, .external_lex_state = 19},
  [4295] = {.lex_state = 200, .external_lex_state = 19},
  [4296] = {.lex_state = 200, .external_lex_state = 18},
  [4297] = {.lex_state = 200, .external_lex_state = 15},
  [4298] = {.lex_state = 206, .external_lex_state = 20},
  [4299] = {.lex_state = 200, .external_lex_state = 15},
  [4300] = {.lex_state = 206, .external_lex_state = 20},
  [4301] = {.lex_state = 199, .external_lex_state = 20},
  [4302] = {.lex_state = 200, .external_lex_state = 18},
  [4303] = {.lex_state = 200, .external_lex_state = 15},
  [4304] = {.lex_state = 200, .external_lex_state = 18},
  [4305] = {.lex_state = 346},
  [4306] = {.lex_state = 200, .external_lex_state = 18},
  [4307] = {.lex_state = 200, .external_lex_state = 18},
  [4308] = {.lex_state = 200, .external_lex_state = 20},
  [4309] = {.lex_state = 200},
  [4310] = {.lex_state = 199, .external_lex_state = 15},
  [4311] = {.lex_state = 200, .external_lex_state = 20},
  [4312] = {.lex_state = 345},
  [4313] = {.lex_state = 199, .external_lex_state = 15},
  [4314] = {.lex_state = 199, .external_lex_state = 15},
  [4315] = {.lex_state = 345},
  [4316] = {.lex_state = 199, .external_lex_state = 16},
  [4317] = {.lex_state = 345},
  [4318] = {.lex_state = 199, .external_lex_state = 20},
  [4319] = {.lex_state = 199, .external_lex_state = 20},
  [4320] = {.lex_state = 199, .external_lex_state = 16},
  [4321] = {.lex_state = 200, .external_lex_state = 15},
  [4322] = {.lex_state = 206, .external_lex_state = 20},
  [4323] = {.lex_state = 199},
  [4324] = {.lex_state = 199, .external_lex_state = 20},
  [4325] = {.lex_state = 199, .external_lex_state = 20},
  [4326] = {.lex_state = 200},
  [4327] = {.lex_state = 199, .external_lex_state = 20},
  [4328] = {.lex_state = 206, .external_lex_state = 20},
  [4329] = {.lex_state = 206, .external_lex_state = 20},
  [4330] = {.lex_state = 345},
  [4331] = {.lex_state = 200, .external_lex_state = 16},
  [4332] = {.lex_state = 345},
  [4333] = {.lex_state = 346},
  [4334] = {.lex_state = 200},
  [4335] = {.lex_state = 200, .external_lex_state = 16},
  [4336] = {.lex_state = 345},
  [4337] = {.lex_state = 199, .external_lex_state = 15},
  [4338] = {.lex_state = 200, .external_lex_state = 16},
  [4339] = {.lex_state = 199, .external_lex_state = 20},
  [4340] = {.lex_state = 200, .external_lex_state = 16},
  [4341] = {.lex_state = 199},
  [4342] = {.lex_state = 200, .external_lex_state = 19},
  [4343] = {.lex_state = 200, .external_lex_state = 19},
  [4344] = {.lex_state = 199},
  [4345] = {.lex_state = 345},
  [4346] = {.lex_state = 200, .external_lex_state = 18},
  [4347] = {.lex_state = 206, .external_lex_state = 20},
  [4348] = {.lex_state = 206, .external_lex_state = 20},
  [4349] = {.lex_state = 199, .external_lex_state = 15},
  [4350] = {.lex_state = 199},
  [4351] = {.lex_state = 199},
  [4352] = {.lex_state = 200},
  [4353] = {.lex_state = 200, .external_lex_state = 20},
  [4354] = {.lex_state = 200, .external_lex_state = 15},
  [4355] = {.lex_state = 200, .external_lex_state = 20},
  [4356] = {.lex_state = 199, .external_lex_state = 20},
  [4357] = {.lex_state = 344},
  [4358] = {.lex_state = 199, .external_lex_state = 20},
  [4359] = {.lex_state = 200},
  [4360] = {.lex_state = 206, .external_lex_state = 20},
  [4361] = {.lex_state = 199, .external_lex_state = 16},
  [4362] = {.lex_state = 200, .external_lex_state = 16},
  [4363] = {.lex_state = 200, .external_lex_state = 20},
  [4364] = {.lex_state = 200},
  [4365] = {.lex_state = 200},
  [4366] = {.lex_state = 200, .external_lex_state = 19},
  [4367] = {.lex_state = 200, .external_lex_state = 15},
  [4368] = {.lex_state = 200, .external_lex_state = 20},
  [4369] = {.lex_state = 206, .external_lex_state = 20},
  [4370] = {.lex_state = 199, .external_lex_state = 16},
  [4371] = {.lex_state = 199},
  [4372] = {.lex_state = 199, .external_lex_state = 16},
  [4373] = {.lex_state = 200, .external_lex_state = 20},
  [4374] = {.lex_state = 200, .external_lex_state = 19},
  [4375] = {.lex_state = 200, .external_lex_state = 16},
  [4376] = {.lex_state = 200, .external_lex_state = 19},
  [4377] = {.lex_state = 345},
  [4378] = {.lex_state = 200, .external_lex_state = 16},
  [4379] = {.lex_state = 200},
  [4380] = {.lex_state = 200, .external_lex_state = 16},
  [4381] = {.lex_state = 199, .external_lex_state = 20},
  [4382] = {.lex_state = 200},
  [4383] = {.lex_state = 199},
  [4384] = {.lex_state = 200},
  [4385] = {.lex_state = 206},
  [4386] = {.lex_state = 206},
  [4387] = {.lex_state = 206, .external_lex_state = 20},
  [4388] = {.lex_state = 206},
  [4389] = {.lex_state = 206},
  [4390] = {.lex_state = 206},
  [4391] = {.lex_state = 200, .external_lex_state = 18},
  [4392] = {.lex_state = 199},
  [4393] = {.lex_state = 206},
  [4394] = {.lex_state = 344},
  [4395] = {.lex_state = 200, .external_lex_state = 20},
  [4396] = {.lex_state = 200},
  [4397] = {.lex_state = 199, .external_lex_state = 15},
  [4398] = {.lex_state = 345},
  [4399] = {.lex_state = 200, .external_lex_state = 19},
  [4400] = {.lex_state = 200},
  [4401] = {.lex_state = 199},
  [4402] = {.lex_state = 200, .external_lex_state = 18},
  [4403] = {.lex_state = 200, .external_lex_state = 20},
  [4404] = {.lex_state = 200, .external_lex_state = 18},
  [4405] = {.lex_state = 206, .external_lex_state = 20},
  [4406] = {.lex_state = 200, .external_lex_state = 18},
  [4407] = {.lex_state = 200, .external_lex_state = 18},
  [4408] = {.lex_state = 200, .external_lex_state = 18},
  [4409] = {.lex_state = 149},
  [4410] = {.lex_state = 200, .external_lex_state = 18},
  [4411] = {.lex_state = 206, .external_lex_state = 20},
  [4412] = {.lex_state = 345},
  [4413] = {.lex_state = 200, .external_lex_state = 18},
  [4414] = {.lex_state = 199, .external_lex_state = 20},
  [4415] = {.lex_state = 200, .external_lex_state = 18},
  [4416] = {.lex_state = 200, .external_lex_state = 18},
  [4417] = {.lex_state = 199, .external_lex_state = 20},
  [4418] = {.lex_state = 200, .external_lex_state = 15},
  [4419] = {.lex_state = 200, .external_lex_state = 18},
  [4420] = {.lex_state = 199, .external_lex_state = 15},
  [4421] = {.lex_state = 199, .external_lex_state = 20},
  [4422] = {.lex_state = 206},
  [4423] = {.lex_state = 345},
  [4424] = {.lex_state = 206},
  [4425] = {.lex_state = 149},
  [4426] = {.lex_state = 200, .external_lex_state = 20},
  [4427] = {.lex_state = 345},
  [4428] = {.lex_state = 206},
  [4429] = {.lex_state = 199},
  [4430] = {.lex_state = 199, .external_lex_state = 16},
  [4431] = {.lex_state = 199, .external_lex_state = 15},
  [4432] = {.lex_state = 199, .external_lex_state = 15},
  [4433] = {.lex_state = 200},
  [4434] = {.lex_state = 199, .external_lex_state = 16},
  [4435] = {.lex_state = 200, .external_lex_state = 16},
  [4436] = {.lex_state = 199, .external_lex_state = 16},
  [4437] = {.lex_state = 199, .external_lex_state = 16},
  [4438] = {.lex_state = 206},
  [4439] = {.lex_state = 200, .external_lex_state = 16},
  [4440] = {.lex_state = 200, .external_lex_state = 16},
  [4441] = {.lex_state = 345},
  [4442] = {.lex_state = 200, .external_lex_state = 16},
  [4443] = {.lex_state = 199, .external_lex_state = 16},
  [4444] = {.lex_state = 206},
  [4445] = {.lex_state = 200, .external_lex_state = 16},
  [4446] = {.lex_state = 199},
  [4447] = {.lex_state = 200, .external_lex_state = 15},
  [4448] = {.lex_state = 200, .external_lex_state = 20},
  [4449] = {.lex_state = 200, .external_lex_state = 15},
  [4450] = {.lex_state = 199, .external_lex_state = 15},
  [4451] = {.lex_state = 345},
  [4452] = {.lex_state = 200, .external_lex_state = 15},
  [4453] = {.lex_state = 200, .external_lex_state = 18},
  [4454] = {.lex_state = 345},
  [4455] = {.lex_state = 199},
  [4456] = {.lex_state = 199, .external_lex_state = 15},
  [4457] = {.lex_state = 199, .external_lex_state = 20},
  [4458] = {.lex_state = 200, .external_lex_state = 20},
  [4459] = {.lex_state = 199, .external_lex_state = 15},
  [4460] = {.lex_state = 200, .external_lex_state = 19},
  [4461] = {.lex_state = 200, .external_lex_state = 19},
  [4462] = {.lex_state = 199, .external_lex_state = 15},
  [4463] = {.lex_state = 200, .external_lex_state = 19},
  [4464] = {.lex_state = 200, .external_lex_state = 15},
  [4465] = {.lex_state = 199, .external_lex_state = 15},
  [4466] = {.lex_state = 345},
  [4467] = {.lex_state = 200, .external_lex_state = 19},
  [4468] = {.lex_state = 199, .external_lex_state = 15},
  [4469] = {.lex_state = 199, .external_lex_state = 15},
  [4470] = {.lex_state = 199, .external_lex_state = 15},
  [4471] = {.lex_state = 206, .external_lex_state = 20},
  [4472] = {.lex_state = 206, .external_lex_state = 20},
  [4473] = {.lex_state = 206, .external_lex_state = 20},
  [4474] = {.lex_state = 200, .external_lex_state = 19},
  [4475] = {.lex_state = 200, .external_lex_state = 19},
  [4476] = {.lex_state = 200, .external_lex_state = 19},
  [4477] = {.lex_state = 200, .external_lex_state = 19},
  [4478] = {.lex_state = 200, .external_lex_state = 19},
  [4479] = {.lex_state = 200, .external_lex_state = 19},
  [4480] = {.lex_state = 200, .external_lex_state = 19},
  [4481] = {.lex_state = 200, .external_lex_state = 19},
  [4482] = {.lex_state = 200},
  [4483] = {.lex_state = 345, .external_lex_state = 20},
  [4484] = {.lex_state = 199, .external_lex_state = 20},
  [4485] = {.lex_state = 200, .external_lex_state = 19},
  [4486] = {.lex_state = 345, .external_lex_state = 20},
  [4487] = {.lex_state = 199, .external_lex_state = 20},
  [4488] = {.lex_state = 346},
  [4489] = {.lex_state = 200, .external_lex_state = 15},
  [4490] = {.lex_state = 200, .external_lex_state = 15},
  [4491] = {.lex_state = 206},
  [4492] = {.lex_state = 346},
  [4493] = {.lex_state = 200, .external_lex_state = 15},
  [4494] = {.lex_state = 345},
  [4495] = {.lex_state = 200, .external_lex_state = 15},
  [4496] = {.lex_state = 206, .external_lex_state = 20},
  [4497] = {.lex_state = 200, .external_lex_state = 15},
  [4498] = {.lex_state = 199, .external_lex_state = 16},
  [4499] = {.lex_state = 200, .external_lex_state = 15},
  [4500] = {.lex_state = 200, .external_lex_state = 15},
  [4501] = {.lex_state = 200, .external_lex_state = 15},
  [4502] = {.lex_state = 199, .external_lex_state = 20},
  [4503] = {.lex_state = 200, .external_lex_state = 15},
  [4504] = {.lex_state = 199, .external_lex_state = 16},
  [4505] = {.lex_state = 199, .external_lex_state = 16},
  [4506] = {.lex_state = 200, .external_lex_state = 16},
  [4507] = {.lex_state = 199, .external_lex_state = 20},
  [4508] = {.lex_state = 199, .external_lex_state = 16},
  [4509] = {.lex_state = 199, .external_lex_state = 16},
  [4510] = {.lex_state = 200, .external_lex_state = 16},
  [4511] = {.lex_state = 206, .external_lex_state = 20},
  [4512] = {.lex_state = 149},
  [4513] = {.lex_state = 345},
  [4514] = {.lex_state = 200, .external_lex_state = 20},
  [4515] = {.lex_state = 200, .external_lex_state = 20},
  [4516] = {.lex_state = 200, .external_lex_state = 20},
  [4517] = {.lex_state = 346, .external_lex_state = 21},
  [4518] = {.lex_state = 199, .external_lex_state = 16},
  [4519] = {.lex_state = 346, .external_lex_state = 21},
  [4520] = {.lex_state = 346},
  [4521] = {.lex_state = 206, .external_lex_state = 20},
  [4522] = {.lex_state = 346, .external_lex_state = 21},
  [4523] = {.lex_state = 346, .external_lex_state = 21},
  [4524] = {.lex_state = 346, .external_lex_state = 21},
  [4525] = {.lex_state = 199, .external_lex_state = 16},
  [4526] = {.lex_state = 206},
  [4527] = {.lex_state = 199},
  [4528] = {.lex_state = 346, .external_lex_state = 21},
  [4529] = {.lex_state = 199},
  [4530] = {.lex_state = 199, .external_lex_state = 16},
  [4531] = {.lex_state = 199},
  [4532] = {.lex_state = 199, .external_lex_state = 16},
  [4533] = {.lex_state = 199},
  [4534] = {.lex_state = 200},
  [4535] = {.lex_state = 346, .external_lex_state = 21},
  [4536] = {.lex_state = 206},
  [4537] = {.lex_state = 149},
  [4538] = {.lex_state = 200, .external_lex_state = 20},
  [4539] = {.lex_state = 200, .external_lex_state = 20},
  [4540] = {.lex_state = 200, .external_lex_state = 20},
  [4541] = {.lex_state = 149},
  [4542] = {.lex_state = 345, .external_lex_state = 20},
  [4543] = {.lex_state = 199},
  [4544] = {.lex_state = 200, .external_lex_state = 20},
  [4545] = {.lex_state = 200, .external_lex_state = 19},
  [4546] = {.lex_state = 200, .external_lex_state = 19},
  [4547] = {.lex_state = 345, .external_lex_state = 20},
  [4548] = {.lex_state = 200, .external_lex_state = 20},
  [4549] = {.lex_state = 200, .external_lex_state = 16},
  [4550] = {.lex_state = 199},
  [4551] = {.lex_state = 200, .external_lex_state = 19},
  [4552] = {.lex_state = 199, .external_lex_state = 20},
  [4553] = {.lex_state = 199},
  [4554] = {.lex_state = 199},
  [4555] = {.lex_state = 200, .external_lex_state = 16},
  [4556] = {.lex_state = 206, .external_lex_state = 20},
  [4557] = {.lex_state = 200, .external_lex_state = 16},
  [4558] = {.lex_state = 345},
  [4559] = {.lex_state = 345, .external_lex_state = 20},
  [4560] = {.lex_state = 345, .external_lex_state = 20},
  [4561] = {.lex_state = 345, .external_lex_state = 20},
  [4562] = {.lex_state = 200, .external_lex_state = 15},
  [4563] = {.lex_state = 200, .external_lex_state = 20},
  [4564] = {.lex_state = 200, .external_lex_state = 20},
  [4565] = {.lex_state = 345},
  [4566] = {.lex_state = 346},
  [4567] = {.lex_state = 346},
  [4568] = {.lex_state = 200, .external_lex_state = 15},
  [4569] = {.lex_state = 200, .external_lex_state = 15},
  [4570] = {.lex_state = 200},
  [4571] = {.lex_state = 200, .external_lex_state = 20},
  [4572] = {.lex_state = 345},
  [4573] = {.lex_state = 200, .external_lex_state = 20},
  [4574] = {.lex_state = 199},
  [4575] = {.lex_state = 345},
  [4576] = {.lex_state = 200},
  [4577] = {.lex_state = 199},
  [4578] = {.lex_state = 199},
  [4579] = {.lex_state = 199, .external_lex_state = 16},
  [4580] = {.lex_state = 199},
  [4581] = {.lex_state = 199, .external_lex_state = 16},
  [4582] = {.lex_state = 199, .external_lex_state = 16},
  [4583] = {.lex_state = 200},
  [4584] = {.lex_state = 345},
  [4585] = {.lex_state = 206},
  [4586] = {.lex_state = 206, .external_lex_state = 20},
  [4587] = {.lex_state = 152, .external_lex_state = 22},
  [4588] = {.lex_state = 152, .external_lex_state = 22},
  [4589] = {.lex_state = 200},
  [4590] = {.lex_state = 152, .external_lex_state = 22},
  [4591] = {.lex_state = 200},
  [4592] = {.lex_state = 206},
  [4593] = {.lex_state = 152, .external_lex_state = 22},
  [4594] = {.lex_state = 346, .external_lex_state = 21},
  [4595] = {.lex_state = 152, .external_lex_state = 22},
  [4596] = {.lex_state = 206},
  [4597] = {.lex_state = 346, .external_lex_state = 21},
  [4598] = {.lex_state = 345},
  [4599] = {.lex_state = 152, .external_lex_state = 22},
  [4600] = {.lex_state = 152, .external_lex_state = 22},
  [4601] = {.lex_state = 152, .external_lex_state = 22},
  [4602] = {.lex_state = 345},
  [4603] = {.lex_state = 152, .external_lex_state = 22},
  [4604] = {.lex_state = 206},
  [4605] = {.lex_state = 152, .external_lex_state = 22},
  [4606] = {.lex_state = 200, .external_lex_state = 16},
  [4607] = {.lex_state = 345},
  [4608] = {.lex_state = 345},
  [4609] = {.lex_state = 345},
  [4610] = {.lex_state = 206, .external_lex_state = 20},
  [4611] = {.lex_state = 206, .external_lex_state = 20},
  [4612] = {.lex_state = 200, .external_lex_state = 16},
  [4613] = {.lex_state = 206, .external_lex_state = 20},
  [4614] = {.lex_state = 200, .external_lex_state = 16},
  [4615] = {.lex_state = 345},
  [4616] = {.lex_state = 152, .external_lex_state = 22},
  [4617] = {.lex_state = 344, .external_lex_state = 19},
  [4618] = {.lex_state = 345},
  [4619] = {.lex_state = 152, .external_lex_state = 22},
  [4620] = {.lex_state = 152, .external_lex_state = 22},
  [4621] = {.lex_state = 152, .external_lex_state = 22},
  [4622] = {.lex_state = 345},
  [4623] = {.lex_state = 345},
  [4624] = {.lex_state = 200},
  [4625] = {.lex_state = 345},
  [4626] = {.lex_state = 200},
  [4627] = {.lex_state = 152, .external_lex_state = 22},
  [4628] = {.lex_state = 346, .external_lex_state = 21},
  [4629] = {.lex_state = 345},
  [4630] = {.lex_state = 152, .external_lex_state = 22},
  [4631] = {.lex_state = 345},
  [4632] = {.lex_state = 152, .external_lex_state = 22},
  [4633] = {.lex_state = 152, .external_lex_state = 22},
  [4634] = {.lex_state = 346},
  [4635] = {.lex_state = 152, .external_lex_state = 22},
  [4636] = {.lex_state = 346},
  [4637] = {.lex_state = 152, .external_lex_state = 22},
  [4638] = {.lex_state = 152, .external_lex_state = 22},
  [4639] = {.lex_state = 152, .external_lex_state = 22},
  [4640] = {.lex_state = 152, .external_lex_state = 22},
  [4641] = {.lex_state = 152, .external_lex_state = 22},
  [4642] = {.lex_state = 206, .external_lex_state = 20},
  [4643] = {.lex_state = 152, .external_lex_state = 22},
  [4644] = {.lex_state = 152, .external_lex_state = 22},
  [4645] = {.lex_state = 346, .external_lex_state = 21},
  [4646] = {.lex_state = 200, .external_lex_state = 16},
  [4647] = {.lex_state = 152, .external_lex_state = 22},
  [4648] = {.lex_state = 152, .external_lex_state = 22},
  [4649] = {.lex_state = 346, .external_lex_state = 21},
  [4650] = {.lex_state = 152, .external_lex_state = 22},
  [4651] = {.lex_state = 200, .external_lex_state = 16},
  [4652] = {.lex_state = 200, .external_lex_state = 16},
  [4653] = {.lex_state = 152, .external_lex_state = 22},
  [4654] = {.lex_state = 152, .external_lex_state = 22},
  [4655] = {.lex_state = 346},
  [4656] = {.lex_state = 346},
  [4657] = {.lex_state = 200, .external_lex_state = 16},
  [4658] = {.lex_state = 344, .external_lex_state = 19},
  [4659] = {.lex_state = 152, .external_lex_state = 22},
  [4660] = {.lex_state = 200, .external_lex_state = 16},
  [4661] = {.lex_state = 200, .external_lex_state = 16},
  [4662] = {.lex_state = 152, .external_lex_state = 22},
  [4663] = {.lex_state = 152, .external_lex_state = 22},
  [4664] = {.lex_state = 200, .external_lex_state = 16},
  [4665] = {.lex_state = 200, .external_lex_state = 16},
  [4666] = {.lex_state = 200},
  [4667] = {.lex_state = 200},
  [4668] = {.lex_state = 200},
  [4669] = {.lex_state = 200},
  [4670] = {.lex_state = 200},
  [4671] = {.lex_state = 152, .external_lex_state = 22},
  [4672] = {.lex_state = 152, .external_lex_state = 22},
  [4673] = {.lex_state = 199, .external_lex_state = 20},
  [4674] = {.lex_state = 152, .external_lex_state = 22},
  [4675] = {.lex_state = 206, .external_lex_state = 20},
  [4676] = {.lex_state = 199, .external_lex_state = 20},
  [4677] = {.lex_state = 199, .external_lex_state = 20},
  [4678] = {.lex_state = 200, .external_lex_state = 16},
  [4679] = {.lex_state = 199, .external_lex_state = 20},
  [4680] = {.lex_state = 199, .external_lex_state = 20},
  [4681] = {.lex_state = 199, .external_lex_state = 20},
  [4682] = {.lex_state = 199, .external_lex_state = 20},
  [4683] = {.lex_state = 199, .external_lex_state = 20},
  [4684] = {.lex_state = 199, .external_lex_state = 20},
  [4685] = {.lex_state = 200},
  [4686] = {.lex_state = 346},
  [4687] = {.lex_state = 346},
  [4688] = {.lex_state = 346},
  [4689] = {.lex_state = 152, .external_lex_state = 22},
  [4690] = {.lex_state = 200},
  [4691] = {.lex_state = 149},
  [4692] = {.lex_state = 152, .external_lex_state = 22},
  [4693] = {.lex_state = 199, .external_lex_state = 20},
  [4694] = {.lex_state = 199, .external_lex_state = 20},
  [4695] = {.lex_state = 206, .external_lex_state = 20},
  [4696] = {.lex_state = 206, .external_lex_state = 20},
  [4697] = {.lex_state = 206, .external_lex_state = 20},
  [4698] = {.lex_state = 199, .external_lex_state = 20},
  [4699] = {.lex_state = 152, .external_lex_state = 22},
  [4700] = {.lex_state = 206, .external_lex_state = 20},
  [4701] = {.lex_state = 344, .external_lex_state = 19},
  [4702] = {.lex_state = 152, .external_lex_state = 22},
  [4703] = {.lex_state = 152, .external_lex_state = 22},
  [4704] = {.lex_state = 152, .external_lex_state = 22},
  [4705] = {.lex_state = 152, .external_lex_state = 22},
  [4706] = {.lex_state = 206, .external_lex_state = 20},
  [4707] = {.lex_state = 152, .external_lex_state = 22},
  [4708] = {.lex_state = 200},
  [4709] = {.lex_state = 206, .external_lex_state = 20},
  [4710] = {.lex_state = 346},
  [4711] = {.lex_state = 193, .external_lex_state = 22},
  [4712] = {.lex_state = 193, .external_lex_state = 22},
  [4713] = {.lex_state = 206},
  [4714] = {.lex_state = 193, .external_lex_state = 22},
  [4715] = {.lex_state = 193, .external_lex_state = 22},
  [4716] = {.lex_state = 193, .external_lex_state = 22},
  [4717] = {.lex_state = 346},
  [4718] = {.lex_state = 149},
  [4719] = {.lex_state = 193, .external_lex_state = 22},
  [4720] = {.lex_state = 149},
  [4721] = {.lex_state = 344, .external_lex_state = 19},
  [4722] = {.lex_state = 206},
  [4723] = {.lex_state = 206},
  [4724] = {.lex_state = 193, .external_lex_state = 22},
  [4725] = {.lex_state = 346},
  [4726] = {.lex_state = 149},
  [4727] = {.lex_state = 149},
  [4728] = {.lex_state = 193, .external_lex_state = 22},
  [4729] = {.lex_state = 206},
  [4730] = {.lex_state = 346, .external_lex_state = 21},
  [4731] = {.lex_state = 149},
  [4732] = {.lex_state = 206},
  [4733] = {.lex_state = 206},
  [4734] = {.lex_state = 193, .external_lex_state = 22},
  [4735] = {.lex_state = 206},
  [4736] = {.lex_state = 149},
  [4737] = {.lex_state = 149},
  [4738] = {.lex_state = 206},
  [4739] = {.lex_state = 149},
  [4740] = {.lex_state = 193, .external_lex_state = 22},
  [4741] = {.lex_state = 206},
  [4742] = {.lex_state = 149},
  [4743] = {.lex_state = 149, .external_lex_state = 15},
  [4744] = {.lex_state = 149},
  [4745] = {.lex_state = 193, .external_lex_state = 22},
  [4746] = {.lex_state = 149},
  [4747] = {.lex_state = 193, .external_lex_state = 22},
  [4748] = {.lex_state = 346},
  [4749] = {.lex_state = 346, .external_lex_state = 21},
  [4750] = {.lex_state = 344, .external_lex_state = 16},
  [4751] = {.lex_state = 344, .external_lex_state = 16},
  [4752] = {.lex_state = 206},
  [4753] = {.lex_state = 346},
  [4754] = {.lex_state = 206},
  [4755] = {.lex_state = 193, .external_lex_state = 22},
  [4756] = {.lex_state = 193, .external_lex_state = 22},
  [4757] = {.lex_state = 193, .external_lex_state = 22},
  [4758] = {.lex_state = 193, .external_lex_state = 22},
  [4759] = {.lex_state = 193, .external_lex_state = 22},
  [4760] = {.lex_state = 344, .external_lex_state = 19},
  [4761] = {.lex_state = 193, .external_lex_state = 22},
  [4762] = {.lex_state = 346},
  [4763] = {.lex_state = 193, .external_lex_state = 22},
  [4764] = {.lex_state = 203, .external_lex_state = 15},
  [4765] = {.lex_state = 149},
  [4766] = {.lex_state = 193, .external_lex_state = 22},
  [4767] = {.lex_state = 193, .external_lex_state = 22},
  [4768] = {.lex_state = 193, .external_lex_state = 22},
  [4769] = {.lex_state = 346, .external_lex_state = 21},
  [4770] = {.lex_state = 193, .external_lex_state = 22},
  [4771] = {.lex_state = 346},
  [4772] = {.lex_state = 344, .external_lex_state = 19},
  [4773] = {.lex_state = 346, .external_lex_state = 21},
  [4774] = {.lex_state = 193, .external_lex_state = 22},
  [4775] = {.lex_state = 149},
  [4776] = {.lex_state = 149},
  [4777] = {.lex_state = 149},
  [4778] = {.lex_state = 149},
  [4779] = {.lex_state = 346},
  [4780] = {.lex_state = 149},
  [4781] = {.lex_state = 149},
  [4782] = {.lex_state = 203, .external_lex_state = 15},
  [4783] = {.lex_state = 149},
  [4784] = {.lex_state = 193, .external_lex_state = 22},
  [4785] = {.lex_state = 346},
  [4786] = {.lex_state = 346, .external_lex_state = 21},
  [4787] = {.lex_state = 193, .external_lex_state = 22},
  [4788] = {.lex_state = 193, .external_lex_state = 22},
  [4789] = {.lex_state = 346},
  [4790] = {.lex_state = 203, .external_lex_state = 15},
  [4791] = {.lex_state = 149},
  [4792] = {.lex_state = 193, .external_lex_state = 22},
  [4793] = {.lex_state = 344, .external_lex_state = 19},
  [4794] = {.lex_state = 149},
  [4795] = {.lex_state = 207},
  [4796] = {.lex_state = 206},
  [4797] = {.lex_state = 149},
  [4798] = {.lex_state = 149},
  [4799] = {.lex_state = 346},
  [4800] = {.lex_state = 344, .external_lex_state = 16},
  [4801] = {.lex_state = 344, .external_lex_state = 16},
  [4802] = {.lex_state = 149},
  [4803] = {.lex_state = 149},
  [4804] = {.lex_state = 193, .external_lex_state = 22},
  [4805] = {.lex_state = 346},
  [4806] = {.lex_state = 346, .external_lex_state = 21},
  [4807] = {.lex_state = 193, .external_lex_state = 22},
  [4808] = {.lex_state = 149},
  [4809] = {.lex_state = 193, .external_lex_state = 22},
  [4810] = {.lex_state = 207},
  [4811] = {.lex_state = 344, .external_lex_state = 16},
  [4812] = {.lex_state = 344, .external_lex_state = 16},
  [4813] = {.lex_state = 344, .external_lex_state = 16},
  [4814] = {.lex_state = 193, .external_lex_state = 22},
  [4815] = {.lex_state = 149},
  [4816] = {.lex_state = 346},
  [4817] = {.lex_state = 193, .external_lex_state = 22},
  [4818] = {.lex_state = 193, .external_lex_state = 22},
  [4819] = {.lex_state = 149},
  [4820] = {.lex_state = 149},
  [4821] = {.lex_state = 149},
  [4822] = {.lex_state = 149},
  [4823] = {.lex_state = 149},
  [4824] = {.lex_state = 149},
  [4825] = {.lex_state = 193, .external_lex_state = 22},
  [4826] = {.lex_state = 344, .external_lex_state = 16},
  [4827] = {.lex_state = 344, .external_lex_state = 16},
  [4828] = {.lex_state = 193, .external_lex_state = 22},
  [4829] = {.lex_state = 149},
  [4830] = {.lex_state = 344, .external_lex_state = 16},
  [4831] = {.lex_state = 344, .external_lex_state = 16},
  [4832] = {.lex_state = 149},
  [4833] = {.lex_state = 193, .external_lex_state = 22},
  [4834] = {.lex_state = 149},
  [4835] = {.lex_state = 149},
  [4836] = {.lex_state = 193, .external_lex_state = 22},
  [4837] = {.lex_state = 149},
  [4838] = {.lex_state = 193, .external_lex_state = 22},
  [4839] = {.lex_state = 149, .external_lex_state = 15},
  [4840] = {.lex_state = 149},
  [4841] = {.lex_state = 149},
  [4842] = {.lex_state = 193, .external_lex_state = 22},
  [4843] = {.lex_state = 346, .external_lex_state = 21},
  [4844] = {.lex_state = 149},
  [4845] = {.lex_state = 149},
  [4846] = {.lex_state = 149},
  [4847] = {.lex_state = 149},
  [4848] = {.lex_state = 149},
  [4849] = {.lex_state = 193, .external_lex_state = 22},
  [4850] = {.lex_state = 193, .external_lex_state = 22},
  [4851] = {.lex_state = 346, .external_lex_state = 21},
  [4852] = {.lex_state = 149},
  [4853] = {.lex_state = 149},
  [4854] = {.lex_state = 149},
  [4855] = {.lex_state = 193, .external_lex_state = 22},
  [4856] = {.lex_state = 193, .external_lex_state = 22},
  [4857] = {.lex_state = 149},
  [4858] = {.lex_state = 193, .external_lex_state = 22},
  [4859] = {.lex_state = 346},
  [4860] = {.lex_state = 346, .external_lex_state = 21},
  [4861] = {.lex_state = 344, .external_lex_state = 16},
  [4862] = {.lex_state = 149, .external_lex_state = 15},
  [4863] = {.lex_state = 344, .external_lex_state = 16},
  [4864] = {.lex_state = 185},
  [4865] = {.lex_state = 344, .external_lex_state = 16},
  [4866] = {.lex_state = 344, .external_lex_state = 16},
  [4867] = {.lex_state = 344, .external_lex_state = 16},
  [4868] = {.lex_state = 149, .external_lex_state = 16},
  [4869] = {.lex_state = 344, .external_lex_state = 16},
  [4870] = {.lex_state = 344, .external_lex_state = 16},
  [4871] = {.lex_state = 346},
  [4872] = {.lex_state = 344, .external_lex_state = 16},
  [4873] = {.lex_state = 149, .external_lex_state = 16},
  [4874] = {.lex_state = 149, .external_lex_state = 15},
  [4875] = {.lex_state = 344, .external_lex_state = 16},
  [4876] = {.lex_state = 346, .external_lex_state = 21},
  [4877] = {.lex_state = 346, .external_lex_state = 21},
  [4878] = {.lex_state = 344, .external_lex_state = 16},
  [4879] = {.lex_state = 346, .external_lex_state = 21},
  [4880] = {.lex_state = 344, .external_lex_state = 16},
  [4881] = {.lex_state = 344, .external_lex_state = 16},
  [4882] = {.lex_state = 185},
  [4883] = {.lex_state = 200, .external_lex_state = 15},
  [4884] = {.lex_state = 153, .external_lex_state = 22},
  [4885] = {.lex_state = 346, .external_lex_state = 21},
  [4886] = {.lex_state = 203, .external_lex_state = 15},
  [4887] = {.lex_state = 344, .external_lex_state = 16},
  [4888] = {.lex_state = 344, .external_lex_state = 16},
  [4889] = {.lex_state = 346, .external_lex_state = 21},
  [4890] = {.lex_state = 198},
  [4891] = {.lex_state = 344, .external_lex_state = 16},
  [4892] = {.lex_state = 344, .external_lex_state = 16},
  [4893] = {.lex_state = 149, .external_lex_state = 15},
  [4894] = {.lex_state = 344, .external_lex_state = 16},
  [4895] = {.lex_state = 344, .external_lex_state = 16},
  [4896] = {.lex_state = 200, .external_lex_state = 18},
  [4897] = {.lex_state = 203, .external_lex_state = 16},
  [4898] = {.lex_state = 344, .external_lex_state = 16},
  [4899] = {.lex_state = 346},
  [4900] = {.lex_state = 344, .external_lex_state = 16},
  [4901] = {.lex_state = 346},
  [4902] = {.lex_state = 344, .external_lex_state = 16},
  [4903] = {.lex_state = 344, .external_lex_state = 16},
  [4904] = {.lex_state = 346, .external_lex_state = 21},
  [4905] = {.lex_state = 346},
  [4906] = {.lex_state = 346},
  [4907] = {.lex_state = 346, .external_lex_state = 21},
  [4908] = {.lex_state = 344, .external_lex_state = 16},
  [4909] = {.lex_state = 346, .external_lex_state = 21},
  [4910] = {.lex_state = 344, .external_lex_state = 16},
  [4911] = {.lex_state = 344, .external_lex_state = 16},
  [4912] = {.lex_state = 200, .external_lex_state = 15},
  [4913] = {.lex_state = 346},
  [4914] = {.lex_state = 198},
  [4915] = {.lex_state = 346},
  [4916] = {.lex_state = 344, .external_lex_state = 16},
  [4917] = {.lex_state = 344, .external_lex_state = 16},
  [4918] = {.lex_state = 200, .external_lex_state = 15},
  [4919] = {.lex_state = 344, .external_lex_state = 16},
  [4920] = {.lex_state = 153, .external_lex_state = 22},
  [4921] = {.lex_state = 346},
  [4922] = {.lex_state = 346, .external_lex_state = 21},
  [4923] = {.lex_state = 346, .external_lex_state = 21},
  [4924] = {.lex_state = 200, .external_lex_state = 18},
  [4925] = {.lex_state = 203, .external_lex_state = 16},
  [4926] = {.lex_state = 344, .external_lex_state = 16},
  [4927] = {.lex_state = 346},
  [4928] = {.lex_state = 344, .external_lex_state = 16},
  [4929] = {.lex_state = 203, .external_lex_state = 16},
  [4930] = {.lex_state = 344, .external_lex_state = 16},
  [4931] = {.lex_state = 346},
  [4932] = {.lex_state = 346},
  [4933] = {.lex_state = 344, .external_lex_state = 16},
  [4934] = {.lex_state = 200, .external_lex_state = 18},
  [4935] = {.lex_state = 153, .external_lex_state = 22},
  [4936] = {.lex_state = 153, .external_lex_state = 22},
  [4937] = {.lex_state = 346},
  [4938] = {.lex_state = 344, .external_lex_state = 16},
  [4939] = {.lex_state = 346, .external_lex_state = 21},
  [4940] = {.lex_state = 153, .external_lex_state = 22},
  [4941] = {.lex_state = 344, .external_lex_state = 16},
  [4942] = {.lex_state = 346},
  [4943] = {.lex_state = 346},
  [4944] = {.lex_state = 346},
  [4945] = {.lex_state = 200, .external_lex_state = 16},
  [4946] = {.lex_state = 346, .external_lex_state = 20},
  [4947] = {.lex_state = 194, .external_lex_state = 22},
  [4948] = {.lex_state = 346},
  [4949] = {.lex_state = 346},
  [4950] = {.lex_state = 346},
  [4951] = {.lex_state = 194, .external_lex_state = 22},
  [4952] = {.lex_state = 200, .external_lex_state = 16},
  [4953] = {.lex_state = 149, .external_lex_state = 16},
  [4954] = {.lex_state = 198},
  [4955] = {.lex_state = 149, .external_lex_state = 16},
  [4956] = {.lex_state = 149, .external_lex_state = 16},
  [4957] = {.lex_state = 346},
  [4958] = {.lex_state = 194, .external_lex_state = 22},
  [4959] = {.lex_state = 346},
  [4960] = {.lex_state = 194, .external_lex_state = 22},
  [4961] = {.lex_state = 194, .external_lex_state = 22},
  [4962] = {.lex_state = 346},
  [4963] = {.lex_state = 346},
  [4964] = {.lex_state = 194, .external_lex_state = 22},
  [4965] = {.lex_state = 194, .external_lex_state = 22},
  [4966] = {.lex_state = 346},
  [4967] = {.lex_state = 346},
  [4968] = {.lex_state = 194, .external_lex_state = 22},
  [4969] = {.lex_state = 194, .external_lex_state = 22},
  [4970] = {.lex_state = 194, .external_lex_state = 22},
  [4971] = {.lex_state = 346},
  [4972] = {.lex_state = 185},
  [4973] = {.lex_state = 346},
  [4974] = {.lex_state = 346},
  [4975] = {.lex_state = 346},
  [4976] = {.lex_state = 346},
  [4977] = {.lex_state = 346},
  [4978] = {.lex_state = 346},
  [4979] = {.lex_state = 346},
  [4980] = {.lex_state = 194, .external_lex_state = 22},
  [4981] = {.lex_state = 203, .external_lex_state = 16},
  [4982] = {.lex_state = 194, .external_lex_state = 22},
  [4983] = {.lex_state = 346},
  [4984] = {.lex_state = 346},
  [4985] = {.lex_state = 346},
  [4986] = {.lex_state = 346},
  [4987] = {.lex_state = 200, .external_lex_state = 19},
  [4988] = {.lex_state = 344},
  [4989] = {.lex_state = 194, .external_lex_state = 22},
  [4990] = {.lex_state = 346},
  [4991] = {.lex_state = 346},
  [4992] = {.lex_state = 200, .external_lex_state = 19},
  [4993] = {.lex_state = 346},
  [4994] = {.lex_state = 194, .external_lex_state = 22},
  [4995] = {.lex_state = 346},
  [4996] = {.lex_state = 344},
  [4997] = {.lex_state = 346},
  [4998] = {.lex_state = 200, .external_lex_state = 19},
  [4999] = {.lex_state = 346},
  [5000] = {.lex_state = 194, .external_lex_state = 22},
  [5001] = {.lex_state = 194, .external_lex_state = 22},
  [5002] = {.lex_state = 346},
  [5003] = {.lex_state = 346, .external_lex_state = 20},
  [5004] = {.lex_state = 200, .external_lex_state = 20},
  [5005] = {.lex_state = 346, .external_lex_state = 16},
  [5006] = {.lex_state = 346},
  [5007] = {.lex_state = 346, .external_lex_state = 20},
  [5008] = {.lex_state = 346},
  [5009] = {.lex_state = 194, .external_lex_state = 22},
  [5010] = {.lex_state = 346},
  [5011] = {.lex_state = 194, .external_lex_state = 22},
  [5012] = {.lex_state = 346},
  [5013] = {.lex_state = 194, .external_lex_state = 22},
  [5014] = {.lex_state = 194, .external_lex_state = 22},
  [5015] = {.lex_state = 149},
  [5016] = {.lex_state = 346, .external_lex_state = 20},
  [5017] = {.lex_state = 346},
  [5018] = {.lex_state = 200, .external_lex_state = 20},
  [5019] = {.lex_state = 200, .external_lex_state = 20},
  [5020] = {.lex_state = 346},
  [5021] = {.lex_state = 346, .external_lex_state = 20},
  [5022] = {.lex_state = 200, .external_lex_state = 16},
  [5023] = {.lex_state = 344},
  [5024] = {.lex_state = 194, .external_lex_state = 22},
  [5025] = {.lex_state = 346},
  [5026] = {.lex_state = 194, .external_lex_state = 22},
  [5027] = {.lex_state = 149},
  [5028] = {.lex_state = 194, .external_lex_state = 22},
  [5029] = {.lex_state = 149, .external_lex_state = 16},
  [5030] = {.lex_state = 346, .external_lex_state = 20},
  [5031] = {.lex_state = 200, .external_lex_state = 15},
  [5032] = {.lex_state = 194, .external_lex_state = 22},
  [5033] = {.lex_state = 149},
  [5034] = {.lex_state = 346},
  [5035] = {.lex_state = 194, .external_lex_state = 22},
  [5036] = {.lex_state = 194, .external_lex_state = 22},
  [5037] = {.lex_state = 346, .external_lex_state = 20},
  [5038] = {.lex_state = 200, .external_lex_state = 15},
  [5039] = {.lex_state = 346, .external_lex_state = 20},
  [5040] = {.lex_state = 194, .external_lex_state = 22},
  [5041] = {.lex_state = 199, .external_lex_state = 20},
  [5042] = {.lex_state = 346},
  [5043] = {.lex_state = 346, .external_lex_state = 20},
  [5044] = {.lex_state = 346},
  [5045] = {.lex_state = 346},
  [5046] = {.lex_state = 198},
  [5047] = {.lex_state = 199, .external_lex_state = 20},
  [5048] = {.lex_state = 344},
  [5049] = {.lex_state = 194, .external_lex_state = 22},
  [5050] = {.lex_state = 194, .external_lex_state = 22},
  [5051] = {.lex_state = 194, .external_lex_state = 22},
  [5052] = {.lex_state = 200, .external_lex_state = 18},
  [5053] = {.lex_state = 346},
  [5054] = {.lex_state = 200, .external_lex_state = 18},
  [5055] = {.lex_state = 200, .external_lex_state = 20},
  [5056] = {.lex_state = 200, .external_lex_state = 18},
  [5057] = {.lex_state = 200, .external_lex_state = 18},
  [5058] = {.lex_state = 200, .external_lex_state = 18},
  [5059] = {.lex_state = 200, .external_lex_state = 18},
  [5060] = {.lex_state = 194, .external_lex_state = 22},
  [5061] = {.lex_state = 344},
  [5062] = {.lex_state = 200, .external_lex_state = 18},
  [5063] = {.lex_state = 194, .external_lex_state = 22},
  [5064] = {.lex_state = 194, .external_lex_state = 22},
  [5065] = {.lex_state = 346},
  [5066] = {.lex_state = 346, .external_lex_state = 16},
  [5067] = {.lex_state = 194, .external_lex_state = 22},
  [5068] = {.lex_state = 198},
  [5069] = {.lex_state = 185},
  [5070] = {.lex_state = 194, .external_lex_state = 22},
  [5071] = {.lex_state = 194, .external_lex_state = 22},
  [5072] = {.lex_state = 198},
  [5073] = {.lex_state = 194, .external_lex_state = 22},
  [5074] = {.lex_state = 346},
  [5075] = {.lex_state = 199, .external_lex_state = 20},
  [5076] = {.lex_state = 346},
  [5077] = {.lex_state = 344},
  [5078] = {.lex_state = 149},
  [5079] = {.lex_state = 194, .external_lex_state = 22},
  [5080] = {.lex_state = 149, .external_lex_state = 15},
  [5081] = {.lex_state = 194, .external_lex_state = 22},
  [5082] = {.lex_state = 149},
  [5083] = {.lex_state = 149, .external_lex_state = 15},
  [5084] = {.lex_state = 149},
  [5085] = {.lex_state = 149},
  [5086] = {.lex_state = 149, .external_lex_state = 15},
  [5087] = {.lex_state = 149},
  [5088] = {.lex_state = 149},
  [5089] = {.lex_state = 149, .external_lex_state = 15},
  [5090] = {.lex_state = 344},
  [5091] = {.lex_state = 149, .external_lex_state = 15},
  [5092] = {.lex_state = 344},
  [5093] = {.lex_state = 344},
  [5094] = {.lex_state = 149},
  [5095] = {.lex_state = 344},
  [5096] = {.lex_state = 194, .external_lex_state = 22},
  [5097] = {.lex_state = 344},
  [5098] = {.lex_state = 344},
  [5099] = {.lex_state = 344},
  [5100] = {.lex_state = 344},
  [5101] = {.lex_state = 346},
  [5102] = {.lex_state = 344},
  [5103] = {.lex_state = 344, .external_lex_state = 21},
  [5104] = {.lex_state = 344},
  [5105] = {.lex_state = 344},
  [5106] = {.lex_state = 344},
  [5107] = {.lex_state = 346},
  [5108] = {.lex_state = 149},
  [5109] = {.lex_state = 346},
  [5110] = {.lex_state = 346},
  [5111] = {.lex_state = 344},
  [5112] = {.lex_state = 194, .external_lex_state = 22},
  [5113] = {.lex_state = 344},
  [5114] = {.lex_state = 346},
  [5115] = {.lex_state = 344},
  [5116] = {.lex_state = 344},
  [5117] = {.lex_state = 198},
  [5118] = {.lex_state = 346},
  [5119] = {.lex_state = 344},
  [5120] = {.lex_state = 344},
  [5121] = {.lex_state = 346},
  [5122] = {.lex_state = 346},
  [5123] = {.lex_state = 346},
  [5124] = {.lex_state = 194, .external_lex_state = 22},
  [5125] = {.lex_state = 344},
  [5126] = {.lex_state = 344},
  [5127] = {.lex_state = 344},
  [5128] = {.lex_state = 346},
  [5129] = {.lex_state = 344},
  [5130] = {.lex_state = 344},
  [5131] = {.lex_state = 198},
  [5132] = {.lex_state = 346, .external_lex_state = 16},
  [5133] = {.lex_state = 344},
  [5134] = {.lex_state = 200, .external_lex_state = 20},
  [5135] = {.lex_state = 344},
  [5136] = {.lex_state = 200, .external_lex_state = 20},
  [5137] = {.lex_state = 346},
  [5138] = {.lex_state = 344},
  [5139] = {.lex_state = 344},
  [5140] = {.lex_state = 344},
  [5141] = {.lex_state = 346},
  [5142] = {.lex_state = 344},
  [5143] = {.lex_state = 344},
  [5144] = {.lex_state = 344},
  [5145] = {.lex_state = 344},
  [5146] = {.lex_state = 344},
  [5147] = {.lex_state = 198},
  [5148] = {.lex_state = 346},
  [5149] = {.lex_state = 198},
  [5150] = {.lex_state = 346},
  [5151] = {.lex_state = 344},
  [5152] = {.lex_state = 149, .external_lex_state = 16},
  [5153] = {.lex_state = 149, .external_lex_state = 15},
  [5154] = {.lex_state = 149, .external_lex_state = 15},
  [5155] = {.lex_state = 346},
  [5156] = {.lex_state = 149, .external_lex_state = 15},
  [5157] = {.lex_state = 198},
  [5158] = {.lex_state = 344},
  [5159] = {.lex_state = 149, .external_lex_state = 15},
  [5160] = {.lex_state = 346},
  [5161] = {.lex_state = 346},
  [5162] = {.lex_state = 194, .external_lex_state = 22},
  [5163] = {.lex_state = 149, .external_lex_state = 15},
  [5164] = {.lex_state = 198},
  [5165] = {.lex_state = 344},
  [5166] = {.lex_state = 194, .external_lex_state = 22},
  [5167] = {.lex_state = 344},
  [5168] = {.lex_state = 149},
  [5169] = {.lex_state = 344},
  [5170] = {.lex_state = 346, .external_lex_state = 16},
  [5171] = {.lex_state = 346},
  [5172] = {.lex_state = 344, .external_lex_state = 21},
  [5173] = {.lex_state = 194, .external_lex_state = 22},
  [5174] = {.lex_state = 346},
  [5175] = {.lex_state = 346},
  [5176] = {.lex_state = 149, .external_lex_state = 15},
  [5177] = {.lex_state = 149},
  [5178] = {.lex_state = 152, .external_lex_state = 22},
  [5179] = {.lex_state = 185},
  [5180] = {.lex_state = 200, .external_lex_state = 16},
  [5181] = {.lex_state = 346},
  [5182] = {.lex_state = 346, .external_lex_state = 20},
  [5183] = {.lex_state = 149},
  [5184] = {.lex_state = 149, .external_lex_state = 15},
  [5185] = {.lex_state = 346},
  [5186] = {.lex_state = 344},
  [5187] = {.lex_state = 149, .external_lex_state = 15},
  [5188] = {.lex_state = 346},
  [5189] = {.lex_state = 346},
  [5190] = {.lex_state = 200, .external_lex_state = 16},
  [5191] = {.lex_state = 149, .external_lex_state = 15},
  [5192] = {.lex_state = 344, .external_lex_state = 21},
  [5193] = {.lex_state = 346},
  [5194] = {.lex_state = 346},
  [5195] = {.lex_state = 152, .external_lex_state = 22},
  [5196] = {.lex_state = 149},
  [5197] = {.lex_state = 346},
  [5198] = {.lex_state = 152, .external_lex_state = 22},
  [5199] = {.lex_state = 346, .external_lex_state = 20},
  [5200] = {.lex_state = 193, .external_lex_state = 22},
  [5201] = {.lex_state = 346},
  [5202] = {.lex_state = 346},
  [5203] = {.lex_state = 149, .external_lex_state = 15},
  [5204] = {.lex_state = 346},
  [5205] = {.lex_state = 346},
  [5206] = {.lex_state = 196, .external_lex_state = 22},
  [5207] = {.lex_state = 149, .external_lex_state = 15},
  [5208] = {.lex_state = 149, .external_lex_state = 15},
  [5209] = {.lex_state = 346},
  [5210] = {.lex_state = 346},
  [5211] = {.lex_state = 346},
  [5212] = {.lex_state = 149},
  [5213] = {.lex_state = 149},
  [5214] = {.lex_state = 346},
  [5215] = {.lex_state = 149, .external_lex_state = 15},
  [5216] = {.lex_state = 149, .external_lex_state = 15},
  [5217] = {.lex_state = 346},
  [5218] = {.lex_state = 346},
  [5219] = {.lex_state = 346},
  [5220] = {.lex_state = 149},
  [5221] = {.lex_state = 149},
  [5222] = {.lex_state = 346},
  [5223] = {.lex_state = 346},
  [5224] = {.lex_state = 346},
  [5225] = {.lex_state = 346},
  [5226] = {.lex_state = 346},
  [5227] = {.lex_state = 346},
  [5228] = {.lex_state = 346},
  [5229] = {.lex_state = 346},
  [5230] = {.lex_state = 206, .external_lex_state = 20},
  [5231] = {.lex_state = 346},
  [5232] = {.lex_state = 206, .external_lex_state = 20},
  [5233] = {.lex_state = 346},
  [5234] = {.lex_state = 346},
  [5235] = {.lex_state = 346},
  [5236] = {.lex_state = 149},
  [5237] = {.lex_state = 149},
  [5238] = {.lex_state = 346},
  [5239] = {.lex_state = 344},
  [5240] = {.lex_state = 346},
  [5241] = {.lex_state = 149, .external_lex_state = 15},
  [5242] = {.lex_state = 346},
  [5243] = {.lex_state = 346},
  [5244] = {.lex_state = 149, .external_lex_state = 15},
  [5245] = {.lex_state = 346},
  [5246] = {.lex_state = 346},
  [5247] = {.lex_state = 346},
  [5248] = {.lex_state = 149, .external_lex_state = 16},
  [5249] = {.lex_state = 346},
  [5250] = {.lex_state = 346},
  [5251] = {.lex_state = 149, .external_lex_state = 15},
  [5252] = {.lex_state = 346},
  [5253] = {.lex_state = 346},
  [5254] = {.lex_state = 346},
  [5255] = {.lex_state = 346},
  [5256] = {.lex_state = 149},
  [5257] = {.lex_state = 149},
  [5258] = {.lex_state = 149},
  [5259] = {.lex_state = 149, .external_lex_state = 15},
  [5260] = {.lex_state = 346},
  [5261] = {.lex_state = 346},
  [5262] = {.lex_state = 346},
  [5263] = {.lex_state = 149, .external_lex_state = 15},
  [5264] = {.lex_state = 346},
  [5265] = {.lex_state = 346},
  [5266] = {.lex_state = 346},
  [5267] = {.lex_state = 149},
  [5268] = {.lex_state = 346},
  [5269] = {.lex_state = 149},
  [5270] = {.lex_state = 149, .external_lex_state = 15},
  [5271] = {.lex_state = 149, .external_lex_state = 15},
  [5272] = {.lex_state = 149, .external_lex_state = 15},
  [5273] = {.lex_state = 149, .external_lex_state = 15},
  [5274] = {.lex_state = 149},
  [5275] = {.lex_state = 344},
  [5276] = {.lex_state = 149, .external_lex_state = 15},
  [5277] = {.lex_state = 346},
  [5278] = {.lex_state = 149, .external_lex_state = 15},
  [5279] = {.lex_state = 198},
  [5280] = {.lex_state = 346},
  [5281] = {.lex_state = 149, .external_lex_state = 15},
  [5282] = {.lex_state = 149},
  [5283] = {.lex_state = 149},
  [5284] = {.lex_state = 149, .external_lex_state = 15},
  [5285] = {.lex_state = 149, .external_lex_state = 15},
  [5286] = {.lex_state = 346},
  [5287] = {.lex_state = 149, .external_lex_state = 15},
  [5288] = {.lex_state = 149, .external_lex_state = 15},
  [5289] = {.lex_state = 149, .external_lex_state = 15},
  [5290] = {.lex_state = 149, .external_lex_state = 15},
  [5291] = {.lex_state = 346},
  [5292] = {.lex_state = 149, .external_lex_state = 15},
  [5293] = {.lex_state = 149, .external_lex_state = 15},
  [5294] = {.lex_state = 149, .external_lex_state = 15},
  [5295] = {.lex_state = 149, .external_lex_state = 15},
  [5296] = {.lex_state = 149, .external_lex_state = 15},
  [5297] = {.lex_state = 346},
  [5298] = {.lex_state = 149, .external_lex_state = 15},
  [5299] = {.lex_state = 346},
  [5300] = {.lex_state = 346},
  [5301] = {.lex_state = 346},
  [5302] = {.lex_state = 149},
  [5303] = {.lex_state = 149, .external_lex_state = 16},
  [5304] = {.lex_state = 346},
  [5305] = {.lex_state = 149, .external_lex_state = 15},
  [5306] = {.lex_state = 149, .external_lex_state = 16},
  [5307] = {.lex_state = 346, .external_lex_state = 20},
  [5308] = {.lex_state = 149, .external_lex_state = 15},
  [5309] = {.lex_state = 185},
  [5310] = {.lex_state = 346},
  [5311] = {.lex_state = 149},
  [5312] = {.lex_state = 149, .external_lex_state = 15},
  [5313] = {.lex_state = 346},
  [5314] = {.lex_state = 346},
  [5315] = {.lex_state = 149, .external_lex_state = 16},
  [5316] = {.lex_state = 149, .external_lex_state = 15},
  [5317] = {.lex_state = 346},
  [5318] = {.lex_state = 196, .external_lex_state = 22},
  [5319] = {.lex_state = 346},
  [5320] = {.lex_state = 346},
  [5321] = {.lex_state = 346},
  [5322] = {.lex_state = 344, .external_lex_state = 21},
  [5323] = {.lex_state = 149},
  [5324] = {.lex_state = 198},
  [5325] = {.lex_state = 346},
  [5326] = {.lex_state = 200, .external_lex_state = 19},
  [5327] = {.lex_state = 346},
  [5328] = {.lex_state = 185},
  [5329] = {.lex_state = 149, .external_lex_state = 15},
  [5330] = {.lex_state = 200, .external_lex_state = 19},
  [5331] = {.lex_state = 346},
  [5332] = {.lex_state = 149, .external_lex_state = 15},
  [5333] = {.lex_state = 346},
  [5334] = {.lex_state = 200, .external_lex_state = 19},
  [5335] = {.lex_state = 200, .external_lex_state = 19},
  [5336] = {.lex_state = 200, .external_lex_state = 19},
  [5337] = {.lex_state = 200, .external_lex_state = 19},
  [5338] = {.lex_state = 346},
  [5339] = {.lex_state = 152, .external_lex_state = 22},
  [5340] = {.lex_state = 344, .external_lex_state = 21},
  [5341] = {.lex_state = 149, .external_lex_state = 15},
  [5342] = {.lex_state = 200, .external_lex_state = 19},
  [5343] = {.lex_state = 149, .external_lex_state = 15},
  [5344] = {.lex_state = 149, .external_lex_state = 15},
  [5345] = {.lex_state = 346},
  [5346] = {.lex_state = 346},
  [5347] = {.lex_state = 149, .external_lex_state = 15},
  [5348] = {.lex_state = 346},
  [5349] = {.lex_state = 149, .external_lex_state = 15},
  [5350] = {.lex_state = 149, .external_lex_state = 15},
  [5351] = {.lex_state = 346, .external_lex_state = 20},
  [5352] = {.lex_state = 198},
  [5353] = {.lex_state = 346},
  [5354] = {.lex_state = 346},
  [5355] = {.lex_state = 346},
  [5356] = {.lex_state = 346},
  [5357] = {.lex_state = 206, .external_lex_state = 20},
  [5358] = {.lex_state = 346, .external_lex_state = 20},
  [5359] = {.lex_state = 149, .external_lex_state = 15},
  [5360] = {.lex_state = 346},
  [5361] = {.lex_state = 346},
  [5362] = {.lex_state = 346},
  [5363] = {.lex_state = 198},
  [5364] = {.lex_state = 149, .external_lex_state = 15},
  [5365] = {.lex_state = 346},
  [5366] = {.lex_state = 149, .external_lex_state = 15},
  [5367] = {.lex_state = 346},
  [5368] = {.lex_state = 346},
  [5369] = {.lex_state = 346},
  [5370] = {.lex_state = 149, .external_lex_state = 15},
  [5371] = {.lex_state = 149, .external_lex_state = 15},
  [5372] = {.lex_state = 196, .external_lex_state = 22},
  [5373] = {.lex_state = 149, .external_lex_state = 15},
  [5374] = {.lex_state = 193, .external_lex_state = 22},
  [5375] = {.lex_state = 193, .external_lex_state = 22},
  [5376] = {.lex_state = 346},
  [5377] = {.lex_state = 149, .external_lex_state = 15},
  [5378] = {.lex_state = 346},
  [5379] = {.lex_state = 346},
  [5380] = {.lex_state = 149, .external_lex_state = 16},
  [5381] = {.lex_state = 346},
  [5382] = {.lex_state = 346},
  [5383] = {.lex_state = 149, .external_lex_state = 16},
  [5384] = {.lex_state = 346},
  [5385] = {.lex_state = 346},
  [5386] = {.lex_state = 149, .external_lex_state = 16},
  [5387] = {.lex_state = 149, .external_lex_state = 16},
  [5388] = {.lex_state = 346},
  [5389] = {.lex_state = 149, .external_lex_state = 15},
  [5390] = {.lex_state = 346},
  [5391] = {.lex_state = 346},
  [5392] = {.lex_state = 346},
  [5393] = {.lex_state = 149, .external_lex_state = 15},
  [5394] = {.lex_state = 149, .external_lex_state = 16},
  [5395] = {.lex_state = 346},
  [5396] = {.lex_state = 149, .external_lex_state = 15},
  [5397] = {.lex_state = 149, .external_lex_state = 15},
  [5398] = {.lex_state = 149, .external_lex_state = 15},
  [5399] = {.lex_state = 346},
  [5400] = {.lex_state = 346},
  [5401] = {.lex_state = 346},
  [5402] = {.lex_state = 346},
  [5403] = {.lex_state = 346},
  [5404] = {.lex_state = 149},
  [5405] = {.lex_state = 185},
  [5406] = {.lex_state = 346},
  [5407] = {.lex_state = 346},
  [5408] = {.lex_state = 149, .external_lex_state = 15},
  [5409] = {.lex_state = 346},
  [5410] = {.lex_state = 346},
  [5411] = {.lex_state = 149, .external_lex_state = 16},
  [5412] = {.lex_state = 346},
  [5413] = {.lex_state = 149, .external_lex_state = 15},
  [5414] = {.lex_state = 149, .external_lex_state = 15},
  [5415] = {.lex_state = 149, .external_lex_state = 16},
  [5416] = {.lex_state = 346},
  [5417] = {.lex_state = 346},
  [5418] = {.lex_state = 344},
  [5419] = {.lex_state = 149},
  [5420] = {.lex_state = 346},
  [5421] = {.lex_state = 344},
  [5422] = {.lex_state = 149, .external_lex_state = 16},
  [5423] = {.lex_state = 149, .external_lex_state = 16},
  [5424] = {.lex_state = 149},
  [5425] = {.lex_state = 149},
  [5426] = {.lex_state = 149},
  [5427] = {.lex_state = 346, .external_lex_state = 20},
  [5428] = {.lex_state = 149},
  [5429] = {.lex_state = 149, .external_lex_state = 16},
  [5430] = {.lex_state = 346},
  [5431] = {.lex_state = 149, .external_lex_state = 16},
  [5432] = {.lex_state = 149},
  [5433] = {.lex_state = 346},
  [5434] = {.lex_state = 149, .external_lex_state = 16},
  [5435] = {.lex_state = 149},
  [5436] = {.lex_state = 149, .external_lex_state = 16},
  [5437] = {.lex_state = 149},
  [5438] = {.lex_state = 149},
  [5439] = {.lex_state = 149},
  [5440] = {.lex_state = 149},
  [5441] = {.lex_state = 149},
  [5442] = {.lex_state = 149},
  [5443] = {.lex_state = 149},
  [5444] = {.lex_state = 149},
  [5445] = {.lex_state = 346, .external_lex_state = 20},
  [5446] = {.lex_state = 149, .external_lex_state = 16},
  [5447] = {.lex_state = 149, .external_lex_state = 16},
  [5448] = {.lex_state = 149, .external_lex_state = 16},
  [5449] = {.lex_state = 149},
  [5450] = {.lex_state = 149, .external_lex_state = 16},
  [5451] = {.lex_state = 149},
  [5452] = {.lex_state = 149, .external_lex_state = 16},
  [5453] = {.lex_state = 149},
  [5454] = {.lex_state = 346, .external_lex_state = 20},
  [5455] = {.lex_state = 149},
  [5456] = {.lex_state = 149},
  [5457] = {.lex_state = 149},
  [5458] = {.lex_state = 149},
  [5459] = {.lex_state = 149},
  [5460] = {.lex_state = 149, .external_lex_state = 16},
  [5461] = {.lex_state = 149},
  [5462] = {.lex_state = 346, .external_lex_state = 20},
  [5463] = {.lex_state = 149},
  [5464] = {.lex_state = 149},
  [5465] = {.lex_state = 149, .external_lex_state = 16},
  [5466] = {.lex_state = 346, .external_lex_state = 20},
  [5467] = {.lex_state = 149, .external_lex_state = 16},
  [5468] = {.lex_state = 149, .external_lex_state = 16},
  [5469] = {.lex_state = 149, .external_lex_state = 16},
  [5470] = {.lex_state = 346},
  [5471] = {.lex_state = 149, .external_lex_state = 16},
  [5472] = {.lex_state = 149, .external_lex_state = 16},
  [5473] = {.lex_state = 149, .external_lex_state = 16},
  [5474] = {.lex_state = 149, .external_lex_state = 16},
  [5475] = {.lex_state = 149, .external_lex_state = 16},
  [5476] = {.lex_state = 149, .external_lex_state = 16},
  [5477] = {.lex_state = 149, .external_lex_state = 16},
  [5478] = {.lex_state = 149, .external_lex_state = 16},
  [5479] = {.lex_state = 149},
  [5480] = {.lex_state = 149, .external_lex_state = 16},
  [5481] = {.lex_state = 149, .external_lex_state = 16},
  [5482] = {.lex_state = 149},
  [5483] = {.lex_state = 149, .external_lex_state = 16},
  [5484] = {.lex_state = 149, .external_lex_state = 16},
  [5485] = {.lex_state = 149, .external_lex_state = 16},
  [5486] = {.lex_state = 149, .external_lex_state = 16},
  [5487] = {.lex_state = 149, .external_lex_state = 16},
  [5488] = {.lex_state = 149, .external_lex_state = 16},
  [5489] = {.lex_state = 149, .external_lex_state = 16},
  [5490] = {.lex_state = 149, .external_lex_state = 16},
  [5491] = {.lex_state = 149, .external_lex_state = 16},
  [5492] = {.lex_state = 149, .external_lex_state = 16},
  [5493] = {.lex_state = 149, .external_lex_state = 16},
  [5494] = {.lex_state = 149, .external_lex_state = 16},
  [5495] = {.lex_state = 149, .external_lex_state = 16},
  [5496] = {.lex_state = 149, .external_lex_state = 16},
  [5497] = {.lex_state = 149, .external_lex_state = 16},
  [5498] = {.lex_state = 149, .external_lex_state = 16},
  [5499] = {.lex_state = 149, .external_lex_state = 16},
  [5500] = {.lex_state = 149, .external_lex_state = 16},
  [5501] = {.lex_state = 149, .external_lex_state = 16},
  [5502] = {.lex_state = 346},
  [5503] = {.lex_state = 149, .external_lex_state = 16},
  [5504] = {.lex_state = 149, .external_lex_state = 16},
  [5505] = {.lex_state = 153, .external_lex_state = 22},
  [5506] = {.lex_state = 149},
  [5507] = {.lex_state = 149, .external_lex_state = 16},
  [5508] = {.lex_state = 149},
  [5509] = {.lex_state = 149, .external_lex_state = 16},
  [5510] = {.lex_state = 153, .external_lex_state = 22},
  [5511] = {.lex_state = 153, .external_lex_state = 22},
  [5512] = {.lex_state = 346, .external_lex_state = 20},
  [5513] = {.lex_state = 346},
  [5514] = {.lex_state = 185},
  [5515] = {.lex_state = 346},
  [5516] = {.lex_state = 198},
  [5517] = {.lex_state = 346},
  [5518] = {.lex_state = 185},
  [5519] = {.lex_state = 346},
  [5520] = {.lex_state = 346, .external_lex_state = 20},
  [5521] = {.lex_state = 346, .external_lex_state = 20},
  [5522] = {.lex_state = 198},
  [5523] = {.lex_state = 346},
  [5524] = {.lex_state = 346},
  [5525] = {.lex_state = 346},
  [5526] = {.lex_state = 346},
  [5527] = {.lex_state = 346},
  [5528] = {.lex_state = 185},
  [5529] = {.lex_state = 346},
  [5530] = {.lex_state = 194, .external_lex_state = 22},
  [5531] = {.lex_state = 346},
  [5532] = {.lex_state = 185},
  [5533] = {.lex_state = 346, .external_lex_state = 20},
  [5534] = {.lex_state = 346, .external_lex_state = 20},
  [5535] = {.lex_state = 185},
  [5536] = {.lex_state = 346, .external_lex_state = 20},
  [5537] = {.lex_state = 346},
  [5538] = {.lex_state = 185},
  [5539] = {.lex_state = 185},
  [5540] = {.lex_state = 185},
  [5541] = {.lex_state = 185},
  [5542] = {.lex_state = 185},
  [5543] = {.lex_state = 346},
  [5544] = {.lex_state = 346},
  [5545] = {.lex_state = 346, .external_lex_state = 20},
  [5546] = {.lex_state = 346},
  [5547] = {.lex_state = 346},
  [5548] = {.lex_state = 185},
  [5549] = {.lex_state = 346},
  [5550] = {.lex_state = 346},
  [5551] = {.lex_state = 346},
  [5552] = {.lex_state = 346},
  [5553] = {.lex_state = 346},
  [5554] = {.lex_state = 185},
  [5555] = {.lex_state = 185},
  [5556] = {.lex_state = 185},
  [5557] = {.lex_state = 346, .external_lex_state = 20},
  [5558] = {.lex_state = 346, .external_lex_state = 20},
  [5559] = {.lex_state = 346},
  [5560] = {.lex_state = 185},
  [5561] = {.lex_state = 185},
  [5562] = {.lex_state = 346},
  [5563] = {.lex_state = 346},
  [5564] = {.lex_state = 194, .external_lex_state = 22},
  [5565] = {.lex_state = 346, .external_lex_state = 20},
  [5566] = {.lex_state = 346, .external_lex_state = 20},
  [5567] = {.lex_state = 185},
  [5568] = {.lex_state = 194, .external_lex_state = 22},
  [5569] = {.lex_state = 346, .external_lex_state = 20},
  [5570] = {.lex_state = 207},
  [5571] = {.lex_state = 185},
  [5572] = {.lex_state = 196, .external_lex_state = 22},
  [5573] = {.lex_state = 207},
  [5574] = {.lex_state = 196, .external_lex_state = 22},
  [5575] = {.lex_state = 196, .external_lex_state = 22},
  [5576] = {.lex_state = 185},
  [5577] = {.lex_state = 149},
  [5578] = {.lex_state = 149},
  [5579] = {.lex_state = 149},
  [5580] = {.lex_state = 185},
  [5581] = {.lex_state = 149},
  [5582] = {.lex_state = 149},
  [5583] = {.lex_state = 149},
  [5584] = {.lex_state = 346},
  [5585] = {.lex_state = 149},
  [5586] = {.lex_state = 346},
  [5587] = {.lex_state = 149},
  [5588] = {.lex_state = 185},
  [5589] = {.lex_state = 149},
  [5590] = {.lex_state = 185},
  [5591] = {.lex_state = 149},
  [5592] = {.lex_state = 149, .external_lex_state = 23},
  [5593] = {.lex_state = 185},
  [5594] = {.lex_state = 149},
  [5595] = {.lex_state = 149},
  [5596] = {.lex_state = 149},
  [5597] = {.lex_state = 149},
  [5598] = {.lex_state = 149},
  [5599] = {.lex_state = 344},
  [5600] = {.lex_state = 149},
  [5601] = {.lex_state = 185},
  [5602] = {.lex_state = 149},
  [5603] = {.lex_state = 149},
  [5604] = {.lex_state = 149},
  [5605] = {.lex_state = 149},
  [5606] = {.lex_state = 149},
  [5607] = {.lex_state = 346},
  [5608] = {.lex_state = 346},
  [5609] = {.lex_state = 149},
  [5610] = {.lex_state = 149},
  [5611] = {.lex_state = 346},
  [5612] = {.lex_state = 149},
  [5613] = {.lex_state = 344},
  [5614] = {.lex_state = 149},
  [5615] = {.lex_state = 185},
  [5616] = {.lex_state = 149},
  [5617] = {.lex_state = 185},
  [5618] = {.lex_state = 149},
  [5619] = {.lex_state = 149},
  [5620] = {.lex_state = 149},
  [5621] = {.lex_state = 149},
  [5622] = {.lex_state = 149},
  [5623] = {.lex_state = 149},
  [5624] = {.lex_state = 149},
  [5625] = {.lex_state = 149},
  [5626] = {.lex_state = 346},
  [5627] = {.lex_state = 149},
  [5628] = {.lex_state = 149},
  [5629] = {.lex_state = 149},
  [5630] = {.lex_state = 185},
  [5631] = {.lex_state = 149},
  [5632] = {.lex_state = 149},
  [5633] = {.lex_state = 149},
  [5634] = {.lex_state = 149},
  [5635] = {.lex_state = 346},
  [5636] = {.lex_state = 149},
  [5637] = {.lex_state = 149},
  [5638] = {.lex_state = 149},
  [5639] = {.lex_state = 346},
  [5640] = {.lex_state = 149},
  [5641] = {.lex_state = 149},
  [5642] = {.lex_state = 149},
  [5643] = {.lex_state = 149},
  [5644] = {.lex_state = 149},
  [5645] = {.lex_state = 185},
  [5646] = {.lex_state = 149},
  [5647] = {.lex_state = 149},
  [5648] = {.lex_state = 149},
  [5649] = {.lex_state = 185},
  [5650] = {.lex_state = 149},
  [5651] = {.lex_state = 185},
  [5652] = {.lex_state = 185},
  [5653] = {.lex_state = 149},
  [5654] = {.lex_state = 207},
  [5655] = {.lex_state = 149},
  [5656] = {.lex_state = 149},
  [5657] = {.lex_state = 149},
  [5658] = {.lex_state = 185},
  [5659] = {.lex_state = 149},
  [5660] = {.lex_state = 149},
  [5661] = {.lex_state = 149},
  [5662] = {.lex_state = 149},
  [5663] = {.lex_state = 346},
  [5664] = {.lex_state = 149},
  [5665] = {.lex_state = 149},
  [5666] = {.lex_state = 149},
  [5667] = {.lex_state = 149},
  [5668] = {.lex_state = 149},
  [5669] = {.lex_state = 149},
  [5670] = {.lex_state = 149},
  [5671] = {.lex_state = 185},
  [5672] = {.lex_state = 185},
  [5673] = {.lex_state = 185},
  [5674] = {.lex_state = 149},
  [5675] = {.lex_state = 149},
  [5676] = {.lex_state = 149},
  [5677] = {.lex_state = 149},
  [5678] = {.lex_state = 149},
  [5679] = {.lex_state = 149},
  [5680] = {.lex_state = 149},
  [5681] = {.lex_state = 149},
  [5682] = {.lex_state = 149},
  [5683] = {.lex_state = 149},
  [5684] = {.lex_state = 149},
  [5685] = {.lex_state = 185},
  [5686] = {.lex_state = 185},
  [5687] = {.lex_state = 149},
  [5688] = {.lex_state = 149},
  [5689] = {.lex_state = 149},
  [5690] = {.lex_state = 346},
  [5691] = {.lex_state = 185},
  [5692] = {.lex_state = 149},
  [5693] = {.lex_state = 346},
  [5694] = {.lex_state = 346},
  [5695] = {.lex_state = 185},
  [5696] = {.lex_state = 346},
  [5697] = {.lex_state = 149},
  [5698] = {.lex_state = 149},
  [5699] = {.lex_state = 149},
  [5700] = {.lex_state = 149},
  [5701] = {.lex_state = 149},
  [5702] = {.lex_state = 346},
  [5703] = {.lex_state = 149},
  [5704] = {.lex_state = 149},
  [5705] = {.lex_state = 207},
  [5706] = {.lex_state = 344, .external_lex_state = 16},
  [5707] = {.lex_state = 344},
  [5708] = {.lex_state = 344},
  [5709] = {.lex_state = 149},
  [5710] = {.lex_state = 207},
  [5711] = {.lex_state = 344},
  [5712] = {.lex_state = 344},
  [5713] = {.lex_state = 344},
  [5714] = {.lex_state = 344, .external_lex_state = 21},
  [5715] = {.lex_state = 344, .external_lex_state = 21},
  [5716] = {.lex_state = 344, .external_lex_state = 21},
  [5717] = {.lex_state = 344},
  [5718] = {.lex_state = 344},
  [5719] = {.lex_state = 344},
  [5720] = {.lex_state = 344, .external_lex_state = 16},
  [5721] = {.lex_state = 344, .external_lex_state = 21},
  [5722] = {.lex_state = 344, .external_lex_state = 16},
  [5723] = {.lex_state = 344},
  [5724] = {.lex_state = 344, .external_lex_state = 16},
  [5725] = {.lex_state = 344},
  [5726] = {.lex_state = 344},
  [5727] = {.lex_state = 207},
  [5728] = {.lex_state = 344},
  [5729] = {.lex_state = 344},
  [5730] = {.lex_state = 344},
  [5731] = {.lex_state = 344},
  [5732] = {.lex_state = 344},
  [5733] = {.lex_state = 344, .external_lex_state = 21},
  [5734] = {.lex_state = 344, .external_lex_state = 16},
  [5735] = {.lex_state = 344},
  [5736] = {.lex_state = 344, .external_lex_state = 16},
  [5737] = {.lex_state = 344},
  [5738] = {.lex_state = 344, .external_lex_state = 15},
  [5739] = {.lex_state = 344, .external_lex_state = 21},
  [5740] = {.lex_state = 344, .external_lex_state = 16},
  [5741] = {.lex_state = 344, .external_lex_state = 24},
  [5742] = {.lex_state = 344, .external_lex_state = 15},
  [5743] = {.lex_state = 344, .external_lex_state = 21},
  [5744] = {.lex_state = 344, .external_lex_state = 15},
  [5745] = {.lex_state = 344},
  [5746] = {.lex_state = 344, .external_lex_state = 25},
  [5747] = {.lex_state = 186, .external_lex_state = 24},
  [5748] = {.lex_state = 344, .external_lex_state = 25},
  [5749] = {.lex_state = 149},
  [5750] = {.lex_state = 344, .external_lex_state = 25},
  [5751] = {.lex_state = 344, .external_lex_state = 15},
  [5752] = {.lex_state = 186, .external_lex_state = 24},
  [5753] = {.lex_state = 149},
  [5754] = {.lex_state = 344, .external_lex_state = 24},
  [5755] = {.lex_state = 344},
  [5756] = {.lex_state = 344},
  [5757] = {.lex_state = 344, .external_lex_state = 16},
  [5758] = {.lex_state = 344},
  [5759] = {.lex_state = 344},
  [5760] = {.lex_state = 344, .external_lex_state = 21},
  [5761] = {.lex_state = 149},
  [5762] = {.lex_state = 344},
  [5763] = {.lex_state = 344},
  [5764] = {.lex_state = 344},
  [5765] = {.lex_state = 344},
  [5766] = {.lex_state = 344, .external_lex_state = 21},
  [5767] = {.lex_state = 149},
  [5768] = {.lex_state = 344},
  [5769] = {.lex_state = 186, .external_lex_state = 15},
  [5770] = {.lex_state = 344, .external_lex_state = 24},
  [5771] = {.lex_state = 344},
  [5772] = {.lex_state = 186, .external_lex_state = 24},
  [5773] = {.lex_state = 186, .external_lex_state = 15},
  [5774] = {.lex_state = 149},
  [5775] = {.lex_state = 149},
  [5776] = {.lex_state = 344, .external_lex_state = 24},
  [5777] = {.lex_state = 186, .external_lex_state = 24},
  [5778] = {.lex_state = 149},
  [5779] = {.lex_state = 149},
  [5780] = {.lex_state = 344},
  [5781] = {.lex_state = 149},
  [5782] = {.lex_state = 344, .external_lex_state = 15},
  [5783] = {.lex_state = 149},
  [5784] = {.lex_state = 186, .external_lex_state = 15},
  [5785] = {.lex_state = 344},
  [5786] = {.lex_state = 344},
  [5787] = {.lex_state = 149},
  [5788] = {.lex_state = 344, .external_lex_state = 15},
  [5789] = {.lex_state = 344, .external_lex_state = 15},
  [5790] = {.lex_state = 344},
  [5791] = {.lex_state = 344},
  [5792] = {.lex_state = 344, .external_lex_state = 24},
  [5793] = {.lex_state = 149},
  [5794] = {.lex_state = 344, .external_lex_state = 15},
  [5795] = {.lex_state = 186, .external_lex_state = 24},
  [5796] = {.lex_state = 344},
  [5797] = {.lex_state = 344, .external_lex_state = 20},
  [5798] = {.lex_state = 344, .external_lex_state = 15},
  [5799] = {.lex_state = 344, .external_lex_state = 15},
  [5800] = {.lex_state = 149},
  [5801] = {.lex_state = 344},
  [5802] = {.lex_state = 344},
  [5803] = {.lex_state = 344},
  [5804] = {.lex_state = 149},
  [5805] = {.lex_state = 344},
  [5806] = {.lex_state = 344},
  [5807] = {.lex_state = 344, .external_lex_state = 16},
  [5808] = {.lex_state = 149},
  [5809] = {.lex_state = 344, .external_lex_state = 15},
  [5810] = {.lex_state = 344},
  [5811] = {.lex_state = 344},
  [5812] = {.lex_state = 149},
  [5813] = {.lex_state = 149},
  [5814] = {.lex_state = 344, .external_lex_state = 16},
  [5815] = {.lex_state = 344},
  [5816] = {.lex_state = 344, .external_lex_state = 15},
  [5817] = {.lex_state = 344, .external_lex_state = 21},
  [5818] = {.lex_state = 344, .external_lex_state = 15},
  [5819] = {.lex_state = 344},
  [5820] = {.lex_state = 344, .external_lex_state = 15},
  [5821] = {.lex_state = 344},
  [5822] = {.lex_state = 344, .external_lex_state = 16},
  [5823] = {.lex_state = 344},
  [5824] = {.lex_state = 149},
  [5825] = {.lex_state = 344},
  [5826] = {.lex_state = 344, .external_lex_state = 16},
  [5827] = {.lex_state = 344, .external_lex_state = 15},
  [5828] = {.lex_state = 344, .external_lex_state = 16},
  [5829] = {.lex_state = 186, .external_lex_state = 15},
  [5830] = {.lex_state = 344, .external_lex_state = 24},
  [5831] = {.lex_state = 186, .external_lex_state = 24},
  [5832] = {.lex_state = 344, .external_lex_state = 16},
  [5833] = {.lex_state = 344},
  [5834] = {.lex_state = 186, .external_lex_state = 15},
  [5835] = {.lex_state = 344, .external_lex_state = 16},
  [5836] = {.lex_state = 149},
  [5837] = {.lex_state = 344, .external_lex_state = 24},
  [5838] = {.lex_state = 344, .external_lex_state = 15},
  [5839] = {.lex_state = 186, .external_lex_state = 24},
  [5840] = {.lex_state = 344, .external_lex_state = 15},
  [5841] = {.lex_state = 149},
  [5842] = {.lex_state = 149},
  [5843] = {.lex_state = 149},
  [5844] = {.lex_state = 344, .external_lex_state = 15},
  [5845] = {.lex_state = 186, .external_lex_state = 24},
  [5846] = {.lex_state = 344, .external_lex_state = 24},
  [5847] = {.lex_state = 344},
  [5848] = {.lex_state = 344, .external_lex_state = 15},
  [5849] = {.lex_state = 344},
  [5850] = {.lex_state = 344},
  [5851] = {.lex_state = 344},
  [5852] = {.lex_state = 149},
  [5853] = {.lex_state = 344},
  [5854] = {.lex_state = 344},
  [5855] = {.lex_state = 186, .external_lex_state = 24},
  [5856] = {.lex_state = 344, .external_lex_state = 15},
  [5857] = {.lex_state = 344, .external_lex_state = 15},
  [5858] = {.lex_state = 344, .external_lex_state = 24},
  [5859] = {.lex_state = 186, .external_lex_state = 15},
  [5860] = {.lex_state = 344, .external_lex_state = 15},
  [5861] = {.lex_state = 344},
  [5862] = {.lex_state = 344, .external_lex_state = 20},
  [5863] = {.lex_state = 149},
  [5864] = {.lex_state = 344},
  [5865] = {.lex_state = 344, .external_lex_state = 15},
  [5866] = {.lex_state = 344, .external_lex_state = 16},
  [5867] = {.lex_state = 344, .external_lex_state = 24},
  [5868] = {.lex_state = 186, .external_lex_state = 24},
  [5869] = {.lex_state = 344},
  [5870] = {.lex_state = 149},
  [5871] = {.lex_state = 344},
  [5872] = {.lex_state = 344, .external_lex_state = 15},
  [5873] = {.lex_state = 344, .external_lex_state = 16},
  [5874] = {.lex_state = 149},
  [5875] = {.lex_state = 149},
  [5876] = {.lex_state = 186, .external_lex_state = 24},
  [5877] = {.lex_state = 344, .external_lex_state = 24},
  [5878] = {.lex_state = 344, .external_lex_state = 24},
  [5879] = {.lex_state = 344, .external_lex_state = 15},
  [5880] = {.lex_state = 344, .external_lex_state = 15},
  [5881] = {.lex_state = 344},
  [5882] = {.lex_state = 186, .external_lex_state = 24},
  [5883] = {.lex_state = 149},
  [5884] = {.lex_state = 344, .external_lex_state = 24},
  [5885] = {.lex_state = 344},
  [5886] = {.lex_state = 186, .external_lex_state = 24},
  [5887] = {.lex_state = 149},
  [5888] = {.lex_state = 149},
  [5889] = {.lex_state = 344},
  [5890] = {.lex_state = 344, .external_lex_state = 15},
  [5891] = {.lex_state = 344},
  [5892] = {.lex_state = 149},
  [5893] = {.lex_state = 344, .external_lex_state = 15},
  [5894] = {.lex_state = 149},
  [5895] = {.lex_state = 344, .external_lex_state = 25},
  [5896] = {.lex_state = 344, .external_lex_state = 21},
  [5897] = {.lex_state = 344},
  [5898] = {.lex_state = 344, .external_lex_state = 21},
  [5899] = {.lex_state = 344},
  [5900] = {.lex_state = 344},
  [5901] = {.lex_state = 344},
  [5902] = {.lex_state = 149},
  [5903] = {.lex_state = 149},
  [5904] = {.lex_state = 344, .external_lex_state = 15},
  [5905] = {.lex_state = 149},
  [5906] = {.lex_state = 344, .external_lex_state = 15},
  [5907] = {.lex_state = 344, .external_lex_state = 15},
  [5908] = {.lex_state = 344},
  [5909] = {.lex_state = 344},
  [5910] = {.lex_state = 344},
  [5911] = {.lex_state = 149},
  [5912] = {.lex_state = 344},
  [5913] = {.lex_state = 344, .external_lex_state = 16},
  [5914] = {.lex_state = 344},
  [5915] = {.lex_state = 344, .external_lex_state = 21},
  [5916] = {.lex_state = 344},
  [5917] = {.lex_state = 344},
  [5918] = {.lex_state = 344, .external_lex_state = 15},
  [5919] = {.lex_state = 344},
  [5920] = {.lex_state = 149},
  [5921] = {.lex_state = 344, .external_lex_state = 25},
  [5922] = {.lex_state = 344, .external_lex_state = 16},
  [5923] = {.lex_state = 149},
  [5924] = {.lex_state = 186, .external_lex_state = 15},
  [5925] = {.lex_state = 344, .external_lex_state = 24},
  [5926] = {.lex_state = 344},
  [5927] = {.lex_state = 186, .external_lex_state = 24},
  [5928] = {.lex_state = 186, .external_lex_state = 15},
  [5929] = {.lex_state = 344},
  [5930] = {.lex_state = 344, .external_lex_state = 15},
  [5931] = {.lex_state = 344, .external_lex_state = 24},
  [5932] = {.lex_state = 186, .external_lex_state = 24},
  [5933] = {.lex_state = 149},
  [5934] = {.lex_state = 149},
  [5935] = {.lex_state = 344, .external_lex_state = 25},
  [5936] = {.lex_state = 344, .external_lex_state = 15},
  [5937] = {.lex_state = 344, .external_lex_state = 15},
  [5938] = {.lex_state = 344, .external_lex_state = 15},
  [5939] = {.lex_state = 344},
  [5940] = {.lex_state = 149},
  [5941] = {.lex_state = 344},
  [5942] = {.lex_state = 344},
  [5943] = {.lex_state = 344, .external_lex_state = 15},
  [5944] = {.lex_state = 344, .external_lex_state = 15},
  [5945] = {.lex_state = 344, .external_lex_state = 15},
  [5946] = {.lex_state = 149},
  [5947] = {.lex_state = 344, .external_lex_state = 15},
  [5948] = {.lex_state = 344, .external_lex_state = 15},
  [5949] = {.lex_state = 344},
  [5950] = {.lex_state = 149},
  [5951] = {.lex_state = 186, .external_lex_state = 24},
  [5952] = {.lex_state = 344},
  [5953] = {.lex_state = 344, .external_lex_state = 24},
  [5954] = {.lex_state = 344, .external_lex_state = 24},
  [5955] = {.lex_state = 186, .external_lex_state = 24},
  [5956] = {.lex_state = 344},
  [5957] = {.lex_state = 186, .external_lex_state = 24},
  [5958] = {.lex_state = 344, .external_lex_state = 25},
  [5959] = {.lex_state = 149},
  [5960] = {.lex_state = 149},
  [5961] = {.lex_state = 149},
  [5962] = {.lex_state = 344, .external_lex_state = 24},
  [5963] = {.lex_state = 344},
  [5964] = {.lex_state = 344},
  [5965] = {.lex_state = 344},
  [5966] = {.lex_state = 344, .external_lex_state = 15},
  [5967] = {.lex_state = 344, .external_lex_state = 16},
  [5968] = {.lex_state = 344, .external_lex_state = 15},
  [5969] = {.lex_state = 186, .external_lex_state = 15},
  [5970] = {.lex_state = 344, .external_lex_state = 16},
  [5971] = {.lex_state = 149},
  [5972] = {.lex_state = 344},
  [5973] = {.lex_state = 344},
  [5974] = {.lex_state = 344},
  [5975] = {.lex_state = 344},
  [5976] = {.lex_state = 149},
  [5977] = {.lex_state = 149},
  [5978] = {.lex_state = 344, .external_lex_state = 15},
  [5979] = {.lex_state = 344, .external_lex_state = 20},
  [5980] = {.lex_state = 149},
  [5981] = {.lex_state = 186, .external_lex_state = 24},
  [5982] = {.lex_state = 344},
  [5983] = {.lex_state = 344, .external_lex_state = 24},
  [5984] = {.lex_state = 149},
  [5985] = {.lex_state = 149},
  [5986] = {.lex_state = 344},
  [5987] = {.lex_state = 344},
  [5988] = {.lex_state = 344, .external_lex_state = 15},
  [5989] = {.lex_state = 344, .external_lex_state = 15},
  [5990] = {.lex_state = 344, .external_lex_state = 25},
  [5991] = {.lex_state = 344, .external_lex_state = 24},
  [5992] = {.lex_state = 149},
  [5993] = {.lex_state = 186, .external_lex_state = 24},
  [5994] = {.lex_state = 344},
  [5995] = {.lex_state = 344, .external_lex_state = 24},
  [5996] = {.lex_state = 186, .external_lex_state = 24},
  [5997] = {.lex_state = 149},
  [5998] = {.lex_state = 344, .external_lex_state = 15},
  [5999] = {.lex_state = 344, .external_lex_state = 15},
  [6000] = {.lex_state = 344, .external_lex_state = 15},
  [6001] = {.lex_state = 344},
  [6002] = {.lex_state = 344},
  [6003] = {.lex_state = 344, .external_lex_state = 24},
  [6004] = {.lex_state = 344, .external_lex_state = 24},
  [6005] = {.lex_state = 344, .external_lex_state = 25},
  [6006] = {.lex_state = 344, .external_lex_state = 24},
  [6007] = {.lex_state = 344, .external_lex_state = 24},
  [6008] = {.lex_state = 344, .external_lex_state = 24},
  [6009] = {.lex_state = 344, .external_lex_state = 24},
  [6010] = {.lex_state = 344, .external_lex_state = 24},
  [6011] = {.lex_state = 344, .external_lex_state = 24},
  [6012] = {.lex_state = 344, .external_lex_state = 24},
  [6013] = {.lex_state = 344},
  [6014] = {.lex_state = 344, .external_lex_state = 24},
  [6015] = {.lex_state = 344, .external_lex_state = 24},
  [6016] = {.lex_state = 344, .external_lex_state = 24},
  [6017] = {.lex_state = 344, .external_lex_state = 24},
  [6018] = {.lex_state = 344, .external_lex_state = 24},
  [6019] = {.lex_state = 344, .external_lex_state = 24},
  [6020] = {.lex_state = 344, .external_lex_state = 24},
  [6021] = {.lex_state = 344, .external_lex_state = 24},
  [6022] = {.lex_state = 344, .external_lex_state = 24},
  [6023] = {.lex_state = 344},
  [6024] = {.lex_state = 344},
  [6025] = {.lex_state = 344, .external_lex_state = 24},
  [6026] = {.lex_state = 344},
  [6027] = {.lex_state = 344, .external_lex_state = 24},
  [6028] = {.lex_state = 344},
  [6029] = {.lex_state = 344},
  [6030] = {.lex_state = 344, .external_lex_state = 24},
  [6031] = {.lex_state = 344},
  [6032] = {.lex_state = 344, .external_lex_state = 24},
  [6033] = {.lex_state = 344},
  [6034] = {.lex_state = 344},
  [6035] = {.lex_state = 344},
  [6036] = {.lex_state = 344},
  [6037] = {.lex_state = 344, .external_lex_state = 24},
  [6038] = {.lex_state = 344, .external_lex_state = 24},
  [6039] = {.lex_state = 344},
  [6040] = {.lex_state = 344},
  [6041] = {.lex_state = 344, .external_lex_state = 24},
  [6042] = {.lex_state = 344, .external_lex_state = 24},
  [6043] = {.lex_state = 344},
  [6044] = {.lex_state = 344},
  [6045] = {.lex_state = 344},
  [6046] = {.lex_state = 344, .external_lex_state = 24},
  [6047] = {.lex_state = 344, .external_lex_state = 24},
  [6048] = {.lex_state = 344},
  [6049] = {.lex_state = 344},
  [6050] = {.lex_state = 344, .external_lex_state = 24},
  [6051] = {.lex_state = 344, .external_lex_state = 24},
  [6052] = {.lex_state = 344, .external_lex_state = 24},
  [6053] = {.lex_state = 344},
  [6054] = {.lex_state = 344, .external_lex_state = 24},
  [6055] = {.lex_state = 344},
  [6056] = {.lex_state = 344, .external_lex_state = 24},
  [6057] = {.lex_state = 344, .external_lex_state = 24},
  [6058] = {.lex_state = 344, .external_lex_state = 24},
  [6059] = {.lex_state = 344},
  [6060] = {.lex_state = 344, .external_lex_state = 24},
  [6061] = {.lex_state = 344, .external_lex_state = 24},
  [6062] = {.lex_state = 344, .external_lex_state = 24},
  [6063] = {.lex_state = 344},
  [6064] = {.lex_state = 344, .external_lex_state = 26},
  [6065] = {.lex_state = 344},
  [6066] = {.lex_state = 344},
  [6067] = {.lex_state = 344, .external_lex_state = 24},
  [6068] = {.lex_state = 344, .external_lex_state = 24},
  [6069] = {.lex_state = 344, .external_lex_state = 24},
  [6070] = {.lex_state = 344, .external_lex_state = 26},
  [6071] = {.lex_state = 344, .external_lex_state = 24},
  [6072] = {.lex_state = 344},
  [6073] = {.lex_state = 344},
  [6074] = {.lex_state = 344},
  [6075] = {.lex_state = 344, .external_lex_state = 24},
  [6076] = {.lex_state = 344, .external_lex_state = 24},
  [6077] = {.lex_state = 186, .external_lex_state = 15},
  [6078] = {.lex_state = 344, .external_lex_state = 24},
  [6079] = {.lex_state = 186, .external_lex_state = 15},
  [6080] = {.lex_state = 344, .external_lex_state = 24},
  [6081] = {.lex_state = 344, .external_lex_state = 24},
  [6082] = {.lex_state = 344, .external_lex_state = 24},
  [6083] = {.lex_state = 344},
  [6084] = {.lex_state = 344, .external_lex_state = 24},
  [6085] = {.lex_state = 344, .external_lex_state = 24},
  [6086] = {.lex_state = 344, .external_lex_state = 24},
  [6087] = {.lex_state = 344, .external_lex_state = 21},
  [6088] = {.lex_state = 344, .external_lex_state = 24},
  [6089] = {.lex_state = 344, .external_lex_state = 24},
  [6090] = {.lex_state = 344, .external_lex_state = 24},
  [6091] = {.lex_state = 344},
  [6092] = {.lex_state = 344},
  [6093] = {.lex_state = 344, .external_lex_state = 26},
  [6094] = {.lex_state = 344, .external_lex_state = 24},
  [6095] = {.lex_state = 344, .external_lex_state = 24},
  [6096] = {.lex_state = 344, .external_lex_state = 24},
  [6097] = {.lex_state = 344},
  [6098] = {.lex_state = 344, .external_lex_state = 24},
  [6099] = {.lex_state = 344, .external_lex_state = 24},
  [6100] = {.lex_state = 344, .external_lex_state = 24},
  [6101] = {.lex_state = 344, .external_lex_state = 24},
  [6102] = {.lex_state = 344, .external_lex_state = 21},
  [6103] = {.lex_state = 344, .external_lex_state = 24},
  [6104] = {.lex_state = 344, .external_lex_state = 24},
  [6105] = {.lex_state = 344, .external_lex_state = 26},
  [6106] = {.lex_state = 344},
  [6107] = {.lex_state = 344, .external_lex_state = 21},
  [6108] = {.lex_state = 344},
  [6109] = {.lex_state = 344, .external_lex_state = 24},
  [6110] = {.lex_state = 344, .external_lex_state = 24},
  [6111] = {.lex_state = 344, .external_lex_state = 24},
  [6112] = {.lex_state = 344},
  [6113] = {.lex_state = 344, .external_lex_state = 24},
  [6114] = {.lex_state = 344, .external_lex_state = 24},
  [6115] = {.lex_state = 344, .external_lex_state = 25},
  [6116] = {.lex_state = 344},
  [6117] = {.lex_state = 344, .external_lex_state = 24},
  [6118] = {.lex_state = 344},
  [6119] = {.lex_state = 344, .external_lex_state = 24},
  [6120] = {.lex_state = 344, .external_lex_state = 26},
  [6121] = {.lex_state = 344},
  [6122] = {.lex_state = 344, .external_lex_state = 24},
  [6123] = {.lex_state = 344, .external_lex_state = 24},
  [6124] = {.lex_state = 344, .external_lex_state = 26},
  [6125] = {.lex_state = 344},
  [6126] = {.lex_state = 344},
  [6127] = {.lex_state = 344, .external_lex_state = 24},
  [6128] = {.lex_state = 344, .external_lex_state = 24},
  [6129] = {.lex_state = 344, .external_lex_state = 24},
  [6130] = {.lex_state = 344, .external_lex_state = 24},
  [6131] = {.lex_state = 344, .external_lex_state = 24},
  [6132] = {.lex_state = 344, .external_lex_state = 24},
  [6133] = {.lex_state = 344, .external_lex_state = 24},
  [6134] = {.lex_state = 344},
  [6135] = {.lex_state = 344, .external_lex_state = 24},
  [6136] = {.lex_state = 344, .external_lex_state = 24},
  [6137] = {.lex_state = 344},
  [6138] = {.lex_state = 344, .external_lex_state = 24},
  [6139] = {.lex_state = 344, .external_lex_state = 24},
  [6140] = {.lex_state = 344, .external_lex_state = 26},
  [6141] = {.lex_state = 344, .external_lex_state = 24},
  [6142] = {.lex_state = 344},
  [6143] = {.lex_state = 344},
  [6144] = {.lex_state = 344, .external_lex_state = 21},
  [6145] = {.lex_state = 344, .external_lex_state = 24},
  [6146] = {.lex_state = 344, .external_lex_state = 26},
  [6147] = {.lex_state = 344},
  [6148] = {.lex_state = 344},
  [6149] = {.lex_state = 344},
  [6150] = {.lex_state = 344},
  [6151] = {.lex_state = 344},
  [6152] = {.lex_state = 344, .external_lex_state = 24},
  [6153] = {.lex_state = 344, .external_lex_state = 24},
  [6154] = {.lex_state = 344, .external_lex_state = 21},
  [6155] = {.lex_state = 344},
  [6156] = {.lex_state = 344, .external_lex_state = 24},
  [6157] = {.lex_state = 344, .external_lex_state = 24},
  [6158] = {.lex_state = 344, .external_lex_state = 24},
  [6159] = {.lex_state = 344, .external_lex_state = 24},
  [6160] = {.lex_state = 344, .external_lex_state = 24},
  [6161] = {.lex_state = 344, .external_lex_state = 24},
  [6162] = {.lex_state = 344, .external_lex_state = 24},
  [6163] = {.lex_state = 344, .external_lex_state = 24},
  [6164] = {.lex_state = 344, .external_lex_state = 24},
  [6165] = {.lex_state = 344, .external_lex_state = 24},
  [6166] = {.lex_state = 344, .external_lex_state = 24},
  [6167] = {.lex_state = 344, .external_lex_state = 24},
  [6168] = {.lex_state = 344},
  [6169] = {.lex_state = 344, .external_lex_state = 24},
  [6170] = {.lex_state = 344, .external_lex_state = 24},
  [6171] = {.lex_state = 344, .external_lex_state = 24},
  [6172] = {.lex_state = 344, .external_lex_state = 26},
  [6173] = {.lex_state = 344},
  [6174] = {.lex_state = 344, .external_lex_state = 24},
  [6175] = {.lex_state = 344, .external_lex_state = 24},
  [6176] = {.lex_state = 344},
  [6177] = {.lex_state = 344, .external_lex_state = 24},
  [6178] = {.lex_state = 344, .external_lex_state = 26},
  [6179] = {.lex_state = 344, .external_lex_state = 24},
  [6180] = {.lex_state = 344, .external_lex_state = 24},
  [6181] = {.lex_state = 344, .external_lex_state = 26},
  [6182] = {.lex_state = 344},
  [6183] = {.lex_state = 344},
  [6184] = {.lex_state = 344, .external_lex_state = 24},
  [6185] = {.lex_state = 186},
  [6186] = {.lex_state = 344, .external_lex_state = 24},
  [6187] = {.lex_state = 344, .external_lex_state = 24},
  [6188] = {.lex_state = 344},
  [6189] = {.lex_state = 344, .external_lex_state = 24},
  [6190] = {.lex_state = 344, .external_lex_state = 24},
  [6191] = {.lex_state = 344, .external_lex_state = 24},
  [6192] = {.lex_state = 344, .external_lex_state = 24},
  [6193] = {.lex_state = 344, .external_lex_state = 24},
  [6194] = {.lex_state = 344, .external_lex_state = 24},
  [6195] = {.lex_state = 344, .external_lex_state = 24},
  [6196] = {.lex_state = 344, .external_lex_state = 24},
  [6197] = {.lex_state = 344, .external_lex_state = 24},
  [6198] = {.lex_state = 344},
  [6199] = {.lex_state = 344, .external_lex_state = 26},
  [6200] = {.lex_state = 344, .external_lex_state = 24},
  [6201] = {.lex_state = 344, .external_lex_state = 24},
  [6202] = {.lex_state = 344, .external_lex_state = 24},
  [6203] = {.lex_state = 344},
  [6204] = {.lex_state = 344, .external_lex_state = 26},
  [6205] = {.lex_state = 344, .external_lex_state = 24},
  [6206] = {.lex_state = 344, .external_lex_state = 24},
  [6207] = {.lex_state = 344, .external_lex_state = 24},
  [6208] = {.lex_state = 344, .external_lex_state = 24},
  [6209] = {.lex_state = 344},
  [6210] = {.lex_state = 344},
  [6211] = {.lex_state = 344, .external_lex_state = 24},
  [6212] = {.lex_state = 344, .external_lex_state = 24},
  [6213] = {.lex_state = 344, .external_lex_state = 24},
  [6214] = {.lex_state = 344, .external_lex_state = 24},
  [6215] = {.lex_state = 344, .external_lex_state = 24},
  [6216] = {.lex_state = 344, .external_lex_state = 15},
  [6217] = {.lex_state = 344, .external_lex_state = 24},
  [6218] = {.lex_state = 344, .external_lex_state = 24},
  [6219] = {.lex_state = 344, .external_lex_state = 24},
  [6220] = {.lex_state = 344, .external_lex_state = 24},
  [6221] = {.lex_state = 344, .external_lex_state = 24},
  [6222] = {.lex_state = 344, .external_lex_state = 24},
  [6223] = {.lex_state = 344, .external_lex_state = 24},
  [6224] = {.lex_state = 344, .external_lex_state = 24},
  [6225] = {.lex_state = 344, .external_lex_state = 24},
  [6226] = {.lex_state = 344, .external_lex_state = 24},
  [6227] = {.lex_state = 344, .external_lex_state = 24},
  [6228] = {.lex_state = 344, .external_lex_state = 24},
  [6229] = {.lex_state = 344, .external_lex_state = 24},
  [6230] = {.lex_state = 344, .external_lex_state = 24},
  [6231] = {.lex_state = 344, .external_lex_state = 24},
  [6232] = {.lex_state = 186},
  [6233] = {.lex_state = 344, .external_lex_state = 24},
  [6234] = {.lex_state = 344},
  [6235] = {.lex_state = 344, .external_lex_state = 15},
  [6236] = {.lex_state = 344, .external_lex_state = 26},
  [6237] = {.lex_state = 344, .external_lex_state = 24},
  [6238] = {.lex_state = 344},
  [6239] = {.lex_state = 344, .external_lex_state = 24},
  [6240] = {.lex_state = 344, .external_lex_state = 24},
  [6241] = {.lex_state = 344, .external_lex_state = 24},
  [6242] = {.lex_state = 344},
  [6243] = {.lex_state = 344, .external_lex_state = 24},
  [6244] = {.lex_state = 344, .external_lex_state = 24},
  [6245] = {.lex_state = 344, .external_lex_state = 24},
  [6246] = {.lex_state = 344, .external_lex_state = 26},
  [6247] = {.lex_state = 344},
  [6248] = {.lex_state = 344},
  [6249] = {.lex_state = 344, .external_lex_state = 24},
  [6250] = {.lex_state = 344, .external_lex_state = 24},
  [6251] = {.lex_state = 344},
  [6252] = {.lex_state = 344, .external_lex_state = 24},
  [6253] = {.lex_state = 344},
  [6254] = {.lex_state = 344, .external_lex_state = 24},
  [6255] = {.lex_state = 344, .external_lex_state = 24},
  [6256] = {.lex_state = 344, .external_lex_state = 24},
  [6257] = {.lex_state = 344, .external_lex_state = 24},
  [6258] = {.lex_state = 344, .external_lex_state = 24},
  [6259] = {.lex_state = 344, .external_lex_state = 24},
  [6260] = {.lex_state = 344, .external_lex_state = 24},
  [6261] = {.lex_state = 344, .external_lex_state = 24},
  [6262] = {.lex_state = 344, .external_lex_state = 24},
  [6263] = {.lex_state = 344, .external_lex_state = 24},
  [6264] = {.lex_state = 344, .external_lex_state = 24},
  [6265] = {.lex_state = 344, .external_lex_state = 24},
  [6266] = {.lex_state = 344, .external_lex_state = 24},
  [6267] = {.lex_state = 344, .external_lex_state = 24},
  [6268] = {.lex_state = 344},
  [6269] = {.lex_state = 344, .external_lex_state = 26},
  [6270] = {.lex_state = 344, .external_lex_state = 25},
  [6271] = {.lex_state = 344},
  [6272] = {.lex_state = 344, .external_lex_state = 26},
  [6273] = {.lex_state = 344},
  [6274] = {.lex_state = 344},
  [6275] = {.lex_state = 344, .external_lex_state = 16},
  [6276] = {.lex_state = 344, .external_lex_state = 24},
  [6277] = {.lex_state = 344, .external_lex_state = 24},
  [6278] = {.lex_state = 344, .external_lex_state = 24},
  [6279] = {.lex_state = 344, .external_lex_state = 24},
  [6280] = {.lex_state = 344, .external_lex_state = 24},
  [6281] = {.lex_state = 344, .external_lex_state = 24},
  [6282] = {.lex_state = 344, .external_lex_state = 24},
  [6283] = {.lex_state = 344, .external_lex_state = 24},
  [6284] = {.lex_state = 344},
  [6285] = {.lex_state = 344},
  [6286] = {.lex_state = 344, .external_lex_state = 24},
  [6287] = {.lex_state = 344, .external_lex_state = 24},
  [6288] = {.lex_state = 344, .external_lex_state = 24},
  [6289] = {.lex_state = 344, .external_lex_state = 24},
  [6290] = {.lex_state = 344, .external_lex_state = 24},
  [6291] = {.lex_state = 344, .external_lex_state = 24},
  [6292] = {.lex_state = 344, .external_lex_state = 24},
  [6293] = {.lex_state = 344, .external_lex_state = 24},
  [6294] = {.lex_state = 344, .external_lex_state = 24},
  [6295] = {.lex_state = 186},
  [6296] = {.lex_state = 344, .external_lex_state = 24},
  [6297] = {.lex_state = 344, .external_lex_state = 24},
  [6298] = {.lex_state = 344, .external_lex_state = 24},
  [6299] = {.lex_state = 344, .external_lex_state = 24},
  [6300] = {.lex_state = 344},
  [6301] = {.lex_state = 344, .external_lex_state = 24},
  [6302] = {.lex_state = 344, .external_lex_state = 24},
  [6303] = {.lex_state = 344, .external_lex_state = 24},
  [6304] = {.lex_state = 344, .external_lex_state = 26},
  [6305] = {.lex_state = 344, .external_lex_state = 24},
  [6306] = {.lex_state = 344, .external_lex_state = 24},
  [6307] = {.lex_state = 344, .external_lex_state = 24},
  [6308] = {.lex_state = 344, .external_lex_state = 24},
  [6309] = {.lex_state = 344},
  [6310] = {.lex_state = 344, .external_lex_state = 24},
  [6311] = {.lex_state = 344, .external_lex_state = 26},
  [6312] = {.lex_state = 344, .external_lex_state = 24},
  [6313] = {.lex_state = 344},
  [6314] = {.lex_state = 344},
  [6315] = {.lex_state = 344, .external_lex_state = 24},
  [6316] = {.lex_state = 344, .external_lex_state = 26},
  [6317] = {.lex_state = 344},
  [6318] = {.lex_state = 344, .external_lex_state = 24},
  [6319] = {.lex_state = 344, .external_lex_state = 24},
  [6320] = {.lex_state = 344, .external_lex_state = 24},
  [6321] = {.lex_state = 344},
  [6322] = {.lex_state = 344, .external_lex_state = 24},
  [6323] = {.lex_state = 344, .external_lex_state = 24},
  [6324] = {.lex_state = 344, .external_lex_state = 24},
  [6325] = {.lex_state = 344, .external_lex_state = 24},
  [6326] = {.lex_state = 344, .external_lex_state = 24},
  [6327] = {.lex_state = 344, .external_lex_state = 24},
  [6328] = {.lex_state = 344},
  [6329] = {.lex_state = 344, .external_lex_state = 24},
  [6330] = {.lex_state = 344, .external_lex_state = 24},
  [6331] = {.lex_state = 344, .external_lex_state = 24},
  [6332] = {.lex_state = 344, .external_lex_state = 24},
  [6333] = {.lex_state = 344, .external_lex_state = 24},
  [6334] = {.lex_state = 344},
  [6335] = {.lex_state = 344},
  [6336] = {.lex_state = 344, .external_lex_state = 26},
  [6337] = {.lex_state = 344, .external_lex_state = 24},
  [6338] = {.lex_state = 344, .external_lex_state = 24},
  [6339] = {.lex_state = 344},
  [6340] = {.lex_state = 344, .external_lex_state = 16},
  [6341] = {.lex_state = 344, .external_lex_state = 24},
  [6342] = {.lex_state = 344, .external_lex_state = 24},
  [6343] = {.lex_state = 344, .external_lex_state = 26},
  [6344] = {.lex_state = 344},
  [6345] = {.lex_state = 344},
  [6346] = {.lex_state = 344, .external_lex_state = 24},
  [6347] = {.lex_state = 344, .external_lex_state = 24},
  [6348] = {.lex_state = 344, .external_lex_state = 24},
  [6349] = {.lex_state = 186, .external_lex_state = 15},
  [6350] = {.lex_state = 344},
  [6351] = {.lex_state = 344, .external_lex_state = 24},
  [6352] = {.lex_state = 344, .external_lex_state = 24},
  [6353] = {.lex_state = 344, .external_lex_state = 24},
  [6354] = {.lex_state = 344, .external_lex_state = 24},
  [6355] = {.lex_state = 344},
  [6356] = {.lex_state = 344},
  [6357] = {.lex_state = 344},
  [6358] = {.lex_state = 344, .external_lex_state = 24},
  [6359] = {.lex_state = 344, .external_lex_state = 24},
  [6360] = {.lex_state = 344, .external_lex_state = 24},
  [6361] = {.lex_state = 344, .external_lex_state = 24},
  [6362] = {.lex_state = 344, .external_lex_state = 24},
  [6363] = {.lex_state = 344, .external_lex_state = 24},
  [6364] = {.lex_state = 344},
  [6365] = {.lex_state = 344, .external_lex_state = 24},
  [6366] = {.lex_state = 186},
  [6367] = {.lex_state = 344, .external_lex_state = 24},
  [6368] = {.lex_state = 344, .external_lex_state = 24},
  [6369] = {.lex_state = 344, .external_lex_state = 24},
  [6370] = {.lex_state = 344, .external_lex_state = 24},
  [6371] = {.lex_state = 344, .external_lex_state = 24},
  [6372] = {.lex_state = 344},
  [6373] = {.lex_state = 344},
  [6374] = {.lex_state = 344, .external_lex_state = 26},
  [6375] = {.lex_state = 344, .external_lex_state = 24},
  [6376] = {.lex_state = 344},
  [6377] = {.lex_state = 344},
  [6378] = {.lex_state = 344, .external_lex_state = 24},
  [6379] = {.lex_state = 149},
  [6380] = {.lex_state = 149},
  [6381] = {.lex_state = 344},
  [6382] = {.lex_state = 344, .external_lex_state = 26},
  [6383] = {.lex_state = 344, .external_lex_state = 24},
  [6384] = {.lex_state = 344, .external_lex_state = 24},
  [6385] = {.lex_state = 344},
  [6386] = {.lex_state = 344},
  [6387] = {.lex_state = 344, .external_lex_state = 25},
  [6388] = {.lex_state = 344, .external_lex_state = 24},
  [6389] = {.lex_state = 344, .external_lex_state = 24},
  [6390] = {.lex_state = 344, .external_lex_state = 24},
  [6391] = {.lex_state = 344, .external_lex_state = 21},
  [6392] = {.lex_state = 344, .external_lex_state = 25},
  [6393] = {.lex_state = 344},
  [6394] = {.lex_state = 344, .external_lex_state = 24},
  [6395] = {.lex_state = 344, .external_lex_state = 25},
  [6396] = {.lex_state = 344, .external_lex_state = 24},
  [6397] = {.lex_state = 344, .external_lex_state = 24},
  [6398] = {.lex_state = 344},
  [6399] = {.lex_state = 344},
  [6400] = {.lex_state = 344, .external_lex_state = 21},
  [6401] = {.lex_state = 344, .external_lex_state = 21},
  [6402] = {.lex_state = 344},
  [6403] = {.lex_state = 344},
  [6404] = {.lex_state = 344, .external_lex_state = 23},
  [6405] = {.lex_state = 344},
  [6406] = {.lex_state = 344, .external_lex_state = 27},
  [6407] = {.lex_state = 344},
  [6408] = {.lex_state = 344},
  [6409] = {.lex_state = 344},
  [6410] = {.lex_state = 344, .external_lex_state = 21},
  [6411] = {.lex_state = 344, .external_lex_state = 21},
  [6412] = {.lex_state = 344, .external_lex_state = 28},
  [6413] = {.lex_state = 344, .external_lex_state = 28},
  [6414] = {.lex_state = 344},
  [6415] = {.lex_state = 344},
  [6416] = {.lex_state = 344},
  [6417] = {.lex_state = 344},
  [6418] = {.lex_state = 344},
  [6419] = {.lex_state = 344},
  [6420] = {.lex_state = 344},
  [6421] = {.lex_state = 344},
  [6422] = {.lex_state = 344},
  [6423] = {.lex_state = 344},
  [6424] = {.lex_state = 344},
  [6425] = {.lex_state = 344},
  [6426] = {.lex_state = 344, .external_lex_state = 21},
  [6427] = {.lex_state = 344},
  [6428] = {.lex_state = 344},
  [6429] = {.lex_state = 344},
  [6430] = {.lex_state = 344},
  [6431] = {.lex_state = 344},
  [6432] = {.lex_state = 344, .external_lex_state = 27},
  [6433] = {.lex_state = 344},
  [6434] = {.lex_state = 344},
  [6435] = {.lex_state = 344, .external_lex_state = 21},
  [6436] = {.lex_state = 344},
  [6437] = {.lex_state = 344, .external_lex_state = 29},
  [6438] = {.lex_state = 344},
  [6439] = {.lex_state = 344, .external_lex_state = 21},
  [6440] = {.lex_state = 344},
  [6441] = {.lex_state = 344},
  [6442] = {.lex_state = 344},
  [6443] = {.lex_state = 344},
  [6444] = {.lex_state = 344},
  [6445] = {.lex_state = 344},
  [6446] = {.lex_state = 344},
  [6447] = {.lex_state = 344, .external_lex_state = 29},
  [6448] = {.lex_state = 344},
  [6449] = {.lex_state = 344, .external_lex_state = 28},
  [6450] = {.lex_state = 344, .external_lex_state = 28},
  [6451] = {.lex_state = 344},
  [6452] = {.lex_state = 344},
  [6453] = {.lex_state = 344},
  [6454] = {.lex_state = 344},
  [6455] = {.lex_state = 344},
  [6456] = {.lex_state = 344, .external_lex_state = 27},
  [6457] = {.lex_state = 344, .external_lex_state = 30},
  [6458] = {.lex_state = 344, .external_lex_state = 21},
  [6459] = {.lex_state = 344},
  [6460] = {.lex_state = 344},
  [6461] = {.lex_state = 344, .external_lex_state = 24},
  [6462] = {.lex_state = 344},
  [6463] = {.lex_state = 344},
  [6464] = {.lex_state = 344},
  [6465] = {.lex_state = 344},
  [6466] = {.lex_state = 344, .external_lex_state = 23},
  [6467] = {.lex_state = 344},
  [6468] = {.lex_state = 344},
  [6469] = {.lex_state = 344},
  [6470] = {.lex_state = 186},
  [6471] = {.lex_state = 344, .external_lex_state = 21},
  [6472] = {.lex_state = 344, .external_lex_state = 21},
  [6473] = {.lex_state = 344},
  [6474] = {.lex_state = 344},
  [6475] = {.lex_state = 344},
  [6476] = {.lex_state = 344},
  [6477] = {.lex_state = 344, .external_lex_state = 29},
  [6478] = {.lex_state = 344},
  [6479] = {.lex_state = 344},
  [6480] = {.lex_state = 186},
  [6481] = {.lex_state = 344},
  [6482] = {.lex_state = 344},
  [6483] = {.lex_state = 344},
  [6484] = {.lex_state = 344},
  [6485] = {.lex_state = 344},
  [6486] = {.lex_state = 344, .external_lex_state = 21},
  [6487] = {.lex_state = 344},
  [6488] = {.lex_state = 344},
  [6489] = {.lex_state = 344},
  [6490] = {.lex_state = 344},
  [6491] = {.lex_state = 149},
  [6492] = {.lex_state = 344, .external_lex_state = 27},
  [6493] = {.lex_state = 344},
  [6494] = {.lex_state = 344},
  [6495] = {.lex_state = 344},
  [6496] = {.lex_state = 344},
  [6497] = {.lex_state = 344},
  [6498] = {.lex_state = 344},
  [6499] = {.lex_state = 344},
  [6500] = {.lex_state = 204},
  [6501] = {.lex_state = 344, .external_lex_state = 21},
  [6502] = {.lex_state = 344, .external_lex_state = 30},
  [6503] = {.lex_state = 344},
  [6504] = {.lex_state = 344, .external_lex_state = 28},
  [6505] = {.lex_state = 344, .external_lex_state = 28},
  [6506] = {.lex_state = 344},
  [6507] = {.lex_state = 344},
  [6508] = {.lex_state = 344},
  [6509] = {.lex_state = 344},
  [6510] = {.lex_state = 149},
  [6511] = {.lex_state = 344, .external_lex_state = 27},
  [6512] = {.lex_state = 344},
  [6513] = {.lex_state = 344, .external_lex_state = 21},
  [6514] = {.lex_state = 186},
  [6515] = {.lex_state = 344},
  [6516] = {.lex_state = 344},
  [6517] = {.lex_state = 344},
  [6518] = {.lex_state = 344},
  [6519] = {.lex_state = 344},
  [6520] = {.lex_state = 344},
  [6521] = {.lex_state = 344, .external_lex_state = 23},
  [6522] = {.lex_state = 344},
  [6523] = {.lex_state = 344},
  [6524] = {.lex_state = 186},
  [6525] = {.lex_state = 344},
  [6526] = {.lex_state = 344, .external_lex_state = 21},
  [6527] = {.lex_state = 344, .external_lex_state = 21},
  [6528] = {.lex_state = 344},
  [6529] = {.lex_state = 344},
  [6530] = {.lex_state = 186},
  [6531] = {.lex_state = 344},
  [6532] = {.lex_state = 186},
  [6533] = {.lex_state = 344},
  [6534] = {.lex_state = 186},
  [6535] = {.lex_state = 344, .external_lex_state = 21},
  [6536] = {.lex_state = 344},
  [6537] = {.lex_state = 344},
  [6538] = {.lex_state = 344},
  [6539] = {.lex_state = 344},
  [6540] = {.lex_state = 344},
  [6541] = {.lex_state = 344, .external_lex_state = 21},
  [6542] = {.lex_state = 344},
  [6543] = {.lex_state = 344, .external_lex_state = 24},
  [6544] = {.lex_state = 344},
  [6545] = {.lex_state = 344, .external_lex_state = 27},
  [6546] = {.lex_state = 344},
  [6547] = {.lex_state = 344},
  [6548] = {.lex_state = 344},
  [6549] = {.lex_state = 344},
  [6550] = {.lex_state = 344},
  [6551] = {.lex_state = 186},
  [6552] = {.lex_state = 186},
  [6553] = {.lex_state = 344},
  [6554] = {.lex_state = 344, .external_lex_state = 28},
  [6555] = {.lex_state = 344, .external_lex_state = 28},
  [6556] = {.lex_state = 344},
  [6557] = {.lex_state = 186},
  [6558] = {.lex_state = 344},
  [6559] = {.lex_state = 344},
  [6560] = {.lex_state = 344},
  [6561] = {.lex_state = 344, .external_lex_state = 27},
  [6562] = {.lex_state = 344},
  [6563] = {.lex_state = 344, .external_lex_state = 21},
  [6564] = {.lex_state = 149},
  [6565] = {.lex_state = 344},
  [6566] = {.lex_state = 344, .external_lex_state = 21},
  [6567] = {.lex_state = 344},
  [6568] = {.lex_state = 344},
  [6569] = {.lex_state = 344},
  [6570] = {.lex_state = 344},
  [6571] = {.lex_state = 344, .external_lex_state = 23},
  [6572] = {.lex_state = 186},
  [6573] = {.lex_state = 344},
  [6574] = {.lex_state = 344},
  [6575] = {.lex_state = 344},
  [6576] = {.lex_state = 344, .external_lex_state = 21},
  [6577] = {.lex_state = 344, .external_lex_state = 21},
  [6578] = {.lex_state = 344},
  [6579] = {.lex_state = 344},
  [6580] = {.lex_state = 344},
  [6581] = {.lex_state = 344},
  [6582] = {.lex_state = 344},
  [6583] = {.lex_state = 344},
  [6584] = {.lex_state = 344},
  [6585] = {.lex_state = 344},
  [6586] = {.lex_state = 344},
  [6587] = {.lex_state = 344},
  [6588] = {.lex_state = 186},
  [6589] = {.lex_state = 344},
  [6590] = {.lex_state = 344},
  [6591] = {.lex_state = 344, .external_lex_state = 21},
  [6592] = {.lex_state = 344},
  [6593] = {.lex_state = 344},
  [6594] = {.lex_state = 344},
  [6595] = {.lex_state = 344, .external_lex_state = 27},
  [6596] = {.lex_state = 344},
  [6597] = {.lex_state = 149},
  [6598] = {.lex_state = 344},
  [6599] = {.lex_state = 344},
  [6600] = {.lex_state = 186},
  [6601] = {.lex_state = 344},
  [6602] = {.lex_state = 344},
  [6603] = {.lex_state = 344},
  [6604] = {.lex_state = 344, .external_lex_state = 28},
  [6605] = {.lex_state = 344, .external_lex_state = 28},
  [6606] = {.lex_state = 344},
  [6607] = {.lex_state = 186},
  [6608] = {.lex_state = 149},
  [6609] = {.lex_state = 344},
  [6610] = {.lex_state = 344},
  [6611] = {.lex_state = 344, .external_lex_state = 27},
  [6612] = {.lex_state = 344},
  [6613] = {.lex_state = 344, .external_lex_state = 21},
  [6614] = {.lex_state = 344},
  [6615] = {.lex_state = 344},
  [6616] = {.lex_state = 344},
  [6617] = {.lex_state = 344, .external_lex_state = 30},
  [6618] = {.lex_state = 344},
  [6619] = {.lex_state = 344},
  [6620] = {.lex_state = 344, .external_lex_state = 23},
  [6621] = {.lex_state = 344},
  [6622] = {.lex_state = 344},
  [6623] = {.lex_state = 344},
  [6624] = {.lex_state = 344},
  [6625] = {.lex_state = 344, .external_lex_state = 21},
  [6626] = {.lex_state = 344, .external_lex_state = 21},
  [6627] = {.lex_state = 186},
  [6628] = {.lex_state = 344},
  [6629] = {.lex_state = 344, .external_lex_state = 29},
  [6630] = {.lex_state = 344},
  [6631] = {.lex_state = 344},
  [6632] = {.lex_state = 344},
  [6633] = {.lex_state = 344, .external_lex_state = 21},
  [6634] = {.lex_state = 344},
  [6635] = {.lex_state = 344, .external_lex_state = 29},
  [6636] = {.lex_state = 344},
  [6637] = {.lex_state = 344},
  [6638] = {.lex_state = 344},
  [6639] = {.lex_state = 344, .external_lex_state = 21},
  [6640] = {.lex_state = 344},
  [6641] = {.lex_state = 344, .external_lex_state = 21},
  [6642] = {.lex_state = 344},
  [6643] = {.lex_state = 344, .external_lex_state = 27},
  [6644] = {.lex_state = 344},
  [6645] = {.lex_state = 186},
  [6646] = {.lex_state = 344},
  [6647] = {.lex_state = 344},
  [6648] = {.lex_state = 344, .external_lex_state = 29},
  [6649] = {.lex_state = 344, .external_lex_state = 21},
  [6650] = {.lex_state = 344},
  [6651] = {.lex_state = 344},
  [6652] = {.lex_state = 344, .external_lex_state = 28},
  [6653] = {.lex_state = 344, .external_lex_state = 28},
  [6654] = {.lex_state = 344},
  [6655] = {.lex_state = 344},
  [6656] = {.lex_state = 344, .external_lex_state = 29},
  [6657] = {.lex_state = 344, .external_lex_state = 21},
  [6658] = {.lex_state = 344},
  [6659] = {.lex_state = 344, .external_lex_state = 27},
  [6660] = {.lex_state = 344},
  [6661] = {.lex_state = 344, .external_lex_state = 21},
  [6662] = {.lex_state = 344},
  [6663] = {.lex_state = 344},
  [6664] = {.lex_state = 344},
  [6665] = {.lex_state = 344},
  [6666] = {.lex_state = 344},
  [6667] = {.lex_state = 344},
  [6668] = {.lex_state = 344, .external_lex_state = 23},
  [6669] = {.lex_state = 186},
  [6670] = {.lex_state = 344},
  [6671] = {.lex_state = 344},
  [6672] = {.lex_state = 344, .external_lex_state = 24},
  [6673] = {.lex_state = 344, .external_lex_state = 21},
  [6674] = {.lex_state = 344, .external_lex_state = 21},
  [6675] = {.lex_state = 344},
  [6676] = {.lex_state = 344},
  [6677] = {.lex_state = 344, .external_lex_state = 29},
  [6678] = {.lex_state = 344},
  [6679] = {.lex_state = 344},
  [6680] = {.lex_state = 344},
  [6681] = {.lex_state = 344},
  [6682] = {.lex_state = 344},
  [6683] = {.lex_state = 186},
  [6684] = {.lex_state = 344},
  [6685] = {.lex_state = 344},
  [6686] = {.lex_state = 344},
  [6687] = {.lex_state = 344, .external_lex_state = 21},
  [6688] = {.lex_state = 344},
  [6689] = {.lex_state = 344},
  [6690] = {.lex_state = 344},
  [6691] = {.lex_state = 344, .external_lex_state = 27},
  [6692] = {.lex_state = 344, .external_lex_state = 30},
  [6693] = {.lex_state = 344, .external_lex_state = 24},
  [6694] = {.lex_state = 186},
  [6695] = {.lex_state = 344, .external_lex_state = 21},
  [6696] = {.lex_state = 344, .external_lex_state = 27},
  [6697] = {.lex_state = 344},
  [6698] = {.lex_state = 344},
  [6699] = {.lex_state = 344},
  [6700] = {.lex_state = 344, .external_lex_state = 28},
  [6701] = {.lex_state = 344, .external_lex_state = 28},
  [6702] = {.lex_state = 344},
  [6703] = {.lex_state = 344},
  [6704] = {.lex_state = 186},
  [6705] = {.lex_state = 344},
  [6706] = {.lex_state = 149},
  [6707] = {.lex_state = 344, .external_lex_state = 27},
  [6708] = {.lex_state = 344},
  [6709] = {.lex_state = 344, .external_lex_state = 21},
  [6710] = {.lex_state = 149},
  [6711] = {.lex_state = 344},
  [6712] = {.lex_state = 344},
  [6713] = {.lex_state = 344},
  [6714] = {.lex_state = 344, .external_lex_state = 21},
  [6715] = {.lex_state = 344},
  [6716] = {.lex_state = 344, .external_lex_state = 23},
  [6717] = {.lex_state = 344},
  [6718] = {.lex_state = 344},
  [6719] = {.lex_state = 344},
  [6720] = {.lex_state = 186},
  [6721] = {.lex_state = 344, .external_lex_state = 21},
  [6722] = {.lex_state = 344, .external_lex_state = 21},
  [6723] = {.lex_state = 344},
  [6724] = {.lex_state = 344},
  [6725] = {.lex_state = 344},
  [6726] = {.lex_state = 186},
  [6727] = {.lex_state = 344},
  [6728] = {.lex_state = 344},
  [6729] = {.lex_state = 344},
  [6730] = {.lex_state = 344},
  [6731] = {.lex_state = 186},
  [6732] = {.lex_state = 344},
  [6733] = {.lex_state = 344},
  [6734] = {.lex_state = 344},
  [6735] = {.lex_state = 344, .external_lex_state = 21},
  [6736] = {.lex_state = 344},
  [6737] = {.lex_state = 186},
  [6738] = {.lex_state = 344},
  [6739] = {.lex_state = 344, .external_lex_state = 27},
  [6740] = {.lex_state = 344, .external_lex_state = 21},
  [6741] = {.lex_state = 344},
  [6742] = {.lex_state = 344},
  [6743] = {.lex_state = 344},
  [6744] = {.lex_state = 344},
  [6745] = {.lex_state = 344, .external_lex_state = 21},
  [6746] = {.lex_state = 344},
  [6747] = {.lex_state = 344, .external_lex_state = 28},
  [6748] = {.lex_state = 344, .external_lex_state = 28},
  [6749] = {.lex_state = 344},
  [6750] = {.lex_state = 344},
  [6751] = {.lex_state = 344, .external_lex_state = 21},
  [6752] = {.lex_state = 344, .external_lex_state = 21},
  [6753] = {.lex_state = 344},
  [6754] = {.lex_state = 344, .external_lex_state = 27},
  [6755] = {.lex_state = 344, .external_lex_state = 21},
  [6756] = {.lex_state = 344},
  [6757] = {.lex_state = 344},
  [6758] = {.lex_state = 344},
  [6759] = {.lex_state = 344},
  [6760] = {.lex_state = 344, .external_lex_state = 21},
  [6761] = {.lex_state = 344},
  [6762] = {.lex_state = 344, .external_lex_state = 23},
  [6763] = {.lex_state = 344, .external_lex_state = 21},
  [6764] = {.lex_state = 344},
  [6765] = {.lex_state = 186},
  [6766] = {.lex_state = 344, .external_lex_state = 21},
  [6767] = {.lex_state = 344, .external_lex_state = 21},
  [6768] = {.lex_state = 344},
  [6769] = {.lex_state = 344},
  [6770] = {.lex_state = 344},
  [6771] = {.lex_state = 344},
  [6772] = {.lex_state = 344},
  [6773] = {.lex_state = 149},
  [6774] = {.lex_state = 344},
  [6775] = {.lex_state = 344},
  [6776] = {.lex_state = 344},
  [6777] = {.lex_state = 186},
  [6778] = {.lex_state = 344},
  [6779] = {.lex_state = 344},
  [6780] = {.lex_state = 344, .external_lex_state = 21},
  [6781] = {.lex_state = 344},
  [6782] = {.lex_state = 186},
  [6783] = {.lex_state = 344},
  [6784] = {.lex_state = 344, .external_lex_state = 27},
  [6785] = {.lex_state = 186},
  [6786] = {.lex_state = 344},
  [6787] = {.lex_state = 344, .external_lex_state = 28},
  [6788] = {.lex_state = 344, .external_lex_state = 28},
  [6789] = {.lex_state = 344},
  [6790] = {.lex_state = 186},
  [6791] = {.lex_state = 186},
  [6792] = {.lex_state = 344},
  [6793] = {.lex_state = 344},
  [6794] = {.lex_state = 344, .external_lex_state = 27},
  [6795] = {.lex_state = 344, .external_lex_state = 21},
  [6796] = {.lex_state = 344},
  [6797] = {.lex_state = 344},
  [6798] = {.lex_state = 344},
  [6799] = {.lex_state = 344},
  [6800] = {.lex_state = 344},
  [6801] = {.lex_state = 344},
  [6802] = {.lex_state = 344, .external_lex_state = 23},
  [6803] = {.lex_state = 344, .external_lex_state = 30},
  [6804] = {.lex_state = 344},
  [6805] = {.lex_state = 344, .external_lex_state = 29},
  [6806] = {.lex_state = 344, .external_lex_state = 21},
  [6807] = {.lex_state = 344, .external_lex_state = 21},
  [6808] = {.lex_state = 344},
  [6809] = {.lex_state = 344},
  [6810] = {.lex_state = 344},
  [6811] = {.lex_state = 344},
  [6812] = {.lex_state = 344},
  [6813] = {.lex_state = 344},
  [6814] = {.lex_state = 186},
  [6815] = {.lex_state = 344},
  [6816] = {.lex_state = 344},
  [6817] = {.lex_state = 344},
  [6818] = {.lex_state = 344},
  [6819] = {.lex_state = 344},
  [6820] = {.lex_state = 344, .external_lex_state = 21},
  [6821] = {.lex_state = 344},
  [6822] = {.lex_state = 344},
  [6823] = {.lex_state = 344},
  [6824] = {.lex_state = 344, .external_lex_state = 27},
  [6825] = {.lex_state = 149},
  [6826] = {.lex_state = 344},
  [6827] = {.lex_state = 344, .external_lex_state = 28},
  [6828] = {.lex_state = 344, .external_lex_state = 28},
  [6829] = {.lex_state = 344},
  [6830] = {.lex_state = 344},
  [6831] = {.lex_state = 344},
  [6832] = {.lex_state = 344},
  [6833] = {.lex_state = 344, .external_lex_state = 21},
  [6834] = {.lex_state = 344, .external_lex_state = 27},
  [6835] = {.lex_state = 344, .external_lex_state = 21},
  [6836] = {.lex_state = 186},
  [6837] = {.lex_state = 344},
  [6838] = {.lex_state = 344},
  [6839] = {.lex_state = 344, .external_lex_state = 29},
  [6840] = {.lex_state = 344},
  [6841] = {.lex_state = 344},
  [6842] = {.lex_state = 344, .external_lex_state = 23},
  [6843] = {.lex_state = 344},
  [6844] = {.lex_state = 344},
  [6845] = {.lex_state = 344, .external_lex_state = 21},
  [6846] = {.lex_state = 344, .external_lex_state = 21},
  [6847] = {.lex_state = 344, .external_lex_state = 21},
  [6848] = {.lex_state = 344},
  [6849] = {.lex_state = 186},
  [6850] = {.lex_state = 344},
  [6851] = {.lex_state = 344},
  [6852] = {.lex_state = 344},
  [6853] = {.lex_state = 344},
  [6854] = {.lex_state = 344},
  [6855] = {.lex_state = 344},
  [6856] = {.lex_state = 344},
  [6857] = {.lex_state = 344},
  [6858] = {.lex_state = 344},
  [6859] = {.lex_state = 344, .external_lex_state = 21},
  [6860] = {.lex_state = 344, .external_lex_state = 21},
  [6861] = {.lex_state = 186},
  [6862] = {.lex_state = 344},
  [6863] = {.lex_state = 344},
  [6864] = {.lex_state = 344, .external_lex_state = 27},
  [6865] = {.lex_state = 344},
  [6866] = {.lex_state = 344, .external_lex_state = 21},
  [6867] = {.lex_state = 344, .external_lex_state = 28},
  [6868] = {.lex_state = 344, .external_lex_state = 28},
  [6869] = {.lex_state = 344},
  [6870] = {.lex_state = 344},
  [6871] = {.lex_state = 344},
  [6872] = {.lex_state = 344},
  [6873] = {.lex_state = 344},
  [6874] = {.lex_state = 344, .external_lex_state = 27},
  [6875] = {.lex_state = 344, .external_lex_state = 21},
  [6876] = {.lex_state = 344},
  [6877] = {.lex_state = 344},
  [6878] = {.lex_state = 344},
  [6879] = {.lex_state = 149},
  [6880] = {.lex_state = 344},
  [6881] = {.lex_state = 344},
  [6882] = {.lex_state = 344, .external_lex_state = 23},
  [6883] = {.lex_state = 344},
  [6884] = {.lex_state = 344},
  [6885] = {.lex_state = 186},
  [6886] = {.lex_state = 344, .external_lex_state = 21},
  [6887] = {.lex_state = 344, .external_lex_state = 21},
  [6888] = {.lex_state = 344},
  [6889] = {.lex_state = 344},
  [6890] = {.lex_state = 344},
  [6891] = {.lex_state = 186},
  [6892] = {.lex_state = 344},
  [6893] = {.lex_state = 344},
  [6894] = {.lex_state = 344, .external_lex_state = 21},
  [6895] = {.lex_state = 344},
  [6896] = {.lex_state = 344},
  [6897] = {.lex_state = 344},
  [6898] = {.lex_state = 344},
  [6899] = {.lex_state = 344},
  [6900] = {.lex_state = 344, .external_lex_state = 21},
  [6901] = {.lex_state = 344, .external_lex_state = 29},
  [6902] = {.lex_state = 344},
  [6903] = {.lex_state = 344},
  [6904] = {.lex_state = 344, .external_lex_state = 27},
  [6905] = {.lex_state = 344, .external_lex_state = 21},
  [6906] = {.lex_state = 186},
  [6907] = {.lex_state = 344, .external_lex_state = 28},
  [6908] = {.lex_state = 344, .external_lex_state = 28},
  [6909] = {.lex_state = 344},
  [6910] = {.lex_state = 344},
  [6911] = {.lex_state = 344, .external_lex_state = 21},
  [6912] = {.lex_state = 186},
  [6913] = {.lex_state = 344},
  [6914] = {.lex_state = 344},
  [6915] = {.lex_state = 344, .external_lex_state = 21},
  [6916] = {.lex_state = 344},
  [6917] = {.lex_state = 186},
  [6918] = {.lex_state = 344},
  [6919] = {.lex_state = 344},
  [6920] = {.lex_state = 344},
  [6921] = {.lex_state = 344},
  [6922] = {.lex_state = 344},
  [6923] = {.lex_state = 344, .external_lex_state = 28},
  [6924] = {.lex_state = 344, .external_lex_state = 28},
  [6925] = {.lex_state = 344},
  [6926] = {.lex_state = 344, .external_lex_state = 29},
  [6927] = {.lex_state = 344, .external_lex_state = 21},
  [6928] = {.lex_state = 344},
  [6929] = {.lex_state = 344},
  [6930] = {.lex_state = 344},
  [6931] = {.lex_state = 186},
  [6932] = {.lex_state = 344},
  [6933] = {.lex_state = 344, .external_lex_state = 30},
  [6934] = {.lex_state = 344, .external_lex_state = 28},
  [6935] = {.lex_state = 344, .external_lex_state = 28},
  [6936] = {.lex_state = 344},
  [6937] = {.lex_state = 344},
  [6938] = {.lex_state = 344, .external_lex_state = 21},
  [6939] = {.lex_state = 344},
  [6940] = {.lex_state = 344},
  [6941] = {.lex_state = 344},
  [6942] = {.lex_state = 344},
  [6943] = {.lex_state = 344},
  [6944] = {.lex_state = 344},
  [6945] = {.lex_state = 344, .external_lex_state = 28},
  [6946] = {.lex_state = 344, .external_lex_state = 28},
  [6947] = {.lex_state = 344},
  [6948] = {.lex_state = 186},
  [6949] = {.lex_state = 344, .external_lex_state = 21},
  [6950] = {.lex_state = 344},
  [6951] = {.lex_state = 149},
  [6952] = {.lex_state = 344},
  [6953] = {.lex_state = 344},
  [6954] = {.lex_state = 344, .external_lex_state = 28},
  [6955] = {.lex_state = 344, .external_lex_state = 28},
  [6956] = {.lex_state = 344},
  [6957] = {.lex_state = 149},
  [6958] = {.lex_state = 344, .external_lex_state = 21},
  [6959] = {.lex_state = 186},
  [6960] = {.lex_state = 344},
  [6961] = {.lex_state = 344},
  [6962] = {.lex_state = 344},
  [6963] = {.lex_state = 344, .external_lex_state = 28},
  [6964] = {.lex_state = 344, .external_lex_state = 28},
  [6965] = {.lex_state = 344},
  [6966] = {.lex_state = 344},
  [6967] = {.lex_state = 344, .external_lex_state = 21},
  [6968] = {.lex_state = 344},
  [6969] = {.lex_state = 186},
  [6970] = {.lex_state = 344},
  [6971] = {.lex_state = 344},
  [6972] = {.lex_state = 344, .external_lex_state = 28},
  [6973] = {.lex_state = 344, .external_lex_state = 28},
  [6974] = {.lex_state = 344},
  [6975] = {.lex_state = 344},
  [6976] = {.lex_state = 344, .external_lex_state = 21},
  [6977] = {.lex_state = 344},
  [6978] = {.lex_state = 344},
  [6979] = {.lex_state = 344, .external_lex_state = 30},
  [6980] = {.lex_state = 344},
  [6981] = {.lex_state = 344, .external_lex_state = 28},
  [6982] = {.lex_state = 344, .external_lex_state = 28},
  [6983] = {.lex_state = 344},
  [6984] = {.lex_state = 344, .external_lex_state = 21},
  [6985] = {.lex_state = 344, .external_lex_state = 21},
  [6986] = {.lex_state = 344},
  [6987] = {.lex_state = 344, .external_lex_state = 28},
  [6988] = {.lex_state = 344, .external_lex_state = 28},
  [6989] = {.lex_state = 344},
  [6990] = {.lex_state = 344, .external_lex_state = 21},
  [6991] = {.lex_state = 344, .external_lex_state = 29},
  [6992] = {.lex_state = 344},
  [6993] = {.lex_state = 344, .external_lex_state = 28},
  [6994] = {.lex_state = 344, .external_lex_state = 28},
  [6995] = {.lex_state = 344},
  [6996] = {.lex_state = 344, .external_lex_state = 21},
  [6997] = {.lex_state = 149},
  [6998] = {.lex_state = 344},
  [6999] = {.lex_state = 186},
  [7000] = {.lex_state = 344, .external_lex_state = 21},
  [7001] = {.lex_state = 186},
  [7002] = {.lex_state = 344},
  [7003] = {.lex_state = 344},
  [7004] = {.lex_state = 344, .external_lex_state = 21},
  [7005] = {.lex_state = 149},
  [7006] = {.lex_state = 344},
  [7007] = {.lex_state = 344},
  [7008] = {.lex_state = 344, .external_lex_state = 21},
  [7009] = {.lex_state = 344, .external_lex_state = 24},
  [7010] = {.lex_state = 344, .external_lex_state = 21},
  [7011] = {.lex_state = 186},
  [7012] = {.lex_state = 344, .external_lex_state = 21},
  [7013] = {.lex_state = 344},
  [7014] = {.lex_state = 344},
  [7015] = {.lex_state = 344},
  [7016] = {.lex_state = 344, .external_lex_state = 21},
  [7017] = {.lex_state = 344, .external_lex_state = 23},
  [7018] = {.lex_state = 149},
  [7019] = {.lex_state = 344},
  [7020] = {.lex_state = 344, .external_lex_state = 21},
  [7021] = {.lex_state = 344},
  [7022] = {.lex_state = 344},
  [7023] = {.lex_state = 344},
  [7024] = {.lex_state = 344, .external_lex_state = 21},
  [7025] = {.lex_state = 344},
  [7026] = {.lex_state = 186},
  [7027] = {.lex_state = 344},
  [7028] = {.lex_state = 344, .external_lex_state = 21},
  [7029] = {.lex_state = 344, .external_lex_state = 29},
  [7030] = {.lex_state = 344},
  [7031] = {.lex_state = 344, .external_lex_state = 21},
  [7032] = {.lex_state = 344, .external_lex_state = 21},
  [7033] = {.lex_state = 344},
  [7034] = {.lex_state = 344},
  [7035] = {.lex_state = 149},
  [7036] = {.lex_state = 344, .external_lex_state = 21},
  [7037] = {.lex_state = 344},
  [7038] = {.lex_state = 344},
  [7039] = {.lex_state = 344},
  [7040] = {.lex_state = 344, .external_lex_state = 21},
  [7041] = {.lex_state = 344},
  [7042] = {.lex_state = 344},
  [7043] = {.lex_state = 149},
  [7044] = {.lex_state = 344, .external_lex_state = 21},
  [7045] = {.lex_state = 344},
  [7046] = {.lex_state = 344},
  [7047] = {.lex_state = 344},
  [7048] = {.lex_state = 344, .external_lex_state = 21},
  [7049] = {.lex_state = 344},
  [7050] = {.lex_state = 344},
  [7051] = {.lex_state = 344},
  [7052] = {.lex_state = 344, .external_lex_state = 21},
  [7053] = {.lex_state = 344, .external_lex_state = 27},
  [7054] = {.lex_state = 344},
  [7055] = {.lex_state = 344, .external_lex_state = 21},
  [7056] = {.lex_state = 344, .external_lex_state = 21},
  [7057] = {.lex_state = 344},
  [7058] = {.lex_state = 344, .external_lex_state = 29},
  [7059] = {.lex_state = 344, .external_lex_state = 21},
  [7060] = {.lex_state = 344, .external_lex_state = 21},
  [7061] = {.lex_state = 344},
  [7062] = {.lex_state = 344},
  [7063] = {.lex_state = 344},
  [7064] = {.lex_state = 344, .external_lex_state = 21},
  [7065] = {.lex_state = 186},
  [7066] = {.lex_state = 344},
  [7067] = {.lex_state = 344},
  [7068] = {.lex_state = 344, .external_lex_state = 21},
  [7069] = {.lex_state = 344},
  [7070] = {.lex_state = 344, .external_lex_state = 29},
  [7071] = {.lex_state = 344},
  [7072] = {.lex_state = 344, .external_lex_state = 21},
  [7073] = {.lex_state = 344},
  [7074] = {.lex_state = 344, .external_lex_state = 30},
  [7075] = {.lex_state = 344},
  [7076] = {.lex_state = 344, .external_lex_state = 21},
  [7077] = {.lex_state = 344},
  [7078] = {.lex_state = 344},
  [7079] = {.lex_state = 344},
  [7080] = {.lex_state = 344, .external_lex_state = 21},
  [7081] = {.lex_state = 149},
  [7082] = {.lex_state = 149},
  [7083] = {.lex_state = 344},
  [7084] = {.lex_state = 186},
  [7085] = {.lex_state = 344},
  [7086] = {.lex_state = 344},
  [7087] = {.lex_state = 186},
  [7088] = {.lex_state = 344},
  [7089] = {.lex_state = 344, .external_lex_state = 21},
  [7090] = {.lex_state = 344},
  [7091] = {.lex_state = 149},
  [7092] = {.lex_state = 344},
  [7093] = {.lex_state = 344},
  [7094] = {.lex_state = 344},
  [7095] = {.lex_state = 344, .external_lex_state = 24},
  [7096] = {.lex_state = 344},
  [7097] = {.lex_state = 344},
  [7098] = {.lex_state = 149},
  [7099] = {.lex_state = 344},
  [7100] = {.lex_state = 344},
  [7101] = {.lex_state = 344},
  [7102] = {.lex_state = 344},
  [7103] = {.lex_state = 344, .external_lex_state = 24},
  [7104] = {.lex_state = 344},
  [7105] = {.lex_state = 344},
  [7106] = {.lex_state = 344},
  [7107] = {.lex_state = 344},
  [7108] = {.lex_state = 344},
  [7109] = {.lex_state = 344},
  [7110] = {.lex_state = 344, .external_lex_state = 21},
  [7111] = {.lex_state = 344},
  [7112] = {.lex_state = 344},
  [7113] = {.lex_state = 186},
  [7114] = {.lex_state = 344},
  [7115] = {.lex_state = 344},
  [7116] = {.lex_state = 344},
  [7117] = {.lex_state = 344, .external_lex_state = 23},
  [7118] = {.lex_state = 344},
  [7119] = {.lex_state = 186},
  [7120] = {.lex_state = 186},
  [7121] = {.lex_state = 344},
  [7122] = {.lex_state = 344, .external_lex_state = 21},
  [7123] = {.lex_state = 344},
  [7124] = {.lex_state = 344},
  [7125] = {.lex_state = 344},
  [7126] = {.lex_state = 149},
  [7127] = {.lex_state = 344, .external_lex_state = 24},
  [7128] = {.lex_state = 344},
  [7129] = {.lex_state = 344},
  [7130] = {.lex_state = 344},
  [7131] = {.lex_state = 344},
  [7132] = {.lex_state = 344},
  [7133] = {.lex_state = 344},
  [7134] = {.lex_state = 344, .external_lex_state = 24},
  [7135] = {.lex_state = 186},
  [7136] = {.lex_state = 344},
  [7137] = {.lex_state = 186},
  [7138] = {.lex_state = 344},
  [7139] = {.lex_state = 344},
  [7140] = {.lex_state = 344},
  [7141] = {.lex_state = 149},
  [7142] = {.lex_state = 344},
  [7143] = {.lex_state = 149},
  [7144] = {.lex_state = 344},
  [7145] = {.lex_state = 149},
  [7146] = {.lex_state = 344},
  [7147] = {.lex_state = 344},
  [7148] = {.lex_state = 344},
  [7149] = {.lex_state = 344},
  [7150] = {.lex_state = 186},
  [7151] = {.lex_state = 344},
  [7152] = {.lex_state = 344},
  [7153] = {.lex_state = 344},
  [7154] = {.lex_state = 344, .external_lex_state = 24},
  [7155] = {.lex_state = 344},
  [7156] = {.lex_state = 344},
  [7157] = {.lex_state = 344},
  [7158] = {.lex_state = 344},
  [7159] = {.lex_state = 149},
  [7160] = {.lex_state = 344},
  [7161] = {.lex_state = 344, .external_lex_state = 24},
  [7162] = {.lex_state = 344},
  [7163] = {.lex_state = 344, .external_lex_state = 27},
  [7164] = {.lex_state = 186},
  [7165] = {.lex_state = 344},
  [7166] = {.lex_state = 344},
  [7167] = {.lex_state = 344},
  [7168] = {.lex_state = 344},
  [7169] = {.lex_state = 344, .external_lex_state = 30},
  [7170] = {.lex_state = 344},
  [7171] = {.lex_state = 344},
  [7172] = {.lex_state = 344},
  [7173] = {.lex_state = 344},
  [7174] = {.lex_state = 344},
  [7175] = {.lex_state = 344},
  [7176] = {.lex_state = 344},
  [7177] = {.lex_state = 344},
  [7178] = {.lex_state = 344, .external_lex_state = 24},
  [7179] = {.lex_state = 344},
  [7180] = {.lex_state = 344},
  [7181] = {.lex_state = 344},
  [7182] = {.lex_state = 149},
  [7183] = {.lex_state = 344},
  [7184] = {.lex_state = 344},
  [7185] = {.lex_state = 344, .external_lex_state = 24},
  [7186] = {.lex_state = 344},
  [7187] = {.lex_state = 344},
  [7188] = {.lex_state = 344},
  [7189] = {.lex_state = 344},
  [7190] = {.lex_state = 344},
  [7191] = {.lex_state = 344},
  [7192] = {.lex_state = 344, .external_lex_state = 29},
  [7193] = {.lex_state = 344},
  [7194] = {.lex_state = 344},
  [7195] = {.lex_state = 186},
  [7196] = {.lex_state = 344},
  [7197] = {.lex_state = 344},
  [7198] = {.lex_state = 344},
  [7199] = {.lex_state = 344, .external_lex_state = 21},
  [7200] = {.lex_state = 149},
  [7201] = {.lex_state = 344, .external_lex_state = 24},
  [7202] = {.lex_state = 344},
  [7203] = {.lex_state = 344},
  [7204] = {.lex_state = 344},
  [7205] = {.lex_state = 344, .external_lex_state = 29},
  [7206] = {.lex_state = 344, .external_lex_state = 21},
  [7207] = {.lex_state = 344},
  [7208] = {.lex_state = 344, .external_lex_state = 24},
  [7209] = {.lex_state = 344},
  [7210] = {.lex_state = 344},
  [7211] = {.lex_state = 186},
  [7212] = {.lex_state = 344},
  [7213] = {.lex_state = 344},
  [7214] = {.lex_state = 344, .external_lex_state = 21},
  [7215] = {.lex_state = 344},
  [7216] = {.lex_state = 344},
  [7217] = {.lex_state = 344},
  [7218] = {.lex_state = 344},
  [7219] = {.lex_state = 344},
  [7220] = {.lex_state = 344, .external_lex_state = 29},
  [7221] = {.lex_state = 344},
  [7222] = {.lex_state = 344, .external_lex_state = 24},
  [7223] = {.lex_state = 344},
  [7224] = {.lex_state = 344},
  [7225] = {.lex_state = 344, .external_lex_state = 29},
  [7226] = {.lex_state = 344},
  [7227] = {.lex_state = 344, .external_lex_state = 30},
  [7228] = {.lex_state = 344},
  [7229] = {.lex_state = 344, .external_lex_state = 24},
  [7230] = {.lex_state = 344, .external_lex_state = 21},
  [7231] = {.lex_state = 344},
  [7232] = {.lex_state = 186},
  [7233] = {.lex_state = 344},
  [7234] = {.lex_state = 344},
  [7235] = {.lex_state = 149},
  [7236] = {.lex_state = 344},
  [7237] = {.lex_state = 149},
  [7238] = {.lex_state = 344},
  [7239] = {.lex_state = 344},
  [7240] = {.lex_state = 344},
  [7241] = {.lex_state = 344},
  [7242] = {.lex_state = 344},
  [7243] = {.lex_state = 344, .external_lex_state = 24},
  [7244] = {.lex_state = 344},
  [7245] = {.lex_state = 344},
  [7246] = {.lex_state = 344},
  [7247] = {.lex_state = 344},
  [7248] = {.lex_state = 344},
  [7249] = {.lex_state = 344},
  [7250] = {.lex_state = 344, .external_lex_state = 24},
  [7251] = {.lex_state = 344},
  [7252] = {.lex_state = 344},
  [7253] = {.lex_state = 344, .external_lex_state = 21},
  [7254] = {.lex_state = 186},
  [7255] = {.lex_state = 344},
  [7256] = {.lex_state = 344, .external_lex_state = 24},
  [7257] = {.lex_state = 344},
  [7258] = {.lex_state = 344},
  [7259] = {.lex_state = 344},
  [7260] = {.lex_state = 149},
  [7261] = {.lex_state = 344},
  [7262] = {.lex_state = 344, .external_lex_state = 24},
  [7263] = {.lex_state = 344},
  [7264] = {.lex_state = 344, .external_lex_state = 24},
  [7265] = {.lex_state = 344},
  [7266] = {.lex_state = 344},
  [7267] = {.lex_state = 344},
  [7268] = {.lex_state = 344},
  [7269] = {.lex_state = 344},
  [7270] = {.lex_state = 344, .external_lex_state = 24},
  [7271] = {.lex_state = 344, .external_lex_state = 24},
  [7272] = {.lex_state = 344, .external_lex_state = 24},
  [7273] = {.lex_state = 344},
  [7274] = {.lex_state = 344},
  [7275] = {.lex_state = 149},
  [7276] = {.lex_state = 344},
  [7277] = {.lex_state = 344},
  [7278] = {.lex_state = 186},
  [7279] = {.lex_state = 186},
  [7280] = {.lex_state = 344},
  [7281] = {.lex_state = 344},
  [7282] = {.lex_state = 344, .external_lex_state = 24},
  [7283] = {.lex_state = 344},
  [7284] = {.lex_state = 344},
  [7285] = {.lex_state = 149},
  [7286] = {.lex_state = 344},
  [7287] = {.lex_state = 344},
  [7288] = {.lex_state = 344},
  [7289] = {.lex_state = 344, .external_lex_state = 24},
  [7290] = {.lex_state = 344},
  [7291] = {.lex_state = 344, .external_lex_state = 24},
  [7292] = {.lex_state = 344},
  [7293] = {.lex_state = 186},
  [7294] = {.lex_state = 186},
  [7295] = {.lex_state = 344},
  [7296] = {.lex_state = 344},
  [7297] = {.lex_state = 344},
  [7298] = {.lex_state = 344, .external_lex_state = 23},
  [7299] = {.lex_state = 344},
  [7300] = {.lex_state = 344, .external_lex_state = 24},
  [7301] = {.lex_state = 344},
  [7302] = {.lex_state = 344},
  [7303] = {.lex_state = 344, .external_lex_state = 23},
  [7304] = {.lex_state = 1},
  [7305] = {.lex_state = 344},
  [7306] = {.lex_state = 149},
  [7307] = {.lex_state = 344, .external_lex_state = 24},
  [7308] = {.lex_state = 344},
  [7309] = {.lex_state = 149},
  [7310] = {.lex_state = 344},
  [7311] = {.lex_state = 344},
  [7312] = {.lex_state = 149},
  [7313] = {.lex_state = 344, .external_lex_state = 23},
  [7314] = {.lex_state = 344},
  [7315] = {.lex_state = 344},
  [7316] = {.lex_state = 186},
  [7317] = {.lex_state = 344},
  [7318] = {.lex_state = 344, .external_lex_state = 24},
  [7319] = {.lex_state = 344},
  [7320] = {.lex_state = 344},
  [7321] = {.lex_state = 344},
  [7322] = {.lex_state = 344},
  [7323] = {.lex_state = 186},
  [7324] = {.lex_state = 344, .external_lex_state = 21},
  [7325] = {.lex_state = 344, .external_lex_state = 24},
  [7326] = {.lex_state = 344},
  [7327] = {.lex_state = 344, .external_lex_state = 21},
  [7328] = {.lex_state = 344},
  [7329] = {.lex_state = 344},
  [7330] = {.lex_state = 344},
  [7331] = {.lex_state = 344},
  [7332] = {.lex_state = 344},
  [7333] = {.lex_state = 344},
  [7334] = {.lex_state = 344},
  [7335] = {.lex_state = 344},
  [7336] = {.lex_state = 344},
  [7337] = {.lex_state = 344},
  [7338] = {.lex_state = 344},
  [7339] = {.lex_state = 1},
  [7340] = {.lex_state = 344, .external_lex_state = 23},
  [7341] = {.lex_state = 344},
  [7342] = {.lex_state = 344},
  [7343] = {.lex_state = 344},
  [7344] = {.lex_state = 344},
  [7345] = {.lex_state = 149},
  [7346] = {.lex_state = 344},
  [7347] = {.lex_state = 344},
  [7348] = {.lex_state = 344},
  [7349] = {.lex_state = 344, .external_lex_state = 21},
  [7350] = {.lex_state = 344},
  [7351] = {.lex_state = 344, .external_lex_state = 29},
  [7352] = {.lex_state = 344, .external_lex_state = 21},
  [7353] = {.lex_state = 344},
  [7354] = {.lex_state = 344},
  [7355] = {.lex_state = 186},
  [7356] = {.lex_state = 344},
  [7357] = {.lex_state = 344},
  [7358] = {.lex_state = 149},
  [7359] = {.lex_state = 344, .external_lex_state = 29},
  [7360] = {.lex_state = 344},
  [7361] = {.lex_state = 344, .external_lex_state = 30},
  [7362] = {.lex_state = 149},
  [7363] = {.lex_state = 344, .external_lex_state = 23},
  [7364] = {.lex_state = 344},
  [7365] = {.lex_state = 186},
  [7366] = {.lex_state = 344},
  [7367] = {.lex_state = 344},
  [7368] = {.lex_state = 149},
  [7369] = {.lex_state = 344},
  [7370] = {.lex_state = 344},
  [7371] = {.lex_state = 344},
  [7372] = {.lex_state = 344, .external_lex_state = 24},
  [7373] = {.lex_state = 344, .external_lex_state = 24},
  [7374] = {.lex_state = 344, .external_lex_state = 24},
  [7375] = {.lex_state = 344},
  [7376] = {.lex_state = 344},
  [7377] = {.lex_state = 344, .external_lex_state = 24},
  [7378] = {.lex_state = 344},
  [7379] = {.lex_state = 344},
  [7380] = {.lex_state = 344},
  [7381] = {.lex_state = 344},
  [7382] = {.lex_state = 344, .external_lex_state = 21},
  [7383] = {.lex_state = 344},
  [7384] = {.lex_state = 344},
  [7385] = {.lex_state = 186},
  [7386] = {.lex_state = 344, .external_lex_state = 30},
  [7387] = {.lex_state = 344},
  [7388] = {.lex_state = 344},
  [7389] = {.lex_state = 344, .external_lex_state = 24},
  [7390] = {.lex_state = 344, .external_lex_state = 24},
  [7391] = {.lex_state = 344, .external_lex_state = 24},
  [7392] = {.lex_state = 344, .external_lex_state = 29},
  [7393] = {.lex_state = 344, .external_lex_state = 24},
  [7394] = {.lex_state = 344},
  [7395] = {.lex_state = 344, .external_lex_state = 28},
  [7396] = {.lex_state = 344},
  [7397] = {.lex_state = 344},
  [7398] = {.lex_state = 344, .external_lex_state = 24},
  [7399] = {.lex_state = 344, .external_lex_state = 24},
  [7400] = {.lex_state = 344, .external_lex_state = 24},
  [7401] = {.lex_state = 344, .external_lex_state = 28},
  [7402] = {.lex_state = 344, .external_lex_state = 24},
  [7403] = {.lex_state = 186},
  [7404] = {.lex_state = 344, .external_lex_state = 21},
  [7405] = {.lex_state = 344, .external_lex_state = 29},
  [7406] = {.lex_state = 344},
  [7407] = {.lex_state = 344, .external_lex_state = 24},
  [7408] = {.lex_state = 344, .external_lex_state = 24},
  [7409] = {.lex_state = 344, .external_lex_state = 24},
  [7410] = {.lex_state = 344},
  [7411] = {.lex_state = 344, .external_lex_state = 24},
  [7412] = {.lex_state = 344},
  [7413] = {.lex_state = 344},
  [7414] = {.lex_state = 344},
  [7415] = {.lex_state = 344},
  [7416] = {.lex_state = 344, .external_lex_state = 24},
  [7417] = {.lex_state = 344, .external_lex_state = 24},
  [7418] = {.lex_state = 344, .external_lex_state = 24},
  [7419] = {.lex_state = 344, .external_lex_state = 31},
  [7420] = {.lex_state = 344, .external_lex_state = 24},
  [7421] = {.lex_state = 186},
  [7422] = {.lex_state = 149},
  [7423] = {.lex_state = 344},
  [7424] = {.lex_state = 344},
  [7425] = {.lex_state = 344, .external_lex_state = 24},
  [7426] = {.lex_state = 344, .external_lex_state = 24},
  [7427] = {.lex_state = 344, .external_lex_state = 24},
  [7428] = {.lex_state = 344},
  [7429] = {.lex_state = 344, .external_lex_state = 24},
  [7430] = {.lex_state = 186},
  [7431] = {.lex_state = 344},
  [7432] = {.lex_state = 344},
  [7433] = {.lex_state = 344},
  [7434] = {.lex_state = 344, .external_lex_state = 24},
  [7435] = {.lex_state = 344, .external_lex_state = 24},
  [7436] = {.lex_state = 344, .external_lex_state = 24},
  [7437] = {.lex_state = 149},
  [7438] = {.lex_state = 344, .external_lex_state = 24},
  [7439] = {.lex_state = 344, .external_lex_state = 21},
  [7440] = {.lex_state = 344},
  [7441] = {.lex_state = 344},
  [7442] = {.lex_state = 344},
  [7443] = {.lex_state = 344, .external_lex_state = 24},
  [7444] = {.lex_state = 344, .external_lex_state = 24},
  [7445] = {.lex_state = 344, .external_lex_state = 24},
  [7446] = {.lex_state = 186},
  [7447] = {.lex_state = 344, .external_lex_state = 24},
  [7448] = {.lex_state = 186},
  [7449] = {.lex_state = 344},
  [7450] = {.lex_state = 344, .external_lex_state = 24},
  [7451] = {.lex_state = 344, .external_lex_state = 24},
  [7452] = {.lex_state = 344, .external_lex_state = 24},
  [7453] = {.lex_state = 344},
  [7454] = {.lex_state = 344, .external_lex_state = 24},
  [7455] = {.lex_state = 149},
  [7456] = {.lex_state = 344},
  [7457] = {.lex_state = 344, .external_lex_state = 24},
  [7458] = {.lex_state = 344, .external_lex_state = 24},
  [7459] = {.lex_state = 344, .external_lex_state = 24},
  [7460] = {.lex_state = 344},
  [7461] = {.lex_state = 344, .external_lex_state = 24},
  [7462] = {.lex_state = 344},
  [7463] = {.lex_state = 344},
  [7464] = {.lex_state = 344, .external_lex_state = 24},
  [7465] = {.lex_state = 344, .external_lex_state = 24},
  [7466] = {.lex_state = 344, .external_lex_state = 24},
  [7467] = {.lex_state = 344},
  [7468] = {.lex_state = 344, .external_lex_state = 24},
  [7469] = {.lex_state = 344, .external_lex_state = 21},
  [7470] = {.lex_state = 344, .external_lex_state = 24},
  [7471] = {.lex_state = 344, .external_lex_state = 24},
  [7472] = {.lex_state = 344},
  [7473] = {.lex_state = 344, .external_lex_state = 24},
  [7474] = {.lex_state = 344},
  [7475] = {.lex_state = 344, .external_lex_state = 24},
  [7476] = {.lex_state = 344},
  [7477] = {.lex_state = 344, .external_lex_state = 24},
  [7478] = {.lex_state = 344, .external_lex_state = 24},
  [7479] = {.lex_state = 344, .external_lex_state = 24},
  [7480] = {.lex_state = 344, .external_lex_state = 24},
  [7481] = {.lex_state = 344, .external_lex_state = 24},
  [7482] = {.lex_state = 344, .external_lex_state = 24},
  [7483] = {.lex_state = 344, .external_lex_state = 24},
  [7484] = {.lex_state = 344, .external_lex_state = 24},
  [7485] = {.lex_state = 344, .external_lex_state = 24},
  [7486] = {.lex_state = 344, .external_lex_state = 24},
  [7487] = {.lex_state = 344, .external_lex_state = 24},
  [7488] = {.lex_state = 344, .external_lex_state = 24},
  [7489] = {.lex_state = 344, .external_lex_state = 24},
  [7490] = {.lex_state = 344, .external_lex_state = 24},
  [7491] = {.lex_state = 344, .external_lex_state = 24},
  [7492] = {.lex_state = 344, .external_lex_state = 24},
  [7493] = {.lex_state = 344, .external_lex_state = 24},
  [7494] = {.lex_state = 344, .external_lex_state = 24},
  [7495] = {.lex_state = 344, .external_lex_state = 24},
  [7496] = {.lex_state = 344, .external_lex_state = 24},
  [7497] = {.lex_state = 344, .external_lex_state = 24},
  [7498] = {.lex_state = 344, .external_lex_state = 24},
  [7499] = {.lex_state = 344, .external_lex_state = 24},
  [7500] = {.lex_state = 344, .external_lex_state = 24},
  [7501] = {.lex_state = 344, .external_lex_state = 24},
  [7502] = {.lex_state = 344, .external_lex_state = 24},
  [7503] = {.lex_state = 344, .external_lex_state = 24},
  [7504] = {.lex_state = 344, .external_lex_state = 24},
  [7505] = {.lex_state = 344},
  [7506] = {.lex_state = 344},
  [7507] = {.lex_state = 344},
  [7508] = {.lex_state = 344},
  [7509] = {.lex_state = 344},
  [7510] = {.lex_state = 344},
  [7511] = {.lex_state = 344},
  [7512] = {.lex_state = 149},
  [7513] = {.lex_state = 344},
  [7514] = {.lex_state = 344},
  [7515] = {.lex_state = 344},
  [7516] = {.lex_state = 1},
  [7517] = {.lex_state = 344},
  [7518] = {.lex_state = 344},
  [7519] = {.lex_state = 344},
  [7520] = {.lex_state = 344, .external_lex_state = 23},
  [7521] = {.lex_state = 344},
  [7522] = {.lex_state = 344},
  [7523] = {.lex_state = 344},
  [7524] = {.lex_state = 186},
  [7525] = {.lex_state = 344},
  [7526] = {.lex_state = 344},
  [7527] = {.lex_state = 344},
  [7528] = {.lex_state = 344},
  [7529] = {.lex_state = 344},
  [7530] = {.lex_state = 344},
  [7531] = {.lex_state = 149},
  [7532] = {.lex_state = 344},
  [7533] = {.lex_state = 344},
  [7534] = {.lex_state = 344},
  [7535] = {.lex_state = 344},
  [7536] = {.lex_state = 344},
  [7537] = {.lex_state = 344},
  [7538] = {.lex_state = 344},
  [7539] = {.lex_state = 186},
  [7540] = {.lex_state = 344},
  [7541] = {.lex_state = 149},
  [7542] = {.lex_state = 149},
  [7543] = {.lex_state = 344},
  [7544] = {.lex_state = 344, .external_lex_state = 23},
  [7545] = {.lex_state = 344},
  [7546] = {.lex_state = 344},
  [7547] = {.lex_state = 344},
  [7548] = {.lex_state = 344},
  [7549] = {.lex_state = 344, .external_lex_state = 27},
  [7550] = {(TSStateId)(-1)},
  [7551] = {(TSStateId)(-1)},
  [7552] = {(TSStateId)(-1)},
  [7553] = {(TSStateId)(-1)},
  [7554] = {(TSStateId)(-1)},
  [7555] = {(TSStateId)(-1)},
  [7556] = {(TSStateId)(-1)},
};

static const uint16_t ts_parse_table[LARGE_STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [sym_block_comment] = STATE(0),
    [sym_compiler_directive_decl] = STATE(0),
    [sym_fsi_directive_decl] = STATE(0),
    [sym_preproc_line] = STATE(0),
    [ts_builtin_sym_end] = ACTIONS(1),
    [sym_identifier] = ACTIONS(1),
    [anon_sym_namespace] = ACTIONS(1),
    [anon_sym_module] = ACTIONS(1),
    [anon_sym_EQ] = ACTIONS(1),
    [anon_sym_open] = ACTIONS(1),
    [anon_sym_LBRACK_LT] = ACTIONS(1),
    [anon_sym_COLON] = ACTIONS(1),
    [anon_sym_assembly] = ACTIONS(1),
    [anon_sym_return] = ACTIONS(1),
    [anon_sym_field] = ACTIONS(1),
    [anon_sym_property] = ACTIONS(1),
    [anon_sym_param] = ACTIONS(1),
    [anon_sym_type] = ACTIONS(1),
    [anon_sym_constructor] = ACTIONS(1),
    [anon_sym_event] = ACTIONS(1),
    [anon_sym_do] = ACTIONS(1),
    [anon_sym_and] = ACTIONS(1),
    [anon_sym_let] = ACTIONS(1),
    [anon_sym_let_BANG] = ACTIONS(1),
    [anon_sym_rec] = ACTIONS(1),
    [anon_sym_inline] = ACTIONS(1),
    [anon_sym_mutable] = ACTIONS(1),
    [aux_sym_access_modifier_token1] = ACTIONS(1),
    [anon_sym_as] = ACTIONS(1),
    [anon_sym_LPAREN] = ACTIONS(1),
    [anon_sym_RPAREN] = ACTIONS(1),
    [anon_sym_COMMA] = ACTIONS(1),
    [anon_sym_null] = ACTIONS(1),
    [anon_sym__] = ACTIONS(1),
    [anon_sym_QMARK] = ACTIONS(1),
    [anon_sym_COLON_QMARK] = ACTIONS(1),
    [anon_sym_COLON_COLON] = ACTIONS(1),
    [anon_sym_PIPE] = ACTIONS(1),
    [anon_sym_AMP] = ACTIONS(1),
    [anon_sym_LBRACK] = ACTIONS(1),
    [anon_sym_RBRACK] = ACTIONS(1),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1),
    [anon_sym_PIPE_RBRACK] = ACTIONS(1),
    [anon_sym_LBRACE] = ACTIONS(1),
    [anon_sym_RBRACE] = ACTIONS(1),
    [anon_sym_LT_AT] = ACTIONS(1),
    [anon_sym_AT_GT] = ACTIONS(1),
    [anon_sym_LT_AT_AT] = ACTIONS(1),
    [anon_sym_AT_AT_GT] = ACTIONS(1),
    [anon_sym_DOT] = ACTIONS(1),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1),
    [anon_sym_new] = ACTIONS(1),
    [anon_sym_with] = ACTIONS(1),
    [anon_sym_return_BANG] = ACTIONS(1),
    [anon_sym_yield] = ACTIONS(1),
    [anon_sym_yield_BANG] = ACTIONS(1),
    [anon_sym_lazy] = ACTIONS(1),
    [anon_sym_assert] = ACTIONS(1),
    [anon_sym_upcast] = ACTIONS(1),
    [anon_sym_downcast] = ACTIONS(1),
    [anon_sym_COLON_GT] = ACTIONS(1),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1),
    [anon_sym_for] = ACTIONS(1),
    [anon_sym_in] = ACTIONS(1),
    [anon_sym_to] = ACTIONS(1),
    [anon_sym_downto] = ACTIONS(1),
    [anon_sym_done] = ACTIONS(1),
    [anon_sym_while] = ACTIONS(1),
    [anon_sym_else] = ACTIONS(1),
    [anon_sym_then] = ACTIONS(1),
    [anon_sym_elif] = ACTIONS(1),
    [anon_sym_if] = ACTIONS(1),
    [anon_sym_fun] = ACTIONS(1),
    [anon_sym_DASH_GT] = ACTIONS(1),
    [anon_sym_try] = ACTIONS(1),
    [anon_sym_finally] = ACTIONS(1),
    [anon_sym_match] = ACTIONS(1),
    [anon_sym_match_BANG] = ACTIONS(1),
    [anon_sym_function] = ACTIONS(1),
    [anon_sym_LT_DASH] = ACTIONS(1),
    [anon_sym_DOT_LBRACK] = ACTIONS(1),
    [anon_sym_LT] = ACTIONS(1),
    [anon_sym_GT] = ACTIONS(1),
    [anon_sym_use] = ACTIONS(1),
    [anon_sym_use_BANG] = ACTIONS(1),
    [anon_sym_do_BANG] = ACTIONS(1),
    [anon_sym_DOT_DOT] = ACTIONS(1),
    [anon_sym_when] = ACTIONS(1),
    [anon_sym_begin] = ACTIONS(1),
    [anon_sym_end] = ACTIONS(1),
    [anon_sym_LPAREN2] = ACTIONS(1),
    [anon_sym_DOT_DOT2] = ACTIONS(1),
    [anon_sym_STAR] = ACTIONS(1),
    [anon_sym_LT2] = ACTIONS(1),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(1),
    [anon_sym_POUND] = ACTIONS(1),
    [anon_sym_CARET] = ACTIONS(1),
    [anon_sym_SQUOTE] = ACTIONS(1),
    [anon_sym_unit] = ACTIONS(1),
    [anon_sym_struct] = ACTIONS(1),
    [anon_sym_not] = ACTIONS(1),
    [anon_sym_enum] = ACTIONS(1),
    [anon_sym_unmanaged] = ACTIONS(1),
    [anon_sym_equality] = ACTIONS(1),
    [anon_sym_comparison] = ACTIONS(1),
    [anon_sym_delegate] = ACTIONS(1),
    [anon_sym_default] = ACTIONS(1),
    [anon_sym_or] = ACTIONS(1),
    [anon_sym_static] = ACTIONS(1),
    [anon_sym_member] = ACTIONS(1),
    [anon_sym_get] = ACTIONS(1),
    [anon_sym_set] = ACTIONS(1),
    [anon_sym_interface] = ACTIONS(1),
    [anon_sym_id] = ACTIONS(1),
    [anon_sym_exception] = ACTIONS(1),
    [anon_sym_of] = ACTIONS(1),
    [anon_sym_class] = ACTIONS(1),
    [anon_sym_abstract] = ACTIONS(1),
    [anon_sym_val] = ACTIONS(1),
    [anon_sym_override] = ACTIONS(1),
    [anon_sym_inherit] = ACTIONS(1),
    [anon_sym_EQ2] = ACTIONS(1),
    [sym__unicodegraph_short] = ACTIONS(1),
    [sym__unicodegraph_long] = ACTIONS(1),
    [sym__trigraph] = ACTIONS(1),
    [aux_sym_char_token1] = ACTIONS(1),
    [anon_sym_LBRACE2] = ACTIONS(1),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1),
    [anon_sym_DQUOTE] = ACTIONS(1),
    [anon_sym_AT_DQUOTE] = ACTIONS(1),
    [anon_sym_DQUOTE2] = ACTIONS(1),
    [anon_sym_DQUOTEB] = ACTIONS(1),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1),
    [sym_bool] = ACTIONS(1),
    [sym_unit] = ACTIONS(1),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1),
    [anon_sym_PIPE_RPAREN] = ACTIONS(1),
    [sym_op_identifier] = ACTIONS(1),
    [anon_sym_PLUS] = ACTIONS(1),
    [anon_sym_DASH] = ACTIONS(1),
    [anon_sym_PLUS_DOT] = ACTIONS(1),
    [anon_sym_DASH_DOT] = ACTIONS(1),
    [anon_sym_PERCENT] = ACTIONS(1),
    [anon_sym_AMP_AMP] = ACTIONS(1),
    [anon_sym_TILDE] = ACTIONS(1),
    [aux_sym_prefix_op_token1] = ACTIONS(1),
    [aux_sym_infix_op_token1] = ACTIONS(1),
    [anon_sym_PIPE_PIPE] = ACTIONS(1),
    [anon_sym_BANG_EQ] = ACTIONS(1),
    [anon_sym_COLON_EQ] = ACTIONS(1),
    [anon_sym_DOLLAR] = ACTIONS(1),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(1),
    [sym_int] = ACTIONS(1),
    [sym_xint] = ACTIONS(1),
    [anon_sym_y] = ACTIONS(1),
    [anon_sym_uy] = ACTIONS(1),
    [anon_sym_s] = ACTIONS(1),
    [anon_sym_us] = ACTIONS(1),
    [anon_sym_l] = ACTIONS(1),
    [aux_sym_uint32_token1] = ACTIONS(1),
    [anon_sym_n] = ACTIONS(1),
    [anon_sym_un] = ACTIONS(1),
    [anon_sym_L] = ACTIONS(1),
    [aux_sym_uint64_token1] = ACTIONS(1),
    [anon_sym_f] = ACTIONS(1),
    [anon_sym_lf] = ACTIONS(1),
    [anon_sym_LF] = ACTIONS(1),
    [aux_sym_bignum_token1] = ACTIONS(1),
    [aux_sym_decimal_token1] = ACTIONS(1),
    [anon_sym_DOT2] = ACTIONS(1),
    [aux_sym_float_token1] = ACTIONS(1),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [anon_sym_STAR_RPAREN] = ACTIONS(1),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [sym__newline] = ACTIONS(1),
    [sym__indent] = ACTIONS(1),
    [sym__dedent] = ACTIONS(1),
    [sym__struct_begin] = ACTIONS(1),
    [sym__interface_begin] = ACTIONS(1),
    [sym__triple_quoted_content] = ACTIONS(1),
    [sym_block_comment_content] = ACTIONS(1),
    [sym__inside_string_marker] = ACTIONS(1),
    [sym__newline_not_aligned] = ACTIONS(1),
    [sym__tuple_marker] = ACTIONS(1),
    [sym__error_sentinel] = ACTIONS(1),
  },
  [1] = {
    [sym_file] = STATE(7538),
    [sym_namespace] = STATE(7537),
    [sym_attributes] = STATE(7536),
    [sym__attribute_set] = STATE(4488),
    [sym_block_comment] = STATE(1),
    [sym_compiler_directive_decl] = STATE(1),
    [sym_fsi_directive_decl] = STATE(1),
    [sym_preproc_line] = STATE(1),
    [sym_module] = STATE(7537),
    [sym__module_signature_elements] = STATE(5762),
    [sym_value_definition] = STATE(5763),
    [aux_sym_file_repeat1] = STATE(5421),
    [aux_sym_attributes_repeat1] = STATE(4305),
    [ts_builtin_sym_end] = ACTIONS(17),
    [anon_sym_namespace] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_LBRACK_LT] = ACTIONS(23),
    [anon_sym_val] = ACTIONS(25),
    [anon_sym_LPAREN_STAR] = ACTIONS(27),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2] = {
    [sym_function_or_value_defn] = STATE(705),
    [sym__expression] = STATE(6),
    [sym_literal_expression] = STATE(867),
    [sym_long_identifier_or_op] = STATE(867),
    [sym_tuple_expression] = STATE(867),
    [sym_brace_expression] = STATE(867),
    [sym_anon_record_expression] = STATE(867),
    [sym_prefixed_expression] = STATE(867),
    [sym_typecast_expression] = STATE(867),
    [sym_for_expression] = STATE(867),
    [sym_while_expression] = STATE(867),
    [sym__if_branch] = STATE(6511),
    [sym_if_expression] = STATE(867),
    [sym_fun_expression] = STATE(867),
    [sym_try_expression] = STATE(867),
    [sym_match_expression] = STATE(867),
    [sym_function_expression] = STATE(867),
    [sym_mutate_expression] = STATE(867),
    [sym_index_expression] = STATE(867),
    [sym_typed_expression] = STATE(867),
    [sym_declaration_expression] = STATE(867),
    [sym_do_expression] = STATE(867),
    [sym_list_expression] = STATE(867),
    [sym_array_expression] = STATE(867),
    [sym_begin_end_expression] = STATE(867),
    [sym_paren_expression] = STATE(867),
    [sym__high_prec_app] = STATE(864),
    [sym__low_prec_app] = STATE(864),
    [sym_application_expression] = STATE(867),
    [sym_dot_expression] = STATE(867),
    [sym_infix_expression] = STATE(867),
    [sym_ce_expression] = STATE(867),
    [sym_sequential_expression] = STATE(867),
    [sym_char] = STATE(868),
    [sym_format_string] = STATE(869),
    [sym__string_literal] = STATE(869),
    [sym_string] = STATE(868),
    [sym_verbatim_string] = STATE(868),
    [sym_bytearray] = STATE(868),
    [sym_verbatim_bytearray] = STATE(868),
    [sym_format_triple_quoted_string] = STATE(870),
    [sym_triple_quoted_string] = STATE(868),
    [sym_const] = STATE(867),
    [sym_long_identifier] = STATE(872),
    [sym_active_pattern] = STATE(871),
    [sym__identifier_or_op] = STATE(873),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(658),
    [sym_infix_op] = STATE(566),
    [sym_sbyte] = STATE(868),
    [sym_byte] = STATE(868),
    [sym_int16] = STATE(868),
    [sym_uint16] = STATE(868),
    [sym_int32] = STATE(868),
    [sym_uint32] = STATE(868),
    [sym_nativeint] = STATE(868),
    [sym_unativeint] = STATE(868),
    [sym_int64] = STATE(868),
    [sym_uint64] = STATE(868),
    [sym_ieee32] = STATE(868),
    [sym_ieee64] = STATE(868),
    [sym_bignum] = STATE(868),
    [sym_decimal] = STATE(868),
    [sym_float] = STATE(860),
    [sym_block_comment] = STATE(2),
    [sym_compiler_directive_decl] = STATE(2),
    [sym_fsi_directive_decl] = STATE(2),
    [sym_preproc_line] = STATE(2),
    [sym_preproc_if_in_expression] = STATE(867),
    [aux_sym_sequential_expression_repeat1] = STATE(866),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(29),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_LBRACK_LT] = ACTIONS(33),
    [anon_sym_COLON] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(37),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [aux_sym_access_modifier_token1] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_COMMA] = ACTIONS(47),
    [anon_sym_null] = ACTIONS(49),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACK_PIPE] = ACTIONS(57),
    [anon_sym_LBRACE] = ACTIONS(59),
    [anon_sym_LT_AT] = ACTIONS(61),
    [anon_sym_LT_AT_AT] = ACTIONS(63),
    [anon_sym_DOT] = ACTIONS(65),
    [anon_sym_LBRACE_PIPE] = ACTIONS(67),
    [anon_sym_new] = ACTIONS(37),
    [anon_sym_with] = ACTIONS(59),
    [anon_sym_return_BANG] = ACTIONS(69),
    [anon_sym_yield] = ACTIONS(37),
    [anon_sym_yield_BANG] = ACTIONS(69),
    [anon_sym_lazy] = ACTIONS(37),
    [anon_sym_assert] = ACTIONS(37),
    [anon_sym_upcast] = ACTIONS(37),
    [anon_sym_downcast] = ACTIONS(37),
    [anon_sym_COLON_GT] = ACTIONS(71),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(71),
    [anon_sym_for] = ACTIONS(73),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(79),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_match] = ACTIONS(83),
    [anon_sym_match_BANG] = ACTIONS(85),
    [anon_sym_function] = ACTIONS(87),
    [anon_sym_LT_DASH] = ACTIONS(89),
    [anon_sym_DOT_LBRACK] = ACTIONS(91),
    [anon_sym_LT] = ACTIONS(93),
    [anon_sym_use] = ACTIONS(95),
    [anon_sym_use_BANG] = ACTIONS(97),
    [anon_sym_do_BANG] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(101),
    [anon_sym_LPAREN2] = ACTIONS(103),
    [anon_sym_default] = ACTIONS(59),
    [anon_sym_or] = ACTIONS(51),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_member] = ACTIONS(59),
    [anon_sym_abstract] = ACTIONS(59),
    [anon_sym_val] = ACTIONS(59),
    [anon_sym_override] = ACTIONS(59),
    [aux_sym_char_token1] = ACTIONS(105),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(107),
    [anon_sym_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DQUOTE] = ACTIONS(111),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(115),
    [sym_bool] = ACTIONS(117),
    [sym_unit] = ACTIONS(119),
    [anon_sym_LPAREN_PIPE] = ACTIONS(121),
    [sym_op_identifier] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(129),
    [sym_xint] = ACTIONS(131),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(135),
    [sym__newline] = ACTIONS(33),
    [sym__dedent] = ACTIONS(33),
  },
  [3] = {
    [sym_function_or_value_defn] = STATE(705),
    [sym__expression] = STATE(6),
    [sym_literal_expression] = STATE(867),
    [sym_long_identifier_or_op] = STATE(867),
    [sym_tuple_expression] = STATE(867),
    [sym_brace_expression] = STATE(867),
    [sym_anon_record_expression] = STATE(867),
    [sym_prefixed_expression] = STATE(867),
    [sym_typecast_expression] = STATE(867),
    [sym_for_expression] = STATE(867),
    [sym_while_expression] = STATE(867),
    [sym__if_branch] = STATE(6511),
    [sym_if_expression] = STATE(867),
    [sym_fun_expression] = STATE(867),
    [sym_try_expression] = STATE(867),
    [sym_match_expression] = STATE(867),
    [sym_function_expression] = STATE(867),
    [sym_mutate_expression] = STATE(867),
    [sym_index_expression] = STATE(867),
    [sym_typed_expression] = STATE(867),
    [sym_declaration_expression] = STATE(867),
    [sym_do_expression] = STATE(867),
    [sym_list_expression] = STATE(867),
    [sym_array_expression] = STATE(867),
    [sym_begin_end_expression] = STATE(867),
    [sym_paren_expression] = STATE(867),
    [sym__high_prec_app] = STATE(864),
    [sym__low_prec_app] = STATE(864),
    [sym_application_expression] = STATE(867),
    [sym_dot_expression] = STATE(867),
    [sym_infix_expression] = STATE(867),
    [sym_ce_expression] = STATE(867),
    [sym_sequential_expression] = STATE(867),
    [sym_char] = STATE(868),
    [sym_format_string] = STATE(869),
    [sym__string_literal] = STATE(869),
    [sym_string] = STATE(868),
    [sym_verbatim_string] = STATE(868),
    [sym_bytearray] = STATE(868),
    [sym_verbatim_bytearray] = STATE(868),
    [sym_format_triple_quoted_string] = STATE(870),
    [sym_triple_quoted_string] = STATE(868),
    [sym_const] = STATE(867),
    [sym_long_identifier] = STATE(872),
    [sym_active_pattern] = STATE(871),
    [sym__identifier_or_op] = STATE(873),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(658),
    [sym_infix_op] = STATE(566),
    [sym_sbyte] = STATE(868),
    [sym_byte] = STATE(868),
    [sym_int16] = STATE(868),
    [sym_uint16] = STATE(868),
    [sym_int32] = STATE(868),
    [sym_uint32] = STATE(868),
    [sym_nativeint] = STATE(868),
    [sym_unativeint] = STATE(868),
    [sym_int64] = STATE(868),
    [sym_uint64] = STATE(868),
    [sym_ieee32] = STATE(868),
    [sym_ieee64] = STATE(868),
    [sym_bignum] = STATE(868),
    [sym_decimal] = STATE(868),
    [sym_float] = STATE(860),
    [sym_block_comment] = STATE(3),
    [sym_compiler_directive_decl] = STATE(3),
    [sym_fsi_directive_decl] = STATE(3),
    [sym_preproc_line] = STATE(3),
    [sym_preproc_if_in_expression] = STATE(867),
    [aux_sym_sequential_expression_repeat1] = STATE(866),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(29),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_LBRACK_LT] = ACTIONS(137),
    [anon_sym_COLON] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(37),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [aux_sym_access_modifier_token1] = ACTIONS(137),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_COMMA] = ACTIONS(47),
    [anon_sym_null] = ACTIONS(49),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACK_PIPE] = ACTIONS(57),
    [anon_sym_LBRACE] = ACTIONS(139),
    [anon_sym_LT_AT] = ACTIONS(61),
    [anon_sym_LT_AT_AT] = ACTIONS(63),
    [anon_sym_DOT] = ACTIONS(65),
    [anon_sym_LBRACE_PIPE] = ACTIONS(67),
    [anon_sym_new] = ACTIONS(141),
    [anon_sym_with] = ACTIONS(143),
    [anon_sym_return_BANG] = ACTIONS(69),
    [anon_sym_yield] = ACTIONS(37),
    [anon_sym_yield_BANG] = ACTIONS(69),
    [anon_sym_lazy] = ACTIONS(37),
    [anon_sym_assert] = ACTIONS(37),
    [anon_sym_upcast] = ACTIONS(37),
    [anon_sym_downcast] = ACTIONS(37),
    [anon_sym_COLON_GT] = ACTIONS(71),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(71),
    [anon_sym_for] = ACTIONS(73),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(79),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_match] = ACTIONS(83),
    [anon_sym_match_BANG] = ACTIONS(85),
    [anon_sym_function] = ACTIONS(87),
    [anon_sym_LT_DASH] = ACTIONS(89),
    [anon_sym_DOT_LBRACK] = ACTIONS(91),
    [anon_sym_LT] = ACTIONS(93),
    [anon_sym_use] = ACTIONS(95),
    [anon_sym_use_BANG] = ACTIONS(97),
    [anon_sym_do_BANG] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(101),
    [anon_sym_LPAREN2] = ACTIONS(103),
    [anon_sym_default] = ACTIONS(141),
    [anon_sym_or] = ACTIONS(51),
    [anon_sym_static] = ACTIONS(141),
    [anon_sym_member] = ACTIONS(141),
    [anon_sym_abstract] = ACTIONS(141),
    [anon_sym_val] = ACTIONS(141),
    [anon_sym_override] = ACTIONS(141),
    [aux_sym_char_token1] = ACTIONS(105),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(107),
    [anon_sym_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DQUOTE] = ACTIONS(111),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(115),
    [sym_bool] = ACTIONS(117),
    [sym_unit] = ACTIONS(119),
    [anon_sym_LPAREN_PIPE] = ACTIONS(121),
    [sym_op_identifier] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(129),
    [sym_xint] = ACTIONS(131),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(135),
    [sym__newline] = ACTIONS(137),
    [sym__dedent] = ACTIONS(137),
  },
  [4] = {
    [sym_function_or_value_defn] = STATE(705),
    [sym__expression] = STATE(6),
    [sym_literal_expression] = STATE(867),
    [sym_long_identifier_or_op] = STATE(867),
    [sym_tuple_expression] = STATE(867),
    [sym_brace_expression] = STATE(867),
    [sym_anon_record_expression] = STATE(867),
    [sym_prefixed_expression] = STATE(867),
    [sym_typecast_expression] = STATE(867),
    [sym_for_expression] = STATE(867),
    [sym_while_expression] = STATE(867),
    [sym__if_branch] = STATE(6511),
    [sym_if_expression] = STATE(867),
    [sym_fun_expression] = STATE(867),
    [sym_try_expression] = STATE(867),
    [sym_match_expression] = STATE(867),
    [sym_function_expression] = STATE(867),
    [sym_mutate_expression] = STATE(867),
    [sym_index_expression] = STATE(867),
    [sym_typed_expression] = STATE(867),
    [sym_declaration_expression] = STATE(867),
    [sym_do_expression] = STATE(867),
    [sym_list_expression] = STATE(867),
    [sym_array_expression] = STATE(867),
    [sym_begin_end_expression] = STATE(867),
    [sym_paren_expression] = STATE(867),
    [sym__high_prec_app] = STATE(864),
    [sym__low_prec_app] = STATE(864),
    [sym_application_expression] = STATE(867),
    [sym_dot_expression] = STATE(867),
    [sym_infix_expression] = STATE(867),
    [sym_ce_expression] = STATE(867),
    [sym_sequential_expression] = STATE(867),
    [sym_char] = STATE(868),
    [sym_format_string] = STATE(869),
    [sym__string_literal] = STATE(869),
    [sym_string] = STATE(868),
    [sym_verbatim_string] = STATE(868),
    [sym_bytearray] = STATE(868),
    [sym_verbatim_bytearray] = STATE(868),
    [sym_format_triple_quoted_string] = STATE(870),
    [sym_triple_quoted_string] = STATE(868),
    [sym_const] = STATE(867),
    [sym_long_identifier] = STATE(872),
    [sym_active_pattern] = STATE(871),
    [sym__identifier_or_op] = STATE(873),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(658),
    [sym_infix_op] = STATE(566),
    [sym_sbyte] = STATE(868),
    [sym_byte] = STATE(868),
    [sym_int16] = STATE(868),
    [sym_uint16] = STATE(868),
    [sym_int32] = STATE(868),
    [sym_uint32] = STATE(868),
    [sym_nativeint] = STATE(868),
    [sym_unativeint] = STATE(868),
    [sym_int64] = STATE(868),
    [sym_uint64] = STATE(868),
    [sym_ieee32] = STATE(868),
    [sym_ieee64] = STATE(868),
    [sym_bignum] = STATE(868),
    [sym_decimal] = STATE(868),
    [sym_float] = STATE(860),
    [sym_block_comment] = STATE(4),
    [sym_compiler_directive_decl] = STATE(4),
    [sym_fsi_directive_decl] = STATE(4),
    [sym_preproc_line] = STATE(4),
    [sym_preproc_if_in_expression] = STATE(867),
    [aux_sym_sequential_expression_repeat1] = STATE(866),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(29),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_LBRACK_LT] = ACTIONS(145),
    [anon_sym_COLON] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(37),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [aux_sym_access_modifier_token1] = ACTIONS(145),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_COMMA] = ACTIONS(47),
    [anon_sym_null] = ACTIONS(49),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACK_PIPE] = ACTIONS(57),
    [anon_sym_LBRACE] = ACTIONS(139),
    [anon_sym_LT_AT] = ACTIONS(61),
    [anon_sym_LT_AT_AT] = ACTIONS(63),
    [anon_sym_DOT] = ACTIONS(65),
    [anon_sym_LBRACE_PIPE] = ACTIONS(67),
    [anon_sym_new] = ACTIONS(37),
    [anon_sym_with] = ACTIONS(147),
    [anon_sym_return_BANG] = ACTIONS(69),
    [anon_sym_yield] = ACTIONS(37),
    [anon_sym_yield_BANG] = ACTIONS(69),
    [anon_sym_lazy] = ACTIONS(37),
    [anon_sym_assert] = ACTIONS(37),
    [anon_sym_upcast] = ACTIONS(37),
    [anon_sym_downcast] = ACTIONS(37),
    [anon_sym_COLON_GT] = ACTIONS(71),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(71),
    [anon_sym_for] = ACTIONS(73),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(79),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_match] = ACTIONS(83),
    [anon_sym_match_BANG] = ACTIONS(85),
    [anon_sym_function] = ACTIONS(87),
    [anon_sym_LT_DASH] = ACTIONS(89),
    [anon_sym_DOT_LBRACK] = ACTIONS(91),
    [anon_sym_LT] = ACTIONS(93),
    [anon_sym_use] = ACTIONS(95),
    [anon_sym_use_BANG] = ACTIONS(97),
    [anon_sym_do_BANG] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(101),
    [anon_sym_LPAREN2] = ACTIONS(103),
    [anon_sym_default] = ACTIONS(147),
    [anon_sym_or] = ACTIONS(51),
    [anon_sym_static] = ACTIONS(147),
    [anon_sym_member] = ACTIONS(147),
    [anon_sym_abstract] = ACTIONS(147),
    [anon_sym_val] = ACTIONS(147),
    [anon_sym_override] = ACTIONS(147),
    [aux_sym_char_token1] = ACTIONS(105),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(107),
    [anon_sym_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DQUOTE] = ACTIONS(111),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(115),
    [sym_bool] = ACTIONS(117),
    [sym_unit] = ACTIONS(119),
    [anon_sym_LPAREN_PIPE] = ACTIONS(121),
    [sym_op_identifier] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(129),
    [sym_xint] = ACTIONS(131),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(135),
    [sym__newline] = ACTIONS(145),
    [sym__dedent] = ACTIONS(145),
  },
  [5] = {
    [sym_function_or_value_defn] = STATE(705),
    [sym__expression] = STATE(6),
    [sym_literal_expression] = STATE(867),
    [sym_long_identifier_or_op] = STATE(867),
    [sym_tuple_expression] = STATE(867),
    [sym_brace_expression] = STATE(867),
    [sym_anon_record_expression] = STATE(867),
    [sym_prefixed_expression] = STATE(867),
    [sym_typecast_expression] = STATE(867),
    [sym_for_expression] = STATE(867),
    [sym_while_expression] = STATE(867),
    [sym__if_branch] = STATE(6511),
    [sym_if_expression] = STATE(867),
    [sym_fun_expression] = STATE(867),
    [sym_try_expression] = STATE(867),
    [sym_match_expression] = STATE(867),
    [sym_function_expression] = STATE(867),
    [sym_mutate_expression] = STATE(867),
    [sym_index_expression] = STATE(867),
    [sym_typed_expression] = STATE(867),
    [sym_declaration_expression] = STATE(867),
    [sym_do_expression] = STATE(867),
    [sym_list_expression] = STATE(867),
    [sym_array_expression] = STATE(867),
    [sym_begin_end_expression] = STATE(867),
    [sym_paren_expression] = STATE(867),
    [sym__high_prec_app] = STATE(864),
    [sym__low_prec_app] = STATE(864),
    [sym_application_expression] = STATE(867),
    [sym_dot_expression] = STATE(867),
    [sym_infix_expression] = STATE(867),
    [sym_ce_expression] = STATE(867),
    [sym_sequential_expression] = STATE(867),
    [sym_char] = STATE(868),
    [sym_format_string] = STATE(869),
    [sym__string_literal] = STATE(869),
    [sym_string] = STATE(868),
    [sym_verbatim_string] = STATE(868),
    [sym_bytearray] = STATE(868),
    [sym_verbatim_bytearray] = STATE(868),
    [sym_format_triple_quoted_string] = STATE(870),
    [sym_triple_quoted_string] = STATE(868),
    [sym_const] = STATE(867),
    [sym_long_identifier] = STATE(872),
    [sym_active_pattern] = STATE(871),
    [sym__identifier_or_op] = STATE(873),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(658),
    [sym_infix_op] = STATE(566),
    [sym_sbyte] = STATE(868),
    [sym_byte] = STATE(868),
    [sym_int16] = STATE(868),
    [sym_uint16] = STATE(868),
    [sym_int32] = STATE(868),
    [sym_uint32] = STATE(868),
    [sym_nativeint] = STATE(868),
    [sym_unativeint] = STATE(868),
    [sym_int64] = STATE(868),
    [sym_uint64] = STATE(868),
    [sym_ieee32] = STATE(868),
    [sym_ieee64] = STATE(868),
    [sym_bignum] = STATE(868),
    [sym_decimal] = STATE(868),
    [sym_float] = STATE(860),
    [sym_block_comment] = STATE(5),
    [sym_compiler_directive_decl] = STATE(5),
    [sym_fsi_directive_decl] = STATE(5),
    [sym_preproc_line] = STATE(5),
    [sym_preproc_if_in_expression] = STATE(867),
    [aux_sym_sequential_expression_repeat1] = STATE(866),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(29),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_LBRACK_LT] = ACTIONS(149),
    [anon_sym_COLON] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(37),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [aux_sym_access_modifier_token1] = ACTIONS(149),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_COMMA] = ACTIONS(47),
    [anon_sym_null] = ACTIONS(49),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACK_PIPE] = ACTIONS(57),
    [anon_sym_LBRACE] = ACTIONS(139),
    [anon_sym_LT_AT] = ACTIONS(61),
    [anon_sym_LT_AT_AT] = ACTIONS(63),
    [anon_sym_DOT] = ACTIONS(65),
    [anon_sym_LBRACE_PIPE] = ACTIONS(67),
    [anon_sym_new] = ACTIONS(37),
    [anon_sym_with] = ACTIONS(151),
    [anon_sym_return_BANG] = ACTIONS(69),
    [anon_sym_yield] = ACTIONS(37),
    [anon_sym_yield_BANG] = ACTIONS(69),
    [anon_sym_lazy] = ACTIONS(37),
    [anon_sym_assert] = ACTIONS(37),
    [anon_sym_upcast] = ACTIONS(37),
    [anon_sym_downcast] = ACTIONS(37),
    [anon_sym_COLON_GT] = ACTIONS(71),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(71),
    [anon_sym_for] = ACTIONS(73),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(79),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_match] = ACTIONS(83),
    [anon_sym_match_BANG] = ACTIONS(85),
    [anon_sym_function] = ACTIONS(87),
    [anon_sym_LT_DASH] = ACTIONS(89),
    [anon_sym_DOT_LBRACK] = ACTIONS(91),
    [anon_sym_LT] = ACTIONS(93),
    [anon_sym_use] = ACTIONS(95),
    [anon_sym_use_BANG] = ACTIONS(97),
    [anon_sym_do_BANG] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(101),
    [anon_sym_LPAREN2] = ACTIONS(103),
    [anon_sym_default] = ACTIONS(151),
    [anon_sym_or] = ACTIONS(51),
    [anon_sym_static] = ACTIONS(151),
    [anon_sym_member] = ACTIONS(151),
    [anon_sym_abstract] = ACTIONS(151),
    [anon_sym_val] = ACTIONS(151),
    [anon_sym_override] = ACTIONS(151),
    [aux_sym_char_token1] = ACTIONS(105),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(107),
    [anon_sym_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DQUOTE] = ACTIONS(111),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(115),
    [sym_bool] = ACTIONS(117),
    [sym_unit] = ACTIONS(119),
    [anon_sym_LPAREN_PIPE] = ACTIONS(121),
    [sym_op_identifier] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(129),
    [sym_xint] = ACTIONS(131),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(135),
    [sym__newline] = ACTIONS(153),
    [sym__dedent] = ACTIONS(149),
  },
  [6] = {
    [sym_function_or_value_defn] = STATE(705),
    [sym__expression] = STATE(6),
    [sym_literal_expression] = STATE(867),
    [sym_long_identifier_or_op] = STATE(867),
    [sym_tuple_expression] = STATE(867),
    [sym_brace_expression] = STATE(867),
    [sym_anon_record_expression] = STATE(867),
    [sym_prefixed_expression] = STATE(867),
    [sym_typecast_expression] = STATE(867),
    [sym_for_expression] = STATE(867),
    [sym_while_expression] = STATE(867),
    [sym__if_branch] = STATE(6511),
    [sym_if_expression] = STATE(867),
    [sym_fun_expression] = STATE(867),
    [sym_try_expression] = STATE(867),
    [sym_match_expression] = STATE(867),
    [sym_function_expression] = STATE(867),
    [sym_mutate_expression] = STATE(867),
    [sym_index_expression] = STATE(867),
    [sym_typed_expression] = STATE(867),
    [sym_declaration_expression] = STATE(867),
    [sym_do_expression] = STATE(867),
    [sym_list_expression] = STATE(867),
    [sym_array_expression] = STATE(867),
    [sym_begin_end_expression] = STATE(867),
    [sym_paren_expression] = STATE(867),
    [sym__high_prec_app] = STATE(864),
    [sym__low_prec_app] = STATE(864),
    [sym_application_expression] = STATE(867),
    [sym_dot_expression] = STATE(867),
    [sym_infix_expression] = STATE(867),
    [sym_ce_expression] = STATE(867),
    [sym_sequential_expression] = STATE(867),
    [sym_char] = STATE(868),
    [sym_format_string] = STATE(869),
    [sym__string_literal] = STATE(869),
    [sym_string] = STATE(868),
    [sym_verbatim_string] = STATE(868),
    [sym_bytearray] = STATE(868),
    [sym_verbatim_bytearray] = STATE(868),
    [sym_format_triple_quoted_string] = STATE(870),
    [sym_triple_quoted_string] = STATE(868),
    [sym_const] = STATE(867),
    [sym_long_identifier] = STATE(872),
    [sym_active_pattern] = STATE(871),
    [sym__identifier_or_op] = STATE(873),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(658),
    [sym_infix_op] = STATE(566),
    [sym_sbyte] = STATE(868),
    [sym_byte] = STATE(868),
    [sym_int16] = STATE(868),
    [sym_uint16] = STATE(868),
    [sym_int32] = STATE(868),
    [sym_uint32] = STATE(868),
    [sym_nativeint] = STATE(868),
    [sym_unativeint] = STATE(868),
    [sym_int64] = STATE(868),
    [sym_uint64] = STATE(868),
    [sym_ieee32] = STATE(868),
    [sym_ieee64] = STATE(868),
    [sym_bignum] = STATE(868),
    [sym_decimal] = STATE(868),
    [sym_float] = STATE(860),
    [sym_block_comment] = STATE(6),
    [sym_compiler_directive_decl] = STATE(6),
    [sym_fsi_directive_decl] = STATE(6),
    [sym_preproc_line] = STATE(6),
    [sym_preproc_if_in_expression] = STATE(867),
    [aux_sym_sequential_expression_repeat1] = STATE(866),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_EQ] = ACTIONS(157),
    [anon_sym_LBRACK_LT] = ACTIONS(157),
    [anon_sym_COLON] = ACTIONS(155),
    [anon_sym_return] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(155),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_let_BANG] = ACTIONS(157),
    [aux_sym_access_modifier_token1] = ACTIONS(157),
    [anon_sym_LPAREN] = ACTIONS(155),
    [anon_sym_COMMA] = ACTIONS(157),
    [anon_sym_null] = ACTIONS(155),
    [anon_sym_QMARK] = ACTIONS(155),
    [anon_sym_COLON_QMARK] = ACTIONS(155),
    [anon_sym_COLON_COLON] = ACTIONS(157),
    [anon_sym_AMP] = ACTIONS(155),
    [anon_sym_LBRACK] = ACTIONS(155),
    [anon_sym_LBRACK_PIPE] = ACTIONS(157),
    [anon_sym_LBRACE] = ACTIONS(155),
    [anon_sym_LT_AT] = ACTIONS(155),
    [anon_sym_LT_AT_AT] = ACTIONS(155),
    [anon_sym_DOT] = ACTIONS(65),
    [anon_sym_LBRACE_PIPE] = ACTIONS(157),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_with] = ACTIONS(155),
    [anon_sym_return_BANG] = ACTIONS(157),
    [anon_sym_yield] = ACTIONS(155),
    [anon_sym_yield_BANG] = ACTIONS(157),
    [anon_sym_lazy] = ACTIONS(155),
    [anon_sym_assert] = ACTIONS(155),
    [anon_sym_upcast] = ACTIONS(155),
    [anon_sym_downcast] = ACTIONS(155),
    [anon_sym_COLON_GT] = ACTIONS(157),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(157),
    [anon_sym_for] = ACTIONS(155),
    [anon_sym_while] = ACTIONS(155),
    [anon_sym_if] = ACTIONS(155),
    [anon_sym_fun] = ACTIONS(155),
    [anon_sym_try] = ACTIONS(155),
    [anon_sym_match] = ACTIONS(155),
    [anon_sym_match_BANG] = ACTIONS(157),
    [anon_sym_function] = ACTIONS(155),
    [anon_sym_LT_DASH] = ACTIONS(155),
    [anon_sym_DOT_LBRACK] = ACTIONS(91),
    [anon_sym_LT] = ACTIONS(93),
    [anon_sym_use] = ACTIONS(155),
    [anon_sym_use_BANG] = ACTIONS(157),
    [anon_sym_do_BANG] = ACTIONS(157),
    [anon_sym_begin] = ACTIONS(155),
    [anon_sym_LPAREN2] = ACTIONS(103),
    [anon_sym_default] = ACTIONS(155),
    [anon_sym_or] = ACTIONS(155),
    [anon_sym_static] = ACTIONS(155),
    [anon_sym_member] = ACTIONS(155),
    [anon_sym_abstract] = ACTIONS(155),
    [anon_sym_val] = ACTIONS(155),
    [anon_sym_override] = ACTIONS(155),
    [aux_sym_char_token1] = ACTIONS(157),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(155),
    [anon_sym_DQUOTE] = ACTIONS(155),
    [anon_sym_AT_DQUOTE] = ACTIONS(157),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(157),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(157),
    [sym_bool] = ACTIONS(155),
    [sym_unit] = ACTIONS(119),
    [anon_sym_LPAREN_PIPE] = ACTIONS(155),
    [sym_op_identifier] = ACTIONS(155),
    [anon_sym_PLUS] = ACTIONS(155),
    [anon_sym_DASH] = ACTIONS(155),
    [anon_sym_PLUS_DOT] = ACTIONS(155),
    [anon_sym_DASH_DOT] = ACTIONS(155),
    [anon_sym_PERCENT] = ACTIONS(155),
    [anon_sym_AMP_AMP] = ACTIONS(155),
    [anon_sym_TILDE] = ACTIONS(157),
    [aux_sym_prefix_op_token1] = ACTIONS(155),
    [aux_sym_infix_op_token1] = ACTIONS(157),
    [aux_sym_infix_op_token2] = ACTIONS(155),
    [anon_sym_PIPE_PIPE] = ACTIONS(155),
    [anon_sym_BANG_EQ] = ACTIONS(155),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_DOLLAR] = ACTIONS(155),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(155),
    [sym_int] = ACTIONS(155),
    [sym_xint] = ACTIONS(157),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(157),
    [sym__newline] = ACTIONS(157),
    [sym__dedent] = ACTIONS(157),
  },
  [7] = {
    [sym_function_or_value_defn] = STATE(705),
    [sym__expression] = STATE(6),
    [sym_literal_expression] = STATE(867),
    [sym_long_identifier_or_op] = STATE(867),
    [sym_tuple_expression] = STATE(867),
    [sym_brace_expression] = STATE(867),
    [sym_anon_record_expression] = STATE(867),
    [sym_prefixed_expression] = STATE(867),
    [sym_typecast_expression] = STATE(867),
    [sym_for_expression] = STATE(867),
    [sym_while_expression] = STATE(867),
    [sym__if_branch] = STATE(6511),
    [sym_if_expression] = STATE(867),
    [sym_fun_expression] = STATE(867),
    [sym_try_expression] = STATE(867),
    [sym_match_expression] = STATE(867),
    [sym_function_expression] = STATE(867),
    [sym_mutate_expression] = STATE(867),
    [sym_index_expression] = STATE(867),
    [sym_typed_expression] = STATE(867),
    [sym_declaration_expression] = STATE(867),
    [sym_do_expression] = STATE(867),
    [sym_list_expression] = STATE(867),
    [sym_array_expression] = STATE(867),
    [sym_begin_end_expression] = STATE(867),
    [sym_paren_expression] = STATE(867),
    [sym__high_prec_app] = STATE(864),
    [sym__low_prec_app] = STATE(864),
    [sym_application_expression] = STATE(867),
    [sym_dot_expression] = STATE(867),
    [sym_infix_expression] = STATE(867),
    [sym_ce_expression] = STATE(867),
    [sym_sequential_expression] = STATE(867),
    [sym_char] = STATE(868),
    [sym_format_string] = STATE(869),
    [sym__string_literal] = STATE(869),
    [sym_string] = STATE(868),
    [sym_verbatim_string] = STATE(868),
    [sym_bytearray] = STATE(868),
    [sym_verbatim_bytearray] = STATE(868),
    [sym_format_triple_quoted_string] = STATE(870),
    [sym_triple_quoted_string] = STATE(868),
    [sym_const] = STATE(867),
    [sym_long_identifier] = STATE(872),
    [sym_active_pattern] = STATE(871),
    [sym__identifier_or_op] = STATE(873),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(658),
    [sym_infix_op] = STATE(566),
    [sym_sbyte] = STATE(868),
    [sym_byte] = STATE(868),
    [sym_int16] = STATE(868),
    [sym_uint16] = STATE(868),
    [sym_int32] = STATE(868),
    [sym_uint32] = STATE(868),
    [sym_nativeint] = STATE(868),
    [sym_unativeint] = STATE(868),
    [sym_int64] = STATE(868),
    [sym_uint64] = STATE(868),
    [sym_ieee32] = STATE(868),
    [sym_ieee64] = STATE(868),
    [sym_bignum] = STATE(868),
    [sym_decimal] = STATE(868),
    [sym_float] = STATE(860),
    [sym_block_comment] = STATE(7),
    [sym_compiler_directive_decl] = STATE(7),
    [sym_fsi_directive_decl] = STATE(7),
    [sym_preproc_line] = STATE(7),
    [sym_preproc_if_in_expression] = STATE(867),
    [aux_sym_sequential_expression_repeat1] = STATE(866),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(29),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_LBRACK_LT] = ACTIONS(159),
    [anon_sym_COLON] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(37),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [aux_sym_access_modifier_token1] = ACTIONS(159),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_COMMA] = ACTIONS(47),
    [anon_sym_null] = ACTIONS(49),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACK_PIPE] = ACTIONS(57),
    [anon_sym_LBRACE] = ACTIONS(139),
    [anon_sym_LT_AT] = ACTIONS(61),
    [anon_sym_LT_AT_AT] = ACTIONS(63),
    [anon_sym_DOT] = ACTIONS(65),
    [anon_sym_LBRACE_PIPE] = ACTIONS(67),
    [anon_sym_new] = ACTIONS(37),
    [anon_sym_with] = ACTIONS(161),
    [anon_sym_return_BANG] = ACTIONS(69),
    [anon_sym_yield] = ACTIONS(37),
    [anon_sym_yield_BANG] = ACTIONS(69),
    [anon_sym_lazy] = ACTIONS(37),
    [anon_sym_assert] = ACTIONS(37),
    [anon_sym_upcast] = ACTIONS(37),
    [anon_sym_downcast] = ACTIONS(37),
    [anon_sym_COLON_GT] = ACTIONS(71),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(71),
    [anon_sym_for] = ACTIONS(73),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(79),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_match] = ACTIONS(83),
    [anon_sym_match_BANG] = ACTIONS(85),
    [anon_sym_function] = ACTIONS(87),
    [anon_sym_LT_DASH] = ACTIONS(89),
    [anon_sym_DOT_LBRACK] = ACTIONS(91),
    [anon_sym_LT] = ACTIONS(93),
    [anon_sym_use] = ACTIONS(95),
    [anon_sym_use_BANG] = ACTIONS(97),
    [anon_sym_do_BANG] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(101),
    [anon_sym_LPAREN2] = ACTIONS(103),
    [anon_sym_default] = ACTIONS(161),
    [anon_sym_or] = ACTIONS(51),
    [anon_sym_static] = ACTIONS(161),
    [anon_sym_member] = ACTIONS(161),
    [anon_sym_abstract] = ACTIONS(161),
    [anon_sym_val] = ACTIONS(161),
    [anon_sym_override] = ACTIONS(161),
    [aux_sym_char_token1] = ACTIONS(105),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(107),
    [anon_sym_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DQUOTE] = ACTIONS(111),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(115),
    [sym_bool] = ACTIONS(117),
    [sym_unit] = ACTIONS(119),
    [anon_sym_LPAREN_PIPE] = ACTIONS(121),
    [sym_op_identifier] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(129),
    [sym_xint] = ACTIONS(131),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(135),
    [sym__newline] = ACTIONS(153),
    [sym__dedent] = ACTIONS(159),
  },
  [8] = {
    [sym_function_or_value_defn] = STATE(705),
    [sym__expression] = STATE(6),
    [sym_literal_expression] = STATE(867),
    [sym_long_identifier_or_op] = STATE(867),
    [sym_tuple_expression] = STATE(867),
    [sym_brace_expression] = STATE(867),
    [sym_anon_record_expression] = STATE(867),
    [sym_prefixed_expression] = STATE(867),
    [sym_typecast_expression] = STATE(867),
    [sym_for_expression] = STATE(867),
    [sym_while_expression] = STATE(867),
    [sym__if_branch] = STATE(6511),
    [sym_if_expression] = STATE(867),
    [sym_fun_expression] = STATE(867),
    [sym_try_expression] = STATE(867),
    [sym_match_expression] = STATE(867),
    [sym_function_expression] = STATE(867),
    [sym_mutate_expression] = STATE(867),
    [sym_index_expression] = STATE(867),
    [sym_typed_expression] = STATE(867),
    [sym_declaration_expression] = STATE(867),
    [sym_do_expression] = STATE(867),
    [sym_list_expression] = STATE(867),
    [sym_array_expression] = STATE(867),
    [sym_begin_end_expression] = STATE(867),
    [sym_paren_expression] = STATE(867),
    [sym__high_prec_app] = STATE(864),
    [sym__low_prec_app] = STATE(864),
    [sym_application_expression] = STATE(867),
    [sym_dot_expression] = STATE(867),
    [sym_infix_expression] = STATE(867),
    [sym_ce_expression] = STATE(867),
    [sym_sequential_expression] = STATE(867),
    [sym_char] = STATE(868),
    [sym_format_string] = STATE(869),
    [sym__string_literal] = STATE(869),
    [sym_string] = STATE(868),
    [sym_verbatim_string] = STATE(868),
    [sym_bytearray] = STATE(868),
    [sym_verbatim_bytearray] = STATE(868),
    [sym_format_triple_quoted_string] = STATE(870),
    [sym_triple_quoted_string] = STATE(868),
    [sym_const] = STATE(867),
    [sym_long_identifier] = STATE(872),
    [sym_active_pattern] = STATE(871),
    [sym__identifier_or_op] = STATE(873),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(658),
    [sym_infix_op] = STATE(566),
    [sym_sbyte] = STATE(868),
    [sym_byte] = STATE(868),
    [sym_int16] = STATE(868),
    [sym_uint16] = STATE(868),
    [sym_int32] = STATE(868),
    [sym_uint32] = STATE(868),
    [sym_nativeint] = STATE(868),
    [sym_unativeint] = STATE(868),
    [sym_int64] = STATE(868),
    [sym_uint64] = STATE(868),
    [sym_ieee32] = STATE(868),
    [sym_ieee64] = STATE(868),
    [sym_bignum] = STATE(868),
    [sym_decimal] = STATE(868),
    [sym_float] = STATE(860),
    [sym_block_comment] = STATE(8),
    [sym_compiler_directive_decl] = STATE(8),
    [sym_fsi_directive_decl] = STATE(8),
    [sym_preproc_line] = STATE(8),
    [sym_preproc_if_in_expression] = STATE(867),
    [aux_sym_sequential_expression_repeat1] = STATE(866),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(29),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_LBRACK_LT] = ACTIONS(163),
    [anon_sym_COLON] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(37),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [aux_sym_access_modifier_token1] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_COMMA] = ACTIONS(47),
    [anon_sym_null] = ACTIONS(49),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACK_PIPE] = ACTIONS(57),
    [anon_sym_LBRACE] = ACTIONS(165),
    [anon_sym_LT_AT] = ACTIONS(61),
    [anon_sym_LT_AT_AT] = ACTIONS(63),
    [anon_sym_DOT] = ACTIONS(65),
    [anon_sym_LBRACE_PIPE] = ACTIONS(67),
    [anon_sym_new] = ACTIONS(37),
    [anon_sym_with] = ACTIONS(165),
    [anon_sym_return_BANG] = ACTIONS(69),
    [anon_sym_yield] = ACTIONS(37),
    [anon_sym_yield_BANG] = ACTIONS(69),
    [anon_sym_lazy] = ACTIONS(37),
    [anon_sym_assert] = ACTIONS(37),
    [anon_sym_upcast] = ACTIONS(37),
    [anon_sym_downcast] = ACTIONS(37),
    [anon_sym_COLON_GT] = ACTIONS(71),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(71),
    [anon_sym_for] = ACTIONS(73),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(79),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_match] = ACTIONS(83),
    [anon_sym_match_BANG] = ACTIONS(85),
    [anon_sym_function] = ACTIONS(87),
    [anon_sym_LT_DASH] = ACTIONS(89),
    [anon_sym_DOT_LBRACK] = ACTIONS(91),
    [anon_sym_LT] = ACTIONS(93),
    [anon_sym_use] = ACTIONS(95),
    [anon_sym_use_BANG] = ACTIONS(97),
    [anon_sym_do_BANG] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(101),
    [anon_sym_LPAREN2] = ACTIONS(103),
    [anon_sym_default] = ACTIONS(165),
    [anon_sym_or] = ACTIONS(51),
    [anon_sym_static] = ACTIONS(165),
    [anon_sym_member] = ACTIONS(165),
    [anon_sym_abstract] = ACTIONS(165),
    [anon_sym_val] = ACTIONS(165),
    [anon_sym_override] = ACTIONS(165),
    [aux_sym_char_token1] = ACTIONS(105),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(107),
    [anon_sym_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DQUOTE] = ACTIONS(111),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(115),
    [sym_bool] = ACTIONS(117),
    [sym_unit] = ACTIONS(119),
    [anon_sym_LPAREN_PIPE] = ACTIONS(121),
    [sym_op_identifier] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(129),
    [sym_xint] = ACTIONS(131),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(135),
    [sym__newline] = ACTIONS(163),
    [sym__dedent] = ACTIONS(163),
  },
  [9] = {
    [sym_function_or_value_defn] = STATE(705),
    [sym__expression] = STATE(6),
    [sym_literal_expression] = STATE(867),
    [sym_long_identifier_or_op] = STATE(867),
    [sym_tuple_expression] = STATE(867),
    [sym_brace_expression] = STATE(867),
    [sym_anon_record_expression] = STATE(867),
    [sym_prefixed_expression] = STATE(867),
    [sym_typecast_expression] = STATE(867),
    [sym_for_expression] = STATE(867),
    [sym_while_expression] = STATE(867),
    [sym__if_branch] = STATE(6511),
    [sym_if_expression] = STATE(867),
    [sym_fun_expression] = STATE(867),
    [sym_try_expression] = STATE(867),
    [sym_match_expression] = STATE(867),
    [sym_function_expression] = STATE(867),
    [sym_mutate_expression] = STATE(867),
    [sym_index_expression] = STATE(867),
    [sym_typed_expression] = STATE(867),
    [sym_declaration_expression] = STATE(867),
    [sym_do_expression] = STATE(867),
    [sym_list_expression] = STATE(867),
    [sym_array_expression] = STATE(867),
    [sym_begin_end_expression] = STATE(867),
    [sym_paren_expression] = STATE(867),
    [sym__high_prec_app] = STATE(864),
    [sym__low_prec_app] = STATE(864),
    [sym_application_expression] = STATE(867),
    [sym_dot_expression] = STATE(867),
    [sym_infix_expression] = STATE(867),
    [sym_ce_expression] = STATE(867),
    [sym_sequential_expression] = STATE(867),
    [sym_char] = STATE(868),
    [sym_format_string] = STATE(869),
    [sym__string_literal] = STATE(869),
    [sym_string] = STATE(868),
    [sym_verbatim_string] = STATE(868),
    [sym_bytearray] = STATE(868),
    [sym_verbatim_bytearray] = STATE(868),
    [sym_format_triple_quoted_string] = STATE(870),
    [sym_triple_quoted_string] = STATE(868),
    [sym_const] = STATE(867),
    [sym_long_identifier] = STATE(872),
    [sym_active_pattern] = STATE(871),
    [sym__identifier_or_op] = STATE(873),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(658),
    [sym_infix_op] = STATE(566),
    [sym_sbyte] = STATE(868),
    [sym_byte] = STATE(868),
    [sym_int16] = STATE(868),
    [sym_uint16] = STATE(868),
    [sym_int32] = STATE(868),
    [sym_uint32] = STATE(868),
    [sym_nativeint] = STATE(868),
    [sym_unativeint] = STATE(868),
    [sym_int64] = STATE(868),
    [sym_uint64] = STATE(868),
    [sym_ieee32] = STATE(868),
    [sym_ieee64] = STATE(868),
    [sym_bignum] = STATE(868),
    [sym_decimal] = STATE(868),
    [sym_float] = STATE(860),
    [sym_block_comment] = STATE(9),
    [sym_compiler_directive_decl] = STATE(9),
    [sym_fsi_directive_decl] = STATE(9),
    [sym_preproc_line] = STATE(9),
    [sym_preproc_if_in_expression] = STATE(867),
    [aux_sym_sequential_expression_repeat1] = STATE(866),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(29),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_LBRACK_LT] = ACTIONS(167),
    [anon_sym_COLON] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(37),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [aux_sym_access_modifier_token1] = ACTIONS(167),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_COMMA] = ACTIONS(47),
    [anon_sym_null] = ACTIONS(49),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACK_PIPE] = ACTIONS(57),
    [anon_sym_LBRACE] = ACTIONS(169),
    [anon_sym_LT_AT] = ACTIONS(61),
    [anon_sym_LT_AT_AT] = ACTIONS(63),
    [anon_sym_DOT] = ACTIONS(65),
    [anon_sym_LBRACE_PIPE] = ACTIONS(67),
    [anon_sym_new] = ACTIONS(37),
    [anon_sym_with] = ACTIONS(169),
    [anon_sym_return_BANG] = ACTIONS(69),
    [anon_sym_yield] = ACTIONS(37),
    [anon_sym_yield_BANG] = ACTIONS(69),
    [anon_sym_lazy] = ACTIONS(37),
    [anon_sym_assert] = ACTIONS(37),
    [anon_sym_upcast] = ACTIONS(37),
    [anon_sym_downcast] = ACTIONS(37),
    [anon_sym_COLON_GT] = ACTIONS(71),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(71),
    [anon_sym_for] = ACTIONS(73),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(79),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_match] = ACTIONS(83),
    [anon_sym_match_BANG] = ACTIONS(85),
    [anon_sym_function] = ACTIONS(87),
    [anon_sym_LT_DASH] = ACTIONS(89),
    [anon_sym_DOT_LBRACK] = ACTIONS(91),
    [anon_sym_LT] = ACTIONS(93),
    [anon_sym_use] = ACTIONS(95),
    [anon_sym_use_BANG] = ACTIONS(97),
    [anon_sym_do_BANG] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(101),
    [anon_sym_LPAREN2] = ACTIONS(103),
    [anon_sym_default] = ACTIONS(169),
    [anon_sym_or] = ACTIONS(51),
    [anon_sym_static] = ACTIONS(169),
    [anon_sym_member] = ACTIONS(169),
    [anon_sym_abstract] = ACTIONS(169),
    [anon_sym_val] = ACTIONS(169),
    [anon_sym_override] = ACTIONS(169),
    [aux_sym_char_token1] = ACTIONS(105),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(107),
    [anon_sym_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DQUOTE] = ACTIONS(111),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(115),
    [sym_bool] = ACTIONS(117),
    [sym_unit] = ACTIONS(119),
    [anon_sym_LPAREN_PIPE] = ACTIONS(121),
    [sym_op_identifier] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(129),
    [sym_xint] = ACTIONS(131),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(135),
    [sym__newline] = ACTIONS(167),
    [sym__dedent] = ACTIONS(167),
  },
  [10] = {
    [sym_function_or_value_defn] = STATE(705),
    [sym__expression] = STATE(6),
    [sym_literal_expression] = STATE(867),
    [sym_long_identifier_or_op] = STATE(867),
    [sym_tuple_expression] = STATE(867),
    [sym_brace_expression] = STATE(867),
    [sym_anon_record_expression] = STATE(867),
    [sym_prefixed_expression] = STATE(867),
    [sym_typecast_expression] = STATE(867),
    [sym_for_expression] = STATE(867),
    [sym_while_expression] = STATE(867),
    [sym__if_branch] = STATE(6511),
    [sym_if_expression] = STATE(867),
    [sym_fun_expression] = STATE(867),
    [sym_try_expression] = STATE(867),
    [sym_match_expression] = STATE(867),
    [sym_function_expression] = STATE(867),
    [sym_mutate_expression] = STATE(867),
    [sym_index_expression] = STATE(867),
    [sym_typed_expression] = STATE(867),
    [sym_declaration_expression] = STATE(867),
    [sym_do_expression] = STATE(867),
    [sym_list_expression] = STATE(867),
    [sym_array_expression] = STATE(867),
    [sym_begin_end_expression] = STATE(867),
    [sym_paren_expression] = STATE(867),
    [sym__high_prec_app] = STATE(864),
    [sym__low_prec_app] = STATE(864),
    [sym_application_expression] = STATE(867),
    [sym_dot_expression] = STATE(867),
    [sym_infix_expression] = STATE(867),
    [sym_ce_expression] = STATE(867),
    [sym_sequential_expression] = STATE(867),
    [sym_char] = STATE(868),
    [sym_format_string] = STATE(869),
    [sym__string_literal] = STATE(869),
    [sym_string] = STATE(868),
    [sym_verbatim_string] = STATE(868),
    [sym_bytearray] = STATE(868),
    [sym_verbatim_bytearray] = STATE(868),
    [sym_format_triple_quoted_string] = STATE(870),
    [sym_triple_quoted_string] = STATE(868),
    [sym_const] = STATE(867),
    [sym_long_identifier] = STATE(872),
    [sym_active_pattern] = STATE(871),
    [sym__identifier_or_op] = STATE(873),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(658),
    [sym_infix_op] = STATE(566),
    [sym_sbyte] = STATE(868),
    [sym_byte] = STATE(868),
    [sym_int16] = STATE(868),
    [sym_uint16] = STATE(868),
    [sym_int32] = STATE(868),
    [sym_uint32] = STATE(868),
    [sym_nativeint] = STATE(868),
    [sym_unativeint] = STATE(868),
    [sym_int64] = STATE(868),
    [sym_uint64] = STATE(868),
    [sym_ieee32] = STATE(868),
    [sym_ieee64] = STATE(868),
    [sym_bignum] = STATE(868),
    [sym_decimal] = STATE(868),
    [sym_float] = STATE(860),
    [sym_block_comment] = STATE(10),
    [sym_compiler_directive_decl] = STATE(10),
    [sym_fsi_directive_decl] = STATE(10),
    [sym_preproc_line] = STATE(10),
    [sym_preproc_if_in_expression] = STATE(867),
    [aux_sym_sequential_expression_repeat1] = STATE(866),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(29),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_LBRACK_LT] = ACTIONS(171),
    [anon_sym_COLON] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(37),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [aux_sym_access_modifier_token1] = ACTIONS(171),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_COMMA] = ACTIONS(47),
    [anon_sym_null] = ACTIONS(49),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACK_PIPE] = ACTIONS(57),
    [anon_sym_LBRACE] = ACTIONS(139),
    [anon_sym_LT_AT] = ACTIONS(61),
    [anon_sym_LT_AT_AT] = ACTIONS(63),
    [anon_sym_DOT] = ACTIONS(65),
    [anon_sym_LBRACE_PIPE] = ACTIONS(67),
    [anon_sym_new] = ACTIONS(37),
    [anon_sym_with] = ACTIONS(173),
    [anon_sym_return_BANG] = ACTIONS(69),
    [anon_sym_yield] = ACTIONS(37),
    [anon_sym_yield_BANG] = ACTIONS(69),
    [anon_sym_lazy] = ACTIONS(37),
    [anon_sym_assert] = ACTIONS(37),
    [anon_sym_upcast] = ACTIONS(37),
    [anon_sym_downcast] = ACTIONS(37),
    [anon_sym_COLON_GT] = ACTIONS(71),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(71),
    [anon_sym_for] = ACTIONS(73),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(79),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_match] = ACTIONS(83),
    [anon_sym_match_BANG] = ACTIONS(85),
    [anon_sym_function] = ACTIONS(87),
    [anon_sym_LT_DASH] = ACTIONS(89),
    [anon_sym_DOT_LBRACK] = ACTIONS(91),
    [anon_sym_LT] = ACTIONS(93),
    [anon_sym_use] = ACTIONS(95),
    [anon_sym_use_BANG] = ACTIONS(97),
    [anon_sym_do_BANG] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(101),
    [anon_sym_LPAREN2] = ACTIONS(103),
    [anon_sym_default] = ACTIONS(173),
    [anon_sym_or] = ACTIONS(51),
    [anon_sym_static] = ACTIONS(173),
    [anon_sym_member] = ACTIONS(173),
    [anon_sym_abstract] = ACTIONS(173),
    [anon_sym_val] = ACTIONS(173),
    [anon_sym_override] = ACTIONS(173),
    [aux_sym_char_token1] = ACTIONS(105),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(107),
    [anon_sym_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DQUOTE] = ACTIONS(111),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(115),
    [sym_bool] = ACTIONS(117),
    [sym_unit] = ACTIONS(119),
    [anon_sym_LPAREN_PIPE] = ACTIONS(121),
    [sym_op_identifier] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(129),
    [sym_xint] = ACTIONS(131),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(135),
    [sym__newline] = ACTIONS(153),
    [sym__dedent] = ACTIONS(171),
  },
  [11] = {
    [sym_function_or_value_defn] = STATE(705),
    [sym__expression] = STATE(6),
    [sym_literal_expression] = STATE(867),
    [sym_long_identifier_or_op] = STATE(867),
    [sym_tuple_expression] = STATE(867),
    [sym_brace_expression] = STATE(867),
    [sym_anon_record_expression] = STATE(867),
    [sym_prefixed_expression] = STATE(867),
    [sym_typecast_expression] = STATE(867),
    [sym_for_expression] = STATE(867),
    [sym_while_expression] = STATE(867),
    [sym__if_branch] = STATE(6511),
    [sym_if_expression] = STATE(867),
    [sym_fun_expression] = STATE(867),
    [sym_try_expression] = STATE(867),
    [sym_match_expression] = STATE(867),
    [sym_function_expression] = STATE(867),
    [sym_mutate_expression] = STATE(867),
    [sym_index_expression] = STATE(867),
    [sym_typed_expression] = STATE(867),
    [sym_declaration_expression] = STATE(867),
    [sym_do_expression] = STATE(867),
    [sym_list_expression] = STATE(867),
    [sym_array_expression] = STATE(867),
    [sym_begin_end_expression] = STATE(867),
    [sym_paren_expression] = STATE(867),
    [sym__high_prec_app] = STATE(864),
    [sym__low_prec_app] = STATE(864),
    [sym_application_expression] = STATE(867),
    [sym_dot_expression] = STATE(867),
    [sym_infix_expression] = STATE(867),
    [sym_ce_expression] = STATE(867),
    [sym_sequential_expression] = STATE(867),
    [sym_char] = STATE(868),
    [sym_format_string] = STATE(869),
    [sym__string_literal] = STATE(869),
    [sym_string] = STATE(868),
    [sym_verbatim_string] = STATE(868),
    [sym_bytearray] = STATE(868),
    [sym_verbatim_bytearray] = STATE(868),
    [sym_format_triple_quoted_string] = STATE(870),
    [sym_triple_quoted_string] = STATE(868),
    [sym_const] = STATE(867),
    [sym_long_identifier] = STATE(872),
    [sym_active_pattern] = STATE(871),
    [sym__identifier_or_op] = STATE(873),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(658),
    [sym_infix_op] = STATE(566),
    [sym_sbyte] = STATE(868),
    [sym_byte] = STATE(868),
    [sym_int16] = STATE(868),
    [sym_uint16] = STATE(868),
    [sym_int32] = STATE(868),
    [sym_uint32] = STATE(868),
    [sym_nativeint] = STATE(868),
    [sym_unativeint] = STATE(868),
    [sym_int64] = STATE(868),
    [sym_uint64] = STATE(868),
    [sym_ieee32] = STATE(868),
    [sym_ieee64] = STATE(868),
    [sym_bignum] = STATE(868),
    [sym_decimal] = STATE(868),
    [sym_float] = STATE(860),
    [sym_block_comment] = STATE(11),
    [sym_compiler_directive_decl] = STATE(11),
    [sym_fsi_directive_decl] = STATE(11),
    [sym_preproc_line] = STATE(11),
    [sym_preproc_if_in_expression] = STATE(867),
    [aux_sym_sequential_expression_repeat1] = STATE(866),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(29),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_LBRACK_LT] = ACTIONS(175),
    [anon_sym_COLON] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(37),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [aux_sym_access_modifier_token1] = ACTIONS(175),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_COMMA] = ACTIONS(47),
    [anon_sym_null] = ACTIONS(49),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACK_PIPE] = ACTIONS(57),
    [anon_sym_LBRACE] = ACTIONS(139),
    [anon_sym_LT_AT] = ACTIONS(61),
    [anon_sym_LT_AT_AT] = ACTIONS(63),
    [anon_sym_DOT] = ACTIONS(65),
    [anon_sym_LBRACE_PIPE] = ACTIONS(67),
    [anon_sym_new] = ACTIONS(177),
    [anon_sym_with] = ACTIONS(179),
    [anon_sym_return_BANG] = ACTIONS(69),
    [anon_sym_yield] = ACTIONS(37),
    [anon_sym_yield_BANG] = ACTIONS(69),
    [anon_sym_lazy] = ACTIONS(37),
    [anon_sym_assert] = ACTIONS(37),
    [anon_sym_upcast] = ACTIONS(37),
    [anon_sym_downcast] = ACTIONS(37),
    [anon_sym_COLON_GT] = ACTIONS(71),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(71),
    [anon_sym_for] = ACTIONS(73),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(79),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_match] = ACTIONS(83),
    [anon_sym_match_BANG] = ACTIONS(85),
    [anon_sym_function] = ACTIONS(87),
    [anon_sym_LT_DASH] = ACTIONS(89),
    [anon_sym_DOT_LBRACK] = ACTIONS(91),
    [anon_sym_LT] = ACTIONS(93),
    [anon_sym_use] = ACTIONS(95),
    [anon_sym_use_BANG] = ACTIONS(97),
    [anon_sym_do_BANG] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(101),
    [anon_sym_LPAREN2] = ACTIONS(103),
    [anon_sym_default] = ACTIONS(177),
    [anon_sym_or] = ACTIONS(51),
    [anon_sym_static] = ACTIONS(177),
    [anon_sym_member] = ACTIONS(177),
    [anon_sym_abstract] = ACTIONS(177),
    [anon_sym_val] = ACTIONS(177),
    [anon_sym_override] = ACTIONS(177),
    [aux_sym_char_token1] = ACTIONS(105),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(107),
    [anon_sym_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DQUOTE] = ACTIONS(111),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(115),
    [sym_bool] = ACTIONS(117),
    [sym_unit] = ACTIONS(119),
    [anon_sym_LPAREN_PIPE] = ACTIONS(121),
    [sym_op_identifier] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(129),
    [sym_xint] = ACTIONS(131),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(135),
    [sym__newline] = ACTIONS(175),
    [sym__dedent] = ACTIONS(175),
  },
  [12] = {
    [sym_function_or_value_defn] = STATE(705),
    [sym__expression] = STATE(6),
    [sym_literal_expression] = STATE(867),
    [sym_long_identifier_or_op] = STATE(867),
    [sym_tuple_expression] = STATE(867),
    [sym_brace_expression] = STATE(867),
    [sym_anon_record_expression] = STATE(867),
    [sym_prefixed_expression] = STATE(867),
    [sym_typecast_expression] = STATE(867),
    [sym_for_expression] = STATE(867),
    [sym_while_expression] = STATE(867),
    [sym__if_branch] = STATE(6511),
    [sym_if_expression] = STATE(867),
    [sym_fun_expression] = STATE(867),
    [sym_try_expression] = STATE(867),
    [sym_match_expression] = STATE(867),
    [sym_function_expression] = STATE(867),
    [sym_mutate_expression] = STATE(867),
    [sym_index_expression] = STATE(867),
    [sym_typed_expression] = STATE(867),
    [sym_declaration_expression] = STATE(867),
    [sym_do_expression] = STATE(867),
    [sym_list_expression] = STATE(867),
    [sym_array_expression] = STATE(867),
    [sym_begin_end_expression] = STATE(867),
    [sym_paren_expression] = STATE(867),
    [sym__high_prec_app] = STATE(864),
    [sym__low_prec_app] = STATE(864),
    [sym_application_expression] = STATE(867),
    [sym_dot_expression] = STATE(867),
    [sym_infix_expression] = STATE(867),
    [sym_ce_expression] = STATE(867),
    [sym_sequential_expression] = STATE(867),
    [sym_char] = STATE(868),
    [sym_format_string] = STATE(869),
    [sym__string_literal] = STATE(869),
    [sym_string] = STATE(868),
    [sym_verbatim_string] = STATE(868),
    [sym_bytearray] = STATE(868),
    [sym_verbatim_bytearray] = STATE(868),
    [sym_format_triple_quoted_string] = STATE(870),
    [sym_triple_quoted_string] = STATE(868),
    [sym_const] = STATE(867),
    [sym_long_identifier] = STATE(872),
    [sym_active_pattern] = STATE(871),
    [sym__identifier_or_op] = STATE(873),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(658),
    [sym_infix_op] = STATE(566),
    [sym_sbyte] = STATE(868),
    [sym_byte] = STATE(868),
    [sym_int16] = STATE(868),
    [sym_uint16] = STATE(868),
    [sym_int32] = STATE(868),
    [sym_uint32] = STATE(868),
    [sym_nativeint] = STATE(868),
    [sym_unativeint] = STATE(868),
    [sym_int64] = STATE(868),
    [sym_uint64] = STATE(868),
    [sym_ieee32] = STATE(868),
    [sym_ieee64] = STATE(868),
    [sym_bignum] = STATE(868),
    [sym_decimal] = STATE(868),
    [sym_float] = STATE(860),
    [sym_block_comment] = STATE(12),
    [sym_compiler_directive_decl] = STATE(12),
    [sym_fsi_directive_decl] = STATE(12),
    [sym_preproc_line] = STATE(12),
    [sym_preproc_if_in_expression] = STATE(867),
    [aux_sym_sequential_expression_repeat1] = STATE(866),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(181),
    [anon_sym_EQ] = ACTIONS(183),
    [anon_sym_LBRACK_LT] = ACTIONS(183),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_return] = ACTIONS(181),
    [anon_sym_do] = ACTIONS(181),
    [anon_sym_let] = ACTIONS(181),
    [anon_sym_let_BANG] = ACTIONS(183),
    [aux_sym_access_modifier_token1] = ACTIONS(183),
    [anon_sym_LPAREN] = ACTIONS(181),
    [anon_sym_COMMA] = ACTIONS(183),
    [anon_sym_null] = ACTIONS(181),
    [anon_sym_QMARK] = ACTIONS(181),
    [anon_sym_COLON_QMARK] = ACTIONS(181),
    [anon_sym_COLON_COLON] = ACTIONS(183),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_LBRACK_PIPE] = ACTIONS(183),
    [anon_sym_LBRACE] = ACTIONS(181),
    [anon_sym_LT_AT] = ACTIONS(181),
    [anon_sym_LT_AT_AT] = ACTIONS(181),
    [anon_sym_DOT] = ACTIONS(65),
    [anon_sym_LBRACE_PIPE] = ACTIONS(183),
    [anon_sym_new] = ACTIONS(181),
    [anon_sym_with] = ACTIONS(181),
    [anon_sym_return_BANG] = ACTIONS(183),
    [anon_sym_yield] = ACTIONS(181),
    [anon_sym_yield_BANG] = ACTIONS(183),
    [anon_sym_lazy] = ACTIONS(181),
    [anon_sym_assert] = ACTIONS(181),
    [anon_sym_upcast] = ACTIONS(181),
    [anon_sym_downcast] = ACTIONS(181),
    [anon_sym_COLON_GT] = ACTIONS(183),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(183),
    [anon_sym_for] = ACTIONS(181),
    [anon_sym_while] = ACTIONS(181),
    [anon_sym_if] = ACTIONS(181),
    [anon_sym_fun] = ACTIONS(181),
    [anon_sym_try] = ACTIONS(181),
    [anon_sym_match] = ACTIONS(181),
    [anon_sym_match_BANG] = ACTIONS(183),
    [anon_sym_function] = ACTIONS(181),
    [anon_sym_LT_DASH] = ACTIONS(181),
    [anon_sym_DOT_LBRACK] = ACTIONS(91),
    [anon_sym_LT] = ACTIONS(93),
    [anon_sym_use] = ACTIONS(181),
    [anon_sym_use_BANG] = ACTIONS(183),
    [anon_sym_do_BANG] = ACTIONS(183),
    [anon_sym_begin] = ACTIONS(181),
    [anon_sym_LPAREN2] = ACTIONS(103),
    [anon_sym_default] = ACTIONS(181),
    [anon_sym_or] = ACTIONS(181),
    [anon_sym_static] = ACTIONS(181),
    [anon_sym_member] = ACTIONS(181),
    [anon_sym_abstract] = ACTIONS(181),
    [anon_sym_val] = ACTIONS(181),
    [anon_sym_override] = ACTIONS(181),
    [aux_sym_char_token1] = ACTIONS(183),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(181),
    [anon_sym_DQUOTE] = ACTIONS(181),
    [anon_sym_AT_DQUOTE] = ACTIONS(183),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(183),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(183),
    [sym_bool] = ACTIONS(181),
    [sym_unit] = ACTIONS(119),
    [anon_sym_LPAREN_PIPE] = ACTIONS(181),
    [sym_op_identifier] = ACTIONS(181),
    [anon_sym_PLUS] = ACTIONS(181),
    [anon_sym_DASH] = ACTIONS(181),
    [anon_sym_PLUS_DOT] = ACTIONS(181),
    [anon_sym_DASH_DOT] = ACTIONS(181),
    [anon_sym_PERCENT] = ACTIONS(181),
    [anon_sym_AMP_AMP] = ACTIONS(181),
    [anon_sym_TILDE] = ACTIONS(183),
    [aux_sym_prefix_op_token1] = ACTIONS(181),
    [aux_sym_infix_op_token1] = ACTIONS(183),
    [aux_sym_infix_op_token2] = ACTIONS(181),
    [anon_sym_PIPE_PIPE] = ACTIONS(181),
    [anon_sym_BANG_EQ] = ACTIONS(181),
    [anon_sym_COLON_EQ] = ACTIONS(183),
    [anon_sym_DOLLAR] = ACTIONS(181),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(181),
    [sym_int] = ACTIONS(181),
    [sym_xint] = ACTIONS(183),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(183),
    [sym__newline] = ACTIONS(183),
    [sym__dedent] = ACTIONS(183),
  },
  [13] = {
    [sym_function_or_value_defn] = STATE(627),
    [sym__expression] = STATE(17),
    [sym_literal_expression] = STATE(1118),
    [sym_long_identifier_or_op] = STATE(1118),
    [sym_tuple_expression] = STATE(1118),
    [sym_brace_expression] = STATE(1118),
    [sym_anon_record_expression] = STATE(1118),
    [sym_prefixed_expression] = STATE(1118),
    [sym_typecast_expression] = STATE(1118),
    [sym_for_expression] = STATE(1118),
    [sym_while_expression] = STATE(1118),
    [sym__if_branch] = STATE(7163),
    [sym_if_expression] = STATE(1118),
    [sym_fun_expression] = STATE(1118),
    [sym_try_expression] = STATE(1118),
    [sym_match_expression] = STATE(1118),
    [sym_function_expression] = STATE(1118),
    [sym_mutate_expression] = STATE(1118),
    [sym_index_expression] = STATE(1118),
    [sym_typed_expression] = STATE(1118),
    [sym_declaration_expression] = STATE(1118),
    [sym_do_expression] = STATE(1118),
    [sym_list_expression] = STATE(1118),
    [sym_array_expression] = STATE(1118),
    [sym_begin_end_expression] = STATE(1118),
    [sym_paren_expression] = STATE(1118),
    [sym__high_prec_app] = STATE(1133),
    [sym__low_prec_app] = STATE(1133),
    [sym_application_expression] = STATE(1118),
    [sym_dot_expression] = STATE(1118),
    [sym_infix_expression] = STATE(1118),
    [sym_ce_expression] = STATE(1118),
    [sym_sequential_expression] = STATE(1118),
    [sym_char] = STATE(1080),
    [sym_format_string] = STATE(1090),
    [sym__string_literal] = STATE(1090),
    [sym_string] = STATE(1080),
    [sym_verbatim_string] = STATE(1080),
    [sym_bytearray] = STATE(1080),
    [sym_verbatim_bytearray] = STATE(1080),
    [sym_format_triple_quoted_string] = STATE(1096),
    [sym_triple_quoted_string] = STATE(1080),
    [sym_const] = STATE(1118),
    [sym_long_identifier] = STATE(1156),
    [sym_active_pattern] = STATE(1085),
    [sym__identifier_or_op] = STATE(1099),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(517),
    [sym_infix_op] = STATE(487),
    [sym_sbyte] = STATE(1080),
    [sym_byte] = STATE(1080),
    [sym_int16] = STATE(1080),
    [sym_uint16] = STATE(1080),
    [sym_int32] = STATE(1080),
    [sym_uint32] = STATE(1080),
    [sym_nativeint] = STATE(1080),
    [sym_unativeint] = STATE(1080),
    [sym_int64] = STATE(1080),
    [sym_uint64] = STATE(1080),
    [sym_ieee32] = STATE(1080),
    [sym_ieee64] = STATE(1080),
    [sym_bignum] = STATE(1080),
    [sym_decimal] = STATE(1080),
    [sym_float] = STATE(979),
    [sym_block_comment] = STATE(13),
    [sym_compiler_directive_decl] = STATE(13),
    [sym_fsi_directive_decl] = STATE(13),
    [sym_preproc_line] = STATE(13),
    [sym_preproc_if_in_expression] = STATE(1118),
    [aux_sym_sequential_expression_repeat1] = STATE(1069),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(181),
    [anon_sym_EQ] = ACTIONS(183),
    [anon_sym_GT_RBRACK] = ACTIONS(183),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_return] = ACTIONS(181),
    [anon_sym_do] = ACTIONS(181),
    [anon_sym_let] = ACTIONS(181),
    [anon_sym_let_BANG] = ACTIONS(183),
    [anon_sym_LPAREN] = ACTIONS(181),
    [anon_sym_COMMA] = ACTIONS(183),
    [anon_sym_null] = ACTIONS(181),
    [anon_sym_QMARK] = ACTIONS(181),
    [anon_sym_COLON_QMARK] = ACTIONS(181),
    [anon_sym_COLON_COLON] = ACTIONS(183),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_RBRACK] = ACTIONS(183),
    [anon_sym_LBRACK_PIPE] = ACTIONS(183),
    [anon_sym_LBRACE] = ACTIONS(181),
    [anon_sym_RBRACE] = ACTIONS(183),
    [anon_sym_LT_AT] = ACTIONS(181),
    [anon_sym_LT_AT_AT] = ACTIONS(181),
    [anon_sym_DOT] = ACTIONS(185),
    [anon_sym_LBRACE_PIPE] = ACTIONS(183),
    [anon_sym_new] = ACTIONS(181),
    [anon_sym_with] = ACTIONS(181),
    [anon_sym_return_BANG] = ACTIONS(183),
    [anon_sym_yield] = ACTIONS(181),
    [anon_sym_yield_BANG] = ACTIONS(183),
    [anon_sym_lazy] = ACTIONS(181),
    [anon_sym_assert] = ACTIONS(181),
    [anon_sym_upcast] = ACTIONS(181),
    [anon_sym_downcast] = ACTIONS(181),
    [anon_sym_COLON_GT] = ACTIONS(183),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(183),
    [anon_sym_for] = ACTIONS(181),
    [anon_sym_to] = ACTIONS(181),
    [anon_sym_downto] = ACTIONS(181),
    [anon_sym_while] = ACTIONS(181),
    [anon_sym_if] = ACTIONS(181),
    [anon_sym_fun] = ACTIONS(181),
    [anon_sym_try] = ACTIONS(181),
    [anon_sym_match] = ACTIONS(181),
    [anon_sym_match_BANG] = ACTIONS(183),
    [anon_sym_function] = ACTIONS(181),
    [anon_sym_LT_DASH] = ACTIONS(181),
    [anon_sym_DOT_LBRACK] = ACTIONS(187),
    [anon_sym_LT] = ACTIONS(189),
    [anon_sym_use] = ACTIONS(181),
    [anon_sym_use_BANG] = ACTIONS(183),
    [anon_sym_do_BANG] = ACTIONS(183),
    [anon_sym_begin] = ACTIONS(181),
    [anon_sym_LPAREN2] = ACTIONS(191),
    [anon_sym_or] = ACTIONS(181),
    [aux_sym_char_token1] = ACTIONS(183),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(181),
    [anon_sym_DQUOTE] = ACTIONS(181),
    [anon_sym_AT_DQUOTE] = ACTIONS(183),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(183),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(183),
    [sym_bool] = ACTIONS(181),
    [sym_unit] = ACTIONS(193),
    [anon_sym_LPAREN_PIPE] = ACTIONS(181),
    [sym_op_identifier] = ACTIONS(181),
    [anon_sym_PLUS] = ACTIONS(181),
    [anon_sym_DASH] = ACTIONS(181),
    [anon_sym_PLUS_DOT] = ACTIONS(181),
    [anon_sym_DASH_DOT] = ACTIONS(181),
    [anon_sym_PERCENT] = ACTIONS(181),
    [anon_sym_AMP_AMP] = ACTIONS(181),
    [anon_sym_TILDE] = ACTIONS(183),
    [aux_sym_prefix_op_token1] = ACTIONS(181),
    [aux_sym_infix_op_token1] = ACTIONS(183),
    [aux_sym_infix_op_token2] = ACTIONS(181),
    [anon_sym_PIPE_PIPE] = ACTIONS(181),
    [anon_sym_BANG_EQ] = ACTIONS(181),
    [anon_sym_COLON_EQ] = ACTIONS(183),
    [anon_sym_DOLLAR] = ACTIONS(181),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(181),
    [sym_int] = ACTIONS(181),
    [sym_xint] = ACTIONS(183),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(183),
    [sym__newline] = ACTIONS(183),
  },
  [14] = {
    [sym_function_or_value_defn] = STATE(627),
    [sym__expression] = STATE(17),
    [sym_literal_expression] = STATE(1118),
    [sym_long_identifier_or_op] = STATE(1118),
    [sym_tuple_expression] = STATE(1118),
    [sym_brace_expression] = STATE(1118),
    [sym_anon_record_expression] = STATE(1118),
    [sym_prefixed_expression] = STATE(1118),
    [sym_typecast_expression] = STATE(1118),
    [sym_for_expression] = STATE(1118),
    [sym_while_expression] = STATE(1118),
    [sym__if_branch] = STATE(7163),
    [sym_if_expression] = STATE(1118),
    [sym_fun_expression] = STATE(1118),
    [sym_try_expression] = STATE(1118),
    [sym_match_expression] = STATE(1118),
    [sym_function_expression] = STATE(1118),
    [sym_mutate_expression] = STATE(1118),
    [sym_index_expression] = STATE(1118),
    [sym_typed_expression] = STATE(1118),
    [sym_declaration_expression] = STATE(1118),
    [sym_do_expression] = STATE(1118),
    [sym_list_expression] = STATE(1118),
    [sym_array_expression] = STATE(1118),
    [sym_begin_end_expression] = STATE(1118),
    [sym_paren_expression] = STATE(1118),
    [sym__high_prec_app] = STATE(1133),
    [sym__low_prec_app] = STATE(1133),
    [sym_application_expression] = STATE(1118),
    [sym_dot_expression] = STATE(1118),
    [sym_infix_expression] = STATE(1118),
    [sym_ce_expression] = STATE(1118),
    [sym_sequential_expression] = STATE(1118),
    [sym_char] = STATE(1080),
    [sym_format_string] = STATE(1090),
    [sym__string_literal] = STATE(1090),
    [sym_string] = STATE(1080),
    [sym_verbatim_string] = STATE(1080),
    [sym_bytearray] = STATE(1080),
    [sym_verbatim_bytearray] = STATE(1080),
    [sym_format_triple_quoted_string] = STATE(1096),
    [sym_triple_quoted_string] = STATE(1080),
    [sym_const] = STATE(1118),
    [sym_long_identifier] = STATE(1156),
    [sym_active_pattern] = STATE(1085),
    [sym__identifier_or_op] = STATE(1099),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(517),
    [sym_infix_op] = STATE(487),
    [sym_sbyte] = STATE(1080),
    [sym_byte] = STATE(1080),
    [sym_int16] = STATE(1080),
    [sym_uint16] = STATE(1080),
    [sym_int32] = STATE(1080),
    [sym_uint32] = STATE(1080),
    [sym_nativeint] = STATE(1080),
    [sym_unativeint] = STATE(1080),
    [sym_int64] = STATE(1080),
    [sym_uint64] = STATE(1080),
    [sym_ieee32] = STATE(1080),
    [sym_ieee64] = STATE(1080),
    [sym_bignum] = STATE(1080),
    [sym_decimal] = STATE(1080),
    [sym_float] = STATE(979),
    [sym_block_comment] = STATE(14),
    [sym_compiler_directive_decl] = STATE(14),
    [sym_fsi_directive_decl] = STATE(14),
    [sym_preproc_line] = STATE(14),
    [sym_preproc_if_in_expression] = STATE(1118),
    [aux_sym_sequential_expression_repeat1] = STATE(1069),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(195),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_GT_RBRACK] = ACTIONS(163),
    [anon_sym_COLON] = ACTIONS(197),
    [anon_sym_return] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_COMMA] = ACTIONS(205),
    [anon_sym_null] = ACTIONS(207),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(197),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(209),
    [anon_sym_RBRACK] = ACTIONS(163),
    [anon_sym_LBRACK_PIPE] = ACTIONS(211),
    [anon_sym_LBRACE] = ACTIONS(165),
    [anon_sym_RBRACE] = ACTIONS(163),
    [anon_sym_LT_AT] = ACTIONS(213),
    [anon_sym_LT_AT_AT] = ACTIONS(215),
    [anon_sym_DOT] = ACTIONS(185),
    [anon_sym_LBRACE_PIPE] = ACTIONS(217),
    [anon_sym_new] = ACTIONS(199),
    [anon_sym_with] = ACTIONS(165),
    [anon_sym_return_BANG] = ACTIONS(219),
    [anon_sym_yield] = ACTIONS(199),
    [anon_sym_yield_BANG] = ACTIONS(219),
    [anon_sym_lazy] = ACTIONS(199),
    [anon_sym_assert] = ACTIONS(199),
    [anon_sym_upcast] = ACTIONS(199),
    [anon_sym_downcast] = ACTIONS(199),
    [anon_sym_COLON_GT] = ACTIONS(221),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(221),
    [anon_sym_for] = ACTIONS(223),
    [anon_sym_to] = ACTIONS(165),
    [anon_sym_downto] = ACTIONS(165),
    [anon_sym_while] = ACTIONS(225),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(229),
    [anon_sym_match] = ACTIONS(231),
    [anon_sym_match_BANG] = ACTIONS(233),
    [anon_sym_function] = ACTIONS(235),
    [anon_sym_LT_DASH] = ACTIONS(237),
    [anon_sym_DOT_LBRACK] = ACTIONS(187),
    [anon_sym_LT] = ACTIONS(189),
    [anon_sym_use] = ACTIONS(239),
    [anon_sym_use_BANG] = ACTIONS(241),
    [anon_sym_do_BANG] = ACTIONS(243),
    [anon_sym_begin] = ACTIONS(245),
    [anon_sym_LPAREN2] = ACTIONS(191),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(247),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(251),
    [anon_sym_AT_DQUOTE] = ACTIONS(253),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(255),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(257),
    [sym_bool] = ACTIONS(259),
    [sym_unit] = ACTIONS(193),
    [anon_sym_LPAREN_PIPE] = ACTIONS(261),
    [sym_op_identifier] = ACTIONS(263),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(265),
    [sym_xint] = ACTIONS(267),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(269),
    [sym__newline] = ACTIONS(163),
  },
  [15] = {
    [sym_function_or_value_defn] = STATE(627),
    [sym__expression] = STATE(17),
    [sym_literal_expression] = STATE(1118),
    [sym_long_identifier_or_op] = STATE(1118),
    [sym_tuple_expression] = STATE(1118),
    [sym_brace_expression] = STATE(1118),
    [sym_anon_record_expression] = STATE(1118),
    [sym_prefixed_expression] = STATE(1118),
    [sym_typecast_expression] = STATE(1118),
    [sym_for_expression] = STATE(1118),
    [sym_while_expression] = STATE(1118),
    [sym__if_branch] = STATE(7163),
    [sym_if_expression] = STATE(1118),
    [sym_fun_expression] = STATE(1118),
    [sym_try_expression] = STATE(1118),
    [sym_match_expression] = STATE(1118),
    [sym_function_expression] = STATE(1118),
    [sym_mutate_expression] = STATE(1118),
    [sym_index_expression] = STATE(1118),
    [sym_typed_expression] = STATE(1118),
    [sym_declaration_expression] = STATE(1118),
    [sym_do_expression] = STATE(1118),
    [sym_list_expression] = STATE(1118),
    [sym_array_expression] = STATE(1118),
    [sym_begin_end_expression] = STATE(1118),
    [sym_paren_expression] = STATE(1118),
    [sym__high_prec_app] = STATE(1133),
    [sym__low_prec_app] = STATE(1133),
    [sym_application_expression] = STATE(1118),
    [sym_dot_expression] = STATE(1118),
    [sym_infix_expression] = STATE(1118),
    [sym_ce_expression] = STATE(1118),
    [sym_sequential_expression] = STATE(1118),
    [sym_char] = STATE(1080),
    [sym_format_string] = STATE(1090),
    [sym__string_literal] = STATE(1090),
    [sym_string] = STATE(1080),
    [sym_verbatim_string] = STATE(1080),
    [sym_bytearray] = STATE(1080),
    [sym_verbatim_bytearray] = STATE(1080),
    [sym_format_triple_quoted_string] = STATE(1096),
    [sym_triple_quoted_string] = STATE(1080),
    [sym_const] = STATE(1118),
    [sym_long_identifier] = STATE(1156),
    [sym_active_pattern] = STATE(1085),
    [sym__identifier_or_op] = STATE(1099),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(517),
    [sym_infix_op] = STATE(487),
    [sym_sbyte] = STATE(1080),
    [sym_byte] = STATE(1080),
    [sym_int16] = STATE(1080),
    [sym_uint16] = STATE(1080),
    [sym_int32] = STATE(1080),
    [sym_uint32] = STATE(1080),
    [sym_nativeint] = STATE(1080),
    [sym_unativeint] = STATE(1080),
    [sym_int64] = STATE(1080),
    [sym_uint64] = STATE(1080),
    [sym_ieee32] = STATE(1080),
    [sym_ieee64] = STATE(1080),
    [sym_bignum] = STATE(1080),
    [sym_decimal] = STATE(1080),
    [sym_float] = STATE(979),
    [sym_block_comment] = STATE(15),
    [sym_compiler_directive_decl] = STATE(15),
    [sym_fsi_directive_decl] = STATE(15),
    [sym_preproc_line] = STATE(15),
    [sym_preproc_if_in_expression] = STATE(1118),
    [aux_sym_sequential_expression_repeat1] = STATE(1069),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(195),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_GT_RBRACK] = ACTIONS(167),
    [anon_sym_COLON] = ACTIONS(197),
    [anon_sym_return] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_COMMA] = ACTIONS(205),
    [anon_sym_null] = ACTIONS(207),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(197),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(209),
    [anon_sym_RBRACK] = ACTIONS(167),
    [anon_sym_LBRACK_PIPE] = ACTIONS(211),
    [anon_sym_LBRACE] = ACTIONS(169),
    [anon_sym_RBRACE] = ACTIONS(167),
    [anon_sym_LT_AT] = ACTIONS(213),
    [anon_sym_LT_AT_AT] = ACTIONS(215),
    [anon_sym_DOT] = ACTIONS(185),
    [anon_sym_LBRACE_PIPE] = ACTIONS(217),
    [anon_sym_new] = ACTIONS(199),
    [anon_sym_with] = ACTIONS(169),
    [anon_sym_return_BANG] = ACTIONS(219),
    [anon_sym_yield] = ACTIONS(199),
    [anon_sym_yield_BANG] = ACTIONS(219),
    [anon_sym_lazy] = ACTIONS(199),
    [anon_sym_assert] = ACTIONS(199),
    [anon_sym_upcast] = ACTIONS(199),
    [anon_sym_downcast] = ACTIONS(199),
    [anon_sym_COLON_GT] = ACTIONS(221),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(221),
    [anon_sym_for] = ACTIONS(223),
    [anon_sym_to] = ACTIONS(169),
    [anon_sym_downto] = ACTIONS(169),
    [anon_sym_while] = ACTIONS(225),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(229),
    [anon_sym_match] = ACTIONS(231),
    [anon_sym_match_BANG] = ACTIONS(233),
    [anon_sym_function] = ACTIONS(235),
    [anon_sym_LT_DASH] = ACTIONS(237),
    [anon_sym_DOT_LBRACK] = ACTIONS(187),
    [anon_sym_LT] = ACTIONS(189),
    [anon_sym_use] = ACTIONS(239),
    [anon_sym_use_BANG] = ACTIONS(241),
    [anon_sym_do_BANG] = ACTIONS(243),
    [anon_sym_begin] = ACTIONS(245),
    [anon_sym_LPAREN2] = ACTIONS(191),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(247),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(251),
    [anon_sym_AT_DQUOTE] = ACTIONS(253),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(255),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(257),
    [sym_bool] = ACTIONS(259),
    [sym_unit] = ACTIONS(193),
    [anon_sym_LPAREN_PIPE] = ACTIONS(261),
    [sym_op_identifier] = ACTIONS(263),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(265),
    [sym_xint] = ACTIONS(267),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(269),
    [sym__newline] = ACTIONS(167),
  },
  [16] = {
    [sym_function_or_value_defn] = STATE(627),
    [sym__expression] = STATE(17),
    [sym_literal_expression] = STATE(1118),
    [sym_long_identifier_or_op] = STATE(1118),
    [sym_tuple_expression] = STATE(1118),
    [sym_brace_expression] = STATE(1118),
    [sym_anon_record_expression] = STATE(1118),
    [sym_prefixed_expression] = STATE(1118),
    [sym_typecast_expression] = STATE(1118),
    [sym_for_expression] = STATE(1118),
    [sym_while_expression] = STATE(1118),
    [sym__if_branch] = STATE(7163),
    [sym_if_expression] = STATE(1118),
    [sym_fun_expression] = STATE(1118),
    [sym_try_expression] = STATE(1118),
    [sym_match_expression] = STATE(1118),
    [sym_function_expression] = STATE(1118),
    [sym_mutate_expression] = STATE(1118),
    [sym_index_expression] = STATE(1118),
    [sym_typed_expression] = STATE(1118),
    [sym_declaration_expression] = STATE(1118),
    [sym_do_expression] = STATE(1118),
    [sym_list_expression] = STATE(1118),
    [sym_array_expression] = STATE(1118),
    [sym_begin_end_expression] = STATE(1118),
    [sym_paren_expression] = STATE(1118),
    [sym__high_prec_app] = STATE(1133),
    [sym__low_prec_app] = STATE(1133),
    [sym_application_expression] = STATE(1118),
    [sym_dot_expression] = STATE(1118),
    [sym_infix_expression] = STATE(1118),
    [sym_ce_expression] = STATE(1118),
    [sym_sequential_expression] = STATE(1118),
    [sym_char] = STATE(1080),
    [sym_format_string] = STATE(1090),
    [sym__string_literal] = STATE(1090),
    [sym_string] = STATE(1080),
    [sym_verbatim_string] = STATE(1080),
    [sym_bytearray] = STATE(1080),
    [sym_verbatim_bytearray] = STATE(1080),
    [sym_format_triple_quoted_string] = STATE(1096),
    [sym_triple_quoted_string] = STATE(1080),
    [sym_const] = STATE(1118),
    [sym_long_identifier] = STATE(1156),
    [sym_active_pattern] = STATE(1085),
    [sym__identifier_or_op] = STATE(1099),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(517),
    [sym_infix_op] = STATE(487),
    [sym_sbyte] = STATE(1080),
    [sym_byte] = STATE(1080),
    [sym_int16] = STATE(1080),
    [sym_uint16] = STATE(1080),
    [sym_int32] = STATE(1080),
    [sym_uint32] = STATE(1080),
    [sym_nativeint] = STATE(1080),
    [sym_unativeint] = STATE(1080),
    [sym_int64] = STATE(1080),
    [sym_uint64] = STATE(1080),
    [sym_ieee32] = STATE(1080),
    [sym_ieee64] = STATE(1080),
    [sym_bignum] = STATE(1080),
    [sym_decimal] = STATE(1080),
    [sym_float] = STATE(979),
    [sym_block_comment] = STATE(16),
    [sym_compiler_directive_decl] = STATE(16),
    [sym_fsi_directive_decl] = STATE(16),
    [sym_preproc_line] = STATE(16),
    [sym_preproc_if_in_expression] = STATE(1118),
    [aux_sym_sequential_expression_repeat1] = STATE(1069),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(195),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_GT_RBRACK] = ACTIONS(149),
    [anon_sym_COLON] = ACTIONS(197),
    [anon_sym_return] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_COMMA] = ACTIONS(205),
    [anon_sym_null] = ACTIONS(207),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(197),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(209),
    [anon_sym_RBRACK] = ACTIONS(149),
    [anon_sym_LBRACK_PIPE] = ACTIONS(211),
    [anon_sym_LBRACE] = ACTIONS(271),
    [anon_sym_RBRACE] = ACTIONS(149),
    [anon_sym_LT_AT] = ACTIONS(213),
    [anon_sym_LT_AT_AT] = ACTIONS(215),
    [anon_sym_DOT] = ACTIONS(185),
    [anon_sym_LBRACE_PIPE] = ACTIONS(217),
    [anon_sym_new] = ACTIONS(199),
    [anon_sym_with] = ACTIONS(151),
    [anon_sym_return_BANG] = ACTIONS(219),
    [anon_sym_yield] = ACTIONS(199),
    [anon_sym_yield_BANG] = ACTIONS(219),
    [anon_sym_lazy] = ACTIONS(199),
    [anon_sym_assert] = ACTIONS(199),
    [anon_sym_upcast] = ACTIONS(199),
    [anon_sym_downcast] = ACTIONS(199),
    [anon_sym_COLON_GT] = ACTIONS(221),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(221),
    [anon_sym_for] = ACTIONS(223),
    [anon_sym_to] = ACTIONS(151),
    [anon_sym_downto] = ACTIONS(151),
    [anon_sym_while] = ACTIONS(225),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(229),
    [anon_sym_match] = ACTIONS(231),
    [anon_sym_match_BANG] = ACTIONS(233),
    [anon_sym_function] = ACTIONS(235),
    [anon_sym_LT_DASH] = ACTIONS(237),
    [anon_sym_DOT_LBRACK] = ACTIONS(187),
    [anon_sym_LT] = ACTIONS(189),
    [anon_sym_use] = ACTIONS(239),
    [anon_sym_use_BANG] = ACTIONS(241),
    [anon_sym_do_BANG] = ACTIONS(243),
    [anon_sym_begin] = ACTIONS(245),
    [anon_sym_LPAREN2] = ACTIONS(191),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(247),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(251),
    [anon_sym_AT_DQUOTE] = ACTIONS(253),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(255),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(257),
    [sym_bool] = ACTIONS(259),
    [sym_unit] = ACTIONS(193),
    [anon_sym_LPAREN_PIPE] = ACTIONS(261),
    [sym_op_identifier] = ACTIONS(263),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(265),
    [sym_xint] = ACTIONS(267),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(269),
    [sym__newline] = ACTIONS(273),
  },
  [17] = {
    [sym_function_or_value_defn] = STATE(627),
    [sym__expression] = STATE(17),
    [sym_literal_expression] = STATE(1118),
    [sym_long_identifier_or_op] = STATE(1118),
    [sym_tuple_expression] = STATE(1118),
    [sym_brace_expression] = STATE(1118),
    [sym_anon_record_expression] = STATE(1118),
    [sym_prefixed_expression] = STATE(1118),
    [sym_typecast_expression] = STATE(1118),
    [sym_for_expression] = STATE(1118),
    [sym_while_expression] = STATE(1118),
    [sym__if_branch] = STATE(7163),
    [sym_if_expression] = STATE(1118),
    [sym_fun_expression] = STATE(1118),
    [sym_try_expression] = STATE(1118),
    [sym_match_expression] = STATE(1118),
    [sym_function_expression] = STATE(1118),
    [sym_mutate_expression] = STATE(1118),
    [sym_index_expression] = STATE(1118),
    [sym_typed_expression] = STATE(1118),
    [sym_declaration_expression] = STATE(1118),
    [sym_do_expression] = STATE(1118),
    [sym_list_expression] = STATE(1118),
    [sym_array_expression] = STATE(1118),
    [sym_begin_end_expression] = STATE(1118),
    [sym_paren_expression] = STATE(1118),
    [sym__high_prec_app] = STATE(1133),
    [sym__low_prec_app] = STATE(1133),
    [sym_application_expression] = STATE(1118),
    [sym_dot_expression] = STATE(1118),
    [sym_infix_expression] = STATE(1118),
    [sym_ce_expression] = STATE(1118),
    [sym_sequential_expression] = STATE(1118),
    [sym_char] = STATE(1080),
    [sym_format_string] = STATE(1090),
    [sym__string_literal] = STATE(1090),
    [sym_string] = STATE(1080),
    [sym_verbatim_string] = STATE(1080),
    [sym_bytearray] = STATE(1080),
    [sym_verbatim_bytearray] = STATE(1080),
    [sym_format_triple_quoted_string] = STATE(1096),
    [sym_triple_quoted_string] = STATE(1080),
    [sym_const] = STATE(1118),
    [sym_long_identifier] = STATE(1156),
    [sym_active_pattern] = STATE(1085),
    [sym__identifier_or_op] = STATE(1099),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(517),
    [sym_infix_op] = STATE(487),
    [sym_sbyte] = STATE(1080),
    [sym_byte] = STATE(1080),
    [sym_int16] = STATE(1080),
    [sym_uint16] = STATE(1080),
    [sym_int32] = STATE(1080),
    [sym_uint32] = STATE(1080),
    [sym_nativeint] = STATE(1080),
    [sym_unativeint] = STATE(1080),
    [sym_int64] = STATE(1080),
    [sym_uint64] = STATE(1080),
    [sym_ieee32] = STATE(1080),
    [sym_ieee64] = STATE(1080),
    [sym_bignum] = STATE(1080),
    [sym_decimal] = STATE(1080),
    [sym_float] = STATE(979),
    [sym_block_comment] = STATE(17),
    [sym_compiler_directive_decl] = STATE(17),
    [sym_fsi_directive_decl] = STATE(17),
    [sym_preproc_line] = STATE(17),
    [sym_preproc_if_in_expression] = STATE(1118),
    [aux_sym_sequential_expression_repeat1] = STATE(1069),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_EQ] = ACTIONS(157),
    [anon_sym_GT_RBRACK] = ACTIONS(157),
    [anon_sym_COLON] = ACTIONS(155),
    [anon_sym_return] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(155),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_let_BANG] = ACTIONS(157),
    [anon_sym_LPAREN] = ACTIONS(155),
    [anon_sym_COMMA] = ACTIONS(157),
    [anon_sym_null] = ACTIONS(155),
    [anon_sym_QMARK] = ACTIONS(155),
    [anon_sym_COLON_QMARK] = ACTIONS(155),
    [anon_sym_COLON_COLON] = ACTIONS(157),
    [anon_sym_AMP] = ACTIONS(155),
    [anon_sym_LBRACK] = ACTIONS(155),
    [anon_sym_RBRACK] = ACTIONS(157),
    [anon_sym_LBRACK_PIPE] = ACTIONS(157),
    [anon_sym_LBRACE] = ACTIONS(155),
    [anon_sym_RBRACE] = ACTIONS(157),
    [anon_sym_LT_AT] = ACTIONS(155),
    [anon_sym_LT_AT_AT] = ACTIONS(155),
    [anon_sym_DOT] = ACTIONS(185),
    [anon_sym_LBRACE_PIPE] = ACTIONS(157),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_with] = ACTIONS(155),
    [anon_sym_return_BANG] = ACTIONS(157),
    [anon_sym_yield] = ACTIONS(155),
    [anon_sym_yield_BANG] = ACTIONS(157),
    [anon_sym_lazy] = ACTIONS(155),
    [anon_sym_assert] = ACTIONS(155),
    [anon_sym_upcast] = ACTIONS(155),
    [anon_sym_downcast] = ACTIONS(155),
    [anon_sym_COLON_GT] = ACTIONS(157),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(157),
    [anon_sym_for] = ACTIONS(155),
    [anon_sym_to] = ACTIONS(155),
    [anon_sym_downto] = ACTIONS(155),
    [anon_sym_while] = ACTIONS(155),
    [anon_sym_if] = ACTIONS(155),
    [anon_sym_fun] = ACTIONS(155),
    [anon_sym_try] = ACTIONS(155),
    [anon_sym_match] = ACTIONS(155),
    [anon_sym_match_BANG] = ACTIONS(157),
    [anon_sym_function] = ACTIONS(155),
    [anon_sym_LT_DASH] = ACTIONS(155),
    [anon_sym_DOT_LBRACK] = ACTIONS(187),
    [anon_sym_LT] = ACTIONS(189),
    [anon_sym_use] = ACTIONS(155),
    [anon_sym_use_BANG] = ACTIONS(157),
    [anon_sym_do_BANG] = ACTIONS(157),
    [anon_sym_begin] = ACTIONS(155),
    [anon_sym_LPAREN2] = ACTIONS(191),
    [anon_sym_or] = ACTIONS(155),
    [aux_sym_char_token1] = ACTIONS(157),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(155),
    [anon_sym_DQUOTE] = ACTIONS(155),
    [anon_sym_AT_DQUOTE] = ACTIONS(157),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(157),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(157),
    [sym_bool] = ACTIONS(155),
    [sym_unit] = ACTIONS(193),
    [anon_sym_LPAREN_PIPE] = ACTIONS(155),
    [sym_op_identifier] = ACTIONS(155),
    [anon_sym_PLUS] = ACTIONS(155),
    [anon_sym_DASH] = ACTIONS(155),
    [anon_sym_PLUS_DOT] = ACTIONS(155),
    [anon_sym_DASH_DOT] = ACTIONS(155),
    [anon_sym_PERCENT] = ACTIONS(155),
    [anon_sym_AMP_AMP] = ACTIONS(155),
    [anon_sym_TILDE] = ACTIONS(157),
    [aux_sym_prefix_op_token1] = ACTIONS(155),
    [aux_sym_infix_op_token1] = ACTIONS(157),
    [aux_sym_infix_op_token2] = ACTIONS(155),
    [anon_sym_PIPE_PIPE] = ACTIONS(155),
    [anon_sym_BANG_EQ] = ACTIONS(155),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_DOLLAR] = ACTIONS(155),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(155),
    [sym_int] = ACTIONS(155),
    [sym_xint] = ACTIONS(157),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(157),
    [sym__newline] = ACTIONS(157),
  },
  [18] = {
    [sym_function_or_value_defn] = STATE(627),
    [sym__expression] = STATE(17),
    [sym_literal_expression] = STATE(1118),
    [sym_long_identifier_or_op] = STATE(1118),
    [sym_tuple_expression] = STATE(1118),
    [sym_brace_expression] = STATE(1118),
    [sym_anon_record_expression] = STATE(1118),
    [sym_prefixed_expression] = STATE(1118),
    [sym_typecast_expression] = STATE(1118),
    [sym_for_expression] = STATE(1118),
    [sym_while_expression] = STATE(1118),
    [sym__if_branch] = STATE(7163),
    [sym_if_expression] = STATE(1118),
    [sym_fun_expression] = STATE(1118),
    [sym_try_expression] = STATE(1118),
    [sym_match_expression] = STATE(1118),
    [sym_function_expression] = STATE(1118),
    [sym_mutate_expression] = STATE(1118),
    [sym_index_expression] = STATE(1118),
    [sym_typed_expression] = STATE(1118),
    [sym_declaration_expression] = STATE(1118),
    [sym_do_expression] = STATE(1118),
    [sym_list_expression] = STATE(1118),
    [sym_array_expression] = STATE(1118),
    [sym_begin_end_expression] = STATE(1118),
    [sym_paren_expression] = STATE(1118),
    [sym__high_prec_app] = STATE(1133),
    [sym__low_prec_app] = STATE(1133),
    [sym_application_expression] = STATE(1118),
    [sym_dot_expression] = STATE(1118),
    [sym_infix_expression] = STATE(1118),
    [sym_ce_expression] = STATE(1118),
    [sym_sequential_expression] = STATE(1118),
    [sym_char] = STATE(1080),
    [sym_format_string] = STATE(1090),
    [sym__string_literal] = STATE(1090),
    [sym_string] = STATE(1080),
    [sym_verbatim_string] = STATE(1080),
    [sym_bytearray] = STATE(1080),
    [sym_verbatim_bytearray] = STATE(1080),
    [sym_format_triple_quoted_string] = STATE(1096),
    [sym_triple_quoted_string] = STATE(1080),
    [sym_const] = STATE(1118),
    [sym_long_identifier] = STATE(1156),
    [sym_active_pattern] = STATE(1085),
    [sym__identifier_or_op] = STATE(1099),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(517),
    [sym_infix_op] = STATE(487),
    [sym_sbyte] = STATE(1080),
    [sym_byte] = STATE(1080),
    [sym_int16] = STATE(1080),
    [sym_uint16] = STATE(1080),
    [sym_int32] = STATE(1080),
    [sym_uint32] = STATE(1080),
    [sym_nativeint] = STATE(1080),
    [sym_unativeint] = STATE(1080),
    [sym_int64] = STATE(1080),
    [sym_uint64] = STATE(1080),
    [sym_ieee32] = STATE(1080),
    [sym_ieee64] = STATE(1080),
    [sym_bignum] = STATE(1080),
    [sym_decimal] = STATE(1080),
    [sym_float] = STATE(979),
    [sym_block_comment] = STATE(18),
    [sym_compiler_directive_decl] = STATE(18),
    [sym_fsi_directive_decl] = STATE(18),
    [sym_preproc_line] = STATE(18),
    [sym_preproc_if_in_expression] = STATE(1118),
    [aux_sym_sequential_expression_repeat1] = STATE(1069),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(195),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_GT_RBRACK] = ACTIONS(145),
    [anon_sym_COLON] = ACTIONS(197),
    [anon_sym_return] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_COMMA] = ACTIONS(205),
    [anon_sym_null] = ACTIONS(207),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(197),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(209),
    [anon_sym_RBRACK] = ACTIONS(145),
    [anon_sym_LBRACK_PIPE] = ACTIONS(211),
    [anon_sym_LBRACE] = ACTIONS(271),
    [anon_sym_RBRACE] = ACTIONS(145),
    [anon_sym_LT_AT] = ACTIONS(213),
    [anon_sym_LT_AT_AT] = ACTIONS(215),
    [anon_sym_DOT] = ACTIONS(185),
    [anon_sym_LBRACE_PIPE] = ACTIONS(217),
    [anon_sym_new] = ACTIONS(199),
    [anon_sym_with] = ACTIONS(147),
    [anon_sym_return_BANG] = ACTIONS(219),
    [anon_sym_yield] = ACTIONS(199),
    [anon_sym_yield_BANG] = ACTIONS(219),
    [anon_sym_lazy] = ACTIONS(199),
    [anon_sym_assert] = ACTIONS(199),
    [anon_sym_upcast] = ACTIONS(199),
    [anon_sym_downcast] = ACTIONS(199),
    [anon_sym_COLON_GT] = ACTIONS(221),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(221),
    [anon_sym_for] = ACTIONS(223),
    [anon_sym_to] = ACTIONS(147),
    [anon_sym_downto] = ACTIONS(147),
    [anon_sym_while] = ACTIONS(225),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(229),
    [anon_sym_match] = ACTIONS(231),
    [anon_sym_match_BANG] = ACTIONS(233),
    [anon_sym_function] = ACTIONS(235),
    [anon_sym_LT_DASH] = ACTIONS(237),
    [anon_sym_DOT_LBRACK] = ACTIONS(187),
    [anon_sym_LT] = ACTIONS(189),
    [anon_sym_use] = ACTIONS(239),
    [anon_sym_use_BANG] = ACTIONS(241),
    [anon_sym_do_BANG] = ACTIONS(243),
    [anon_sym_begin] = ACTIONS(245),
    [anon_sym_LPAREN2] = ACTIONS(191),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(247),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(251),
    [anon_sym_AT_DQUOTE] = ACTIONS(253),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(255),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(257),
    [sym_bool] = ACTIONS(259),
    [sym_unit] = ACTIONS(193),
    [anon_sym_LPAREN_PIPE] = ACTIONS(261),
    [sym_op_identifier] = ACTIONS(263),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(265),
    [sym_xint] = ACTIONS(267),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(269),
    [sym__newline] = ACTIONS(145),
  },
  [19] = {
    [sym_function_or_value_defn] = STATE(627),
    [sym__expression] = STATE(17),
    [sym_literal_expression] = STATE(1118),
    [sym_long_identifier_or_op] = STATE(1118),
    [sym_tuple_expression] = STATE(1118),
    [sym_brace_expression] = STATE(1118),
    [sym_anon_record_expression] = STATE(1118),
    [sym_prefixed_expression] = STATE(1118),
    [sym_typecast_expression] = STATE(1118),
    [sym_for_expression] = STATE(1118),
    [sym_while_expression] = STATE(1118),
    [sym__if_branch] = STATE(7163),
    [sym_if_expression] = STATE(1118),
    [sym_fun_expression] = STATE(1118),
    [sym_try_expression] = STATE(1118),
    [sym_match_expression] = STATE(1118),
    [sym_function_expression] = STATE(1118),
    [sym_mutate_expression] = STATE(1118),
    [sym_index_expression] = STATE(1118),
    [sym_typed_expression] = STATE(1118),
    [sym_declaration_expression] = STATE(1118),
    [sym_do_expression] = STATE(1118),
    [sym_list_expression] = STATE(1118),
    [sym_array_expression] = STATE(1118),
    [sym_begin_end_expression] = STATE(1118),
    [sym_paren_expression] = STATE(1118),
    [sym__high_prec_app] = STATE(1133),
    [sym__low_prec_app] = STATE(1133),
    [sym_application_expression] = STATE(1118),
    [sym_dot_expression] = STATE(1118),
    [sym_infix_expression] = STATE(1118),
    [sym_ce_expression] = STATE(1118),
    [sym_sequential_expression] = STATE(1118),
    [sym_char] = STATE(1080),
    [sym_format_string] = STATE(1090),
    [sym__string_literal] = STATE(1090),
    [sym_string] = STATE(1080),
    [sym_verbatim_string] = STATE(1080),
    [sym_bytearray] = STATE(1080),
    [sym_verbatim_bytearray] = STATE(1080),
    [sym_format_triple_quoted_string] = STATE(1096),
    [sym_triple_quoted_string] = STATE(1080),
    [sym_const] = STATE(1118),
    [sym_long_identifier] = STATE(1156),
    [sym_active_pattern] = STATE(1085),
    [sym__identifier_or_op] = STATE(1099),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(517),
    [sym_infix_op] = STATE(487),
    [sym_sbyte] = STATE(1080),
    [sym_byte] = STATE(1080),
    [sym_int16] = STATE(1080),
    [sym_uint16] = STATE(1080),
    [sym_int32] = STATE(1080),
    [sym_uint32] = STATE(1080),
    [sym_nativeint] = STATE(1080),
    [sym_unativeint] = STATE(1080),
    [sym_int64] = STATE(1080),
    [sym_uint64] = STATE(1080),
    [sym_ieee32] = STATE(1080),
    [sym_ieee64] = STATE(1080),
    [sym_bignum] = STATE(1080),
    [sym_decimal] = STATE(1080),
    [sym_float] = STATE(979),
    [sym_block_comment] = STATE(19),
    [sym_compiler_directive_decl] = STATE(19),
    [sym_fsi_directive_decl] = STATE(19),
    [sym_preproc_line] = STATE(19),
    [sym_preproc_if_in_expression] = STATE(1118),
    [aux_sym_sequential_expression_repeat1] = STATE(1069),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(195),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_GT_RBRACK] = ACTIONS(33),
    [anon_sym_COLON] = ACTIONS(197),
    [anon_sym_return] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_COMMA] = ACTIONS(205),
    [anon_sym_null] = ACTIONS(207),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(197),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(209),
    [anon_sym_RBRACK] = ACTIONS(33),
    [anon_sym_LBRACK_PIPE] = ACTIONS(211),
    [anon_sym_LBRACE] = ACTIONS(59),
    [anon_sym_RBRACE] = ACTIONS(33),
    [anon_sym_LT_AT] = ACTIONS(213),
    [anon_sym_LT_AT_AT] = ACTIONS(215),
    [anon_sym_DOT] = ACTIONS(185),
    [anon_sym_LBRACE_PIPE] = ACTIONS(217),
    [anon_sym_new] = ACTIONS(199),
    [anon_sym_with] = ACTIONS(59),
    [anon_sym_return_BANG] = ACTIONS(219),
    [anon_sym_yield] = ACTIONS(199),
    [anon_sym_yield_BANG] = ACTIONS(219),
    [anon_sym_lazy] = ACTIONS(199),
    [anon_sym_assert] = ACTIONS(199),
    [anon_sym_upcast] = ACTIONS(199),
    [anon_sym_downcast] = ACTIONS(199),
    [anon_sym_COLON_GT] = ACTIONS(221),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(221),
    [anon_sym_for] = ACTIONS(223),
    [anon_sym_to] = ACTIONS(59),
    [anon_sym_downto] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(225),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(229),
    [anon_sym_match] = ACTIONS(231),
    [anon_sym_match_BANG] = ACTIONS(233),
    [anon_sym_function] = ACTIONS(235),
    [anon_sym_LT_DASH] = ACTIONS(237),
    [anon_sym_DOT_LBRACK] = ACTIONS(187),
    [anon_sym_LT] = ACTIONS(189),
    [anon_sym_use] = ACTIONS(239),
    [anon_sym_use_BANG] = ACTIONS(241),
    [anon_sym_do_BANG] = ACTIONS(243),
    [anon_sym_begin] = ACTIONS(245),
    [anon_sym_LPAREN2] = ACTIONS(191),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(247),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(251),
    [anon_sym_AT_DQUOTE] = ACTIONS(253),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(255),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(257),
    [sym_bool] = ACTIONS(259),
    [sym_unit] = ACTIONS(193),
    [anon_sym_LPAREN_PIPE] = ACTIONS(261),
    [sym_op_identifier] = ACTIONS(263),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(265),
    [sym_xint] = ACTIONS(267),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(269),
    [sym__newline] = ACTIONS(33),
  },
  [20] = {
    [sym_function_or_value_defn] = STATE(627),
    [sym__expression] = STATE(17),
    [sym_literal_expression] = STATE(1118),
    [sym_long_identifier_or_op] = STATE(1118),
    [sym_tuple_expression] = STATE(1118),
    [sym_brace_expression] = STATE(1118),
    [sym_anon_record_expression] = STATE(1118),
    [sym_prefixed_expression] = STATE(1118),
    [sym_typecast_expression] = STATE(1118),
    [sym_for_expression] = STATE(1118),
    [sym_while_expression] = STATE(1118),
    [sym__if_branch] = STATE(7163),
    [sym_if_expression] = STATE(1118),
    [sym_fun_expression] = STATE(1118),
    [sym_try_expression] = STATE(1118),
    [sym_match_expression] = STATE(1118),
    [sym_function_expression] = STATE(1118),
    [sym_mutate_expression] = STATE(1118),
    [sym_index_expression] = STATE(1118),
    [sym_typed_expression] = STATE(1118),
    [sym_declaration_expression] = STATE(1118),
    [sym_do_expression] = STATE(1118),
    [sym_list_expression] = STATE(1118),
    [sym_array_expression] = STATE(1118),
    [sym_begin_end_expression] = STATE(1118),
    [sym_paren_expression] = STATE(1118),
    [sym__high_prec_app] = STATE(1133),
    [sym__low_prec_app] = STATE(1133),
    [sym_application_expression] = STATE(1118),
    [sym_dot_expression] = STATE(1118),
    [sym_infix_expression] = STATE(1118),
    [sym_ce_expression] = STATE(1118),
    [sym_sequential_expression] = STATE(1118),
    [sym_char] = STATE(1080),
    [sym_format_string] = STATE(1090),
    [sym__string_literal] = STATE(1090),
    [sym_string] = STATE(1080),
    [sym_verbatim_string] = STATE(1080),
    [sym_bytearray] = STATE(1080),
    [sym_verbatim_bytearray] = STATE(1080),
    [sym_format_triple_quoted_string] = STATE(1096),
    [sym_triple_quoted_string] = STATE(1080),
    [sym_const] = STATE(1118),
    [sym_long_identifier] = STATE(1156),
    [sym_active_pattern] = STATE(1085),
    [sym__identifier_or_op] = STATE(1099),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(517),
    [sym_infix_op] = STATE(487),
    [sym_sbyte] = STATE(1080),
    [sym_byte] = STATE(1080),
    [sym_int16] = STATE(1080),
    [sym_uint16] = STATE(1080),
    [sym_int32] = STATE(1080),
    [sym_uint32] = STATE(1080),
    [sym_nativeint] = STATE(1080),
    [sym_unativeint] = STATE(1080),
    [sym_int64] = STATE(1080),
    [sym_uint64] = STATE(1080),
    [sym_ieee32] = STATE(1080),
    [sym_ieee64] = STATE(1080),
    [sym_bignum] = STATE(1080),
    [sym_decimal] = STATE(1080),
    [sym_float] = STATE(979),
    [sym_block_comment] = STATE(20),
    [sym_compiler_directive_decl] = STATE(20),
    [sym_fsi_directive_decl] = STATE(20),
    [sym_preproc_line] = STATE(20),
    [sym_preproc_if_in_expression] = STATE(1118),
    [aux_sym_sequential_expression_repeat1] = STATE(1069),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(195),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_GT_RBRACK] = ACTIONS(171),
    [anon_sym_COLON] = ACTIONS(197),
    [anon_sym_return] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_COMMA] = ACTIONS(205),
    [anon_sym_null] = ACTIONS(207),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(197),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(209),
    [anon_sym_RBRACK] = ACTIONS(171),
    [anon_sym_LBRACK_PIPE] = ACTIONS(211),
    [anon_sym_LBRACE] = ACTIONS(271),
    [anon_sym_RBRACE] = ACTIONS(171),
    [anon_sym_LT_AT] = ACTIONS(213),
    [anon_sym_LT_AT_AT] = ACTIONS(215),
    [anon_sym_DOT] = ACTIONS(185),
    [anon_sym_LBRACE_PIPE] = ACTIONS(217),
    [anon_sym_new] = ACTIONS(199),
    [anon_sym_with] = ACTIONS(173),
    [anon_sym_return_BANG] = ACTIONS(219),
    [anon_sym_yield] = ACTIONS(199),
    [anon_sym_yield_BANG] = ACTIONS(219),
    [anon_sym_lazy] = ACTIONS(199),
    [anon_sym_assert] = ACTIONS(199),
    [anon_sym_upcast] = ACTIONS(199),
    [anon_sym_downcast] = ACTIONS(199),
    [anon_sym_COLON_GT] = ACTIONS(221),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(221),
    [anon_sym_for] = ACTIONS(223),
    [anon_sym_to] = ACTIONS(173),
    [anon_sym_downto] = ACTIONS(173),
    [anon_sym_while] = ACTIONS(225),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(229),
    [anon_sym_match] = ACTIONS(231),
    [anon_sym_match_BANG] = ACTIONS(233),
    [anon_sym_function] = ACTIONS(235),
    [anon_sym_LT_DASH] = ACTIONS(237),
    [anon_sym_DOT_LBRACK] = ACTIONS(187),
    [anon_sym_LT] = ACTIONS(189),
    [anon_sym_use] = ACTIONS(239),
    [anon_sym_use_BANG] = ACTIONS(241),
    [anon_sym_do_BANG] = ACTIONS(243),
    [anon_sym_begin] = ACTIONS(245),
    [anon_sym_LPAREN2] = ACTIONS(191),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(247),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(251),
    [anon_sym_AT_DQUOTE] = ACTIONS(253),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(255),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(257),
    [sym_bool] = ACTIONS(259),
    [sym_unit] = ACTIONS(193),
    [anon_sym_LPAREN_PIPE] = ACTIONS(261),
    [sym_op_identifier] = ACTIONS(263),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(265),
    [sym_xint] = ACTIONS(267),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(269),
    [sym__newline] = ACTIONS(273),
  },
  [21] = {
    [sym_function_or_value_defn] = STATE(627),
    [sym__expression] = STATE(17),
    [sym_literal_expression] = STATE(1118),
    [sym_long_identifier_or_op] = STATE(1118),
    [sym_tuple_expression] = STATE(1118),
    [sym_brace_expression] = STATE(1118),
    [sym_anon_record_expression] = STATE(1118),
    [sym_prefixed_expression] = STATE(1118),
    [sym_typecast_expression] = STATE(1118),
    [sym_for_expression] = STATE(1118),
    [sym_while_expression] = STATE(1118),
    [sym__if_branch] = STATE(7163),
    [sym_if_expression] = STATE(1118),
    [sym_fun_expression] = STATE(1118),
    [sym_try_expression] = STATE(1118),
    [sym_match_expression] = STATE(1118),
    [sym_function_expression] = STATE(1118),
    [sym_mutate_expression] = STATE(1118),
    [sym_index_expression] = STATE(1118),
    [sym_typed_expression] = STATE(1118),
    [sym_declaration_expression] = STATE(1118),
    [sym_do_expression] = STATE(1118),
    [sym_list_expression] = STATE(1118),
    [sym_array_expression] = STATE(1118),
    [sym_begin_end_expression] = STATE(1118),
    [sym_paren_expression] = STATE(1118),
    [sym__high_prec_app] = STATE(1133),
    [sym__low_prec_app] = STATE(1133),
    [sym_application_expression] = STATE(1118),
    [sym_dot_expression] = STATE(1118),
    [sym_infix_expression] = STATE(1118),
    [sym_ce_expression] = STATE(1118),
    [sym_sequential_expression] = STATE(1118),
    [sym_char] = STATE(1080),
    [sym_format_string] = STATE(1090),
    [sym__string_literal] = STATE(1090),
    [sym_string] = STATE(1080),
    [sym_verbatim_string] = STATE(1080),
    [sym_bytearray] = STATE(1080),
    [sym_verbatim_bytearray] = STATE(1080),
    [sym_format_triple_quoted_string] = STATE(1096),
    [sym_triple_quoted_string] = STATE(1080),
    [sym_const] = STATE(1118),
    [sym_long_identifier] = STATE(1156),
    [sym_active_pattern] = STATE(1085),
    [sym__identifier_or_op] = STATE(1099),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(517),
    [sym_infix_op] = STATE(487),
    [sym_sbyte] = STATE(1080),
    [sym_byte] = STATE(1080),
    [sym_int16] = STATE(1080),
    [sym_uint16] = STATE(1080),
    [sym_int32] = STATE(1080),
    [sym_uint32] = STATE(1080),
    [sym_nativeint] = STATE(1080),
    [sym_unativeint] = STATE(1080),
    [sym_int64] = STATE(1080),
    [sym_uint64] = STATE(1080),
    [sym_ieee32] = STATE(1080),
    [sym_ieee64] = STATE(1080),
    [sym_bignum] = STATE(1080),
    [sym_decimal] = STATE(1080),
    [sym_float] = STATE(979),
    [sym_block_comment] = STATE(21),
    [sym_compiler_directive_decl] = STATE(21),
    [sym_fsi_directive_decl] = STATE(21),
    [sym_preproc_line] = STATE(21),
    [sym_preproc_if_in_expression] = STATE(1118),
    [aux_sym_sequential_expression_repeat1] = STATE(1069),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(195),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_GT_RBRACK] = ACTIONS(159),
    [anon_sym_COLON] = ACTIONS(197),
    [anon_sym_return] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_COMMA] = ACTIONS(205),
    [anon_sym_null] = ACTIONS(207),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(197),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(209),
    [anon_sym_RBRACK] = ACTIONS(159),
    [anon_sym_LBRACK_PIPE] = ACTIONS(211),
    [anon_sym_LBRACE] = ACTIONS(271),
    [anon_sym_RBRACE] = ACTIONS(159),
    [anon_sym_LT_AT] = ACTIONS(213),
    [anon_sym_LT_AT_AT] = ACTIONS(215),
    [anon_sym_DOT] = ACTIONS(185),
    [anon_sym_LBRACE_PIPE] = ACTIONS(217),
    [anon_sym_new] = ACTIONS(199),
    [anon_sym_with] = ACTIONS(161),
    [anon_sym_return_BANG] = ACTIONS(219),
    [anon_sym_yield] = ACTIONS(199),
    [anon_sym_yield_BANG] = ACTIONS(219),
    [anon_sym_lazy] = ACTIONS(199),
    [anon_sym_assert] = ACTIONS(199),
    [anon_sym_upcast] = ACTIONS(199),
    [anon_sym_downcast] = ACTIONS(199),
    [anon_sym_COLON_GT] = ACTIONS(221),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(221),
    [anon_sym_for] = ACTIONS(223),
    [anon_sym_to] = ACTIONS(161),
    [anon_sym_downto] = ACTIONS(161),
    [anon_sym_while] = ACTIONS(225),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(229),
    [anon_sym_match] = ACTIONS(231),
    [anon_sym_match_BANG] = ACTIONS(233),
    [anon_sym_function] = ACTIONS(235),
    [anon_sym_LT_DASH] = ACTIONS(237),
    [anon_sym_DOT_LBRACK] = ACTIONS(187),
    [anon_sym_LT] = ACTIONS(189),
    [anon_sym_use] = ACTIONS(239),
    [anon_sym_use_BANG] = ACTIONS(241),
    [anon_sym_do_BANG] = ACTIONS(243),
    [anon_sym_begin] = ACTIONS(245),
    [anon_sym_LPAREN2] = ACTIONS(191),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(247),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(251),
    [anon_sym_AT_DQUOTE] = ACTIONS(253),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(255),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(257),
    [sym_bool] = ACTIONS(259),
    [sym_unit] = ACTIONS(193),
    [anon_sym_LPAREN_PIPE] = ACTIONS(261),
    [sym_op_identifier] = ACTIONS(263),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(265),
    [sym_xint] = ACTIONS(267),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(269),
    [sym__newline] = ACTIONS(273),
  },
  [22] = {
    [sym_function_or_value_defn] = STATE(482),
    [sym__expression] = STATE(28),
    [sym_literal_expression] = STATE(1537),
    [sym_long_identifier_or_op] = STATE(1537),
    [sym_tuple_expression] = STATE(1537),
    [sym_brace_expression] = STATE(1537),
    [sym_anon_record_expression] = STATE(1537),
    [sym_prefixed_expression] = STATE(1537),
    [sym_typecast_expression] = STATE(1537),
    [sym_for_expression] = STATE(1537),
    [sym_while_expression] = STATE(1537),
    [sym__if_branch] = STATE(6834),
    [sym_if_expression] = STATE(1537),
    [sym_fun_expression] = STATE(1537),
    [sym_try_expression] = STATE(1537),
    [sym_match_expression] = STATE(1537),
    [sym_function_expression] = STATE(1537),
    [sym_mutate_expression] = STATE(1537),
    [sym_index_expression] = STATE(1537),
    [sym_typed_expression] = STATE(1537),
    [sym_declaration_expression] = STATE(1537),
    [sym_do_expression] = STATE(1537),
    [sym_list_expression] = STATE(1537),
    [sym_array_expression] = STATE(1537),
    [sym_begin_end_expression] = STATE(1537),
    [sym_paren_expression] = STATE(1537),
    [sym__high_prec_app] = STATE(1538),
    [sym__low_prec_app] = STATE(1538),
    [sym_application_expression] = STATE(1537),
    [sym_dot_expression] = STATE(1537),
    [sym_infix_expression] = STATE(1537),
    [sym_ce_expression] = STATE(1537),
    [sym_sequential_expression] = STATE(1537),
    [sym__object_members] = STATE(5715),
    [sym_char] = STATE(1484),
    [sym_format_string] = STATE(1483),
    [sym__string_literal] = STATE(1483),
    [sym_string] = STATE(1484),
    [sym_verbatim_string] = STATE(1484),
    [sym_bytearray] = STATE(1484),
    [sym_verbatim_bytearray] = STATE(1484),
    [sym_format_triple_quoted_string] = STATE(1482),
    [sym_triple_quoted_string] = STATE(1484),
    [sym_const] = STATE(1537),
    [sym_long_identifier] = STATE(1643),
    [sym_active_pattern] = STATE(1645),
    [sym__identifier_or_op] = STATE(1689),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(670),
    [sym_infix_op] = STATE(491),
    [sym_sbyte] = STATE(1484),
    [sym_byte] = STATE(1484),
    [sym_int16] = STATE(1484),
    [sym_uint16] = STATE(1484),
    [sym_int32] = STATE(1484),
    [sym_uint32] = STATE(1484),
    [sym_nativeint] = STATE(1484),
    [sym_unativeint] = STATE(1484),
    [sym_int64] = STATE(1484),
    [sym_uint64] = STATE(1484),
    [sym_ieee32] = STATE(1484),
    [sym_ieee64] = STATE(1484),
    [sym_bignum] = STATE(1484),
    [sym_decimal] = STATE(1484),
    [sym_float] = STATE(1327),
    [sym_block_comment] = STATE(22),
    [sym_compiler_directive_decl] = STATE(22),
    [sym_fsi_directive_decl] = STATE(22),
    [sym_preproc_line] = STATE(22),
    [sym_preproc_if_in_expression] = STATE(1537),
    [aux_sym_sequential_expression_repeat1] = STATE(1437),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(275),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(277),
    [anon_sym_return] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(281),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_as] = ACTIONS(283),
    [anon_sym_LPAREN] = ACTIONS(285),
    [anon_sym_COMMA] = ACTIONS(287),
    [anon_sym_null] = ACTIONS(289),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(277),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(291),
    [anon_sym_LBRACK_PIPE] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(295),
    [anon_sym_LT_AT] = ACTIONS(297),
    [anon_sym_LT_AT_AT] = ACTIONS(299),
    [anon_sym_DOT] = ACTIONS(301),
    [anon_sym_LBRACE_PIPE] = ACTIONS(303),
    [anon_sym_new] = ACTIONS(279),
    [anon_sym_with] = ACTIONS(305),
    [anon_sym_return_BANG] = ACTIONS(307),
    [anon_sym_yield] = ACTIONS(279),
    [anon_sym_yield_BANG] = ACTIONS(307),
    [anon_sym_lazy] = ACTIONS(279),
    [anon_sym_assert] = ACTIONS(279),
    [anon_sym_upcast] = ACTIONS(279),
    [anon_sym_downcast] = ACTIONS(279),
    [anon_sym_COLON_GT] = ACTIONS(309),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(309),
    [anon_sym_for] = ACTIONS(311),
    [anon_sym_while] = ACTIONS(313),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(315),
    [anon_sym_try] = ACTIONS(317),
    [anon_sym_match] = ACTIONS(319),
    [anon_sym_match_BANG] = ACTIONS(321),
    [anon_sym_function] = ACTIONS(323),
    [anon_sym_LT_DASH] = ACTIONS(325),
    [anon_sym_DOT_LBRACK] = ACTIONS(327),
    [anon_sym_LT] = ACTIONS(329),
    [anon_sym_use] = ACTIONS(331),
    [anon_sym_use_BANG] = ACTIONS(333),
    [anon_sym_do_BANG] = ACTIONS(335),
    [anon_sym_begin] = ACTIONS(337),
    [anon_sym_LPAREN2] = ACTIONS(339),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(341),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(343),
    [anon_sym_DQUOTE] = ACTIONS(345),
    [anon_sym_AT_DQUOTE] = ACTIONS(347),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(349),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(351),
    [sym_bool] = ACTIONS(353),
    [sym_unit] = ACTIONS(355),
    [anon_sym_LPAREN_PIPE] = ACTIONS(357),
    [sym_op_identifier] = ACTIONS(359),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(361),
    [sym_xint] = ACTIONS(363),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(365),
    [sym__newline] = ACTIONS(145),
    [sym__dedent] = ACTIONS(145),
  },
  [23] = {
    [sym_function_or_value_defn] = STATE(482),
    [sym__expression] = STATE(28),
    [sym_literal_expression] = STATE(1537),
    [sym_long_identifier_or_op] = STATE(1537),
    [sym_tuple_expression] = STATE(1537),
    [sym_brace_expression] = STATE(1537),
    [sym_anon_record_expression] = STATE(1537),
    [sym_prefixed_expression] = STATE(1537),
    [sym_typecast_expression] = STATE(1537),
    [sym_for_expression] = STATE(1537),
    [sym_while_expression] = STATE(1537),
    [sym__if_branch] = STATE(6834),
    [sym_if_expression] = STATE(1537),
    [sym_fun_expression] = STATE(1537),
    [sym_try_expression] = STATE(1537),
    [sym_match_expression] = STATE(1537),
    [sym_function_expression] = STATE(1537),
    [sym_mutate_expression] = STATE(1537),
    [sym_index_expression] = STATE(1537),
    [sym_typed_expression] = STATE(1537),
    [sym_declaration_expression] = STATE(1537),
    [sym_do_expression] = STATE(1537),
    [sym_list_expression] = STATE(1537),
    [sym_array_expression] = STATE(1537),
    [sym_begin_end_expression] = STATE(1537),
    [sym_paren_expression] = STATE(1537),
    [sym__high_prec_app] = STATE(1538),
    [sym__low_prec_app] = STATE(1538),
    [sym_application_expression] = STATE(1537),
    [sym_dot_expression] = STATE(1537),
    [sym_infix_expression] = STATE(1537),
    [sym_ce_expression] = STATE(1537),
    [sym_sequential_expression] = STATE(1537),
    [sym_char] = STATE(1484),
    [sym_format_string] = STATE(1483),
    [sym__string_literal] = STATE(1483),
    [sym_string] = STATE(1484),
    [sym_verbatim_string] = STATE(1484),
    [sym_bytearray] = STATE(1484),
    [sym_verbatim_bytearray] = STATE(1484),
    [sym_format_triple_quoted_string] = STATE(1482),
    [sym_triple_quoted_string] = STATE(1484),
    [sym_const] = STATE(1537),
    [sym_long_identifier] = STATE(1643),
    [sym_active_pattern] = STATE(1645),
    [sym__identifier_or_op] = STATE(1689),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(670),
    [sym_infix_op] = STATE(491),
    [sym_sbyte] = STATE(1484),
    [sym_byte] = STATE(1484),
    [sym_int16] = STATE(1484),
    [sym_uint16] = STATE(1484),
    [sym_int32] = STATE(1484),
    [sym_uint32] = STATE(1484),
    [sym_nativeint] = STATE(1484),
    [sym_unativeint] = STATE(1484),
    [sym_int64] = STATE(1484),
    [sym_uint64] = STATE(1484),
    [sym_ieee32] = STATE(1484),
    [sym_ieee64] = STATE(1484),
    [sym_bignum] = STATE(1484),
    [sym_decimal] = STATE(1484),
    [sym_float] = STATE(1327),
    [sym_block_comment] = STATE(23),
    [sym_compiler_directive_decl] = STATE(23),
    [sym_fsi_directive_decl] = STATE(23),
    [sym_preproc_line] = STATE(23),
    [sym_preproc_if_in_expression] = STATE(1537),
    [aux_sym_sequential_expression_repeat1] = STATE(1437),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(275),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(277),
    [anon_sym_return] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(281),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_as] = ACTIONS(161),
    [anon_sym_LPAREN] = ACTIONS(285),
    [anon_sym_COMMA] = ACTIONS(287),
    [anon_sym_null] = ACTIONS(289),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(277),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(291),
    [anon_sym_LBRACK_PIPE] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(295),
    [anon_sym_LT_AT] = ACTIONS(297),
    [anon_sym_LT_AT_AT] = ACTIONS(299),
    [anon_sym_DOT] = ACTIONS(301),
    [anon_sym_LBRACE_PIPE] = ACTIONS(303),
    [anon_sym_new] = ACTIONS(279),
    [anon_sym_with] = ACTIONS(161),
    [anon_sym_return_BANG] = ACTIONS(307),
    [anon_sym_yield] = ACTIONS(279),
    [anon_sym_yield_BANG] = ACTIONS(307),
    [anon_sym_lazy] = ACTIONS(279),
    [anon_sym_assert] = ACTIONS(279),
    [anon_sym_upcast] = ACTIONS(279),
    [anon_sym_downcast] = ACTIONS(279),
    [anon_sym_COLON_GT] = ACTIONS(309),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(309),
    [anon_sym_for] = ACTIONS(311),
    [anon_sym_while] = ACTIONS(313),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(315),
    [anon_sym_try] = ACTIONS(317),
    [anon_sym_match] = ACTIONS(319),
    [anon_sym_match_BANG] = ACTIONS(321),
    [anon_sym_function] = ACTIONS(323),
    [anon_sym_LT_DASH] = ACTIONS(325),
    [anon_sym_DOT_LBRACK] = ACTIONS(327),
    [anon_sym_LT] = ACTIONS(329),
    [anon_sym_use] = ACTIONS(331),
    [anon_sym_use_BANG] = ACTIONS(333),
    [anon_sym_do_BANG] = ACTIONS(335),
    [anon_sym_begin] = ACTIONS(337),
    [anon_sym_LPAREN2] = ACTIONS(339),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(341),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(343),
    [anon_sym_DQUOTE] = ACTIONS(345),
    [anon_sym_AT_DQUOTE] = ACTIONS(347),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(349),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(351),
    [sym_bool] = ACTIONS(353),
    [sym_unit] = ACTIONS(355),
    [anon_sym_LPAREN_PIPE] = ACTIONS(357),
    [sym_op_identifier] = ACTIONS(359),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(361),
    [sym_xint] = ACTIONS(363),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(365),
    [sym__newline] = ACTIONS(367),
    [sym__dedent] = ACTIONS(159),
  },
  [24] = {
    [sym_function_or_value_defn] = STATE(729),
    [sym__expression] = STATE(59),
    [sym_literal_expression] = STATE(867),
    [sym_long_identifier_or_op] = STATE(867),
    [sym_tuple_expression] = STATE(867),
    [sym_brace_expression] = STATE(867),
    [sym_anon_record_expression] = STATE(867),
    [sym_prefixed_expression] = STATE(867),
    [sym_typecast_expression] = STATE(867),
    [sym_for_expression] = STATE(867),
    [sym_while_expression] = STATE(867),
    [sym__if_branch] = STATE(6511),
    [sym_if_expression] = STATE(867),
    [sym_fun_expression] = STATE(867),
    [sym_try_expression] = STATE(867),
    [sym_match_expression] = STATE(867),
    [sym_function_expression] = STATE(867),
    [sym_mutate_expression] = STATE(867),
    [sym_index_expression] = STATE(867),
    [sym_typed_expression] = STATE(867),
    [sym_declaration_expression] = STATE(867),
    [sym_do_expression] = STATE(867),
    [sym_list_expression] = STATE(867),
    [sym_array_expression] = STATE(867),
    [sym_begin_end_expression] = STATE(867),
    [sym_paren_expression] = STATE(867),
    [sym__high_prec_app] = STATE(864),
    [sym__low_prec_app] = STATE(864),
    [sym_application_expression] = STATE(867),
    [sym_dot_expression] = STATE(867),
    [sym_infix_expression] = STATE(867),
    [sym_ce_expression] = STATE(867),
    [sym_sequential_expression] = STATE(867),
    [sym_char] = STATE(868),
    [sym_format_string] = STATE(869),
    [sym__string_literal] = STATE(869),
    [sym_string] = STATE(868),
    [sym_verbatim_string] = STATE(868),
    [sym_bytearray] = STATE(868),
    [sym_verbatim_bytearray] = STATE(868),
    [sym_format_triple_quoted_string] = STATE(870),
    [sym_triple_quoted_string] = STATE(868),
    [sym_const] = STATE(867),
    [sym_long_identifier] = STATE(872),
    [sym_active_pattern] = STATE(871),
    [sym__identifier_or_op] = STATE(873),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(499),
    [sym_infix_op] = STATE(743),
    [sym_sbyte] = STATE(868),
    [sym_byte] = STATE(868),
    [sym_int16] = STATE(868),
    [sym_uint16] = STATE(868),
    [sym_int32] = STATE(868),
    [sym_uint32] = STATE(868),
    [sym_nativeint] = STATE(868),
    [sym_unativeint] = STATE(868),
    [sym_int64] = STATE(868),
    [sym_uint64] = STATE(868),
    [sym_ieee32] = STATE(868),
    [sym_ieee64] = STATE(868),
    [sym_bignum] = STATE(868),
    [sym_decimal] = STATE(868),
    [sym_float] = STATE(1368),
    [sym_block_comment] = STATE(24),
    [sym_compiler_directive_decl] = STATE(24),
    [sym_fsi_directive_decl] = STATE(24),
    [sym_preproc_line] = STATE(24),
    [sym_preproc_if_in_expression] = STATE(867),
    [aux_sym__list_elements_repeat1] = STATE(5826),
    [aux_sym_sequential_expression_repeat1] = STATE(1578),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(29),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(369),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_COMMA] = ACTIONS(371),
    [anon_sym_null] = ACTIONS(49),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACK_PIPE] = ACTIONS(57),
    [anon_sym_LBRACE] = ACTIONS(139),
    [anon_sym_LT_AT] = ACTIONS(61),
    [anon_sym_LT_AT_AT] = ACTIONS(63),
    [anon_sym_DOT] = ACTIONS(65),
    [anon_sym_LBRACE_PIPE] = ACTIONS(67),
    [anon_sym_new] = ACTIONS(369),
    [anon_sym_return_BANG] = ACTIONS(373),
    [anon_sym_yield] = ACTIONS(369),
    [anon_sym_yield_BANG] = ACTIONS(373),
    [anon_sym_lazy] = ACTIONS(369),
    [anon_sym_assert] = ACTIONS(369),
    [anon_sym_upcast] = ACTIONS(369),
    [anon_sym_downcast] = ACTIONS(369),
    [anon_sym_COLON_GT] = ACTIONS(71),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(71),
    [anon_sym_for] = ACTIONS(375),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(79),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_match] = ACTIONS(83),
    [anon_sym_match_BANG] = ACTIONS(85),
    [anon_sym_function] = ACTIONS(87),
    [anon_sym_LT_DASH] = ACTIONS(377),
    [anon_sym_DOT_LBRACK] = ACTIONS(91),
    [anon_sym_LT] = ACTIONS(93),
    [anon_sym_use] = ACTIONS(379),
    [anon_sym_use_BANG] = ACTIONS(381),
    [anon_sym_do_BANG] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(101),
    [anon_sym_LPAREN2] = ACTIONS(103),
    [anon_sym_DOT_DOT2] = ACTIONS(383),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(105),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(107),
    [anon_sym_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DQUOTE] = ACTIONS(111),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(115),
    [sym_bool] = ACTIONS(117),
    [sym_unit] = ACTIONS(119),
    [anon_sym_LPAREN_PIPE] = ACTIONS(121),
    [sym_op_identifier] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(385),
    [sym_xint] = ACTIONS(387),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(135),
    [sym__newline] = ACTIONS(389),
    [sym__dedent] = ACTIONS(391),
  },
  [25] = {
    [sym_function_or_value_defn] = STATE(703),
    [sym__expression] = STATE(108),
    [sym_literal_expression] = STATE(1797),
    [sym_long_identifier_or_op] = STATE(1797),
    [sym_tuple_expression] = STATE(1797),
    [sym_brace_expression] = STATE(1797),
    [sym_anon_record_expression] = STATE(1797),
    [sym_prefixed_expression] = STATE(1797),
    [sym_typecast_expression] = STATE(1797),
    [sym_for_expression] = STATE(1797),
    [sym_while_expression] = STATE(1797),
    [sym__if_branch] = STATE(6611),
    [sym_if_expression] = STATE(1797),
    [sym_fun_expression] = STATE(1797),
    [sym_try_expression] = STATE(1797),
    [sym_match_expression] = STATE(1797),
    [sym_function_expression] = STATE(1797),
    [sym_mutate_expression] = STATE(1797),
    [sym_index_expression] = STATE(1797),
    [sym_typed_expression] = STATE(1797),
    [sym_declaration_expression] = STATE(1797),
    [sym_do_expression] = STATE(1797),
    [sym_list_expression] = STATE(1797),
    [sym_array_expression] = STATE(1797),
    [sym_begin_end_expression] = STATE(1797),
    [sym_paren_expression] = STATE(1797),
    [sym__high_prec_app] = STATE(1800),
    [sym__low_prec_app] = STATE(1800),
    [sym_application_expression] = STATE(1797),
    [sym_dot_expression] = STATE(1797),
    [sym_infix_expression] = STATE(1797),
    [sym_ce_expression] = STATE(1797),
    [sym_sequential_expression] = STATE(1797),
    [sym__object_members] = STATE(5715),
    [sym_char] = STATE(1694),
    [sym_format_string] = STATE(1693),
    [sym__string_literal] = STATE(1693),
    [sym_string] = STATE(1694),
    [sym_verbatim_string] = STATE(1694),
    [sym_bytearray] = STATE(1694),
    [sym_verbatim_bytearray] = STATE(1694),
    [sym_format_triple_quoted_string] = STATE(1692),
    [sym_triple_quoted_string] = STATE(1694),
    [sym_const] = STATE(1797),
    [sym_long_identifier] = STATE(1813),
    [sym_active_pattern] = STATE(1753),
    [sym__identifier_or_op] = STATE(1812),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(756),
    [sym_infix_op] = STATE(515),
    [sym_sbyte] = STATE(1694),
    [sym_byte] = STATE(1694),
    [sym_int16] = STATE(1694),
    [sym_uint16] = STATE(1694),
    [sym_int32] = STATE(1694),
    [sym_uint32] = STATE(1694),
    [sym_nativeint] = STATE(1694),
    [sym_unativeint] = STATE(1694),
    [sym_int64] = STATE(1694),
    [sym_uint64] = STATE(1694),
    [sym_ieee32] = STATE(1694),
    [sym_ieee64] = STATE(1694),
    [sym_bignum] = STATE(1694),
    [sym_decimal] = STATE(1694),
    [sym_float] = STATE(1425),
    [sym_block_comment] = STATE(25),
    [sym_compiler_directive_decl] = STATE(25),
    [sym_fsi_directive_decl] = STATE(25),
    [sym_preproc_line] = STATE(25),
    [sym_preproc_if_in_expression] = STATE(1797),
    [aux_sym_sequential_expression_repeat1] = STATE(1585),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(393),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(395),
    [anon_sym_return] = ACTIONS(397),
    [anon_sym_do] = ACTIONS(399),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_as] = ACTIONS(283),
    [anon_sym_LPAREN] = ACTIONS(401),
    [anon_sym_COMMA] = ACTIONS(403),
    [anon_sym_null] = ACTIONS(405),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(395),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(407),
    [anon_sym_LBRACK_PIPE] = ACTIONS(409),
    [anon_sym_LBRACE] = ACTIONS(411),
    [anon_sym_LT_AT] = ACTIONS(413),
    [anon_sym_LT_AT_AT] = ACTIONS(415),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_LBRACE_PIPE] = ACTIONS(419),
    [anon_sym_new] = ACTIONS(397),
    [anon_sym_with] = ACTIONS(305),
    [anon_sym_return_BANG] = ACTIONS(421),
    [anon_sym_yield] = ACTIONS(397),
    [anon_sym_yield_BANG] = ACTIONS(421),
    [anon_sym_lazy] = ACTIONS(397),
    [anon_sym_assert] = ACTIONS(397),
    [anon_sym_upcast] = ACTIONS(397),
    [anon_sym_downcast] = ACTIONS(397),
    [anon_sym_COLON_GT] = ACTIONS(423),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(423),
    [anon_sym_for] = ACTIONS(425),
    [anon_sym_while] = ACTIONS(427),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(429),
    [anon_sym_try] = ACTIONS(431),
    [anon_sym_match] = ACTIONS(433),
    [anon_sym_match_BANG] = ACTIONS(435),
    [anon_sym_function] = ACTIONS(437),
    [anon_sym_LT_DASH] = ACTIONS(439),
    [anon_sym_DOT_LBRACK] = ACTIONS(441),
    [anon_sym_LT] = ACTIONS(443),
    [anon_sym_use] = ACTIONS(445),
    [anon_sym_use_BANG] = ACTIONS(447),
    [anon_sym_do_BANG] = ACTIONS(449),
    [anon_sym_begin] = ACTIONS(451),
    [anon_sym_LPAREN2] = ACTIONS(453),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(455),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(457),
    [anon_sym_DQUOTE] = ACTIONS(459),
    [anon_sym_AT_DQUOTE] = ACTIONS(461),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(463),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(465),
    [sym_bool] = ACTIONS(467),
    [sym_unit] = ACTIONS(469),
    [anon_sym_LPAREN_PIPE] = ACTIONS(471),
    [sym_op_identifier] = ACTIONS(473),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(475),
    [sym_xint] = ACTIONS(477),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(479),
    [sym__newline] = ACTIONS(145),
  },
  [26] = {
    [sym_function_or_value_defn] = STATE(482),
    [sym__expression] = STATE(28),
    [sym_literal_expression] = STATE(1537),
    [sym_long_identifier_or_op] = STATE(1537),
    [sym_tuple_expression] = STATE(1537),
    [sym_brace_expression] = STATE(1537),
    [sym_anon_record_expression] = STATE(1537),
    [sym_prefixed_expression] = STATE(1537),
    [sym_typecast_expression] = STATE(1537),
    [sym_for_expression] = STATE(1537),
    [sym_while_expression] = STATE(1537),
    [sym__if_branch] = STATE(6834),
    [sym_if_expression] = STATE(1537),
    [sym_fun_expression] = STATE(1537),
    [sym_try_expression] = STATE(1537),
    [sym_match_expression] = STATE(1537),
    [sym_function_expression] = STATE(1537),
    [sym_mutate_expression] = STATE(1537),
    [sym_index_expression] = STATE(1537),
    [sym_typed_expression] = STATE(1537),
    [sym_declaration_expression] = STATE(1537),
    [sym_do_expression] = STATE(1537),
    [sym_list_expression] = STATE(1537),
    [sym_array_expression] = STATE(1537),
    [sym_begin_end_expression] = STATE(1537),
    [sym_paren_expression] = STATE(1537),
    [sym__high_prec_app] = STATE(1538),
    [sym__low_prec_app] = STATE(1538),
    [sym_application_expression] = STATE(1537),
    [sym_dot_expression] = STATE(1537),
    [sym_infix_expression] = STATE(1537),
    [sym_ce_expression] = STATE(1537),
    [sym_sequential_expression] = STATE(1537),
    [sym_char] = STATE(1484),
    [sym_format_string] = STATE(1483),
    [sym__string_literal] = STATE(1483),
    [sym_string] = STATE(1484),
    [sym_verbatim_string] = STATE(1484),
    [sym_bytearray] = STATE(1484),
    [sym_verbatim_bytearray] = STATE(1484),
    [sym_format_triple_quoted_string] = STATE(1482),
    [sym_triple_quoted_string] = STATE(1484),
    [sym_const] = STATE(1537),
    [sym_long_identifier] = STATE(1643),
    [sym_active_pattern] = STATE(1645),
    [sym__identifier_or_op] = STATE(1689),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(670),
    [sym_infix_op] = STATE(491),
    [sym_sbyte] = STATE(1484),
    [sym_byte] = STATE(1484),
    [sym_int16] = STATE(1484),
    [sym_uint16] = STATE(1484),
    [sym_int32] = STATE(1484),
    [sym_uint32] = STATE(1484),
    [sym_nativeint] = STATE(1484),
    [sym_unativeint] = STATE(1484),
    [sym_int64] = STATE(1484),
    [sym_uint64] = STATE(1484),
    [sym_ieee32] = STATE(1484),
    [sym_ieee64] = STATE(1484),
    [sym_bignum] = STATE(1484),
    [sym_decimal] = STATE(1484),
    [sym_float] = STATE(1327),
    [sym_block_comment] = STATE(26),
    [sym_compiler_directive_decl] = STATE(26),
    [sym_fsi_directive_decl] = STATE(26),
    [sym_preproc_line] = STATE(26),
    [sym_preproc_if_in_expression] = STATE(1537),
    [aux_sym_sequential_expression_repeat1] = STATE(1437),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(275),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(277),
    [anon_sym_return] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(281),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_as] = ACTIONS(147),
    [anon_sym_LPAREN] = ACTIONS(285),
    [anon_sym_COMMA] = ACTIONS(287),
    [anon_sym_null] = ACTIONS(289),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(277),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(291),
    [anon_sym_LBRACK_PIPE] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(295),
    [anon_sym_LT_AT] = ACTIONS(297),
    [anon_sym_LT_AT_AT] = ACTIONS(299),
    [anon_sym_DOT] = ACTIONS(301),
    [anon_sym_LBRACE_PIPE] = ACTIONS(303),
    [anon_sym_new] = ACTIONS(279),
    [anon_sym_with] = ACTIONS(147),
    [anon_sym_return_BANG] = ACTIONS(307),
    [anon_sym_yield] = ACTIONS(279),
    [anon_sym_yield_BANG] = ACTIONS(307),
    [anon_sym_lazy] = ACTIONS(279),
    [anon_sym_assert] = ACTIONS(279),
    [anon_sym_upcast] = ACTIONS(279),
    [anon_sym_downcast] = ACTIONS(279),
    [anon_sym_COLON_GT] = ACTIONS(309),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(309),
    [anon_sym_for] = ACTIONS(311),
    [anon_sym_while] = ACTIONS(313),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(315),
    [anon_sym_try] = ACTIONS(317),
    [anon_sym_match] = ACTIONS(319),
    [anon_sym_match_BANG] = ACTIONS(321),
    [anon_sym_function] = ACTIONS(323),
    [anon_sym_LT_DASH] = ACTIONS(325),
    [anon_sym_DOT_LBRACK] = ACTIONS(327),
    [anon_sym_LT] = ACTIONS(329),
    [anon_sym_use] = ACTIONS(331),
    [anon_sym_use_BANG] = ACTIONS(333),
    [anon_sym_do_BANG] = ACTIONS(335),
    [anon_sym_begin] = ACTIONS(337),
    [anon_sym_LPAREN2] = ACTIONS(339),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(341),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(343),
    [anon_sym_DQUOTE] = ACTIONS(345),
    [anon_sym_AT_DQUOTE] = ACTIONS(347),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(349),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(351),
    [sym_bool] = ACTIONS(353),
    [sym_unit] = ACTIONS(355),
    [anon_sym_LPAREN_PIPE] = ACTIONS(357),
    [sym_op_identifier] = ACTIONS(359),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(361),
    [sym_xint] = ACTIONS(363),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(365),
    [sym__newline] = ACTIONS(145),
    [sym__dedent] = ACTIONS(145),
  },
  [27] = {
    [sym_function_or_value_defn] = STATE(482),
    [sym__expression] = STATE(28),
    [sym_literal_expression] = STATE(1537),
    [sym_long_identifier_or_op] = STATE(1537),
    [sym_tuple_expression] = STATE(1537),
    [sym_brace_expression] = STATE(1537),
    [sym_anon_record_expression] = STATE(1537),
    [sym_prefixed_expression] = STATE(1537),
    [sym_typecast_expression] = STATE(1537),
    [sym_for_expression] = STATE(1537),
    [sym_while_expression] = STATE(1537),
    [sym__if_branch] = STATE(6834),
    [sym_if_expression] = STATE(1537),
    [sym_fun_expression] = STATE(1537),
    [sym_try_expression] = STATE(1537),
    [sym_match_expression] = STATE(1537),
    [sym_function_expression] = STATE(1537),
    [sym_mutate_expression] = STATE(1537),
    [sym_index_expression] = STATE(1537),
    [sym_typed_expression] = STATE(1537),
    [sym_declaration_expression] = STATE(1537),
    [sym_do_expression] = STATE(1537),
    [sym_list_expression] = STATE(1537),
    [sym_array_expression] = STATE(1537),
    [sym_begin_end_expression] = STATE(1537),
    [sym_paren_expression] = STATE(1537),
    [sym__high_prec_app] = STATE(1538),
    [sym__low_prec_app] = STATE(1538),
    [sym_application_expression] = STATE(1537),
    [sym_dot_expression] = STATE(1537),
    [sym_infix_expression] = STATE(1537),
    [sym_ce_expression] = STATE(1537),
    [sym_sequential_expression] = STATE(1537),
    [sym_char] = STATE(1484),
    [sym_format_string] = STATE(1483),
    [sym__string_literal] = STATE(1483),
    [sym_string] = STATE(1484),
    [sym_verbatim_string] = STATE(1484),
    [sym_bytearray] = STATE(1484),
    [sym_verbatim_bytearray] = STATE(1484),
    [sym_format_triple_quoted_string] = STATE(1482),
    [sym_triple_quoted_string] = STATE(1484),
    [sym_const] = STATE(1537),
    [sym_long_identifier] = STATE(1643),
    [sym_active_pattern] = STATE(1645),
    [sym__identifier_or_op] = STATE(1689),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(670),
    [sym_infix_op] = STATE(491),
    [sym_sbyte] = STATE(1484),
    [sym_byte] = STATE(1484),
    [sym_int16] = STATE(1484),
    [sym_uint16] = STATE(1484),
    [sym_int32] = STATE(1484),
    [sym_uint32] = STATE(1484),
    [sym_nativeint] = STATE(1484),
    [sym_unativeint] = STATE(1484),
    [sym_int64] = STATE(1484),
    [sym_uint64] = STATE(1484),
    [sym_ieee32] = STATE(1484),
    [sym_ieee64] = STATE(1484),
    [sym_bignum] = STATE(1484),
    [sym_decimal] = STATE(1484),
    [sym_float] = STATE(1327),
    [sym_block_comment] = STATE(27),
    [sym_compiler_directive_decl] = STATE(27),
    [sym_fsi_directive_decl] = STATE(27),
    [sym_preproc_line] = STATE(27),
    [sym_preproc_if_in_expression] = STATE(1537),
    [aux_sym_sequential_expression_repeat1] = STATE(1437),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(275),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(277),
    [anon_sym_return] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(281),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_as] = ACTIONS(151),
    [anon_sym_LPAREN] = ACTIONS(285),
    [anon_sym_COMMA] = ACTIONS(287),
    [anon_sym_null] = ACTIONS(289),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(277),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(291),
    [anon_sym_LBRACK_PIPE] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(295),
    [anon_sym_LT_AT] = ACTIONS(297),
    [anon_sym_LT_AT_AT] = ACTIONS(299),
    [anon_sym_DOT] = ACTIONS(301),
    [anon_sym_LBRACE_PIPE] = ACTIONS(303),
    [anon_sym_new] = ACTIONS(279),
    [anon_sym_with] = ACTIONS(151),
    [anon_sym_return_BANG] = ACTIONS(307),
    [anon_sym_yield] = ACTIONS(279),
    [anon_sym_yield_BANG] = ACTIONS(307),
    [anon_sym_lazy] = ACTIONS(279),
    [anon_sym_assert] = ACTIONS(279),
    [anon_sym_upcast] = ACTIONS(279),
    [anon_sym_downcast] = ACTIONS(279),
    [anon_sym_COLON_GT] = ACTIONS(309),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(309),
    [anon_sym_for] = ACTIONS(311),
    [anon_sym_while] = ACTIONS(313),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(315),
    [anon_sym_try] = ACTIONS(317),
    [anon_sym_match] = ACTIONS(319),
    [anon_sym_match_BANG] = ACTIONS(321),
    [anon_sym_function] = ACTIONS(323),
    [anon_sym_LT_DASH] = ACTIONS(325),
    [anon_sym_DOT_LBRACK] = ACTIONS(327),
    [anon_sym_LT] = ACTIONS(329),
    [anon_sym_use] = ACTIONS(331),
    [anon_sym_use_BANG] = ACTIONS(333),
    [anon_sym_do_BANG] = ACTIONS(335),
    [anon_sym_begin] = ACTIONS(337),
    [anon_sym_LPAREN2] = ACTIONS(339),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(341),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(343),
    [anon_sym_DQUOTE] = ACTIONS(345),
    [anon_sym_AT_DQUOTE] = ACTIONS(347),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(349),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(351),
    [sym_bool] = ACTIONS(353),
    [sym_unit] = ACTIONS(355),
    [anon_sym_LPAREN_PIPE] = ACTIONS(357),
    [sym_op_identifier] = ACTIONS(359),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(361),
    [sym_xint] = ACTIONS(363),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(365),
    [sym__newline] = ACTIONS(367),
    [sym__dedent] = ACTIONS(149),
  },
  [28] = {
    [sym_function_or_value_defn] = STATE(482),
    [sym__expression] = STATE(28),
    [sym_literal_expression] = STATE(1537),
    [sym_long_identifier_or_op] = STATE(1537),
    [sym_tuple_expression] = STATE(1537),
    [sym_brace_expression] = STATE(1537),
    [sym_anon_record_expression] = STATE(1537),
    [sym_prefixed_expression] = STATE(1537),
    [sym_typecast_expression] = STATE(1537),
    [sym_for_expression] = STATE(1537),
    [sym_while_expression] = STATE(1537),
    [sym__if_branch] = STATE(6834),
    [sym_if_expression] = STATE(1537),
    [sym_fun_expression] = STATE(1537),
    [sym_try_expression] = STATE(1537),
    [sym_match_expression] = STATE(1537),
    [sym_function_expression] = STATE(1537),
    [sym_mutate_expression] = STATE(1537),
    [sym_index_expression] = STATE(1537),
    [sym_typed_expression] = STATE(1537),
    [sym_declaration_expression] = STATE(1537),
    [sym_do_expression] = STATE(1537),
    [sym_list_expression] = STATE(1537),
    [sym_array_expression] = STATE(1537),
    [sym_begin_end_expression] = STATE(1537),
    [sym_paren_expression] = STATE(1537),
    [sym__high_prec_app] = STATE(1538),
    [sym__low_prec_app] = STATE(1538),
    [sym_application_expression] = STATE(1537),
    [sym_dot_expression] = STATE(1537),
    [sym_infix_expression] = STATE(1537),
    [sym_ce_expression] = STATE(1537),
    [sym_sequential_expression] = STATE(1537),
    [sym_char] = STATE(1484),
    [sym_format_string] = STATE(1483),
    [sym__string_literal] = STATE(1483),
    [sym_string] = STATE(1484),
    [sym_verbatim_string] = STATE(1484),
    [sym_bytearray] = STATE(1484),
    [sym_verbatim_bytearray] = STATE(1484),
    [sym_format_triple_quoted_string] = STATE(1482),
    [sym_triple_quoted_string] = STATE(1484),
    [sym_const] = STATE(1537),
    [sym_long_identifier] = STATE(1643),
    [sym_active_pattern] = STATE(1645),
    [sym__identifier_or_op] = STATE(1689),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(670),
    [sym_infix_op] = STATE(491),
    [sym_sbyte] = STATE(1484),
    [sym_byte] = STATE(1484),
    [sym_int16] = STATE(1484),
    [sym_uint16] = STATE(1484),
    [sym_int32] = STATE(1484),
    [sym_uint32] = STATE(1484),
    [sym_nativeint] = STATE(1484),
    [sym_unativeint] = STATE(1484),
    [sym_int64] = STATE(1484),
    [sym_uint64] = STATE(1484),
    [sym_ieee32] = STATE(1484),
    [sym_ieee64] = STATE(1484),
    [sym_bignum] = STATE(1484),
    [sym_decimal] = STATE(1484),
    [sym_float] = STATE(1327),
    [sym_block_comment] = STATE(28),
    [sym_compiler_directive_decl] = STATE(28),
    [sym_fsi_directive_decl] = STATE(28),
    [sym_preproc_line] = STATE(28),
    [sym_preproc_if_in_expression] = STATE(1537),
    [aux_sym_sequential_expression_repeat1] = STATE(1437),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_EQ] = ACTIONS(157),
    [anon_sym_COLON] = ACTIONS(155),
    [anon_sym_return] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(155),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_let_BANG] = ACTIONS(157),
    [anon_sym_as] = ACTIONS(155),
    [anon_sym_LPAREN] = ACTIONS(155),
    [anon_sym_COMMA] = ACTIONS(157),
    [anon_sym_null] = ACTIONS(155),
    [anon_sym_QMARK] = ACTIONS(155),
    [anon_sym_COLON_QMARK] = ACTIONS(155),
    [anon_sym_COLON_COLON] = ACTIONS(157),
    [anon_sym_AMP] = ACTIONS(155),
    [anon_sym_LBRACK] = ACTIONS(155),
    [anon_sym_LBRACK_PIPE] = ACTIONS(157),
    [anon_sym_LBRACE] = ACTIONS(155),
    [anon_sym_LT_AT] = ACTIONS(155),
    [anon_sym_LT_AT_AT] = ACTIONS(155),
    [anon_sym_DOT] = ACTIONS(301),
    [anon_sym_LBRACE_PIPE] = ACTIONS(157),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_with] = ACTIONS(155),
    [anon_sym_return_BANG] = ACTIONS(157),
    [anon_sym_yield] = ACTIONS(155),
    [anon_sym_yield_BANG] = ACTIONS(157),
    [anon_sym_lazy] = ACTIONS(155),
    [anon_sym_assert] = ACTIONS(155),
    [anon_sym_upcast] = ACTIONS(155),
    [anon_sym_downcast] = ACTIONS(155),
    [anon_sym_COLON_GT] = ACTIONS(157),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(157),
    [anon_sym_for] = ACTIONS(155),
    [anon_sym_while] = ACTIONS(155),
    [anon_sym_if] = ACTIONS(155),
    [anon_sym_fun] = ACTIONS(155),
    [anon_sym_try] = ACTIONS(155),
    [anon_sym_match] = ACTIONS(155),
    [anon_sym_match_BANG] = ACTIONS(157),
    [anon_sym_function] = ACTIONS(155),
    [anon_sym_LT_DASH] = ACTIONS(155),
    [anon_sym_DOT_LBRACK] = ACTIONS(327),
    [anon_sym_LT] = ACTIONS(329),
    [anon_sym_use] = ACTIONS(155),
    [anon_sym_use_BANG] = ACTIONS(157),
    [anon_sym_do_BANG] = ACTIONS(157),
    [anon_sym_begin] = ACTIONS(155),
    [anon_sym_LPAREN2] = ACTIONS(339),
    [anon_sym_or] = ACTIONS(155),
    [aux_sym_char_token1] = ACTIONS(157),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(155),
    [anon_sym_DQUOTE] = ACTIONS(155),
    [anon_sym_AT_DQUOTE] = ACTIONS(157),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(157),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(157),
    [sym_bool] = ACTIONS(155),
    [sym_unit] = ACTIONS(355),
    [anon_sym_LPAREN_PIPE] = ACTIONS(155),
    [sym_op_identifier] = ACTIONS(155),
    [anon_sym_PLUS] = ACTIONS(155),
    [anon_sym_DASH] = ACTIONS(155),
    [anon_sym_PLUS_DOT] = ACTIONS(155),
    [anon_sym_DASH_DOT] = ACTIONS(155),
    [anon_sym_PERCENT] = ACTIONS(155),
    [anon_sym_AMP_AMP] = ACTIONS(155),
    [anon_sym_TILDE] = ACTIONS(157),
    [aux_sym_prefix_op_token1] = ACTIONS(155),
    [aux_sym_infix_op_token1] = ACTIONS(157),
    [aux_sym_infix_op_token2] = ACTIONS(155),
    [anon_sym_PIPE_PIPE] = ACTIONS(155),
    [anon_sym_BANG_EQ] = ACTIONS(155),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_DOLLAR] = ACTIONS(155),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(155),
    [sym_int] = ACTIONS(155),
    [sym_xint] = ACTIONS(157),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(157),
    [sym__newline] = ACTIONS(157),
    [sym__dedent] = ACTIONS(157),
  },
  [29] = {
    [sym_function_or_value_defn] = STATE(482),
    [sym__expression] = STATE(28),
    [sym_literal_expression] = STATE(1537),
    [sym_long_identifier_or_op] = STATE(1537),
    [sym_tuple_expression] = STATE(1537),
    [sym_brace_expression] = STATE(1537),
    [sym_anon_record_expression] = STATE(1537),
    [sym_prefixed_expression] = STATE(1537),
    [sym_typecast_expression] = STATE(1537),
    [sym_for_expression] = STATE(1537),
    [sym_while_expression] = STATE(1537),
    [sym__if_branch] = STATE(6834),
    [sym_if_expression] = STATE(1537),
    [sym_fun_expression] = STATE(1537),
    [sym_try_expression] = STATE(1537),
    [sym_match_expression] = STATE(1537),
    [sym_function_expression] = STATE(1537),
    [sym_mutate_expression] = STATE(1537),
    [sym_index_expression] = STATE(1537),
    [sym_typed_expression] = STATE(1537),
    [sym_declaration_expression] = STATE(1537),
    [sym_do_expression] = STATE(1537),
    [sym_list_expression] = STATE(1537),
    [sym_array_expression] = STATE(1537),
    [sym_begin_end_expression] = STATE(1537),
    [sym_paren_expression] = STATE(1537),
    [sym__high_prec_app] = STATE(1538),
    [sym__low_prec_app] = STATE(1538),
    [sym_application_expression] = STATE(1537),
    [sym_dot_expression] = STATE(1537),
    [sym_infix_expression] = STATE(1537),
    [sym_ce_expression] = STATE(1537),
    [sym_sequential_expression] = STATE(1537),
    [sym_char] = STATE(1484),
    [sym_format_string] = STATE(1483),
    [sym__string_literal] = STATE(1483),
    [sym_string] = STATE(1484),
    [sym_verbatim_string] = STATE(1484),
    [sym_bytearray] = STATE(1484),
    [sym_verbatim_bytearray] = STATE(1484),
    [sym_format_triple_quoted_string] = STATE(1482),
    [sym_triple_quoted_string] = STATE(1484),
    [sym_const] = STATE(1537),
    [sym_long_identifier] = STATE(1643),
    [sym_active_pattern] = STATE(1645),
    [sym__identifier_or_op] = STATE(1689),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(670),
    [sym_infix_op] = STATE(491),
    [sym_sbyte] = STATE(1484),
    [sym_byte] = STATE(1484),
    [sym_int16] = STATE(1484),
    [sym_uint16] = STATE(1484),
    [sym_int32] = STATE(1484),
    [sym_uint32] = STATE(1484),
    [sym_nativeint] = STATE(1484),
    [sym_unativeint] = STATE(1484),
    [sym_int64] = STATE(1484),
    [sym_uint64] = STATE(1484),
    [sym_ieee32] = STATE(1484),
    [sym_ieee64] = STATE(1484),
    [sym_bignum] = STATE(1484),
    [sym_decimal] = STATE(1484),
    [sym_float] = STATE(1327),
    [sym_block_comment] = STATE(29),
    [sym_compiler_directive_decl] = STATE(29),
    [sym_fsi_directive_decl] = STATE(29),
    [sym_preproc_line] = STATE(29),
    [sym_preproc_if_in_expression] = STATE(1537),
    [aux_sym_sequential_expression_repeat1] = STATE(1437),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(275),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(277),
    [anon_sym_return] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(281),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_as] = ACTIONS(173),
    [anon_sym_LPAREN] = ACTIONS(285),
    [anon_sym_COMMA] = ACTIONS(287),
    [anon_sym_null] = ACTIONS(289),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(277),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(291),
    [anon_sym_LBRACK_PIPE] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(295),
    [anon_sym_LT_AT] = ACTIONS(297),
    [anon_sym_LT_AT_AT] = ACTIONS(299),
    [anon_sym_DOT] = ACTIONS(301),
    [anon_sym_LBRACE_PIPE] = ACTIONS(303),
    [anon_sym_new] = ACTIONS(279),
    [anon_sym_with] = ACTIONS(173),
    [anon_sym_return_BANG] = ACTIONS(307),
    [anon_sym_yield] = ACTIONS(279),
    [anon_sym_yield_BANG] = ACTIONS(307),
    [anon_sym_lazy] = ACTIONS(279),
    [anon_sym_assert] = ACTIONS(279),
    [anon_sym_upcast] = ACTIONS(279),
    [anon_sym_downcast] = ACTIONS(279),
    [anon_sym_COLON_GT] = ACTIONS(309),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(309),
    [anon_sym_for] = ACTIONS(311),
    [anon_sym_while] = ACTIONS(313),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(315),
    [anon_sym_try] = ACTIONS(317),
    [anon_sym_match] = ACTIONS(319),
    [anon_sym_match_BANG] = ACTIONS(321),
    [anon_sym_function] = ACTIONS(323),
    [anon_sym_LT_DASH] = ACTIONS(325),
    [anon_sym_DOT_LBRACK] = ACTIONS(327),
    [anon_sym_LT] = ACTIONS(329),
    [anon_sym_use] = ACTIONS(331),
    [anon_sym_use_BANG] = ACTIONS(333),
    [anon_sym_do_BANG] = ACTIONS(335),
    [anon_sym_begin] = ACTIONS(337),
    [anon_sym_LPAREN2] = ACTIONS(339),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(341),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(343),
    [anon_sym_DQUOTE] = ACTIONS(345),
    [anon_sym_AT_DQUOTE] = ACTIONS(347),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(349),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(351),
    [sym_bool] = ACTIONS(353),
    [sym_unit] = ACTIONS(355),
    [anon_sym_LPAREN_PIPE] = ACTIONS(357),
    [sym_op_identifier] = ACTIONS(359),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(361),
    [sym_xint] = ACTIONS(363),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(365),
    [sym__newline] = ACTIONS(367),
    [sym__dedent] = ACTIONS(171),
  },
  [30] = {
    [sym_function_or_value_defn] = STATE(482),
    [sym__expression] = STATE(28),
    [sym_literal_expression] = STATE(1537),
    [sym_long_identifier_or_op] = STATE(1537),
    [sym_tuple_expression] = STATE(1537),
    [sym_brace_expression] = STATE(1537),
    [sym_anon_record_expression] = STATE(1537),
    [sym_prefixed_expression] = STATE(1537),
    [sym_typecast_expression] = STATE(1537),
    [sym_for_expression] = STATE(1537),
    [sym_while_expression] = STATE(1537),
    [sym__if_branch] = STATE(6834),
    [sym_if_expression] = STATE(1537),
    [sym_fun_expression] = STATE(1537),
    [sym_try_expression] = STATE(1537),
    [sym_match_expression] = STATE(1537),
    [sym_function_expression] = STATE(1537),
    [sym_mutate_expression] = STATE(1537),
    [sym_index_expression] = STATE(1537),
    [sym_typed_expression] = STATE(1537),
    [sym_declaration_expression] = STATE(1537),
    [sym_do_expression] = STATE(1537),
    [sym_list_expression] = STATE(1537),
    [sym_array_expression] = STATE(1537),
    [sym_begin_end_expression] = STATE(1537),
    [sym_paren_expression] = STATE(1537),
    [sym__high_prec_app] = STATE(1538),
    [sym__low_prec_app] = STATE(1538),
    [sym_application_expression] = STATE(1537),
    [sym_dot_expression] = STATE(1537),
    [sym_infix_expression] = STATE(1537),
    [sym_ce_expression] = STATE(1537),
    [sym_sequential_expression] = STATE(1537),
    [sym_char] = STATE(1484),
    [sym_format_string] = STATE(1483),
    [sym__string_literal] = STATE(1483),
    [sym_string] = STATE(1484),
    [sym_verbatim_string] = STATE(1484),
    [sym_bytearray] = STATE(1484),
    [sym_verbatim_bytearray] = STATE(1484),
    [sym_format_triple_quoted_string] = STATE(1482),
    [sym_triple_quoted_string] = STATE(1484),
    [sym_const] = STATE(1537),
    [sym_long_identifier] = STATE(1643),
    [sym_active_pattern] = STATE(1645),
    [sym__identifier_or_op] = STATE(1689),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(670),
    [sym_infix_op] = STATE(491),
    [sym_sbyte] = STATE(1484),
    [sym_byte] = STATE(1484),
    [sym_int16] = STATE(1484),
    [sym_uint16] = STATE(1484),
    [sym_int32] = STATE(1484),
    [sym_uint32] = STATE(1484),
    [sym_nativeint] = STATE(1484),
    [sym_unativeint] = STATE(1484),
    [sym_int64] = STATE(1484),
    [sym_uint64] = STATE(1484),
    [sym_ieee32] = STATE(1484),
    [sym_ieee64] = STATE(1484),
    [sym_bignum] = STATE(1484),
    [sym_decimal] = STATE(1484),
    [sym_float] = STATE(1327),
    [sym_block_comment] = STATE(30),
    [sym_compiler_directive_decl] = STATE(30),
    [sym_fsi_directive_decl] = STATE(30),
    [sym_preproc_line] = STATE(30),
    [sym_preproc_if_in_expression] = STATE(1537),
    [aux_sym_sequential_expression_repeat1] = STATE(1437),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(275),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(277),
    [anon_sym_return] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(281),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_as] = ACTIONS(59),
    [anon_sym_LPAREN] = ACTIONS(285),
    [anon_sym_COMMA] = ACTIONS(287),
    [anon_sym_null] = ACTIONS(289),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(277),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(291),
    [anon_sym_LBRACK_PIPE] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(59),
    [anon_sym_LT_AT] = ACTIONS(297),
    [anon_sym_LT_AT_AT] = ACTIONS(299),
    [anon_sym_DOT] = ACTIONS(301),
    [anon_sym_LBRACE_PIPE] = ACTIONS(303),
    [anon_sym_new] = ACTIONS(279),
    [anon_sym_with] = ACTIONS(59),
    [anon_sym_return_BANG] = ACTIONS(307),
    [anon_sym_yield] = ACTIONS(279),
    [anon_sym_yield_BANG] = ACTIONS(307),
    [anon_sym_lazy] = ACTIONS(279),
    [anon_sym_assert] = ACTIONS(279),
    [anon_sym_upcast] = ACTIONS(279),
    [anon_sym_downcast] = ACTIONS(279),
    [anon_sym_COLON_GT] = ACTIONS(309),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(309),
    [anon_sym_for] = ACTIONS(311),
    [anon_sym_while] = ACTIONS(313),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(315),
    [anon_sym_try] = ACTIONS(317),
    [anon_sym_match] = ACTIONS(319),
    [anon_sym_match_BANG] = ACTIONS(321),
    [anon_sym_function] = ACTIONS(323),
    [anon_sym_LT_DASH] = ACTIONS(325),
    [anon_sym_DOT_LBRACK] = ACTIONS(327),
    [anon_sym_LT] = ACTIONS(329),
    [anon_sym_use] = ACTIONS(331),
    [anon_sym_use_BANG] = ACTIONS(333),
    [anon_sym_do_BANG] = ACTIONS(335),
    [anon_sym_begin] = ACTIONS(337),
    [anon_sym_LPAREN2] = ACTIONS(339),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(341),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(343),
    [anon_sym_DQUOTE] = ACTIONS(345),
    [anon_sym_AT_DQUOTE] = ACTIONS(347),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(349),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(351),
    [sym_bool] = ACTIONS(353),
    [sym_unit] = ACTIONS(355),
    [anon_sym_LPAREN_PIPE] = ACTIONS(357),
    [sym_op_identifier] = ACTIONS(359),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(361),
    [sym_xint] = ACTIONS(363),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(365),
    [sym__newline] = ACTIONS(33),
    [sym__dedent] = ACTIONS(33),
  },
  [31] = {
    [sym_function_or_value_defn] = STATE(482),
    [sym__expression] = STATE(28),
    [sym_literal_expression] = STATE(1537),
    [sym_long_identifier_or_op] = STATE(1537),
    [sym_tuple_expression] = STATE(1537),
    [sym_brace_expression] = STATE(1537),
    [sym_anon_record_expression] = STATE(1537),
    [sym_prefixed_expression] = STATE(1537),
    [sym_typecast_expression] = STATE(1537),
    [sym_for_expression] = STATE(1537),
    [sym_while_expression] = STATE(1537),
    [sym__if_branch] = STATE(6834),
    [sym_if_expression] = STATE(1537),
    [sym_fun_expression] = STATE(1537),
    [sym_try_expression] = STATE(1537),
    [sym_match_expression] = STATE(1537),
    [sym_function_expression] = STATE(1537),
    [sym_mutate_expression] = STATE(1537),
    [sym_index_expression] = STATE(1537),
    [sym_typed_expression] = STATE(1537),
    [sym_declaration_expression] = STATE(1537),
    [sym_do_expression] = STATE(1537),
    [sym_list_expression] = STATE(1537),
    [sym_array_expression] = STATE(1537),
    [sym_begin_end_expression] = STATE(1537),
    [sym_paren_expression] = STATE(1537),
    [sym__high_prec_app] = STATE(1538),
    [sym__low_prec_app] = STATE(1538),
    [sym_application_expression] = STATE(1537),
    [sym_dot_expression] = STATE(1537),
    [sym_infix_expression] = STATE(1537),
    [sym_ce_expression] = STATE(1537),
    [sym_sequential_expression] = STATE(1537),
    [sym_char] = STATE(1484),
    [sym_format_string] = STATE(1483),
    [sym__string_literal] = STATE(1483),
    [sym_string] = STATE(1484),
    [sym_verbatim_string] = STATE(1484),
    [sym_bytearray] = STATE(1484),
    [sym_verbatim_bytearray] = STATE(1484),
    [sym_format_triple_quoted_string] = STATE(1482),
    [sym_triple_quoted_string] = STATE(1484),
    [sym_const] = STATE(1537),
    [sym_long_identifier] = STATE(1643),
    [sym_active_pattern] = STATE(1645),
    [sym__identifier_or_op] = STATE(1689),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(670),
    [sym_infix_op] = STATE(491),
    [sym_sbyte] = STATE(1484),
    [sym_byte] = STATE(1484),
    [sym_int16] = STATE(1484),
    [sym_uint16] = STATE(1484),
    [sym_int32] = STATE(1484),
    [sym_uint32] = STATE(1484),
    [sym_nativeint] = STATE(1484),
    [sym_unativeint] = STATE(1484),
    [sym_int64] = STATE(1484),
    [sym_uint64] = STATE(1484),
    [sym_ieee32] = STATE(1484),
    [sym_ieee64] = STATE(1484),
    [sym_bignum] = STATE(1484),
    [sym_decimal] = STATE(1484),
    [sym_float] = STATE(1327),
    [sym_block_comment] = STATE(31),
    [sym_compiler_directive_decl] = STATE(31),
    [sym_fsi_directive_decl] = STATE(31),
    [sym_preproc_line] = STATE(31),
    [sym_preproc_if_in_expression] = STATE(1537),
    [aux_sym_sequential_expression_repeat1] = STATE(1437),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(275),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(277),
    [anon_sym_return] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(281),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_as] = ACTIONS(169),
    [anon_sym_LPAREN] = ACTIONS(285),
    [anon_sym_COMMA] = ACTIONS(287),
    [anon_sym_null] = ACTIONS(289),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(277),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(291),
    [anon_sym_LBRACK_PIPE] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(169),
    [anon_sym_LT_AT] = ACTIONS(297),
    [anon_sym_LT_AT_AT] = ACTIONS(299),
    [anon_sym_DOT] = ACTIONS(301),
    [anon_sym_LBRACE_PIPE] = ACTIONS(303),
    [anon_sym_new] = ACTIONS(279),
    [anon_sym_with] = ACTIONS(169),
    [anon_sym_return_BANG] = ACTIONS(307),
    [anon_sym_yield] = ACTIONS(279),
    [anon_sym_yield_BANG] = ACTIONS(307),
    [anon_sym_lazy] = ACTIONS(279),
    [anon_sym_assert] = ACTIONS(279),
    [anon_sym_upcast] = ACTIONS(279),
    [anon_sym_downcast] = ACTIONS(279),
    [anon_sym_COLON_GT] = ACTIONS(309),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(309),
    [anon_sym_for] = ACTIONS(311),
    [anon_sym_while] = ACTIONS(313),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(315),
    [anon_sym_try] = ACTIONS(317),
    [anon_sym_match] = ACTIONS(319),
    [anon_sym_match_BANG] = ACTIONS(321),
    [anon_sym_function] = ACTIONS(323),
    [anon_sym_LT_DASH] = ACTIONS(325),
    [anon_sym_DOT_LBRACK] = ACTIONS(327),
    [anon_sym_LT] = ACTIONS(329),
    [anon_sym_use] = ACTIONS(331),
    [anon_sym_use_BANG] = ACTIONS(333),
    [anon_sym_do_BANG] = ACTIONS(335),
    [anon_sym_begin] = ACTIONS(337),
    [anon_sym_LPAREN2] = ACTIONS(339),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(341),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(343),
    [anon_sym_DQUOTE] = ACTIONS(345),
    [anon_sym_AT_DQUOTE] = ACTIONS(347),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(349),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(351),
    [sym_bool] = ACTIONS(353),
    [sym_unit] = ACTIONS(355),
    [anon_sym_LPAREN_PIPE] = ACTIONS(357),
    [sym_op_identifier] = ACTIONS(359),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(361),
    [sym_xint] = ACTIONS(363),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(365),
    [sym__newline] = ACTIONS(167),
    [sym__dedent] = ACTIONS(167),
  },
  [32] = {
    [sym_function_or_value_defn] = STATE(482),
    [sym__expression] = STATE(28),
    [sym_literal_expression] = STATE(1537),
    [sym_long_identifier_or_op] = STATE(1537),
    [sym_tuple_expression] = STATE(1537),
    [sym_brace_expression] = STATE(1537),
    [sym_anon_record_expression] = STATE(1537),
    [sym_prefixed_expression] = STATE(1537),
    [sym_typecast_expression] = STATE(1537),
    [sym_for_expression] = STATE(1537),
    [sym_while_expression] = STATE(1537),
    [sym__if_branch] = STATE(6834),
    [sym_if_expression] = STATE(1537),
    [sym_fun_expression] = STATE(1537),
    [sym_try_expression] = STATE(1537),
    [sym_match_expression] = STATE(1537),
    [sym_function_expression] = STATE(1537),
    [sym_mutate_expression] = STATE(1537),
    [sym_index_expression] = STATE(1537),
    [sym_typed_expression] = STATE(1537),
    [sym_declaration_expression] = STATE(1537),
    [sym_do_expression] = STATE(1537),
    [sym_list_expression] = STATE(1537),
    [sym_array_expression] = STATE(1537),
    [sym_begin_end_expression] = STATE(1537),
    [sym_paren_expression] = STATE(1537),
    [sym__high_prec_app] = STATE(1538),
    [sym__low_prec_app] = STATE(1538),
    [sym_application_expression] = STATE(1537),
    [sym_dot_expression] = STATE(1537),
    [sym_infix_expression] = STATE(1537),
    [sym_ce_expression] = STATE(1537),
    [sym_sequential_expression] = STATE(1537),
    [sym_char] = STATE(1484),
    [sym_format_string] = STATE(1483),
    [sym__string_literal] = STATE(1483),
    [sym_string] = STATE(1484),
    [sym_verbatim_string] = STATE(1484),
    [sym_bytearray] = STATE(1484),
    [sym_verbatim_bytearray] = STATE(1484),
    [sym_format_triple_quoted_string] = STATE(1482),
    [sym_triple_quoted_string] = STATE(1484),
    [sym_const] = STATE(1537),
    [sym_long_identifier] = STATE(1643),
    [sym_active_pattern] = STATE(1645),
    [sym__identifier_or_op] = STATE(1689),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(670),
    [sym_infix_op] = STATE(491),
    [sym_sbyte] = STATE(1484),
    [sym_byte] = STATE(1484),
    [sym_int16] = STATE(1484),
    [sym_uint16] = STATE(1484),
    [sym_int32] = STATE(1484),
    [sym_uint32] = STATE(1484),
    [sym_nativeint] = STATE(1484),
    [sym_unativeint] = STATE(1484),
    [sym_int64] = STATE(1484),
    [sym_uint64] = STATE(1484),
    [sym_ieee32] = STATE(1484),
    [sym_ieee64] = STATE(1484),
    [sym_bignum] = STATE(1484),
    [sym_decimal] = STATE(1484),
    [sym_float] = STATE(1327),
    [sym_block_comment] = STATE(32),
    [sym_compiler_directive_decl] = STATE(32),
    [sym_fsi_directive_decl] = STATE(32),
    [sym_preproc_line] = STATE(32),
    [sym_preproc_if_in_expression] = STATE(1537),
    [aux_sym_sequential_expression_repeat1] = STATE(1437),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(181),
    [anon_sym_EQ] = ACTIONS(183),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_return] = ACTIONS(181),
    [anon_sym_do] = ACTIONS(181),
    [anon_sym_let] = ACTIONS(181),
    [anon_sym_let_BANG] = ACTIONS(183),
    [anon_sym_as] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(181),
    [anon_sym_COMMA] = ACTIONS(183),
    [anon_sym_null] = ACTIONS(181),
    [anon_sym_QMARK] = ACTIONS(181),
    [anon_sym_COLON_QMARK] = ACTIONS(181),
    [anon_sym_COLON_COLON] = ACTIONS(183),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_LBRACK_PIPE] = ACTIONS(183),
    [anon_sym_LBRACE] = ACTIONS(181),
    [anon_sym_LT_AT] = ACTIONS(181),
    [anon_sym_LT_AT_AT] = ACTIONS(181),
    [anon_sym_DOT] = ACTIONS(301),
    [anon_sym_LBRACE_PIPE] = ACTIONS(183),
    [anon_sym_new] = ACTIONS(181),
    [anon_sym_with] = ACTIONS(181),
    [anon_sym_return_BANG] = ACTIONS(183),
    [anon_sym_yield] = ACTIONS(181),
    [anon_sym_yield_BANG] = ACTIONS(183),
    [anon_sym_lazy] = ACTIONS(181),
    [anon_sym_assert] = ACTIONS(181),
    [anon_sym_upcast] = ACTIONS(181),
    [anon_sym_downcast] = ACTIONS(181),
    [anon_sym_COLON_GT] = ACTIONS(183),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(183),
    [anon_sym_for] = ACTIONS(181),
    [anon_sym_while] = ACTIONS(181),
    [anon_sym_if] = ACTIONS(181),
    [anon_sym_fun] = ACTIONS(181),
    [anon_sym_try] = ACTIONS(181),
    [anon_sym_match] = ACTIONS(181),
    [anon_sym_match_BANG] = ACTIONS(183),
    [anon_sym_function] = ACTIONS(181),
    [anon_sym_LT_DASH] = ACTIONS(181),
    [anon_sym_DOT_LBRACK] = ACTIONS(327),
    [anon_sym_LT] = ACTIONS(329),
    [anon_sym_use] = ACTIONS(181),
    [anon_sym_use_BANG] = ACTIONS(183),
    [anon_sym_do_BANG] = ACTIONS(183),
    [anon_sym_begin] = ACTIONS(181),
    [anon_sym_LPAREN2] = ACTIONS(339),
    [anon_sym_or] = ACTIONS(181),
    [aux_sym_char_token1] = ACTIONS(183),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(181),
    [anon_sym_DQUOTE] = ACTIONS(181),
    [anon_sym_AT_DQUOTE] = ACTIONS(183),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(183),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(183),
    [sym_bool] = ACTIONS(181),
    [sym_unit] = ACTIONS(355),
    [anon_sym_LPAREN_PIPE] = ACTIONS(181),
    [sym_op_identifier] = ACTIONS(181),
    [anon_sym_PLUS] = ACTIONS(181),
    [anon_sym_DASH] = ACTIONS(181),
    [anon_sym_PLUS_DOT] = ACTIONS(181),
    [anon_sym_DASH_DOT] = ACTIONS(181),
    [anon_sym_PERCENT] = ACTIONS(181),
    [anon_sym_AMP_AMP] = ACTIONS(181),
    [anon_sym_TILDE] = ACTIONS(183),
    [aux_sym_prefix_op_token1] = ACTIONS(181),
    [aux_sym_infix_op_token1] = ACTIONS(183),
    [aux_sym_infix_op_token2] = ACTIONS(181),
    [anon_sym_PIPE_PIPE] = ACTIONS(181),
    [anon_sym_BANG_EQ] = ACTIONS(181),
    [anon_sym_COLON_EQ] = ACTIONS(183),
    [anon_sym_DOLLAR] = ACTIONS(181),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(181),
    [sym_int] = ACTIONS(181),
    [sym_xint] = ACTIONS(183),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(183),
    [sym__newline] = ACTIONS(183),
    [sym__dedent] = ACTIONS(183),
  },
  [33] = {
    [sym_function_or_value_defn] = STATE(482),
    [sym__expression] = STATE(28),
    [sym_literal_expression] = STATE(1537),
    [sym_long_identifier_or_op] = STATE(1537),
    [sym_tuple_expression] = STATE(1537),
    [sym_brace_expression] = STATE(1537),
    [sym_anon_record_expression] = STATE(1537),
    [sym_prefixed_expression] = STATE(1537),
    [sym_typecast_expression] = STATE(1537),
    [sym_for_expression] = STATE(1537),
    [sym_while_expression] = STATE(1537),
    [sym__if_branch] = STATE(6834),
    [sym_if_expression] = STATE(1537),
    [sym_fun_expression] = STATE(1537),
    [sym_try_expression] = STATE(1537),
    [sym_match_expression] = STATE(1537),
    [sym_function_expression] = STATE(1537),
    [sym_mutate_expression] = STATE(1537),
    [sym_index_expression] = STATE(1537),
    [sym_typed_expression] = STATE(1537),
    [sym_declaration_expression] = STATE(1537),
    [sym_do_expression] = STATE(1537),
    [sym_list_expression] = STATE(1537),
    [sym_array_expression] = STATE(1537),
    [sym_begin_end_expression] = STATE(1537),
    [sym_paren_expression] = STATE(1537),
    [sym__high_prec_app] = STATE(1538),
    [sym__low_prec_app] = STATE(1538),
    [sym_application_expression] = STATE(1537),
    [sym_dot_expression] = STATE(1537),
    [sym_infix_expression] = STATE(1537),
    [sym_ce_expression] = STATE(1537),
    [sym_sequential_expression] = STATE(1537),
    [sym_char] = STATE(1484),
    [sym_format_string] = STATE(1483),
    [sym__string_literal] = STATE(1483),
    [sym_string] = STATE(1484),
    [sym_verbatim_string] = STATE(1484),
    [sym_bytearray] = STATE(1484),
    [sym_verbatim_bytearray] = STATE(1484),
    [sym_format_triple_quoted_string] = STATE(1482),
    [sym_triple_quoted_string] = STATE(1484),
    [sym_const] = STATE(1537),
    [sym_long_identifier] = STATE(1643),
    [sym_active_pattern] = STATE(1645),
    [sym__identifier_or_op] = STATE(1689),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(670),
    [sym_infix_op] = STATE(491),
    [sym_sbyte] = STATE(1484),
    [sym_byte] = STATE(1484),
    [sym_int16] = STATE(1484),
    [sym_uint16] = STATE(1484),
    [sym_int32] = STATE(1484),
    [sym_uint32] = STATE(1484),
    [sym_nativeint] = STATE(1484),
    [sym_unativeint] = STATE(1484),
    [sym_int64] = STATE(1484),
    [sym_uint64] = STATE(1484),
    [sym_ieee32] = STATE(1484),
    [sym_ieee64] = STATE(1484),
    [sym_bignum] = STATE(1484),
    [sym_decimal] = STATE(1484),
    [sym_float] = STATE(1327),
    [sym_block_comment] = STATE(33),
    [sym_compiler_directive_decl] = STATE(33),
    [sym_fsi_directive_decl] = STATE(33),
    [sym_preproc_line] = STATE(33),
    [sym_preproc_if_in_expression] = STATE(1537),
    [aux_sym_sequential_expression_repeat1] = STATE(1437),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(275),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(277),
    [anon_sym_return] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(281),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_as] = ACTIONS(165),
    [anon_sym_LPAREN] = ACTIONS(285),
    [anon_sym_COMMA] = ACTIONS(287),
    [anon_sym_null] = ACTIONS(289),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(277),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(291),
    [anon_sym_LBRACK_PIPE] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(165),
    [anon_sym_LT_AT] = ACTIONS(297),
    [anon_sym_LT_AT_AT] = ACTIONS(299),
    [anon_sym_DOT] = ACTIONS(301),
    [anon_sym_LBRACE_PIPE] = ACTIONS(303),
    [anon_sym_new] = ACTIONS(279),
    [anon_sym_with] = ACTIONS(165),
    [anon_sym_return_BANG] = ACTIONS(307),
    [anon_sym_yield] = ACTIONS(279),
    [anon_sym_yield_BANG] = ACTIONS(307),
    [anon_sym_lazy] = ACTIONS(279),
    [anon_sym_assert] = ACTIONS(279),
    [anon_sym_upcast] = ACTIONS(279),
    [anon_sym_downcast] = ACTIONS(279),
    [anon_sym_COLON_GT] = ACTIONS(309),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(309),
    [anon_sym_for] = ACTIONS(311),
    [anon_sym_while] = ACTIONS(313),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(315),
    [anon_sym_try] = ACTIONS(317),
    [anon_sym_match] = ACTIONS(319),
    [anon_sym_match_BANG] = ACTIONS(321),
    [anon_sym_function] = ACTIONS(323),
    [anon_sym_LT_DASH] = ACTIONS(325),
    [anon_sym_DOT_LBRACK] = ACTIONS(327),
    [anon_sym_LT] = ACTIONS(329),
    [anon_sym_use] = ACTIONS(331),
    [anon_sym_use_BANG] = ACTIONS(333),
    [anon_sym_do_BANG] = ACTIONS(335),
    [anon_sym_begin] = ACTIONS(337),
    [anon_sym_LPAREN2] = ACTIONS(339),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(341),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(343),
    [anon_sym_DQUOTE] = ACTIONS(345),
    [anon_sym_AT_DQUOTE] = ACTIONS(347),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(349),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(351),
    [sym_bool] = ACTIONS(353),
    [sym_unit] = ACTIONS(355),
    [anon_sym_LPAREN_PIPE] = ACTIONS(357),
    [sym_op_identifier] = ACTIONS(359),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(361),
    [sym_xint] = ACTIONS(363),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(365),
    [sym__newline] = ACTIONS(163),
    [sym__dedent] = ACTIONS(163),
  },
  [34] = {
    [sym_function_or_value_defn] = STATE(663),
    [sym__expression] = STATE(76),
    [sym_literal_expression] = STATE(1118),
    [sym_long_identifier_or_op] = STATE(1118),
    [sym_tuple_expression] = STATE(1118),
    [sym_brace_expression] = STATE(1118),
    [sym_anon_record_expression] = STATE(1118),
    [sym_prefixed_expression] = STATE(1118),
    [sym_typecast_expression] = STATE(1118),
    [sym_for_expression] = STATE(1118),
    [sym_while_expression] = STATE(1118),
    [sym__if_branch] = STATE(7163),
    [sym_if_expression] = STATE(1118),
    [sym_fun_expression] = STATE(1118),
    [sym_try_expression] = STATE(1118),
    [sym_match_expression] = STATE(1118),
    [sym_function_expression] = STATE(1118),
    [sym_mutate_expression] = STATE(1118),
    [sym_index_expression] = STATE(1118),
    [sym_typed_expression] = STATE(1118),
    [sym_declaration_expression] = STATE(1118),
    [sym_do_expression] = STATE(1118),
    [sym_list_expression] = STATE(1118),
    [sym_array_expression] = STATE(1118),
    [sym_begin_end_expression] = STATE(1118),
    [sym_paren_expression] = STATE(1118),
    [sym__high_prec_app] = STATE(1133),
    [sym__low_prec_app] = STATE(1133),
    [sym_application_expression] = STATE(1118),
    [sym_dot_expression] = STATE(1118),
    [sym_infix_expression] = STATE(1118),
    [sym_ce_expression] = STATE(1118),
    [sym_sequential_expression] = STATE(1118),
    [sym_char] = STATE(1080),
    [sym_format_string] = STATE(1090),
    [sym__string_literal] = STATE(1090),
    [sym_string] = STATE(1080),
    [sym_verbatim_string] = STATE(1080),
    [sym_bytearray] = STATE(1080),
    [sym_verbatim_bytearray] = STATE(1080),
    [sym_format_triple_quoted_string] = STATE(1096),
    [sym_triple_quoted_string] = STATE(1080),
    [sym_const] = STATE(1118),
    [sym_long_identifier] = STATE(1156),
    [sym_active_pattern] = STATE(1085),
    [sym__identifier_or_op] = STATE(1099),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(548),
    [sym_infix_op] = STATE(687),
    [sym_sbyte] = STATE(1080),
    [sym_byte] = STATE(1080),
    [sym_int16] = STATE(1080),
    [sym_uint16] = STATE(1080),
    [sym_int32] = STATE(1080),
    [sym_uint32] = STATE(1080),
    [sym_nativeint] = STATE(1080),
    [sym_unativeint] = STATE(1080),
    [sym_int64] = STATE(1080),
    [sym_uint64] = STATE(1080),
    [sym_ieee32] = STATE(1080),
    [sym_ieee64] = STATE(1080),
    [sym_bignum] = STATE(1080),
    [sym_decimal] = STATE(1080),
    [sym_float] = STATE(979),
    [sym_block_comment] = STATE(34),
    [sym_compiler_directive_decl] = STATE(34),
    [sym_fsi_directive_decl] = STATE(34),
    [sym_preproc_line] = STATE(34),
    [sym_preproc_if_in_expression] = STATE(1118),
    [aux_sym_sequential_expression_repeat1] = STATE(1558),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(195),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(197),
    [anon_sym_return] = ACTIONS(481),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_COMMA] = ACTIONS(483),
    [anon_sym_null] = ACTIONS(207),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(197),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(209),
    [anon_sym_RBRACK] = ACTIONS(485),
    [anon_sym_LBRACK_PIPE] = ACTIONS(211),
    [anon_sym_LBRACE] = ACTIONS(271),
    [anon_sym_LT_AT] = ACTIONS(213),
    [anon_sym_LT_AT_AT] = ACTIONS(215),
    [anon_sym_DOT] = ACTIONS(185),
    [anon_sym_LBRACE_PIPE] = ACTIONS(217),
    [anon_sym_new] = ACTIONS(481),
    [anon_sym_return_BANG] = ACTIONS(487),
    [anon_sym_yield] = ACTIONS(481),
    [anon_sym_yield_BANG] = ACTIONS(487),
    [anon_sym_lazy] = ACTIONS(481),
    [anon_sym_assert] = ACTIONS(481),
    [anon_sym_upcast] = ACTIONS(481),
    [anon_sym_downcast] = ACTIONS(481),
    [anon_sym_COLON_GT] = ACTIONS(221),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(221),
    [anon_sym_for] = ACTIONS(489),
    [anon_sym_while] = ACTIONS(225),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(229),
    [anon_sym_match] = ACTIONS(231),
    [anon_sym_match_BANG] = ACTIONS(233),
    [anon_sym_function] = ACTIONS(235),
    [anon_sym_LT_DASH] = ACTIONS(491),
    [anon_sym_DOT_LBRACK] = ACTIONS(187),
    [anon_sym_LT] = ACTIONS(189),
    [anon_sym_use] = ACTIONS(493),
    [anon_sym_use_BANG] = ACTIONS(495),
    [anon_sym_do_BANG] = ACTIONS(243),
    [anon_sym_begin] = ACTIONS(245),
    [anon_sym_LPAREN2] = ACTIONS(191),
    [anon_sym_DOT_DOT2] = ACTIONS(497),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(247),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(251),
    [anon_sym_AT_DQUOTE] = ACTIONS(253),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(255),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(257),
    [sym_bool] = ACTIONS(259),
    [sym_unit] = ACTIONS(193),
    [anon_sym_LPAREN_PIPE] = ACTIONS(261),
    [sym_op_identifier] = ACTIONS(263),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(499),
    [sym_xint] = ACTIONS(267),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(269),
    [sym__newline] = ACTIONS(501),
  },
  [35] = {
    [sym_function_or_value_defn] = STATE(535),
    [sym__expression] = STATE(98),
    [sym_literal_expression] = STATE(2008),
    [sym_long_identifier_or_op] = STATE(2008),
    [sym_tuple_expression] = STATE(2008),
    [sym_brace_expression] = STATE(2008),
    [sym_anon_record_expression] = STATE(2008),
    [sym_prefixed_expression] = STATE(2008),
    [sym_typecast_expression] = STATE(2008),
    [sym_for_expression] = STATE(2008),
    [sym_while_expression] = STATE(2008),
    [sym__if_branch] = STATE(6754),
    [sym_if_expression] = STATE(2008),
    [sym_fun_expression] = STATE(2008),
    [sym_try_expression] = STATE(2008),
    [sym_match_expression] = STATE(2008),
    [sym_function_expression] = STATE(2008),
    [sym_mutate_expression] = STATE(2008),
    [sym_index_expression] = STATE(2008),
    [sym_typed_expression] = STATE(2008),
    [sym_declaration_expression] = STATE(2008),
    [sym_do_expression] = STATE(2008),
    [sym_list_expression] = STATE(2008),
    [sym_array_expression] = STATE(2008),
    [sym_begin_end_expression] = STATE(2008),
    [sym_paren_expression] = STATE(2008),
    [sym__high_prec_app] = STATE(2007),
    [sym__low_prec_app] = STATE(2007),
    [sym_application_expression] = STATE(2008),
    [sym_dot_expression] = STATE(2008),
    [sym_infix_expression] = STATE(2008),
    [sym_ce_expression] = STATE(2008),
    [sym_sequential_expression] = STATE(2008),
    [sym_char] = STATE(1859),
    [sym_format_string] = STATE(1861),
    [sym__string_literal] = STATE(1861),
    [sym_string] = STATE(1859),
    [sym_verbatim_string] = STATE(1859),
    [sym_bytearray] = STATE(1859),
    [sym_verbatim_bytearray] = STATE(1859),
    [sym_format_triple_quoted_string] = STATE(1862),
    [sym_triple_quoted_string] = STATE(1859),
    [sym_const] = STATE(2008),
    [sym_long_identifier] = STATE(1701),
    [sym_active_pattern] = STATE(1702),
    [sym__identifier_or_op] = STATE(1724),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(664),
    [sym_infix_op] = STATE(543),
    [sym_sbyte] = STATE(1859),
    [sym_byte] = STATE(1859),
    [sym_int16] = STATE(1859),
    [sym_uint16] = STATE(1859),
    [sym_int32] = STATE(1859),
    [sym_uint32] = STATE(1859),
    [sym_nativeint] = STATE(1859),
    [sym_unativeint] = STATE(1859),
    [sym_int64] = STATE(1859),
    [sym_uint64] = STATE(1859),
    [sym_ieee32] = STATE(1859),
    [sym_ieee64] = STATE(1859),
    [sym_bignum] = STATE(1859),
    [sym_decimal] = STATE(1859),
    [sym_float] = STATE(1447),
    [sym_block_comment] = STATE(35),
    [sym_compiler_directive_decl] = STATE(35),
    [sym_fsi_directive_decl] = STATE(35),
    [sym_preproc_line] = STATE(35),
    [sym_preproc_if_in_expression] = STATE(2008),
    [aux_sym_sequential_expression_repeat1] = STATE(1490),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(503),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(505),
    [anon_sym_return] = ACTIONS(507),
    [anon_sym_do] = ACTIONS(509),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(511),
    [anon_sym_COMMA] = ACTIONS(513),
    [anon_sym_null] = ACTIONS(515),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(505),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(517),
    [anon_sym_LBRACK_PIPE] = ACTIONS(519),
    [anon_sym_LBRACE] = ACTIONS(521),
    [anon_sym_LT_AT] = ACTIONS(523),
    [anon_sym_LT_AT_AT] = ACTIONS(525),
    [anon_sym_DOT] = ACTIONS(527),
    [anon_sym_LBRACE_PIPE] = ACTIONS(529),
    [anon_sym_new] = ACTIONS(507),
    [anon_sym_return_BANG] = ACTIONS(531),
    [anon_sym_yield] = ACTIONS(507),
    [anon_sym_yield_BANG] = ACTIONS(531),
    [anon_sym_lazy] = ACTIONS(507),
    [anon_sym_assert] = ACTIONS(507),
    [anon_sym_upcast] = ACTIONS(507),
    [anon_sym_downcast] = ACTIONS(507),
    [anon_sym_COLON_GT] = ACTIONS(533),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(533),
    [anon_sym_for] = ACTIONS(535),
    [anon_sym_while] = ACTIONS(537),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(539),
    [anon_sym_DASH_GT] = ACTIONS(541),
    [anon_sym_try] = ACTIONS(543),
    [anon_sym_match] = ACTIONS(545),
    [anon_sym_match_BANG] = ACTIONS(547),
    [anon_sym_function] = ACTIONS(549),
    [anon_sym_LT_DASH] = ACTIONS(551),
    [anon_sym_DOT_LBRACK] = ACTIONS(553),
    [anon_sym_LT] = ACTIONS(555),
    [anon_sym_use] = ACTIONS(557),
    [anon_sym_use_BANG] = ACTIONS(559),
    [anon_sym_do_BANG] = ACTIONS(561),
    [anon_sym_DOT_DOT] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_LPAREN2] = ACTIONS(567),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(569),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(571),
    [anon_sym_DQUOTE] = ACTIONS(573),
    [anon_sym_AT_DQUOTE] = ACTIONS(575),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(577),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(579),
    [sym_bool] = ACTIONS(581),
    [sym_unit] = ACTIONS(583),
    [anon_sym_LPAREN_PIPE] = ACTIONS(585),
    [sym_op_identifier] = ACTIONS(587),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(589),
    [sym_xint] = ACTIONS(591),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(593),
    [sym__newline] = ACTIONS(595),
  },
  [36] = {
    [sym_function_or_value_defn] = STATE(663),
    [sym__expression] = STATE(76),
    [sym_literal_expression] = STATE(1118),
    [sym_long_identifier_or_op] = STATE(1118),
    [sym_tuple_expression] = STATE(1118),
    [sym_brace_expression] = STATE(1118),
    [sym_anon_record_expression] = STATE(1118),
    [sym_prefixed_expression] = STATE(1118),
    [sym_typecast_expression] = STATE(1118),
    [sym_for_expression] = STATE(1118),
    [sym_while_expression] = STATE(1118),
    [sym__if_branch] = STATE(7163),
    [sym_if_expression] = STATE(1118),
    [sym_fun_expression] = STATE(1118),
    [sym_try_expression] = STATE(1118),
    [sym_match_expression] = STATE(1118),
    [sym_function_expression] = STATE(1118),
    [sym_mutate_expression] = STATE(1118),
    [sym_index_expression] = STATE(1118),
    [sym_typed_expression] = STATE(1118),
    [sym_declaration_expression] = STATE(1118),
    [sym_do_expression] = STATE(1118),
    [sym_list_expression] = STATE(1118),
    [sym_array_expression] = STATE(1118),
    [sym_begin_end_expression] = STATE(1118),
    [sym_paren_expression] = STATE(1118),
    [sym__high_prec_app] = STATE(1133),
    [sym__low_prec_app] = STATE(1133),
    [sym_application_expression] = STATE(1118),
    [sym_dot_expression] = STATE(1118),
    [sym_infix_expression] = STATE(1118),
    [sym_ce_expression] = STATE(1118),
    [sym_sequential_expression] = STATE(1118),
    [sym_char] = STATE(1080),
    [sym_format_string] = STATE(1090),
    [sym__string_literal] = STATE(1090),
    [sym_string] = STATE(1080),
    [sym_verbatim_string] = STATE(1080),
    [sym_bytearray] = STATE(1080),
    [sym_verbatim_bytearray] = STATE(1080),
    [sym_format_triple_quoted_string] = STATE(1096),
    [sym_triple_quoted_string] = STATE(1080),
    [sym_const] = STATE(1118),
    [sym_long_identifier] = STATE(1156),
    [sym_active_pattern] = STATE(1085),
    [sym__identifier_or_op] = STATE(1099),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(548),
    [sym_infix_op] = STATE(687),
    [sym_sbyte] = STATE(1080),
    [sym_byte] = STATE(1080),
    [sym_int16] = STATE(1080),
    [sym_uint16] = STATE(1080),
    [sym_int32] = STATE(1080),
    [sym_uint32] = STATE(1080),
    [sym_nativeint] = STATE(1080),
    [sym_unativeint] = STATE(1080),
    [sym_int64] = STATE(1080),
    [sym_uint64] = STATE(1080),
    [sym_ieee32] = STATE(1080),
    [sym_ieee64] = STATE(1080),
    [sym_bignum] = STATE(1080),
    [sym_decimal] = STATE(1080),
    [sym_float] = STATE(979),
    [sym_block_comment] = STATE(36),
    [sym_compiler_directive_decl] = STATE(36),
    [sym_fsi_directive_decl] = STATE(36),
    [sym_preproc_line] = STATE(36),
    [sym_preproc_if_in_expression] = STATE(1118),
    [aux_sym_sequential_expression_repeat1] = STATE(1558),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(195),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(197),
    [anon_sym_return] = ACTIONS(481),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_COMMA] = ACTIONS(483),
    [anon_sym_null] = ACTIONS(207),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(197),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(209),
    [anon_sym_RBRACK] = ACTIONS(597),
    [anon_sym_LBRACK_PIPE] = ACTIONS(211),
    [anon_sym_LBRACE] = ACTIONS(271),
    [anon_sym_LT_AT] = ACTIONS(213),
    [anon_sym_LT_AT_AT] = ACTIONS(215),
    [anon_sym_DOT] = ACTIONS(185),
    [anon_sym_LBRACE_PIPE] = ACTIONS(217),
    [anon_sym_new] = ACTIONS(481),
    [anon_sym_return_BANG] = ACTIONS(487),
    [anon_sym_yield] = ACTIONS(481),
    [anon_sym_yield_BANG] = ACTIONS(487),
    [anon_sym_lazy] = ACTIONS(481),
    [anon_sym_assert] = ACTIONS(481),
    [anon_sym_upcast] = ACTIONS(481),
    [anon_sym_downcast] = ACTIONS(481),
    [anon_sym_COLON_GT] = ACTIONS(221),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(221),
    [anon_sym_for] = ACTIONS(489),
    [anon_sym_while] = ACTIONS(225),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(229),
    [anon_sym_match] = ACTIONS(231),
    [anon_sym_match_BANG] = ACTIONS(233),
    [anon_sym_function] = ACTIONS(235),
    [anon_sym_LT_DASH] = ACTIONS(491),
    [anon_sym_DOT_LBRACK] = ACTIONS(187),
    [anon_sym_LT] = ACTIONS(189),
    [anon_sym_use] = ACTIONS(493),
    [anon_sym_use_BANG] = ACTIONS(495),
    [anon_sym_do_BANG] = ACTIONS(243),
    [anon_sym_begin] = ACTIONS(245),
    [anon_sym_LPAREN2] = ACTIONS(191),
    [anon_sym_DOT_DOT2] = ACTIONS(497),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(247),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(251),
    [anon_sym_AT_DQUOTE] = ACTIONS(253),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(255),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(257),
    [sym_bool] = ACTIONS(259),
    [sym_unit] = ACTIONS(193),
    [anon_sym_LPAREN_PIPE] = ACTIONS(261),
    [sym_op_identifier] = ACTIONS(263),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(499),
    [sym_xint] = ACTIONS(267),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(269),
    [sym__newline] = ACTIONS(501),
  },
  [37] = {
    [sym_function_or_value_defn] = STATE(535),
    [sym__expression] = STATE(98),
    [sym_literal_expression] = STATE(2008),
    [sym_long_identifier_or_op] = STATE(2008),
    [sym_tuple_expression] = STATE(2008),
    [sym_brace_expression] = STATE(2008),
    [sym_anon_record_expression] = STATE(2008),
    [sym_prefixed_expression] = STATE(2008),
    [sym_typecast_expression] = STATE(2008),
    [sym_for_expression] = STATE(2008),
    [sym_while_expression] = STATE(2008),
    [sym__if_branch] = STATE(6754),
    [sym_if_expression] = STATE(2008),
    [sym_fun_expression] = STATE(2008),
    [sym_try_expression] = STATE(2008),
    [sym_match_expression] = STATE(2008),
    [sym_function_expression] = STATE(2008),
    [sym_mutate_expression] = STATE(2008),
    [sym_index_expression] = STATE(2008),
    [sym_typed_expression] = STATE(2008),
    [sym_declaration_expression] = STATE(2008),
    [sym_do_expression] = STATE(2008),
    [sym_list_expression] = STATE(2008),
    [sym_array_expression] = STATE(2008),
    [sym_begin_end_expression] = STATE(2008),
    [sym_paren_expression] = STATE(2008),
    [sym__high_prec_app] = STATE(2007),
    [sym__low_prec_app] = STATE(2007),
    [sym_application_expression] = STATE(2008),
    [sym_dot_expression] = STATE(2008),
    [sym_infix_expression] = STATE(2008),
    [sym_ce_expression] = STATE(2008),
    [sym_sequential_expression] = STATE(2008),
    [sym_char] = STATE(1859),
    [sym_format_string] = STATE(1861),
    [sym__string_literal] = STATE(1861),
    [sym_string] = STATE(1859),
    [sym_verbatim_string] = STATE(1859),
    [sym_bytearray] = STATE(1859),
    [sym_verbatim_bytearray] = STATE(1859),
    [sym_format_triple_quoted_string] = STATE(1862),
    [sym_triple_quoted_string] = STATE(1859),
    [sym_const] = STATE(2008),
    [sym_long_identifier] = STATE(1701),
    [sym_active_pattern] = STATE(1702),
    [sym__identifier_or_op] = STATE(1724),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(664),
    [sym_infix_op] = STATE(543),
    [sym_sbyte] = STATE(1859),
    [sym_byte] = STATE(1859),
    [sym_int16] = STATE(1859),
    [sym_uint16] = STATE(1859),
    [sym_int32] = STATE(1859),
    [sym_uint32] = STATE(1859),
    [sym_nativeint] = STATE(1859),
    [sym_unativeint] = STATE(1859),
    [sym_int64] = STATE(1859),
    [sym_uint64] = STATE(1859),
    [sym_ieee32] = STATE(1859),
    [sym_ieee64] = STATE(1859),
    [sym_bignum] = STATE(1859),
    [sym_decimal] = STATE(1859),
    [sym_float] = STATE(1447),
    [sym_block_comment] = STATE(37),
    [sym_compiler_directive_decl] = STATE(37),
    [sym_fsi_directive_decl] = STATE(37),
    [sym_preproc_line] = STATE(37),
    [sym_preproc_if_in_expression] = STATE(2008),
    [aux_sym_sequential_expression_repeat1] = STATE(1490),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(503),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(505),
    [anon_sym_return] = ACTIONS(507),
    [anon_sym_do] = ACTIONS(599),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(511),
    [anon_sym_COMMA] = ACTIONS(513),
    [anon_sym_null] = ACTIONS(515),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(505),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(517),
    [anon_sym_LBRACK_PIPE] = ACTIONS(519),
    [anon_sym_LBRACE] = ACTIONS(169),
    [anon_sym_LT_AT] = ACTIONS(523),
    [anon_sym_LT_AT_AT] = ACTIONS(525),
    [anon_sym_DOT] = ACTIONS(527),
    [anon_sym_LBRACE_PIPE] = ACTIONS(529),
    [anon_sym_new] = ACTIONS(507),
    [anon_sym_return_BANG] = ACTIONS(531),
    [anon_sym_yield] = ACTIONS(507),
    [anon_sym_yield_BANG] = ACTIONS(531),
    [anon_sym_lazy] = ACTIONS(507),
    [anon_sym_assert] = ACTIONS(507),
    [anon_sym_upcast] = ACTIONS(507),
    [anon_sym_downcast] = ACTIONS(507),
    [anon_sym_COLON_GT] = ACTIONS(533),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(533),
    [anon_sym_for] = ACTIONS(535),
    [anon_sym_while] = ACTIONS(537),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(539),
    [anon_sym_DASH_GT] = ACTIONS(169),
    [anon_sym_try] = ACTIONS(543),
    [anon_sym_match] = ACTIONS(545),
    [anon_sym_match_BANG] = ACTIONS(547),
    [anon_sym_function] = ACTIONS(549),
    [anon_sym_LT_DASH] = ACTIONS(551),
    [anon_sym_DOT_LBRACK] = ACTIONS(553),
    [anon_sym_LT] = ACTIONS(555),
    [anon_sym_use] = ACTIONS(557),
    [anon_sym_use_BANG] = ACTIONS(559),
    [anon_sym_do_BANG] = ACTIONS(561),
    [anon_sym_DOT_DOT] = ACTIONS(167),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_LPAREN2] = ACTIONS(567),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(569),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(571),
    [anon_sym_DQUOTE] = ACTIONS(573),
    [anon_sym_AT_DQUOTE] = ACTIONS(575),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(577),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(579),
    [sym_bool] = ACTIONS(581),
    [sym_unit] = ACTIONS(583),
    [anon_sym_LPAREN_PIPE] = ACTIONS(585),
    [sym_op_identifier] = ACTIONS(587),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(589),
    [sym_xint] = ACTIONS(591),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(593),
    [sym__newline] = ACTIONS(167),
  },
  [38] = {
    [sym_function_or_value_defn] = STATE(627),
    [sym__expression] = STATE(17),
    [sym_literal_expression] = STATE(1118),
    [sym_long_identifier_or_op] = STATE(1118),
    [sym_tuple_expression] = STATE(1118),
    [sym_brace_expression] = STATE(1118),
    [sym_anon_record_expression] = STATE(1118),
    [sym_prefixed_expression] = STATE(1118),
    [sym_typecast_expression] = STATE(1118),
    [sym_for_expression] = STATE(1118),
    [sym_while_expression] = STATE(1118),
    [sym__if_branch] = STATE(7163),
    [sym_if_expression] = STATE(1118),
    [sym_fun_expression] = STATE(1118),
    [sym_try_expression] = STATE(1118),
    [sym_match_expression] = STATE(1118),
    [sym_function_expression] = STATE(1118),
    [sym_mutate_expression] = STATE(1118),
    [sym_index_expression] = STATE(1118),
    [sym_typed_expression] = STATE(1118),
    [sym_declaration_expression] = STATE(1118),
    [sym_do_expression] = STATE(1118),
    [sym_list_expression] = STATE(1118),
    [sym_array_expression] = STATE(1118),
    [sym_begin_end_expression] = STATE(1118),
    [sym_paren_expression] = STATE(1118),
    [sym__high_prec_app] = STATE(1133),
    [sym__low_prec_app] = STATE(1133),
    [sym_application_expression] = STATE(1118),
    [sym_dot_expression] = STATE(1118),
    [sym_infix_expression] = STATE(1118),
    [sym_ce_expression] = STATE(1118),
    [sym_sequential_expression] = STATE(1118),
    [sym_char] = STATE(1080),
    [sym_format_string] = STATE(1090),
    [sym__string_literal] = STATE(1090),
    [sym_string] = STATE(1080),
    [sym_verbatim_string] = STATE(1080),
    [sym_bytearray] = STATE(1080),
    [sym_verbatim_bytearray] = STATE(1080),
    [sym_format_triple_quoted_string] = STATE(1096),
    [sym_triple_quoted_string] = STATE(1080),
    [sym_const] = STATE(1118),
    [sym_long_identifier] = STATE(1156),
    [sym_active_pattern] = STATE(1085),
    [sym__identifier_or_op] = STATE(1099),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(517),
    [sym_infix_op] = STATE(487),
    [sym_sbyte] = STATE(1080),
    [sym_byte] = STATE(1080),
    [sym_int16] = STATE(1080),
    [sym_uint16] = STATE(1080),
    [sym_int32] = STATE(1080),
    [sym_uint32] = STATE(1080),
    [sym_nativeint] = STATE(1080),
    [sym_unativeint] = STATE(1080),
    [sym_int64] = STATE(1080),
    [sym_uint64] = STATE(1080),
    [sym_ieee32] = STATE(1080),
    [sym_ieee64] = STATE(1080),
    [sym_bignum] = STATE(1080),
    [sym_decimal] = STATE(1080),
    [sym_float] = STATE(979),
    [sym_block_comment] = STATE(38),
    [sym_compiler_directive_decl] = STATE(38),
    [sym_fsi_directive_decl] = STATE(38),
    [sym_preproc_line] = STATE(38),
    [sym_preproc_if_in_expression] = STATE(1118),
    [aux_sym_sequential_expression_repeat1] = STATE(1069),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(195),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(197),
    [anon_sym_return] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_COMMA] = ACTIONS(205),
    [anon_sym_null] = ACTIONS(207),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(197),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(209),
    [anon_sym_LBRACK_PIPE] = ACTIONS(211),
    [anon_sym_LBRACE] = ACTIONS(271),
    [anon_sym_LT_AT] = ACTIONS(213),
    [anon_sym_LT_AT_AT] = ACTIONS(215),
    [anon_sym_DOT] = ACTIONS(185),
    [anon_sym_LBRACE_PIPE] = ACTIONS(217),
    [anon_sym_new] = ACTIONS(199),
    [anon_sym_return_BANG] = ACTIONS(219),
    [anon_sym_yield] = ACTIONS(199),
    [anon_sym_yield_BANG] = ACTIONS(219),
    [anon_sym_lazy] = ACTIONS(199),
    [anon_sym_assert] = ACTIONS(199),
    [anon_sym_upcast] = ACTIONS(199),
    [anon_sym_downcast] = ACTIONS(199),
    [anon_sym_COLON_GT] = ACTIONS(221),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(221),
    [anon_sym_for] = ACTIONS(223),
    [anon_sym_to] = ACTIONS(601),
    [anon_sym_downto] = ACTIONS(601),
    [anon_sym_while] = ACTIONS(225),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(229),
    [anon_sym_match] = ACTIONS(231),
    [anon_sym_match_BANG] = ACTIONS(233),
    [anon_sym_function] = ACTIONS(235),
    [anon_sym_LT_DASH] = ACTIONS(237),
    [anon_sym_DOT_LBRACK] = ACTIONS(187),
    [anon_sym_LT] = ACTIONS(189),
    [anon_sym_use] = ACTIONS(239),
    [anon_sym_use_BANG] = ACTIONS(241),
    [anon_sym_do_BANG] = ACTIONS(243),
    [anon_sym_begin] = ACTIONS(245),
    [anon_sym_LPAREN2] = ACTIONS(191),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(247),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(251),
    [anon_sym_AT_DQUOTE] = ACTIONS(253),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(255),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(257),
    [sym_bool] = ACTIONS(259),
    [sym_unit] = ACTIONS(193),
    [anon_sym_LPAREN_PIPE] = ACTIONS(261),
    [sym_op_identifier] = ACTIONS(263),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(265),
    [sym_xint] = ACTIONS(267),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(269),
    [sym__newline] = ACTIONS(273),
  },
  [39] = {
    [sym_function_or_value_defn] = STATE(535),
    [sym__expression] = STATE(98),
    [sym_literal_expression] = STATE(2008),
    [sym_long_identifier_or_op] = STATE(2008),
    [sym_tuple_expression] = STATE(2008),
    [sym_brace_expression] = STATE(2008),
    [sym_anon_record_expression] = STATE(2008),
    [sym_prefixed_expression] = STATE(2008),
    [sym_typecast_expression] = STATE(2008),
    [sym_for_expression] = STATE(2008),
    [sym_while_expression] = STATE(2008),
    [sym__if_branch] = STATE(6754),
    [sym_if_expression] = STATE(2008),
    [sym_fun_expression] = STATE(2008),
    [sym_try_expression] = STATE(2008),
    [sym_match_expression] = STATE(2008),
    [sym_function_expression] = STATE(2008),
    [sym_mutate_expression] = STATE(2008),
    [sym_index_expression] = STATE(2008),
    [sym_typed_expression] = STATE(2008),
    [sym_declaration_expression] = STATE(2008),
    [sym_do_expression] = STATE(2008),
    [sym_list_expression] = STATE(2008),
    [sym_array_expression] = STATE(2008),
    [sym_begin_end_expression] = STATE(2008),
    [sym_paren_expression] = STATE(2008),
    [sym__high_prec_app] = STATE(2007),
    [sym__low_prec_app] = STATE(2007),
    [sym_application_expression] = STATE(2008),
    [sym_dot_expression] = STATE(2008),
    [sym_infix_expression] = STATE(2008),
    [sym_ce_expression] = STATE(2008),
    [sym_sequential_expression] = STATE(2008),
    [sym_char] = STATE(1859),
    [sym_format_string] = STATE(1861),
    [sym__string_literal] = STATE(1861),
    [sym_string] = STATE(1859),
    [sym_verbatim_string] = STATE(1859),
    [sym_bytearray] = STATE(1859),
    [sym_verbatim_bytearray] = STATE(1859),
    [sym_format_triple_quoted_string] = STATE(1862),
    [sym_triple_quoted_string] = STATE(1859),
    [sym_const] = STATE(2008),
    [sym_long_identifier] = STATE(1701),
    [sym_active_pattern] = STATE(1702),
    [sym__identifier_or_op] = STATE(1724),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(664),
    [sym_infix_op] = STATE(543),
    [sym_sbyte] = STATE(1859),
    [sym_byte] = STATE(1859),
    [sym_int16] = STATE(1859),
    [sym_uint16] = STATE(1859),
    [sym_int32] = STATE(1859),
    [sym_uint32] = STATE(1859),
    [sym_nativeint] = STATE(1859),
    [sym_unativeint] = STATE(1859),
    [sym_int64] = STATE(1859),
    [sym_uint64] = STATE(1859),
    [sym_ieee32] = STATE(1859),
    [sym_ieee64] = STATE(1859),
    [sym_bignum] = STATE(1859),
    [sym_decimal] = STATE(1859),
    [sym_float] = STATE(1447),
    [sym_block_comment] = STATE(39),
    [sym_compiler_directive_decl] = STATE(39),
    [sym_fsi_directive_decl] = STATE(39),
    [sym_preproc_line] = STATE(39),
    [sym_preproc_if_in_expression] = STATE(2008),
    [aux_sym_sequential_expression_repeat1] = STATE(1490),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(503),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(505),
    [anon_sym_return] = ACTIONS(507),
    [anon_sym_do] = ACTIONS(599),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(511),
    [anon_sym_COMMA] = ACTIONS(513),
    [anon_sym_null] = ACTIONS(515),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(505),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(517),
    [anon_sym_LBRACK_PIPE] = ACTIONS(519),
    [anon_sym_LBRACE] = ACTIONS(165),
    [anon_sym_LT_AT] = ACTIONS(523),
    [anon_sym_LT_AT_AT] = ACTIONS(525),
    [anon_sym_DOT] = ACTIONS(527),
    [anon_sym_LBRACE_PIPE] = ACTIONS(529),
    [anon_sym_new] = ACTIONS(507),
    [anon_sym_return_BANG] = ACTIONS(531),
    [anon_sym_yield] = ACTIONS(507),
    [anon_sym_yield_BANG] = ACTIONS(531),
    [anon_sym_lazy] = ACTIONS(507),
    [anon_sym_assert] = ACTIONS(507),
    [anon_sym_upcast] = ACTIONS(507),
    [anon_sym_downcast] = ACTIONS(507),
    [anon_sym_COLON_GT] = ACTIONS(533),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(533),
    [anon_sym_for] = ACTIONS(535),
    [anon_sym_while] = ACTIONS(537),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(539),
    [anon_sym_DASH_GT] = ACTIONS(165),
    [anon_sym_try] = ACTIONS(543),
    [anon_sym_match] = ACTIONS(545),
    [anon_sym_match_BANG] = ACTIONS(547),
    [anon_sym_function] = ACTIONS(549),
    [anon_sym_LT_DASH] = ACTIONS(551),
    [anon_sym_DOT_LBRACK] = ACTIONS(553),
    [anon_sym_LT] = ACTIONS(555),
    [anon_sym_use] = ACTIONS(557),
    [anon_sym_use_BANG] = ACTIONS(559),
    [anon_sym_do_BANG] = ACTIONS(561),
    [anon_sym_DOT_DOT] = ACTIONS(163),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_LPAREN2] = ACTIONS(567),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(569),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(571),
    [anon_sym_DQUOTE] = ACTIONS(573),
    [anon_sym_AT_DQUOTE] = ACTIONS(575),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(577),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(579),
    [sym_bool] = ACTIONS(581),
    [sym_unit] = ACTIONS(583),
    [anon_sym_LPAREN_PIPE] = ACTIONS(585),
    [sym_op_identifier] = ACTIONS(587),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(589),
    [sym_xint] = ACTIONS(591),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(593),
    [sym__newline] = ACTIONS(163),
  },
  [40] = {
    [sym_function_or_value_defn] = STATE(627),
    [sym__expression] = STATE(17),
    [sym_literal_expression] = STATE(1118),
    [sym_long_identifier_or_op] = STATE(1118),
    [sym_tuple_expression] = STATE(1118),
    [sym_brace_expression] = STATE(1118),
    [sym_anon_record_expression] = STATE(1118),
    [sym_prefixed_expression] = STATE(1118),
    [sym_typecast_expression] = STATE(1118),
    [sym_for_expression] = STATE(1118),
    [sym_while_expression] = STATE(1118),
    [sym__if_branch] = STATE(7163),
    [sym_if_expression] = STATE(1118),
    [sym_fun_expression] = STATE(1118),
    [sym_try_expression] = STATE(1118),
    [sym_match_expression] = STATE(1118),
    [sym_function_expression] = STATE(1118),
    [sym_mutate_expression] = STATE(1118),
    [sym_index_expression] = STATE(1118),
    [sym_typed_expression] = STATE(1118),
    [sym_declaration_expression] = STATE(1118),
    [sym_do_expression] = STATE(1118),
    [sym_list_expression] = STATE(1118),
    [sym_array_expression] = STATE(1118),
    [sym_begin_end_expression] = STATE(1118),
    [sym_paren_expression] = STATE(1118),
    [sym__high_prec_app] = STATE(1133),
    [sym__low_prec_app] = STATE(1133),
    [sym_application_expression] = STATE(1118),
    [sym_dot_expression] = STATE(1118),
    [sym_infix_expression] = STATE(1118),
    [sym_ce_expression] = STATE(1118),
    [sym_sequential_expression] = STATE(1118),
    [sym_char] = STATE(1080),
    [sym_format_string] = STATE(1090),
    [sym__string_literal] = STATE(1090),
    [sym_string] = STATE(1080),
    [sym_verbatim_string] = STATE(1080),
    [sym_bytearray] = STATE(1080),
    [sym_verbatim_bytearray] = STATE(1080),
    [sym_format_triple_quoted_string] = STATE(1096),
    [sym_triple_quoted_string] = STATE(1080),
    [sym_const] = STATE(1118),
    [sym_long_identifier] = STATE(1156),
    [sym_active_pattern] = STATE(1085),
    [sym__identifier_or_op] = STATE(1099),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(517),
    [sym_infix_op] = STATE(487),
    [sym_sbyte] = STATE(1080),
    [sym_byte] = STATE(1080),
    [sym_int16] = STATE(1080),
    [sym_uint16] = STATE(1080),
    [sym_int32] = STATE(1080),
    [sym_uint32] = STATE(1080),
    [sym_nativeint] = STATE(1080),
    [sym_unativeint] = STATE(1080),
    [sym_int64] = STATE(1080),
    [sym_uint64] = STATE(1080),
    [sym_ieee32] = STATE(1080),
    [sym_ieee64] = STATE(1080),
    [sym_bignum] = STATE(1080),
    [sym_decimal] = STATE(1080),
    [sym_float] = STATE(979),
    [sym_block_comment] = STATE(40),
    [sym_compiler_directive_decl] = STATE(40),
    [sym_fsi_directive_decl] = STATE(40),
    [sym_preproc_line] = STATE(40),
    [sym_preproc_if_in_expression] = STATE(1118),
    [aux_sym_sequential_expression_repeat1] = STATE(1069),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(195),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(197),
    [anon_sym_return] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_COMMA] = ACTIONS(205),
    [anon_sym_null] = ACTIONS(207),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(197),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(209),
    [anon_sym_LBRACK_PIPE] = ACTIONS(211),
    [anon_sym_LBRACE] = ACTIONS(271),
    [anon_sym_LT_AT] = ACTIONS(213),
    [anon_sym_LT_AT_AT] = ACTIONS(215),
    [anon_sym_DOT] = ACTIONS(185),
    [anon_sym_LBRACE_PIPE] = ACTIONS(217),
    [anon_sym_new] = ACTIONS(199),
    [anon_sym_return_BANG] = ACTIONS(219),
    [anon_sym_yield] = ACTIONS(199),
    [anon_sym_yield_BANG] = ACTIONS(219),
    [anon_sym_lazy] = ACTIONS(199),
    [anon_sym_assert] = ACTIONS(199),
    [anon_sym_upcast] = ACTIONS(199),
    [anon_sym_downcast] = ACTIONS(199),
    [anon_sym_COLON_GT] = ACTIONS(221),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(221),
    [anon_sym_for] = ACTIONS(223),
    [anon_sym_to] = ACTIONS(603),
    [anon_sym_downto] = ACTIONS(603),
    [anon_sym_while] = ACTIONS(225),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(229),
    [anon_sym_match] = ACTIONS(231),
    [anon_sym_match_BANG] = ACTIONS(233),
    [anon_sym_function] = ACTIONS(235),
    [anon_sym_LT_DASH] = ACTIONS(237),
    [anon_sym_DOT_LBRACK] = ACTIONS(187),
    [anon_sym_LT] = ACTIONS(189),
    [anon_sym_use] = ACTIONS(239),
    [anon_sym_use_BANG] = ACTIONS(241),
    [anon_sym_do_BANG] = ACTIONS(243),
    [anon_sym_begin] = ACTIONS(245),
    [anon_sym_LPAREN2] = ACTIONS(191),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(247),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(251),
    [anon_sym_AT_DQUOTE] = ACTIONS(253),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(255),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(257),
    [sym_bool] = ACTIONS(259),
    [sym_unit] = ACTIONS(193),
    [anon_sym_LPAREN_PIPE] = ACTIONS(261),
    [sym_op_identifier] = ACTIONS(263),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(265),
    [sym_xint] = ACTIONS(267),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(269),
    [sym__newline] = ACTIONS(273),
  },
  [41] = {
    [sym_function_or_value_defn] = STATE(535),
    [sym__expression] = STATE(98),
    [sym_literal_expression] = STATE(2008),
    [sym_long_identifier_or_op] = STATE(2008),
    [sym_tuple_expression] = STATE(2008),
    [sym_brace_expression] = STATE(2008),
    [sym_anon_record_expression] = STATE(2008),
    [sym_prefixed_expression] = STATE(2008),
    [sym_typecast_expression] = STATE(2008),
    [sym_for_expression] = STATE(2008),
    [sym_while_expression] = STATE(2008),
    [sym__if_branch] = STATE(6754),
    [sym_if_expression] = STATE(2008),
    [sym_fun_expression] = STATE(2008),
    [sym_try_expression] = STATE(2008),
    [sym_match_expression] = STATE(2008),
    [sym_function_expression] = STATE(2008),
    [sym_mutate_expression] = STATE(2008),
    [sym_index_expression] = STATE(2008),
    [sym_typed_expression] = STATE(2008),
    [sym_declaration_expression] = STATE(2008),
    [sym_do_expression] = STATE(2008),
    [sym_list_expression] = STATE(2008),
    [sym_array_expression] = STATE(2008),
    [sym_begin_end_expression] = STATE(2008),
    [sym_paren_expression] = STATE(2008),
    [sym__high_prec_app] = STATE(2007),
    [sym__low_prec_app] = STATE(2007),
    [sym_application_expression] = STATE(2008),
    [sym_dot_expression] = STATE(2008),
    [sym_infix_expression] = STATE(2008),
    [sym_ce_expression] = STATE(2008),
    [sym_sequential_expression] = STATE(2008),
    [sym_char] = STATE(1859),
    [sym_format_string] = STATE(1861),
    [sym__string_literal] = STATE(1861),
    [sym_string] = STATE(1859),
    [sym_verbatim_string] = STATE(1859),
    [sym_bytearray] = STATE(1859),
    [sym_verbatim_bytearray] = STATE(1859),
    [sym_format_triple_quoted_string] = STATE(1862),
    [sym_triple_quoted_string] = STATE(1859),
    [sym_const] = STATE(2008),
    [sym_long_identifier] = STATE(1701),
    [sym_active_pattern] = STATE(1702),
    [sym__identifier_or_op] = STATE(1724),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(664),
    [sym_infix_op] = STATE(543),
    [sym_sbyte] = STATE(1859),
    [sym_byte] = STATE(1859),
    [sym_int16] = STATE(1859),
    [sym_uint16] = STATE(1859),
    [sym_int32] = STATE(1859),
    [sym_uint32] = STATE(1859),
    [sym_nativeint] = STATE(1859),
    [sym_unativeint] = STATE(1859),
    [sym_int64] = STATE(1859),
    [sym_uint64] = STATE(1859),
    [sym_ieee32] = STATE(1859),
    [sym_ieee64] = STATE(1859),
    [sym_bignum] = STATE(1859),
    [sym_decimal] = STATE(1859),
    [sym_float] = STATE(1447),
    [sym_block_comment] = STATE(41),
    [sym_compiler_directive_decl] = STATE(41),
    [sym_fsi_directive_decl] = STATE(41),
    [sym_preproc_line] = STATE(41),
    [sym_preproc_if_in_expression] = STATE(2008),
    [aux_sym_sequential_expression_repeat1] = STATE(1490),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(503),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(505),
    [anon_sym_return] = ACTIONS(507),
    [anon_sym_do] = ACTIONS(599),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(511),
    [anon_sym_COMMA] = ACTIONS(513),
    [anon_sym_null] = ACTIONS(515),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(505),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(517),
    [anon_sym_LBRACK_PIPE] = ACTIONS(519),
    [anon_sym_LBRACE] = ACTIONS(521),
    [anon_sym_LT_AT] = ACTIONS(523),
    [anon_sym_LT_AT_AT] = ACTIONS(525),
    [anon_sym_DOT] = ACTIONS(527),
    [anon_sym_LBRACE_PIPE] = ACTIONS(529),
    [anon_sym_new] = ACTIONS(507),
    [anon_sym_return_BANG] = ACTIONS(531),
    [anon_sym_yield] = ACTIONS(507),
    [anon_sym_yield_BANG] = ACTIONS(531),
    [anon_sym_lazy] = ACTIONS(507),
    [anon_sym_assert] = ACTIONS(507),
    [anon_sym_upcast] = ACTIONS(507),
    [anon_sym_downcast] = ACTIONS(507),
    [anon_sym_COLON_GT] = ACTIONS(533),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(533),
    [anon_sym_for] = ACTIONS(535),
    [anon_sym_while] = ACTIONS(537),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(539),
    [anon_sym_DASH_GT] = ACTIONS(161),
    [anon_sym_try] = ACTIONS(543),
    [anon_sym_match] = ACTIONS(545),
    [anon_sym_match_BANG] = ACTIONS(547),
    [anon_sym_function] = ACTIONS(549),
    [anon_sym_LT_DASH] = ACTIONS(551),
    [anon_sym_DOT_LBRACK] = ACTIONS(553),
    [anon_sym_LT] = ACTIONS(555),
    [anon_sym_use] = ACTIONS(557),
    [anon_sym_use_BANG] = ACTIONS(559),
    [anon_sym_do_BANG] = ACTIONS(561),
    [anon_sym_DOT_DOT] = ACTIONS(159),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_LPAREN2] = ACTIONS(567),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(569),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(571),
    [anon_sym_DQUOTE] = ACTIONS(573),
    [anon_sym_AT_DQUOTE] = ACTIONS(575),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(577),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(579),
    [sym_bool] = ACTIONS(581),
    [sym_unit] = ACTIONS(583),
    [anon_sym_LPAREN_PIPE] = ACTIONS(585),
    [sym_op_identifier] = ACTIONS(587),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(589),
    [sym_xint] = ACTIONS(591),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(593),
    [sym__newline] = ACTIONS(595),
  },
  [42] = {
    [sym_function_or_value_defn] = STATE(627),
    [sym__expression] = STATE(17),
    [sym_literal_expression] = STATE(1118),
    [sym_long_identifier_or_op] = STATE(1118),
    [sym_tuple_expression] = STATE(1118),
    [sym_brace_expression] = STATE(1118),
    [sym_anon_record_expression] = STATE(1118),
    [sym_prefixed_expression] = STATE(1118),
    [sym_typecast_expression] = STATE(1118),
    [sym_for_expression] = STATE(1118),
    [sym_while_expression] = STATE(1118),
    [sym__if_branch] = STATE(7163),
    [sym_if_expression] = STATE(1118),
    [sym_fun_expression] = STATE(1118),
    [sym_try_expression] = STATE(1118),
    [sym_match_expression] = STATE(1118),
    [sym_function_expression] = STATE(1118),
    [sym_mutate_expression] = STATE(1118),
    [sym_index_expression] = STATE(1118),
    [sym_typed_expression] = STATE(1118),
    [sym_declaration_expression] = STATE(1118),
    [sym_do_expression] = STATE(1118),
    [sym_list_expression] = STATE(1118),
    [sym_array_expression] = STATE(1118),
    [sym_begin_end_expression] = STATE(1118),
    [sym_paren_expression] = STATE(1118),
    [sym__high_prec_app] = STATE(1133),
    [sym__low_prec_app] = STATE(1133),
    [sym_application_expression] = STATE(1118),
    [sym_dot_expression] = STATE(1118),
    [sym_infix_expression] = STATE(1118),
    [sym_ce_expression] = STATE(1118),
    [sym_sequential_expression] = STATE(1118),
    [sym_char] = STATE(1080),
    [sym_format_string] = STATE(1090),
    [sym__string_literal] = STATE(1090),
    [sym_string] = STATE(1080),
    [sym_verbatim_string] = STATE(1080),
    [sym_bytearray] = STATE(1080),
    [sym_verbatim_bytearray] = STATE(1080),
    [sym_format_triple_quoted_string] = STATE(1096),
    [sym_triple_quoted_string] = STATE(1080),
    [sym_const] = STATE(1118),
    [sym_long_identifier] = STATE(1156),
    [sym_active_pattern] = STATE(1085),
    [sym__identifier_or_op] = STATE(1099),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(517),
    [sym_infix_op] = STATE(487),
    [sym_sbyte] = STATE(1080),
    [sym_byte] = STATE(1080),
    [sym_int16] = STATE(1080),
    [sym_uint16] = STATE(1080),
    [sym_int32] = STATE(1080),
    [sym_uint32] = STATE(1080),
    [sym_nativeint] = STATE(1080),
    [sym_unativeint] = STATE(1080),
    [sym_int64] = STATE(1080),
    [sym_uint64] = STATE(1080),
    [sym_ieee32] = STATE(1080),
    [sym_ieee64] = STATE(1080),
    [sym_bignum] = STATE(1080),
    [sym_decimal] = STATE(1080),
    [sym_float] = STATE(979),
    [sym_block_comment] = STATE(42),
    [sym_compiler_directive_decl] = STATE(42),
    [sym_fsi_directive_decl] = STATE(42),
    [sym_preproc_line] = STATE(42),
    [sym_preproc_if_in_expression] = STATE(1118),
    [aux_sym_sequential_expression_repeat1] = STATE(1069),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(195),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(197),
    [anon_sym_return] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_COMMA] = ACTIONS(205),
    [anon_sym_null] = ACTIONS(207),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(197),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(209),
    [anon_sym_LBRACK_PIPE] = ACTIONS(211),
    [anon_sym_LBRACE] = ACTIONS(271),
    [anon_sym_LT_AT] = ACTIONS(213),
    [anon_sym_LT_AT_AT] = ACTIONS(215),
    [anon_sym_DOT] = ACTIONS(185),
    [anon_sym_LBRACE_PIPE] = ACTIONS(217),
    [anon_sym_new] = ACTIONS(199),
    [anon_sym_return_BANG] = ACTIONS(219),
    [anon_sym_yield] = ACTIONS(199),
    [anon_sym_yield_BANG] = ACTIONS(219),
    [anon_sym_lazy] = ACTIONS(199),
    [anon_sym_assert] = ACTIONS(199),
    [anon_sym_upcast] = ACTIONS(199),
    [anon_sym_downcast] = ACTIONS(199),
    [anon_sym_COLON_GT] = ACTIONS(221),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(221),
    [anon_sym_for] = ACTIONS(223),
    [anon_sym_to] = ACTIONS(605),
    [anon_sym_downto] = ACTIONS(605),
    [anon_sym_while] = ACTIONS(225),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(229),
    [anon_sym_match] = ACTIONS(231),
    [anon_sym_match_BANG] = ACTIONS(233),
    [anon_sym_function] = ACTIONS(235),
    [anon_sym_LT_DASH] = ACTIONS(237),
    [anon_sym_DOT_LBRACK] = ACTIONS(187),
    [anon_sym_LT] = ACTIONS(189),
    [anon_sym_use] = ACTIONS(239),
    [anon_sym_use_BANG] = ACTIONS(241),
    [anon_sym_do_BANG] = ACTIONS(243),
    [anon_sym_begin] = ACTIONS(245),
    [anon_sym_LPAREN2] = ACTIONS(191),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(247),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(251),
    [anon_sym_AT_DQUOTE] = ACTIONS(253),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(255),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(257),
    [sym_bool] = ACTIONS(259),
    [sym_unit] = ACTIONS(193),
    [anon_sym_LPAREN_PIPE] = ACTIONS(261),
    [sym_op_identifier] = ACTIONS(263),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(265),
    [sym_xint] = ACTIONS(267),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(269),
    [sym__newline] = ACTIONS(273),
  },
  [43] = {
    [sym_function_or_value_defn] = STATE(535),
    [sym__expression] = STATE(98),
    [sym_literal_expression] = STATE(2008),
    [sym_long_identifier_or_op] = STATE(2008),
    [sym_tuple_expression] = STATE(2008),
    [sym_brace_expression] = STATE(2008),
    [sym_anon_record_expression] = STATE(2008),
    [sym_prefixed_expression] = STATE(2008),
    [sym_typecast_expression] = STATE(2008),
    [sym_for_expression] = STATE(2008),
    [sym_while_expression] = STATE(2008),
    [sym__if_branch] = STATE(6754),
    [sym_if_expression] = STATE(2008),
    [sym_fun_expression] = STATE(2008),
    [sym_try_expression] = STATE(2008),
    [sym_match_expression] = STATE(2008),
    [sym_function_expression] = STATE(2008),
    [sym_mutate_expression] = STATE(2008),
    [sym_index_expression] = STATE(2008),
    [sym_typed_expression] = STATE(2008),
    [sym_declaration_expression] = STATE(2008),
    [sym_do_expression] = STATE(2008),
    [sym_list_expression] = STATE(2008),
    [sym_array_expression] = STATE(2008),
    [sym_begin_end_expression] = STATE(2008),
    [sym_paren_expression] = STATE(2008),
    [sym__high_prec_app] = STATE(2007),
    [sym__low_prec_app] = STATE(2007),
    [sym_application_expression] = STATE(2008),
    [sym_dot_expression] = STATE(2008),
    [sym_infix_expression] = STATE(2008),
    [sym_ce_expression] = STATE(2008),
    [sym_sequential_expression] = STATE(2008),
    [sym_char] = STATE(1859),
    [sym_format_string] = STATE(1861),
    [sym__string_literal] = STATE(1861),
    [sym_string] = STATE(1859),
    [sym_verbatim_string] = STATE(1859),
    [sym_bytearray] = STATE(1859),
    [sym_verbatim_bytearray] = STATE(1859),
    [sym_format_triple_quoted_string] = STATE(1862),
    [sym_triple_quoted_string] = STATE(1859),
    [sym_const] = STATE(2008),
    [sym_long_identifier] = STATE(1701),
    [sym_active_pattern] = STATE(1702),
    [sym__identifier_or_op] = STATE(1724),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(664),
    [sym_infix_op] = STATE(543),
    [sym_sbyte] = STATE(1859),
    [sym_byte] = STATE(1859),
    [sym_int16] = STATE(1859),
    [sym_uint16] = STATE(1859),
    [sym_int32] = STATE(1859),
    [sym_uint32] = STATE(1859),
    [sym_nativeint] = STATE(1859),
    [sym_unativeint] = STATE(1859),
    [sym_int64] = STATE(1859),
    [sym_uint64] = STATE(1859),
    [sym_ieee32] = STATE(1859),
    [sym_ieee64] = STATE(1859),
    [sym_bignum] = STATE(1859),
    [sym_decimal] = STATE(1859),
    [sym_float] = STATE(1447),
    [sym_block_comment] = STATE(43),
    [sym_compiler_directive_decl] = STATE(43),
    [sym_fsi_directive_decl] = STATE(43),
    [sym_preproc_line] = STATE(43),
    [sym_preproc_if_in_expression] = STATE(2008),
    [aux_sym_sequential_expression_repeat1] = STATE(1490),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(503),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(505),
    [anon_sym_return] = ACTIONS(507),
    [anon_sym_do] = ACTIONS(599),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(511),
    [anon_sym_COMMA] = ACTIONS(513),
    [anon_sym_null] = ACTIONS(515),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(505),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(517),
    [anon_sym_LBRACK_PIPE] = ACTIONS(519),
    [anon_sym_LBRACE] = ACTIONS(521),
    [anon_sym_LT_AT] = ACTIONS(523),
    [anon_sym_LT_AT_AT] = ACTIONS(525),
    [anon_sym_DOT] = ACTIONS(527),
    [anon_sym_LBRACE_PIPE] = ACTIONS(529),
    [anon_sym_new] = ACTIONS(507),
    [anon_sym_return_BANG] = ACTIONS(531),
    [anon_sym_yield] = ACTIONS(507),
    [anon_sym_yield_BANG] = ACTIONS(531),
    [anon_sym_lazy] = ACTIONS(507),
    [anon_sym_assert] = ACTIONS(507),
    [anon_sym_upcast] = ACTIONS(507),
    [anon_sym_downcast] = ACTIONS(507),
    [anon_sym_COLON_GT] = ACTIONS(533),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(533),
    [anon_sym_for] = ACTIONS(535),
    [anon_sym_while] = ACTIONS(537),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(539),
    [anon_sym_DASH_GT] = ACTIONS(151),
    [anon_sym_try] = ACTIONS(543),
    [anon_sym_match] = ACTIONS(545),
    [anon_sym_match_BANG] = ACTIONS(547),
    [anon_sym_function] = ACTIONS(549),
    [anon_sym_LT_DASH] = ACTIONS(551),
    [anon_sym_DOT_LBRACK] = ACTIONS(553),
    [anon_sym_LT] = ACTIONS(555),
    [anon_sym_use] = ACTIONS(557),
    [anon_sym_use_BANG] = ACTIONS(559),
    [anon_sym_do_BANG] = ACTIONS(561),
    [anon_sym_DOT_DOT] = ACTIONS(149),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_LPAREN2] = ACTIONS(567),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(569),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(571),
    [anon_sym_DQUOTE] = ACTIONS(573),
    [anon_sym_AT_DQUOTE] = ACTIONS(575),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(577),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(579),
    [sym_bool] = ACTIONS(581),
    [sym_unit] = ACTIONS(583),
    [anon_sym_LPAREN_PIPE] = ACTIONS(585),
    [sym_op_identifier] = ACTIONS(587),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(589),
    [sym_xint] = ACTIONS(591),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(593),
    [sym__newline] = ACTIONS(595),
  },
  [44] = {
    [sym_function_or_value_defn] = STATE(535),
    [sym__expression] = STATE(98),
    [sym_literal_expression] = STATE(2008),
    [sym_long_identifier_or_op] = STATE(2008),
    [sym_tuple_expression] = STATE(2008),
    [sym_brace_expression] = STATE(2008),
    [sym_anon_record_expression] = STATE(2008),
    [sym_prefixed_expression] = STATE(2008),
    [sym_typecast_expression] = STATE(2008),
    [sym_for_expression] = STATE(2008),
    [sym_while_expression] = STATE(2008),
    [sym__if_branch] = STATE(6754),
    [sym_if_expression] = STATE(2008),
    [sym_fun_expression] = STATE(2008),
    [sym_try_expression] = STATE(2008),
    [sym_match_expression] = STATE(2008),
    [sym_function_expression] = STATE(2008),
    [sym_mutate_expression] = STATE(2008),
    [sym_index_expression] = STATE(2008),
    [sym_typed_expression] = STATE(2008),
    [sym_declaration_expression] = STATE(2008),
    [sym_do_expression] = STATE(2008),
    [sym_list_expression] = STATE(2008),
    [sym_array_expression] = STATE(2008),
    [sym_begin_end_expression] = STATE(2008),
    [sym_paren_expression] = STATE(2008),
    [sym__high_prec_app] = STATE(2007),
    [sym__low_prec_app] = STATE(2007),
    [sym_application_expression] = STATE(2008),
    [sym_dot_expression] = STATE(2008),
    [sym_infix_expression] = STATE(2008),
    [sym_ce_expression] = STATE(2008),
    [sym_sequential_expression] = STATE(2008),
    [sym_char] = STATE(1859),
    [sym_format_string] = STATE(1861),
    [sym__string_literal] = STATE(1861),
    [sym_string] = STATE(1859),
    [sym_verbatim_string] = STATE(1859),
    [sym_bytearray] = STATE(1859),
    [sym_verbatim_bytearray] = STATE(1859),
    [sym_format_triple_quoted_string] = STATE(1862),
    [sym_triple_quoted_string] = STATE(1859),
    [sym_const] = STATE(2008),
    [sym_long_identifier] = STATE(1701),
    [sym_active_pattern] = STATE(1702),
    [sym__identifier_or_op] = STATE(1724),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(664),
    [sym_infix_op] = STATE(543),
    [sym_sbyte] = STATE(1859),
    [sym_byte] = STATE(1859),
    [sym_int16] = STATE(1859),
    [sym_uint16] = STATE(1859),
    [sym_int32] = STATE(1859),
    [sym_uint32] = STATE(1859),
    [sym_nativeint] = STATE(1859),
    [sym_unativeint] = STATE(1859),
    [sym_int64] = STATE(1859),
    [sym_uint64] = STATE(1859),
    [sym_ieee32] = STATE(1859),
    [sym_ieee64] = STATE(1859),
    [sym_bignum] = STATE(1859),
    [sym_decimal] = STATE(1859),
    [sym_float] = STATE(1447),
    [sym_block_comment] = STATE(44),
    [sym_compiler_directive_decl] = STATE(44),
    [sym_fsi_directive_decl] = STATE(44),
    [sym_preproc_line] = STATE(44),
    [sym_preproc_if_in_expression] = STATE(2008),
    [aux_sym_sequential_expression_repeat1] = STATE(1490),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(503),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(505),
    [anon_sym_return] = ACTIONS(507),
    [anon_sym_do] = ACTIONS(599),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(511),
    [anon_sym_COMMA] = ACTIONS(513),
    [anon_sym_null] = ACTIONS(515),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(505),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(517),
    [anon_sym_LBRACK_PIPE] = ACTIONS(519),
    [anon_sym_LBRACE] = ACTIONS(521),
    [anon_sym_LT_AT] = ACTIONS(523),
    [anon_sym_LT_AT_AT] = ACTIONS(525),
    [anon_sym_DOT] = ACTIONS(527),
    [anon_sym_LBRACE_PIPE] = ACTIONS(529),
    [anon_sym_new] = ACTIONS(507),
    [anon_sym_return_BANG] = ACTIONS(531),
    [anon_sym_yield] = ACTIONS(507),
    [anon_sym_yield_BANG] = ACTIONS(531),
    [anon_sym_lazy] = ACTIONS(507),
    [anon_sym_assert] = ACTIONS(507),
    [anon_sym_upcast] = ACTIONS(507),
    [anon_sym_downcast] = ACTIONS(507),
    [anon_sym_COLON_GT] = ACTIONS(533),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(533),
    [anon_sym_for] = ACTIONS(535),
    [anon_sym_while] = ACTIONS(537),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(539),
    [anon_sym_DASH_GT] = ACTIONS(147),
    [anon_sym_try] = ACTIONS(543),
    [anon_sym_match] = ACTIONS(545),
    [anon_sym_match_BANG] = ACTIONS(547),
    [anon_sym_function] = ACTIONS(549),
    [anon_sym_LT_DASH] = ACTIONS(551),
    [anon_sym_DOT_LBRACK] = ACTIONS(553),
    [anon_sym_LT] = ACTIONS(555),
    [anon_sym_use] = ACTIONS(557),
    [anon_sym_use_BANG] = ACTIONS(559),
    [anon_sym_do_BANG] = ACTIONS(561),
    [anon_sym_DOT_DOT] = ACTIONS(145),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_LPAREN2] = ACTIONS(567),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(569),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(571),
    [anon_sym_DQUOTE] = ACTIONS(573),
    [anon_sym_AT_DQUOTE] = ACTIONS(575),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(577),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(579),
    [sym_bool] = ACTIONS(581),
    [sym_unit] = ACTIONS(583),
    [anon_sym_LPAREN_PIPE] = ACTIONS(585),
    [sym_op_identifier] = ACTIONS(587),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(589),
    [sym_xint] = ACTIONS(591),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(593),
    [sym__newline] = ACTIONS(145),
  },
  [45] = {
    [sym_function_or_value_defn] = STATE(663),
    [sym__expression] = STATE(76),
    [sym_literal_expression] = STATE(1118),
    [sym_long_identifier_or_op] = STATE(1118),
    [sym_tuple_expression] = STATE(1118),
    [sym_brace_expression] = STATE(1118),
    [sym_anon_record_expression] = STATE(1118),
    [sym_prefixed_expression] = STATE(1118),
    [sym_typecast_expression] = STATE(1118),
    [sym_for_expression] = STATE(1118),
    [sym_while_expression] = STATE(1118),
    [sym__if_branch] = STATE(7163),
    [sym_if_expression] = STATE(1118),
    [sym_fun_expression] = STATE(1118),
    [sym_try_expression] = STATE(1118),
    [sym_match_expression] = STATE(1118),
    [sym_function_expression] = STATE(1118),
    [sym_mutate_expression] = STATE(1118),
    [sym_index_expression] = STATE(1118),
    [sym_typed_expression] = STATE(1118),
    [sym_declaration_expression] = STATE(1118),
    [sym_do_expression] = STATE(1118),
    [sym_list_expression] = STATE(1118),
    [sym_array_expression] = STATE(1118),
    [sym_begin_end_expression] = STATE(1118),
    [sym_paren_expression] = STATE(1118),
    [sym__high_prec_app] = STATE(1133),
    [sym__low_prec_app] = STATE(1133),
    [sym_application_expression] = STATE(1118),
    [sym_dot_expression] = STATE(1118),
    [sym_infix_expression] = STATE(1118),
    [sym_ce_expression] = STATE(1118),
    [sym_sequential_expression] = STATE(1118),
    [sym_char] = STATE(1080),
    [sym_format_string] = STATE(1090),
    [sym__string_literal] = STATE(1090),
    [sym_string] = STATE(1080),
    [sym_verbatim_string] = STATE(1080),
    [sym_bytearray] = STATE(1080),
    [sym_verbatim_bytearray] = STATE(1080),
    [sym_format_triple_quoted_string] = STATE(1096),
    [sym_triple_quoted_string] = STATE(1080),
    [sym_const] = STATE(1118),
    [sym_long_identifier] = STATE(1156),
    [sym_active_pattern] = STATE(1085),
    [sym__identifier_or_op] = STATE(1099),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(548),
    [sym_infix_op] = STATE(687),
    [sym_sbyte] = STATE(1080),
    [sym_byte] = STATE(1080),
    [sym_int16] = STATE(1080),
    [sym_uint16] = STATE(1080),
    [sym_int32] = STATE(1080),
    [sym_uint32] = STATE(1080),
    [sym_nativeint] = STATE(1080),
    [sym_unativeint] = STATE(1080),
    [sym_int64] = STATE(1080),
    [sym_uint64] = STATE(1080),
    [sym_ieee32] = STATE(1080),
    [sym_ieee64] = STATE(1080),
    [sym_bignum] = STATE(1080),
    [sym_decimal] = STATE(1080),
    [sym_float] = STATE(979),
    [sym_block_comment] = STATE(45),
    [sym_compiler_directive_decl] = STATE(45),
    [sym_fsi_directive_decl] = STATE(45),
    [sym_preproc_line] = STATE(45),
    [sym_preproc_if_in_expression] = STATE(1118),
    [aux_sym_sequential_expression_repeat1] = STATE(1558),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(195),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(197),
    [anon_sym_return] = ACTIONS(481),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_COMMA] = ACTIONS(483),
    [anon_sym_null] = ACTIONS(207),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(197),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(209),
    [anon_sym_RBRACK] = ACTIONS(607),
    [anon_sym_LBRACK_PIPE] = ACTIONS(211),
    [anon_sym_LBRACE] = ACTIONS(271),
    [anon_sym_LT_AT] = ACTIONS(213),
    [anon_sym_LT_AT_AT] = ACTIONS(215),
    [anon_sym_DOT] = ACTIONS(185),
    [anon_sym_LBRACE_PIPE] = ACTIONS(217),
    [anon_sym_new] = ACTIONS(481),
    [anon_sym_return_BANG] = ACTIONS(487),
    [anon_sym_yield] = ACTIONS(481),
    [anon_sym_yield_BANG] = ACTIONS(487),
    [anon_sym_lazy] = ACTIONS(481),
    [anon_sym_assert] = ACTIONS(481),
    [anon_sym_upcast] = ACTIONS(481),
    [anon_sym_downcast] = ACTIONS(481),
    [anon_sym_COLON_GT] = ACTIONS(221),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(221),
    [anon_sym_for] = ACTIONS(489),
    [anon_sym_while] = ACTIONS(225),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(229),
    [anon_sym_match] = ACTIONS(231),
    [anon_sym_match_BANG] = ACTIONS(233),
    [anon_sym_function] = ACTIONS(235),
    [anon_sym_LT_DASH] = ACTIONS(491),
    [anon_sym_DOT_LBRACK] = ACTIONS(187),
    [anon_sym_LT] = ACTIONS(189),
    [anon_sym_use] = ACTIONS(493),
    [anon_sym_use_BANG] = ACTIONS(495),
    [anon_sym_do_BANG] = ACTIONS(243),
    [anon_sym_begin] = ACTIONS(245),
    [anon_sym_LPAREN2] = ACTIONS(191),
    [anon_sym_DOT_DOT2] = ACTIONS(497),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(247),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(251),
    [anon_sym_AT_DQUOTE] = ACTIONS(253),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(255),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(257),
    [sym_bool] = ACTIONS(259),
    [sym_unit] = ACTIONS(193),
    [anon_sym_LPAREN_PIPE] = ACTIONS(261),
    [sym_op_identifier] = ACTIONS(263),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(499),
    [sym_xint] = ACTIONS(267),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(269),
    [sym__newline] = ACTIONS(501),
  },
  [46] = {
    [sym_function_or_value_defn] = STATE(729),
    [sym__expression] = STATE(59),
    [sym_literal_expression] = STATE(867),
    [sym_long_identifier_or_op] = STATE(867),
    [sym_tuple_expression] = STATE(867),
    [sym_brace_expression] = STATE(867),
    [sym_anon_record_expression] = STATE(867),
    [sym_prefixed_expression] = STATE(867),
    [sym_typecast_expression] = STATE(867),
    [sym_for_expression] = STATE(867),
    [sym_while_expression] = STATE(867),
    [sym__if_branch] = STATE(6511),
    [sym_if_expression] = STATE(867),
    [sym_fun_expression] = STATE(867),
    [sym_try_expression] = STATE(867),
    [sym_match_expression] = STATE(867),
    [sym_function_expression] = STATE(867),
    [sym_mutate_expression] = STATE(867),
    [sym_index_expression] = STATE(867),
    [sym_typed_expression] = STATE(867),
    [sym_declaration_expression] = STATE(867),
    [sym_do_expression] = STATE(867),
    [sym_list_expression] = STATE(867),
    [sym_array_expression] = STATE(867),
    [sym_begin_end_expression] = STATE(867),
    [sym_paren_expression] = STATE(867),
    [sym__high_prec_app] = STATE(864),
    [sym__low_prec_app] = STATE(864),
    [sym_application_expression] = STATE(867),
    [sym_dot_expression] = STATE(867),
    [sym_infix_expression] = STATE(867),
    [sym_ce_expression] = STATE(867),
    [sym_sequential_expression] = STATE(867),
    [sym_char] = STATE(868),
    [sym_format_string] = STATE(869),
    [sym__string_literal] = STATE(869),
    [sym_string] = STATE(868),
    [sym_verbatim_string] = STATE(868),
    [sym_bytearray] = STATE(868),
    [sym_verbatim_bytearray] = STATE(868),
    [sym_format_triple_quoted_string] = STATE(870),
    [sym_triple_quoted_string] = STATE(868),
    [sym_const] = STATE(867),
    [sym_long_identifier] = STATE(872),
    [sym_active_pattern] = STATE(871),
    [sym__identifier_or_op] = STATE(873),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(499),
    [sym_infix_op] = STATE(743),
    [sym_sbyte] = STATE(868),
    [sym_byte] = STATE(868),
    [sym_int16] = STATE(868),
    [sym_uint16] = STATE(868),
    [sym_int32] = STATE(868),
    [sym_uint32] = STATE(868),
    [sym_nativeint] = STATE(868),
    [sym_unativeint] = STATE(868),
    [sym_int64] = STATE(868),
    [sym_uint64] = STATE(868),
    [sym_ieee32] = STATE(868),
    [sym_ieee64] = STATE(868),
    [sym_bignum] = STATE(868),
    [sym_decimal] = STATE(868),
    [sym_float] = STATE(1368),
    [sym_block_comment] = STATE(46),
    [sym_compiler_directive_decl] = STATE(46),
    [sym_fsi_directive_decl] = STATE(46),
    [sym_preproc_line] = STATE(46),
    [sym_preproc_if_in_expression] = STATE(867),
    [aux_sym_sequential_expression_repeat1] = STATE(1578),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(29),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(369),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_COMMA] = ACTIONS(371),
    [anon_sym_null] = ACTIONS(49),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACK_PIPE] = ACTIONS(57),
    [anon_sym_LBRACE] = ACTIONS(139),
    [anon_sym_LT_AT] = ACTIONS(61),
    [anon_sym_LT_AT_AT] = ACTIONS(63),
    [anon_sym_DOT] = ACTIONS(65),
    [anon_sym_LBRACE_PIPE] = ACTIONS(67),
    [anon_sym_new] = ACTIONS(369),
    [anon_sym_return_BANG] = ACTIONS(373),
    [anon_sym_yield] = ACTIONS(369),
    [anon_sym_yield_BANG] = ACTIONS(373),
    [anon_sym_lazy] = ACTIONS(369),
    [anon_sym_assert] = ACTIONS(369),
    [anon_sym_upcast] = ACTIONS(369),
    [anon_sym_downcast] = ACTIONS(369),
    [anon_sym_COLON_GT] = ACTIONS(71),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(71),
    [anon_sym_for] = ACTIONS(375),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(79),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_match] = ACTIONS(83),
    [anon_sym_match_BANG] = ACTIONS(85),
    [anon_sym_function] = ACTIONS(87),
    [anon_sym_LT_DASH] = ACTIONS(377),
    [anon_sym_DOT_LBRACK] = ACTIONS(91),
    [anon_sym_LT] = ACTIONS(93),
    [anon_sym_use] = ACTIONS(379),
    [anon_sym_use_BANG] = ACTIONS(381),
    [anon_sym_do_BANG] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(101),
    [anon_sym_LPAREN2] = ACTIONS(103),
    [anon_sym_DOT_DOT2] = ACTIONS(171),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(105),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(107),
    [anon_sym_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DQUOTE] = ACTIONS(111),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(115),
    [sym_bool] = ACTIONS(117),
    [sym_unit] = ACTIONS(119),
    [anon_sym_LPAREN_PIPE] = ACTIONS(121),
    [sym_op_identifier] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(385),
    [sym_xint] = ACTIONS(387),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(135),
    [sym__newline] = ACTIONS(609),
    [sym__dedent] = ACTIONS(171),
  },
  [47] = {
    [sym_function_or_value_defn] = STATE(729),
    [sym__expression] = STATE(59),
    [sym_literal_expression] = STATE(867),
    [sym_long_identifier_or_op] = STATE(867),
    [sym_tuple_expression] = STATE(867),
    [sym_brace_expression] = STATE(867),
    [sym_anon_record_expression] = STATE(867),
    [sym_prefixed_expression] = STATE(867),
    [sym_typecast_expression] = STATE(867),
    [sym_for_expression] = STATE(867),
    [sym_while_expression] = STATE(867),
    [sym__if_branch] = STATE(6511),
    [sym_if_expression] = STATE(867),
    [sym_fun_expression] = STATE(867),
    [sym_try_expression] = STATE(867),
    [sym_match_expression] = STATE(867),
    [sym_function_expression] = STATE(867),
    [sym_mutate_expression] = STATE(867),
    [sym_index_expression] = STATE(867),
    [sym_typed_expression] = STATE(867),
    [sym_declaration_expression] = STATE(867),
    [sym_do_expression] = STATE(867),
    [sym_list_expression] = STATE(867),
    [sym_array_expression] = STATE(867),
    [sym_begin_end_expression] = STATE(867),
    [sym_paren_expression] = STATE(867),
    [sym__high_prec_app] = STATE(864),
    [sym__low_prec_app] = STATE(864),
    [sym_application_expression] = STATE(867),
    [sym_dot_expression] = STATE(867),
    [sym_infix_expression] = STATE(867),
    [sym_ce_expression] = STATE(867),
    [sym_sequential_expression] = STATE(867),
    [sym_char] = STATE(868),
    [sym_format_string] = STATE(869),
    [sym__string_literal] = STATE(869),
    [sym_string] = STATE(868),
    [sym_verbatim_string] = STATE(868),
    [sym_bytearray] = STATE(868),
    [sym_verbatim_bytearray] = STATE(868),
    [sym_format_triple_quoted_string] = STATE(870),
    [sym_triple_quoted_string] = STATE(868),
    [sym_const] = STATE(867),
    [sym_long_identifier] = STATE(872),
    [sym_active_pattern] = STATE(871),
    [sym__identifier_or_op] = STATE(873),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(499),
    [sym_infix_op] = STATE(743),
    [sym_sbyte] = STATE(868),
    [sym_byte] = STATE(868),
    [sym_int16] = STATE(868),
    [sym_uint16] = STATE(868),
    [sym_int32] = STATE(868),
    [sym_uint32] = STATE(868),
    [sym_nativeint] = STATE(868),
    [sym_unativeint] = STATE(868),
    [sym_int64] = STATE(868),
    [sym_uint64] = STATE(868),
    [sym_ieee32] = STATE(868),
    [sym_ieee64] = STATE(868),
    [sym_bignum] = STATE(868),
    [sym_decimal] = STATE(868),
    [sym_float] = STATE(1368),
    [sym_block_comment] = STATE(47),
    [sym_compiler_directive_decl] = STATE(47),
    [sym_fsi_directive_decl] = STATE(47),
    [sym_preproc_line] = STATE(47),
    [sym_preproc_if_in_expression] = STATE(867),
    [aux_sym_sequential_expression_repeat1] = STATE(1578),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(29),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(369),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_COMMA] = ACTIONS(371),
    [anon_sym_null] = ACTIONS(49),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACK_PIPE] = ACTIONS(57),
    [anon_sym_LBRACE] = ACTIONS(59),
    [anon_sym_LT_AT] = ACTIONS(61),
    [anon_sym_LT_AT_AT] = ACTIONS(63),
    [anon_sym_DOT] = ACTIONS(65),
    [anon_sym_LBRACE_PIPE] = ACTIONS(67),
    [anon_sym_new] = ACTIONS(369),
    [anon_sym_return_BANG] = ACTIONS(373),
    [anon_sym_yield] = ACTIONS(369),
    [anon_sym_yield_BANG] = ACTIONS(373),
    [anon_sym_lazy] = ACTIONS(369),
    [anon_sym_assert] = ACTIONS(369),
    [anon_sym_upcast] = ACTIONS(369),
    [anon_sym_downcast] = ACTIONS(369),
    [anon_sym_COLON_GT] = ACTIONS(71),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(71),
    [anon_sym_for] = ACTIONS(375),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(79),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_match] = ACTIONS(83),
    [anon_sym_match_BANG] = ACTIONS(85),
    [anon_sym_function] = ACTIONS(87),
    [anon_sym_LT_DASH] = ACTIONS(377),
    [anon_sym_DOT_LBRACK] = ACTIONS(91),
    [anon_sym_LT] = ACTIONS(93),
    [anon_sym_use] = ACTIONS(379),
    [anon_sym_use_BANG] = ACTIONS(381),
    [anon_sym_do_BANG] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(101),
    [anon_sym_LPAREN2] = ACTIONS(103),
    [anon_sym_DOT_DOT2] = ACTIONS(33),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(105),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(107),
    [anon_sym_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DQUOTE] = ACTIONS(111),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(115),
    [sym_bool] = ACTIONS(117),
    [sym_unit] = ACTIONS(119),
    [anon_sym_LPAREN_PIPE] = ACTIONS(121),
    [sym_op_identifier] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(385),
    [sym_xint] = ACTIONS(387),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(135),
    [sym__newline] = ACTIONS(33),
    [sym__dedent] = ACTIONS(33),
  },
  [48] = {
    [sym_function_or_value_defn] = STATE(627),
    [sym__expression] = STATE(17),
    [sym_literal_expression] = STATE(1118),
    [sym_long_identifier_or_op] = STATE(1118),
    [sym_tuple_expression] = STATE(1118),
    [sym_brace_expression] = STATE(1118),
    [sym_anon_record_expression] = STATE(1118),
    [sym_prefixed_expression] = STATE(1118),
    [sym_typecast_expression] = STATE(1118),
    [sym_for_expression] = STATE(1118),
    [sym_while_expression] = STATE(1118),
    [sym__if_branch] = STATE(7163),
    [sym_if_expression] = STATE(1118),
    [sym_fun_expression] = STATE(1118),
    [sym_try_expression] = STATE(1118),
    [sym_match_expression] = STATE(1118),
    [sym_function_expression] = STATE(1118),
    [sym_mutate_expression] = STATE(1118),
    [sym_index_expression] = STATE(1118),
    [sym_typed_expression] = STATE(1118),
    [sym_declaration_expression] = STATE(1118),
    [sym_do_expression] = STATE(1118),
    [sym_list_expression] = STATE(1118),
    [sym_array_expression] = STATE(1118),
    [sym_begin_end_expression] = STATE(1118),
    [sym_paren_expression] = STATE(1118),
    [sym__high_prec_app] = STATE(1133),
    [sym__low_prec_app] = STATE(1133),
    [sym_application_expression] = STATE(1118),
    [sym_dot_expression] = STATE(1118),
    [sym_infix_expression] = STATE(1118),
    [sym_ce_expression] = STATE(1118),
    [sym_sequential_expression] = STATE(1118),
    [sym_char] = STATE(1080),
    [sym_format_string] = STATE(1090),
    [sym__string_literal] = STATE(1090),
    [sym_string] = STATE(1080),
    [sym_verbatim_string] = STATE(1080),
    [sym_bytearray] = STATE(1080),
    [sym_verbatim_bytearray] = STATE(1080),
    [sym_format_triple_quoted_string] = STATE(1096),
    [sym_triple_quoted_string] = STATE(1080),
    [sym_const] = STATE(1118),
    [sym_long_identifier] = STATE(1156),
    [sym_active_pattern] = STATE(1085),
    [sym__identifier_or_op] = STATE(1099),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(517),
    [sym_infix_op] = STATE(487),
    [sym_sbyte] = STATE(1080),
    [sym_byte] = STATE(1080),
    [sym_int16] = STATE(1080),
    [sym_uint16] = STATE(1080),
    [sym_int32] = STATE(1080),
    [sym_uint32] = STATE(1080),
    [sym_nativeint] = STATE(1080),
    [sym_unativeint] = STATE(1080),
    [sym_int64] = STATE(1080),
    [sym_uint64] = STATE(1080),
    [sym_ieee32] = STATE(1080),
    [sym_ieee64] = STATE(1080),
    [sym_bignum] = STATE(1080),
    [sym_decimal] = STATE(1080),
    [sym_float] = STATE(979),
    [sym_block_comment] = STATE(48),
    [sym_compiler_directive_decl] = STATE(48),
    [sym_fsi_directive_decl] = STATE(48),
    [sym_preproc_line] = STATE(48),
    [sym_preproc_if_in_expression] = STATE(1118),
    [aux_sym_sequential_expression_repeat1] = STATE(1069),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(195),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(197),
    [anon_sym_return] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_COMMA] = ACTIONS(205),
    [anon_sym_null] = ACTIONS(207),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(197),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(209),
    [anon_sym_LBRACK_PIPE] = ACTIONS(211),
    [anon_sym_LBRACE] = ACTIONS(271),
    [anon_sym_LT_AT] = ACTIONS(213),
    [anon_sym_LT_AT_AT] = ACTIONS(215),
    [anon_sym_DOT] = ACTIONS(185),
    [anon_sym_LBRACE_PIPE] = ACTIONS(217),
    [anon_sym_new] = ACTIONS(199),
    [anon_sym_return_BANG] = ACTIONS(219),
    [anon_sym_yield] = ACTIONS(199),
    [anon_sym_yield_BANG] = ACTIONS(219),
    [anon_sym_lazy] = ACTIONS(199),
    [anon_sym_assert] = ACTIONS(199),
    [anon_sym_upcast] = ACTIONS(199),
    [anon_sym_downcast] = ACTIONS(199),
    [anon_sym_COLON_GT] = ACTIONS(221),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(221),
    [anon_sym_for] = ACTIONS(223),
    [anon_sym_to] = ACTIONS(611),
    [anon_sym_downto] = ACTIONS(611),
    [anon_sym_while] = ACTIONS(225),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(229),
    [anon_sym_match] = ACTIONS(231),
    [anon_sym_match_BANG] = ACTIONS(233),
    [anon_sym_function] = ACTIONS(235),
    [anon_sym_LT_DASH] = ACTIONS(237),
    [anon_sym_DOT_LBRACK] = ACTIONS(187),
    [anon_sym_LT] = ACTIONS(189),
    [anon_sym_use] = ACTIONS(239),
    [anon_sym_use_BANG] = ACTIONS(241),
    [anon_sym_do_BANG] = ACTIONS(243),
    [anon_sym_begin] = ACTIONS(245),
    [anon_sym_LPAREN2] = ACTIONS(191),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(247),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(251),
    [anon_sym_AT_DQUOTE] = ACTIONS(253),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(255),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(257),
    [sym_bool] = ACTIONS(259),
    [sym_unit] = ACTIONS(193),
    [anon_sym_LPAREN_PIPE] = ACTIONS(261),
    [sym_op_identifier] = ACTIONS(263),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(265),
    [sym_xint] = ACTIONS(267),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(269),
    [sym__newline] = ACTIONS(273),
  },
  [49] = {
    [sym_function_or_value_defn] = STATE(729),
    [sym__expression] = STATE(59),
    [sym_literal_expression] = STATE(867),
    [sym_long_identifier_or_op] = STATE(867),
    [sym_tuple_expression] = STATE(867),
    [sym_brace_expression] = STATE(867),
    [sym_anon_record_expression] = STATE(867),
    [sym_prefixed_expression] = STATE(867),
    [sym_typecast_expression] = STATE(867),
    [sym_for_expression] = STATE(867),
    [sym_while_expression] = STATE(867),
    [sym__if_branch] = STATE(6511),
    [sym_if_expression] = STATE(867),
    [sym_fun_expression] = STATE(867),
    [sym_try_expression] = STATE(867),
    [sym_match_expression] = STATE(867),
    [sym_function_expression] = STATE(867),
    [sym_mutate_expression] = STATE(867),
    [sym_index_expression] = STATE(867),
    [sym_typed_expression] = STATE(867),
    [sym_declaration_expression] = STATE(867),
    [sym_do_expression] = STATE(867),
    [sym_list_expression] = STATE(867),
    [sym_array_expression] = STATE(867),
    [sym_begin_end_expression] = STATE(867),
    [sym_paren_expression] = STATE(867),
    [sym__high_prec_app] = STATE(864),
    [sym__low_prec_app] = STATE(864),
    [sym_application_expression] = STATE(867),
    [sym_dot_expression] = STATE(867),
    [sym_infix_expression] = STATE(867),
    [sym_ce_expression] = STATE(867),
    [sym_sequential_expression] = STATE(867),
    [sym_char] = STATE(868),
    [sym_format_string] = STATE(869),
    [sym__string_literal] = STATE(869),
    [sym_string] = STATE(868),
    [sym_verbatim_string] = STATE(868),
    [sym_bytearray] = STATE(868),
    [sym_verbatim_bytearray] = STATE(868),
    [sym_format_triple_quoted_string] = STATE(870),
    [sym_triple_quoted_string] = STATE(868),
    [sym_const] = STATE(867),
    [sym_long_identifier] = STATE(872),
    [sym_active_pattern] = STATE(871),
    [sym__identifier_or_op] = STATE(873),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(499),
    [sym_infix_op] = STATE(743),
    [sym_sbyte] = STATE(868),
    [sym_byte] = STATE(868),
    [sym_int16] = STATE(868),
    [sym_uint16] = STATE(868),
    [sym_int32] = STATE(868),
    [sym_uint32] = STATE(868),
    [sym_nativeint] = STATE(868),
    [sym_unativeint] = STATE(868),
    [sym_int64] = STATE(868),
    [sym_uint64] = STATE(868),
    [sym_ieee32] = STATE(868),
    [sym_ieee64] = STATE(868),
    [sym_bignum] = STATE(868),
    [sym_decimal] = STATE(868),
    [sym_float] = STATE(1368),
    [sym_block_comment] = STATE(49),
    [sym_compiler_directive_decl] = STATE(49),
    [sym_fsi_directive_decl] = STATE(49),
    [sym_preproc_line] = STATE(49),
    [sym_preproc_if_in_expression] = STATE(867),
    [aux_sym_sequential_expression_repeat1] = STATE(1578),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(181),
    [anon_sym_EQ] = ACTIONS(183),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_return] = ACTIONS(181),
    [anon_sym_do] = ACTIONS(181),
    [anon_sym_let] = ACTIONS(181),
    [anon_sym_let_BANG] = ACTIONS(183),
    [anon_sym_LPAREN] = ACTIONS(181),
    [anon_sym_COMMA] = ACTIONS(183),
    [anon_sym_null] = ACTIONS(181),
    [anon_sym_QMARK] = ACTIONS(181),
    [anon_sym_COLON_QMARK] = ACTIONS(181),
    [anon_sym_COLON_COLON] = ACTIONS(183),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_LBRACK_PIPE] = ACTIONS(183),
    [anon_sym_LBRACE] = ACTIONS(181),
    [anon_sym_LT_AT] = ACTIONS(181),
    [anon_sym_LT_AT_AT] = ACTIONS(181),
    [anon_sym_DOT] = ACTIONS(65),
    [anon_sym_LBRACE_PIPE] = ACTIONS(183),
    [anon_sym_new] = ACTIONS(181),
    [anon_sym_return_BANG] = ACTIONS(183),
    [anon_sym_yield] = ACTIONS(181),
    [anon_sym_yield_BANG] = ACTIONS(183),
    [anon_sym_lazy] = ACTIONS(181),
    [anon_sym_assert] = ACTIONS(181),
    [anon_sym_upcast] = ACTIONS(181),
    [anon_sym_downcast] = ACTIONS(181),
    [anon_sym_COLON_GT] = ACTIONS(183),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(183),
    [anon_sym_for] = ACTIONS(181),
    [anon_sym_while] = ACTIONS(181),
    [anon_sym_if] = ACTIONS(181),
    [anon_sym_fun] = ACTIONS(181),
    [anon_sym_try] = ACTIONS(181),
    [anon_sym_match] = ACTIONS(181),
    [anon_sym_match_BANG] = ACTIONS(183),
    [anon_sym_function] = ACTIONS(181),
    [anon_sym_LT_DASH] = ACTIONS(181),
    [anon_sym_DOT_LBRACK] = ACTIONS(91),
    [anon_sym_LT] = ACTIONS(93),
    [anon_sym_use] = ACTIONS(181),
    [anon_sym_use_BANG] = ACTIONS(183),
    [anon_sym_do_BANG] = ACTIONS(183),
    [anon_sym_begin] = ACTIONS(181),
    [anon_sym_LPAREN2] = ACTIONS(103),
    [anon_sym_DOT_DOT2] = ACTIONS(183),
    [anon_sym_or] = ACTIONS(181),
    [aux_sym_char_token1] = ACTIONS(183),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(181),
    [anon_sym_DQUOTE] = ACTIONS(181),
    [anon_sym_AT_DQUOTE] = ACTIONS(183),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(183),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(183),
    [sym_bool] = ACTIONS(181),
    [sym_unit] = ACTIONS(119),
    [anon_sym_LPAREN_PIPE] = ACTIONS(181),
    [sym_op_identifier] = ACTIONS(181),
    [anon_sym_PLUS] = ACTIONS(181),
    [anon_sym_DASH] = ACTIONS(181),
    [anon_sym_PLUS_DOT] = ACTIONS(181),
    [anon_sym_DASH_DOT] = ACTIONS(181),
    [anon_sym_PERCENT] = ACTIONS(181),
    [anon_sym_AMP_AMP] = ACTIONS(181),
    [anon_sym_TILDE] = ACTIONS(183),
    [aux_sym_prefix_op_token1] = ACTIONS(181),
    [aux_sym_infix_op_token1] = ACTIONS(183),
    [aux_sym_infix_op_token2] = ACTIONS(181),
    [anon_sym_PIPE_PIPE] = ACTIONS(181),
    [anon_sym_BANG_EQ] = ACTIONS(181),
    [anon_sym_COLON_EQ] = ACTIONS(183),
    [anon_sym_DOLLAR] = ACTIONS(181),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(181),
    [sym_int] = ACTIONS(181),
    [sym_xint] = ACTIONS(183),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(183),
    [sym__newline] = ACTIONS(183),
    [sym__dedent] = ACTIONS(183),
  },
  [50] = {
    [sym_function_or_value_defn] = STATE(627),
    [sym__expression] = STATE(17),
    [sym_literal_expression] = STATE(1118),
    [sym_long_identifier_or_op] = STATE(1118),
    [sym_tuple_expression] = STATE(1118),
    [sym_brace_expression] = STATE(1118),
    [sym_anon_record_expression] = STATE(1118),
    [sym_prefixed_expression] = STATE(1118),
    [sym_typecast_expression] = STATE(1118),
    [sym_for_expression] = STATE(1118),
    [sym_while_expression] = STATE(1118),
    [sym__if_branch] = STATE(7163),
    [sym_if_expression] = STATE(1118),
    [sym_fun_expression] = STATE(1118),
    [sym_try_expression] = STATE(1118),
    [sym_match_expression] = STATE(1118),
    [sym_function_expression] = STATE(1118),
    [sym_mutate_expression] = STATE(1118),
    [sym_index_expression] = STATE(1118),
    [sym_typed_expression] = STATE(1118),
    [sym_declaration_expression] = STATE(1118),
    [sym_do_expression] = STATE(1118),
    [sym_list_expression] = STATE(1118),
    [sym_array_expression] = STATE(1118),
    [sym_begin_end_expression] = STATE(1118),
    [sym_paren_expression] = STATE(1118),
    [sym__high_prec_app] = STATE(1133),
    [sym__low_prec_app] = STATE(1133),
    [sym_application_expression] = STATE(1118),
    [sym_dot_expression] = STATE(1118),
    [sym_infix_expression] = STATE(1118),
    [sym_ce_expression] = STATE(1118),
    [sym_sequential_expression] = STATE(1118),
    [sym_char] = STATE(1080),
    [sym_format_string] = STATE(1090),
    [sym__string_literal] = STATE(1090),
    [sym_string] = STATE(1080),
    [sym_verbatim_string] = STATE(1080),
    [sym_bytearray] = STATE(1080),
    [sym_verbatim_bytearray] = STATE(1080),
    [sym_format_triple_quoted_string] = STATE(1096),
    [sym_triple_quoted_string] = STATE(1080),
    [sym_const] = STATE(1118),
    [sym_long_identifier] = STATE(1156),
    [sym_active_pattern] = STATE(1085),
    [sym__identifier_or_op] = STATE(1099),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(517),
    [sym_infix_op] = STATE(487),
    [sym_sbyte] = STATE(1080),
    [sym_byte] = STATE(1080),
    [sym_int16] = STATE(1080),
    [sym_uint16] = STATE(1080),
    [sym_int32] = STATE(1080),
    [sym_uint32] = STATE(1080),
    [sym_nativeint] = STATE(1080),
    [sym_unativeint] = STATE(1080),
    [sym_int64] = STATE(1080),
    [sym_uint64] = STATE(1080),
    [sym_ieee32] = STATE(1080),
    [sym_ieee64] = STATE(1080),
    [sym_bignum] = STATE(1080),
    [sym_decimal] = STATE(1080),
    [sym_float] = STATE(979),
    [sym_block_comment] = STATE(50),
    [sym_compiler_directive_decl] = STATE(50),
    [sym_fsi_directive_decl] = STATE(50),
    [sym_preproc_line] = STATE(50),
    [sym_preproc_if_in_expression] = STATE(1118),
    [aux_sym_sequential_expression_repeat1] = STATE(1069),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(195),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(197),
    [anon_sym_return] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_COMMA] = ACTIONS(205),
    [anon_sym_null] = ACTIONS(207),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(197),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(209),
    [anon_sym_LBRACK_PIPE] = ACTIONS(211),
    [anon_sym_LBRACE] = ACTIONS(271),
    [anon_sym_LT_AT] = ACTIONS(213),
    [anon_sym_LT_AT_AT] = ACTIONS(215),
    [anon_sym_DOT] = ACTIONS(185),
    [anon_sym_LBRACE_PIPE] = ACTIONS(217),
    [anon_sym_new] = ACTIONS(199),
    [anon_sym_return_BANG] = ACTIONS(219),
    [anon_sym_yield] = ACTIONS(199),
    [anon_sym_yield_BANG] = ACTIONS(219),
    [anon_sym_lazy] = ACTIONS(199),
    [anon_sym_assert] = ACTIONS(199),
    [anon_sym_upcast] = ACTIONS(199),
    [anon_sym_downcast] = ACTIONS(199),
    [anon_sym_COLON_GT] = ACTIONS(221),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(221),
    [anon_sym_for] = ACTIONS(223),
    [anon_sym_to] = ACTIONS(613),
    [anon_sym_downto] = ACTIONS(613),
    [anon_sym_while] = ACTIONS(225),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(229),
    [anon_sym_match] = ACTIONS(231),
    [anon_sym_match_BANG] = ACTIONS(233),
    [anon_sym_function] = ACTIONS(235),
    [anon_sym_LT_DASH] = ACTIONS(237),
    [anon_sym_DOT_LBRACK] = ACTIONS(187),
    [anon_sym_LT] = ACTIONS(189),
    [anon_sym_use] = ACTIONS(239),
    [anon_sym_use_BANG] = ACTIONS(241),
    [anon_sym_do_BANG] = ACTIONS(243),
    [anon_sym_begin] = ACTIONS(245),
    [anon_sym_LPAREN2] = ACTIONS(191),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(247),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(251),
    [anon_sym_AT_DQUOTE] = ACTIONS(253),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(255),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(257),
    [sym_bool] = ACTIONS(259),
    [sym_unit] = ACTIONS(193),
    [anon_sym_LPAREN_PIPE] = ACTIONS(261),
    [sym_op_identifier] = ACTIONS(263),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(265),
    [sym_xint] = ACTIONS(267),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(269),
    [sym__newline] = ACTIONS(273),
  },
  [51] = {
    [sym_function_or_value_defn] = STATE(729),
    [sym__expression] = STATE(59),
    [sym_literal_expression] = STATE(867),
    [sym_long_identifier_or_op] = STATE(867),
    [sym_tuple_expression] = STATE(867),
    [sym_brace_expression] = STATE(867),
    [sym_anon_record_expression] = STATE(867),
    [sym_prefixed_expression] = STATE(867),
    [sym_typecast_expression] = STATE(867),
    [sym_for_expression] = STATE(867),
    [sym_while_expression] = STATE(867),
    [sym__if_branch] = STATE(6511),
    [sym_if_expression] = STATE(867),
    [sym_fun_expression] = STATE(867),
    [sym_try_expression] = STATE(867),
    [sym_match_expression] = STATE(867),
    [sym_function_expression] = STATE(867),
    [sym_mutate_expression] = STATE(867),
    [sym_index_expression] = STATE(867),
    [sym_typed_expression] = STATE(867),
    [sym_declaration_expression] = STATE(867),
    [sym_do_expression] = STATE(867),
    [sym_list_expression] = STATE(867),
    [sym_array_expression] = STATE(867),
    [sym_begin_end_expression] = STATE(867),
    [sym_paren_expression] = STATE(867),
    [sym__high_prec_app] = STATE(864),
    [sym__low_prec_app] = STATE(864),
    [sym_application_expression] = STATE(867),
    [sym_dot_expression] = STATE(867),
    [sym_infix_expression] = STATE(867),
    [sym_ce_expression] = STATE(867),
    [sym_sequential_expression] = STATE(867),
    [sym_char] = STATE(868),
    [sym_format_string] = STATE(869),
    [sym__string_literal] = STATE(869),
    [sym_string] = STATE(868),
    [sym_verbatim_string] = STATE(868),
    [sym_bytearray] = STATE(868),
    [sym_verbatim_bytearray] = STATE(868),
    [sym_format_triple_quoted_string] = STATE(870),
    [sym_triple_quoted_string] = STATE(868),
    [sym_const] = STATE(867),
    [sym_long_identifier] = STATE(872),
    [sym_active_pattern] = STATE(871),
    [sym__identifier_or_op] = STATE(873),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(499),
    [sym_infix_op] = STATE(743),
    [sym_sbyte] = STATE(868),
    [sym_byte] = STATE(868),
    [sym_int16] = STATE(868),
    [sym_uint16] = STATE(868),
    [sym_int32] = STATE(868),
    [sym_uint32] = STATE(868),
    [sym_nativeint] = STATE(868),
    [sym_unativeint] = STATE(868),
    [sym_int64] = STATE(868),
    [sym_uint64] = STATE(868),
    [sym_ieee32] = STATE(868),
    [sym_ieee64] = STATE(868),
    [sym_bignum] = STATE(868),
    [sym_decimal] = STATE(868),
    [sym_float] = STATE(1368),
    [sym_block_comment] = STATE(51),
    [sym_compiler_directive_decl] = STATE(51),
    [sym_fsi_directive_decl] = STATE(51),
    [sym_preproc_line] = STATE(51),
    [sym_preproc_if_in_expression] = STATE(867),
    [aux_sym_sequential_expression_repeat1] = STATE(1578),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(29),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(369),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_COMMA] = ACTIONS(371),
    [anon_sym_null] = ACTIONS(49),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACK_PIPE] = ACTIONS(57),
    [anon_sym_LBRACE] = ACTIONS(169),
    [anon_sym_LT_AT] = ACTIONS(61),
    [anon_sym_LT_AT_AT] = ACTIONS(63),
    [anon_sym_DOT] = ACTIONS(65),
    [anon_sym_LBRACE_PIPE] = ACTIONS(67),
    [anon_sym_new] = ACTIONS(369),
    [anon_sym_return_BANG] = ACTIONS(373),
    [anon_sym_yield] = ACTIONS(369),
    [anon_sym_yield_BANG] = ACTIONS(373),
    [anon_sym_lazy] = ACTIONS(369),
    [anon_sym_assert] = ACTIONS(369),
    [anon_sym_upcast] = ACTIONS(369),
    [anon_sym_downcast] = ACTIONS(369),
    [anon_sym_COLON_GT] = ACTIONS(71),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(71),
    [anon_sym_for] = ACTIONS(375),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(79),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_match] = ACTIONS(83),
    [anon_sym_match_BANG] = ACTIONS(85),
    [anon_sym_function] = ACTIONS(87),
    [anon_sym_LT_DASH] = ACTIONS(377),
    [anon_sym_DOT_LBRACK] = ACTIONS(91),
    [anon_sym_LT] = ACTIONS(93),
    [anon_sym_use] = ACTIONS(379),
    [anon_sym_use_BANG] = ACTIONS(381),
    [anon_sym_do_BANG] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(101),
    [anon_sym_LPAREN2] = ACTIONS(103),
    [anon_sym_DOT_DOT2] = ACTIONS(167),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(105),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(107),
    [anon_sym_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DQUOTE] = ACTIONS(111),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(115),
    [sym_bool] = ACTIONS(117),
    [sym_unit] = ACTIONS(119),
    [anon_sym_LPAREN_PIPE] = ACTIONS(121),
    [sym_op_identifier] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(385),
    [sym_xint] = ACTIONS(387),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(135),
    [sym__newline] = ACTIONS(167),
    [sym__dedent] = ACTIONS(167),
  },
  [52] = {
    [sym_function_or_value_defn] = STATE(627),
    [sym__expression] = STATE(17),
    [sym_literal_expression] = STATE(1118),
    [sym_long_identifier_or_op] = STATE(1118),
    [sym_tuple_expression] = STATE(1118),
    [sym_brace_expression] = STATE(1118),
    [sym_anon_record_expression] = STATE(1118),
    [sym_prefixed_expression] = STATE(1118),
    [sym_typecast_expression] = STATE(1118),
    [sym_for_expression] = STATE(1118),
    [sym_while_expression] = STATE(1118),
    [sym__if_branch] = STATE(7163),
    [sym_if_expression] = STATE(1118),
    [sym_fun_expression] = STATE(1118),
    [sym_try_expression] = STATE(1118),
    [sym_match_expression] = STATE(1118),
    [sym_function_expression] = STATE(1118),
    [sym_mutate_expression] = STATE(1118),
    [sym_index_expression] = STATE(1118),
    [sym_typed_expression] = STATE(1118),
    [sym_declaration_expression] = STATE(1118),
    [sym_do_expression] = STATE(1118),
    [sym_list_expression] = STATE(1118),
    [sym_array_expression] = STATE(1118),
    [sym_begin_end_expression] = STATE(1118),
    [sym_paren_expression] = STATE(1118),
    [sym__high_prec_app] = STATE(1133),
    [sym__low_prec_app] = STATE(1133),
    [sym_application_expression] = STATE(1118),
    [sym_dot_expression] = STATE(1118),
    [sym_infix_expression] = STATE(1118),
    [sym_ce_expression] = STATE(1118),
    [sym_sequential_expression] = STATE(1118),
    [sym_char] = STATE(1080),
    [sym_format_string] = STATE(1090),
    [sym__string_literal] = STATE(1090),
    [sym_string] = STATE(1080),
    [sym_verbatim_string] = STATE(1080),
    [sym_bytearray] = STATE(1080),
    [sym_verbatim_bytearray] = STATE(1080),
    [sym_format_triple_quoted_string] = STATE(1096),
    [sym_triple_quoted_string] = STATE(1080),
    [sym_const] = STATE(1118),
    [sym_long_identifier] = STATE(1156),
    [sym_active_pattern] = STATE(1085),
    [sym__identifier_or_op] = STATE(1099),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(517),
    [sym_infix_op] = STATE(487),
    [sym_sbyte] = STATE(1080),
    [sym_byte] = STATE(1080),
    [sym_int16] = STATE(1080),
    [sym_uint16] = STATE(1080),
    [sym_int32] = STATE(1080),
    [sym_uint32] = STATE(1080),
    [sym_nativeint] = STATE(1080),
    [sym_unativeint] = STATE(1080),
    [sym_int64] = STATE(1080),
    [sym_uint64] = STATE(1080),
    [sym_ieee32] = STATE(1080),
    [sym_ieee64] = STATE(1080),
    [sym_bignum] = STATE(1080),
    [sym_decimal] = STATE(1080),
    [sym_float] = STATE(979),
    [sym_block_comment] = STATE(52),
    [sym_compiler_directive_decl] = STATE(52),
    [sym_fsi_directive_decl] = STATE(52),
    [sym_preproc_line] = STATE(52),
    [sym_preproc_if_in_expression] = STATE(1118),
    [aux_sym_sequential_expression_repeat1] = STATE(1069),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(195),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(197),
    [anon_sym_return] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_COMMA] = ACTIONS(205),
    [anon_sym_null] = ACTIONS(207),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(197),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(209),
    [anon_sym_LBRACK_PIPE] = ACTIONS(211),
    [anon_sym_LBRACE] = ACTIONS(271),
    [anon_sym_LT_AT] = ACTIONS(213),
    [anon_sym_LT_AT_AT] = ACTIONS(215),
    [anon_sym_DOT] = ACTIONS(185),
    [anon_sym_LBRACE_PIPE] = ACTIONS(217),
    [anon_sym_new] = ACTIONS(199),
    [anon_sym_return_BANG] = ACTIONS(219),
    [anon_sym_yield] = ACTIONS(199),
    [anon_sym_yield_BANG] = ACTIONS(219),
    [anon_sym_lazy] = ACTIONS(199),
    [anon_sym_assert] = ACTIONS(199),
    [anon_sym_upcast] = ACTIONS(199),
    [anon_sym_downcast] = ACTIONS(199),
    [anon_sym_COLON_GT] = ACTIONS(221),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(221),
    [anon_sym_for] = ACTIONS(223),
    [anon_sym_to] = ACTIONS(615),
    [anon_sym_downto] = ACTIONS(615),
    [anon_sym_while] = ACTIONS(225),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(229),
    [anon_sym_match] = ACTIONS(231),
    [anon_sym_match_BANG] = ACTIONS(233),
    [anon_sym_function] = ACTIONS(235),
    [anon_sym_LT_DASH] = ACTIONS(237),
    [anon_sym_DOT_LBRACK] = ACTIONS(187),
    [anon_sym_LT] = ACTIONS(189),
    [anon_sym_use] = ACTIONS(239),
    [anon_sym_use_BANG] = ACTIONS(241),
    [anon_sym_do_BANG] = ACTIONS(243),
    [anon_sym_begin] = ACTIONS(245),
    [anon_sym_LPAREN2] = ACTIONS(191),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(247),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(251),
    [anon_sym_AT_DQUOTE] = ACTIONS(253),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(255),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(257),
    [sym_bool] = ACTIONS(259),
    [sym_unit] = ACTIONS(193),
    [anon_sym_LPAREN_PIPE] = ACTIONS(261),
    [sym_op_identifier] = ACTIONS(263),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(265),
    [sym_xint] = ACTIONS(267),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(269),
    [sym__newline] = ACTIONS(273),
  },
  [53] = {
    [sym_function_or_value_defn] = STATE(729),
    [sym__expression] = STATE(59),
    [sym_literal_expression] = STATE(867),
    [sym_long_identifier_or_op] = STATE(867),
    [sym_tuple_expression] = STATE(867),
    [sym_brace_expression] = STATE(867),
    [sym_anon_record_expression] = STATE(867),
    [sym_prefixed_expression] = STATE(867),
    [sym_typecast_expression] = STATE(867),
    [sym_for_expression] = STATE(867),
    [sym_while_expression] = STATE(867),
    [sym__if_branch] = STATE(6511),
    [sym_if_expression] = STATE(867),
    [sym_fun_expression] = STATE(867),
    [sym_try_expression] = STATE(867),
    [sym_match_expression] = STATE(867),
    [sym_function_expression] = STATE(867),
    [sym_mutate_expression] = STATE(867),
    [sym_index_expression] = STATE(867),
    [sym_typed_expression] = STATE(867),
    [sym_declaration_expression] = STATE(867),
    [sym_do_expression] = STATE(867),
    [sym_list_expression] = STATE(867),
    [sym_array_expression] = STATE(867),
    [sym_begin_end_expression] = STATE(867),
    [sym_paren_expression] = STATE(867),
    [sym__high_prec_app] = STATE(864),
    [sym__low_prec_app] = STATE(864),
    [sym_application_expression] = STATE(867),
    [sym_dot_expression] = STATE(867),
    [sym_infix_expression] = STATE(867),
    [sym_ce_expression] = STATE(867),
    [sym_sequential_expression] = STATE(867),
    [sym_char] = STATE(868),
    [sym_format_string] = STATE(869),
    [sym__string_literal] = STATE(869),
    [sym_string] = STATE(868),
    [sym_verbatim_string] = STATE(868),
    [sym_bytearray] = STATE(868),
    [sym_verbatim_bytearray] = STATE(868),
    [sym_format_triple_quoted_string] = STATE(870),
    [sym_triple_quoted_string] = STATE(868),
    [sym_const] = STATE(867),
    [sym_long_identifier] = STATE(872),
    [sym_active_pattern] = STATE(871),
    [sym__identifier_or_op] = STATE(873),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(499),
    [sym_infix_op] = STATE(743),
    [sym_sbyte] = STATE(868),
    [sym_byte] = STATE(868),
    [sym_int16] = STATE(868),
    [sym_uint16] = STATE(868),
    [sym_int32] = STATE(868),
    [sym_uint32] = STATE(868),
    [sym_nativeint] = STATE(868),
    [sym_unativeint] = STATE(868),
    [sym_int64] = STATE(868),
    [sym_uint64] = STATE(868),
    [sym_ieee32] = STATE(868),
    [sym_ieee64] = STATE(868),
    [sym_bignum] = STATE(868),
    [sym_decimal] = STATE(868),
    [sym_float] = STATE(1368),
    [sym_block_comment] = STATE(53),
    [sym_compiler_directive_decl] = STATE(53),
    [sym_fsi_directive_decl] = STATE(53),
    [sym_preproc_line] = STATE(53),
    [sym_preproc_if_in_expression] = STATE(867),
    [aux_sym_sequential_expression_repeat1] = STATE(1578),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(29),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(369),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_COMMA] = ACTIONS(371),
    [anon_sym_null] = ACTIONS(49),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACK_PIPE] = ACTIONS(57),
    [anon_sym_LBRACE] = ACTIONS(165),
    [anon_sym_LT_AT] = ACTIONS(61),
    [anon_sym_LT_AT_AT] = ACTIONS(63),
    [anon_sym_DOT] = ACTIONS(65),
    [anon_sym_LBRACE_PIPE] = ACTIONS(67),
    [anon_sym_new] = ACTIONS(369),
    [anon_sym_return_BANG] = ACTIONS(373),
    [anon_sym_yield] = ACTIONS(369),
    [anon_sym_yield_BANG] = ACTIONS(373),
    [anon_sym_lazy] = ACTIONS(369),
    [anon_sym_assert] = ACTIONS(369),
    [anon_sym_upcast] = ACTIONS(369),
    [anon_sym_downcast] = ACTIONS(369),
    [anon_sym_COLON_GT] = ACTIONS(71),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(71),
    [anon_sym_for] = ACTIONS(375),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(79),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_match] = ACTIONS(83),
    [anon_sym_match_BANG] = ACTIONS(85),
    [anon_sym_function] = ACTIONS(87),
    [anon_sym_LT_DASH] = ACTIONS(377),
    [anon_sym_DOT_LBRACK] = ACTIONS(91),
    [anon_sym_LT] = ACTIONS(93),
    [anon_sym_use] = ACTIONS(379),
    [anon_sym_use_BANG] = ACTIONS(381),
    [anon_sym_do_BANG] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(101),
    [anon_sym_LPAREN2] = ACTIONS(103),
    [anon_sym_DOT_DOT2] = ACTIONS(163),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(105),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(107),
    [anon_sym_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DQUOTE] = ACTIONS(111),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(115),
    [sym_bool] = ACTIONS(117),
    [sym_unit] = ACTIONS(119),
    [anon_sym_LPAREN_PIPE] = ACTIONS(121),
    [sym_op_identifier] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(385),
    [sym_xint] = ACTIONS(387),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(135),
    [sym__newline] = ACTIONS(163),
    [sym__dedent] = ACTIONS(163),
  },
  [54] = {
    [sym_function_or_value_defn] = STATE(627),
    [sym__expression] = STATE(17),
    [sym_literal_expression] = STATE(1118),
    [sym_long_identifier_or_op] = STATE(1118),
    [sym_tuple_expression] = STATE(1118),
    [sym_brace_expression] = STATE(1118),
    [sym_anon_record_expression] = STATE(1118),
    [sym_prefixed_expression] = STATE(1118),
    [sym_typecast_expression] = STATE(1118),
    [sym_for_expression] = STATE(1118),
    [sym_while_expression] = STATE(1118),
    [sym__if_branch] = STATE(7163),
    [sym_if_expression] = STATE(1118),
    [sym_fun_expression] = STATE(1118),
    [sym_try_expression] = STATE(1118),
    [sym_match_expression] = STATE(1118),
    [sym_function_expression] = STATE(1118),
    [sym_mutate_expression] = STATE(1118),
    [sym_index_expression] = STATE(1118),
    [sym_typed_expression] = STATE(1118),
    [sym_declaration_expression] = STATE(1118),
    [sym_do_expression] = STATE(1118),
    [sym_list_expression] = STATE(1118),
    [sym_array_expression] = STATE(1118),
    [sym_begin_end_expression] = STATE(1118),
    [sym_paren_expression] = STATE(1118),
    [sym__high_prec_app] = STATE(1133),
    [sym__low_prec_app] = STATE(1133),
    [sym_application_expression] = STATE(1118),
    [sym_dot_expression] = STATE(1118),
    [sym_infix_expression] = STATE(1118),
    [sym_ce_expression] = STATE(1118),
    [sym_sequential_expression] = STATE(1118),
    [sym_char] = STATE(1080),
    [sym_format_string] = STATE(1090),
    [sym__string_literal] = STATE(1090),
    [sym_string] = STATE(1080),
    [sym_verbatim_string] = STATE(1080),
    [sym_bytearray] = STATE(1080),
    [sym_verbatim_bytearray] = STATE(1080),
    [sym_format_triple_quoted_string] = STATE(1096),
    [sym_triple_quoted_string] = STATE(1080),
    [sym_const] = STATE(1118),
    [sym_long_identifier] = STATE(1156),
    [sym_active_pattern] = STATE(1085),
    [sym__identifier_or_op] = STATE(1099),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(517),
    [sym_infix_op] = STATE(487),
    [sym_sbyte] = STATE(1080),
    [sym_byte] = STATE(1080),
    [sym_int16] = STATE(1080),
    [sym_uint16] = STATE(1080),
    [sym_int32] = STATE(1080),
    [sym_uint32] = STATE(1080),
    [sym_nativeint] = STATE(1080),
    [sym_unativeint] = STATE(1080),
    [sym_int64] = STATE(1080),
    [sym_uint64] = STATE(1080),
    [sym_ieee32] = STATE(1080),
    [sym_ieee64] = STATE(1080),
    [sym_bignum] = STATE(1080),
    [sym_decimal] = STATE(1080),
    [sym_float] = STATE(979),
    [sym_block_comment] = STATE(54),
    [sym_compiler_directive_decl] = STATE(54),
    [sym_fsi_directive_decl] = STATE(54),
    [sym_preproc_line] = STATE(54),
    [sym_preproc_if_in_expression] = STATE(1118),
    [aux_sym_sequential_expression_repeat1] = STATE(1069),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(195),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(197),
    [anon_sym_return] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_COMMA] = ACTIONS(205),
    [anon_sym_null] = ACTIONS(207),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(197),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(209),
    [anon_sym_LBRACK_PIPE] = ACTIONS(211),
    [anon_sym_LBRACE] = ACTIONS(271),
    [anon_sym_LT_AT] = ACTIONS(213),
    [anon_sym_LT_AT_AT] = ACTIONS(215),
    [anon_sym_DOT] = ACTIONS(185),
    [anon_sym_LBRACE_PIPE] = ACTIONS(217),
    [anon_sym_new] = ACTIONS(199),
    [anon_sym_return_BANG] = ACTIONS(219),
    [anon_sym_yield] = ACTIONS(199),
    [anon_sym_yield_BANG] = ACTIONS(219),
    [anon_sym_lazy] = ACTIONS(199),
    [anon_sym_assert] = ACTIONS(199),
    [anon_sym_upcast] = ACTIONS(199),
    [anon_sym_downcast] = ACTIONS(199),
    [anon_sym_COLON_GT] = ACTIONS(221),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(221),
    [anon_sym_for] = ACTIONS(223),
    [anon_sym_to] = ACTIONS(617),
    [anon_sym_downto] = ACTIONS(617),
    [anon_sym_while] = ACTIONS(225),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(229),
    [anon_sym_match] = ACTIONS(231),
    [anon_sym_match_BANG] = ACTIONS(233),
    [anon_sym_function] = ACTIONS(235),
    [anon_sym_LT_DASH] = ACTIONS(237),
    [anon_sym_DOT_LBRACK] = ACTIONS(187),
    [anon_sym_LT] = ACTIONS(189),
    [anon_sym_use] = ACTIONS(239),
    [anon_sym_use_BANG] = ACTIONS(241),
    [anon_sym_do_BANG] = ACTIONS(243),
    [anon_sym_begin] = ACTIONS(245),
    [anon_sym_LPAREN2] = ACTIONS(191),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(247),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(251),
    [anon_sym_AT_DQUOTE] = ACTIONS(253),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(255),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(257),
    [sym_bool] = ACTIONS(259),
    [sym_unit] = ACTIONS(193),
    [anon_sym_LPAREN_PIPE] = ACTIONS(261),
    [sym_op_identifier] = ACTIONS(263),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(265),
    [sym_xint] = ACTIONS(267),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(269),
    [sym__newline] = ACTIONS(273),
  },
  [55] = {
    [sym_function_or_value_defn] = STATE(663),
    [sym__expression] = STATE(76),
    [sym_literal_expression] = STATE(1118),
    [sym_long_identifier_or_op] = STATE(1118),
    [sym_tuple_expression] = STATE(1118),
    [sym_brace_expression] = STATE(1118),
    [sym_anon_record_expression] = STATE(1118),
    [sym_prefixed_expression] = STATE(1118),
    [sym_typecast_expression] = STATE(1118),
    [sym_for_expression] = STATE(1118),
    [sym_while_expression] = STATE(1118),
    [sym__if_branch] = STATE(7163),
    [sym_if_expression] = STATE(1118),
    [sym_fun_expression] = STATE(1118),
    [sym_try_expression] = STATE(1118),
    [sym_match_expression] = STATE(1118),
    [sym_function_expression] = STATE(1118),
    [sym_mutate_expression] = STATE(1118),
    [sym_index_expression] = STATE(1118),
    [sym_typed_expression] = STATE(1118),
    [sym_declaration_expression] = STATE(1118),
    [sym_do_expression] = STATE(1118),
    [sym_list_expression] = STATE(1118),
    [sym_array_expression] = STATE(1118),
    [sym_begin_end_expression] = STATE(1118),
    [sym_paren_expression] = STATE(1118),
    [sym__high_prec_app] = STATE(1133),
    [sym__low_prec_app] = STATE(1133),
    [sym_application_expression] = STATE(1118),
    [sym_dot_expression] = STATE(1118),
    [sym_infix_expression] = STATE(1118),
    [sym_ce_expression] = STATE(1118),
    [sym_sequential_expression] = STATE(1118),
    [sym_char] = STATE(1080),
    [sym_format_string] = STATE(1090),
    [sym__string_literal] = STATE(1090),
    [sym_string] = STATE(1080),
    [sym_verbatim_string] = STATE(1080),
    [sym_bytearray] = STATE(1080),
    [sym_verbatim_bytearray] = STATE(1080),
    [sym_format_triple_quoted_string] = STATE(1096),
    [sym_triple_quoted_string] = STATE(1080),
    [sym_const] = STATE(1118),
    [sym_long_identifier] = STATE(1156),
    [sym_active_pattern] = STATE(1085),
    [sym__identifier_or_op] = STATE(1099),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(548),
    [sym_infix_op] = STATE(687),
    [sym_sbyte] = STATE(1080),
    [sym_byte] = STATE(1080),
    [sym_int16] = STATE(1080),
    [sym_uint16] = STATE(1080),
    [sym_int32] = STATE(1080),
    [sym_uint32] = STATE(1080),
    [sym_nativeint] = STATE(1080),
    [sym_unativeint] = STATE(1080),
    [sym_int64] = STATE(1080),
    [sym_uint64] = STATE(1080),
    [sym_ieee32] = STATE(1080),
    [sym_ieee64] = STATE(1080),
    [sym_bignum] = STATE(1080),
    [sym_decimal] = STATE(1080),
    [sym_float] = STATE(979),
    [sym_block_comment] = STATE(55),
    [sym_compiler_directive_decl] = STATE(55),
    [sym_fsi_directive_decl] = STATE(55),
    [sym_preproc_line] = STATE(55),
    [sym_preproc_if_in_expression] = STATE(1118),
    [aux_sym_sequential_expression_repeat1] = STATE(1558),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(195),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(197),
    [anon_sym_return] = ACTIONS(481),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_COMMA] = ACTIONS(483),
    [anon_sym_null] = ACTIONS(207),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(197),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(209),
    [anon_sym_RBRACK] = ACTIONS(619),
    [anon_sym_LBRACK_PIPE] = ACTIONS(211),
    [anon_sym_LBRACE] = ACTIONS(271),
    [anon_sym_LT_AT] = ACTIONS(213),
    [anon_sym_LT_AT_AT] = ACTIONS(215),
    [anon_sym_DOT] = ACTIONS(185),
    [anon_sym_LBRACE_PIPE] = ACTIONS(217),
    [anon_sym_new] = ACTIONS(481),
    [anon_sym_return_BANG] = ACTIONS(487),
    [anon_sym_yield] = ACTIONS(481),
    [anon_sym_yield_BANG] = ACTIONS(487),
    [anon_sym_lazy] = ACTIONS(481),
    [anon_sym_assert] = ACTIONS(481),
    [anon_sym_upcast] = ACTIONS(481),
    [anon_sym_downcast] = ACTIONS(481),
    [anon_sym_COLON_GT] = ACTIONS(221),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(221),
    [anon_sym_for] = ACTIONS(489),
    [anon_sym_while] = ACTIONS(225),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(229),
    [anon_sym_match] = ACTIONS(231),
    [anon_sym_match_BANG] = ACTIONS(233),
    [anon_sym_function] = ACTIONS(235),
    [anon_sym_LT_DASH] = ACTIONS(491),
    [anon_sym_DOT_LBRACK] = ACTIONS(187),
    [anon_sym_LT] = ACTIONS(189),
    [anon_sym_use] = ACTIONS(493),
    [anon_sym_use_BANG] = ACTIONS(495),
    [anon_sym_do_BANG] = ACTIONS(243),
    [anon_sym_begin] = ACTIONS(245),
    [anon_sym_LPAREN2] = ACTIONS(191),
    [anon_sym_DOT_DOT2] = ACTIONS(497),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(247),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(251),
    [anon_sym_AT_DQUOTE] = ACTIONS(253),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(255),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(257),
    [sym_bool] = ACTIONS(259),
    [sym_unit] = ACTIONS(193),
    [anon_sym_LPAREN_PIPE] = ACTIONS(261),
    [sym_op_identifier] = ACTIONS(263),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(499),
    [sym_xint] = ACTIONS(267),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(269),
    [sym__newline] = ACTIONS(501),
  },
  [56] = {
    [sym_function_or_value_defn] = STATE(627),
    [sym__expression] = STATE(17),
    [sym_literal_expression] = STATE(1118),
    [sym_long_identifier_or_op] = STATE(1118),
    [sym_tuple_expression] = STATE(1118),
    [sym_brace_expression] = STATE(1118),
    [sym_anon_record_expression] = STATE(1118),
    [sym_prefixed_expression] = STATE(1118),
    [sym_typecast_expression] = STATE(1118),
    [sym_for_expression] = STATE(1118),
    [sym_while_expression] = STATE(1118),
    [sym__if_branch] = STATE(7163),
    [sym_if_expression] = STATE(1118),
    [sym_fun_expression] = STATE(1118),
    [sym_try_expression] = STATE(1118),
    [sym_match_expression] = STATE(1118),
    [sym_function_expression] = STATE(1118),
    [sym_mutate_expression] = STATE(1118),
    [sym_index_expression] = STATE(1118),
    [sym_typed_expression] = STATE(1118),
    [sym_declaration_expression] = STATE(1118),
    [sym_do_expression] = STATE(1118),
    [sym_list_expression] = STATE(1118),
    [sym_array_expression] = STATE(1118),
    [sym_begin_end_expression] = STATE(1118),
    [sym_paren_expression] = STATE(1118),
    [sym__high_prec_app] = STATE(1133),
    [sym__low_prec_app] = STATE(1133),
    [sym_application_expression] = STATE(1118),
    [sym_dot_expression] = STATE(1118),
    [sym_infix_expression] = STATE(1118),
    [sym_ce_expression] = STATE(1118),
    [sym_sequential_expression] = STATE(1118),
    [sym_char] = STATE(1080),
    [sym_format_string] = STATE(1090),
    [sym__string_literal] = STATE(1090),
    [sym_string] = STATE(1080),
    [sym_verbatim_string] = STATE(1080),
    [sym_bytearray] = STATE(1080),
    [sym_verbatim_bytearray] = STATE(1080),
    [sym_format_triple_quoted_string] = STATE(1096),
    [sym_triple_quoted_string] = STATE(1080),
    [sym_const] = STATE(1118),
    [sym_long_identifier] = STATE(1156),
    [sym_active_pattern] = STATE(1085),
    [sym__identifier_or_op] = STATE(1099),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(517),
    [sym_infix_op] = STATE(487),
    [sym_sbyte] = STATE(1080),
    [sym_byte] = STATE(1080),
    [sym_int16] = STATE(1080),
    [sym_uint16] = STATE(1080),
    [sym_int32] = STATE(1080),
    [sym_uint32] = STATE(1080),
    [sym_nativeint] = STATE(1080),
    [sym_unativeint] = STATE(1080),
    [sym_int64] = STATE(1080),
    [sym_uint64] = STATE(1080),
    [sym_ieee32] = STATE(1080),
    [sym_ieee64] = STATE(1080),
    [sym_bignum] = STATE(1080),
    [sym_decimal] = STATE(1080),
    [sym_float] = STATE(979),
    [sym_block_comment] = STATE(56),
    [sym_compiler_directive_decl] = STATE(56),
    [sym_fsi_directive_decl] = STATE(56),
    [sym_preproc_line] = STATE(56),
    [sym_preproc_if_in_expression] = STATE(1118),
    [aux_sym_sequential_expression_repeat1] = STATE(1069),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(195),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(197),
    [anon_sym_return] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_COMMA] = ACTIONS(205),
    [anon_sym_null] = ACTIONS(207),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(197),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(209),
    [anon_sym_LBRACK_PIPE] = ACTIONS(211),
    [anon_sym_LBRACE] = ACTIONS(271),
    [anon_sym_LT_AT] = ACTIONS(213),
    [anon_sym_LT_AT_AT] = ACTIONS(215),
    [anon_sym_DOT] = ACTIONS(185),
    [anon_sym_LBRACE_PIPE] = ACTIONS(217),
    [anon_sym_new] = ACTIONS(199),
    [anon_sym_return_BANG] = ACTIONS(219),
    [anon_sym_yield] = ACTIONS(199),
    [anon_sym_yield_BANG] = ACTIONS(219),
    [anon_sym_lazy] = ACTIONS(199),
    [anon_sym_assert] = ACTIONS(199),
    [anon_sym_upcast] = ACTIONS(199),
    [anon_sym_downcast] = ACTIONS(199),
    [anon_sym_COLON_GT] = ACTIONS(221),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(221),
    [anon_sym_for] = ACTIONS(223),
    [anon_sym_to] = ACTIONS(621),
    [anon_sym_downto] = ACTIONS(621),
    [anon_sym_while] = ACTIONS(225),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(229),
    [anon_sym_match] = ACTIONS(231),
    [anon_sym_match_BANG] = ACTIONS(233),
    [anon_sym_function] = ACTIONS(235),
    [anon_sym_LT_DASH] = ACTIONS(237),
    [anon_sym_DOT_LBRACK] = ACTIONS(187),
    [anon_sym_LT] = ACTIONS(189),
    [anon_sym_use] = ACTIONS(239),
    [anon_sym_use_BANG] = ACTIONS(241),
    [anon_sym_do_BANG] = ACTIONS(243),
    [anon_sym_begin] = ACTIONS(245),
    [anon_sym_LPAREN2] = ACTIONS(191),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(247),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(251),
    [anon_sym_AT_DQUOTE] = ACTIONS(253),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(255),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(257),
    [sym_bool] = ACTIONS(259),
    [sym_unit] = ACTIONS(193),
    [anon_sym_LPAREN_PIPE] = ACTIONS(261),
    [sym_op_identifier] = ACTIONS(263),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(265),
    [sym_xint] = ACTIONS(267),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(269),
    [sym__newline] = ACTIONS(273),
  },
  [57] = {
    [sym_function_or_value_defn] = STATE(729),
    [sym__expression] = STATE(59),
    [sym_literal_expression] = STATE(867),
    [sym_long_identifier_or_op] = STATE(867),
    [sym_tuple_expression] = STATE(867),
    [sym_brace_expression] = STATE(867),
    [sym_anon_record_expression] = STATE(867),
    [sym_prefixed_expression] = STATE(867),
    [sym_typecast_expression] = STATE(867),
    [sym_for_expression] = STATE(867),
    [sym_while_expression] = STATE(867),
    [sym__if_branch] = STATE(6511),
    [sym_if_expression] = STATE(867),
    [sym_fun_expression] = STATE(867),
    [sym_try_expression] = STATE(867),
    [sym_match_expression] = STATE(867),
    [sym_function_expression] = STATE(867),
    [sym_mutate_expression] = STATE(867),
    [sym_index_expression] = STATE(867),
    [sym_typed_expression] = STATE(867),
    [sym_declaration_expression] = STATE(867),
    [sym_do_expression] = STATE(867),
    [sym_list_expression] = STATE(867),
    [sym_array_expression] = STATE(867),
    [sym_begin_end_expression] = STATE(867),
    [sym_paren_expression] = STATE(867),
    [sym__high_prec_app] = STATE(864),
    [sym__low_prec_app] = STATE(864),
    [sym_application_expression] = STATE(867),
    [sym_dot_expression] = STATE(867),
    [sym_infix_expression] = STATE(867),
    [sym_ce_expression] = STATE(867),
    [sym_sequential_expression] = STATE(867),
    [sym_char] = STATE(868),
    [sym_format_string] = STATE(869),
    [sym__string_literal] = STATE(869),
    [sym_string] = STATE(868),
    [sym_verbatim_string] = STATE(868),
    [sym_bytearray] = STATE(868),
    [sym_verbatim_bytearray] = STATE(868),
    [sym_format_triple_quoted_string] = STATE(870),
    [sym_triple_quoted_string] = STATE(868),
    [sym_const] = STATE(867),
    [sym_long_identifier] = STATE(872),
    [sym_active_pattern] = STATE(871),
    [sym__identifier_or_op] = STATE(873),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(499),
    [sym_infix_op] = STATE(743),
    [sym_sbyte] = STATE(868),
    [sym_byte] = STATE(868),
    [sym_int16] = STATE(868),
    [sym_uint16] = STATE(868),
    [sym_int32] = STATE(868),
    [sym_uint32] = STATE(868),
    [sym_nativeint] = STATE(868),
    [sym_unativeint] = STATE(868),
    [sym_int64] = STATE(868),
    [sym_uint64] = STATE(868),
    [sym_ieee32] = STATE(868),
    [sym_ieee64] = STATE(868),
    [sym_bignum] = STATE(868),
    [sym_decimal] = STATE(868),
    [sym_float] = STATE(1368),
    [sym_block_comment] = STATE(57),
    [sym_compiler_directive_decl] = STATE(57),
    [sym_fsi_directive_decl] = STATE(57),
    [sym_preproc_line] = STATE(57),
    [sym_preproc_if_in_expression] = STATE(867),
    [aux_sym_sequential_expression_repeat1] = STATE(1578),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(29),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(369),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_COMMA] = ACTIONS(371),
    [anon_sym_null] = ACTIONS(49),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACK_PIPE] = ACTIONS(57),
    [anon_sym_LBRACE] = ACTIONS(139),
    [anon_sym_LT_AT] = ACTIONS(61),
    [anon_sym_LT_AT_AT] = ACTIONS(63),
    [anon_sym_DOT] = ACTIONS(65),
    [anon_sym_LBRACE_PIPE] = ACTIONS(67),
    [anon_sym_new] = ACTIONS(369),
    [anon_sym_return_BANG] = ACTIONS(373),
    [anon_sym_yield] = ACTIONS(369),
    [anon_sym_yield_BANG] = ACTIONS(373),
    [anon_sym_lazy] = ACTIONS(369),
    [anon_sym_assert] = ACTIONS(369),
    [anon_sym_upcast] = ACTIONS(369),
    [anon_sym_downcast] = ACTIONS(369),
    [anon_sym_COLON_GT] = ACTIONS(71),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(71),
    [anon_sym_for] = ACTIONS(375),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(79),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_match] = ACTIONS(83),
    [anon_sym_match_BANG] = ACTIONS(85),
    [anon_sym_function] = ACTIONS(87),
    [anon_sym_LT_DASH] = ACTIONS(377),
    [anon_sym_DOT_LBRACK] = ACTIONS(91),
    [anon_sym_LT] = ACTIONS(93),
    [anon_sym_use] = ACTIONS(379),
    [anon_sym_use_BANG] = ACTIONS(381),
    [anon_sym_do_BANG] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(101),
    [anon_sym_LPAREN2] = ACTIONS(103),
    [anon_sym_DOT_DOT2] = ACTIONS(159),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(105),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(107),
    [anon_sym_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DQUOTE] = ACTIONS(111),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(115),
    [sym_bool] = ACTIONS(117),
    [sym_unit] = ACTIONS(119),
    [anon_sym_LPAREN_PIPE] = ACTIONS(121),
    [sym_op_identifier] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(385),
    [sym_xint] = ACTIONS(387),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(135),
    [sym__newline] = ACTIONS(609),
    [sym__dedent] = ACTIONS(159),
  },
  [58] = {
    [sym_function_or_value_defn] = STATE(627),
    [sym__expression] = STATE(17),
    [sym_literal_expression] = STATE(1118),
    [sym_long_identifier_or_op] = STATE(1118),
    [sym_tuple_expression] = STATE(1118),
    [sym_brace_expression] = STATE(1118),
    [sym_anon_record_expression] = STATE(1118),
    [sym_prefixed_expression] = STATE(1118),
    [sym_typecast_expression] = STATE(1118),
    [sym_for_expression] = STATE(1118),
    [sym_while_expression] = STATE(1118),
    [sym__if_branch] = STATE(7163),
    [sym_if_expression] = STATE(1118),
    [sym_fun_expression] = STATE(1118),
    [sym_try_expression] = STATE(1118),
    [sym_match_expression] = STATE(1118),
    [sym_function_expression] = STATE(1118),
    [sym_mutate_expression] = STATE(1118),
    [sym_index_expression] = STATE(1118),
    [sym_typed_expression] = STATE(1118),
    [sym_declaration_expression] = STATE(1118),
    [sym_do_expression] = STATE(1118),
    [sym_list_expression] = STATE(1118),
    [sym_array_expression] = STATE(1118),
    [sym_begin_end_expression] = STATE(1118),
    [sym_paren_expression] = STATE(1118),
    [sym__high_prec_app] = STATE(1133),
    [sym__low_prec_app] = STATE(1133),
    [sym_application_expression] = STATE(1118),
    [sym_dot_expression] = STATE(1118),
    [sym_infix_expression] = STATE(1118),
    [sym_ce_expression] = STATE(1118),
    [sym_sequential_expression] = STATE(1118),
    [sym_char] = STATE(1080),
    [sym_format_string] = STATE(1090),
    [sym__string_literal] = STATE(1090),
    [sym_string] = STATE(1080),
    [sym_verbatim_string] = STATE(1080),
    [sym_bytearray] = STATE(1080),
    [sym_verbatim_bytearray] = STATE(1080),
    [sym_format_triple_quoted_string] = STATE(1096),
    [sym_triple_quoted_string] = STATE(1080),
    [sym_const] = STATE(1118),
    [sym_long_identifier] = STATE(1156),
    [sym_active_pattern] = STATE(1085),
    [sym__identifier_or_op] = STATE(1099),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(517),
    [sym_infix_op] = STATE(487),
    [sym_sbyte] = STATE(1080),
    [sym_byte] = STATE(1080),
    [sym_int16] = STATE(1080),
    [sym_uint16] = STATE(1080),
    [sym_int32] = STATE(1080),
    [sym_uint32] = STATE(1080),
    [sym_nativeint] = STATE(1080),
    [sym_unativeint] = STATE(1080),
    [sym_int64] = STATE(1080),
    [sym_uint64] = STATE(1080),
    [sym_ieee32] = STATE(1080),
    [sym_ieee64] = STATE(1080),
    [sym_bignum] = STATE(1080),
    [sym_decimal] = STATE(1080),
    [sym_float] = STATE(979),
    [sym_block_comment] = STATE(58),
    [sym_compiler_directive_decl] = STATE(58),
    [sym_fsi_directive_decl] = STATE(58),
    [sym_preproc_line] = STATE(58),
    [sym_preproc_if_in_expression] = STATE(1118),
    [aux_sym_sequential_expression_repeat1] = STATE(1069),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(195),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(197),
    [anon_sym_return] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_COMMA] = ACTIONS(205),
    [anon_sym_null] = ACTIONS(207),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(197),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(209),
    [anon_sym_LBRACK_PIPE] = ACTIONS(211),
    [anon_sym_LBRACE] = ACTIONS(271),
    [anon_sym_LT_AT] = ACTIONS(213),
    [anon_sym_LT_AT_AT] = ACTIONS(215),
    [anon_sym_DOT] = ACTIONS(185),
    [anon_sym_LBRACE_PIPE] = ACTIONS(217),
    [anon_sym_new] = ACTIONS(199),
    [anon_sym_return_BANG] = ACTIONS(219),
    [anon_sym_yield] = ACTIONS(199),
    [anon_sym_yield_BANG] = ACTIONS(219),
    [anon_sym_lazy] = ACTIONS(199),
    [anon_sym_assert] = ACTIONS(199),
    [anon_sym_upcast] = ACTIONS(199),
    [anon_sym_downcast] = ACTIONS(199),
    [anon_sym_COLON_GT] = ACTIONS(221),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(221),
    [anon_sym_for] = ACTIONS(223),
    [anon_sym_to] = ACTIONS(623),
    [anon_sym_downto] = ACTIONS(623),
    [anon_sym_while] = ACTIONS(225),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(229),
    [anon_sym_match] = ACTIONS(231),
    [anon_sym_match_BANG] = ACTIONS(233),
    [anon_sym_function] = ACTIONS(235),
    [anon_sym_LT_DASH] = ACTIONS(237),
    [anon_sym_DOT_LBRACK] = ACTIONS(187),
    [anon_sym_LT] = ACTIONS(189),
    [anon_sym_use] = ACTIONS(239),
    [anon_sym_use_BANG] = ACTIONS(241),
    [anon_sym_do_BANG] = ACTIONS(243),
    [anon_sym_begin] = ACTIONS(245),
    [anon_sym_LPAREN2] = ACTIONS(191),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(247),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(251),
    [anon_sym_AT_DQUOTE] = ACTIONS(253),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(255),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(257),
    [sym_bool] = ACTIONS(259),
    [sym_unit] = ACTIONS(193),
    [anon_sym_LPAREN_PIPE] = ACTIONS(261),
    [sym_op_identifier] = ACTIONS(263),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(265),
    [sym_xint] = ACTIONS(267),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(269),
    [sym__newline] = ACTIONS(273),
  },
  [59] = {
    [sym_function_or_value_defn] = STATE(729),
    [sym__expression] = STATE(59),
    [sym_literal_expression] = STATE(867),
    [sym_long_identifier_or_op] = STATE(867),
    [sym_tuple_expression] = STATE(867),
    [sym_brace_expression] = STATE(867),
    [sym_anon_record_expression] = STATE(867),
    [sym_prefixed_expression] = STATE(867),
    [sym_typecast_expression] = STATE(867),
    [sym_for_expression] = STATE(867),
    [sym_while_expression] = STATE(867),
    [sym__if_branch] = STATE(6511),
    [sym_if_expression] = STATE(867),
    [sym_fun_expression] = STATE(867),
    [sym_try_expression] = STATE(867),
    [sym_match_expression] = STATE(867),
    [sym_function_expression] = STATE(867),
    [sym_mutate_expression] = STATE(867),
    [sym_index_expression] = STATE(867),
    [sym_typed_expression] = STATE(867),
    [sym_declaration_expression] = STATE(867),
    [sym_do_expression] = STATE(867),
    [sym_list_expression] = STATE(867),
    [sym_array_expression] = STATE(867),
    [sym_begin_end_expression] = STATE(867),
    [sym_paren_expression] = STATE(867),
    [sym__high_prec_app] = STATE(864),
    [sym__low_prec_app] = STATE(864),
    [sym_application_expression] = STATE(867),
    [sym_dot_expression] = STATE(867),
    [sym_infix_expression] = STATE(867),
    [sym_ce_expression] = STATE(867),
    [sym_sequential_expression] = STATE(867),
    [sym_char] = STATE(868),
    [sym_format_string] = STATE(869),
    [sym__string_literal] = STATE(869),
    [sym_string] = STATE(868),
    [sym_verbatim_string] = STATE(868),
    [sym_bytearray] = STATE(868),
    [sym_verbatim_bytearray] = STATE(868),
    [sym_format_triple_quoted_string] = STATE(870),
    [sym_triple_quoted_string] = STATE(868),
    [sym_const] = STATE(867),
    [sym_long_identifier] = STATE(872),
    [sym_active_pattern] = STATE(871),
    [sym__identifier_or_op] = STATE(873),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(499),
    [sym_infix_op] = STATE(743),
    [sym_sbyte] = STATE(868),
    [sym_byte] = STATE(868),
    [sym_int16] = STATE(868),
    [sym_uint16] = STATE(868),
    [sym_int32] = STATE(868),
    [sym_uint32] = STATE(868),
    [sym_nativeint] = STATE(868),
    [sym_unativeint] = STATE(868),
    [sym_int64] = STATE(868),
    [sym_uint64] = STATE(868),
    [sym_ieee32] = STATE(868),
    [sym_ieee64] = STATE(868),
    [sym_bignum] = STATE(868),
    [sym_decimal] = STATE(868),
    [sym_float] = STATE(1368),
    [sym_block_comment] = STATE(59),
    [sym_compiler_directive_decl] = STATE(59),
    [sym_fsi_directive_decl] = STATE(59),
    [sym_preproc_line] = STATE(59),
    [sym_preproc_if_in_expression] = STATE(867),
    [aux_sym_sequential_expression_repeat1] = STATE(1578),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_EQ] = ACTIONS(157),
    [anon_sym_COLON] = ACTIONS(155),
    [anon_sym_return] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(155),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_let_BANG] = ACTIONS(157),
    [anon_sym_LPAREN] = ACTIONS(155),
    [anon_sym_COMMA] = ACTIONS(157),
    [anon_sym_null] = ACTIONS(155),
    [anon_sym_QMARK] = ACTIONS(155),
    [anon_sym_COLON_QMARK] = ACTIONS(155),
    [anon_sym_COLON_COLON] = ACTIONS(157),
    [anon_sym_AMP] = ACTIONS(155),
    [anon_sym_LBRACK] = ACTIONS(155),
    [anon_sym_LBRACK_PIPE] = ACTIONS(157),
    [anon_sym_LBRACE] = ACTIONS(155),
    [anon_sym_LT_AT] = ACTIONS(155),
    [anon_sym_LT_AT_AT] = ACTIONS(155),
    [anon_sym_DOT] = ACTIONS(65),
    [anon_sym_LBRACE_PIPE] = ACTIONS(157),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_return_BANG] = ACTIONS(157),
    [anon_sym_yield] = ACTIONS(155),
    [anon_sym_yield_BANG] = ACTIONS(157),
    [anon_sym_lazy] = ACTIONS(155),
    [anon_sym_assert] = ACTIONS(155),
    [anon_sym_upcast] = ACTIONS(155),
    [anon_sym_downcast] = ACTIONS(155),
    [anon_sym_COLON_GT] = ACTIONS(157),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(157),
    [anon_sym_for] = ACTIONS(155),
    [anon_sym_while] = ACTIONS(155),
    [anon_sym_if] = ACTIONS(155),
    [anon_sym_fun] = ACTIONS(155),
    [anon_sym_try] = ACTIONS(155),
    [anon_sym_match] = ACTIONS(155),
    [anon_sym_match_BANG] = ACTIONS(157),
    [anon_sym_function] = ACTIONS(155),
    [anon_sym_LT_DASH] = ACTIONS(155),
    [anon_sym_DOT_LBRACK] = ACTIONS(91),
    [anon_sym_LT] = ACTIONS(93),
    [anon_sym_use] = ACTIONS(155),
    [anon_sym_use_BANG] = ACTIONS(157),
    [anon_sym_do_BANG] = ACTIONS(157),
    [anon_sym_begin] = ACTIONS(155),
    [anon_sym_LPAREN2] = ACTIONS(103),
    [anon_sym_DOT_DOT2] = ACTIONS(157),
    [anon_sym_or] = ACTIONS(155),
    [aux_sym_char_token1] = ACTIONS(157),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(155),
    [anon_sym_DQUOTE] = ACTIONS(155),
    [anon_sym_AT_DQUOTE] = ACTIONS(157),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(157),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(157),
    [sym_bool] = ACTIONS(155),
    [sym_unit] = ACTIONS(119),
    [anon_sym_LPAREN_PIPE] = ACTIONS(155),
    [sym_op_identifier] = ACTIONS(155),
    [anon_sym_PLUS] = ACTIONS(155),
    [anon_sym_DASH] = ACTIONS(155),
    [anon_sym_PLUS_DOT] = ACTIONS(155),
    [anon_sym_DASH_DOT] = ACTIONS(155),
    [anon_sym_PERCENT] = ACTIONS(155),
    [anon_sym_AMP_AMP] = ACTIONS(155),
    [anon_sym_TILDE] = ACTIONS(157),
    [aux_sym_prefix_op_token1] = ACTIONS(155),
    [aux_sym_infix_op_token1] = ACTIONS(157),
    [aux_sym_infix_op_token2] = ACTIONS(155),
    [anon_sym_PIPE_PIPE] = ACTIONS(155),
    [anon_sym_BANG_EQ] = ACTIONS(155),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_DOLLAR] = ACTIONS(155),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(155),
    [sym_int] = ACTIONS(155),
    [sym_xint] = ACTIONS(157),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(157),
    [sym__newline] = ACTIONS(157),
    [sym__dedent] = ACTIONS(157),
  },
  [60] = {
    [sym_function_or_value_defn] = STATE(627),
    [sym__expression] = STATE(17),
    [sym_literal_expression] = STATE(1118),
    [sym_long_identifier_or_op] = STATE(1118),
    [sym_tuple_expression] = STATE(1118),
    [sym_brace_expression] = STATE(1118),
    [sym_anon_record_expression] = STATE(1118),
    [sym_prefixed_expression] = STATE(1118),
    [sym_typecast_expression] = STATE(1118),
    [sym_for_expression] = STATE(1118),
    [sym_while_expression] = STATE(1118),
    [sym__if_branch] = STATE(7163),
    [sym_if_expression] = STATE(1118),
    [sym_fun_expression] = STATE(1118),
    [sym_try_expression] = STATE(1118),
    [sym_match_expression] = STATE(1118),
    [sym_function_expression] = STATE(1118),
    [sym_mutate_expression] = STATE(1118),
    [sym_index_expression] = STATE(1118),
    [sym_typed_expression] = STATE(1118),
    [sym_declaration_expression] = STATE(1118),
    [sym_do_expression] = STATE(1118),
    [sym_list_expression] = STATE(1118),
    [sym_array_expression] = STATE(1118),
    [sym_begin_end_expression] = STATE(1118),
    [sym_paren_expression] = STATE(1118),
    [sym__high_prec_app] = STATE(1133),
    [sym__low_prec_app] = STATE(1133),
    [sym_application_expression] = STATE(1118),
    [sym_dot_expression] = STATE(1118),
    [sym_infix_expression] = STATE(1118),
    [sym_ce_expression] = STATE(1118),
    [sym_sequential_expression] = STATE(1118),
    [sym_char] = STATE(1080),
    [sym_format_string] = STATE(1090),
    [sym__string_literal] = STATE(1090),
    [sym_string] = STATE(1080),
    [sym_verbatim_string] = STATE(1080),
    [sym_bytearray] = STATE(1080),
    [sym_verbatim_bytearray] = STATE(1080),
    [sym_format_triple_quoted_string] = STATE(1096),
    [sym_triple_quoted_string] = STATE(1080),
    [sym_const] = STATE(1118),
    [sym_long_identifier] = STATE(1156),
    [sym_active_pattern] = STATE(1085),
    [sym__identifier_or_op] = STATE(1099),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(517),
    [sym_infix_op] = STATE(487),
    [sym_sbyte] = STATE(1080),
    [sym_byte] = STATE(1080),
    [sym_int16] = STATE(1080),
    [sym_uint16] = STATE(1080),
    [sym_int32] = STATE(1080),
    [sym_uint32] = STATE(1080),
    [sym_nativeint] = STATE(1080),
    [sym_unativeint] = STATE(1080),
    [sym_int64] = STATE(1080),
    [sym_uint64] = STATE(1080),
    [sym_ieee32] = STATE(1080),
    [sym_ieee64] = STATE(1080),
    [sym_bignum] = STATE(1080),
    [sym_decimal] = STATE(1080),
    [sym_float] = STATE(979),
    [sym_block_comment] = STATE(60),
    [sym_compiler_directive_decl] = STATE(60),
    [sym_fsi_directive_decl] = STATE(60),
    [sym_preproc_line] = STATE(60),
    [sym_preproc_if_in_expression] = STATE(1118),
    [aux_sym_sequential_expression_repeat1] = STATE(1069),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(195),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(197),
    [anon_sym_return] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_COMMA] = ACTIONS(205),
    [anon_sym_null] = ACTIONS(207),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(197),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(209),
    [anon_sym_LBRACK_PIPE] = ACTIONS(211),
    [anon_sym_LBRACE] = ACTIONS(271),
    [anon_sym_LT_AT] = ACTIONS(213),
    [anon_sym_LT_AT_AT] = ACTIONS(215),
    [anon_sym_DOT] = ACTIONS(185),
    [anon_sym_LBRACE_PIPE] = ACTIONS(217),
    [anon_sym_new] = ACTIONS(199),
    [anon_sym_return_BANG] = ACTIONS(219),
    [anon_sym_yield] = ACTIONS(199),
    [anon_sym_yield_BANG] = ACTIONS(219),
    [anon_sym_lazy] = ACTIONS(199),
    [anon_sym_assert] = ACTIONS(199),
    [anon_sym_upcast] = ACTIONS(199),
    [anon_sym_downcast] = ACTIONS(199),
    [anon_sym_COLON_GT] = ACTIONS(221),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(221),
    [anon_sym_for] = ACTIONS(223),
    [anon_sym_to] = ACTIONS(625),
    [anon_sym_downto] = ACTIONS(625),
    [anon_sym_while] = ACTIONS(225),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(229),
    [anon_sym_match] = ACTIONS(231),
    [anon_sym_match_BANG] = ACTIONS(233),
    [anon_sym_function] = ACTIONS(235),
    [anon_sym_LT_DASH] = ACTIONS(237),
    [anon_sym_DOT_LBRACK] = ACTIONS(187),
    [anon_sym_LT] = ACTIONS(189),
    [anon_sym_use] = ACTIONS(239),
    [anon_sym_use_BANG] = ACTIONS(241),
    [anon_sym_do_BANG] = ACTIONS(243),
    [anon_sym_begin] = ACTIONS(245),
    [anon_sym_LPAREN2] = ACTIONS(191),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(247),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(251),
    [anon_sym_AT_DQUOTE] = ACTIONS(253),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(255),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(257),
    [sym_bool] = ACTIONS(259),
    [sym_unit] = ACTIONS(193),
    [anon_sym_LPAREN_PIPE] = ACTIONS(261),
    [sym_op_identifier] = ACTIONS(263),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(265),
    [sym_xint] = ACTIONS(267),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(269),
    [sym__newline] = ACTIONS(273),
  },
  [61] = {
    [sym_function_or_value_defn] = STATE(729),
    [sym__expression] = STATE(59),
    [sym_literal_expression] = STATE(867),
    [sym_long_identifier_or_op] = STATE(867),
    [sym_tuple_expression] = STATE(867),
    [sym_brace_expression] = STATE(867),
    [sym_anon_record_expression] = STATE(867),
    [sym_prefixed_expression] = STATE(867),
    [sym_typecast_expression] = STATE(867),
    [sym_for_expression] = STATE(867),
    [sym_while_expression] = STATE(867),
    [sym__if_branch] = STATE(6511),
    [sym_if_expression] = STATE(867),
    [sym_fun_expression] = STATE(867),
    [sym_try_expression] = STATE(867),
    [sym_match_expression] = STATE(867),
    [sym_function_expression] = STATE(867),
    [sym_mutate_expression] = STATE(867),
    [sym_index_expression] = STATE(867),
    [sym_typed_expression] = STATE(867),
    [sym_declaration_expression] = STATE(867),
    [sym_do_expression] = STATE(867),
    [sym_list_expression] = STATE(867),
    [sym_array_expression] = STATE(867),
    [sym_begin_end_expression] = STATE(867),
    [sym_paren_expression] = STATE(867),
    [sym__high_prec_app] = STATE(864),
    [sym__low_prec_app] = STATE(864),
    [sym_application_expression] = STATE(867),
    [sym_dot_expression] = STATE(867),
    [sym_infix_expression] = STATE(867),
    [sym_ce_expression] = STATE(867),
    [sym_sequential_expression] = STATE(867),
    [sym_char] = STATE(868),
    [sym_format_string] = STATE(869),
    [sym__string_literal] = STATE(869),
    [sym_string] = STATE(868),
    [sym_verbatim_string] = STATE(868),
    [sym_bytearray] = STATE(868),
    [sym_verbatim_bytearray] = STATE(868),
    [sym_format_triple_quoted_string] = STATE(870),
    [sym_triple_quoted_string] = STATE(868),
    [sym_const] = STATE(867),
    [sym_long_identifier] = STATE(872),
    [sym_active_pattern] = STATE(871),
    [sym__identifier_or_op] = STATE(873),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(499),
    [sym_infix_op] = STATE(743),
    [sym_sbyte] = STATE(868),
    [sym_byte] = STATE(868),
    [sym_int16] = STATE(868),
    [sym_uint16] = STATE(868),
    [sym_int32] = STATE(868),
    [sym_uint32] = STATE(868),
    [sym_nativeint] = STATE(868),
    [sym_unativeint] = STATE(868),
    [sym_int64] = STATE(868),
    [sym_uint64] = STATE(868),
    [sym_ieee32] = STATE(868),
    [sym_ieee64] = STATE(868),
    [sym_bignum] = STATE(868),
    [sym_decimal] = STATE(868),
    [sym_float] = STATE(1368),
    [sym_block_comment] = STATE(61),
    [sym_compiler_directive_decl] = STATE(61),
    [sym_fsi_directive_decl] = STATE(61),
    [sym_preproc_line] = STATE(61),
    [sym_preproc_if_in_expression] = STATE(867),
    [aux_sym_sequential_expression_repeat1] = STATE(1578),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(29),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(369),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_COMMA] = ACTIONS(371),
    [anon_sym_null] = ACTIONS(49),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACK_PIPE] = ACTIONS(57),
    [anon_sym_LBRACE] = ACTIONS(139),
    [anon_sym_LT_AT] = ACTIONS(61),
    [anon_sym_LT_AT_AT] = ACTIONS(63),
    [anon_sym_DOT] = ACTIONS(65),
    [anon_sym_LBRACE_PIPE] = ACTIONS(67),
    [anon_sym_new] = ACTIONS(369),
    [anon_sym_return_BANG] = ACTIONS(373),
    [anon_sym_yield] = ACTIONS(369),
    [anon_sym_yield_BANG] = ACTIONS(373),
    [anon_sym_lazy] = ACTIONS(369),
    [anon_sym_assert] = ACTIONS(369),
    [anon_sym_upcast] = ACTIONS(369),
    [anon_sym_downcast] = ACTIONS(369),
    [anon_sym_COLON_GT] = ACTIONS(71),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(71),
    [anon_sym_for] = ACTIONS(375),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(79),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_match] = ACTIONS(83),
    [anon_sym_match_BANG] = ACTIONS(85),
    [anon_sym_function] = ACTIONS(87),
    [anon_sym_LT_DASH] = ACTIONS(377),
    [anon_sym_DOT_LBRACK] = ACTIONS(91),
    [anon_sym_LT] = ACTIONS(93),
    [anon_sym_use] = ACTIONS(379),
    [anon_sym_use_BANG] = ACTIONS(381),
    [anon_sym_do_BANG] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(101),
    [anon_sym_LPAREN2] = ACTIONS(103),
    [anon_sym_DOT_DOT2] = ACTIONS(149),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(105),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(107),
    [anon_sym_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DQUOTE] = ACTIONS(111),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(115),
    [sym_bool] = ACTIONS(117),
    [sym_unit] = ACTIONS(119),
    [anon_sym_LPAREN_PIPE] = ACTIONS(121),
    [sym_op_identifier] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(385),
    [sym_xint] = ACTIONS(387),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(135),
    [sym__newline] = ACTIONS(609),
    [sym__dedent] = ACTIONS(149),
  },
  [62] = {
    [sym_function_or_value_defn] = STATE(729),
    [sym__expression] = STATE(59),
    [sym_literal_expression] = STATE(867),
    [sym_long_identifier_or_op] = STATE(867),
    [sym_tuple_expression] = STATE(867),
    [sym_brace_expression] = STATE(867),
    [sym_anon_record_expression] = STATE(867),
    [sym_prefixed_expression] = STATE(867),
    [sym_typecast_expression] = STATE(867),
    [sym_for_expression] = STATE(867),
    [sym_while_expression] = STATE(867),
    [sym__if_branch] = STATE(6511),
    [sym_if_expression] = STATE(867),
    [sym_fun_expression] = STATE(867),
    [sym_try_expression] = STATE(867),
    [sym_match_expression] = STATE(867),
    [sym_function_expression] = STATE(867),
    [sym_mutate_expression] = STATE(867),
    [sym_index_expression] = STATE(867),
    [sym_typed_expression] = STATE(867),
    [sym_declaration_expression] = STATE(867),
    [sym_do_expression] = STATE(867),
    [sym_list_expression] = STATE(867),
    [sym_array_expression] = STATE(867),
    [sym_begin_end_expression] = STATE(867),
    [sym_paren_expression] = STATE(867),
    [sym__high_prec_app] = STATE(864),
    [sym__low_prec_app] = STATE(864),
    [sym_application_expression] = STATE(867),
    [sym_dot_expression] = STATE(867),
    [sym_infix_expression] = STATE(867),
    [sym_ce_expression] = STATE(867),
    [sym_sequential_expression] = STATE(867),
    [sym_char] = STATE(868),
    [sym_format_string] = STATE(869),
    [sym__string_literal] = STATE(869),
    [sym_string] = STATE(868),
    [sym_verbatim_string] = STATE(868),
    [sym_bytearray] = STATE(868),
    [sym_verbatim_bytearray] = STATE(868),
    [sym_format_triple_quoted_string] = STATE(870),
    [sym_triple_quoted_string] = STATE(868),
    [sym_const] = STATE(867),
    [sym_long_identifier] = STATE(872),
    [sym_active_pattern] = STATE(871),
    [sym__identifier_or_op] = STATE(873),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(499),
    [sym_infix_op] = STATE(743),
    [sym_sbyte] = STATE(868),
    [sym_byte] = STATE(868),
    [sym_int16] = STATE(868),
    [sym_uint16] = STATE(868),
    [sym_int32] = STATE(868),
    [sym_uint32] = STATE(868),
    [sym_nativeint] = STATE(868),
    [sym_unativeint] = STATE(868),
    [sym_int64] = STATE(868),
    [sym_uint64] = STATE(868),
    [sym_ieee32] = STATE(868),
    [sym_ieee64] = STATE(868),
    [sym_bignum] = STATE(868),
    [sym_decimal] = STATE(868),
    [sym_float] = STATE(1368),
    [sym_block_comment] = STATE(62),
    [sym_compiler_directive_decl] = STATE(62),
    [sym_fsi_directive_decl] = STATE(62),
    [sym_preproc_line] = STATE(62),
    [sym_preproc_if_in_expression] = STATE(867),
    [aux_sym_sequential_expression_repeat1] = STATE(1578),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(29),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(369),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_COMMA] = ACTIONS(371),
    [anon_sym_null] = ACTIONS(49),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACK_PIPE] = ACTIONS(57),
    [anon_sym_LBRACE] = ACTIONS(139),
    [anon_sym_LT_AT] = ACTIONS(61),
    [anon_sym_LT_AT_AT] = ACTIONS(63),
    [anon_sym_DOT] = ACTIONS(65),
    [anon_sym_LBRACE_PIPE] = ACTIONS(67),
    [anon_sym_new] = ACTIONS(369),
    [anon_sym_return_BANG] = ACTIONS(373),
    [anon_sym_yield] = ACTIONS(369),
    [anon_sym_yield_BANG] = ACTIONS(373),
    [anon_sym_lazy] = ACTIONS(369),
    [anon_sym_assert] = ACTIONS(369),
    [anon_sym_upcast] = ACTIONS(369),
    [anon_sym_downcast] = ACTIONS(369),
    [anon_sym_COLON_GT] = ACTIONS(71),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(71),
    [anon_sym_for] = ACTIONS(375),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(79),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_match] = ACTIONS(83),
    [anon_sym_match_BANG] = ACTIONS(85),
    [anon_sym_function] = ACTIONS(87),
    [anon_sym_LT_DASH] = ACTIONS(377),
    [anon_sym_DOT_LBRACK] = ACTIONS(91),
    [anon_sym_LT] = ACTIONS(93),
    [anon_sym_use] = ACTIONS(379),
    [anon_sym_use_BANG] = ACTIONS(381),
    [anon_sym_do_BANG] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(101),
    [anon_sym_LPAREN2] = ACTIONS(103),
    [anon_sym_DOT_DOT2] = ACTIONS(145),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(105),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(107),
    [anon_sym_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DQUOTE] = ACTIONS(111),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(115),
    [sym_bool] = ACTIONS(117),
    [sym_unit] = ACTIONS(119),
    [anon_sym_LPAREN_PIPE] = ACTIONS(121),
    [sym_op_identifier] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(385),
    [sym_xint] = ACTIONS(387),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(135),
    [sym__newline] = ACTIONS(145),
    [sym__dedent] = ACTIONS(145),
  },
  [63] = {
    [sym_function_or_value_defn] = STATE(663),
    [sym__expression] = STATE(76),
    [sym_literal_expression] = STATE(1118),
    [sym_long_identifier_or_op] = STATE(1118),
    [sym_tuple_expression] = STATE(1118),
    [sym_brace_expression] = STATE(1118),
    [sym_anon_record_expression] = STATE(1118),
    [sym_prefixed_expression] = STATE(1118),
    [sym_typecast_expression] = STATE(1118),
    [sym_for_expression] = STATE(1118),
    [sym_while_expression] = STATE(1118),
    [sym__if_branch] = STATE(7163),
    [sym_if_expression] = STATE(1118),
    [sym_fun_expression] = STATE(1118),
    [sym_try_expression] = STATE(1118),
    [sym_match_expression] = STATE(1118),
    [sym_function_expression] = STATE(1118),
    [sym_mutate_expression] = STATE(1118),
    [sym_index_expression] = STATE(1118),
    [sym_typed_expression] = STATE(1118),
    [sym_declaration_expression] = STATE(1118),
    [sym_do_expression] = STATE(1118),
    [sym_list_expression] = STATE(1118),
    [sym_array_expression] = STATE(1118),
    [sym_begin_end_expression] = STATE(1118),
    [sym_paren_expression] = STATE(1118),
    [sym__high_prec_app] = STATE(1133),
    [sym__low_prec_app] = STATE(1133),
    [sym_application_expression] = STATE(1118),
    [sym_dot_expression] = STATE(1118),
    [sym_infix_expression] = STATE(1118),
    [sym_ce_expression] = STATE(1118),
    [sym_sequential_expression] = STATE(1118),
    [sym_char] = STATE(1080),
    [sym_format_string] = STATE(1090),
    [sym__string_literal] = STATE(1090),
    [sym_string] = STATE(1080),
    [sym_verbatim_string] = STATE(1080),
    [sym_bytearray] = STATE(1080),
    [sym_verbatim_bytearray] = STATE(1080),
    [sym_format_triple_quoted_string] = STATE(1096),
    [sym_triple_quoted_string] = STATE(1080),
    [sym_const] = STATE(1118),
    [sym_long_identifier] = STATE(1156),
    [sym_active_pattern] = STATE(1085),
    [sym__identifier_or_op] = STATE(1099),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(548),
    [sym_infix_op] = STATE(687),
    [sym_sbyte] = STATE(1080),
    [sym_byte] = STATE(1080),
    [sym_int16] = STATE(1080),
    [sym_uint16] = STATE(1080),
    [sym_int32] = STATE(1080),
    [sym_uint32] = STATE(1080),
    [sym_nativeint] = STATE(1080),
    [sym_unativeint] = STATE(1080),
    [sym_int64] = STATE(1080),
    [sym_uint64] = STATE(1080),
    [sym_ieee32] = STATE(1080),
    [sym_ieee64] = STATE(1080),
    [sym_bignum] = STATE(1080),
    [sym_decimal] = STATE(1080),
    [sym_float] = STATE(979),
    [sym_block_comment] = STATE(63),
    [sym_compiler_directive_decl] = STATE(63),
    [sym_fsi_directive_decl] = STATE(63),
    [sym_preproc_line] = STATE(63),
    [sym_preproc_if_in_expression] = STATE(1118),
    [aux_sym_sequential_expression_repeat1] = STATE(1558),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(195),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(197),
    [anon_sym_return] = ACTIONS(481),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_COMMA] = ACTIONS(483),
    [anon_sym_null] = ACTIONS(207),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(197),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(209),
    [anon_sym_RBRACK] = ACTIONS(627),
    [anon_sym_LBRACK_PIPE] = ACTIONS(211),
    [anon_sym_LBRACE] = ACTIONS(271),
    [anon_sym_LT_AT] = ACTIONS(213),
    [anon_sym_LT_AT_AT] = ACTIONS(215),
    [anon_sym_DOT] = ACTIONS(185),
    [anon_sym_LBRACE_PIPE] = ACTIONS(217),
    [anon_sym_new] = ACTIONS(481),
    [anon_sym_return_BANG] = ACTIONS(487),
    [anon_sym_yield] = ACTIONS(481),
    [anon_sym_yield_BANG] = ACTIONS(487),
    [anon_sym_lazy] = ACTIONS(481),
    [anon_sym_assert] = ACTIONS(481),
    [anon_sym_upcast] = ACTIONS(481),
    [anon_sym_downcast] = ACTIONS(481),
    [anon_sym_COLON_GT] = ACTIONS(221),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(221),
    [anon_sym_for] = ACTIONS(489),
    [anon_sym_while] = ACTIONS(225),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(229),
    [anon_sym_match] = ACTIONS(231),
    [anon_sym_match_BANG] = ACTIONS(233),
    [anon_sym_function] = ACTIONS(235),
    [anon_sym_LT_DASH] = ACTIONS(491),
    [anon_sym_DOT_LBRACK] = ACTIONS(187),
    [anon_sym_LT] = ACTIONS(189),
    [anon_sym_use] = ACTIONS(493),
    [anon_sym_use_BANG] = ACTIONS(495),
    [anon_sym_do_BANG] = ACTIONS(243),
    [anon_sym_begin] = ACTIONS(245),
    [anon_sym_LPAREN2] = ACTIONS(191),
    [anon_sym_DOT_DOT2] = ACTIONS(497),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(247),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(251),
    [anon_sym_AT_DQUOTE] = ACTIONS(253),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(255),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(257),
    [sym_bool] = ACTIONS(259),
    [sym_unit] = ACTIONS(193),
    [anon_sym_LPAREN_PIPE] = ACTIONS(261),
    [sym_op_identifier] = ACTIONS(263),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(499),
    [sym_xint] = ACTIONS(267),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(269),
    [sym__newline] = ACTIONS(501),
  },
  [64] = {
    [sym_function_or_value_defn] = STATE(663),
    [sym__expression] = STATE(76),
    [sym_literal_expression] = STATE(1118),
    [sym_long_identifier_or_op] = STATE(1118),
    [sym_tuple_expression] = STATE(1118),
    [sym_brace_expression] = STATE(1118),
    [sym_anon_record_expression] = STATE(1118),
    [sym_prefixed_expression] = STATE(1118),
    [sym_typecast_expression] = STATE(1118),
    [sym_for_expression] = STATE(1118),
    [sym_while_expression] = STATE(1118),
    [sym__if_branch] = STATE(7163),
    [sym_if_expression] = STATE(1118),
    [sym_fun_expression] = STATE(1118),
    [sym_try_expression] = STATE(1118),
    [sym_match_expression] = STATE(1118),
    [sym_function_expression] = STATE(1118),
    [sym_mutate_expression] = STATE(1118),
    [sym_index_expression] = STATE(1118),
    [sym_typed_expression] = STATE(1118),
    [sym_declaration_expression] = STATE(1118),
    [sym_do_expression] = STATE(1118),
    [sym_list_expression] = STATE(1118),
    [sym_array_expression] = STATE(1118),
    [sym_begin_end_expression] = STATE(1118),
    [sym_paren_expression] = STATE(1118),
    [sym__high_prec_app] = STATE(1133),
    [sym__low_prec_app] = STATE(1133),
    [sym_application_expression] = STATE(1118),
    [sym_dot_expression] = STATE(1118),
    [sym_infix_expression] = STATE(1118),
    [sym_ce_expression] = STATE(1118),
    [sym_sequential_expression] = STATE(1118),
    [sym_char] = STATE(1080),
    [sym_format_string] = STATE(1090),
    [sym__string_literal] = STATE(1090),
    [sym_string] = STATE(1080),
    [sym_verbatim_string] = STATE(1080),
    [sym_bytearray] = STATE(1080),
    [sym_verbatim_bytearray] = STATE(1080),
    [sym_format_triple_quoted_string] = STATE(1096),
    [sym_triple_quoted_string] = STATE(1080),
    [sym_const] = STATE(1118),
    [sym_long_identifier] = STATE(1156),
    [sym_active_pattern] = STATE(1085),
    [sym__identifier_or_op] = STATE(1099),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(548),
    [sym_infix_op] = STATE(687),
    [sym_sbyte] = STATE(1080),
    [sym_byte] = STATE(1080),
    [sym_int16] = STATE(1080),
    [sym_uint16] = STATE(1080),
    [sym_int32] = STATE(1080),
    [sym_uint32] = STATE(1080),
    [sym_nativeint] = STATE(1080),
    [sym_unativeint] = STATE(1080),
    [sym_int64] = STATE(1080),
    [sym_uint64] = STATE(1080),
    [sym_ieee32] = STATE(1080),
    [sym_ieee64] = STATE(1080),
    [sym_bignum] = STATE(1080),
    [sym_decimal] = STATE(1080),
    [sym_float] = STATE(979),
    [sym_block_comment] = STATE(64),
    [sym_compiler_directive_decl] = STATE(64),
    [sym_fsi_directive_decl] = STATE(64),
    [sym_preproc_line] = STATE(64),
    [sym_preproc_if_in_expression] = STATE(1118),
    [aux_sym_sequential_expression_repeat1] = STATE(1558),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(195),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(197),
    [anon_sym_return] = ACTIONS(481),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_COMMA] = ACTIONS(483),
    [anon_sym_null] = ACTIONS(207),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(197),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(209),
    [anon_sym_RBRACK] = ACTIONS(171),
    [anon_sym_LBRACK_PIPE] = ACTIONS(211),
    [anon_sym_LBRACE] = ACTIONS(271),
    [anon_sym_LT_AT] = ACTIONS(213),
    [anon_sym_LT_AT_AT] = ACTIONS(215),
    [anon_sym_DOT] = ACTIONS(185),
    [anon_sym_LBRACE_PIPE] = ACTIONS(217),
    [anon_sym_new] = ACTIONS(481),
    [anon_sym_return_BANG] = ACTIONS(487),
    [anon_sym_yield] = ACTIONS(481),
    [anon_sym_yield_BANG] = ACTIONS(487),
    [anon_sym_lazy] = ACTIONS(481),
    [anon_sym_assert] = ACTIONS(481),
    [anon_sym_upcast] = ACTIONS(481),
    [anon_sym_downcast] = ACTIONS(481),
    [anon_sym_COLON_GT] = ACTIONS(221),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(221),
    [anon_sym_for] = ACTIONS(489),
    [anon_sym_while] = ACTIONS(225),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(229),
    [anon_sym_match] = ACTIONS(231),
    [anon_sym_match_BANG] = ACTIONS(233),
    [anon_sym_function] = ACTIONS(235),
    [anon_sym_LT_DASH] = ACTIONS(491),
    [anon_sym_DOT_LBRACK] = ACTIONS(187),
    [anon_sym_LT] = ACTIONS(189),
    [anon_sym_use] = ACTIONS(493),
    [anon_sym_use_BANG] = ACTIONS(495),
    [anon_sym_do_BANG] = ACTIONS(243),
    [anon_sym_begin] = ACTIONS(245),
    [anon_sym_LPAREN2] = ACTIONS(191),
    [anon_sym_DOT_DOT2] = ACTIONS(171),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(247),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(251),
    [anon_sym_AT_DQUOTE] = ACTIONS(253),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(255),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(257),
    [sym_bool] = ACTIONS(259),
    [sym_unit] = ACTIONS(193),
    [anon_sym_LPAREN_PIPE] = ACTIONS(261),
    [sym_op_identifier] = ACTIONS(263),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(499),
    [sym_xint] = ACTIONS(267),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(269),
    [sym__newline] = ACTIONS(501),
  },
  [65] = {
    [sym_function_or_value_defn] = STATE(532),
    [sym__expression] = STATE(126),
    [sym_literal_expression] = STATE(2000),
    [sym_long_identifier_or_op] = STATE(2000),
    [sym_tuple_expression] = STATE(2000),
    [sym_brace_expression] = STATE(2000),
    [sym_anon_record_expression] = STATE(2000),
    [sym_prefixed_expression] = STATE(2000),
    [sym_typecast_expression] = STATE(2000),
    [sym_for_expression] = STATE(2000),
    [sym_while_expression] = STATE(2000),
    [sym__if_branch] = STATE(6707),
    [sym_if_expression] = STATE(2000),
    [sym_fun_expression] = STATE(2000),
    [sym_try_expression] = STATE(2000),
    [sym_match_expression] = STATE(2000),
    [sym_function_expression] = STATE(2000),
    [sym_mutate_expression] = STATE(2000),
    [sym_index_expression] = STATE(2000),
    [sym_typed_expression] = STATE(2000),
    [sym_declaration_expression] = STATE(2000),
    [sym_do_expression] = STATE(2000),
    [sym_list_expression] = STATE(2000),
    [sym_array_expression] = STATE(2000),
    [sym_begin_end_expression] = STATE(2000),
    [sym_paren_expression] = STATE(2000),
    [sym__high_prec_app] = STATE(2003),
    [sym__low_prec_app] = STATE(2003),
    [sym_application_expression] = STATE(2000),
    [sym_dot_expression] = STATE(2000),
    [sym_infix_expression] = STATE(2000),
    [sym_ce_expression] = STATE(2000),
    [sym_sequential_expression] = STATE(2000),
    [sym_char] = STATE(1801),
    [sym_format_string] = STATE(1804),
    [sym__string_literal] = STATE(1804),
    [sym_string] = STATE(1801),
    [sym_verbatim_string] = STATE(1801),
    [sym_bytearray] = STATE(1801),
    [sym_verbatim_bytearray] = STATE(1801),
    [sym_format_triple_quoted_string] = STATE(1807),
    [sym_triple_quoted_string] = STATE(1801),
    [sym_const] = STATE(2000),
    [sym_long_identifier] = STATE(1725),
    [sym_active_pattern] = STATE(1726),
    [sym__identifier_or_op] = STATE(1751),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(723),
    [sym_infix_op] = STATE(561),
    [sym_sbyte] = STATE(1801),
    [sym_byte] = STATE(1801),
    [sym_int16] = STATE(1801),
    [sym_uint16] = STATE(1801),
    [sym_int32] = STATE(1801),
    [sym_uint32] = STATE(1801),
    [sym_nativeint] = STATE(1801),
    [sym_unativeint] = STATE(1801),
    [sym_int64] = STATE(1801),
    [sym_uint64] = STATE(1801),
    [sym_ieee32] = STATE(1801),
    [sym_ieee64] = STATE(1801),
    [sym_bignum] = STATE(1801),
    [sym_decimal] = STATE(1801),
    [sym_float] = STATE(1427),
    [sym_block_comment] = STATE(65),
    [sym_compiler_directive_decl] = STATE(65),
    [sym_fsi_directive_decl] = STATE(65),
    [sym_preproc_line] = STATE(65),
    [sym_preproc_if_in_expression] = STATE(2000),
    [aux_sym_sequential_expression_repeat1] = STATE(1635),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(629),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(631),
    [anon_sym_return] = ACTIONS(633),
    [anon_sym_do] = ACTIONS(635),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(637),
    [anon_sym_COMMA] = ACTIONS(639),
    [anon_sym_null] = ACTIONS(641),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(631),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(643),
    [anon_sym_LBRACK_PIPE] = ACTIONS(645),
    [anon_sym_LBRACE] = ACTIONS(169),
    [anon_sym_LT_AT] = ACTIONS(647),
    [anon_sym_LT_AT_AT] = ACTIONS(649),
    [anon_sym_DOT] = ACTIONS(651),
    [anon_sym_LBRACE_PIPE] = ACTIONS(653),
    [anon_sym_new] = ACTIONS(633),
    [anon_sym_return_BANG] = ACTIONS(655),
    [anon_sym_yield] = ACTIONS(633),
    [anon_sym_yield_BANG] = ACTIONS(655),
    [anon_sym_lazy] = ACTIONS(633),
    [anon_sym_assert] = ACTIONS(633),
    [anon_sym_upcast] = ACTIONS(633),
    [anon_sym_downcast] = ACTIONS(633),
    [anon_sym_COLON_GT] = ACTIONS(657),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(657),
    [anon_sym_for] = ACTIONS(659),
    [anon_sym_while] = ACTIONS(661),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(663),
    [anon_sym_try] = ACTIONS(665),
    [anon_sym_match] = ACTIONS(667),
    [anon_sym_match_BANG] = ACTIONS(669),
    [anon_sym_function] = ACTIONS(671),
    [anon_sym_LT_DASH] = ACTIONS(673),
    [anon_sym_DOT_LBRACK] = ACTIONS(675),
    [anon_sym_LT] = ACTIONS(677),
    [anon_sym_use] = ACTIONS(679),
    [anon_sym_use_BANG] = ACTIONS(681),
    [anon_sym_do_BANG] = ACTIONS(683),
    [anon_sym_begin] = ACTIONS(685),
    [anon_sym_LPAREN2] = ACTIONS(687),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(689),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(691),
    [anon_sym_DQUOTE] = ACTIONS(693),
    [anon_sym_AT_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(697),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(699),
    [sym_bool] = ACTIONS(701),
    [sym_unit] = ACTIONS(703),
    [anon_sym_LPAREN_PIPE] = ACTIONS(705),
    [sym_op_identifier] = ACTIONS(707),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(709),
    [sym_xint] = ACTIONS(711),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(713),
    [anon_sym_POUNDendif] = ACTIONS(167),
    [anon_sym_POUNDelse] = ACTIONS(167),
    [sym__newline] = ACTIONS(167),
  },
  [66] = {
    [sym_function_or_value_defn] = STATE(663),
    [sym__expression] = STATE(76),
    [sym_literal_expression] = STATE(1118),
    [sym_long_identifier_or_op] = STATE(1118),
    [sym_tuple_expression] = STATE(1118),
    [sym_brace_expression] = STATE(1118),
    [sym_anon_record_expression] = STATE(1118),
    [sym_prefixed_expression] = STATE(1118),
    [sym_typecast_expression] = STATE(1118),
    [sym_for_expression] = STATE(1118),
    [sym_while_expression] = STATE(1118),
    [sym__if_branch] = STATE(7163),
    [sym_if_expression] = STATE(1118),
    [sym_fun_expression] = STATE(1118),
    [sym_try_expression] = STATE(1118),
    [sym_match_expression] = STATE(1118),
    [sym_function_expression] = STATE(1118),
    [sym_mutate_expression] = STATE(1118),
    [sym_index_expression] = STATE(1118),
    [sym_typed_expression] = STATE(1118),
    [sym_declaration_expression] = STATE(1118),
    [sym_do_expression] = STATE(1118),
    [sym_list_expression] = STATE(1118),
    [sym_array_expression] = STATE(1118),
    [sym_begin_end_expression] = STATE(1118),
    [sym_paren_expression] = STATE(1118),
    [sym__high_prec_app] = STATE(1133),
    [sym__low_prec_app] = STATE(1133),
    [sym_application_expression] = STATE(1118),
    [sym_dot_expression] = STATE(1118),
    [sym_infix_expression] = STATE(1118),
    [sym_ce_expression] = STATE(1118),
    [sym_sequential_expression] = STATE(1118),
    [sym_char] = STATE(1080),
    [sym_format_string] = STATE(1090),
    [sym__string_literal] = STATE(1090),
    [sym_string] = STATE(1080),
    [sym_verbatim_string] = STATE(1080),
    [sym_bytearray] = STATE(1080),
    [sym_verbatim_bytearray] = STATE(1080),
    [sym_format_triple_quoted_string] = STATE(1096),
    [sym_triple_quoted_string] = STATE(1080),
    [sym_const] = STATE(1118),
    [sym_long_identifier] = STATE(1156),
    [sym_active_pattern] = STATE(1085),
    [sym__identifier_or_op] = STATE(1099),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(548),
    [sym_infix_op] = STATE(687),
    [sym_sbyte] = STATE(1080),
    [sym_byte] = STATE(1080),
    [sym_int16] = STATE(1080),
    [sym_uint16] = STATE(1080),
    [sym_int32] = STATE(1080),
    [sym_uint32] = STATE(1080),
    [sym_nativeint] = STATE(1080),
    [sym_unativeint] = STATE(1080),
    [sym_int64] = STATE(1080),
    [sym_uint64] = STATE(1080),
    [sym_ieee32] = STATE(1080),
    [sym_ieee64] = STATE(1080),
    [sym_bignum] = STATE(1080),
    [sym_decimal] = STATE(1080),
    [sym_float] = STATE(979),
    [sym_block_comment] = STATE(66),
    [sym_compiler_directive_decl] = STATE(66),
    [sym_fsi_directive_decl] = STATE(66),
    [sym_preproc_line] = STATE(66),
    [sym_preproc_if_in_expression] = STATE(1118),
    [aux_sym_sequential_expression_repeat1] = STATE(1558),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(195),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(197),
    [anon_sym_return] = ACTIONS(481),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_COMMA] = ACTIONS(483),
    [anon_sym_null] = ACTIONS(207),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(197),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(209),
    [anon_sym_RBRACK] = ACTIONS(715),
    [anon_sym_LBRACK_PIPE] = ACTIONS(211),
    [anon_sym_LBRACE] = ACTIONS(271),
    [anon_sym_LT_AT] = ACTIONS(213),
    [anon_sym_LT_AT_AT] = ACTIONS(215),
    [anon_sym_DOT] = ACTIONS(185),
    [anon_sym_LBRACE_PIPE] = ACTIONS(217),
    [anon_sym_new] = ACTIONS(481),
    [anon_sym_return_BANG] = ACTIONS(487),
    [anon_sym_yield] = ACTIONS(481),
    [anon_sym_yield_BANG] = ACTIONS(487),
    [anon_sym_lazy] = ACTIONS(481),
    [anon_sym_assert] = ACTIONS(481),
    [anon_sym_upcast] = ACTIONS(481),
    [anon_sym_downcast] = ACTIONS(481),
    [anon_sym_COLON_GT] = ACTIONS(221),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(221),
    [anon_sym_for] = ACTIONS(489),
    [anon_sym_while] = ACTIONS(225),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(229),
    [anon_sym_match] = ACTIONS(231),
    [anon_sym_match_BANG] = ACTIONS(233),
    [anon_sym_function] = ACTIONS(235),
    [anon_sym_LT_DASH] = ACTIONS(491),
    [anon_sym_DOT_LBRACK] = ACTIONS(187),
    [anon_sym_LT] = ACTIONS(189),
    [anon_sym_use] = ACTIONS(493),
    [anon_sym_use_BANG] = ACTIONS(495),
    [anon_sym_do_BANG] = ACTIONS(243),
    [anon_sym_begin] = ACTIONS(245),
    [anon_sym_LPAREN2] = ACTIONS(191),
    [anon_sym_DOT_DOT2] = ACTIONS(497),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(247),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(251),
    [anon_sym_AT_DQUOTE] = ACTIONS(253),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(255),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(257),
    [sym_bool] = ACTIONS(259),
    [sym_unit] = ACTIONS(193),
    [anon_sym_LPAREN_PIPE] = ACTIONS(261),
    [sym_op_identifier] = ACTIONS(263),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(499),
    [sym_xint] = ACTIONS(267),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(269),
    [sym__newline] = ACTIONS(501),
  },
  [67] = {
    [sym_function_or_value_defn] = STATE(663),
    [sym__expression] = STATE(76),
    [sym_literal_expression] = STATE(1118),
    [sym_long_identifier_or_op] = STATE(1118),
    [sym_tuple_expression] = STATE(1118),
    [sym_brace_expression] = STATE(1118),
    [sym_anon_record_expression] = STATE(1118),
    [sym_prefixed_expression] = STATE(1118),
    [sym_typecast_expression] = STATE(1118),
    [sym_for_expression] = STATE(1118),
    [sym_while_expression] = STATE(1118),
    [sym__if_branch] = STATE(7163),
    [sym_if_expression] = STATE(1118),
    [sym_fun_expression] = STATE(1118),
    [sym_try_expression] = STATE(1118),
    [sym_match_expression] = STATE(1118),
    [sym_function_expression] = STATE(1118),
    [sym_mutate_expression] = STATE(1118),
    [sym_index_expression] = STATE(1118),
    [sym_typed_expression] = STATE(1118),
    [sym_declaration_expression] = STATE(1118),
    [sym_do_expression] = STATE(1118),
    [sym_list_expression] = STATE(1118),
    [sym_array_expression] = STATE(1118),
    [sym_begin_end_expression] = STATE(1118),
    [sym_paren_expression] = STATE(1118),
    [sym__high_prec_app] = STATE(1133),
    [sym__low_prec_app] = STATE(1133),
    [sym_application_expression] = STATE(1118),
    [sym_dot_expression] = STATE(1118),
    [sym_infix_expression] = STATE(1118),
    [sym_ce_expression] = STATE(1118),
    [sym_sequential_expression] = STATE(1118),
    [sym_char] = STATE(1080),
    [sym_format_string] = STATE(1090),
    [sym__string_literal] = STATE(1090),
    [sym_string] = STATE(1080),
    [sym_verbatim_string] = STATE(1080),
    [sym_bytearray] = STATE(1080),
    [sym_verbatim_bytearray] = STATE(1080),
    [sym_format_triple_quoted_string] = STATE(1096),
    [sym_triple_quoted_string] = STATE(1080),
    [sym_const] = STATE(1118),
    [sym_long_identifier] = STATE(1156),
    [sym_active_pattern] = STATE(1085),
    [sym__identifier_or_op] = STATE(1099),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(548),
    [sym_infix_op] = STATE(687),
    [sym_sbyte] = STATE(1080),
    [sym_byte] = STATE(1080),
    [sym_int16] = STATE(1080),
    [sym_uint16] = STATE(1080),
    [sym_int32] = STATE(1080),
    [sym_uint32] = STATE(1080),
    [sym_nativeint] = STATE(1080),
    [sym_unativeint] = STATE(1080),
    [sym_int64] = STATE(1080),
    [sym_uint64] = STATE(1080),
    [sym_ieee32] = STATE(1080),
    [sym_ieee64] = STATE(1080),
    [sym_bignum] = STATE(1080),
    [sym_decimal] = STATE(1080),
    [sym_float] = STATE(979),
    [sym_block_comment] = STATE(67),
    [sym_compiler_directive_decl] = STATE(67),
    [sym_fsi_directive_decl] = STATE(67),
    [sym_preproc_line] = STATE(67),
    [sym_preproc_if_in_expression] = STATE(1118),
    [aux_sym_sequential_expression_repeat1] = STATE(1558),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(195),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(197),
    [anon_sym_return] = ACTIONS(481),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_COMMA] = ACTIONS(483),
    [anon_sym_null] = ACTIONS(207),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(197),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(209),
    [anon_sym_RBRACK] = ACTIONS(33),
    [anon_sym_LBRACK_PIPE] = ACTIONS(211),
    [anon_sym_LBRACE] = ACTIONS(59),
    [anon_sym_LT_AT] = ACTIONS(213),
    [anon_sym_LT_AT_AT] = ACTIONS(215),
    [anon_sym_DOT] = ACTIONS(185),
    [anon_sym_LBRACE_PIPE] = ACTIONS(217),
    [anon_sym_new] = ACTIONS(481),
    [anon_sym_return_BANG] = ACTIONS(487),
    [anon_sym_yield] = ACTIONS(481),
    [anon_sym_yield_BANG] = ACTIONS(487),
    [anon_sym_lazy] = ACTIONS(481),
    [anon_sym_assert] = ACTIONS(481),
    [anon_sym_upcast] = ACTIONS(481),
    [anon_sym_downcast] = ACTIONS(481),
    [anon_sym_COLON_GT] = ACTIONS(221),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(221),
    [anon_sym_for] = ACTIONS(489),
    [anon_sym_while] = ACTIONS(225),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(229),
    [anon_sym_match] = ACTIONS(231),
    [anon_sym_match_BANG] = ACTIONS(233),
    [anon_sym_function] = ACTIONS(235),
    [anon_sym_LT_DASH] = ACTIONS(491),
    [anon_sym_DOT_LBRACK] = ACTIONS(187),
    [anon_sym_LT] = ACTIONS(189),
    [anon_sym_use] = ACTIONS(493),
    [anon_sym_use_BANG] = ACTIONS(495),
    [anon_sym_do_BANG] = ACTIONS(243),
    [anon_sym_begin] = ACTIONS(245),
    [anon_sym_LPAREN2] = ACTIONS(191),
    [anon_sym_DOT_DOT2] = ACTIONS(33),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(247),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(251),
    [anon_sym_AT_DQUOTE] = ACTIONS(253),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(255),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(257),
    [sym_bool] = ACTIONS(259),
    [sym_unit] = ACTIONS(193),
    [anon_sym_LPAREN_PIPE] = ACTIONS(261),
    [sym_op_identifier] = ACTIONS(263),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(499),
    [sym_xint] = ACTIONS(267),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(269),
    [sym__newline] = ACTIONS(33),
  },
  [68] = {
    [sym_function_or_value_defn] = STATE(535),
    [sym__expression] = STATE(98),
    [sym_literal_expression] = STATE(2008),
    [sym_long_identifier_or_op] = STATE(2008),
    [sym_tuple_expression] = STATE(2008),
    [sym_brace_expression] = STATE(2008),
    [sym_anon_record_expression] = STATE(2008),
    [sym_prefixed_expression] = STATE(2008),
    [sym_typecast_expression] = STATE(2008),
    [sym_for_expression] = STATE(2008),
    [sym_while_expression] = STATE(2008),
    [sym__if_branch] = STATE(6754),
    [sym_if_expression] = STATE(2008),
    [sym_fun_expression] = STATE(2008),
    [sym_try_expression] = STATE(2008),
    [sym_match_expression] = STATE(2008),
    [sym_function_expression] = STATE(2008),
    [sym_mutate_expression] = STATE(2008),
    [sym_index_expression] = STATE(2008),
    [sym_typed_expression] = STATE(2008),
    [sym_declaration_expression] = STATE(2008),
    [sym_do_expression] = STATE(2008),
    [sym_list_expression] = STATE(2008),
    [sym_array_expression] = STATE(2008),
    [sym_begin_end_expression] = STATE(2008),
    [sym_paren_expression] = STATE(2008),
    [sym__high_prec_app] = STATE(2007),
    [sym__low_prec_app] = STATE(2007),
    [sym_application_expression] = STATE(2008),
    [sym_dot_expression] = STATE(2008),
    [sym_infix_expression] = STATE(2008),
    [sym_ce_expression] = STATE(2008),
    [sym_sequential_expression] = STATE(2008),
    [sym_char] = STATE(1859),
    [sym_format_string] = STATE(1861),
    [sym__string_literal] = STATE(1861),
    [sym_string] = STATE(1859),
    [sym_verbatim_string] = STATE(1859),
    [sym_bytearray] = STATE(1859),
    [sym_verbatim_bytearray] = STATE(1859),
    [sym_format_triple_quoted_string] = STATE(1862),
    [sym_triple_quoted_string] = STATE(1859),
    [sym_const] = STATE(2008),
    [sym_long_identifier] = STATE(1701),
    [sym_active_pattern] = STATE(1702),
    [sym__identifier_or_op] = STATE(1724),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(664),
    [sym_infix_op] = STATE(543),
    [sym_sbyte] = STATE(1859),
    [sym_byte] = STATE(1859),
    [sym_int16] = STATE(1859),
    [sym_uint16] = STATE(1859),
    [sym_int32] = STATE(1859),
    [sym_uint32] = STATE(1859),
    [sym_nativeint] = STATE(1859),
    [sym_unativeint] = STATE(1859),
    [sym_int64] = STATE(1859),
    [sym_uint64] = STATE(1859),
    [sym_ieee32] = STATE(1859),
    [sym_ieee64] = STATE(1859),
    [sym_bignum] = STATE(1859),
    [sym_decimal] = STATE(1859),
    [sym_float] = STATE(1447),
    [sym_block_comment] = STATE(68),
    [sym_compiler_directive_decl] = STATE(68),
    [sym_fsi_directive_decl] = STATE(68),
    [sym_preproc_line] = STATE(68),
    [sym_preproc_if_in_expression] = STATE(2008),
    [aux_sym_sequential_expression_repeat1] = STATE(1490),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(503),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(505),
    [anon_sym_return] = ACTIONS(507),
    [anon_sym_do] = ACTIONS(599),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(511),
    [anon_sym_COMMA] = ACTIONS(513),
    [anon_sym_null] = ACTIONS(515),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(505),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(517),
    [anon_sym_LBRACK_PIPE] = ACTIONS(519),
    [anon_sym_LBRACE] = ACTIONS(59),
    [anon_sym_LT_AT] = ACTIONS(523),
    [anon_sym_LT_AT_AT] = ACTIONS(525),
    [anon_sym_DOT] = ACTIONS(527),
    [anon_sym_LBRACE_PIPE] = ACTIONS(529),
    [anon_sym_new] = ACTIONS(507),
    [anon_sym_return_BANG] = ACTIONS(531),
    [anon_sym_yield] = ACTIONS(507),
    [anon_sym_yield_BANG] = ACTIONS(531),
    [anon_sym_lazy] = ACTIONS(507),
    [anon_sym_assert] = ACTIONS(507),
    [anon_sym_upcast] = ACTIONS(507),
    [anon_sym_downcast] = ACTIONS(507),
    [anon_sym_COLON_GT] = ACTIONS(533),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(533),
    [anon_sym_for] = ACTIONS(535),
    [anon_sym_while] = ACTIONS(537),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(539),
    [anon_sym_DASH_GT] = ACTIONS(59),
    [anon_sym_try] = ACTIONS(543),
    [anon_sym_match] = ACTIONS(545),
    [anon_sym_match_BANG] = ACTIONS(547),
    [anon_sym_function] = ACTIONS(549),
    [anon_sym_LT_DASH] = ACTIONS(551),
    [anon_sym_DOT_LBRACK] = ACTIONS(553),
    [anon_sym_LT] = ACTIONS(555),
    [anon_sym_use] = ACTIONS(557),
    [anon_sym_use_BANG] = ACTIONS(559),
    [anon_sym_do_BANG] = ACTIONS(561),
    [anon_sym_DOT_DOT] = ACTIONS(33),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_LPAREN2] = ACTIONS(567),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(569),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(571),
    [anon_sym_DQUOTE] = ACTIONS(573),
    [anon_sym_AT_DQUOTE] = ACTIONS(575),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(577),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(579),
    [sym_bool] = ACTIONS(581),
    [sym_unit] = ACTIONS(583),
    [anon_sym_LPAREN_PIPE] = ACTIONS(585),
    [sym_op_identifier] = ACTIONS(587),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(589),
    [sym_xint] = ACTIONS(591),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(593),
    [sym__newline] = ACTIONS(33),
  },
  [69] = {
    [sym_function_or_value_defn] = STATE(663),
    [sym__expression] = STATE(76),
    [sym_literal_expression] = STATE(1118),
    [sym_long_identifier_or_op] = STATE(1118),
    [sym_tuple_expression] = STATE(1118),
    [sym_brace_expression] = STATE(1118),
    [sym_anon_record_expression] = STATE(1118),
    [sym_prefixed_expression] = STATE(1118),
    [sym_typecast_expression] = STATE(1118),
    [sym_for_expression] = STATE(1118),
    [sym_while_expression] = STATE(1118),
    [sym__if_branch] = STATE(7163),
    [sym_if_expression] = STATE(1118),
    [sym_fun_expression] = STATE(1118),
    [sym_try_expression] = STATE(1118),
    [sym_match_expression] = STATE(1118),
    [sym_function_expression] = STATE(1118),
    [sym_mutate_expression] = STATE(1118),
    [sym_index_expression] = STATE(1118),
    [sym_typed_expression] = STATE(1118),
    [sym_declaration_expression] = STATE(1118),
    [sym_do_expression] = STATE(1118),
    [sym_list_expression] = STATE(1118),
    [sym_array_expression] = STATE(1118),
    [sym_begin_end_expression] = STATE(1118),
    [sym_paren_expression] = STATE(1118),
    [sym__high_prec_app] = STATE(1133),
    [sym__low_prec_app] = STATE(1133),
    [sym_application_expression] = STATE(1118),
    [sym_dot_expression] = STATE(1118),
    [sym_infix_expression] = STATE(1118),
    [sym_ce_expression] = STATE(1118),
    [sym_sequential_expression] = STATE(1118),
    [sym_char] = STATE(1080),
    [sym_format_string] = STATE(1090),
    [sym__string_literal] = STATE(1090),
    [sym_string] = STATE(1080),
    [sym_verbatim_string] = STATE(1080),
    [sym_bytearray] = STATE(1080),
    [sym_verbatim_bytearray] = STATE(1080),
    [sym_format_triple_quoted_string] = STATE(1096),
    [sym_triple_quoted_string] = STATE(1080),
    [sym_const] = STATE(1118),
    [sym_long_identifier] = STATE(1156),
    [sym_active_pattern] = STATE(1085),
    [sym__identifier_or_op] = STATE(1099),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(548),
    [sym_infix_op] = STATE(687),
    [sym_sbyte] = STATE(1080),
    [sym_byte] = STATE(1080),
    [sym_int16] = STATE(1080),
    [sym_uint16] = STATE(1080),
    [sym_int32] = STATE(1080),
    [sym_uint32] = STATE(1080),
    [sym_nativeint] = STATE(1080),
    [sym_unativeint] = STATE(1080),
    [sym_int64] = STATE(1080),
    [sym_uint64] = STATE(1080),
    [sym_ieee32] = STATE(1080),
    [sym_ieee64] = STATE(1080),
    [sym_bignum] = STATE(1080),
    [sym_decimal] = STATE(1080),
    [sym_float] = STATE(979),
    [sym_block_comment] = STATE(69),
    [sym_compiler_directive_decl] = STATE(69),
    [sym_fsi_directive_decl] = STATE(69),
    [sym_preproc_line] = STATE(69),
    [sym_preproc_if_in_expression] = STATE(1118),
    [aux_sym_sequential_expression_repeat1] = STATE(1558),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(181),
    [anon_sym_EQ] = ACTIONS(183),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_return] = ACTIONS(181),
    [anon_sym_do] = ACTIONS(181),
    [anon_sym_let] = ACTIONS(181),
    [anon_sym_let_BANG] = ACTIONS(183),
    [anon_sym_LPAREN] = ACTIONS(181),
    [anon_sym_COMMA] = ACTIONS(183),
    [anon_sym_null] = ACTIONS(181),
    [anon_sym_QMARK] = ACTIONS(181),
    [anon_sym_COLON_QMARK] = ACTIONS(181),
    [anon_sym_COLON_COLON] = ACTIONS(183),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_RBRACK] = ACTIONS(183),
    [anon_sym_LBRACK_PIPE] = ACTIONS(183),
    [anon_sym_LBRACE] = ACTIONS(181),
    [anon_sym_LT_AT] = ACTIONS(181),
    [anon_sym_LT_AT_AT] = ACTIONS(181),
    [anon_sym_DOT] = ACTIONS(185),
    [anon_sym_LBRACE_PIPE] = ACTIONS(183),
    [anon_sym_new] = ACTIONS(181),
    [anon_sym_return_BANG] = ACTIONS(183),
    [anon_sym_yield] = ACTIONS(181),
    [anon_sym_yield_BANG] = ACTIONS(183),
    [anon_sym_lazy] = ACTIONS(181),
    [anon_sym_assert] = ACTIONS(181),
    [anon_sym_upcast] = ACTIONS(181),
    [anon_sym_downcast] = ACTIONS(181),
    [anon_sym_COLON_GT] = ACTIONS(183),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(183),
    [anon_sym_for] = ACTIONS(181),
    [anon_sym_while] = ACTIONS(181),
    [anon_sym_if] = ACTIONS(181),
    [anon_sym_fun] = ACTIONS(181),
    [anon_sym_try] = ACTIONS(181),
    [anon_sym_match] = ACTIONS(181),
    [anon_sym_match_BANG] = ACTIONS(183),
    [anon_sym_function] = ACTIONS(181),
    [anon_sym_LT_DASH] = ACTIONS(181),
    [anon_sym_DOT_LBRACK] = ACTIONS(187),
    [anon_sym_LT] = ACTIONS(189),
    [anon_sym_use] = ACTIONS(181),
    [anon_sym_use_BANG] = ACTIONS(183),
    [anon_sym_do_BANG] = ACTIONS(183),
    [anon_sym_begin] = ACTIONS(181),
    [anon_sym_LPAREN2] = ACTIONS(191),
    [anon_sym_DOT_DOT2] = ACTIONS(183),
    [anon_sym_or] = ACTIONS(181),
    [aux_sym_char_token1] = ACTIONS(183),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(181),
    [anon_sym_DQUOTE] = ACTIONS(181),
    [anon_sym_AT_DQUOTE] = ACTIONS(183),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(183),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(183),
    [sym_bool] = ACTIONS(181),
    [sym_unit] = ACTIONS(193),
    [anon_sym_LPAREN_PIPE] = ACTIONS(181),
    [sym_op_identifier] = ACTIONS(181),
    [anon_sym_PLUS] = ACTIONS(181),
    [anon_sym_DASH] = ACTIONS(181),
    [anon_sym_PLUS_DOT] = ACTIONS(181),
    [anon_sym_DASH_DOT] = ACTIONS(181),
    [anon_sym_PERCENT] = ACTIONS(181),
    [anon_sym_AMP_AMP] = ACTIONS(181),
    [anon_sym_TILDE] = ACTIONS(183),
    [aux_sym_prefix_op_token1] = ACTIONS(181),
    [aux_sym_infix_op_token1] = ACTIONS(183),
    [aux_sym_infix_op_token2] = ACTIONS(181),
    [anon_sym_PIPE_PIPE] = ACTIONS(181),
    [anon_sym_BANG_EQ] = ACTIONS(181),
    [anon_sym_COLON_EQ] = ACTIONS(183),
    [anon_sym_DOLLAR] = ACTIONS(181),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(181),
    [sym_int] = ACTIONS(181),
    [sym_xint] = ACTIONS(183),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(183),
    [sym__newline] = ACTIONS(183),
  },
  [70] = {
    [sym_function_or_value_defn] = STATE(663),
    [sym__expression] = STATE(76),
    [sym_literal_expression] = STATE(1118),
    [sym_long_identifier_or_op] = STATE(1118),
    [sym_tuple_expression] = STATE(1118),
    [sym_brace_expression] = STATE(1118),
    [sym_anon_record_expression] = STATE(1118),
    [sym_prefixed_expression] = STATE(1118),
    [sym_typecast_expression] = STATE(1118),
    [sym_for_expression] = STATE(1118),
    [sym_while_expression] = STATE(1118),
    [sym__if_branch] = STATE(7163),
    [sym_if_expression] = STATE(1118),
    [sym_fun_expression] = STATE(1118),
    [sym_try_expression] = STATE(1118),
    [sym_match_expression] = STATE(1118),
    [sym_function_expression] = STATE(1118),
    [sym_mutate_expression] = STATE(1118),
    [sym_index_expression] = STATE(1118),
    [sym_typed_expression] = STATE(1118),
    [sym_declaration_expression] = STATE(1118),
    [sym_do_expression] = STATE(1118),
    [sym_list_expression] = STATE(1118),
    [sym_array_expression] = STATE(1118),
    [sym_begin_end_expression] = STATE(1118),
    [sym_paren_expression] = STATE(1118),
    [sym__high_prec_app] = STATE(1133),
    [sym__low_prec_app] = STATE(1133),
    [sym_application_expression] = STATE(1118),
    [sym_dot_expression] = STATE(1118),
    [sym_infix_expression] = STATE(1118),
    [sym_ce_expression] = STATE(1118),
    [sym_sequential_expression] = STATE(1118),
    [sym_char] = STATE(1080),
    [sym_format_string] = STATE(1090),
    [sym__string_literal] = STATE(1090),
    [sym_string] = STATE(1080),
    [sym_verbatim_string] = STATE(1080),
    [sym_bytearray] = STATE(1080),
    [sym_verbatim_bytearray] = STATE(1080),
    [sym_format_triple_quoted_string] = STATE(1096),
    [sym_triple_quoted_string] = STATE(1080),
    [sym_const] = STATE(1118),
    [sym_long_identifier] = STATE(1156),
    [sym_active_pattern] = STATE(1085),
    [sym__identifier_or_op] = STATE(1099),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(548),
    [sym_infix_op] = STATE(687),
    [sym_sbyte] = STATE(1080),
    [sym_byte] = STATE(1080),
    [sym_int16] = STATE(1080),
    [sym_uint16] = STATE(1080),
    [sym_int32] = STATE(1080),
    [sym_uint32] = STATE(1080),
    [sym_nativeint] = STATE(1080),
    [sym_unativeint] = STATE(1080),
    [sym_int64] = STATE(1080),
    [sym_uint64] = STATE(1080),
    [sym_ieee32] = STATE(1080),
    [sym_ieee64] = STATE(1080),
    [sym_bignum] = STATE(1080),
    [sym_decimal] = STATE(1080),
    [sym_float] = STATE(979),
    [sym_block_comment] = STATE(70),
    [sym_compiler_directive_decl] = STATE(70),
    [sym_fsi_directive_decl] = STATE(70),
    [sym_preproc_line] = STATE(70),
    [sym_preproc_if_in_expression] = STATE(1118),
    [aux_sym_sequential_expression_repeat1] = STATE(1558),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(195),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(197),
    [anon_sym_return] = ACTIONS(481),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_COMMA] = ACTIONS(483),
    [anon_sym_null] = ACTIONS(207),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(197),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(209),
    [anon_sym_RBRACK] = ACTIONS(717),
    [anon_sym_LBRACK_PIPE] = ACTIONS(211),
    [anon_sym_LBRACE] = ACTIONS(271),
    [anon_sym_LT_AT] = ACTIONS(213),
    [anon_sym_LT_AT_AT] = ACTIONS(215),
    [anon_sym_DOT] = ACTIONS(185),
    [anon_sym_LBRACE_PIPE] = ACTIONS(217),
    [anon_sym_new] = ACTIONS(481),
    [anon_sym_return_BANG] = ACTIONS(487),
    [anon_sym_yield] = ACTIONS(481),
    [anon_sym_yield_BANG] = ACTIONS(487),
    [anon_sym_lazy] = ACTIONS(481),
    [anon_sym_assert] = ACTIONS(481),
    [anon_sym_upcast] = ACTIONS(481),
    [anon_sym_downcast] = ACTIONS(481),
    [anon_sym_COLON_GT] = ACTIONS(221),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(221),
    [anon_sym_for] = ACTIONS(489),
    [anon_sym_while] = ACTIONS(225),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(229),
    [anon_sym_match] = ACTIONS(231),
    [anon_sym_match_BANG] = ACTIONS(233),
    [anon_sym_function] = ACTIONS(235),
    [anon_sym_LT_DASH] = ACTIONS(491),
    [anon_sym_DOT_LBRACK] = ACTIONS(187),
    [anon_sym_LT] = ACTIONS(189),
    [anon_sym_use] = ACTIONS(493),
    [anon_sym_use_BANG] = ACTIONS(495),
    [anon_sym_do_BANG] = ACTIONS(243),
    [anon_sym_begin] = ACTIONS(245),
    [anon_sym_LPAREN2] = ACTIONS(191),
    [anon_sym_DOT_DOT2] = ACTIONS(497),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(247),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(251),
    [anon_sym_AT_DQUOTE] = ACTIONS(253),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(255),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(257),
    [sym_bool] = ACTIONS(259),
    [sym_unit] = ACTIONS(193),
    [anon_sym_LPAREN_PIPE] = ACTIONS(261),
    [sym_op_identifier] = ACTIONS(263),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(499),
    [sym_xint] = ACTIONS(267),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(269),
    [sym__newline] = ACTIONS(501),
  },
  [71] = {
    [sym_function_or_value_defn] = STATE(663),
    [sym__expression] = STATE(76),
    [sym_literal_expression] = STATE(1118),
    [sym_long_identifier_or_op] = STATE(1118),
    [sym_tuple_expression] = STATE(1118),
    [sym_brace_expression] = STATE(1118),
    [sym_anon_record_expression] = STATE(1118),
    [sym_prefixed_expression] = STATE(1118),
    [sym_typecast_expression] = STATE(1118),
    [sym_for_expression] = STATE(1118),
    [sym_while_expression] = STATE(1118),
    [sym__if_branch] = STATE(7163),
    [sym_if_expression] = STATE(1118),
    [sym_fun_expression] = STATE(1118),
    [sym_try_expression] = STATE(1118),
    [sym_match_expression] = STATE(1118),
    [sym_function_expression] = STATE(1118),
    [sym_mutate_expression] = STATE(1118),
    [sym_index_expression] = STATE(1118),
    [sym_typed_expression] = STATE(1118),
    [sym_declaration_expression] = STATE(1118),
    [sym_do_expression] = STATE(1118),
    [sym_list_expression] = STATE(1118),
    [sym_array_expression] = STATE(1118),
    [sym_begin_end_expression] = STATE(1118),
    [sym_paren_expression] = STATE(1118),
    [sym__high_prec_app] = STATE(1133),
    [sym__low_prec_app] = STATE(1133),
    [sym_application_expression] = STATE(1118),
    [sym_dot_expression] = STATE(1118),
    [sym_infix_expression] = STATE(1118),
    [sym_ce_expression] = STATE(1118),
    [sym_sequential_expression] = STATE(1118),
    [sym_char] = STATE(1080),
    [sym_format_string] = STATE(1090),
    [sym__string_literal] = STATE(1090),
    [sym_string] = STATE(1080),
    [sym_verbatim_string] = STATE(1080),
    [sym_bytearray] = STATE(1080),
    [sym_verbatim_bytearray] = STATE(1080),
    [sym_format_triple_quoted_string] = STATE(1096),
    [sym_triple_quoted_string] = STATE(1080),
    [sym_const] = STATE(1118),
    [sym_long_identifier] = STATE(1156),
    [sym_active_pattern] = STATE(1085),
    [sym__identifier_or_op] = STATE(1099),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(548),
    [sym_infix_op] = STATE(687),
    [sym_sbyte] = STATE(1080),
    [sym_byte] = STATE(1080),
    [sym_int16] = STATE(1080),
    [sym_uint16] = STATE(1080),
    [sym_int32] = STATE(1080),
    [sym_uint32] = STATE(1080),
    [sym_nativeint] = STATE(1080),
    [sym_unativeint] = STATE(1080),
    [sym_int64] = STATE(1080),
    [sym_uint64] = STATE(1080),
    [sym_ieee32] = STATE(1080),
    [sym_ieee64] = STATE(1080),
    [sym_bignum] = STATE(1080),
    [sym_decimal] = STATE(1080),
    [sym_float] = STATE(979),
    [sym_block_comment] = STATE(71),
    [sym_compiler_directive_decl] = STATE(71),
    [sym_fsi_directive_decl] = STATE(71),
    [sym_preproc_line] = STATE(71),
    [sym_preproc_if_in_expression] = STATE(1118),
    [aux_sym_sequential_expression_repeat1] = STATE(1558),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(195),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(197),
    [anon_sym_return] = ACTIONS(481),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_COMMA] = ACTIONS(483),
    [anon_sym_null] = ACTIONS(207),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(197),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(209),
    [anon_sym_RBRACK] = ACTIONS(167),
    [anon_sym_LBRACK_PIPE] = ACTIONS(211),
    [anon_sym_LBRACE] = ACTIONS(169),
    [anon_sym_LT_AT] = ACTIONS(213),
    [anon_sym_LT_AT_AT] = ACTIONS(215),
    [anon_sym_DOT] = ACTIONS(185),
    [anon_sym_LBRACE_PIPE] = ACTIONS(217),
    [anon_sym_new] = ACTIONS(481),
    [anon_sym_return_BANG] = ACTIONS(487),
    [anon_sym_yield] = ACTIONS(481),
    [anon_sym_yield_BANG] = ACTIONS(487),
    [anon_sym_lazy] = ACTIONS(481),
    [anon_sym_assert] = ACTIONS(481),
    [anon_sym_upcast] = ACTIONS(481),
    [anon_sym_downcast] = ACTIONS(481),
    [anon_sym_COLON_GT] = ACTIONS(221),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(221),
    [anon_sym_for] = ACTIONS(489),
    [anon_sym_while] = ACTIONS(225),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(229),
    [anon_sym_match] = ACTIONS(231),
    [anon_sym_match_BANG] = ACTIONS(233),
    [anon_sym_function] = ACTIONS(235),
    [anon_sym_LT_DASH] = ACTIONS(491),
    [anon_sym_DOT_LBRACK] = ACTIONS(187),
    [anon_sym_LT] = ACTIONS(189),
    [anon_sym_use] = ACTIONS(493),
    [anon_sym_use_BANG] = ACTIONS(495),
    [anon_sym_do_BANG] = ACTIONS(243),
    [anon_sym_begin] = ACTIONS(245),
    [anon_sym_LPAREN2] = ACTIONS(191),
    [anon_sym_DOT_DOT2] = ACTIONS(167),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(247),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(251),
    [anon_sym_AT_DQUOTE] = ACTIONS(253),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(255),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(257),
    [sym_bool] = ACTIONS(259),
    [sym_unit] = ACTIONS(193),
    [anon_sym_LPAREN_PIPE] = ACTIONS(261),
    [sym_op_identifier] = ACTIONS(263),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(499),
    [sym_xint] = ACTIONS(267),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(269),
    [sym__newline] = ACTIONS(167),
  },
  [72] = {
    [sym_function_or_value_defn] = STATE(663),
    [sym__expression] = STATE(76),
    [sym_literal_expression] = STATE(1118),
    [sym_long_identifier_or_op] = STATE(1118),
    [sym_tuple_expression] = STATE(1118),
    [sym_brace_expression] = STATE(1118),
    [sym_anon_record_expression] = STATE(1118),
    [sym_prefixed_expression] = STATE(1118),
    [sym_typecast_expression] = STATE(1118),
    [sym_for_expression] = STATE(1118),
    [sym_while_expression] = STATE(1118),
    [sym__if_branch] = STATE(7163),
    [sym_if_expression] = STATE(1118),
    [sym_fun_expression] = STATE(1118),
    [sym_try_expression] = STATE(1118),
    [sym_match_expression] = STATE(1118),
    [sym_function_expression] = STATE(1118),
    [sym_mutate_expression] = STATE(1118),
    [sym_index_expression] = STATE(1118),
    [sym_typed_expression] = STATE(1118),
    [sym_declaration_expression] = STATE(1118),
    [sym_do_expression] = STATE(1118),
    [sym_list_expression] = STATE(1118),
    [sym_array_expression] = STATE(1118),
    [sym_begin_end_expression] = STATE(1118),
    [sym_paren_expression] = STATE(1118),
    [sym__high_prec_app] = STATE(1133),
    [sym__low_prec_app] = STATE(1133),
    [sym_application_expression] = STATE(1118),
    [sym_dot_expression] = STATE(1118),
    [sym_infix_expression] = STATE(1118),
    [sym_ce_expression] = STATE(1118),
    [sym_sequential_expression] = STATE(1118),
    [sym_char] = STATE(1080),
    [sym_format_string] = STATE(1090),
    [sym__string_literal] = STATE(1090),
    [sym_string] = STATE(1080),
    [sym_verbatim_string] = STATE(1080),
    [sym_bytearray] = STATE(1080),
    [sym_verbatim_bytearray] = STATE(1080),
    [sym_format_triple_quoted_string] = STATE(1096),
    [sym_triple_quoted_string] = STATE(1080),
    [sym_const] = STATE(1118),
    [sym_long_identifier] = STATE(1156),
    [sym_active_pattern] = STATE(1085),
    [sym__identifier_or_op] = STATE(1099),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(548),
    [sym_infix_op] = STATE(687),
    [sym_sbyte] = STATE(1080),
    [sym_byte] = STATE(1080),
    [sym_int16] = STATE(1080),
    [sym_uint16] = STATE(1080),
    [sym_int32] = STATE(1080),
    [sym_uint32] = STATE(1080),
    [sym_nativeint] = STATE(1080),
    [sym_unativeint] = STATE(1080),
    [sym_int64] = STATE(1080),
    [sym_uint64] = STATE(1080),
    [sym_ieee32] = STATE(1080),
    [sym_ieee64] = STATE(1080),
    [sym_bignum] = STATE(1080),
    [sym_decimal] = STATE(1080),
    [sym_float] = STATE(979),
    [sym_block_comment] = STATE(72),
    [sym_compiler_directive_decl] = STATE(72),
    [sym_fsi_directive_decl] = STATE(72),
    [sym_preproc_line] = STATE(72),
    [sym_preproc_if_in_expression] = STATE(1118),
    [aux_sym_sequential_expression_repeat1] = STATE(1558),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(195),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(197),
    [anon_sym_return] = ACTIONS(481),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_COMMA] = ACTIONS(483),
    [anon_sym_null] = ACTIONS(207),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(197),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(209),
    [anon_sym_RBRACK] = ACTIONS(163),
    [anon_sym_LBRACK_PIPE] = ACTIONS(211),
    [anon_sym_LBRACE] = ACTIONS(165),
    [anon_sym_LT_AT] = ACTIONS(213),
    [anon_sym_LT_AT_AT] = ACTIONS(215),
    [anon_sym_DOT] = ACTIONS(185),
    [anon_sym_LBRACE_PIPE] = ACTIONS(217),
    [anon_sym_new] = ACTIONS(481),
    [anon_sym_return_BANG] = ACTIONS(487),
    [anon_sym_yield] = ACTIONS(481),
    [anon_sym_yield_BANG] = ACTIONS(487),
    [anon_sym_lazy] = ACTIONS(481),
    [anon_sym_assert] = ACTIONS(481),
    [anon_sym_upcast] = ACTIONS(481),
    [anon_sym_downcast] = ACTIONS(481),
    [anon_sym_COLON_GT] = ACTIONS(221),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(221),
    [anon_sym_for] = ACTIONS(489),
    [anon_sym_while] = ACTIONS(225),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(229),
    [anon_sym_match] = ACTIONS(231),
    [anon_sym_match_BANG] = ACTIONS(233),
    [anon_sym_function] = ACTIONS(235),
    [anon_sym_LT_DASH] = ACTIONS(491),
    [anon_sym_DOT_LBRACK] = ACTIONS(187),
    [anon_sym_LT] = ACTIONS(189),
    [anon_sym_use] = ACTIONS(493),
    [anon_sym_use_BANG] = ACTIONS(495),
    [anon_sym_do_BANG] = ACTIONS(243),
    [anon_sym_begin] = ACTIONS(245),
    [anon_sym_LPAREN2] = ACTIONS(191),
    [anon_sym_DOT_DOT2] = ACTIONS(163),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(247),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(251),
    [anon_sym_AT_DQUOTE] = ACTIONS(253),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(255),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(257),
    [sym_bool] = ACTIONS(259),
    [sym_unit] = ACTIONS(193),
    [anon_sym_LPAREN_PIPE] = ACTIONS(261),
    [sym_op_identifier] = ACTIONS(263),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(499),
    [sym_xint] = ACTIONS(267),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(269),
    [sym__newline] = ACTIONS(163),
  },
  [73] = {
    [sym_function_or_value_defn] = STATE(663),
    [sym__expression] = STATE(76),
    [sym_literal_expression] = STATE(1118),
    [sym_long_identifier_or_op] = STATE(1118),
    [sym_tuple_expression] = STATE(1118),
    [sym_brace_expression] = STATE(1118),
    [sym_anon_record_expression] = STATE(1118),
    [sym_prefixed_expression] = STATE(1118),
    [sym_typecast_expression] = STATE(1118),
    [sym_for_expression] = STATE(1118),
    [sym_while_expression] = STATE(1118),
    [sym__if_branch] = STATE(7163),
    [sym_if_expression] = STATE(1118),
    [sym_fun_expression] = STATE(1118),
    [sym_try_expression] = STATE(1118),
    [sym_match_expression] = STATE(1118),
    [sym_function_expression] = STATE(1118),
    [sym_mutate_expression] = STATE(1118),
    [sym_index_expression] = STATE(1118),
    [sym_typed_expression] = STATE(1118),
    [sym_declaration_expression] = STATE(1118),
    [sym_do_expression] = STATE(1118),
    [sym_list_expression] = STATE(1118),
    [sym_array_expression] = STATE(1118),
    [sym_begin_end_expression] = STATE(1118),
    [sym_paren_expression] = STATE(1118),
    [sym__high_prec_app] = STATE(1133),
    [sym__low_prec_app] = STATE(1133),
    [sym_application_expression] = STATE(1118),
    [sym_dot_expression] = STATE(1118),
    [sym_infix_expression] = STATE(1118),
    [sym_ce_expression] = STATE(1118),
    [sym_sequential_expression] = STATE(1118),
    [sym_char] = STATE(1080),
    [sym_format_string] = STATE(1090),
    [sym__string_literal] = STATE(1090),
    [sym_string] = STATE(1080),
    [sym_verbatim_string] = STATE(1080),
    [sym_bytearray] = STATE(1080),
    [sym_verbatim_bytearray] = STATE(1080),
    [sym_format_triple_quoted_string] = STATE(1096),
    [sym_triple_quoted_string] = STATE(1080),
    [sym_const] = STATE(1118),
    [sym_long_identifier] = STATE(1156),
    [sym_active_pattern] = STATE(1085),
    [sym__identifier_or_op] = STATE(1099),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(548),
    [sym_infix_op] = STATE(687),
    [sym_sbyte] = STATE(1080),
    [sym_byte] = STATE(1080),
    [sym_int16] = STATE(1080),
    [sym_uint16] = STATE(1080),
    [sym_int32] = STATE(1080),
    [sym_uint32] = STATE(1080),
    [sym_nativeint] = STATE(1080),
    [sym_unativeint] = STATE(1080),
    [sym_int64] = STATE(1080),
    [sym_uint64] = STATE(1080),
    [sym_ieee32] = STATE(1080),
    [sym_ieee64] = STATE(1080),
    [sym_bignum] = STATE(1080),
    [sym_decimal] = STATE(1080),
    [sym_float] = STATE(979),
    [sym_block_comment] = STATE(73),
    [sym_compiler_directive_decl] = STATE(73),
    [sym_fsi_directive_decl] = STATE(73),
    [sym_preproc_line] = STATE(73),
    [sym_preproc_if_in_expression] = STATE(1118),
    [aux_sym_sequential_expression_repeat1] = STATE(1558),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(195),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(197),
    [anon_sym_return] = ACTIONS(481),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_COMMA] = ACTIONS(483),
    [anon_sym_null] = ACTIONS(207),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(197),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(209),
    [anon_sym_RBRACK] = ACTIONS(719),
    [anon_sym_LBRACK_PIPE] = ACTIONS(211),
    [anon_sym_LBRACE] = ACTIONS(271),
    [anon_sym_LT_AT] = ACTIONS(213),
    [anon_sym_LT_AT_AT] = ACTIONS(215),
    [anon_sym_DOT] = ACTIONS(185),
    [anon_sym_LBRACE_PIPE] = ACTIONS(217),
    [anon_sym_new] = ACTIONS(481),
    [anon_sym_return_BANG] = ACTIONS(487),
    [anon_sym_yield] = ACTIONS(481),
    [anon_sym_yield_BANG] = ACTIONS(487),
    [anon_sym_lazy] = ACTIONS(481),
    [anon_sym_assert] = ACTIONS(481),
    [anon_sym_upcast] = ACTIONS(481),
    [anon_sym_downcast] = ACTIONS(481),
    [anon_sym_COLON_GT] = ACTIONS(221),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(221),
    [anon_sym_for] = ACTIONS(489),
    [anon_sym_while] = ACTIONS(225),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(229),
    [anon_sym_match] = ACTIONS(231),
    [anon_sym_match_BANG] = ACTIONS(233),
    [anon_sym_function] = ACTIONS(235),
    [anon_sym_LT_DASH] = ACTIONS(491),
    [anon_sym_DOT_LBRACK] = ACTIONS(187),
    [anon_sym_LT] = ACTIONS(189),
    [anon_sym_use] = ACTIONS(493),
    [anon_sym_use_BANG] = ACTIONS(495),
    [anon_sym_do_BANG] = ACTIONS(243),
    [anon_sym_begin] = ACTIONS(245),
    [anon_sym_LPAREN2] = ACTIONS(191),
    [anon_sym_DOT_DOT2] = ACTIONS(497),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(247),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(251),
    [anon_sym_AT_DQUOTE] = ACTIONS(253),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(255),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(257),
    [sym_bool] = ACTIONS(259),
    [sym_unit] = ACTIONS(193),
    [anon_sym_LPAREN_PIPE] = ACTIONS(261),
    [sym_op_identifier] = ACTIONS(263),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(499),
    [sym_xint] = ACTIONS(267),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(269),
    [sym__newline] = ACTIONS(501),
  },
  [74] = {
    [sym_function_or_value_defn] = STATE(535),
    [sym__expression] = STATE(98),
    [sym_literal_expression] = STATE(2008),
    [sym_long_identifier_or_op] = STATE(2008),
    [sym_tuple_expression] = STATE(2008),
    [sym_brace_expression] = STATE(2008),
    [sym_anon_record_expression] = STATE(2008),
    [sym_prefixed_expression] = STATE(2008),
    [sym_typecast_expression] = STATE(2008),
    [sym_for_expression] = STATE(2008),
    [sym_while_expression] = STATE(2008),
    [sym__if_branch] = STATE(6754),
    [sym_if_expression] = STATE(2008),
    [sym_fun_expression] = STATE(2008),
    [sym_try_expression] = STATE(2008),
    [sym_match_expression] = STATE(2008),
    [sym_function_expression] = STATE(2008),
    [sym_mutate_expression] = STATE(2008),
    [sym_index_expression] = STATE(2008),
    [sym_typed_expression] = STATE(2008),
    [sym_declaration_expression] = STATE(2008),
    [sym_do_expression] = STATE(2008),
    [sym_list_expression] = STATE(2008),
    [sym_array_expression] = STATE(2008),
    [sym_begin_end_expression] = STATE(2008),
    [sym_paren_expression] = STATE(2008),
    [sym__high_prec_app] = STATE(2007),
    [sym__low_prec_app] = STATE(2007),
    [sym_application_expression] = STATE(2008),
    [sym_dot_expression] = STATE(2008),
    [sym_infix_expression] = STATE(2008),
    [sym_ce_expression] = STATE(2008),
    [sym_sequential_expression] = STATE(2008),
    [sym_char] = STATE(1859),
    [sym_format_string] = STATE(1861),
    [sym__string_literal] = STATE(1861),
    [sym_string] = STATE(1859),
    [sym_verbatim_string] = STATE(1859),
    [sym_bytearray] = STATE(1859),
    [sym_verbatim_bytearray] = STATE(1859),
    [sym_format_triple_quoted_string] = STATE(1862),
    [sym_triple_quoted_string] = STATE(1859),
    [sym_const] = STATE(2008),
    [sym_long_identifier] = STATE(1701),
    [sym_active_pattern] = STATE(1702),
    [sym__identifier_or_op] = STATE(1724),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(664),
    [sym_infix_op] = STATE(543),
    [sym_sbyte] = STATE(1859),
    [sym_byte] = STATE(1859),
    [sym_int16] = STATE(1859),
    [sym_uint16] = STATE(1859),
    [sym_int32] = STATE(1859),
    [sym_uint32] = STATE(1859),
    [sym_nativeint] = STATE(1859),
    [sym_unativeint] = STATE(1859),
    [sym_int64] = STATE(1859),
    [sym_uint64] = STATE(1859),
    [sym_ieee32] = STATE(1859),
    [sym_ieee64] = STATE(1859),
    [sym_bignum] = STATE(1859),
    [sym_decimal] = STATE(1859),
    [sym_float] = STATE(1447),
    [sym_block_comment] = STATE(74),
    [sym_compiler_directive_decl] = STATE(74),
    [sym_fsi_directive_decl] = STATE(74),
    [sym_preproc_line] = STATE(74),
    [sym_preproc_if_in_expression] = STATE(2008),
    [aux_sym_sequential_expression_repeat1] = STATE(1490),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(503),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(505),
    [anon_sym_return] = ACTIONS(507),
    [anon_sym_do] = ACTIONS(599),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(511),
    [anon_sym_COMMA] = ACTIONS(513),
    [anon_sym_null] = ACTIONS(515),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(505),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(517),
    [anon_sym_LBRACK_PIPE] = ACTIONS(519),
    [anon_sym_LBRACE] = ACTIONS(521),
    [anon_sym_LT_AT] = ACTIONS(523),
    [anon_sym_LT_AT_AT] = ACTIONS(525),
    [anon_sym_DOT] = ACTIONS(527),
    [anon_sym_LBRACE_PIPE] = ACTIONS(529),
    [anon_sym_new] = ACTIONS(507),
    [anon_sym_return_BANG] = ACTIONS(531),
    [anon_sym_yield] = ACTIONS(507),
    [anon_sym_yield_BANG] = ACTIONS(531),
    [anon_sym_lazy] = ACTIONS(507),
    [anon_sym_assert] = ACTIONS(507),
    [anon_sym_upcast] = ACTIONS(507),
    [anon_sym_downcast] = ACTIONS(507),
    [anon_sym_COLON_GT] = ACTIONS(533),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(533),
    [anon_sym_for] = ACTIONS(535),
    [anon_sym_while] = ACTIONS(537),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(539),
    [anon_sym_DASH_GT] = ACTIONS(173),
    [anon_sym_try] = ACTIONS(543),
    [anon_sym_match] = ACTIONS(545),
    [anon_sym_match_BANG] = ACTIONS(547),
    [anon_sym_function] = ACTIONS(549),
    [anon_sym_LT_DASH] = ACTIONS(551),
    [anon_sym_DOT_LBRACK] = ACTIONS(553),
    [anon_sym_LT] = ACTIONS(555),
    [anon_sym_use] = ACTIONS(557),
    [anon_sym_use_BANG] = ACTIONS(559),
    [anon_sym_do_BANG] = ACTIONS(561),
    [anon_sym_DOT_DOT] = ACTIONS(171),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_LPAREN2] = ACTIONS(567),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(569),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(571),
    [anon_sym_DQUOTE] = ACTIONS(573),
    [anon_sym_AT_DQUOTE] = ACTIONS(575),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(577),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(579),
    [sym_bool] = ACTIONS(581),
    [sym_unit] = ACTIONS(583),
    [anon_sym_LPAREN_PIPE] = ACTIONS(585),
    [sym_op_identifier] = ACTIONS(587),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(589),
    [sym_xint] = ACTIONS(591),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(593),
    [sym__newline] = ACTIONS(595),
  },
  [75] = {
    [sym_function_or_value_defn] = STATE(663),
    [sym__expression] = STATE(76),
    [sym_literal_expression] = STATE(1118),
    [sym_long_identifier_or_op] = STATE(1118),
    [sym_tuple_expression] = STATE(1118),
    [sym_brace_expression] = STATE(1118),
    [sym_anon_record_expression] = STATE(1118),
    [sym_prefixed_expression] = STATE(1118),
    [sym_typecast_expression] = STATE(1118),
    [sym_for_expression] = STATE(1118),
    [sym_while_expression] = STATE(1118),
    [sym__if_branch] = STATE(7163),
    [sym_if_expression] = STATE(1118),
    [sym_fun_expression] = STATE(1118),
    [sym_try_expression] = STATE(1118),
    [sym_match_expression] = STATE(1118),
    [sym_function_expression] = STATE(1118),
    [sym_mutate_expression] = STATE(1118),
    [sym_index_expression] = STATE(1118),
    [sym_typed_expression] = STATE(1118),
    [sym_declaration_expression] = STATE(1118),
    [sym_do_expression] = STATE(1118),
    [sym_list_expression] = STATE(1118),
    [sym_array_expression] = STATE(1118),
    [sym_begin_end_expression] = STATE(1118),
    [sym_paren_expression] = STATE(1118),
    [sym__high_prec_app] = STATE(1133),
    [sym__low_prec_app] = STATE(1133),
    [sym_application_expression] = STATE(1118),
    [sym_dot_expression] = STATE(1118),
    [sym_infix_expression] = STATE(1118),
    [sym_ce_expression] = STATE(1118),
    [sym_sequential_expression] = STATE(1118),
    [sym_char] = STATE(1080),
    [sym_format_string] = STATE(1090),
    [sym__string_literal] = STATE(1090),
    [sym_string] = STATE(1080),
    [sym_verbatim_string] = STATE(1080),
    [sym_bytearray] = STATE(1080),
    [sym_verbatim_bytearray] = STATE(1080),
    [sym_format_triple_quoted_string] = STATE(1096),
    [sym_triple_quoted_string] = STATE(1080),
    [sym_const] = STATE(1118),
    [sym_long_identifier] = STATE(1156),
    [sym_active_pattern] = STATE(1085),
    [sym__identifier_or_op] = STATE(1099),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(548),
    [sym_infix_op] = STATE(687),
    [sym_sbyte] = STATE(1080),
    [sym_byte] = STATE(1080),
    [sym_int16] = STATE(1080),
    [sym_uint16] = STATE(1080),
    [sym_int32] = STATE(1080),
    [sym_uint32] = STATE(1080),
    [sym_nativeint] = STATE(1080),
    [sym_unativeint] = STATE(1080),
    [sym_int64] = STATE(1080),
    [sym_uint64] = STATE(1080),
    [sym_ieee32] = STATE(1080),
    [sym_ieee64] = STATE(1080),
    [sym_bignum] = STATE(1080),
    [sym_decimal] = STATE(1080),
    [sym_float] = STATE(979),
    [sym_block_comment] = STATE(75),
    [sym_compiler_directive_decl] = STATE(75),
    [sym_fsi_directive_decl] = STATE(75),
    [sym_preproc_line] = STATE(75),
    [sym_preproc_if_in_expression] = STATE(1118),
    [aux_sym_sequential_expression_repeat1] = STATE(1558),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(195),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(197),
    [anon_sym_return] = ACTIONS(481),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_COMMA] = ACTIONS(483),
    [anon_sym_null] = ACTIONS(207),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(197),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(209),
    [anon_sym_RBRACK] = ACTIONS(159),
    [anon_sym_LBRACK_PIPE] = ACTIONS(211),
    [anon_sym_LBRACE] = ACTIONS(271),
    [anon_sym_LT_AT] = ACTIONS(213),
    [anon_sym_LT_AT_AT] = ACTIONS(215),
    [anon_sym_DOT] = ACTIONS(185),
    [anon_sym_LBRACE_PIPE] = ACTIONS(217),
    [anon_sym_new] = ACTIONS(481),
    [anon_sym_return_BANG] = ACTIONS(487),
    [anon_sym_yield] = ACTIONS(481),
    [anon_sym_yield_BANG] = ACTIONS(487),
    [anon_sym_lazy] = ACTIONS(481),
    [anon_sym_assert] = ACTIONS(481),
    [anon_sym_upcast] = ACTIONS(481),
    [anon_sym_downcast] = ACTIONS(481),
    [anon_sym_COLON_GT] = ACTIONS(221),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(221),
    [anon_sym_for] = ACTIONS(489),
    [anon_sym_while] = ACTIONS(225),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(229),
    [anon_sym_match] = ACTIONS(231),
    [anon_sym_match_BANG] = ACTIONS(233),
    [anon_sym_function] = ACTIONS(235),
    [anon_sym_LT_DASH] = ACTIONS(491),
    [anon_sym_DOT_LBRACK] = ACTIONS(187),
    [anon_sym_LT] = ACTIONS(189),
    [anon_sym_use] = ACTIONS(493),
    [anon_sym_use_BANG] = ACTIONS(495),
    [anon_sym_do_BANG] = ACTIONS(243),
    [anon_sym_begin] = ACTIONS(245),
    [anon_sym_LPAREN2] = ACTIONS(191),
    [anon_sym_DOT_DOT2] = ACTIONS(159),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(247),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(251),
    [anon_sym_AT_DQUOTE] = ACTIONS(253),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(255),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(257),
    [sym_bool] = ACTIONS(259),
    [sym_unit] = ACTIONS(193),
    [anon_sym_LPAREN_PIPE] = ACTIONS(261),
    [sym_op_identifier] = ACTIONS(263),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(499),
    [sym_xint] = ACTIONS(267),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(269),
    [sym__newline] = ACTIONS(501),
  },
  [76] = {
    [sym_function_or_value_defn] = STATE(663),
    [sym__expression] = STATE(76),
    [sym_literal_expression] = STATE(1118),
    [sym_long_identifier_or_op] = STATE(1118),
    [sym_tuple_expression] = STATE(1118),
    [sym_brace_expression] = STATE(1118),
    [sym_anon_record_expression] = STATE(1118),
    [sym_prefixed_expression] = STATE(1118),
    [sym_typecast_expression] = STATE(1118),
    [sym_for_expression] = STATE(1118),
    [sym_while_expression] = STATE(1118),
    [sym__if_branch] = STATE(7163),
    [sym_if_expression] = STATE(1118),
    [sym_fun_expression] = STATE(1118),
    [sym_try_expression] = STATE(1118),
    [sym_match_expression] = STATE(1118),
    [sym_function_expression] = STATE(1118),
    [sym_mutate_expression] = STATE(1118),
    [sym_index_expression] = STATE(1118),
    [sym_typed_expression] = STATE(1118),
    [sym_declaration_expression] = STATE(1118),
    [sym_do_expression] = STATE(1118),
    [sym_list_expression] = STATE(1118),
    [sym_array_expression] = STATE(1118),
    [sym_begin_end_expression] = STATE(1118),
    [sym_paren_expression] = STATE(1118),
    [sym__high_prec_app] = STATE(1133),
    [sym__low_prec_app] = STATE(1133),
    [sym_application_expression] = STATE(1118),
    [sym_dot_expression] = STATE(1118),
    [sym_infix_expression] = STATE(1118),
    [sym_ce_expression] = STATE(1118),
    [sym_sequential_expression] = STATE(1118),
    [sym_char] = STATE(1080),
    [sym_format_string] = STATE(1090),
    [sym__string_literal] = STATE(1090),
    [sym_string] = STATE(1080),
    [sym_verbatim_string] = STATE(1080),
    [sym_bytearray] = STATE(1080),
    [sym_verbatim_bytearray] = STATE(1080),
    [sym_format_triple_quoted_string] = STATE(1096),
    [sym_triple_quoted_string] = STATE(1080),
    [sym_const] = STATE(1118),
    [sym_long_identifier] = STATE(1156),
    [sym_active_pattern] = STATE(1085),
    [sym__identifier_or_op] = STATE(1099),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(548),
    [sym_infix_op] = STATE(687),
    [sym_sbyte] = STATE(1080),
    [sym_byte] = STATE(1080),
    [sym_int16] = STATE(1080),
    [sym_uint16] = STATE(1080),
    [sym_int32] = STATE(1080),
    [sym_uint32] = STATE(1080),
    [sym_nativeint] = STATE(1080),
    [sym_unativeint] = STATE(1080),
    [sym_int64] = STATE(1080),
    [sym_uint64] = STATE(1080),
    [sym_ieee32] = STATE(1080),
    [sym_ieee64] = STATE(1080),
    [sym_bignum] = STATE(1080),
    [sym_decimal] = STATE(1080),
    [sym_float] = STATE(979),
    [sym_block_comment] = STATE(76),
    [sym_compiler_directive_decl] = STATE(76),
    [sym_fsi_directive_decl] = STATE(76),
    [sym_preproc_line] = STATE(76),
    [sym_preproc_if_in_expression] = STATE(1118),
    [aux_sym_sequential_expression_repeat1] = STATE(1558),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_EQ] = ACTIONS(157),
    [anon_sym_COLON] = ACTIONS(155),
    [anon_sym_return] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(155),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_let_BANG] = ACTIONS(157),
    [anon_sym_LPAREN] = ACTIONS(155),
    [anon_sym_COMMA] = ACTIONS(157),
    [anon_sym_null] = ACTIONS(155),
    [anon_sym_QMARK] = ACTIONS(155),
    [anon_sym_COLON_QMARK] = ACTIONS(155),
    [anon_sym_COLON_COLON] = ACTIONS(157),
    [anon_sym_AMP] = ACTIONS(155),
    [anon_sym_LBRACK] = ACTIONS(155),
    [anon_sym_RBRACK] = ACTIONS(157),
    [anon_sym_LBRACK_PIPE] = ACTIONS(157),
    [anon_sym_LBRACE] = ACTIONS(155),
    [anon_sym_LT_AT] = ACTIONS(155),
    [anon_sym_LT_AT_AT] = ACTIONS(155),
    [anon_sym_DOT] = ACTIONS(185),
    [anon_sym_LBRACE_PIPE] = ACTIONS(157),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_return_BANG] = ACTIONS(157),
    [anon_sym_yield] = ACTIONS(155),
    [anon_sym_yield_BANG] = ACTIONS(157),
    [anon_sym_lazy] = ACTIONS(155),
    [anon_sym_assert] = ACTIONS(155),
    [anon_sym_upcast] = ACTIONS(155),
    [anon_sym_downcast] = ACTIONS(155),
    [anon_sym_COLON_GT] = ACTIONS(157),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(157),
    [anon_sym_for] = ACTIONS(155),
    [anon_sym_while] = ACTIONS(155),
    [anon_sym_if] = ACTIONS(155),
    [anon_sym_fun] = ACTIONS(155),
    [anon_sym_try] = ACTIONS(155),
    [anon_sym_match] = ACTIONS(155),
    [anon_sym_match_BANG] = ACTIONS(157),
    [anon_sym_function] = ACTIONS(155),
    [anon_sym_LT_DASH] = ACTIONS(155),
    [anon_sym_DOT_LBRACK] = ACTIONS(187),
    [anon_sym_LT] = ACTIONS(189),
    [anon_sym_use] = ACTIONS(155),
    [anon_sym_use_BANG] = ACTIONS(157),
    [anon_sym_do_BANG] = ACTIONS(157),
    [anon_sym_begin] = ACTIONS(155),
    [anon_sym_LPAREN2] = ACTIONS(191),
    [anon_sym_DOT_DOT2] = ACTIONS(157),
    [anon_sym_or] = ACTIONS(155),
    [aux_sym_char_token1] = ACTIONS(157),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(155),
    [anon_sym_DQUOTE] = ACTIONS(155),
    [anon_sym_AT_DQUOTE] = ACTIONS(157),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(157),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(157),
    [sym_bool] = ACTIONS(155),
    [sym_unit] = ACTIONS(193),
    [anon_sym_LPAREN_PIPE] = ACTIONS(155),
    [sym_op_identifier] = ACTIONS(155),
    [anon_sym_PLUS] = ACTIONS(155),
    [anon_sym_DASH] = ACTIONS(155),
    [anon_sym_PLUS_DOT] = ACTIONS(155),
    [anon_sym_DASH_DOT] = ACTIONS(155),
    [anon_sym_PERCENT] = ACTIONS(155),
    [anon_sym_AMP_AMP] = ACTIONS(155),
    [anon_sym_TILDE] = ACTIONS(157),
    [aux_sym_prefix_op_token1] = ACTIONS(155),
    [aux_sym_infix_op_token1] = ACTIONS(157),
    [aux_sym_infix_op_token2] = ACTIONS(155),
    [anon_sym_PIPE_PIPE] = ACTIONS(155),
    [anon_sym_BANG_EQ] = ACTIONS(155),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_DOLLAR] = ACTIONS(155),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(155),
    [sym_int] = ACTIONS(155),
    [sym_xint] = ACTIONS(157),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(157),
    [sym__newline] = ACTIONS(157),
  },
  [77] = {
    [sym_function_or_value_defn] = STATE(663),
    [sym__expression] = STATE(76),
    [sym_literal_expression] = STATE(1118),
    [sym_long_identifier_or_op] = STATE(1118),
    [sym_tuple_expression] = STATE(1118),
    [sym_brace_expression] = STATE(1118),
    [sym_anon_record_expression] = STATE(1118),
    [sym_prefixed_expression] = STATE(1118),
    [sym_typecast_expression] = STATE(1118),
    [sym_for_expression] = STATE(1118),
    [sym_while_expression] = STATE(1118),
    [sym__if_branch] = STATE(7163),
    [sym_if_expression] = STATE(1118),
    [sym_fun_expression] = STATE(1118),
    [sym_try_expression] = STATE(1118),
    [sym_match_expression] = STATE(1118),
    [sym_function_expression] = STATE(1118),
    [sym_mutate_expression] = STATE(1118),
    [sym_index_expression] = STATE(1118),
    [sym_typed_expression] = STATE(1118),
    [sym_declaration_expression] = STATE(1118),
    [sym_do_expression] = STATE(1118),
    [sym_list_expression] = STATE(1118),
    [sym_array_expression] = STATE(1118),
    [sym_begin_end_expression] = STATE(1118),
    [sym_paren_expression] = STATE(1118),
    [sym__high_prec_app] = STATE(1133),
    [sym__low_prec_app] = STATE(1133),
    [sym_application_expression] = STATE(1118),
    [sym_dot_expression] = STATE(1118),
    [sym_infix_expression] = STATE(1118),
    [sym_ce_expression] = STATE(1118),
    [sym_sequential_expression] = STATE(1118),
    [sym_char] = STATE(1080),
    [sym_format_string] = STATE(1090),
    [sym__string_literal] = STATE(1090),
    [sym_string] = STATE(1080),
    [sym_verbatim_string] = STATE(1080),
    [sym_bytearray] = STATE(1080),
    [sym_verbatim_bytearray] = STATE(1080),
    [sym_format_triple_quoted_string] = STATE(1096),
    [sym_triple_quoted_string] = STATE(1080),
    [sym_const] = STATE(1118),
    [sym_long_identifier] = STATE(1156),
    [sym_active_pattern] = STATE(1085),
    [sym__identifier_or_op] = STATE(1099),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(548),
    [sym_infix_op] = STATE(687),
    [sym_sbyte] = STATE(1080),
    [sym_byte] = STATE(1080),
    [sym_int16] = STATE(1080),
    [sym_uint16] = STATE(1080),
    [sym_int32] = STATE(1080),
    [sym_uint32] = STATE(1080),
    [sym_nativeint] = STATE(1080),
    [sym_unativeint] = STATE(1080),
    [sym_int64] = STATE(1080),
    [sym_uint64] = STATE(1080),
    [sym_ieee32] = STATE(1080),
    [sym_ieee64] = STATE(1080),
    [sym_bignum] = STATE(1080),
    [sym_decimal] = STATE(1080),
    [sym_float] = STATE(979),
    [sym_block_comment] = STATE(77),
    [sym_compiler_directive_decl] = STATE(77),
    [sym_fsi_directive_decl] = STATE(77),
    [sym_preproc_line] = STATE(77),
    [sym_preproc_if_in_expression] = STATE(1118),
    [aux_sym_sequential_expression_repeat1] = STATE(1558),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(195),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(197),
    [anon_sym_return] = ACTIONS(481),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_COMMA] = ACTIONS(483),
    [anon_sym_null] = ACTIONS(207),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(197),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(209),
    [anon_sym_RBRACK] = ACTIONS(721),
    [anon_sym_LBRACK_PIPE] = ACTIONS(211),
    [anon_sym_LBRACE] = ACTIONS(271),
    [anon_sym_LT_AT] = ACTIONS(213),
    [anon_sym_LT_AT_AT] = ACTIONS(215),
    [anon_sym_DOT] = ACTIONS(185),
    [anon_sym_LBRACE_PIPE] = ACTIONS(217),
    [anon_sym_new] = ACTIONS(481),
    [anon_sym_return_BANG] = ACTIONS(487),
    [anon_sym_yield] = ACTIONS(481),
    [anon_sym_yield_BANG] = ACTIONS(487),
    [anon_sym_lazy] = ACTIONS(481),
    [anon_sym_assert] = ACTIONS(481),
    [anon_sym_upcast] = ACTIONS(481),
    [anon_sym_downcast] = ACTIONS(481),
    [anon_sym_COLON_GT] = ACTIONS(221),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(221),
    [anon_sym_for] = ACTIONS(489),
    [anon_sym_while] = ACTIONS(225),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(229),
    [anon_sym_match] = ACTIONS(231),
    [anon_sym_match_BANG] = ACTIONS(233),
    [anon_sym_function] = ACTIONS(235),
    [anon_sym_LT_DASH] = ACTIONS(491),
    [anon_sym_DOT_LBRACK] = ACTIONS(187),
    [anon_sym_LT] = ACTIONS(189),
    [anon_sym_use] = ACTIONS(493),
    [anon_sym_use_BANG] = ACTIONS(495),
    [anon_sym_do_BANG] = ACTIONS(243),
    [anon_sym_begin] = ACTIONS(245),
    [anon_sym_LPAREN2] = ACTIONS(191),
    [anon_sym_DOT_DOT2] = ACTIONS(497),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(247),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(251),
    [anon_sym_AT_DQUOTE] = ACTIONS(253),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(255),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(257),
    [sym_bool] = ACTIONS(259),
    [sym_unit] = ACTIONS(193),
    [anon_sym_LPAREN_PIPE] = ACTIONS(261),
    [sym_op_identifier] = ACTIONS(263),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(499),
    [sym_xint] = ACTIONS(267),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(269),
    [sym__newline] = ACTIONS(501),
  },
  [78] = {
    [sym_function_or_value_defn] = STATE(663),
    [sym__expression] = STATE(76),
    [sym_literal_expression] = STATE(1118),
    [sym_long_identifier_or_op] = STATE(1118),
    [sym_tuple_expression] = STATE(1118),
    [sym_brace_expression] = STATE(1118),
    [sym_anon_record_expression] = STATE(1118),
    [sym_prefixed_expression] = STATE(1118),
    [sym_typecast_expression] = STATE(1118),
    [sym_for_expression] = STATE(1118),
    [sym_while_expression] = STATE(1118),
    [sym__if_branch] = STATE(7163),
    [sym_if_expression] = STATE(1118),
    [sym_fun_expression] = STATE(1118),
    [sym_try_expression] = STATE(1118),
    [sym_match_expression] = STATE(1118),
    [sym_function_expression] = STATE(1118),
    [sym_mutate_expression] = STATE(1118),
    [sym_index_expression] = STATE(1118),
    [sym_typed_expression] = STATE(1118),
    [sym_declaration_expression] = STATE(1118),
    [sym_do_expression] = STATE(1118),
    [sym_list_expression] = STATE(1118),
    [sym_array_expression] = STATE(1118),
    [sym_begin_end_expression] = STATE(1118),
    [sym_paren_expression] = STATE(1118),
    [sym__high_prec_app] = STATE(1133),
    [sym__low_prec_app] = STATE(1133),
    [sym_application_expression] = STATE(1118),
    [sym_dot_expression] = STATE(1118),
    [sym_infix_expression] = STATE(1118),
    [sym_ce_expression] = STATE(1118),
    [sym_sequential_expression] = STATE(1118),
    [sym_char] = STATE(1080),
    [sym_format_string] = STATE(1090),
    [sym__string_literal] = STATE(1090),
    [sym_string] = STATE(1080),
    [sym_verbatim_string] = STATE(1080),
    [sym_bytearray] = STATE(1080),
    [sym_verbatim_bytearray] = STATE(1080),
    [sym_format_triple_quoted_string] = STATE(1096),
    [sym_triple_quoted_string] = STATE(1080),
    [sym_const] = STATE(1118),
    [sym_long_identifier] = STATE(1156),
    [sym_active_pattern] = STATE(1085),
    [sym__identifier_or_op] = STATE(1099),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(548),
    [sym_infix_op] = STATE(687),
    [sym_sbyte] = STATE(1080),
    [sym_byte] = STATE(1080),
    [sym_int16] = STATE(1080),
    [sym_uint16] = STATE(1080),
    [sym_int32] = STATE(1080),
    [sym_uint32] = STATE(1080),
    [sym_nativeint] = STATE(1080),
    [sym_unativeint] = STATE(1080),
    [sym_int64] = STATE(1080),
    [sym_uint64] = STATE(1080),
    [sym_ieee32] = STATE(1080),
    [sym_ieee64] = STATE(1080),
    [sym_bignum] = STATE(1080),
    [sym_decimal] = STATE(1080),
    [sym_float] = STATE(979),
    [sym_block_comment] = STATE(78),
    [sym_compiler_directive_decl] = STATE(78),
    [sym_fsi_directive_decl] = STATE(78),
    [sym_preproc_line] = STATE(78),
    [sym_preproc_if_in_expression] = STATE(1118),
    [aux_sym_sequential_expression_repeat1] = STATE(1558),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(195),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(197),
    [anon_sym_return] = ACTIONS(481),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_COMMA] = ACTIONS(483),
    [anon_sym_null] = ACTIONS(207),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(197),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(209),
    [anon_sym_RBRACK] = ACTIONS(149),
    [anon_sym_LBRACK_PIPE] = ACTIONS(211),
    [anon_sym_LBRACE] = ACTIONS(271),
    [anon_sym_LT_AT] = ACTIONS(213),
    [anon_sym_LT_AT_AT] = ACTIONS(215),
    [anon_sym_DOT] = ACTIONS(185),
    [anon_sym_LBRACE_PIPE] = ACTIONS(217),
    [anon_sym_new] = ACTIONS(481),
    [anon_sym_return_BANG] = ACTIONS(487),
    [anon_sym_yield] = ACTIONS(481),
    [anon_sym_yield_BANG] = ACTIONS(487),
    [anon_sym_lazy] = ACTIONS(481),
    [anon_sym_assert] = ACTIONS(481),
    [anon_sym_upcast] = ACTIONS(481),
    [anon_sym_downcast] = ACTIONS(481),
    [anon_sym_COLON_GT] = ACTIONS(221),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(221),
    [anon_sym_for] = ACTIONS(489),
    [anon_sym_while] = ACTIONS(225),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(229),
    [anon_sym_match] = ACTIONS(231),
    [anon_sym_match_BANG] = ACTIONS(233),
    [anon_sym_function] = ACTIONS(235),
    [anon_sym_LT_DASH] = ACTIONS(491),
    [anon_sym_DOT_LBRACK] = ACTIONS(187),
    [anon_sym_LT] = ACTIONS(189),
    [anon_sym_use] = ACTIONS(493),
    [anon_sym_use_BANG] = ACTIONS(495),
    [anon_sym_do_BANG] = ACTIONS(243),
    [anon_sym_begin] = ACTIONS(245),
    [anon_sym_LPAREN2] = ACTIONS(191),
    [anon_sym_DOT_DOT2] = ACTIONS(149),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(247),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(251),
    [anon_sym_AT_DQUOTE] = ACTIONS(253),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(255),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(257),
    [sym_bool] = ACTIONS(259),
    [sym_unit] = ACTIONS(193),
    [anon_sym_LPAREN_PIPE] = ACTIONS(261),
    [sym_op_identifier] = ACTIONS(263),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(499),
    [sym_xint] = ACTIONS(267),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(269),
    [sym__newline] = ACTIONS(501),
  },
  [79] = {
    [sym_function_or_value_defn] = STATE(663),
    [sym__expression] = STATE(76),
    [sym_literal_expression] = STATE(1118),
    [sym_long_identifier_or_op] = STATE(1118),
    [sym_tuple_expression] = STATE(1118),
    [sym_brace_expression] = STATE(1118),
    [sym_anon_record_expression] = STATE(1118),
    [sym_prefixed_expression] = STATE(1118),
    [sym_typecast_expression] = STATE(1118),
    [sym_for_expression] = STATE(1118),
    [sym_while_expression] = STATE(1118),
    [sym__if_branch] = STATE(7163),
    [sym_if_expression] = STATE(1118),
    [sym_fun_expression] = STATE(1118),
    [sym_try_expression] = STATE(1118),
    [sym_match_expression] = STATE(1118),
    [sym_function_expression] = STATE(1118),
    [sym_mutate_expression] = STATE(1118),
    [sym_index_expression] = STATE(1118),
    [sym_typed_expression] = STATE(1118),
    [sym_declaration_expression] = STATE(1118),
    [sym_do_expression] = STATE(1118),
    [sym_list_expression] = STATE(1118),
    [sym_array_expression] = STATE(1118),
    [sym_begin_end_expression] = STATE(1118),
    [sym_paren_expression] = STATE(1118),
    [sym__high_prec_app] = STATE(1133),
    [sym__low_prec_app] = STATE(1133),
    [sym_application_expression] = STATE(1118),
    [sym_dot_expression] = STATE(1118),
    [sym_infix_expression] = STATE(1118),
    [sym_ce_expression] = STATE(1118),
    [sym_sequential_expression] = STATE(1118),
    [sym_char] = STATE(1080),
    [sym_format_string] = STATE(1090),
    [sym__string_literal] = STATE(1090),
    [sym_string] = STATE(1080),
    [sym_verbatim_string] = STATE(1080),
    [sym_bytearray] = STATE(1080),
    [sym_verbatim_bytearray] = STATE(1080),
    [sym_format_triple_quoted_string] = STATE(1096),
    [sym_triple_quoted_string] = STATE(1080),
    [sym_const] = STATE(1118),
    [sym_long_identifier] = STATE(1156),
    [sym_active_pattern] = STATE(1085),
    [sym__identifier_or_op] = STATE(1099),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(548),
    [sym_infix_op] = STATE(687),
    [sym_sbyte] = STATE(1080),
    [sym_byte] = STATE(1080),
    [sym_int16] = STATE(1080),
    [sym_uint16] = STATE(1080),
    [sym_int32] = STATE(1080),
    [sym_uint32] = STATE(1080),
    [sym_nativeint] = STATE(1080),
    [sym_unativeint] = STATE(1080),
    [sym_int64] = STATE(1080),
    [sym_uint64] = STATE(1080),
    [sym_ieee32] = STATE(1080),
    [sym_ieee64] = STATE(1080),
    [sym_bignum] = STATE(1080),
    [sym_decimal] = STATE(1080),
    [sym_float] = STATE(979),
    [sym_block_comment] = STATE(79),
    [sym_compiler_directive_decl] = STATE(79),
    [sym_fsi_directive_decl] = STATE(79),
    [sym_preproc_line] = STATE(79),
    [sym_preproc_if_in_expression] = STATE(1118),
    [aux_sym_sequential_expression_repeat1] = STATE(1558),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(195),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(197),
    [anon_sym_return] = ACTIONS(481),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_COMMA] = ACTIONS(483),
    [anon_sym_null] = ACTIONS(207),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(197),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(209),
    [anon_sym_RBRACK] = ACTIONS(145),
    [anon_sym_LBRACK_PIPE] = ACTIONS(211),
    [anon_sym_LBRACE] = ACTIONS(271),
    [anon_sym_LT_AT] = ACTIONS(213),
    [anon_sym_LT_AT_AT] = ACTIONS(215),
    [anon_sym_DOT] = ACTIONS(185),
    [anon_sym_LBRACE_PIPE] = ACTIONS(217),
    [anon_sym_new] = ACTIONS(481),
    [anon_sym_return_BANG] = ACTIONS(487),
    [anon_sym_yield] = ACTIONS(481),
    [anon_sym_yield_BANG] = ACTIONS(487),
    [anon_sym_lazy] = ACTIONS(481),
    [anon_sym_assert] = ACTIONS(481),
    [anon_sym_upcast] = ACTIONS(481),
    [anon_sym_downcast] = ACTIONS(481),
    [anon_sym_COLON_GT] = ACTIONS(221),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(221),
    [anon_sym_for] = ACTIONS(489),
    [anon_sym_while] = ACTIONS(225),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(229),
    [anon_sym_match] = ACTIONS(231),
    [anon_sym_match_BANG] = ACTIONS(233),
    [anon_sym_function] = ACTIONS(235),
    [anon_sym_LT_DASH] = ACTIONS(491),
    [anon_sym_DOT_LBRACK] = ACTIONS(187),
    [anon_sym_LT] = ACTIONS(189),
    [anon_sym_use] = ACTIONS(493),
    [anon_sym_use_BANG] = ACTIONS(495),
    [anon_sym_do_BANG] = ACTIONS(243),
    [anon_sym_begin] = ACTIONS(245),
    [anon_sym_LPAREN2] = ACTIONS(191),
    [anon_sym_DOT_DOT2] = ACTIONS(145),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(247),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(251),
    [anon_sym_AT_DQUOTE] = ACTIONS(253),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(255),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(257),
    [sym_bool] = ACTIONS(259),
    [sym_unit] = ACTIONS(193),
    [anon_sym_LPAREN_PIPE] = ACTIONS(261),
    [sym_op_identifier] = ACTIONS(263),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(499),
    [sym_xint] = ACTIONS(267),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(269),
    [sym__newline] = ACTIONS(145),
  },
  [80] = {
    [sym_function_or_value_defn] = STATE(596),
    [sym__expression] = STATE(109),
    [sym_literal_expression] = STATE(1809),
    [sym_long_identifier_or_op] = STATE(1809),
    [sym_tuple_expression] = STATE(1809),
    [sym_brace_expression] = STATE(1809),
    [sym_anon_record_expression] = STATE(1809),
    [sym_prefixed_expression] = STATE(1809),
    [sym_typecast_expression] = STATE(1809),
    [sym_for_expression] = STATE(1809),
    [sym_while_expression] = STATE(1809),
    [sym__if_branch] = STATE(6874),
    [sym_if_expression] = STATE(1809),
    [sym_fun_expression] = STATE(1809),
    [sym_try_expression] = STATE(1809),
    [sym_match_expression] = STATE(1809),
    [sym_function_expression] = STATE(1809),
    [sym_mutate_expression] = STATE(1809),
    [sym_index_expression] = STATE(1809),
    [sym_typed_expression] = STATE(1809),
    [sym_declaration_expression] = STATE(1809),
    [sym_do_expression] = STATE(1809),
    [sym_list_expression] = STATE(1809),
    [sym_array_expression] = STATE(1809),
    [sym_begin_end_expression] = STATE(1809),
    [sym_paren_expression] = STATE(1809),
    [sym__high_prec_app] = STATE(1806),
    [sym__low_prec_app] = STATE(1806),
    [sym_application_expression] = STATE(1809),
    [sym_dot_expression] = STATE(1809),
    [sym_infix_expression] = STATE(1809),
    [sym_ce_expression] = STATE(1809),
    [sym_sequential_expression] = STATE(1809),
    [sym_char] = STATE(2014),
    [sym_format_string] = STATE(2019),
    [sym__string_literal] = STATE(2019),
    [sym_string] = STATE(2014),
    [sym_verbatim_string] = STATE(2014),
    [sym_bytearray] = STATE(2014),
    [sym_verbatim_bytearray] = STATE(2014),
    [sym_format_triple_quoted_string] = STATE(2020),
    [sym_triple_quoted_string] = STATE(2014),
    [sym_const] = STATE(1809),
    [sym_long_identifier] = STATE(1810),
    [sym_active_pattern] = STATE(1860),
    [sym__identifier_or_op] = STATE(1750),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(655),
    [sym_infix_op] = STATE(608),
    [sym_sbyte] = STATE(2014),
    [sym_byte] = STATE(2014),
    [sym_int16] = STATE(2014),
    [sym_uint16] = STATE(2014),
    [sym_int32] = STATE(2014),
    [sym_uint32] = STATE(2014),
    [sym_nativeint] = STATE(2014),
    [sym_unativeint] = STATE(2014),
    [sym_int64] = STATE(2014),
    [sym_uint64] = STATE(2014),
    [sym_ieee32] = STATE(2014),
    [sym_ieee64] = STATE(2014),
    [sym_bignum] = STATE(2014),
    [sym_decimal] = STATE(2014),
    [sym_float] = STATE(1438),
    [sym_block_comment] = STATE(80),
    [sym_compiler_directive_decl] = STATE(80),
    [sym_fsi_directive_decl] = STATE(80),
    [sym_preproc_line] = STATE(80),
    [sym_preproc_if_in_expression] = STATE(1809),
    [aux_sym_sequential_expression_repeat1] = STATE(1620),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(723),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(725),
    [anon_sym_return] = ACTIONS(727),
    [anon_sym_do] = ACTIONS(729),
    [anon_sym_and] = ACTIONS(147),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(731),
    [anon_sym_COMMA] = ACTIONS(733),
    [anon_sym_null] = ACTIONS(735),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(725),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(737),
    [anon_sym_LBRACK_PIPE] = ACTIONS(739),
    [anon_sym_LBRACE] = ACTIONS(741),
    [anon_sym_LT_AT] = ACTIONS(743),
    [anon_sym_LT_AT_AT] = ACTIONS(745),
    [anon_sym_DOT] = ACTIONS(747),
    [anon_sym_LBRACE_PIPE] = ACTIONS(749),
    [anon_sym_new] = ACTIONS(727),
    [anon_sym_return_BANG] = ACTIONS(751),
    [anon_sym_yield] = ACTIONS(727),
    [anon_sym_yield_BANG] = ACTIONS(751),
    [anon_sym_lazy] = ACTIONS(727),
    [anon_sym_assert] = ACTIONS(727),
    [anon_sym_upcast] = ACTIONS(727),
    [anon_sym_downcast] = ACTIONS(727),
    [anon_sym_COLON_GT] = ACTIONS(753),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(753),
    [anon_sym_for] = ACTIONS(755),
    [anon_sym_while] = ACTIONS(757),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(759),
    [anon_sym_try] = ACTIONS(761),
    [anon_sym_match] = ACTIONS(763),
    [anon_sym_match_BANG] = ACTIONS(765),
    [anon_sym_function] = ACTIONS(767),
    [anon_sym_LT_DASH] = ACTIONS(769),
    [anon_sym_DOT_LBRACK] = ACTIONS(771),
    [anon_sym_LT] = ACTIONS(773),
    [anon_sym_use] = ACTIONS(775),
    [anon_sym_use_BANG] = ACTIONS(777),
    [anon_sym_do_BANG] = ACTIONS(779),
    [anon_sym_begin] = ACTIONS(781),
    [anon_sym_LPAREN2] = ACTIONS(783),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(785),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(787),
    [anon_sym_DQUOTE] = ACTIONS(789),
    [anon_sym_AT_DQUOTE] = ACTIONS(791),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(793),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(795),
    [sym_bool] = ACTIONS(797),
    [sym_unit] = ACTIONS(799),
    [anon_sym_LPAREN_PIPE] = ACTIONS(801),
    [sym_op_identifier] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(805),
    [sym_xint] = ACTIONS(807),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(809),
    [sym__newline] = ACTIONS(145),
    [sym__dedent] = ACTIONS(145),
  },
  [81] = {
    [sym_function_or_value_defn] = STATE(663),
    [sym__expression] = STATE(76),
    [sym_literal_expression] = STATE(1118),
    [sym_long_identifier_or_op] = STATE(1118),
    [sym_tuple_expression] = STATE(1118),
    [sym_brace_expression] = STATE(1118),
    [sym_anon_record_expression] = STATE(1118),
    [sym_prefixed_expression] = STATE(1118),
    [sym_typecast_expression] = STATE(1118),
    [sym_for_expression] = STATE(1118),
    [sym_while_expression] = STATE(1118),
    [sym__if_branch] = STATE(7163),
    [sym_if_expression] = STATE(1118),
    [sym_fun_expression] = STATE(1118),
    [sym_try_expression] = STATE(1118),
    [sym_match_expression] = STATE(1118),
    [sym_function_expression] = STATE(1118),
    [sym_mutate_expression] = STATE(1118),
    [sym_index_expression] = STATE(1118),
    [sym_typed_expression] = STATE(1118),
    [sym_declaration_expression] = STATE(1118),
    [sym_do_expression] = STATE(1118),
    [sym_list_expression] = STATE(1118),
    [sym_array_expression] = STATE(1118),
    [sym_begin_end_expression] = STATE(1118),
    [sym_paren_expression] = STATE(1118),
    [sym__high_prec_app] = STATE(1133),
    [sym__low_prec_app] = STATE(1133),
    [sym_application_expression] = STATE(1118),
    [sym_dot_expression] = STATE(1118),
    [sym_infix_expression] = STATE(1118),
    [sym_ce_expression] = STATE(1118),
    [sym_sequential_expression] = STATE(1118),
    [sym_char] = STATE(1080),
    [sym_format_string] = STATE(1090),
    [sym__string_literal] = STATE(1090),
    [sym_string] = STATE(1080),
    [sym_verbatim_string] = STATE(1080),
    [sym_bytearray] = STATE(1080),
    [sym_verbatim_bytearray] = STATE(1080),
    [sym_format_triple_quoted_string] = STATE(1096),
    [sym_triple_quoted_string] = STATE(1080),
    [sym_const] = STATE(1118),
    [sym_long_identifier] = STATE(1156),
    [sym_active_pattern] = STATE(1085),
    [sym__identifier_or_op] = STATE(1099),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(548),
    [sym_infix_op] = STATE(687),
    [sym_sbyte] = STATE(1080),
    [sym_byte] = STATE(1080),
    [sym_int16] = STATE(1080),
    [sym_uint16] = STATE(1080),
    [sym_int32] = STATE(1080),
    [sym_uint32] = STATE(1080),
    [sym_nativeint] = STATE(1080),
    [sym_unativeint] = STATE(1080),
    [sym_int64] = STATE(1080),
    [sym_uint64] = STATE(1080),
    [sym_ieee32] = STATE(1080),
    [sym_ieee64] = STATE(1080),
    [sym_bignum] = STATE(1080),
    [sym_decimal] = STATE(1080),
    [sym_float] = STATE(979),
    [sym_block_comment] = STATE(81),
    [sym_compiler_directive_decl] = STATE(81),
    [sym_fsi_directive_decl] = STATE(81),
    [sym_preproc_line] = STATE(81),
    [sym_preproc_if_in_expression] = STATE(1118),
    [aux_sym_sequential_expression_repeat1] = STATE(1558),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(195),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(197),
    [anon_sym_return] = ACTIONS(481),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_COMMA] = ACTIONS(483),
    [anon_sym_null] = ACTIONS(207),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(197),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(209),
    [anon_sym_RBRACK] = ACTIONS(811),
    [anon_sym_LBRACK_PIPE] = ACTIONS(211),
    [anon_sym_LBRACE] = ACTIONS(271),
    [anon_sym_LT_AT] = ACTIONS(213),
    [anon_sym_LT_AT_AT] = ACTIONS(215),
    [anon_sym_DOT] = ACTIONS(185),
    [anon_sym_LBRACE_PIPE] = ACTIONS(217),
    [anon_sym_new] = ACTIONS(481),
    [anon_sym_return_BANG] = ACTIONS(487),
    [anon_sym_yield] = ACTIONS(481),
    [anon_sym_yield_BANG] = ACTIONS(487),
    [anon_sym_lazy] = ACTIONS(481),
    [anon_sym_assert] = ACTIONS(481),
    [anon_sym_upcast] = ACTIONS(481),
    [anon_sym_downcast] = ACTIONS(481),
    [anon_sym_COLON_GT] = ACTIONS(221),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(221),
    [anon_sym_for] = ACTIONS(489),
    [anon_sym_while] = ACTIONS(225),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(229),
    [anon_sym_match] = ACTIONS(231),
    [anon_sym_match_BANG] = ACTIONS(233),
    [anon_sym_function] = ACTIONS(235),
    [anon_sym_LT_DASH] = ACTIONS(491),
    [anon_sym_DOT_LBRACK] = ACTIONS(187),
    [anon_sym_LT] = ACTIONS(189),
    [anon_sym_use] = ACTIONS(493),
    [anon_sym_use_BANG] = ACTIONS(495),
    [anon_sym_do_BANG] = ACTIONS(243),
    [anon_sym_begin] = ACTIONS(245),
    [anon_sym_LPAREN2] = ACTIONS(191),
    [anon_sym_DOT_DOT2] = ACTIONS(497),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(247),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(251),
    [anon_sym_AT_DQUOTE] = ACTIONS(253),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(255),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(257),
    [sym_bool] = ACTIONS(259),
    [sym_unit] = ACTIONS(193),
    [anon_sym_LPAREN_PIPE] = ACTIONS(261),
    [sym_op_identifier] = ACTIONS(263),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(499),
    [sym_xint] = ACTIONS(267),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(269),
    [sym__newline] = ACTIONS(501),
  },
  [82] = {
    [sym_function_or_value_defn] = STATE(535),
    [sym__expression] = STATE(98),
    [sym_literal_expression] = STATE(2008),
    [sym_long_identifier_or_op] = STATE(2008),
    [sym_tuple_expression] = STATE(2008),
    [sym_brace_expression] = STATE(2008),
    [sym_anon_record_expression] = STATE(2008),
    [sym_prefixed_expression] = STATE(2008),
    [sym_typecast_expression] = STATE(2008),
    [sym_for_expression] = STATE(2008),
    [sym_while_expression] = STATE(2008),
    [sym__if_branch] = STATE(6754),
    [sym_if_expression] = STATE(2008),
    [sym_fun_expression] = STATE(2008),
    [sym_try_expression] = STATE(2008),
    [sym_match_expression] = STATE(2008),
    [sym_function_expression] = STATE(2008),
    [sym_mutate_expression] = STATE(2008),
    [sym_index_expression] = STATE(2008),
    [sym_typed_expression] = STATE(2008),
    [sym_declaration_expression] = STATE(2008),
    [sym_do_expression] = STATE(2008),
    [sym_list_expression] = STATE(2008),
    [sym_array_expression] = STATE(2008),
    [sym_begin_end_expression] = STATE(2008),
    [sym_paren_expression] = STATE(2008),
    [sym__high_prec_app] = STATE(2007),
    [sym__low_prec_app] = STATE(2007),
    [sym_application_expression] = STATE(2008),
    [sym_dot_expression] = STATE(2008),
    [sym_infix_expression] = STATE(2008),
    [sym_ce_expression] = STATE(2008),
    [sym_sequential_expression] = STATE(2008),
    [sym_char] = STATE(1859),
    [sym_format_string] = STATE(1861),
    [sym__string_literal] = STATE(1861),
    [sym_string] = STATE(1859),
    [sym_verbatim_string] = STATE(1859),
    [sym_bytearray] = STATE(1859),
    [sym_verbatim_bytearray] = STATE(1859),
    [sym_format_triple_quoted_string] = STATE(1862),
    [sym_triple_quoted_string] = STATE(1859),
    [sym_const] = STATE(2008),
    [sym_long_identifier] = STATE(1701),
    [sym_active_pattern] = STATE(1702),
    [sym__identifier_or_op] = STATE(1724),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(664),
    [sym_infix_op] = STATE(543),
    [sym_sbyte] = STATE(1859),
    [sym_byte] = STATE(1859),
    [sym_int16] = STATE(1859),
    [sym_uint16] = STATE(1859),
    [sym_int32] = STATE(1859),
    [sym_uint32] = STATE(1859),
    [sym_nativeint] = STATE(1859),
    [sym_unativeint] = STATE(1859),
    [sym_int64] = STATE(1859),
    [sym_uint64] = STATE(1859),
    [sym_ieee32] = STATE(1859),
    [sym_ieee64] = STATE(1859),
    [sym_bignum] = STATE(1859),
    [sym_decimal] = STATE(1859),
    [sym_float] = STATE(1447),
    [sym_block_comment] = STATE(82),
    [sym_compiler_directive_decl] = STATE(82),
    [sym_fsi_directive_decl] = STATE(82),
    [sym_preproc_line] = STATE(82),
    [sym_preproc_if_in_expression] = STATE(2008),
    [aux_sym_sequential_expression_repeat1] = STATE(1490),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(503),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(505),
    [anon_sym_return] = ACTIONS(507),
    [anon_sym_do] = ACTIONS(813),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(511),
    [anon_sym_COMMA] = ACTIONS(513),
    [anon_sym_null] = ACTIONS(515),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(505),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(517),
    [anon_sym_LBRACK_PIPE] = ACTIONS(519),
    [anon_sym_LBRACE] = ACTIONS(521),
    [anon_sym_LT_AT] = ACTIONS(523),
    [anon_sym_LT_AT_AT] = ACTIONS(525),
    [anon_sym_DOT] = ACTIONS(527),
    [anon_sym_LBRACE_PIPE] = ACTIONS(529),
    [anon_sym_new] = ACTIONS(507),
    [anon_sym_return_BANG] = ACTIONS(531),
    [anon_sym_yield] = ACTIONS(507),
    [anon_sym_yield_BANG] = ACTIONS(531),
    [anon_sym_lazy] = ACTIONS(507),
    [anon_sym_assert] = ACTIONS(507),
    [anon_sym_upcast] = ACTIONS(507),
    [anon_sym_downcast] = ACTIONS(507),
    [anon_sym_COLON_GT] = ACTIONS(533),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(533),
    [anon_sym_for] = ACTIONS(535),
    [anon_sym_while] = ACTIONS(537),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(539),
    [anon_sym_DASH_GT] = ACTIONS(813),
    [anon_sym_try] = ACTIONS(543),
    [anon_sym_match] = ACTIONS(545),
    [anon_sym_match_BANG] = ACTIONS(547),
    [anon_sym_function] = ACTIONS(549),
    [anon_sym_LT_DASH] = ACTIONS(551),
    [anon_sym_DOT_LBRACK] = ACTIONS(553),
    [anon_sym_LT] = ACTIONS(555),
    [anon_sym_use] = ACTIONS(557),
    [anon_sym_use_BANG] = ACTIONS(559),
    [anon_sym_do_BANG] = ACTIONS(561),
    [anon_sym_DOT_DOT] = ACTIONS(815),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_LPAREN2] = ACTIONS(567),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(569),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(571),
    [anon_sym_DQUOTE] = ACTIONS(573),
    [anon_sym_AT_DQUOTE] = ACTIONS(575),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(577),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(579),
    [sym_bool] = ACTIONS(581),
    [sym_unit] = ACTIONS(583),
    [anon_sym_LPAREN_PIPE] = ACTIONS(585),
    [sym_op_identifier] = ACTIONS(587),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(589),
    [sym_xint] = ACTIONS(591),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(593),
    [sym__newline] = ACTIONS(595),
  },
  [83] = {
    [sym_function_or_value_defn] = STATE(627),
    [sym__expression] = STATE(17),
    [sym_literal_expression] = STATE(1118),
    [sym_long_identifier_or_op] = STATE(1118),
    [sym_tuple_expression] = STATE(1118),
    [sym_brace_expression] = STATE(1118),
    [sym_anon_record_expression] = STATE(1118),
    [sym_prefixed_expression] = STATE(1118),
    [sym_typecast_expression] = STATE(1118),
    [sym_for_expression] = STATE(1118),
    [sym_while_expression] = STATE(1118),
    [sym__if_branch] = STATE(7163),
    [sym_if_expression] = STATE(1118),
    [sym_fun_expression] = STATE(1118),
    [sym_try_expression] = STATE(1118),
    [sym_match_expression] = STATE(1118),
    [sym_function_expression] = STATE(1118),
    [sym_mutate_expression] = STATE(1118),
    [sym_index_expression] = STATE(1118),
    [sym_typed_expression] = STATE(1118),
    [sym_declaration_expression] = STATE(1118),
    [sym_do_expression] = STATE(1118),
    [sym_list_expression] = STATE(1118),
    [sym_array_expression] = STATE(1118),
    [sym_begin_end_expression] = STATE(1118),
    [sym_paren_expression] = STATE(1118),
    [sym__high_prec_app] = STATE(1133),
    [sym__low_prec_app] = STATE(1133),
    [sym_application_expression] = STATE(1118),
    [sym_dot_expression] = STATE(1118),
    [sym_infix_expression] = STATE(1118),
    [sym_ce_expression] = STATE(1118),
    [sym_sequential_expression] = STATE(1118),
    [sym_char] = STATE(1080),
    [sym_format_string] = STATE(1090),
    [sym__string_literal] = STATE(1090),
    [sym_string] = STATE(1080),
    [sym_verbatim_string] = STATE(1080),
    [sym_bytearray] = STATE(1080),
    [sym_verbatim_bytearray] = STATE(1080),
    [sym_format_triple_quoted_string] = STATE(1096),
    [sym_triple_quoted_string] = STATE(1080),
    [sym_const] = STATE(1118),
    [sym_long_identifier] = STATE(1156),
    [sym_active_pattern] = STATE(1085),
    [sym__identifier_or_op] = STATE(1099),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(517),
    [sym_infix_op] = STATE(487),
    [sym_sbyte] = STATE(1080),
    [sym_byte] = STATE(1080),
    [sym_int16] = STATE(1080),
    [sym_uint16] = STATE(1080),
    [sym_int32] = STATE(1080),
    [sym_uint32] = STATE(1080),
    [sym_nativeint] = STATE(1080),
    [sym_unativeint] = STATE(1080),
    [sym_int64] = STATE(1080),
    [sym_uint64] = STATE(1080),
    [sym_ieee32] = STATE(1080),
    [sym_ieee64] = STATE(1080),
    [sym_bignum] = STATE(1080),
    [sym_decimal] = STATE(1080),
    [sym_float] = STATE(979),
    [sym_block_comment] = STATE(83),
    [sym_compiler_directive_decl] = STATE(83),
    [sym_fsi_directive_decl] = STATE(83),
    [sym_preproc_line] = STATE(83),
    [sym_preproc_if_in_expression] = STATE(1118),
    [aux_sym_sequential_expression_repeat1] = STATE(1069),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(195),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(197),
    [anon_sym_return] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_COMMA] = ACTIONS(205),
    [anon_sym_null] = ACTIONS(207),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(197),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(209),
    [anon_sym_LBRACK_PIPE] = ACTIONS(211),
    [anon_sym_LBRACE] = ACTIONS(271),
    [anon_sym_LT_AT] = ACTIONS(213),
    [anon_sym_LT_AT_AT] = ACTIONS(215),
    [anon_sym_DOT] = ACTIONS(185),
    [anon_sym_LBRACE_PIPE] = ACTIONS(217),
    [anon_sym_new] = ACTIONS(199),
    [anon_sym_return_BANG] = ACTIONS(219),
    [anon_sym_yield] = ACTIONS(199),
    [anon_sym_yield_BANG] = ACTIONS(219),
    [anon_sym_lazy] = ACTIONS(199),
    [anon_sym_assert] = ACTIONS(199),
    [anon_sym_upcast] = ACTIONS(199),
    [anon_sym_downcast] = ACTIONS(199),
    [anon_sym_COLON_GT] = ACTIONS(221),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(221),
    [anon_sym_for] = ACTIONS(223),
    [anon_sym_to] = ACTIONS(817),
    [anon_sym_downto] = ACTIONS(817),
    [anon_sym_while] = ACTIONS(225),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(229),
    [anon_sym_match] = ACTIONS(231),
    [anon_sym_match_BANG] = ACTIONS(233),
    [anon_sym_function] = ACTIONS(235),
    [anon_sym_LT_DASH] = ACTIONS(237),
    [anon_sym_DOT_LBRACK] = ACTIONS(187),
    [anon_sym_LT] = ACTIONS(189),
    [anon_sym_use] = ACTIONS(239),
    [anon_sym_use_BANG] = ACTIONS(241),
    [anon_sym_do_BANG] = ACTIONS(243),
    [anon_sym_begin] = ACTIONS(245),
    [anon_sym_LPAREN2] = ACTIONS(191),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(247),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(251),
    [anon_sym_AT_DQUOTE] = ACTIONS(253),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(255),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(257),
    [sym_bool] = ACTIONS(259),
    [sym_unit] = ACTIONS(193),
    [anon_sym_LPAREN_PIPE] = ACTIONS(261),
    [sym_op_identifier] = ACTIONS(263),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(265),
    [sym_xint] = ACTIONS(267),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(269),
    [sym__newline] = ACTIONS(273),
  },
  [84] = {
    [sym_function_or_value_defn] = STATE(532),
    [sym__expression] = STATE(126),
    [sym_literal_expression] = STATE(2000),
    [sym_long_identifier_or_op] = STATE(2000),
    [sym_tuple_expression] = STATE(2000),
    [sym_brace_expression] = STATE(2000),
    [sym_anon_record_expression] = STATE(2000),
    [sym_prefixed_expression] = STATE(2000),
    [sym_typecast_expression] = STATE(2000),
    [sym_for_expression] = STATE(2000),
    [sym_while_expression] = STATE(2000),
    [sym__if_branch] = STATE(6707),
    [sym_if_expression] = STATE(2000),
    [sym_fun_expression] = STATE(2000),
    [sym_try_expression] = STATE(2000),
    [sym_match_expression] = STATE(2000),
    [sym_function_expression] = STATE(2000),
    [sym_mutate_expression] = STATE(2000),
    [sym_index_expression] = STATE(2000),
    [sym_typed_expression] = STATE(2000),
    [sym_declaration_expression] = STATE(2000),
    [sym_do_expression] = STATE(2000),
    [sym_list_expression] = STATE(2000),
    [sym_array_expression] = STATE(2000),
    [sym_begin_end_expression] = STATE(2000),
    [sym_paren_expression] = STATE(2000),
    [sym__high_prec_app] = STATE(2003),
    [sym__low_prec_app] = STATE(2003),
    [sym_application_expression] = STATE(2000),
    [sym_dot_expression] = STATE(2000),
    [sym_infix_expression] = STATE(2000),
    [sym_ce_expression] = STATE(2000),
    [sym_sequential_expression] = STATE(2000),
    [sym_char] = STATE(1801),
    [sym_format_string] = STATE(1804),
    [sym__string_literal] = STATE(1804),
    [sym_string] = STATE(1801),
    [sym_verbatim_string] = STATE(1801),
    [sym_bytearray] = STATE(1801),
    [sym_verbatim_bytearray] = STATE(1801),
    [sym_format_triple_quoted_string] = STATE(1807),
    [sym_triple_quoted_string] = STATE(1801),
    [sym_const] = STATE(2000),
    [sym_long_identifier] = STATE(1725),
    [sym_active_pattern] = STATE(1726),
    [sym__identifier_or_op] = STATE(1751),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(723),
    [sym_infix_op] = STATE(561),
    [sym_sbyte] = STATE(1801),
    [sym_byte] = STATE(1801),
    [sym_int16] = STATE(1801),
    [sym_uint16] = STATE(1801),
    [sym_int32] = STATE(1801),
    [sym_uint32] = STATE(1801),
    [sym_nativeint] = STATE(1801),
    [sym_unativeint] = STATE(1801),
    [sym_int64] = STATE(1801),
    [sym_uint64] = STATE(1801),
    [sym_ieee32] = STATE(1801),
    [sym_ieee64] = STATE(1801),
    [sym_bignum] = STATE(1801),
    [sym_decimal] = STATE(1801),
    [sym_float] = STATE(1427),
    [sym_block_comment] = STATE(84),
    [sym_compiler_directive_decl] = STATE(84),
    [sym_fsi_directive_decl] = STATE(84),
    [sym_preproc_line] = STATE(84),
    [sym_preproc_if_in_expression] = STATE(2000),
    [aux_sym_sequential_expression_repeat1] = STATE(1635),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(629),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(631),
    [anon_sym_return] = ACTIONS(633),
    [anon_sym_do] = ACTIONS(635),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(637),
    [anon_sym_COMMA] = ACTIONS(639),
    [anon_sym_null] = ACTIONS(641),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(631),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(643),
    [anon_sym_LBRACK_PIPE] = ACTIONS(645),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_LT_AT] = ACTIONS(647),
    [anon_sym_LT_AT_AT] = ACTIONS(649),
    [anon_sym_DOT] = ACTIONS(651),
    [anon_sym_LBRACE_PIPE] = ACTIONS(653),
    [anon_sym_new] = ACTIONS(633),
    [anon_sym_return_BANG] = ACTIONS(655),
    [anon_sym_yield] = ACTIONS(633),
    [anon_sym_yield_BANG] = ACTIONS(655),
    [anon_sym_lazy] = ACTIONS(633),
    [anon_sym_assert] = ACTIONS(633),
    [anon_sym_upcast] = ACTIONS(633),
    [anon_sym_downcast] = ACTIONS(633),
    [anon_sym_COLON_GT] = ACTIONS(657),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(657),
    [anon_sym_for] = ACTIONS(659),
    [anon_sym_while] = ACTIONS(661),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(663),
    [anon_sym_try] = ACTIONS(665),
    [anon_sym_match] = ACTIONS(667),
    [anon_sym_match_BANG] = ACTIONS(669),
    [anon_sym_function] = ACTIONS(671),
    [anon_sym_LT_DASH] = ACTIONS(673),
    [anon_sym_DOT_LBRACK] = ACTIONS(675),
    [anon_sym_LT] = ACTIONS(677),
    [anon_sym_use] = ACTIONS(679),
    [anon_sym_use_BANG] = ACTIONS(681),
    [anon_sym_do_BANG] = ACTIONS(683),
    [anon_sym_begin] = ACTIONS(685),
    [anon_sym_LPAREN2] = ACTIONS(687),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(689),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(691),
    [anon_sym_DQUOTE] = ACTIONS(693),
    [anon_sym_AT_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(697),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(699),
    [sym_bool] = ACTIONS(701),
    [sym_unit] = ACTIONS(703),
    [anon_sym_LPAREN_PIPE] = ACTIONS(705),
    [sym_op_identifier] = ACTIONS(707),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(709),
    [sym_xint] = ACTIONS(711),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(713),
    [anon_sym_POUNDendif] = ACTIONS(821),
    [anon_sym_POUNDelse] = ACTIONS(821),
    [sym__newline] = ACTIONS(823),
  },
  [85] = {
    [sym_function_or_value_defn] = STATE(600),
    [sym__expression] = STATE(88),
    [sym_literal_expression] = STATE(867),
    [sym_long_identifier_or_op] = STATE(867),
    [sym_tuple_expression] = STATE(867),
    [sym_brace_expression] = STATE(867),
    [sym_anon_record_expression] = STATE(867),
    [sym_prefixed_expression] = STATE(867),
    [sym_typecast_expression] = STATE(867),
    [sym_for_expression] = STATE(867),
    [sym_while_expression] = STATE(867),
    [sym__if_branch] = STATE(6511),
    [sym_if_expression] = STATE(867),
    [sym_fun_expression] = STATE(867),
    [sym_try_expression] = STATE(867),
    [sym_match_expression] = STATE(867),
    [sym_function_expression] = STATE(867),
    [sym_mutate_expression] = STATE(867),
    [sym_index_expression] = STATE(867),
    [sym_typed_expression] = STATE(867),
    [sym_declaration_expression] = STATE(867),
    [sym_do_expression] = STATE(867),
    [sym_list_expression] = STATE(867),
    [sym_array_expression] = STATE(867),
    [sym_begin_end_expression] = STATE(867),
    [sym_paren_expression] = STATE(867),
    [sym__high_prec_app] = STATE(864),
    [sym__low_prec_app] = STATE(864),
    [sym_application_expression] = STATE(867),
    [sym_dot_expression] = STATE(867),
    [sym_infix_expression] = STATE(867),
    [sym_ce_expression] = STATE(867),
    [sym_sequential_expression] = STATE(867),
    [sym_char] = STATE(868),
    [sym_format_string] = STATE(869),
    [sym__string_literal] = STATE(869),
    [sym_string] = STATE(868),
    [sym_verbatim_string] = STATE(868),
    [sym_bytearray] = STATE(868),
    [sym_verbatim_bytearray] = STATE(868),
    [sym_format_triple_quoted_string] = STATE(870),
    [sym_triple_quoted_string] = STATE(868),
    [sym_const] = STATE(867),
    [sym_long_identifier] = STATE(872),
    [sym_active_pattern] = STATE(871),
    [sym__identifier_or_op] = STATE(873),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(656),
    [sym_infix_op] = STATE(581),
    [sym_sbyte] = STATE(868),
    [sym_byte] = STATE(868),
    [sym_int16] = STATE(868),
    [sym_uint16] = STATE(868),
    [sym_int32] = STATE(868),
    [sym_uint32] = STATE(868),
    [sym_nativeint] = STATE(868),
    [sym_unativeint] = STATE(868),
    [sym_int64] = STATE(868),
    [sym_uint64] = STATE(868),
    [sym_ieee32] = STATE(868),
    [sym_ieee64] = STATE(868),
    [sym_bignum] = STATE(868),
    [sym_decimal] = STATE(868),
    [sym_float] = STATE(1368),
    [sym_block_comment] = STATE(85),
    [sym_compiler_directive_decl] = STATE(85),
    [sym_fsi_directive_decl] = STATE(85),
    [sym_preproc_line] = STATE(85),
    [sym_preproc_if_in_expression] = STATE(867),
    [aux_sym_sequential_expression_repeat1] = STATE(1542),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(29),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(825),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_COMMA] = ACTIONS(827),
    [anon_sym_null] = ACTIONS(49),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACK_PIPE] = ACTIONS(57),
    [anon_sym_LBRACE] = ACTIONS(139),
    [anon_sym_LT_AT] = ACTIONS(61),
    [anon_sym_LT_AT_AT] = ACTIONS(63),
    [anon_sym_DOT] = ACTIONS(65),
    [anon_sym_LBRACE_PIPE] = ACTIONS(67),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_with] = ACTIONS(147),
    [anon_sym_return_BANG] = ACTIONS(829),
    [anon_sym_yield] = ACTIONS(825),
    [anon_sym_yield_BANG] = ACTIONS(829),
    [anon_sym_lazy] = ACTIONS(825),
    [anon_sym_assert] = ACTIONS(825),
    [anon_sym_upcast] = ACTIONS(825),
    [anon_sym_downcast] = ACTIONS(825),
    [anon_sym_COLON_GT] = ACTIONS(71),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(71),
    [anon_sym_for] = ACTIONS(73),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(79),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_match] = ACTIONS(83),
    [anon_sym_match_BANG] = ACTIONS(85),
    [anon_sym_function] = ACTIONS(87),
    [anon_sym_LT_DASH] = ACTIONS(831),
    [anon_sym_DOT_LBRACK] = ACTIONS(91),
    [anon_sym_LT] = ACTIONS(93),
    [anon_sym_use] = ACTIONS(833),
    [anon_sym_use_BANG] = ACTIONS(835),
    [anon_sym_do_BANG] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(101),
    [anon_sym_LPAREN2] = ACTIONS(103),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(105),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(107),
    [anon_sym_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DQUOTE] = ACTIONS(111),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(115),
    [sym_bool] = ACTIONS(117),
    [sym_unit] = ACTIONS(119),
    [anon_sym_LPAREN_PIPE] = ACTIONS(121),
    [sym_op_identifier] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(837),
    [sym_xint] = ACTIONS(387),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(135),
    [sym__newline] = ACTIONS(145),
    [sym__dedent] = ACTIONS(145),
  },
  [86] = {
    [sym_function_or_value_defn] = STATE(600),
    [sym__expression] = STATE(88),
    [sym_literal_expression] = STATE(867),
    [sym_long_identifier_or_op] = STATE(867),
    [sym_tuple_expression] = STATE(867),
    [sym_brace_expression] = STATE(867),
    [sym_anon_record_expression] = STATE(867),
    [sym_prefixed_expression] = STATE(867),
    [sym_typecast_expression] = STATE(867),
    [sym_for_expression] = STATE(867),
    [sym_while_expression] = STATE(867),
    [sym__if_branch] = STATE(6511),
    [sym_if_expression] = STATE(867),
    [sym_fun_expression] = STATE(867),
    [sym_try_expression] = STATE(867),
    [sym_match_expression] = STATE(867),
    [sym_function_expression] = STATE(867),
    [sym_mutate_expression] = STATE(867),
    [sym_index_expression] = STATE(867),
    [sym_typed_expression] = STATE(867),
    [sym_declaration_expression] = STATE(867),
    [sym_do_expression] = STATE(867),
    [sym_list_expression] = STATE(867),
    [sym_array_expression] = STATE(867),
    [sym_begin_end_expression] = STATE(867),
    [sym_paren_expression] = STATE(867),
    [sym__high_prec_app] = STATE(864),
    [sym__low_prec_app] = STATE(864),
    [sym_application_expression] = STATE(867),
    [sym_dot_expression] = STATE(867),
    [sym_infix_expression] = STATE(867),
    [sym_ce_expression] = STATE(867),
    [sym_sequential_expression] = STATE(867),
    [sym_char] = STATE(868),
    [sym_format_string] = STATE(869),
    [sym__string_literal] = STATE(869),
    [sym_string] = STATE(868),
    [sym_verbatim_string] = STATE(868),
    [sym_bytearray] = STATE(868),
    [sym_verbatim_bytearray] = STATE(868),
    [sym_format_triple_quoted_string] = STATE(870),
    [sym_triple_quoted_string] = STATE(868),
    [sym_const] = STATE(867),
    [sym_long_identifier] = STATE(872),
    [sym_active_pattern] = STATE(871),
    [sym__identifier_or_op] = STATE(873),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(656),
    [sym_infix_op] = STATE(581),
    [sym_sbyte] = STATE(868),
    [sym_byte] = STATE(868),
    [sym_int16] = STATE(868),
    [sym_uint16] = STATE(868),
    [sym_int32] = STATE(868),
    [sym_uint32] = STATE(868),
    [sym_nativeint] = STATE(868),
    [sym_unativeint] = STATE(868),
    [sym_int64] = STATE(868),
    [sym_uint64] = STATE(868),
    [sym_ieee32] = STATE(868),
    [sym_ieee64] = STATE(868),
    [sym_bignum] = STATE(868),
    [sym_decimal] = STATE(868),
    [sym_float] = STATE(1368),
    [sym_block_comment] = STATE(86),
    [sym_compiler_directive_decl] = STATE(86),
    [sym_fsi_directive_decl] = STATE(86),
    [sym_preproc_line] = STATE(86),
    [sym_preproc_if_in_expression] = STATE(867),
    [aux_sym_sequential_expression_repeat1] = STATE(1542),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(29),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(825),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_COMMA] = ACTIONS(827),
    [anon_sym_null] = ACTIONS(49),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACK_PIPE] = ACTIONS(57),
    [anon_sym_LBRACE] = ACTIONS(139),
    [anon_sym_LT_AT] = ACTIONS(61),
    [anon_sym_LT_AT_AT] = ACTIONS(63),
    [anon_sym_DOT] = ACTIONS(65),
    [anon_sym_LBRACE_PIPE] = ACTIONS(67),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_with] = ACTIONS(151),
    [anon_sym_return_BANG] = ACTIONS(829),
    [anon_sym_yield] = ACTIONS(825),
    [anon_sym_yield_BANG] = ACTIONS(829),
    [anon_sym_lazy] = ACTIONS(825),
    [anon_sym_assert] = ACTIONS(825),
    [anon_sym_upcast] = ACTIONS(825),
    [anon_sym_downcast] = ACTIONS(825),
    [anon_sym_COLON_GT] = ACTIONS(71),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(71),
    [anon_sym_for] = ACTIONS(73),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(79),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_match] = ACTIONS(83),
    [anon_sym_match_BANG] = ACTIONS(85),
    [anon_sym_function] = ACTIONS(87),
    [anon_sym_LT_DASH] = ACTIONS(831),
    [anon_sym_DOT_LBRACK] = ACTIONS(91),
    [anon_sym_LT] = ACTIONS(93),
    [anon_sym_use] = ACTIONS(833),
    [anon_sym_use_BANG] = ACTIONS(835),
    [anon_sym_do_BANG] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(101),
    [anon_sym_LPAREN2] = ACTIONS(103),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(105),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(107),
    [anon_sym_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DQUOTE] = ACTIONS(111),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(115),
    [sym_bool] = ACTIONS(117),
    [sym_unit] = ACTIONS(119),
    [anon_sym_LPAREN_PIPE] = ACTIONS(121),
    [sym_op_identifier] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(837),
    [sym_xint] = ACTIONS(387),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(135),
    [sym__newline] = ACTIONS(839),
    [sym__dedent] = ACTIONS(149),
  },
  [87] = {
    [sym_function_or_value_defn] = STATE(663),
    [sym__expression] = STATE(76),
    [sym_literal_expression] = STATE(1118),
    [sym_long_identifier_or_op] = STATE(1118),
    [sym_tuple_expression] = STATE(1118),
    [sym_brace_expression] = STATE(1118),
    [sym_anon_record_expression] = STATE(1118),
    [sym_prefixed_expression] = STATE(1118),
    [sym_typecast_expression] = STATE(1118),
    [sym_for_expression] = STATE(1118),
    [sym_while_expression] = STATE(1118),
    [sym__if_branch] = STATE(7163),
    [sym_if_expression] = STATE(1118),
    [sym_fun_expression] = STATE(1118),
    [sym_try_expression] = STATE(1118),
    [sym_match_expression] = STATE(1118),
    [sym_function_expression] = STATE(1118),
    [sym_mutate_expression] = STATE(1118),
    [sym_index_expression] = STATE(1118),
    [sym_typed_expression] = STATE(1118),
    [sym_declaration_expression] = STATE(1118),
    [sym_do_expression] = STATE(1118),
    [sym_list_expression] = STATE(1118),
    [sym_array_expression] = STATE(1118),
    [sym_begin_end_expression] = STATE(1118),
    [sym_paren_expression] = STATE(1118),
    [sym__high_prec_app] = STATE(1133),
    [sym__low_prec_app] = STATE(1133),
    [sym_application_expression] = STATE(1118),
    [sym_dot_expression] = STATE(1118),
    [sym_infix_expression] = STATE(1118),
    [sym_ce_expression] = STATE(1118),
    [sym_sequential_expression] = STATE(1118),
    [sym_char] = STATE(1080),
    [sym_format_string] = STATE(1090),
    [sym__string_literal] = STATE(1090),
    [sym_string] = STATE(1080),
    [sym_verbatim_string] = STATE(1080),
    [sym_bytearray] = STATE(1080),
    [sym_verbatim_bytearray] = STATE(1080),
    [sym_format_triple_quoted_string] = STATE(1096),
    [sym_triple_quoted_string] = STATE(1080),
    [sym_const] = STATE(1118),
    [sym_long_identifier] = STATE(1156),
    [sym_active_pattern] = STATE(1085),
    [sym__identifier_or_op] = STATE(1099),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(548),
    [sym_infix_op] = STATE(687),
    [sym_sbyte] = STATE(1080),
    [sym_byte] = STATE(1080),
    [sym_int16] = STATE(1080),
    [sym_uint16] = STATE(1080),
    [sym_int32] = STATE(1080),
    [sym_uint32] = STATE(1080),
    [sym_nativeint] = STATE(1080),
    [sym_unativeint] = STATE(1080),
    [sym_int64] = STATE(1080),
    [sym_uint64] = STATE(1080),
    [sym_ieee32] = STATE(1080),
    [sym_ieee64] = STATE(1080),
    [sym_bignum] = STATE(1080),
    [sym_decimal] = STATE(1080),
    [sym_float] = STATE(979),
    [sym_block_comment] = STATE(87),
    [sym_compiler_directive_decl] = STATE(87),
    [sym_fsi_directive_decl] = STATE(87),
    [sym_preproc_line] = STATE(87),
    [sym_preproc_if_in_expression] = STATE(1118),
    [aux_sym_sequential_expression_repeat1] = STATE(1558),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(195),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(197),
    [anon_sym_return] = ACTIONS(481),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_COMMA] = ACTIONS(483),
    [anon_sym_null] = ACTIONS(207),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(197),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(209),
    [anon_sym_RBRACK] = ACTIONS(841),
    [anon_sym_LBRACK_PIPE] = ACTIONS(211),
    [anon_sym_LBRACE] = ACTIONS(271),
    [anon_sym_LT_AT] = ACTIONS(213),
    [anon_sym_LT_AT_AT] = ACTIONS(215),
    [anon_sym_DOT] = ACTIONS(185),
    [anon_sym_LBRACE_PIPE] = ACTIONS(217),
    [anon_sym_new] = ACTIONS(481),
    [anon_sym_return_BANG] = ACTIONS(487),
    [anon_sym_yield] = ACTIONS(481),
    [anon_sym_yield_BANG] = ACTIONS(487),
    [anon_sym_lazy] = ACTIONS(481),
    [anon_sym_assert] = ACTIONS(481),
    [anon_sym_upcast] = ACTIONS(481),
    [anon_sym_downcast] = ACTIONS(481),
    [anon_sym_COLON_GT] = ACTIONS(221),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(221),
    [anon_sym_for] = ACTIONS(489),
    [anon_sym_while] = ACTIONS(225),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(229),
    [anon_sym_match] = ACTIONS(231),
    [anon_sym_match_BANG] = ACTIONS(233),
    [anon_sym_function] = ACTIONS(235),
    [anon_sym_LT_DASH] = ACTIONS(491),
    [anon_sym_DOT_LBRACK] = ACTIONS(187),
    [anon_sym_LT] = ACTIONS(189),
    [anon_sym_use] = ACTIONS(493),
    [anon_sym_use_BANG] = ACTIONS(495),
    [anon_sym_do_BANG] = ACTIONS(243),
    [anon_sym_begin] = ACTIONS(245),
    [anon_sym_LPAREN2] = ACTIONS(191),
    [anon_sym_DOT_DOT2] = ACTIONS(497),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(247),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(251),
    [anon_sym_AT_DQUOTE] = ACTIONS(253),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(255),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(257),
    [sym_bool] = ACTIONS(259),
    [sym_unit] = ACTIONS(193),
    [anon_sym_LPAREN_PIPE] = ACTIONS(261),
    [sym_op_identifier] = ACTIONS(263),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(499),
    [sym_xint] = ACTIONS(267),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(269),
    [sym__newline] = ACTIONS(501),
  },
  [88] = {
    [sym_function_or_value_defn] = STATE(600),
    [sym__expression] = STATE(88),
    [sym_literal_expression] = STATE(867),
    [sym_long_identifier_or_op] = STATE(867),
    [sym_tuple_expression] = STATE(867),
    [sym_brace_expression] = STATE(867),
    [sym_anon_record_expression] = STATE(867),
    [sym_prefixed_expression] = STATE(867),
    [sym_typecast_expression] = STATE(867),
    [sym_for_expression] = STATE(867),
    [sym_while_expression] = STATE(867),
    [sym__if_branch] = STATE(6511),
    [sym_if_expression] = STATE(867),
    [sym_fun_expression] = STATE(867),
    [sym_try_expression] = STATE(867),
    [sym_match_expression] = STATE(867),
    [sym_function_expression] = STATE(867),
    [sym_mutate_expression] = STATE(867),
    [sym_index_expression] = STATE(867),
    [sym_typed_expression] = STATE(867),
    [sym_declaration_expression] = STATE(867),
    [sym_do_expression] = STATE(867),
    [sym_list_expression] = STATE(867),
    [sym_array_expression] = STATE(867),
    [sym_begin_end_expression] = STATE(867),
    [sym_paren_expression] = STATE(867),
    [sym__high_prec_app] = STATE(864),
    [sym__low_prec_app] = STATE(864),
    [sym_application_expression] = STATE(867),
    [sym_dot_expression] = STATE(867),
    [sym_infix_expression] = STATE(867),
    [sym_ce_expression] = STATE(867),
    [sym_sequential_expression] = STATE(867),
    [sym_char] = STATE(868),
    [sym_format_string] = STATE(869),
    [sym__string_literal] = STATE(869),
    [sym_string] = STATE(868),
    [sym_verbatim_string] = STATE(868),
    [sym_bytearray] = STATE(868),
    [sym_verbatim_bytearray] = STATE(868),
    [sym_format_triple_quoted_string] = STATE(870),
    [sym_triple_quoted_string] = STATE(868),
    [sym_const] = STATE(867),
    [sym_long_identifier] = STATE(872),
    [sym_active_pattern] = STATE(871),
    [sym__identifier_or_op] = STATE(873),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(656),
    [sym_infix_op] = STATE(581),
    [sym_sbyte] = STATE(868),
    [sym_byte] = STATE(868),
    [sym_int16] = STATE(868),
    [sym_uint16] = STATE(868),
    [sym_int32] = STATE(868),
    [sym_uint32] = STATE(868),
    [sym_nativeint] = STATE(868),
    [sym_unativeint] = STATE(868),
    [sym_int64] = STATE(868),
    [sym_uint64] = STATE(868),
    [sym_ieee32] = STATE(868),
    [sym_ieee64] = STATE(868),
    [sym_bignum] = STATE(868),
    [sym_decimal] = STATE(868),
    [sym_float] = STATE(1368),
    [sym_block_comment] = STATE(88),
    [sym_compiler_directive_decl] = STATE(88),
    [sym_fsi_directive_decl] = STATE(88),
    [sym_preproc_line] = STATE(88),
    [sym_preproc_if_in_expression] = STATE(867),
    [aux_sym_sequential_expression_repeat1] = STATE(1542),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_EQ] = ACTIONS(157),
    [anon_sym_COLON] = ACTIONS(155),
    [anon_sym_return] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(155),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_let_BANG] = ACTIONS(157),
    [anon_sym_LPAREN] = ACTIONS(155),
    [anon_sym_COMMA] = ACTIONS(157),
    [anon_sym_null] = ACTIONS(155),
    [anon_sym_QMARK] = ACTIONS(155),
    [anon_sym_COLON_QMARK] = ACTIONS(155),
    [anon_sym_COLON_COLON] = ACTIONS(157),
    [anon_sym_AMP] = ACTIONS(155),
    [anon_sym_LBRACK] = ACTIONS(155),
    [anon_sym_LBRACK_PIPE] = ACTIONS(157),
    [anon_sym_LBRACE] = ACTIONS(155),
    [anon_sym_LT_AT] = ACTIONS(155),
    [anon_sym_LT_AT_AT] = ACTIONS(155),
    [anon_sym_DOT] = ACTIONS(65),
    [anon_sym_LBRACE_PIPE] = ACTIONS(157),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_with] = ACTIONS(155),
    [anon_sym_return_BANG] = ACTIONS(157),
    [anon_sym_yield] = ACTIONS(155),
    [anon_sym_yield_BANG] = ACTIONS(157),
    [anon_sym_lazy] = ACTIONS(155),
    [anon_sym_assert] = ACTIONS(155),
    [anon_sym_upcast] = ACTIONS(155),
    [anon_sym_downcast] = ACTIONS(155),
    [anon_sym_COLON_GT] = ACTIONS(157),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(157),
    [anon_sym_for] = ACTIONS(155),
    [anon_sym_while] = ACTIONS(155),
    [anon_sym_if] = ACTIONS(155),
    [anon_sym_fun] = ACTIONS(155),
    [anon_sym_try] = ACTIONS(155),
    [anon_sym_match] = ACTIONS(155),
    [anon_sym_match_BANG] = ACTIONS(157),
    [anon_sym_function] = ACTIONS(155),
    [anon_sym_LT_DASH] = ACTIONS(155),
    [anon_sym_DOT_LBRACK] = ACTIONS(91),
    [anon_sym_LT] = ACTIONS(93),
    [anon_sym_use] = ACTIONS(155),
    [anon_sym_use_BANG] = ACTIONS(157),
    [anon_sym_do_BANG] = ACTIONS(157),
    [anon_sym_begin] = ACTIONS(155),
    [anon_sym_LPAREN2] = ACTIONS(103),
    [anon_sym_or] = ACTIONS(155),
    [aux_sym_char_token1] = ACTIONS(157),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(155),
    [anon_sym_DQUOTE] = ACTIONS(155),
    [anon_sym_AT_DQUOTE] = ACTIONS(157),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(157),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(157),
    [sym_bool] = ACTIONS(155),
    [sym_unit] = ACTIONS(119),
    [anon_sym_LPAREN_PIPE] = ACTIONS(155),
    [sym_op_identifier] = ACTIONS(155),
    [anon_sym_PLUS] = ACTIONS(155),
    [anon_sym_DASH] = ACTIONS(155),
    [anon_sym_PLUS_DOT] = ACTIONS(155),
    [anon_sym_DASH_DOT] = ACTIONS(155),
    [anon_sym_PERCENT] = ACTIONS(155),
    [anon_sym_AMP_AMP] = ACTIONS(155),
    [anon_sym_TILDE] = ACTIONS(157),
    [aux_sym_prefix_op_token1] = ACTIONS(155),
    [aux_sym_infix_op_token1] = ACTIONS(157),
    [aux_sym_infix_op_token2] = ACTIONS(155),
    [anon_sym_PIPE_PIPE] = ACTIONS(155),
    [anon_sym_BANG_EQ] = ACTIONS(155),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_DOLLAR] = ACTIONS(155),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(155),
    [sym_int] = ACTIONS(155),
    [sym_xint] = ACTIONS(157),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(157),
    [sym__newline] = ACTIONS(157),
    [sym__dedent] = ACTIONS(157),
  },
  [89] = {
    [sym_function_or_value_defn] = STATE(600),
    [sym__expression] = STATE(88),
    [sym_literal_expression] = STATE(867),
    [sym_long_identifier_or_op] = STATE(867),
    [sym_tuple_expression] = STATE(867),
    [sym_brace_expression] = STATE(867),
    [sym_anon_record_expression] = STATE(867),
    [sym_prefixed_expression] = STATE(867),
    [sym_typecast_expression] = STATE(867),
    [sym_for_expression] = STATE(867),
    [sym_while_expression] = STATE(867),
    [sym__if_branch] = STATE(6511),
    [sym_if_expression] = STATE(867),
    [sym_fun_expression] = STATE(867),
    [sym_try_expression] = STATE(867),
    [sym_match_expression] = STATE(867),
    [sym_function_expression] = STATE(867),
    [sym_mutate_expression] = STATE(867),
    [sym_index_expression] = STATE(867),
    [sym_typed_expression] = STATE(867),
    [sym_declaration_expression] = STATE(867),
    [sym_do_expression] = STATE(867),
    [sym_list_expression] = STATE(867),
    [sym_array_expression] = STATE(867),
    [sym_begin_end_expression] = STATE(867),
    [sym_paren_expression] = STATE(867),
    [sym__high_prec_app] = STATE(864),
    [sym__low_prec_app] = STATE(864),
    [sym_application_expression] = STATE(867),
    [sym_dot_expression] = STATE(867),
    [sym_infix_expression] = STATE(867),
    [sym_ce_expression] = STATE(867),
    [sym_sequential_expression] = STATE(867),
    [sym_char] = STATE(868),
    [sym_format_string] = STATE(869),
    [sym__string_literal] = STATE(869),
    [sym_string] = STATE(868),
    [sym_verbatim_string] = STATE(868),
    [sym_bytearray] = STATE(868),
    [sym_verbatim_bytearray] = STATE(868),
    [sym_format_triple_quoted_string] = STATE(870),
    [sym_triple_quoted_string] = STATE(868),
    [sym_const] = STATE(867),
    [sym_long_identifier] = STATE(872),
    [sym_active_pattern] = STATE(871),
    [sym__identifier_or_op] = STATE(873),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(656),
    [sym_infix_op] = STATE(581),
    [sym_sbyte] = STATE(868),
    [sym_byte] = STATE(868),
    [sym_int16] = STATE(868),
    [sym_uint16] = STATE(868),
    [sym_int32] = STATE(868),
    [sym_uint32] = STATE(868),
    [sym_nativeint] = STATE(868),
    [sym_unativeint] = STATE(868),
    [sym_int64] = STATE(868),
    [sym_uint64] = STATE(868),
    [sym_ieee32] = STATE(868),
    [sym_ieee64] = STATE(868),
    [sym_bignum] = STATE(868),
    [sym_decimal] = STATE(868),
    [sym_float] = STATE(1368),
    [sym_block_comment] = STATE(89),
    [sym_compiler_directive_decl] = STATE(89),
    [sym_fsi_directive_decl] = STATE(89),
    [sym_preproc_line] = STATE(89),
    [sym_preproc_if_in_expression] = STATE(867),
    [aux_sym_sequential_expression_repeat1] = STATE(1542),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(29),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(825),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_COMMA] = ACTIONS(827),
    [anon_sym_null] = ACTIONS(49),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACK_PIPE] = ACTIONS(57),
    [anon_sym_LBRACE] = ACTIONS(139),
    [anon_sym_LT_AT] = ACTIONS(61),
    [anon_sym_LT_AT_AT] = ACTIONS(63),
    [anon_sym_DOT] = ACTIONS(65),
    [anon_sym_LBRACE_PIPE] = ACTIONS(67),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_with] = ACTIONS(161),
    [anon_sym_return_BANG] = ACTIONS(829),
    [anon_sym_yield] = ACTIONS(825),
    [anon_sym_yield_BANG] = ACTIONS(829),
    [anon_sym_lazy] = ACTIONS(825),
    [anon_sym_assert] = ACTIONS(825),
    [anon_sym_upcast] = ACTIONS(825),
    [anon_sym_downcast] = ACTIONS(825),
    [anon_sym_COLON_GT] = ACTIONS(71),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(71),
    [anon_sym_for] = ACTIONS(73),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(79),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_match] = ACTIONS(83),
    [anon_sym_match_BANG] = ACTIONS(85),
    [anon_sym_function] = ACTIONS(87),
    [anon_sym_LT_DASH] = ACTIONS(831),
    [anon_sym_DOT_LBRACK] = ACTIONS(91),
    [anon_sym_LT] = ACTIONS(93),
    [anon_sym_use] = ACTIONS(833),
    [anon_sym_use_BANG] = ACTIONS(835),
    [anon_sym_do_BANG] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(101),
    [anon_sym_LPAREN2] = ACTIONS(103),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(105),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(107),
    [anon_sym_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DQUOTE] = ACTIONS(111),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(115),
    [sym_bool] = ACTIONS(117),
    [sym_unit] = ACTIONS(119),
    [anon_sym_LPAREN_PIPE] = ACTIONS(121),
    [sym_op_identifier] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(837),
    [sym_xint] = ACTIONS(387),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(135),
    [sym__newline] = ACTIONS(839),
    [sym__dedent] = ACTIONS(159),
  },
  [90] = {
    [sym_function_or_value_defn] = STATE(600),
    [sym__expression] = STATE(88),
    [sym_literal_expression] = STATE(867),
    [sym_long_identifier_or_op] = STATE(867),
    [sym_tuple_expression] = STATE(867),
    [sym_brace_expression] = STATE(867),
    [sym_anon_record_expression] = STATE(867),
    [sym_prefixed_expression] = STATE(867),
    [sym_typecast_expression] = STATE(867),
    [sym_for_expression] = STATE(867),
    [sym_while_expression] = STATE(867),
    [sym__if_branch] = STATE(6511),
    [sym_if_expression] = STATE(867),
    [sym_fun_expression] = STATE(867),
    [sym_try_expression] = STATE(867),
    [sym_match_expression] = STATE(867),
    [sym_function_expression] = STATE(867),
    [sym_mutate_expression] = STATE(867),
    [sym_index_expression] = STATE(867),
    [sym_typed_expression] = STATE(867),
    [sym_declaration_expression] = STATE(867),
    [sym_do_expression] = STATE(867),
    [sym_list_expression] = STATE(867),
    [sym_array_expression] = STATE(867),
    [sym_begin_end_expression] = STATE(867),
    [sym_paren_expression] = STATE(867),
    [sym__high_prec_app] = STATE(864),
    [sym__low_prec_app] = STATE(864),
    [sym_application_expression] = STATE(867),
    [sym_dot_expression] = STATE(867),
    [sym_infix_expression] = STATE(867),
    [sym_ce_expression] = STATE(867),
    [sym_sequential_expression] = STATE(867),
    [sym_char] = STATE(868),
    [sym_format_string] = STATE(869),
    [sym__string_literal] = STATE(869),
    [sym_string] = STATE(868),
    [sym_verbatim_string] = STATE(868),
    [sym_bytearray] = STATE(868),
    [sym_verbatim_bytearray] = STATE(868),
    [sym_format_triple_quoted_string] = STATE(870),
    [sym_triple_quoted_string] = STATE(868),
    [sym_const] = STATE(867),
    [sym_long_identifier] = STATE(872),
    [sym_active_pattern] = STATE(871),
    [sym__identifier_or_op] = STATE(873),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(656),
    [sym_infix_op] = STATE(581),
    [sym_sbyte] = STATE(868),
    [sym_byte] = STATE(868),
    [sym_int16] = STATE(868),
    [sym_uint16] = STATE(868),
    [sym_int32] = STATE(868),
    [sym_uint32] = STATE(868),
    [sym_nativeint] = STATE(868),
    [sym_unativeint] = STATE(868),
    [sym_int64] = STATE(868),
    [sym_uint64] = STATE(868),
    [sym_ieee32] = STATE(868),
    [sym_ieee64] = STATE(868),
    [sym_bignum] = STATE(868),
    [sym_decimal] = STATE(868),
    [sym_float] = STATE(1368),
    [sym_block_comment] = STATE(90),
    [sym_compiler_directive_decl] = STATE(90),
    [sym_fsi_directive_decl] = STATE(90),
    [sym_preproc_line] = STATE(90),
    [sym_preproc_if_in_expression] = STATE(867),
    [aux_sym_sequential_expression_repeat1] = STATE(1542),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(29),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(825),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_COMMA] = ACTIONS(827),
    [anon_sym_null] = ACTIONS(49),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACK_PIPE] = ACTIONS(57),
    [anon_sym_LBRACE] = ACTIONS(165),
    [anon_sym_LT_AT] = ACTIONS(61),
    [anon_sym_LT_AT_AT] = ACTIONS(63),
    [anon_sym_DOT] = ACTIONS(65),
    [anon_sym_LBRACE_PIPE] = ACTIONS(67),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_with] = ACTIONS(165),
    [anon_sym_return_BANG] = ACTIONS(829),
    [anon_sym_yield] = ACTIONS(825),
    [anon_sym_yield_BANG] = ACTIONS(829),
    [anon_sym_lazy] = ACTIONS(825),
    [anon_sym_assert] = ACTIONS(825),
    [anon_sym_upcast] = ACTIONS(825),
    [anon_sym_downcast] = ACTIONS(825),
    [anon_sym_COLON_GT] = ACTIONS(71),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(71),
    [anon_sym_for] = ACTIONS(73),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(79),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_match] = ACTIONS(83),
    [anon_sym_match_BANG] = ACTIONS(85),
    [anon_sym_function] = ACTIONS(87),
    [anon_sym_LT_DASH] = ACTIONS(831),
    [anon_sym_DOT_LBRACK] = ACTIONS(91),
    [anon_sym_LT] = ACTIONS(93),
    [anon_sym_use] = ACTIONS(833),
    [anon_sym_use_BANG] = ACTIONS(835),
    [anon_sym_do_BANG] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(101),
    [anon_sym_LPAREN2] = ACTIONS(103),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(105),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(107),
    [anon_sym_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DQUOTE] = ACTIONS(111),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(115),
    [sym_bool] = ACTIONS(117),
    [sym_unit] = ACTIONS(119),
    [anon_sym_LPAREN_PIPE] = ACTIONS(121),
    [sym_op_identifier] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(837),
    [sym_xint] = ACTIONS(387),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(135),
    [sym__newline] = ACTIONS(163),
    [sym__dedent] = ACTIONS(163),
  },
  [91] = {
    [sym_function_or_value_defn] = STATE(600),
    [sym__expression] = STATE(88),
    [sym_literal_expression] = STATE(867),
    [sym_long_identifier_or_op] = STATE(867),
    [sym_tuple_expression] = STATE(867),
    [sym_brace_expression] = STATE(867),
    [sym_anon_record_expression] = STATE(867),
    [sym_prefixed_expression] = STATE(867),
    [sym_typecast_expression] = STATE(867),
    [sym_for_expression] = STATE(867),
    [sym_while_expression] = STATE(867),
    [sym__if_branch] = STATE(6511),
    [sym_if_expression] = STATE(867),
    [sym_fun_expression] = STATE(867),
    [sym_try_expression] = STATE(867),
    [sym_match_expression] = STATE(867),
    [sym_function_expression] = STATE(867),
    [sym_mutate_expression] = STATE(867),
    [sym_index_expression] = STATE(867),
    [sym_typed_expression] = STATE(867),
    [sym_declaration_expression] = STATE(867),
    [sym_do_expression] = STATE(867),
    [sym_list_expression] = STATE(867),
    [sym_array_expression] = STATE(867),
    [sym_begin_end_expression] = STATE(867),
    [sym_paren_expression] = STATE(867),
    [sym__high_prec_app] = STATE(864),
    [sym__low_prec_app] = STATE(864),
    [sym_application_expression] = STATE(867),
    [sym_dot_expression] = STATE(867),
    [sym_infix_expression] = STATE(867),
    [sym_ce_expression] = STATE(867),
    [sym_sequential_expression] = STATE(867),
    [sym_char] = STATE(868),
    [sym_format_string] = STATE(869),
    [sym__string_literal] = STATE(869),
    [sym_string] = STATE(868),
    [sym_verbatim_string] = STATE(868),
    [sym_bytearray] = STATE(868),
    [sym_verbatim_bytearray] = STATE(868),
    [sym_format_triple_quoted_string] = STATE(870),
    [sym_triple_quoted_string] = STATE(868),
    [sym_const] = STATE(867),
    [sym_long_identifier] = STATE(872),
    [sym_active_pattern] = STATE(871),
    [sym__identifier_or_op] = STATE(873),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(656),
    [sym_infix_op] = STATE(581),
    [sym_sbyte] = STATE(868),
    [sym_byte] = STATE(868),
    [sym_int16] = STATE(868),
    [sym_uint16] = STATE(868),
    [sym_int32] = STATE(868),
    [sym_uint32] = STATE(868),
    [sym_nativeint] = STATE(868),
    [sym_unativeint] = STATE(868),
    [sym_int64] = STATE(868),
    [sym_uint64] = STATE(868),
    [sym_ieee32] = STATE(868),
    [sym_ieee64] = STATE(868),
    [sym_bignum] = STATE(868),
    [sym_decimal] = STATE(868),
    [sym_float] = STATE(1368),
    [sym_block_comment] = STATE(91),
    [sym_compiler_directive_decl] = STATE(91),
    [sym_fsi_directive_decl] = STATE(91),
    [sym_preproc_line] = STATE(91),
    [sym_preproc_if_in_expression] = STATE(867),
    [aux_sym_sequential_expression_repeat1] = STATE(1542),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(29),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(825),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_COMMA] = ACTIONS(827),
    [anon_sym_null] = ACTIONS(49),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACK_PIPE] = ACTIONS(57),
    [anon_sym_LBRACE] = ACTIONS(169),
    [anon_sym_LT_AT] = ACTIONS(61),
    [anon_sym_LT_AT_AT] = ACTIONS(63),
    [anon_sym_DOT] = ACTIONS(65),
    [anon_sym_LBRACE_PIPE] = ACTIONS(67),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_with] = ACTIONS(169),
    [anon_sym_return_BANG] = ACTIONS(829),
    [anon_sym_yield] = ACTIONS(825),
    [anon_sym_yield_BANG] = ACTIONS(829),
    [anon_sym_lazy] = ACTIONS(825),
    [anon_sym_assert] = ACTIONS(825),
    [anon_sym_upcast] = ACTIONS(825),
    [anon_sym_downcast] = ACTIONS(825),
    [anon_sym_COLON_GT] = ACTIONS(71),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(71),
    [anon_sym_for] = ACTIONS(73),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(79),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_match] = ACTIONS(83),
    [anon_sym_match_BANG] = ACTIONS(85),
    [anon_sym_function] = ACTIONS(87),
    [anon_sym_LT_DASH] = ACTIONS(831),
    [anon_sym_DOT_LBRACK] = ACTIONS(91),
    [anon_sym_LT] = ACTIONS(93),
    [anon_sym_use] = ACTIONS(833),
    [anon_sym_use_BANG] = ACTIONS(835),
    [anon_sym_do_BANG] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(101),
    [anon_sym_LPAREN2] = ACTIONS(103),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(105),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(107),
    [anon_sym_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DQUOTE] = ACTIONS(111),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(115),
    [sym_bool] = ACTIONS(117),
    [sym_unit] = ACTIONS(119),
    [anon_sym_LPAREN_PIPE] = ACTIONS(121),
    [sym_op_identifier] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(837),
    [sym_xint] = ACTIONS(387),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(135),
    [sym__newline] = ACTIONS(167),
    [sym__dedent] = ACTIONS(167),
  },
  [92] = {
    [sym_function_or_value_defn] = STATE(600),
    [sym__expression] = STATE(88),
    [sym_literal_expression] = STATE(867),
    [sym_long_identifier_or_op] = STATE(867),
    [sym_tuple_expression] = STATE(867),
    [sym_brace_expression] = STATE(867),
    [sym_anon_record_expression] = STATE(867),
    [sym_prefixed_expression] = STATE(867),
    [sym_typecast_expression] = STATE(867),
    [sym_for_expression] = STATE(867),
    [sym_while_expression] = STATE(867),
    [sym__if_branch] = STATE(6511),
    [sym_if_expression] = STATE(867),
    [sym_fun_expression] = STATE(867),
    [sym_try_expression] = STATE(867),
    [sym_match_expression] = STATE(867),
    [sym_function_expression] = STATE(867),
    [sym_mutate_expression] = STATE(867),
    [sym_index_expression] = STATE(867),
    [sym_typed_expression] = STATE(867),
    [sym_declaration_expression] = STATE(867),
    [sym_do_expression] = STATE(867),
    [sym_list_expression] = STATE(867),
    [sym_array_expression] = STATE(867),
    [sym_begin_end_expression] = STATE(867),
    [sym_paren_expression] = STATE(867),
    [sym__high_prec_app] = STATE(864),
    [sym__low_prec_app] = STATE(864),
    [sym_application_expression] = STATE(867),
    [sym_dot_expression] = STATE(867),
    [sym_infix_expression] = STATE(867),
    [sym_ce_expression] = STATE(867),
    [sym_sequential_expression] = STATE(867),
    [sym_char] = STATE(868),
    [sym_format_string] = STATE(869),
    [sym__string_literal] = STATE(869),
    [sym_string] = STATE(868),
    [sym_verbatim_string] = STATE(868),
    [sym_bytearray] = STATE(868),
    [sym_verbatim_bytearray] = STATE(868),
    [sym_format_triple_quoted_string] = STATE(870),
    [sym_triple_quoted_string] = STATE(868),
    [sym_const] = STATE(867),
    [sym_long_identifier] = STATE(872),
    [sym_active_pattern] = STATE(871),
    [sym__identifier_or_op] = STATE(873),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(656),
    [sym_infix_op] = STATE(581),
    [sym_sbyte] = STATE(868),
    [sym_byte] = STATE(868),
    [sym_int16] = STATE(868),
    [sym_uint16] = STATE(868),
    [sym_int32] = STATE(868),
    [sym_uint32] = STATE(868),
    [sym_nativeint] = STATE(868),
    [sym_unativeint] = STATE(868),
    [sym_int64] = STATE(868),
    [sym_uint64] = STATE(868),
    [sym_ieee32] = STATE(868),
    [sym_ieee64] = STATE(868),
    [sym_bignum] = STATE(868),
    [sym_decimal] = STATE(868),
    [sym_float] = STATE(1368),
    [sym_block_comment] = STATE(92),
    [sym_compiler_directive_decl] = STATE(92),
    [sym_fsi_directive_decl] = STATE(92),
    [sym_preproc_line] = STATE(92),
    [sym_preproc_if_in_expression] = STATE(867),
    [aux_sym_sequential_expression_repeat1] = STATE(1542),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(181),
    [anon_sym_EQ] = ACTIONS(183),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_return] = ACTIONS(181),
    [anon_sym_do] = ACTIONS(181),
    [anon_sym_let] = ACTIONS(181),
    [anon_sym_let_BANG] = ACTIONS(183),
    [anon_sym_LPAREN] = ACTIONS(181),
    [anon_sym_COMMA] = ACTIONS(183),
    [anon_sym_null] = ACTIONS(181),
    [anon_sym_QMARK] = ACTIONS(181),
    [anon_sym_COLON_QMARK] = ACTIONS(181),
    [anon_sym_COLON_COLON] = ACTIONS(183),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_LBRACK_PIPE] = ACTIONS(183),
    [anon_sym_LBRACE] = ACTIONS(181),
    [anon_sym_LT_AT] = ACTIONS(181),
    [anon_sym_LT_AT_AT] = ACTIONS(181),
    [anon_sym_DOT] = ACTIONS(65),
    [anon_sym_LBRACE_PIPE] = ACTIONS(183),
    [anon_sym_new] = ACTIONS(181),
    [anon_sym_with] = ACTIONS(181),
    [anon_sym_return_BANG] = ACTIONS(183),
    [anon_sym_yield] = ACTIONS(181),
    [anon_sym_yield_BANG] = ACTIONS(183),
    [anon_sym_lazy] = ACTIONS(181),
    [anon_sym_assert] = ACTIONS(181),
    [anon_sym_upcast] = ACTIONS(181),
    [anon_sym_downcast] = ACTIONS(181),
    [anon_sym_COLON_GT] = ACTIONS(183),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(183),
    [anon_sym_for] = ACTIONS(181),
    [anon_sym_while] = ACTIONS(181),
    [anon_sym_if] = ACTIONS(181),
    [anon_sym_fun] = ACTIONS(181),
    [anon_sym_try] = ACTIONS(181),
    [anon_sym_match] = ACTIONS(181),
    [anon_sym_match_BANG] = ACTIONS(183),
    [anon_sym_function] = ACTIONS(181),
    [anon_sym_LT_DASH] = ACTIONS(181),
    [anon_sym_DOT_LBRACK] = ACTIONS(91),
    [anon_sym_LT] = ACTIONS(93),
    [anon_sym_use] = ACTIONS(181),
    [anon_sym_use_BANG] = ACTIONS(183),
    [anon_sym_do_BANG] = ACTIONS(183),
    [anon_sym_begin] = ACTIONS(181),
    [anon_sym_LPAREN2] = ACTIONS(103),
    [anon_sym_or] = ACTIONS(181),
    [aux_sym_char_token1] = ACTIONS(183),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(181),
    [anon_sym_DQUOTE] = ACTIONS(181),
    [anon_sym_AT_DQUOTE] = ACTIONS(183),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(183),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(183),
    [sym_bool] = ACTIONS(181),
    [sym_unit] = ACTIONS(119),
    [anon_sym_LPAREN_PIPE] = ACTIONS(181),
    [sym_op_identifier] = ACTIONS(181),
    [anon_sym_PLUS] = ACTIONS(181),
    [anon_sym_DASH] = ACTIONS(181),
    [anon_sym_PLUS_DOT] = ACTIONS(181),
    [anon_sym_DASH_DOT] = ACTIONS(181),
    [anon_sym_PERCENT] = ACTIONS(181),
    [anon_sym_AMP_AMP] = ACTIONS(181),
    [anon_sym_TILDE] = ACTIONS(183),
    [aux_sym_prefix_op_token1] = ACTIONS(181),
    [aux_sym_infix_op_token1] = ACTIONS(183),
    [aux_sym_infix_op_token2] = ACTIONS(181),
    [anon_sym_PIPE_PIPE] = ACTIONS(181),
    [anon_sym_BANG_EQ] = ACTIONS(181),
    [anon_sym_COLON_EQ] = ACTIONS(183),
    [anon_sym_DOLLAR] = ACTIONS(181),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(181),
    [sym_int] = ACTIONS(181),
    [sym_xint] = ACTIONS(183),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(183),
    [sym__newline] = ACTIONS(183),
    [sym__dedent] = ACTIONS(183),
  },
  [93] = {
    [sym_function_or_value_defn] = STATE(600),
    [sym__expression] = STATE(88),
    [sym_literal_expression] = STATE(867),
    [sym_long_identifier_or_op] = STATE(867),
    [sym_tuple_expression] = STATE(867),
    [sym_brace_expression] = STATE(867),
    [sym_anon_record_expression] = STATE(867),
    [sym_prefixed_expression] = STATE(867),
    [sym_typecast_expression] = STATE(867),
    [sym_for_expression] = STATE(867),
    [sym_while_expression] = STATE(867),
    [sym__if_branch] = STATE(6511),
    [sym_if_expression] = STATE(867),
    [sym_fun_expression] = STATE(867),
    [sym_try_expression] = STATE(867),
    [sym_match_expression] = STATE(867),
    [sym_function_expression] = STATE(867),
    [sym_mutate_expression] = STATE(867),
    [sym_index_expression] = STATE(867),
    [sym_typed_expression] = STATE(867),
    [sym_declaration_expression] = STATE(867),
    [sym_do_expression] = STATE(867),
    [sym_list_expression] = STATE(867),
    [sym_array_expression] = STATE(867),
    [sym_begin_end_expression] = STATE(867),
    [sym_paren_expression] = STATE(867),
    [sym__high_prec_app] = STATE(864),
    [sym__low_prec_app] = STATE(864),
    [sym_application_expression] = STATE(867),
    [sym_dot_expression] = STATE(867),
    [sym_infix_expression] = STATE(867),
    [sym_ce_expression] = STATE(867),
    [sym_sequential_expression] = STATE(867),
    [sym_char] = STATE(868),
    [sym_format_string] = STATE(869),
    [sym__string_literal] = STATE(869),
    [sym_string] = STATE(868),
    [sym_verbatim_string] = STATE(868),
    [sym_bytearray] = STATE(868),
    [sym_verbatim_bytearray] = STATE(868),
    [sym_format_triple_quoted_string] = STATE(870),
    [sym_triple_quoted_string] = STATE(868),
    [sym_const] = STATE(867),
    [sym_long_identifier] = STATE(872),
    [sym_active_pattern] = STATE(871),
    [sym__identifier_or_op] = STATE(873),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(656),
    [sym_infix_op] = STATE(581),
    [sym_sbyte] = STATE(868),
    [sym_byte] = STATE(868),
    [sym_int16] = STATE(868),
    [sym_uint16] = STATE(868),
    [sym_int32] = STATE(868),
    [sym_uint32] = STATE(868),
    [sym_nativeint] = STATE(868),
    [sym_unativeint] = STATE(868),
    [sym_int64] = STATE(868),
    [sym_uint64] = STATE(868),
    [sym_ieee32] = STATE(868),
    [sym_ieee64] = STATE(868),
    [sym_bignum] = STATE(868),
    [sym_decimal] = STATE(868),
    [sym_float] = STATE(1368),
    [sym_block_comment] = STATE(93),
    [sym_compiler_directive_decl] = STATE(93),
    [sym_fsi_directive_decl] = STATE(93),
    [sym_preproc_line] = STATE(93),
    [sym_preproc_if_in_expression] = STATE(867),
    [aux_sym_sequential_expression_repeat1] = STATE(1542),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(29),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(825),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_COMMA] = ACTIONS(827),
    [anon_sym_null] = ACTIONS(49),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACK_PIPE] = ACTIONS(57),
    [anon_sym_LBRACE] = ACTIONS(59),
    [anon_sym_LT_AT] = ACTIONS(61),
    [anon_sym_LT_AT_AT] = ACTIONS(63),
    [anon_sym_DOT] = ACTIONS(65),
    [anon_sym_LBRACE_PIPE] = ACTIONS(67),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_with] = ACTIONS(59),
    [anon_sym_return_BANG] = ACTIONS(829),
    [anon_sym_yield] = ACTIONS(825),
    [anon_sym_yield_BANG] = ACTIONS(829),
    [anon_sym_lazy] = ACTIONS(825),
    [anon_sym_assert] = ACTIONS(825),
    [anon_sym_upcast] = ACTIONS(825),
    [anon_sym_downcast] = ACTIONS(825),
    [anon_sym_COLON_GT] = ACTIONS(71),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(71),
    [anon_sym_for] = ACTIONS(73),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(79),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_match] = ACTIONS(83),
    [anon_sym_match_BANG] = ACTIONS(85),
    [anon_sym_function] = ACTIONS(87),
    [anon_sym_LT_DASH] = ACTIONS(831),
    [anon_sym_DOT_LBRACK] = ACTIONS(91),
    [anon_sym_LT] = ACTIONS(93),
    [anon_sym_use] = ACTIONS(833),
    [anon_sym_use_BANG] = ACTIONS(835),
    [anon_sym_do_BANG] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(101),
    [anon_sym_LPAREN2] = ACTIONS(103),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(105),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(107),
    [anon_sym_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DQUOTE] = ACTIONS(111),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(115),
    [sym_bool] = ACTIONS(117),
    [sym_unit] = ACTIONS(119),
    [anon_sym_LPAREN_PIPE] = ACTIONS(121),
    [sym_op_identifier] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(837),
    [sym_xint] = ACTIONS(387),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(135),
    [sym__newline] = ACTIONS(33),
    [sym__dedent] = ACTIONS(33),
  },
  [94] = {
    [sym_function_or_value_defn] = STATE(729),
    [sym__expression] = STATE(59),
    [sym_literal_expression] = STATE(867),
    [sym_long_identifier_or_op] = STATE(867),
    [sym_tuple_expression] = STATE(867),
    [sym_brace_expression] = STATE(867),
    [sym_anon_record_expression] = STATE(867),
    [sym_prefixed_expression] = STATE(867),
    [sym_typecast_expression] = STATE(867),
    [sym_for_expression] = STATE(867),
    [sym_while_expression] = STATE(867),
    [sym__if_branch] = STATE(6511),
    [sym_if_expression] = STATE(867),
    [sym_fun_expression] = STATE(867),
    [sym_try_expression] = STATE(867),
    [sym_match_expression] = STATE(867),
    [sym_function_expression] = STATE(867),
    [sym_mutate_expression] = STATE(867),
    [sym_index_expression] = STATE(867),
    [sym_typed_expression] = STATE(867),
    [sym_declaration_expression] = STATE(867),
    [sym_do_expression] = STATE(867),
    [sym_list_expression] = STATE(867),
    [sym_array_expression] = STATE(867),
    [sym_begin_end_expression] = STATE(867),
    [sym_paren_expression] = STATE(867),
    [sym__high_prec_app] = STATE(864),
    [sym__low_prec_app] = STATE(864),
    [sym_application_expression] = STATE(867),
    [sym_dot_expression] = STATE(867),
    [sym_infix_expression] = STATE(867),
    [sym_ce_expression] = STATE(867),
    [sym_sequential_expression] = STATE(867),
    [sym_char] = STATE(868),
    [sym_format_string] = STATE(869),
    [sym__string_literal] = STATE(869),
    [sym_string] = STATE(868),
    [sym_verbatim_string] = STATE(868),
    [sym_bytearray] = STATE(868),
    [sym_verbatim_bytearray] = STATE(868),
    [sym_format_triple_quoted_string] = STATE(870),
    [sym_triple_quoted_string] = STATE(868),
    [sym_const] = STATE(867),
    [sym_long_identifier] = STATE(872),
    [sym_active_pattern] = STATE(871),
    [sym__identifier_or_op] = STATE(873),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(499),
    [sym_infix_op] = STATE(743),
    [sym_sbyte] = STATE(868),
    [sym_byte] = STATE(868),
    [sym_int16] = STATE(868),
    [sym_uint16] = STATE(868),
    [sym_int32] = STATE(868),
    [sym_uint32] = STATE(868),
    [sym_nativeint] = STATE(868),
    [sym_unativeint] = STATE(868),
    [sym_int64] = STATE(868),
    [sym_uint64] = STATE(868),
    [sym_ieee32] = STATE(868),
    [sym_ieee64] = STATE(868),
    [sym_bignum] = STATE(868),
    [sym_decimal] = STATE(868),
    [sym_float] = STATE(1368),
    [sym_block_comment] = STATE(94),
    [sym_compiler_directive_decl] = STATE(94),
    [sym_fsi_directive_decl] = STATE(94),
    [sym_preproc_line] = STATE(94),
    [sym_preproc_if_in_expression] = STATE(867),
    [aux_sym_sequential_expression_repeat1] = STATE(1578),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(29),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(369),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_COMMA] = ACTIONS(371),
    [anon_sym_null] = ACTIONS(49),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACK_PIPE] = ACTIONS(57),
    [anon_sym_LBRACE] = ACTIONS(139),
    [anon_sym_LT_AT] = ACTIONS(61),
    [anon_sym_LT_AT_AT] = ACTIONS(63),
    [anon_sym_DOT] = ACTIONS(65),
    [anon_sym_LBRACE_PIPE] = ACTIONS(67),
    [anon_sym_new] = ACTIONS(369),
    [anon_sym_return_BANG] = ACTIONS(373),
    [anon_sym_yield] = ACTIONS(369),
    [anon_sym_yield_BANG] = ACTIONS(373),
    [anon_sym_lazy] = ACTIONS(369),
    [anon_sym_assert] = ACTIONS(369),
    [anon_sym_upcast] = ACTIONS(369),
    [anon_sym_downcast] = ACTIONS(369),
    [anon_sym_COLON_GT] = ACTIONS(71),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(71),
    [anon_sym_for] = ACTIONS(375),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(79),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_match] = ACTIONS(83),
    [anon_sym_match_BANG] = ACTIONS(85),
    [anon_sym_function] = ACTIONS(87),
    [anon_sym_LT_DASH] = ACTIONS(377),
    [anon_sym_DOT_LBRACK] = ACTIONS(91),
    [anon_sym_LT] = ACTIONS(93),
    [anon_sym_use] = ACTIONS(379),
    [anon_sym_use_BANG] = ACTIONS(381),
    [anon_sym_do_BANG] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(101),
    [anon_sym_LPAREN2] = ACTIONS(103),
    [anon_sym_DOT_DOT2] = ACTIONS(383),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(105),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(107),
    [anon_sym_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DQUOTE] = ACTIONS(111),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(115),
    [sym_bool] = ACTIONS(117),
    [sym_unit] = ACTIONS(119),
    [anon_sym_LPAREN_PIPE] = ACTIONS(121),
    [sym_op_identifier] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(385),
    [sym_xint] = ACTIONS(387),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(135),
    [sym__newline] = ACTIONS(609),
    [sym__dedent] = ACTIONS(811),
  },
  [95] = {
    [sym_function_or_value_defn] = STATE(729),
    [sym__expression] = STATE(59),
    [sym_literal_expression] = STATE(867),
    [sym_long_identifier_or_op] = STATE(867),
    [sym_tuple_expression] = STATE(867),
    [sym_brace_expression] = STATE(867),
    [sym_anon_record_expression] = STATE(867),
    [sym_prefixed_expression] = STATE(867),
    [sym_typecast_expression] = STATE(867),
    [sym_for_expression] = STATE(867),
    [sym_while_expression] = STATE(867),
    [sym__if_branch] = STATE(6511),
    [sym_if_expression] = STATE(867),
    [sym_fun_expression] = STATE(867),
    [sym_try_expression] = STATE(867),
    [sym_match_expression] = STATE(867),
    [sym_function_expression] = STATE(867),
    [sym_mutate_expression] = STATE(867),
    [sym_index_expression] = STATE(867),
    [sym_typed_expression] = STATE(867),
    [sym_declaration_expression] = STATE(867),
    [sym_do_expression] = STATE(867),
    [sym_list_expression] = STATE(867),
    [sym_array_expression] = STATE(867),
    [sym_begin_end_expression] = STATE(867),
    [sym_paren_expression] = STATE(867),
    [sym__high_prec_app] = STATE(864),
    [sym__low_prec_app] = STATE(864),
    [sym_application_expression] = STATE(867),
    [sym_dot_expression] = STATE(867),
    [sym_infix_expression] = STATE(867),
    [sym_ce_expression] = STATE(867),
    [sym_sequential_expression] = STATE(867),
    [sym_char] = STATE(868),
    [sym_format_string] = STATE(869),
    [sym__string_literal] = STATE(869),
    [sym_string] = STATE(868),
    [sym_verbatim_string] = STATE(868),
    [sym_bytearray] = STATE(868),
    [sym_verbatim_bytearray] = STATE(868),
    [sym_format_triple_quoted_string] = STATE(870),
    [sym_triple_quoted_string] = STATE(868),
    [sym_const] = STATE(867),
    [sym_long_identifier] = STATE(872),
    [sym_active_pattern] = STATE(871),
    [sym__identifier_or_op] = STATE(873),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(499),
    [sym_infix_op] = STATE(743),
    [sym_sbyte] = STATE(868),
    [sym_byte] = STATE(868),
    [sym_int16] = STATE(868),
    [sym_uint16] = STATE(868),
    [sym_int32] = STATE(868),
    [sym_uint32] = STATE(868),
    [sym_nativeint] = STATE(868),
    [sym_unativeint] = STATE(868),
    [sym_int64] = STATE(868),
    [sym_uint64] = STATE(868),
    [sym_ieee32] = STATE(868),
    [sym_ieee64] = STATE(868),
    [sym_bignum] = STATE(868),
    [sym_decimal] = STATE(868),
    [sym_float] = STATE(1368),
    [sym_block_comment] = STATE(95),
    [sym_compiler_directive_decl] = STATE(95),
    [sym_fsi_directive_decl] = STATE(95),
    [sym_preproc_line] = STATE(95),
    [sym_preproc_if_in_expression] = STATE(867),
    [aux_sym_sequential_expression_repeat1] = STATE(1578),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(29),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(369),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_COMMA] = ACTIONS(371),
    [anon_sym_null] = ACTIONS(49),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACK_PIPE] = ACTIONS(57),
    [anon_sym_LBRACE] = ACTIONS(139),
    [anon_sym_LT_AT] = ACTIONS(61),
    [anon_sym_LT_AT_AT] = ACTIONS(63),
    [anon_sym_DOT] = ACTIONS(65),
    [anon_sym_LBRACE_PIPE] = ACTIONS(67),
    [anon_sym_new] = ACTIONS(369),
    [anon_sym_return_BANG] = ACTIONS(373),
    [anon_sym_yield] = ACTIONS(369),
    [anon_sym_yield_BANG] = ACTIONS(373),
    [anon_sym_lazy] = ACTIONS(369),
    [anon_sym_assert] = ACTIONS(369),
    [anon_sym_upcast] = ACTIONS(369),
    [anon_sym_downcast] = ACTIONS(369),
    [anon_sym_COLON_GT] = ACTIONS(71),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(71),
    [anon_sym_for] = ACTIONS(375),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(79),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_match] = ACTIONS(83),
    [anon_sym_match_BANG] = ACTIONS(85),
    [anon_sym_function] = ACTIONS(87),
    [anon_sym_LT_DASH] = ACTIONS(377),
    [anon_sym_DOT_LBRACK] = ACTIONS(91),
    [anon_sym_LT] = ACTIONS(93),
    [anon_sym_use] = ACTIONS(379),
    [anon_sym_use_BANG] = ACTIONS(381),
    [anon_sym_do_BANG] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(101),
    [anon_sym_LPAREN2] = ACTIONS(103),
    [anon_sym_DOT_DOT2] = ACTIONS(159),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(105),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(107),
    [anon_sym_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DQUOTE] = ACTIONS(111),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(115),
    [sym_bool] = ACTIONS(117),
    [sym_unit] = ACTIONS(119),
    [anon_sym_LPAREN_PIPE] = ACTIONS(121),
    [sym_op_identifier] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(385),
    [sym_xint] = ACTIONS(387),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(135),
    [sym__newline] = ACTIONS(843),
    [sym__dedent] = ACTIONS(843),
  },
  [96] = {
    [sym_function_or_value_defn] = STATE(600),
    [sym__expression] = STATE(88),
    [sym_literal_expression] = STATE(867),
    [sym_long_identifier_or_op] = STATE(867),
    [sym_tuple_expression] = STATE(867),
    [sym_brace_expression] = STATE(867),
    [sym_anon_record_expression] = STATE(867),
    [sym_prefixed_expression] = STATE(867),
    [sym_typecast_expression] = STATE(867),
    [sym_for_expression] = STATE(867),
    [sym_while_expression] = STATE(867),
    [sym__if_branch] = STATE(6511),
    [sym_if_expression] = STATE(867),
    [sym_fun_expression] = STATE(867),
    [sym_try_expression] = STATE(867),
    [sym_match_expression] = STATE(867),
    [sym_function_expression] = STATE(867),
    [sym_mutate_expression] = STATE(867),
    [sym_index_expression] = STATE(867),
    [sym_typed_expression] = STATE(867),
    [sym_declaration_expression] = STATE(867),
    [sym_do_expression] = STATE(867),
    [sym_list_expression] = STATE(867),
    [sym_array_expression] = STATE(867),
    [sym_begin_end_expression] = STATE(867),
    [sym_paren_expression] = STATE(867),
    [sym__high_prec_app] = STATE(864),
    [sym__low_prec_app] = STATE(864),
    [sym_application_expression] = STATE(867),
    [sym_dot_expression] = STATE(867),
    [sym_infix_expression] = STATE(867),
    [sym_ce_expression] = STATE(867),
    [sym_sequential_expression] = STATE(867),
    [sym_char] = STATE(868),
    [sym_format_string] = STATE(869),
    [sym__string_literal] = STATE(869),
    [sym_string] = STATE(868),
    [sym_verbatim_string] = STATE(868),
    [sym_bytearray] = STATE(868),
    [sym_verbatim_bytearray] = STATE(868),
    [sym_format_triple_quoted_string] = STATE(870),
    [sym_triple_quoted_string] = STATE(868),
    [sym_const] = STATE(867),
    [sym_long_identifier] = STATE(872),
    [sym_active_pattern] = STATE(871),
    [sym__identifier_or_op] = STATE(873),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(656),
    [sym_infix_op] = STATE(581),
    [sym_sbyte] = STATE(868),
    [sym_byte] = STATE(868),
    [sym_int16] = STATE(868),
    [sym_uint16] = STATE(868),
    [sym_int32] = STATE(868),
    [sym_uint32] = STATE(868),
    [sym_nativeint] = STATE(868),
    [sym_unativeint] = STATE(868),
    [sym_int64] = STATE(868),
    [sym_uint64] = STATE(868),
    [sym_ieee32] = STATE(868),
    [sym_ieee64] = STATE(868),
    [sym_bignum] = STATE(868),
    [sym_decimal] = STATE(868),
    [sym_float] = STATE(1368),
    [sym_block_comment] = STATE(96),
    [sym_compiler_directive_decl] = STATE(96),
    [sym_fsi_directive_decl] = STATE(96),
    [sym_preproc_line] = STATE(96),
    [sym_preproc_if_in_expression] = STATE(867),
    [aux_sym_sequential_expression_repeat1] = STATE(1542),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(29),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(825),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_COMMA] = ACTIONS(827),
    [anon_sym_null] = ACTIONS(49),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACK_PIPE] = ACTIONS(57),
    [anon_sym_LBRACE] = ACTIONS(139),
    [anon_sym_LT_AT] = ACTIONS(61),
    [anon_sym_LT_AT_AT] = ACTIONS(63),
    [anon_sym_DOT] = ACTIONS(65),
    [anon_sym_LBRACE_PIPE] = ACTIONS(67),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_with] = ACTIONS(173),
    [anon_sym_return_BANG] = ACTIONS(829),
    [anon_sym_yield] = ACTIONS(825),
    [anon_sym_yield_BANG] = ACTIONS(829),
    [anon_sym_lazy] = ACTIONS(825),
    [anon_sym_assert] = ACTIONS(825),
    [anon_sym_upcast] = ACTIONS(825),
    [anon_sym_downcast] = ACTIONS(825),
    [anon_sym_COLON_GT] = ACTIONS(71),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(71),
    [anon_sym_for] = ACTIONS(73),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(79),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_match] = ACTIONS(83),
    [anon_sym_match_BANG] = ACTIONS(85),
    [anon_sym_function] = ACTIONS(87),
    [anon_sym_LT_DASH] = ACTIONS(831),
    [anon_sym_DOT_LBRACK] = ACTIONS(91),
    [anon_sym_LT] = ACTIONS(93),
    [anon_sym_use] = ACTIONS(833),
    [anon_sym_use_BANG] = ACTIONS(835),
    [anon_sym_do_BANG] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(101),
    [anon_sym_LPAREN2] = ACTIONS(103),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(105),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(107),
    [anon_sym_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DQUOTE] = ACTIONS(111),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(115),
    [sym_bool] = ACTIONS(117),
    [sym_unit] = ACTIONS(119),
    [anon_sym_LPAREN_PIPE] = ACTIONS(121),
    [sym_op_identifier] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(837),
    [sym_xint] = ACTIONS(387),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(135),
    [sym__newline] = ACTIONS(839),
    [sym__dedent] = ACTIONS(171),
  },
  [97] = {
    [sym_function_or_value_defn] = STATE(535),
    [sym__expression] = STATE(98),
    [sym_literal_expression] = STATE(2008),
    [sym_long_identifier_or_op] = STATE(2008),
    [sym_tuple_expression] = STATE(2008),
    [sym_brace_expression] = STATE(2008),
    [sym_anon_record_expression] = STATE(2008),
    [sym_prefixed_expression] = STATE(2008),
    [sym_typecast_expression] = STATE(2008),
    [sym_for_expression] = STATE(2008),
    [sym_while_expression] = STATE(2008),
    [sym__if_branch] = STATE(6754),
    [sym_if_expression] = STATE(2008),
    [sym_fun_expression] = STATE(2008),
    [sym_try_expression] = STATE(2008),
    [sym_match_expression] = STATE(2008),
    [sym_function_expression] = STATE(2008),
    [sym_mutate_expression] = STATE(2008),
    [sym_index_expression] = STATE(2008),
    [sym_typed_expression] = STATE(2008),
    [sym_declaration_expression] = STATE(2008),
    [sym_do_expression] = STATE(2008),
    [sym_list_expression] = STATE(2008),
    [sym_array_expression] = STATE(2008),
    [sym_begin_end_expression] = STATE(2008),
    [sym_paren_expression] = STATE(2008),
    [sym__high_prec_app] = STATE(2007),
    [sym__low_prec_app] = STATE(2007),
    [sym_application_expression] = STATE(2008),
    [sym_dot_expression] = STATE(2008),
    [sym_infix_expression] = STATE(2008),
    [sym_ce_expression] = STATE(2008),
    [sym_sequential_expression] = STATE(2008),
    [sym_char] = STATE(1859),
    [sym_format_string] = STATE(1861),
    [sym__string_literal] = STATE(1861),
    [sym_string] = STATE(1859),
    [sym_verbatim_string] = STATE(1859),
    [sym_bytearray] = STATE(1859),
    [sym_verbatim_bytearray] = STATE(1859),
    [sym_format_triple_quoted_string] = STATE(1862),
    [sym_triple_quoted_string] = STATE(1859),
    [sym_const] = STATE(2008),
    [sym_long_identifier] = STATE(1701),
    [sym_active_pattern] = STATE(1702),
    [sym__identifier_or_op] = STATE(1724),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(664),
    [sym_infix_op] = STATE(543),
    [sym_sbyte] = STATE(1859),
    [sym_byte] = STATE(1859),
    [sym_int16] = STATE(1859),
    [sym_uint16] = STATE(1859),
    [sym_int32] = STATE(1859),
    [sym_uint32] = STATE(1859),
    [sym_nativeint] = STATE(1859),
    [sym_unativeint] = STATE(1859),
    [sym_int64] = STATE(1859),
    [sym_uint64] = STATE(1859),
    [sym_ieee32] = STATE(1859),
    [sym_ieee64] = STATE(1859),
    [sym_bignum] = STATE(1859),
    [sym_decimal] = STATE(1859),
    [sym_float] = STATE(1447),
    [sym_block_comment] = STATE(97),
    [sym_compiler_directive_decl] = STATE(97),
    [sym_fsi_directive_decl] = STATE(97),
    [sym_preproc_line] = STATE(97),
    [sym_preproc_if_in_expression] = STATE(2008),
    [aux_sym_sequential_expression_repeat1] = STATE(1490),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(503),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(505),
    [anon_sym_return] = ACTIONS(507),
    [anon_sym_do] = ACTIONS(845),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(511),
    [anon_sym_COMMA] = ACTIONS(513),
    [anon_sym_null] = ACTIONS(515),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(505),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(517),
    [anon_sym_LBRACK_PIPE] = ACTIONS(519),
    [anon_sym_LBRACE] = ACTIONS(521),
    [anon_sym_LT_AT] = ACTIONS(523),
    [anon_sym_LT_AT_AT] = ACTIONS(525),
    [anon_sym_DOT] = ACTIONS(527),
    [anon_sym_LBRACE_PIPE] = ACTIONS(529),
    [anon_sym_new] = ACTIONS(507),
    [anon_sym_return_BANG] = ACTIONS(531),
    [anon_sym_yield] = ACTIONS(507),
    [anon_sym_yield_BANG] = ACTIONS(531),
    [anon_sym_lazy] = ACTIONS(507),
    [anon_sym_assert] = ACTIONS(507),
    [anon_sym_upcast] = ACTIONS(507),
    [anon_sym_downcast] = ACTIONS(507),
    [anon_sym_COLON_GT] = ACTIONS(533),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(533),
    [anon_sym_for] = ACTIONS(535),
    [anon_sym_while] = ACTIONS(537),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(539),
    [anon_sym_DASH_GT] = ACTIONS(541),
    [anon_sym_try] = ACTIONS(543),
    [anon_sym_match] = ACTIONS(545),
    [anon_sym_match_BANG] = ACTIONS(547),
    [anon_sym_function] = ACTIONS(549),
    [anon_sym_LT_DASH] = ACTIONS(551),
    [anon_sym_DOT_LBRACK] = ACTIONS(553),
    [anon_sym_LT] = ACTIONS(555),
    [anon_sym_use] = ACTIONS(557),
    [anon_sym_use_BANG] = ACTIONS(559),
    [anon_sym_do_BANG] = ACTIONS(561),
    [anon_sym_DOT_DOT] = ACTIONS(563),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_LPAREN2] = ACTIONS(567),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(569),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(571),
    [anon_sym_DQUOTE] = ACTIONS(573),
    [anon_sym_AT_DQUOTE] = ACTIONS(575),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(577),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(579),
    [sym_bool] = ACTIONS(581),
    [sym_unit] = ACTIONS(583),
    [anon_sym_LPAREN_PIPE] = ACTIONS(585),
    [sym_op_identifier] = ACTIONS(587),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(589),
    [sym_xint] = ACTIONS(591),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(593),
    [sym__newline] = ACTIONS(595),
  },
  [98] = {
    [sym_function_or_value_defn] = STATE(535),
    [sym__expression] = STATE(98),
    [sym_literal_expression] = STATE(2008),
    [sym_long_identifier_or_op] = STATE(2008),
    [sym_tuple_expression] = STATE(2008),
    [sym_brace_expression] = STATE(2008),
    [sym_anon_record_expression] = STATE(2008),
    [sym_prefixed_expression] = STATE(2008),
    [sym_typecast_expression] = STATE(2008),
    [sym_for_expression] = STATE(2008),
    [sym_while_expression] = STATE(2008),
    [sym__if_branch] = STATE(6754),
    [sym_if_expression] = STATE(2008),
    [sym_fun_expression] = STATE(2008),
    [sym_try_expression] = STATE(2008),
    [sym_match_expression] = STATE(2008),
    [sym_function_expression] = STATE(2008),
    [sym_mutate_expression] = STATE(2008),
    [sym_index_expression] = STATE(2008),
    [sym_typed_expression] = STATE(2008),
    [sym_declaration_expression] = STATE(2008),
    [sym_do_expression] = STATE(2008),
    [sym_list_expression] = STATE(2008),
    [sym_array_expression] = STATE(2008),
    [sym_begin_end_expression] = STATE(2008),
    [sym_paren_expression] = STATE(2008),
    [sym__high_prec_app] = STATE(2007),
    [sym__low_prec_app] = STATE(2007),
    [sym_application_expression] = STATE(2008),
    [sym_dot_expression] = STATE(2008),
    [sym_infix_expression] = STATE(2008),
    [sym_ce_expression] = STATE(2008),
    [sym_sequential_expression] = STATE(2008),
    [sym_char] = STATE(1859),
    [sym_format_string] = STATE(1861),
    [sym__string_literal] = STATE(1861),
    [sym_string] = STATE(1859),
    [sym_verbatim_string] = STATE(1859),
    [sym_bytearray] = STATE(1859),
    [sym_verbatim_bytearray] = STATE(1859),
    [sym_format_triple_quoted_string] = STATE(1862),
    [sym_triple_quoted_string] = STATE(1859),
    [sym_const] = STATE(2008),
    [sym_long_identifier] = STATE(1701),
    [sym_active_pattern] = STATE(1702),
    [sym__identifier_or_op] = STATE(1724),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(664),
    [sym_infix_op] = STATE(543),
    [sym_sbyte] = STATE(1859),
    [sym_byte] = STATE(1859),
    [sym_int16] = STATE(1859),
    [sym_uint16] = STATE(1859),
    [sym_int32] = STATE(1859),
    [sym_uint32] = STATE(1859),
    [sym_nativeint] = STATE(1859),
    [sym_unativeint] = STATE(1859),
    [sym_int64] = STATE(1859),
    [sym_uint64] = STATE(1859),
    [sym_ieee32] = STATE(1859),
    [sym_ieee64] = STATE(1859),
    [sym_bignum] = STATE(1859),
    [sym_decimal] = STATE(1859),
    [sym_float] = STATE(1447),
    [sym_block_comment] = STATE(98),
    [sym_compiler_directive_decl] = STATE(98),
    [sym_fsi_directive_decl] = STATE(98),
    [sym_preproc_line] = STATE(98),
    [sym_preproc_if_in_expression] = STATE(2008),
    [aux_sym_sequential_expression_repeat1] = STATE(1490),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_EQ] = ACTIONS(157),
    [anon_sym_COLON] = ACTIONS(155),
    [anon_sym_return] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(155),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_let_BANG] = ACTIONS(157),
    [anon_sym_LPAREN] = ACTIONS(155),
    [anon_sym_COMMA] = ACTIONS(157),
    [anon_sym_null] = ACTIONS(155),
    [anon_sym_QMARK] = ACTIONS(155),
    [anon_sym_COLON_QMARK] = ACTIONS(155),
    [anon_sym_COLON_COLON] = ACTIONS(157),
    [anon_sym_AMP] = ACTIONS(155),
    [anon_sym_LBRACK] = ACTIONS(155),
    [anon_sym_LBRACK_PIPE] = ACTIONS(157),
    [anon_sym_LBRACE] = ACTIONS(155),
    [anon_sym_LT_AT] = ACTIONS(155),
    [anon_sym_LT_AT_AT] = ACTIONS(155),
    [anon_sym_DOT] = ACTIONS(527),
    [anon_sym_LBRACE_PIPE] = ACTIONS(157),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_return_BANG] = ACTIONS(157),
    [anon_sym_yield] = ACTIONS(155),
    [anon_sym_yield_BANG] = ACTIONS(157),
    [anon_sym_lazy] = ACTIONS(155),
    [anon_sym_assert] = ACTIONS(155),
    [anon_sym_upcast] = ACTIONS(155),
    [anon_sym_downcast] = ACTIONS(155),
    [anon_sym_COLON_GT] = ACTIONS(157),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(157),
    [anon_sym_for] = ACTIONS(155),
    [anon_sym_while] = ACTIONS(155),
    [anon_sym_if] = ACTIONS(155),
    [anon_sym_fun] = ACTIONS(155),
    [anon_sym_DASH_GT] = ACTIONS(155),
    [anon_sym_try] = ACTIONS(155),
    [anon_sym_match] = ACTIONS(155),
    [anon_sym_match_BANG] = ACTIONS(157),
    [anon_sym_function] = ACTIONS(155),
    [anon_sym_LT_DASH] = ACTIONS(155),
    [anon_sym_DOT_LBRACK] = ACTIONS(553),
    [anon_sym_LT] = ACTIONS(555),
    [anon_sym_use] = ACTIONS(155),
    [anon_sym_use_BANG] = ACTIONS(157),
    [anon_sym_do_BANG] = ACTIONS(157),
    [anon_sym_DOT_DOT] = ACTIONS(157),
    [anon_sym_begin] = ACTIONS(155),
    [anon_sym_LPAREN2] = ACTIONS(567),
    [anon_sym_or] = ACTIONS(155),
    [aux_sym_char_token1] = ACTIONS(157),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(155),
    [anon_sym_DQUOTE] = ACTIONS(155),
    [anon_sym_AT_DQUOTE] = ACTIONS(157),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(157),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(157),
    [sym_bool] = ACTIONS(155),
    [sym_unit] = ACTIONS(583),
    [anon_sym_LPAREN_PIPE] = ACTIONS(155),
    [sym_op_identifier] = ACTIONS(155),
    [anon_sym_PLUS] = ACTIONS(155),
    [anon_sym_DASH] = ACTIONS(155),
    [anon_sym_PLUS_DOT] = ACTIONS(155),
    [anon_sym_DASH_DOT] = ACTIONS(155),
    [anon_sym_PERCENT] = ACTIONS(155),
    [anon_sym_AMP_AMP] = ACTIONS(155),
    [anon_sym_TILDE] = ACTIONS(157),
    [aux_sym_prefix_op_token1] = ACTIONS(155),
    [aux_sym_infix_op_token1] = ACTIONS(157),
    [aux_sym_infix_op_token2] = ACTIONS(155),
    [anon_sym_PIPE_PIPE] = ACTIONS(155),
    [anon_sym_BANG_EQ] = ACTIONS(155),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_DOLLAR] = ACTIONS(155),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(155),
    [sym_int] = ACTIONS(155),
    [sym_xint] = ACTIONS(157),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(157),
    [sym__newline] = ACTIONS(157),
  },
  [99] = {
    [sym_function_or_value_defn] = STATE(535),
    [sym__expression] = STATE(98),
    [sym_literal_expression] = STATE(2008),
    [sym_long_identifier_or_op] = STATE(2008),
    [sym_tuple_expression] = STATE(2008),
    [sym_brace_expression] = STATE(2008),
    [sym_anon_record_expression] = STATE(2008),
    [sym_prefixed_expression] = STATE(2008),
    [sym_typecast_expression] = STATE(2008),
    [sym_for_expression] = STATE(2008),
    [sym_while_expression] = STATE(2008),
    [sym__if_branch] = STATE(6754),
    [sym_if_expression] = STATE(2008),
    [sym_fun_expression] = STATE(2008),
    [sym_try_expression] = STATE(2008),
    [sym_match_expression] = STATE(2008),
    [sym_function_expression] = STATE(2008),
    [sym_mutate_expression] = STATE(2008),
    [sym_index_expression] = STATE(2008),
    [sym_typed_expression] = STATE(2008),
    [sym_declaration_expression] = STATE(2008),
    [sym_do_expression] = STATE(2008),
    [sym_list_expression] = STATE(2008),
    [sym_array_expression] = STATE(2008),
    [sym_begin_end_expression] = STATE(2008),
    [sym_paren_expression] = STATE(2008),
    [sym__high_prec_app] = STATE(2007),
    [sym__low_prec_app] = STATE(2007),
    [sym_application_expression] = STATE(2008),
    [sym_dot_expression] = STATE(2008),
    [sym_infix_expression] = STATE(2008),
    [sym_ce_expression] = STATE(2008),
    [sym_sequential_expression] = STATE(2008),
    [sym_char] = STATE(1859),
    [sym_format_string] = STATE(1861),
    [sym__string_literal] = STATE(1861),
    [sym_string] = STATE(1859),
    [sym_verbatim_string] = STATE(1859),
    [sym_bytearray] = STATE(1859),
    [sym_verbatim_bytearray] = STATE(1859),
    [sym_format_triple_quoted_string] = STATE(1862),
    [sym_triple_quoted_string] = STATE(1859),
    [sym_const] = STATE(2008),
    [sym_long_identifier] = STATE(1701),
    [sym_active_pattern] = STATE(1702),
    [sym__identifier_or_op] = STATE(1724),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(664),
    [sym_infix_op] = STATE(543),
    [sym_sbyte] = STATE(1859),
    [sym_byte] = STATE(1859),
    [sym_int16] = STATE(1859),
    [sym_uint16] = STATE(1859),
    [sym_int32] = STATE(1859),
    [sym_uint32] = STATE(1859),
    [sym_nativeint] = STATE(1859),
    [sym_unativeint] = STATE(1859),
    [sym_int64] = STATE(1859),
    [sym_uint64] = STATE(1859),
    [sym_ieee32] = STATE(1859),
    [sym_ieee64] = STATE(1859),
    [sym_bignum] = STATE(1859),
    [sym_decimal] = STATE(1859),
    [sym_float] = STATE(1447),
    [sym_block_comment] = STATE(99),
    [sym_compiler_directive_decl] = STATE(99),
    [sym_fsi_directive_decl] = STATE(99),
    [sym_preproc_line] = STATE(99),
    [sym_preproc_if_in_expression] = STATE(2008),
    [aux_sym_sequential_expression_repeat1] = STATE(1490),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(181),
    [anon_sym_EQ] = ACTIONS(183),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_return] = ACTIONS(181),
    [anon_sym_do] = ACTIONS(181),
    [anon_sym_let] = ACTIONS(181),
    [anon_sym_let_BANG] = ACTIONS(183),
    [anon_sym_LPAREN] = ACTIONS(181),
    [anon_sym_COMMA] = ACTIONS(183),
    [anon_sym_null] = ACTIONS(181),
    [anon_sym_QMARK] = ACTIONS(181),
    [anon_sym_COLON_QMARK] = ACTIONS(181),
    [anon_sym_COLON_COLON] = ACTIONS(183),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_LBRACK_PIPE] = ACTIONS(183),
    [anon_sym_LBRACE] = ACTIONS(181),
    [anon_sym_LT_AT] = ACTIONS(181),
    [anon_sym_LT_AT_AT] = ACTIONS(181),
    [anon_sym_DOT] = ACTIONS(527),
    [anon_sym_LBRACE_PIPE] = ACTIONS(183),
    [anon_sym_new] = ACTIONS(181),
    [anon_sym_return_BANG] = ACTIONS(183),
    [anon_sym_yield] = ACTIONS(181),
    [anon_sym_yield_BANG] = ACTIONS(183),
    [anon_sym_lazy] = ACTIONS(181),
    [anon_sym_assert] = ACTIONS(181),
    [anon_sym_upcast] = ACTIONS(181),
    [anon_sym_downcast] = ACTIONS(181),
    [anon_sym_COLON_GT] = ACTIONS(183),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(183),
    [anon_sym_for] = ACTIONS(181),
    [anon_sym_while] = ACTIONS(181),
    [anon_sym_if] = ACTIONS(181),
    [anon_sym_fun] = ACTIONS(181),
    [anon_sym_DASH_GT] = ACTIONS(181),
    [anon_sym_try] = ACTIONS(181),
    [anon_sym_match] = ACTIONS(181),
    [anon_sym_match_BANG] = ACTIONS(183),
    [anon_sym_function] = ACTIONS(181),
    [anon_sym_LT_DASH] = ACTIONS(181),
    [anon_sym_DOT_LBRACK] = ACTIONS(553),
    [anon_sym_LT] = ACTIONS(555),
    [anon_sym_use] = ACTIONS(181),
    [anon_sym_use_BANG] = ACTIONS(183),
    [anon_sym_do_BANG] = ACTIONS(183),
    [anon_sym_DOT_DOT] = ACTIONS(183),
    [anon_sym_begin] = ACTIONS(181),
    [anon_sym_LPAREN2] = ACTIONS(567),
    [anon_sym_or] = ACTIONS(181),
    [aux_sym_char_token1] = ACTIONS(183),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(181),
    [anon_sym_DQUOTE] = ACTIONS(181),
    [anon_sym_AT_DQUOTE] = ACTIONS(183),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(183),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(183),
    [sym_bool] = ACTIONS(181),
    [sym_unit] = ACTIONS(583),
    [anon_sym_LPAREN_PIPE] = ACTIONS(181),
    [sym_op_identifier] = ACTIONS(181),
    [anon_sym_PLUS] = ACTIONS(181),
    [anon_sym_DASH] = ACTIONS(181),
    [anon_sym_PLUS_DOT] = ACTIONS(181),
    [anon_sym_DASH_DOT] = ACTIONS(181),
    [anon_sym_PERCENT] = ACTIONS(181),
    [anon_sym_AMP_AMP] = ACTIONS(181),
    [anon_sym_TILDE] = ACTIONS(183),
    [aux_sym_prefix_op_token1] = ACTIONS(181),
    [aux_sym_infix_op_token1] = ACTIONS(183),
    [aux_sym_infix_op_token2] = ACTIONS(181),
    [anon_sym_PIPE_PIPE] = ACTIONS(181),
    [anon_sym_BANG_EQ] = ACTIONS(181),
    [anon_sym_COLON_EQ] = ACTIONS(183),
    [anon_sym_DOLLAR] = ACTIONS(181),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(181),
    [sym_int] = ACTIONS(181),
    [sym_xint] = ACTIONS(183),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(183),
    [sym__newline] = ACTIONS(183),
  },
  [100] = {
    [sym_function_or_value_defn] = STATE(600),
    [sym__expression] = STATE(88),
    [sym_literal_expression] = STATE(867),
    [sym_long_identifier_or_op] = STATE(867),
    [sym_tuple_expression] = STATE(867),
    [sym_brace_expression] = STATE(867),
    [sym_anon_record_expression] = STATE(867),
    [sym_prefixed_expression] = STATE(867),
    [sym_typecast_expression] = STATE(867),
    [sym_for_expression] = STATE(867),
    [sym_while_expression] = STATE(867),
    [sym__if_branch] = STATE(6511),
    [sym_if_expression] = STATE(867),
    [sym_fun_expression] = STATE(867),
    [sym_try_expression] = STATE(867),
    [sym_match_expression] = STATE(867),
    [sym_function_expression] = STATE(867),
    [sym_mutate_expression] = STATE(867),
    [sym_index_expression] = STATE(867),
    [sym_typed_expression] = STATE(867),
    [sym_declaration_expression] = STATE(867),
    [sym_do_expression] = STATE(867),
    [sym_list_expression] = STATE(867),
    [sym_array_expression] = STATE(867),
    [sym_begin_end_expression] = STATE(867),
    [sym_paren_expression] = STATE(867),
    [sym__high_prec_app] = STATE(864),
    [sym__low_prec_app] = STATE(864),
    [sym_application_expression] = STATE(867),
    [sym_dot_expression] = STATE(867),
    [sym_infix_expression] = STATE(867),
    [sym_ce_expression] = STATE(867),
    [sym_sequential_expression] = STATE(867),
    [sym_char] = STATE(868),
    [sym_format_string] = STATE(869),
    [sym__string_literal] = STATE(869),
    [sym_string] = STATE(868),
    [sym_verbatim_string] = STATE(868),
    [sym_bytearray] = STATE(868),
    [sym_verbatim_bytearray] = STATE(868),
    [sym_format_triple_quoted_string] = STATE(870),
    [sym_triple_quoted_string] = STATE(868),
    [sym_const] = STATE(867),
    [sym_long_identifier] = STATE(872),
    [sym_active_pattern] = STATE(871),
    [sym__identifier_or_op] = STATE(873),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(656),
    [sym_infix_op] = STATE(581),
    [sym_sbyte] = STATE(868),
    [sym_byte] = STATE(868),
    [sym_int16] = STATE(868),
    [sym_uint16] = STATE(868),
    [sym_int32] = STATE(868),
    [sym_uint32] = STATE(868),
    [sym_nativeint] = STATE(868),
    [sym_unativeint] = STATE(868),
    [sym_int64] = STATE(868),
    [sym_uint64] = STATE(868),
    [sym_ieee32] = STATE(868),
    [sym_ieee64] = STATE(868),
    [sym_bignum] = STATE(868),
    [sym_decimal] = STATE(868),
    [sym_float] = STATE(1368),
    [sym_block_comment] = STATE(100),
    [sym_compiler_directive_decl] = STATE(100),
    [sym_fsi_directive_decl] = STATE(100),
    [sym_preproc_line] = STATE(100),
    [sym_preproc_if_in_expression] = STATE(867),
    [aux_sym_sequential_expression_repeat1] = STATE(1542),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(29),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(825),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_COMMA] = ACTIONS(827),
    [anon_sym_null] = ACTIONS(49),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACK_PIPE] = ACTIONS(57),
    [anon_sym_LBRACE] = ACTIONS(139),
    [anon_sym_LT_AT] = ACTIONS(61),
    [anon_sym_LT_AT_AT] = ACTIONS(63),
    [anon_sym_DOT] = ACTIONS(65),
    [anon_sym_LBRACE_PIPE] = ACTIONS(67),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_with] = ACTIONS(847),
    [anon_sym_return_BANG] = ACTIONS(829),
    [anon_sym_yield] = ACTIONS(825),
    [anon_sym_yield_BANG] = ACTIONS(829),
    [anon_sym_lazy] = ACTIONS(825),
    [anon_sym_assert] = ACTIONS(825),
    [anon_sym_upcast] = ACTIONS(825),
    [anon_sym_downcast] = ACTIONS(825),
    [anon_sym_COLON_GT] = ACTIONS(71),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(71),
    [anon_sym_for] = ACTIONS(73),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(79),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_match] = ACTIONS(83),
    [anon_sym_match_BANG] = ACTIONS(85),
    [anon_sym_function] = ACTIONS(87),
    [anon_sym_LT_DASH] = ACTIONS(831),
    [anon_sym_DOT_LBRACK] = ACTIONS(91),
    [anon_sym_LT] = ACTIONS(93),
    [anon_sym_use] = ACTIONS(833),
    [anon_sym_use_BANG] = ACTIONS(835),
    [anon_sym_do_BANG] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(101),
    [anon_sym_LPAREN2] = ACTIONS(103),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(105),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(107),
    [anon_sym_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DQUOTE] = ACTIONS(111),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(115),
    [sym_bool] = ACTIONS(117),
    [sym_unit] = ACTIONS(119),
    [anon_sym_LPAREN_PIPE] = ACTIONS(121),
    [sym_op_identifier] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(837),
    [sym_xint] = ACTIONS(387),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(135),
    [sym__newline] = ACTIONS(839),
    [sym__dedent] = ACTIONS(849),
  },
  [101] = {
    [sym_function_or_value_defn] = STATE(596),
    [sym__expression] = STATE(109),
    [sym_literal_expression] = STATE(1809),
    [sym_long_identifier_or_op] = STATE(1809),
    [sym_tuple_expression] = STATE(1809),
    [sym_brace_expression] = STATE(1809),
    [sym_anon_record_expression] = STATE(1809),
    [sym_prefixed_expression] = STATE(1809),
    [sym_typecast_expression] = STATE(1809),
    [sym_for_expression] = STATE(1809),
    [sym_while_expression] = STATE(1809),
    [sym__if_branch] = STATE(6874),
    [sym_if_expression] = STATE(1809),
    [sym_fun_expression] = STATE(1809),
    [sym_try_expression] = STATE(1809),
    [sym_match_expression] = STATE(1809),
    [sym_function_expression] = STATE(1809),
    [sym_mutate_expression] = STATE(1809),
    [sym_index_expression] = STATE(1809),
    [sym_typed_expression] = STATE(1809),
    [sym_declaration_expression] = STATE(1809),
    [sym_do_expression] = STATE(1809),
    [sym_list_expression] = STATE(1809),
    [sym_array_expression] = STATE(1809),
    [sym_begin_end_expression] = STATE(1809),
    [sym_paren_expression] = STATE(1809),
    [sym__high_prec_app] = STATE(1806),
    [sym__low_prec_app] = STATE(1806),
    [sym_application_expression] = STATE(1809),
    [sym_dot_expression] = STATE(1809),
    [sym_infix_expression] = STATE(1809),
    [sym_ce_expression] = STATE(1809),
    [sym_sequential_expression] = STATE(1809),
    [sym_char] = STATE(2014),
    [sym_format_string] = STATE(2019),
    [sym__string_literal] = STATE(2019),
    [sym_string] = STATE(2014),
    [sym_verbatim_string] = STATE(2014),
    [sym_bytearray] = STATE(2014),
    [sym_verbatim_bytearray] = STATE(2014),
    [sym_format_triple_quoted_string] = STATE(2020),
    [sym_triple_quoted_string] = STATE(2014),
    [sym_const] = STATE(1809),
    [sym_long_identifier] = STATE(1810),
    [sym_active_pattern] = STATE(1860),
    [sym__identifier_or_op] = STATE(1750),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(655),
    [sym_infix_op] = STATE(608),
    [sym_sbyte] = STATE(2014),
    [sym_byte] = STATE(2014),
    [sym_int16] = STATE(2014),
    [sym_uint16] = STATE(2014),
    [sym_int32] = STATE(2014),
    [sym_uint32] = STATE(2014),
    [sym_nativeint] = STATE(2014),
    [sym_unativeint] = STATE(2014),
    [sym_int64] = STATE(2014),
    [sym_uint64] = STATE(2014),
    [sym_ieee32] = STATE(2014),
    [sym_ieee64] = STATE(2014),
    [sym_bignum] = STATE(2014),
    [sym_decimal] = STATE(2014),
    [sym_float] = STATE(1438),
    [sym_block_comment] = STATE(101),
    [sym_compiler_directive_decl] = STATE(101),
    [sym_fsi_directive_decl] = STATE(101),
    [sym_preproc_line] = STATE(101),
    [sym_preproc_if_in_expression] = STATE(1809),
    [aux_sym_sequential_expression_repeat1] = STATE(1620),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(723),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(725),
    [anon_sym_return] = ACTIONS(727),
    [anon_sym_do] = ACTIONS(729),
    [anon_sym_and] = ACTIONS(151),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(731),
    [anon_sym_COMMA] = ACTIONS(733),
    [anon_sym_null] = ACTIONS(735),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(725),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(737),
    [anon_sym_LBRACK_PIPE] = ACTIONS(739),
    [anon_sym_LBRACE] = ACTIONS(741),
    [anon_sym_LT_AT] = ACTIONS(743),
    [anon_sym_LT_AT_AT] = ACTIONS(745),
    [anon_sym_DOT] = ACTIONS(747),
    [anon_sym_LBRACE_PIPE] = ACTIONS(749),
    [anon_sym_new] = ACTIONS(727),
    [anon_sym_return_BANG] = ACTIONS(751),
    [anon_sym_yield] = ACTIONS(727),
    [anon_sym_yield_BANG] = ACTIONS(751),
    [anon_sym_lazy] = ACTIONS(727),
    [anon_sym_assert] = ACTIONS(727),
    [anon_sym_upcast] = ACTIONS(727),
    [anon_sym_downcast] = ACTIONS(727),
    [anon_sym_COLON_GT] = ACTIONS(753),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(753),
    [anon_sym_for] = ACTIONS(755),
    [anon_sym_while] = ACTIONS(757),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(759),
    [anon_sym_try] = ACTIONS(761),
    [anon_sym_match] = ACTIONS(763),
    [anon_sym_match_BANG] = ACTIONS(765),
    [anon_sym_function] = ACTIONS(767),
    [anon_sym_LT_DASH] = ACTIONS(769),
    [anon_sym_DOT_LBRACK] = ACTIONS(771),
    [anon_sym_LT] = ACTIONS(773),
    [anon_sym_use] = ACTIONS(775),
    [anon_sym_use_BANG] = ACTIONS(777),
    [anon_sym_do_BANG] = ACTIONS(779),
    [anon_sym_begin] = ACTIONS(781),
    [anon_sym_LPAREN2] = ACTIONS(783),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(785),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(787),
    [anon_sym_DQUOTE] = ACTIONS(789),
    [anon_sym_AT_DQUOTE] = ACTIONS(791),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(793),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(795),
    [sym_bool] = ACTIONS(797),
    [sym_unit] = ACTIONS(799),
    [anon_sym_LPAREN_PIPE] = ACTIONS(801),
    [sym_op_identifier] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(805),
    [sym_xint] = ACTIONS(807),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(809),
    [sym__newline] = ACTIONS(851),
    [sym__dedent] = ACTIONS(149),
  },
  [102] = {
    [sym_function_or_value_defn] = STATE(532),
    [sym__expression] = STATE(126),
    [sym_literal_expression] = STATE(2000),
    [sym_long_identifier_or_op] = STATE(2000),
    [sym_tuple_expression] = STATE(2000),
    [sym_brace_expression] = STATE(2000),
    [sym_anon_record_expression] = STATE(2000),
    [sym_prefixed_expression] = STATE(2000),
    [sym_typecast_expression] = STATE(2000),
    [sym_for_expression] = STATE(2000),
    [sym_while_expression] = STATE(2000),
    [sym__if_branch] = STATE(6707),
    [sym_if_expression] = STATE(2000),
    [sym_fun_expression] = STATE(2000),
    [sym_try_expression] = STATE(2000),
    [sym_match_expression] = STATE(2000),
    [sym_function_expression] = STATE(2000),
    [sym_mutate_expression] = STATE(2000),
    [sym_index_expression] = STATE(2000),
    [sym_typed_expression] = STATE(2000),
    [sym_declaration_expression] = STATE(2000),
    [sym_do_expression] = STATE(2000),
    [sym_list_expression] = STATE(2000),
    [sym_array_expression] = STATE(2000),
    [sym_begin_end_expression] = STATE(2000),
    [sym_paren_expression] = STATE(2000),
    [sym__high_prec_app] = STATE(2003),
    [sym__low_prec_app] = STATE(2003),
    [sym_application_expression] = STATE(2000),
    [sym_dot_expression] = STATE(2000),
    [sym_infix_expression] = STATE(2000),
    [sym_ce_expression] = STATE(2000),
    [sym_sequential_expression] = STATE(2000),
    [sym_char] = STATE(1801),
    [sym_format_string] = STATE(1804),
    [sym__string_literal] = STATE(1804),
    [sym_string] = STATE(1801),
    [sym_verbatim_string] = STATE(1801),
    [sym_bytearray] = STATE(1801),
    [sym_verbatim_bytearray] = STATE(1801),
    [sym_format_triple_quoted_string] = STATE(1807),
    [sym_triple_quoted_string] = STATE(1801),
    [sym_const] = STATE(2000),
    [sym_long_identifier] = STATE(1725),
    [sym_active_pattern] = STATE(1726),
    [sym__identifier_or_op] = STATE(1751),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(723),
    [sym_infix_op] = STATE(561),
    [sym_sbyte] = STATE(1801),
    [sym_byte] = STATE(1801),
    [sym_int16] = STATE(1801),
    [sym_uint16] = STATE(1801),
    [sym_int32] = STATE(1801),
    [sym_uint32] = STATE(1801),
    [sym_nativeint] = STATE(1801),
    [sym_unativeint] = STATE(1801),
    [sym_int64] = STATE(1801),
    [sym_uint64] = STATE(1801),
    [sym_ieee32] = STATE(1801),
    [sym_ieee64] = STATE(1801),
    [sym_bignum] = STATE(1801),
    [sym_decimal] = STATE(1801),
    [sym_float] = STATE(1427),
    [sym_block_comment] = STATE(102),
    [sym_compiler_directive_decl] = STATE(102),
    [sym_fsi_directive_decl] = STATE(102),
    [sym_preproc_line] = STATE(102),
    [sym_preproc_if_in_expression] = STATE(2000),
    [aux_sym_sequential_expression_repeat1] = STATE(1635),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(629),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(631),
    [anon_sym_return] = ACTIONS(633),
    [anon_sym_do] = ACTIONS(635),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(637),
    [anon_sym_COMMA] = ACTIONS(639),
    [anon_sym_null] = ACTIONS(641),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(631),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(643),
    [anon_sym_LBRACK_PIPE] = ACTIONS(645),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_LT_AT] = ACTIONS(647),
    [anon_sym_LT_AT_AT] = ACTIONS(649),
    [anon_sym_DOT] = ACTIONS(651),
    [anon_sym_LBRACE_PIPE] = ACTIONS(653),
    [anon_sym_new] = ACTIONS(633),
    [anon_sym_return_BANG] = ACTIONS(655),
    [anon_sym_yield] = ACTIONS(633),
    [anon_sym_yield_BANG] = ACTIONS(655),
    [anon_sym_lazy] = ACTIONS(633),
    [anon_sym_assert] = ACTIONS(633),
    [anon_sym_upcast] = ACTIONS(633),
    [anon_sym_downcast] = ACTIONS(633),
    [anon_sym_COLON_GT] = ACTIONS(657),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(657),
    [anon_sym_for] = ACTIONS(659),
    [anon_sym_while] = ACTIONS(661),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(663),
    [anon_sym_try] = ACTIONS(665),
    [anon_sym_match] = ACTIONS(667),
    [anon_sym_match_BANG] = ACTIONS(669),
    [anon_sym_function] = ACTIONS(671),
    [anon_sym_LT_DASH] = ACTIONS(673),
    [anon_sym_DOT_LBRACK] = ACTIONS(675),
    [anon_sym_LT] = ACTIONS(677),
    [anon_sym_use] = ACTIONS(679),
    [anon_sym_use_BANG] = ACTIONS(681),
    [anon_sym_do_BANG] = ACTIONS(683),
    [anon_sym_begin] = ACTIONS(685),
    [anon_sym_LPAREN2] = ACTIONS(687),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(689),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(691),
    [anon_sym_DQUOTE] = ACTIONS(693),
    [anon_sym_AT_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(697),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(699),
    [sym_bool] = ACTIONS(701),
    [sym_unit] = ACTIONS(703),
    [anon_sym_LPAREN_PIPE] = ACTIONS(705),
    [sym_op_identifier] = ACTIONS(707),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(709),
    [sym_xint] = ACTIONS(711),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(713),
    [anon_sym_POUNDendif] = ACTIONS(853),
    [anon_sym_POUNDelse] = ACTIONS(853),
    [sym__newline] = ACTIONS(823),
  },
  [103] = {
    [sym_function_or_value_defn] = STATE(627),
    [sym__expression] = STATE(17),
    [sym_literal_expression] = STATE(1118),
    [sym_long_identifier_or_op] = STATE(1118),
    [sym_tuple_expression] = STATE(1118),
    [sym_brace_expression] = STATE(1118),
    [sym_anon_record_expression] = STATE(1118),
    [sym_prefixed_expression] = STATE(1118),
    [sym_typecast_expression] = STATE(1118),
    [sym_for_expression] = STATE(1118),
    [sym_while_expression] = STATE(1118),
    [sym__if_branch] = STATE(7163),
    [sym_if_expression] = STATE(1118),
    [sym_fun_expression] = STATE(1118),
    [sym_try_expression] = STATE(1118),
    [sym_match_expression] = STATE(1118),
    [sym_function_expression] = STATE(1118),
    [sym_mutate_expression] = STATE(1118),
    [sym_index_expression] = STATE(1118),
    [sym_typed_expression] = STATE(1118),
    [sym_declaration_expression] = STATE(1118),
    [sym_do_expression] = STATE(1118),
    [sym_list_expression] = STATE(1118),
    [sym_array_expression] = STATE(1118),
    [sym_begin_end_expression] = STATE(1118),
    [sym_paren_expression] = STATE(1118),
    [sym__high_prec_app] = STATE(1133),
    [sym__low_prec_app] = STATE(1133),
    [sym_application_expression] = STATE(1118),
    [sym_dot_expression] = STATE(1118),
    [sym_infix_expression] = STATE(1118),
    [sym_ce_expression] = STATE(1118),
    [sym_sequential_expression] = STATE(1118),
    [sym_char] = STATE(1080),
    [sym_format_string] = STATE(1090),
    [sym__string_literal] = STATE(1090),
    [sym_string] = STATE(1080),
    [sym_verbatim_string] = STATE(1080),
    [sym_bytearray] = STATE(1080),
    [sym_verbatim_bytearray] = STATE(1080),
    [sym_format_triple_quoted_string] = STATE(1096),
    [sym_triple_quoted_string] = STATE(1080),
    [sym_const] = STATE(1118),
    [sym_long_identifier] = STATE(1156),
    [sym_active_pattern] = STATE(1085),
    [sym__identifier_or_op] = STATE(1099),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(517),
    [sym_infix_op] = STATE(487),
    [sym_sbyte] = STATE(1080),
    [sym_byte] = STATE(1080),
    [sym_int16] = STATE(1080),
    [sym_uint16] = STATE(1080),
    [sym_int32] = STATE(1080),
    [sym_uint32] = STATE(1080),
    [sym_nativeint] = STATE(1080),
    [sym_unativeint] = STATE(1080),
    [sym_int64] = STATE(1080),
    [sym_uint64] = STATE(1080),
    [sym_ieee32] = STATE(1080),
    [sym_ieee64] = STATE(1080),
    [sym_bignum] = STATE(1080),
    [sym_decimal] = STATE(1080),
    [sym_float] = STATE(979),
    [sym_block_comment] = STATE(103),
    [sym_compiler_directive_decl] = STATE(103),
    [sym_fsi_directive_decl] = STATE(103),
    [sym_preproc_line] = STATE(103),
    [sym_preproc_if_in_expression] = STATE(1118),
    [aux_sym_sequential_expression_repeat1] = STATE(1069),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(195),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(197),
    [anon_sym_return] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_COMMA] = ACTIONS(205),
    [anon_sym_null] = ACTIONS(207),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(197),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(209),
    [anon_sym_LBRACK_PIPE] = ACTIONS(211),
    [anon_sym_LBRACE] = ACTIONS(271),
    [anon_sym_LT_AT] = ACTIONS(213),
    [anon_sym_LT_AT_AT] = ACTIONS(215),
    [anon_sym_DOT] = ACTIONS(185),
    [anon_sym_LBRACE_PIPE] = ACTIONS(217),
    [anon_sym_new] = ACTIONS(199),
    [anon_sym_return_BANG] = ACTIONS(219),
    [anon_sym_yield] = ACTIONS(199),
    [anon_sym_yield_BANG] = ACTIONS(219),
    [anon_sym_lazy] = ACTIONS(199),
    [anon_sym_assert] = ACTIONS(199),
    [anon_sym_upcast] = ACTIONS(199),
    [anon_sym_downcast] = ACTIONS(199),
    [anon_sym_COLON_GT] = ACTIONS(221),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(221),
    [anon_sym_for] = ACTIONS(223),
    [anon_sym_to] = ACTIONS(855),
    [anon_sym_downto] = ACTIONS(855),
    [anon_sym_while] = ACTIONS(225),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(229),
    [anon_sym_match] = ACTIONS(231),
    [anon_sym_match_BANG] = ACTIONS(233),
    [anon_sym_function] = ACTIONS(235),
    [anon_sym_LT_DASH] = ACTIONS(237),
    [anon_sym_DOT_LBRACK] = ACTIONS(187),
    [anon_sym_LT] = ACTIONS(189),
    [anon_sym_use] = ACTIONS(239),
    [anon_sym_use_BANG] = ACTIONS(241),
    [anon_sym_do_BANG] = ACTIONS(243),
    [anon_sym_begin] = ACTIONS(245),
    [anon_sym_LPAREN2] = ACTIONS(191),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(247),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(251),
    [anon_sym_AT_DQUOTE] = ACTIONS(253),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(255),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(257),
    [sym_bool] = ACTIONS(259),
    [sym_unit] = ACTIONS(193),
    [anon_sym_LPAREN_PIPE] = ACTIONS(261),
    [sym_op_identifier] = ACTIONS(263),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(265),
    [sym_xint] = ACTIONS(267),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(269),
    [sym__newline] = ACTIONS(273),
  },
  [104] = {
    [sym_function_or_value_defn] = STATE(663),
    [sym__expression] = STATE(76),
    [sym_literal_expression] = STATE(1118),
    [sym_long_identifier_or_op] = STATE(1118),
    [sym_tuple_expression] = STATE(1118),
    [sym_brace_expression] = STATE(1118),
    [sym_anon_record_expression] = STATE(1118),
    [sym_prefixed_expression] = STATE(1118),
    [sym_typecast_expression] = STATE(1118),
    [sym_for_expression] = STATE(1118),
    [sym_while_expression] = STATE(1118),
    [sym__if_branch] = STATE(7163),
    [sym_if_expression] = STATE(1118),
    [sym_fun_expression] = STATE(1118),
    [sym_try_expression] = STATE(1118),
    [sym_match_expression] = STATE(1118),
    [sym_function_expression] = STATE(1118),
    [sym_mutate_expression] = STATE(1118),
    [sym_index_expression] = STATE(1118),
    [sym_typed_expression] = STATE(1118),
    [sym_declaration_expression] = STATE(1118),
    [sym_do_expression] = STATE(1118),
    [sym_list_expression] = STATE(1118),
    [sym_array_expression] = STATE(1118),
    [sym_begin_end_expression] = STATE(1118),
    [sym_paren_expression] = STATE(1118),
    [sym__high_prec_app] = STATE(1133),
    [sym__low_prec_app] = STATE(1133),
    [sym_application_expression] = STATE(1118),
    [sym_dot_expression] = STATE(1118),
    [sym_infix_expression] = STATE(1118),
    [sym_ce_expression] = STATE(1118),
    [sym_sequential_expression] = STATE(1118),
    [sym_char] = STATE(1080),
    [sym_format_string] = STATE(1090),
    [sym__string_literal] = STATE(1090),
    [sym_string] = STATE(1080),
    [sym_verbatim_string] = STATE(1080),
    [sym_bytearray] = STATE(1080),
    [sym_verbatim_bytearray] = STATE(1080),
    [sym_format_triple_quoted_string] = STATE(1096),
    [sym_triple_quoted_string] = STATE(1080),
    [sym_const] = STATE(1118),
    [sym_long_identifier] = STATE(1156),
    [sym_active_pattern] = STATE(1085),
    [sym__identifier_or_op] = STATE(1099),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(548),
    [sym_infix_op] = STATE(687),
    [sym_sbyte] = STATE(1080),
    [sym_byte] = STATE(1080),
    [sym_int16] = STATE(1080),
    [sym_uint16] = STATE(1080),
    [sym_int32] = STATE(1080),
    [sym_uint32] = STATE(1080),
    [sym_nativeint] = STATE(1080),
    [sym_unativeint] = STATE(1080),
    [sym_int64] = STATE(1080),
    [sym_uint64] = STATE(1080),
    [sym_ieee32] = STATE(1080),
    [sym_ieee64] = STATE(1080),
    [sym_bignum] = STATE(1080),
    [sym_decimal] = STATE(1080),
    [sym_float] = STATE(979),
    [sym_block_comment] = STATE(104),
    [sym_compiler_directive_decl] = STATE(104),
    [sym_fsi_directive_decl] = STATE(104),
    [sym_preproc_line] = STATE(104),
    [sym_preproc_if_in_expression] = STATE(1118),
    [aux_sym_sequential_expression_repeat1] = STATE(1558),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(195),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(197),
    [anon_sym_return] = ACTIONS(481),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_COMMA] = ACTIONS(483),
    [anon_sym_null] = ACTIONS(207),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(197),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(209),
    [anon_sym_RBRACK] = ACTIONS(857),
    [anon_sym_LBRACK_PIPE] = ACTIONS(211),
    [anon_sym_LBRACE] = ACTIONS(271),
    [anon_sym_LT_AT] = ACTIONS(213),
    [anon_sym_LT_AT_AT] = ACTIONS(215),
    [anon_sym_DOT] = ACTIONS(185),
    [anon_sym_LBRACE_PIPE] = ACTIONS(217),
    [anon_sym_new] = ACTIONS(481),
    [anon_sym_return_BANG] = ACTIONS(487),
    [anon_sym_yield] = ACTIONS(481),
    [anon_sym_yield_BANG] = ACTIONS(487),
    [anon_sym_lazy] = ACTIONS(481),
    [anon_sym_assert] = ACTIONS(481),
    [anon_sym_upcast] = ACTIONS(481),
    [anon_sym_downcast] = ACTIONS(481),
    [anon_sym_COLON_GT] = ACTIONS(221),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(221),
    [anon_sym_for] = ACTIONS(489),
    [anon_sym_while] = ACTIONS(225),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(229),
    [anon_sym_match] = ACTIONS(231),
    [anon_sym_match_BANG] = ACTIONS(233),
    [anon_sym_function] = ACTIONS(235),
    [anon_sym_LT_DASH] = ACTIONS(491),
    [anon_sym_DOT_LBRACK] = ACTIONS(187),
    [anon_sym_LT] = ACTIONS(189),
    [anon_sym_use] = ACTIONS(493),
    [anon_sym_use_BANG] = ACTIONS(495),
    [anon_sym_do_BANG] = ACTIONS(243),
    [anon_sym_begin] = ACTIONS(245),
    [anon_sym_LPAREN2] = ACTIONS(191),
    [anon_sym_DOT_DOT2] = ACTIONS(497),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(247),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(251),
    [anon_sym_AT_DQUOTE] = ACTIONS(253),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(255),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(257),
    [sym_bool] = ACTIONS(259),
    [sym_unit] = ACTIONS(193),
    [anon_sym_LPAREN_PIPE] = ACTIONS(261),
    [sym_op_identifier] = ACTIONS(263),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(499),
    [sym_xint] = ACTIONS(267),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(269),
    [sym__newline] = ACTIONS(501),
  },
  [105] = {
    [sym_function_or_value_defn] = STATE(600),
    [sym__expression] = STATE(88),
    [sym_literal_expression] = STATE(867),
    [sym_long_identifier_or_op] = STATE(867),
    [sym_tuple_expression] = STATE(867),
    [sym_brace_expression] = STATE(867),
    [sym_anon_record_expression] = STATE(867),
    [sym_prefixed_expression] = STATE(867),
    [sym_typecast_expression] = STATE(867),
    [sym_for_expression] = STATE(867),
    [sym_while_expression] = STATE(867),
    [sym__if_branch] = STATE(6511),
    [sym_if_expression] = STATE(867),
    [sym_fun_expression] = STATE(867),
    [sym_try_expression] = STATE(867),
    [sym_match_expression] = STATE(867),
    [sym_function_expression] = STATE(867),
    [sym_mutate_expression] = STATE(867),
    [sym_index_expression] = STATE(867),
    [sym_typed_expression] = STATE(867),
    [sym_declaration_expression] = STATE(867),
    [sym_do_expression] = STATE(867),
    [sym_list_expression] = STATE(867),
    [sym_array_expression] = STATE(867),
    [sym_begin_end_expression] = STATE(867),
    [sym_paren_expression] = STATE(867),
    [sym__high_prec_app] = STATE(864),
    [sym__low_prec_app] = STATE(864),
    [sym_application_expression] = STATE(867),
    [sym_dot_expression] = STATE(867),
    [sym_infix_expression] = STATE(867),
    [sym_ce_expression] = STATE(867),
    [sym_sequential_expression] = STATE(867),
    [sym_char] = STATE(868),
    [sym_format_string] = STATE(869),
    [sym__string_literal] = STATE(869),
    [sym_string] = STATE(868),
    [sym_verbatim_string] = STATE(868),
    [sym_bytearray] = STATE(868),
    [sym_verbatim_bytearray] = STATE(868),
    [sym_format_triple_quoted_string] = STATE(870),
    [sym_triple_quoted_string] = STATE(868),
    [sym_const] = STATE(867),
    [sym_long_identifier] = STATE(872),
    [sym_active_pattern] = STATE(871),
    [sym__identifier_or_op] = STATE(873),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(656),
    [sym_infix_op] = STATE(581),
    [sym_sbyte] = STATE(868),
    [sym_byte] = STATE(868),
    [sym_int16] = STATE(868),
    [sym_uint16] = STATE(868),
    [sym_int32] = STATE(868),
    [sym_uint32] = STATE(868),
    [sym_nativeint] = STATE(868),
    [sym_unativeint] = STATE(868),
    [sym_int64] = STATE(868),
    [sym_uint64] = STATE(868),
    [sym_ieee32] = STATE(868),
    [sym_ieee64] = STATE(868),
    [sym_bignum] = STATE(868),
    [sym_decimal] = STATE(868),
    [sym_float] = STATE(1368),
    [sym_block_comment] = STATE(105),
    [sym_compiler_directive_decl] = STATE(105),
    [sym_fsi_directive_decl] = STATE(105),
    [sym_preproc_line] = STATE(105),
    [sym_preproc_if_in_expression] = STATE(867),
    [aux_sym__list_elements_repeat1] = STATE(5740),
    [aux_sym_sequential_expression_repeat1] = STATE(1542),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(29),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(825),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_COMMA] = ACTIONS(827),
    [anon_sym_null] = ACTIONS(49),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACK_PIPE] = ACTIONS(57),
    [anon_sym_LBRACE] = ACTIONS(139),
    [anon_sym_LT_AT] = ACTIONS(61),
    [anon_sym_LT_AT_AT] = ACTIONS(63),
    [anon_sym_DOT] = ACTIONS(65),
    [anon_sym_LBRACE_PIPE] = ACTIONS(67),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_return_BANG] = ACTIONS(829),
    [anon_sym_yield] = ACTIONS(825),
    [anon_sym_yield_BANG] = ACTIONS(829),
    [anon_sym_lazy] = ACTIONS(825),
    [anon_sym_assert] = ACTIONS(825),
    [anon_sym_upcast] = ACTIONS(825),
    [anon_sym_downcast] = ACTIONS(825),
    [anon_sym_COLON_GT] = ACTIONS(71),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(71),
    [anon_sym_for] = ACTIONS(73),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(79),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_match] = ACTIONS(83),
    [anon_sym_match_BANG] = ACTIONS(85),
    [anon_sym_function] = ACTIONS(87),
    [anon_sym_LT_DASH] = ACTIONS(831),
    [anon_sym_DOT_LBRACK] = ACTIONS(91),
    [anon_sym_LT] = ACTIONS(93),
    [anon_sym_use] = ACTIONS(833),
    [anon_sym_use_BANG] = ACTIONS(835),
    [anon_sym_do_BANG] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(101),
    [anon_sym_LPAREN2] = ACTIONS(103),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(105),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(107),
    [anon_sym_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DQUOTE] = ACTIONS(111),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(115),
    [sym_bool] = ACTIONS(117),
    [sym_unit] = ACTIONS(119),
    [anon_sym_LPAREN_PIPE] = ACTIONS(121),
    [sym_op_identifier] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(837),
    [sym_xint] = ACTIONS(387),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(135),
    [sym__newline] = ACTIONS(859),
    [sym__dedent] = ACTIONS(861),
  },
  [106] = {
    [sym_function_or_value_defn] = STATE(703),
    [sym__expression] = STATE(108),
    [sym_literal_expression] = STATE(1797),
    [sym_long_identifier_or_op] = STATE(1797),
    [sym_tuple_expression] = STATE(1797),
    [sym_brace_expression] = STATE(1797),
    [sym_anon_record_expression] = STATE(1797),
    [sym_prefixed_expression] = STATE(1797),
    [sym_typecast_expression] = STATE(1797),
    [sym_for_expression] = STATE(1797),
    [sym_while_expression] = STATE(1797),
    [sym__if_branch] = STATE(6611),
    [sym_if_expression] = STATE(1797),
    [sym_fun_expression] = STATE(1797),
    [sym_try_expression] = STATE(1797),
    [sym_match_expression] = STATE(1797),
    [sym_function_expression] = STATE(1797),
    [sym_mutate_expression] = STATE(1797),
    [sym_index_expression] = STATE(1797),
    [sym_typed_expression] = STATE(1797),
    [sym_declaration_expression] = STATE(1797),
    [sym_do_expression] = STATE(1797),
    [sym_list_expression] = STATE(1797),
    [sym_array_expression] = STATE(1797),
    [sym_begin_end_expression] = STATE(1797),
    [sym_paren_expression] = STATE(1797),
    [sym__high_prec_app] = STATE(1800),
    [sym__low_prec_app] = STATE(1800),
    [sym_application_expression] = STATE(1797),
    [sym_dot_expression] = STATE(1797),
    [sym_infix_expression] = STATE(1797),
    [sym_ce_expression] = STATE(1797),
    [sym_sequential_expression] = STATE(1797),
    [sym_char] = STATE(1694),
    [sym_format_string] = STATE(1693),
    [sym__string_literal] = STATE(1693),
    [sym_string] = STATE(1694),
    [sym_verbatim_string] = STATE(1694),
    [sym_bytearray] = STATE(1694),
    [sym_verbatim_bytearray] = STATE(1694),
    [sym_format_triple_quoted_string] = STATE(1692),
    [sym_triple_quoted_string] = STATE(1694),
    [sym_const] = STATE(1797),
    [sym_long_identifier] = STATE(1813),
    [sym_active_pattern] = STATE(1753),
    [sym__identifier_or_op] = STATE(1812),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(756),
    [sym_infix_op] = STATE(515),
    [sym_sbyte] = STATE(1694),
    [sym_byte] = STATE(1694),
    [sym_int16] = STATE(1694),
    [sym_uint16] = STATE(1694),
    [sym_int32] = STATE(1694),
    [sym_uint32] = STATE(1694),
    [sym_nativeint] = STATE(1694),
    [sym_unativeint] = STATE(1694),
    [sym_int64] = STATE(1694),
    [sym_uint64] = STATE(1694),
    [sym_ieee32] = STATE(1694),
    [sym_ieee64] = STATE(1694),
    [sym_bignum] = STATE(1694),
    [sym_decimal] = STATE(1694),
    [sym_float] = STATE(1425),
    [sym_block_comment] = STATE(106),
    [sym_compiler_directive_decl] = STATE(106),
    [sym_fsi_directive_decl] = STATE(106),
    [sym_preproc_line] = STATE(106),
    [sym_preproc_if_in_expression] = STATE(1797),
    [aux_sym_sequential_expression_repeat1] = STATE(1585),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(393),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(395),
    [anon_sym_return] = ACTIONS(397),
    [anon_sym_do] = ACTIONS(399),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_as] = ACTIONS(147),
    [anon_sym_LPAREN] = ACTIONS(401),
    [anon_sym_COMMA] = ACTIONS(403),
    [anon_sym_null] = ACTIONS(405),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(395),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(407),
    [anon_sym_LBRACK_PIPE] = ACTIONS(409),
    [anon_sym_LBRACE] = ACTIONS(411),
    [anon_sym_LT_AT] = ACTIONS(413),
    [anon_sym_LT_AT_AT] = ACTIONS(415),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_LBRACE_PIPE] = ACTIONS(419),
    [anon_sym_new] = ACTIONS(397),
    [anon_sym_with] = ACTIONS(147),
    [anon_sym_return_BANG] = ACTIONS(421),
    [anon_sym_yield] = ACTIONS(397),
    [anon_sym_yield_BANG] = ACTIONS(421),
    [anon_sym_lazy] = ACTIONS(397),
    [anon_sym_assert] = ACTIONS(397),
    [anon_sym_upcast] = ACTIONS(397),
    [anon_sym_downcast] = ACTIONS(397),
    [anon_sym_COLON_GT] = ACTIONS(423),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(423),
    [anon_sym_for] = ACTIONS(425),
    [anon_sym_while] = ACTIONS(427),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(429),
    [anon_sym_try] = ACTIONS(431),
    [anon_sym_match] = ACTIONS(433),
    [anon_sym_match_BANG] = ACTIONS(435),
    [anon_sym_function] = ACTIONS(437),
    [anon_sym_LT_DASH] = ACTIONS(439),
    [anon_sym_DOT_LBRACK] = ACTIONS(441),
    [anon_sym_LT] = ACTIONS(443),
    [anon_sym_use] = ACTIONS(445),
    [anon_sym_use_BANG] = ACTIONS(447),
    [anon_sym_do_BANG] = ACTIONS(449),
    [anon_sym_begin] = ACTIONS(451),
    [anon_sym_LPAREN2] = ACTIONS(453),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(455),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(457),
    [anon_sym_DQUOTE] = ACTIONS(459),
    [anon_sym_AT_DQUOTE] = ACTIONS(461),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(463),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(465),
    [sym_bool] = ACTIONS(467),
    [sym_unit] = ACTIONS(469),
    [anon_sym_LPAREN_PIPE] = ACTIONS(471),
    [sym_op_identifier] = ACTIONS(473),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(475),
    [sym_xint] = ACTIONS(477),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(479),
    [sym__newline] = ACTIONS(145),
  },
  [107] = {
    [sym_function_or_value_defn] = STATE(703),
    [sym__expression] = STATE(108),
    [sym_literal_expression] = STATE(1797),
    [sym_long_identifier_or_op] = STATE(1797),
    [sym_tuple_expression] = STATE(1797),
    [sym_brace_expression] = STATE(1797),
    [sym_anon_record_expression] = STATE(1797),
    [sym_prefixed_expression] = STATE(1797),
    [sym_typecast_expression] = STATE(1797),
    [sym_for_expression] = STATE(1797),
    [sym_while_expression] = STATE(1797),
    [sym__if_branch] = STATE(6611),
    [sym_if_expression] = STATE(1797),
    [sym_fun_expression] = STATE(1797),
    [sym_try_expression] = STATE(1797),
    [sym_match_expression] = STATE(1797),
    [sym_function_expression] = STATE(1797),
    [sym_mutate_expression] = STATE(1797),
    [sym_index_expression] = STATE(1797),
    [sym_typed_expression] = STATE(1797),
    [sym_declaration_expression] = STATE(1797),
    [sym_do_expression] = STATE(1797),
    [sym_list_expression] = STATE(1797),
    [sym_array_expression] = STATE(1797),
    [sym_begin_end_expression] = STATE(1797),
    [sym_paren_expression] = STATE(1797),
    [sym__high_prec_app] = STATE(1800),
    [sym__low_prec_app] = STATE(1800),
    [sym_application_expression] = STATE(1797),
    [sym_dot_expression] = STATE(1797),
    [sym_infix_expression] = STATE(1797),
    [sym_ce_expression] = STATE(1797),
    [sym_sequential_expression] = STATE(1797),
    [sym_char] = STATE(1694),
    [sym_format_string] = STATE(1693),
    [sym__string_literal] = STATE(1693),
    [sym_string] = STATE(1694),
    [sym_verbatim_string] = STATE(1694),
    [sym_bytearray] = STATE(1694),
    [sym_verbatim_bytearray] = STATE(1694),
    [sym_format_triple_quoted_string] = STATE(1692),
    [sym_triple_quoted_string] = STATE(1694),
    [sym_const] = STATE(1797),
    [sym_long_identifier] = STATE(1813),
    [sym_active_pattern] = STATE(1753),
    [sym__identifier_or_op] = STATE(1812),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(756),
    [sym_infix_op] = STATE(515),
    [sym_sbyte] = STATE(1694),
    [sym_byte] = STATE(1694),
    [sym_int16] = STATE(1694),
    [sym_uint16] = STATE(1694),
    [sym_int32] = STATE(1694),
    [sym_uint32] = STATE(1694),
    [sym_nativeint] = STATE(1694),
    [sym_unativeint] = STATE(1694),
    [sym_int64] = STATE(1694),
    [sym_uint64] = STATE(1694),
    [sym_ieee32] = STATE(1694),
    [sym_ieee64] = STATE(1694),
    [sym_bignum] = STATE(1694),
    [sym_decimal] = STATE(1694),
    [sym_float] = STATE(1425),
    [sym_block_comment] = STATE(107),
    [sym_compiler_directive_decl] = STATE(107),
    [sym_fsi_directive_decl] = STATE(107),
    [sym_preproc_line] = STATE(107),
    [sym_preproc_if_in_expression] = STATE(1797),
    [aux_sym_sequential_expression_repeat1] = STATE(1585),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(393),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(395),
    [anon_sym_return] = ACTIONS(397),
    [anon_sym_do] = ACTIONS(399),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_as] = ACTIONS(151),
    [anon_sym_LPAREN] = ACTIONS(401),
    [anon_sym_COMMA] = ACTIONS(403),
    [anon_sym_null] = ACTIONS(405),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(395),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(407),
    [anon_sym_LBRACK_PIPE] = ACTIONS(409),
    [anon_sym_LBRACE] = ACTIONS(411),
    [anon_sym_LT_AT] = ACTIONS(413),
    [anon_sym_LT_AT_AT] = ACTIONS(415),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_LBRACE_PIPE] = ACTIONS(419),
    [anon_sym_new] = ACTIONS(397),
    [anon_sym_with] = ACTIONS(151),
    [anon_sym_return_BANG] = ACTIONS(421),
    [anon_sym_yield] = ACTIONS(397),
    [anon_sym_yield_BANG] = ACTIONS(421),
    [anon_sym_lazy] = ACTIONS(397),
    [anon_sym_assert] = ACTIONS(397),
    [anon_sym_upcast] = ACTIONS(397),
    [anon_sym_downcast] = ACTIONS(397),
    [anon_sym_COLON_GT] = ACTIONS(423),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(423),
    [anon_sym_for] = ACTIONS(425),
    [anon_sym_while] = ACTIONS(427),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(429),
    [anon_sym_try] = ACTIONS(431),
    [anon_sym_match] = ACTIONS(433),
    [anon_sym_match_BANG] = ACTIONS(435),
    [anon_sym_function] = ACTIONS(437),
    [anon_sym_LT_DASH] = ACTIONS(439),
    [anon_sym_DOT_LBRACK] = ACTIONS(441),
    [anon_sym_LT] = ACTIONS(443),
    [anon_sym_use] = ACTIONS(445),
    [anon_sym_use_BANG] = ACTIONS(447),
    [anon_sym_do_BANG] = ACTIONS(449),
    [anon_sym_begin] = ACTIONS(451),
    [anon_sym_LPAREN2] = ACTIONS(453),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(455),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(457),
    [anon_sym_DQUOTE] = ACTIONS(459),
    [anon_sym_AT_DQUOTE] = ACTIONS(461),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(463),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(465),
    [sym_bool] = ACTIONS(467),
    [sym_unit] = ACTIONS(469),
    [anon_sym_LPAREN_PIPE] = ACTIONS(471),
    [sym_op_identifier] = ACTIONS(473),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(475),
    [sym_xint] = ACTIONS(477),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(479),
    [sym__newline] = ACTIONS(863),
  },
  [108] = {
    [sym_function_or_value_defn] = STATE(703),
    [sym__expression] = STATE(108),
    [sym_literal_expression] = STATE(1797),
    [sym_long_identifier_or_op] = STATE(1797),
    [sym_tuple_expression] = STATE(1797),
    [sym_brace_expression] = STATE(1797),
    [sym_anon_record_expression] = STATE(1797),
    [sym_prefixed_expression] = STATE(1797),
    [sym_typecast_expression] = STATE(1797),
    [sym_for_expression] = STATE(1797),
    [sym_while_expression] = STATE(1797),
    [sym__if_branch] = STATE(6611),
    [sym_if_expression] = STATE(1797),
    [sym_fun_expression] = STATE(1797),
    [sym_try_expression] = STATE(1797),
    [sym_match_expression] = STATE(1797),
    [sym_function_expression] = STATE(1797),
    [sym_mutate_expression] = STATE(1797),
    [sym_index_expression] = STATE(1797),
    [sym_typed_expression] = STATE(1797),
    [sym_declaration_expression] = STATE(1797),
    [sym_do_expression] = STATE(1797),
    [sym_list_expression] = STATE(1797),
    [sym_array_expression] = STATE(1797),
    [sym_begin_end_expression] = STATE(1797),
    [sym_paren_expression] = STATE(1797),
    [sym__high_prec_app] = STATE(1800),
    [sym__low_prec_app] = STATE(1800),
    [sym_application_expression] = STATE(1797),
    [sym_dot_expression] = STATE(1797),
    [sym_infix_expression] = STATE(1797),
    [sym_ce_expression] = STATE(1797),
    [sym_sequential_expression] = STATE(1797),
    [sym_char] = STATE(1694),
    [sym_format_string] = STATE(1693),
    [sym__string_literal] = STATE(1693),
    [sym_string] = STATE(1694),
    [sym_verbatim_string] = STATE(1694),
    [sym_bytearray] = STATE(1694),
    [sym_verbatim_bytearray] = STATE(1694),
    [sym_format_triple_quoted_string] = STATE(1692),
    [sym_triple_quoted_string] = STATE(1694),
    [sym_const] = STATE(1797),
    [sym_long_identifier] = STATE(1813),
    [sym_active_pattern] = STATE(1753),
    [sym__identifier_or_op] = STATE(1812),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(756),
    [sym_infix_op] = STATE(515),
    [sym_sbyte] = STATE(1694),
    [sym_byte] = STATE(1694),
    [sym_int16] = STATE(1694),
    [sym_uint16] = STATE(1694),
    [sym_int32] = STATE(1694),
    [sym_uint32] = STATE(1694),
    [sym_nativeint] = STATE(1694),
    [sym_unativeint] = STATE(1694),
    [sym_int64] = STATE(1694),
    [sym_uint64] = STATE(1694),
    [sym_ieee32] = STATE(1694),
    [sym_ieee64] = STATE(1694),
    [sym_bignum] = STATE(1694),
    [sym_decimal] = STATE(1694),
    [sym_float] = STATE(1425),
    [sym_block_comment] = STATE(108),
    [sym_compiler_directive_decl] = STATE(108),
    [sym_fsi_directive_decl] = STATE(108),
    [sym_preproc_line] = STATE(108),
    [sym_preproc_if_in_expression] = STATE(1797),
    [aux_sym_sequential_expression_repeat1] = STATE(1585),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_EQ] = ACTIONS(157),
    [anon_sym_COLON] = ACTIONS(155),
    [anon_sym_return] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(155),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_let_BANG] = ACTIONS(157),
    [anon_sym_as] = ACTIONS(155),
    [anon_sym_LPAREN] = ACTIONS(155),
    [anon_sym_COMMA] = ACTIONS(157),
    [anon_sym_null] = ACTIONS(155),
    [anon_sym_QMARK] = ACTIONS(155),
    [anon_sym_COLON_QMARK] = ACTIONS(155),
    [anon_sym_COLON_COLON] = ACTIONS(157),
    [anon_sym_AMP] = ACTIONS(155),
    [anon_sym_LBRACK] = ACTIONS(155),
    [anon_sym_LBRACK_PIPE] = ACTIONS(157),
    [anon_sym_LBRACE] = ACTIONS(155),
    [anon_sym_LT_AT] = ACTIONS(155),
    [anon_sym_LT_AT_AT] = ACTIONS(155),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_LBRACE_PIPE] = ACTIONS(157),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_with] = ACTIONS(155),
    [anon_sym_return_BANG] = ACTIONS(157),
    [anon_sym_yield] = ACTIONS(155),
    [anon_sym_yield_BANG] = ACTIONS(157),
    [anon_sym_lazy] = ACTIONS(155),
    [anon_sym_assert] = ACTIONS(155),
    [anon_sym_upcast] = ACTIONS(155),
    [anon_sym_downcast] = ACTIONS(155),
    [anon_sym_COLON_GT] = ACTIONS(157),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(157),
    [anon_sym_for] = ACTIONS(155),
    [anon_sym_while] = ACTIONS(155),
    [anon_sym_if] = ACTIONS(155),
    [anon_sym_fun] = ACTIONS(155),
    [anon_sym_try] = ACTIONS(155),
    [anon_sym_match] = ACTIONS(155),
    [anon_sym_match_BANG] = ACTIONS(157),
    [anon_sym_function] = ACTIONS(155),
    [anon_sym_LT_DASH] = ACTIONS(155),
    [anon_sym_DOT_LBRACK] = ACTIONS(441),
    [anon_sym_LT] = ACTIONS(443),
    [anon_sym_use] = ACTIONS(155),
    [anon_sym_use_BANG] = ACTIONS(157),
    [anon_sym_do_BANG] = ACTIONS(157),
    [anon_sym_begin] = ACTIONS(155),
    [anon_sym_LPAREN2] = ACTIONS(453),
    [anon_sym_or] = ACTIONS(155),
    [aux_sym_char_token1] = ACTIONS(157),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(155),
    [anon_sym_DQUOTE] = ACTIONS(155),
    [anon_sym_AT_DQUOTE] = ACTIONS(157),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(157),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(157),
    [sym_bool] = ACTIONS(155),
    [sym_unit] = ACTIONS(469),
    [anon_sym_LPAREN_PIPE] = ACTIONS(155),
    [sym_op_identifier] = ACTIONS(155),
    [anon_sym_PLUS] = ACTIONS(155),
    [anon_sym_DASH] = ACTIONS(155),
    [anon_sym_PLUS_DOT] = ACTIONS(155),
    [anon_sym_DASH_DOT] = ACTIONS(155),
    [anon_sym_PERCENT] = ACTIONS(155),
    [anon_sym_AMP_AMP] = ACTIONS(155),
    [anon_sym_TILDE] = ACTIONS(157),
    [aux_sym_prefix_op_token1] = ACTIONS(155),
    [aux_sym_infix_op_token1] = ACTIONS(157),
    [aux_sym_infix_op_token2] = ACTIONS(155),
    [anon_sym_PIPE_PIPE] = ACTIONS(155),
    [anon_sym_BANG_EQ] = ACTIONS(155),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_DOLLAR] = ACTIONS(155),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(155),
    [sym_int] = ACTIONS(155),
    [sym_xint] = ACTIONS(157),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(157),
    [sym__newline] = ACTIONS(157),
  },
  [109] = {
    [sym_function_or_value_defn] = STATE(596),
    [sym__expression] = STATE(109),
    [sym_literal_expression] = STATE(1809),
    [sym_long_identifier_or_op] = STATE(1809),
    [sym_tuple_expression] = STATE(1809),
    [sym_brace_expression] = STATE(1809),
    [sym_anon_record_expression] = STATE(1809),
    [sym_prefixed_expression] = STATE(1809),
    [sym_typecast_expression] = STATE(1809),
    [sym_for_expression] = STATE(1809),
    [sym_while_expression] = STATE(1809),
    [sym__if_branch] = STATE(6874),
    [sym_if_expression] = STATE(1809),
    [sym_fun_expression] = STATE(1809),
    [sym_try_expression] = STATE(1809),
    [sym_match_expression] = STATE(1809),
    [sym_function_expression] = STATE(1809),
    [sym_mutate_expression] = STATE(1809),
    [sym_index_expression] = STATE(1809),
    [sym_typed_expression] = STATE(1809),
    [sym_declaration_expression] = STATE(1809),
    [sym_do_expression] = STATE(1809),
    [sym_list_expression] = STATE(1809),
    [sym_array_expression] = STATE(1809),
    [sym_begin_end_expression] = STATE(1809),
    [sym_paren_expression] = STATE(1809),
    [sym__high_prec_app] = STATE(1806),
    [sym__low_prec_app] = STATE(1806),
    [sym_application_expression] = STATE(1809),
    [sym_dot_expression] = STATE(1809),
    [sym_infix_expression] = STATE(1809),
    [sym_ce_expression] = STATE(1809),
    [sym_sequential_expression] = STATE(1809),
    [sym_char] = STATE(2014),
    [sym_format_string] = STATE(2019),
    [sym__string_literal] = STATE(2019),
    [sym_string] = STATE(2014),
    [sym_verbatim_string] = STATE(2014),
    [sym_bytearray] = STATE(2014),
    [sym_verbatim_bytearray] = STATE(2014),
    [sym_format_triple_quoted_string] = STATE(2020),
    [sym_triple_quoted_string] = STATE(2014),
    [sym_const] = STATE(1809),
    [sym_long_identifier] = STATE(1810),
    [sym_active_pattern] = STATE(1860),
    [sym__identifier_or_op] = STATE(1750),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(655),
    [sym_infix_op] = STATE(608),
    [sym_sbyte] = STATE(2014),
    [sym_byte] = STATE(2014),
    [sym_int16] = STATE(2014),
    [sym_uint16] = STATE(2014),
    [sym_int32] = STATE(2014),
    [sym_uint32] = STATE(2014),
    [sym_nativeint] = STATE(2014),
    [sym_unativeint] = STATE(2014),
    [sym_int64] = STATE(2014),
    [sym_uint64] = STATE(2014),
    [sym_ieee32] = STATE(2014),
    [sym_ieee64] = STATE(2014),
    [sym_bignum] = STATE(2014),
    [sym_decimal] = STATE(2014),
    [sym_float] = STATE(1438),
    [sym_block_comment] = STATE(109),
    [sym_compiler_directive_decl] = STATE(109),
    [sym_fsi_directive_decl] = STATE(109),
    [sym_preproc_line] = STATE(109),
    [sym_preproc_if_in_expression] = STATE(1809),
    [aux_sym_sequential_expression_repeat1] = STATE(1620),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_EQ] = ACTIONS(157),
    [anon_sym_COLON] = ACTIONS(155),
    [anon_sym_return] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(155),
    [anon_sym_and] = ACTIONS(155),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_let_BANG] = ACTIONS(157),
    [anon_sym_LPAREN] = ACTIONS(155),
    [anon_sym_COMMA] = ACTIONS(157),
    [anon_sym_null] = ACTIONS(155),
    [anon_sym_QMARK] = ACTIONS(155),
    [anon_sym_COLON_QMARK] = ACTIONS(155),
    [anon_sym_COLON_COLON] = ACTIONS(157),
    [anon_sym_AMP] = ACTIONS(155),
    [anon_sym_LBRACK] = ACTIONS(155),
    [anon_sym_LBRACK_PIPE] = ACTIONS(157),
    [anon_sym_LBRACE] = ACTIONS(155),
    [anon_sym_LT_AT] = ACTIONS(155),
    [anon_sym_LT_AT_AT] = ACTIONS(155),
    [anon_sym_DOT] = ACTIONS(747),
    [anon_sym_LBRACE_PIPE] = ACTIONS(157),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_return_BANG] = ACTIONS(157),
    [anon_sym_yield] = ACTIONS(155),
    [anon_sym_yield_BANG] = ACTIONS(157),
    [anon_sym_lazy] = ACTIONS(155),
    [anon_sym_assert] = ACTIONS(155),
    [anon_sym_upcast] = ACTIONS(155),
    [anon_sym_downcast] = ACTIONS(155),
    [anon_sym_COLON_GT] = ACTIONS(157),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(157),
    [anon_sym_for] = ACTIONS(155),
    [anon_sym_while] = ACTIONS(155),
    [anon_sym_if] = ACTIONS(155),
    [anon_sym_fun] = ACTIONS(155),
    [anon_sym_try] = ACTIONS(155),
    [anon_sym_match] = ACTIONS(155),
    [anon_sym_match_BANG] = ACTIONS(157),
    [anon_sym_function] = ACTIONS(155),
    [anon_sym_LT_DASH] = ACTIONS(155),
    [anon_sym_DOT_LBRACK] = ACTIONS(771),
    [anon_sym_LT] = ACTIONS(773),
    [anon_sym_use] = ACTIONS(155),
    [anon_sym_use_BANG] = ACTIONS(157),
    [anon_sym_do_BANG] = ACTIONS(157),
    [anon_sym_begin] = ACTIONS(155),
    [anon_sym_LPAREN2] = ACTIONS(783),
    [anon_sym_or] = ACTIONS(155),
    [aux_sym_char_token1] = ACTIONS(157),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(155),
    [anon_sym_DQUOTE] = ACTIONS(155),
    [anon_sym_AT_DQUOTE] = ACTIONS(157),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(157),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(157),
    [sym_bool] = ACTIONS(155),
    [sym_unit] = ACTIONS(799),
    [anon_sym_LPAREN_PIPE] = ACTIONS(155),
    [sym_op_identifier] = ACTIONS(155),
    [anon_sym_PLUS] = ACTIONS(155),
    [anon_sym_DASH] = ACTIONS(155),
    [anon_sym_PLUS_DOT] = ACTIONS(155),
    [anon_sym_DASH_DOT] = ACTIONS(155),
    [anon_sym_PERCENT] = ACTIONS(155),
    [anon_sym_AMP_AMP] = ACTIONS(155),
    [anon_sym_TILDE] = ACTIONS(157),
    [aux_sym_prefix_op_token1] = ACTIONS(155),
    [aux_sym_infix_op_token1] = ACTIONS(157),
    [aux_sym_infix_op_token2] = ACTIONS(155),
    [anon_sym_PIPE_PIPE] = ACTIONS(155),
    [anon_sym_BANG_EQ] = ACTIONS(155),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_DOLLAR] = ACTIONS(155),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(155),
    [sym_int] = ACTIONS(155),
    [sym_xint] = ACTIONS(157),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(157),
    [sym__newline] = ACTIONS(157),
    [sym__dedent] = ACTIONS(157),
  },
  [110] = {
    [sym_function_or_value_defn] = STATE(596),
    [sym__expression] = STATE(109),
    [sym_literal_expression] = STATE(1809),
    [sym_long_identifier_or_op] = STATE(1809),
    [sym_tuple_expression] = STATE(1809),
    [sym_brace_expression] = STATE(1809),
    [sym_anon_record_expression] = STATE(1809),
    [sym_prefixed_expression] = STATE(1809),
    [sym_typecast_expression] = STATE(1809),
    [sym_for_expression] = STATE(1809),
    [sym_while_expression] = STATE(1809),
    [sym__if_branch] = STATE(6874),
    [sym_if_expression] = STATE(1809),
    [sym_fun_expression] = STATE(1809),
    [sym_try_expression] = STATE(1809),
    [sym_match_expression] = STATE(1809),
    [sym_function_expression] = STATE(1809),
    [sym_mutate_expression] = STATE(1809),
    [sym_index_expression] = STATE(1809),
    [sym_typed_expression] = STATE(1809),
    [sym_declaration_expression] = STATE(1809),
    [sym_do_expression] = STATE(1809),
    [sym_list_expression] = STATE(1809),
    [sym_array_expression] = STATE(1809),
    [sym_begin_end_expression] = STATE(1809),
    [sym_paren_expression] = STATE(1809),
    [sym__high_prec_app] = STATE(1806),
    [sym__low_prec_app] = STATE(1806),
    [sym_application_expression] = STATE(1809),
    [sym_dot_expression] = STATE(1809),
    [sym_infix_expression] = STATE(1809),
    [sym_ce_expression] = STATE(1809),
    [sym_sequential_expression] = STATE(1809),
    [sym_char] = STATE(2014),
    [sym_format_string] = STATE(2019),
    [sym__string_literal] = STATE(2019),
    [sym_string] = STATE(2014),
    [sym_verbatim_string] = STATE(2014),
    [sym_bytearray] = STATE(2014),
    [sym_verbatim_bytearray] = STATE(2014),
    [sym_format_triple_quoted_string] = STATE(2020),
    [sym_triple_quoted_string] = STATE(2014),
    [sym_const] = STATE(1809),
    [sym_long_identifier] = STATE(1810),
    [sym_active_pattern] = STATE(1860),
    [sym__identifier_or_op] = STATE(1750),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(655),
    [sym_infix_op] = STATE(608),
    [sym_sbyte] = STATE(2014),
    [sym_byte] = STATE(2014),
    [sym_int16] = STATE(2014),
    [sym_uint16] = STATE(2014),
    [sym_int32] = STATE(2014),
    [sym_uint32] = STATE(2014),
    [sym_nativeint] = STATE(2014),
    [sym_unativeint] = STATE(2014),
    [sym_int64] = STATE(2014),
    [sym_uint64] = STATE(2014),
    [sym_ieee32] = STATE(2014),
    [sym_ieee64] = STATE(2014),
    [sym_bignum] = STATE(2014),
    [sym_decimal] = STATE(2014),
    [sym_float] = STATE(1438),
    [sym_block_comment] = STATE(110),
    [sym_compiler_directive_decl] = STATE(110),
    [sym_fsi_directive_decl] = STATE(110),
    [sym_preproc_line] = STATE(110),
    [sym_preproc_if_in_expression] = STATE(1809),
    [aux_sym_sequential_expression_repeat1] = STATE(1620),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(723),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(725),
    [anon_sym_return] = ACTIONS(727),
    [anon_sym_do] = ACTIONS(729),
    [anon_sym_and] = ACTIONS(161),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(731),
    [anon_sym_COMMA] = ACTIONS(733),
    [anon_sym_null] = ACTIONS(735),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(725),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(737),
    [anon_sym_LBRACK_PIPE] = ACTIONS(739),
    [anon_sym_LBRACE] = ACTIONS(741),
    [anon_sym_LT_AT] = ACTIONS(743),
    [anon_sym_LT_AT_AT] = ACTIONS(745),
    [anon_sym_DOT] = ACTIONS(747),
    [anon_sym_LBRACE_PIPE] = ACTIONS(749),
    [anon_sym_new] = ACTIONS(727),
    [anon_sym_return_BANG] = ACTIONS(751),
    [anon_sym_yield] = ACTIONS(727),
    [anon_sym_yield_BANG] = ACTIONS(751),
    [anon_sym_lazy] = ACTIONS(727),
    [anon_sym_assert] = ACTIONS(727),
    [anon_sym_upcast] = ACTIONS(727),
    [anon_sym_downcast] = ACTIONS(727),
    [anon_sym_COLON_GT] = ACTIONS(753),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(753),
    [anon_sym_for] = ACTIONS(755),
    [anon_sym_while] = ACTIONS(757),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(759),
    [anon_sym_try] = ACTIONS(761),
    [anon_sym_match] = ACTIONS(763),
    [anon_sym_match_BANG] = ACTIONS(765),
    [anon_sym_function] = ACTIONS(767),
    [anon_sym_LT_DASH] = ACTIONS(769),
    [anon_sym_DOT_LBRACK] = ACTIONS(771),
    [anon_sym_LT] = ACTIONS(773),
    [anon_sym_use] = ACTIONS(775),
    [anon_sym_use_BANG] = ACTIONS(777),
    [anon_sym_do_BANG] = ACTIONS(779),
    [anon_sym_begin] = ACTIONS(781),
    [anon_sym_LPAREN2] = ACTIONS(783),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(785),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(787),
    [anon_sym_DQUOTE] = ACTIONS(789),
    [anon_sym_AT_DQUOTE] = ACTIONS(791),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(793),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(795),
    [sym_bool] = ACTIONS(797),
    [sym_unit] = ACTIONS(799),
    [anon_sym_LPAREN_PIPE] = ACTIONS(801),
    [sym_op_identifier] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(805),
    [sym_xint] = ACTIONS(807),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(809),
    [sym__newline] = ACTIONS(851),
    [sym__dedent] = ACTIONS(159),
  },
  [111] = {
    [sym_function_or_value_defn] = STATE(703),
    [sym__expression] = STATE(108),
    [sym_literal_expression] = STATE(1797),
    [sym_long_identifier_or_op] = STATE(1797),
    [sym_tuple_expression] = STATE(1797),
    [sym_brace_expression] = STATE(1797),
    [sym_anon_record_expression] = STATE(1797),
    [sym_prefixed_expression] = STATE(1797),
    [sym_typecast_expression] = STATE(1797),
    [sym_for_expression] = STATE(1797),
    [sym_while_expression] = STATE(1797),
    [sym__if_branch] = STATE(6611),
    [sym_if_expression] = STATE(1797),
    [sym_fun_expression] = STATE(1797),
    [sym_try_expression] = STATE(1797),
    [sym_match_expression] = STATE(1797),
    [sym_function_expression] = STATE(1797),
    [sym_mutate_expression] = STATE(1797),
    [sym_index_expression] = STATE(1797),
    [sym_typed_expression] = STATE(1797),
    [sym_declaration_expression] = STATE(1797),
    [sym_do_expression] = STATE(1797),
    [sym_list_expression] = STATE(1797),
    [sym_array_expression] = STATE(1797),
    [sym_begin_end_expression] = STATE(1797),
    [sym_paren_expression] = STATE(1797),
    [sym__high_prec_app] = STATE(1800),
    [sym__low_prec_app] = STATE(1800),
    [sym_application_expression] = STATE(1797),
    [sym_dot_expression] = STATE(1797),
    [sym_infix_expression] = STATE(1797),
    [sym_ce_expression] = STATE(1797),
    [sym_sequential_expression] = STATE(1797),
    [sym_char] = STATE(1694),
    [sym_format_string] = STATE(1693),
    [sym__string_literal] = STATE(1693),
    [sym_string] = STATE(1694),
    [sym_verbatim_string] = STATE(1694),
    [sym_bytearray] = STATE(1694),
    [sym_verbatim_bytearray] = STATE(1694),
    [sym_format_triple_quoted_string] = STATE(1692),
    [sym_triple_quoted_string] = STATE(1694),
    [sym_const] = STATE(1797),
    [sym_long_identifier] = STATE(1813),
    [sym_active_pattern] = STATE(1753),
    [sym__identifier_or_op] = STATE(1812),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(756),
    [sym_infix_op] = STATE(515),
    [sym_sbyte] = STATE(1694),
    [sym_byte] = STATE(1694),
    [sym_int16] = STATE(1694),
    [sym_uint16] = STATE(1694),
    [sym_int32] = STATE(1694),
    [sym_uint32] = STATE(1694),
    [sym_nativeint] = STATE(1694),
    [sym_unativeint] = STATE(1694),
    [sym_int64] = STATE(1694),
    [sym_uint64] = STATE(1694),
    [sym_ieee32] = STATE(1694),
    [sym_ieee64] = STATE(1694),
    [sym_bignum] = STATE(1694),
    [sym_decimal] = STATE(1694),
    [sym_float] = STATE(1425),
    [sym_block_comment] = STATE(111),
    [sym_compiler_directive_decl] = STATE(111),
    [sym_fsi_directive_decl] = STATE(111),
    [sym_preproc_line] = STATE(111),
    [sym_preproc_if_in_expression] = STATE(1797),
    [aux_sym_sequential_expression_repeat1] = STATE(1585),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(393),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(395),
    [anon_sym_return] = ACTIONS(397),
    [anon_sym_do] = ACTIONS(399),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_as] = ACTIONS(161),
    [anon_sym_LPAREN] = ACTIONS(401),
    [anon_sym_COMMA] = ACTIONS(403),
    [anon_sym_null] = ACTIONS(405),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(395),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(407),
    [anon_sym_LBRACK_PIPE] = ACTIONS(409),
    [anon_sym_LBRACE] = ACTIONS(411),
    [anon_sym_LT_AT] = ACTIONS(413),
    [anon_sym_LT_AT_AT] = ACTIONS(415),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_LBRACE_PIPE] = ACTIONS(419),
    [anon_sym_new] = ACTIONS(397),
    [anon_sym_with] = ACTIONS(161),
    [anon_sym_return_BANG] = ACTIONS(421),
    [anon_sym_yield] = ACTIONS(397),
    [anon_sym_yield_BANG] = ACTIONS(421),
    [anon_sym_lazy] = ACTIONS(397),
    [anon_sym_assert] = ACTIONS(397),
    [anon_sym_upcast] = ACTIONS(397),
    [anon_sym_downcast] = ACTIONS(397),
    [anon_sym_COLON_GT] = ACTIONS(423),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(423),
    [anon_sym_for] = ACTIONS(425),
    [anon_sym_while] = ACTIONS(427),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(429),
    [anon_sym_try] = ACTIONS(431),
    [anon_sym_match] = ACTIONS(433),
    [anon_sym_match_BANG] = ACTIONS(435),
    [anon_sym_function] = ACTIONS(437),
    [anon_sym_LT_DASH] = ACTIONS(439),
    [anon_sym_DOT_LBRACK] = ACTIONS(441),
    [anon_sym_LT] = ACTIONS(443),
    [anon_sym_use] = ACTIONS(445),
    [anon_sym_use_BANG] = ACTIONS(447),
    [anon_sym_do_BANG] = ACTIONS(449),
    [anon_sym_begin] = ACTIONS(451),
    [anon_sym_LPAREN2] = ACTIONS(453),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(455),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(457),
    [anon_sym_DQUOTE] = ACTIONS(459),
    [anon_sym_AT_DQUOTE] = ACTIONS(461),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(463),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(465),
    [sym_bool] = ACTIONS(467),
    [sym_unit] = ACTIONS(469),
    [anon_sym_LPAREN_PIPE] = ACTIONS(471),
    [sym_op_identifier] = ACTIONS(473),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(475),
    [sym_xint] = ACTIONS(477),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(479),
    [sym__newline] = ACTIONS(863),
  },
  [112] = {
    [sym_function_or_value_defn] = STATE(663),
    [sym__expression] = STATE(76),
    [sym_literal_expression] = STATE(1118),
    [sym_long_identifier_or_op] = STATE(1118),
    [sym_tuple_expression] = STATE(1118),
    [sym_brace_expression] = STATE(1118),
    [sym_anon_record_expression] = STATE(1118),
    [sym_prefixed_expression] = STATE(1118),
    [sym_typecast_expression] = STATE(1118),
    [sym_for_expression] = STATE(1118),
    [sym_while_expression] = STATE(1118),
    [sym__if_branch] = STATE(7163),
    [sym_if_expression] = STATE(1118),
    [sym_fun_expression] = STATE(1118),
    [sym_try_expression] = STATE(1118),
    [sym_match_expression] = STATE(1118),
    [sym_function_expression] = STATE(1118),
    [sym_mutate_expression] = STATE(1118),
    [sym_index_expression] = STATE(1118),
    [sym_typed_expression] = STATE(1118),
    [sym_declaration_expression] = STATE(1118),
    [sym_do_expression] = STATE(1118),
    [sym_list_expression] = STATE(1118),
    [sym_array_expression] = STATE(1118),
    [sym_begin_end_expression] = STATE(1118),
    [sym_paren_expression] = STATE(1118),
    [sym__high_prec_app] = STATE(1133),
    [sym__low_prec_app] = STATE(1133),
    [sym_application_expression] = STATE(1118),
    [sym_dot_expression] = STATE(1118),
    [sym_infix_expression] = STATE(1118),
    [sym_ce_expression] = STATE(1118),
    [sym_sequential_expression] = STATE(1118),
    [sym_char] = STATE(1080),
    [sym_format_string] = STATE(1090),
    [sym__string_literal] = STATE(1090),
    [sym_string] = STATE(1080),
    [sym_verbatim_string] = STATE(1080),
    [sym_bytearray] = STATE(1080),
    [sym_verbatim_bytearray] = STATE(1080),
    [sym_format_triple_quoted_string] = STATE(1096),
    [sym_triple_quoted_string] = STATE(1080),
    [sym_const] = STATE(1118),
    [sym_long_identifier] = STATE(1156),
    [sym_active_pattern] = STATE(1085),
    [sym__identifier_or_op] = STATE(1099),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(548),
    [sym_infix_op] = STATE(687),
    [sym_sbyte] = STATE(1080),
    [sym_byte] = STATE(1080),
    [sym_int16] = STATE(1080),
    [sym_uint16] = STATE(1080),
    [sym_int32] = STATE(1080),
    [sym_uint32] = STATE(1080),
    [sym_nativeint] = STATE(1080),
    [sym_unativeint] = STATE(1080),
    [sym_int64] = STATE(1080),
    [sym_uint64] = STATE(1080),
    [sym_ieee32] = STATE(1080),
    [sym_ieee64] = STATE(1080),
    [sym_bignum] = STATE(1080),
    [sym_decimal] = STATE(1080),
    [sym_float] = STATE(979),
    [sym_block_comment] = STATE(112),
    [sym_compiler_directive_decl] = STATE(112),
    [sym_fsi_directive_decl] = STATE(112),
    [sym_preproc_line] = STATE(112),
    [sym_preproc_if_in_expression] = STATE(1118),
    [aux_sym_sequential_expression_repeat1] = STATE(1558),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(195),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(197),
    [anon_sym_return] = ACTIONS(481),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_COMMA] = ACTIONS(483),
    [anon_sym_null] = ACTIONS(207),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(197),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(209),
    [anon_sym_RBRACK] = ACTIONS(865),
    [anon_sym_LBRACK_PIPE] = ACTIONS(211),
    [anon_sym_LBRACE] = ACTIONS(271),
    [anon_sym_LT_AT] = ACTIONS(213),
    [anon_sym_LT_AT_AT] = ACTIONS(215),
    [anon_sym_DOT] = ACTIONS(185),
    [anon_sym_LBRACE_PIPE] = ACTIONS(217),
    [anon_sym_new] = ACTIONS(481),
    [anon_sym_return_BANG] = ACTIONS(487),
    [anon_sym_yield] = ACTIONS(481),
    [anon_sym_yield_BANG] = ACTIONS(487),
    [anon_sym_lazy] = ACTIONS(481),
    [anon_sym_assert] = ACTIONS(481),
    [anon_sym_upcast] = ACTIONS(481),
    [anon_sym_downcast] = ACTIONS(481),
    [anon_sym_COLON_GT] = ACTIONS(221),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(221),
    [anon_sym_for] = ACTIONS(489),
    [anon_sym_while] = ACTIONS(225),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(229),
    [anon_sym_match] = ACTIONS(231),
    [anon_sym_match_BANG] = ACTIONS(233),
    [anon_sym_function] = ACTIONS(235),
    [anon_sym_LT_DASH] = ACTIONS(491),
    [anon_sym_DOT_LBRACK] = ACTIONS(187),
    [anon_sym_LT] = ACTIONS(189),
    [anon_sym_use] = ACTIONS(493),
    [anon_sym_use_BANG] = ACTIONS(495),
    [anon_sym_do_BANG] = ACTIONS(243),
    [anon_sym_begin] = ACTIONS(245),
    [anon_sym_LPAREN2] = ACTIONS(191),
    [anon_sym_DOT_DOT2] = ACTIONS(497),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(247),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(251),
    [anon_sym_AT_DQUOTE] = ACTIONS(253),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(255),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(257),
    [sym_bool] = ACTIONS(259),
    [sym_unit] = ACTIONS(193),
    [anon_sym_LPAREN_PIPE] = ACTIONS(261),
    [sym_op_identifier] = ACTIONS(263),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(499),
    [sym_xint] = ACTIONS(267),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(269),
    [sym__newline] = ACTIONS(501),
  },
  [113] = {
    [sym_function_or_value_defn] = STATE(596),
    [sym__expression] = STATE(109),
    [sym_literal_expression] = STATE(1809),
    [sym_long_identifier_or_op] = STATE(1809),
    [sym_tuple_expression] = STATE(1809),
    [sym_brace_expression] = STATE(1809),
    [sym_anon_record_expression] = STATE(1809),
    [sym_prefixed_expression] = STATE(1809),
    [sym_typecast_expression] = STATE(1809),
    [sym_for_expression] = STATE(1809),
    [sym_while_expression] = STATE(1809),
    [sym__if_branch] = STATE(6874),
    [sym_if_expression] = STATE(1809),
    [sym_fun_expression] = STATE(1809),
    [sym_try_expression] = STATE(1809),
    [sym_match_expression] = STATE(1809),
    [sym_function_expression] = STATE(1809),
    [sym_mutate_expression] = STATE(1809),
    [sym_index_expression] = STATE(1809),
    [sym_typed_expression] = STATE(1809),
    [sym_declaration_expression] = STATE(1809),
    [sym_do_expression] = STATE(1809),
    [sym_list_expression] = STATE(1809),
    [sym_array_expression] = STATE(1809),
    [sym_begin_end_expression] = STATE(1809),
    [sym_paren_expression] = STATE(1809),
    [sym__high_prec_app] = STATE(1806),
    [sym__low_prec_app] = STATE(1806),
    [sym_application_expression] = STATE(1809),
    [sym_dot_expression] = STATE(1809),
    [sym_infix_expression] = STATE(1809),
    [sym_ce_expression] = STATE(1809),
    [sym_sequential_expression] = STATE(1809),
    [sym_char] = STATE(2014),
    [sym_format_string] = STATE(2019),
    [sym__string_literal] = STATE(2019),
    [sym_string] = STATE(2014),
    [sym_verbatim_string] = STATE(2014),
    [sym_bytearray] = STATE(2014),
    [sym_verbatim_bytearray] = STATE(2014),
    [sym_format_triple_quoted_string] = STATE(2020),
    [sym_triple_quoted_string] = STATE(2014),
    [sym_const] = STATE(1809),
    [sym_long_identifier] = STATE(1810),
    [sym_active_pattern] = STATE(1860),
    [sym__identifier_or_op] = STATE(1750),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(655),
    [sym_infix_op] = STATE(608),
    [sym_sbyte] = STATE(2014),
    [sym_byte] = STATE(2014),
    [sym_int16] = STATE(2014),
    [sym_uint16] = STATE(2014),
    [sym_int32] = STATE(2014),
    [sym_uint32] = STATE(2014),
    [sym_nativeint] = STATE(2014),
    [sym_unativeint] = STATE(2014),
    [sym_int64] = STATE(2014),
    [sym_uint64] = STATE(2014),
    [sym_ieee32] = STATE(2014),
    [sym_ieee64] = STATE(2014),
    [sym_bignum] = STATE(2014),
    [sym_decimal] = STATE(2014),
    [sym_float] = STATE(1438),
    [sym_block_comment] = STATE(113),
    [sym_compiler_directive_decl] = STATE(113),
    [sym_fsi_directive_decl] = STATE(113),
    [sym_preproc_line] = STATE(113),
    [sym_preproc_if_in_expression] = STATE(1809),
    [aux_sym_sequential_expression_repeat1] = STATE(1620),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(723),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(725),
    [anon_sym_return] = ACTIONS(727),
    [anon_sym_do] = ACTIONS(729),
    [anon_sym_and] = ACTIONS(165),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(731),
    [anon_sym_COMMA] = ACTIONS(733),
    [anon_sym_null] = ACTIONS(735),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(725),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(737),
    [anon_sym_LBRACK_PIPE] = ACTIONS(739),
    [anon_sym_LBRACE] = ACTIONS(165),
    [anon_sym_LT_AT] = ACTIONS(743),
    [anon_sym_LT_AT_AT] = ACTIONS(745),
    [anon_sym_DOT] = ACTIONS(747),
    [anon_sym_LBRACE_PIPE] = ACTIONS(749),
    [anon_sym_new] = ACTIONS(727),
    [anon_sym_return_BANG] = ACTIONS(751),
    [anon_sym_yield] = ACTIONS(727),
    [anon_sym_yield_BANG] = ACTIONS(751),
    [anon_sym_lazy] = ACTIONS(727),
    [anon_sym_assert] = ACTIONS(727),
    [anon_sym_upcast] = ACTIONS(727),
    [anon_sym_downcast] = ACTIONS(727),
    [anon_sym_COLON_GT] = ACTIONS(753),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(753),
    [anon_sym_for] = ACTIONS(755),
    [anon_sym_while] = ACTIONS(757),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(759),
    [anon_sym_try] = ACTIONS(761),
    [anon_sym_match] = ACTIONS(763),
    [anon_sym_match_BANG] = ACTIONS(765),
    [anon_sym_function] = ACTIONS(767),
    [anon_sym_LT_DASH] = ACTIONS(769),
    [anon_sym_DOT_LBRACK] = ACTIONS(771),
    [anon_sym_LT] = ACTIONS(773),
    [anon_sym_use] = ACTIONS(775),
    [anon_sym_use_BANG] = ACTIONS(777),
    [anon_sym_do_BANG] = ACTIONS(779),
    [anon_sym_begin] = ACTIONS(781),
    [anon_sym_LPAREN2] = ACTIONS(783),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(785),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(787),
    [anon_sym_DQUOTE] = ACTIONS(789),
    [anon_sym_AT_DQUOTE] = ACTIONS(791),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(793),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(795),
    [sym_bool] = ACTIONS(797),
    [sym_unit] = ACTIONS(799),
    [anon_sym_LPAREN_PIPE] = ACTIONS(801),
    [sym_op_identifier] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(805),
    [sym_xint] = ACTIONS(807),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(809),
    [sym__newline] = ACTIONS(163),
    [sym__dedent] = ACTIONS(163),
  },
  [114] = {
    [sym_function_or_value_defn] = STATE(596),
    [sym__expression] = STATE(109),
    [sym_literal_expression] = STATE(1809),
    [sym_long_identifier_or_op] = STATE(1809),
    [sym_tuple_expression] = STATE(1809),
    [sym_brace_expression] = STATE(1809),
    [sym_anon_record_expression] = STATE(1809),
    [sym_prefixed_expression] = STATE(1809),
    [sym_typecast_expression] = STATE(1809),
    [sym_for_expression] = STATE(1809),
    [sym_while_expression] = STATE(1809),
    [sym__if_branch] = STATE(6874),
    [sym_if_expression] = STATE(1809),
    [sym_fun_expression] = STATE(1809),
    [sym_try_expression] = STATE(1809),
    [sym_match_expression] = STATE(1809),
    [sym_function_expression] = STATE(1809),
    [sym_mutate_expression] = STATE(1809),
    [sym_index_expression] = STATE(1809),
    [sym_typed_expression] = STATE(1809),
    [sym_declaration_expression] = STATE(1809),
    [sym_do_expression] = STATE(1809),
    [sym_list_expression] = STATE(1809),
    [sym_array_expression] = STATE(1809),
    [sym_begin_end_expression] = STATE(1809),
    [sym_paren_expression] = STATE(1809),
    [sym__high_prec_app] = STATE(1806),
    [sym__low_prec_app] = STATE(1806),
    [sym_application_expression] = STATE(1809),
    [sym_dot_expression] = STATE(1809),
    [sym_infix_expression] = STATE(1809),
    [sym_ce_expression] = STATE(1809),
    [sym_sequential_expression] = STATE(1809),
    [sym_char] = STATE(2014),
    [sym_format_string] = STATE(2019),
    [sym__string_literal] = STATE(2019),
    [sym_string] = STATE(2014),
    [sym_verbatim_string] = STATE(2014),
    [sym_bytearray] = STATE(2014),
    [sym_verbatim_bytearray] = STATE(2014),
    [sym_format_triple_quoted_string] = STATE(2020),
    [sym_triple_quoted_string] = STATE(2014),
    [sym_const] = STATE(1809),
    [sym_long_identifier] = STATE(1810),
    [sym_active_pattern] = STATE(1860),
    [sym__identifier_or_op] = STATE(1750),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(655),
    [sym_infix_op] = STATE(608),
    [sym_sbyte] = STATE(2014),
    [sym_byte] = STATE(2014),
    [sym_int16] = STATE(2014),
    [sym_uint16] = STATE(2014),
    [sym_int32] = STATE(2014),
    [sym_uint32] = STATE(2014),
    [sym_nativeint] = STATE(2014),
    [sym_unativeint] = STATE(2014),
    [sym_int64] = STATE(2014),
    [sym_uint64] = STATE(2014),
    [sym_ieee32] = STATE(2014),
    [sym_ieee64] = STATE(2014),
    [sym_bignum] = STATE(2014),
    [sym_decimal] = STATE(2014),
    [sym_float] = STATE(1438),
    [sym_block_comment] = STATE(114),
    [sym_compiler_directive_decl] = STATE(114),
    [sym_fsi_directive_decl] = STATE(114),
    [sym_preproc_line] = STATE(114),
    [sym_preproc_if_in_expression] = STATE(1809),
    [aux_sym_sequential_expression_repeat1] = STATE(1620),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(723),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(725),
    [anon_sym_return] = ACTIONS(727),
    [anon_sym_do] = ACTIONS(729),
    [anon_sym_and] = ACTIONS(169),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(731),
    [anon_sym_COMMA] = ACTIONS(733),
    [anon_sym_null] = ACTIONS(735),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(725),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(737),
    [anon_sym_LBRACK_PIPE] = ACTIONS(739),
    [anon_sym_LBRACE] = ACTIONS(169),
    [anon_sym_LT_AT] = ACTIONS(743),
    [anon_sym_LT_AT_AT] = ACTIONS(745),
    [anon_sym_DOT] = ACTIONS(747),
    [anon_sym_LBRACE_PIPE] = ACTIONS(749),
    [anon_sym_new] = ACTIONS(727),
    [anon_sym_return_BANG] = ACTIONS(751),
    [anon_sym_yield] = ACTIONS(727),
    [anon_sym_yield_BANG] = ACTIONS(751),
    [anon_sym_lazy] = ACTIONS(727),
    [anon_sym_assert] = ACTIONS(727),
    [anon_sym_upcast] = ACTIONS(727),
    [anon_sym_downcast] = ACTIONS(727),
    [anon_sym_COLON_GT] = ACTIONS(753),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(753),
    [anon_sym_for] = ACTIONS(755),
    [anon_sym_while] = ACTIONS(757),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(759),
    [anon_sym_try] = ACTIONS(761),
    [anon_sym_match] = ACTIONS(763),
    [anon_sym_match_BANG] = ACTIONS(765),
    [anon_sym_function] = ACTIONS(767),
    [anon_sym_LT_DASH] = ACTIONS(769),
    [anon_sym_DOT_LBRACK] = ACTIONS(771),
    [anon_sym_LT] = ACTIONS(773),
    [anon_sym_use] = ACTIONS(775),
    [anon_sym_use_BANG] = ACTIONS(777),
    [anon_sym_do_BANG] = ACTIONS(779),
    [anon_sym_begin] = ACTIONS(781),
    [anon_sym_LPAREN2] = ACTIONS(783),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(785),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(787),
    [anon_sym_DQUOTE] = ACTIONS(789),
    [anon_sym_AT_DQUOTE] = ACTIONS(791),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(793),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(795),
    [sym_bool] = ACTIONS(797),
    [sym_unit] = ACTIONS(799),
    [anon_sym_LPAREN_PIPE] = ACTIONS(801),
    [sym_op_identifier] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(805),
    [sym_xint] = ACTIONS(807),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(809),
    [sym__newline] = ACTIONS(167),
    [sym__dedent] = ACTIONS(167),
  },
  [115] = {
    [sym_function_or_value_defn] = STATE(596),
    [sym__expression] = STATE(109),
    [sym_literal_expression] = STATE(1809),
    [sym_long_identifier_or_op] = STATE(1809),
    [sym_tuple_expression] = STATE(1809),
    [sym_brace_expression] = STATE(1809),
    [sym_anon_record_expression] = STATE(1809),
    [sym_prefixed_expression] = STATE(1809),
    [sym_typecast_expression] = STATE(1809),
    [sym_for_expression] = STATE(1809),
    [sym_while_expression] = STATE(1809),
    [sym__if_branch] = STATE(6874),
    [sym_if_expression] = STATE(1809),
    [sym_fun_expression] = STATE(1809),
    [sym_try_expression] = STATE(1809),
    [sym_match_expression] = STATE(1809),
    [sym_function_expression] = STATE(1809),
    [sym_mutate_expression] = STATE(1809),
    [sym_index_expression] = STATE(1809),
    [sym_typed_expression] = STATE(1809),
    [sym_declaration_expression] = STATE(1809),
    [sym_do_expression] = STATE(1809),
    [sym_list_expression] = STATE(1809),
    [sym_array_expression] = STATE(1809),
    [sym_begin_end_expression] = STATE(1809),
    [sym_paren_expression] = STATE(1809),
    [sym__high_prec_app] = STATE(1806),
    [sym__low_prec_app] = STATE(1806),
    [sym_application_expression] = STATE(1809),
    [sym_dot_expression] = STATE(1809),
    [sym_infix_expression] = STATE(1809),
    [sym_ce_expression] = STATE(1809),
    [sym_sequential_expression] = STATE(1809),
    [sym_char] = STATE(2014),
    [sym_format_string] = STATE(2019),
    [sym__string_literal] = STATE(2019),
    [sym_string] = STATE(2014),
    [sym_verbatim_string] = STATE(2014),
    [sym_bytearray] = STATE(2014),
    [sym_verbatim_bytearray] = STATE(2014),
    [sym_format_triple_quoted_string] = STATE(2020),
    [sym_triple_quoted_string] = STATE(2014),
    [sym_const] = STATE(1809),
    [sym_long_identifier] = STATE(1810),
    [sym_active_pattern] = STATE(1860),
    [sym__identifier_or_op] = STATE(1750),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(655),
    [sym_infix_op] = STATE(608),
    [sym_sbyte] = STATE(2014),
    [sym_byte] = STATE(2014),
    [sym_int16] = STATE(2014),
    [sym_uint16] = STATE(2014),
    [sym_int32] = STATE(2014),
    [sym_uint32] = STATE(2014),
    [sym_nativeint] = STATE(2014),
    [sym_unativeint] = STATE(2014),
    [sym_int64] = STATE(2014),
    [sym_uint64] = STATE(2014),
    [sym_ieee32] = STATE(2014),
    [sym_ieee64] = STATE(2014),
    [sym_bignum] = STATE(2014),
    [sym_decimal] = STATE(2014),
    [sym_float] = STATE(1438),
    [sym_block_comment] = STATE(115),
    [sym_compiler_directive_decl] = STATE(115),
    [sym_fsi_directive_decl] = STATE(115),
    [sym_preproc_line] = STATE(115),
    [sym_preproc_if_in_expression] = STATE(1809),
    [aux_sym_sequential_expression_repeat1] = STATE(1620),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(723),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(725),
    [anon_sym_return] = ACTIONS(727),
    [anon_sym_do] = ACTIONS(729),
    [anon_sym_and] = ACTIONS(867),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(731),
    [anon_sym_COMMA] = ACTIONS(733),
    [anon_sym_null] = ACTIONS(735),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(725),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(737),
    [anon_sym_LBRACK_PIPE] = ACTIONS(739),
    [anon_sym_LBRACE] = ACTIONS(741),
    [anon_sym_LT_AT] = ACTIONS(743),
    [anon_sym_LT_AT_AT] = ACTIONS(745),
    [anon_sym_DOT] = ACTIONS(747),
    [anon_sym_LBRACE_PIPE] = ACTIONS(749),
    [anon_sym_new] = ACTIONS(727),
    [anon_sym_return_BANG] = ACTIONS(751),
    [anon_sym_yield] = ACTIONS(727),
    [anon_sym_yield_BANG] = ACTIONS(751),
    [anon_sym_lazy] = ACTIONS(727),
    [anon_sym_assert] = ACTIONS(727),
    [anon_sym_upcast] = ACTIONS(727),
    [anon_sym_downcast] = ACTIONS(727),
    [anon_sym_COLON_GT] = ACTIONS(753),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(753),
    [anon_sym_for] = ACTIONS(755),
    [anon_sym_while] = ACTIONS(757),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(759),
    [anon_sym_try] = ACTIONS(761),
    [anon_sym_match] = ACTIONS(763),
    [anon_sym_match_BANG] = ACTIONS(765),
    [anon_sym_function] = ACTIONS(767),
    [anon_sym_LT_DASH] = ACTIONS(769),
    [anon_sym_DOT_LBRACK] = ACTIONS(771),
    [anon_sym_LT] = ACTIONS(773),
    [anon_sym_use] = ACTIONS(775),
    [anon_sym_use_BANG] = ACTIONS(777),
    [anon_sym_do_BANG] = ACTIONS(779),
    [anon_sym_begin] = ACTIONS(781),
    [anon_sym_LPAREN2] = ACTIONS(783),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(785),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(787),
    [anon_sym_DQUOTE] = ACTIONS(789),
    [anon_sym_AT_DQUOTE] = ACTIONS(791),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(793),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(795),
    [sym_bool] = ACTIONS(797),
    [sym_unit] = ACTIONS(799),
    [anon_sym_LPAREN_PIPE] = ACTIONS(801),
    [sym_op_identifier] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(805),
    [sym_xint] = ACTIONS(807),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(809),
    [sym__newline] = ACTIONS(851),
    [sym__dedent] = ACTIONS(869),
  },
  [116] = {
    [sym_function_or_value_defn] = STATE(703),
    [sym__expression] = STATE(108),
    [sym_literal_expression] = STATE(1797),
    [sym_long_identifier_or_op] = STATE(1797),
    [sym_tuple_expression] = STATE(1797),
    [sym_brace_expression] = STATE(1797),
    [sym_anon_record_expression] = STATE(1797),
    [sym_prefixed_expression] = STATE(1797),
    [sym_typecast_expression] = STATE(1797),
    [sym_for_expression] = STATE(1797),
    [sym_while_expression] = STATE(1797),
    [sym__if_branch] = STATE(6611),
    [sym_if_expression] = STATE(1797),
    [sym_fun_expression] = STATE(1797),
    [sym_try_expression] = STATE(1797),
    [sym_match_expression] = STATE(1797),
    [sym_function_expression] = STATE(1797),
    [sym_mutate_expression] = STATE(1797),
    [sym_index_expression] = STATE(1797),
    [sym_typed_expression] = STATE(1797),
    [sym_declaration_expression] = STATE(1797),
    [sym_do_expression] = STATE(1797),
    [sym_list_expression] = STATE(1797),
    [sym_array_expression] = STATE(1797),
    [sym_begin_end_expression] = STATE(1797),
    [sym_paren_expression] = STATE(1797),
    [sym__high_prec_app] = STATE(1800),
    [sym__low_prec_app] = STATE(1800),
    [sym_application_expression] = STATE(1797),
    [sym_dot_expression] = STATE(1797),
    [sym_infix_expression] = STATE(1797),
    [sym_ce_expression] = STATE(1797),
    [sym_sequential_expression] = STATE(1797),
    [sym_char] = STATE(1694),
    [sym_format_string] = STATE(1693),
    [sym__string_literal] = STATE(1693),
    [sym_string] = STATE(1694),
    [sym_verbatim_string] = STATE(1694),
    [sym_bytearray] = STATE(1694),
    [sym_verbatim_bytearray] = STATE(1694),
    [sym_format_triple_quoted_string] = STATE(1692),
    [sym_triple_quoted_string] = STATE(1694),
    [sym_const] = STATE(1797),
    [sym_long_identifier] = STATE(1813),
    [sym_active_pattern] = STATE(1753),
    [sym__identifier_or_op] = STATE(1812),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(756),
    [sym_infix_op] = STATE(515),
    [sym_sbyte] = STATE(1694),
    [sym_byte] = STATE(1694),
    [sym_int16] = STATE(1694),
    [sym_uint16] = STATE(1694),
    [sym_int32] = STATE(1694),
    [sym_uint32] = STATE(1694),
    [sym_nativeint] = STATE(1694),
    [sym_unativeint] = STATE(1694),
    [sym_int64] = STATE(1694),
    [sym_uint64] = STATE(1694),
    [sym_ieee32] = STATE(1694),
    [sym_ieee64] = STATE(1694),
    [sym_bignum] = STATE(1694),
    [sym_decimal] = STATE(1694),
    [sym_float] = STATE(1425),
    [sym_block_comment] = STATE(116),
    [sym_compiler_directive_decl] = STATE(116),
    [sym_fsi_directive_decl] = STATE(116),
    [sym_preproc_line] = STATE(116),
    [sym_preproc_if_in_expression] = STATE(1797),
    [aux_sym_sequential_expression_repeat1] = STATE(1585),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(393),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(395),
    [anon_sym_return] = ACTIONS(397),
    [anon_sym_do] = ACTIONS(399),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_as] = ACTIONS(165),
    [anon_sym_LPAREN] = ACTIONS(401),
    [anon_sym_COMMA] = ACTIONS(403),
    [anon_sym_null] = ACTIONS(405),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(395),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(407),
    [anon_sym_LBRACK_PIPE] = ACTIONS(409),
    [anon_sym_LBRACE] = ACTIONS(165),
    [anon_sym_LT_AT] = ACTIONS(413),
    [anon_sym_LT_AT_AT] = ACTIONS(415),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_LBRACE_PIPE] = ACTIONS(419),
    [anon_sym_new] = ACTIONS(397),
    [anon_sym_with] = ACTIONS(165),
    [anon_sym_return_BANG] = ACTIONS(421),
    [anon_sym_yield] = ACTIONS(397),
    [anon_sym_yield_BANG] = ACTIONS(421),
    [anon_sym_lazy] = ACTIONS(397),
    [anon_sym_assert] = ACTIONS(397),
    [anon_sym_upcast] = ACTIONS(397),
    [anon_sym_downcast] = ACTIONS(397),
    [anon_sym_COLON_GT] = ACTIONS(423),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(423),
    [anon_sym_for] = ACTIONS(425),
    [anon_sym_while] = ACTIONS(427),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(429),
    [anon_sym_try] = ACTIONS(431),
    [anon_sym_match] = ACTIONS(433),
    [anon_sym_match_BANG] = ACTIONS(435),
    [anon_sym_function] = ACTIONS(437),
    [anon_sym_LT_DASH] = ACTIONS(439),
    [anon_sym_DOT_LBRACK] = ACTIONS(441),
    [anon_sym_LT] = ACTIONS(443),
    [anon_sym_use] = ACTIONS(445),
    [anon_sym_use_BANG] = ACTIONS(447),
    [anon_sym_do_BANG] = ACTIONS(449),
    [anon_sym_begin] = ACTIONS(451),
    [anon_sym_LPAREN2] = ACTIONS(453),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(455),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(457),
    [anon_sym_DQUOTE] = ACTIONS(459),
    [anon_sym_AT_DQUOTE] = ACTIONS(461),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(463),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(465),
    [sym_bool] = ACTIONS(467),
    [sym_unit] = ACTIONS(469),
    [anon_sym_LPAREN_PIPE] = ACTIONS(471),
    [sym_op_identifier] = ACTIONS(473),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(475),
    [sym_xint] = ACTIONS(477),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(479),
    [sym__newline] = ACTIONS(163),
  },
  [117] = {
    [sym_function_or_value_defn] = STATE(703),
    [sym__expression] = STATE(108),
    [sym_literal_expression] = STATE(1797),
    [sym_long_identifier_or_op] = STATE(1797),
    [sym_tuple_expression] = STATE(1797),
    [sym_brace_expression] = STATE(1797),
    [sym_anon_record_expression] = STATE(1797),
    [sym_prefixed_expression] = STATE(1797),
    [sym_typecast_expression] = STATE(1797),
    [sym_for_expression] = STATE(1797),
    [sym_while_expression] = STATE(1797),
    [sym__if_branch] = STATE(6611),
    [sym_if_expression] = STATE(1797),
    [sym_fun_expression] = STATE(1797),
    [sym_try_expression] = STATE(1797),
    [sym_match_expression] = STATE(1797),
    [sym_function_expression] = STATE(1797),
    [sym_mutate_expression] = STATE(1797),
    [sym_index_expression] = STATE(1797),
    [sym_typed_expression] = STATE(1797),
    [sym_declaration_expression] = STATE(1797),
    [sym_do_expression] = STATE(1797),
    [sym_list_expression] = STATE(1797),
    [sym_array_expression] = STATE(1797),
    [sym_begin_end_expression] = STATE(1797),
    [sym_paren_expression] = STATE(1797),
    [sym__high_prec_app] = STATE(1800),
    [sym__low_prec_app] = STATE(1800),
    [sym_application_expression] = STATE(1797),
    [sym_dot_expression] = STATE(1797),
    [sym_infix_expression] = STATE(1797),
    [sym_ce_expression] = STATE(1797),
    [sym_sequential_expression] = STATE(1797),
    [sym_char] = STATE(1694),
    [sym_format_string] = STATE(1693),
    [sym__string_literal] = STATE(1693),
    [sym_string] = STATE(1694),
    [sym_verbatim_string] = STATE(1694),
    [sym_bytearray] = STATE(1694),
    [sym_verbatim_bytearray] = STATE(1694),
    [sym_format_triple_quoted_string] = STATE(1692),
    [sym_triple_quoted_string] = STATE(1694),
    [sym_const] = STATE(1797),
    [sym_long_identifier] = STATE(1813),
    [sym_active_pattern] = STATE(1753),
    [sym__identifier_or_op] = STATE(1812),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(756),
    [sym_infix_op] = STATE(515),
    [sym_sbyte] = STATE(1694),
    [sym_byte] = STATE(1694),
    [sym_int16] = STATE(1694),
    [sym_uint16] = STATE(1694),
    [sym_int32] = STATE(1694),
    [sym_uint32] = STATE(1694),
    [sym_nativeint] = STATE(1694),
    [sym_unativeint] = STATE(1694),
    [sym_int64] = STATE(1694),
    [sym_uint64] = STATE(1694),
    [sym_ieee32] = STATE(1694),
    [sym_ieee64] = STATE(1694),
    [sym_bignum] = STATE(1694),
    [sym_decimal] = STATE(1694),
    [sym_float] = STATE(1425),
    [sym_block_comment] = STATE(117),
    [sym_compiler_directive_decl] = STATE(117),
    [sym_fsi_directive_decl] = STATE(117),
    [sym_preproc_line] = STATE(117),
    [sym_preproc_if_in_expression] = STATE(1797),
    [aux_sym_sequential_expression_repeat1] = STATE(1585),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(393),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(395),
    [anon_sym_return] = ACTIONS(397),
    [anon_sym_do] = ACTIONS(399),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_as] = ACTIONS(169),
    [anon_sym_LPAREN] = ACTIONS(401),
    [anon_sym_COMMA] = ACTIONS(403),
    [anon_sym_null] = ACTIONS(405),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(395),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(407),
    [anon_sym_LBRACK_PIPE] = ACTIONS(409),
    [anon_sym_LBRACE] = ACTIONS(169),
    [anon_sym_LT_AT] = ACTIONS(413),
    [anon_sym_LT_AT_AT] = ACTIONS(415),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_LBRACE_PIPE] = ACTIONS(419),
    [anon_sym_new] = ACTIONS(397),
    [anon_sym_with] = ACTIONS(169),
    [anon_sym_return_BANG] = ACTIONS(421),
    [anon_sym_yield] = ACTIONS(397),
    [anon_sym_yield_BANG] = ACTIONS(421),
    [anon_sym_lazy] = ACTIONS(397),
    [anon_sym_assert] = ACTIONS(397),
    [anon_sym_upcast] = ACTIONS(397),
    [anon_sym_downcast] = ACTIONS(397),
    [anon_sym_COLON_GT] = ACTIONS(423),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(423),
    [anon_sym_for] = ACTIONS(425),
    [anon_sym_while] = ACTIONS(427),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(429),
    [anon_sym_try] = ACTIONS(431),
    [anon_sym_match] = ACTIONS(433),
    [anon_sym_match_BANG] = ACTIONS(435),
    [anon_sym_function] = ACTIONS(437),
    [anon_sym_LT_DASH] = ACTIONS(439),
    [anon_sym_DOT_LBRACK] = ACTIONS(441),
    [anon_sym_LT] = ACTIONS(443),
    [anon_sym_use] = ACTIONS(445),
    [anon_sym_use_BANG] = ACTIONS(447),
    [anon_sym_do_BANG] = ACTIONS(449),
    [anon_sym_begin] = ACTIONS(451),
    [anon_sym_LPAREN2] = ACTIONS(453),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(455),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(457),
    [anon_sym_DQUOTE] = ACTIONS(459),
    [anon_sym_AT_DQUOTE] = ACTIONS(461),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(463),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(465),
    [sym_bool] = ACTIONS(467),
    [sym_unit] = ACTIONS(469),
    [anon_sym_LPAREN_PIPE] = ACTIONS(471),
    [sym_op_identifier] = ACTIONS(473),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(475),
    [sym_xint] = ACTIONS(477),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(479),
    [sym__newline] = ACTIONS(167),
  },
  [118] = {
    [sym_function_or_value_defn] = STATE(703),
    [sym__expression] = STATE(108),
    [sym_literal_expression] = STATE(1797),
    [sym_long_identifier_or_op] = STATE(1797),
    [sym_tuple_expression] = STATE(1797),
    [sym_brace_expression] = STATE(1797),
    [sym_anon_record_expression] = STATE(1797),
    [sym_prefixed_expression] = STATE(1797),
    [sym_typecast_expression] = STATE(1797),
    [sym_for_expression] = STATE(1797),
    [sym_while_expression] = STATE(1797),
    [sym__if_branch] = STATE(6611),
    [sym_if_expression] = STATE(1797),
    [sym_fun_expression] = STATE(1797),
    [sym_try_expression] = STATE(1797),
    [sym_match_expression] = STATE(1797),
    [sym_function_expression] = STATE(1797),
    [sym_mutate_expression] = STATE(1797),
    [sym_index_expression] = STATE(1797),
    [sym_typed_expression] = STATE(1797),
    [sym_declaration_expression] = STATE(1797),
    [sym_do_expression] = STATE(1797),
    [sym_list_expression] = STATE(1797),
    [sym_array_expression] = STATE(1797),
    [sym_begin_end_expression] = STATE(1797),
    [sym_paren_expression] = STATE(1797),
    [sym__high_prec_app] = STATE(1800),
    [sym__low_prec_app] = STATE(1800),
    [sym_application_expression] = STATE(1797),
    [sym_dot_expression] = STATE(1797),
    [sym_infix_expression] = STATE(1797),
    [sym_ce_expression] = STATE(1797),
    [sym_sequential_expression] = STATE(1797),
    [sym_char] = STATE(1694),
    [sym_format_string] = STATE(1693),
    [sym__string_literal] = STATE(1693),
    [sym_string] = STATE(1694),
    [sym_verbatim_string] = STATE(1694),
    [sym_bytearray] = STATE(1694),
    [sym_verbatim_bytearray] = STATE(1694),
    [sym_format_triple_quoted_string] = STATE(1692),
    [sym_triple_quoted_string] = STATE(1694),
    [sym_const] = STATE(1797),
    [sym_long_identifier] = STATE(1813),
    [sym_active_pattern] = STATE(1753),
    [sym__identifier_or_op] = STATE(1812),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(756),
    [sym_infix_op] = STATE(515),
    [sym_sbyte] = STATE(1694),
    [sym_byte] = STATE(1694),
    [sym_int16] = STATE(1694),
    [sym_uint16] = STATE(1694),
    [sym_int32] = STATE(1694),
    [sym_uint32] = STATE(1694),
    [sym_nativeint] = STATE(1694),
    [sym_unativeint] = STATE(1694),
    [sym_int64] = STATE(1694),
    [sym_uint64] = STATE(1694),
    [sym_ieee32] = STATE(1694),
    [sym_ieee64] = STATE(1694),
    [sym_bignum] = STATE(1694),
    [sym_decimal] = STATE(1694),
    [sym_float] = STATE(1425),
    [sym_block_comment] = STATE(118),
    [sym_compiler_directive_decl] = STATE(118),
    [sym_fsi_directive_decl] = STATE(118),
    [sym_preproc_line] = STATE(118),
    [sym_preproc_if_in_expression] = STATE(1797),
    [aux_sym_sequential_expression_repeat1] = STATE(1585),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(181),
    [anon_sym_EQ] = ACTIONS(183),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_return] = ACTIONS(181),
    [anon_sym_do] = ACTIONS(181),
    [anon_sym_let] = ACTIONS(181),
    [anon_sym_let_BANG] = ACTIONS(183),
    [anon_sym_as] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(181),
    [anon_sym_COMMA] = ACTIONS(183),
    [anon_sym_null] = ACTIONS(181),
    [anon_sym_QMARK] = ACTIONS(181),
    [anon_sym_COLON_QMARK] = ACTIONS(181),
    [anon_sym_COLON_COLON] = ACTIONS(183),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_LBRACK_PIPE] = ACTIONS(183),
    [anon_sym_LBRACE] = ACTIONS(181),
    [anon_sym_LT_AT] = ACTIONS(181),
    [anon_sym_LT_AT_AT] = ACTIONS(181),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_LBRACE_PIPE] = ACTIONS(183),
    [anon_sym_new] = ACTIONS(181),
    [anon_sym_with] = ACTIONS(181),
    [anon_sym_return_BANG] = ACTIONS(183),
    [anon_sym_yield] = ACTIONS(181),
    [anon_sym_yield_BANG] = ACTIONS(183),
    [anon_sym_lazy] = ACTIONS(181),
    [anon_sym_assert] = ACTIONS(181),
    [anon_sym_upcast] = ACTIONS(181),
    [anon_sym_downcast] = ACTIONS(181),
    [anon_sym_COLON_GT] = ACTIONS(183),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(183),
    [anon_sym_for] = ACTIONS(181),
    [anon_sym_while] = ACTIONS(181),
    [anon_sym_if] = ACTIONS(181),
    [anon_sym_fun] = ACTIONS(181),
    [anon_sym_try] = ACTIONS(181),
    [anon_sym_match] = ACTIONS(181),
    [anon_sym_match_BANG] = ACTIONS(183),
    [anon_sym_function] = ACTIONS(181),
    [anon_sym_LT_DASH] = ACTIONS(181),
    [anon_sym_DOT_LBRACK] = ACTIONS(441),
    [anon_sym_LT] = ACTIONS(443),
    [anon_sym_use] = ACTIONS(181),
    [anon_sym_use_BANG] = ACTIONS(183),
    [anon_sym_do_BANG] = ACTIONS(183),
    [anon_sym_begin] = ACTIONS(181),
    [anon_sym_LPAREN2] = ACTIONS(453),
    [anon_sym_or] = ACTIONS(181),
    [aux_sym_char_token1] = ACTIONS(183),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(181),
    [anon_sym_DQUOTE] = ACTIONS(181),
    [anon_sym_AT_DQUOTE] = ACTIONS(183),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(183),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(183),
    [sym_bool] = ACTIONS(181),
    [sym_unit] = ACTIONS(469),
    [anon_sym_LPAREN_PIPE] = ACTIONS(181),
    [sym_op_identifier] = ACTIONS(181),
    [anon_sym_PLUS] = ACTIONS(181),
    [anon_sym_DASH] = ACTIONS(181),
    [anon_sym_PLUS_DOT] = ACTIONS(181),
    [anon_sym_DASH_DOT] = ACTIONS(181),
    [anon_sym_PERCENT] = ACTIONS(181),
    [anon_sym_AMP_AMP] = ACTIONS(181),
    [anon_sym_TILDE] = ACTIONS(183),
    [aux_sym_prefix_op_token1] = ACTIONS(181),
    [aux_sym_infix_op_token1] = ACTIONS(183),
    [aux_sym_infix_op_token2] = ACTIONS(181),
    [anon_sym_PIPE_PIPE] = ACTIONS(181),
    [anon_sym_BANG_EQ] = ACTIONS(181),
    [anon_sym_COLON_EQ] = ACTIONS(183),
    [anon_sym_DOLLAR] = ACTIONS(181),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(181),
    [sym_int] = ACTIONS(181),
    [sym_xint] = ACTIONS(183),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(183),
    [sym__newline] = ACTIONS(183),
  },
  [119] = {
    [sym_function_or_value_defn] = STATE(703),
    [sym__expression] = STATE(108),
    [sym_literal_expression] = STATE(1797),
    [sym_long_identifier_or_op] = STATE(1797),
    [sym_tuple_expression] = STATE(1797),
    [sym_brace_expression] = STATE(1797),
    [sym_anon_record_expression] = STATE(1797),
    [sym_prefixed_expression] = STATE(1797),
    [sym_typecast_expression] = STATE(1797),
    [sym_for_expression] = STATE(1797),
    [sym_while_expression] = STATE(1797),
    [sym__if_branch] = STATE(6611),
    [sym_if_expression] = STATE(1797),
    [sym_fun_expression] = STATE(1797),
    [sym_try_expression] = STATE(1797),
    [sym_match_expression] = STATE(1797),
    [sym_function_expression] = STATE(1797),
    [sym_mutate_expression] = STATE(1797),
    [sym_index_expression] = STATE(1797),
    [sym_typed_expression] = STATE(1797),
    [sym_declaration_expression] = STATE(1797),
    [sym_do_expression] = STATE(1797),
    [sym_list_expression] = STATE(1797),
    [sym_array_expression] = STATE(1797),
    [sym_begin_end_expression] = STATE(1797),
    [sym_paren_expression] = STATE(1797),
    [sym__high_prec_app] = STATE(1800),
    [sym__low_prec_app] = STATE(1800),
    [sym_application_expression] = STATE(1797),
    [sym_dot_expression] = STATE(1797),
    [sym_infix_expression] = STATE(1797),
    [sym_ce_expression] = STATE(1797),
    [sym_sequential_expression] = STATE(1797),
    [sym_char] = STATE(1694),
    [sym_format_string] = STATE(1693),
    [sym__string_literal] = STATE(1693),
    [sym_string] = STATE(1694),
    [sym_verbatim_string] = STATE(1694),
    [sym_bytearray] = STATE(1694),
    [sym_verbatim_bytearray] = STATE(1694),
    [sym_format_triple_quoted_string] = STATE(1692),
    [sym_triple_quoted_string] = STATE(1694),
    [sym_const] = STATE(1797),
    [sym_long_identifier] = STATE(1813),
    [sym_active_pattern] = STATE(1753),
    [sym__identifier_or_op] = STATE(1812),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(756),
    [sym_infix_op] = STATE(515),
    [sym_sbyte] = STATE(1694),
    [sym_byte] = STATE(1694),
    [sym_int16] = STATE(1694),
    [sym_uint16] = STATE(1694),
    [sym_int32] = STATE(1694),
    [sym_uint32] = STATE(1694),
    [sym_nativeint] = STATE(1694),
    [sym_unativeint] = STATE(1694),
    [sym_int64] = STATE(1694),
    [sym_uint64] = STATE(1694),
    [sym_ieee32] = STATE(1694),
    [sym_ieee64] = STATE(1694),
    [sym_bignum] = STATE(1694),
    [sym_decimal] = STATE(1694),
    [sym_float] = STATE(1425),
    [sym_block_comment] = STATE(119),
    [sym_compiler_directive_decl] = STATE(119),
    [sym_fsi_directive_decl] = STATE(119),
    [sym_preproc_line] = STATE(119),
    [sym_preproc_if_in_expression] = STATE(1797),
    [aux_sym_sequential_expression_repeat1] = STATE(1585),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(393),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(395),
    [anon_sym_return] = ACTIONS(397),
    [anon_sym_do] = ACTIONS(399),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_as] = ACTIONS(59),
    [anon_sym_LPAREN] = ACTIONS(401),
    [anon_sym_COMMA] = ACTIONS(403),
    [anon_sym_null] = ACTIONS(405),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(395),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(407),
    [anon_sym_LBRACK_PIPE] = ACTIONS(409),
    [anon_sym_LBRACE] = ACTIONS(59),
    [anon_sym_LT_AT] = ACTIONS(413),
    [anon_sym_LT_AT_AT] = ACTIONS(415),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_LBRACE_PIPE] = ACTIONS(419),
    [anon_sym_new] = ACTIONS(397),
    [anon_sym_with] = ACTIONS(59),
    [anon_sym_return_BANG] = ACTIONS(421),
    [anon_sym_yield] = ACTIONS(397),
    [anon_sym_yield_BANG] = ACTIONS(421),
    [anon_sym_lazy] = ACTIONS(397),
    [anon_sym_assert] = ACTIONS(397),
    [anon_sym_upcast] = ACTIONS(397),
    [anon_sym_downcast] = ACTIONS(397),
    [anon_sym_COLON_GT] = ACTIONS(423),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(423),
    [anon_sym_for] = ACTIONS(425),
    [anon_sym_while] = ACTIONS(427),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(429),
    [anon_sym_try] = ACTIONS(431),
    [anon_sym_match] = ACTIONS(433),
    [anon_sym_match_BANG] = ACTIONS(435),
    [anon_sym_function] = ACTIONS(437),
    [anon_sym_LT_DASH] = ACTIONS(439),
    [anon_sym_DOT_LBRACK] = ACTIONS(441),
    [anon_sym_LT] = ACTIONS(443),
    [anon_sym_use] = ACTIONS(445),
    [anon_sym_use_BANG] = ACTIONS(447),
    [anon_sym_do_BANG] = ACTIONS(449),
    [anon_sym_begin] = ACTIONS(451),
    [anon_sym_LPAREN2] = ACTIONS(453),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(455),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(457),
    [anon_sym_DQUOTE] = ACTIONS(459),
    [anon_sym_AT_DQUOTE] = ACTIONS(461),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(463),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(465),
    [sym_bool] = ACTIONS(467),
    [sym_unit] = ACTIONS(469),
    [anon_sym_LPAREN_PIPE] = ACTIONS(471),
    [sym_op_identifier] = ACTIONS(473),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(475),
    [sym_xint] = ACTIONS(477),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(479),
    [sym__newline] = ACTIONS(33),
  },
  [120] = {
    [sym_function_or_value_defn] = STATE(703),
    [sym__expression] = STATE(108),
    [sym_literal_expression] = STATE(1797),
    [sym_long_identifier_or_op] = STATE(1797),
    [sym_tuple_expression] = STATE(1797),
    [sym_brace_expression] = STATE(1797),
    [sym_anon_record_expression] = STATE(1797),
    [sym_prefixed_expression] = STATE(1797),
    [sym_typecast_expression] = STATE(1797),
    [sym_for_expression] = STATE(1797),
    [sym_while_expression] = STATE(1797),
    [sym__if_branch] = STATE(6611),
    [sym_if_expression] = STATE(1797),
    [sym_fun_expression] = STATE(1797),
    [sym_try_expression] = STATE(1797),
    [sym_match_expression] = STATE(1797),
    [sym_function_expression] = STATE(1797),
    [sym_mutate_expression] = STATE(1797),
    [sym_index_expression] = STATE(1797),
    [sym_typed_expression] = STATE(1797),
    [sym_declaration_expression] = STATE(1797),
    [sym_do_expression] = STATE(1797),
    [sym_list_expression] = STATE(1797),
    [sym_array_expression] = STATE(1797),
    [sym_begin_end_expression] = STATE(1797),
    [sym_paren_expression] = STATE(1797),
    [sym__high_prec_app] = STATE(1800),
    [sym__low_prec_app] = STATE(1800),
    [sym_application_expression] = STATE(1797),
    [sym_dot_expression] = STATE(1797),
    [sym_infix_expression] = STATE(1797),
    [sym_ce_expression] = STATE(1797),
    [sym_sequential_expression] = STATE(1797),
    [sym_char] = STATE(1694),
    [sym_format_string] = STATE(1693),
    [sym__string_literal] = STATE(1693),
    [sym_string] = STATE(1694),
    [sym_verbatim_string] = STATE(1694),
    [sym_bytearray] = STATE(1694),
    [sym_verbatim_bytearray] = STATE(1694),
    [sym_format_triple_quoted_string] = STATE(1692),
    [sym_triple_quoted_string] = STATE(1694),
    [sym_const] = STATE(1797),
    [sym_long_identifier] = STATE(1813),
    [sym_active_pattern] = STATE(1753),
    [sym__identifier_or_op] = STATE(1812),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(756),
    [sym_infix_op] = STATE(515),
    [sym_sbyte] = STATE(1694),
    [sym_byte] = STATE(1694),
    [sym_int16] = STATE(1694),
    [sym_uint16] = STATE(1694),
    [sym_int32] = STATE(1694),
    [sym_uint32] = STATE(1694),
    [sym_nativeint] = STATE(1694),
    [sym_unativeint] = STATE(1694),
    [sym_int64] = STATE(1694),
    [sym_uint64] = STATE(1694),
    [sym_ieee32] = STATE(1694),
    [sym_ieee64] = STATE(1694),
    [sym_bignum] = STATE(1694),
    [sym_decimal] = STATE(1694),
    [sym_float] = STATE(1425),
    [sym_block_comment] = STATE(120),
    [sym_compiler_directive_decl] = STATE(120),
    [sym_fsi_directive_decl] = STATE(120),
    [sym_preproc_line] = STATE(120),
    [sym_preproc_if_in_expression] = STATE(1797),
    [aux_sym_sequential_expression_repeat1] = STATE(1585),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(393),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(395),
    [anon_sym_return] = ACTIONS(397),
    [anon_sym_do] = ACTIONS(399),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_as] = ACTIONS(173),
    [anon_sym_LPAREN] = ACTIONS(401),
    [anon_sym_COMMA] = ACTIONS(403),
    [anon_sym_null] = ACTIONS(405),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(395),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(407),
    [anon_sym_LBRACK_PIPE] = ACTIONS(409),
    [anon_sym_LBRACE] = ACTIONS(411),
    [anon_sym_LT_AT] = ACTIONS(413),
    [anon_sym_LT_AT_AT] = ACTIONS(415),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_LBRACE_PIPE] = ACTIONS(419),
    [anon_sym_new] = ACTIONS(397),
    [anon_sym_with] = ACTIONS(173),
    [anon_sym_return_BANG] = ACTIONS(421),
    [anon_sym_yield] = ACTIONS(397),
    [anon_sym_yield_BANG] = ACTIONS(421),
    [anon_sym_lazy] = ACTIONS(397),
    [anon_sym_assert] = ACTIONS(397),
    [anon_sym_upcast] = ACTIONS(397),
    [anon_sym_downcast] = ACTIONS(397),
    [anon_sym_COLON_GT] = ACTIONS(423),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(423),
    [anon_sym_for] = ACTIONS(425),
    [anon_sym_while] = ACTIONS(427),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(429),
    [anon_sym_try] = ACTIONS(431),
    [anon_sym_match] = ACTIONS(433),
    [anon_sym_match_BANG] = ACTIONS(435),
    [anon_sym_function] = ACTIONS(437),
    [anon_sym_LT_DASH] = ACTIONS(439),
    [anon_sym_DOT_LBRACK] = ACTIONS(441),
    [anon_sym_LT] = ACTIONS(443),
    [anon_sym_use] = ACTIONS(445),
    [anon_sym_use_BANG] = ACTIONS(447),
    [anon_sym_do_BANG] = ACTIONS(449),
    [anon_sym_begin] = ACTIONS(451),
    [anon_sym_LPAREN2] = ACTIONS(453),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(455),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(457),
    [anon_sym_DQUOTE] = ACTIONS(459),
    [anon_sym_AT_DQUOTE] = ACTIONS(461),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(463),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(465),
    [sym_bool] = ACTIONS(467),
    [sym_unit] = ACTIONS(469),
    [anon_sym_LPAREN_PIPE] = ACTIONS(471),
    [sym_op_identifier] = ACTIONS(473),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(475),
    [sym_xint] = ACTIONS(477),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(479),
    [sym__newline] = ACTIONS(863),
  },
  [121] = {
    [sym_function_or_value_defn] = STATE(596),
    [sym__expression] = STATE(109),
    [sym_literal_expression] = STATE(1809),
    [sym_long_identifier_or_op] = STATE(1809),
    [sym_tuple_expression] = STATE(1809),
    [sym_brace_expression] = STATE(1809),
    [sym_anon_record_expression] = STATE(1809),
    [sym_prefixed_expression] = STATE(1809),
    [sym_typecast_expression] = STATE(1809),
    [sym_for_expression] = STATE(1809),
    [sym_while_expression] = STATE(1809),
    [sym__if_branch] = STATE(6874),
    [sym_if_expression] = STATE(1809),
    [sym_fun_expression] = STATE(1809),
    [sym_try_expression] = STATE(1809),
    [sym_match_expression] = STATE(1809),
    [sym_function_expression] = STATE(1809),
    [sym_mutate_expression] = STATE(1809),
    [sym_index_expression] = STATE(1809),
    [sym_typed_expression] = STATE(1809),
    [sym_declaration_expression] = STATE(1809),
    [sym_do_expression] = STATE(1809),
    [sym_list_expression] = STATE(1809),
    [sym_array_expression] = STATE(1809),
    [sym_begin_end_expression] = STATE(1809),
    [sym_paren_expression] = STATE(1809),
    [sym__high_prec_app] = STATE(1806),
    [sym__low_prec_app] = STATE(1806),
    [sym_application_expression] = STATE(1809),
    [sym_dot_expression] = STATE(1809),
    [sym_infix_expression] = STATE(1809),
    [sym_ce_expression] = STATE(1809),
    [sym_sequential_expression] = STATE(1809),
    [sym_char] = STATE(2014),
    [sym_format_string] = STATE(2019),
    [sym__string_literal] = STATE(2019),
    [sym_string] = STATE(2014),
    [sym_verbatim_string] = STATE(2014),
    [sym_bytearray] = STATE(2014),
    [sym_verbatim_bytearray] = STATE(2014),
    [sym_format_triple_quoted_string] = STATE(2020),
    [sym_triple_quoted_string] = STATE(2014),
    [sym_const] = STATE(1809),
    [sym_long_identifier] = STATE(1810),
    [sym_active_pattern] = STATE(1860),
    [sym__identifier_or_op] = STATE(1750),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(655),
    [sym_infix_op] = STATE(608),
    [sym_sbyte] = STATE(2014),
    [sym_byte] = STATE(2014),
    [sym_int16] = STATE(2014),
    [sym_uint16] = STATE(2014),
    [sym_int32] = STATE(2014),
    [sym_uint32] = STATE(2014),
    [sym_nativeint] = STATE(2014),
    [sym_unativeint] = STATE(2014),
    [sym_int64] = STATE(2014),
    [sym_uint64] = STATE(2014),
    [sym_ieee32] = STATE(2014),
    [sym_ieee64] = STATE(2014),
    [sym_bignum] = STATE(2014),
    [sym_decimal] = STATE(2014),
    [sym_float] = STATE(1438),
    [sym_block_comment] = STATE(121),
    [sym_compiler_directive_decl] = STATE(121),
    [sym_fsi_directive_decl] = STATE(121),
    [sym_preproc_line] = STATE(121),
    [sym_preproc_if_in_expression] = STATE(1809),
    [aux_sym_sequential_expression_repeat1] = STATE(1620),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(181),
    [anon_sym_EQ] = ACTIONS(183),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_return] = ACTIONS(181),
    [anon_sym_do] = ACTIONS(181),
    [anon_sym_and] = ACTIONS(181),
    [anon_sym_let] = ACTIONS(181),
    [anon_sym_let_BANG] = ACTIONS(183),
    [anon_sym_LPAREN] = ACTIONS(181),
    [anon_sym_COMMA] = ACTIONS(183),
    [anon_sym_null] = ACTIONS(181),
    [anon_sym_QMARK] = ACTIONS(181),
    [anon_sym_COLON_QMARK] = ACTIONS(181),
    [anon_sym_COLON_COLON] = ACTIONS(183),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_LBRACK_PIPE] = ACTIONS(183),
    [anon_sym_LBRACE] = ACTIONS(181),
    [anon_sym_LT_AT] = ACTIONS(181),
    [anon_sym_LT_AT_AT] = ACTIONS(181),
    [anon_sym_DOT] = ACTIONS(747),
    [anon_sym_LBRACE_PIPE] = ACTIONS(183),
    [anon_sym_new] = ACTIONS(181),
    [anon_sym_return_BANG] = ACTIONS(183),
    [anon_sym_yield] = ACTIONS(181),
    [anon_sym_yield_BANG] = ACTIONS(183),
    [anon_sym_lazy] = ACTIONS(181),
    [anon_sym_assert] = ACTIONS(181),
    [anon_sym_upcast] = ACTIONS(181),
    [anon_sym_downcast] = ACTIONS(181),
    [anon_sym_COLON_GT] = ACTIONS(183),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(183),
    [anon_sym_for] = ACTIONS(181),
    [anon_sym_while] = ACTIONS(181),
    [anon_sym_if] = ACTIONS(181),
    [anon_sym_fun] = ACTIONS(181),
    [anon_sym_try] = ACTIONS(181),
    [anon_sym_match] = ACTIONS(181),
    [anon_sym_match_BANG] = ACTIONS(183),
    [anon_sym_function] = ACTIONS(181),
    [anon_sym_LT_DASH] = ACTIONS(181),
    [anon_sym_DOT_LBRACK] = ACTIONS(771),
    [anon_sym_LT] = ACTIONS(773),
    [anon_sym_use] = ACTIONS(181),
    [anon_sym_use_BANG] = ACTIONS(183),
    [anon_sym_do_BANG] = ACTIONS(183),
    [anon_sym_begin] = ACTIONS(181),
    [anon_sym_LPAREN2] = ACTIONS(783),
    [anon_sym_or] = ACTIONS(181),
    [aux_sym_char_token1] = ACTIONS(183),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(181),
    [anon_sym_DQUOTE] = ACTIONS(181),
    [anon_sym_AT_DQUOTE] = ACTIONS(183),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(183),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(183),
    [sym_bool] = ACTIONS(181),
    [sym_unit] = ACTIONS(799),
    [anon_sym_LPAREN_PIPE] = ACTIONS(181),
    [sym_op_identifier] = ACTIONS(181),
    [anon_sym_PLUS] = ACTIONS(181),
    [anon_sym_DASH] = ACTIONS(181),
    [anon_sym_PLUS_DOT] = ACTIONS(181),
    [anon_sym_DASH_DOT] = ACTIONS(181),
    [anon_sym_PERCENT] = ACTIONS(181),
    [anon_sym_AMP_AMP] = ACTIONS(181),
    [anon_sym_TILDE] = ACTIONS(183),
    [aux_sym_prefix_op_token1] = ACTIONS(181),
    [aux_sym_infix_op_token1] = ACTIONS(183),
    [aux_sym_infix_op_token2] = ACTIONS(181),
    [anon_sym_PIPE_PIPE] = ACTIONS(181),
    [anon_sym_BANG_EQ] = ACTIONS(181),
    [anon_sym_COLON_EQ] = ACTIONS(183),
    [anon_sym_DOLLAR] = ACTIONS(181),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(181),
    [sym_int] = ACTIONS(181),
    [sym_xint] = ACTIONS(183),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(183),
    [sym__newline] = ACTIONS(183),
    [sym__dedent] = ACTIONS(183),
  },
  [122] = {
    [sym_function_or_value_defn] = STATE(532),
    [sym__expression] = STATE(126),
    [sym_literal_expression] = STATE(2000),
    [sym_long_identifier_or_op] = STATE(2000),
    [sym_tuple_expression] = STATE(2000),
    [sym_brace_expression] = STATE(2000),
    [sym_anon_record_expression] = STATE(2000),
    [sym_prefixed_expression] = STATE(2000),
    [sym_typecast_expression] = STATE(2000),
    [sym_for_expression] = STATE(2000),
    [sym_while_expression] = STATE(2000),
    [sym__if_branch] = STATE(6707),
    [sym_if_expression] = STATE(2000),
    [sym_fun_expression] = STATE(2000),
    [sym_try_expression] = STATE(2000),
    [sym_match_expression] = STATE(2000),
    [sym_function_expression] = STATE(2000),
    [sym_mutate_expression] = STATE(2000),
    [sym_index_expression] = STATE(2000),
    [sym_typed_expression] = STATE(2000),
    [sym_declaration_expression] = STATE(2000),
    [sym_do_expression] = STATE(2000),
    [sym_list_expression] = STATE(2000),
    [sym_array_expression] = STATE(2000),
    [sym_begin_end_expression] = STATE(2000),
    [sym_paren_expression] = STATE(2000),
    [sym__high_prec_app] = STATE(2003),
    [sym__low_prec_app] = STATE(2003),
    [sym_application_expression] = STATE(2000),
    [sym_dot_expression] = STATE(2000),
    [sym_infix_expression] = STATE(2000),
    [sym_ce_expression] = STATE(2000),
    [sym_sequential_expression] = STATE(2000),
    [sym_char] = STATE(1801),
    [sym_format_string] = STATE(1804),
    [sym__string_literal] = STATE(1804),
    [sym_string] = STATE(1801),
    [sym_verbatim_string] = STATE(1801),
    [sym_bytearray] = STATE(1801),
    [sym_verbatim_bytearray] = STATE(1801),
    [sym_format_triple_quoted_string] = STATE(1807),
    [sym_triple_quoted_string] = STATE(1801),
    [sym_const] = STATE(2000),
    [sym_long_identifier] = STATE(1725),
    [sym_active_pattern] = STATE(1726),
    [sym__identifier_or_op] = STATE(1751),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(723),
    [sym_infix_op] = STATE(561),
    [sym_sbyte] = STATE(1801),
    [sym_byte] = STATE(1801),
    [sym_int16] = STATE(1801),
    [sym_uint16] = STATE(1801),
    [sym_int32] = STATE(1801),
    [sym_uint32] = STATE(1801),
    [sym_nativeint] = STATE(1801),
    [sym_unativeint] = STATE(1801),
    [sym_int64] = STATE(1801),
    [sym_uint64] = STATE(1801),
    [sym_ieee32] = STATE(1801),
    [sym_ieee64] = STATE(1801),
    [sym_bignum] = STATE(1801),
    [sym_decimal] = STATE(1801),
    [sym_float] = STATE(1427),
    [sym_block_comment] = STATE(122),
    [sym_compiler_directive_decl] = STATE(122),
    [sym_fsi_directive_decl] = STATE(122),
    [sym_preproc_line] = STATE(122),
    [sym_preproc_if_in_expression] = STATE(2000),
    [aux_sym_sequential_expression_repeat1] = STATE(1635),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(629),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(631),
    [anon_sym_return] = ACTIONS(633),
    [anon_sym_do] = ACTIONS(635),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(637),
    [anon_sym_COMMA] = ACTIONS(639),
    [anon_sym_null] = ACTIONS(641),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(631),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(643),
    [anon_sym_LBRACK_PIPE] = ACTIONS(645),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_LT_AT] = ACTIONS(647),
    [anon_sym_LT_AT_AT] = ACTIONS(649),
    [anon_sym_DOT] = ACTIONS(651),
    [anon_sym_LBRACE_PIPE] = ACTIONS(653),
    [anon_sym_new] = ACTIONS(633),
    [anon_sym_return_BANG] = ACTIONS(655),
    [anon_sym_yield] = ACTIONS(633),
    [anon_sym_yield_BANG] = ACTIONS(655),
    [anon_sym_lazy] = ACTIONS(633),
    [anon_sym_assert] = ACTIONS(633),
    [anon_sym_upcast] = ACTIONS(633),
    [anon_sym_downcast] = ACTIONS(633),
    [anon_sym_COLON_GT] = ACTIONS(657),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(657),
    [anon_sym_for] = ACTIONS(659),
    [anon_sym_while] = ACTIONS(661),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(663),
    [anon_sym_try] = ACTIONS(665),
    [anon_sym_match] = ACTIONS(667),
    [anon_sym_match_BANG] = ACTIONS(669),
    [anon_sym_function] = ACTIONS(671),
    [anon_sym_LT_DASH] = ACTIONS(673),
    [anon_sym_DOT_LBRACK] = ACTIONS(675),
    [anon_sym_LT] = ACTIONS(677),
    [anon_sym_use] = ACTIONS(679),
    [anon_sym_use_BANG] = ACTIONS(681),
    [anon_sym_do_BANG] = ACTIONS(683),
    [anon_sym_begin] = ACTIONS(685),
    [anon_sym_LPAREN2] = ACTIONS(687),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(689),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(691),
    [anon_sym_DQUOTE] = ACTIONS(693),
    [anon_sym_AT_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(697),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(699),
    [sym_bool] = ACTIONS(701),
    [sym_unit] = ACTIONS(703),
    [anon_sym_LPAREN_PIPE] = ACTIONS(705),
    [sym_op_identifier] = ACTIONS(707),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(709),
    [sym_xint] = ACTIONS(711),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(713),
    [anon_sym_POUNDendif] = ACTIONS(145),
    [anon_sym_POUNDelse] = ACTIONS(145),
    [sym__newline] = ACTIONS(145),
  },
  [123] = {
    [sym_function_or_value_defn] = STATE(596),
    [sym__expression] = STATE(109),
    [sym_literal_expression] = STATE(1809),
    [sym_long_identifier_or_op] = STATE(1809),
    [sym_tuple_expression] = STATE(1809),
    [sym_brace_expression] = STATE(1809),
    [sym_anon_record_expression] = STATE(1809),
    [sym_prefixed_expression] = STATE(1809),
    [sym_typecast_expression] = STATE(1809),
    [sym_for_expression] = STATE(1809),
    [sym_while_expression] = STATE(1809),
    [sym__if_branch] = STATE(6874),
    [sym_if_expression] = STATE(1809),
    [sym_fun_expression] = STATE(1809),
    [sym_try_expression] = STATE(1809),
    [sym_match_expression] = STATE(1809),
    [sym_function_expression] = STATE(1809),
    [sym_mutate_expression] = STATE(1809),
    [sym_index_expression] = STATE(1809),
    [sym_typed_expression] = STATE(1809),
    [sym_declaration_expression] = STATE(1809),
    [sym_do_expression] = STATE(1809),
    [sym_list_expression] = STATE(1809),
    [sym_array_expression] = STATE(1809),
    [sym_begin_end_expression] = STATE(1809),
    [sym_paren_expression] = STATE(1809),
    [sym__high_prec_app] = STATE(1806),
    [sym__low_prec_app] = STATE(1806),
    [sym_application_expression] = STATE(1809),
    [sym_dot_expression] = STATE(1809),
    [sym_infix_expression] = STATE(1809),
    [sym_ce_expression] = STATE(1809),
    [sym_sequential_expression] = STATE(1809),
    [sym_char] = STATE(2014),
    [sym_format_string] = STATE(2019),
    [sym__string_literal] = STATE(2019),
    [sym_string] = STATE(2014),
    [sym_verbatim_string] = STATE(2014),
    [sym_bytearray] = STATE(2014),
    [sym_verbatim_bytearray] = STATE(2014),
    [sym_format_triple_quoted_string] = STATE(2020),
    [sym_triple_quoted_string] = STATE(2014),
    [sym_const] = STATE(1809),
    [sym_long_identifier] = STATE(1810),
    [sym_active_pattern] = STATE(1860),
    [sym__identifier_or_op] = STATE(1750),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(655),
    [sym_infix_op] = STATE(608),
    [sym_sbyte] = STATE(2014),
    [sym_byte] = STATE(2014),
    [sym_int16] = STATE(2014),
    [sym_uint16] = STATE(2014),
    [sym_int32] = STATE(2014),
    [sym_uint32] = STATE(2014),
    [sym_nativeint] = STATE(2014),
    [sym_unativeint] = STATE(2014),
    [sym_int64] = STATE(2014),
    [sym_uint64] = STATE(2014),
    [sym_ieee32] = STATE(2014),
    [sym_ieee64] = STATE(2014),
    [sym_bignum] = STATE(2014),
    [sym_decimal] = STATE(2014),
    [sym_float] = STATE(1438),
    [sym_block_comment] = STATE(123),
    [sym_compiler_directive_decl] = STATE(123),
    [sym_fsi_directive_decl] = STATE(123),
    [sym_preproc_line] = STATE(123),
    [sym_preproc_if_in_expression] = STATE(1809),
    [aux_sym_sequential_expression_repeat1] = STATE(1620),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(723),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(725),
    [anon_sym_return] = ACTIONS(727),
    [anon_sym_do] = ACTIONS(729),
    [anon_sym_and] = ACTIONS(59),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(731),
    [anon_sym_COMMA] = ACTIONS(733),
    [anon_sym_null] = ACTIONS(735),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(725),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(737),
    [anon_sym_LBRACK_PIPE] = ACTIONS(739),
    [anon_sym_LBRACE] = ACTIONS(59),
    [anon_sym_LT_AT] = ACTIONS(743),
    [anon_sym_LT_AT_AT] = ACTIONS(745),
    [anon_sym_DOT] = ACTIONS(747),
    [anon_sym_LBRACE_PIPE] = ACTIONS(749),
    [anon_sym_new] = ACTIONS(727),
    [anon_sym_return_BANG] = ACTIONS(751),
    [anon_sym_yield] = ACTIONS(727),
    [anon_sym_yield_BANG] = ACTIONS(751),
    [anon_sym_lazy] = ACTIONS(727),
    [anon_sym_assert] = ACTIONS(727),
    [anon_sym_upcast] = ACTIONS(727),
    [anon_sym_downcast] = ACTIONS(727),
    [anon_sym_COLON_GT] = ACTIONS(753),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(753),
    [anon_sym_for] = ACTIONS(755),
    [anon_sym_while] = ACTIONS(757),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(759),
    [anon_sym_try] = ACTIONS(761),
    [anon_sym_match] = ACTIONS(763),
    [anon_sym_match_BANG] = ACTIONS(765),
    [anon_sym_function] = ACTIONS(767),
    [anon_sym_LT_DASH] = ACTIONS(769),
    [anon_sym_DOT_LBRACK] = ACTIONS(771),
    [anon_sym_LT] = ACTIONS(773),
    [anon_sym_use] = ACTIONS(775),
    [anon_sym_use_BANG] = ACTIONS(777),
    [anon_sym_do_BANG] = ACTIONS(779),
    [anon_sym_begin] = ACTIONS(781),
    [anon_sym_LPAREN2] = ACTIONS(783),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(785),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(787),
    [anon_sym_DQUOTE] = ACTIONS(789),
    [anon_sym_AT_DQUOTE] = ACTIONS(791),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(793),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(795),
    [sym_bool] = ACTIONS(797),
    [sym_unit] = ACTIONS(799),
    [anon_sym_LPAREN_PIPE] = ACTIONS(801),
    [sym_op_identifier] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(805),
    [sym_xint] = ACTIONS(807),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(809),
    [sym__newline] = ACTIONS(33),
    [sym__dedent] = ACTIONS(33),
  },
  [124] = {
    [sym_function_or_value_defn] = STATE(532),
    [sym__expression] = STATE(126),
    [sym_literal_expression] = STATE(2000),
    [sym_long_identifier_or_op] = STATE(2000),
    [sym_tuple_expression] = STATE(2000),
    [sym_brace_expression] = STATE(2000),
    [sym_anon_record_expression] = STATE(2000),
    [sym_prefixed_expression] = STATE(2000),
    [sym_typecast_expression] = STATE(2000),
    [sym_for_expression] = STATE(2000),
    [sym_while_expression] = STATE(2000),
    [sym__if_branch] = STATE(6707),
    [sym_if_expression] = STATE(2000),
    [sym_fun_expression] = STATE(2000),
    [sym_try_expression] = STATE(2000),
    [sym_match_expression] = STATE(2000),
    [sym_function_expression] = STATE(2000),
    [sym_mutate_expression] = STATE(2000),
    [sym_index_expression] = STATE(2000),
    [sym_typed_expression] = STATE(2000),
    [sym_declaration_expression] = STATE(2000),
    [sym_do_expression] = STATE(2000),
    [sym_list_expression] = STATE(2000),
    [sym_array_expression] = STATE(2000),
    [sym_begin_end_expression] = STATE(2000),
    [sym_paren_expression] = STATE(2000),
    [sym__high_prec_app] = STATE(2003),
    [sym__low_prec_app] = STATE(2003),
    [sym_application_expression] = STATE(2000),
    [sym_dot_expression] = STATE(2000),
    [sym_infix_expression] = STATE(2000),
    [sym_ce_expression] = STATE(2000),
    [sym_sequential_expression] = STATE(2000),
    [sym_char] = STATE(1801),
    [sym_format_string] = STATE(1804),
    [sym__string_literal] = STATE(1804),
    [sym_string] = STATE(1801),
    [sym_verbatim_string] = STATE(1801),
    [sym_bytearray] = STATE(1801),
    [sym_verbatim_bytearray] = STATE(1801),
    [sym_format_triple_quoted_string] = STATE(1807),
    [sym_triple_quoted_string] = STATE(1801),
    [sym_const] = STATE(2000),
    [sym_long_identifier] = STATE(1725),
    [sym_active_pattern] = STATE(1726),
    [sym__identifier_or_op] = STATE(1751),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(723),
    [sym_infix_op] = STATE(561),
    [sym_sbyte] = STATE(1801),
    [sym_byte] = STATE(1801),
    [sym_int16] = STATE(1801),
    [sym_uint16] = STATE(1801),
    [sym_int32] = STATE(1801),
    [sym_uint32] = STATE(1801),
    [sym_nativeint] = STATE(1801),
    [sym_unativeint] = STATE(1801),
    [sym_int64] = STATE(1801),
    [sym_uint64] = STATE(1801),
    [sym_ieee32] = STATE(1801),
    [sym_ieee64] = STATE(1801),
    [sym_bignum] = STATE(1801),
    [sym_decimal] = STATE(1801),
    [sym_float] = STATE(1427),
    [sym_block_comment] = STATE(124),
    [sym_compiler_directive_decl] = STATE(124),
    [sym_fsi_directive_decl] = STATE(124),
    [sym_preproc_line] = STATE(124),
    [sym_preproc_if_in_expression] = STATE(2000),
    [aux_sym_sequential_expression_repeat1] = STATE(1635),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(629),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(631),
    [anon_sym_return] = ACTIONS(633),
    [anon_sym_do] = ACTIONS(635),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(637),
    [anon_sym_COMMA] = ACTIONS(639),
    [anon_sym_null] = ACTIONS(641),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(631),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(643),
    [anon_sym_LBRACK_PIPE] = ACTIONS(645),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_LT_AT] = ACTIONS(647),
    [anon_sym_LT_AT_AT] = ACTIONS(649),
    [anon_sym_DOT] = ACTIONS(651),
    [anon_sym_LBRACE_PIPE] = ACTIONS(653),
    [anon_sym_new] = ACTIONS(633),
    [anon_sym_return_BANG] = ACTIONS(655),
    [anon_sym_yield] = ACTIONS(633),
    [anon_sym_yield_BANG] = ACTIONS(655),
    [anon_sym_lazy] = ACTIONS(633),
    [anon_sym_assert] = ACTIONS(633),
    [anon_sym_upcast] = ACTIONS(633),
    [anon_sym_downcast] = ACTIONS(633),
    [anon_sym_COLON_GT] = ACTIONS(657),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(657),
    [anon_sym_for] = ACTIONS(659),
    [anon_sym_while] = ACTIONS(661),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(663),
    [anon_sym_try] = ACTIONS(665),
    [anon_sym_match] = ACTIONS(667),
    [anon_sym_match_BANG] = ACTIONS(669),
    [anon_sym_function] = ACTIONS(671),
    [anon_sym_LT_DASH] = ACTIONS(673),
    [anon_sym_DOT_LBRACK] = ACTIONS(675),
    [anon_sym_LT] = ACTIONS(677),
    [anon_sym_use] = ACTIONS(679),
    [anon_sym_use_BANG] = ACTIONS(681),
    [anon_sym_do_BANG] = ACTIONS(683),
    [anon_sym_begin] = ACTIONS(685),
    [anon_sym_LPAREN2] = ACTIONS(687),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(689),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(691),
    [anon_sym_DQUOTE] = ACTIONS(693),
    [anon_sym_AT_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(697),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(699),
    [sym_bool] = ACTIONS(701),
    [sym_unit] = ACTIONS(703),
    [anon_sym_LPAREN_PIPE] = ACTIONS(705),
    [sym_op_identifier] = ACTIONS(707),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(709),
    [sym_xint] = ACTIONS(711),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(713),
    [anon_sym_POUNDendif] = ACTIONS(149),
    [anon_sym_POUNDelse] = ACTIONS(149),
    [sym__newline] = ACTIONS(823),
  },
  [125] = {
    [sym_function_or_value_defn] = STATE(596),
    [sym__expression] = STATE(109),
    [sym_literal_expression] = STATE(1809),
    [sym_long_identifier_or_op] = STATE(1809),
    [sym_tuple_expression] = STATE(1809),
    [sym_brace_expression] = STATE(1809),
    [sym_anon_record_expression] = STATE(1809),
    [sym_prefixed_expression] = STATE(1809),
    [sym_typecast_expression] = STATE(1809),
    [sym_for_expression] = STATE(1809),
    [sym_while_expression] = STATE(1809),
    [sym__if_branch] = STATE(6874),
    [sym_if_expression] = STATE(1809),
    [sym_fun_expression] = STATE(1809),
    [sym_try_expression] = STATE(1809),
    [sym_match_expression] = STATE(1809),
    [sym_function_expression] = STATE(1809),
    [sym_mutate_expression] = STATE(1809),
    [sym_index_expression] = STATE(1809),
    [sym_typed_expression] = STATE(1809),
    [sym_declaration_expression] = STATE(1809),
    [sym_do_expression] = STATE(1809),
    [sym_list_expression] = STATE(1809),
    [sym_array_expression] = STATE(1809),
    [sym_begin_end_expression] = STATE(1809),
    [sym_paren_expression] = STATE(1809),
    [sym__high_prec_app] = STATE(1806),
    [sym__low_prec_app] = STATE(1806),
    [sym_application_expression] = STATE(1809),
    [sym_dot_expression] = STATE(1809),
    [sym_infix_expression] = STATE(1809),
    [sym_ce_expression] = STATE(1809),
    [sym_sequential_expression] = STATE(1809),
    [sym_char] = STATE(2014),
    [sym_format_string] = STATE(2019),
    [sym__string_literal] = STATE(2019),
    [sym_string] = STATE(2014),
    [sym_verbatim_string] = STATE(2014),
    [sym_bytearray] = STATE(2014),
    [sym_verbatim_bytearray] = STATE(2014),
    [sym_format_triple_quoted_string] = STATE(2020),
    [sym_triple_quoted_string] = STATE(2014),
    [sym_const] = STATE(1809),
    [sym_long_identifier] = STATE(1810),
    [sym_active_pattern] = STATE(1860),
    [sym__identifier_or_op] = STATE(1750),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(655),
    [sym_infix_op] = STATE(608),
    [sym_sbyte] = STATE(2014),
    [sym_byte] = STATE(2014),
    [sym_int16] = STATE(2014),
    [sym_uint16] = STATE(2014),
    [sym_int32] = STATE(2014),
    [sym_uint32] = STATE(2014),
    [sym_nativeint] = STATE(2014),
    [sym_unativeint] = STATE(2014),
    [sym_int64] = STATE(2014),
    [sym_uint64] = STATE(2014),
    [sym_ieee32] = STATE(2014),
    [sym_ieee64] = STATE(2014),
    [sym_bignum] = STATE(2014),
    [sym_decimal] = STATE(2014),
    [sym_float] = STATE(1438),
    [sym_block_comment] = STATE(125),
    [sym_compiler_directive_decl] = STATE(125),
    [sym_fsi_directive_decl] = STATE(125),
    [sym_preproc_line] = STATE(125),
    [sym_preproc_if_in_expression] = STATE(1809),
    [aux_sym_sequential_expression_repeat1] = STATE(1620),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(723),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(725),
    [anon_sym_return] = ACTIONS(727),
    [anon_sym_do] = ACTIONS(729),
    [anon_sym_and] = ACTIONS(173),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(731),
    [anon_sym_COMMA] = ACTIONS(733),
    [anon_sym_null] = ACTIONS(735),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(725),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(737),
    [anon_sym_LBRACK_PIPE] = ACTIONS(739),
    [anon_sym_LBRACE] = ACTIONS(741),
    [anon_sym_LT_AT] = ACTIONS(743),
    [anon_sym_LT_AT_AT] = ACTIONS(745),
    [anon_sym_DOT] = ACTIONS(747),
    [anon_sym_LBRACE_PIPE] = ACTIONS(749),
    [anon_sym_new] = ACTIONS(727),
    [anon_sym_return_BANG] = ACTIONS(751),
    [anon_sym_yield] = ACTIONS(727),
    [anon_sym_yield_BANG] = ACTIONS(751),
    [anon_sym_lazy] = ACTIONS(727),
    [anon_sym_assert] = ACTIONS(727),
    [anon_sym_upcast] = ACTIONS(727),
    [anon_sym_downcast] = ACTIONS(727),
    [anon_sym_COLON_GT] = ACTIONS(753),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(753),
    [anon_sym_for] = ACTIONS(755),
    [anon_sym_while] = ACTIONS(757),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(759),
    [anon_sym_try] = ACTIONS(761),
    [anon_sym_match] = ACTIONS(763),
    [anon_sym_match_BANG] = ACTIONS(765),
    [anon_sym_function] = ACTIONS(767),
    [anon_sym_LT_DASH] = ACTIONS(769),
    [anon_sym_DOT_LBRACK] = ACTIONS(771),
    [anon_sym_LT] = ACTIONS(773),
    [anon_sym_use] = ACTIONS(775),
    [anon_sym_use_BANG] = ACTIONS(777),
    [anon_sym_do_BANG] = ACTIONS(779),
    [anon_sym_begin] = ACTIONS(781),
    [anon_sym_LPAREN2] = ACTIONS(783),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(785),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(787),
    [anon_sym_DQUOTE] = ACTIONS(789),
    [anon_sym_AT_DQUOTE] = ACTIONS(791),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(793),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(795),
    [sym_bool] = ACTIONS(797),
    [sym_unit] = ACTIONS(799),
    [anon_sym_LPAREN_PIPE] = ACTIONS(801),
    [sym_op_identifier] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(805),
    [sym_xint] = ACTIONS(807),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(809),
    [sym__newline] = ACTIONS(851),
    [sym__dedent] = ACTIONS(171),
  },
  [126] = {
    [sym_function_or_value_defn] = STATE(532),
    [sym__expression] = STATE(126),
    [sym_literal_expression] = STATE(2000),
    [sym_long_identifier_or_op] = STATE(2000),
    [sym_tuple_expression] = STATE(2000),
    [sym_brace_expression] = STATE(2000),
    [sym_anon_record_expression] = STATE(2000),
    [sym_prefixed_expression] = STATE(2000),
    [sym_typecast_expression] = STATE(2000),
    [sym_for_expression] = STATE(2000),
    [sym_while_expression] = STATE(2000),
    [sym__if_branch] = STATE(6707),
    [sym_if_expression] = STATE(2000),
    [sym_fun_expression] = STATE(2000),
    [sym_try_expression] = STATE(2000),
    [sym_match_expression] = STATE(2000),
    [sym_function_expression] = STATE(2000),
    [sym_mutate_expression] = STATE(2000),
    [sym_index_expression] = STATE(2000),
    [sym_typed_expression] = STATE(2000),
    [sym_declaration_expression] = STATE(2000),
    [sym_do_expression] = STATE(2000),
    [sym_list_expression] = STATE(2000),
    [sym_array_expression] = STATE(2000),
    [sym_begin_end_expression] = STATE(2000),
    [sym_paren_expression] = STATE(2000),
    [sym__high_prec_app] = STATE(2003),
    [sym__low_prec_app] = STATE(2003),
    [sym_application_expression] = STATE(2000),
    [sym_dot_expression] = STATE(2000),
    [sym_infix_expression] = STATE(2000),
    [sym_ce_expression] = STATE(2000),
    [sym_sequential_expression] = STATE(2000),
    [sym_char] = STATE(1801),
    [sym_format_string] = STATE(1804),
    [sym__string_literal] = STATE(1804),
    [sym_string] = STATE(1801),
    [sym_verbatim_string] = STATE(1801),
    [sym_bytearray] = STATE(1801),
    [sym_verbatim_bytearray] = STATE(1801),
    [sym_format_triple_quoted_string] = STATE(1807),
    [sym_triple_quoted_string] = STATE(1801),
    [sym_const] = STATE(2000),
    [sym_long_identifier] = STATE(1725),
    [sym_active_pattern] = STATE(1726),
    [sym__identifier_or_op] = STATE(1751),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(723),
    [sym_infix_op] = STATE(561),
    [sym_sbyte] = STATE(1801),
    [sym_byte] = STATE(1801),
    [sym_int16] = STATE(1801),
    [sym_uint16] = STATE(1801),
    [sym_int32] = STATE(1801),
    [sym_uint32] = STATE(1801),
    [sym_nativeint] = STATE(1801),
    [sym_unativeint] = STATE(1801),
    [sym_int64] = STATE(1801),
    [sym_uint64] = STATE(1801),
    [sym_ieee32] = STATE(1801),
    [sym_ieee64] = STATE(1801),
    [sym_bignum] = STATE(1801),
    [sym_decimal] = STATE(1801),
    [sym_float] = STATE(1427),
    [sym_block_comment] = STATE(126),
    [sym_compiler_directive_decl] = STATE(126),
    [sym_fsi_directive_decl] = STATE(126),
    [sym_preproc_line] = STATE(126),
    [sym_preproc_if_in_expression] = STATE(2000),
    [aux_sym_sequential_expression_repeat1] = STATE(1635),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_EQ] = ACTIONS(157),
    [anon_sym_COLON] = ACTIONS(155),
    [anon_sym_return] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(155),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_let_BANG] = ACTIONS(157),
    [anon_sym_LPAREN] = ACTIONS(155),
    [anon_sym_COMMA] = ACTIONS(157),
    [anon_sym_null] = ACTIONS(155),
    [anon_sym_QMARK] = ACTIONS(155),
    [anon_sym_COLON_QMARK] = ACTIONS(155),
    [anon_sym_COLON_COLON] = ACTIONS(157),
    [anon_sym_AMP] = ACTIONS(155),
    [anon_sym_LBRACK] = ACTIONS(155),
    [anon_sym_LBRACK_PIPE] = ACTIONS(157),
    [anon_sym_LBRACE] = ACTIONS(155),
    [anon_sym_LT_AT] = ACTIONS(155),
    [anon_sym_LT_AT_AT] = ACTIONS(155),
    [anon_sym_DOT] = ACTIONS(651),
    [anon_sym_LBRACE_PIPE] = ACTIONS(157),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_return_BANG] = ACTIONS(157),
    [anon_sym_yield] = ACTIONS(155),
    [anon_sym_yield_BANG] = ACTIONS(157),
    [anon_sym_lazy] = ACTIONS(155),
    [anon_sym_assert] = ACTIONS(155),
    [anon_sym_upcast] = ACTIONS(155),
    [anon_sym_downcast] = ACTIONS(155),
    [anon_sym_COLON_GT] = ACTIONS(157),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(157),
    [anon_sym_for] = ACTIONS(155),
    [anon_sym_while] = ACTIONS(155),
    [anon_sym_if] = ACTIONS(155),
    [anon_sym_fun] = ACTIONS(155),
    [anon_sym_try] = ACTIONS(155),
    [anon_sym_match] = ACTIONS(155),
    [anon_sym_match_BANG] = ACTIONS(157),
    [anon_sym_function] = ACTIONS(155),
    [anon_sym_LT_DASH] = ACTIONS(155),
    [anon_sym_DOT_LBRACK] = ACTIONS(675),
    [anon_sym_LT] = ACTIONS(677),
    [anon_sym_use] = ACTIONS(155),
    [anon_sym_use_BANG] = ACTIONS(157),
    [anon_sym_do_BANG] = ACTIONS(157),
    [anon_sym_begin] = ACTIONS(155),
    [anon_sym_LPAREN2] = ACTIONS(687),
    [anon_sym_or] = ACTIONS(155),
    [aux_sym_char_token1] = ACTIONS(157),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(155),
    [anon_sym_DQUOTE] = ACTIONS(155),
    [anon_sym_AT_DQUOTE] = ACTIONS(157),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(157),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(157),
    [sym_bool] = ACTIONS(155),
    [sym_unit] = ACTIONS(703),
    [anon_sym_LPAREN_PIPE] = ACTIONS(155),
    [sym_op_identifier] = ACTIONS(155),
    [anon_sym_PLUS] = ACTIONS(155),
    [anon_sym_DASH] = ACTIONS(155),
    [anon_sym_PLUS_DOT] = ACTIONS(155),
    [anon_sym_DASH_DOT] = ACTIONS(155),
    [anon_sym_PERCENT] = ACTIONS(155),
    [anon_sym_AMP_AMP] = ACTIONS(155),
    [anon_sym_TILDE] = ACTIONS(157),
    [aux_sym_prefix_op_token1] = ACTIONS(155),
    [aux_sym_infix_op_token1] = ACTIONS(157),
    [aux_sym_infix_op_token2] = ACTIONS(155),
    [anon_sym_PIPE_PIPE] = ACTIONS(155),
    [anon_sym_BANG_EQ] = ACTIONS(155),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_DOLLAR] = ACTIONS(155),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(155),
    [sym_int] = ACTIONS(155),
    [sym_xint] = ACTIONS(157),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(157),
    [anon_sym_POUNDendif] = ACTIONS(157),
    [anon_sym_POUNDelse] = ACTIONS(157),
    [sym__newline] = ACTIONS(157),
  },
  [127] = {
    [sym_function_or_value_defn] = STATE(532),
    [sym__expression] = STATE(126),
    [sym_literal_expression] = STATE(2000),
    [sym_long_identifier_or_op] = STATE(2000),
    [sym_tuple_expression] = STATE(2000),
    [sym_brace_expression] = STATE(2000),
    [sym_anon_record_expression] = STATE(2000),
    [sym_prefixed_expression] = STATE(2000),
    [sym_typecast_expression] = STATE(2000),
    [sym_for_expression] = STATE(2000),
    [sym_while_expression] = STATE(2000),
    [sym__if_branch] = STATE(6707),
    [sym_if_expression] = STATE(2000),
    [sym_fun_expression] = STATE(2000),
    [sym_try_expression] = STATE(2000),
    [sym_match_expression] = STATE(2000),
    [sym_function_expression] = STATE(2000),
    [sym_mutate_expression] = STATE(2000),
    [sym_index_expression] = STATE(2000),
    [sym_typed_expression] = STATE(2000),
    [sym_declaration_expression] = STATE(2000),
    [sym_do_expression] = STATE(2000),
    [sym_list_expression] = STATE(2000),
    [sym_array_expression] = STATE(2000),
    [sym_begin_end_expression] = STATE(2000),
    [sym_paren_expression] = STATE(2000),
    [sym__high_prec_app] = STATE(2003),
    [sym__low_prec_app] = STATE(2003),
    [sym_application_expression] = STATE(2000),
    [sym_dot_expression] = STATE(2000),
    [sym_infix_expression] = STATE(2000),
    [sym_ce_expression] = STATE(2000),
    [sym_sequential_expression] = STATE(2000),
    [sym_char] = STATE(1801),
    [sym_format_string] = STATE(1804),
    [sym__string_literal] = STATE(1804),
    [sym_string] = STATE(1801),
    [sym_verbatim_string] = STATE(1801),
    [sym_bytearray] = STATE(1801),
    [sym_verbatim_bytearray] = STATE(1801),
    [sym_format_triple_quoted_string] = STATE(1807),
    [sym_triple_quoted_string] = STATE(1801),
    [sym_const] = STATE(2000),
    [sym_long_identifier] = STATE(1725),
    [sym_active_pattern] = STATE(1726),
    [sym__identifier_or_op] = STATE(1751),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(723),
    [sym_infix_op] = STATE(561),
    [sym_sbyte] = STATE(1801),
    [sym_byte] = STATE(1801),
    [sym_int16] = STATE(1801),
    [sym_uint16] = STATE(1801),
    [sym_int32] = STATE(1801),
    [sym_uint32] = STATE(1801),
    [sym_nativeint] = STATE(1801),
    [sym_unativeint] = STATE(1801),
    [sym_int64] = STATE(1801),
    [sym_uint64] = STATE(1801),
    [sym_ieee32] = STATE(1801),
    [sym_ieee64] = STATE(1801),
    [sym_bignum] = STATE(1801),
    [sym_decimal] = STATE(1801),
    [sym_float] = STATE(1427),
    [sym_block_comment] = STATE(127),
    [sym_compiler_directive_decl] = STATE(127),
    [sym_fsi_directive_decl] = STATE(127),
    [sym_preproc_line] = STATE(127),
    [sym_preproc_if_in_expression] = STATE(2000),
    [aux_sym_sequential_expression_repeat1] = STATE(1635),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(629),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(631),
    [anon_sym_return] = ACTIONS(633),
    [anon_sym_do] = ACTIONS(635),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(637),
    [anon_sym_COMMA] = ACTIONS(639),
    [anon_sym_null] = ACTIONS(641),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(631),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(643),
    [anon_sym_LBRACK_PIPE] = ACTIONS(645),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_LT_AT] = ACTIONS(647),
    [anon_sym_LT_AT_AT] = ACTIONS(649),
    [anon_sym_DOT] = ACTIONS(651),
    [anon_sym_LBRACE_PIPE] = ACTIONS(653),
    [anon_sym_new] = ACTIONS(633),
    [anon_sym_return_BANG] = ACTIONS(655),
    [anon_sym_yield] = ACTIONS(633),
    [anon_sym_yield_BANG] = ACTIONS(655),
    [anon_sym_lazy] = ACTIONS(633),
    [anon_sym_assert] = ACTIONS(633),
    [anon_sym_upcast] = ACTIONS(633),
    [anon_sym_downcast] = ACTIONS(633),
    [anon_sym_COLON_GT] = ACTIONS(657),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(657),
    [anon_sym_for] = ACTIONS(659),
    [anon_sym_while] = ACTIONS(661),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(663),
    [anon_sym_try] = ACTIONS(665),
    [anon_sym_match] = ACTIONS(667),
    [anon_sym_match_BANG] = ACTIONS(669),
    [anon_sym_function] = ACTIONS(671),
    [anon_sym_LT_DASH] = ACTIONS(673),
    [anon_sym_DOT_LBRACK] = ACTIONS(675),
    [anon_sym_LT] = ACTIONS(677),
    [anon_sym_use] = ACTIONS(679),
    [anon_sym_use_BANG] = ACTIONS(681),
    [anon_sym_do_BANG] = ACTIONS(683),
    [anon_sym_begin] = ACTIONS(685),
    [anon_sym_LPAREN2] = ACTIONS(687),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(689),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(691),
    [anon_sym_DQUOTE] = ACTIONS(693),
    [anon_sym_AT_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(697),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(699),
    [sym_bool] = ACTIONS(701),
    [sym_unit] = ACTIONS(703),
    [anon_sym_LPAREN_PIPE] = ACTIONS(705),
    [sym_op_identifier] = ACTIONS(707),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(709),
    [sym_xint] = ACTIONS(711),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(713),
    [anon_sym_POUNDendif] = ACTIONS(159),
    [anon_sym_POUNDelse] = ACTIONS(159),
    [sym__newline] = ACTIONS(823),
  },
  [128] = {
    [sym_function_or_value_defn] = STATE(596),
    [sym__expression] = STATE(109),
    [sym_literal_expression] = STATE(1809),
    [sym_long_identifier_or_op] = STATE(1809),
    [sym_tuple_expression] = STATE(1809),
    [sym_brace_expression] = STATE(1809),
    [sym_anon_record_expression] = STATE(1809),
    [sym_prefixed_expression] = STATE(1809),
    [sym_typecast_expression] = STATE(1809),
    [sym_for_expression] = STATE(1809),
    [sym_while_expression] = STATE(1809),
    [sym__if_branch] = STATE(6874),
    [sym_if_expression] = STATE(1809),
    [sym_fun_expression] = STATE(1809),
    [sym_try_expression] = STATE(1809),
    [sym_match_expression] = STATE(1809),
    [sym_function_expression] = STATE(1809),
    [sym_mutate_expression] = STATE(1809),
    [sym_index_expression] = STATE(1809),
    [sym_typed_expression] = STATE(1809),
    [sym_declaration_expression] = STATE(1809),
    [sym_do_expression] = STATE(1809),
    [sym_list_expression] = STATE(1809),
    [sym_array_expression] = STATE(1809),
    [sym_begin_end_expression] = STATE(1809),
    [sym_paren_expression] = STATE(1809),
    [sym__high_prec_app] = STATE(1806),
    [sym__low_prec_app] = STATE(1806),
    [sym_application_expression] = STATE(1809),
    [sym_dot_expression] = STATE(1809),
    [sym_infix_expression] = STATE(1809),
    [sym_ce_expression] = STATE(1809),
    [sym_sequential_expression] = STATE(1809),
    [sym_char] = STATE(2014),
    [sym_format_string] = STATE(2019),
    [sym__string_literal] = STATE(2019),
    [sym_string] = STATE(2014),
    [sym_verbatim_string] = STATE(2014),
    [sym_bytearray] = STATE(2014),
    [sym_verbatim_bytearray] = STATE(2014),
    [sym_format_triple_quoted_string] = STATE(2020),
    [sym_triple_quoted_string] = STATE(2014),
    [sym_const] = STATE(1809),
    [sym_long_identifier] = STATE(1810),
    [sym_active_pattern] = STATE(1860),
    [sym__identifier_or_op] = STATE(1750),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(655),
    [sym_infix_op] = STATE(608),
    [sym_sbyte] = STATE(2014),
    [sym_byte] = STATE(2014),
    [sym_int16] = STATE(2014),
    [sym_uint16] = STATE(2014),
    [sym_int32] = STATE(2014),
    [sym_uint32] = STATE(2014),
    [sym_nativeint] = STATE(2014),
    [sym_unativeint] = STATE(2014),
    [sym_int64] = STATE(2014),
    [sym_uint64] = STATE(2014),
    [sym_ieee32] = STATE(2014),
    [sym_ieee64] = STATE(2014),
    [sym_bignum] = STATE(2014),
    [sym_decimal] = STATE(2014),
    [sym_float] = STATE(1438),
    [sym_block_comment] = STATE(128),
    [sym_compiler_directive_decl] = STATE(128),
    [sym_fsi_directive_decl] = STATE(128),
    [sym_preproc_line] = STATE(128),
    [sym_preproc_if_in_expression] = STATE(1809),
    [aux_sym_sequential_expression_repeat1] = STATE(1620),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(723),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(725),
    [anon_sym_return] = ACTIONS(727),
    [anon_sym_do] = ACTIONS(729),
    [anon_sym_and] = ACTIONS(871),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(731),
    [anon_sym_COMMA] = ACTIONS(733),
    [anon_sym_null] = ACTIONS(735),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(725),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(737),
    [anon_sym_LBRACK_PIPE] = ACTIONS(739),
    [anon_sym_LBRACE] = ACTIONS(741),
    [anon_sym_LT_AT] = ACTIONS(743),
    [anon_sym_LT_AT_AT] = ACTIONS(745),
    [anon_sym_DOT] = ACTIONS(747),
    [anon_sym_LBRACE_PIPE] = ACTIONS(749),
    [anon_sym_new] = ACTIONS(727),
    [anon_sym_return_BANG] = ACTIONS(751),
    [anon_sym_yield] = ACTIONS(727),
    [anon_sym_yield_BANG] = ACTIONS(751),
    [anon_sym_lazy] = ACTIONS(727),
    [anon_sym_assert] = ACTIONS(727),
    [anon_sym_upcast] = ACTIONS(727),
    [anon_sym_downcast] = ACTIONS(727),
    [anon_sym_COLON_GT] = ACTIONS(753),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(753),
    [anon_sym_for] = ACTIONS(755),
    [anon_sym_while] = ACTIONS(757),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(759),
    [anon_sym_try] = ACTIONS(761),
    [anon_sym_match] = ACTIONS(763),
    [anon_sym_match_BANG] = ACTIONS(765),
    [anon_sym_function] = ACTIONS(767),
    [anon_sym_LT_DASH] = ACTIONS(769),
    [anon_sym_DOT_LBRACK] = ACTIONS(771),
    [anon_sym_LT] = ACTIONS(773),
    [anon_sym_use] = ACTIONS(775),
    [anon_sym_use_BANG] = ACTIONS(777),
    [anon_sym_do_BANG] = ACTIONS(779),
    [anon_sym_begin] = ACTIONS(781),
    [anon_sym_LPAREN2] = ACTIONS(783),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(785),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(787),
    [anon_sym_DQUOTE] = ACTIONS(789),
    [anon_sym_AT_DQUOTE] = ACTIONS(791),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(793),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(795),
    [sym_bool] = ACTIONS(797),
    [sym_unit] = ACTIONS(799),
    [anon_sym_LPAREN_PIPE] = ACTIONS(801),
    [sym_op_identifier] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(805),
    [sym_xint] = ACTIONS(807),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(809),
    [sym__newline] = ACTIONS(851),
    [sym__dedent] = ACTIONS(873),
  },
  [129] = {
    [sym_function_or_value_defn] = STATE(532),
    [sym__expression] = STATE(126),
    [sym_literal_expression] = STATE(2000),
    [sym_long_identifier_or_op] = STATE(2000),
    [sym_tuple_expression] = STATE(2000),
    [sym_brace_expression] = STATE(2000),
    [sym_anon_record_expression] = STATE(2000),
    [sym_prefixed_expression] = STATE(2000),
    [sym_typecast_expression] = STATE(2000),
    [sym_for_expression] = STATE(2000),
    [sym_while_expression] = STATE(2000),
    [sym__if_branch] = STATE(6707),
    [sym_if_expression] = STATE(2000),
    [sym_fun_expression] = STATE(2000),
    [sym_try_expression] = STATE(2000),
    [sym_match_expression] = STATE(2000),
    [sym_function_expression] = STATE(2000),
    [sym_mutate_expression] = STATE(2000),
    [sym_index_expression] = STATE(2000),
    [sym_typed_expression] = STATE(2000),
    [sym_declaration_expression] = STATE(2000),
    [sym_do_expression] = STATE(2000),
    [sym_list_expression] = STATE(2000),
    [sym_array_expression] = STATE(2000),
    [sym_begin_end_expression] = STATE(2000),
    [sym_paren_expression] = STATE(2000),
    [sym__high_prec_app] = STATE(2003),
    [sym__low_prec_app] = STATE(2003),
    [sym_application_expression] = STATE(2000),
    [sym_dot_expression] = STATE(2000),
    [sym_infix_expression] = STATE(2000),
    [sym_ce_expression] = STATE(2000),
    [sym_sequential_expression] = STATE(2000),
    [sym_char] = STATE(1801),
    [sym_format_string] = STATE(1804),
    [sym__string_literal] = STATE(1804),
    [sym_string] = STATE(1801),
    [sym_verbatim_string] = STATE(1801),
    [sym_bytearray] = STATE(1801),
    [sym_verbatim_bytearray] = STATE(1801),
    [sym_format_triple_quoted_string] = STATE(1807),
    [sym_triple_quoted_string] = STATE(1801),
    [sym_const] = STATE(2000),
    [sym_long_identifier] = STATE(1725),
    [sym_active_pattern] = STATE(1726),
    [sym__identifier_or_op] = STATE(1751),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(723),
    [sym_infix_op] = STATE(561),
    [sym_sbyte] = STATE(1801),
    [sym_byte] = STATE(1801),
    [sym_int16] = STATE(1801),
    [sym_uint16] = STATE(1801),
    [sym_int32] = STATE(1801),
    [sym_uint32] = STATE(1801),
    [sym_nativeint] = STATE(1801),
    [sym_unativeint] = STATE(1801),
    [sym_int64] = STATE(1801),
    [sym_uint64] = STATE(1801),
    [sym_ieee32] = STATE(1801),
    [sym_ieee64] = STATE(1801),
    [sym_bignum] = STATE(1801),
    [sym_decimal] = STATE(1801),
    [sym_float] = STATE(1427),
    [sym_block_comment] = STATE(129),
    [sym_compiler_directive_decl] = STATE(129),
    [sym_fsi_directive_decl] = STATE(129),
    [sym_preproc_line] = STATE(129),
    [sym_preproc_if_in_expression] = STATE(2000),
    [aux_sym_sequential_expression_repeat1] = STATE(1635),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(629),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(631),
    [anon_sym_return] = ACTIONS(633),
    [anon_sym_do] = ACTIONS(635),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(637),
    [anon_sym_COMMA] = ACTIONS(639),
    [anon_sym_null] = ACTIONS(641),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(631),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(643),
    [anon_sym_LBRACK_PIPE] = ACTIONS(645),
    [anon_sym_LBRACE] = ACTIONS(165),
    [anon_sym_LT_AT] = ACTIONS(647),
    [anon_sym_LT_AT_AT] = ACTIONS(649),
    [anon_sym_DOT] = ACTIONS(651),
    [anon_sym_LBRACE_PIPE] = ACTIONS(653),
    [anon_sym_new] = ACTIONS(633),
    [anon_sym_return_BANG] = ACTIONS(655),
    [anon_sym_yield] = ACTIONS(633),
    [anon_sym_yield_BANG] = ACTIONS(655),
    [anon_sym_lazy] = ACTIONS(633),
    [anon_sym_assert] = ACTIONS(633),
    [anon_sym_upcast] = ACTIONS(633),
    [anon_sym_downcast] = ACTIONS(633),
    [anon_sym_COLON_GT] = ACTIONS(657),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(657),
    [anon_sym_for] = ACTIONS(659),
    [anon_sym_while] = ACTIONS(661),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(663),
    [anon_sym_try] = ACTIONS(665),
    [anon_sym_match] = ACTIONS(667),
    [anon_sym_match_BANG] = ACTIONS(669),
    [anon_sym_function] = ACTIONS(671),
    [anon_sym_LT_DASH] = ACTIONS(673),
    [anon_sym_DOT_LBRACK] = ACTIONS(675),
    [anon_sym_LT] = ACTIONS(677),
    [anon_sym_use] = ACTIONS(679),
    [anon_sym_use_BANG] = ACTIONS(681),
    [anon_sym_do_BANG] = ACTIONS(683),
    [anon_sym_begin] = ACTIONS(685),
    [anon_sym_LPAREN2] = ACTIONS(687),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(689),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(691),
    [anon_sym_DQUOTE] = ACTIONS(693),
    [anon_sym_AT_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(697),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(699),
    [sym_bool] = ACTIONS(701),
    [sym_unit] = ACTIONS(703),
    [anon_sym_LPAREN_PIPE] = ACTIONS(705),
    [sym_op_identifier] = ACTIONS(707),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(709),
    [sym_xint] = ACTIONS(711),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(713),
    [anon_sym_POUNDendif] = ACTIONS(163),
    [anon_sym_POUNDelse] = ACTIONS(163),
    [sym__newline] = ACTIONS(163),
  },
  [130] = {
    [sym_function_or_value_defn] = STATE(532),
    [sym__expression] = STATE(126),
    [sym_literal_expression] = STATE(2000),
    [sym_long_identifier_or_op] = STATE(2000),
    [sym_tuple_expression] = STATE(2000),
    [sym_brace_expression] = STATE(2000),
    [sym_anon_record_expression] = STATE(2000),
    [sym_prefixed_expression] = STATE(2000),
    [sym_typecast_expression] = STATE(2000),
    [sym_for_expression] = STATE(2000),
    [sym_while_expression] = STATE(2000),
    [sym__if_branch] = STATE(6707),
    [sym_if_expression] = STATE(2000),
    [sym_fun_expression] = STATE(2000),
    [sym_try_expression] = STATE(2000),
    [sym_match_expression] = STATE(2000),
    [sym_function_expression] = STATE(2000),
    [sym_mutate_expression] = STATE(2000),
    [sym_index_expression] = STATE(2000),
    [sym_typed_expression] = STATE(2000),
    [sym_declaration_expression] = STATE(2000),
    [sym_do_expression] = STATE(2000),
    [sym_list_expression] = STATE(2000),
    [sym_array_expression] = STATE(2000),
    [sym_begin_end_expression] = STATE(2000),
    [sym_paren_expression] = STATE(2000),
    [sym__high_prec_app] = STATE(2003),
    [sym__low_prec_app] = STATE(2003),
    [sym_application_expression] = STATE(2000),
    [sym_dot_expression] = STATE(2000),
    [sym_infix_expression] = STATE(2000),
    [sym_ce_expression] = STATE(2000),
    [sym_sequential_expression] = STATE(2000),
    [sym_char] = STATE(1801),
    [sym_format_string] = STATE(1804),
    [sym__string_literal] = STATE(1804),
    [sym_string] = STATE(1801),
    [sym_verbatim_string] = STATE(1801),
    [sym_bytearray] = STATE(1801),
    [sym_verbatim_bytearray] = STATE(1801),
    [sym_format_triple_quoted_string] = STATE(1807),
    [sym_triple_quoted_string] = STATE(1801),
    [sym_const] = STATE(2000),
    [sym_long_identifier] = STATE(1725),
    [sym_active_pattern] = STATE(1726),
    [sym__identifier_or_op] = STATE(1751),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(723),
    [sym_infix_op] = STATE(561),
    [sym_sbyte] = STATE(1801),
    [sym_byte] = STATE(1801),
    [sym_int16] = STATE(1801),
    [sym_uint16] = STATE(1801),
    [sym_int32] = STATE(1801),
    [sym_uint32] = STATE(1801),
    [sym_nativeint] = STATE(1801),
    [sym_unativeint] = STATE(1801),
    [sym_int64] = STATE(1801),
    [sym_uint64] = STATE(1801),
    [sym_ieee32] = STATE(1801),
    [sym_ieee64] = STATE(1801),
    [sym_bignum] = STATE(1801),
    [sym_decimal] = STATE(1801),
    [sym_float] = STATE(1427),
    [sym_block_comment] = STATE(130),
    [sym_compiler_directive_decl] = STATE(130),
    [sym_fsi_directive_decl] = STATE(130),
    [sym_preproc_line] = STATE(130),
    [sym_preproc_if_in_expression] = STATE(2000),
    [aux_sym_sequential_expression_repeat1] = STATE(1635),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(629),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(631),
    [anon_sym_return] = ACTIONS(633),
    [anon_sym_do] = ACTIONS(635),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(637),
    [anon_sym_COMMA] = ACTIONS(639),
    [anon_sym_null] = ACTIONS(641),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(631),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(643),
    [anon_sym_LBRACK_PIPE] = ACTIONS(645),
    [anon_sym_LBRACE] = ACTIONS(819),
    [anon_sym_LT_AT] = ACTIONS(647),
    [anon_sym_LT_AT_AT] = ACTIONS(649),
    [anon_sym_DOT] = ACTIONS(651),
    [anon_sym_LBRACE_PIPE] = ACTIONS(653),
    [anon_sym_new] = ACTIONS(633),
    [anon_sym_return_BANG] = ACTIONS(655),
    [anon_sym_yield] = ACTIONS(633),
    [anon_sym_yield_BANG] = ACTIONS(655),
    [anon_sym_lazy] = ACTIONS(633),
    [anon_sym_assert] = ACTIONS(633),
    [anon_sym_upcast] = ACTIONS(633),
    [anon_sym_downcast] = ACTIONS(633),
    [anon_sym_COLON_GT] = ACTIONS(657),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(657),
    [anon_sym_for] = ACTIONS(659),
    [anon_sym_while] = ACTIONS(661),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(663),
    [anon_sym_try] = ACTIONS(665),
    [anon_sym_match] = ACTIONS(667),
    [anon_sym_match_BANG] = ACTIONS(669),
    [anon_sym_function] = ACTIONS(671),
    [anon_sym_LT_DASH] = ACTIONS(673),
    [anon_sym_DOT_LBRACK] = ACTIONS(675),
    [anon_sym_LT] = ACTIONS(677),
    [anon_sym_use] = ACTIONS(679),
    [anon_sym_use_BANG] = ACTIONS(681),
    [anon_sym_do_BANG] = ACTIONS(683),
    [anon_sym_begin] = ACTIONS(685),
    [anon_sym_LPAREN2] = ACTIONS(687),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(689),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(691),
    [anon_sym_DQUOTE] = ACTIONS(693),
    [anon_sym_AT_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(697),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(699),
    [sym_bool] = ACTIONS(701),
    [sym_unit] = ACTIONS(703),
    [anon_sym_LPAREN_PIPE] = ACTIONS(705),
    [sym_op_identifier] = ACTIONS(707),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(709),
    [sym_xint] = ACTIONS(711),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(713),
    [anon_sym_POUNDendif] = ACTIONS(171),
    [anon_sym_POUNDelse] = ACTIONS(171),
    [sym__newline] = ACTIONS(823),
  },
  [131] = {
    [sym_function_or_value_defn] = STATE(532),
    [sym__expression] = STATE(126),
    [sym_literal_expression] = STATE(2000),
    [sym_long_identifier_or_op] = STATE(2000),
    [sym_tuple_expression] = STATE(2000),
    [sym_brace_expression] = STATE(2000),
    [sym_anon_record_expression] = STATE(2000),
    [sym_prefixed_expression] = STATE(2000),
    [sym_typecast_expression] = STATE(2000),
    [sym_for_expression] = STATE(2000),
    [sym_while_expression] = STATE(2000),
    [sym__if_branch] = STATE(6707),
    [sym_if_expression] = STATE(2000),
    [sym_fun_expression] = STATE(2000),
    [sym_try_expression] = STATE(2000),
    [sym_match_expression] = STATE(2000),
    [sym_function_expression] = STATE(2000),
    [sym_mutate_expression] = STATE(2000),
    [sym_index_expression] = STATE(2000),
    [sym_typed_expression] = STATE(2000),
    [sym_declaration_expression] = STATE(2000),
    [sym_do_expression] = STATE(2000),
    [sym_list_expression] = STATE(2000),
    [sym_array_expression] = STATE(2000),
    [sym_begin_end_expression] = STATE(2000),
    [sym_paren_expression] = STATE(2000),
    [sym__high_prec_app] = STATE(2003),
    [sym__low_prec_app] = STATE(2003),
    [sym_application_expression] = STATE(2000),
    [sym_dot_expression] = STATE(2000),
    [sym_infix_expression] = STATE(2000),
    [sym_ce_expression] = STATE(2000),
    [sym_sequential_expression] = STATE(2000),
    [sym_char] = STATE(1801),
    [sym_format_string] = STATE(1804),
    [sym__string_literal] = STATE(1804),
    [sym_string] = STATE(1801),
    [sym_verbatim_string] = STATE(1801),
    [sym_bytearray] = STATE(1801),
    [sym_verbatim_bytearray] = STATE(1801),
    [sym_format_triple_quoted_string] = STATE(1807),
    [sym_triple_quoted_string] = STATE(1801),
    [sym_const] = STATE(2000),
    [sym_long_identifier] = STATE(1725),
    [sym_active_pattern] = STATE(1726),
    [sym__identifier_or_op] = STATE(1751),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(723),
    [sym_infix_op] = STATE(561),
    [sym_sbyte] = STATE(1801),
    [sym_byte] = STATE(1801),
    [sym_int16] = STATE(1801),
    [sym_uint16] = STATE(1801),
    [sym_int32] = STATE(1801),
    [sym_uint32] = STATE(1801),
    [sym_nativeint] = STATE(1801),
    [sym_unativeint] = STATE(1801),
    [sym_int64] = STATE(1801),
    [sym_uint64] = STATE(1801),
    [sym_ieee32] = STATE(1801),
    [sym_ieee64] = STATE(1801),
    [sym_bignum] = STATE(1801),
    [sym_decimal] = STATE(1801),
    [sym_float] = STATE(1427),
    [sym_block_comment] = STATE(131),
    [sym_compiler_directive_decl] = STATE(131),
    [sym_fsi_directive_decl] = STATE(131),
    [sym_preproc_line] = STATE(131),
    [sym_preproc_if_in_expression] = STATE(2000),
    [aux_sym_sequential_expression_repeat1] = STATE(1635),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(629),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(631),
    [anon_sym_return] = ACTIONS(633),
    [anon_sym_do] = ACTIONS(635),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(637),
    [anon_sym_COMMA] = ACTIONS(639),
    [anon_sym_null] = ACTIONS(641),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(631),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(643),
    [anon_sym_LBRACK_PIPE] = ACTIONS(645),
    [anon_sym_LBRACE] = ACTIONS(59),
    [anon_sym_LT_AT] = ACTIONS(647),
    [anon_sym_LT_AT_AT] = ACTIONS(649),
    [anon_sym_DOT] = ACTIONS(651),
    [anon_sym_LBRACE_PIPE] = ACTIONS(653),
    [anon_sym_new] = ACTIONS(633),
    [anon_sym_return_BANG] = ACTIONS(655),
    [anon_sym_yield] = ACTIONS(633),
    [anon_sym_yield_BANG] = ACTIONS(655),
    [anon_sym_lazy] = ACTIONS(633),
    [anon_sym_assert] = ACTIONS(633),
    [anon_sym_upcast] = ACTIONS(633),
    [anon_sym_downcast] = ACTIONS(633),
    [anon_sym_COLON_GT] = ACTIONS(657),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(657),
    [anon_sym_for] = ACTIONS(659),
    [anon_sym_while] = ACTIONS(661),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(663),
    [anon_sym_try] = ACTIONS(665),
    [anon_sym_match] = ACTIONS(667),
    [anon_sym_match_BANG] = ACTIONS(669),
    [anon_sym_function] = ACTIONS(671),
    [anon_sym_LT_DASH] = ACTIONS(673),
    [anon_sym_DOT_LBRACK] = ACTIONS(675),
    [anon_sym_LT] = ACTIONS(677),
    [anon_sym_use] = ACTIONS(679),
    [anon_sym_use_BANG] = ACTIONS(681),
    [anon_sym_do_BANG] = ACTIONS(683),
    [anon_sym_begin] = ACTIONS(685),
    [anon_sym_LPAREN2] = ACTIONS(687),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(689),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(691),
    [anon_sym_DQUOTE] = ACTIONS(693),
    [anon_sym_AT_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(697),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(699),
    [sym_bool] = ACTIONS(701),
    [sym_unit] = ACTIONS(703),
    [anon_sym_LPAREN_PIPE] = ACTIONS(705),
    [sym_op_identifier] = ACTIONS(707),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(709),
    [sym_xint] = ACTIONS(711),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(713),
    [anon_sym_POUNDendif] = ACTIONS(33),
    [anon_sym_POUNDelse] = ACTIONS(33),
    [sym__newline] = ACTIONS(33),
  },
  [132] = {
    [sym_function_or_value_defn] = STATE(532),
    [sym__expression] = STATE(126),
    [sym_literal_expression] = STATE(2000),
    [sym_long_identifier_or_op] = STATE(2000),
    [sym_tuple_expression] = STATE(2000),
    [sym_brace_expression] = STATE(2000),
    [sym_anon_record_expression] = STATE(2000),
    [sym_prefixed_expression] = STATE(2000),
    [sym_typecast_expression] = STATE(2000),
    [sym_for_expression] = STATE(2000),
    [sym_while_expression] = STATE(2000),
    [sym__if_branch] = STATE(6707),
    [sym_if_expression] = STATE(2000),
    [sym_fun_expression] = STATE(2000),
    [sym_try_expression] = STATE(2000),
    [sym_match_expression] = STATE(2000),
    [sym_function_expression] = STATE(2000),
    [sym_mutate_expression] = STATE(2000),
    [sym_index_expression] = STATE(2000),
    [sym_typed_expression] = STATE(2000),
    [sym_declaration_expression] = STATE(2000),
    [sym_do_expression] = STATE(2000),
    [sym_list_expression] = STATE(2000),
    [sym_array_expression] = STATE(2000),
    [sym_begin_end_expression] = STATE(2000),
    [sym_paren_expression] = STATE(2000),
    [sym__high_prec_app] = STATE(2003),
    [sym__low_prec_app] = STATE(2003),
    [sym_application_expression] = STATE(2000),
    [sym_dot_expression] = STATE(2000),
    [sym_infix_expression] = STATE(2000),
    [sym_ce_expression] = STATE(2000),
    [sym_sequential_expression] = STATE(2000),
    [sym_char] = STATE(1801),
    [sym_format_string] = STATE(1804),
    [sym__string_literal] = STATE(1804),
    [sym_string] = STATE(1801),
    [sym_verbatim_string] = STATE(1801),
    [sym_bytearray] = STATE(1801),
    [sym_verbatim_bytearray] = STATE(1801),
    [sym_format_triple_quoted_string] = STATE(1807),
    [sym_triple_quoted_string] = STATE(1801),
    [sym_const] = STATE(2000),
    [sym_long_identifier] = STATE(1725),
    [sym_active_pattern] = STATE(1726),
    [sym__identifier_or_op] = STATE(1751),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(723),
    [sym_infix_op] = STATE(561),
    [sym_sbyte] = STATE(1801),
    [sym_byte] = STATE(1801),
    [sym_int16] = STATE(1801),
    [sym_uint16] = STATE(1801),
    [sym_int32] = STATE(1801),
    [sym_uint32] = STATE(1801),
    [sym_nativeint] = STATE(1801),
    [sym_unativeint] = STATE(1801),
    [sym_int64] = STATE(1801),
    [sym_uint64] = STATE(1801),
    [sym_ieee32] = STATE(1801),
    [sym_ieee64] = STATE(1801),
    [sym_bignum] = STATE(1801),
    [sym_decimal] = STATE(1801),
    [sym_float] = STATE(1427),
    [sym_block_comment] = STATE(132),
    [sym_compiler_directive_decl] = STATE(132),
    [sym_fsi_directive_decl] = STATE(132),
    [sym_preproc_line] = STATE(132),
    [sym_preproc_if_in_expression] = STATE(2000),
    [aux_sym_sequential_expression_repeat1] = STATE(1635),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(181),
    [anon_sym_EQ] = ACTIONS(183),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_return] = ACTIONS(181),
    [anon_sym_do] = ACTIONS(181),
    [anon_sym_let] = ACTIONS(181),
    [anon_sym_let_BANG] = ACTIONS(183),
    [anon_sym_LPAREN] = ACTIONS(181),
    [anon_sym_COMMA] = ACTIONS(183),
    [anon_sym_null] = ACTIONS(181),
    [anon_sym_QMARK] = ACTIONS(181),
    [anon_sym_COLON_QMARK] = ACTIONS(181),
    [anon_sym_COLON_COLON] = ACTIONS(183),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_LBRACK_PIPE] = ACTIONS(183),
    [anon_sym_LBRACE] = ACTIONS(181),
    [anon_sym_LT_AT] = ACTIONS(181),
    [anon_sym_LT_AT_AT] = ACTIONS(181),
    [anon_sym_DOT] = ACTIONS(651),
    [anon_sym_LBRACE_PIPE] = ACTIONS(183),
    [anon_sym_new] = ACTIONS(181),
    [anon_sym_return_BANG] = ACTIONS(183),
    [anon_sym_yield] = ACTIONS(181),
    [anon_sym_yield_BANG] = ACTIONS(183),
    [anon_sym_lazy] = ACTIONS(181),
    [anon_sym_assert] = ACTIONS(181),
    [anon_sym_upcast] = ACTIONS(181),
    [anon_sym_downcast] = ACTIONS(181),
    [anon_sym_COLON_GT] = ACTIONS(183),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(183),
    [anon_sym_for] = ACTIONS(181),
    [anon_sym_while] = ACTIONS(181),
    [anon_sym_if] = ACTIONS(181),
    [anon_sym_fun] = ACTIONS(181),
    [anon_sym_try] = ACTIONS(181),
    [anon_sym_match] = ACTIONS(181),
    [anon_sym_match_BANG] = ACTIONS(183),
    [anon_sym_function] = ACTIONS(181),
    [anon_sym_LT_DASH] = ACTIONS(181),
    [anon_sym_DOT_LBRACK] = ACTIONS(675),
    [anon_sym_LT] = ACTIONS(677),
    [anon_sym_use] = ACTIONS(181),
    [anon_sym_use_BANG] = ACTIONS(183),
    [anon_sym_do_BANG] = ACTIONS(183),
    [anon_sym_begin] = ACTIONS(181),
    [anon_sym_LPAREN2] = ACTIONS(687),
    [anon_sym_or] = ACTIONS(181),
    [aux_sym_char_token1] = ACTIONS(183),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(181),
    [anon_sym_DQUOTE] = ACTIONS(181),
    [anon_sym_AT_DQUOTE] = ACTIONS(183),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(183),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(183),
    [sym_bool] = ACTIONS(181),
    [sym_unit] = ACTIONS(703),
    [anon_sym_LPAREN_PIPE] = ACTIONS(181),
    [sym_op_identifier] = ACTIONS(181),
    [anon_sym_PLUS] = ACTIONS(181),
    [anon_sym_DASH] = ACTIONS(181),
    [anon_sym_PLUS_DOT] = ACTIONS(181),
    [anon_sym_DASH_DOT] = ACTIONS(181),
    [anon_sym_PERCENT] = ACTIONS(181),
    [anon_sym_AMP_AMP] = ACTIONS(181),
    [anon_sym_TILDE] = ACTIONS(183),
    [aux_sym_prefix_op_token1] = ACTIONS(181),
    [aux_sym_infix_op_token1] = ACTIONS(183),
    [aux_sym_infix_op_token2] = ACTIONS(181),
    [anon_sym_PIPE_PIPE] = ACTIONS(181),
    [anon_sym_BANG_EQ] = ACTIONS(181),
    [anon_sym_COLON_EQ] = ACTIONS(183),
    [anon_sym_DOLLAR] = ACTIONS(181),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(181),
    [sym_int] = ACTIONS(181),
    [sym_xint] = ACTIONS(183),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(183),
    [anon_sym_POUNDendif] = ACTIONS(183),
    [anon_sym_POUNDelse] = ACTIONS(183),
    [sym__newline] = ACTIONS(183),
  },
  [133] = {
    [sym_function_or_value_defn] = STATE(627),
    [sym__expression] = STATE(17),
    [sym_literal_expression] = STATE(1118),
    [sym_long_identifier_or_op] = STATE(1118),
    [sym_tuple_expression] = STATE(1118),
    [sym_brace_expression] = STATE(1118),
    [sym_anon_record_expression] = STATE(1118),
    [sym_prefixed_expression] = STATE(1118),
    [sym_typecast_expression] = STATE(1118),
    [sym_for_expression] = STATE(1118),
    [sym_while_expression] = STATE(1118),
    [sym__if_branch] = STATE(7163),
    [sym_if_expression] = STATE(1118),
    [sym_fun_expression] = STATE(1118),
    [sym_try_expression] = STATE(1118),
    [sym_match_expression] = STATE(1118),
    [sym_function_expression] = STATE(1118),
    [sym_mutate_expression] = STATE(1118),
    [sym_index_expression] = STATE(1118),
    [sym_typed_expression] = STATE(1118),
    [sym_declaration_expression] = STATE(1118),
    [sym_do_expression] = STATE(1118),
    [sym_list_expression] = STATE(1118),
    [sym_array_expression] = STATE(1118),
    [sym_begin_end_expression] = STATE(1118),
    [sym_paren_expression] = STATE(1118),
    [sym__high_prec_app] = STATE(1133),
    [sym__low_prec_app] = STATE(1133),
    [sym_application_expression] = STATE(1118),
    [sym_dot_expression] = STATE(1118),
    [sym_infix_expression] = STATE(1118),
    [sym_ce_expression] = STATE(1118),
    [sym_sequential_expression] = STATE(1118),
    [sym_char] = STATE(1080),
    [sym_format_string] = STATE(1090),
    [sym__string_literal] = STATE(1090),
    [sym_string] = STATE(1080),
    [sym_verbatim_string] = STATE(1080),
    [sym_bytearray] = STATE(1080),
    [sym_verbatim_bytearray] = STATE(1080),
    [sym_format_triple_quoted_string] = STATE(1096),
    [sym_triple_quoted_string] = STATE(1080),
    [sym_const] = STATE(1118),
    [sym_long_identifier] = STATE(1156),
    [sym_active_pattern] = STATE(1085),
    [sym__identifier_or_op] = STATE(1099),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(517),
    [sym_infix_op] = STATE(487),
    [sym_sbyte] = STATE(1080),
    [sym_byte] = STATE(1080),
    [sym_int16] = STATE(1080),
    [sym_uint16] = STATE(1080),
    [sym_int32] = STATE(1080),
    [sym_uint32] = STATE(1080),
    [sym_nativeint] = STATE(1080),
    [sym_unativeint] = STATE(1080),
    [sym_int64] = STATE(1080),
    [sym_uint64] = STATE(1080),
    [sym_ieee32] = STATE(1080),
    [sym_ieee64] = STATE(1080),
    [sym_bignum] = STATE(1080),
    [sym_decimal] = STATE(1080),
    [sym_float] = STATE(979),
    [sym_block_comment] = STATE(133),
    [sym_compiler_directive_decl] = STATE(133),
    [sym_fsi_directive_decl] = STATE(133),
    [sym_preproc_line] = STATE(133),
    [sym_preproc_if_in_expression] = STATE(1118),
    [aux_sym_sequential_expression_repeat1] = STATE(1069),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(195),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(197),
    [anon_sym_return] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_COMMA] = ACTIONS(875),
    [anon_sym_null] = ACTIONS(207),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(197),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(209),
    [anon_sym_RBRACK] = ACTIONS(875),
    [anon_sym_LBRACK_PIPE] = ACTIONS(211),
    [anon_sym_LBRACE] = ACTIONS(271),
    [anon_sym_LT_AT] = ACTIONS(213),
    [anon_sym_LT_AT_AT] = ACTIONS(215),
    [anon_sym_DOT] = ACTIONS(185),
    [anon_sym_LBRACE_PIPE] = ACTIONS(217),
    [anon_sym_new] = ACTIONS(199),
    [anon_sym_return_BANG] = ACTIONS(219),
    [anon_sym_yield] = ACTIONS(199),
    [anon_sym_yield_BANG] = ACTIONS(219),
    [anon_sym_lazy] = ACTIONS(199),
    [anon_sym_assert] = ACTIONS(199),
    [anon_sym_upcast] = ACTIONS(199),
    [anon_sym_downcast] = ACTIONS(199),
    [anon_sym_COLON_GT] = ACTIONS(221),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(221),
    [anon_sym_for] = ACTIONS(223),
    [anon_sym_while] = ACTIONS(225),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(229),
    [anon_sym_match] = ACTIONS(231),
    [anon_sym_match_BANG] = ACTIONS(233),
    [anon_sym_function] = ACTIONS(235),
    [anon_sym_LT_DASH] = ACTIONS(237),
    [anon_sym_DOT_LBRACK] = ACTIONS(187),
    [anon_sym_LT] = ACTIONS(189),
    [anon_sym_use] = ACTIONS(239),
    [anon_sym_use_BANG] = ACTIONS(241),
    [anon_sym_do_BANG] = ACTIONS(243),
    [anon_sym_begin] = ACTIONS(245),
    [anon_sym_LPAREN2] = ACTIONS(191),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(247),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(251),
    [anon_sym_AT_DQUOTE] = ACTIONS(253),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(255),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(257),
    [sym_bool] = ACTIONS(259),
    [sym_unit] = ACTIONS(193),
    [anon_sym_LPAREN_PIPE] = ACTIONS(261),
    [sym_op_identifier] = ACTIONS(263),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(265),
    [sym_xint] = ACTIONS(267),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(269),
    [sym__newline] = ACTIONS(273),
  },
  [134] = {
    [sym_function_or_value_defn] = STATE(509),
    [sym__expression] = STATE(326),
    [sym_literal_expression] = STATE(2230),
    [sym_long_identifier_or_op] = STATE(2230),
    [sym_tuple_expression] = STATE(2230),
    [sym_brace_expression] = STATE(2230),
    [sym_anon_record_expression] = STATE(2230),
    [sym_prefixed_expression] = STATE(2230),
    [sym_typecast_expression] = STATE(2230),
    [sym_for_expression] = STATE(2230),
    [sym_while_expression] = STATE(2230),
    [sym__if_branch] = STATE(6659),
    [sym_if_expression] = STATE(2230),
    [sym_fun_expression] = STATE(2230),
    [sym_try_expression] = STATE(2230),
    [sym_match_expression] = STATE(2230),
    [sym_function_expression] = STATE(2230),
    [sym_mutate_expression] = STATE(2230),
    [sym_index_expression] = STATE(2230),
    [sym_typed_expression] = STATE(2230),
    [sym_declaration_expression] = STATE(2230),
    [sym_do_expression] = STATE(2230),
    [sym_list_expression] = STATE(2230),
    [sym_array_expression] = STATE(2230),
    [sym_begin_end_expression] = STATE(2230),
    [sym_paren_expression] = STATE(2230),
    [sym__high_prec_app] = STATE(2229),
    [sym__low_prec_app] = STATE(2229),
    [sym_application_expression] = STATE(2230),
    [sym_dot_expression] = STATE(2230),
    [sym_infix_expression] = STATE(2230),
    [sym_ce_expression] = STATE(2230),
    [sym_sequential_expression] = STATE(2230),
    [sym_char] = STATE(2100),
    [sym_format_string] = STATE(2106),
    [sym__string_literal] = STATE(2106),
    [sym_string] = STATE(2100),
    [sym_verbatim_string] = STATE(2100),
    [sym_bytearray] = STATE(2100),
    [sym_verbatim_bytearray] = STATE(2100),
    [sym_format_triple_quoted_string] = STATE(2107),
    [sym_triple_quoted_string] = STATE(2100),
    [sym_const] = STATE(2230),
    [sym_long_identifier] = STATE(2232),
    [sym_active_pattern] = STATE(2424),
    [sym__identifier_or_op] = STATE(2305),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(737),
    [sym_infix_op] = STATE(694),
    [sym_sbyte] = STATE(2100),
    [sym_byte] = STATE(2100),
    [sym_int16] = STATE(2100),
    [sym_uint16] = STATE(2100),
    [sym_int32] = STATE(2100),
    [sym_uint32] = STATE(2100),
    [sym_nativeint] = STATE(2100),
    [sym_unativeint] = STATE(2100),
    [sym_int64] = STATE(2100),
    [sym_uint64] = STATE(2100),
    [sym_ieee32] = STATE(2100),
    [sym_ieee64] = STATE(2100),
    [sym_bignum] = STATE(2100),
    [sym_decimal] = STATE(2100),
    [sym_float] = STATE(1487),
    [sym_block_comment] = STATE(134),
    [sym_compiler_directive_decl] = STATE(134),
    [sym_fsi_directive_decl] = STATE(134),
    [sym_preproc_line] = STATE(134),
    [sym_preproc_if_in_expression] = STATE(2230),
    [aux_sym_sequential_expression_repeat1] = STATE(1743),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(877),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(879),
    [anon_sym_return] = ACTIONS(881),
    [anon_sym_do] = ACTIONS(883),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(885),
    [anon_sym_COMMA] = ACTIONS(887),
    [anon_sym_null] = ACTIONS(889),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(879),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(891),
    [anon_sym_LBRACK_PIPE] = ACTIONS(893),
    [anon_sym_LBRACE] = ACTIONS(895),
    [anon_sym_LT_AT] = ACTIONS(897),
    [anon_sym_LT_AT_AT] = ACTIONS(899),
    [anon_sym_DOT] = ACTIONS(901),
    [anon_sym_LBRACE_PIPE] = ACTIONS(903),
    [anon_sym_new] = ACTIONS(881),
    [anon_sym_return_BANG] = ACTIONS(905),
    [anon_sym_yield] = ACTIONS(881),
    [anon_sym_yield_BANG] = ACTIONS(905),
    [anon_sym_lazy] = ACTIONS(881),
    [anon_sym_assert] = ACTIONS(881),
    [anon_sym_upcast] = ACTIONS(881),
    [anon_sym_downcast] = ACTIONS(881),
    [anon_sym_COLON_GT] = ACTIONS(907),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(907),
    [anon_sym_for] = ACTIONS(909),
    [anon_sym_while] = ACTIONS(911),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(913),
    [anon_sym_try] = ACTIONS(915),
    [anon_sym_match] = ACTIONS(917),
    [anon_sym_match_BANG] = ACTIONS(919),
    [anon_sym_function] = ACTIONS(921),
    [anon_sym_LT_DASH] = ACTIONS(923),
    [anon_sym_DOT_LBRACK] = ACTIONS(925),
    [anon_sym_LT] = ACTIONS(927),
    [anon_sym_use] = ACTIONS(929),
    [anon_sym_use_BANG] = ACTIONS(931),
    [anon_sym_do_BANG] = ACTIONS(933),
    [anon_sym_DOT_DOT] = ACTIONS(935),
    [anon_sym_begin] = ACTIONS(937),
    [anon_sym_LPAREN2] = ACTIONS(939),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(941),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(943),
    [anon_sym_DQUOTE] = ACTIONS(945),
    [anon_sym_AT_DQUOTE] = ACTIONS(947),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(949),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(951),
    [sym_bool] = ACTIONS(953),
    [sym_unit] = ACTIONS(955),
    [anon_sym_LPAREN_PIPE] = ACTIONS(957),
    [sym_op_identifier] = ACTIONS(959),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(961),
    [sym_xint] = ACTIONS(963),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(965),
    [sym__newline] = ACTIONS(967),
  },
  [135] = {
    [sym_function_or_value_defn] = STATE(733),
    [sym__expression] = STATE(142),
    [sym_literal_expression] = STATE(2008),
    [sym_long_identifier_or_op] = STATE(2008),
    [sym_tuple_expression] = STATE(2008),
    [sym_brace_expression] = STATE(2008),
    [sym_anon_record_expression] = STATE(2008),
    [sym_prefixed_expression] = STATE(2008),
    [sym_typecast_expression] = STATE(2008),
    [sym_for_expression] = STATE(2008),
    [sym_while_expression] = STATE(2008),
    [sym__if_branch] = STATE(6754),
    [sym_if_expression] = STATE(2008),
    [sym_fun_expression] = STATE(2008),
    [sym_try_expression] = STATE(2008),
    [sym_match_expression] = STATE(2008),
    [sym_function_expression] = STATE(2008),
    [sym_mutate_expression] = STATE(2008),
    [sym_index_expression] = STATE(2008),
    [sym_typed_expression] = STATE(2008),
    [sym_declaration_expression] = STATE(2008),
    [sym_do_expression] = STATE(2008),
    [sym_list_expression] = STATE(2008),
    [sym_array_expression] = STATE(2008),
    [sym_begin_end_expression] = STATE(2008),
    [sym_paren_expression] = STATE(2008),
    [sym__high_prec_app] = STATE(2007),
    [sym__low_prec_app] = STATE(2007),
    [sym_application_expression] = STATE(2008),
    [sym_dot_expression] = STATE(2008),
    [sym_infix_expression] = STATE(2008),
    [sym_ce_expression] = STATE(2008),
    [sym_sequential_expression] = STATE(2008),
    [sym_char] = STATE(1859),
    [sym_format_string] = STATE(1861),
    [sym__string_literal] = STATE(1861),
    [sym_string] = STATE(1859),
    [sym_verbatim_string] = STATE(1859),
    [sym_bytearray] = STATE(1859),
    [sym_verbatim_bytearray] = STATE(1859),
    [sym_format_triple_quoted_string] = STATE(1862),
    [sym_triple_quoted_string] = STATE(1859),
    [sym_const] = STATE(2008),
    [sym_long_identifier] = STATE(1701),
    [sym_active_pattern] = STATE(1702),
    [sym__identifier_or_op] = STATE(1724),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(706),
    [sym_infix_op] = STATE(678),
    [sym_sbyte] = STATE(1859),
    [sym_byte] = STATE(1859),
    [sym_int16] = STATE(1859),
    [sym_uint16] = STATE(1859),
    [sym_int32] = STATE(1859),
    [sym_uint32] = STATE(1859),
    [sym_nativeint] = STATE(1859),
    [sym_unativeint] = STATE(1859),
    [sym_int64] = STATE(1859),
    [sym_uint64] = STATE(1859),
    [sym_ieee32] = STATE(1859),
    [sym_ieee64] = STATE(1859),
    [sym_bignum] = STATE(1859),
    [sym_decimal] = STATE(1859),
    [sym_float] = STATE(1447),
    [sym_block_comment] = STATE(135),
    [sym_compiler_directive_decl] = STATE(135),
    [sym_fsi_directive_decl] = STATE(135),
    [sym_preproc_line] = STATE(135),
    [sym_preproc_if_in_expression] = STATE(2008),
    [aux_sym_sequential_expression_repeat1] = STATE(1995),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(181),
    [anon_sym_EQ] = ACTIONS(183),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_return] = ACTIONS(181),
    [anon_sym_do] = ACTIONS(181),
    [anon_sym_let] = ACTIONS(181),
    [anon_sym_let_BANG] = ACTIONS(183),
    [anon_sym_LPAREN] = ACTIONS(181),
    [anon_sym_COMMA] = ACTIONS(183),
    [anon_sym_null] = ACTIONS(181),
    [anon_sym_QMARK] = ACTIONS(181),
    [anon_sym_COLON_QMARK] = ACTIONS(181),
    [anon_sym_COLON_COLON] = ACTIONS(183),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_LBRACK_PIPE] = ACTIONS(183),
    [anon_sym_LBRACE] = ACTIONS(181),
    [anon_sym_LT_AT] = ACTIONS(181),
    [anon_sym_LT_AT_AT] = ACTIONS(181),
    [anon_sym_DOT] = ACTIONS(527),
    [anon_sym_LBRACE_PIPE] = ACTIONS(183),
    [anon_sym_new] = ACTIONS(181),
    [anon_sym_return_BANG] = ACTIONS(183),
    [anon_sym_yield] = ACTIONS(181),
    [anon_sym_yield_BANG] = ACTIONS(183),
    [anon_sym_lazy] = ACTIONS(181),
    [anon_sym_assert] = ACTIONS(181),
    [anon_sym_upcast] = ACTIONS(181),
    [anon_sym_downcast] = ACTIONS(181),
    [anon_sym_COLON_GT] = ACTIONS(183),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(183),
    [anon_sym_for] = ACTIONS(181),
    [anon_sym_while] = ACTIONS(181),
    [anon_sym_if] = ACTIONS(181),
    [anon_sym_fun] = ACTIONS(181),
    [anon_sym_DASH_GT] = ACTIONS(181),
    [anon_sym_try] = ACTIONS(181),
    [anon_sym_match] = ACTIONS(181),
    [anon_sym_match_BANG] = ACTIONS(183),
    [anon_sym_function] = ACTIONS(181),
    [anon_sym_LT_DASH] = ACTIONS(181),
    [anon_sym_DOT_LBRACK] = ACTIONS(553),
    [anon_sym_LT] = ACTIONS(555),
    [anon_sym_use] = ACTIONS(181),
    [anon_sym_use_BANG] = ACTIONS(183),
    [anon_sym_do_BANG] = ACTIONS(183),
    [anon_sym_begin] = ACTIONS(181),
    [anon_sym_LPAREN2] = ACTIONS(567),
    [anon_sym_or] = ACTIONS(181),
    [aux_sym_char_token1] = ACTIONS(183),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(181),
    [anon_sym_DQUOTE] = ACTIONS(181),
    [anon_sym_AT_DQUOTE] = ACTIONS(183),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(183),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(183),
    [sym_bool] = ACTIONS(181),
    [sym_unit] = ACTIONS(583),
    [anon_sym_LPAREN_PIPE] = ACTIONS(181),
    [sym_op_identifier] = ACTIONS(181),
    [anon_sym_PLUS] = ACTIONS(181),
    [anon_sym_DASH] = ACTIONS(181),
    [anon_sym_PLUS_DOT] = ACTIONS(181),
    [anon_sym_DASH_DOT] = ACTIONS(181),
    [anon_sym_PERCENT] = ACTIONS(181),
    [anon_sym_AMP_AMP] = ACTIONS(181),
    [anon_sym_TILDE] = ACTIONS(183),
    [aux_sym_prefix_op_token1] = ACTIONS(181),
    [aux_sym_infix_op_token1] = ACTIONS(183),
    [aux_sym_infix_op_token2] = ACTIONS(181),
    [anon_sym_PIPE_PIPE] = ACTIONS(181),
    [anon_sym_BANG_EQ] = ACTIONS(181),
    [anon_sym_COLON_EQ] = ACTIONS(183),
    [anon_sym_DOLLAR] = ACTIONS(181),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(181),
    [sym_int] = ACTIONS(181),
    [sym_xint] = ACTIONS(183),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(183),
    [sym__newline] = ACTIONS(183),
  },
  [136] = {
    [sym_function_or_value_defn] = STATE(733),
    [sym__expression] = STATE(142),
    [sym_literal_expression] = STATE(2008),
    [sym_long_identifier_or_op] = STATE(2008),
    [sym_tuple_expression] = STATE(2008),
    [sym_brace_expression] = STATE(2008),
    [sym_anon_record_expression] = STATE(2008),
    [sym_prefixed_expression] = STATE(2008),
    [sym_typecast_expression] = STATE(2008),
    [sym_for_expression] = STATE(2008),
    [sym_while_expression] = STATE(2008),
    [sym__if_branch] = STATE(6754),
    [sym_if_expression] = STATE(2008),
    [sym_fun_expression] = STATE(2008),
    [sym_try_expression] = STATE(2008),
    [sym_match_expression] = STATE(2008),
    [sym_function_expression] = STATE(2008),
    [sym_mutate_expression] = STATE(2008),
    [sym_index_expression] = STATE(2008),
    [sym_typed_expression] = STATE(2008),
    [sym_declaration_expression] = STATE(2008),
    [sym_do_expression] = STATE(2008),
    [sym_list_expression] = STATE(2008),
    [sym_array_expression] = STATE(2008),
    [sym_begin_end_expression] = STATE(2008),
    [sym_paren_expression] = STATE(2008),
    [sym__high_prec_app] = STATE(2007),
    [sym__low_prec_app] = STATE(2007),
    [sym_application_expression] = STATE(2008),
    [sym_dot_expression] = STATE(2008),
    [sym_infix_expression] = STATE(2008),
    [sym_ce_expression] = STATE(2008),
    [sym_sequential_expression] = STATE(2008),
    [sym_char] = STATE(1859),
    [sym_format_string] = STATE(1861),
    [sym__string_literal] = STATE(1861),
    [sym_string] = STATE(1859),
    [sym_verbatim_string] = STATE(1859),
    [sym_bytearray] = STATE(1859),
    [sym_verbatim_bytearray] = STATE(1859),
    [sym_format_triple_quoted_string] = STATE(1862),
    [sym_triple_quoted_string] = STATE(1859),
    [sym_const] = STATE(2008),
    [sym_long_identifier] = STATE(1701),
    [sym_active_pattern] = STATE(1702),
    [sym__identifier_or_op] = STATE(1724),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(706),
    [sym_infix_op] = STATE(678),
    [sym_sbyte] = STATE(1859),
    [sym_byte] = STATE(1859),
    [sym_int16] = STATE(1859),
    [sym_uint16] = STATE(1859),
    [sym_int32] = STATE(1859),
    [sym_uint32] = STATE(1859),
    [sym_nativeint] = STATE(1859),
    [sym_unativeint] = STATE(1859),
    [sym_int64] = STATE(1859),
    [sym_uint64] = STATE(1859),
    [sym_ieee32] = STATE(1859),
    [sym_ieee64] = STATE(1859),
    [sym_bignum] = STATE(1859),
    [sym_decimal] = STATE(1859),
    [sym_float] = STATE(1447),
    [sym_block_comment] = STATE(136),
    [sym_compiler_directive_decl] = STATE(136),
    [sym_fsi_directive_decl] = STATE(136),
    [sym_preproc_line] = STATE(136),
    [sym_preproc_if_in_expression] = STATE(2008),
    [aux_sym_sequential_expression_repeat1] = STATE(1995),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(503),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(969),
    [anon_sym_return] = ACTIONS(971),
    [anon_sym_do] = ACTIONS(599),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(511),
    [anon_sym_COMMA] = ACTIONS(973),
    [anon_sym_null] = ACTIONS(515),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(969),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(517),
    [anon_sym_LBRACK_PIPE] = ACTIONS(519),
    [anon_sym_LBRACE] = ACTIONS(169),
    [anon_sym_LT_AT] = ACTIONS(523),
    [anon_sym_LT_AT_AT] = ACTIONS(525),
    [anon_sym_DOT] = ACTIONS(527),
    [anon_sym_LBRACE_PIPE] = ACTIONS(529),
    [anon_sym_new] = ACTIONS(971),
    [anon_sym_return_BANG] = ACTIONS(975),
    [anon_sym_yield] = ACTIONS(971),
    [anon_sym_yield_BANG] = ACTIONS(975),
    [anon_sym_lazy] = ACTIONS(971),
    [anon_sym_assert] = ACTIONS(971),
    [anon_sym_upcast] = ACTIONS(971),
    [anon_sym_downcast] = ACTIONS(971),
    [anon_sym_COLON_GT] = ACTIONS(977),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(977),
    [anon_sym_for] = ACTIONS(979),
    [anon_sym_while] = ACTIONS(537),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(539),
    [anon_sym_DASH_GT] = ACTIONS(169),
    [anon_sym_try] = ACTIONS(543),
    [anon_sym_match] = ACTIONS(545),
    [anon_sym_match_BANG] = ACTIONS(547),
    [anon_sym_function] = ACTIONS(549),
    [anon_sym_LT_DASH] = ACTIONS(981),
    [anon_sym_DOT_LBRACK] = ACTIONS(553),
    [anon_sym_LT] = ACTIONS(555),
    [anon_sym_use] = ACTIONS(983),
    [anon_sym_use_BANG] = ACTIONS(985),
    [anon_sym_do_BANG] = ACTIONS(561),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_LPAREN2] = ACTIONS(567),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(569),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(571),
    [anon_sym_DQUOTE] = ACTIONS(573),
    [anon_sym_AT_DQUOTE] = ACTIONS(575),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(577),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(579),
    [sym_bool] = ACTIONS(581),
    [sym_unit] = ACTIONS(583),
    [anon_sym_LPAREN_PIPE] = ACTIONS(585),
    [sym_op_identifier] = ACTIONS(587),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(591),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(593),
    [sym__newline] = ACTIONS(167),
  },
  [137] = {
    [sym_function_or_value_defn] = STATE(651),
    [sym__expression] = STATE(167),
    [sym_literal_expression] = STATE(2168),
    [sym_long_identifier_or_op] = STATE(2168),
    [sym_tuple_expression] = STATE(2168),
    [sym_brace_expression] = STATE(2168),
    [sym_anon_record_expression] = STATE(2168),
    [sym_prefixed_expression] = STATE(2168),
    [sym_typecast_expression] = STATE(2168),
    [sym_for_expression] = STATE(2168),
    [sym_while_expression] = STATE(2168),
    [sym__if_branch] = STATE(6406),
    [sym_if_expression] = STATE(2168),
    [sym_fun_expression] = STATE(2168),
    [sym_try_expression] = STATE(2168),
    [sym_match_expression] = STATE(2168),
    [sym_function_expression] = STATE(2168),
    [sym_mutate_expression] = STATE(2168),
    [sym_index_expression] = STATE(2168),
    [sym_typed_expression] = STATE(2168),
    [sym_declaration_expression] = STATE(2168),
    [sym_do_expression] = STATE(2168),
    [sym_list_expression] = STATE(2168),
    [sym_array_expression] = STATE(2168),
    [sym_begin_end_expression] = STATE(2168),
    [sym_paren_expression] = STATE(2168),
    [sym__high_prec_app] = STATE(2179),
    [sym__low_prec_app] = STATE(2179),
    [sym_application_expression] = STATE(2168),
    [sym_dot_expression] = STATE(2168),
    [sym_infix_expression] = STATE(2168),
    [sym_ce_expression] = STATE(2168),
    [sym_sequential_expression] = STATE(2168),
    [sym_char] = STATE(2469),
    [sym_format_string] = STATE(2412),
    [sym__string_literal] = STATE(2412),
    [sym_string] = STATE(2469),
    [sym_verbatim_string] = STATE(2469),
    [sym_bytearray] = STATE(2469),
    [sym_verbatim_bytearray] = STATE(2469),
    [sym_format_triple_quoted_string] = STATE(2408),
    [sym_triple_quoted_string] = STATE(2469),
    [sym_const] = STATE(2168),
    [sym_long_identifier] = STATE(2183),
    [sym_active_pattern] = STATE(2182),
    [sym__identifier_or_op] = STATE(2093),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(650),
    [sym_infix_op] = STATE(721),
    [sym_sbyte] = STATE(2469),
    [sym_byte] = STATE(2469),
    [sym_int16] = STATE(2469),
    [sym_uint16] = STATE(2469),
    [sym_int32] = STATE(2469),
    [sym_uint32] = STATE(2469),
    [sym_nativeint] = STATE(2469),
    [sym_unativeint] = STATE(2469),
    [sym_int64] = STATE(2469),
    [sym_uint64] = STATE(2469),
    [sym_ieee32] = STATE(2469),
    [sym_ieee64] = STATE(2469),
    [sym_bignum] = STATE(2469),
    [sym_decimal] = STATE(2469),
    [sym_float] = STATE(1586),
    [sym_block_comment] = STATE(137),
    [sym_compiler_directive_decl] = STATE(137),
    [sym_fsi_directive_decl] = STATE(137),
    [sym_preproc_line] = STATE(137),
    [sym_preproc_if_in_expression] = STATE(2168),
    [aux_sym_sequential_expression_repeat1] = STATE(1755),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(989),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(991),
    [anon_sym_return] = ACTIONS(993),
    [anon_sym_do] = ACTIONS(995),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(997),
    [anon_sym_COMMA] = ACTIONS(999),
    [anon_sym_null] = ACTIONS(1001),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(991),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1003),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1005),
    [anon_sym_LBRACE] = ACTIONS(1007),
    [anon_sym_LT_AT] = ACTIONS(1009),
    [anon_sym_AT_GT] = ACTIONS(1011),
    [anon_sym_LT_AT_AT] = ACTIONS(1013),
    [anon_sym_DOT] = ACTIONS(1015),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1017),
    [anon_sym_new] = ACTIONS(993),
    [anon_sym_return_BANG] = ACTIONS(1019),
    [anon_sym_yield] = ACTIONS(993),
    [anon_sym_yield_BANG] = ACTIONS(1019),
    [anon_sym_lazy] = ACTIONS(993),
    [anon_sym_assert] = ACTIONS(993),
    [anon_sym_upcast] = ACTIONS(993),
    [anon_sym_downcast] = ACTIONS(993),
    [anon_sym_COLON_GT] = ACTIONS(1021),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1021),
    [anon_sym_for] = ACTIONS(1023),
    [anon_sym_while] = ACTIONS(1025),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(1027),
    [anon_sym_try] = ACTIONS(1029),
    [anon_sym_match] = ACTIONS(1031),
    [anon_sym_match_BANG] = ACTIONS(1033),
    [anon_sym_function] = ACTIONS(1035),
    [anon_sym_LT_DASH] = ACTIONS(1037),
    [anon_sym_DOT_LBRACK] = ACTIONS(1039),
    [anon_sym_LT] = ACTIONS(1041),
    [anon_sym_use] = ACTIONS(1043),
    [anon_sym_use_BANG] = ACTIONS(1045),
    [anon_sym_do_BANG] = ACTIONS(1047),
    [anon_sym_begin] = ACTIONS(1049),
    [anon_sym_LPAREN2] = ACTIONS(1051),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(1053),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1055),
    [anon_sym_DQUOTE] = ACTIONS(1057),
    [anon_sym_AT_DQUOTE] = ACTIONS(1059),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1061),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1063),
    [sym_bool] = ACTIONS(1065),
    [sym_unit] = ACTIONS(1067),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1069),
    [sym_op_identifier] = ACTIONS(1071),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(1073),
    [sym_xint] = ACTIONS(1075),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1077),
    [sym__newline] = ACTIONS(1079),
  },
  [138] = {
    [sym_function_or_value_defn] = STATE(733),
    [sym__expression] = STATE(142),
    [sym_literal_expression] = STATE(2008),
    [sym_long_identifier_or_op] = STATE(2008),
    [sym_tuple_expression] = STATE(2008),
    [sym_brace_expression] = STATE(2008),
    [sym_anon_record_expression] = STATE(2008),
    [sym_prefixed_expression] = STATE(2008),
    [sym_typecast_expression] = STATE(2008),
    [sym_for_expression] = STATE(2008),
    [sym_while_expression] = STATE(2008),
    [sym__if_branch] = STATE(6754),
    [sym_if_expression] = STATE(2008),
    [sym_fun_expression] = STATE(2008),
    [sym_try_expression] = STATE(2008),
    [sym_match_expression] = STATE(2008),
    [sym_function_expression] = STATE(2008),
    [sym_mutate_expression] = STATE(2008),
    [sym_index_expression] = STATE(2008),
    [sym_typed_expression] = STATE(2008),
    [sym_declaration_expression] = STATE(2008),
    [sym_do_expression] = STATE(2008),
    [sym_list_expression] = STATE(2008),
    [sym_array_expression] = STATE(2008),
    [sym_begin_end_expression] = STATE(2008),
    [sym_paren_expression] = STATE(2008),
    [sym__high_prec_app] = STATE(2007),
    [sym__low_prec_app] = STATE(2007),
    [sym_application_expression] = STATE(2008),
    [sym_dot_expression] = STATE(2008),
    [sym_infix_expression] = STATE(2008),
    [sym_ce_expression] = STATE(2008),
    [sym_sequential_expression] = STATE(2008),
    [sym_char] = STATE(1859),
    [sym_format_string] = STATE(1861),
    [sym__string_literal] = STATE(1861),
    [sym_string] = STATE(1859),
    [sym_verbatim_string] = STATE(1859),
    [sym_bytearray] = STATE(1859),
    [sym_verbatim_bytearray] = STATE(1859),
    [sym_format_triple_quoted_string] = STATE(1862),
    [sym_triple_quoted_string] = STATE(1859),
    [sym_const] = STATE(2008),
    [sym_long_identifier] = STATE(1701),
    [sym_active_pattern] = STATE(1702),
    [sym__identifier_or_op] = STATE(1724),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(706),
    [sym_infix_op] = STATE(678),
    [sym_sbyte] = STATE(1859),
    [sym_byte] = STATE(1859),
    [sym_int16] = STATE(1859),
    [sym_uint16] = STATE(1859),
    [sym_int32] = STATE(1859),
    [sym_uint32] = STATE(1859),
    [sym_nativeint] = STATE(1859),
    [sym_unativeint] = STATE(1859),
    [sym_int64] = STATE(1859),
    [sym_uint64] = STATE(1859),
    [sym_ieee32] = STATE(1859),
    [sym_ieee64] = STATE(1859),
    [sym_bignum] = STATE(1859),
    [sym_decimal] = STATE(1859),
    [sym_float] = STATE(1447),
    [sym_block_comment] = STATE(138),
    [sym_compiler_directive_decl] = STATE(138),
    [sym_fsi_directive_decl] = STATE(138),
    [sym_preproc_line] = STATE(138),
    [sym_preproc_if_in_expression] = STATE(2008),
    [aux_sym_sequential_expression_repeat1] = STATE(1995),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(503),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(969),
    [anon_sym_return] = ACTIONS(971),
    [anon_sym_do] = ACTIONS(599),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(511),
    [anon_sym_COMMA] = ACTIONS(973),
    [anon_sym_null] = ACTIONS(515),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(969),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(517),
    [anon_sym_LBRACK_PIPE] = ACTIONS(519),
    [anon_sym_LBRACE] = ACTIONS(165),
    [anon_sym_LT_AT] = ACTIONS(523),
    [anon_sym_LT_AT_AT] = ACTIONS(525),
    [anon_sym_DOT] = ACTIONS(527),
    [anon_sym_LBRACE_PIPE] = ACTIONS(529),
    [anon_sym_new] = ACTIONS(971),
    [anon_sym_return_BANG] = ACTIONS(975),
    [anon_sym_yield] = ACTIONS(971),
    [anon_sym_yield_BANG] = ACTIONS(975),
    [anon_sym_lazy] = ACTIONS(971),
    [anon_sym_assert] = ACTIONS(971),
    [anon_sym_upcast] = ACTIONS(971),
    [anon_sym_downcast] = ACTIONS(971),
    [anon_sym_COLON_GT] = ACTIONS(977),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(977),
    [anon_sym_for] = ACTIONS(979),
    [anon_sym_while] = ACTIONS(537),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(539),
    [anon_sym_DASH_GT] = ACTIONS(165),
    [anon_sym_try] = ACTIONS(543),
    [anon_sym_match] = ACTIONS(545),
    [anon_sym_match_BANG] = ACTIONS(547),
    [anon_sym_function] = ACTIONS(549),
    [anon_sym_LT_DASH] = ACTIONS(981),
    [anon_sym_DOT_LBRACK] = ACTIONS(553),
    [anon_sym_LT] = ACTIONS(555),
    [anon_sym_use] = ACTIONS(983),
    [anon_sym_use_BANG] = ACTIONS(985),
    [anon_sym_do_BANG] = ACTIONS(561),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_LPAREN2] = ACTIONS(567),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(569),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(571),
    [anon_sym_DQUOTE] = ACTIONS(573),
    [anon_sym_AT_DQUOTE] = ACTIONS(575),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(577),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(579),
    [sym_bool] = ACTIONS(581),
    [sym_unit] = ACTIONS(583),
    [anon_sym_LPAREN_PIPE] = ACTIONS(585),
    [sym_op_identifier] = ACTIONS(587),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(591),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(593),
    [sym__newline] = ACTIONS(163),
  },
  [139] = {
    [sym_function_or_value_defn] = STATE(630),
    [sym__expression] = STATE(219),
    [sym_literal_expression] = STATE(2380),
    [sym_long_identifier_or_op] = STATE(2380),
    [sym_tuple_expression] = STATE(2380),
    [sym_brace_expression] = STATE(2380),
    [sym_anon_record_expression] = STATE(2380),
    [sym_prefixed_expression] = STATE(2380),
    [sym_typecast_expression] = STATE(2380),
    [sym_for_expression] = STATE(2380),
    [sym_while_expression] = STATE(2380),
    [sym__if_branch] = STATE(6456),
    [sym_if_expression] = STATE(2380),
    [sym_fun_expression] = STATE(2380),
    [sym_try_expression] = STATE(2380),
    [sym_match_expression] = STATE(2380),
    [sym_function_expression] = STATE(2380),
    [sym_mutate_expression] = STATE(2380),
    [sym_index_expression] = STATE(2380),
    [sym_typed_expression] = STATE(2380),
    [sym_declaration_expression] = STATE(2380),
    [sym_do_expression] = STATE(2380),
    [sym_list_expression] = STATE(2380),
    [sym_array_expression] = STATE(2380),
    [sym_begin_end_expression] = STATE(2380),
    [sym_paren_expression] = STATE(2380),
    [sym__high_prec_app] = STATE(2383),
    [sym__low_prec_app] = STATE(2383),
    [sym_application_expression] = STATE(2380),
    [sym_dot_expression] = STATE(2380),
    [sym_infix_expression] = STATE(2380),
    [sym_ce_expression] = STATE(2380),
    [sym_sequential_expression] = STATE(2380),
    [sym_char] = STATE(2261),
    [sym_format_string] = STATE(2274),
    [sym__string_literal] = STATE(2274),
    [sym_string] = STATE(2261),
    [sym_verbatim_string] = STATE(2261),
    [sym_bytearray] = STATE(2261),
    [sym_verbatim_bytearray] = STATE(2261),
    [sym_format_triple_quoted_string] = STATE(2275),
    [sym_triple_quoted_string] = STATE(2261),
    [sym_const] = STATE(2380),
    [sym_long_identifier] = STATE(2391),
    [sym_active_pattern] = STATE(2470),
    [sym__identifier_or_op] = STATE(2390),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(632),
    [sym_infix_op] = STATE(616),
    [sym_sbyte] = STATE(2261),
    [sym_byte] = STATE(2261),
    [sym_int16] = STATE(2261),
    [sym_uint16] = STATE(2261),
    [sym_int32] = STATE(2261),
    [sym_uint32] = STATE(2261),
    [sym_nativeint] = STATE(2261),
    [sym_unativeint] = STATE(2261),
    [sym_int64] = STATE(2261),
    [sym_uint64] = STATE(2261),
    [sym_ieee32] = STATE(2261),
    [sym_ieee64] = STATE(2261),
    [sym_bignum] = STATE(2261),
    [sym_decimal] = STATE(2261),
    [sym_float] = STATE(1614),
    [sym_block_comment] = STATE(139),
    [sym_compiler_directive_decl] = STATE(139),
    [sym_fsi_directive_decl] = STATE(139),
    [sym_preproc_line] = STATE(139),
    [sym_preproc_if_in_expression] = STATE(2380),
    [aux_sym_sequential_expression_repeat1] = STATE(1882),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(1081),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(1083),
    [anon_sym_return] = ACTIONS(1085),
    [anon_sym_do] = ACTIONS(1087),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(1089),
    [anon_sym_COMMA] = ACTIONS(1091),
    [anon_sym_null] = ACTIONS(1093),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(1083),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1095),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1097),
    [anon_sym_LBRACE] = ACTIONS(1099),
    [anon_sym_LT_AT] = ACTIONS(1101),
    [anon_sym_LT_AT_AT] = ACTIONS(1103),
    [anon_sym_AT_AT_GT] = ACTIONS(1011),
    [anon_sym_DOT] = ACTIONS(1105),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1107),
    [anon_sym_new] = ACTIONS(1085),
    [anon_sym_return_BANG] = ACTIONS(1109),
    [anon_sym_yield] = ACTIONS(1085),
    [anon_sym_yield_BANG] = ACTIONS(1109),
    [anon_sym_lazy] = ACTIONS(1085),
    [anon_sym_assert] = ACTIONS(1085),
    [anon_sym_upcast] = ACTIONS(1085),
    [anon_sym_downcast] = ACTIONS(1085),
    [anon_sym_COLON_GT] = ACTIONS(1111),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1111),
    [anon_sym_for] = ACTIONS(1113),
    [anon_sym_while] = ACTIONS(1115),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(1117),
    [anon_sym_try] = ACTIONS(1119),
    [anon_sym_match] = ACTIONS(1121),
    [anon_sym_match_BANG] = ACTIONS(1123),
    [anon_sym_function] = ACTIONS(1125),
    [anon_sym_LT_DASH] = ACTIONS(1127),
    [anon_sym_DOT_LBRACK] = ACTIONS(1129),
    [anon_sym_LT] = ACTIONS(1131),
    [anon_sym_use] = ACTIONS(1133),
    [anon_sym_use_BANG] = ACTIONS(1135),
    [anon_sym_do_BANG] = ACTIONS(1137),
    [anon_sym_begin] = ACTIONS(1139),
    [anon_sym_LPAREN2] = ACTIONS(1141),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(1143),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1145),
    [anon_sym_DQUOTE] = ACTIONS(1147),
    [anon_sym_AT_DQUOTE] = ACTIONS(1149),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1151),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1153),
    [sym_bool] = ACTIONS(1155),
    [sym_unit] = ACTIONS(1157),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1159),
    [sym_op_identifier] = ACTIONS(1161),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(1163),
    [sym_xint] = ACTIONS(1165),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1167),
    [sym__newline] = ACTIONS(1169),
  },
  [140] = {
    [sym_function_or_value_defn] = STATE(733),
    [sym__expression] = STATE(142),
    [sym_literal_expression] = STATE(2008),
    [sym_long_identifier_or_op] = STATE(2008),
    [sym_tuple_expression] = STATE(2008),
    [sym_brace_expression] = STATE(2008),
    [sym_anon_record_expression] = STATE(2008),
    [sym_prefixed_expression] = STATE(2008),
    [sym_typecast_expression] = STATE(2008),
    [sym_for_expression] = STATE(2008),
    [sym_while_expression] = STATE(2008),
    [sym__if_branch] = STATE(6754),
    [sym_if_expression] = STATE(2008),
    [sym_fun_expression] = STATE(2008),
    [sym_try_expression] = STATE(2008),
    [sym_match_expression] = STATE(2008),
    [sym_function_expression] = STATE(2008),
    [sym_mutate_expression] = STATE(2008),
    [sym_index_expression] = STATE(2008),
    [sym_typed_expression] = STATE(2008),
    [sym_declaration_expression] = STATE(2008),
    [sym_do_expression] = STATE(2008),
    [sym_list_expression] = STATE(2008),
    [sym_array_expression] = STATE(2008),
    [sym_begin_end_expression] = STATE(2008),
    [sym_paren_expression] = STATE(2008),
    [sym__high_prec_app] = STATE(2007),
    [sym__low_prec_app] = STATE(2007),
    [sym_application_expression] = STATE(2008),
    [sym_dot_expression] = STATE(2008),
    [sym_infix_expression] = STATE(2008),
    [sym_ce_expression] = STATE(2008),
    [sym_sequential_expression] = STATE(2008),
    [sym_char] = STATE(1859),
    [sym_format_string] = STATE(1861),
    [sym__string_literal] = STATE(1861),
    [sym_string] = STATE(1859),
    [sym_verbatim_string] = STATE(1859),
    [sym_bytearray] = STATE(1859),
    [sym_verbatim_bytearray] = STATE(1859),
    [sym_format_triple_quoted_string] = STATE(1862),
    [sym_triple_quoted_string] = STATE(1859),
    [sym_const] = STATE(2008),
    [sym_long_identifier] = STATE(1701),
    [sym_active_pattern] = STATE(1702),
    [sym__identifier_or_op] = STATE(1724),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(706),
    [sym_infix_op] = STATE(678),
    [sym_sbyte] = STATE(1859),
    [sym_byte] = STATE(1859),
    [sym_int16] = STATE(1859),
    [sym_uint16] = STATE(1859),
    [sym_int32] = STATE(1859),
    [sym_uint32] = STATE(1859),
    [sym_nativeint] = STATE(1859),
    [sym_unativeint] = STATE(1859),
    [sym_int64] = STATE(1859),
    [sym_uint64] = STATE(1859),
    [sym_ieee32] = STATE(1859),
    [sym_ieee64] = STATE(1859),
    [sym_bignum] = STATE(1859),
    [sym_decimal] = STATE(1859),
    [sym_float] = STATE(1447),
    [sym_block_comment] = STATE(140),
    [sym_compiler_directive_decl] = STATE(140),
    [sym_fsi_directive_decl] = STATE(140),
    [sym_preproc_line] = STATE(140),
    [sym_preproc_if_in_expression] = STATE(2008),
    [aux_sym_sequential_expression_repeat1] = STATE(1995),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(503),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(969),
    [anon_sym_return] = ACTIONS(971),
    [anon_sym_do] = ACTIONS(599),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(511),
    [anon_sym_COMMA] = ACTIONS(973),
    [anon_sym_null] = ACTIONS(515),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(969),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(517),
    [anon_sym_LBRACK_PIPE] = ACTIONS(519),
    [anon_sym_LBRACE] = ACTIONS(521),
    [anon_sym_LT_AT] = ACTIONS(523),
    [anon_sym_LT_AT_AT] = ACTIONS(525),
    [anon_sym_DOT] = ACTIONS(527),
    [anon_sym_LBRACE_PIPE] = ACTIONS(529),
    [anon_sym_new] = ACTIONS(971),
    [anon_sym_return_BANG] = ACTIONS(975),
    [anon_sym_yield] = ACTIONS(971),
    [anon_sym_yield_BANG] = ACTIONS(975),
    [anon_sym_lazy] = ACTIONS(971),
    [anon_sym_assert] = ACTIONS(971),
    [anon_sym_upcast] = ACTIONS(971),
    [anon_sym_downcast] = ACTIONS(971),
    [anon_sym_COLON_GT] = ACTIONS(977),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(977),
    [anon_sym_for] = ACTIONS(979),
    [anon_sym_while] = ACTIONS(537),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(539),
    [anon_sym_DASH_GT] = ACTIONS(161),
    [anon_sym_try] = ACTIONS(543),
    [anon_sym_match] = ACTIONS(545),
    [anon_sym_match_BANG] = ACTIONS(547),
    [anon_sym_function] = ACTIONS(549),
    [anon_sym_LT_DASH] = ACTIONS(981),
    [anon_sym_DOT_LBRACK] = ACTIONS(553),
    [anon_sym_LT] = ACTIONS(555),
    [anon_sym_use] = ACTIONS(983),
    [anon_sym_use_BANG] = ACTIONS(985),
    [anon_sym_do_BANG] = ACTIONS(561),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_LPAREN2] = ACTIONS(567),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(569),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(571),
    [anon_sym_DQUOTE] = ACTIONS(573),
    [anon_sym_AT_DQUOTE] = ACTIONS(575),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(577),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(579),
    [sym_bool] = ACTIONS(581),
    [sym_unit] = ACTIONS(583),
    [anon_sym_LPAREN_PIPE] = ACTIONS(585),
    [sym_op_identifier] = ACTIONS(587),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(591),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(593),
    [sym__newline] = ACTIONS(1171),
  },
  [141] = {
    [sym_function_or_value_defn] = STATE(600),
    [sym__expression] = STATE(88),
    [sym_literal_expression] = STATE(867),
    [sym_long_identifier_or_op] = STATE(867),
    [sym_tuple_expression] = STATE(867),
    [sym_brace_expression] = STATE(867),
    [sym_anon_record_expression] = STATE(867),
    [sym_prefixed_expression] = STATE(867),
    [sym_typecast_expression] = STATE(867),
    [sym_for_expression] = STATE(867),
    [sym_while_expression] = STATE(867),
    [sym__if_branch] = STATE(6511),
    [sym_if_expression] = STATE(867),
    [sym_fun_expression] = STATE(867),
    [sym_try_expression] = STATE(867),
    [sym_match_expression] = STATE(867),
    [sym_function_expression] = STATE(867),
    [sym_mutate_expression] = STATE(867),
    [sym_index_expression] = STATE(867),
    [sym_typed_expression] = STATE(867),
    [sym_declaration_expression] = STATE(867),
    [sym_do_expression] = STATE(867),
    [sym_list_expression] = STATE(867),
    [sym_array_expression] = STATE(867),
    [sym_begin_end_expression] = STATE(867),
    [sym_paren_expression] = STATE(867),
    [sym__high_prec_app] = STATE(864),
    [sym__low_prec_app] = STATE(864),
    [sym_application_expression] = STATE(867),
    [sym_dot_expression] = STATE(867),
    [sym_infix_expression] = STATE(867),
    [sym_ce_expression] = STATE(867),
    [sym_sequential_expression] = STATE(867),
    [sym_char] = STATE(868),
    [sym_format_string] = STATE(869),
    [sym__string_literal] = STATE(869),
    [sym_string] = STATE(868),
    [sym_verbatim_string] = STATE(868),
    [sym_bytearray] = STATE(868),
    [sym_verbatim_bytearray] = STATE(868),
    [sym_format_triple_quoted_string] = STATE(870),
    [sym_triple_quoted_string] = STATE(868),
    [sym_const] = STATE(867),
    [sym_long_identifier] = STATE(872),
    [sym_active_pattern] = STATE(871),
    [sym__identifier_or_op] = STATE(873),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(656),
    [sym_infix_op] = STATE(581),
    [sym_sbyte] = STATE(868),
    [sym_byte] = STATE(868),
    [sym_int16] = STATE(868),
    [sym_uint16] = STATE(868),
    [sym_int32] = STATE(868),
    [sym_uint32] = STATE(868),
    [sym_nativeint] = STATE(868),
    [sym_unativeint] = STATE(868),
    [sym_int64] = STATE(868),
    [sym_uint64] = STATE(868),
    [sym_ieee32] = STATE(868),
    [sym_ieee64] = STATE(868),
    [sym_bignum] = STATE(868),
    [sym_decimal] = STATE(868),
    [sym_float] = STATE(1368),
    [sym_block_comment] = STATE(141),
    [sym_compiler_directive_decl] = STATE(141),
    [sym_fsi_directive_decl] = STATE(141),
    [sym_preproc_line] = STATE(141),
    [sym_preproc_if_in_expression] = STATE(867),
    [aux_sym_sequential_expression_repeat1] = STATE(1542),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(29),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(825),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_COMMA] = ACTIONS(827),
    [anon_sym_null] = ACTIONS(49),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACK_PIPE] = ACTIONS(57),
    [anon_sym_LBRACE] = ACTIONS(139),
    [anon_sym_LT_AT] = ACTIONS(61),
    [anon_sym_LT_AT_AT] = ACTIONS(63),
    [anon_sym_DOT] = ACTIONS(65),
    [anon_sym_LBRACE_PIPE] = ACTIONS(67),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_return_BANG] = ACTIONS(829),
    [anon_sym_yield] = ACTIONS(825),
    [anon_sym_yield_BANG] = ACTIONS(829),
    [anon_sym_lazy] = ACTIONS(825),
    [anon_sym_assert] = ACTIONS(825),
    [anon_sym_upcast] = ACTIONS(825),
    [anon_sym_downcast] = ACTIONS(825),
    [anon_sym_COLON_GT] = ACTIONS(71),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(71),
    [anon_sym_for] = ACTIONS(73),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(79),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_match] = ACTIONS(83),
    [anon_sym_match_BANG] = ACTIONS(85),
    [anon_sym_function] = ACTIONS(87),
    [anon_sym_LT_DASH] = ACTIONS(831),
    [anon_sym_DOT_LBRACK] = ACTIONS(91),
    [anon_sym_LT] = ACTIONS(93),
    [anon_sym_use] = ACTIONS(833),
    [anon_sym_use_BANG] = ACTIONS(835),
    [anon_sym_do_BANG] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(101),
    [anon_sym_LPAREN2] = ACTIONS(103),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(105),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(107),
    [anon_sym_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DQUOTE] = ACTIONS(111),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(115),
    [sym_bool] = ACTIONS(117),
    [sym_unit] = ACTIONS(119),
    [anon_sym_LPAREN_PIPE] = ACTIONS(121),
    [sym_op_identifier] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(837),
    [sym_xint] = ACTIONS(387),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(135),
    [sym__newline] = ACTIONS(839),
    [sym__dedent] = ACTIONS(1173),
  },
  [142] = {
    [sym_function_or_value_defn] = STATE(733),
    [sym__expression] = STATE(142),
    [sym_literal_expression] = STATE(2008),
    [sym_long_identifier_or_op] = STATE(2008),
    [sym_tuple_expression] = STATE(2008),
    [sym_brace_expression] = STATE(2008),
    [sym_anon_record_expression] = STATE(2008),
    [sym_prefixed_expression] = STATE(2008),
    [sym_typecast_expression] = STATE(2008),
    [sym_for_expression] = STATE(2008),
    [sym_while_expression] = STATE(2008),
    [sym__if_branch] = STATE(6754),
    [sym_if_expression] = STATE(2008),
    [sym_fun_expression] = STATE(2008),
    [sym_try_expression] = STATE(2008),
    [sym_match_expression] = STATE(2008),
    [sym_function_expression] = STATE(2008),
    [sym_mutate_expression] = STATE(2008),
    [sym_index_expression] = STATE(2008),
    [sym_typed_expression] = STATE(2008),
    [sym_declaration_expression] = STATE(2008),
    [sym_do_expression] = STATE(2008),
    [sym_list_expression] = STATE(2008),
    [sym_array_expression] = STATE(2008),
    [sym_begin_end_expression] = STATE(2008),
    [sym_paren_expression] = STATE(2008),
    [sym__high_prec_app] = STATE(2007),
    [sym__low_prec_app] = STATE(2007),
    [sym_application_expression] = STATE(2008),
    [sym_dot_expression] = STATE(2008),
    [sym_infix_expression] = STATE(2008),
    [sym_ce_expression] = STATE(2008),
    [sym_sequential_expression] = STATE(2008),
    [sym_char] = STATE(1859),
    [sym_format_string] = STATE(1861),
    [sym__string_literal] = STATE(1861),
    [sym_string] = STATE(1859),
    [sym_verbatim_string] = STATE(1859),
    [sym_bytearray] = STATE(1859),
    [sym_verbatim_bytearray] = STATE(1859),
    [sym_format_triple_quoted_string] = STATE(1862),
    [sym_triple_quoted_string] = STATE(1859),
    [sym_const] = STATE(2008),
    [sym_long_identifier] = STATE(1701),
    [sym_active_pattern] = STATE(1702),
    [sym__identifier_or_op] = STATE(1724),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(706),
    [sym_infix_op] = STATE(678),
    [sym_sbyte] = STATE(1859),
    [sym_byte] = STATE(1859),
    [sym_int16] = STATE(1859),
    [sym_uint16] = STATE(1859),
    [sym_int32] = STATE(1859),
    [sym_uint32] = STATE(1859),
    [sym_nativeint] = STATE(1859),
    [sym_unativeint] = STATE(1859),
    [sym_int64] = STATE(1859),
    [sym_uint64] = STATE(1859),
    [sym_ieee32] = STATE(1859),
    [sym_ieee64] = STATE(1859),
    [sym_bignum] = STATE(1859),
    [sym_decimal] = STATE(1859),
    [sym_float] = STATE(1447),
    [sym_block_comment] = STATE(142),
    [sym_compiler_directive_decl] = STATE(142),
    [sym_fsi_directive_decl] = STATE(142),
    [sym_preproc_line] = STATE(142),
    [sym_preproc_if_in_expression] = STATE(2008),
    [aux_sym_sequential_expression_repeat1] = STATE(1995),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_EQ] = ACTIONS(157),
    [anon_sym_COLON] = ACTIONS(155),
    [anon_sym_return] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(155),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_let_BANG] = ACTIONS(157),
    [anon_sym_LPAREN] = ACTIONS(155),
    [anon_sym_COMMA] = ACTIONS(157),
    [anon_sym_null] = ACTIONS(155),
    [anon_sym_QMARK] = ACTIONS(155),
    [anon_sym_COLON_QMARK] = ACTIONS(155),
    [anon_sym_COLON_COLON] = ACTIONS(157),
    [anon_sym_AMP] = ACTIONS(155),
    [anon_sym_LBRACK] = ACTIONS(155),
    [anon_sym_LBRACK_PIPE] = ACTIONS(157),
    [anon_sym_LBRACE] = ACTIONS(155),
    [anon_sym_LT_AT] = ACTIONS(155),
    [anon_sym_LT_AT_AT] = ACTIONS(155),
    [anon_sym_DOT] = ACTIONS(527),
    [anon_sym_LBRACE_PIPE] = ACTIONS(157),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_return_BANG] = ACTIONS(157),
    [anon_sym_yield] = ACTIONS(155),
    [anon_sym_yield_BANG] = ACTIONS(157),
    [anon_sym_lazy] = ACTIONS(155),
    [anon_sym_assert] = ACTIONS(155),
    [anon_sym_upcast] = ACTIONS(155),
    [anon_sym_downcast] = ACTIONS(155),
    [anon_sym_COLON_GT] = ACTIONS(157),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(157),
    [anon_sym_for] = ACTIONS(155),
    [anon_sym_while] = ACTIONS(155),
    [anon_sym_if] = ACTIONS(155),
    [anon_sym_fun] = ACTIONS(155),
    [anon_sym_DASH_GT] = ACTIONS(155),
    [anon_sym_try] = ACTIONS(155),
    [anon_sym_match] = ACTIONS(155),
    [anon_sym_match_BANG] = ACTIONS(157),
    [anon_sym_function] = ACTIONS(155),
    [anon_sym_LT_DASH] = ACTIONS(155),
    [anon_sym_DOT_LBRACK] = ACTIONS(553),
    [anon_sym_LT] = ACTIONS(555),
    [anon_sym_use] = ACTIONS(155),
    [anon_sym_use_BANG] = ACTIONS(157),
    [anon_sym_do_BANG] = ACTIONS(157),
    [anon_sym_begin] = ACTIONS(155),
    [anon_sym_LPAREN2] = ACTIONS(567),
    [anon_sym_or] = ACTIONS(155),
    [aux_sym_char_token1] = ACTIONS(157),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(155),
    [anon_sym_DQUOTE] = ACTIONS(155),
    [anon_sym_AT_DQUOTE] = ACTIONS(157),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(157),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(157),
    [sym_bool] = ACTIONS(155),
    [sym_unit] = ACTIONS(583),
    [anon_sym_LPAREN_PIPE] = ACTIONS(155),
    [sym_op_identifier] = ACTIONS(155),
    [anon_sym_PLUS] = ACTIONS(155),
    [anon_sym_DASH] = ACTIONS(155),
    [anon_sym_PLUS_DOT] = ACTIONS(155),
    [anon_sym_DASH_DOT] = ACTIONS(155),
    [anon_sym_PERCENT] = ACTIONS(155),
    [anon_sym_AMP_AMP] = ACTIONS(155),
    [anon_sym_TILDE] = ACTIONS(157),
    [aux_sym_prefix_op_token1] = ACTIONS(155),
    [aux_sym_infix_op_token1] = ACTIONS(157),
    [aux_sym_infix_op_token2] = ACTIONS(155),
    [anon_sym_PIPE_PIPE] = ACTIONS(155),
    [anon_sym_BANG_EQ] = ACTIONS(155),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_DOLLAR] = ACTIONS(155),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(155),
    [sym_int] = ACTIONS(155),
    [sym_xint] = ACTIONS(157),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(157),
    [sym__newline] = ACTIONS(157),
  },
  [143] = {
    [sym_function_or_value_defn] = STATE(651),
    [sym__expression] = STATE(167),
    [sym_literal_expression] = STATE(2168),
    [sym_long_identifier_or_op] = STATE(2168),
    [sym_tuple_expression] = STATE(2168),
    [sym_brace_expression] = STATE(2168),
    [sym_anon_record_expression] = STATE(2168),
    [sym_prefixed_expression] = STATE(2168),
    [sym_typecast_expression] = STATE(2168),
    [sym_for_expression] = STATE(2168),
    [sym_while_expression] = STATE(2168),
    [sym__if_branch] = STATE(6406),
    [sym_if_expression] = STATE(2168),
    [sym_fun_expression] = STATE(2168),
    [sym_try_expression] = STATE(2168),
    [sym_match_expression] = STATE(2168),
    [sym_function_expression] = STATE(2168),
    [sym_mutate_expression] = STATE(2168),
    [sym_index_expression] = STATE(2168),
    [sym_typed_expression] = STATE(2168),
    [sym_declaration_expression] = STATE(2168),
    [sym_do_expression] = STATE(2168),
    [sym_list_expression] = STATE(2168),
    [sym_array_expression] = STATE(2168),
    [sym_begin_end_expression] = STATE(2168),
    [sym_paren_expression] = STATE(2168),
    [sym__high_prec_app] = STATE(2179),
    [sym__low_prec_app] = STATE(2179),
    [sym_application_expression] = STATE(2168),
    [sym_dot_expression] = STATE(2168),
    [sym_infix_expression] = STATE(2168),
    [sym_ce_expression] = STATE(2168),
    [sym_sequential_expression] = STATE(2168),
    [sym_char] = STATE(2469),
    [sym_format_string] = STATE(2412),
    [sym__string_literal] = STATE(2412),
    [sym_string] = STATE(2469),
    [sym_verbatim_string] = STATE(2469),
    [sym_bytearray] = STATE(2469),
    [sym_verbatim_bytearray] = STATE(2469),
    [sym_format_triple_quoted_string] = STATE(2408),
    [sym_triple_quoted_string] = STATE(2469),
    [sym_const] = STATE(2168),
    [sym_long_identifier] = STATE(2183),
    [sym_active_pattern] = STATE(2182),
    [sym__identifier_or_op] = STATE(2093),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(650),
    [sym_infix_op] = STATE(721),
    [sym_sbyte] = STATE(2469),
    [sym_byte] = STATE(2469),
    [sym_int16] = STATE(2469),
    [sym_uint16] = STATE(2469),
    [sym_int32] = STATE(2469),
    [sym_uint32] = STATE(2469),
    [sym_nativeint] = STATE(2469),
    [sym_unativeint] = STATE(2469),
    [sym_int64] = STATE(2469),
    [sym_uint64] = STATE(2469),
    [sym_ieee32] = STATE(2469),
    [sym_ieee64] = STATE(2469),
    [sym_bignum] = STATE(2469),
    [sym_decimal] = STATE(2469),
    [sym_float] = STATE(1586),
    [sym_block_comment] = STATE(143),
    [sym_compiler_directive_decl] = STATE(143),
    [sym_fsi_directive_decl] = STATE(143),
    [sym_preproc_line] = STATE(143),
    [sym_preproc_if_in_expression] = STATE(2168),
    [aux_sym_sequential_expression_repeat1] = STATE(1755),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(989),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(991),
    [anon_sym_return] = ACTIONS(993),
    [anon_sym_do] = ACTIONS(995),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(997),
    [anon_sym_COMMA] = ACTIONS(999),
    [anon_sym_null] = ACTIONS(1001),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(991),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1003),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1005),
    [anon_sym_LBRACE] = ACTIONS(1007),
    [anon_sym_LT_AT] = ACTIONS(1009),
    [anon_sym_AT_GT] = ACTIONS(1175),
    [anon_sym_LT_AT_AT] = ACTIONS(1013),
    [anon_sym_DOT] = ACTIONS(1015),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1017),
    [anon_sym_new] = ACTIONS(993),
    [anon_sym_return_BANG] = ACTIONS(1019),
    [anon_sym_yield] = ACTIONS(993),
    [anon_sym_yield_BANG] = ACTIONS(1019),
    [anon_sym_lazy] = ACTIONS(993),
    [anon_sym_assert] = ACTIONS(993),
    [anon_sym_upcast] = ACTIONS(993),
    [anon_sym_downcast] = ACTIONS(993),
    [anon_sym_COLON_GT] = ACTIONS(1021),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1021),
    [anon_sym_for] = ACTIONS(1023),
    [anon_sym_while] = ACTIONS(1025),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(1027),
    [anon_sym_try] = ACTIONS(1029),
    [anon_sym_match] = ACTIONS(1031),
    [anon_sym_match_BANG] = ACTIONS(1033),
    [anon_sym_function] = ACTIONS(1035),
    [anon_sym_LT_DASH] = ACTIONS(1037),
    [anon_sym_DOT_LBRACK] = ACTIONS(1039),
    [anon_sym_LT] = ACTIONS(1041),
    [anon_sym_use] = ACTIONS(1043),
    [anon_sym_use_BANG] = ACTIONS(1045),
    [anon_sym_do_BANG] = ACTIONS(1047),
    [anon_sym_begin] = ACTIONS(1049),
    [anon_sym_LPAREN2] = ACTIONS(1051),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(1053),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1055),
    [anon_sym_DQUOTE] = ACTIONS(1057),
    [anon_sym_AT_DQUOTE] = ACTIONS(1059),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1061),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1063),
    [sym_bool] = ACTIONS(1065),
    [sym_unit] = ACTIONS(1067),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1069),
    [sym_op_identifier] = ACTIONS(1071),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(1073),
    [sym_xint] = ACTIONS(1075),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1077),
    [sym__newline] = ACTIONS(1079),
  },
  [144] = {
    [sym_function_or_value_defn] = STATE(630),
    [sym__expression] = STATE(219),
    [sym_literal_expression] = STATE(2380),
    [sym_long_identifier_or_op] = STATE(2380),
    [sym_tuple_expression] = STATE(2380),
    [sym_brace_expression] = STATE(2380),
    [sym_anon_record_expression] = STATE(2380),
    [sym_prefixed_expression] = STATE(2380),
    [sym_typecast_expression] = STATE(2380),
    [sym_for_expression] = STATE(2380),
    [sym_while_expression] = STATE(2380),
    [sym__if_branch] = STATE(6456),
    [sym_if_expression] = STATE(2380),
    [sym_fun_expression] = STATE(2380),
    [sym_try_expression] = STATE(2380),
    [sym_match_expression] = STATE(2380),
    [sym_function_expression] = STATE(2380),
    [sym_mutate_expression] = STATE(2380),
    [sym_index_expression] = STATE(2380),
    [sym_typed_expression] = STATE(2380),
    [sym_declaration_expression] = STATE(2380),
    [sym_do_expression] = STATE(2380),
    [sym_list_expression] = STATE(2380),
    [sym_array_expression] = STATE(2380),
    [sym_begin_end_expression] = STATE(2380),
    [sym_paren_expression] = STATE(2380),
    [sym__high_prec_app] = STATE(2383),
    [sym__low_prec_app] = STATE(2383),
    [sym_application_expression] = STATE(2380),
    [sym_dot_expression] = STATE(2380),
    [sym_infix_expression] = STATE(2380),
    [sym_ce_expression] = STATE(2380),
    [sym_sequential_expression] = STATE(2380),
    [sym_char] = STATE(2261),
    [sym_format_string] = STATE(2274),
    [sym__string_literal] = STATE(2274),
    [sym_string] = STATE(2261),
    [sym_verbatim_string] = STATE(2261),
    [sym_bytearray] = STATE(2261),
    [sym_verbatim_bytearray] = STATE(2261),
    [sym_format_triple_quoted_string] = STATE(2275),
    [sym_triple_quoted_string] = STATE(2261),
    [sym_const] = STATE(2380),
    [sym_long_identifier] = STATE(2391),
    [sym_active_pattern] = STATE(2470),
    [sym__identifier_or_op] = STATE(2390),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(632),
    [sym_infix_op] = STATE(616),
    [sym_sbyte] = STATE(2261),
    [sym_byte] = STATE(2261),
    [sym_int16] = STATE(2261),
    [sym_uint16] = STATE(2261),
    [sym_int32] = STATE(2261),
    [sym_uint32] = STATE(2261),
    [sym_nativeint] = STATE(2261),
    [sym_unativeint] = STATE(2261),
    [sym_int64] = STATE(2261),
    [sym_uint64] = STATE(2261),
    [sym_ieee32] = STATE(2261),
    [sym_ieee64] = STATE(2261),
    [sym_bignum] = STATE(2261),
    [sym_decimal] = STATE(2261),
    [sym_float] = STATE(1614),
    [sym_block_comment] = STATE(144),
    [sym_compiler_directive_decl] = STATE(144),
    [sym_fsi_directive_decl] = STATE(144),
    [sym_preproc_line] = STATE(144),
    [sym_preproc_if_in_expression] = STATE(2380),
    [aux_sym_sequential_expression_repeat1] = STATE(1882),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(1081),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(1083),
    [anon_sym_return] = ACTIONS(1085),
    [anon_sym_do] = ACTIONS(1087),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(1089),
    [anon_sym_COMMA] = ACTIONS(1091),
    [anon_sym_null] = ACTIONS(1093),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(1083),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1095),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1097),
    [anon_sym_LBRACE] = ACTIONS(1099),
    [anon_sym_LT_AT] = ACTIONS(1101),
    [anon_sym_LT_AT_AT] = ACTIONS(1103),
    [anon_sym_AT_AT_GT] = ACTIONS(1175),
    [anon_sym_DOT] = ACTIONS(1105),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1107),
    [anon_sym_new] = ACTIONS(1085),
    [anon_sym_return_BANG] = ACTIONS(1109),
    [anon_sym_yield] = ACTIONS(1085),
    [anon_sym_yield_BANG] = ACTIONS(1109),
    [anon_sym_lazy] = ACTIONS(1085),
    [anon_sym_assert] = ACTIONS(1085),
    [anon_sym_upcast] = ACTIONS(1085),
    [anon_sym_downcast] = ACTIONS(1085),
    [anon_sym_COLON_GT] = ACTIONS(1111),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1111),
    [anon_sym_for] = ACTIONS(1113),
    [anon_sym_while] = ACTIONS(1115),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(1117),
    [anon_sym_try] = ACTIONS(1119),
    [anon_sym_match] = ACTIONS(1121),
    [anon_sym_match_BANG] = ACTIONS(1123),
    [anon_sym_function] = ACTIONS(1125),
    [anon_sym_LT_DASH] = ACTIONS(1127),
    [anon_sym_DOT_LBRACK] = ACTIONS(1129),
    [anon_sym_LT] = ACTIONS(1131),
    [anon_sym_use] = ACTIONS(1133),
    [anon_sym_use_BANG] = ACTIONS(1135),
    [anon_sym_do_BANG] = ACTIONS(1137),
    [anon_sym_begin] = ACTIONS(1139),
    [anon_sym_LPAREN2] = ACTIONS(1141),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(1143),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1145),
    [anon_sym_DQUOTE] = ACTIONS(1147),
    [anon_sym_AT_DQUOTE] = ACTIONS(1149),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1151),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1153),
    [sym_bool] = ACTIONS(1155),
    [sym_unit] = ACTIONS(1157),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1159),
    [sym_op_identifier] = ACTIONS(1161),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(1163),
    [sym_xint] = ACTIONS(1165),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1167),
    [sym__newline] = ACTIONS(1169),
  },
  [145] = {
    [sym_function_or_value_defn] = STATE(600),
    [sym__expression] = STATE(88),
    [sym_literal_expression] = STATE(867),
    [sym_long_identifier_or_op] = STATE(867),
    [sym_tuple_expression] = STATE(867),
    [sym_brace_expression] = STATE(867),
    [sym_anon_record_expression] = STATE(867),
    [sym_prefixed_expression] = STATE(867),
    [sym_typecast_expression] = STATE(867),
    [sym_for_expression] = STATE(867),
    [sym_while_expression] = STATE(867),
    [sym__if_branch] = STATE(6511),
    [sym_if_expression] = STATE(867),
    [sym_fun_expression] = STATE(867),
    [sym_try_expression] = STATE(867),
    [sym_match_expression] = STATE(867),
    [sym_function_expression] = STATE(867),
    [sym_mutate_expression] = STATE(867),
    [sym_index_expression] = STATE(867),
    [sym_typed_expression] = STATE(867),
    [sym_declaration_expression] = STATE(867),
    [sym_do_expression] = STATE(867),
    [sym_list_expression] = STATE(867),
    [sym_array_expression] = STATE(867),
    [sym_begin_end_expression] = STATE(867),
    [sym_paren_expression] = STATE(867),
    [sym__high_prec_app] = STATE(864),
    [sym__low_prec_app] = STATE(864),
    [sym_application_expression] = STATE(867),
    [sym_dot_expression] = STATE(867),
    [sym_infix_expression] = STATE(867),
    [sym_ce_expression] = STATE(867),
    [sym_sequential_expression] = STATE(867),
    [sym_char] = STATE(868),
    [sym_format_string] = STATE(869),
    [sym__string_literal] = STATE(869),
    [sym_string] = STATE(868),
    [sym_verbatim_string] = STATE(868),
    [sym_bytearray] = STATE(868),
    [sym_verbatim_bytearray] = STATE(868),
    [sym_format_triple_quoted_string] = STATE(870),
    [sym_triple_quoted_string] = STATE(868),
    [sym_const] = STATE(867),
    [sym_long_identifier] = STATE(872),
    [sym_active_pattern] = STATE(871),
    [sym__identifier_or_op] = STATE(873),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(656),
    [sym_infix_op] = STATE(581),
    [sym_sbyte] = STATE(868),
    [sym_byte] = STATE(868),
    [sym_int16] = STATE(868),
    [sym_uint16] = STATE(868),
    [sym_int32] = STATE(868),
    [sym_uint32] = STATE(868),
    [sym_nativeint] = STATE(868),
    [sym_unativeint] = STATE(868),
    [sym_int64] = STATE(868),
    [sym_uint64] = STATE(868),
    [sym_ieee32] = STATE(868),
    [sym_ieee64] = STATE(868),
    [sym_bignum] = STATE(868),
    [sym_decimal] = STATE(868),
    [sym_float] = STATE(1368),
    [sym_block_comment] = STATE(145),
    [sym_compiler_directive_decl] = STATE(145),
    [sym_fsi_directive_decl] = STATE(145),
    [sym_preproc_line] = STATE(145),
    [sym_preproc_if_in_expression] = STATE(867),
    [aux_sym_sequential_expression_repeat1] = STATE(1542),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(29),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(825),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_COMMA] = ACTIONS(827),
    [anon_sym_null] = ACTIONS(49),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACK_PIPE] = ACTIONS(57),
    [anon_sym_LBRACE] = ACTIONS(139),
    [anon_sym_LT_AT] = ACTIONS(61),
    [anon_sym_LT_AT_AT] = ACTIONS(63),
    [anon_sym_DOT] = ACTIONS(65),
    [anon_sym_LBRACE_PIPE] = ACTIONS(67),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_return_BANG] = ACTIONS(829),
    [anon_sym_yield] = ACTIONS(825),
    [anon_sym_yield_BANG] = ACTIONS(829),
    [anon_sym_lazy] = ACTIONS(825),
    [anon_sym_assert] = ACTIONS(825),
    [anon_sym_upcast] = ACTIONS(825),
    [anon_sym_downcast] = ACTIONS(825),
    [anon_sym_COLON_GT] = ACTIONS(71),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(71),
    [anon_sym_for] = ACTIONS(73),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(79),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_match] = ACTIONS(83),
    [anon_sym_match_BANG] = ACTIONS(85),
    [anon_sym_function] = ACTIONS(87),
    [anon_sym_LT_DASH] = ACTIONS(831),
    [anon_sym_DOT_LBRACK] = ACTIONS(91),
    [anon_sym_LT] = ACTIONS(93),
    [anon_sym_use] = ACTIONS(833),
    [anon_sym_use_BANG] = ACTIONS(835),
    [anon_sym_do_BANG] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(101),
    [anon_sym_LPAREN2] = ACTIONS(103),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(105),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(107),
    [anon_sym_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DQUOTE] = ACTIONS(111),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(115),
    [sym_bool] = ACTIONS(117),
    [sym_unit] = ACTIONS(119),
    [anon_sym_LPAREN_PIPE] = ACTIONS(121),
    [sym_op_identifier] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(837),
    [sym_xint] = ACTIONS(387),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(135),
    [sym__newline] = ACTIONS(839),
    [sym__dedent] = ACTIONS(1177),
  },
  [146] = {
    [sym_function_or_value_defn] = STATE(651),
    [sym__expression] = STATE(167),
    [sym_literal_expression] = STATE(2168),
    [sym_long_identifier_or_op] = STATE(2168),
    [sym_tuple_expression] = STATE(2168),
    [sym_brace_expression] = STATE(2168),
    [sym_anon_record_expression] = STATE(2168),
    [sym_prefixed_expression] = STATE(2168),
    [sym_typecast_expression] = STATE(2168),
    [sym_for_expression] = STATE(2168),
    [sym_while_expression] = STATE(2168),
    [sym__if_branch] = STATE(6406),
    [sym_if_expression] = STATE(2168),
    [sym_fun_expression] = STATE(2168),
    [sym_try_expression] = STATE(2168),
    [sym_match_expression] = STATE(2168),
    [sym_function_expression] = STATE(2168),
    [sym_mutate_expression] = STATE(2168),
    [sym_index_expression] = STATE(2168),
    [sym_typed_expression] = STATE(2168),
    [sym_declaration_expression] = STATE(2168),
    [sym_do_expression] = STATE(2168),
    [sym_list_expression] = STATE(2168),
    [sym_array_expression] = STATE(2168),
    [sym_begin_end_expression] = STATE(2168),
    [sym_paren_expression] = STATE(2168),
    [sym__high_prec_app] = STATE(2179),
    [sym__low_prec_app] = STATE(2179),
    [sym_application_expression] = STATE(2168),
    [sym_dot_expression] = STATE(2168),
    [sym_infix_expression] = STATE(2168),
    [sym_ce_expression] = STATE(2168),
    [sym_sequential_expression] = STATE(2168),
    [sym_char] = STATE(2469),
    [sym_format_string] = STATE(2412),
    [sym__string_literal] = STATE(2412),
    [sym_string] = STATE(2469),
    [sym_verbatim_string] = STATE(2469),
    [sym_bytearray] = STATE(2469),
    [sym_verbatim_bytearray] = STATE(2469),
    [sym_format_triple_quoted_string] = STATE(2408),
    [sym_triple_quoted_string] = STATE(2469),
    [sym_const] = STATE(2168),
    [sym_long_identifier] = STATE(2183),
    [sym_active_pattern] = STATE(2182),
    [sym__identifier_or_op] = STATE(2093),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(650),
    [sym_infix_op] = STATE(721),
    [sym_sbyte] = STATE(2469),
    [sym_byte] = STATE(2469),
    [sym_int16] = STATE(2469),
    [sym_uint16] = STATE(2469),
    [sym_int32] = STATE(2469),
    [sym_uint32] = STATE(2469),
    [sym_nativeint] = STATE(2469),
    [sym_unativeint] = STATE(2469),
    [sym_int64] = STATE(2469),
    [sym_uint64] = STATE(2469),
    [sym_ieee32] = STATE(2469),
    [sym_ieee64] = STATE(2469),
    [sym_bignum] = STATE(2469),
    [sym_decimal] = STATE(2469),
    [sym_float] = STATE(1586),
    [sym_block_comment] = STATE(146),
    [sym_compiler_directive_decl] = STATE(146),
    [sym_fsi_directive_decl] = STATE(146),
    [sym_preproc_line] = STATE(146),
    [sym_preproc_if_in_expression] = STATE(2168),
    [aux_sym_sequential_expression_repeat1] = STATE(1755),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(989),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(991),
    [anon_sym_return] = ACTIONS(993),
    [anon_sym_do] = ACTIONS(995),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(997),
    [anon_sym_COMMA] = ACTIONS(999),
    [anon_sym_null] = ACTIONS(1001),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(991),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1003),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1005),
    [anon_sym_LBRACE] = ACTIONS(1007),
    [anon_sym_LT_AT] = ACTIONS(1009),
    [anon_sym_AT_GT] = ACTIONS(1179),
    [anon_sym_LT_AT_AT] = ACTIONS(1013),
    [anon_sym_DOT] = ACTIONS(1015),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1017),
    [anon_sym_new] = ACTIONS(993),
    [anon_sym_return_BANG] = ACTIONS(1019),
    [anon_sym_yield] = ACTIONS(993),
    [anon_sym_yield_BANG] = ACTIONS(1019),
    [anon_sym_lazy] = ACTIONS(993),
    [anon_sym_assert] = ACTIONS(993),
    [anon_sym_upcast] = ACTIONS(993),
    [anon_sym_downcast] = ACTIONS(993),
    [anon_sym_COLON_GT] = ACTIONS(1021),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1021),
    [anon_sym_for] = ACTIONS(1023),
    [anon_sym_while] = ACTIONS(1025),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(1027),
    [anon_sym_try] = ACTIONS(1029),
    [anon_sym_match] = ACTIONS(1031),
    [anon_sym_match_BANG] = ACTIONS(1033),
    [anon_sym_function] = ACTIONS(1035),
    [anon_sym_LT_DASH] = ACTIONS(1037),
    [anon_sym_DOT_LBRACK] = ACTIONS(1039),
    [anon_sym_LT] = ACTIONS(1041),
    [anon_sym_use] = ACTIONS(1043),
    [anon_sym_use_BANG] = ACTIONS(1045),
    [anon_sym_do_BANG] = ACTIONS(1047),
    [anon_sym_begin] = ACTIONS(1049),
    [anon_sym_LPAREN2] = ACTIONS(1051),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(1053),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1055),
    [anon_sym_DQUOTE] = ACTIONS(1057),
    [anon_sym_AT_DQUOTE] = ACTIONS(1059),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1061),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1063),
    [sym_bool] = ACTIONS(1065),
    [sym_unit] = ACTIONS(1067),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1069),
    [sym_op_identifier] = ACTIONS(1071),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(1073),
    [sym_xint] = ACTIONS(1075),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1077),
    [sym__newline] = ACTIONS(1079),
  },
  [147] = {
    [sym_function_or_value_defn] = STATE(630),
    [sym__expression] = STATE(219),
    [sym_literal_expression] = STATE(2380),
    [sym_long_identifier_or_op] = STATE(2380),
    [sym_tuple_expression] = STATE(2380),
    [sym_brace_expression] = STATE(2380),
    [sym_anon_record_expression] = STATE(2380),
    [sym_prefixed_expression] = STATE(2380),
    [sym_typecast_expression] = STATE(2380),
    [sym_for_expression] = STATE(2380),
    [sym_while_expression] = STATE(2380),
    [sym__if_branch] = STATE(6456),
    [sym_if_expression] = STATE(2380),
    [sym_fun_expression] = STATE(2380),
    [sym_try_expression] = STATE(2380),
    [sym_match_expression] = STATE(2380),
    [sym_function_expression] = STATE(2380),
    [sym_mutate_expression] = STATE(2380),
    [sym_index_expression] = STATE(2380),
    [sym_typed_expression] = STATE(2380),
    [sym_declaration_expression] = STATE(2380),
    [sym_do_expression] = STATE(2380),
    [sym_list_expression] = STATE(2380),
    [sym_array_expression] = STATE(2380),
    [sym_begin_end_expression] = STATE(2380),
    [sym_paren_expression] = STATE(2380),
    [sym__high_prec_app] = STATE(2383),
    [sym__low_prec_app] = STATE(2383),
    [sym_application_expression] = STATE(2380),
    [sym_dot_expression] = STATE(2380),
    [sym_infix_expression] = STATE(2380),
    [sym_ce_expression] = STATE(2380),
    [sym_sequential_expression] = STATE(2380),
    [sym_char] = STATE(2261),
    [sym_format_string] = STATE(2274),
    [sym__string_literal] = STATE(2274),
    [sym_string] = STATE(2261),
    [sym_verbatim_string] = STATE(2261),
    [sym_bytearray] = STATE(2261),
    [sym_verbatim_bytearray] = STATE(2261),
    [sym_format_triple_quoted_string] = STATE(2275),
    [sym_triple_quoted_string] = STATE(2261),
    [sym_const] = STATE(2380),
    [sym_long_identifier] = STATE(2391),
    [sym_active_pattern] = STATE(2470),
    [sym__identifier_or_op] = STATE(2390),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(632),
    [sym_infix_op] = STATE(616),
    [sym_sbyte] = STATE(2261),
    [sym_byte] = STATE(2261),
    [sym_int16] = STATE(2261),
    [sym_uint16] = STATE(2261),
    [sym_int32] = STATE(2261),
    [sym_uint32] = STATE(2261),
    [sym_nativeint] = STATE(2261),
    [sym_unativeint] = STATE(2261),
    [sym_int64] = STATE(2261),
    [sym_uint64] = STATE(2261),
    [sym_ieee32] = STATE(2261),
    [sym_ieee64] = STATE(2261),
    [sym_bignum] = STATE(2261),
    [sym_decimal] = STATE(2261),
    [sym_float] = STATE(1614),
    [sym_block_comment] = STATE(147),
    [sym_compiler_directive_decl] = STATE(147),
    [sym_fsi_directive_decl] = STATE(147),
    [sym_preproc_line] = STATE(147),
    [sym_preproc_if_in_expression] = STATE(2380),
    [aux_sym_sequential_expression_repeat1] = STATE(1882),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(1081),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(1083),
    [anon_sym_return] = ACTIONS(1085),
    [anon_sym_do] = ACTIONS(1087),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(1089),
    [anon_sym_COMMA] = ACTIONS(1091),
    [anon_sym_null] = ACTIONS(1093),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(1083),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1095),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1097),
    [anon_sym_LBRACE] = ACTIONS(1099),
    [anon_sym_LT_AT] = ACTIONS(1101),
    [anon_sym_LT_AT_AT] = ACTIONS(1103),
    [anon_sym_AT_AT_GT] = ACTIONS(1179),
    [anon_sym_DOT] = ACTIONS(1105),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1107),
    [anon_sym_new] = ACTIONS(1085),
    [anon_sym_return_BANG] = ACTIONS(1109),
    [anon_sym_yield] = ACTIONS(1085),
    [anon_sym_yield_BANG] = ACTIONS(1109),
    [anon_sym_lazy] = ACTIONS(1085),
    [anon_sym_assert] = ACTIONS(1085),
    [anon_sym_upcast] = ACTIONS(1085),
    [anon_sym_downcast] = ACTIONS(1085),
    [anon_sym_COLON_GT] = ACTIONS(1111),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1111),
    [anon_sym_for] = ACTIONS(1113),
    [anon_sym_while] = ACTIONS(1115),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(1117),
    [anon_sym_try] = ACTIONS(1119),
    [anon_sym_match] = ACTIONS(1121),
    [anon_sym_match_BANG] = ACTIONS(1123),
    [anon_sym_function] = ACTIONS(1125),
    [anon_sym_LT_DASH] = ACTIONS(1127),
    [anon_sym_DOT_LBRACK] = ACTIONS(1129),
    [anon_sym_LT] = ACTIONS(1131),
    [anon_sym_use] = ACTIONS(1133),
    [anon_sym_use_BANG] = ACTIONS(1135),
    [anon_sym_do_BANG] = ACTIONS(1137),
    [anon_sym_begin] = ACTIONS(1139),
    [anon_sym_LPAREN2] = ACTIONS(1141),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(1143),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1145),
    [anon_sym_DQUOTE] = ACTIONS(1147),
    [anon_sym_AT_DQUOTE] = ACTIONS(1149),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1151),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1153),
    [sym_bool] = ACTIONS(1155),
    [sym_unit] = ACTIONS(1157),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1159),
    [sym_op_identifier] = ACTIONS(1161),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(1163),
    [sym_xint] = ACTIONS(1165),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1167),
    [sym__newline] = ACTIONS(1169),
  },
  [148] = {
    [sym_function_or_value_defn] = STATE(600),
    [sym__expression] = STATE(88),
    [sym_literal_expression] = STATE(867),
    [sym_long_identifier_or_op] = STATE(867),
    [sym_tuple_expression] = STATE(867),
    [sym_brace_expression] = STATE(867),
    [sym_anon_record_expression] = STATE(867),
    [sym_prefixed_expression] = STATE(867),
    [sym_typecast_expression] = STATE(867),
    [sym_for_expression] = STATE(867),
    [sym_while_expression] = STATE(867),
    [sym__if_branch] = STATE(6511),
    [sym_if_expression] = STATE(867),
    [sym_fun_expression] = STATE(867),
    [sym_try_expression] = STATE(867),
    [sym_match_expression] = STATE(867),
    [sym_function_expression] = STATE(867),
    [sym_mutate_expression] = STATE(867),
    [sym_index_expression] = STATE(867),
    [sym_typed_expression] = STATE(867),
    [sym_declaration_expression] = STATE(867),
    [sym_do_expression] = STATE(867),
    [sym_list_expression] = STATE(867),
    [sym_array_expression] = STATE(867),
    [sym_begin_end_expression] = STATE(867),
    [sym_paren_expression] = STATE(867),
    [sym__high_prec_app] = STATE(864),
    [sym__low_prec_app] = STATE(864),
    [sym_application_expression] = STATE(867),
    [sym_dot_expression] = STATE(867),
    [sym_infix_expression] = STATE(867),
    [sym_ce_expression] = STATE(867),
    [sym_sequential_expression] = STATE(867),
    [sym_char] = STATE(868),
    [sym_format_string] = STATE(869),
    [sym__string_literal] = STATE(869),
    [sym_string] = STATE(868),
    [sym_verbatim_string] = STATE(868),
    [sym_bytearray] = STATE(868),
    [sym_verbatim_bytearray] = STATE(868),
    [sym_format_triple_quoted_string] = STATE(870),
    [sym_triple_quoted_string] = STATE(868),
    [sym_const] = STATE(867),
    [sym_long_identifier] = STATE(872),
    [sym_active_pattern] = STATE(871),
    [sym__identifier_or_op] = STATE(873),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(656),
    [sym_infix_op] = STATE(581),
    [sym_sbyte] = STATE(868),
    [sym_byte] = STATE(868),
    [sym_int16] = STATE(868),
    [sym_uint16] = STATE(868),
    [sym_int32] = STATE(868),
    [sym_uint32] = STATE(868),
    [sym_nativeint] = STATE(868),
    [sym_unativeint] = STATE(868),
    [sym_int64] = STATE(868),
    [sym_uint64] = STATE(868),
    [sym_ieee32] = STATE(868),
    [sym_ieee64] = STATE(868),
    [sym_bignum] = STATE(868),
    [sym_decimal] = STATE(868),
    [sym_float] = STATE(1368),
    [sym_block_comment] = STATE(148),
    [sym_compiler_directive_decl] = STATE(148),
    [sym_fsi_directive_decl] = STATE(148),
    [sym_preproc_line] = STATE(148),
    [sym_preproc_if_in_expression] = STATE(867),
    [aux_sym_sequential_expression_repeat1] = STATE(1542),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(29),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(825),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_COMMA] = ACTIONS(827),
    [anon_sym_null] = ACTIONS(49),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACK_PIPE] = ACTIONS(57),
    [anon_sym_LBRACE] = ACTIONS(139),
    [anon_sym_LT_AT] = ACTIONS(61),
    [anon_sym_LT_AT_AT] = ACTIONS(63),
    [anon_sym_DOT] = ACTIONS(65),
    [anon_sym_LBRACE_PIPE] = ACTIONS(67),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_return_BANG] = ACTIONS(829),
    [anon_sym_yield] = ACTIONS(825),
    [anon_sym_yield_BANG] = ACTIONS(829),
    [anon_sym_lazy] = ACTIONS(825),
    [anon_sym_assert] = ACTIONS(825),
    [anon_sym_upcast] = ACTIONS(825),
    [anon_sym_downcast] = ACTIONS(825),
    [anon_sym_COLON_GT] = ACTIONS(71),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(71),
    [anon_sym_for] = ACTIONS(73),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(79),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_match] = ACTIONS(83),
    [anon_sym_match_BANG] = ACTIONS(85),
    [anon_sym_function] = ACTIONS(87),
    [anon_sym_LT_DASH] = ACTIONS(831),
    [anon_sym_DOT_LBRACK] = ACTIONS(91),
    [anon_sym_LT] = ACTIONS(93),
    [anon_sym_use] = ACTIONS(833),
    [anon_sym_use_BANG] = ACTIONS(835),
    [anon_sym_do_BANG] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(101),
    [anon_sym_LPAREN2] = ACTIONS(103),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(105),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(107),
    [anon_sym_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DQUOTE] = ACTIONS(111),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(115),
    [sym_bool] = ACTIONS(117),
    [sym_unit] = ACTIONS(119),
    [anon_sym_LPAREN_PIPE] = ACTIONS(121),
    [sym_op_identifier] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(837),
    [sym_xint] = ACTIONS(387),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(135),
    [sym__newline] = ACTIONS(839),
    [sym__dedent] = ACTIONS(1181),
  },
  [149] = {
    [sym_function_or_value_defn] = STATE(627),
    [sym__expression] = STATE(17),
    [sym_literal_expression] = STATE(1118),
    [sym_long_identifier_or_op] = STATE(1118),
    [sym_tuple_expression] = STATE(1118),
    [sym_brace_expression] = STATE(1118),
    [sym_anon_record_expression] = STATE(1118),
    [sym_prefixed_expression] = STATE(1118),
    [sym_typecast_expression] = STATE(1118),
    [sym_for_expression] = STATE(1118),
    [sym_while_expression] = STATE(1118),
    [sym__if_branch] = STATE(7163),
    [sym_if_expression] = STATE(1118),
    [sym_fun_expression] = STATE(1118),
    [sym_try_expression] = STATE(1118),
    [sym_match_expression] = STATE(1118),
    [sym_function_expression] = STATE(1118),
    [sym_mutate_expression] = STATE(1118),
    [sym_index_expression] = STATE(1118),
    [sym_typed_expression] = STATE(1118),
    [sym_declaration_expression] = STATE(1118),
    [sym_do_expression] = STATE(1118),
    [sym_list_expression] = STATE(1118),
    [sym_array_expression] = STATE(1118),
    [sym_begin_end_expression] = STATE(1118),
    [sym_paren_expression] = STATE(1118),
    [sym__high_prec_app] = STATE(1133),
    [sym__low_prec_app] = STATE(1133),
    [sym_application_expression] = STATE(1118),
    [sym_dot_expression] = STATE(1118),
    [sym_infix_expression] = STATE(1118),
    [sym_ce_expression] = STATE(1118),
    [sym_sequential_expression] = STATE(1118),
    [sym_char] = STATE(1080),
    [sym_format_string] = STATE(1090),
    [sym__string_literal] = STATE(1090),
    [sym_string] = STATE(1080),
    [sym_verbatim_string] = STATE(1080),
    [sym_bytearray] = STATE(1080),
    [sym_verbatim_bytearray] = STATE(1080),
    [sym_format_triple_quoted_string] = STATE(1096),
    [sym_triple_quoted_string] = STATE(1080),
    [sym_const] = STATE(1118),
    [sym_long_identifier] = STATE(1156),
    [sym_active_pattern] = STATE(1085),
    [sym__identifier_or_op] = STATE(1099),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(517),
    [sym_infix_op] = STATE(487),
    [sym_sbyte] = STATE(1080),
    [sym_byte] = STATE(1080),
    [sym_int16] = STATE(1080),
    [sym_uint16] = STATE(1080),
    [sym_int32] = STATE(1080),
    [sym_uint32] = STATE(1080),
    [sym_nativeint] = STATE(1080),
    [sym_unativeint] = STATE(1080),
    [sym_int64] = STATE(1080),
    [sym_uint64] = STATE(1080),
    [sym_ieee32] = STATE(1080),
    [sym_ieee64] = STATE(1080),
    [sym_bignum] = STATE(1080),
    [sym_decimal] = STATE(1080),
    [sym_float] = STATE(979),
    [sym_block_comment] = STATE(149),
    [sym_compiler_directive_decl] = STATE(149),
    [sym_fsi_directive_decl] = STATE(149),
    [sym_preproc_line] = STATE(149),
    [sym_preproc_if_in_expression] = STATE(1118),
    [aux_sym_sequential_expression_repeat1] = STATE(1069),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(195),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(197),
    [anon_sym_return] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_COMMA] = ACTIONS(205),
    [anon_sym_null] = ACTIONS(207),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(197),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(209),
    [anon_sym_LBRACK_PIPE] = ACTIONS(211),
    [anon_sym_LBRACE] = ACTIONS(271),
    [anon_sym_LT_AT] = ACTIONS(213),
    [anon_sym_LT_AT_AT] = ACTIONS(215),
    [anon_sym_DOT] = ACTIONS(185),
    [anon_sym_LBRACE_PIPE] = ACTIONS(217),
    [anon_sym_new] = ACTIONS(199),
    [anon_sym_with] = ACTIONS(1183),
    [anon_sym_return_BANG] = ACTIONS(219),
    [anon_sym_yield] = ACTIONS(199),
    [anon_sym_yield_BANG] = ACTIONS(219),
    [anon_sym_lazy] = ACTIONS(199),
    [anon_sym_assert] = ACTIONS(199),
    [anon_sym_upcast] = ACTIONS(199),
    [anon_sym_downcast] = ACTIONS(199),
    [anon_sym_COLON_GT] = ACTIONS(221),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(221),
    [anon_sym_for] = ACTIONS(223),
    [anon_sym_while] = ACTIONS(225),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(229),
    [anon_sym_match] = ACTIONS(231),
    [anon_sym_match_BANG] = ACTIONS(233),
    [anon_sym_function] = ACTIONS(235),
    [anon_sym_LT_DASH] = ACTIONS(237),
    [anon_sym_DOT_LBRACK] = ACTIONS(187),
    [anon_sym_LT] = ACTIONS(189),
    [anon_sym_use] = ACTIONS(239),
    [anon_sym_use_BANG] = ACTIONS(241),
    [anon_sym_do_BANG] = ACTIONS(243),
    [anon_sym_begin] = ACTIONS(245),
    [anon_sym_LPAREN2] = ACTIONS(191),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(247),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(251),
    [anon_sym_AT_DQUOTE] = ACTIONS(253),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(255),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(257),
    [sym_bool] = ACTIONS(259),
    [sym_unit] = ACTIONS(193),
    [anon_sym_LPAREN_PIPE] = ACTIONS(261),
    [sym_op_identifier] = ACTIONS(263),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(265),
    [sym_xint] = ACTIONS(267),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(269),
    [sym__newline] = ACTIONS(1185),
  },
  [150] = {
    [sym_function_or_value_defn] = STATE(651),
    [sym__expression] = STATE(167),
    [sym_literal_expression] = STATE(2168),
    [sym_long_identifier_or_op] = STATE(2168),
    [sym_tuple_expression] = STATE(2168),
    [sym_brace_expression] = STATE(2168),
    [sym_anon_record_expression] = STATE(2168),
    [sym_prefixed_expression] = STATE(2168),
    [sym_typecast_expression] = STATE(2168),
    [sym_for_expression] = STATE(2168),
    [sym_while_expression] = STATE(2168),
    [sym__if_branch] = STATE(6406),
    [sym_if_expression] = STATE(2168),
    [sym_fun_expression] = STATE(2168),
    [sym_try_expression] = STATE(2168),
    [sym_match_expression] = STATE(2168),
    [sym_function_expression] = STATE(2168),
    [sym_mutate_expression] = STATE(2168),
    [sym_index_expression] = STATE(2168),
    [sym_typed_expression] = STATE(2168),
    [sym_declaration_expression] = STATE(2168),
    [sym_do_expression] = STATE(2168),
    [sym_list_expression] = STATE(2168),
    [sym_array_expression] = STATE(2168),
    [sym_begin_end_expression] = STATE(2168),
    [sym_paren_expression] = STATE(2168),
    [sym__high_prec_app] = STATE(2179),
    [sym__low_prec_app] = STATE(2179),
    [sym_application_expression] = STATE(2168),
    [sym_dot_expression] = STATE(2168),
    [sym_infix_expression] = STATE(2168),
    [sym_ce_expression] = STATE(2168),
    [sym_sequential_expression] = STATE(2168),
    [sym_char] = STATE(2469),
    [sym_format_string] = STATE(2412),
    [sym__string_literal] = STATE(2412),
    [sym_string] = STATE(2469),
    [sym_verbatim_string] = STATE(2469),
    [sym_bytearray] = STATE(2469),
    [sym_verbatim_bytearray] = STATE(2469),
    [sym_format_triple_quoted_string] = STATE(2408),
    [sym_triple_quoted_string] = STATE(2469),
    [sym_const] = STATE(2168),
    [sym_long_identifier] = STATE(2183),
    [sym_active_pattern] = STATE(2182),
    [sym__identifier_or_op] = STATE(2093),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(650),
    [sym_infix_op] = STATE(721),
    [sym_sbyte] = STATE(2469),
    [sym_byte] = STATE(2469),
    [sym_int16] = STATE(2469),
    [sym_uint16] = STATE(2469),
    [sym_int32] = STATE(2469),
    [sym_uint32] = STATE(2469),
    [sym_nativeint] = STATE(2469),
    [sym_unativeint] = STATE(2469),
    [sym_int64] = STATE(2469),
    [sym_uint64] = STATE(2469),
    [sym_ieee32] = STATE(2469),
    [sym_ieee64] = STATE(2469),
    [sym_bignum] = STATE(2469),
    [sym_decimal] = STATE(2469),
    [sym_float] = STATE(1586),
    [sym_block_comment] = STATE(150),
    [sym_compiler_directive_decl] = STATE(150),
    [sym_fsi_directive_decl] = STATE(150),
    [sym_preproc_line] = STATE(150),
    [sym_preproc_if_in_expression] = STATE(2168),
    [aux_sym_sequential_expression_repeat1] = STATE(1755),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(989),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(991),
    [anon_sym_return] = ACTIONS(993),
    [anon_sym_do] = ACTIONS(995),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(997),
    [anon_sym_COMMA] = ACTIONS(999),
    [anon_sym_null] = ACTIONS(1001),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(991),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1003),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1005),
    [anon_sym_LBRACE] = ACTIONS(1007),
    [anon_sym_LT_AT] = ACTIONS(1009),
    [anon_sym_AT_GT] = ACTIONS(1187),
    [anon_sym_LT_AT_AT] = ACTIONS(1013),
    [anon_sym_DOT] = ACTIONS(1015),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1017),
    [anon_sym_new] = ACTIONS(993),
    [anon_sym_return_BANG] = ACTIONS(1019),
    [anon_sym_yield] = ACTIONS(993),
    [anon_sym_yield_BANG] = ACTIONS(1019),
    [anon_sym_lazy] = ACTIONS(993),
    [anon_sym_assert] = ACTIONS(993),
    [anon_sym_upcast] = ACTIONS(993),
    [anon_sym_downcast] = ACTIONS(993),
    [anon_sym_COLON_GT] = ACTIONS(1021),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1021),
    [anon_sym_for] = ACTIONS(1023),
    [anon_sym_while] = ACTIONS(1025),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(1027),
    [anon_sym_try] = ACTIONS(1029),
    [anon_sym_match] = ACTIONS(1031),
    [anon_sym_match_BANG] = ACTIONS(1033),
    [anon_sym_function] = ACTIONS(1035),
    [anon_sym_LT_DASH] = ACTIONS(1037),
    [anon_sym_DOT_LBRACK] = ACTIONS(1039),
    [anon_sym_LT] = ACTIONS(1041),
    [anon_sym_use] = ACTIONS(1043),
    [anon_sym_use_BANG] = ACTIONS(1045),
    [anon_sym_do_BANG] = ACTIONS(1047),
    [anon_sym_begin] = ACTIONS(1049),
    [anon_sym_LPAREN2] = ACTIONS(1051),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(1053),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1055),
    [anon_sym_DQUOTE] = ACTIONS(1057),
    [anon_sym_AT_DQUOTE] = ACTIONS(1059),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1061),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1063),
    [sym_bool] = ACTIONS(1065),
    [sym_unit] = ACTIONS(1067),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1069),
    [sym_op_identifier] = ACTIONS(1071),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(1073),
    [sym_xint] = ACTIONS(1075),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1077),
    [sym__newline] = ACTIONS(1079),
  },
  [151] = {
    [sym_function_or_value_defn] = STATE(630),
    [sym__expression] = STATE(219),
    [sym_literal_expression] = STATE(2380),
    [sym_long_identifier_or_op] = STATE(2380),
    [sym_tuple_expression] = STATE(2380),
    [sym_brace_expression] = STATE(2380),
    [sym_anon_record_expression] = STATE(2380),
    [sym_prefixed_expression] = STATE(2380),
    [sym_typecast_expression] = STATE(2380),
    [sym_for_expression] = STATE(2380),
    [sym_while_expression] = STATE(2380),
    [sym__if_branch] = STATE(6456),
    [sym_if_expression] = STATE(2380),
    [sym_fun_expression] = STATE(2380),
    [sym_try_expression] = STATE(2380),
    [sym_match_expression] = STATE(2380),
    [sym_function_expression] = STATE(2380),
    [sym_mutate_expression] = STATE(2380),
    [sym_index_expression] = STATE(2380),
    [sym_typed_expression] = STATE(2380),
    [sym_declaration_expression] = STATE(2380),
    [sym_do_expression] = STATE(2380),
    [sym_list_expression] = STATE(2380),
    [sym_array_expression] = STATE(2380),
    [sym_begin_end_expression] = STATE(2380),
    [sym_paren_expression] = STATE(2380),
    [sym__high_prec_app] = STATE(2383),
    [sym__low_prec_app] = STATE(2383),
    [sym_application_expression] = STATE(2380),
    [sym_dot_expression] = STATE(2380),
    [sym_infix_expression] = STATE(2380),
    [sym_ce_expression] = STATE(2380),
    [sym_sequential_expression] = STATE(2380),
    [sym_char] = STATE(2261),
    [sym_format_string] = STATE(2274),
    [sym__string_literal] = STATE(2274),
    [sym_string] = STATE(2261),
    [sym_verbatim_string] = STATE(2261),
    [sym_bytearray] = STATE(2261),
    [sym_verbatim_bytearray] = STATE(2261),
    [sym_format_triple_quoted_string] = STATE(2275),
    [sym_triple_quoted_string] = STATE(2261),
    [sym_const] = STATE(2380),
    [sym_long_identifier] = STATE(2391),
    [sym_active_pattern] = STATE(2470),
    [sym__identifier_or_op] = STATE(2390),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(632),
    [sym_infix_op] = STATE(616),
    [sym_sbyte] = STATE(2261),
    [sym_byte] = STATE(2261),
    [sym_int16] = STATE(2261),
    [sym_uint16] = STATE(2261),
    [sym_int32] = STATE(2261),
    [sym_uint32] = STATE(2261),
    [sym_nativeint] = STATE(2261),
    [sym_unativeint] = STATE(2261),
    [sym_int64] = STATE(2261),
    [sym_uint64] = STATE(2261),
    [sym_ieee32] = STATE(2261),
    [sym_ieee64] = STATE(2261),
    [sym_bignum] = STATE(2261),
    [sym_decimal] = STATE(2261),
    [sym_float] = STATE(1614),
    [sym_block_comment] = STATE(151),
    [sym_compiler_directive_decl] = STATE(151),
    [sym_fsi_directive_decl] = STATE(151),
    [sym_preproc_line] = STATE(151),
    [sym_preproc_if_in_expression] = STATE(2380),
    [aux_sym_sequential_expression_repeat1] = STATE(1882),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(1081),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(1083),
    [anon_sym_return] = ACTIONS(1085),
    [anon_sym_do] = ACTIONS(1087),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(1089),
    [anon_sym_COMMA] = ACTIONS(1091),
    [anon_sym_null] = ACTIONS(1093),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(1083),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1095),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1097),
    [anon_sym_LBRACE] = ACTIONS(1099),
    [anon_sym_LT_AT] = ACTIONS(1101),
    [anon_sym_LT_AT_AT] = ACTIONS(1103),
    [anon_sym_AT_AT_GT] = ACTIONS(1187),
    [anon_sym_DOT] = ACTIONS(1105),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1107),
    [anon_sym_new] = ACTIONS(1085),
    [anon_sym_return_BANG] = ACTIONS(1109),
    [anon_sym_yield] = ACTIONS(1085),
    [anon_sym_yield_BANG] = ACTIONS(1109),
    [anon_sym_lazy] = ACTIONS(1085),
    [anon_sym_assert] = ACTIONS(1085),
    [anon_sym_upcast] = ACTIONS(1085),
    [anon_sym_downcast] = ACTIONS(1085),
    [anon_sym_COLON_GT] = ACTIONS(1111),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1111),
    [anon_sym_for] = ACTIONS(1113),
    [anon_sym_while] = ACTIONS(1115),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(1117),
    [anon_sym_try] = ACTIONS(1119),
    [anon_sym_match] = ACTIONS(1121),
    [anon_sym_match_BANG] = ACTIONS(1123),
    [anon_sym_function] = ACTIONS(1125),
    [anon_sym_LT_DASH] = ACTIONS(1127),
    [anon_sym_DOT_LBRACK] = ACTIONS(1129),
    [anon_sym_LT] = ACTIONS(1131),
    [anon_sym_use] = ACTIONS(1133),
    [anon_sym_use_BANG] = ACTIONS(1135),
    [anon_sym_do_BANG] = ACTIONS(1137),
    [anon_sym_begin] = ACTIONS(1139),
    [anon_sym_LPAREN2] = ACTIONS(1141),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(1143),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1145),
    [anon_sym_DQUOTE] = ACTIONS(1147),
    [anon_sym_AT_DQUOTE] = ACTIONS(1149),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1151),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1153),
    [sym_bool] = ACTIONS(1155),
    [sym_unit] = ACTIONS(1157),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1159),
    [sym_op_identifier] = ACTIONS(1161),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(1163),
    [sym_xint] = ACTIONS(1165),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1167),
    [sym__newline] = ACTIONS(1169),
  },
  [152] = {
    [sym_function_or_value_defn] = STATE(733),
    [sym__expression] = STATE(142),
    [sym_literal_expression] = STATE(2008),
    [sym_long_identifier_or_op] = STATE(2008),
    [sym_tuple_expression] = STATE(2008),
    [sym_brace_expression] = STATE(2008),
    [sym_anon_record_expression] = STATE(2008),
    [sym_prefixed_expression] = STATE(2008),
    [sym_typecast_expression] = STATE(2008),
    [sym_for_expression] = STATE(2008),
    [sym_while_expression] = STATE(2008),
    [sym__if_branch] = STATE(6754),
    [sym_if_expression] = STATE(2008),
    [sym_fun_expression] = STATE(2008),
    [sym_try_expression] = STATE(2008),
    [sym_match_expression] = STATE(2008),
    [sym_function_expression] = STATE(2008),
    [sym_mutate_expression] = STATE(2008),
    [sym_index_expression] = STATE(2008),
    [sym_typed_expression] = STATE(2008),
    [sym_declaration_expression] = STATE(2008),
    [sym_do_expression] = STATE(2008),
    [sym_list_expression] = STATE(2008),
    [sym_array_expression] = STATE(2008),
    [sym_begin_end_expression] = STATE(2008),
    [sym_paren_expression] = STATE(2008),
    [sym__high_prec_app] = STATE(2007),
    [sym__low_prec_app] = STATE(2007),
    [sym_application_expression] = STATE(2008),
    [sym_dot_expression] = STATE(2008),
    [sym_infix_expression] = STATE(2008),
    [sym_ce_expression] = STATE(2008),
    [sym_sequential_expression] = STATE(2008),
    [sym_char] = STATE(1859),
    [sym_format_string] = STATE(1861),
    [sym__string_literal] = STATE(1861),
    [sym_string] = STATE(1859),
    [sym_verbatim_string] = STATE(1859),
    [sym_bytearray] = STATE(1859),
    [sym_verbatim_bytearray] = STATE(1859),
    [sym_format_triple_quoted_string] = STATE(1862),
    [sym_triple_quoted_string] = STATE(1859),
    [sym_const] = STATE(2008),
    [sym_long_identifier] = STATE(1701),
    [sym_active_pattern] = STATE(1702),
    [sym__identifier_or_op] = STATE(1724),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(706),
    [sym_infix_op] = STATE(678),
    [sym_sbyte] = STATE(1859),
    [sym_byte] = STATE(1859),
    [sym_int16] = STATE(1859),
    [sym_uint16] = STATE(1859),
    [sym_int32] = STATE(1859),
    [sym_uint32] = STATE(1859),
    [sym_nativeint] = STATE(1859),
    [sym_unativeint] = STATE(1859),
    [sym_int64] = STATE(1859),
    [sym_uint64] = STATE(1859),
    [sym_ieee32] = STATE(1859),
    [sym_ieee64] = STATE(1859),
    [sym_bignum] = STATE(1859),
    [sym_decimal] = STATE(1859),
    [sym_float] = STATE(1447),
    [sym_block_comment] = STATE(152),
    [sym_compiler_directive_decl] = STATE(152),
    [sym_fsi_directive_decl] = STATE(152),
    [sym_preproc_line] = STATE(152),
    [sym_preproc_if_in_expression] = STATE(2008),
    [aux_sym_sequential_expression_repeat1] = STATE(1995),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(503),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(969),
    [anon_sym_return] = ACTIONS(971),
    [anon_sym_do] = ACTIONS(599),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(511),
    [anon_sym_COMMA] = ACTIONS(973),
    [anon_sym_null] = ACTIONS(515),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(969),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(517),
    [anon_sym_LBRACK_PIPE] = ACTIONS(519),
    [anon_sym_LBRACE] = ACTIONS(521),
    [anon_sym_LT_AT] = ACTIONS(523),
    [anon_sym_LT_AT_AT] = ACTIONS(525),
    [anon_sym_DOT] = ACTIONS(527),
    [anon_sym_LBRACE_PIPE] = ACTIONS(529),
    [anon_sym_new] = ACTIONS(971),
    [anon_sym_return_BANG] = ACTIONS(975),
    [anon_sym_yield] = ACTIONS(971),
    [anon_sym_yield_BANG] = ACTIONS(975),
    [anon_sym_lazy] = ACTIONS(971),
    [anon_sym_assert] = ACTIONS(971),
    [anon_sym_upcast] = ACTIONS(971),
    [anon_sym_downcast] = ACTIONS(971),
    [anon_sym_COLON_GT] = ACTIONS(977),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(977),
    [anon_sym_for] = ACTIONS(979),
    [anon_sym_while] = ACTIONS(537),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(539),
    [anon_sym_DASH_GT] = ACTIONS(151),
    [anon_sym_try] = ACTIONS(543),
    [anon_sym_match] = ACTIONS(545),
    [anon_sym_match_BANG] = ACTIONS(547),
    [anon_sym_function] = ACTIONS(549),
    [anon_sym_LT_DASH] = ACTIONS(981),
    [anon_sym_DOT_LBRACK] = ACTIONS(553),
    [anon_sym_LT] = ACTIONS(555),
    [anon_sym_use] = ACTIONS(983),
    [anon_sym_use_BANG] = ACTIONS(985),
    [anon_sym_do_BANG] = ACTIONS(561),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_LPAREN2] = ACTIONS(567),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(569),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(571),
    [anon_sym_DQUOTE] = ACTIONS(573),
    [anon_sym_AT_DQUOTE] = ACTIONS(575),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(577),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(579),
    [sym_bool] = ACTIONS(581),
    [sym_unit] = ACTIONS(583),
    [anon_sym_LPAREN_PIPE] = ACTIONS(585),
    [sym_op_identifier] = ACTIONS(587),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(591),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(593),
    [sym__newline] = ACTIONS(1171),
  },
  [153] = {
    [sym_function_or_value_defn] = STATE(733),
    [sym__expression] = STATE(142),
    [sym_literal_expression] = STATE(2008),
    [sym_long_identifier_or_op] = STATE(2008),
    [sym_tuple_expression] = STATE(2008),
    [sym_brace_expression] = STATE(2008),
    [sym_anon_record_expression] = STATE(2008),
    [sym_prefixed_expression] = STATE(2008),
    [sym_typecast_expression] = STATE(2008),
    [sym_for_expression] = STATE(2008),
    [sym_while_expression] = STATE(2008),
    [sym__if_branch] = STATE(6754),
    [sym_if_expression] = STATE(2008),
    [sym_fun_expression] = STATE(2008),
    [sym_try_expression] = STATE(2008),
    [sym_match_expression] = STATE(2008),
    [sym_function_expression] = STATE(2008),
    [sym_mutate_expression] = STATE(2008),
    [sym_index_expression] = STATE(2008),
    [sym_typed_expression] = STATE(2008),
    [sym_declaration_expression] = STATE(2008),
    [sym_do_expression] = STATE(2008),
    [sym_list_expression] = STATE(2008),
    [sym_array_expression] = STATE(2008),
    [sym_begin_end_expression] = STATE(2008),
    [sym_paren_expression] = STATE(2008),
    [sym__high_prec_app] = STATE(2007),
    [sym__low_prec_app] = STATE(2007),
    [sym_application_expression] = STATE(2008),
    [sym_dot_expression] = STATE(2008),
    [sym_infix_expression] = STATE(2008),
    [sym_ce_expression] = STATE(2008),
    [sym_sequential_expression] = STATE(2008),
    [sym_char] = STATE(1859),
    [sym_format_string] = STATE(1861),
    [sym__string_literal] = STATE(1861),
    [sym_string] = STATE(1859),
    [sym_verbatim_string] = STATE(1859),
    [sym_bytearray] = STATE(1859),
    [sym_verbatim_bytearray] = STATE(1859),
    [sym_format_triple_quoted_string] = STATE(1862),
    [sym_triple_quoted_string] = STATE(1859),
    [sym_const] = STATE(2008),
    [sym_long_identifier] = STATE(1701),
    [sym_active_pattern] = STATE(1702),
    [sym__identifier_or_op] = STATE(1724),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(706),
    [sym_infix_op] = STATE(678),
    [sym_sbyte] = STATE(1859),
    [sym_byte] = STATE(1859),
    [sym_int16] = STATE(1859),
    [sym_uint16] = STATE(1859),
    [sym_int32] = STATE(1859),
    [sym_uint32] = STATE(1859),
    [sym_nativeint] = STATE(1859),
    [sym_unativeint] = STATE(1859),
    [sym_int64] = STATE(1859),
    [sym_uint64] = STATE(1859),
    [sym_ieee32] = STATE(1859),
    [sym_ieee64] = STATE(1859),
    [sym_bignum] = STATE(1859),
    [sym_decimal] = STATE(1859),
    [sym_float] = STATE(1447),
    [sym_block_comment] = STATE(153),
    [sym_compiler_directive_decl] = STATE(153),
    [sym_fsi_directive_decl] = STATE(153),
    [sym_preproc_line] = STATE(153),
    [sym_preproc_if_in_expression] = STATE(2008),
    [aux_sym_sequential_expression_repeat1] = STATE(1995),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(503),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(969),
    [anon_sym_return] = ACTIONS(971),
    [anon_sym_do] = ACTIONS(599),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(511),
    [anon_sym_COMMA] = ACTIONS(973),
    [anon_sym_null] = ACTIONS(515),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(969),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(517),
    [anon_sym_LBRACK_PIPE] = ACTIONS(519),
    [anon_sym_LBRACE] = ACTIONS(521),
    [anon_sym_LT_AT] = ACTIONS(523),
    [anon_sym_LT_AT_AT] = ACTIONS(525),
    [anon_sym_DOT] = ACTIONS(527),
    [anon_sym_LBRACE_PIPE] = ACTIONS(529),
    [anon_sym_new] = ACTIONS(971),
    [anon_sym_return_BANG] = ACTIONS(975),
    [anon_sym_yield] = ACTIONS(971),
    [anon_sym_yield_BANG] = ACTIONS(975),
    [anon_sym_lazy] = ACTIONS(971),
    [anon_sym_assert] = ACTIONS(971),
    [anon_sym_upcast] = ACTIONS(971),
    [anon_sym_downcast] = ACTIONS(971),
    [anon_sym_COLON_GT] = ACTIONS(977),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(977),
    [anon_sym_for] = ACTIONS(979),
    [anon_sym_while] = ACTIONS(537),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(539),
    [anon_sym_DASH_GT] = ACTIONS(147),
    [anon_sym_try] = ACTIONS(543),
    [anon_sym_match] = ACTIONS(545),
    [anon_sym_match_BANG] = ACTIONS(547),
    [anon_sym_function] = ACTIONS(549),
    [anon_sym_LT_DASH] = ACTIONS(981),
    [anon_sym_DOT_LBRACK] = ACTIONS(553),
    [anon_sym_LT] = ACTIONS(555),
    [anon_sym_use] = ACTIONS(983),
    [anon_sym_use_BANG] = ACTIONS(985),
    [anon_sym_do_BANG] = ACTIONS(561),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_LPAREN2] = ACTIONS(567),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(569),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(571),
    [anon_sym_DQUOTE] = ACTIONS(573),
    [anon_sym_AT_DQUOTE] = ACTIONS(575),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(577),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(579),
    [sym_bool] = ACTIONS(581),
    [sym_unit] = ACTIONS(583),
    [anon_sym_LPAREN_PIPE] = ACTIONS(585),
    [sym_op_identifier] = ACTIONS(587),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(591),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(593),
    [sym__newline] = ACTIONS(145),
  },
  [154] = {
    [sym_function_or_value_defn] = STATE(600),
    [sym__expression] = STATE(88),
    [sym_literal_expression] = STATE(867),
    [sym_long_identifier_or_op] = STATE(867),
    [sym_tuple_expression] = STATE(867),
    [sym_brace_expression] = STATE(867),
    [sym_anon_record_expression] = STATE(867),
    [sym_prefixed_expression] = STATE(867),
    [sym_typecast_expression] = STATE(867),
    [sym_for_expression] = STATE(867),
    [sym_while_expression] = STATE(867),
    [sym__if_branch] = STATE(6511),
    [sym_if_expression] = STATE(867),
    [sym_fun_expression] = STATE(867),
    [sym_try_expression] = STATE(867),
    [sym_match_expression] = STATE(867),
    [sym_function_expression] = STATE(867),
    [sym_mutate_expression] = STATE(867),
    [sym_index_expression] = STATE(867),
    [sym_typed_expression] = STATE(867),
    [sym_declaration_expression] = STATE(867),
    [sym_do_expression] = STATE(867),
    [sym_list_expression] = STATE(867),
    [sym_array_expression] = STATE(867),
    [sym_begin_end_expression] = STATE(867),
    [sym_paren_expression] = STATE(867),
    [sym__high_prec_app] = STATE(864),
    [sym__low_prec_app] = STATE(864),
    [sym_application_expression] = STATE(867),
    [sym_dot_expression] = STATE(867),
    [sym_infix_expression] = STATE(867),
    [sym_ce_expression] = STATE(867),
    [sym_sequential_expression] = STATE(867),
    [sym_char] = STATE(868),
    [sym_format_string] = STATE(869),
    [sym__string_literal] = STATE(869),
    [sym_string] = STATE(868),
    [sym_verbatim_string] = STATE(868),
    [sym_bytearray] = STATE(868),
    [sym_verbatim_bytearray] = STATE(868),
    [sym_format_triple_quoted_string] = STATE(870),
    [sym_triple_quoted_string] = STATE(868),
    [sym_const] = STATE(867),
    [sym_long_identifier] = STATE(872),
    [sym_active_pattern] = STATE(871),
    [sym__identifier_or_op] = STATE(873),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(656),
    [sym_infix_op] = STATE(581),
    [sym_sbyte] = STATE(868),
    [sym_byte] = STATE(868),
    [sym_int16] = STATE(868),
    [sym_uint16] = STATE(868),
    [sym_int32] = STATE(868),
    [sym_uint32] = STATE(868),
    [sym_nativeint] = STATE(868),
    [sym_unativeint] = STATE(868),
    [sym_int64] = STATE(868),
    [sym_uint64] = STATE(868),
    [sym_ieee32] = STATE(868),
    [sym_ieee64] = STATE(868),
    [sym_bignum] = STATE(868),
    [sym_decimal] = STATE(868),
    [sym_float] = STATE(1368),
    [sym_block_comment] = STATE(154),
    [sym_compiler_directive_decl] = STATE(154),
    [sym_fsi_directive_decl] = STATE(154),
    [sym_preproc_line] = STATE(154),
    [sym_preproc_if_in_expression] = STATE(867),
    [aux_sym_sequential_expression_repeat1] = STATE(1542),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(29),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(825),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_COMMA] = ACTIONS(827),
    [anon_sym_null] = ACTIONS(49),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACK_PIPE] = ACTIONS(57),
    [anon_sym_LBRACE] = ACTIONS(139),
    [anon_sym_LT_AT] = ACTIONS(61),
    [anon_sym_LT_AT_AT] = ACTIONS(63),
    [anon_sym_DOT] = ACTIONS(65),
    [anon_sym_LBRACE_PIPE] = ACTIONS(67),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_return_BANG] = ACTIONS(829),
    [anon_sym_yield] = ACTIONS(825),
    [anon_sym_yield_BANG] = ACTIONS(829),
    [anon_sym_lazy] = ACTIONS(825),
    [anon_sym_assert] = ACTIONS(825),
    [anon_sym_upcast] = ACTIONS(825),
    [anon_sym_downcast] = ACTIONS(825),
    [anon_sym_COLON_GT] = ACTIONS(71),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(71),
    [anon_sym_for] = ACTIONS(73),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(79),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_match] = ACTIONS(83),
    [anon_sym_match_BANG] = ACTIONS(85),
    [anon_sym_function] = ACTIONS(87),
    [anon_sym_LT_DASH] = ACTIONS(831),
    [anon_sym_DOT_LBRACK] = ACTIONS(91),
    [anon_sym_LT] = ACTIONS(93),
    [anon_sym_use] = ACTIONS(833),
    [anon_sym_use_BANG] = ACTIONS(835),
    [anon_sym_do_BANG] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(101),
    [anon_sym_LPAREN2] = ACTIONS(103),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(105),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(107),
    [anon_sym_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DQUOTE] = ACTIONS(111),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(115),
    [sym_bool] = ACTIONS(117),
    [sym_unit] = ACTIONS(119),
    [anon_sym_LPAREN_PIPE] = ACTIONS(121),
    [sym_op_identifier] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(837),
    [sym_xint] = ACTIONS(387),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(135),
    [sym__newline] = ACTIONS(839),
    [sym__dedent] = ACTIONS(1189),
  },
  [155] = {
    [sym_function_or_value_defn] = STATE(651),
    [sym__expression] = STATE(167),
    [sym_literal_expression] = STATE(2168),
    [sym_long_identifier_or_op] = STATE(2168),
    [sym_tuple_expression] = STATE(2168),
    [sym_brace_expression] = STATE(2168),
    [sym_anon_record_expression] = STATE(2168),
    [sym_prefixed_expression] = STATE(2168),
    [sym_typecast_expression] = STATE(2168),
    [sym_for_expression] = STATE(2168),
    [sym_while_expression] = STATE(2168),
    [sym__if_branch] = STATE(6406),
    [sym_if_expression] = STATE(2168),
    [sym_fun_expression] = STATE(2168),
    [sym_try_expression] = STATE(2168),
    [sym_match_expression] = STATE(2168),
    [sym_function_expression] = STATE(2168),
    [sym_mutate_expression] = STATE(2168),
    [sym_index_expression] = STATE(2168),
    [sym_typed_expression] = STATE(2168),
    [sym_declaration_expression] = STATE(2168),
    [sym_do_expression] = STATE(2168),
    [sym_list_expression] = STATE(2168),
    [sym_array_expression] = STATE(2168),
    [sym_begin_end_expression] = STATE(2168),
    [sym_paren_expression] = STATE(2168),
    [sym__high_prec_app] = STATE(2179),
    [sym__low_prec_app] = STATE(2179),
    [sym_application_expression] = STATE(2168),
    [sym_dot_expression] = STATE(2168),
    [sym_infix_expression] = STATE(2168),
    [sym_ce_expression] = STATE(2168),
    [sym_sequential_expression] = STATE(2168),
    [sym_char] = STATE(2469),
    [sym_format_string] = STATE(2412),
    [sym__string_literal] = STATE(2412),
    [sym_string] = STATE(2469),
    [sym_verbatim_string] = STATE(2469),
    [sym_bytearray] = STATE(2469),
    [sym_verbatim_bytearray] = STATE(2469),
    [sym_format_triple_quoted_string] = STATE(2408),
    [sym_triple_quoted_string] = STATE(2469),
    [sym_const] = STATE(2168),
    [sym_long_identifier] = STATE(2183),
    [sym_active_pattern] = STATE(2182),
    [sym__identifier_or_op] = STATE(2093),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(650),
    [sym_infix_op] = STATE(721),
    [sym_sbyte] = STATE(2469),
    [sym_byte] = STATE(2469),
    [sym_int16] = STATE(2469),
    [sym_uint16] = STATE(2469),
    [sym_int32] = STATE(2469),
    [sym_uint32] = STATE(2469),
    [sym_nativeint] = STATE(2469),
    [sym_unativeint] = STATE(2469),
    [sym_int64] = STATE(2469),
    [sym_uint64] = STATE(2469),
    [sym_ieee32] = STATE(2469),
    [sym_ieee64] = STATE(2469),
    [sym_bignum] = STATE(2469),
    [sym_decimal] = STATE(2469),
    [sym_float] = STATE(1586),
    [sym_block_comment] = STATE(155),
    [sym_compiler_directive_decl] = STATE(155),
    [sym_fsi_directive_decl] = STATE(155),
    [sym_preproc_line] = STATE(155),
    [sym_preproc_if_in_expression] = STATE(2168),
    [aux_sym_sequential_expression_repeat1] = STATE(1755),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(989),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(991),
    [anon_sym_return] = ACTIONS(993),
    [anon_sym_do] = ACTIONS(995),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(997),
    [anon_sym_COMMA] = ACTIONS(999),
    [anon_sym_null] = ACTIONS(1001),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(991),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1003),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1005),
    [anon_sym_LBRACE] = ACTIONS(1007),
    [anon_sym_LT_AT] = ACTIONS(1009),
    [anon_sym_AT_GT] = ACTIONS(1191),
    [anon_sym_LT_AT_AT] = ACTIONS(1013),
    [anon_sym_DOT] = ACTIONS(1015),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1017),
    [anon_sym_new] = ACTIONS(993),
    [anon_sym_return_BANG] = ACTIONS(1019),
    [anon_sym_yield] = ACTIONS(993),
    [anon_sym_yield_BANG] = ACTIONS(1019),
    [anon_sym_lazy] = ACTIONS(993),
    [anon_sym_assert] = ACTIONS(993),
    [anon_sym_upcast] = ACTIONS(993),
    [anon_sym_downcast] = ACTIONS(993),
    [anon_sym_COLON_GT] = ACTIONS(1021),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1021),
    [anon_sym_for] = ACTIONS(1023),
    [anon_sym_while] = ACTIONS(1025),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(1027),
    [anon_sym_try] = ACTIONS(1029),
    [anon_sym_match] = ACTIONS(1031),
    [anon_sym_match_BANG] = ACTIONS(1033),
    [anon_sym_function] = ACTIONS(1035),
    [anon_sym_LT_DASH] = ACTIONS(1037),
    [anon_sym_DOT_LBRACK] = ACTIONS(1039),
    [anon_sym_LT] = ACTIONS(1041),
    [anon_sym_use] = ACTIONS(1043),
    [anon_sym_use_BANG] = ACTIONS(1045),
    [anon_sym_do_BANG] = ACTIONS(1047),
    [anon_sym_begin] = ACTIONS(1049),
    [anon_sym_LPAREN2] = ACTIONS(1051),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(1053),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1055),
    [anon_sym_DQUOTE] = ACTIONS(1057),
    [anon_sym_AT_DQUOTE] = ACTIONS(1059),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1061),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1063),
    [sym_bool] = ACTIONS(1065),
    [sym_unit] = ACTIONS(1067),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1069),
    [sym_op_identifier] = ACTIONS(1071),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(1073),
    [sym_xint] = ACTIONS(1075),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1077),
    [sym__newline] = ACTIONS(1079),
  },
  [156] = {
    [sym_function_or_value_defn] = STATE(630),
    [sym__expression] = STATE(219),
    [sym_literal_expression] = STATE(2380),
    [sym_long_identifier_or_op] = STATE(2380),
    [sym_tuple_expression] = STATE(2380),
    [sym_brace_expression] = STATE(2380),
    [sym_anon_record_expression] = STATE(2380),
    [sym_prefixed_expression] = STATE(2380),
    [sym_typecast_expression] = STATE(2380),
    [sym_for_expression] = STATE(2380),
    [sym_while_expression] = STATE(2380),
    [sym__if_branch] = STATE(6456),
    [sym_if_expression] = STATE(2380),
    [sym_fun_expression] = STATE(2380),
    [sym_try_expression] = STATE(2380),
    [sym_match_expression] = STATE(2380),
    [sym_function_expression] = STATE(2380),
    [sym_mutate_expression] = STATE(2380),
    [sym_index_expression] = STATE(2380),
    [sym_typed_expression] = STATE(2380),
    [sym_declaration_expression] = STATE(2380),
    [sym_do_expression] = STATE(2380),
    [sym_list_expression] = STATE(2380),
    [sym_array_expression] = STATE(2380),
    [sym_begin_end_expression] = STATE(2380),
    [sym_paren_expression] = STATE(2380),
    [sym__high_prec_app] = STATE(2383),
    [sym__low_prec_app] = STATE(2383),
    [sym_application_expression] = STATE(2380),
    [sym_dot_expression] = STATE(2380),
    [sym_infix_expression] = STATE(2380),
    [sym_ce_expression] = STATE(2380),
    [sym_sequential_expression] = STATE(2380),
    [sym_char] = STATE(2261),
    [sym_format_string] = STATE(2274),
    [sym__string_literal] = STATE(2274),
    [sym_string] = STATE(2261),
    [sym_verbatim_string] = STATE(2261),
    [sym_bytearray] = STATE(2261),
    [sym_verbatim_bytearray] = STATE(2261),
    [sym_format_triple_quoted_string] = STATE(2275),
    [sym_triple_quoted_string] = STATE(2261),
    [sym_const] = STATE(2380),
    [sym_long_identifier] = STATE(2391),
    [sym_active_pattern] = STATE(2470),
    [sym__identifier_or_op] = STATE(2390),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(632),
    [sym_infix_op] = STATE(616),
    [sym_sbyte] = STATE(2261),
    [sym_byte] = STATE(2261),
    [sym_int16] = STATE(2261),
    [sym_uint16] = STATE(2261),
    [sym_int32] = STATE(2261),
    [sym_uint32] = STATE(2261),
    [sym_nativeint] = STATE(2261),
    [sym_unativeint] = STATE(2261),
    [sym_int64] = STATE(2261),
    [sym_uint64] = STATE(2261),
    [sym_ieee32] = STATE(2261),
    [sym_ieee64] = STATE(2261),
    [sym_bignum] = STATE(2261),
    [sym_decimal] = STATE(2261),
    [sym_float] = STATE(1614),
    [sym_block_comment] = STATE(156),
    [sym_compiler_directive_decl] = STATE(156),
    [sym_fsi_directive_decl] = STATE(156),
    [sym_preproc_line] = STATE(156),
    [sym_preproc_if_in_expression] = STATE(2380),
    [aux_sym_sequential_expression_repeat1] = STATE(1882),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(1081),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(1083),
    [anon_sym_return] = ACTIONS(1085),
    [anon_sym_do] = ACTIONS(1087),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(1089),
    [anon_sym_COMMA] = ACTIONS(1091),
    [anon_sym_null] = ACTIONS(1093),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(1083),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1095),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1097),
    [anon_sym_LBRACE] = ACTIONS(1099),
    [anon_sym_LT_AT] = ACTIONS(1101),
    [anon_sym_LT_AT_AT] = ACTIONS(1103),
    [anon_sym_AT_AT_GT] = ACTIONS(1191),
    [anon_sym_DOT] = ACTIONS(1105),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1107),
    [anon_sym_new] = ACTIONS(1085),
    [anon_sym_return_BANG] = ACTIONS(1109),
    [anon_sym_yield] = ACTIONS(1085),
    [anon_sym_yield_BANG] = ACTIONS(1109),
    [anon_sym_lazy] = ACTIONS(1085),
    [anon_sym_assert] = ACTIONS(1085),
    [anon_sym_upcast] = ACTIONS(1085),
    [anon_sym_downcast] = ACTIONS(1085),
    [anon_sym_COLON_GT] = ACTIONS(1111),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1111),
    [anon_sym_for] = ACTIONS(1113),
    [anon_sym_while] = ACTIONS(1115),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(1117),
    [anon_sym_try] = ACTIONS(1119),
    [anon_sym_match] = ACTIONS(1121),
    [anon_sym_match_BANG] = ACTIONS(1123),
    [anon_sym_function] = ACTIONS(1125),
    [anon_sym_LT_DASH] = ACTIONS(1127),
    [anon_sym_DOT_LBRACK] = ACTIONS(1129),
    [anon_sym_LT] = ACTIONS(1131),
    [anon_sym_use] = ACTIONS(1133),
    [anon_sym_use_BANG] = ACTIONS(1135),
    [anon_sym_do_BANG] = ACTIONS(1137),
    [anon_sym_begin] = ACTIONS(1139),
    [anon_sym_LPAREN2] = ACTIONS(1141),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(1143),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1145),
    [anon_sym_DQUOTE] = ACTIONS(1147),
    [anon_sym_AT_DQUOTE] = ACTIONS(1149),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1151),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1153),
    [sym_bool] = ACTIONS(1155),
    [sym_unit] = ACTIONS(1157),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1159),
    [sym_op_identifier] = ACTIONS(1161),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(1163),
    [sym_xint] = ACTIONS(1165),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1167),
    [sym__newline] = ACTIONS(1169),
  },
  [157] = {
    [sym_function_or_value_defn] = STATE(600),
    [sym__expression] = STATE(88),
    [sym_literal_expression] = STATE(867),
    [sym_long_identifier_or_op] = STATE(867),
    [sym_tuple_expression] = STATE(867),
    [sym_brace_expression] = STATE(867),
    [sym_anon_record_expression] = STATE(867),
    [sym_prefixed_expression] = STATE(867),
    [sym_typecast_expression] = STATE(867),
    [sym_for_expression] = STATE(867),
    [sym_while_expression] = STATE(867),
    [sym__if_branch] = STATE(6511),
    [sym_if_expression] = STATE(867),
    [sym_fun_expression] = STATE(867),
    [sym_try_expression] = STATE(867),
    [sym_match_expression] = STATE(867),
    [sym_function_expression] = STATE(867),
    [sym_mutate_expression] = STATE(867),
    [sym_index_expression] = STATE(867),
    [sym_typed_expression] = STATE(867),
    [sym_declaration_expression] = STATE(867),
    [sym_do_expression] = STATE(867),
    [sym_list_expression] = STATE(867),
    [sym_array_expression] = STATE(867),
    [sym_begin_end_expression] = STATE(867),
    [sym_paren_expression] = STATE(867),
    [sym__high_prec_app] = STATE(864),
    [sym__low_prec_app] = STATE(864),
    [sym_application_expression] = STATE(867),
    [sym_dot_expression] = STATE(867),
    [sym_infix_expression] = STATE(867),
    [sym_ce_expression] = STATE(867),
    [sym_sequential_expression] = STATE(867),
    [sym_char] = STATE(868),
    [sym_format_string] = STATE(869),
    [sym__string_literal] = STATE(869),
    [sym_string] = STATE(868),
    [sym_verbatim_string] = STATE(868),
    [sym_bytearray] = STATE(868),
    [sym_verbatim_bytearray] = STATE(868),
    [sym_format_triple_quoted_string] = STATE(870),
    [sym_triple_quoted_string] = STATE(868),
    [sym_const] = STATE(867),
    [sym_long_identifier] = STATE(872),
    [sym_active_pattern] = STATE(871),
    [sym__identifier_or_op] = STATE(873),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(656),
    [sym_infix_op] = STATE(581),
    [sym_sbyte] = STATE(868),
    [sym_byte] = STATE(868),
    [sym_int16] = STATE(868),
    [sym_uint16] = STATE(868),
    [sym_int32] = STATE(868),
    [sym_uint32] = STATE(868),
    [sym_nativeint] = STATE(868),
    [sym_unativeint] = STATE(868),
    [sym_int64] = STATE(868),
    [sym_uint64] = STATE(868),
    [sym_ieee32] = STATE(868),
    [sym_ieee64] = STATE(868),
    [sym_bignum] = STATE(868),
    [sym_decimal] = STATE(868),
    [sym_float] = STATE(1368),
    [sym_block_comment] = STATE(157),
    [sym_compiler_directive_decl] = STATE(157),
    [sym_fsi_directive_decl] = STATE(157),
    [sym_preproc_line] = STATE(157),
    [sym_preproc_if_in_expression] = STATE(867),
    [aux_sym_sequential_expression_repeat1] = STATE(1542),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(29),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(825),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_COMMA] = ACTIONS(827),
    [anon_sym_null] = ACTIONS(49),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACK_PIPE] = ACTIONS(57),
    [anon_sym_LBRACE] = ACTIONS(139),
    [anon_sym_LT_AT] = ACTIONS(61),
    [anon_sym_LT_AT_AT] = ACTIONS(63),
    [anon_sym_DOT] = ACTIONS(65),
    [anon_sym_LBRACE_PIPE] = ACTIONS(67),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_return_BANG] = ACTIONS(829),
    [anon_sym_yield] = ACTIONS(825),
    [anon_sym_yield_BANG] = ACTIONS(829),
    [anon_sym_lazy] = ACTIONS(825),
    [anon_sym_assert] = ACTIONS(825),
    [anon_sym_upcast] = ACTIONS(825),
    [anon_sym_downcast] = ACTIONS(825),
    [anon_sym_COLON_GT] = ACTIONS(71),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(71),
    [anon_sym_for] = ACTIONS(73),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(79),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_match] = ACTIONS(83),
    [anon_sym_match_BANG] = ACTIONS(85),
    [anon_sym_function] = ACTIONS(87),
    [anon_sym_LT_DASH] = ACTIONS(831),
    [anon_sym_DOT_LBRACK] = ACTIONS(91),
    [anon_sym_LT] = ACTIONS(93),
    [anon_sym_use] = ACTIONS(833),
    [anon_sym_use_BANG] = ACTIONS(835),
    [anon_sym_do_BANG] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(101),
    [anon_sym_LPAREN2] = ACTIONS(103),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(105),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(107),
    [anon_sym_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DQUOTE] = ACTIONS(111),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(115),
    [sym_bool] = ACTIONS(117),
    [sym_unit] = ACTIONS(119),
    [anon_sym_LPAREN_PIPE] = ACTIONS(121),
    [sym_op_identifier] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(837),
    [sym_xint] = ACTIONS(387),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(135),
    [sym__newline] = ACTIONS(839),
    [sym__dedent] = ACTIONS(1193),
  },
  [158] = {
    [sym_function_or_value_defn] = STATE(651),
    [sym__expression] = STATE(167),
    [sym_literal_expression] = STATE(2168),
    [sym_long_identifier_or_op] = STATE(2168),
    [sym_tuple_expression] = STATE(2168),
    [sym_brace_expression] = STATE(2168),
    [sym_anon_record_expression] = STATE(2168),
    [sym_prefixed_expression] = STATE(2168),
    [sym_typecast_expression] = STATE(2168),
    [sym_for_expression] = STATE(2168),
    [sym_while_expression] = STATE(2168),
    [sym__if_branch] = STATE(6406),
    [sym_if_expression] = STATE(2168),
    [sym_fun_expression] = STATE(2168),
    [sym_try_expression] = STATE(2168),
    [sym_match_expression] = STATE(2168),
    [sym_function_expression] = STATE(2168),
    [sym_mutate_expression] = STATE(2168),
    [sym_index_expression] = STATE(2168),
    [sym_typed_expression] = STATE(2168),
    [sym_declaration_expression] = STATE(2168),
    [sym_do_expression] = STATE(2168),
    [sym_list_expression] = STATE(2168),
    [sym_array_expression] = STATE(2168),
    [sym_begin_end_expression] = STATE(2168),
    [sym_paren_expression] = STATE(2168),
    [sym__high_prec_app] = STATE(2179),
    [sym__low_prec_app] = STATE(2179),
    [sym_application_expression] = STATE(2168),
    [sym_dot_expression] = STATE(2168),
    [sym_infix_expression] = STATE(2168),
    [sym_ce_expression] = STATE(2168),
    [sym_sequential_expression] = STATE(2168),
    [sym_char] = STATE(2469),
    [sym_format_string] = STATE(2412),
    [sym__string_literal] = STATE(2412),
    [sym_string] = STATE(2469),
    [sym_verbatim_string] = STATE(2469),
    [sym_bytearray] = STATE(2469),
    [sym_verbatim_bytearray] = STATE(2469),
    [sym_format_triple_quoted_string] = STATE(2408),
    [sym_triple_quoted_string] = STATE(2469),
    [sym_const] = STATE(2168),
    [sym_long_identifier] = STATE(2183),
    [sym_active_pattern] = STATE(2182),
    [sym__identifier_or_op] = STATE(2093),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(650),
    [sym_infix_op] = STATE(721),
    [sym_sbyte] = STATE(2469),
    [sym_byte] = STATE(2469),
    [sym_int16] = STATE(2469),
    [sym_uint16] = STATE(2469),
    [sym_int32] = STATE(2469),
    [sym_uint32] = STATE(2469),
    [sym_nativeint] = STATE(2469),
    [sym_unativeint] = STATE(2469),
    [sym_int64] = STATE(2469),
    [sym_uint64] = STATE(2469),
    [sym_ieee32] = STATE(2469),
    [sym_ieee64] = STATE(2469),
    [sym_bignum] = STATE(2469),
    [sym_decimal] = STATE(2469),
    [sym_float] = STATE(1586),
    [sym_block_comment] = STATE(158),
    [sym_compiler_directive_decl] = STATE(158),
    [sym_fsi_directive_decl] = STATE(158),
    [sym_preproc_line] = STATE(158),
    [sym_preproc_if_in_expression] = STATE(2168),
    [aux_sym_sequential_expression_repeat1] = STATE(1755),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(989),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(991),
    [anon_sym_return] = ACTIONS(993),
    [anon_sym_do] = ACTIONS(995),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(997),
    [anon_sym_COMMA] = ACTIONS(999),
    [anon_sym_null] = ACTIONS(1001),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(991),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1003),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1005),
    [anon_sym_LBRACE] = ACTIONS(1007),
    [anon_sym_LT_AT] = ACTIONS(1009),
    [anon_sym_AT_GT] = ACTIONS(1195),
    [anon_sym_LT_AT_AT] = ACTIONS(1013),
    [anon_sym_DOT] = ACTIONS(1015),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1017),
    [anon_sym_new] = ACTIONS(993),
    [anon_sym_return_BANG] = ACTIONS(1019),
    [anon_sym_yield] = ACTIONS(993),
    [anon_sym_yield_BANG] = ACTIONS(1019),
    [anon_sym_lazy] = ACTIONS(993),
    [anon_sym_assert] = ACTIONS(993),
    [anon_sym_upcast] = ACTIONS(993),
    [anon_sym_downcast] = ACTIONS(993),
    [anon_sym_COLON_GT] = ACTIONS(1021),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1021),
    [anon_sym_for] = ACTIONS(1023),
    [anon_sym_while] = ACTIONS(1025),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(1027),
    [anon_sym_try] = ACTIONS(1029),
    [anon_sym_match] = ACTIONS(1031),
    [anon_sym_match_BANG] = ACTIONS(1033),
    [anon_sym_function] = ACTIONS(1035),
    [anon_sym_LT_DASH] = ACTIONS(1037),
    [anon_sym_DOT_LBRACK] = ACTIONS(1039),
    [anon_sym_LT] = ACTIONS(1041),
    [anon_sym_use] = ACTIONS(1043),
    [anon_sym_use_BANG] = ACTIONS(1045),
    [anon_sym_do_BANG] = ACTIONS(1047),
    [anon_sym_begin] = ACTIONS(1049),
    [anon_sym_LPAREN2] = ACTIONS(1051),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(1053),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1055),
    [anon_sym_DQUOTE] = ACTIONS(1057),
    [anon_sym_AT_DQUOTE] = ACTIONS(1059),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1061),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1063),
    [sym_bool] = ACTIONS(1065),
    [sym_unit] = ACTIONS(1067),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1069),
    [sym_op_identifier] = ACTIONS(1071),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(1073),
    [sym_xint] = ACTIONS(1075),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1077),
    [sym__newline] = ACTIONS(1079),
  },
  [159] = {
    [sym_function_or_value_defn] = STATE(630),
    [sym__expression] = STATE(219),
    [sym_literal_expression] = STATE(2380),
    [sym_long_identifier_or_op] = STATE(2380),
    [sym_tuple_expression] = STATE(2380),
    [sym_brace_expression] = STATE(2380),
    [sym_anon_record_expression] = STATE(2380),
    [sym_prefixed_expression] = STATE(2380),
    [sym_typecast_expression] = STATE(2380),
    [sym_for_expression] = STATE(2380),
    [sym_while_expression] = STATE(2380),
    [sym__if_branch] = STATE(6456),
    [sym_if_expression] = STATE(2380),
    [sym_fun_expression] = STATE(2380),
    [sym_try_expression] = STATE(2380),
    [sym_match_expression] = STATE(2380),
    [sym_function_expression] = STATE(2380),
    [sym_mutate_expression] = STATE(2380),
    [sym_index_expression] = STATE(2380),
    [sym_typed_expression] = STATE(2380),
    [sym_declaration_expression] = STATE(2380),
    [sym_do_expression] = STATE(2380),
    [sym_list_expression] = STATE(2380),
    [sym_array_expression] = STATE(2380),
    [sym_begin_end_expression] = STATE(2380),
    [sym_paren_expression] = STATE(2380),
    [sym__high_prec_app] = STATE(2383),
    [sym__low_prec_app] = STATE(2383),
    [sym_application_expression] = STATE(2380),
    [sym_dot_expression] = STATE(2380),
    [sym_infix_expression] = STATE(2380),
    [sym_ce_expression] = STATE(2380),
    [sym_sequential_expression] = STATE(2380),
    [sym_char] = STATE(2261),
    [sym_format_string] = STATE(2274),
    [sym__string_literal] = STATE(2274),
    [sym_string] = STATE(2261),
    [sym_verbatim_string] = STATE(2261),
    [sym_bytearray] = STATE(2261),
    [sym_verbatim_bytearray] = STATE(2261),
    [sym_format_triple_quoted_string] = STATE(2275),
    [sym_triple_quoted_string] = STATE(2261),
    [sym_const] = STATE(2380),
    [sym_long_identifier] = STATE(2391),
    [sym_active_pattern] = STATE(2470),
    [sym__identifier_or_op] = STATE(2390),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(632),
    [sym_infix_op] = STATE(616),
    [sym_sbyte] = STATE(2261),
    [sym_byte] = STATE(2261),
    [sym_int16] = STATE(2261),
    [sym_uint16] = STATE(2261),
    [sym_int32] = STATE(2261),
    [sym_uint32] = STATE(2261),
    [sym_nativeint] = STATE(2261),
    [sym_unativeint] = STATE(2261),
    [sym_int64] = STATE(2261),
    [sym_uint64] = STATE(2261),
    [sym_ieee32] = STATE(2261),
    [sym_ieee64] = STATE(2261),
    [sym_bignum] = STATE(2261),
    [sym_decimal] = STATE(2261),
    [sym_float] = STATE(1614),
    [sym_block_comment] = STATE(159),
    [sym_compiler_directive_decl] = STATE(159),
    [sym_fsi_directive_decl] = STATE(159),
    [sym_preproc_line] = STATE(159),
    [sym_preproc_if_in_expression] = STATE(2380),
    [aux_sym_sequential_expression_repeat1] = STATE(1882),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(1081),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(1083),
    [anon_sym_return] = ACTIONS(1085),
    [anon_sym_do] = ACTIONS(1087),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(1089),
    [anon_sym_COMMA] = ACTIONS(1091),
    [anon_sym_null] = ACTIONS(1093),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(1083),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1095),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1097),
    [anon_sym_LBRACE] = ACTIONS(1099),
    [anon_sym_LT_AT] = ACTIONS(1101),
    [anon_sym_LT_AT_AT] = ACTIONS(1103),
    [anon_sym_AT_AT_GT] = ACTIONS(1195),
    [anon_sym_DOT] = ACTIONS(1105),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1107),
    [anon_sym_new] = ACTIONS(1085),
    [anon_sym_return_BANG] = ACTIONS(1109),
    [anon_sym_yield] = ACTIONS(1085),
    [anon_sym_yield_BANG] = ACTIONS(1109),
    [anon_sym_lazy] = ACTIONS(1085),
    [anon_sym_assert] = ACTIONS(1085),
    [anon_sym_upcast] = ACTIONS(1085),
    [anon_sym_downcast] = ACTIONS(1085),
    [anon_sym_COLON_GT] = ACTIONS(1111),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1111),
    [anon_sym_for] = ACTIONS(1113),
    [anon_sym_while] = ACTIONS(1115),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(1117),
    [anon_sym_try] = ACTIONS(1119),
    [anon_sym_match] = ACTIONS(1121),
    [anon_sym_match_BANG] = ACTIONS(1123),
    [anon_sym_function] = ACTIONS(1125),
    [anon_sym_LT_DASH] = ACTIONS(1127),
    [anon_sym_DOT_LBRACK] = ACTIONS(1129),
    [anon_sym_LT] = ACTIONS(1131),
    [anon_sym_use] = ACTIONS(1133),
    [anon_sym_use_BANG] = ACTIONS(1135),
    [anon_sym_do_BANG] = ACTIONS(1137),
    [anon_sym_begin] = ACTIONS(1139),
    [anon_sym_LPAREN2] = ACTIONS(1141),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(1143),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1145),
    [anon_sym_DQUOTE] = ACTIONS(1147),
    [anon_sym_AT_DQUOTE] = ACTIONS(1149),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1151),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1153),
    [sym_bool] = ACTIONS(1155),
    [sym_unit] = ACTIONS(1157),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1159),
    [sym_op_identifier] = ACTIONS(1161),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(1163),
    [sym_xint] = ACTIONS(1165),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1167),
    [sym__newline] = ACTIONS(1169),
  },
  [160] = {
    [sym_function_or_value_defn] = STATE(600),
    [sym__expression] = STATE(88),
    [sym_literal_expression] = STATE(867),
    [sym_long_identifier_or_op] = STATE(867),
    [sym_tuple_expression] = STATE(867),
    [sym_brace_expression] = STATE(867),
    [sym_anon_record_expression] = STATE(867),
    [sym_prefixed_expression] = STATE(867),
    [sym_typecast_expression] = STATE(867),
    [sym_for_expression] = STATE(867),
    [sym_while_expression] = STATE(867),
    [sym__if_branch] = STATE(6511),
    [sym_if_expression] = STATE(867),
    [sym_fun_expression] = STATE(867),
    [sym_try_expression] = STATE(867),
    [sym_match_expression] = STATE(867),
    [sym_function_expression] = STATE(867),
    [sym_mutate_expression] = STATE(867),
    [sym_index_expression] = STATE(867),
    [sym_typed_expression] = STATE(867),
    [sym_declaration_expression] = STATE(867),
    [sym_do_expression] = STATE(867),
    [sym_list_expression] = STATE(867),
    [sym_array_expression] = STATE(867),
    [sym_begin_end_expression] = STATE(867),
    [sym_paren_expression] = STATE(867),
    [sym__high_prec_app] = STATE(864),
    [sym__low_prec_app] = STATE(864),
    [sym_application_expression] = STATE(867),
    [sym_dot_expression] = STATE(867),
    [sym_infix_expression] = STATE(867),
    [sym_ce_expression] = STATE(867),
    [sym_sequential_expression] = STATE(867),
    [sym_char] = STATE(868),
    [sym_format_string] = STATE(869),
    [sym__string_literal] = STATE(869),
    [sym_string] = STATE(868),
    [sym_verbatim_string] = STATE(868),
    [sym_bytearray] = STATE(868),
    [sym_verbatim_bytearray] = STATE(868),
    [sym_format_triple_quoted_string] = STATE(870),
    [sym_triple_quoted_string] = STATE(868),
    [sym_const] = STATE(867),
    [sym_long_identifier] = STATE(872),
    [sym_active_pattern] = STATE(871),
    [sym__identifier_or_op] = STATE(873),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(656),
    [sym_infix_op] = STATE(581),
    [sym_sbyte] = STATE(868),
    [sym_byte] = STATE(868),
    [sym_int16] = STATE(868),
    [sym_uint16] = STATE(868),
    [sym_int32] = STATE(868),
    [sym_uint32] = STATE(868),
    [sym_nativeint] = STATE(868),
    [sym_unativeint] = STATE(868),
    [sym_int64] = STATE(868),
    [sym_uint64] = STATE(868),
    [sym_ieee32] = STATE(868),
    [sym_ieee64] = STATE(868),
    [sym_bignum] = STATE(868),
    [sym_decimal] = STATE(868),
    [sym_float] = STATE(1368),
    [sym_block_comment] = STATE(160),
    [sym_compiler_directive_decl] = STATE(160),
    [sym_fsi_directive_decl] = STATE(160),
    [sym_preproc_line] = STATE(160),
    [sym_preproc_if_in_expression] = STATE(867),
    [aux_sym_sequential_expression_repeat1] = STATE(1542),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(29),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(825),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_COMMA] = ACTIONS(827),
    [anon_sym_null] = ACTIONS(49),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACK_PIPE] = ACTIONS(57),
    [anon_sym_LBRACE] = ACTIONS(139),
    [anon_sym_LT_AT] = ACTIONS(61),
    [anon_sym_LT_AT_AT] = ACTIONS(63),
    [anon_sym_DOT] = ACTIONS(65),
    [anon_sym_LBRACE_PIPE] = ACTIONS(67),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_return_BANG] = ACTIONS(829),
    [anon_sym_yield] = ACTIONS(825),
    [anon_sym_yield_BANG] = ACTIONS(829),
    [anon_sym_lazy] = ACTIONS(825),
    [anon_sym_assert] = ACTIONS(825),
    [anon_sym_upcast] = ACTIONS(825),
    [anon_sym_downcast] = ACTIONS(825),
    [anon_sym_COLON_GT] = ACTIONS(71),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(71),
    [anon_sym_for] = ACTIONS(73),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(79),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_match] = ACTIONS(83),
    [anon_sym_match_BANG] = ACTIONS(85),
    [anon_sym_function] = ACTIONS(87),
    [anon_sym_LT_DASH] = ACTIONS(831),
    [anon_sym_DOT_LBRACK] = ACTIONS(91),
    [anon_sym_LT] = ACTIONS(93),
    [anon_sym_use] = ACTIONS(833),
    [anon_sym_use_BANG] = ACTIONS(835),
    [anon_sym_do_BANG] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(101),
    [anon_sym_LPAREN2] = ACTIONS(103),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(105),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(107),
    [anon_sym_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DQUOTE] = ACTIONS(111),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(115),
    [sym_bool] = ACTIONS(117),
    [sym_unit] = ACTIONS(119),
    [anon_sym_LPAREN_PIPE] = ACTIONS(121),
    [sym_op_identifier] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(837),
    [sym_xint] = ACTIONS(387),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(135),
    [sym__newline] = ACTIONS(839),
    [sym__dedent] = ACTIONS(1197),
  },
  [161] = {
    [sym_function_or_value_defn] = STATE(627),
    [sym__expression] = STATE(17),
    [sym_literal_expression] = STATE(1118),
    [sym_long_identifier_or_op] = STATE(1118),
    [sym_tuple_expression] = STATE(1118),
    [sym_brace_expression] = STATE(1118),
    [sym_anon_record_expression] = STATE(1118),
    [sym_prefixed_expression] = STATE(1118),
    [sym_typecast_expression] = STATE(1118),
    [sym_for_expression] = STATE(1118),
    [sym_while_expression] = STATE(1118),
    [sym__if_branch] = STATE(7163),
    [sym_if_expression] = STATE(1118),
    [sym_fun_expression] = STATE(1118),
    [sym_try_expression] = STATE(1118),
    [sym_match_expression] = STATE(1118),
    [sym_function_expression] = STATE(1118),
    [sym_mutate_expression] = STATE(1118),
    [sym_index_expression] = STATE(1118),
    [sym_typed_expression] = STATE(1118),
    [sym_declaration_expression] = STATE(1118),
    [sym_do_expression] = STATE(1118),
    [sym_list_expression] = STATE(1118),
    [sym_array_expression] = STATE(1118),
    [sym_begin_end_expression] = STATE(1118),
    [sym_paren_expression] = STATE(1118),
    [sym__high_prec_app] = STATE(1133),
    [sym__low_prec_app] = STATE(1133),
    [sym_application_expression] = STATE(1118),
    [sym_dot_expression] = STATE(1118),
    [sym_infix_expression] = STATE(1118),
    [sym_ce_expression] = STATE(1118),
    [sym_sequential_expression] = STATE(1118),
    [sym_char] = STATE(1080),
    [sym_format_string] = STATE(1090),
    [sym__string_literal] = STATE(1090),
    [sym_string] = STATE(1080),
    [sym_verbatim_string] = STATE(1080),
    [sym_bytearray] = STATE(1080),
    [sym_verbatim_bytearray] = STATE(1080),
    [sym_format_triple_quoted_string] = STATE(1096),
    [sym_triple_quoted_string] = STATE(1080),
    [sym_const] = STATE(1118),
    [sym_long_identifier] = STATE(1156),
    [sym_active_pattern] = STATE(1085),
    [sym__identifier_or_op] = STATE(1099),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(517),
    [sym_infix_op] = STATE(487),
    [sym_sbyte] = STATE(1080),
    [sym_byte] = STATE(1080),
    [sym_int16] = STATE(1080),
    [sym_uint16] = STATE(1080),
    [sym_int32] = STATE(1080),
    [sym_uint32] = STATE(1080),
    [sym_nativeint] = STATE(1080),
    [sym_unativeint] = STATE(1080),
    [sym_int64] = STATE(1080),
    [sym_uint64] = STATE(1080),
    [sym_ieee32] = STATE(1080),
    [sym_ieee64] = STATE(1080),
    [sym_bignum] = STATE(1080),
    [sym_decimal] = STATE(1080),
    [sym_float] = STATE(979),
    [sym_block_comment] = STATE(161),
    [sym_compiler_directive_decl] = STATE(161),
    [sym_fsi_directive_decl] = STATE(161),
    [sym_preproc_line] = STATE(161),
    [sym_preproc_if_in_expression] = STATE(1118),
    [aux_sym_sequential_expression_repeat1] = STATE(1069),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(195),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(197),
    [anon_sym_return] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_COMMA] = ACTIONS(205),
    [anon_sym_null] = ACTIONS(207),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(197),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(209),
    [anon_sym_LBRACK_PIPE] = ACTIONS(211),
    [anon_sym_LBRACE] = ACTIONS(271),
    [anon_sym_LT_AT] = ACTIONS(213),
    [anon_sym_LT_AT_AT] = ACTIONS(215),
    [anon_sym_DOT] = ACTIONS(185),
    [anon_sym_LBRACE_PIPE] = ACTIONS(217),
    [anon_sym_new] = ACTIONS(199),
    [anon_sym_with] = ACTIONS(1199),
    [anon_sym_return_BANG] = ACTIONS(219),
    [anon_sym_yield] = ACTIONS(199),
    [anon_sym_yield_BANG] = ACTIONS(219),
    [anon_sym_lazy] = ACTIONS(199),
    [anon_sym_assert] = ACTIONS(199),
    [anon_sym_upcast] = ACTIONS(199),
    [anon_sym_downcast] = ACTIONS(199),
    [anon_sym_COLON_GT] = ACTIONS(221),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(221),
    [anon_sym_for] = ACTIONS(223),
    [anon_sym_while] = ACTIONS(225),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(229),
    [anon_sym_match] = ACTIONS(231),
    [anon_sym_match_BANG] = ACTIONS(233),
    [anon_sym_function] = ACTIONS(235),
    [anon_sym_LT_DASH] = ACTIONS(237),
    [anon_sym_DOT_LBRACK] = ACTIONS(187),
    [anon_sym_LT] = ACTIONS(189),
    [anon_sym_use] = ACTIONS(239),
    [anon_sym_use_BANG] = ACTIONS(241),
    [anon_sym_do_BANG] = ACTIONS(243),
    [anon_sym_begin] = ACTIONS(245),
    [anon_sym_LPAREN2] = ACTIONS(191),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(247),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(251),
    [anon_sym_AT_DQUOTE] = ACTIONS(253),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(255),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(257),
    [sym_bool] = ACTIONS(259),
    [sym_unit] = ACTIONS(193),
    [anon_sym_LPAREN_PIPE] = ACTIONS(261),
    [sym_op_identifier] = ACTIONS(263),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(265),
    [sym_xint] = ACTIONS(267),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(269),
    [sym__newline] = ACTIONS(1201),
  },
  [162] = {
    [sym_function_or_value_defn] = STATE(651),
    [sym__expression] = STATE(167),
    [sym_literal_expression] = STATE(2168),
    [sym_long_identifier_or_op] = STATE(2168),
    [sym_tuple_expression] = STATE(2168),
    [sym_brace_expression] = STATE(2168),
    [sym_anon_record_expression] = STATE(2168),
    [sym_prefixed_expression] = STATE(2168),
    [sym_typecast_expression] = STATE(2168),
    [sym_for_expression] = STATE(2168),
    [sym_while_expression] = STATE(2168),
    [sym__if_branch] = STATE(6406),
    [sym_if_expression] = STATE(2168),
    [sym_fun_expression] = STATE(2168),
    [sym_try_expression] = STATE(2168),
    [sym_match_expression] = STATE(2168),
    [sym_function_expression] = STATE(2168),
    [sym_mutate_expression] = STATE(2168),
    [sym_index_expression] = STATE(2168),
    [sym_typed_expression] = STATE(2168),
    [sym_declaration_expression] = STATE(2168),
    [sym_do_expression] = STATE(2168),
    [sym_list_expression] = STATE(2168),
    [sym_array_expression] = STATE(2168),
    [sym_begin_end_expression] = STATE(2168),
    [sym_paren_expression] = STATE(2168),
    [sym__high_prec_app] = STATE(2179),
    [sym__low_prec_app] = STATE(2179),
    [sym_application_expression] = STATE(2168),
    [sym_dot_expression] = STATE(2168),
    [sym_infix_expression] = STATE(2168),
    [sym_ce_expression] = STATE(2168),
    [sym_sequential_expression] = STATE(2168),
    [sym_char] = STATE(2469),
    [sym_format_string] = STATE(2412),
    [sym__string_literal] = STATE(2412),
    [sym_string] = STATE(2469),
    [sym_verbatim_string] = STATE(2469),
    [sym_bytearray] = STATE(2469),
    [sym_verbatim_bytearray] = STATE(2469),
    [sym_format_triple_quoted_string] = STATE(2408),
    [sym_triple_quoted_string] = STATE(2469),
    [sym_const] = STATE(2168),
    [sym_long_identifier] = STATE(2183),
    [sym_active_pattern] = STATE(2182),
    [sym__identifier_or_op] = STATE(2093),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(650),
    [sym_infix_op] = STATE(721),
    [sym_sbyte] = STATE(2469),
    [sym_byte] = STATE(2469),
    [sym_int16] = STATE(2469),
    [sym_uint16] = STATE(2469),
    [sym_int32] = STATE(2469),
    [sym_uint32] = STATE(2469),
    [sym_nativeint] = STATE(2469),
    [sym_unativeint] = STATE(2469),
    [sym_int64] = STATE(2469),
    [sym_uint64] = STATE(2469),
    [sym_ieee32] = STATE(2469),
    [sym_ieee64] = STATE(2469),
    [sym_bignum] = STATE(2469),
    [sym_decimal] = STATE(2469),
    [sym_float] = STATE(1586),
    [sym_block_comment] = STATE(162),
    [sym_compiler_directive_decl] = STATE(162),
    [sym_fsi_directive_decl] = STATE(162),
    [sym_preproc_line] = STATE(162),
    [sym_preproc_if_in_expression] = STATE(2168),
    [aux_sym_sequential_expression_repeat1] = STATE(1755),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(989),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(991),
    [anon_sym_return] = ACTIONS(993),
    [anon_sym_do] = ACTIONS(995),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(997),
    [anon_sym_COMMA] = ACTIONS(999),
    [anon_sym_null] = ACTIONS(1001),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(991),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1003),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1005),
    [anon_sym_LBRACE] = ACTIONS(1007),
    [anon_sym_LT_AT] = ACTIONS(1009),
    [anon_sym_AT_GT] = ACTIONS(1203),
    [anon_sym_LT_AT_AT] = ACTIONS(1013),
    [anon_sym_DOT] = ACTIONS(1015),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1017),
    [anon_sym_new] = ACTIONS(993),
    [anon_sym_return_BANG] = ACTIONS(1019),
    [anon_sym_yield] = ACTIONS(993),
    [anon_sym_yield_BANG] = ACTIONS(1019),
    [anon_sym_lazy] = ACTIONS(993),
    [anon_sym_assert] = ACTIONS(993),
    [anon_sym_upcast] = ACTIONS(993),
    [anon_sym_downcast] = ACTIONS(993),
    [anon_sym_COLON_GT] = ACTIONS(1021),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1021),
    [anon_sym_for] = ACTIONS(1023),
    [anon_sym_while] = ACTIONS(1025),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(1027),
    [anon_sym_try] = ACTIONS(1029),
    [anon_sym_match] = ACTIONS(1031),
    [anon_sym_match_BANG] = ACTIONS(1033),
    [anon_sym_function] = ACTIONS(1035),
    [anon_sym_LT_DASH] = ACTIONS(1037),
    [anon_sym_DOT_LBRACK] = ACTIONS(1039),
    [anon_sym_LT] = ACTIONS(1041),
    [anon_sym_use] = ACTIONS(1043),
    [anon_sym_use_BANG] = ACTIONS(1045),
    [anon_sym_do_BANG] = ACTIONS(1047),
    [anon_sym_begin] = ACTIONS(1049),
    [anon_sym_LPAREN2] = ACTIONS(1051),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(1053),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1055),
    [anon_sym_DQUOTE] = ACTIONS(1057),
    [anon_sym_AT_DQUOTE] = ACTIONS(1059),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1061),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1063),
    [sym_bool] = ACTIONS(1065),
    [sym_unit] = ACTIONS(1067),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1069),
    [sym_op_identifier] = ACTIONS(1071),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(1073),
    [sym_xint] = ACTIONS(1075),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1077),
    [sym__newline] = ACTIONS(1079),
  },
  [163] = {
    [sym_function_or_value_defn] = STATE(630),
    [sym__expression] = STATE(219),
    [sym_literal_expression] = STATE(2380),
    [sym_long_identifier_or_op] = STATE(2380),
    [sym_tuple_expression] = STATE(2380),
    [sym_brace_expression] = STATE(2380),
    [sym_anon_record_expression] = STATE(2380),
    [sym_prefixed_expression] = STATE(2380),
    [sym_typecast_expression] = STATE(2380),
    [sym_for_expression] = STATE(2380),
    [sym_while_expression] = STATE(2380),
    [sym__if_branch] = STATE(6456),
    [sym_if_expression] = STATE(2380),
    [sym_fun_expression] = STATE(2380),
    [sym_try_expression] = STATE(2380),
    [sym_match_expression] = STATE(2380),
    [sym_function_expression] = STATE(2380),
    [sym_mutate_expression] = STATE(2380),
    [sym_index_expression] = STATE(2380),
    [sym_typed_expression] = STATE(2380),
    [sym_declaration_expression] = STATE(2380),
    [sym_do_expression] = STATE(2380),
    [sym_list_expression] = STATE(2380),
    [sym_array_expression] = STATE(2380),
    [sym_begin_end_expression] = STATE(2380),
    [sym_paren_expression] = STATE(2380),
    [sym__high_prec_app] = STATE(2383),
    [sym__low_prec_app] = STATE(2383),
    [sym_application_expression] = STATE(2380),
    [sym_dot_expression] = STATE(2380),
    [sym_infix_expression] = STATE(2380),
    [sym_ce_expression] = STATE(2380),
    [sym_sequential_expression] = STATE(2380),
    [sym_char] = STATE(2261),
    [sym_format_string] = STATE(2274),
    [sym__string_literal] = STATE(2274),
    [sym_string] = STATE(2261),
    [sym_verbatim_string] = STATE(2261),
    [sym_bytearray] = STATE(2261),
    [sym_verbatim_bytearray] = STATE(2261),
    [sym_format_triple_quoted_string] = STATE(2275),
    [sym_triple_quoted_string] = STATE(2261),
    [sym_const] = STATE(2380),
    [sym_long_identifier] = STATE(2391),
    [sym_active_pattern] = STATE(2470),
    [sym__identifier_or_op] = STATE(2390),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(632),
    [sym_infix_op] = STATE(616),
    [sym_sbyte] = STATE(2261),
    [sym_byte] = STATE(2261),
    [sym_int16] = STATE(2261),
    [sym_uint16] = STATE(2261),
    [sym_int32] = STATE(2261),
    [sym_uint32] = STATE(2261),
    [sym_nativeint] = STATE(2261),
    [sym_unativeint] = STATE(2261),
    [sym_int64] = STATE(2261),
    [sym_uint64] = STATE(2261),
    [sym_ieee32] = STATE(2261),
    [sym_ieee64] = STATE(2261),
    [sym_bignum] = STATE(2261),
    [sym_decimal] = STATE(2261),
    [sym_float] = STATE(1614),
    [sym_block_comment] = STATE(163),
    [sym_compiler_directive_decl] = STATE(163),
    [sym_fsi_directive_decl] = STATE(163),
    [sym_preproc_line] = STATE(163),
    [sym_preproc_if_in_expression] = STATE(2380),
    [aux_sym_sequential_expression_repeat1] = STATE(1882),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(1081),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(1083),
    [anon_sym_return] = ACTIONS(1085),
    [anon_sym_do] = ACTIONS(1087),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(1089),
    [anon_sym_COMMA] = ACTIONS(1091),
    [anon_sym_null] = ACTIONS(1093),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(1083),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1095),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1097),
    [anon_sym_LBRACE] = ACTIONS(1099),
    [anon_sym_LT_AT] = ACTIONS(1101),
    [anon_sym_LT_AT_AT] = ACTIONS(1103),
    [anon_sym_AT_AT_GT] = ACTIONS(1203),
    [anon_sym_DOT] = ACTIONS(1105),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1107),
    [anon_sym_new] = ACTIONS(1085),
    [anon_sym_return_BANG] = ACTIONS(1109),
    [anon_sym_yield] = ACTIONS(1085),
    [anon_sym_yield_BANG] = ACTIONS(1109),
    [anon_sym_lazy] = ACTIONS(1085),
    [anon_sym_assert] = ACTIONS(1085),
    [anon_sym_upcast] = ACTIONS(1085),
    [anon_sym_downcast] = ACTIONS(1085),
    [anon_sym_COLON_GT] = ACTIONS(1111),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1111),
    [anon_sym_for] = ACTIONS(1113),
    [anon_sym_while] = ACTIONS(1115),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(1117),
    [anon_sym_try] = ACTIONS(1119),
    [anon_sym_match] = ACTIONS(1121),
    [anon_sym_match_BANG] = ACTIONS(1123),
    [anon_sym_function] = ACTIONS(1125),
    [anon_sym_LT_DASH] = ACTIONS(1127),
    [anon_sym_DOT_LBRACK] = ACTIONS(1129),
    [anon_sym_LT] = ACTIONS(1131),
    [anon_sym_use] = ACTIONS(1133),
    [anon_sym_use_BANG] = ACTIONS(1135),
    [anon_sym_do_BANG] = ACTIONS(1137),
    [anon_sym_begin] = ACTIONS(1139),
    [anon_sym_LPAREN2] = ACTIONS(1141),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(1143),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1145),
    [anon_sym_DQUOTE] = ACTIONS(1147),
    [anon_sym_AT_DQUOTE] = ACTIONS(1149),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1151),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1153),
    [sym_bool] = ACTIONS(1155),
    [sym_unit] = ACTIONS(1157),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1159),
    [sym_op_identifier] = ACTIONS(1161),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(1163),
    [sym_xint] = ACTIONS(1165),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1167),
    [sym__newline] = ACTIONS(1169),
  },
  [164] = {
    [sym_function_or_value_defn] = STATE(600),
    [sym__expression] = STATE(88),
    [sym_literal_expression] = STATE(867),
    [sym_long_identifier_or_op] = STATE(867),
    [sym_tuple_expression] = STATE(867),
    [sym_brace_expression] = STATE(867),
    [sym_anon_record_expression] = STATE(867),
    [sym_prefixed_expression] = STATE(867),
    [sym_typecast_expression] = STATE(867),
    [sym_for_expression] = STATE(867),
    [sym_while_expression] = STATE(867),
    [sym__if_branch] = STATE(6511),
    [sym_if_expression] = STATE(867),
    [sym_fun_expression] = STATE(867),
    [sym_try_expression] = STATE(867),
    [sym_match_expression] = STATE(867),
    [sym_function_expression] = STATE(867),
    [sym_mutate_expression] = STATE(867),
    [sym_index_expression] = STATE(867),
    [sym_typed_expression] = STATE(867),
    [sym_declaration_expression] = STATE(867),
    [sym_do_expression] = STATE(867),
    [sym_list_expression] = STATE(867),
    [sym_array_expression] = STATE(867),
    [sym_begin_end_expression] = STATE(867),
    [sym_paren_expression] = STATE(867),
    [sym__high_prec_app] = STATE(864),
    [sym__low_prec_app] = STATE(864),
    [sym_application_expression] = STATE(867),
    [sym_dot_expression] = STATE(867),
    [sym_infix_expression] = STATE(867),
    [sym_ce_expression] = STATE(867),
    [sym_sequential_expression] = STATE(867),
    [sym_char] = STATE(868),
    [sym_format_string] = STATE(869),
    [sym__string_literal] = STATE(869),
    [sym_string] = STATE(868),
    [sym_verbatim_string] = STATE(868),
    [sym_bytearray] = STATE(868),
    [sym_verbatim_bytearray] = STATE(868),
    [sym_format_triple_quoted_string] = STATE(870),
    [sym_triple_quoted_string] = STATE(868),
    [sym_const] = STATE(867),
    [sym_long_identifier] = STATE(872),
    [sym_active_pattern] = STATE(871),
    [sym__identifier_or_op] = STATE(873),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(656),
    [sym_infix_op] = STATE(581),
    [sym_sbyte] = STATE(868),
    [sym_byte] = STATE(868),
    [sym_int16] = STATE(868),
    [sym_uint16] = STATE(868),
    [sym_int32] = STATE(868),
    [sym_uint32] = STATE(868),
    [sym_nativeint] = STATE(868),
    [sym_unativeint] = STATE(868),
    [sym_int64] = STATE(868),
    [sym_uint64] = STATE(868),
    [sym_ieee32] = STATE(868),
    [sym_ieee64] = STATE(868),
    [sym_bignum] = STATE(868),
    [sym_decimal] = STATE(868),
    [sym_float] = STATE(1368),
    [sym_block_comment] = STATE(164),
    [sym_compiler_directive_decl] = STATE(164),
    [sym_fsi_directive_decl] = STATE(164),
    [sym_preproc_line] = STATE(164),
    [sym_preproc_if_in_expression] = STATE(867),
    [aux_sym_sequential_expression_repeat1] = STATE(1542),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(29),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(825),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_COMMA] = ACTIONS(827),
    [anon_sym_null] = ACTIONS(49),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACK_PIPE] = ACTIONS(57),
    [anon_sym_LBRACE] = ACTIONS(139),
    [anon_sym_LT_AT] = ACTIONS(61),
    [anon_sym_LT_AT_AT] = ACTIONS(63),
    [anon_sym_DOT] = ACTIONS(65),
    [anon_sym_LBRACE_PIPE] = ACTIONS(67),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_return_BANG] = ACTIONS(829),
    [anon_sym_yield] = ACTIONS(825),
    [anon_sym_yield_BANG] = ACTIONS(829),
    [anon_sym_lazy] = ACTIONS(825),
    [anon_sym_assert] = ACTIONS(825),
    [anon_sym_upcast] = ACTIONS(825),
    [anon_sym_downcast] = ACTIONS(825),
    [anon_sym_COLON_GT] = ACTIONS(71),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(71),
    [anon_sym_for] = ACTIONS(73),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(79),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_match] = ACTIONS(83),
    [anon_sym_match_BANG] = ACTIONS(85),
    [anon_sym_function] = ACTIONS(87),
    [anon_sym_LT_DASH] = ACTIONS(831),
    [anon_sym_DOT_LBRACK] = ACTIONS(91),
    [anon_sym_LT] = ACTIONS(93),
    [anon_sym_use] = ACTIONS(833),
    [anon_sym_use_BANG] = ACTIONS(835),
    [anon_sym_do_BANG] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(101),
    [anon_sym_LPAREN2] = ACTIONS(103),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(105),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(107),
    [anon_sym_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DQUOTE] = ACTIONS(111),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(115),
    [sym_bool] = ACTIONS(117),
    [sym_unit] = ACTIONS(119),
    [anon_sym_LPAREN_PIPE] = ACTIONS(121),
    [sym_op_identifier] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(837),
    [sym_xint] = ACTIONS(387),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(135),
    [sym__newline] = ACTIONS(839),
    [sym__dedent] = ACTIONS(1205),
  },
  [165] = {
    [sym_function_or_value_defn] = STATE(651),
    [sym__expression] = STATE(167),
    [sym_literal_expression] = STATE(2168),
    [sym_long_identifier_or_op] = STATE(2168),
    [sym_tuple_expression] = STATE(2168),
    [sym_brace_expression] = STATE(2168),
    [sym_anon_record_expression] = STATE(2168),
    [sym_prefixed_expression] = STATE(2168),
    [sym_typecast_expression] = STATE(2168),
    [sym_for_expression] = STATE(2168),
    [sym_while_expression] = STATE(2168),
    [sym__if_branch] = STATE(6406),
    [sym_if_expression] = STATE(2168),
    [sym_fun_expression] = STATE(2168),
    [sym_try_expression] = STATE(2168),
    [sym_match_expression] = STATE(2168),
    [sym_function_expression] = STATE(2168),
    [sym_mutate_expression] = STATE(2168),
    [sym_index_expression] = STATE(2168),
    [sym_typed_expression] = STATE(2168),
    [sym_declaration_expression] = STATE(2168),
    [sym_do_expression] = STATE(2168),
    [sym_list_expression] = STATE(2168),
    [sym_array_expression] = STATE(2168),
    [sym_begin_end_expression] = STATE(2168),
    [sym_paren_expression] = STATE(2168),
    [sym__high_prec_app] = STATE(2179),
    [sym__low_prec_app] = STATE(2179),
    [sym_application_expression] = STATE(2168),
    [sym_dot_expression] = STATE(2168),
    [sym_infix_expression] = STATE(2168),
    [sym_ce_expression] = STATE(2168),
    [sym_sequential_expression] = STATE(2168),
    [sym_char] = STATE(2469),
    [sym_format_string] = STATE(2412),
    [sym__string_literal] = STATE(2412),
    [sym_string] = STATE(2469),
    [sym_verbatim_string] = STATE(2469),
    [sym_bytearray] = STATE(2469),
    [sym_verbatim_bytearray] = STATE(2469),
    [sym_format_triple_quoted_string] = STATE(2408),
    [sym_triple_quoted_string] = STATE(2469),
    [sym_const] = STATE(2168),
    [sym_long_identifier] = STATE(2183),
    [sym_active_pattern] = STATE(2182),
    [sym__identifier_or_op] = STATE(2093),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(650),
    [sym_infix_op] = STATE(721),
    [sym_sbyte] = STATE(2469),
    [sym_byte] = STATE(2469),
    [sym_int16] = STATE(2469),
    [sym_uint16] = STATE(2469),
    [sym_int32] = STATE(2469),
    [sym_uint32] = STATE(2469),
    [sym_nativeint] = STATE(2469),
    [sym_unativeint] = STATE(2469),
    [sym_int64] = STATE(2469),
    [sym_uint64] = STATE(2469),
    [sym_ieee32] = STATE(2469),
    [sym_ieee64] = STATE(2469),
    [sym_bignum] = STATE(2469),
    [sym_decimal] = STATE(2469),
    [sym_float] = STATE(1586),
    [sym_block_comment] = STATE(165),
    [sym_compiler_directive_decl] = STATE(165),
    [sym_fsi_directive_decl] = STATE(165),
    [sym_preproc_line] = STATE(165),
    [sym_preproc_if_in_expression] = STATE(2168),
    [aux_sym_sequential_expression_repeat1] = STATE(1755),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(989),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(991),
    [anon_sym_return] = ACTIONS(993),
    [anon_sym_do] = ACTIONS(995),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(997),
    [anon_sym_COMMA] = ACTIONS(999),
    [anon_sym_null] = ACTIONS(1001),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(991),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1003),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1005),
    [anon_sym_LBRACE] = ACTIONS(1007),
    [anon_sym_LT_AT] = ACTIONS(1009),
    [anon_sym_AT_GT] = ACTIONS(147),
    [anon_sym_LT_AT_AT] = ACTIONS(1013),
    [anon_sym_DOT] = ACTIONS(1015),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1017),
    [anon_sym_new] = ACTIONS(993),
    [anon_sym_return_BANG] = ACTIONS(1019),
    [anon_sym_yield] = ACTIONS(993),
    [anon_sym_yield_BANG] = ACTIONS(1019),
    [anon_sym_lazy] = ACTIONS(993),
    [anon_sym_assert] = ACTIONS(993),
    [anon_sym_upcast] = ACTIONS(993),
    [anon_sym_downcast] = ACTIONS(993),
    [anon_sym_COLON_GT] = ACTIONS(1021),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1021),
    [anon_sym_for] = ACTIONS(1023),
    [anon_sym_while] = ACTIONS(1025),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(1027),
    [anon_sym_try] = ACTIONS(1029),
    [anon_sym_match] = ACTIONS(1031),
    [anon_sym_match_BANG] = ACTIONS(1033),
    [anon_sym_function] = ACTIONS(1035),
    [anon_sym_LT_DASH] = ACTIONS(1037),
    [anon_sym_DOT_LBRACK] = ACTIONS(1039),
    [anon_sym_LT] = ACTIONS(1041),
    [anon_sym_use] = ACTIONS(1043),
    [anon_sym_use_BANG] = ACTIONS(1045),
    [anon_sym_do_BANG] = ACTIONS(1047),
    [anon_sym_begin] = ACTIONS(1049),
    [anon_sym_LPAREN2] = ACTIONS(1051),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(1053),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1055),
    [anon_sym_DQUOTE] = ACTIONS(1057),
    [anon_sym_AT_DQUOTE] = ACTIONS(1059),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1061),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1063),
    [sym_bool] = ACTIONS(1065),
    [sym_unit] = ACTIONS(1067),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1069),
    [sym_op_identifier] = ACTIONS(1071),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(1073),
    [sym_xint] = ACTIONS(1075),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1077),
    [sym__newline] = ACTIONS(145),
  },
  [166] = {
    [sym_function_or_value_defn] = STATE(651),
    [sym__expression] = STATE(167),
    [sym_literal_expression] = STATE(2168),
    [sym_long_identifier_or_op] = STATE(2168),
    [sym_tuple_expression] = STATE(2168),
    [sym_brace_expression] = STATE(2168),
    [sym_anon_record_expression] = STATE(2168),
    [sym_prefixed_expression] = STATE(2168),
    [sym_typecast_expression] = STATE(2168),
    [sym_for_expression] = STATE(2168),
    [sym_while_expression] = STATE(2168),
    [sym__if_branch] = STATE(6406),
    [sym_if_expression] = STATE(2168),
    [sym_fun_expression] = STATE(2168),
    [sym_try_expression] = STATE(2168),
    [sym_match_expression] = STATE(2168),
    [sym_function_expression] = STATE(2168),
    [sym_mutate_expression] = STATE(2168),
    [sym_index_expression] = STATE(2168),
    [sym_typed_expression] = STATE(2168),
    [sym_declaration_expression] = STATE(2168),
    [sym_do_expression] = STATE(2168),
    [sym_list_expression] = STATE(2168),
    [sym_array_expression] = STATE(2168),
    [sym_begin_end_expression] = STATE(2168),
    [sym_paren_expression] = STATE(2168),
    [sym__high_prec_app] = STATE(2179),
    [sym__low_prec_app] = STATE(2179),
    [sym_application_expression] = STATE(2168),
    [sym_dot_expression] = STATE(2168),
    [sym_infix_expression] = STATE(2168),
    [sym_ce_expression] = STATE(2168),
    [sym_sequential_expression] = STATE(2168),
    [sym_char] = STATE(2469),
    [sym_format_string] = STATE(2412),
    [sym__string_literal] = STATE(2412),
    [sym_string] = STATE(2469),
    [sym_verbatim_string] = STATE(2469),
    [sym_bytearray] = STATE(2469),
    [sym_verbatim_bytearray] = STATE(2469),
    [sym_format_triple_quoted_string] = STATE(2408),
    [sym_triple_quoted_string] = STATE(2469),
    [sym_const] = STATE(2168),
    [sym_long_identifier] = STATE(2183),
    [sym_active_pattern] = STATE(2182),
    [sym__identifier_or_op] = STATE(2093),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(650),
    [sym_infix_op] = STATE(721),
    [sym_sbyte] = STATE(2469),
    [sym_byte] = STATE(2469),
    [sym_int16] = STATE(2469),
    [sym_uint16] = STATE(2469),
    [sym_int32] = STATE(2469),
    [sym_uint32] = STATE(2469),
    [sym_nativeint] = STATE(2469),
    [sym_unativeint] = STATE(2469),
    [sym_int64] = STATE(2469),
    [sym_uint64] = STATE(2469),
    [sym_ieee32] = STATE(2469),
    [sym_ieee64] = STATE(2469),
    [sym_bignum] = STATE(2469),
    [sym_decimal] = STATE(2469),
    [sym_float] = STATE(1586),
    [sym_block_comment] = STATE(166),
    [sym_compiler_directive_decl] = STATE(166),
    [sym_fsi_directive_decl] = STATE(166),
    [sym_preproc_line] = STATE(166),
    [sym_preproc_if_in_expression] = STATE(2168),
    [aux_sym_sequential_expression_repeat1] = STATE(1755),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(989),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(991),
    [anon_sym_return] = ACTIONS(993),
    [anon_sym_do] = ACTIONS(995),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(997),
    [anon_sym_COMMA] = ACTIONS(999),
    [anon_sym_null] = ACTIONS(1001),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(991),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1003),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1005),
    [anon_sym_LBRACE] = ACTIONS(1007),
    [anon_sym_LT_AT] = ACTIONS(1009),
    [anon_sym_AT_GT] = ACTIONS(151),
    [anon_sym_LT_AT_AT] = ACTIONS(1013),
    [anon_sym_DOT] = ACTIONS(1015),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1017),
    [anon_sym_new] = ACTIONS(993),
    [anon_sym_return_BANG] = ACTIONS(1019),
    [anon_sym_yield] = ACTIONS(993),
    [anon_sym_yield_BANG] = ACTIONS(1019),
    [anon_sym_lazy] = ACTIONS(993),
    [anon_sym_assert] = ACTIONS(993),
    [anon_sym_upcast] = ACTIONS(993),
    [anon_sym_downcast] = ACTIONS(993),
    [anon_sym_COLON_GT] = ACTIONS(1021),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1021),
    [anon_sym_for] = ACTIONS(1023),
    [anon_sym_while] = ACTIONS(1025),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(1027),
    [anon_sym_try] = ACTIONS(1029),
    [anon_sym_match] = ACTIONS(1031),
    [anon_sym_match_BANG] = ACTIONS(1033),
    [anon_sym_function] = ACTIONS(1035),
    [anon_sym_LT_DASH] = ACTIONS(1037),
    [anon_sym_DOT_LBRACK] = ACTIONS(1039),
    [anon_sym_LT] = ACTIONS(1041),
    [anon_sym_use] = ACTIONS(1043),
    [anon_sym_use_BANG] = ACTIONS(1045),
    [anon_sym_do_BANG] = ACTIONS(1047),
    [anon_sym_begin] = ACTIONS(1049),
    [anon_sym_LPAREN2] = ACTIONS(1051),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(1053),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1055),
    [anon_sym_DQUOTE] = ACTIONS(1057),
    [anon_sym_AT_DQUOTE] = ACTIONS(1059),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1061),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1063),
    [sym_bool] = ACTIONS(1065),
    [sym_unit] = ACTIONS(1067),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1069),
    [sym_op_identifier] = ACTIONS(1071),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(1073),
    [sym_xint] = ACTIONS(1075),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1077),
    [sym__newline] = ACTIONS(1079),
  },
  [167] = {
    [sym_function_or_value_defn] = STATE(651),
    [sym__expression] = STATE(167),
    [sym_literal_expression] = STATE(2168),
    [sym_long_identifier_or_op] = STATE(2168),
    [sym_tuple_expression] = STATE(2168),
    [sym_brace_expression] = STATE(2168),
    [sym_anon_record_expression] = STATE(2168),
    [sym_prefixed_expression] = STATE(2168),
    [sym_typecast_expression] = STATE(2168),
    [sym_for_expression] = STATE(2168),
    [sym_while_expression] = STATE(2168),
    [sym__if_branch] = STATE(6406),
    [sym_if_expression] = STATE(2168),
    [sym_fun_expression] = STATE(2168),
    [sym_try_expression] = STATE(2168),
    [sym_match_expression] = STATE(2168),
    [sym_function_expression] = STATE(2168),
    [sym_mutate_expression] = STATE(2168),
    [sym_index_expression] = STATE(2168),
    [sym_typed_expression] = STATE(2168),
    [sym_declaration_expression] = STATE(2168),
    [sym_do_expression] = STATE(2168),
    [sym_list_expression] = STATE(2168),
    [sym_array_expression] = STATE(2168),
    [sym_begin_end_expression] = STATE(2168),
    [sym_paren_expression] = STATE(2168),
    [sym__high_prec_app] = STATE(2179),
    [sym__low_prec_app] = STATE(2179),
    [sym_application_expression] = STATE(2168),
    [sym_dot_expression] = STATE(2168),
    [sym_infix_expression] = STATE(2168),
    [sym_ce_expression] = STATE(2168),
    [sym_sequential_expression] = STATE(2168),
    [sym_char] = STATE(2469),
    [sym_format_string] = STATE(2412),
    [sym__string_literal] = STATE(2412),
    [sym_string] = STATE(2469),
    [sym_verbatim_string] = STATE(2469),
    [sym_bytearray] = STATE(2469),
    [sym_verbatim_bytearray] = STATE(2469),
    [sym_format_triple_quoted_string] = STATE(2408),
    [sym_triple_quoted_string] = STATE(2469),
    [sym_const] = STATE(2168),
    [sym_long_identifier] = STATE(2183),
    [sym_active_pattern] = STATE(2182),
    [sym__identifier_or_op] = STATE(2093),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(650),
    [sym_infix_op] = STATE(721),
    [sym_sbyte] = STATE(2469),
    [sym_byte] = STATE(2469),
    [sym_int16] = STATE(2469),
    [sym_uint16] = STATE(2469),
    [sym_int32] = STATE(2469),
    [sym_uint32] = STATE(2469),
    [sym_nativeint] = STATE(2469),
    [sym_unativeint] = STATE(2469),
    [sym_int64] = STATE(2469),
    [sym_uint64] = STATE(2469),
    [sym_ieee32] = STATE(2469),
    [sym_ieee64] = STATE(2469),
    [sym_bignum] = STATE(2469),
    [sym_decimal] = STATE(2469),
    [sym_float] = STATE(1586),
    [sym_block_comment] = STATE(167),
    [sym_compiler_directive_decl] = STATE(167),
    [sym_fsi_directive_decl] = STATE(167),
    [sym_preproc_line] = STATE(167),
    [sym_preproc_if_in_expression] = STATE(2168),
    [aux_sym_sequential_expression_repeat1] = STATE(1755),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_EQ] = ACTIONS(157),
    [anon_sym_COLON] = ACTIONS(155),
    [anon_sym_return] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(155),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_let_BANG] = ACTIONS(157),
    [anon_sym_LPAREN] = ACTIONS(155),
    [anon_sym_COMMA] = ACTIONS(157),
    [anon_sym_null] = ACTIONS(155),
    [anon_sym_QMARK] = ACTIONS(155),
    [anon_sym_COLON_QMARK] = ACTIONS(155),
    [anon_sym_COLON_COLON] = ACTIONS(157),
    [anon_sym_AMP] = ACTIONS(155),
    [anon_sym_LBRACK] = ACTIONS(155),
    [anon_sym_LBRACK_PIPE] = ACTIONS(157),
    [anon_sym_LBRACE] = ACTIONS(155),
    [anon_sym_LT_AT] = ACTIONS(155),
    [anon_sym_AT_GT] = ACTIONS(155),
    [anon_sym_LT_AT_AT] = ACTIONS(155),
    [anon_sym_DOT] = ACTIONS(1015),
    [anon_sym_LBRACE_PIPE] = ACTIONS(157),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_return_BANG] = ACTIONS(157),
    [anon_sym_yield] = ACTIONS(155),
    [anon_sym_yield_BANG] = ACTIONS(157),
    [anon_sym_lazy] = ACTIONS(155),
    [anon_sym_assert] = ACTIONS(155),
    [anon_sym_upcast] = ACTIONS(155),
    [anon_sym_downcast] = ACTIONS(155),
    [anon_sym_COLON_GT] = ACTIONS(157),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(157),
    [anon_sym_for] = ACTIONS(155),
    [anon_sym_while] = ACTIONS(155),
    [anon_sym_if] = ACTIONS(155),
    [anon_sym_fun] = ACTIONS(155),
    [anon_sym_try] = ACTIONS(155),
    [anon_sym_match] = ACTIONS(155),
    [anon_sym_match_BANG] = ACTIONS(157),
    [anon_sym_function] = ACTIONS(155),
    [anon_sym_LT_DASH] = ACTIONS(155),
    [anon_sym_DOT_LBRACK] = ACTIONS(1039),
    [anon_sym_LT] = ACTIONS(1041),
    [anon_sym_use] = ACTIONS(155),
    [anon_sym_use_BANG] = ACTIONS(157),
    [anon_sym_do_BANG] = ACTIONS(157),
    [anon_sym_begin] = ACTIONS(155),
    [anon_sym_LPAREN2] = ACTIONS(1051),
    [anon_sym_or] = ACTIONS(155),
    [aux_sym_char_token1] = ACTIONS(157),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(155),
    [anon_sym_DQUOTE] = ACTIONS(155),
    [anon_sym_AT_DQUOTE] = ACTIONS(157),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(157),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(157),
    [sym_bool] = ACTIONS(155),
    [sym_unit] = ACTIONS(1067),
    [anon_sym_LPAREN_PIPE] = ACTIONS(155),
    [sym_op_identifier] = ACTIONS(155),
    [anon_sym_PLUS] = ACTIONS(155),
    [anon_sym_DASH] = ACTIONS(155),
    [anon_sym_PLUS_DOT] = ACTIONS(155),
    [anon_sym_DASH_DOT] = ACTIONS(155),
    [anon_sym_PERCENT] = ACTIONS(155),
    [anon_sym_AMP_AMP] = ACTIONS(155),
    [anon_sym_TILDE] = ACTIONS(157),
    [aux_sym_prefix_op_token1] = ACTIONS(155),
    [aux_sym_infix_op_token1] = ACTIONS(157),
    [aux_sym_infix_op_token2] = ACTIONS(155),
    [anon_sym_PIPE_PIPE] = ACTIONS(155),
    [anon_sym_BANG_EQ] = ACTIONS(155),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_DOLLAR] = ACTIONS(155),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(155),
    [sym_int] = ACTIONS(155),
    [sym_xint] = ACTIONS(157),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(157),
    [sym__newline] = ACTIONS(157),
  },
  [168] = {
    [sym_function_or_value_defn] = STATE(651),
    [sym__expression] = STATE(167),
    [sym_literal_expression] = STATE(2168),
    [sym_long_identifier_or_op] = STATE(2168),
    [sym_tuple_expression] = STATE(2168),
    [sym_brace_expression] = STATE(2168),
    [sym_anon_record_expression] = STATE(2168),
    [sym_prefixed_expression] = STATE(2168),
    [sym_typecast_expression] = STATE(2168),
    [sym_for_expression] = STATE(2168),
    [sym_while_expression] = STATE(2168),
    [sym__if_branch] = STATE(6406),
    [sym_if_expression] = STATE(2168),
    [sym_fun_expression] = STATE(2168),
    [sym_try_expression] = STATE(2168),
    [sym_match_expression] = STATE(2168),
    [sym_function_expression] = STATE(2168),
    [sym_mutate_expression] = STATE(2168),
    [sym_index_expression] = STATE(2168),
    [sym_typed_expression] = STATE(2168),
    [sym_declaration_expression] = STATE(2168),
    [sym_do_expression] = STATE(2168),
    [sym_list_expression] = STATE(2168),
    [sym_array_expression] = STATE(2168),
    [sym_begin_end_expression] = STATE(2168),
    [sym_paren_expression] = STATE(2168),
    [sym__high_prec_app] = STATE(2179),
    [sym__low_prec_app] = STATE(2179),
    [sym_application_expression] = STATE(2168),
    [sym_dot_expression] = STATE(2168),
    [sym_infix_expression] = STATE(2168),
    [sym_ce_expression] = STATE(2168),
    [sym_sequential_expression] = STATE(2168),
    [sym_char] = STATE(2469),
    [sym_format_string] = STATE(2412),
    [sym__string_literal] = STATE(2412),
    [sym_string] = STATE(2469),
    [sym_verbatim_string] = STATE(2469),
    [sym_bytearray] = STATE(2469),
    [sym_verbatim_bytearray] = STATE(2469),
    [sym_format_triple_quoted_string] = STATE(2408),
    [sym_triple_quoted_string] = STATE(2469),
    [sym_const] = STATE(2168),
    [sym_long_identifier] = STATE(2183),
    [sym_active_pattern] = STATE(2182),
    [sym__identifier_or_op] = STATE(2093),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(650),
    [sym_infix_op] = STATE(721),
    [sym_sbyte] = STATE(2469),
    [sym_byte] = STATE(2469),
    [sym_int16] = STATE(2469),
    [sym_uint16] = STATE(2469),
    [sym_int32] = STATE(2469),
    [sym_uint32] = STATE(2469),
    [sym_nativeint] = STATE(2469),
    [sym_unativeint] = STATE(2469),
    [sym_int64] = STATE(2469),
    [sym_uint64] = STATE(2469),
    [sym_ieee32] = STATE(2469),
    [sym_ieee64] = STATE(2469),
    [sym_bignum] = STATE(2469),
    [sym_decimal] = STATE(2469),
    [sym_float] = STATE(1586),
    [sym_block_comment] = STATE(168),
    [sym_compiler_directive_decl] = STATE(168),
    [sym_fsi_directive_decl] = STATE(168),
    [sym_preproc_line] = STATE(168),
    [sym_preproc_if_in_expression] = STATE(2168),
    [aux_sym_sequential_expression_repeat1] = STATE(1755),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(989),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(991),
    [anon_sym_return] = ACTIONS(993),
    [anon_sym_do] = ACTIONS(995),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(997),
    [anon_sym_COMMA] = ACTIONS(999),
    [anon_sym_null] = ACTIONS(1001),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(991),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1003),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1005),
    [anon_sym_LBRACE] = ACTIONS(1007),
    [anon_sym_LT_AT] = ACTIONS(1009),
    [anon_sym_AT_GT] = ACTIONS(1207),
    [anon_sym_LT_AT_AT] = ACTIONS(1013),
    [anon_sym_DOT] = ACTIONS(1015),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1017),
    [anon_sym_new] = ACTIONS(993),
    [anon_sym_return_BANG] = ACTIONS(1019),
    [anon_sym_yield] = ACTIONS(993),
    [anon_sym_yield_BANG] = ACTIONS(1019),
    [anon_sym_lazy] = ACTIONS(993),
    [anon_sym_assert] = ACTIONS(993),
    [anon_sym_upcast] = ACTIONS(993),
    [anon_sym_downcast] = ACTIONS(993),
    [anon_sym_COLON_GT] = ACTIONS(1021),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1021),
    [anon_sym_for] = ACTIONS(1023),
    [anon_sym_while] = ACTIONS(1025),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(1027),
    [anon_sym_try] = ACTIONS(1029),
    [anon_sym_match] = ACTIONS(1031),
    [anon_sym_match_BANG] = ACTIONS(1033),
    [anon_sym_function] = ACTIONS(1035),
    [anon_sym_LT_DASH] = ACTIONS(1037),
    [anon_sym_DOT_LBRACK] = ACTIONS(1039),
    [anon_sym_LT] = ACTIONS(1041),
    [anon_sym_use] = ACTIONS(1043),
    [anon_sym_use_BANG] = ACTIONS(1045),
    [anon_sym_do_BANG] = ACTIONS(1047),
    [anon_sym_begin] = ACTIONS(1049),
    [anon_sym_LPAREN2] = ACTIONS(1051),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(1053),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1055),
    [anon_sym_DQUOTE] = ACTIONS(1057),
    [anon_sym_AT_DQUOTE] = ACTIONS(1059),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1061),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1063),
    [sym_bool] = ACTIONS(1065),
    [sym_unit] = ACTIONS(1067),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1069),
    [sym_op_identifier] = ACTIONS(1071),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(1073),
    [sym_xint] = ACTIONS(1075),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1077),
    [sym__newline] = ACTIONS(1079),
  },
  [169] = {
    [sym_function_or_value_defn] = STATE(630),
    [sym__expression] = STATE(219),
    [sym_literal_expression] = STATE(2380),
    [sym_long_identifier_or_op] = STATE(2380),
    [sym_tuple_expression] = STATE(2380),
    [sym_brace_expression] = STATE(2380),
    [sym_anon_record_expression] = STATE(2380),
    [sym_prefixed_expression] = STATE(2380),
    [sym_typecast_expression] = STATE(2380),
    [sym_for_expression] = STATE(2380),
    [sym_while_expression] = STATE(2380),
    [sym__if_branch] = STATE(6456),
    [sym_if_expression] = STATE(2380),
    [sym_fun_expression] = STATE(2380),
    [sym_try_expression] = STATE(2380),
    [sym_match_expression] = STATE(2380),
    [sym_function_expression] = STATE(2380),
    [sym_mutate_expression] = STATE(2380),
    [sym_index_expression] = STATE(2380),
    [sym_typed_expression] = STATE(2380),
    [sym_declaration_expression] = STATE(2380),
    [sym_do_expression] = STATE(2380),
    [sym_list_expression] = STATE(2380),
    [sym_array_expression] = STATE(2380),
    [sym_begin_end_expression] = STATE(2380),
    [sym_paren_expression] = STATE(2380),
    [sym__high_prec_app] = STATE(2383),
    [sym__low_prec_app] = STATE(2383),
    [sym_application_expression] = STATE(2380),
    [sym_dot_expression] = STATE(2380),
    [sym_infix_expression] = STATE(2380),
    [sym_ce_expression] = STATE(2380),
    [sym_sequential_expression] = STATE(2380),
    [sym_char] = STATE(2261),
    [sym_format_string] = STATE(2274),
    [sym__string_literal] = STATE(2274),
    [sym_string] = STATE(2261),
    [sym_verbatim_string] = STATE(2261),
    [sym_bytearray] = STATE(2261),
    [sym_verbatim_bytearray] = STATE(2261),
    [sym_format_triple_quoted_string] = STATE(2275),
    [sym_triple_quoted_string] = STATE(2261),
    [sym_const] = STATE(2380),
    [sym_long_identifier] = STATE(2391),
    [sym_active_pattern] = STATE(2470),
    [sym__identifier_or_op] = STATE(2390),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(632),
    [sym_infix_op] = STATE(616),
    [sym_sbyte] = STATE(2261),
    [sym_byte] = STATE(2261),
    [sym_int16] = STATE(2261),
    [sym_uint16] = STATE(2261),
    [sym_int32] = STATE(2261),
    [sym_uint32] = STATE(2261),
    [sym_nativeint] = STATE(2261),
    [sym_unativeint] = STATE(2261),
    [sym_int64] = STATE(2261),
    [sym_uint64] = STATE(2261),
    [sym_ieee32] = STATE(2261),
    [sym_ieee64] = STATE(2261),
    [sym_bignum] = STATE(2261),
    [sym_decimal] = STATE(2261),
    [sym_float] = STATE(1614),
    [sym_block_comment] = STATE(169),
    [sym_compiler_directive_decl] = STATE(169),
    [sym_fsi_directive_decl] = STATE(169),
    [sym_preproc_line] = STATE(169),
    [sym_preproc_if_in_expression] = STATE(2380),
    [aux_sym_sequential_expression_repeat1] = STATE(1882),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(1081),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(1083),
    [anon_sym_return] = ACTIONS(1085),
    [anon_sym_do] = ACTIONS(1087),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(1089),
    [anon_sym_COMMA] = ACTIONS(1091),
    [anon_sym_null] = ACTIONS(1093),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(1083),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1095),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1097),
    [anon_sym_LBRACE] = ACTIONS(1099),
    [anon_sym_LT_AT] = ACTIONS(1101),
    [anon_sym_LT_AT_AT] = ACTIONS(1103),
    [anon_sym_AT_AT_GT] = ACTIONS(1207),
    [anon_sym_DOT] = ACTIONS(1105),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1107),
    [anon_sym_new] = ACTIONS(1085),
    [anon_sym_return_BANG] = ACTIONS(1109),
    [anon_sym_yield] = ACTIONS(1085),
    [anon_sym_yield_BANG] = ACTIONS(1109),
    [anon_sym_lazy] = ACTIONS(1085),
    [anon_sym_assert] = ACTIONS(1085),
    [anon_sym_upcast] = ACTIONS(1085),
    [anon_sym_downcast] = ACTIONS(1085),
    [anon_sym_COLON_GT] = ACTIONS(1111),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1111),
    [anon_sym_for] = ACTIONS(1113),
    [anon_sym_while] = ACTIONS(1115),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(1117),
    [anon_sym_try] = ACTIONS(1119),
    [anon_sym_match] = ACTIONS(1121),
    [anon_sym_match_BANG] = ACTIONS(1123),
    [anon_sym_function] = ACTIONS(1125),
    [anon_sym_LT_DASH] = ACTIONS(1127),
    [anon_sym_DOT_LBRACK] = ACTIONS(1129),
    [anon_sym_LT] = ACTIONS(1131),
    [anon_sym_use] = ACTIONS(1133),
    [anon_sym_use_BANG] = ACTIONS(1135),
    [anon_sym_do_BANG] = ACTIONS(1137),
    [anon_sym_begin] = ACTIONS(1139),
    [anon_sym_LPAREN2] = ACTIONS(1141),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(1143),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1145),
    [anon_sym_DQUOTE] = ACTIONS(1147),
    [anon_sym_AT_DQUOTE] = ACTIONS(1149),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1151),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1153),
    [sym_bool] = ACTIONS(1155),
    [sym_unit] = ACTIONS(1157),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1159),
    [sym_op_identifier] = ACTIONS(1161),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(1163),
    [sym_xint] = ACTIONS(1165),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1167),
    [sym__newline] = ACTIONS(1169),
  },
  [170] = {
    [sym_function_or_value_defn] = STATE(600),
    [sym__expression] = STATE(88),
    [sym_literal_expression] = STATE(867),
    [sym_long_identifier_or_op] = STATE(867),
    [sym_tuple_expression] = STATE(867),
    [sym_brace_expression] = STATE(867),
    [sym_anon_record_expression] = STATE(867),
    [sym_prefixed_expression] = STATE(867),
    [sym_typecast_expression] = STATE(867),
    [sym_for_expression] = STATE(867),
    [sym_while_expression] = STATE(867),
    [sym__if_branch] = STATE(6511),
    [sym_if_expression] = STATE(867),
    [sym_fun_expression] = STATE(867),
    [sym_try_expression] = STATE(867),
    [sym_match_expression] = STATE(867),
    [sym_function_expression] = STATE(867),
    [sym_mutate_expression] = STATE(867),
    [sym_index_expression] = STATE(867),
    [sym_typed_expression] = STATE(867),
    [sym_declaration_expression] = STATE(867),
    [sym_do_expression] = STATE(867),
    [sym_list_expression] = STATE(867),
    [sym_array_expression] = STATE(867),
    [sym_begin_end_expression] = STATE(867),
    [sym_paren_expression] = STATE(867),
    [sym__high_prec_app] = STATE(864),
    [sym__low_prec_app] = STATE(864),
    [sym_application_expression] = STATE(867),
    [sym_dot_expression] = STATE(867),
    [sym_infix_expression] = STATE(867),
    [sym_ce_expression] = STATE(867),
    [sym_sequential_expression] = STATE(867),
    [sym_char] = STATE(868),
    [sym_format_string] = STATE(869),
    [sym__string_literal] = STATE(869),
    [sym_string] = STATE(868),
    [sym_verbatim_string] = STATE(868),
    [sym_bytearray] = STATE(868),
    [sym_verbatim_bytearray] = STATE(868),
    [sym_format_triple_quoted_string] = STATE(870),
    [sym_triple_quoted_string] = STATE(868),
    [sym_const] = STATE(867),
    [sym_long_identifier] = STATE(872),
    [sym_active_pattern] = STATE(871),
    [sym__identifier_or_op] = STATE(873),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(656),
    [sym_infix_op] = STATE(581),
    [sym_sbyte] = STATE(868),
    [sym_byte] = STATE(868),
    [sym_int16] = STATE(868),
    [sym_uint16] = STATE(868),
    [sym_int32] = STATE(868),
    [sym_uint32] = STATE(868),
    [sym_nativeint] = STATE(868),
    [sym_unativeint] = STATE(868),
    [sym_int64] = STATE(868),
    [sym_uint64] = STATE(868),
    [sym_ieee32] = STATE(868),
    [sym_ieee64] = STATE(868),
    [sym_bignum] = STATE(868),
    [sym_decimal] = STATE(868),
    [sym_float] = STATE(1368),
    [sym_block_comment] = STATE(170),
    [sym_compiler_directive_decl] = STATE(170),
    [sym_fsi_directive_decl] = STATE(170),
    [sym_preproc_line] = STATE(170),
    [sym_preproc_if_in_expression] = STATE(867),
    [aux_sym_sequential_expression_repeat1] = STATE(1542),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(29),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(825),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_COMMA] = ACTIONS(827),
    [anon_sym_null] = ACTIONS(49),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACK_PIPE] = ACTIONS(57),
    [anon_sym_LBRACE] = ACTIONS(139),
    [anon_sym_LT_AT] = ACTIONS(61),
    [anon_sym_LT_AT_AT] = ACTIONS(63),
    [anon_sym_DOT] = ACTIONS(65),
    [anon_sym_LBRACE_PIPE] = ACTIONS(67),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_return_BANG] = ACTIONS(829),
    [anon_sym_yield] = ACTIONS(825),
    [anon_sym_yield_BANG] = ACTIONS(829),
    [anon_sym_lazy] = ACTIONS(825),
    [anon_sym_assert] = ACTIONS(825),
    [anon_sym_upcast] = ACTIONS(825),
    [anon_sym_downcast] = ACTIONS(825),
    [anon_sym_COLON_GT] = ACTIONS(71),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(71),
    [anon_sym_for] = ACTIONS(73),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(79),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_match] = ACTIONS(83),
    [anon_sym_match_BANG] = ACTIONS(85),
    [anon_sym_function] = ACTIONS(87),
    [anon_sym_LT_DASH] = ACTIONS(831),
    [anon_sym_DOT_LBRACK] = ACTIONS(91),
    [anon_sym_LT] = ACTIONS(93),
    [anon_sym_use] = ACTIONS(833),
    [anon_sym_use_BANG] = ACTIONS(835),
    [anon_sym_do_BANG] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(101),
    [anon_sym_LPAREN2] = ACTIONS(103),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(105),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(107),
    [anon_sym_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DQUOTE] = ACTIONS(111),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(115),
    [sym_bool] = ACTIONS(117),
    [sym_unit] = ACTIONS(119),
    [anon_sym_LPAREN_PIPE] = ACTIONS(121),
    [sym_op_identifier] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(837),
    [sym_xint] = ACTIONS(387),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(135),
    [sym__newline] = ACTIONS(839),
    [sym__dedent] = ACTIONS(1209),
  },
  [171] = {
    [sym_function_or_value_defn] = STATE(627),
    [sym__expression] = STATE(17),
    [sym_literal_expression] = STATE(1118),
    [sym_long_identifier_or_op] = STATE(1118),
    [sym_tuple_expression] = STATE(1118),
    [sym_brace_expression] = STATE(1118),
    [sym_anon_record_expression] = STATE(1118),
    [sym_prefixed_expression] = STATE(1118),
    [sym_typecast_expression] = STATE(1118),
    [sym_for_expression] = STATE(1118),
    [sym_while_expression] = STATE(1118),
    [sym__if_branch] = STATE(7163),
    [sym_if_expression] = STATE(1118),
    [sym_fun_expression] = STATE(1118),
    [sym_try_expression] = STATE(1118),
    [sym_match_expression] = STATE(1118),
    [sym_function_expression] = STATE(1118),
    [sym_mutate_expression] = STATE(1118),
    [sym_index_expression] = STATE(1118),
    [sym_typed_expression] = STATE(1118),
    [sym_declaration_expression] = STATE(1118),
    [sym_do_expression] = STATE(1118),
    [sym_list_expression] = STATE(1118),
    [sym_array_expression] = STATE(1118),
    [sym_begin_end_expression] = STATE(1118),
    [sym_paren_expression] = STATE(1118),
    [sym__high_prec_app] = STATE(1133),
    [sym__low_prec_app] = STATE(1133),
    [sym_application_expression] = STATE(1118),
    [sym_dot_expression] = STATE(1118),
    [sym_infix_expression] = STATE(1118),
    [sym_ce_expression] = STATE(1118),
    [sym_sequential_expression] = STATE(1118),
    [sym_char] = STATE(1080),
    [sym_format_string] = STATE(1090),
    [sym__string_literal] = STATE(1090),
    [sym_string] = STATE(1080),
    [sym_verbatim_string] = STATE(1080),
    [sym_bytearray] = STATE(1080),
    [sym_verbatim_bytearray] = STATE(1080),
    [sym_format_triple_quoted_string] = STATE(1096),
    [sym_triple_quoted_string] = STATE(1080),
    [sym_const] = STATE(1118),
    [sym_long_identifier] = STATE(1156),
    [sym_active_pattern] = STATE(1085),
    [sym__identifier_or_op] = STATE(1099),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(517),
    [sym_infix_op] = STATE(487),
    [sym_sbyte] = STATE(1080),
    [sym_byte] = STATE(1080),
    [sym_int16] = STATE(1080),
    [sym_uint16] = STATE(1080),
    [sym_int32] = STATE(1080),
    [sym_uint32] = STATE(1080),
    [sym_nativeint] = STATE(1080),
    [sym_unativeint] = STATE(1080),
    [sym_int64] = STATE(1080),
    [sym_uint64] = STATE(1080),
    [sym_ieee32] = STATE(1080),
    [sym_ieee64] = STATE(1080),
    [sym_bignum] = STATE(1080),
    [sym_decimal] = STATE(1080),
    [sym_float] = STATE(979),
    [sym_block_comment] = STATE(171),
    [sym_compiler_directive_decl] = STATE(171),
    [sym_fsi_directive_decl] = STATE(171),
    [sym_preproc_line] = STATE(171),
    [sym_preproc_if_in_expression] = STATE(1118),
    [aux_sym_sequential_expression_repeat1] = STATE(1069),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(195),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(197),
    [anon_sym_return] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_COMMA] = ACTIONS(205),
    [anon_sym_null] = ACTIONS(207),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(197),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(209),
    [anon_sym_LBRACK_PIPE] = ACTIONS(211),
    [anon_sym_LBRACE] = ACTIONS(271),
    [anon_sym_LT_AT] = ACTIONS(213),
    [anon_sym_LT_AT_AT] = ACTIONS(215),
    [anon_sym_DOT] = ACTIONS(185),
    [anon_sym_LBRACE_PIPE] = ACTIONS(217),
    [anon_sym_new] = ACTIONS(199),
    [anon_sym_with] = ACTIONS(1211),
    [anon_sym_return_BANG] = ACTIONS(219),
    [anon_sym_yield] = ACTIONS(199),
    [anon_sym_yield_BANG] = ACTIONS(219),
    [anon_sym_lazy] = ACTIONS(199),
    [anon_sym_assert] = ACTIONS(199),
    [anon_sym_upcast] = ACTIONS(199),
    [anon_sym_downcast] = ACTIONS(199),
    [anon_sym_COLON_GT] = ACTIONS(221),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(221),
    [anon_sym_for] = ACTIONS(223),
    [anon_sym_while] = ACTIONS(225),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(229),
    [anon_sym_match] = ACTIONS(231),
    [anon_sym_match_BANG] = ACTIONS(233),
    [anon_sym_function] = ACTIONS(235),
    [anon_sym_LT_DASH] = ACTIONS(237),
    [anon_sym_DOT_LBRACK] = ACTIONS(187),
    [anon_sym_LT] = ACTIONS(189),
    [anon_sym_use] = ACTIONS(239),
    [anon_sym_use_BANG] = ACTIONS(241),
    [anon_sym_do_BANG] = ACTIONS(243),
    [anon_sym_begin] = ACTIONS(245),
    [anon_sym_LPAREN2] = ACTIONS(191),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(247),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(251),
    [anon_sym_AT_DQUOTE] = ACTIONS(253),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(255),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(257),
    [sym_bool] = ACTIONS(259),
    [sym_unit] = ACTIONS(193),
    [anon_sym_LPAREN_PIPE] = ACTIONS(261),
    [sym_op_identifier] = ACTIONS(263),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(265),
    [sym_xint] = ACTIONS(267),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(269),
    [sym__newline] = ACTIONS(1213),
  },
  [172] = {
    [sym_function_or_value_defn] = STATE(600),
    [sym__expression] = STATE(88),
    [sym_literal_expression] = STATE(867),
    [sym_long_identifier_or_op] = STATE(867),
    [sym_tuple_expression] = STATE(867),
    [sym_brace_expression] = STATE(867),
    [sym_anon_record_expression] = STATE(867),
    [sym_prefixed_expression] = STATE(867),
    [sym_typecast_expression] = STATE(867),
    [sym_for_expression] = STATE(867),
    [sym_while_expression] = STATE(867),
    [sym__if_branch] = STATE(6511),
    [sym_if_expression] = STATE(867),
    [sym_fun_expression] = STATE(867),
    [sym_try_expression] = STATE(867),
    [sym_match_expression] = STATE(867),
    [sym_function_expression] = STATE(867),
    [sym_mutate_expression] = STATE(867),
    [sym_index_expression] = STATE(867),
    [sym_typed_expression] = STATE(867),
    [sym_declaration_expression] = STATE(867),
    [sym_do_expression] = STATE(867),
    [sym_list_expression] = STATE(867),
    [sym_array_expression] = STATE(867),
    [sym_begin_end_expression] = STATE(867),
    [sym_paren_expression] = STATE(867),
    [sym__high_prec_app] = STATE(864),
    [sym__low_prec_app] = STATE(864),
    [sym_application_expression] = STATE(867),
    [sym_dot_expression] = STATE(867),
    [sym_infix_expression] = STATE(867),
    [sym_ce_expression] = STATE(867),
    [sym_sequential_expression] = STATE(867),
    [sym_char] = STATE(868),
    [sym_format_string] = STATE(869),
    [sym__string_literal] = STATE(869),
    [sym_string] = STATE(868),
    [sym_verbatim_string] = STATE(868),
    [sym_bytearray] = STATE(868),
    [sym_verbatim_bytearray] = STATE(868),
    [sym_format_triple_quoted_string] = STATE(870),
    [sym_triple_quoted_string] = STATE(868),
    [sym_const] = STATE(867),
    [sym_long_identifier] = STATE(872),
    [sym_active_pattern] = STATE(871),
    [sym__identifier_or_op] = STATE(873),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(656),
    [sym_infix_op] = STATE(581),
    [sym_sbyte] = STATE(868),
    [sym_byte] = STATE(868),
    [sym_int16] = STATE(868),
    [sym_uint16] = STATE(868),
    [sym_int32] = STATE(868),
    [sym_uint32] = STATE(868),
    [sym_nativeint] = STATE(868),
    [sym_unativeint] = STATE(868),
    [sym_int64] = STATE(868),
    [sym_uint64] = STATE(868),
    [sym_ieee32] = STATE(868),
    [sym_ieee64] = STATE(868),
    [sym_bignum] = STATE(868),
    [sym_decimal] = STATE(868),
    [sym_float] = STATE(1368),
    [sym_block_comment] = STATE(172),
    [sym_compiler_directive_decl] = STATE(172),
    [sym_fsi_directive_decl] = STATE(172),
    [sym_preproc_line] = STATE(172),
    [sym_preproc_if_in_expression] = STATE(867),
    [aux_sym_sequential_expression_repeat1] = STATE(1542),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(29),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(825),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_COMMA] = ACTIONS(827),
    [anon_sym_null] = ACTIONS(49),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACK_PIPE] = ACTIONS(57),
    [anon_sym_LBRACE] = ACTIONS(139),
    [anon_sym_LT_AT] = ACTIONS(61),
    [anon_sym_LT_AT_AT] = ACTIONS(63),
    [anon_sym_DOT] = ACTIONS(65),
    [anon_sym_LBRACE_PIPE] = ACTIONS(67),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_return_BANG] = ACTIONS(829),
    [anon_sym_yield] = ACTIONS(825),
    [anon_sym_yield_BANG] = ACTIONS(829),
    [anon_sym_lazy] = ACTIONS(825),
    [anon_sym_assert] = ACTIONS(825),
    [anon_sym_upcast] = ACTIONS(825),
    [anon_sym_downcast] = ACTIONS(825),
    [anon_sym_COLON_GT] = ACTIONS(71),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(71),
    [anon_sym_for] = ACTIONS(73),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(79),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_match] = ACTIONS(83),
    [anon_sym_match_BANG] = ACTIONS(85),
    [anon_sym_function] = ACTIONS(87),
    [anon_sym_LT_DASH] = ACTIONS(831),
    [anon_sym_DOT_LBRACK] = ACTIONS(91),
    [anon_sym_LT] = ACTIONS(93),
    [anon_sym_use] = ACTIONS(833),
    [anon_sym_use_BANG] = ACTIONS(835),
    [anon_sym_do_BANG] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(101),
    [anon_sym_LPAREN2] = ACTIONS(103),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(105),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(107),
    [anon_sym_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DQUOTE] = ACTIONS(111),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(115),
    [sym_bool] = ACTIONS(117),
    [sym_unit] = ACTIONS(119),
    [anon_sym_LPAREN_PIPE] = ACTIONS(121),
    [sym_op_identifier] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(837),
    [sym_xint] = ACTIONS(387),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(135),
    [sym__newline] = ACTIONS(843),
    [sym__dedent] = ACTIONS(843),
  },
  [173] = {
    [sym_function_or_value_defn] = STATE(651),
    [sym__expression] = STATE(167),
    [sym_literal_expression] = STATE(2168),
    [sym_long_identifier_or_op] = STATE(2168),
    [sym_tuple_expression] = STATE(2168),
    [sym_brace_expression] = STATE(2168),
    [sym_anon_record_expression] = STATE(2168),
    [sym_prefixed_expression] = STATE(2168),
    [sym_typecast_expression] = STATE(2168),
    [sym_for_expression] = STATE(2168),
    [sym_while_expression] = STATE(2168),
    [sym__if_branch] = STATE(6406),
    [sym_if_expression] = STATE(2168),
    [sym_fun_expression] = STATE(2168),
    [sym_try_expression] = STATE(2168),
    [sym_match_expression] = STATE(2168),
    [sym_function_expression] = STATE(2168),
    [sym_mutate_expression] = STATE(2168),
    [sym_index_expression] = STATE(2168),
    [sym_typed_expression] = STATE(2168),
    [sym_declaration_expression] = STATE(2168),
    [sym_do_expression] = STATE(2168),
    [sym_list_expression] = STATE(2168),
    [sym_array_expression] = STATE(2168),
    [sym_begin_end_expression] = STATE(2168),
    [sym_paren_expression] = STATE(2168),
    [sym__high_prec_app] = STATE(2179),
    [sym__low_prec_app] = STATE(2179),
    [sym_application_expression] = STATE(2168),
    [sym_dot_expression] = STATE(2168),
    [sym_infix_expression] = STATE(2168),
    [sym_ce_expression] = STATE(2168),
    [sym_sequential_expression] = STATE(2168),
    [sym_char] = STATE(2469),
    [sym_format_string] = STATE(2412),
    [sym__string_literal] = STATE(2412),
    [sym_string] = STATE(2469),
    [sym_verbatim_string] = STATE(2469),
    [sym_bytearray] = STATE(2469),
    [sym_verbatim_bytearray] = STATE(2469),
    [sym_format_triple_quoted_string] = STATE(2408),
    [sym_triple_quoted_string] = STATE(2469),
    [sym_const] = STATE(2168),
    [sym_long_identifier] = STATE(2183),
    [sym_active_pattern] = STATE(2182),
    [sym__identifier_or_op] = STATE(2093),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(650),
    [sym_infix_op] = STATE(721),
    [sym_sbyte] = STATE(2469),
    [sym_byte] = STATE(2469),
    [sym_int16] = STATE(2469),
    [sym_uint16] = STATE(2469),
    [sym_int32] = STATE(2469),
    [sym_uint32] = STATE(2469),
    [sym_nativeint] = STATE(2469),
    [sym_unativeint] = STATE(2469),
    [sym_int64] = STATE(2469),
    [sym_uint64] = STATE(2469),
    [sym_ieee32] = STATE(2469),
    [sym_ieee64] = STATE(2469),
    [sym_bignum] = STATE(2469),
    [sym_decimal] = STATE(2469),
    [sym_float] = STATE(1586),
    [sym_block_comment] = STATE(173),
    [sym_compiler_directive_decl] = STATE(173),
    [sym_fsi_directive_decl] = STATE(173),
    [sym_preproc_line] = STATE(173),
    [sym_preproc_if_in_expression] = STATE(2168),
    [aux_sym_sequential_expression_repeat1] = STATE(1755),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(989),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(991),
    [anon_sym_return] = ACTIONS(993),
    [anon_sym_do] = ACTIONS(995),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(997),
    [anon_sym_COMMA] = ACTIONS(999),
    [anon_sym_null] = ACTIONS(1001),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(991),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1003),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1005),
    [anon_sym_LBRACE] = ACTIONS(1007),
    [anon_sym_LT_AT] = ACTIONS(1009),
    [anon_sym_AT_GT] = ACTIONS(1215),
    [anon_sym_LT_AT_AT] = ACTIONS(1013),
    [anon_sym_DOT] = ACTIONS(1015),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1017),
    [anon_sym_new] = ACTIONS(993),
    [anon_sym_return_BANG] = ACTIONS(1019),
    [anon_sym_yield] = ACTIONS(993),
    [anon_sym_yield_BANG] = ACTIONS(1019),
    [anon_sym_lazy] = ACTIONS(993),
    [anon_sym_assert] = ACTIONS(993),
    [anon_sym_upcast] = ACTIONS(993),
    [anon_sym_downcast] = ACTIONS(993),
    [anon_sym_COLON_GT] = ACTIONS(1021),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1021),
    [anon_sym_for] = ACTIONS(1023),
    [anon_sym_while] = ACTIONS(1025),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(1027),
    [anon_sym_try] = ACTIONS(1029),
    [anon_sym_match] = ACTIONS(1031),
    [anon_sym_match_BANG] = ACTIONS(1033),
    [anon_sym_function] = ACTIONS(1035),
    [anon_sym_LT_DASH] = ACTIONS(1037),
    [anon_sym_DOT_LBRACK] = ACTIONS(1039),
    [anon_sym_LT] = ACTIONS(1041),
    [anon_sym_use] = ACTIONS(1043),
    [anon_sym_use_BANG] = ACTIONS(1045),
    [anon_sym_do_BANG] = ACTIONS(1047),
    [anon_sym_begin] = ACTIONS(1049),
    [anon_sym_LPAREN2] = ACTIONS(1051),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(1053),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1055),
    [anon_sym_DQUOTE] = ACTIONS(1057),
    [anon_sym_AT_DQUOTE] = ACTIONS(1059),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1061),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1063),
    [sym_bool] = ACTIONS(1065),
    [sym_unit] = ACTIONS(1067),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1069),
    [sym_op_identifier] = ACTIONS(1071),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(1073),
    [sym_xint] = ACTIONS(1075),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1077),
    [sym__newline] = ACTIONS(1079),
  },
  [174] = {
    [sym_function_or_value_defn] = STATE(630),
    [sym__expression] = STATE(219),
    [sym_literal_expression] = STATE(2380),
    [sym_long_identifier_or_op] = STATE(2380),
    [sym_tuple_expression] = STATE(2380),
    [sym_brace_expression] = STATE(2380),
    [sym_anon_record_expression] = STATE(2380),
    [sym_prefixed_expression] = STATE(2380),
    [sym_typecast_expression] = STATE(2380),
    [sym_for_expression] = STATE(2380),
    [sym_while_expression] = STATE(2380),
    [sym__if_branch] = STATE(6456),
    [sym_if_expression] = STATE(2380),
    [sym_fun_expression] = STATE(2380),
    [sym_try_expression] = STATE(2380),
    [sym_match_expression] = STATE(2380),
    [sym_function_expression] = STATE(2380),
    [sym_mutate_expression] = STATE(2380),
    [sym_index_expression] = STATE(2380),
    [sym_typed_expression] = STATE(2380),
    [sym_declaration_expression] = STATE(2380),
    [sym_do_expression] = STATE(2380),
    [sym_list_expression] = STATE(2380),
    [sym_array_expression] = STATE(2380),
    [sym_begin_end_expression] = STATE(2380),
    [sym_paren_expression] = STATE(2380),
    [sym__high_prec_app] = STATE(2383),
    [sym__low_prec_app] = STATE(2383),
    [sym_application_expression] = STATE(2380),
    [sym_dot_expression] = STATE(2380),
    [sym_infix_expression] = STATE(2380),
    [sym_ce_expression] = STATE(2380),
    [sym_sequential_expression] = STATE(2380),
    [sym_char] = STATE(2261),
    [sym_format_string] = STATE(2274),
    [sym__string_literal] = STATE(2274),
    [sym_string] = STATE(2261),
    [sym_verbatim_string] = STATE(2261),
    [sym_bytearray] = STATE(2261),
    [sym_verbatim_bytearray] = STATE(2261),
    [sym_format_triple_quoted_string] = STATE(2275),
    [sym_triple_quoted_string] = STATE(2261),
    [sym_const] = STATE(2380),
    [sym_long_identifier] = STATE(2391),
    [sym_active_pattern] = STATE(2470),
    [sym__identifier_or_op] = STATE(2390),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(632),
    [sym_infix_op] = STATE(616),
    [sym_sbyte] = STATE(2261),
    [sym_byte] = STATE(2261),
    [sym_int16] = STATE(2261),
    [sym_uint16] = STATE(2261),
    [sym_int32] = STATE(2261),
    [sym_uint32] = STATE(2261),
    [sym_nativeint] = STATE(2261),
    [sym_unativeint] = STATE(2261),
    [sym_int64] = STATE(2261),
    [sym_uint64] = STATE(2261),
    [sym_ieee32] = STATE(2261),
    [sym_ieee64] = STATE(2261),
    [sym_bignum] = STATE(2261),
    [sym_decimal] = STATE(2261),
    [sym_float] = STATE(1614),
    [sym_block_comment] = STATE(174),
    [sym_compiler_directive_decl] = STATE(174),
    [sym_fsi_directive_decl] = STATE(174),
    [sym_preproc_line] = STATE(174),
    [sym_preproc_if_in_expression] = STATE(2380),
    [aux_sym_sequential_expression_repeat1] = STATE(1882),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(1081),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(1083),
    [anon_sym_return] = ACTIONS(1085),
    [anon_sym_do] = ACTIONS(1087),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(1089),
    [anon_sym_COMMA] = ACTIONS(1091),
    [anon_sym_null] = ACTIONS(1093),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(1083),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1095),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1097),
    [anon_sym_LBRACE] = ACTIONS(1099),
    [anon_sym_LT_AT] = ACTIONS(1101),
    [anon_sym_LT_AT_AT] = ACTIONS(1103),
    [anon_sym_AT_AT_GT] = ACTIONS(1215),
    [anon_sym_DOT] = ACTIONS(1105),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1107),
    [anon_sym_new] = ACTIONS(1085),
    [anon_sym_return_BANG] = ACTIONS(1109),
    [anon_sym_yield] = ACTIONS(1085),
    [anon_sym_yield_BANG] = ACTIONS(1109),
    [anon_sym_lazy] = ACTIONS(1085),
    [anon_sym_assert] = ACTIONS(1085),
    [anon_sym_upcast] = ACTIONS(1085),
    [anon_sym_downcast] = ACTIONS(1085),
    [anon_sym_COLON_GT] = ACTIONS(1111),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1111),
    [anon_sym_for] = ACTIONS(1113),
    [anon_sym_while] = ACTIONS(1115),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(1117),
    [anon_sym_try] = ACTIONS(1119),
    [anon_sym_match] = ACTIONS(1121),
    [anon_sym_match_BANG] = ACTIONS(1123),
    [anon_sym_function] = ACTIONS(1125),
    [anon_sym_LT_DASH] = ACTIONS(1127),
    [anon_sym_DOT_LBRACK] = ACTIONS(1129),
    [anon_sym_LT] = ACTIONS(1131),
    [anon_sym_use] = ACTIONS(1133),
    [anon_sym_use_BANG] = ACTIONS(1135),
    [anon_sym_do_BANG] = ACTIONS(1137),
    [anon_sym_begin] = ACTIONS(1139),
    [anon_sym_LPAREN2] = ACTIONS(1141),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(1143),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1145),
    [anon_sym_DQUOTE] = ACTIONS(1147),
    [anon_sym_AT_DQUOTE] = ACTIONS(1149),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1151),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1153),
    [sym_bool] = ACTIONS(1155),
    [sym_unit] = ACTIONS(1157),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1159),
    [sym_op_identifier] = ACTIONS(1161),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(1163),
    [sym_xint] = ACTIONS(1165),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1167),
    [sym__newline] = ACTIONS(1169),
  },
  [175] = {
    [sym_function_or_value_defn] = STATE(600),
    [sym__expression] = STATE(88),
    [sym_literal_expression] = STATE(867),
    [sym_long_identifier_or_op] = STATE(867),
    [sym_tuple_expression] = STATE(867),
    [sym_brace_expression] = STATE(867),
    [sym_anon_record_expression] = STATE(867),
    [sym_prefixed_expression] = STATE(867),
    [sym_typecast_expression] = STATE(867),
    [sym_for_expression] = STATE(867),
    [sym_while_expression] = STATE(867),
    [sym__if_branch] = STATE(6511),
    [sym_if_expression] = STATE(867),
    [sym_fun_expression] = STATE(867),
    [sym_try_expression] = STATE(867),
    [sym_match_expression] = STATE(867),
    [sym_function_expression] = STATE(867),
    [sym_mutate_expression] = STATE(867),
    [sym_index_expression] = STATE(867),
    [sym_typed_expression] = STATE(867),
    [sym_declaration_expression] = STATE(867),
    [sym_do_expression] = STATE(867),
    [sym_list_expression] = STATE(867),
    [sym_array_expression] = STATE(867),
    [sym_begin_end_expression] = STATE(867),
    [sym_paren_expression] = STATE(867),
    [sym__high_prec_app] = STATE(864),
    [sym__low_prec_app] = STATE(864),
    [sym_application_expression] = STATE(867),
    [sym_dot_expression] = STATE(867),
    [sym_infix_expression] = STATE(867),
    [sym_ce_expression] = STATE(867),
    [sym_sequential_expression] = STATE(867),
    [sym_char] = STATE(868),
    [sym_format_string] = STATE(869),
    [sym__string_literal] = STATE(869),
    [sym_string] = STATE(868),
    [sym_verbatim_string] = STATE(868),
    [sym_bytearray] = STATE(868),
    [sym_verbatim_bytearray] = STATE(868),
    [sym_format_triple_quoted_string] = STATE(870),
    [sym_triple_quoted_string] = STATE(868),
    [sym_const] = STATE(867),
    [sym_long_identifier] = STATE(872),
    [sym_active_pattern] = STATE(871),
    [sym__identifier_or_op] = STATE(873),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(656),
    [sym_infix_op] = STATE(581),
    [sym_sbyte] = STATE(868),
    [sym_byte] = STATE(868),
    [sym_int16] = STATE(868),
    [sym_uint16] = STATE(868),
    [sym_int32] = STATE(868),
    [sym_uint32] = STATE(868),
    [sym_nativeint] = STATE(868),
    [sym_unativeint] = STATE(868),
    [sym_int64] = STATE(868),
    [sym_uint64] = STATE(868),
    [sym_ieee32] = STATE(868),
    [sym_ieee64] = STATE(868),
    [sym_bignum] = STATE(868),
    [sym_decimal] = STATE(868),
    [sym_float] = STATE(1368),
    [sym_block_comment] = STATE(175),
    [sym_compiler_directive_decl] = STATE(175),
    [sym_fsi_directive_decl] = STATE(175),
    [sym_preproc_line] = STATE(175),
    [sym_preproc_if_in_expression] = STATE(867),
    [aux_sym_sequential_expression_repeat1] = STATE(1542),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(29),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(825),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_COMMA] = ACTIONS(827),
    [anon_sym_null] = ACTIONS(49),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACK_PIPE] = ACTIONS(57),
    [anon_sym_LBRACE] = ACTIONS(139),
    [anon_sym_LT_AT] = ACTIONS(61),
    [anon_sym_LT_AT_AT] = ACTIONS(63),
    [anon_sym_DOT] = ACTIONS(65),
    [anon_sym_LBRACE_PIPE] = ACTIONS(67),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_return_BANG] = ACTIONS(829),
    [anon_sym_yield] = ACTIONS(825),
    [anon_sym_yield_BANG] = ACTIONS(829),
    [anon_sym_lazy] = ACTIONS(825),
    [anon_sym_assert] = ACTIONS(825),
    [anon_sym_upcast] = ACTIONS(825),
    [anon_sym_downcast] = ACTIONS(825),
    [anon_sym_COLON_GT] = ACTIONS(71),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(71),
    [anon_sym_for] = ACTIONS(73),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(79),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_match] = ACTIONS(83),
    [anon_sym_match_BANG] = ACTIONS(85),
    [anon_sym_function] = ACTIONS(87),
    [anon_sym_LT_DASH] = ACTIONS(831),
    [anon_sym_DOT_LBRACK] = ACTIONS(91),
    [anon_sym_LT] = ACTIONS(93),
    [anon_sym_use] = ACTIONS(833),
    [anon_sym_use_BANG] = ACTIONS(835),
    [anon_sym_do_BANG] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(101),
    [anon_sym_LPAREN2] = ACTIONS(103),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(105),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(107),
    [anon_sym_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DQUOTE] = ACTIONS(111),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(115),
    [sym_bool] = ACTIONS(117),
    [sym_unit] = ACTIONS(119),
    [anon_sym_LPAREN_PIPE] = ACTIONS(121),
    [sym_op_identifier] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(837),
    [sym_xint] = ACTIONS(387),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(135),
    [sym__newline] = ACTIONS(839),
    [sym__dedent] = ACTIONS(1217),
  },
  [176] = {
    [sym_function_or_value_defn] = STATE(627),
    [sym__expression] = STATE(17),
    [sym_literal_expression] = STATE(1118),
    [sym_long_identifier_or_op] = STATE(1118),
    [sym_tuple_expression] = STATE(1118),
    [sym_brace_expression] = STATE(1118),
    [sym_anon_record_expression] = STATE(1118),
    [sym_prefixed_expression] = STATE(1118),
    [sym_typecast_expression] = STATE(1118),
    [sym_for_expression] = STATE(1118),
    [sym_while_expression] = STATE(1118),
    [sym__if_branch] = STATE(7163),
    [sym_if_expression] = STATE(1118),
    [sym_fun_expression] = STATE(1118),
    [sym_try_expression] = STATE(1118),
    [sym_match_expression] = STATE(1118),
    [sym_function_expression] = STATE(1118),
    [sym_mutate_expression] = STATE(1118),
    [sym_index_expression] = STATE(1118),
    [sym_typed_expression] = STATE(1118),
    [sym_declaration_expression] = STATE(1118),
    [sym_do_expression] = STATE(1118),
    [sym_list_expression] = STATE(1118),
    [sym_array_expression] = STATE(1118),
    [sym_begin_end_expression] = STATE(1118),
    [sym_paren_expression] = STATE(1118),
    [sym__high_prec_app] = STATE(1133),
    [sym__low_prec_app] = STATE(1133),
    [sym_application_expression] = STATE(1118),
    [sym_dot_expression] = STATE(1118),
    [sym_infix_expression] = STATE(1118),
    [sym_ce_expression] = STATE(1118),
    [sym_sequential_expression] = STATE(1118),
    [sym_char] = STATE(1080),
    [sym_format_string] = STATE(1090),
    [sym__string_literal] = STATE(1090),
    [sym_string] = STATE(1080),
    [sym_verbatim_string] = STATE(1080),
    [sym_bytearray] = STATE(1080),
    [sym_verbatim_bytearray] = STATE(1080),
    [sym_format_triple_quoted_string] = STATE(1096),
    [sym_triple_quoted_string] = STATE(1080),
    [sym_const] = STATE(1118),
    [sym_long_identifier] = STATE(1156),
    [sym_active_pattern] = STATE(1085),
    [sym__identifier_or_op] = STATE(1099),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(517),
    [sym_infix_op] = STATE(487),
    [sym_sbyte] = STATE(1080),
    [sym_byte] = STATE(1080),
    [sym_int16] = STATE(1080),
    [sym_uint16] = STATE(1080),
    [sym_int32] = STATE(1080),
    [sym_uint32] = STATE(1080),
    [sym_nativeint] = STATE(1080),
    [sym_unativeint] = STATE(1080),
    [sym_int64] = STATE(1080),
    [sym_uint64] = STATE(1080),
    [sym_ieee32] = STATE(1080),
    [sym_ieee64] = STATE(1080),
    [sym_bignum] = STATE(1080),
    [sym_decimal] = STATE(1080),
    [sym_float] = STATE(979),
    [sym_block_comment] = STATE(176),
    [sym_compiler_directive_decl] = STATE(176),
    [sym_fsi_directive_decl] = STATE(176),
    [sym_preproc_line] = STATE(176),
    [sym_preproc_if_in_expression] = STATE(1118),
    [aux_sym_sequential_expression_repeat1] = STATE(1069),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(195),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(197),
    [anon_sym_return] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_COMMA] = ACTIONS(205),
    [anon_sym_null] = ACTIONS(207),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(197),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(209),
    [anon_sym_LBRACK_PIPE] = ACTIONS(211),
    [anon_sym_LBRACE] = ACTIONS(271),
    [anon_sym_LT_AT] = ACTIONS(213),
    [anon_sym_LT_AT_AT] = ACTIONS(215),
    [anon_sym_DOT] = ACTIONS(185),
    [anon_sym_LBRACE_PIPE] = ACTIONS(217),
    [anon_sym_new] = ACTIONS(199),
    [anon_sym_with] = ACTIONS(1219),
    [anon_sym_return_BANG] = ACTIONS(219),
    [anon_sym_yield] = ACTIONS(199),
    [anon_sym_yield_BANG] = ACTIONS(219),
    [anon_sym_lazy] = ACTIONS(199),
    [anon_sym_assert] = ACTIONS(199),
    [anon_sym_upcast] = ACTIONS(199),
    [anon_sym_downcast] = ACTIONS(199),
    [anon_sym_COLON_GT] = ACTIONS(221),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(221),
    [anon_sym_for] = ACTIONS(223),
    [anon_sym_while] = ACTIONS(225),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(229),
    [anon_sym_match] = ACTIONS(231),
    [anon_sym_match_BANG] = ACTIONS(233),
    [anon_sym_function] = ACTIONS(235),
    [anon_sym_LT_DASH] = ACTIONS(237),
    [anon_sym_DOT_LBRACK] = ACTIONS(187),
    [anon_sym_LT] = ACTIONS(189),
    [anon_sym_use] = ACTIONS(239),
    [anon_sym_use_BANG] = ACTIONS(241),
    [anon_sym_do_BANG] = ACTIONS(243),
    [anon_sym_begin] = ACTIONS(245),
    [anon_sym_LPAREN2] = ACTIONS(191),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(247),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(251),
    [anon_sym_AT_DQUOTE] = ACTIONS(253),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(255),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(257),
    [sym_bool] = ACTIONS(259),
    [sym_unit] = ACTIONS(193),
    [anon_sym_LPAREN_PIPE] = ACTIONS(261),
    [sym_op_identifier] = ACTIONS(263),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(265),
    [sym_xint] = ACTIONS(267),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(269),
    [sym__newline] = ACTIONS(1221),
  },
  [177] = {
    [sym_function_or_value_defn] = STATE(600),
    [sym__expression] = STATE(88),
    [sym_literal_expression] = STATE(867),
    [sym_long_identifier_or_op] = STATE(867),
    [sym_tuple_expression] = STATE(867),
    [sym_brace_expression] = STATE(867),
    [sym_anon_record_expression] = STATE(867),
    [sym_prefixed_expression] = STATE(867),
    [sym_typecast_expression] = STATE(867),
    [sym_for_expression] = STATE(867),
    [sym_while_expression] = STATE(867),
    [sym__if_branch] = STATE(6511),
    [sym_if_expression] = STATE(867),
    [sym_fun_expression] = STATE(867),
    [sym_try_expression] = STATE(867),
    [sym_match_expression] = STATE(867),
    [sym_function_expression] = STATE(867),
    [sym_mutate_expression] = STATE(867),
    [sym_index_expression] = STATE(867),
    [sym_typed_expression] = STATE(867),
    [sym_declaration_expression] = STATE(867),
    [sym_do_expression] = STATE(867),
    [sym_list_expression] = STATE(867),
    [sym_array_expression] = STATE(867),
    [sym_begin_end_expression] = STATE(867),
    [sym_paren_expression] = STATE(867),
    [sym__high_prec_app] = STATE(864),
    [sym__low_prec_app] = STATE(864),
    [sym_application_expression] = STATE(867),
    [sym_dot_expression] = STATE(867),
    [sym_infix_expression] = STATE(867),
    [sym_ce_expression] = STATE(867),
    [sym_sequential_expression] = STATE(867),
    [sym_char] = STATE(868),
    [sym_format_string] = STATE(869),
    [sym__string_literal] = STATE(869),
    [sym_string] = STATE(868),
    [sym_verbatim_string] = STATE(868),
    [sym_bytearray] = STATE(868),
    [sym_verbatim_bytearray] = STATE(868),
    [sym_format_triple_quoted_string] = STATE(870),
    [sym_triple_quoted_string] = STATE(868),
    [sym_const] = STATE(867),
    [sym_long_identifier] = STATE(872),
    [sym_active_pattern] = STATE(871),
    [sym__identifier_or_op] = STATE(873),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(656),
    [sym_infix_op] = STATE(581),
    [sym_sbyte] = STATE(868),
    [sym_byte] = STATE(868),
    [sym_int16] = STATE(868),
    [sym_uint16] = STATE(868),
    [sym_int32] = STATE(868),
    [sym_uint32] = STATE(868),
    [sym_nativeint] = STATE(868),
    [sym_unativeint] = STATE(868),
    [sym_int64] = STATE(868),
    [sym_uint64] = STATE(868),
    [sym_ieee32] = STATE(868),
    [sym_ieee64] = STATE(868),
    [sym_bignum] = STATE(868),
    [sym_decimal] = STATE(868),
    [sym_float] = STATE(1368),
    [sym_block_comment] = STATE(177),
    [sym_compiler_directive_decl] = STATE(177),
    [sym_fsi_directive_decl] = STATE(177),
    [sym_preproc_line] = STATE(177),
    [sym_preproc_if_in_expression] = STATE(867),
    [aux_sym_sequential_expression_repeat1] = STATE(1542),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(29),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(825),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_COMMA] = ACTIONS(827),
    [anon_sym_null] = ACTIONS(49),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACK_PIPE] = ACTIONS(57),
    [anon_sym_LBRACE] = ACTIONS(139),
    [anon_sym_LT_AT] = ACTIONS(61),
    [anon_sym_LT_AT_AT] = ACTIONS(63),
    [anon_sym_DOT] = ACTIONS(65),
    [anon_sym_LBRACE_PIPE] = ACTIONS(67),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_return_BANG] = ACTIONS(829),
    [anon_sym_yield] = ACTIONS(825),
    [anon_sym_yield_BANG] = ACTIONS(829),
    [anon_sym_lazy] = ACTIONS(825),
    [anon_sym_assert] = ACTIONS(825),
    [anon_sym_upcast] = ACTIONS(825),
    [anon_sym_downcast] = ACTIONS(825),
    [anon_sym_COLON_GT] = ACTIONS(71),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(71),
    [anon_sym_for] = ACTIONS(73),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(79),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_match] = ACTIONS(83),
    [anon_sym_match_BANG] = ACTIONS(85),
    [anon_sym_function] = ACTIONS(87),
    [anon_sym_LT_DASH] = ACTIONS(831),
    [anon_sym_DOT_LBRACK] = ACTIONS(91),
    [anon_sym_LT] = ACTIONS(93),
    [anon_sym_use] = ACTIONS(833),
    [anon_sym_use_BANG] = ACTIONS(835),
    [anon_sym_do_BANG] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(101),
    [anon_sym_LPAREN2] = ACTIONS(103),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(105),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(107),
    [anon_sym_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DQUOTE] = ACTIONS(111),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(115),
    [sym_bool] = ACTIONS(117),
    [sym_unit] = ACTIONS(119),
    [anon_sym_LPAREN_PIPE] = ACTIONS(121),
    [sym_op_identifier] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(837),
    [sym_xint] = ACTIONS(387),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(135),
    [sym__newline] = ACTIONS(839),
    [sym__dedent] = ACTIONS(1223),
  },
  [178] = {
    [sym_function_or_value_defn] = STATE(651),
    [sym__expression] = STATE(167),
    [sym_literal_expression] = STATE(2168),
    [sym_long_identifier_or_op] = STATE(2168),
    [sym_tuple_expression] = STATE(2168),
    [sym_brace_expression] = STATE(2168),
    [sym_anon_record_expression] = STATE(2168),
    [sym_prefixed_expression] = STATE(2168),
    [sym_typecast_expression] = STATE(2168),
    [sym_for_expression] = STATE(2168),
    [sym_while_expression] = STATE(2168),
    [sym__if_branch] = STATE(6406),
    [sym_if_expression] = STATE(2168),
    [sym_fun_expression] = STATE(2168),
    [sym_try_expression] = STATE(2168),
    [sym_match_expression] = STATE(2168),
    [sym_function_expression] = STATE(2168),
    [sym_mutate_expression] = STATE(2168),
    [sym_index_expression] = STATE(2168),
    [sym_typed_expression] = STATE(2168),
    [sym_declaration_expression] = STATE(2168),
    [sym_do_expression] = STATE(2168),
    [sym_list_expression] = STATE(2168),
    [sym_array_expression] = STATE(2168),
    [sym_begin_end_expression] = STATE(2168),
    [sym_paren_expression] = STATE(2168),
    [sym__high_prec_app] = STATE(2179),
    [sym__low_prec_app] = STATE(2179),
    [sym_application_expression] = STATE(2168),
    [sym_dot_expression] = STATE(2168),
    [sym_infix_expression] = STATE(2168),
    [sym_ce_expression] = STATE(2168),
    [sym_sequential_expression] = STATE(2168),
    [sym_char] = STATE(2469),
    [sym_format_string] = STATE(2412),
    [sym__string_literal] = STATE(2412),
    [sym_string] = STATE(2469),
    [sym_verbatim_string] = STATE(2469),
    [sym_bytearray] = STATE(2469),
    [sym_verbatim_bytearray] = STATE(2469),
    [sym_format_triple_quoted_string] = STATE(2408),
    [sym_triple_quoted_string] = STATE(2469),
    [sym_const] = STATE(2168),
    [sym_long_identifier] = STATE(2183),
    [sym_active_pattern] = STATE(2182),
    [sym__identifier_or_op] = STATE(2093),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(650),
    [sym_infix_op] = STATE(721),
    [sym_sbyte] = STATE(2469),
    [sym_byte] = STATE(2469),
    [sym_int16] = STATE(2469),
    [sym_uint16] = STATE(2469),
    [sym_int32] = STATE(2469),
    [sym_uint32] = STATE(2469),
    [sym_nativeint] = STATE(2469),
    [sym_unativeint] = STATE(2469),
    [sym_int64] = STATE(2469),
    [sym_uint64] = STATE(2469),
    [sym_ieee32] = STATE(2469),
    [sym_ieee64] = STATE(2469),
    [sym_bignum] = STATE(2469),
    [sym_decimal] = STATE(2469),
    [sym_float] = STATE(1586),
    [sym_block_comment] = STATE(178),
    [sym_compiler_directive_decl] = STATE(178),
    [sym_fsi_directive_decl] = STATE(178),
    [sym_preproc_line] = STATE(178),
    [sym_preproc_if_in_expression] = STATE(2168),
    [aux_sym_sequential_expression_repeat1] = STATE(1755),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(989),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(991),
    [anon_sym_return] = ACTIONS(993),
    [anon_sym_do] = ACTIONS(995),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(997),
    [anon_sym_COMMA] = ACTIONS(999),
    [anon_sym_null] = ACTIONS(1001),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(991),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1003),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1005),
    [anon_sym_LBRACE] = ACTIONS(1007),
    [anon_sym_LT_AT] = ACTIONS(1009),
    [anon_sym_AT_GT] = ACTIONS(1225),
    [anon_sym_LT_AT_AT] = ACTIONS(1013),
    [anon_sym_DOT] = ACTIONS(1015),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1017),
    [anon_sym_new] = ACTIONS(993),
    [anon_sym_return_BANG] = ACTIONS(1019),
    [anon_sym_yield] = ACTIONS(993),
    [anon_sym_yield_BANG] = ACTIONS(1019),
    [anon_sym_lazy] = ACTIONS(993),
    [anon_sym_assert] = ACTIONS(993),
    [anon_sym_upcast] = ACTIONS(993),
    [anon_sym_downcast] = ACTIONS(993),
    [anon_sym_COLON_GT] = ACTIONS(1021),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1021),
    [anon_sym_for] = ACTIONS(1023),
    [anon_sym_while] = ACTIONS(1025),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(1027),
    [anon_sym_try] = ACTIONS(1029),
    [anon_sym_match] = ACTIONS(1031),
    [anon_sym_match_BANG] = ACTIONS(1033),
    [anon_sym_function] = ACTIONS(1035),
    [anon_sym_LT_DASH] = ACTIONS(1037),
    [anon_sym_DOT_LBRACK] = ACTIONS(1039),
    [anon_sym_LT] = ACTIONS(1041),
    [anon_sym_use] = ACTIONS(1043),
    [anon_sym_use_BANG] = ACTIONS(1045),
    [anon_sym_do_BANG] = ACTIONS(1047),
    [anon_sym_begin] = ACTIONS(1049),
    [anon_sym_LPAREN2] = ACTIONS(1051),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(1053),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1055),
    [anon_sym_DQUOTE] = ACTIONS(1057),
    [anon_sym_AT_DQUOTE] = ACTIONS(1059),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1061),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1063),
    [sym_bool] = ACTIONS(1065),
    [sym_unit] = ACTIONS(1067),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1069),
    [sym_op_identifier] = ACTIONS(1071),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(1073),
    [sym_xint] = ACTIONS(1075),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1077),
    [sym__newline] = ACTIONS(1079),
  },
  [179] = {
    [sym_function_or_value_defn] = STATE(630),
    [sym__expression] = STATE(219),
    [sym_literal_expression] = STATE(2380),
    [sym_long_identifier_or_op] = STATE(2380),
    [sym_tuple_expression] = STATE(2380),
    [sym_brace_expression] = STATE(2380),
    [sym_anon_record_expression] = STATE(2380),
    [sym_prefixed_expression] = STATE(2380),
    [sym_typecast_expression] = STATE(2380),
    [sym_for_expression] = STATE(2380),
    [sym_while_expression] = STATE(2380),
    [sym__if_branch] = STATE(6456),
    [sym_if_expression] = STATE(2380),
    [sym_fun_expression] = STATE(2380),
    [sym_try_expression] = STATE(2380),
    [sym_match_expression] = STATE(2380),
    [sym_function_expression] = STATE(2380),
    [sym_mutate_expression] = STATE(2380),
    [sym_index_expression] = STATE(2380),
    [sym_typed_expression] = STATE(2380),
    [sym_declaration_expression] = STATE(2380),
    [sym_do_expression] = STATE(2380),
    [sym_list_expression] = STATE(2380),
    [sym_array_expression] = STATE(2380),
    [sym_begin_end_expression] = STATE(2380),
    [sym_paren_expression] = STATE(2380),
    [sym__high_prec_app] = STATE(2383),
    [sym__low_prec_app] = STATE(2383),
    [sym_application_expression] = STATE(2380),
    [sym_dot_expression] = STATE(2380),
    [sym_infix_expression] = STATE(2380),
    [sym_ce_expression] = STATE(2380),
    [sym_sequential_expression] = STATE(2380),
    [sym_char] = STATE(2261),
    [sym_format_string] = STATE(2274),
    [sym__string_literal] = STATE(2274),
    [sym_string] = STATE(2261),
    [sym_verbatim_string] = STATE(2261),
    [sym_bytearray] = STATE(2261),
    [sym_verbatim_bytearray] = STATE(2261),
    [sym_format_triple_quoted_string] = STATE(2275),
    [sym_triple_quoted_string] = STATE(2261),
    [sym_const] = STATE(2380),
    [sym_long_identifier] = STATE(2391),
    [sym_active_pattern] = STATE(2470),
    [sym__identifier_or_op] = STATE(2390),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(632),
    [sym_infix_op] = STATE(616),
    [sym_sbyte] = STATE(2261),
    [sym_byte] = STATE(2261),
    [sym_int16] = STATE(2261),
    [sym_uint16] = STATE(2261),
    [sym_int32] = STATE(2261),
    [sym_uint32] = STATE(2261),
    [sym_nativeint] = STATE(2261),
    [sym_unativeint] = STATE(2261),
    [sym_int64] = STATE(2261),
    [sym_uint64] = STATE(2261),
    [sym_ieee32] = STATE(2261),
    [sym_ieee64] = STATE(2261),
    [sym_bignum] = STATE(2261),
    [sym_decimal] = STATE(2261),
    [sym_float] = STATE(1614),
    [sym_block_comment] = STATE(179),
    [sym_compiler_directive_decl] = STATE(179),
    [sym_fsi_directive_decl] = STATE(179),
    [sym_preproc_line] = STATE(179),
    [sym_preproc_if_in_expression] = STATE(2380),
    [aux_sym_sequential_expression_repeat1] = STATE(1882),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(1081),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(1083),
    [anon_sym_return] = ACTIONS(1085),
    [anon_sym_do] = ACTIONS(1087),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(1089),
    [anon_sym_COMMA] = ACTIONS(1091),
    [anon_sym_null] = ACTIONS(1093),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(1083),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1095),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1097),
    [anon_sym_LBRACE] = ACTIONS(1099),
    [anon_sym_LT_AT] = ACTIONS(1101),
    [anon_sym_LT_AT_AT] = ACTIONS(1103),
    [anon_sym_AT_AT_GT] = ACTIONS(1225),
    [anon_sym_DOT] = ACTIONS(1105),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1107),
    [anon_sym_new] = ACTIONS(1085),
    [anon_sym_return_BANG] = ACTIONS(1109),
    [anon_sym_yield] = ACTIONS(1085),
    [anon_sym_yield_BANG] = ACTIONS(1109),
    [anon_sym_lazy] = ACTIONS(1085),
    [anon_sym_assert] = ACTIONS(1085),
    [anon_sym_upcast] = ACTIONS(1085),
    [anon_sym_downcast] = ACTIONS(1085),
    [anon_sym_COLON_GT] = ACTIONS(1111),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1111),
    [anon_sym_for] = ACTIONS(1113),
    [anon_sym_while] = ACTIONS(1115),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(1117),
    [anon_sym_try] = ACTIONS(1119),
    [anon_sym_match] = ACTIONS(1121),
    [anon_sym_match_BANG] = ACTIONS(1123),
    [anon_sym_function] = ACTIONS(1125),
    [anon_sym_LT_DASH] = ACTIONS(1127),
    [anon_sym_DOT_LBRACK] = ACTIONS(1129),
    [anon_sym_LT] = ACTIONS(1131),
    [anon_sym_use] = ACTIONS(1133),
    [anon_sym_use_BANG] = ACTIONS(1135),
    [anon_sym_do_BANG] = ACTIONS(1137),
    [anon_sym_begin] = ACTIONS(1139),
    [anon_sym_LPAREN2] = ACTIONS(1141),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(1143),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1145),
    [anon_sym_DQUOTE] = ACTIONS(1147),
    [anon_sym_AT_DQUOTE] = ACTIONS(1149),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1151),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1153),
    [sym_bool] = ACTIONS(1155),
    [sym_unit] = ACTIONS(1157),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1159),
    [sym_op_identifier] = ACTIONS(1161),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(1163),
    [sym_xint] = ACTIONS(1165),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1167),
    [sym__newline] = ACTIONS(1169),
  },
  [180] = {
    [sym_function_or_value_defn] = STATE(600),
    [sym__expression] = STATE(88),
    [sym_literal_expression] = STATE(867),
    [sym_long_identifier_or_op] = STATE(867),
    [sym_tuple_expression] = STATE(867),
    [sym_brace_expression] = STATE(867),
    [sym_anon_record_expression] = STATE(867),
    [sym_prefixed_expression] = STATE(867),
    [sym_typecast_expression] = STATE(867),
    [sym_for_expression] = STATE(867),
    [sym_while_expression] = STATE(867),
    [sym__if_branch] = STATE(6511),
    [sym_if_expression] = STATE(867),
    [sym_fun_expression] = STATE(867),
    [sym_try_expression] = STATE(867),
    [sym_match_expression] = STATE(867),
    [sym_function_expression] = STATE(867),
    [sym_mutate_expression] = STATE(867),
    [sym_index_expression] = STATE(867),
    [sym_typed_expression] = STATE(867),
    [sym_declaration_expression] = STATE(867),
    [sym_do_expression] = STATE(867),
    [sym_list_expression] = STATE(867),
    [sym_array_expression] = STATE(867),
    [sym_begin_end_expression] = STATE(867),
    [sym_paren_expression] = STATE(867),
    [sym__high_prec_app] = STATE(864),
    [sym__low_prec_app] = STATE(864),
    [sym_application_expression] = STATE(867),
    [sym_dot_expression] = STATE(867),
    [sym_infix_expression] = STATE(867),
    [sym_ce_expression] = STATE(867),
    [sym_sequential_expression] = STATE(867),
    [sym_char] = STATE(868),
    [sym_format_string] = STATE(869),
    [sym__string_literal] = STATE(869),
    [sym_string] = STATE(868),
    [sym_verbatim_string] = STATE(868),
    [sym_bytearray] = STATE(868),
    [sym_verbatim_bytearray] = STATE(868),
    [sym_format_triple_quoted_string] = STATE(870),
    [sym_triple_quoted_string] = STATE(868),
    [sym_const] = STATE(867),
    [sym_long_identifier] = STATE(872),
    [sym_active_pattern] = STATE(871),
    [sym__identifier_or_op] = STATE(873),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(656),
    [sym_infix_op] = STATE(581),
    [sym_sbyte] = STATE(868),
    [sym_byte] = STATE(868),
    [sym_int16] = STATE(868),
    [sym_uint16] = STATE(868),
    [sym_int32] = STATE(868),
    [sym_uint32] = STATE(868),
    [sym_nativeint] = STATE(868),
    [sym_unativeint] = STATE(868),
    [sym_int64] = STATE(868),
    [sym_uint64] = STATE(868),
    [sym_ieee32] = STATE(868),
    [sym_ieee64] = STATE(868),
    [sym_bignum] = STATE(868),
    [sym_decimal] = STATE(868),
    [sym_float] = STATE(1368),
    [sym_block_comment] = STATE(180),
    [sym_compiler_directive_decl] = STATE(180),
    [sym_fsi_directive_decl] = STATE(180),
    [sym_preproc_line] = STATE(180),
    [sym_preproc_if_in_expression] = STATE(867),
    [aux_sym_sequential_expression_repeat1] = STATE(1542),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(29),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(825),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_COMMA] = ACTIONS(827),
    [anon_sym_null] = ACTIONS(49),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACK_PIPE] = ACTIONS(57),
    [anon_sym_LBRACE] = ACTIONS(139),
    [anon_sym_LT_AT] = ACTIONS(61),
    [anon_sym_LT_AT_AT] = ACTIONS(63),
    [anon_sym_DOT] = ACTIONS(65),
    [anon_sym_LBRACE_PIPE] = ACTIONS(67),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_return_BANG] = ACTIONS(829),
    [anon_sym_yield] = ACTIONS(825),
    [anon_sym_yield_BANG] = ACTIONS(829),
    [anon_sym_lazy] = ACTIONS(825),
    [anon_sym_assert] = ACTIONS(825),
    [anon_sym_upcast] = ACTIONS(825),
    [anon_sym_downcast] = ACTIONS(825),
    [anon_sym_COLON_GT] = ACTIONS(71),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(71),
    [anon_sym_for] = ACTIONS(73),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(79),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_match] = ACTIONS(83),
    [anon_sym_match_BANG] = ACTIONS(85),
    [anon_sym_function] = ACTIONS(87),
    [anon_sym_LT_DASH] = ACTIONS(831),
    [anon_sym_DOT_LBRACK] = ACTIONS(91),
    [anon_sym_LT] = ACTIONS(93),
    [anon_sym_use] = ACTIONS(833),
    [anon_sym_use_BANG] = ACTIONS(835),
    [anon_sym_do_BANG] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(101),
    [anon_sym_LPAREN2] = ACTIONS(103),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(105),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(107),
    [anon_sym_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DQUOTE] = ACTIONS(111),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(115),
    [sym_bool] = ACTIONS(117),
    [sym_unit] = ACTIONS(119),
    [anon_sym_LPAREN_PIPE] = ACTIONS(121),
    [sym_op_identifier] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(837),
    [sym_xint] = ACTIONS(387),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(135),
    [sym__newline] = ACTIONS(839),
    [sym__dedent] = ACTIONS(1227),
  },
  [181] = {
    [sym_function_or_value_defn] = STATE(627),
    [sym__expression] = STATE(17),
    [sym_literal_expression] = STATE(1118),
    [sym_long_identifier_or_op] = STATE(1118),
    [sym_tuple_expression] = STATE(1118),
    [sym_brace_expression] = STATE(1118),
    [sym_anon_record_expression] = STATE(1118),
    [sym_prefixed_expression] = STATE(1118),
    [sym_typecast_expression] = STATE(1118),
    [sym_for_expression] = STATE(1118),
    [sym_while_expression] = STATE(1118),
    [sym__if_branch] = STATE(7163),
    [sym_if_expression] = STATE(1118),
    [sym_fun_expression] = STATE(1118),
    [sym_try_expression] = STATE(1118),
    [sym_match_expression] = STATE(1118),
    [sym_function_expression] = STATE(1118),
    [sym_mutate_expression] = STATE(1118),
    [sym_index_expression] = STATE(1118),
    [sym_typed_expression] = STATE(1118),
    [sym_declaration_expression] = STATE(1118),
    [sym_do_expression] = STATE(1118),
    [sym_list_expression] = STATE(1118),
    [sym_array_expression] = STATE(1118),
    [sym_begin_end_expression] = STATE(1118),
    [sym_paren_expression] = STATE(1118),
    [sym__high_prec_app] = STATE(1133),
    [sym__low_prec_app] = STATE(1133),
    [sym_application_expression] = STATE(1118),
    [sym_dot_expression] = STATE(1118),
    [sym_infix_expression] = STATE(1118),
    [sym_ce_expression] = STATE(1118),
    [sym_sequential_expression] = STATE(1118),
    [sym_char] = STATE(1080),
    [sym_format_string] = STATE(1090),
    [sym__string_literal] = STATE(1090),
    [sym_string] = STATE(1080),
    [sym_verbatim_string] = STATE(1080),
    [sym_bytearray] = STATE(1080),
    [sym_verbatim_bytearray] = STATE(1080),
    [sym_format_triple_quoted_string] = STATE(1096),
    [sym_triple_quoted_string] = STATE(1080),
    [sym_const] = STATE(1118),
    [sym_long_identifier] = STATE(1156),
    [sym_active_pattern] = STATE(1085),
    [sym__identifier_or_op] = STATE(1099),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(517),
    [sym_infix_op] = STATE(487),
    [sym_sbyte] = STATE(1080),
    [sym_byte] = STATE(1080),
    [sym_int16] = STATE(1080),
    [sym_uint16] = STATE(1080),
    [sym_int32] = STATE(1080),
    [sym_uint32] = STATE(1080),
    [sym_nativeint] = STATE(1080),
    [sym_unativeint] = STATE(1080),
    [sym_int64] = STATE(1080),
    [sym_uint64] = STATE(1080),
    [sym_ieee32] = STATE(1080),
    [sym_ieee64] = STATE(1080),
    [sym_bignum] = STATE(1080),
    [sym_decimal] = STATE(1080),
    [sym_float] = STATE(979),
    [sym_block_comment] = STATE(181),
    [sym_compiler_directive_decl] = STATE(181),
    [sym_fsi_directive_decl] = STATE(181),
    [sym_preproc_line] = STATE(181),
    [sym_preproc_if_in_expression] = STATE(1118),
    [aux_sym_sequential_expression_repeat1] = STATE(1069),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(195),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(197),
    [anon_sym_return] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_COMMA] = ACTIONS(205),
    [anon_sym_null] = ACTIONS(207),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(197),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(209),
    [anon_sym_LBRACK_PIPE] = ACTIONS(211),
    [anon_sym_LBRACE] = ACTIONS(271),
    [anon_sym_LT_AT] = ACTIONS(213),
    [anon_sym_LT_AT_AT] = ACTIONS(215),
    [anon_sym_DOT] = ACTIONS(185),
    [anon_sym_LBRACE_PIPE] = ACTIONS(217),
    [anon_sym_new] = ACTIONS(199),
    [anon_sym_with] = ACTIONS(1229),
    [anon_sym_return_BANG] = ACTIONS(219),
    [anon_sym_yield] = ACTIONS(199),
    [anon_sym_yield_BANG] = ACTIONS(219),
    [anon_sym_lazy] = ACTIONS(199),
    [anon_sym_assert] = ACTIONS(199),
    [anon_sym_upcast] = ACTIONS(199),
    [anon_sym_downcast] = ACTIONS(199),
    [anon_sym_COLON_GT] = ACTIONS(221),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(221),
    [anon_sym_for] = ACTIONS(223),
    [anon_sym_while] = ACTIONS(225),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(229),
    [anon_sym_match] = ACTIONS(231),
    [anon_sym_match_BANG] = ACTIONS(233),
    [anon_sym_function] = ACTIONS(235),
    [anon_sym_LT_DASH] = ACTIONS(237),
    [anon_sym_DOT_LBRACK] = ACTIONS(187),
    [anon_sym_LT] = ACTIONS(189),
    [anon_sym_use] = ACTIONS(239),
    [anon_sym_use_BANG] = ACTIONS(241),
    [anon_sym_do_BANG] = ACTIONS(243),
    [anon_sym_begin] = ACTIONS(245),
    [anon_sym_LPAREN2] = ACTIONS(191),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(247),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(251),
    [anon_sym_AT_DQUOTE] = ACTIONS(253),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(255),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(257),
    [sym_bool] = ACTIONS(259),
    [sym_unit] = ACTIONS(193),
    [anon_sym_LPAREN_PIPE] = ACTIONS(261),
    [sym_op_identifier] = ACTIONS(263),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(265),
    [sym_xint] = ACTIONS(267),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(269),
    [sym__newline] = ACTIONS(1231),
  },
  [182] = {
    [sym_function_or_value_defn] = STATE(651),
    [sym__expression] = STATE(167),
    [sym_literal_expression] = STATE(2168),
    [sym_long_identifier_or_op] = STATE(2168),
    [sym_tuple_expression] = STATE(2168),
    [sym_brace_expression] = STATE(2168),
    [sym_anon_record_expression] = STATE(2168),
    [sym_prefixed_expression] = STATE(2168),
    [sym_typecast_expression] = STATE(2168),
    [sym_for_expression] = STATE(2168),
    [sym_while_expression] = STATE(2168),
    [sym__if_branch] = STATE(6406),
    [sym_if_expression] = STATE(2168),
    [sym_fun_expression] = STATE(2168),
    [sym_try_expression] = STATE(2168),
    [sym_match_expression] = STATE(2168),
    [sym_function_expression] = STATE(2168),
    [sym_mutate_expression] = STATE(2168),
    [sym_index_expression] = STATE(2168),
    [sym_typed_expression] = STATE(2168),
    [sym_declaration_expression] = STATE(2168),
    [sym_do_expression] = STATE(2168),
    [sym_list_expression] = STATE(2168),
    [sym_array_expression] = STATE(2168),
    [sym_begin_end_expression] = STATE(2168),
    [sym_paren_expression] = STATE(2168),
    [sym__high_prec_app] = STATE(2179),
    [sym__low_prec_app] = STATE(2179),
    [sym_application_expression] = STATE(2168),
    [sym_dot_expression] = STATE(2168),
    [sym_infix_expression] = STATE(2168),
    [sym_ce_expression] = STATE(2168),
    [sym_sequential_expression] = STATE(2168),
    [sym_char] = STATE(2469),
    [sym_format_string] = STATE(2412),
    [sym__string_literal] = STATE(2412),
    [sym_string] = STATE(2469),
    [sym_verbatim_string] = STATE(2469),
    [sym_bytearray] = STATE(2469),
    [sym_verbatim_bytearray] = STATE(2469),
    [sym_format_triple_quoted_string] = STATE(2408),
    [sym_triple_quoted_string] = STATE(2469),
    [sym_const] = STATE(2168),
    [sym_long_identifier] = STATE(2183),
    [sym_active_pattern] = STATE(2182),
    [sym__identifier_or_op] = STATE(2093),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(650),
    [sym_infix_op] = STATE(721),
    [sym_sbyte] = STATE(2469),
    [sym_byte] = STATE(2469),
    [sym_int16] = STATE(2469),
    [sym_uint16] = STATE(2469),
    [sym_int32] = STATE(2469),
    [sym_uint32] = STATE(2469),
    [sym_nativeint] = STATE(2469),
    [sym_unativeint] = STATE(2469),
    [sym_int64] = STATE(2469),
    [sym_uint64] = STATE(2469),
    [sym_ieee32] = STATE(2469),
    [sym_ieee64] = STATE(2469),
    [sym_bignum] = STATE(2469),
    [sym_decimal] = STATE(2469),
    [sym_float] = STATE(1586),
    [sym_block_comment] = STATE(182),
    [sym_compiler_directive_decl] = STATE(182),
    [sym_fsi_directive_decl] = STATE(182),
    [sym_preproc_line] = STATE(182),
    [sym_preproc_if_in_expression] = STATE(2168),
    [aux_sym_sequential_expression_repeat1] = STATE(1755),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(989),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(991),
    [anon_sym_return] = ACTIONS(993),
    [anon_sym_do] = ACTIONS(995),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(997),
    [anon_sym_COMMA] = ACTIONS(999),
    [anon_sym_null] = ACTIONS(1001),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(991),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1003),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1005),
    [anon_sym_LBRACE] = ACTIONS(1007),
    [anon_sym_LT_AT] = ACTIONS(1009),
    [anon_sym_AT_GT] = ACTIONS(161),
    [anon_sym_LT_AT_AT] = ACTIONS(1013),
    [anon_sym_DOT] = ACTIONS(1015),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1017),
    [anon_sym_new] = ACTIONS(993),
    [anon_sym_return_BANG] = ACTIONS(1019),
    [anon_sym_yield] = ACTIONS(993),
    [anon_sym_yield_BANG] = ACTIONS(1019),
    [anon_sym_lazy] = ACTIONS(993),
    [anon_sym_assert] = ACTIONS(993),
    [anon_sym_upcast] = ACTIONS(993),
    [anon_sym_downcast] = ACTIONS(993),
    [anon_sym_COLON_GT] = ACTIONS(1021),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1021),
    [anon_sym_for] = ACTIONS(1023),
    [anon_sym_while] = ACTIONS(1025),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(1027),
    [anon_sym_try] = ACTIONS(1029),
    [anon_sym_match] = ACTIONS(1031),
    [anon_sym_match_BANG] = ACTIONS(1033),
    [anon_sym_function] = ACTIONS(1035),
    [anon_sym_LT_DASH] = ACTIONS(1037),
    [anon_sym_DOT_LBRACK] = ACTIONS(1039),
    [anon_sym_LT] = ACTIONS(1041),
    [anon_sym_use] = ACTIONS(1043),
    [anon_sym_use_BANG] = ACTIONS(1045),
    [anon_sym_do_BANG] = ACTIONS(1047),
    [anon_sym_begin] = ACTIONS(1049),
    [anon_sym_LPAREN2] = ACTIONS(1051),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(1053),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1055),
    [anon_sym_DQUOTE] = ACTIONS(1057),
    [anon_sym_AT_DQUOTE] = ACTIONS(1059),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1061),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1063),
    [sym_bool] = ACTIONS(1065),
    [sym_unit] = ACTIONS(1067),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1069),
    [sym_op_identifier] = ACTIONS(1071),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(1073),
    [sym_xint] = ACTIONS(1075),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1077),
    [sym__newline] = ACTIONS(1079),
  },
  [183] = {
    [sym_function_or_value_defn] = STATE(651),
    [sym__expression] = STATE(167),
    [sym_literal_expression] = STATE(2168),
    [sym_long_identifier_or_op] = STATE(2168),
    [sym_tuple_expression] = STATE(2168),
    [sym_brace_expression] = STATE(2168),
    [sym_anon_record_expression] = STATE(2168),
    [sym_prefixed_expression] = STATE(2168),
    [sym_typecast_expression] = STATE(2168),
    [sym_for_expression] = STATE(2168),
    [sym_while_expression] = STATE(2168),
    [sym__if_branch] = STATE(6406),
    [sym_if_expression] = STATE(2168),
    [sym_fun_expression] = STATE(2168),
    [sym_try_expression] = STATE(2168),
    [sym_match_expression] = STATE(2168),
    [sym_function_expression] = STATE(2168),
    [sym_mutate_expression] = STATE(2168),
    [sym_index_expression] = STATE(2168),
    [sym_typed_expression] = STATE(2168),
    [sym_declaration_expression] = STATE(2168),
    [sym_do_expression] = STATE(2168),
    [sym_list_expression] = STATE(2168),
    [sym_array_expression] = STATE(2168),
    [sym_begin_end_expression] = STATE(2168),
    [sym_paren_expression] = STATE(2168),
    [sym__high_prec_app] = STATE(2179),
    [sym__low_prec_app] = STATE(2179),
    [sym_application_expression] = STATE(2168),
    [sym_dot_expression] = STATE(2168),
    [sym_infix_expression] = STATE(2168),
    [sym_ce_expression] = STATE(2168),
    [sym_sequential_expression] = STATE(2168),
    [sym_char] = STATE(2469),
    [sym_format_string] = STATE(2412),
    [sym__string_literal] = STATE(2412),
    [sym_string] = STATE(2469),
    [sym_verbatim_string] = STATE(2469),
    [sym_bytearray] = STATE(2469),
    [sym_verbatim_bytearray] = STATE(2469),
    [sym_format_triple_quoted_string] = STATE(2408),
    [sym_triple_quoted_string] = STATE(2469),
    [sym_const] = STATE(2168),
    [sym_long_identifier] = STATE(2183),
    [sym_active_pattern] = STATE(2182),
    [sym__identifier_or_op] = STATE(2093),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(650),
    [sym_infix_op] = STATE(721),
    [sym_sbyte] = STATE(2469),
    [sym_byte] = STATE(2469),
    [sym_int16] = STATE(2469),
    [sym_uint16] = STATE(2469),
    [sym_int32] = STATE(2469),
    [sym_uint32] = STATE(2469),
    [sym_nativeint] = STATE(2469),
    [sym_unativeint] = STATE(2469),
    [sym_int64] = STATE(2469),
    [sym_uint64] = STATE(2469),
    [sym_ieee32] = STATE(2469),
    [sym_ieee64] = STATE(2469),
    [sym_bignum] = STATE(2469),
    [sym_decimal] = STATE(2469),
    [sym_float] = STATE(1586),
    [sym_block_comment] = STATE(183),
    [sym_compiler_directive_decl] = STATE(183),
    [sym_fsi_directive_decl] = STATE(183),
    [sym_preproc_line] = STATE(183),
    [sym_preproc_if_in_expression] = STATE(2168),
    [aux_sym_sequential_expression_repeat1] = STATE(1755),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(989),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(991),
    [anon_sym_return] = ACTIONS(993),
    [anon_sym_do] = ACTIONS(995),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(997),
    [anon_sym_COMMA] = ACTIONS(999),
    [anon_sym_null] = ACTIONS(1001),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(991),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1003),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1005),
    [anon_sym_LBRACE] = ACTIONS(165),
    [anon_sym_LT_AT] = ACTIONS(1009),
    [anon_sym_AT_GT] = ACTIONS(165),
    [anon_sym_LT_AT_AT] = ACTIONS(1013),
    [anon_sym_DOT] = ACTIONS(1015),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1017),
    [anon_sym_new] = ACTIONS(993),
    [anon_sym_return_BANG] = ACTIONS(1019),
    [anon_sym_yield] = ACTIONS(993),
    [anon_sym_yield_BANG] = ACTIONS(1019),
    [anon_sym_lazy] = ACTIONS(993),
    [anon_sym_assert] = ACTIONS(993),
    [anon_sym_upcast] = ACTIONS(993),
    [anon_sym_downcast] = ACTIONS(993),
    [anon_sym_COLON_GT] = ACTIONS(1021),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1021),
    [anon_sym_for] = ACTIONS(1023),
    [anon_sym_while] = ACTIONS(1025),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(1027),
    [anon_sym_try] = ACTIONS(1029),
    [anon_sym_match] = ACTIONS(1031),
    [anon_sym_match_BANG] = ACTIONS(1033),
    [anon_sym_function] = ACTIONS(1035),
    [anon_sym_LT_DASH] = ACTIONS(1037),
    [anon_sym_DOT_LBRACK] = ACTIONS(1039),
    [anon_sym_LT] = ACTIONS(1041),
    [anon_sym_use] = ACTIONS(1043),
    [anon_sym_use_BANG] = ACTIONS(1045),
    [anon_sym_do_BANG] = ACTIONS(1047),
    [anon_sym_begin] = ACTIONS(1049),
    [anon_sym_LPAREN2] = ACTIONS(1051),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(1053),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1055),
    [anon_sym_DQUOTE] = ACTIONS(1057),
    [anon_sym_AT_DQUOTE] = ACTIONS(1059),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1061),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1063),
    [sym_bool] = ACTIONS(1065),
    [sym_unit] = ACTIONS(1067),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1069),
    [sym_op_identifier] = ACTIONS(1071),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(1073),
    [sym_xint] = ACTIONS(1075),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1077),
    [sym__newline] = ACTIONS(163),
  },
  [184] = {
    [sym_function_or_value_defn] = STATE(651),
    [sym__expression] = STATE(167),
    [sym_literal_expression] = STATE(2168),
    [sym_long_identifier_or_op] = STATE(2168),
    [sym_tuple_expression] = STATE(2168),
    [sym_brace_expression] = STATE(2168),
    [sym_anon_record_expression] = STATE(2168),
    [sym_prefixed_expression] = STATE(2168),
    [sym_typecast_expression] = STATE(2168),
    [sym_for_expression] = STATE(2168),
    [sym_while_expression] = STATE(2168),
    [sym__if_branch] = STATE(6406),
    [sym_if_expression] = STATE(2168),
    [sym_fun_expression] = STATE(2168),
    [sym_try_expression] = STATE(2168),
    [sym_match_expression] = STATE(2168),
    [sym_function_expression] = STATE(2168),
    [sym_mutate_expression] = STATE(2168),
    [sym_index_expression] = STATE(2168),
    [sym_typed_expression] = STATE(2168),
    [sym_declaration_expression] = STATE(2168),
    [sym_do_expression] = STATE(2168),
    [sym_list_expression] = STATE(2168),
    [sym_array_expression] = STATE(2168),
    [sym_begin_end_expression] = STATE(2168),
    [sym_paren_expression] = STATE(2168),
    [sym__high_prec_app] = STATE(2179),
    [sym__low_prec_app] = STATE(2179),
    [sym_application_expression] = STATE(2168),
    [sym_dot_expression] = STATE(2168),
    [sym_infix_expression] = STATE(2168),
    [sym_ce_expression] = STATE(2168),
    [sym_sequential_expression] = STATE(2168),
    [sym_char] = STATE(2469),
    [sym_format_string] = STATE(2412),
    [sym__string_literal] = STATE(2412),
    [sym_string] = STATE(2469),
    [sym_verbatim_string] = STATE(2469),
    [sym_bytearray] = STATE(2469),
    [sym_verbatim_bytearray] = STATE(2469),
    [sym_format_triple_quoted_string] = STATE(2408),
    [sym_triple_quoted_string] = STATE(2469),
    [sym_const] = STATE(2168),
    [sym_long_identifier] = STATE(2183),
    [sym_active_pattern] = STATE(2182),
    [sym__identifier_or_op] = STATE(2093),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(650),
    [sym_infix_op] = STATE(721),
    [sym_sbyte] = STATE(2469),
    [sym_byte] = STATE(2469),
    [sym_int16] = STATE(2469),
    [sym_uint16] = STATE(2469),
    [sym_int32] = STATE(2469),
    [sym_uint32] = STATE(2469),
    [sym_nativeint] = STATE(2469),
    [sym_unativeint] = STATE(2469),
    [sym_int64] = STATE(2469),
    [sym_uint64] = STATE(2469),
    [sym_ieee32] = STATE(2469),
    [sym_ieee64] = STATE(2469),
    [sym_bignum] = STATE(2469),
    [sym_decimal] = STATE(2469),
    [sym_float] = STATE(1586),
    [sym_block_comment] = STATE(184),
    [sym_compiler_directive_decl] = STATE(184),
    [sym_fsi_directive_decl] = STATE(184),
    [sym_preproc_line] = STATE(184),
    [sym_preproc_if_in_expression] = STATE(2168),
    [aux_sym_sequential_expression_repeat1] = STATE(1755),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(989),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(991),
    [anon_sym_return] = ACTIONS(993),
    [anon_sym_do] = ACTIONS(995),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(997),
    [anon_sym_COMMA] = ACTIONS(999),
    [anon_sym_null] = ACTIONS(1001),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(991),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1003),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1005),
    [anon_sym_LBRACE] = ACTIONS(169),
    [anon_sym_LT_AT] = ACTIONS(1009),
    [anon_sym_AT_GT] = ACTIONS(169),
    [anon_sym_LT_AT_AT] = ACTIONS(1013),
    [anon_sym_DOT] = ACTIONS(1015),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1017),
    [anon_sym_new] = ACTIONS(993),
    [anon_sym_return_BANG] = ACTIONS(1019),
    [anon_sym_yield] = ACTIONS(993),
    [anon_sym_yield_BANG] = ACTIONS(1019),
    [anon_sym_lazy] = ACTIONS(993),
    [anon_sym_assert] = ACTIONS(993),
    [anon_sym_upcast] = ACTIONS(993),
    [anon_sym_downcast] = ACTIONS(993),
    [anon_sym_COLON_GT] = ACTIONS(1021),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1021),
    [anon_sym_for] = ACTIONS(1023),
    [anon_sym_while] = ACTIONS(1025),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(1027),
    [anon_sym_try] = ACTIONS(1029),
    [anon_sym_match] = ACTIONS(1031),
    [anon_sym_match_BANG] = ACTIONS(1033),
    [anon_sym_function] = ACTIONS(1035),
    [anon_sym_LT_DASH] = ACTIONS(1037),
    [anon_sym_DOT_LBRACK] = ACTIONS(1039),
    [anon_sym_LT] = ACTIONS(1041),
    [anon_sym_use] = ACTIONS(1043),
    [anon_sym_use_BANG] = ACTIONS(1045),
    [anon_sym_do_BANG] = ACTIONS(1047),
    [anon_sym_begin] = ACTIONS(1049),
    [anon_sym_LPAREN2] = ACTIONS(1051),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(1053),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1055),
    [anon_sym_DQUOTE] = ACTIONS(1057),
    [anon_sym_AT_DQUOTE] = ACTIONS(1059),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1061),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1063),
    [sym_bool] = ACTIONS(1065),
    [sym_unit] = ACTIONS(1067),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1069),
    [sym_op_identifier] = ACTIONS(1071),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(1073),
    [sym_xint] = ACTIONS(1075),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1077),
    [sym__newline] = ACTIONS(167),
  },
  [185] = {
    [sym_function_or_value_defn] = STATE(651),
    [sym__expression] = STATE(167),
    [sym_literal_expression] = STATE(2168),
    [sym_long_identifier_or_op] = STATE(2168),
    [sym_tuple_expression] = STATE(2168),
    [sym_brace_expression] = STATE(2168),
    [sym_anon_record_expression] = STATE(2168),
    [sym_prefixed_expression] = STATE(2168),
    [sym_typecast_expression] = STATE(2168),
    [sym_for_expression] = STATE(2168),
    [sym_while_expression] = STATE(2168),
    [sym__if_branch] = STATE(6406),
    [sym_if_expression] = STATE(2168),
    [sym_fun_expression] = STATE(2168),
    [sym_try_expression] = STATE(2168),
    [sym_match_expression] = STATE(2168),
    [sym_function_expression] = STATE(2168),
    [sym_mutate_expression] = STATE(2168),
    [sym_index_expression] = STATE(2168),
    [sym_typed_expression] = STATE(2168),
    [sym_declaration_expression] = STATE(2168),
    [sym_do_expression] = STATE(2168),
    [sym_list_expression] = STATE(2168),
    [sym_array_expression] = STATE(2168),
    [sym_begin_end_expression] = STATE(2168),
    [sym_paren_expression] = STATE(2168),
    [sym__high_prec_app] = STATE(2179),
    [sym__low_prec_app] = STATE(2179),
    [sym_application_expression] = STATE(2168),
    [sym_dot_expression] = STATE(2168),
    [sym_infix_expression] = STATE(2168),
    [sym_ce_expression] = STATE(2168),
    [sym_sequential_expression] = STATE(2168),
    [sym_char] = STATE(2469),
    [sym_format_string] = STATE(2412),
    [sym__string_literal] = STATE(2412),
    [sym_string] = STATE(2469),
    [sym_verbatim_string] = STATE(2469),
    [sym_bytearray] = STATE(2469),
    [sym_verbatim_bytearray] = STATE(2469),
    [sym_format_triple_quoted_string] = STATE(2408),
    [sym_triple_quoted_string] = STATE(2469),
    [sym_const] = STATE(2168),
    [sym_long_identifier] = STATE(2183),
    [sym_active_pattern] = STATE(2182),
    [sym__identifier_or_op] = STATE(2093),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(650),
    [sym_infix_op] = STATE(721),
    [sym_sbyte] = STATE(2469),
    [sym_byte] = STATE(2469),
    [sym_int16] = STATE(2469),
    [sym_uint16] = STATE(2469),
    [sym_int32] = STATE(2469),
    [sym_uint32] = STATE(2469),
    [sym_nativeint] = STATE(2469),
    [sym_unativeint] = STATE(2469),
    [sym_int64] = STATE(2469),
    [sym_uint64] = STATE(2469),
    [sym_ieee32] = STATE(2469),
    [sym_ieee64] = STATE(2469),
    [sym_bignum] = STATE(2469),
    [sym_decimal] = STATE(2469),
    [sym_float] = STATE(1586),
    [sym_block_comment] = STATE(185),
    [sym_compiler_directive_decl] = STATE(185),
    [sym_fsi_directive_decl] = STATE(185),
    [sym_preproc_line] = STATE(185),
    [sym_preproc_if_in_expression] = STATE(2168),
    [aux_sym_sequential_expression_repeat1] = STATE(1755),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(181),
    [anon_sym_EQ] = ACTIONS(183),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_return] = ACTIONS(181),
    [anon_sym_do] = ACTIONS(181),
    [anon_sym_let] = ACTIONS(181),
    [anon_sym_let_BANG] = ACTIONS(183),
    [anon_sym_LPAREN] = ACTIONS(181),
    [anon_sym_COMMA] = ACTIONS(183),
    [anon_sym_null] = ACTIONS(181),
    [anon_sym_QMARK] = ACTIONS(181),
    [anon_sym_COLON_QMARK] = ACTIONS(181),
    [anon_sym_COLON_COLON] = ACTIONS(183),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_LBRACK_PIPE] = ACTIONS(183),
    [anon_sym_LBRACE] = ACTIONS(181),
    [anon_sym_LT_AT] = ACTIONS(181),
    [anon_sym_AT_GT] = ACTIONS(181),
    [anon_sym_LT_AT_AT] = ACTIONS(181),
    [anon_sym_DOT] = ACTIONS(1015),
    [anon_sym_LBRACE_PIPE] = ACTIONS(183),
    [anon_sym_new] = ACTIONS(181),
    [anon_sym_return_BANG] = ACTIONS(183),
    [anon_sym_yield] = ACTIONS(181),
    [anon_sym_yield_BANG] = ACTIONS(183),
    [anon_sym_lazy] = ACTIONS(181),
    [anon_sym_assert] = ACTIONS(181),
    [anon_sym_upcast] = ACTIONS(181),
    [anon_sym_downcast] = ACTIONS(181),
    [anon_sym_COLON_GT] = ACTIONS(183),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(183),
    [anon_sym_for] = ACTIONS(181),
    [anon_sym_while] = ACTIONS(181),
    [anon_sym_if] = ACTIONS(181),
    [anon_sym_fun] = ACTIONS(181),
    [anon_sym_try] = ACTIONS(181),
    [anon_sym_match] = ACTIONS(181),
    [anon_sym_match_BANG] = ACTIONS(183),
    [anon_sym_function] = ACTIONS(181),
    [anon_sym_LT_DASH] = ACTIONS(181),
    [anon_sym_DOT_LBRACK] = ACTIONS(1039),
    [anon_sym_LT] = ACTIONS(1041),
    [anon_sym_use] = ACTIONS(181),
    [anon_sym_use_BANG] = ACTIONS(183),
    [anon_sym_do_BANG] = ACTIONS(183),
    [anon_sym_begin] = ACTIONS(181),
    [anon_sym_LPAREN2] = ACTIONS(1051),
    [anon_sym_or] = ACTIONS(181),
    [aux_sym_char_token1] = ACTIONS(183),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(181),
    [anon_sym_DQUOTE] = ACTIONS(181),
    [anon_sym_AT_DQUOTE] = ACTIONS(183),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(183),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(183),
    [sym_bool] = ACTIONS(181),
    [sym_unit] = ACTIONS(1067),
    [anon_sym_LPAREN_PIPE] = ACTIONS(181),
    [sym_op_identifier] = ACTIONS(181),
    [anon_sym_PLUS] = ACTIONS(181),
    [anon_sym_DASH] = ACTIONS(181),
    [anon_sym_PLUS_DOT] = ACTIONS(181),
    [anon_sym_DASH_DOT] = ACTIONS(181),
    [anon_sym_PERCENT] = ACTIONS(181),
    [anon_sym_AMP_AMP] = ACTIONS(181),
    [anon_sym_TILDE] = ACTIONS(183),
    [aux_sym_prefix_op_token1] = ACTIONS(181),
    [aux_sym_infix_op_token1] = ACTIONS(183),
    [aux_sym_infix_op_token2] = ACTIONS(181),
    [anon_sym_PIPE_PIPE] = ACTIONS(181),
    [anon_sym_BANG_EQ] = ACTIONS(181),
    [anon_sym_COLON_EQ] = ACTIONS(183),
    [anon_sym_DOLLAR] = ACTIONS(181),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(181),
    [sym_int] = ACTIONS(181),
    [sym_xint] = ACTIONS(183),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(183),
    [sym__newline] = ACTIONS(183),
  },
  [186] = {
    [sym_function_or_value_defn] = STATE(600),
    [sym__expression] = STATE(88),
    [sym_literal_expression] = STATE(867),
    [sym_long_identifier_or_op] = STATE(867),
    [sym_tuple_expression] = STATE(867),
    [sym_brace_expression] = STATE(867),
    [sym_anon_record_expression] = STATE(867),
    [sym_prefixed_expression] = STATE(867),
    [sym_typecast_expression] = STATE(867),
    [sym_for_expression] = STATE(867),
    [sym_while_expression] = STATE(867),
    [sym__if_branch] = STATE(6511),
    [sym_if_expression] = STATE(867),
    [sym_fun_expression] = STATE(867),
    [sym_try_expression] = STATE(867),
    [sym_match_expression] = STATE(867),
    [sym_function_expression] = STATE(867),
    [sym_mutate_expression] = STATE(867),
    [sym_index_expression] = STATE(867),
    [sym_typed_expression] = STATE(867),
    [sym_declaration_expression] = STATE(867),
    [sym_do_expression] = STATE(867),
    [sym_list_expression] = STATE(867),
    [sym_array_expression] = STATE(867),
    [sym_begin_end_expression] = STATE(867),
    [sym_paren_expression] = STATE(867),
    [sym__high_prec_app] = STATE(864),
    [sym__low_prec_app] = STATE(864),
    [sym_application_expression] = STATE(867),
    [sym_dot_expression] = STATE(867),
    [sym_infix_expression] = STATE(867),
    [sym_ce_expression] = STATE(867),
    [sym_sequential_expression] = STATE(867),
    [sym_char] = STATE(868),
    [sym_format_string] = STATE(869),
    [sym__string_literal] = STATE(869),
    [sym_string] = STATE(868),
    [sym_verbatim_string] = STATE(868),
    [sym_bytearray] = STATE(868),
    [sym_verbatim_bytearray] = STATE(868),
    [sym_format_triple_quoted_string] = STATE(870),
    [sym_triple_quoted_string] = STATE(868),
    [sym_const] = STATE(867),
    [sym_long_identifier] = STATE(872),
    [sym_active_pattern] = STATE(871),
    [sym__identifier_or_op] = STATE(873),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(656),
    [sym_infix_op] = STATE(581),
    [sym_sbyte] = STATE(868),
    [sym_byte] = STATE(868),
    [sym_int16] = STATE(868),
    [sym_uint16] = STATE(868),
    [sym_int32] = STATE(868),
    [sym_uint32] = STATE(868),
    [sym_nativeint] = STATE(868),
    [sym_unativeint] = STATE(868),
    [sym_int64] = STATE(868),
    [sym_uint64] = STATE(868),
    [sym_ieee32] = STATE(868),
    [sym_ieee64] = STATE(868),
    [sym_bignum] = STATE(868),
    [sym_decimal] = STATE(868),
    [sym_float] = STATE(1368),
    [sym_block_comment] = STATE(186),
    [sym_compiler_directive_decl] = STATE(186),
    [sym_fsi_directive_decl] = STATE(186),
    [sym_preproc_line] = STATE(186),
    [sym_preproc_if_in_expression] = STATE(867),
    [aux_sym_sequential_expression_repeat1] = STATE(1542),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(29),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(825),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_COMMA] = ACTIONS(827),
    [anon_sym_null] = ACTIONS(49),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACK_PIPE] = ACTIONS(57),
    [anon_sym_LBRACE] = ACTIONS(139),
    [anon_sym_LT_AT] = ACTIONS(61),
    [anon_sym_LT_AT_AT] = ACTIONS(63),
    [anon_sym_DOT] = ACTIONS(65),
    [anon_sym_LBRACE_PIPE] = ACTIONS(67),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_return_BANG] = ACTIONS(829),
    [anon_sym_yield] = ACTIONS(825),
    [anon_sym_yield_BANG] = ACTIONS(829),
    [anon_sym_lazy] = ACTIONS(825),
    [anon_sym_assert] = ACTIONS(825),
    [anon_sym_upcast] = ACTIONS(825),
    [anon_sym_downcast] = ACTIONS(825),
    [anon_sym_COLON_GT] = ACTIONS(71),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(71),
    [anon_sym_for] = ACTIONS(73),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(79),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_match] = ACTIONS(83),
    [anon_sym_match_BANG] = ACTIONS(85),
    [anon_sym_function] = ACTIONS(87),
    [anon_sym_LT_DASH] = ACTIONS(831),
    [anon_sym_DOT_LBRACK] = ACTIONS(91),
    [anon_sym_LT] = ACTIONS(93),
    [anon_sym_use] = ACTIONS(833),
    [anon_sym_use_BANG] = ACTIONS(835),
    [anon_sym_do_BANG] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(101),
    [anon_sym_LPAREN2] = ACTIONS(103),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(105),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(107),
    [anon_sym_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DQUOTE] = ACTIONS(111),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(115),
    [sym_bool] = ACTIONS(117),
    [sym_unit] = ACTIONS(119),
    [anon_sym_LPAREN_PIPE] = ACTIONS(121),
    [sym_op_identifier] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(837),
    [sym_xint] = ACTIONS(387),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(135),
    [sym__newline] = ACTIONS(839),
    [sym__dedent] = ACTIONS(1233),
  },
  [187] = {
    [sym_function_or_value_defn] = STATE(600),
    [sym__expression] = STATE(88),
    [sym_literal_expression] = STATE(867),
    [sym_long_identifier_or_op] = STATE(867),
    [sym_tuple_expression] = STATE(867),
    [sym_brace_expression] = STATE(867),
    [sym_anon_record_expression] = STATE(867),
    [sym_prefixed_expression] = STATE(867),
    [sym_typecast_expression] = STATE(867),
    [sym_for_expression] = STATE(867),
    [sym_while_expression] = STATE(867),
    [sym__if_branch] = STATE(6511),
    [sym_if_expression] = STATE(867),
    [sym_fun_expression] = STATE(867),
    [sym_try_expression] = STATE(867),
    [sym_match_expression] = STATE(867),
    [sym_function_expression] = STATE(867),
    [sym_mutate_expression] = STATE(867),
    [sym_index_expression] = STATE(867),
    [sym_typed_expression] = STATE(867),
    [sym_declaration_expression] = STATE(867),
    [sym_do_expression] = STATE(867),
    [sym_list_expression] = STATE(867),
    [sym_array_expression] = STATE(867),
    [sym_begin_end_expression] = STATE(867),
    [sym_paren_expression] = STATE(867),
    [sym__high_prec_app] = STATE(864),
    [sym__low_prec_app] = STATE(864),
    [sym_application_expression] = STATE(867),
    [sym_dot_expression] = STATE(867),
    [sym_infix_expression] = STATE(867),
    [sym_ce_expression] = STATE(867),
    [sym_sequential_expression] = STATE(867),
    [sym_char] = STATE(868),
    [sym_format_string] = STATE(869),
    [sym__string_literal] = STATE(869),
    [sym_string] = STATE(868),
    [sym_verbatim_string] = STATE(868),
    [sym_bytearray] = STATE(868),
    [sym_verbatim_bytearray] = STATE(868),
    [sym_format_triple_quoted_string] = STATE(870),
    [sym_triple_quoted_string] = STATE(868),
    [sym_const] = STATE(867),
    [sym_long_identifier] = STATE(872),
    [sym_active_pattern] = STATE(871),
    [sym__identifier_or_op] = STATE(873),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(656),
    [sym_infix_op] = STATE(581),
    [sym_sbyte] = STATE(868),
    [sym_byte] = STATE(868),
    [sym_int16] = STATE(868),
    [sym_uint16] = STATE(868),
    [sym_int32] = STATE(868),
    [sym_uint32] = STATE(868),
    [sym_nativeint] = STATE(868),
    [sym_unativeint] = STATE(868),
    [sym_int64] = STATE(868),
    [sym_uint64] = STATE(868),
    [sym_ieee32] = STATE(868),
    [sym_ieee64] = STATE(868),
    [sym_bignum] = STATE(868),
    [sym_decimal] = STATE(868),
    [sym_float] = STATE(1368),
    [sym_block_comment] = STATE(187),
    [sym_compiler_directive_decl] = STATE(187),
    [sym_fsi_directive_decl] = STATE(187),
    [sym_preproc_line] = STATE(187),
    [sym_preproc_if_in_expression] = STATE(867),
    [aux_sym_sequential_expression_repeat1] = STATE(1542),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(29),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(825),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_COMMA] = ACTIONS(827),
    [anon_sym_null] = ACTIONS(49),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACK_PIPE] = ACTIONS(57),
    [anon_sym_LBRACE] = ACTIONS(139),
    [anon_sym_LT_AT] = ACTIONS(61),
    [anon_sym_LT_AT_AT] = ACTIONS(63),
    [anon_sym_DOT] = ACTIONS(65),
    [anon_sym_LBRACE_PIPE] = ACTIONS(67),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_return_BANG] = ACTIONS(829),
    [anon_sym_yield] = ACTIONS(825),
    [anon_sym_yield_BANG] = ACTIONS(829),
    [anon_sym_lazy] = ACTIONS(825),
    [anon_sym_assert] = ACTIONS(825),
    [anon_sym_upcast] = ACTIONS(825),
    [anon_sym_downcast] = ACTIONS(825),
    [anon_sym_COLON_GT] = ACTIONS(71),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(71),
    [anon_sym_for] = ACTIONS(73),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(79),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_match] = ACTIONS(83),
    [anon_sym_match_BANG] = ACTIONS(85),
    [anon_sym_function] = ACTIONS(87),
    [anon_sym_LT_DASH] = ACTIONS(831),
    [anon_sym_DOT_LBRACK] = ACTIONS(91),
    [anon_sym_LT] = ACTIONS(93),
    [anon_sym_use] = ACTIONS(833),
    [anon_sym_use_BANG] = ACTIONS(835),
    [anon_sym_do_BANG] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(101),
    [anon_sym_LPAREN2] = ACTIONS(103),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(105),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(107),
    [anon_sym_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DQUOTE] = ACTIONS(111),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(115),
    [sym_bool] = ACTIONS(117),
    [sym_unit] = ACTIONS(119),
    [anon_sym_LPAREN_PIPE] = ACTIONS(121),
    [sym_op_identifier] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(837),
    [sym_xint] = ACTIONS(387),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(135),
    [sym__newline] = ACTIONS(839),
    [sym__dedent] = ACTIONS(1235),
  },
  [188] = {
    [sym_function_or_value_defn] = STATE(630),
    [sym__expression] = STATE(219),
    [sym_literal_expression] = STATE(2380),
    [sym_long_identifier_or_op] = STATE(2380),
    [sym_tuple_expression] = STATE(2380),
    [sym_brace_expression] = STATE(2380),
    [sym_anon_record_expression] = STATE(2380),
    [sym_prefixed_expression] = STATE(2380),
    [sym_typecast_expression] = STATE(2380),
    [sym_for_expression] = STATE(2380),
    [sym_while_expression] = STATE(2380),
    [sym__if_branch] = STATE(6456),
    [sym_if_expression] = STATE(2380),
    [sym_fun_expression] = STATE(2380),
    [sym_try_expression] = STATE(2380),
    [sym_match_expression] = STATE(2380),
    [sym_function_expression] = STATE(2380),
    [sym_mutate_expression] = STATE(2380),
    [sym_index_expression] = STATE(2380),
    [sym_typed_expression] = STATE(2380),
    [sym_declaration_expression] = STATE(2380),
    [sym_do_expression] = STATE(2380),
    [sym_list_expression] = STATE(2380),
    [sym_array_expression] = STATE(2380),
    [sym_begin_end_expression] = STATE(2380),
    [sym_paren_expression] = STATE(2380),
    [sym__high_prec_app] = STATE(2383),
    [sym__low_prec_app] = STATE(2383),
    [sym_application_expression] = STATE(2380),
    [sym_dot_expression] = STATE(2380),
    [sym_infix_expression] = STATE(2380),
    [sym_ce_expression] = STATE(2380),
    [sym_sequential_expression] = STATE(2380),
    [sym_char] = STATE(2261),
    [sym_format_string] = STATE(2274),
    [sym__string_literal] = STATE(2274),
    [sym_string] = STATE(2261),
    [sym_verbatim_string] = STATE(2261),
    [sym_bytearray] = STATE(2261),
    [sym_verbatim_bytearray] = STATE(2261),
    [sym_format_triple_quoted_string] = STATE(2275),
    [sym_triple_quoted_string] = STATE(2261),
    [sym_const] = STATE(2380),
    [sym_long_identifier] = STATE(2391),
    [sym_active_pattern] = STATE(2470),
    [sym__identifier_or_op] = STATE(2390),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(632),
    [sym_infix_op] = STATE(616),
    [sym_sbyte] = STATE(2261),
    [sym_byte] = STATE(2261),
    [sym_int16] = STATE(2261),
    [sym_uint16] = STATE(2261),
    [sym_int32] = STATE(2261),
    [sym_uint32] = STATE(2261),
    [sym_nativeint] = STATE(2261),
    [sym_unativeint] = STATE(2261),
    [sym_int64] = STATE(2261),
    [sym_uint64] = STATE(2261),
    [sym_ieee32] = STATE(2261),
    [sym_ieee64] = STATE(2261),
    [sym_bignum] = STATE(2261),
    [sym_decimal] = STATE(2261),
    [sym_float] = STATE(1614),
    [sym_block_comment] = STATE(188),
    [sym_compiler_directive_decl] = STATE(188),
    [sym_fsi_directive_decl] = STATE(188),
    [sym_preproc_line] = STATE(188),
    [sym_preproc_if_in_expression] = STATE(2380),
    [aux_sym_sequential_expression_repeat1] = STATE(1882),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(1081),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(1083),
    [anon_sym_return] = ACTIONS(1085),
    [anon_sym_do] = ACTIONS(1087),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(1089),
    [anon_sym_COMMA] = ACTIONS(1091),
    [anon_sym_null] = ACTIONS(1093),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(1083),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1095),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1097),
    [anon_sym_LBRACE] = ACTIONS(1099),
    [anon_sym_LT_AT] = ACTIONS(1101),
    [anon_sym_LT_AT_AT] = ACTIONS(1103),
    [anon_sym_AT_AT_GT] = ACTIONS(1237),
    [anon_sym_DOT] = ACTIONS(1105),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1107),
    [anon_sym_new] = ACTIONS(1085),
    [anon_sym_return_BANG] = ACTIONS(1109),
    [anon_sym_yield] = ACTIONS(1085),
    [anon_sym_yield_BANG] = ACTIONS(1109),
    [anon_sym_lazy] = ACTIONS(1085),
    [anon_sym_assert] = ACTIONS(1085),
    [anon_sym_upcast] = ACTIONS(1085),
    [anon_sym_downcast] = ACTIONS(1085),
    [anon_sym_COLON_GT] = ACTIONS(1111),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1111),
    [anon_sym_for] = ACTIONS(1113),
    [anon_sym_while] = ACTIONS(1115),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(1117),
    [anon_sym_try] = ACTIONS(1119),
    [anon_sym_match] = ACTIONS(1121),
    [anon_sym_match_BANG] = ACTIONS(1123),
    [anon_sym_function] = ACTIONS(1125),
    [anon_sym_LT_DASH] = ACTIONS(1127),
    [anon_sym_DOT_LBRACK] = ACTIONS(1129),
    [anon_sym_LT] = ACTIONS(1131),
    [anon_sym_use] = ACTIONS(1133),
    [anon_sym_use_BANG] = ACTIONS(1135),
    [anon_sym_do_BANG] = ACTIONS(1137),
    [anon_sym_begin] = ACTIONS(1139),
    [anon_sym_LPAREN2] = ACTIONS(1141),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(1143),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1145),
    [anon_sym_DQUOTE] = ACTIONS(1147),
    [anon_sym_AT_DQUOTE] = ACTIONS(1149),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1151),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1153),
    [sym_bool] = ACTIONS(1155),
    [sym_unit] = ACTIONS(1157),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1159),
    [sym_op_identifier] = ACTIONS(1161),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(1163),
    [sym_xint] = ACTIONS(1165),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1167),
    [sym__newline] = ACTIONS(1169),
  },
  [189] = {
    [sym_function_or_value_defn] = STATE(651),
    [sym__expression] = STATE(167),
    [sym_literal_expression] = STATE(2168),
    [sym_long_identifier_or_op] = STATE(2168),
    [sym_tuple_expression] = STATE(2168),
    [sym_brace_expression] = STATE(2168),
    [sym_anon_record_expression] = STATE(2168),
    [sym_prefixed_expression] = STATE(2168),
    [sym_typecast_expression] = STATE(2168),
    [sym_for_expression] = STATE(2168),
    [sym_while_expression] = STATE(2168),
    [sym__if_branch] = STATE(6406),
    [sym_if_expression] = STATE(2168),
    [sym_fun_expression] = STATE(2168),
    [sym_try_expression] = STATE(2168),
    [sym_match_expression] = STATE(2168),
    [sym_function_expression] = STATE(2168),
    [sym_mutate_expression] = STATE(2168),
    [sym_index_expression] = STATE(2168),
    [sym_typed_expression] = STATE(2168),
    [sym_declaration_expression] = STATE(2168),
    [sym_do_expression] = STATE(2168),
    [sym_list_expression] = STATE(2168),
    [sym_array_expression] = STATE(2168),
    [sym_begin_end_expression] = STATE(2168),
    [sym_paren_expression] = STATE(2168),
    [sym__high_prec_app] = STATE(2179),
    [sym__low_prec_app] = STATE(2179),
    [sym_application_expression] = STATE(2168),
    [sym_dot_expression] = STATE(2168),
    [sym_infix_expression] = STATE(2168),
    [sym_ce_expression] = STATE(2168),
    [sym_sequential_expression] = STATE(2168),
    [sym_char] = STATE(2469),
    [sym_format_string] = STATE(2412),
    [sym__string_literal] = STATE(2412),
    [sym_string] = STATE(2469),
    [sym_verbatim_string] = STATE(2469),
    [sym_bytearray] = STATE(2469),
    [sym_verbatim_bytearray] = STATE(2469),
    [sym_format_triple_quoted_string] = STATE(2408),
    [sym_triple_quoted_string] = STATE(2469),
    [sym_const] = STATE(2168),
    [sym_long_identifier] = STATE(2183),
    [sym_active_pattern] = STATE(2182),
    [sym__identifier_or_op] = STATE(2093),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(650),
    [sym_infix_op] = STATE(721),
    [sym_sbyte] = STATE(2469),
    [sym_byte] = STATE(2469),
    [sym_int16] = STATE(2469),
    [sym_uint16] = STATE(2469),
    [sym_int32] = STATE(2469),
    [sym_uint32] = STATE(2469),
    [sym_nativeint] = STATE(2469),
    [sym_unativeint] = STATE(2469),
    [sym_int64] = STATE(2469),
    [sym_uint64] = STATE(2469),
    [sym_ieee32] = STATE(2469),
    [sym_ieee64] = STATE(2469),
    [sym_bignum] = STATE(2469),
    [sym_decimal] = STATE(2469),
    [sym_float] = STATE(1586),
    [sym_block_comment] = STATE(189),
    [sym_compiler_directive_decl] = STATE(189),
    [sym_fsi_directive_decl] = STATE(189),
    [sym_preproc_line] = STATE(189),
    [sym_preproc_if_in_expression] = STATE(2168),
    [aux_sym_sequential_expression_repeat1] = STATE(1755),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(989),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(991),
    [anon_sym_return] = ACTIONS(993),
    [anon_sym_do] = ACTIONS(995),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(997),
    [anon_sym_COMMA] = ACTIONS(999),
    [anon_sym_null] = ACTIONS(1001),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(991),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1003),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1005),
    [anon_sym_LBRACE] = ACTIONS(1007),
    [anon_sym_LT_AT] = ACTIONS(1009),
    [anon_sym_AT_GT] = ACTIONS(1237),
    [anon_sym_LT_AT_AT] = ACTIONS(1013),
    [anon_sym_DOT] = ACTIONS(1015),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1017),
    [anon_sym_new] = ACTIONS(993),
    [anon_sym_return_BANG] = ACTIONS(1019),
    [anon_sym_yield] = ACTIONS(993),
    [anon_sym_yield_BANG] = ACTIONS(1019),
    [anon_sym_lazy] = ACTIONS(993),
    [anon_sym_assert] = ACTIONS(993),
    [anon_sym_upcast] = ACTIONS(993),
    [anon_sym_downcast] = ACTIONS(993),
    [anon_sym_COLON_GT] = ACTIONS(1021),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1021),
    [anon_sym_for] = ACTIONS(1023),
    [anon_sym_while] = ACTIONS(1025),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(1027),
    [anon_sym_try] = ACTIONS(1029),
    [anon_sym_match] = ACTIONS(1031),
    [anon_sym_match_BANG] = ACTIONS(1033),
    [anon_sym_function] = ACTIONS(1035),
    [anon_sym_LT_DASH] = ACTIONS(1037),
    [anon_sym_DOT_LBRACK] = ACTIONS(1039),
    [anon_sym_LT] = ACTIONS(1041),
    [anon_sym_use] = ACTIONS(1043),
    [anon_sym_use_BANG] = ACTIONS(1045),
    [anon_sym_do_BANG] = ACTIONS(1047),
    [anon_sym_begin] = ACTIONS(1049),
    [anon_sym_LPAREN2] = ACTIONS(1051),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(1053),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1055),
    [anon_sym_DQUOTE] = ACTIONS(1057),
    [anon_sym_AT_DQUOTE] = ACTIONS(1059),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1061),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1063),
    [sym_bool] = ACTIONS(1065),
    [sym_unit] = ACTIONS(1067),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1069),
    [sym_op_identifier] = ACTIONS(1071),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(1073),
    [sym_xint] = ACTIONS(1075),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1077),
    [sym__newline] = ACTIONS(1079),
  },
  [190] = {
    [sym_function_or_value_defn] = STATE(627),
    [sym__expression] = STATE(17),
    [sym_literal_expression] = STATE(1118),
    [sym_long_identifier_or_op] = STATE(1118),
    [sym_tuple_expression] = STATE(1118),
    [sym_brace_expression] = STATE(1118),
    [sym_anon_record_expression] = STATE(1118),
    [sym_prefixed_expression] = STATE(1118),
    [sym_typecast_expression] = STATE(1118),
    [sym_for_expression] = STATE(1118),
    [sym_while_expression] = STATE(1118),
    [sym__if_branch] = STATE(7163),
    [sym_if_expression] = STATE(1118),
    [sym_fun_expression] = STATE(1118),
    [sym_try_expression] = STATE(1118),
    [sym_match_expression] = STATE(1118),
    [sym_function_expression] = STATE(1118),
    [sym_mutate_expression] = STATE(1118),
    [sym_index_expression] = STATE(1118),
    [sym_typed_expression] = STATE(1118),
    [sym_declaration_expression] = STATE(1118),
    [sym_do_expression] = STATE(1118),
    [sym_list_expression] = STATE(1118),
    [sym_array_expression] = STATE(1118),
    [sym_begin_end_expression] = STATE(1118),
    [sym_paren_expression] = STATE(1118),
    [sym__high_prec_app] = STATE(1133),
    [sym__low_prec_app] = STATE(1133),
    [sym_application_expression] = STATE(1118),
    [sym_dot_expression] = STATE(1118),
    [sym_infix_expression] = STATE(1118),
    [sym_ce_expression] = STATE(1118),
    [sym_sequential_expression] = STATE(1118),
    [sym_char] = STATE(1080),
    [sym_format_string] = STATE(1090),
    [sym__string_literal] = STATE(1090),
    [sym_string] = STATE(1080),
    [sym_verbatim_string] = STATE(1080),
    [sym_bytearray] = STATE(1080),
    [sym_verbatim_bytearray] = STATE(1080),
    [sym_format_triple_quoted_string] = STATE(1096),
    [sym_triple_quoted_string] = STATE(1080),
    [sym_const] = STATE(1118),
    [sym_long_identifier] = STATE(1156),
    [sym_active_pattern] = STATE(1085),
    [sym__identifier_or_op] = STATE(1099),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(517),
    [sym_infix_op] = STATE(487),
    [sym_sbyte] = STATE(1080),
    [sym_byte] = STATE(1080),
    [sym_int16] = STATE(1080),
    [sym_uint16] = STATE(1080),
    [sym_int32] = STATE(1080),
    [sym_uint32] = STATE(1080),
    [sym_nativeint] = STATE(1080),
    [sym_unativeint] = STATE(1080),
    [sym_int64] = STATE(1080),
    [sym_uint64] = STATE(1080),
    [sym_ieee32] = STATE(1080),
    [sym_ieee64] = STATE(1080),
    [sym_bignum] = STATE(1080),
    [sym_decimal] = STATE(1080),
    [sym_float] = STATE(979),
    [sym_block_comment] = STATE(190),
    [sym_compiler_directive_decl] = STATE(190),
    [sym_fsi_directive_decl] = STATE(190),
    [sym_preproc_line] = STATE(190),
    [sym_preproc_if_in_expression] = STATE(1118),
    [aux_sym_sequential_expression_repeat1] = STATE(1069),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(195),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(197),
    [anon_sym_return] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_COMMA] = ACTIONS(1239),
    [anon_sym_null] = ACTIONS(207),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(197),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(209),
    [anon_sym_RBRACK] = ACTIONS(1239),
    [anon_sym_LBRACK_PIPE] = ACTIONS(211),
    [anon_sym_LBRACE] = ACTIONS(271),
    [anon_sym_LT_AT] = ACTIONS(213),
    [anon_sym_LT_AT_AT] = ACTIONS(215),
    [anon_sym_DOT] = ACTIONS(185),
    [anon_sym_LBRACE_PIPE] = ACTIONS(217),
    [anon_sym_new] = ACTIONS(199),
    [anon_sym_return_BANG] = ACTIONS(219),
    [anon_sym_yield] = ACTIONS(199),
    [anon_sym_yield_BANG] = ACTIONS(219),
    [anon_sym_lazy] = ACTIONS(199),
    [anon_sym_assert] = ACTIONS(199),
    [anon_sym_upcast] = ACTIONS(199),
    [anon_sym_downcast] = ACTIONS(199),
    [anon_sym_COLON_GT] = ACTIONS(221),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(221),
    [anon_sym_for] = ACTIONS(223),
    [anon_sym_while] = ACTIONS(225),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(229),
    [anon_sym_match] = ACTIONS(231),
    [anon_sym_match_BANG] = ACTIONS(233),
    [anon_sym_function] = ACTIONS(235),
    [anon_sym_LT_DASH] = ACTIONS(237),
    [anon_sym_DOT_LBRACK] = ACTIONS(187),
    [anon_sym_LT] = ACTIONS(189),
    [anon_sym_use] = ACTIONS(239),
    [anon_sym_use_BANG] = ACTIONS(241),
    [anon_sym_do_BANG] = ACTIONS(243),
    [anon_sym_begin] = ACTIONS(245),
    [anon_sym_LPAREN2] = ACTIONS(191),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(247),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(251),
    [anon_sym_AT_DQUOTE] = ACTIONS(253),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(255),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(257),
    [sym_bool] = ACTIONS(259),
    [sym_unit] = ACTIONS(193),
    [anon_sym_LPAREN_PIPE] = ACTIONS(261),
    [sym_op_identifier] = ACTIONS(263),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(265),
    [sym_xint] = ACTIONS(267),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(269),
    [sym__newline] = ACTIONS(273),
  },
  [191] = {
    [sym_function_or_value_defn] = STATE(627),
    [sym__expression] = STATE(17),
    [sym_literal_expression] = STATE(1118),
    [sym_long_identifier_or_op] = STATE(1118),
    [sym_tuple_expression] = STATE(1118),
    [sym_brace_expression] = STATE(1118),
    [sym_anon_record_expression] = STATE(1118),
    [sym_prefixed_expression] = STATE(1118),
    [sym_typecast_expression] = STATE(1118),
    [sym_for_expression] = STATE(1118),
    [sym_while_expression] = STATE(1118),
    [sym__if_branch] = STATE(7163),
    [sym_if_expression] = STATE(1118),
    [sym_fun_expression] = STATE(1118),
    [sym_try_expression] = STATE(1118),
    [sym_match_expression] = STATE(1118),
    [sym_function_expression] = STATE(1118),
    [sym_mutate_expression] = STATE(1118),
    [sym_index_expression] = STATE(1118),
    [sym_typed_expression] = STATE(1118),
    [sym_declaration_expression] = STATE(1118),
    [sym_do_expression] = STATE(1118),
    [sym_list_expression] = STATE(1118),
    [sym_array_expression] = STATE(1118),
    [sym_begin_end_expression] = STATE(1118),
    [sym_paren_expression] = STATE(1118),
    [sym__high_prec_app] = STATE(1133),
    [sym__low_prec_app] = STATE(1133),
    [sym_application_expression] = STATE(1118),
    [sym_dot_expression] = STATE(1118),
    [sym_infix_expression] = STATE(1118),
    [sym_ce_expression] = STATE(1118),
    [sym_sequential_expression] = STATE(1118),
    [sym_char] = STATE(1080),
    [sym_format_string] = STATE(1090),
    [sym__string_literal] = STATE(1090),
    [sym_string] = STATE(1080),
    [sym_verbatim_string] = STATE(1080),
    [sym_bytearray] = STATE(1080),
    [sym_verbatim_bytearray] = STATE(1080),
    [sym_format_triple_quoted_string] = STATE(1096),
    [sym_triple_quoted_string] = STATE(1080),
    [sym_const] = STATE(1118),
    [sym_long_identifier] = STATE(1156),
    [sym_active_pattern] = STATE(1085),
    [sym__identifier_or_op] = STATE(1099),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(517),
    [sym_infix_op] = STATE(487),
    [sym_sbyte] = STATE(1080),
    [sym_byte] = STATE(1080),
    [sym_int16] = STATE(1080),
    [sym_uint16] = STATE(1080),
    [sym_int32] = STATE(1080),
    [sym_uint32] = STATE(1080),
    [sym_nativeint] = STATE(1080),
    [sym_unativeint] = STATE(1080),
    [sym_int64] = STATE(1080),
    [sym_uint64] = STATE(1080),
    [sym_ieee32] = STATE(1080),
    [sym_ieee64] = STATE(1080),
    [sym_bignum] = STATE(1080),
    [sym_decimal] = STATE(1080),
    [sym_float] = STATE(979),
    [sym_block_comment] = STATE(191),
    [sym_compiler_directive_decl] = STATE(191),
    [sym_fsi_directive_decl] = STATE(191),
    [sym_preproc_line] = STATE(191),
    [sym_preproc_if_in_expression] = STATE(1118),
    [aux_sym_sequential_expression_repeat1] = STATE(1069),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(195),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(197),
    [anon_sym_return] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_COMMA] = ACTIONS(205),
    [anon_sym_null] = ACTIONS(207),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(197),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(209),
    [anon_sym_LBRACK_PIPE] = ACTIONS(211),
    [anon_sym_LBRACE] = ACTIONS(271),
    [anon_sym_LT_AT] = ACTIONS(213),
    [anon_sym_LT_AT_AT] = ACTIONS(215),
    [anon_sym_DOT] = ACTIONS(185),
    [anon_sym_LBRACE_PIPE] = ACTIONS(217),
    [anon_sym_new] = ACTIONS(199),
    [anon_sym_with] = ACTIONS(1241),
    [anon_sym_return_BANG] = ACTIONS(219),
    [anon_sym_yield] = ACTIONS(199),
    [anon_sym_yield_BANG] = ACTIONS(219),
    [anon_sym_lazy] = ACTIONS(199),
    [anon_sym_assert] = ACTIONS(199),
    [anon_sym_upcast] = ACTIONS(199),
    [anon_sym_downcast] = ACTIONS(199),
    [anon_sym_COLON_GT] = ACTIONS(221),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(221),
    [anon_sym_for] = ACTIONS(223),
    [anon_sym_while] = ACTIONS(225),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(229),
    [anon_sym_match] = ACTIONS(231),
    [anon_sym_match_BANG] = ACTIONS(233),
    [anon_sym_function] = ACTIONS(235),
    [anon_sym_LT_DASH] = ACTIONS(237),
    [anon_sym_DOT_LBRACK] = ACTIONS(187),
    [anon_sym_LT] = ACTIONS(189),
    [anon_sym_use] = ACTIONS(239),
    [anon_sym_use_BANG] = ACTIONS(241),
    [anon_sym_do_BANG] = ACTIONS(243),
    [anon_sym_begin] = ACTIONS(245),
    [anon_sym_LPAREN2] = ACTIONS(191),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(247),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(251),
    [anon_sym_AT_DQUOTE] = ACTIONS(253),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(255),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(257),
    [sym_bool] = ACTIONS(259),
    [sym_unit] = ACTIONS(193),
    [anon_sym_LPAREN_PIPE] = ACTIONS(261),
    [sym_op_identifier] = ACTIONS(263),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(265),
    [sym_xint] = ACTIONS(267),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(269),
    [sym__newline] = ACTIONS(1243),
  },
  [192] = {
    [sym_function_or_value_defn] = STATE(600),
    [sym__expression] = STATE(88),
    [sym_literal_expression] = STATE(867),
    [sym_long_identifier_or_op] = STATE(867),
    [sym_tuple_expression] = STATE(867),
    [sym_brace_expression] = STATE(867),
    [sym_anon_record_expression] = STATE(867),
    [sym_prefixed_expression] = STATE(867),
    [sym_typecast_expression] = STATE(867),
    [sym_for_expression] = STATE(867),
    [sym_while_expression] = STATE(867),
    [sym__if_branch] = STATE(6511),
    [sym_if_expression] = STATE(867),
    [sym_fun_expression] = STATE(867),
    [sym_try_expression] = STATE(867),
    [sym_match_expression] = STATE(867),
    [sym_function_expression] = STATE(867),
    [sym_mutate_expression] = STATE(867),
    [sym_index_expression] = STATE(867),
    [sym_typed_expression] = STATE(867),
    [sym_declaration_expression] = STATE(867),
    [sym_do_expression] = STATE(867),
    [sym_list_expression] = STATE(867),
    [sym_array_expression] = STATE(867),
    [sym_begin_end_expression] = STATE(867),
    [sym_paren_expression] = STATE(867),
    [sym__high_prec_app] = STATE(864),
    [sym__low_prec_app] = STATE(864),
    [sym_application_expression] = STATE(867),
    [sym_dot_expression] = STATE(867),
    [sym_infix_expression] = STATE(867),
    [sym_ce_expression] = STATE(867),
    [sym_sequential_expression] = STATE(867),
    [sym_char] = STATE(868),
    [sym_format_string] = STATE(869),
    [sym__string_literal] = STATE(869),
    [sym_string] = STATE(868),
    [sym_verbatim_string] = STATE(868),
    [sym_bytearray] = STATE(868),
    [sym_verbatim_bytearray] = STATE(868),
    [sym_format_triple_quoted_string] = STATE(870),
    [sym_triple_quoted_string] = STATE(868),
    [sym_const] = STATE(867),
    [sym_long_identifier] = STATE(872),
    [sym_active_pattern] = STATE(871),
    [sym__identifier_or_op] = STATE(873),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(656),
    [sym_infix_op] = STATE(581),
    [sym_sbyte] = STATE(868),
    [sym_byte] = STATE(868),
    [sym_int16] = STATE(868),
    [sym_uint16] = STATE(868),
    [sym_int32] = STATE(868),
    [sym_uint32] = STATE(868),
    [sym_nativeint] = STATE(868),
    [sym_unativeint] = STATE(868),
    [sym_int64] = STATE(868),
    [sym_uint64] = STATE(868),
    [sym_ieee32] = STATE(868),
    [sym_ieee64] = STATE(868),
    [sym_bignum] = STATE(868),
    [sym_decimal] = STATE(868),
    [sym_float] = STATE(1368),
    [sym_block_comment] = STATE(192),
    [sym_compiler_directive_decl] = STATE(192),
    [sym_fsi_directive_decl] = STATE(192),
    [sym_preproc_line] = STATE(192),
    [sym_preproc_if_in_expression] = STATE(867),
    [aux_sym_sequential_expression_repeat1] = STATE(1542),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(29),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(825),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_COMMA] = ACTIONS(827),
    [anon_sym_null] = ACTIONS(49),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACK_PIPE] = ACTIONS(57),
    [anon_sym_LBRACE] = ACTIONS(139),
    [anon_sym_LT_AT] = ACTIONS(61),
    [anon_sym_LT_AT_AT] = ACTIONS(63),
    [anon_sym_DOT] = ACTIONS(65),
    [anon_sym_LBRACE_PIPE] = ACTIONS(67),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_return_BANG] = ACTIONS(829),
    [anon_sym_yield] = ACTIONS(825),
    [anon_sym_yield_BANG] = ACTIONS(829),
    [anon_sym_lazy] = ACTIONS(825),
    [anon_sym_assert] = ACTIONS(825),
    [anon_sym_upcast] = ACTIONS(825),
    [anon_sym_downcast] = ACTIONS(825),
    [anon_sym_COLON_GT] = ACTIONS(71),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(71),
    [anon_sym_for] = ACTIONS(73),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(79),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_match] = ACTIONS(83),
    [anon_sym_match_BANG] = ACTIONS(85),
    [anon_sym_function] = ACTIONS(87),
    [anon_sym_LT_DASH] = ACTIONS(831),
    [anon_sym_DOT_LBRACK] = ACTIONS(91),
    [anon_sym_LT] = ACTIONS(93),
    [anon_sym_use] = ACTIONS(833),
    [anon_sym_use_BANG] = ACTIONS(835),
    [anon_sym_do_BANG] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(101),
    [anon_sym_LPAREN2] = ACTIONS(103),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(105),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(107),
    [anon_sym_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DQUOTE] = ACTIONS(111),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(115),
    [sym_bool] = ACTIONS(117),
    [sym_unit] = ACTIONS(119),
    [anon_sym_LPAREN_PIPE] = ACTIONS(121),
    [sym_op_identifier] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(837),
    [sym_xint] = ACTIONS(387),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(135),
    [sym__newline] = ACTIONS(839),
    [sym__dedent] = ACTIONS(1245),
  },
  [193] = {
    [sym_function_or_value_defn] = STATE(627),
    [sym__expression] = STATE(17),
    [sym_literal_expression] = STATE(1118),
    [sym_long_identifier_or_op] = STATE(1118),
    [sym_tuple_expression] = STATE(1118),
    [sym_brace_expression] = STATE(1118),
    [sym_anon_record_expression] = STATE(1118),
    [sym_prefixed_expression] = STATE(1118),
    [sym_typecast_expression] = STATE(1118),
    [sym_for_expression] = STATE(1118),
    [sym_while_expression] = STATE(1118),
    [sym__if_branch] = STATE(7163),
    [sym_if_expression] = STATE(1118),
    [sym_fun_expression] = STATE(1118),
    [sym_try_expression] = STATE(1118),
    [sym_match_expression] = STATE(1118),
    [sym_function_expression] = STATE(1118),
    [sym_mutate_expression] = STATE(1118),
    [sym_index_expression] = STATE(1118),
    [sym_typed_expression] = STATE(1118),
    [sym_declaration_expression] = STATE(1118),
    [sym_do_expression] = STATE(1118),
    [sym_list_expression] = STATE(1118),
    [sym_array_expression] = STATE(1118),
    [sym_begin_end_expression] = STATE(1118),
    [sym_paren_expression] = STATE(1118),
    [sym__high_prec_app] = STATE(1133),
    [sym__low_prec_app] = STATE(1133),
    [sym_application_expression] = STATE(1118),
    [sym_dot_expression] = STATE(1118),
    [sym_infix_expression] = STATE(1118),
    [sym_ce_expression] = STATE(1118),
    [sym_sequential_expression] = STATE(1118),
    [sym_char] = STATE(1080),
    [sym_format_string] = STATE(1090),
    [sym__string_literal] = STATE(1090),
    [sym_string] = STATE(1080),
    [sym_verbatim_string] = STATE(1080),
    [sym_bytearray] = STATE(1080),
    [sym_verbatim_bytearray] = STATE(1080),
    [sym_format_triple_quoted_string] = STATE(1096),
    [sym_triple_quoted_string] = STATE(1080),
    [sym_const] = STATE(1118),
    [sym_long_identifier] = STATE(1156),
    [sym_active_pattern] = STATE(1085),
    [sym__identifier_or_op] = STATE(1099),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(517),
    [sym_infix_op] = STATE(487),
    [sym_sbyte] = STATE(1080),
    [sym_byte] = STATE(1080),
    [sym_int16] = STATE(1080),
    [sym_uint16] = STATE(1080),
    [sym_int32] = STATE(1080),
    [sym_uint32] = STATE(1080),
    [sym_nativeint] = STATE(1080),
    [sym_unativeint] = STATE(1080),
    [sym_int64] = STATE(1080),
    [sym_uint64] = STATE(1080),
    [sym_ieee32] = STATE(1080),
    [sym_ieee64] = STATE(1080),
    [sym_bignum] = STATE(1080),
    [sym_decimal] = STATE(1080),
    [sym_float] = STATE(979),
    [sym_block_comment] = STATE(193),
    [sym_compiler_directive_decl] = STATE(193),
    [sym_fsi_directive_decl] = STATE(193),
    [sym_preproc_line] = STATE(193),
    [sym_preproc_if_in_expression] = STATE(1118),
    [aux_sym_sequential_expression_repeat1] = STATE(1069),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(195),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_GT_RBRACK] = ACTIONS(1247),
    [anon_sym_COLON] = ACTIONS(197),
    [anon_sym_return] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_COMMA] = ACTIONS(205),
    [anon_sym_null] = ACTIONS(207),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(197),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(209),
    [anon_sym_LBRACK_PIPE] = ACTIONS(211),
    [anon_sym_LBRACE] = ACTIONS(271),
    [anon_sym_LT_AT] = ACTIONS(213),
    [anon_sym_LT_AT_AT] = ACTIONS(215),
    [anon_sym_DOT] = ACTIONS(185),
    [anon_sym_LBRACE_PIPE] = ACTIONS(217),
    [anon_sym_new] = ACTIONS(199),
    [anon_sym_return_BANG] = ACTIONS(219),
    [anon_sym_yield] = ACTIONS(199),
    [anon_sym_yield_BANG] = ACTIONS(219),
    [anon_sym_lazy] = ACTIONS(199),
    [anon_sym_assert] = ACTIONS(199),
    [anon_sym_upcast] = ACTIONS(199),
    [anon_sym_downcast] = ACTIONS(199),
    [anon_sym_COLON_GT] = ACTIONS(221),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(221),
    [anon_sym_for] = ACTIONS(223),
    [anon_sym_while] = ACTIONS(225),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(229),
    [anon_sym_match] = ACTIONS(231),
    [anon_sym_match_BANG] = ACTIONS(233),
    [anon_sym_function] = ACTIONS(235),
    [anon_sym_LT_DASH] = ACTIONS(237),
    [anon_sym_DOT_LBRACK] = ACTIONS(187),
    [anon_sym_LT] = ACTIONS(189),
    [anon_sym_use] = ACTIONS(239),
    [anon_sym_use_BANG] = ACTIONS(241),
    [anon_sym_do_BANG] = ACTIONS(243),
    [anon_sym_begin] = ACTIONS(245),
    [anon_sym_LPAREN2] = ACTIONS(191),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(247),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(251),
    [anon_sym_AT_DQUOTE] = ACTIONS(253),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(255),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(257),
    [sym_bool] = ACTIONS(259),
    [sym_unit] = ACTIONS(193),
    [anon_sym_LPAREN_PIPE] = ACTIONS(261),
    [sym_op_identifier] = ACTIONS(263),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(265),
    [sym_xint] = ACTIONS(267),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(269),
    [sym__newline] = ACTIONS(1247),
  },
  [194] = {
    [sym_function_or_value_defn] = STATE(627),
    [sym__expression] = STATE(17),
    [sym_literal_expression] = STATE(1118),
    [sym_long_identifier_or_op] = STATE(1118),
    [sym_tuple_expression] = STATE(1118),
    [sym_brace_expression] = STATE(1118),
    [sym_anon_record_expression] = STATE(1118),
    [sym_prefixed_expression] = STATE(1118),
    [sym_typecast_expression] = STATE(1118),
    [sym_for_expression] = STATE(1118),
    [sym_while_expression] = STATE(1118),
    [sym__if_branch] = STATE(7163),
    [sym_if_expression] = STATE(1118),
    [sym_fun_expression] = STATE(1118),
    [sym_try_expression] = STATE(1118),
    [sym_match_expression] = STATE(1118),
    [sym_function_expression] = STATE(1118),
    [sym_mutate_expression] = STATE(1118),
    [sym_index_expression] = STATE(1118),
    [sym_typed_expression] = STATE(1118),
    [sym_declaration_expression] = STATE(1118),
    [sym_do_expression] = STATE(1118),
    [sym_list_expression] = STATE(1118),
    [sym_array_expression] = STATE(1118),
    [sym_begin_end_expression] = STATE(1118),
    [sym_paren_expression] = STATE(1118),
    [sym__high_prec_app] = STATE(1133),
    [sym__low_prec_app] = STATE(1133),
    [sym_application_expression] = STATE(1118),
    [sym_dot_expression] = STATE(1118),
    [sym_infix_expression] = STATE(1118),
    [sym_ce_expression] = STATE(1118),
    [sym_sequential_expression] = STATE(1118),
    [sym_char] = STATE(1080),
    [sym_format_string] = STATE(1090),
    [sym__string_literal] = STATE(1090),
    [sym_string] = STATE(1080),
    [sym_verbatim_string] = STATE(1080),
    [sym_bytearray] = STATE(1080),
    [sym_verbatim_bytearray] = STATE(1080),
    [sym_format_triple_quoted_string] = STATE(1096),
    [sym_triple_quoted_string] = STATE(1080),
    [sym_const] = STATE(1118),
    [sym_long_identifier] = STATE(1156),
    [sym_active_pattern] = STATE(1085),
    [sym__identifier_or_op] = STATE(1099),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(517),
    [sym_infix_op] = STATE(487),
    [sym_sbyte] = STATE(1080),
    [sym_byte] = STATE(1080),
    [sym_int16] = STATE(1080),
    [sym_uint16] = STATE(1080),
    [sym_int32] = STATE(1080),
    [sym_uint32] = STATE(1080),
    [sym_nativeint] = STATE(1080),
    [sym_unativeint] = STATE(1080),
    [sym_int64] = STATE(1080),
    [sym_uint64] = STATE(1080),
    [sym_ieee32] = STATE(1080),
    [sym_ieee64] = STATE(1080),
    [sym_bignum] = STATE(1080),
    [sym_decimal] = STATE(1080),
    [sym_float] = STATE(979),
    [sym_block_comment] = STATE(194),
    [sym_compiler_directive_decl] = STATE(194),
    [sym_fsi_directive_decl] = STATE(194),
    [sym_preproc_line] = STATE(194),
    [sym_preproc_if_in_expression] = STATE(1118),
    [aux_sym_sequential_expression_repeat1] = STATE(1069),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(195),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(197),
    [anon_sym_return] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_COMMA] = ACTIONS(205),
    [anon_sym_null] = ACTIONS(207),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(197),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(209),
    [anon_sym_LBRACK_PIPE] = ACTIONS(211),
    [anon_sym_LBRACE] = ACTIONS(271),
    [anon_sym_LT_AT] = ACTIONS(213),
    [anon_sym_LT_AT_AT] = ACTIONS(215),
    [anon_sym_DOT] = ACTIONS(185),
    [anon_sym_LBRACE_PIPE] = ACTIONS(217),
    [anon_sym_new] = ACTIONS(199),
    [anon_sym_with] = ACTIONS(1249),
    [anon_sym_return_BANG] = ACTIONS(219),
    [anon_sym_yield] = ACTIONS(199),
    [anon_sym_yield_BANG] = ACTIONS(219),
    [anon_sym_lazy] = ACTIONS(199),
    [anon_sym_assert] = ACTIONS(199),
    [anon_sym_upcast] = ACTIONS(199),
    [anon_sym_downcast] = ACTIONS(199),
    [anon_sym_COLON_GT] = ACTIONS(221),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(221),
    [anon_sym_for] = ACTIONS(223),
    [anon_sym_while] = ACTIONS(225),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(229),
    [anon_sym_match] = ACTIONS(231),
    [anon_sym_match_BANG] = ACTIONS(233),
    [anon_sym_function] = ACTIONS(235),
    [anon_sym_LT_DASH] = ACTIONS(237),
    [anon_sym_DOT_LBRACK] = ACTIONS(187),
    [anon_sym_LT] = ACTIONS(189),
    [anon_sym_use] = ACTIONS(239),
    [anon_sym_use_BANG] = ACTIONS(241),
    [anon_sym_do_BANG] = ACTIONS(243),
    [anon_sym_begin] = ACTIONS(245),
    [anon_sym_LPAREN2] = ACTIONS(191),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(247),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(251),
    [anon_sym_AT_DQUOTE] = ACTIONS(253),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(255),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(257),
    [sym_bool] = ACTIONS(259),
    [sym_unit] = ACTIONS(193),
    [anon_sym_LPAREN_PIPE] = ACTIONS(261),
    [sym_op_identifier] = ACTIONS(263),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(265),
    [sym_xint] = ACTIONS(267),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(269),
    [sym__newline] = ACTIONS(1251),
  },
  [195] = {
    [sym_function_or_value_defn] = STATE(600),
    [sym__expression] = STATE(88),
    [sym_literal_expression] = STATE(867),
    [sym_long_identifier_or_op] = STATE(867),
    [sym_tuple_expression] = STATE(867),
    [sym_brace_expression] = STATE(867),
    [sym_anon_record_expression] = STATE(867),
    [sym_prefixed_expression] = STATE(867),
    [sym_typecast_expression] = STATE(867),
    [sym_for_expression] = STATE(867),
    [sym_while_expression] = STATE(867),
    [sym__if_branch] = STATE(6511),
    [sym_if_expression] = STATE(867),
    [sym_fun_expression] = STATE(867),
    [sym_try_expression] = STATE(867),
    [sym_match_expression] = STATE(867),
    [sym_function_expression] = STATE(867),
    [sym_mutate_expression] = STATE(867),
    [sym_index_expression] = STATE(867),
    [sym_typed_expression] = STATE(867),
    [sym_declaration_expression] = STATE(867),
    [sym_do_expression] = STATE(867),
    [sym_list_expression] = STATE(867),
    [sym_array_expression] = STATE(867),
    [sym_begin_end_expression] = STATE(867),
    [sym_paren_expression] = STATE(867),
    [sym__high_prec_app] = STATE(864),
    [sym__low_prec_app] = STATE(864),
    [sym_application_expression] = STATE(867),
    [sym_dot_expression] = STATE(867),
    [sym_infix_expression] = STATE(867),
    [sym_ce_expression] = STATE(867),
    [sym_sequential_expression] = STATE(867),
    [sym_char] = STATE(868),
    [sym_format_string] = STATE(869),
    [sym__string_literal] = STATE(869),
    [sym_string] = STATE(868),
    [sym_verbatim_string] = STATE(868),
    [sym_bytearray] = STATE(868),
    [sym_verbatim_bytearray] = STATE(868),
    [sym_format_triple_quoted_string] = STATE(870),
    [sym_triple_quoted_string] = STATE(868),
    [sym_const] = STATE(867),
    [sym_long_identifier] = STATE(872),
    [sym_active_pattern] = STATE(871),
    [sym__identifier_or_op] = STATE(873),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(656),
    [sym_infix_op] = STATE(581),
    [sym_sbyte] = STATE(868),
    [sym_byte] = STATE(868),
    [sym_int16] = STATE(868),
    [sym_uint16] = STATE(868),
    [sym_int32] = STATE(868),
    [sym_uint32] = STATE(868),
    [sym_nativeint] = STATE(868),
    [sym_unativeint] = STATE(868),
    [sym_int64] = STATE(868),
    [sym_uint64] = STATE(868),
    [sym_ieee32] = STATE(868),
    [sym_ieee64] = STATE(868),
    [sym_bignum] = STATE(868),
    [sym_decimal] = STATE(868),
    [sym_float] = STATE(1368),
    [sym_block_comment] = STATE(195),
    [sym_compiler_directive_decl] = STATE(195),
    [sym_fsi_directive_decl] = STATE(195),
    [sym_preproc_line] = STATE(195),
    [sym_preproc_if_in_expression] = STATE(867),
    [aux_sym_sequential_expression_repeat1] = STATE(1542),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(29),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(825),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_COMMA] = ACTIONS(827),
    [anon_sym_null] = ACTIONS(49),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACK_PIPE] = ACTIONS(57),
    [anon_sym_LBRACE] = ACTIONS(139),
    [anon_sym_LT_AT] = ACTIONS(61),
    [anon_sym_LT_AT_AT] = ACTIONS(63),
    [anon_sym_DOT] = ACTIONS(65),
    [anon_sym_LBRACE_PIPE] = ACTIONS(67),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_return_BANG] = ACTIONS(829),
    [anon_sym_yield] = ACTIONS(825),
    [anon_sym_yield_BANG] = ACTIONS(829),
    [anon_sym_lazy] = ACTIONS(825),
    [anon_sym_assert] = ACTIONS(825),
    [anon_sym_upcast] = ACTIONS(825),
    [anon_sym_downcast] = ACTIONS(825),
    [anon_sym_COLON_GT] = ACTIONS(71),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(71),
    [anon_sym_for] = ACTIONS(73),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(79),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_match] = ACTIONS(83),
    [anon_sym_match_BANG] = ACTIONS(85),
    [anon_sym_function] = ACTIONS(87),
    [anon_sym_LT_DASH] = ACTIONS(831),
    [anon_sym_DOT_LBRACK] = ACTIONS(91),
    [anon_sym_LT] = ACTIONS(93),
    [anon_sym_use] = ACTIONS(833),
    [anon_sym_use_BANG] = ACTIONS(835),
    [anon_sym_do_BANG] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(101),
    [anon_sym_LPAREN2] = ACTIONS(103),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(105),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(107),
    [anon_sym_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DQUOTE] = ACTIONS(111),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(115),
    [sym_bool] = ACTIONS(117),
    [sym_unit] = ACTIONS(119),
    [anon_sym_LPAREN_PIPE] = ACTIONS(121),
    [sym_op_identifier] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(837),
    [sym_xint] = ACTIONS(387),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(135),
    [sym__newline] = ACTIONS(839),
    [sym__dedent] = ACTIONS(1253),
  },
  [196] = {
    [sym_function_or_value_defn] = STATE(600),
    [sym__expression] = STATE(88),
    [sym_literal_expression] = STATE(867),
    [sym_long_identifier_or_op] = STATE(867),
    [sym_tuple_expression] = STATE(867),
    [sym_brace_expression] = STATE(867),
    [sym_anon_record_expression] = STATE(867),
    [sym_prefixed_expression] = STATE(867),
    [sym_typecast_expression] = STATE(867),
    [sym_for_expression] = STATE(867),
    [sym_while_expression] = STATE(867),
    [sym__if_branch] = STATE(6511),
    [sym_if_expression] = STATE(867),
    [sym_fun_expression] = STATE(867),
    [sym_try_expression] = STATE(867),
    [sym_match_expression] = STATE(867),
    [sym_function_expression] = STATE(867),
    [sym_mutate_expression] = STATE(867),
    [sym_index_expression] = STATE(867),
    [sym_typed_expression] = STATE(867),
    [sym_declaration_expression] = STATE(867),
    [sym_do_expression] = STATE(867),
    [sym_list_expression] = STATE(867),
    [sym_array_expression] = STATE(867),
    [sym_begin_end_expression] = STATE(867),
    [sym_paren_expression] = STATE(867),
    [sym__high_prec_app] = STATE(864),
    [sym__low_prec_app] = STATE(864),
    [sym_application_expression] = STATE(867),
    [sym_dot_expression] = STATE(867),
    [sym_infix_expression] = STATE(867),
    [sym_ce_expression] = STATE(867),
    [sym_sequential_expression] = STATE(867),
    [sym_char] = STATE(868),
    [sym_format_string] = STATE(869),
    [sym__string_literal] = STATE(869),
    [sym_string] = STATE(868),
    [sym_verbatim_string] = STATE(868),
    [sym_bytearray] = STATE(868),
    [sym_verbatim_bytearray] = STATE(868),
    [sym_format_triple_quoted_string] = STATE(870),
    [sym_triple_quoted_string] = STATE(868),
    [sym_const] = STATE(867),
    [sym_long_identifier] = STATE(872),
    [sym_active_pattern] = STATE(871),
    [sym__identifier_or_op] = STATE(873),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(656),
    [sym_infix_op] = STATE(581),
    [sym_sbyte] = STATE(868),
    [sym_byte] = STATE(868),
    [sym_int16] = STATE(868),
    [sym_uint16] = STATE(868),
    [sym_int32] = STATE(868),
    [sym_uint32] = STATE(868),
    [sym_nativeint] = STATE(868),
    [sym_unativeint] = STATE(868),
    [sym_int64] = STATE(868),
    [sym_uint64] = STATE(868),
    [sym_ieee32] = STATE(868),
    [sym_ieee64] = STATE(868),
    [sym_bignum] = STATE(868),
    [sym_decimal] = STATE(868),
    [sym_float] = STATE(1368),
    [sym_block_comment] = STATE(196),
    [sym_compiler_directive_decl] = STATE(196),
    [sym_fsi_directive_decl] = STATE(196),
    [sym_preproc_line] = STATE(196),
    [sym_preproc_if_in_expression] = STATE(867),
    [aux_sym_sequential_expression_repeat1] = STATE(1542),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(29),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(825),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_COMMA] = ACTIONS(827),
    [anon_sym_null] = ACTIONS(49),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACK_PIPE] = ACTIONS(57),
    [anon_sym_LBRACE] = ACTIONS(139),
    [anon_sym_LT_AT] = ACTIONS(61),
    [anon_sym_LT_AT_AT] = ACTIONS(63),
    [anon_sym_DOT] = ACTIONS(65),
    [anon_sym_LBRACE_PIPE] = ACTIONS(67),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_return_BANG] = ACTIONS(829),
    [anon_sym_yield] = ACTIONS(825),
    [anon_sym_yield_BANG] = ACTIONS(829),
    [anon_sym_lazy] = ACTIONS(825),
    [anon_sym_assert] = ACTIONS(825),
    [anon_sym_upcast] = ACTIONS(825),
    [anon_sym_downcast] = ACTIONS(825),
    [anon_sym_COLON_GT] = ACTIONS(71),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(71),
    [anon_sym_for] = ACTIONS(73),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(79),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_match] = ACTIONS(83),
    [anon_sym_match_BANG] = ACTIONS(85),
    [anon_sym_function] = ACTIONS(87),
    [anon_sym_LT_DASH] = ACTIONS(831),
    [anon_sym_DOT_LBRACK] = ACTIONS(91),
    [anon_sym_LT] = ACTIONS(93),
    [anon_sym_use] = ACTIONS(833),
    [anon_sym_use_BANG] = ACTIONS(835),
    [anon_sym_do_BANG] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(101),
    [anon_sym_LPAREN2] = ACTIONS(103),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(105),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(107),
    [anon_sym_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DQUOTE] = ACTIONS(111),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(115),
    [sym_bool] = ACTIONS(117),
    [sym_unit] = ACTIONS(119),
    [anon_sym_LPAREN_PIPE] = ACTIONS(121),
    [sym_op_identifier] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(837),
    [sym_xint] = ACTIONS(387),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(135),
    [sym__newline] = ACTIONS(839),
    [sym__dedent] = ACTIONS(1255),
  },
  [197] = {
    [sym_function_or_value_defn] = STATE(600),
    [sym__expression] = STATE(88),
    [sym_literal_expression] = STATE(867),
    [sym_long_identifier_or_op] = STATE(867),
    [sym_tuple_expression] = STATE(867),
    [sym_brace_expression] = STATE(867),
    [sym_anon_record_expression] = STATE(867),
    [sym_prefixed_expression] = STATE(867),
    [sym_typecast_expression] = STATE(867),
    [sym_for_expression] = STATE(867),
    [sym_while_expression] = STATE(867),
    [sym__if_branch] = STATE(6511),
    [sym_if_expression] = STATE(867),
    [sym_fun_expression] = STATE(867),
    [sym_try_expression] = STATE(867),
    [sym_match_expression] = STATE(867),
    [sym_function_expression] = STATE(867),
    [sym_mutate_expression] = STATE(867),
    [sym_index_expression] = STATE(867),
    [sym_typed_expression] = STATE(867),
    [sym_declaration_expression] = STATE(867),
    [sym_do_expression] = STATE(867),
    [sym_list_expression] = STATE(867),
    [sym_array_expression] = STATE(867),
    [sym_begin_end_expression] = STATE(867),
    [sym_paren_expression] = STATE(867),
    [sym__high_prec_app] = STATE(864),
    [sym__low_prec_app] = STATE(864),
    [sym_application_expression] = STATE(867),
    [sym_dot_expression] = STATE(867),
    [sym_infix_expression] = STATE(867),
    [sym_ce_expression] = STATE(867),
    [sym_sequential_expression] = STATE(867),
    [sym_char] = STATE(868),
    [sym_format_string] = STATE(869),
    [sym__string_literal] = STATE(869),
    [sym_string] = STATE(868),
    [sym_verbatim_string] = STATE(868),
    [sym_bytearray] = STATE(868),
    [sym_verbatim_bytearray] = STATE(868),
    [sym_format_triple_quoted_string] = STATE(870),
    [sym_triple_quoted_string] = STATE(868),
    [sym_const] = STATE(867),
    [sym_long_identifier] = STATE(872),
    [sym_active_pattern] = STATE(871),
    [sym__identifier_or_op] = STATE(873),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(656),
    [sym_infix_op] = STATE(581),
    [sym_sbyte] = STATE(868),
    [sym_byte] = STATE(868),
    [sym_int16] = STATE(868),
    [sym_uint16] = STATE(868),
    [sym_int32] = STATE(868),
    [sym_uint32] = STATE(868),
    [sym_nativeint] = STATE(868),
    [sym_unativeint] = STATE(868),
    [sym_int64] = STATE(868),
    [sym_uint64] = STATE(868),
    [sym_ieee32] = STATE(868),
    [sym_ieee64] = STATE(868),
    [sym_bignum] = STATE(868),
    [sym_decimal] = STATE(868),
    [sym_float] = STATE(1368),
    [sym_block_comment] = STATE(197),
    [sym_compiler_directive_decl] = STATE(197),
    [sym_fsi_directive_decl] = STATE(197),
    [sym_preproc_line] = STATE(197),
    [sym_preproc_if_in_expression] = STATE(867),
    [aux_sym_sequential_expression_repeat1] = STATE(1542),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(29),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(825),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_COMMA] = ACTIONS(827),
    [anon_sym_null] = ACTIONS(49),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACK_PIPE] = ACTIONS(57),
    [anon_sym_LBRACE] = ACTIONS(139),
    [anon_sym_LT_AT] = ACTIONS(61),
    [anon_sym_LT_AT_AT] = ACTIONS(63),
    [anon_sym_DOT] = ACTIONS(65),
    [anon_sym_LBRACE_PIPE] = ACTIONS(67),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_return_BANG] = ACTIONS(829),
    [anon_sym_yield] = ACTIONS(825),
    [anon_sym_yield_BANG] = ACTIONS(829),
    [anon_sym_lazy] = ACTIONS(825),
    [anon_sym_assert] = ACTIONS(825),
    [anon_sym_upcast] = ACTIONS(825),
    [anon_sym_downcast] = ACTIONS(825),
    [anon_sym_COLON_GT] = ACTIONS(71),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(71),
    [anon_sym_for] = ACTIONS(73),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(79),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_match] = ACTIONS(83),
    [anon_sym_match_BANG] = ACTIONS(85),
    [anon_sym_function] = ACTIONS(87),
    [anon_sym_LT_DASH] = ACTIONS(831),
    [anon_sym_DOT_LBRACK] = ACTIONS(91),
    [anon_sym_LT] = ACTIONS(93),
    [anon_sym_use] = ACTIONS(833),
    [anon_sym_use_BANG] = ACTIONS(835),
    [anon_sym_do_BANG] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(101),
    [anon_sym_LPAREN2] = ACTIONS(103),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(105),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(107),
    [anon_sym_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DQUOTE] = ACTIONS(111),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(115),
    [sym_bool] = ACTIONS(117),
    [sym_unit] = ACTIONS(119),
    [anon_sym_LPAREN_PIPE] = ACTIONS(121),
    [sym_op_identifier] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(837),
    [sym_xint] = ACTIONS(387),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(135),
    [sym__newline] = ACTIONS(839),
    [sym__dedent] = ACTIONS(1257),
  },
  [198] = {
    [sym_function_or_value_defn] = STATE(600),
    [sym__expression] = STATE(88),
    [sym_literal_expression] = STATE(867),
    [sym_long_identifier_or_op] = STATE(867),
    [sym_tuple_expression] = STATE(867),
    [sym_brace_expression] = STATE(867),
    [sym_anon_record_expression] = STATE(867),
    [sym_prefixed_expression] = STATE(867),
    [sym_typecast_expression] = STATE(867),
    [sym_for_expression] = STATE(867),
    [sym_while_expression] = STATE(867),
    [sym__if_branch] = STATE(6511),
    [sym_if_expression] = STATE(867),
    [sym_fun_expression] = STATE(867),
    [sym_try_expression] = STATE(867),
    [sym_match_expression] = STATE(867),
    [sym_function_expression] = STATE(867),
    [sym_mutate_expression] = STATE(867),
    [sym_index_expression] = STATE(867),
    [sym_typed_expression] = STATE(867),
    [sym_declaration_expression] = STATE(867),
    [sym_do_expression] = STATE(867),
    [sym_list_expression] = STATE(867),
    [sym_array_expression] = STATE(867),
    [sym_begin_end_expression] = STATE(867),
    [sym_paren_expression] = STATE(867),
    [sym__high_prec_app] = STATE(864),
    [sym__low_prec_app] = STATE(864),
    [sym_application_expression] = STATE(867),
    [sym_dot_expression] = STATE(867),
    [sym_infix_expression] = STATE(867),
    [sym_ce_expression] = STATE(867),
    [sym_sequential_expression] = STATE(867),
    [sym_char] = STATE(868),
    [sym_format_string] = STATE(869),
    [sym__string_literal] = STATE(869),
    [sym_string] = STATE(868),
    [sym_verbatim_string] = STATE(868),
    [sym_bytearray] = STATE(868),
    [sym_verbatim_bytearray] = STATE(868),
    [sym_format_triple_quoted_string] = STATE(870),
    [sym_triple_quoted_string] = STATE(868),
    [sym_const] = STATE(867),
    [sym_long_identifier] = STATE(872),
    [sym_active_pattern] = STATE(871),
    [sym__identifier_or_op] = STATE(873),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(656),
    [sym_infix_op] = STATE(581),
    [sym_sbyte] = STATE(868),
    [sym_byte] = STATE(868),
    [sym_int16] = STATE(868),
    [sym_uint16] = STATE(868),
    [sym_int32] = STATE(868),
    [sym_uint32] = STATE(868),
    [sym_nativeint] = STATE(868),
    [sym_unativeint] = STATE(868),
    [sym_int64] = STATE(868),
    [sym_uint64] = STATE(868),
    [sym_ieee32] = STATE(868),
    [sym_ieee64] = STATE(868),
    [sym_bignum] = STATE(868),
    [sym_decimal] = STATE(868),
    [sym_float] = STATE(1368),
    [sym_block_comment] = STATE(198),
    [sym_compiler_directive_decl] = STATE(198),
    [sym_fsi_directive_decl] = STATE(198),
    [sym_preproc_line] = STATE(198),
    [sym_preproc_if_in_expression] = STATE(867),
    [aux_sym_sequential_expression_repeat1] = STATE(1542),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(29),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(825),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_COMMA] = ACTIONS(827),
    [anon_sym_null] = ACTIONS(49),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACK_PIPE] = ACTIONS(57),
    [anon_sym_LBRACE] = ACTIONS(139),
    [anon_sym_LT_AT] = ACTIONS(61),
    [anon_sym_LT_AT_AT] = ACTIONS(63),
    [anon_sym_DOT] = ACTIONS(65),
    [anon_sym_LBRACE_PIPE] = ACTIONS(67),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_return_BANG] = ACTIONS(829),
    [anon_sym_yield] = ACTIONS(825),
    [anon_sym_yield_BANG] = ACTIONS(829),
    [anon_sym_lazy] = ACTIONS(825),
    [anon_sym_assert] = ACTIONS(825),
    [anon_sym_upcast] = ACTIONS(825),
    [anon_sym_downcast] = ACTIONS(825),
    [anon_sym_COLON_GT] = ACTIONS(71),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(71),
    [anon_sym_for] = ACTIONS(73),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(79),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_match] = ACTIONS(83),
    [anon_sym_match_BANG] = ACTIONS(85),
    [anon_sym_function] = ACTIONS(87),
    [anon_sym_LT_DASH] = ACTIONS(831),
    [anon_sym_DOT_LBRACK] = ACTIONS(91),
    [anon_sym_LT] = ACTIONS(93),
    [anon_sym_use] = ACTIONS(833),
    [anon_sym_use_BANG] = ACTIONS(835),
    [anon_sym_do_BANG] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(101),
    [anon_sym_LPAREN2] = ACTIONS(103),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(105),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(107),
    [anon_sym_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DQUOTE] = ACTIONS(111),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(115),
    [sym_bool] = ACTIONS(117),
    [sym_unit] = ACTIONS(119),
    [anon_sym_LPAREN_PIPE] = ACTIONS(121),
    [sym_op_identifier] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(837),
    [sym_xint] = ACTIONS(387),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(135),
    [sym__newline] = ACTIONS(839),
    [sym__dedent] = ACTIONS(1259),
  },
  [199] = {
    [sym_function_or_value_defn] = STATE(704),
    [sym__expression] = STATE(312),
    [sym_literal_expression] = STATE(2403),
    [sym_long_identifier_or_op] = STATE(2403),
    [sym_tuple_expression] = STATE(2403),
    [sym_brace_expression] = STATE(2403),
    [sym_anon_record_expression] = STATE(2403),
    [sym_prefixed_expression] = STATE(2403),
    [sym_typecast_expression] = STATE(2403),
    [sym_for_expression] = STATE(2403),
    [sym_while_expression] = STATE(2403),
    [sym__if_branch] = STATE(6794),
    [sym_if_expression] = STATE(2403),
    [sym_fun_expression] = STATE(2403),
    [sym_try_expression] = STATE(2403),
    [sym_match_expression] = STATE(2403),
    [sym_function_expression] = STATE(2403),
    [sym_mutate_expression] = STATE(2403),
    [sym_index_expression] = STATE(2403),
    [sym_typed_expression] = STATE(2403),
    [sym_declaration_expression] = STATE(2403),
    [sym_do_expression] = STATE(2403),
    [sym_list_expression] = STATE(2403),
    [sym_array_expression] = STATE(2403),
    [sym_begin_end_expression] = STATE(2403),
    [sym_paren_expression] = STATE(2403),
    [sym__high_prec_app] = STATE(2405),
    [sym__low_prec_app] = STATE(2405),
    [sym_application_expression] = STATE(2403),
    [sym_dot_expression] = STATE(2403),
    [sym_infix_expression] = STATE(2403),
    [sym_ce_expression] = STATE(2403),
    [sym_sequential_expression] = STATE(2403),
    [sym_char] = STATE(2425),
    [sym_format_string] = STATE(2420),
    [sym__string_literal] = STATE(2420),
    [sym_string] = STATE(2425),
    [sym_verbatim_string] = STATE(2425),
    [sym_bytearray] = STATE(2425),
    [sym_verbatim_bytearray] = STATE(2425),
    [sym_format_triple_quoted_string] = STATE(2419),
    [sym_triple_quoted_string] = STATE(2425),
    [sym_const] = STATE(2403),
    [sym_long_identifier] = STATE(2079),
    [sym_active_pattern] = STATE(2080),
    [sym__identifier_or_op] = STATE(2089),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(688),
    [sym_infix_op] = STATE(668),
    [sym_sbyte] = STATE(2425),
    [sym_byte] = STATE(2425),
    [sym_int16] = STATE(2425),
    [sym_uint16] = STATE(2425),
    [sym_int32] = STATE(2425),
    [sym_uint32] = STATE(2425),
    [sym_nativeint] = STATE(2425),
    [sym_unativeint] = STATE(2425),
    [sym_int64] = STATE(2425),
    [sym_uint64] = STATE(2425),
    [sym_ieee32] = STATE(2425),
    [sym_ieee64] = STATE(2425),
    [sym_bignum] = STATE(2425),
    [sym_decimal] = STATE(2425),
    [sym_float] = STATE(1511),
    [sym_block_comment] = STATE(199),
    [sym_compiler_directive_decl] = STATE(199),
    [sym_fsi_directive_decl] = STATE(199),
    [sym_preproc_line] = STATE(199),
    [sym_preproc_if_in_expression] = STATE(2403),
    [aux_sym_sequential_expression_repeat1] = STATE(1901),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(1261),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(1263),
    [anon_sym_return] = ACTIONS(1265),
    [anon_sym_do] = ACTIONS(1267),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(1269),
    [anon_sym_COMMA] = ACTIONS(1271),
    [anon_sym_null] = ACTIONS(1273),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(1263),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1275),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1277),
    [anon_sym_LBRACE] = ACTIONS(1279),
    [anon_sym_LT_AT] = ACTIONS(1281),
    [anon_sym_LT_AT_AT] = ACTIONS(1283),
    [anon_sym_DOT] = ACTIONS(1285),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1287),
    [anon_sym_new] = ACTIONS(1265),
    [anon_sym_return_BANG] = ACTIONS(1289),
    [anon_sym_yield] = ACTIONS(1265),
    [anon_sym_yield_BANG] = ACTIONS(1289),
    [anon_sym_lazy] = ACTIONS(1265),
    [anon_sym_assert] = ACTIONS(1265),
    [anon_sym_upcast] = ACTIONS(1265),
    [anon_sym_downcast] = ACTIONS(1265),
    [anon_sym_COLON_GT] = ACTIONS(1291),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1291),
    [anon_sym_for] = ACTIONS(1293),
    [anon_sym_while] = ACTIONS(1295),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(1297),
    [anon_sym_try] = ACTIONS(1299),
    [anon_sym_match] = ACTIONS(1301),
    [anon_sym_match_BANG] = ACTIONS(1303),
    [anon_sym_function] = ACTIONS(1305),
    [anon_sym_LT_DASH] = ACTIONS(1307),
    [anon_sym_DOT_LBRACK] = ACTIONS(1309),
    [anon_sym_LT] = ACTIONS(1311),
    [anon_sym_use] = ACTIONS(1313),
    [anon_sym_use_BANG] = ACTIONS(1315),
    [anon_sym_do_BANG] = ACTIONS(1317),
    [anon_sym_begin] = ACTIONS(1319),
    [anon_sym_LPAREN2] = ACTIONS(1321),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(1323),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1325),
    [anon_sym_DQUOTE] = ACTIONS(1327),
    [anon_sym_AT_DQUOTE] = ACTIONS(1329),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1331),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1333),
    [sym_bool] = ACTIONS(1335),
    [sym_unit] = ACTIONS(1337),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1339),
    [sym_op_identifier] = ACTIONS(1341),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(1343),
    [sym_xint] = ACTIONS(1345),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1347),
    [anon_sym_POUNDendif] = ACTIONS(853),
    [sym__newline] = ACTIONS(1349),
  },
  [200] = {
    [sym_function_or_value_defn] = STATE(600),
    [sym__expression] = STATE(88),
    [sym_literal_expression] = STATE(867),
    [sym_long_identifier_or_op] = STATE(867),
    [sym_tuple_expression] = STATE(867),
    [sym_brace_expression] = STATE(867),
    [sym_anon_record_expression] = STATE(867),
    [sym_prefixed_expression] = STATE(867),
    [sym_typecast_expression] = STATE(867),
    [sym_for_expression] = STATE(867),
    [sym_while_expression] = STATE(867),
    [sym__if_branch] = STATE(6511),
    [sym_if_expression] = STATE(867),
    [sym_fun_expression] = STATE(867),
    [sym_try_expression] = STATE(867),
    [sym_match_expression] = STATE(867),
    [sym_function_expression] = STATE(867),
    [sym_mutate_expression] = STATE(867),
    [sym_index_expression] = STATE(867),
    [sym_typed_expression] = STATE(867),
    [sym_declaration_expression] = STATE(867),
    [sym_do_expression] = STATE(867),
    [sym_list_expression] = STATE(867),
    [sym_array_expression] = STATE(867),
    [sym_begin_end_expression] = STATE(867),
    [sym_paren_expression] = STATE(867),
    [sym__high_prec_app] = STATE(864),
    [sym__low_prec_app] = STATE(864),
    [sym_application_expression] = STATE(867),
    [sym_dot_expression] = STATE(867),
    [sym_infix_expression] = STATE(867),
    [sym_ce_expression] = STATE(867),
    [sym_sequential_expression] = STATE(867),
    [sym_char] = STATE(868),
    [sym_format_string] = STATE(869),
    [sym__string_literal] = STATE(869),
    [sym_string] = STATE(868),
    [sym_verbatim_string] = STATE(868),
    [sym_bytearray] = STATE(868),
    [sym_verbatim_bytearray] = STATE(868),
    [sym_format_triple_quoted_string] = STATE(870),
    [sym_triple_quoted_string] = STATE(868),
    [sym_const] = STATE(867),
    [sym_long_identifier] = STATE(872),
    [sym_active_pattern] = STATE(871),
    [sym__identifier_or_op] = STATE(873),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(656),
    [sym_infix_op] = STATE(581),
    [sym_sbyte] = STATE(868),
    [sym_byte] = STATE(868),
    [sym_int16] = STATE(868),
    [sym_uint16] = STATE(868),
    [sym_int32] = STATE(868),
    [sym_uint32] = STATE(868),
    [sym_nativeint] = STATE(868),
    [sym_unativeint] = STATE(868),
    [sym_int64] = STATE(868),
    [sym_uint64] = STATE(868),
    [sym_ieee32] = STATE(868),
    [sym_ieee64] = STATE(868),
    [sym_bignum] = STATE(868),
    [sym_decimal] = STATE(868),
    [sym_float] = STATE(1368),
    [sym_block_comment] = STATE(200),
    [sym_compiler_directive_decl] = STATE(200),
    [sym_fsi_directive_decl] = STATE(200),
    [sym_preproc_line] = STATE(200),
    [sym_preproc_if_in_expression] = STATE(867),
    [aux_sym_sequential_expression_repeat1] = STATE(1542),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(29),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(825),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_COMMA] = ACTIONS(827),
    [anon_sym_null] = ACTIONS(49),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACK_PIPE] = ACTIONS(57),
    [anon_sym_LBRACE] = ACTIONS(139),
    [anon_sym_LT_AT] = ACTIONS(61),
    [anon_sym_LT_AT_AT] = ACTIONS(63),
    [anon_sym_DOT] = ACTIONS(65),
    [anon_sym_LBRACE_PIPE] = ACTIONS(67),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_return_BANG] = ACTIONS(829),
    [anon_sym_yield] = ACTIONS(825),
    [anon_sym_yield_BANG] = ACTIONS(829),
    [anon_sym_lazy] = ACTIONS(825),
    [anon_sym_assert] = ACTIONS(825),
    [anon_sym_upcast] = ACTIONS(825),
    [anon_sym_downcast] = ACTIONS(825),
    [anon_sym_COLON_GT] = ACTIONS(71),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(71),
    [anon_sym_for] = ACTIONS(73),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(79),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_match] = ACTIONS(83),
    [anon_sym_match_BANG] = ACTIONS(85),
    [anon_sym_function] = ACTIONS(87),
    [anon_sym_LT_DASH] = ACTIONS(831),
    [anon_sym_DOT_LBRACK] = ACTIONS(91),
    [anon_sym_LT] = ACTIONS(93),
    [anon_sym_use] = ACTIONS(833),
    [anon_sym_use_BANG] = ACTIONS(835),
    [anon_sym_do_BANG] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(101),
    [anon_sym_LPAREN2] = ACTIONS(103),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(105),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(107),
    [anon_sym_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DQUOTE] = ACTIONS(111),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(115),
    [sym_bool] = ACTIONS(117),
    [sym_unit] = ACTIONS(119),
    [anon_sym_LPAREN_PIPE] = ACTIONS(121),
    [sym_op_identifier] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(837),
    [sym_xint] = ACTIONS(387),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(135),
    [sym__newline] = ACTIONS(839),
    [sym__dedent] = ACTIONS(1351),
  },
  [201] = {
    [sym_function_or_value_defn] = STATE(651),
    [sym__expression] = STATE(167),
    [sym_literal_expression] = STATE(2168),
    [sym_long_identifier_or_op] = STATE(2168),
    [sym_tuple_expression] = STATE(2168),
    [sym_brace_expression] = STATE(2168),
    [sym_anon_record_expression] = STATE(2168),
    [sym_prefixed_expression] = STATE(2168),
    [sym_typecast_expression] = STATE(2168),
    [sym_for_expression] = STATE(2168),
    [sym_while_expression] = STATE(2168),
    [sym__if_branch] = STATE(6406),
    [sym_if_expression] = STATE(2168),
    [sym_fun_expression] = STATE(2168),
    [sym_try_expression] = STATE(2168),
    [sym_match_expression] = STATE(2168),
    [sym_function_expression] = STATE(2168),
    [sym_mutate_expression] = STATE(2168),
    [sym_index_expression] = STATE(2168),
    [sym_typed_expression] = STATE(2168),
    [sym_declaration_expression] = STATE(2168),
    [sym_do_expression] = STATE(2168),
    [sym_list_expression] = STATE(2168),
    [sym_array_expression] = STATE(2168),
    [sym_begin_end_expression] = STATE(2168),
    [sym_paren_expression] = STATE(2168),
    [sym__high_prec_app] = STATE(2179),
    [sym__low_prec_app] = STATE(2179),
    [sym_application_expression] = STATE(2168),
    [sym_dot_expression] = STATE(2168),
    [sym_infix_expression] = STATE(2168),
    [sym_ce_expression] = STATE(2168),
    [sym_sequential_expression] = STATE(2168),
    [sym_char] = STATE(2469),
    [sym_format_string] = STATE(2412),
    [sym__string_literal] = STATE(2412),
    [sym_string] = STATE(2469),
    [sym_verbatim_string] = STATE(2469),
    [sym_bytearray] = STATE(2469),
    [sym_verbatim_bytearray] = STATE(2469),
    [sym_format_triple_quoted_string] = STATE(2408),
    [sym_triple_quoted_string] = STATE(2469),
    [sym_const] = STATE(2168),
    [sym_long_identifier] = STATE(2183),
    [sym_active_pattern] = STATE(2182),
    [sym__identifier_or_op] = STATE(2093),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(650),
    [sym_infix_op] = STATE(721),
    [sym_sbyte] = STATE(2469),
    [sym_byte] = STATE(2469),
    [sym_int16] = STATE(2469),
    [sym_uint16] = STATE(2469),
    [sym_int32] = STATE(2469),
    [sym_uint32] = STATE(2469),
    [sym_nativeint] = STATE(2469),
    [sym_unativeint] = STATE(2469),
    [sym_int64] = STATE(2469),
    [sym_uint64] = STATE(2469),
    [sym_ieee32] = STATE(2469),
    [sym_ieee64] = STATE(2469),
    [sym_bignum] = STATE(2469),
    [sym_decimal] = STATE(2469),
    [sym_float] = STATE(1586),
    [sym_block_comment] = STATE(201),
    [sym_compiler_directive_decl] = STATE(201),
    [sym_fsi_directive_decl] = STATE(201),
    [sym_preproc_line] = STATE(201),
    [sym_preproc_if_in_expression] = STATE(2168),
    [aux_sym_sequential_expression_repeat1] = STATE(1755),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(989),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(991),
    [anon_sym_return] = ACTIONS(993),
    [anon_sym_do] = ACTIONS(995),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(997),
    [anon_sym_COMMA] = ACTIONS(999),
    [anon_sym_null] = ACTIONS(1001),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(991),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1003),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1005),
    [anon_sym_LBRACE] = ACTIONS(59),
    [anon_sym_LT_AT] = ACTIONS(1009),
    [anon_sym_AT_GT] = ACTIONS(59),
    [anon_sym_LT_AT_AT] = ACTIONS(1013),
    [anon_sym_DOT] = ACTIONS(1015),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1017),
    [anon_sym_new] = ACTIONS(993),
    [anon_sym_return_BANG] = ACTIONS(1019),
    [anon_sym_yield] = ACTIONS(993),
    [anon_sym_yield_BANG] = ACTIONS(1019),
    [anon_sym_lazy] = ACTIONS(993),
    [anon_sym_assert] = ACTIONS(993),
    [anon_sym_upcast] = ACTIONS(993),
    [anon_sym_downcast] = ACTIONS(993),
    [anon_sym_COLON_GT] = ACTIONS(1021),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1021),
    [anon_sym_for] = ACTIONS(1023),
    [anon_sym_while] = ACTIONS(1025),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(1027),
    [anon_sym_try] = ACTIONS(1029),
    [anon_sym_match] = ACTIONS(1031),
    [anon_sym_match_BANG] = ACTIONS(1033),
    [anon_sym_function] = ACTIONS(1035),
    [anon_sym_LT_DASH] = ACTIONS(1037),
    [anon_sym_DOT_LBRACK] = ACTIONS(1039),
    [anon_sym_LT] = ACTIONS(1041),
    [anon_sym_use] = ACTIONS(1043),
    [anon_sym_use_BANG] = ACTIONS(1045),
    [anon_sym_do_BANG] = ACTIONS(1047),
    [anon_sym_begin] = ACTIONS(1049),
    [anon_sym_LPAREN2] = ACTIONS(1051),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(1053),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1055),
    [anon_sym_DQUOTE] = ACTIONS(1057),
    [anon_sym_AT_DQUOTE] = ACTIONS(1059),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1061),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1063),
    [sym_bool] = ACTIONS(1065),
    [sym_unit] = ACTIONS(1067),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1069),
    [sym_op_identifier] = ACTIONS(1071),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(1073),
    [sym_xint] = ACTIONS(1075),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1077),
    [sym__newline] = ACTIONS(33),
  },
  [202] = {
    [sym_function_or_value_defn] = STATE(600),
    [sym__expression] = STATE(88),
    [sym_literal_expression] = STATE(867),
    [sym_long_identifier_or_op] = STATE(867),
    [sym_tuple_expression] = STATE(867),
    [sym_brace_expression] = STATE(867),
    [sym_anon_record_expression] = STATE(867),
    [sym_prefixed_expression] = STATE(867),
    [sym_typecast_expression] = STATE(867),
    [sym_for_expression] = STATE(867),
    [sym_while_expression] = STATE(867),
    [sym__if_branch] = STATE(6511),
    [sym_if_expression] = STATE(867),
    [sym_fun_expression] = STATE(867),
    [sym_try_expression] = STATE(867),
    [sym_match_expression] = STATE(867),
    [sym_function_expression] = STATE(867),
    [sym_mutate_expression] = STATE(867),
    [sym_index_expression] = STATE(867),
    [sym_typed_expression] = STATE(867),
    [sym_declaration_expression] = STATE(867),
    [sym_do_expression] = STATE(867),
    [sym_list_expression] = STATE(867),
    [sym_array_expression] = STATE(867),
    [sym_begin_end_expression] = STATE(867),
    [sym_paren_expression] = STATE(867),
    [sym__high_prec_app] = STATE(864),
    [sym__low_prec_app] = STATE(864),
    [sym_application_expression] = STATE(867),
    [sym_dot_expression] = STATE(867),
    [sym_infix_expression] = STATE(867),
    [sym_ce_expression] = STATE(867),
    [sym_sequential_expression] = STATE(867),
    [sym_char] = STATE(868),
    [sym_format_string] = STATE(869),
    [sym__string_literal] = STATE(869),
    [sym_string] = STATE(868),
    [sym_verbatim_string] = STATE(868),
    [sym_bytearray] = STATE(868),
    [sym_verbatim_bytearray] = STATE(868),
    [sym_format_triple_quoted_string] = STATE(870),
    [sym_triple_quoted_string] = STATE(868),
    [sym_const] = STATE(867),
    [sym_long_identifier] = STATE(872),
    [sym_active_pattern] = STATE(871),
    [sym__identifier_or_op] = STATE(873),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(656),
    [sym_infix_op] = STATE(581),
    [sym_sbyte] = STATE(868),
    [sym_byte] = STATE(868),
    [sym_int16] = STATE(868),
    [sym_uint16] = STATE(868),
    [sym_int32] = STATE(868),
    [sym_uint32] = STATE(868),
    [sym_nativeint] = STATE(868),
    [sym_unativeint] = STATE(868),
    [sym_int64] = STATE(868),
    [sym_uint64] = STATE(868),
    [sym_ieee32] = STATE(868),
    [sym_ieee64] = STATE(868),
    [sym_bignum] = STATE(868),
    [sym_decimal] = STATE(868),
    [sym_float] = STATE(1368),
    [sym_block_comment] = STATE(202),
    [sym_compiler_directive_decl] = STATE(202),
    [sym_fsi_directive_decl] = STATE(202),
    [sym_preproc_line] = STATE(202),
    [sym_preproc_if_in_expression] = STATE(867),
    [aux_sym_sequential_expression_repeat1] = STATE(1542),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(29),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(825),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_COMMA] = ACTIONS(827),
    [anon_sym_null] = ACTIONS(49),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACK_PIPE] = ACTIONS(57),
    [anon_sym_LBRACE] = ACTIONS(139),
    [anon_sym_LT_AT] = ACTIONS(61),
    [anon_sym_LT_AT_AT] = ACTIONS(63),
    [anon_sym_DOT] = ACTIONS(65),
    [anon_sym_LBRACE_PIPE] = ACTIONS(67),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_return_BANG] = ACTIONS(829),
    [anon_sym_yield] = ACTIONS(825),
    [anon_sym_yield_BANG] = ACTIONS(829),
    [anon_sym_lazy] = ACTIONS(825),
    [anon_sym_assert] = ACTIONS(825),
    [anon_sym_upcast] = ACTIONS(825),
    [anon_sym_downcast] = ACTIONS(825),
    [anon_sym_COLON_GT] = ACTIONS(71),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(71),
    [anon_sym_for] = ACTIONS(73),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(79),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_match] = ACTIONS(83),
    [anon_sym_match_BANG] = ACTIONS(85),
    [anon_sym_function] = ACTIONS(87),
    [anon_sym_LT_DASH] = ACTIONS(831),
    [anon_sym_DOT_LBRACK] = ACTIONS(91),
    [anon_sym_LT] = ACTIONS(93),
    [anon_sym_use] = ACTIONS(833),
    [anon_sym_use_BANG] = ACTIONS(835),
    [anon_sym_do_BANG] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(101),
    [anon_sym_LPAREN2] = ACTIONS(103),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(105),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(107),
    [anon_sym_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DQUOTE] = ACTIONS(111),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(115),
    [sym_bool] = ACTIONS(117),
    [sym_unit] = ACTIONS(119),
    [anon_sym_LPAREN_PIPE] = ACTIONS(121),
    [sym_op_identifier] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(837),
    [sym_xint] = ACTIONS(387),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(135),
    [sym__newline] = ACTIONS(839),
    [sym__dedent] = ACTIONS(1353),
  },
  [203] = {
    [sym_function_or_value_defn] = STATE(600),
    [sym__expression] = STATE(88),
    [sym_literal_expression] = STATE(867),
    [sym_long_identifier_or_op] = STATE(867),
    [sym_tuple_expression] = STATE(867),
    [sym_brace_expression] = STATE(867),
    [sym_anon_record_expression] = STATE(867),
    [sym_prefixed_expression] = STATE(867),
    [sym_typecast_expression] = STATE(867),
    [sym_for_expression] = STATE(867),
    [sym_while_expression] = STATE(867),
    [sym__if_branch] = STATE(6511),
    [sym_if_expression] = STATE(867),
    [sym_fun_expression] = STATE(867),
    [sym_try_expression] = STATE(867),
    [sym_match_expression] = STATE(867),
    [sym_function_expression] = STATE(867),
    [sym_mutate_expression] = STATE(867),
    [sym_index_expression] = STATE(867),
    [sym_typed_expression] = STATE(867),
    [sym_declaration_expression] = STATE(867),
    [sym_do_expression] = STATE(867),
    [sym_list_expression] = STATE(867),
    [sym_array_expression] = STATE(867),
    [sym_begin_end_expression] = STATE(867),
    [sym_paren_expression] = STATE(867),
    [sym__high_prec_app] = STATE(864),
    [sym__low_prec_app] = STATE(864),
    [sym_application_expression] = STATE(867),
    [sym_dot_expression] = STATE(867),
    [sym_infix_expression] = STATE(867),
    [sym_ce_expression] = STATE(867),
    [sym_sequential_expression] = STATE(867),
    [sym_char] = STATE(868),
    [sym_format_string] = STATE(869),
    [sym__string_literal] = STATE(869),
    [sym_string] = STATE(868),
    [sym_verbatim_string] = STATE(868),
    [sym_bytearray] = STATE(868),
    [sym_verbatim_bytearray] = STATE(868),
    [sym_format_triple_quoted_string] = STATE(870),
    [sym_triple_quoted_string] = STATE(868),
    [sym_const] = STATE(867),
    [sym_long_identifier] = STATE(872),
    [sym_active_pattern] = STATE(871),
    [sym__identifier_or_op] = STATE(873),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(656),
    [sym_infix_op] = STATE(581),
    [sym_sbyte] = STATE(868),
    [sym_byte] = STATE(868),
    [sym_int16] = STATE(868),
    [sym_uint16] = STATE(868),
    [sym_int32] = STATE(868),
    [sym_uint32] = STATE(868),
    [sym_nativeint] = STATE(868),
    [sym_unativeint] = STATE(868),
    [sym_int64] = STATE(868),
    [sym_uint64] = STATE(868),
    [sym_ieee32] = STATE(868),
    [sym_ieee64] = STATE(868),
    [sym_bignum] = STATE(868),
    [sym_decimal] = STATE(868),
    [sym_float] = STATE(1368),
    [sym_block_comment] = STATE(203),
    [sym_compiler_directive_decl] = STATE(203),
    [sym_fsi_directive_decl] = STATE(203),
    [sym_preproc_line] = STATE(203),
    [sym_preproc_if_in_expression] = STATE(867),
    [aux_sym_sequential_expression_repeat1] = STATE(1542),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(29),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(825),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_COMMA] = ACTIONS(827),
    [anon_sym_null] = ACTIONS(49),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACK_PIPE] = ACTIONS(57),
    [anon_sym_LBRACE] = ACTIONS(139),
    [anon_sym_LT_AT] = ACTIONS(61),
    [anon_sym_LT_AT_AT] = ACTIONS(63),
    [anon_sym_DOT] = ACTIONS(65),
    [anon_sym_LBRACE_PIPE] = ACTIONS(67),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_return_BANG] = ACTIONS(829),
    [anon_sym_yield] = ACTIONS(825),
    [anon_sym_yield_BANG] = ACTIONS(829),
    [anon_sym_lazy] = ACTIONS(825),
    [anon_sym_assert] = ACTIONS(825),
    [anon_sym_upcast] = ACTIONS(825),
    [anon_sym_downcast] = ACTIONS(825),
    [anon_sym_COLON_GT] = ACTIONS(71),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(71),
    [anon_sym_for] = ACTIONS(73),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(79),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_match] = ACTIONS(83),
    [anon_sym_match_BANG] = ACTIONS(85),
    [anon_sym_function] = ACTIONS(87),
    [anon_sym_LT_DASH] = ACTIONS(831),
    [anon_sym_DOT_LBRACK] = ACTIONS(91),
    [anon_sym_LT] = ACTIONS(93),
    [anon_sym_use] = ACTIONS(833),
    [anon_sym_use_BANG] = ACTIONS(835),
    [anon_sym_do_BANG] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(101),
    [anon_sym_LPAREN2] = ACTIONS(103),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(105),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(107),
    [anon_sym_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DQUOTE] = ACTIONS(111),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(115),
    [sym_bool] = ACTIONS(117),
    [sym_unit] = ACTIONS(119),
    [anon_sym_LPAREN_PIPE] = ACTIONS(121),
    [sym_op_identifier] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(837),
    [sym_xint] = ACTIONS(387),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(135),
    [sym__newline] = ACTIONS(839),
    [sym__dedent] = ACTIONS(1355),
  },
  [204] = {
    [sym_function_or_value_defn] = STATE(651),
    [sym__expression] = STATE(167),
    [sym_literal_expression] = STATE(2168),
    [sym_long_identifier_or_op] = STATE(2168),
    [sym_tuple_expression] = STATE(2168),
    [sym_brace_expression] = STATE(2168),
    [sym_anon_record_expression] = STATE(2168),
    [sym_prefixed_expression] = STATE(2168),
    [sym_typecast_expression] = STATE(2168),
    [sym_for_expression] = STATE(2168),
    [sym_while_expression] = STATE(2168),
    [sym__if_branch] = STATE(6406),
    [sym_if_expression] = STATE(2168),
    [sym_fun_expression] = STATE(2168),
    [sym_try_expression] = STATE(2168),
    [sym_match_expression] = STATE(2168),
    [sym_function_expression] = STATE(2168),
    [sym_mutate_expression] = STATE(2168),
    [sym_index_expression] = STATE(2168),
    [sym_typed_expression] = STATE(2168),
    [sym_declaration_expression] = STATE(2168),
    [sym_do_expression] = STATE(2168),
    [sym_list_expression] = STATE(2168),
    [sym_array_expression] = STATE(2168),
    [sym_begin_end_expression] = STATE(2168),
    [sym_paren_expression] = STATE(2168),
    [sym__high_prec_app] = STATE(2179),
    [sym__low_prec_app] = STATE(2179),
    [sym_application_expression] = STATE(2168),
    [sym_dot_expression] = STATE(2168),
    [sym_infix_expression] = STATE(2168),
    [sym_ce_expression] = STATE(2168),
    [sym_sequential_expression] = STATE(2168),
    [sym_char] = STATE(2469),
    [sym_format_string] = STATE(2412),
    [sym__string_literal] = STATE(2412),
    [sym_string] = STATE(2469),
    [sym_verbatim_string] = STATE(2469),
    [sym_bytearray] = STATE(2469),
    [sym_verbatim_bytearray] = STATE(2469),
    [sym_format_triple_quoted_string] = STATE(2408),
    [sym_triple_quoted_string] = STATE(2469),
    [sym_const] = STATE(2168),
    [sym_long_identifier] = STATE(2183),
    [sym_active_pattern] = STATE(2182),
    [sym__identifier_or_op] = STATE(2093),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(650),
    [sym_infix_op] = STATE(721),
    [sym_sbyte] = STATE(2469),
    [sym_byte] = STATE(2469),
    [sym_int16] = STATE(2469),
    [sym_uint16] = STATE(2469),
    [sym_int32] = STATE(2469),
    [sym_uint32] = STATE(2469),
    [sym_nativeint] = STATE(2469),
    [sym_unativeint] = STATE(2469),
    [sym_int64] = STATE(2469),
    [sym_uint64] = STATE(2469),
    [sym_ieee32] = STATE(2469),
    [sym_ieee64] = STATE(2469),
    [sym_bignum] = STATE(2469),
    [sym_decimal] = STATE(2469),
    [sym_float] = STATE(1586),
    [sym_block_comment] = STATE(204),
    [sym_compiler_directive_decl] = STATE(204),
    [sym_fsi_directive_decl] = STATE(204),
    [sym_preproc_line] = STATE(204),
    [sym_preproc_if_in_expression] = STATE(2168),
    [aux_sym_sequential_expression_repeat1] = STATE(1755),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(989),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(991),
    [anon_sym_return] = ACTIONS(993),
    [anon_sym_do] = ACTIONS(995),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(997),
    [anon_sym_COMMA] = ACTIONS(999),
    [anon_sym_null] = ACTIONS(1001),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(991),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1003),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1005),
    [anon_sym_LBRACE] = ACTIONS(1007),
    [anon_sym_LT_AT] = ACTIONS(1009),
    [anon_sym_AT_GT] = ACTIONS(173),
    [anon_sym_LT_AT_AT] = ACTIONS(1013),
    [anon_sym_DOT] = ACTIONS(1015),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1017),
    [anon_sym_new] = ACTIONS(993),
    [anon_sym_return_BANG] = ACTIONS(1019),
    [anon_sym_yield] = ACTIONS(993),
    [anon_sym_yield_BANG] = ACTIONS(1019),
    [anon_sym_lazy] = ACTIONS(993),
    [anon_sym_assert] = ACTIONS(993),
    [anon_sym_upcast] = ACTIONS(993),
    [anon_sym_downcast] = ACTIONS(993),
    [anon_sym_COLON_GT] = ACTIONS(1021),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1021),
    [anon_sym_for] = ACTIONS(1023),
    [anon_sym_while] = ACTIONS(1025),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(1027),
    [anon_sym_try] = ACTIONS(1029),
    [anon_sym_match] = ACTIONS(1031),
    [anon_sym_match_BANG] = ACTIONS(1033),
    [anon_sym_function] = ACTIONS(1035),
    [anon_sym_LT_DASH] = ACTIONS(1037),
    [anon_sym_DOT_LBRACK] = ACTIONS(1039),
    [anon_sym_LT] = ACTIONS(1041),
    [anon_sym_use] = ACTIONS(1043),
    [anon_sym_use_BANG] = ACTIONS(1045),
    [anon_sym_do_BANG] = ACTIONS(1047),
    [anon_sym_begin] = ACTIONS(1049),
    [anon_sym_LPAREN2] = ACTIONS(1051),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(1053),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1055),
    [anon_sym_DQUOTE] = ACTIONS(1057),
    [anon_sym_AT_DQUOTE] = ACTIONS(1059),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1061),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1063),
    [sym_bool] = ACTIONS(1065),
    [sym_unit] = ACTIONS(1067),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1069),
    [sym_op_identifier] = ACTIONS(1071),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(1073),
    [sym_xint] = ACTIONS(1075),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1077),
    [sym__newline] = ACTIONS(1079),
  },
  [205] = {
    [sym_function_or_value_defn] = STATE(704),
    [sym__expression] = STATE(312),
    [sym_literal_expression] = STATE(2403),
    [sym_long_identifier_or_op] = STATE(2403),
    [sym_tuple_expression] = STATE(2403),
    [sym_brace_expression] = STATE(2403),
    [sym_anon_record_expression] = STATE(2403),
    [sym_prefixed_expression] = STATE(2403),
    [sym_typecast_expression] = STATE(2403),
    [sym_for_expression] = STATE(2403),
    [sym_while_expression] = STATE(2403),
    [sym__if_branch] = STATE(6794),
    [sym_if_expression] = STATE(2403),
    [sym_fun_expression] = STATE(2403),
    [sym_try_expression] = STATE(2403),
    [sym_match_expression] = STATE(2403),
    [sym_function_expression] = STATE(2403),
    [sym_mutate_expression] = STATE(2403),
    [sym_index_expression] = STATE(2403),
    [sym_typed_expression] = STATE(2403),
    [sym_declaration_expression] = STATE(2403),
    [sym_do_expression] = STATE(2403),
    [sym_list_expression] = STATE(2403),
    [sym_array_expression] = STATE(2403),
    [sym_begin_end_expression] = STATE(2403),
    [sym_paren_expression] = STATE(2403),
    [sym__high_prec_app] = STATE(2405),
    [sym__low_prec_app] = STATE(2405),
    [sym_application_expression] = STATE(2403),
    [sym_dot_expression] = STATE(2403),
    [sym_infix_expression] = STATE(2403),
    [sym_ce_expression] = STATE(2403),
    [sym_sequential_expression] = STATE(2403),
    [sym_char] = STATE(2425),
    [sym_format_string] = STATE(2420),
    [sym__string_literal] = STATE(2420),
    [sym_string] = STATE(2425),
    [sym_verbatim_string] = STATE(2425),
    [sym_bytearray] = STATE(2425),
    [sym_verbatim_bytearray] = STATE(2425),
    [sym_format_triple_quoted_string] = STATE(2419),
    [sym_triple_quoted_string] = STATE(2425),
    [sym_const] = STATE(2403),
    [sym_long_identifier] = STATE(2079),
    [sym_active_pattern] = STATE(2080),
    [sym__identifier_or_op] = STATE(2089),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(688),
    [sym_infix_op] = STATE(668),
    [sym_sbyte] = STATE(2425),
    [sym_byte] = STATE(2425),
    [sym_int16] = STATE(2425),
    [sym_uint16] = STATE(2425),
    [sym_int32] = STATE(2425),
    [sym_uint32] = STATE(2425),
    [sym_nativeint] = STATE(2425),
    [sym_unativeint] = STATE(2425),
    [sym_int64] = STATE(2425),
    [sym_uint64] = STATE(2425),
    [sym_ieee32] = STATE(2425),
    [sym_ieee64] = STATE(2425),
    [sym_bignum] = STATE(2425),
    [sym_decimal] = STATE(2425),
    [sym_float] = STATE(1511),
    [sym_block_comment] = STATE(205),
    [sym_compiler_directive_decl] = STATE(205),
    [sym_fsi_directive_decl] = STATE(205),
    [sym_preproc_line] = STATE(205),
    [sym_preproc_if_in_expression] = STATE(2403),
    [aux_sym_sequential_expression_repeat1] = STATE(1901),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(1261),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(1263),
    [anon_sym_return] = ACTIONS(1265),
    [anon_sym_do] = ACTIONS(1267),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(1269),
    [anon_sym_COMMA] = ACTIONS(1271),
    [anon_sym_null] = ACTIONS(1273),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(1263),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1275),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1277),
    [anon_sym_LBRACE] = ACTIONS(1279),
    [anon_sym_LT_AT] = ACTIONS(1281),
    [anon_sym_LT_AT_AT] = ACTIONS(1283),
    [anon_sym_DOT] = ACTIONS(1285),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1287),
    [anon_sym_new] = ACTIONS(1265),
    [anon_sym_return_BANG] = ACTIONS(1289),
    [anon_sym_yield] = ACTIONS(1265),
    [anon_sym_yield_BANG] = ACTIONS(1289),
    [anon_sym_lazy] = ACTIONS(1265),
    [anon_sym_assert] = ACTIONS(1265),
    [anon_sym_upcast] = ACTIONS(1265),
    [anon_sym_downcast] = ACTIONS(1265),
    [anon_sym_COLON_GT] = ACTIONS(1291),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1291),
    [anon_sym_for] = ACTIONS(1293),
    [anon_sym_while] = ACTIONS(1295),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(1297),
    [anon_sym_try] = ACTIONS(1299),
    [anon_sym_match] = ACTIONS(1301),
    [anon_sym_match_BANG] = ACTIONS(1303),
    [anon_sym_function] = ACTIONS(1305),
    [anon_sym_LT_DASH] = ACTIONS(1307),
    [anon_sym_DOT_LBRACK] = ACTIONS(1309),
    [anon_sym_LT] = ACTIONS(1311),
    [anon_sym_use] = ACTIONS(1313),
    [anon_sym_use_BANG] = ACTIONS(1315),
    [anon_sym_do_BANG] = ACTIONS(1317),
    [anon_sym_begin] = ACTIONS(1319),
    [anon_sym_LPAREN2] = ACTIONS(1321),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(1323),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1325),
    [anon_sym_DQUOTE] = ACTIONS(1327),
    [anon_sym_AT_DQUOTE] = ACTIONS(1329),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1331),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1333),
    [sym_bool] = ACTIONS(1335),
    [sym_unit] = ACTIONS(1337),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1339),
    [sym_op_identifier] = ACTIONS(1341),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(1343),
    [sym_xint] = ACTIONS(1345),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1347),
    [anon_sym_POUNDendif] = ACTIONS(821),
    [sym__newline] = ACTIONS(1349),
  },
  [206] = {
    [sym_function_or_value_defn] = STATE(600),
    [sym__expression] = STATE(88),
    [sym_literal_expression] = STATE(867),
    [sym_long_identifier_or_op] = STATE(867),
    [sym_tuple_expression] = STATE(867),
    [sym_brace_expression] = STATE(867),
    [sym_anon_record_expression] = STATE(867),
    [sym_prefixed_expression] = STATE(867),
    [sym_typecast_expression] = STATE(867),
    [sym_for_expression] = STATE(867),
    [sym_while_expression] = STATE(867),
    [sym__if_branch] = STATE(6511),
    [sym_if_expression] = STATE(867),
    [sym_fun_expression] = STATE(867),
    [sym_try_expression] = STATE(867),
    [sym_match_expression] = STATE(867),
    [sym_function_expression] = STATE(867),
    [sym_mutate_expression] = STATE(867),
    [sym_index_expression] = STATE(867),
    [sym_typed_expression] = STATE(867),
    [sym_declaration_expression] = STATE(867),
    [sym_do_expression] = STATE(867),
    [sym_list_expression] = STATE(867),
    [sym_array_expression] = STATE(867),
    [sym_begin_end_expression] = STATE(867),
    [sym_paren_expression] = STATE(867),
    [sym__high_prec_app] = STATE(864),
    [sym__low_prec_app] = STATE(864),
    [sym_application_expression] = STATE(867),
    [sym_dot_expression] = STATE(867),
    [sym_infix_expression] = STATE(867),
    [sym_ce_expression] = STATE(867),
    [sym_sequential_expression] = STATE(867),
    [sym_char] = STATE(868),
    [sym_format_string] = STATE(869),
    [sym__string_literal] = STATE(869),
    [sym_string] = STATE(868),
    [sym_verbatim_string] = STATE(868),
    [sym_bytearray] = STATE(868),
    [sym_verbatim_bytearray] = STATE(868),
    [sym_format_triple_quoted_string] = STATE(870),
    [sym_triple_quoted_string] = STATE(868),
    [sym_const] = STATE(867),
    [sym_long_identifier] = STATE(872),
    [sym_active_pattern] = STATE(871),
    [sym__identifier_or_op] = STATE(873),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(656),
    [sym_infix_op] = STATE(581),
    [sym_sbyte] = STATE(868),
    [sym_byte] = STATE(868),
    [sym_int16] = STATE(868),
    [sym_uint16] = STATE(868),
    [sym_int32] = STATE(868),
    [sym_uint32] = STATE(868),
    [sym_nativeint] = STATE(868),
    [sym_unativeint] = STATE(868),
    [sym_int64] = STATE(868),
    [sym_uint64] = STATE(868),
    [sym_ieee32] = STATE(868),
    [sym_ieee64] = STATE(868),
    [sym_bignum] = STATE(868),
    [sym_decimal] = STATE(868),
    [sym_float] = STATE(1368),
    [sym_block_comment] = STATE(206),
    [sym_compiler_directive_decl] = STATE(206),
    [sym_fsi_directive_decl] = STATE(206),
    [sym_preproc_line] = STATE(206),
    [sym_preproc_if_in_expression] = STATE(867),
    [aux_sym_sequential_expression_repeat1] = STATE(1542),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(29),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(825),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_COMMA] = ACTIONS(827),
    [anon_sym_null] = ACTIONS(49),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACK_PIPE] = ACTIONS(57),
    [anon_sym_LBRACE] = ACTIONS(139),
    [anon_sym_LT_AT] = ACTIONS(61),
    [anon_sym_LT_AT_AT] = ACTIONS(63),
    [anon_sym_DOT] = ACTIONS(65),
    [anon_sym_LBRACE_PIPE] = ACTIONS(67),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_return_BANG] = ACTIONS(829),
    [anon_sym_yield] = ACTIONS(825),
    [anon_sym_yield_BANG] = ACTIONS(829),
    [anon_sym_lazy] = ACTIONS(825),
    [anon_sym_assert] = ACTIONS(825),
    [anon_sym_upcast] = ACTIONS(825),
    [anon_sym_downcast] = ACTIONS(825),
    [anon_sym_COLON_GT] = ACTIONS(71),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(71),
    [anon_sym_for] = ACTIONS(73),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(79),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_match] = ACTIONS(83),
    [anon_sym_match_BANG] = ACTIONS(85),
    [anon_sym_function] = ACTIONS(87),
    [anon_sym_LT_DASH] = ACTIONS(831),
    [anon_sym_DOT_LBRACK] = ACTIONS(91),
    [anon_sym_LT] = ACTIONS(93),
    [anon_sym_use] = ACTIONS(833),
    [anon_sym_use_BANG] = ACTIONS(835),
    [anon_sym_do_BANG] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(101),
    [anon_sym_LPAREN2] = ACTIONS(103),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(105),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(107),
    [anon_sym_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DQUOTE] = ACTIONS(111),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(115),
    [sym_bool] = ACTIONS(117),
    [sym_unit] = ACTIONS(119),
    [anon_sym_LPAREN_PIPE] = ACTIONS(121),
    [sym_op_identifier] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(837),
    [sym_xint] = ACTIONS(387),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(135),
    [sym__newline] = ACTIONS(839),
    [sym__dedent] = ACTIONS(1357),
  },
  [207] = {
    [sym_function_or_value_defn] = STATE(600),
    [sym__expression] = STATE(88),
    [sym_literal_expression] = STATE(867),
    [sym_long_identifier_or_op] = STATE(867),
    [sym_tuple_expression] = STATE(867),
    [sym_brace_expression] = STATE(867),
    [sym_anon_record_expression] = STATE(867),
    [sym_prefixed_expression] = STATE(867),
    [sym_typecast_expression] = STATE(867),
    [sym_for_expression] = STATE(867),
    [sym_while_expression] = STATE(867),
    [sym__if_branch] = STATE(6511),
    [sym_if_expression] = STATE(867),
    [sym_fun_expression] = STATE(867),
    [sym_try_expression] = STATE(867),
    [sym_match_expression] = STATE(867),
    [sym_function_expression] = STATE(867),
    [sym_mutate_expression] = STATE(867),
    [sym_index_expression] = STATE(867),
    [sym_typed_expression] = STATE(867),
    [sym_declaration_expression] = STATE(867),
    [sym_do_expression] = STATE(867),
    [sym_list_expression] = STATE(867),
    [sym_array_expression] = STATE(867),
    [sym_begin_end_expression] = STATE(867),
    [sym_paren_expression] = STATE(867),
    [sym__high_prec_app] = STATE(864),
    [sym__low_prec_app] = STATE(864),
    [sym_application_expression] = STATE(867),
    [sym_dot_expression] = STATE(867),
    [sym_infix_expression] = STATE(867),
    [sym_ce_expression] = STATE(867),
    [sym_sequential_expression] = STATE(867),
    [sym_char] = STATE(868),
    [sym_format_string] = STATE(869),
    [sym__string_literal] = STATE(869),
    [sym_string] = STATE(868),
    [sym_verbatim_string] = STATE(868),
    [sym_bytearray] = STATE(868),
    [sym_verbatim_bytearray] = STATE(868),
    [sym_format_triple_quoted_string] = STATE(870),
    [sym_triple_quoted_string] = STATE(868),
    [sym_const] = STATE(867),
    [sym_long_identifier] = STATE(872),
    [sym_active_pattern] = STATE(871),
    [sym__identifier_or_op] = STATE(873),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(656),
    [sym_infix_op] = STATE(581),
    [sym_sbyte] = STATE(868),
    [sym_byte] = STATE(868),
    [sym_int16] = STATE(868),
    [sym_uint16] = STATE(868),
    [sym_int32] = STATE(868),
    [sym_uint32] = STATE(868),
    [sym_nativeint] = STATE(868),
    [sym_unativeint] = STATE(868),
    [sym_int64] = STATE(868),
    [sym_uint64] = STATE(868),
    [sym_ieee32] = STATE(868),
    [sym_ieee64] = STATE(868),
    [sym_bignum] = STATE(868),
    [sym_decimal] = STATE(868),
    [sym_float] = STATE(1368),
    [sym_block_comment] = STATE(207),
    [sym_compiler_directive_decl] = STATE(207),
    [sym_fsi_directive_decl] = STATE(207),
    [sym_preproc_line] = STATE(207),
    [sym_preproc_if_in_expression] = STATE(867),
    [aux_sym_sequential_expression_repeat1] = STATE(1542),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(29),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(825),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_COMMA] = ACTIONS(827),
    [anon_sym_null] = ACTIONS(49),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACK_PIPE] = ACTIONS(57),
    [anon_sym_LBRACE] = ACTIONS(139),
    [anon_sym_LT_AT] = ACTIONS(61),
    [anon_sym_LT_AT_AT] = ACTIONS(63),
    [anon_sym_DOT] = ACTIONS(65),
    [anon_sym_LBRACE_PIPE] = ACTIONS(67),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_return_BANG] = ACTIONS(829),
    [anon_sym_yield] = ACTIONS(825),
    [anon_sym_yield_BANG] = ACTIONS(829),
    [anon_sym_lazy] = ACTIONS(825),
    [anon_sym_assert] = ACTIONS(825),
    [anon_sym_upcast] = ACTIONS(825),
    [anon_sym_downcast] = ACTIONS(825),
    [anon_sym_COLON_GT] = ACTIONS(71),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(71),
    [anon_sym_for] = ACTIONS(73),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(79),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_match] = ACTIONS(83),
    [anon_sym_match_BANG] = ACTIONS(85),
    [anon_sym_function] = ACTIONS(87),
    [anon_sym_LT_DASH] = ACTIONS(831),
    [anon_sym_DOT_LBRACK] = ACTIONS(91),
    [anon_sym_LT] = ACTIONS(93),
    [anon_sym_use] = ACTIONS(833),
    [anon_sym_use_BANG] = ACTIONS(835),
    [anon_sym_do_BANG] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(101),
    [anon_sym_LPAREN2] = ACTIONS(103),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(105),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(107),
    [anon_sym_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DQUOTE] = ACTIONS(111),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(115),
    [sym_bool] = ACTIONS(117),
    [sym_unit] = ACTIONS(119),
    [anon_sym_LPAREN_PIPE] = ACTIONS(121),
    [sym_op_identifier] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(837),
    [sym_xint] = ACTIONS(387),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(135),
    [sym__newline] = ACTIONS(839),
    [sym__dedent] = ACTIONS(1359),
  },
  [208] = {
    [sym_function_or_value_defn] = STATE(627),
    [sym__expression] = STATE(17),
    [sym_literal_expression] = STATE(1118),
    [sym_long_identifier_or_op] = STATE(1118),
    [sym_tuple_expression] = STATE(1118),
    [sym_brace_expression] = STATE(1118),
    [sym_anon_record_expression] = STATE(1118),
    [sym_prefixed_expression] = STATE(1118),
    [sym_typecast_expression] = STATE(1118),
    [sym_for_expression] = STATE(1118),
    [sym_while_expression] = STATE(1118),
    [sym__if_branch] = STATE(7163),
    [sym_if_expression] = STATE(1118),
    [sym_fun_expression] = STATE(1118),
    [sym_try_expression] = STATE(1118),
    [sym_match_expression] = STATE(1118),
    [sym_function_expression] = STATE(1118),
    [sym_mutate_expression] = STATE(1118),
    [sym_index_expression] = STATE(1118),
    [sym_typed_expression] = STATE(1118),
    [sym_declaration_expression] = STATE(1118),
    [sym_do_expression] = STATE(1118),
    [sym_list_expression] = STATE(1118),
    [sym_array_expression] = STATE(1118),
    [sym_begin_end_expression] = STATE(1118),
    [sym_paren_expression] = STATE(1118),
    [sym__high_prec_app] = STATE(1133),
    [sym__low_prec_app] = STATE(1133),
    [sym_application_expression] = STATE(1118),
    [sym_dot_expression] = STATE(1118),
    [sym_infix_expression] = STATE(1118),
    [sym_ce_expression] = STATE(1118),
    [sym_sequential_expression] = STATE(1118),
    [sym_char] = STATE(1080),
    [sym_format_string] = STATE(1090),
    [sym__string_literal] = STATE(1090),
    [sym_string] = STATE(1080),
    [sym_verbatim_string] = STATE(1080),
    [sym_bytearray] = STATE(1080),
    [sym_verbatim_bytearray] = STATE(1080),
    [sym_format_triple_quoted_string] = STATE(1096),
    [sym_triple_quoted_string] = STATE(1080),
    [sym_const] = STATE(1118),
    [sym_long_identifier] = STATE(1156),
    [sym_active_pattern] = STATE(1085),
    [sym__identifier_or_op] = STATE(1099),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(517),
    [sym_infix_op] = STATE(487),
    [sym_sbyte] = STATE(1080),
    [sym_byte] = STATE(1080),
    [sym_int16] = STATE(1080),
    [sym_uint16] = STATE(1080),
    [sym_int32] = STATE(1080),
    [sym_uint32] = STATE(1080),
    [sym_nativeint] = STATE(1080),
    [sym_unativeint] = STATE(1080),
    [sym_int64] = STATE(1080),
    [sym_uint64] = STATE(1080),
    [sym_ieee32] = STATE(1080),
    [sym_ieee64] = STATE(1080),
    [sym_bignum] = STATE(1080),
    [sym_decimal] = STATE(1080),
    [sym_float] = STATE(979),
    [sym_block_comment] = STATE(208),
    [sym_compiler_directive_decl] = STATE(208),
    [sym_fsi_directive_decl] = STATE(208),
    [sym_preproc_line] = STATE(208),
    [sym_preproc_if_in_expression] = STATE(1118),
    [aux_sym_sequential_expression_repeat1] = STATE(1069),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(195),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(197),
    [anon_sym_return] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_COMMA] = ACTIONS(205),
    [anon_sym_null] = ACTIONS(207),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(197),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(209),
    [anon_sym_LBRACK_PIPE] = ACTIONS(211),
    [anon_sym_LBRACE] = ACTIONS(271),
    [anon_sym_LT_AT] = ACTIONS(213),
    [anon_sym_LT_AT_AT] = ACTIONS(215),
    [anon_sym_DOT] = ACTIONS(185),
    [anon_sym_LBRACE_PIPE] = ACTIONS(217),
    [anon_sym_new] = ACTIONS(199),
    [anon_sym_with] = ACTIONS(1361),
    [anon_sym_return_BANG] = ACTIONS(219),
    [anon_sym_yield] = ACTIONS(199),
    [anon_sym_yield_BANG] = ACTIONS(219),
    [anon_sym_lazy] = ACTIONS(199),
    [anon_sym_assert] = ACTIONS(199),
    [anon_sym_upcast] = ACTIONS(199),
    [anon_sym_downcast] = ACTIONS(199),
    [anon_sym_COLON_GT] = ACTIONS(221),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(221),
    [anon_sym_for] = ACTIONS(223),
    [anon_sym_while] = ACTIONS(225),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(229),
    [anon_sym_match] = ACTIONS(231),
    [anon_sym_match_BANG] = ACTIONS(233),
    [anon_sym_function] = ACTIONS(235),
    [anon_sym_LT_DASH] = ACTIONS(237),
    [anon_sym_DOT_LBRACK] = ACTIONS(187),
    [anon_sym_LT] = ACTIONS(189),
    [anon_sym_use] = ACTIONS(239),
    [anon_sym_use_BANG] = ACTIONS(241),
    [anon_sym_do_BANG] = ACTIONS(243),
    [anon_sym_begin] = ACTIONS(245),
    [anon_sym_LPAREN2] = ACTIONS(191),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(247),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(251),
    [anon_sym_AT_DQUOTE] = ACTIONS(253),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(255),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(257),
    [sym_bool] = ACTIONS(259),
    [sym_unit] = ACTIONS(193),
    [anon_sym_LPAREN_PIPE] = ACTIONS(261),
    [sym_op_identifier] = ACTIONS(263),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(265),
    [sym_xint] = ACTIONS(267),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(269),
    [sym__newline] = ACTIONS(1363),
  },
  [209] = {
    [sym_function_or_value_defn] = STATE(600),
    [sym__expression] = STATE(88),
    [sym_literal_expression] = STATE(867),
    [sym_long_identifier_or_op] = STATE(867),
    [sym_tuple_expression] = STATE(867),
    [sym_brace_expression] = STATE(867),
    [sym_anon_record_expression] = STATE(867),
    [sym_prefixed_expression] = STATE(867),
    [sym_typecast_expression] = STATE(867),
    [sym_for_expression] = STATE(867),
    [sym_while_expression] = STATE(867),
    [sym__if_branch] = STATE(6511),
    [sym_if_expression] = STATE(867),
    [sym_fun_expression] = STATE(867),
    [sym_try_expression] = STATE(867),
    [sym_match_expression] = STATE(867),
    [sym_function_expression] = STATE(867),
    [sym_mutate_expression] = STATE(867),
    [sym_index_expression] = STATE(867),
    [sym_typed_expression] = STATE(867),
    [sym_declaration_expression] = STATE(867),
    [sym_do_expression] = STATE(867),
    [sym_list_expression] = STATE(867),
    [sym_array_expression] = STATE(867),
    [sym_begin_end_expression] = STATE(867),
    [sym_paren_expression] = STATE(867),
    [sym__high_prec_app] = STATE(864),
    [sym__low_prec_app] = STATE(864),
    [sym_application_expression] = STATE(867),
    [sym_dot_expression] = STATE(867),
    [sym_infix_expression] = STATE(867),
    [sym_ce_expression] = STATE(867),
    [sym_sequential_expression] = STATE(867),
    [sym_char] = STATE(868),
    [sym_format_string] = STATE(869),
    [sym__string_literal] = STATE(869),
    [sym_string] = STATE(868),
    [sym_verbatim_string] = STATE(868),
    [sym_bytearray] = STATE(868),
    [sym_verbatim_bytearray] = STATE(868),
    [sym_format_triple_quoted_string] = STATE(870),
    [sym_triple_quoted_string] = STATE(868),
    [sym_const] = STATE(867),
    [sym_long_identifier] = STATE(872),
    [sym_active_pattern] = STATE(871),
    [sym__identifier_or_op] = STATE(873),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(656),
    [sym_infix_op] = STATE(581),
    [sym_sbyte] = STATE(868),
    [sym_byte] = STATE(868),
    [sym_int16] = STATE(868),
    [sym_uint16] = STATE(868),
    [sym_int32] = STATE(868),
    [sym_uint32] = STATE(868),
    [sym_nativeint] = STATE(868),
    [sym_unativeint] = STATE(868),
    [sym_int64] = STATE(868),
    [sym_uint64] = STATE(868),
    [sym_ieee32] = STATE(868),
    [sym_ieee64] = STATE(868),
    [sym_bignum] = STATE(868),
    [sym_decimal] = STATE(868),
    [sym_float] = STATE(1368),
    [sym_block_comment] = STATE(209),
    [sym_compiler_directive_decl] = STATE(209),
    [sym_fsi_directive_decl] = STATE(209),
    [sym_preproc_line] = STATE(209),
    [sym_preproc_if_in_expression] = STATE(867),
    [aux_sym_sequential_expression_repeat1] = STATE(1542),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(29),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(825),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_COMMA] = ACTIONS(827),
    [anon_sym_null] = ACTIONS(49),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACK_PIPE] = ACTIONS(57),
    [anon_sym_LBRACE] = ACTIONS(139),
    [anon_sym_LT_AT] = ACTIONS(61),
    [anon_sym_LT_AT_AT] = ACTIONS(63),
    [anon_sym_DOT] = ACTIONS(65),
    [anon_sym_LBRACE_PIPE] = ACTIONS(67),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_return_BANG] = ACTIONS(829),
    [anon_sym_yield] = ACTIONS(825),
    [anon_sym_yield_BANG] = ACTIONS(829),
    [anon_sym_lazy] = ACTIONS(825),
    [anon_sym_assert] = ACTIONS(825),
    [anon_sym_upcast] = ACTIONS(825),
    [anon_sym_downcast] = ACTIONS(825),
    [anon_sym_COLON_GT] = ACTIONS(71),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(71),
    [anon_sym_for] = ACTIONS(73),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(79),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_match] = ACTIONS(83),
    [anon_sym_match_BANG] = ACTIONS(85),
    [anon_sym_function] = ACTIONS(87),
    [anon_sym_LT_DASH] = ACTIONS(831),
    [anon_sym_DOT_LBRACK] = ACTIONS(91),
    [anon_sym_LT] = ACTIONS(93),
    [anon_sym_use] = ACTIONS(833),
    [anon_sym_use_BANG] = ACTIONS(835),
    [anon_sym_do_BANG] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(101),
    [anon_sym_LPAREN2] = ACTIONS(103),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(105),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(107),
    [anon_sym_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DQUOTE] = ACTIONS(111),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(115),
    [sym_bool] = ACTIONS(117),
    [sym_unit] = ACTIONS(119),
    [anon_sym_LPAREN_PIPE] = ACTIONS(121),
    [sym_op_identifier] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(837),
    [sym_xint] = ACTIONS(387),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(135),
    [sym__newline] = ACTIONS(839),
    [sym__dedent] = ACTIONS(1365),
  },
  [210] = {
    [sym_function_or_value_defn] = STATE(733),
    [sym__expression] = STATE(142),
    [sym_literal_expression] = STATE(2008),
    [sym_long_identifier_or_op] = STATE(2008),
    [sym_tuple_expression] = STATE(2008),
    [sym_brace_expression] = STATE(2008),
    [sym_anon_record_expression] = STATE(2008),
    [sym_prefixed_expression] = STATE(2008),
    [sym_typecast_expression] = STATE(2008),
    [sym_for_expression] = STATE(2008),
    [sym_while_expression] = STATE(2008),
    [sym__if_branch] = STATE(6754),
    [sym_if_expression] = STATE(2008),
    [sym_fun_expression] = STATE(2008),
    [sym_try_expression] = STATE(2008),
    [sym_match_expression] = STATE(2008),
    [sym_function_expression] = STATE(2008),
    [sym_mutate_expression] = STATE(2008),
    [sym_index_expression] = STATE(2008),
    [sym_typed_expression] = STATE(2008),
    [sym_declaration_expression] = STATE(2008),
    [sym_do_expression] = STATE(2008),
    [sym_list_expression] = STATE(2008),
    [sym_array_expression] = STATE(2008),
    [sym_begin_end_expression] = STATE(2008),
    [sym_paren_expression] = STATE(2008),
    [sym__high_prec_app] = STATE(2007),
    [sym__low_prec_app] = STATE(2007),
    [sym_application_expression] = STATE(2008),
    [sym_dot_expression] = STATE(2008),
    [sym_infix_expression] = STATE(2008),
    [sym_ce_expression] = STATE(2008),
    [sym_sequential_expression] = STATE(2008),
    [sym_char] = STATE(1859),
    [sym_format_string] = STATE(1861),
    [sym__string_literal] = STATE(1861),
    [sym_string] = STATE(1859),
    [sym_verbatim_string] = STATE(1859),
    [sym_bytearray] = STATE(1859),
    [sym_verbatim_bytearray] = STATE(1859),
    [sym_format_triple_quoted_string] = STATE(1862),
    [sym_triple_quoted_string] = STATE(1859),
    [sym_const] = STATE(2008),
    [sym_long_identifier] = STATE(1701),
    [sym_active_pattern] = STATE(1702),
    [sym__identifier_or_op] = STATE(1724),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(706),
    [sym_infix_op] = STATE(678),
    [sym_sbyte] = STATE(1859),
    [sym_byte] = STATE(1859),
    [sym_int16] = STATE(1859),
    [sym_uint16] = STATE(1859),
    [sym_int32] = STATE(1859),
    [sym_uint32] = STATE(1859),
    [sym_nativeint] = STATE(1859),
    [sym_unativeint] = STATE(1859),
    [sym_int64] = STATE(1859),
    [sym_uint64] = STATE(1859),
    [sym_ieee32] = STATE(1859),
    [sym_ieee64] = STATE(1859),
    [sym_bignum] = STATE(1859),
    [sym_decimal] = STATE(1859),
    [sym_float] = STATE(1447),
    [sym_block_comment] = STATE(210),
    [sym_compiler_directive_decl] = STATE(210),
    [sym_fsi_directive_decl] = STATE(210),
    [sym_preproc_line] = STATE(210),
    [sym_preproc_if_in_expression] = STATE(2008),
    [aux_sym_sequential_expression_repeat1] = STATE(1995),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(503),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(969),
    [anon_sym_return] = ACTIONS(971),
    [anon_sym_do] = ACTIONS(1367),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(511),
    [anon_sym_COMMA] = ACTIONS(973),
    [anon_sym_null] = ACTIONS(515),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(969),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(517),
    [anon_sym_LBRACK_PIPE] = ACTIONS(519),
    [anon_sym_LBRACE] = ACTIONS(521),
    [anon_sym_LT_AT] = ACTIONS(523),
    [anon_sym_LT_AT_AT] = ACTIONS(525),
    [anon_sym_DOT] = ACTIONS(527),
    [anon_sym_LBRACE_PIPE] = ACTIONS(529),
    [anon_sym_new] = ACTIONS(971),
    [anon_sym_return_BANG] = ACTIONS(975),
    [anon_sym_yield] = ACTIONS(971),
    [anon_sym_yield_BANG] = ACTIONS(975),
    [anon_sym_lazy] = ACTIONS(971),
    [anon_sym_assert] = ACTIONS(971),
    [anon_sym_upcast] = ACTIONS(971),
    [anon_sym_downcast] = ACTIONS(971),
    [anon_sym_COLON_GT] = ACTIONS(977),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(977),
    [anon_sym_for] = ACTIONS(979),
    [anon_sym_while] = ACTIONS(537),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(539),
    [anon_sym_DASH_GT] = ACTIONS(1367),
    [anon_sym_try] = ACTIONS(543),
    [anon_sym_match] = ACTIONS(545),
    [anon_sym_match_BANG] = ACTIONS(547),
    [anon_sym_function] = ACTIONS(549),
    [anon_sym_LT_DASH] = ACTIONS(981),
    [anon_sym_DOT_LBRACK] = ACTIONS(553),
    [anon_sym_LT] = ACTIONS(555),
    [anon_sym_use] = ACTIONS(983),
    [anon_sym_use_BANG] = ACTIONS(985),
    [anon_sym_do_BANG] = ACTIONS(561),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_LPAREN2] = ACTIONS(567),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(569),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(571),
    [anon_sym_DQUOTE] = ACTIONS(573),
    [anon_sym_AT_DQUOTE] = ACTIONS(575),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(577),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(579),
    [sym_bool] = ACTIONS(581),
    [sym_unit] = ACTIONS(583),
    [anon_sym_LPAREN_PIPE] = ACTIONS(585),
    [sym_op_identifier] = ACTIONS(587),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(591),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(593),
    [sym__newline] = ACTIONS(1171),
  },
  [211] = {
    [sym_function_or_value_defn] = STATE(600),
    [sym__expression] = STATE(88),
    [sym_literal_expression] = STATE(867),
    [sym_long_identifier_or_op] = STATE(867),
    [sym_tuple_expression] = STATE(867),
    [sym_brace_expression] = STATE(867),
    [sym_anon_record_expression] = STATE(867),
    [sym_prefixed_expression] = STATE(867),
    [sym_typecast_expression] = STATE(867),
    [sym_for_expression] = STATE(867),
    [sym_while_expression] = STATE(867),
    [sym__if_branch] = STATE(6511),
    [sym_if_expression] = STATE(867),
    [sym_fun_expression] = STATE(867),
    [sym_try_expression] = STATE(867),
    [sym_match_expression] = STATE(867),
    [sym_function_expression] = STATE(867),
    [sym_mutate_expression] = STATE(867),
    [sym_index_expression] = STATE(867),
    [sym_typed_expression] = STATE(867),
    [sym_declaration_expression] = STATE(867),
    [sym_do_expression] = STATE(867),
    [sym_list_expression] = STATE(867),
    [sym_array_expression] = STATE(867),
    [sym_begin_end_expression] = STATE(867),
    [sym_paren_expression] = STATE(867),
    [sym__high_prec_app] = STATE(864),
    [sym__low_prec_app] = STATE(864),
    [sym_application_expression] = STATE(867),
    [sym_dot_expression] = STATE(867),
    [sym_infix_expression] = STATE(867),
    [sym_ce_expression] = STATE(867),
    [sym_sequential_expression] = STATE(867),
    [sym_char] = STATE(868),
    [sym_format_string] = STATE(869),
    [sym__string_literal] = STATE(869),
    [sym_string] = STATE(868),
    [sym_verbatim_string] = STATE(868),
    [sym_bytearray] = STATE(868),
    [sym_verbatim_bytearray] = STATE(868),
    [sym_format_triple_quoted_string] = STATE(870),
    [sym_triple_quoted_string] = STATE(868),
    [sym_const] = STATE(867),
    [sym_long_identifier] = STATE(872),
    [sym_active_pattern] = STATE(871),
    [sym__identifier_or_op] = STATE(873),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(656),
    [sym_infix_op] = STATE(581),
    [sym_sbyte] = STATE(868),
    [sym_byte] = STATE(868),
    [sym_int16] = STATE(868),
    [sym_uint16] = STATE(868),
    [sym_int32] = STATE(868),
    [sym_uint32] = STATE(868),
    [sym_nativeint] = STATE(868),
    [sym_unativeint] = STATE(868),
    [sym_int64] = STATE(868),
    [sym_uint64] = STATE(868),
    [sym_ieee32] = STATE(868),
    [sym_ieee64] = STATE(868),
    [sym_bignum] = STATE(868),
    [sym_decimal] = STATE(868),
    [sym_float] = STATE(1368),
    [sym_block_comment] = STATE(211),
    [sym_compiler_directive_decl] = STATE(211),
    [sym_fsi_directive_decl] = STATE(211),
    [sym_preproc_line] = STATE(211),
    [sym_preproc_if_in_expression] = STATE(867),
    [aux_sym_sequential_expression_repeat1] = STATE(1542),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(29),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(825),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_COMMA] = ACTIONS(827),
    [anon_sym_null] = ACTIONS(49),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACK_PIPE] = ACTIONS(57),
    [anon_sym_LBRACE] = ACTIONS(139),
    [anon_sym_LT_AT] = ACTIONS(61),
    [anon_sym_LT_AT_AT] = ACTIONS(63),
    [anon_sym_DOT] = ACTIONS(65),
    [anon_sym_LBRACE_PIPE] = ACTIONS(67),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_return_BANG] = ACTIONS(829),
    [anon_sym_yield] = ACTIONS(825),
    [anon_sym_yield_BANG] = ACTIONS(829),
    [anon_sym_lazy] = ACTIONS(825),
    [anon_sym_assert] = ACTIONS(825),
    [anon_sym_upcast] = ACTIONS(825),
    [anon_sym_downcast] = ACTIONS(825),
    [anon_sym_COLON_GT] = ACTIONS(71),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(71),
    [anon_sym_for] = ACTIONS(73),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(79),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_match] = ACTIONS(83),
    [anon_sym_match_BANG] = ACTIONS(85),
    [anon_sym_function] = ACTIONS(87),
    [anon_sym_LT_DASH] = ACTIONS(831),
    [anon_sym_DOT_LBRACK] = ACTIONS(91),
    [anon_sym_LT] = ACTIONS(93),
    [anon_sym_use] = ACTIONS(833),
    [anon_sym_use_BANG] = ACTIONS(835),
    [anon_sym_do_BANG] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(101),
    [anon_sym_LPAREN2] = ACTIONS(103),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(105),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(107),
    [anon_sym_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DQUOTE] = ACTIONS(111),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(115),
    [sym_bool] = ACTIONS(117),
    [sym_unit] = ACTIONS(119),
    [anon_sym_LPAREN_PIPE] = ACTIONS(121),
    [sym_op_identifier] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(837),
    [sym_xint] = ACTIONS(387),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(135),
    [sym__newline] = ACTIONS(839),
    [sym__dedent] = ACTIONS(1369),
  },
  [212] = {
    [sym_function_or_value_defn] = STATE(600),
    [sym__expression] = STATE(88),
    [sym_literal_expression] = STATE(867),
    [sym_long_identifier_or_op] = STATE(867),
    [sym_tuple_expression] = STATE(867),
    [sym_brace_expression] = STATE(867),
    [sym_anon_record_expression] = STATE(867),
    [sym_prefixed_expression] = STATE(867),
    [sym_typecast_expression] = STATE(867),
    [sym_for_expression] = STATE(867),
    [sym_while_expression] = STATE(867),
    [sym__if_branch] = STATE(6511),
    [sym_if_expression] = STATE(867),
    [sym_fun_expression] = STATE(867),
    [sym_try_expression] = STATE(867),
    [sym_match_expression] = STATE(867),
    [sym_function_expression] = STATE(867),
    [sym_mutate_expression] = STATE(867),
    [sym_index_expression] = STATE(867),
    [sym_typed_expression] = STATE(867),
    [sym_declaration_expression] = STATE(867),
    [sym_do_expression] = STATE(867),
    [sym_list_expression] = STATE(867),
    [sym_array_expression] = STATE(867),
    [sym_begin_end_expression] = STATE(867),
    [sym_paren_expression] = STATE(867),
    [sym__high_prec_app] = STATE(864),
    [sym__low_prec_app] = STATE(864),
    [sym_application_expression] = STATE(867),
    [sym_dot_expression] = STATE(867),
    [sym_infix_expression] = STATE(867),
    [sym_ce_expression] = STATE(867),
    [sym_sequential_expression] = STATE(867),
    [sym_char] = STATE(868),
    [sym_format_string] = STATE(869),
    [sym__string_literal] = STATE(869),
    [sym_string] = STATE(868),
    [sym_verbatim_string] = STATE(868),
    [sym_bytearray] = STATE(868),
    [sym_verbatim_bytearray] = STATE(868),
    [sym_format_triple_quoted_string] = STATE(870),
    [sym_triple_quoted_string] = STATE(868),
    [sym_const] = STATE(867),
    [sym_long_identifier] = STATE(872),
    [sym_active_pattern] = STATE(871),
    [sym__identifier_or_op] = STATE(873),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(656),
    [sym_infix_op] = STATE(581),
    [sym_sbyte] = STATE(868),
    [sym_byte] = STATE(868),
    [sym_int16] = STATE(868),
    [sym_uint16] = STATE(868),
    [sym_int32] = STATE(868),
    [sym_uint32] = STATE(868),
    [sym_nativeint] = STATE(868),
    [sym_unativeint] = STATE(868),
    [sym_int64] = STATE(868),
    [sym_uint64] = STATE(868),
    [sym_ieee32] = STATE(868),
    [sym_ieee64] = STATE(868),
    [sym_bignum] = STATE(868),
    [sym_decimal] = STATE(868),
    [sym_float] = STATE(1368),
    [sym_block_comment] = STATE(212),
    [sym_compiler_directive_decl] = STATE(212),
    [sym_fsi_directive_decl] = STATE(212),
    [sym_preproc_line] = STATE(212),
    [sym_preproc_if_in_expression] = STATE(867),
    [aux_sym_sequential_expression_repeat1] = STATE(1542),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(29),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(825),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_COMMA] = ACTIONS(827),
    [anon_sym_null] = ACTIONS(49),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACK_PIPE] = ACTIONS(57),
    [anon_sym_LBRACE] = ACTIONS(139),
    [anon_sym_LT_AT] = ACTIONS(61),
    [anon_sym_LT_AT_AT] = ACTIONS(63),
    [anon_sym_DOT] = ACTIONS(65),
    [anon_sym_LBRACE_PIPE] = ACTIONS(67),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_return_BANG] = ACTIONS(829),
    [anon_sym_yield] = ACTIONS(825),
    [anon_sym_yield_BANG] = ACTIONS(829),
    [anon_sym_lazy] = ACTIONS(825),
    [anon_sym_assert] = ACTIONS(825),
    [anon_sym_upcast] = ACTIONS(825),
    [anon_sym_downcast] = ACTIONS(825),
    [anon_sym_COLON_GT] = ACTIONS(71),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(71),
    [anon_sym_for] = ACTIONS(73),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(79),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_match] = ACTIONS(83),
    [anon_sym_match_BANG] = ACTIONS(85),
    [anon_sym_function] = ACTIONS(87),
    [anon_sym_LT_DASH] = ACTIONS(831),
    [anon_sym_DOT_LBRACK] = ACTIONS(91),
    [anon_sym_LT] = ACTIONS(93),
    [anon_sym_use] = ACTIONS(833),
    [anon_sym_use_BANG] = ACTIONS(835),
    [anon_sym_do_BANG] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(101),
    [anon_sym_LPAREN2] = ACTIONS(103),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(105),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(107),
    [anon_sym_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DQUOTE] = ACTIONS(111),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(115),
    [sym_bool] = ACTIONS(117),
    [sym_unit] = ACTIONS(119),
    [anon_sym_LPAREN_PIPE] = ACTIONS(121),
    [sym_op_identifier] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(837),
    [sym_xint] = ACTIONS(387),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(135),
    [sym__newline] = ACTIONS(839),
    [sym__dedent] = ACTIONS(1371),
  },
  [213] = {
    [sym_function_or_value_defn] = STATE(630),
    [sym__expression] = STATE(219),
    [sym_literal_expression] = STATE(2380),
    [sym_long_identifier_or_op] = STATE(2380),
    [sym_tuple_expression] = STATE(2380),
    [sym_brace_expression] = STATE(2380),
    [sym_anon_record_expression] = STATE(2380),
    [sym_prefixed_expression] = STATE(2380),
    [sym_typecast_expression] = STATE(2380),
    [sym_for_expression] = STATE(2380),
    [sym_while_expression] = STATE(2380),
    [sym__if_branch] = STATE(6456),
    [sym_if_expression] = STATE(2380),
    [sym_fun_expression] = STATE(2380),
    [sym_try_expression] = STATE(2380),
    [sym_match_expression] = STATE(2380),
    [sym_function_expression] = STATE(2380),
    [sym_mutate_expression] = STATE(2380),
    [sym_index_expression] = STATE(2380),
    [sym_typed_expression] = STATE(2380),
    [sym_declaration_expression] = STATE(2380),
    [sym_do_expression] = STATE(2380),
    [sym_list_expression] = STATE(2380),
    [sym_array_expression] = STATE(2380),
    [sym_begin_end_expression] = STATE(2380),
    [sym_paren_expression] = STATE(2380),
    [sym__high_prec_app] = STATE(2383),
    [sym__low_prec_app] = STATE(2383),
    [sym_application_expression] = STATE(2380),
    [sym_dot_expression] = STATE(2380),
    [sym_infix_expression] = STATE(2380),
    [sym_ce_expression] = STATE(2380),
    [sym_sequential_expression] = STATE(2380),
    [sym_char] = STATE(2261),
    [sym_format_string] = STATE(2274),
    [sym__string_literal] = STATE(2274),
    [sym_string] = STATE(2261),
    [sym_verbatim_string] = STATE(2261),
    [sym_bytearray] = STATE(2261),
    [sym_verbatim_bytearray] = STATE(2261),
    [sym_format_triple_quoted_string] = STATE(2275),
    [sym_triple_quoted_string] = STATE(2261),
    [sym_const] = STATE(2380),
    [sym_long_identifier] = STATE(2391),
    [sym_active_pattern] = STATE(2470),
    [sym__identifier_or_op] = STATE(2390),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(632),
    [sym_infix_op] = STATE(616),
    [sym_sbyte] = STATE(2261),
    [sym_byte] = STATE(2261),
    [sym_int16] = STATE(2261),
    [sym_uint16] = STATE(2261),
    [sym_int32] = STATE(2261),
    [sym_uint32] = STATE(2261),
    [sym_nativeint] = STATE(2261),
    [sym_unativeint] = STATE(2261),
    [sym_int64] = STATE(2261),
    [sym_uint64] = STATE(2261),
    [sym_ieee32] = STATE(2261),
    [sym_ieee64] = STATE(2261),
    [sym_bignum] = STATE(2261),
    [sym_decimal] = STATE(2261),
    [sym_float] = STATE(1614),
    [sym_block_comment] = STATE(213),
    [sym_compiler_directive_decl] = STATE(213),
    [sym_fsi_directive_decl] = STATE(213),
    [sym_preproc_line] = STATE(213),
    [sym_preproc_if_in_expression] = STATE(2380),
    [aux_sym_sequential_expression_repeat1] = STATE(1882),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(1081),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(1083),
    [anon_sym_return] = ACTIONS(1085),
    [anon_sym_do] = ACTIONS(1087),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(1089),
    [anon_sym_COMMA] = ACTIONS(1091),
    [anon_sym_null] = ACTIONS(1093),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(1083),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1095),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1097),
    [anon_sym_LBRACE] = ACTIONS(1099),
    [anon_sym_LT_AT] = ACTIONS(1101),
    [anon_sym_LT_AT_AT] = ACTIONS(1103),
    [anon_sym_AT_AT_GT] = ACTIONS(147),
    [anon_sym_DOT] = ACTIONS(1105),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1107),
    [anon_sym_new] = ACTIONS(1085),
    [anon_sym_return_BANG] = ACTIONS(1109),
    [anon_sym_yield] = ACTIONS(1085),
    [anon_sym_yield_BANG] = ACTIONS(1109),
    [anon_sym_lazy] = ACTIONS(1085),
    [anon_sym_assert] = ACTIONS(1085),
    [anon_sym_upcast] = ACTIONS(1085),
    [anon_sym_downcast] = ACTIONS(1085),
    [anon_sym_COLON_GT] = ACTIONS(1111),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1111),
    [anon_sym_for] = ACTIONS(1113),
    [anon_sym_while] = ACTIONS(1115),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(1117),
    [anon_sym_try] = ACTIONS(1119),
    [anon_sym_match] = ACTIONS(1121),
    [anon_sym_match_BANG] = ACTIONS(1123),
    [anon_sym_function] = ACTIONS(1125),
    [anon_sym_LT_DASH] = ACTIONS(1127),
    [anon_sym_DOT_LBRACK] = ACTIONS(1129),
    [anon_sym_LT] = ACTIONS(1131),
    [anon_sym_use] = ACTIONS(1133),
    [anon_sym_use_BANG] = ACTIONS(1135),
    [anon_sym_do_BANG] = ACTIONS(1137),
    [anon_sym_begin] = ACTIONS(1139),
    [anon_sym_LPAREN2] = ACTIONS(1141),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(1143),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1145),
    [anon_sym_DQUOTE] = ACTIONS(1147),
    [anon_sym_AT_DQUOTE] = ACTIONS(1149),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1151),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1153),
    [sym_bool] = ACTIONS(1155),
    [sym_unit] = ACTIONS(1157),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1159),
    [sym_op_identifier] = ACTIONS(1161),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(1163),
    [sym_xint] = ACTIONS(1165),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1167),
    [sym__newline] = ACTIONS(145),
  },
  [214] = {
    [sym_function_or_value_defn] = STATE(733),
    [sym__expression] = STATE(142),
    [sym_literal_expression] = STATE(2008),
    [sym_long_identifier_or_op] = STATE(2008),
    [sym_tuple_expression] = STATE(2008),
    [sym_brace_expression] = STATE(2008),
    [sym_anon_record_expression] = STATE(2008),
    [sym_prefixed_expression] = STATE(2008),
    [sym_typecast_expression] = STATE(2008),
    [sym_for_expression] = STATE(2008),
    [sym_while_expression] = STATE(2008),
    [sym__if_branch] = STATE(6754),
    [sym_if_expression] = STATE(2008),
    [sym_fun_expression] = STATE(2008),
    [sym_try_expression] = STATE(2008),
    [sym_match_expression] = STATE(2008),
    [sym_function_expression] = STATE(2008),
    [sym_mutate_expression] = STATE(2008),
    [sym_index_expression] = STATE(2008),
    [sym_typed_expression] = STATE(2008),
    [sym_declaration_expression] = STATE(2008),
    [sym_do_expression] = STATE(2008),
    [sym_list_expression] = STATE(2008),
    [sym_array_expression] = STATE(2008),
    [sym_begin_end_expression] = STATE(2008),
    [sym_paren_expression] = STATE(2008),
    [sym__high_prec_app] = STATE(2007),
    [sym__low_prec_app] = STATE(2007),
    [sym_application_expression] = STATE(2008),
    [sym_dot_expression] = STATE(2008),
    [sym_infix_expression] = STATE(2008),
    [sym_ce_expression] = STATE(2008),
    [sym_sequential_expression] = STATE(2008),
    [sym_char] = STATE(1859),
    [sym_format_string] = STATE(1861),
    [sym__string_literal] = STATE(1861),
    [sym_string] = STATE(1859),
    [sym_verbatim_string] = STATE(1859),
    [sym_bytearray] = STATE(1859),
    [sym_verbatim_bytearray] = STATE(1859),
    [sym_format_triple_quoted_string] = STATE(1862),
    [sym_triple_quoted_string] = STATE(1859),
    [sym_const] = STATE(2008),
    [sym_long_identifier] = STATE(1701),
    [sym_active_pattern] = STATE(1702),
    [sym__identifier_or_op] = STATE(1724),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(706),
    [sym_infix_op] = STATE(678),
    [sym_sbyte] = STATE(1859),
    [sym_byte] = STATE(1859),
    [sym_int16] = STATE(1859),
    [sym_uint16] = STATE(1859),
    [sym_int32] = STATE(1859),
    [sym_uint32] = STATE(1859),
    [sym_nativeint] = STATE(1859),
    [sym_unativeint] = STATE(1859),
    [sym_int64] = STATE(1859),
    [sym_uint64] = STATE(1859),
    [sym_ieee32] = STATE(1859),
    [sym_ieee64] = STATE(1859),
    [sym_bignum] = STATE(1859),
    [sym_decimal] = STATE(1859),
    [sym_float] = STATE(1447),
    [sym_block_comment] = STATE(214),
    [sym_compiler_directive_decl] = STATE(214),
    [sym_fsi_directive_decl] = STATE(214),
    [sym_preproc_line] = STATE(214),
    [sym_preproc_if_in_expression] = STATE(2008),
    [aux_sym_sequential_expression_repeat1] = STATE(1995),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(503),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(969),
    [anon_sym_return] = ACTIONS(971),
    [anon_sym_do] = ACTIONS(599),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(511),
    [anon_sym_COMMA] = ACTIONS(973),
    [anon_sym_null] = ACTIONS(515),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(969),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(517),
    [anon_sym_LBRACK_PIPE] = ACTIONS(519),
    [anon_sym_LBRACE] = ACTIONS(521),
    [anon_sym_LT_AT] = ACTIONS(523),
    [anon_sym_LT_AT_AT] = ACTIONS(525),
    [anon_sym_DOT] = ACTIONS(527),
    [anon_sym_LBRACE_PIPE] = ACTIONS(529),
    [anon_sym_new] = ACTIONS(971),
    [anon_sym_return_BANG] = ACTIONS(975),
    [anon_sym_yield] = ACTIONS(971),
    [anon_sym_yield_BANG] = ACTIONS(975),
    [anon_sym_lazy] = ACTIONS(971),
    [anon_sym_assert] = ACTIONS(971),
    [anon_sym_upcast] = ACTIONS(971),
    [anon_sym_downcast] = ACTIONS(971),
    [anon_sym_COLON_GT] = ACTIONS(977),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(977),
    [anon_sym_for] = ACTIONS(979),
    [anon_sym_while] = ACTIONS(537),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(539),
    [anon_sym_DASH_GT] = ACTIONS(173),
    [anon_sym_try] = ACTIONS(543),
    [anon_sym_match] = ACTIONS(545),
    [anon_sym_match_BANG] = ACTIONS(547),
    [anon_sym_function] = ACTIONS(549),
    [anon_sym_LT_DASH] = ACTIONS(981),
    [anon_sym_DOT_LBRACK] = ACTIONS(553),
    [anon_sym_LT] = ACTIONS(555),
    [anon_sym_use] = ACTIONS(983),
    [anon_sym_use_BANG] = ACTIONS(985),
    [anon_sym_do_BANG] = ACTIONS(561),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_LPAREN2] = ACTIONS(567),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(569),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(571),
    [anon_sym_DQUOTE] = ACTIONS(573),
    [anon_sym_AT_DQUOTE] = ACTIONS(575),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(577),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(579),
    [sym_bool] = ACTIONS(581),
    [sym_unit] = ACTIONS(583),
    [anon_sym_LPAREN_PIPE] = ACTIONS(585),
    [sym_op_identifier] = ACTIONS(587),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(591),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(593),
    [sym__newline] = ACTIONS(1171),
  },
  [215] = {
    [sym_function_or_value_defn] = STATE(600),
    [sym__expression] = STATE(88),
    [sym_literal_expression] = STATE(867),
    [sym_long_identifier_or_op] = STATE(867),
    [sym_tuple_expression] = STATE(867),
    [sym_brace_expression] = STATE(867),
    [sym_anon_record_expression] = STATE(867),
    [sym_prefixed_expression] = STATE(867),
    [sym_typecast_expression] = STATE(867),
    [sym_for_expression] = STATE(867),
    [sym_while_expression] = STATE(867),
    [sym__if_branch] = STATE(6511),
    [sym_if_expression] = STATE(867),
    [sym_fun_expression] = STATE(867),
    [sym_try_expression] = STATE(867),
    [sym_match_expression] = STATE(867),
    [sym_function_expression] = STATE(867),
    [sym_mutate_expression] = STATE(867),
    [sym_index_expression] = STATE(867),
    [sym_typed_expression] = STATE(867),
    [sym_declaration_expression] = STATE(867),
    [sym_do_expression] = STATE(867),
    [sym_list_expression] = STATE(867),
    [sym_array_expression] = STATE(867),
    [sym_begin_end_expression] = STATE(867),
    [sym_paren_expression] = STATE(867),
    [sym__high_prec_app] = STATE(864),
    [sym__low_prec_app] = STATE(864),
    [sym_application_expression] = STATE(867),
    [sym_dot_expression] = STATE(867),
    [sym_infix_expression] = STATE(867),
    [sym_ce_expression] = STATE(867),
    [sym_sequential_expression] = STATE(867),
    [sym_char] = STATE(868),
    [sym_format_string] = STATE(869),
    [sym__string_literal] = STATE(869),
    [sym_string] = STATE(868),
    [sym_verbatim_string] = STATE(868),
    [sym_bytearray] = STATE(868),
    [sym_verbatim_bytearray] = STATE(868),
    [sym_format_triple_quoted_string] = STATE(870),
    [sym_triple_quoted_string] = STATE(868),
    [sym_const] = STATE(867),
    [sym_long_identifier] = STATE(872),
    [sym_active_pattern] = STATE(871),
    [sym__identifier_or_op] = STATE(873),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(656),
    [sym_infix_op] = STATE(581),
    [sym_sbyte] = STATE(868),
    [sym_byte] = STATE(868),
    [sym_int16] = STATE(868),
    [sym_uint16] = STATE(868),
    [sym_int32] = STATE(868),
    [sym_uint32] = STATE(868),
    [sym_nativeint] = STATE(868),
    [sym_unativeint] = STATE(868),
    [sym_int64] = STATE(868),
    [sym_uint64] = STATE(868),
    [sym_ieee32] = STATE(868),
    [sym_ieee64] = STATE(868),
    [sym_bignum] = STATE(868),
    [sym_decimal] = STATE(868),
    [sym_float] = STATE(1368),
    [sym_block_comment] = STATE(215),
    [sym_compiler_directive_decl] = STATE(215),
    [sym_fsi_directive_decl] = STATE(215),
    [sym_preproc_line] = STATE(215),
    [sym_preproc_if_in_expression] = STATE(867),
    [aux_sym_sequential_expression_repeat1] = STATE(1542),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(29),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(825),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_COMMA] = ACTIONS(827),
    [anon_sym_null] = ACTIONS(49),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACK_PIPE] = ACTIONS(57),
    [anon_sym_LBRACE] = ACTIONS(139),
    [anon_sym_LT_AT] = ACTIONS(61),
    [anon_sym_LT_AT_AT] = ACTIONS(63),
    [anon_sym_DOT] = ACTIONS(65),
    [anon_sym_LBRACE_PIPE] = ACTIONS(67),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_return_BANG] = ACTIONS(829),
    [anon_sym_yield] = ACTIONS(825),
    [anon_sym_yield_BANG] = ACTIONS(829),
    [anon_sym_lazy] = ACTIONS(825),
    [anon_sym_assert] = ACTIONS(825),
    [anon_sym_upcast] = ACTIONS(825),
    [anon_sym_downcast] = ACTIONS(825),
    [anon_sym_COLON_GT] = ACTIONS(71),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(71),
    [anon_sym_for] = ACTIONS(73),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(79),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_match] = ACTIONS(83),
    [anon_sym_match_BANG] = ACTIONS(85),
    [anon_sym_function] = ACTIONS(87),
    [anon_sym_LT_DASH] = ACTIONS(831),
    [anon_sym_DOT_LBRACK] = ACTIONS(91),
    [anon_sym_LT] = ACTIONS(93),
    [anon_sym_use] = ACTIONS(833),
    [anon_sym_use_BANG] = ACTIONS(835),
    [anon_sym_do_BANG] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(101),
    [anon_sym_LPAREN2] = ACTIONS(103),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(105),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(107),
    [anon_sym_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DQUOTE] = ACTIONS(111),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(115),
    [sym_bool] = ACTIONS(117),
    [sym_unit] = ACTIONS(119),
    [anon_sym_LPAREN_PIPE] = ACTIONS(121),
    [sym_op_identifier] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(837),
    [sym_xint] = ACTIONS(387),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(135),
    [sym__newline] = ACTIONS(839),
    [sym__dedent] = ACTIONS(1373),
  },
  [216] = {
    [sym_function_or_value_defn] = STATE(630),
    [sym__expression] = STATE(219),
    [sym_literal_expression] = STATE(2380),
    [sym_long_identifier_or_op] = STATE(2380),
    [sym_tuple_expression] = STATE(2380),
    [sym_brace_expression] = STATE(2380),
    [sym_anon_record_expression] = STATE(2380),
    [sym_prefixed_expression] = STATE(2380),
    [sym_typecast_expression] = STATE(2380),
    [sym_for_expression] = STATE(2380),
    [sym_while_expression] = STATE(2380),
    [sym__if_branch] = STATE(6456),
    [sym_if_expression] = STATE(2380),
    [sym_fun_expression] = STATE(2380),
    [sym_try_expression] = STATE(2380),
    [sym_match_expression] = STATE(2380),
    [sym_function_expression] = STATE(2380),
    [sym_mutate_expression] = STATE(2380),
    [sym_index_expression] = STATE(2380),
    [sym_typed_expression] = STATE(2380),
    [sym_declaration_expression] = STATE(2380),
    [sym_do_expression] = STATE(2380),
    [sym_list_expression] = STATE(2380),
    [sym_array_expression] = STATE(2380),
    [sym_begin_end_expression] = STATE(2380),
    [sym_paren_expression] = STATE(2380),
    [sym__high_prec_app] = STATE(2383),
    [sym__low_prec_app] = STATE(2383),
    [sym_application_expression] = STATE(2380),
    [sym_dot_expression] = STATE(2380),
    [sym_infix_expression] = STATE(2380),
    [sym_ce_expression] = STATE(2380),
    [sym_sequential_expression] = STATE(2380),
    [sym_char] = STATE(2261),
    [sym_format_string] = STATE(2274),
    [sym__string_literal] = STATE(2274),
    [sym_string] = STATE(2261),
    [sym_verbatim_string] = STATE(2261),
    [sym_bytearray] = STATE(2261),
    [sym_verbatim_bytearray] = STATE(2261),
    [sym_format_triple_quoted_string] = STATE(2275),
    [sym_triple_quoted_string] = STATE(2261),
    [sym_const] = STATE(2380),
    [sym_long_identifier] = STATE(2391),
    [sym_active_pattern] = STATE(2470),
    [sym__identifier_or_op] = STATE(2390),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(632),
    [sym_infix_op] = STATE(616),
    [sym_sbyte] = STATE(2261),
    [sym_byte] = STATE(2261),
    [sym_int16] = STATE(2261),
    [sym_uint16] = STATE(2261),
    [sym_int32] = STATE(2261),
    [sym_uint32] = STATE(2261),
    [sym_nativeint] = STATE(2261),
    [sym_unativeint] = STATE(2261),
    [sym_int64] = STATE(2261),
    [sym_uint64] = STATE(2261),
    [sym_ieee32] = STATE(2261),
    [sym_ieee64] = STATE(2261),
    [sym_bignum] = STATE(2261),
    [sym_decimal] = STATE(2261),
    [sym_float] = STATE(1614),
    [sym_block_comment] = STATE(216),
    [sym_compiler_directive_decl] = STATE(216),
    [sym_fsi_directive_decl] = STATE(216),
    [sym_preproc_line] = STATE(216),
    [sym_preproc_if_in_expression] = STATE(2380),
    [aux_sym_sequential_expression_repeat1] = STATE(1882),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(1081),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(1083),
    [anon_sym_return] = ACTIONS(1085),
    [anon_sym_do] = ACTIONS(1087),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(1089),
    [anon_sym_COMMA] = ACTIONS(1091),
    [anon_sym_null] = ACTIONS(1093),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(1083),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1095),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1097),
    [anon_sym_LBRACE] = ACTIONS(1099),
    [anon_sym_LT_AT] = ACTIONS(1101),
    [anon_sym_LT_AT_AT] = ACTIONS(1103),
    [anon_sym_AT_AT_GT] = ACTIONS(151),
    [anon_sym_DOT] = ACTIONS(1105),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1107),
    [anon_sym_new] = ACTIONS(1085),
    [anon_sym_return_BANG] = ACTIONS(1109),
    [anon_sym_yield] = ACTIONS(1085),
    [anon_sym_yield_BANG] = ACTIONS(1109),
    [anon_sym_lazy] = ACTIONS(1085),
    [anon_sym_assert] = ACTIONS(1085),
    [anon_sym_upcast] = ACTIONS(1085),
    [anon_sym_downcast] = ACTIONS(1085),
    [anon_sym_COLON_GT] = ACTIONS(1111),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1111),
    [anon_sym_for] = ACTIONS(1113),
    [anon_sym_while] = ACTIONS(1115),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(1117),
    [anon_sym_try] = ACTIONS(1119),
    [anon_sym_match] = ACTIONS(1121),
    [anon_sym_match_BANG] = ACTIONS(1123),
    [anon_sym_function] = ACTIONS(1125),
    [anon_sym_LT_DASH] = ACTIONS(1127),
    [anon_sym_DOT_LBRACK] = ACTIONS(1129),
    [anon_sym_LT] = ACTIONS(1131),
    [anon_sym_use] = ACTIONS(1133),
    [anon_sym_use_BANG] = ACTIONS(1135),
    [anon_sym_do_BANG] = ACTIONS(1137),
    [anon_sym_begin] = ACTIONS(1139),
    [anon_sym_LPAREN2] = ACTIONS(1141),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(1143),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1145),
    [anon_sym_DQUOTE] = ACTIONS(1147),
    [anon_sym_AT_DQUOTE] = ACTIONS(1149),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1151),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1153),
    [sym_bool] = ACTIONS(1155),
    [sym_unit] = ACTIONS(1157),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1159),
    [sym_op_identifier] = ACTIONS(1161),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(1163),
    [sym_xint] = ACTIONS(1165),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1167),
    [sym__newline] = ACTIONS(1169),
  },
  [217] = {
    [sym_function_or_value_defn] = STATE(509),
    [sym__expression] = STATE(326),
    [sym_literal_expression] = STATE(2230),
    [sym_long_identifier_or_op] = STATE(2230),
    [sym_tuple_expression] = STATE(2230),
    [sym_brace_expression] = STATE(2230),
    [sym_anon_record_expression] = STATE(2230),
    [sym_prefixed_expression] = STATE(2230),
    [sym_typecast_expression] = STATE(2230),
    [sym_for_expression] = STATE(2230),
    [sym_while_expression] = STATE(2230),
    [sym__if_branch] = STATE(6659),
    [sym_if_expression] = STATE(2230),
    [sym_fun_expression] = STATE(2230),
    [sym_try_expression] = STATE(2230),
    [sym_match_expression] = STATE(2230),
    [sym_function_expression] = STATE(2230),
    [sym_mutate_expression] = STATE(2230),
    [sym_index_expression] = STATE(2230),
    [sym_typed_expression] = STATE(2230),
    [sym_declaration_expression] = STATE(2230),
    [sym_do_expression] = STATE(2230),
    [sym_list_expression] = STATE(2230),
    [sym_array_expression] = STATE(2230),
    [sym_begin_end_expression] = STATE(2230),
    [sym_paren_expression] = STATE(2230),
    [sym__high_prec_app] = STATE(2229),
    [sym__low_prec_app] = STATE(2229),
    [sym_application_expression] = STATE(2230),
    [sym_dot_expression] = STATE(2230),
    [sym_infix_expression] = STATE(2230),
    [sym_ce_expression] = STATE(2230),
    [sym_sequential_expression] = STATE(2230),
    [sym_char] = STATE(2100),
    [sym_format_string] = STATE(2106),
    [sym__string_literal] = STATE(2106),
    [sym_string] = STATE(2100),
    [sym_verbatim_string] = STATE(2100),
    [sym_bytearray] = STATE(2100),
    [sym_verbatim_bytearray] = STATE(2100),
    [sym_format_triple_quoted_string] = STATE(2107),
    [sym_triple_quoted_string] = STATE(2100),
    [sym_const] = STATE(2230),
    [sym_long_identifier] = STATE(2232),
    [sym_active_pattern] = STATE(2424),
    [sym__identifier_or_op] = STATE(2305),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(737),
    [sym_infix_op] = STATE(694),
    [sym_sbyte] = STATE(2100),
    [sym_byte] = STATE(2100),
    [sym_int16] = STATE(2100),
    [sym_uint16] = STATE(2100),
    [sym_int32] = STATE(2100),
    [sym_uint32] = STATE(2100),
    [sym_nativeint] = STATE(2100),
    [sym_unativeint] = STATE(2100),
    [sym_int64] = STATE(2100),
    [sym_uint64] = STATE(2100),
    [sym_ieee32] = STATE(2100),
    [sym_ieee64] = STATE(2100),
    [sym_bignum] = STATE(2100),
    [sym_decimal] = STATE(2100),
    [sym_float] = STATE(1487),
    [sym_block_comment] = STATE(217),
    [sym_compiler_directive_decl] = STATE(217),
    [sym_fsi_directive_decl] = STATE(217),
    [sym_preproc_line] = STATE(217),
    [sym_preproc_if_in_expression] = STATE(2230),
    [aux_sym_sequential_expression_repeat1] = STATE(1743),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(877),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(879),
    [anon_sym_return] = ACTIONS(881),
    [anon_sym_do] = ACTIONS(813),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(885),
    [anon_sym_COMMA] = ACTIONS(887),
    [anon_sym_null] = ACTIONS(889),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(879),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(891),
    [anon_sym_LBRACK_PIPE] = ACTIONS(893),
    [anon_sym_LBRACE] = ACTIONS(895),
    [anon_sym_LT_AT] = ACTIONS(897),
    [anon_sym_LT_AT_AT] = ACTIONS(899),
    [anon_sym_DOT] = ACTIONS(901),
    [anon_sym_LBRACE_PIPE] = ACTIONS(903),
    [anon_sym_new] = ACTIONS(881),
    [anon_sym_return_BANG] = ACTIONS(905),
    [anon_sym_yield] = ACTIONS(881),
    [anon_sym_yield_BANG] = ACTIONS(905),
    [anon_sym_lazy] = ACTIONS(881),
    [anon_sym_assert] = ACTIONS(881),
    [anon_sym_upcast] = ACTIONS(881),
    [anon_sym_downcast] = ACTIONS(881),
    [anon_sym_COLON_GT] = ACTIONS(907),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(907),
    [anon_sym_for] = ACTIONS(909),
    [anon_sym_while] = ACTIONS(911),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(913),
    [anon_sym_try] = ACTIONS(915),
    [anon_sym_match] = ACTIONS(917),
    [anon_sym_match_BANG] = ACTIONS(919),
    [anon_sym_function] = ACTIONS(921),
    [anon_sym_LT_DASH] = ACTIONS(923),
    [anon_sym_DOT_LBRACK] = ACTIONS(925),
    [anon_sym_LT] = ACTIONS(927),
    [anon_sym_use] = ACTIONS(929),
    [anon_sym_use_BANG] = ACTIONS(931),
    [anon_sym_do_BANG] = ACTIONS(933),
    [anon_sym_DOT_DOT] = ACTIONS(1375),
    [anon_sym_begin] = ACTIONS(937),
    [anon_sym_LPAREN2] = ACTIONS(939),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(941),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(943),
    [anon_sym_DQUOTE] = ACTIONS(945),
    [anon_sym_AT_DQUOTE] = ACTIONS(947),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(949),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(951),
    [sym_bool] = ACTIONS(953),
    [sym_unit] = ACTIONS(955),
    [anon_sym_LPAREN_PIPE] = ACTIONS(957),
    [sym_op_identifier] = ACTIONS(959),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(961),
    [sym_xint] = ACTIONS(963),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(965),
    [sym__newline] = ACTIONS(967),
  },
  [218] = {
    [sym_function_or_value_defn] = STATE(600),
    [sym__expression] = STATE(88),
    [sym_literal_expression] = STATE(867),
    [sym_long_identifier_or_op] = STATE(867),
    [sym_tuple_expression] = STATE(867),
    [sym_brace_expression] = STATE(867),
    [sym_anon_record_expression] = STATE(867),
    [sym_prefixed_expression] = STATE(867),
    [sym_typecast_expression] = STATE(867),
    [sym_for_expression] = STATE(867),
    [sym_while_expression] = STATE(867),
    [sym__if_branch] = STATE(6511),
    [sym_if_expression] = STATE(867),
    [sym_fun_expression] = STATE(867),
    [sym_try_expression] = STATE(867),
    [sym_match_expression] = STATE(867),
    [sym_function_expression] = STATE(867),
    [sym_mutate_expression] = STATE(867),
    [sym_index_expression] = STATE(867),
    [sym_typed_expression] = STATE(867),
    [sym_declaration_expression] = STATE(867),
    [sym_do_expression] = STATE(867),
    [sym_list_expression] = STATE(867),
    [sym_array_expression] = STATE(867),
    [sym_begin_end_expression] = STATE(867),
    [sym_paren_expression] = STATE(867),
    [sym__high_prec_app] = STATE(864),
    [sym__low_prec_app] = STATE(864),
    [sym_application_expression] = STATE(867),
    [sym_dot_expression] = STATE(867),
    [sym_infix_expression] = STATE(867),
    [sym_ce_expression] = STATE(867),
    [sym_sequential_expression] = STATE(867),
    [sym_char] = STATE(868),
    [sym_format_string] = STATE(869),
    [sym__string_literal] = STATE(869),
    [sym_string] = STATE(868),
    [sym_verbatim_string] = STATE(868),
    [sym_bytearray] = STATE(868),
    [sym_verbatim_bytearray] = STATE(868),
    [sym_format_triple_quoted_string] = STATE(870),
    [sym_triple_quoted_string] = STATE(868),
    [sym_const] = STATE(867),
    [sym_long_identifier] = STATE(872),
    [sym_active_pattern] = STATE(871),
    [sym__identifier_or_op] = STATE(873),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(656),
    [sym_infix_op] = STATE(581),
    [sym_sbyte] = STATE(868),
    [sym_byte] = STATE(868),
    [sym_int16] = STATE(868),
    [sym_uint16] = STATE(868),
    [sym_int32] = STATE(868),
    [sym_uint32] = STATE(868),
    [sym_nativeint] = STATE(868),
    [sym_unativeint] = STATE(868),
    [sym_int64] = STATE(868),
    [sym_uint64] = STATE(868),
    [sym_ieee32] = STATE(868),
    [sym_ieee64] = STATE(868),
    [sym_bignum] = STATE(868),
    [sym_decimal] = STATE(868),
    [sym_float] = STATE(1368),
    [sym_block_comment] = STATE(218),
    [sym_compiler_directive_decl] = STATE(218),
    [sym_fsi_directive_decl] = STATE(218),
    [sym_preproc_line] = STATE(218),
    [sym_preproc_if_in_expression] = STATE(867),
    [aux_sym_sequential_expression_repeat1] = STATE(1542),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(29),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(825),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_COMMA] = ACTIONS(827),
    [anon_sym_null] = ACTIONS(49),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACK_PIPE] = ACTIONS(57),
    [anon_sym_LBRACE] = ACTIONS(139),
    [anon_sym_LT_AT] = ACTIONS(61),
    [anon_sym_LT_AT_AT] = ACTIONS(63),
    [anon_sym_DOT] = ACTIONS(65),
    [anon_sym_LBRACE_PIPE] = ACTIONS(67),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_return_BANG] = ACTIONS(829),
    [anon_sym_yield] = ACTIONS(825),
    [anon_sym_yield_BANG] = ACTIONS(829),
    [anon_sym_lazy] = ACTIONS(825),
    [anon_sym_assert] = ACTIONS(825),
    [anon_sym_upcast] = ACTIONS(825),
    [anon_sym_downcast] = ACTIONS(825),
    [anon_sym_COLON_GT] = ACTIONS(71),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(71),
    [anon_sym_for] = ACTIONS(73),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(79),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_match] = ACTIONS(83),
    [anon_sym_match_BANG] = ACTIONS(85),
    [anon_sym_function] = ACTIONS(87),
    [anon_sym_LT_DASH] = ACTIONS(831),
    [anon_sym_DOT_LBRACK] = ACTIONS(91),
    [anon_sym_LT] = ACTIONS(93),
    [anon_sym_use] = ACTIONS(833),
    [anon_sym_use_BANG] = ACTIONS(835),
    [anon_sym_do_BANG] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(101),
    [anon_sym_LPAREN2] = ACTIONS(103),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(105),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(107),
    [anon_sym_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DQUOTE] = ACTIONS(111),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(115),
    [sym_bool] = ACTIONS(117),
    [sym_unit] = ACTIONS(119),
    [anon_sym_LPAREN_PIPE] = ACTIONS(121),
    [sym_op_identifier] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(837),
    [sym_xint] = ACTIONS(387),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(135),
    [sym__newline] = ACTIONS(839),
    [sym__dedent] = ACTIONS(1377),
  },
  [219] = {
    [sym_function_or_value_defn] = STATE(630),
    [sym__expression] = STATE(219),
    [sym_literal_expression] = STATE(2380),
    [sym_long_identifier_or_op] = STATE(2380),
    [sym_tuple_expression] = STATE(2380),
    [sym_brace_expression] = STATE(2380),
    [sym_anon_record_expression] = STATE(2380),
    [sym_prefixed_expression] = STATE(2380),
    [sym_typecast_expression] = STATE(2380),
    [sym_for_expression] = STATE(2380),
    [sym_while_expression] = STATE(2380),
    [sym__if_branch] = STATE(6456),
    [sym_if_expression] = STATE(2380),
    [sym_fun_expression] = STATE(2380),
    [sym_try_expression] = STATE(2380),
    [sym_match_expression] = STATE(2380),
    [sym_function_expression] = STATE(2380),
    [sym_mutate_expression] = STATE(2380),
    [sym_index_expression] = STATE(2380),
    [sym_typed_expression] = STATE(2380),
    [sym_declaration_expression] = STATE(2380),
    [sym_do_expression] = STATE(2380),
    [sym_list_expression] = STATE(2380),
    [sym_array_expression] = STATE(2380),
    [sym_begin_end_expression] = STATE(2380),
    [sym_paren_expression] = STATE(2380),
    [sym__high_prec_app] = STATE(2383),
    [sym__low_prec_app] = STATE(2383),
    [sym_application_expression] = STATE(2380),
    [sym_dot_expression] = STATE(2380),
    [sym_infix_expression] = STATE(2380),
    [sym_ce_expression] = STATE(2380),
    [sym_sequential_expression] = STATE(2380),
    [sym_char] = STATE(2261),
    [sym_format_string] = STATE(2274),
    [sym__string_literal] = STATE(2274),
    [sym_string] = STATE(2261),
    [sym_verbatim_string] = STATE(2261),
    [sym_bytearray] = STATE(2261),
    [sym_verbatim_bytearray] = STATE(2261),
    [sym_format_triple_quoted_string] = STATE(2275),
    [sym_triple_quoted_string] = STATE(2261),
    [sym_const] = STATE(2380),
    [sym_long_identifier] = STATE(2391),
    [sym_active_pattern] = STATE(2470),
    [sym__identifier_or_op] = STATE(2390),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(632),
    [sym_infix_op] = STATE(616),
    [sym_sbyte] = STATE(2261),
    [sym_byte] = STATE(2261),
    [sym_int16] = STATE(2261),
    [sym_uint16] = STATE(2261),
    [sym_int32] = STATE(2261),
    [sym_uint32] = STATE(2261),
    [sym_nativeint] = STATE(2261),
    [sym_unativeint] = STATE(2261),
    [sym_int64] = STATE(2261),
    [sym_uint64] = STATE(2261),
    [sym_ieee32] = STATE(2261),
    [sym_ieee64] = STATE(2261),
    [sym_bignum] = STATE(2261),
    [sym_decimal] = STATE(2261),
    [sym_float] = STATE(1614),
    [sym_block_comment] = STATE(219),
    [sym_compiler_directive_decl] = STATE(219),
    [sym_fsi_directive_decl] = STATE(219),
    [sym_preproc_line] = STATE(219),
    [sym_preproc_if_in_expression] = STATE(2380),
    [aux_sym_sequential_expression_repeat1] = STATE(1882),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_EQ] = ACTIONS(157),
    [anon_sym_COLON] = ACTIONS(155),
    [anon_sym_return] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(155),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_let_BANG] = ACTIONS(157),
    [anon_sym_LPAREN] = ACTIONS(155),
    [anon_sym_COMMA] = ACTIONS(157),
    [anon_sym_null] = ACTIONS(155),
    [anon_sym_QMARK] = ACTIONS(155),
    [anon_sym_COLON_QMARK] = ACTIONS(155),
    [anon_sym_COLON_COLON] = ACTIONS(157),
    [anon_sym_AMP] = ACTIONS(155),
    [anon_sym_LBRACK] = ACTIONS(155),
    [anon_sym_LBRACK_PIPE] = ACTIONS(157),
    [anon_sym_LBRACE] = ACTIONS(155),
    [anon_sym_LT_AT] = ACTIONS(155),
    [anon_sym_LT_AT_AT] = ACTIONS(155),
    [anon_sym_AT_AT_GT] = ACTIONS(155),
    [anon_sym_DOT] = ACTIONS(1105),
    [anon_sym_LBRACE_PIPE] = ACTIONS(157),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_return_BANG] = ACTIONS(157),
    [anon_sym_yield] = ACTIONS(155),
    [anon_sym_yield_BANG] = ACTIONS(157),
    [anon_sym_lazy] = ACTIONS(155),
    [anon_sym_assert] = ACTIONS(155),
    [anon_sym_upcast] = ACTIONS(155),
    [anon_sym_downcast] = ACTIONS(155),
    [anon_sym_COLON_GT] = ACTIONS(157),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(157),
    [anon_sym_for] = ACTIONS(155),
    [anon_sym_while] = ACTIONS(155),
    [anon_sym_if] = ACTIONS(155),
    [anon_sym_fun] = ACTIONS(155),
    [anon_sym_try] = ACTIONS(155),
    [anon_sym_match] = ACTIONS(155),
    [anon_sym_match_BANG] = ACTIONS(157),
    [anon_sym_function] = ACTIONS(155),
    [anon_sym_LT_DASH] = ACTIONS(155),
    [anon_sym_DOT_LBRACK] = ACTIONS(1129),
    [anon_sym_LT] = ACTIONS(1131),
    [anon_sym_use] = ACTIONS(155),
    [anon_sym_use_BANG] = ACTIONS(157),
    [anon_sym_do_BANG] = ACTIONS(157),
    [anon_sym_begin] = ACTIONS(155),
    [anon_sym_LPAREN2] = ACTIONS(1141),
    [anon_sym_or] = ACTIONS(155),
    [aux_sym_char_token1] = ACTIONS(157),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(155),
    [anon_sym_DQUOTE] = ACTIONS(155),
    [anon_sym_AT_DQUOTE] = ACTIONS(157),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(157),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(157),
    [sym_bool] = ACTIONS(155),
    [sym_unit] = ACTIONS(1157),
    [anon_sym_LPAREN_PIPE] = ACTIONS(155),
    [sym_op_identifier] = ACTIONS(155),
    [anon_sym_PLUS] = ACTIONS(155),
    [anon_sym_DASH] = ACTIONS(155),
    [anon_sym_PLUS_DOT] = ACTIONS(155),
    [anon_sym_DASH_DOT] = ACTIONS(155),
    [anon_sym_PERCENT] = ACTIONS(155),
    [anon_sym_AMP_AMP] = ACTIONS(155),
    [anon_sym_TILDE] = ACTIONS(157),
    [aux_sym_prefix_op_token1] = ACTIONS(155),
    [aux_sym_infix_op_token1] = ACTIONS(157),
    [aux_sym_infix_op_token2] = ACTIONS(155),
    [anon_sym_PIPE_PIPE] = ACTIONS(155),
    [anon_sym_BANG_EQ] = ACTIONS(155),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_DOLLAR] = ACTIONS(155),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(155),
    [sym_int] = ACTIONS(155),
    [sym_xint] = ACTIONS(157),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(157),
    [sym__newline] = ACTIONS(157),
  },
  [220] = {
    [sym_function_or_value_defn] = STATE(600),
    [sym__expression] = STATE(88),
    [sym_literal_expression] = STATE(867),
    [sym_long_identifier_or_op] = STATE(867),
    [sym_tuple_expression] = STATE(867),
    [sym_brace_expression] = STATE(867),
    [sym_anon_record_expression] = STATE(867),
    [sym_prefixed_expression] = STATE(867),
    [sym_typecast_expression] = STATE(867),
    [sym_for_expression] = STATE(867),
    [sym_while_expression] = STATE(867),
    [sym__if_branch] = STATE(6511),
    [sym_if_expression] = STATE(867),
    [sym_fun_expression] = STATE(867),
    [sym_try_expression] = STATE(867),
    [sym_match_expression] = STATE(867),
    [sym_function_expression] = STATE(867),
    [sym_mutate_expression] = STATE(867),
    [sym_index_expression] = STATE(867),
    [sym_typed_expression] = STATE(867),
    [sym_declaration_expression] = STATE(867),
    [sym_do_expression] = STATE(867),
    [sym_list_expression] = STATE(867),
    [sym_array_expression] = STATE(867),
    [sym_begin_end_expression] = STATE(867),
    [sym_paren_expression] = STATE(867),
    [sym__high_prec_app] = STATE(864),
    [sym__low_prec_app] = STATE(864),
    [sym_application_expression] = STATE(867),
    [sym_dot_expression] = STATE(867),
    [sym_infix_expression] = STATE(867),
    [sym_ce_expression] = STATE(867),
    [sym_sequential_expression] = STATE(867),
    [sym_char] = STATE(868),
    [sym_format_string] = STATE(869),
    [sym__string_literal] = STATE(869),
    [sym_string] = STATE(868),
    [sym_verbatim_string] = STATE(868),
    [sym_bytearray] = STATE(868),
    [sym_verbatim_bytearray] = STATE(868),
    [sym_format_triple_quoted_string] = STATE(870),
    [sym_triple_quoted_string] = STATE(868),
    [sym_const] = STATE(867),
    [sym_long_identifier] = STATE(872),
    [sym_active_pattern] = STATE(871),
    [sym__identifier_or_op] = STATE(873),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(656),
    [sym_infix_op] = STATE(581),
    [sym_sbyte] = STATE(868),
    [sym_byte] = STATE(868),
    [sym_int16] = STATE(868),
    [sym_uint16] = STATE(868),
    [sym_int32] = STATE(868),
    [sym_uint32] = STATE(868),
    [sym_nativeint] = STATE(868),
    [sym_unativeint] = STATE(868),
    [sym_int64] = STATE(868),
    [sym_uint64] = STATE(868),
    [sym_ieee32] = STATE(868),
    [sym_ieee64] = STATE(868),
    [sym_bignum] = STATE(868),
    [sym_decimal] = STATE(868),
    [sym_float] = STATE(1368),
    [sym_block_comment] = STATE(220),
    [sym_compiler_directive_decl] = STATE(220),
    [sym_fsi_directive_decl] = STATE(220),
    [sym_preproc_line] = STATE(220),
    [sym_preproc_if_in_expression] = STATE(867),
    [aux_sym_sequential_expression_repeat1] = STATE(1542),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(29),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(825),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_COMMA] = ACTIONS(827),
    [anon_sym_null] = ACTIONS(49),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACK_PIPE] = ACTIONS(57),
    [anon_sym_LBRACE] = ACTIONS(139),
    [anon_sym_LT_AT] = ACTIONS(61),
    [anon_sym_LT_AT_AT] = ACTIONS(63),
    [anon_sym_DOT] = ACTIONS(65),
    [anon_sym_LBRACE_PIPE] = ACTIONS(67),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_return_BANG] = ACTIONS(829),
    [anon_sym_yield] = ACTIONS(825),
    [anon_sym_yield_BANG] = ACTIONS(829),
    [anon_sym_lazy] = ACTIONS(825),
    [anon_sym_assert] = ACTIONS(825),
    [anon_sym_upcast] = ACTIONS(825),
    [anon_sym_downcast] = ACTIONS(825),
    [anon_sym_COLON_GT] = ACTIONS(71),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(71),
    [anon_sym_for] = ACTIONS(73),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(79),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_match] = ACTIONS(83),
    [anon_sym_match_BANG] = ACTIONS(85),
    [anon_sym_function] = ACTIONS(87),
    [anon_sym_LT_DASH] = ACTIONS(831),
    [anon_sym_DOT_LBRACK] = ACTIONS(91),
    [anon_sym_LT] = ACTIONS(93),
    [anon_sym_use] = ACTIONS(833),
    [anon_sym_use_BANG] = ACTIONS(835),
    [anon_sym_do_BANG] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(101),
    [anon_sym_LPAREN2] = ACTIONS(103),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(105),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(107),
    [anon_sym_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DQUOTE] = ACTIONS(111),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(115),
    [sym_bool] = ACTIONS(117),
    [sym_unit] = ACTIONS(119),
    [anon_sym_LPAREN_PIPE] = ACTIONS(121),
    [sym_op_identifier] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(837),
    [sym_xint] = ACTIONS(387),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(135),
    [sym__newline] = ACTIONS(839),
    [sym__dedent] = ACTIONS(1379),
  },
  [221] = {
    [sym_function_or_value_defn] = STATE(600),
    [sym__expression] = STATE(88),
    [sym_literal_expression] = STATE(867),
    [sym_long_identifier_or_op] = STATE(867),
    [sym_tuple_expression] = STATE(867),
    [sym_brace_expression] = STATE(867),
    [sym_anon_record_expression] = STATE(867),
    [sym_prefixed_expression] = STATE(867),
    [sym_typecast_expression] = STATE(867),
    [sym_for_expression] = STATE(867),
    [sym_while_expression] = STATE(867),
    [sym__if_branch] = STATE(6511),
    [sym_if_expression] = STATE(867),
    [sym_fun_expression] = STATE(867),
    [sym_try_expression] = STATE(867),
    [sym_match_expression] = STATE(867),
    [sym_function_expression] = STATE(867),
    [sym_mutate_expression] = STATE(867),
    [sym_index_expression] = STATE(867),
    [sym_typed_expression] = STATE(867),
    [sym_declaration_expression] = STATE(867),
    [sym_do_expression] = STATE(867),
    [sym_list_expression] = STATE(867),
    [sym_array_expression] = STATE(867),
    [sym_begin_end_expression] = STATE(867),
    [sym_paren_expression] = STATE(867),
    [sym__high_prec_app] = STATE(864),
    [sym__low_prec_app] = STATE(864),
    [sym_application_expression] = STATE(867),
    [sym_dot_expression] = STATE(867),
    [sym_infix_expression] = STATE(867),
    [sym_ce_expression] = STATE(867),
    [sym_sequential_expression] = STATE(867),
    [sym_char] = STATE(868),
    [sym_format_string] = STATE(869),
    [sym__string_literal] = STATE(869),
    [sym_string] = STATE(868),
    [sym_verbatim_string] = STATE(868),
    [sym_bytearray] = STATE(868),
    [sym_verbatim_bytearray] = STATE(868),
    [sym_format_triple_quoted_string] = STATE(870),
    [sym_triple_quoted_string] = STATE(868),
    [sym_const] = STATE(867),
    [sym_long_identifier] = STATE(872),
    [sym_active_pattern] = STATE(871),
    [sym__identifier_or_op] = STATE(873),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(656),
    [sym_infix_op] = STATE(581),
    [sym_sbyte] = STATE(868),
    [sym_byte] = STATE(868),
    [sym_int16] = STATE(868),
    [sym_uint16] = STATE(868),
    [sym_int32] = STATE(868),
    [sym_uint32] = STATE(868),
    [sym_nativeint] = STATE(868),
    [sym_unativeint] = STATE(868),
    [sym_int64] = STATE(868),
    [sym_uint64] = STATE(868),
    [sym_ieee32] = STATE(868),
    [sym_ieee64] = STATE(868),
    [sym_bignum] = STATE(868),
    [sym_decimal] = STATE(868),
    [sym_float] = STATE(1368),
    [sym_block_comment] = STATE(221),
    [sym_compiler_directive_decl] = STATE(221),
    [sym_fsi_directive_decl] = STATE(221),
    [sym_preproc_line] = STATE(221),
    [sym_preproc_if_in_expression] = STATE(867),
    [aux_sym_sequential_expression_repeat1] = STATE(1542),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(29),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(825),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_COMMA] = ACTIONS(827),
    [anon_sym_null] = ACTIONS(49),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACK_PIPE] = ACTIONS(57),
    [anon_sym_LBRACE] = ACTIONS(139),
    [anon_sym_LT_AT] = ACTIONS(61),
    [anon_sym_LT_AT_AT] = ACTIONS(63),
    [anon_sym_DOT] = ACTIONS(65),
    [anon_sym_LBRACE_PIPE] = ACTIONS(67),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_return_BANG] = ACTIONS(829),
    [anon_sym_yield] = ACTIONS(825),
    [anon_sym_yield_BANG] = ACTIONS(829),
    [anon_sym_lazy] = ACTIONS(825),
    [anon_sym_assert] = ACTIONS(825),
    [anon_sym_upcast] = ACTIONS(825),
    [anon_sym_downcast] = ACTIONS(825),
    [anon_sym_COLON_GT] = ACTIONS(71),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(71),
    [anon_sym_for] = ACTIONS(73),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(79),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_match] = ACTIONS(83),
    [anon_sym_match_BANG] = ACTIONS(85),
    [anon_sym_function] = ACTIONS(87),
    [anon_sym_LT_DASH] = ACTIONS(831),
    [anon_sym_DOT_LBRACK] = ACTIONS(91),
    [anon_sym_LT] = ACTIONS(93),
    [anon_sym_use] = ACTIONS(833),
    [anon_sym_use_BANG] = ACTIONS(835),
    [anon_sym_do_BANG] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(101),
    [anon_sym_LPAREN2] = ACTIONS(103),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(105),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(107),
    [anon_sym_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DQUOTE] = ACTIONS(111),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(115),
    [sym_bool] = ACTIONS(117),
    [sym_unit] = ACTIONS(119),
    [anon_sym_LPAREN_PIPE] = ACTIONS(121),
    [sym_op_identifier] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(837),
    [sym_xint] = ACTIONS(387),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(135),
    [sym__newline] = ACTIONS(839),
    [sym__dedent] = ACTIONS(1381),
  },
  [222] = {
    [sym_function_or_value_defn] = STATE(600),
    [sym__expression] = STATE(88),
    [sym_literal_expression] = STATE(867),
    [sym_long_identifier_or_op] = STATE(867),
    [sym_tuple_expression] = STATE(867),
    [sym_brace_expression] = STATE(867),
    [sym_anon_record_expression] = STATE(867),
    [sym_prefixed_expression] = STATE(867),
    [sym_typecast_expression] = STATE(867),
    [sym_for_expression] = STATE(867),
    [sym_while_expression] = STATE(867),
    [sym__if_branch] = STATE(6511),
    [sym_if_expression] = STATE(867),
    [sym_fun_expression] = STATE(867),
    [sym_try_expression] = STATE(867),
    [sym_match_expression] = STATE(867),
    [sym_function_expression] = STATE(867),
    [sym_mutate_expression] = STATE(867),
    [sym_index_expression] = STATE(867),
    [sym_typed_expression] = STATE(867),
    [sym_declaration_expression] = STATE(867),
    [sym_do_expression] = STATE(867),
    [sym_list_expression] = STATE(867),
    [sym_array_expression] = STATE(867),
    [sym_begin_end_expression] = STATE(867),
    [sym_paren_expression] = STATE(867),
    [sym__high_prec_app] = STATE(864),
    [sym__low_prec_app] = STATE(864),
    [sym_application_expression] = STATE(867),
    [sym_dot_expression] = STATE(867),
    [sym_infix_expression] = STATE(867),
    [sym_ce_expression] = STATE(867),
    [sym_sequential_expression] = STATE(867),
    [sym_char] = STATE(868),
    [sym_format_string] = STATE(869),
    [sym__string_literal] = STATE(869),
    [sym_string] = STATE(868),
    [sym_verbatim_string] = STATE(868),
    [sym_bytearray] = STATE(868),
    [sym_verbatim_bytearray] = STATE(868),
    [sym_format_triple_quoted_string] = STATE(870),
    [sym_triple_quoted_string] = STATE(868),
    [sym_const] = STATE(867),
    [sym_long_identifier] = STATE(872),
    [sym_active_pattern] = STATE(871),
    [sym__identifier_or_op] = STATE(873),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(656),
    [sym_infix_op] = STATE(581),
    [sym_sbyte] = STATE(868),
    [sym_byte] = STATE(868),
    [sym_int16] = STATE(868),
    [sym_uint16] = STATE(868),
    [sym_int32] = STATE(868),
    [sym_uint32] = STATE(868),
    [sym_nativeint] = STATE(868),
    [sym_unativeint] = STATE(868),
    [sym_int64] = STATE(868),
    [sym_uint64] = STATE(868),
    [sym_ieee32] = STATE(868),
    [sym_ieee64] = STATE(868),
    [sym_bignum] = STATE(868),
    [sym_decimal] = STATE(868),
    [sym_float] = STATE(1368),
    [sym_block_comment] = STATE(222),
    [sym_compiler_directive_decl] = STATE(222),
    [sym_fsi_directive_decl] = STATE(222),
    [sym_preproc_line] = STATE(222),
    [sym_preproc_if_in_expression] = STATE(867),
    [aux_sym_sequential_expression_repeat1] = STATE(1542),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(29),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(825),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_COMMA] = ACTIONS(827),
    [anon_sym_null] = ACTIONS(49),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACK_PIPE] = ACTIONS(57),
    [anon_sym_LBRACE] = ACTIONS(139),
    [anon_sym_LT_AT] = ACTIONS(61),
    [anon_sym_LT_AT_AT] = ACTIONS(63),
    [anon_sym_DOT] = ACTIONS(65),
    [anon_sym_LBRACE_PIPE] = ACTIONS(67),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_return_BANG] = ACTIONS(829),
    [anon_sym_yield] = ACTIONS(825),
    [anon_sym_yield_BANG] = ACTIONS(829),
    [anon_sym_lazy] = ACTIONS(825),
    [anon_sym_assert] = ACTIONS(825),
    [anon_sym_upcast] = ACTIONS(825),
    [anon_sym_downcast] = ACTIONS(825),
    [anon_sym_COLON_GT] = ACTIONS(71),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(71),
    [anon_sym_for] = ACTIONS(73),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(79),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_match] = ACTIONS(83),
    [anon_sym_match_BANG] = ACTIONS(85),
    [anon_sym_function] = ACTIONS(87),
    [anon_sym_LT_DASH] = ACTIONS(831),
    [anon_sym_DOT_LBRACK] = ACTIONS(91),
    [anon_sym_LT] = ACTIONS(93),
    [anon_sym_use] = ACTIONS(833),
    [anon_sym_use_BANG] = ACTIONS(835),
    [anon_sym_do_BANG] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(101),
    [anon_sym_LPAREN2] = ACTIONS(103),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(105),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(107),
    [anon_sym_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DQUOTE] = ACTIONS(111),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(115),
    [sym_bool] = ACTIONS(117),
    [sym_unit] = ACTIONS(119),
    [anon_sym_LPAREN_PIPE] = ACTIONS(121),
    [sym_op_identifier] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(837),
    [sym_xint] = ACTIONS(387),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(135),
    [sym__newline] = ACTIONS(843),
    [sym__dedent] = ACTIONS(843),
  },
  [223] = {
    [sym_function_or_value_defn] = STATE(630),
    [sym__expression] = STATE(219),
    [sym_literal_expression] = STATE(2380),
    [sym_long_identifier_or_op] = STATE(2380),
    [sym_tuple_expression] = STATE(2380),
    [sym_brace_expression] = STATE(2380),
    [sym_anon_record_expression] = STATE(2380),
    [sym_prefixed_expression] = STATE(2380),
    [sym_typecast_expression] = STATE(2380),
    [sym_for_expression] = STATE(2380),
    [sym_while_expression] = STATE(2380),
    [sym__if_branch] = STATE(6456),
    [sym_if_expression] = STATE(2380),
    [sym_fun_expression] = STATE(2380),
    [sym_try_expression] = STATE(2380),
    [sym_match_expression] = STATE(2380),
    [sym_function_expression] = STATE(2380),
    [sym_mutate_expression] = STATE(2380),
    [sym_index_expression] = STATE(2380),
    [sym_typed_expression] = STATE(2380),
    [sym_declaration_expression] = STATE(2380),
    [sym_do_expression] = STATE(2380),
    [sym_list_expression] = STATE(2380),
    [sym_array_expression] = STATE(2380),
    [sym_begin_end_expression] = STATE(2380),
    [sym_paren_expression] = STATE(2380),
    [sym__high_prec_app] = STATE(2383),
    [sym__low_prec_app] = STATE(2383),
    [sym_application_expression] = STATE(2380),
    [sym_dot_expression] = STATE(2380),
    [sym_infix_expression] = STATE(2380),
    [sym_ce_expression] = STATE(2380),
    [sym_sequential_expression] = STATE(2380),
    [sym_char] = STATE(2261),
    [sym_format_string] = STATE(2274),
    [sym__string_literal] = STATE(2274),
    [sym_string] = STATE(2261),
    [sym_verbatim_string] = STATE(2261),
    [sym_bytearray] = STATE(2261),
    [sym_verbatim_bytearray] = STATE(2261),
    [sym_format_triple_quoted_string] = STATE(2275),
    [sym_triple_quoted_string] = STATE(2261),
    [sym_const] = STATE(2380),
    [sym_long_identifier] = STATE(2391),
    [sym_active_pattern] = STATE(2470),
    [sym__identifier_or_op] = STATE(2390),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(632),
    [sym_infix_op] = STATE(616),
    [sym_sbyte] = STATE(2261),
    [sym_byte] = STATE(2261),
    [sym_int16] = STATE(2261),
    [sym_uint16] = STATE(2261),
    [sym_int32] = STATE(2261),
    [sym_uint32] = STATE(2261),
    [sym_nativeint] = STATE(2261),
    [sym_unativeint] = STATE(2261),
    [sym_int64] = STATE(2261),
    [sym_uint64] = STATE(2261),
    [sym_ieee32] = STATE(2261),
    [sym_ieee64] = STATE(2261),
    [sym_bignum] = STATE(2261),
    [sym_decimal] = STATE(2261),
    [sym_float] = STATE(1614),
    [sym_block_comment] = STATE(223),
    [sym_compiler_directive_decl] = STATE(223),
    [sym_fsi_directive_decl] = STATE(223),
    [sym_preproc_line] = STATE(223),
    [sym_preproc_if_in_expression] = STATE(2380),
    [aux_sym_sequential_expression_repeat1] = STATE(1882),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(1081),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(1083),
    [anon_sym_return] = ACTIONS(1085),
    [anon_sym_do] = ACTIONS(1087),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(1089),
    [anon_sym_COMMA] = ACTIONS(1091),
    [anon_sym_null] = ACTIONS(1093),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(1083),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1095),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1097),
    [anon_sym_LBRACE] = ACTIONS(1099),
    [anon_sym_LT_AT] = ACTIONS(1101),
    [anon_sym_LT_AT_AT] = ACTIONS(1103),
    [anon_sym_AT_AT_GT] = ACTIONS(161),
    [anon_sym_DOT] = ACTIONS(1105),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1107),
    [anon_sym_new] = ACTIONS(1085),
    [anon_sym_return_BANG] = ACTIONS(1109),
    [anon_sym_yield] = ACTIONS(1085),
    [anon_sym_yield_BANG] = ACTIONS(1109),
    [anon_sym_lazy] = ACTIONS(1085),
    [anon_sym_assert] = ACTIONS(1085),
    [anon_sym_upcast] = ACTIONS(1085),
    [anon_sym_downcast] = ACTIONS(1085),
    [anon_sym_COLON_GT] = ACTIONS(1111),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1111),
    [anon_sym_for] = ACTIONS(1113),
    [anon_sym_while] = ACTIONS(1115),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(1117),
    [anon_sym_try] = ACTIONS(1119),
    [anon_sym_match] = ACTIONS(1121),
    [anon_sym_match_BANG] = ACTIONS(1123),
    [anon_sym_function] = ACTIONS(1125),
    [anon_sym_LT_DASH] = ACTIONS(1127),
    [anon_sym_DOT_LBRACK] = ACTIONS(1129),
    [anon_sym_LT] = ACTIONS(1131),
    [anon_sym_use] = ACTIONS(1133),
    [anon_sym_use_BANG] = ACTIONS(1135),
    [anon_sym_do_BANG] = ACTIONS(1137),
    [anon_sym_begin] = ACTIONS(1139),
    [anon_sym_LPAREN2] = ACTIONS(1141),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(1143),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1145),
    [anon_sym_DQUOTE] = ACTIONS(1147),
    [anon_sym_AT_DQUOTE] = ACTIONS(1149),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1151),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1153),
    [sym_bool] = ACTIONS(1155),
    [sym_unit] = ACTIONS(1157),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1159),
    [sym_op_identifier] = ACTIONS(1161),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(1163),
    [sym_xint] = ACTIONS(1165),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1167),
    [sym__newline] = ACTIONS(1169),
  },
  [224] = {
    [sym_function_or_value_defn] = STATE(600),
    [sym__expression] = STATE(88),
    [sym_literal_expression] = STATE(867),
    [sym_long_identifier_or_op] = STATE(867),
    [sym_tuple_expression] = STATE(867),
    [sym_brace_expression] = STATE(867),
    [sym_anon_record_expression] = STATE(867),
    [sym_prefixed_expression] = STATE(867),
    [sym_typecast_expression] = STATE(867),
    [sym_for_expression] = STATE(867),
    [sym_while_expression] = STATE(867),
    [sym__if_branch] = STATE(6511),
    [sym_if_expression] = STATE(867),
    [sym_fun_expression] = STATE(867),
    [sym_try_expression] = STATE(867),
    [sym_match_expression] = STATE(867),
    [sym_function_expression] = STATE(867),
    [sym_mutate_expression] = STATE(867),
    [sym_index_expression] = STATE(867),
    [sym_typed_expression] = STATE(867),
    [sym_declaration_expression] = STATE(867),
    [sym_do_expression] = STATE(867),
    [sym_list_expression] = STATE(867),
    [sym_array_expression] = STATE(867),
    [sym_begin_end_expression] = STATE(867),
    [sym_paren_expression] = STATE(867),
    [sym__high_prec_app] = STATE(864),
    [sym__low_prec_app] = STATE(864),
    [sym_application_expression] = STATE(867),
    [sym_dot_expression] = STATE(867),
    [sym_infix_expression] = STATE(867),
    [sym_ce_expression] = STATE(867),
    [sym_sequential_expression] = STATE(867),
    [sym_char] = STATE(868),
    [sym_format_string] = STATE(869),
    [sym__string_literal] = STATE(869),
    [sym_string] = STATE(868),
    [sym_verbatim_string] = STATE(868),
    [sym_bytearray] = STATE(868),
    [sym_verbatim_bytearray] = STATE(868),
    [sym_format_triple_quoted_string] = STATE(870),
    [sym_triple_quoted_string] = STATE(868),
    [sym_const] = STATE(867),
    [sym_long_identifier] = STATE(872),
    [sym_active_pattern] = STATE(871),
    [sym__identifier_or_op] = STATE(873),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(656),
    [sym_infix_op] = STATE(581),
    [sym_sbyte] = STATE(868),
    [sym_byte] = STATE(868),
    [sym_int16] = STATE(868),
    [sym_uint16] = STATE(868),
    [sym_int32] = STATE(868),
    [sym_uint32] = STATE(868),
    [sym_nativeint] = STATE(868),
    [sym_unativeint] = STATE(868),
    [sym_int64] = STATE(868),
    [sym_uint64] = STATE(868),
    [sym_ieee32] = STATE(868),
    [sym_ieee64] = STATE(868),
    [sym_bignum] = STATE(868),
    [sym_decimal] = STATE(868),
    [sym_float] = STATE(1368),
    [sym_block_comment] = STATE(224),
    [sym_compiler_directive_decl] = STATE(224),
    [sym_fsi_directive_decl] = STATE(224),
    [sym_preproc_line] = STATE(224),
    [sym_preproc_if_in_expression] = STATE(867),
    [aux_sym_sequential_expression_repeat1] = STATE(1542),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(29),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(825),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_COMMA] = ACTIONS(827),
    [anon_sym_null] = ACTIONS(49),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACK_PIPE] = ACTIONS(57),
    [anon_sym_LBRACE] = ACTIONS(139),
    [anon_sym_LT_AT] = ACTIONS(61),
    [anon_sym_LT_AT_AT] = ACTIONS(63),
    [anon_sym_DOT] = ACTIONS(65),
    [anon_sym_LBRACE_PIPE] = ACTIONS(67),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_return_BANG] = ACTIONS(829),
    [anon_sym_yield] = ACTIONS(825),
    [anon_sym_yield_BANG] = ACTIONS(829),
    [anon_sym_lazy] = ACTIONS(825),
    [anon_sym_assert] = ACTIONS(825),
    [anon_sym_upcast] = ACTIONS(825),
    [anon_sym_downcast] = ACTIONS(825),
    [anon_sym_COLON_GT] = ACTIONS(71),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(71),
    [anon_sym_for] = ACTIONS(73),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(79),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_match] = ACTIONS(83),
    [anon_sym_match_BANG] = ACTIONS(85),
    [anon_sym_function] = ACTIONS(87),
    [anon_sym_LT_DASH] = ACTIONS(831),
    [anon_sym_DOT_LBRACK] = ACTIONS(91),
    [anon_sym_LT] = ACTIONS(93),
    [anon_sym_use] = ACTIONS(833),
    [anon_sym_use_BANG] = ACTIONS(835),
    [anon_sym_do_BANG] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(101),
    [anon_sym_LPAREN2] = ACTIONS(103),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(105),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(107),
    [anon_sym_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DQUOTE] = ACTIONS(111),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(115),
    [sym_bool] = ACTIONS(117),
    [sym_unit] = ACTIONS(119),
    [anon_sym_LPAREN_PIPE] = ACTIONS(121),
    [sym_op_identifier] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(837),
    [sym_xint] = ACTIONS(387),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(135),
    [sym__newline] = ACTIONS(839),
    [sym__dedent] = ACTIONS(1383),
  },
  [225] = {
    [sym_function_or_value_defn] = STATE(630),
    [sym__expression] = STATE(219),
    [sym_literal_expression] = STATE(2380),
    [sym_long_identifier_or_op] = STATE(2380),
    [sym_tuple_expression] = STATE(2380),
    [sym_brace_expression] = STATE(2380),
    [sym_anon_record_expression] = STATE(2380),
    [sym_prefixed_expression] = STATE(2380),
    [sym_typecast_expression] = STATE(2380),
    [sym_for_expression] = STATE(2380),
    [sym_while_expression] = STATE(2380),
    [sym__if_branch] = STATE(6456),
    [sym_if_expression] = STATE(2380),
    [sym_fun_expression] = STATE(2380),
    [sym_try_expression] = STATE(2380),
    [sym_match_expression] = STATE(2380),
    [sym_function_expression] = STATE(2380),
    [sym_mutate_expression] = STATE(2380),
    [sym_index_expression] = STATE(2380),
    [sym_typed_expression] = STATE(2380),
    [sym_declaration_expression] = STATE(2380),
    [sym_do_expression] = STATE(2380),
    [sym_list_expression] = STATE(2380),
    [sym_array_expression] = STATE(2380),
    [sym_begin_end_expression] = STATE(2380),
    [sym_paren_expression] = STATE(2380),
    [sym__high_prec_app] = STATE(2383),
    [sym__low_prec_app] = STATE(2383),
    [sym_application_expression] = STATE(2380),
    [sym_dot_expression] = STATE(2380),
    [sym_infix_expression] = STATE(2380),
    [sym_ce_expression] = STATE(2380),
    [sym_sequential_expression] = STATE(2380),
    [sym_char] = STATE(2261),
    [sym_format_string] = STATE(2274),
    [sym__string_literal] = STATE(2274),
    [sym_string] = STATE(2261),
    [sym_verbatim_string] = STATE(2261),
    [sym_bytearray] = STATE(2261),
    [sym_verbatim_bytearray] = STATE(2261),
    [sym_format_triple_quoted_string] = STATE(2275),
    [sym_triple_quoted_string] = STATE(2261),
    [sym_const] = STATE(2380),
    [sym_long_identifier] = STATE(2391),
    [sym_active_pattern] = STATE(2470),
    [sym__identifier_or_op] = STATE(2390),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(632),
    [sym_infix_op] = STATE(616),
    [sym_sbyte] = STATE(2261),
    [sym_byte] = STATE(2261),
    [sym_int16] = STATE(2261),
    [sym_uint16] = STATE(2261),
    [sym_int32] = STATE(2261),
    [sym_uint32] = STATE(2261),
    [sym_nativeint] = STATE(2261),
    [sym_unativeint] = STATE(2261),
    [sym_int64] = STATE(2261),
    [sym_uint64] = STATE(2261),
    [sym_ieee32] = STATE(2261),
    [sym_ieee64] = STATE(2261),
    [sym_bignum] = STATE(2261),
    [sym_decimal] = STATE(2261),
    [sym_float] = STATE(1614),
    [sym_block_comment] = STATE(225),
    [sym_compiler_directive_decl] = STATE(225),
    [sym_fsi_directive_decl] = STATE(225),
    [sym_preproc_line] = STATE(225),
    [sym_preproc_if_in_expression] = STATE(2380),
    [aux_sym_sequential_expression_repeat1] = STATE(1882),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(1081),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(1083),
    [anon_sym_return] = ACTIONS(1085),
    [anon_sym_do] = ACTIONS(1087),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(1089),
    [anon_sym_COMMA] = ACTIONS(1091),
    [anon_sym_null] = ACTIONS(1093),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(1083),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1095),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1097),
    [anon_sym_LBRACE] = ACTIONS(165),
    [anon_sym_LT_AT] = ACTIONS(1101),
    [anon_sym_LT_AT_AT] = ACTIONS(1103),
    [anon_sym_AT_AT_GT] = ACTIONS(165),
    [anon_sym_DOT] = ACTIONS(1105),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1107),
    [anon_sym_new] = ACTIONS(1085),
    [anon_sym_return_BANG] = ACTIONS(1109),
    [anon_sym_yield] = ACTIONS(1085),
    [anon_sym_yield_BANG] = ACTIONS(1109),
    [anon_sym_lazy] = ACTIONS(1085),
    [anon_sym_assert] = ACTIONS(1085),
    [anon_sym_upcast] = ACTIONS(1085),
    [anon_sym_downcast] = ACTIONS(1085),
    [anon_sym_COLON_GT] = ACTIONS(1111),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1111),
    [anon_sym_for] = ACTIONS(1113),
    [anon_sym_while] = ACTIONS(1115),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(1117),
    [anon_sym_try] = ACTIONS(1119),
    [anon_sym_match] = ACTIONS(1121),
    [anon_sym_match_BANG] = ACTIONS(1123),
    [anon_sym_function] = ACTIONS(1125),
    [anon_sym_LT_DASH] = ACTIONS(1127),
    [anon_sym_DOT_LBRACK] = ACTIONS(1129),
    [anon_sym_LT] = ACTIONS(1131),
    [anon_sym_use] = ACTIONS(1133),
    [anon_sym_use_BANG] = ACTIONS(1135),
    [anon_sym_do_BANG] = ACTIONS(1137),
    [anon_sym_begin] = ACTIONS(1139),
    [anon_sym_LPAREN2] = ACTIONS(1141),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(1143),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1145),
    [anon_sym_DQUOTE] = ACTIONS(1147),
    [anon_sym_AT_DQUOTE] = ACTIONS(1149),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1151),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1153),
    [sym_bool] = ACTIONS(1155),
    [sym_unit] = ACTIONS(1157),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1159),
    [sym_op_identifier] = ACTIONS(1161),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(1163),
    [sym_xint] = ACTIONS(1165),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1167),
    [sym__newline] = ACTIONS(163),
  },
  [226] = {
    [sym_function_or_value_defn] = STATE(600),
    [sym__expression] = STATE(88),
    [sym_literal_expression] = STATE(867),
    [sym_long_identifier_or_op] = STATE(867),
    [sym_tuple_expression] = STATE(867),
    [sym_brace_expression] = STATE(867),
    [sym_anon_record_expression] = STATE(867),
    [sym_prefixed_expression] = STATE(867),
    [sym_typecast_expression] = STATE(867),
    [sym_for_expression] = STATE(867),
    [sym_while_expression] = STATE(867),
    [sym__if_branch] = STATE(6511),
    [sym_if_expression] = STATE(867),
    [sym_fun_expression] = STATE(867),
    [sym_try_expression] = STATE(867),
    [sym_match_expression] = STATE(867),
    [sym_function_expression] = STATE(867),
    [sym_mutate_expression] = STATE(867),
    [sym_index_expression] = STATE(867),
    [sym_typed_expression] = STATE(867),
    [sym_declaration_expression] = STATE(867),
    [sym_do_expression] = STATE(867),
    [sym_list_expression] = STATE(867),
    [sym_array_expression] = STATE(867),
    [sym_begin_end_expression] = STATE(867),
    [sym_paren_expression] = STATE(867),
    [sym__high_prec_app] = STATE(864),
    [sym__low_prec_app] = STATE(864),
    [sym_application_expression] = STATE(867),
    [sym_dot_expression] = STATE(867),
    [sym_infix_expression] = STATE(867),
    [sym_ce_expression] = STATE(867),
    [sym_sequential_expression] = STATE(867),
    [sym_char] = STATE(868),
    [sym_format_string] = STATE(869),
    [sym__string_literal] = STATE(869),
    [sym_string] = STATE(868),
    [sym_verbatim_string] = STATE(868),
    [sym_bytearray] = STATE(868),
    [sym_verbatim_bytearray] = STATE(868),
    [sym_format_triple_quoted_string] = STATE(870),
    [sym_triple_quoted_string] = STATE(868),
    [sym_const] = STATE(867),
    [sym_long_identifier] = STATE(872),
    [sym_active_pattern] = STATE(871),
    [sym__identifier_or_op] = STATE(873),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(656),
    [sym_infix_op] = STATE(581),
    [sym_sbyte] = STATE(868),
    [sym_byte] = STATE(868),
    [sym_int16] = STATE(868),
    [sym_uint16] = STATE(868),
    [sym_int32] = STATE(868),
    [sym_uint32] = STATE(868),
    [sym_nativeint] = STATE(868),
    [sym_unativeint] = STATE(868),
    [sym_int64] = STATE(868),
    [sym_uint64] = STATE(868),
    [sym_ieee32] = STATE(868),
    [sym_ieee64] = STATE(868),
    [sym_bignum] = STATE(868),
    [sym_decimal] = STATE(868),
    [sym_float] = STATE(1368),
    [sym_block_comment] = STATE(226),
    [sym_compiler_directive_decl] = STATE(226),
    [sym_fsi_directive_decl] = STATE(226),
    [sym_preproc_line] = STATE(226),
    [sym_preproc_if_in_expression] = STATE(867),
    [aux_sym_sequential_expression_repeat1] = STATE(1542),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(29),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(825),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_COMMA] = ACTIONS(827),
    [anon_sym_null] = ACTIONS(49),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACK_PIPE] = ACTIONS(57),
    [anon_sym_LBRACE] = ACTIONS(139),
    [anon_sym_LT_AT] = ACTIONS(61),
    [anon_sym_LT_AT_AT] = ACTIONS(63),
    [anon_sym_DOT] = ACTIONS(65),
    [anon_sym_LBRACE_PIPE] = ACTIONS(67),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_return_BANG] = ACTIONS(829),
    [anon_sym_yield] = ACTIONS(825),
    [anon_sym_yield_BANG] = ACTIONS(829),
    [anon_sym_lazy] = ACTIONS(825),
    [anon_sym_assert] = ACTIONS(825),
    [anon_sym_upcast] = ACTIONS(825),
    [anon_sym_downcast] = ACTIONS(825),
    [anon_sym_COLON_GT] = ACTIONS(71),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(71),
    [anon_sym_for] = ACTIONS(73),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(79),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_match] = ACTIONS(83),
    [anon_sym_match_BANG] = ACTIONS(85),
    [anon_sym_function] = ACTIONS(87),
    [anon_sym_LT_DASH] = ACTIONS(831),
    [anon_sym_DOT_LBRACK] = ACTIONS(91),
    [anon_sym_LT] = ACTIONS(93),
    [anon_sym_use] = ACTIONS(833),
    [anon_sym_use_BANG] = ACTIONS(835),
    [anon_sym_do_BANG] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(101),
    [anon_sym_LPAREN2] = ACTIONS(103),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(105),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(107),
    [anon_sym_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DQUOTE] = ACTIONS(111),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(115),
    [sym_bool] = ACTIONS(117),
    [sym_unit] = ACTIONS(119),
    [anon_sym_LPAREN_PIPE] = ACTIONS(121),
    [sym_op_identifier] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(837),
    [sym_xint] = ACTIONS(387),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(135),
    [sym__newline] = ACTIONS(839),
    [sym__dedent] = ACTIONS(1385),
  },
  [227] = {
    [sym_function_or_value_defn] = STATE(630),
    [sym__expression] = STATE(219),
    [sym_literal_expression] = STATE(2380),
    [sym_long_identifier_or_op] = STATE(2380),
    [sym_tuple_expression] = STATE(2380),
    [sym_brace_expression] = STATE(2380),
    [sym_anon_record_expression] = STATE(2380),
    [sym_prefixed_expression] = STATE(2380),
    [sym_typecast_expression] = STATE(2380),
    [sym_for_expression] = STATE(2380),
    [sym_while_expression] = STATE(2380),
    [sym__if_branch] = STATE(6456),
    [sym_if_expression] = STATE(2380),
    [sym_fun_expression] = STATE(2380),
    [sym_try_expression] = STATE(2380),
    [sym_match_expression] = STATE(2380),
    [sym_function_expression] = STATE(2380),
    [sym_mutate_expression] = STATE(2380),
    [sym_index_expression] = STATE(2380),
    [sym_typed_expression] = STATE(2380),
    [sym_declaration_expression] = STATE(2380),
    [sym_do_expression] = STATE(2380),
    [sym_list_expression] = STATE(2380),
    [sym_array_expression] = STATE(2380),
    [sym_begin_end_expression] = STATE(2380),
    [sym_paren_expression] = STATE(2380),
    [sym__high_prec_app] = STATE(2383),
    [sym__low_prec_app] = STATE(2383),
    [sym_application_expression] = STATE(2380),
    [sym_dot_expression] = STATE(2380),
    [sym_infix_expression] = STATE(2380),
    [sym_ce_expression] = STATE(2380),
    [sym_sequential_expression] = STATE(2380),
    [sym_char] = STATE(2261),
    [sym_format_string] = STATE(2274),
    [sym__string_literal] = STATE(2274),
    [sym_string] = STATE(2261),
    [sym_verbatim_string] = STATE(2261),
    [sym_bytearray] = STATE(2261),
    [sym_verbatim_bytearray] = STATE(2261),
    [sym_format_triple_quoted_string] = STATE(2275),
    [sym_triple_quoted_string] = STATE(2261),
    [sym_const] = STATE(2380),
    [sym_long_identifier] = STATE(2391),
    [sym_active_pattern] = STATE(2470),
    [sym__identifier_or_op] = STATE(2390),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(632),
    [sym_infix_op] = STATE(616),
    [sym_sbyte] = STATE(2261),
    [sym_byte] = STATE(2261),
    [sym_int16] = STATE(2261),
    [sym_uint16] = STATE(2261),
    [sym_int32] = STATE(2261),
    [sym_uint32] = STATE(2261),
    [sym_nativeint] = STATE(2261),
    [sym_unativeint] = STATE(2261),
    [sym_int64] = STATE(2261),
    [sym_uint64] = STATE(2261),
    [sym_ieee32] = STATE(2261),
    [sym_ieee64] = STATE(2261),
    [sym_bignum] = STATE(2261),
    [sym_decimal] = STATE(2261),
    [sym_float] = STATE(1614),
    [sym_block_comment] = STATE(227),
    [sym_compiler_directive_decl] = STATE(227),
    [sym_fsi_directive_decl] = STATE(227),
    [sym_preproc_line] = STATE(227),
    [sym_preproc_if_in_expression] = STATE(2380),
    [aux_sym_sequential_expression_repeat1] = STATE(1882),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(1081),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(1083),
    [anon_sym_return] = ACTIONS(1085),
    [anon_sym_do] = ACTIONS(1087),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(1089),
    [anon_sym_COMMA] = ACTIONS(1091),
    [anon_sym_null] = ACTIONS(1093),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(1083),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1095),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1097),
    [anon_sym_LBRACE] = ACTIONS(169),
    [anon_sym_LT_AT] = ACTIONS(1101),
    [anon_sym_LT_AT_AT] = ACTIONS(1103),
    [anon_sym_AT_AT_GT] = ACTIONS(169),
    [anon_sym_DOT] = ACTIONS(1105),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1107),
    [anon_sym_new] = ACTIONS(1085),
    [anon_sym_return_BANG] = ACTIONS(1109),
    [anon_sym_yield] = ACTIONS(1085),
    [anon_sym_yield_BANG] = ACTIONS(1109),
    [anon_sym_lazy] = ACTIONS(1085),
    [anon_sym_assert] = ACTIONS(1085),
    [anon_sym_upcast] = ACTIONS(1085),
    [anon_sym_downcast] = ACTIONS(1085),
    [anon_sym_COLON_GT] = ACTIONS(1111),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1111),
    [anon_sym_for] = ACTIONS(1113),
    [anon_sym_while] = ACTIONS(1115),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(1117),
    [anon_sym_try] = ACTIONS(1119),
    [anon_sym_match] = ACTIONS(1121),
    [anon_sym_match_BANG] = ACTIONS(1123),
    [anon_sym_function] = ACTIONS(1125),
    [anon_sym_LT_DASH] = ACTIONS(1127),
    [anon_sym_DOT_LBRACK] = ACTIONS(1129),
    [anon_sym_LT] = ACTIONS(1131),
    [anon_sym_use] = ACTIONS(1133),
    [anon_sym_use_BANG] = ACTIONS(1135),
    [anon_sym_do_BANG] = ACTIONS(1137),
    [anon_sym_begin] = ACTIONS(1139),
    [anon_sym_LPAREN2] = ACTIONS(1141),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(1143),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1145),
    [anon_sym_DQUOTE] = ACTIONS(1147),
    [anon_sym_AT_DQUOTE] = ACTIONS(1149),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1151),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1153),
    [sym_bool] = ACTIONS(1155),
    [sym_unit] = ACTIONS(1157),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1159),
    [sym_op_identifier] = ACTIONS(1161),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(1163),
    [sym_xint] = ACTIONS(1165),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1167),
    [sym__newline] = ACTIONS(167),
  },
  [228] = {
    [sym_function_or_value_defn] = STATE(600),
    [sym__expression] = STATE(88),
    [sym_literal_expression] = STATE(867),
    [sym_long_identifier_or_op] = STATE(867),
    [sym_tuple_expression] = STATE(867),
    [sym_brace_expression] = STATE(867),
    [sym_anon_record_expression] = STATE(867),
    [sym_prefixed_expression] = STATE(867),
    [sym_typecast_expression] = STATE(867),
    [sym_for_expression] = STATE(867),
    [sym_while_expression] = STATE(867),
    [sym__if_branch] = STATE(6511),
    [sym_if_expression] = STATE(867),
    [sym_fun_expression] = STATE(867),
    [sym_try_expression] = STATE(867),
    [sym_match_expression] = STATE(867),
    [sym_function_expression] = STATE(867),
    [sym_mutate_expression] = STATE(867),
    [sym_index_expression] = STATE(867),
    [sym_typed_expression] = STATE(867),
    [sym_declaration_expression] = STATE(867),
    [sym_do_expression] = STATE(867),
    [sym_list_expression] = STATE(867),
    [sym_array_expression] = STATE(867),
    [sym_begin_end_expression] = STATE(867),
    [sym_paren_expression] = STATE(867),
    [sym__high_prec_app] = STATE(864),
    [sym__low_prec_app] = STATE(864),
    [sym_application_expression] = STATE(867),
    [sym_dot_expression] = STATE(867),
    [sym_infix_expression] = STATE(867),
    [sym_ce_expression] = STATE(867),
    [sym_sequential_expression] = STATE(867),
    [sym_char] = STATE(868),
    [sym_format_string] = STATE(869),
    [sym__string_literal] = STATE(869),
    [sym_string] = STATE(868),
    [sym_verbatim_string] = STATE(868),
    [sym_bytearray] = STATE(868),
    [sym_verbatim_bytearray] = STATE(868),
    [sym_format_triple_quoted_string] = STATE(870),
    [sym_triple_quoted_string] = STATE(868),
    [sym_const] = STATE(867),
    [sym_long_identifier] = STATE(872),
    [sym_active_pattern] = STATE(871),
    [sym__identifier_or_op] = STATE(873),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(656),
    [sym_infix_op] = STATE(581),
    [sym_sbyte] = STATE(868),
    [sym_byte] = STATE(868),
    [sym_int16] = STATE(868),
    [sym_uint16] = STATE(868),
    [sym_int32] = STATE(868),
    [sym_uint32] = STATE(868),
    [sym_nativeint] = STATE(868),
    [sym_unativeint] = STATE(868),
    [sym_int64] = STATE(868),
    [sym_uint64] = STATE(868),
    [sym_ieee32] = STATE(868),
    [sym_ieee64] = STATE(868),
    [sym_bignum] = STATE(868),
    [sym_decimal] = STATE(868),
    [sym_float] = STATE(1368),
    [sym_block_comment] = STATE(228),
    [sym_compiler_directive_decl] = STATE(228),
    [sym_fsi_directive_decl] = STATE(228),
    [sym_preproc_line] = STATE(228),
    [sym_preproc_if_in_expression] = STATE(867),
    [aux_sym_sequential_expression_repeat1] = STATE(1542),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(29),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(825),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_COMMA] = ACTIONS(827),
    [anon_sym_null] = ACTIONS(49),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACK_PIPE] = ACTIONS(57),
    [anon_sym_LBRACE] = ACTIONS(139),
    [anon_sym_LT_AT] = ACTIONS(61),
    [anon_sym_LT_AT_AT] = ACTIONS(63),
    [anon_sym_DOT] = ACTIONS(65),
    [anon_sym_LBRACE_PIPE] = ACTIONS(67),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_return_BANG] = ACTIONS(829),
    [anon_sym_yield] = ACTIONS(825),
    [anon_sym_yield_BANG] = ACTIONS(829),
    [anon_sym_lazy] = ACTIONS(825),
    [anon_sym_assert] = ACTIONS(825),
    [anon_sym_upcast] = ACTIONS(825),
    [anon_sym_downcast] = ACTIONS(825),
    [anon_sym_COLON_GT] = ACTIONS(71),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(71),
    [anon_sym_for] = ACTIONS(73),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(79),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_match] = ACTIONS(83),
    [anon_sym_match_BANG] = ACTIONS(85),
    [anon_sym_function] = ACTIONS(87),
    [anon_sym_LT_DASH] = ACTIONS(831),
    [anon_sym_DOT_LBRACK] = ACTIONS(91),
    [anon_sym_LT] = ACTIONS(93),
    [anon_sym_use] = ACTIONS(833),
    [anon_sym_use_BANG] = ACTIONS(835),
    [anon_sym_do_BANG] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(101),
    [anon_sym_LPAREN2] = ACTIONS(103),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(105),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(107),
    [anon_sym_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DQUOTE] = ACTIONS(111),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(115),
    [sym_bool] = ACTIONS(117),
    [sym_unit] = ACTIONS(119),
    [anon_sym_LPAREN_PIPE] = ACTIONS(121),
    [sym_op_identifier] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(837),
    [sym_xint] = ACTIONS(387),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(135),
    [sym__newline] = ACTIONS(839),
    [sym__dedent] = ACTIONS(1387),
  },
  [229] = {
    [sym_function_or_value_defn] = STATE(630),
    [sym__expression] = STATE(219),
    [sym_literal_expression] = STATE(2380),
    [sym_long_identifier_or_op] = STATE(2380),
    [sym_tuple_expression] = STATE(2380),
    [sym_brace_expression] = STATE(2380),
    [sym_anon_record_expression] = STATE(2380),
    [sym_prefixed_expression] = STATE(2380),
    [sym_typecast_expression] = STATE(2380),
    [sym_for_expression] = STATE(2380),
    [sym_while_expression] = STATE(2380),
    [sym__if_branch] = STATE(6456),
    [sym_if_expression] = STATE(2380),
    [sym_fun_expression] = STATE(2380),
    [sym_try_expression] = STATE(2380),
    [sym_match_expression] = STATE(2380),
    [sym_function_expression] = STATE(2380),
    [sym_mutate_expression] = STATE(2380),
    [sym_index_expression] = STATE(2380),
    [sym_typed_expression] = STATE(2380),
    [sym_declaration_expression] = STATE(2380),
    [sym_do_expression] = STATE(2380),
    [sym_list_expression] = STATE(2380),
    [sym_array_expression] = STATE(2380),
    [sym_begin_end_expression] = STATE(2380),
    [sym_paren_expression] = STATE(2380),
    [sym__high_prec_app] = STATE(2383),
    [sym__low_prec_app] = STATE(2383),
    [sym_application_expression] = STATE(2380),
    [sym_dot_expression] = STATE(2380),
    [sym_infix_expression] = STATE(2380),
    [sym_ce_expression] = STATE(2380),
    [sym_sequential_expression] = STATE(2380),
    [sym_char] = STATE(2261),
    [sym_format_string] = STATE(2274),
    [sym__string_literal] = STATE(2274),
    [sym_string] = STATE(2261),
    [sym_verbatim_string] = STATE(2261),
    [sym_bytearray] = STATE(2261),
    [sym_verbatim_bytearray] = STATE(2261),
    [sym_format_triple_quoted_string] = STATE(2275),
    [sym_triple_quoted_string] = STATE(2261),
    [sym_const] = STATE(2380),
    [sym_long_identifier] = STATE(2391),
    [sym_active_pattern] = STATE(2470),
    [sym__identifier_or_op] = STATE(2390),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(632),
    [sym_infix_op] = STATE(616),
    [sym_sbyte] = STATE(2261),
    [sym_byte] = STATE(2261),
    [sym_int16] = STATE(2261),
    [sym_uint16] = STATE(2261),
    [sym_int32] = STATE(2261),
    [sym_uint32] = STATE(2261),
    [sym_nativeint] = STATE(2261),
    [sym_unativeint] = STATE(2261),
    [sym_int64] = STATE(2261),
    [sym_uint64] = STATE(2261),
    [sym_ieee32] = STATE(2261),
    [sym_ieee64] = STATE(2261),
    [sym_bignum] = STATE(2261),
    [sym_decimal] = STATE(2261),
    [sym_float] = STATE(1614),
    [sym_block_comment] = STATE(229),
    [sym_compiler_directive_decl] = STATE(229),
    [sym_fsi_directive_decl] = STATE(229),
    [sym_preproc_line] = STATE(229),
    [sym_preproc_if_in_expression] = STATE(2380),
    [aux_sym_sequential_expression_repeat1] = STATE(1882),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(181),
    [anon_sym_EQ] = ACTIONS(183),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_return] = ACTIONS(181),
    [anon_sym_do] = ACTIONS(181),
    [anon_sym_let] = ACTIONS(181),
    [anon_sym_let_BANG] = ACTIONS(183),
    [anon_sym_LPAREN] = ACTIONS(181),
    [anon_sym_COMMA] = ACTIONS(183),
    [anon_sym_null] = ACTIONS(181),
    [anon_sym_QMARK] = ACTIONS(181),
    [anon_sym_COLON_QMARK] = ACTIONS(181),
    [anon_sym_COLON_COLON] = ACTIONS(183),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_LBRACK_PIPE] = ACTIONS(183),
    [anon_sym_LBRACE] = ACTIONS(181),
    [anon_sym_LT_AT] = ACTIONS(181),
    [anon_sym_LT_AT_AT] = ACTIONS(181),
    [anon_sym_AT_AT_GT] = ACTIONS(181),
    [anon_sym_DOT] = ACTIONS(1105),
    [anon_sym_LBRACE_PIPE] = ACTIONS(183),
    [anon_sym_new] = ACTIONS(181),
    [anon_sym_return_BANG] = ACTIONS(183),
    [anon_sym_yield] = ACTIONS(181),
    [anon_sym_yield_BANG] = ACTIONS(183),
    [anon_sym_lazy] = ACTIONS(181),
    [anon_sym_assert] = ACTIONS(181),
    [anon_sym_upcast] = ACTIONS(181),
    [anon_sym_downcast] = ACTIONS(181),
    [anon_sym_COLON_GT] = ACTIONS(183),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(183),
    [anon_sym_for] = ACTIONS(181),
    [anon_sym_while] = ACTIONS(181),
    [anon_sym_if] = ACTIONS(181),
    [anon_sym_fun] = ACTIONS(181),
    [anon_sym_try] = ACTIONS(181),
    [anon_sym_match] = ACTIONS(181),
    [anon_sym_match_BANG] = ACTIONS(183),
    [anon_sym_function] = ACTIONS(181),
    [anon_sym_LT_DASH] = ACTIONS(181),
    [anon_sym_DOT_LBRACK] = ACTIONS(1129),
    [anon_sym_LT] = ACTIONS(1131),
    [anon_sym_use] = ACTIONS(181),
    [anon_sym_use_BANG] = ACTIONS(183),
    [anon_sym_do_BANG] = ACTIONS(183),
    [anon_sym_begin] = ACTIONS(181),
    [anon_sym_LPAREN2] = ACTIONS(1141),
    [anon_sym_or] = ACTIONS(181),
    [aux_sym_char_token1] = ACTIONS(183),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(181),
    [anon_sym_DQUOTE] = ACTIONS(181),
    [anon_sym_AT_DQUOTE] = ACTIONS(183),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(183),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(183),
    [sym_bool] = ACTIONS(181),
    [sym_unit] = ACTIONS(1157),
    [anon_sym_LPAREN_PIPE] = ACTIONS(181),
    [sym_op_identifier] = ACTIONS(181),
    [anon_sym_PLUS] = ACTIONS(181),
    [anon_sym_DASH] = ACTIONS(181),
    [anon_sym_PLUS_DOT] = ACTIONS(181),
    [anon_sym_DASH_DOT] = ACTIONS(181),
    [anon_sym_PERCENT] = ACTIONS(181),
    [anon_sym_AMP_AMP] = ACTIONS(181),
    [anon_sym_TILDE] = ACTIONS(183),
    [aux_sym_prefix_op_token1] = ACTIONS(181),
    [aux_sym_infix_op_token1] = ACTIONS(183),
    [aux_sym_infix_op_token2] = ACTIONS(181),
    [anon_sym_PIPE_PIPE] = ACTIONS(181),
    [anon_sym_BANG_EQ] = ACTIONS(181),
    [anon_sym_COLON_EQ] = ACTIONS(183),
    [anon_sym_DOLLAR] = ACTIONS(181),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(181),
    [sym_int] = ACTIONS(181),
    [sym_xint] = ACTIONS(183),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(183),
    [sym__newline] = ACTIONS(183),
  },
  [230] = {
    [sym_function_or_value_defn] = STATE(630),
    [sym__expression] = STATE(219),
    [sym_literal_expression] = STATE(2380),
    [sym_long_identifier_or_op] = STATE(2380),
    [sym_tuple_expression] = STATE(2380),
    [sym_brace_expression] = STATE(2380),
    [sym_anon_record_expression] = STATE(2380),
    [sym_prefixed_expression] = STATE(2380),
    [sym_typecast_expression] = STATE(2380),
    [sym_for_expression] = STATE(2380),
    [sym_while_expression] = STATE(2380),
    [sym__if_branch] = STATE(6456),
    [sym_if_expression] = STATE(2380),
    [sym_fun_expression] = STATE(2380),
    [sym_try_expression] = STATE(2380),
    [sym_match_expression] = STATE(2380),
    [sym_function_expression] = STATE(2380),
    [sym_mutate_expression] = STATE(2380),
    [sym_index_expression] = STATE(2380),
    [sym_typed_expression] = STATE(2380),
    [sym_declaration_expression] = STATE(2380),
    [sym_do_expression] = STATE(2380),
    [sym_list_expression] = STATE(2380),
    [sym_array_expression] = STATE(2380),
    [sym_begin_end_expression] = STATE(2380),
    [sym_paren_expression] = STATE(2380),
    [sym__high_prec_app] = STATE(2383),
    [sym__low_prec_app] = STATE(2383),
    [sym_application_expression] = STATE(2380),
    [sym_dot_expression] = STATE(2380),
    [sym_infix_expression] = STATE(2380),
    [sym_ce_expression] = STATE(2380),
    [sym_sequential_expression] = STATE(2380),
    [sym_char] = STATE(2261),
    [sym_format_string] = STATE(2274),
    [sym__string_literal] = STATE(2274),
    [sym_string] = STATE(2261),
    [sym_verbatim_string] = STATE(2261),
    [sym_bytearray] = STATE(2261),
    [sym_verbatim_bytearray] = STATE(2261),
    [sym_format_triple_quoted_string] = STATE(2275),
    [sym_triple_quoted_string] = STATE(2261),
    [sym_const] = STATE(2380),
    [sym_long_identifier] = STATE(2391),
    [sym_active_pattern] = STATE(2470),
    [sym__identifier_or_op] = STATE(2390),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(632),
    [sym_infix_op] = STATE(616),
    [sym_sbyte] = STATE(2261),
    [sym_byte] = STATE(2261),
    [sym_int16] = STATE(2261),
    [sym_uint16] = STATE(2261),
    [sym_int32] = STATE(2261),
    [sym_uint32] = STATE(2261),
    [sym_nativeint] = STATE(2261),
    [sym_unativeint] = STATE(2261),
    [sym_int64] = STATE(2261),
    [sym_uint64] = STATE(2261),
    [sym_ieee32] = STATE(2261),
    [sym_ieee64] = STATE(2261),
    [sym_bignum] = STATE(2261),
    [sym_decimal] = STATE(2261),
    [sym_float] = STATE(1614),
    [sym_block_comment] = STATE(230),
    [sym_compiler_directive_decl] = STATE(230),
    [sym_fsi_directive_decl] = STATE(230),
    [sym_preproc_line] = STATE(230),
    [sym_preproc_if_in_expression] = STATE(2380),
    [aux_sym_sequential_expression_repeat1] = STATE(1882),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(1081),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(1083),
    [anon_sym_return] = ACTIONS(1085),
    [anon_sym_do] = ACTIONS(1087),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(1089),
    [anon_sym_COMMA] = ACTIONS(1091),
    [anon_sym_null] = ACTIONS(1093),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(1083),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1095),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1097),
    [anon_sym_LBRACE] = ACTIONS(59),
    [anon_sym_LT_AT] = ACTIONS(1101),
    [anon_sym_LT_AT_AT] = ACTIONS(1103),
    [anon_sym_AT_AT_GT] = ACTIONS(59),
    [anon_sym_DOT] = ACTIONS(1105),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1107),
    [anon_sym_new] = ACTIONS(1085),
    [anon_sym_return_BANG] = ACTIONS(1109),
    [anon_sym_yield] = ACTIONS(1085),
    [anon_sym_yield_BANG] = ACTIONS(1109),
    [anon_sym_lazy] = ACTIONS(1085),
    [anon_sym_assert] = ACTIONS(1085),
    [anon_sym_upcast] = ACTIONS(1085),
    [anon_sym_downcast] = ACTIONS(1085),
    [anon_sym_COLON_GT] = ACTIONS(1111),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1111),
    [anon_sym_for] = ACTIONS(1113),
    [anon_sym_while] = ACTIONS(1115),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(1117),
    [anon_sym_try] = ACTIONS(1119),
    [anon_sym_match] = ACTIONS(1121),
    [anon_sym_match_BANG] = ACTIONS(1123),
    [anon_sym_function] = ACTIONS(1125),
    [anon_sym_LT_DASH] = ACTIONS(1127),
    [anon_sym_DOT_LBRACK] = ACTIONS(1129),
    [anon_sym_LT] = ACTIONS(1131),
    [anon_sym_use] = ACTIONS(1133),
    [anon_sym_use_BANG] = ACTIONS(1135),
    [anon_sym_do_BANG] = ACTIONS(1137),
    [anon_sym_begin] = ACTIONS(1139),
    [anon_sym_LPAREN2] = ACTIONS(1141),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(1143),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1145),
    [anon_sym_DQUOTE] = ACTIONS(1147),
    [anon_sym_AT_DQUOTE] = ACTIONS(1149),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1151),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1153),
    [sym_bool] = ACTIONS(1155),
    [sym_unit] = ACTIONS(1157),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1159),
    [sym_op_identifier] = ACTIONS(1161),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(1163),
    [sym_xint] = ACTIONS(1165),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1167),
    [sym__newline] = ACTIONS(33),
  },
  [231] = {
    [sym_function_or_value_defn] = STATE(600),
    [sym__expression] = STATE(88),
    [sym_literal_expression] = STATE(867),
    [sym_long_identifier_or_op] = STATE(867),
    [sym_tuple_expression] = STATE(867),
    [sym_brace_expression] = STATE(867),
    [sym_anon_record_expression] = STATE(867),
    [sym_prefixed_expression] = STATE(867),
    [sym_typecast_expression] = STATE(867),
    [sym_for_expression] = STATE(867),
    [sym_while_expression] = STATE(867),
    [sym__if_branch] = STATE(6511),
    [sym_if_expression] = STATE(867),
    [sym_fun_expression] = STATE(867),
    [sym_try_expression] = STATE(867),
    [sym_match_expression] = STATE(867),
    [sym_function_expression] = STATE(867),
    [sym_mutate_expression] = STATE(867),
    [sym_index_expression] = STATE(867),
    [sym_typed_expression] = STATE(867),
    [sym_declaration_expression] = STATE(867),
    [sym_do_expression] = STATE(867),
    [sym_list_expression] = STATE(867),
    [sym_array_expression] = STATE(867),
    [sym_begin_end_expression] = STATE(867),
    [sym_paren_expression] = STATE(867),
    [sym__high_prec_app] = STATE(864),
    [sym__low_prec_app] = STATE(864),
    [sym_application_expression] = STATE(867),
    [sym_dot_expression] = STATE(867),
    [sym_infix_expression] = STATE(867),
    [sym_ce_expression] = STATE(867),
    [sym_sequential_expression] = STATE(867),
    [sym_char] = STATE(868),
    [sym_format_string] = STATE(869),
    [sym__string_literal] = STATE(869),
    [sym_string] = STATE(868),
    [sym_verbatim_string] = STATE(868),
    [sym_bytearray] = STATE(868),
    [sym_verbatim_bytearray] = STATE(868),
    [sym_format_triple_quoted_string] = STATE(870),
    [sym_triple_quoted_string] = STATE(868),
    [sym_const] = STATE(867),
    [sym_long_identifier] = STATE(872),
    [sym_active_pattern] = STATE(871),
    [sym__identifier_or_op] = STATE(873),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(656),
    [sym_infix_op] = STATE(581),
    [sym_sbyte] = STATE(868),
    [sym_byte] = STATE(868),
    [sym_int16] = STATE(868),
    [sym_uint16] = STATE(868),
    [sym_int32] = STATE(868),
    [sym_uint32] = STATE(868),
    [sym_nativeint] = STATE(868),
    [sym_unativeint] = STATE(868),
    [sym_int64] = STATE(868),
    [sym_uint64] = STATE(868),
    [sym_ieee32] = STATE(868),
    [sym_ieee64] = STATE(868),
    [sym_bignum] = STATE(868),
    [sym_decimal] = STATE(868),
    [sym_float] = STATE(1368),
    [sym_block_comment] = STATE(231),
    [sym_compiler_directive_decl] = STATE(231),
    [sym_fsi_directive_decl] = STATE(231),
    [sym_preproc_line] = STATE(231),
    [sym_preproc_if_in_expression] = STATE(867),
    [aux_sym_sequential_expression_repeat1] = STATE(1542),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(29),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(825),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_COMMA] = ACTIONS(827),
    [anon_sym_null] = ACTIONS(49),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACK_PIPE] = ACTIONS(57),
    [anon_sym_LBRACE] = ACTIONS(139),
    [anon_sym_LT_AT] = ACTIONS(61),
    [anon_sym_LT_AT_AT] = ACTIONS(63),
    [anon_sym_DOT] = ACTIONS(65),
    [anon_sym_LBRACE_PIPE] = ACTIONS(67),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_return_BANG] = ACTIONS(829),
    [anon_sym_yield] = ACTIONS(825),
    [anon_sym_yield_BANG] = ACTIONS(829),
    [anon_sym_lazy] = ACTIONS(825),
    [anon_sym_assert] = ACTIONS(825),
    [anon_sym_upcast] = ACTIONS(825),
    [anon_sym_downcast] = ACTIONS(825),
    [anon_sym_COLON_GT] = ACTIONS(71),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(71),
    [anon_sym_for] = ACTIONS(73),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(79),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_match] = ACTIONS(83),
    [anon_sym_match_BANG] = ACTIONS(85),
    [anon_sym_function] = ACTIONS(87),
    [anon_sym_LT_DASH] = ACTIONS(831),
    [anon_sym_DOT_LBRACK] = ACTIONS(91),
    [anon_sym_LT] = ACTIONS(93),
    [anon_sym_use] = ACTIONS(833),
    [anon_sym_use_BANG] = ACTIONS(835),
    [anon_sym_do_BANG] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(101),
    [anon_sym_LPAREN2] = ACTIONS(103),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(105),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(107),
    [anon_sym_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DQUOTE] = ACTIONS(111),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(115),
    [sym_bool] = ACTIONS(117),
    [sym_unit] = ACTIONS(119),
    [anon_sym_LPAREN_PIPE] = ACTIONS(121),
    [sym_op_identifier] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(837),
    [sym_xint] = ACTIONS(387),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(135),
    [sym__newline] = ACTIONS(839),
    [sym__dedent] = ACTIONS(1389),
  },
  [232] = {
    [sym_function_or_value_defn] = STATE(630),
    [sym__expression] = STATE(219),
    [sym_literal_expression] = STATE(2380),
    [sym_long_identifier_or_op] = STATE(2380),
    [sym_tuple_expression] = STATE(2380),
    [sym_brace_expression] = STATE(2380),
    [sym_anon_record_expression] = STATE(2380),
    [sym_prefixed_expression] = STATE(2380),
    [sym_typecast_expression] = STATE(2380),
    [sym_for_expression] = STATE(2380),
    [sym_while_expression] = STATE(2380),
    [sym__if_branch] = STATE(6456),
    [sym_if_expression] = STATE(2380),
    [sym_fun_expression] = STATE(2380),
    [sym_try_expression] = STATE(2380),
    [sym_match_expression] = STATE(2380),
    [sym_function_expression] = STATE(2380),
    [sym_mutate_expression] = STATE(2380),
    [sym_index_expression] = STATE(2380),
    [sym_typed_expression] = STATE(2380),
    [sym_declaration_expression] = STATE(2380),
    [sym_do_expression] = STATE(2380),
    [sym_list_expression] = STATE(2380),
    [sym_array_expression] = STATE(2380),
    [sym_begin_end_expression] = STATE(2380),
    [sym_paren_expression] = STATE(2380),
    [sym__high_prec_app] = STATE(2383),
    [sym__low_prec_app] = STATE(2383),
    [sym_application_expression] = STATE(2380),
    [sym_dot_expression] = STATE(2380),
    [sym_infix_expression] = STATE(2380),
    [sym_ce_expression] = STATE(2380),
    [sym_sequential_expression] = STATE(2380),
    [sym_char] = STATE(2261),
    [sym_format_string] = STATE(2274),
    [sym__string_literal] = STATE(2274),
    [sym_string] = STATE(2261),
    [sym_verbatim_string] = STATE(2261),
    [sym_bytearray] = STATE(2261),
    [sym_verbatim_bytearray] = STATE(2261),
    [sym_format_triple_quoted_string] = STATE(2275),
    [sym_triple_quoted_string] = STATE(2261),
    [sym_const] = STATE(2380),
    [sym_long_identifier] = STATE(2391),
    [sym_active_pattern] = STATE(2470),
    [sym__identifier_or_op] = STATE(2390),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(632),
    [sym_infix_op] = STATE(616),
    [sym_sbyte] = STATE(2261),
    [sym_byte] = STATE(2261),
    [sym_int16] = STATE(2261),
    [sym_uint16] = STATE(2261),
    [sym_int32] = STATE(2261),
    [sym_uint32] = STATE(2261),
    [sym_nativeint] = STATE(2261),
    [sym_unativeint] = STATE(2261),
    [sym_int64] = STATE(2261),
    [sym_uint64] = STATE(2261),
    [sym_ieee32] = STATE(2261),
    [sym_ieee64] = STATE(2261),
    [sym_bignum] = STATE(2261),
    [sym_decimal] = STATE(2261),
    [sym_float] = STATE(1614),
    [sym_block_comment] = STATE(232),
    [sym_compiler_directive_decl] = STATE(232),
    [sym_fsi_directive_decl] = STATE(232),
    [sym_preproc_line] = STATE(232),
    [sym_preproc_if_in_expression] = STATE(2380),
    [aux_sym_sequential_expression_repeat1] = STATE(1882),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(1081),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(1083),
    [anon_sym_return] = ACTIONS(1085),
    [anon_sym_do] = ACTIONS(1087),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(1089),
    [anon_sym_COMMA] = ACTIONS(1091),
    [anon_sym_null] = ACTIONS(1093),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(1083),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1095),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1097),
    [anon_sym_LBRACE] = ACTIONS(1099),
    [anon_sym_LT_AT] = ACTIONS(1101),
    [anon_sym_LT_AT_AT] = ACTIONS(1103),
    [anon_sym_AT_AT_GT] = ACTIONS(173),
    [anon_sym_DOT] = ACTIONS(1105),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1107),
    [anon_sym_new] = ACTIONS(1085),
    [anon_sym_return_BANG] = ACTIONS(1109),
    [anon_sym_yield] = ACTIONS(1085),
    [anon_sym_yield_BANG] = ACTIONS(1109),
    [anon_sym_lazy] = ACTIONS(1085),
    [anon_sym_assert] = ACTIONS(1085),
    [anon_sym_upcast] = ACTIONS(1085),
    [anon_sym_downcast] = ACTIONS(1085),
    [anon_sym_COLON_GT] = ACTIONS(1111),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1111),
    [anon_sym_for] = ACTIONS(1113),
    [anon_sym_while] = ACTIONS(1115),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(1117),
    [anon_sym_try] = ACTIONS(1119),
    [anon_sym_match] = ACTIONS(1121),
    [anon_sym_match_BANG] = ACTIONS(1123),
    [anon_sym_function] = ACTIONS(1125),
    [anon_sym_LT_DASH] = ACTIONS(1127),
    [anon_sym_DOT_LBRACK] = ACTIONS(1129),
    [anon_sym_LT] = ACTIONS(1131),
    [anon_sym_use] = ACTIONS(1133),
    [anon_sym_use_BANG] = ACTIONS(1135),
    [anon_sym_do_BANG] = ACTIONS(1137),
    [anon_sym_begin] = ACTIONS(1139),
    [anon_sym_LPAREN2] = ACTIONS(1141),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(1143),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1145),
    [anon_sym_DQUOTE] = ACTIONS(1147),
    [anon_sym_AT_DQUOTE] = ACTIONS(1149),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1151),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1153),
    [sym_bool] = ACTIONS(1155),
    [sym_unit] = ACTIONS(1157),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1159),
    [sym_op_identifier] = ACTIONS(1161),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(1163),
    [sym_xint] = ACTIONS(1165),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1167),
    [sym__newline] = ACTIONS(1169),
  },
  [233] = {
    [sym_function_or_value_defn] = STATE(600),
    [sym__expression] = STATE(88),
    [sym_literal_expression] = STATE(867),
    [sym_long_identifier_or_op] = STATE(867),
    [sym_tuple_expression] = STATE(867),
    [sym_brace_expression] = STATE(867),
    [sym_anon_record_expression] = STATE(867),
    [sym_prefixed_expression] = STATE(867),
    [sym_typecast_expression] = STATE(867),
    [sym_for_expression] = STATE(867),
    [sym_while_expression] = STATE(867),
    [sym__if_branch] = STATE(6511),
    [sym_if_expression] = STATE(867),
    [sym_fun_expression] = STATE(867),
    [sym_try_expression] = STATE(867),
    [sym_match_expression] = STATE(867),
    [sym_function_expression] = STATE(867),
    [sym_mutate_expression] = STATE(867),
    [sym_index_expression] = STATE(867),
    [sym_typed_expression] = STATE(867),
    [sym_declaration_expression] = STATE(867),
    [sym_do_expression] = STATE(867),
    [sym_list_expression] = STATE(867),
    [sym_array_expression] = STATE(867),
    [sym_begin_end_expression] = STATE(867),
    [sym_paren_expression] = STATE(867),
    [sym__high_prec_app] = STATE(864),
    [sym__low_prec_app] = STATE(864),
    [sym_application_expression] = STATE(867),
    [sym_dot_expression] = STATE(867),
    [sym_infix_expression] = STATE(867),
    [sym_ce_expression] = STATE(867),
    [sym_sequential_expression] = STATE(867),
    [sym_char] = STATE(868),
    [sym_format_string] = STATE(869),
    [sym__string_literal] = STATE(869),
    [sym_string] = STATE(868),
    [sym_verbatim_string] = STATE(868),
    [sym_bytearray] = STATE(868),
    [sym_verbatim_bytearray] = STATE(868),
    [sym_format_triple_quoted_string] = STATE(870),
    [sym_triple_quoted_string] = STATE(868),
    [sym_const] = STATE(867),
    [sym_long_identifier] = STATE(872),
    [sym_active_pattern] = STATE(871),
    [sym__identifier_or_op] = STATE(873),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(656),
    [sym_infix_op] = STATE(581),
    [sym_sbyte] = STATE(868),
    [sym_byte] = STATE(868),
    [sym_int16] = STATE(868),
    [sym_uint16] = STATE(868),
    [sym_int32] = STATE(868),
    [sym_uint32] = STATE(868),
    [sym_nativeint] = STATE(868),
    [sym_unativeint] = STATE(868),
    [sym_int64] = STATE(868),
    [sym_uint64] = STATE(868),
    [sym_ieee32] = STATE(868),
    [sym_ieee64] = STATE(868),
    [sym_bignum] = STATE(868),
    [sym_decimal] = STATE(868),
    [sym_float] = STATE(1368),
    [sym_block_comment] = STATE(233),
    [sym_compiler_directive_decl] = STATE(233),
    [sym_fsi_directive_decl] = STATE(233),
    [sym_preproc_line] = STATE(233),
    [sym_preproc_if_in_expression] = STATE(867),
    [aux_sym_sequential_expression_repeat1] = STATE(1542),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(29),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(825),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_COMMA] = ACTIONS(827),
    [anon_sym_null] = ACTIONS(49),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACK_PIPE] = ACTIONS(57),
    [anon_sym_LBRACE] = ACTIONS(139),
    [anon_sym_LT_AT] = ACTIONS(61),
    [anon_sym_LT_AT_AT] = ACTIONS(63),
    [anon_sym_DOT] = ACTIONS(65),
    [anon_sym_LBRACE_PIPE] = ACTIONS(67),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_return_BANG] = ACTIONS(829),
    [anon_sym_yield] = ACTIONS(825),
    [anon_sym_yield_BANG] = ACTIONS(829),
    [anon_sym_lazy] = ACTIONS(825),
    [anon_sym_assert] = ACTIONS(825),
    [anon_sym_upcast] = ACTIONS(825),
    [anon_sym_downcast] = ACTIONS(825),
    [anon_sym_COLON_GT] = ACTIONS(71),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(71),
    [anon_sym_for] = ACTIONS(73),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(79),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_match] = ACTIONS(83),
    [anon_sym_match_BANG] = ACTIONS(85),
    [anon_sym_function] = ACTIONS(87),
    [anon_sym_LT_DASH] = ACTIONS(831),
    [anon_sym_DOT_LBRACK] = ACTIONS(91),
    [anon_sym_LT] = ACTIONS(93),
    [anon_sym_use] = ACTIONS(833),
    [anon_sym_use_BANG] = ACTIONS(835),
    [anon_sym_do_BANG] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(101),
    [anon_sym_LPAREN2] = ACTIONS(103),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(105),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(107),
    [anon_sym_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DQUOTE] = ACTIONS(111),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(115),
    [sym_bool] = ACTIONS(117),
    [sym_unit] = ACTIONS(119),
    [anon_sym_LPAREN_PIPE] = ACTIONS(121),
    [sym_op_identifier] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(837),
    [sym_xint] = ACTIONS(387),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(135),
    [sym__newline] = ACTIONS(839),
    [sym__dedent] = ACTIONS(1391),
  },
  [234] = {
    [sym_function_or_value_defn] = STATE(600),
    [sym__expression] = STATE(88),
    [sym_literal_expression] = STATE(867),
    [sym_long_identifier_or_op] = STATE(867),
    [sym_tuple_expression] = STATE(867),
    [sym_brace_expression] = STATE(867),
    [sym_anon_record_expression] = STATE(867),
    [sym_prefixed_expression] = STATE(867),
    [sym_typecast_expression] = STATE(867),
    [sym_for_expression] = STATE(867),
    [sym_while_expression] = STATE(867),
    [sym__if_branch] = STATE(6511),
    [sym_if_expression] = STATE(867),
    [sym_fun_expression] = STATE(867),
    [sym_try_expression] = STATE(867),
    [sym_match_expression] = STATE(867),
    [sym_function_expression] = STATE(867),
    [sym_mutate_expression] = STATE(867),
    [sym_index_expression] = STATE(867),
    [sym_typed_expression] = STATE(867),
    [sym_declaration_expression] = STATE(867),
    [sym_do_expression] = STATE(867),
    [sym_list_expression] = STATE(867),
    [sym_array_expression] = STATE(867),
    [sym_begin_end_expression] = STATE(867),
    [sym_paren_expression] = STATE(867),
    [sym__high_prec_app] = STATE(864),
    [sym__low_prec_app] = STATE(864),
    [sym_application_expression] = STATE(867),
    [sym_dot_expression] = STATE(867),
    [sym_infix_expression] = STATE(867),
    [sym_ce_expression] = STATE(867),
    [sym_sequential_expression] = STATE(867),
    [sym_char] = STATE(868),
    [sym_format_string] = STATE(869),
    [sym__string_literal] = STATE(869),
    [sym_string] = STATE(868),
    [sym_verbatim_string] = STATE(868),
    [sym_bytearray] = STATE(868),
    [sym_verbatim_bytearray] = STATE(868),
    [sym_format_triple_quoted_string] = STATE(870),
    [sym_triple_quoted_string] = STATE(868),
    [sym_const] = STATE(867),
    [sym_long_identifier] = STATE(872),
    [sym_active_pattern] = STATE(871),
    [sym__identifier_or_op] = STATE(873),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(656),
    [sym_infix_op] = STATE(581),
    [sym_sbyte] = STATE(868),
    [sym_byte] = STATE(868),
    [sym_int16] = STATE(868),
    [sym_uint16] = STATE(868),
    [sym_int32] = STATE(868),
    [sym_uint32] = STATE(868),
    [sym_nativeint] = STATE(868),
    [sym_unativeint] = STATE(868),
    [sym_int64] = STATE(868),
    [sym_uint64] = STATE(868),
    [sym_ieee32] = STATE(868),
    [sym_ieee64] = STATE(868),
    [sym_bignum] = STATE(868),
    [sym_decimal] = STATE(868),
    [sym_float] = STATE(1368),
    [sym_block_comment] = STATE(234),
    [sym_compiler_directive_decl] = STATE(234),
    [sym_fsi_directive_decl] = STATE(234),
    [sym_preproc_line] = STATE(234),
    [sym_preproc_if_in_expression] = STATE(867),
    [aux_sym_sequential_expression_repeat1] = STATE(1542),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(29),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(825),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_COMMA] = ACTIONS(827),
    [anon_sym_null] = ACTIONS(49),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACK_PIPE] = ACTIONS(57),
    [anon_sym_LBRACE] = ACTIONS(139),
    [anon_sym_LT_AT] = ACTIONS(61),
    [anon_sym_LT_AT_AT] = ACTIONS(63),
    [anon_sym_DOT] = ACTIONS(65),
    [anon_sym_LBRACE_PIPE] = ACTIONS(67),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_return_BANG] = ACTIONS(829),
    [anon_sym_yield] = ACTIONS(825),
    [anon_sym_yield_BANG] = ACTIONS(829),
    [anon_sym_lazy] = ACTIONS(825),
    [anon_sym_assert] = ACTIONS(825),
    [anon_sym_upcast] = ACTIONS(825),
    [anon_sym_downcast] = ACTIONS(825),
    [anon_sym_COLON_GT] = ACTIONS(71),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(71),
    [anon_sym_for] = ACTIONS(73),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(79),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_match] = ACTIONS(83),
    [anon_sym_match_BANG] = ACTIONS(85),
    [anon_sym_function] = ACTIONS(87),
    [anon_sym_LT_DASH] = ACTIONS(831),
    [anon_sym_DOT_LBRACK] = ACTIONS(91),
    [anon_sym_LT] = ACTIONS(93),
    [anon_sym_use] = ACTIONS(833),
    [anon_sym_use_BANG] = ACTIONS(835),
    [anon_sym_do_BANG] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(101),
    [anon_sym_LPAREN2] = ACTIONS(103),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(105),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(107),
    [anon_sym_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DQUOTE] = ACTIONS(111),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(115),
    [sym_bool] = ACTIONS(117),
    [sym_unit] = ACTIONS(119),
    [anon_sym_LPAREN_PIPE] = ACTIONS(121),
    [sym_op_identifier] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(837),
    [sym_xint] = ACTIONS(387),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(135),
    [sym__newline] = ACTIONS(839),
    [sym__dedent] = ACTIONS(1393),
  },
  [235] = {
    [sym_function_or_value_defn] = STATE(600),
    [sym__expression] = STATE(88),
    [sym_literal_expression] = STATE(867),
    [sym_long_identifier_or_op] = STATE(867),
    [sym_tuple_expression] = STATE(867),
    [sym_brace_expression] = STATE(867),
    [sym_anon_record_expression] = STATE(867),
    [sym_prefixed_expression] = STATE(867),
    [sym_typecast_expression] = STATE(867),
    [sym_for_expression] = STATE(867),
    [sym_while_expression] = STATE(867),
    [sym__if_branch] = STATE(6511),
    [sym_if_expression] = STATE(867),
    [sym_fun_expression] = STATE(867),
    [sym_try_expression] = STATE(867),
    [sym_match_expression] = STATE(867),
    [sym_function_expression] = STATE(867),
    [sym_mutate_expression] = STATE(867),
    [sym_index_expression] = STATE(867),
    [sym_typed_expression] = STATE(867),
    [sym_declaration_expression] = STATE(867),
    [sym_do_expression] = STATE(867),
    [sym_list_expression] = STATE(867),
    [sym_array_expression] = STATE(867),
    [sym_begin_end_expression] = STATE(867),
    [sym_paren_expression] = STATE(867),
    [sym__high_prec_app] = STATE(864),
    [sym__low_prec_app] = STATE(864),
    [sym_application_expression] = STATE(867),
    [sym_dot_expression] = STATE(867),
    [sym_infix_expression] = STATE(867),
    [sym_ce_expression] = STATE(867),
    [sym_sequential_expression] = STATE(867),
    [sym_char] = STATE(868),
    [sym_format_string] = STATE(869),
    [sym__string_literal] = STATE(869),
    [sym_string] = STATE(868),
    [sym_verbatim_string] = STATE(868),
    [sym_bytearray] = STATE(868),
    [sym_verbatim_bytearray] = STATE(868),
    [sym_format_triple_quoted_string] = STATE(870),
    [sym_triple_quoted_string] = STATE(868),
    [sym_const] = STATE(867),
    [sym_long_identifier] = STATE(872),
    [sym_active_pattern] = STATE(871),
    [sym__identifier_or_op] = STATE(873),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(656),
    [sym_infix_op] = STATE(581),
    [sym_sbyte] = STATE(868),
    [sym_byte] = STATE(868),
    [sym_int16] = STATE(868),
    [sym_uint16] = STATE(868),
    [sym_int32] = STATE(868),
    [sym_uint32] = STATE(868),
    [sym_nativeint] = STATE(868),
    [sym_unativeint] = STATE(868),
    [sym_int64] = STATE(868),
    [sym_uint64] = STATE(868),
    [sym_ieee32] = STATE(868),
    [sym_ieee64] = STATE(868),
    [sym_bignum] = STATE(868),
    [sym_decimal] = STATE(868),
    [sym_float] = STATE(1368),
    [sym_block_comment] = STATE(235),
    [sym_compiler_directive_decl] = STATE(235),
    [sym_fsi_directive_decl] = STATE(235),
    [sym_preproc_line] = STATE(235),
    [sym_preproc_if_in_expression] = STATE(867),
    [aux_sym_sequential_expression_repeat1] = STATE(1542),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(29),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(825),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_COMMA] = ACTIONS(827),
    [anon_sym_null] = ACTIONS(49),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACK_PIPE] = ACTIONS(57),
    [anon_sym_LBRACE] = ACTIONS(139),
    [anon_sym_LT_AT] = ACTIONS(61),
    [anon_sym_LT_AT_AT] = ACTIONS(63),
    [anon_sym_DOT] = ACTIONS(65),
    [anon_sym_LBRACE_PIPE] = ACTIONS(67),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_return_BANG] = ACTIONS(829),
    [anon_sym_yield] = ACTIONS(825),
    [anon_sym_yield_BANG] = ACTIONS(829),
    [anon_sym_lazy] = ACTIONS(825),
    [anon_sym_assert] = ACTIONS(825),
    [anon_sym_upcast] = ACTIONS(825),
    [anon_sym_downcast] = ACTIONS(825),
    [anon_sym_COLON_GT] = ACTIONS(71),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(71),
    [anon_sym_for] = ACTIONS(73),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(79),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_match] = ACTIONS(83),
    [anon_sym_match_BANG] = ACTIONS(85),
    [anon_sym_function] = ACTIONS(87),
    [anon_sym_LT_DASH] = ACTIONS(831),
    [anon_sym_DOT_LBRACK] = ACTIONS(91),
    [anon_sym_LT] = ACTIONS(93),
    [anon_sym_use] = ACTIONS(833),
    [anon_sym_use_BANG] = ACTIONS(835),
    [anon_sym_do_BANG] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(101),
    [anon_sym_LPAREN2] = ACTIONS(103),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(105),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(107),
    [anon_sym_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DQUOTE] = ACTIONS(111),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(115),
    [sym_bool] = ACTIONS(117),
    [sym_unit] = ACTIONS(119),
    [anon_sym_LPAREN_PIPE] = ACTIONS(121),
    [sym_op_identifier] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(837),
    [sym_xint] = ACTIONS(387),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(135),
    [sym__newline] = ACTIONS(839),
    [sym__dedent] = ACTIONS(1395),
  },
  [236] = {
    [sym_function_or_value_defn] = STATE(600),
    [sym__expression] = STATE(88),
    [sym_literal_expression] = STATE(867),
    [sym_long_identifier_or_op] = STATE(867),
    [sym_tuple_expression] = STATE(867),
    [sym_brace_expression] = STATE(867),
    [sym_anon_record_expression] = STATE(867),
    [sym_prefixed_expression] = STATE(867),
    [sym_typecast_expression] = STATE(867),
    [sym_for_expression] = STATE(867),
    [sym_while_expression] = STATE(867),
    [sym__if_branch] = STATE(6511),
    [sym_if_expression] = STATE(867),
    [sym_fun_expression] = STATE(867),
    [sym_try_expression] = STATE(867),
    [sym_match_expression] = STATE(867),
    [sym_function_expression] = STATE(867),
    [sym_mutate_expression] = STATE(867),
    [sym_index_expression] = STATE(867),
    [sym_typed_expression] = STATE(867),
    [sym_declaration_expression] = STATE(867),
    [sym_do_expression] = STATE(867),
    [sym_list_expression] = STATE(867),
    [sym_array_expression] = STATE(867),
    [sym_begin_end_expression] = STATE(867),
    [sym_paren_expression] = STATE(867),
    [sym__high_prec_app] = STATE(864),
    [sym__low_prec_app] = STATE(864),
    [sym_application_expression] = STATE(867),
    [sym_dot_expression] = STATE(867),
    [sym_infix_expression] = STATE(867),
    [sym_ce_expression] = STATE(867),
    [sym_sequential_expression] = STATE(867),
    [sym_char] = STATE(868),
    [sym_format_string] = STATE(869),
    [sym__string_literal] = STATE(869),
    [sym_string] = STATE(868),
    [sym_verbatim_string] = STATE(868),
    [sym_bytearray] = STATE(868),
    [sym_verbatim_bytearray] = STATE(868),
    [sym_format_triple_quoted_string] = STATE(870),
    [sym_triple_quoted_string] = STATE(868),
    [sym_const] = STATE(867),
    [sym_long_identifier] = STATE(872),
    [sym_active_pattern] = STATE(871),
    [sym__identifier_or_op] = STATE(873),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(656),
    [sym_infix_op] = STATE(581),
    [sym_sbyte] = STATE(868),
    [sym_byte] = STATE(868),
    [sym_int16] = STATE(868),
    [sym_uint16] = STATE(868),
    [sym_int32] = STATE(868),
    [sym_uint32] = STATE(868),
    [sym_nativeint] = STATE(868),
    [sym_unativeint] = STATE(868),
    [sym_int64] = STATE(868),
    [sym_uint64] = STATE(868),
    [sym_ieee32] = STATE(868),
    [sym_ieee64] = STATE(868),
    [sym_bignum] = STATE(868),
    [sym_decimal] = STATE(868),
    [sym_float] = STATE(1368),
    [sym_block_comment] = STATE(236),
    [sym_compiler_directive_decl] = STATE(236),
    [sym_fsi_directive_decl] = STATE(236),
    [sym_preproc_line] = STATE(236),
    [sym_preproc_if_in_expression] = STATE(867),
    [aux_sym_sequential_expression_repeat1] = STATE(1542),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(29),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(825),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_COMMA] = ACTIONS(827),
    [anon_sym_null] = ACTIONS(49),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACK_PIPE] = ACTIONS(57),
    [anon_sym_LBRACE] = ACTIONS(139),
    [anon_sym_LT_AT] = ACTIONS(61),
    [anon_sym_LT_AT_AT] = ACTIONS(63),
    [anon_sym_DOT] = ACTIONS(65),
    [anon_sym_LBRACE_PIPE] = ACTIONS(67),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_return_BANG] = ACTIONS(829),
    [anon_sym_yield] = ACTIONS(825),
    [anon_sym_yield_BANG] = ACTIONS(829),
    [anon_sym_lazy] = ACTIONS(825),
    [anon_sym_assert] = ACTIONS(825),
    [anon_sym_upcast] = ACTIONS(825),
    [anon_sym_downcast] = ACTIONS(825),
    [anon_sym_COLON_GT] = ACTIONS(71),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(71),
    [anon_sym_for] = ACTIONS(73),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(79),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_match] = ACTIONS(83),
    [anon_sym_match_BANG] = ACTIONS(85),
    [anon_sym_function] = ACTIONS(87),
    [anon_sym_LT_DASH] = ACTIONS(831),
    [anon_sym_DOT_LBRACK] = ACTIONS(91),
    [anon_sym_LT] = ACTIONS(93),
    [anon_sym_use] = ACTIONS(833),
    [anon_sym_use_BANG] = ACTIONS(835),
    [anon_sym_do_BANG] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(101),
    [anon_sym_LPAREN2] = ACTIONS(103),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(105),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(107),
    [anon_sym_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DQUOTE] = ACTIONS(111),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(115),
    [sym_bool] = ACTIONS(117),
    [sym_unit] = ACTIONS(119),
    [anon_sym_LPAREN_PIPE] = ACTIONS(121),
    [sym_op_identifier] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(837),
    [sym_xint] = ACTIONS(387),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(135),
    [sym__newline] = ACTIONS(839),
    [sym__dedent] = ACTIONS(1397),
  },
  [237] = {
    [sym_function_or_value_defn] = STATE(600),
    [sym__expression] = STATE(88),
    [sym_literal_expression] = STATE(867),
    [sym_long_identifier_or_op] = STATE(867),
    [sym_tuple_expression] = STATE(867),
    [sym_brace_expression] = STATE(867),
    [sym_anon_record_expression] = STATE(867),
    [sym_prefixed_expression] = STATE(867),
    [sym_typecast_expression] = STATE(867),
    [sym_for_expression] = STATE(867),
    [sym_while_expression] = STATE(867),
    [sym__if_branch] = STATE(6511),
    [sym_if_expression] = STATE(867),
    [sym_fun_expression] = STATE(867),
    [sym_try_expression] = STATE(867),
    [sym_match_expression] = STATE(867),
    [sym_function_expression] = STATE(867),
    [sym_mutate_expression] = STATE(867),
    [sym_index_expression] = STATE(867),
    [sym_typed_expression] = STATE(867),
    [sym_declaration_expression] = STATE(867),
    [sym_do_expression] = STATE(867),
    [sym_list_expression] = STATE(867),
    [sym_array_expression] = STATE(867),
    [sym_begin_end_expression] = STATE(867),
    [sym_paren_expression] = STATE(867),
    [sym__high_prec_app] = STATE(864),
    [sym__low_prec_app] = STATE(864),
    [sym_application_expression] = STATE(867),
    [sym_dot_expression] = STATE(867),
    [sym_infix_expression] = STATE(867),
    [sym_ce_expression] = STATE(867),
    [sym_sequential_expression] = STATE(867),
    [sym_char] = STATE(868),
    [sym_format_string] = STATE(869),
    [sym__string_literal] = STATE(869),
    [sym_string] = STATE(868),
    [sym_verbatim_string] = STATE(868),
    [sym_bytearray] = STATE(868),
    [sym_verbatim_bytearray] = STATE(868),
    [sym_format_triple_quoted_string] = STATE(870),
    [sym_triple_quoted_string] = STATE(868),
    [sym_const] = STATE(867),
    [sym_long_identifier] = STATE(872),
    [sym_active_pattern] = STATE(871),
    [sym__identifier_or_op] = STATE(873),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(656),
    [sym_infix_op] = STATE(581),
    [sym_sbyte] = STATE(868),
    [sym_byte] = STATE(868),
    [sym_int16] = STATE(868),
    [sym_uint16] = STATE(868),
    [sym_int32] = STATE(868),
    [sym_uint32] = STATE(868),
    [sym_nativeint] = STATE(868),
    [sym_unativeint] = STATE(868),
    [sym_int64] = STATE(868),
    [sym_uint64] = STATE(868),
    [sym_ieee32] = STATE(868),
    [sym_ieee64] = STATE(868),
    [sym_bignum] = STATE(868),
    [sym_decimal] = STATE(868),
    [sym_float] = STATE(1368),
    [sym_block_comment] = STATE(237),
    [sym_compiler_directive_decl] = STATE(237),
    [sym_fsi_directive_decl] = STATE(237),
    [sym_preproc_line] = STATE(237),
    [sym_preproc_if_in_expression] = STATE(867),
    [aux_sym_sequential_expression_repeat1] = STATE(1542),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(29),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(825),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_COMMA] = ACTIONS(827),
    [anon_sym_null] = ACTIONS(49),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACK_PIPE] = ACTIONS(57),
    [anon_sym_LBRACE] = ACTIONS(139),
    [anon_sym_LT_AT] = ACTIONS(61),
    [anon_sym_LT_AT_AT] = ACTIONS(63),
    [anon_sym_DOT] = ACTIONS(65),
    [anon_sym_LBRACE_PIPE] = ACTIONS(67),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_return_BANG] = ACTIONS(829),
    [anon_sym_yield] = ACTIONS(825),
    [anon_sym_yield_BANG] = ACTIONS(829),
    [anon_sym_lazy] = ACTIONS(825),
    [anon_sym_assert] = ACTIONS(825),
    [anon_sym_upcast] = ACTIONS(825),
    [anon_sym_downcast] = ACTIONS(825),
    [anon_sym_COLON_GT] = ACTIONS(71),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(71),
    [anon_sym_for] = ACTIONS(73),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(79),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_match] = ACTIONS(83),
    [anon_sym_match_BANG] = ACTIONS(85),
    [anon_sym_function] = ACTIONS(87),
    [anon_sym_LT_DASH] = ACTIONS(831),
    [anon_sym_DOT_LBRACK] = ACTIONS(91),
    [anon_sym_LT] = ACTIONS(93),
    [anon_sym_use] = ACTIONS(833),
    [anon_sym_use_BANG] = ACTIONS(835),
    [anon_sym_do_BANG] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(101),
    [anon_sym_LPAREN2] = ACTIONS(103),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(105),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(107),
    [anon_sym_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DQUOTE] = ACTIONS(111),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(115),
    [sym_bool] = ACTIONS(117),
    [sym_unit] = ACTIONS(119),
    [anon_sym_LPAREN_PIPE] = ACTIONS(121),
    [sym_op_identifier] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(837),
    [sym_xint] = ACTIONS(387),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(135),
    [sym__newline] = ACTIONS(839),
    [sym__dedent] = ACTIONS(1399),
  },
  [238] = {
    [sym_function_or_value_defn] = STATE(651),
    [sym__expression] = STATE(167),
    [sym_literal_expression] = STATE(2168),
    [sym_long_identifier_or_op] = STATE(2168),
    [sym_tuple_expression] = STATE(2168),
    [sym_brace_expression] = STATE(2168),
    [sym_anon_record_expression] = STATE(2168),
    [sym_prefixed_expression] = STATE(2168),
    [sym_typecast_expression] = STATE(2168),
    [sym_for_expression] = STATE(2168),
    [sym_while_expression] = STATE(2168),
    [sym__if_branch] = STATE(6406),
    [sym_if_expression] = STATE(2168),
    [sym_fun_expression] = STATE(2168),
    [sym_try_expression] = STATE(2168),
    [sym_match_expression] = STATE(2168),
    [sym_function_expression] = STATE(2168),
    [sym_mutate_expression] = STATE(2168),
    [sym_index_expression] = STATE(2168),
    [sym_typed_expression] = STATE(2168),
    [sym_declaration_expression] = STATE(2168),
    [sym_do_expression] = STATE(2168),
    [sym_list_expression] = STATE(2168),
    [sym_array_expression] = STATE(2168),
    [sym_begin_end_expression] = STATE(2168),
    [sym_paren_expression] = STATE(2168),
    [sym__high_prec_app] = STATE(2179),
    [sym__low_prec_app] = STATE(2179),
    [sym_application_expression] = STATE(2168),
    [sym_dot_expression] = STATE(2168),
    [sym_infix_expression] = STATE(2168),
    [sym_ce_expression] = STATE(2168),
    [sym_sequential_expression] = STATE(2168),
    [sym_char] = STATE(2469),
    [sym_format_string] = STATE(2412),
    [sym__string_literal] = STATE(2412),
    [sym_string] = STATE(2469),
    [sym_verbatim_string] = STATE(2469),
    [sym_bytearray] = STATE(2469),
    [sym_verbatim_bytearray] = STATE(2469),
    [sym_format_triple_quoted_string] = STATE(2408),
    [sym_triple_quoted_string] = STATE(2469),
    [sym_const] = STATE(2168),
    [sym_long_identifier] = STATE(2183),
    [sym_active_pattern] = STATE(2182),
    [sym__identifier_or_op] = STATE(2093),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(650),
    [sym_infix_op] = STATE(721),
    [sym_sbyte] = STATE(2469),
    [sym_byte] = STATE(2469),
    [sym_int16] = STATE(2469),
    [sym_uint16] = STATE(2469),
    [sym_int32] = STATE(2469),
    [sym_uint32] = STATE(2469),
    [sym_nativeint] = STATE(2469),
    [sym_unativeint] = STATE(2469),
    [sym_int64] = STATE(2469),
    [sym_uint64] = STATE(2469),
    [sym_ieee32] = STATE(2469),
    [sym_ieee64] = STATE(2469),
    [sym_bignum] = STATE(2469),
    [sym_decimal] = STATE(2469),
    [sym_float] = STATE(1586),
    [sym_block_comment] = STATE(238),
    [sym_compiler_directive_decl] = STATE(238),
    [sym_fsi_directive_decl] = STATE(238),
    [sym_preproc_line] = STATE(238),
    [sym_preproc_if_in_expression] = STATE(2168),
    [aux_sym_sequential_expression_repeat1] = STATE(1755),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(989),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(991),
    [anon_sym_return] = ACTIONS(993),
    [anon_sym_do] = ACTIONS(995),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(997),
    [anon_sym_COMMA] = ACTIONS(999),
    [anon_sym_null] = ACTIONS(1001),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(991),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1003),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1005),
    [anon_sym_LBRACE] = ACTIONS(1007),
    [anon_sym_LT_AT] = ACTIONS(1009),
    [anon_sym_AT_GT] = ACTIONS(1401),
    [anon_sym_LT_AT_AT] = ACTIONS(1013),
    [anon_sym_DOT] = ACTIONS(1015),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1017),
    [anon_sym_new] = ACTIONS(993),
    [anon_sym_return_BANG] = ACTIONS(1019),
    [anon_sym_yield] = ACTIONS(993),
    [anon_sym_yield_BANG] = ACTIONS(1019),
    [anon_sym_lazy] = ACTIONS(993),
    [anon_sym_assert] = ACTIONS(993),
    [anon_sym_upcast] = ACTIONS(993),
    [anon_sym_downcast] = ACTIONS(993),
    [anon_sym_COLON_GT] = ACTIONS(1021),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1021),
    [anon_sym_for] = ACTIONS(1023),
    [anon_sym_while] = ACTIONS(1025),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(1027),
    [anon_sym_try] = ACTIONS(1029),
    [anon_sym_match] = ACTIONS(1031),
    [anon_sym_match_BANG] = ACTIONS(1033),
    [anon_sym_function] = ACTIONS(1035),
    [anon_sym_LT_DASH] = ACTIONS(1037),
    [anon_sym_DOT_LBRACK] = ACTIONS(1039),
    [anon_sym_LT] = ACTIONS(1041),
    [anon_sym_use] = ACTIONS(1043),
    [anon_sym_use_BANG] = ACTIONS(1045),
    [anon_sym_do_BANG] = ACTIONS(1047),
    [anon_sym_begin] = ACTIONS(1049),
    [anon_sym_LPAREN2] = ACTIONS(1051),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(1053),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1055),
    [anon_sym_DQUOTE] = ACTIONS(1057),
    [anon_sym_AT_DQUOTE] = ACTIONS(1059),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1061),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1063),
    [sym_bool] = ACTIONS(1065),
    [sym_unit] = ACTIONS(1067),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1069),
    [sym_op_identifier] = ACTIONS(1071),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(1073),
    [sym_xint] = ACTIONS(1075),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1077),
    [sym__newline] = ACTIONS(1079),
  },
  [239] = {
    [sym_function_or_value_defn] = STATE(630),
    [sym__expression] = STATE(219),
    [sym_literal_expression] = STATE(2380),
    [sym_long_identifier_or_op] = STATE(2380),
    [sym_tuple_expression] = STATE(2380),
    [sym_brace_expression] = STATE(2380),
    [sym_anon_record_expression] = STATE(2380),
    [sym_prefixed_expression] = STATE(2380),
    [sym_typecast_expression] = STATE(2380),
    [sym_for_expression] = STATE(2380),
    [sym_while_expression] = STATE(2380),
    [sym__if_branch] = STATE(6456),
    [sym_if_expression] = STATE(2380),
    [sym_fun_expression] = STATE(2380),
    [sym_try_expression] = STATE(2380),
    [sym_match_expression] = STATE(2380),
    [sym_function_expression] = STATE(2380),
    [sym_mutate_expression] = STATE(2380),
    [sym_index_expression] = STATE(2380),
    [sym_typed_expression] = STATE(2380),
    [sym_declaration_expression] = STATE(2380),
    [sym_do_expression] = STATE(2380),
    [sym_list_expression] = STATE(2380),
    [sym_array_expression] = STATE(2380),
    [sym_begin_end_expression] = STATE(2380),
    [sym_paren_expression] = STATE(2380),
    [sym__high_prec_app] = STATE(2383),
    [sym__low_prec_app] = STATE(2383),
    [sym_application_expression] = STATE(2380),
    [sym_dot_expression] = STATE(2380),
    [sym_infix_expression] = STATE(2380),
    [sym_ce_expression] = STATE(2380),
    [sym_sequential_expression] = STATE(2380),
    [sym_char] = STATE(2261),
    [sym_format_string] = STATE(2274),
    [sym__string_literal] = STATE(2274),
    [sym_string] = STATE(2261),
    [sym_verbatim_string] = STATE(2261),
    [sym_bytearray] = STATE(2261),
    [sym_verbatim_bytearray] = STATE(2261),
    [sym_format_triple_quoted_string] = STATE(2275),
    [sym_triple_quoted_string] = STATE(2261),
    [sym_const] = STATE(2380),
    [sym_long_identifier] = STATE(2391),
    [sym_active_pattern] = STATE(2470),
    [sym__identifier_or_op] = STATE(2390),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(632),
    [sym_infix_op] = STATE(616),
    [sym_sbyte] = STATE(2261),
    [sym_byte] = STATE(2261),
    [sym_int16] = STATE(2261),
    [sym_uint16] = STATE(2261),
    [sym_int32] = STATE(2261),
    [sym_uint32] = STATE(2261),
    [sym_nativeint] = STATE(2261),
    [sym_unativeint] = STATE(2261),
    [sym_int64] = STATE(2261),
    [sym_uint64] = STATE(2261),
    [sym_ieee32] = STATE(2261),
    [sym_ieee64] = STATE(2261),
    [sym_bignum] = STATE(2261),
    [sym_decimal] = STATE(2261),
    [sym_float] = STATE(1614),
    [sym_block_comment] = STATE(239),
    [sym_compiler_directive_decl] = STATE(239),
    [sym_fsi_directive_decl] = STATE(239),
    [sym_preproc_line] = STATE(239),
    [sym_preproc_if_in_expression] = STATE(2380),
    [aux_sym_sequential_expression_repeat1] = STATE(1882),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(1081),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(1083),
    [anon_sym_return] = ACTIONS(1085),
    [anon_sym_do] = ACTIONS(1087),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(1089),
    [anon_sym_COMMA] = ACTIONS(1091),
    [anon_sym_null] = ACTIONS(1093),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(1083),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1095),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1097),
    [anon_sym_LBRACE] = ACTIONS(1099),
    [anon_sym_LT_AT] = ACTIONS(1101),
    [anon_sym_LT_AT_AT] = ACTIONS(1103),
    [anon_sym_AT_AT_GT] = ACTIONS(1401),
    [anon_sym_DOT] = ACTIONS(1105),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1107),
    [anon_sym_new] = ACTIONS(1085),
    [anon_sym_return_BANG] = ACTIONS(1109),
    [anon_sym_yield] = ACTIONS(1085),
    [anon_sym_yield_BANG] = ACTIONS(1109),
    [anon_sym_lazy] = ACTIONS(1085),
    [anon_sym_assert] = ACTIONS(1085),
    [anon_sym_upcast] = ACTIONS(1085),
    [anon_sym_downcast] = ACTIONS(1085),
    [anon_sym_COLON_GT] = ACTIONS(1111),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1111),
    [anon_sym_for] = ACTIONS(1113),
    [anon_sym_while] = ACTIONS(1115),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(1117),
    [anon_sym_try] = ACTIONS(1119),
    [anon_sym_match] = ACTIONS(1121),
    [anon_sym_match_BANG] = ACTIONS(1123),
    [anon_sym_function] = ACTIONS(1125),
    [anon_sym_LT_DASH] = ACTIONS(1127),
    [anon_sym_DOT_LBRACK] = ACTIONS(1129),
    [anon_sym_LT] = ACTIONS(1131),
    [anon_sym_use] = ACTIONS(1133),
    [anon_sym_use_BANG] = ACTIONS(1135),
    [anon_sym_do_BANG] = ACTIONS(1137),
    [anon_sym_begin] = ACTIONS(1139),
    [anon_sym_LPAREN2] = ACTIONS(1141),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(1143),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1145),
    [anon_sym_DQUOTE] = ACTIONS(1147),
    [anon_sym_AT_DQUOTE] = ACTIONS(1149),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1151),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1153),
    [sym_bool] = ACTIONS(1155),
    [sym_unit] = ACTIONS(1157),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1159),
    [sym_op_identifier] = ACTIONS(1161),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(1163),
    [sym_xint] = ACTIONS(1165),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1167),
    [sym__newline] = ACTIONS(1169),
  },
  [240] = {
    [sym_function_or_value_defn] = STATE(733),
    [sym__expression] = STATE(142),
    [sym_literal_expression] = STATE(2008),
    [sym_long_identifier_or_op] = STATE(2008),
    [sym_tuple_expression] = STATE(2008),
    [sym_brace_expression] = STATE(2008),
    [sym_anon_record_expression] = STATE(2008),
    [sym_prefixed_expression] = STATE(2008),
    [sym_typecast_expression] = STATE(2008),
    [sym_for_expression] = STATE(2008),
    [sym_while_expression] = STATE(2008),
    [sym__if_branch] = STATE(6754),
    [sym_if_expression] = STATE(2008),
    [sym_fun_expression] = STATE(2008),
    [sym_try_expression] = STATE(2008),
    [sym_match_expression] = STATE(2008),
    [sym_function_expression] = STATE(2008),
    [sym_mutate_expression] = STATE(2008),
    [sym_index_expression] = STATE(2008),
    [sym_typed_expression] = STATE(2008),
    [sym_declaration_expression] = STATE(2008),
    [sym_do_expression] = STATE(2008),
    [sym_list_expression] = STATE(2008),
    [sym_array_expression] = STATE(2008),
    [sym_begin_end_expression] = STATE(2008),
    [sym_paren_expression] = STATE(2008),
    [sym__high_prec_app] = STATE(2007),
    [sym__low_prec_app] = STATE(2007),
    [sym_application_expression] = STATE(2008),
    [sym_dot_expression] = STATE(2008),
    [sym_infix_expression] = STATE(2008),
    [sym_ce_expression] = STATE(2008),
    [sym_sequential_expression] = STATE(2008),
    [sym_char] = STATE(1859),
    [sym_format_string] = STATE(1861),
    [sym__string_literal] = STATE(1861),
    [sym_string] = STATE(1859),
    [sym_verbatim_string] = STATE(1859),
    [sym_bytearray] = STATE(1859),
    [sym_verbatim_bytearray] = STATE(1859),
    [sym_format_triple_quoted_string] = STATE(1862),
    [sym_triple_quoted_string] = STATE(1859),
    [sym_const] = STATE(2008),
    [sym_long_identifier] = STATE(1701),
    [sym_active_pattern] = STATE(1702),
    [sym__identifier_or_op] = STATE(1724),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(706),
    [sym_infix_op] = STATE(678),
    [sym_sbyte] = STATE(1859),
    [sym_byte] = STATE(1859),
    [sym_int16] = STATE(1859),
    [sym_uint16] = STATE(1859),
    [sym_int32] = STATE(1859),
    [sym_uint32] = STATE(1859),
    [sym_nativeint] = STATE(1859),
    [sym_unativeint] = STATE(1859),
    [sym_int64] = STATE(1859),
    [sym_uint64] = STATE(1859),
    [sym_ieee32] = STATE(1859),
    [sym_ieee64] = STATE(1859),
    [sym_bignum] = STATE(1859),
    [sym_decimal] = STATE(1859),
    [sym_float] = STATE(1447),
    [sym_block_comment] = STATE(240),
    [sym_compiler_directive_decl] = STATE(240),
    [sym_fsi_directive_decl] = STATE(240),
    [sym_preproc_line] = STATE(240),
    [sym_preproc_if_in_expression] = STATE(2008),
    [aux_sym_sequential_expression_repeat1] = STATE(1995),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(503),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(969),
    [anon_sym_return] = ACTIONS(971),
    [anon_sym_do] = ACTIONS(599),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(511),
    [anon_sym_COMMA] = ACTIONS(973),
    [anon_sym_null] = ACTIONS(515),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(969),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(517),
    [anon_sym_LBRACK_PIPE] = ACTIONS(519),
    [anon_sym_LBRACE] = ACTIONS(521),
    [anon_sym_LT_AT] = ACTIONS(523),
    [anon_sym_LT_AT_AT] = ACTIONS(525),
    [anon_sym_DOT] = ACTIONS(527),
    [anon_sym_LBRACE_PIPE] = ACTIONS(529),
    [anon_sym_new] = ACTIONS(971),
    [anon_sym_return_BANG] = ACTIONS(975),
    [anon_sym_yield] = ACTIONS(971),
    [anon_sym_yield_BANG] = ACTIONS(975),
    [anon_sym_lazy] = ACTIONS(971),
    [anon_sym_assert] = ACTIONS(971),
    [anon_sym_upcast] = ACTIONS(971),
    [anon_sym_downcast] = ACTIONS(971),
    [anon_sym_COLON_GT] = ACTIONS(977),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(977),
    [anon_sym_for] = ACTIONS(979),
    [anon_sym_while] = ACTIONS(537),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(539),
    [anon_sym_DASH_GT] = ACTIONS(1403),
    [anon_sym_try] = ACTIONS(543),
    [anon_sym_match] = ACTIONS(545),
    [anon_sym_match_BANG] = ACTIONS(547),
    [anon_sym_function] = ACTIONS(549),
    [anon_sym_LT_DASH] = ACTIONS(981),
    [anon_sym_DOT_LBRACK] = ACTIONS(553),
    [anon_sym_LT] = ACTIONS(555),
    [anon_sym_use] = ACTIONS(983),
    [anon_sym_use_BANG] = ACTIONS(985),
    [anon_sym_do_BANG] = ACTIONS(561),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_LPAREN2] = ACTIONS(567),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(569),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(571),
    [anon_sym_DQUOTE] = ACTIONS(573),
    [anon_sym_AT_DQUOTE] = ACTIONS(575),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(577),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(579),
    [sym_bool] = ACTIONS(581),
    [sym_unit] = ACTIONS(583),
    [anon_sym_LPAREN_PIPE] = ACTIONS(585),
    [sym_op_identifier] = ACTIONS(587),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(591),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(593),
    [sym__newline] = ACTIONS(1171),
  },
  [241] = {
    [sym_function_or_value_defn] = STATE(600),
    [sym__expression] = STATE(88),
    [sym_literal_expression] = STATE(867),
    [sym_long_identifier_or_op] = STATE(867),
    [sym_tuple_expression] = STATE(867),
    [sym_brace_expression] = STATE(867),
    [sym_anon_record_expression] = STATE(867),
    [sym_prefixed_expression] = STATE(867),
    [sym_typecast_expression] = STATE(867),
    [sym_for_expression] = STATE(867),
    [sym_while_expression] = STATE(867),
    [sym__if_branch] = STATE(6511),
    [sym_if_expression] = STATE(867),
    [sym_fun_expression] = STATE(867),
    [sym_try_expression] = STATE(867),
    [sym_match_expression] = STATE(867),
    [sym_function_expression] = STATE(867),
    [sym_mutate_expression] = STATE(867),
    [sym_index_expression] = STATE(867),
    [sym_typed_expression] = STATE(867),
    [sym_declaration_expression] = STATE(867),
    [sym_do_expression] = STATE(867),
    [sym_list_expression] = STATE(867),
    [sym_array_expression] = STATE(867),
    [sym_begin_end_expression] = STATE(867),
    [sym_paren_expression] = STATE(867),
    [sym__high_prec_app] = STATE(864),
    [sym__low_prec_app] = STATE(864),
    [sym_application_expression] = STATE(867),
    [sym_dot_expression] = STATE(867),
    [sym_infix_expression] = STATE(867),
    [sym_ce_expression] = STATE(867),
    [sym_sequential_expression] = STATE(867),
    [sym_char] = STATE(868),
    [sym_format_string] = STATE(869),
    [sym__string_literal] = STATE(869),
    [sym_string] = STATE(868),
    [sym_verbatim_string] = STATE(868),
    [sym_bytearray] = STATE(868),
    [sym_verbatim_bytearray] = STATE(868),
    [sym_format_triple_quoted_string] = STATE(870),
    [sym_triple_quoted_string] = STATE(868),
    [sym_const] = STATE(867),
    [sym_long_identifier] = STATE(872),
    [sym_active_pattern] = STATE(871),
    [sym__identifier_or_op] = STATE(873),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(656),
    [sym_infix_op] = STATE(581),
    [sym_sbyte] = STATE(868),
    [sym_byte] = STATE(868),
    [sym_int16] = STATE(868),
    [sym_uint16] = STATE(868),
    [sym_int32] = STATE(868),
    [sym_uint32] = STATE(868),
    [sym_nativeint] = STATE(868),
    [sym_unativeint] = STATE(868),
    [sym_int64] = STATE(868),
    [sym_uint64] = STATE(868),
    [sym_ieee32] = STATE(868),
    [sym_ieee64] = STATE(868),
    [sym_bignum] = STATE(868),
    [sym_decimal] = STATE(868),
    [sym_float] = STATE(1368),
    [sym_block_comment] = STATE(241),
    [sym_compiler_directive_decl] = STATE(241),
    [sym_fsi_directive_decl] = STATE(241),
    [sym_preproc_line] = STATE(241),
    [sym_preproc_if_in_expression] = STATE(867),
    [aux_sym_sequential_expression_repeat1] = STATE(1542),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(29),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(825),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_COMMA] = ACTIONS(827),
    [anon_sym_null] = ACTIONS(49),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACK_PIPE] = ACTIONS(57),
    [anon_sym_LBRACE] = ACTIONS(139),
    [anon_sym_LT_AT] = ACTIONS(61),
    [anon_sym_LT_AT_AT] = ACTIONS(63),
    [anon_sym_DOT] = ACTIONS(65),
    [anon_sym_LBRACE_PIPE] = ACTIONS(67),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_return_BANG] = ACTIONS(829),
    [anon_sym_yield] = ACTIONS(825),
    [anon_sym_yield_BANG] = ACTIONS(829),
    [anon_sym_lazy] = ACTIONS(825),
    [anon_sym_assert] = ACTIONS(825),
    [anon_sym_upcast] = ACTIONS(825),
    [anon_sym_downcast] = ACTIONS(825),
    [anon_sym_COLON_GT] = ACTIONS(71),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(71),
    [anon_sym_for] = ACTIONS(73),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(79),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_match] = ACTIONS(83),
    [anon_sym_match_BANG] = ACTIONS(85),
    [anon_sym_function] = ACTIONS(87),
    [anon_sym_LT_DASH] = ACTIONS(831),
    [anon_sym_DOT_LBRACK] = ACTIONS(91),
    [anon_sym_LT] = ACTIONS(93),
    [anon_sym_use] = ACTIONS(833),
    [anon_sym_use_BANG] = ACTIONS(835),
    [anon_sym_do_BANG] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(101),
    [anon_sym_LPAREN2] = ACTIONS(103),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(105),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(107),
    [anon_sym_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DQUOTE] = ACTIONS(111),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(115),
    [sym_bool] = ACTIONS(117),
    [sym_unit] = ACTIONS(119),
    [anon_sym_LPAREN_PIPE] = ACTIONS(121),
    [sym_op_identifier] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(837),
    [sym_xint] = ACTIONS(387),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(135),
    [sym__newline] = ACTIONS(839),
    [sym__dedent] = ACTIONS(1405),
  },
  [242] = {
    [sym_function_or_value_defn] = STATE(600),
    [sym__expression] = STATE(88),
    [sym_literal_expression] = STATE(867),
    [sym_long_identifier_or_op] = STATE(867),
    [sym_tuple_expression] = STATE(867),
    [sym_brace_expression] = STATE(867),
    [sym_anon_record_expression] = STATE(867),
    [sym_prefixed_expression] = STATE(867),
    [sym_typecast_expression] = STATE(867),
    [sym_for_expression] = STATE(867),
    [sym_while_expression] = STATE(867),
    [sym__if_branch] = STATE(6511),
    [sym_if_expression] = STATE(867),
    [sym_fun_expression] = STATE(867),
    [sym_try_expression] = STATE(867),
    [sym_match_expression] = STATE(867),
    [sym_function_expression] = STATE(867),
    [sym_mutate_expression] = STATE(867),
    [sym_index_expression] = STATE(867),
    [sym_typed_expression] = STATE(867),
    [sym_declaration_expression] = STATE(867),
    [sym_do_expression] = STATE(867),
    [sym_list_expression] = STATE(867),
    [sym_array_expression] = STATE(867),
    [sym_begin_end_expression] = STATE(867),
    [sym_paren_expression] = STATE(867),
    [sym__high_prec_app] = STATE(864),
    [sym__low_prec_app] = STATE(864),
    [sym_application_expression] = STATE(867),
    [sym_dot_expression] = STATE(867),
    [sym_infix_expression] = STATE(867),
    [sym_ce_expression] = STATE(867),
    [sym_sequential_expression] = STATE(867),
    [sym_char] = STATE(868),
    [sym_format_string] = STATE(869),
    [sym__string_literal] = STATE(869),
    [sym_string] = STATE(868),
    [sym_verbatim_string] = STATE(868),
    [sym_bytearray] = STATE(868),
    [sym_verbatim_bytearray] = STATE(868),
    [sym_format_triple_quoted_string] = STATE(870),
    [sym_triple_quoted_string] = STATE(868),
    [sym_const] = STATE(867),
    [sym_long_identifier] = STATE(872),
    [sym_active_pattern] = STATE(871),
    [sym__identifier_or_op] = STATE(873),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(656),
    [sym_infix_op] = STATE(581),
    [sym_sbyte] = STATE(868),
    [sym_byte] = STATE(868),
    [sym_int16] = STATE(868),
    [sym_uint16] = STATE(868),
    [sym_int32] = STATE(868),
    [sym_uint32] = STATE(868),
    [sym_nativeint] = STATE(868),
    [sym_unativeint] = STATE(868),
    [sym_int64] = STATE(868),
    [sym_uint64] = STATE(868),
    [sym_ieee32] = STATE(868),
    [sym_ieee64] = STATE(868),
    [sym_bignum] = STATE(868),
    [sym_decimal] = STATE(868),
    [sym_float] = STATE(1368),
    [sym_block_comment] = STATE(242),
    [sym_compiler_directive_decl] = STATE(242),
    [sym_fsi_directive_decl] = STATE(242),
    [sym_preproc_line] = STATE(242),
    [sym_preproc_if_in_expression] = STATE(867),
    [aux_sym_sequential_expression_repeat1] = STATE(1542),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(29),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(825),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_COMMA] = ACTIONS(827),
    [anon_sym_null] = ACTIONS(49),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACK_PIPE] = ACTIONS(57),
    [anon_sym_LBRACE] = ACTIONS(139),
    [anon_sym_LT_AT] = ACTIONS(61),
    [anon_sym_LT_AT_AT] = ACTIONS(63),
    [anon_sym_DOT] = ACTIONS(65),
    [anon_sym_LBRACE_PIPE] = ACTIONS(67),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_return_BANG] = ACTIONS(829),
    [anon_sym_yield] = ACTIONS(825),
    [anon_sym_yield_BANG] = ACTIONS(829),
    [anon_sym_lazy] = ACTIONS(825),
    [anon_sym_assert] = ACTIONS(825),
    [anon_sym_upcast] = ACTIONS(825),
    [anon_sym_downcast] = ACTIONS(825),
    [anon_sym_COLON_GT] = ACTIONS(71),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(71),
    [anon_sym_for] = ACTIONS(73),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(79),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_match] = ACTIONS(83),
    [anon_sym_match_BANG] = ACTIONS(85),
    [anon_sym_function] = ACTIONS(87),
    [anon_sym_LT_DASH] = ACTIONS(831),
    [anon_sym_DOT_LBRACK] = ACTIONS(91),
    [anon_sym_LT] = ACTIONS(93),
    [anon_sym_use] = ACTIONS(833),
    [anon_sym_use_BANG] = ACTIONS(835),
    [anon_sym_do_BANG] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(101),
    [anon_sym_LPAREN2] = ACTIONS(103),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(105),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(107),
    [anon_sym_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DQUOTE] = ACTIONS(111),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(115),
    [sym_bool] = ACTIONS(117),
    [sym_unit] = ACTIONS(119),
    [anon_sym_LPAREN_PIPE] = ACTIONS(121),
    [sym_op_identifier] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(837),
    [sym_xint] = ACTIONS(387),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(135),
    [sym__newline] = ACTIONS(839),
    [sym__dedent] = ACTIONS(1407),
  },
  [243] = {
    [sym_function_or_value_defn] = STATE(600),
    [sym__expression] = STATE(88),
    [sym_literal_expression] = STATE(867),
    [sym_long_identifier_or_op] = STATE(867),
    [sym_tuple_expression] = STATE(867),
    [sym_brace_expression] = STATE(867),
    [sym_anon_record_expression] = STATE(867),
    [sym_prefixed_expression] = STATE(867),
    [sym_typecast_expression] = STATE(867),
    [sym_for_expression] = STATE(867),
    [sym_while_expression] = STATE(867),
    [sym__if_branch] = STATE(6511),
    [sym_if_expression] = STATE(867),
    [sym_fun_expression] = STATE(867),
    [sym_try_expression] = STATE(867),
    [sym_match_expression] = STATE(867),
    [sym_function_expression] = STATE(867),
    [sym_mutate_expression] = STATE(867),
    [sym_index_expression] = STATE(867),
    [sym_typed_expression] = STATE(867),
    [sym_declaration_expression] = STATE(867),
    [sym_do_expression] = STATE(867),
    [sym_list_expression] = STATE(867),
    [sym_array_expression] = STATE(867),
    [sym_begin_end_expression] = STATE(867),
    [sym_paren_expression] = STATE(867),
    [sym__high_prec_app] = STATE(864),
    [sym__low_prec_app] = STATE(864),
    [sym_application_expression] = STATE(867),
    [sym_dot_expression] = STATE(867),
    [sym_infix_expression] = STATE(867),
    [sym_ce_expression] = STATE(867),
    [sym_sequential_expression] = STATE(867),
    [sym_char] = STATE(868),
    [sym_format_string] = STATE(869),
    [sym__string_literal] = STATE(869),
    [sym_string] = STATE(868),
    [sym_verbatim_string] = STATE(868),
    [sym_bytearray] = STATE(868),
    [sym_verbatim_bytearray] = STATE(868),
    [sym_format_triple_quoted_string] = STATE(870),
    [sym_triple_quoted_string] = STATE(868),
    [sym_const] = STATE(867),
    [sym_long_identifier] = STATE(872),
    [sym_active_pattern] = STATE(871),
    [sym__identifier_or_op] = STATE(873),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(656),
    [sym_infix_op] = STATE(581),
    [sym_sbyte] = STATE(868),
    [sym_byte] = STATE(868),
    [sym_int16] = STATE(868),
    [sym_uint16] = STATE(868),
    [sym_int32] = STATE(868),
    [sym_uint32] = STATE(868),
    [sym_nativeint] = STATE(868),
    [sym_unativeint] = STATE(868),
    [sym_int64] = STATE(868),
    [sym_uint64] = STATE(868),
    [sym_ieee32] = STATE(868),
    [sym_ieee64] = STATE(868),
    [sym_bignum] = STATE(868),
    [sym_decimal] = STATE(868),
    [sym_float] = STATE(1368),
    [sym_block_comment] = STATE(243),
    [sym_compiler_directive_decl] = STATE(243),
    [sym_fsi_directive_decl] = STATE(243),
    [sym_preproc_line] = STATE(243),
    [sym_preproc_if_in_expression] = STATE(867),
    [aux_sym_sequential_expression_repeat1] = STATE(1542),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(29),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(825),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_COMMA] = ACTIONS(827),
    [anon_sym_null] = ACTIONS(49),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACK_PIPE] = ACTIONS(57),
    [anon_sym_LBRACE] = ACTIONS(139),
    [anon_sym_LT_AT] = ACTIONS(61),
    [anon_sym_LT_AT_AT] = ACTIONS(63),
    [anon_sym_DOT] = ACTIONS(65),
    [anon_sym_LBRACE_PIPE] = ACTIONS(67),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_return_BANG] = ACTIONS(829),
    [anon_sym_yield] = ACTIONS(825),
    [anon_sym_yield_BANG] = ACTIONS(829),
    [anon_sym_lazy] = ACTIONS(825),
    [anon_sym_assert] = ACTIONS(825),
    [anon_sym_upcast] = ACTIONS(825),
    [anon_sym_downcast] = ACTIONS(825),
    [anon_sym_COLON_GT] = ACTIONS(71),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(71),
    [anon_sym_for] = ACTIONS(73),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(79),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_match] = ACTIONS(83),
    [anon_sym_match_BANG] = ACTIONS(85),
    [anon_sym_function] = ACTIONS(87),
    [anon_sym_LT_DASH] = ACTIONS(831),
    [anon_sym_DOT_LBRACK] = ACTIONS(91),
    [anon_sym_LT] = ACTIONS(93),
    [anon_sym_use] = ACTIONS(833),
    [anon_sym_use_BANG] = ACTIONS(835),
    [anon_sym_do_BANG] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(101),
    [anon_sym_LPAREN2] = ACTIONS(103),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(105),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(107),
    [anon_sym_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DQUOTE] = ACTIONS(111),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(115),
    [sym_bool] = ACTIONS(117),
    [sym_unit] = ACTIONS(119),
    [anon_sym_LPAREN_PIPE] = ACTIONS(121),
    [sym_op_identifier] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(837),
    [sym_xint] = ACTIONS(387),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(135),
    [sym__newline] = ACTIONS(839),
    [sym__dedent] = ACTIONS(1409),
  },
  [244] = {
    [sym_function_or_value_defn] = STATE(600),
    [sym__expression] = STATE(88),
    [sym_literal_expression] = STATE(867),
    [sym_long_identifier_or_op] = STATE(867),
    [sym_tuple_expression] = STATE(867),
    [sym_brace_expression] = STATE(867),
    [sym_anon_record_expression] = STATE(867),
    [sym_prefixed_expression] = STATE(867),
    [sym_typecast_expression] = STATE(867),
    [sym_for_expression] = STATE(867),
    [sym_while_expression] = STATE(867),
    [sym__if_branch] = STATE(6511),
    [sym_if_expression] = STATE(867),
    [sym_fun_expression] = STATE(867),
    [sym_try_expression] = STATE(867),
    [sym_match_expression] = STATE(867),
    [sym_function_expression] = STATE(867),
    [sym_mutate_expression] = STATE(867),
    [sym_index_expression] = STATE(867),
    [sym_typed_expression] = STATE(867),
    [sym_declaration_expression] = STATE(867),
    [sym_do_expression] = STATE(867),
    [sym_list_expression] = STATE(867),
    [sym_array_expression] = STATE(867),
    [sym_begin_end_expression] = STATE(867),
    [sym_paren_expression] = STATE(867),
    [sym__high_prec_app] = STATE(864),
    [sym__low_prec_app] = STATE(864),
    [sym_application_expression] = STATE(867),
    [sym_dot_expression] = STATE(867),
    [sym_infix_expression] = STATE(867),
    [sym_ce_expression] = STATE(867),
    [sym_sequential_expression] = STATE(867),
    [sym_char] = STATE(868),
    [sym_format_string] = STATE(869),
    [sym__string_literal] = STATE(869),
    [sym_string] = STATE(868),
    [sym_verbatim_string] = STATE(868),
    [sym_bytearray] = STATE(868),
    [sym_verbatim_bytearray] = STATE(868),
    [sym_format_triple_quoted_string] = STATE(870),
    [sym_triple_quoted_string] = STATE(868),
    [sym_const] = STATE(867),
    [sym_long_identifier] = STATE(872),
    [sym_active_pattern] = STATE(871),
    [sym__identifier_or_op] = STATE(873),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(656),
    [sym_infix_op] = STATE(581),
    [sym_sbyte] = STATE(868),
    [sym_byte] = STATE(868),
    [sym_int16] = STATE(868),
    [sym_uint16] = STATE(868),
    [sym_int32] = STATE(868),
    [sym_uint32] = STATE(868),
    [sym_nativeint] = STATE(868),
    [sym_unativeint] = STATE(868),
    [sym_int64] = STATE(868),
    [sym_uint64] = STATE(868),
    [sym_ieee32] = STATE(868),
    [sym_ieee64] = STATE(868),
    [sym_bignum] = STATE(868),
    [sym_decimal] = STATE(868),
    [sym_float] = STATE(1368),
    [sym_block_comment] = STATE(244),
    [sym_compiler_directive_decl] = STATE(244),
    [sym_fsi_directive_decl] = STATE(244),
    [sym_preproc_line] = STATE(244),
    [sym_preproc_if_in_expression] = STATE(867),
    [aux_sym_sequential_expression_repeat1] = STATE(1542),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(29),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(825),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_COMMA] = ACTIONS(827),
    [anon_sym_null] = ACTIONS(49),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACK_PIPE] = ACTIONS(57),
    [anon_sym_LBRACE] = ACTIONS(139),
    [anon_sym_LT_AT] = ACTIONS(61),
    [anon_sym_LT_AT_AT] = ACTIONS(63),
    [anon_sym_DOT] = ACTIONS(65),
    [anon_sym_LBRACE_PIPE] = ACTIONS(67),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_return_BANG] = ACTIONS(829),
    [anon_sym_yield] = ACTIONS(825),
    [anon_sym_yield_BANG] = ACTIONS(829),
    [anon_sym_lazy] = ACTIONS(825),
    [anon_sym_assert] = ACTIONS(825),
    [anon_sym_upcast] = ACTIONS(825),
    [anon_sym_downcast] = ACTIONS(825),
    [anon_sym_COLON_GT] = ACTIONS(71),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(71),
    [anon_sym_for] = ACTIONS(73),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(79),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_match] = ACTIONS(83),
    [anon_sym_match_BANG] = ACTIONS(85),
    [anon_sym_function] = ACTIONS(87),
    [anon_sym_LT_DASH] = ACTIONS(831),
    [anon_sym_DOT_LBRACK] = ACTIONS(91),
    [anon_sym_LT] = ACTIONS(93),
    [anon_sym_use] = ACTIONS(833),
    [anon_sym_use_BANG] = ACTIONS(835),
    [anon_sym_do_BANG] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(101),
    [anon_sym_LPAREN2] = ACTIONS(103),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(105),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(107),
    [anon_sym_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DQUOTE] = ACTIONS(111),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(115),
    [sym_bool] = ACTIONS(117),
    [sym_unit] = ACTIONS(119),
    [anon_sym_LPAREN_PIPE] = ACTIONS(121),
    [sym_op_identifier] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(837),
    [sym_xint] = ACTIONS(387),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(135),
    [sym__newline] = ACTIONS(1411),
    [sym__dedent] = ACTIONS(1411),
  },
  [245] = {
    [sym_function_or_value_defn] = STATE(600),
    [sym__expression] = STATE(88),
    [sym_literal_expression] = STATE(867),
    [sym_long_identifier_or_op] = STATE(867),
    [sym_tuple_expression] = STATE(867),
    [sym_brace_expression] = STATE(867),
    [sym_anon_record_expression] = STATE(867),
    [sym_prefixed_expression] = STATE(867),
    [sym_typecast_expression] = STATE(867),
    [sym_for_expression] = STATE(867),
    [sym_while_expression] = STATE(867),
    [sym__if_branch] = STATE(6511),
    [sym_if_expression] = STATE(867),
    [sym_fun_expression] = STATE(867),
    [sym_try_expression] = STATE(867),
    [sym_match_expression] = STATE(867),
    [sym_function_expression] = STATE(867),
    [sym_mutate_expression] = STATE(867),
    [sym_index_expression] = STATE(867),
    [sym_typed_expression] = STATE(867),
    [sym_declaration_expression] = STATE(867),
    [sym_do_expression] = STATE(867),
    [sym_list_expression] = STATE(867),
    [sym_array_expression] = STATE(867),
    [sym_begin_end_expression] = STATE(867),
    [sym_paren_expression] = STATE(867),
    [sym__high_prec_app] = STATE(864),
    [sym__low_prec_app] = STATE(864),
    [sym_application_expression] = STATE(867),
    [sym_dot_expression] = STATE(867),
    [sym_infix_expression] = STATE(867),
    [sym_ce_expression] = STATE(867),
    [sym_sequential_expression] = STATE(867),
    [sym_char] = STATE(868),
    [sym_format_string] = STATE(869),
    [sym__string_literal] = STATE(869),
    [sym_string] = STATE(868),
    [sym_verbatim_string] = STATE(868),
    [sym_bytearray] = STATE(868),
    [sym_verbatim_bytearray] = STATE(868),
    [sym_format_triple_quoted_string] = STATE(870),
    [sym_triple_quoted_string] = STATE(868),
    [sym_const] = STATE(867),
    [sym_long_identifier] = STATE(872),
    [sym_active_pattern] = STATE(871),
    [sym__identifier_or_op] = STATE(873),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(656),
    [sym_infix_op] = STATE(581),
    [sym_sbyte] = STATE(868),
    [sym_byte] = STATE(868),
    [sym_int16] = STATE(868),
    [sym_uint16] = STATE(868),
    [sym_int32] = STATE(868),
    [sym_uint32] = STATE(868),
    [sym_nativeint] = STATE(868),
    [sym_unativeint] = STATE(868),
    [sym_int64] = STATE(868),
    [sym_uint64] = STATE(868),
    [sym_ieee32] = STATE(868),
    [sym_ieee64] = STATE(868),
    [sym_bignum] = STATE(868),
    [sym_decimal] = STATE(868),
    [sym_float] = STATE(1368),
    [sym_block_comment] = STATE(245),
    [sym_compiler_directive_decl] = STATE(245),
    [sym_fsi_directive_decl] = STATE(245),
    [sym_preproc_line] = STATE(245),
    [sym_preproc_if_in_expression] = STATE(867),
    [aux_sym_sequential_expression_repeat1] = STATE(1542),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(29),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(825),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_COMMA] = ACTIONS(827),
    [anon_sym_null] = ACTIONS(49),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACK_PIPE] = ACTIONS(57),
    [anon_sym_LBRACE] = ACTIONS(139),
    [anon_sym_LT_AT] = ACTIONS(61),
    [anon_sym_LT_AT_AT] = ACTIONS(63),
    [anon_sym_DOT] = ACTIONS(65),
    [anon_sym_LBRACE_PIPE] = ACTIONS(67),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_return_BANG] = ACTIONS(829),
    [anon_sym_yield] = ACTIONS(825),
    [anon_sym_yield_BANG] = ACTIONS(829),
    [anon_sym_lazy] = ACTIONS(825),
    [anon_sym_assert] = ACTIONS(825),
    [anon_sym_upcast] = ACTIONS(825),
    [anon_sym_downcast] = ACTIONS(825),
    [anon_sym_COLON_GT] = ACTIONS(71),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(71),
    [anon_sym_for] = ACTIONS(73),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(79),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_match] = ACTIONS(83),
    [anon_sym_match_BANG] = ACTIONS(85),
    [anon_sym_function] = ACTIONS(87),
    [anon_sym_LT_DASH] = ACTIONS(831),
    [anon_sym_DOT_LBRACK] = ACTIONS(91),
    [anon_sym_LT] = ACTIONS(93),
    [anon_sym_use] = ACTIONS(833),
    [anon_sym_use_BANG] = ACTIONS(835),
    [anon_sym_do_BANG] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(101),
    [anon_sym_LPAREN2] = ACTIONS(103),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(105),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(107),
    [anon_sym_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DQUOTE] = ACTIONS(111),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(115),
    [sym_bool] = ACTIONS(117),
    [sym_unit] = ACTIONS(119),
    [anon_sym_LPAREN_PIPE] = ACTIONS(121),
    [sym_op_identifier] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(837),
    [sym_xint] = ACTIONS(387),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(135),
    [sym__newline] = ACTIONS(839),
    [sym__dedent] = ACTIONS(1413),
  },
  [246] = {
    [sym_function_or_value_defn] = STATE(600),
    [sym__expression] = STATE(88),
    [sym_literal_expression] = STATE(867),
    [sym_long_identifier_or_op] = STATE(867),
    [sym_tuple_expression] = STATE(867),
    [sym_brace_expression] = STATE(867),
    [sym_anon_record_expression] = STATE(867),
    [sym_prefixed_expression] = STATE(867),
    [sym_typecast_expression] = STATE(867),
    [sym_for_expression] = STATE(867),
    [sym_while_expression] = STATE(867),
    [sym__if_branch] = STATE(6511),
    [sym_if_expression] = STATE(867),
    [sym_fun_expression] = STATE(867),
    [sym_try_expression] = STATE(867),
    [sym_match_expression] = STATE(867),
    [sym_function_expression] = STATE(867),
    [sym_mutate_expression] = STATE(867),
    [sym_index_expression] = STATE(867),
    [sym_typed_expression] = STATE(867),
    [sym_declaration_expression] = STATE(867),
    [sym_do_expression] = STATE(867),
    [sym_list_expression] = STATE(867),
    [sym_array_expression] = STATE(867),
    [sym_begin_end_expression] = STATE(867),
    [sym_paren_expression] = STATE(867),
    [sym__high_prec_app] = STATE(864),
    [sym__low_prec_app] = STATE(864),
    [sym_application_expression] = STATE(867),
    [sym_dot_expression] = STATE(867),
    [sym_infix_expression] = STATE(867),
    [sym_ce_expression] = STATE(867),
    [sym_sequential_expression] = STATE(867),
    [sym_char] = STATE(868),
    [sym_format_string] = STATE(869),
    [sym__string_literal] = STATE(869),
    [sym_string] = STATE(868),
    [sym_verbatim_string] = STATE(868),
    [sym_bytearray] = STATE(868),
    [sym_verbatim_bytearray] = STATE(868),
    [sym_format_triple_quoted_string] = STATE(870),
    [sym_triple_quoted_string] = STATE(868),
    [sym_const] = STATE(867),
    [sym_long_identifier] = STATE(872),
    [sym_active_pattern] = STATE(871),
    [sym__identifier_or_op] = STATE(873),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(656),
    [sym_infix_op] = STATE(581),
    [sym_sbyte] = STATE(868),
    [sym_byte] = STATE(868),
    [sym_int16] = STATE(868),
    [sym_uint16] = STATE(868),
    [sym_int32] = STATE(868),
    [sym_uint32] = STATE(868),
    [sym_nativeint] = STATE(868),
    [sym_unativeint] = STATE(868),
    [sym_int64] = STATE(868),
    [sym_uint64] = STATE(868),
    [sym_ieee32] = STATE(868),
    [sym_ieee64] = STATE(868),
    [sym_bignum] = STATE(868),
    [sym_decimal] = STATE(868),
    [sym_float] = STATE(1368),
    [sym_block_comment] = STATE(246),
    [sym_compiler_directive_decl] = STATE(246),
    [sym_fsi_directive_decl] = STATE(246),
    [sym_preproc_line] = STATE(246),
    [sym_preproc_if_in_expression] = STATE(867),
    [aux_sym_sequential_expression_repeat1] = STATE(1542),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(29),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(825),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_COMMA] = ACTIONS(827),
    [anon_sym_null] = ACTIONS(49),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACK_PIPE] = ACTIONS(57),
    [anon_sym_LBRACE] = ACTIONS(139),
    [anon_sym_LT_AT] = ACTIONS(61),
    [anon_sym_LT_AT_AT] = ACTIONS(63),
    [anon_sym_DOT] = ACTIONS(65),
    [anon_sym_LBRACE_PIPE] = ACTIONS(67),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_return_BANG] = ACTIONS(829),
    [anon_sym_yield] = ACTIONS(825),
    [anon_sym_yield_BANG] = ACTIONS(829),
    [anon_sym_lazy] = ACTIONS(825),
    [anon_sym_assert] = ACTIONS(825),
    [anon_sym_upcast] = ACTIONS(825),
    [anon_sym_downcast] = ACTIONS(825),
    [anon_sym_COLON_GT] = ACTIONS(71),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(71),
    [anon_sym_for] = ACTIONS(73),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(79),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_match] = ACTIONS(83),
    [anon_sym_match_BANG] = ACTIONS(85),
    [anon_sym_function] = ACTIONS(87),
    [anon_sym_LT_DASH] = ACTIONS(831),
    [anon_sym_DOT_LBRACK] = ACTIONS(91),
    [anon_sym_LT] = ACTIONS(93),
    [anon_sym_use] = ACTIONS(833),
    [anon_sym_use_BANG] = ACTIONS(835),
    [anon_sym_do_BANG] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(101),
    [anon_sym_LPAREN2] = ACTIONS(103),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(105),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(107),
    [anon_sym_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DQUOTE] = ACTIONS(111),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(115),
    [sym_bool] = ACTIONS(117),
    [sym_unit] = ACTIONS(119),
    [anon_sym_LPAREN_PIPE] = ACTIONS(121),
    [sym_op_identifier] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(837),
    [sym_xint] = ACTIONS(387),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(135),
    [sym__newline] = ACTIONS(839),
    [sym__dedent] = ACTIONS(1415),
  },
  [247] = {
    [sym_function_or_value_defn] = STATE(627),
    [sym__expression] = STATE(17),
    [sym_literal_expression] = STATE(1118),
    [sym_long_identifier_or_op] = STATE(1118),
    [sym_tuple_expression] = STATE(1118),
    [sym_brace_expression] = STATE(1118),
    [sym_anon_record_expression] = STATE(1118),
    [sym_prefixed_expression] = STATE(1118),
    [sym_typecast_expression] = STATE(1118),
    [sym_for_expression] = STATE(1118),
    [sym_while_expression] = STATE(1118),
    [sym__if_branch] = STATE(7163),
    [sym_if_expression] = STATE(1118),
    [sym_fun_expression] = STATE(1118),
    [sym_try_expression] = STATE(1118),
    [sym_match_expression] = STATE(1118),
    [sym_function_expression] = STATE(1118),
    [sym_mutate_expression] = STATE(1118),
    [sym_index_expression] = STATE(1118),
    [sym_typed_expression] = STATE(1118),
    [sym_declaration_expression] = STATE(1118),
    [sym_do_expression] = STATE(1118),
    [sym_list_expression] = STATE(1118),
    [sym_array_expression] = STATE(1118),
    [sym_begin_end_expression] = STATE(1118),
    [sym_paren_expression] = STATE(1118),
    [sym__high_prec_app] = STATE(1133),
    [sym__low_prec_app] = STATE(1133),
    [sym_application_expression] = STATE(1118),
    [sym_dot_expression] = STATE(1118),
    [sym_infix_expression] = STATE(1118),
    [sym_ce_expression] = STATE(1118),
    [sym_sequential_expression] = STATE(1118),
    [sym_char] = STATE(1080),
    [sym_format_string] = STATE(1090),
    [sym__string_literal] = STATE(1090),
    [sym_string] = STATE(1080),
    [sym_verbatim_string] = STATE(1080),
    [sym_bytearray] = STATE(1080),
    [sym_verbatim_bytearray] = STATE(1080),
    [sym_format_triple_quoted_string] = STATE(1096),
    [sym_triple_quoted_string] = STATE(1080),
    [sym_const] = STATE(1118),
    [sym_long_identifier] = STATE(1156),
    [sym_active_pattern] = STATE(1085),
    [sym__identifier_or_op] = STATE(1099),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(517),
    [sym_infix_op] = STATE(487),
    [sym_sbyte] = STATE(1080),
    [sym_byte] = STATE(1080),
    [sym_int16] = STATE(1080),
    [sym_uint16] = STATE(1080),
    [sym_int32] = STATE(1080),
    [sym_uint32] = STATE(1080),
    [sym_nativeint] = STATE(1080),
    [sym_unativeint] = STATE(1080),
    [sym_int64] = STATE(1080),
    [sym_uint64] = STATE(1080),
    [sym_ieee32] = STATE(1080),
    [sym_ieee64] = STATE(1080),
    [sym_bignum] = STATE(1080),
    [sym_decimal] = STATE(1080),
    [sym_float] = STATE(979),
    [sym_block_comment] = STATE(247),
    [sym_compiler_directive_decl] = STATE(247),
    [sym_fsi_directive_decl] = STATE(247),
    [sym_preproc_line] = STATE(247),
    [sym_preproc_if_in_expression] = STATE(1118),
    [aux_sym_sequential_expression_repeat1] = STATE(1069),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(195),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(197),
    [anon_sym_return] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_COMMA] = ACTIONS(205),
    [anon_sym_null] = ACTIONS(207),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(197),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(209),
    [anon_sym_LBRACK_PIPE] = ACTIONS(211),
    [anon_sym_LBRACE] = ACTIONS(271),
    [anon_sym_LT_AT] = ACTIONS(213),
    [anon_sym_LT_AT_AT] = ACTIONS(215),
    [anon_sym_DOT] = ACTIONS(185),
    [anon_sym_LBRACE_PIPE] = ACTIONS(217),
    [anon_sym_new] = ACTIONS(199),
    [anon_sym_with] = ACTIONS(1417),
    [anon_sym_return_BANG] = ACTIONS(219),
    [anon_sym_yield] = ACTIONS(199),
    [anon_sym_yield_BANG] = ACTIONS(219),
    [anon_sym_lazy] = ACTIONS(199),
    [anon_sym_assert] = ACTIONS(199),
    [anon_sym_upcast] = ACTIONS(199),
    [anon_sym_downcast] = ACTIONS(199),
    [anon_sym_COLON_GT] = ACTIONS(221),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(221),
    [anon_sym_for] = ACTIONS(223),
    [anon_sym_while] = ACTIONS(225),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(229),
    [anon_sym_match] = ACTIONS(231),
    [anon_sym_match_BANG] = ACTIONS(233),
    [anon_sym_function] = ACTIONS(235),
    [anon_sym_LT_DASH] = ACTIONS(237),
    [anon_sym_DOT_LBRACK] = ACTIONS(187),
    [anon_sym_LT] = ACTIONS(189),
    [anon_sym_use] = ACTIONS(239),
    [anon_sym_use_BANG] = ACTIONS(241),
    [anon_sym_do_BANG] = ACTIONS(243),
    [anon_sym_begin] = ACTIONS(245),
    [anon_sym_LPAREN2] = ACTIONS(191),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(247),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(251),
    [anon_sym_AT_DQUOTE] = ACTIONS(253),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(255),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(257),
    [sym_bool] = ACTIONS(259),
    [sym_unit] = ACTIONS(193),
    [anon_sym_LPAREN_PIPE] = ACTIONS(261),
    [sym_op_identifier] = ACTIONS(263),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(265),
    [sym_xint] = ACTIONS(267),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(269),
    [sym__newline] = ACTIONS(1419),
  },
  [248] = {
    [sym_function_or_value_defn] = STATE(600),
    [sym__expression] = STATE(88),
    [sym_literal_expression] = STATE(867),
    [sym_long_identifier_or_op] = STATE(867),
    [sym_tuple_expression] = STATE(867),
    [sym_brace_expression] = STATE(867),
    [sym_anon_record_expression] = STATE(867),
    [sym_prefixed_expression] = STATE(867),
    [sym_typecast_expression] = STATE(867),
    [sym_for_expression] = STATE(867),
    [sym_while_expression] = STATE(867),
    [sym__if_branch] = STATE(6511),
    [sym_if_expression] = STATE(867),
    [sym_fun_expression] = STATE(867),
    [sym_try_expression] = STATE(867),
    [sym_match_expression] = STATE(867),
    [sym_function_expression] = STATE(867),
    [sym_mutate_expression] = STATE(867),
    [sym_index_expression] = STATE(867),
    [sym_typed_expression] = STATE(867),
    [sym_declaration_expression] = STATE(867),
    [sym_do_expression] = STATE(867),
    [sym_list_expression] = STATE(867),
    [sym_array_expression] = STATE(867),
    [sym_begin_end_expression] = STATE(867),
    [sym_paren_expression] = STATE(867),
    [sym__high_prec_app] = STATE(864),
    [sym__low_prec_app] = STATE(864),
    [sym_application_expression] = STATE(867),
    [sym_dot_expression] = STATE(867),
    [sym_infix_expression] = STATE(867),
    [sym_ce_expression] = STATE(867),
    [sym_sequential_expression] = STATE(867),
    [sym_char] = STATE(868),
    [sym_format_string] = STATE(869),
    [sym__string_literal] = STATE(869),
    [sym_string] = STATE(868),
    [sym_verbatim_string] = STATE(868),
    [sym_bytearray] = STATE(868),
    [sym_verbatim_bytearray] = STATE(868),
    [sym_format_triple_quoted_string] = STATE(870),
    [sym_triple_quoted_string] = STATE(868),
    [sym_const] = STATE(867),
    [sym_long_identifier] = STATE(872),
    [sym_active_pattern] = STATE(871),
    [sym__identifier_or_op] = STATE(873),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(656),
    [sym_infix_op] = STATE(581),
    [sym_sbyte] = STATE(868),
    [sym_byte] = STATE(868),
    [sym_int16] = STATE(868),
    [sym_uint16] = STATE(868),
    [sym_int32] = STATE(868),
    [sym_uint32] = STATE(868),
    [sym_nativeint] = STATE(868),
    [sym_unativeint] = STATE(868),
    [sym_int64] = STATE(868),
    [sym_uint64] = STATE(868),
    [sym_ieee32] = STATE(868),
    [sym_ieee64] = STATE(868),
    [sym_bignum] = STATE(868),
    [sym_decimal] = STATE(868),
    [sym_float] = STATE(1368),
    [sym_block_comment] = STATE(248),
    [sym_compiler_directive_decl] = STATE(248),
    [sym_fsi_directive_decl] = STATE(248),
    [sym_preproc_line] = STATE(248),
    [sym_preproc_if_in_expression] = STATE(867),
    [aux_sym_sequential_expression_repeat1] = STATE(1542),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(29),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(825),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_COMMA] = ACTIONS(827),
    [anon_sym_null] = ACTIONS(49),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACK_PIPE] = ACTIONS(57),
    [anon_sym_LBRACE] = ACTIONS(139),
    [anon_sym_LT_AT] = ACTIONS(61),
    [anon_sym_LT_AT_AT] = ACTIONS(63),
    [anon_sym_DOT] = ACTIONS(65),
    [anon_sym_LBRACE_PIPE] = ACTIONS(67),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_return_BANG] = ACTIONS(829),
    [anon_sym_yield] = ACTIONS(825),
    [anon_sym_yield_BANG] = ACTIONS(829),
    [anon_sym_lazy] = ACTIONS(825),
    [anon_sym_assert] = ACTIONS(825),
    [anon_sym_upcast] = ACTIONS(825),
    [anon_sym_downcast] = ACTIONS(825),
    [anon_sym_COLON_GT] = ACTIONS(71),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(71),
    [anon_sym_for] = ACTIONS(73),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(79),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_match] = ACTIONS(83),
    [anon_sym_match_BANG] = ACTIONS(85),
    [anon_sym_function] = ACTIONS(87),
    [anon_sym_LT_DASH] = ACTIONS(831),
    [anon_sym_DOT_LBRACK] = ACTIONS(91),
    [anon_sym_LT] = ACTIONS(93),
    [anon_sym_use] = ACTIONS(833),
    [anon_sym_use_BANG] = ACTIONS(835),
    [anon_sym_do_BANG] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(101),
    [anon_sym_LPAREN2] = ACTIONS(103),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(105),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(107),
    [anon_sym_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DQUOTE] = ACTIONS(111),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(115),
    [sym_bool] = ACTIONS(117),
    [sym_unit] = ACTIONS(119),
    [anon_sym_LPAREN_PIPE] = ACTIONS(121),
    [sym_op_identifier] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(837),
    [sym_xint] = ACTIONS(387),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(135),
    [sym__newline] = ACTIONS(839),
    [sym__dedent] = ACTIONS(1421),
  },
  [249] = {
    [sym_function_or_value_defn] = STATE(600),
    [sym__expression] = STATE(88),
    [sym_literal_expression] = STATE(867),
    [sym_long_identifier_or_op] = STATE(867),
    [sym_tuple_expression] = STATE(867),
    [sym_brace_expression] = STATE(867),
    [sym_anon_record_expression] = STATE(867),
    [sym_prefixed_expression] = STATE(867),
    [sym_typecast_expression] = STATE(867),
    [sym_for_expression] = STATE(867),
    [sym_while_expression] = STATE(867),
    [sym__if_branch] = STATE(6511),
    [sym_if_expression] = STATE(867),
    [sym_fun_expression] = STATE(867),
    [sym_try_expression] = STATE(867),
    [sym_match_expression] = STATE(867),
    [sym_function_expression] = STATE(867),
    [sym_mutate_expression] = STATE(867),
    [sym_index_expression] = STATE(867),
    [sym_typed_expression] = STATE(867),
    [sym_declaration_expression] = STATE(867),
    [sym_do_expression] = STATE(867),
    [sym_list_expression] = STATE(867),
    [sym_array_expression] = STATE(867),
    [sym_begin_end_expression] = STATE(867),
    [sym_paren_expression] = STATE(867),
    [sym__high_prec_app] = STATE(864),
    [sym__low_prec_app] = STATE(864),
    [sym_application_expression] = STATE(867),
    [sym_dot_expression] = STATE(867),
    [sym_infix_expression] = STATE(867),
    [sym_ce_expression] = STATE(867),
    [sym_sequential_expression] = STATE(867),
    [sym_char] = STATE(868),
    [sym_format_string] = STATE(869),
    [sym__string_literal] = STATE(869),
    [sym_string] = STATE(868),
    [sym_verbatim_string] = STATE(868),
    [sym_bytearray] = STATE(868),
    [sym_verbatim_bytearray] = STATE(868),
    [sym_format_triple_quoted_string] = STATE(870),
    [sym_triple_quoted_string] = STATE(868),
    [sym_const] = STATE(867),
    [sym_long_identifier] = STATE(872),
    [sym_active_pattern] = STATE(871),
    [sym__identifier_or_op] = STATE(873),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(656),
    [sym_infix_op] = STATE(581),
    [sym_sbyte] = STATE(868),
    [sym_byte] = STATE(868),
    [sym_int16] = STATE(868),
    [sym_uint16] = STATE(868),
    [sym_int32] = STATE(868),
    [sym_uint32] = STATE(868),
    [sym_nativeint] = STATE(868),
    [sym_unativeint] = STATE(868),
    [sym_int64] = STATE(868),
    [sym_uint64] = STATE(868),
    [sym_ieee32] = STATE(868),
    [sym_ieee64] = STATE(868),
    [sym_bignum] = STATE(868),
    [sym_decimal] = STATE(868),
    [sym_float] = STATE(1368),
    [sym_block_comment] = STATE(249),
    [sym_compiler_directive_decl] = STATE(249),
    [sym_fsi_directive_decl] = STATE(249),
    [sym_preproc_line] = STATE(249),
    [sym_preproc_if_in_expression] = STATE(867),
    [aux_sym_sequential_expression_repeat1] = STATE(1542),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(29),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(825),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_COMMA] = ACTIONS(827),
    [anon_sym_null] = ACTIONS(49),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACK_PIPE] = ACTIONS(57),
    [anon_sym_LBRACE] = ACTIONS(139),
    [anon_sym_LT_AT] = ACTIONS(61),
    [anon_sym_LT_AT_AT] = ACTIONS(63),
    [anon_sym_DOT] = ACTIONS(65),
    [anon_sym_LBRACE_PIPE] = ACTIONS(67),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_return_BANG] = ACTIONS(829),
    [anon_sym_yield] = ACTIONS(825),
    [anon_sym_yield_BANG] = ACTIONS(829),
    [anon_sym_lazy] = ACTIONS(825),
    [anon_sym_assert] = ACTIONS(825),
    [anon_sym_upcast] = ACTIONS(825),
    [anon_sym_downcast] = ACTIONS(825),
    [anon_sym_COLON_GT] = ACTIONS(71),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(71),
    [anon_sym_for] = ACTIONS(73),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(79),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_match] = ACTIONS(83),
    [anon_sym_match_BANG] = ACTIONS(85),
    [anon_sym_function] = ACTIONS(87),
    [anon_sym_LT_DASH] = ACTIONS(831),
    [anon_sym_DOT_LBRACK] = ACTIONS(91),
    [anon_sym_LT] = ACTIONS(93),
    [anon_sym_use] = ACTIONS(833),
    [anon_sym_use_BANG] = ACTIONS(835),
    [anon_sym_do_BANG] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(101),
    [anon_sym_LPAREN2] = ACTIONS(103),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(105),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(107),
    [anon_sym_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DQUOTE] = ACTIONS(111),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(115),
    [sym_bool] = ACTIONS(117),
    [sym_unit] = ACTIONS(119),
    [anon_sym_LPAREN_PIPE] = ACTIONS(121),
    [sym_op_identifier] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(837),
    [sym_xint] = ACTIONS(387),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(135),
    [sym__newline] = ACTIONS(839),
    [sym__dedent] = ACTIONS(1423),
  },
  [250] = {
    [sym_function_or_value_defn] = STATE(600),
    [sym__expression] = STATE(88),
    [sym_literal_expression] = STATE(867),
    [sym_long_identifier_or_op] = STATE(867),
    [sym_tuple_expression] = STATE(867),
    [sym_brace_expression] = STATE(867),
    [sym_anon_record_expression] = STATE(867),
    [sym_prefixed_expression] = STATE(867),
    [sym_typecast_expression] = STATE(867),
    [sym_for_expression] = STATE(867),
    [sym_while_expression] = STATE(867),
    [sym__if_branch] = STATE(6511),
    [sym_if_expression] = STATE(867),
    [sym_fun_expression] = STATE(867),
    [sym_try_expression] = STATE(867),
    [sym_match_expression] = STATE(867),
    [sym_function_expression] = STATE(867),
    [sym_mutate_expression] = STATE(867),
    [sym_index_expression] = STATE(867),
    [sym_typed_expression] = STATE(867),
    [sym_declaration_expression] = STATE(867),
    [sym_do_expression] = STATE(867),
    [sym_list_expression] = STATE(867),
    [sym_array_expression] = STATE(867),
    [sym_begin_end_expression] = STATE(867),
    [sym_paren_expression] = STATE(867),
    [sym__high_prec_app] = STATE(864),
    [sym__low_prec_app] = STATE(864),
    [sym_application_expression] = STATE(867),
    [sym_dot_expression] = STATE(867),
    [sym_infix_expression] = STATE(867),
    [sym_ce_expression] = STATE(867),
    [sym_sequential_expression] = STATE(867),
    [sym_char] = STATE(868),
    [sym_format_string] = STATE(869),
    [sym__string_literal] = STATE(869),
    [sym_string] = STATE(868),
    [sym_verbatim_string] = STATE(868),
    [sym_bytearray] = STATE(868),
    [sym_verbatim_bytearray] = STATE(868),
    [sym_format_triple_quoted_string] = STATE(870),
    [sym_triple_quoted_string] = STATE(868),
    [sym_const] = STATE(867),
    [sym_long_identifier] = STATE(872),
    [sym_active_pattern] = STATE(871),
    [sym__identifier_or_op] = STATE(873),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(656),
    [sym_infix_op] = STATE(581),
    [sym_sbyte] = STATE(868),
    [sym_byte] = STATE(868),
    [sym_int16] = STATE(868),
    [sym_uint16] = STATE(868),
    [sym_int32] = STATE(868),
    [sym_uint32] = STATE(868),
    [sym_nativeint] = STATE(868),
    [sym_unativeint] = STATE(868),
    [sym_int64] = STATE(868),
    [sym_uint64] = STATE(868),
    [sym_ieee32] = STATE(868),
    [sym_ieee64] = STATE(868),
    [sym_bignum] = STATE(868),
    [sym_decimal] = STATE(868),
    [sym_float] = STATE(1368),
    [sym_block_comment] = STATE(250),
    [sym_compiler_directive_decl] = STATE(250),
    [sym_fsi_directive_decl] = STATE(250),
    [sym_preproc_line] = STATE(250),
    [sym_preproc_if_in_expression] = STATE(867),
    [aux_sym_sequential_expression_repeat1] = STATE(1542),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(29),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(825),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_COMMA] = ACTIONS(827),
    [anon_sym_null] = ACTIONS(49),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACK_PIPE] = ACTIONS(57),
    [anon_sym_LBRACE] = ACTIONS(139),
    [anon_sym_LT_AT] = ACTIONS(61),
    [anon_sym_LT_AT_AT] = ACTIONS(63),
    [anon_sym_DOT] = ACTIONS(65),
    [anon_sym_LBRACE_PIPE] = ACTIONS(67),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_return_BANG] = ACTIONS(829),
    [anon_sym_yield] = ACTIONS(825),
    [anon_sym_yield_BANG] = ACTIONS(829),
    [anon_sym_lazy] = ACTIONS(825),
    [anon_sym_assert] = ACTIONS(825),
    [anon_sym_upcast] = ACTIONS(825),
    [anon_sym_downcast] = ACTIONS(825),
    [anon_sym_COLON_GT] = ACTIONS(71),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(71),
    [anon_sym_for] = ACTIONS(73),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(79),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_match] = ACTIONS(83),
    [anon_sym_match_BANG] = ACTIONS(85),
    [anon_sym_function] = ACTIONS(87),
    [anon_sym_LT_DASH] = ACTIONS(831),
    [anon_sym_DOT_LBRACK] = ACTIONS(91),
    [anon_sym_LT] = ACTIONS(93),
    [anon_sym_use] = ACTIONS(833),
    [anon_sym_use_BANG] = ACTIONS(835),
    [anon_sym_do_BANG] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(101),
    [anon_sym_LPAREN2] = ACTIONS(103),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(105),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(107),
    [anon_sym_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DQUOTE] = ACTIONS(111),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(115),
    [sym_bool] = ACTIONS(117),
    [sym_unit] = ACTIONS(119),
    [anon_sym_LPAREN_PIPE] = ACTIONS(121),
    [sym_op_identifier] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(837),
    [sym_xint] = ACTIONS(387),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(135),
    [sym__newline] = ACTIONS(839),
    [sym__dedent] = ACTIONS(1425),
  },
  [251] = {
    [sym_function_or_value_defn] = STATE(600),
    [sym__expression] = STATE(88),
    [sym_literal_expression] = STATE(867),
    [sym_long_identifier_or_op] = STATE(867),
    [sym_tuple_expression] = STATE(867),
    [sym_brace_expression] = STATE(867),
    [sym_anon_record_expression] = STATE(867),
    [sym_prefixed_expression] = STATE(867),
    [sym_typecast_expression] = STATE(867),
    [sym_for_expression] = STATE(867),
    [sym_while_expression] = STATE(867),
    [sym__if_branch] = STATE(6511),
    [sym_if_expression] = STATE(867),
    [sym_fun_expression] = STATE(867),
    [sym_try_expression] = STATE(867),
    [sym_match_expression] = STATE(867),
    [sym_function_expression] = STATE(867),
    [sym_mutate_expression] = STATE(867),
    [sym_index_expression] = STATE(867),
    [sym_typed_expression] = STATE(867),
    [sym_declaration_expression] = STATE(867),
    [sym_do_expression] = STATE(867),
    [sym_list_expression] = STATE(867),
    [sym_array_expression] = STATE(867),
    [sym_begin_end_expression] = STATE(867),
    [sym_paren_expression] = STATE(867),
    [sym__high_prec_app] = STATE(864),
    [sym__low_prec_app] = STATE(864),
    [sym_application_expression] = STATE(867),
    [sym_dot_expression] = STATE(867),
    [sym_infix_expression] = STATE(867),
    [sym_ce_expression] = STATE(867),
    [sym_sequential_expression] = STATE(867),
    [sym_char] = STATE(868),
    [sym_format_string] = STATE(869),
    [sym__string_literal] = STATE(869),
    [sym_string] = STATE(868),
    [sym_verbatim_string] = STATE(868),
    [sym_bytearray] = STATE(868),
    [sym_verbatim_bytearray] = STATE(868),
    [sym_format_triple_quoted_string] = STATE(870),
    [sym_triple_quoted_string] = STATE(868),
    [sym_const] = STATE(867),
    [sym_long_identifier] = STATE(872),
    [sym_active_pattern] = STATE(871),
    [sym__identifier_or_op] = STATE(873),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(656),
    [sym_infix_op] = STATE(581),
    [sym_sbyte] = STATE(868),
    [sym_byte] = STATE(868),
    [sym_int16] = STATE(868),
    [sym_uint16] = STATE(868),
    [sym_int32] = STATE(868),
    [sym_uint32] = STATE(868),
    [sym_nativeint] = STATE(868),
    [sym_unativeint] = STATE(868),
    [sym_int64] = STATE(868),
    [sym_uint64] = STATE(868),
    [sym_ieee32] = STATE(868),
    [sym_ieee64] = STATE(868),
    [sym_bignum] = STATE(868),
    [sym_decimal] = STATE(868),
    [sym_float] = STATE(1368),
    [sym_block_comment] = STATE(251),
    [sym_compiler_directive_decl] = STATE(251),
    [sym_fsi_directive_decl] = STATE(251),
    [sym_preproc_line] = STATE(251),
    [sym_preproc_if_in_expression] = STATE(867),
    [aux_sym_sequential_expression_repeat1] = STATE(1542),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(29),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(825),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_COMMA] = ACTIONS(827),
    [anon_sym_null] = ACTIONS(49),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACK_PIPE] = ACTIONS(57),
    [anon_sym_LBRACE] = ACTIONS(139),
    [anon_sym_LT_AT] = ACTIONS(61),
    [anon_sym_LT_AT_AT] = ACTIONS(63),
    [anon_sym_DOT] = ACTIONS(65),
    [anon_sym_LBRACE_PIPE] = ACTIONS(67),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_return_BANG] = ACTIONS(829),
    [anon_sym_yield] = ACTIONS(825),
    [anon_sym_yield_BANG] = ACTIONS(829),
    [anon_sym_lazy] = ACTIONS(825),
    [anon_sym_assert] = ACTIONS(825),
    [anon_sym_upcast] = ACTIONS(825),
    [anon_sym_downcast] = ACTIONS(825),
    [anon_sym_COLON_GT] = ACTIONS(71),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(71),
    [anon_sym_for] = ACTIONS(73),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(79),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_match] = ACTIONS(83),
    [anon_sym_match_BANG] = ACTIONS(85),
    [anon_sym_function] = ACTIONS(87),
    [anon_sym_LT_DASH] = ACTIONS(831),
    [anon_sym_DOT_LBRACK] = ACTIONS(91),
    [anon_sym_LT] = ACTIONS(93),
    [anon_sym_use] = ACTIONS(833),
    [anon_sym_use_BANG] = ACTIONS(835),
    [anon_sym_do_BANG] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(101),
    [anon_sym_LPAREN2] = ACTIONS(103),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(105),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(107),
    [anon_sym_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DQUOTE] = ACTIONS(111),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(115),
    [sym_bool] = ACTIONS(117),
    [sym_unit] = ACTIONS(119),
    [anon_sym_LPAREN_PIPE] = ACTIONS(121),
    [sym_op_identifier] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(837),
    [sym_xint] = ACTIONS(387),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(135),
    [sym__newline] = ACTIONS(839),
    [sym__dedent] = ACTIONS(1427),
  },
  [252] = {
    [sym_function_or_value_defn] = STATE(627),
    [sym__expression] = STATE(17),
    [sym_literal_expression] = STATE(1118),
    [sym_long_identifier_or_op] = STATE(1118),
    [sym_tuple_expression] = STATE(1118),
    [sym_brace_expression] = STATE(1118),
    [sym_anon_record_expression] = STATE(1118),
    [sym_prefixed_expression] = STATE(1118),
    [sym_typecast_expression] = STATE(1118),
    [sym_for_expression] = STATE(1118),
    [sym_while_expression] = STATE(1118),
    [sym__if_branch] = STATE(7163),
    [sym_if_expression] = STATE(1118),
    [sym_fun_expression] = STATE(1118),
    [sym_try_expression] = STATE(1118),
    [sym_match_expression] = STATE(1118),
    [sym_function_expression] = STATE(1118),
    [sym_mutate_expression] = STATE(1118),
    [sym_index_expression] = STATE(1118),
    [sym_typed_expression] = STATE(1118),
    [sym_declaration_expression] = STATE(1118),
    [sym_do_expression] = STATE(1118),
    [sym_list_expression] = STATE(1118),
    [sym_array_expression] = STATE(1118),
    [sym_begin_end_expression] = STATE(1118),
    [sym_paren_expression] = STATE(1118),
    [sym__high_prec_app] = STATE(1133),
    [sym__low_prec_app] = STATE(1133),
    [sym_application_expression] = STATE(1118),
    [sym_dot_expression] = STATE(1118),
    [sym_infix_expression] = STATE(1118),
    [sym_ce_expression] = STATE(1118),
    [sym_sequential_expression] = STATE(1118),
    [sym_char] = STATE(1080),
    [sym_format_string] = STATE(1090),
    [sym__string_literal] = STATE(1090),
    [sym_string] = STATE(1080),
    [sym_verbatim_string] = STATE(1080),
    [sym_bytearray] = STATE(1080),
    [sym_verbatim_bytearray] = STATE(1080),
    [sym_format_triple_quoted_string] = STATE(1096),
    [sym_triple_quoted_string] = STATE(1080),
    [sym_const] = STATE(1118),
    [sym_long_identifier] = STATE(1156),
    [sym_active_pattern] = STATE(1085),
    [sym__identifier_or_op] = STATE(1099),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(517),
    [sym_infix_op] = STATE(487),
    [sym_sbyte] = STATE(1080),
    [sym_byte] = STATE(1080),
    [sym_int16] = STATE(1080),
    [sym_uint16] = STATE(1080),
    [sym_int32] = STATE(1080),
    [sym_uint32] = STATE(1080),
    [sym_nativeint] = STATE(1080),
    [sym_unativeint] = STATE(1080),
    [sym_int64] = STATE(1080),
    [sym_uint64] = STATE(1080),
    [sym_ieee32] = STATE(1080),
    [sym_ieee64] = STATE(1080),
    [sym_bignum] = STATE(1080),
    [sym_decimal] = STATE(1080),
    [sym_float] = STATE(979),
    [sym_block_comment] = STATE(252),
    [sym_compiler_directive_decl] = STATE(252),
    [sym_fsi_directive_decl] = STATE(252),
    [sym_preproc_line] = STATE(252),
    [sym_preproc_if_in_expression] = STATE(1118),
    [aux_sym_sequential_expression_repeat1] = STATE(1069),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(195),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(197),
    [anon_sym_return] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_COMMA] = ACTIONS(205),
    [anon_sym_null] = ACTIONS(207),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(197),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(209),
    [anon_sym_LBRACK_PIPE] = ACTIONS(211),
    [anon_sym_LBRACE] = ACTIONS(271),
    [anon_sym_LT_AT] = ACTIONS(213),
    [anon_sym_LT_AT_AT] = ACTIONS(215),
    [anon_sym_DOT] = ACTIONS(185),
    [anon_sym_LBRACE_PIPE] = ACTIONS(217),
    [anon_sym_new] = ACTIONS(199),
    [anon_sym_with] = ACTIONS(1429),
    [anon_sym_return_BANG] = ACTIONS(219),
    [anon_sym_yield] = ACTIONS(199),
    [anon_sym_yield_BANG] = ACTIONS(219),
    [anon_sym_lazy] = ACTIONS(199),
    [anon_sym_assert] = ACTIONS(199),
    [anon_sym_upcast] = ACTIONS(199),
    [anon_sym_downcast] = ACTIONS(199),
    [anon_sym_COLON_GT] = ACTIONS(221),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(221),
    [anon_sym_for] = ACTIONS(223),
    [anon_sym_while] = ACTIONS(225),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(229),
    [anon_sym_match] = ACTIONS(231),
    [anon_sym_match_BANG] = ACTIONS(233),
    [anon_sym_function] = ACTIONS(235),
    [anon_sym_LT_DASH] = ACTIONS(237),
    [anon_sym_DOT_LBRACK] = ACTIONS(187),
    [anon_sym_LT] = ACTIONS(189),
    [anon_sym_use] = ACTIONS(239),
    [anon_sym_use_BANG] = ACTIONS(241),
    [anon_sym_do_BANG] = ACTIONS(243),
    [anon_sym_begin] = ACTIONS(245),
    [anon_sym_LPAREN2] = ACTIONS(191),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(247),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(251),
    [anon_sym_AT_DQUOTE] = ACTIONS(253),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(255),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(257),
    [sym_bool] = ACTIONS(259),
    [sym_unit] = ACTIONS(193),
    [anon_sym_LPAREN_PIPE] = ACTIONS(261),
    [sym_op_identifier] = ACTIONS(263),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(265),
    [sym_xint] = ACTIONS(267),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(269),
    [sym__newline] = ACTIONS(1431),
  },
  [253] = {
    [sym_function_or_value_defn] = STATE(600),
    [sym__expression] = STATE(88),
    [sym_literal_expression] = STATE(867),
    [sym_long_identifier_or_op] = STATE(867),
    [sym_tuple_expression] = STATE(867),
    [sym_brace_expression] = STATE(867),
    [sym_anon_record_expression] = STATE(867),
    [sym_prefixed_expression] = STATE(867),
    [sym_typecast_expression] = STATE(867),
    [sym_for_expression] = STATE(867),
    [sym_while_expression] = STATE(867),
    [sym__if_branch] = STATE(6511),
    [sym_if_expression] = STATE(867),
    [sym_fun_expression] = STATE(867),
    [sym_try_expression] = STATE(867),
    [sym_match_expression] = STATE(867),
    [sym_function_expression] = STATE(867),
    [sym_mutate_expression] = STATE(867),
    [sym_index_expression] = STATE(867),
    [sym_typed_expression] = STATE(867),
    [sym_declaration_expression] = STATE(867),
    [sym_do_expression] = STATE(867),
    [sym_list_expression] = STATE(867),
    [sym_array_expression] = STATE(867),
    [sym_begin_end_expression] = STATE(867),
    [sym_paren_expression] = STATE(867),
    [sym__high_prec_app] = STATE(864),
    [sym__low_prec_app] = STATE(864),
    [sym_application_expression] = STATE(867),
    [sym_dot_expression] = STATE(867),
    [sym_infix_expression] = STATE(867),
    [sym_ce_expression] = STATE(867),
    [sym_sequential_expression] = STATE(867),
    [sym_char] = STATE(868),
    [sym_format_string] = STATE(869),
    [sym__string_literal] = STATE(869),
    [sym_string] = STATE(868),
    [sym_verbatim_string] = STATE(868),
    [sym_bytearray] = STATE(868),
    [sym_verbatim_bytearray] = STATE(868),
    [sym_format_triple_quoted_string] = STATE(870),
    [sym_triple_quoted_string] = STATE(868),
    [sym_const] = STATE(867),
    [sym_long_identifier] = STATE(872),
    [sym_active_pattern] = STATE(871),
    [sym__identifier_or_op] = STATE(873),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(656),
    [sym_infix_op] = STATE(581),
    [sym_sbyte] = STATE(868),
    [sym_byte] = STATE(868),
    [sym_int16] = STATE(868),
    [sym_uint16] = STATE(868),
    [sym_int32] = STATE(868),
    [sym_uint32] = STATE(868),
    [sym_nativeint] = STATE(868),
    [sym_unativeint] = STATE(868),
    [sym_int64] = STATE(868),
    [sym_uint64] = STATE(868),
    [sym_ieee32] = STATE(868),
    [sym_ieee64] = STATE(868),
    [sym_bignum] = STATE(868),
    [sym_decimal] = STATE(868),
    [sym_float] = STATE(1368),
    [sym_block_comment] = STATE(253),
    [sym_compiler_directive_decl] = STATE(253),
    [sym_fsi_directive_decl] = STATE(253),
    [sym_preproc_line] = STATE(253),
    [sym_preproc_if_in_expression] = STATE(867),
    [aux_sym_sequential_expression_repeat1] = STATE(1542),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(29),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(825),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_COMMA] = ACTIONS(875),
    [anon_sym_null] = ACTIONS(49),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACK_PIPE] = ACTIONS(57),
    [anon_sym_LBRACE] = ACTIONS(139),
    [anon_sym_LT_AT] = ACTIONS(61),
    [anon_sym_LT_AT_AT] = ACTIONS(63),
    [anon_sym_DOT] = ACTIONS(65),
    [anon_sym_LBRACE_PIPE] = ACTIONS(67),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_return_BANG] = ACTIONS(829),
    [anon_sym_yield] = ACTIONS(825),
    [anon_sym_yield_BANG] = ACTIONS(829),
    [anon_sym_lazy] = ACTIONS(825),
    [anon_sym_assert] = ACTIONS(825),
    [anon_sym_upcast] = ACTIONS(825),
    [anon_sym_downcast] = ACTIONS(825),
    [anon_sym_COLON_GT] = ACTIONS(71),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(71),
    [anon_sym_for] = ACTIONS(73),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(79),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_match] = ACTIONS(83),
    [anon_sym_match_BANG] = ACTIONS(85),
    [anon_sym_function] = ACTIONS(87),
    [anon_sym_LT_DASH] = ACTIONS(831),
    [anon_sym_DOT_LBRACK] = ACTIONS(91),
    [anon_sym_LT] = ACTIONS(93),
    [anon_sym_use] = ACTIONS(833),
    [anon_sym_use_BANG] = ACTIONS(835),
    [anon_sym_do_BANG] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(101),
    [anon_sym_LPAREN2] = ACTIONS(103),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(105),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(107),
    [anon_sym_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DQUOTE] = ACTIONS(111),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(115),
    [sym_bool] = ACTIONS(117),
    [sym_unit] = ACTIONS(119),
    [anon_sym_LPAREN_PIPE] = ACTIONS(121),
    [sym_op_identifier] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(837),
    [sym_xint] = ACTIONS(387),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(135),
    [sym__newline] = ACTIONS(839),
    [sym__dedent] = ACTIONS(875),
  },
  [254] = {
    [sym_function_or_value_defn] = STATE(600),
    [sym__expression] = STATE(88),
    [sym_literal_expression] = STATE(867),
    [sym_long_identifier_or_op] = STATE(867),
    [sym_tuple_expression] = STATE(867),
    [sym_brace_expression] = STATE(867),
    [sym_anon_record_expression] = STATE(867),
    [sym_prefixed_expression] = STATE(867),
    [sym_typecast_expression] = STATE(867),
    [sym_for_expression] = STATE(867),
    [sym_while_expression] = STATE(867),
    [sym__if_branch] = STATE(6511),
    [sym_if_expression] = STATE(867),
    [sym_fun_expression] = STATE(867),
    [sym_try_expression] = STATE(867),
    [sym_match_expression] = STATE(867),
    [sym_function_expression] = STATE(867),
    [sym_mutate_expression] = STATE(867),
    [sym_index_expression] = STATE(867),
    [sym_typed_expression] = STATE(867),
    [sym_declaration_expression] = STATE(867),
    [sym_do_expression] = STATE(867),
    [sym_list_expression] = STATE(867),
    [sym_array_expression] = STATE(867),
    [sym_begin_end_expression] = STATE(867),
    [sym_paren_expression] = STATE(867),
    [sym__high_prec_app] = STATE(864),
    [sym__low_prec_app] = STATE(864),
    [sym_application_expression] = STATE(867),
    [sym_dot_expression] = STATE(867),
    [sym_infix_expression] = STATE(867),
    [sym_ce_expression] = STATE(867),
    [sym_sequential_expression] = STATE(867),
    [sym_char] = STATE(868),
    [sym_format_string] = STATE(869),
    [sym__string_literal] = STATE(869),
    [sym_string] = STATE(868),
    [sym_verbatim_string] = STATE(868),
    [sym_bytearray] = STATE(868),
    [sym_verbatim_bytearray] = STATE(868),
    [sym_format_triple_quoted_string] = STATE(870),
    [sym_triple_quoted_string] = STATE(868),
    [sym_const] = STATE(867),
    [sym_long_identifier] = STATE(872),
    [sym_active_pattern] = STATE(871),
    [sym__identifier_or_op] = STATE(873),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(656),
    [sym_infix_op] = STATE(581),
    [sym_sbyte] = STATE(868),
    [sym_byte] = STATE(868),
    [sym_int16] = STATE(868),
    [sym_uint16] = STATE(868),
    [sym_int32] = STATE(868),
    [sym_uint32] = STATE(868),
    [sym_nativeint] = STATE(868),
    [sym_unativeint] = STATE(868),
    [sym_int64] = STATE(868),
    [sym_uint64] = STATE(868),
    [sym_ieee32] = STATE(868),
    [sym_ieee64] = STATE(868),
    [sym_bignum] = STATE(868),
    [sym_decimal] = STATE(868),
    [sym_float] = STATE(1368),
    [sym_block_comment] = STATE(254),
    [sym_compiler_directive_decl] = STATE(254),
    [sym_fsi_directive_decl] = STATE(254),
    [sym_preproc_line] = STATE(254),
    [sym_preproc_if_in_expression] = STATE(867),
    [aux_sym_sequential_expression_repeat1] = STATE(1542),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(29),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(825),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_COMMA] = ACTIONS(827),
    [anon_sym_null] = ACTIONS(49),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACK_PIPE] = ACTIONS(57),
    [anon_sym_LBRACE] = ACTIONS(139),
    [anon_sym_LT_AT] = ACTIONS(61),
    [anon_sym_LT_AT_AT] = ACTIONS(63),
    [anon_sym_DOT] = ACTIONS(65),
    [anon_sym_LBRACE_PIPE] = ACTIONS(67),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_return_BANG] = ACTIONS(829),
    [anon_sym_yield] = ACTIONS(825),
    [anon_sym_yield_BANG] = ACTIONS(829),
    [anon_sym_lazy] = ACTIONS(825),
    [anon_sym_assert] = ACTIONS(825),
    [anon_sym_upcast] = ACTIONS(825),
    [anon_sym_downcast] = ACTIONS(825),
    [anon_sym_COLON_GT] = ACTIONS(71),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(71),
    [anon_sym_for] = ACTIONS(73),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(79),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_match] = ACTIONS(83),
    [anon_sym_match_BANG] = ACTIONS(85),
    [anon_sym_function] = ACTIONS(87),
    [anon_sym_LT_DASH] = ACTIONS(831),
    [anon_sym_DOT_LBRACK] = ACTIONS(91),
    [anon_sym_LT] = ACTIONS(93),
    [anon_sym_use] = ACTIONS(833),
    [anon_sym_use_BANG] = ACTIONS(835),
    [anon_sym_do_BANG] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(101),
    [anon_sym_LPAREN2] = ACTIONS(103),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(105),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(107),
    [anon_sym_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DQUOTE] = ACTIONS(111),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(115),
    [sym_bool] = ACTIONS(117),
    [sym_unit] = ACTIONS(119),
    [anon_sym_LPAREN_PIPE] = ACTIONS(121),
    [sym_op_identifier] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(837),
    [sym_xint] = ACTIONS(387),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(135),
    [sym__newline] = ACTIONS(839),
    [sym__dedent] = ACTIONS(1433),
  },
  [255] = {
    [sym_function_or_value_defn] = STATE(509),
    [sym__expression] = STATE(326),
    [sym_literal_expression] = STATE(2230),
    [sym_long_identifier_or_op] = STATE(2230),
    [sym_tuple_expression] = STATE(2230),
    [sym_brace_expression] = STATE(2230),
    [sym_anon_record_expression] = STATE(2230),
    [sym_prefixed_expression] = STATE(2230),
    [sym_typecast_expression] = STATE(2230),
    [sym_for_expression] = STATE(2230),
    [sym_while_expression] = STATE(2230),
    [sym__if_branch] = STATE(6659),
    [sym_if_expression] = STATE(2230),
    [sym_fun_expression] = STATE(2230),
    [sym_try_expression] = STATE(2230),
    [sym_match_expression] = STATE(2230),
    [sym_function_expression] = STATE(2230),
    [sym_mutate_expression] = STATE(2230),
    [sym_index_expression] = STATE(2230),
    [sym_typed_expression] = STATE(2230),
    [sym_declaration_expression] = STATE(2230),
    [sym_do_expression] = STATE(2230),
    [sym_list_expression] = STATE(2230),
    [sym_array_expression] = STATE(2230),
    [sym_begin_end_expression] = STATE(2230),
    [sym_paren_expression] = STATE(2230),
    [sym__high_prec_app] = STATE(2229),
    [sym__low_prec_app] = STATE(2229),
    [sym_application_expression] = STATE(2230),
    [sym_dot_expression] = STATE(2230),
    [sym_infix_expression] = STATE(2230),
    [sym_ce_expression] = STATE(2230),
    [sym_sequential_expression] = STATE(2230),
    [sym_char] = STATE(2100),
    [sym_format_string] = STATE(2106),
    [sym__string_literal] = STATE(2106),
    [sym_string] = STATE(2100),
    [sym_verbatim_string] = STATE(2100),
    [sym_bytearray] = STATE(2100),
    [sym_verbatim_bytearray] = STATE(2100),
    [sym_format_triple_quoted_string] = STATE(2107),
    [sym_triple_quoted_string] = STATE(2100),
    [sym_const] = STATE(2230),
    [sym_long_identifier] = STATE(2232),
    [sym_active_pattern] = STATE(2424),
    [sym__identifier_or_op] = STATE(2305),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(737),
    [sym_infix_op] = STATE(694),
    [sym_sbyte] = STATE(2100),
    [sym_byte] = STATE(2100),
    [sym_int16] = STATE(2100),
    [sym_uint16] = STATE(2100),
    [sym_int32] = STATE(2100),
    [sym_uint32] = STATE(2100),
    [sym_nativeint] = STATE(2100),
    [sym_unativeint] = STATE(2100),
    [sym_int64] = STATE(2100),
    [sym_uint64] = STATE(2100),
    [sym_ieee32] = STATE(2100),
    [sym_ieee64] = STATE(2100),
    [sym_bignum] = STATE(2100),
    [sym_decimal] = STATE(2100),
    [sym_float] = STATE(1487),
    [sym_block_comment] = STATE(255),
    [sym_compiler_directive_decl] = STATE(255),
    [sym_fsi_directive_decl] = STATE(255),
    [sym_preproc_line] = STATE(255),
    [sym_preproc_if_in_expression] = STATE(2230),
    [aux_sym_sequential_expression_repeat1] = STATE(1743),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(877),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(879),
    [anon_sym_return] = ACTIONS(881),
    [anon_sym_do] = ACTIONS(1435),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(885),
    [anon_sym_COMMA] = ACTIONS(887),
    [anon_sym_null] = ACTIONS(889),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(879),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(891),
    [anon_sym_LBRACK_PIPE] = ACTIONS(893),
    [anon_sym_LBRACE] = ACTIONS(895),
    [anon_sym_LT_AT] = ACTIONS(897),
    [anon_sym_LT_AT_AT] = ACTIONS(899),
    [anon_sym_DOT] = ACTIONS(901),
    [anon_sym_LBRACE_PIPE] = ACTIONS(903),
    [anon_sym_new] = ACTIONS(881),
    [anon_sym_return_BANG] = ACTIONS(905),
    [anon_sym_yield] = ACTIONS(881),
    [anon_sym_yield_BANG] = ACTIONS(905),
    [anon_sym_lazy] = ACTIONS(881),
    [anon_sym_assert] = ACTIONS(881),
    [anon_sym_upcast] = ACTIONS(881),
    [anon_sym_downcast] = ACTIONS(881),
    [anon_sym_COLON_GT] = ACTIONS(907),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(907),
    [anon_sym_for] = ACTIONS(909),
    [anon_sym_while] = ACTIONS(911),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(913),
    [anon_sym_try] = ACTIONS(915),
    [anon_sym_match] = ACTIONS(917),
    [anon_sym_match_BANG] = ACTIONS(919),
    [anon_sym_function] = ACTIONS(921),
    [anon_sym_LT_DASH] = ACTIONS(923),
    [anon_sym_DOT_LBRACK] = ACTIONS(925),
    [anon_sym_LT] = ACTIONS(927),
    [anon_sym_use] = ACTIONS(929),
    [anon_sym_use_BANG] = ACTIONS(931),
    [anon_sym_do_BANG] = ACTIONS(933),
    [anon_sym_DOT_DOT] = ACTIONS(935),
    [anon_sym_begin] = ACTIONS(937),
    [anon_sym_LPAREN2] = ACTIONS(939),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(941),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(943),
    [anon_sym_DQUOTE] = ACTIONS(945),
    [anon_sym_AT_DQUOTE] = ACTIONS(947),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(949),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(951),
    [sym_bool] = ACTIONS(953),
    [sym_unit] = ACTIONS(955),
    [anon_sym_LPAREN_PIPE] = ACTIONS(957),
    [sym_op_identifier] = ACTIONS(959),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(961),
    [sym_xint] = ACTIONS(963),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(965),
    [sym__newline] = ACTIONS(967),
  },
  [256] = {
    [sym_function_or_value_defn] = STATE(733),
    [sym__expression] = STATE(142),
    [sym_literal_expression] = STATE(2008),
    [sym_long_identifier_or_op] = STATE(2008),
    [sym_tuple_expression] = STATE(2008),
    [sym_brace_expression] = STATE(2008),
    [sym_anon_record_expression] = STATE(2008),
    [sym_prefixed_expression] = STATE(2008),
    [sym_typecast_expression] = STATE(2008),
    [sym_for_expression] = STATE(2008),
    [sym_while_expression] = STATE(2008),
    [sym__if_branch] = STATE(6754),
    [sym_if_expression] = STATE(2008),
    [sym_fun_expression] = STATE(2008),
    [sym_try_expression] = STATE(2008),
    [sym_match_expression] = STATE(2008),
    [sym_function_expression] = STATE(2008),
    [sym_mutate_expression] = STATE(2008),
    [sym_index_expression] = STATE(2008),
    [sym_typed_expression] = STATE(2008),
    [sym_declaration_expression] = STATE(2008),
    [sym_do_expression] = STATE(2008),
    [sym_list_expression] = STATE(2008),
    [sym_array_expression] = STATE(2008),
    [sym_begin_end_expression] = STATE(2008),
    [sym_paren_expression] = STATE(2008),
    [sym__high_prec_app] = STATE(2007),
    [sym__low_prec_app] = STATE(2007),
    [sym_application_expression] = STATE(2008),
    [sym_dot_expression] = STATE(2008),
    [sym_infix_expression] = STATE(2008),
    [sym_ce_expression] = STATE(2008),
    [sym_sequential_expression] = STATE(2008),
    [sym_char] = STATE(1859),
    [sym_format_string] = STATE(1861),
    [sym__string_literal] = STATE(1861),
    [sym_string] = STATE(1859),
    [sym_verbatim_string] = STATE(1859),
    [sym_bytearray] = STATE(1859),
    [sym_verbatim_bytearray] = STATE(1859),
    [sym_format_triple_quoted_string] = STATE(1862),
    [sym_triple_quoted_string] = STATE(1859),
    [sym_const] = STATE(2008),
    [sym_long_identifier] = STATE(1701),
    [sym_active_pattern] = STATE(1702),
    [sym__identifier_or_op] = STATE(1724),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(706),
    [sym_infix_op] = STATE(678),
    [sym_sbyte] = STATE(1859),
    [sym_byte] = STATE(1859),
    [sym_int16] = STATE(1859),
    [sym_uint16] = STATE(1859),
    [sym_int32] = STATE(1859),
    [sym_uint32] = STATE(1859),
    [sym_nativeint] = STATE(1859),
    [sym_unativeint] = STATE(1859),
    [sym_int64] = STATE(1859),
    [sym_uint64] = STATE(1859),
    [sym_ieee32] = STATE(1859),
    [sym_ieee64] = STATE(1859),
    [sym_bignum] = STATE(1859),
    [sym_decimal] = STATE(1859),
    [sym_float] = STATE(1447),
    [sym_block_comment] = STATE(256),
    [sym_compiler_directive_decl] = STATE(256),
    [sym_fsi_directive_decl] = STATE(256),
    [sym_preproc_line] = STATE(256),
    [sym_preproc_if_in_expression] = STATE(2008),
    [aux_sym_sequential_expression_repeat1] = STATE(1995),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(503),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(969),
    [anon_sym_return] = ACTIONS(971),
    [anon_sym_do] = ACTIONS(599),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(511),
    [anon_sym_COMMA] = ACTIONS(973),
    [anon_sym_null] = ACTIONS(515),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(969),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(517),
    [anon_sym_LBRACK_PIPE] = ACTIONS(519),
    [anon_sym_LBRACE] = ACTIONS(521),
    [anon_sym_LT_AT] = ACTIONS(523),
    [anon_sym_LT_AT_AT] = ACTIONS(525),
    [anon_sym_DOT] = ACTIONS(527),
    [anon_sym_LBRACE_PIPE] = ACTIONS(529),
    [anon_sym_new] = ACTIONS(971),
    [anon_sym_return_BANG] = ACTIONS(975),
    [anon_sym_yield] = ACTIONS(971),
    [anon_sym_yield_BANG] = ACTIONS(975),
    [anon_sym_lazy] = ACTIONS(971),
    [anon_sym_assert] = ACTIONS(971),
    [anon_sym_upcast] = ACTIONS(971),
    [anon_sym_downcast] = ACTIONS(971),
    [anon_sym_COLON_GT] = ACTIONS(977),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(977),
    [anon_sym_for] = ACTIONS(979),
    [anon_sym_while] = ACTIONS(537),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(539),
    [anon_sym_DASH_GT] = ACTIONS(1437),
    [anon_sym_try] = ACTIONS(543),
    [anon_sym_match] = ACTIONS(545),
    [anon_sym_match_BANG] = ACTIONS(547),
    [anon_sym_function] = ACTIONS(549),
    [anon_sym_LT_DASH] = ACTIONS(981),
    [anon_sym_DOT_LBRACK] = ACTIONS(553),
    [anon_sym_LT] = ACTIONS(555),
    [anon_sym_use] = ACTIONS(983),
    [anon_sym_use_BANG] = ACTIONS(985),
    [anon_sym_do_BANG] = ACTIONS(561),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_LPAREN2] = ACTIONS(567),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(569),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(571),
    [anon_sym_DQUOTE] = ACTIONS(573),
    [anon_sym_AT_DQUOTE] = ACTIONS(575),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(577),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(579),
    [sym_bool] = ACTIONS(581),
    [sym_unit] = ACTIONS(583),
    [anon_sym_LPAREN_PIPE] = ACTIONS(585),
    [sym_op_identifier] = ACTIONS(587),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(591),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(593),
    [sym__newline] = ACTIONS(1171),
  },
  [257] = {
    [sym_function_or_value_defn] = STATE(704),
    [sym__expression] = STATE(312),
    [sym_literal_expression] = STATE(2403),
    [sym_long_identifier_or_op] = STATE(2403),
    [sym_tuple_expression] = STATE(2403),
    [sym_brace_expression] = STATE(2403),
    [sym_anon_record_expression] = STATE(2403),
    [sym_prefixed_expression] = STATE(2403),
    [sym_typecast_expression] = STATE(2403),
    [sym_for_expression] = STATE(2403),
    [sym_while_expression] = STATE(2403),
    [sym__if_branch] = STATE(6794),
    [sym_if_expression] = STATE(2403),
    [sym_fun_expression] = STATE(2403),
    [sym_try_expression] = STATE(2403),
    [sym_match_expression] = STATE(2403),
    [sym_function_expression] = STATE(2403),
    [sym_mutate_expression] = STATE(2403),
    [sym_index_expression] = STATE(2403),
    [sym_typed_expression] = STATE(2403),
    [sym_declaration_expression] = STATE(2403),
    [sym_do_expression] = STATE(2403),
    [sym_list_expression] = STATE(2403),
    [sym_array_expression] = STATE(2403),
    [sym_begin_end_expression] = STATE(2403),
    [sym_paren_expression] = STATE(2403),
    [sym__high_prec_app] = STATE(2405),
    [sym__low_prec_app] = STATE(2405),
    [sym_application_expression] = STATE(2403),
    [sym_dot_expression] = STATE(2403),
    [sym_infix_expression] = STATE(2403),
    [sym_ce_expression] = STATE(2403),
    [sym_sequential_expression] = STATE(2403),
    [sym_char] = STATE(2425),
    [sym_format_string] = STATE(2420),
    [sym__string_literal] = STATE(2420),
    [sym_string] = STATE(2425),
    [sym_verbatim_string] = STATE(2425),
    [sym_bytearray] = STATE(2425),
    [sym_verbatim_bytearray] = STATE(2425),
    [sym_format_triple_quoted_string] = STATE(2419),
    [sym_triple_quoted_string] = STATE(2425),
    [sym_const] = STATE(2403),
    [sym_long_identifier] = STATE(2079),
    [sym_active_pattern] = STATE(2080),
    [sym__identifier_or_op] = STATE(2089),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(688),
    [sym_infix_op] = STATE(668),
    [sym_sbyte] = STATE(2425),
    [sym_byte] = STATE(2425),
    [sym_int16] = STATE(2425),
    [sym_uint16] = STATE(2425),
    [sym_int32] = STATE(2425),
    [sym_uint32] = STATE(2425),
    [sym_nativeint] = STATE(2425),
    [sym_unativeint] = STATE(2425),
    [sym_int64] = STATE(2425),
    [sym_uint64] = STATE(2425),
    [sym_ieee32] = STATE(2425),
    [sym_ieee64] = STATE(2425),
    [sym_bignum] = STATE(2425),
    [sym_decimal] = STATE(2425),
    [sym_float] = STATE(1511),
    [sym_block_comment] = STATE(257),
    [sym_compiler_directive_decl] = STATE(257),
    [sym_fsi_directive_decl] = STATE(257),
    [sym_preproc_line] = STATE(257),
    [sym_preproc_if_in_expression] = STATE(2403),
    [aux_sym_sequential_expression_repeat1] = STATE(1901),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(1261),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(1263),
    [anon_sym_return] = ACTIONS(1265),
    [anon_sym_do] = ACTIONS(1267),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(1269),
    [anon_sym_COMMA] = ACTIONS(1271),
    [anon_sym_null] = ACTIONS(1273),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(1263),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1275),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1277),
    [anon_sym_LBRACE] = ACTIONS(1279),
    [anon_sym_LT_AT] = ACTIONS(1281),
    [anon_sym_LT_AT_AT] = ACTIONS(1283),
    [anon_sym_DOT] = ACTIONS(1285),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1287),
    [anon_sym_new] = ACTIONS(1265),
    [anon_sym_return_BANG] = ACTIONS(1289),
    [anon_sym_yield] = ACTIONS(1265),
    [anon_sym_yield_BANG] = ACTIONS(1289),
    [anon_sym_lazy] = ACTIONS(1265),
    [anon_sym_assert] = ACTIONS(1265),
    [anon_sym_upcast] = ACTIONS(1265),
    [anon_sym_downcast] = ACTIONS(1265),
    [anon_sym_COLON_GT] = ACTIONS(1291),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1291),
    [anon_sym_for] = ACTIONS(1293),
    [anon_sym_while] = ACTIONS(1295),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(1297),
    [anon_sym_try] = ACTIONS(1299),
    [anon_sym_match] = ACTIONS(1301),
    [anon_sym_match_BANG] = ACTIONS(1303),
    [anon_sym_function] = ACTIONS(1305),
    [anon_sym_LT_DASH] = ACTIONS(1307),
    [anon_sym_DOT_LBRACK] = ACTIONS(1309),
    [anon_sym_LT] = ACTIONS(1311),
    [anon_sym_use] = ACTIONS(1313),
    [anon_sym_use_BANG] = ACTIONS(1315),
    [anon_sym_do_BANG] = ACTIONS(1317),
    [anon_sym_begin] = ACTIONS(1319),
    [anon_sym_LPAREN2] = ACTIONS(1321),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(1323),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1325),
    [anon_sym_DQUOTE] = ACTIONS(1327),
    [anon_sym_AT_DQUOTE] = ACTIONS(1329),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1331),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1333),
    [sym_bool] = ACTIONS(1335),
    [sym_unit] = ACTIONS(1337),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1339),
    [sym_op_identifier] = ACTIONS(1341),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(1343),
    [sym_xint] = ACTIONS(1345),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1347),
    [anon_sym_POUNDendif] = ACTIONS(171),
    [sym__newline] = ACTIONS(1349),
  },
  [258] = {
    [sym_function_or_value_defn] = STATE(527),
    [sym__expression] = STATE(260),
    [sym_literal_expression] = STATE(2384),
    [sym_long_identifier_or_op] = STATE(2384),
    [sym_tuple_expression] = STATE(2384),
    [sym_brace_expression] = STATE(2384),
    [sym_anon_record_expression] = STATE(2384),
    [sym_prefixed_expression] = STATE(2384),
    [sym_typecast_expression] = STATE(2384),
    [sym_for_expression] = STATE(2384),
    [sym_while_expression] = STATE(2384),
    [sym__if_branch] = STATE(6561),
    [sym_if_expression] = STATE(2384),
    [sym_fun_expression] = STATE(2384),
    [sym_try_expression] = STATE(2384),
    [sym_match_expression] = STATE(2384),
    [sym_function_expression] = STATE(2384),
    [sym_mutate_expression] = STATE(2384),
    [sym_index_expression] = STATE(2384),
    [sym_typed_expression] = STATE(2384),
    [sym_declaration_expression] = STATE(2384),
    [sym_do_expression] = STATE(2384),
    [sym_list_expression] = STATE(2384),
    [sym_array_expression] = STATE(2384),
    [sym_begin_end_expression] = STATE(2384),
    [sym_paren_expression] = STATE(2384),
    [sym__high_prec_app] = STATE(2249),
    [sym__low_prec_app] = STATE(2249),
    [sym_application_expression] = STATE(2384),
    [sym_dot_expression] = STATE(2384),
    [sym_infix_expression] = STATE(2384),
    [sym_ce_expression] = STATE(2384),
    [sym_sequential_expression] = STATE(2384),
    [sym_char] = STATE(2144),
    [sym_format_string] = STATE(2142),
    [sym__string_literal] = STATE(2142),
    [sym_string] = STATE(2144),
    [sym_verbatim_string] = STATE(2144),
    [sym_bytearray] = STATE(2144),
    [sym_verbatim_bytearray] = STATE(2144),
    [sym_format_triple_quoted_string] = STATE(2141),
    [sym_triple_quoted_string] = STATE(2144),
    [sym_const] = STATE(2384),
    [sym_long_identifier] = STATE(2400),
    [sym_active_pattern] = STATE(2317),
    [sym__identifier_or_op] = STATE(2392),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(633),
    [sym_infix_op] = STATE(511),
    [sym_sbyte] = STATE(2144),
    [sym_byte] = STATE(2144),
    [sym_int16] = STATE(2144),
    [sym_uint16] = STATE(2144),
    [sym_int32] = STATE(2144),
    [sym_uint32] = STATE(2144),
    [sym_nativeint] = STATE(2144),
    [sym_unativeint] = STATE(2144),
    [sym_int64] = STATE(2144),
    [sym_uint64] = STATE(2144),
    [sym_ieee32] = STATE(2144),
    [sym_ieee64] = STATE(2144),
    [sym_bignum] = STATE(2144),
    [sym_decimal] = STATE(2144),
    [sym_float] = STATE(1672),
    [sym_block_comment] = STATE(258),
    [sym_compiler_directive_decl] = STATE(258),
    [sym_fsi_directive_decl] = STATE(258),
    [sym_preproc_line] = STATE(258),
    [sym_preproc_if_in_expression] = STATE(2384),
    [aux_sym_sequential_expression_repeat1] = STATE(1748),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(1439),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(1441),
    [anon_sym_return] = ACTIONS(1443),
    [anon_sym_do] = ACTIONS(1445),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(1447),
    [anon_sym_COMMA] = ACTIONS(1449),
    [anon_sym_null] = ACTIONS(1451),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(1441),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1453),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1455),
    [anon_sym_LBRACE] = ACTIONS(1457),
    [anon_sym_LT_AT] = ACTIONS(1459),
    [anon_sym_LT_AT_AT] = ACTIONS(1461),
    [anon_sym_DOT] = ACTIONS(1463),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1465),
    [anon_sym_new] = ACTIONS(1443),
    [anon_sym_return_BANG] = ACTIONS(1467),
    [anon_sym_yield] = ACTIONS(1443),
    [anon_sym_yield_BANG] = ACTIONS(1467),
    [anon_sym_lazy] = ACTIONS(1443),
    [anon_sym_assert] = ACTIONS(1443),
    [anon_sym_upcast] = ACTIONS(1443),
    [anon_sym_downcast] = ACTIONS(1443),
    [anon_sym_COLON_GT] = ACTIONS(1469),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1469),
    [anon_sym_for] = ACTIONS(1471),
    [anon_sym_while] = ACTIONS(1473),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(1475),
    [anon_sym_try] = ACTIONS(1477),
    [anon_sym_match] = ACTIONS(1479),
    [anon_sym_match_BANG] = ACTIONS(1481),
    [anon_sym_function] = ACTIONS(1483),
    [anon_sym_LT_DASH] = ACTIONS(1485),
    [anon_sym_DOT_LBRACK] = ACTIONS(1487),
    [anon_sym_LT] = ACTIONS(1489),
    [anon_sym_GT] = ACTIONS(147),
    [anon_sym_use] = ACTIONS(1491),
    [anon_sym_use_BANG] = ACTIONS(1493),
    [anon_sym_do_BANG] = ACTIONS(1495),
    [anon_sym_begin] = ACTIONS(1497),
    [anon_sym_LPAREN2] = ACTIONS(1499),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(1501),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1503),
    [anon_sym_DQUOTE] = ACTIONS(1505),
    [anon_sym_AT_DQUOTE] = ACTIONS(1507),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1509),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1511),
    [sym_bool] = ACTIONS(1513),
    [sym_unit] = ACTIONS(1515),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1517),
    [sym_op_identifier] = ACTIONS(1519),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(1521),
    [sym_xint] = ACTIONS(1523),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1525),
    [sym__newline] = ACTIONS(145),
  },
  [259] = {
    [sym_function_or_value_defn] = STATE(527),
    [sym__expression] = STATE(260),
    [sym_literal_expression] = STATE(2384),
    [sym_long_identifier_or_op] = STATE(2384),
    [sym_tuple_expression] = STATE(2384),
    [sym_brace_expression] = STATE(2384),
    [sym_anon_record_expression] = STATE(2384),
    [sym_prefixed_expression] = STATE(2384),
    [sym_typecast_expression] = STATE(2384),
    [sym_for_expression] = STATE(2384),
    [sym_while_expression] = STATE(2384),
    [sym__if_branch] = STATE(6561),
    [sym_if_expression] = STATE(2384),
    [sym_fun_expression] = STATE(2384),
    [sym_try_expression] = STATE(2384),
    [sym_match_expression] = STATE(2384),
    [sym_function_expression] = STATE(2384),
    [sym_mutate_expression] = STATE(2384),
    [sym_index_expression] = STATE(2384),
    [sym_typed_expression] = STATE(2384),
    [sym_declaration_expression] = STATE(2384),
    [sym_do_expression] = STATE(2384),
    [sym_list_expression] = STATE(2384),
    [sym_array_expression] = STATE(2384),
    [sym_begin_end_expression] = STATE(2384),
    [sym_paren_expression] = STATE(2384),
    [sym__high_prec_app] = STATE(2249),
    [sym__low_prec_app] = STATE(2249),
    [sym_application_expression] = STATE(2384),
    [sym_dot_expression] = STATE(2384),
    [sym_infix_expression] = STATE(2384),
    [sym_ce_expression] = STATE(2384),
    [sym_sequential_expression] = STATE(2384),
    [sym_char] = STATE(2144),
    [sym_format_string] = STATE(2142),
    [sym__string_literal] = STATE(2142),
    [sym_string] = STATE(2144),
    [sym_verbatim_string] = STATE(2144),
    [sym_bytearray] = STATE(2144),
    [sym_verbatim_bytearray] = STATE(2144),
    [sym_format_triple_quoted_string] = STATE(2141),
    [sym_triple_quoted_string] = STATE(2144),
    [sym_const] = STATE(2384),
    [sym_long_identifier] = STATE(2400),
    [sym_active_pattern] = STATE(2317),
    [sym__identifier_or_op] = STATE(2392),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(633),
    [sym_infix_op] = STATE(511),
    [sym_sbyte] = STATE(2144),
    [sym_byte] = STATE(2144),
    [sym_int16] = STATE(2144),
    [sym_uint16] = STATE(2144),
    [sym_int32] = STATE(2144),
    [sym_uint32] = STATE(2144),
    [sym_nativeint] = STATE(2144),
    [sym_unativeint] = STATE(2144),
    [sym_int64] = STATE(2144),
    [sym_uint64] = STATE(2144),
    [sym_ieee32] = STATE(2144),
    [sym_ieee64] = STATE(2144),
    [sym_bignum] = STATE(2144),
    [sym_decimal] = STATE(2144),
    [sym_float] = STATE(1672),
    [sym_block_comment] = STATE(259),
    [sym_compiler_directive_decl] = STATE(259),
    [sym_fsi_directive_decl] = STATE(259),
    [sym_preproc_line] = STATE(259),
    [sym_preproc_if_in_expression] = STATE(2384),
    [aux_sym_sequential_expression_repeat1] = STATE(1748),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(1439),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(1441),
    [anon_sym_return] = ACTIONS(1443),
    [anon_sym_do] = ACTIONS(1445),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(1447),
    [anon_sym_COMMA] = ACTIONS(1449),
    [anon_sym_null] = ACTIONS(1451),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(1441),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1453),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1455),
    [anon_sym_LBRACE] = ACTIONS(1457),
    [anon_sym_LT_AT] = ACTIONS(1459),
    [anon_sym_LT_AT_AT] = ACTIONS(1461),
    [anon_sym_DOT] = ACTIONS(1463),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1465),
    [anon_sym_new] = ACTIONS(1443),
    [anon_sym_return_BANG] = ACTIONS(1467),
    [anon_sym_yield] = ACTIONS(1443),
    [anon_sym_yield_BANG] = ACTIONS(1467),
    [anon_sym_lazy] = ACTIONS(1443),
    [anon_sym_assert] = ACTIONS(1443),
    [anon_sym_upcast] = ACTIONS(1443),
    [anon_sym_downcast] = ACTIONS(1443),
    [anon_sym_COLON_GT] = ACTIONS(1469),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1469),
    [anon_sym_for] = ACTIONS(1471),
    [anon_sym_while] = ACTIONS(1473),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(1475),
    [anon_sym_try] = ACTIONS(1477),
    [anon_sym_match] = ACTIONS(1479),
    [anon_sym_match_BANG] = ACTIONS(1481),
    [anon_sym_function] = ACTIONS(1483),
    [anon_sym_LT_DASH] = ACTIONS(1485),
    [anon_sym_DOT_LBRACK] = ACTIONS(1487),
    [anon_sym_LT] = ACTIONS(1489),
    [anon_sym_GT] = ACTIONS(151),
    [anon_sym_use] = ACTIONS(1491),
    [anon_sym_use_BANG] = ACTIONS(1493),
    [anon_sym_do_BANG] = ACTIONS(1495),
    [anon_sym_begin] = ACTIONS(1497),
    [anon_sym_LPAREN2] = ACTIONS(1499),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(1501),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1503),
    [anon_sym_DQUOTE] = ACTIONS(1505),
    [anon_sym_AT_DQUOTE] = ACTIONS(1507),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1509),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1511),
    [sym_bool] = ACTIONS(1513),
    [sym_unit] = ACTIONS(1515),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1517),
    [sym_op_identifier] = ACTIONS(1519),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(1521),
    [sym_xint] = ACTIONS(1523),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1525),
    [sym__newline] = ACTIONS(1527),
  },
  [260] = {
    [sym_function_or_value_defn] = STATE(527),
    [sym__expression] = STATE(260),
    [sym_literal_expression] = STATE(2384),
    [sym_long_identifier_or_op] = STATE(2384),
    [sym_tuple_expression] = STATE(2384),
    [sym_brace_expression] = STATE(2384),
    [sym_anon_record_expression] = STATE(2384),
    [sym_prefixed_expression] = STATE(2384),
    [sym_typecast_expression] = STATE(2384),
    [sym_for_expression] = STATE(2384),
    [sym_while_expression] = STATE(2384),
    [sym__if_branch] = STATE(6561),
    [sym_if_expression] = STATE(2384),
    [sym_fun_expression] = STATE(2384),
    [sym_try_expression] = STATE(2384),
    [sym_match_expression] = STATE(2384),
    [sym_function_expression] = STATE(2384),
    [sym_mutate_expression] = STATE(2384),
    [sym_index_expression] = STATE(2384),
    [sym_typed_expression] = STATE(2384),
    [sym_declaration_expression] = STATE(2384),
    [sym_do_expression] = STATE(2384),
    [sym_list_expression] = STATE(2384),
    [sym_array_expression] = STATE(2384),
    [sym_begin_end_expression] = STATE(2384),
    [sym_paren_expression] = STATE(2384),
    [sym__high_prec_app] = STATE(2249),
    [sym__low_prec_app] = STATE(2249),
    [sym_application_expression] = STATE(2384),
    [sym_dot_expression] = STATE(2384),
    [sym_infix_expression] = STATE(2384),
    [sym_ce_expression] = STATE(2384),
    [sym_sequential_expression] = STATE(2384),
    [sym_char] = STATE(2144),
    [sym_format_string] = STATE(2142),
    [sym__string_literal] = STATE(2142),
    [sym_string] = STATE(2144),
    [sym_verbatim_string] = STATE(2144),
    [sym_bytearray] = STATE(2144),
    [sym_verbatim_bytearray] = STATE(2144),
    [sym_format_triple_quoted_string] = STATE(2141),
    [sym_triple_quoted_string] = STATE(2144),
    [sym_const] = STATE(2384),
    [sym_long_identifier] = STATE(2400),
    [sym_active_pattern] = STATE(2317),
    [sym__identifier_or_op] = STATE(2392),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(633),
    [sym_infix_op] = STATE(511),
    [sym_sbyte] = STATE(2144),
    [sym_byte] = STATE(2144),
    [sym_int16] = STATE(2144),
    [sym_uint16] = STATE(2144),
    [sym_int32] = STATE(2144),
    [sym_uint32] = STATE(2144),
    [sym_nativeint] = STATE(2144),
    [sym_unativeint] = STATE(2144),
    [sym_int64] = STATE(2144),
    [sym_uint64] = STATE(2144),
    [sym_ieee32] = STATE(2144),
    [sym_ieee64] = STATE(2144),
    [sym_bignum] = STATE(2144),
    [sym_decimal] = STATE(2144),
    [sym_float] = STATE(1672),
    [sym_block_comment] = STATE(260),
    [sym_compiler_directive_decl] = STATE(260),
    [sym_fsi_directive_decl] = STATE(260),
    [sym_preproc_line] = STATE(260),
    [sym_preproc_if_in_expression] = STATE(2384),
    [aux_sym_sequential_expression_repeat1] = STATE(1748),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_EQ] = ACTIONS(157),
    [anon_sym_COLON] = ACTIONS(155),
    [anon_sym_return] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(155),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_let_BANG] = ACTIONS(157),
    [anon_sym_LPAREN] = ACTIONS(155),
    [anon_sym_COMMA] = ACTIONS(157),
    [anon_sym_null] = ACTIONS(155),
    [anon_sym_QMARK] = ACTIONS(155),
    [anon_sym_COLON_QMARK] = ACTIONS(155),
    [anon_sym_COLON_COLON] = ACTIONS(157),
    [anon_sym_AMP] = ACTIONS(155),
    [anon_sym_LBRACK] = ACTIONS(155),
    [anon_sym_LBRACK_PIPE] = ACTIONS(157),
    [anon_sym_LBRACE] = ACTIONS(155),
    [anon_sym_LT_AT] = ACTIONS(155),
    [anon_sym_LT_AT_AT] = ACTIONS(155),
    [anon_sym_DOT] = ACTIONS(1463),
    [anon_sym_LBRACE_PIPE] = ACTIONS(157),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_return_BANG] = ACTIONS(157),
    [anon_sym_yield] = ACTIONS(155),
    [anon_sym_yield_BANG] = ACTIONS(157),
    [anon_sym_lazy] = ACTIONS(155),
    [anon_sym_assert] = ACTIONS(155),
    [anon_sym_upcast] = ACTIONS(155),
    [anon_sym_downcast] = ACTIONS(155),
    [anon_sym_COLON_GT] = ACTIONS(157),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(157),
    [anon_sym_for] = ACTIONS(155),
    [anon_sym_while] = ACTIONS(155),
    [anon_sym_if] = ACTIONS(155),
    [anon_sym_fun] = ACTIONS(155),
    [anon_sym_try] = ACTIONS(155),
    [anon_sym_match] = ACTIONS(155),
    [anon_sym_match_BANG] = ACTIONS(157),
    [anon_sym_function] = ACTIONS(155),
    [anon_sym_LT_DASH] = ACTIONS(155),
    [anon_sym_DOT_LBRACK] = ACTIONS(1487),
    [anon_sym_LT] = ACTIONS(1489),
    [anon_sym_GT] = ACTIONS(155),
    [anon_sym_use] = ACTIONS(155),
    [anon_sym_use_BANG] = ACTIONS(157),
    [anon_sym_do_BANG] = ACTIONS(157),
    [anon_sym_begin] = ACTIONS(155),
    [anon_sym_LPAREN2] = ACTIONS(1499),
    [anon_sym_or] = ACTIONS(155),
    [aux_sym_char_token1] = ACTIONS(157),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(155),
    [anon_sym_DQUOTE] = ACTIONS(155),
    [anon_sym_AT_DQUOTE] = ACTIONS(157),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(157),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(157),
    [sym_bool] = ACTIONS(155),
    [sym_unit] = ACTIONS(1515),
    [anon_sym_LPAREN_PIPE] = ACTIONS(155),
    [sym_op_identifier] = ACTIONS(155),
    [anon_sym_PLUS] = ACTIONS(155),
    [anon_sym_DASH] = ACTIONS(155),
    [anon_sym_PLUS_DOT] = ACTIONS(155),
    [anon_sym_DASH_DOT] = ACTIONS(155),
    [anon_sym_PERCENT] = ACTIONS(155),
    [anon_sym_AMP_AMP] = ACTIONS(155),
    [anon_sym_TILDE] = ACTIONS(157),
    [aux_sym_prefix_op_token1] = ACTIONS(155),
    [aux_sym_infix_op_token1] = ACTIONS(157),
    [aux_sym_infix_op_token2] = ACTIONS(155),
    [anon_sym_PIPE_PIPE] = ACTIONS(155),
    [anon_sym_BANG_EQ] = ACTIONS(155),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_DOLLAR] = ACTIONS(155),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(155),
    [sym_int] = ACTIONS(155),
    [sym_xint] = ACTIONS(157),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(157),
    [sym__newline] = ACTIONS(157),
  },
  [261] = {
    [sym_function_or_value_defn] = STATE(704),
    [sym__expression] = STATE(312),
    [sym_literal_expression] = STATE(2403),
    [sym_long_identifier_or_op] = STATE(2403),
    [sym_tuple_expression] = STATE(2403),
    [sym_brace_expression] = STATE(2403),
    [sym_anon_record_expression] = STATE(2403),
    [sym_prefixed_expression] = STATE(2403),
    [sym_typecast_expression] = STATE(2403),
    [sym_for_expression] = STATE(2403),
    [sym_while_expression] = STATE(2403),
    [sym__if_branch] = STATE(6794),
    [sym_if_expression] = STATE(2403),
    [sym_fun_expression] = STATE(2403),
    [sym_try_expression] = STATE(2403),
    [sym_match_expression] = STATE(2403),
    [sym_function_expression] = STATE(2403),
    [sym_mutate_expression] = STATE(2403),
    [sym_index_expression] = STATE(2403),
    [sym_typed_expression] = STATE(2403),
    [sym_declaration_expression] = STATE(2403),
    [sym_do_expression] = STATE(2403),
    [sym_list_expression] = STATE(2403),
    [sym_array_expression] = STATE(2403),
    [sym_begin_end_expression] = STATE(2403),
    [sym_paren_expression] = STATE(2403),
    [sym__high_prec_app] = STATE(2405),
    [sym__low_prec_app] = STATE(2405),
    [sym_application_expression] = STATE(2403),
    [sym_dot_expression] = STATE(2403),
    [sym_infix_expression] = STATE(2403),
    [sym_ce_expression] = STATE(2403),
    [sym_sequential_expression] = STATE(2403),
    [sym_char] = STATE(2425),
    [sym_format_string] = STATE(2420),
    [sym__string_literal] = STATE(2420),
    [sym_string] = STATE(2425),
    [sym_verbatim_string] = STATE(2425),
    [sym_bytearray] = STATE(2425),
    [sym_verbatim_bytearray] = STATE(2425),
    [sym_format_triple_quoted_string] = STATE(2419),
    [sym_triple_quoted_string] = STATE(2425),
    [sym_const] = STATE(2403),
    [sym_long_identifier] = STATE(2079),
    [sym_active_pattern] = STATE(2080),
    [sym__identifier_or_op] = STATE(2089),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(688),
    [sym_infix_op] = STATE(668),
    [sym_sbyte] = STATE(2425),
    [sym_byte] = STATE(2425),
    [sym_int16] = STATE(2425),
    [sym_uint16] = STATE(2425),
    [sym_int32] = STATE(2425),
    [sym_uint32] = STATE(2425),
    [sym_nativeint] = STATE(2425),
    [sym_unativeint] = STATE(2425),
    [sym_int64] = STATE(2425),
    [sym_uint64] = STATE(2425),
    [sym_ieee32] = STATE(2425),
    [sym_ieee64] = STATE(2425),
    [sym_bignum] = STATE(2425),
    [sym_decimal] = STATE(2425),
    [sym_float] = STATE(1511),
    [sym_block_comment] = STATE(261),
    [sym_compiler_directive_decl] = STATE(261),
    [sym_fsi_directive_decl] = STATE(261),
    [sym_preproc_line] = STATE(261),
    [sym_preproc_if_in_expression] = STATE(2403),
    [aux_sym_sequential_expression_repeat1] = STATE(1901),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(1261),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(1263),
    [anon_sym_return] = ACTIONS(1265),
    [anon_sym_do] = ACTIONS(1267),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(1269),
    [anon_sym_COMMA] = ACTIONS(1271),
    [anon_sym_null] = ACTIONS(1273),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(1263),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1275),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1277),
    [anon_sym_LBRACE] = ACTIONS(1279),
    [anon_sym_LT_AT] = ACTIONS(1281),
    [anon_sym_LT_AT_AT] = ACTIONS(1283),
    [anon_sym_DOT] = ACTIONS(1285),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1287),
    [anon_sym_new] = ACTIONS(1265),
    [anon_sym_return_BANG] = ACTIONS(1289),
    [anon_sym_yield] = ACTIONS(1265),
    [anon_sym_yield_BANG] = ACTIONS(1289),
    [anon_sym_lazy] = ACTIONS(1265),
    [anon_sym_assert] = ACTIONS(1265),
    [anon_sym_upcast] = ACTIONS(1265),
    [anon_sym_downcast] = ACTIONS(1265),
    [anon_sym_COLON_GT] = ACTIONS(1291),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1291),
    [anon_sym_for] = ACTIONS(1293),
    [anon_sym_while] = ACTIONS(1295),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(1297),
    [anon_sym_try] = ACTIONS(1299),
    [anon_sym_match] = ACTIONS(1301),
    [anon_sym_match_BANG] = ACTIONS(1303),
    [anon_sym_function] = ACTIONS(1305),
    [anon_sym_LT_DASH] = ACTIONS(1307),
    [anon_sym_DOT_LBRACK] = ACTIONS(1309),
    [anon_sym_LT] = ACTIONS(1311),
    [anon_sym_use] = ACTIONS(1313),
    [anon_sym_use_BANG] = ACTIONS(1315),
    [anon_sym_do_BANG] = ACTIONS(1317),
    [anon_sym_begin] = ACTIONS(1319),
    [anon_sym_LPAREN2] = ACTIONS(1321),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(1323),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1325),
    [anon_sym_DQUOTE] = ACTIONS(1327),
    [anon_sym_AT_DQUOTE] = ACTIONS(1329),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1331),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1333),
    [sym_bool] = ACTIONS(1335),
    [sym_unit] = ACTIONS(1337),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1339),
    [sym_op_identifier] = ACTIONS(1341),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(1343),
    [sym_xint] = ACTIONS(1345),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1347),
    [anon_sym_POUNDendif] = ACTIONS(145),
    [sym__newline] = ACTIONS(145),
  },
  [262] = {
    [sym_function_or_value_defn] = STATE(600),
    [sym__expression] = STATE(88),
    [sym_literal_expression] = STATE(867),
    [sym_long_identifier_or_op] = STATE(867),
    [sym_tuple_expression] = STATE(867),
    [sym_brace_expression] = STATE(867),
    [sym_anon_record_expression] = STATE(867),
    [sym_prefixed_expression] = STATE(867),
    [sym_typecast_expression] = STATE(867),
    [sym_for_expression] = STATE(867),
    [sym_while_expression] = STATE(867),
    [sym__if_branch] = STATE(6511),
    [sym_if_expression] = STATE(867),
    [sym_fun_expression] = STATE(867),
    [sym_try_expression] = STATE(867),
    [sym_match_expression] = STATE(867),
    [sym_function_expression] = STATE(867),
    [sym_mutate_expression] = STATE(867),
    [sym_index_expression] = STATE(867),
    [sym_typed_expression] = STATE(867),
    [sym_declaration_expression] = STATE(867),
    [sym_do_expression] = STATE(867),
    [sym_list_expression] = STATE(867),
    [sym_array_expression] = STATE(867),
    [sym_begin_end_expression] = STATE(867),
    [sym_paren_expression] = STATE(867),
    [sym__high_prec_app] = STATE(864),
    [sym__low_prec_app] = STATE(864),
    [sym_application_expression] = STATE(867),
    [sym_dot_expression] = STATE(867),
    [sym_infix_expression] = STATE(867),
    [sym_ce_expression] = STATE(867),
    [sym_sequential_expression] = STATE(867),
    [sym_char] = STATE(868),
    [sym_format_string] = STATE(869),
    [sym__string_literal] = STATE(869),
    [sym_string] = STATE(868),
    [sym_verbatim_string] = STATE(868),
    [sym_bytearray] = STATE(868),
    [sym_verbatim_bytearray] = STATE(868),
    [sym_format_triple_quoted_string] = STATE(870),
    [sym_triple_quoted_string] = STATE(868),
    [sym_const] = STATE(867),
    [sym_long_identifier] = STATE(872),
    [sym_active_pattern] = STATE(871),
    [sym__identifier_or_op] = STATE(873),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(656),
    [sym_infix_op] = STATE(581),
    [sym_sbyte] = STATE(868),
    [sym_byte] = STATE(868),
    [sym_int16] = STATE(868),
    [sym_uint16] = STATE(868),
    [sym_int32] = STATE(868),
    [sym_uint32] = STATE(868),
    [sym_nativeint] = STATE(868),
    [sym_unativeint] = STATE(868),
    [sym_int64] = STATE(868),
    [sym_uint64] = STATE(868),
    [sym_ieee32] = STATE(868),
    [sym_ieee64] = STATE(868),
    [sym_bignum] = STATE(868),
    [sym_decimal] = STATE(868),
    [sym_float] = STATE(1368),
    [sym_block_comment] = STATE(262),
    [sym_compiler_directive_decl] = STATE(262),
    [sym_fsi_directive_decl] = STATE(262),
    [sym_preproc_line] = STATE(262),
    [sym_preproc_if_in_expression] = STATE(867),
    [aux_sym_sequential_expression_repeat1] = STATE(1542),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(29),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(825),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_COMMA] = ACTIONS(827),
    [anon_sym_null] = ACTIONS(49),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACK_PIPE] = ACTIONS(57),
    [anon_sym_LBRACE] = ACTIONS(139),
    [anon_sym_LT_AT] = ACTIONS(61),
    [anon_sym_LT_AT_AT] = ACTIONS(63),
    [anon_sym_DOT] = ACTIONS(65),
    [anon_sym_LBRACE_PIPE] = ACTIONS(67),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_return_BANG] = ACTIONS(829),
    [anon_sym_yield] = ACTIONS(825),
    [anon_sym_yield_BANG] = ACTIONS(829),
    [anon_sym_lazy] = ACTIONS(825),
    [anon_sym_assert] = ACTIONS(825),
    [anon_sym_upcast] = ACTIONS(825),
    [anon_sym_downcast] = ACTIONS(825),
    [anon_sym_COLON_GT] = ACTIONS(71),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(71),
    [anon_sym_for] = ACTIONS(73),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(79),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_match] = ACTIONS(83),
    [anon_sym_match_BANG] = ACTIONS(85),
    [anon_sym_function] = ACTIONS(87),
    [anon_sym_LT_DASH] = ACTIONS(831),
    [anon_sym_DOT_LBRACK] = ACTIONS(91),
    [anon_sym_LT] = ACTIONS(93),
    [anon_sym_use] = ACTIONS(833),
    [anon_sym_use_BANG] = ACTIONS(835),
    [anon_sym_do_BANG] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(101),
    [anon_sym_LPAREN2] = ACTIONS(103),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(105),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(107),
    [anon_sym_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DQUOTE] = ACTIONS(111),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(115),
    [sym_bool] = ACTIONS(117),
    [sym_unit] = ACTIONS(119),
    [anon_sym_LPAREN_PIPE] = ACTIONS(121),
    [sym_op_identifier] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(837),
    [sym_xint] = ACTIONS(387),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(135),
    [sym__newline] = ACTIONS(839),
    [sym__dedent] = ACTIONS(1529),
  },
  [263] = {
    [sym_function_or_value_defn] = STATE(704),
    [sym__expression] = STATE(312),
    [sym_literal_expression] = STATE(2403),
    [sym_long_identifier_or_op] = STATE(2403),
    [sym_tuple_expression] = STATE(2403),
    [sym_brace_expression] = STATE(2403),
    [sym_anon_record_expression] = STATE(2403),
    [sym_prefixed_expression] = STATE(2403),
    [sym_typecast_expression] = STATE(2403),
    [sym_for_expression] = STATE(2403),
    [sym_while_expression] = STATE(2403),
    [sym__if_branch] = STATE(6794),
    [sym_if_expression] = STATE(2403),
    [sym_fun_expression] = STATE(2403),
    [sym_try_expression] = STATE(2403),
    [sym_match_expression] = STATE(2403),
    [sym_function_expression] = STATE(2403),
    [sym_mutate_expression] = STATE(2403),
    [sym_index_expression] = STATE(2403),
    [sym_typed_expression] = STATE(2403),
    [sym_declaration_expression] = STATE(2403),
    [sym_do_expression] = STATE(2403),
    [sym_list_expression] = STATE(2403),
    [sym_array_expression] = STATE(2403),
    [sym_begin_end_expression] = STATE(2403),
    [sym_paren_expression] = STATE(2403),
    [sym__high_prec_app] = STATE(2405),
    [sym__low_prec_app] = STATE(2405),
    [sym_application_expression] = STATE(2403),
    [sym_dot_expression] = STATE(2403),
    [sym_infix_expression] = STATE(2403),
    [sym_ce_expression] = STATE(2403),
    [sym_sequential_expression] = STATE(2403),
    [sym_char] = STATE(2425),
    [sym_format_string] = STATE(2420),
    [sym__string_literal] = STATE(2420),
    [sym_string] = STATE(2425),
    [sym_verbatim_string] = STATE(2425),
    [sym_bytearray] = STATE(2425),
    [sym_verbatim_bytearray] = STATE(2425),
    [sym_format_triple_quoted_string] = STATE(2419),
    [sym_triple_quoted_string] = STATE(2425),
    [sym_const] = STATE(2403),
    [sym_long_identifier] = STATE(2079),
    [sym_active_pattern] = STATE(2080),
    [sym__identifier_or_op] = STATE(2089),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(688),
    [sym_infix_op] = STATE(668),
    [sym_sbyte] = STATE(2425),
    [sym_byte] = STATE(2425),
    [sym_int16] = STATE(2425),
    [sym_uint16] = STATE(2425),
    [sym_int32] = STATE(2425),
    [sym_uint32] = STATE(2425),
    [sym_nativeint] = STATE(2425),
    [sym_unativeint] = STATE(2425),
    [sym_int64] = STATE(2425),
    [sym_uint64] = STATE(2425),
    [sym_ieee32] = STATE(2425),
    [sym_ieee64] = STATE(2425),
    [sym_bignum] = STATE(2425),
    [sym_decimal] = STATE(2425),
    [sym_float] = STATE(1511),
    [sym_block_comment] = STATE(263),
    [sym_compiler_directive_decl] = STATE(263),
    [sym_fsi_directive_decl] = STATE(263),
    [sym_preproc_line] = STATE(263),
    [sym_preproc_if_in_expression] = STATE(2403),
    [aux_sym_sequential_expression_repeat1] = STATE(1901),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(1261),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(1263),
    [anon_sym_return] = ACTIONS(1265),
    [anon_sym_do] = ACTIONS(1267),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(1269),
    [anon_sym_COMMA] = ACTIONS(1271),
    [anon_sym_null] = ACTIONS(1273),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(1263),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1275),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1277),
    [anon_sym_LBRACE] = ACTIONS(59),
    [anon_sym_LT_AT] = ACTIONS(1281),
    [anon_sym_LT_AT_AT] = ACTIONS(1283),
    [anon_sym_DOT] = ACTIONS(1285),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1287),
    [anon_sym_new] = ACTIONS(1265),
    [anon_sym_return_BANG] = ACTIONS(1289),
    [anon_sym_yield] = ACTIONS(1265),
    [anon_sym_yield_BANG] = ACTIONS(1289),
    [anon_sym_lazy] = ACTIONS(1265),
    [anon_sym_assert] = ACTIONS(1265),
    [anon_sym_upcast] = ACTIONS(1265),
    [anon_sym_downcast] = ACTIONS(1265),
    [anon_sym_COLON_GT] = ACTIONS(1291),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1291),
    [anon_sym_for] = ACTIONS(1293),
    [anon_sym_while] = ACTIONS(1295),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(1297),
    [anon_sym_try] = ACTIONS(1299),
    [anon_sym_match] = ACTIONS(1301),
    [anon_sym_match_BANG] = ACTIONS(1303),
    [anon_sym_function] = ACTIONS(1305),
    [anon_sym_LT_DASH] = ACTIONS(1307),
    [anon_sym_DOT_LBRACK] = ACTIONS(1309),
    [anon_sym_LT] = ACTIONS(1311),
    [anon_sym_use] = ACTIONS(1313),
    [anon_sym_use_BANG] = ACTIONS(1315),
    [anon_sym_do_BANG] = ACTIONS(1317),
    [anon_sym_begin] = ACTIONS(1319),
    [anon_sym_LPAREN2] = ACTIONS(1321),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(1323),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1325),
    [anon_sym_DQUOTE] = ACTIONS(1327),
    [anon_sym_AT_DQUOTE] = ACTIONS(1329),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1331),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1333),
    [sym_bool] = ACTIONS(1335),
    [sym_unit] = ACTIONS(1337),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1339),
    [sym_op_identifier] = ACTIONS(1341),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(1343),
    [sym_xint] = ACTIONS(1345),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1347),
    [anon_sym_POUNDendif] = ACTIONS(33),
    [sym__newline] = ACTIONS(33),
  },
  [264] = {
    [sym_function_or_value_defn] = STATE(509),
    [sym__expression] = STATE(326),
    [sym_literal_expression] = STATE(2230),
    [sym_long_identifier_or_op] = STATE(2230),
    [sym_tuple_expression] = STATE(2230),
    [sym_brace_expression] = STATE(2230),
    [sym_anon_record_expression] = STATE(2230),
    [sym_prefixed_expression] = STATE(2230),
    [sym_typecast_expression] = STATE(2230),
    [sym_for_expression] = STATE(2230),
    [sym_while_expression] = STATE(2230),
    [sym__if_branch] = STATE(6659),
    [sym_if_expression] = STATE(2230),
    [sym_fun_expression] = STATE(2230),
    [sym_try_expression] = STATE(2230),
    [sym_match_expression] = STATE(2230),
    [sym_function_expression] = STATE(2230),
    [sym_mutate_expression] = STATE(2230),
    [sym_index_expression] = STATE(2230),
    [sym_typed_expression] = STATE(2230),
    [sym_declaration_expression] = STATE(2230),
    [sym_do_expression] = STATE(2230),
    [sym_list_expression] = STATE(2230),
    [sym_array_expression] = STATE(2230),
    [sym_begin_end_expression] = STATE(2230),
    [sym_paren_expression] = STATE(2230),
    [sym__high_prec_app] = STATE(2229),
    [sym__low_prec_app] = STATE(2229),
    [sym_application_expression] = STATE(2230),
    [sym_dot_expression] = STATE(2230),
    [sym_infix_expression] = STATE(2230),
    [sym_ce_expression] = STATE(2230),
    [sym_sequential_expression] = STATE(2230),
    [sym_char] = STATE(2100),
    [sym_format_string] = STATE(2106),
    [sym__string_literal] = STATE(2106),
    [sym_string] = STATE(2100),
    [sym_verbatim_string] = STATE(2100),
    [sym_bytearray] = STATE(2100),
    [sym_verbatim_bytearray] = STATE(2100),
    [sym_format_triple_quoted_string] = STATE(2107),
    [sym_triple_quoted_string] = STATE(2100),
    [sym_const] = STATE(2230),
    [sym_long_identifier] = STATE(2232),
    [sym_active_pattern] = STATE(2424),
    [sym__identifier_or_op] = STATE(2305),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(737),
    [sym_infix_op] = STATE(694),
    [sym_sbyte] = STATE(2100),
    [sym_byte] = STATE(2100),
    [sym_int16] = STATE(2100),
    [sym_uint16] = STATE(2100),
    [sym_int32] = STATE(2100),
    [sym_uint32] = STATE(2100),
    [sym_nativeint] = STATE(2100),
    [sym_unativeint] = STATE(2100),
    [sym_int64] = STATE(2100),
    [sym_uint64] = STATE(2100),
    [sym_ieee32] = STATE(2100),
    [sym_ieee64] = STATE(2100),
    [sym_bignum] = STATE(2100),
    [sym_decimal] = STATE(2100),
    [sym_float] = STATE(1487),
    [sym_block_comment] = STATE(264),
    [sym_compiler_directive_decl] = STATE(264),
    [sym_fsi_directive_decl] = STATE(264),
    [sym_preproc_line] = STATE(264),
    [sym_preproc_if_in_expression] = STATE(2230),
    [aux_sym_sequential_expression_repeat1] = STATE(1743),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(877),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(879),
    [anon_sym_return] = ACTIONS(881),
    [anon_sym_do] = ACTIONS(1531),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(885),
    [anon_sym_COMMA] = ACTIONS(887),
    [anon_sym_null] = ACTIONS(889),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(879),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(891),
    [anon_sym_LBRACK_PIPE] = ACTIONS(893),
    [anon_sym_LBRACE] = ACTIONS(895),
    [anon_sym_LT_AT] = ACTIONS(897),
    [anon_sym_LT_AT_AT] = ACTIONS(899),
    [anon_sym_DOT] = ACTIONS(901),
    [anon_sym_LBRACE_PIPE] = ACTIONS(903),
    [anon_sym_new] = ACTIONS(881),
    [anon_sym_return_BANG] = ACTIONS(905),
    [anon_sym_yield] = ACTIONS(881),
    [anon_sym_yield_BANG] = ACTIONS(905),
    [anon_sym_lazy] = ACTIONS(881),
    [anon_sym_assert] = ACTIONS(881),
    [anon_sym_upcast] = ACTIONS(881),
    [anon_sym_downcast] = ACTIONS(881),
    [anon_sym_COLON_GT] = ACTIONS(907),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(907),
    [anon_sym_for] = ACTIONS(909),
    [anon_sym_while] = ACTIONS(911),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(913),
    [anon_sym_try] = ACTIONS(915),
    [anon_sym_match] = ACTIONS(917),
    [anon_sym_match_BANG] = ACTIONS(919),
    [anon_sym_function] = ACTIONS(921),
    [anon_sym_LT_DASH] = ACTIONS(923),
    [anon_sym_DOT_LBRACK] = ACTIONS(925),
    [anon_sym_LT] = ACTIONS(927),
    [anon_sym_use] = ACTIONS(929),
    [anon_sym_use_BANG] = ACTIONS(931),
    [anon_sym_do_BANG] = ACTIONS(933),
    [anon_sym_DOT_DOT] = ACTIONS(935),
    [anon_sym_begin] = ACTIONS(937),
    [anon_sym_LPAREN2] = ACTIONS(939),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(941),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(943),
    [anon_sym_DQUOTE] = ACTIONS(945),
    [anon_sym_AT_DQUOTE] = ACTIONS(947),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(949),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(951),
    [sym_bool] = ACTIONS(953),
    [sym_unit] = ACTIONS(955),
    [anon_sym_LPAREN_PIPE] = ACTIONS(957),
    [sym_op_identifier] = ACTIONS(959),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(961),
    [sym_xint] = ACTIONS(963),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(965),
    [sym__newline] = ACTIONS(967),
  },
  [265] = {
    [sym_function_or_value_defn] = STATE(527),
    [sym__expression] = STATE(260),
    [sym_literal_expression] = STATE(2384),
    [sym_long_identifier_or_op] = STATE(2384),
    [sym_tuple_expression] = STATE(2384),
    [sym_brace_expression] = STATE(2384),
    [sym_anon_record_expression] = STATE(2384),
    [sym_prefixed_expression] = STATE(2384),
    [sym_typecast_expression] = STATE(2384),
    [sym_for_expression] = STATE(2384),
    [sym_while_expression] = STATE(2384),
    [sym__if_branch] = STATE(6561),
    [sym_if_expression] = STATE(2384),
    [sym_fun_expression] = STATE(2384),
    [sym_try_expression] = STATE(2384),
    [sym_match_expression] = STATE(2384),
    [sym_function_expression] = STATE(2384),
    [sym_mutate_expression] = STATE(2384),
    [sym_index_expression] = STATE(2384),
    [sym_typed_expression] = STATE(2384),
    [sym_declaration_expression] = STATE(2384),
    [sym_do_expression] = STATE(2384),
    [sym_list_expression] = STATE(2384),
    [sym_array_expression] = STATE(2384),
    [sym_begin_end_expression] = STATE(2384),
    [sym_paren_expression] = STATE(2384),
    [sym__high_prec_app] = STATE(2249),
    [sym__low_prec_app] = STATE(2249),
    [sym_application_expression] = STATE(2384),
    [sym_dot_expression] = STATE(2384),
    [sym_infix_expression] = STATE(2384),
    [sym_ce_expression] = STATE(2384),
    [sym_sequential_expression] = STATE(2384),
    [sym_char] = STATE(2144),
    [sym_format_string] = STATE(2142),
    [sym__string_literal] = STATE(2142),
    [sym_string] = STATE(2144),
    [sym_verbatim_string] = STATE(2144),
    [sym_bytearray] = STATE(2144),
    [sym_verbatim_bytearray] = STATE(2144),
    [sym_format_triple_quoted_string] = STATE(2141),
    [sym_triple_quoted_string] = STATE(2144),
    [sym_const] = STATE(2384),
    [sym_long_identifier] = STATE(2400),
    [sym_active_pattern] = STATE(2317),
    [sym__identifier_or_op] = STATE(2392),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(633),
    [sym_infix_op] = STATE(511),
    [sym_sbyte] = STATE(2144),
    [sym_byte] = STATE(2144),
    [sym_int16] = STATE(2144),
    [sym_uint16] = STATE(2144),
    [sym_int32] = STATE(2144),
    [sym_uint32] = STATE(2144),
    [sym_nativeint] = STATE(2144),
    [sym_unativeint] = STATE(2144),
    [sym_int64] = STATE(2144),
    [sym_uint64] = STATE(2144),
    [sym_ieee32] = STATE(2144),
    [sym_ieee64] = STATE(2144),
    [sym_bignum] = STATE(2144),
    [sym_decimal] = STATE(2144),
    [sym_float] = STATE(1672),
    [sym_block_comment] = STATE(265),
    [sym_compiler_directive_decl] = STATE(265),
    [sym_fsi_directive_decl] = STATE(265),
    [sym_preproc_line] = STATE(265),
    [sym_preproc_if_in_expression] = STATE(2384),
    [aux_sym_sequential_expression_repeat1] = STATE(1748),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(1439),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(1441),
    [anon_sym_return] = ACTIONS(1443),
    [anon_sym_do] = ACTIONS(1445),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(1447),
    [anon_sym_COMMA] = ACTIONS(1449),
    [anon_sym_null] = ACTIONS(1451),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(1441),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1453),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1455),
    [anon_sym_LBRACE] = ACTIONS(1457),
    [anon_sym_LT_AT] = ACTIONS(1459),
    [anon_sym_LT_AT_AT] = ACTIONS(1461),
    [anon_sym_DOT] = ACTIONS(1463),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1465),
    [anon_sym_new] = ACTIONS(1443),
    [anon_sym_return_BANG] = ACTIONS(1467),
    [anon_sym_yield] = ACTIONS(1443),
    [anon_sym_yield_BANG] = ACTIONS(1467),
    [anon_sym_lazy] = ACTIONS(1443),
    [anon_sym_assert] = ACTIONS(1443),
    [anon_sym_upcast] = ACTIONS(1443),
    [anon_sym_downcast] = ACTIONS(1443),
    [anon_sym_COLON_GT] = ACTIONS(1469),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1469),
    [anon_sym_for] = ACTIONS(1471),
    [anon_sym_while] = ACTIONS(1473),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(1475),
    [anon_sym_try] = ACTIONS(1477),
    [anon_sym_match] = ACTIONS(1479),
    [anon_sym_match_BANG] = ACTIONS(1481),
    [anon_sym_function] = ACTIONS(1483),
    [anon_sym_LT_DASH] = ACTIONS(1485),
    [anon_sym_DOT_LBRACK] = ACTIONS(1487),
    [anon_sym_LT] = ACTIONS(1489),
    [anon_sym_GT] = ACTIONS(161),
    [anon_sym_use] = ACTIONS(1491),
    [anon_sym_use_BANG] = ACTIONS(1493),
    [anon_sym_do_BANG] = ACTIONS(1495),
    [anon_sym_begin] = ACTIONS(1497),
    [anon_sym_LPAREN2] = ACTIONS(1499),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(1501),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1503),
    [anon_sym_DQUOTE] = ACTIONS(1505),
    [anon_sym_AT_DQUOTE] = ACTIONS(1507),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1509),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1511),
    [sym_bool] = ACTIONS(1513),
    [sym_unit] = ACTIONS(1515),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1517),
    [sym_op_identifier] = ACTIONS(1519),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(1521),
    [sym_xint] = ACTIONS(1523),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1525),
    [sym__newline] = ACTIONS(1527),
  },
  [266] = {
    [sym_function_or_value_defn] = STATE(733),
    [sym__expression] = STATE(142),
    [sym_literal_expression] = STATE(2008),
    [sym_long_identifier_or_op] = STATE(2008),
    [sym_tuple_expression] = STATE(2008),
    [sym_brace_expression] = STATE(2008),
    [sym_anon_record_expression] = STATE(2008),
    [sym_prefixed_expression] = STATE(2008),
    [sym_typecast_expression] = STATE(2008),
    [sym_for_expression] = STATE(2008),
    [sym_while_expression] = STATE(2008),
    [sym__if_branch] = STATE(6754),
    [sym_if_expression] = STATE(2008),
    [sym_fun_expression] = STATE(2008),
    [sym_try_expression] = STATE(2008),
    [sym_match_expression] = STATE(2008),
    [sym_function_expression] = STATE(2008),
    [sym_mutate_expression] = STATE(2008),
    [sym_index_expression] = STATE(2008),
    [sym_typed_expression] = STATE(2008),
    [sym_declaration_expression] = STATE(2008),
    [sym_do_expression] = STATE(2008),
    [sym_list_expression] = STATE(2008),
    [sym_array_expression] = STATE(2008),
    [sym_begin_end_expression] = STATE(2008),
    [sym_paren_expression] = STATE(2008),
    [sym__high_prec_app] = STATE(2007),
    [sym__low_prec_app] = STATE(2007),
    [sym_application_expression] = STATE(2008),
    [sym_dot_expression] = STATE(2008),
    [sym_infix_expression] = STATE(2008),
    [sym_ce_expression] = STATE(2008),
    [sym_sequential_expression] = STATE(2008),
    [sym_char] = STATE(1859),
    [sym_format_string] = STATE(1861),
    [sym__string_literal] = STATE(1861),
    [sym_string] = STATE(1859),
    [sym_verbatim_string] = STATE(1859),
    [sym_bytearray] = STATE(1859),
    [sym_verbatim_bytearray] = STATE(1859),
    [sym_format_triple_quoted_string] = STATE(1862),
    [sym_triple_quoted_string] = STATE(1859),
    [sym_const] = STATE(2008),
    [sym_long_identifier] = STATE(1701),
    [sym_active_pattern] = STATE(1702),
    [sym__identifier_or_op] = STATE(1724),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(706),
    [sym_infix_op] = STATE(678),
    [sym_sbyte] = STATE(1859),
    [sym_byte] = STATE(1859),
    [sym_int16] = STATE(1859),
    [sym_uint16] = STATE(1859),
    [sym_int32] = STATE(1859),
    [sym_uint32] = STATE(1859),
    [sym_nativeint] = STATE(1859),
    [sym_unativeint] = STATE(1859),
    [sym_int64] = STATE(1859),
    [sym_uint64] = STATE(1859),
    [sym_ieee32] = STATE(1859),
    [sym_ieee64] = STATE(1859),
    [sym_bignum] = STATE(1859),
    [sym_decimal] = STATE(1859),
    [sym_float] = STATE(1447),
    [sym_block_comment] = STATE(266),
    [sym_compiler_directive_decl] = STATE(266),
    [sym_fsi_directive_decl] = STATE(266),
    [sym_preproc_line] = STATE(266),
    [sym_preproc_if_in_expression] = STATE(2008),
    [aux_sym_sequential_expression_repeat1] = STATE(1995),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(503),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(969),
    [anon_sym_return] = ACTIONS(971),
    [anon_sym_do] = ACTIONS(599),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(511),
    [anon_sym_COMMA] = ACTIONS(973),
    [anon_sym_null] = ACTIONS(515),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(969),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(517),
    [anon_sym_LBRACK_PIPE] = ACTIONS(519),
    [anon_sym_LBRACE] = ACTIONS(521),
    [anon_sym_LT_AT] = ACTIONS(523),
    [anon_sym_LT_AT_AT] = ACTIONS(525),
    [anon_sym_DOT] = ACTIONS(527),
    [anon_sym_LBRACE_PIPE] = ACTIONS(529),
    [anon_sym_new] = ACTIONS(971),
    [anon_sym_return_BANG] = ACTIONS(975),
    [anon_sym_yield] = ACTIONS(971),
    [anon_sym_yield_BANG] = ACTIONS(975),
    [anon_sym_lazy] = ACTIONS(971),
    [anon_sym_assert] = ACTIONS(971),
    [anon_sym_upcast] = ACTIONS(971),
    [anon_sym_downcast] = ACTIONS(971),
    [anon_sym_COLON_GT] = ACTIONS(977),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(977),
    [anon_sym_for] = ACTIONS(979),
    [anon_sym_while] = ACTIONS(537),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(539),
    [anon_sym_DASH_GT] = ACTIONS(1533),
    [anon_sym_try] = ACTIONS(543),
    [anon_sym_match] = ACTIONS(545),
    [anon_sym_match_BANG] = ACTIONS(547),
    [anon_sym_function] = ACTIONS(549),
    [anon_sym_LT_DASH] = ACTIONS(981),
    [anon_sym_DOT_LBRACK] = ACTIONS(553),
    [anon_sym_LT] = ACTIONS(555),
    [anon_sym_use] = ACTIONS(983),
    [anon_sym_use_BANG] = ACTIONS(985),
    [anon_sym_do_BANG] = ACTIONS(561),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_LPAREN2] = ACTIONS(567),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(569),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(571),
    [anon_sym_DQUOTE] = ACTIONS(573),
    [anon_sym_AT_DQUOTE] = ACTIONS(575),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(577),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(579),
    [sym_bool] = ACTIONS(581),
    [sym_unit] = ACTIONS(583),
    [anon_sym_LPAREN_PIPE] = ACTIONS(585),
    [sym_op_identifier] = ACTIONS(587),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(591),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(593),
    [sym__newline] = ACTIONS(1171),
  },
  [267] = {
    [sym_function_or_value_defn] = STATE(733),
    [sym__expression] = STATE(142),
    [sym_literal_expression] = STATE(2008),
    [sym_long_identifier_or_op] = STATE(2008),
    [sym_tuple_expression] = STATE(2008),
    [sym_brace_expression] = STATE(2008),
    [sym_anon_record_expression] = STATE(2008),
    [sym_prefixed_expression] = STATE(2008),
    [sym_typecast_expression] = STATE(2008),
    [sym_for_expression] = STATE(2008),
    [sym_while_expression] = STATE(2008),
    [sym__if_branch] = STATE(6754),
    [sym_if_expression] = STATE(2008),
    [sym_fun_expression] = STATE(2008),
    [sym_try_expression] = STATE(2008),
    [sym_match_expression] = STATE(2008),
    [sym_function_expression] = STATE(2008),
    [sym_mutate_expression] = STATE(2008),
    [sym_index_expression] = STATE(2008),
    [sym_typed_expression] = STATE(2008),
    [sym_declaration_expression] = STATE(2008),
    [sym_do_expression] = STATE(2008),
    [sym_list_expression] = STATE(2008),
    [sym_array_expression] = STATE(2008),
    [sym_begin_end_expression] = STATE(2008),
    [sym_paren_expression] = STATE(2008),
    [sym__high_prec_app] = STATE(2007),
    [sym__low_prec_app] = STATE(2007),
    [sym_application_expression] = STATE(2008),
    [sym_dot_expression] = STATE(2008),
    [sym_infix_expression] = STATE(2008),
    [sym_ce_expression] = STATE(2008),
    [sym_sequential_expression] = STATE(2008),
    [sym_char] = STATE(1859),
    [sym_format_string] = STATE(1861),
    [sym__string_literal] = STATE(1861),
    [sym_string] = STATE(1859),
    [sym_verbatim_string] = STATE(1859),
    [sym_bytearray] = STATE(1859),
    [sym_verbatim_bytearray] = STATE(1859),
    [sym_format_triple_quoted_string] = STATE(1862),
    [sym_triple_quoted_string] = STATE(1859),
    [sym_const] = STATE(2008),
    [sym_long_identifier] = STATE(1701),
    [sym_active_pattern] = STATE(1702),
    [sym__identifier_or_op] = STATE(1724),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(706),
    [sym_infix_op] = STATE(678),
    [sym_sbyte] = STATE(1859),
    [sym_byte] = STATE(1859),
    [sym_int16] = STATE(1859),
    [sym_uint16] = STATE(1859),
    [sym_int32] = STATE(1859),
    [sym_uint32] = STATE(1859),
    [sym_nativeint] = STATE(1859),
    [sym_unativeint] = STATE(1859),
    [sym_int64] = STATE(1859),
    [sym_uint64] = STATE(1859),
    [sym_ieee32] = STATE(1859),
    [sym_ieee64] = STATE(1859),
    [sym_bignum] = STATE(1859),
    [sym_decimal] = STATE(1859),
    [sym_float] = STATE(1447),
    [sym_block_comment] = STATE(267),
    [sym_compiler_directive_decl] = STATE(267),
    [sym_fsi_directive_decl] = STATE(267),
    [sym_preproc_line] = STATE(267),
    [sym_preproc_if_in_expression] = STATE(2008),
    [aux_sym_sequential_expression_repeat1] = STATE(1995),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(503),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(969),
    [anon_sym_return] = ACTIONS(971),
    [anon_sym_do] = ACTIONS(599),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(511),
    [anon_sym_COMMA] = ACTIONS(973),
    [anon_sym_null] = ACTIONS(515),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(969),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(517),
    [anon_sym_LBRACK_PIPE] = ACTIONS(519),
    [anon_sym_LBRACE] = ACTIONS(59),
    [anon_sym_LT_AT] = ACTIONS(523),
    [anon_sym_LT_AT_AT] = ACTIONS(525),
    [anon_sym_DOT] = ACTIONS(527),
    [anon_sym_LBRACE_PIPE] = ACTIONS(529),
    [anon_sym_new] = ACTIONS(971),
    [anon_sym_return_BANG] = ACTIONS(975),
    [anon_sym_yield] = ACTIONS(971),
    [anon_sym_yield_BANG] = ACTIONS(975),
    [anon_sym_lazy] = ACTIONS(971),
    [anon_sym_assert] = ACTIONS(971),
    [anon_sym_upcast] = ACTIONS(971),
    [anon_sym_downcast] = ACTIONS(971),
    [anon_sym_COLON_GT] = ACTIONS(977),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(977),
    [anon_sym_for] = ACTIONS(979),
    [anon_sym_while] = ACTIONS(537),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(539),
    [anon_sym_DASH_GT] = ACTIONS(59),
    [anon_sym_try] = ACTIONS(543),
    [anon_sym_match] = ACTIONS(545),
    [anon_sym_match_BANG] = ACTIONS(547),
    [anon_sym_function] = ACTIONS(549),
    [anon_sym_LT_DASH] = ACTIONS(981),
    [anon_sym_DOT_LBRACK] = ACTIONS(553),
    [anon_sym_LT] = ACTIONS(555),
    [anon_sym_use] = ACTIONS(983),
    [anon_sym_use_BANG] = ACTIONS(985),
    [anon_sym_do_BANG] = ACTIONS(561),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_LPAREN2] = ACTIONS(567),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(569),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(571),
    [anon_sym_DQUOTE] = ACTIONS(573),
    [anon_sym_AT_DQUOTE] = ACTIONS(575),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(577),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(579),
    [sym_bool] = ACTIONS(581),
    [sym_unit] = ACTIONS(583),
    [anon_sym_LPAREN_PIPE] = ACTIONS(585),
    [sym_op_identifier] = ACTIONS(587),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(591),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(593),
    [sym__newline] = ACTIONS(33),
  },
  [268] = {
    [sym_function_or_value_defn] = STATE(527),
    [sym__expression] = STATE(260),
    [sym_literal_expression] = STATE(2384),
    [sym_long_identifier_or_op] = STATE(2384),
    [sym_tuple_expression] = STATE(2384),
    [sym_brace_expression] = STATE(2384),
    [sym_anon_record_expression] = STATE(2384),
    [sym_prefixed_expression] = STATE(2384),
    [sym_typecast_expression] = STATE(2384),
    [sym_for_expression] = STATE(2384),
    [sym_while_expression] = STATE(2384),
    [sym__if_branch] = STATE(6561),
    [sym_if_expression] = STATE(2384),
    [sym_fun_expression] = STATE(2384),
    [sym_try_expression] = STATE(2384),
    [sym_match_expression] = STATE(2384),
    [sym_function_expression] = STATE(2384),
    [sym_mutate_expression] = STATE(2384),
    [sym_index_expression] = STATE(2384),
    [sym_typed_expression] = STATE(2384),
    [sym_declaration_expression] = STATE(2384),
    [sym_do_expression] = STATE(2384),
    [sym_list_expression] = STATE(2384),
    [sym_array_expression] = STATE(2384),
    [sym_begin_end_expression] = STATE(2384),
    [sym_paren_expression] = STATE(2384),
    [sym__high_prec_app] = STATE(2249),
    [sym__low_prec_app] = STATE(2249),
    [sym_application_expression] = STATE(2384),
    [sym_dot_expression] = STATE(2384),
    [sym_infix_expression] = STATE(2384),
    [sym_ce_expression] = STATE(2384),
    [sym_sequential_expression] = STATE(2384),
    [sym_char] = STATE(2144),
    [sym_format_string] = STATE(2142),
    [sym__string_literal] = STATE(2142),
    [sym_string] = STATE(2144),
    [sym_verbatim_string] = STATE(2144),
    [sym_bytearray] = STATE(2144),
    [sym_verbatim_bytearray] = STATE(2144),
    [sym_format_triple_quoted_string] = STATE(2141),
    [sym_triple_quoted_string] = STATE(2144),
    [sym_const] = STATE(2384),
    [sym_long_identifier] = STATE(2400),
    [sym_active_pattern] = STATE(2317),
    [sym__identifier_or_op] = STATE(2392),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(633),
    [sym_infix_op] = STATE(511),
    [sym_sbyte] = STATE(2144),
    [sym_byte] = STATE(2144),
    [sym_int16] = STATE(2144),
    [sym_uint16] = STATE(2144),
    [sym_int32] = STATE(2144),
    [sym_uint32] = STATE(2144),
    [sym_nativeint] = STATE(2144),
    [sym_unativeint] = STATE(2144),
    [sym_int64] = STATE(2144),
    [sym_uint64] = STATE(2144),
    [sym_ieee32] = STATE(2144),
    [sym_ieee64] = STATE(2144),
    [sym_bignum] = STATE(2144),
    [sym_decimal] = STATE(2144),
    [sym_float] = STATE(1672),
    [sym_block_comment] = STATE(268),
    [sym_compiler_directive_decl] = STATE(268),
    [sym_fsi_directive_decl] = STATE(268),
    [sym_preproc_line] = STATE(268),
    [sym_preproc_if_in_expression] = STATE(2384),
    [aux_sym_sequential_expression_repeat1] = STATE(1748),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(1439),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(1441),
    [anon_sym_return] = ACTIONS(1443),
    [anon_sym_do] = ACTIONS(1445),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(1447),
    [anon_sym_COMMA] = ACTIONS(1449),
    [anon_sym_null] = ACTIONS(1451),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(1441),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1453),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1455),
    [anon_sym_LBRACE] = ACTIONS(165),
    [anon_sym_LT_AT] = ACTIONS(1459),
    [anon_sym_LT_AT_AT] = ACTIONS(1461),
    [anon_sym_DOT] = ACTIONS(1463),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1465),
    [anon_sym_new] = ACTIONS(1443),
    [anon_sym_return_BANG] = ACTIONS(1467),
    [anon_sym_yield] = ACTIONS(1443),
    [anon_sym_yield_BANG] = ACTIONS(1467),
    [anon_sym_lazy] = ACTIONS(1443),
    [anon_sym_assert] = ACTIONS(1443),
    [anon_sym_upcast] = ACTIONS(1443),
    [anon_sym_downcast] = ACTIONS(1443),
    [anon_sym_COLON_GT] = ACTIONS(1469),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1469),
    [anon_sym_for] = ACTIONS(1471),
    [anon_sym_while] = ACTIONS(1473),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(1475),
    [anon_sym_try] = ACTIONS(1477),
    [anon_sym_match] = ACTIONS(1479),
    [anon_sym_match_BANG] = ACTIONS(1481),
    [anon_sym_function] = ACTIONS(1483),
    [anon_sym_LT_DASH] = ACTIONS(1485),
    [anon_sym_DOT_LBRACK] = ACTIONS(1487),
    [anon_sym_LT] = ACTIONS(1489),
    [anon_sym_GT] = ACTIONS(165),
    [anon_sym_use] = ACTIONS(1491),
    [anon_sym_use_BANG] = ACTIONS(1493),
    [anon_sym_do_BANG] = ACTIONS(1495),
    [anon_sym_begin] = ACTIONS(1497),
    [anon_sym_LPAREN2] = ACTIONS(1499),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(1501),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1503),
    [anon_sym_DQUOTE] = ACTIONS(1505),
    [anon_sym_AT_DQUOTE] = ACTIONS(1507),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1509),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1511),
    [sym_bool] = ACTIONS(1513),
    [sym_unit] = ACTIONS(1515),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1517),
    [sym_op_identifier] = ACTIONS(1519),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(1521),
    [sym_xint] = ACTIONS(1523),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1525),
    [sym__newline] = ACTIONS(163),
  },
  [269] = {
    [sym_function_or_value_defn] = STATE(527),
    [sym__expression] = STATE(260),
    [sym_literal_expression] = STATE(2384),
    [sym_long_identifier_or_op] = STATE(2384),
    [sym_tuple_expression] = STATE(2384),
    [sym_brace_expression] = STATE(2384),
    [sym_anon_record_expression] = STATE(2384),
    [sym_prefixed_expression] = STATE(2384),
    [sym_typecast_expression] = STATE(2384),
    [sym_for_expression] = STATE(2384),
    [sym_while_expression] = STATE(2384),
    [sym__if_branch] = STATE(6561),
    [sym_if_expression] = STATE(2384),
    [sym_fun_expression] = STATE(2384),
    [sym_try_expression] = STATE(2384),
    [sym_match_expression] = STATE(2384),
    [sym_function_expression] = STATE(2384),
    [sym_mutate_expression] = STATE(2384),
    [sym_index_expression] = STATE(2384),
    [sym_typed_expression] = STATE(2384),
    [sym_declaration_expression] = STATE(2384),
    [sym_do_expression] = STATE(2384),
    [sym_list_expression] = STATE(2384),
    [sym_array_expression] = STATE(2384),
    [sym_begin_end_expression] = STATE(2384),
    [sym_paren_expression] = STATE(2384),
    [sym__high_prec_app] = STATE(2249),
    [sym__low_prec_app] = STATE(2249),
    [sym_application_expression] = STATE(2384),
    [sym_dot_expression] = STATE(2384),
    [sym_infix_expression] = STATE(2384),
    [sym_ce_expression] = STATE(2384),
    [sym_sequential_expression] = STATE(2384),
    [sym_char] = STATE(2144),
    [sym_format_string] = STATE(2142),
    [sym__string_literal] = STATE(2142),
    [sym_string] = STATE(2144),
    [sym_verbatim_string] = STATE(2144),
    [sym_bytearray] = STATE(2144),
    [sym_verbatim_bytearray] = STATE(2144),
    [sym_format_triple_quoted_string] = STATE(2141),
    [sym_triple_quoted_string] = STATE(2144),
    [sym_const] = STATE(2384),
    [sym_long_identifier] = STATE(2400),
    [sym_active_pattern] = STATE(2317),
    [sym__identifier_or_op] = STATE(2392),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(633),
    [sym_infix_op] = STATE(511),
    [sym_sbyte] = STATE(2144),
    [sym_byte] = STATE(2144),
    [sym_int16] = STATE(2144),
    [sym_uint16] = STATE(2144),
    [sym_int32] = STATE(2144),
    [sym_uint32] = STATE(2144),
    [sym_nativeint] = STATE(2144),
    [sym_unativeint] = STATE(2144),
    [sym_int64] = STATE(2144),
    [sym_uint64] = STATE(2144),
    [sym_ieee32] = STATE(2144),
    [sym_ieee64] = STATE(2144),
    [sym_bignum] = STATE(2144),
    [sym_decimal] = STATE(2144),
    [sym_float] = STATE(1672),
    [sym_block_comment] = STATE(269),
    [sym_compiler_directive_decl] = STATE(269),
    [sym_fsi_directive_decl] = STATE(269),
    [sym_preproc_line] = STATE(269),
    [sym_preproc_if_in_expression] = STATE(2384),
    [aux_sym_sequential_expression_repeat1] = STATE(1748),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(1439),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(1441),
    [anon_sym_return] = ACTIONS(1443),
    [anon_sym_do] = ACTIONS(1445),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(1447),
    [anon_sym_COMMA] = ACTIONS(1449),
    [anon_sym_null] = ACTIONS(1451),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(1441),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1453),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1455),
    [anon_sym_LBRACE] = ACTIONS(169),
    [anon_sym_LT_AT] = ACTIONS(1459),
    [anon_sym_LT_AT_AT] = ACTIONS(1461),
    [anon_sym_DOT] = ACTIONS(1463),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1465),
    [anon_sym_new] = ACTIONS(1443),
    [anon_sym_return_BANG] = ACTIONS(1467),
    [anon_sym_yield] = ACTIONS(1443),
    [anon_sym_yield_BANG] = ACTIONS(1467),
    [anon_sym_lazy] = ACTIONS(1443),
    [anon_sym_assert] = ACTIONS(1443),
    [anon_sym_upcast] = ACTIONS(1443),
    [anon_sym_downcast] = ACTIONS(1443),
    [anon_sym_COLON_GT] = ACTIONS(1469),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1469),
    [anon_sym_for] = ACTIONS(1471),
    [anon_sym_while] = ACTIONS(1473),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(1475),
    [anon_sym_try] = ACTIONS(1477),
    [anon_sym_match] = ACTIONS(1479),
    [anon_sym_match_BANG] = ACTIONS(1481),
    [anon_sym_function] = ACTIONS(1483),
    [anon_sym_LT_DASH] = ACTIONS(1485),
    [anon_sym_DOT_LBRACK] = ACTIONS(1487),
    [anon_sym_LT] = ACTIONS(1489),
    [anon_sym_GT] = ACTIONS(169),
    [anon_sym_use] = ACTIONS(1491),
    [anon_sym_use_BANG] = ACTIONS(1493),
    [anon_sym_do_BANG] = ACTIONS(1495),
    [anon_sym_begin] = ACTIONS(1497),
    [anon_sym_LPAREN2] = ACTIONS(1499),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(1501),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1503),
    [anon_sym_DQUOTE] = ACTIONS(1505),
    [anon_sym_AT_DQUOTE] = ACTIONS(1507),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1509),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1511),
    [sym_bool] = ACTIONS(1513),
    [sym_unit] = ACTIONS(1515),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1517),
    [sym_op_identifier] = ACTIONS(1519),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(1521),
    [sym_xint] = ACTIONS(1523),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1525),
    [sym__newline] = ACTIONS(167),
  },
  [270] = {
    [sym_function_or_value_defn] = STATE(527),
    [sym__expression] = STATE(260),
    [sym_literal_expression] = STATE(2384),
    [sym_long_identifier_or_op] = STATE(2384),
    [sym_tuple_expression] = STATE(2384),
    [sym_brace_expression] = STATE(2384),
    [sym_anon_record_expression] = STATE(2384),
    [sym_prefixed_expression] = STATE(2384),
    [sym_typecast_expression] = STATE(2384),
    [sym_for_expression] = STATE(2384),
    [sym_while_expression] = STATE(2384),
    [sym__if_branch] = STATE(6561),
    [sym_if_expression] = STATE(2384),
    [sym_fun_expression] = STATE(2384),
    [sym_try_expression] = STATE(2384),
    [sym_match_expression] = STATE(2384),
    [sym_function_expression] = STATE(2384),
    [sym_mutate_expression] = STATE(2384),
    [sym_index_expression] = STATE(2384),
    [sym_typed_expression] = STATE(2384),
    [sym_declaration_expression] = STATE(2384),
    [sym_do_expression] = STATE(2384),
    [sym_list_expression] = STATE(2384),
    [sym_array_expression] = STATE(2384),
    [sym_begin_end_expression] = STATE(2384),
    [sym_paren_expression] = STATE(2384),
    [sym__high_prec_app] = STATE(2249),
    [sym__low_prec_app] = STATE(2249),
    [sym_application_expression] = STATE(2384),
    [sym_dot_expression] = STATE(2384),
    [sym_infix_expression] = STATE(2384),
    [sym_ce_expression] = STATE(2384),
    [sym_sequential_expression] = STATE(2384),
    [sym_char] = STATE(2144),
    [sym_format_string] = STATE(2142),
    [sym__string_literal] = STATE(2142),
    [sym_string] = STATE(2144),
    [sym_verbatim_string] = STATE(2144),
    [sym_bytearray] = STATE(2144),
    [sym_verbatim_bytearray] = STATE(2144),
    [sym_format_triple_quoted_string] = STATE(2141),
    [sym_triple_quoted_string] = STATE(2144),
    [sym_const] = STATE(2384),
    [sym_long_identifier] = STATE(2400),
    [sym_active_pattern] = STATE(2317),
    [sym__identifier_or_op] = STATE(2392),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(633),
    [sym_infix_op] = STATE(511),
    [sym_sbyte] = STATE(2144),
    [sym_byte] = STATE(2144),
    [sym_int16] = STATE(2144),
    [sym_uint16] = STATE(2144),
    [sym_int32] = STATE(2144),
    [sym_uint32] = STATE(2144),
    [sym_nativeint] = STATE(2144),
    [sym_unativeint] = STATE(2144),
    [sym_int64] = STATE(2144),
    [sym_uint64] = STATE(2144),
    [sym_ieee32] = STATE(2144),
    [sym_ieee64] = STATE(2144),
    [sym_bignum] = STATE(2144),
    [sym_decimal] = STATE(2144),
    [sym_float] = STATE(1672),
    [sym_block_comment] = STATE(270),
    [sym_compiler_directive_decl] = STATE(270),
    [sym_fsi_directive_decl] = STATE(270),
    [sym_preproc_line] = STATE(270),
    [sym_preproc_if_in_expression] = STATE(2384),
    [aux_sym_sequential_expression_repeat1] = STATE(1748),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(181),
    [anon_sym_EQ] = ACTIONS(183),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_return] = ACTIONS(181),
    [anon_sym_do] = ACTIONS(181),
    [anon_sym_let] = ACTIONS(181),
    [anon_sym_let_BANG] = ACTIONS(183),
    [anon_sym_LPAREN] = ACTIONS(181),
    [anon_sym_COMMA] = ACTIONS(183),
    [anon_sym_null] = ACTIONS(181),
    [anon_sym_QMARK] = ACTIONS(181),
    [anon_sym_COLON_QMARK] = ACTIONS(181),
    [anon_sym_COLON_COLON] = ACTIONS(183),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_LBRACK_PIPE] = ACTIONS(183),
    [anon_sym_LBRACE] = ACTIONS(181),
    [anon_sym_LT_AT] = ACTIONS(181),
    [anon_sym_LT_AT_AT] = ACTIONS(181),
    [anon_sym_DOT] = ACTIONS(1463),
    [anon_sym_LBRACE_PIPE] = ACTIONS(183),
    [anon_sym_new] = ACTIONS(181),
    [anon_sym_return_BANG] = ACTIONS(183),
    [anon_sym_yield] = ACTIONS(181),
    [anon_sym_yield_BANG] = ACTIONS(183),
    [anon_sym_lazy] = ACTIONS(181),
    [anon_sym_assert] = ACTIONS(181),
    [anon_sym_upcast] = ACTIONS(181),
    [anon_sym_downcast] = ACTIONS(181),
    [anon_sym_COLON_GT] = ACTIONS(183),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(183),
    [anon_sym_for] = ACTIONS(181),
    [anon_sym_while] = ACTIONS(181),
    [anon_sym_if] = ACTIONS(181),
    [anon_sym_fun] = ACTIONS(181),
    [anon_sym_try] = ACTIONS(181),
    [anon_sym_match] = ACTIONS(181),
    [anon_sym_match_BANG] = ACTIONS(183),
    [anon_sym_function] = ACTIONS(181),
    [anon_sym_LT_DASH] = ACTIONS(181),
    [anon_sym_DOT_LBRACK] = ACTIONS(1487),
    [anon_sym_LT] = ACTIONS(1489),
    [anon_sym_GT] = ACTIONS(181),
    [anon_sym_use] = ACTIONS(181),
    [anon_sym_use_BANG] = ACTIONS(183),
    [anon_sym_do_BANG] = ACTIONS(183),
    [anon_sym_begin] = ACTIONS(181),
    [anon_sym_LPAREN2] = ACTIONS(1499),
    [anon_sym_or] = ACTIONS(181),
    [aux_sym_char_token1] = ACTIONS(183),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(181),
    [anon_sym_DQUOTE] = ACTIONS(181),
    [anon_sym_AT_DQUOTE] = ACTIONS(183),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(183),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(183),
    [sym_bool] = ACTIONS(181),
    [sym_unit] = ACTIONS(1515),
    [anon_sym_LPAREN_PIPE] = ACTIONS(181),
    [sym_op_identifier] = ACTIONS(181),
    [anon_sym_PLUS] = ACTIONS(181),
    [anon_sym_DASH] = ACTIONS(181),
    [anon_sym_PLUS_DOT] = ACTIONS(181),
    [anon_sym_DASH_DOT] = ACTIONS(181),
    [anon_sym_PERCENT] = ACTIONS(181),
    [anon_sym_AMP_AMP] = ACTIONS(181),
    [anon_sym_TILDE] = ACTIONS(183),
    [aux_sym_prefix_op_token1] = ACTIONS(181),
    [aux_sym_infix_op_token1] = ACTIONS(183),
    [aux_sym_infix_op_token2] = ACTIONS(181),
    [anon_sym_PIPE_PIPE] = ACTIONS(181),
    [anon_sym_BANG_EQ] = ACTIONS(181),
    [anon_sym_COLON_EQ] = ACTIONS(183),
    [anon_sym_DOLLAR] = ACTIONS(181),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(181),
    [sym_int] = ACTIONS(181),
    [sym_xint] = ACTIONS(183),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(183),
    [sym__newline] = ACTIONS(183),
  },
  [271] = {
    [sym_function_or_value_defn] = STATE(527),
    [sym__expression] = STATE(260),
    [sym_literal_expression] = STATE(2384),
    [sym_long_identifier_or_op] = STATE(2384),
    [sym_tuple_expression] = STATE(2384),
    [sym_brace_expression] = STATE(2384),
    [sym_anon_record_expression] = STATE(2384),
    [sym_prefixed_expression] = STATE(2384),
    [sym_typecast_expression] = STATE(2384),
    [sym_for_expression] = STATE(2384),
    [sym_while_expression] = STATE(2384),
    [sym__if_branch] = STATE(6561),
    [sym_if_expression] = STATE(2384),
    [sym_fun_expression] = STATE(2384),
    [sym_try_expression] = STATE(2384),
    [sym_match_expression] = STATE(2384),
    [sym_function_expression] = STATE(2384),
    [sym_mutate_expression] = STATE(2384),
    [sym_index_expression] = STATE(2384),
    [sym_typed_expression] = STATE(2384),
    [sym_declaration_expression] = STATE(2384),
    [sym_do_expression] = STATE(2384),
    [sym_list_expression] = STATE(2384),
    [sym_array_expression] = STATE(2384),
    [sym_begin_end_expression] = STATE(2384),
    [sym_paren_expression] = STATE(2384),
    [sym__high_prec_app] = STATE(2249),
    [sym__low_prec_app] = STATE(2249),
    [sym_application_expression] = STATE(2384),
    [sym_dot_expression] = STATE(2384),
    [sym_infix_expression] = STATE(2384),
    [sym_ce_expression] = STATE(2384),
    [sym_sequential_expression] = STATE(2384),
    [sym_char] = STATE(2144),
    [sym_format_string] = STATE(2142),
    [sym__string_literal] = STATE(2142),
    [sym_string] = STATE(2144),
    [sym_verbatim_string] = STATE(2144),
    [sym_bytearray] = STATE(2144),
    [sym_verbatim_bytearray] = STATE(2144),
    [sym_format_triple_quoted_string] = STATE(2141),
    [sym_triple_quoted_string] = STATE(2144),
    [sym_const] = STATE(2384),
    [sym_long_identifier] = STATE(2400),
    [sym_active_pattern] = STATE(2317),
    [sym__identifier_or_op] = STATE(2392),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(633),
    [sym_infix_op] = STATE(511),
    [sym_sbyte] = STATE(2144),
    [sym_byte] = STATE(2144),
    [sym_int16] = STATE(2144),
    [sym_uint16] = STATE(2144),
    [sym_int32] = STATE(2144),
    [sym_uint32] = STATE(2144),
    [sym_nativeint] = STATE(2144),
    [sym_unativeint] = STATE(2144),
    [sym_int64] = STATE(2144),
    [sym_uint64] = STATE(2144),
    [sym_ieee32] = STATE(2144),
    [sym_ieee64] = STATE(2144),
    [sym_bignum] = STATE(2144),
    [sym_decimal] = STATE(2144),
    [sym_float] = STATE(1672),
    [sym_block_comment] = STATE(271),
    [sym_compiler_directive_decl] = STATE(271),
    [sym_fsi_directive_decl] = STATE(271),
    [sym_preproc_line] = STATE(271),
    [sym_preproc_if_in_expression] = STATE(2384),
    [aux_sym_sequential_expression_repeat1] = STATE(1748),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(1439),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(1441),
    [anon_sym_return] = ACTIONS(1443),
    [anon_sym_do] = ACTIONS(1445),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(1447),
    [anon_sym_COMMA] = ACTIONS(1449),
    [anon_sym_null] = ACTIONS(1451),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(1441),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1453),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1455),
    [anon_sym_LBRACE] = ACTIONS(59),
    [anon_sym_LT_AT] = ACTIONS(1459),
    [anon_sym_LT_AT_AT] = ACTIONS(1461),
    [anon_sym_DOT] = ACTIONS(1463),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1465),
    [anon_sym_new] = ACTIONS(1443),
    [anon_sym_return_BANG] = ACTIONS(1467),
    [anon_sym_yield] = ACTIONS(1443),
    [anon_sym_yield_BANG] = ACTIONS(1467),
    [anon_sym_lazy] = ACTIONS(1443),
    [anon_sym_assert] = ACTIONS(1443),
    [anon_sym_upcast] = ACTIONS(1443),
    [anon_sym_downcast] = ACTIONS(1443),
    [anon_sym_COLON_GT] = ACTIONS(1469),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1469),
    [anon_sym_for] = ACTIONS(1471),
    [anon_sym_while] = ACTIONS(1473),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(1475),
    [anon_sym_try] = ACTIONS(1477),
    [anon_sym_match] = ACTIONS(1479),
    [anon_sym_match_BANG] = ACTIONS(1481),
    [anon_sym_function] = ACTIONS(1483),
    [anon_sym_LT_DASH] = ACTIONS(1485),
    [anon_sym_DOT_LBRACK] = ACTIONS(1487),
    [anon_sym_LT] = ACTIONS(1489),
    [anon_sym_GT] = ACTIONS(59),
    [anon_sym_use] = ACTIONS(1491),
    [anon_sym_use_BANG] = ACTIONS(1493),
    [anon_sym_do_BANG] = ACTIONS(1495),
    [anon_sym_begin] = ACTIONS(1497),
    [anon_sym_LPAREN2] = ACTIONS(1499),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(1501),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1503),
    [anon_sym_DQUOTE] = ACTIONS(1505),
    [anon_sym_AT_DQUOTE] = ACTIONS(1507),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1509),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1511),
    [sym_bool] = ACTIONS(1513),
    [sym_unit] = ACTIONS(1515),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1517),
    [sym_op_identifier] = ACTIONS(1519),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(1521),
    [sym_xint] = ACTIONS(1523),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1525),
    [sym__newline] = ACTIONS(33),
  },
  [272] = {
    [sym_function_or_value_defn] = STATE(704),
    [sym__expression] = STATE(312),
    [sym_literal_expression] = STATE(2403),
    [sym_long_identifier_or_op] = STATE(2403),
    [sym_tuple_expression] = STATE(2403),
    [sym_brace_expression] = STATE(2403),
    [sym_anon_record_expression] = STATE(2403),
    [sym_prefixed_expression] = STATE(2403),
    [sym_typecast_expression] = STATE(2403),
    [sym_for_expression] = STATE(2403),
    [sym_while_expression] = STATE(2403),
    [sym__if_branch] = STATE(6794),
    [sym_if_expression] = STATE(2403),
    [sym_fun_expression] = STATE(2403),
    [sym_try_expression] = STATE(2403),
    [sym_match_expression] = STATE(2403),
    [sym_function_expression] = STATE(2403),
    [sym_mutate_expression] = STATE(2403),
    [sym_index_expression] = STATE(2403),
    [sym_typed_expression] = STATE(2403),
    [sym_declaration_expression] = STATE(2403),
    [sym_do_expression] = STATE(2403),
    [sym_list_expression] = STATE(2403),
    [sym_array_expression] = STATE(2403),
    [sym_begin_end_expression] = STATE(2403),
    [sym_paren_expression] = STATE(2403),
    [sym__high_prec_app] = STATE(2405),
    [sym__low_prec_app] = STATE(2405),
    [sym_application_expression] = STATE(2403),
    [sym_dot_expression] = STATE(2403),
    [sym_infix_expression] = STATE(2403),
    [sym_ce_expression] = STATE(2403),
    [sym_sequential_expression] = STATE(2403),
    [sym_char] = STATE(2425),
    [sym_format_string] = STATE(2420),
    [sym__string_literal] = STATE(2420),
    [sym_string] = STATE(2425),
    [sym_verbatim_string] = STATE(2425),
    [sym_bytearray] = STATE(2425),
    [sym_verbatim_bytearray] = STATE(2425),
    [sym_format_triple_quoted_string] = STATE(2419),
    [sym_triple_quoted_string] = STATE(2425),
    [sym_const] = STATE(2403),
    [sym_long_identifier] = STATE(2079),
    [sym_active_pattern] = STATE(2080),
    [sym__identifier_or_op] = STATE(2089),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(688),
    [sym_infix_op] = STATE(668),
    [sym_sbyte] = STATE(2425),
    [sym_byte] = STATE(2425),
    [sym_int16] = STATE(2425),
    [sym_uint16] = STATE(2425),
    [sym_int32] = STATE(2425),
    [sym_uint32] = STATE(2425),
    [sym_nativeint] = STATE(2425),
    [sym_unativeint] = STATE(2425),
    [sym_int64] = STATE(2425),
    [sym_uint64] = STATE(2425),
    [sym_ieee32] = STATE(2425),
    [sym_ieee64] = STATE(2425),
    [sym_bignum] = STATE(2425),
    [sym_decimal] = STATE(2425),
    [sym_float] = STATE(1511),
    [sym_block_comment] = STATE(272),
    [sym_compiler_directive_decl] = STATE(272),
    [sym_fsi_directive_decl] = STATE(272),
    [sym_preproc_line] = STATE(272),
    [sym_preproc_if_in_expression] = STATE(2403),
    [aux_sym_sequential_expression_repeat1] = STATE(1901),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(1261),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(1263),
    [anon_sym_return] = ACTIONS(1265),
    [anon_sym_do] = ACTIONS(1267),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(1269),
    [anon_sym_COMMA] = ACTIONS(1271),
    [anon_sym_null] = ACTIONS(1273),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(1263),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1275),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1277),
    [anon_sym_LBRACE] = ACTIONS(1279),
    [anon_sym_LT_AT] = ACTIONS(1281),
    [anon_sym_LT_AT_AT] = ACTIONS(1283),
    [anon_sym_DOT] = ACTIONS(1285),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1287),
    [anon_sym_new] = ACTIONS(1265),
    [anon_sym_return_BANG] = ACTIONS(1289),
    [anon_sym_yield] = ACTIONS(1265),
    [anon_sym_yield_BANG] = ACTIONS(1289),
    [anon_sym_lazy] = ACTIONS(1265),
    [anon_sym_assert] = ACTIONS(1265),
    [anon_sym_upcast] = ACTIONS(1265),
    [anon_sym_downcast] = ACTIONS(1265),
    [anon_sym_COLON_GT] = ACTIONS(1291),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1291),
    [anon_sym_for] = ACTIONS(1293),
    [anon_sym_while] = ACTIONS(1295),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(1297),
    [anon_sym_try] = ACTIONS(1299),
    [anon_sym_match] = ACTIONS(1301),
    [anon_sym_match_BANG] = ACTIONS(1303),
    [anon_sym_function] = ACTIONS(1305),
    [anon_sym_LT_DASH] = ACTIONS(1307),
    [anon_sym_DOT_LBRACK] = ACTIONS(1309),
    [anon_sym_LT] = ACTIONS(1311),
    [anon_sym_use] = ACTIONS(1313),
    [anon_sym_use_BANG] = ACTIONS(1315),
    [anon_sym_do_BANG] = ACTIONS(1317),
    [anon_sym_begin] = ACTIONS(1319),
    [anon_sym_LPAREN2] = ACTIONS(1321),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(1323),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1325),
    [anon_sym_DQUOTE] = ACTIONS(1327),
    [anon_sym_AT_DQUOTE] = ACTIONS(1329),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1331),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1333),
    [sym_bool] = ACTIONS(1335),
    [sym_unit] = ACTIONS(1337),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1339),
    [sym_op_identifier] = ACTIONS(1341),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(1343),
    [sym_xint] = ACTIONS(1345),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1347),
    [anon_sym_POUNDendif] = ACTIONS(149),
    [sym__newline] = ACTIONS(1349),
  },
  [273] = {
    [sym_function_or_value_defn] = STATE(509),
    [sym__expression] = STATE(326),
    [sym_literal_expression] = STATE(2230),
    [sym_long_identifier_or_op] = STATE(2230),
    [sym_tuple_expression] = STATE(2230),
    [sym_brace_expression] = STATE(2230),
    [sym_anon_record_expression] = STATE(2230),
    [sym_prefixed_expression] = STATE(2230),
    [sym_typecast_expression] = STATE(2230),
    [sym_for_expression] = STATE(2230),
    [sym_while_expression] = STATE(2230),
    [sym__if_branch] = STATE(6659),
    [sym_if_expression] = STATE(2230),
    [sym_fun_expression] = STATE(2230),
    [sym_try_expression] = STATE(2230),
    [sym_match_expression] = STATE(2230),
    [sym_function_expression] = STATE(2230),
    [sym_mutate_expression] = STATE(2230),
    [sym_index_expression] = STATE(2230),
    [sym_typed_expression] = STATE(2230),
    [sym_declaration_expression] = STATE(2230),
    [sym_do_expression] = STATE(2230),
    [sym_list_expression] = STATE(2230),
    [sym_array_expression] = STATE(2230),
    [sym_begin_end_expression] = STATE(2230),
    [sym_paren_expression] = STATE(2230),
    [sym__high_prec_app] = STATE(2229),
    [sym__low_prec_app] = STATE(2229),
    [sym_application_expression] = STATE(2230),
    [sym_dot_expression] = STATE(2230),
    [sym_infix_expression] = STATE(2230),
    [sym_ce_expression] = STATE(2230),
    [sym_sequential_expression] = STATE(2230),
    [sym_char] = STATE(2100),
    [sym_format_string] = STATE(2106),
    [sym__string_literal] = STATE(2106),
    [sym_string] = STATE(2100),
    [sym_verbatim_string] = STATE(2100),
    [sym_bytearray] = STATE(2100),
    [sym_verbatim_bytearray] = STATE(2100),
    [sym_format_triple_quoted_string] = STATE(2107),
    [sym_triple_quoted_string] = STATE(2100),
    [sym_const] = STATE(2230),
    [sym_long_identifier] = STATE(2232),
    [sym_active_pattern] = STATE(2424),
    [sym__identifier_or_op] = STATE(2305),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(737),
    [sym_infix_op] = STATE(694),
    [sym_sbyte] = STATE(2100),
    [sym_byte] = STATE(2100),
    [sym_int16] = STATE(2100),
    [sym_uint16] = STATE(2100),
    [sym_int32] = STATE(2100),
    [sym_uint32] = STATE(2100),
    [sym_nativeint] = STATE(2100),
    [sym_unativeint] = STATE(2100),
    [sym_int64] = STATE(2100),
    [sym_uint64] = STATE(2100),
    [sym_ieee32] = STATE(2100),
    [sym_ieee64] = STATE(2100),
    [sym_bignum] = STATE(2100),
    [sym_decimal] = STATE(2100),
    [sym_float] = STATE(1487),
    [sym_block_comment] = STATE(273),
    [sym_compiler_directive_decl] = STATE(273),
    [sym_fsi_directive_decl] = STATE(273),
    [sym_preproc_line] = STATE(273),
    [sym_preproc_if_in_expression] = STATE(2230),
    [aux_sym_sequential_expression_repeat1] = STATE(1743),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(877),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(879),
    [anon_sym_return] = ACTIONS(881),
    [anon_sym_do] = ACTIONS(1535),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(885),
    [anon_sym_COMMA] = ACTIONS(887),
    [anon_sym_null] = ACTIONS(889),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(879),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(891),
    [anon_sym_LBRACK_PIPE] = ACTIONS(893),
    [anon_sym_LBRACE] = ACTIONS(895),
    [anon_sym_LT_AT] = ACTIONS(897),
    [anon_sym_LT_AT_AT] = ACTIONS(899),
    [anon_sym_DOT] = ACTIONS(901),
    [anon_sym_LBRACE_PIPE] = ACTIONS(903),
    [anon_sym_new] = ACTIONS(881),
    [anon_sym_return_BANG] = ACTIONS(905),
    [anon_sym_yield] = ACTIONS(881),
    [anon_sym_yield_BANG] = ACTIONS(905),
    [anon_sym_lazy] = ACTIONS(881),
    [anon_sym_assert] = ACTIONS(881),
    [anon_sym_upcast] = ACTIONS(881),
    [anon_sym_downcast] = ACTIONS(881),
    [anon_sym_COLON_GT] = ACTIONS(907),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(907),
    [anon_sym_for] = ACTIONS(909),
    [anon_sym_while] = ACTIONS(911),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(913),
    [anon_sym_try] = ACTIONS(915),
    [anon_sym_match] = ACTIONS(917),
    [anon_sym_match_BANG] = ACTIONS(919),
    [anon_sym_function] = ACTIONS(921),
    [anon_sym_LT_DASH] = ACTIONS(923),
    [anon_sym_DOT_LBRACK] = ACTIONS(925),
    [anon_sym_LT] = ACTIONS(927),
    [anon_sym_use] = ACTIONS(929),
    [anon_sym_use_BANG] = ACTIONS(931),
    [anon_sym_do_BANG] = ACTIONS(933),
    [anon_sym_DOT_DOT] = ACTIONS(935),
    [anon_sym_begin] = ACTIONS(937),
    [anon_sym_LPAREN2] = ACTIONS(939),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(941),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(943),
    [anon_sym_DQUOTE] = ACTIONS(945),
    [anon_sym_AT_DQUOTE] = ACTIONS(947),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(949),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(951),
    [sym_bool] = ACTIONS(953),
    [sym_unit] = ACTIONS(955),
    [anon_sym_LPAREN_PIPE] = ACTIONS(957),
    [sym_op_identifier] = ACTIONS(959),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(961),
    [sym_xint] = ACTIONS(963),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(965),
    [sym__newline] = ACTIONS(967),
  },
  [274] = {
    [sym_function_or_value_defn] = STATE(627),
    [sym__expression] = STATE(17),
    [sym_literal_expression] = STATE(1118),
    [sym_long_identifier_or_op] = STATE(1118),
    [sym_tuple_expression] = STATE(1118),
    [sym_brace_expression] = STATE(1118),
    [sym_anon_record_expression] = STATE(1118),
    [sym_prefixed_expression] = STATE(1118),
    [sym_typecast_expression] = STATE(1118),
    [sym_for_expression] = STATE(1118),
    [sym_while_expression] = STATE(1118),
    [sym__if_branch] = STATE(7163),
    [sym_if_expression] = STATE(1118),
    [sym_fun_expression] = STATE(1118),
    [sym_try_expression] = STATE(1118),
    [sym_match_expression] = STATE(1118),
    [sym_function_expression] = STATE(1118),
    [sym_mutate_expression] = STATE(1118),
    [sym_index_expression] = STATE(1118),
    [sym_typed_expression] = STATE(1118),
    [sym_declaration_expression] = STATE(1118),
    [sym_do_expression] = STATE(1118),
    [sym_list_expression] = STATE(1118),
    [sym_array_expression] = STATE(1118),
    [sym_begin_end_expression] = STATE(1118),
    [sym_paren_expression] = STATE(1118),
    [sym__high_prec_app] = STATE(1133),
    [sym__low_prec_app] = STATE(1133),
    [sym_application_expression] = STATE(1118),
    [sym_dot_expression] = STATE(1118),
    [sym_infix_expression] = STATE(1118),
    [sym_ce_expression] = STATE(1118),
    [sym_sequential_expression] = STATE(1118),
    [sym_char] = STATE(1080),
    [sym_format_string] = STATE(1090),
    [sym__string_literal] = STATE(1090),
    [sym_string] = STATE(1080),
    [sym_verbatim_string] = STATE(1080),
    [sym_bytearray] = STATE(1080),
    [sym_verbatim_bytearray] = STATE(1080),
    [sym_format_triple_quoted_string] = STATE(1096),
    [sym_triple_quoted_string] = STATE(1080),
    [sym_const] = STATE(1118),
    [sym_long_identifier] = STATE(1156),
    [sym_active_pattern] = STATE(1085),
    [sym__identifier_or_op] = STATE(1099),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(517),
    [sym_infix_op] = STATE(487),
    [sym_sbyte] = STATE(1080),
    [sym_byte] = STATE(1080),
    [sym_int16] = STATE(1080),
    [sym_uint16] = STATE(1080),
    [sym_int32] = STATE(1080),
    [sym_uint32] = STATE(1080),
    [sym_nativeint] = STATE(1080),
    [sym_unativeint] = STATE(1080),
    [sym_int64] = STATE(1080),
    [sym_uint64] = STATE(1080),
    [sym_ieee32] = STATE(1080),
    [sym_ieee64] = STATE(1080),
    [sym_bignum] = STATE(1080),
    [sym_decimal] = STATE(1080),
    [sym_float] = STATE(979),
    [sym_block_comment] = STATE(274),
    [sym_compiler_directive_decl] = STATE(274),
    [sym_fsi_directive_decl] = STATE(274),
    [sym_preproc_line] = STATE(274),
    [sym_preproc_if_in_expression] = STATE(1118),
    [aux_sym_sequential_expression_repeat1] = STATE(1069),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(195),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(197),
    [anon_sym_return] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_COMMA] = ACTIONS(205),
    [anon_sym_null] = ACTIONS(207),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(197),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(209),
    [anon_sym_LBRACK_PIPE] = ACTIONS(211),
    [anon_sym_LBRACE] = ACTIONS(271),
    [anon_sym_LT_AT] = ACTIONS(213),
    [anon_sym_LT_AT_AT] = ACTIONS(215),
    [anon_sym_DOT] = ACTIONS(185),
    [anon_sym_LBRACE_PIPE] = ACTIONS(217),
    [anon_sym_new] = ACTIONS(199),
    [anon_sym_with] = ACTIONS(1537),
    [anon_sym_return_BANG] = ACTIONS(219),
    [anon_sym_yield] = ACTIONS(199),
    [anon_sym_yield_BANG] = ACTIONS(219),
    [anon_sym_lazy] = ACTIONS(199),
    [anon_sym_assert] = ACTIONS(199),
    [anon_sym_upcast] = ACTIONS(199),
    [anon_sym_downcast] = ACTIONS(199),
    [anon_sym_COLON_GT] = ACTIONS(221),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(221),
    [anon_sym_for] = ACTIONS(223),
    [anon_sym_while] = ACTIONS(225),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(229),
    [anon_sym_match] = ACTIONS(231),
    [anon_sym_match_BANG] = ACTIONS(233),
    [anon_sym_function] = ACTIONS(235),
    [anon_sym_LT_DASH] = ACTIONS(237),
    [anon_sym_DOT_LBRACK] = ACTIONS(187),
    [anon_sym_LT] = ACTIONS(189),
    [anon_sym_use] = ACTIONS(239),
    [anon_sym_use_BANG] = ACTIONS(241),
    [anon_sym_do_BANG] = ACTIONS(243),
    [anon_sym_begin] = ACTIONS(245),
    [anon_sym_LPAREN2] = ACTIONS(191),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(247),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(251),
    [anon_sym_AT_DQUOTE] = ACTIONS(253),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(255),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(257),
    [sym_bool] = ACTIONS(259),
    [sym_unit] = ACTIONS(193),
    [anon_sym_LPAREN_PIPE] = ACTIONS(261),
    [sym_op_identifier] = ACTIONS(263),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(265),
    [sym_xint] = ACTIONS(267),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(269),
    [sym__newline] = ACTIONS(1539),
  },
  [275] = {
    [sym_function_or_value_defn] = STATE(600),
    [sym__expression] = STATE(88),
    [sym_literal_expression] = STATE(867),
    [sym_long_identifier_or_op] = STATE(867),
    [sym_tuple_expression] = STATE(867),
    [sym_brace_expression] = STATE(867),
    [sym_anon_record_expression] = STATE(867),
    [sym_prefixed_expression] = STATE(867),
    [sym_typecast_expression] = STATE(867),
    [sym_for_expression] = STATE(867),
    [sym_while_expression] = STATE(867),
    [sym__if_branch] = STATE(6511),
    [sym_if_expression] = STATE(867),
    [sym_fun_expression] = STATE(867),
    [sym_try_expression] = STATE(867),
    [sym_match_expression] = STATE(867),
    [sym_function_expression] = STATE(867),
    [sym_mutate_expression] = STATE(867),
    [sym_index_expression] = STATE(867),
    [sym_typed_expression] = STATE(867),
    [sym_declaration_expression] = STATE(867),
    [sym_do_expression] = STATE(867),
    [sym_list_expression] = STATE(867),
    [sym_array_expression] = STATE(867),
    [sym_begin_end_expression] = STATE(867),
    [sym_paren_expression] = STATE(867),
    [sym__high_prec_app] = STATE(864),
    [sym__low_prec_app] = STATE(864),
    [sym_application_expression] = STATE(867),
    [sym_dot_expression] = STATE(867),
    [sym_infix_expression] = STATE(867),
    [sym_ce_expression] = STATE(867),
    [sym_sequential_expression] = STATE(867),
    [sym_char] = STATE(868),
    [sym_format_string] = STATE(869),
    [sym__string_literal] = STATE(869),
    [sym_string] = STATE(868),
    [sym_verbatim_string] = STATE(868),
    [sym_bytearray] = STATE(868),
    [sym_verbatim_bytearray] = STATE(868),
    [sym_format_triple_quoted_string] = STATE(870),
    [sym_triple_quoted_string] = STATE(868),
    [sym_const] = STATE(867),
    [sym_long_identifier] = STATE(872),
    [sym_active_pattern] = STATE(871),
    [sym__identifier_or_op] = STATE(873),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(656),
    [sym_infix_op] = STATE(581),
    [sym_sbyte] = STATE(868),
    [sym_byte] = STATE(868),
    [sym_int16] = STATE(868),
    [sym_uint16] = STATE(868),
    [sym_int32] = STATE(868),
    [sym_uint32] = STATE(868),
    [sym_nativeint] = STATE(868),
    [sym_unativeint] = STATE(868),
    [sym_int64] = STATE(868),
    [sym_uint64] = STATE(868),
    [sym_ieee32] = STATE(868),
    [sym_ieee64] = STATE(868),
    [sym_bignum] = STATE(868),
    [sym_decimal] = STATE(868),
    [sym_float] = STATE(1368),
    [sym_block_comment] = STATE(275),
    [sym_compiler_directive_decl] = STATE(275),
    [sym_fsi_directive_decl] = STATE(275),
    [sym_preproc_line] = STATE(275),
    [sym_preproc_if_in_expression] = STATE(867),
    [aux_sym_sequential_expression_repeat1] = STATE(1542),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(29),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(825),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_COMMA] = ACTIONS(827),
    [anon_sym_null] = ACTIONS(49),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACK_PIPE] = ACTIONS(57),
    [anon_sym_LBRACE] = ACTIONS(139),
    [anon_sym_LT_AT] = ACTIONS(61),
    [anon_sym_LT_AT_AT] = ACTIONS(63),
    [anon_sym_DOT] = ACTIONS(65),
    [anon_sym_LBRACE_PIPE] = ACTIONS(67),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_return_BANG] = ACTIONS(829),
    [anon_sym_yield] = ACTIONS(825),
    [anon_sym_yield_BANG] = ACTIONS(829),
    [anon_sym_lazy] = ACTIONS(825),
    [anon_sym_assert] = ACTIONS(825),
    [anon_sym_upcast] = ACTIONS(825),
    [anon_sym_downcast] = ACTIONS(825),
    [anon_sym_COLON_GT] = ACTIONS(71),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(71),
    [anon_sym_for] = ACTIONS(73),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(79),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_match] = ACTIONS(83),
    [anon_sym_match_BANG] = ACTIONS(85),
    [anon_sym_function] = ACTIONS(87),
    [anon_sym_LT_DASH] = ACTIONS(831),
    [anon_sym_DOT_LBRACK] = ACTIONS(91),
    [anon_sym_LT] = ACTIONS(93),
    [anon_sym_use] = ACTIONS(833),
    [anon_sym_use_BANG] = ACTIONS(835),
    [anon_sym_do_BANG] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(101),
    [anon_sym_LPAREN2] = ACTIONS(103),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(105),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(107),
    [anon_sym_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DQUOTE] = ACTIONS(111),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(115),
    [sym_bool] = ACTIONS(117),
    [sym_unit] = ACTIONS(119),
    [anon_sym_LPAREN_PIPE] = ACTIONS(121),
    [sym_op_identifier] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(837),
    [sym_xint] = ACTIONS(387),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(135),
    [sym__newline] = ACTIONS(839),
    [sym__dedent] = ACTIONS(1541),
  },
  [276] = {
    [sym_function_or_value_defn] = STATE(509),
    [sym__expression] = STATE(326),
    [sym_literal_expression] = STATE(2230),
    [sym_long_identifier_or_op] = STATE(2230),
    [sym_tuple_expression] = STATE(2230),
    [sym_brace_expression] = STATE(2230),
    [sym_anon_record_expression] = STATE(2230),
    [sym_prefixed_expression] = STATE(2230),
    [sym_typecast_expression] = STATE(2230),
    [sym_for_expression] = STATE(2230),
    [sym_while_expression] = STATE(2230),
    [sym__if_branch] = STATE(6659),
    [sym_if_expression] = STATE(2230),
    [sym_fun_expression] = STATE(2230),
    [sym_try_expression] = STATE(2230),
    [sym_match_expression] = STATE(2230),
    [sym_function_expression] = STATE(2230),
    [sym_mutate_expression] = STATE(2230),
    [sym_index_expression] = STATE(2230),
    [sym_typed_expression] = STATE(2230),
    [sym_declaration_expression] = STATE(2230),
    [sym_do_expression] = STATE(2230),
    [sym_list_expression] = STATE(2230),
    [sym_array_expression] = STATE(2230),
    [sym_begin_end_expression] = STATE(2230),
    [sym_paren_expression] = STATE(2230),
    [sym__high_prec_app] = STATE(2229),
    [sym__low_prec_app] = STATE(2229),
    [sym_application_expression] = STATE(2230),
    [sym_dot_expression] = STATE(2230),
    [sym_infix_expression] = STATE(2230),
    [sym_ce_expression] = STATE(2230),
    [sym_sequential_expression] = STATE(2230),
    [sym_char] = STATE(2100),
    [sym_format_string] = STATE(2106),
    [sym__string_literal] = STATE(2106),
    [sym_string] = STATE(2100),
    [sym_verbatim_string] = STATE(2100),
    [sym_bytearray] = STATE(2100),
    [sym_verbatim_bytearray] = STATE(2100),
    [sym_format_triple_quoted_string] = STATE(2107),
    [sym_triple_quoted_string] = STATE(2100),
    [sym_const] = STATE(2230),
    [sym_long_identifier] = STATE(2232),
    [sym_active_pattern] = STATE(2424),
    [sym__identifier_or_op] = STATE(2305),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(737),
    [sym_infix_op] = STATE(694),
    [sym_sbyte] = STATE(2100),
    [sym_byte] = STATE(2100),
    [sym_int16] = STATE(2100),
    [sym_uint16] = STATE(2100),
    [sym_int32] = STATE(2100),
    [sym_uint32] = STATE(2100),
    [sym_nativeint] = STATE(2100),
    [sym_unativeint] = STATE(2100),
    [sym_int64] = STATE(2100),
    [sym_uint64] = STATE(2100),
    [sym_ieee32] = STATE(2100),
    [sym_ieee64] = STATE(2100),
    [sym_bignum] = STATE(2100),
    [sym_decimal] = STATE(2100),
    [sym_float] = STATE(1487),
    [sym_block_comment] = STATE(276),
    [sym_compiler_directive_decl] = STATE(276),
    [sym_fsi_directive_decl] = STATE(276),
    [sym_preproc_line] = STATE(276),
    [sym_preproc_if_in_expression] = STATE(2230),
    [aux_sym_sequential_expression_repeat1] = STATE(1743),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(877),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(879),
    [anon_sym_return] = ACTIONS(881),
    [anon_sym_do] = ACTIONS(1543),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(885),
    [anon_sym_COMMA] = ACTIONS(887),
    [anon_sym_null] = ACTIONS(889),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(879),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(891),
    [anon_sym_LBRACK_PIPE] = ACTIONS(893),
    [anon_sym_LBRACE] = ACTIONS(895),
    [anon_sym_LT_AT] = ACTIONS(897),
    [anon_sym_LT_AT_AT] = ACTIONS(899),
    [anon_sym_DOT] = ACTIONS(901),
    [anon_sym_LBRACE_PIPE] = ACTIONS(903),
    [anon_sym_new] = ACTIONS(881),
    [anon_sym_return_BANG] = ACTIONS(905),
    [anon_sym_yield] = ACTIONS(881),
    [anon_sym_yield_BANG] = ACTIONS(905),
    [anon_sym_lazy] = ACTIONS(881),
    [anon_sym_assert] = ACTIONS(881),
    [anon_sym_upcast] = ACTIONS(881),
    [anon_sym_downcast] = ACTIONS(881),
    [anon_sym_COLON_GT] = ACTIONS(907),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(907),
    [anon_sym_for] = ACTIONS(909),
    [anon_sym_while] = ACTIONS(911),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(913),
    [anon_sym_try] = ACTIONS(915),
    [anon_sym_match] = ACTIONS(917),
    [anon_sym_match_BANG] = ACTIONS(919),
    [anon_sym_function] = ACTIONS(921),
    [anon_sym_LT_DASH] = ACTIONS(923),
    [anon_sym_DOT_LBRACK] = ACTIONS(925),
    [anon_sym_LT] = ACTIONS(927),
    [anon_sym_use] = ACTIONS(929),
    [anon_sym_use_BANG] = ACTIONS(931),
    [anon_sym_do_BANG] = ACTIONS(933),
    [anon_sym_DOT_DOT] = ACTIONS(935),
    [anon_sym_begin] = ACTIONS(937),
    [anon_sym_LPAREN2] = ACTIONS(939),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(941),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(943),
    [anon_sym_DQUOTE] = ACTIONS(945),
    [anon_sym_AT_DQUOTE] = ACTIONS(947),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(949),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(951),
    [sym_bool] = ACTIONS(953),
    [sym_unit] = ACTIONS(955),
    [anon_sym_LPAREN_PIPE] = ACTIONS(957),
    [sym_op_identifier] = ACTIONS(959),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(961),
    [sym_xint] = ACTIONS(963),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(965),
    [sym__newline] = ACTIONS(967),
  },
  [277] = {
    [sym_function_or_value_defn] = STATE(527),
    [sym__expression] = STATE(260),
    [sym_literal_expression] = STATE(2384),
    [sym_long_identifier_or_op] = STATE(2384),
    [sym_tuple_expression] = STATE(2384),
    [sym_brace_expression] = STATE(2384),
    [sym_anon_record_expression] = STATE(2384),
    [sym_prefixed_expression] = STATE(2384),
    [sym_typecast_expression] = STATE(2384),
    [sym_for_expression] = STATE(2384),
    [sym_while_expression] = STATE(2384),
    [sym__if_branch] = STATE(6561),
    [sym_if_expression] = STATE(2384),
    [sym_fun_expression] = STATE(2384),
    [sym_try_expression] = STATE(2384),
    [sym_match_expression] = STATE(2384),
    [sym_function_expression] = STATE(2384),
    [sym_mutate_expression] = STATE(2384),
    [sym_index_expression] = STATE(2384),
    [sym_typed_expression] = STATE(2384),
    [sym_declaration_expression] = STATE(2384),
    [sym_do_expression] = STATE(2384),
    [sym_list_expression] = STATE(2384),
    [sym_array_expression] = STATE(2384),
    [sym_begin_end_expression] = STATE(2384),
    [sym_paren_expression] = STATE(2384),
    [sym__high_prec_app] = STATE(2249),
    [sym__low_prec_app] = STATE(2249),
    [sym_application_expression] = STATE(2384),
    [sym_dot_expression] = STATE(2384),
    [sym_infix_expression] = STATE(2384),
    [sym_ce_expression] = STATE(2384),
    [sym_sequential_expression] = STATE(2384),
    [sym_char] = STATE(2144),
    [sym_format_string] = STATE(2142),
    [sym__string_literal] = STATE(2142),
    [sym_string] = STATE(2144),
    [sym_verbatim_string] = STATE(2144),
    [sym_bytearray] = STATE(2144),
    [sym_verbatim_bytearray] = STATE(2144),
    [sym_format_triple_quoted_string] = STATE(2141),
    [sym_triple_quoted_string] = STATE(2144),
    [sym_const] = STATE(2384),
    [sym_long_identifier] = STATE(2400),
    [sym_active_pattern] = STATE(2317),
    [sym__identifier_or_op] = STATE(2392),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(633),
    [sym_infix_op] = STATE(511),
    [sym_sbyte] = STATE(2144),
    [sym_byte] = STATE(2144),
    [sym_int16] = STATE(2144),
    [sym_uint16] = STATE(2144),
    [sym_int32] = STATE(2144),
    [sym_uint32] = STATE(2144),
    [sym_nativeint] = STATE(2144),
    [sym_unativeint] = STATE(2144),
    [sym_int64] = STATE(2144),
    [sym_uint64] = STATE(2144),
    [sym_ieee32] = STATE(2144),
    [sym_ieee64] = STATE(2144),
    [sym_bignum] = STATE(2144),
    [sym_decimal] = STATE(2144),
    [sym_float] = STATE(1672),
    [sym_block_comment] = STATE(277),
    [sym_compiler_directive_decl] = STATE(277),
    [sym_fsi_directive_decl] = STATE(277),
    [sym_preproc_line] = STATE(277),
    [sym_preproc_if_in_expression] = STATE(2384),
    [aux_sym_sequential_expression_repeat1] = STATE(1748),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(1439),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(1441),
    [anon_sym_return] = ACTIONS(1443),
    [anon_sym_do] = ACTIONS(1445),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(1447),
    [anon_sym_COMMA] = ACTIONS(1449),
    [anon_sym_null] = ACTIONS(1451),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(1441),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1453),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1455),
    [anon_sym_LBRACE] = ACTIONS(1457),
    [anon_sym_LT_AT] = ACTIONS(1459),
    [anon_sym_LT_AT_AT] = ACTIONS(1461),
    [anon_sym_DOT] = ACTIONS(1463),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1465),
    [anon_sym_new] = ACTIONS(1443),
    [anon_sym_return_BANG] = ACTIONS(1467),
    [anon_sym_yield] = ACTIONS(1443),
    [anon_sym_yield_BANG] = ACTIONS(1467),
    [anon_sym_lazy] = ACTIONS(1443),
    [anon_sym_assert] = ACTIONS(1443),
    [anon_sym_upcast] = ACTIONS(1443),
    [anon_sym_downcast] = ACTIONS(1443),
    [anon_sym_COLON_GT] = ACTIONS(1469),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1469),
    [anon_sym_for] = ACTIONS(1471),
    [anon_sym_while] = ACTIONS(1473),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(1475),
    [anon_sym_try] = ACTIONS(1477),
    [anon_sym_match] = ACTIONS(1479),
    [anon_sym_match_BANG] = ACTIONS(1481),
    [anon_sym_function] = ACTIONS(1483),
    [anon_sym_LT_DASH] = ACTIONS(1485),
    [anon_sym_DOT_LBRACK] = ACTIONS(1487),
    [anon_sym_LT] = ACTIONS(1489),
    [anon_sym_GT] = ACTIONS(173),
    [anon_sym_use] = ACTIONS(1491),
    [anon_sym_use_BANG] = ACTIONS(1493),
    [anon_sym_do_BANG] = ACTIONS(1495),
    [anon_sym_begin] = ACTIONS(1497),
    [anon_sym_LPAREN2] = ACTIONS(1499),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(1501),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1503),
    [anon_sym_DQUOTE] = ACTIONS(1505),
    [anon_sym_AT_DQUOTE] = ACTIONS(1507),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1509),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1511),
    [sym_bool] = ACTIONS(1513),
    [sym_unit] = ACTIONS(1515),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1517),
    [sym_op_identifier] = ACTIONS(1519),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(1521),
    [sym_xint] = ACTIONS(1523),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1525),
    [sym__newline] = ACTIONS(1527),
  },
  [278] = {
    [sym_function_or_value_defn] = STATE(704),
    [sym__expression] = STATE(312),
    [sym_literal_expression] = STATE(2403),
    [sym_long_identifier_or_op] = STATE(2403),
    [sym_tuple_expression] = STATE(2403),
    [sym_brace_expression] = STATE(2403),
    [sym_anon_record_expression] = STATE(2403),
    [sym_prefixed_expression] = STATE(2403),
    [sym_typecast_expression] = STATE(2403),
    [sym_for_expression] = STATE(2403),
    [sym_while_expression] = STATE(2403),
    [sym__if_branch] = STATE(6794),
    [sym_if_expression] = STATE(2403),
    [sym_fun_expression] = STATE(2403),
    [sym_try_expression] = STATE(2403),
    [sym_match_expression] = STATE(2403),
    [sym_function_expression] = STATE(2403),
    [sym_mutate_expression] = STATE(2403),
    [sym_index_expression] = STATE(2403),
    [sym_typed_expression] = STATE(2403),
    [sym_declaration_expression] = STATE(2403),
    [sym_do_expression] = STATE(2403),
    [sym_list_expression] = STATE(2403),
    [sym_array_expression] = STATE(2403),
    [sym_begin_end_expression] = STATE(2403),
    [sym_paren_expression] = STATE(2403),
    [sym__high_prec_app] = STATE(2405),
    [sym__low_prec_app] = STATE(2405),
    [sym_application_expression] = STATE(2403),
    [sym_dot_expression] = STATE(2403),
    [sym_infix_expression] = STATE(2403),
    [sym_ce_expression] = STATE(2403),
    [sym_sequential_expression] = STATE(2403),
    [sym_char] = STATE(2425),
    [sym_format_string] = STATE(2420),
    [sym__string_literal] = STATE(2420),
    [sym_string] = STATE(2425),
    [sym_verbatim_string] = STATE(2425),
    [sym_bytearray] = STATE(2425),
    [sym_verbatim_bytearray] = STATE(2425),
    [sym_format_triple_quoted_string] = STATE(2419),
    [sym_triple_quoted_string] = STATE(2425),
    [sym_const] = STATE(2403),
    [sym_long_identifier] = STATE(2079),
    [sym_active_pattern] = STATE(2080),
    [sym__identifier_or_op] = STATE(2089),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(688),
    [sym_infix_op] = STATE(668),
    [sym_sbyte] = STATE(2425),
    [sym_byte] = STATE(2425),
    [sym_int16] = STATE(2425),
    [sym_uint16] = STATE(2425),
    [sym_int32] = STATE(2425),
    [sym_uint32] = STATE(2425),
    [sym_nativeint] = STATE(2425),
    [sym_unativeint] = STATE(2425),
    [sym_int64] = STATE(2425),
    [sym_uint64] = STATE(2425),
    [sym_ieee32] = STATE(2425),
    [sym_ieee64] = STATE(2425),
    [sym_bignum] = STATE(2425),
    [sym_decimal] = STATE(2425),
    [sym_float] = STATE(1511),
    [sym_block_comment] = STATE(278),
    [sym_compiler_directive_decl] = STATE(278),
    [sym_fsi_directive_decl] = STATE(278),
    [sym_preproc_line] = STATE(278),
    [sym_preproc_if_in_expression] = STATE(2403),
    [aux_sym_sequential_expression_repeat1] = STATE(1901),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(181),
    [anon_sym_EQ] = ACTIONS(183),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_return] = ACTIONS(181),
    [anon_sym_do] = ACTIONS(181),
    [anon_sym_let] = ACTIONS(181),
    [anon_sym_let_BANG] = ACTIONS(183),
    [anon_sym_LPAREN] = ACTIONS(181),
    [anon_sym_COMMA] = ACTIONS(183),
    [anon_sym_null] = ACTIONS(181),
    [anon_sym_QMARK] = ACTIONS(181),
    [anon_sym_COLON_QMARK] = ACTIONS(181),
    [anon_sym_COLON_COLON] = ACTIONS(183),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_LBRACK_PIPE] = ACTIONS(183),
    [anon_sym_LBRACE] = ACTIONS(181),
    [anon_sym_LT_AT] = ACTIONS(181),
    [anon_sym_LT_AT_AT] = ACTIONS(181),
    [anon_sym_DOT] = ACTIONS(1285),
    [anon_sym_LBRACE_PIPE] = ACTIONS(183),
    [anon_sym_new] = ACTIONS(181),
    [anon_sym_return_BANG] = ACTIONS(183),
    [anon_sym_yield] = ACTIONS(181),
    [anon_sym_yield_BANG] = ACTIONS(183),
    [anon_sym_lazy] = ACTIONS(181),
    [anon_sym_assert] = ACTIONS(181),
    [anon_sym_upcast] = ACTIONS(181),
    [anon_sym_downcast] = ACTIONS(181),
    [anon_sym_COLON_GT] = ACTIONS(183),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(183),
    [anon_sym_for] = ACTIONS(181),
    [anon_sym_while] = ACTIONS(181),
    [anon_sym_if] = ACTIONS(181),
    [anon_sym_fun] = ACTIONS(181),
    [anon_sym_try] = ACTIONS(181),
    [anon_sym_match] = ACTIONS(181),
    [anon_sym_match_BANG] = ACTIONS(183),
    [anon_sym_function] = ACTIONS(181),
    [anon_sym_LT_DASH] = ACTIONS(181),
    [anon_sym_DOT_LBRACK] = ACTIONS(1309),
    [anon_sym_LT] = ACTIONS(1311),
    [anon_sym_use] = ACTIONS(181),
    [anon_sym_use_BANG] = ACTIONS(183),
    [anon_sym_do_BANG] = ACTIONS(183),
    [anon_sym_begin] = ACTIONS(181),
    [anon_sym_LPAREN2] = ACTIONS(1321),
    [anon_sym_or] = ACTIONS(181),
    [aux_sym_char_token1] = ACTIONS(183),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(181),
    [anon_sym_DQUOTE] = ACTIONS(181),
    [anon_sym_AT_DQUOTE] = ACTIONS(183),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(183),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(183),
    [sym_bool] = ACTIONS(181),
    [sym_unit] = ACTIONS(1337),
    [anon_sym_LPAREN_PIPE] = ACTIONS(181),
    [sym_op_identifier] = ACTIONS(181),
    [anon_sym_PLUS] = ACTIONS(181),
    [anon_sym_DASH] = ACTIONS(181),
    [anon_sym_PLUS_DOT] = ACTIONS(181),
    [anon_sym_DASH_DOT] = ACTIONS(181),
    [anon_sym_PERCENT] = ACTIONS(181),
    [anon_sym_AMP_AMP] = ACTIONS(181),
    [anon_sym_TILDE] = ACTIONS(183),
    [aux_sym_prefix_op_token1] = ACTIONS(181),
    [aux_sym_infix_op_token1] = ACTIONS(183),
    [aux_sym_infix_op_token2] = ACTIONS(181),
    [anon_sym_PIPE_PIPE] = ACTIONS(181),
    [anon_sym_BANG_EQ] = ACTIONS(181),
    [anon_sym_COLON_EQ] = ACTIONS(183),
    [anon_sym_DOLLAR] = ACTIONS(181),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(181),
    [sym_int] = ACTIONS(181),
    [sym_xint] = ACTIONS(183),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(183),
    [anon_sym_POUNDendif] = ACTIONS(183),
    [sym__newline] = ACTIONS(183),
  },
  [279] = {
    [sym_function_or_value_defn] = STATE(733),
    [sym__expression] = STATE(142),
    [sym_literal_expression] = STATE(2008),
    [sym_long_identifier_or_op] = STATE(2008),
    [sym_tuple_expression] = STATE(2008),
    [sym_brace_expression] = STATE(2008),
    [sym_anon_record_expression] = STATE(2008),
    [sym_prefixed_expression] = STATE(2008),
    [sym_typecast_expression] = STATE(2008),
    [sym_for_expression] = STATE(2008),
    [sym_while_expression] = STATE(2008),
    [sym__if_branch] = STATE(6754),
    [sym_if_expression] = STATE(2008),
    [sym_fun_expression] = STATE(2008),
    [sym_try_expression] = STATE(2008),
    [sym_match_expression] = STATE(2008),
    [sym_function_expression] = STATE(2008),
    [sym_mutate_expression] = STATE(2008),
    [sym_index_expression] = STATE(2008),
    [sym_typed_expression] = STATE(2008),
    [sym_declaration_expression] = STATE(2008),
    [sym_do_expression] = STATE(2008),
    [sym_list_expression] = STATE(2008),
    [sym_array_expression] = STATE(2008),
    [sym_begin_end_expression] = STATE(2008),
    [sym_paren_expression] = STATE(2008),
    [sym__high_prec_app] = STATE(2007),
    [sym__low_prec_app] = STATE(2007),
    [sym_application_expression] = STATE(2008),
    [sym_dot_expression] = STATE(2008),
    [sym_infix_expression] = STATE(2008),
    [sym_ce_expression] = STATE(2008),
    [sym_sequential_expression] = STATE(2008),
    [sym_char] = STATE(1859),
    [sym_format_string] = STATE(1861),
    [sym__string_literal] = STATE(1861),
    [sym_string] = STATE(1859),
    [sym_verbatim_string] = STATE(1859),
    [sym_bytearray] = STATE(1859),
    [sym_verbatim_bytearray] = STATE(1859),
    [sym_format_triple_quoted_string] = STATE(1862),
    [sym_triple_quoted_string] = STATE(1859),
    [sym_const] = STATE(2008),
    [sym_long_identifier] = STATE(1701),
    [sym_active_pattern] = STATE(1702),
    [sym__identifier_or_op] = STATE(1724),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(706),
    [sym_infix_op] = STATE(678),
    [sym_sbyte] = STATE(1859),
    [sym_byte] = STATE(1859),
    [sym_int16] = STATE(1859),
    [sym_uint16] = STATE(1859),
    [sym_int32] = STATE(1859),
    [sym_uint32] = STATE(1859),
    [sym_nativeint] = STATE(1859),
    [sym_unativeint] = STATE(1859),
    [sym_int64] = STATE(1859),
    [sym_uint64] = STATE(1859),
    [sym_ieee32] = STATE(1859),
    [sym_ieee64] = STATE(1859),
    [sym_bignum] = STATE(1859),
    [sym_decimal] = STATE(1859),
    [sym_float] = STATE(1447),
    [sym_block_comment] = STATE(279),
    [sym_compiler_directive_decl] = STATE(279),
    [sym_fsi_directive_decl] = STATE(279),
    [sym_preproc_line] = STATE(279),
    [sym_preproc_if_in_expression] = STATE(2008),
    [aux_sym_sequential_expression_repeat1] = STATE(1995),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(503),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(969),
    [anon_sym_return] = ACTIONS(971),
    [anon_sym_do] = ACTIONS(599),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(511),
    [anon_sym_COMMA] = ACTIONS(973),
    [anon_sym_null] = ACTIONS(515),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(969),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(517),
    [anon_sym_LBRACK_PIPE] = ACTIONS(519),
    [anon_sym_LBRACE] = ACTIONS(521),
    [anon_sym_LT_AT] = ACTIONS(523),
    [anon_sym_LT_AT_AT] = ACTIONS(525),
    [anon_sym_DOT] = ACTIONS(527),
    [anon_sym_LBRACE_PIPE] = ACTIONS(529),
    [anon_sym_new] = ACTIONS(971),
    [anon_sym_return_BANG] = ACTIONS(975),
    [anon_sym_yield] = ACTIONS(971),
    [anon_sym_yield_BANG] = ACTIONS(975),
    [anon_sym_lazy] = ACTIONS(971),
    [anon_sym_assert] = ACTIONS(971),
    [anon_sym_upcast] = ACTIONS(971),
    [anon_sym_downcast] = ACTIONS(971),
    [anon_sym_COLON_GT] = ACTIONS(977),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(977),
    [anon_sym_for] = ACTIONS(979),
    [anon_sym_while] = ACTIONS(537),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(539),
    [anon_sym_DASH_GT] = ACTIONS(1545),
    [anon_sym_try] = ACTIONS(543),
    [anon_sym_match] = ACTIONS(545),
    [anon_sym_match_BANG] = ACTIONS(547),
    [anon_sym_function] = ACTIONS(549),
    [anon_sym_LT_DASH] = ACTIONS(981),
    [anon_sym_DOT_LBRACK] = ACTIONS(553),
    [anon_sym_LT] = ACTIONS(555),
    [anon_sym_use] = ACTIONS(983),
    [anon_sym_use_BANG] = ACTIONS(985),
    [anon_sym_do_BANG] = ACTIONS(561),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_LPAREN2] = ACTIONS(567),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(569),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(571),
    [anon_sym_DQUOTE] = ACTIONS(573),
    [anon_sym_AT_DQUOTE] = ACTIONS(575),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(577),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(579),
    [sym_bool] = ACTIONS(581),
    [sym_unit] = ACTIONS(583),
    [anon_sym_LPAREN_PIPE] = ACTIONS(585),
    [sym_op_identifier] = ACTIONS(587),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(591),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(593),
    [sym__newline] = ACTIONS(1171),
  },
  [280] = {
    [sym_function_or_value_defn] = STATE(600),
    [sym__expression] = STATE(88),
    [sym_literal_expression] = STATE(867),
    [sym_long_identifier_or_op] = STATE(867),
    [sym_tuple_expression] = STATE(867),
    [sym_brace_expression] = STATE(867),
    [sym_anon_record_expression] = STATE(867),
    [sym_prefixed_expression] = STATE(867),
    [sym_typecast_expression] = STATE(867),
    [sym_for_expression] = STATE(867),
    [sym_while_expression] = STATE(867),
    [sym__if_branch] = STATE(6511),
    [sym_if_expression] = STATE(867),
    [sym_fun_expression] = STATE(867),
    [sym_try_expression] = STATE(867),
    [sym_match_expression] = STATE(867),
    [sym_function_expression] = STATE(867),
    [sym_mutate_expression] = STATE(867),
    [sym_index_expression] = STATE(867),
    [sym_typed_expression] = STATE(867),
    [sym_declaration_expression] = STATE(867),
    [sym_do_expression] = STATE(867),
    [sym_list_expression] = STATE(867),
    [sym_array_expression] = STATE(867),
    [sym_begin_end_expression] = STATE(867),
    [sym_paren_expression] = STATE(867),
    [sym__high_prec_app] = STATE(864),
    [sym__low_prec_app] = STATE(864),
    [sym_application_expression] = STATE(867),
    [sym_dot_expression] = STATE(867),
    [sym_infix_expression] = STATE(867),
    [sym_ce_expression] = STATE(867),
    [sym_sequential_expression] = STATE(867),
    [sym_char] = STATE(868),
    [sym_format_string] = STATE(869),
    [sym__string_literal] = STATE(869),
    [sym_string] = STATE(868),
    [sym_verbatim_string] = STATE(868),
    [sym_bytearray] = STATE(868),
    [sym_verbatim_bytearray] = STATE(868),
    [sym_format_triple_quoted_string] = STATE(870),
    [sym_triple_quoted_string] = STATE(868),
    [sym_const] = STATE(867),
    [sym_long_identifier] = STATE(872),
    [sym_active_pattern] = STATE(871),
    [sym__identifier_or_op] = STATE(873),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(656),
    [sym_infix_op] = STATE(581),
    [sym_sbyte] = STATE(868),
    [sym_byte] = STATE(868),
    [sym_int16] = STATE(868),
    [sym_uint16] = STATE(868),
    [sym_int32] = STATE(868),
    [sym_uint32] = STATE(868),
    [sym_nativeint] = STATE(868),
    [sym_unativeint] = STATE(868),
    [sym_int64] = STATE(868),
    [sym_uint64] = STATE(868),
    [sym_ieee32] = STATE(868),
    [sym_ieee64] = STATE(868),
    [sym_bignum] = STATE(868),
    [sym_decimal] = STATE(868),
    [sym_float] = STATE(1368),
    [sym_block_comment] = STATE(280),
    [sym_compiler_directive_decl] = STATE(280),
    [sym_fsi_directive_decl] = STATE(280),
    [sym_preproc_line] = STATE(280),
    [sym_preproc_if_in_expression] = STATE(867),
    [aux_sym_sequential_expression_repeat1] = STATE(1542),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(29),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(825),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_COMMA] = ACTIONS(1239),
    [anon_sym_null] = ACTIONS(49),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACK_PIPE] = ACTIONS(57),
    [anon_sym_LBRACE] = ACTIONS(139),
    [anon_sym_LT_AT] = ACTIONS(61),
    [anon_sym_LT_AT_AT] = ACTIONS(63),
    [anon_sym_DOT] = ACTIONS(65),
    [anon_sym_LBRACE_PIPE] = ACTIONS(67),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_return_BANG] = ACTIONS(829),
    [anon_sym_yield] = ACTIONS(825),
    [anon_sym_yield_BANG] = ACTIONS(829),
    [anon_sym_lazy] = ACTIONS(825),
    [anon_sym_assert] = ACTIONS(825),
    [anon_sym_upcast] = ACTIONS(825),
    [anon_sym_downcast] = ACTIONS(825),
    [anon_sym_COLON_GT] = ACTIONS(71),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(71),
    [anon_sym_for] = ACTIONS(73),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(79),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_match] = ACTIONS(83),
    [anon_sym_match_BANG] = ACTIONS(85),
    [anon_sym_function] = ACTIONS(87),
    [anon_sym_LT_DASH] = ACTIONS(831),
    [anon_sym_DOT_LBRACK] = ACTIONS(91),
    [anon_sym_LT] = ACTIONS(93),
    [anon_sym_use] = ACTIONS(833),
    [anon_sym_use_BANG] = ACTIONS(835),
    [anon_sym_do_BANG] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(101),
    [anon_sym_LPAREN2] = ACTIONS(103),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(105),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(107),
    [anon_sym_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DQUOTE] = ACTIONS(111),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(115),
    [sym_bool] = ACTIONS(117),
    [sym_unit] = ACTIONS(119),
    [anon_sym_LPAREN_PIPE] = ACTIONS(121),
    [sym_op_identifier] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(837),
    [sym_xint] = ACTIONS(387),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(135),
    [sym__newline] = ACTIONS(839),
    [sym__dedent] = ACTIONS(1239),
  },
  [281] = {
    [sym_function_or_value_defn] = STATE(704),
    [sym__expression] = STATE(312),
    [sym_literal_expression] = STATE(2403),
    [sym_long_identifier_or_op] = STATE(2403),
    [sym_tuple_expression] = STATE(2403),
    [sym_brace_expression] = STATE(2403),
    [sym_anon_record_expression] = STATE(2403),
    [sym_prefixed_expression] = STATE(2403),
    [sym_typecast_expression] = STATE(2403),
    [sym_for_expression] = STATE(2403),
    [sym_while_expression] = STATE(2403),
    [sym__if_branch] = STATE(6794),
    [sym_if_expression] = STATE(2403),
    [sym_fun_expression] = STATE(2403),
    [sym_try_expression] = STATE(2403),
    [sym_match_expression] = STATE(2403),
    [sym_function_expression] = STATE(2403),
    [sym_mutate_expression] = STATE(2403),
    [sym_index_expression] = STATE(2403),
    [sym_typed_expression] = STATE(2403),
    [sym_declaration_expression] = STATE(2403),
    [sym_do_expression] = STATE(2403),
    [sym_list_expression] = STATE(2403),
    [sym_array_expression] = STATE(2403),
    [sym_begin_end_expression] = STATE(2403),
    [sym_paren_expression] = STATE(2403),
    [sym__high_prec_app] = STATE(2405),
    [sym__low_prec_app] = STATE(2405),
    [sym_application_expression] = STATE(2403),
    [sym_dot_expression] = STATE(2403),
    [sym_infix_expression] = STATE(2403),
    [sym_ce_expression] = STATE(2403),
    [sym_sequential_expression] = STATE(2403),
    [sym_char] = STATE(2425),
    [sym_format_string] = STATE(2420),
    [sym__string_literal] = STATE(2420),
    [sym_string] = STATE(2425),
    [sym_verbatim_string] = STATE(2425),
    [sym_bytearray] = STATE(2425),
    [sym_verbatim_bytearray] = STATE(2425),
    [sym_format_triple_quoted_string] = STATE(2419),
    [sym_triple_quoted_string] = STATE(2425),
    [sym_const] = STATE(2403),
    [sym_long_identifier] = STATE(2079),
    [sym_active_pattern] = STATE(2080),
    [sym__identifier_or_op] = STATE(2089),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(688),
    [sym_infix_op] = STATE(668),
    [sym_sbyte] = STATE(2425),
    [sym_byte] = STATE(2425),
    [sym_int16] = STATE(2425),
    [sym_uint16] = STATE(2425),
    [sym_int32] = STATE(2425),
    [sym_uint32] = STATE(2425),
    [sym_nativeint] = STATE(2425),
    [sym_unativeint] = STATE(2425),
    [sym_int64] = STATE(2425),
    [sym_uint64] = STATE(2425),
    [sym_ieee32] = STATE(2425),
    [sym_ieee64] = STATE(2425),
    [sym_bignum] = STATE(2425),
    [sym_decimal] = STATE(2425),
    [sym_float] = STATE(1511),
    [sym_block_comment] = STATE(281),
    [sym_compiler_directive_decl] = STATE(281),
    [sym_fsi_directive_decl] = STATE(281),
    [sym_preproc_line] = STATE(281),
    [sym_preproc_if_in_expression] = STATE(2403),
    [aux_sym_sequential_expression_repeat1] = STATE(1901),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(1261),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(1263),
    [anon_sym_return] = ACTIONS(1265),
    [anon_sym_do] = ACTIONS(1267),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(1269),
    [anon_sym_COMMA] = ACTIONS(1271),
    [anon_sym_null] = ACTIONS(1273),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(1263),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1275),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1277),
    [anon_sym_LBRACE] = ACTIONS(169),
    [anon_sym_LT_AT] = ACTIONS(1281),
    [anon_sym_LT_AT_AT] = ACTIONS(1283),
    [anon_sym_DOT] = ACTIONS(1285),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1287),
    [anon_sym_new] = ACTIONS(1265),
    [anon_sym_return_BANG] = ACTIONS(1289),
    [anon_sym_yield] = ACTIONS(1265),
    [anon_sym_yield_BANG] = ACTIONS(1289),
    [anon_sym_lazy] = ACTIONS(1265),
    [anon_sym_assert] = ACTIONS(1265),
    [anon_sym_upcast] = ACTIONS(1265),
    [anon_sym_downcast] = ACTIONS(1265),
    [anon_sym_COLON_GT] = ACTIONS(1291),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1291),
    [anon_sym_for] = ACTIONS(1293),
    [anon_sym_while] = ACTIONS(1295),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(1297),
    [anon_sym_try] = ACTIONS(1299),
    [anon_sym_match] = ACTIONS(1301),
    [anon_sym_match_BANG] = ACTIONS(1303),
    [anon_sym_function] = ACTIONS(1305),
    [anon_sym_LT_DASH] = ACTIONS(1307),
    [anon_sym_DOT_LBRACK] = ACTIONS(1309),
    [anon_sym_LT] = ACTIONS(1311),
    [anon_sym_use] = ACTIONS(1313),
    [anon_sym_use_BANG] = ACTIONS(1315),
    [anon_sym_do_BANG] = ACTIONS(1317),
    [anon_sym_begin] = ACTIONS(1319),
    [anon_sym_LPAREN2] = ACTIONS(1321),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(1323),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1325),
    [anon_sym_DQUOTE] = ACTIONS(1327),
    [anon_sym_AT_DQUOTE] = ACTIONS(1329),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1331),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1333),
    [sym_bool] = ACTIONS(1335),
    [sym_unit] = ACTIONS(1337),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1339),
    [sym_op_identifier] = ACTIONS(1341),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(1343),
    [sym_xint] = ACTIONS(1345),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1347),
    [anon_sym_POUNDendif] = ACTIONS(167),
    [sym__newline] = ACTIONS(167),
  },
  [282] = {
    [sym_function_or_value_defn] = STATE(600),
    [sym__expression] = STATE(88),
    [sym_literal_expression] = STATE(867),
    [sym_long_identifier_or_op] = STATE(867),
    [sym_tuple_expression] = STATE(867),
    [sym_brace_expression] = STATE(867),
    [sym_anon_record_expression] = STATE(867),
    [sym_prefixed_expression] = STATE(867),
    [sym_typecast_expression] = STATE(867),
    [sym_for_expression] = STATE(867),
    [sym_while_expression] = STATE(867),
    [sym__if_branch] = STATE(6511),
    [sym_if_expression] = STATE(867),
    [sym_fun_expression] = STATE(867),
    [sym_try_expression] = STATE(867),
    [sym_match_expression] = STATE(867),
    [sym_function_expression] = STATE(867),
    [sym_mutate_expression] = STATE(867),
    [sym_index_expression] = STATE(867),
    [sym_typed_expression] = STATE(867),
    [sym_declaration_expression] = STATE(867),
    [sym_do_expression] = STATE(867),
    [sym_list_expression] = STATE(867),
    [sym_array_expression] = STATE(867),
    [sym_begin_end_expression] = STATE(867),
    [sym_paren_expression] = STATE(867),
    [sym__high_prec_app] = STATE(864),
    [sym__low_prec_app] = STATE(864),
    [sym_application_expression] = STATE(867),
    [sym_dot_expression] = STATE(867),
    [sym_infix_expression] = STATE(867),
    [sym_ce_expression] = STATE(867),
    [sym_sequential_expression] = STATE(867),
    [sym_char] = STATE(868),
    [sym_format_string] = STATE(869),
    [sym__string_literal] = STATE(869),
    [sym_string] = STATE(868),
    [sym_verbatim_string] = STATE(868),
    [sym_bytearray] = STATE(868),
    [sym_verbatim_bytearray] = STATE(868),
    [sym_format_triple_quoted_string] = STATE(870),
    [sym_triple_quoted_string] = STATE(868),
    [sym_const] = STATE(867),
    [sym_long_identifier] = STATE(872),
    [sym_active_pattern] = STATE(871),
    [sym__identifier_or_op] = STATE(873),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(656),
    [sym_infix_op] = STATE(581),
    [sym_sbyte] = STATE(868),
    [sym_byte] = STATE(868),
    [sym_int16] = STATE(868),
    [sym_uint16] = STATE(868),
    [sym_int32] = STATE(868),
    [sym_uint32] = STATE(868),
    [sym_nativeint] = STATE(868),
    [sym_unativeint] = STATE(868),
    [sym_int64] = STATE(868),
    [sym_uint64] = STATE(868),
    [sym_ieee32] = STATE(868),
    [sym_ieee64] = STATE(868),
    [sym_bignum] = STATE(868),
    [sym_decimal] = STATE(868),
    [sym_float] = STATE(1368),
    [sym_block_comment] = STATE(282),
    [sym_compiler_directive_decl] = STATE(282),
    [sym_fsi_directive_decl] = STATE(282),
    [sym_preproc_line] = STATE(282),
    [sym_preproc_if_in_expression] = STATE(867),
    [aux_sym_sequential_expression_repeat1] = STATE(1542),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(29),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(825),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_COMMA] = ACTIONS(827),
    [anon_sym_null] = ACTIONS(49),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACK_PIPE] = ACTIONS(57),
    [anon_sym_LBRACE] = ACTIONS(139),
    [anon_sym_LT_AT] = ACTIONS(61),
    [anon_sym_LT_AT_AT] = ACTIONS(63),
    [anon_sym_DOT] = ACTIONS(65),
    [anon_sym_LBRACE_PIPE] = ACTIONS(67),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_return_BANG] = ACTIONS(829),
    [anon_sym_yield] = ACTIONS(825),
    [anon_sym_yield_BANG] = ACTIONS(829),
    [anon_sym_lazy] = ACTIONS(825),
    [anon_sym_assert] = ACTIONS(825),
    [anon_sym_upcast] = ACTIONS(825),
    [anon_sym_downcast] = ACTIONS(825),
    [anon_sym_COLON_GT] = ACTIONS(71),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(71),
    [anon_sym_for] = ACTIONS(73),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(79),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_match] = ACTIONS(83),
    [anon_sym_match_BANG] = ACTIONS(85),
    [anon_sym_function] = ACTIONS(87),
    [anon_sym_LT_DASH] = ACTIONS(831),
    [anon_sym_DOT_LBRACK] = ACTIONS(91),
    [anon_sym_LT] = ACTIONS(93),
    [anon_sym_use] = ACTIONS(833),
    [anon_sym_use_BANG] = ACTIONS(835),
    [anon_sym_do_BANG] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(101),
    [anon_sym_LPAREN2] = ACTIONS(103),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(105),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(107),
    [anon_sym_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DQUOTE] = ACTIONS(111),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(115),
    [sym_bool] = ACTIONS(117),
    [sym_unit] = ACTIONS(119),
    [anon_sym_LPAREN_PIPE] = ACTIONS(121),
    [sym_op_identifier] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(837),
    [sym_xint] = ACTIONS(387),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(135),
    [sym__newline] = ACTIONS(839),
    [sym__dedent] = ACTIONS(1547),
  },
  [283] = {
    [sym_function_or_value_defn] = STATE(509),
    [sym__expression] = STATE(326),
    [sym_literal_expression] = STATE(2230),
    [sym_long_identifier_or_op] = STATE(2230),
    [sym_tuple_expression] = STATE(2230),
    [sym_brace_expression] = STATE(2230),
    [sym_anon_record_expression] = STATE(2230),
    [sym_prefixed_expression] = STATE(2230),
    [sym_typecast_expression] = STATE(2230),
    [sym_for_expression] = STATE(2230),
    [sym_while_expression] = STATE(2230),
    [sym__if_branch] = STATE(6659),
    [sym_if_expression] = STATE(2230),
    [sym_fun_expression] = STATE(2230),
    [sym_try_expression] = STATE(2230),
    [sym_match_expression] = STATE(2230),
    [sym_function_expression] = STATE(2230),
    [sym_mutate_expression] = STATE(2230),
    [sym_index_expression] = STATE(2230),
    [sym_typed_expression] = STATE(2230),
    [sym_declaration_expression] = STATE(2230),
    [sym_do_expression] = STATE(2230),
    [sym_list_expression] = STATE(2230),
    [sym_array_expression] = STATE(2230),
    [sym_begin_end_expression] = STATE(2230),
    [sym_paren_expression] = STATE(2230),
    [sym__high_prec_app] = STATE(2229),
    [sym__low_prec_app] = STATE(2229),
    [sym_application_expression] = STATE(2230),
    [sym_dot_expression] = STATE(2230),
    [sym_infix_expression] = STATE(2230),
    [sym_ce_expression] = STATE(2230),
    [sym_sequential_expression] = STATE(2230),
    [sym_char] = STATE(2100),
    [sym_format_string] = STATE(2106),
    [sym__string_literal] = STATE(2106),
    [sym_string] = STATE(2100),
    [sym_verbatim_string] = STATE(2100),
    [sym_bytearray] = STATE(2100),
    [sym_verbatim_bytearray] = STATE(2100),
    [sym_format_triple_quoted_string] = STATE(2107),
    [sym_triple_quoted_string] = STATE(2100),
    [sym_const] = STATE(2230),
    [sym_long_identifier] = STATE(2232),
    [sym_active_pattern] = STATE(2424),
    [sym__identifier_or_op] = STATE(2305),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(737),
    [sym_infix_op] = STATE(694),
    [sym_sbyte] = STATE(2100),
    [sym_byte] = STATE(2100),
    [sym_int16] = STATE(2100),
    [sym_uint16] = STATE(2100),
    [sym_int32] = STATE(2100),
    [sym_uint32] = STATE(2100),
    [sym_nativeint] = STATE(2100),
    [sym_unativeint] = STATE(2100),
    [sym_int64] = STATE(2100),
    [sym_uint64] = STATE(2100),
    [sym_ieee32] = STATE(2100),
    [sym_ieee64] = STATE(2100),
    [sym_bignum] = STATE(2100),
    [sym_decimal] = STATE(2100),
    [sym_float] = STATE(1487),
    [sym_block_comment] = STATE(283),
    [sym_compiler_directive_decl] = STATE(283),
    [sym_fsi_directive_decl] = STATE(283),
    [sym_preproc_line] = STATE(283),
    [sym_preproc_if_in_expression] = STATE(2230),
    [aux_sym_sequential_expression_repeat1] = STATE(1743),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(877),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(879),
    [anon_sym_return] = ACTIONS(881),
    [anon_sym_do] = ACTIONS(1549),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(885),
    [anon_sym_COMMA] = ACTIONS(887),
    [anon_sym_null] = ACTIONS(889),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(879),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(891),
    [anon_sym_LBRACK_PIPE] = ACTIONS(893),
    [anon_sym_LBRACE] = ACTIONS(895),
    [anon_sym_LT_AT] = ACTIONS(897),
    [anon_sym_LT_AT_AT] = ACTIONS(899),
    [anon_sym_DOT] = ACTIONS(901),
    [anon_sym_LBRACE_PIPE] = ACTIONS(903),
    [anon_sym_new] = ACTIONS(881),
    [anon_sym_return_BANG] = ACTIONS(905),
    [anon_sym_yield] = ACTIONS(881),
    [anon_sym_yield_BANG] = ACTIONS(905),
    [anon_sym_lazy] = ACTIONS(881),
    [anon_sym_assert] = ACTIONS(881),
    [anon_sym_upcast] = ACTIONS(881),
    [anon_sym_downcast] = ACTIONS(881),
    [anon_sym_COLON_GT] = ACTIONS(907),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(907),
    [anon_sym_for] = ACTIONS(909),
    [anon_sym_while] = ACTIONS(911),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(913),
    [anon_sym_try] = ACTIONS(915),
    [anon_sym_match] = ACTIONS(917),
    [anon_sym_match_BANG] = ACTIONS(919),
    [anon_sym_function] = ACTIONS(921),
    [anon_sym_LT_DASH] = ACTIONS(923),
    [anon_sym_DOT_LBRACK] = ACTIONS(925),
    [anon_sym_LT] = ACTIONS(927),
    [anon_sym_use] = ACTIONS(929),
    [anon_sym_use_BANG] = ACTIONS(931),
    [anon_sym_do_BANG] = ACTIONS(933),
    [anon_sym_DOT_DOT] = ACTIONS(935),
    [anon_sym_begin] = ACTIONS(937),
    [anon_sym_LPAREN2] = ACTIONS(939),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(941),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(943),
    [anon_sym_DQUOTE] = ACTIONS(945),
    [anon_sym_AT_DQUOTE] = ACTIONS(947),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(949),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(951),
    [sym_bool] = ACTIONS(953),
    [sym_unit] = ACTIONS(955),
    [anon_sym_LPAREN_PIPE] = ACTIONS(957),
    [sym_op_identifier] = ACTIONS(959),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(961),
    [sym_xint] = ACTIONS(963),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(965),
    [sym__newline] = ACTIONS(967),
  },
  [284] = {
    [sym_function_or_value_defn] = STATE(733),
    [sym__expression] = STATE(142),
    [sym_literal_expression] = STATE(2008),
    [sym_long_identifier_or_op] = STATE(2008),
    [sym_tuple_expression] = STATE(2008),
    [sym_brace_expression] = STATE(2008),
    [sym_anon_record_expression] = STATE(2008),
    [sym_prefixed_expression] = STATE(2008),
    [sym_typecast_expression] = STATE(2008),
    [sym_for_expression] = STATE(2008),
    [sym_while_expression] = STATE(2008),
    [sym__if_branch] = STATE(6754),
    [sym_if_expression] = STATE(2008),
    [sym_fun_expression] = STATE(2008),
    [sym_try_expression] = STATE(2008),
    [sym_match_expression] = STATE(2008),
    [sym_function_expression] = STATE(2008),
    [sym_mutate_expression] = STATE(2008),
    [sym_index_expression] = STATE(2008),
    [sym_typed_expression] = STATE(2008),
    [sym_declaration_expression] = STATE(2008),
    [sym_do_expression] = STATE(2008),
    [sym_list_expression] = STATE(2008),
    [sym_array_expression] = STATE(2008),
    [sym_begin_end_expression] = STATE(2008),
    [sym_paren_expression] = STATE(2008),
    [sym__high_prec_app] = STATE(2007),
    [sym__low_prec_app] = STATE(2007),
    [sym_application_expression] = STATE(2008),
    [sym_dot_expression] = STATE(2008),
    [sym_infix_expression] = STATE(2008),
    [sym_ce_expression] = STATE(2008),
    [sym_sequential_expression] = STATE(2008),
    [sym_char] = STATE(1859),
    [sym_format_string] = STATE(1861),
    [sym__string_literal] = STATE(1861),
    [sym_string] = STATE(1859),
    [sym_verbatim_string] = STATE(1859),
    [sym_bytearray] = STATE(1859),
    [sym_verbatim_bytearray] = STATE(1859),
    [sym_format_triple_quoted_string] = STATE(1862),
    [sym_triple_quoted_string] = STATE(1859),
    [sym_const] = STATE(2008),
    [sym_long_identifier] = STATE(1701),
    [sym_active_pattern] = STATE(1702),
    [sym__identifier_or_op] = STATE(1724),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(706),
    [sym_infix_op] = STATE(678),
    [sym_sbyte] = STATE(1859),
    [sym_byte] = STATE(1859),
    [sym_int16] = STATE(1859),
    [sym_uint16] = STATE(1859),
    [sym_int32] = STATE(1859),
    [sym_uint32] = STATE(1859),
    [sym_nativeint] = STATE(1859),
    [sym_unativeint] = STATE(1859),
    [sym_int64] = STATE(1859),
    [sym_uint64] = STATE(1859),
    [sym_ieee32] = STATE(1859),
    [sym_ieee64] = STATE(1859),
    [sym_bignum] = STATE(1859),
    [sym_decimal] = STATE(1859),
    [sym_float] = STATE(1447),
    [sym_block_comment] = STATE(284),
    [sym_compiler_directive_decl] = STATE(284),
    [sym_fsi_directive_decl] = STATE(284),
    [sym_preproc_line] = STATE(284),
    [sym_preproc_if_in_expression] = STATE(2008),
    [aux_sym_sequential_expression_repeat1] = STATE(1995),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(503),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(969),
    [anon_sym_return] = ACTIONS(971),
    [anon_sym_do] = ACTIONS(599),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(511),
    [anon_sym_COMMA] = ACTIONS(973),
    [anon_sym_null] = ACTIONS(515),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(969),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(517),
    [anon_sym_LBRACK_PIPE] = ACTIONS(519),
    [anon_sym_LBRACE] = ACTIONS(521),
    [anon_sym_LT_AT] = ACTIONS(523),
    [anon_sym_LT_AT_AT] = ACTIONS(525),
    [anon_sym_DOT] = ACTIONS(527),
    [anon_sym_LBRACE_PIPE] = ACTIONS(529),
    [anon_sym_new] = ACTIONS(971),
    [anon_sym_return_BANG] = ACTIONS(975),
    [anon_sym_yield] = ACTIONS(971),
    [anon_sym_yield_BANG] = ACTIONS(975),
    [anon_sym_lazy] = ACTIONS(971),
    [anon_sym_assert] = ACTIONS(971),
    [anon_sym_upcast] = ACTIONS(971),
    [anon_sym_downcast] = ACTIONS(971),
    [anon_sym_COLON_GT] = ACTIONS(977),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(977),
    [anon_sym_for] = ACTIONS(979),
    [anon_sym_while] = ACTIONS(537),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(539),
    [anon_sym_DASH_GT] = ACTIONS(1551),
    [anon_sym_try] = ACTIONS(543),
    [anon_sym_match] = ACTIONS(545),
    [anon_sym_match_BANG] = ACTIONS(547),
    [anon_sym_function] = ACTIONS(549),
    [anon_sym_LT_DASH] = ACTIONS(981),
    [anon_sym_DOT_LBRACK] = ACTIONS(553),
    [anon_sym_LT] = ACTIONS(555),
    [anon_sym_use] = ACTIONS(983),
    [anon_sym_use_BANG] = ACTIONS(985),
    [anon_sym_do_BANG] = ACTIONS(561),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_LPAREN2] = ACTIONS(567),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(569),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(571),
    [anon_sym_DQUOTE] = ACTIONS(573),
    [anon_sym_AT_DQUOTE] = ACTIONS(575),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(577),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(579),
    [sym_bool] = ACTIONS(581),
    [sym_unit] = ACTIONS(583),
    [anon_sym_LPAREN_PIPE] = ACTIONS(585),
    [sym_op_identifier] = ACTIONS(587),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(591),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(593),
    [sym__newline] = ACTIONS(1171),
  },
  [285] = {
    [sym_function_or_value_defn] = STATE(600),
    [sym__expression] = STATE(88),
    [sym_literal_expression] = STATE(867),
    [sym_long_identifier_or_op] = STATE(867),
    [sym_tuple_expression] = STATE(867),
    [sym_brace_expression] = STATE(867),
    [sym_anon_record_expression] = STATE(867),
    [sym_prefixed_expression] = STATE(867),
    [sym_typecast_expression] = STATE(867),
    [sym_for_expression] = STATE(867),
    [sym_while_expression] = STATE(867),
    [sym__if_branch] = STATE(6511),
    [sym_if_expression] = STATE(867),
    [sym_fun_expression] = STATE(867),
    [sym_try_expression] = STATE(867),
    [sym_match_expression] = STATE(867),
    [sym_function_expression] = STATE(867),
    [sym_mutate_expression] = STATE(867),
    [sym_index_expression] = STATE(867),
    [sym_typed_expression] = STATE(867),
    [sym_declaration_expression] = STATE(867),
    [sym_do_expression] = STATE(867),
    [sym_list_expression] = STATE(867),
    [sym_array_expression] = STATE(867),
    [sym_begin_end_expression] = STATE(867),
    [sym_paren_expression] = STATE(867),
    [sym__high_prec_app] = STATE(864),
    [sym__low_prec_app] = STATE(864),
    [sym_application_expression] = STATE(867),
    [sym_dot_expression] = STATE(867),
    [sym_infix_expression] = STATE(867),
    [sym_ce_expression] = STATE(867),
    [sym_sequential_expression] = STATE(867),
    [sym_char] = STATE(868),
    [sym_format_string] = STATE(869),
    [sym__string_literal] = STATE(869),
    [sym_string] = STATE(868),
    [sym_verbatim_string] = STATE(868),
    [sym_bytearray] = STATE(868),
    [sym_verbatim_bytearray] = STATE(868),
    [sym_format_triple_quoted_string] = STATE(870),
    [sym_triple_quoted_string] = STATE(868),
    [sym_const] = STATE(867),
    [sym_long_identifier] = STATE(872),
    [sym_active_pattern] = STATE(871),
    [sym__identifier_or_op] = STATE(873),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(656),
    [sym_infix_op] = STATE(581),
    [sym_sbyte] = STATE(868),
    [sym_byte] = STATE(868),
    [sym_int16] = STATE(868),
    [sym_uint16] = STATE(868),
    [sym_int32] = STATE(868),
    [sym_uint32] = STATE(868),
    [sym_nativeint] = STATE(868),
    [sym_unativeint] = STATE(868),
    [sym_int64] = STATE(868),
    [sym_uint64] = STATE(868),
    [sym_ieee32] = STATE(868),
    [sym_ieee64] = STATE(868),
    [sym_bignum] = STATE(868),
    [sym_decimal] = STATE(868),
    [sym_float] = STATE(1368),
    [sym_block_comment] = STATE(285),
    [sym_compiler_directive_decl] = STATE(285),
    [sym_fsi_directive_decl] = STATE(285),
    [sym_preproc_line] = STATE(285),
    [sym_preproc_if_in_expression] = STATE(867),
    [aux_sym_sequential_expression_repeat1] = STATE(1542),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(29),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(825),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_COMMA] = ACTIONS(827),
    [anon_sym_null] = ACTIONS(49),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACK_PIPE] = ACTIONS(57),
    [anon_sym_LBRACE] = ACTIONS(139),
    [anon_sym_LT_AT] = ACTIONS(61),
    [anon_sym_LT_AT_AT] = ACTIONS(63),
    [anon_sym_DOT] = ACTIONS(65),
    [anon_sym_LBRACE_PIPE] = ACTIONS(67),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_return_BANG] = ACTIONS(829),
    [anon_sym_yield] = ACTIONS(825),
    [anon_sym_yield_BANG] = ACTIONS(829),
    [anon_sym_lazy] = ACTIONS(825),
    [anon_sym_assert] = ACTIONS(825),
    [anon_sym_upcast] = ACTIONS(825),
    [anon_sym_downcast] = ACTIONS(825),
    [anon_sym_COLON_GT] = ACTIONS(71),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(71),
    [anon_sym_for] = ACTIONS(73),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(79),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_match] = ACTIONS(83),
    [anon_sym_match_BANG] = ACTIONS(85),
    [anon_sym_function] = ACTIONS(87),
    [anon_sym_LT_DASH] = ACTIONS(831),
    [anon_sym_DOT_LBRACK] = ACTIONS(91),
    [anon_sym_LT] = ACTIONS(93),
    [anon_sym_use] = ACTIONS(833),
    [anon_sym_use_BANG] = ACTIONS(835),
    [anon_sym_do_BANG] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(101),
    [anon_sym_LPAREN2] = ACTIONS(103),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(105),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(107),
    [anon_sym_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DQUOTE] = ACTIONS(111),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(115),
    [sym_bool] = ACTIONS(117),
    [sym_unit] = ACTIONS(119),
    [anon_sym_LPAREN_PIPE] = ACTIONS(121),
    [sym_op_identifier] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(837),
    [sym_xint] = ACTIONS(387),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(135),
    [sym__newline] = ACTIONS(839),
    [sym__dedent] = ACTIONS(1553),
  },
  [286] = {
    [sym_function_or_value_defn] = STATE(509),
    [sym__expression] = STATE(326),
    [sym_literal_expression] = STATE(2230),
    [sym_long_identifier_or_op] = STATE(2230),
    [sym_tuple_expression] = STATE(2230),
    [sym_brace_expression] = STATE(2230),
    [sym_anon_record_expression] = STATE(2230),
    [sym_prefixed_expression] = STATE(2230),
    [sym_typecast_expression] = STATE(2230),
    [sym_for_expression] = STATE(2230),
    [sym_while_expression] = STATE(2230),
    [sym__if_branch] = STATE(6659),
    [sym_if_expression] = STATE(2230),
    [sym_fun_expression] = STATE(2230),
    [sym_try_expression] = STATE(2230),
    [sym_match_expression] = STATE(2230),
    [sym_function_expression] = STATE(2230),
    [sym_mutate_expression] = STATE(2230),
    [sym_index_expression] = STATE(2230),
    [sym_typed_expression] = STATE(2230),
    [sym_declaration_expression] = STATE(2230),
    [sym_do_expression] = STATE(2230),
    [sym_list_expression] = STATE(2230),
    [sym_array_expression] = STATE(2230),
    [sym_begin_end_expression] = STATE(2230),
    [sym_paren_expression] = STATE(2230),
    [sym__high_prec_app] = STATE(2229),
    [sym__low_prec_app] = STATE(2229),
    [sym_application_expression] = STATE(2230),
    [sym_dot_expression] = STATE(2230),
    [sym_infix_expression] = STATE(2230),
    [sym_ce_expression] = STATE(2230),
    [sym_sequential_expression] = STATE(2230),
    [sym_char] = STATE(2100),
    [sym_format_string] = STATE(2106),
    [sym__string_literal] = STATE(2106),
    [sym_string] = STATE(2100),
    [sym_verbatim_string] = STATE(2100),
    [sym_bytearray] = STATE(2100),
    [sym_verbatim_bytearray] = STATE(2100),
    [sym_format_triple_quoted_string] = STATE(2107),
    [sym_triple_quoted_string] = STATE(2100),
    [sym_const] = STATE(2230),
    [sym_long_identifier] = STATE(2232),
    [sym_active_pattern] = STATE(2424),
    [sym__identifier_or_op] = STATE(2305),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(737),
    [sym_infix_op] = STATE(694),
    [sym_sbyte] = STATE(2100),
    [sym_byte] = STATE(2100),
    [sym_int16] = STATE(2100),
    [sym_uint16] = STATE(2100),
    [sym_int32] = STATE(2100),
    [sym_uint32] = STATE(2100),
    [sym_nativeint] = STATE(2100),
    [sym_unativeint] = STATE(2100),
    [sym_int64] = STATE(2100),
    [sym_uint64] = STATE(2100),
    [sym_ieee32] = STATE(2100),
    [sym_ieee64] = STATE(2100),
    [sym_bignum] = STATE(2100),
    [sym_decimal] = STATE(2100),
    [sym_float] = STATE(1487),
    [sym_block_comment] = STATE(286),
    [sym_compiler_directive_decl] = STATE(286),
    [sym_fsi_directive_decl] = STATE(286),
    [sym_preproc_line] = STATE(286),
    [sym_preproc_if_in_expression] = STATE(2230),
    [aux_sym_sequential_expression_repeat1] = STATE(1743),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(877),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(879),
    [anon_sym_return] = ACTIONS(881),
    [anon_sym_do] = ACTIONS(1555),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(885),
    [anon_sym_COMMA] = ACTIONS(887),
    [anon_sym_null] = ACTIONS(889),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(879),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(891),
    [anon_sym_LBRACK_PIPE] = ACTIONS(893),
    [anon_sym_LBRACE] = ACTIONS(895),
    [anon_sym_LT_AT] = ACTIONS(897),
    [anon_sym_LT_AT_AT] = ACTIONS(899),
    [anon_sym_DOT] = ACTIONS(901),
    [anon_sym_LBRACE_PIPE] = ACTIONS(903),
    [anon_sym_new] = ACTIONS(881),
    [anon_sym_return_BANG] = ACTIONS(905),
    [anon_sym_yield] = ACTIONS(881),
    [anon_sym_yield_BANG] = ACTIONS(905),
    [anon_sym_lazy] = ACTIONS(881),
    [anon_sym_assert] = ACTIONS(881),
    [anon_sym_upcast] = ACTIONS(881),
    [anon_sym_downcast] = ACTIONS(881),
    [anon_sym_COLON_GT] = ACTIONS(907),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(907),
    [anon_sym_for] = ACTIONS(909),
    [anon_sym_while] = ACTIONS(911),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(913),
    [anon_sym_try] = ACTIONS(915),
    [anon_sym_match] = ACTIONS(917),
    [anon_sym_match_BANG] = ACTIONS(919),
    [anon_sym_function] = ACTIONS(921),
    [anon_sym_LT_DASH] = ACTIONS(923),
    [anon_sym_DOT_LBRACK] = ACTIONS(925),
    [anon_sym_LT] = ACTIONS(927),
    [anon_sym_use] = ACTIONS(929),
    [anon_sym_use_BANG] = ACTIONS(931),
    [anon_sym_do_BANG] = ACTIONS(933),
    [anon_sym_DOT_DOT] = ACTIONS(935),
    [anon_sym_begin] = ACTIONS(937),
    [anon_sym_LPAREN2] = ACTIONS(939),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(941),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(943),
    [anon_sym_DQUOTE] = ACTIONS(945),
    [anon_sym_AT_DQUOTE] = ACTIONS(947),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(949),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(951),
    [sym_bool] = ACTIONS(953),
    [sym_unit] = ACTIONS(955),
    [anon_sym_LPAREN_PIPE] = ACTIONS(957),
    [sym_op_identifier] = ACTIONS(959),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(961),
    [sym_xint] = ACTIONS(963),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(965),
    [sym__newline] = ACTIONS(967),
  },
  [287] = {
    [sym_function_or_value_defn] = STATE(733),
    [sym__expression] = STATE(142),
    [sym_literal_expression] = STATE(2008),
    [sym_long_identifier_or_op] = STATE(2008),
    [sym_tuple_expression] = STATE(2008),
    [sym_brace_expression] = STATE(2008),
    [sym_anon_record_expression] = STATE(2008),
    [sym_prefixed_expression] = STATE(2008),
    [sym_typecast_expression] = STATE(2008),
    [sym_for_expression] = STATE(2008),
    [sym_while_expression] = STATE(2008),
    [sym__if_branch] = STATE(6754),
    [sym_if_expression] = STATE(2008),
    [sym_fun_expression] = STATE(2008),
    [sym_try_expression] = STATE(2008),
    [sym_match_expression] = STATE(2008),
    [sym_function_expression] = STATE(2008),
    [sym_mutate_expression] = STATE(2008),
    [sym_index_expression] = STATE(2008),
    [sym_typed_expression] = STATE(2008),
    [sym_declaration_expression] = STATE(2008),
    [sym_do_expression] = STATE(2008),
    [sym_list_expression] = STATE(2008),
    [sym_array_expression] = STATE(2008),
    [sym_begin_end_expression] = STATE(2008),
    [sym_paren_expression] = STATE(2008),
    [sym__high_prec_app] = STATE(2007),
    [sym__low_prec_app] = STATE(2007),
    [sym_application_expression] = STATE(2008),
    [sym_dot_expression] = STATE(2008),
    [sym_infix_expression] = STATE(2008),
    [sym_ce_expression] = STATE(2008),
    [sym_sequential_expression] = STATE(2008),
    [sym_char] = STATE(1859),
    [sym_format_string] = STATE(1861),
    [sym__string_literal] = STATE(1861),
    [sym_string] = STATE(1859),
    [sym_verbatim_string] = STATE(1859),
    [sym_bytearray] = STATE(1859),
    [sym_verbatim_bytearray] = STATE(1859),
    [sym_format_triple_quoted_string] = STATE(1862),
    [sym_triple_quoted_string] = STATE(1859),
    [sym_const] = STATE(2008),
    [sym_long_identifier] = STATE(1701),
    [sym_active_pattern] = STATE(1702),
    [sym__identifier_or_op] = STATE(1724),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(706),
    [sym_infix_op] = STATE(678),
    [sym_sbyte] = STATE(1859),
    [sym_byte] = STATE(1859),
    [sym_int16] = STATE(1859),
    [sym_uint16] = STATE(1859),
    [sym_int32] = STATE(1859),
    [sym_uint32] = STATE(1859),
    [sym_nativeint] = STATE(1859),
    [sym_unativeint] = STATE(1859),
    [sym_int64] = STATE(1859),
    [sym_uint64] = STATE(1859),
    [sym_ieee32] = STATE(1859),
    [sym_ieee64] = STATE(1859),
    [sym_bignum] = STATE(1859),
    [sym_decimal] = STATE(1859),
    [sym_float] = STATE(1447),
    [sym_block_comment] = STATE(287),
    [sym_compiler_directive_decl] = STATE(287),
    [sym_fsi_directive_decl] = STATE(287),
    [sym_preproc_line] = STATE(287),
    [sym_preproc_if_in_expression] = STATE(2008),
    [aux_sym_sequential_expression_repeat1] = STATE(1995),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(503),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(969),
    [anon_sym_return] = ACTIONS(971),
    [anon_sym_do] = ACTIONS(599),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(511),
    [anon_sym_COMMA] = ACTIONS(973),
    [anon_sym_null] = ACTIONS(515),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(969),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(517),
    [anon_sym_LBRACK_PIPE] = ACTIONS(519),
    [anon_sym_LBRACE] = ACTIONS(521),
    [anon_sym_LT_AT] = ACTIONS(523),
    [anon_sym_LT_AT_AT] = ACTIONS(525),
    [anon_sym_DOT] = ACTIONS(527),
    [anon_sym_LBRACE_PIPE] = ACTIONS(529),
    [anon_sym_new] = ACTIONS(971),
    [anon_sym_return_BANG] = ACTIONS(975),
    [anon_sym_yield] = ACTIONS(971),
    [anon_sym_yield_BANG] = ACTIONS(975),
    [anon_sym_lazy] = ACTIONS(971),
    [anon_sym_assert] = ACTIONS(971),
    [anon_sym_upcast] = ACTIONS(971),
    [anon_sym_downcast] = ACTIONS(971),
    [anon_sym_COLON_GT] = ACTIONS(977),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(977),
    [anon_sym_for] = ACTIONS(979),
    [anon_sym_while] = ACTIONS(537),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(539),
    [anon_sym_DASH_GT] = ACTIONS(1557),
    [anon_sym_try] = ACTIONS(543),
    [anon_sym_match] = ACTIONS(545),
    [anon_sym_match_BANG] = ACTIONS(547),
    [anon_sym_function] = ACTIONS(549),
    [anon_sym_LT_DASH] = ACTIONS(981),
    [anon_sym_DOT_LBRACK] = ACTIONS(553),
    [anon_sym_LT] = ACTIONS(555),
    [anon_sym_use] = ACTIONS(983),
    [anon_sym_use_BANG] = ACTIONS(985),
    [anon_sym_do_BANG] = ACTIONS(561),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_LPAREN2] = ACTIONS(567),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(569),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(571),
    [anon_sym_DQUOTE] = ACTIONS(573),
    [anon_sym_AT_DQUOTE] = ACTIONS(575),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(577),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(579),
    [sym_bool] = ACTIONS(581),
    [sym_unit] = ACTIONS(583),
    [anon_sym_LPAREN_PIPE] = ACTIONS(585),
    [sym_op_identifier] = ACTIONS(587),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(591),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(593),
    [sym__newline] = ACTIONS(1171),
  },
  [288] = {
    [sym_function_or_value_defn] = STATE(509),
    [sym__expression] = STATE(326),
    [sym_literal_expression] = STATE(2230),
    [sym_long_identifier_or_op] = STATE(2230),
    [sym_tuple_expression] = STATE(2230),
    [sym_brace_expression] = STATE(2230),
    [sym_anon_record_expression] = STATE(2230),
    [sym_prefixed_expression] = STATE(2230),
    [sym_typecast_expression] = STATE(2230),
    [sym_for_expression] = STATE(2230),
    [sym_while_expression] = STATE(2230),
    [sym__if_branch] = STATE(6659),
    [sym_if_expression] = STATE(2230),
    [sym_fun_expression] = STATE(2230),
    [sym_try_expression] = STATE(2230),
    [sym_match_expression] = STATE(2230),
    [sym_function_expression] = STATE(2230),
    [sym_mutate_expression] = STATE(2230),
    [sym_index_expression] = STATE(2230),
    [sym_typed_expression] = STATE(2230),
    [sym_declaration_expression] = STATE(2230),
    [sym_do_expression] = STATE(2230),
    [sym_list_expression] = STATE(2230),
    [sym_array_expression] = STATE(2230),
    [sym_begin_end_expression] = STATE(2230),
    [sym_paren_expression] = STATE(2230),
    [sym__high_prec_app] = STATE(2229),
    [sym__low_prec_app] = STATE(2229),
    [sym_application_expression] = STATE(2230),
    [sym_dot_expression] = STATE(2230),
    [sym_infix_expression] = STATE(2230),
    [sym_ce_expression] = STATE(2230),
    [sym_sequential_expression] = STATE(2230),
    [sym_char] = STATE(2100),
    [sym_format_string] = STATE(2106),
    [sym__string_literal] = STATE(2106),
    [sym_string] = STATE(2100),
    [sym_verbatim_string] = STATE(2100),
    [sym_bytearray] = STATE(2100),
    [sym_verbatim_bytearray] = STATE(2100),
    [sym_format_triple_quoted_string] = STATE(2107),
    [sym_triple_quoted_string] = STATE(2100),
    [sym_const] = STATE(2230),
    [sym_long_identifier] = STATE(2232),
    [sym_active_pattern] = STATE(2424),
    [sym__identifier_or_op] = STATE(2305),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(737),
    [sym_infix_op] = STATE(694),
    [sym_sbyte] = STATE(2100),
    [sym_byte] = STATE(2100),
    [sym_int16] = STATE(2100),
    [sym_uint16] = STATE(2100),
    [sym_int32] = STATE(2100),
    [sym_uint32] = STATE(2100),
    [sym_nativeint] = STATE(2100),
    [sym_unativeint] = STATE(2100),
    [sym_int64] = STATE(2100),
    [sym_uint64] = STATE(2100),
    [sym_ieee32] = STATE(2100),
    [sym_ieee64] = STATE(2100),
    [sym_bignum] = STATE(2100),
    [sym_decimal] = STATE(2100),
    [sym_float] = STATE(1487),
    [sym_block_comment] = STATE(288),
    [sym_compiler_directive_decl] = STATE(288),
    [sym_fsi_directive_decl] = STATE(288),
    [sym_preproc_line] = STATE(288),
    [sym_preproc_if_in_expression] = STATE(2230),
    [aux_sym_sequential_expression_repeat1] = STATE(1743),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(877),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(879),
    [anon_sym_return] = ACTIONS(881),
    [anon_sym_do] = ACTIONS(1559),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(885),
    [anon_sym_COMMA] = ACTIONS(887),
    [anon_sym_null] = ACTIONS(889),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(879),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(891),
    [anon_sym_LBRACK_PIPE] = ACTIONS(893),
    [anon_sym_LBRACE] = ACTIONS(895),
    [anon_sym_LT_AT] = ACTIONS(897),
    [anon_sym_LT_AT_AT] = ACTIONS(899),
    [anon_sym_DOT] = ACTIONS(901),
    [anon_sym_LBRACE_PIPE] = ACTIONS(903),
    [anon_sym_new] = ACTIONS(881),
    [anon_sym_return_BANG] = ACTIONS(905),
    [anon_sym_yield] = ACTIONS(881),
    [anon_sym_yield_BANG] = ACTIONS(905),
    [anon_sym_lazy] = ACTIONS(881),
    [anon_sym_assert] = ACTIONS(881),
    [anon_sym_upcast] = ACTIONS(881),
    [anon_sym_downcast] = ACTIONS(881),
    [anon_sym_COLON_GT] = ACTIONS(907),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(907),
    [anon_sym_for] = ACTIONS(909),
    [anon_sym_while] = ACTIONS(911),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(913),
    [anon_sym_try] = ACTIONS(915),
    [anon_sym_match] = ACTIONS(917),
    [anon_sym_match_BANG] = ACTIONS(919),
    [anon_sym_function] = ACTIONS(921),
    [anon_sym_LT_DASH] = ACTIONS(923),
    [anon_sym_DOT_LBRACK] = ACTIONS(925),
    [anon_sym_LT] = ACTIONS(927),
    [anon_sym_use] = ACTIONS(929),
    [anon_sym_use_BANG] = ACTIONS(931),
    [anon_sym_do_BANG] = ACTIONS(933),
    [anon_sym_DOT_DOT] = ACTIONS(935),
    [anon_sym_begin] = ACTIONS(937),
    [anon_sym_LPAREN2] = ACTIONS(939),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(941),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(943),
    [anon_sym_DQUOTE] = ACTIONS(945),
    [anon_sym_AT_DQUOTE] = ACTIONS(947),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(949),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(951),
    [sym_bool] = ACTIONS(953),
    [sym_unit] = ACTIONS(955),
    [anon_sym_LPAREN_PIPE] = ACTIONS(957),
    [sym_op_identifier] = ACTIONS(959),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(961),
    [sym_xint] = ACTIONS(963),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(965),
    [sym__newline] = ACTIONS(967),
  },
  [289] = {
    [sym_function_or_value_defn] = STATE(527),
    [sym__expression] = STATE(260),
    [sym_literal_expression] = STATE(2384),
    [sym_long_identifier_or_op] = STATE(2384),
    [sym_tuple_expression] = STATE(2384),
    [sym_brace_expression] = STATE(2384),
    [sym_anon_record_expression] = STATE(2384),
    [sym_prefixed_expression] = STATE(2384),
    [sym_typecast_expression] = STATE(2384),
    [sym_for_expression] = STATE(2384),
    [sym_while_expression] = STATE(2384),
    [sym__if_branch] = STATE(6561),
    [sym_if_expression] = STATE(2384),
    [sym_fun_expression] = STATE(2384),
    [sym_try_expression] = STATE(2384),
    [sym_match_expression] = STATE(2384),
    [sym_function_expression] = STATE(2384),
    [sym_mutate_expression] = STATE(2384),
    [sym_index_expression] = STATE(2384),
    [sym_typed_expression] = STATE(2384),
    [sym_declaration_expression] = STATE(2384),
    [sym_do_expression] = STATE(2384),
    [sym_list_expression] = STATE(2384),
    [sym_array_expression] = STATE(2384),
    [sym_begin_end_expression] = STATE(2384),
    [sym_paren_expression] = STATE(2384),
    [sym__high_prec_app] = STATE(2249),
    [sym__low_prec_app] = STATE(2249),
    [sym_application_expression] = STATE(2384),
    [sym_dot_expression] = STATE(2384),
    [sym_infix_expression] = STATE(2384),
    [sym_ce_expression] = STATE(2384),
    [sym_sequential_expression] = STATE(2384),
    [sym_char] = STATE(2144),
    [sym_format_string] = STATE(2142),
    [sym__string_literal] = STATE(2142),
    [sym_string] = STATE(2144),
    [sym_verbatim_string] = STATE(2144),
    [sym_bytearray] = STATE(2144),
    [sym_verbatim_bytearray] = STATE(2144),
    [sym_format_triple_quoted_string] = STATE(2141),
    [sym_triple_quoted_string] = STATE(2144),
    [sym_const] = STATE(2384),
    [sym_long_identifier] = STATE(2400),
    [sym_active_pattern] = STATE(2317),
    [sym__identifier_or_op] = STATE(2392),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(633),
    [sym_infix_op] = STATE(511),
    [sym_sbyte] = STATE(2144),
    [sym_byte] = STATE(2144),
    [sym_int16] = STATE(2144),
    [sym_uint16] = STATE(2144),
    [sym_int32] = STATE(2144),
    [sym_uint32] = STATE(2144),
    [sym_nativeint] = STATE(2144),
    [sym_unativeint] = STATE(2144),
    [sym_int64] = STATE(2144),
    [sym_uint64] = STATE(2144),
    [sym_ieee32] = STATE(2144),
    [sym_ieee64] = STATE(2144),
    [sym_bignum] = STATE(2144),
    [sym_decimal] = STATE(2144),
    [sym_float] = STATE(1672),
    [sym_block_comment] = STATE(289),
    [sym_compiler_directive_decl] = STATE(289),
    [sym_fsi_directive_decl] = STATE(289),
    [sym_preproc_line] = STATE(289),
    [sym_preproc_if_in_expression] = STATE(2384),
    [aux_sym_sequential_expression_repeat1] = STATE(1748),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(1439),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(1441),
    [anon_sym_return] = ACTIONS(1443),
    [anon_sym_do] = ACTIONS(1445),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(1447),
    [anon_sym_COMMA] = ACTIONS(1449),
    [anon_sym_null] = ACTIONS(1451),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(1441),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1453),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1455),
    [anon_sym_LBRACE] = ACTIONS(1457),
    [anon_sym_LT_AT] = ACTIONS(1459),
    [anon_sym_LT_AT_AT] = ACTIONS(1461),
    [anon_sym_DOT] = ACTIONS(1463),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1465),
    [anon_sym_new] = ACTIONS(1443),
    [anon_sym_return_BANG] = ACTIONS(1467),
    [anon_sym_yield] = ACTIONS(1443),
    [anon_sym_yield_BANG] = ACTIONS(1467),
    [anon_sym_lazy] = ACTIONS(1443),
    [anon_sym_assert] = ACTIONS(1443),
    [anon_sym_upcast] = ACTIONS(1443),
    [anon_sym_downcast] = ACTIONS(1443),
    [anon_sym_COLON_GT] = ACTIONS(1469),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1469),
    [anon_sym_for] = ACTIONS(1471),
    [anon_sym_while] = ACTIONS(1473),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(1475),
    [anon_sym_try] = ACTIONS(1477),
    [anon_sym_match] = ACTIONS(1479),
    [anon_sym_match_BANG] = ACTIONS(1481),
    [anon_sym_function] = ACTIONS(1483),
    [anon_sym_LT_DASH] = ACTIONS(1485),
    [anon_sym_DOT_LBRACK] = ACTIONS(1487),
    [anon_sym_LT] = ACTIONS(1489),
    [anon_sym_GT] = ACTIONS(1561),
    [anon_sym_use] = ACTIONS(1491),
    [anon_sym_use_BANG] = ACTIONS(1493),
    [anon_sym_do_BANG] = ACTIONS(1495),
    [anon_sym_begin] = ACTIONS(1497),
    [anon_sym_LPAREN2] = ACTIONS(1499),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(1501),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1503),
    [anon_sym_DQUOTE] = ACTIONS(1505),
    [anon_sym_AT_DQUOTE] = ACTIONS(1507),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1509),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1511),
    [sym_bool] = ACTIONS(1513),
    [sym_unit] = ACTIONS(1515),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1517),
    [sym_op_identifier] = ACTIONS(1519),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(1521),
    [sym_xint] = ACTIONS(1523),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1525),
    [sym__newline] = ACTIONS(1527),
  },
  [290] = {
    [sym_function_or_value_defn] = STATE(600),
    [sym__expression] = STATE(88),
    [sym_literal_expression] = STATE(867),
    [sym_long_identifier_or_op] = STATE(867),
    [sym_tuple_expression] = STATE(867),
    [sym_brace_expression] = STATE(867),
    [sym_anon_record_expression] = STATE(867),
    [sym_prefixed_expression] = STATE(867),
    [sym_typecast_expression] = STATE(867),
    [sym_for_expression] = STATE(867),
    [sym_while_expression] = STATE(867),
    [sym__if_branch] = STATE(6511),
    [sym_if_expression] = STATE(867),
    [sym_fun_expression] = STATE(867),
    [sym_try_expression] = STATE(867),
    [sym_match_expression] = STATE(867),
    [sym_function_expression] = STATE(867),
    [sym_mutate_expression] = STATE(867),
    [sym_index_expression] = STATE(867),
    [sym_typed_expression] = STATE(867),
    [sym_declaration_expression] = STATE(867),
    [sym_do_expression] = STATE(867),
    [sym_list_expression] = STATE(867),
    [sym_array_expression] = STATE(867),
    [sym_begin_end_expression] = STATE(867),
    [sym_paren_expression] = STATE(867),
    [sym__high_prec_app] = STATE(864),
    [sym__low_prec_app] = STATE(864),
    [sym_application_expression] = STATE(867),
    [sym_dot_expression] = STATE(867),
    [sym_infix_expression] = STATE(867),
    [sym_ce_expression] = STATE(867),
    [sym_sequential_expression] = STATE(867),
    [sym_char] = STATE(868),
    [sym_format_string] = STATE(869),
    [sym__string_literal] = STATE(869),
    [sym_string] = STATE(868),
    [sym_verbatim_string] = STATE(868),
    [sym_bytearray] = STATE(868),
    [sym_verbatim_bytearray] = STATE(868),
    [sym_format_triple_quoted_string] = STATE(870),
    [sym_triple_quoted_string] = STATE(868),
    [sym_const] = STATE(867),
    [sym_long_identifier] = STATE(872),
    [sym_active_pattern] = STATE(871),
    [sym__identifier_or_op] = STATE(873),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(656),
    [sym_infix_op] = STATE(581),
    [sym_sbyte] = STATE(868),
    [sym_byte] = STATE(868),
    [sym_int16] = STATE(868),
    [sym_uint16] = STATE(868),
    [sym_int32] = STATE(868),
    [sym_uint32] = STATE(868),
    [sym_nativeint] = STATE(868),
    [sym_unativeint] = STATE(868),
    [sym_int64] = STATE(868),
    [sym_uint64] = STATE(868),
    [sym_ieee32] = STATE(868),
    [sym_ieee64] = STATE(868),
    [sym_bignum] = STATE(868),
    [sym_decimal] = STATE(868),
    [sym_float] = STATE(1368),
    [sym_block_comment] = STATE(290),
    [sym_compiler_directive_decl] = STATE(290),
    [sym_fsi_directive_decl] = STATE(290),
    [sym_preproc_line] = STATE(290),
    [sym_preproc_if_in_expression] = STATE(867),
    [aux_sym_sequential_expression_repeat1] = STATE(1542),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(29),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(825),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_COMMA] = ACTIONS(827),
    [anon_sym_null] = ACTIONS(49),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACK_PIPE] = ACTIONS(57),
    [anon_sym_LBRACE] = ACTIONS(139),
    [anon_sym_LT_AT] = ACTIONS(61),
    [anon_sym_LT_AT_AT] = ACTIONS(63),
    [anon_sym_DOT] = ACTIONS(65),
    [anon_sym_LBRACE_PIPE] = ACTIONS(67),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_return_BANG] = ACTIONS(829),
    [anon_sym_yield] = ACTIONS(825),
    [anon_sym_yield_BANG] = ACTIONS(829),
    [anon_sym_lazy] = ACTIONS(825),
    [anon_sym_assert] = ACTIONS(825),
    [anon_sym_upcast] = ACTIONS(825),
    [anon_sym_downcast] = ACTIONS(825),
    [anon_sym_COLON_GT] = ACTIONS(71),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(71),
    [anon_sym_for] = ACTIONS(73),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(79),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_match] = ACTIONS(83),
    [anon_sym_match_BANG] = ACTIONS(85),
    [anon_sym_function] = ACTIONS(87),
    [anon_sym_LT_DASH] = ACTIONS(831),
    [anon_sym_DOT_LBRACK] = ACTIONS(91),
    [anon_sym_LT] = ACTIONS(93),
    [anon_sym_use] = ACTIONS(833),
    [anon_sym_use_BANG] = ACTIONS(835),
    [anon_sym_do_BANG] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(101),
    [anon_sym_LPAREN2] = ACTIONS(103),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(105),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(107),
    [anon_sym_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DQUOTE] = ACTIONS(111),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(115),
    [sym_bool] = ACTIONS(117),
    [sym_unit] = ACTIONS(119),
    [anon_sym_LPAREN_PIPE] = ACTIONS(121),
    [sym_op_identifier] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(837),
    [sym_xint] = ACTIONS(387),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(135),
    [sym__newline] = ACTIONS(839),
    [sym__dedent] = ACTIONS(1563),
  },
  [291] = {
    [sym_function_or_value_defn] = STATE(509),
    [sym__expression] = STATE(326),
    [sym_literal_expression] = STATE(2230),
    [sym_long_identifier_or_op] = STATE(2230),
    [sym_tuple_expression] = STATE(2230),
    [sym_brace_expression] = STATE(2230),
    [sym_anon_record_expression] = STATE(2230),
    [sym_prefixed_expression] = STATE(2230),
    [sym_typecast_expression] = STATE(2230),
    [sym_for_expression] = STATE(2230),
    [sym_while_expression] = STATE(2230),
    [sym__if_branch] = STATE(6659),
    [sym_if_expression] = STATE(2230),
    [sym_fun_expression] = STATE(2230),
    [sym_try_expression] = STATE(2230),
    [sym_match_expression] = STATE(2230),
    [sym_function_expression] = STATE(2230),
    [sym_mutate_expression] = STATE(2230),
    [sym_index_expression] = STATE(2230),
    [sym_typed_expression] = STATE(2230),
    [sym_declaration_expression] = STATE(2230),
    [sym_do_expression] = STATE(2230),
    [sym_list_expression] = STATE(2230),
    [sym_array_expression] = STATE(2230),
    [sym_begin_end_expression] = STATE(2230),
    [sym_paren_expression] = STATE(2230),
    [sym__high_prec_app] = STATE(2229),
    [sym__low_prec_app] = STATE(2229),
    [sym_application_expression] = STATE(2230),
    [sym_dot_expression] = STATE(2230),
    [sym_infix_expression] = STATE(2230),
    [sym_ce_expression] = STATE(2230),
    [sym_sequential_expression] = STATE(2230),
    [sym_char] = STATE(2100),
    [sym_format_string] = STATE(2106),
    [sym__string_literal] = STATE(2106),
    [sym_string] = STATE(2100),
    [sym_verbatim_string] = STATE(2100),
    [sym_bytearray] = STATE(2100),
    [sym_verbatim_bytearray] = STATE(2100),
    [sym_format_triple_quoted_string] = STATE(2107),
    [sym_triple_quoted_string] = STATE(2100),
    [sym_const] = STATE(2230),
    [sym_long_identifier] = STATE(2232),
    [sym_active_pattern] = STATE(2424),
    [sym__identifier_or_op] = STATE(2305),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(737),
    [sym_infix_op] = STATE(694),
    [sym_sbyte] = STATE(2100),
    [sym_byte] = STATE(2100),
    [sym_int16] = STATE(2100),
    [sym_uint16] = STATE(2100),
    [sym_int32] = STATE(2100),
    [sym_uint32] = STATE(2100),
    [sym_nativeint] = STATE(2100),
    [sym_unativeint] = STATE(2100),
    [sym_int64] = STATE(2100),
    [sym_uint64] = STATE(2100),
    [sym_ieee32] = STATE(2100),
    [sym_ieee64] = STATE(2100),
    [sym_bignum] = STATE(2100),
    [sym_decimal] = STATE(2100),
    [sym_float] = STATE(1487),
    [sym_block_comment] = STATE(291),
    [sym_compiler_directive_decl] = STATE(291),
    [sym_fsi_directive_decl] = STATE(291),
    [sym_preproc_line] = STATE(291),
    [sym_preproc_if_in_expression] = STATE(2230),
    [aux_sym_sequential_expression_repeat1] = STATE(1743),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(877),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(879),
    [anon_sym_return] = ACTIONS(881),
    [anon_sym_do] = ACTIONS(1565),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(885),
    [anon_sym_COMMA] = ACTIONS(887),
    [anon_sym_null] = ACTIONS(889),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(879),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(891),
    [anon_sym_LBRACK_PIPE] = ACTIONS(893),
    [anon_sym_LBRACE] = ACTIONS(895),
    [anon_sym_LT_AT] = ACTIONS(897),
    [anon_sym_LT_AT_AT] = ACTIONS(899),
    [anon_sym_DOT] = ACTIONS(901),
    [anon_sym_LBRACE_PIPE] = ACTIONS(903),
    [anon_sym_new] = ACTIONS(881),
    [anon_sym_return_BANG] = ACTIONS(905),
    [anon_sym_yield] = ACTIONS(881),
    [anon_sym_yield_BANG] = ACTIONS(905),
    [anon_sym_lazy] = ACTIONS(881),
    [anon_sym_assert] = ACTIONS(881),
    [anon_sym_upcast] = ACTIONS(881),
    [anon_sym_downcast] = ACTIONS(881),
    [anon_sym_COLON_GT] = ACTIONS(907),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(907),
    [anon_sym_for] = ACTIONS(909),
    [anon_sym_while] = ACTIONS(911),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(913),
    [anon_sym_try] = ACTIONS(915),
    [anon_sym_match] = ACTIONS(917),
    [anon_sym_match_BANG] = ACTIONS(919),
    [anon_sym_function] = ACTIONS(921),
    [anon_sym_LT_DASH] = ACTIONS(923),
    [anon_sym_DOT_LBRACK] = ACTIONS(925),
    [anon_sym_LT] = ACTIONS(927),
    [anon_sym_use] = ACTIONS(929),
    [anon_sym_use_BANG] = ACTIONS(931),
    [anon_sym_do_BANG] = ACTIONS(933),
    [anon_sym_DOT_DOT] = ACTIONS(935),
    [anon_sym_begin] = ACTIONS(937),
    [anon_sym_LPAREN2] = ACTIONS(939),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(941),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(943),
    [anon_sym_DQUOTE] = ACTIONS(945),
    [anon_sym_AT_DQUOTE] = ACTIONS(947),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(949),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(951),
    [sym_bool] = ACTIONS(953),
    [sym_unit] = ACTIONS(955),
    [anon_sym_LPAREN_PIPE] = ACTIONS(957),
    [sym_op_identifier] = ACTIONS(959),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(961),
    [sym_xint] = ACTIONS(963),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(965),
    [sym__newline] = ACTIONS(967),
  },
  [292] = {
    [sym_function_or_value_defn] = STATE(509),
    [sym__expression] = STATE(326),
    [sym_literal_expression] = STATE(2230),
    [sym_long_identifier_or_op] = STATE(2230),
    [sym_tuple_expression] = STATE(2230),
    [sym_brace_expression] = STATE(2230),
    [sym_anon_record_expression] = STATE(2230),
    [sym_prefixed_expression] = STATE(2230),
    [sym_typecast_expression] = STATE(2230),
    [sym_for_expression] = STATE(2230),
    [sym_while_expression] = STATE(2230),
    [sym__if_branch] = STATE(6659),
    [sym_if_expression] = STATE(2230),
    [sym_fun_expression] = STATE(2230),
    [sym_try_expression] = STATE(2230),
    [sym_match_expression] = STATE(2230),
    [sym_function_expression] = STATE(2230),
    [sym_mutate_expression] = STATE(2230),
    [sym_index_expression] = STATE(2230),
    [sym_typed_expression] = STATE(2230),
    [sym_declaration_expression] = STATE(2230),
    [sym_do_expression] = STATE(2230),
    [sym_list_expression] = STATE(2230),
    [sym_array_expression] = STATE(2230),
    [sym_begin_end_expression] = STATE(2230),
    [sym_paren_expression] = STATE(2230),
    [sym__high_prec_app] = STATE(2229),
    [sym__low_prec_app] = STATE(2229),
    [sym_application_expression] = STATE(2230),
    [sym_dot_expression] = STATE(2230),
    [sym_infix_expression] = STATE(2230),
    [sym_ce_expression] = STATE(2230),
    [sym_sequential_expression] = STATE(2230),
    [sym_char] = STATE(2100),
    [sym_format_string] = STATE(2106),
    [sym__string_literal] = STATE(2106),
    [sym_string] = STATE(2100),
    [sym_verbatim_string] = STATE(2100),
    [sym_bytearray] = STATE(2100),
    [sym_verbatim_bytearray] = STATE(2100),
    [sym_format_triple_quoted_string] = STATE(2107),
    [sym_triple_quoted_string] = STATE(2100),
    [sym_const] = STATE(2230),
    [sym_long_identifier] = STATE(2232),
    [sym_active_pattern] = STATE(2424),
    [sym__identifier_or_op] = STATE(2305),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(737),
    [sym_infix_op] = STATE(694),
    [sym_sbyte] = STATE(2100),
    [sym_byte] = STATE(2100),
    [sym_int16] = STATE(2100),
    [sym_uint16] = STATE(2100),
    [sym_int32] = STATE(2100),
    [sym_uint32] = STATE(2100),
    [sym_nativeint] = STATE(2100),
    [sym_unativeint] = STATE(2100),
    [sym_int64] = STATE(2100),
    [sym_uint64] = STATE(2100),
    [sym_ieee32] = STATE(2100),
    [sym_ieee64] = STATE(2100),
    [sym_bignum] = STATE(2100),
    [sym_decimal] = STATE(2100),
    [sym_float] = STATE(1487),
    [sym_block_comment] = STATE(292),
    [sym_compiler_directive_decl] = STATE(292),
    [sym_fsi_directive_decl] = STATE(292),
    [sym_preproc_line] = STATE(292),
    [sym_preproc_if_in_expression] = STATE(2230),
    [aux_sym_sequential_expression_repeat1] = STATE(1743),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(877),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(879),
    [anon_sym_return] = ACTIONS(881),
    [anon_sym_do] = ACTIONS(1567),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(885),
    [anon_sym_COMMA] = ACTIONS(887),
    [anon_sym_null] = ACTIONS(889),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(879),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(891),
    [anon_sym_LBRACK_PIPE] = ACTIONS(893),
    [anon_sym_LBRACE] = ACTIONS(895),
    [anon_sym_LT_AT] = ACTIONS(897),
    [anon_sym_LT_AT_AT] = ACTIONS(899),
    [anon_sym_DOT] = ACTIONS(901),
    [anon_sym_LBRACE_PIPE] = ACTIONS(903),
    [anon_sym_new] = ACTIONS(881),
    [anon_sym_return_BANG] = ACTIONS(905),
    [anon_sym_yield] = ACTIONS(881),
    [anon_sym_yield_BANG] = ACTIONS(905),
    [anon_sym_lazy] = ACTIONS(881),
    [anon_sym_assert] = ACTIONS(881),
    [anon_sym_upcast] = ACTIONS(881),
    [anon_sym_downcast] = ACTIONS(881),
    [anon_sym_COLON_GT] = ACTIONS(907),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(907),
    [anon_sym_for] = ACTIONS(909),
    [anon_sym_while] = ACTIONS(911),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(913),
    [anon_sym_try] = ACTIONS(915),
    [anon_sym_match] = ACTIONS(917),
    [anon_sym_match_BANG] = ACTIONS(919),
    [anon_sym_function] = ACTIONS(921),
    [anon_sym_LT_DASH] = ACTIONS(923),
    [anon_sym_DOT_LBRACK] = ACTIONS(925),
    [anon_sym_LT] = ACTIONS(927),
    [anon_sym_use] = ACTIONS(929),
    [anon_sym_use_BANG] = ACTIONS(931),
    [anon_sym_do_BANG] = ACTIONS(933),
    [anon_sym_DOT_DOT] = ACTIONS(935),
    [anon_sym_begin] = ACTIONS(937),
    [anon_sym_LPAREN2] = ACTIONS(939),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(941),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(943),
    [anon_sym_DQUOTE] = ACTIONS(945),
    [anon_sym_AT_DQUOTE] = ACTIONS(947),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(949),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(951),
    [sym_bool] = ACTIONS(953),
    [sym_unit] = ACTIONS(955),
    [anon_sym_LPAREN_PIPE] = ACTIONS(957),
    [sym_op_identifier] = ACTIONS(959),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(961),
    [sym_xint] = ACTIONS(963),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(965),
    [sym__newline] = ACTIONS(967),
  },
  [293] = {
    [sym_function_or_value_defn] = STATE(627),
    [sym__expression] = STATE(17),
    [sym_literal_expression] = STATE(1118),
    [sym_long_identifier_or_op] = STATE(1118),
    [sym_tuple_expression] = STATE(1118),
    [sym_brace_expression] = STATE(1118),
    [sym_anon_record_expression] = STATE(1118),
    [sym_prefixed_expression] = STATE(1118),
    [sym_typecast_expression] = STATE(1118),
    [sym_for_expression] = STATE(1118),
    [sym_while_expression] = STATE(1118),
    [sym__if_branch] = STATE(7163),
    [sym_if_expression] = STATE(1118),
    [sym_fun_expression] = STATE(1118),
    [sym_try_expression] = STATE(1118),
    [sym_match_expression] = STATE(1118),
    [sym_function_expression] = STATE(1118),
    [sym_mutate_expression] = STATE(1118),
    [sym_index_expression] = STATE(1118),
    [sym_typed_expression] = STATE(1118),
    [sym_declaration_expression] = STATE(1118),
    [sym_do_expression] = STATE(1118),
    [sym_list_expression] = STATE(1118),
    [sym_array_expression] = STATE(1118),
    [sym_begin_end_expression] = STATE(1118),
    [sym_paren_expression] = STATE(1118),
    [sym__high_prec_app] = STATE(1133),
    [sym__low_prec_app] = STATE(1133),
    [sym_application_expression] = STATE(1118),
    [sym_dot_expression] = STATE(1118),
    [sym_infix_expression] = STATE(1118),
    [sym_ce_expression] = STATE(1118),
    [sym_sequential_expression] = STATE(1118),
    [sym_char] = STATE(1080),
    [sym_format_string] = STATE(1090),
    [sym__string_literal] = STATE(1090),
    [sym_string] = STATE(1080),
    [sym_verbatim_string] = STATE(1080),
    [sym_bytearray] = STATE(1080),
    [sym_verbatim_bytearray] = STATE(1080),
    [sym_format_triple_quoted_string] = STATE(1096),
    [sym_triple_quoted_string] = STATE(1080),
    [sym_const] = STATE(1118),
    [sym_long_identifier] = STATE(1156),
    [sym_active_pattern] = STATE(1085),
    [sym__identifier_or_op] = STATE(1099),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(517),
    [sym_infix_op] = STATE(487),
    [sym_sbyte] = STATE(1080),
    [sym_byte] = STATE(1080),
    [sym_int16] = STATE(1080),
    [sym_uint16] = STATE(1080),
    [sym_int32] = STATE(1080),
    [sym_uint32] = STATE(1080),
    [sym_nativeint] = STATE(1080),
    [sym_unativeint] = STATE(1080),
    [sym_int64] = STATE(1080),
    [sym_uint64] = STATE(1080),
    [sym_ieee32] = STATE(1080),
    [sym_ieee64] = STATE(1080),
    [sym_bignum] = STATE(1080),
    [sym_decimal] = STATE(1080),
    [sym_float] = STATE(979),
    [sym_block_comment] = STATE(293),
    [sym_compiler_directive_decl] = STATE(293),
    [sym_fsi_directive_decl] = STATE(293),
    [sym_preproc_line] = STATE(293),
    [sym_preproc_if_in_expression] = STATE(1118),
    [aux_sym_sequential_expression_repeat1] = STATE(1069),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(195),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(197),
    [anon_sym_return] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_COMMA] = ACTIONS(205),
    [anon_sym_null] = ACTIONS(207),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(197),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(209),
    [anon_sym_LBRACK_PIPE] = ACTIONS(211),
    [anon_sym_LBRACE] = ACTIONS(271),
    [anon_sym_LT_AT] = ACTIONS(213),
    [anon_sym_LT_AT_AT] = ACTIONS(215),
    [anon_sym_DOT] = ACTIONS(185),
    [anon_sym_LBRACE_PIPE] = ACTIONS(217),
    [anon_sym_new] = ACTIONS(199),
    [anon_sym_with] = ACTIONS(1569),
    [anon_sym_return_BANG] = ACTIONS(219),
    [anon_sym_yield] = ACTIONS(199),
    [anon_sym_yield_BANG] = ACTIONS(219),
    [anon_sym_lazy] = ACTIONS(199),
    [anon_sym_assert] = ACTIONS(199),
    [anon_sym_upcast] = ACTIONS(199),
    [anon_sym_downcast] = ACTIONS(199),
    [anon_sym_COLON_GT] = ACTIONS(221),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(221),
    [anon_sym_for] = ACTIONS(223),
    [anon_sym_while] = ACTIONS(225),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(229),
    [anon_sym_match] = ACTIONS(231),
    [anon_sym_match_BANG] = ACTIONS(233),
    [anon_sym_function] = ACTIONS(235),
    [anon_sym_LT_DASH] = ACTIONS(237),
    [anon_sym_DOT_LBRACK] = ACTIONS(187),
    [anon_sym_LT] = ACTIONS(189),
    [anon_sym_use] = ACTIONS(239),
    [anon_sym_use_BANG] = ACTIONS(241),
    [anon_sym_do_BANG] = ACTIONS(243),
    [anon_sym_begin] = ACTIONS(245),
    [anon_sym_LPAREN2] = ACTIONS(191),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(247),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(251),
    [anon_sym_AT_DQUOTE] = ACTIONS(253),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(255),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(257),
    [sym_bool] = ACTIONS(259),
    [sym_unit] = ACTIONS(193),
    [anon_sym_LPAREN_PIPE] = ACTIONS(261),
    [sym_op_identifier] = ACTIONS(263),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(265),
    [sym_xint] = ACTIONS(267),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(269),
    [sym__newline] = ACTIONS(1571),
  },
  [294] = {
    [sym_function_or_value_defn] = STATE(733),
    [sym__expression] = STATE(142),
    [sym_literal_expression] = STATE(2008),
    [sym_long_identifier_or_op] = STATE(2008),
    [sym_tuple_expression] = STATE(2008),
    [sym_brace_expression] = STATE(2008),
    [sym_anon_record_expression] = STATE(2008),
    [sym_prefixed_expression] = STATE(2008),
    [sym_typecast_expression] = STATE(2008),
    [sym_for_expression] = STATE(2008),
    [sym_while_expression] = STATE(2008),
    [sym__if_branch] = STATE(6754),
    [sym_if_expression] = STATE(2008),
    [sym_fun_expression] = STATE(2008),
    [sym_try_expression] = STATE(2008),
    [sym_match_expression] = STATE(2008),
    [sym_function_expression] = STATE(2008),
    [sym_mutate_expression] = STATE(2008),
    [sym_index_expression] = STATE(2008),
    [sym_typed_expression] = STATE(2008),
    [sym_declaration_expression] = STATE(2008),
    [sym_do_expression] = STATE(2008),
    [sym_list_expression] = STATE(2008),
    [sym_array_expression] = STATE(2008),
    [sym_begin_end_expression] = STATE(2008),
    [sym_paren_expression] = STATE(2008),
    [sym__high_prec_app] = STATE(2007),
    [sym__low_prec_app] = STATE(2007),
    [sym_application_expression] = STATE(2008),
    [sym_dot_expression] = STATE(2008),
    [sym_infix_expression] = STATE(2008),
    [sym_ce_expression] = STATE(2008),
    [sym_sequential_expression] = STATE(2008),
    [sym_char] = STATE(1859),
    [sym_format_string] = STATE(1861),
    [sym__string_literal] = STATE(1861),
    [sym_string] = STATE(1859),
    [sym_verbatim_string] = STATE(1859),
    [sym_bytearray] = STATE(1859),
    [sym_verbatim_bytearray] = STATE(1859),
    [sym_format_triple_quoted_string] = STATE(1862),
    [sym_triple_quoted_string] = STATE(1859),
    [sym_const] = STATE(2008),
    [sym_long_identifier] = STATE(1701),
    [sym_active_pattern] = STATE(1702),
    [sym__identifier_or_op] = STATE(1724),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(706),
    [sym_infix_op] = STATE(678),
    [sym_sbyte] = STATE(1859),
    [sym_byte] = STATE(1859),
    [sym_int16] = STATE(1859),
    [sym_uint16] = STATE(1859),
    [sym_int32] = STATE(1859),
    [sym_uint32] = STATE(1859),
    [sym_nativeint] = STATE(1859),
    [sym_unativeint] = STATE(1859),
    [sym_int64] = STATE(1859),
    [sym_uint64] = STATE(1859),
    [sym_ieee32] = STATE(1859),
    [sym_ieee64] = STATE(1859),
    [sym_bignum] = STATE(1859),
    [sym_decimal] = STATE(1859),
    [sym_float] = STATE(1447),
    [sym_block_comment] = STATE(294),
    [sym_compiler_directive_decl] = STATE(294),
    [sym_fsi_directive_decl] = STATE(294),
    [sym_preproc_line] = STATE(294),
    [sym_preproc_if_in_expression] = STATE(2008),
    [aux_sym_sequential_expression_repeat1] = STATE(1995),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(503),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(969),
    [anon_sym_return] = ACTIONS(971),
    [anon_sym_do] = ACTIONS(599),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(511),
    [anon_sym_COMMA] = ACTIONS(973),
    [anon_sym_null] = ACTIONS(515),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(969),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(517),
    [anon_sym_LBRACK_PIPE] = ACTIONS(519),
    [anon_sym_LBRACE] = ACTIONS(521),
    [anon_sym_LT_AT] = ACTIONS(523),
    [anon_sym_LT_AT_AT] = ACTIONS(525),
    [anon_sym_DOT] = ACTIONS(527),
    [anon_sym_LBRACE_PIPE] = ACTIONS(529),
    [anon_sym_new] = ACTIONS(971),
    [anon_sym_return_BANG] = ACTIONS(975),
    [anon_sym_yield] = ACTIONS(971),
    [anon_sym_yield_BANG] = ACTIONS(975),
    [anon_sym_lazy] = ACTIONS(971),
    [anon_sym_assert] = ACTIONS(971),
    [anon_sym_upcast] = ACTIONS(971),
    [anon_sym_downcast] = ACTIONS(971),
    [anon_sym_COLON_GT] = ACTIONS(977),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(977),
    [anon_sym_for] = ACTIONS(979),
    [anon_sym_while] = ACTIONS(537),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(539),
    [anon_sym_DASH_GT] = ACTIONS(1573),
    [anon_sym_try] = ACTIONS(543),
    [anon_sym_match] = ACTIONS(545),
    [anon_sym_match_BANG] = ACTIONS(547),
    [anon_sym_function] = ACTIONS(549),
    [anon_sym_LT_DASH] = ACTIONS(981),
    [anon_sym_DOT_LBRACK] = ACTIONS(553),
    [anon_sym_LT] = ACTIONS(555),
    [anon_sym_use] = ACTIONS(983),
    [anon_sym_use_BANG] = ACTIONS(985),
    [anon_sym_do_BANG] = ACTIONS(561),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_LPAREN2] = ACTIONS(567),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(569),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(571),
    [anon_sym_DQUOTE] = ACTIONS(573),
    [anon_sym_AT_DQUOTE] = ACTIONS(575),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(577),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(579),
    [sym_bool] = ACTIONS(581),
    [sym_unit] = ACTIONS(583),
    [anon_sym_LPAREN_PIPE] = ACTIONS(585),
    [sym_op_identifier] = ACTIONS(587),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(591),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(593),
    [sym__newline] = ACTIONS(1171),
  },
  [295] = {
    [sym_function_or_value_defn] = STATE(704),
    [sym__expression] = STATE(312),
    [sym_literal_expression] = STATE(2403),
    [sym_long_identifier_or_op] = STATE(2403),
    [sym_tuple_expression] = STATE(2403),
    [sym_brace_expression] = STATE(2403),
    [sym_anon_record_expression] = STATE(2403),
    [sym_prefixed_expression] = STATE(2403),
    [sym_typecast_expression] = STATE(2403),
    [sym_for_expression] = STATE(2403),
    [sym_while_expression] = STATE(2403),
    [sym__if_branch] = STATE(6794),
    [sym_if_expression] = STATE(2403),
    [sym_fun_expression] = STATE(2403),
    [sym_try_expression] = STATE(2403),
    [sym_match_expression] = STATE(2403),
    [sym_function_expression] = STATE(2403),
    [sym_mutate_expression] = STATE(2403),
    [sym_index_expression] = STATE(2403),
    [sym_typed_expression] = STATE(2403),
    [sym_declaration_expression] = STATE(2403),
    [sym_do_expression] = STATE(2403),
    [sym_list_expression] = STATE(2403),
    [sym_array_expression] = STATE(2403),
    [sym_begin_end_expression] = STATE(2403),
    [sym_paren_expression] = STATE(2403),
    [sym__high_prec_app] = STATE(2405),
    [sym__low_prec_app] = STATE(2405),
    [sym_application_expression] = STATE(2403),
    [sym_dot_expression] = STATE(2403),
    [sym_infix_expression] = STATE(2403),
    [sym_ce_expression] = STATE(2403),
    [sym_sequential_expression] = STATE(2403),
    [sym_char] = STATE(2425),
    [sym_format_string] = STATE(2420),
    [sym__string_literal] = STATE(2420),
    [sym_string] = STATE(2425),
    [sym_verbatim_string] = STATE(2425),
    [sym_bytearray] = STATE(2425),
    [sym_verbatim_bytearray] = STATE(2425),
    [sym_format_triple_quoted_string] = STATE(2419),
    [sym_triple_quoted_string] = STATE(2425),
    [sym_const] = STATE(2403),
    [sym_long_identifier] = STATE(2079),
    [sym_active_pattern] = STATE(2080),
    [sym__identifier_or_op] = STATE(2089),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(688),
    [sym_infix_op] = STATE(668),
    [sym_sbyte] = STATE(2425),
    [sym_byte] = STATE(2425),
    [sym_int16] = STATE(2425),
    [sym_uint16] = STATE(2425),
    [sym_int32] = STATE(2425),
    [sym_uint32] = STATE(2425),
    [sym_nativeint] = STATE(2425),
    [sym_unativeint] = STATE(2425),
    [sym_int64] = STATE(2425),
    [sym_uint64] = STATE(2425),
    [sym_ieee32] = STATE(2425),
    [sym_ieee64] = STATE(2425),
    [sym_bignum] = STATE(2425),
    [sym_decimal] = STATE(2425),
    [sym_float] = STATE(1511),
    [sym_block_comment] = STATE(295),
    [sym_compiler_directive_decl] = STATE(295),
    [sym_fsi_directive_decl] = STATE(295),
    [sym_preproc_line] = STATE(295),
    [sym_preproc_if_in_expression] = STATE(2403),
    [aux_sym_sequential_expression_repeat1] = STATE(1901),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(1261),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(1263),
    [anon_sym_return] = ACTIONS(1265),
    [anon_sym_do] = ACTIONS(1267),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(1269),
    [anon_sym_COMMA] = ACTIONS(1271),
    [anon_sym_null] = ACTIONS(1273),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(1263),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1275),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1277),
    [anon_sym_LBRACE] = ACTIONS(165),
    [anon_sym_LT_AT] = ACTIONS(1281),
    [anon_sym_LT_AT_AT] = ACTIONS(1283),
    [anon_sym_DOT] = ACTIONS(1285),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1287),
    [anon_sym_new] = ACTIONS(1265),
    [anon_sym_return_BANG] = ACTIONS(1289),
    [anon_sym_yield] = ACTIONS(1265),
    [anon_sym_yield_BANG] = ACTIONS(1289),
    [anon_sym_lazy] = ACTIONS(1265),
    [anon_sym_assert] = ACTIONS(1265),
    [anon_sym_upcast] = ACTIONS(1265),
    [anon_sym_downcast] = ACTIONS(1265),
    [anon_sym_COLON_GT] = ACTIONS(1291),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1291),
    [anon_sym_for] = ACTIONS(1293),
    [anon_sym_while] = ACTIONS(1295),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(1297),
    [anon_sym_try] = ACTIONS(1299),
    [anon_sym_match] = ACTIONS(1301),
    [anon_sym_match_BANG] = ACTIONS(1303),
    [anon_sym_function] = ACTIONS(1305),
    [anon_sym_LT_DASH] = ACTIONS(1307),
    [anon_sym_DOT_LBRACK] = ACTIONS(1309),
    [anon_sym_LT] = ACTIONS(1311),
    [anon_sym_use] = ACTIONS(1313),
    [anon_sym_use_BANG] = ACTIONS(1315),
    [anon_sym_do_BANG] = ACTIONS(1317),
    [anon_sym_begin] = ACTIONS(1319),
    [anon_sym_LPAREN2] = ACTIONS(1321),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(1323),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1325),
    [anon_sym_DQUOTE] = ACTIONS(1327),
    [anon_sym_AT_DQUOTE] = ACTIONS(1329),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1331),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1333),
    [sym_bool] = ACTIONS(1335),
    [sym_unit] = ACTIONS(1337),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1339),
    [sym_op_identifier] = ACTIONS(1341),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(1343),
    [sym_xint] = ACTIONS(1345),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1347),
    [anon_sym_POUNDendif] = ACTIONS(163),
    [sym__newline] = ACTIONS(163),
  },
  [296] = {
    [sym_function_or_value_defn] = STATE(509),
    [sym__expression] = STATE(326),
    [sym_literal_expression] = STATE(2230),
    [sym_long_identifier_or_op] = STATE(2230),
    [sym_tuple_expression] = STATE(2230),
    [sym_brace_expression] = STATE(2230),
    [sym_anon_record_expression] = STATE(2230),
    [sym_prefixed_expression] = STATE(2230),
    [sym_typecast_expression] = STATE(2230),
    [sym_for_expression] = STATE(2230),
    [sym_while_expression] = STATE(2230),
    [sym__if_branch] = STATE(6659),
    [sym_if_expression] = STATE(2230),
    [sym_fun_expression] = STATE(2230),
    [sym_try_expression] = STATE(2230),
    [sym_match_expression] = STATE(2230),
    [sym_function_expression] = STATE(2230),
    [sym_mutate_expression] = STATE(2230),
    [sym_index_expression] = STATE(2230),
    [sym_typed_expression] = STATE(2230),
    [sym_declaration_expression] = STATE(2230),
    [sym_do_expression] = STATE(2230),
    [sym_list_expression] = STATE(2230),
    [sym_array_expression] = STATE(2230),
    [sym_begin_end_expression] = STATE(2230),
    [sym_paren_expression] = STATE(2230),
    [sym__high_prec_app] = STATE(2229),
    [sym__low_prec_app] = STATE(2229),
    [sym_application_expression] = STATE(2230),
    [sym_dot_expression] = STATE(2230),
    [sym_infix_expression] = STATE(2230),
    [sym_ce_expression] = STATE(2230),
    [sym_sequential_expression] = STATE(2230),
    [sym_char] = STATE(2100),
    [sym_format_string] = STATE(2106),
    [sym__string_literal] = STATE(2106),
    [sym_string] = STATE(2100),
    [sym_verbatim_string] = STATE(2100),
    [sym_bytearray] = STATE(2100),
    [sym_verbatim_bytearray] = STATE(2100),
    [sym_format_triple_quoted_string] = STATE(2107),
    [sym_triple_quoted_string] = STATE(2100),
    [sym_const] = STATE(2230),
    [sym_long_identifier] = STATE(2232),
    [sym_active_pattern] = STATE(2424),
    [sym__identifier_or_op] = STATE(2305),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(737),
    [sym_infix_op] = STATE(694),
    [sym_sbyte] = STATE(2100),
    [sym_byte] = STATE(2100),
    [sym_int16] = STATE(2100),
    [sym_uint16] = STATE(2100),
    [sym_int32] = STATE(2100),
    [sym_uint32] = STATE(2100),
    [sym_nativeint] = STATE(2100),
    [sym_unativeint] = STATE(2100),
    [sym_int64] = STATE(2100),
    [sym_uint64] = STATE(2100),
    [sym_ieee32] = STATE(2100),
    [sym_ieee64] = STATE(2100),
    [sym_bignum] = STATE(2100),
    [sym_decimal] = STATE(2100),
    [sym_float] = STATE(1487),
    [sym_block_comment] = STATE(296),
    [sym_compiler_directive_decl] = STATE(296),
    [sym_fsi_directive_decl] = STATE(296),
    [sym_preproc_line] = STATE(296),
    [sym_preproc_if_in_expression] = STATE(2230),
    [aux_sym_sequential_expression_repeat1] = STATE(1743),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(877),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(879),
    [anon_sym_return] = ACTIONS(881),
    [anon_sym_do] = ACTIONS(1575),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(885),
    [anon_sym_COMMA] = ACTIONS(887),
    [anon_sym_null] = ACTIONS(889),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(879),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(891),
    [anon_sym_LBRACK_PIPE] = ACTIONS(893),
    [anon_sym_LBRACE] = ACTIONS(895),
    [anon_sym_LT_AT] = ACTIONS(897),
    [anon_sym_LT_AT_AT] = ACTIONS(899),
    [anon_sym_DOT] = ACTIONS(901),
    [anon_sym_LBRACE_PIPE] = ACTIONS(903),
    [anon_sym_new] = ACTIONS(881),
    [anon_sym_return_BANG] = ACTIONS(905),
    [anon_sym_yield] = ACTIONS(881),
    [anon_sym_yield_BANG] = ACTIONS(905),
    [anon_sym_lazy] = ACTIONS(881),
    [anon_sym_assert] = ACTIONS(881),
    [anon_sym_upcast] = ACTIONS(881),
    [anon_sym_downcast] = ACTIONS(881),
    [anon_sym_COLON_GT] = ACTIONS(907),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(907),
    [anon_sym_for] = ACTIONS(909),
    [anon_sym_while] = ACTIONS(911),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(913),
    [anon_sym_try] = ACTIONS(915),
    [anon_sym_match] = ACTIONS(917),
    [anon_sym_match_BANG] = ACTIONS(919),
    [anon_sym_function] = ACTIONS(921),
    [anon_sym_LT_DASH] = ACTIONS(923),
    [anon_sym_DOT_LBRACK] = ACTIONS(925),
    [anon_sym_LT] = ACTIONS(927),
    [anon_sym_use] = ACTIONS(929),
    [anon_sym_use_BANG] = ACTIONS(931),
    [anon_sym_do_BANG] = ACTIONS(933),
    [anon_sym_DOT_DOT] = ACTIONS(935),
    [anon_sym_begin] = ACTIONS(937),
    [anon_sym_LPAREN2] = ACTIONS(939),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(941),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(943),
    [anon_sym_DQUOTE] = ACTIONS(945),
    [anon_sym_AT_DQUOTE] = ACTIONS(947),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(949),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(951),
    [sym_bool] = ACTIONS(953),
    [sym_unit] = ACTIONS(955),
    [anon_sym_LPAREN_PIPE] = ACTIONS(957),
    [sym_op_identifier] = ACTIONS(959),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(961),
    [sym_xint] = ACTIONS(963),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(965),
    [sym__newline] = ACTIONS(967),
  },
  [297] = {
    [sym_function_or_value_defn] = STATE(704),
    [sym__expression] = STATE(312),
    [sym_literal_expression] = STATE(2403),
    [sym_long_identifier_or_op] = STATE(2403),
    [sym_tuple_expression] = STATE(2403),
    [sym_brace_expression] = STATE(2403),
    [sym_anon_record_expression] = STATE(2403),
    [sym_prefixed_expression] = STATE(2403),
    [sym_typecast_expression] = STATE(2403),
    [sym_for_expression] = STATE(2403),
    [sym_while_expression] = STATE(2403),
    [sym__if_branch] = STATE(6794),
    [sym_if_expression] = STATE(2403),
    [sym_fun_expression] = STATE(2403),
    [sym_try_expression] = STATE(2403),
    [sym_match_expression] = STATE(2403),
    [sym_function_expression] = STATE(2403),
    [sym_mutate_expression] = STATE(2403),
    [sym_index_expression] = STATE(2403),
    [sym_typed_expression] = STATE(2403),
    [sym_declaration_expression] = STATE(2403),
    [sym_do_expression] = STATE(2403),
    [sym_list_expression] = STATE(2403),
    [sym_array_expression] = STATE(2403),
    [sym_begin_end_expression] = STATE(2403),
    [sym_paren_expression] = STATE(2403),
    [sym__high_prec_app] = STATE(2405),
    [sym__low_prec_app] = STATE(2405),
    [sym_application_expression] = STATE(2403),
    [sym_dot_expression] = STATE(2403),
    [sym_infix_expression] = STATE(2403),
    [sym_ce_expression] = STATE(2403),
    [sym_sequential_expression] = STATE(2403),
    [sym_char] = STATE(2425),
    [sym_format_string] = STATE(2420),
    [sym__string_literal] = STATE(2420),
    [sym_string] = STATE(2425),
    [sym_verbatim_string] = STATE(2425),
    [sym_bytearray] = STATE(2425),
    [sym_verbatim_bytearray] = STATE(2425),
    [sym_format_triple_quoted_string] = STATE(2419),
    [sym_triple_quoted_string] = STATE(2425),
    [sym_const] = STATE(2403),
    [sym_long_identifier] = STATE(2079),
    [sym_active_pattern] = STATE(2080),
    [sym__identifier_or_op] = STATE(2089),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(688),
    [sym_infix_op] = STATE(668),
    [sym_sbyte] = STATE(2425),
    [sym_byte] = STATE(2425),
    [sym_int16] = STATE(2425),
    [sym_uint16] = STATE(2425),
    [sym_int32] = STATE(2425),
    [sym_uint32] = STATE(2425),
    [sym_nativeint] = STATE(2425),
    [sym_unativeint] = STATE(2425),
    [sym_int64] = STATE(2425),
    [sym_uint64] = STATE(2425),
    [sym_ieee32] = STATE(2425),
    [sym_ieee64] = STATE(2425),
    [sym_bignum] = STATE(2425),
    [sym_decimal] = STATE(2425),
    [sym_float] = STATE(1511),
    [sym_block_comment] = STATE(297),
    [sym_compiler_directive_decl] = STATE(297),
    [sym_fsi_directive_decl] = STATE(297),
    [sym_preproc_line] = STATE(297),
    [sym_preproc_if_in_expression] = STATE(2403),
    [aux_sym_sequential_expression_repeat1] = STATE(1901),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(1261),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(1263),
    [anon_sym_return] = ACTIONS(1265),
    [anon_sym_do] = ACTIONS(1267),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(1269),
    [anon_sym_COMMA] = ACTIONS(1271),
    [anon_sym_null] = ACTIONS(1273),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(1263),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1275),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1277),
    [anon_sym_LBRACE] = ACTIONS(1279),
    [anon_sym_LT_AT] = ACTIONS(1281),
    [anon_sym_LT_AT_AT] = ACTIONS(1283),
    [anon_sym_DOT] = ACTIONS(1285),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1287),
    [anon_sym_new] = ACTIONS(1265),
    [anon_sym_return_BANG] = ACTIONS(1289),
    [anon_sym_yield] = ACTIONS(1265),
    [anon_sym_yield_BANG] = ACTIONS(1289),
    [anon_sym_lazy] = ACTIONS(1265),
    [anon_sym_assert] = ACTIONS(1265),
    [anon_sym_upcast] = ACTIONS(1265),
    [anon_sym_downcast] = ACTIONS(1265),
    [anon_sym_COLON_GT] = ACTIONS(1291),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(1291),
    [anon_sym_for] = ACTIONS(1293),
    [anon_sym_while] = ACTIONS(1295),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(1297),
    [anon_sym_try] = ACTIONS(1299),
    [anon_sym_match] = ACTIONS(1301),
    [anon_sym_match_BANG] = ACTIONS(1303),
    [anon_sym_function] = ACTIONS(1305),
    [anon_sym_LT_DASH] = ACTIONS(1307),
    [anon_sym_DOT_LBRACK] = ACTIONS(1309),
    [anon_sym_LT] = ACTIONS(1311),
    [anon_sym_use] = ACTIONS(1313),
    [anon_sym_use_BANG] = ACTIONS(1315),
    [anon_sym_do_BANG] = ACTIONS(1317),
    [anon_sym_begin] = ACTIONS(1319),
    [anon_sym_LPAREN2] = ACTIONS(1321),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(1323),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1325),
    [anon_sym_DQUOTE] = ACTIONS(1327),
    [anon_sym_AT_DQUOTE] = ACTIONS(1329),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1331),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1333),
    [sym_bool] = ACTIONS(1335),
    [sym_unit] = ACTIONS(1337),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1339),
    [sym_op_identifier] = ACTIONS(1341),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(1343),
    [sym_xint] = ACTIONS(1345),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1347),
    [anon_sym_POUNDendif] = ACTIONS(159),
    [sym__newline] = ACTIONS(1349),
  },
  [298] = {
    [sym_function_or_value_defn] = STATE(733),
    [sym__expression] = STATE(142),
    [sym_literal_expression] = STATE(2008),
    [sym_long_identifier_or_op] = STATE(2008),
    [sym_tuple_expression] = STATE(2008),
    [sym_brace_expression] = STATE(2008),
    [sym_anon_record_expression] = STATE(2008),
    [sym_prefixed_expression] = STATE(2008),
    [sym_typecast_expression] = STATE(2008),
    [sym_for_expression] = STATE(2008),
    [sym_while_expression] = STATE(2008),
    [sym__if_branch] = STATE(6754),
    [sym_if_expression] = STATE(2008),
    [sym_fun_expression] = STATE(2008),
    [sym_try_expression] = STATE(2008),
    [sym_match_expression] = STATE(2008),
    [sym_function_expression] = STATE(2008),
    [sym_mutate_expression] = STATE(2008),
    [sym_index_expression] = STATE(2008),
    [sym_typed_expression] = STATE(2008),
    [sym_declaration_expression] = STATE(2008),
    [sym_do_expression] = STATE(2008),
    [sym_list_expression] = STATE(2008),
    [sym_array_expression] = STATE(2008),
    [sym_begin_end_expression] = STATE(2008),
    [sym_paren_expression] = STATE(2008),
    [sym__high_prec_app] = STATE(2007),
    [sym__low_prec_app] = STATE(2007),
    [sym_application_expression] = STATE(2008),
    [sym_dot_expression] = STATE(2008),
    [sym_infix_expression] = STATE(2008),
    [sym_ce_expression] = STATE(2008),
    [sym_sequential_expression] = STATE(2008),
    [sym_char] = STATE(1859),
    [sym_format_string] = STATE(1861),
    [sym__string_literal] = STATE(1861),
    [sym_string] = STATE(1859),
    [sym_verbatim_string] = STATE(1859),
    [sym_bytearray] = STATE(1859),
    [sym_verbatim_bytearray] = STATE(1859),
    [sym_format_triple_quoted_string] = STATE(1862),
    [sym_triple_quoted_string] = STATE(1859),
    [sym_const] = STATE(2008),
    [sym_long_identifier] = STATE(1701),
    [sym_active_pattern] = STATE(1702),
    [sym__identifier_or_op] = STATE(1724),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(706),
    [sym_infix_op] = STATE(678),
    [sym_sbyte] = STATE(1859),
    [sym_byte] = STATE(1859),
    [sym_int16] = STATE(1859),
    [sym_uint16] = STATE(1859),
    [sym_int32] = STATE(1859),
    [sym_uint32] = STATE(1859),
    [sym_nativeint] = STATE(1859),
    [sym_unativeint] = STATE(1859),
    [sym_int64] = STATE(1859),
    [sym_uint64] = STATE(1859),
    [sym_ieee32] = STATE(1859),
    [sym_ieee64] = STATE(1859),
    [sym_bignum] = STATE(1859),
    [sym_decimal] = STATE(1859),
    [sym_float] = STATE(1447),
    [sym_block_comment] = STATE(298),
    [sym_compiler_directive_decl] = STATE(298),
    [sym_fsi_directive_decl] = STATE(298),
    [sym_preproc_line] = STATE(298),
    [sym_preproc_if_in_expression] = STATE(2008),
    [aux_sym_sequential_expression_repeat1] = STATE(1995),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(503),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(969),
    [anon_sym_return] = ACTIONS(971),
    [anon_sym_do] = ACTIONS(599),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(511),
    [anon_sym_COMMA] = ACTIONS(973),
    [anon_sym_null] = ACTIONS(515),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(969),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(517),
    [anon_sym_LBRACK_PIPE] = ACTIONS(519),
    [anon_sym_LBRACE] = ACTIONS(521),
    [anon_sym_LT_AT] = ACTIONS(523),
    [anon_sym_LT_AT_AT] = ACTIONS(525),
    [anon_sym_DOT] = ACTIONS(527),
    [anon_sym_LBRACE_PIPE] = ACTIONS(529),
    [anon_sym_new] = ACTIONS(971),
    [anon_sym_return_BANG] = ACTIONS(975),
    [anon_sym_yield] = ACTIONS(971),
    [anon_sym_yield_BANG] = ACTIONS(975),
    [anon_sym_lazy] = ACTIONS(971),
    [anon_sym_assert] = ACTIONS(971),
    [anon_sym_upcast] = ACTIONS(971),
    [anon_sym_downcast] = ACTIONS(971),
    [anon_sym_COLON_GT] = ACTIONS(977),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(977),
    [anon_sym_for] = ACTIONS(979),
    [anon_sym_while] = ACTIONS(537),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(539),
    [anon_sym_DASH_GT] = ACTIONS(1577),
    [anon_sym_try] = ACTIONS(543),
    [anon_sym_match] = ACTIONS(545),
    [anon_sym_match_BANG] = ACTIONS(547),
    [anon_sym_function] = ACTIONS(549),
    [anon_sym_LT_DASH] = ACTIONS(981),
    [anon_sym_DOT_LBRACK] = ACTIONS(553),
    [anon_sym_LT] = ACTIONS(555),
    [anon_sym_use] = ACTIONS(983),
    [anon_sym_use_BANG] = ACTIONS(985),
    [anon_sym_do_BANG] = ACTIONS(561),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_LPAREN2] = ACTIONS(567),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(569),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(571),
    [anon_sym_DQUOTE] = ACTIONS(573),
    [anon_sym_AT_DQUOTE] = ACTIONS(575),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(577),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(579),
    [sym_bool] = ACTIONS(581),
    [sym_unit] = ACTIONS(583),
    [anon_sym_LPAREN_PIPE] = ACTIONS(585),
    [sym_op_identifier] = ACTIONS(587),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(591),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(593),
    [sym__newline] = ACTIONS(1171),
  },
  [299] = {
    [sym_function_or_value_defn] = STATE(733),
    [sym__expression] = STATE(142),
    [sym_literal_expression] = STATE(2008),
    [sym_long_identifier_or_op] = STATE(2008),
    [sym_tuple_expression] = STATE(2008),
    [sym_brace_expression] = STATE(2008),
    [sym_anon_record_expression] = STATE(2008),
    [sym_prefixed_expression] = STATE(2008),
    [sym_typecast_expression] = STATE(2008),
    [sym_for_expression] = STATE(2008),
    [sym_while_expression] = STATE(2008),
    [sym__if_branch] = STATE(6754),
    [sym_if_expression] = STATE(2008),
    [sym_fun_expression] = STATE(2008),
    [sym_try_expression] = STATE(2008),
    [sym_match_expression] = STATE(2008),
    [sym_function_expression] = STATE(2008),
    [sym_mutate_expression] = STATE(2008),
    [sym_index_expression] = STATE(2008),
    [sym_typed_expression] = STATE(2008),
    [sym_declaration_expression] = STATE(2008),
    [sym_do_expression] = STATE(2008),
    [sym_list_expression] = STATE(2008),
    [sym_array_expression] = STATE(2008),
    [sym_begin_end_expression] = STATE(2008),
    [sym_paren_expression] = STATE(2008),
    [sym__high_prec_app] = STATE(2007),
    [sym__low_prec_app] = STATE(2007),
    [sym_application_expression] = STATE(2008),
    [sym_dot_expression] = STATE(2008),
    [sym_infix_expression] = STATE(2008),
    [sym_ce_expression] = STATE(2008),
    [sym_sequential_expression] = STATE(2008),
    [sym_char] = STATE(1859),
    [sym_format_string] = STATE(1861),
    [sym__string_literal] = STATE(1861),
    [sym_string] = STATE(1859),
    [sym_verbatim_string] = STATE(1859),
    [sym_bytearray] = STATE(1859),
    [sym_verbatim_bytearray] = STATE(1859),
    [sym_format_triple_quoted_string] = STATE(1862),
    [sym_triple_quoted_string] = STATE(1859),
    [sym_const] = STATE(2008),
    [sym_long_identifier] = STATE(1701),
    [sym_active_pattern] = STATE(1702),
    [sym__identifier_or_op] = STATE(1724),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(706),
    [sym_infix_op] = STATE(678),
    [sym_sbyte] = STATE(1859),
    [sym_byte] = STATE(1859),
    [sym_int16] = STATE(1859),
    [sym_uint16] = STATE(1859),
    [sym_int32] = STATE(1859),
    [sym_uint32] = STATE(1859),
    [sym_nativeint] = STATE(1859),
    [sym_unativeint] = STATE(1859),
    [sym_int64] = STATE(1859),
    [sym_uint64] = STATE(1859),
    [sym_ieee32] = STATE(1859),
    [sym_ieee64] = STATE(1859),
    [sym_bignum] = STATE(1859),
    [sym_decimal] = STATE(1859),
    [sym_float] = STATE(1447),
    [sym_block_comment] = STATE(299),
    [sym_compiler_directive_decl] = STATE(299),
    [sym_fsi_directive_decl] = STATE(299),
    [sym_preproc_line] = STATE(299),
    [sym_preproc_if_in_expression] = STATE(2008),
    [aux_sym_sequential_expression_repeat1] = STATE(1995),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(503),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(969),
    [anon_sym_return] = ACTIONS(971),
    [anon_sym_do] = ACTIONS(599),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(511),
    [anon_sym_COMMA] = ACTIONS(973),
    [anon_sym_null] = ACTIONS(515),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(969),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(517),
    [anon_sym_LBRACK_PIPE] = ACTIONS(519),
    [anon_sym_LBRACE] = ACTIONS(521),
    [anon_sym_LT_AT] = ACTIONS(523),
    [anon_sym_LT_AT_AT] = ACTIONS(525),
    [anon_sym_DOT] = ACTIONS(527),
    [anon_sym_LBRACE_PIPE] = ACTIONS(529),
    [anon_sym_new] = ACTIONS(971),
    [anon_sym_return_BANG] = ACTIONS(975),
    [anon_sym_yield] = ACTIONS(971),
    [anon_sym_yield_BANG] = ACTIONS(975),
    [anon_sym_lazy] = ACTIONS(971),
    [anon_sym_assert] = ACTIONS(971),
    [anon_sym_upcast] = ACTIONS(971),
    [anon_sym_downcast] = ACTIONS(971),
    [anon_sym_COLON_GT] = ACTIONS(977),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(977),
    [anon_sym_for] = ACTIONS(979),
    [anon_sym_while] = ACTIONS(537),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(539),
    [anon_sym_DASH_GT] = ACTIONS(1579),
    [anon_sym_try] = ACTIONS(543),
    [anon_sym_match] = ACTIONS(545),
    [anon_sym_match_BANG] = ACTIONS(547),
    [anon_sym_function] = ACTIONS(549),
    [anon_sym_LT_DASH] = ACTIONS(981),
    [anon_sym_DOT_LBRACK] = ACTIONS(553),
    [anon_sym_LT] = ACTIONS(555),
    [anon_sym_use] = ACTIONS(983),
    [anon_sym_use_BANG] = ACTIONS(985),
    [anon_sym_do_BANG] = ACTIONS(561),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_LPAREN2] = ACTIONS(567),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(569),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(571),
    [anon_sym_DQUOTE] = ACTIONS(573),
    [anon_sym_AT_DQUOTE] = ACTIONS(575),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(577),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(579),
    [sym_bool] = ACTIONS(581),
    [sym_unit] = ACTIONS(583),
    [anon_sym_LPAREN_PIPE] = ACTIONS(585),
    [sym_op_identifier] = ACTIONS(587),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(591),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(593),
    [sym__newline] = ACTIONS(1171),
  },
  [300] = {
    [sym_function_or_value_defn] = STATE(600),
    [sym__expression] = STATE(88),
    [sym_literal_expression] = STATE(867),
    [sym_long_identifier_or_op] = STATE(867),
    [sym_tuple_expression] = STATE(867),
    [sym_brace_expression] = STATE(867),
    [sym_anon_record_expression] = STATE(867),
    [sym_prefixed_expression] = STATE(867),
    [sym_typecast_expression] = STATE(867),
    [sym_for_expression] = STATE(867),
    [sym_while_expression] = STATE(867),
    [sym__if_branch] = STATE(6511),
    [sym_if_expression] = STATE(867),
    [sym_fun_expression] = STATE(867),
    [sym_try_expression] = STATE(867),
    [sym_match_expression] = STATE(867),
    [sym_function_expression] = STATE(867),
    [sym_mutate_expression] = STATE(867),
    [sym_index_expression] = STATE(867),
    [sym_typed_expression] = STATE(867),
    [sym_declaration_expression] = STATE(867),
    [sym_do_expression] = STATE(867),
    [sym_list_expression] = STATE(867),
    [sym_array_expression] = STATE(867),
    [sym_begin_end_expression] = STATE(867),
    [sym_paren_expression] = STATE(867),
    [sym__high_prec_app] = STATE(864),
    [sym__low_prec_app] = STATE(864),
    [sym_application_expression] = STATE(867),
    [sym_dot_expression] = STATE(867),
    [sym_infix_expression] = STATE(867),
    [sym_ce_expression] = STATE(867),
    [sym_sequential_expression] = STATE(867),
    [sym_char] = STATE(868),
    [sym_format_string] = STATE(869),
    [sym__string_literal] = STATE(869),
    [sym_string] = STATE(868),
    [sym_verbatim_string] = STATE(868),
    [sym_bytearray] = STATE(868),
    [sym_verbatim_bytearray] = STATE(868),
    [sym_format_triple_quoted_string] = STATE(870),
    [sym_triple_quoted_string] = STATE(868),
    [sym_const] = STATE(867),
    [sym_long_identifier] = STATE(872),
    [sym_active_pattern] = STATE(871),
    [sym__identifier_or_op] = STATE(873),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(656),
    [sym_infix_op] = STATE(581),
    [sym_sbyte] = STATE(868),
    [sym_byte] = STATE(868),
    [sym_int16] = STATE(868),
    [sym_uint16] = STATE(868),
    [sym_int32] = STATE(868),
    [sym_uint32] = STATE(868),
    [sym_nativeint] = STATE(868),
    [sym_unativeint] = STATE(868),
    [sym_int64] = STATE(868),
    [sym_uint64] = STATE(868),
    [sym_ieee32] = STATE(868),
    [sym_ieee64] = STATE(868),
    [sym_bignum] = STATE(868),
    [sym_decimal] = STATE(868),
    [sym_float] = STATE(1368),
    [sym_block_comment] = STATE(300),
    [sym_compiler_directive_decl] = STATE(300),
    [sym_fsi_directive_decl] = STATE(300),
    [sym_preproc_line] = STATE(300),
    [sym_preproc_if_in_expression] = STATE(867),
    [aux_sym_sequential_expression_repeat1] = STATE(1542),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(29),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(825),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_COMMA] = ACTIONS(827),
    [anon_sym_null] = ACTIONS(49),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACK_PIPE] = ACTIONS(57),
    [anon_sym_LBRACE] = ACTIONS(139),
    [anon_sym_LT_AT] = ACTIONS(61),
    [anon_sym_LT_AT_AT] = ACTIONS(63),
    [anon_sym_DOT] = ACTIONS(65),
    [anon_sym_LBRACE_PIPE] = ACTIONS(67),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_return_BANG] = ACTIONS(829),
    [anon_sym_yield] = ACTIONS(825),
    [anon_sym_yield_BANG] = ACTIONS(829),
    [anon_sym_lazy] = ACTIONS(825),
    [anon_sym_assert] = ACTIONS(825),
    [anon_sym_upcast] = ACTIONS(825),
    [anon_sym_downcast] = ACTIONS(825),
    [anon_sym_COLON_GT] = ACTIONS(71),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(71),
    [anon_sym_for] = ACTIONS(73),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(79),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_match] = ACTIONS(83),
    [anon_sym_match_BANG] = ACTIONS(85),
    [anon_sym_function] = ACTIONS(87),
    [anon_sym_LT_DASH] = ACTIONS(831),
    [anon_sym_DOT_LBRACK] = ACTIONS(91),
    [anon_sym_LT] = ACTIONS(93),
    [anon_sym_use] = ACTIONS(833),
    [anon_sym_use_BANG] = ACTIONS(835),
    [anon_sym_do_BANG] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(101),
    [anon_sym_LPAREN2] = ACTIONS(103),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(105),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(107),
    [anon_sym_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DQUOTE] = ACTIONS(111),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(115),
    [sym_bool] = ACTIONS(117),
    [sym_unit] = ACTIONS(119),
    [anon_sym_LPAREN_PIPE] = ACTIONS(121),
    [sym_op_identifier] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(837),
    [sym_xint] = ACTIONS(387),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(135),
    [sym__newline] = ACTIONS(839),
    [sym__dedent] = ACTIONS(1581),
  },
  [301] = {
    [sym_function_or_value_defn] = STATE(733),
    [sym__expression] = STATE(142),
    [sym_literal_expression] = STATE(2008),
    [sym_long_identifier_or_op] = STATE(2008),
    [sym_tuple_expression] = STATE(2008),
    [sym_brace_expression] = STATE(2008),
    [sym_anon_record_expression] = STATE(2008),
    [sym_prefixed_expression] = STATE(2008),
    [sym_typecast_expression] = STATE(2008),
    [sym_for_expression] = STATE(2008),
    [sym_while_expression] = STATE(2008),
    [sym__if_branch] = STATE(6754),
    [sym_if_expression] = STATE(2008),
    [sym_fun_expression] = STATE(2008),
    [sym_try_expression] = STATE(2008),
    [sym_match_expression] = STATE(2008),
    [sym_function_expression] = STATE(2008),
    [sym_mutate_expression] = STATE(2008),
    [sym_index_expression] = STATE(2008),
    [sym_typed_expression] = STATE(2008),
    [sym_declaration_expression] = STATE(2008),
    [sym_do_expression] = STATE(2008),
    [sym_list_expression] = STATE(2008),
    [sym_array_expression] = STATE(2008),
    [sym_begin_end_expression] = STATE(2008),
    [sym_paren_expression] = STATE(2008),
    [sym__high_prec_app] = STATE(2007),
    [sym__low_prec_app] = STATE(2007),
    [sym_application_expression] = STATE(2008),
    [sym_dot_expression] = STATE(2008),
    [sym_infix_expression] = STATE(2008),
    [sym_ce_expression] = STATE(2008),
    [sym_sequential_expression] = STATE(2008),
    [sym_char] = STATE(1859),
    [sym_format_string] = STATE(1861),
    [sym__string_literal] = STATE(1861),
    [sym_string] = STATE(1859),
    [sym_verbatim_string] = STATE(1859),
    [sym_bytearray] = STATE(1859),
    [sym_verbatim_bytearray] = STATE(1859),
    [sym_format_triple_quoted_string] = STATE(1862),
    [sym_triple_quoted_string] = STATE(1859),
    [sym_const] = STATE(2008),
    [sym_long_identifier] = STATE(1701),
    [sym_active_pattern] = STATE(1702),
    [sym__identifier_or_op] = STATE(1724),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(706),
    [sym_infix_op] = STATE(678),
    [sym_sbyte] = STATE(1859),
    [sym_byte] = STATE(1859),
    [sym_int16] = STATE(1859),
    [sym_uint16] = STATE(1859),
    [sym_int32] = STATE(1859),
    [sym_uint32] = STATE(1859),
    [sym_nativeint] = STATE(1859),
    [sym_unativeint] = STATE(1859),
    [sym_int64] = STATE(1859),
    [sym_uint64] = STATE(1859),
    [sym_ieee32] = STATE(1859),
    [sym_ieee64] = STATE(1859),
    [sym_bignum] = STATE(1859),
    [sym_decimal] = STATE(1859),
    [sym_float] = STATE(1447),
    [sym_block_comment] = STATE(301),
    [sym_compiler_directive_decl] = STATE(301),
    [sym_fsi_directive_decl] = STATE(301),
    [sym_preproc_line] = STATE(301),
    [sym_preproc_if_in_expression] = STATE(2008),
    [aux_sym_sequential_expression_repeat1] = STATE(1995),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(503),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(969),
    [anon_sym_return] = ACTIONS(971),
    [anon_sym_do] = ACTIONS(599),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(511),
    [anon_sym_COMMA] = ACTIONS(973),
    [anon_sym_null] = ACTIONS(515),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(969),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(517),
    [anon_sym_LBRACK_PIPE] = ACTIONS(519),
    [anon_sym_LBRACE] = ACTIONS(521),
    [anon_sym_LT_AT] = ACTIONS(523),
    [anon_sym_LT_AT_AT] = ACTIONS(525),
    [anon_sym_DOT] = ACTIONS(527),
    [anon_sym_LBRACE_PIPE] = ACTIONS(529),
    [anon_sym_new] = ACTIONS(971),
    [anon_sym_return_BANG] = ACTIONS(975),
    [anon_sym_yield] = ACTIONS(971),
    [anon_sym_yield_BANG] = ACTIONS(975),
    [anon_sym_lazy] = ACTIONS(971),
    [anon_sym_assert] = ACTIONS(971),
    [anon_sym_upcast] = ACTIONS(971),
    [anon_sym_downcast] = ACTIONS(971),
    [anon_sym_COLON_GT] = ACTIONS(977),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(977),
    [anon_sym_for] = ACTIONS(979),
    [anon_sym_while] = ACTIONS(537),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(539),
    [anon_sym_DASH_GT] = ACTIONS(1583),
    [anon_sym_try] = ACTIONS(543),
    [anon_sym_match] = ACTIONS(545),
    [anon_sym_match_BANG] = ACTIONS(547),
    [anon_sym_function] = ACTIONS(549),
    [anon_sym_LT_DASH] = ACTIONS(981),
    [anon_sym_DOT_LBRACK] = ACTIONS(553),
    [anon_sym_LT] = ACTIONS(555),
    [anon_sym_use] = ACTIONS(983),
    [anon_sym_use_BANG] = ACTIONS(985),
    [anon_sym_do_BANG] = ACTIONS(561),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_LPAREN2] = ACTIONS(567),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(569),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(571),
    [anon_sym_DQUOTE] = ACTIONS(573),
    [anon_sym_AT_DQUOTE] = ACTIONS(575),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(577),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(579),
    [sym_bool] = ACTIONS(581),
    [sym_unit] = ACTIONS(583),
    [anon_sym_LPAREN_PIPE] = ACTIONS(585),
    [sym_op_identifier] = ACTIONS(587),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(591),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(593),
    [sym__newline] = ACTIONS(1171),
  },
  [302] = {
    [sym_function_or_value_defn] = STATE(509),
    [sym__expression] = STATE(326),
    [sym_literal_expression] = STATE(2230),
    [sym_long_identifier_or_op] = STATE(2230),
    [sym_tuple_expression] = STATE(2230),
    [sym_brace_expression] = STATE(2230),
    [sym_anon_record_expression] = STATE(2230),
    [sym_prefixed_expression] = STATE(2230),
    [sym_typecast_expression] = STATE(2230),
    [sym_for_expression] = STATE(2230),
    [sym_while_expression] = STATE(2230),
    [sym__if_branch] = STATE(6659),
    [sym_if_expression] = STATE(2230),
    [sym_fun_expression] = STATE(2230),
    [sym_try_expression] = STATE(2230),
    [sym_match_expression] = STATE(2230),
    [sym_function_expression] = STATE(2230),
    [sym_mutate_expression] = STATE(2230),
    [sym_index_expression] = STATE(2230),
    [sym_typed_expression] = STATE(2230),
    [sym_declaration_expression] = STATE(2230),
    [sym_do_expression] = STATE(2230),
    [sym_list_expression] = STATE(2230),
    [sym_array_expression] = STATE(2230),
    [sym_begin_end_expression] = STATE(2230),
    [sym_paren_expression] = STATE(2230),
    [sym__high_prec_app] = STATE(2229),
    [sym__low_prec_app] = STATE(2229),
    [sym_application_expression] = STATE(2230),
    [sym_dot_expression] = STATE(2230),
    [sym_infix_expression] = STATE(2230),
    [sym_ce_expression] = STATE(2230),
    [sym_sequential_expression] = STATE(2230),
    [sym_char] = STATE(2100),
    [sym_format_string] = STATE(2106),
    [sym__string_literal] = STATE(2106),
    [sym_string] = STATE(2100),
    [sym_verbatim_string] = STATE(2100),
    [sym_bytearray] = STATE(2100),
    [sym_verbatim_bytearray] = STATE(2100),
    [sym_format_triple_quoted_string] = STATE(2107),
    [sym_triple_quoted_string] = STATE(2100),
    [sym_const] = STATE(2230),
    [sym_long_identifier] = STATE(2232),
    [sym_active_pattern] = STATE(2424),
    [sym__identifier_or_op] = STATE(2305),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(737),
    [sym_infix_op] = STATE(694),
    [sym_sbyte] = STATE(2100),
    [sym_byte] = STATE(2100),
    [sym_int16] = STATE(2100),
    [sym_uint16] = STATE(2100),
    [sym_int32] = STATE(2100),
    [sym_uint32] = STATE(2100),
    [sym_nativeint] = STATE(2100),
    [sym_unativeint] = STATE(2100),
    [sym_int64] = STATE(2100),
    [sym_uint64] = STATE(2100),
    [sym_ieee32] = STATE(2100),
    [sym_ieee64] = STATE(2100),
    [sym_bignum] = STATE(2100),
    [sym_decimal] = STATE(2100),
    [sym_float] = STATE(1487),
    [sym_block_comment] = STATE(302),
    [sym_compiler_directive_decl] = STATE(302),
    [sym_fsi_directive_decl] = STATE(302),
    [sym_preproc_line] = STATE(302),
    [sym_preproc_if_in_expression] = STATE(2230),
    [aux_sym_sequential_expression_repeat1] = STATE(1743),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(877),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(879),
    [anon_sym_return] = ACTIONS(881),
    [anon_sym_do] = ACTIONS(1585),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(885),
    [anon_sym_COMMA] = ACTIONS(887),
    [anon_sym_null] = ACTIONS(889),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(879),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(891),
    [anon_sym_LBRACK_PIPE] = ACTIONS(893),
    [anon_sym_LBRACE] = ACTIONS(169),
    [anon_sym_LT_AT] = ACTIONS(897),
    [anon_sym_LT_AT_AT] = ACTIONS(899),
    [anon_sym_DOT] = ACTIONS(901),
    [anon_sym_LBRACE_PIPE] = ACTIONS(903),
    [anon_sym_new] = ACTIONS(881),
    [anon_sym_return_BANG] = ACTIONS(905),
    [anon_sym_yield] = ACTIONS(881),
    [anon_sym_yield_BANG] = ACTIONS(905),
    [anon_sym_lazy] = ACTIONS(881),
    [anon_sym_assert] = ACTIONS(881),
    [anon_sym_upcast] = ACTIONS(881),
    [anon_sym_downcast] = ACTIONS(881),
    [anon_sym_COLON_GT] = ACTIONS(907),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(907),
    [anon_sym_for] = ACTIONS(909),
    [anon_sym_while] = ACTIONS(911),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(913),
    [anon_sym_try] = ACTIONS(915),
    [anon_sym_match] = ACTIONS(917),
    [anon_sym_match_BANG] = ACTIONS(919),
    [anon_sym_function] = ACTIONS(921),
    [anon_sym_LT_DASH] = ACTIONS(923),
    [anon_sym_DOT_LBRACK] = ACTIONS(925),
    [anon_sym_LT] = ACTIONS(927),
    [anon_sym_use] = ACTIONS(929),
    [anon_sym_use_BANG] = ACTIONS(931),
    [anon_sym_do_BANG] = ACTIONS(933),
    [anon_sym_DOT_DOT] = ACTIONS(167),
    [anon_sym_begin] = ACTIONS(937),
    [anon_sym_LPAREN2] = ACTIONS(939),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(941),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(943),
    [anon_sym_DQUOTE] = ACTIONS(945),
    [anon_sym_AT_DQUOTE] = ACTIONS(947),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(949),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(951),
    [sym_bool] = ACTIONS(953),
    [sym_unit] = ACTIONS(955),
    [anon_sym_LPAREN_PIPE] = ACTIONS(957),
    [sym_op_identifier] = ACTIONS(959),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(961),
    [sym_xint] = ACTIONS(963),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(965),
    [sym__newline] = ACTIONS(167),
  },
  [303] = {
    [sym_function_or_value_defn] = STATE(509),
    [sym__expression] = STATE(326),
    [sym_literal_expression] = STATE(2230),
    [sym_long_identifier_or_op] = STATE(2230),
    [sym_tuple_expression] = STATE(2230),
    [sym_brace_expression] = STATE(2230),
    [sym_anon_record_expression] = STATE(2230),
    [sym_prefixed_expression] = STATE(2230),
    [sym_typecast_expression] = STATE(2230),
    [sym_for_expression] = STATE(2230),
    [sym_while_expression] = STATE(2230),
    [sym__if_branch] = STATE(6659),
    [sym_if_expression] = STATE(2230),
    [sym_fun_expression] = STATE(2230),
    [sym_try_expression] = STATE(2230),
    [sym_match_expression] = STATE(2230),
    [sym_function_expression] = STATE(2230),
    [sym_mutate_expression] = STATE(2230),
    [sym_index_expression] = STATE(2230),
    [sym_typed_expression] = STATE(2230),
    [sym_declaration_expression] = STATE(2230),
    [sym_do_expression] = STATE(2230),
    [sym_list_expression] = STATE(2230),
    [sym_array_expression] = STATE(2230),
    [sym_begin_end_expression] = STATE(2230),
    [sym_paren_expression] = STATE(2230),
    [sym__high_prec_app] = STATE(2229),
    [sym__low_prec_app] = STATE(2229),
    [sym_application_expression] = STATE(2230),
    [sym_dot_expression] = STATE(2230),
    [sym_infix_expression] = STATE(2230),
    [sym_ce_expression] = STATE(2230),
    [sym_sequential_expression] = STATE(2230),
    [sym_char] = STATE(2100),
    [sym_format_string] = STATE(2106),
    [sym__string_literal] = STATE(2106),
    [sym_string] = STATE(2100),
    [sym_verbatim_string] = STATE(2100),
    [sym_bytearray] = STATE(2100),
    [sym_verbatim_bytearray] = STATE(2100),
    [sym_format_triple_quoted_string] = STATE(2107),
    [sym_triple_quoted_string] = STATE(2100),
    [sym_const] = STATE(2230),
    [sym_long_identifier] = STATE(2232),
    [sym_active_pattern] = STATE(2424),
    [sym__identifier_or_op] = STATE(2305),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(737),
    [sym_infix_op] = STATE(694),
    [sym_sbyte] = STATE(2100),
    [sym_byte] = STATE(2100),
    [sym_int16] = STATE(2100),
    [sym_uint16] = STATE(2100),
    [sym_int32] = STATE(2100),
    [sym_uint32] = STATE(2100),
    [sym_nativeint] = STATE(2100),
    [sym_unativeint] = STATE(2100),
    [sym_int64] = STATE(2100),
    [sym_uint64] = STATE(2100),
    [sym_ieee32] = STATE(2100),
    [sym_ieee64] = STATE(2100),
    [sym_bignum] = STATE(2100),
    [sym_decimal] = STATE(2100),
    [sym_float] = STATE(1487),
    [sym_block_comment] = STATE(303),
    [sym_compiler_directive_decl] = STATE(303),
    [sym_fsi_directive_decl] = STATE(303),
    [sym_preproc_line] = STATE(303),
    [sym_preproc_if_in_expression] = STATE(2230),
    [aux_sym_sequential_expression_repeat1] = STATE(1743),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(877),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(879),
    [anon_sym_return] = ACTIONS(881),
    [anon_sym_do] = ACTIONS(1585),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(885),
    [anon_sym_COMMA] = ACTIONS(887),
    [anon_sym_null] = ACTIONS(889),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(879),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(891),
    [anon_sym_LBRACK_PIPE] = ACTIONS(893),
    [anon_sym_LBRACE] = ACTIONS(165),
    [anon_sym_LT_AT] = ACTIONS(897),
    [anon_sym_LT_AT_AT] = ACTIONS(899),
    [anon_sym_DOT] = ACTIONS(901),
    [anon_sym_LBRACE_PIPE] = ACTIONS(903),
    [anon_sym_new] = ACTIONS(881),
    [anon_sym_return_BANG] = ACTIONS(905),
    [anon_sym_yield] = ACTIONS(881),
    [anon_sym_yield_BANG] = ACTIONS(905),
    [anon_sym_lazy] = ACTIONS(881),
    [anon_sym_assert] = ACTIONS(881),
    [anon_sym_upcast] = ACTIONS(881),
    [anon_sym_downcast] = ACTIONS(881),
    [anon_sym_COLON_GT] = ACTIONS(907),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(907),
    [anon_sym_for] = ACTIONS(909),
    [anon_sym_while] = ACTIONS(911),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(913),
    [anon_sym_try] = ACTIONS(915),
    [anon_sym_match] = ACTIONS(917),
    [anon_sym_match_BANG] = ACTIONS(919),
    [anon_sym_function] = ACTIONS(921),
    [anon_sym_LT_DASH] = ACTIONS(923),
    [anon_sym_DOT_LBRACK] = ACTIONS(925),
    [anon_sym_LT] = ACTIONS(927),
    [anon_sym_use] = ACTIONS(929),
    [anon_sym_use_BANG] = ACTIONS(931),
    [anon_sym_do_BANG] = ACTIONS(933),
    [anon_sym_DOT_DOT] = ACTIONS(163),
    [anon_sym_begin] = ACTIONS(937),
    [anon_sym_LPAREN2] = ACTIONS(939),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(941),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(943),
    [anon_sym_DQUOTE] = ACTIONS(945),
    [anon_sym_AT_DQUOTE] = ACTIONS(947),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(949),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(951),
    [sym_bool] = ACTIONS(953),
    [sym_unit] = ACTIONS(955),
    [anon_sym_LPAREN_PIPE] = ACTIONS(957),
    [sym_op_identifier] = ACTIONS(959),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(961),
    [sym_xint] = ACTIONS(963),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(965),
    [sym__newline] = ACTIONS(163),
  },
  [304] = {
    [sym_function_or_value_defn] = STATE(509),
    [sym__expression] = STATE(326),
    [sym_literal_expression] = STATE(2230),
    [sym_long_identifier_or_op] = STATE(2230),
    [sym_tuple_expression] = STATE(2230),
    [sym_brace_expression] = STATE(2230),
    [sym_anon_record_expression] = STATE(2230),
    [sym_prefixed_expression] = STATE(2230),
    [sym_typecast_expression] = STATE(2230),
    [sym_for_expression] = STATE(2230),
    [sym_while_expression] = STATE(2230),
    [sym__if_branch] = STATE(6659),
    [sym_if_expression] = STATE(2230),
    [sym_fun_expression] = STATE(2230),
    [sym_try_expression] = STATE(2230),
    [sym_match_expression] = STATE(2230),
    [sym_function_expression] = STATE(2230),
    [sym_mutate_expression] = STATE(2230),
    [sym_index_expression] = STATE(2230),
    [sym_typed_expression] = STATE(2230),
    [sym_declaration_expression] = STATE(2230),
    [sym_do_expression] = STATE(2230),
    [sym_list_expression] = STATE(2230),
    [sym_array_expression] = STATE(2230),
    [sym_begin_end_expression] = STATE(2230),
    [sym_paren_expression] = STATE(2230),
    [sym__high_prec_app] = STATE(2229),
    [sym__low_prec_app] = STATE(2229),
    [sym_application_expression] = STATE(2230),
    [sym_dot_expression] = STATE(2230),
    [sym_infix_expression] = STATE(2230),
    [sym_ce_expression] = STATE(2230),
    [sym_sequential_expression] = STATE(2230),
    [sym_char] = STATE(2100),
    [sym_format_string] = STATE(2106),
    [sym__string_literal] = STATE(2106),
    [sym_string] = STATE(2100),
    [sym_verbatim_string] = STATE(2100),
    [sym_bytearray] = STATE(2100),
    [sym_verbatim_bytearray] = STATE(2100),
    [sym_format_triple_quoted_string] = STATE(2107),
    [sym_triple_quoted_string] = STATE(2100),
    [sym_const] = STATE(2230),
    [sym_long_identifier] = STATE(2232),
    [sym_active_pattern] = STATE(2424),
    [sym__identifier_or_op] = STATE(2305),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(737),
    [sym_infix_op] = STATE(694),
    [sym_sbyte] = STATE(2100),
    [sym_byte] = STATE(2100),
    [sym_int16] = STATE(2100),
    [sym_uint16] = STATE(2100),
    [sym_int32] = STATE(2100),
    [sym_uint32] = STATE(2100),
    [sym_nativeint] = STATE(2100),
    [sym_unativeint] = STATE(2100),
    [sym_int64] = STATE(2100),
    [sym_uint64] = STATE(2100),
    [sym_ieee32] = STATE(2100),
    [sym_ieee64] = STATE(2100),
    [sym_bignum] = STATE(2100),
    [sym_decimal] = STATE(2100),
    [sym_float] = STATE(1487),
    [sym_block_comment] = STATE(304),
    [sym_compiler_directive_decl] = STATE(304),
    [sym_fsi_directive_decl] = STATE(304),
    [sym_preproc_line] = STATE(304),
    [sym_preproc_if_in_expression] = STATE(2230),
    [aux_sym_sequential_expression_repeat1] = STATE(1743),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(877),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(879),
    [anon_sym_return] = ACTIONS(881),
    [anon_sym_do] = ACTIONS(1587),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(885),
    [anon_sym_COMMA] = ACTIONS(887),
    [anon_sym_null] = ACTIONS(889),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(879),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(891),
    [anon_sym_LBRACK_PIPE] = ACTIONS(893),
    [anon_sym_LBRACE] = ACTIONS(895),
    [anon_sym_LT_AT] = ACTIONS(897),
    [anon_sym_LT_AT_AT] = ACTIONS(899),
    [anon_sym_DOT] = ACTIONS(901),
    [anon_sym_LBRACE_PIPE] = ACTIONS(903),
    [anon_sym_new] = ACTIONS(881),
    [anon_sym_return_BANG] = ACTIONS(905),
    [anon_sym_yield] = ACTIONS(881),
    [anon_sym_yield_BANG] = ACTIONS(905),
    [anon_sym_lazy] = ACTIONS(881),
    [anon_sym_assert] = ACTIONS(881),
    [anon_sym_upcast] = ACTIONS(881),
    [anon_sym_downcast] = ACTIONS(881),
    [anon_sym_COLON_GT] = ACTIONS(907),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(907),
    [anon_sym_for] = ACTIONS(909),
    [anon_sym_while] = ACTIONS(911),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(913),
    [anon_sym_try] = ACTIONS(915),
    [anon_sym_match] = ACTIONS(917),
    [anon_sym_match_BANG] = ACTIONS(919),
    [anon_sym_function] = ACTIONS(921),
    [anon_sym_LT_DASH] = ACTIONS(923),
    [anon_sym_DOT_LBRACK] = ACTIONS(925),
    [anon_sym_LT] = ACTIONS(927),
    [anon_sym_use] = ACTIONS(929),
    [anon_sym_use_BANG] = ACTIONS(931),
    [anon_sym_do_BANG] = ACTIONS(933),
    [anon_sym_DOT_DOT] = ACTIONS(935),
    [anon_sym_begin] = ACTIONS(937),
    [anon_sym_LPAREN2] = ACTIONS(939),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(941),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(943),
    [anon_sym_DQUOTE] = ACTIONS(945),
    [anon_sym_AT_DQUOTE] = ACTIONS(947),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(949),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(951),
    [sym_bool] = ACTIONS(953),
    [sym_unit] = ACTIONS(955),
    [anon_sym_LPAREN_PIPE] = ACTIONS(957),
    [sym_op_identifier] = ACTIONS(959),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(961),
    [sym_xint] = ACTIONS(963),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(965),
    [sym__newline] = ACTIONS(967),
  },
  [305] = {
    [sym_function_or_value_defn] = STATE(509),
    [sym__expression] = STATE(326),
    [sym_literal_expression] = STATE(2230),
    [sym_long_identifier_or_op] = STATE(2230),
    [sym_tuple_expression] = STATE(2230),
    [sym_brace_expression] = STATE(2230),
    [sym_anon_record_expression] = STATE(2230),
    [sym_prefixed_expression] = STATE(2230),
    [sym_typecast_expression] = STATE(2230),
    [sym_for_expression] = STATE(2230),
    [sym_while_expression] = STATE(2230),
    [sym__if_branch] = STATE(6659),
    [sym_if_expression] = STATE(2230),
    [sym_fun_expression] = STATE(2230),
    [sym_try_expression] = STATE(2230),
    [sym_match_expression] = STATE(2230),
    [sym_function_expression] = STATE(2230),
    [sym_mutate_expression] = STATE(2230),
    [sym_index_expression] = STATE(2230),
    [sym_typed_expression] = STATE(2230),
    [sym_declaration_expression] = STATE(2230),
    [sym_do_expression] = STATE(2230),
    [sym_list_expression] = STATE(2230),
    [sym_array_expression] = STATE(2230),
    [sym_begin_end_expression] = STATE(2230),
    [sym_paren_expression] = STATE(2230),
    [sym__high_prec_app] = STATE(2229),
    [sym__low_prec_app] = STATE(2229),
    [sym_application_expression] = STATE(2230),
    [sym_dot_expression] = STATE(2230),
    [sym_infix_expression] = STATE(2230),
    [sym_ce_expression] = STATE(2230),
    [sym_sequential_expression] = STATE(2230),
    [sym_char] = STATE(2100),
    [sym_format_string] = STATE(2106),
    [sym__string_literal] = STATE(2106),
    [sym_string] = STATE(2100),
    [sym_verbatim_string] = STATE(2100),
    [sym_bytearray] = STATE(2100),
    [sym_verbatim_bytearray] = STATE(2100),
    [sym_format_triple_quoted_string] = STATE(2107),
    [sym_triple_quoted_string] = STATE(2100),
    [sym_const] = STATE(2230),
    [sym_long_identifier] = STATE(2232),
    [sym_active_pattern] = STATE(2424),
    [sym__identifier_or_op] = STATE(2305),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(737),
    [sym_infix_op] = STATE(694),
    [sym_sbyte] = STATE(2100),
    [sym_byte] = STATE(2100),
    [sym_int16] = STATE(2100),
    [sym_uint16] = STATE(2100),
    [sym_int32] = STATE(2100),
    [sym_uint32] = STATE(2100),
    [sym_nativeint] = STATE(2100),
    [sym_unativeint] = STATE(2100),
    [sym_int64] = STATE(2100),
    [sym_uint64] = STATE(2100),
    [sym_ieee32] = STATE(2100),
    [sym_ieee64] = STATE(2100),
    [sym_bignum] = STATE(2100),
    [sym_decimal] = STATE(2100),
    [sym_float] = STATE(1487),
    [sym_block_comment] = STATE(305),
    [sym_compiler_directive_decl] = STATE(305),
    [sym_fsi_directive_decl] = STATE(305),
    [sym_preproc_line] = STATE(305),
    [sym_preproc_if_in_expression] = STATE(2230),
    [aux_sym_sequential_expression_repeat1] = STATE(1743),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(877),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(879),
    [anon_sym_return] = ACTIONS(881),
    [anon_sym_do] = ACTIONS(1589),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(885),
    [anon_sym_COMMA] = ACTIONS(887),
    [anon_sym_null] = ACTIONS(889),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(879),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(891),
    [anon_sym_LBRACK_PIPE] = ACTIONS(893),
    [anon_sym_LBRACE] = ACTIONS(895),
    [anon_sym_LT_AT] = ACTIONS(897),
    [anon_sym_LT_AT_AT] = ACTIONS(899),
    [anon_sym_DOT] = ACTIONS(901),
    [anon_sym_LBRACE_PIPE] = ACTIONS(903),
    [anon_sym_new] = ACTIONS(881),
    [anon_sym_return_BANG] = ACTIONS(905),
    [anon_sym_yield] = ACTIONS(881),
    [anon_sym_yield_BANG] = ACTIONS(905),
    [anon_sym_lazy] = ACTIONS(881),
    [anon_sym_assert] = ACTIONS(881),
    [anon_sym_upcast] = ACTIONS(881),
    [anon_sym_downcast] = ACTIONS(881),
    [anon_sym_COLON_GT] = ACTIONS(907),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(907),
    [anon_sym_for] = ACTIONS(909),
    [anon_sym_while] = ACTIONS(911),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(913),
    [anon_sym_try] = ACTIONS(915),
    [anon_sym_match] = ACTIONS(917),
    [anon_sym_match_BANG] = ACTIONS(919),
    [anon_sym_function] = ACTIONS(921),
    [anon_sym_LT_DASH] = ACTIONS(923),
    [anon_sym_DOT_LBRACK] = ACTIONS(925),
    [anon_sym_LT] = ACTIONS(927),
    [anon_sym_use] = ACTIONS(929),
    [anon_sym_use_BANG] = ACTIONS(931),
    [anon_sym_do_BANG] = ACTIONS(933),
    [anon_sym_DOT_DOT] = ACTIONS(935),
    [anon_sym_begin] = ACTIONS(937),
    [anon_sym_LPAREN2] = ACTIONS(939),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(941),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(943),
    [anon_sym_DQUOTE] = ACTIONS(945),
    [anon_sym_AT_DQUOTE] = ACTIONS(947),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(949),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(951),
    [sym_bool] = ACTIONS(953),
    [sym_unit] = ACTIONS(955),
    [anon_sym_LPAREN_PIPE] = ACTIONS(957),
    [sym_op_identifier] = ACTIONS(959),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(961),
    [sym_xint] = ACTIONS(963),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(965),
    [sym__newline] = ACTIONS(967),
  },
  [306] = {
    [sym_function_or_value_defn] = STATE(600),
    [sym__expression] = STATE(88),
    [sym_literal_expression] = STATE(867),
    [sym_long_identifier_or_op] = STATE(867),
    [sym_tuple_expression] = STATE(867),
    [sym_brace_expression] = STATE(867),
    [sym_anon_record_expression] = STATE(867),
    [sym_prefixed_expression] = STATE(867),
    [sym_typecast_expression] = STATE(867),
    [sym_for_expression] = STATE(867),
    [sym_while_expression] = STATE(867),
    [sym__if_branch] = STATE(6511),
    [sym_if_expression] = STATE(867),
    [sym_fun_expression] = STATE(867),
    [sym_try_expression] = STATE(867),
    [sym_match_expression] = STATE(867),
    [sym_function_expression] = STATE(867),
    [sym_mutate_expression] = STATE(867),
    [sym_index_expression] = STATE(867),
    [sym_typed_expression] = STATE(867),
    [sym_declaration_expression] = STATE(867),
    [sym_do_expression] = STATE(867),
    [sym_list_expression] = STATE(867),
    [sym_array_expression] = STATE(867),
    [sym_begin_end_expression] = STATE(867),
    [sym_paren_expression] = STATE(867),
    [sym__high_prec_app] = STATE(864),
    [sym__low_prec_app] = STATE(864),
    [sym_application_expression] = STATE(867),
    [sym_dot_expression] = STATE(867),
    [sym_infix_expression] = STATE(867),
    [sym_ce_expression] = STATE(867),
    [sym_sequential_expression] = STATE(867),
    [sym_char] = STATE(868),
    [sym_format_string] = STATE(869),
    [sym__string_literal] = STATE(869),
    [sym_string] = STATE(868),
    [sym_verbatim_string] = STATE(868),
    [sym_bytearray] = STATE(868),
    [sym_verbatim_bytearray] = STATE(868),
    [sym_format_triple_quoted_string] = STATE(870),
    [sym_triple_quoted_string] = STATE(868),
    [sym_const] = STATE(867),
    [sym_long_identifier] = STATE(872),
    [sym_active_pattern] = STATE(871),
    [sym__identifier_or_op] = STATE(873),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(656),
    [sym_infix_op] = STATE(581),
    [sym_sbyte] = STATE(868),
    [sym_byte] = STATE(868),
    [sym_int16] = STATE(868),
    [sym_uint16] = STATE(868),
    [sym_int32] = STATE(868),
    [sym_uint32] = STATE(868),
    [sym_nativeint] = STATE(868),
    [sym_unativeint] = STATE(868),
    [sym_int64] = STATE(868),
    [sym_uint64] = STATE(868),
    [sym_ieee32] = STATE(868),
    [sym_ieee64] = STATE(868),
    [sym_bignum] = STATE(868),
    [sym_decimal] = STATE(868),
    [sym_float] = STATE(1368),
    [sym_block_comment] = STATE(306),
    [sym_compiler_directive_decl] = STATE(306),
    [sym_fsi_directive_decl] = STATE(306),
    [sym_preproc_line] = STATE(306),
    [sym_preproc_if_in_expression] = STATE(867),
    [aux_sym_sequential_expression_repeat1] = STATE(1542),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(29),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(825),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_COMMA] = ACTIONS(827),
    [anon_sym_null] = ACTIONS(49),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACK_PIPE] = ACTIONS(57),
    [anon_sym_LBRACE] = ACTIONS(139),
    [anon_sym_LT_AT] = ACTIONS(61),
    [anon_sym_LT_AT_AT] = ACTIONS(63),
    [anon_sym_DOT] = ACTIONS(65),
    [anon_sym_LBRACE_PIPE] = ACTIONS(67),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_return_BANG] = ACTIONS(829),
    [anon_sym_yield] = ACTIONS(825),
    [anon_sym_yield_BANG] = ACTIONS(829),
    [anon_sym_lazy] = ACTIONS(825),
    [anon_sym_assert] = ACTIONS(825),
    [anon_sym_upcast] = ACTIONS(825),
    [anon_sym_downcast] = ACTIONS(825),
    [anon_sym_COLON_GT] = ACTIONS(71),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(71),
    [anon_sym_for] = ACTIONS(73),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(79),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_match] = ACTIONS(83),
    [anon_sym_match_BANG] = ACTIONS(85),
    [anon_sym_function] = ACTIONS(87),
    [anon_sym_LT_DASH] = ACTIONS(831),
    [anon_sym_DOT_LBRACK] = ACTIONS(91),
    [anon_sym_LT] = ACTIONS(93),
    [anon_sym_use] = ACTIONS(833),
    [anon_sym_use_BANG] = ACTIONS(835),
    [anon_sym_do_BANG] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(101),
    [anon_sym_LPAREN2] = ACTIONS(103),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(105),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(107),
    [anon_sym_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DQUOTE] = ACTIONS(111),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(115),
    [sym_bool] = ACTIONS(117),
    [sym_unit] = ACTIONS(119),
    [anon_sym_LPAREN_PIPE] = ACTIONS(121),
    [sym_op_identifier] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(837),
    [sym_xint] = ACTIONS(387),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(135),
    [sym__newline] = ACTIONS(839),
    [sym__dedent] = ACTIONS(1591),
  },
  [307] = {
    [sym_function_or_value_defn] = STATE(627),
    [sym__expression] = STATE(17),
    [sym_literal_expression] = STATE(1118),
    [sym_long_identifier_or_op] = STATE(1118),
    [sym_tuple_expression] = STATE(1118),
    [sym_brace_expression] = STATE(1118),
    [sym_anon_record_expression] = STATE(1118),
    [sym_prefixed_expression] = STATE(1118),
    [sym_typecast_expression] = STATE(1118),
    [sym_for_expression] = STATE(1118),
    [sym_while_expression] = STATE(1118),
    [sym__if_branch] = STATE(7163),
    [sym_if_expression] = STATE(1118),
    [sym_fun_expression] = STATE(1118),
    [sym_try_expression] = STATE(1118),
    [sym_match_expression] = STATE(1118),
    [sym_function_expression] = STATE(1118),
    [sym_mutate_expression] = STATE(1118),
    [sym_index_expression] = STATE(1118),
    [sym_typed_expression] = STATE(1118),
    [sym_declaration_expression] = STATE(1118),
    [sym_do_expression] = STATE(1118),
    [sym_list_expression] = STATE(1118),
    [sym_array_expression] = STATE(1118),
    [sym_begin_end_expression] = STATE(1118),
    [sym_paren_expression] = STATE(1118),
    [sym__high_prec_app] = STATE(1133),
    [sym__low_prec_app] = STATE(1133),
    [sym_application_expression] = STATE(1118),
    [sym_dot_expression] = STATE(1118),
    [sym_infix_expression] = STATE(1118),
    [sym_ce_expression] = STATE(1118),
    [sym_sequential_expression] = STATE(1118),
    [sym_char] = STATE(1080),
    [sym_format_string] = STATE(1090),
    [sym__string_literal] = STATE(1090),
    [sym_string] = STATE(1080),
    [sym_verbatim_string] = STATE(1080),
    [sym_bytearray] = STATE(1080),
    [sym_verbatim_bytearray] = STATE(1080),
    [sym_format_triple_quoted_string] = STATE(1096),
    [sym_triple_quoted_string] = STATE(1080),
    [sym_const] = STATE(1118),
    [sym_long_identifier] = STATE(1156),
    [sym_active_pattern] = STATE(1085),
    [sym__identifier_or_op] = STATE(1099),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(517),
    [sym_infix_op] = STATE(487),
    [sym_sbyte] = STATE(1080),
    [sym_byte] = STATE(1080),
    [sym_int16] = STATE(1080),
    [sym_uint16] = STATE(1080),
    [sym_int32] = STATE(1080),
    [sym_uint32] = STATE(1080),
    [sym_nativeint] = STATE(1080),
    [sym_unativeint] = STATE(1080),
    [sym_int64] = STATE(1080),
    [sym_uint64] = STATE(1080),
    [sym_ieee32] = STATE(1080),
    [sym_ieee64] = STATE(1080),
    [sym_bignum] = STATE(1080),
    [sym_decimal] = STATE(1080),
    [sym_float] = STATE(979),
    [sym_block_comment] = STATE(307),
    [sym_compiler_directive_decl] = STATE(307),
    [sym_fsi_directive_decl] = STATE(307),
    [sym_preproc_line] = STATE(307),
    [sym_preproc_if_in_expression] = STATE(1118),
    [aux_sym_sequential_expression_repeat1] = STATE(1069),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(195),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(197),
    [anon_sym_return] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_COMMA] = ACTIONS(205),
    [anon_sym_null] = ACTIONS(207),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(197),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(209),
    [anon_sym_LBRACK_PIPE] = ACTIONS(211),
    [anon_sym_LBRACE] = ACTIONS(271),
    [anon_sym_LT_AT] = ACTIONS(213),
    [anon_sym_LT_AT_AT] = ACTIONS(215),
    [anon_sym_DOT] = ACTIONS(185),
    [anon_sym_LBRACE_PIPE] = ACTIONS(217),
    [anon_sym_new] = ACTIONS(199),
    [anon_sym_with] = ACTIONS(847),
    [anon_sym_return_BANG] = ACTIONS(219),
    [anon_sym_yield] = ACTIONS(199),
    [anon_sym_yield_BANG] = ACTIONS(219),
    [anon_sym_lazy] = ACTIONS(199),
    [anon_sym_assert] = ACTIONS(199),
    [anon_sym_upcast] = ACTIONS(199),
    [anon_sym_downcast] = ACTIONS(199),
    [anon_sym_COLON_GT] = ACTIONS(221),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(221),
    [anon_sym_for] = ACTIONS(223),
    [anon_sym_while] = ACTIONS(225),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(229),
    [anon_sym_match] = ACTIONS(231),
    [anon_sym_match_BANG] = ACTIONS(233),
    [anon_sym_function] = ACTIONS(235),
    [anon_sym_LT_DASH] = ACTIONS(237),
    [anon_sym_DOT_LBRACK] = ACTIONS(187),
    [anon_sym_LT] = ACTIONS(189),
    [anon_sym_use] = ACTIONS(239),
    [anon_sym_use_BANG] = ACTIONS(241),
    [anon_sym_do_BANG] = ACTIONS(243),
    [anon_sym_begin] = ACTIONS(245),
    [anon_sym_LPAREN2] = ACTIONS(191),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(247),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(251),
    [anon_sym_AT_DQUOTE] = ACTIONS(253),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(255),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(257),
    [sym_bool] = ACTIONS(259),
    [sym_unit] = ACTIONS(193),
    [anon_sym_LPAREN_PIPE] = ACTIONS(261),
    [sym_op_identifier] = ACTIONS(263),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(265),
    [sym_xint] = ACTIONS(267),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(269),
    [sym__newline] = ACTIONS(273),
  },
  [308] = {
    [sym_function_or_value_defn] = STATE(600),
    [sym__expression] = STATE(88),
    [sym_literal_expression] = STATE(867),
    [sym_long_identifier_or_op] = STATE(867),
    [sym_tuple_expression] = STATE(867),
    [sym_brace_expression] = STATE(867),
    [sym_anon_record_expression] = STATE(867),
    [sym_prefixed_expression] = STATE(867),
    [sym_typecast_expression] = STATE(867),
    [sym_for_expression] = STATE(867),
    [sym_while_expression] = STATE(867),
    [sym__if_branch] = STATE(6511),
    [sym_if_expression] = STATE(867),
    [sym_fun_expression] = STATE(867),
    [sym_try_expression] = STATE(867),
    [sym_match_expression] = STATE(867),
    [sym_function_expression] = STATE(867),
    [sym_mutate_expression] = STATE(867),
    [sym_index_expression] = STATE(867),
    [sym_typed_expression] = STATE(867),
    [sym_declaration_expression] = STATE(867),
    [sym_do_expression] = STATE(867),
    [sym_list_expression] = STATE(867),
    [sym_array_expression] = STATE(867),
    [sym_begin_end_expression] = STATE(867),
    [sym_paren_expression] = STATE(867),
    [sym__high_prec_app] = STATE(864),
    [sym__low_prec_app] = STATE(864),
    [sym_application_expression] = STATE(867),
    [sym_dot_expression] = STATE(867),
    [sym_infix_expression] = STATE(867),
    [sym_ce_expression] = STATE(867),
    [sym_sequential_expression] = STATE(867),
    [sym_char] = STATE(868),
    [sym_format_string] = STATE(869),
    [sym__string_literal] = STATE(869),
    [sym_string] = STATE(868),
    [sym_verbatim_string] = STATE(868),
    [sym_bytearray] = STATE(868),
    [sym_verbatim_bytearray] = STATE(868),
    [sym_format_triple_quoted_string] = STATE(870),
    [sym_triple_quoted_string] = STATE(868),
    [sym_const] = STATE(867),
    [sym_long_identifier] = STATE(872),
    [sym_active_pattern] = STATE(871),
    [sym__identifier_or_op] = STATE(873),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(656),
    [sym_infix_op] = STATE(581),
    [sym_sbyte] = STATE(868),
    [sym_byte] = STATE(868),
    [sym_int16] = STATE(868),
    [sym_uint16] = STATE(868),
    [sym_int32] = STATE(868),
    [sym_uint32] = STATE(868),
    [sym_nativeint] = STATE(868),
    [sym_unativeint] = STATE(868),
    [sym_int64] = STATE(868),
    [sym_uint64] = STATE(868),
    [sym_ieee32] = STATE(868),
    [sym_ieee64] = STATE(868),
    [sym_bignum] = STATE(868),
    [sym_decimal] = STATE(868),
    [sym_float] = STATE(1368),
    [sym_block_comment] = STATE(308),
    [sym_compiler_directive_decl] = STATE(308),
    [sym_fsi_directive_decl] = STATE(308),
    [sym_preproc_line] = STATE(308),
    [sym_preproc_if_in_expression] = STATE(867),
    [aux_sym_sequential_expression_repeat1] = STATE(1542),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(29),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(825),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_COMMA] = ACTIONS(827),
    [anon_sym_null] = ACTIONS(49),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACK_PIPE] = ACTIONS(57),
    [anon_sym_LBRACE] = ACTIONS(139),
    [anon_sym_LT_AT] = ACTIONS(61),
    [anon_sym_LT_AT_AT] = ACTIONS(63),
    [anon_sym_DOT] = ACTIONS(65),
    [anon_sym_LBRACE_PIPE] = ACTIONS(67),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_return_BANG] = ACTIONS(829),
    [anon_sym_yield] = ACTIONS(825),
    [anon_sym_yield_BANG] = ACTIONS(829),
    [anon_sym_lazy] = ACTIONS(825),
    [anon_sym_assert] = ACTIONS(825),
    [anon_sym_upcast] = ACTIONS(825),
    [anon_sym_downcast] = ACTIONS(825),
    [anon_sym_COLON_GT] = ACTIONS(71),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(71),
    [anon_sym_for] = ACTIONS(73),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(79),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_match] = ACTIONS(83),
    [anon_sym_match_BANG] = ACTIONS(85),
    [anon_sym_function] = ACTIONS(87),
    [anon_sym_LT_DASH] = ACTIONS(831),
    [anon_sym_DOT_LBRACK] = ACTIONS(91),
    [anon_sym_LT] = ACTIONS(93),
    [anon_sym_use] = ACTIONS(833),
    [anon_sym_use_BANG] = ACTIONS(835),
    [anon_sym_do_BANG] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(101),
    [anon_sym_LPAREN2] = ACTIONS(103),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(105),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(107),
    [anon_sym_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DQUOTE] = ACTIONS(111),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(115),
    [sym_bool] = ACTIONS(117),
    [sym_unit] = ACTIONS(119),
    [anon_sym_LPAREN_PIPE] = ACTIONS(121),
    [sym_op_identifier] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(837),
    [sym_xint] = ACTIONS(387),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(135),
    [sym__newline] = ACTIONS(839),
    [sym__dedent] = ACTIONS(1593),
  },
  [309] = {
    [sym_function_or_value_defn] = STATE(509),
    [sym__expression] = STATE(326),
    [sym_literal_expression] = STATE(2230),
    [sym_long_identifier_or_op] = STATE(2230),
    [sym_tuple_expression] = STATE(2230),
    [sym_brace_expression] = STATE(2230),
    [sym_anon_record_expression] = STATE(2230),
    [sym_prefixed_expression] = STATE(2230),
    [sym_typecast_expression] = STATE(2230),
    [sym_for_expression] = STATE(2230),
    [sym_while_expression] = STATE(2230),
    [sym__if_branch] = STATE(6659),
    [sym_if_expression] = STATE(2230),
    [sym_fun_expression] = STATE(2230),
    [sym_try_expression] = STATE(2230),
    [sym_match_expression] = STATE(2230),
    [sym_function_expression] = STATE(2230),
    [sym_mutate_expression] = STATE(2230),
    [sym_index_expression] = STATE(2230),
    [sym_typed_expression] = STATE(2230),
    [sym_declaration_expression] = STATE(2230),
    [sym_do_expression] = STATE(2230),
    [sym_list_expression] = STATE(2230),
    [sym_array_expression] = STATE(2230),
    [sym_begin_end_expression] = STATE(2230),
    [sym_paren_expression] = STATE(2230),
    [sym__high_prec_app] = STATE(2229),
    [sym__low_prec_app] = STATE(2229),
    [sym_application_expression] = STATE(2230),
    [sym_dot_expression] = STATE(2230),
    [sym_infix_expression] = STATE(2230),
    [sym_ce_expression] = STATE(2230),
    [sym_sequential_expression] = STATE(2230),
    [sym_char] = STATE(2100),
    [sym_format_string] = STATE(2106),
    [sym__string_literal] = STATE(2106),
    [sym_string] = STATE(2100),
    [sym_verbatim_string] = STATE(2100),
    [sym_bytearray] = STATE(2100),
    [sym_verbatim_bytearray] = STATE(2100),
    [sym_format_triple_quoted_string] = STATE(2107),
    [sym_triple_quoted_string] = STATE(2100),
    [sym_const] = STATE(2230),
    [sym_long_identifier] = STATE(2232),
    [sym_active_pattern] = STATE(2424),
    [sym__identifier_or_op] = STATE(2305),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(737),
    [sym_infix_op] = STATE(694),
    [sym_sbyte] = STATE(2100),
    [sym_byte] = STATE(2100),
    [sym_int16] = STATE(2100),
    [sym_uint16] = STATE(2100),
    [sym_int32] = STATE(2100),
    [sym_uint32] = STATE(2100),
    [sym_nativeint] = STATE(2100),
    [sym_unativeint] = STATE(2100),
    [sym_int64] = STATE(2100),
    [sym_uint64] = STATE(2100),
    [sym_ieee32] = STATE(2100),
    [sym_ieee64] = STATE(2100),
    [sym_bignum] = STATE(2100),
    [sym_decimal] = STATE(2100),
    [sym_float] = STATE(1487),
    [sym_block_comment] = STATE(309),
    [sym_compiler_directive_decl] = STATE(309),
    [sym_fsi_directive_decl] = STATE(309),
    [sym_preproc_line] = STATE(309),
    [sym_preproc_if_in_expression] = STATE(2230),
    [aux_sym_sequential_expression_repeat1] = STATE(1743),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(877),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(879),
    [anon_sym_return] = ACTIONS(881),
    [anon_sym_do] = ACTIONS(1585),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(885),
    [anon_sym_COMMA] = ACTIONS(887),
    [anon_sym_null] = ACTIONS(889),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(879),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(891),
    [anon_sym_LBRACK_PIPE] = ACTIONS(893),
    [anon_sym_LBRACE] = ACTIONS(895),
    [anon_sym_LT_AT] = ACTIONS(897),
    [anon_sym_LT_AT_AT] = ACTIONS(899),
    [anon_sym_DOT] = ACTIONS(901),
    [anon_sym_LBRACE_PIPE] = ACTIONS(903),
    [anon_sym_new] = ACTIONS(881),
    [anon_sym_return_BANG] = ACTIONS(905),
    [anon_sym_yield] = ACTIONS(881),
    [anon_sym_yield_BANG] = ACTIONS(905),
    [anon_sym_lazy] = ACTIONS(881),
    [anon_sym_assert] = ACTIONS(881),
    [anon_sym_upcast] = ACTIONS(881),
    [anon_sym_downcast] = ACTIONS(881),
    [anon_sym_COLON_GT] = ACTIONS(907),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(907),
    [anon_sym_for] = ACTIONS(909),
    [anon_sym_while] = ACTIONS(911),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(913),
    [anon_sym_try] = ACTIONS(915),
    [anon_sym_match] = ACTIONS(917),
    [anon_sym_match_BANG] = ACTIONS(919),
    [anon_sym_function] = ACTIONS(921),
    [anon_sym_LT_DASH] = ACTIONS(923),
    [anon_sym_DOT_LBRACK] = ACTIONS(925),
    [anon_sym_LT] = ACTIONS(927),
    [anon_sym_use] = ACTIONS(929),
    [anon_sym_use_BANG] = ACTIONS(931),
    [anon_sym_do_BANG] = ACTIONS(933),
    [anon_sym_DOT_DOT] = ACTIONS(171),
    [anon_sym_begin] = ACTIONS(937),
    [anon_sym_LPAREN2] = ACTIONS(939),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(941),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(943),
    [anon_sym_DQUOTE] = ACTIONS(945),
    [anon_sym_AT_DQUOTE] = ACTIONS(947),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(949),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(951),
    [sym_bool] = ACTIONS(953),
    [sym_unit] = ACTIONS(955),
    [anon_sym_LPAREN_PIPE] = ACTIONS(957),
    [sym_op_identifier] = ACTIONS(959),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(961),
    [sym_xint] = ACTIONS(963),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(965),
    [sym__newline] = ACTIONS(967),
  },
  [310] = {
    [sym_function_or_value_defn] = STATE(627),
    [sym__expression] = STATE(17),
    [sym_literal_expression] = STATE(1118),
    [sym_long_identifier_or_op] = STATE(1118),
    [sym_tuple_expression] = STATE(1118),
    [sym_brace_expression] = STATE(1118),
    [sym_anon_record_expression] = STATE(1118),
    [sym_prefixed_expression] = STATE(1118),
    [sym_typecast_expression] = STATE(1118),
    [sym_for_expression] = STATE(1118),
    [sym_while_expression] = STATE(1118),
    [sym__if_branch] = STATE(7163),
    [sym_if_expression] = STATE(1118),
    [sym_fun_expression] = STATE(1118),
    [sym_try_expression] = STATE(1118),
    [sym_match_expression] = STATE(1118),
    [sym_function_expression] = STATE(1118),
    [sym_mutate_expression] = STATE(1118),
    [sym_index_expression] = STATE(1118),
    [sym_typed_expression] = STATE(1118),
    [sym_declaration_expression] = STATE(1118),
    [sym_do_expression] = STATE(1118),
    [sym_list_expression] = STATE(1118),
    [sym_array_expression] = STATE(1118),
    [sym_begin_end_expression] = STATE(1118),
    [sym_paren_expression] = STATE(1118),
    [sym__high_prec_app] = STATE(1133),
    [sym__low_prec_app] = STATE(1133),
    [sym_application_expression] = STATE(1118),
    [sym_dot_expression] = STATE(1118),
    [sym_infix_expression] = STATE(1118),
    [sym_ce_expression] = STATE(1118),
    [sym_sequential_expression] = STATE(1118),
    [sym_char] = STATE(1080),
    [sym_format_string] = STATE(1090),
    [sym__string_literal] = STATE(1090),
    [sym_string] = STATE(1080),
    [sym_verbatim_string] = STATE(1080),
    [sym_bytearray] = STATE(1080),
    [sym_verbatim_bytearray] = STATE(1080),
    [sym_format_triple_quoted_string] = STATE(1096),
    [sym_triple_quoted_string] = STATE(1080),
    [sym_const] = STATE(1118),
    [sym_long_identifier] = STATE(1156),
    [sym_active_pattern] = STATE(1085),
    [sym__identifier_or_op] = STATE(1099),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(517),
    [sym_infix_op] = STATE(487),
    [sym_sbyte] = STATE(1080),
    [sym_byte] = STATE(1080),
    [sym_int16] = STATE(1080),
    [sym_uint16] = STATE(1080),
    [sym_int32] = STATE(1080),
    [sym_uint32] = STATE(1080),
    [sym_nativeint] = STATE(1080),
    [sym_unativeint] = STATE(1080),
    [sym_int64] = STATE(1080),
    [sym_uint64] = STATE(1080),
    [sym_ieee32] = STATE(1080),
    [sym_ieee64] = STATE(1080),
    [sym_bignum] = STATE(1080),
    [sym_decimal] = STATE(1080),
    [sym_float] = STATE(979),
    [sym_block_comment] = STATE(310),
    [sym_compiler_directive_decl] = STATE(310),
    [sym_fsi_directive_decl] = STATE(310),
    [sym_preproc_line] = STATE(310),
    [sym_preproc_if_in_expression] = STATE(1118),
    [aux_sym_sequential_expression_repeat1] = STATE(1069),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(195),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(197),
    [anon_sym_return] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_COMMA] = ACTIONS(205),
    [anon_sym_null] = ACTIONS(207),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(197),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(209),
    [anon_sym_LBRACK_PIPE] = ACTIONS(211),
    [anon_sym_LBRACE] = ACTIONS(271),
    [anon_sym_RBRACE] = ACTIONS(1595),
    [anon_sym_LT_AT] = ACTIONS(213),
    [anon_sym_LT_AT_AT] = ACTIONS(215),
    [anon_sym_DOT] = ACTIONS(185),
    [anon_sym_LBRACE_PIPE] = ACTIONS(217),
    [anon_sym_new] = ACTIONS(199),
    [anon_sym_return_BANG] = ACTIONS(219),
    [anon_sym_yield] = ACTIONS(199),
    [anon_sym_yield_BANG] = ACTIONS(219),
    [anon_sym_lazy] = ACTIONS(199),
    [anon_sym_assert] = ACTIONS(199),
    [anon_sym_upcast] = ACTIONS(199),
    [anon_sym_downcast] = ACTIONS(199),
    [anon_sym_COLON_GT] = ACTIONS(221),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(221),
    [anon_sym_for] = ACTIONS(223),
    [anon_sym_while] = ACTIONS(225),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(229),
    [anon_sym_match] = ACTIONS(231),
    [anon_sym_match_BANG] = ACTIONS(233),
    [anon_sym_function] = ACTIONS(235),
    [anon_sym_LT_DASH] = ACTIONS(237),
    [anon_sym_DOT_LBRACK] = ACTIONS(187),
    [anon_sym_LT] = ACTIONS(189),
    [anon_sym_use] = ACTIONS(239),
    [anon_sym_use_BANG] = ACTIONS(241),
    [anon_sym_do_BANG] = ACTIONS(243),
    [anon_sym_begin] = ACTIONS(245),
    [anon_sym_LPAREN2] = ACTIONS(191),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(247),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(251),
    [anon_sym_AT_DQUOTE] = ACTIONS(253),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(255),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(257),
    [sym_bool] = ACTIONS(259),
    [sym_unit] = ACTIONS(193),
    [anon_sym_LPAREN_PIPE] = ACTIONS(261),
    [sym_op_identifier] = ACTIONS(263),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(265),
    [sym_xint] = ACTIONS(267),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(269),
    [sym__newline] = ACTIONS(273),
  },
  [311] = {
    [sym_function_or_value_defn] = STATE(509),
    [sym__expression] = STATE(326),
    [sym_literal_expression] = STATE(2230),
    [sym_long_identifier_or_op] = STATE(2230),
    [sym_tuple_expression] = STATE(2230),
    [sym_brace_expression] = STATE(2230),
    [sym_anon_record_expression] = STATE(2230),
    [sym_prefixed_expression] = STATE(2230),
    [sym_typecast_expression] = STATE(2230),
    [sym_for_expression] = STATE(2230),
    [sym_while_expression] = STATE(2230),
    [sym__if_branch] = STATE(6659),
    [sym_if_expression] = STATE(2230),
    [sym_fun_expression] = STATE(2230),
    [sym_try_expression] = STATE(2230),
    [sym_match_expression] = STATE(2230),
    [sym_function_expression] = STATE(2230),
    [sym_mutate_expression] = STATE(2230),
    [sym_index_expression] = STATE(2230),
    [sym_typed_expression] = STATE(2230),
    [sym_declaration_expression] = STATE(2230),
    [sym_do_expression] = STATE(2230),
    [sym_list_expression] = STATE(2230),
    [sym_array_expression] = STATE(2230),
    [sym_begin_end_expression] = STATE(2230),
    [sym_paren_expression] = STATE(2230),
    [sym__high_prec_app] = STATE(2229),
    [sym__low_prec_app] = STATE(2229),
    [sym_application_expression] = STATE(2230),
    [sym_dot_expression] = STATE(2230),
    [sym_infix_expression] = STATE(2230),
    [sym_ce_expression] = STATE(2230),
    [sym_sequential_expression] = STATE(2230),
    [sym_char] = STATE(2100),
    [sym_format_string] = STATE(2106),
    [sym__string_literal] = STATE(2106),
    [sym_string] = STATE(2100),
    [sym_verbatim_string] = STATE(2100),
    [sym_bytearray] = STATE(2100),
    [sym_verbatim_bytearray] = STATE(2100),
    [sym_format_triple_quoted_string] = STATE(2107),
    [sym_triple_quoted_string] = STATE(2100),
    [sym_const] = STATE(2230),
    [sym_long_identifier] = STATE(2232),
    [sym_active_pattern] = STATE(2424),
    [sym__identifier_or_op] = STATE(2305),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(737),
    [sym_infix_op] = STATE(694),
    [sym_sbyte] = STATE(2100),
    [sym_byte] = STATE(2100),
    [sym_int16] = STATE(2100),
    [sym_uint16] = STATE(2100),
    [sym_int32] = STATE(2100),
    [sym_uint32] = STATE(2100),
    [sym_nativeint] = STATE(2100),
    [sym_unativeint] = STATE(2100),
    [sym_int64] = STATE(2100),
    [sym_uint64] = STATE(2100),
    [sym_ieee32] = STATE(2100),
    [sym_ieee64] = STATE(2100),
    [sym_bignum] = STATE(2100),
    [sym_decimal] = STATE(2100),
    [sym_float] = STATE(1487),
    [sym_block_comment] = STATE(311),
    [sym_compiler_directive_decl] = STATE(311),
    [sym_fsi_directive_decl] = STATE(311),
    [sym_preproc_line] = STATE(311),
    [sym_preproc_if_in_expression] = STATE(2230),
    [aux_sym_sequential_expression_repeat1] = STATE(1743),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(877),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(879),
    [anon_sym_return] = ACTIONS(881),
    [anon_sym_do] = ACTIONS(1597),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(885),
    [anon_sym_COMMA] = ACTIONS(887),
    [anon_sym_null] = ACTIONS(889),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(879),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(891),
    [anon_sym_LBRACK_PIPE] = ACTIONS(893),
    [anon_sym_LBRACE] = ACTIONS(895),
    [anon_sym_LT_AT] = ACTIONS(897),
    [anon_sym_LT_AT_AT] = ACTIONS(899),
    [anon_sym_DOT] = ACTIONS(901),
    [anon_sym_LBRACE_PIPE] = ACTIONS(903),
    [anon_sym_new] = ACTIONS(881),
    [anon_sym_return_BANG] = ACTIONS(905),
    [anon_sym_yield] = ACTIONS(881),
    [anon_sym_yield_BANG] = ACTIONS(905),
    [anon_sym_lazy] = ACTIONS(881),
    [anon_sym_assert] = ACTIONS(881),
    [anon_sym_upcast] = ACTIONS(881),
    [anon_sym_downcast] = ACTIONS(881),
    [anon_sym_COLON_GT] = ACTIONS(907),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(907),
    [anon_sym_for] = ACTIONS(909),
    [anon_sym_while] = ACTIONS(911),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(913),
    [anon_sym_try] = ACTIONS(915),
    [anon_sym_match] = ACTIONS(917),
    [anon_sym_match_BANG] = ACTIONS(919),
    [anon_sym_function] = ACTIONS(921),
    [anon_sym_LT_DASH] = ACTIONS(923),
    [anon_sym_DOT_LBRACK] = ACTIONS(925),
    [anon_sym_LT] = ACTIONS(927),
    [anon_sym_use] = ACTIONS(929),
    [anon_sym_use_BANG] = ACTIONS(931),
    [anon_sym_do_BANG] = ACTIONS(933),
    [anon_sym_DOT_DOT] = ACTIONS(935),
    [anon_sym_begin] = ACTIONS(937),
    [anon_sym_LPAREN2] = ACTIONS(939),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(941),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(943),
    [anon_sym_DQUOTE] = ACTIONS(945),
    [anon_sym_AT_DQUOTE] = ACTIONS(947),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(949),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(951),
    [sym_bool] = ACTIONS(953),
    [sym_unit] = ACTIONS(955),
    [anon_sym_LPAREN_PIPE] = ACTIONS(957),
    [sym_op_identifier] = ACTIONS(959),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(961),
    [sym_xint] = ACTIONS(963),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(965),
    [sym__newline] = ACTIONS(967),
  },
  [312] = {
    [sym_function_or_value_defn] = STATE(704),
    [sym__expression] = STATE(312),
    [sym_literal_expression] = STATE(2403),
    [sym_long_identifier_or_op] = STATE(2403),
    [sym_tuple_expression] = STATE(2403),
    [sym_brace_expression] = STATE(2403),
    [sym_anon_record_expression] = STATE(2403),
    [sym_prefixed_expression] = STATE(2403),
    [sym_typecast_expression] = STATE(2403),
    [sym_for_expression] = STATE(2403),
    [sym_while_expression] = STATE(2403),
    [sym__if_branch] = STATE(6794),
    [sym_if_expression] = STATE(2403),
    [sym_fun_expression] = STATE(2403),
    [sym_try_expression] = STATE(2403),
    [sym_match_expression] = STATE(2403),
    [sym_function_expression] = STATE(2403),
    [sym_mutate_expression] = STATE(2403),
    [sym_index_expression] = STATE(2403),
    [sym_typed_expression] = STATE(2403),
    [sym_declaration_expression] = STATE(2403),
    [sym_do_expression] = STATE(2403),
    [sym_list_expression] = STATE(2403),
    [sym_array_expression] = STATE(2403),
    [sym_begin_end_expression] = STATE(2403),
    [sym_paren_expression] = STATE(2403),
    [sym__high_prec_app] = STATE(2405),
    [sym__low_prec_app] = STATE(2405),
    [sym_application_expression] = STATE(2403),
    [sym_dot_expression] = STATE(2403),
    [sym_infix_expression] = STATE(2403),
    [sym_ce_expression] = STATE(2403),
    [sym_sequential_expression] = STATE(2403),
    [sym_char] = STATE(2425),
    [sym_format_string] = STATE(2420),
    [sym__string_literal] = STATE(2420),
    [sym_string] = STATE(2425),
    [sym_verbatim_string] = STATE(2425),
    [sym_bytearray] = STATE(2425),
    [sym_verbatim_bytearray] = STATE(2425),
    [sym_format_triple_quoted_string] = STATE(2419),
    [sym_triple_quoted_string] = STATE(2425),
    [sym_const] = STATE(2403),
    [sym_long_identifier] = STATE(2079),
    [sym_active_pattern] = STATE(2080),
    [sym__identifier_or_op] = STATE(2089),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(688),
    [sym_infix_op] = STATE(668),
    [sym_sbyte] = STATE(2425),
    [sym_byte] = STATE(2425),
    [sym_int16] = STATE(2425),
    [sym_uint16] = STATE(2425),
    [sym_int32] = STATE(2425),
    [sym_uint32] = STATE(2425),
    [sym_nativeint] = STATE(2425),
    [sym_unativeint] = STATE(2425),
    [sym_int64] = STATE(2425),
    [sym_uint64] = STATE(2425),
    [sym_ieee32] = STATE(2425),
    [sym_ieee64] = STATE(2425),
    [sym_bignum] = STATE(2425),
    [sym_decimal] = STATE(2425),
    [sym_float] = STATE(1511),
    [sym_block_comment] = STATE(312),
    [sym_compiler_directive_decl] = STATE(312),
    [sym_fsi_directive_decl] = STATE(312),
    [sym_preproc_line] = STATE(312),
    [sym_preproc_if_in_expression] = STATE(2403),
    [aux_sym_sequential_expression_repeat1] = STATE(1901),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_EQ] = ACTIONS(157),
    [anon_sym_COLON] = ACTIONS(155),
    [anon_sym_return] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(155),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_let_BANG] = ACTIONS(157),
    [anon_sym_LPAREN] = ACTIONS(155),
    [anon_sym_COMMA] = ACTIONS(157),
    [anon_sym_null] = ACTIONS(155),
    [anon_sym_QMARK] = ACTIONS(155),
    [anon_sym_COLON_QMARK] = ACTIONS(155),
    [anon_sym_COLON_COLON] = ACTIONS(157),
    [anon_sym_AMP] = ACTIONS(155),
    [anon_sym_LBRACK] = ACTIONS(155),
    [anon_sym_LBRACK_PIPE] = ACTIONS(157),
    [anon_sym_LBRACE] = ACTIONS(155),
    [anon_sym_LT_AT] = ACTIONS(155),
    [anon_sym_LT_AT_AT] = ACTIONS(155),
    [anon_sym_DOT] = ACTIONS(1285),
    [anon_sym_LBRACE_PIPE] = ACTIONS(157),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_return_BANG] = ACTIONS(157),
    [anon_sym_yield] = ACTIONS(155),
    [anon_sym_yield_BANG] = ACTIONS(157),
    [anon_sym_lazy] = ACTIONS(155),
    [anon_sym_assert] = ACTIONS(155),
    [anon_sym_upcast] = ACTIONS(155),
    [anon_sym_downcast] = ACTIONS(155),
    [anon_sym_COLON_GT] = ACTIONS(157),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(157),
    [anon_sym_for] = ACTIONS(155),
    [anon_sym_while] = ACTIONS(155),
    [anon_sym_if] = ACTIONS(155),
    [anon_sym_fun] = ACTIONS(155),
    [anon_sym_try] = ACTIONS(155),
    [anon_sym_match] = ACTIONS(155),
    [anon_sym_match_BANG] = ACTIONS(157),
    [anon_sym_function] = ACTIONS(155),
    [anon_sym_LT_DASH] = ACTIONS(155),
    [anon_sym_DOT_LBRACK] = ACTIONS(1309),
    [anon_sym_LT] = ACTIONS(1311),
    [anon_sym_use] = ACTIONS(155),
    [anon_sym_use_BANG] = ACTIONS(157),
    [anon_sym_do_BANG] = ACTIONS(157),
    [anon_sym_begin] = ACTIONS(155),
    [anon_sym_LPAREN2] = ACTIONS(1321),
    [anon_sym_or] = ACTIONS(155),
    [aux_sym_char_token1] = ACTIONS(157),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(155),
    [anon_sym_DQUOTE] = ACTIONS(155),
    [anon_sym_AT_DQUOTE] = ACTIONS(157),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(157),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(157),
    [sym_bool] = ACTIONS(155),
    [sym_unit] = ACTIONS(1337),
    [anon_sym_LPAREN_PIPE] = ACTIONS(155),
    [sym_op_identifier] = ACTIONS(155),
    [anon_sym_PLUS] = ACTIONS(155),
    [anon_sym_DASH] = ACTIONS(155),
    [anon_sym_PLUS_DOT] = ACTIONS(155),
    [anon_sym_DASH_DOT] = ACTIONS(155),
    [anon_sym_PERCENT] = ACTIONS(155),
    [anon_sym_AMP_AMP] = ACTIONS(155),
    [anon_sym_TILDE] = ACTIONS(157),
    [aux_sym_prefix_op_token1] = ACTIONS(155),
    [aux_sym_infix_op_token1] = ACTIONS(157),
    [aux_sym_infix_op_token2] = ACTIONS(155),
    [anon_sym_PIPE_PIPE] = ACTIONS(155),
    [anon_sym_BANG_EQ] = ACTIONS(155),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_DOLLAR] = ACTIONS(155),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(155),
    [sym_int] = ACTIONS(155),
    [sym_xint] = ACTIONS(157),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(157),
    [anon_sym_POUNDendif] = ACTIONS(157),
    [sym__newline] = ACTIONS(157),
  },
  [313] = {
    [sym_function_or_value_defn] = STATE(600),
    [sym__expression] = STATE(88),
    [sym_literal_expression] = STATE(867),
    [sym_long_identifier_or_op] = STATE(867),
    [sym_tuple_expression] = STATE(867),
    [sym_brace_expression] = STATE(867),
    [sym_anon_record_expression] = STATE(867),
    [sym_prefixed_expression] = STATE(867),
    [sym_typecast_expression] = STATE(867),
    [sym_for_expression] = STATE(867),
    [sym_while_expression] = STATE(867),
    [sym__if_branch] = STATE(6511),
    [sym_if_expression] = STATE(867),
    [sym_fun_expression] = STATE(867),
    [sym_try_expression] = STATE(867),
    [sym_match_expression] = STATE(867),
    [sym_function_expression] = STATE(867),
    [sym_mutate_expression] = STATE(867),
    [sym_index_expression] = STATE(867),
    [sym_typed_expression] = STATE(867),
    [sym_declaration_expression] = STATE(867),
    [sym_do_expression] = STATE(867),
    [sym_list_expression] = STATE(867),
    [sym_array_expression] = STATE(867),
    [sym_begin_end_expression] = STATE(867),
    [sym_paren_expression] = STATE(867),
    [sym__high_prec_app] = STATE(864),
    [sym__low_prec_app] = STATE(864),
    [sym_application_expression] = STATE(867),
    [sym_dot_expression] = STATE(867),
    [sym_infix_expression] = STATE(867),
    [sym_ce_expression] = STATE(867),
    [sym_sequential_expression] = STATE(867),
    [sym_char] = STATE(868),
    [sym_format_string] = STATE(869),
    [sym__string_literal] = STATE(869),
    [sym_string] = STATE(868),
    [sym_verbatim_string] = STATE(868),
    [sym_bytearray] = STATE(868),
    [sym_verbatim_bytearray] = STATE(868),
    [sym_format_triple_quoted_string] = STATE(870),
    [sym_triple_quoted_string] = STATE(868),
    [sym_const] = STATE(867),
    [sym_long_identifier] = STATE(872),
    [sym_active_pattern] = STATE(871),
    [sym__identifier_or_op] = STATE(873),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(656),
    [sym_infix_op] = STATE(581),
    [sym_sbyte] = STATE(868),
    [sym_byte] = STATE(868),
    [sym_int16] = STATE(868),
    [sym_uint16] = STATE(868),
    [sym_int32] = STATE(868),
    [sym_uint32] = STATE(868),
    [sym_nativeint] = STATE(868),
    [sym_unativeint] = STATE(868),
    [sym_int64] = STATE(868),
    [sym_uint64] = STATE(868),
    [sym_ieee32] = STATE(868),
    [sym_ieee64] = STATE(868),
    [sym_bignum] = STATE(868),
    [sym_decimal] = STATE(868),
    [sym_float] = STATE(1368),
    [sym_block_comment] = STATE(313),
    [sym_compiler_directive_decl] = STATE(313),
    [sym_fsi_directive_decl] = STATE(313),
    [sym_preproc_line] = STATE(313),
    [sym_preproc_if_in_expression] = STATE(867),
    [aux_sym_sequential_expression_repeat1] = STATE(1542),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(29),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(825),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_COMMA] = ACTIONS(827),
    [anon_sym_null] = ACTIONS(49),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACK_PIPE] = ACTIONS(57),
    [anon_sym_LBRACE] = ACTIONS(139),
    [anon_sym_LT_AT] = ACTIONS(61),
    [anon_sym_LT_AT_AT] = ACTIONS(63),
    [anon_sym_DOT] = ACTIONS(65),
    [anon_sym_LBRACE_PIPE] = ACTIONS(67),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_return_BANG] = ACTIONS(829),
    [anon_sym_yield] = ACTIONS(825),
    [anon_sym_yield_BANG] = ACTIONS(829),
    [anon_sym_lazy] = ACTIONS(825),
    [anon_sym_assert] = ACTIONS(825),
    [anon_sym_upcast] = ACTIONS(825),
    [anon_sym_downcast] = ACTIONS(825),
    [anon_sym_COLON_GT] = ACTIONS(71),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(71),
    [anon_sym_for] = ACTIONS(73),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(79),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_match] = ACTIONS(83),
    [anon_sym_match_BANG] = ACTIONS(85),
    [anon_sym_function] = ACTIONS(87),
    [anon_sym_LT_DASH] = ACTIONS(831),
    [anon_sym_DOT_LBRACK] = ACTIONS(91),
    [anon_sym_LT] = ACTIONS(93),
    [anon_sym_use] = ACTIONS(833),
    [anon_sym_use_BANG] = ACTIONS(835),
    [anon_sym_do_BANG] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(101),
    [anon_sym_LPAREN2] = ACTIONS(103),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(105),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(107),
    [anon_sym_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DQUOTE] = ACTIONS(111),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(115),
    [sym_bool] = ACTIONS(117),
    [sym_unit] = ACTIONS(119),
    [anon_sym_LPAREN_PIPE] = ACTIONS(121),
    [sym_op_identifier] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(837),
    [sym_xint] = ACTIONS(387),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(135),
    [sym__newline] = ACTIONS(839),
    [sym__dedent] = ACTIONS(1599),
  },
  [314] = {
    [sym_function_or_value_defn] = STATE(600),
    [sym__expression] = STATE(88),
    [sym_literal_expression] = STATE(867),
    [sym_long_identifier_or_op] = STATE(867),
    [sym_tuple_expression] = STATE(867),
    [sym_brace_expression] = STATE(867),
    [sym_anon_record_expression] = STATE(867),
    [sym_prefixed_expression] = STATE(867),
    [sym_typecast_expression] = STATE(867),
    [sym_for_expression] = STATE(867),
    [sym_while_expression] = STATE(867),
    [sym__if_branch] = STATE(6511),
    [sym_if_expression] = STATE(867),
    [sym_fun_expression] = STATE(867),
    [sym_try_expression] = STATE(867),
    [sym_match_expression] = STATE(867),
    [sym_function_expression] = STATE(867),
    [sym_mutate_expression] = STATE(867),
    [sym_index_expression] = STATE(867),
    [sym_typed_expression] = STATE(867),
    [sym_declaration_expression] = STATE(867),
    [sym_do_expression] = STATE(867),
    [sym_list_expression] = STATE(867),
    [sym_array_expression] = STATE(867),
    [sym_begin_end_expression] = STATE(867),
    [sym_paren_expression] = STATE(867),
    [sym__high_prec_app] = STATE(864),
    [sym__low_prec_app] = STATE(864),
    [sym_application_expression] = STATE(867),
    [sym_dot_expression] = STATE(867),
    [sym_infix_expression] = STATE(867),
    [sym_ce_expression] = STATE(867),
    [sym_sequential_expression] = STATE(867),
    [sym_char] = STATE(868),
    [sym_format_string] = STATE(869),
    [sym__string_literal] = STATE(869),
    [sym_string] = STATE(868),
    [sym_verbatim_string] = STATE(868),
    [sym_bytearray] = STATE(868),
    [sym_verbatim_bytearray] = STATE(868),
    [sym_format_triple_quoted_string] = STATE(870),
    [sym_triple_quoted_string] = STATE(868),
    [sym_const] = STATE(867),
    [sym_long_identifier] = STATE(872),
    [sym_active_pattern] = STATE(871),
    [sym__identifier_or_op] = STATE(873),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(656),
    [sym_infix_op] = STATE(581),
    [sym_sbyte] = STATE(868),
    [sym_byte] = STATE(868),
    [sym_int16] = STATE(868),
    [sym_uint16] = STATE(868),
    [sym_int32] = STATE(868),
    [sym_uint32] = STATE(868),
    [sym_nativeint] = STATE(868),
    [sym_unativeint] = STATE(868),
    [sym_int64] = STATE(868),
    [sym_uint64] = STATE(868),
    [sym_ieee32] = STATE(868),
    [sym_ieee64] = STATE(868),
    [sym_bignum] = STATE(868),
    [sym_decimal] = STATE(868),
    [sym_float] = STATE(1368),
    [sym_block_comment] = STATE(314),
    [sym_compiler_directive_decl] = STATE(314),
    [sym_fsi_directive_decl] = STATE(314),
    [sym_preproc_line] = STATE(314),
    [sym_preproc_if_in_expression] = STATE(867),
    [aux_sym_sequential_expression_repeat1] = STATE(1542),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(29),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(825),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_COMMA] = ACTIONS(827),
    [anon_sym_null] = ACTIONS(49),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACK_PIPE] = ACTIONS(57),
    [anon_sym_LBRACE] = ACTIONS(139),
    [anon_sym_LT_AT] = ACTIONS(61),
    [anon_sym_LT_AT_AT] = ACTIONS(63),
    [anon_sym_DOT] = ACTIONS(65),
    [anon_sym_LBRACE_PIPE] = ACTIONS(67),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_return_BANG] = ACTIONS(829),
    [anon_sym_yield] = ACTIONS(825),
    [anon_sym_yield_BANG] = ACTIONS(829),
    [anon_sym_lazy] = ACTIONS(825),
    [anon_sym_assert] = ACTIONS(825),
    [anon_sym_upcast] = ACTIONS(825),
    [anon_sym_downcast] = ACTIONS(825),
    [anon_sym_COLON_GT] = ACTIONS(71),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(71),
    [anon_sym_for] = ACTIONS(73),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(79),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_match] = ACTIONS(83),
    [anon_sym_match_BANG] = ACTIONS(85),
    [anon_sym_function] = ACTIONS(87),
    [anon_sym_LT_DASH] = ACTIONS(831),
    [anon_sym_DOT_LBRACK] = ACTIONS(91),
    [anon_sym_LT] = ACTIONS(93),
    [anon_sym_use] = ACTIONS(833),
    [anon_sym_use_BANG] = ACTIONS(835),
    [anon_sym_do_BANG] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(101),
    [anon_sym_LPAREN2] = ACTIONS(103),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(105),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(107),
    [anon_sym_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DQUOTE] = ACTIONS(111),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(115),
    [sym_bool] = ACTIONS(117),
    [sym_unit] = ACTIONS(119),
    [anon_sym_LPAREN_PIPE] = ACTIONS(121),
    [sym_op_identifier] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(837),
    [sym_xint] = ACTIONS(387),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(135),
    [sym__newline] = ACTIONS(839),
    [sym__dedent] = ACTIONS(1601),
  },
  [315] = {
    [sym_function_or_value_defn] = STATE(509),
    [sym__expression] = STATE(326),
    [sym_literal_expression] = STATE(2230),
    [sym_long_identifier_or_op] = STATE(2230),
    [sym_tuple_expression] = STATE(2230),
    [sym_brace_expression] = STATE(2230),
    [sym_anon_record_expression] = STATE(2230),
    [sym_prefixed_expression] = STATE(2230),
    [sym_typecast_expression] = STATE(2230),
    [sym_for_expression] = STATE(2230),
    [sym_while_expression] = STATE(2230),
    [sym__if_branch] = STATE(6659),
    [sym_if_expression] = STATE(2230),
    [sym_fun_expression] = STATE(2230),
    [sym_try_expression] = STATE(2230),
    [sym_match_expression] = STATE(2230),
    [sym_function_expression] = STATE(2230),
    [sym_mutate_expression] = STATE(2230),
    [sym_index_expression] = STATE(2230),
    [sym_typed_expression] = STATE(2230),
    [sym_declaration_expression] = STATE(2230),
    [sym_do_expression] = STATE(2230),
    [sym_list_expression] = STATE(2230),
    [sym_array_expression] = STATE(2230),
    [sym_begin_end_expression] = STATE(2230),
    [sym_paren_expression] = STATE(2230),
    [sym__high_prec_app] = STATE(2229),
    [sym__low_prec_app] = STATE(2229),
    [sym_application_expression] = STATE(2230),
    [sym_dot_expression] = STATE(2230),
    [sym_infix_expression] = STATE(2230),
    [sym_ce_expression] = STATE(2230),
    [sym_sequential_expression] = STATE(2230),
    [sym_char] = STATE(2100),
    [sym_format_string] = STATE(2106),
    [sym__string_literal] = STATE(2106),
    [sym_string] = STATE(2100),
    [sym_verbatim_string] = STATE(2100),
    [sym_bytearray] = STATE(2100),
    [sym_verbatim_bytearray] = STATE(2100),
    [sym_format_triple_quoted_string] = STATE(2107),
    [sym_triple_quoted_string] = STATE(2100),
    [sym_const] = STATE(2230),
    [sym_long_identifier] = STATE(2232),
    [sym_active_pattern] = STATE(2424),
    [sym__identifier_or_op] = STATE(2305),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(737),
    [sym_infix_op] = STATE(694),
    [sym_sbyte] = STATE(2100),
    [sym_byte] = STATE(2100),
    [sym_int16] = STATE(2100),
    [sym_uint16] = STATE(2100),
    [sym_int32] = STATE(2100),
    [sym_uint32] = STATE(2100),
    [sym_nativeint] = STATE(2100),
    [sym_unativeint] = STATE(2100),
    [sym_int64] = STATE(2100),
    [sym_uint64] = STATE(2100),
    [sym_ieee32] = STATE(2100),
    [sym_ieee64] = STATE(2100),
    [sym_bignum] = STATE(2100),
    [sym_decimal] = STATE(2100),
    [sym_float] = STATE(1487),
    [sym_block_comment] = STATE(315),
    [sym_compiler_directive_decl] = STATE(315),
    [sym_fsi_directive_decl] = STATE(315),
    [sym_preproc_line] = STATE(315),
    [sym_preproc_if_in_expression] = STATE(2230),
    [aux_sym_sequential_expression_repeat1] = STATE(1743),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(877),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(879),
    [anon_sym_return] = ACTIONS(881),
    [anon_sym_do] = ACTIONS(1585),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(885),
    [anon_sym_COMMA] = ACTIONS(887),
    [anon_sym_null] = ACTIONS(889),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(879),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(891),
    [anon_sym_LBRACK_PIPE] = ACTIONS(893),
    [anon_sym_LBRACE] = ACTIONS(895),
    [anon_sym_LT_AT] = ACTIONS(897),
    [anon_sym_LT_AT_AT] = ACTIONS(899),
    [anon_sym_DOT] = ACTIONS(901),
    [anon_sym_LBRACE_PIPE] = ACTIONS(903),
    [anon_sym_new] = ACTIONS(881),
    [anon_sym_return_BANG] = ACTIONS(905),
    [anon_sym_yield] = ACTIONS(881),
    [anon_sym_yield_BANG] = ACTIONS(905),
    [anon_sym_lazy] = ACTIONS(881),
    [anon_sym_assert] = ACTIONS(881),
    [anon_sym_upcast] = ACTIONS(881),
    [anon_sym_downcast] = ACTIONS(881),
    [anon_sym_COLON_GT] = ACTIONS(907),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(907),
    [anon_sym_for] = ACTIONS(909),
    [anon_sym_while] = ACTIONS(911),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(913),
    [anon_sym_try] = ACTIONS(915),
    [anon_sym_match] = ACTIONS(917),
    [anon_sym_match_BANG] = ACTIONS(919),
    [anon_sym_function] = ACTIONS(921),
    [anon_sym_LT_DASH] = ACTIONS(923),
    [anon_sym_DOT_LBRACK] = ACTIONS(925),
    [anon_sym_LT] = ACTIONS(927),
    [anon_sym_use] = ACTIONS(929),
    [anon_sym_use_BANG] = ACTIONS(931),
    [anon_sym_do_BANG] = ACTIONS(933),
    [anon_sym_DOT_DOT] = ACTIONS(149),
    [anon_sym_begin] = ACTIONS(937),
    [anon_sym_LPAREN2] = ACTIONS(939),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(941),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(943),
    [anon_sym_DQUOTE] = ACTIONS(945),
    [anon_sym_AT_DQUOTE] = ACTIONS(947),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(949),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(951),
    [sym_bool] = ACTIONS(953),
    [sym_unit] = ACTIONS(955),
    [anon_sym_LPAREN_PIPE] = ACTIONS(957),
    [sym_op_identifier] = ACTIONS(959),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(961),
    [sym_xint] = ACTIONS(963),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(965),
    [sym__newline] = ACTIONS(967),
  },
  [316] = {
    [sym_function_or_value_defn] = STATE(733),
    [sym__expression] = STATE(142),
    [sym_literal_expression] = STATE(2008),
    [sym_long_identifier_or_op] = STATE(2008),
    [sym_tuple_expression] = STATE(2008),
    [sym_brace_expression] = STATE(2008),
    [sym_anon_record_expression] = STATE(2008),
    [sym_prefixed_expression] = STATE(2008),
    [sym_typecast_expression] = STATE(2008),
    [sym_for_expression] = STATE(2008),
    [sym_while_expression] = STATE(2008),
    [sym__if_branch] = STATE(6754),
    [sym_if_expression] = STATE(2008),
    [sym_fun_expression] = STATE(2008),
    [sym_try_expression] = STATE(2008),
    [sym_match_expression] = STATE(2008),
    [sym_function_expression] = STATE(2008),
    [sym_mutate_expression] = STATE(2008),
    [sym_index_expression] = STATE(2008),
    [sym_typed_expression] = STATE(2008),
    [sym_declaration_expression] = STATE(2008),
    [sym_do_expression] = STATE(2008),
    [sym_list_expression] = STATE(2008),
    [sym_array_expression] = STATE(2008),
    [sym_begin_end_expression] = STATE(2008),
    [sym_paren_expression] = STATE(2008),
    [sym__high_prec_app] = STATE(2007),
    [sym__low_prec_app] = STATE(2007),
    [sym_application_expression] = STATE(2008),
    [sym_dot_expression] = STATE(2008),
    [sym_infix_expression] = STATE(2008),
    [sym_ce_expression] = STATE(2008),
    [sym_sequential_expression] = STATE(2008),
    [sym_char] = STATE(1859),
    [sym_format_string] = STATE(1861),
    [sym__string_literal] = STATE(1861),
    [sym_string] = STATE(1859),
    [sym_verbatim_string] = STATE(1859),
    [sym_bytearray] = STATE(1859),
    [sym_verbatim_bytearray] = STATE(1859),
    [sym_format_triple_quoted_string] = STATE(1862),
    [sym_triple_quoted_string] = STATE(1859),
    [sym_const] = STATE(2008),
    [sym_long_identifier] = STATE(1701),
    [sym_active_pattern] = STATE(1702),
    [sym__identifier_or_op] = STATE(1724),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(706),
    [sym_infix_op] = STATE(678),
    [sym_sbyte] = STATE(1859),
    [sym_byte] = STATE(1859),
    [sym_int16] = STATE(1859),
    [sym_uint16] = STATE(1859),
    [sym_int32] = STATE(1859),
    [sym_uint32] = STATE(1859),
    [sym_nativeint] = STATE(1859),
    [sym_unativeint] = STATE(1859),
    [sym_int64] = STATE(1859),
    [sym_uint64] = STATE(1859),
    [sym_ieee32] = STATE(1859),
    [sym_ieee64] = STATE(1859),
    [sym_bignum] = STATE(1859),
    [sym_decimal] = STATE(1859),
    [sym_float] = STATE(1447),
    [sym_block_comment] = STATE(316),
    [sym_compiler_directive_decl] = STATE(316),
    [sym_fsi_directive_decl] = STATE(316),
    [sym_preproc_line] = STATE(316),
    [sym_preproc_if_in_expression] = STATE(2008),
    [aux_sym_sequential_expression_repeat1] = STATE(1995),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(503),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(969),
    [anon_sym_return] = ACTIONS(971),
    [anon_sym_do] = ACTIONS(599),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(511),
    [anon_sym_COMMA] = ACTIONS(973),
    [anon_sym_null] = ACTIONS(515),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(969),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(517),
    [anon_sym_LBRACK_PIPE] = ACTIONS(519),
    [anon_sym_LBRACE] = ACTIONS(521),
    [anon_sym_LT_AT] = ACTIONS(523),
    [anon_sym_LT_AT_AT] = ACTIONS(525),
    [anon_sym_DOT] = ACTIONS(527),
    [anon_sym_LBRACE_PIPE] = ACTIONS(529),
    [anon_sym_new] = ACTIONS(971),
    [anon_sym_return_BANG] = ACTIONS(975),
    [anon_sym_yield] = ACTIONS(971),
    [anon_sym_yield_BANG] = ACTIONS(975),
    [anon_sym_lazy] = ACTIONS(971),
    [anon_sym_assert] = ACTIONS(971),
    [anon_sym_upcast] = ACTIONS(971),
    [anon_sym_downcast] = ACTIONS(971),
    [anon_sym_COLON_GT] = ACTIONS(977),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(977),
    [anon_sym_for] = ACTIONS(979),
    [anon_sym_while] = ACTIONS(537),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(539),
    [anon_sym_DASH_GT] = ACTIONS(1603),
    [anon_sym_try] = ACTIONS(543),
    [anon_sym_match] = ACTIONS(545),
    [anon_sym_match_BANG] = ACTIONS(547),
    [anon_sym_function] = ACTIONS(549),
    [anon_sym_LT_DASH] = ACTIONS(981),
    [anon_sym_DOT_LBRACK] = ACTIONS(553),
    [anon_sym_LT] = ACTIONS(555),
    [anon_sym_use] = ACTIONS(983),
    [anon_sym_use_BANG] = ACTIONS(985),
    [anon_sym_do_BANG] = ACTIONS(561),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_LPAREN2] = ACTIONS(567),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(569),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(571),
    [anon_sym_DQUOTE] = ACTIONS(573),
    [anon_sym_AT_DQUOTE] = ACTIONS(575),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(577),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(579),
    [sym_bool] = ACTIONS(581),
    [sym_unit] = ACTIONS(583),
    [anon_sym_LPAREN_PIPE] = ACTIONS(585),
    [sym_op_identifier] = ACTIONS(587),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(591),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(593),
    [sym__newline] = ACTIONS(1171),
  },
  [317] = {
    [sym_function_or_value_defn] = STATE(509),
    [sym__expression] = STATE(326),
    [sym_literal_expression] = STATE(2230),
    [sym_long_identifier_or_op] = STATE(2230),
    [sym_tuple_expression] = STATE(2230),
    [sym_brace_expression] = STATE(2230),
    [sym_anon_record_expression] = STATE(2230),
    [sym_prefixed_expression] = STATE(2230),
    [sym_typecast_expression] = STATE(2230),
    [sym_for_expression] = STATE(2230),
    [sym_while_expression] = STATE(2230),
    [sym__if_branch] = STATE(6659),
    [sym_if_expression] = STATE(2230),
    [sym_fun_expression] = STATE(2230),
    [sym_try_expression] = STATE(2230),
    [sym_match_expression] = STATE(2230),
    [sym_function_expression] = STATE(2230),
    [sym_mutate_expression] = STATE(2230),
    [sym_index_expression] = STATE(2230),
    [sym_typed_expression] = STATE(2230),
    [sym_declaration_expression] = STATE(2230),
    [sym_do_expression] = STATE(2230),
    [sym_list_expression] = STATE(2230),
    [sym_array_expression] = STATE(2230),
    [sym_begin_end_expression] = STATE(2230),
    [sym_paren_expression] = STATE(2230),
    [sym__high_prec_app] = STATE(2229),
    [sym__low_prec_app] = STATE(2229),
    [sym_application_expression] = STATE(2230),
    [sym_dot_expression] = STATE(2230),
    [sym_infix_expression] = STATE(2230),
    [sym_ce_expression] = STATE(2230),
    [sym_sequential_expression] = STATE(2230),
    [sym_char] = STATE(2100),
    [sym_format_string] = STATE(2106),
    [sym__string_literal] = STATE(2106),
    [sym_string] = STATE(2100),
    [sym_verbatim_string] = STATE(2100),
    [sym_bytearray] = STATE(2100),
    [sym_verbatim_bytearray] = STATE(2100),
    [sym_format_triple_quoted_string] = STATE(2107),
    [sym_triple_quoted_string] = STATE(2100),
    [sym_const] = STATE(2230),
    [sym_long_identifier] = STATE(2232),
    [sym_active_pattern] = STATE(2424),
    [sym__identifier_or_op] = STATE(2305),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(737),
    [sym_infix_op] = STATE(694),
    [sym_sbyte] = STATE(2100),
    [sym_byte] = STATE(2100),
    [sym_int16] = STATE(2100),
    [sym_uint16] = STATE(2100),
    [sym_int32] = STATE(2100),
    [sym_uint32] = STATE(2100),
    [sym_nativeint] = STATE(2100),
    [sym_unativeint] = STATE(2100),
    [sym_int64] = STATE(2100),
    [sym_uint64] = STATE(2100),
    [sym_ieee32] = STATE(2100),
    [sym_ieee64] = STATE(2100),
    [sym_bignum] = STATE(2100),
    [sym_decimal] = STATE(2100),
    [sym_float] = STATE(1487),
    [sym_block_comment] = STATE(317),
    [sym_compiler_directive_decl] = STATE(317),
    [sym_fsi_directive_decl] = STATE(317),
    [sym_preproc_line] = STATE(317),
    [sym_preproc_if_in_expression] = STATE(2230),
    [aux_sym_sequential_expression_repeat1] = STATE(1743),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(877),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(879),
    [anon_sym_return] = ACTIONS(881),
    [anon_sym_do] = ACTIONS(1585),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(885),
    [anon_sym_COMMA] = ACTIONS(887),
    [anon_sym_null] = ACTIONS(889),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(879),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(891),
    [anon_sym_LBRACK_PIPE] = ACTIONS(893),
    [anon_sym_LBRACE] = ACTIONS(59),
    [anon_sym_LT_AT] = ACTIONS(897),
    [anon_sym_LT_AT_AT] = ACTIONS(899),
    [anon_sym_DOT] = ACTIONS(901),
    [anon_sym_LBRACE_PIPE] = ACTIONS(903),
    [anon_sym_new] = ACTIONS(881),
    [anon_sym_return_BANG] = ACTIONS(905),
    [anon_sym_yield] = ACTIONS(881),
    [anon_sym_yield_BANG] = ACTIONS(905),
    [anon_sym_lazy] = ACTIONS(881),
    [anon_sym_assert] = ACTIONS(881),
    [anon_sym_upcast] = ACTIONS(881),
    [anon_sym_downcast] = ACTIONS(881),
    [anon_sym_COLON_GT] = ACTIONS(907),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(907),
    [anon_sym_for] = ACTIONS(909),
    [anon_sym_while] = ACTIONS(911),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(913),
    [anon_sym_try] = ACTIONS(915),
    [anon_sym_match] = ACTIONS(917),
    [anon_sym_match_BANG] = ACTIONS(919),
    [anon_sym_function] = ACTIONS(921),
    [anon_sym_LT_DASH] = ACTIONS(923),
    [anon_sym_DOT_LBRACK] = ACTIONS(925),
    [anon_sym_LT] = ACTIONS(927),
    [anon_sym_use] = ACTIONS(929),
    [anon_sym_use_BANG] = ACTIONS(931),
    [anon_sym_do_BANG] = ACTIONS(933),
    [anon_sym_DOT_DOT] = ACTIONS(33),
    [anon_sym_begin] = ACTIONS(937),
    [anon_sym_LPAREN2] = ACTIONS(939),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(941),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(943),
    [anon_sym_DQUOTE] = ACTIONS(945),
    [anon_sym_AT_DQUOTE] = ACTIONS(947),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(949),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(951),
    [sym_bool] = ACTIONS(953),
    [sym_unit] = ACTIONS(955),
    [anon_sym_LPAREN_PIPE] = ACTIONS(957),
    [sym_op_identifier] = ACTIONS(959),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(961),
    [sym_xint] = ACTIONS(963),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(965),
    [sym__newline] = ACTIONS(33),
  },
  [318] = {
    [sym_function_or_value_defn] = STATE(509),
    [sym__expression] = STATE(326),
    [sym_literal_expression] = STATE(2230),
    [sym_long_identifier_or_op] = STATE(2230),
    [sym_tuple_expression] = STATE(2230),
    [sym_brace_expression] = STATE(2230),
    [sym_anon_record_expression] = STATE(2230),
    [sym_prefixed_expression] = STATE(2230),
    [sym_typecast_expression] = STATE(2230),
    [sym_for_expression] = STATE(2230),
    [sym_while_expression] = STATE(2230),
    [sym__if_branch] = STATE(6659),
    [sym_if_expression] = STATE(2230),
    [sym_fun_expression] = STATE(2230),
    [sym_try_expression] = STATE(2230),
    [sym_match_expression] = STATE(2230),
    [sym_function_expression] = STATE(2230),
    [sym_mutate_expression] = STATE(2230),
    [sym_index_expression] = STATE(2230),
    [sym_typed_expression] = STATE(2230),
    [sym_declaration_expression] = STATE(2230),
    [sym_do_expression] = STATE(2230),
    [sym_list_expression] = STATE(2230),
    [sym_array_expression] = STATE(2230),
    [sym_begin_end_expression] = STATE(2230),
    [sym_paren_expression] = STATE(2230),
    [sym__high_prec_app] = STATE(2229),
    [sym__low_prec_app] = STATE(2229),
    [sym_application_expression] = STATE(2230),
    [sym_dot_expression] = STATE(2230),
    [sym_infix_expression] = STATE(2230),
    [sym_ce_expression] = STATE(2230),
    [sym_sequential_expression] = STATE(2230),
    [sym_char] = STATE(2100),
    [sym_format_string] = STATE(2106),
    [sym__string_literal] = STATE(2106),
    [sym_string] = STATE(2100),
    [sym_verbatim_string] = STATE(2100),
    [sym_bytearray] = STATE(2100),
    [sym_verbatim_bytearray] = STATE(2100),
    [sym_format_triple_quoted_string] = STATE(2107),
    [sym_triple_quoted_string] = STATE(2100),
    [sym_const] = STATE(2230),
    [sym_long_identifier] = STATE(2232),
    [sym_active_pattern] = STATE(2424),
    [sym__identifier_or_op] = STATE(2305),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(737),
    [sym_infix_op] = STATE(694),
    [sym_sbyte] = STATE(2100),
    [sym_byte] = STATE(2100),
    [sym_int16] = STATE(2100),
    [sym_uint16] = STATE(2100),
    [sym_int32] = STATE(2100),
    [sym_uint32] = STATE(2100),
    [sym_nativeint] = STATE(2100),
    [sym_unativeint] = STATE(2100),
    [sym_int64] = STATE(2100),
    [sym_uint64] = STATE(2100),
    [sym_ieee32] = STATE(2100),
    [sym_ieee64] = STATE(2100),
    [sym_bignum] = STATE(2100),
    [sym_decimal] = STATE(2100),
    [sym_float] = STATE(1487),
    [sym_block_comment] = STATE(318),
    [sym_compiler_directive_decl] = STATE(318),
    [sym_fsi_directive_decl] = STATE(318),
    [sym_preproc_line] = STATE(318),
    [sym_preproc_if_in_expression] = STATE(2230),
    [aux_sym_sequential_expression_repeat1] = STATE(1743),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(877),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(879),
    [anon_sym_return] = ACTIONS(881),
    [anon_sym_do] = ACTIONS(1585),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(885),
    [anon_sym_COMMA] = ACTIONS(887),
    [anon_sym_null] = ACTIONS(889),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(879),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(891),
    [anon_sym_LBRACK_PIPE] = ACTIONS(893),
    [anon_sym_LBRACE] = ACTIONS(895),
    [anon_sym_LT_AT] = ACTIONS(897),
    [anon_sym_LT_AT_AT] = ACTIONS(899),
    [anon_sym_DOT] = ACTIONS(901),
    [anon_sym_LBRACE_PIPE] = ACTIONS(903),
    [anon_sym_new] = ACTIONS(881),
    [anon_sym_return_BANG] = ACTIONS(905),
    [anon_sym_yield] = ACTIONS(881),
    [anon_sym_yield_BANG] = ACTIONS(905),
    [anon_sym_lazy] = ACTIONS(881),
    [anon_sym_assert] = ACTIONS(881),
    [anon_sym_upcast] = ACTIONS(881),
    [anon_sym_downcast] = ACTIONS(881),
    [anon_sym_COLON_GT] = ACTIONS(907),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(907),
    [anon_sym_for] = ACTIONS(909),
    [anon_sym_while] = ACTIONS(911),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(913),
    [anon_sym_try] = ACTIONS(915),
    [anon_sym_match] = ACTIONS(917),
    [anon_sym_match_BANG] = ACTIONS(919),
    [anon_sym_function] = ACTIONS(921),
    [anon_sym_LT_DASH] = ACTIONS(923),
    [anon_sym_DOT_LBRACK] = ACTIONS(925),
    [anon_sym_LT] = ACTIONS(927),
    [anon_sym_use] = ACTIONS(929),
    [anon_sym_use_BANG] = ACTIONS(931),
    [anon_sym_do_BANG] = ACTIONS(933),
    [anon_sym_DOT_DOT] = ACTIONS(145),
    [anon_sym_begin] = ACTIONS(937),
    [anon_sym_LPAREN2] = ACTIONS(939),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(941),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(943),
    [anon_sym_DQUOTE] = ACTIONS(945),
    [anon_sym_AT_DQUOTE] = ACTIONS(947),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(949),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(951),
    [sym_bool] = ACTIONS(953),
    [sym_unit] = ACTIONS(955),
    [anon_sym_LPAREN_PIPE] = ACTIONS(957),
    [sym_op_identifier] = ACTIONS(959),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(961),
    [sym_xint] = ACTIONS(963),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(965),
    [sym__newline] = ACTIONS(145),
  },
  [319] = {
    [sym_function_or_value_defn] = STATE(509),
    [sym__expression] = STATE(326),
    [sym_literal_expression] = STATE(2230),
    [sym_long_identifier_or_op] = STATE(2230),
    [sym_tuple_expression] = STATE(2230),
    [sym_brace_expression] = STATE(2230),
    [sym_anon_record_expression] = STATE(2230),
    [sym_prefixed_expression] = STATE(2230),
    [sym_typecast_expression] = STATE(2230),
    [sym_for_expression] = STATE(2230),
    [sym_while_expression] = STATE(2230),
    [sym__if_branch] = STATE(6659),
    [sym_if_expression] = STATE(2230),
    [sym_fun_expression] = STATE(2230),
    [sym_try_expression] = STATE(2230),
    [sym_match_expression] = STATE(2230),
    [sym_function_expression] = STATE(2230),
    [sym_mutate_expression] = STATE(2230),
    [sym_index_expression] = STATE(2230),
    [sym_typed_expression] = STATE(2230),
    [sym_declaration_expression] = STATE(2230),
    [sym_do_expression] = STATE(2230),
    [sym_list_expression] = STATE(2230),
    [sym_array_expression] = STATE(2230),
    [sym_begin_end_expression] = STATE(2230),
    [sym_paren_expression] = STATE(2230),
    [sym__high_prec_app] = STATE(2229),
    [sym__low_prec_app] = STATE(2229),
    [sym_application_expression] = STATE(2230),
    [sym_dot_expression] = STATE(2230),
    [sym_infix_expression] = STATE(2230),
    [sym_ce_expression] = STATE(2230),
    [sym_sequential_expression] = STATE(2230),
    [sym_char] = STATE(2100),
    [sym_format_string] = STATE(2106),
    [sym__string_literal] = STATE(2106),
    [sym_string] = STATE(2100),
    [sym_verbatim_string] = STATE(2100),
    [sym_bytearray] = STATE(2100),
    [sym_verbatim_bytearray] = STATE(2100),
    [sym_format_triple_quoted_string] = STATE(2107),
    [sym_triple_quoted_string] = STATE(2100),
    [sym_const] = STATE(2230),
    [sym_long_identifier] = STATE(2232),
    [sym_active_pattern] = STATE(2424),
    [sym__identifier_or_op] = STATE(2305),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(737),
    [sym_infix_op] = STATE(694),
    [sym_sbyte] = STATE(2100),
    [sym_byte] = STATE(2100),
    [sym_int16] = STATE(2100),
    [sym_uint16] = STATE(2100),
    [sym_int32] = STATE(2100),
    [sym_uint32] = STATE(2100),
    [sym_nativeint] = STATE(2100),
    [sym_unativeint] = STATE(2100),
    [sym_int64] = STATE(2100),
    [sym_uint64] = STATE(2100),
    [sym_ieee32] = STATE(2100),
    [sym_ieee64] = STATE(2100),
    [sym_bignum] = STATE(2100),
    [sym_decimal] = STATE(2100),
    [sym_float] = STATE(1487),
    [sym_block_comment] = STATE(319),
    [sym_compiler_directive_decl] = STATE(319),
    [sym_fsi_directive_decl] = STATE(319),
    [sym_preproc_line] = STATE(319),
    [sym_preproc_if_in_expression] = STATE(2230),
    [aux_sym_sequential_expression_repeat1] = STATE(1743),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(877),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(879),
    [anon_sym_return] = ACTIONS(881),
    [anon_sym_do] = ACTIONS(1605),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(885),
    [anon_sym_COMMA] = ACTIONS(887),
    [anon_sym_null] = ACTIONS(889),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(879),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(891),
    [anon_sym_LBRACK_PIPE] = ACTIONS(893),
    [anon_sym_LBRACE] = ACTIONS(895),
    [anon_sym_LT_AT] = ACTIONS(897),
    [anon_sym_LT_AT_AT] = ACTIONS(899),
    [anon_sym_DOT] = ACTIONS(901),
    [anon_sym_LBRACE_PIPE] = ACTIONS(903),
    [anon_sym_new] = ACTIONS(881),
    [anon_sym_return_BANG] = ACTIONS(905),
    [anon_sym_yield] = ACTIONS(881),
    [anon_sym_yield_BANG] = ACTIONS(905),
    [anon_sym_lazy] = ACTIONS(881),
    [anon_sym_assert] = ACTIONS(881),
    [anon_sym_upcast] = ACTIONS(881),
    [anon_sym_downcast] = ACTIONS(881),
    [anon_sym_COLON_GT] = ACTIONS(907),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(907),
    [anon_sym_for] = ACTIONS(909),
    [anon_sym_while] = ACTIONS(911),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(913),
    [anon_sym_try] = ACTIONS(915),
    [anon_sym_match] = ACTIONS(917),
    [anon_sym_match_BANG] = ACTIONS(919),
    [anon_sym_function] = ACTIONS(921),
    [anon_sym_LT_DASH] = ACTIONS(923),
    [anon_sym_DOT_LBRACK] = ACTIONS(925),
    [anon_sym_LT] = ACTIONS(927),
    [anon_sym_use] = ACTIONS(929),
    [anon_sym_use_BANG] = ACTIONS(931),
    [anon_sym_do_BANG] = ACTIONS(933),
    [anon_sym_DOT_DOT] = ACTIONS(935),
    [anon_sym_begin] = ACTIONS(937),
    [anon_sym_LPAREN2] = ACTIONS(939),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(941),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(943),
    [anon_sym_DQUOTE] = ACTIONS(945),
    [anon_sym_AT_DQUOTE] = ACTIONS(947),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(949),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(951),
    [sym_bool] = ACTIONS(953),
    [sym_unit] = ACTIONS(955),
    [anon_sym_LPAREN_PIPE] = ACTIONS(957),
    [sym_op_identifier] = ACTIONS(959),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(961),
    [sym_xint] = ACTIONS(963),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(965),
    [sym__newline] = ACTIONS(967),
  },
  [320] = {
    [sym_function_or_value_defn] = STATE(733),
    [sym__expression] = STATE(142),
    [sym_literal_expression] = STATE(2008),
    [sym_long_identifier_or_op] = STATE(2008),
    [sym_tuple_expression] = STATE(2008),
    [sym_brace_expression] = STATE(2008),
    [sym_anon_record_expression] = STATE(2008),
    [sym_prefixed_expression] = STATE(2008),
    [sym_typecast_expression] = STATE(2008),
    [sym_for_expression] = STATE(2008),
    [sym_while_expression] = STATE(2008),
    [sym__if_branch] = STATE(6754),
    [sym_if_expression] = STATE(2008),
    [sym_fun_expression] = STATE(2008),
    [sym_try_expression] = STATE(2008),
    [sym_match_expression] = STATE(2008),
    [sym_function_expression] = STATE(2008),
    [sym_mutate_expression] = STATE(2008),
    [sym_index_expression] = STATE(2008),
    [sym_typed_expression] = STATE(2008),
    [sym_declaration_expression] = STATE(2008),
    [sym_do_expression] = STATE(2008),
    [sym_list_expression] = STATE(2008),
    [sym_array_expression] = STATE(2008),
    [sym_begin_end_expression] = STATE(2008),
    [sym_paren_expression] = STATE(2008),
    [sym__high_prec_app] = STATE(2007),
    [sym__low_prec_app] = STATE(2007),
    [sym_application_expression] = STATE(2008),
    [sym_dot_expression] = STATE(2008),
    [sym_infix_expression] = STATE(2008),
    [sym_ce_expression] = STATE(2008),
    [sym_sequential_expression] = STATE(2008),
    [sym_char] = STATE(1859),
    [sym_format_string] = STATE(1861),
    [sym__string_literal] = STATE(1861),
    [sym_string] = STATE(1859),
    [sym_verbatim_string] = STATE(1859),
    [sym_bytearray] = STATE(1859),
    [sym_verbatim_bytearray] = STATE(1859),
    [sym_format_triple_quoted_string] = STATE(1862),
    [sym_triple_quoted_string] = STATE(1859),
    [sym_const] = STATE(2008),
    [sym_long_identifier] = STATE(1701),
    [sym_active_pattern] = STATE(1702),
    [sym__identifier_or_op] = STATE(1724),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(706),
    [sym_infix_op] = STATE(678),
    [sym_sbyte] = STATE(1859),
    [sym_byte] = STATE(1859),
    [sym_int16] = STATE(1859),
    [sym_uint16] = STATE(1859),
    [sym_int32] = STATE(1859),
    [sym_uint32] = STATE(1859),
    [sym_nativeint] = STATE(1859),
    [sym_unativeint] = STATE(1859),
    [sym_int64] = STATE(1859),
    [sym_uint64] = STATE(1859),
    [sym_ieee32] = STATE(1859),
    [sym_ieee64] = STATE(1859),
    [sym_bignum] = STATE(1859),
    [sym_decimal] = STATE(1859),
    [sym_float] = STATE(1447),
    [sym_block_comment] = STATE(320),
    [sym_compiler_directive_decl] = STATE(320),
    [sym_fsi_directive_decl] = STATE(320),
    [sym_preproc_line] = STATE(320),
    [sym_preproc_if_in_expression] = STATE(2008),
    [aux_sym_sequential_expression_repeat1] = STATE(1995),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(503),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(969),
    [anon_sym_return] = ACTIONS(971),
    [anon_sym_do] = ACTIONS(599),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(511),
    [anon_sym_COMMA] = ACTIONS(973),
    [anon_sym_null] = ACTIONS(515),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(969),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(517),
    [anon_sym_LBRACK_PIPE] = ACTIONS(519),
    [anon_sym_LBRACE] = ACTIONS(521),
    [anon_sym_LT_AT] = ACTIONS(523),
    [anon_sym_LT_AT_AT] = ACTIONS(525),
    [anon_sym_DOT] = ACTIONS(527),
    [anon_sym_LBRACE_PIPE] = ACTIONS(529),
    [anon_sym_new] = ACTIONS(971),
    [anon_sym_return_BANG] = ACTIONS(975),
    [anon_sym_yield] = ACTIONS(971),
    [anon_sym_yield_BANG] = ACTIONS(975),
    [anon_sym_lazy] = ACTIONS(971),
    [anon_sym_assert] = ACTIONS(971),
    [anon_sym_upcast] = ACTIONS(971),
    [anon_sym_downcast] = ACTIONS(971),
    [anon_sym_COLON_GT] = ACTIONS(977),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(977),
    [anon_sym_for] = ACTIONS(979),
    [anon_sym_while] = ACTIONS(537),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(539),
    [anon_sym_DASH_GT] = ACTIONS(1607),
    [anon_sym_try] = ACTIONS(543),
    [anon_sym_match] = ACTIONS(545),
    [anon_sym_match_BANG] = ACTIONS(547),
    [anon_sym_function] = ACTIONS(549),
    [anon_sym_LT_DASH] = ACTIONS(981),
    [anon_sym_DOT_LBRACK] = ACTIONS(553),
    [anon_sym_LT] = ACTIONS(555),
    [anon_sym_use] = ACTIONS(983),
    [anon_sym_use_BANG] = ACTIONS(985),
    [anon_sym_do_BANG] = ACTIONS(561),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_LPAREN2] = ACTIONS(567),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(569),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(571),
    [anon_sym_DQUOTE] = ACTIONS(573),
    [anon_sym_AT_DQUOTE] = ACTIONS(575),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(577),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(579),
    [sym_bool] = ACTIONS(581),
    [sym_unit] = ACTIONS(583),
    [anon_sym_LPAREN_PIPE] = ACTIONS(585),
    [sym_op_identifier] = ACTIONS(587),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(591),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(593),
    [sym__newline] = ACTIONS(1171),
  },
  [321] = {
    [sym_function_or_value_defn] = STATE(600),
    [sym__expression] = STATE(88),
    [sym_literal_expression] = STATE(867),
    [sym_long_identifier_or_op] = STATE(867),
    [sym_tuple_expression] = STATE(867),
    [sym_brace_expression] = STATE(867),
    [sym_anon_record_expression] = STATE(867),
    [sym_prefixed_expression] = STATE(867),
    [sym_typecast_expression] = STATE(867),
    [sym_for_expression] = STATE(867),
    [sym_while_expression] = STATE(867),
    [sym__if_branch] = STATE(6511),
    [sym_if_expression] = STATE(867),
    [sym_fun_expression] = STATE(867),
    [sym_try_expression] = STATE(867),
    [sym_match_expression] = STATE(867),
    [sym_function_expression] = STATE(867),
    [sym_mutate_expression] = STATE(867),
    [sym_index_expression] = STATE(867),
    [sym_typed_expression] = STATE(867),
    [sym_declaration_expression] = STATE(867),
    [sym_do_expression] = STATE(867),
    [sym_list_expression] = STATE(867),
    [sym_array_expression] = STATE(867),
    [sym_begin_end_expression] = STATE(867),
    [sym_paren_expression] = STATE(867),
    [sym__high_prec_app] = STATE(864),
    [sym__low_prec_app] = STATE(864),
    [sym_application_expression] = STATE(867),
    [sym_dot_expression] = STATE(867),
    [sym_infix_expression] = STATE(867),
    [sym_ce_expression] = STATE(867),
    [sym_sequential_expression] = STATE(867),
    [sym_char] = STATE(868),
    [sym_format_string] = STATE(869),
    [sym__string_literal] = STATE(869),
    [sym_string] = STATE(868),
    [sym_verbatim_string] = STATE(868),
    [sym_bytearray] = STATE(868),
    [sym_verbatim_bytearray] = STATE(868),
    [sym_format_triple_quoted_string] = STATE(870),
    [sym_triple_quoted_string] = STATE(868),
    [sym_const] = STATE(867),
    [sym_long_identifier] = STATE(872),
    [sym_active_pattern] = STATE(871),
    [sym__identifier_or_op] = STATE(873),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(656),
    [sym_infix_op] = STATE(581),
    [sym_sbyte] = STATE(868),
    [sym_byte] = STATE(868),
    [sym_int16] = STATE(868),
    [sym_uint16] = STATE(868),
    [sym_int32] = STATE(868),
    [sym_uint32] = STATE(868),
    [sym_nativeint] = STATE(868),
    [sym_unativeint] = STATE(868),
    [sym_int64] = STATE(868),
    [sym_uint64] = STATE(868),
    [sym_ieee32] = STATE(868),
    [sym_ieee64] = STATE(868),
    [sym_bignum] = STATE(868),
    [sym_decimal] = STATE(868),
    [sym_float] = STATE(1368),
    [sym_block_comment] = STATE(321),
    [sym_compiler_directive_decl] = STATE(321),
    [sym_fsi_directive_decl] = STATE(321),
    [sym_preproc_line] = STATE(321),
    [sym_preproc_if_in_expression] = STATE(867),
    [aux_sym_sequential_expression_repeat1] = STATE(1542),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(29),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(825),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_COMMA] = ACTIONS(827),
    [anon_sym_null] = ACTIONS(49),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACK_PIPE] = ACTIONS(57),
    [anon_sym_LBRACE] = ACTIONS(139),
    [anon_sym_LT_AT] = ACTIONS(61),
    [anon_sym_LT_AT_AT] = ACTIONS(63),
    [anon_sym_DOT] = ACTIONS(65),
    [anon_sym_LBRACE_PIPE] = ACTIONS(67),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_return_BANG] = ACTIONS(829),
    [anon_sym_yield] = ACTIONS(825),
    [anon_sym_yield_BANG] = ACTIONS(829),
    [anon_sym_lazy] = ACTIONS(825),
    [anon_sym_assert] = ACTIONS(825),
    [anon_sym_upcast] = ACTIONS(825),
    [anon_sym_downcast] = ACTIONS(825),
    [anon_sym_COLON_GT] = ACTIONS(71),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(71),
    [anon_sym_for] = ACTIONS(73),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(79),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_match] = ACTIONS(83),
    [anon_sym_match_BANG] = ACTIONS(85),
    [anon_sym_function] = ACTIONS(87),
    [anon_sym_LT_DASH] = ACTIONS(831),
    [anon_sym_DOT_LBRACK] = ACTIONS(91),
    [anon_sym_LT] = ACTIONS(93),
    [anon_sym_use] = ACTIONS(833),
    [anon_sym_use_BANG] = ACTIONS(835),
    [anon_sym_do_BANG] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(101),
    [anon_sym_LPAREN2] = ACTIONS(103),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(105),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(107),
    [anon_sym_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DQUOTE] = ACTIONS(111),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(115),
    [sym_bool] = ACTIONS(117),
    [sym_unit] = ACTIONS(119),
    [anon_sym_LPAREN_PIPE] = ACTIONS(121),
    [sym_op_identifier] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(837),
    [sym_xint] = ACTIONS(387),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(135),
    [sym__newline] = ACTIONS(839),
    [sym__dedent] = ACTIONS(1609),
  },
  [322] = {
    [sym_function_or_value_defn] = STATE(733),
    [sym__expression] = STATE(142),
    [sym_literal_expression] = STATE(2008),
    [sym_long_identifier_or_op] = STATE(2008),
    [sym_tuple_expression] = STATE(2008),
    [sym_brace_expression] = STATE(2008),
    [sym_anon_record_expression] = STATE(2008),
    [sym_prefixed_expression] = STATE(2008),
    [sym_typecast_expression] = STATE(2008),
    [sym_for_expression] = STATE(2008),
    [sym_while_expression] = STATE(2008),
    [sym__if_branch] = STATE(6754),
    [sym_if_expression] = STATE(2008),
    [sym_fun_expression] = STATE(2008),
    [sym_try_expression] = STATE(2008),
    [sym_match_expression] = STATE(2008),
    [sym_function_expression] = STATE(2008),
    [sym_mutate_expression] = STATE(2008),
    [sym_index_expression] = STATE(2008),
    [sym_typed_expression] = STATE(2008),
    [sym_declaration_expression] = STATE(2008),
    [sym_do_expression] = STATE(2008),
    [sym_list_expression] = STATE(2008),
    [sym_array_expression] = STATE(2008),
    [sym_begin_end_expression] = STATE(2008),
    [sym_paren_expression] = STATE(2008),
    [sym__high_prec_app] = STATE(2007),
    [sym__low_prec_app] = STATE(2007),
    [sym_application_expression] = STATE(2008),
    [sym_dot_expression] = STATE(2008),
    [sym_infix_expression] = STATE(2008),
    [sym_ce_expression] = STATE(2008),
    [sym_sequential_expression] = STATE(2008),
    [sym_char] = STATE(1859),
    [sym_format_string] = STATE(1861),
    [sym__string_literal] = STATE(1861),
    [sym_string] = STATE(1859),
    [sym_verbatim_string] = STATE(1859),
    [sym_bytearray] = STATE(1859),
    [sym_verbatim_bytearray] = STATE(1859),
    [sym_format_triple_quoted_string] = STATE(1862),
    [sym_triple_quoted_string] = STATE(1859),
    [sym_const] = STATE(2008),
    [sym_long_identifier] = STATE(1701),
    [sym_active_pattern] = STATE(1702),
    [sym__identifier_or_op] = STATE(1724),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(706),
    [sym_infix_op] = STATE(678),
    [sym_sbyte] = STATE(1859),
    [sym_byte] = STATE(1859),
    [sym_int16] = STATE(1859),
    [sym_uint16] = STATE(1859),
    [sym_int32] = STATE(1859),
    [sym_uint32] = STATE(1859),
    [sym_nativeint] = STATE(1859),
    [sym_unativeint] = STATE(1859),
    [sym_int64] = STATE(1859),
    [sym_uint64] = STATE(1859),
    [sym_ieee32] = STATE(1859),
    [sym_ieee64] = STATE(1859),
    [sym_bignum] = STATE(1859),
    [sym_decimal] = STATE(1859),
    [sym_float] = STATE(1447),
    [sym_block_comment] = STATE(322),
    [sym_compiler_directive_decl] = STATE(322),
    [sym_fsi_directive_decl] = STATE(322),
    [sym_preproc_line] = STATE(322),
    [sym_preproc_if_in_expression] = STATE(2008),
    [aux_sym_sequential_expression_repeat1] = STATE(1995),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(503),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(969),
    [anon_sym_return] = ACTIONS(971),
    [anon_sym_do] = ACTIONS(599),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(511),
    [anon_sym_COMMA] = ACTIONS(973),
    [anon_sym_null] = ACTIONS(515),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(969),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(517),
    [anon_sym_LBRACK_PIPE] = ACTIONS(519),
    [anon_sym_LBRACE] = ACTIONS(521),
    [anon_sym_LT_AT] = ACTIONS(523),
    [anon_sym_LT_AT_AT] = ACTIONS(525),
    [anon_sym_DOT] = ACTIONS(527),
    [anon_sym_LBRACE_PIPE] = ACTIONS(529),
    [anon_sym_new] = ACTIONS(971),
    [anon_sym_return_BANG] = ACTIONS(975),
    [anon_sym_yield] = ACTIONS(971),
    [anon_sym_yield_BANG] = ACTIONS(975),
    [anon_sym_lazy] = ACTIONS(971),
    [anon_sym_assert] = ACTIONS(971),
    [anon_sym_upcast] = ACTIONS(971),
    [anon_sym_downcast] = ACTIONS(971),
    [anon_sym_COLON_GT] = ACTIONS(977),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(977),
    [anon_sym_for] = ACTIONS(979),
    [anon_sym_while] = ACTIONS(537),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(539),
    [anon_sym_DASH_GT] = ACTIONS(1611),
    [anon_sym_try] = ACTIONS(543),
    [anon_sym_match] = ACTIONS(545),
    [anon_sym_match_BANG] = ACTIONS(547),
    [anon_sym_function] = ACTIONS(549),
    [anon_sym_LT_DASH] = ACTIONS(981),
    [anon_sym_DOT_LBRACK] = ACTIONS(553),
    [anon_sym_LT] = ACTIONS(555),
    [anon_sym_use] = ACTIONS(983),
    [anon_sym_use_BANG] = ACTIONS(985),
    [anon_sym_do_BANG] = ACTIONS(561),
    [anon_sym_begin] = ACTIONS(565),
    [anon_sym_LPAREN2] = ACTIONS(567),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(569),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(571),
    [anon_sym_DQUOTE] = ACTIONS(573),
    [anon_sym_AT_DQUOTE] = ACTIONS(575),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(577),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(579),
    [sym_bool] = ACTIONS(581),
    [sym_unit] = ACTIONS(583),
    [anon_sym_LPAREN_PIPE] = ACTIONS(585),
    [sym_op_identifier] = ACTIONS(587),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(591),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(593),
    [sym__newline] = ACTIONS(1171),
  },
  [323] = {
    [sym_function_or_value_defn] = STATE(509),
    [sym__expression] = STATE(326),
    [sym_literal_expression] = STATE(2230),
    [sym_long_identifier_or_op] = STATE(2230),
    [sym_tuple_expression] = STATE(2230),
    [sym_brace_expression] = STATE(2230),
    [sym_anon_record_expression] = STATE(2230),
    [sym_prefixed_expression] = STATE(2230),
    [sym_typecast_expression] = STATE(2230),
    [sym_for_expression] = STATE(2230),
    [sym_while_expression] = STATE(2230),
    [sym__if_branch] = STATE(6659),
    [sym_if_expression] = STATE(2230),
    [sym_fun_expression] = STATE(2230),
    [sym_try_expression] = STATE(2230),
    [sym_match_expression] = STATE(2230),
    [sym_function_expression] = STATE(2230),
    [sym_mutate_expression] = STATE(2230),
    [sym_index_expression] = STATE(2230),
    [sym_typed_expression] = STATE(2230),
    [sym_declaration_expression] = STATE(2230),
    [sym_do_expression] = STATE(2230),
    [sym_list_expression] = STATE(2230),
    [sym_array_expression] = STATE(2230),
    [sym_begin_end_expression] = STATE(2230),
    [sym_paren_expression] = STATE(2230),
    [sym__high_prec_app] = STATE(2229),
    [sym__low_prec_app] = STATE(2229),
    [sym_application_expression] = STATE(2230),
    [sym_dot_expression] = STATE(2230),
    [sym_infix_expression] = STATE(2230),
    [sym_ce_expression] = STATE(2230),
    [sym_sequential_expression] = STATE(2230),
    [sym_char] = STATE(2100),
    [sym_format_string] = STATE(2106),
    [sym__string_literal] = STATE(2106),
    [sym_string] = STATE(2100),
    [sym_verbatim_string] = STATE(2100),
    [sym_bytearray] = STATE(2100),
    [sym_verbatim_bytearray] = STATE(2100),
    [sym_format_triple_quoted_string] = STATE(2107),
    [sym_triple_quoted_string] = STATE(2100),
    [sym_const] = STATE(2230),
    [sym_long_identifier] = STATE(2232),
    [sym_active_pattern] = STATE(2424),
    [sym__identifier_or_op] = STATE(2305),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(737),
    [sym_infix_op] = STATE(694),
    [sym_sbyte] = STATE(2100),
    [sym_byte] = STATE(2100),
    [sym_int16] = STATE(2100),
    [sym_uint16] = STATE(2100),
    [sym_int32] = STATE(2100),
    [sym_uint32] = STATE(2100),
    [sym_nativeint] = STATE(2100),
    [sym_unativeint] = STATE(2100),
    [sym_int64] = STATE(2100),
    [sym_uint64] = STATE(2100),
    [sym_ieee32] = STATE(2100),
    [sym_ieee64] = STATE(2100),
    [sym_bignum] = STATE(2100),
    [sym_decimal] = STATE(2100),
    [sym_float] = STATE(1487),
    [sym_block_comment] = STATE(323),
    [sym_compiler_directive_decl] = STATE(323),
    [sym_fsi_directive_decl] = STATE(323),
    [sym_preproc_line] = STATE(323),
    [sym_preproc_if_in_expression] = STATE(2230),
    [aux_sym_sequential_expression_repeat1] = STATE(1743),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(181),
    [anon_sym_EQ] = ACTIONS(183),
    [anon_sym_COLON] = ACTIONS(181),
    [anon_sym_return] = ACTIONS(181),
    [anon_sym_do] = ACTIONS(181),
    [anon_sym_let] = ACTIONS(181),
    [anon_sym_let_BANG] = ACTIONS(183),
    [anon_sym_LPAREN] = ACTIONS(181),
    [anon_sym_COMMA] = ACTIONS(183),
    [anon_sym_null] = ACTIONS(181),
    [anon_sym_QMARK] = ACTIONS(181),
    [anon_sym_COLON_QMARK] = ACTIONS(181),
    [anon_sym_COLON_COLON] = ACTIONS(183),
    [anon_sym_AMP] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_LBRACK_PIPE] = ACTIONS(183),
    [anon_sym_LBRACE] = ACTIONS(181),
    [anon_sym_LT_AT] = ACTIONS(181),
    [anon_sym_LT_AT_AT] = ACTIONS(181),
    [anon_sym_DOT] = ACTIONS(901),
    [anon_sym_LBRACE_PIPE] = ACTIONS(183),
    [anon_sym_new] = ACTIONS(181),
    [anon_sym_return_BANG] = ACTIONS(183),
    [anon_sym_yield] = ACTIONS(181),
    [anon_sym_yield_BANG] = ACTIONS(183),
    [anon_sym_lazy] = ACTIONS(181),
    [anon_sym_assert] = ACTIONS(181),
    [anon_sym_upcast] = ACTIONS(181),
    [anon_sym_downcast] = ACTIONS(181),
    [anon_sym_COLON_GT] = ACTIONS(183),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(183),
    [anon_sym_for] = ACTIONS(181),
    [anon_sym_while] = ACTIONS(181),
    [anon_sym_if] = ACTIONS(181),
    [anon_sym_fun] = ACTIONS(181),
    [anon_sym_try] = ACTIONS(181),
    [anon_sym_match] = ACTIONS(181),
    [anon_sym_match_BANG] = ACTIONS(183),
    [anon_sym_function] = ACTIONS(181),
    [anon_sym_LT_DASH] = ACTIONS(181),
    [anon_sym_DOT_LBRACK] = ACTIONS(925),
    [anon_sym_LT] = ACTIONS(927),
    [anon_sym_use] = ACTIONS(181),
    [anon_sym_use_BANG] = ACTIONS(183),
    [anon_sym_do_BANG] = ACTIONS(183),
    [anon_sym_DOT_DOT] = ACTIONS(183),
    [anon_sym_begin] = ACTIONS(181),
    [anon_sym_LPAREN2] = ACTIONS(939),
    [anon_sym_or] = ACTIONS(181),
    [aux_sym_char_token1] = ACTIONS(183),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(181),
    [anon_sym_DQUOTE] = ACTIONS(181),
    [anon_sym_AT_DQUOTE] = ACTIONS(183),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(183),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(183),
    [sym_bool] = ACTIONS(181),
    [sym_unit] = ACTIONS(955),
    [anon_sym_LPAREN_PIPE] = ACTIONS(181),
    [sym_op_identifier] = ACTIONS(181),
    [anon_sym_PLUS] = ACTIONS(181),
    [anon_sym_DASH] = ACTIONS(181),
    [anon_sym_PLUS_DOT] = ACTIONS(181),
    [anon_sym_DASH_DOT] = ACTIONS(181),
    [anon_sym_PERCENT] = ACTIONS(181),
    [anon_sym_AMP_AMP] = ACTIONS(181),
    [anon_sym_TILDE] = ACTIONS(183),
    [aux_sym_prefix_op_token1] = ACTIONS(181),
    [aux_sym_infix_op_token1] = ACTIONS(183),
    [aux_sym_infix_op_token2] = ACTIONS(181),
    [anon_sym_PIPE_PIPE] = ACTIONS(181),
    [anon_sym_BANG_EQ] = ACTIONS(181),
    [anon_sym_COLON_EQ] = ACTIONS(183),
    [anon_sym_DOLLAR] = ACTIONS(181),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(181),
    [sym_int] = ACTIONS(181),
    [sym_xint] = ACTIONS(183),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(183),
    [sym__newline] = ACTIONS(183),
  },
  [324] = {
    [sym_function_or_value_defn] = STATE(509),
    [sym__expression] = STATE(326),
    [sym_literal_expression] = STATE(2230),
    [sym_long_identifier_or_op] = STATE(2230),
    [sym_tuple_expression] = STATE(2230),
    [sym_brace_expression] = STATE(2230),
    [sym_anon_record_expression] = STATE(2230),
    [sym_prefixed_expression] = STATE(2230),
    [sym_typecast_expression] = STATE(2230),
    [sym_for_expression] = STATE(2230),
    [sym_while_expression] = STATE(2230),
    [sym__if_branch] = STATE(6659),
    [sym_if_expression] = STATE(2230),
    [sym_fun_expression] = STATE(2230),
    [sym_try_expression] = STATE(2230),
    [sym_match_expression] = STATE(2230),
    [sym_function_expression] = STATE(2230),
    [sym_mutate_expression] = STATE(2230),
    [sym_index_expression] = STATE(2230),
    [sym_typed_expression] = STATE(2230),
    [sym_declaration_expression] = STATE(2230),
    [sym_do_expression] = STATE(2230),
    [sym_list_expression] = STATE(2230),
    [sym_array_expression] = STATE(2230),
    [sym_begin_end_expression] = STATE(2230),
    [sym_paren_expression] = STATE(2230),
    [sym__high_prec_app] = STATE(2229),
    [sym__low_prec_app] = STATE(2229),
    [sym_application_expression] = STATE(2230),
    [sym_dot_expression] = STATE(2230),
    [sym_infix_expression] = STATE(2230),
    [sym_ce_expression] = STATE(2230),
    [sym_sequential_expression] = STATE(2230),
    [sym_char] = STATE(2100),
    [sym_format_string] = STATE(2106),
    [sym__string_literal] = STATE(2106),
    [sym_string] = STATE(2100),
    [sym_verbatim_string] = STATE(2100),
    [sym_bytearray] = STATE(2100),
    [sym_verbatim_bytearray] = STATE(2100),
    [sym_format_triple_quoted_string] = STATE(2107),
    [sym_triple_quoted_string] = STATE(2100),
    [sym_const] = STATE(2230),
    [sym_long_identifier] = STATE(2232),
    [sym_active_pattern] = STATE(2424),
    [sym__identifier_or_op] = STATE(2305),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(737),
    [sym_infix_op] = STATE(694),
    [sym_sbyte] = STATE(2100),
    [sym_byte] = STATE(2100),
    [sym_int16] = STATE(2100),
    [sym_uint16] = STATE(2100),
    [sym_int32] = STATE(2100),
    [sym_uint32] = STATE(2100),
    [sym_nativeint] = STATE(2100),
    [sym_unativeint] = STATE(2100),
    [sym_int64] = STATE(2100),
    [sym_uint64] = STATE(2100),
    [sym_ieee32] = STATE(2100),
    [sym_ieee64] = STATE(2100),
    [sym_bignum] = STATE(2100),
    [sym_decimal] = STATE(2100),
    [sym_float] = STATE(1487),
    [sym_block_comment] = STATE(324),
    [sym_compiler_directive_decl] = STATE(324),
    [sym_fsi_directive_decl] = STATE(324),
    [sym_preproc_line] = STATE(324),
    [sym_preproc_if_in_expression] = STATE(2230),
    [aux_sym_sequential_expression_repeat1] = STATE(1743),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(877),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(879),
    [anon_sym_return] = ACTIONS(881),
    [anon_sym_do] = ACTIONS(1585),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(885),
    [anon_sym_COMMA] = ACTIONS(887),
    [anon_sym_null] = ACTIONS(889),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(879),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(891),
    [anon_sym_LBRACK_PIPE] = ACTIONS(893),
    [anon_sym_LBRACE] = ACTIONS(895),
    [anon_sym_LT_AT] = ACTIONS(897),
    [anon_sym_LT_AT_AT] = ACTIONS(899),
    [anon_sym_DOT] = ACTIONS(901),
    [anon_sym_LBRACE_PIPE] = ACTIONS(903),
    [anon_sym_new] = ACTIONS(881),
    [anon_sym_return_BANG] = ACTIONS(905),
    [anon_sym_yield] = ACTIONS(881),
    [anon_sym_yield_BANG] = ACTIONS(905),
    [anon_sym_lazy] = ACTIONS(881),
    [anon_sym_assert] = ACTIONS(881),
    [anon_sym_upcast] = ACTIONS(881),
    [anon_sym_downcast] = ACTIONS(881),
    [anon_sym_COLON_GT] = ACTIONS(907),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(907),
    [anon_sym_for] = ACTIONS(909),
    [anon_sym_while] = ACTIONS(911),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(913),
    [anon_sym_try] = ACTIONS(915),
    [anon_sym_match] = ACTIONS(917),
    [anon_sym_match_BANG] = ACTIONS(919),
    [anon_sym_function] = ACTIONS(921),
    [anon_sym_LT_DASH] = ACTIONS(923),
    [anon_sym_DOT_LBRACK] = ACTIONS(925),
    [anon_sym_LT] = ACTIONS(927),
    [anon_sym_use] = ACTIONS(929),
    [anon_sym_use_BANG] = ACTIONS(931),
    [anon_sym_do_BANG] = ACTIONS(933),
    [anon_sym_DOT_DOT] = ACTIONS(159),
    [anon_sym_begin] = ACTIONS(937),
    [anon_sym_LPAREN2] = ACTIONS(939),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(941),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(943),
    [anon_sym_DQUOTE] = ACTIONS(945),
    [anon_sym_AT_DQUOTE] = ACTIONS(947),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(949),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(951),
    [sym_bool] = ACTIONS(953),
    [sym_unit] = ACTIONS(955),
    [anon_sym_LPAREN_PIPE] = ACTIONS(957),
    [sym_op_identifier] = ACTIONS(959),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(961),
    [sym_xint] = ACTIONS(963),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(965),
    [sym__newline] = ACTIONS(967),
  },
  [325] = {
    [sym_function_or_value_defn] = STATE(600),
    [sym__expression] = STATE(88),
    [sym_literal_expression] = STATE(867),
    [sym_long_identifier_or_op] = STATE(867),
    [sym_tuple_expression] = STATE(867),
    [sym_brace_expression] = STATE(867),
    [sym_anon_record_expression] = STATE(867),
    [sym_prefixed_expression] = STATE(867),
    [sym_typecast_expression] = STATE(867),
    [sym_for_expression] = STATE(867),
    [sym_while_expression] = STATE(867),
    [sym__if_branch] = STATE(6511),
    [sym_if_expression] = STATE(867),
    [sym_fun_expression] = STATE(867),
    [sym_try_expression] = STATE(867),
    [sym_match_expression] = STATE(867),
    [sym_function_expression] = STATE(867),
    [sym_mutate_expression] = STATE(867),
    [sym_index_expression] = STATE(867),
    [sym_typed_expression] = STATE(867),
    [sym_declaration_expression] = STATE(867),
    [sym_do_expression] = STATE(867),
    [sym_list_expression] = STATE(867),
    [sym_array_expression] = STATE(867),
    [sym_begin_end_expression] = STATE(867),
    [sym_paren_expression] = STATE(867),
    [sym__high_prec_app] = STATE(864),
    [sym__low_prec_app] = STATE(864),
    [sym_application_expression] = STATE(867),
    [sym_dot_expression] = STATE(867),
    [sym_infix_expression] = STATE(867),
    [sym_ce_expression] = STATE(867),
    [sym_sequential_expression] = STATE(867),
    [sym_char] = STATE(868),
    [sym_format_string] = STATE(869),
    [sym__string_literal] = STATE(869),
    [sym_string] = STATE(868),
    [sym_verbatim_string] = STATE(868),
    [sym_bytearray] = STATE(868),
    [sym_verbatim_bytearray] = STATE(868),
    [sym_format_triple_quoted_string] = STATE(870),
    [sym_triple_quoted_string] = STATE(868),
    [sym_const] = STATE(867),
    [sym_long_identifier] = STATE(872),
    [sym_active_pattern] = STATE(871),
    [sym__identifier_or_op] = STATE(873),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(656),
    [sym_infix_op] = STATE(581),
    [sym_sbyte] = STATE(868),
    [sym_byte] = STATE(868),
    [sym_int16] = STATE(868),
    [sym_uint16] = STATE(868),
    [sym_int32] = STATE(868),
    [sym_uint32] = STATE(868),
    [sym_nativeint] = STATE(868),
    [sym_unativeint] = STATE(868),
    [sym_int64] = STATE(868),
    [sym_uint64] = STATE(868),
    [sym_ieee32] = STATE(868),
    [sym_ieee64] = STATE(868),
    [sym_bignum] = STATE(868),
    [sym_decimal] = STATE(868),
    [sym_float] = STATE(1368),
    [sym_block_comment] = STATE(325),
    [sym_compiler_directive_decl] = STATE(325),
    [sym_fsi_directive_decl] = STATE(325),
    [sym_preproc_line] = STATE(325),
    [sym_preproc_if_in_expression] = STATE(867),
    [aux_sym_sequential_expression_repeat1] = STATE(1542),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(29),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(825),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_COMMA] = ACTIONS(827),
    [anon_sym_null] = ACTIONS(49),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACK_PIPE] = ACTIONS(57),
    [anon_sym_LBRACE] = ACTIONS(139),
    [anon_sym_LT_AT] = ACTIONS(61),
    [anon_sym_LT_AT_AT] = ACTIONS(63),
    [anon_sym_DOT] = ACTIONS(65),
    [anon_sym_LBRACE_PIPE] = ACTIONS(67),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_return_BANG] = ACTIONS(829),
    [anon_sym_yield] = ACTIONS(825),
    [anon_sym_yield_BANG] = ACTIONS(829),
    [anon_sym_lazy] = ACTIONS(825),
    [anon_sym_assert] = ACTIONS(825),
    [anon_sym_upcast] = ACTIONS(825),
    [anon_sym_downcast] = ACTIONS(825),
    [anon_sym_COLON_GT] = ACTIONS(71),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(71),
    [anon_sym_for] = ACTIONS(73),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(79),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_match] = ACTIONS(83),
    [anon_sym_match_BANG] = ACTIONS(85),
    [anon_sym_function] = ACTIONS(87),
    [anon_sym_LT_DASH] = ACTIONS(831),
    [anon_sym_DOT_LBRACK] = ACTIONS(91),
    [anon_sym_LT] = ACTIONS(93),
    [anon_sym_use] = ACTIONS(833),
    [anon_sym_use_BANG] = ACTIONS(835),
    [anon_sym_do_BANG] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(101),
    [anon_sym_LPAREN2] = ACTIONS(103),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(105),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(107),
    [anon_sym_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DQUOTE] = ACTIONS(111),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(115),
    [sym_bool] = ACTIONS(117),
    [sym_unit] = ACTIONS(119),
    [anon_sym_LPAREN_PIPE] = ACTIONS(121),
    [sym_op_identifier] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(837),
    [sym_xint] = ACTIONS(387),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(135),
    [sym__newline] = ACTIONS(839),
    [sym__dedent] = ACTIONS(1613),
  },
  [326] = {
    [sym_function_or_value_defn] = STATE(509),
    [sym__expression] = STATE(326),
    [sym_literal_expression] = STATE(2230),
    [sym_long_identifier_or_op] = STATE(2230),
    [sym_tuple_expression] = STATE(2230),
    [sym_brace_expression] = STATE(2230),
    [sym_anon_record_expression] = STATE(2230),
    [sym_prefixed_expression] = STATE(2230),
    [sym_typecast_expression] = STATE(2230),
    [sym_for_expression] = STATE(2230),
    [sym_while_expression] = STATE(2230),
    [sym__if_branch] = STATE(6659),
    [sym_if_expression] = STATE(2230),
    [sym_fun_expression] = STATE(2230),
    [sym_try_expression] = STATE(2230),
    [sym_match_expression] = STATE(2230),
    [sym_function_expression] = STATE(2230),
    [sym_mutate_expression] = STATE(2230),
    [sym_index_expression] = STATE(2230),
    [sym_typed_expression] = STATE(2230),
    [sym_declaration_expression] = STATE(2230),
    [sym_do_expression] = STATE(2230),
    [sym_list_expression] = STATE(2230),
    [sym_array_expression] = STATE(2230),
    [sym_begin_end_expression] = STATE(2230),
    [sym_paren_expression] = STATE(2230),
    [sym__high_prec_app] = STATE(2229),
    [sym__low_prec_app] = STATE(2229),
    [sym_application_expression] = STATE(2230),
    [sym_dot_expression] = STATE(2230),
    [sym_infix_expression] = STATE(2230),
    [sym_ce_expression] = STATE(2230),
    [sym_sequential_expression] = STATE(2230),
    [sym_char] = STATE(2100),
    [sym_format_string] = STATE(2106),
    [sym__string_literal] = STATE(2106),
    [sym_string] = STATE(2100),
    [sym_verbatim_string] = STATE(2100),
    [sym_bytearray] = STATE(2100),
    [sym_verbatim_bytearray] = STATE(2100),
    [sym_format_triple_quoted_string] = STATE(2107),
    [sym_triple_quoted_string] = STATE(2100),
    [sym_const] = STATE(2230),
    [sym_long_identifier] = STATE(2232),
    [sym_active_pattern] = STATE(2424),
    [sym__identifier_or_op] = STATE(2305),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(737),
    [sym_infix_op] = STATE(694),
    [sym_sbyte] = STATE(2100),
    [sym_byte] = STATE(2100),
    [sym_int16] = STATE(2100),
    [sym_uint16] = STATE(2100),
    [sym_int32] = STATE(2100),
    [sym_uint32] = STATE(2100),
    [sym_nativeint] = STATE(2100),
    [sym_unativeint] = STATE(2100),
    [sym_int64] = STATE(2100),
    [sym_uint64] = STATE(2100),
    [sym_ieee32] = STATE(2100),
    [sym_ieee64] = STATE(2100),
    [sym_bignum] = STATE(2100),
    [sym_decimal] = STATE(2100),
    [sym_float] = STATE(1487),
    [sym_block_comment] = STATE(326),
    [sym_compiler_directive_decl] = STATE(326),
    [sym_fsi_directive_decl] = STATE(326),
    [sym_preproc_line] = STATE(326),
    [sym_preproc_if_in_expression] = STATE(2230),
    [aux_sym_sequential_expression_repeat1] = STATE(1743),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(155),
    [anon_sym_EQ] = ACTIONS(157),
    [anon_sym_COLON] = ACTIONS(155),
    [anon_sym_return] = ACTIONS(155),
    [anon_sym_do] = ACTIONS(155),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_let_BANG] = ACTIONS(157),
    [anon_sym_LPAREN] = ACTIONS(155),
    [anon_sym_COMMA] = ACTIONS(157),
    [anon_sym_null] = ACTIONS(155),
    [anon_sym_QMARK] = ACTIONS(155),
    [anon_sym_COLON_QMARK] = ACTIONS(155),
    [anon_sym_COLON_COLON] = ACTIONS(157),
    [anon_sym_AMP] = ACTIONS(155),
    [anon_sym_LBRACK] = ACTIONS(155),
    [anon_sym_LBRACK_PIPE] = ACTIONS(157),
    [anon_sym_LBRACE] = ACTIONS(155),
    [anon_sym_LT_AT] = ACTIONS(155),
    [anon_sym_LT_AT_AT] = ACTIONS(155),
    [anon_sym_DOT] = ACTIONS(901),
    [anon_sym_LBRACE_PIPE] = ACTIONS(157),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_return_BANG] = ACTIONS(157),
    [anon_sym_yield] = ACTIONS(155),
    [anon_sym_yield_BANG] = ACTIONS(157),
    [anon_sym_lazy] = ACTIONS(155),
    [anon_sym_assert] = ACTIONS(155),
    [anon_sym_upcast] = ACTIONS(155),
    [anon_sym_downcast] = ACTIONS(155),
    [anon_sym_COLON_GT] = ACTIONS(157),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(157),
    [anon_sym_for] = ACTIONS(155),
    [anon_sym_while] = ACTIONS(155),
    [anon_sym_if] = ACTIONS(155),
    [anon_sym_fun] = ACTIONS(155),
    [anon_sym_try] = ACTIONS(155),
    [anon_sym_match] = ACTIONS(155),
    [anon_sym_match_BANG] = ACTIONS(157),
    [anon_sym_function] = ACTIONS(155),
    [anon_sym_LT_DASH] = ACTIONS(155),
    [anon_sym_DOT_LBRACK] = ACTIONS(925),
    [anon_sym_LT] = ACTIONS(927),
    [anon_sym_use] = ACTIONS(155),
    [anon_sym_use_BANG] = ACTIONS(157),
    [anon_sym_do_BANG] = ACTIONS(157),
    [anon_sym_DOT_DOT] = ACTIONS(157),
    [anon_sym_begin] = ACTIONS(155),
    [anon_sym_LPAREN2] = ACTIONS(939),
    [anon_sym_or] = ACTIONS(155),
    [aux_sym_char_token1] = ACTIONS(157),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(155),
    [anon_sym_DQUOTE] = ACTIONS(155),
    [anon_sym_AT_DQUOTE] = ACTIONS(157),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(157),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(157),
    [sym_bool] = ACTIONS(155),
    [sym_unit] = ACTIONS(955),
    [anon_sym_LPAREN_PIPE] = ACTIONS(155),
    [sym_op_identifier] = ACTIONS(155),
    [anon_sym_PLUS] = ACTIONS(155),
    [anon_sym_DASH] = ACTIONS(155),
    [anon_sym_PLUS_DOT] = ACTIONS(155),
    [anon_sym_DASH_DOT] = ACTIONS(155),
    [anon_sym_PERCENT] = ACTIONS(155),
    [anon_sym_AMP_AMP] = ACTIONS(155),
    [anon_sym_TILDE] = ACTIONS(157),
    [aux_sym_prefix_op_token1] = ACTIONS(155),
    [aux_sym_infix_op_token1] = ACTIONS(157),
    [aux_sym_infix_op_token2] = ACTIONS(155),
    [anon_sym_PIPE_PIPE] = ACTIONS(155),
    [anon_sym_BANG_EQ] = ACTIONS(155),
    [anon_sym_COLON_EQ] = ACTIONS(157),
    [anon_sym_DOLLAR] = ACTIONS(155),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(155),
    [sym_int] = ACTIONS(155),
    [sym_xint] = ACTIONS(157),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(157),
    [sym__newline] = ACTIONS(157),
  },
  [327] = {
    [sym_function_or_value_defn] = STATE(627),
    [sym__expression] = STATE(17),
    [sym_literal_expression] = STATE(1118),
    [sym_long_identifier_or_op] = STATE(1118),
    [sym_tuple_expression] = STATE(1118),
    [sym_brace_expression] = STATE(1118),
    [sym_anon_record_expression] = STATE(1118),
    [sym_prefixed_expression] = STATE(1118),
    [sym_typecast_expression] = STATE(1118),
    [sym_for_expression] = STATE(1118),
    [sym_while_expression] = STATE(1118),
    [sym__if_branch] = STATE(7163),
    [sym_if_expression] = STATE(1118),
    [sym_fun_expression] = STATE(1118),
    [sym_try_expression] = STATE(1118),
    [sym_match_expression] = STATE(1118),
    [sym_function_expression] = STATE(1118),
    [sym_mutate_expression] = STATE(1118),
    [sym_index_expression] = STATE(1118),
    [sym_typed_expression] = STATE(1118),
    [sym_declaration_expression] = STATE(1118),
    [sym_do_expression] = STATE(1118),
    [sym_list_expression] = STATE(1118),
    [sym_array_expression] = STATE(1118),
    [sym_begin_end_expression] = STATE(1118),
    [sym_paren_expression] = STATE(1118),
    [sym__high_prec_app] = STATE(1133),
    [sym__low_prec_app] = STATE(1133),
    [sym_application_expression] = STATE(1118),
    [sym_dot_expression] = STATE(1118),
    [sym_infix_expression] = STATE(1118),
    [sym_ce_expression] = STATE(1118),
    [sym_sequential_expression] = STATE(1118),
    [sym_char] = STATE(1080),
    [sym_format_string] = STATE(1090),
    [sym__string_literal] = STATE(1090),
    [sym_string] = STATE(1080),
    [sym_verbatim_string] = STATE(1080),
    [sym_bytearray] = STATE(1080),
    [sym_verbatim_bytearray] = STATE(1080),
    [sym_format_triple_quoted_string] = STATE(1096),
    [sym_triple_quoted_string] = STATE(1080),
    [sym_const] = STATE(1118),
    [sym_long_identifier] = STATE(1156),
    [sym_active_pattern] = STATE(1085),
    [sym__identifier_or_op] = STATE(1099),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(517),
    [sym_infix_op] = STATE(487),
    [sym_sbyte] = STATE(1080),
    [sym_byte] = STATE(1080),
    [sym_int16] = STATE(1080),
    [sym_uint16] = STATE(1080),
    [sym_int32] = STATE(1080),
    [sym_uint32] = STATE(1080),
    [sym_nativeint] = STATE(1080),
    [sym_unativeint] = STATE(1080),
    [sym_int64] = STATE(1080),
    [sym_uint64] = STATE(1080),
    [sym_ieee32] = STATE(1080),
    [sym_ieee64] = STATE(1080),
    [sym_bignum] = STATE(1080),
    [sym_decimal] = STATE(1080),
    [sym_float] = STATE(979),
    [sym_block_comment] = STATE(327),
    [sym_compiler_directive_decl] = STATE(327),
    [sym_fsi_directive_decl] = STATE(327),
    [sym_preproc_line] = STATE(327),
    [sym_preproc_if_in_expression] = STATE(1118),
    [aux_sym_sequential_expression_repeat1] = STATE(1069),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(195),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(197),
    [anon_sym_return] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(1615),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_COMMA] = ACTIONS(205),
    [anon_sym_null] = ACTIONS(207),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(197),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(209),
    [anon_sym_LBRACK_PIPE] = ACTIONS(211),
    [anon_sym_LBRACE] = ACTIONS(271),
    [anon_sym_LT_AT] = ACTIONS(213),
    [anon_sym_LT_AT_AT] = ACTIONS(215),
    [anon_sym_DOT] = ACTIONS(185),
    [anon_sym_LBRACE_PIPE] = ACTIONS(217),
    [anon_sym_new] = ACTIONS(199),
    [anon_sym_return_BANG] = ACTIONS(219),
    [anon_sym_yield] = ACTIONS(199),
    [anon_sym_yield_BANG] = ACTIONS(219),
    [anon_sym_lazy] = ACTIONS(199),
    [anon_sym_assert] = ACTIONS(199),
    [anon_sym_upcast] = ACTIONS(199),
    [anon_sym_downcast] = ACTIONS(199),
    [anon_sym_COLON_GT] = ACTIONS(221),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(221),
    [anon_sym_for] = ACTIONS(223),
    [anon_sym_while] = ACTIONS(225),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(229),
    [anon_sym_match] = ACTIONS(231),
    [anon_sym_match_BANG] = ACTIONS(233),
    [anon_sym_function] = ACTIONS(235),
    [anon_sym_LT_DASH] = ACTIONS(237),
    [anon_sym_DOT_LBRACK] = ACTIONS(187),
    [anon_sym_LT] = ACTIONS(189),
    [anon_sym_use] = ACTIONS(239),
    [anon_sym_use_BANG] = ACTIONS(241),
    [anon_sym_do_BANG] = ACTIONS(243),
    [anon_sym_begin] = ACTIONS(245),
    [anon_sym_LPAREN2] = ACTIONS(191),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(247),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(251),
    [anon_sym_AT_DQUOTE] = ACTIONS(253),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(255),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(257),
    [sym_bool] = ACTIONS(259),
    [sym_unit] = ACTIONS(193),
    [anon_sym_LPAREN_PIPE] = ACTIONS(261),
    [sym_op_identifier] = ACTIONS(263),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(265),
    [sym_xint] = ACTIONS(267),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(269),
    [sym__newline] = ACTIONS(273),
  },
  [328] = {
    [sym_function_or_value_defn] = STATE(627),
    [sym__expression] = STATE(17),
    [sym_literal_expression] = STATE(1118),
    [sym_long_identifier_or_op] = STATE(1118),
    [sym_tuple_expression] = STATE(1118),
    [sym_brace_expression] = STATE(1118),
    [sym_anon_record_expression] = STATE(1118),
    [sym_prefixed_expression] = STATE(1118),
    [sym_typecast_expression] = STATE(1118),
    [sym_for_expression] = STATE(1118),
    [sym_while_expression] = STATE(1118),
    [sym__if_branch] = STATE(7163),
    [sym_if_expression] = STATE(1118),
    [sym_fun_expression] = STATE(1118),
    [sym_try_expression] = STATE(1118),
    [sym_match_expression] = STATE(1118),
    [sym_function_expression] = STATE(1118),
    [sym_mutate_expression] = STATE(1118),
    [sym_index_expression] = STATE(1118),
    [sym_typed_expression] = STATE(1118),
    [sym_declaration_expression] = STATE(1118),
    [sym_do_expression] = STATE(1118),
    [sym_list_expression] = STATE(1118),
    [sym_array_expression] = STATE(1118),
    [sym_begin_end_expression] = STATE(1118),
    [sym_paren_expression] = STATE(1118),
    [sym__high_prec_app] = STATE(1133),
    [sym__low_prec_app] = STATE(1133),
    [sym_application_expression] = STATE(1118),
    [sym_dot_expression] = STATE(1118),
    [sym_infix_expression] = STATE(1118),
    [sym_ce_expression] = STATE(1118),
    [sym_sequential_expression] = STATE(1118),
    [sym_char] = STATE(1080),
    [sym_format_string] = STATE(1090),
    [sym__string_literal] = STATE(1090),
    [sym_string] = STATE(1080),
    [sym_verbatim_string] = STATE(1080),
    [sym_bytearray] = STATE(1080),
    [sym_verbatim_bytearray] = STATE(1080),
    [sym_format_triple_quoted_string] = STATE(1096),
    [sym_triple_quoted_string] = STATE(1080),
    [sym_const] = STATE(1118),
    [sym_long_identifier] = STATE(1156),
    [sym_active_pattern] = STATE(1085),
    [sym__identifier_or_op] = STATE(1099),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(517),
    [sym_infix_op] = STATE(487),
    [sym_sbyte] = STATE(1080),
    [sym_byte] = STATE(1080),
    [sym_int16] = STATE(1080),
    [sym_uint16] = STATE(1080),
    [sym_int32] = STATE(1080),
    [sym_uint32] = STATE(1080),
    [sym_nativeint] = STATE(1080),
    [sym_unativeint] = STATE(1080),
    [sym_int64] = STATE(1080),
    [sym_uint64] = STATE(1080),
    [sym_ieee32] = STATE(1080),
    [sym_ieee64] = STATE(1080),
    [sym_bignum] = STATE(1080),
    [sym_decimal] = STATE(1080),
    [sym_float] = STATE(979),
    [sym_block_comment] = STATE(328),
    [sym_compiler_directive_decl] = STATE(328),
    [sym_fsi_directive_decl] = STATE(328),
    [sym_preproc_line] = STATE(328),
    [sym_preproc_if_in_expression] = STATE(1118),
    [aux_sym_sequential_expression_repeat1] = STATE(1069),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(195),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(197),
    [anon_sym_return] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(1617),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_COMMA] = ACTIONS(205),
    [anon_sym_null] = ACTIONS(207),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(197),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(209),
    [anon_sym_LBRACK_PIPE] = ACTIONS(211),
    [anon_sym_LBRACE] = ACTIONS(271),
    [anon_sym_LT_AT] = ACTIONS(213),
    [anon_sym_LT_AT_AT] = ACTIONS(215),
    [anon_sym_DOT] = ACTIONS(185),
    [anon_sym_LBRACE_PIPE] = ACTIONS(217),
    [anon_sym_new] = ACTIONS(199),
    [anon_sym_return_BANG] = ACTIONS(219),
    [anon_sym_yield] = ACTIONS(199),
    [anon_sym_yield_BANG] = ACTIONS(219),
    [anon_sym_lazy] = ACTIONS(199),
    [anon_sym_assert] = ACTIONS(199),
    [anon_sym_upcast] = ACTIONS(199),
    [anon_sym_downcast] = ACTIONS(199),
    [anon_sym_COLON_GT] = ACTIONS(221),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(221),
    [anon_sym_for] = ACTIONS(223),
    [anon_sym_while] = ACTIONS(225),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(229),
    [anon_sym_match] = ACTIONS(231),
    [anon_sym_match_BANG] = ACTIONS(233),
    [anon_sym_function] = ACTIONS(235),
    [anon_sym_LT_DASH] = ACTIONS(237),
    [anon_sym_DOT_LBRACK] = ACTIONS(187),
    [anon_sym_LT] = ACTIONS(189),
    [anon_sym_use] = ACTIONS(239),
    [anon_sym_use_BANG] = ACTIONS(241),
    [anon_sym_do_BANG] = ACTIONS(243),
    [anon_sym_begin] = ACTIONS(245),
    [anon_sym_LPAREN2] = ACTIONS(191),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(247),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(251),
    [anon_sym_AT_DQUOTE] = ACTIONS(253),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(255),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(257),
    [sym_bool] = ACTIONS(259),
    [sym_unit] = ACTIONS(193),
    [anon_sym_LPAREN_PIPE] = ACTIONS(261),
    [sym_op_identifier] = ACTIONS(263),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(265),
    [sym_xint] = ACTIONS(267),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(269),
    [sym__newline] = ACTIONS(273),
  },
  [329] = {
    [sym_function_or_value_defn] = STATE(627),
    [sym__expression] = STATE(17),
    [sym_literal_expression] = STATE(1118),
    [sym_long_identifier_or_op] = STATE(1118),
    [sym_tuple_expression] = STATE(1118),
    [sym_brace_expression] = STATE(1118),
    [sym_anon_record_expression] = STATE(1118),
    [sym_prefixed_expression] = STATE(1118),
    [sym_typecast_expression] = STATE(1118),
    [sym_for_expression] = STATE(1118),
    [sym_while_expression] = STATE(1118),
    [sym__if_branch] = STATE(7163),
    [sym_if_expression] = STATE(1118),
    [sym_fun_expression] = STATE(1118),
    [sym_try_expression] = STATE(1118),
    [sym_match_expression] = STATE(1118),
    [sym_function_expression] = STATE(1118),
    [sym_mutate_expression] = STATE(1118),
    [sym_index_expression] = STATE(1118),
    [sym_typed_expression] = STATE(1118),
    [sym_declaration_expression] = STATE(1118),
    [sym_do_expression] = STATE(1118),
    [sym_list_expression] = STATE(1118),
    [sym_array_expression] = STATE(1118),
    [sym_begin_end_expression] = STATE(1118),
    [sym_paren_expression] = STATE(1118),
    [sym__high_prec_app] = STATE(1133),
    [sym__low_prec_app] = STATE(1133),
    [sym_application_expression] = STATE(1118),
    [sym_dot_expression] = STATE(1118),
    [sym_infix_expression] = STATE(1118),
    [sym_ce_expression] = STATE(1118),
    [sym_sequential_expression] = STATE(1118),
    [sym_char] = STATE(1080),
    [sym_format_string] = STATE(1090),
    [sym__string_literal] = STATE(1090),
    [sym_string] = STATE(1080),
    [sym_verbatim_string] = STATE(1080),
    [sym_bytearray] = STATE(1080),
    [sym_verbatim_bytearray] = STATE(1080),
    [sym_format_triple_quoted_string] = STATE(1096),
    [sym_triple_quoted_string] = STATE(1080),
    [sym_const] = STATE(1118),
    [sym_long_identifier] = STATE(1156),
    [sym_active_pattern] = STATE(1085),
    [sym__identifier_or_op] = STATE(1099),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(517),
    [sym_infix_op] = STATE(487),
    [sym_sbyte] = STATE(1080),
    [sym_byte] = STATE(1080),
    [sym_int16] = STATE(1080),
    [sym_uint16] = STATE(1080),
    [sym_int32] = STATE(1080),
    [sym_uint32] = STATE(1080),
    [sym_nativeint] = STATE(1080),
    [sym_unativeint] = STATE(1080),
    [sym_int64] = STATE(1080),
    [sym_uint64] = STATE(1080),
    [sym_ieee32] = STATE(1080),
    [sym_ieee64] = STATE(1080),
    [sym_bignum] = STATE(1080),
    [sym_decimal] = STATE(1080),
    [sym_float] = STATE(979),
    [sym_block_comment] = STATE(329),
    [sym_compiler_directive_decl] = STATE(329),
    [sym_fsi_directive_decl] = STATE(329),
    [sym_preproc_line] = STATE(329),
    [sym_preproc_if_in_expression] = STATE(1118),
    [aux_sym_sequential_expression_repeat1] = STATE(1069),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(195),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(197),
    [anon_sym_return] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(1619),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_COMMA] = ACTIONS(205),
    [anon_sym_null] = ACTIONS(207),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(197),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(209),
    [anon_sym_LBRACK_PIPE] = ACTIONS(211),
    [anon_sym_LBRACE] = ACTIONS(271),
    [anon_sym_LT_AT] = ACTIONS(213),
    [anon_sym_LT_AT_AT] = ACTIONS(215),
    [anon_sym_DOT] = ACTIONS(185),
    [anon_sym_LBRACE_PIPE] = ACTIONS(217),
    [anon_sym_new] = ACTIONS(199),
    [anon_sym_return_BANG] = ACTIONS(219),
    [anon_sym_yield] = ACTIONS(199),
    [anon_sym_yield_BANG] = ACTIONS(219),
    [anon_sym_lazy] = ACTIONS(199),
    [anon_sym_assert] = ACTIONS(199),
    [anon_sym_upcast] = ACTIONS(199),
    [anon_sym_downcast] = ACTIONS(199),
    [anon_sym_COLON_GT] = ACTIONS(221),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(221),
    [anon_sym_for] = ACTIONS(223),
    [anon_sym_while] = ACTIONS(225),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(229),
    [anon_sym_match] = ACTIONS(231),
    [anon_sym_match_BANG] = ACTIONS(233),
    [anon_sym_function] = ACTIONS(235),
    [anon_sym_LT_DASH] = ACTIONS(237),
    [anon_sym_DOT_LBRACK] = ACTIONS(187),
    [anon_sym_LT] = ACTIONS(189),
    [anon_sym_use] = ACTIONS(239),
    [anon_sym_use_BANG] = ACTIONS(241),
    [anon_sym_do_BANG] = ACTIONS(243),
    [anon_sym_begin] = ACTIONS(245),
    [anon_sym_LPAREN2] = ACTIONS(191),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(247),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(251),
    [anon_sym_AT_DQUOTE] = ACTIONS(253),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(255),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(257),
    [sym_bool] = ACTIONS(259),
    [sym_unit] = ACTIONS(193),
    [anon_sym_LPAREN_PIPE] = ACTIONS(261),
    [sym_op_identifier] = ACTIONS(263),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(265),
    [sym_xint] = ACTIONS(267),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(269),
    [sym__newline] = ACTIONS(273),
  },
  [330] = {
    [sym_function_or_value_defn] = STATE(627),
    [sym__expression] = STATE(17),
    [sym_literal_expression] = STATE(1118),
    [sym_long_identifier_or_op] = STATE(1118),
    [sym_tuple_expression] = STATE(1118),
    [sym_brace_expression] = STATE(1118),
    [sym_anon_record_expression] = STATE(1118),
    [sym_prefixed_expression] = STATE(1118),
    [sym_typecast_expression] = STATE(1118),
    [sym_for_expression] = STATE(1118),
    [sym_while_expression] = STATE(1118),
    [sym__if_branch] = STATE(7163),
    [sym_if_expression] = STATE(1118),
    [sym_fun_expression] = STATE(1118),
    [sym_try_expression] = STATE(1118),
    [sym_match_expression] = STATE(1118),
    [sym_function_expression] = STATE(1118),
    [sym_mutate_expression] = STATE(1118),
    [sym_index_expression] = STATE(1118),
    [sym_typed_expression] = STATE(1118),
    [sym_declaration_expression] = STATE(1118),
    [sym_do_expression] = STATE(1118),
    [sym_list_expression] = STATE(1118),
    [sym_array_expression] = STATE(1118),
    [sym_begin_end_expression] = STATE(1118),
    [sym_paren_expression] = STATE(1118),
    [sym__high_prec_app] = STATE(1133),
    [sym__low_prec_app] = STATE(1133),
    [sym_application_expression] = STATE(1118),
    [sym_dot_expression] = STATE(1118),
    [sym_infix_expression] = STATE(1118),
    [sym_ce_expression] = STATE(1118),
    [sym_sequential_expression] = STATE(1118),
    [sym_char] = STATE(1080),
    [sym_format_string] = STATE(1090),
    [sym__string_literal] = STATE(1090),
    [sym_string] = STATE(1080),
    [sym_verbatim_string] = STATE(1080),
    [sym_bytearray] = STATE(1080),
    [sym_verbatim_bytearray] = STATE(1080),
    [sym_format_triple_quoted_string] = STATE(1096),
    [sym_triple_quoted_string] = STATE(1080),
    [sym_const] = STATE(1118),
    [sym_long_identifier] = STATE(1156),
    [sym_active_pattern] = STATE(1085),
    [sym__identifier_or_op] = STATE(1099),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(517),
    [sym_infix_op] = STATE(487),
    [sym_sbyte] = STATE(1080),
    [sym_byte] = STATE(1080),
    [sym_int16] = STATE(1080),
    [sym_uint16] = STATE(1080),
    [sym_int32] = STATE(1080),
    [sym_uint32] = STATE(1080),
    [sym_nativeint] = STATE(1080),
    [sym_unativeint] = STATE(1080),
    [sym_int64] = STATE(1080),
    [sym_uint64] = STATE(1080),
    [sym_ieee32] = STATE(1080),
    [sym_ieee64] = STATE(1080),
    [sym_bignum] = STATE(1080),
    [sym_decimal] = STATE(1080),
    [sym_float] = STATE(979),
    [sym_block_comment] = STATE(330),
    [sym_compiler_directive_decl] = STATE(330),
    [sym_fsi_directive_decl] = STATE(330),
    [sym_preproc_line] = STATE(330),
    [sym_preproc_if_in_expression] = STATE(1118),
    [aux_sym_sequential_expression_repeat1] = STATE(1069),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(195),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(197),
    [anon_sym_return] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(1621),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_COMMA] = ACTIONS(205),
    [anon_sym_null] = ACTIONS(207),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(197),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(209),
    [anon_sym_LBRACK_PIPE] = ACTIONS(211),
    [anon_sym_LBRACE] = ACTIONS(271),
    [anon_sym_LT_AT] = ACTIONS(213),
    [anon_sym_LT_AT_AT] = ACTIONS(215),
    [anon_sym_DOT] = ACTIONS(185),
    [anon_sym_LBRACE_PIPE] = ACTIONS(217),
    [anon_sym_new] = ACTIONS(199),
    [anon_sym_return_BANG] = ACTIONS(219),
    [anon_sym_yield] = ACTIONS(199),
    [anon_sym_yield_BANG] = ACTIONS(219),
    [anon_sym_lazy] = ACTIONS(199),
    [anon_sym_assert] = ACTIONS(199),
    [anon_sym_upcast] = ACTIONS(199),
    [anon_sym_downcast] = ACTIONS(199),
    [anon_sym_COLON_GT] = ACTIONS(221),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(221),
    [anon_sym_for] = ACTIONS(223),
    [anon_sym_while] = ACTIONS(225),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(229),
    [anon_sym_match] = ACTIONS(231),
    [anon_sym_match_BANG] = ACTIONS(233),
    [anon_sym_function] = ACTIONS(235),
    [anon_sym_LT_DASH] = ACTIONS(237),
    [anon_sym_DOT_LBRACK] = ACTIONS(187),
    [anon_sym_LT] = ACTIONS(189),
    [anon_sym_use] = ACTIONS(239),
    [anon_sym_use_BANG] = ACTIONS(241),
    [anon_sym_do_BANG] = ACTIONS(243),
    [anon_sym_begin] = ACTIONS(245),
    [anon_sym_LPAREN2] = ACTIONS(191),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(247),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(251),
    [anon_sym_AT_DQUOTE] = ACTIONS(253),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(255),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(257),
    [sym_bool] = ACTIONS(259),
    [sym_unit] = ACTIONS(193),
    [anon_sym_LPAREN_PIPE] = ACTIONS(261),
    [sym_op_identifier] = ACTIONS(263),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(265),
    [sym_xint] = ACTIONS(267),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(269),
    [sym__newline] = ACTIONS(273),
  },
  [331] = {
    [sym_function_or_value_defn] = STATE(627),
    [sym__expression] = STATE(17),
    [sym_literal_expression] = STATE(1118),
    [sym_long_identifier_or_op] = STATE(1118),
    [sym_tuple_expression] = STATE(1118),
    [sym_brace_expression] = STATE(1118),
    [sym_anon_record_expression] = STATE(1118),
    [sym_prefixed_expression] = STATE(1118),
    [sym_typecast_expression] = STATE(1118),
    [sym_for_expression] = STATE(1118),
    [sym_while_expression] = STATE(1118),
    [sym__if_branch] = STATE(7163),
    [sym_if_expression] = STATE(1118),
    [sym_fun_expression] = STATE(1118),
    [sym_try_expression] = STATE(1118),
    [sym_match_expression] = STATE(1118),
    [sym_function_expression] = STATE(1118),
    [sym_mutate_expression] = STATE(1118),
    [sym_index_expression] = STATE(1118),
    [sym_typed_expression] = STATE(1118),
    [sym_declaration_expression] = STATE(1118),
    [sym_do_expression] = STATE(1118),
    [sym_list_expression] = STATE(1118),
    [sym_array_expression] = STATE(1118),
    [sym_begin_end_expression] = STATE(1118),
    [sym_paren_expression] = STATE(1118),
    [sym__high_prec_app] = STATE(1133),
    [sym__low_prec_app] = STATE(1133),
    [sym_application_expression] = STATE(1118),
    [sym_dot_expression] = STATE(1118),
    [sym_infix_expression] = STATE(1118),
    [sym_ce_expression] = STATE(1118),
    [sym_sequential_expression] = STATE(1118),
    [sym_char] = STATE(1080),
    [sym_format_string] = STATE(1090),
    [sym__string_literal] = STATE(1090),
    [sym_string] = STATE(1080),
    [sym_verbatim_string] = STATE(1080),
    [sym_bytearray] = STATE(1080),
    [sym_verbatim_bytearray] = STATE(1080),
    [sym_format_triple_quoted_string] = STATE(1096),
    [sym_triple_quoted_string] = STATE(1080),
    [sym_const] = STATE(1118),
    [sym_long_identifier] = STATE(1156),
    [sym_active_pattern] = STATE(1085),
    [sym__identifier_or_op] = STATE(1099),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(517),
    [sym_infix_op] = STATE(487),
    [sym_sbyte] = STATE(1080),
    [sym_byte] = STATE(1080),
    [sym_int16] = STATE(1080),
    [sym_uint16] = STATE(1080),
    [sym_int32] = STATE(1080),
    [sym_uint32] = STATE(1080),
    [sym_nativeint] = STATE(1080),
    [sym_unativeint] = STATE(1080),
    [sym_int64] = STATE(1080),
    [sym_uint64] = STATE(1080),
    [sym_ieee32] = STATE(1080),
    [sym_ieee64] = STATE(1080),
    [sym_bignum] = STATE(1080),
    [sym_decimal] = STATE(1080),
    [sym_float] = STATE(979),
    [sym_block_comment] = STATE(331),
    [sym_compiler_directive_decl] = STATE(331),
    [sym_fsi_directive_decl] = STATE(331),
    [sym_preproc_line] = STATE(331),
    [sym_preproc_if_in_expression] = STATE(1118),
    [aux_sym_sequential_expression_repeat1] = STATE(1069),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(195),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(197),
    [anon_sym_return] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(1623),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_COMMA] = ACTIONS(205),
    [anon_sym_null] = ACTIONS(207),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(197),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(209),
    [anon_sym_LBRACK_PIPE] = ACTIONS(211),
    [anon_sym_LBRACE] = ACTIONS(271),
    [anon_sym_LT_AT] = ACTIONS(213),
    [anon_sym_LT_AT_AT] = ACTIONS(215),
    [anon_sym_DOT] = ACTIONS(185),
    [anon_sym_LBRACE_PIPE] = ACTIONS(217),
    [anon_sym_new] = ACTIONS(199),
    [anon_sym_return_BANG] = ACTIONS(219),
    [anon_sym_yield] = ACTIONS(199),
    [anon_sym_yield_BANG] = ACTIONS(219),
    [anon_sym_lazy] = ACTIONS(199),
    [anon_sym_assert] = ACTIONS(199),
    [anon_sym_upcast] = ACTIONS(199),
    [anon_sym_downcast] = ACTIONS(199),
    [anon_sym_COLON_GT] = ACTIONS(221),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(221),
    [anon_sym_for] = ACTIONS(223),
    [anon_sym_while] = ACTIONS(225),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(229),
    [anon_sym_match] = ACTIONS(231),
    [anon_sym_match_BANG] = ACTIONS(233),
    [anon_sym_function] = ACTIONS(235),
    [anon_sym_LT_DASH] = ACTIONS(237),
    [anon_sym_DOT_LBRACK] = ACTIONS(187),
    [anon_sym_LT] = ACTIONS(189),
    [anon_sym_use] = ACTIONS(239),
    [anon_sym_use_BANG] = ACTIONS(241),
    [anon_sym_do_BANG] = ACTIONS(243),
    [anon_sym_begin] = ACTIONS(245),
    [anon_sym_LPAREN2] = ACTIONS(191),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(247),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(251),
    [anon_sym_AT_DQUOTE] = ACTIONS(253),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(255),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(257),
    [sym_bool] = ACTIONS(259),
    [sym_unit] = ACTIONS(193),
    [anon_sym_LPAREN_PIPE] = ACTIONS(261),
    [sym_op_identifier] = ACTIONS(263),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(265),
    [sym_xint] = ACTIONS(267),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(269),
    [sym__newline] = ACTIONS(273),
  },
  [332] = {
    [sym_function_or_value_defn] = STATE(627),
    [sym__expression] = STATE(17),
    [sym_literal_expression] = STATE(1118),
    [sym_long_identifier_or_op] = STATE(1118),
    [sym_tuple_expression] = STATE(1118),
    [sym_brace_expression] = STATE(1118),
    [sym_anon_record_expression] = STATE(1118),
    [sym_prefixed_expression] = STATE(1118),
    [sym_typecast_expression] = STATE(1118),
    [sym_for_expression] = STATE(1118),
    [sym_while_expression] = STATE(1118),
    [sym__if_branch] = STATE(7163),
    [sym_if_expression] = STATE(1118),
    [sym_fun_expression] = STATE(1118),
    [sym_try_expression] = STATE(1118),
    [sym_match_expression] = STATE(1118),
    [sym_function_expression] = STATE(1118),
    [sym_mutate_expression] = STATE(1118),
    [sym_index_expression] = STATE(1118),
    [sym_typed_expression] = STATE(1118),
    [sym_declaration_expression] = STATE(1118),
    [sym_do_expression] = STATE(1118),
    [sym_list_expression] = STATE(1118),
    [sym_array_expression] = STATE(1118),
    [sym_begin_end_expression] = STATE(1118),
    [sym_paren_expression] = STATE(1118),
    [sym__high_prec_app] = STATE(1133),
    [sym__low_prec_app] = STATE(1133),
    [sym_application_expression] = STATE(1118),
    [sym_dot_expression] = STATE(1118),
    [sym_infix_expression] = STATE(1118),
    [sym_ce_expression] = STATE(1118),
    [sym_sequential_expression] = STATE(1118),
    [sym_char] = STATE(1080),
    [sym_format_string] = STATE(1090),
    [sym__string_literal] = STATE(1090),
    [sym_string] = STATE(1080),
    [sym_verbatim_string] = STATE(1080),
    [sym_bytearray] = STATE(1080),
    [sym_verbatim_bytearray] = STATE(1080),
    [sym_format_triple_quoted_string] = STATE(1096),
    [sym_triple_quoted_string] = STATE(1080),
    [sym_const] = STATE(1118),
    [sym_long_identifier] = STATE(1156),
    [sym_active_pattern] = STATE(1085),
    [sym__identifier_or_op] = STATE(1099),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(517),
    [sym_infix_op] = STATE(487),
    [sym_sbyte] = STATE(1080),
    [sym_byte] = STATE(1080),
    [sym_int16] = STATE(1080),
    [sym_uint16] = STATE(1080),
    [sym_int32] = STATE(1080),
    [sym_uint32] = STATE(1080),
    [sym_nativeint] = STATE(1080),
    [sym_unativeint] = STATE(1080),
    [sym_int64] = STATE(1080),
    [sym_uint64] = STATE(1080),
    [sym_ieee32] = STATE(1080),
    [sym_ieee64] = STATE(1080),
    [sym_bignum] = STATE(1080),
    [sym_decimal] = STATE(1080),
    [sym_float] = STATE(979),
    [sym_block_comment] = STATE(332),
    [sym_compiler_directive_decl] = STATE(332),
    [sym_fsi_directive_decl] = STATE(332),
    [sym_preproc_line] = STATE(332),
    [sym_preproc_if_in_expression] = STATE(1118),
    [aux_sym_sequential_expression_repeat1] = STATE(1069),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(195),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(197),
    [anon_sym_return] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(1625),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_COMMA] = ACTIONS(205),
    [anon_sym_null] = ACTIONS(207),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(197),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(209),
    [anon_sym_LBRACK_PIPE] = ACTIONS(211),
    [anon_sym_LBRACE] = ACTIONS(271),
    [anon_sym_LT_AT] = ACTIONS(213),
    [anon_sym_LT_AT_AT] = ACTIONS(215),
    [anon_sym_DOT] = ACTIONS(185),
    [anon_sym_LBRACE_PIPE] = ACTIONS(217),
    [anon_sym_new] = ACTIONS(199),
    [anon_sym_return_BANG] = ACTIONS(219),
    [anon_sym_yield] = ACTIONS(199),
    [anon_sym_yield_BANG] = ACTIONS(219),
    [anon_sym_lazy] = ACTIONS(199),
    [anon_sym_assert] = ACTIONS(199),
    [anon_sym_upcast] = ACTIONS(199),
    [anon_sym_downcast] = ACTIONS(199),
    [anon_sym_COLON_GT] = ACTIONS(221),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(221),
    [anon_sym_for] = ACTIONS(223),
    [anon_sym_while] = ACTIONS(225),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(229),
    [anon_sym_match] = ACTIONS(231),
    [anon_sym_match_BANG] = ACTIONS(233),
    [anon_sym_function] = ACTIONS(235),
    [anon_sym_LT_DASH] = ACTIONS(237),
    [anon_sym_DOT_LBRACK] = ACTIONS(187),
    [anon_sym_LT] = ACTIONS(189),
    [anon_sym_use] = ACTIONS(239),
    [anon_sym_use_BANG] = ACTIONS(241),
    [anon_sym_do_BANG] = ACTIONS(243),
    [anon_sym_begin] = ACTIONS(245),
    [anon_sym_LPAREN2] = ACTIONS(191),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(247),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(251),
    [anon_sym_AT_DQUOTE] = ACTIONS(253),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(255),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(257),
    [sym_bool] = ACTIONS(259),
    [sym_unit] = ACTIONS(193),
    [anon_sym_LPAREN_PIPE] = ACTIONS(261),
    [sym_op_identifier] = ACTIONS(263),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(265),
    [sym_xint] = ACTIONS(267),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(269),
    [sym__newline] = ACTIONS(273),
  },
  [333] = {
    [sym_function_or_value_defn] = STATE(627),
    [sym__expression] = STATE(17),
    [sym_literal_expression] = STATE(1118),
    [sym_long_identifier_or_op] = STATE(1118),
    [sym_tuple_expression] = STATE(1118),
    [sym_brace_expression] = STATE(1118),
    [sym_anon_record_expression] = STATE(1118),
    [sym_prefixed_expression] = STATE(1118),
    [sym_typecast_expression] = STATE(1118),
    [sym_for_expression] = STATE(1118),
    [sym_while_expression] = STATE(1118),
    [sym__if_branch] = STATE(7163),
    [sym_if_expression] = STATE(1118),
    [sym_fun_expression] = STATE(1118),
    [sym_try_expression] = STATE(1118),
    [sym_match_expression] = STATE(1118),
    [sym_function_expression] = STATE(1118),
    [sym_mutate_expression] = STATE(1118),
    [sym_index_expression] = STATE(1118),
    [sym_typed_expression] = STATE(1118),
    [sym_declaration_expression] = STATE(1118),
    [sym_do_expression] = STATE(1118),
    [sym_list_expression] = STATE(1118),
    [sym_array_expression] = STATE(1118),
    [sym_begin_end_expression] = STATE(1118),
    [sym_paren_expression] = STATE(1118),
    [sym__high_prec_app] = STATE(1133),
    [sym__low_prec_app] = STATE(1133),
    [sym_application_expression] = STATE(1118),
    [sym_dot_expression] = STATE(1118),
    [sym_infix_expression] = STATE(1118),
    [sym_ce_expression] = STATE(1118),
    [sym_sequential_expression] = STATE(1118),
    [sym_char] = STATE(1080),
    [sym_format_string] = STATE(1090),
    [sym__string_literal] = STATE(1090),
    [sym_string] = STATE(1080),
    [sym_verbatim_string] = STATE(1080),
    [sym_bytearray] = STATE(1080),
    [sym_verbatim_bytearray] = STATE(1080),
    [sym_format_triple_quoted_string] = STATE(1096),
    [sym_triple_quoted_string] = STATE(1080),
    [sym_const] = STATE(1118),
    [sym_long_identifier] = STATE(1156),
    [sym_active_pattern] = STATE(1085),
    [sym__identifier_or_op] = STATE(1099),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(517),
    [sym_infix_op] = STATE(487),
    [sym_sbyte] = STATE(1080),
    [sym_byte] = STATE(1080),
    [sym_int16] = STATE(1080),
    [sym_uint16] = STATE(1080),
    [sym_int32] = STATE(1080),
    [sym_uint32] = STATE(1080),
    [sym_nativeint] = STATE(1080),
    [sym_unativeint] = STATE(1080),
    [sym_int64] = STATE(1080),
    [sym_uint64] = STATE(1080),
    [sym_ieee32] = STATE(1080),
    [sym_ieee64] = STATE(1080),
    [sym_bignum] = STATE(1080),
    [sym_decimal] = STATE(1080),
    [sym_float] = STATE(979),
    [sym_block_comment] = STATE(333),
    [sym_compiler_directive_decl] = STATE(333),
    [sym_fsi_directive_decl] = STATE(333),
    [sym_preproc_line] = STATE(333),
    [sym_preproc_if_in_expression] = STATE(1118),
    [aux_sym_sequential_expression_repeat1] = STATE(1069),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(195),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(197),
    [anon_sym_return] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(1627),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_COMMA] = ACTIONS(205),
    [anon_sym_null] = ACTIONS(207),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(197),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(209),
    [anon_sym_LBRACK_PIPE] = ACTIONS(211),
    [anon_sym_LBRACE] = ACTIONS(271),
    [anon_sym_LT_AT] = ACTIONS(213),
    [anon_sym_LT_AT_AT] = ACTIONS(215),
    [anon_sym_DOT] = ACTIONS(185),
    [anon_sym_LBRACE_PIPE] = ACTIONS(217),
    [anon_sym_new] = ACTIONS(199),
    [anon_sym_return_BANG] = ACTIONS(219),
    [anon_sym_yield] = ACTIONS(199),
    [anon_sym_yield_BANG] = ACTIONS(219),
    [anon_sym_lazy] = ACTIONS(199),
    [anon_sym_assert] = ACTIONS(199),
    [anon_sym_upcast] = ACTIONS(199),
    [anon_sym_downcast] = ACTIONS(199),
    [anon_sym_COLON_GT] = ACTIONS(221),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(221),
    [anon_sym_for] = ACTIONS(223),
    [anon_sym_while] = ACTIONS(225),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(229),
    [anon_sym_match] = ACTIONS(231),
    [anon_sym_match_BANG] = ACTIONS(233),
    [anon_sym_function] = ACTIONS(235),
    [anon_sym_LT_DASH] = ACTIONS(237),
    [anon_sym_DOT_LBRACK] = ACTIONS(187),
    [anon_sym_LT] = ACTIONS(189),
    [anon_sym_use] = ACTIONS(239),
    [anon_sym_use_BANG] = ACTIONS(241),
    [anon_sym_do_BANG] = ACTIONS(243),
    [anon_sym_begin] = ACTIONS(245),
    [anon_sym_LPAREN2] = ACTIONS(191),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(247),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(251),
    [anon_sym_AT_DQUOTE] = ACTIONS(253),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(255),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(257),
    [sym_bool] = ACTIONS(259),
    [sym_unit] = ACTIONS(193),
    [anon_sym_LPAREN_PIPE] = ACTIONS(261),
    [sym_op_identifier] = ACTIONS(263),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(265),
    [sym_xint] = ACTIONS(267),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(269),
    [sym__newline] = ACTIONS(273),
  },
  [334] = {
    [sym_function_or_value_defn] = STATE(627),
    [sym__expression] = STATE(17),
    [sym_literal_expression] = STATE(1118),
    [sym_long_identifier_or_op] = STATE(1118),
    [sym_tuple_expression] = STATE(1118),
    [sym_brace_expression] = STATE(1118),
    [sym_anon_record_expression] = STATE(1118),
    [sym_prefixed_expression] = STATE(1118),
    [sym_typecast_expression] = STATE(1118),
    [sym_for_expression] = STATE(1118),
    [sym_while_expression] = STATE(1118),
    [sym__if_branch] = STATE(7163),
    [sym_if_expression] = STATE(1118),
    [sym_fun_expression] = STATE(1118),
    [sym_try_expression] = STATE(1118),
    [sym_match_expression] = STATE(1118),
    [sym_function_expression] = STATE(1118),
    [sym_mutate_expression] = STATE(1118),
    [sym_index_expression] = STATE(1118),
    [sym_typed_expression] = STATE(1118),
    [sym_declaration_expression] = STATE(1118),
    [sym_do_expression] = STATE(1118),
    [sym_list_expression] = STATE(1118),
    [sym_array_expression] = STATE(1118),
    [sym_begin_end_expression] = STATE(1118),
    [sym_paren_expression] = STATE(1118),
    [sym__high_prec_app] = STATE(1133),
    [sym__low_prec_app] = STATE(1133),
    [sym_application_expression] = STATE(1118),
    [sym_dot_expression] = STATE(1118),
    [sym_infix_expression] = STATE(1118),
    [sym_ce_expression] = STATE(1118),
    [sym_sequential_expression] = STATE(1118),
    [sym_char] = STATE(1080),
    [sym_format_string] = STATE(1090),
    [sym__string_literal] = STATE(1090),
    [sym_string] = STATE(1080),
    [sym_verbatim_string] = STATE(1080),
    [sym_bytearray] = STATE(1080),
    [sym_verbatim_bytearray] = STATE(1080),
    [sym_format_triple_quoted_string] = STATE(1096),
    [sym_triple_quoted_string] = STATE(1080),
    [sym_const] = STATE(1118),
    [sym_long_identifier] = STATE(1156),
    [sym_active_pattern] = STATE(1085),
    [sym__identifier_or_op] = STATE(1099),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(517),
    [sym_infix_op] = STATE(487),
    [sym_sbyte] = STATE(1080),
    [sym_byte] = STATE(1080),
    [sym_int16] = STATE(1080),
    [sym_uint16] = STATE(1080),
    [sym_int32] = STATE(1080),
    [sym_uint32] = STATE(1080),
    [sym_nativeint] = STATE(1080),
    [sym_unativeint] = STATE(1080),
    [sym_int64] = STATE(1080),
    [sym_uint64] = STATE(1080),
    [sym_ieee32] = STATE(1080),
    [sym_ieee64] = STATE(1080),
    [sym_bignum] = STATE(1080),
    [sym_decimal] = STATE(1080),
    [sym_float] = STATE(979),
    [sym_block_comment] = STATE(334),
    [sym_compiler_directive_decl] = STATE(334),
    [sym_fsi_directive_decl] = STATE(334),
    [sym_preproc_line] = STATE(334),
    [sym_preproc_if_in_expression] = STATE(1118),
    [aux_sym_sequential_expression_repeat1] = STATE(1069),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(195),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(197),
    [anon_sym_return] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(1629),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_COMMA] = ACTIONS(205),
    [anon_sym_null] = ACTIONS(207),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(197),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(209),
    [anon_sym_LBRACK_PIPE] = ACTIONS(211),
    [anon_sym_LBRACE] = ACTIONS(271),
    [anon_sym_LT_AT] = ACTIONS(213),
    [anon_sym_LT_AT_AT] = ACTIONS(215),
    [anon_sym_DOT] = ACTIONS(185),
    [anon_sym_LBRACE_PIPE] = ACTIONS(217),
    [anon_sym_new] = ACTIONS(199),
    [anon_sym_return_BANG] = ACTIONS(219),
    [anon_sym_yield] = ACTIONS(199),
    [anon_sym_yield_BANG] = ACTIONS(219),
    [anon_sym_lazy] = ACTIONS(199),
    [anon_sym_assert] = ACTIONS(199),
    [anon_sym_upcast] = ACTIONS(199),
    [anon_sym_downcast] = ACTIONS(199),
    [anon_sym_COLON_GT] = ACTIONS(221),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(221),
    [anon_sym_for] = ACTIONS(223),
    [anon_sym_while] = ACTIONS(225),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(229),
    [anon_sym_match] = ACTIONS(231),
    [anon_sym_match_BANG] = ACTIONS(233),
    [anon_sym_function] = ACTIONS(235),
    [anon_sym_LT_DASH] = ACTIONS(237),
    [anon_sym_DOT_LBRACK] = ACTIONS(187),
    [anon_sym_LT] = ACTIONS(189),
    [anon_sym_use] = ACTIONS(239),
    [anon_sym_use_BANG] = ACTIONS(241),
    [anon_sym_do_BANG] = ACTIONS(243),
    [anon_sym_begin] = ACTIONS(245),
    [anon_sym_LPAREN2] = ACTIONS(191),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(247),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(251),
    [anon_sym_AT_DQUOTE] = ACTIONS(253),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(255),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(257),
    [sym_bool] = ACTIONS(259),
    [sym_unit] = ACTIONS(193),
    [anon_sym_LPAREN_PIPE] = ACTIONS(261),
    [sym_op_identifier] = ACTIONS(263),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(265),
    [sym_xint] = ACTIONS(267),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(269),
    [sym__newline] = ACTIONS(273),
  },
  [335] = {
    [sym_function_or_value_defn] = STATE(627),
    [sym__expression] = STATE(17),
    [sym_literal_expression] = STATE(1118),
    [sym_long_identifier_or_op] = STATE(1118),
    [sym_tuple_expression] = STATE(1118),
    [sym_brace_expression] = STATE(1118),
    [sym_anon_record_expression] = STATE(1118),
    [sym_prefixed_expression] = STATE(1118),
    [sym_typecast_expression] = STATE(1118),
    [sym_for_expression] = STATE(1118),
    [sym_while_expression] = STATE(1118),
    [sym__if_branch] = STATE(7163),
    [sym_if_expression] = STATE(1118),
    [sym_fun_expression] = STATE(1118),
    [sym_try_expression] = STATE(1118),
    [sym_match_expression] = STATE(1118),
    [sym_function_expression] = STATE(1118),
    [sym_mutate_expression] = STATE(1118),
    [sym_index_expression] = STATE(1118),
    [sym_typed_expression] = STATE(1118),
    [sym_declaration_expression] = STATE(1118),
    [sym_do_expression] = STATE(1118),
    [sym_list_expression] = STATE(1118),
    [sym_array_expression] = STATE(1118),
    [sym_begin_end_expression] = STATE(1118),
    [sym_paren_expression] = STATE(1118),
    [sym__high_prec_app] = STATE(1133),
    [sym__low_prec_app] = STATE(1133),
    [sym_application_expression] = STATE(1118),
    [sym_dot_expression] = STATE(1118),
    [sym_infix_expression] = STATE(1118),
    [sym_ce_expression] = STATE(1118),
    [sym_sequential_expression] = STATE(1118),
    [sym_char] = STATE(1080),
    [sym_format_string] = STATE(1090),
    [sym__string_literal] = STATE(1090),
    [sym_string] = STATE(1080),
    [sym_verbatim_string] = STATE(1080),
    [sym_bytearray] = STATE(1080),
    [sym_verbatim_bytearray] = STATE(1080),
    [sym_format_triple_quoted_string] = STATE(1096),
    [sym_triple_quoted_string] = STATE(1080),
    [sym_const] = STATE(1118),
    [sym_long_identifier] = STATE(1156),
    [sym_active_pattern] = STATE(1085),
    [sym__identifier_or_op] = STATE(1099),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(517),
    [sym_infix_op] = STATE(487),
    [sym_sbyte] = STATE(1080),
    [sym_byte] = STATE(1080),
    [sym_int16] = STATE(1080),
    [sym_uint16] = STATE(1080),
    [sym_int32] = STATE(1080),
    [sym_uint32] = STATE(1080),
    [sym_nativeint] = STATE(1080),
    [sym_unativeint] = STATE(1080),
    [sym_int64] = STATE(1080),
    [sym_uint64] = STATE(1080),
    [sym_ieee32] = STATE(1080),
    [sym_ieee64] = STATE(1080),
    [sym_bignum] = STATE(1080),
    [sym_decimal] = STATE(1080),
    [sym_float] = STATE(979),
    [sym_block_comment] = STATE(335),
    [sym_compiler_directive_decl] = STATE(335),
    [sym_fsi_directive_decl] = STATE(335),
    [sym_preproc_line] = STATE(335),
    [sym_preproc_if_in_expression] = STATE(1118),
    [aux_sym_sequential_expression_repeat1] = STATE(1069),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(195),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(197),
    [anon_sym_return] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(1631),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_COMMA] = ACTIONS(205),
    [anon_sym_null] = ACTIONS(207),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(197),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(209),
    [anon_sym_LBRACK_PIPE] = ACTIONS(211),
    [anon_sym_LBRACE] = ACTIONS(271),
    [anon_sym_LT_AT] = ACTIONS(213),
    [anon_sym_LT_AT_AT] = ACTIONS(215),
    [anon_sym_DOT] = ACTIONS(185),
    [anon_sym_LBRACE_PIPE] = ACTIONS(217),
    [anon_sym_new] = ACTIONS(199),
    [anon_sym_return_BANG] = ACTIONS(219),
    [anon_sym_yield] = ACTIONS(199),
    [anon_sym_yield_BANG] = ACTIONS(219),
    [anon_sym_lazy] = ACTIONS(199),
    [anon_sym_assert] = ACTIONS(199),
    [anon_sym_upcast] = ACTIONS(199),
    [anon_sym_downcast] = ACTIONS(199),
    [anon_sym_COLON_GT] = ACTIONS(221),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(221),
    [anon_sym_for] = ACTIONS(223),
    [anon_sym_while] = ACTIONS(225),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(229),
    [anon_sym_match] = ACTIONS(231),
    [anon_sym_match_BANG] = ACTIONS(233),
    [anon_sym_function] = ACTIONS(235),
    [anon_sym_LT_DASH] = ACTIONS(237),
    [anon_sym_DOT_LBRACK] = ACTIONS(187),
    [anon_sym_LT] = ACTIONS(189),
    [anon_sym_use] = ACTIONS(239),
    [anon_sym_use_BANG] = ACTIONS(241),
    [anon_sym_do_BANG] = ACTIONS(243),
    [anon_sym_begin] = ACTIONS(245),
    [anon_sym_LPAREN2] = ACTIONS(191),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(247),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(251),
    [anon_sym_AT_DQUOTE] = ACTIONS(253),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(255),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(257),
    [sym_bool] = ACTIONS(259),
    [sym_unit] = ACTIONS(193),
    [anon_sym_LPAREN_PIPE] = ACTIONS(261),
    [sym_op_identifier] = ACTIONS(263),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(265),
    [sym_xint] = ACTIONS(267),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(269),
    [sym__newline] = ACTIONS(273),
  },
  [336] = {
    [sym_function_or_value_defn] = STATE(627),
    [sym__expression] = STATE(17),
    [sym_literal_expression] = STATE(1118),
    [sym_long_identifier_or_op] = STATE(1118),
    [sym_tuple_expression] = STATE(1118),
    [sym_brace_expression] = STATE(1118),
    [sym_anon_record_expression] = STATE(1118),
    [sym_prefixed_expression] = STATE(1118),
    [sym_typecast_expression] = STATE(1118),
    [sym_for_expression] = STATE(1118),
    [sym_while_expression] = STATE(1118),
    [sym__if_branch] = STATE(7163),
    [sym_if_expression] = STATE(1118),
    [sym_fun_expression] = STATE(1118),
    [sym_try_expression] = STATE(1118),
    [sym_match_expression] = STATE(1118),
    [sym_function_expression] = STATE(1118),
    [sym_mutate_expression] = STATE(1118),
    [sym_index_expression] = STATE(1118),
    [sym_typed_expression] = STATE(1118),
    [sym_declaration_expression] = STATE(1118),
    [sym_do_expression] = STATE(1118),
    [sym_list_expression] = STATE(1118),
    [sym_array_expression] = STATE(1118),
    [sym_begin_end_expression] = STATE(1118),
    [sym_paren_expression] = STATE(1118),
    [sym__high_prec_app] = STATE(1133),
    [sym__low_prec_app] = STATE(1133),
    [sym_application_expression] = STATE(1118),
    [sym_dot_expression] = STATE(1118),
    [sym_infix_expression] = STATE(1118),
    [sym_ce_expression] = STATE(1118),
    [sym_sequential_expression] = STATE(1118),
    [sym_char] = STATE(1080),
    [sym_format_string] = STATE(1090),
    [sym__string_literal] = STATE(1090),
    [sym_string] = STATE(1080),
    [sym_verbatim_string] = STATE(1080),
    [sym_bytearray] = STATE(1080),
    [sym_verbatim_bytearray] = STATE(1080),
    [sym_format_triple_quoted_string] = STATE(1096),
    [sym_triple_quoted_string] = STATE(1080),
    [sym_const] = STATE(1118),
    [sym_long_identifier] = STATE(1156),
    [sym_active_pattern] = STATE(1085),
    [sym__identifier_or_op] = STATE(1099),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(517),
    [sym_infix_op] = STATE(487),
    [sym_sbyte] = STATE(1080),
    [sym_byte] = STATE(1080),
    [sym_int16] = STATE(1080),
    [sym_uint16] = STATE(1080),
    [sym_int32] = STATE(1080),
    [sym_uint32] = STATE(1080),
    [sym_nativeint] = STATE(1080),
    [sym_unativeint] = STATE(1080),
    [sym_int64] = STATE(1080),
    [sym_uint64] = STATE(1080),
    [sym_ieee32] = STATE(1080),
    [sym_ieee64] = STATE(1080),
    [sym_bignum] = STATE(1080),
    [sym_decimal] = STATE(1080),
    [sym_float] = STATE(979),
    [sym_block_comment] = STATE(336),
    [sym_compiler_directive_decl] = STATE(336),
    [sym_fsi_directive_decl] = STATE(336),
    [sym_preproc_line] = STATE(336),
    [sym_preproc_if_in_expression] = STATE(1118),
    [aux_sym_sequential_expression_repeat1] = STATE(1069),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(195),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(197),
    [anon_sym_return] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(1633),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_COMMA] = ACTIONS(205),
    [anon_sym_null] = ACTIONS(207),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(197),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(209),
    [anon_sym_LBRACK_PIPE] = ACTIONS(211),
    [anon_sym_LBRACE] = ACTIONS(271),
    [anon_sym_LT_AT] = ACTIONS(213),
    [anon_sym_LT_AT_AT] = ACTIONS(215),
    [anon_sym_DOT] = ACTIONS(185),
    [anon_sym_LBRACE_PIPE] = ACTIONS(217),
    [anon_sym_new] = ACTIONS(199),
    [anon_sym_return_BANG] = ACTIONS(219),
    [anon_sym_yield] = ACTIONS(199),
    [anon_sym_yield_BANG] = ACTIONS(219),
    [anon_sym_lazy] = ACTIONS(199),
    [anon_sym_assert] = ACTIONS(199),
    [anon_sym_upcast] = ACTIONS(199),
    [anon_sym_downcast] = ACTIONS(199),
    [anon_sym_COLON_GT] = ACTIONS(221),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(221),
    [anon_sym_for] = ACTIONS(223),
    [anon_sym_while] = ACTIONS(225),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(229),
    [anon_sym_match] = ACTIONS(231),
    [anon_sym_match_BANG] = ACTIONS(233),
    [anon_sym_function] = ACTIONS(235),
    [anon_sym_LT_DASH] = ACTIONS(237),
    [anon_sym_DOT_LBRACK] = ACTIONS(187),
    [anon_sym_LT] = ACTIONS(189),
    [anon_sym_use] = ACTIONS(239),
    [anon_sym_use_BANG] = ACTIONS(241),
    [anon_sym_do_BANG] = ACTIONS(243),
    [anon_sym_begin] = ACTIONS(245),
    [anon_sym_LPAREN2] = ACTIONS(191),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(247),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(251),
    [anon_sym_AT_DQUOTE] = ACTIONS(253),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(255),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(257),
    [sym_bool] = ACTIONS(259),
    [sym_unit] = ACTIONS(193),
    [anon_sym_LPAREN_PIPE] = ACTIONS(261),
    [sym_op_identifier] = ACTIONS(263),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(265),
    [sym_xint] = ACTIONS(267),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(269),
    [sym__newline] = ACTIONS(273),
  },
  [337] = {
    [sym_function_or_value_defn] = STATE(627),
    [sym__expression] = STATE(17),
    [sym_literal_expression] = STATE(1118),
    [sym_long_identifier_or_op] = STATE(1118),
    [sym_tuple_expression] = STATE(1118),
    [sym_brace_expression] = STATE(1118),
    [sym_anon_record_expression] = STATE(1118),
    [sym_prefixed_expression] = STATE(1118),
    [sym_typecast_expression] = STATE(1118),
    [sym_for_expression] = STATE(1118),
    [sym_while_expression] = STATE(1118),
    [sym__if_branch] = STATE(7163),
    [sym_if_expression] = STATE(1118),
    [sym_fun_expression] = STATE(1118),
    [sym_try_expression] = STATE(1118),
    [sym_match_expression] = STATE(1118),
    [sym_function_expression] = STATE(1118),
    [sym_mutate_expression] = STATE(1118),
    [sym_index_expression] = STATE(1118),
    [sym_typed_expression] = STATE(1118),
    [sym_declaration_expression] = STATE(1118),
    [sym_do_expression] = STATE(1118),
    [sym_list_expression] = STATE(1118),
    [sym_array_expression] = STATE(1118),
    [sym_begin_end_expression] = STATE(1118),
    [sym_paren_expression] = STATE(1118),
    [sym__high_prec_app] = STATE(1133),
    [sym__low_prec_app] = STATE(1133),
    [sym_application_expression] = STATE(1118),
    [sym_dot_expression] = STATE(1118),
    [sym_infix_expression] = STATE(1118),
    [sym_ce_expression] = STATE(1118),
    [sym_sequential_expression] = STATE(1118),
    [sym_char] = STATE(1080),
    [sym_format_string] = STATE(1090),
    [sym__string_literal] = STATE(1090),
    [sym_string] = STATE(1080),
    [sym_verbatim_string] = STATE(1080),
    [sym_bytearray] = STATE(1080),
    [sym_verbatim_bytearray] = STATE(1080),
    [sym_format_triple_quoted_string] = STATE(1096),
    [sym_triple_quoted_string] = STATE(1080),
    [sym_const] = STATE(1118),
    [sym_long_identifier] = STATE(1156),
    [sym_active_pattern] = STATE(1085),
    [sym__identifier_or_op] = STATE(1099),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(517),
    [sym_infix_op] = STATE(487),
    [sym_sbyte] = STATE(1080),
    [sym_byte] = STATE(1080),
    [sym_int16] = STATE(1080),
    [sym_uint16] = STATE(1080),
    [sym_int32] = STATE(1080),
    [sym_uint32] = STATE(1080),
    [sym_nativeint] = STATE(1080),
    [sym_unativeint] = STATE(1080),
    [sym_int64] = STATE(1080),
    [sym_uint64] = STATE(1080),
    [sym_ieee32] = STATE(1080),
    [sym_ieee64] = STATE(1080),
    [sym_bignum] = STATE(1080),
    [sym_decimal] = STATE(1080),
    [sym_float] = STATE(979),
    [sym_block_comment] = STATE(337),
    [sym_compiler_directive_decl] = STATE(337),
    [sym_fsi_directive_decl] = STATE(337),
    [sym_preproc_line] = STATE(337),
    [sym_preproc_if_in_expression] = STATE(1118),
    [aux_sym_sequential_expression_repeat1] = STATE(1069),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(195),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(197),
    [anon_sym_return] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(1635),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_COMMA] = ACTIONS(205),
    [anon_sym_null] = ACTIONS(207),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(197),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(209),
    [anon_sym_LBRACK_PIPE] = ACTIONS(211),
    [anon_sym_LBRACE] = ACTIONS(271),
    [anon_sym_LT_AT] = ACTIONS(213),
    [anon_sym_LT_AT_AT] = ACTIONS(215),
    [anon_sym_DOT] = ACTIONS(185),
    [anon_sym_LBRACE_PIPE] = ACTIONS(217),
    [anon_sym_new] = ACTIONS(199),
    [anon_sym_return_BANG] = ACTIONS(219),
    [anon_sym_yield] = ACTIONS(199),
    [anon_sym_yield_BANG] = ACTIONS(219),
    [anon_sym_lazy] = ACTIONS(199),
    [anon_sym_assert] = ACTIONS(199),
    [anon_sym_upcast] = ACTIONS(199),
    [anon_sym_downcast] = ACTIONS(199),
    [anon_sym_COLON_GT] = ACTIONS(221),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(221),
    [anon_sym_for] = ACTIONS(223),
    [anon_sym_while] = ACTIONS(225),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(229),
    [anon_sym_match] = ACTIONS(231),
    [anon_sym_match_BANG] = ACTIONS(233),
    [anon_sym_function] = ACTIONS(235),
    [anon_sym_LT_DASH] = ACTIONS(237),
    [anon_sym_DOT_LBRACK] = ACTIONS(187),
    [anon_sym_LT] = ACTIONS(189),
    [anon_sym_use] = ACTIONS(239),
    [anon_sym_use_BANG] = ACTIONS(241),
    [anon_sym_do_BANG] = ACTIONS(243),
    [anon_sym_begin] = ACTIONS(245),
    [anon_sym_LPAREN2] = ACTIONS(191),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(247),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(251),
    [anon_sym_AT_DQUOTE] = ACTIONS(253),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(255),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(257),
    [sym_bool] = ACTIONS(259),
    [sym_unit] = ACTIONS(193),
    [anon_sym_LPAREN_PIPE] = ACTIONS(261),
    [sym_op_identifier] = ACTIONS(263),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(265),
    [sym_xint] = ACTIONS(267),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(269),
    [sym__newline] = ACTIONS(273),
  },
  [338] = {
    [sym_function_or_value_defn] = STATE(627),
    [sym__expression] = STATE(17),
    [sym_literal_expression] = STATE(1118),
    [sym_long_identifier_or_op] = STATE(1118),
    [sym_tuple_expression] = STATE(1118),
    [sym_brace_expression] = STATE(1118),
    [sym_anon_record_expression] = STATE(1118),
    [sym_prefixed_expression] = STATE(1118),
    [sym_typecast_expression] = STATE(1118),
    [sym_for_expression] = STATE(1118),
    [sym_while_expression] = STATE(1118),
    [sym__if_branch] = STATE(7163),
    [sym_if_expression] = STATE(1118),
    [sym_fun_expression] = STATE(1118),
    [sym_try_expression] = STATE(1118),
    [sym_match_expression] = STATE(1118),
    [sym_function_expression] = STATE(1118),
    [sym_mutate_expression] = STATE(1118),
    [sym_index_expression] = STATE(1118),
    [sym_typed_expression] = STATE(1118),
    [sym_declaration_expression] = STATE(1118),
    [sym_do_expression] = STATE(1118),
    [sym_list_expression] = STATE(1118),
    [sym_array_expression] = STATE(1118),
    [sym_begin_end_expression] = STATE(1118),
    [sym_paren_expression] = STATE(1118),
    [sym__high_prec_app] = STATE(1133),
    [sym__low_prec_app] = STATE(1133),
    [sym_application_expression] = STATE(1118),
    [sym_dot_expression] = STATE(1118),
    [sym_infix_expression] = STATE(1118),
    [sym_ce_expression] = STATE(1118),
    [sym_sequential_expression] = STATE(1118),
    [sym_char] = STATE(1080),
    [sym_format_string] = STATE(1090),
    [sym__string_literal] = STATE(1090),
    [sym_string] = STATE(1080),
    [sym_verbatim_string] = STATE(1080),
    [sym_bytearray] = STATE(1080),
    [sym_verbatim_bytearray] = STATE(1080),
    [sym_format_triple_quoted_string] = STATE(1096),
    [sym_triple_quoted_string] = STATE(1080),
    [sym_const] = STATE(1118),
    [sym_long_identifier] = STATE(1156),
    [sym_active_pattern] = STATE(1085),
    [sym__identifier_or_op] = STATE(1099),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(517),
    [sym_infix_op] = STATE(487),
    [sym_sbyte] = STATE(1080),
    [sym_byte] = STATE(1080),
    [sym_int16] = STATE(1080),
    [sym_uint16] = STATE(1080),
    [sym_int32] = STATE(1080),
    [sym_uint32] = STATE(1080),
    [sym_nativeint] = STATE(1080),
    [sym_unativeint] = STATE(1080),
    [sym_int64] = STATE(1080),
    [sym_uint64] = STATE(1080),
    [sym_ieee32] = STATE(1080),
    [sym_ieee64] = STATE(1080),
    [sym_bignum] = STATE(1080),
    [sym_decimal] = STATE(1080),
    [sym_float] = STATE(979),
    [sym_block_comment] = STATE(338),
    [sym_compiler_directive_decl] = STATE(338),
    [sym_fsi_directive_decl] = STATE(338),
    [sym_preproc_line] = STATE(338),
    [sym_preproc_if_in_expression] = STATE(1118),
    [aux_sym_sequential_expression_repeat1] = STATE(1069),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(195),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(197),
    [anon_sym_return] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(1637),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_COMMA] = ACTIONS(205),
    [anon_sym_null] = ACTIONS(207),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(197),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(209),
    [anon_sym_LBRACK_PIPE] = ACTIONS(211),
    [anon_sym_LBRACE] = ACTIONS(271),
    [anon_sym_LT_AT] = ACTIONS(213),
    [anon_sym_LT_AT_AT] = ACTIONS(215),
    [anon_sym_DOT] = ACTIONS(185),
    [anon_sym_LBRACE_PIPE] = ACTIONS(217),
    [anon_sym_new] = ACTIONS(199),
    [anon_sym_return_BANG] = ACTIONS(219),
    [anon_sym_yield] = ACTIONS(199),
    [anon_sym_yield_BANG] = ACTIONS(219),
    [anon_sym_lazy] = ACTIONS(199),
    [anon_sym_assert] = ACTIONS(199),
    [anon_sym_upcast] = ACTIONS(199),
    [anon_sym_downcast] = ACTIONS(199),
    [anon_sym_COLON_GT] = ACTIONS(221),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(221),
    [anon_sym_for] = ACTIONS(223),
    [anon_sym_while] = ACTIONS(225),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(229),
    [anon_sym_match] = ACTIONS(231),
    [anon_sym_match_BANG] = ACTIONS(233),
    [anon_sym_function] = ACTIONS(235),
    [anon_sym_LT_DASH] = ACTIONS(237),
    [anon_sym_DOT_LBRACK] = ACTIONS(187),
    [anon_sym_LT] = ACTIONS(189),
    [anon_sym_use] = ACTIONS(239),
    [anon_sym_use_BANG] = ACTIONS(241),
    [anon_sym_do_BANG] = ACTIONS(243),
    [anon_sym_begin] = ACTIONS(245),
    [anon_sym_LPAREN2] = ACTIONS(191),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(247),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(251),
    [anon_sym_AT_DQUOTE] = ACTIONS(253),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(255),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(257),
    [sym_bool] = ACTIONS(259),
    [sym_unit] = ACTIONS(193),
    [anon_sym_LPAREN_PIPE] = ACTIONS(261),
    [sym_op_identifier] = ACTIONS(263),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(265),
    [sym_xint] = ACTIONS(267),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(269),
    [sym__newline] = ACTIONS(273),
  },
  [339] = {
    [sym_function_or_value_defn] = STATE(627),
    [sym__expression] = STATE(17),
    [sym_literal_expression] = STATE(1118),
    [sym_long_identifier_or_op] = STATE(1118),
    [sym_tuple_expression] = STATE(1118),
    [sym_brace_expression] = STATE(1118),
    [sym_anon_record_expression] = STATE(1118),
    [sym_prefixed_expression] = STATE(1118),
    [sym_typecast_expression] = STATE(1118),
    [sym_for_expression] = STATE(1118),
    [sym_while_expression] = STATE(1118),
    [sym__if_branch] = STATE(7163),
    [sym_if_expression] = STATE(1118),
    [sym_fun_expression] = STATE(1118),
    [sym_try_expression] = STATE(1118),
    [sym_match_expression] = STATE(1118),
    [sym_function_expression] = STATE(1118),
    [sym_mutate_expression] = STATE(1118),
    [sym_index_expression] = STATE(1118),
    [sym_typed_expression] = STATE(1118),
    [sym_declaration_expression] = STATE(1118),
    [sym_do_expression] = STATE(1118),
    [sym_list_expression] = STATE(1118),
    [sym_array_expression] = STATE(1118),
    [sym_begin_end_expression] = STATE(1118),
    [sym_paren_expression] = STATE(1118),
    [sym__high_prec_app] = STATE(1133),
    [sym__low_prec_app] = STATE(1133),
    [sym_application_expression] = STATE(1118),
    [sym_dot_expression] = STATE(1118),
    [sym_infix_expression] = STATE(1118),
    [sym_ce_expression] = STATE(1118),
    [sym_sequential_expression] = STATE(1118),
    [sym_char] = STATE(1080),
    [sym_format_string] = STATE(1090),
    [sym__string_literal] = STATE(1090),
    [sym_string] = STATE(1080),
    [sym_verbatim_string] = STATE(1080),
    [sym_bytearray] = STATE(1080),
    [sym_verbatim_bytearray] = STATE(1080),
    [sym_format_triple_quoted_string] = STATE(1096),
    [sym_triple_quoted_string] = STATE(1080),
    [sym_const] = STATE(1118),
    [sym_long_identifier] = STATE(1156),
    [sym_active_pattern] = STATE(1085),
    [sym__identifier_or_op] = STATE(1099),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(517),
    [sym_infix_op] = STATE(487),
    [sym_sbyte] = STATE(1080),
    [sym_byte] = STATE(1080),
    [sym_int16] = STATE(1080),
    [sym_uint16] = STATE(1080),
    [sym_int32] = STATE(1080),
    [sym_uint32] = STATE(1080),
    [sym_nativeint] = STATE(1080),
    [sym_unativeint] = STATE(1080),
    [sym_int64] = STATE(1080),
    [sym_uint64] = STATE(1080),
    [sym_ieee32] = STATE(1080),
    [sym_ieee64] = STATE(1080),
    [sym_bignum] = STATE(1080),
    [sym_decimal] = STATE(1080),
    [sym_float] = STATE(979),
    [sym_block_comment] = STATE(339),
    [sym_compiler_directive_decl] = STATE(339),
    [sym_fsi_directive_decl] = STATE(339),
    [sym_preproc_line] = STATE(339),
    [sym_preproc_if_in_expression] = STATE(1118),
    [aux_sym_sequential_expression_repeat1] = STATE(1069),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(195),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(197),
    [anon_sym_return] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(1639),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_COMMA] = ACTIONS(205),
    [anon_sym_null] = ACTIONS(207),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(197),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(209),
    [anon_sym_LBRACK_PIPE] = ACTIONS(211),
    [anon_sym_LBRACE] = ACTIONS(271),
    [anon_sym_LT_AT] = ACTIONS(213),
    [anon_sym_LT_AT_AT] = ACTIONS(215),
    [anon_sym_DOT] = ACTIONS(185),
    [anon_sym_LBRACE_PIPE] = ACTIONS(217),
    [anon_sym_new] = ACTIONS(199),
    [anon_sym_return_BANG] = ACTIONS(219),
    [anon_sym_yield] = ACTIONS(199),
    [anon_sym_yield_BANG] = ACTIONS(219),
    [anon_sym_lazy] = ACTIONS(199),
    [anon_sym_assert] = ACTIONS(199),
    [anon_sym_upcast] = ACTIONS(199),
    [anon_sym_downcast] = ACTIONS(199),
    [anon_sym_COLON_GT] = ACTIONS(221),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(221),
    [anon_sym_for] = ACTIONS(223),
    [anon_sym_while] = ACTIONS(225),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(229),
    [anon_sym_match] = ACTIONS(231),
    [anon_sym_match_BANG] = ACTIONS(233),
    [anon_sym_function] = ACTIONS(235),
    [anon_sym_LT_DASH] = ACTIONS(237),
    [anon_sym_DOT_LBRACK] = ACTIONS(187),
    [anon_sym_LT] = ACTIONS(189),
    [anon_sym_use] = ACTIONS(239),
    [anon_sym_use_BANG] = ACTIONS(241),
    [anon_sym_do_BANG] = ACTIONS(243),
    [anon_sym_begin] = ACTIONS(245),
    [anon_sym_LPAREN2] = ACTIONS(191),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(247),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(251),
    [anon_sym_AT_DQUOTE] = ACTIONS(253),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(255),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(257),
    [sym_bool] = ACTIONS(259),
    [sym_unit] = ACTIONS(193),
    [anon_sym_LPAREN_PIPE] = ACTIONS(261),
    [sym_op_identifier] = ACTIONS(263),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(265),
    [sym_xint] = ACTIONS(267),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(269),
    [sym__newline] = ACTIONS(273),
  },
  [340] = {
    [sym_function_or_value_defn] = STATE(627),
    [sym__expression] = STATE(17),
    [sym_literal_expression] = STATE(1118),
    [sym_long_identifier_or_op] = STATE(1118),
    [sym_tuple_expression] = STATE(1118),
    [sym_brace_expression] = STATE(1118),
    [sym_anon_record_expression] = STATE(1118),
    [sym_prefixed_expression] = STATE(1118),
    [sym_typecast_expression] = STATE(1118),
    [sym_for_expression] = STATE(1118),
    [sym_while_expression] = STATE(1118),
    [sym__if_branch] = STATE(7163),
    [sym_if_expression] = STATE(1118),
    [sym_fun_expression] = STATE(1118),
    [sym_try_expression] = STATE(1118),
    [sym_match_expression] = STATE(1118),
    [sym_function_expression] = STATE(1118),
    [sym_mutate_expression] = STATE(1118),
    [sym_index_expression] = STATE(1118),
    [sym_typed_expression] = STATE(1118),
    [sym_declaration_expression] = STATE(1118),
    [sym_do_expression] = STATE(1118),
    [sym_list_expression] = STATE(1118),
    [sym_array_expression] = STATE(1118),
    [sym_begin_end_expression] = STATE(1118),
    [sym_paren_expression] = STATE(1118),
    [sym__high_prec_app] = STATE(1133),
    [sym__low_prec_app] = STATE(1133),
    [sym_application_expression] = STATE(1118),
    [sym_dot_expression] = STATE(1118),
    [sym_infix_expression] = STATE(1118),
    [sym_ce_expression] = STATE(1118),
    [sym_sequential_expression] = STATE(1118),
    [sym_char] = STATE(1080),
    [sym_format_string] = STATE(1090),
    [sym__string_literal] = STATE(1090),
    [sym_string] = STATE(1080),
    [sym_verbatim_string] = STATE(1080),
    [sym_bytearray] = STATE(1080),
    [sym_verbatim_bytearray] = STATE(1080),
    [sym_format_triple_quoted_string] = STATE(1096),
    [sym_triple_quoted_string] = STATE(1080),
    [sym_const] = STATE(1118),
    [sym_long_identifier] = STATE(1156),
    [sym_active_pattern] = STATE(1085),
    [sym__identifier_or_op] = STATE(1099),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(517),
    [sym_infix_op] = STATE(487),
    [sym_sbyte] = STATE(1080),
    [sym_byte] = STATE(1080),
    [sym_int16] = STATE(1080),
    [sym_uint16] = STATE(1080),
    [sym_int32] = STATE(1080),
    [sym_uint32] = STATE(1080),
    [sym_nativeint] = STATE(1080),
    [sym_unativeint] = STATE(1080),
    [sym_int64] = STATE(1080),
    [sym_uint64] = STATE(1080),
    [sym_ieee32] = STATE(1080),
    [sym_ieee64] = STATE(1080),
    [sym_bignum] = STATE(1080),
    [sym_decimal] = STATE(1080),
    [sym_float] = STATE(979),
    [sym_block_comment] = STATE(340),
    [sym_compiler_directive_decl] = STATE(340),
    [sym_fsi_directive_decl] = STATE(340),
    [sym_preproc_line] = STATE(340),
    [sym_preproc_if_in_expression] = STATE(1118),
    [aux_sym_sequential_expression_repeat1] = STATE(1069),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(195),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(197),
    [anon_sym_return] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(1641),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_COMMA] = ACTIONS(205),
    [anon_sym_null] = ACTIONS(207),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(197),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(209),
    [anon_sym_LBRACK_PIPE] = ACTIONS(211),
    [anon_sym_LBRACE] = ACTIONS(271),
    [anon_sym_LT_AT] = ACTIONS(213),
    [anon_sym_LT_AT_AT] = ACTIONS(215),
    [anon_sym_DOT] = ACTIONS(185),
    [anon_sym_LBRACE_PIPE] = ACTIONS(217),
    [anon_sym_new] = ACTIONS(199),
    [anon_sym_return_BANG] = ACTIONS(219),
    [anon_sym_yield] = ACTIONS(199),
    [anon_sym_yield_BANG] = ACTIONS(219),
    [anon_sym_lazy] = ACTIONS(199),
    [anon_sym_assert] = ACTIONS(199),
    [anon_sym_upcast] = ACTIONS(199),
    [anon_sym_downcast] = ACTIONS(199),
    [anon_sym_COLON_GT] = ACTIONS(221),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(221),
    [anon_sym_for] = ACTIONS(223),
    [anon_sym_while] = ACTIONS(225),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(229),
    [anon_sym_match] = ACTIONS(231),
    [anon_sym_match_BANG] = ACTIONS(233),
    [anon_sym_function] = ACTIONS(235),
    [anon_sym_LT_DASH] = ACTIONS(237),
    [anon_sym_DOT_LBRACK] = ACTIONS(187),
    [anon_sym_LT] = ACTIONS(189),
    [anon_sym_use] = ACTIONS(239),
    [anon_sym_use_BANG] = ACTIONS(241),
    [anon_sym_do_BANG] = ACTIONS(243),
    [anon_sym_begin] = ACTIONS(245),
    [anon_sym_LPAREN2] = ACTIONS(191),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(247),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(251),
    [anon_sym_AT_DQUOTE] = ACTIONS(253),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(255),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(257),
    [sym_bool] = ACTIONS(259),
    [sym_unit] = ACTIONS(193),
    [anon_sym_LPAREN_PIPE] = ACTIONS(261),
    [sym_op_identifier] = ACTIONS(263),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(265),
    [sym_xint] = ACTIONS(267),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(269),
    [sym__newline] = ACTIONS(273),
  },
  [341] = {
    [sym_function_or_value_defn] = STATE(627),
    [sym__expression] = STATE(17),
    [sym_literal_expression] = STATE(1118),
    [sym_long_identifier_or_op] = STATE(1118),
    [sym_tuple_expression] = STATE(1118),
    [sym_brace_expression] = STATE(1118),
    [sym_anon_record_expression] = STATE(1118),
    [sym_prefixed_expression] = STATE(1118),
    [sym_typecast_expression] = STATE(1118),
    [sym_for_expression] = STATE(1118),
    [sym_while_expression] = STATE(1118),
    [sym__if_branch] = STATE(7163),
    [sym_if_expression] = STATE(1118),
    [sym_fun_expression] = STATE(1118),
    [sym_try_expression] = STATE(1118),
    [sym_match_expression] = STATE(1118),
    [sym_function_expression] = STATE(1118),
    [sym_mutate_expression] = STATE(1118),
    [sym_index_expression] = STATE(1118),
    [sym_typed_expression] = STATE(1118),
    [sym_declaration_expression] = STATE(1118),
    [sym_do_expression] = STATE(1118),
    [sym_list_expression] = STATE(1118),
    [sym_array_expression] = STATE(1118),
    [sym_begin_end_expression] = STATE(1118),
    [sym_paren_expression] = STATE(1118),
    [sym__high_prec_app] = STATE(1133),
    [sym__low_prec_app] = STATE(1133),
    [sym_application_expression] = STATE(1118),
    [sym_dot_expression] = STATE(1118),
    [sym_infix_expression] = STATE(1118),
    [sym_ce_expression] = STATE(1118),
    [sym_sequential_expression] = STATE(1118),
    [sym_char] = STATE(1080),
    [sym_format_string] = STATE(1090),
    [sym__string_literal] = STATE(1090),
    [sym_string] = STATE(1080),
    [sym_verbatim_string] = STATE(1080),
    [sym_bytearray] = STATE(1080),
    [sym_verbatim_bytearray] = STATE(1080),
    [sym_format_triple_quoted_string] = STATE(1096),
    [sym_triple_quoted_string] = STATE(1080),
    [sym_const] = STATE(1118),
    [sym_long_identifier] = STATE(1156),
    [sym_active_pattern] = STATE(1085),
    [sym__identifier_or_op] = STATE(1099),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(517),
    [sym_infix_op] = STATE(487),
    [sym_sbyte] = STATE(1080),
    [sym_byte] = STATE(1080),
    [sym_int16] = STATE(1080),
    [sym_uint16] = STATE(1080),
    [sym_int32] = STATE(1080),
    [sym_uint32] = STATE(1080),
    [sym_nativeint] = STATE(1080),
    [sym_unativeint] = STATE(1080),
    [sym_int64] = STATE(1080),
    [sym_uint64] = STATE(1080),
    [sym_ieee32] = STATE(1080),
    [sym_ieee64] = STATE(1080),
    [sym_bignum] = STATE(1080),
    [sym_decimal] = STATE(1080),
    [sym_float] = STATE(979),
    [sym_block_comment] = STATE(341),
    [sym_compiler_directive_decl] = STATE(341),
    [sym_fsi_directive_decl] = STATE(341),
    [sym_preproc_line] = STATE(341),
    [sym_preproc_if_in_expression] = STATE(1118),
    [aux_sym_sequential_expression_repeat1] = STATE(1069),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(195),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(197),
    [anon_sym_return] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(1643),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_COMMA] = ACTIONS(205),
    [anon_sym_null] = ACTIONS(207),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(197),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(209),
    [anon_sym_LBRACK_PIPE] = ACTIONS(211),
    [anon_sym_LBRACE] = ACTIONS(271),
    [anon_sym_LT_AT] = ACTIONS(213),
    [anon_sym_LT_AT_AT] = ACTIONS(215),
    [anon_sym_DOT] = ACTIONS(185),
    [anon_sym_LBRACE_PIPE] = ACTIONS(217),
    [anon_sym_new] = ACTIONS(199),
    [anon_sym_return_BANG] = ACTIONS(219),
    [anon_sym_yield] = ACTIONS(199),
    [anon_sym_yield_BANG] = ACTIONS(219),
    [anon_sym_lazy] = ACTIONS(199),
    [anon_sym_assert] = ACTIONS(199),
    [anon_sym_upcast] = ACTIONS(199),
    [anon_sym_downcast] = ACTIONS(199),
    [anon_sym_COLON_GT] = ACTIONS(221),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(221),
    [anon_sym_for] = ACTIONS(223),
    [anon_sym_while] = ACTIONS(225),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(229),
    [anon_sym_match] = ACTIONS(231),
    [anon_sym_match_BANG] = ACTIONS(233),
    [anon_sym_function] = ACTIONS(235),
    [anon_sym_LT_DASH] = ACTIONS(237),
    [anon_sym_DOT_LBRACK] = ACTIONS(187),
    [anon_sym_LT] = ACTIONS(189),
    [anon_sym_use] = ACTIONS(239),
    [anon_sym_use_BANG] = ACTIONS(241),
    [anon_sym_do_BANG] = ACTIONS(243),
    [anon_sym_begin] = ACTIONS(245),
    [anon_sym_LPAREN2] = ACTIONS(191),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(247),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(251),
    [anon_sym_AT_DQUOTE] = ACTIONS(253),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(255),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(257),
    [sym_bool] = ACTIONS(259),
    [sym_unit] = ACTIONS(193),
    [anon_sym_LPAREN_PIPE] = ACTIONS(261),
    [sym_op_identifier] = ACTIONS(263),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(265),
    [sym_xint] = ACTIONS(267),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(269),
    [sym__newline] = ACTIONS(273),
  },
  [342] = {
    [sym_function_or_value_defn] = STATE(627),
    [sym__expression] = STATE(17),
    [sym_literal_expression] = STATE(1118),
    [sym_long_identifier_or_op] = STATE(1118),
    [sym_tuple_expression] = STATE(1118),
    [sym_brace_expression] = STATE(1118),
    [sym_anon_record_expression] = STATE(1118),
    [sym_prefixed_expression] = STATE(1118),
    [sym_typecast_expression] = STATE(1118),
    [sym_for_expression] = STATE(1118),
    [sym_while_expression] = STATE(1118),
    [sym__if_branch] = STATE(7163),
    [sym_if_expression] = STATE(1118),
    [sym_fun_expression] = STATE(1118),
    [sym_try_expression] = STATE(1118),
    [sym_match_expression] = STATE(1118),
    [sym_function_expression] = STATE(1118),
    [sym_mutate_expression] = STATE(1118),
    [sym_index_expression] = STATE(1118),
    [sym_typed_expression] = STATE(1118),
    [sym_declaration_expression] = STATE(1118),
    [sym_do_expression] = STATE(1118),
    [sym_list_expression] = STATE(1118),
    [sym_array_expression] = STATE(1118),
    [sym_begin_end_expression] = STATE(1118),
    [sym_paren_expression] = STATE(1118),
    [sym__high_prec_app] = STATE(1133),
    [sym__low_prec_app] = STATE(1133),
    [sym_application_expression] = STATE(1118),
    [sym_dot_expression] = STATE(1118),
    [sym_infix_expression] = STATE(1118),
    [sym_ce_expression] = STATE(1118),
    [sym_sequential_expression] = STATE(1118),
    [sym_char] = STATE(1080),
    [sym_format_string] = STATE(1090),
    [sym__string_literal] = STATE(1090),
    [sym_string] = STATE(1080),
    [sym_verbatim_string] = STATE(1080),
    [sym_bytearray] = STATE(1080),
    [sym_verbatim_bytearray] = STATE(1080),
    [sym_format_triple_quoted_string] = STATE(1096),
    [sym_triple_quoted_string] = STATE(1080),
    [sym_const] = STATE(1118),
    [sym_long_identifier] = STATE(1156),
    [sym_active_pattern] = STATE(1085),
    [sym__identifier_or_op] = STATE(1099),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(517),
    [sym_infix_op] = STATE(487),
    [sym_sbyte] = STATE(1080),
    [sym_byte] = STATE(1080),
    [sym_int16] = STATE(1080),
    [sym_uint16] = STATE(1080),
    [sym_int32] = STATE(1080),
    [sym_uint32] = STATE(1080),
    [sym_nativeint] = STATE(1080),
    [sym_unativeint] = STATE(1080),
    [sym_int64] = STATE(1080),
    [sym_uint64] = STATE(1080),
    [sym_ieee32] = STATE(1080),
    [sym_ieee64] = STATE(1080),
    [sym_bignum] = STATE(1080),
    [sym_decimal] = STATE(1080),
    [sym_float] = STATE(979),
    [sym_block_comment] = STATE(342),
    [sym_compiler_directive_decl] = STATE(342),
    [sym_fsi_directive_decl] = STATE(342),
    [sym_preproc_line] = STATE(342),
    [sym_preproc_if_in_expression] = STATE(1118),
    [aux_sym_sequential_expression_repeat1] = STATE(1069),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(195),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(197),
    [anon_sym_return] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(1645),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_COMMA] = ACTIONS(205),
    [anon_sym_null] = ACTIONS(207),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(197),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(209),
    [anon_sym_LBRACK_PIPE] = ACTIONS(211),
    [anon_sym_LBRACE] = ACTIONS(271),
    [anon_sym_LT_AT] = ACTIONS(213),
    [anon_sym_LT_AT_AT] = ACTIONS(215),
    [anon_sym_DOT] = ACTIONS(185),
    [anon_sym_LBRACE_PIPE] = ACTIONS(217),
    [anon_sym_new] = ACTIONS(199),
    [anon_sym_return_BANG] = ACTIONS(219),
    [anon_sym_yield] = ACTIONS(199),
    [anon_sym_yield_BANG] = ACTIONS(219),
    [anon_sym_lazy] = ACTIONS(199),
    [anon_sym_assert] = ACTIONS(199),
    [anon_sym_upcast] = ACTIONS(199),
    [anon_sym_downcast] = ACTIONS(199),
    [anon_sym_COLON_GT] = ACTIONS(221),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(221),
    [anon_sym_for] = ACTIONS(223),
    [anon_sym_while] = ACTIONS(225),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(229),
    [anon_sym_match] = ACTIONS(231),
    [anon_sym_match_BANG] = ACTIONS(233),
    [anon_sym_function] = ACTIONS(235),
    [anon_sym_LT_DASH] = ACTIONS(237),
    [anon_sym_DOT_LBRACK] = ACTIONS(187),
    [anon_sym_LT] = ACTIONS(189),
    [anon_sym_use] = ACTIONS(239),
    [anon_sym_use_BANG] = ACTIONS(241),
    [anon_sym_do_BANG] = ACTIONS(243),
    [anon_sym_begin] = ACTIONS(245),
    [anon_sym_LPAREN2] = ACTIONS(191),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(247),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(251),
    [anon_sym_AT_DQUOTE] = ACTIONS(253),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(255),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(257),
    [sym_bool] = ACTIONS(259),
    [sym_unit] = ACTIONS(193),
    [anon_sym_LPAREN_PIPE] = ACTIONS(261),
    [sym_op_identifier] = ACTIONS(263),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(265),
    [sym_xint] = ACTIONS(267),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(269),
    [sym__newline] = ACTIONS(273),
  },
  [343] = {
    [sym_function_or_value_defn] = STATE(627),
    [sym__expression] = STATE(17),
    [sym_literal_expression] = STATE(1118),
    [sym_long_identifier_or_op] = STATE(1118),
    [sym_tuple_expression] = STATE(1118),
    [sym_brace_expression] = STATE(1118),
    [sym_anon_record_expression] = STATE(1118),
    [sym_prefixed_expression] = STATE(1118),
    [sym_typecast_expression] = STATE(1118),
    [sym_for_expression] = STATE(1118),
    [sym_while_expression] = STATE(1118),
    [sym__if_branch] = STATE(7163),
    [sym_if_expression] = STATE(1118),
    [sym_fun_expression] = STATE(1118),
    [sym_try_expression] = STATE(1118),
    [sym_match_expression] = STATE(1118),
    [sym_function_expression] = STATE(1118),
    [sym_mutate_expression] = STATE(1118),
    [sym_index_expression] = STATE(1118),
    [sym_typed_expression] = STATE(1118),
    [sym_declaration_expression] = STATE(1118),
    [sym_do_expression] = STATE(1118),
    [sym_list_expression] = STATE(1118),
    [sym_array_expression] = STATE(1118),
    [sym_begin_end_expression] = STATE(1118),
    [sym_paren_expression] = STATE(1118),
    [sym__high_prec_app] = STATE(1133),
    [sym__low_prec_app] = STATE(1133),
    [sym_application_expression] = STATE(1118),
    [sym_dot_expression] = STATE(1118),
    [sym_infix_expression] = STATE(1118),
    [sym_ce_expression] = STATE(1118),
    [sym_sequential_expression] = STATE(1118),
    [sym_char] = STATE(1080),
    [sym_format_string] = STATE(1090),
    [sym__string_literal] = STATE(1090),
    [sym_string] = STATE(1080),
    [sym_verbatim_string] = STATE(1080),
    [sym_bytearray] = STATE(1080),
    [sym_verbatim_bytearray] = STATE(1080),
    [sym_format_triple_quoted_string] = STATE(1096),
    [sym_triple_quoted_string] = STATE(1080),
    [sym_const] = STATE(1118),
    [sym_long_identifier] = STATE(1156),
    [sym_active_pattern] = STATE(1085),
    [sym__identifier_or_op] = STATE(1099),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(517),
    [sym_infix_op] = STATE(487),
    [sym_sbyte] = STATE(1080),
    [sym_byte] = STATE(1080),
    [sym_int16] = STATE(1080),
    [sym_uint16] = STATE(1080),
    [sym_int32] = STATE(1080),
    [sym_uint32] = STATE(1080),
    [sym_nativeint] = STATE(1080),
    [sym_unativeint] = STATE(1080),
    [sym_int64] = STATE(1080),
    [sym_uint64] = STATE(1080),
    [sym_ieee32] = STATE(1080),
    [sym_ieee64] = STATE(1080),
    [sym_bignum] = STATE(1080),
    [sym_decimal] = STATE(1080),
    [sym_float] = STATE(979),
    [sym_block_comment] = STATE(343),
    [sym_compiler_directive_decl] = STATE(343),
    [sym_fsi_directive_decl] = STATE(343),
    [sym_preproc_line] = STATE(343),
    [sym_preproc_if_in_expression] = STATE(1118),
    [aux_sym_sequential_expression_repeat1] = STATE(1069),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(195),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(197),
    [anon_sym_return] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(1647),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_COMMA] = ACTIONS(205),
    [anon_sym_null] = ACTIONS(207),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(197),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(209),
    [anon_sym_LBRACK_PIPE] = ACTIONS(211),
    [anon_sym_LBRACE] = ACTIONS(271),
    [anon_sym_LT_AT] = ACTIONS(213),
    [anon_sym_LT_AT_AT] = ACTIONS(215),
    [anon_sym_DOT] = ACTIONS(185),
    [anon_sym_LBRACE_PIPE] = ACTIONS(217),
    [anon_sym_new] = ACTIONS(199),
    [anon_sym_return_BANG] = ACTIONS(219),
    [anon_sym_yield] = ACTIONS(199),
    [anon_sym_yield_BANG] = ACTIONS(219),
    [anon_sym_lazy] = ACTIONS(199),
    [anon_sym_assert] = ACTIONS(199),
    [anon_sym_upcast] = ACTIONS(199),
    [anon_sym_downcast] = ACTIONS(199),
    [anon_sym_COLON_GT] = ACTIONS(221),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(221),
    [anon_sym_for] = ACTIONS(223),
    [anon_sym_while] = ACTIONS(225),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(229),
    [anon_sym_match] = ACTIONS(231),
    [anon_sym_match_BANG] = ACTIONS(233),
    [anon_sym_function] = ACTIONS(235),
    [anon_sym_LT_DASH] = ACTIONS(237),
    [anon_sym_DOT_LBRACK] = ACTIONS(187),
    [anon_sym_LT] = ACTIONS(189),
    [anon_sym_use] = ACTIONS(239),
    [anon_sym_use_BANG] = ACTIONS(241),
    [anon_sym_do_BANG] = ACTIONS(243),
    [anon_sym_begin] = ACTIONS(245),
    [anon_sym_LPAREN2] = ACTIONS(191),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(247),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(251),
    [anon_sym_AT_DQUOTE] = ACTIONS(253),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(255),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(257),
    [sym_bool] = ACTIONS(259),
    [sym_unit] = ACTIONS(193),
    [anon_sym_LPAREN_PIPE] = ACTIONS(261),
    [sym_op_identifier] = ACTIONS(263),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(265),
    [sym_xint] = ACTIONS(267),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(269),
    [sym__newline] = ACTIONS(273),
  },
  [344] = {
    [sym_function_or_value_defn] = STATE(627),
    [sym__expression] = STATE(17),
    [sym_literal_expression] = STATE(1118),
    [sym_long_identifier_or_op] = STATE(1118),
    [sym_tuple_expression] = STATE(1118),
    [sym_brace_expression] = STATE(1118),
    [sym_anon_record_expression] = STATE(1118),
    [sym_prefixed_expression] = STATE(1118),
    [sym_typecast_expression] = STATE(1118),
    [sym_for_expression] = STATE(1118),
    [sym_while_expression] = STATE(1118),
    [sym__if_branch] = STATE(7163),
    [sym_if_expression] = STATE(1118),
    [sym_fun_expression] = STATE(1118),
    [sym_try_expression] = STATE(1118),
    [sym_match_expression] = STATE(1118),
    [sym_function_expression] = STATE(1118),
    [sym_mutate_expression] = STATE(1118),
    [sym_index_expression] = STATE(1118),
    [sym_typed_expression] = STATE(1118),
    [sym_declaration_expression] = STATE(1118),
    [sym_do_expression] = STATE(1118),
    [sym_list_expression] = STATE(1118),
    [sym_array_expression] = STATE(1118),
    [sym_begin_end_expression] = STATE(1118),
    [sym_paren_expression] = STATE(1118),
    [sym__high_prec_app] = STATE(1133),
    [sym__low_prec_app] = STATE(1133),
    [sym_application_expression] = STATE(1118),
    [sym_dot_expression] = STATE(1118),
    [sym_infix_expression] = STATE(1118),
    [sym_ce_expression] = STATE(1118),
    [sym_sequential_expression] = STATE(1118),
    [sym_char] = STATE(1080),
    [sym_format_string] = STATE(1090),
    [sym__string_literal] = STATE(1090),
    [sym_string] = STATE(1080),
    [sym_verbatim_string] = STATE(1080),
    [sym_bytearray] = STATE(1080),
    [sym_verbatim_bytearray] = STATE(1080),
    [sym_format_triple_quoted_string] = STATE(1096),
    [sym_triple_quoted_string] = STATE(1080),
    [sym_const] = STATE(1118),
    [sym_long_identifier] = STATE(1156),
    [sym_active_pattern] = STATE(1085),
    [sym__identifier_or_op] = STATE(1099),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(517),
    [sym_infix_op] = STATE(487),
    [sym_sbyte] = STATE(1080),
    [sym_byte] = STATE(1080),
    [sym_int16] = STATE(1080),
    [sym_uint16] = STATE(1080),
    [sym_int32] = STATE(1080),
    [sym_uint32] = STATE(1080),
    [sym_nativeint] = STATE(1080),
    [sym_unativeint] = STATE(1080),
    [sym_int64] = STATE(1080),
    [sym_uint64] = STATE(1080),
    [sym_ieee32] = STATE(1080),
    [sym_ieee64] = STATE(1080),
    [sym_bignum] = STATE(1080),
    [sym_decimal] = STATE(1080),
    [sym_float] = STATE(979),
    [sym_block_comment] = STATE(344),
    [sym_compiler_directive_decl] = STATE(344),
    [sym_fsi_directive_decl] = STATE(344),
    [sym_preproc_line] = STATE(344),
    [sym_preproc_if_in_expression] = STATE(1118),
    [aux_sym_sequential_expression_repeat1] = STATE(1069),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(195),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(197),
    [anon_sym_return] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(1649),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_COMMA] = ACTIONS(205),
    [anon_sym_null] = ACTIONS(207),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(197),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(209),
    [anon_sym_LBRACK_PIPE] = ACTIONS(211),
    [anon_sym_LBRACE] = ACTIONS(271),
    [anon_sym_LT_AT] = ACTIONS(213),
    [anon_sym_LT_AT_AT] = ACTIONS(215),
    [anon_sym_DOT] = ACTIONS(185),
    [anon_sym_LBRACE_PIPE] = ACTIONS(217),
    [anon_sym_new] = ACTIONS(199),
    [anon_sym_return_BANG] = ACTIONS(219),
    [anon_sym_yield] = ACTIONS(199),
    [anon_sym_yield_BANG] = ACTIONS(219),
    [anon_sym_lazy] = ACTIONS(199),
    [anon_sym_assert] = ACTIONS(199),
    [anon_sym_upcast] = ACTIONS(199),
    [anon_sym_downcast] = ACTIONS(199),
    [anon_sym_COLON_GT] = ACTIONS(221),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(221),
    [anon_sym_for] = ACTIONS(223),
    [anon_sym_while] = ACTIONS(225),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(229),
    [anon_sym_match] = ACTIONS(231),
    [anon_sym_match_BANG] = ACTIONS(233),
    [anon_sym_function] = ACTIONS(235),
    [anon_sym_LT_DASH] = ACTIONS(237),
    [anon_sym_DOT_LBRACK] = ACTIONS(187),
    [anon_sym_LT] = ACTIONS(189),
    [anon_sym_use] = ACTIONS(239),
    [anon_sym_use_BANG] = ACTIONS(241),
    [anon_sym_do_BANG] = ACTIONS(243),
    [anon_sym_begin] = ACTIONS(245),
    [anon_sym_LPAREN2] = ACTIONS(191),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(247),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(251),
    [anon_sym_AT_DQUOTE] = ACTIONS(253),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(255),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(257),
    [sym_bool] = ACTIONS(259),
    [sym_unit] = ACTIONS(193),
    [anon_sym_LPAREN_PIPE] = ACTIONS(261),
    [sym_op_identifier] = ACTIONS(263),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(265),
    [sym_xint] = ACTIONS(267),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(269),
    [sym__newline] = ACTIONS(273),
  },
  [345] = {
    [sym_function_or_value_defn] = STATE(627),
    [sym__expression] = STATE(17),
    [sym_literal_expression] = STATE(1118),
    [sym_long_identifier_or_op] = STATE(1118),
    [sym_tuple_expression] = STATE(1118),
    [sym_brace_expression] = STATE(1118),
    [sym_anon_record_expression] = STATE(1118),
    [sym_prefixed_expression] = STATE(1118),
    [sym_typecast_expression] = STATE(1118),
    [sym_for_expression] = STATE(1118),
    [sym_while_expression] = STATE(1118),
    [sym__if_branch] = STATE(7163),
    [sym_if_expression] = STATE(1118),
    [sym_fun_expression] = STATE(1118),
    [sym_try_expression] = STATE(1118),
    [sym_match_expression] = STATE(1118),
    [sym_function_expression] = STATE(1118),
    [sym_mutate_expression] = STATE(1118),
    [sym_index_expression] = STATE(1118),
    [sym_typed_expression] = STATE(1118),
    [sym_declaration_expression] = STATE(1118),
    [sym_do_expression] = STATE(1118),
    [sym_list_expression] = STATE(1118),
    [sym_array_expression] = STATE(1118),
    [sym_begin_end_expression] = STATE(1118),
    [sym_paren_expression] = STATE(1118),
    [sym__high_prec_app] = STATE(1133),
    [sym__low_prec_app] = STATE(1133),
    [sym_application_expression] = STATE(1118),
    [sym_dot_expression] = STATE(1118),
    [sym_infix_expression] = STATE(1118),
    [sym_ce_expression] = STATE(1118),
    [sym_sequential_expression] = STATE(1118),
    [sym_char] = STATE(1080),
    [sym_format_string] = STATE(1090),
    [sym__string_literal] = STATE(1090),
    [sym_string] = STATE(1080),
    [sym_verbatim_string] = STATE(1080),
    [sym_bytearray] = STATE(1080),
    [sym_verbatim_bytearray] = STATE(1080),
    [sym_format_triple_quoted_string] = STATE(1096),
    [sym_triple_quoted_string] = STATE(1080),
    [sym_const] = STATE(1118),
    [sym_long_identifier] = STATE(1156),
    [sym_active_pattern] = STATE(1085),
    [sym__identifier_or_op] = STATE(1099),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(517),
    [sym_infix_op] = STATE(487),
    [sym_sbyte] = STATE(1080),
    [sym_byte] = STATE(1080),
    [sym_int16] = STATE(1080),
    [sym_uint16] = STATE(1080),
    [sym_int32] = STATE(1080),
    [sym_uint32] = STATE(1080),
    [sym_nativeint] = STATE(1080),
    [sym_unativeint] = STATE(1080),
    [sym_int64] = STATE(1080),
    [sym_uint64] = STATE(1080),
    [sym_ieee32] = STATE(1080),
    [sym_ieee64] = STATE(1080),
    [sym_bignum] = STATE(1080),
    [sym_decimal] = STATE(1080),
    [sym_float] = STATE(979),
    [sym_block_comment] = STATE(345),
    [sym_compiler_directive_decl] = STATE(345),
    [sym_fsi_directive_decl] = STATE(345),
    [sym_preproc_line] = STATE(345),
    [sym_preproc_if_in_expression] = STATE(1118),
    [aux_sym_sequential_expression_repeat1] = STATE(1069),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(195),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(197),
    [anon_sym_return] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(1651),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_COMMA] = ACTIONS(205),
    [anon_sym_null] = ACTIONS(207),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(197),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(209),
    [anon_sym_LBRACK_PIPE] = ACTIONS(211),
    [anon_sym_LBRACE] = ACTIONS(271),
    [anon_sym_LT_AT] = ACTIONS(213),
    [anon_sym_LT_AT_AT] = ACTIONS(215),
    [anon_sym_DOT] = ACTIONS(185),
    [anon_sym_LBRACE_PIPE] = ACTIONS(217),
    [anon_sym_new] = ACTIONS(199),
    [anon_sym_return_BANG] = ACTIONS(219),
    [anon_sym_yield] = ACTIONS(199),
    [anon_sym_yield_BANG] = ACTIONS(219),
    [anon_sym_lazy] = ACTIONS(199),
    [anon_sym_assert] = ACTIONS(199),
    [anon_sym_upcast] = ACTIONS(199),
    [anon_sym_downcast] = ACTIONS(199),
    [anon_sym_COLON_GT] = ACTIONS(221),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(221),
    [anon_sym_for] = ACTIONS(223),
    [anon_sym_while] = ACTIONS(225),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(229),
    [anon_sym_match] = ACTIONS(231),
    [anon_sym_match_BANG] = ACTIONS(233),
    [anon_sym_function] = ACTIONS(235),
    [anon_sym_LT_DASH] = ACTIONS(237),
    [anon_sym_DOT_LBRACK] = ACTIONS(187),
    [anon_sym_LT] = ACTIONS(189),
    [anon_sym_use] = ACTIONS(239),
    [anon_sym_use_BANG] = ACTIONS(241),
    [anon_sym_do_BANG] = ACTIONS(243),
    [anon_sym_begin] = ACTIONS(245),
    [anon_sym_LPAREN2] = ACTIONS(191),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(247),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(251),
    [anon_sym_AT_DQUOTE] = ACTIONS(253),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(255),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(257),
    [sym_bool] = ACTIONS(259),
    [sym_unit] = ACTIONS(193),
    [anon_sym_LPAREN_PIPE] = ACTIONS(261),
    [sym_op_identifier] = ACTIONS(263),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(265),
    [sym_xint] = ACTIONS(267),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(269),
    [sym__newline] = ACTIONS(273),
  },
  [346] = {
    [sym_function_or_value_defn] = STATE(627),
    [sym__expression] = STATE(17),
    [sym_literal_expression] = STATE(1118),
    [sym_long_identifier_or_op] = STATE(1118),
    [sym_tuple_expression] = STATE(1118),
    [sym_brace_expression] = STATE(1118),
    [sym_anon_record_expression] = STATE(1118),
    [sym_prefixed_expression] = STATE(1118),
    [sym_typecast_expression] = STATE(1118),
    [sym_for_expression] = STATE(1118),
    [sym_while_expression] = STATE(1118),
    [sym__if_branch] = STATE(7163),
    [sym_if_expression] = STATE(1118),
    [sym_fun_expression] = STATE(1118),
    [sym_try_expression] = STATE(1118),
    [sym_match_expression] = STATE(1118),
    [sym_function_expression] = STATE(1118),
    [sym_mutate_expression] = STATE(1118),
    [sym_index_expression] = STATE(1118),
    [sym_typed_expression] = STATE(1118),
    [sym_declaration_expression] = STATE(1118),
    [sym_do_expression] = STATE(1118),
    [sym_list_expression] = STATE(1118),
    [sym_array_expression] = STATE(1118),
    [sym_begin_end_expression] = STATE(1118),
    [sym_paren_expression] = STATE(1118),
    [sym__high_prec_app] = STATE(1133),
    [sym__low_prec_app] = STATE(1133),
    [sym_application_expression] = STATE(1118),
    [sym_dot_expression] = STATE(1118),
    [sym_infix_expression] = STATE(1118),
    [sym_ce_expression] = STATE(1118),
    [sym_sequential_expression] = STATE(1118),
    [sym_char] = STATE(1080),
    [sym_format_string] = STATE(1090),
    [sym__string_literal] = STATE(1090),
    [sym_string] = STATE(1080),
    [sym_verbatim_string] = STATE(1080),
    [sym_bytearray] = STATE(1080),
    [sym_verbatim_bytearray] = STATE(1080),
    [sym_format_triple_quoted_string] = STATE(1096),
    [sym_triple_quoted_string] = STATE(1080),
    [sym_const] = STATE(1118),
    [sym_long_identifier] = STATE(1156),
    [sym_active_pattern] = STATE(1085),
    [sym__identifier_or_op] = STATE(1099),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(517),
    [sym_infix_op] = STATE(487),
    [sym_sbyte] = STATE(1080),
    [sym_byte] = STATE(1080),
    [sym_int16] = STATE(1080),
    [sym_uint16] = STATE(1080),
    [sym_int32] = STATE(1080),
    [sym_uint32] = STATE(1080),
    [sym_nativeint] = STATE(1080),
    [sym_unativeint] = STATE(1080),
    [sym_int64] = STATE(1080),
    [sym_uint64] = STATE(1080),
    [sym_ieee32] = STATE(1080),
    [sym_ieee64] = STATE(1080),
    [sym_bignum] = STATE(1080),
    [sym_decimal] = STATE(1080),
    [sym_float] = STATE(979),
    [sym_block_comment] = STATE(346),
    [sym_compiler_directive_decl] = STATE(346),
    [sym_fsi_directive_decl] = STATE(346),
    [sym_preproc_line] = STATE(346),
    [sym_preproc_if_in_expression] = STATE(1118),
    [aux_sym_sequential_expression_repeat1] = STATE(1069),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(195),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(197),
    [anon_sym_return] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(1653),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_COMMA] = ACTIONS(205),
    [anon_sym_null] = ACTIONS(207),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(197),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(209),
    [anon_sym_LBRACK_PIPE] = ACTIONS(211),
    [anon_sym_LBRACE] = ACTIONS(271),
    [anon_sym_LT_AT] = ACTIONS(213),
    [anon_sym_LT_AT_AT] = ACTIONS(215),
    [anon_sym_DOT] = ACTIONS(185),
    [anon_sym_LBRACE_PIPE] = ACTIONS(217),
    [anon_sym_new] = ACTIONS(199),
    [anon_sym_return_BANG] = ACTIONS(219),
    [anon_sym_yield] = ACTIONS(199),
    [anon_sym_yield_BANG] = ACTIONS(219),
    [anon_sym_lazy] = ACTIONS(199),
    [anon_sym_assert] = ACTIONS(199),
    [anon_sym_upcast] = ACTIONS(199),
    [anon_sym_downcast] = ACTIONS(199),
    [anon_sym_COLON_GT] = ACTIONS(221),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(221),
    [anon_sym_for] = ACTIONS(223),
    [anon_sym_while] = ACTIONS(225),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(229),
    [anon_sym_match] = ACTIONS(231),
    [anon_sym_match_BANG] = ACTIONS(233),
    [anon_sym_function] = ACTIONS(235),
    [anon_sym_LT_DASH] = ACTIONS(237),
    [anon_sym_DOT_LBRACK] = ACTIONS(187),
    [anon_sym_LT] = ACTIONS(189),
    [anon_sym_use] = ACTIONS(239),
    [anon_sym_use_BANG] = ACTIONS(241),
    [anon_sym_do_BANG] = ACTIONS(243),
    [anon_sym_begin] = ACTIONS(245),
    [anon_sym_LPAREN2] = ACTIONS(191),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(247),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(251),
    [anon_sym_AT_DQUOTE] = ACTIONS(253),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(255),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(257),
    [sym_bool] = ACTIONS(259),
    [sym_unit] = ACTIONS(193),
    [anon_sym_LPAREN_PIPE] = ACTIONS(261),
    [sym_op_identifier] = ACTIONS(263),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(265),
    [sym_xint] = ACTIONS(267),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(269),
    [sym__newline] = ACTIONS(273),
  },
  [347] = {
    [sym_function_or_value_defn] = STATE(627),
    [sym__expression] = STATE(17),
    [sym_literal_expression] = STATE(1118),
    [sym_long_identifier_or_op] = STATE(1118),
    [sym_tuple_expression] = STATE(1118),
    [sym_brace_expression] = STATE(1118),
    [sym_anon_record_expression] = STATE(1118),
    [sym_prefixed_expression] = STATE(1118),
    [sym_typecast_expression] = STATE(1118),
    [sym_for_expression] = STATE(1118),
    [sym_while_expression] = STATE(1118),
    [sym__if_branch] = STATE(7163),
    [sym_if_expression] = STATE(1118),
    [sym_fun_expression] = STATE(1118),
    [sym_try_expression] = STATE(1118),
    [sym_match_expression] = STATE(1118),
    [sym_function_expression] = STATE(1118),
    [sym_mutate_expression] = STATE(1118),
    [sym_index_expression] = STATE(1118),
    [sym_typed_expression] = STATE(1118),
    [sym_declaration_expression] = STATE(1118),
    [sym_do_expression] = STATE(1118),
    [sym_list_expression] = STATE(1118),
    [sym_array_expression] = STATE(1118),
    [sym_begin_end_expression] = STATE(1118),
    [sym_paren_expression] = STATE(1118),
    [sym__high_prec_app] = STATE(1133),
    [sym__low_prec_app] = STATE(1133),
    [sym_application_expression] = STATE(1118),
    [sym_dot_expression] = STATE(1118),
    [sym_infix_expression] = STATE(1118),
    [sym_ce_expression] = STATE(1118),
    [sym_sequential_expression] = STATE(1118),
    [sym_char] = STATE(1080),
    [sym_format_string] = STATE(1090),
    [sym__string_literal] = STATE(1090),
    [sym_string] = STATE(1080),
    [sym_verbatim_string] = STATE(1080),
    [sym_bytearray] = STATE(1080),
    [sym_verbatim_bytearray] = STATE(1080),
    [sym_format_triple_quoted_string] = STATE(1096),
    [sym_triple_quoted_string] = STATE(1080),
    [sym_const] = STATE(1118),
    [sym_long_identifier] = STATE(1156),
    [sym_active_pattern] = STATE(1085),
    [sym__identifier_or_op] = STATE(1099),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(517),
    [sym_infix_op] = STATE(487),
    [sym_sbyte] = STATE(1080),
    [sym_byte] = STATE(1080),
    [sym_int16] = STATE(1080),
    [sym_uint16] = STATE(1080),
    [sym_int32] = STATE(1080),
    [sym_uint32] = STATE(1080),
    [sym_nativeint] = STATE(1080),
    [sym_unativeint] = STATE(1080),
    [sym_int64] = STATE(1080),
    [sym_uint64] = STATE(1080),
    [sym_ieee32] = STATE(1080),
    [sym_ieee64] = STATE(1080),
    [sym_bignum] = STATE(1080),
    [sym_decimal] = STATE(1080),
    [sym_float] = STATE(979),
    [sym_block_comment] = STATE(347),
    [sym_compiler_directive_decl] = STATE(347),
    [sym_fsi_directive_decl] = STATE(347),
    [sym_preproc_line] = STATE(347),
    [sym_preproc_if_in_expression] = STATE(1118),
    [aux_sym_sequential_expression_repeat1] = STATE(1069),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(195),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(197),
    [anon_sym_return] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(1655),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_COMMA] = ACTIONS(205),
    [anon_sym_null] = ACTIONS(207),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(197),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(209),
    [anon_sym_LBRACK_PIPE] = ACTIONS(211),
    [anon_sym_LBRACE] = ACTIONS(271),
    [anon_sym_LT_AT] = ACTIONS(213),
    [anon_sym_LT_AT_AT] = ACTIONS(215),
    [anon_sym_DOT] = ACTIONS(185),
    [anon_sym_LBRACE_PIPE] = ACTIONS(217),
    [anon_sym_new] = ACTIONS(199),
    [anon_sym_return_BANG] = ACTIONS(219),
    [anon_sym_yield] = ACTIONS(199),
    [anon_sym_yield_BANG] = ACTIONS(219),
    [anon_sym_lazy] = ACTIONS(199),
    [anon_sym_assert] = ACTIONS(199),
    [anon_sym_upcast] = ACTIONS(199),
    [anon_sym_downcast] = ACTIONS(199),
    [anon_sym_COLON_GT] = ACTIONS(221),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(221),
    [anon_sym_for] = ACTIONS(223),
    [anon_sym_while] = ACTIONS(225),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(229),
    [anon_sym_match] = ACTIONS(231),
    [anon_sym_match_BANG] = ACTIONS(233),
    [anon_sym_function] = ACTIONS(235),
    [anon_sym_LT_DASH] = ACTIONS(237),
    [anon_sym_DOT_LBRACK] = ACTIONS(187),
    [anon_sym_LT] = ACTIONS(189),
    [anon_sym_use] = ACTIONS(239),
    [anon_sym_use_BANG] = ACTIONS(241),
    [anon_sym_do_BANG] = ACTIONS(243),
    [anon_sym_begin] = ACTIONS(245),
    [anon_sym_LPAREN2] = ACTIONS(191),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(247),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(251),
    [anon_sym_AT_DQUOTE] = ACTIONS(253),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(255),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(257),
    [sym_bool] = ACTIONS(259),
    [sym_unit] = ACTIONS(193),
    [anon_sym_LPAREN_PIPE] = ACTIONS(261),
    [sym_op_identifier] = ACTIONS(263),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(265),
    [sym_xint] = ACTIONS(267),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(269),
    [sym__newline] = ACTIONS(273),
  },
  [348] = {
    [sym_function_or_value_defn] = STATE(627),
    [sym__expression] = STATE(17),
    [sym_literal_expression] = STATE(1118),
    [sym_long_identifier_or_op] = STATE(1118),
    [sym_tuple_expression] = STATE(1118),
    [sym_brace_expression] = STATE(1118),
    [sym_anon_record_expression] = STATE(1118),
    [sym_prefixed_expression] = STATE(1118),
    [sym_typecast_expression] = STATE(1118),
    [sym_for_expression] = STATE(1118),
    [sym_while_expression] = STATE(1118),
    [sym__if_branch] = STATE(7163),
    [sym_if_expression] = STATE(1118),
    [sym_fun_expression] = STATE(1118),
    [sym_try_expression] = STATE(1118),
    [sym_match_expression] = STATE(1118),
    [sym_function_expression] = STATE(1118),
    [sym_mutate_expression] = STATE(1118),
    [sym_index_expression] = STATE(1118),
    [sym_typed_expression] = STATE(1118),
    [sym_declaration_expression] = STATE(1118),
    [sym_do_expression] = STATE(1118),
    [sym_list_expression] = STATE(1118),
    [sym_array_expression] = STATE(1118),
    [sym_begin_end_expression] = STATE(1118),
    [sym_paren_expression] = STATE(1118),
    [sym__high_prec_app] = STATE(1133),
    [sym__low_prec_app] = STATE(1133),
    [sym_application_expression] = STATE(1118),
    [sym_dot_expression] = STATE(1118),
    [sym_infix_expression] = STATE(1118),
    [sym_ce_expression] = STATE(1118),
    [sym_sequential_expression] = STATE(1118),
    [sym_char] = STATE(1080),
    [sym_format_string] = STATE(1090),
    [sym__string_literal] = STATE(1090),
    [sym_string] = STATE(1080),
    [sym_verbatim_string] = STATE(1080),
    [sym_bytearray] = STATE(1080),
    [sym_verbatim_bytearray] = STATE(1080),
    [sym_format_triple_quoted_string] = STATE(1096),
    [sym_triple_quoted_string] = STATE(1080),
    [sym_const] = STATE(1118),
    [sym_long_identifier] = STATE(1156),
    [sym_active_pattern] = STATE(1085),
    [sym__identifier_or_op] = STATE(1099),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(517),
    [sym_infix_op] = STATE(487),
    [sym_sbyte] = STATE(1080),
    [sym_byte] = STATE(1080),
    [sym_int16] = STATE(1080),
    [sym_uint16] = STATE(1080),
    [sym_int32] = STATE(1080),
    [sym_uint32] = STATE(1080),
    [sym_nativeint] = STATE(1080),
    [sym_unativeint] = STATE(1080),
    [sym_int64] = STATE(1080),
    [sym_uint64] = STATE(1080),
    [sym_ieee32] = STATE(1080),
    [sym_ieee64] = STATE(1080),
    [sym_bignum] = STATE(1080),
    [sym_decimal] = STATE(1080),
    [sym_float] = STATE(979),
    [sym_block_comment] = STATE(348),
    [sym_compiler_directive_decl] = STATE(348),
    [sym_fsi_directive_decl] = STATE(348),
    [sym_preproc_line] = STATE(348),
    [sym_preproc_if_in_expression] = STATE(1118),
    [aux_sym_sequential_expression_repeat1] = STATE(1069),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(195),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(197),
    [anon_sym_return] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(1367),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_COMMA] = ACTIONS(205),
    [anon_sym_null] = ACTIONS(207),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(197),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(209),
    [anon_sym_LBRACK_PIPE] = ACTIONS(211),
    [anon_sym_LBRACE] = ACTIONS(271),
    [anon_sym_LT_AT] = ACTIONS(213),
    [anon_sym_LT_AT_AT] = ACTIONS(215),
    [anon_sym_DOT] = ACTIONS(185),
    [anon_sym_LBRACE_PIPE] = ACTIONS(217),
    [anon_sym_new] = ACTIONS(199),
    [anon_sym_return_BANG] = ACTIONS(219),
    [anon_sym_yield] = ACTIONS(199),
    [anon_sym_yield_BANG] = ACTIONS(219),
    [anon_sym_lazy] = ACTIONS(199),
    [anon_sym_assert] = ACTIONS(199),
    [anon_sym_upcast] = ACTIONS(199),
    [anon_sym_downcast] = ACTIONS(199),
    [anon_sym_COLON_GT] = ACTIONS(221),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(221),
    [anon_sym_for] = ACTIONS(223),
    [anon_sym_while] = ACTIONS(225),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(229),
    [anon_sym_match] = ACTIONS(231),
    [anon_sym_match_BANG] = ACTIONS(233),
    [anon_sym_function] = ACTIONS(235),
    [anon_sym_LT_DASH] = ACTIONS(237),
    [anon_sym_DOT_LBRACK] = ACTIONS(187),
    [anon_sym_LT] = ACTIONS(189),
    [anon_sym_use] = ACTIONS(239),
    [anon_sym_use_BANG] = ACTIONS(241),
    [anon_sym_do_BANG] = ACTIONS(243),
    [anon_sym_begin] = ACTIONS(245),
    [anon_sym_LPAREN2] = ACTIONS(191),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(247),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(251),
    [anon_sym_AT_DQUOTE] = ACTIONS(253),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(255),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(257),
    [sym_bool] = ACTIONS(259),
    [sym_unit] = ACTIONS(193),
    [anon_sym_LPAREN_PIPE] = ACTIONS(261),
    [sym_op_identifier] = ACTIONS(263),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(265),
    [sym_xint] = ACTIONS(267),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(269),
    [sym__newline] = ACTIONS(273),
  },
  [349] = {
    [sym_function_or_value_defn] = STATE(627),
    [sym__expression] = STATE(17),
    [sym_literal_expression] = STATE(1118),
    [sym_long_identifier_or_op] = STATE(1118),
    [sym_tuple_expression] = STATE(1118),
    [sym_brace_expression] = STATE(1118),
    [sym_anon_record_expression] = STATE(1118),
    [sym_prefixed_expression] = STATE(1118),
    [sym_typecast_expression] = STATE(1118),
    [sym_for_expression] = STATE(1118),
    [sym_while_expression] = STATE(1118),
    [sym__if_branch] = STATE(7163),
    [sym_if_expression] = STATE(1118),
    [sym_fun_expression] = STATE(1118),
    [sym_try_expression] = STATE(1118),
    [sym_match_expression] = STATE(1118),
    [sym_function_expression] = STATE(1118),
    [sym_mutate_expression] = STATE(1118),
    [sym_index_expression] = STATE(1118),
    [sym_typed_expression] = STATE(1118),
    [sym_declaration_expression] = STATE(1118),
    [sym_do_expression] = STATE(1118),
    [sym_list_expression] = STATE(1118),
    [sym_array_expression] = STATE(1118),
    [sym_begin_end_expression] = STATE(1118),
    [sym_paren_expression] = STATE(1118),
    [sym__high_prec_app] = STATE(1133),
    [sym__low_prec_app] = STATE(1133),
    [sym_application_expression] = STATE(1118),
    [sym_dot_expression] = STATE(1118),
    [sym_infix_expression] = STATE(1118),
    [sym_ce_expression] = STATE(1118),
    [sym_sequential_expression] = STATE(1118),
    [sym_char] = STATE(1080),
    [sym_format_string] = STATE(1090),
    [sym__string_literal] = STATE(1090),
    [sym_string] = STATE(1080),
    [sym_verbatim_string] = STATE(1080),
    [sym_bytearray] = STATE(1080),
    [sym_verbatim_bytearray] = STATE(1080),
    [sym_format_triple_quoted_string] = STATE(1096),
    [sym_triple_quoted_string] = STATE(1080),
    [sym_const] = STATE(1118),
    [sym_long_identifier] = STATE(1156),
    [sym_active_pattern] = STATE(1085),
    [sym__identifier_or_op] = STATE(1099),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(517),
    [sym_infix_op] = STATE(487),
    [sym_sbyte] = STATE(1080),
    [sym_byte] = STATE(1080),
    [sym_int16] = STATE(1080),
    [sym_uint16] = STATE(1080),
    [sym_int32] = STATE(1080),
    [sym_uint32] = STATE(1080),
    [sym_nativeint] = STATE(1080),
    [sym_unativeint] = STATE(1080),
    [sym_int64] = STATE(1080),
    [sym_uint64] = STATE(1080),
    [sym_ieee32] = STATE(1080),
    [sym_ieee64] = STATE(1080),
    [sym_bignum] = STATE(1080),
    [sym_decimal] = STATE(1080),
    [sym_float] = STATE(979),
    [sym_block_comment] = STATE(349),
    [sym_compiler_directive_decl] = STATE(349),
    [sym_fsi_directive_decl] = STATE(349),
    [sym_preproc_line] = STATE(349),
    [sym_preproc_if_in_expression] = STATE(1118),
    [aux_sym_sequential_expression_repeat1] = STATE(1069),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(195),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(197),
    [anon_sym_return] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(1657),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_COMMA] = ACTIONS(205),
    [anon_sym_null] = ACTIONS(207),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(197),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(209),
    [anon_sym_LBRACK_PIPE] = ACTIONS(211),
    [anon_sym_LBRACE] = ACTIONS(271),
    [anon_sym_LT_AT] = ACTIONS(213),
    [anon_sym_LT_AT_AT] = ACTIONS(215),
    [anon_sym_DOT] = ACTIONS(185),
    [anon_sym_LBRACE_PIPE] = ACTIONS(217),
    [anon_sym_new] = ACTIONS(199),
    [anon_sym_return_BANG] = ACTIONS(219),
    [anon_sym_yield] = ACTIONS(199),
    [anon_sym_yield_BANG] = ACTIONS(219),
    [anon_sym_lazy] = ACTIONS(199),
    [anon_sym_assert] = ACTIONS(199),
    [anon_sym_upcast] = ACTIONS(199),
    [anon_sym_downcast] = ACTIONS(199),
    [anon_sym_COLON_GT] = ACTIONS(221),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(221),
    [anon_sym_for] = ACTIONS(223),
    [anon_sym_while] = ACTIONS(225),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(229),
    [anon_sym_match] = ACTIONS(231),
    [anon_sym_match_BANG] = ACTIONS(233),
    [anon_sym_function] = ACTIONS(235),
    [anon_sym_LT_DASH] = ACTIONS(237),
    [anon_sym_DOT_LBRACK] = ACTIONS(187),
    [anon_sym_LT] = ACTIONS(189),
    [anon_sym_use] = ACTIONS(239),
    [anon_sym_use_BANG] = ACTIONS(241),
    [anon_sym_do_BANG] = ACTIONS(243),
    [anon_sym_begin] = ACTIONS(245),
    [anon_sym_LPAREN2] = ACTIONS(191),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(247),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(251),
    [anon_sym_AT_DQUOTE] = ACTIONS(253),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(255),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(257),
    [sym_bool] = ACTIONS(259),
    [sym_unit] = ACTIONS(193),
    [anon_sym_LPAREN_PIPE] = ACTIONS(261),
    [sym_op_identifier] = ACTIONS(263),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(265),
    [sym_xint] = ACTIONS(267),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(269),
    [sym__newline] = ACTIONS(273),
  },
  [350] = {
    [sym_function_or_value_defn] = STATE(627),
    [sym__expression] = STATE(17),
    [sym_literal_expression] = STATE(1118),
    [sym_long_identifier_or_op] = STATE(1118),
    [sym_tuple_expression] = STATE(1118),
    [sym_brace_expression] = STATE(1118),
    [sym_anon_record_expression] = STATE(1118),
    [sym_prefixed_expression] = STATE(1118),
    [sym_typecast_expression] = STATE(1118),
    [sym_for_expression] = STATE(1118),
    [sym_while_expression] = STATE(1118),
    [sym__if_branch] = STATE(7163),
    [sym_if_expression] = STATE(1118),
    [sym_fun_expression] = STATE(1118),
    [sym_try_expression] = STATE(1118),
    [sym_match_expression] = STATE(1118),
    [sym_function_expression] = STATE(1118),
    [sym_mutate_expression] = STATE(1118),
    [sym_index_expression] = STATE(1118),
    [sym_typed_expression] = STATE(1118),
    [sym_declaration_expression] = STATE(1118),
    [sym_do_expression] = STATE(1118),
    [sym_list_expression] = STATE(1118),
    [sym_array_expression] = STATE(1118),
    [sym_begin_end_expression] = STATE(1118),
    [sym_paren_expression] = STATE(1118),
    [sym__high_prec_app] = STATE(1133),
    [sym__low_prec_app] = STATE(1133),
    [sym_application_expression] = STATE(1118),
    [sym_dot_expression] = STATE(1118),
    [sym_infix_expression] = STATE(1118),
    [sym_ce_expression] = STATE(1118),
    [sym_sequential_expression] = STATE(1118),
    [sym_char] = STATE(1080),
    [sym_format_string] = STATE(1090),
    [sym__string_literal] = STATE(1090),
    [sym_string] = STATE(1080),
    [sym_verbatim_string] = STATE(1080),
    [sym_bytearray] = STATE(1080),
    [sym_verbatim_bytearray] = STATE(1080),
    [sym_format_triple_quoted_string] = STATE(1096),
    [sym_triple_quoted_string] = STATE(1080),
    [sym_const] = STATE(1118),
    [sym_long_identifier] = STATE(1156),
    [sym_active_pattern] = STATE(1085),
    [sym__identifier_or_op] = STATE(1099),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(517),
    [sym_infix_op] = STATE(487),
    [sym_sbyte] = STATE(1080),
    [sym_byte] = STATE(1080),
    [sym_int16] = STATE(1080),
    [sym_uint16] = STATE(1080),
    [sym_int32] = STATE(1080),
    [sym_uint32] = STATE(1080),
    [sym_nativeint] = STATE(1080),
    [sym_unativeint] = STATE(1080),
    [sym_int64] = STATE(1080),
    [sym_uint64] = STATE(1080),
    [sym_ieee32] = STATE(1080),
    [sym_ieee64] = STATE(1080),
    [sym_bignum] = STATE(1080),
    [sym_decimal] = STATE(1080),
    [sym_float] = STATE(979),
    [sym_block_comment] = STATE(350),
    [sym_compiler_directive_decl] = STATE(350),
    [sym_fsi_directive_decl] = STATE(350),
    [sym_preproc_line] = STATE(350),
    [sym_preproc_if_in_expression] = STATE(1118),
    [aux_sym_sequential_expression_repeat1] = STATE(1069),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(195),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(197),
    [anon_sym_return] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(1659),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_COMMA] = ACTIONS(205),
    [anon_sym_null] = ACTIONS(207),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(197),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(209),
    [anon_sym_LBRACK_PIPE] = ACTIONS(211),
    [anon_sym_LBRACE] = ACTIONS(271),
    [anon_sym_LT_AT] = ACTIONS(213),
    [anon_sym_LT_AT_AT] = ACTIONS(215),
    [anon_sym_DOT] = ACTIONS(185),
    [anon_sym_LBRACE_PIPE] = ACTIONS(217),
    [anon_sym_new] = ACTIONS(199),
    [anon_sym_return_BANG] = ACTIONS(219),
    [anon_sym_yield] = ACTIONS(199),
    [anon_sym_yield_BANG] = ACTIONS(219),
    [anon_sym_lazy] = ACTIONS(199),
    [anon_sym_assert] = ACTIONS(199),
    [anon_sym_upcast] = ACTIONS(199),
    [anon_sym_downcast] = ACTIONS(199),
    [anon_sym_COLON_GT] = ACTIONS(221),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(221),
    [anon_sym_for] = ACTIONS(223),
    [anon_sym_while] = ACTIONS(225),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(229),
    [anon_sym_match] = ACTIONS(231),
    [anon_sym_match_BANG] = ACTIONS(233),
    [anon_sym_function] = ACTIONS(235),
    [anon_sym_LT_DASH] = ACTIONS(237),
    [anon_sym_DOT_LBRACK] = ACTIONS(187),
    [anon_sym_LT] = ACTIONS(189),
    [anon_sym_use] = ACTIONS(239),
    [anon_sym_use_BANG] = ACTIONS(241),
    [anon_sym_do_BANG] = ACTIONS(243),
    [anon_sym_begin] = ACTIONS(245),
    [anon_sym_LPAREN2] = ACTIONS(191),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(247),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(251),
    [anon_sym_AT_DQUOTE] = ACTIONS(253),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(255),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(257),
    [sym_bool] = ACTIONS(259),
    [sym_unit] = ACTIONS(193),
    [anon_sym_LPAREN_PIPE] = ACTIONS(261),
    [sym_op_identifier] = ACTIONS(263),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(265),
    [sym_xint] = ACTIONS(267),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(269),
    [sym__newline] = ACTIONS(273),
  },
  [351] = {
    [sym_function_or_value_defn] = STATE(627),
    [sym__expression] = STATE(17),
    [sym_literal_expression] = STATE(1118),
    [sym_long_identifier_or_op] = STATE(1118),
    [sym_tuple_expression] = STATE(1118),
    [sym_brace_expression] = STATE(1118),
    [sym_anon_record_expression] = STATE(1118),
    [sym_prefixed_expression] = STATE(1118),
    [sym_typecast_expression] = STATE(1118),
    [sym_for_expression] = STATE(1118),
    [sym_while_expression] = STATE(1118),
    [sym__if_branch] = STATE(7163),
    [sym_if_expression] = STATE(1118),
    [sym_fun_expression] = STATE(1118),
    [sym_try_expression] = STATE(1118),
    [sym_match_expression] = STATE(1118),
    [sym_function_expression] = STATE(1118),
    [sym_mutate_expression] = STATE(1118),
    [sym_index_expression] = STATE(1118),
    [sym_typed_expression] = STATE(1118),
    [sym_declaration_expression] = STATE(1118),
    [sym_do_expression] = STATE(1118),
    [sym_list_expression] = STATE(1118),
    [sym_array_expression] = STATE(1118),
    [sym_begin_end_expression] = STATE(1118),
    [sym_paren_expression] = STATE(1118),
    [sym__high_prec_app] = STATE(1133),
    [sym__low_prec_app] = STATE(1133),
    [sym_application_expression] = STATE(1118),
    [sym_dot_expression] = STATE(1118),
    [sym_infix_expression] = STATE(1118),
    [sym_ce_expression] = STATE(1118),
    [sym_sequential_expression] = STATE(1118),
    [sym_char] = STATE(1080),
    [sym_format_string] = STATE(1090),
    [sym__string_literal] = STATE(1090),
    [sym_string] = STATE(1080),
    [sym_verbatim_string] = STATE(1080),
    [sym_bytearray] = STATE(1080),
    [sym_verbatim_bytearray] = STATE(1080),
    [sym_format_triple_quoted_string] = STATE(1096),
    [sym_triple_quoted_string] = STATE(1080),
    [sym_const] = STATE(1118),
    [sym_long_identifier] = STATE(1156),
    [sym_active_pattern] = STATE(1085),
    [sym__identifier_or_op] = STATE(1099),
    [sym__infix_or_prefix_op] = STATE(2839),
    [sym_prefix_op] = STATE(517),
    [sym_infix_op] = STATE(487),
    [sym_sbyte] = STATE(1080),
    [sym_byte] = STATE(1080),
    [sym_int16] = STATE(1080),
    [sym_uint16] = STATE(1080),
    [sym_int32] = STATE(1080),
    [sym_uint32] = STATE(1080),
    [sym_nativeint] = STATE(1080),
    [sym_unativeint] = STATE(1080),
    [sym_int64] = STATE(1080),
    [sym_uint64] = STATE(1080),
    [sym_ieee32] = STATE(1080),
    [sym_ieee64] = STATE(1080),
    [sym_bignum] = STATE(1080),
    [sym_decimal] = STATE(1080),
    [sym_float] = STATE(979),
    [sym_block_comment] = STATE(351),
    [sym_compiler_directive_decl] = STATE(351),
    [sym_fsi_directive_decl] = STATE(351),
    [sym_preproc_line] = STATE(351),
    [sym_preproc_if_in_expression] = STATE(1118),
    [aux_sym_sequential_expression_repeat1] = STATE(1069),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(195),
    [anon_sym_EQ] = ACTIONS(31),
    [anon_sym_COLON] = ACTIONS(197),
    [anon_sym_return] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(1661),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_COMMA] = ACTIONS(205),
    [anon_sym_null] = ACTIONS(207),
    [anon_sym_QMARK] = ACTIONS(51),
    [anon_sym_COLON_QMARK] = ACTIONS(197),
    [anon_sym_COLON_COLON] = ACTIONS(31),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(209),
    [anon_sym_LBRACK_PIPE] = ACTIONS(211),
    [anon_sym_LBRACE] = ACTIONS(271),
    [anon_sym_LT_AT] = ACTIONS(213),
    [anon_sym_LT_AT_AT] = ACTIONS(215),
    [anon_sym_DOT] = ACTIONS(185),
    [anon_sym_LBRACE_PIPE] = ACTIONS(217),
    [anon_sym_new] = ACTIONS(199),
    [anon_sym_return_BANG] = ACTIONS(219),
    [anon_sym_yield] = ACTIONS(199),
    [anon_sym_yield_BANG] = ACTIONS(219),
    [anon_sym_lazy] = ACTIONS(199),
    [anon_sym_assert] = ACTIONS(199),
    [anon_sym_upcast] = ACTIONS(199),
    [anon_sym_downcast] = ACTIONS(199),
    [anon_sym_COLON_GT] = ACTIONS(221),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(221),
    [anon_sym_for] = ACTIONS(223),
    [anon_sym_while] = ACTIONS(225),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(229),
    [anon_sym_match] = ACTIONS(231),
    [anon_sym_match_BANG] = ACTIONS(233),
    [anon_sym_function] = ACTIONS(235),
    [anon_sym_LT_DASH] = ACTIONS(237),
    [anon_sym_DOT_LBRACK] = ACTIONS(187),
    [anon_sym_LT] = ACTIONS(189),
    [anon_sym_use] = ACTIONS(239),
    [anon_sym_use_BANG] = ACTIONS(241),
    [anon_sym_do_BANG] = ACTIONS(243),
    [anon_sym_begin] = ACTIONS(245),
    [anon_sym_LPAREN2] = ACTIONS(191),
    [anon_sym_or] = ACTIONS(51),
    [aux_sym_char_token1] = ACTIONS(247),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(251),
    [anon_sym_AT_DQUOTE] = ACTIONS(253),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(255),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(257),
    [sym_bool] = ACTIONS(259),
    [sym_unit] = ACTIONS(193),
    [anon_sym_LPAREN_PIPE] = ACTIONS(261),
    [sym_op_identifier] = ACTIONS(263),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(53),
    [anon_sym_DASH_DOT] = ACTIONS(53),
    [anon_sym_PERCENT] = ACTIONS(53),
    [anon_sym_AMP_AMP] = ACTIONS(53),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(127),
    [aux_sym_infix_op_token1] = ACTIONS(31),
    [aux_sym_infix_op_token2] = ACTIONS(51),
    [anon_sym_PIPE_PIPE] = ACTIONS(51),
    [anon_sym_BANG_EQ] = ACTIONS(51),
    [anon_sym_COLON_EQ] = ACTIONS(31),
    [anon_sym_DOLLAR] = ACTIONS(51),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(51),
    [sym_int] = ACTIONS(265),
    [sym_xint] = ACTIONS(267),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(269),
    [sym__newline] = ACTIONS(273),
  },
  [352] = {
    [sym_function_or_value_defn] = STATE(729),
    [sym__expression] = STATE(24),
    [sym_literal_expression] = STATE(867),
    [sym_long_identifier_or_op] = STATE(867),
    [sym_tuple_expression] = STATE(867),
    [sym_brace_expression] = STATE(867),
    [sym_anon_record_expression] = STATE(867),
    [sym_prefixed_expression] = STATE(867),
    [sym_typecast_expression] = STATE(867),
    [sym_for_expression] = STATE(867),
    [sym_while_expression] = STATE(867),
    [sym__if_branch] = STATE(6511),
    [sym_if_expression] = STATE(867),
    [sym_fun_expression] = STATE(867),
    [sym_try_expression] = STATE(867),
    [sym_match_expression] = STATE(867),
    [sym_function_expression] = STATE(867),
    [sym_mutate_expression] = STATE(867),
    [sym_index_expression] = STATE(867),
    [sym_typed_expression] = STATE(867),
    [sym_declaration_expression] = STATE(867),
    [sym_do_expression] = STATE(867),
    [sym__list_elements] = STATE(6763),
    [sym_list_expression] = STATE(867),
    [sym_array_expression] = STATE(867),
    [sym_begin_end_expression] = STATE(867),
    [sym_paren_expression] = STATE(867),
    [sym__high_prec_app] = STATE(864),
    [sym__low_prec_app] = STATE(864),
    [sym_application_expression] = STATE(867),
    [sym_dot_expression] = STATE(867),
    [sym_infix_expression] = STATE(867),
    [sym_ce_expression] = STATE(867),
    [sym_sequential_expression] = STATE(867),
    [sym__comp_or_range_expression] = STATE(6763),
    [sym_short_comp_expression] = STATE(6760),
    [sym_slice_ranges] = STATE(6763),
    [sym__slice_range_special] = STATE(6154),
    [sym_slice_range] = STATE(5915),
    [sym_char] = STATE(868),
    [sym_format_string] = STATE(869),
    [sym__string_literal] = STATE(869),
    [sym_string] = STATE(868),
    [sym_verbatim_string] = STATE(868),
    [sym_bytearray] = STATE(868),
    [sym_verbatim_bytearray] = STATE(868),
    [sym_format_triple_quoted_string] = STATE(870),
    [sym_triple_quoted_string] = STATE(868),
    [sym_const] = STATE(867),
    [sym_long_identifier] = STATE(872),
    [sym_active_pattern] = STATE(871),
    [sym__identifier_or_op] = STATE(873),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(499),
    [sym_sbyte] = STATE(868),
    [sym_byte] = STATE(868),
    [sym_int16] = STATE(868),
    [sym_uint16] = STATE(868),
    [sym_int32] = STATE(868),
    [sym_uint32] = STATE(868),
    [sym_nativeint] = STATE(868),
    [sym_unativeint] = STATE(868),
    [sym_int64] = STATE(868),
    [sym_uint64] = STATE(868),
    [sym_ieee32] = STATE(868),
    [sym_ieee64] = STATE(868),
    [sym_bignum] = STATE(868),
    [sym_decimal] = STATE(868),
    [sym_float] = STATE(1368),
    [sym_block_comment] = STATE(352),
    [sym_compiler_directive_decl] = STATE(352),
    [sym_fsi_directive_decl] = STATE(352),
    [sym_preproc_line] = STATE(352),
    [sym_preproc_if_in_expression] = STATE(867),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(29),
    [anon_sym_return] = ACTIONS(369),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_null] = ACTIONS(49),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACK_PIPE] = ACTIONS(57),
    [anon_sym_LBRACE] = ACTIONS(1663),
    [anon_sym_LT_AT] = ACTIONS(61),
    [anon_sym_LT_AT_AT] = ACTIONS(1665),
    [anon_sym_LBRACE_PIPE] = ACTIONS(67),
    [anon_sym_new] = ACTIONS(369),
    [anon_sym_return_BANG] = ACTIONS(373),
    [anon_sym_yield] = ACTIONS(369),
    [anon_sym_yield_BANG] = ACTIONS(373),
    [anon_sym_lazy] = ACTIONS(369),
    [anon_sym_assert] = ACTIONS(369),
    [anon_sym_upcast] = ACTIONS(369),
    [anon_sym_downcast] = ACTIONS(369),
    [anon_sym_for] = ACTIONS(1667),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(79),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_match] = ACTIONS(83),
    [anon_sym_match_BANG] = ACTIONS(85),
    [anon_sym_function] = ACTIONS(87),
    [anon_sym_use] = ACTIONS(379),
    [anon_sym_use_BANG] = ACTIONS(381),
    [anon_sym_do_BANG] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(101),
    [anon_sym_DOT_DOT3] = ACTIONS(1669),
    [anon_sym_STAR] = ACTIONS(1671),
    [aux_sym_char_token1] = ACTIONS(105),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(107),
    [anon_sym_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DQUOTE] = ACTIONS(111),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(115),
    [sym_bool] = ACTIONS(117),
    [sym_unit] = ACTIONS(1673),
    [anon_sym_LPAREN_PIPE] = ACTIONS(121),
    [sym_op_identifier] = ACTIONS(1675),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(385),
    [sym_xint] = ACTIONS(387),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(135),
    [sym__newline] = ACTIONS(1681),
  },
  [353] = {
    [sym_function_or_value_defn] = STATE(627),
    [sym__expression] = STATE(193),
    [sym_literal_expression] = STATE(1118),
    [sym_long_identifier_or_op] = STATE(1118),
    [sym_tuple_expression] = STATE(1118),
    [sym_brace_expression] = STATE(1118),
    [sym_anon_record_expression] = STATE(1118),
    [sym_prefixed_expression] = STATE(1118),
    [sym_typecast_expression] = STATE(1118),
    [sym_for_expression] = STATE(1118),
    [sym_while_expression] = STATE(1118),
    [sym__if_branch] = STATE(7163),
    [sym_if_expression] = STATE(1118),
    [sym_fun_expression] = STATE(1118),
    [sym_try_expression] = STATE(1118),
    [sym_match_expression] = STATE(1118),
    [sym_function_expression] = STATE(1118),
    [sym_mutate_expression] = STATE(1118),
    [sym_index_expression] = STATE(1118),
    [sym_typed_expression] = STATE(1118),
    [sym_declaration_expression] = STATE(1118),
    [sym_do_expression] = STATE(1118),
    [sym_list_expression] = STATE(1118),
    [sym_array_expression] = STATE(1118),
    [sym_begin_end_expression] = STATE(1118),
    [sym_paren_expression] = STATE(1118),
    [sym__high_prec_app] = STATE(1133),
    [sym__low_prec_app] = STATE(1133),
    [sym_application_expression] = STATE(1118),
    [sym_dot_expression] = STATE(1118),
    [sym_infix_expression] = STATE(1118),
    [sym_ce_expression] = STATE(1118),
    [sym_sequential_expression] = STATE(1118),
    [sym_type_arguments] = STATE(2786),
    [sym_char] = STATE(1080),
    [sym_format_string] = STATE(1090),
    [sym__string_literal] = STATE(1090),
    [sym_string] = STATE(1080),
    [sym_verbatim_string] = STATE(1080),
    [sym_bytearray] = STATE(1080),
    [sym_verbatim_bytearray] = STATE(1080),
    [sym_format_triple_quoted_string] = STATE(1096),
    [sym_triple_quoted_string] = STATE(1080),
    [sym_const] = STATE(1118),
    [sym_long_identifier] = STATE(1370),
    [sym_active_pattern] = STATE(1085),
    [sym__identifier_or_op] = STATE(1099),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(517),
    [sym_sbyte] = STATE(1080),
    [sym_byte] = STATE(1080),
    [sym_int16] = STATE(1080),
    [sym_uint16] = STATE(1080),
    [sym_int32] = STATE(1080),
    [sym_uint32] = STATE(1080),
    [sym_nativeint] = STATE(1080),
    [sym_unativeint] = STATE(1080),
    [sym_int64] = STATE(1080),
    [sym_uint64] = STATE(1080),
    [sym_ieee32] = STATE(1080),
    [sym_ieee64] = STATE(1080),
    [sym_bignum] = STATE(1080),
    [sym_decimal] = STATE(1080),
    [sym_float] = STATE(979),
    [sym_block_comment] = STATE(353),
    [sym_compiler_directive_decl] = STATE(353),
    [sym_fsi_directive_decl] = STATE(353),
    [sym_preproc_line] = STATE(353),
    [sym_preproc_if_in_expression] = STATE(1118),
    [aux_sym_compound_type_repeat1] = STATE(2768),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(1683),
    [anon_sym_GT_RBRACK] = ACTIONS(1685),
    [anon_sym_return] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_null] = ACTIONS(207),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(209),
    [anon_sym_LBRACK_PIPE] = ACTIONS(211),
    [anon_sym_LBRACE] = ACTIONS(1687),
    [anon_sym_LT_AT] = ACTIONS(213),
    [anon_sym_LT_AT_AT] = ACTIONS(1689),
    [anon_sym_LBRACE_PIPE] = ACTIONS(217),
    [anon_sym_new] = ACTIONS(199),
    [anon_sym_return_BANG] = ACTIONS(219),
    [anon_sym_yield] = ACTIONS(199),
    [anon_sym_yield_BANG] = ACTIONS(219),
    [anon_sym_lazy] = ACTIONS(199),
    [anon_sym_assert] = ACTIONS(199),
    [anon_sym_upcast] = ACTIONS(199),
    [anon_sym_downcast] = ACTIONS(199),
    [anon_sym_for] = ACTIONS(223),
    [anon_sym_while] = ACTIONS(225),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(227),
    [anon_sym_DASH_GT] = ACTIONS(1691),
    [anon_sym_try] = ACTIONS(229),
    [anon_sym_match] = ACTIONS(231),
    [anon_sym_match_BANG] = ACTIONS(233),
    [anon_sym_function] = ACTIONS(235),
    [anon_sym_use] = ACTIONS(239),
    [anon_sym_use_BANG] = ACTIONS(241),
    [anon_sym_do_BANG] = ACTIONS(243),
    [anon_sym_begin] = ACTIONS(245),
    [anon_sym_STAR] = ACTIONS(1693),
    [anon_sym_LT2] = ACTIONS(1695),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(1697),
    [aux_sym_char_token1] = ACTIONS(247),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(251),
    [anon_sym_AT_DQUOTE] = ACTIONS(253),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(255),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(257),
    [sym_bool] = ACTIONS(259),
    [sym_unit] = ACTIONS(1699),
    [anon_sym_LPAREN_PIPE] = ACTIONS(261),
    [sym_op_identifier] = ACTIONS(1701),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(265),
    [sym_xint] = ACTIONS(267),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(269),
    [sym__newline] = ACTIONS(1685),
  },
  [354] = {
    [sym_function_or_value_defn] = STATE(600),
    [sym__expression] = STATE(100),
    [sym_literal_expression] = STATE(867),
    [sym_long_identifier_or_op] = STATE(867),
    [sym_tuple_expression] = STATE(867),
    [sym_brace_expression] = STATE(867),
    [sym_anon_record_expression] = STATE(867),
    [sym_object_expression] = STATE(6526),
    [sym_with_field_expression] = STATE(6526),
    [sym_prefixed_expression] = STATE(867),
    [sym_typecast_expression] = STATE(867),
    [sym_for_expression] = STATE(867),
    [sym_while_expression] = STATE(867),
    [sym__if_branch] = STATE(6511),
    [sym_if_expression] = STATE(867),
    [sym_fun_expression] = STATE(867),
    [sym_try_expression] = STATE(867),
    [sym_match_expression] = STATE(867),
    [sym_function_expression] = STATE(867),
    [sym_mutate_expression] = STATE(867),
    [sym_index_expression] = STATE(867),
    [sym_typed_expression] = STATE(867),
    [sym_declaration_expression] = STATE(867),
    [sym_do_expression] = STATE(867),
    [sym_list_expression] = STATE(867),
    [sym_array_expression] = STATE(867),
    [sym_begin_end_expression] = STATE(867),
    [sym_paren_expression] = STATE(867),
    [sym__high_prec_app] = STATE(864),
    [sym__low_prec_app] = STATE(864),
    [sym_application_expression] = STATE(867),
    [sym_dot_expression] = STATE(867),
    [sym_infix_expression] = STATE(867),
    [sym_ce_expression] = STATE(867),
    [sym_sequential_expression] = STATE(867),
    [sym__comp_or_range_expression] = STATE(6541),
    [sym_short_comp_expression] = STATE(6760),
    [sym_field_initializer] = STATE(5913),
    [sym_field_initializers] = STATE(6526),
    [sym_char] = STATE(868),
    [sym_format_string] = STATE(869),
    [sym__string_literal] = STATE(869),
    [sym_string] = STATE(868),
    [sym_verbatim_string] = STATE(868),
    [sym_bytearray] = STATE(868),
    [sym_verbatim_bytearray] = STATE(868),
    [sym_format_triple_quoted_string] = STATE(870),
    [sym_triple_quoted_string] = STATE(868),
    [sym_const] = STATE(867),
    [sym_long_identifier] = STATE(1626),
    [sym_active_pattern] = STATE(871),
    [sym__identifier_or_op] = STATE(873),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(656),
    [sym_sbyte] = STATE(868),
    [sym_byte] = STATE(868),
    [sym_int16] = STATE(868),
    [sym_uint16] = STATE(868),
    [sym_int32] = STATE(868),
    [sym_uint32] = STATE(868),
    [sym_nativeint] = STATE(868),
    [sym_unativeint] = STATE(868),
    [sym_int64] = STATE(868),
    [sym_uint64] = STATE(868),
    [sym_ieee32] = STATE(868),
    [sym_ieee64] = STATE(868),
    [sym_bignum] = STATE(868),
    [sym_decimal] = STATE(868),
    [sym_float] = STATE(1368),
    [sym_block_comment] = STATE(354),
    [sym_compiler_directive_decl] = STATE(354),
    [sym_fsi_directive_decl] = STATE(354),
    [sym_preproc_line] = STATE(354),
    [sym_preproc_if_in_expression] = STATE(867),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(1703),
    [anon_sym_return] = ACTIONS(825),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_null] = ACTIONS(49),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACK_PIPE] = ACTIONS(57),
    [anon_sym_LBRACE] = ACTIONS(1663),
    [anon_sym_LT_AT] = ACTIONS(61),
    [anon_sym_LT_AT_AT] = ACTIONS(1665),
    [anon_sym_LBRACE_PIPE] = ACTIONS(67),
    [anon_sym_new] = ACTIONS(1705),
    [anon_sym_return_BANG] = ACTIONS(829),
    [anon_sym_yield] = ACTIONS(825),
    [anon_sym_yield_BANG] = ACTIONS(829),
    [anon_sym_lazy] = ACTIONS(825),
    [anon_sym_assert] = ACTIONS(825),
    [anon_sym_upcast] = ACTIONS(825),
    [anon_sym_downcast] = ACTIONS(825),
    [anon_sym_for] = ACTIONS(1707),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(79),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_match] = ACTIONS(83),
    [anon_sym_match_BANG] = ACTIONS(85),
    [anon_sym_function] = ACTIONS(87),
    [anon_sym_use] = ACTIONS(833),
    [anon_sym_use_BANG] = ACTIONS(835),
    [anon_sym_do_BANG] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(101),
    [aux_sym_char_token1] = ACTIONS(105),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(107),
    [anon_sym_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DQUOTE] = ACTIONS(111),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(115),
    [sym_bool] = ACTIONS(117),
    [sym_unit] = ACTIONS(1673),
    [anon_sym_LPAREN_PIPE] = ACTIONS(121),
    [sym_op_identifier] = ACTIONS(1675),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(837),
    [sym_xint] = ACTIONS(387),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(135),
  },
  [355] = {
    [sym_function_or_value_defn] = STATE(600),
    [sym__expression] = STATE(100),
    [sym_literal_expression] = STATE(867),
    [sym_long_identifier_or_op] = STATE(867),
    [sym_tuple_expression] = STATE(867),
    [sym_brace_expression] = STATE(867),
    [sym_anon_record_expression] = STATE(867),
    [sym_object_expression] = STATE(6806),
    [sym_with_field_expression] = STATE(6806),
    [sym_prefixed_expression] = STATE(867),
    [sym_typecast_expression] = STATE(867),
    [sym_for_expression] = STATE(867),
    [sym_while_expression] = STATE(867),
    [sym__if_branch] = STATE(6511),
    [sym_if_expression] = STATE(867),
    [sym_fun_expression] = STATE(867),
    [sym_try_expression] = STATE(867),
    [sym_match_expression] = STATE(867),
    [sym_function_expression] = STATE(867),
    [sym_mutate_expression] = STATE(867),
    [sym_index_expression] = STATE(867),
    [sym_typed_expression] = STATE(867),
    [sym_declaration_expression] = STATE(867),
    [sym_do_expression] = STATE(867),
    [sym_list_expression] = STATE(867),
    [sym_array_expression] = STATE(867),
    [sym_begin_end_expression] = STATE(867),
    [sym_paren_expression] = STATE(867),
    [sym__high_prec_app] = STATE(864),
    [sym__low_prec_app] = STATE(864),
    [sym_application_expression] = STATE(867),
    [sym_dot_expression] = STATE(867),
    [sym_infix_expression] = STATE(867),
    [sym_ce_expression] = STATE(867),
    [sym_sequential_expression] = STATE(867),
    [sym__comp_or_range_expression] = STATE(6820),
    [sym_short_comp_expression] = STATE(6760),
    [sym_field_initializer] = STATE(5913),
    [sym_field_initializers] = STATE(6806),
    [sym_char] = STATE(868),
    [sym_format_string] = STATE(869),
    [sym__string_literal] = STATE(869),
    [sym_string] = STATE(868),
    [sym_verbatim_string] = STATE(868),
    [sym_bytearray] = STATE(868),
    [sym_verbatim_bytearray] = STATE(868),
    [sym_format_triple_quoted_string] = STATE(870),
    [sym_triple_quoted_string] = STATE(868),
    [sym_const] = STATE(867),
    [sym_long_identifier] = STATE(1626),
    [sym_active_pattern] = STATE(871),
    [sym__identifier_or_op] = STATE(873),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(656),
    [sym_sbyte] = STATE(868),
    [sym_byte] = STATE(868),
    [sym_int16] = STATE(868),
    [sym_uint16] = STATE(868),
    [sym_int32] = STATE(868),
    [sym_uint32] = STATE(868),
    [sym_nativeint] = STATE(868),
    [sym_unativeint] = STATE(868),
    [sym_int64] = STATE(868),
    [sym_uint64] = STATE(868),
    [sym_ieee32] = STATE(868),
    [sym_ieee64] = STATE(868),
    [sym_bignum] = STATE(868),
    [sym_decimal] = STATE(868),
    [sym_float] = STATE(1368),
    [sym_block_comment] = STATE(355),
    [sym_compiler_directive_decl] = STATE(355),
    [sym_fsi_directive_decl] = STATE(355),
    [sym_preproc_line] = STATE(355),
    [sym_preproc_if_in_expression] = STATE(867),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(1703),
    [anon_sym_return] = ACTIONS(825),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_null] = ACTIONS(49),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACK_PIPE] = ACTIONS(57),
    [anon_sym_LBRACE] = ACTIONS(1663),
    [anon_sym_LT_AT] = ACTIONS(61),
    [anon_sym_LT_AT_AT] = ACTIONS(1665),
    [anon_sym_LBRACE_PIPE] = ACTIONS(67),
    [anon_sym_new] = ACTIONS(1705),
    [anon_sym_return_BANG] = ACTIONS(829),
    [anon_sym_yield] = ACTIONS(825),
    [anon_sym_yield_BANG] = ACTIONS(829),
    [anon_sym_lazy] = ACTIONS(825),
    [anon_sym_assert] = ACTIONS(825),
    [anon_sym_upcast] = ACTIONS(825),
    [anon_sym_downcast] = ACTIONS(825),
    [anon_sym_for] = ACTIONS(1707),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(79),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_match] = ACTIONS(83),
    [anon_sym_match_BANG] = ACTIONS(85),
    [anon_sym_function] = ACTIONS(87),
    [anon_sym_use] = ACTIONS(833),
    [anon_sym_use_BANG] = ACTIONS(835),
    [anon_sym_do_BANG] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(101),
    [aux_sym_char_token1] = ACTIONS(105),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(107),
    [anon_sym_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DQUOTE] = ACTIONS(111),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(115),
    [sym_bool] = ACTIONS(117),
    [sym_unit] = ACTIONS(1673),
    [anon_sym_LPAREN_PIPE] = ACTIONS(121),
    [sym_op_identifier] = ACTIONS(1675),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(837),
    [sym_xint] = ACTIONS(387),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(135),
  },
  [356] = {
    [sym_function_or_value_defn] = STATE(600),
    [sym__expression] = STATE(100),
    [sym_literal_expression] = STATE(867),
    [sym_long_identifier_or_op] = STATE(867),
    [sym_tuple_expression] = STATE(867),
    [sym_brace_expression] = STATE(867),
    [sym_anon_record_expression] = STATE(867),
    [sym_object_expression] = STATE(6752),
    [sym_with_field_expression] = STATE(6752),
    [sym_prefixed_expression] = STATE(867),
    [sym_typecast_expression] = STATE(867),
    [sym_for_expression] = STATE(867),
    [sym_while_expression] = STATE(867),
    [sym__if_branch] = STATE(6511),
    [sym_if_expression] = STATE(867),
    [sym_fun_expression] = STATE(867),
    [sym_try_expression] = STATE(867),
    [sym_match_expression] = STATE(867),
    [sym_function_expression] = STATE(867),
    [sym_mutate_expression] = STATE(867),
    [sym_index_expression] = STATE(867),
    [sym_typed_expression] = STATE(867),
    [sym_declaration_expression] = STATE(867),
    [sym_do_expression] = STATE(867),
    [sym_list_expression] = STATE(867),
    [sym_array_expression] = STATE(867),
    [sym_begin_end_expression] = STATE(867),
    [sym_paren_expression] = STATE(867),
    [sym__high_prec_app] = STATE(864),
    [sym__low_prec_app] = STATE(864),
    [sym_application_expression] = STATE(867),
    [sym_dot_expression] = STATE(867),
    [sym_infix_expression] = STATE(867),
    [sym_ce_expression] = STATE(867),
    [sym_sequential_expression] = STATE(867),
    [sym__comp_or_range_expression] = STATE(6401),
    [sym_short_comp_expression] = STATE(6760),
    [sym_field_initializer] = STATE(5913),
    [sym_field_initializers] = STATE(6752),
    [sym_char] = STATE(868),
    [sym_format_string] = STATE(869),
    [sym__string_literal] = STATE(869),
    [sym_string] = STATE(868),
    [sym_verbatim_string] = STATE(868),
    [sym_bytearray] = STATE(868),
    [sym_verbatim_bytearray] = STATE(868),
    [sym_format_triple_quoted_string] = STATE(870),
    [sym_triple_quoted_string] = STATE(868),
    [sym_const] = STATE(867),
    [sym_long_identifier] = STATE(1626),
    [sym_active_pattern] = STATE(871),
    [sym__identifier_or_op] = STATE(873),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(656),
    [sym_sbyte] = STATE(868),
    [sym_byte] = STATE(868),
    [sym_int16] = STATE(868),
    [sym_uint16] = STATE(868),
    [sym_int32] = STATE(868),
    [sym_uint32] = STATE(868),
    [sym_nativeint] = STATE(868),
    [sym_unativeint] = STATE(868),
    [sym_int64] = STATE(868),
    [sym_uint64] = STATE(868),
    [sym_ieee32] = STATE(868),
    [sym_ieee64] = STATE(868),
    [sym_bignum] = STATE(868),
    [sym_decimal] = STATE(868),
    [sym_float] = STATE(1368),
    [sym_block_comment] = STATE(356),
    [sym_compiler_directive_decl] = STATE(356),
    [sym_fsi_directive_decl] = STATE(356),
    [sym_preproc_line] = STATE(356),
    [sym_preproc_if_in_expression] = STATE(867),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(1703),
    [anon_sym_return] = ACTIONS(825),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_null] = ACTIONS(49),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACK_PIPE] = ACTIONS(57),
    [anon_sym_LBRACE] = ACTIONS(1663),
    [anon_sym_LT_AT] = ACTIONS(61),
    [anon_sym_LT_AT_AT] = ACTIONS(1665),
    [anon_sym_LBRACE_PIPE] = ACTIONS(67),
    [anon_sym_new] = ACTIONS(1705),
    [anon_sym_return_BANG] = ACTIONS(829),
    [anon_sym_yield] = ACTIONS(825),
    [anon_sym_yield_BANG] = ACTIONS(829),
    [anon_sym_lazy] = ACTIONS(825),
    [anon_sym_assert] = ACTIONS(825),
    [anon_sym_upcast] = ACTIONS(825),
    [anon_sym_downcast] = ACTIONS(825),
    [anon_sym_for] = ACTIONS(1707),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(79),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_match] = ACTIONS(83),
    [anon_sym_match_BANG] = ACTIONS(85),
    [anon_sym_function] = ACTIONS(87),
    [anon_sym_use] = ACTIONS(833),
    [anon_sym_use_BANG] = ACTIONS(835),
    [anon_sym_do_BANG] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(101),
    [aux_sym_char_token1] = ACTIONS(105),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(107),
    [anon_sym_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DQUOTE] = ACTIONS(111),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(115),
    [sym_bool] = ACTIONS(117),
    [sym_unit] = ACTIONS(1673),
    [anon_sym_LPAREN_PIPE] = ACTIONS(121),
    [sym_op_identifier] = ACTIONS(1675),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(837),
    [sym_xint] = ACTIONS(387),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(135),
  },
  [357] = {
    [sym_function_or_value_defn] = STATE(600),
    [sym__expression] = STATE(100),
    [sym_literal_expression] = STATE(867),
    [sym_long_identifier_or_op] = STATE(867),
    [sym_tuple_expression] = STATE(867),
    [sym_brace_expression] = STATE(867),
    [sym_anon_record_expression] = STATE(867),
    [sym_object_expression] = STATE(6846),
    [sym_with_field_expression] = STATE(6846),
    [sym_prefixed_expression] = STATE(867),
    [sym_typecast_expression] = STATE(867),
    [sym_for_expression] = STATE(867),
    [sym_while_expression] = STATE(867),
    [sym__if_branch] = STATE(6511),
    [sym_if_expression] = STATE(867),
    [sym_fun_expression] = STATE(867),
    [sym_try_expression] = STATE(867),
    [sym_match_expression] = STATE(867),
    [sym_function_expression] = STATE(867),
    [sym_mutate_expression] = STATE(867),
    [sym_index_expression] = STATE(867),
    [sym_typed_expression] = STATE(867),
    [sym_declaration_expression] = STATE(867),
    [sym_do_expression] = STATE(867),
    [sym_list_expression] = STATE(867),
    [sym_array_expression] = STATE(867),
    [sym_begin_end_expression] = STATE(867),
    [sym_paren_expression] = STATE(867),
    [sym__high_prec_app] = STATE(864),
    [sym__low_prec_app] = STATE(864),
    [sym_application_expression] = STATE(867),
    [sym_dot_expression] = STATE(867),
    [sym_infix_expression] = STATE(867),
    [sym_ce_expression] = STATE(867),
    [sym_sequential_expression] = STATE(867),
    [sym__comp_or_range_expression] = STATE(6860),
    [sym_short_comp_expression] = STATE(6760),
    [sym_field_initializer] = STATE(5913),
    [sym_field_initializers] = STATE(6846),
    [sym_char] = STATE(868),
    [sym_format_string] = STATE(869),
    [sym__string_literal] = STATE(869),
    [sym_string] = STATE(868),
    [sym_verbatim_string] = STATE(868),
    [sym_bytearray] = STATE(868),
    [sym_verbatim_bytearray] = STATE(868),
    [sym_format_triple_quoted_string] = STATE(870),
    [sym_triple_quoted_string] = STATE(868),
    [sym_const] = STATE(867),
    [sym_long_identifier] = STATE(1626),
    [sym_active_pattern] = STATE(871),
    [sym__identifier_or_op] = STATE(873),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(656),
    [sym_sbyte] = STATE(868),
    [sym_byte] = STATE(868),
    [sym_int16] = STATE(868),
    [sym_uint16] = STATE(868),
    [sym_int32] = STATE(868),
    [sym_uint32] = STATE(868),
    [sym_nativeint] = STATE(868),
    [sym_unativeint] = STATE(868),
    [sym_int64] = STATE(868),
    [sym_uint64] = STATE(868),
    [sym_ieee32] = STATE(868),
    [sym_ieee64] = STATE(868),
    [sym_bignum] = STATE(868),
    [sym_decimal] = STATE(868),
    [sym_float] = STATE(1368),
    [sym_block_comment] = STATE(357),
    [sym_compiler_directive_decl] = STATE(357),
    [sym_fsi_directive_decl] = STATE(357),
    [sym_preproc_line] = STATE(357),
    [sym_preproc_if_in_expression] = STATE(867),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(1703),
    [anon_sym_return] = ACTIONS(825),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_null] = ACTIONS(49),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACK_PIPE] = ACTIONS(57),
    [anon_sym_LBRACE] = ACTIONS(1663),
    [anon_sym_LT_AT] = ACTIONS(61),
    [anon_sym_LT_AT_AT] = ACTIONS(1665),
    [anon_sym_LBRACE_PIPE] = ACTIONS(67),
    [anon_sym_new] = ACTIONS(1705),
    [anon_sym_return_BANG] = ACTIONS(829),
    [anon_sym_yield] = ACTIONS(825),
    [anon_sym_yield_BANG] = ACTIONS(829),
    [anon_sym_lazy] = ACTIONS(825),
    [anon_sym_assert] = ACTIONS(825),
    [anon_sym_upcast] = ACTIONS(825),
    [anon_sym_downcast] = ACTIONS(825),
    [anon_sym_for] = ACTIONS(1707),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(79),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_match] = ACTIONS(83),
    [anon_sym_match_BANG] = ACTIONS(85),
    [anon_sym_function] = ACTIONS(87),
    [anon_sym_use] = ACTIONS(833),
    [anon_sym_use_BANG] = ACTIONS(835),
    [anon_sym_do_BANG] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(101),
    [aux_sym_char_token1] = ACTIONS(105),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(107),
    [anon_sym_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DQUOTE] = ACTIONS(111),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(115),
    [sym_bool] = ACTIONS(117),
    [sym_unit] = ACTIONS(1673),
    [anon_sym_LPAREN_PIPE] = ACTIONS(121),
    [sym_op_identifier] = ACTIONS(1675),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(837),
    [sym_xint] = ACTIONS(387),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(135),
  },
  [358] = {
    [sym_function_or_value_defn] = STATE(600),
    [sym__expression] = STATE(100),
    [sym_literal_expression] = STATE(867),
    [sym_long_identifier_or_op] = STATE(867),
    [sym_tuple_expression] = STATE(867),
    [sym_brace_expression] = STATE(867),
    [sym_anon_record_expression] = STATE(867),
    [sym_object_expression] = STATE(6673),
    [sym_with_field_expression] = STATE(6673),
    [sym_prefixed_expression] = STATE(867),
    [sym_typecast_expression] = STATE(867),
    [sym_for_expression] = STATE(867),
    [sym_while_expression] = STATE(867),
    [sym__if_branch] = STATE(6511),
    [sym_if_expression] = STATE(867),
    [sym_fun_expression] = STATE(867),
    [sym_try_expression] = STATE(867),
    [sym_match_expression] = STATE(867),
    [sym_function_expression] = STATE(867),
    [sym_mutate_expression] = STATE(867),
    [sym_index_expression] = STATE(867),
    [sym_typed_expression] = STATE(867),
    [sym_declaration_expression] = STATE(867),
    [sym_do_expression] = STATE(867),
    [sym_list_expression] = STATE(867),
    [sym_array_expression] = STATE(867),
    [sym_begin_end_expression] = STATE(867),
    [sym_paren_expression] = STATE(867),
    [sym__high_prec_app] = STATE(864),
    [sym__low_prec_app] = STATE(864),
    [sym_application_expression] = STATE(867),
    [sym_dot_expression] = STATE(867),
    [sym_infix_expression] = STATE(867),
    [sym_ce_expression] = STATE(867),
    [sym_sequential_expression] = STATE(867),
    [sym__comp_or_range_expression] = STATE(6687),
    [sym_short_comp_expression] = STATE(6760),
    [sym_field_initializer] = STATE(5913),
    [sym_field_initializers] = STATE(6673),
    [sym_char] = STATE(868),
    [sym_format_string] = STATE(869),
    [sym__string_literal] = STATE(869),
    [sym_string] = STATE(868),
    [sym_verbatim_string] = STATE(868),
    [sym_bytearray] = STATE(868),
    [sym_verbatim_bytearray] = STATE(868),
    [sym_format_triple_quoted_string] = STATE(870),
    [sym_triple_quoted_string] = STATE(868),
    [sym_const] = STATE(867),
    [sym_long_identifier] = STATE(1626),
    [sym_active_pattern] = STATE(871),
    [sym__identifier_or_op] = STATE(873),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(656),
    [sym_sbyte] = STATE(868),
    [sym_byte] = STATE(868),
    [sym_int16] = STATE(868),
    [sym_uint16] = STATE(868),
    [sym_int32] = STATE(868),
    [sym_uint32] = STATE(868),
    [sym_nativeint] = STATE(868),
    [sym_unativeint] = STATE(868),
    [sym_int64] = STATE(868),
    [sym_uint64] = STATE(868),
    [sym_ieee32] = STATE(868),
    [sym_ieee64] = STATE(868),
    [sym_bignum] = STATE(868),
    [sym_decimal] = STATE(868),
    [sym_float] = STATE(1368),
    [sym_block_comment] = STATE(358),
    [sym_compiler_directive_decl] = STATE(358),
    [sym_fsi_directive_decl] = STATE(358),
    [sym_preproc_line] = STATE(358),
    [sym_preproc_if_in_expression] = STATE(867),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(1703),
    [anon_sym_return] = ACTIONS(825),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_null] = ACTIONS(49),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACK_PIPE] = ACTIONS(57),
    [anon_sym_LBRACE] = ACTIONS(1663),
    [anon_sym_LT_AT] = ACTIONS(61),
    [anon_sym_LT_AT_AT] = ACTIONS(1665),
    [anon_sym_LBRACE_PIPE] = ACTIONS(67),
    [anon_sym_new] = ACTIONS(1705),
    [anon_sym_return_BANG] = ACTIONS(829),
    [anon_sym_yield] = ACTIONS(825),
    [anon_sym_yield_BANG] = ACTIONS(829),
    [anon_sym_lazy] = ACTIONS(825),
    [anon_sym_assert] = ACTIONS(825),
    [anon_sym_upcast] = ACTIONS(825),
    [anon_sym_downcast] = ACTIONS(825),
    [anon_sym_for] = ACTIONS(1707),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(79),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_match] = ACTIONS(83),
    [anon_sym_match_BANG] = ACTIONS(85),
    [anon_sym_function] = ACTIONS(87),
    [anon_sym_use] = ACTIONS(833),
    [anon_sym_use_BANG] = ACTIONS(835),
    [anon_sym_do_BANG] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(101),
    [aux_sym_char_token1] = ACTIONS(105),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(107),
    [anon_sym_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DQUOTE] = ACTIONS(111),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(115),
    [sym_bool] = ACTIONS(117),
    [sym_unit] = ACTIONS(1673),
    [anon_sym_LPAREN_PIPE] = ACTIONS(121),
    [sym_op_identifier] = ACTIONS(1675),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(837),
    [sym_xint] = ACTIONS(387),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(135),
  },
  [359] = {
    [sym_function_or_value_defn] = STATE(600),
    [sym__expression] = STATE(100),
    [sym_literal_expression] = STATE(867),
    [sym_long_identifier_or_op] = STATE(867),
    [sym_tuple_expression] = STATE(867),
    [sym_brace_expression] = STATE(867),
    [sym_anon_record_expression] = STATE(867),
    [sym_object_expression] = STATE(6471),
    [sym_with_field_expression] = STATE(6471),
    [sym_prefixed_expression] = STATE(867),
    [sym_typecast_expression] = STATE(867),
    [sym_for_expression] = STATE(867),
    [sym_while_expression] = STATE(867),
    [sym__if_branch] = STATE(6511),
    [sym_if_expression] = STATE(867),
    [sym_fun_expression] = STATE(867),
    [sym_try_expression] = STATE(867),
    [sym_match_expression] = STATE(867),
    [sym_function_expression] = STATE(867),
    [sym_mutate_expression] = STATE(867),
    [sym_index_expression] = STATE(867),
    [sym_typed_expression] = STATE(867),
    [sym_declaration_expression] = STATE(867),
    [sym_do_expression] = STATE(867),
    [sym_list_expression] = STATE(867),
    [sym_array_expression] = STATE(867),
    [sym_begin_end_expression] = STATE(867),
    [sym_paren_expression] = STATE(867),
    [sym__high_prec_app] = STATE(864),
    [sym__low_prec_app] = STATE(864),
    [sym_application_expression] = STATE(867),
    [sym_dot_expression] = STATE(867),
    [sym_infix_expression] = STATE(867),
    [sym_ce_expression] = STATE(867),
    [sym_sequential_expression] = STATE(867),
    [sym__comp_or_range_expression] = STATE(6486),
    [sym_short_comp_expression] = STATE(6760),
    [sym_field_initializer] = STATE(5913),
    [sym_field_initializers] = STATE(6471),
    [sym_char] = STATE(868),
    [sym_format_string] = STATE(869),
    [sym__string_literal] = STATE(869),
    [sym_string] = STATE(868),
    [sym_verbatim_string] = STATE(868),
    [sym_bytearray] = STATE(868),
    [sym_verbatim_bytearray] = STATE(868),
    [sym_format_triple_quoted_string] = STATE(870),
    [sym_triple_quoted_string] = STATE(868),
    [sym_const] = STATE(867),
    [sym_long_identifier] = STATE(1626),
    [sym_active_pattern] = STATE(871),
    [sym__identifier_or_op] = STATE(873),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(656),
    [sym_sbyte] = STATE(868),
    [sym_byte] = STATE(868),
    [sym_int16] = STATE(868),
    [sym_uint16] = STATE(868),
    [sym_int32] = STATE(868),
    [sym_uint32] = STATE(868),
    [sym_nativeint] = STATE(868),
    [sym_unativeint] = STATE(868),
    [sym_int64] = STATE(868),
    [sym_uint64] = STATE(868),
    [sym_ieee32] = STATE(868),
    [sym_ieee64] = STATE(868),
    [sym_bignum] = STATE(868),
    [sym_decimal] = STATE(868),
    [sym_float] = STATE(1368),
    [sym_block_comment] = STATE(359),
    [sym_compiler_directive_decl] = STATE(359),
    [sym_fsi_directive_decl] = STATE(359),
    [sym_preproc_line] = STATE(359),
    [sym_preproc_if_in_expression] = STATE(867),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(1703),
    [anon_sym_return] = ACTIONS(825),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_null] = ACTIONS(49),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACK_PIPE] = ACTIONS(57),
    [anon_sym_LBRACE] = ACTIONS(1663),
    [anon_sym_LT_AT] = ACTIONS(61),
    [anon_sym_LT_AT_AT] = ACTIONS(1665),
    [anon_sym_LBRACE_PIPE] = ACTIONS(67),
    [anon_sym_new] = ACTIONS(1705),
    [anon_sym_return_BANG] = ACTIONS(829),
    [anon_sym_yield] = ACTIONS(825),
    [anon_sym_yield_BANG] = ACTIONS(829),
    [anon_sym_lazy] = ACTIONS(825),
    [anon_sym_assert] = ACTIONS(825),
    [anon_sym_upcast] = ACTIONS(825),
    [anon_sym_downcast] = ACTIONS(825),
    [anon_sym_for] = ACTIONS(1707),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(79),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_match] = ACTIONS(83),
    [anon_sym_match_BANG] = ACTIONS(85),
    [anon_sym_function] = ACTIONS(87),
    [anon_sym_use] = ACTIONS(833),
    [anon_sym_use_BANG] = ACTIONS(835),
    [anon_sym_do_BANG] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(101),
    [aux_sym_char_token1] = ACTIONS(105),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(107),
    [anon_sym_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DQUOTE] = ACTIONS(111),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(115),
    [sym_bool] = ACTIONS(117),
    [sym_unit] = ACTIONS(1673),
    [anon_sym_LPAREN_PIPE] = ACTIONS(121),
    [sym_op_identifier] = ACTIONS(1675),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(837),
    [sym_xint] = ACTIONS(387),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(135),
  },
  [360] = {
    [sym_function_or_value_defn] = STATE(600),
    [sym__expression] = STATE(100),
    [sym_literal_expression] = STATE(867),
    [sym_long_identifier_or_op] = STATE(867),
    [sym_tuple_expression] = STATE(867),
    [sym_brace_expression] = STATE(867),
    [sym_anon_record_expression] = STATE(867),
    [sym_object_expression] = STATE(6721),
    [sym_with_field_expression] = STATE(6721),
    [sym_prefixed_expression] = STATE(867),
    [sym_typecast_expression] = STATE(867),
    [sym_for_expression] = STATE(867),
    [sym_while_expression] = STATE(867),
    [sym__if_branch] = STATE(6511),
    [sym_if_expression] = STATE(867),
    [sym_fun_expression] = STATE(867),
    [sym_try_expression] = STATE(867),
    [sym_match_expression] = STATE(867),
    [sym_function_expression] = STATE(867),
    [sym_mutate_expression] = STATE(867),
    [sym_index_expression] = STATE(867),
    [sym_typed_expression] = STATE(867),
    [sym_declaration_expression] = STATE(867),
    [sym_do_expression] = STATE(867),
    [sym_list_expression] = STATE(867),
    [sym_array_expression] = STATE(867),
    [sym_begin_end_expression] = STATE(867),
    [sym_paren_expression] = STATE(867),
    [sym__high_prec_app] = STATE(864),
    [sym__low_prec_app] = STATE(864),
    [sym_application_expression] = STATE(867),
    [sym_dot_expression] = STATE(867),
    [sym_infix_expression] = STATE(867),
    [sym_ce_expression] = STATE(867),
    [sym_sequential_expression] = STATE(867),
    [sym__comp_or_range_expression] = STATE(6735),
    [sym_short_comp_expression] = STATE(6760),
    [sym_field_initializer] = STATE(5913),
    [sym_field_initializers] = STATE(6721),
    [sym_char] = STATE(868),
    [sym_format_string] = STATE(869),
    [sym__string_literal] = STATE(869),
    [sym_string] = STATE(868),
    [sym_verbatim_string] = STATE(868),
    [sym_bytearray] = STATE(868),
    [sym_verbatim_bytearray] = STATE(868),
    [sym_format_triple_quoted_string] = STATE(870),
    [sym_triple_quoted_string] = STATE(868),
    [sym_const] = STATE(867),
    [sym_long_identifier] = STATE(1626),
    [sym_active_pattern] = STATE(871),
    [sym__identifier_or_op] = STATE(873),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(656),
    [sym_sbyte] = STATE(868),
    [sym_byte] = STATE(868),
    [sym_int16] = STATE(868),
    [sym_uint16] = STATE(868),
    [sym_int32] = STATE(868),
    [sym_uint32] = STATE(868),
    [sym_nativeint] = STATE(868),
    [sym_unativeint] = STATE(868),
    [sym_int64] = STATE(868),
    [sym_uint64] = STATE(868),
    [sym_ieee32] = STATE(868),
    [sym_ieee64] = STATE(868),
    [sym_bignum] = STATE(868),
    [sym_decimal] = STATE(868),
    [sym_float] = STATE(1368),
    [sym_block_comment] = STATE(360),
    [sym_compiler_directive_decl] = STATE(360),
    [sym_fsi_directive_decl] = STATE(360),
    [sym_preproc_line] = STATE(360),
    [sym_preproc_if_in_expression] = STATE(867),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(1703),
    [anon_sym_return] = ACTIONS(825),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_null] = ACTIONS(49),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACK_PIPE] = ACTIONS(57),
    [anon_sym_LBRACE] = ACTIONS(1663),
    [anon_sym_LT_AT] = ACTIONS(61),
    [anon_sym_LT_AT_AT] = ACTIONS(1665),
    [anon_sym_LBRACE_PIPE] = ACTIONS(67),
    [anon_sym_new] = ACTIONS(1705),
    [anon_sym_return_BANG] = ACTIONS(829),
    [anon_sym_yield] = ACTIONS(825),
    [anon_sym_yield_BANG] = ACTIONS(829),
    [anon_sym_lazy] = ACTIONS(825),
    [anon_sym_assert] = ACTIONS(825),
    [anon_sym_upcast] = ACTIONS(825),
    [anon_sym_downcast] = ACTIONS(825),
    [anon_sym_for] = ACTIONS(1707),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(79),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_match] = ACTIONS(83),
    [anon_sym_match_BANG] = ACTIONS(85),
    [anon_sym_function] = ACTIONS(87),
    [anon_sym_use] = ACTIONS(833),
    [anon_sym_use_BANG] = ACTIONS(835),
    [anon_sym_do_BANG] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(101),
    [aux_sym_char_token1] = ACTIONS(105),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(107),
    [anon_sym_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DQUOTE] = ACTIONS(111),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(115),
    [sym_bool] = ACTIONS(117),
    [sym_unit] = ACTIONS(1673),
    [anon_sym_LPAREN_PIPE] = ACTIONS(121),
    [sym_op_identifier] = ACTIONS(1675),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(837),
    [sym_xint] = ACTIONS(387),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(135),
  },
  [361] = {
    [sym_function_or_value_defn] = STATE(600),
    [sym__expression] = STATE(100),
    [sym_literal_expression] = STATE(867),
    [sym_long_identifier_or_op] = STATE(867),
    [sym_tuple_expression] = STATE(867),
    [sym_brace_expression] = STATE(867),
    [sym_anon_record_expression] = STATE(867),
    [sym_object_expression] = STATE(6886),
    [sym_with_field_expression] = STATE(6886),
    [sym_prefixed_expression] = STATE(867),
    [sym_typecast_expression] = STATE(867),
    [sym_for_expression] = STATE(867),
    [sym_while_expression] = STATE(867),
    [sym__if_branch] = STATE(6511),
    [sym_if_expression] = STATE(867),
    [sym_fun_expression] = STATE(867),
    [sym_try_expression] = STATE(867),
    [sym_match_expression] = STATE(867),
    [sym_function_expression] = STATE(867),
    [sym_mutate_expression] = STATE(867),
    [sym_index_expression] = STATE(867),
    [sym_typed_expression] = STATE(867),
    [sym_declaration_expression] = STATE(867),
    [sym_do_expression] = STATE(867),
    [sym_list_expression] = STATE(867),
    [sym_array_expression] = STATE(867),
    [sym_begin_end_expression] = STATE(867),
    [sym_paren_expression] = STATE(867),
    [sym__high_prec_app] = STATE(864),
    [sym__low_prec_app] = STATE(864),
    [sym_application_expression] = STATE(867),
    [sym_dot_expression] = STATE(867),
    [sym_infix_expression] = STATE(867),
    [sym_ce_expression] = STATE(867),
    [sym_sequential_expression] = STATE(867),
    [sym__comp_or_range_expression] = STATE(6900),
    [sym_short_comp_expression] = STATE(6760),
    [sym_field_initializer] = STATE(5913),
    [sym_field_initializers] = STATE(6886),
    [sym_char] = STATE(868),
    [sym_format_string] = STATE(869),
    [sym__string_literal] = STATE(869),
    [sym_string] = STATE(868),
    [sym_verbatim_string] = STATE(868),
    [sym_bytearray] = STATE(868),
    [sym_verbatim_bytearray] = STATE(868),
    [sym_format_triple_quoted_string] = STATE(870),
    [sym_triple_quoted_string] = STATE(868),
    [sym_const] = STATE(867),
    [sym_long_identifier] = STATE(1626),
    [sym_active_pattern] = STATE(871),
    [sym__identifier_or_op] = STATE(873),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(656),
    [sym_sbyte] = STATE(868),
    [sym_byte] = STATE(868),
    [sym_int16] = STATE(868),
    [sym_uint16] = STATE(868),
    [sym_int32] = STATE(868),
    [sym_uint32] = STATE(868),
    [sym_nativeint] = STATE(868),
    [sym_unativeint] = STATE(868),
    [sym_int64] = STATE(868),
    [sym_uint64] = STATE(868),
    [sym_ieee32] = STATE(868),
    [sym_ieee64] = STATE(868),
    [sym_bignum] = STATE(868),
    [sym_decimal] = STATE(868),
    [sym_float] = STATE(1368),
    [sym_block_comment] = STATE(361),
    [sym_compiler_directive_decl] = STATE(361),
    [sym_fsi_directive_decl] = STATE(361),
    [sym_preproc_line] = STATE(361),
    [sym_preproc_if_in_expression] = STATE(867),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(1703),
    [anon_sym_return] = ACTIONS(825),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_null] = ACTIONS(49),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACK_PIPE] = ACTIONS(57),
    [anon_sym_LBRACE] = ACTIONS(1663),
    [anon_sym_LT_AT] = ACTIONS(61),
    [anon_sym_LT_AT_AT] = ACTIONS(1665),
    [anon_sym_LBRACE_PIPE] = ACTIONS(67),
    [anon_sym_new] = ACTIONS(1705),
    [anon_sym_return_BANG] = ACTIONS(829),
    [anon_sym_yield] = ACTIONS(825),
    [anon_sym_yield_BANG] = ACTIONS(829),
    [anon_sym_lazy] = ACTIONS(825),
    [anon_sym_assert] = ACTIONS(825),
    [anon_sym_upcast] = ACTIONS(825),
    [anon_sym_downcast] = ACTIONS(825),
    [anon_sym_for] = ACTIONS(1707),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(79),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_match] = ACTIONS(83),
    [anon_sym_match_BANG] = ACTIONS(85),
    [anon_sym_function] = ACTIONS(87),
    [anon_sym_use] = ACTIONS(833),
    [anon_sym_use_BANG] = ACTIONS(835),
    [anon_sym_do_BANG] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(101),
    [aux_sym_char_token1] = ACTIONS(105),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(107),
    [anon_sym_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DQUOTE] = ACTIONS(111),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(115),
    [sym_bool] = ACTIONS(117),
    [sym_unit] = ACTIONS(1673),
    [anon_sym_LPAREN_PIPE] = ACTIONS(121),
    [sym_op_identifier] = ACTIONS(1675),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(837),
    [sym_xint] = ACTIONS(387),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(135),
  },
  [362] = {
    [sym_function_or_value_defn] = STATE(600),
    [sym__expression] = STATE(100),
    [sym_literal_expression] = STATE(867),
    [sym_long_identifier_or_op] = STATE(867),
    [sym_tuple_expression] = STATE(867),
    [sym_brace_expression] = STATE(867),
    [sym_anon_record_expression] = STATE(867),
    [sym_object_expression] = STATE(6625),
    [sym_with_field_expression] = STATE(6625),
    [sym_prefixed_expression] = STATE(867),
    [sym_typecast_expression] = STATE(867),
    [sym_for_expression] = STATE(867),
    [sym_while_expression] = STATE(867),
    [sym__if_branch] = STATE(6511),
    [sym_if_expression] = STATE(867),
    [sym_fun_expression] = STATE(867),
    [sym_try_expression] = STATE(867),
    [sym_match_expression] = STATE(867),
    [sym_function_expression] = STATE(867),
    [sym_mutate_expression] = STATE(867),
    [sym_index_expression] = STATE(867),
    [sym_typed_expression] = STATE(867),
    [sym_declaration_expression] = STATE(867),
    [sym_do_expression] = STATE(867),
    [sym_list_expression] = STATE(867),
    [sym_array_expression] = STATE(867),
    [sym_begin_end_expression] = STATE(867),
    [sym_paren_expression] = STATE(867),
    [sym__high_prec_app] = STATE(864),
    [sym__low_prec_app] = STATE(864),
    [sym_application_expression] = STATE(867),
    [sym_dot_expression] = STATE(867),
    [sym_infix_expression] = STATE(867),
    [sym_ce_expression] = STATE(867),
    [sym_sequential_expression] = STATE(867),
    [sym__comp_or_range_expression] = STATE(6639),
    [sym_short_comp_expression] = STATE(6760),
    [sym_field_initializer] = STATE(5913),
    [sym_field_initializers] = STATE(6625),
    [sym_char] = STATE(868),
    [sym_format_string] = STATE(869),
    [sym__string_literal] = STATE(869),
    [sym_string] = STATE(868),
    [sym_verbatim_string] = STATE(868),
    [sym_bytearray] = STATE(868),
    [sym_verbatim_bytearray] = STATE(868),
    [sym_format_triple_quoted_string] = STATE(870),
    [sym_triple_quoted_string] = STATE(868),
    [sym_const] = STATE(867),
    [sym_long_identifier] = STATE(1626),
    [sym_active_pattern] = STATE(871),
    [sym__identifier_or_op] = STATE(873),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(656),
    [sym_sbyte] = STATE(868),
    [sym_byte] = STATE(868),
    [sym_int16] = STATE(868),
    [sym_uint16] = STATE(868),
    [sym_int32] = STATE(868),
    [sym_uint32] = STATE(868),
    [sym_nativeint] = STATE(868),
    [sym_unativeint] = STATE(868),
    [sym_int64] = STATE(868),
    [sym_uint64] = STATE(868),
    [sym_ieee32] = STATE(868),
    [sym_ieee64] = STATE(868),
    [sym_bignum] = STATE(868),
    [sym_decimal] = STATE(868),
    [sym_float] = STATE(1368),
    [sym_block_comment] = STATE(362),
    [sym_compiler_directive_decl] = STATE(362),
    [sym_fsi_directive_decl] = STATE(362),
    [sym_preproc_line] = STATE(362),
    [sym_preproc_if_in_expression] = STATE(867),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(1703),
    [anon_sym_return] = ACTIONS(825),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_null] = ACTIONS(49),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACK_PIPE] = ACTIONS(57),
    [anon_sym_LBRACE] = ACTIONS(1663),
    [anon_sym_LT_AT] = ACTIONS(61),
    [anon_sym_LT_AT_AT] = ACTIONS(1665),
    [anon_sym_LBRACE_PIPE] = ACTIONS(67),
    [anon_sym_new] = ACTIONS(1705),
    [anon_sym_return_BANG] = ACTIONS(829),
    [anon_sym_yield] = ACTIONS(825),
    [anon_sym_yield_BANG] = ACTIONS(829),
    [anon_sym_lazy] = ACTIONS(825),
    [anon_sym_assert] = ACTIONS(825),
    [anon_sym_upcast] = ACTIONS(825),
    [anon_sym_downcast] = ACTIONS(825),
    [anon_sym_for] = ACTIONS(1707),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(79),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_match] = ACTIONS(83),
    [anon_sym_match_BANG] = ACTIONS(85),
    [anon_sym_function] = ACTIONS(87),
    [anon_sym_use] = ACTIONS(833),
    [anon_sym_use_BANG] = ACTIONS(835),
    [anon_sym_do_BANG] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(101),
    [aux_sym_char_token1] = ACTIONS(105),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(107),
    [anon_sym_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DQUOTE] = ACTIONS(111),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(115),
    [sym_bool] = ACTIONS(117),
    [sym_unit] = ACTIONS(1673),
    [anon_sym_LPAREN_PIPE] = ACTIONS(121),
    [sym_op_identifier] = ACTIONS(1675),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(837),
    [sym_xint] = ACTIONS(387),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(135),
  },
  [363] = {
    [sym_function_or_value_defn] = STATE(600),
    [sym__expression] = STATE(100),
    [sym_literal_expression] = STATE(867),
    [sym_long_identifier_or_op] = STATE(867),
    [sym_tuple_expression] = STATE(867),
    [sym_brace_expression] = STATE(867),
    [sym_anon_record_expression] = STATE(867),
    [sym_object_expression] = STATE(6766),
    [sym_with_field_expression] = STATE(6766),
    [sym_prefixed_expression] = STATE(867),
    [sym_typecast_expression] = STATE(867),
    [sym_for_expression] = STATE(867),
    [sym_while_expression] = STATE(867),
    [sym__if_branch] = STATE(6511),
    [sym_if_expression] = STATE(867),
    [sym_fun_expression] = STATE(867),
    [sym_try_expression] = STATE(867),
    [sym_match_expression] = STATE(867),
    [sym_function_expression] = STATE(867),
    [sym_mutate_expression] = STATE(867),
    [sym_index_expression] = STATE(867),
    [sym_typed_expression] = STATE(867),
    [sym_declaration_expression] = STATE(867),
    [sym_do_expression] = STATE(867),
    [sym_list_expression] = STATE(867),
    [sym_array_expression] = STATE(867),
    [sym_begin_end_expression] = STATE(867),
    [sym_paren_expression] = STATE(867),
    [sym__high_prec_app] = STATE(864),
    [sym__low_prec_app] = STATE(864),
    [sym_application_expression] = STATE(867),
    [sym_dot_expression] = STATE(867),
    [sym_infix_expression] = STATE(867),
    [sym_ce_expression] = STATE(867),
    [sym_sequential_expression] = STATE(867),
    [sym__comp_or_range_expression] = STATE(6780),
    [sym_short_comp_expression] = STATE(6760),
    [sym_field_initializer] = STATE(5913),
    [sym_field_initializers] = STATE(6766),
    [sym_char] = STATE(868),
    [sym_format_string] = STATE(869),
    [sym__string_literal] = STATE(869),
    [sym_string] = STATE(868),
    [sym_verbatim_string] = STATE(868),
    [sym_bytearray] = STATE(868),
    [sym_verbatim_bytearray] = STATE(868),
    [sym_format_triple_quoted_string] = STATE(870),
    [sym_triple_quoted_string] = STATE(868),
    [sym_const] = STATE(867),
    [sym_long_identifier] = STATE(1626),
    [sym_active_pattern] = STATE(871),
    [sym__identifier_or_op] = STATE(873),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(656),
    [sym_sbyte] = STATE(868),
    [sym_byte] = STATE(868),
    [sym_int16] = STATE(868),
    [sym_uint16] = STATE(868),
    [sym_int32] = STATE(868),
    [sym_uint32] = STATE(868),
    [sym_nativeint] = STATE(868),
    [sym_unativeint] = STATE(868),
    [sym_int64] = STATE(868),
    [sym_uint64] = STATE(868),
    [sym_ieee32] = STATE(868),
    [sym_ieee64] = STATE(868),
    [sym_bignum] = STATE(868),
    [sym_decimal] = STATE(868),
    [sym_float] = STATE(1368),
    [sym_block_comment] = STATE(363),
    [sym_compiler_directive_decl] = STATE(363),
    [sym_fsi_directive_decl] = STATE(363),
    [sym_preproc_line] = STATE(363),
    [sym_preproc_if_in_expression] = STATE(867),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(1703),
    [anon_sym_return] = ACTIONS(825),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_null] = ACTIONS(49),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACK_PIPE] = ACTIONS(57),
    [anon_sym_LBRACE] = ACTIONS(1663),
    [anon_sym_LT_AT] = ACTIONS(61),
    [anon_sym_LT_AT_AT] = ACTIONS(1665),
    [anon_sym_LBRACE_PIPE] = ACTIONS(67),
    [anon_sym_new] = ACTIONS(1705),
    [anon_sym_return_BANG] = ACTIONS(829),
    [anon_sym_yield] = ACTIONS(825),
    [anon_sym_yield_BANG] = ACTIONS(829),
    [anon_sym_lazy] = ACTIONS(825),
    [anon_sym_assert] = ACTIONS(825),
    [anon_sym_upcast] = ACTIONS(825),
    [anon_sym_downcast] = ACTIONS(825),
    [anon_sym_for] = ACTIONS(1707),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(79),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_match] = ACTIONS(83),
    [anon_sym_match_BANG] = ACTIONS(85),
    [anon_sym_function] = ACTIONS(87),
    [anon_sym_use] = ACTIONS(833),
    [anon_sym_use_BANG] = ACTIONS(835),
    [anon_sym_do_BANG] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(101),
    [aux_sym_char_token1] = ACTIONS(105),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(107),
    [anon_sym_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DQUOTE] = ACTIONS(111),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(115),
    [sym_bool] = ACTIONS(117),
    [sym_unit] = ACTIONS(1673),
    [anon_sym_LPAREN_PIPE] = ACTIONS(121),
    [sym_op_identifier] = ACTIONS(1675),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(837),
    [sym_xint] = ACTIONS(387),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(135),
  },
  [364] = {
    [sym_function_or_value_defn] = STATE(600),
    [sym__expression] = STATE(100),
    [sym_literal_expression] = STATE(867),
    [sym_long_identifier_or_op] = STATE(867),
    [sym_tuple_expression] = STATE(867),
    [sym_brace_expression] = STATE(867),
    [sym_anon_record_expression] = STATE(867),
    [sym_object_expression] = STATE(6576),
    [sym_with_field_expression] = STATE(6576),
    [sym_prefixed_expression] = STATE(867),
    [sym_typecast_expression] = STATE(867),
    [sym_for_expression] = STATE(867),
    [sym_while_expression] = STATE(867),
    [sym__if_branch] = STATE(6511),
    [sym_if_expression] = STATE(867),
    [sym_fun_expression] = STATE(867),
    [sym_try_expression] = STATE(867),
    [sym_match_expression] = STATE(867),
    [sym_function_expression] = STATE(867),
    [sym_mutate_expression] = STATE(867),
    [sym_index_expression] = STATE(867),
    [sym_typed_expression] = STATE(867),
    [sym_declaration_expression] = STATE(867),
    [sym_do_expression] = STATE(867),
    [sym_list_expression] = STATE(867),
    [sym_array_expression] = STATE(867),
    [sym_begin_end_expression] = STATE(867),
    [sym_paren_expression] = STATE(867),
    [sym__high_prec_app] = STATE(864),
    [sym__low_prec_app] = STATE(864),
    [sym_application_expression] = STATE(867),
    [sym_dot_expression] = STATE(867),
    [sym_infix_expression] = STATE(867),
    [sym_ce_expression] = STATE(867),
    [sym_sequential_expression] = STATE(867),
    [sym__comp_or_range_expression] = STATE(6591),
    [sym_short_comp_expression] = STATE(6760),
    [sym_field_initializer] = STATE(5913),
    [sym_field_initializers] = STATE(6576),
    [sym_char] = STATE(868),
    [sym_format_string] = STATE(869),
    [sym__string_literal] = STATE(869),
    [sym_string] = STATE(868),
    [sym_verbatim_string] = STATE(868),
    [sym_bytearray] = STATE(868),
    [sym_verbatim_bytearray] = STATE(868),
    [sym_format_triple_quoted_string] = STATE(870),
    [sym_triple_quoted_string] = STATE(868),
    [sym_const] = STATE(867),
    [sym_long_identifier] = STATE(1626),
    [sym_active_pattern] = STATE(871),
    [sym__identifier_or_op] = STATE(873),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(656),
    [sym_sbyte] = STATE(868),
    [sym_byte] = STATE(868),
    [sym_int16] = STATE(868),
    [sym_uint16] = STATE(868),
    [sym_int32] = STATE(868),
    [sym_uint32] = STATE(868),
    [sym_nativeint] = STATE(868),
    [sym_unativeint] = STATE(868),
    [sym_int64] = STATE(868),
    [sym_uint64] = STATE(868),
    [sym_ieee32] = STATE(868),
    [sym_ieee64] = STATE(868),
    [sym_bignum] = STATE(868),
    [sym_decimal] = STATE(868),
    [sym_float] = STATE(1368),
    [sym_block_comment] = STATE(364),
    [sym_compiler_directive_decl] = STATE(364),
    [sym_fsi_directive_decl] = STATE(364),
    [sym_preproc_line] = STATE(364),
    [sym_preproc_if_in_expression] = STATE(867),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(1703),
    [anon_sym_return] = ACTIONS(825),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_null] = ACTIONS(49),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACK_PIPE] = ACTIONS(57),
    [anon_sym_LBRACE] = ACTIONS(1663),
    [anon_sym_LT_AT] = ACTIONS(61),
    [anon_sym_LT_AT_AT] = ACTIONS(1665),
    [anon_sym_LBRACE_PIPE] = ACTIONS(67),
    [anon_sym_new] = ACTIONS(1705),
    [anon_sym_return_BANG] = ACTIONS(829),
    [anon_sym_yield] = ACTIONS(825),
    [anon_sym_yield_BANG] = ACTIONS(829),
    [anon_sym_lazy] = ACTIONS(825),
    [anon_sym_assert] = ACTIONS(825),
    [anon_sym_upcast] = ACTIONS(825),
    [anon_sym_downcast] = ACTIONS(825),
    [anon_sym_for] = ACTIONS(1707),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(79),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_match] = ACTIONS(83),
    [anon_sym_match_BANG] = ACTIONS(85),
    [anon_sym_function] = ACTIONS(87),
    [anon_sym_use] = ACTIONS(833),
    [anon_sym_use_BANG] = ACTIONS(835),
    [anon_sym_do_BANG] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(101),
    [aux_sym_char_token1] = ACTIONS(105),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(107),
    [anon_sym_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DQUOTE] = ACTIONS(111),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(115),
    [sym_bool] = ACTIONS(117),
    [sym_unit] = ACTIONS(1673),
    [anon_sym_LPAREN_PIPE] = ACTIONS(121),
    [sym_op_identifier] = ACTIONS(1675),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(837),
    [sym_xint] = ACTIONS(387),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(135),
  },
  [365] = {
    [sym_function_or_value_defn] = STATE(600),
    [sym__expression] = STATE(100),
    [sym_literal_expression] = STATE(867),
    [sym_long_identifier_or_op] = STATE(867),
    [sym_tuple_expression] = STATE(867),
    [sym_brace_expression] = STATE(867),
    [sym_anon_record_expression] = STATE(867),
    [sym_object_expression] = STATE(6410),
    [sym_with_field_expression] = STATE(6410),
    [sym_prefixed_expression] = STATE(867),
    [sym_typecast_expression] = STATE(867),
    [sym_for_expression] = STATE(867),
    [sym_while_expression] = STATE(867),
    [sym__if_branch] = STATE(6511),
    [sym_if_expression] = STATE(867),
    [sym_fun_expression] = STATE(867),
    [sym_try_expression] = STATE(867),
    [sym_match_expression] = STATE(867),
    [sym_function_expression] = STATE(867),
    [sym_mutate_expression] = STATE(867),
    [sym_index_expression] = STATE(867),
    [sym_typed_expression] = STATE(867),
    [sym_declaration_expression] = STATE(867),
    [sym_do_expression] = STATE(867),
    [sym_list_expression] = STATE(867),
    [sym_array_expression] = STATE(867),
    [sym_begin_end_expression] = STATE(867),
    [sym_paren_expression] = STATE(867),
    [sym__high_prec_app] = STATE(864),
    [sym__low_prec_app] = STATE(864),
    [sym_application_expression] = STATE(867),
    [sym_dot_expression] = STATE(867),
    [sym_infix_expression] = STATE(867),
    [sym_ce_expression] = STATE(867),
    [sym_sequential_expression] = STATE(867),
    [sym__comp_or_range_expression] = STATE(6426),
    [sym_short_comp_expression] = STATE(6760),
    [sym_field_initializer] = STATE(5913),
    [sym_field_initializers] = STATE(6410),
    [sym_char] = STATE(868),
    [sym_format_string] = STATE(869),
    [sym__string_literal] = STATE(869),
    [sym_string] = STATE(868),
    [sym_verbatim_string] = STATE(868),
    [sym_bytearray] = STATE(868),
    [sym_verbatim_bytearray] = STATE(868),
    [sym_format_triple_quoted_string] = STATE(870),
    [sym_triple_quoted_string] = STATE(868),
    [sym_const] = STATE(867),
    [sym_long_identifier] = STATE(1626),
    [sym_active_pattern] = STATE(871),
    [sym__identifier_or_op] = STATE(873),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(656),
    [sym_sbyte] = STATE(868),
    [sym_byte] = STATE(868),
    [sym_int16] = STATE(868),
    [sym_uint16] = STATE(868),
    [sym_int32] = STATE(868),
    [sym_uint32] = STATE(868),
    [sym_nativeint] = STATE(868),
    [sym_unativeint] = STATE(868),
    [sym_int64] = STATE(868),
    [sym_uint64] = STATE(868),
    [sym_ieee32] = STATE(868),
    [sym_ieee64] = STATE(868),
    [sym_bignum] = STATE(868),
    [sym_decimal] = STATE(868),
    [sym_float] = STATE(1368),
    [sym_block_comment] = STATE(365),
    [sym_compiler_directive_decl] = STATE(365),
    [sym_fsi_directive_decl] = STATE(365),
    [sym_preproc_line] = STATE(365),
    [sym_preproc_if_in_expression] = STATE(867),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(1703),
    [anon_sym_return] = ACTIONS(825),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_null] = ACTIONS(49),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACK_PIPE] = ACTIONS(57),
    [anon_sym_LBRACE] = ACTIONS(1663),
    [anon_sym_LT_AT] = ACTIONS(61),
    [anon_sym_LT_AT_AT] = ACTIONS(1665),
    [anon_sym_LBRACE_PIPE] = ACTIONS(67),
    [anon_sym_new] = ACTIONS(1705),
    [anon_sym_return_BANG] = ACTIONS(829),
    [anon_sym_yield] = ACTIONS(825),
    [anon_sym_yield_BANG] = ACTIONS(829),
    [anon_sym_lazy] = ACTIONS(825),
    [anon_sym_assert] = ACTIONS(825),
    [anon_sym_upcast] = ACTIONS(825),
    [anon_sym_downcast] = ACTIONS(825),
    [anon_sym_for] = ACTIONS(1707),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(79),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_match] = ACTIONS(83),
    [anon_sym_match_BANG] = ACTIONS(85),
    [anon_sym_function] = ACTIONS(87),
    [anon_sym_use] = ACTIONS(833),
    [anon_sym_use_BANG] = ACTIONS(835),
    [anon_sym_do_BANG] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(101),
    [aux_sym_char_token1] = ACTIONS(105),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(107),
    [anon_sym_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DQUOTE] = ACTIONS(111),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(115),
    [sym_bool] = ACTIONS(117),
    [sym_unit] = ACTIONS(1673),
    [anon_sym_LPAREN_PIPE] = ACTIONS(121),
    [sym_op_identifier] = ACTIONS(1675),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(837),
    [sym_xint] = ACTIONS(387),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(135),
  },
  [366] = {
    [sym_function_or_value_defn] = STATE(663),
    [sym__expression] = STATE(87),
    [sym_literal_expression] = STATE(1118),
    [sym_long_identifier_or_op] = STATE(1118),
    [sym_tuple_expression] = STATE(1118),
    [sym_brace_expression] = STATE(1118),
    [sym_anon_record_expression] = STATE(1118),
    [sym_prefixed_expression] = STATE(1118),
    [sym_typecast_expression] = STATE(1118),
    [sym_for_expression] = STATE(1118),
    [sym_while_expression] = STATE(1118),
    [sym__if_branch] = STATE(7163),
    [sym_if_expression] = STATE(1118),
    [sym_fun_expression] = STATE(1118),
    [sym_try_expression] = STATE(1118),
    [sym_match_expression] = STATE(1118),
    [sym_function_expression] = STATE(1118),
    [sym_mutate_expression] = STATE(1118),
    [sym_index_expression] = STATE(1118),
    [sym_typed_expression] = STATE(1118),
    [sym_declaration_expression] = STATE(1118),
    [sym_do_expression] = STATE(1118),
    [sym_list_expression] = STATE(1118),
    [sym_array_expression] = STATE(1118),
    [sym_begin_end_expression] = STATE(1118),
    [sym_paren_expression] = STATE(1118),
    [sym__high_prec_app] = STATE(1133),
    [sym__low_prec_app] = STATE(1133),
    [sym_application_expression] = STATE(1118),
    [sym_dot_expression] = STATE(1118),
    [sym_infix_expression] = STATE(1118),
    [sym_ce_expression] = STATE(1118),
    [sym_sequential_expression] = STATE(1118),
    [sym_slice_ranges] = STATE(6399),
    [sym__slice_range_special] = STATE(6328),
    [sym_slice_range] = STATE(5802),
    [sym_char] = STATE(1080),
    [sym_format_string] = STATE(1090),
    [sym__string_literal] = STATE(1090),
    [sym_string] = STATE(1080),
    [sym_verbatim_string] = STATE(1080),
    [sym_bytearray] = STATE(1080),
    [sym_verbatim_bytearray] = STATE(1080),
    [sym_format_triple_quoted_string] = STATE(1096),
    [sym_triple_quoted_string] = STATE(1080),
    [sym_const] = STATE(1118),
    [sym_long_identifier] = STATE(1156),
    [sym_active_pattern] = STATE(1085),
    [sym__identifier_or_op] = STATE(1099),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(548),
    [sym_sbyte] = STATE(1080),
    [sym_byte] = STATE(1080),
    [sym_int16] = STATE(1080),
    [sym_uint16] = STATE(1080),
    [sym_int32] = STATE(1080),
    [sym_uint32] = STATE(1080),
    [sym_nativeint] = STATE(1080),
    [sym_unativeint] = STATE(1080),
    [sym_int64] = STATE(1080),
    [sym_uint64] = STATE(1080),
    [sym_ieee32] = STATE(1080),
    [sym_ieee64] = STATE(1080),
    [sym_bignum] = STATE(1080),
    [sym_decimal] = STATE(1080),
    [sym_float] = STATE(979),
    [sym_block_comment] = STATE(366),
    [sym_compiler_directive_decl] = STATE(366),
    [sym_fsi_directive_decl] = STATE(366),
    [sym_preproc_line] = STATE(366),
    [sym_preproc_if_in_expression] = STATE(1118),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(195),
    [anon_sym_return] = ACTIONS(481),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_null] = ACTIONS(207),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(209),
    [anon_sym_LBRACK_PIPE] = ACTIONS(211),
    [anon_sym_LBRACE] = ACTIONS(1687),
    [anon_sym_LT_AT] = ACTIONS(213),
    [anon_sym_LT_AT_AT] = ACTIONS(1689),
    [anon_sym_LBRACE_PIPE] = ACTIONS(217),
    [anon_sym_new] = ACTIONS(481),
    [anon_sym_return_BANG] = ACTIONS(487),
    [anon_sym_yield] = ACTIONS(481),
    [anon_sym_yield_BANG] = ACTIONS(487),
    [anon_sym_lazy] = ACTIONS(481),
    [anon_sym_assert] = ACTIONS(481),
    [anon_sym_upcast] = ACTIONS(481),
    [anon_sym_downcast] = ACTIONS(481),
    [anon_sym_for] = ACTIONS(489),
    [anon_sym_while] = ACTIONS(225),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(229),
    [anon_sym_match] = ACTIONS(231),
    [anon_sym_match_BANG] = ACTIONS(233),
    [anon_sym_function] = ACTIONS(235),
    [anon_sym_use] = ACTIONS(493),
    [anon_sym_use_BANG] = ACTIONS(495),
    [anon_sym_do_BANG] = ACTIONS(243),
    [anon_sym_begin] = ACTIONS(245),
    [anon_sym_DOT_DOT3] = ACTIONS(1709),
    [anon_sym_STAR] = ACTIONS(1711),
    [aux_sym_char_token1] = ACTIONS(247),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(251),
    [anon_sym_AT_DQUOTE] = ACTIONS(253),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(255),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(257),
    [sym_bool] = ACTIONS(259),
    [sym_unit] = ACTIONS(1699),
    [anon_sym_LPAREN_PIPE] = ACTIONS(261),
    [sym_op_identifier] = ACTIONS(1701),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(499),
    [sym_xint] = ACTIONS(267),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(269),
  },
  [367] = {
    [sym_function_or_value_defn] = STATE(532),
    [sym__expression] = STATE(102),
    [sym_literal_expression] = STATE(2000),
    [sym_long_identifier_or_op] = STATE(2000),
    [sym_tuple_expression] = STATE(2000),
    [sym_brace_expression] = STATE(2000),
    [sym_anon_record_expression] = STATE(2000),
    [sym_prefixed_expression] = STATE(2000),
    [sym_typecast_expression] = STATE(2000),
    [sym_for_expression] = STATE(2000),
    [sym_while_expression] = STATE(2000),
    [sym__if_branch] = STATE(6707),
    [sym_if_expression] = STATE(2000),
    [sym_fun_expression] = STATE(2000),
    [sym_try_expression] = STATE(2000),
    [sym_match_expression] = STATE(2000),
    [sym_function_expression] = STATE(2000),
    [sym_mutate_expression] = STATE(2000),
    [sym_index_expression] = STATE(2000),
    [sym_typed_expression] = STATE(2000),
    [sym_declaration_expression] = STATE(2000),
    [sym_do_expression] = STATE(2000),
    [sym_list_expression] = STATE(2000),
    [sym_array_expression] = STATE(2000),
    [sym_begin_end_expression] = STATE(2000),
    [sym_paren_expression] = STATE(2000),
    [sym__high_prec_app] = STATE(2003),
    [sym__low_prec_app] = STATE(2003),
    [sym_application_expression] = STATE(2000),
    [sym_dot_expression] = STATE(2000),
    [sym_infix_expression] = STATE(2000),
    [sym_ce_expression] = STATE(2000),
    [sym_sequential_expression] = STATE(2000),
    [sym_char] = STATE(1801),
    [sym_format_string] = STATE(1804),
    [sym__string_literal] = STATE(1804),
    [sym_string] = STATE(1801),
    [sym_verbatim_string] = STATE(1801),
    [sym_bytearray] = STATE(1801),
    [sym_verbatim_bytearray] = STATE(1801),
    [sym_format_triple_quoted_string] = STATE(1807),
    [sym_triple_quoted_string] = STATE(1801),
    [sym_const] = STATE(2000),
    [sym_long_identifier] = STATE(1725),
    [sym_active_pattern] = STATE(1726),
    [sym__identifier_or_op] = STATE(1751),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(723),
    [sym_sbyte] = STATE(1801),
    [sym_byte] = STATE(1801),
    [sym_int16] = STATE(1801),
    [sym_uint16] = STATE(1801),
    [sym_int32] = STATE(1801),
    [sym_uint32] = STATE(1801),
    [sym_nativeint] = STATE(1801),
    [sym_unativeint] = STATE(1801),
    [sym_int64] = STATE(1801),
    [sym_uint64] = STATE(1801),
    [sym_ieee32] = STATE(1801),
    [sym_ieee64] = STATE(1801),
    [sym_bignum] = STATE(1801),
    [sym_decimal] = STATE(1801),
    [sym_float] = STATE(1427),
    [sym_block_comment] = STATE(367),
    [sym_compiler_directive_decl] = STATE(367),
    [sym_fsi_directive_decl] = STATE(367),
    [sym_preproc_line] = STATE(367),
    [sym_preproc_if_in_expression] = STATE(2000),
    [sym_preproc_else_in_expression] = STATE(6656),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [aux_sym_preproc_if_in_expression_repeat1] = STATE(416),
    [sym_identifier] = ACTIONS(629),
    [anon_sym_return] = ACTIONS(633),
    [anon_sym_do] = ACTIONS(635),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(637),
    [anon_sym_null] = ACTIONS(641),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(643),
    [anon_sym_LBRACK_PIPE] = ACTIONS(645),
    [anon_sym_LBRACE] = ACTIONS(1713),
    [anon_sym_LT_AT] = ACTIONS(647),
    [anon_sym_LT_AT_AT] = ACTIONS(1715),
    [anon_sym_LBRACE_PIPE] = ACTIONS(653),
    [anon_sym_new] = ACTIONS(633),
    [anon_sym_return_BANG] = ACTIONS(655),
    [anon_sym_yield] = ACTIONS(633),
    [anon_sym_yield_BANG] = ACTIONS(655),
    [anon_sym_lazy] = ACTIONS(633),
    [anon_sym_assert] = ACTIONS(633),
    [anon_sym_upcast] = ACTIONS(633),
    [anon_sym_downcast] = ACTIONS(633),
    [anon_sym_for] = ACTIONS(659),
    [anon_sym_while] = ACTIONS(661),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(663),
    [anon_sym_try] = ACTIONS(665),
    [anon_sym_match] = ACTIONS(667),
    [anon_sym_match_BANG] = ACTIONS(669),
    [anon_sym_function] = ACTIONS(671),
    [anon_sym_use] = ACTIONS(679),
    [anon_sym_use_BANG] = ACTIONS(681),
    [anon_sym_do_BANG] = ACTIONS(683),
    [anon_sym_begin] = ACTIONS(685),
    [aux_sym_char_token1] = ACTIONS(689),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(691),
    [anon_sym_DQUOTE] = ACTIONS(693),
    [anon_sym_AT_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(697),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(699),
    [sym_bool] = ACTIONS(701),
    [sym_unit] = ACTIONS(1717),
    [anon_sym_LPAREN_PIPE] = ACTIONS(705),
    [sym_op_identifier] = ACTIONS(1719),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(709),
    [sym_xint] = ACTIONS(711),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(713),
    [anon_sym_POUNDendif] = ACTIONS(1721),
    [anon_sym_POUNDelse] = ACTIONS(1723),
    [sym__newline] = ACTIONS(1725),
  },
  [368] = {
    [sym_function_or_value_defn] = STATE(532),
    [sym__expression] = STATE(102),
    [sym_literal_expression] = STATE(2000),
    [sym_long_identifier_or_op] = STATE(2000),
    [sym_tuple_expression] = STATE(2000),
    [sym_brace_expression] = STATE(2000),
    [sym_anon_record_expression] = STATE(2000),
    [sym_prefixed_expression] = STATE(2000),
    [sym_typecast_expression] = STATE(2000),
    [sym_for_expression] = STATE(2000),
    [sym_while_expression] = STATE(2000),
    [sym__if_branch] = STATE(6707),
    [sym_if_expression] = STATE(2000),
    [sym_fun_expression] = STATE(2000),
    [sym_try_expression] = STATE(2000),
    [sym_match_expression] = STATE(2000),
    [sym_function_expression] = STATE(2000),
    [sym_mutate_expression] = STATE(2000),
    [sym_index_expression] = STATE(2000),
    [sym_typed_expression] = STATE(2000),
    [sym_declaration_expression] = STATE(2000),
    [sym_do_expression] = STATE(2000),
    [sym_list_expression] = STATE(2000),
    [sym_array_expression] = STATE(2000),
    [sym_begin_end_expression] = STATE(2000),
    [sym_paren_expression] = STATE(2000),
    [sym__high_prec_app] = STATE(2003),
    [sym__low_prec_app] = STATE(2003),
    [sym_application_expression] = STATE(2000),
    [sym_dot_expression] = STATE(2000),
    [sym_infix_expression] = STATE(2000),
    [sym_ce_expression] = STATE(2000),
    [sym_sequential_expression] = STATE(2000),
    [sym_char] = STATE(1801),
    [sym_format_string] = STATE(1804),
    [sym__string_literal] = STATE(1804),
    [sym_string] = STATE(1801),
    [sym_verbatim_string] = STATE(1801),
    [sym_bytearray] = STATE(1801),
    [sym_verbatim_bytearray] = STATE(1801),
    [sym_format_triple_quoted_string] = STATE(1807),
    [sym_triple_quoted_string] = STATE(1801),
    [sym_const] = STATE(2000),
    [sym_long_identifier] = STATE(1725),
    [sym_active_pattern] = STATE(1726),
    [sym__identifier_or_op] = STATE(1751),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(723),
    [sym_sbyte] = STATE(1801),
    [sym_byte] = STATE(1801),
    [sym_int16] = STATE(1801),
    [sym_uint16] = STATE(1801),
    [sym_int32] = STATE(1801),
    [sym_uint32] = STATE(1801),
    [sym_nativeint] = STATE(1801),
    [sym_unativeint] = STATE(1801),
    [sym_int64] = STATE(1801),
    [sym_uint64] = STATE(1801),
    [sym_ieee32] = STATE(1801),
    [sym_ieee64] = STATE(1801),
    [sym_bignum] = STATE(1801),
    [sym_decimal] = STATE(1801),
    [sym_float] = STATE(1427),
    [sym_block_comment] = STATE(368),
    [sym_compiler_directive_decl] = STATE(368),
    [sym_fsi_directive_decl] = STATE(368),
    [sym_preproc_line] = STATE(368),
    [sym_preproc_if_in_expression] = STATE(2000),
    [sym_preproc_else_in_expression] = STATE(7192),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [aux_sym_preproc_if_in_expression_repeat1] = STATE(370),
    [sym_identifier] = ACTIONS(629),
    [anon_sym_return] = ACTIONS(633),
    [anon_sym_do] = ACTIONS(635),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(637),
    [anon_sym_null] = ACTIONS(641),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(643),
    [anon_sym_LBRACK_PIPE] = ACTIONS(645),
    [anon_sym_LBRACE] = ACTIONS(1713),
    [anon_sym_LT_AT] = ACTIONS(647),
    [anon_sym_LT_AT_AT] = ACTIONS(1715),
    [anon_sym_LBRACE_PIPE] = ACTIONS(653),
    [anon_sym_new] = ACTIONS(633),
    [anon_sym_return_BANG] = ACTIONS(655),
    [anon_sym_yield] = ACTIONS(633),
    [anon_sym_yield_BANG] = ACTIONS(655),
    [anon_sym_lazy] = ACTIONS(633),
    [anon_sym_assert] = ACTIONS(633),
    [anon_sym_upcast] = ACTIONS(633),
    [anon_sym_downcast] = ACTIONS(633),
    [anon_sym_for] = ACTIONS(659),
    [anon_sym_while] = ACTIONS(661),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(663),
    [anon_sym_try] = ACTIONS(665),
    [anon_sym_match] = ACTIONS(667),
    [anon_sym_match_BANG] = ACTIONS(669),
    [anon_sym_function] = ACTIONS(671),
    [anon_sym_use] = ACTIONS(679),
    [anon_sym_use_BANG] = ACTIONS(681),
    [anon_sym_do_BANG] = ACTIONS(683),
    [anon_sym_begin] = ACTIONS(685),
    [aux_sym_char_token1] = ACTIONS(689),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(691),
    [anon_sym_DQUOTE] = ACTIONS(693),
    [anon_sym_AT_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(697),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(699),
    [sym_bool] = ACTIONS(701),
    [sym_unit] = ACTIONS(1717),
    [anon_sym_LPAREN_PIPE] = ACTIONS(705),
    [sym_op_identifier] = ACTIONS(1719),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(709),
    [sym_xint] = ACTIONS(711),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(713),
    [anon_sym_POUNDendif] = ACTIONS(1727),
    [anon_sym_POUNDelse] = ACTIONS(1723),
    [sym__newline] = ACTIONS(1725),
  },
  [369] = {
    [sym_function_or_value_defn] = STATE(532),
    [sym__expression] = STATE(102),
    [sym_literal_expression] = STATE(2000),
    [sym_long_identifier_or_op] = STATE(2000),
    [sym_tuple_expression] = STATE(2000),
    [sym_brace_expression] = STATE(2000),
    [sym_anon_record_expression] = STATE(2000),
    [sym_prefixed_expression] = STATE(2000),
    [sym_typecast_expression] = STATE(2000),
    [sym_for_expression] = STATE(2000),
    [sym_while_expression] = STATE(2000),
    [sym__if_branch] = STATE(6707),
    [sym_if_expression] = STATE(2000),
    [sym_fun_expression] = STATE(2000),
    [sym_try_expression] = STATE(2000),
    [sym_match_expression] = STATE(2000),
    [sym_function_expression] = STATE(2000),
    [sym_mutate_expression] = STATE(2000),
    [sym_index_expression] = STATE(2000),
    [sym_typed_expression] = STATE(2000),
    [sym_declaration_expression] = STATE(2000),
    [sym_do_expression] = STATE(2000),
    [sym_list_expression] = STATE(2000),
    [sym_array_expression] = STATE(2000),
    [sym_begin_end_expression] = STATE(2000),
    [sym_paren_expression] = STATE(2000),
    [sym__high_prec_app] = STATE(2003),
    [sym__low_prec_app] = STATE(2003),
    [sym_application_expression] = STATE(2000),
    [sym_dot_expression] = STATE(2000),
    [sym_infix_expression] = STATE(2000),
    [sym_ce_expression] = STATE(2000),
    [sym_sequential_expression] = STATE(2000),
    [sym_char] = STATE(1801),
    [sym_format_string] = STATE(1804),
    [sym__string_literal] = STATE(1804),
    [sym_string] = STATE(1801),
    [sym_verbatim_string] = STATE(1801),
    [sym_bytearray] = STATE(1801),
    [sym_verbatim_bytearray] = STATE(1801),
    [sym_format_triple_quoted_string] = STATE(1807),
    [sym_triple_quoted_string] = STATE(1801),
    [sym_const] = STATE(2000),
    [sym_long_identifier] = STATE(1725),
    [sym_active_pattern] = STATE(1726),
    [sym__identifier_or_op] = STATE(1751),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(723),
    [sym_sbyte] = STATE(1801),
    [sym_byte] = STATE(1801),
    [sym_int16] = STATE(1801),
    [sym_uint16] = STATE(1801),
    [sym_int32] = STATE(1801),
    [sym_uint32] = STATE(1801),
    [sym_nativeint] = STATE(1801),
    [sym_unativeint] = STATE(1801),
    [sym_int64] = STATE(1801),
    [sym_uint64] = STATE(1801),
    [sym_ieee32] = STATE(1801),
    [sym_ieee64] = STATE(1801),
    [sym_bignum] = STATE(1801),
    [sym_decimal] = STATE(1801),
    [sym_float] = STATE(1427),
    [sym_block_comment] = STATE(369),
    [sym_compiler_directive_decl] = STATE(369),
    [sym_fsi_directive_decl] = STATE(369),
    [sym_preproc_line] = STATE(369),
    [sym_preproc_if_in_expression] = STATE(2000),
    [sym_preproc_else_in_expression] = STATE(7359),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [aux_sym_preproc_if_in_expression_repeat1] = STATE(399),
    [sym_identifier] = ACTIONS(629),
    [anon_sym_return] = ACTIONS(633),
    [anon_sym_do] = ACTIONS(635),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(637),
    [anon_sym_null] = ACTIONS(641),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(643),
    [anon_sym_LBRACK_PIPE] = ACTIONS(645),
    [anon_sym_LBRACE] = ACTIONS(1713),
    [anon_sym_LT_AT] = ACTIONS(647),
    [anon_sym_LT_AT_AT] = ACTIONS(1715),
    [anon_sym_LBRACE_PIPE] = ACTIONS(653),
    [anon_sym_new] = ACTIONS(633),
    [anon_sym_return_BANG] = ACTIONS(655),
    [anon_sym_yield] = ACTIONS(633),
    [anon_sym_yield_BANG] = ACTIONS(655),
    [anon_sym_lazy] = ACTIONS(633),
    [anon_sym_assert] = ACTIONS(633),
    [anon_sym_upcast] = ACTIONS(633),
    [anon_sym_downcast] = ACTIONS(633),
    [anon_sym_for] = ACTIONS(659),
    [anon_sym_while] = ACTIONS(661),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(663),
    [anon_sym_try] = ACTIONS(665),
    [anon_sym_match] = ACTIONS(667),
    [anon_sym_match_BANG] = ACTIONS(669),
    [anon_sym_function] = ACTIONS(671),
    [anon_sym_use] = ACTIONS(679),
    [anon_sym_use_BANG] = ACTIONS(681),
    [anon_sym_do_BANG] = ACTIONS(683),
    [anon_sym_begin] = ACTIONS(685),
    [aux_sym_char_token1] = ACTIONS(689),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(691),
    [anon_sym_DQUOTE] = ACTIONS(693),
    [anon_sym_AT_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(697),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(699),
    [sym_bool] = ACTIONS(701),
    [sym_unit] = ACTIONS(1717),
    [anon_sym_LPAREN_PIPE] = ACTIONS(705),
    [sym_op_identifier] = ACTIONS(1719),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(709),
    [sym_xint] = ACTIONS(711),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(713),
    [anon_sym_POUNDendif] = ACTIONS(1729),
    [anon_sym_POUNDelse] = ACTIONS(1723),
    [sym__newline] = ACTIONS(1725),
  },
  [370] = {
    [sym_function_or_value_defn] = STATE(532),
    [sym__expression] = STATE(102),
    [sym_literal_expression] = STATE(2000),
    [sym_long_identifier_or_op] = STATE(2000),
    [sym_tuple_expression] = STATE(2000),
    [sym_brace_expression] = STATE(2000),
    [sym_anon_record_expression] = STATE(2000),
    [sym_prefixed_expression] = STATE(2000),
    [sym_typecast_expression] = STATE(2000),
    [sym_for_expression] = STATE(2000),
    [sym_while_expression] = STATE(2000),
    [sym__if_branch] = STATE(6707),
    [sym_if_expression] = STATE(2000),
    [sym_fun_expression] = STATE(2000),
    [sym_try_expression] = STATE(2000),
    [sym_match_expression] = STATE(2000),
    [sym_function_expression] = STATE(2000),
    [sym_mutate_expression] = STATE(2000),
    [sym_index_expression] = STATE(2000),
    [sym_typed_expression] = STATE(2000),
    [sym_declaration_expression] = STATE(2000),
    [sym_do_expression] = STATE(2000),
    [sym_list_expression] = STATE(2000),
    [sym_array_expression] = STATE(2000),
    [sym_begin_end_expression] = STATE(2000),
    [sym_paren_expression] = STATE(2000),
    [sym__high_prec_app] = STATE(2003),
    [sym__low_prec_app] = STATE(2003),
    [sym_application_expression] = STATE(2000),
    [sym_dot_expression] = STATE(2000),
    [sym_infix_expression] = STATE(2000),
    [sym_ce_expression] = STATE(2000),
    [sym_sequential_expression] = STATE(2000),
    [sym_char] = STATE(1801),
    [sym_format_string] = STATE(1804),
    [sym__string_literal] = STATE(1804),
    [sym_string] = STATE(1801),
    [sym_verbatim_string] = STATE(1801),
    [sym_bytearray] = STATE(1801),
    [sym_verbatim_bytearray] = STATE(1801),
    [sym_format_triple_quoted_string] = STATE(1807),
    [sym_triple_quoted_string] = STATE(1801),
    [sym_const] = STATE(2000),
    [sym_long_identifier] = STATE(1725),
    [sym_active_pattern] = STATE(1726),
    [sym__identifier_or_op] = STATE(1751),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(723),
    [sym_sbyte] = STATE(1801),
    [sym_byte] = STATE(1801),
    [sym_int16] = STATE(1801),
    [sym_uint16] = STATE(1801),
    [sym_int32] = STATE(1801),
    [sym_uint32] = STATE(1801),
    [sym_nativeint] = STATE(1801),
    [sym_unativeint] = STATE(1801),
    [sym_int64] = STATE(1801),
    [sym_uint64] = STATE(1801),
    [sym_ieee32] = STATE(1801),
    [sym_ieee64] = STATE(1801),
    [sym_bignum] = STATE(1801),
    [sym_decimal] = STATE(1801),
    [sym_float] = STATE(1427),
    [sym_block_comment] = STATE(370),
    [sym_compiler_directive_decl] = STATE(370),
    [sym_fsi_directive_decl] = STATE(370),
    [sym_preproc_line] = STATE(370),
    [sym_preproc_if_in_expression] = STATE(2000),
    [sym_preproc_else_in_expression] = STATE(7220),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [aux_sym_preproc_if_in_expression_repeat1] = STATE(416),
    [sym_identifier] = ACTIONS(629),
    [anon_sym_return] = ACTIONS(633),
    [anon_sym_do] = ACTIONS(635),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(637),
    [anon_sym_null] = ACTIONS(641),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(643),
    [anon_sym_LBRACK_PIPE] = ACTIONS(645),
    [anon_sym_LBRACE] = ACTIONS(1713),
    [anon_sym_LT_AT] = ACTIONS(647),
    [anon_sym_LT_AT_AT] = ACTIONS(1715),
    [anon_sym_LBRACE_PIPE] = ACTIONS(653),
    [anon_sym_new] = ACTIONS(633),
    [anon_sym_return_BANG] = ACTIONS(655),
    [anon_sym_yield] = ACTIONS(633),
    [anon_sym_yield_BANG] = ACTIONS(655),
    [anon_sym_lazy] = ACTIONS(633),
    [anon_sym_assert] = ACTIONS(633),
    [anon_sym_upcast] = ACTIONS(633),
    [anon_sym_downcast] = ACTIONS(633),
    [anon_sym_for] = ACTIONS(659),
    [anon_sym_while] = ACTIONS(661),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(663),
    [anon_sym_try] = ACTIONS(665),
    [anon_sym_match] = ACTIONS(667),
    [anon_sym_match_BANG] = ACTIONS(669),
    [anon_sym_function] = ACTIONS(671),
    [anon_sym_use] = ACTIONS(679),
    [anon_sym_use_BANG] = ACTIONS(681),
    [anon_sym_do_BANG] = ACTIONS(683),
    [anon_sym_begin] = ACTIONS(685),
    [aux_sym_char_token1] = ACTIONS(689),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(691),
    [anon_sym_DQUOTE] = ACTIONS(693),
    [anon_sym_AT_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(697),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(699),
    [sym_bool] = ACTIONS(701),
    [sym_unit] = ACTIONS(1717),
    [anon_sym_LPAREN_PIPE] = ACTIONS(705),
    [sym_op_identifier] = ACTIONS(1719),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(709),
    [sym_xint] = ACTIONS(711),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(713),
    [anon_sym_POUNDendif] = ACTIONS(1731),
    [anon_sym_POUNDelse] = ACTIONS(1723),
    [sym__newline] = ACTIONS(1725),
  },
  [371] = {
    [sym_function_or_value_defn] = STATE(663),
    [sym__expression] = STATE(63),
    [sym_literal_expression] = STATE(1118),
    [sym_long_identifier_or_op] = STATE(1118),
    [sym_tuple_expression] = STATE(1118),
    [sym_brace_expression] = STATE(1118),
    [sym_anon_record_expression] = STATE(1118),
    [sym_prefixed_expression] = STATE(1118),
    [sym_typecast_expression] = STATE(1118),
    [sym_for_expression] = STATE(1118),
    [sym_while_expression] = STATE(1118),
    [sym__if_branch] = STATE(7163),
    [sym_if_expression] = STATE(1118),
    [sym_fun_expression] = STATE(1118),
    [sym_try_expression] = STATE(1118),
    [sym_match_expression] = STATE(1118),
    [sym_function_expression] = STATE(1118),
    [sym_mutate_expression] = STATE(1118),
    [sym_index_expression] = STATE(1118),
    [sym_typed_expression] = STATE(1118),
    [sym_declaration_expression] = STATE(1118),
    [sym_do_expression] = STATE(1118),
    [sym_list_expression] = STATE(1118),
    [sym_array_expression] = STATE(1118),
    [sym_begin_end_expression] = STATE(1118),
    [sym_paren_expression] = STATE(1118),
    [sym__high_prec_app] = STATE(1133),
    [sym__low_prec_app] = STATE(1133),
    [sym_application_expression] = STATE(1118),
    [sym_dot_expression] = STATE(1118),
    [sym_infix_expression] = STATE(1118),
    [sym_ce_expression] = STATE(1118),
    [sym_sequential_expression] = STATE(1118),
    [sym_slice_ranges] = STATE(6764),
    [sym__slice_range_special] = STATE(6328),
    [sym_slice_range] = STATE(5802),
    [sym_char] = STATE(1080),
    [sym_format_string] = STATE(1090),
    [sym__string_literal] = STATE(1090),
    [sym_string] = STATE(1080),
    [sym_verbatim_string] = STATE(1080),
    [sym_bytearray] = STATE(1080),
    [sym_verbatim_bytearray] = STATE(1080),
    [sym_format_triple_quoted_string] = STATE(1096),
    [sym_triple_quoted_string] = STATE(1080),
    [sym_const] = STATE(1118),
    [sym_long_identifier] = STATE(1156),
    [sym_active_pattern] = STATE(1085),
    [sym__identifier_or_op] = STATE(1099),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(548),
    [sym_sbyte] = STATE(1080),
    [sym_byte] = STATE(1080),
    [sym_int16] = STATE(1080),
    [sym_uint16] = STATE(1080),
    [sym_int32] = STATE(1080),
    [sym_uint32] = STATE(1080),
    [sym_nativeint] = STATE(1080),
    [sym_unativeint] = STATE(1080),
    [sym_int64] = STATE(1080),
    [sym_uint64] = STATE(1080),
    [sym_ieee32] = STATE(1080),
    [sym_ieee64] = STATE(1080),
    [sym_bignum] = STATE(1080),
    [sym_decimal] = STATE(1080),
    [sym_float] = STATE(979),
    [sym_block_comment] = STATE(371),
    [sym_compiler_directive_decl] = STATE(371),
    [sym_fsi_directive_decl] = STATE(371),
    [sym_preproc_line] = STATE(371),
    [sym_preproc_if_in_expression] = STATE(1118),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(195),
    [anon_sym_return] = ACTIONS(481),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_null] = ACTIONS(207),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(209),
    [anon_sym_LBRACK_PIPE] = ACTIONS(211),
    [anon_sym_LBRACE] = ACTIONS(1687),
    [anon_sym_LT_AT] = ACTIONS(213),
    [anon_sym_LT_AT_AT] = ACTIONS(1689),
    [anon_sym_LBRACE_PIPE] = ACTIONS(217),
    [anon_sym_new] = ACTIONS(481),
    [anon_sym_return_BANG] = ACTIONS(487),
    [anon_sym_yield] = ACTIONS(481),
    [anon_sym_yield_BANG] = ACTIONS(487),
    [anon_sym_lazy] = ACTIONS(481),
    [anon_sym_assert] = ACTIONS(481),
    [anon_sym_upcast] = ACTIONS(481),
    [anon_sym_downcast] = ACTIONS(481),
    [anon_sym_for] = ACTIONS(489),
    [anon_sym_while] = ACTIONS(225),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(229),
    [anon_sym_match] = ACTIONS(231),
    [anon_sym_match_BANG] = ACTIONS(233),
    [anon_sym_function] = ACTIONS(235),
    [anon_sym_use] = ACTIONS(493),
    [anon_sym_use_BANG] = ACTIONS(495),
    [anon_sym_do_BANG] = ACTIONS(243),
    [anon_sym_begin] = ACTIONS(245),
    [anon_sym_DOT_DOT3] = ACTIONS(1709),
    [anon_sym_STAR] = ACTIONS(1711),
    [aux_sym_char_token1] = ACTIONS(247),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(251),
    [anon_sym_AT_DQUOTE] = ACTIONS(253),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(255),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(257),
    [sym_bool] = ACTIONS(259),
    [sym_unit] = ACTIONS(1699),
    [anon_sym_LPAREN_PIPE] = ACTIONS(261),
    [sym_op_identifier] = ACTIONS(1701),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(499),
    [sym_xint] = ACTIONS(267),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(269),
  },
  [372] = {
    [sym_function_or_value_defn] = STATE(532),
    [sym__expression] = STATE(102),
    [sym_literal_expression] = STATE(2000),
    [sym_long_identifier_or_op] = STATE(2000),
    [sym_tuple_expression] = STATE(2000),
    [sym_brace_expression] = STATE(2000),
    [sym_anon_record_expression] = STATE(2000),
    [sym_prefixed_expression] = STATE(2000),
    [sym_typecast_expression] = STATE(2000),
    [sym_for_expression] = STATE(2000),
    [sym_while_expression] = STATE(2000),
    [sym__if_branch] = STATE(6707),
    [sym_if_expression] = STATE(2000),
    [sym_fun_expression] = STATE(2000),
    [sym_try_expression] = STATE(2000),
    [sym_match_expression] = STATE(2000),
    [sym_function_expression] = STATE(2000),
    [sym_mutate_expression] = STATE(2000),
    [sym_index_expression] = STATE(2000),
    [sym_typed_expression] = STATE(2000),
    [sym_declaration_expression] = STATE(2000),
    [sym_do_expression] = STATE(2000),
    [sym_list_expression] = STATE(2000),
    [sym_array_expression] = STATE(2000),
    [sym_begin_end_expression] = STATE(2000),
    [sym_paren_expression] = STATE(2000),
    [sym__high_prec_app] = STATE(2003),
    [sym__low_prec_app] = STATE(2003),
    [sym_application_expression] = STATE(2000),
    [sym_dot_expression] = STATE(2000),
    [sym_infix_expression] = STATE(2000),
    [sym_ce_expression] = STATE(2000),
    [sym_sequential_expression] = STATE(2000),
    [sym_char] = STATE(1801),
    [sym_format_string] = STATE(1804),
    [sym__string_literal] = STATE(1804),
    [sym_string] = STATE(1801),
    [sym_verbatim_string] = STATE(1801),
    [sym_bytearray] = STATE(1801),
    [sym_verbatim_bytearray] = STATE(1801),
    [sym_format_triple_quoted_string] = STATE(1807),
    [sym_triple_quoted_string] = STATE(1801),
    [sym_const] = STATE(2000),
    [sym_long_identifier] = STATE(1725),
    [sym_active_pattern] = STATE(1726),
    [sym__identifier_or_op] = STATE(1751),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(723),
    [sym_sbyte] = STATE(1801),
    [sym_byte] = STATE(1801),
    [sym_int16] = STATE(1801),
    [sym_uint16] = STATE(1801),
    [sym_int32] = STATE(1801),
    [sym_uint32] = STATE(1801),
    [sym_nativeint] = STATE(1801),
    [sym_unativeint] = STATE(1801),
    [sym_int64] = STATE(1801),
    [sym_uint64] = STATE(1801),
    [sym_ieee32] = STATE(1801),
    [sym_ieee64] = STATE(1801),
    [sym_bignum] = STATE(1801),
    [sym_decimal] = STATE(1801),
    [sym_float] = STATE(1427),
    [sym_block_comment] = STATE(372),
    [sym_compiler_directive_decl] = STATE(372),
    [sym_fsi_directive_decl] = STATE(372),
    [sym_preproc_line] = STATE(372),
    [sym_preproc_if_in_expression] = STATE(2000),
    [sym_preproc_else_in_expression] = STATE(7392),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [aux_sym_preproc_if_in_expression_repeat1] = STATE(373),
    [sym_identifier] = ACTIONS(629),
    [anon_sym_return] = ACTIONS(633),
    [anon_sym_do] = ACTIONS(635),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(637),
    [anon_sym_null] = ACTIONS(641),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(643),
    [anon_sym_LBRACK_PIPE] = ACTIONS(645),
    [anon_sym_LBRACE] = ACTIONS(1713),
    [anon_sym_LT_AT] = ACTIONS(647),
    [anon_sym_LT_AT_AT] = ACTIONS(1715),
    [anon_sym_LBRACE_PIPE] = ACTIONS(653),
    [anon_sym_new] = ACTIONS(633),
    [anon_sym_return_BANG] = ACTIONS(655),
    [anon_sym_yield] = ACTIONS(633),
    [anon_sym_yield_BANG] = ACTIONS(655),
    [anon_sym_lazy] = ACTIONS(633),
    [anon_sym_assert] = ACTIONS(633),
    [anon_sym_upcast] = ACTIONS(633),
    [anon_sym_downcast] = ACTIONS(633),
    [anon_sym_for] = ACTIONS(659),
    [anon_sym_while] = ACTIONS(661),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(663),
    [anon_sym_try] = ACTIONS(665),
    [anon_sym_match] = ACTIONS(667),
    [anon_sym_match_BANG] = ACTIONS(669),
    [anon_sym_function] = ACTIONS(671),
    [anon_sym_use] = ACTIONS(679),
    [anon_sym_use_BANG] = ACTIONS(681),
    [anon_sym_do_BANG] = ACTIONS(683),
    [anon_sym_begin] = ACTIONS(685),
    [aux_sym_char_token1] = ACTIONS(689),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(691),
    [anon_sym_DQUOTE] = ACTIONS(693),
    [anon_sym_AT_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(697),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(699),
    [sym_bool] = ACTIONS(701),
    [sym_unit] = ACTIONS(1717),
    [anon_sym_LPAREN_PIPE] = ACTIONS(705),
    [sym_op_identifier] = ACTIONS(1719),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(709),
    [sym_xint] = ACTIONS(711),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(713),
    [anon_sym_POUNDendif] = ACTIONS(1733),
    [anon_sym_POUNDelse] = ACTIONS(1723),
    [sym__newline] = ACTIONS(1725),
  },
  [373] = {
    [sym_function_or_value_defn] = STATE(532),
    [sym__expression] = STATE(102),
    [sym_literal_expression] = STATE(2000),
    [sym_long_identifier_or_op] = STATE(2000),
    [sym_tuple_expression] = STATE(2000),
    [sym_brace_expression] = STATE(2000),
    [sym_anon_record_expression] = STATE(2000),
    [sym_prefixed_expression] = STATE(2000),
    [sym_typecast_expression] = STATE(2000),
    [sym_for_expression] = STATE(2000),
    [sym_while_expression] = STATE(2000),
    [sym__if_branch] = STATE(6707),
    [sym_if_expression] = STATE(2000),
    [sym_fun_expression] = STATE(2000),
    [sym_try_expression] = STATE(2000),
    [sym_match_expression] = STATE(2000),
    [sym_function_expression] = STATE(2000),
    [sym_mutate_expression] = STATE(2000),
    [sym_index_expression] = STATE(2000),
    [sym_typed_expression] = STATE(2000),
    [sym_declaration_expression] = STATE(2000),
    [sym_do_expression] = STATE(2000),
    [sym_list_expression] = STATE(2000),
    [sym_array_expression] = STATE(2000),
    [sym_begin_end_expression] = STATE(2000),
    [sym_paren_expression] = STATE(2000),
    [sym__high_prec_app] = STATE(2003),
    [sym__low_prec_app] = STATE(2003),
    [sym_application_expression] = STATE(2000),
    [sym_dot_expression] = STATE(2000),
    [sym_infix_expression] = STATE(2000),
    [sym_ce_expression] = STATE(2000),
    [sym_sequential_expression] = STATE(2000),
    [sym_char] = STATE(1801),
    [sym_format_string] = STATE(1804),
    [sym__string_literal] = STATE(1804),
    [sym_string] = STATE(1801),
    [sym_verbatim_string] = STATE(1801),
    [sym_bytearray] = STATE(1801),
    [sym_verbatim_bytearray] = STATE(1801),
    [sym_format_triple_quoted_string] = STATE(1807),
    [sym_triple_quoted_string] = STATE(1801),
    [sym_const] = STATE(2000),
    [sym_long_identifier] = STATE(1725),
    [sym_active_pattern] = STATE(1726),
    [sym__identifier_or_op] = STATE(1751),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(723),
    [sym_sbyte] = STATE(1801),
    [sym_byte] = STATE(1801),
    [sym_int16] = STATE(1801),
    [sym_uint16] = STATE(1801),
    [sym_int32] = STATE(1801),
    [sym_uint32] = STATE(1801),
    [sym_nativeint] = STATE(1801),
    [sym_unativeint] = STATE(1801),
    [sym_int64] = STATE(1801),
    [sym_uint64] = STATE(1801),
    [sym_ieee32] = STATE(1801),
    [sym_ieee64] = STATE(1801),
    [sym_bignum] = STATE(1801),
    [sym_decimal] = STATE(1801),
    [sym_float] = STATE(1427),
    [sym_block_comment] = STATE(373),
    [sym_compiler_directive_decl] = STATE(373),
    [sym_fsi_directive_decl] = STATE(373),
    [sym_preproc_line] = STATE(373),
    [sym_preproc_if_in_expression] = STATE(2000),
    [sym_preproc_else_in_expression] = STATE(7405),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [aux_sym_preproc_if_in_expression_repeat1] = STATE(416),
    [sym_identifier] = ACTIONS(629),
    [anon_sym_return] = ACTIONS(633),
    [anon_sym_do] = ACTIONS(635),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(637),
    [anon_sym_null] = ACTIONS(641),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(643),
    [anon_sym_LBRACK_PIPE] = ACTIONS(645),
    [anon_sym_LBRACE] = ACTIONS(1713),
    [anon_sym_LT_AT] = ACTIONS(647),
    [anon_sym_LT_AT_AT] = ACTIONS(1715),
    [anon_sym_LBRACE_PIPE] = ACTIONS(653),
    [anon_sym_new] = ACTIONS(633),
    [anon_sym_return_BANG] = ACTIONS(655),
    [anon_sym_yield] = ACTIONS(633),
    [anon_sym_yield_BANG] = ACTIONS(655),
    [anon_sym_lazy] = ACTIONS(633),
    [anon_sym_assert] = ACTIONS(633),
    [anon_sym_upcast] = ACTIONS(633),
    [anon_sym_downcast] = ACTIONS(633),
    [anon_sym_for] = ACTIONS(659),
    [anon_sym_while] = ACTIONS(661),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(663),
    [anon_sym_try] = ACTIONS(665),
    [anon_sym_match] = ACTIONS(667),
    [anon_sym_match_BANG] = ACTIONS(669),
    [anon_sym_function] = ACTIONS(671),
    [anon_sym_use] = ACTIONS(679),
    [anon_sym_use_BANG] = ACTIONS(681),
    [anon_sym_do_BANG] = ACTIONS(683),
    [anon_sym_begin] = ACTIONS(685),
    [aux_sym_char_token1] = ACTIONS(689),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(691),
    [anon_sym_DQUOTE] = ACTIONS(693),
    [anon_sym_AT_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(697),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(699),
    [sym_bool] = ACTIONS(701),
    [sym_unit] = ACTIONS(1717),
    [anon_sym_LPAREN_PIPE] = ACTIONS(705),
    [sym_op_identifier] = ACTIONS(1719),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(709),
    [sym_xint] = ACTIONS(711),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(713),
    [anon_sym_POUNDendif] = ACTIONS(1735),
    [anon_sym_POUNDelse] = ACTIONS(1723),
    [sym__newline] = ACTIONS(1725),
  },
  [374] = {
    [sym_function_or_value_defn] = STATE(532),
    [sym__expression] = STATE(102),
    [sym_literal_expression] = STATE(2000),
    [sym_long_identifier_or_op] = STATE(2000),
    [sym_tuple_expression] = STATE(2000),
    [sym_brace_expression] = STATE(2000),
    [sym_anon_record_expression] = STATE(2000),
    [sym_prefixed_expression] = STATE(2000),
    [sym_typecast_expression] = STATE(2000),
    [sym_for_expression] = STATE(2000),
    [sym_while_expression] = STATE(2000),
    [sym__if_branch] = STATE(6707),
    [sym_if_expression] = STATE(2000),
    [sym_fun_expression] = STATE(2000),
    [sym_try_expression] = STATE(2000),
    [sym_match_expression] = STATE(2000),
    [sym_function_expression] = STATE(2000),
    [sym_mutate_expression] = STATE(2000),
    [sym_index_expression] = STATE(2000),
    [sym_typed_expression] = STATE(2000),
    [sym_declaration_expression] = STATE(2000),
    [sym_do_expression] = STATE(2000),
    [sym_list_expression] = STATE(2000),
    [sym_array_expression] = STATE(2000),
    [sym_begin_end_expression] = STATE(2000),
    [sym_paren_expression] = STATE(2000),
    [sym__high_prec_app] = STATE(2003),
    [sym__low_prec_app] = STATE(2003),
    [sym_application_expression] = STATE(2000),
    [sym_dot_expression] = STATE(2000),
    [sym_infix_expression] = STATE(2000),
    [sym_ce_expression] = STATE(2000),
    [sym_sequential_expression] = STATE(2000),
    [sym_char] = STATE(1801),
    [sym_format_string] = STATE(1804),
    [sym__string_literal] = STATE(1804),
    [sym_string] = STATE(1801),
    [sym_verbatim_string] = STATE(1801),
    [sym_bytearray] = STATE(1801),
    [sym_verbatim_bytearray] = STATE(1801),
    [sym_format_triple_quoted_string] = STATE(1807),
    [sym_triple_quoted_string] = STATE(1801),
    [sym_const] = STATE(2000),
    [sym_long_identifier] = STATE(1725),
    [sym_active_pattern] = STATE(1726),
    [sym__identifier_or_op] = STATE(1751),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(723),
    [sym_sbyte] = STATE(1801),
    [sym_byte] = STATE(1801),
    [sym_int16] = STATE(1801),
    [sym_uint16] = STATE(1801),
    [sym_int32] = STATE(1801),
    [sym_uint32] = STATE(1801),
    [sym_nativeint] = STATE(1801),
    [sym_unativeint] = STATE(1801),
    [sym_int64] = STATE(1801),
    [sym_uint64] = STATE(1801),
    [sym_ieee32] = STATE(1801),
    [sym_ieee64] = STATE(1801),
    [sym_bignum] = STATE(1801),
    [sym_decimal] = STATE(1801),
    [sym_float] = STATE(1427),
    [sym_block_comment] = STATE(374),
    [sym_compiler_directive_decl] = STATE(374),
    [sym_fsi_directive_decl] = STATE(374),
    [sym_preproc_line] = STATE(374),
    [sym_preproc_if_in_expression] = STATE(2000),
    [sym_preproc_else_in_expression] = STATE(7070),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [aux_sym_preproc_if_in_expression_repeat1] = STATE(377),
    [sym_identifier] = ACTIONS(629),
    [anon_sym_return] = ACTIONS(633),
    [anon_sym_do] = ACTIONS(635),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(637),
    [anon_sym_null] = ACTIONS(641),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(643),
    [anon_sym_LBRACK_PIPE] = ACTIONS(645),
    [anon_sym_LBRACE] = ACTIONS(1713),
    [anon_sym_LT_AT] = ACTIONS(647),
    [anon_sym_LT_AT_AT] = ACTIONS(1715),
    [anon_sym_LBRACE_PIPE] = ACTIONS(653),
    [anon_sym_new] = ACTIONS(633),
    [anon_sym_return_BANG] = ACTIONS(655),
    [anon_sym_yield] = ACTIONS(633),
    [anon_sym_yield_BANG] = ACTIONS(655),
    [anon_sym_lazy] = ACTIONS(633),
    [anon_sym_assert] = ACTIONS(633),
    [anon_sym_upcast] = ACTIONS(633),
    [anon_sym_downcast] = ACTIONS(633),
    [anon_sym_for] = ACTIONS(659),
    [anon_sym_while] = ACTIONS(661),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(663),
    [anon_sym_try] = ACTIONS(665),
    [anon_sym_match] = ACTIONS(667),
    [anon_sym_match_BANG] = ACTIONS(669),
    [anon_sym_function] = ACTIONS(671),
    [anon_sym_use] = ACTIONS(679),
    [anon_sym_use_BANG] = ACTIONS(681),
    [anon_sym_do_BANG] = ACTIONS(683),
    [anon_sym_begin] = ACTIONS(685),
    [aux_sym_char_token1] = ACTIONS(689),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(691),
    [anon_sym_DQUOTE] = ACTIONS(693),
    [anon_sym_AT_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(697),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(699),
    [sym_bool] = ACTIONS(701),
    [sym_unit] = ACTIONS(1717),
    [anon_sym_LPAREN_PIPE] = ACTIONS(705),
    [sym_op_identifier] = ACTIONS(1719),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(709),
    [sym_xint] = ACTIONS(711),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(713),
    [anon_sym_POUNDendif] = ACTIONS(1737),
    [anon_sym_POUNDelse] = ACTIONS(1723),
    [sym__newline] = ACTIONS(1725),
  },
  [375] = {
    [sym_function_or_value_defn] = STATE(663),
    [sym__expression] = STATE(77),
    [sym_literal_expression] = STATE(1118),
    [sym_long_identifier_or_op] = STATE(1118),
    [sym_tuple_expression] = STATE(1118),
    [sym_brace_expression] = STATE(1118),
    [sym_anon_record_expression] = STATE(1118),
    [sym_prefixed_expression] = STATE(1118),
    [sym_typecast_expression] = STATE(1118),
    [sym_for_expression] = STATE(1118),
    [sym_while_expression] = STATE(1118),
    [sym__if_branch] = STATE(7163),
    [sym_if_expression] = STATE(1118),
    [sym_fun_expression] = STATE(1118),
    [sym_try_expression] = STATE(1118),
    [sym_match_expression] = STATE(1118),
    [sym_function_expression] = STATE(1118),
    [sym_mutate_expression] = STATE(1118),
    [sym_index_expression] = STATE(1118),
    [sym_typed_expression] = STATE(1118),
    [sym_declaration_expression] = STATE(1118),
    [sym_do_expression] = STATE(1118),
    [sym_list_expression] = STATE(1118),
    [sym_array_expression] = STATE(1118),
    [sym_begin_end_expression] = STATE(1118),
    [sym_paren_expression] = STATE(1118),
    [sym__high_prec_app] = STATE(1133),
    [sym__low_prec_app] = STATE(1133),
    [sym_application_expression] = STATE(1118),
    [sym_dot_expression] = STATE(1118),
    [sym_infix_expression] = STATE(1118),
    [sym_ce_expression] = STATE(1118),
    [sym_sequential_expression] = STATE(1118),
    [sym_slice_ranges] = STATE(7330),
    [sym__slice_range_special] = STATE(6328),
    [sym_slice_range] = STATE(5802),
    [sym_char] = STATE(1080),
    [sym_format_string] = STATE(1090),
    [sym__string_literal] = STATE(1090),
    [sym_string] = STATE(1080),
    [sym_verbatim_string] = STATE(1080),
    [sym_bytearray] = STATE(1080),
    [sym_verbatim_bytearray] = STATE(1080),
    [sym_format_triple_quoted_string] = STATE(1096),
    [sym_triple_quoted_string] = STATE(1080),
    [sym_const] = STATE(1118),
    [sym_long_identifier] = STATE(1156),
    [sym_active_pattern] = STATE(1085),
    [sym__identifier_or_op] = STATE(1099),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(548),
    [sym_sbyte] = STATE(1080),
    [sym_byte] = STATE(1080),
    [sym_int16] = STATE(1080),
    [sym_uint16] = STATE(1080),
    [sym_int32] = STATE(1080),
    [sym_uint32] = STATE(1080),
    [sym_nativeint] = STATE(1080),
    [sym_unativeint] = STATE(1080),
    [sym_int64] = STATE(1080),
    [sym_uint64] = STATE(1080),
    [sym_ieee32] = STATE(1080),
    [sym_ieee64] = STATE(1080),
    [sym_bignum] = STATE(1080),
    [sym_decimal] = STATE(1080),
    [sym_float] = STATE(979),
    [sym_block_comment] = STATE(375),
    [sym_compiler_directive_decl] = STATE(375),
    [sym_fsi_directive_decl] = STATE(375),
    [sym_preproc_line] = STATE(375),
    [sym_preproc_if_in_expression] = STATE(1118),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(195),
    [anon_sym_return] = ACTIONS(481),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_null] = ACTIONS(207),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(209),
    [anon_sym_LBRACK_PIPE] = ACTIONS(211),
    [anon_sym_LBRACE] = ACTIONS(1687),
    [anon_sym_LT_AT] = ACTIONS(213),
    [anon_sym_LT_AT_AT] = ACTIONS(1689),
    [anon_sym_LBRACE_PIPE] = ACTIONS(217),
    [anon_sym_new] = ACTIONS(481),
    [anon_sym_return_BANG] = ACTIONS(487),
    [anon_sym_yield] = ACTIONS(481),
    [anon_sym_yield_BANG] = ACTIONS(487),
    [anon_sym_lazy] = ACTIONS(481),
    [anon_sym_assert] = ACTIONS(481),
    [anon_sym_upcast] = ACTIONS(481),
    [anon_sym_downcast] = ACTIONS(481),
    [anon_sym_for] = ACTIONS(489),
    [anon_sym_while] = ACTIONS(225),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(229),
    [anon_sym_match] = ACTIONS(231),
    [anon_sym_match_BANG] = ACTIONS(233),
    [anon_sym_function] = ACTIONS(235),
    [anon_sym_use] = ACTIONS(493),
    [anon_sym_use_BANG] = ACTIONS(495),
    [anon_sym_do_BANG] = ACTIONS(243),
    [anon_sym_begin] = ACTIONS(245),
    [anon_sym_DOT_DOT3] = ACTIONS(1709),
    [anon_sym_STAR] = ACTIONS(1711),
    [aux_sym_char_token1] = ACTIONS(247),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(251),
    [anon_sym_AT_DQUOTE] = ACTIONS(253),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(255),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(257),
    [sym_bool] = ACTIONS(259),
    [sym_unit] = ACTIONS(1699),
    [anon_sym_LPAREN_PIPE] = ACTIONS(261),
    [sym_op_identifier] = ACTIONS(1701),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(499),
    [sym_xint] = ACTIONS(267),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(269),
  },
  [376] = {
    [sym_function_or_value_defn] = STATE(532),
    [sym__expression] = STATE(102),
    [sym_literal_expression] = STATE(2000),
    [sym_long_identifier_or_op] = STATE(2000),
    [sym_tuple_expression] = STATE(2000),
    [sym_brace_expression] = STATE(2000),
    [sym_anon_record_expression] = STATE(2000),
    [sym_prefixed_expression] = STATE(2000),
    [sym_typecast_expression] = STATE(2000),
    [sym_for_expression] = STATE(2000),
    [sym_while_expression] = STATE(2000),
    [sym__if_branch] = STATE(6707),
    [sym_if_expression] = STATE(2000),
    [sym_fun_expression] = STATE(2000),
    [sym_try_expression] = STATE(2000),
    [sym_match_expression] = STATE(2000),
    [sym_function_expression] = STATE(2000),
    [sym_mutate_expression] = STATE(2000),
    [sym_index_expression] = STATE(2000),
    [sym_typed_expression] = STATE(2000),
    [sym_declaration_expression] = STATE(2000),
    [sym_do_expression] = STATE(2000),
    [sym_list_expression] = STATE(2000),
    [sym_array_expression] = STATE(2000),
    [sym_begin_end_expression] = STATE(2000),
    [sym_paren_expression] = STATE(2000),
    [sym__high_prec_app] = STATE(2003),
    [sym__low_prec_app] = STATE(2003),
    [sym_application_expression] = STATE(2000),
    [sym_dot_expression] = STATE(2000),
    [sym_infix_expression] = STATE(2000),
    [sym_ce_expression] = STATE(2000),
    [sym_sequential_expression] = STATE(2000),
    [sym_char] = STATE(1801),
    [sym_format_string] = STATE(1804),
    [sym__string_literal] = STATE(1804),
    [sym_string] = STATE(1801),
    [sym_verbatim_string] = STATE(1801),
    [sym_bytearray] = STATE(1801),
    [sym_verbatim_bytearray] = STATE(1801),
    [sym_format_triple_quoted_string] = STATE(1807),
    [sym_triple_quoted_string] = STATE(1801),
    [sym_const] = STATE(2000),
    [sym_long_identifier] = STATE(1725),
    [sym_active_pattern] = STATE(1726),
    [sym__identifier_or_op] = STATE(1751),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(723),
    [sym_sbyte] = STATE(1801),
    [sym_byte] = STATE(1801),
    [sym_int16] = STATE(1801),
    [sym_uint16] = STATE(1801),
    [sym_int32] = STATE(1801),
    [sym_uint32] = STATE(1801),
    [sym_nativeint] = STATE(1801),
    [sym_unativeint] = STATE(1801),
    [sym_int64] = STATE(1801),
    [sym_uint64] = STATE(1801),
    [sym_ieee32] = STATE(1801),
    [sym_ieee64] = STATE(1801),
    [sym_bignum] = STATE(1801),
    [sym_decimal] = STATE(1801),
    [sym_float] = STATE(1427),
    [sym_block_comment] = STATE(376),
    [sym_compiler_directive_decl] = STATE(376),
    [sym_fsi_directive_decl] = STATE(376),
    [sym_preproc_line] = STATE(376),
    [sym_preproc_if_in_expression] = STATE(2000),
    [sym_preproc_else_in_expression] = STATE(6629),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [aux_sym_preproc_if_in_expression_repeat1] = STATE(378),
    [sym_identifier] = ACTIONS(629),
    [anon_sym_return] = ACTIONS(633),
    [anon_sym_do] = ACTIONS(635),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(637),
    [anon_sym_null] = ACTIONS(641),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(643),
    [anon_sym_LBRACK_PIPE] = ACTIONS(645),
    [anon_sym_LBRACE] = ACTIONS(1713),
    [anon_sym_LT_AT] = ACTIONS(647),
    [anon_sym_LT_AT_AT] = ACTIONS(1715),
    [anon_sym_LBRACE_PIPE] = ACTIONS(653),
    [anon_sym_new] = ACTIONS(633),
    [anon_sym_return_BANG] = ACTIONS(655),
    [anon_sym_yield] = ACTIONS(633),
    [anon_sym_yield_BANG] = ACTIONS(655),
    [anon_sym_lazy] = ACTIONS(633),
    [anon_sym_assert] = ACTIONS(633),
    [anon_sym_upcast] = ACTIONS(633),
    [anon_sym_downcast] = ACTIONS(633),
    [anon_sym_for] = ACTIONS(659),
    [anon_sym_while] = ACTIONS(661),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(663),
    [anon_sym_try] = ACTIONS(665),
    [anon_sym_match] = ACTIONS(667),
    [anon_sym_match_BANG] = ACTIONS(669),
    [anon_sym_function] = ACTIONS(671),
    [anon_sym_use] = ACTIONS(679),
    [anon_sym_use_BANG] = ACTIONS(681),
    [anon_sym_do_BANG] = ACTIONS(683),
    [anon_sym_begin] = ACTIONS(685),
    [aux_sym_char_token1] = ACTIONS(689),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(691),
    [anon_sym_DQUOTE] = ACTIONS(693),
    [anon_sym_AT_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(697),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(699),
    [sym_bool] = ACTIONS(701),
    [sym_unit] = ACTIONS(1717),
    [anon_sym_LPAREN_PIPE] = ACTIONS(705),
    [sym_op_identifier] = ACTIONS(1719),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(709),
    [sym_xint] = ACTIONS(711),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(713),
    [anon_sym_POUNDendif] = ACTIONS(1739),
    [anon_sym_POUNDelse] = ACTIONS(1723),
    [sym__newline] = ACTIONS(1725),
  },
  [377] = {
    [sym_function_or_value_defn] = STATE(532),
    [sym__expression] = STATE(102),
    [sym_literal_expression] = STATE(2000),
    [sym_long_identifier_or_op] = STATE(2000),
    [sym_tuple_expression] = STATE(2000),
    [sym_brace_expression] = STATE(2000),
    [sym_anon_record_expression] = STATE(2000),
    [sym_prefixed_expression] = STATE(2000),
    [sym_typecast_expression] = STATE(2000),
    [sym_for_expression] = STATE(2000),
    [sym_while_expression] = STATE(2000),
    [sym__if_branch] = STATE(6707),
    [sym_if_expression] = STATE(2000),
    [sym_fun_expression] = STATE(2000),
    [sym_try_expression] = STATE(2000),
    [sym_match_expression] = STATE(2000),
    [sym_function_expression] = STATE(2000),
    [sym_mutate_expression] = STATE(2000),
    [sym_index_expression] = STATE(2000),
    [sym_typed_expression] = STATE(2000),
    [sym_declaration_expression] = STATE(2000),
    [sym_do_expression] = STATE(2000),
    [sym_list_expression] = STATE(2000),
    [sym_array_expression] = STATE(2000),
    [sym_begin_end_expression] = STATE(2000),
    [sym_paren_expression] = STATE(2000),
    [sym__high_prec_app] = STATE(2003),
    [sym__low_prec_app] = STATE(2003),
    [sym_application_expression] = STATE(2000),
    [sym_dot_expression] = STATE(2000),
    [sym_infix_expression] = STATE(2000),
    [sym_ce_expression] = STATE(2000),
    [sym_sequential_expression] = STATE(2000),
    [sym_char] = STATE(1801),
    [sym_format_string] = STATE(1804),
    [sym__string_literal] = STATE(1804),
    [sym_string] = STATE(1801),
    [sym_verbatim_string] = STATE(1801),
    [sym_bytearray] = STATE(1801),
    [sym_verbatim_bytearray] = STATE(1801),
    [sym_format_triple_quoted_string] = STATE(1807),
    [sym_triple_quoted_string] = STATE(1801),
    [sym_const] = STATE(2000),
    [sym_long_identifier] = STATE(1725),
    [sym_active_pattern] = STATE(1726),
    [sym__identifier_or_op] = STATE(1751),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(723),
    [sym_sbyte] = STATE(1801),
    [sym_byte] = STATE(1801),
    [sym_int16] = STATE(1801),
    [sym_uint16] = STATE(1801),
    [sym_int32] = STATE(1801),
    [sym_uint32] = STATE(1801),
    [sym_nativeint] = STATE(1801),
    [sym_unativeint] = STATE(1801),
    [sym_int64] = STATE(1801),
    [sym_uint64] = STATE(1801),
    [sym_ieee32] = STATE(1801),
    [sym_ieee64] = STATE(1801),
    [sym_bignum] = STATE(1801),
    [sym_decimal] = STATE(1801),
    [sym_float] = STATE(1427),
    [sym_block_comment] = STATE(377),
    [sym_compiler_directive_decl] = STATE(377),
    [sym_fsi_directive_decl] = STATE(377),
    [sym_preproc_line] = STATE(377),
    [sym_preproc_if_in_expression] = STATE(2000),
    [sym_preproc_else_in_expression] = STATE(7058),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [aux_sym_preproc_if_in_expression_repeat1] = STATE(416),
    [sym_identifier] = ACTIONS(629),
    [anon_sym_return] = ACTIONS(633),
    [anon_sym_do] = ACTIONS(635),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(637),
    [anon_sym_null] = ACTIONS(641),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(643),
    [anon_sym_LBRACK_PIPE] = ACTIONS(645),
    [anon_sym_LBRACE] = ACTIONS(1713),
    [anon_sym_LT_AT] = ACTIONS(647),
    [anon_sym_LT_AT_AT] = ACTIONS(1715),
    [anon_sym_LBRACE_PIPE] = ACTIONS(653),
    [anon_sym_new] = ACTIONS(633),
    [anon_sym_return_BANG] = ACTIONS(655),
    [anon_sym_yield] = ACTIONS(633),
    [anon_sym_yield_BANG] = ACTIONS(655),
    [anon_sym_lazy] = ACTIONS(633),
    [anon_sym_assert] = ACTIONS(633),
    [anon_sym_upcast] = ACTIONS(633),
    [anon_sym_downcast] = ACTIONS(633),
    [anon_sym_for] = ACTIONS(659),
    [anon_sym_while] = ACTIONS(661),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(663),
    [anon_sym_try] = ACTIONS(665),
    [anon_sym_match] = ACTIONS(667),
    [anon_sym_match_BANG] = ACTIONS(669),
    [anon_sym_function] = ACTIONS(671),
    [anon_sym_use] = ACTIONS(679),
    [anon_sym_use_BANG] = ACTIONS(681),
    [anon_sym_do_BANG] = ACTIONS(683),
    [anon_sym_begin] = ACTIONS(685),
    [aux_sym_char_token1] = ACTIONS(689),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(691),
    [anon_sym_DQUOTE] = ACTIONS(693),
    [anon_sym_AT_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(697),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(699),
    [sym_bool] = ACTIONS(701),
    [sym_unit] = ACTIONS(1717),
    [anon_sym_LPAREN_PIPE] = ACTIONS(705),
    [sym_op_identifier] = ACTIONS(1719),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(709),
    [sym_xint] = ACTIONS(711),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(713),
    [anon_sym_POUNDendif] = ACTIONS(1741),
    [anon_sym_POUNDelse] = ACTIONS(1723),
    [sym__newline] = ACTIONS(1725),
  },
  [378] = {
    [sym_function_or_value_defn] = STATE(532),
    [sym__expression] = STATE(102),
    [sym_literal_expression] = STATE(2000),
    [sym_long_identifier_or_op] = STATE(2000),
    [sym_tuple_expression] = STATE(2000),
    [sym_brace_expression] = STATE(2000),
    [sym_anon_record_expression] = STATE(2000),
    [sym_prefixed_expression] = STATE(2000),
    [sym_typecast_expression] = STATE(2000),
    [sym_for_expression] = STATE(2000),
    [sym_while_expression] = STATE(2000),
    [sym__if_branch] = STATE(6707),
    [sym_if_expression] = STATE(2000),
    [sym_fun_expression] = STATE(2000),
    [sym_try_expression] = STATE(2000),
    [sym_match_expression] = STATE(2000),
    [sym_function_expression] = STATE(2000),
    [sym_mutate_expression] = STATE(2000),
    [sym_index_expression] = STATE(2000),
    [sym_typed_expression] = STATE(2000),
    [sym_declaration_expression] = STATE(2000),
    [sym_do_expression] = STATE(2000),
    [sym_list_expression] = STATE(2000),
    [sym_array_expression] = STATE(2000),
    [sym_begin_end_expression] = STATE(2000),
    [sym_paren_expression] = STATE(2000),
    [sym__high_prec_app] = STATE(2003),
    [sym__low_prec_app] = STATE(2003),
    [sym_application_expression] = STATE(2000),
    [sym_dot_expression] = STATE(2000),
    [sym_infix_expression] = STATE(2000),
    [sym_ce_expression] = STATE(2000),
    [sym_sequential_expression] = STATE(2000),
    [sym_char] = STATE(1801),
    [sym_format_string] = STATE(1804),
    [sym__string_literal] = STATE(1804),
    [sym_string] = STATE(1801),
    [sym_verbatim_string] = STATE(1801),
    [sym_bytearray] = STATE(1801),
    [sym_verbatim_bytearray] = STATE(1801),
    [sym_format_triple_quoted_string] = STATE(1807),
    [sym_triple_quoted_string] = STATE(1801),
    [sym_const] = STATE(2000),
    [sym_long_identifier] = STATE(1725),
    [sym_active_pattern] = STATE(1726),
    [sym__identifier_or_op] = STATE(1751),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(723),
    [sym_sbyte] = STATE(1801),
    [sym_byte] = STATE(1801),
    [sym_int16] = STATE(1801),
    [sym_uint16] = STATE(1801),
    [sym_int32] = STATE(1801),
    [sym_uint32] = STATE(1801),
    [sym_nativeint] = STATE(1801),
    [sym_unativeint] = STATE(1801),
    [sym_int64] = STATE(1801),
    [sym_uint64] = STATE(1801),
    [sym_ieee32] = STATE(1801),
    [sym_ieee64] = STATE(1801),
    [sym_bignum] = STATE(1801),
    [sym_decimal] = STATE(1801),
    [sym_float] = STATE(1427),
    [sym_block_comment] = STATE(378),
    [sym_compiler_directive_decl] = STATE(378),
    [sym_fsi_directive_decl] = STATE(378),
    [sym_preproc_line] = STATE(378),
    [sym_preproc_if_in_expression] = STATE(2000),
    [sym_preproc_else_in_expression] = STATE(6635),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [aux_sym_preproc_if_in_expression_repeat1] = STATE(416),
    [sym_identifier] = ACTIONS(629),
    [anon_sym_return] = ACTIONS(633),
    [anon_sym_do] = ACTIONS(635),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(637),
    [anon_sym_null] = ACTIONS(641),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(643),
    [anon_sym_LBRACK_PIPE] = ACTIONS(645),
    [anon_sym_LBRACE] = ACTIONS(1713),
    [anon_sym_LT_AT] = ACTIONS(647),
    [anon_sym_LT_AT_AT] = ACTIONS(1715),
    [anon_sym_LBRACE_PIPE] = ACTIONS(653),
    [anon_sym_new] = ACTIONS(633),
    [anon_sym_return_BANG] = ACTIONS(655),
    [anon_sym_yield] = ACTIONS(633),
    [anon_sym_yield_BANG] = ACTIONS(655),
    [anon_sym_lazy] = ACTIONS(633),
    [anon_sym_assert] = ACTIONS(633),
    [anon_sym_upcast] = ACTIONS(633),
    [anon_sym_downcast] = ACTIONS(633),
    [anon_sym_for] = ACTIONS(659),
    [anon_sym_while] = ACTIONS(661),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(663),
    [anon_sym_try] = ACTIONS(665),
    [anon_sym_match] = ACTIONS(667),
    [anon_sym_match_BANG] = ACTIONS(669),
    [anon_sym_function] = ACTIONS(671),
    [anon_sym_use] = ACTIONS(679),
    [anon_sym_use_BANG] = ACTIONS(681),
    [anon_sym_do_BANG] = ACTIONS(683),
    [anon_sym_begin] = ACTIONS(685),
    [aux_sym_char_token1] = ACTIONS(689),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(691),
    [anon_sym_DQUOTE] = ACTIONS(693),
    [anon_sym_AT_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(697),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(699),
    [sym_bool] = ACTIONS(701),
    [sym_unit] = ACTIONS(1717),
    [anon_sym_LPAREN_PIPE] = ACTIONS(705),
    [sym_op_identifier] = ACTIONS(1719),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(709),
    [sym_xint] = ACTIONS(711),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(713),
    [anon_sym_POUNDendif] = ACTIONS(1743),
    [anon_sym_POUNDelse] = ACTIONS(1723),
    [sym__newline] = ACTIONS(1725),
  },
  [379] = {
    [sym_function_or_value_defn] = STATE(663),
    [sym__expression] = STATE(104),
    [sym_literal_expression] = STATE(1118),
    [sym_long_identifier_or_op] = STATE(1118),
    [sym_tuple_expression] = STATE(1118),
    [sym_brace_expression] = STATE(1118),
    [sym_anon_record_expression] = STATE(1118),
    [sym_prefixed_expression] = STATE(1118),
    [sym_typecast_expression] = STATE(1118),
    [sym_for_expression] = STATE(1118),
    [sym_while_expression] = STATE(1118),
    [sym__if_branch] = STATE(7163),
    [sym_if_expression] = STATE(1118),
    [sym_fun_expression] = STATE(1118),
    [sym_try_expression] = STATE(1118),
    [sym_match_expression] = STATE(1118),
    [sym_function_expression] = STATE(1118),
    [sym_mutate_expression] = STATE(1118),
    [sym_index_expression] = STATE(1118),
    [sym_typed_expression] = STATE(1118),
    [sym_declaration_expression] = STATE(1118),
    [sym_do_expression] = STATE(1118),
    [sym_list_expression] = STATE(1118),
    [sym_array_expression] = STATE(1118),
    [sym_begin_end_expression] = STATE(1118),
    [sym_paren_expression] = STATE(1118),
    [sym__high_prec_app] = STATE(1133),
    [sym__low_prec_app] = STATE(1133),
    [sym_application_expression] = STATE(1118),
    [sym_dot_expression] = STATE(1118),
    [sym_infix_expression] = STATE(1118),
    [sym_ce_expression] = STATE(1118),
    [sym_sequential_expression] = STATE(1118),
    [sym_slice_ranges] = STATE(7104),
    [sym__slice_range_special] = STATE(6328),
    [sym_slice_range] = STATE(5802),
    [sym_char] = STATE(1080),
    [sym_format_string] = STATE(1090),
    [sym__string_literal] = STATE(1090),
    [sym_string] = STATE(1080),
    [sym_verbatim_string] = STATE(1080),
    [sym_bytearray] = STATE(1080),
    [sym_verbatim_bytearray] = STATE(1080),
    [sym_format_triple_quoted_string] = STATE(1096),
    [sym_triple_quoted_string] = STATE(1080),
    [sym_const] = STATE(1118),
    [sym_long_identifier] = STATE(1156),
    [sym_active_pattern] = STATE(1085),
    [sym__identifier_or_op] = STATE(1099),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(548),
    [sym_sbyte] = STATE(1080),
    [sym_byte] = STATE(1080),
    [sym_int16] = STATE(1080),
    [sym_uint16] = STATE(1080),
    [sym_int32] = STATE(1080),
    [sym_uint32] = STATE(1080),
    [sym_nativeint] = STATE(1080),
    [sym_unativeint] = STATE(1080),
    [sym_int64] = STATE(1080),
    [sym_uint64] = STATE(1080),
    [sym_ieee32] = STATE(1080),
    [sym_ieee64] = STATE(1080),
    [sym_bignum] = STATE(1080),
    [sym_decimal] = STATE(1080),
    [sym_float] = STATE(979),
    [sym_block_comment] = STATE(379),
    [sym_compiler_directive_decl] = STATE(379),
    [sym_fsi_directive_decl] = STATE(379),
    [sym_preproc_line] = STATE(379),
    [sym_preproc_if_in_expression] = STATE(1118),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(195),
    [anon_sym_return] = ACTIONS(481),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_null] = ACTIONS(207),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(209),
    [anon_sym_LBRACK_PIPE] = ACTIONS(211),
    [anon_sym_LBRACE] = ACTIONS(1687),
    [anon_sym_LT_AT] = ACTIONS(213),
    [anon_sym_LT_AT_AT] = ACTIONS(1689),
    [anon_sym_LBRACE_PIPE] = ACTIONS(217),
    [anon_sym_new] = ACTIONS(481),
    [anon_sym_return_BANG] = ACTIONS(487),
    [anon_sym_yield] = ACTIONS(481),
    [anon_sym_yield_BANG] = ACTIONS(487),
    [anon_sym_lazy] = ACTIONS(481),
    [anon_sym_assert] = ACTIONS(481),
    [anon_sym_upcast] = ACTIONS(481),
    [anon_sym_downcast] = ACTIONS(481),
    [anon_sym_for] = ACTIONS(489),
    [anon_sym_while] = ACTIONS(225),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(229),
    [anon_sym_match] = ACTIONS(231),
    [anon_sym_match_BANG] = ACTIONS(233),
    [anon_sym_function] = ACTIONS(235),
    [anon_sym_use] = ACTIONS(493),
    [anon_sym_use_BANG] = ACTIONS(495),
    [anon_sym_do_BANG] = ACTIONS(243),
    [anon_sym_begin] = ACTIONS(245),
    [anon_sym_DOT_DOT3] = ACTIONS(1709),
    [anon_sym_STAR] = ACTIONS(1711),
    [aux_sym_char_token1] = ACTIONS(247),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(251),
    [anon_sym_AT_DQUOTE] = ACTIONS(253),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(255),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(257),
    [sym_bool] = ACTIONS(259),
    [sym_unit] = ACTIONS(1699),
    [anon_sym_LPAREN_PIPE] = ACTIONS(261),
    [sym_op_identifier] = ACTIONS(1701),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(499),
    [sym_xint] = ACTIONS(267),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(269),
  },
  [380] = {
    [sym_function_or_value_defn] = STATE(663),
    [sym__expression] = STATE(36),
    [sym_literal_expression] = STATE(1118),
    [sym_long_identifier_or_op] = STATE(1118),
    [sym_tuple_expression] = STATE(1118),
    [sym_brace_expression] = STATE(1118),
    [sym_anon_record_expression] = STATE(1118),
    [sym_prefixed_expression] = STATE(1118),
    [sym_typecast_expression] = STATE(1118),
    [sym_for_expression] = STATE(1118),
    [sym_while_expression] = STATE(1118),
    [sym__if_branch] = STATE(7163),
    [sym_if_expression] = STATE(1118),
    [sym_fun_expression] = STATE(1118),
    [sym_try_expression] = STATE(1118),
    [sym_match_expression] = STATE(1118),
    [sym_function_expression] = STATE(1118),
    [sym_mutate_expression] = STATE(1118),
    [sym_index_expression] = STATE(1118),
    [sym_typed_expression] = STATE(1118),
    [sym_declaration_expression] = STATE(1118),
    [sym_do_expression] = STATE(1118),
    [sym_list_expression] = STATE(1118),
    [sym_array_expression] = STATE(1118),
    [sym_begin_end_expression] = STATE(1118),
    [sym_paren_expression] = STATE(1118),
    [sym__high_prec_app] = STATE(1133),
    [sym__low_prec_app] = STATE(1133),
    [sym_application_expression] = STATE(1118),
    [sym_dot_expression] = STATE(1118),
    [sym_infix_expression] = STATE(1118),
    [sym_ce_expression] = STATE(1118),
    [sym_sequential_expression] = STATE(1118),
    [sym_slice_ranges] = STATE(6736),
    [sym__slice_range_special] = STATE(6328),
    [sym_slice_range] = STATE(5802),
    [sym_char] = STATE(1080),
    [sym_format_string] = STATE(1090),
    [sym__string_literal] = STATE(1090),
    [sym_string] = STATE(1080),
    [sym_verbatim_string] = STATE(1080),
    [sym_bytearray] = STATE(1080),
    [sym_verbatim_bytearray] = STATE(1080),
    [sym_format_triple_quoted_string] = STATE(1096),
    [sym_triple_quoted_string] = STATE(1080),
    [sym_const] = STATE(1118),
    [sym_long_identifier] = STATE(1156),
    [sym_active_pattern] = STATE(1085),
    [sym__identifier_or_op] = STATE(1099),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(548),
    [sym_sbyte] = STATE(1080),
    [sym_byte] = STATE(1080),
    [sym_int16] = STATE(1080),
    [sym_uint16] = STATE(1080),
    [sym_int32] = STATE(1080),
    [sym_uint32] = STATE(1080),
    [sym_nativeint] = STATE(1080),
    [sym_unativeint] = STATE(1080),
    [sym_int64] = STATE(1080),
    [sym_uint64] = STATE(1080),
    [sym_ieee32] = STATE(1080),
    [sym_ieee64] = STATE(1080),
    [sym_bignum] = STATE(1080),
    [sym_decimal] = STATE(1080),
    [sym_float] = STATE(979),
    [sym_block_comment] = STATE(380),
    [sym_compiler_directive_decl] = STATE(380),
    [sym_fsi_directive_decl] = STATE(380),
    [sym_preproc_line] = STATE(380),
    [sym_preproc_if_in_expression] = STATE(1118),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(195),
    [anon_sym_return] = ACTIONS(481),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_null] = ACTIONS(207),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(209),
    [anon_sym_LBRACK_PIPE] = ACTIONS(211),
    [anon_sym_LBRACE] = ACTIONS(1687),
    [anon_sym_LT_AT] = ACTIONS(213),
    [anon_sym_LT_AT_AT] = ACTIONS(1689),
    [anon_sym_LBRACE_PIPE] = ACTIONS(217),
    [anon_sym_new] = ACTIONS(481),
    [anon_sym_return_BANG] = ACTIONS(487),
    [anon_sym_yield] = ACTIONS(481),
    [anon_sym_yield_BANG] = ACTIONS(487),
    [anon_sym_lazy] = ACTIONS(481),
    [anon_sym_assert] = ACTIONS(481),
    [anon_sym_upcast] = ACTIONS(481),
    [anon_sym_downcast] = ACTIONS(481),
    [anon_sym_for] = ACTIONS(489),
    [anon_sym_while] = ACTIONS(225),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(229),
    [anon_sym_match] = ACTIONS(231),
    [anon_sym_match_BANG] = ACTIONS(233),
    [anon_sym_function] = ACTIONS(235),
    [anon_sym_use] = ACTIONS(493),
    [anon_sym_use_BANG] = ACTIONS(495),
    [anon_sym_do_BANG] = ACTIONS(243),
    [anon_sym_begin] = ACTIONS(245),
    [anon_sym_DOT_DOT3] = ACTIONS(1709),
    [anon_sym_STAR] = ACTIONS(1711),
    [aux_sym_char_token1] = ACTIONS(247),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(251),
    [anon_sym_AT_DQUOTE] = ACTIONS(253),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(255),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(257),
    [sym_bool] = ACTIONS(259),
    [sym_unit] = ACTIONS(1699),
    [anon_sym_LPAREN_PIPE] = ACTIONS(261),
    [sym_op_identifier] = ACTIONS(1701),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(499),
    [sym_xint] = ACTIONS(267),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(269),
  },
  [381] = {
    [sym_function_or_value_defn] = STATE(663),
    [sym__expression] = STATE(45),
    [sym_literal_expression] = STATE(1118),
    [sym_long_identifier_or_op] = STATE(1118),
    [sym_tuple_expression] = STATE(1118),
    [sym_brace_expression] = STATE(1118),
    [sym_anon_record_expression] = STATE(1118),
    [sym_prefixed_expression] = STATE(1118),
    [sym_typecast_expression] = STATE(1118),
    [sym_for_expression] = STATE(1118),
    [sym_while_expression] = STATE(1118),
    [sym__if_branch] = STATE(7163),
    [sym_if_expression] = STATE(1118),
    [sym_fun_expression] = STATE(1118),
    [sym_try_expression] = STATE(1118),
    [sym_match_expression] = STATE(1118),
    [sym_function_expression] = STATE(1118),
    [sym_mutate_expression] = STATE(1118),
    [sym_index_expression] = STATE(1118),
    [sym_typed_expression] = STATE(1118),
    [sym_declaration_expression] = STATE(1118),
    [sym_do_expression] = STATE(1118),
    [sym_list_expression] = STATE(1118),
    [sym_array_expression] = STATE(1118),
    [sym_begin_end_expression] = STATE(1118),
    [sym_paren_expression] = STATE(1118),
    [sym__high_prec_app] = STATE(1133),
    [sym__low_prec_app] = STATE(1133),
    [sym_application_expression] = STATE(1118),
    [sym_dot_expression] = STATE(1118),
    [sym_infix_expression] = STATE(1118),
    [sym_ce_expression] = STATE(1118),
    [sym_sequential_expression] = STATE(1118),
    [sym_slice_ranges] = STATE(6497),
    [sym__slice_range_special] = STATE(6328),
    [sym_slice_range] = STATE(5802),
    [sym_char] = STATE(1080),
    [sym_format_string] = STATE(1090),
    [sym__string_literal] = STATE(1090),
    [sym_string] = STATE(1080),
    [sym_verbatim_string] = STATE(1080),
    [sym_bytearray] = STATE(1080),
    [sym_verbatim_bytearray] = STATE(1080),
    [sym_format_triple_quoted_string] = STATE(1096),
    [sym_triple_quoted_string] = STATE(1080),
    [sym_const] = STATE(1118),
    [sym_long_identifier] = STATE(1156),
    [sym_active_pattern] = STATE(1085),
    [sym__identifier_or_op] = STATE(1099),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(548),
    [sym_sbyte] = STATE(1080),
    [sym_byte] = STATE(1080),
    [sym_int16] = STATE(1080),
    [sym_uint16] = STATE(1080),
    [sym_int32] = STATE(1080),
    [sym_uint32] = STATE(1080),
    [sym_nativeint] = STATE(1080),
    [sym_unativeint] = STATE(1080),
    [sym_int64] = STATE(1080),
    [sym_uint64] = STATE(1080),
    [sym_ieee32] = STATE(1080),
    [sym_ieee64] = STATE(1080),
    [sym_bignum] = STATE(1080),
    [sym_decimal] = STATE(1080),
    [sym_float] = STATE(979),
    [sym_block_comment] = STATE(381),
    [sym_compiler_directive_decl] = STATE(381),
    [sym_fsi_directive_decl] = STATE(381),
    [sym_preproc_line] = STATE(381),
    [sym_preproc_if_in_expression] = STATE(1118),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(195),
    [anon_sym_return] = ACTIONS(481),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_null] = ACTIONS(207),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(209),
    [anon_sym_LBRACK_PIPE] = ACTIONS(211),
    [anon_sym_LBRACE] = ACTIONS(1687),
    [anon_sym_LT_AT] = ACTIONS(213),
    [anon_sym_LT_AT_AT] = ACTIONS(1689),
    [anon_sym_LBRACE_PIPE] = ACTIONS(217),
    [anon_sym_new] = ACTIONS(481),
    [anon_sym_return_BANG] = ACTIONS(487),
    [anon_sym_yield] = ACTIONS(481),
    [anon_sym_yield_BANG] = ACTIONS(487),
    [anon_sym_lazy] = ACTIONS(481),
    [anon_sym_assert] = ACTIONS(481),
    [anon_sym_upcast] = ACTIONS(481),
    [anon_sym_downcast] = ACTIONS(481),
    [anon_sym_for] = ACTIONS(489),
    [anon_sym_while] = ACTIONS(225),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(229),
    [anon_sym_match] = ACTIONS(231),
    [anon_sym_match_BANG] = ACTIONS(233),
    [anon_sym_function] = ACTIONS(235),
    [anon_sym_use] = ACTIONS(493),
    [anon_sym_use_BANG] = ACTIONS(495),
    [anon_sym_do_BANG] = ACTIONS(243),
    [anon_sym_begin] = ACTIONS(245),
    [anon_sym_DOT_DOT3] = ACTIONS(1709),
    [anon_sym_STAR] = ACTIONS(1711),
    [aux_sym_char_token1] = ACTIONS(247),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(251),
    [anon_sym_AT_DQUOTE] = ACTIONS(253),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(255),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(257),
    [sym_bool] = ACTIONS(259),
    [sym_unit] = ACTIONS(1699),
    [anon_sym_LPAREN_PIPE] = ACTIONS(261),
    [sym_op_identifier] = ACTIONS(1701),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(499),
    [sym_xint] = ACTIONS(267),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(269),
  },
  [382] = {
    [sym_function_or_value_defn] = STATE(663),
    [sym__expression] = STATE(34),
    [sym_literal_expression] = STATE(1118),
    [sym_long_identifier_or_op] = STATE(1118),
    [sym_tuple_expression] = STATE(1118),
    [sym_brace_expression] = STATE(1118),
    [sym_anon_record_expression] = STATE(1118),
    [sym_prefixed_expression] = STATE(1118),
    [sym_typecast_expression] = STATE(1118),
    [sym_for_expression] = STATE(1118),
    [sym_while_expression] = STATE(1118),
    [sym__if_branch] = STATE(7163),
    [sym_if_expression] = STATE(1118),
    [sym_fun_expression] = STATE(1118),
    [sym_try_expression] = STATE(1118),
    [sym_match_expression] = STATE(1118),
    [sym_function_expression] = STATE(1118),
    [sym_mutate_expression] = STATE(1118),
    [sym_index_expression] = STATE(1118),
    [sym_typed_expression] = STATE(1118),
    [sym_declaration_expression] = STATE(1118),
    [sym_do_expression] = STATE(1118),
    [sym_list_expression] = STATE(1118),
    [sym_array_expression] = STATE(1118),
    [sym_begin_end_expression] = STATE(1118),
    [sym_paren_expression] = STATE(1118),
    [sym__high_prec_app] = STATE(1133),
    [sym__low_prec_app] = STATE(1133),
    [sym_application_expression] = STATE(1118),
    [sym_dot_expression] = STATE(1118),
    [sym_infix_expression] = STATE(1118),
    [sym_ce_expression] = STATE(1118),
    [sym_sequential_expression] = STATE(1118),
    [sym_slice_ranges] = STATE(6922),
    [sym__slice_range_special] = STATE(6328),
    [sym_slice_range] = STATE(5802),
    [sym_char] = STATE(1080),
    [sym_format_string] = STATE(1090),
    [sym__string_literal] = STATE(1090),
    [sym_string] = STATE(1080),
    [sym_verbatim_string] = STATE(1080),
    [sym_bytearray] = STATE(1080),
    [sym_verbatim_bytearray] = STATE(1080),
    [sym_format_triple_quoted_string] = STATE(1096),
    [sym_triple_quoted_string] = STATE(1080),
    [sym_const] = STATE(1118),
    [sym_long_identifier] = STATE(1156),
    [sym_active_pattern] = STATE(1085),
    [sym__identifier_or_op] = STATE(1099),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(548),
    [sym_sbyte] = STATE(1080),
    [sym_byte] = STATE(1080),
    [sym_int16] = STATE(1080),
    [sym_uint16] = STATE(1080),
    [sym_int32] = STATE(1080),
    [sym_uint32] = STATE(1080),
    [sym_nativeint] = STATE(1080),
    [sym_unativeint] = STATE(1080),
    [sym_int64] = STATE(1080),
    [sym_uint64] = STATE(1080),
    [sym_ieee32] = STATE(1080),
    [sym_ieee64] = STATE(1080),
    [sym_bignum] = STATE(1080),
    [sym_decimal] = STATE(1080),
    [sym_float] = STATE(979),
    [sym_block_comment] = STATE(382),
    [sym_compiler_directive_decl] = STATE(382),
    [sym_fsi_directive_decl] = STATE(382),
    [sym_preproc_line] = STATE(382),
    [sym_preproc_if_in_expression] = STATE(1118),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(195),
    [anon_sym_return] = ACTIONS(481),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_null] = ACTIONS(207),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(209),
    [anon_sym_LBRACK_PIPE] = ACTIONS(211),
    [anon_sym_LBRACE] = ACTIONS(1687),
    [anon_sym_LT_AT] = ACTIONS(213),
    [anon_sym_LT_AT_AT] = ACTIONS(1689),
    [anon_sym_LBRACE_PIPE] = ACTIONS(217),
    [anon_sym_new] = ACTIONS(481),
    [anon_sym_return_BANG] = ACTIONS(487),
    [anon_sym_yield] = ACTIONS(481),
    [anon_sym_yield_BANG] = ACTIONS(487),
    [anon_sym_lazy] = ACTIONS(481),
    [anon_sym_assert] = ACTIONS(481),
    [anon_sym_upcast] = ACTIONS(481),
    [anon_sym_downcast] = ACTIONS(481),
    [anon_sym_for] = ACTIONS(489),
    [anon_sym_while] = ACTIONS(225),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(229),
    [anon_sym_match] = ACTIONS(231),
    [anon_sym_match_BANG] = ACTIONS(233),
    [anon_sym_function] = ACTIONS(235),
    [anon_sym_use] = ACTIONS(493),
    [anon_sym_use_BANG] = ACTIONS(495),
    [anon_sym_do_BANG] = ACTIONS(243),
    [anon_sym_begin] = ACTIONS(245),
    [anon_sym_DOT_DOT3] = ACTIONS(1709),
    [anon_sym_STAR] = ACTIONS(1711),
    [aux_sym_char_token1] = ACTIONS(247),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(251),
    [anon_sym_AT_DQUOTE] = ACTIONS(253),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(255),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(257),
    [sym_bool] = ACTIONS(259),
    [sym_unit] = ACTIONS(1699),
    [anon_sym_LPAREN_PIPE] = ACTIONS(261),
    [sym_op_identifier] = ACTIONS(1701),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(499),
    [sym_xint] = ACTIONS(267),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(269),
  },
  [383] = {
    [sym_function_or_value_defn] = STATE(532),
    [sym__expression] = STATE(102),
    [sym_literal_expression] = STATE(2000),
    [sym_long_identifier_or_op] = STATE(2000),
    [sym_tuple_expression] = STATE(2000),
    [sym_brace_expression] = STATE(2000),
    [sym_anon_record_expression] = STATE(2000),
    [sym_prefixed_expression] = STATE(2000),
    [sym_typecast_expression] = STATE(2000),
    [sym_for_expression] = STATE(2000),
    [sym_while_expression] = STATE(2000),
    [sym__if_branch] = STATE(6707),
    [sym_if_expression] = STATE(2000),
    [sym_fun_expression] = STATE(2000),
    [sym_try_expression] = STATE(2000),
    [sym_match_expression] = STATE(2000),
    [sym_function_expression] = STATE(2000),
    [sym_mutate_expression] = STATE(2000),
    [sym_index_expression] = STATE(2000),
    [sym_typed_expression] = STATE(2000),
    [sym_declaration_expression] = STATE(2000),
    [sym_do_expression] = STATE(2000),
    [sym_list_expression] = STATE(2000),
    [sym_array_expression] = STATE(2000),
    [sym_begin_end_expression] = STATE(2000),
    [sym_paren_expression] = STATE(2000),
    [sym__high_prec_app] = STATE(2003),
    [sym__low_prec_app] = STATE(2003),
    [sym_application_expression] = STATE(2000),
    [sym_dot_expression] = STATE(2000),
    [sym_infix_expression] = STATE(2000),
    [sym_ce_expression] = STATE(2000),
    [sym_sequential_expression] = STATE(2000),
    [sym_char] = STATE(1801),
    [sym_format_string] = STATE(1804),
    [sym__string_literal] = STATE(1804),
    [sym_string] = STATE(1801),
    [sym_verbatim_string] = STATE(1801),
    [sym_bytearray] = STATE(1801),
    [sym_verbatim_bytearray] = STATE(1801),
    [sym_format_triple_quoted_string] = STATE(1807),
    [sym_triple_quoted_string] = STATE(1801),
    [sym_const] = STATE(2000),
    [sym_long_identifier] = STATE(1725),
    [sym_active_pattern] = STATE(1726),
    [sym__identifier_or_op] = STATE(1751),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(723),
    [sym_sbyte] = STATE(1801),
    [sym_byte] = STATE(1801),
    [sym_int16] = STATE(1801),
    [sym_uint16] = STATE(1801),
    [sym_int32] = STATE(1801),
    [sym_uint32] = STATE(1801),
    [sym_nativeint] = STATE(1801),
    [sym_unativeint] = STATE(1801),
    [sym_int64] = STATE(1801),
    [sym_uint64] = STATE(1801),
    [sym_ieee32] = STATE(1801),
    [sym_ieee64] = STATE(1801),
    [sym_bignum] = STATE(1801),
    [sym_decimal] = STATE(1801),
    [sym_float] = STATE(1427),
    [sym_block_comment] = STATE(383),
    [sym_compiler_directive_decl] = STATE(383),
    [sym_fsi_directive_decl] = STATE(383),
    [sym_preproc_line] = STATE(383),
    [sym_preproc_if_in_expression] = STATE(2000),
    [sym_preproc_else_in_expression] = STATE(6447),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [aux_sym_preproc_if_in_expression_repeat1] = STATE(389),
    [sym_identifier] = ACTIONS(629),
    [anon_sym_return] = ACTIONS(633),
    [anon_sym_do] = ACTIONS(635),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(637),
    [anon_sym_null] = ACTIONS(641),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(643),
    [anon_sym_LBRACK_PIPE] = ACTIONS(645),
    [anon_sym_LBRACE] = ACTIONS(1713),
    [anon_sym_LT_AT] = ACTIONS(647),
    [anon_sym_LT_AT_AT] = ACTIONS(1715),
    [anon_sym_LBRACE_PIPE] = ACTIONS(653),
    [anon_sym_new] = ACTIONS(633),
    [anon_sym_return_BANG] = ACTIONS(655),
    [anon_sym_yield] = ACTIONS(633),
    [anon_sym_yield_BANG] = ACTIONS(655),
    [anon_sym_lazy] = ACTIONS(633),
    [anon_sym_assert] = ACTIONS(633),
    [anon_sym_upcast] = ACTIONS(633),
    [anon_sym_downcast] = ACTIONS(633),
    [anon_sym_for] = ACTIONS(659),
    [anon_sym_while] = ACTIONS(661),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(663),
    [anon_sym_try] = ACTIONS(665),
    [anon_sym_match] = ACTIONS(667),
    [anon_sym_match_BANG] = ACTIONS(669),
    [anon_sym_function] = ACTIONS(671),
    [anon_sym_use] = ACTIONS(679),
    [anon_sym_use_BANG] = ACTIONS(681),
    [anon_sym_do_BANG] = ACTIONS(683),
    [anon_sym_begin] = ACTIONS(685),
    [aux_sym_char_token1] = ACTIONS(689),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(691),
    [anon_sym_DQUOTE] = ACTIONS(693),
    [anon_sym_AT_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(697),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(699),
    [sym_bool] = ACTIONS(701),
    [sym_unit] = ACTIONS(1717),
    [anon_sym_LPAREN_PIPE] = ACTIONS(705),
    [sym_op_identifier] = ACTIONS(1719),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(709),
    [sym_xint] = ACTIONS(711),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(713),
    [anon_sym_POUNDendif] = ACTIONS(1745),
    [anon_sym_POUNDelse] = ACTIONS(1723),
    [sym__newline] = ACTIONS(1725),
  },
  [384] = {
    [sym_function_or_value_defn] = STATE(663),
    [sym__expression] = STATE(112),
    [sym_literal_expression] = STATE(1118),
    [sym_long_identifier_or_op] = STATE(1118),
    [sym_tuple_expression] = STATE(1118),
    [sym_brace_expression] = STATE(1118),
    [sym_anon_record_expression] = STATE(1118),
    [sym_prefixed_expression] = STATE(1118),
    [sym_typecast_expression] = STATE(1118),
    [sym_for_expression] = STATE(1118),
    [sym_while_expression] = STATE(1118),
    [sym__if_branch] = STATE(7163),
    [sym_if_expression] = STATE(1118),
    [sym_fun_expression] = STATE(1118),
    [sym_try_expression] = STATE(1118),
    [sym_match_expression] = STATE(1118),
    [sym_function_expression] = STATE(1118),
    [sym_mutate_expression] = STATE(1118),
    [sym_index_expression] = STATE(1118),
    [sym_typed_expression] = STATE(1118),
    [sym_declaration_expression] = STATE(1118),
    [sym_do_expression] = STATE(1118),
    [sym_list_expression] = STATE(1118),
    [sym_array_expression] = STATE(1118),
    [sym_begin_end_expression] = STATE(1118),
    [sym_paren_expression] = STATE(1118),
    [sym__high_prec_app] = STATE(1133),
    [sym__low_prec_app] = STATE(1133),
    [sym_application_expression] = STATE(1118),
    [sym_dot_expression] = STATE(1118),
    [sym_infix_expression] = STATE(1118),
    [sym_ce_expression] = STATE(1118),
    [sym_sequential_expression] = STATE(1118),
    [sym_slice_ranges] = STATE(6689),
    [sym__slice_range_special] = STATE(6328),
    [sym_slice_range] = STATE(5802),
    [sym_char] = STATE(1080),
    [sym_format_string] = STATE(1090),
    [sym__string_literal] = STATE(1090),
    [sym_string] = STATE(1080),
    [sym_verbatim_string] = STATE(1080),
    [sym_bytearray] = STATE(1080),
    [sym_verbatim_bytearray] = STATE(1080),
    [sym_format_triple_quoted_string] = STATE(1096),
    [sym_triple_quoted_string] = STATE(1080),
    [sym_const] = STATE(1118),
    [sym_long_identifier] = STATE(1156),
    [sym_active_pattern] = STATE(1085),
    [sym__identifier_or_op] = STATE(1099),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(548),
    [sym_sbyte] = STATE(1080),
    [sym_byte] = STATE(1080),
    [sym_int16] = STATE(1080),
    [sym_uint16] = STATE(1080),
    [sym_int32] = STATE(1080),
    [sym_uint32] = STATE(1080),
    [sym_nativeint] = STATE(1080),
    [sym_unativeint] = STATE(1080),
    [sym_int64] = STATE(1080),
    [sym_uint64] = STATE(1080),
    [sym_ieee32] = STATE(1080),
    [sym_ieee64] = STATE(1080),
    [sym_bignum] = STATE(1080),
    [sym_decimal] = STATE(1080),
    [sym_float] = STATE(979),
    [sym_block_comment] = STATE(384),
    [sym_compiler_directive_decl] = STATE(384),
    [sym_fsi_directive_decl] = STATE(384),
    [sym_preproc_line] = STATE(384),
    [sym_preproc_if_in_expression] = STATE(1118),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(195),
    [anon_sym_return] = ACTIONS(481),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_null] = ACTIONS(207),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(209),
    [anon_sym_LBRACK_PIPE] = ACTIONS(211),
    [anon_sym_LBRACE] = ACTIONS(1687),
    [anon_sym_LT_AT] = ACTIONS(213),
    [anon_sym_LT_AT_AT] = ACTIONS(1689),
    [anon_sym_LBRACE_PIPE] = ACTIONS(217),
    [anon_sym_new] = ACTIONS(481),
    [anon_sym_return_BANG] = ACTIONS(487),
    [anon_sym_yield] = ACTIONS(481),
    [anon_sym_yield_BANG] = ACTIONS(487),
    [anon_sym_lazy] = ACTIONS(481),
    [anon_sym_assert] = ACTIONS(481),
    [anon_sym_upcast] = ACTIONS(481),
    [anon_sym_downcast] = ACTIONS(481),
    [anon_sym_for] = ACTIONS(489),
    [anon_sym_while] = ACTIONS(225),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(229),
    [anon_sym_match] = ACTIONS(231),
    [anon_sym_match_BANG] = ACTIONS(233),
    [anon_sym_function] = ACTIONS(235),
    [anon_sym_use] = ACTIONS(493),
    [anon_sym_use_BANG] = ACTIONS(495),
    [anon_sym_do_BANG] = ACTIONS(243),
    [anon_sym_begin] = ACTIONS(245),
    [anon_sym_DOT_DOT3] = ACTIONS(1709),
    [anon_sym_STAR] = ACTIONS(1711),
    [aux_sym_char_token1] = ACTIONS(247),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(251),
    [anon_sym_AT_DQUOTE] = ACTIONS(253),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(255),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(257),
    [sym_bool] = ACTIONS(259),
    [sym_unit] = ACTIONS(1699),
    [anon_sym_LPAREN_PIPE] = ACTIONS(261),
    [sym_op_identifier] = ACTIONS(1701),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(499),
    [sym_xint] = ACTIONS(267),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(269),
  },
  [385] = {
    [sym_function_or_value_defn] = STATE(532),
    [sym__expression] = STATE(102),
    [sym_literal_expression] = STATE(2000),
    [sym_long_identifier_or_op] = STATE(2000),
    [sym_tuple_expression] = STATE(2000),
    [sym_brace_expression] = STATE(2000),
    [sym_anon_record_expression] = STATE(2000),
    [sym_prefixed_expression] = STATE(2000),
    [sym_typecast_expression] = STATE(2000),
    [sym_for_expression] = STATE(2000),
    [sym_while_expression] = STATE(2000),
    [sym__if_branch] = STATE(6707),
    [sym_if_expression] = STATE(2000),
    [sym_fun_expression] = STATE(2000),
    [sym_try_expression] = STATE(2000),
    [sym_match_expression] = STATE(2000),
    [sym_function_expression] = STATE(2000),
    [sym_mutate_expression] = STATE(2000),
    [sym_index_expression] = STATE(2000),
    [sym_typed_expression] = STATE(2000),
    [sym_declaration_expression] = STATE(2000),
    [sym_do_expression] = STATE(2000),
    [sym_list_expression] = STATE(2000),
    [sym_array_expression] = STATE(2000),
    [sym_begin_end_expression] = STATE(2000),
    [sym_paren_expression] = STATE(2000),
    [sym__high_prec_app] = STATE(2003),
    [sym__low_prec_app] = STATE(2003),
    [sym_application_expression] = STATE(2000),
    [sym_dot_expression] = STATE(2000),
    [sym_infix_expression] = STATE(2000),
    [sym_ce_expression] = STATE(2000),
    [sym_sequential_expression] = STATE(2000),
    [sym_char] = STATE(1801),
    [sym_format_string] = STATE(1804),
    [sym__string_literal] = STATE(1804),
    [sym_string] = STATE(1801),
    [sym_verbatim_string] = STATE(1801),
    [sym_bytearray] = STATE(1801),
    [sym_verbatim_bytearray] = STATE(1801),
    [sym_format_triple_quoted_string] = STATE(1807),
    [sym_triple_quoted_string] = STATE(1801),
    [sym_const] = STATE(2000),
    [sym_long_identifier] = STATE(1725),
    [sym_active_pattern] = STATE(1726),
    [sym__identifier_or_op] = STATE(1751),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(723),
    [sym_sbyte] = STATE(1801),
    [sym_byte] = STATE(1801),
    [sym_int16] = STATE(1801),
    [sym_uint16] = STATE(1801),
    [sym_int32] = STATE(1801),
    [sym_uint32] = STATE(1801),
    [sym_nativeint] = STATE(1801),
    [sym_unativeint] = STATE(1801),
    [sym_int64] = STATE(1801),
    [sym_uint64] = STATE(1801),
    [sym_ieee32] = STATE(1801),
    [sym_ieee64] = STATE(1801),
    [sym_bignum] = STATE(1801),
    [sym_decimal] = STATE(1801),
    [sym_float] = STATE(1427),
    [sym_block_comment] = STATE(385),
    [sym_compiler_directive_decl] = STATE(385),
    [sym_fsi_directive_decl] = STATE(385),
    [sym_preproc_line] = STATE(385),
    [sym_preproc_if_in_expression] = STATE(2000),
    [sym_preproc_else_in_expression] = STATE(7205),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [aux_sym_preproc_if_in_expression_repeat1] = STATE(416),
    [sym_identifier] = ACTIONS(629),
    [anon_sym_return] = ACTIONS(633),
    [anon_sym_do] = ACTIONS(635),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(637),
    [anon_sym_null] = ACTIONS(641),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(643),
    [anon_sym_LBRACK_PIPE] = ACTIONS(645),
    [anon_sym_LBRACE] = ACTIONS(1713),
    [anon_sym_LT_AT] = ACTIONS(647),
    [anon_sym_LT_AT_AT] = ACTIONS(1715),
    [anon_sym_LBRACE_PIPE] = ACTIONS(653),
    [anon_sym_new] = ACTIONS(633),
    [anon_sym_return_BANG] = ACTIONS(655),
    [anon_sym_yield] = ACTIONS(633),
    [anon_sym_yield_BANG] = ACTIONS(655),
    [anon_sym_lazy] = ACTIONS(633),
    [anon_sym_assert] = ACTIONS(633),
    [anon_sym_upcast] = ACTIONS(633),
    [anon_sym_downcast] = ACTIONS(633),
    [anon_sym_for] = ACTIONS(659),
    [anon_sym_while] = ACTIONS(661),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(663),
    [anon_sym_try] = ACTIONS(665),
    [anon_sym_match] = ACTIONS(667),
    [anon_sym_match_BANG] = ACTIONS(669),
    [anon_sym_function] = ACTIONS(671),
    [anon_sym_use] = ACTIONS(679),
    [anon_sym_use_BANG] = ACTIONS(681),
    [anon_sym_do_BANG] = ACTIONS(683),
    [anon_sym_begin] = ACTIONS(685),
    [aux_sym_char_token1] = ACTIONS(689),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(691),
    [anon_sym_DQUOTE] = ACTIONS(693),
    [anon_sym_AT_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(697),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(699),
    [sym_bool] = ACTIONS(701),
    [sym_unit] = ACTIONS(1717),
    [anon_sym_LPAREN_PIPE] = ACTIONS(705),
    [sym_op_identifier] = ACTIONS(1719),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(709),
    [sym_xint] = ACTIONS(711),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(713),
    [anon_sym_POUNDendif] = ACTIONS(1747),
    [anon_sym_POUNDelse] = ACTIONS(1723),
    [sym__newline] = ACTIONS(1725),
  },
  [386] = {
    [sym_function_or_value_defn] = STATE(532),
    [sym__expression] = STATE(102),
    [sym_literal_expression] = STATE(2000),
    [sym_long_identifier_or_op] = STATE(2000),
    [sym_tuple_expression] = STATE(2000),
    [sym_brace_expression] = STATE(2000),
    [sym_anon_record_expression] = STATE(2000),
    [sym_prefixed_expression] = STATE(2000),
    [sym_typecast_expression] = STATE(2000),
    [sym_for_expression] = STATE(2000),
    [sym_while_expression] = STATE(2000),
    [sym__if_branch] = STATE(6707),
    [sym_if_expression] = STATE(2000),
    [sym_fun_expression] = STATE(2000),
    [sym_try_expression] = STATE(2000),
    [sym_match_expression] = STATE(2000),
    [sym_function_expression] = STATE(2000),
    [sym_mutate_expression] = STATE(2000),
    [sym_index_expression] = STATE(2000),
    [sym_typed_expression] = STATE(2000),
    [sym_declaration_expression] = STATE(2000),
    [sym_do_expression] = STATE(2000),
    [sym_list_expression] = STATE(2000),
    [sym_array_expression] = STATE(2000),
    [sym_begin_end_expression] = STATE(2000),
    [sym_paren_expression] = STATE(2000),
    [sym__high_prec_app] = STATE(2003),
    [sym__low_prec_app] = STATE(2003),
    [sym_application_expression] = STATE(2000),
    [sym_dot_expression] = STATE(2000),
    [sym_infix_expression] = STATE(2000),
    [sym_ce_expression] = STATE(2000),
    [sym_sequential_expression] = STATE(2000),
    [sym_char] = STATE(1801),
    [sym_format_string] = STATE(1804),
    [sym__string_literal] = STATE(1804),
    [sym_string] = STATE(1801),
    [sym_verbatim_string] = STATE(1801),
    [sym_bytearray] = STATE(1801),
    [sym_verbatim_bytearray] = STATE(1801),
    [sym_format_triple_quoted_string] = STATE(1807),
    [sym_triple_quoted_string] = STATE(1801),
    [sym_const] = STATE(2000),
    [sym_long_identifier] = STATE(1725),
    [sym_active_pattern] = STATE(1726),
    [sym__identifier_or_op] = STATE(1751),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(723),
    [sym_sbyte] = STATE(1801),
    [sym_byte] = STATE(1801),
    [sym_int16] = STATE(1801),
    [sym_uint16] = STATE(1801),
    [sym_int32] = STATE(1801),
    [sym_uint32] = STATE(1801),
    [sym_nativeint] = STATE(1801),
    [sym_unativeint] = STATE(1801),
    [sym_int64] = STATE(1801),
    [sym_uint64] = STATE(1801),
    [sym_ieee32] = STATE(1801),
    [sym_ieee64] = STATE(1801),
    [sym_bignum] = STATE(1801),
    [sym_decimal] = STATE(1801),
    [sym_float] = STATE(1427),
    [sym_block_comment] = STATE(386),
    [sym_compiler_directive_decl] = STATE(386),
    [sym_fsi_directive_decl] = STATE(386),
    [sym_preproc_line] = STATE(386),
    [sym_preproc_if_in_expression] = STATE(2000),
    [sym_preproc_else_in_expression] = STATE(6648),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [aux_sym_preproc_if_in_expression_repeat1] = STATE(416),
    [sym_identifier] = ACTIONS(629),
    [anon_sym_return] = ACTIONS(633),
    [anon_sym_do] = ACTIONS(635),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(637),
    [anon_sym_null] = ACTIONS(641),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(643),
    [anon_sym_LBRACK_PIPE] = ACTIONS(645),
    [anon_sym_LBRACE] = ACTIONS(1713),
    [anon_sym_LT_AT] = ACTIONS(647),
    [anon_sym_LT_AT_AT] = ACTIONS(1715),
    [anon_sym_LBRACE_PIPE] = ACTIONS(653),
    [anon_sym_new] = ACTIONS(633),
    [anon_sym_return_BANG] = ACTIONS(655),
    [anon_sym_yield] = ACTIONS(633),
    [anon_sym_yield_BANG] = ACTIONS(655),
    [anon_sym_lazy] = ACTIONS(633),
    [anon_sym_assert] = ACTIONS(633),
    [anon_sym_upcast] = ACTIONS(633),
    [anon_sym_downcast] = ACTIONS(633),
    [anon_sym_for] = ACTIONS(659),
    [anon_sym_while] = ACTIONS(661),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(663),
    [anon_sym_try] = ACTIONS(665),
    [anon_sym_match] = ACTIONS(667),
    [anon_sym_match_BANG] = ACTIONS(669),
    [anon_sym_function] = ACTIONS(671),
    [anon_sym_use] = ACTIONS(679),
    [anon_sym_use_BANG] = ACTIONS(681),
    [anon_sym_do_BANG] = ACTIONS(683),
    [anon_sym_begin] = ACTIONS(685),
    [aux_sym_char_token1] = ACTIONS(689),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(691),
    [anon_sym_DQUOTE] = ACTIONS(693),
    [anon_sym_AT_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(697),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(699),
    [sym_bool] = ACTIONS(701),
    [sym_unit] = ACTIONS(1717),
    [anon_sym_LPAREN_PIPE] = ACTIONS(705),
    [sym_op_identifier] = ACTIONS(1719),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(709),
    [sym_xint] = ACTIONS(711),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(713),
    [anon_sym_POUNDendif] = ACTIONS(1749),
    [anon_sym_POUNDelse] = ACTIONS(1723),
    [sym__newline] = ACTIONS(1725),
  },
  [387] = {
    [sym_function_or_value_defn] = STATE(663),
    [sym__expression] = STATE(55),
    [sym_literal_expression] = STATE(1118),
    [sym_long_identifier_or_op] = STATE(1118),
    [sym_tuple_expression] = STATE(1118),
    [sym_brace_expression] = STATE(1118),
    [sym_anon_record_expression] = STATE(1118),
    [sym_prefixed_expression] = STATE(1118),
    [sym_typecast_expression] = STATE(1118),
    [sym_for_expression] = STATE(1118),
    [sym_while_expression] = STATE(1118),
    [sym__if_branch] = STATE(7163),
    [sym_if_expression] = STATE(1118),
    [sym_fun_expression] = STATE(1118),
    [sym_try_expression] = STATE(1118),
    [sym_match_expression] = STATE(1118),
    [sym_function_expression] = STATE(1118),
    [sym_mutate_expression] = STATE(1118),
    [sym_index_expression] = STATE(1118),
    [sym_typed_expression] = STATE(1118),
    [sym_declaration_expression] = STATE(1118),
    [sym_do_expression] = STATE(1118),
    [sym_list_expression] = STATE(1118),
    [sym_array_expression] = STATE(1118),
    [sym_begin_end_expression] = STATE(1118),
    [sym_paren_expression] = STATE(1118),
    [sym__high_prec_app] = STATE(1133),
    [sym__low_prec_app] = STATE(1133),
    [sym_application_expression] = STATE(1118),
    [sym_dot_expression] = STATE(1118),
    [sym_infix_expression] = STATE(1118),
    [sym_ce_expression] = STATE(1118),
    [sym_sequential_expression] = STATE(1118),
    [sym_slice_ranges] = STATE(6575),
    [sym__slice_range_special] = STATE(6328),
    [sym_slice_range] = STATE(5802),
    [sym_char] = STATE(1080),
    [sym_format_string] = STATE(1090),
    [sym__string_literal] = STATE(1090),
    [sym_string] = STATE(1080),
    [sym_verbatim_string] = STATE(1080),
    [sym_bytearray] = STATE(1080),
    [sym_verbatim_bytearray] = STATE(1080),
    [sym_format_triple_quoted_string] = STATE(1096),
    [sym_triple_quoted_string] = STATE(1080),
    [sym_const] = STATE(1118),
    [sym_long_identifier] = STATE(1156),
    [sym_active_pattern] = STATE(1085),
    [sym__identifier_or_op] = STATE(1099),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(548),
    [sym_sbyte] = STATE(1080),
    [sym_byte] = STATE(1080),
    [sym_int16] = STATE(1080),
    [sym_uint16] = STATE(1080),
    [sym_int32] = STATE(1080),
    [sym_uint32] = STATE(1080),
    [sym_nativeint] = STATE(1080),
    [sym_unativeint] = STATE(1080),
    [sym_int64] = STATE(1080),
    [sym_uint64] = STATE(1080),
    [sym_ieee32] = STATE(1080),
    [sym_ieee64] = STATE(1080),
    [sym_bignum] = STATE(1080),
    [sym_decimal] = STATE(1080),
    [sym_float] = STATE(979),
    [sym_block_comment] = STATE(387),
    [sym_compiler_directive_decl] = STATE(387),
    [sym_fsi_directive_decl] = STATE(387),
    [sym_preproc_line] = STATE(387),
    [sym_preproc_if_in_expression] = STATE(1118),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(195),
    [anon_sym_return] = ACTIONS(481),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_null] = ACTIONS(207),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(209),
    [anon_sym_LBRACK_PIPE] = ACTIONS(211),
    [anon_sym_LBRACE] = ACTIONS(1687),
    [anon_sym_LT_AT] = ACTIONS(213),
    [anon_sym_LT_AT_AT] = ACTIONS(1689),
    [anon_sym_LBRACE_PIPE] = ACTIONS(217),
    [anon_sym_new] = ACTIONS(481),
    [anon_sym_return_BANG] = ACTIONS(487),
    [anon_sym_yield] = ACTIONS(481),
    [anon_sym_yield_BANG] = ACTIONS(487),
    [anon_sym_lazy] = ACTIONS(481),
    [anon_sym_assert] = ACTIONS(481),
    [anon_sym_upcast] = ACTIONS(481),
    [anon_sym_downcast] = ACTIONS(481),
    [anon_sym_for] = ACTIONS(489),
    [anon_sym_while] = ACTIONS(225),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(229),
    [anon_sym_match] = ACTIONS(231),
    [anon_sym_match_BANG] = ACTIONS(233),
    [anon_sym_function] = ACTIONS(235),
    [anon_sym_use] = ACTIONS(493),
    [anon_sym_use_BANG] = ACTIONS(495),
    [anon_sym_do_BANG] = ACTIONS(243),
    [anon_sym_begin] = ACTIONS(245),
    [anon_sym_DOT_DOT3] = ACTIONS(1709),
    [anon_sym_STAR] = ACTIONS(1711),
    [aux_sym_char_token1] = ACTIONS(247),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(251),
    [anon_sym_AT_DQUOTE] = ACTIONS(253),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(255),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(257),
    [sym_bool] = ACTIONS(259),
    [sym_unit] = ACTIONS(1699),
    [anon_sym_LPAREN_PIPE] = ACTIONS(261),
    [sym_op_identifier] = ACTIONS(1701),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(499),
    [sym_xint] = ACTIONS(267),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(269),
  },
  [388] = {
    [sym_function_or_value_defn] = STATE(532),
    [sym__expression] = STATE(102),
    [sym_literal_expression] = STATE(2000),
    [sym_long_identifier_or_op] = STATE(2000),
    [sym_tuple_expression] = STATE(2000),
    [sym_brace_expression] = STATE(2000),
    [sym_anon_record_expression] = STATE(2000),
    [sym_prefixed_expression] = STATE(2000),
    [sym_typecast_expression] = STATE(2000),
    [sym_for_expression] = STATE(2000),
    [sym_while_expression] = STATE(2000),
    [sym__if_branch] = STATE(6707),
    [sym_if_expression] = STATE(2000),
    [sym_fun_expression] = STATE(2000),
    [sym_try_expression] = STATE(2000),
    [sym_match_expression] = STATE(2000),
    [sym_function_expression] = STATE(2000),
    [sym_mutate_expression] = STATE(2000),
    [sym_index_expression] = STATE(2000),
    [sym_typed_expression] = STATE(2000),
    [sym_declaration_expression] = STATE(2000),
    [sym_do_expression] = STATE(2000),
    [sym_list_expression] = STATE(2000),
    [sym_array_expression] = STATE(2000),
    [sym_begin_end_expression] = STATE(2000),
    [sym_paren_expression] = STATE(2000),
    [sym__high_prec_app] = STATE(2003),
    [sym__low_prec_app] = STATE(2003),
    [sym_application_expression] = STATE(2000),
    [sym_dot_expression] = STATE(2000),
    [sym_infix_expression] = STATE(2000),
    [sym_ce_expression] = STATE(2000),
    [sym_sequential_expression] = STATE(2000),
    [sym_char] = STATE(1801),
    [sym_format_string] = STATE(1804),
    [sym__string_literal] = STATE(1804),
    [sym_string] = STATE(1801),
    [sym_verbatim_string] = STATE(1801),
    [sym_bytearray] = STATE(1801),
    [sym_verbatim_bytearray] = STATE(1801),
    [sym_format_triple_quoted_string] = STATE(1807),
    [sym_triple_quoted_string] = STATE(1801),
    [sym_const] = STATE(2000),
    [sym_long_identifier] = STATE(1725),
    [sym_active_pattern] = STATE(1726),
    [sym__identifier_or_op] = STATE(1751),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(723),
    [sym_sbyte] = STATE(1801),
    [sym_byte] = STATE(1801),
    [sym_int16] = STATE(1801),
    [sym_uint16] = STATE(1801),
    [sym_int32] = STATE(1801),
    [sym_uint32] = STATE(1801),
    [sym_nativeint] = STATE(1801),
    [sym_unativeint] = STATE(1801),
    [sym_int64] = STATE(1801),
    [sym_uint64] = STATE(1801),
    [sym_ieee32] = STATE(1801),
    [sym_ieee64] = STATE(1801),
    [sym_bignum] = STATE(1801),
    [sym_decimal] = STATE(1801),
    [sym_float] = STATE(1427),
    [sym_block_comment] = STATE(388),
    [sym_compiler_directive_decl] = STATE(388),
    [sym_fsi_directive_decl] = STATE(388),
    [sym_preproc_line] = STATE(388),
    [sym_preproc_if_in_expression] = STATE(2000),
    [sym_preproc_else_in_expression] = STATE(7225),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [aux_sym_preproc_if_in_expression_repeat1] = STATE(385),
    [sym_identifier] = ACTIONS(629),
    [anon_sym_return] = ACTIONS(633),
    [anon_sym_do] = ACTIONS(635),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(637),
    [anon_sym_null] = ACTIONS(641),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(643),
    [anon_sym_LBRACK_PIPE] = ACTIONS(645),
    [anon_sym_LBRACE] = ACTIONS(1713),
    [anon_sym_LT_AT] = ACTIONS(647),
    [anon_sym_LT_AT_AT] = ACTIONS(1715),
    [anon_sym_LBRACE_PIPE] = ACTIONS(653),
    [anon_sym_new] = ACTIONS(633),
    [anon_sym_return_BANG] = ACTIONS(655),
    [anon_sym_yield] = ACTIONS(633),
    [anon_sym_yield_BANG] = ACTIONS(655),
    [anon_sym_lazy] = ACTIONS(633),
    [anon_sym_assert] = ACTIONS(633),
    [anon_sym_upcast] = ACTIONS(633),
    [anon_sym_downcast] = ACTIONS(633),
    [anon_sym_for] = ACTIONS(659),
    [anon_sym_while] = ACTIONS(661),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(663),
    [anon_sym_try] = ACTIONS(665),
    [anon_sym_match] = ACTIONS(667),
    [anon_sym_match_BANG] = ACTIONS(669),
    [anon_sym_function] = ACTIONS(671),
    [anon_sym_use] = ACTIONS(679),
    [anon_sym_use_BANG] = ACTIONS(681),
    [anon_sym_do_BANG] = ACTIONS(683),
    [anon_sym_begin] = ACTIONS(685),
    [aux_sym_char_token1] = ACTIONS(689),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(691),
    [anon_sym_DQUOTE] = ACTIONS(693),
    [anon_sym_AT_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(697),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(699),
    [sym_bool] = ACTIONS(701),
    [sym_unit] = ACTIONS(1717),
    [anon_sym_LPAREN_PIPE] = ACTIONS(705),
    [sym_op_identifier] = ACTIONS(1719),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(709),
    [sym_xint] = ACTIONS(711),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(713),
    [anon_sym_POUNDendif] = ACTIONS(1751),
    [anon_sym_POUNDelse] = ACTIONS(1723),
    [sym__newline] = ACTIONS(1725),
  },
  [389] = {
    [sym_function_or_value_defn] = STATE(532),
    [sym__expression] = STATE(102),
    [sym_literal_expression] = STATE(2000),
    [sym_long_identifier_or_op] = STATE(2000),
    [sym_tuple_expression] = STATE(2000),
    [sym_brace_expression] = STATE(2000),
    [sym_anon_record_expression] = STATE(2000),
    [sym_prefixed_expression] = STATE(2000),
    [sym_typecast_expression] = STATE(2000),
    [sym_for_expression] = STATE(2000),
    [sym_while_expression] = STATE(2000),
    [sym__if_branch] = STATE(6707),
    [sym_if_expression] = STATE(2000),
    [sym_fun_expression] = STATE(2000),
    [sym_try_expression] = STATE(2000),
    [sym_match_expression] = STATE(2000),
    [sym_function_expression] = STATE(2000),
    [sym_mutate_expression] = STATE(2000),
    [sym_index_expression] = STATE(2000),
    [sym_typed_expression] = STATE(2000),
    [sym_declaration_expression] = STATE(2000),
    [sym_do_expression] = STATE(2000),
    [sym_list_expression] = STATE(2000),
    [sym_array_expression] = STATE(2000),
    [sym_begin_end_expression] = STATE(2000),
    [sym_paren_expression] = STATE(2000),
    [sym__high_prec_app] = STATE(2003),
    [sym__low_prec_app] = STATE(2003),
    [sym_application_expression] = STATE(2000),
    [sym_dot_expression] = STATE(2000),
    [sym_infix_expression] = STATE(2000),
    [sym_ce_expression] = STATE(2000),
    [sym_sequential_expression] = STATE(2000),
    [sym_char] = STATE(1801),
    [sym_format_string] = STATE(1804),
    [sym__string_literal] = STATE(1804),
    [sym_string] = STATE(1801),
    [sym_verbatim_string] = STATE(1801),
    [sym_bytearray] = STATE(1801),
    [sym_verbatim_bytearray] = STATE(1801),
    [sym_format_triple_quoted_string] = STATE(1807),
    [sym_triple_quoted_string] = STATE(1801),
    [sym_const] = STATE(2000),
    [sym_long_identifier] = STATE(1725),
    [sym_active_pattern] = STATE(1726),
    [sym__identifier_or_op] = STATE(1751),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(723),
    [sym_sbyte] = STATE(1801),
    [sym_byte] = STATE(1801),
    [sym_int16] = STATE(1801),
    [sym_uint16] = STATE(1801),
    [sym_int32] = STATE(1801),
    [sym_uint32] = STATE(1801),
    [sym_nativeint] = STATE(1801),
    [sym_unativeint] = STATE(1801),
    [sym_int64] = STATE(1801),
    [sym_uint64] = STATE(1801),
    [sym_ieee32] = STATE(1801),
    [sym_ieee64] = STATE(1801),
    [sym_bignum] = STATE(1801),
    [sym_decimal] = STATE(1801),
    [sym_float] = STATE(1427),
    [sym_block_comment] = STATE(389),
    [sym_compiler_directive_decl] = STATE(389),
    [sym_fsi_directive_decl] = STATE(389),
    [sym_preproc_line] = STATE(389),
    [sym_preproc_if_in_expression] = STATE(2000),
    [sym_preproc_else_in_expression] = STATE(6437),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [aux_sym_preproc_if_in_expression_repeat1] = STATE(416),
    [sym_identifier] = ACTIONS(629),
    [anon_sym_return] = ACTIONS(633),
    [anon_sym_do] = ACTIONS(635),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(637),
    [anon_sym_null] = ACTIONS(641),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(643),
    [anon_sym_LBRACK_PIPE] = ACTIONS(645),
    [anon_sym_LBRACE] = ACTIONS(1713),
    [anon_sym_LT_AT] = ACTIONS(647),
    [anon_sym_LT_AT_AT] = ACTIONS(1715),
    [anon_sym_LBRACE_PIPE] = ACTIONS(653),
    [anon_sym_new] = ACTIONS(633),
    [anon_sym_return_BANG] = ACTIONS(655),
    [anon_sym_yield] = ACTIONS(633),
    [anon_sym_yield_BANG] = ACTIONS(655),
    [anon_sym_lazy] = ACTIONS(633),
    [anon_sym_assert] = ACTIONS(633),
    [anon_sym_upcast] = ACTIONS(633),
    [anon_sym_downcast] = ACTIONS(633),
    [anon_sym_for] = ACTIONS(659),
    [anon_sym_while] = ACTIONS(661),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(663),
    [anon_sym_try] = ACTIONS(665),
    [anon_sym_match] = ACTIONS(667),
    [anon_sym_match_BANG] = ACTIONS(669),
    [anon_sym_function] = ACTIONS(671),
    [anon_sym_use] = ACTIONS(679),
    [anon_sym_use_BANG] = ACTIONS(681),
    [anon_sym_do_BANG] = ACTIONS(683),
    [anon_sym_begin] = ACTIONS(685),
    [aux_sym_char_token1] = ACTIONS(689),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(691),
    [anon_sym_DQUOTE] = ACTIONS(693),
    [anon_sym_AT_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(697),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(699),
    [sym_bool] = ACTIONS(701),
    [sym_unit] = ACTIONS(1717),
    [anon_sym_LPAREN_PIPE] = ACTIONS(705),
    [sym_op_identifier] = ACTIONS(1719),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(709),
    [sym_xint] = ACTIONS(711),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(713),
    [anon_sym_POUNDendif] = ACTIONS(1753),
    [anon_sym_POUNDelse] = ACTIONS(1723),
    [sym__newline] = ACTIONS(1725),
  },
  [390] = {
    [sym_function_or_value_defn] = STATE(663),
    [sym__expression] = STATE(66),
    [sym_literal_expression] = STATE(1118),
    [sym_long_identifier_or_op] = STATE(1118),
    [sym_tuple_expression] = STATE(1118),
    [sym_brace_expression] = STATE(1118),
    [sym_anon_record_expression] = STATE(1118),
    [sym_prefixed_expression] = STATE(1118),
    [sym_typecast_expression] = STATE(1118),
    [sym_for_expression] = STATE(1118),
    [sym_while_expression] = STATE(1118),
    [sym__if_branch] = STATE(7163),
    [sym_if_expression] = STATE(1118),
    [sym_fun_expression] = STATE(1118),
    [sym_try_expression] = STATE(1118),
    [sym_match_expression] = STATE(1118),
    [sym_function_expression] = STATE(1118),
    [sym_mutate_expression] = STATE(1118),
    [sym_index_expression] = STATE(1118),
    [sym_typed_expression] = STATE(1118),
    [sym_declaration_expression] = STATE(1118),
    [sym_do_expression] = STATE(1118),
    [sym_list_expression] = STATE(1118),
    [sym_array_expression] = STATE(1118),
    [sym_begin_end_expression] = STATE(1118),
    [sym_paren_expression] = STATE(1118),
    [sym__high_prec_app] = STATE(1133),
    [sym__low_prec_app] = STATE(1133),
    [sym_application_expression] = STATE(1118),
    [sym_dot_expression] = STATE(1118),
    [sym_infix_expression] = STATE(1118),
    [sym_ce_expression] = STATE(1118),
    [sym_sequential_expression] = STATE(1118),
    [sym_slice_ranges] = STATE(7247),
    [sym__slice_range_special] = STATE(6328),
    [sym_slice_range] = STATE(5802),
    [sym_char] = STATE(1080),
    [sym_format_string] = STATE(1090),
    [sym__string_literal] = STATE(1090),
    [sym_string] = STATE(1080),
    [sym_verbatim_string] = STATE(1080),
    [sym_bytearray] = STATE(1080),
    [sym_verbatim_bytearray] = STATE(1080),
    [sym_format_triple_quoted_string] = STATE(1096),
    [sym_triple_quoted_string] = STATE(1080),
    [sym_const] = STATE(1118),
    [sym_long_identifier] = STATE(1156),
    [sym_active_pattern] = STATE(1085),
    [sym__identifier_or_op] = STATE(1099),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(548),
    [sym_sbyte] = STATE(1080),
    [sym_byte] = STATE(1080),
    [sym_int16] = STATE(1080),
    [sym_uint16] = STATE(1080),
    [sym_int32] = STATE(1080),
    [sym_uint32] = STATE(1080),
    [sym_nativeint] = STATE(1080),
    [sym_unativeint] = STATE(1080),
    [sym_int64] = STATE(1080),
    [sym_uint64] = STATE(1080),
    [sym_ieee32] = STATE(1080),
    [sym_ieee64] = STATE(1080),
    [sym_bignum] = STATE(1080),
    [sym_decimal] = STATE(1080),
    [sym_float] = STATE(979),
    [sym_block_comment] = STATE(390),
    [sym_compiler_directive_decl] = STATE(390),
    [sym_fsi_directive_decl] = STATE(390),
    [sym_preproc_line] = STATE(390),
    [sym_preproc_if_in_expression] = STATE(1118),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(195),
    [anon_sym_return] = ACTIONS(481),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_null] = ACTIONS(207),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(209),
    [anon_sym_LBRACK_PIPE] = ACTIONS(211),
    [anon_sym_LBRACE] = ACTIONS(1687),
    [anon_sym_LT_AT] = ACTIONS(213),
    [anon_sym_LT_AT_AT] = ACTIONS(1689),
    [anon_sym_LBRACE_PIPE] = ACTIONS(217),
    [anon_sym_new] = ACTIONS(481),
    [anon_sym_return_BANG] = ACTIONS(487),
    [anon_sym_yield] = ACTIONS(481),
    [anon_sym_yield_BANG] = ACTIONS(487),
    [anon_sym_lazy] = ACTIONS(481),
    [anon_sym_assert] = ACTIONS(481),
    [anon_sym_upcast] = ACTIONS(481),
    [anon_sym_downcast] = ACTIONS(481),
    [anon_sym_for] = ACTIONS(489),
    [anon_sym_while] = ACTIONS(225),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(229),
    [anon_sym_match] = ACTIONS(231),
    [anon_sym_match_BANG] = ACTIONS(233),
    [anon_sym_function] = ACTIONS(235),
    [anon_sym_use] = ACTIONS(493),
    [anon_sym_use_BANG] = ACTIONS(495),
    [anon_sym_do_BANG] = ACTIONS(243),
    [anon_sym_begin] = ACTIONS(245),
    [anon_sym_DOT_DOT3] = ACTIONS(1709),
    [anon_sym_STAR] = ACTIONS(1711),
    [aux_sym_char_token1] = ACTIONS(247),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(251),
    [anon_sym_AT_DQUOTE] = ACTIONS(253),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(255),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(257),
    [sym_bool] = ACTIONS(259),
    [sym_unit] = ACTIONS(1699),
    [anon_sym_LPAREN_PIPE] = ACTIONS(261),
    [sym_op_identifier] = ACTIONS(1701),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(499),
    [sym_xint] = ACTIONS(267),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(269),
  },
  [391] = {
    [sym_function_or_value_defn] = STATE(532),
    [sym__expression] = STATE(102),
    [sym_literal_expression] = STATE(2000),
    [sym_long_identifier_or_op] = STATE(2000),
    [sym_tuple_expression] = STATE(2000),
    [sym_brace_expression] = STATE(2000),
    [sym_anon_record_expression] = STATE(2000),
    [sym_prefixed_expression] = STATE(2000),
    [sym_typecast_expression] = STATE(2000),
    [sym_for_expression] = STATE(2000),
    [sym_while_expression] = STATE(2000),
    [sym__if_branch] = STATE(6707),
    [sym_if_expression] = STATE(2000),
    [sym_fun_expression] = STATE(2000),
    [sym_try_expression] = STATE(2000),
    [sym_match_expression] = STATE(2000),
    [sym_function_expression] = STATE(2000),
    [sym_mutate_expression] = STATE(2000),
    [sym_index_expression] = STATE(2000),
    [sym_typed_expression] = STATE(2000),
    [sym_declaration_expression] = STATE(2000),
    [sym_do_expression] = STATE(2000),
    [sym_list_expression] = STATE(2000),
    [sym_array_expression] = STATE(2000),
    [sym_begin_end_expression] = STATE(2000),
    [sym_paren_expression] = STATE(2000),
    [sym__high_prec_app] = STATE(2003),
    [sym__low_prec_app] = STATE(2003),
    [sym_application_expression] = STATE(2000),
    [sym_dot_expression] = STATE(2000),
    [sym_infix_expression] = STATE(2000),
    [sym_ce_expression] = STATE(2000),
    [sym_sequential_expression] = STATE(2000),
    [sym_char] = STATE(1801),
    [sym_format_string] = STATE(1804),
    [sym__string_literal] = STATE(1804),
    [sym_string] = STATE(1801),
    [sym_verbatim_string] = STATE(1801),
    [sym_bytearray] = STATE(1801),
    [sym_verbatim_bytearray] = STATE(1801),
    [sym_format_triple_quoted_string] = STATE(1807),
    [sym_triple_quoted_string] = STATE(1801),
    [sym_const] = STATE(2000),
    [sym_long_identifier] = STATE(1725),
    [sym_active_pattern] = STATE(1726),
    [sym__identifier_or_op] = STATE(1751),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(723),
    [sym_sbyte] = STATE(1801),
    [sym_byte] = STATE(1801),
    [sym_int16] = STATE(1801),
    [sym_uint16] = STATE(1801),
    [sym_int32] = STATE(1801),
    [sym_uint32] = STATE(1801),
    [sym_nativeint] = STATE(1801),
    [sym_unativeint] = STATE(1801),
    [sym_int64] = STATE(1801),
    [sym_uint64] = STATE(1801),
    [sym_ieee32] = STATE(1801),
    [sym_ieee64] = STATE(1801),
    [sym_bignum] = STATE(1801),
    [sym_decimal] = STATE(1801),
    [sym_float] = STATE(1427),
    [sym_block_comment] = STATE(391),
    [sym_compiler_directive_decl] = STATE(391),
    [sym_fsi_directive_decl] = STATE(391),
    [sym_preproc_line] = STATE(391),
    [sym_preproc_if_in_expression] = STATE(2000),
    [sym_preproc_else_in_expression] = STATE(7029),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [aux_sym_preproc_if_in_expression_repeat1] = STATE(416),
    [sym_identifier] = ACTIONS(629),
    [anon_sym_return] = ACTIONS(633),
    [anon_sym_do] = ACTIONS(635),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(637),
    [anon_sym_null] = ACTIONS(641),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(643),
    [anon_sym_LBRACK_PIPE] = ACTIONS(645),
    [anon_sym_LBRACE] = ACTIONS(1713),
    [anon_sym_LT_AT] = ACTIONS(647),
    [anon_sym_LT_AT_AT] = ACTIONS(1715),
    [anon_sym_LBRACE_PIPE] = ACTIONS(653),
    [anon_sym_new] = ACTIONS(633),
    [anon_sym_return_BANG] = ACTIONS(655),
    [anon_sym_yield] = ACTIONS(633),
    [anon_sym_yield_BANG] = ACTIONS(655),
    [anon_sym_lazy] = ACTIONS(633),
    [anon_sym_assert] = ACTIONS(633),
    [anon_sym_upcast] = ACTIONS(633),
    [anon_sym_downcast] = ACTIONS(633),
    [anon_sym_for] = ACTIONS(659),
    [anon_sym_while] = ACTIONS(661),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(663),
    [anon_sym_try] = ACTIONS(665),
    [anon_sym_match] = ACTIONS(667),
    [anon_sym_match_BANG] = ACTIONS(669),
    [anon_sym_function] = ACTIONS(671),
    [anon_sym_use] = ACTIONS(679),
    [anon_sym_use_BANG] = ACTIONS(681),
    [anon_sym_do_BANG] = ACTIONS(683),
    [anon_sym_begin] = ACTIONS(685),
    [aux_sym_char_token1] = ACTIONS(689),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(691),
    [anon_sym_DQUOTE] = ACTIONS(693),
    [anon_sym_AT_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(697),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(699),
    [sym_bool] = ACTIONS(701),
    [sym_unit] = ACTIONS(1717),
    [anon_sym_LPAREN_PIPE] = ACTIONS(705),
    [sym_op_identifier] = ACTIONS(1719),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(709),
    [sym_xint] = ACTIONS(711),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(713),
    [anon_sym_POUNDendif] = ACTIONS(1755),
    [anon_sym_POUNDelse] = ACTIONS(1723),
    [sym__newline] = ACTIONS(1725),
  },
  [392] = {
    [sym_function_or_value_defn] = STATE(532),
    [sym__expression] = STATE(102),
    [sym_literal_expression] = STATE(2000),
    [sym_long_identifier_or_op] = STATE(2000),
    [sym_tuple_expression] = STATE(2000),
    [sym_brace_expression] = STATE(2000),
    [sym_anon_record_expression] = STATE(2000),
    [sym_prefixed_expression] = STATE(2000),
    [sym_typecast_expression] = STATE(2000),
    [sym_for_expression] = STATE(2000),
    [sym_while_expression] = STATE(2000),
    [sym__if_branch] = STATE(6707),
    [sym_if_expression] = STATE(2000),
    [sym_fun_expression] = STATE(2000),
    [sym_try_expression] = STATE(2000),
    [sym_match_expression] = STATE(2000),
    [sym_function_expression] = STATE(2000),
    [sym_mutate_expression] = STATE(2000),
    [sym_index_expression] = STATE(2000),
    [sym_typed_expression] = STATE(2000),
    [sym_declaration_expression] = STATE(2000),
    [sym_do_expression] = STATE(2000),
    [sym_list_expression] = STATE(2000),
    [sym_array_expression] = STATE(2000),
    [sym_begin_end_expression] = STATE(2000),
    [sym_paren_expression] = STATE(2000),
    [sym__high_prec_app] = STATE(2003),
    [sym__low_prec_app] = STATE(2003),
    [sym_application_expression] = STATE(2000),
    [sym_dot_expression] = STATE(2000),
    [sym_infix_expression] = STATE(2000),
    [sym_ce_expression] = STATE(2000),
    [sym_sequential_expression] = STATE(2000),
    [sym_char] = STATE(1801),
    [sym_format_string] = STATE(1804),
    [sym__string_literal] = STATE(1804),
    [sym_string] = STATE(1801),
    [sym_verbatim_string] = STATE(1801),
    [sym_bytearray] = STATE(1801),
    [sym_verbatim_bytearray] = STATE(1801),
    [sym_format_triple_quoted_string] = STATE(1807),
    [sym_triple_quoted_string] = STATE(1801),
    [sym_const] = STATE(2000),
    [sym_long_identifier] = STATE(1725),
    [sym_active_pattern] = STATE(1726),
    [sym__identifier_or_op] = STATE(1751),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(723),
    [sym_sbyte] = STATE(1801),
    [sym_byte] = STATE(1801),
    [sym_int16] = STATE(1801),
    [sym_uint16] = STATE(1801),
    [sym_int32] = STATE(1801),
    [sym_uint32] = STATE(1801),
    [sym_nativeint] = STATE(1801),
    [sym_unativeint] = STATE(1801),
    [sym_int64] = STATE(1801),
    [sym_uint64] = STATE(1801),
    [sym_ieee32] = STATE(1801),
    [sym_ieee64] = STATE(1801),
    [sym_bignum] = STATE(1801),
    [sym_decimal] = STATE(1801),
    [sym_float] = STATE(1427),
    [sym_block_comment] = STATE(392),
    [sym_compiler_directive_decl] = STATE(392),
    [sym_fsi_directive_decl] = STATE(392),
    [sym_preproc_line] = STATE(392),
    [sym_preproc_if_in_expression] = STATE(2000),
    [sym_preproc_else_in_expression] = STATE(6926),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [aux_sym_preproc_if_in_expression_repeat1] = STATE(393),
    [sym_identifier] = ACTIONS(629),
    [anon_sym_return] = ACTIONS(633),
    [anon_sym_do] = ACTIONS(635),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(637),
    [anon_sym_null] = ACTIONS(641),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(643),
    [anon_sym_LBRACK_PIPE] = ACTIONS(645),
    [anon_sym_LBRACE] = ACTIONS(1713),
    [anon_sym_LT_AT] = ACTIONS(647),
    [anon_sym_LT_AT_AT] = ACTIONS(1715),
    [anon_sym_LBRACE_PIPE] = ACTIONS(653),
    [anon_sym_new] = ACTIONS(633),
    [anon_sym_return_BANG] = ACTIONS(655),
    [anon_sym_yield] = ACTIONS(633),
    [anon_sym_yield_BANG] = ACTIONS(655),
    [anon_sym_lazy] = ACTIONS(633),
    [anon_sym_assert] = ACTIONS(633),
    [anon_sym_upcast] = ACTIONS(633),
    [anon_sym_downcast] = ACTIONS(633),
    [anon_sym_for] = ACTIONS(659),
    [anon_sym_while] = ACTIONS(661),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(663),
    [anon_sym_try] = ACTIONS(665),
    [anon_sym_match] = ACTIONS(667),
    [anon_sym_match_BANG] = ACTIONS(669),
    [anon_sym_function] = ACTIONS(671),
    [anon_sym_use] = ACTIONS(679),
    [anon_sym_use_BANG] = ACTIONS(681),
    [anon_sym_do_BANG] = ACTIONS(683),
    [anon_sym_begin] = ACTIONS(685),
    [aux_sym_char_token1] = ACTIONS(689),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(691),
    [anon_sym_DQUOTE] = ACTIONS(693),
    [anon_sym_AT_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(697),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(699),
    [sym_bool] = ACTIONS(701),
    [sym_unit] = ACTIONS(1717),
    [anon_sym_LPAREN_PIPE] = ACTIONS(705),
    [sym_op_identifier] = ACTIONS(1719),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(709),
    [sym_xint] = ACTIONS(711),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(713),
    [anon_sym_POUNDendif] = ACTIONS(1757),
    [anon_sym_POUNDelse] = ACTIONS(1723),
    [sym__newline] = ACTIONS(1725),
  },
  [393] = {
    [sym_function_or_value_defn] = STATE(532),
    [sym__expression] = STATE(102),
    [sym_literal_expression] = STATE(2000),
    [sym_long_identifier_or_op] = STATE(2000),
    [sym_tuple_expression] = STATE(2000),
    [sym_brace_expression] = STATE(2000),
    [sym_anon_record_expression] = STATE(2000),
    [sym_prefixed_expression] = STATE(2000),
    [sym_typecast_expression] = STATE(2000),
    [sym_for_expression] = STATE(2000),
    [sym_while_expression] = STATE(2000),
    [sym__if_branch] = STATE(6707),
    [sym_if_expression] = STATE(2000),
    [sym_fun_expression] = STATE(2000),
    [sym_try_expression] = STATE(2000),
    [sym_match_expression] = STATE(2000),
    [sym_function_expression] = STATE(2000),
    [sym_mutate_expression] = STATE(2000),
    [sym_index_expression] = STATE(2000),
    [sym_typed_expression] = STATE(2000),
    [sym_declaration_expression] = STATE(2000),
    [sym_do_expression] = STATE(2000),
    [sym_list_expression] = STATE(2000),
    [sym_array_expression] = STATE(2000),
    [sym_begin_end_expression] = STATE(2000),
    [sym_paren_expression] = STATE(2000),
    [sym__high_prec_app] = STATE(2003),
    [sym__low_prec_app] = STATE(2003),
    [sym_application_expression] = STATE(2000),
    [sym_dot_expression] = STATE(2000),
    [sym_infix_expression] = STATE(2000),
    [sym_ce_expression] = STATE(2000),
    [sym_sequential_expression] = STATE(2000),
    [sym_char] = STATE(1801),
    [sym_format_string] = STATE(1804),
    [sym__string_literal] = STATE(1804),
    [sym_string] = STATE(1801),
    [sym_verbatim_string] = STATE(1801),
    [sym_bytearray] = STATE(1801),
    [sym_verbatim_bytearray] = STATE(1801),
    [sym_format_triple_quoted_string] = STATE(1807),
    [sym_triple_quoted_string] = STATE(1801),
    [sym_const] = STATE(2000),
    [sym_long_identifier] = STATE(1725),
    [sym_active_pattern] = STATE(1726),
    [sym__identifier_or_op] = STATE(1751),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(723),
    [sym_sbyte] = STATE(1801),
    [sym_byte] = STATE(1801),
    [sym_int16] = STATE(1801),
    [sym_uint16] = STATE(1801),
    [sym_int32] = STATE(1801),
    [sym_uint32] = STATE(1801),
    [sym_nativeint] = STATE(1801),
    [sym_unativeint] = STATE(1801),
    [sym_int64] = STATE(1801),
    [sym_uint64] = STATE(1801),
    [sym_ieee32] = STATE(1801),
    [sym_ieee64] = STATE(1801),
    [sym_bignum] = STATE(1801),
    [sym_decimal] = STATE(1801),
    [sym_float] = STATE(1427),
    [sym_block_comment] = STATE(393),
    [sym_compiler_directive_decl] = STATE(393),
    [sym_fsi_directive_decl] = STATE(393),
    [sym_preproc_line] = STATE(393),
    [sym_preproc_if_in_expression] = STATE(2000),
    [sym_preproc_else_in_expression] = STATE(6901),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [aux_sym_preproc_if_in_expression_repeat1] = STATE(416),
    [sym_identifier] = ACTIONS(629),
    [anon_sym_return] = ACTIONS(633),
    [anon_sym_do] = ACTIONS(635),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(637),
    [anon_sym_null] = ACTIONS(641),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(643),
    [anon_sym_LBRACK_PIPE] = ACTIONS(645),
    [anon_sym_LBRACE] = ACTIONS(1713),
    [anon_sym_LT_AT] = ACTIONS(647),
    [anon_sym_LT_AT_AT] = ACTIONS(1715),
    [anon_sym_LBRACE_PIPE] = ACTIONS(653),
    [anon_sym_new] = ACTIONS(633),
    [anon_sym_return_BANG] = ACTIONS(655),
    [anon_sym_yield] = ACTIONS(633),
    [anon_sym_yield_BANG] = ACTIONS(655),
    [anon_sym_lazy] = ACTIONS(633),
    [anon_sym_assert] = ACTIONS(633),
    [anon_sym_upcast] = ACTIONS(633),
    [anon_sym_downcast] = ACTIONS(633),
    [anon_sym_for] = ACTIONS(659),
    [anon_sym_while] = ACTIONS(661),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(663),
    [anon_sym_try] = ACTIONS(665),
    [anon_sym_match] = ACTIONS(667),
    [anon_sym_match_BANG] = ACTIONS(669),
    [anon_sym_function] = ACTIONS(671),
    [anon_sym_use] = ACTIONS(679),
    [anon_sym_use_BANG] = ACTIONS(681),
    [anon_sym_do_BANG] = ACTIONS(683),
    [anon_sym_begin] = ACTIONS(685),
    [aux_sym_char_token1] = ACTIONS(689),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(691),
    [anon_sym_DQUOTE] = ACTIONS(693),
    [anon_sym_AT_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(697),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(699),
    [sym_bool] = ACTIONS(701),
    [sym_unit] = ACTIONS(1717),
    [anon_sym_LPAREN_PIPE] = ACTIONS(705),
    [sym_op_identifier] = ACTIONS(1719),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(709),
    [sym_xint] = ACTIONS(711),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(713),
    [anon_sym_POUNDendif] = ACTIONS(1759),
    [anon_sym_POUNDelse] = ACTIONS(1723),
    [sym__newline] = ACTIONS(1725),
  },
  [394] = {
    [sym_function_or_value_defn] = STATE(532),
    [sym__expression] = STATE(102),
    [sym_literal_expression] = STATE(2000),
    [sym_long_identifier_or_op] = STATE(2000),
    [sym_tuple_expression] = STATE(2000),
    [sym_brace_expression] = STATE(2000),
    [sym_anon_record_expression] = STATE(2000),
    [sym_prefixed_expression] = STATE(2000),
    [sym_typecast_expression] = STATE(2000),
    [sym_for_expression] = STATE(2000),
    [sym_while_expression] = STATE(2000),
    [sym__if_branch] = STATE(6707),
    [sym_if_expression] = STATE(2000),
    [sym_fun_expression] = STATE(2000),
    [sym_try_expression] = STATE(2000),
    [sym_match_expression] = STATE(2000),
    [sym_function_expression] = STATE(2000),
    [sym_mutate_expression] = STATE(2000),
    [sym_index_expression] = STATE(2000),
    [sym_typed_expression] = STATE(2000),
    [sym_declaration_expression] = STATE(2000),
    [sym_do_expression] = STATE(2000),
    [sym_list_expression] = STATE(2000),
    [sym_array_expression] = STATE(2000),
    [sym_begin_end_expression] = STATE(2000),
    [sym_paren_expression] = STATE(2000),
    [sym__high_prec_app] = STATE(2003),
    [sym__low_prec_app] = STATE(2003),
    [sym_application_expression] = STATE(2000),
    [sym_dot_expression] = STATE(2000),
    [sym_infix_expression] = STATE(2000),
    [sym_ce_expression] = STATE(2000),
    [sym_sequential_expression] = STATE(2000),
    [sym_char] = STATE(1801),
    [sym_format_string] = STATE(1804),
    [sym__string_literal] = STATE(1804),
    [sym_string] = STATE(1801),
    [sym_verbatim_string] = STATE(1801),
    [sym_bytearray] = STATE(1801),
    [sym_verbatim_bytearray] = STATE(1801),
    [sym_format_triple_quoted_string] = STATE(1807),
    [sym_triple_quoted_string] = STATE(1801),
    [sym_const] = STATE(2000),
    [sym_long_identifier] = STATE(1725),
    [sym_active_pattern] = STATE(1726),
    [sym__identifier_or_op] = STATE(1751),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(723),
    [sym_sbyte] = STATE(1801),
    [sym_byte] = STATE(1801),
    [sym_int16] = STATE(1801),
    [sym_uint16] = STATE(1801),
    [sym_int32] = STATE(1801),
    [sym_uint32] = STATE(1801),
    [sym_nativeint] = STATE(1801),
    [sym_unativeint] = STATE(1801),
    [sym_int64] = STATE(1801),
    [sym_uint64] = STATE(1801),
    [sym_ieee32] = STATE(1801),
    [sym_ieee64] = STATE(1801),
    [sym_bignum] = STATE(1801),
    [sym_decimal] = STATE(1801),
    [sym_float] = STATE(1427),
    [sym_block_comment] = STATE(394),
    [sym_compiler_directive_decl] = STATE(394),
    [sym_fsi_directive_decl] = STATE(394),
    [sym_preproc_line] = STATE(394),
    [sym_preproc_if_in_expression] = STATE(2000),
    [sym_preproc_else_in_expression] = STATE(6839),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [aux_sym_preproc_if_in_expression_repeat1] = STATE(416),
    [sym_identifier] = ACTIONS(629),
    [anon_sym_return] = ACTIONS(633),
    [anon_sym_do] = ACTIONS(635),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(637),
    [anon_sym_null] = ACTIONS(641),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(643),
    [anon_sym_LBRACK_PIPE] = ACTIONS(645),
    [anon_sym_LBRACE] = ACTIONS(1713),
    [anon_sym_LT_AT] = ACTIONS(647),
    [anon_sym_LT_AT_AT] = ACTIONS(1715),
    [anon_sym_LBRACE_PIPE] = ACTIONS(653),
    [anon_sym_new] = ACTIONS(633),
    [anon_sym_return_BANG] = ACTIONS(655),
    [anon_sym_yield] = ACTIONS(633),
    [anon_sym_yield_BANG] = ACTIONS(655),
    [anon_sym_lazy] = ACTIONS(633),
    [anon_sym_assert] = ACTIONS(633),
    [anon_sym_upcast] = ACTIONS(633),
    [anon_sym_downcast] = ACTIONS(633),
    [anon_sym_for] = ACTIONS(659),
    [anon_sym_while] = ACTIONS(661),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(663),
    [anon_sym_try] = ACTIONS(665),
    [anon_sym_match] = ACTIONS(667),
    [anon_sym_match_BANG] = ACTIONS(669),
    [anon_sym_function] = ACTIONS(671),
    [anon_sym_use] = ACTIONS(679),
    [anon_sym_use_BANG] = ACTIONS(681),
    [anon_sym_do_BANG] = ACTIONS(683),
    [anon_sym_begin] = ACTIONS(685),
    [aux_sym_char_token1] = ACTIONS(689),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(691),
    [anon_sym_DQUOTE] = ACTIONS(693),
    [anon_sym_AT_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(697),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(699),
    [sym_bool] = ACTIONS(701),
    [sym_unit] = ACTIONS(1717),
    [anon_sym_LPAREN_PIPE] = ACTIONS(705),
    [sym_op_identifier] = ACTIONS(1719),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(709),
    [sym_xint] = ACTIONS(711),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(713),
    [anon_sym_POUNDendif] = ACTIONS(1761),
    [anon_sym_POUNDelse] = ACTIONS(1723),
    [sym__newline] = ACTIONS(1725),
  },
  [395] = {
    [sym_function_or_value_defn] = STATE(532),
    [sym__expression] = STATE(102),
    [sym_literal_expression] = STATE(2000),
    [sym_long_identifier_or_op] = STATE(2000),
    [sym_tuple_expression] = STATE(2000),
    [sym_brace_expression] = STATE(2000),
    [sym_anon_record_expression] = STATE(2000),
    [sym_prefixed_expression] = STATE(2000),
    [sym_typecast_expression] = STATE(2000),
    [sym_for_expression] = STATE(2000),
    [sym_while_expression] = STATE(2000),
    [sym__if_branch] = STATE(6707),
    [sym_if_expression] = STATE(2000),
    [sym_fun_expression] = STATE(2000),
    [sym_try_expression] = STATE(2000),
    [sym_match_expression] = STATE(2000),
    [sym_function_expression] = STATE(2000),
    [sym_mutate_expression] = STATE(2000),
    [sym_index_expression] = STATE(2000),
    [sym_typed_expression] = STATE(2000),
    [sym_declaration_expression] = STATE(2000),
    [sym_do_expression] = STATE(2000),
    [sym_list_expression] = STATE(2000),
    [sym_array_expression] = STATE(2000),
    [sym_begin_end_expression] = STATE(2000),
    [sym_paren_expression] = STATE(2000),
    [sym__high_prec_app] = STATE(2003),
    [sym__low_prec_app] = STATE(2003),
    [sym_application_expression] = STATE(2000),
    [sym_dot_expression] = STATE(2000),
    [sym_infix_expression] = STATE(2000),
    [sym_ce_expression] = STATE(2000),
    [sym_sequential_expression] = STATE(2000),
    [sym_char] = STATE(1801),
    [sym_format_string] = STATE(1804),
    [sym__string_literal] = STATE(1804),
    [sym_string] = STATE(1801),
    [sym_verbatim_string] = STATE(1801),
    [sym_bytearray] = STATE(1801),
    [sym_verbatim_bytearray] = STATE(1801),
    [sym_format_triple_quoted_string] = STATE(1807),
    [sym_triple_quoted_string] = STATE(1801),
    [sym_const] = STATE(2000),
    [sym_long_identifier] = STATE(1725),
    [sym_active_pattern] = STATE(1726),
    [sym__identifier_or_op] = STATE(1751),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(723),
    [sym_sbyte] = STATE(1801),
    [sym_byte] = STATE(1801),
    [sym_int16] = STATE(1801),
    [sym_uint16] = STATE(1801),
    [sym_int32] = STATE(1801),
    [sym_uint32] = STATE(1801),
    [sym_nativeint] = STATE(1801),
    [sym_unativeint] = STATE(1801),
    [sym_int64] = STATE(1801),
    [sym_uint64] = STATE(1801),
    [sym_ieee32] = STATE(1801),
    [sym_ieee64] = STATE(1801),
    [sym_bignum] = STATE(1801),
    [sym_decimal] = STATE(1801),
    [sym_float] = STATE(1427),
    [sym_block_comment] = STATE(395),
    [sym_compiler_directive_decl] = STATE(395),
    [sym_fsi_directive_decl] = STATE(395),
    [sym_preproc_line] = STATE(395),
    [sym_preproc_if_in_expression] = STATE(2000),
    [sym_preproc_else_in_expression] = STATE(6677),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [aux_sym_preproc_if_in_expression_repeat1] = STATE(367),
    [sym_identifier] = ACTIONS(629),
    [anon_sym_return] = ACTIONS(633),
    [anon_sym_do] = ACTIONS(635),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(637),
    [anon_sym_null] = ACTIONS(641),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(643),
    [anon_sym_LBRACK_PIPE] = ACTIONS(645),
    [anon_sym_LBRACE] = ACTIONS(1713),
    [anon_sym_LT_AT] = ACTIONS(647),
    [anon_sym_LT_AT_AT] = ACTIONS(1715),
    [anon_sym_LBRACE_PIPE] = ACTIONS(653),
    [anon_sym_new] = ACTIONS(633),
    [anon_sym_return_BANG] = ACTIONS(655),
    [anon_sym_yield] = ACTIONS(633),
    [anon_sym_yield_BANG] = ACTIONS(655),
    [anon_sym_lazy] = ACTIONS(633),
    [anon_sym_assert] = ACTIONS(633),
    [anon_sym_upcast] = ACTIONS(633),
    [anon_sym_downcast] = ACTIONS(633),
    [anon_sym_for] = ACTIONS(659),
    [anon_sym_while] = ACTIONS(661),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(663),
    [anon_sym_try] = ACTIONS(665),
    [anon_sym_match] = ACTIONS(667),
    [anon_sym_match_BANG] = ACTIONS(669),
    [anon_sym_function] = ACTIONS(671),
    [anon_sym_use] = ACTIONS(679),
    [anon_sym_use_BANG] = ACTIONS(681),
    [anon_sym_do_BANG] = ACTIONS(683),
    [anon_sym_begin] = ACTIONS(685),
    [aux_sym_char_token1] = ACTIONS(689),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(691),
    [anon_sym_DQUOTE] = ACTIONS(693),
    [anon_sym_AT_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(697),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(699),
    [sym_bool] = ACTIONS(701),
    [sym_unit] = ACTIONS(1717),
    [anon_sym_LPAREN_PIPE] = ACTIONS(705),
    [sym_op_identifier] = ACTIONS(1719),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(709),
    [sym_xint] = ACTIONS(711),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(713),
    [anon_sym_POUNDendif] = ACTIONS(1763),
    [anon_sym_POUNDelse] = ACTIONS(1723),
    [sym__newline] = ACTIONS(1725),
  },
  [396] = {
    [sym_function_or_value_defn] = STATE(532),
    [sym__expression] = STATE(102),
    [sym_literal_expression] = STATE(2000),
    [sym_long_identifier_or_op] = STATE(2000),
    [sym_tuple_expression] = STATE(2000),
    [sym_brace_expression] = STATE(2000),
    [sym_anon_record_expression] = STATE(2000),
    [sym_prefixed_expression] = STATE(2000),
    [sym_typecast_expression] = STATE(2000),
    [sym_for_expression] = STATE(2000),
    [sym_while_expression] = STATE(2000),
    [sym__if_branch] = STATE(6707),
    [sym_if_expression] = STATE(2000),
    [sym_fun_expression] = STATE(2000),
    [sym_try_expression] = STATE(2000),
    [sym_match_expression] = STATE(2000),
    [sym_function_expression] = STATE(2000),
    [sym_mutate_expression] = STATE(2000),
    [sym_index_expression] = STATE(2000),
    [sym_typed_expression] = STATE(2000),
    [sym_declaration_expression] = STATE(2000),
    [sym_do_expression] = STATE(2000),
    [sym_list_expression] = STATE(2000),
    [sym_array_expression] = STATE(2000),
    [sym_begin_end_expression] = STATE(2000),
    [sym_paren_expression] = STATE(2000),
    [sym__high_prec_app] = STATE(2003),
    [sym__low_prec_app] = STATE(2003),
    [sym_application_expression] = STATE(2000),
    [sym_dot_expression] = STATE(2000),
    [sym_infix_expression] = STATE(2000),
    [sym_ce_expression] = STATE(2000),
    [sym_sequential_expression] = STATE(2000),
    [sym_char] = STATE(1801),
    [sym_format_string] = STATE(1804),
    [sym__string_literal] = STATE(1804),
    [sym_string] = STATE(1801),
    [sym_verbatim_string] = STATE(1801),
    [sym_bytearray] = STATE(1801),
    [sym_verbatim_bytearray] = STATE(1801),
    [sym_format_triple_quoted_string] = STATE(1807),
    [sym_triple_quoted_string] = STATE(1801),
    [sym_const] = STATE(2000),
    [sym_long_identifier] = STATE(1725),
    [sym_active_pattern] = STATE(1726),
    [sym__identifier_or_op] = STATE(1751),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(723),
    [sym_sbyte] = STATE(1801),
    [sym_byte] = STATE(1801),
    [sym_int16] = STATE(1801),
    [sym_uint16] = STATE(1801),
    [sym_int32] = STATE(1801),
    [sym_uint32] = STATE(1801),
    [sym_nativeint] = STATE(1801),
    [sym_unativeint] = STATE(1801),
    [sym_int64] = STATE(1801),
    [sym_uint64] = STATE(1801),
    [sym_ieee32] = STATE(1801),
    [sym_ieee64] = STATE(1801),
    [sym_bignum] = STATE(1801),
    [sym_decimal] = STATE(1801),
    [sym_float] = STATE(1427),
    [sym_block_comment] = STATE(396),
    [sym_compiler_directive_decl] = STATE(396),
    [sym_fsi_directive_decl] = STATE(396),
    [sym_preproc_line] = STATE(396),
    [sym_preproc_if_in_expression] = STATE(2000),
    [sym_preproc_else_in_expression] = STATE(6477),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [aux_sym_preproc_if_in_expression_repeat1] = STATE(386),
    [sym_identifier] = ACTIONS(629),
    [anon_sym_return] = ACTIONS(633),
    [anon_sym_do] = ACTIONS(635),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(637),
    [anon_sym_null] = ACTIONS(641),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(643),
    [anon_sym_LBRACK_PIPE] = ACTIONS(645),
    [anon_sym_LBRACE] = ACTIONS(1713),
    [anon_sym_LT_AT] = ACTIONS(647),
    [anon_sym_LT_AT_AT] = ACTIONS(1715),
    [anon_sym_LBRACE_PIPE] = ACTIONS(653),
    [anon_sym_new] = ACTIONS(633),
    [anon_sym_return_BANG] = ACTIONS(655),
    [anon_sym_yield] = ACTIONS(633),
    [anon_sym_yield_BANG] = ACTIONS(655),
    [anon_sym_lazy] = ACTIONS(633),
    [anon_sym_assert] = ACTIONS(633),
    [anon_sym_upcast] = ACTIONS(633),
    [anon_sym_downcast] = ACTIONS(633),
    [anon_sym_for] = ACTIONS(659),
    [anon_sym_while] = ACTIONS(661),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(663),
    [anon_sym_try] = ACTIONS(665),
    [anon_sym_match] = ACTIONS(667),
    [anon_sym_match_BANG] = ACTIONS(669),
    [anon_sym_function] = ACTIONS(671),
    [anon_sym_use] = ACTIONS(679),
    [anon_sym_use_BANG] = ACTIONS(681),
    [anon_sym_do_BANG] = ACTIONS(683),
    [anon_sym_begin] = ACTIONS(685),
    [aux_sym_char_token1] = ACTIONS(689),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(691),
    [anon_sym_DQUOTE] = ACTIONS(693),
    [anon_sym_AT_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(697),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(699),
    [sym_bool] = ACTIONS(701),
    [sym_unit] = ACTIONS(1717),
    [anon_sym_LPAREN_PIPE] = ACTIONS(705),
    [sym_op_identifier] = ACTIONS(1719),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(709),
    [sym_xint] = ACTIONS(711),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(713),
    [anon_sym_POUNDendif] = ACTIONS(1765),
    [anon_sym_POUNDelse] = ACTIONS(1723),
    [sym__newline] = ACTIONS(1725),
  },
  [397] = {
    [sym_function_or_value_defn] = STATE(663),
    [sym__expression] = STATE(73),
    [sym_literal_expression] = STATE(1118),
    [sym_long_identifier_or_op] = STATE(1118),
    [sym_tuple_expression] = STATE(1118),
    [sym_brace_expression] = STATE(1118),
    [sym_anon_record_expression] = STATE(1118),
    [sym_prefixed_expression] = STATE(1118),
    [sym_typecast_expression] = STATE(1118),
    [sym_for_expression] = STATE(1118),
    [sym_while_expression] = STATE(1118),
    [sym__if_branch] = STATE(7163),
    [sym_if_expression] = STATE(1118),
    [sym_fun_expression] = STATE(1118),
    [sym_try_expression] = STATE(1118),
    [sym_match_expression] = STATE(1118),
    [sym_function_expression] = STATE(1118),
    [sym_mutate_expression] = STATE(1118),
    [sym_index_expression] = STATE(1118),
    [sym_typed_expression] = STATE(1118),
    [sym_declaration_expression] = STATE(1118),
    [sym_do_expression] = STATE(1118),
    [sym_list_expression] = STATE(1118),
    [sym_array_expression] = STATE(1118),
    [sym_begin_end_expression] = STATE(1118),
    [sym_paren_expression] = STATE(1118),
    [sym__high_prec_app] = STATE(1133),
    [sym__low_prec_app] = STATE(1133),
    [sym_application_expression] = STATE(1118),
    [sym_dot_expression] = STATE(1118),
    [sym_infix_expression] = STATE(1118),
    [sym_ce_expression] = STATE(1118),
    [sym_sequential_expression] = STATE(1118),
    [sym_slice_ranges] = STATE(7142),
    [sym__slice_range_special] = STATE(6328),
    [sym_slice_range] = STATE(5802),
    [sym_char] = STATE(1080),
    [sym_format_string] = STATE(1090),
    [sym__string_literal] = STATE(1090),
    [sym_string] = STATE(1080),
    [sym_verbatim_string] = STATE(1080),
    [sym_bytearray] = STATE(1080),
    [sym_verbatim_bytearray] = STATE(1080),
    [sym_format_triple_quoted_string] = STATE(1096),
    [sym_triple_quoted_string] = STATE(1080),
    [sym_const] = STATE(1118),
    [sym_long_identifier] = STATE(1156),
    [sym_active_pattern] = STATE(1085),
    [sym__identifier_or_op] = STATE(1099),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(548),
    [sym_sbyte] = STATE(1080),
    [sym_byte] = STATE(1080),
    [sym_int16] = STATE(1080),
    [sym_uint16] = STATE(1080),
    [sym_int32] = STATE(1080),
    [sym_uint32] = STATE(1080),
    [sym_nativeint] = STATE(1080),
    [sym_unativeint] = STATE(1080),
    [sym_int64] = STATE(1080),
    [sym_uint64] = STATE(1080),
    [sym_ieee32] = STATE(1080),
    [sym_ieee64] = STATE(1080),
    [sym_bignum] = STATE(1080),
    [sym_decimal] = STATE(1080),
    [sym_float] = STATE(979),
    [sym_block_comment] = STATE(397),
    [sym_compiler_directive_decl] = STATE(397),
    [sym_fsi_directive_decl] = STATE(397),
    [sym_preproc_line] = STATE(397),
    [sym_preproc_if_in_expression] = STATE(1118),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(195),
    [anon_sym_return] = ACTIONS(481),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_null] = ACTIONS(207),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(209),
    [anon_sym_LBRACK_PIPE] = ACTIONS(211),
    [anon_sym_LBRACE] = ACTIONS(1687),
    [anon_sym_LT_AT] = ACTIONS(213),
    [anon_sym_LT_AT_AT] = ACTIONS(1689),
    [anon_sym_LBRACE_PIPE] = ACTIONS(217),
    [anon_sym_new] = ACTIONS(481),
    [anon_sym_return_BANG] = ACTIONS(487),
    [anon_sym_yield] = ACTIONS(481),
    [anon_sym_yield_BANG] = ACTIONS(487),
    [anon_sym_lazy] = ACTIONS(481),
    [anon_sym_assert] = ACTIONS(481),
    [anon_sym_upcast] = ACTIONS(481),
    [anon_sym_downcast] = ACTIONS(481),
    [anon_sym_for] = ACTIONS(489),
    [anon_sym_while] = ACTIONS(225),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(229),
    [anon_sym_match] = ACTIONS(231),
    [anon_sym_match_BANG] = ACTIONS(233),
    [anon_sym_function] = ACTIONS(235),
    [anon_sym_use] = ACTIONS(493),
    [anon_sym_use_BANG] = ACTIONS(495),
    [anon_sym_do_BANG] = ACTIONS(243),
    [anon_sym_begin] = ACTIONS(245),
    [anon_sym_DOT_DOT3] = ACTIONS(1709),
    [anon_sym_STAR] = ACTIONS(1711),
    [aux_sym_char_token1] = ACTIONS(247),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(251),
    [anon_sym_AT_DQUOTE] = ACTIONS(253),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(255),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(257),
    [sym_bool] = ACTIONS(259),
    [sym_unit] = ACTIONS(1699),
    [anon_sym_LPAREN_PIPE] = ACTIONS(261),
    [sym_op_identifier] = ACTIONS(1701),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(499),
    [sym_xint] = ACTIONS(267),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(269),
  },
  [398] = {
    [sym_function_or_value_defn] = STATE(532),
    [sym__expression] = STATE(102),
    [sym_literal_expression] = STATE(2000),
    [sym_long_identifier_or_op] = STATE(2000),
    [sym_tuple_expression] = STATE(2000),
    [sym_brace_expression] = STATE(2000),
    [sym_anon_record_expression] = STATE(2000),
    [sym_prefixed_expression] = STATE(2000),
    [sym_typecast_expression] = STATE(2000),
    [sym_for_expression] = STATE(2000),
    [sym_while_expression] = STATE(2000),
    [sym__if_branch] = STATE(6707),
    [sym_if_expression] = STATE(2000),
    [sym_fun_expression] = STATE(2000),
    [sym_try_expression] = STATE(2000),
    [sym_match_expression] = STATE(2000),
    [sym_function_expression] = STATE(2000),
    [sym_mutate_expression] = STATE(2000),
    [sym_index_expression] = STATE(2000),
    [sym_typed_expression] = STATE(2000),
    [sym_declaration_expression] = STATE(2000),
    [sym_do_expression] = STATE(2000),
    [sym_list_expression] = STATE(2000),
    [sym_array_expression] = STATE(2000),
    [sym_begin_end_expression] = STATE(2000),
    [sym_paren_expression] = STATE(2000),
    [sym__high_prec_app] = STATE(2003),
    [sym__low_prec_app] = STATE(2003),
    [sym_application_expression] = STATE(2000),
    [sym_dot_expression] = STATE(2000),
    [sym_infix_expression] = STATE(2000),
    [sym_ce_expression] = STATE(2000),
    [sym_sequential_expression] = STATE(2000),
    [sym_char] = STATE(1801),
    [sym_format_string] = STATE(1804),
    [sym__string_literal] = STATE(1804),
    [sym_string] = STATE(1801),
    [sym_verbatim_string] = STATE(1801),
    [sym_bytearray] = STATE(1801),
    [sym_verbatim_bytearray] = STATE(1801),
    [sym_format_triple_quoted_string] = STATE(1807),
    [sym_triple_quoted_string] = STATE(1801),
    [sym_const] = STATE(2000),
    [sym_long_identifier] = STATE(1725),
    [sym_active_pattern] = STATE(1726),
    [sym__identifier_or_op] = STATE(1751),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(723),
    [sym_sbyte] = STATE(1801),
    [sym_byte] = STATE(1801),
    [sym_int16] = STATE(1801),
    [sym_uint16] = STATE(1801),
    [sym_int32] = STATE(1801),
    [sym_uint32] = STATE(1801),
    [sym_nativeint] = STATE(1801),
    [sym_unativeint] = STATE(1801),
    [sym_int64] = STATE(1801),
    [sym_uint64] = STATE(1801),
    [sym_ieee32] = STATE(1801),
    [sym_ieee64] = STATE(1801),
    [sym_bignum] = STATE(1801),
    [sym_decimal] = STATE(1801),
    [sym_float] = STATE(1427),
    [sym_block_comment] = STATE(398),
    [sym_compiler_directive_decl] = STATE(398),
    [sym_fsi_directive_decl] = STATE(398),
    [sym_preproc_line] = STATE(398),
    [sym_preproc_if_in_expression] = STATE(2000),
    [sym_preproc_else_in_expression] = STATE(6805),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [aux_sym_preproc_if_in_expression_repeat1] = STATE(394),
    [sym_identifier] = ACTIONS(629),
    [anon_sym_return] = ACTIONS(633),
    [anon_sym_do] = ACTIONS(635),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(637),
    [anon_sym_null] = ACTIONS(641),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(643),
    [anon_sym_LBRACK_PIPE] = ACTIONS(645),
    [anon_sym_LBRACE] = ACTIONS(1713),
    [anon_sym_LT_AT] = ACTIONS(647),
    [anon_sym_LT_AT_AT] = ACTIONS(1715),
    [anon_sym_LBRACE_PIPE] = ACTIONS(653),
    [anon_sym_new] = ACTIONS(633),
    [anon_sym_return_BANG] = ACTIONS(655),
    [anon_sym_yield] = ACTIONS(633),
    [anon_sym_yield_BANG] = ACTIONS(655),
    [anon_sym_lazy] = ACTIONS(633),
    [anon_sym_assert] = ACTIONS(633),
    [anon_sym_upcast] = ACTIONS(633),
    [anon_sym_downcast] = ACTIONS(633),
    [anon_sym_for] = ACTIONS(659),
    [anon_sym_while] = ACTIONS(661),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(663),
    [anon_sym_try] = ACTIONS(665),
    [anon_sym_match] = ACTIONS(667),
    [anon_sym_match_BANG] = ACTIONS(669),
    [anon_sym_function] = ACTIONS(671),
    [anon_sym_use] = ACTIONS(679),
    [anon_sym_use_BANG] = ACTIONS(681),
    [anon_sym_do_BANG] = ACTIONS(683),
    [anon_sym_begin] = ACTIONS(685),
    [aux_sym_char_token1] = ACTIONS(689),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(691),
    [anon_sym_DQUOTE] = ACTIONS(693),
    [anon_sym_AT_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(697),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(699),
    [sym_bool] = ACTIONS(701),
    [sym_unit] = ACTIONS(1717),
    [anon_sym_LPAREN_PIPE] = ACTIONS(705),
    [sym_op_identifier] = ACTIONS(1719),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(709),
    [sym_xint] = ACTIONS(711),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(713),
    [anon_sym_POUNDendif] = ACTIONS(1767),
    [anon_sym_POUNDelse] = ACTIONS(1723),
    [sym__newline] = ACTIONS(1725),
  },
  [399] = {
    [sym_function_or_value_defn] = STATE(532),
    [sym__expression] = STATE(102),
    [sym_literal_expression] = STATE(2000),
    [sym_long_identifier_or_op] = STATE(2000),
    [sym_tuple_expression] = STATE(2000),
    [sym_brace_expression] = STATE(2000),
    [sym_anon_record_expression] = STATE(2000),
    [sym_prefixed_expression] = STATE(2000),
    [sym_typecast_expression] = STATE(2000),
    [sym_for_expression] = STATE(2000),
    [sym_while_expression] = STATE(2000),
    [sym__if_branch] = STATE(6707),
    [sym_if_expression] = STATE(2000),
    [sym_fun_expression] = STATE(2000),
    [sym_try_expression] = STATE(2000),
    [sym_match_expression] = STATE(2000),
    [sym_function_expression] = STATE(2000),
    [sym_mutate_expression] = STATE(2000),
    [sym_index_expression] = STATE(2000),
    [sym_typed_expression] = STATE(2000),
    [sym_declaration_expression] = STATE(2000),
    [sym_do_expression] = STATE(2000),
    [sym_list_expression] = STATE(2000),
    [sym_array_expression] = STATE(2000),
    [sym_begin_end_expression] = STATE(2000),
    [sym_paren_expression] = STATE(2000),
    [sym__high_prec_app] = STATE(2003),
    [sym__low_prec_app] = STATE(2003),
    [sym_application_expression] = STATE(2000),
    [sym_dot_expression] = STATE(2000),
    [sym_infix_expression] = STATE(2000),
    [sym_ce_expression] = STATE(2000),
    [sym_sequential_expression] = STATE(2000),
    [sym_char] = STATE(1801),
    [sym_format_string] = STATE(1804),
    [sym__string_literal] = STATE(1804),
    [sym_string] = STATE(1801),
    [sym_verbatim_string] = STATE(1801),
    [sym_bytearray] = STATE(1801),
    [sym_verbatim_bytearray] = STATE(1801),
    [sym_format_triple_quoted_string] = STATE(1807),
    [sym_triple_quoted_string] = STATE(1801),
    [sym_const] = STATE(2000),
    [sym_long_identifier] = STATE(1725),
    [sym_active_pattern] = STATE(1726),
    [sym__identifier_or_op] = STATE(1751),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(723),
    [sym_sbyte] = STATE(1801),
    [sym_byte] = STATE(1801),
    [sym_int16] = STATE(1801),
    [sym_uint16] = STATE(1801),
    [sym_int32] = STATE(1801),
    [sym_uint32] = STATE(1801),
    [sym_nativeint] = STATE(1801),
    [sym_unativeint] = STATE(1801),
    [sym_int64] = STATE(1801),
    [sym_uint64] = STATE(1801),
    [sym_ieee32] = STATE(1801),
    [sym_ieee64] = STATE(1801),
    [sym_bignum] = STATE(1801),
    [sym_decimal] = STATE(1801),
    [sym_float] = STATE(1427),
    [sym_block_comment] = STATE(399),
    [sym_compiler_directive_decl] = STATE(399),
    [sym_fsi_directive_decl] = STATE(399),
    [sym_preproc_line] = STATE(399),
    [sym_preproc_if_in_expression] = STATE(2000),
    [sym_preproc_else_in_expression] = STATE(7351),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [aux_sym_preproc_if_in_expression_repeat1] = STATE(416),
    [sym_identifier] = ACTIONS(629),
    [anon_sym_return] = ACTIONS(633),
    [anon_sym_do] = ACTIONS(635),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(637),
    [anon_sym_null] = ACTIONS(641),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(643),
    [anon_sym_LBRACK_PIPE] = ACTIONS(645),
    [anon_sym_LBRACE] = ACTIONS(1713),
    [anon_sym_LT_AT] = ACTIONS(647),
    [anon_sym_LT_AT_AT] = ACTIONS(1715),
    [anon_sym_LBRACE_PIPE] = ACTIONS(653),
    [anon_sym_new] = ACTIONS(633),
    [anon_sym_return_BANG] = ACTIONS(655),
    [anon_sym_yield] = ACTIONS(633),
    [anon_sym_yield_BANG] = ACTIONS(655),
    [anon_sym_lazy] = ACTIONS(633),
    [anon_sym_assert] = ACTIONS(633),
    [anon_sym_upcast] = ACTIONS(633),
    [anon_sym_downcast] = ACTIONS(633),
    [anon_sym_for] = ACTIONS(659),
    [anon_sym_while] = ACTIONS(661),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(663),
    [anon_sym_try] = ACTIONS(665),
    [anon_sym_match] = ACTIONS(667),
    [anon_sym_match_BANG] = ACTIONS(669),
    [anon_sym_function] = ACTIONS(671),
    [anon_sym_use] = ACTIONS(679),
    [anon_sym_use_BANG] = ACTIONS(681),
    [anon_sym_do_BANG] = ACTIONS(683),
    [anon_sym_begin] = ACTIONS(685),
    [aux_sym_char_token1] = ACTIONS(689),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(691),
    [anon_sym_DQUOTE] = ACTIONS(693),
    [anon_sym_AT_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(697),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(699),
    [sym_bool] = ACTIONS(701),
    [sym_unit] = ACTIONS(1717),
    [anon_sym_LPAREN_PIPE] = ACTIONS(705),
    [sym_op_identifier] = ACTIONS(1719),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(709),
    [sym_xint] = ACTIONS(711),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(713),
    [anon_sym_POUNDendif] = ACTIONS(1769),
    [anon_sym_POUNDelse] = ACTIONS(1723),
    [sym__newline] = ACTIONS(1725),
  },
  [400] = {
    [sym_function_or_value_defn] = STATE(532),
    [sym__expression] = STATE(102),
    [sym_literal_expression] = STATE(2000),
    [sym_long_identifier_or_op] = STATE(2000),
    [sym_tuple_expression] = STATE(2000),
    [sym_brace_expression] = STATE(2000),
    [sym_anon_record_expression] = STATE(2000),
    [sym_prefixed_expression] = STATE(2000),
    [sym_typecast_expression] = STATE(2000),
    [sym_for_expression] = STATE(2000),
    [sym_while_expression] = STATE(2000),
    [sym__if_branch] = STATE(6707),
    [sym_if_expression] = STATE(2000),
    [sym_fun_expression] = STATE(2000),
    [sym_try_expression] = STATE(2000),
    [sym_match_expression] = STATE(2000),
    [sym_function_expression] = STATE(2000),
    [sym_mutate_expression] = STATE(2000),
    [sym_index_expression] = STATE(2000),
    [sym_typed_expression] = STATE(2000),
    [sym_declaration_expression] = STATE(2000),
    [sym_do_expression] = STATE(2000),
    [sym_list_expression] = STATE(2000),
    [sym_array_expression] = STATE(2000),
    [sym_begin_end_expression] = STATE(2000),
    [sym_paren_expression] = STATE(2000),
    [sym__high_prec_app] = STATE(2003),
    [sym__low_prec_app] = STATE(2003),
    [sym_application_expression] = STATE(2000),
    [sym_dot_expression] = STATE(2000),
    [sym_infix_expression] = STATE(2000),
    [sym_ce_expression] = STATE(2000),
    [sym_sequential_expression] = STATE(2000),
    [sym_char] = STATE(1801),
    [sym_format_string] = STATE(1804),
    [sym__string_literal] = STATE(1804),
    [sym_string] = STATE(1801),
    [sym_verbatim_string] = STATE(1801),
    [sym_bytearray] = STATE(1801),
    [sym_verbatim_bytearray] = STATE(1801),
    [sym_format_triple_quoted_string] = STATE(1807),
    [sym_triple_quoted_string] = STATE(1801),
    [sym_const] = STATE(2000),
    [sym_long_identifier] = STATE(1725),
    [sym_active_pattern] = STATE(1726),
    [sym__identifier_or_op] = STATE(1751),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(723),
    [sym_sbyte] = STATE(1801),
    [sym_byte] = STATE(1801),
    [sym_int16] = STATE(1801),
    [sym_uint16] = STATE(1801),
    [sym_int32] = STATE(1801),
    [sym_uint32] = STATE(1801),
    [sym_nativeint] = STATE(1801),
    [sym_unativeint] = STATE(1801),
    [sym_int64] = STATE(1801),
    [sym_uint64] = STATE(1801),
    [sym_ieee32] = STATE(1801),
    [sym_ieee64] = STATE(1801),
    [sym_bignum] = STATE(1801),
    [sym_decimal] = STATE(1801),
    [sym_float] = STATE(1427),
    [sym_block_comment] = STATE(400),
    [sym_compiler_directive_decl] = STATE(400),
    [sym_fsi_directive_decl] = STATE(400),
    [sym_preproc_line] = STATE(400),
    [sym_preproc_if_in_expression] = STATE(2000),
    [sym_preproc_else_in_expression] = STATE(6991),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [aux_sym_preproc_if_in_expression_repeat1] = STATE(391),
    [sym_identifier] = ACTIONS(629),
    [anon_sym_return] = ACTIONS(633),
    [anon_sym_do] = ACTIONS(635),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(637),
    [anon_sym_null] = ACTIONS(641),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(643),
    [anon_sym_LBRACK_PIPE] = ACTIONS(645),
    [anon_sym_LBRACE] = ACTIONS(1713),
    [anon_sym_LT_AT] = ACTIONS(647),
    [anon_sym_LT_AT_AT] = ACTIONS(1715),
    [anon_sym_LBRACE_PIPE] = ACTIONS(653),
    [anon_sym_new] = ACTIONS(633),
    [anon_sym_return_BANG] = ACTIONS(655),
    [anon_sym_yield] = ACTIONS(633),
    [anon_sym_yield_BANG] = ACTIONS(655),
    [anon_sym_lazy] = ACTIONS(633),
    [anon_sym_assert] = ACTIONS(633),
    [anon_sym_upcast] = ACTIONS(633),
    [anon_sym_downcast] = ACTIONS(633),
    [anon_sym_for] = ACTIONS(659),
    [anon_sym_while] = ACTIONS(661),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(663),
    [anon_sym_try] = ACTIONS(665),
    [anon_sym_match] = ACTIONS(667),
    [anon_sym_match_BANG] = ACTIONS(669),
    [anon_sym_function] = ACTIONS(671),
    [anon_sym_use] = ACTIONS(679),
    [anon_sym_use_BANG] = ACTIONS(681),
    [anon_sym_do_BANG] = ACTIONS(683),
    [anon_sym_begin] = ACTIONS(685),
    [aux_sym_char_token1] = ACTIONS(689),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(691),
    [anon_sym_DQUOTE] = ACTIONS(693),
    [anon_sym_AT_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(697),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(699),
    [sym_bool] = ACTIONS(701),
    [sym_unit] = ACTIONS(1717),
    [anon_sym_LPAREN_PIPE] = ACTIONS(705),
    [sym_op_identifier] = ACTIONS(1719),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(709),
    [sym_xint] = ACTIONS(711),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(713),
    [anon_sym_POUNDendif] = ACTIONS(1771),
    [anon_sym_POUNDelse] = ACTIONS(1723),
    [sym__newline] = ACTIONS(1725),
  },
  [401] = {
    [sym_function_or_value_defn] = STATE(663),
    [sym__expression] = STATE(70),
    [sym_literal_expression] = STATE(1118),
    [sym_long_identifier_or_op] = STATE(1118),
    [sym_tuple_expression] = STATE(1118),
    [sym_brace_expression] = STATE(1118),
    [sym_anon_record_expression] = STATE(1118),
    [sym_prefixed_expression] = STATE(1118),
    [sym_typecast_expression] = STATE(1118),
    [sym_for_expression] = STATE(1118),
    [sym_while_expression] = STATE(1118),
    [sym__if_branch] = STATE(7163),
    [sym_if_expression] = STATE(1118),
    [sym_fun_expression] = STATE(1118),
    [sym_try_expression] = STATE(1118),
    [sym_match_expression] = STATE(1118),
    [sym_function_expression] = STATE(1118),
    [sym_mutate_expression] = STATE(1118),
    [sym_index_expression] = STATE(1118),
    [sym_typed_expression] = STATE(1118),
    [sym_declaration_expression] = STATE(1118),
    [sym_do_expression] = STATE(1118),
    [sym_list_expression] = STATE(1118),
    [sym_array_expression] = STATE(1118),
    [sym_begin_end_expression] = STATE(1118),
    [sym_paren_expression] = STATE(1118),
    [sym__high_prec_app] = STATE(1133),
    [sym__low_prec_app] = STATE(1133),
    [sym_application_expression] = STATE(1118),
    [sym_dot_expression] = STATE(1118),
    [sym_infix_expression] = STATE(1118),
    [sym_ce_expression] = STATE(1118),
    [sym_sequential_expression] = STATE(1118),
    [sym_slice_ranges] = STATE(7379),
    [sym__slice_range_special] = STATE(6328),
    [sym_slice_range] = STATE(5802),
    [sym_char] = STATE(1080),
    [sym_format_string] = STATE(1090),
    [sym__string_literal] = STATE(1090),
    [sym_string] = STATE(1080),
    [sym_verbatim_string] = STATE(1080),
    [sym_bytearray] = STATE(1080),
    [sym_verbatim_bytearray] = STATE(1080),
    [sym_format_triple_quoted_string] = STATE(1096),
    [sym_triple_quoted_string] = STATE(1080),
    [sym_const] = STATE(1118),
    [sym_long_identifier] = STATE(1156),
    [sym_active_pattern] = STATE(1085),
    [sym__identifier_or_op] = STATE(1099),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(548),
    [sym_sbyte] = STATE(1080),
    [sym_byte] = STATE(1080),
    [sym_int16] = STATE(1080),
    [sym_uint16] = STATE(1080),
    [sym_int32] = STATE(1080),
    [sym_uint32] = STATE(1080),
    [sym_nativeint] = STATE(1080),
    [sym_unativeint] = STATE(1080),
    [sym_int64] = STATE(1080),
    [sym_uint64] = STATE(1080),
    [sym_ieee32] = STATE(1080),
    [sym_ieee64] = STATE(1080),
    [sym_bignum] = STATE(1080),
    [sym_decimal] = STATE(1080),
    [sym_float] = STATE(979),
    [sym_block_comment] = STATE(401),
    [sym_compiler_directive_decl] = STATE(401),
    [sym_fsi_directive_decl] = STATE(401),
    [sym_preproc_line] = STATE(401),
    [sym_preproc_if_in_expression] = STATE(1118),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(195),
    [anon_sym_return] = ACTIONS(481),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_null] = ACTIONS(207),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(209),
    [anon_sym_LBRACK_PIPE] = ACTIONS(211),
    [anon_sym_LBRACE] = ACTIONS(1687),
    [anon_sym_LT_AT] = ACTIONS(213),
    [anon_sym_LT_AT_AT] = ACTIONS(1689),
    [anon_sym_LBRACE_PIPE] = ACTIONS(217),
    [anon_sym_new] = ACTIONS(481),
    [anon_sym_return_BANG] = ACTIONS(487),
    [anon_sym_yield] = ACTIONS(481),
    [anon_sym_yield_BANG] = ACTIONS(487),
    [anon_sym_lazy] = ACTIONS(481),
    [anon_sym_assert] = ACTIONS(481),
    [anon_sym_upcast] = ACTIONS(481),
    [anon_sym_downcast] = ACTIONS(481),
    [anon_sym_for] = ACTIONS(489),
    [anon_sym_while] = ACTIONS(225),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(229),
    [anon_sym_match] = ACTIONS(231),
    [anon_sym_match_BANG] = ACTIONS(233),
    [anon_sym_function] = ACTIONS(235),
    [anon_sym_use] = ACTIONS(493),
    [anon_sym_use_BANG] = ACTIONS(495),
    [anon_sym_do_BANG] = ACTIONS(243),
    [anon_sym_begin] = ACTIONS(245),
    [anon_sym_DOT_DOT3] = ACTIONS(1709),
    [anon_sym_STAR] = ACTIONS(1711),
    [aux_sym_char_token1] = ACTIONS(247),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(251),
    [anon_sym_AT_DQUOTE] = ACTIONS(253),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(255),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(257),
    [sym_bool] = ACTIONS(259),
    [sym_unit] = ACTIONS(1699),
    [anon_sym_LPAREN_PIPE] = ACTIONS(261),
    [sym_op_identifier] = ACTIONS(1701),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(499),
    [sym_xint] = ACTIONS(267),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(269),
  },
  [402] = {
    [sym_function_or_value_defn] = STATE(627),
    [sym__expression] = STATE(307),
    [sym_literal_expression] = STATE(1118),
    [sym_long_identifier_or_op] = STATE(1118),
    [sym_tuple_expression] = STATE(1118),
    [sym_brace_expression] = STATE(1118),
    [sym_anon_record_expression] = STATE(1118),
    [sym_object_expression] = STATE(6766),
    [sym_with_field_expression] = STATE(6766),
    [sym_prefixed_expression] = STATE(1118),
    [sym_typecast_expression] = STATE(1118),
    [sym_for_expression] = STATE(1118),
    [sym_while_expression] = STATE(1118),
    [sym__if_branch] = STATE(7163),
    [sym_if_expression] = STATE(1118),
    [sym_fun_expression] = STATE(1118),
    [sym_try_expression] = STATE(1118),
    [sym_match_expression] = STATE(1118),
    [sym_function_expression] = STATE(1118),
    [sym_mutate_expression] = STATE(1118),
    [sym_index_expression] = STATE(1118),
    [sym_typed_expression] = STATE(1118),
    [sym_declaration_expression] = STATE(1118),
    [sym_do_expression] = STATE(1118),
    [sym_list_expression] = STATE(1118),
    [sym_array_expression] = STATE(1118),
    [sym_begin_end_expression] = STATE(1118),
    [sym_paren_expression] = STATE(1118),
    [sym__high_prec_app] = STATE(1133),
    [sym__low_prec_app] = STATE(1133),
    [sym_application_expression] = STATE(1118),
    [sym_dot_expression] = STATE(1118),
    [sym_infix_expression] = STATE(1118),
    [sym_ce_expression] = STATE(1118),
    [sym_sequential_expression] = STATE(1118),
    [sym_field_initializer] = STATE(5913),
    [sym_field_initializers] = STATE(6766),
    [sym_char] = STATE(1080),
    [sym_format_string] = STATE(1090),
    [sym__string_literal] = STATE(1090),
    [sym_string] = STATE(1080),
    [sym_verbatim_string] = STATE(1080),
    [sym_bytearray] = STATE(1080),
    [sym_verbatim_bytearray] = STATE(1080),
    [sym_format_triple_quoted_string] = STATE(1096),
    [sym_triple_quoted_string] = STATE(1080),
    [sym_const] = STATE(1118),
    [sym_long_identifier] = STATE(2053),
    [sym_active_pattern] = STATE(1085),
    [sym__identifier_or_op] = STATE(1099),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(517),
    [sym_sbyte] = STATE(1080),
    [sym_byte] = STATE(1080),
    [sym_int16] = STATE(1080),
    [sym_uint16] = STATE(1080),
    [sym_int32] = STATE(1080),
    [sym_uint32] = STATE(1080),
    [sym_nativeint] = STATE(1080),
    [sym_unativeint] = STATE(1080),
    [sym_int64] = STATE(1080),
    [sym_uint64] = STATE(1080),
    [sym_ieee32] = STATE(1080),
    [sym_ieee64] = STATE(1080),
    [sym_bignum] = STATE(1080),
    [sym_decimal] = STATE(1080),
    [sym_float] = STATE(979),
    [sym_block_comment] = STATE(402),
    [sym_compiler_directive_decl] = STATE(402),
    [sym_fsi_directive_decl] = STATE(402),
    [sym_preproc_line] = STATE(402),
    [sym_preproc_if_in_expression] = STATE(1118),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(1773),
    [anon_sym_return] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_null] = ACTIONS(207),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(209),
    [anon_sym_LBRACK_PIPE] = ACTIONS(211),
    [anon_sym_LBRACE] = ACTIONS(1687),
    [anon_sym_LT_AT] = ACTIONS(213),
    [anon_sym_LT_AT_AT] = ACTIONS(1689),
    [anon_sym_LBRACE_PIPE] = ACTIONS(217),
    [anon_sym_new] = ACTIONS(1775),
    [anon_sym_return_BANG] = ACTIONS(219),
    [anon_sym_yield] = ACTIONS(199),
    [anon_sym_yield_BANG] = ACTIONS(219),
    [anon_sym_lazy] = ACTIONS(199),
    [anon_sym_assert] = ACTIONS(199),
    [anon_sym_upcast] = ACTIONS(199),
    [anon_sym_downcast] = ACTIONS(199),
    [anon_sym_for] = ACTIONS(223),
    [anon_sym_while] = ACTIONS(225),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(229),
    [anon_sym_match] = ACTIONS(231),
    [anon_sym_match_BANG] = ACTIONS(233),
    [anon_sym_function] = ACTIONS(235),
    [anon_sym_use] = ACTIONS(239),
    [anon_sym_use_BANG] = ACTIONS(241),
    [anon_sym_do_BANG] = ACTIONS(243),
    [anon_sym_begin] = ACTIONS(245),
    [aux_sym_char_token1] = ACTIONS(247),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(251),
    [anon_sym_AT_DQUOTE] = ACTIONS(253),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(255),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(257),
    [sym_bool] = ACTIONS(259),
    [sym_unit] = ACTIONS(1699),
    [anon_sym_LPAREN_PIPE] = ACTIONS(261),
    [sym_op_identifier] = ACTIONS(1701),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(265),
    [sym_xint] = ACTIONS(267),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(269),
  },
  [403] = {
    [sym_function_or_value_defn] = STATE(627),
    [sym__expression] = STATE(307),
    [sym_literal_expression] = STATE(1118),
    [sym_long_identifier_or_op] = STATE(1118),
    [sym_tuple_expression] = STATE(1118),
    [sym_brace_expression] = STATE(1118),
    [sym_anon_record_expression] = STATE(1118),
    [sym_object_expression] = STATE(6625),
    [sym_with_field_expression] = STATE(6625),
    [sym_prefixed_expression] = STATE(1118),
    [sym_typecast_expression] = STATE(1118),
    [sym_for_expression] = STATE(1118),
    [sym_while_expression] = STATE(1118),
    [sym__if_branch] = STATE(7163),
    [sym_if_expression] = STATE(1118),
    [sym_fun_expression] = STATE(1118),
    [sym_try_expression] = STATE(1118),
    [sym_match_expression] = STATE(1118),
    [sym_function_expression] = STATE(1118),
    [sym_mutate_expression] = STATE(1118),
    [sym_index_expression] = STATE(1118),
    [sym_typed_expression] = STATE(1118),
    [sym_declaration_expression] = STATE(1118),
    [sym_do_expression] = STATE(1118),
    [sym_list_expression] = STATE(1118),
    [sym_array_expression] = STATE(1118),
    [sym_begin_end_expression] = STATE(1118),
    [sym_paren_expression] = STATE(1118),
    [sym__high_prec_app] = STATE(1133),
    [sym__low_prec_app] = STATE(1133),
    [sym_application_expression] = STATE(1118),
    [sym_dot_expression] = STATE(1118),
    [sym_infix_expression] = STATE(1118),
    [sym_ce_expression] = STATE(1118),
    [sym_sequential_expression] = STATE(1118),
    [sym_field_initializer] = STATE(5913),
    [sym_field_initializers] = STATE(6625),
    [sym_char] = STATE(1080),
    [sym_format_string] = STATE(1090),
    [sym__string_literal] = STATE(1090),
    [sym_string] = STATE(1080),
    [sym_verbatim_string] = STATE(1080),
    [sym_bytearray] = STATE(1080),
    [sym_verbatim_bytearray] = STATE(1080),
    [sym_format_triple_quoted_string] = STATE(1096),
    [sym_triple_quoted_string] = STATE(1080),
    [sym_const] = STATE(1118),
    [sym_long_identifier] = STATE(2053),
    [sym_active_pattern] = STATE(1085),
    [sym__identifier_or_op] = STATE(1099),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(517),
    [sym_sbyte] = STATE(1080),
    [sym_byte] = STATE(1080),
    [sym_int16] = STATE(1080),
    [sym_uint16] = STATE(1080),
    [sym_int32] = STATE(1080),
    [sym_uint32] = STATE(1080),
    [sym_nativeint] = STATE(1080),
    [sym_unativeint] = STATE(1080),
    [sym_int64] = STATE(1080),
    [sym_uint64] = STATE(1080),
    [sym_ieee32] = STATE(1080),
    [sym_ieee64] = STATE(1080),
    [sym_bignum] = STATE(1080),
    [sym_decimal] = STATE(1080),
    [sym_float] = STATE(979),
    [sym_block_comment] = STATE(403),
    [sym_compiler_directive_decl] = STATE(403),
    [sym_fsi_directive_decl] = STATE(403),
    [sym_preproc_line] = STATE(403),
    [sym_preproc_if_in_expression] = STATE(1118),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(1773),
    [anon_sym_return] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_null] = ACTIONS(207),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(209),
    [anon_sym_LBRACK_PIPE] = ACTIONS(211),
    [anon_sym_LBRACE] = ACTIONS(1687),
    [anon_sym_LT_AT] = ACTIONS(213),
    [anon_sym_LT_AT_AT] = ACTIONS(1689),
    [anon_sym_LBRACE_PIPE] = ACTIONS(217),
    [anon_sym_new] = ACTIONS(1775),
    [anon_sym_return_BANG] = ACTIONS(219),
    [anon_sym_yield] = ACTIONS(199),
    [anon_sym_yield_BANG] = ACTIONS(219),
    [anon_sym_lazy] = ACTIONS(199),
    [anon_sym_assert] = ACTIONS(199),
    [anon_sym_upcast] = ACTIONS(199),
    [anon_sym_downcast] = ACTIONS(199),
    [anon_sym_for] = ACTIONS(223),
    [anon_sym_while] = ACTIONS(225),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(229),
    [anon_sym_match] = ACTIONS(231),
    [anon_sym_match_BANG] = ACTIONS(233),
    [anon_sym_function] = ACTIONS(235),
    [anon_sym_use] = ACTIONS(239),
    [anon_sym_use_BANG] = ACTIONS(241),
    [anon_sym_do_BANG] = ACTIONS(243),
    [anon_sym_begin] = ACTIONS(245),
    [aux_sym_char_token1] = ACTIONS(247),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(251),
    [anon_sym_AT_DQUOTE] = ACTIONS(253),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(255),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(257),
    [sym_bool] = ACTIONS(259),
    [sym_unit] = ACTIONS(1699),
    [anon_sym_LPAREN_PIPE] = ACTIONS(261),
    [sym_op_identifier] = ACTIONS(1701),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(265),
    [sym_xint] = ACTIONS(267),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(269),
  },
  [404] = {
    [sym_function_or_value_defn] = STATE(627),
    [sym__expression] = STATE(307),
    [sym_literal_expression] = STATE(1118),
    [sym_long_identifier_or_op] = STATE(1118),
    [sym_tuple_expression] = STATE(1118),
    [sym_brace_expression] = STATE(1118),
    [sym_anon_record_expression] = STATE(1118),
    [sym_object_expression] = STATE(6886),
    [sym_with_field_expression] = STATE(6886),
    [sym_prefixed_expression] = STATE(1118),
    [sym_typecast_expression] = STATE(1118),
    [sym_for_expression] = STATE(1118),
    [sym_while_expression] = STATE(1118),
    [sym__if_branch] = STATE(7163),
    [sym_if_expression] = STATE(1118),
    [sym_fun_expression] = STATE(1118),
    [sym_try_expression] = STATE(1118),
    [sym_match_expression] = STATE(1118),
    [sym_function_expression] = STATE(1118),
    [sym_mutate_expression] = STATE(1118),
    [sym_index_expression] = STATE(1118),
    [sym_typed_expression] = STATE(1118),
    [sym_declaration_expression] = STATE(1118),
    [sym_do_expression] = STATE(1118),
    [sym_list_expression] = STATE(1118),
    [sym_array_expression] = STATE(1118),
    [sym_begin_end_expression] = STATE(1118),
    [sym_paren_expression] = STATE(1118),
    [sym__high_prec_app] = STATE(1133),
    [sym__low_prec_app] = STATE(1133),
    [sym_application_expression] = STATE(1118),
    [sym_dot_expression] = STATE(1118),
    [sym_infix_expression] = STATE(1118),
    [sym_ce_expression] = STATE(1118),
    [sym_sequential_expression] = STATE(1118),
    [sym_field_initializer] = STATE(5913),
    [sym_field_initializers] = STATE(6886),
    [sym_char] = STATE(1080),
    [sym_format_string] = STATE(1090),
    [sym__string_literal] = STATE(1090),
    [sym_string] = STATE(1080),
    [sym_verbatim_string] = STATE(1080),
    [sym_bytearray] = STATE(1080),
    [sym_verbatim_bytearray] = STATE(1080),
    [sym_format_triple_quoted_string] = STATE(1096),
    [sym_triple_quoted_string] = STATE(1080),
    [sym_const] = STATE(1118),
    [sym_long_identifier] = STATE(2053),
    [sym_active_pattern] = STATE(1085),
    [sym__identifier_or_op] = STATE(1099),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(517),
    [sym_sbyte] = STATE(1080),
    [sym_byte] = STATE(1080),
    [sym_int16] = STATE(1080),
    [sym_uint16] = STATE(1080),
    [sym_int32] = STATE(1080),
    [sym_uint32] = STATE(1080),
    [sym_nativeint] = STATE(1080),
    [sym_unativeint] = STATE(1080),
    [sym_int64] = STATE(1080),
    [sym_uint64] = STATE(1080),
    [sym_ieee32] = STATE(1080),
    [sym_ieee64] = STATE(1080),
    [sym_bignum] = STATE(1080),
    [sym_decimal] = STATE(1080),
    [sym_float] = STATE(979),
    [sym_block_comment] = STATE(404),
    [sym_compiler_directive_decl] = STATE(404),
    [sym_fsi_directive_decl] = STATE(404),
    [sym_preproc_line] = STATE(404),
    [sym_preproc_if_in_expression] = STATE(1118),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(1773),
    [anon_sym_return] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_null] = ACTIONS(207),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(209),
    [anon_sym_LBRACK_PIPE] = ACTIONS(211),
    [anon_sym_LBRACE] = ACTIONS(1687),
    [anon_sym_LT_AT] = ACTIONS(213),
    [anon_sym_LT_AT_AT] = ACTIONS(1689),
    [anon_sym_LBRACE_PIPE] = ACTIONS(217),
    [anon_sym_new] = ACTIONS(1775),
    [anon_sym_return_BANG] = ACTIONS(219),
    [anon_sym_yield] = ACTIONS(199),
    [anon_sym_yield_BANG] = ACTIONS(219),
    [anon_sym_lazy] = ACTIONS(199),
    [anon_sym_assert] = ACTIONS(199),
    [anon_sym_upcast] = ACTIONS(199),
    [anon_sym_downcast] = ACTIONS(199),
    [anon_sym_for] = ACTIONS(223),
    [anon_sym_while] = ACTIONS(225),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(229),
    [anon_sym_match] = ACTIONS(231),
    [anon_sym_match_BANG] = ACTIONS(233),
    [anon_sym_function] = ACTIONS(235),
    [anon_sym_use] = ACTIONS(239),
    [anon_sym_use_BANG] = ACTIONS(241),
    [anon_sym_do_BANG] = ACTIONS(243),
    [anon_sym_begin] = ACTIONS(245),
    [aux_sym_char_token1] = ACTIONS(247),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(251),
    [anon_sym_AT_DQUOTE] = ACTIONS(253),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(255),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(257),
    [sym_bool] = ACTIONS(259),
    [sym_unit] = ACTIONS(1699),
    [anon_sym_LPAREN_PIPE] = ACTIONS(261),
    [sym_op_identifier] = ACTIONS(1701),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(265),
    [sym_xint] = ACTIONS(267),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(269),
  },
  [405] = {
    [sym_function_or_value_defn] = STATE(627),
    [sym__expression] = STATE(307),
    [sym_literal_expression] = STATE(1118),
    [sym_long_identifier_or_op] = STATE(1118),
    [sym_tuple_expression] = STATE(1118),
    [sym_brace_expression] = STATE(1118),
    [sym_anon_record_expression] = STATE(1118),
    [sym_object_expression] = STATE(6806),
    [sym_with_field_expression] = STATE(6806),
    [sym_prefixed_expression] = STATE(1118),
    [sym_typecast_expression] = STATE(1118),
    [sym_for_expression] = STATE(1118),
    [sym_while_expression] = STATE(1118),
    [sym__if_branch] = STATE(7163),
    [sym_if_expression] = STATE(1118),
    [sym_fun_expression] = STATE(1118),
    [sym_try_expression] = STATE(1118),
    [sym_match_expression] = STATE(1118),
    [sym_function_expression] = STATE(1118),
    [sym_mutate_expression] = STATE(1118),
    [sym_index_expression] = STATE(1118),
    [sym_typed_expression] = STATE(1118),
    [sym_declaration_expression] = STATE(1118),
    [sym_do_expression] = STATE(1118),
    [sym_list_expression] = STATE(1118),
    [sym_array_expression] = STATE(1118),
    [sym_begin_end_expression] = STATE(1118),
    [sym_paren_expression] = STATE(1118),
    [sym__high_prec_app] = STATE(1133),
    [sym__low_prec_app] = STATE(1133),
    [sym_application_expression] = STATE(1118),
    [sym_dot_expression] = STATE(1118),
    [sym_infix_expression] = STATE(1118),
    [sym_ce_expression] = STATE(1118),
    [sym_sequential_expression] = STATE(1118),
    [sym_field_initializer] = STATE(5913),
    [sym_field_initializers] = STATE(6806),
    [sym_char] = STATE(1080),
    [sym_format_string] = STATE(1090),
    [sym__string_literal] = STATE(1090),
    [sym_string] = STATE(1080),
    [sym_verbatim_string] = STATE(1080),
    [sym_bytearray] = STATE(1080),
    [sym_verbatim_bytearray] = STATE(1080),
    [sym_format_triple_quoted_string] = STATE(1096),
    [sym_triple_quoted_string] = STATE(1080),
    [sym_const] = STATE(1118),
    [sym_long_identifier] = STATE(2053),
    [sym_active_pattern] = STATE(1085),
    [sym__identifier_or_op] = STATE(1099),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(517),
    [sym_sbyte] = STATE(1080),
    [sym_byte] = STATE(1080),
    [sym_int16] = STATE(1080),
    [sym_uint16] = STATE(1080),
    [sym_int32] = STATE(1080),
    [sym_uint32] = STATE(1080),
    [sym_nativeint] = STATE(1080),
    [sym_unativeint] = STATE(1080),
    [sym_int64] = STATE(1080),
    [sym_uint64] = STATE(1080),
    [sym_ieee32] = STATE(1080),
    [sym_ieee64] = STATE(1080),
    [sym_bignum] = STATE(1080),
    [sym_decimal] = STATE(1080),
    [sym_float] = STATE(979),
    [sym_block_comment] = STATE(405),
    [sym_compiler_directive_decl] = STATE(405),
    [sym_fsi_directive_decl] = STATE(405),
    [sym_preproc_line] = STATE(405),
    [sym_preproc_if_in_expression] = STATE(1118),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(1773),
    [anon_sym_return] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_null] = ACTIONS(207),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(209),
    [anon_sym_LBRACK_PIPE] = ACTIONS(211),
    [anon_sym_LBRACE] = ACTIONS(1687),
    [anon_sym_LT_AT] = ACTIONS(213),
    [anon_sym_LT_AT_AT] = ACTIONS(1689),
    [anon_sym_LBRACE_PIPE] = ACTIONS(217),
    [anon_sym_new] = ACTIONS(1775),
    [anon_sym_return_BANG] = ACTIONS(219),
    [anon_sym_yield] = ACTIONS(199),
    [anon_sym_yield_BANG] = ACTIONS(219),
    [anon_sym_lazy] = ACTIONS(199),
    [anon_sym_assert] = ACTIONS(199),
    [anon_sym_upcast] = ACTIONS(199),
    [anon_sym_downcast] = ACTIONS(199),
    [anon_sym_for] = ACTIONS(223),
    [anon_sym_while] = ACTIONS(225),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(229),
    [anon_sym_match] = ACTIONS(231),
    [anon_sym_match_BANG] = ACTIONS(233),
    [anon_sym_function] = ACTIONS(235),
    [anon_sym_use] = ACTIONS(239),
    [anon_sym_use_BANG] = ACTIONS(241),
    [anon_sym_do_BANG] = ACTIONS(243),
    [anon_sym_begin] = ACTIONS(245),
    [aux_sym_char_token1] = ACTIONS(247),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(251),
    [anon_sym_AT_DQUOTE] = ACTIONS(253),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(255),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(257),
    [sym_bool] = ACTIONS(259),
    [sym_unit] = ACTIONS(1699),
    [anon_sym_LPAREN_PIPE] = ACTIONS(261),
    [sym_op_identifier] = ACTIONS(1701),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(265),
    [sym_xint] = ACTIONS(267),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(269),
  },
  [406] = {
    [sym_function_or_value_defn] = STATE(627),
    [sym__expression] = STATE(307),
    [sym_literal_expression] = STATE(1118),
    [sym_long_identifier_or_op] = STATE(1118),
    [sym_tuple_expression] = STATE(1118),
    [sym_brace_expression] = STATE(1118),
    [sym_anon_record_expression] = STATE(1118),
    [sym_object_expression] = STATE(6526),
    [sym_with_field_expression] = STATE(6526),
    [sym_prefixed_expression] = STATE(1118),
    [sym_typecast_expression] = STATE(1118),
    [sym_for_expression] = STATE(1118),
    [sym_while_expression] = STATE(1118),
    [sym__if_branch] = STATE(7163),
    [sym_if_expression] = STATE(1118),
    [sym_fun_expression] = STATE(1118),
    [sym_try_expression] = STATE(1118),
    [sym_match_expression] = STATE(1118),
    [sym_function_expression] = STATE(1118),
    [sym_mutate_expression] = STATE(1118),
    [sym_index_expression] = STATE(1118),
    [sym_typed_expression] = STATE(1118),
    [sym_declaration_expression] = STATE(1118),
    [sym_do_expression] = STATE(1118),
    [sym_list_expression] = STATE(1118),
    [sym_array_expression] = STATE(1118),
    [sym_begin_end_expression] = STATE(1118),
    [sym_paren_expression] = STATE(1118),
    [sym__high_prec_app] = STATE(1133),
    [sym__low_prec_app] = STATE(1133),
    [sym_application_expression] = STATE(1118),
    [sym_dot_expression] = STATE(1118),
    [sym_infix_expression] = STATE(1118),
    [sym_ce_expression] = STATE(1118),
    [sym_sequential_expression] = STATE(1118),
    [sym_field_initializer] = STATE(5913),
    [sym_field_initializers] = STATE(6526),
    [sym_char] = STATE(1080),
    [sym_format_string] = STATE(1090),
    [sym__string_literal] = STATE(1090),
    [sym_string] = STATE(1080),
    [sym_verbatim_string] = STATE(1080),
    [sym_bytearray] = STATE(1080),
    [sym_verbatim_bytearray] = STATE(1080),
    [sym_format_triple_quoted_string] = STATE(1096),
    [sym_triple_quoted_string] = STATE(1080),
    [sym_const] = STATE(1118),
    [sym_long_identifier] = STATE(2053),
    [sym_active_pattern] = STATE(1085),
    [sym__identifier_or_op] = STATE(1099),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(517),
    [sym_sbyte] = STATE(1080),
    [sym_byte] = STATE(1080),
    [sym_int16] = STATE(1080),
    [sym_uint16] = STATE(1080),
    [sym_int32] = STATE(1080),
    [sym_uint32] = STATE(1080),
    [sym_nativeint] = STATE(1080),
    [sym_unativeint] = STATE(1080),
    [sym_int64] = STATE(1080),
    [sym_uint64] = STATE(1080),
    [sym_ieee32] = STATE(1080),
    [sym_ieee64] = STATE(1080),
    [sym_bignum] = STATE(1080),
    [sym_decimal] = STATE(1080),
    [sym_float] = STATE(979),
    [sym_block_comment] = STATE(406),
    [sym_compiler_directive_decl] = STATE(406),
    [sym_fsi_directive_decl] = STATE(406),
    [sym_preproc_line] = STATE(406),
    [sym_preproc_if_in_expression] = STATE(1118),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(1773),
    [anon_sym_return] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_null] = ACTIONS(207),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(209),
    [anon_sym_LBRACK_PIPE] = ACTIONS(211),
    [anon_sym_LBRACE] = ACTIONS(1687),
    [anon_sym_LT_AT] = ACTIONS(213),
    [anon_sym_LT_AT_AT] = ACTIONS(1689),
    [anon_sym_LBRACE_PIPE] = ACTIONS(217),
    [anon_sym_new] = ACTIONS(1775),
    [anon_sym_return_BANG] = ACTIONS(219),
    [anon_sym_yield] = ACTIONS(199),
    [anon_sym_yield_BANG] = ACTIONS(219),
    [anon_sym_lazy] = ACTIONS(199),
    [anon_sym_assert] = ACTIONS(199),
    [anon_sym_upcast] = ACTIONS(199),
    [anon_sym_downcast] = ACTIONS(199),
    [anon_sym_for] = ACTIONS(223),
    [anon_sym_while] = ACTIONS(225),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(229),
    [anon_sym_match] = ACTIONS(231),
    [anon_sym_match_BANG] = ACTIONS(233),
    [anon_sym_function] = ACTIONS(235),
    [anon_sym_use] = ACTIONS(239),
    [anon_sym_use_BANG] = ACTIONS(241),
    [anon_sym_do_BANG] = ACTIONS(243),
    [anon_sym_begin] = ACTIONS(245),
    [aux_sym_char_token1] = ACTIONS(247),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(251),
    [anon_sym_AT_DQUOTE] = ACTIONS(253),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(255),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(257),
    [sym_bool] = ACTIONS(259),
    [sym_unit] = ACTIONS(1699),
    [anon_sym_LPAREN_PIPE] = ACTIONS(261),
    [sym_op_identifier] = ACTIONS(1701),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(265),
    [sym_xint] = ACTIONS(267),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(269),
  },
  [407] = {
    [sym_function_or_value_defn] = STATE(627),
    [sym__expression] = STATE(307),
    [sym_literal_expression] = STATE(1118),
    [sym_long_identifier_or_op] = STATE(1118),
    [sym_tuple_expression] = STATE(1118),
    [sym_brace_expression] = STATE(1118),
    [sym_anon_record_expression] = STATE(1118),
    [sym_object_expression] = STATE(6673),
    [sym_with_field_expression] = STATE(6673),
    [sym_prefixed_expression] = STATE(1118),
    [sym_typecast_expression] = STATE(1118),
    [sym_for_expression] = STATE(1118),
    [sym_while_expression] = STATE(1118),
    [sym__if_branch] = STATE(7163),
    [sym_if_expression] = STATE(1118),
    [sym_fun_expression] = STATE(1118),
    [sym_try_expression] = STATE(1118),
    [sym_match_expression] = STATE(1118),
    [sym_function_expression] = STATE(1118),
    [sym_mutate_expression] = STATE(1118),
    [sym_index_expression] = STATE(1118),
    [sym_typed_expression] = STATE(1118),
    [sym_declaration_expression] = STATE(1118),
    [sym_do_expression] = STATE(1118),
    [sym_list_expression] = STATE(1118),
    [sym_array_expression] = STATE(1118),
    [sym_begin_end_expression] = STATE(1118),
    [sym_paren_expression] = STATE(1118),
    [sym__high_prec_app] = STATE(1133),
    [sym__low_prec_app] = STATE(1133),
    [sym_application_expression] = STATE(1118),
    [sym_dot_expression] = STATE(1118),
    [sym_infix_expression] = STATE(1118),
    [sym_ce_expression] = STATE(1118),
    [sym_sequential_expression] = STATE(1118),
    [sym_field_initializer] = STATE(5913),
    [sym_field_initializers] = STATE(6673),
    [sym_char] = STATE(1080),
    [sym_format_string] = STATE(1090),
    [sym__string_literal] = STATE(1090),
    [sym_string] = STATE(1080),
    [sym_verbatim_string] = STATE(1080),
    [sym_bytearray] = STATE(1080),
    [sym_verbatim_bytearray] = STATE(1080),
    [sym_format_triple_quoted_string] = STATE(1096),
    [sym_triple_quoted_string] = STATE(1080),
    [sym_const] = STATE(1118),
    [sym_long_identifier] = STATE(2053),
    [sym_active_pattern] = STATE(1085),
    [sym__identifier_or_op] = STATE(1099),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(517),
    [sym_sbyte] = STATE(1080),
    [sym_byte] = STATE(1080),
    [sym_int16] = STATE(1080),
    [sym_uint16] = STATE(1080),
    [sym_int32] = STATE(1080),
    [sym_uint32] = STATE(1080),
    [sym_nativeint] = STATE(1080),
    [sym_unativeint] = STATE(1080),
    [sym_int64] = STATE(1080),
    [sym_uint64] = STATE(1080),
    [sym_ieee32] = STATE(1080),
    [sym_ieee64] = STATE(1080),
    [sym_bignum] = STATE(1080),
    [sym_decimal] = STATE(1080),
    [sym_float] = STATE(979),
    [sym_block_comment] = STATE(407),
    [sym_compiler_directive_decl] = STATE(407),
    [sym_fsi_directive_decl] = STATE(407),
    [sym_preproc_line] = STATE(407),
    [sym_preproc_if_in_expression] = STATE(1118),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(1773),
    [anon_sym_return] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_null] = ACTIONS(207),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(209),
    [anon_sym_LBRACK_PIPE] = ACTIONS(211),
    [anon_sym_LBRACE] = ACTIONS(1687),
    [anon_sym_LT_AT] = ACTIONS(213),
    [anon_sym_LT_AT_AT] = ACTIONS(1689),
    [anon_sym_LBRACE_PIPE] = ACTIONS(217),
    [anon_sym_new] = ACTIONS(1775),
    [anon_sym_return_BANG] = ACTIONS(219),
    [anon_sym_yield] = ACTIONS(199),
    [anon_sym_yield_BANG] = ACTIONS(219),
    [anon_sym_lazy] = ACTIONS(199),
    [anon_sym_assert] = ACTIONS(199),
    [anon_sym_upcast] = ACTIONS(199),
    [anon_sym_downcast] = ACTIONS(199),
    [anon_sym_for] = ACTIONS(223),
    [anon_sym_while] = ACTIONS(225),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(229),
    [anon_sym_match] = ACTIONS(231),
    [anon_sym_match_BANG] = ACTIONS(233),
    [anon_sym_function] = ACTIONS(235),
    [anon_sym_use] = ACTIONS(239),
    [anon_sym_use_BANG] = ACTIONS(241),
    [anon_sym_do_BANG] = ACTIONS(243),
    [anon_sym_begin] = ACTIONS(245),
    [aux_sym_char_token1] = ACTIONS(247),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(251),
    [anon_sym_AT_DQUOTE] = ACTIONS(253),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(255),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(257),
    [sym_bool] = ACTIONS(259),
    [sym_unit] = ACTIONS(1699),
    [anon_sym_LPAREN_PIPE] = ACTIONS(261),
    [sym_op_identifier] = ACTIONS(1701),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(265),
    [sym_xint] = ACTIONS(267),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(269),
  },
  [408] = {
    [sym_function_or_value_defn] = STATE(627),
    [sym__expression] = STATE(307),
    [sym_literal_expression] = STATE(1118),
    [sym_long_identifier_or_op] = STATE(1118),
    [sym_tuple_expression] = STATE(1118),
    [sym_brace_expression] = STATE(1118),
    [sym_anon_record_expression] = STATE(1118),
    [sym_object_expression] = STATE(6576),
    [sym_with_field_expression] = STATE(6576),
    [sym_prefixed_expression] = STATE(1118),
    [sym_typecast_expression] = STATE(1118),
    [sym_for_expression] = STATE(1118),
    [sym_while_expression] = STATE(1118),
    [sym__if_branch] = STATE(7163),
    [sym_if_expression] = STATE(1118),
    [sym_fun_expression] = STATE(1118),
    [sym_try_expression] = STATE(1118),
    [sym_match_expression] = STATE(1118),
    [sym_function_expression] = STATE(1118),
    [sym_mutate_expression] = STATE(1118),
    [sym_index_expression] = STATE(1118),
    [sym_typed_expression] = STATE(1118),
    [sym_declaration_expression] = STATE(1118),
    [sym_do_expression] = STATE(1118),
    [sym_list_expression] = STATE(1118),
    [sym_array_expression] = STATE(1118),
    [sym_begin_end_expression] = STATE(1118),
    [sym_paren_expression] = STATE(1118),
    [sym__high_prec_app] = STATE(1133),
    [sym__low_prec_app] = STATE(1133),
    [sym_application_expression] = STATE(1118),
    [sym_dot_expression] = STATE(1118),
    [sym_infix_expression] = STATE(1118),
    [sym_ce_expression] = STATE(1118),
    [sym_sequential_expression] = STATE(1118),
    [sym_field_initializer] = STATE(5913),
    [sym_field_initializers] = STATE(6576),
    [sym_char] = STATE(1080),
    [sym_format_string] = STATE(1090),
    [sym__string_literal] = STATE(1090),
    [sym_string] = STATE(1080),
    [sym_verbatim_string] = STATE(1080),
    [sym_bytearray] = STATE(1080),
    [sym_verbatim_bytearray] = STATE(1080),
    [sym_format_triple_quoted_string] = STATE(1096),
    [sym_triple_quoted_string] = STATE(1080),
    [sym_const] = STATE(1118),
    [sym_long_identifier] = STATE(2053),
    [sym_active_pattern] = STATE(1085),
    [sym__identifier_or_op] = STATE(1099),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(517),
    [sym_sbyte] = STATE(1080),
    [sym_byte] = STATE(1080),
    [sym_int16] = STATE(1080),
    [sym_uint16] = STATE(1080),
    [sym_int32] = STATE(1080),
    [sym_uint32] = STATE(1080),
    [sym_nativeint] = STATE(1080),
    [sym_unativeint] = STATE(1080),
    [sym_int64] = STATE(1080),
    [sym_uint64] = STATE(1080),
    [sym_ieee32] = STATE(1080),
    [sym_ieee64] = STATE(1080),
    [sym_bignum] = STATE(1080),
    [sym_decimal] = STATE(1080),
    [sym_float] = STATE(979),
    [sym_block_comment] = STATE(408),
    [sym_compiler_directive_decl] = STATE(408),
    [sym_fsi_directive_decl] = STATE(408),
    [sym_preproc_line] = STATE(408),
    [sym_preproc_if_in_expression] = STATE(1118),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(1773),
    [anon_sym_return] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_null] = ACTIONS(207),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(209),
    [anon_sym_LBRACK_PIPE] = ACTIONS(211),
    [anon_sym_LBRACE] = ACTIONS(1687),
    [anon_sym_LT_AT] = ACTIONS(213),
    [anon_sym_LT_AT_AT] = ACTIONS(1689),
    [anon_sym_LBRACE_PIPE] = ACTIONS(217),
    [anon_sym_new] = ACTIONS(1775),
    [anon_sym_return_BANG] = ACTIONS(219),
    [anon_sym_yield] = ACTIONS(199),
    [anon_sym_yield_BANG] = ACTIONS(219),
    [anon_sym_lazy] = ACTIONS(199),
    [anon_sym_assert] = ACTIONS(199),
    [anon_sym_upcast] = ACTIONS(199),
    [anon_sym_downcast] = ACTIONS(199),
    [anon_sym_for] = ACTIONS(223),
    [anon_sym_while] = ACTIONS(225),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(229),
    [anon_sym_match] = ACTIONS(231),
    [anon_sym_match_BANG] = ACTIONS(233),
    [anon_sym_function] = ACTIONS(235),
    [anon_sym_use] = ACTIONS(239),
    [anon_sym_use_BANG] = ACTIONS(241),
    [anon_sym_do_BANG] = ACTIONS(243),
    [anon_sym_begin] = ACTIONS(245),
    [aux_sym_char_token1] = ACTIONS(247),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(251),
    [anon_sym_AT_DQUOTE] = ACTIONS(253),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(255),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(257),
    [sym_bool] = ACTIONS(259),
    [sym_unit] = ACTIONS(1699),
    [anon_sym_LPAREN_PIPE] = ACTIONS(261),
    [sym_op_identifier] = ACTIONS(1701),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(265),
    [sym_xint] = ACTIONS(267),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(269),
  },
  [409] = {
    [sym_function_or_value_defn] = STATE(627),
    [sym__expression] = STATE(307),
    [sym_literal_expression] = STATE(1118),
    [sym_long_identifier_or_op] = STATE(1118),
    [sym_tuple_expression] = STATE(1118),
    [sym_brace_expression] = STATE(1118),
    [sym_anon_record_expression] = STATE(1118),
    [sym_object_expression] = STATE(6721),
    [sym_with_field_expression] = STATE(6721),
    [sym_prefixed_expression] = STATE(1118),
    [sym_typecast_expression] = STATE(1118),
    [sym_for_expression] = STATE(1118),
    [sym_while_expression] = STATE(1118),
    [sym__if_branch] = STATE(7163),
    [sym_if_expression] = STATE(1118),
    [sym_fun_expression] = STATE(1118),
    [sym_try_expression] = STATE(1118),
    [sym_match_expression] = STATE(1118),
    [sym_function_expression] = STATE(1118),
    [sym_mutate_expression] = STATE(1118),
    [sym_index_expression] = STATE(1118),
    [sym_typed_expression] = STATE(1118),
    [sym_declaration_expression] = STATE(1118),
    [sym_do_expression] = STATE(1118),
    [sym_list_expression] = STATE(1118),
    [sym_array_expression] = STATE(1118),
    [sym_begin_end_expression] = STATE(1118),
    [sym_paren_expression] = STATE(1118),
    [sym__high_prec_app] = STATE(1133),
    [sym__low_prec_app] = STATE(1133),
    [sym_application_expression] = STATE(1118),
    [sym_dot_expression] = STATE(1118),
    [sym_infix_expression] = STATE(1118),
    [sym_ce_expression] = STATE(1118),
    [sym_sequential_expression] = STATE(1118),
    [sym_field_initializer] = STATE(5913),
    [sym_field_initializers] = STATE(6721),
    [sym_char] = STATE(1080),
    [sym_format_string] = STATE(1090),
    [sym__string_literal] = STATE(1090),
    [sym_string] = STATE(1080),
    [sym_verbatim_string] = STATE(1080),
    [sym_bytearray] = STATE(1080),
    [sym_verbatim_bytearray] = STATE(1080),
    [sym_format_triple_quoted_string] = STATE(1096),
    [sym_triple_quoted_string] = STATE(1080),
    [sym_const] = STATE(1118),
    [sym_long_identifier] = STATE(2053),
    [sym_active_pattern] = STATE(1085),
    [sym__identifier_or_op] = STATE(1099),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(517),
    [sym_sbyte] = STATE(1080),
    [sym_byte] = STATE(1080),
    [sym_int16] = STATE(1080),
    [sym_uint16] = STATE(1080),
    [sym_int32] = STATE(1080),
    [sym_uint32] = STATE(1080),
    [sym_nativeint] = STATE(1080),
    [sym_unativeint] = STATE(1080),
    [sym_int64] = STATE(1080),
    [sym_uint64] = STATE(1080),
    [sym_ieee32] = STATE(1080),
    [sym_ieee64] = STATE(1080),
    [sym_bignum] = STATE(1080),
    [sym_decimal] = STATE(1080),
    [sym_float] = STATE(979),
    [sym_block_comment] = STATE(409),
    [sym_compiler_directive_decl] = STATE(409),
    [sym_fsi_directive_decl] = STATE(409),
    [sym_preproc_line] = STATE(409),
    [sym_preproc_if_in_expression] = STATE(1118),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(1773),
    [anon_sym_return] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_null] = ACTIONS(207),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(209),
    [anon_sym_LBRACK_PIPE] = ACTIONS(211),
    [anon_sym_LBRACE] = ACTIONS(1687),
    [anon_sym_LT_AT] = ACTIONS(213),
    [anon_sym_LT_AT_AT] = ACTIONS(1689),
    [anon_sym_LBRACE_PIPE] = ACTIONS(217),
    [anon_sym_new] = ACTIONS(1775),
    [anon_sym_return_BANG] = ACTIONS(219),
    [anon_sym_yield] = ACTIONS(199),
    [anon_sym_yield_BANG] = ACTIONS(219),
    [anon_sym_lazy] = ACTIONS(199),
    [anon_sym_assert] = ACTIONS(199),
    [anon_sym_upcast] = ACTIONS(199),
    [anon_sym_downcast] = ACTIONS(199),
    [anon_sym_for] = ACTIONS(223),
    [anon_sym_while] = ACTIONS(225),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(229),
    [anon_sym_match] = ACTIONS(231),
    [anon_sym_match_BANG] = ACTIONS(233),
    [anon_sym_function] = ACTIONS(235),
    [anon_sym_use] = ACTIONS(239),
    [anon_sym_use_BANG] = ACTIONS(241),
    [anon_sym_do_BANG] = ACTIONS(243),
    [anon_sym_begin] = ACTIONS(245),
    [aux_sym_char_token1] = ACTIONS(247),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(251),
    [anon_sym_AT_DQUOTE] = ACTIONS(253),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(255),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(257),
    [sym_bool] = ACTIONS(259),
    [sym_unit] = ACTIONS(1699),
    [anon_sym_LPAREN_PIPE] = ACTIONS(261),
    [sym_op_identifier] = ACTIONS(1701),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(265),
    [sym_xint] = ACTIONS(267),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(269),
  },
  [410] = {
    [sym_function_or_value_defn] = STATE(663),
    [sym__expression] = STATE(81),
    [sym_literal_expression] = STATE(1118),
    [sym_long_identifier_or_op] = STATE(1118),
    [sym_tuple_expression] = STATE(1118),
    [sym_brace_expression] = STATE(1118),
    [sym_anon_record_expression] = STATE(1118),
    [sym_prefixed_expression] = STATE(1118),
    [sym_typecast_expression] = STATE(1118),
    [sym_for_expression] = STATE(1118),
    [sym_while_expression] = STATE(1118),
    [sym__if_branch] = STATE(7163),
    [sym_if_expression] = STATE(1118),
    [sym_fun_expression] = STATE(1118),
    [sym_try_expression] = STATE(1118),
    [sym_match_expression] = STATE(1118),
    [sym_function_expression] = STATE(1118),
    [sym_mutate_expression] = STATE(1118),
    [sym_index_expression] = STATE(1118),
    [sym_typed_expression] = STATE(1118),
    [sym_declaration_expression] = STATE(1118),
    [sym_do_expression] = STATE(1118),
    [sym_list_expression] = STATE(1118),
    [sym_array_expression] = STATE(1118),
    [sym_begin_end_expression] = STATE(1118),
    [sym_paren_expression] = STATE(1118),
    [sym__high_prec_app] = STATE(1133),
    [sym__low_prec_app] = STATE(1133),
    [sym_application_expression] = STATE(1118),
    [sym_dot_expression] = STATE(1118),
    [sym_infix_expression] = STATE(1118),
    [sym_ce_expression] = STATE(1118),
    [sym_sequential_expression] = STATE(1118),
    [sym__slice_range_special] = STATE(6328),
    [sym_slice_range] = STATE(6364),
    [sym_char] = STATE(1080),
    [sym_format_string] = STATE(1090),
    [sym__string_literal] = STATE(1090),
    [sym_string] = STATE(1080),
    [sym_verbatim_string] = STATE(1080),
    [sym_bytearray] = STATE(1080),
    [sym_verbatim_bytearray] = STATE(1080),
    [sym_format_triple_quoted_string] = STATE(1096),
    [sym_triple_quoted_string] = STATE(1080),
    [sym_const] = STATE(1118),
    [sym_long_identifier] = STATE(1156),
    [sym_active_pattern] = STATE(1085),
    [sym__identifier_or_op] = STATE(1099),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(548),
    [sym_sbyte] = STATE(1080),
    [sym_byte] = STATE(1080),
    [sym_int16] = STATE(1080),
    [sym_uint16] = STATE(1080),
    [sym_int32] = STATE(1080),
    [sym_uint32] = STATE(1080),
    [sym_nativeint] = STATE(1080),
    [sym_unativeint] = STATE(1080),
    [sym_int64] = STATE(1080),
    [sym_uint64] = STATE(1080),
    [sym_ieee32] = STATE(1080),
    [sym_ieee64] = STATE(1080),
    [sym_bignum] = STATE(1080),
    [sym_decimal] = STATE(1080),
    [sym_float] = STATE(979),
    [sym_block_comment] = STATE(410),
    [sym_compiler_directive_decl] = STATE(410),
    [sym_fsi_directive_decl] = STATE(410),
    [sym_preproc_line] = STATE(410),
    [sym_preproc_if_in_expression] = STATE(1118),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(195),
    [anon_sym_return] = ACTIONS(481),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_null] = ACTIONS(207),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(209),
    [anon_sym_LBRACK_PIPE] = ACTIONS(211),
    [anon_sym_LBRACE] = ACTIONS(1687),
    [anon_sym_LT_AT] = ACTIONS(213),
    [anon_sym_LT_AT_AT] = ACTIONS(1689),
    [anon_sym_LBRACE_PIPE] = ACTIONS(217),
    [anon_sym_new] = ACTIONS(481),
    [anon_sym_return_BANG] = ACTIONS(487),
    [anon_sym_yield] = ACTIONS(481),
    [anon_sym_yield_BANG] = ACTIONS(487),
    [anon_sym_lazy] = ACTIONS(481),
    [anon_sym_assert] = ACTIONS(481),
    [anon_sym_upcast] = ACTIONS(481),
    [anon_sym_downcast] = ACTIONS(481),
    [anon_sym_for] = ACTIONS(489),
    [anon_sym_while] = ACTIONS(225),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(229),
    [anon_sym_match] = ACTIONS(231),
    [anon_sym_match_BANG] = ACTIONS(233),
    [anon_sym_function] = ACTIONS(235),
    [anon_sym_use] = ACTIONS(493),
    [anon_sym_use_BANG] = ACTIONS(495),
    [anon_sym_do_BANG] = ACTIONS(243),
    [anon_sym_begin] = ACTIONS(245),
    [anon_sym_DOT_DOT3] = ACTIONS(1709),
    [anon_sym_STAR] = ACTIONS(1711),
    [aux_sym_char_token1] = ACTIONS(247),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(251),
    [anon_sym_AT_DQUOTE] = ACTIONS(253),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(255),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(257),
    [sym_bool] = ACTIONS(259),
    [sym_unit] = ACTIONS(1699),
    [anon_sym_LPAREN_PIPE] = ACTIONS(261),
    [sym_op_identifier] = ACTIONS(1701),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(499),
    [sym_xint] = ACTIONS(267),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(269),
  },
  [411] = {
    [sym_function_or_value_defn] = STATE(627),
    [sym__expression] = STATE(307),
    [sym_literal_expression] = STATE(1118),
    [sym_long_identifier_or_op] = STATE(1118),
    [sym_tuple_expression] = STATE(1118),
    [sym_brace_expression] = STATE(1118),
    [sym_anon_record_expression] = STATE(1118),
    [sym_object_expression] = STATE(6471),
    [sym_with_field_expression] = STATE(6471),
    [sym_prefixed_expression] = STATE(1118),
    [sym_typecast_expression] = STATE(1118),
    [sym_for_expression] = STATE(1118),
    [sym_while_expression] = STATE(1118),
    [sym__if_branch] = STATE(7163),
    [sym_if_expression] = STATE(1118),
    [sym_fun_expression] = STATE(1118),
    [sym_try_expression] = STATE(1118),
    [sym_match_expression] = STATE(1118),
    [sym_function_expression] = STATE(1118),
    [sym_mutate_expression] = STATE(1118),
    [sym_index_expression] = STATE(1118),
    [sym_typed_expression] = STATE(1118),
    [sym_declaration_expression] = STATE(1118),
    [sym_do_expression] = STATE(1118),
    [sym_list_expression] = STATE(1118),
    [sym_array_expression] = STATE(1118),
    [sym_begin_end_expression] = STATE(1118),
    [sym_paren_expression] = STATE(1118),
    [sym__high_prec_app] = STATE(1133),
    [sym__low_prec_app] = STATE(1133),
    [sym_application_expression] = STATE(1118),
    [sym_dot_expression] = STATE(1118),
    [sym_infix_expression] = STATE(1118),
    [sym_ce_expression] = STATE(1118),
    [sym_sequential_expression] = STATE(1118),
    [sym_field_initializer] = STATE(5913),
    [sym_field_initializers] = STATE(6471),
    [sym_char] = STATE(1080),
    [sym_format_string] = STATE(1090),
    [sym__string_literal] = STATE(1090),
    [sym_string] = STATE(1080),
    [sym_verbatim_string] = STATE(1080),
    [sym_bytearray] = STATE(1080),
    [sym_verbatim_bytearray] = STATE(1080),
    [sym_format_triple_quoted_string] = STATE(1096),
    [sym_triple_quoted_string] = STATE(1080),
    [sym_const] = STATE(1118),
    [sym_long_identifier] = STATE(2053),
    [sym_active_pattern] = STATE(1085),
    [sym__identifier_or_op] = STATE(1099),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(517),
    [sym_sbyte] = STATE(1080),
    [sym_byte] = STATE(1080),
    [sym_int16] = STATE(1080),
    [sym_uint16] = STATE(1080),
    [sym_int32] = STATE(1080),
    [sym_uint32] = STATE(1080),
    [sym_nativeint] = STATE(1080),
    [sym_unativeint] = STATE(1080),
    [sym_int64] = STATE(1080),
    [sym_uint64] = STATE(1080),
    [sym_ieee32] = STATE(1080),
    [sym_ieee64] = STATE(1080),
    [sym_bignum] = STATE(1080),
    [sym_decimal] = STATE(1080),
    [sym_float] = STATE(979),
    [sym_block_comment] = STATE(411),
    [sym_compiler_directive_decl] = STATE(411),
    [sym_fsi_directive_decl] = STATE(411),
    [sym_preproc_line] = STATE(411),
    [sym_preproc_if_in_expression] = STATE(1118),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(1773),
    [anon_sym_return] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_null] = ACTIONS(207),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(209),
    [anon_sym_LBRACK_PIPE] = ACTIONS(211),
    [anon_sym_LBRACE] = ACTIONS(1687),
    [anon_sym_LT_AT] = ACTIONS(213),
    [anon_sym_LT_AT_AT] = ACTIONS(1689),
    [anon_sym_LBRACE_PIPE] = ACTIONS(217),
    [anon_sym_new] = ACTIONS(1775),
    [anon_sym_return_BANG] = ACTIONS(219),
    [anon_sym_yield] = ACTIONS(199),
    [anon_sym_yield_BANG] = ACTIONS(219),
    [anon_sym_lazy] = ACTIONS(199),
    [anon_sym_assert] = ACTIONS(199),
    [anon_sym_upcast] = ACTIONS(199),
    [anon_sym_downcast] = ACTIONS(199),
    [anon_sym_for] = ACTIONS(223),
    [anon_sym_while] = ACTIONS(225),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(229),
    [anon_sym_match] = ACTIONS(231),
    [anon_sym_match_BANG] = ACTIONS(233),
    [anon_sym_function] = ACTIONS(235),
    [anon_sym_use] = ACTIONS(239),
    [anon_sym_use_BANG] = ACTIONS(241),
    [anon_sym_do_BANG] = ACTIONS(243),
    [anon_sym_begin] = ACTIONS(245),
    [aux_sym_char_token1] = ACTIONS(247),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(251),
    [anon_sym_AT_DQUOTE] = ACTIONS(253),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(255),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(257),
    [sym_bool] = ACTIONS(259),
    [sym_unit] = ACTIONS(1699),
    [anon_sym_LPAREN_PIPE] = ACTIONS(261),
    [sym_op_identifier] = ACTIONS(1701),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(265),
    [sym_xint] = ACTIONS(267),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(269),
  },
  [412] = {
    [sym_function_or_value_defn] = STATE(729),
    [sym__expression] = STATE(94),
    [sym_literal_expression] = STATE(867),
    [sym_long_identifier_or_op] = STATE(867),
    [sym_tuple_expression] = STATE(867),
    [sym_brace_expression] = STATE(867),
    [sym_anon_record_expression] = STATE(867),
    [sym_prefixed_expression] = STATE(867),
    [sym_typecast_expression] = STATE(867),
    [sym_for_expression] = STATE(867),
    [sym_while_expression] = STATE(867),
    [sym__if_branch] = STATE(6511),
    [sym_if_expression] = STATE(867),
    [sym_fun_expression] = STATE(867),
    [sym_try_expression] = STATE(867),
    [sym_match_expression] = STATE(867),
    [sym_function_expression] = STATE(867),
    [sym_mutate_expression] = STATE(867),
    [sym_index_expression] = STATE(867),
    [sym_typed_expression] = STATE(867),
    [sym_declaration_expression] = STATE(867),
    [sym_do_expression] = STATE(867),
    [sym_list_expression] = STATE(867),
    [sym_array_expression] = STATE(867),
    [sym_begin_end_expression] = STATE(867),
    [sym_paren_expression] = STATE(867),
    [sym__high_prec_app] = STATE(864),
    [sym__low_prec_app] = STATE(864),
    [sym_application_expression] = STATE(867),
    [sym_dot_expression] = STATE(867),
    [sym_infix_expression] = STATE(867),
    [sym_ce_expression] = STATE(867),
    [sym_sequential_expression] = STATE(867),
    [sym__slice_range_special] = STATE(6154),
    [sym_slice_range] = STATE(6391),
    [sym_char] = STATE(868),
    [sym_format_string] = STATE(869),
    [sym__string_literal] = STATE(869),
    [sym_string] = STATE(868),
    [sym_verbatim_string] = STATE(868),
    [sym_bytearray] = STATE(868),
    [sym_verbatim_bytearray] = STATE(868),
    [sym_format_triple_quoted_string] = STATE(870),
    [sym_triple_quoted_string] = STATE(868),
    [sym_const] = STATE(867),
    [sym_long_identifier] = STATE(872),
    [sym_active_pattern] = STATE(871),
    [sym__identifier_or_op] = STATE(873),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(499),
    [sym_sbyte] = STATE(868),
    [sym_byte] = STATE(868),
    [sym_int16] = STATE(868),
    [sym_uint16] = STATE(868),
    [sym_int32] = STATE(868),
    [sym_uint32] = STATE(868),
    [sym_nativeint] = STATE(868),
    [sym_unativeint] = STATE(868),
    [sym_int64] = STATE(868),
    [sym_uint64] = STATE(868),
    [sym_ieee32] = STATE(868),
    [sym_ieee64] = STATE(868),
    [sym_bignum] = STATE(868),
    [sym_decimal] = STATE(868),
    [sym_float] = STATE(1368),
    [sym_block_comment] = STATE(412),
    [sym_compiler_directive_decl] = STATE(412),
    [sym_fsi_directive_decl] = STATE(412),
    [sym_preproc_line] = STATE(412),
    [sym_preproc_if_in_expression] = STATE(867),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(29),
    [anon_sym_return] = ACTIONS(369),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_null] = ACTIONS(49),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACK_PIPE] = ACTIONS(57),
    [anon_sym_LBRACE] = ACTIONS(1663),
    [anon_sym_LT_AT] = ACTIONS(61),
    [anon_sym_LT_AT_AT] = ACTIONS(1665),
    [anon_sym_LBRACE_PIPE] = ACTIONS(67),
    [anon_sym_new] = ACTIONS(369),
    [anon_sym_return_BANG] = ACTIONS(373),
    [anon_sym_yield] = ACTIONS(369),
    [anon_sym_yield_BANG] = ACTIONS(373),
    [anon_sym_lazy] = ACTIONS(369),
    [anon_sym_assert] = ACTIONS(369),
    [anon_sym_upcast] = ACTIONS(369),
    [anon_sym_downcast] = ACTIONS(369),
    [anon_sym_for] = ACTIONS(375),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(79),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_match] = ACTIONS(83),
    [anon_sym_match_BANG] = ACTIONS(85),
    [anon_sym_function] = ACTIONS(87),
    [anon_sym_use] = ACTIONS(379),
    [anon_sym_use_BANG] = ACTIONS(381),
    [anon_sym_do_BANG] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(101),
    [anon_sym_DOT_DOT3] = ACTIONS(1669),
    [anon_sym_STAR] = ACTIONS(1671),
    [aux_sym_char_token1] = ACTIONS(105),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(107),
    [anon_sym_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DQUOTE] = ACTIONS(111),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(115),
    [sym_bool] = ACTIONS(117),
    [sym_unit] = ACTIONS(1673),
    [anon_sym_LPAREN_PIPE] = ACTIONS(121),
    [sym_op_identifier] = ACTIONS(1675),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(385),
    [sym_xint] = ACTIONS(387),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(135),
  },
  [413] = {
    [sym_function_or_value_defn] = STATE(627),
    [sym__expression] = STATE(307),
    [sym_literal_expression] = STATE(1118),
    [sym_long_identifier_or_op] = STATE(1118),
    [sym_tuple_expression] = STATE(1118),
    [sym_brace_expression] = STATE(1118),
    [sym_anon_record_expression] = STATE(1118),
    [sym_object_expression] = STATE(6752),
    [sym_with_field_expression] = STATE(6752),
    [sym_prefixed_expression] = STATE(1118),
    [sym_typecast_expression] = STATE(1118),
    [sym_for_expression] = STATE(1118),
    [sym_while_expression] = STATE(1118),
    [sym__if_branch] = STATE(7163),
    [sym_if_expression] = STATE(1118),
    [sym_fun_expression] = STATE(1118),
    [sym_try_expression] = STATE(1118),
    [sym_match_expression] = STATE(1118),
    [sym_function_expression] = STATE(1118),
    [sym_mutate_expression] = STATE(1118),
    [sym_index_expression] = STATE(1118),
    [sym_typed_expression] = STATE(1118),
    [sym_declaration_expression] = STATE(1118),
    [sym_do_expression] = STATE(1118),
    [sym_list_expression] = STATE(1118),
    [sym_array_expression] = STATE(1118),
    [sym_begin_end_expression] = STATE(1118),
    [sym_paren_expression] = STATE(1118),
    [sym__high_prec_app] = STATE(1133),
    [sym__low_prec_app] = STATE(1133),
    [sym_application_expression] = STATE(1118),
    [sym_dot_expression] = STATE(1118),
    [sym_infix_expression] = STATE(1118),
    [sym_ce_expression] = STATE(1118),
    [sym_sequential_expression] = STATE(1118),
    [sym_field_initializer] = STATE(5913),
    [sym_field_initializers] = STATE(6752),
    [sym_char] = STATE(1080),
    [sym_format_string] = STATE(1090),
    [sym__string_literal] = STATE(1090),
    [sym_string] = STATE(1080),
    [sym_verbatim_string] = STATE(1080),
    [sym_bytearray] = STATE(1080),
    [sym_verbatim_bytearray] = STATE(1080),
    [sym_format_triple_quoted_string] = STATE(1096),
    [sym_triple_quoted_string] = STATE(1080),
    [sym_const] = STATE(1118),
    [sym_long_identifier] = STATE(2053),
    [sym_active_pattern] = STATE(1085),
    [sym__identifier_or_op] = STATE(1099),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(517),
    [sym_sbyte] = STATE(1080),
    [sym_byte] = STATE(1080),
    [sym_int16] = STATE(1080),
    [sym_uint16] = STATE(1080),
    [sym_int32] = STATE(1080),
    [sym_uint32] = STATE(1080),
    [sym_nativeint] = STATE(1080),
    [sym_unativeint] = STATE(1080),
    [sym_int64] = STATE(1080),
    [sym_uint64] = STATE(1080),
    [sym_ieee32] = STATE(1080),
    [sym_ieee64] = STATE(1080),
    [sym_bignum] = STATE(1080),
    [sym_decimal] = STATE(1080),
    [sym_float] = STATE(979),
    [sym_block_comment] = STATE(413),
    [sym_compiler_directive_decl] = STATE(413),
    [sym_fsi_directive_decl] = STATE(413),
    [sym_preproc_line] = STATE(413),
    [sym_preproc_if_in_expression] = STATE(1118),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(1773),
    [anon_sym_return] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_null] = ACTIONS(207),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(209),
    [anon_sym_LBRACK_PIPE] = ACTIONS(211),
    [anon_sym_LBRACE] = ACTIONS(1687),
    [anon_sym_LT_AT] = ACTIONS(213),
    [anon_sym_LT_AT_AT] = ACTIONS(1689),
    [anon_sym_LBRACE_PIPE] = ACTIONS(217),
    [anon_sym_new] = ACTIONS(1775),
    [anon_sym_return_BANG] = ACTIONS(219),
    [anon_sym_yield] = ACTIONS(199),
    [anon_sym_yield_BANG] = ACTIONS(219),
    [anon_sym_lazy] = ACTIONS(199),
    [anon_sym_assert] = ACTIONS(199),
    [anon_sym_upcast] = ACTIONS(199),
    [anon_sym_downcast] = ACTIONS(199),
    [anon_sym_for] = ACTIONS(223),
    [anon_sym_while] = ACTIONS(225),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(229),
    [anon_sym_match] = ACTIONS(231),
    [anon_sym_match_BANG] = ACTIONS(233),
    [anon_sym_function] = ACTIONS(235),
    [anon_sym_use] = ACTIONS(239),
    [anon_sym_use_BANG] = ACTIONS(241),
    [anon_sym_do_BANG] = ACTIONS(243),
    [anon_sym_begin] = ACTIONS(245),
    [aux_sym_char_token1] = ACTIONS(247),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(251),
    [anon_sym_AT_DQUOTE] = ACTIONS(253),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(255),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(257),
    [sym_bool] = ACTIONS(259),
    [sym_unit] = ACTIONS(1699),
    [anon_sym_LPAREN_PIPE] = ACTIONS(261),
    [sym_op_identifier] = ACTIONS(1701),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(265),
    [sym_xint] = ACTIONS(267),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(269),
  },
  [414] = {
    [sym_function_or_value_defn] = STATE(627),
    [sym__expression] = STATE(307),
    [sym_literal_expression] = STATE(1118),
    [sym_long_identifier_or_op] = STATE(1118),
    [sym_tuple_expression] = STATE(1118),
    [sym_brace_expression] = STATE(1118),
    [sym_anon_record_expression] = STATE(1118),
    [sym_object_expression] = STATE(6410),
    [sym_with_field_expression] = STATE(6410),
    [sym_prefixed_expression] = STATE(1118),
    [sym_typecast_expression] = STATE(1118),
    [sym_for_expression] = STATE(1118),
    [sym_while_expression] = STATE(1118),
    [sym__if_branch] = STATE(7163),
    [sym_if_expression] = STATE(1118),
    [sym_fun_expression] = STATE(1118),
    [sym_try_expression] = STATE(1118),
    [sym_match_expression] = STATE(1118),
    [sym_function_expression] = STATE(1118),
    [sym_mutate_expression] = STATE(1118),
    [sym_index_expression] = STATE(1118),
    [sym_typed_expression] = STATE(1118),
    [sym_declaration_expression] = STATE(1118),
    [sym_do_expression] = STATE(1118),
    [sym_list_expression] = STATE(1118),
    [sym_array_expression] = STATE(1118),
    [sym_begin_end_expression] = STATE(1118),
    [sym_paren_expression] = STATE(1118),
    [sym__high_prec_app] = STATE(1133),
    [sym__low_prec_app] = STATE(1133),
    [sym_application_expression] = STATE(1118),
    [sym_dot_expression] = STATE(1118),
    [sym_infix_expression] = STATE(1118),
    [sym_ce_expression] = STATE(1118),
    [sym_sequential_expression] = STATE(1118),
    [sym_field_initializer] = STATE(5913),
    [sym_field_initializers] = STATE(6410),
    [sym_char] = STATE(1080),
    [sym_format_string] = STATE(1090),
    [sym__string_literal] = STATE(1090),
    [sym_string] = STATE(1080),
    [sym_verbatim_string] = STATE(1080),
    [sym_bytearray] = STATE(1080),
    [sym_verbatim_bytearray] = STATE(1080),
    [sym_format_triple_quoted_string] = STATE(1096),
    [sym_triple_quoted_string] = STATE(1080),
    [sym_const] = STATE(1118),
    [sym_long_identifier] = STATE(2053),
    [sym_active_pattern] = STATE(1085),
    [sym__identifier_or_op] = STATE(1099),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(517),
    [sym_sbyte] = STATE(1080),
    [sym_byte] = STATE(1080),
    [sym_int16] = STATE(1080),
    [sym_uint16] = STATE(1080),
    [sym_int32] = STATE(1080),
    [sym_uint32] = STATE(1080),
    [sym_nativeint] = STATE(1080),
    [sym_unativeint] = STATE(1080),
    [sym_int64] = STATE(1080),
    [sym_uint64] = STATE(1080),
    [sym_ieee32] = STATE(1080),
    [sym_ieee64] = STATE(1080),
    [sym_bignum] = STATE(1080),
    [sym_decimal] = STATE(1080),
    [sym_float] = STATE(979),
    [sym_block_comment] = STATE(414),
    [sym_compiler_directive_decl] = STATE(414),
    [sym_fsi_directive_decl] = STATE(414),
    [sym_preproc_line] = STATE(414),
    [sym_preproc_if_in_expression] = STATE(1118),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(1773),
    [anon_sym_return] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_null] = ACTIONS(207),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(209),
    [anon_sym_LBRACK_PIPE] = ACTIONS(211),
    [anon_sym_LBRACE] = ACTIONS(1687),
    [anon_sym_LT_AT] = ACTIONS(213),
    [anon_sym_LT_AT_AT] = ACTIONS(1689),
    [anon_sym_LBRACE_PIPE] = ACTIONS(217),
    [anon_sym_new] = ACTIONS(1775),
    [anon_sym_return_BANG] = ACTIONS(219),
    [anon_sym_yield] = ACTIONS(199),
    [anon_sym_yield_BANG] = ACTIONS(219),
    [anon_sym_lazy] = ACTIONS(199),
    [anon_sym_assert] = ACTIONS(199),
    [anon_sym_upcast] = ACTIONS(199),
    [anon_sym_downcast] = ACTIONS(199),
    [anon_sym_for] = ACTIONS(223),
    [anon_sym_while] = ACTIONS(225),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(229),
    [anon_sym_match] = ACTIONS(231),
    [anon_sym_match_BANG] = ACTIONS(233),
    [anon_sym_function] = ACTIONS(235),
    [anon_sym_use] = ACTIONS(239),
    [anon_sym_use_BANG] = ACTIONS(241),
    [anon_sym_do_BANG] = ACTIONS(243),
    [anon_sym_begin] = ACTIONS(245),
    [aux_sym_char_token1] = ACTIONS(247),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(251),
    [anon_sym_AT_DQUOTE] = ACTIONS(253),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(255),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(257),
    [sym_bool] = ACTIONS(259),
    [sym_unit] = ACTIONS(1699),
    [anon_sym_LPAREN_PIPE] = ACTIONS(261),
    [sym_op_identifier] = ACTIONS(1701),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(265),
    [sym_xint] = ACTIONS(267),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(269),
  },
  [415] = {
    [sym_function_or_value_defn] = STATE(627),
    [sym__expression] = STATE(307),
    [sym_literal_expression] = STATE(1118),
    [sym_long_identifier_or_op] = STATE(1118),
    [sym_tuple_expression] = STATE(1118),
    [sym_brace_expression] = STATE(1118),
    [sym_anon_record_expression] = STATE(1118),
    [sym_object_expression] = STATE(6846),
    [sym_with_field_expression] = STATE(6846),
    [sym_prefixed_expression] = STATE(1118),
    [sym_typecast_expression] = STATE(1118),
    [sym_for_expression] = STATE(1118),
    [sym_while_expression] = STATE(1118),
    [sym__if_branch] = STATE(7163),
    [sym_if_expression] = STATE(1118),
    [sym_fun_expression] = STATE(1118),
    [sym_try_expression] = STATE(1118),
    [sym_match_expression] = STATE(1118),
    [sym_function_expression] = STATE(1118),
    [sym_mutate_expression] = STATE(1118),
    [sym_index_expression] = STATE(1118),
    [sym_typed_expression] = STATE(1118),
    [sym_declaration_expression] = STATE(1118),
    [sym_do_expression] = STATE(1118),
    [sym_list_expression] = STATE(1118),
    [sym_array_expression] = STATE(1118),
    [sym_begin_end_expression] = STATE(1118),
    [sym_paren_expression] = STATE(1118),
    [sym__high_prec_app] = STATE(1133),
    [sym__low_prec_app] = STATE(1133),
    [sym_application_expression] = STATE(1118),
    [sym_dot_expression] = STATE(1118),
    [sym_infix_expression] = STATE(1118),
    [sym_ce_expression] = STATE(1118),
    [sym_sequential_expression] = STATE(1118),
    [sym_field_initializer] = STATE(5913),
    [sym_field_initializers] = STATE(6846),
    [sym_char] = STATE(1080),
    [sym_format_string] = STATE(1090),
    [sym__string_literal] = STATE(1090),
    [sym_string] = STATE(1080),
    [sym_verbatim_string] = STATE(1080),
    [sym_bytearray] = STATE(1080),
    [sym_verbatim_bytearray] = STATE(1080),
    [sym_format_triple_quoted_string] = STATE(1096),
    [sym_triple_quoted_string] = STATE(1080),
    [sym_const] = STATE(1118),
    [sym_long_identifier] = STATE(2053),
    [sym_active_pattern] = STATE(1085),
    [sym__identifier_or_op] = STATE(1099),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(517),
    [sym_sbyte] = STATE(1080),
    [sym_byte] = STATE(1080),
    [sym_int16] = STATE(1080),
    [sym_uint16] = STATE(1080),
    [sym_int32] = STATE(1080),
    [sym_uint32] = STATE(1080),
    [sym_nativeint] = STATE(1080),
    [sym_unativeint] = STATE(1080),
    [sym_int64] = STATE(1080),
    [sym_uint64] = STATE(1080),
    [sym_ieee32] = STATE(1080),
    [sym_ieee64] = STATE(1080),
    [sym_bignum] = STATE(1080),
    [sym_decimal] = STATE(1080),
    [sym_float] = STATE(979),
    [sym_block_comment] = STATE(415),
    [sym_compiler_directive_decl] = STATE(415),
    [sym_fsi_directive_decl] = STATE(415),
    [sym_preproc_line] = STATE(415),
    [sym_preproc_if_in_expression] = STATE(1118),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(1773),
    [anon_sym_return] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_null] = ACTIONS(207),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(209),
    [anon_sym_LBRACK_PIPE] = ACTIONS(211),
    [anon_sym_LBRACE] = ACTIONS(1687),
    [anon_sym_LT_AT] = ACTIONS(213),
    [anon_sym_LT_AT_AT] = ACTIONS(1689),
    [anon_sym_LBRACE_PIPE] = ACTIONS(217),
    [anon_sym_new] = ACTIONS(1775),
    [anon_sym_return_BANG] = ACTIONS(219),
    [anon_sym_yield] = ACTIONS(199),
    [anon_sym_yield_BANG] = ACTIONS(219),
    [anon_sym_lazy] = ACTIONS(199),
    [anon_sym_assert] = ACTIONS(199),
    [anon_sym_upcast] = ACTIONS(199),
    [anon_sym_downcast] = ACTIONS(199),
    [anon_sym_for] = ACTIONS(223),
    [anon_sym_while] = ACTIONS(225),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(229),
    [anon_sym_match] = ACTIONS(231),
    [anon_sym_match_BANG] = ACTIONS(233),
    [anon_sym_function] = ACTIONS(235),
    [anon_sym_use] = ACTIONS(239),
    [anon_sym_use_BANG] = ACTIONS(241),
    [anon_sym_do_BANG] = ACTIONS(243),
    [anon_sym_begin] = ACTIONS(245),
    [aux_sym_char_token1] = ACTIONS(247),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(251),
    [anon_sym_AT_DQUOTE] = ACTIONS(253),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(255),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(257),
    [sym_bool] = ACTIONS(259),
    [sym_unit] = ACTIONS(1699),
    [anon_sym_LPAREN_PIPE] = ACTIONS(261),
    [sym_op_identifier] = ACTIONS(1701),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(265),
    [sym_xint] = ACTIONS(267),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(269),
  },
  [416] = {
    [sym_function_or_value_defn] = STATE(532),
    [sym__expression] = STATE(102),
    [sym_literal_expression] = STATE(2000),
    [sym_long_identifier_or_op] = STATE(2000),
    [sym_tuple_expression] = STATE(2000),
    [sym_brace_expression] = STATE(2000),
    [sym_anon_record_expression] = STATE(2000),
    [sym_prefixed_expression] = STATE(2000),
    [sym_typecast_expression] = STATE(2000),
    [sym_for_expression] = STATE(2000),
    [sym_while_expression] = STATE(2000),
    [sym__if_branch] = STATE(6707),
    [sym_if_expression] = STATE(2000),
    [sym_fun_expression] = STATE(2000),
    [sym_try_expression] = STATE(2000),
    [sym_match_expression] = STATE(2000),
    [sym_function_expression] = STATE(2000),
    [sym_mutate_expression] = STATE(2000),
    [sym_index_expression] = STATE(2000),
    [sym_typed_expression] = STATE(2000),
    [sym_declaration_expression] = STATE(2000),
    [sym_do_expression] = STATE(2000),
    [sym_list_expression] = STATE(2000),
    [sym_array_expression] = STATE(2000),
    [sym_begin_end_expression] = STATE(2000),
    [sym_paren_expression] = STATE(2000),
    [sym__high_prec_app] = STATE(2003),
    [sym__low_prec_app] = STATE(2003),
    [sym_application_expression] = STATE(2000),
    [sym_dot_expression] = STATE(2000),
    [sym_infix_expression] = STATE(2000),
    [sym_ce_expression] = STATE(2000),
    [sym_sequential_expression] = STATE(2000),
    [sym_char] = STATE(1801),
    [sym_format_string] = STATE(1804),
    [sym__string_literal] = STATE(1804),
    [sym_string] = STATE(1801),
    [sym_verbatim_string] = STATE(1801),
    [sym_bytearray] = STATE(1801),
    [sym_verbatim_bytearray] = STATE(1801),
    [sym_format_triple_quoted_string] = STATE(1807),
    [sym_triple_quoted_string] = STATE(1801),
    [sym_const] = STATE(2000),
    [sym_long_identifier] = STATE(1725),
    [sym_active_pattern] = STATE(1726),
    [sym__identifier_or_op] = STATE(1751),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(723),
    [sym_sbyte] = STATE(1801),
    [sym_byte] = STATE(1801),
    [sym_int16] = STATE(1801),
    [sym_uint16] = STATE(1801),
    [sym_int32] = STATE(1801),
    [sym_uint32] = STATE(1801),
    [sym_nativeint] = STATE(1801),
    [sym_unativeint] = STATE(1801),
    [sym_int64] = STATE(1801),
    [sym_uint64] = STATE(1801),
    [sym_ieee32] = STATE(1801),
    [sym_ieee64] = STATE(1801),
    [sym_bignum] = STATE(1801),
    [sym_decimal] = STATE(1801),
    [sym_float] = STATE(1427),
    [sym_block_comment] = STATE(416),
    [sym_compiler_directive_decl] = STATE(416),
    [sym_fsi_directive_decl] = STATE(416),
    [sym_preproc_line] = STATE(416),
    [sym_preproc_if_in_expression] = STATE(2000),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [aux_sym_preproc_if_in_expression_repeat1] = STATE(416),
    [sym_identifier] = ACTIONS(1777),
    [anon_sym_return] = ACTIONS(1780),
    [anon_sym_do] = ACTIONS(1783),
    [anon_sym_let] = ACTIONS(1786),
    [anon_sym_let_BANG] = ACTIONS(1789),
    [anon_sym_LPAREN] = ACTIONS(1792),
    [anon_sym_null] = ACTIONS(1795),
    [anon_sym_AMP] = ACTIONS(1798),
    [anon_sym_LBRACK] = ACTIONS(1801),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1804),
    [anon_sym_LBRACE] = ACTIONS(1807),
    [anon_sym_LT_AT] = ACTIONS(1810),
    [anon_sym_LT_AT_AT] = ACTIONS(1813),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1816),
    [anon_sym_new] = ACTIONS(1780),
    [anon_sym_return_BANG] = ACTIONS(1819),
    [anon_sym_yield] = ACTIONS(1780),
    [anon_sym_yield_BANG] = ACTIONS(1819),
    [anon_sym_lazy] = ACTIONS(1780),
    [anon_sym_assert] = ACTIONS(1780),
    [anon_sym_upcast] = ACTIONS(1780),
    [anon_sym_downcast] = ACTIONS(1780),
    [anon_sym_for] = ACTIONS(1822),
    [anon_sym_while] = ACTIONS(1825),
    [anon_sym_if] = ACTIONS(1828),
    [anon_sym_fun] = ACTIONS(1831),
    [anon_sym_try] = ACTIONS(1834),
    [anon_sym_match] = ACTIONS(1837),
    [anon_sym_match_BANG] = ACTIONS(1840),
    [anon_sym_function] = ACTIONS(1843),
    [anon_sym_use] = ACTIONS(1846),
    [anon_sym_use_BANG] = ACTIONS(1849),
    [anon_sym_do_BANG] = ACTIONS(1852),
    [anon_sym_begin] = ACTIONS(1855),
    [aux_sym_char_token1] = ACTIONS(1858),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1861),
    [anon_sym_DQUOTE] = ACTIONS(1864),
    [anon_sym_AT_DQUOTE] = ACTIONS(1867),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1870),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1873),
    [sym_bool] = ACTIONS(1876),
    [sym_unit] = ACTIONS(1879),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1882),
    [sym_op_identifier] = ACTIONS(1885),
    [anon_sym_PLUS] = ACTIONS(1798),
    [anon_sym_DASH] = ACTIONS(1798),
    [anon_sym_PLUS_DOT] = ACTIONS(1888),
    [anon_sym_DASH_DOT] = ACTIONS(1888),
    [anon_sym_PERCENT] = ACTIONS(1888),
    [anon_sym_AMP_AMP] = ACTIONS(1888),
    [anon_sym_TILDE] = ACTIONS(1891),
    [aux_sym_prefix_op_token1] = ACTIONS(1894),
    [sym_int] = ACTIONS(1897),
    [sym_xint] = ACTIONS(1900),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1903),
    [anon_sym_POUNDendif] = ACTIONS(821),
    [anon_sym_POUNDelse] = ACTIONS(821),
    [sym__newline] = ACTIONS(1906),
  },
  [417] = {
    [sym_function_or_value_defn] = STATE(704),
    [sym__expression] = STATE(199),
    [sym_literal_expression] = STATE(2403),
    [sym_long_identifier_or_op] = STATE(2403),
    [sym_tuple_expression] = STATE(2403),
    [sym_brace_expression] = STATE(2403),
    [sym_anon_record_expression] = STATE(2403),
    [sym_prefixed_expression] = STATE(2403),
    [sym_typecast_expression] = STATE(2403),
    [sym_for_expression] = STATE(2403),
    [sym_while_expression] = STATE(2403),
    [sym__if_branch] = STATE(6794),
    [sym_if_expression] = STATE(2403),
    [sym_fun_expression] = STATE(2403),
    [sym_try_expression] = STATE(2403),
    [sym_match_expression] = STATE(2403),
    [sym_function_expression] = STATE(2403),
    [sym_mutate_expression] = STATE(2403),
    [sym_index_expression] = STATE(2403),
    [sym_typed_expression] = STATE(2403),
    [sym_declaration_expression] = STATE(2403),
    [sym_do_expression] = STATE(2403),
    [sym_list_expression] = STATE(2403),
    [sym_array_expression] = STATE(2403),
    [sym_begin_end_expression] = STATE(2403),
    [sym_paren_expression] = STATE(2403),
    [sym__high_prec_app] = STATE(2405),
    [sym__low_prec_app] = STATE(2405),
    [sym_application_expression] = STATE(2403),
    [sym_dot_expression] = STATE(2403),
    [sym_infix_expression] = STATE(2403),
    [sym_ce_expression] = STATE(2403),
    [sym_sequential_expression] = STATE(2403),
    [sym_char] = STATE(2425),
    [sym_format_string] = STATE(2420),
    [sym__string_literal] = STATE(2420),
    [sym_string] = STATE(2425),
    [sym_verbatim_string] = STATE(2425),
    [sym_bytearray] = STATE(2425),
    [sym_verbatim_bytearray] = STATE(2425),
    [sym_format_triple_quoted_string] = STATE(2419),
    [sym_triple_quoted_string] = STATE(2425),
    [sym_const] = STATE(2403),
    [sym_long_identifier] = STATE(2079),
    [sym_active_pattern] = STATE(2080),
    [sym__identifier_or_op] = STATE(2089),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(688),
    [sym_sbyte] = STATE(2425),
    [sym_byte] = STATE(2425),
    [sym_int16] = STATE(2425),
    [sym_uint16] = STATE(2425),
    [sym_int32] = STATE(2425),
    [sym_uint32] = STATE(2425),
    [sym_nativeint] = STATE(2425),
    [sym_unativeint] = STATE(2425),
    [sym_int64] = STATE(2425),
    [sym_uint64] = STATE(2425),
    [sym_ieee32] = STATE(2425),
    [sym_ieee64] = STATE(2425),
    [sym_bignum] = STATE(2425),
    [sym_decimal] = STATE(2425),
    [sym_float] = STATE(1511),
    [sym_block_comment] = STATE(417),
    [sym_compiler_directive_decl] = STATE(417),
    [sym_fsi_directive_decl] = STATE(417),
    [sym_preproc_line] = STATE(417),
    [sym_preproc_if_in_expression] = STATE(2403),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [aux_sym_preproc_if_in_expression_repeat1] = STATE(422),
    [sym_identifier] = ACTIONS(1261),
    [anon_sym_return] = ACTIONS(1265),
    [anon_sym_do] = ACTIONS(1267),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(1269),
    [anon_sym_null] = ACTIONS(1273),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1275),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1277),
    [anon_sym_LBRACE] = ACTIONS(1909),
    [anon_sym_LT_AT] = ACTIONS(1281),
    [anon_sym_LT_AT_AT] = ACTIONS(1911),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1287),
    [anon_sym_new] = ACTIONS(1265),
    [anon_sym_return_BANG] = ACTIONS(1289),
    [anon_sym_yield] = ACTIONS(1265),
    [anon_sym_yield_BANG] = ACTIONS(1289),
    [anon_sym_lazy] = ACTIONS(1265),
    [anon_sym_assert] = ACTIONS(1265),
    [anon_sym_upcast] = ACTIONS(1265),
    [anon_sym_downcast] = ACTIONS(1265),
    [anon_sym_for] = ACTIONS(1293),
    [anon_sym_while] = ACTIONS(1295),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(1297),
    [anon_sym_try] = ACTIONS(1299),
    [anon_sym_match] = ACTIONS(1301),
    [anon_sym_match_BANG] = ACTIONS(1303),
    [anon_sym_function] = ACTIONS(1305),
    [anon_sym_use] = ACTIONS(1313),
    [anon_sym_use_BANG] = ACTIONS(1315),
    [anon_sym_do_BANG] = ACTIONS(1317),
    [anon_sym_begin] = ACTIONS(1319),
    [aux_sym_char_token1] = ACTIONS(1323),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1325),
    [anon_sym_DQUOTE] = ACTIONS(1327),
    [anon_sym_AT_DQUOTE] = ACTIONS(1329),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1331),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1333),
    [sym_bool] = ACTIONS(1335),
    [sym_unit] = ACTIONS(1913),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1339),
    [sym_op_identifier] = ACTIONS(1915),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(1343),
    [sym_xint] = ACTIONS(1345),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1347),
    [anon_sym_POUNDendif] = ACTIONS(1917),
    [sym__newline] = ACTIONS(1919),
  },
  [418] = {
    [sym_function_or_value_defn] = STATE(627),
    [sym__expression] = STATE(307),
    [sym_literal_expression] = STATE(1118),
    [sym_long_identifier_or_op] = STATE(1118),
    [sym_tuple_expression] = STATE(1118),
    [sym_brace_expression] = STATE(1118),
    [sym_anon_record_expression] = STATE(1118),
    [sym_with_field_expression] = STATE(6767),
    [sym_prefixed_expression] = STATE(1118),
    [sym_typecast_expression] = STATE(1118),
    [sym_for_expression] = STATE(1118),
    [sym_while_expression] = STATE(1118),
    [sym__if_branch] = STATE(7163),
    [sym_if_expression] = STATE(1118),
    [sym_fun_expression] = STATE(1118),
    [sym_try_expression] = STATE(1118),
    [sym_match_expression] = STATE(1118),
    [sym_function_expression] = STATE(1118),
    [sym_mutate_expression] = STATE(1118),
    [sym_index_expression] = STATE(1118),
    [sym_typed_expression] = STATE(1118),
    [sym_declaration_expression] = STATE(1118),
    [sym_do_expression] = STATE(1118),
    [sym_list_expression] = STATE(1118),
    [sym_array_expression] = STATE(1118),
    [sym_begin_end_expression] = STATE(1118),
    [sym_paren_expression] = STATE(1118),
    [sym__high_prec_app] = STATE(1133),
    [sym__low_prec_app] = STATE(1133),
    [sym_application_expression] = STATE(1118),
    [sym_dot_expression] = STATE(1118),
    [sym_infix_expression] = STATE(1118),
    [sym_ce_expression] = STATE(1118),
    [sym_sequential_expression] = STATE(1118),
    [sym_field_initializer] = STATE(5913),
    [sym_field_initializers] = STATE(6767),
    [sym_char] = STATE(1080),
    [sym_format_string] = STATE(1090),
    [sym__string_literal] = STATE(1090),
    [sym_string] = STATE(1080),
    [sym_verbatim_string] = STATE(1080),
    [sym_bytearray] = STATE(1080),
    [sym_verbatim_bytearray] = STATE(1080),
    [sym_format_triple_quoted_string] = STATE(1096),
    [sym_triple_quoted_string] = STATE(1080),
    [sym_const] = STATE(1118),
    [sym_long_identifier] = STATE(2053),
    [sym_active_pattern] = STATE(1085),
    [sym__identifier_or_op] = STATE(1099),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(517),
    [sym_sbyte] = STATE(1080),
    [sym_byte] = STATE(1080),
    [sym_int16] = STATE(1080),
    [sym_uint16] = STATE(1080),
    [sym_int32] = STATE(1080),
    [sym_uint32] = STATE(1080),
    [sym_nativeint] = STATE(1080),
    [sym_unativeint] = STATE(1080),
    [sym_int64] = STATE(1080),
    [sym_uint64] = STATE(1080),
    [sym_ieee32] = STATE(1080),
    [sym_ieee64] = STATE(1080),
    [sym_bignum] = STATE(1080),
    [sym_decimal] = STATE(1080),
    [sym_float] = STATE(979),
    [sym_block_comment] = STATE(418),
    [sym_compiler_directive_decl] = STATE(418),
    [sym_fsi_directive_decl] = STATE(418),
    [sym_preproc_line] = STATE(418),
    [sym_preproc_if_in_expression] = STATE(1118),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(1773),
    [anon_sym_return] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_null] = ACTIONS(207),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(209),
    [anon_sym_LBRACK_PIPE] = ACTIONS(211),
    [anon_sym_LBRACE] = ACTIONS(1687),
    [anon_sym_LT_AT] = ACTIONS(213),
    [anon_sym_LT_AT_AT] = ACTIONS(1689),
    [anon_sym_LBRACE_PIPE] = ACTIONS(217),
    [anon_sym_new] = ACTIONS(199),
    [anon_sym_return_BANG] = ACTIONS(219),
    [anon_sym_yield] = ACTIONS(199),
    [anon_sym_yield_BANG] = ACTIONS(219),
    [anon_sym_lazy] = ACTIONS(199),
    [anon_sym_assert] = ACTIONS(199),
    [anon_sym_upcast] = ACTIONS(199),
    [anon_sym_downcast] = ACTIONS(199),
    [anon_sym_for] = ACTIONS(223),
    [anon_sym_while] = ACTIONS(225),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(229),
    [anon_sym_match] = ACTIONS(231),
    [anon_sym_match_BANG] = ACTIONS(233),
    [anon_sym_function] = ACTIONS(235),
    [anon_sym_use] = ACTIONS(239),
    [anon_sym_use_BANG] = ACTIONS(241),
    [anon_sym_do_BANG] = ACTIONS(243),
    [anon_sym_begin] = ACTIONS(245),
    [aux_sym_char_token1] = ACTIONS(247),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(251),
    [anon_sym_AT_DQUOTE] = ACTIONS(253),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(255),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(257),
    [sym_bool] = ACTIONS(259),
    [sym_unit] = ACTIONS(1699),
    [anon_sym_LPAREN_PIPE] = ACTIONS(261),
    [sym_op_identifier] = ACTIONS(1701),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(265),
    [sym_xint] = ACTIONS(267),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(269),
  },
  [419] = {
    [sym_function_or_value_defn] = STATE(627),
    [sym__expression] = STATE(307),
    [sym_literal_expression] = STATE(1118),
    [sym_long_identifier_or_op] = STATE(1118),
    [sym_tuple_expression] = STATE(1118),
    [sym_brace_expression] = STATE(1118),
    [sym_anon_record_expression] = STATE(1118),
    [sym_with_field_expression] = STATE(6807),
    [sym_prefixed_expression] = STATE(1118),
    [sym_typecast_expression] = STATE(1118),
    [sym_for_expression] = STATE(1118),
    [sym_while_expression] = STATE(1118),
    [sym__if_branch] = STATE(7163),
    [sym_if_expression] = STATE(1118),
    [sym_fun_expression] = STATE(1118),
    [sym_try_expression] = STATE(1118),
    [sym_match_expression] = STATE(1118),
    [sym_function_expression] = STATE(1118),
    [sym_mutate_expression] = STATE(1118),
    [sym_index_expression] = STATE(1118),
    [sym_typed_expression] = STATE(1118),
    [sym_declaration_expression] = STATE(1118),
    [sym_do_expression] = STATE(1118),
    [sym_list_expression] = STATE(1118),
    [sym_array_expression] = STATE(1118),
    [sym_begin_end_expression] = STATE(1118),
    [sym_paren_expression] = STATE(1118),
    [sym__high_prec_app] = STATE(1133),
    [sym__low_prec_app] = STATE(1133),
    [sym_application_expression] = STATE(1118),
    [sym_dot_expression] = STATE(1118),
    [sym_infix_expression] = STATE(1118),
    [sym_ce_expression] = STATE(1118),
    [sym_sequential_expression] = STATE(1118),
    [sym_field_initializer] = STATE(5913),
    [sym_field_initializers] = STATE(6807),
    [sym_char] = STATE(1080),
    [sym_format_string] = STATE(1090),
    [sym__string_literal] = STATE(1090),
    [sym_string] = STATE(1080),
    [sym_verbatim_string] = STATE(1080),
    [sym_bytearray] = STATE(1080),
    [sym_verbatim_bytearray] = STATE(1080),
    [sym_format_triple_quoted_string] = STATE(1096),
    [sym_triple_quoted_string] = STATE(1080),
    [sym_const] = STATE(1118),
    [sym_long_identifier] = STATE(2053),
    [sym_active_pattern] = STATE(1085),
    [sym__identifier_or_op] = STATE(1099),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(517),
    [sym_sbyte] = STATE(1080),
    [sym_byte] = STATE(1080),
    [sym_int16] = STATE(1080),
    [sym_uint16] = STATE(1080),
    [sym_int32] = STATE(1080),
    [sym_uint32] = STATE(1080),
    [sym_nativeint] = STATE(1080),
    [sym_unativeint] = STATE(1080),
    [sym_int64] = STATE(1080),
    [sym_uint64] = STATE(1080),
    [sym_ieee32] = STATE(1080),
    [sym_ieee64] = STATE(1080),
    [sym_bignum] = STATE(1080),
    [sym_decimal] = STATE(1080),
    [sym_float] = STATE(979),
    [sym_block_comment] = STATE(419),
    [sym_compiler_directive_decl] = STATE(419),
    [sym_fsi_directive_decl] = STATE(419),
    [sym_preproc_line] = STATE(419),
    [sym_preproc_if_in_expression] = STATE(1118),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(1773),
    [anon_sym_return] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_null] = ACTIONS(207),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(209),
    [anon_sym_LBRACK_PIPE] = ACTIONS(211),
    [anon_sym_LBRACE] = ACTIONS(1687),
    [anon_sym_LT_AT] = ACTIONS(213),
    [anon_sym_LT_AT_AT] = ACTIONS(1689),
    [anon_sym_LBRACE_PIPE] = ACTIONS(217),
    [anon_sym_new] = ACTIONS(199),
    [anon_sym_return_BANG] = ACTIONS(219),
    [anon_sym_yield] = ACTIONS(199),
    [anon_sym_yield_BANG] = ACTIONS(219),
    [anon_sym_lazy] = ACTIONS(199),
    [anon_sym_assert] = ACTIONS(199),
    [anon_sym_upcast] = ACTIONS(199),
    [anon_sym_downcast] = ACTIONS(199),
    [anon_sym_for] = ACTIONS(223),
    [anon_sym_while] = ACTIONS(225),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(229),
    [anon_sym_match] = ACTIONS(231),
    [anon_sym_match_BANG] = ACTIONS(233),
    [anon_sym_function] = ACTIONS(235),
    [anon_sym_use] = ACTIONS(239),
    [anon_sym_use_BANG] = ACTIONS(241),
    [anon_sym_do_BANG] = ACTIONS(243),
    [anon_sym_begin] = ACTIONS(245),
    [aux_sym_char_token1] = ACTIONS(247),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(251),
    [anon_sym_AT_DQUOTE] = ACTIONS(253),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(255),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(257),
    [sym_bool] = ACTIONS(259),
    [sym_unit] = ACTIONS(1699),
    [anon_sym_LPAREN_PIPE] = ACTIONS(261),
    [sym_op_identifier] = ACTIONS(1701),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(265),
    [sym_xint] = ACTIONS(267),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(269),
  },
  [420] = {
    [sym_function_or_value_defn] = STATE(627),
    [sym__expression] = STATE(307),
    [sym_literal_expression] = STATE(1118),
    [sym_long_identifier_or_op] = STATE(1118),
    [sym_tuple_expression] = STATE(1118),
    [sym_brace_expression] = STATE(1118),
    [sym_anon_record_expression] = STATE(1118),
    [sym_with_field_expression] = STATE(6847),
    [sym_prefixed_expression] = STATE(1118),
    [sym_typecast_expression] = STATE(1118),
    [sym_for_expression] = STATE(1118),
    [sym_while_expression] = STATE(1118),
    [sym__if_branch] = STATE(7163),
    [sym_if_expression] = STATE(1118),
    [sym_fun_expression] = STATE(1118),
    [sym_try_expression] = STATE(1118),
    [sym_match_expression] = STATE(1118),
    [sym_function_expression] = STATE(1118),
    [sym_mutate_expression] = STATE(1118),
    [sym_index_expression] = STATE(1118),
    [sym_typed_expression] = STATE(1118),
    [sym_declaration_expression] = STATE(1118),
    [sym_do_expression] = STATE(1118),
    [sym_list_expression] = STATE(1118),
    [sym_array_expression] = STATE(1118),
    [sym_begin_end_expression] = STATE(1118),
    [sym_paren_expression] = STATE(1118),
    [sym__high_prec_app] = STATE(1133),
    [sym__low_prec_app] = STATE(1133),
    [sym_application_expression] = STATE(1118),
    [sym_dot_expression] = STATE(1118),
    [sym_infix_expression] = STATE(1118),
    [sym_ce_expression] = STATE(1118),
    [sym_sequential_expression] = STATE(1118),
    [sym_field_initializer] = STATE(5913),
    [sym_field_initializers] = STATE(6847),
    [sym_char] = STATE(1080),
    [sym_format_string] = STATE(1090),
    [sym__string_literal] = STATE(1090),
    [sym_string] = STATE(1080),
    [sym_verbatim_string] = STATE(1080),
    [sym_bytearray] = STATE(1080),
    [sym_verbatim_bytearray] = STATE(1080),
    [sym_format_triple_quoted_string] = STATE(1096),
    [sym_triple_quoted_string] = STATE(1080),
    [sym_const] = STATE(1118),
    [sym_long_identifier] = STATE(2053),
    [sym_active_pattern] = STATE(1085),
    [sym__identifier_or_op] = STATE(1099),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(517),
    [sym_sbyte] = STATE(1080),
    [sym_byte] = STATE(1080),
    [sym_int16] = STATE(1080),
    [sym_uint16] = STATE(1080),
    [sym_int32] = STATE(1080),
    [sym_uint32] = STATE(1080),
    [sym_nativeint] = STATE(1080),
    [sym_unativeint] = STATE(1080),
    [sym_int64] = STATE(1080),
    [sym_uint64] = STATE(1080),
    [sym_ieee32] = STATE(1080),
    [sym_ieee64] = STATE(1080),
    [sym_bignum] = STATE(1080),
    [sym_decimal] = STATE(1080),
    [sym_float] = STATE(979),
    [sym_block_comment] = STATE(420),
    [sym_compiler_directive_decl] = STATE(420),
    [sym_fsi_directive_decl] = STATE(420),
    [sym_preproc_line] = STATE(420),
    [sym_preproc_if_in_expression] = STATE(1118),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(1773),
    [anon_sym_return] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_null] = ACTIONS(207),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(209),
    [anon_sym_LBRACK_PIPE] = ACTIONS(211),
    [anon_sym_LBRACE] = ACTIONS(1687),
    [anon_sym_LT_AT] = ACTIONS(213),
    [anon_sym_LT_AT_AT] = ACTIONS(1689),
    [anon_sym_LBRACE_PIPE] = ACTIONS(217),
    [anon_sym_new] = ACTIONS(199),
    [anon_sym_return_BANG] = ACTIONS(219),
    [anon_sym_yield] = ACTIONS(199),
    [anon_sym_yield_BANG] = ACTIONS(219),
    [anon_sym_lazy] = ACTIONS(199),
    [anon_sym_assert] = ACTIONS(199),
    [anon_sym_upcast] = ACTIONS(199),
    [anon_sym_downcast] = ACTIONS(199),
    [anon_sym_for] = ACTIONS(223),
    [anon_sym_while] = ACTIONS(225),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(229),
    [anon_sym_match] = ACTIONS(231),
    [anon_sym_match_BANG] = ACTIONS(233),
    [anon_sym_function] = ACTIONS(235),
    [anon_sym_use] = ACTIONS(239),
    [anon_sym_use_BANG] = ACTIONS(241),
    [anon_sym_do_BANG] = ACTIONS(243),
    [anon_sym_begin] = ACTIONS(245),
    [aux_sym_char_token1] = ACTIONS(247),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(251),
    [anon_sym_AT_DQUOTE] = ACTIONS(253),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(255),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(257),
    [sym_bool] = ACTIONS(259),
    [sym_unit] = ACTIONS(1699),
    [anon_sym_LPAREN_PIPE] = ACTIONS(261),
    [sym_op_identifier] = ACTIONS(1701),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(265),
    [sym_xint] = ACTIONS(267),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(269),
  },
  [421] = {
    [sym_function_or_value_defn] = STATE(627),
    [sym__expression] = STATE(307),
    [sym_literal_expression] = STATE(1118),
    [sym_long_identifier_or_op] = STATE(1118),
    [sym_tuple_expression] = STATE(1118),
    [sym_brace_expression] = STATE(1118),
    [sym_anon_record_expression] = STATE(1118),
    [sym_with_field_expression] = STATE(6411),
    [sym_prefixed_expression] = STATE(1118),
    [sym_typecast_expression] = STATE(1118),
    [sym_for_expression] = STATE(1118),
    [sym_while_expression] = STATE(1118),
    [sym__if_branch] = STATE(7163),
    [sym_if_expression] = STATE(1118),
    [sym_fun_expression] = STATE(1118),
    [sym_try_expression] = STATE(1118),
    [sym_match_expression] = STATE(1118),
    [sym_function_expression] = STATE(1118),
    [sym_mutate_expression] = STATE(1118),
    [sym_index_expression] = STATE(1118),
    [sym_typed_expression] = STATE(1118),
    [sym_declaration_expression] = STATE(1118),
    [sym_do_expression] = STATE(1118),
    [sym_list_expression] = STATE(1118),
    [sym_array_expression] = STATE(1118),
    [sym_begin_end_expression] = STATE(1118),
    [sym_paren_expression] = STATE(1118),
    [sym__high_prec_app] = STATE(1133),
    [sym__low_prec_app] = STATE(1133),
    [sym_application_expression] = STATE(1118),
    [sym_dot_expression] = STATE(1118),
    [sym_infix_expression] = STATE(1118),
    [sym_ce_expression] = STATE(1118),
    [sym_sequential_expression] = STATE(1118),
    [sym_field_initializer] = STATE(5913),
    [sym_field_initializers] = STATE(6411),
    [sym_char] = STATE(1080),
    [sym_format_string] = STATE(1090),
    [sym__string_literal] = STATE(1090),
    [sym_string] = STATE(1080),
    [sym_verbatim_string] = STATE(1080),
    [sym_bytearray] = STATE(1080),
    [sym_verbatim_bytearray] = STATE(1080),
    [sym_format_triple_quoted_string] = STATE(1096),
    [sym_triple_quoted_string] = STATE(1080),
    [sym_const] = STATE(1118),
    [sym_long_identifier] = STATE(2053),
    [sym_active_pattern] = STATE(1085),
    [sym__identifier_or_op] = STATE(1099),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(517),
    [sym_sbyte] = STATE(1080),
    [sym_byte] = STATE(1080),
    [sym_int16] = STATE(1080),
    [sym_uint16] = STATE(1080),
    [sym_int32] = STATE(1080),
    [sym_uint32] = STATE(1080),
    [sym_nativeint] = STATE(1080),
    [sym_unativeint] = STATE(1080),
    [sym_int64] = STATE(1080),
    [sym_uint64] = STATE(1080),
    [sym_ieee32] = STATE(1080),
    [sym_ieee64] = STATE(1080),
    [sym_bignum] = STATE(1080),
    [sym_decimal] = STATE(1080),
    [sym_float] = STATE(979),
    [sym_block_comment] = STATE(421),
    [sym_compiler_directive_decl] = STATE(421),
    [sym_fsi_directive_decl] = STATE(421),
    [sym_preproc_line] = STATE(421),
    [sym_preproc_if_in_expression] = STATE(1118),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(1773),
    [anon_sym_return] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_null] = ACTIONS(207),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(209),
    [anon_sym_LBRACK_PIPE] = ACTIONS(211),
    [anon_sym_LBRACE] = ACTIONS(1687),
    [anon_sym_LT_AT] = ACTIONS(213),
    [anon_sym_LT_AT_AT] = ACTIONS(1689),
    [anon_sym_LBRACE_PIPE] = ACTIONS(217),
    [anon_sym_new] = ACTIONS(199),
    [anon_sym_return_BANG] = ACTIONS(219),
    [anon_sym_yield] = ACTIONS(199),
    [anon_sym_yield_BANG] = ACTIONS(219),
    [anon_sym_lazy] = ACTIONS(199),
    [anon_sym_assert] = ACTIONS(199),
    [anon_sym_upcast] = ACTIONS(199),
    [anon_sym_downcast] = ACTIONS(199),
    [anon_sym_for] = ACTIONS(223),
    [anon_sym_while] = ACTIONS(225),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(229),
    [anon_sym_match] = ACTIONS(231),
    [anon_sym_match_BANG] = ACTIONS(233),
    [anon_sym_function] = ACTIONS(235),
    [anon_sym_use] = ACTIONS(239),
    [anon_sym_use_BANG] = ACTIONS(241),
    [anon_sym_do_BANG] = ACTIONS(243),
    [anon_sym_begin] = ACTIONS(245),
    [aux_sym_char_token1] = ACTIONS(247),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(251),
    [anon_sym_AT_DQUOTE] = ACTIONS(253),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(255),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(257),
    [sym_bool] = ACTIONS(259),
    [sym_unit] = ACTIONS(1699),
    [anon_sym_LPAREN_PIPE] = ACTIONS(261),
    [sym_op_identifier] = ACTIONS(1701),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(265),
    [sym_xint] = ACTIONS(267),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(269),
  },
  [422] = {
    [sym_function_or_value_defn] = STATE(704),
    [sym__expression] = STATE(199),
    [sym_literal_expression] = STATE(2403),
    [sym_long_identifier_or_op] = STATE(2403),
    [sym_tuple_expression] = STATE(2403),
    [sym_brace_expression] = STATE(2403),
    [sym_anon_record_expression] = STATE(2403),
    [sym_prefixed_expression] = STATE(2403),
    [sym_typecast_expression] = STATE(2403),
    [sym_for_expression] = STATE(2403),
    [sym_while_expression] = STATE(2403),
    [sym__if_branch] = STATE(6794),
    [sym_if_expression] = STATE(2403),
    [sym_fun_expression] = STATE(2403),
    [sym_try_expression] = STATE(2403),
    [sym_match_expression] = STATE(2403),
    [sym_function_expression] = STATE(2403),
    [sym_mutate_expression] = STATE(2403),
    [sym_index_expression] = STATE(2403),
    [sym_typed_expression] = STATE(2403),
    [sym_declaration_expression] = STATE(2403),
    [sym_do_expression] = STATE(2403),
    [sym_list_expression] = STATE(2403),
    [sym_array_expression] = STATE(2403),
    [sym_begin_end_expression] = STATE(2403),
    [sym_paren_expression] = STATE(2403),
    [sym__high_prec_app] = STATE(2405),
    [sym__low_prec_app] = STATE(2405),
    [sym_application_expression] = STATE(2403),
    [sym_dot_expression] = STATE(2403),
    [sym_infix_expression] = STATE(2403),
    [sym_ce_expression] = STATE(2403),
    [sym_sequential_expression] = STATE(2403),
    [sym_char] = STATE(2425),
    [sym_format_string] = STATE(2420),
    [sym__string_literal] = STATE(2420),
    [sym_string] = STATE(2425),
    [sym_verbatim_string] = STATE(2425),
    [sym_bytearray] = STATE(2425),
    [sym_verbatim_bytearray] = STATE(2425),
    [sym_format_triple_quoted_string] = STATE(2419),
    [sym_triple_quoted_string] = STATE(2425),
    [sym_const] = STATE(2403),
    [sym_long_identifier] = STATE(2079),
    [sym_active_pattern] = STATE(2080),
    [sym__identifier_or_op] = STATE(2089),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(688),
    [sym_sbyte] = STATE(2425),
    [sym_byte] = STATE(2425),
    [sym_int16] = STATE(2425),
    [sym_uint16] = STATE(2425),
    [sym_int32] = STATE(2425),
    [sym_uint32] = STATE(2425),
    [sym_nativeint] = STATE(2425),
    [sym_unativeint] = STATE(2425),
    [sym_int64] = STATE(2425),
    [sym_uint64] = STATE(2425),
    [sym_ieee32] = STATE(2425),
    [sym_ieee64] = STATE(2425),
    [sym_bignum] = STATE(2425),
    [sym_decimal] = STATE(2425),
    [sym_float] = STATE(1511),
    [sym_block_comment] = STATE(422),
    [sym_compiler_directive_decl] = STATE(422),
    [sym_fsi_directive_decl] = STATE(422),
    [sym_preproc_line] = STATE(422),
    [sym_preproc_if_in_expression] = STATE(2403),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [aux_sym_preproc_if_in_expression_repeat1] = STATE(422),
    [sym_identifier] = ACTIONS(1921),
    [anon_sym_return] = ACTIONS(1924),
    [anon_sym_do] = ACTIONS(1927),
    [anon_sym_let] = ACTIONS(1786),
    [anon_sym_let_BANG] = ACTIONS(1789),
    [anon_sym_LPAREN] = ACTIONS(1930),
    [anon_sym_null] = ACTIONS(1933),
    [anon_sym_AMP] = ACTIONS(1798),
    [anon_sym_LBRACK] = ACTIONS(1936),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1939),
    [anon_sym_LBRACE] = ACTIONS(1942),
    [anon_sym_LT_AT] = ACTIONS(1945),
    [anon_sym_LT_AT_AT] = ACTIONS(1948),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1951),
    [anon_sym_new] = ACTIONS(1924),
    [anon_sym_return_BANG] = ACTIONS(1954),
    [anon_sym_yield] = ACTIONS(1924),
    [anon_sym_yield_BANG] = ACTIONS(1954),
    [anon_sym_lazy] = ACTIONS(1924),
    [anon_sym_assert] = ACTIONS(1924),
    [anon_sym_upcast] = ACTIONS(1924),
    [anon_sym_downcast] = ACTIONS(1924),
    [anon_sym_for] = ACTIONS(1957),
    [anon_sym_while] = ACTIONS(1960),
    [anon_sym_if] = ACTIONS(1828),
    [anon_sym_fun] = ACTIONS(1963),
    [anon_sym_try] = ACTIONS(1966),
    [anon_sym_match] = ACTIONS(1969),
    [anon_sym_match_BANG] = ACTIONS(1972),
    [anon_sym_function] = ACTIONS(1975),
    [anon_sym_use] = ACTIONS(1978),
    [anon_sym_use_BANG] = ACTIONS(1981),
    [anon_sym_do_BANG] = ACTIONS(1984),
    [anon_sym_begin] = ACTIONS(1987),
    [aux_sym_char_token1] = ACTIONS(1990),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1993),
    [anon_sym_DQUOTE] = ACTIONS(1996),
    [anon_sym_AT_DQUOTE] = ACTIONS(1999),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2002),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2005),
    [sym_bool] = ACTIONS(2008),
    [sym_unit] = ACTIONS(2011),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2014),
    [sym_op_identifier] = ACTIONS(2017),
    [anon_sym_PLUS] = ACTIONS(1798),
    [anon_sym_DASH] = ACTIONS(1798),
    [anon_sym_PLUS_DOT] = ACTIONS(1888),
    [anon_sym_DASH_DOT] = ACTIONS(1888),
    [anon_sym_PERCENT] = ACTIONS(1888),
    [anon_sym_AMP_AMP] = ACTIONS(1888),
    [anon_sym_TILDE] = ACTIONS(1891),
    [aux_sym_prefix_op_token1] = ACTIONS(1894),
    [sym_int] = ACTIONS(2020),
    [sym_xint] = ACTIONS(2023),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2026),
    [anon_sym_POUNDendif] = ACTIONS(821),
    [sym__newline] = ACTIONS(2029),
  },
  [423] = {
    [sym_function_or_value_defn] = STATE(704),
    [sym__expression] = STATE(199),
    [sym_literal_expression] = STATE(2403),
    [sym_long_identifier_or_op] = STATE(2403),
    [sym_tuple_expression] = STATE(2403),
    [sym_brace_expression] = STATE(2403),
    [sym_anon_record_expression] = STATE(2403),
    [sym_prefixed_expression] = STATE(2403),
    [sym_typecast_expression] = STATE(2403),
    [sym_for_expression] = STATE(2403),
    [sym_while_expression] = STATE(2403),
    [sym__if_branch] = STATE(6794),
    [sym_if_expression] = STATE(2403),
    [sym_fun_expression] = STATE(2403),
    [sym_try_expression] = STATE(2403),
    [sym_match_expression] = STATE(2403),
    [sym_function_expression] = STATE(2403),
    [sym_mutate_expression] = STATE(2403),
    [sym_index_expression] = STATE(2403),
    [sym_typed_expression] = STATE(2403),
    [sym_declaration_expression] = STATE(2403),
    [sym_do_expression] = STATE(2403),
    [sym_list_expression] = STATE(2403),
    [sym_array_expression] = STATE(2403),
    [sym_begin_end_expression] = STATE(2403),
    [sym_paren_expression] = STATE(2403),
    [sym__high_prec_app] = STATE(2405),
    [sym__low_prec_app] = STATE(2405),
    [sym_application_expression] = STATE(2403),
    [sym_dot_expression] = STATE(2403),
    [sym_infix_expression] = STATE(2403),
    [sym_ce_expression] = STATE(2403),
    [sym_sequential_expression] = STATE(2403),
    [sym_char] = STATE(2425),
    [sym_format_string] = STATE(2420),
    [sym__string_literal] = STATE(2420),
    [sym_string] = STATE(2425),
    [sym_verbatim_string] = STATE(2425),
    [sym_bytearray] = STATE(2425),
    [sym_verbatim_bytearray] = STATE(2425),
    [sym_format_triple_quoted_string] = STATE(2419),
    [sym_triple_quoted_string] = STATE(2425),
    [sym_const] = STATE(2403),
    [sym_long_identifier] = STATE(2079),
    [sym_active_pattern] = STATE(2080),
    [sym__identifier_or_op] = STATE(2089),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(688),
    [sym_sbyte] = STATE(2425),
    [sym_byte] = STATE(2425),
    [sym_int16] = STATE(2425),
    [sym_uint16] = STATE(2425),
    [sym_int32] = STATE(2425),
    [sym_uint32] = STATE(2425),
    [sym_nativeint] = STATE(2425),
    [sym_unativeint] = STATE(2425),
    [sym_int64] = STATE(2425),
    [sym_uint64] = STATE(2425),
    [sym_ieee32] = STATE(2425),
    [sym_ieee64] = STATE(2425),
    [sym_bignum] = STATE(2425),
    [sym_decimal] = STATE(2425),
    [sym_float] = STATE(1511),
    [sym_block_comment] = STATE(423),
    [sym_compiler_directive_decl] = STATE(423),
    [sym_fsi_directive_decl] = STATE(423),
    [sym_preproc_line] = STATE(423),
    [sym_preproc_if_in_expression] = STATE(2403),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [aux_sym_preproc_if_in_expression_repeat1] = STATE(417),
    [sym_identifier] = ACTIONS(1261),
    [anon_sym_return] = ACTIONS(1265),
    [anon_sym_do] = ACTIONS(1267),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(1269),
    [anon_sym_null] = ACTIONS(1273),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1275),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1277),
    [anon_sym_LBRACE] = ACTIONS(1909),
    [anon_sym_LT_AT] = ACTIONS(1281),
    [anon_sym_LT_AT_AT] = ACTIONS(1911),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1287),
    [anon_sym_new] = ACTIONS(1265),
    [anon_sym_return_BANG] = ACTIONS(1289),
    [anon_sym_yield] = ACTIONS(1265),
    [anon_sym_yield_BANG] = ACTIONS(1289),
    [anon_sym_lazy] = ACTIONS(1265),
    [anon_sym_assert] = ACTIONS(1265),
    [anon_sym_upcast] = ACTIONS(1265),
    [anon_sym_downcast] = ACTIONS(1265),
    [anon_sym_for] = ACTIONS(1293),
    [anon_sym_while] = ACTIONS(1295),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(1297),
    [anon_sym_try] = ACTIONS(1299),
    [anon_sym_match] = ACTIONS(1301),
    [anon_sym_match_BANG] = ACTIONS(1303),
    [anon_sym_function] = ACTIONS(1305),
    [anon_sym_use] = ACTIONS(1313),
    [anon_sym_use_BANG] = ACTIONS(1315),
    [anon_sym_do_BANG] = ACTIONS(1317),
    [anon_sym_begin] = ACTIONS(1319),
    [aux_sym_char_token1] = ACTIONS(1323),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1325),
    [anon_sym_DQUOTE] = ACTIONS(1327),
    [anon_sym_AT_DQUOTE] = ACTIONS(1329),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1331),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1333),
    [sym_bool] = ACTIONS(1335),
    [sym_unit] = ACTIONS(1913),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1339),
    [sym_op_identifier] = ACTIONS(1915),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(1343),
    [sym_xint] = ACTIONS(1345),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1347),
    [anon_sym_POUNDendif] = ACTIONS(2032),
    [sym__newline] = ACTIONS(1919),
  },
  [424] = {
    [sym_function_or_value_defn] = STATE(627),
    [sym__expression] = STATE(307),
    [sym_literal_expression] = STATE(1118),
    [sym_long_identifier_or_op] = STATE(1118),
    [sym_tuple_expression] = STATE(1118),
    [sym_brace_expression] = STATE(1118),
    [sym_anon_record_expression] = STATE(1118),
    [sym_with_field_expression] = STATE(6740),
    [sym_prefixed_expression] = STATE(1118),
    [sym_typecast_expression] = STATE(1118),
    [sym_for_expression] = STATE(1118),
    [sym_while_expression] = STATE(1118),
    [sym__if_branch] = STATE(7163),
    [sym_if_expression] = STATE(1118),
    [sym_fun_expression] = STATE(1118),
    [sym_try_expression] = STATE(1118),
    [sym_match_expression] = STATE(1118),
    [sym_function_expression] = STATE(1118),
    [sym_mutate_expression] = STATE(1118),
    [sym_index_expression] = STATE(1118),
    [sym_typed_expression] = STATE(1118),
    [sym_declaration_expression] = STATE(1118),
    [sym_do_expression] = STATE(1118),
    [sym_list_expression] = STATE(1118),
    [sym_array_expression] = STATE(1118),
    [sym_begin_end_expression] = STATE(1118),
    [sym_paren_expression] = STATE(1118),
    [sym__high_prec_app] = STATE(1133),
    [sym__low_prec_app] = STATE(1133),
    [sym_application_expression] = STATE(1118),
    [sym_dot_expression] = STATE(1118),
    [sym_infix_expression] = STATE(1118),
    [sym_ce_expression] = STATE(1118),
    [sym_sequential_expression] = STATE(1118),
    [sym_field_initializer] = STATE(5913),
    [sym_field_initializers] = STATE(6740),
    [sym_char] = STATE(1080),
    [sym_format_string] = STATE(1090),
    [sym__string_literal] = STATE(1090),
    [sym_string] = STATE(1080),
    [sym_verbatim_string] = STATE(1080),
    [sym_bytearray] = STATE(1080),
    [sym_verbatim_bytearray] = STATE(1080),
    [sym_format_triple_quoted_string] = STATE(1096),
    [sym_triple_quoted_string] = STATE(1080),
    [sym_const] = STATE(1118),
    [sym_long_identifier] = STATE(2053),
    [sym_active_pattern] = STATE(1085),
    [sym__identifier_or_op] = STATE(1099),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(517),
    [sym_sbyte] = STATE(1080),
    [sym_byte] = STATE(1080),
    [sym_int16] = STATE(1080),
    [sym_uint16] = STATE(1080),
    [sym_int32] = STATE(1080),
    [sym_uint32] = STATE(1080),
    [sym_nativeint] = STATE(1080),
    [sym_unativeint] = STATE(1080),
    [sym_int64] = STATE(1080),
    [sym_uint64] = STATE(1080),
    [sym_ieee32] = STATE(1080),
    [sym_ieee64] = STATE(1080),
    [sym_bignum] = STATE(1080),
    [sym_decimal] = STATE(1080),
    [sym_float] = STATE(979),
    [sym_block_comment] = STATE(424),
    [sym_compiler_directive_decl] = STATE(424),
    [sym_fsi_directive_decl] = STATE(424),
    [sym_preproc_line] = STATE(424),
    [sym_preproc_if_in_expression] = STATE(1118),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(1773),
    [anon_sym_return] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_null] = ACTIONS(207),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(209),
    [anon_sym_LBRACK_PIPE] = ACTIONS(211),
    [anon_sym_LBRACE] = ACTIONS(1687),
    [anon_sym_LT_AT] = ACTIONS(213),
    [anon_sym_LT_AT_AT] = ACTIONS(1689),
    [anon_sym_LBRACE_PIPE] = ACTIONS(217),
    [anon_sym_new] = ACTIONS(199),
    [anon_sym_return_BANG] = ACTIONS(219),
    [anon_sym_yield] = ACTIONS(199),
    [anon_sym_yield_BANG] = ACTIONS(219),
    [anon_sym_lazy] = ACTIONS(199),
    [anon_sym_assert] = ACTIONS(199),
    [anon_sym_upcast] = ACTIONS(199),
    [anon_sym_downcast] = ACTIONS(199),
    [anon_sym_for] = ACTIONS(223),
    [anon_sym_while] = ACTIONS(225),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(229),
    [anon_sym_match] = ACTIONS(231),
    [anon_sym_match_BANG] = ACTIONS(233),
    [anon_sym_function] = ACTIONS(235),
    [anon_sym_use] = ACTIONS(239),
    [anon_sym_use_BANG] = ACTIONS(241),
    [anon_sym_do_BANG] = ACTIONS(243),
    [anon_sym_begin] = ACTIONS(245),
    [aux_sym_char_token1] = ACTIONS(247),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(251),
    [anon_sym_AT_DQUOTE] = ACTIONS(253),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(255),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(257),
    [sym_bool] = ACTIONS(259),
    [sym_unit] = ACTIONS(1699),
    [anon_sym_LPAREN_PIPE] = ACTIONS(261),
    [sym_op_identifier] = ACTIONS(1701),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(265),
    [sym_xint] = ACTIONS(267),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(269),
  },
  [425] = {
    [sym_function_or_value_defn] = STATE(627),
    [sym__expression] = STATE(307),
    [sym_literal_expression] = STATE(1118),
    [sym_long_identifier_or_op] = STATE(1118),
    [sym_tuple_expression] = STATE(1118),
    [sym_brace_expression] = STATE(1118),
    [sym_anon_record_expression] = STATE(1118),
    [sym_with_field_expression] = STATE(6722),
    [sym_prefixed_expression] = STATE(1118),
    [sym_typecast_expression] = STATE(1118),
    [sym_for_expression] = STATE(1118),
    [sym_while_expression] = STATE(1118),
    [sym__if_branch] = STATE(7163),
    [sym_if_expression] = STATE(1118),
    [sym_fun_expression] = STATE(1118),
    [sym_try_expression] = STATE(1118),
    [sym_match_expression] = STATE(1118),
    [sym_function_expression] = STATE(1118),
    [sym_mutate_expression] = STATE(1118),
    [sym_index_expression] = STATE(1118),
    [sym_typed_expression] = STATE(1118),
    [sym_declaration_expression] = STATE(1118),
    [sym_do_expression] = STATE(1118),
    [sym_list_expression] = STATE(1118),
    [sym_array_expression] = STATE(1118),
    [sym_begin_end_expression] = STATE(1118),
    [sym_paren_expression] = STATE(1118),
    [sym__high_prec_app] = STATE(1133),
    [sym__low_prec_app] = STATE(1133),
    [sym_application_expression] = STATE(1118),
    [sym_dot_expression] = STATE(1118),
    [sym_infix_expression] = STATE(1118),
    [sym_ce_expression] = STATE(1118),
    [sym_sequential_expression] = STATE(1118),
    [sym_field_initializer] = STATE(5913),
    [sym_field_initializers] = STATE(6722),
    [sym_char] = STATE(1080),
    [sym_format_string] = STATE(1090),
    [sym__string_literal] = STATE(1090),
    [sym_string] = STATE(1080),
    [sym_verbatim_string] = STATE(1080),
    [sym_bytearray] = STATE(1080),
    [sym_verbatim_bytearray] = STATE(1080),
    [sym_format_triple_quoted_string] = STATE(1096),
    [sym_triple_quoted_string] = STATE(1080),
    [sym_const] = STATE(1118),
    [sym_long_identifier] = STATE(2053),
    [sym_active_pattern] = STATE(1085),
    [sym__identifier_or_op] = STATE(1099),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(517),
    [sym_sbyte] = STATE(1080),
    [sym_byte] = STATE(1080),
    [sym_int16] = STATE(1080),
    [sym_uint16] = STATE(1080),
    [sym_int32] = STATE(1080),
    [sym_uint32] = STATE(1080),
    [sym_nativeint] = STATE(1080),
    [sym_unativeint] = STATE(1080),
    [sym_int64] = STATE(1080),
    [sym_uint64] = STATE(1080),
    [sym_ieee32] = STATE(1080),
    [sym_ieee64] = STATE(1080),
    [sym_bignum] = STATE(1080),
    [sym_decimal] = STATE(1080),
    [sym_float] = STATE(979),
    [sym_block_comment] = STATE(425),
    [sym_compiler_directive_decl] = STATE(425),
    [sym_fsi_directive_decl] = STATE(425),
    [sym_preproc_line] = STATE(425),
    [sym_preproc_if_in_expression] = STATE(1118),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(1773),
    [anon_sym_return] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_null] = ACTIONS(207),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(209),
    [anon_sym_LBRACK_PIPE] = ACTIONS(211),
    [anon_sym_LBRACE] = ACTIONS(1687),
    [anon_sym_LT_AT] = ACTIONS(213),
    [anon_sym_LT_AT_AT] = ACTIONS(1689),
    [anon_sym_LBRACE_PIPE] = ACTIONS(217),
    [anon_sym_new] = ACTIONS(199),
    [anon_sym_return_BANG] = ACTIONS(219),
    [anon_sym_yield] = ACTIONS(199),
    [anon_sym_yield_BANG] = ACTIONS(219),
    [anon_sym_lazy] = ACTIONS(199),
    [anon_sym_assert] = ACTIONS(199),
    [anon_sym_upcast] = ACTIONS(199),
    [anon_sym_downcast] = ACTIONS(199),
    [anon_sym_for] = ACTIONS(223),
    [anon_sym_while] = ACTIONS(225),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(229),
    [anon_sym_match] = ACTIONS(231),
    [anon_sym_match_BANG] = ACTIONS(233),
    [anon_sym_function] = ACTIONS(235),
    [anon_sym_use] = ACTIONS(239),
    [anon_sym_use_BANG] = ACTIONS(241),
    [anon_sym_do_BANG] = ACTIONS(243),
    [anon_sym_begin] = ACTIONS(245),
    [aux_sym_char_token1] = ACTIONS(247),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(251),
    [anon_sym_AT_DQUOTE] = ACTIONS(253),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(255),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(257),
    [sym_bool] = ACTIONS(259),
    [sym_unit] = ACTIONS(1699),
    [anon_sym_LPAREN_PIPE] = ACTIONS(261),
    [sym_op_identifier] = ACTIONS(1701),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(265),
    [sym_xint] = ACTIONS(267),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(269),
  },
  [426] = {
    [sym_function_or_value_defn] = STATE(627),
    [sym__expression] = STATE(307),
    [sym_literal_expression] = STATE(1118),
    [sym_long_identifier_or_op] = STATE(1118),
    [sym_tuple_expression] = STATE(1118),
    [sym_brace_expression] = STATE(1118),
    [sym_anon_record_expression] = STATE(1118),
    [sym_with_field_expression] = STATE(6472),
    [sym_prefixed_expression] = STATE(1118),
    [sym_typecast_expression] = STATE(1118),
    [sym_for_expression] = STATE(1118),
    [sym_while_expression] = STATE(1118),
    [sym__if_branch] = STATE(7163),
    [sym_if_expression] = STATE(1118),
    [sym_fun_expression] = STATE(1118),
    [sym_try_expression] = STATE(1118),
    [sym_match_expression] = STATE(1118),
    [sym_function_expression] = STATE(1118),
    [sym_mutate_expression] = STATE(1118),
    [sym_index_expression] = STATE(1118),
    [sym_typed_expression] = STATE(1118),
    [sym_declaration_expression] = STATE(1118),
    [sym_do_expression] = STATE(1118),
    [sym_list_expression] = STATE(1118),
    [sym_array_expression] = STATE(1118),
    [sym_begin_end_expression] = STATE(1118),
    [sym_paren_expression] = STATE(1118),
    [sym__high_prec_app] = STATE(1133),
    [sym__low_prec_app] = STATE(1133),
    [sym_application_expression] = STATE(1118),
    [sym_dot_expression] = STATE(1118),
    [sym_infix_expression] = STATE(1118),
    [sym_ce_expression] = STATE(1118),
    [sym_sequential_expression] = STATE(1118),
    [sym_field_initializer] = STATE(5913),
    [sym_field_initializers] = STATE(6472),
    [sym_char] = STATE(1080),
    [sym_format_string] = STATE(1090),
    [sym__string_literal] = STATE(1090),
    [sym_string] = STATE(1080),
    [sym_verbatim_string] = STATE(1080),
    [sym_bytearray] = STATE(1080),
    [sym_verbatim_bytearray] = STATE(1080),
    [sym_format_triple_quoted_string] = STATE(1096),
    [sym_triple_quoted_string] = STATE(1080),
    [sym_const] = STATE(1118),
    [sym_long_identifier] = STATE(2053),
    [sym_active_pattern] = STATE(1085),
    [sym__identifier_or_op] = STATE(1099),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(517),
    [sym_sbyte] = STATE(1080),
    [sym_byte] = STATE(1080),
    [sym_int16] = STATE(1080),
    [sym_uint16] = STATE(1080),
    [sym_int32] = STATE(1080),
    [sym_uint32] = STATE(1080),
    [sym_nativeint] = STATE(1080),
    [sym_unativeint] = STATE(1080),
    [sym_int64] = STATE(1080),
    [sym_uint64] = STATE(1080),
    [sym_ieee32] = STATE(1080),
    [sym_ieee64] = STATE(1080),
    [sym_bignum] = STATE(1080),
    [sym_decimal] = STATE(1080),
    [sym_float] = STATE(979),
    [sym_block_comment] = STATE(426),
    [sym_compiler_directive_decl] = STATE(426),
    [sym_fsi_directive_decl] = STATE(426),
    [sym_preproc_line] = STATE(426),
    [sym_preproc_if_in_expression] = STATE(1118),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(1773),
    [anon_sym_return] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_null] = ACTIONS(207),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(209),
    [anon_sym_LBRACK_PIPE] = ACTIONS(211),
    [anon_sym_LBRACE] = ACTIONS(1687),
    [anon_sym_LT_AT] = ACTIONS(213),
    [anon_sym_LT_AT_AT] = ACTIONS(1689),
    [anon_sym_LBRACE_PIPE] = ACTIONS(217),
    [anon_sym_new] = ACTIONS(199),
    [anon_sym_return_BANG] = ACTIONS(219),
    [anon_sym_yield] = ACTIONS(199),
    [anon_sym_yield_BANG] = ACTIONS(219),
    [anon_sym_lazy] = ACTIONS(199),
    [anon_sym_assert] = ACTIONS(199),
    [anon_sym_upcast] = ACTIONS(199),
    [anon_sym_downcast] = ACTIONS(199),
    [anon_sym_for] = ACTIONS(223),
    [anon_sym_while] = ACTIONS(225),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(229),
    [anon_sym_match] = ACTIONS(231),
    [anon_sym_match_BANG] = ACTIONS(233),
    [anon_sym_function] = ACTIONS(235),
    [anon_sym_use] = ACTIONS(239),
    [anon_sym_use_BANG] = ACTIONS(241),
    [anon_sym_do_BANG] = ACTIONS(243),
    [anon_sym_begin] = ACTIONS(245),
    [aux_sym_char_token1] = ACTIONS(247),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(251),
    [anon_sym_AT_DQUOTE] = ACTIONS(253),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(255),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(257),
    [sym_bool] = ACTIONS(259),
    [sym_unit] = ACTIONS(1699),
    [anon_sym_LPAREN_PIPE] = ACTIONS(261),
    [sym_op_identifier] = ACTIONS(1701),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(265),
    [sym_xint] = ACTIONS(267),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(269),
  },
  [427] = {
    [sym_function_or_value_defn] = STATE(627),
    [sym__expression] = STATE(307),
    [sym_literal_expression] = STATE(1118),
    [sym_long_identifier_or_op] = STATE(1118),
    [sym_tuple_expression] = STATE(1118),
    [sym_brace_expression] = STATE(1118),
    [sym_anon_record_expression] = STATE(1118),
    [sym_with_field_expression] = STATE(6626),
    [sym_prefixed_expression] = STATE(1118),
    [sym_typecast_expression] = STATE(1118),
    [sym_for_expression] = STATE(1118),
    [sym_while_expression] = STATE(1118),
    [sym__if_branch] = STATE(7163),
    [sym_if_expression] = STATE(1118),
    [sym_fun_expression] = STATE(1118),
    [sym_try_expression] = STATE(1118),
    [sym_match_expression] = STATE(1118),
    [sym_function_expression] = STATE(1118),
    [sym_mutate_expression] = STATE(1118),
    [sym_index_expression] = STATE(1118),
    [sym_typed_expression] = STATE(1118),
    [sym_declaration_expression] = STATE(1118),
    [sym_do_expression] = STATE(1118),
    [sym_list_expression] = STATE(1118),
    [sym_array_expression] = STATE(1118),
    [sym_begin_end_expression] = STATE(1118),
    [sym_paren_expression] = STATE(1118),
    [sym__high_prec_app] = STATE(1133),
    [sym__low_prec_app] = STATE(1133),
    [sym_application_expression] = STATE(1118),
    [sym_dot_expression] = STATE(1118),
    [sym_infix_expression] = STATE(1118),
    [sym_ce_expression] = STATE(1118),
    [sym_sequential_expression] = STATE(1118),
    [sym_field_initializer] = STATE(5913),
    [sym_field_initializers] = STATE(6626),
    [sym_char] = STATE(1080),
    [sym_format_string] = STATE(1090),
    [sym__string_literal] = STATE(1090),
    [sym_string] = STATE(1080),
    [sym_verbatim_string] = STATE(1080),
    [sym_bytearray] = STATE(1080),
    [sym_verbatim_bytearray] = STATE(1080),
    [sym_format_triple_quoted_string] = STATE(1096),
    [sym_triple_quoted_string] = STATE(1080),
    [sym_const] = STATE(1118),
    [sym_long_identifier] = STATE(2053),
    [sym_active_pattern] = STATE(1085),
    [sym__identifier_or_op] = STATE(1099),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(517),
    [sym_sbyte] = STATE(1080),
    [sym_byte] = STATE(1080),
    [sym_int16] = STATE(1080),
    [sym_uint16] = STATE(1080),
    [sym_int32] = STATE(1080),
    [sym_uint32] = STATE(1080),
    [sym_nativeint] = STATE(1080),
    [sym_unativeint] = STATE(1080),
    [sym_int64] = STATE(1080),
    [sym_uint64] = STATE(1080),
    [sym_ieee32] = STATE(1080),
    [sym_ieee64] = STATE(1080),
    [sym_bignum] = STATE(1080),
    [sym_decimal] = STATE(1080),
    [sym_float] = STATE(979),
    [sym_block_comment] = STATE(427),
    [sym_compiler_directive_decl] = STATE(427),
    [sym_fsi_directive_decl] = STATE(427),
    [sym_preproc_line] = STATE(427),
    [sym_preproc_if_in_expression] = STATE(1118),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(1773),
    [anon_sym_return] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_null] = ACTIONS(207),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(209),
    [anon_sym_LBRACK_PIPE] = ACTIONS(211),
    [anon_sym_LBRACE] = ACTIONS(1687),
    [anon_sym_LT_AT] = ACTIONS(213),
    [anon_sym_LT_AT_AT] = ACTIONS(1689),
    [anon_sym_LBRACE_PIPE] = ACTIONS(217),
    [anon_sym_new] = ACTIONS(199),
    [anon_sym_return_BANG] = ACTIONS(219),
    [anon_sym_yield] = ACTIONS(199),
    [anon_sym_yield_BANG] = ACTIONS(219),
    [anon_sym_lazy] = ACTIONS(199),
    [anon_sym_assert] = ACTIONS(199),
    [anon_sym_upcast] = ACTIONS(199),
    [anon_sym_downcast] = ACTIONS(199),
    [anon_sym_for] = ACTIONS(223),
    [anon_sym_while] = ACTIONS(225),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(229),
    [anon_sym_match] = ACTIONS(231),
    [anon_sym_match_BANG] = ACTIONS(233),
    [anon_sym_function] = ACTIONS(235),
    [anon_sym_use] = ACTIONS(239),
    [anon_sym_use_BANG] = ACTIONS(241),
    [anon_sym_do_BANG] = ACTIONS(243),
    [anon_sym_begin] = ACTIONS(245),
    [aux_sym_char_token1] = ACTIONS(247),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(251),
    [anon_sym_AT_DQUOTE] = ACTIONS(253),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(255),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(257),
    [sym_bool] = ACTIONS(259),
    [sym_unit] = ACTIONS(1699),
    [anon_sym_LPAREN_PIPE] = ACTIONS(261),
    [sym_op_identifier] = ACTIONS(1701),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(265),
    [sym_xint] = ACTIONS(267),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(269),
  },
  [428] = {
    [sym_function_or_value_defn] = STATE(627),
    [sym__expression] = STATE(307),
    [sym_literal_expression] = STATE(1118),
    [sym_long_identifier_or_op] = STATE(1118),
    [sym_tuple_expression] = STATE(1118),
    [sym_brace_expression] = STATE(1118),
    [sym_anon_record_expression] = STATE(1118),
    [sym_with_field_expression] = STATE(6674),
    [sym_prefixed_expression] = STATE(1118),
    [sym_typecast_expression] = STATE(1118),
    [sym_for_expression] = STATE(1118),
    [sym_while_expression] = STATE(1118),
    [sym__if_branch] = STATE(7163),
    [sym_if_expression] = STATE(1118),
    [sym_fun_expression] = STATE(1118),
    [sym_try_expression] = STATE(1118),
    [sym_match_expression] = STATE(1118),
    [sym_function_expression] = STATE(1118),
    [sym_mutate_expression] = STATE(1118),
    [sym_index_expression] = STATE(1118),
    [sym_typed_expression] = STATE(1118),
    [sym_declaration_expression] = STATE(1118),
    [sym_do_expression] = STATE(1118),
    [sym_list_expression] = STATE(1118),
    [sym_array_expression] = STATE(1118),
    [sym_begin_end_expression] = STATE(1118),
    [sym_paren_expression] = STATE(1118),
    [sym__high_prec_app] = STATE(1133),
    [sym__low_prec_app] = STATE(1133),
    [sym_application_expression] = STATE(1118),
    [sym_dot_expression] = STATE(1118),
    [sym_infix_expression] = STATE(1118),
    [sym_ce_expression] = STATE(1118),
    [sym_sequential_expression] = STATE(1118),
    [sym_field_initializer] = STATE(5913),
    [sym_field_initializers] = STATE(6674),
    [sym_char] = STATE(1080),
    [sym_format_string] = STATE(1090),
    [sym__string_literal] = STATE(1090),
    [sym_string] = STATE(1080),
    [sym_verbatim_string] = STATE(1080),
    [sym_bytearray] = STATE(1080),
    [sym_verbatim_bytearray] = STATE(1080),
    [sym_format_triple_quoted_string] = STATE(1096),
    [sym_triple_quoted_string] = STATE(1080),
    [sym_const] = STATE(1118),
    [sym_long_identifier] = STATE(2053),
    [sym_active_pattern] = STATE(1085),
    [sym__identifier_or_op] = STATE(1099),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(517),
    [sym_sbyte] = STATE(1080),
    [sym_byte] = STATE(1080),
    [sym_int16] = STATE(1080),
    [sym_uint16] = STATE(1080),
    [sym_int32] = STATE(1080),
    [sym_uint32] = STATE(1080),
    [sym_nativeint] = STATE(1080),
    [sym_unativeint] = STATE(1080),
    [sym_int64] = STATE(1080),
    [sym_uint64] = STATE(1080),
    [sym_ieee32] = STATE(1080),
    [sym_ieee64] = STATE(1080),
    [sym_bignum] = STATE(1080),
    [sym_decimal] = STATE(1080),
    [sym_float] = STATE(979),
    [sym_block_comment] = STATE(428),
    [sym_compiler_directive_decl] = STATE(428),
    [sym_fsi_directive_decl] = STATE(428),
    [sym_preproc_line] = STATE(428),
    [sym_preproc_if_in_expression] = STATE(1118),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(1773),
    [anon_sym_return] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_null] = ACTIONS(207),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(209),
    [anon_sym_LBRACK_PIPE] = ACTIONS(211),
    [anon_sym_LBRACE] = ACTIONS(1687),
    [anon_sym_LT_AT] = ACTIONS(213),
    [anon_sym_LT_AT_AT] = ACTIONS(1689),
    [anon_sym_LBRACE_PIPE] = ACTIONS(217),
    [anon_sym_new] = ACTIONS(199),
    [anon_sym_return_BANG] = ACTIONS(219),
    [anon_sym_yield] = ACTIONS(199),
    [anon_sym_yield_BANG] = ACTIONS(219),
    [anon_sym_lazy] = ACTIONS(199),
    [anon_sym_assert] = ACTIONS(199),
    [anon_sym_upcast] = ACTIONS(199),
    [anon_sym_downcast] = ACTIONS(199),
    [anon_sym_for] = ACTIONS(223),
    [anon_sym_while] = ACTIONS(225),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(229),
    [anon_sym_match] = ACTIONS(231),
    [anon_sym_match_BANG] = ACTIONS(233),
    [anon_sym_function] = ACTIONS(235),
    [anon_sym_use] = ACTIONS(239),
    [anon_sym_use_BANG] = ACTIONS(241),
    [anon_sym_do_BANG] = ACTIONS(243),
    [anon_sym_begin] = ACTIONS(245),
    [aux_sym_char_token1] = ACTIONS(247),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(251),
    [anon_sym_AT_DQUOTE] = ACTIONS(253),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(255),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(257),
    [sym_bool] = ACTIONS(259),
    [sym_unit] = ACTIONS(1699),
    [anon_sym_LPAREN_PIPE] = ACTIONS(261),
    [sym_op_identifier] = ACTIONS(1701),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(265),
    [sym_xint] = ACTIONS(267),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(269),
  },
  [429] = {
    [sym_function_or_value_defn] = STATE(627),
    [sym__expression] = STATE(307),
    [sym_literal_expression] = STATE(1118),
    [sym_long_identifier_or_op] = STATE(1118),
    [sym_tuple_expression] = STATE(1118),
    [sym_brace_expression] = STATE(1118),
    [sym_anon_record_expression] = STATE(1118),
    [sym_with_field_expression] = STATE(6577),
    [sym_prefixed_expression] = STATE(1118),
    [sym_typecast_expression] = STATE(1118),
    [sym_for_expression] = STATE(1118),
    [sym_while_expression] = STATE(1118),
    [sym__if_branch] = STATE(7163),
    [sym_if_expression] = STATE(1118),
    [sym_fun_expression] = STATE(1118),
    [sym_try_expression] = STATE(1118),
    [sym_match_expression] = STATE(1118),
    [sym_function_expression] = STATE(1118),
    [sym_mutate_expression] = STATE(1118),
    [sym_index_expression] = STATE(1118),
    [sym_typed_expression] = STATE(1118),
    [sym_declaration_expression] = STATE(1118),
    [sym_do_expression] = STATE(1118),
    [sym_list_expression] = STATE(1118),
    [sym_array_expression] = STATE(1118),
    [sym_begin_end_expression] = STATE(1118),
    [sym_paren_expression] = STATE(1118),
    [sym__high_prec_app] = STATE(1133),
    [sym__low_prec_app] = STATE(1133),
    [sym_application_expression] = STATE(1118),
    [sym_dot_expression] = STATE(1118),
    [sym_infix_expression] = STATE(1118),
    [sym_ce_expression] = STATE(1118),
    [sym_sequential_expression] = STATE(1118),
    [sym_field_initializer] = STATE(5913),
    [sym_field_initializers] = STATE(6577),
    [sym_char] = STATE(1080),
    [sym_format_string] = STATE(1090),
    [sym__string_literal] = STATE(1090),
    [sym_string] = STATE(1080),
    [sym_verbatim_string] = STATE(1080),
    [sym_bytearray] = STATE(1080),
    [sym_verbatim_bytearray] = STATE(1080),
    [sym_format_triple_quoted_string] = STATE(1096),
    [sym_triple_quoted_string] = STATE(1080),
    [sym_const] = STATE(1118),
    [sym_long_identifier] = STATE(2053),
    [sym_active_pattern] = STATE(1085),
    [sym__identifier_or_op] = STATE(1099),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(517),
    [sym_sbyte] = STATE(1080),
    [sym_byte] = STATE(1080),
    [sym_int16] = STATE(1080),
    [sym_uint16] = STATE(1080),
    [sym_int32] = STATE(1080),
    [sym_uint32] = STATE(1080),
    [sym_nativeint] = STATE(1080),
    [sym_unativeint] = STATE(1080),
    [sym_int64] = STATE(1080),
    [sym_uint64] = STATE(1080),
    [sym_ieee32] = STATE(1080),
    [sym_ieee64] = STATE(1080),
    [sym_bignum] = STATE(1080),
    [sym_decimal] = STATE(1080),
    [sym_float] = STATE(979),
    [sym_block_comment] = STATE(429),
    [sym_compiler_directive_decl] = STATE(429),
    [sym_fsi_directive_decl] = STATE(429),
    [sym_preproc_line] = STATE(429),
    [sym_preproc_if_in_expression] = STATE(1118),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(1773),
    [anon_sym_return] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_null] = ACTIONS(207),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(209),
    [anon_sym_LBRACK_PIPE] = ACTIONS(211),
    [anon_sym_LBRACE] = ACTIONS(1687),
    [anon_sym_LT_AT] = ACTIONS(213),
    [anon_sym_LT_AT_AT] = ACTIONS(1689),
    [anon_sym_LBRACE_PIPE] = ACTIONS(217),
    [anon_sym_new] = ACTIONS(199),
    [anon_sym_return_BANG] = ACTIONS(219),
    [anon_sym_yield] = ACTIONS(199),
    [anon_sym_yield_BANG] = ACTIONS(219),
    [anon_sym_lazy] = ACTIONS(199),
    [anon_sym_assert] = ACTIONS(199),
    [anon_sym_upcast] = ACTIONS(199),
    [anon_sym_downcast] = ACTIONS(199),
    [anon_sym_for] = ACTIONS(223),
    [anon_sym_while] = ACTIONS(225),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(229),
    [anon_sym_match] = ACTIONS(231),
    [anon_sym_match_BANG] = ACTIONS(233),
    [anon_sym_function] = ACTIONS(235),
    [anon_sym_use] = ACTIONS(239),
    [anon_sym_use_BANG] = ACTIONS(241),
    [anon_sym_do_BANG] = ACTIONS(243),
    [anon_sym_begin] = ACTIONS(245),
    [aux_sym_char_token1] = ACTIONS(247),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(251),
    [anon_sym_AT_DQUOTE] = ACTIONS(253),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(255),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(257),
    [sym_bool] = ACTIONS(259),
    [sym_unit] = ACTIONS(1699),
    [anon_sym_LPAREN_PIPE] = ACTIONS(261),
    [sym_op_identifier] = ACTIONS(1701),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(265),
    [sym_xint] = ACTIONS(267),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(269),
  },
  [430] = {
    [sym_function_or_value_defn] = STATE(627),
    [sym__expression] = STATE(307),
    [sym_literal_expression] = STATE(1118),
    [sym_long_identifier_or_op] = STATE(1118),
    [sym_tuple_expression] = STATE(1118),
    [sym_brace_expression] = STATE(1118),
    [sym_anon_record_expression] = STATE(1118),
    [sym_with_field_expression] = STATE(6527),
    [sym_prefixed_expression] = STATE(1118),
    [sym_typecast_expression] = STATE(1118),
    [sym_for_expression] = STATE(1118),
    [sym_while_expression] = STATE(1118),
    [sym__if_branch] = STATE(7163),
    [sym_if_expression] = STATE(1118),
    [sym_fun_expression] = STATE(1118),
    [sym_try_expression] = STATE(1118),
    [sym_match_expression] = STATE(1118),
    [sym_function_expression] = STATE(1118),
    [sym_mutate_expression] = STATE(1118),
    [sym_index_expression] = STATE(1118),
    [sym_typed_expression] = STATE(1118),
    [sym_declaration_expression] = STATE(1118),
    [sym_do_expression] = STATE(1118),
    [sym_list_expression] = STATE(1118),
    [sym_array_expression] = STATE(1118),
    [sym_begin_end_expression] = STATE(1118),
    [sym_paren_expression] = STATE(1118),
    [sym__high_prec_app] = STATE(1133),
    [sym__low_prec_app] = STATE(1133),
    [sym_application_expression] = STATE(1118),
    [sym_dot_expression] = STATE(1118),
    [sym_infix_expression] = STATE(1118),
    [sym_ce_expression] = STATE(1118),
    [sym_sequential_expression] = STATE(1118),
    [sym_field_initializer] = STATE(5913),
    [sym_field_initializers] = STATE(6527),
    [sym_char] = STATE(1080),
    [sym_format_string] = STATE(1090),
    [sym__string_literal] = STATE(1090),
    [sym_string] = STATE(1080),
    [sym_verbatim_string] = STATE(1080),
    [sym_bytearray] = STATE(1080),
    [sym_verbatim_bytearray] = STATE(1080),
    [sym_format_triple_quoted_string] = STATE(1096),
    [sym_triple_quoted_string] = STATE(1080),
    [sym_const] = STATE(1118),
    [sym_long_identifier] = STATE(2053),
    [sym_active_pattern] = STATE(1085),
    [sym__identifier_or_op] = STATE(1099),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(517),
    [sym_sbyte] = STATE(1080),
    [sym_byte] = STATE(1080),
    [sym_int16] = STATE(1080),
    [sym_uint16] = STATE(1080),
    [sym_int32] = STATE(1080),
    [sym_uint32] = STATE(1080),
    [sym_nativeint] = STATE(1080),
    [sym_unativeint] = STATE(1080),
    [sym_int64] = STATE(1080),
    [sym_uint64] = STATE(1080),
    [sym_ieee32] = STATE(1080),
    [sym_ieee64] = STATE(1080),
    [sym_bignum] = STATE(1080),
    [sym_decimal] = STATE(1080),
    [sym_float] = STATE(979),
    [sym_block_comment] = STATE(430),
    [sym_compiler_directive_decl] = STATE(430),
    [sym_fsi_directive_decl] = STATE(430),
    [sym_preproc_line] = STATE(430),
    [sym_preproc_if_in_expression] = STATE(1118),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(1773),
    [anon_sym_return] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_null] = ACTIONS(207),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(209),
    [anon_sym_LBRACK_PIPE] = ACTIONS(211),
    [anon_sym_LBRACE] = ACTIONS(1687),
    [anon_sym_LT_AT] = ACTIONS(213),
    [anon_sym_LT_AT_AT] = ACTIONS(1689),
    [anon_sym_LBRACE_PIPE] = ACTIONS(217),
    [anon_sym_new] = ACTIONS(199),
    [anon_sym_return_BANG] = ACTIONS(219),
    [anon_sym_yield] = ACTIONS(199),
    [anon_sym_yield_BANG] = ACTIONS(219),
    [anon_sym_lazy] = ACTIONS(199),
    [anon_sym_assert] = ACTIONS(199),
    [anon_sym_upcast] = ACTIONS(199),
    [anon_sym_downcast] = ACTIONS(199),
    [anon_sym_for] = ACTIONS(223),
    [anon_sym_while] = ACTIONS(225),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(229),
    [anon_sym_match] = ACTIONS(231),
    [anon_sym_match_BANG] = ACTIONS(233),
    [anon_sym_function] = ACTIONS(235),
    [anon_sym_use] = ACTIONS(239),
    [anon_sym_use_BANG] = ACTIONS(241),
    [anon_sym_do_BANG] = ACTIONS(243),
    [anon_sym_begin] = ACTIONS(245),
    [aux_sym_char_token1] = ACTIONS(247),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(251),
    [anon_sym_AT_DQUOTE] = ACTIONS(253),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(255),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(257),
    [sym_bool] = ACTIONS(259),
    [sym_unit] = ACTIONS(1699),
    [anon_sym_LPAREN_PIPE] = ACTIONS(261),
    [sym_op_identifier] = ACTIONS(1701),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(265),
    [sym_xint] = ACTIONS(267),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(269),
  },
  [431] = {
    [sym_function_or_value_defn] = STATE(627),
    [sym__expression] = STATE(307),
    [sym_literal_expression] = STATE(1118),
    [sym_long_identifier_or_op] = STATE(1118),
    [sym_tuple_expression] = STATE(1118),
    [sym_brace_expression] = STATE(1118),
    [sym_anon_record_expression] = STATE(1118),
    [sym_with_field_expression] = STATE(6887),
    [sym_prefixed_expression] = STATE(1118),
    [sym_typecast_expression] = STATE(1118),
    [sym_for_expression] = STATE(1118),
    [sym_while_expression] = STATE(1118),
    [sym__if_branch] = STATE(7163),
    [sym_if_expression] = STATE(1118),
    [sym_fun_expression] = STATE(1118),
    [sym_try_expression] = STATE(1118),
    [sym_match_expression] = STATE(1118),
    [sym_function_expression] = STATE(1118),
    [sym_mutate_expression] = STATE(1118),
    [sym_index_expression] = STATE(1118),
    [sym_typed_expression] = STATE(1118),
    [sym_declaration_expression] = STATE(1118),
    [sym_do_expression] = STATE(1118),
    [sym_list_expression] = STATE(1118),
    [sym_array_expression] = STATE(1118),
    [sym_begin_end_expression] = STATE(1118),
    [sym_paren_expression] = STATE(1118),
    [sym__high_prec_app] = STATE(1133),
    [sym__low_prec_app] = STATE(1133),
    [sym_application_expression] = STATE(1118),
    [sym_dot_expression] = STATE(1118),
    [sym_infix_expression] = STATE(1118),
    [sym_ce_expression] = STATE(1118),
    [sym_sequential_expression] = STATE(1118),
    [sym_field_initializer] = STATE(5913),
    [sym_field_initializers] = STATE(6887),
    [sym_char] = STATE(1080),
    [sym_format_string] = STATE(1090),
    [sym__string_literal] = STATE(1090),
    [sym_string] = STATE(1080),
    [sym_verbatim_string] = STATE(1080),
    [sym_bytearray] = STATE(1080),
    [sym_verbatim_bytearray] = STATE(1080),
    [sym_format_triple_quoted_string] = STATE(1096),
    [sym_triple_quoted_string] = STATE(1080),
    [sym_const] = STATE(1118),
    [sym_long_identifier] = STATE(2053),
    [sym_active_pattern] = STATE(1085),
    [sym__identifier_or_op] = STATE(1099),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(517),
    [sym_sbyte] = STATE(1080),
    [sym_byte] = STATE(1080),
    [sym_int16] = STATE(1080),
    [sym_uint16] = STATE(1080),
    [sym_int32] = STATE(1080),
    [sym_uint32] = STATE(1080),
    [sym_nativeint] = STATE(1080),
    [sym_unativeint] = STATE(1080),
    [sym_int64] = STATE(1080),
    [sym_uint64] = STATE(1080),
    [sym_ieee32] = STATE(1080),
    [sym_ieee64] = STATE(1080),
    [sym_bignum] = STATE(1080),
    [sym_decimal] = STATE(1080),
    [sym_float] = STATE(979),
    [sym_block_comment] = STATE(431),
    [sym_compiler_directive_decl] = STATE(431),
    [sym_fsi_directive_decl] = STATE(431),
    [sym_preproc_line] = STATE(431),
    [sym_preproc_if_in_expression] = STATE(1118),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(1773),
    [anon_sym_return] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_null] = ACTIONS(207),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(209),
    [anon_sym_LBRACK_PIPE] = ACTIONS(211),
    [anon_sym_LBRACE] = ACTIONS(1687),
    [anon_sym_LT_AT] = ACTIONS(213),
    [anon_sym_LT_AT_AT] = ACTIONS(1689),
    [anon_sym_LBRACE_PIPE] = ACTIONS(217),
    [anon_sym_new] = ACTIONS(199),
    [anon_sym_return_BANG] = ACTIONS(219),
    [anon_sym_yield] = ACTIONS(199),
    [anon_sym_yield_BANG] = ACTIONS(219),
    [anon_sym_lazy] = ACTIONS(199),
    [anon_sym_assert] = ACTIONS(199),
    [anon_sym_upcast] = ACTIONS(199),
    [anon_sym_downcast] = ACTIONS(199),
    [anon_sym_for] = ACTIONS(223),
    [anon_sym_while] = ACTIONS(225),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(229),
    [anon_sym_match] = ACTIONS(231),
    [anon_sym_match_BANG] = ACTIONS(233),
    [anon_sym_function] = ACTIONS(235),
    [anon_sym_use] = ACTIONS(239),
    [anon_sym_use_BANG] = ACTIONS(241),
    [anon_sym_do_BANG] = ACTIONS(243),
    [anon_sym_begin] = ACTIONS(245),
    [aux_sym_char_token1] = ACTIONS(247),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(251),
    [anon_sym_AT_DQUOTE] = ACTIONS(253),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(255),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(257),
    [sym_bool] = ACTIONS(259),
    [sym_unit] = ACTIONS(1699),
    [anon_sym_LPAREN_PIPE] = ACTIONS(261),
    [sym_op_identifier] = ACTIONS(1701),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(265),
    [sym_xint] = ACTIONS(267),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(269),
  },
  [432] = {
    [sym_function_or_value_defn] = STATE(527),
    [sym__expression] = STATE(289),
    [sym_literal_expression] = STATE(2384),
    [sym_long_identifier_or_op] = STATE(2384),
    [sym_tuple_expression] = STATE(2384),
    [sym_brace_expression] = STATE(2384),
    [sym_anon_record_expression] = STATE(2384),
    [sym_prefixed_expression] = STATE(2384),
    [sym_typecast_expression] = STATE(2384),
    [sym_for_expression] = STATE(2384),
    [sym_while_expression] = STATE(2384),
    [sym__if_branch] = STATE(6561),
    [sym_if_expression] = STATE(2384),
    [sym_fun_expression] = STATE(2384),
    [sym_try_expression] = STATE(2384),
    [sym_match_expression] = STATE(2384),
    [sym_function_expression] = STATE(2384),
    [sym_mutate_expression] = STATE(2384),
    [sym_index_expression] = STATE(2384),
    [sym_typed_expression] = STATE(2384),
    [sym_declaration_expression] = STATE(2384),
    [sym_do_expression] = STATE(2384),
    [sym_list_expression] = STATE(2384),
    [sym_array_expression] = STATE(2384),
    [sym_begin_end_expression] = STATE(2384),
    [sym_paren_expression] = STATE(2384),
    [sym__high_prec_app] = STATE(2249),
    [sym__low_prec_app] = STATE(2249),
    [sym_application_expression] = STATE(2384),
    [sym_dot_expression] = STATE(2384),
    [sym_infix_expression] = STATE(2384),
    [sym_ce_expression] = STATE(2384),
    [sym_sequential_expression] = STATE(2384),
    [sym_char] = STATE(2144),
    [sym_format_string] = STATE(2142),
    [sym__string_literal] = STATE(2142),
    [sym_string] = STATE(2144),
    [sym_verbatim_string] = STATE(2144),
    [sym_bytearray] = STATE(2144),
    [sym_verbatim_bytearray] = STATE(2144),
    [sym_format_triple_quoted_string] = STATE(2141),
    [sym_triple_quoted_string] = STATE(2144),
    [sym_const] = STATE(2384),
    [sym_long_identifier] = STATE(2400),
    [sym_active_pattern] = STATE(2317),
    [sym__identifier_or_op] = STATE(2392),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(633),
    [sym_sbyte] = STATE(2144),
    [sym_byte] = STATE(2144),
    [sym_int16] = STATE(2144),
    [sym_uint16] = STATE(2144),
    [sym_int32] = STATE(2144),
    [sym_uint32] = STATE(2144),
    [sym_nativeint] = STATE(2144),
    [sym_unativeint] = STATE(2144),
    [sym_int64] = STATE(2144),
    [sym_uint64] = STATE(2144),
    [sym_ieee32] = STATE(2144),
    [sym_ieee64] = STATE(2144),
    [sym_bignum] = STATE(2144),
    [sym_decimal] = STATE(2144),
    [sym_float] = STATE(1672),
    [sym_block_comment] = STATE(432),
    [sym_compiler_directive_decl] = STATE(432),
    [sym_fsi_directive_decl] = STATE(432),
    [sym_preproc_line] = STATE(432),
    [sym_preproc_if_in_expression] = STATE(2384),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(1439),
    [anon_sym_return] = ACTIONS(1443),
    [anon_sym_do] = ACTIONS(1445),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(1447),
    [anon_sym_COMMA] = ACTIONS(2034),
    [anon_sym_null] = ACTIONS(1451),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1453),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1455),
    [anon_sym_LBRACE] = ACTIONS(2036),
    [anon_sym_LT_AT] = ACTIONS(1459),
    [anon_sym_LT_AT_AT] = ACTIONS(2038),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1465),
    [anon_sym_new] = ACTIONS(1443),
    [anon_sym_return_BANG] = ACTIONS(1467),
    [anon_sym_yield] = ACTIONS(1443),
    [anon_sym_yield_BANG] = ACTIONS(1467),
    [anon_sym_lazy] = ACTIONS(1443),
    [anon_sym_assert] = ACTIONS(1443),
    [anon_sym_upcast] = ACTIONS(1443),
    [anon_sym_downcast] = ACTIONS(1443),
    [anon_sym_for] = ACTIONS(1471),
    [anon_sym_while] = ACTIONS(1473),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(1475),
    [anon_sym_try] = ACTIONS(1477),
    [anon_sym_match] = ACTIONS(1479),
    [anon_sym_match_BANG] = ACTIONS(1481),
    [anon_sym_function] = ACTIONS(1483),
    [anon_sym_GT] = ACTIONS(2034),
    [anon_sym_use] = ACTIONS(1491),
    [anon_sym_use_BANG] = ACTIONS(1493),
    [anon_sym_do_BANG] = ACTIONS(1495),
    [anon_sym_begin] = ACTIONS(1497),
    [aux_sym_char_token1] = ACTIONS(1501),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1503),
    [anon_sym_DQUOTE] = ACTIONS(1505),
    [anon_sym_AT_DQUOTE] = ACTIONS(1507),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1509),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1511),
    [sym_bool] = ACTIONS(1513),
    [sym_unit] = ACTIONS(2040),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1517),
    [sym_op_identifier] = ACTIONS(2042),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(1521),
    [sym_xint] = ACTIONS(1523),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1525),
  },
  [433] = {
    [sym_function_or_value_defn] = STATE(627),
    [sym__expression] = STATE(133),
    [sym_literal_expression] = STATE(1118),
    [sym_long_identifier_or_op] = STATE(1118),
    [sym_tuple_expression] = STATE(1118),
    [sym_brace_expression] = STATE(1118),
    [sym_anon_record_expression] = STATE(1118),
    [sym_prefixed_expression] = STATE(1118),
    [sym_typecast_expression] = STATE(1118),
    [sym_for_expression] = STATE(1118),
    [sym_while_expression] = STATE(1118),
    [sym__if_branch] = STATE(7163),
    [sym_if_expression] = STATE(1118),
    [sym_fun_expression] = STATE(1118),
    [sym_try_expression] = STATE(1118),
    [sym_match_expression] = STATE(1118),
    [sym_function_expression] = STATE(1118),
    [sym_mutate_expression] = STATE(1118),
    [sym_index_expression] = STATE(1118),
    [sym_typed_expression] = STATE(1118),
    [sym_declaration_expression] = STATE(1118),
    [sym_do_expression] = STATE(1118),
    [sym_list_expression] = STATE(1118),
    [sym_array_expression] = STATE(1118),
    [sym_begin_end_expression] = STATE(1118),
    [sym_paren_expression] = STATE(1118),
    [sym__high_prec_app] = STATE(1133),
    [sym__low_prec_app] = STATE(1133),
    [sym_application_expression] = STATE(1118),
    [sym_dot_expression] = STATE(1118),
    [sym_infix_expression] = STATE(1118),
    [sym_ce_expression] = STATE(1118),
    [sym_sequential_expression] = STATE(1118),
    [sym_char] = STATE(1080),
    [sym_format_string] = STATE(1090),
    [sym__string_literal] = STATE(1090),
    [sym_string] = STATE(1080),
    [sym_verbatim_string] = STATE(1080),
    [sym_bytearray] = STATE(1080),
    [sym_verbatim_bytearray] = STATE(1080),
    [sym_format_triple_quoted_string] = STATE(1096),
    [sym_triple_quoted_string] = STATE(1080),
    [sym_const] = STATE(1118),
    [sym_long_identifier] = STATE(1156),
    [sym_active_pattern] = STATE(1085),
    [sym__identifier_or_op] = STATE(1099),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(517),
    [sym_sbyte] = STATE(1080),
    [sym_byte] = STATE(1080),
    [sym_int16] = STATE(1080),
    [sym_uint16] = STATE(1080),
    [sym_int32] = STATE(1080),
    [sym_uint32] = STATE(1080),
    [sym_nativeint] = STATE(1080),
    [sym_unativeint] = STATE(1080),
    [sym_int64] = STATE(1080),
    [sym_uint64] = STATE(1080),
    [sym_ieee32] = STATE(1080),
    [sym_ieee64] = STATE(1080),
    [sym_bignum] = STATE(1080),
    [sym_decimal] = STATE(1080),
    [sym_float] = STATE(979),
    [sym_block_comment] = STATE(433),
    [sym_compiler_directive_decl] = STATE(433),
    [sym_fsi_directive_decl] = STATE(433),
    [sym_preproc_line] = STATE(433),
    [sym_preproc_if_in_expression] = STATE(1118),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(195),
    [anon_sym_return] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_COMMA] = ACTIONS(2044),
    [anon_sym_null] = ACTIONS(207),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(209),
    [anon_sym_RBRACK] = ACTIONS(2044),
    [anon_sym_LBRACK_PIPE] = ACTIONS(211),
    [anon_sym_LBRACE] = ACTIONS(1687),
    [anon_sym_LT_AT] = ACTIONS(213),
    [anon_sym_LT_AT_AT] = ACTIONS(1689),
    [anon_sym_LBRACE_PIPE] = ACTIONS(217),
    [anon_sym_new] = ACTIONS(199),
    [anon_sym_return_BANG] = ACTIONS(219),
    [anon_sym_yield] = ACTIONS(199),
    [anon_sym_yield_BANG] = ACTIONS(219),
    [anon_sym_lazy] = ACTIONS(199),
    [anon_sym_assert] = ACTIONS(199),
    [anon_sym_upcast] = ACTIONS(199),
    [anon_sym_downcast] = ACTIONS(199),
    [anon_sym_for] = ACTIONS(223),
    [anon_sym_while] = ACTIONS(225),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(229),
    [anon_sym_match] = ACTIONS(231),
    [anon_sym_match_BANG] = ACTIONS(233),
    [anon_sym_function] = ACTIONS(235),
    [anon_sym_use] = ACTIONS(239),
    [anon_sym_use_BANG] = ACTIONS(241),
    [anon_sym_do_BANG] = ACTIONS(243),
    [anon_sym_begin] = ACTIONS(245),
    [aux_sym_char_token1] = ACTIONS(247),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(251),
    [anon_sym_AT_DQUOTE] = ACTIONS(253),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(255),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(257),
    [sym_bool] = ACTIONS(259),
    [sym_unit] = ACTIONS(1699),
    [anon_sym_LPAREN_PIPE] = ACTIONS(261),
    [sym_op_identifier] = ACTIONS(1701),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(265),
    [sym_xint] = ACTIONS(267),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(269),
  },
  [434] = {
    [sym_function_or_value_defn] = STATE(600),
    [sym__expression] = STATE(253),
    [sym_literal_expression] = STATE(867),
    [sym_long_identifier_or_op] = STATE(867),
    [sym_tuple_expression] = STATE(867),
    [sym_brace_expression] = STATE(867),
    [sym_anon_record_expression] = STATE(867),
    [sym_prefixed_expression] = STATE(867),
    [sym_typecast_expression] = STATE(867),
    [sym_for_expression] = STATE(867),
    [sym_while_expression] = STATE(867),
    [sym__if_branch] = STATE(6511),
    [sym_if_expression] = STATE(867),
    [sym_fun_expression] = STATE(867),
    [sym_try_expression] = STATE(867),
    [sym_match_expression] = STATE(867),
    [sym_function_expression] = STATE(867),
    [sym_mutate_expression] = STATE(867),
    [sym_index_expression] = STATE(867),
    [sym_typed_expression] = STATE(867),
    [sym_declaration_expression] = STATE(867),
    [sym_do_expression] = STATE(867),
    [sym_list_expression] = STATE(867),
    [sym_array_expression] = STATE(867),
    [sym_begin_end_expression] = STATE(867),
    [sym_paren_expression] = STATE(867),
    [sym__high_prec_app] = STATE(864),
    [sym__low_prec_app] = STATE(864),
    [sym_application_expression] = STATE(867),
    [sym_dot_expression] = STATE(867),
    [sym_infix_expression] = STATE(867),
    [sym_ce_expression] = STATE(867),
    [sym_sequential_expression] = STATE(867),
    [sym_char] = STATE(868),
    [sym_format_string] = STATE(869),
    [sym__string_literal] = STATE(869),
    [sym_string] = STATE(868),
    [sym_verbatim_string] = STATE(868),
    [sym_bytearray] = STATE(868),
    [sym_verbatim_bytearray] = STATE(868),
    [sym_format_triple_quoted_string] = STATE(870),
    [sym_triple_quoted_string] = STATE(868),
    [sym_const] = STATE(867),
    [sym_long_identifier] = STATE(872),
    [sym_active_pattern] = STATE(871),
    [sym__identifier_or_op] = STATE(873),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(656),
    [sym_sbyte] = STATE(868),
    [sym_byte] = STATE(868),
    [sym_int16] = STATE(868),
    [sym_uint16] = STATE(868),
    [sym_int32] = STATE(868),
    [sym_uint32] = STATE(868),
    [sym_nativeint] = STATE(868),
    [sym_unativeint] = STATE(868),
    [sym_int64] = STATE(868),
    [sym_uint64] = STATE(868),
    [sym_ieee32] = STATE(868),
    [sym_ieee64] = STATE(868),
    [sym_bignum] = STATE(868),
    [sym_decimal] = STATE(868),
    [sym_float] = STATE(1368),
    [sym_block_comment] = STATE(434),
    [sym_compiler_directive_decl] = STATE(434),
    [sym_fsi_directive_decl] = STATE(434),
    [sym_preproc_line] = STATE(434),
    [sym_preproc_if_in_expression] = STATE(867),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(29),
    [anon_sym_return] = ACTIONS(825),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_COMMA] = ACTIONS(2044),
    [anon_sym_null] = ACTIONS(49),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACK_PIPE] = ACTIONS(57),
    [anon_sym_LBRACE] = ACTIONS(1663),
    [anon_sym_LT_AT] = ACTIONS(61),
    [anon_sym_LT_AT_AT] = ACTIONS(1665),
    [anon_sym_LBRACE_PIPE] = ACTIONS(67),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_return_BANG] = ACTIONS(829),
    [anon_sym_yield] = ACTIONS(825),
    [anon_sym_yield_BANG] = ACTIONS(829),
    [anon_sym_lazy] = ACTIONS(825),
    [anon_sym_assert] = ACTIONS(825),
    [anon_sym_upcast] = ACTIONS(825),
    [anon_sym_downcast] = ACTIONS(825),
    [anon_sym_for] = ACTIONS(73),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(79),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_match] = ACTIONS(83),
    [anon_sym_match_BANG] = ACTIONS(85),
    [anon_sym_function] = ACTIONS(87),
    [anon_sym_use] = ACTIONS(833),
    [anon_sym_use_BANG] = ACTIONS(835),
    [anon_sym_do_BANG] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(101),
    [aux_sym_char_token1] = ACTIONS(105),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(107),
    [anon_sym_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DQUOTE] = ACTIONS(111),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(115),
    [sym_bool] = ACTIONS(117),
    [sym_unit] = ACTIONS(1673),
    [anon_sym_LPAREN_PIPE] = ACTIONS(121),
    [sym_op_identifier] = ACTIONS(1675),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(837),
    [sym_xint] = ACTIONS(387),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(135),
    [sym__dedent] = ACTIONS(2044),
  },
  [435] = {
    [sym_function_or_value_defn] = STATE(627),
    [sym__expression] = STATE(21),
    [sym_literal_expression] = STATE(1118),
    [sym_long_identifier_or_op] = STATE(1118),
    [sym_tuple_expression] = STATE(1118),
    [sym_brace_expression] = STATE(1118),
    [sym_anon_record_expression] = STATE(1118),
    [sym_prefixed_expression] = STATE(1118),
    [sym_typecast_expression] = STATE(1118),
    [sym_for_expression] = STATE(1118),
    [sym_while_expression] = STATE(1118),
    [sym__if_branch] = STATE(7163),
    [sym_if_expression] = STATE(1118),
    [sym_fun_expression] = STATE(1118),
    [sym_try_expression] = STATE(1118),
    [sym_match_expression] = STATE(1118),
    [sym_function_expression] = STATE(1118),
    [sym_mutate_expression] = STATE(1118),
    [sym_index_expression] = STATE(1118),
    [sym_typed_expression] = STATE(1118),
    [sym_declaration_expression] = STATE(1118),
    [sym_do_expression] = STATE(1118),
    [sym_list_expression] = STATE(1118),
    [sym_array_expression] = STATE(1118),
    [sym_begin_end_expression] = STATE(1118),
    [sym_paren_expression] = STATE(1118),
    [sym__high_prec_app] = STATE(1133),
    [sym__low_prec_app] = STATE(1133),
    [sym_application_expression] = STATE(1118),
    [sym_dot_expression] = STATE(1118),
    [sym_infix_expression] = STATE(1118),
    [sym_ce_expression] = STATE(1118),
    [sym_sequential_expression] = STATE(1118),
    [sym_char] = STATE(1080),
    [sym_format_string] = STATE(1090),
    [sym__string_literal] = STATE(1090),
    [sym_string] = STATE(1080),
    [sym_verbatim_string] = STATE(1080),
    [sym_bytearray] = STATE(1080),
    [sym_verbatim_bytearray] = STATE(1080),
    [sym_format_triple_quoted_string] = STATE(1096),
    [sym_triple_quoted_string] = STATE(1080),
    [sym_const] = STATE(1118),
    [sym_long_identifier] = STATE(1156),
    [sym_active_pattern] = STATE(1085),
    [sym__identifier_or_op] = STATE(1099),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(517),
    [sym_sbyte] = STATE(1080),
    [sym_byte] = STATE(1080),
    [sym_int16] = STATE(1080),
    [sym_uint16] = STATE(1080),
    [sym_int32] = STATE(1080),
    [sym_uint32] = STATE(1080),
    [sym_nativeint] = STATE(1080),
    [sym_unativeint] = STATE(1080),
    [sym_int64] = STATE(1080),
    [sym_uint64] = STATE(1080),
    [sym_ieee32] = STATE(1080),
    [sym_ieee64] = STATE(1080),
    [sym_bignum] = STATE(1080),
    [sym_decimal] = STATE(1080),
    [sym_float] = STATE(979),
    [sym_block_comment] = STATE(435),
    [sym_compiler_directive_decl] = STATE(435),
    [sym_fsi_directive_decl] = STATE(435),
    [sym_preproc_line] = STATE(435),
    [sym_preproc_if_in_expression] = STATE(1118),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(195),
    [anon_sym_return] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_null] = ACTIONS(207),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(209),
    [anon_sym_LBRACK_PIPE] = ACTIONS(211),
    [anon_sym_LBRACE] = ACTIONS(1687),
    [anon_sym_LT_AT] = ACTIONS(213),
    [anon_sym_LT_AT_AT] = ACTIONS(1689),
    [anon_sym_LBRACE_PIPE] = ACTIONS(217),
    [anon_sym_new] = ACTIONS(199),
    [anon_sym_with] = ACTIONS(2046),
    [anon_sym_return_BANG] = ACTIONS(219),
    [anon_sym_yield] = ACTIONS(199),
    [anon_sym_yield_BANG] = ACTIONS(219),
    [anon_sym_lazy] = ACTIONS(199),
    [anon_sym_assert] = ACTIONS(199),
    [anon_sym_upcast] = ACTIONS(199),
    [anon_sym_downcast] = ACTIONS(199),
    [anon_sym_for] = ACTIONS(223),
    [anon_sym_while] = ACTIONS(225),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(229),
    [anon_sym_match] = ACTIONS(231),
    [anon_sym_match_BANG] = ACTIONS(233),
    [anon_sym_function] = ACTIONS(235),
    [anon_sym_use] = ACTIONS(239),
    [anon_sym_use_BANG] = ACTIONS(241),
    [anon_sym_do_BANG] = ACTIONS(243),
    [anon_sym_begin] = ACTIONS(245),
    [aux_sym_char_token1] = ACTIONS(247),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(251),
    [anon_sym_AT_DQUOTE] = ACTIONS(253),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(255),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(257),
    [sym_bool] = ACTIONS(259),
    [sym_unit] = ACTIONS(1699),
    [anon_sym_LPAREN_PIPE] = ACTIONS(261),
    [sym_op_identifier] = ACTIONS(1701),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(265),
    [sym_xint] = ACTIONS(267),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(269),
  },
  [436] = {
    [sym_function_or_value_defn] = STATE(509),
    [sym__expression] = STATE(292),
    [sym_literal_expression] = STATE(2230),
    [sym_long_identifier_or_op] = STATE(2230),
    [sym_tuple_expression] = STATE(2230),
    [sym_brace_expression] = STATE(2230),
    [sym_anon_record_expression] = STATE(2230),
    [sym_prefixed_expression] = STATE(2230),
    [sym_typecast_expression] = STATE(2230),
    [sym_for_expression] = STATE(2230),
    [sym_while_expression] = STATE(2230),
    [sym__if_branch] = STATE(6659),
    [sym_if_expression] = STATE(2230),
    [sym_fun_expression] = STATE(2230),
    [sym_try_expression] = STATE(2230),
    [sym_match_expression] = STATE(2230),
    [sym_function_expression] = STATE(2230),
    [sym_mutate_expression] = STATE(2230),
    [sym_index_expression] = STATE(2230),
    [sym_typed_expression] = STATE(2230),
    [sym_declaration_expression] = STATE(2230),
    [sym_do_expression] = STATE(2230),
    [sym_list_expression] = STATE(2230),
    [sym_array_expression] = STATE(2230),
    [sym_range_expression] = STATE(6536),
    [sym_begin_end_expression] = STATE(2230),
    [sym_paren_expression] = STATE(2230),
    [sym__high_prec_app] = STATE(2229),
    [sym__low_prec_app] = STATE(2229),
    [sym_application_expression] = STATE(2230),
    [sym_dot_expression] = STATE(2230),
    [sym_infix_expression] = STATE(2230),
    [sym_ce_expression] = STATE(2230),
    [sym_sequential_expression] = STATE(2230),
    [sym_char] = STATE(2100),
    [sym_format_string] = STATE(2106),
    [sym__string_literal] = STATE(2106),
    [sym_string] = STATE(2100),
    [sym_verbatim_string] = STATE(2100),
    [sym_bytearray] = STATE(2100),
    [sym_verbatim_bytearray] = STATE(2100),
    [sym_format_triple_quoted_string] = STATE(2107),
    [sym_triple_quoted_string] = STATE(2100),
    [sym_const] = STATE(2230),
    [sym_long_identifier] = STATE(2232),
    [sym_active_pattern] = STATE(2424),
    [sym__identifier_or_op] = STATE(2305),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(737),
    [sym_sbyte] = STATE(2100),
    [sym_byte] = STATE(2100),
    [sym_int16] = STATE(2100),
    [sym_uint16] = STATE(2100),
    [sym_int32] = STATE(2100),
    [sym_uint32] = STATE(2100),
    [sym_nativeint] = STATE(2100),
    [sym_unativeint] = STATE(2100),
    [sym_int64] = STATE(2100),
    [sym_uint64] = STATE(2100),
    [sym_ieee32] = STATE(2100),
    [sym_ieee64] = STATE(2100),
    [sym_bignum] = STATE(2100),
    [sym_decimal] = STATE(2100),
    [sym_float] = STATE(1487),
    [sym_block_comment] = STATE(436),
    [sym_compiler_directive_decl] = STATE(436),
    [sym_fsi_directive_decl] = STATE(436),
    [sym_preproc_line] = STATE(436),
    [sym_preproc_if_in_expression] = STATE(2230),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(877),
    [anon_sym_return] = ACTIONS(881),
    [anon_sym_do] = ACTIONS(1585),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(885),
    [anon_sym_null] = ACTIONS(889),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(891),
    [anon_sym_LBRACK_PIPE] = ACTIONS(893),
    [anon_sym_LBRACE] = ACTIONS(2048),
    [anon_sym_LT_AT] = ACTIONS(897),
    [anon_sym_LT_AT_AT] = ACTIONS(2050),
    [anon_sym_LBRACE_PIPE] = ACTIONS(903),
    [anon_sym_new] = ACTIONS(881),
    [anon_sym_return_BANG] = ACTIONS(905),
    [anon_sym_yield] = ACTIONS(881),
    [anon_sym_yield_BANG] = ACTIONS(905),
    [anon_sym_lazy] = ACTIONS(881),
    [anon_sym_assert] = ACTIONS(881),
    [anon_sym_upcast] = ACTIONS(881),
    [anon_sym_downcast] = ACTIONS(881),
    [anon_sym_for] = ACTIONS(909),
    [anon_sym_while] = ACTIONS(911),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(913),
    [anon_sym_try] = ACTIONS(915),
    [anon_sym_match] = ACTIONS(917),
    [anon_sym_match_BANG] = ACTIONS(919),
    [anon_sym_function] = ACTIONS(921),
    [anon_sym_use] = ACTIONS(929),
    [anon_sym_use_BANG] = ACTIONS(931),
    [anon_sym_do_BANG] = ACTIONS(933),
    [anon_sym_begin] = ACTIONS(937),
    [aux_sym_char_token1] = ACTIONS(941),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(943),
    [anon_sym_DQUOTE] = ACTIONS(945),
    [anon_sym_AT_DQUOTE] = ACTIONS(947),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(949),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(951),
    [sym_bool] = ACTIONS(953),
    [sym_unit] = ACTIONS(2052),
    [anon_sym_LPAREN_PIPE] = ACTIONS(957),
    [sym_op_identifier] = ACTIONS(2054),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(961),
    [sym_xint] = ACTIONS(963),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(965),
  },
  [437] = {
    [sym_function_or_value_defn] = STATE(729),
    [sym__expression] = STATE(53),
    [sym_literal_expression] = STATE(867),
    [sym_long_identifier_or_op] = STATE(867),
    [sym_tuple_expression] = STATE(867),
    [sym_brace_expression] = STATE(867),
    [sym_anon_record_expression] = STATE(867),
    [sym_prefixed_expression] = STATE(867),
    [sym_typecast_expression] = STATE(867),
    [sym_for_expression] = STATE(867),
    [sym_while_expression] = STATE(867),
    [sym__if_branch] = STATE(6511),
    [sym_if_expression] = STATE(867),
    [sym_fun_expression] = STATE(867),
    [sym_try_expression] = STATE(867),
    [sym_match_expression] = STATE(867),
    [sym_function_expression] = STATE(867),
    [sym_mutate_expression] = STATE(867),
    [sym_index_expression] = STATE(867),
    [sym_typed_expression] = STATE(867),
    [sym_declaration_expression] = STATE(867),
    [sym_do_expression] = STATE(867),
    [sym_list_expression] = STATE(867),
    [sym_array_expression] = STATE(867),
    [sym_begin_end_expression] = STATE(867),
    [sym_paren_expression] = STATE(867),
    [sym__high_prec_app] = STATE(864),
    [sym__low_prec_app] = STATE(864),
    [sym_application_expression] = STATE(867),
    [sym_dot_expression] = STATE(867),
    [sym_infix_expression] = STATE(867),
    [sym_ce_expression] = STATE(867),
    [sym_sequential_expression] = STATE(867),
    [sym_char] = STATE(868),
    [sym_format_string] = STATE(869),
    [sym__string_literal] = STATE(869),
    [sym_string] = STATE(868),
    [sym_verbatim_string] = STATE(868),
    [sym_bytearray] = STATE(868),
    [sym_verbatim_bytearray] = STATE(868),
    [sym_format_triple_quoted_string] = STATE(870),
    [sym_triple_quoted_string] = STATE(868),
    [sym_const] = STATE(867),
    [sym_long_identifier] = STATE(872),
    [sym_active_pattern] = STATE(871),
    [sym__identifier_or_op] = STATE(873),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(499),
    [sym_sbyte] = STATE(868),
    [sym_byte] = STATE(868),
    [sym_int16] = STATE(868),
    [sym_uint16] = STATE(868),
    [sym_int32] = STATE(868),
    [sym_uint32] = STATE(868),
    [sym_nativeint] = STATE(868),
    [sym_unativeint] = STATE(868),
    [sym_int64] = STATE(868),
    [sym_uint64] = STATE(868),
    [sym_ieee32] = STATE(868),
    [sym_ieee64] = STATE(868),
    [sym_bignum] = STATE(868),
    [sym_decimal] = STATE(868),
    [sym_float] = STATE(1368),
    [sym_block_comment] = STATE(437),
    [sym_compiler_directive_decl] = STATE(437),
    [sym_fsi_directive_decl] = STATE(437),
    [sym_preproc_line] = STATE(437),
    [sym_preproc_if_in_expression] = STATE(867),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(29),
    [anon_sym_return] = ACTIONS(369),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_null] = ACTIONS(49),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACK_PIPE] = ACTIONS(57),
    [anon_sym_LBRACE] = ACTIONS(1663),
    [anon_sym_LT_AT] = ACTIONS(61),
    [anon_sym_LT_AT_AT] = ACTIONS(1665),
    [anon_sym_LBRACE_PIPE] = ACTIONS(67),
    [anon_sym_new] = ACTIONS(369),
    [anon_sym_return_BANG] = ACTIONS(373),
    [anon_sym_yield] = ACTIONS(369),
    [anon_sym_yield_BANG] = ACTIONS(373),
    [anon_sym_lazy] = ACTIONS(369),
    [anon_sym_assert] = ACTIONS(369),
    [anon_sym_upcast] = ACTIONS(369),
    [anon_sym_downcast] = ACTIONS(369),
    [anon_sym_for] = ACTIONS(375),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(79),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_match] = ACTIONS(83),
    [anon_sym_match_BANG] = ACTIONS(85),
    [anon_sym_function] = ACTIONS(87),
    [anon_sym_use] = ACTIONS(379),
    [anon_sym_use_BANG] = ACTIONS(381),
    [anon_sym_do_BANG] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(101),
    [aux_sym_char_token1] = ACTIONS(105),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(107),
    [anon_sym_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DQUOTE] = ACTIONS(111),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(115),
    [sym_bool] = ACTIONS(117),
    [sym_unit] = ACTIONS(1673),
    [anon_sym_LPAREN_PIPE] = ACTIONS(121),
    [sym_op_identifier] = ACTIONS(1675),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(385),
    [sym_xint] = ACTIONS(387),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(135),
    [sym__tuple_marker] = ACTIONS(2056),
  },
  [438] = {
    [sym_function_or_value_defn] = STATE(509),
    [sym__expression] = STATE(288),
    [sym_literal_expression] = STATE(2230),
    [sym_long_identifier_or_op] = STATE(2230),
    [sym_tuple_expression] = STATE(2230),
    [sym_brace_expression] = STATE(2230),
    [sym_anon_record_expression] = STATE(2230),
    [sym_prefixed_expression] = STATE(2230),
    [sym_typecast_expression] = STATE(2230),
    [sym_for_expression] = STATE(2230),
    [sym_while_expression] = STATE(2230),
    [sym__if_branch] = STATE(6659),
    [sym_if_expression] = STATE(2230),
    [sym_fun_expression] = STATE(2230),
    [sym_try_expression] = STATE(2230),
    [sym_match_expression] = STATE(2230),
    [sym_function_expression] = STATE(2230),
    [sym_mutate_expression] = STATE(2230),
    [sym_index_expression] = STATE(2230),
    [sym_typed_expression] = STATE(2230),
    [sym_declaration_expression] = STATE(2230),
    [sym_do_expression] = STATE(2230),
    [sym_list_expression] = STATE(2230),
    [sym_array_expression] = STATE(2230),
    [sym_range_expression] = STATE(6895),
    [sym_begin_end_expression] = STATE(2230),
    [sym_paren_expression] = STATE(2230),
    [sym__high_prec_app] = STATE(2229),
    [sym__low_prec_app] = STATE(2229),
    [sym_application_expression] = STATE(2230),
    [sym_dot_expression] = STATE(2230),
    [sym_infix_expression] = STATE(2230),
    [sym_ce_expression] = STATE(2230),
    [sym_sequential_expression] = STATE(2230),
    [sym_char] = STATE(2100),
    [sym_format_string] = STATE(2106),
    [sym__string_literal] = STATE(2106),
    [sym_string] = STATE(2100),
    [sym_verbatim_string] = STATE(2100),
    [sym_bytearray] = STATE(2100),
    [sym_verbatim_bytearray] = STATE(2100),
    [sym_format_triple_quoted_string] = STATE(2107),
    [sym_triple_quoted_string] = STATE(2100),
    [sym_const] = STATE(2230),
    [sym_long_identifier] = STATE(2232),
    [sym_active_pattern] = STATE(2424),
    [sym__identifier_or_op] = STATE(2305),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(737),
    [sym_sbyte] = STATE(2100),
    [sym_byte] = STATE(2100),
    [sym_int16] = STATE(2100),
    [sym_uint16] = STATE(2100),
    [sym_int32] = STATE(2100),
    [sym_uint32] = STATE(2100),
    [sym_nativeint] = STATE(2100),
    [sym_unativeint] = STATE(2100),
    [sym_int64] = STATE(2100),
    [sym_uint64] = STATE(2100),
    [sym_ieee32] = STATE(2100),
    [sym_ieee64] = STATE(2100),
    [sym_bignum] = STATE(2100),
    [sym_decimal] = STATE(2100),
    [sym_float] = STATE(1487),
    [sym_block_comment] = STATE(438),
    [sym_compiler_directive_decl] = STATE(438),
    [sym_fsi_directive_decl] = STATE(438),
    [sym_preproc_line] = STATE(438),
    [sym_preproc_if_in_expression] = STATE(2230),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(877),
    [anon_sym_return] = ACTIONS(881),
    [anon_sym_do] = ACTIONS(1585),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(885),
    [anon_sym_null] = ACTIONS(889),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(891),
    [anon_sym_LBRACK_PIPE] = ACTIONS(893),
    [anon_sym_LBRACE] = ACTIONS(2048),
    [anon_sym_LT_AT] = ACTIONS(897),
    [anon_sym_LT_AT_AT] = ACTIONS(2050),
    [anon_sym_LBRACE_PIPE] = ACTIONS(903),
    [anon_sym_new] = ACTIONS(881),
    [anon_sym_return_BANG] = ACTIONS(905),
    [anon_sym_yield] = ACTIONS(881),
    [anon_sym_yield_BANG] = ACTIONS(905),
    [anon_sym_lazy] = ACTIONS(881),
    [anon_sym_assert] = ACTIONS(881),
    [anon_sym_upcast] = ACTIONS(881),
    [anon_sym_downcast] = ACTIONS(881),
    [anon_sym_for] = ACTIONS(909),
    [anon_sym_while] = ACTIONS(911),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(913),
    [anon_sym_try] = ACTIONS(915),
    [anon_sym_match] = ACTIONS(917),
    [anon_sym_match_BANG] = ACTIONS(919),
    [anon_sym_function] = ACTIONS(921),
    [anon_sym_use] = ACTIONS(929),
    [anon_sym_use_BANG] = ACTIONS(931),
    [anon_sym_do_BANG] = ACTIONS(933),
    [anon_sym_begin] = ACTIONS(937),
    [aux_sym_char_token1] = ACTIONS(941),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(943),
    [anon_sym_DQUOTE] = ACTIONS(945),
    [anon_sym_AT_DQUOTE] = ACTIONS(947),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(949),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(951),
    [sym_bool] = ACTIONS(953),
    [sym_unit] = ACTIONS(2052),
    [anon_sym_LPAREN_PIPE] = ACTIONS(957),
    [sym_op_identifier] = ACTIONS(2054),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(961),
    [sym_xint] = ACTIONS(963),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(965),
  },
  [439] = {
    [sym_function_or_value_defn] = STATE(509),
    [sym__expression] = STATE(291),
    [sym_literal_expression] = STATE(2230),
    [sym_long_identifier_or_op] = STATE(2230),
    [sym_tuple_expression] = STATE(2230),
    [sym_brace_expression] = STATE(2230),
    [sym_anon_record_expression] = STATE(2230),
    [sym_prefixed_expression] = STATE(2230),
    [sym_typecast_expression] = STATE(2230),
    [sym_for_expression] = STATE(2230),
    [sym_while_expression] = STATE(2230),
    [sym__if_branch] = STATE(6659),
    [sym_if_expression] = STATE(2230),
    [sym_fun_expression] = STATE(2230),
    [sym_try_expression] = STATE(2230),
    [sym_match_expression] = STATE(2230),
    [sym_function_expression] = STATE(2230),
    [sym_mutate_expression] = STATE(2230),
    [sym_index_expression] = STATE(2230),
    [sym_typed_expression] = STATE(2230),
    [sym_declaration_expression] = STATE(2230),
    [sym_do_expression] = STATE(2230),
    [sym_list_expression] = STATE(2230),
    [sym_array_expression] = STATE(2230),
    [sym_range_expression] = STATE(6775),
    [sym_begin_end_expression] = STATE(2230),
    [sym_paren_expression] = STATE(2230),
    [sym__high_prec_app] = STATE(2229),
    [sym__low_prec_app] = STATE(2229),
    [sym_application_expression] = STATE(2230),
    [sym_dot_expression] = STATE(2230),
    [sym_infix_expression] = STATE(2230),
    [sym_ce_expression] = STATE(2230),
    [sym_sequential_expression] = STATE(2230),
    [sym_char] = STATE(2100),
    [sym_format_string] = STATE(2106),
    [sym__string_literal] = STATE(2106),
    [sym_string] = STATE(2100),
    [sym_verbatim_string] = STATE(2100),
    [sym_bytearray] = STATE(2100),
    [sym_verbatim_bytearray] = STATE(2100),
    [sym_format_triple_quoted_string] = STATE(2107),
    [sym_triple_quoted_string] = STATE(2100),
    [sym_const] = STATE(2230),
    [sym_long_identifier] = STATE(2232),
    [sym_active_pattern] = STATE(2424),
    [sym__identifier_or_op] = STATE(2305),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(737),
    [sym_sbyte] = STATE(2100),
    [sym_byte] = STATE(2100),
    [sym_int16] = STATE(2100),
    [sym_uint16] = STATE(2100),
    [sym_int32] = STATE(2100),
    [sym_uint32] = STATE(2100),
    [sym_nativeint] = STATE(2100),
    [sym_unativeint] = STATE(2100),
    [sym_int64] = STATE(2100),
    [sym_uint64] = STATE(2100),
    [sym_ieee32] = STATE(2100),
    [sym_ieee64] = STATE(2100),
    [sym_bignum] = STATE(2100),
    [sym_decimal] = STATE(2100),
    [sym_float] = STATE(1487),
    [sym_block_comment] = STATE(439),
    [sym_compiler_directive_decl] = STATE(439),
    [sym_fsi_directive_decl] = STATE(439),
    [sym_preproc_line] = STATE(439),
    [sym_preproc_if_in_expression] = STATE(2230),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(877),
    [anon_sym_return] = ACTIONS(881),
    [anon_sym_do] = ACTIONS(1585),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(885),
    [anon_sym_null] = ACTIONS(889),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(891),
    [anon_sym_LBRACK_PIPE] = ACTIONS(893),
    [anon_sym_LBRACE] = ACTIONS(2048),
    [anon_sym_LT_AT] = ACTIONS(897),
    [anon_sym_LT_AT_AT] = ACTIONS(2050),
    [anon_sym_LBRACE_PIPE] = ACTIONS(903),
    [anon_sym_new] = ACTIONS(881),
    [anon_sym_return_BANG] = ACTIONS(905),
    [anon_sym_yield] = ACTIONS(881),
    [anon_sym_yield_BANG] = ACTIONS(905),
    [anon_sym_lazy] = ACTIONS(881),
    [anon_sym_assert] = ACTIONS(881),
    [anon_sym_upcast] = ACTIONS(881),
    [anon_sym_downcast] = ACTIONS(881),
    [anon_sym_for] = ACTIONS(909),
    [anon_sym_while] = ACTIONS(911),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(913),
    [anon_sym_try] = ACTIONS(915),
    [anon_sym_match] = ACTIONS(917),
    [anon_sym_match_BANG] = ACTIONS(919),
    [anon_sym_function] = ACTIONS(921),
    [anon_sym_use] = ACTIONS(929),
    [anon_sym_use_BANG] = ACTIONS(931),
    [anon_sym_do_BANG] = ACTIONS(933),
    [anon_sym_begin] = ACTIONS(937),
    [aux_sym_char_token1] = ACTIONS(941),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(943),
    [anon_sym_DQUOTE] = ACTIONS(945),
    [anon_sym_AT_DQUOTE] = ACTIONS(947),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(949),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(951),
    [sym_bool] = ACTIONS(953),
    [sym_unit] = ACTIONS(2052),
    [anon_sym_LPAREN_PIPE] = ACTIONS(957),
    [sym_op_identifier] = ACTIONS(2054),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(961),
    [sym_xint] = ACTIONS(963),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(965),
  },
  [440] = {
    [sym_function_or_value_defn] = STATE(627),
    [sym__expression] = STATE(21),
    [sym_literal_expression] = STATE(1118),
    [sym_long_identifier_or_op] = STATE(1118),
    [sym_tuple_expression] = STATE(1118),
    [sym_brace_expression] = STATE(1118),
    [sym_anon_record_expression] = STATE(1118),
    [sym_prefixed_expression] = STATE(1118),
    [sym_typecast_expression] = STATE(1118),
    [sym_for_expression] = STATE(1118),
    [sym_while_expression] = STATE(1118),
    [sym__if_branch] = STATE(7163),
    [sym_if_expression] = STATE(1118),
    [sym_fun_expression] = STATE(1118),
    [sym_try_expression] = STATE(1118),
    [sym_match_expression] = STATE(1118),
    [sym_function_expression] = STATE(1118),
    [sym_mutate_expression] = STATE(1118),
    [sym_index_expression] = STATE(1118),
    [sym_typed_expression] = STATE(1118),
    [sym_declaration_expression] = STATE(1118),
    [sym_do_expression] = STATE(1118),
    [sym_list_expression] = STATE(1118),
    [sym_array_expression] = STATE(1118),
    [sym_begin_end_expression] = STATE(1118),
    [sym_paren_expression] = STATE(1118),
    [sym__high_prec_app] = STATE(1133),
    [sym__low_prec_app] = STATE(1133),
    [sym_application_expression] = STATE(1118),
    [sym_dot_expression] = STATE(1118),
    [sym_infix_expression] = STATE(1118),
    [sym_ce_expression] = STATE(1118),
    [sym_sequential_expression] = STATE(1118),
    [sym_char] = STATE(1080),
    [sym_format_string] = STATE(1090),
    [sym__string_literal] = STATE(1090),
    [sym_string] = STATE(1080),
    [sym_verbatim_string] = STATE(1080),
    [sym_bytearray] = STATE(1080),
    [sym_verbatim_bytearray] = STATE(1080),
    [sym_format_triple_quoted_string] = STATE(1096),
    [sym_triple_quoted_string] = STATE(1080),
    [sym_const] = STATE(1118),
    [sym_long_identifier] = STATE(1156),
    [sym_active_pattern] = STATE(1085),
    [sym__identifier_or_op] = STATE(1099),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(517),
    [sym_sbyte] = STATE(1080),
    [sym_byte] = STATE(1080),
    [sym_int16] = STATE(1080),
    [sym_uint16] = STATE(1080),
    [sym_int32] = STATE(1080),
    [sym_uint32] = STATE(1080),
    [sym_nativeint] = STATE(1080),
    [sym_unativeint] = STATE(1080),
    [sym_int64] = STATE(1080),
    [sym_uint64] = STATE(1080),
    [sym_ieee32] = STATE(1080),
    [sym_ieee64] = STATE(1080),
    [sym_bignum] = STATE(1080),
    [sym_decimal] = STATE(1080),
    [sym_float] = STATE(979),
    [sym_block_comment] = STATE(440),
    [sym_compiler_directive_decl] = STATE(440),
    [sym_fsi_directive_decl] = STATE(440),
    [sym_preproc_line] = STATE(440),
    [sym_preproc_if_in_expression] = STATE(1118),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(195),
    [anon_sym_return] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_null] = ACTIONS(207),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(209),
    [anon_sym_LBRACK_PIPE] = ACTIONS(211),
    [anon_sym_LBRACE] = ACTIONS(1687),
    [anon_sym_LT_AT] = ACTIONS(213),
    [anon_sym_LT_AT_AT] = ACTIONS(1689),
    [anon_sym_LBRACE_PIPE] = ACTIONS(217),
    [anon_sym_new] = ACTIONS(199),
    [anon_sym_with] = ACTIONS(2058),
    [anon_sym_return_BANG] = ACTIONS(219),
    [anon_sym_yield] = ACTIONS(199),
    [anon_sym_yield_BANG] = ACTIONS(219),
    [anon_sym_lazy] = ACTIONS(199),
    [anon_sym_assert] = ACTIONS(199),
    [anon_sym_upcast] = ACTIONS(199),
    [anon_sym_downcast] = ACTIONS(199),
    [anon_sym_for] = ACTIONS(223),
    [anon_sym_while] = ACTIONS(225),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(229),
    [anon_sym_match] = ACTIONS(231),
    [anon_sym_match_BANG] = ACTIONS(233),
    [anon_sym_function] = ACTIONS(235),
    [anon_sym_use] = ACTIONS(239),
    [anon_sym_use_BANG] = ACTIONS(241),
    [anon_sym_do_BANG] = ACTIONS(243),
    [anon_sym_begin] = ACTIONS(245),
    [aux_sym_char_token1] = ACTIONS(247),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(251),
    [anon_sym_AT_DQUOTE] = ACTIONS(253),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(255),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(257),
    [sym_bool] = ACTIONS(259),
    [sym_unit] = ACTIONS(1699),
    [anon_sym_LPAREN_PIPE] = ACTIONS(261),
    [sym_op_identifier] = ACTIONS(1701),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(265),
    [sym_xint] = ACTIONS(267),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(269),
  },
  [441] = {
    [sym_function_or_value_defn] = STATE(733),
    [sym__expression] = STATE(138),
    [sym_literal_expression] = STATE(2008),
    [sym_long_identifier_or_op] = STATE(2008),
    [sym_tuple_expression] = STATE(2008),
    [sym_brace_expression] = STATE(2008),
    [sym_anon_record_expression] = STATE(2008),
    [sym_prefixed_expression] = STATE(2008),
    [sym_typecast_expression] = STATE(2008),
    [sym_for_expression] = STATE(2008),
    [sym_while_expression] = STATE(2008),
    [sym__if_branch] = STATE(6754),
    [sym_if_expression] = STATE(2008),
    [sym_fun_expression] = STATE(2008),
    [sym_try_expression] = STATE(2008),
    [sym_match_expression] = STATE(2008),
    [sym_function_expression] = STATE(2008),
    [sym_mutate_expression] = STATE(2008),
    [sym_index_expression] = STATE(2008),
    [sym_typed_expression] = STATE(2008),
    [sym_declaration_expression] = STATE(2008),
    [sym_do_expression] = STATE(2008),
    [sym_list_expression] = STATE(2008),
    [sym_array_expression] = STATE(2008),
    [sym_begin_end_expression] = STATE(2008),
    [sym_paren_expression] = STATE(2008),
    [sym__high_prec_app] = STATE(2007),
    [sym__low_prec_app] = STATE(2007),
    [sym_application_expression] = STATE(2008),
    [sym_dot_expression] = STATE(2008),
    [sym_infix_expression] = STATE(2008),
    [sym_ce_expression] = STATE(2008),
    [sym_sequential_expression] = STATE(2008),
    [sym_char] = STATE(1859),
    [sym_format_string] = STATE(1861),
    [sym__string_literal] = STATE(1861),
    [sym_string] = STATE(1859),
    [sym_verbatim_string] = STATE(1859),
    [sym_bytearray] = STATE(1859),
    [sym_verbatim_bytearray] = STATE(1859),
    [sym_format_triple_quoted_string] = STATE(1862),
    [sym_triple_quoted_string] = STATE(1859),
    [sym_const] = STATE(2008),
    [sym_long_identifier] = STATE(1701),
    [sym_active_pattern] = STATE(1702),
    [sym__identifier_or_op] = STATE(1724),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(706),
    [sym_sbyte] = STATE(1859),
    [sym_byte] = STATE(1859),
    [sym_int16] = STATE(1859),
    [sym_uint16] = STATE(1859),
    [sym_int32] = STATE(1859),
    [sym_uint32] = STATE(1859),
    [sym_nativeint] = STATE(1859),
    [sym_unativeint] = STATE(1859),
    [sym_int64] = STATE(1859),
    [sym_uint64] = STATE(1859),
    [sym_ieee32] = STATE(1859),
    [sym_ieee64] = STATE(1859),
    [sym_bignum] = STATE(1859),
    [sym_decimal] = STATE(1859),
    [sym_float] = STATE(1447),
    [sym_block_comment] = STATE(441),
    [sym_compiler_directive_decl] = STATE(441),
    [sym_fsi_directive_decl] = STATE(441),
    [sym_preproc_line] = STATE(441),
    [sym_preproc_if_in_expression] = STATE(2008),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(503),
    [anon_sym_return] = ACTIONS(971),
    [anon_sym_do] = ACTIONS(599),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(511),
    [anon_sym_null] = ACTIONS(515),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(517),
    [anon_sym_LBRACK_PIPE] = ACTIONS(519),
    [anon_sym_LBRACE] = ACTIONS(2060),
    [anon_sym_LT_AT] = ACTIONS(523),
    [anon_sym_LT_AT_AT] = ACTIONS(2062),
    [anon_sym_LBRACE_PIPE] = ACTIONS(529),
    [anon_sym_new] = ACTIONS(971),
    [anon_sym_return_BANG] = ACTIONS(975),
    [anon_sym_yield] = ACTIONS(971),
    [anon_sym_yield_BANG] = ACTIONS(975),
    [anon_sym_lazy] = ACTIONS(971),
    [anon_sym_assert] = ACTIONS(971),
    [anon_sym_upcast] = ACTIONS(971),
    [anon_sym_downcast] = ACTIONS(971),
    [anon_sym_for] = ACTIONS(979),
    [anon_sym_while] = ACTIONS(537),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(539),
    [anon_sym_try] = ACTIONS(543),
    [anon_sym_match] = ACTIONS(545),
    [anon_sym_match_BANG] = ACTIONS(547),
    [anon_sym_function] = ACTIONS(549),
    [anon_sym_use] = ACTIONS(983),
    [anon_sym_use_BANG] = ACTIONS(985),
    [anon_sym_do_BANG] = ACTIONS(561),
    [anon_sym_begin] = ACTIONS(565),
    [aux_sym_char_token1] = ACTIONS(569),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(571),
    [anon_sym_DQUOTE] = ACTIONS(573),
    [anon_sym_AT_DQUOTE] = ACTIONS(575),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(577),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(579),
    [sym_bool] = ACTIONS(581),
    [sym_unit] = ACTIONS(2064),
    [anon_sym_LPAREN_PIPE] = ACTIONS(585),
    [sym_op_identifier] = ACTIONS(2066),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(591),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(593),
    [sym__tuple_marker] = ACTIONS(2068),
  },
  [442] = {
    [sym_function_or_value_defn] = STATE(651),
    [sym__expression] = STATE(183),
    [sym_literal_expression] = STATE(2168),
    [sym_long_identifier_or_op] = STATE(2168),
    [sym_tuple_expression] = STATE(2168),
    [sym_brace_expression] = STATE(2168),
    [sym_anon_record_expression] = STATE(2168),
    [sym_prefixed_expression] = STATE(2168),
    [sym_typecast_expression] = STATE(2168),
    [sym_for_expression] = STATE(2168),
    [sym_while_expression] = STATE(2168),
    [sym__if_branch] = STATE(6406),
    [sym_if_expression] = STATE(2168),
    [sym_fun_expression] = STATE(2168),
    [sym_try_expression] = STATE(2168),
    [sym_match_expression] = STATE(2168),
    [sym_function_expression] = STATE(2168),
    [sym_mutate_expression] = STATE(2168),
    [sym_index_expression] = STATE(2168),
    [sym_typed_expression] = STATE(2168),
    [sym_declaration_expression] = STATE(2168),
    [sym_do_expression] = STATE(2168),
    [sym_list_expression] = STATE(2168),
    [sym_array_expression] = STATE(2168),
    [sym_begin_end_expression] = STATE(2168),
    [sym_paren_expression] = STATE(2168),
    [sym__high_prec_app] = STATE(2179),
    [sym__low_prec_app] = STATE(2179),
    [sym_application_expression] = STATE(2168),
    [sym_dot_expression] = STATE(2168),
    [sym_infix_expression] = STATE(2168),
    [sym_ce_expression] = STATE(2168),
    [sym_sequential_expression] = STATE(2168),
    [sym_char] = STATE(2469),
    [sym_format_string] = STATE(2412),
    [sym__string_literal] = STATE(2412),
    [sym_string] = STATE(2469),
    [sym_verbatim_string] = STATE(2469),
    [sym_bytearray] = STATE(2469),
    [sym_verbatim_bytearray] = STATE(2469),
    [sym_format_triple_quoted_string] = STATE(2408),
    [sym_triple_quoted_string] = STATE(2469),
    [sym_const] = STATE(2168),
    [sym_long_identifier] = STATE(2183),
    [sym_active_pattern] = STATE(2182),
    [sym__identifier_or_op] = STATE(2093),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(650),
    [sym_sbyte] = STATE(2469),
    [sym_byte] = STATE(2469),
    [sym_int16] = STATE(2469),
    [sym_uint16] = STATE(2469),
    [sym_int32] = STATE(2469),
    [sym_uint32] = STATE(2469),
    [sym_nativeint] = STATE(2469),
    [sym_unativeint] = STATE(2469),
    [sym_int64] = STATE(2469),
    [sym_uint64] = STATE(2469),
    [sym_ieee32] = STATE(2469),
    [sym_ieee64] = STATE(2469),
    [sym_bignum] = STATE(2469),
    [sym_decimal] = STATE(2469),
    [sym_float] = STATE(1586),
    [sym_block_comment] = STATE(442),
    [sym_compiler_directive_decl] = STATE(442),
    [sym_fsi_directive_decl] = STATE(442),
    [sym_preproc_line] = STATE(442),
    [sym_preproc_if_in_expression] = STATE(2168),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(989),
    [anon_sym_return] = ACTIONS(993),
    [anon_sym_do] = ACTIONS(995),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(997),
    [anon_sym_null] = ACTIONS(1001),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1003),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1005),
    [anon_sym_LBRACE] = ACTIONS(2070),
    [anon_sym_LT_AT] = ACTIONS(1009),
    [anon_sym_LT_AT_AT] = ACTIONS(2072),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1017),
    [anon_sym_new] = ACTIONS(993),
    [anon_sym_return_BANG] = ACTIONS(1019),
    [anon_sym_yield] = ACTIONS(993),
    [anon_sym_yield_BANG] = ACTIONS(1019),
    [anon_sym_lazy] = ACTIONS(993),
    [anon_sym_assert] = ACTIONS(993),
    [anon_sym_upcast] = ACTIONS(993),
    [anon_sym_downcast] = ACTIONS(993),
    [anon_sym_for] = ACTIONS(1023),
    [anon_sym_while] = ACTIONS(1025),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(1027),
    [anon_sym_try] = ACTIONS(1029),
    [anon_sym_match] = ACTIONS(1031),
    [anon_sym_match_BANG] = ACTIONS(1033),
    [anon_sym_function] = ACTIONS(1035),
    [anon_sym_use] = ACTIONS(1043),
    [anon_sym_use_BANG] = ACTIONS(1045),
    [anon_sym_do_BANG] = ACTIONS(1047),
    [anon_sym_begin] = ACTIONS(1049),
    [aux_sym_char_token1] = ACTIONS(1053),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1055),
    [anon_sym_DQUOTE] = ACTIONS(1057),
    [anon_sym_AT_DQUOTE] = ACTIONS(1059),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1061),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1063),
    [sym_bool] = ACTIONS(1065),
    [sym_unit] = ACTIONS(2074),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1069),
    [sym_op_identifier] = ACTIONS(2076),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(1073),
    [sym_xint] = ACTIONS(1075),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1077),
    [sym__tuple_marker] = ACTIONS(2078),
  },
  [443] = {
    [sym_function_or_value_defn] = STATE(627),
    [sym__expression] = STATE(21),
    [sym_literal_expression] = STATE(1118),
    [sym_long_identifier_or_op] = STATE(1118),
    [sym_tuple_expression] = STATE(1118),
    [sym_brace_expression] = STATE(1118),
    [sym_anon_record_expression] = STATE(1118),
    [sym_prefixed_expression] = STATE(1118),
    [sym_typecast_expression] = STATE(1118),
    [sym_for_expression] = STATE(1118),
    [sym_while_expression] = STATE(1118),
    [sym__if_branch] = STATE(7163),
    [sym_if_expression] = STATE(1118),
    [sym_fun_expression] = STATE(1118),
    [sym_try_expression] = STATE(1118),
    [sym_match_expression] = STATE(1118),
    [sym_function_expression] = STATE(1118),
    [sym_mutate_expression] = STATE(1118),
    [sym_index_expression] = STATE(1118),
    [sym_typed_expression] = STATE(1118),
    [sym_declaration_expression] = STATE(1118),
    [sym_do_expression] = STATE(1118),
    [sym_list_expression] = STATE(1118),
    [sym_array_expression] = STATE(1118),
    [sym_begin_end_expression] = STATE(1118),
    [sym_paren_expression] = STATE(1118),
    [sym__high_prec_app] = STATE(1133),
    [sym__low_prec_app] = STATE(1133),
    [sym_application_expression] = STATE(1118),
    [sym_dot_expression] = STATE(1118),
    [sym_infix_expression] = STATE(1118),
    [sym_ce_expression] = STATE(1118),
    [sym_sequential_expression] = STATE(1118),
    [sym_char] = STATE(1080),
    [sym_format_string] = STATE(1090),
    [sym__string_literal] = STATE(1090),
    [sym_string] = STATE(1080),
    [sym_verbatim_string] = STATE(1080),
    [sym_bytearray] = STATE(1080),
    [sym_verbatim_bytearray] = STATE(1080),
    [sym_format_triple_quoted_string] = STATE(1096),
    [sym_triple_quoted_string] = STATE(1080),
    [sym_const] = STATE(1118),
    [sym_long_identifier] = STATE(1156),
    [sym_active_pattern] = STATE(1085),
    [sym__identifier_or_op] = STATE(1099),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(517),
    [sym_sbyte] = STATE(1080),
    [sym_byte] = STATE(1080),
    [sym_int16] = STATE(1080),
    [sym_uint16] = STATE(1080),
    [sym_int32] = STATE(1080),
    [sym_uint32] = STATE(1080),
    [sym_nativeint] = STATE(1080),
    [sym_unativeint] = STATE(1080),
    [sym_int64] = STATE(1080),
    [sym_uint64] = STATE(1080),
    [sym_ieee32] = STATE(1080),
    [sym_ieee64] = STATE(1080),
    [sym_bignum] = STATE(1080),
    [sym_decimal] = STATE(1080),
    [sym_float] = STATE(979),
    [sym_block_comment] = STATE(443),
    [sym_compiler_directive_decl] = STATE(443),
    [sym_fsi_directive_decl] = STATE(443),
    [sym_preproc_line] = STATE(443),
    [sym_preproc_if_in_expression] = STATE(1118),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(195),
    [anon_sym_return] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_null] = ACTIONS(207),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(209),
    [anon_sym_LBRACK_PIPE] = ACTIONS(211),
    [anon_sym_LBRACE] = ACTIONS(1687),
    [anon_sym_LT_AT] = ACTIONS(213),
    [anon_sym_LT_AT_AT] = ACTIONS(1689),
    [anon_sym_LBRACE_PIPE] = ACTIONS(217),
    [anon_sym_new] = ACTIONS(199),
    [anon_sym_with] = ACTIONS(2080),
    [anon_sym_return_BANG] = ACTIONS(219),
    [anon_sym_yield] = ACTIONS(199),
    [anon_sym_yield_BANG] = ACTIONS(219),
    [anon_sym_lazy] = ACTIONS(199),
    [anon_sym_assert] = ACTIONS(199),
    [anon_sym_upcast] = ACTIONS(199),
    [anon_sym_downcast] = ACTIONS(199),
    [anon_sym_for] = ACTIONS(223),
    [anon_sym_while] = ACTIONS(225),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(229),
    [anon_sym_match] = ACTIONS(231),
    [anon_sym_match_BANG] = ACTIONS(233),
    [anon_sym_function] = ACTIONS(235),
    [anon_sym_use] = ACTIONS(239),
    [anon_sym_use_BANG] = ACTIONS(241),
    [anon_sym_do_BANG] = ACTIONS(243),
    [anon_sym_begin] = ACTIONS(245),
    [aux_sym_char_token1] = ACTIONS(247),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(251),
    [anon_sym_AT_DQUOTE] = ACTIONS(253),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(255),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(257),
    [sym_bool] = ACTIONS(259),
    [sym_unit] = ACTIONS(1699),
    [anon_sym_LPAREN_PIPE] = ACTIONS(261),
    [sym_op_identifier] = ACTIONS(1701),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(265),
    [sym_xint] = ACTIONS(267),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(269),
  },
  [444] = {
    [sym_function_or_value_defn] = STATE(509),
    [sym__expression] = STATE(283),
    [sym_literal_expression] = STATE(2230),
    [sym_long_identifier_or_op] = STATE(2230),
    [sym_tuple_expression] = STATE(2230),
    [sym_brace_expression] = STATE(2230),
    [sym_anon_record_expression] = STATE(2230),
    [sym_prefixed_expression] = STATE(2230),
    [sym_typecast_expression] = STATE(2230),
    [sym_for_expression] = STATE(2230),
    [sym_while_expression] = STATE(2230),
    [sym__if_branch] = STATE(6659),
    [sym_if_expression] = STATE(2230),
    [sym_fun_expression] = STATE(2230),
    [sym_try_expression] = STATE(2230),
    [sym_match_expression] = STATE(2230),
    [sym_function_expression] = STATE(2230),
    [sym_mutate_expression] = STATE(2230),
    [sym_index_expression] = STATE(2230),
    [sym_typed_expression] = STATE(2230),
    [sym_declaration_expression] = STATE(2230),
    [sym_do_expression] = STATE(2230),
    [sym_list_expression] = STATE(2230),
    [sym_array_expression] = STATE(2230),
    [sym_range_expression] = STATE(6531),
    [sym_begin_end_expression] = STATE(2230),
    [sym_paren_expression] = STATE(2230),
    [sym__high_prec_app] = STATE(2229),
    [sym__low_prec_app] = STATE(2229),
    [sym_application_expression] = STATE(2230),
    [sym_dot_expression] = STATE(2230),
    [sym_infix_expression] = STATE(2230),
    [sym_ce_expression] = STATE(2230),
    [sym_sequential_expression] = STATE(2230),
    [sym_char] = STATE(2100),
    [sym_format_string] = STATE(2106),
    [sym__string_literal] = STATE(2106),
    [sym_string] = STATE(2100),
    [sym_verbatim_string] = STATE(2100),
    [sym_bytearray] = STATE(2100),
    [sym_verbatim_bytearray] = STATE(2100),
    [sym_format_triple_quoted_string] = STATE(2107),
    [sym_triple_quoted_string] = STATE(2100),
    [sym_const] = STATE(2230),
    [sym_long_identifier] = STATE(2232),
    [sym_active_pattern] = STATE(2424),
    [sym__identifier_or_op] = STATE(2305),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(737),
    [sym_sbyte] = STATE(2100),
    [sym_byte] = STATE(2100),
    [sym_int16] = STATE(2100),
    [sym_uint16] = STATE(2100),
    [sym_int32] = STATE(2100),
    [sym_uint32] = STATE(2100),
    [sym_nativeint] = STATE(2100),
    [sym_unativeint] = STATE(2100),
    [sym_int64] = STATE(2100),
    [sym_uint64] = STATE(2100),
    [sym_ieee32] = STATE(2100),
    [sym_ieee64] = STATE(2100),
    [sym_bignum] = STATE(2100),
    [sym_decimal] = STATE(2100),
    [sym_float] = STATE(1487),
    [sym_block_comment] = STATE(444),
    [sym_compiler_directive_decl] = STATE(444),
    [sym_fsi_directive_decl] = STATE(444),
    [sym_preproc_line] = STATE(444),
    [sym_preproc_if_in_expression] = STATE(2230),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(877),
    [anon_sym_return] = ACTIONS(881),
    [anon_sym_do] = ACTIONS(1585),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(885),
    [anon_sym_null] = ACTIONS(889),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(891),
    [anon_sym_LBRACK_PIPE] = ACTIONS(893),
    [anon_sym_LBRACE] = ACTIONS(2048),
    [anon_sym_LT_AT] = ACTIONS(897),
    [anon_sym_LT_AT_AT] = ACTIONS(2050),
    [anon_sym_LBRACE_PIPE] = ACTIONS(903),
    [anon_sym_new] = ACTIONS(881),
    [anon_sym_return_BANG] = ACTIONS(905),
    [anon_sym_yield] = ACTIONS(881),
    [anon_sym_yield_BANG] = ACTIONS(905),
    [anon_sym_lazy] = ACTIONS(881),
    [anon_sym_assert] = ACTIONS(881),
    [anon_sym_upcast] = ACTIONS(881),
    [anon_sym_downcast] = ACTIONS(881),
    [anon_sym_for] = ACTIONS(909),
    [anon_sym_while] = ACTIONS(911),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(913),
    [anon_sym_try] = ACTIONS(915),
    [anon_sym_match] = ACTIONS(917),
    [anon_sym_match_BANG] = ACTIONS(919),
    [anon_sym_function] = ACTIONS(921),
    [anon_sym_use] = ACTIONS(929),
    [anon_sym_use_BANG] = ACTIONS(931),
    [anon_sym_do_BANG] = ACTIONS(933),
    [anon_sym_begin] = ACTIONS(937),
    [aux_sym_char_token1] = ACTIONS(941),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(943),
    [anon_sym_DQUOTE] = ACTIONS(945),
    [anon_sym_AT_DQUOTE] = ACTIONS(947),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(949),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(951),
    [sym_bool] = ACTIONS(953),
    [sym_unit] = ACTIONS(2052),
    [anon_sym_LPAREN_PIPE] = ACTIONS(957),
    [sym_op_identifier] = ACTIONS(2054),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(961),
    [sym_xint] = ACTIONS(963),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(965),
  },
  [445] = {
    [sym_function_or_value_defn] = STATE(509),
    [sym__expression] = STATE(296),
    [sym_literal_expression] = STATE(2230),
    [sym_long_identifier_or_op] = STATE(2230),
    [sym_tuple_expression] = STATE(2230),
    [sym_brace_expression] = STATE(2230),
    [sym_anon_record_expression] = STATE(2230),
    [sym_prefixed_expression] = STATE(2230),
    [sym_typecast_expression] = STATE(2230),
    [sym_for_expression] = STATE(2230),
    [sym_while_expression] = STATE(2230),
    [sym__if_branch] = STATE(6659),
    [sym_if_expression] = STATE(2230),
    [sym_fun_expression] = STATE(2230),
    [sym_try_expression] = STATE(2230),
    [sym_match_expression] = STATE(2230),
    [sym_function_expression] = STATE(2230),
    [sym_mutate_expression] = STATE(2230),
    [sym_index_expression] = STATE(2230),
    [sym_typed_expression] = STATE(2230),
    [sym_declaration_expression] = STATE(2230),
    [sym_do_expression] = STATE(2230),
    [sym_list_expression] = STATE(2230),
    [sym_array_expression] = STATE(2230),
    [sym_range_expression] = STATE(6855),
    [sym_begin_end_expression] = STATE(2230),
    [sym_paren_expression] = STATE(2230),
    [sym__high_prec_app] = STATE(2229),
    [sym__low_prec_app] = STATE(2229),
    [sym_application_expression] = STATE(2230),
    [sym_dot_expression] = STATE(2230),
    [sym_infix_expression] = STATE(2230),
    [sym_ce_expression] = STATE(2230),
    [sym_sequential_expression] = STATE(2230),
    [sym_char] = STATE(2100),
    [sym_format_string] = STATE(2106),
    [sym__string_literal] = STATE(2106),
    [sym_string] = STATE(2100),
    [sym_verbatim_string] = STATE(2100),
    [sym_bytearray] = STATE(2100),
    [sym_verbatim_bytearray] = STATE(2100),
    [sym_format_triple_quoted_string] = STATE(2107),
    [sym_triple_quoted_string] = STATE(2100),
    [sym_const] = STATE(2230),
    [sym_long_identifier] = STATE(2232),
    [sym_active_pattern] = STATE(2424),
    [sym__identifier_or_op] = STATE(2305),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(737),
    [sym_sbyte] = STATE(2100),
    [sym_byte] = STATE(2100),
    [sym_int16] = STATE(2100),
    [sym_uint16] = STATE(2100),
    [sym_int32] = STATE(2100),
    [sym_uint32] = STATE(2100),
    [sym_nativeint] = STATE(2100),
    [sym_unativeint] = STATE(2100),
    [sym_int64] = STATE(2100),
    [sym_uint64] = STATE(2100),
    [sym_ieee32] = STATE(2100),
    [sym_ieee64] = STATE(2100),
    [sym_bignum] = STATE(2100),
    [sym_decimal] = STATE(2100),
    [sym_float] = STATE(1487),
    [sym_block_comment] = STATE(445),
    [sym_compiler_directive_decl] = STATE(445),
    [sym_fsi_directive_decl] = STATE(445),
    [sym_preproc_line] = STATE(445),
    [sym_preproc_if_in_expression] = STATE(2230),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(877),
    [anon_sym_return] = ACTIONS(881),
    [anon_sym_do] = ACTIONS(1585),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(885),
    [anon_sym_null] = ACTIONS(889),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(891),
    [anon_sym_LBRACK_PIPE] = ACTIONS(893),
    [anon_sym_LBRACE] = ACTIONS(2048),
    [anon_sym_LT_AT] = ACTIONS(897),
    [anon_sym_LT_AT_AT] = ACTIONS(2050),
    [anon_sym_LBRACE_PIPE] = ACTIONS(903),
    [anon_sym_new] = ACTIONS(881),
    [anon_sym_return_BANG] = ACTIONS(905),
    [anon_sym_yield] = ACTIONS(881),
    [anon_sym_yield_BANG] = ACTIONS(905),
    [anon_sym_lazy] = ACTIONS(881),
    [anon_sym_assert] = ACTIONS(881),
    [anon_sym_upcast] = ACTIONS(881),
    [anon_sym_downcast] = ACTIONS(881),
    [anon_sym_for] = ACTIONS(909),
    [anon_sym_while] = ACTIONS(911),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(913),
    [anon_sym_try] = ACTIONS(915),
    [anon_sym_match] = ACTIONS(917),
    [anon_sym_match_BANG] = ACTIONS(919),
    [anon_sym_function] = ACTIONS(921),
    [anon_sym_use] = ACTIONS(929),
    [anon_sym_use_BANG] = ACTIONS(931),
    [anon_sym_do_BANG] = ACTIONS(933),
    [anon_sym_begin] = ACTIONS(937),
    [aux_sym_char_token1] = ACTIONS(941),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(943),
    [anon_sym_DQUOTE] = ACTIONS(945),
    [anon_sym_AT_DQUOTE] = ACTIONS(947),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(949),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(951),
    [sym_bool] = ACTIONS(953),
    [sym_unit] = ACTIONS(2052),
    [anon_sym_LPAREN_PIPE] = ACTIONS(957),
    [sym_op_identifier] = ACTIONS(2054),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(961),
    [sym_xint] = ACTIONS(963),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(965),
  },
  [446] = {
    [sym_function_or_value_defn] = STATE(627),
    [sym__expression] = STATE(21),
    [sym_literal_expression] = STATE(1118),
    [sym_long_identifier_or_op] = STATE(1118),
    [sym_tuple_expression] = STATE(1118),
    [sym_brace_expression] = STATE(1118),
    [sym_anon_record_expression] = STATE(1118),
    [sym_prefixed_expression] = STATE(1118),
    [sym_typecast_expression] = STATE(1118),
    [sym_for_expression] = STATE(1118),
    [sym_while_expression] = STATE(1118),
    [sym__if_branch] = STATE(7163),
    [sym_if_expression] = STATE(1118),
    [sym_fun_expression] = STATE(1118),
    [sym_try_expression] = STATE(1118),
    [sym_match_expression] = STATE(1118),
    [sym_function_expression] = STATE(1118),
    [sym_mutate_expression] = STATE(1118),
    [sym_index_expression] = STATE(1118),
    [sym_typed_expression] = STATE(1118),
    [sym_declaration_expression] = STATE(1118),
    [sym_do_expression] = STATE(1118),
    [sym_list_expression] = STATE(1118),
    [sym_array_expression] = STATE(1118),
    [sym_begin_end_expression] = STATE(1118),
    [sym_paren_expression] = STATE(1118),
    [sym__high_prec_app] = STATE(1133),
    [sym__low_prec_app] = STATE(1133),
    [sym_application_expression] = STATE(1118),
    [sym_dot_expression] = STATE(1118),
    [sym_infix_expression] = STATE(1118),
    [sym_ce_expression] = STATE(1118),
    [sym_sequential_expression] = STATE(1118),
    [sym_char] = STATE(1080),
    [sym_format_string] = STATE(1090),
    [sym__string_literal] = STATE(1090),
    [sym_string] = STATE(1080),
    [sym_verbatim_string] = STATE(1080),
    [sym_bytearray] = STATE(1080),
    [sym_verbatim_bytearray] = STATE(1080),
    [sym_format_triple_quoted_string] = STATE(1096),
    [sym_triple_quoted_string] = STATE(1080),
    [sym_const] = STATE(1118),
    [sym_long_identifier] = STATE(1156),
    [sym_active_pattern] = STATE(1085),
    [sym__identifier_or_op] = STATE(1099),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(517),
    [sym_sbyte] = STATE(1080),
    [sym_byte] = STATE(1080),
    [sym_int16] = STATE(1080),
    [sym_uint16] = STATE(1080),
    [sym_int32] = STATE(1080),
    [sym_uint32] = STATE(1080),
    [sym_nativeint] = STATE(1080),
    [sym_unativeint] = STATE(1080),
    [sym_int64] = STATE(1080),
    [sym_uint64] = STATE(1080),
    [sym_ieee32] = STATE(1080),
    [sym_ieee64] = STATE(1080),
    [sym_bignum] = STATE(1080),
    [sym_decimal] = STATE(1080),
    [sym_float] = STATE(979),
    [sym_block_comment] = STATE(446),
    [sym_compiler_directive_decl] = STATE(446),
    [sym_fsi_directive_decl] = STATE(446),
    [sym_preproc_line] = STATE(446),
    [sym_preproc_if_in_expression] = STATE(1118),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(195),
    [anon_sym_return] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_null] = ACTIONS(207),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(209),
    [anon_sym_LBRACK_PIPE] = ACTIONS(211),
    [anon_sym_LBRACE] = ACTIONS(1687),
    [anon_sym_LT_AT] = ACTIONS(213),
    [anon_sym_LT_AT_AT] = ACTIONS(1689),
    [anon_sym_LBRACE_PIPE] = ACTIONS(217),
    [anon_sym_new] = ACTIONS(199),
    [anon_sym_with] = ACTIONS(2082),
    [anon_sym_return_BANG] = ACTIONS(219),
    [anon_sym_yield] = ACTIONS(199),
    [anon_sym_yield_BANG] = ACTIONS(219),
    [anon_sym_lazy] = ACTIONS(199),
    [anon_sym_assert] = ACTIONS(199),
    [anon_sym_upcast] = ACTIONS(199),
    [anon_sym_downcast] = ACTIONS(199),
    [anon_sym_for] = ACTIONS(223),
    [anon_sym_while] = ACTIONS(225),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(229),
    [anon_sym_match] = ACTIONS(231),
    [anon_sym_match_BANG] = ACTIONS(233),
    [anon_sym_function] = ACTIONS(235),
    [anon_sym_use] = ACTIONS(239),
    [anon_sym_use_BANG] = ACTIONS(241),
    [anon_sym_do_BANG] = ACTIONS(243),
    [anon_sym_begin] = ACTIONS(245),
    [aux_sym_char_token1] = ACTIONS(247),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(251),
    [anon_sym_AT_DQUOTE] = ACTIONS(253),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(255),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(257),
    [sym_bool] = ACTIONS(259),
    [sym_unit] = ACTIONS(1699),
    [anon_sym_LPAREN_PIPE] = ACTIONS(261),
    [sym_op_identifier] = ACTIONS(1701),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(265),
    [sym_xint] = ACTIONS(267),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(269),
  },
  [447] = {
    [sym_function_or_value_defn] = STATE(509),
    [sym__expression] = STATE(304),
    [sym_literal_expression] = STATE(2230),
    [sym_long_identifier_or_op] = STATE(2230),
    [sym_tuple_expression] = STATE(2230),
    [sym_brace_expression] = STATE(2230),
    [sym_anon_record_expression] = STATE(2230),
    [sym_prefixed_expression] = STATE(2230),
    [sym_typecast_expression] = STATE(2230),
    [sym_for_expression] = STATE(2230),
    [sym_while_expression] = STATE(2230),
    [sym__if_branch] = STATE(6659),
    [sym_if_expression] = STATE(2230),
    [sym_fun_expression] = STATE(2230),
    [sym_try_expression] = STATE(2230),
    [sym_match_expression] = STATE(2230),
    [sym_function_expression] = STATE(2230),
    [sym_mutate_expression] = STATE(2230),
    [sym_index_expression] = STATE(2230),
    [sym_typed_expression] = STATE(2230),
    [sym_declaration_expression] = STATE(2230),
    [sym_do_expression] = STATE(2230),
    [sym_list_expression] = STATE(2230),
    [sym_array_expression] = STATE(2230),
    [sym_range_expression] = STATE(6815),
    [sym_begin_end_expression] = STATE(2230),
    [sym_paren_expression] = STATE(2230),
    [sym__high_prec_app] = STATE(2229),
    [sym__low_prec_app] = STATE(2229),
    [sym_application_expression] = STATE(2230),
    [sym_dot_expression] = STATE(2230),
    [sym_infix_expression] = STATE(2230),
    [sym_ce_expression] = STATE(2230),
    [sym_sequential_expression] = STATE(2230),
    [sym_char] = STATE(2100),
    [sym_format_string] = STATE(2106),
    [sym__string_literal] = STATE(2106),
    [sym_string] = STATE(2100),
    [sym_verbatim_string] = STATE(2100),
    [sym_bytearray] = STATE(2100),
    [sym_verbatim_bytearray] = STATE(2100),
    [sym_format_triple_quoted_string] = STATE(2107),
    [sym_triple_quoted_string] = STATE(2100),
    [sym_const] = STATE(2230),
    [sym_long_identifier] = STATE(2232),
    [sym_active_pattern] = STATE(2424),
    [sym__identifier_or_op] = STATE(2305),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(737),
    [sym_sbyte] = STATE(2100),
    [sym_byte] = STATE(2100),
    [sym_int16] = STATE(2100),
    [sym_uint16] = STATE(2100),
    [sym_int32] = STATE(2100),
    [sym_uint32] = STATE(2100),
    [sym_nativeint] = STATE(2100),
    [sym_unativeint] = STATE(2100),
    [sym_int64] = STATE(2100),
    [sym_uint64] = STATE(2100),
    [sym_ieee32] = STATE(2100),
    [sym_ieee64] = STATE(2100),
    [sym_bignum] = STATE(2100),
    [sym_decimal] = STATE(2100),
    [sym_float] = STATE(1487),
    [sym_block_comment] = STATE(447),
    [sym_compiler_directive_decl] = STATE(447),
    [sym_fsi_directive_decl] = STATE(447),
    [sym_preproc_line] = STATE(447),
    [sym_preproc_if_in_expression] = STATE(2230),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(877),
    [anon_sym_return] = ACTIONS(881),
    [anon_sym_do] = ACTIONS(1585),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(885),
    [anon_sym_null] = ACTIONS(889),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(891),
    [anon_sym_LBRACK_PIPE] = ACTIONS(893),
    [anon_sym_LBRACE] = ACTIONS(2048),
    [anon_sym_LT_AT] = ACTIONS(897),
    [anon_sym_LT_AT_AT] = ACTIONS(2050),
    [anon_sym_LBRACE_PIPE] = ACTIONS(903),
    [anon_sym_new] = ACTIONS(881),
    [anon_sym_return_BANG] = ACTIONS(905),
    [anon_sym_yield] = ACTIONS(881),
    [anon_sym_yield_BANG] = ACTIONS(905),
    [anon_sym_lazy] = ACTIONS(881),
    [anon_sym_assert] = ACTIONS(881),
    [anon_sym_upcast] = ACTIONS(881),
    [anon_sym_downcast] = ACTIONS(881),
    [anon_sym_for] = ACTIONS(909),
    [anon_sym_while] = ACTIONS(911),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(913),
    [anon_sym_try] = ACTIONS(915),
    [anon_sym_match] = ACTIONS(917),
    [anon_sym_match_BANG] = ACTIONS(919),
    [anon_sym_function] = ACTIONS(921),
    [anon_sym_use] = ACTIONS(929),
    [anon_sym_use_BANG] = ACTIONS(931),
    [anon_sym_do_BANG] = ACTIONS(933),
    [anon_sym_begin] = ACTIONS(937),
    [aux_sym_char_token1] = ACTIONS(941),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(943),
    [anon_sym_DQUOTE] = ACTIONS(945),
    [anon_sym_AT_DQUOTE] = ACTIONS(947),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(949),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(951),
    [sym_bool] = ACTIONS(953),
    [sym_unit] = ACTIONS(2052),
    [anon_sym_LPAREN_PIPE] = ACTIONS(957),
    [sym_op_identifier] = ACTIONS(2054),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(961),
    [sym_xint] = ACTIONS(963),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(965),
  },
  [448] = {
    [sym_function_or_value_defn] = STATE(705),
    [sym__expression] = STATE(8),
    [sym_literal_expression] = STATE(867),
    [sym_long_identifier_or_op] = STATE(867),
    [sym_tuple_expression] = STATE(867),
    [sym_brace_expression] = STATE(867),
    [sym_anon_record_expression] = STATE(867),
    [sym_prefixed_expression] = STATE(867),
    [sym_typecast_expression] = STATE(867),
    [sym_for_expression] = STATE(867),
    [sym_while_expression] = STATE(867),
    [sym__if_branch] = STATE(6511),
    [sym_if_expression] = STATE(867),
    [sym_fun_expression] = STATE(867),
    [sym_try_expression] = STATE(867),
    [sym_match_expression] = STATE(867),
    [sym_function_expression] = STATE(867),
    [sym_mutate_expression] = STATE(867),
    [sym_index_expression] = STATE(867),
    [sym_typed_expression] = STATE(867),
    [sym_declaration_expression] = STATE(867),
    [sym_do_expression] = STATE(867),
    [sym_list_expression] = STATE(867),
    [sym_array_expression] = STATE(867),
    [sym_begin_end_expression] = STATE(867),
    [sym_paren_expression] = STATE(867),
    [sym__high_prec_app] = STATE(864),
    [sym__low_prec_app] = STATE(864),
    [sym_application_expression] = STATE(867),
    [sym_dot_expression] = STATE(867),
    [sym_infix_expression] = STATE(867),
    [sym_ce_expression] = STATE(867),
    [sym_sequential_expression] = STATE(867),
    [sym_char] = STATE(868),
    [sym_format_string] = STATE(869),
    [sym__string_literal] = STATE(869),
    [sym_string] = STATE(868),
    [sym_verbatim_string] = STATE(868),
    [sym_bytearray] = STATE(868),
    [sym_verbatim_bytearray] = STATE(868),
    [sym_format_triple_quoted_string] = STATE(870),
    [sym_triple_quoted_string] = STATE(868),
    [sym_const] = STATE(867),
    [sym_long_identifier] = STATE(872),
    [sym_active_pattern] = STATE(871),
    [sym__identifier_or_op] = STATE(873),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(658),
    [sym_sbyte] = STATE(868),
    [sym_byte] = STATE(868),
    [sym_int16] = STATE(868),
    [sym_uint16] = STATE(868),
    [sym_int32] = STATE(868),
    [sym_uint32] = STATE(868),
    [sym_nativeint] = STATE(868),
    [sym_unativeint] = STATE(868),
    [sym_int64] = STATE(868),
    [sym_uint64] = STATE(868),
    [sym_ieee32] = STATE(868),
    [sym_ieee64] = STATE(868),
    [sym_bignum] = STATE(868),
    [sym_decimal] = STATE(868),
    [sym_float] = STATE(860),
    [sym_block_comment] = STATE(448),
    [sym_compiler_directive_decl] = STATE(448),
    [sym_fsi_directive_decl] = STATE(448),
    [sym_preproc_line] = STATE(448),
    [sym_preproc_if_in_expression] = STATE(867),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(29),
    [anon_sym_return] = ACTIONS(37),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_null] = ACTIONS(49),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACK_PIPE] = ACTIONS(57),
    [anon_sym_LBRACE] = ACTIONS(1663),
    [anon_sym_LT_AT] = ACTIONS(61),
    [anon_sym_LT_AT_AT] = ACTIONS(1665),
    [anon_sym_LBRACE_PIPE] = ACTIONS(67),
    [anon_sym_new] = ACTIONS(37),
    [anon_sym_return_BANG] = ACTIONS(69),
    [anon_sym_yield] = ACTIONS(37),
    [anon_sym_yield_BANG] = ACTIONS(69),
    [anon_sym_lazy] = ACTIONS(37),
    [anon_sym_assert] = ACTIONS(37),
    [anon_sym_upcast] = ACTIONS(37),
    [anon_sym_downcast] = ACTIONS(37),
    [anon_sym_for] = ACTIONS(73),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(79),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_match] = ACTIONS(83),
    [anon_sym_match_BANG] = ACTIONS(85),
    [anon_sym_function] = ACTIONS(87),
    [anon_sym_use] = ACTIONS(95),
    [anon_sym_use_BANG] = ACTIONS(97),
    [anon_sym_do_BANG] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(101),
    [aux_sym_char_token1] = ACTIONS(105),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(107),
    [anon_sym_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DQUOTE] = ACTIONS(111),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(115),
    [sym_bool] = ACTIONS(117),
    [sym_unit] = ACTIONS(1673),
    [anon_sym_LPAREN_PIPE] = ACTIONS(121),
    [sym_op_identifier] = ACTIONS(1675),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(129),
    [sym_xint] = ACTIONS(131),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(135),
    [sym__tuple_marker] = ACTIONS(2084),
  },
  [449] = {
    [sym_function_or_value_defn] = STATE(627),
    [sym__expression] = STATE(21),
    [sym_literal_expression] = STATE(1118),
    [sym_long_identifier_or_op] = STATE(1118),
    [sym_tuple_expression] = STATE(1118),
    [sym_brace_expression] = STATE(1118),
    [sym_anon_record_expression] = STATE(1118),
    [sym_prefixed_expression] = STATE(1118),
    [sym_typecast_expression] = STATE(1118),
    [sym_for_expression] = STATE(1118),
    [sym_while_expression] = STATE(1118),
    [sym__if_branch] = STATE(7163),
    [sym_if_expression] = STATE(1118),
    [sym_fun_expression] = STATE(1118),
    [sym_try_expression] = STATE(1118),
    [sym_match_expression] = STATE(1118),
    [sym_function_expression] = STATE(1118),
    [sym_mutate_expression] = STATE(1118),
    [sym_index_expression] = STATE(1118),
    [sym_typed_expression] = STATE(1118),
    [sym_declaration_expression] = STATE(1118),
    [sym_do_expression] = STATE(1118),
    [sym_list_expression] = STATE(1118),
    [sym_array_expression] = STATE(1118),
    [sym_begin_end_expression] = STATE(1118),
    [sym_paren_expression] = STATE(1118),
    [sym__high_prec_app] = STATE(1133),
    [sym__low_prec_app] = STATE(1133),
    [sym_application_expression] = STATE(1118),
    [sym_dot_expression] = STATE(1118),
    [sym_infix_expression] = STATE(1118),
    [sym_ce_expression] = STATE(1118),
    [sym_sequential_expression] = STATE(1118),
    [sym_char] = STATE(1080),
    [sym_format_string] = STATE(1090),
    [sym__string_literal] = STATE(1090),
    [sym_string] = STATE(1080),
    [sym_verbatim_string] = STATE(1080),
    [sym_bytearray] = STATE(1080),
    [sym_verbatim_bytearray] = STATE(1080),
    [sym_format_triple_quoted_string] = STATE(1096),
    [sym_triple_quoted_string] = STATE(1080),
    [sym_const] = STATE(1118),
    [sym_long_identifier] = STATE(1156),
    [sym_active_pattern] = STATE(1085),
    [sym__identifier_or_op] = STATE(1099),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(517),
    [sym_sbyte] = STATE(1080),
    [sym_byte] = STATE(1080),
    [sym_int16] = STATE(1080),
    [sym_uint16] = STATE(1080),
    [sym_int32] = STATE(1080),
    [sym_uint32] = STATE(1080),
    [sym_nativeint] = STATE(1080),
    [sym_unativeint] = STATE(1080),
    [sym_int64] = STATE(1080),
    [sym_uint64] = STATE(1080),
    [sym_ieee32] = STATE(1080),
    [sym_ieee64] = STATE(1080),
    [sym_bignum] = STATE(1080),
    [sym_decimal] = STATE(1080),
    [sym_float] = STATE(979),
    [sym_block_comment] = STATE(449),
    [sym_compiler_directive_decl] = STATE(449),
    [sym_fsi_directive_decl] = STATE(449),
    [sym_preproc_line] = STATE(449),
    [sym_preproc_if_in_expression] = STATE(1118),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(195),
    [anon_sym_return] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_null] = ACTIONS(207),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(209),
    [anon_sym_LBRACK_PIPE] = ACTIONS(211),
    [anon_sym_LBRACE] = ACTIONS(1687),
    [anon_sym_LT_AT] = ACTIONS(213),
    [anon_sym_LT_AT_AT] = ACTIONS(1689),
    [anon_sym_LBRACE_PIPE] = ACTIONS(217),
    [anon_sym_new] = ACTIONS(199),
    [anon_sym_with] = ACTIONS(2086),
    [anon_sym_return_BANG] = ACTIONS(219),
    [anon_sym_yield] = ACTIONS(199),
    [anon_sym_yield_BANG] = ACTIONS(219),
    [anon_sym_lazy] = ACTIONS(199),
    [anon_sym_assert] = ACTIONS(199),
    [anon_sym_upcast] = ACTIONS(199),
    [anon_sym_downcast] = ACTIONS(199),
    [anon_sym_for] = ACTIONS(223),
    [anon_sym_while] = ACTIONS(225),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(229),
    [anon_sym_match] = ACTIONS(231),
    [anon_sym_match_BANG] = ACTIONS(233),
    [anon_sym_function] = ACTIONS(235),
    [anon_sym_use] = ACTIONS(239),
    [anon_sym_use_BANG] = ACTIONS(241),
    [anon_sym_do_BANG] = ACTIONS(243),
    [anon_sym_begin] = ACTIONS(245),
    [aux_sym_char_token1] = ACTIONS(247),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(251),
    [anon_sym_AT_DQUOTE] = ACTIONS(253),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(255),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(257),
    [sym_bool] = ACTIONS(259),
    [sym_unit] = ACTIONS(1699),
    [anon_sym_LPAREN_PIPE] = ACTIONS(261),
    [sym_op_identifier] = ACTIONS(1701),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(265),
    [sym_xint] = ACTIONS(267),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(269),
  },
  [450] = {
    [sym_function_or_value_defn] = STATE(509),
    [sym__expression] = STATE(276),
    [sym_literal_expression] = STATE(2230),
    [sym_long_identifier_or_op] = STATE(2230),
    [sym_tuple_expression] = STATE(2230),
    [sym_brace_expression] = STATE(2230),
    [sym_anon_record_expression] = STATE(2230),
    [sym_prefixed_expression] = STATE(2230),
    [sym_typecast_expression] = STATE(2230),
    [sym_for_expression] = STATE(2230),
    [sym_while_expression] = STATE(2230),
    [sym__if_branch] = STATE(6659),
    [sym_if_expression] = STATE(2230),
    [sym_fun_expression] = STATE(2230),
    [sym_try_expression] = STATE(2230),
    [sym_match_expression] = STATE(2230),
    [sym_function_expression] = STATE(2230),
    [sym_mutate_expression] = STATE(2230),
    [sym_index_expression] = STATE(2230),
    [sym_typed_expression] = STATE(2230),
    [sym_declaration_expression] = STATE(2230),
    [sym_do_expression] = STATE(2230),
    [sym_list_expression] = STATE(2230),
    [sym_array_expression] = STATE(2230),
    [sym_range_expression] = STATE(6536),
    [sym_begin_end_expression] = STATE(2230),
    [sym_paren_expression] = STATE(2230),
    [sym__high_prec_app] = STATE(2229),
    [sym__low_prec_app] = STATE(2229),
    [sym_application_expression] = STATE(2230),
    [sym_dot_expression] = STATE(2230),
    [sym_infix_expression] = STATE(2230),
    [sym_ce_expression] = STATE(2230),
    [sym_sequential_expression] = STATE(2230),
    [sym_char] = STATE(2100),
    [sym_format_string] = STATE(2106),
    [sym__string_literal] = STATE(2106),
    [sym_string] = STATE(2100),
    [sym_verbatim_string] = STATE(2100),
    [sym_bytearray] = STATE(2100),
    [sym_verbatim_bytearray] = STATE(2100),
    [sym_format_triple_quoted_string] = STATE(2107),
    [sym_triple_quoted_string] = STATE(2100),
    [sym_const] = STATE(2230),
    [sym_long_identifier] = STATE(2232),
    [sym_active_pattern] = STATE(2424),
    [sym__identifier_or_op] = STATE(2305),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(737),
    [sym_sbyte] = STATE(2100),
    [sym_byte] = STATE(2100),
    [sym_int16] = STATE(2100),
    [sym_uint16] = STATE(2100),
    [sym_int32] = STATE(2100),
    [sym_uint32] = STATE(2100),
    [sym_nativeint] = STATE(2100),
    [sym_unativeint] = STATE(2100),
    [sym_int64] = STATE(2100),
    [sym_uint64] = STATE(2100),
    [sym_ieee32] = STATE(2100),
    [sym_ieee64] = STATE(2100),
    [sym_bignum] = STATE(2100),
    [sym_decimal] = STATE(2100),
    [sym_float] = STATE(1487),
    [sym_block_comment] = STATE(450),
    [sym_compiler_directive_decl] = STATE(450),
    [sym_fsi_directive_decl] = STATE(450),
    [sym_preproc_line] = STATE(450),
    [sym_preproc_if_in_expression] = STATE(2230),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(877),
    [anon_sym_return] = ACTIONS(881),
    [anon_sym_do] = ACTIONS(1585),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(885),
    [anon_sym_null] = ACTIONS(889),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(891),
    [anon_sym_LBRACK_PIPE] = ACTIONS(893),
    [anon_sym_LBRACE] = ACTIONS(2048),
    [anon_sym_LT_AT] = ACTIONS(897),
    [anon_sym_LT_AT_AT] = ACTIONS(2050),
    [anon_sym_LBRACE_PIPE] = ACTIONS(903),
    [anon_sym_new] = ACTIONS(881),
    [anon_sym_return_BANG] = ACTIONS(905),
    [anon_sym_yield] = ACTIONS(881),
    [anon_sym_yield_BANG] = ACTIONS(905),
    [anon_sym_lazy] = ACTIONS(881),
    [anon_sym_assert] = ACTIONS(881),
    [anon_sym_upcast] = ACTIONS(881),
    [anon_sym_downcast] = ACTIONS(881),
    [anon_sym_for] = ACTIONS(909),
    [anon_sym_while] = ACTIONS(911),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(913),
    [anon_sym_try] = ACTIONS(915),
    [anon_sym_match] = ACTIONS(917),
    [anon_sym_match_BANG] = ACTIONS(919),
    [anon_sym_function] = ACTIONS(921),
    [anon_sym_use] = ACTIONS(929),
    [anon_sym_use_BANG] = ACTIONS(931),
    [anon_sym_do_BANG] = ACTIONS(933),
    [anon_sym_begin] = ACTIONS(937),
    [aux_sym_char_token1] = ACTIONS(941),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(943),
    [anon_sym_DQUOTE] = ACTIONS(945),
    [anon_sym_AT_DQUOTE] = ACTIONS(947),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(949),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(951),
    [sym_bool] = ACTIONS(953),
    [sym_unit] = ACTIONS(2052),
    [anon_sym_LPAREN_PIPE] = ACTIONS(957),
    [sym_op_identifier] = ACTIONS(2054),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(961),
    [sym_xint] = ACTIONS(963),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(965),
  },
  [451] = {
    [sym_function_or_value_defn] = STATE(704),
    [sym__expression] = STATE(295),
    [sym_literal_expression] = STATE(2403),
    [sym_long_identifier_or_op] = STATE(2403),
    [sym_tuple_expression] = STATE(2403),
    [sym_brace_expression] = STATE(2403),
    [sym_anon_record_expression] = STATE(2403),
    [sym_prefixed_expression] = STATE(2403),
    [sym_typecast_expression] = STATE(2403),
    [sym_for_expression] = STATE(2403),
    [sym_while_expression] = STATE(2403),
    [sym__if_branch] = STATE(6794),
    [sym_if_expression] = STATE(2403),
    [sym_fun_expression] = STATE(2403),
    [sym_try_expression] = STATE(2403),
    [sym_match_expression] = STATE(2403),
    [sym_function_expression] = STATE(2403),
    [sym_mutate_expression] = STATE(2403),
    [sym_index_expression] = STATE(2403),
    [sym_typed_expression] = STATE(2403),
    [sym_declaration_expression] = STATE(2403),
    [sym_do_expression] = STATE(2403),
    [sym_list_expression] = STATE(2403),
    [sym_array_expression] = STATE(2403),
    [sym_begin_end_expression] = STATE(2403),
    [sym_paren_expression] = STATE(2403),
    [sym__high_prec_app] = STATE(2405),
    [sym__low_prec_app] = STATE(2405),
    [sym_application_expression] = STATE(2403),
    [sym_dot_expression] = STATE(2403),
    [sym_infix_expression] = STATE(2403),
    [sym_ce_expression] = STATE(2403),
    [sym_sequential_expression] = STATE(2403),
    [sym_char] = STATE(2425),
    [sym_format_string] = STATE(2420),
    [sym__string_literal] = STATE(2420),
    [sym_string] = STATE(2425),
    [sym_verbatim_string] = STATE(2425),
    [sym_bytearray] = STATE(2425),
    [sym_verbatim_bytearray] = STATE(2425),
    [sym_format_triple_quoted_string] = STATE(2419),
    [sym_triple_quoted_string] = STATE(2425),
    [sym_const] = STATE(2403),
    [sym_long_identifier] = STATE(2079),
    [sym_active_pattern] = STATE(2080),
    [sym__identifier_or_op] = STATE(2089),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(688),
    [sym_sbyte] = STATE(2425),
    [sym_byte] = STATE(2425),
    [sym_int16] = STATE(2425),
    [sym_uint16] = STATE(2425),
    [sym_int32] = STATE(2425),
    [sym_uint32] = STATE(2425),
    [sym_nativeint] = STATE(2425),
    [sym_unativeint] = STATE(2425),
    [sym_int64] = STATE(2425),
    [sym_uint64] = STATE(2425),
    [sym_ieee32] = STATE(2425),
    [sym_ieee64] = STATE(2425),
    [sym_bignum] = STATE(2425),
    [sym_decimal] = STATE(2425),
    [sym_float] = STATE(1511),
    [sym_block_comment] = STATE(451),
    [sym_compiler_directive_decl] = STATE(451),
    [sym_fsi_directive_decl] = STATE(451),
    [sym_preproc_line] = STATE(451),
    [sym_preproc_if_in_expression] = STATE(2403),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(1261),
    [anon_sym_return] = ACTIONS(1265),
    [anon_sym_do] = ACTIONS(1267),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(1269),
    [anon_sym_null] = ACTIONS(1273),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1275),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1277),
    [anon_sym_LBRACE] = ACTIONS(1909),
    [anon_sym_LT_AT] = ACTIONS(1281),
    [anon_sym_LT_AT_AT] = ACTIONS(1911),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1287),
    [anon_sym_new] = ACTIONS(1265),
    [anon_sym_return_BANG] = ACTIONS(1289),
    [anon_sym_yield] = ACTIONS(1265),
    [anon_sym_yield_BANG] = ACTIONS(1289),
    [anon_sym_lazy] = ACTIONS(1265),
    [anon_sym_assert] = ACTIONS(1265),
    [anon_sym_upcast] = ACTIONS(1265),
    [anon_sym_downcast] = ACTIONS(1265),
    [anon_sym_for] = ACTIONS(1293),
    [anon_sym_while] = ACTIONS(1295),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(1297),
    [anon_sym_try] = ACTIONS(1299),
    [anon_sym_match] = ACTIONS(1301),
    [anon_sym_match_BANG] = ACTIONS(1303),
    [anon_sym_function] = ACTIONS(1305),
    [anon_sym_use] = ACTIONS(1313),
    [anon_sym_use_BANG] = ACTIONS(1315),
    [anon_sym_do_BANG] = ACTIONS(1317),
    [anon_sym_begin] = ACTIONS(1319),
    [aux_sym_char_token1] = ACTIONS(1323),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1325),
    [anon_sym_DQUOTE] = ACTIONS(1327),
    [anon_sym_AT_DQUOTE] = ACTIONS(1329),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1331),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1333),
    [sym_bool] = ACTIONS(1335),
    [sym_unit] = ACTIONS(1913),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1339),
    [sym_op_identifier] = ACTIONS(1915),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(1343),
    [sym_xint] = ACTIONS(1345),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1347),
    [sym__tuple_marker] = ACTIONS(2088),
  },
  [452] = {
    [sym_function_or_value_defn] = STATE(663),
    [sym__expression] = STATE(72),
    [sym_literal_expression] = STATE(1118),
    [sym_long_identifier_or_op] = STATE(1118),
    [sym_tuple_expression] = STATE(1118),
    [sym_brace_expression] = STATE(1118),
    [sym_anon_record_expression] = STATE(1118),
    [sym_prefixed_expression] = STATE(1118),
    [sym_typecast_expression] = STATE(1118),
    [sym_for_expression] = STATE(1118),
    [sym_while_expression] = STATE(1118),
    [sym__if_branch] = STATE(7163),
    [sym_if_expression] = STATE(1118),
    [sym_fun_expression] = STATE(1118),
    [sym_try_expression] = STATE(1118),
    [sym_match_expression] = STATE(1118),
    [sym_function_expression] = STATE(1118),
    [sym_mutate_expression] = STATE(1118),
    [sym_index_expression] = STATE(1118),
    [sym_typed_expression] = STATE(1118),
    [sym_declaration_expression] = STATE(1118),
    [sym_do_expression] = STATE(1118),
    [sym_list_expression] = STATE(1118),
    [sym_array_expression] = STATE(1118),
    [sym_begin_end_expression] = STATE(1118),
    [sym_paren_expression] = STATE(1118),
    [sym__high_prec_app] = STATE(1133),
    [sym__low_prec_app] = STATE(1133),
    [sym_application_expression] = STATE(1118),
    [sym_dot_expression] = STATE(1118),
    [sym_infix_expression] = STATE(1118),
    [sym_ce_expression] = STATE(1118),
    [sym_sequential_expression] = STATE(1118),
    [sym_char] = STATE(1080),
    [sym_format_string] = STATE(1090),
    [sym__string_literal] = STATE(1090),
    [sym_string] = STATE(1080),
    [sym_verbatim_string] = STATE(1080),
    [sym_bytearray] = STATE(1080),
    [sym_verbatim_bytearray] = STATE(1080),
    [sym_format_triple_quoted_string] = STATE(1096),
    [sym_triple_quoted_string] = STATE(1080),
    [sym_const] = STATE(1118),
    [sym_long_identifier] = STATE(1156),
    [sym_active_pattern] = STATE(1085),
    [sym__identifier_or_op] = STATE(1099),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(548),
    [sym_sbyte] = STATE(1080),
    [sym_byte] = STATE(1080),
    [sym_int16] = STATE(1080),
    [sym_uint16] = STATE(1080),
    [sym_int32] = STATE(1080),
    [sym_uint32] = STATE(1080),
    [sym_nativeint] = STATE(1080),
    [sym_unativeint] = STATE(1080),
    [sym_int64] = STATE(1080),
    [sym_uint64] = STATE(1080),
    [sym_ieee32] = STATE(1080),
    [sym_ieee64] = STATE(1080),
    [sym_bignum] = STATE(1080),
    [sym_decimal] = STATE(1080),
    [sym_float] = STATE(979),
    [sym_block_comment] = STATE(452),
    [sym_compiler_directive_decl] = STATE(452),
    [sym_fsi_directive_decl] = STATE(452),
    [sym_preproc_line] = STATE(452),
    [sym_preproc_if_in_expression] = STATE(1118),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(195),
    [anon_sym_return] = ACTIONS(481),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_null] = ACTIONS(207),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(209),
    [anon_sym_LBRACK_PIPE] = ACTIONS(211),
    [anon_sym_LBRACE] = ACTIONS(1687),
    [anon_sym_LT_AT] = ACTIONS(213),
    [anon_sym_LT_AT_AT] = ACTIONS(1689),
    [anon_sym_LBRACE_PIPE] = ACTIONS(217),
    [anon_sym_new] = ACTIONS(481),
    [anon_sym_return_BANG] = ACTIONS(487),
    [anon_sym_yield] = ACTIONS(481),
    [anon_sym_yield_BANG] = ACTIONS(487),
    [anon_sym_lazy] = ACTIONS(481),
    [anon_sym_assert] = ACTIONS(481),
    [anon_sym_upcast] = ACTIONS(481),
    [anon_sym_downcast] = ACTIONS(481),
    [anon_sym_for] = ACTIONS(489),
    [anon_sym_while] = ACTIONS(225),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(229),
    [anon_sym_match] = ACTIONS(231),
    [anon_sym_match_BANG] = ACTIONS(233),
    [anon_sym_function] = ACTIONS(235),
    [anon_sym_use] = ACTIONS(493),
    [anon_sym_use_BANG] = ACTIONS(495),
    [anon_sym_do_BANG] = ACTIONS(243),
    [anon_sym_begin] = ACTIONS(245),
    [aux_sym_char_token1] = ACTIONS(247),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(251),
    [anon_sym_AT_DQUOTE] = ACTIONS(253),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(255),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(257),
    [sym_bool] = ACTIONS(259),
    [sym_unit] = ACTIONS(1699),
    [anon_sym_LPAREN_PIPE] = ACTIONS(261),
    [sym_op_identifier] = ACTIONS(1701),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(499),
    [sym_xint] = ACTIONS(267),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(269),
    [sym__tuple_marker] = ACTIONS(2090),
  },
  [453] = {
    [sym_function_or_value_defn] = STATE(627),
    [sym__expression] = STATE(21),
    [sym_literal_expression] = STATE(1118),
    [sym_long_identifier_or_op] = STATE(1118),
    [sym_tuple_expression] = STATE(1118),
    [sym_brace_expression] = STATE(1118),
    [sym_anon_record_expression] = STATE(1118),
    [sym_prefixed_expression] = STATE(1118),
    [sym_typecast_expression] = STATE(1118),
    [sym_for_expression] = STATE(1118),
    [sym_while_expression] = STATE(1118),
    [sym__if_branch] = STATE(7163),
    [sym_if_expression] = STATE(1118),
    [sym_fun_expression] = STATE(1118),
    [sym_try_expression] = STATE(1118),
    [sym_match_expression] = STATE(1118),
    [sym_function_expression] = STATE(1118),
    [sym_mutate_expression] = STATE(1118),
    [sym_index_expression] = STATE(1118),
    [sym_typed_expression] = STATE(1118),
    [sym_declaration_expression] = STATE(1118),
    [sym_do_expression] = STATE(1118),
    [sym_list_expression] = STATE(1118),
    [sym_array_expression] = STATE(1118),
    [sym_begin_end_expression] = STATE(1118),
    [sym_paren_expression] = STATE(1118),
    [sym__high_prec_app] = STATE(1133),
    [sym__low_prec_app] = STATE(1133),
    [sym_application_expression] = STATE(1118),
    [sym_dot_expression] = STATE(1118),
    [sym_infix_expression] = STATE(1118),
    [sym_ce_expression] = STATE(1118),
    [sym_sequential_expression] = STATE(1118),
    [sym_char] = STATE(1080),
    [sym_format_string] = STATE(1090),
    [sym__string_literal] = STATE(1090),
    [sym_string] = STATE(1080),
    [sym_verbatim_string] = STATE(1080),
    [sym_bytearray] = STATE(1080),
    [sym_verbatim_bytearray] = STATE(1080),
    [sym_format_triple_quoted_string] = STATE(1096),
    [sym_triple_quoted_string] = STATE(1080),
    [sym_const] = STATE(1118),
    [sym_long_identifier] = STATE(1156),
    [sym_active_pattern] = STATE(1085),
    [sym__identifier_or_op] = STATE(1099),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(517),
    [sym_sbyte] = STATE(1080),
    [sym_byte] = STATE(1080),
    [sym_int16] = STATE(1080),
    [sym_uint16] = STATE(1080),
    [sym_int32] = STATE(1080),
    [sym_uint32] = STATE(1080),
    [sym_nativeint] = STATE(1080),
    [sym_unativeint] = STATE(1080),
    [sym_int64] = STATE(1080),
    [sym_uint64] = STATE(1080),
    [sym_ieee32] = STATE(1080),
    [sym_ieee64] = STATE(1080),
    [sym_bignum] = STATE(1080),
    [sym_decimal] = STATE(1080),
    [sym_float] = STATE(979),
    [sym_block_comment] = STATE(453),
    [sym_compiler_directive_decl] = STATE(453),
    [sym_fsi_directive_decl] = STATE(453),
    [sym_preproc_line] = STATE(453),
    [sym_preproc_if_in_expression] = STATE(1118),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(195),
    [anon_sym_return] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_null] = ACTIONS(207),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(209),
    [anon_sym_LBRACK_PIPE] = ACTIONS(211),
    [anon_sym_LBRACE] = ACTIONS(1687),
    [anon_sym_LT_AT] = ACTIONS(213),
    [anon_sym_LT_AT_AT] = ACTIONS(1689),
    [anon_sym_LBRACE_PIPE] = ACTIONS(217),
    [anon_sym_new] = ACTIONS(199),
    [anon_sym_with] = ACTIONS(2092),
    [anon_sym_return_BANG] = ACTIONS(219),
    [anon_sym_yield] = ACTIONS(199),
    [anon_sym_yield_BANG] = ACTIONS(219),
    [anon_sym_lazy] = ACTIONS(199),
    [anon_sym_assert] = ACTIONS(199),
    [anon_sym_upcast] = ACTIONS(199),
    [anon_sym_downcast] = ACTIONS(199),
    [anon_sym_for] = ACTIONS(223),
    [anon_sym_while] = ACTIONS(225),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(229),
    [anon_sym_match] = ACTIONS(231),
    [anon_sym_match_BANG] = ACTIONS(233),
    [anon_sym_function] = ACTIONS(235),
    [anon_sym_use] = ACTIONS(239),
    [anon_sym_use_BANG] = ACTIONS(241),
    [anon_sym_do_BANG] = ACTIONS(243),
    [anon_sym_begin] = ACTIONS(245),
    [aux_sym_char_token1] = ACTIONS(247),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(251),
    [anon_sym_AT_DQUOTE] = ACTIONS(253),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(255),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(257),
    [sym_bool] = ACTIONS(259),
    [sym_unit] = ACTIONS(1699),
    [anon_sym_LPAREN_PIPE] = ACTIONS(261),
    [sym_op_identifier] = ACTIONS(1701),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(265),
    [sym_xint] = ACTIONS(267),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(269),
  },
  [454] = {
    [sym_function_or_value_defn] = STATE(509),
    [sym__expression] = STATE(264),
    [sym_literal_expression] = STATE(2230),
    [sym_long_identifier_or_op] = STATE(2230),
    [sym_tuple_expression] = STATE(2230),
    [sym_brace_expression] = STATE(2230),
    [sym_anon_record_expression] = STATE(2230),
    [sym_prefixed_expression] = STATE(2230),
    [sym_typecast_expression] = STATE(2230),
    [sym_for_expression] = STATE(2230),
    [sym_while_expression] = STATE(2230),
    [sym__if_branch] = STATE(6659),
    [sym_if_expression] = STATE(2230),
    [sym_fun_expression] = STATE(2230),
    [sym_try_expression] = STATE(2230),
    [sym_match_expression] = STATE(2230),
    [sym_function_expression] = STATE(2230),
    [sym_mutate_expression] = STATE(2230),
    [sym_index_expression] = STATE(2230),
    [sym_typed_expression] = STATE(2230),
    [sym_declaration_expression] = STATE(2230),
    [sym_do_expression] = STATE(2230),
    [sym_list_expression] = STATE(2230),
    [sym_array_expression] = STATE(2230),
    [sym_range_expression] = STATE(6481),
    [sym_begin_end_expression] = STATE(2230),
    [sym_paren_expression] = STATE(2230),
    [sym__high_prec_app] = STATE(2229),
    [sym__low_prec_app] = STATE(2229),
    [sym_application_expression] = STATE(2230),
    [sym_dot_expression] = STATE(2230),
    [sym_infix_expression] = STATE(2230),
    [sym_ce_expression] = STATE(2230),
    [sym_sequential_expression] = STATE(2230),
    [sym_char] = STATE(2100),
    [sym_format_string] = STATE(2106),
    [sym__string_literal] = STATE(2106),
    [sym_string] = STATE(2100),
    [sym_verbatim_string] = STATE(2100),
    [sym_bytearray] = STATE(2100),
    [sym_verbatim_bytearray] = STATE(2100),
    [sym_format_triple_quoted_string] = STATE(2107),
    [sym_triple_quoted_string] = STATE(2100),
    [sym_const] = STATE(2230),
    [sym_long_identifier] = STATE(2232),
    [sym_active_pattern] = STATE(2424),
    [sym__identifier_or_op] = STATE(2305),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(737),
    [sym_sbyte] = STATE(2100),
    [sym_byte] = STATE(2100),
    [sym_int16] = STATE(2100),
    [sym_uint16] = STATE(2100),
    [sym_int32] = STATE(2100),
    [sym_uint32] = STATE(2100),
    [sym_nativeint] = STATE(2100),
    [sym_unativeint] = STATE(2100),
    [sym_int64] = STATE(2100),
    [sym_uint64] = STATE(2100),
    [sym_ieee32] = STATE(2100),
    [sym_ieee64] = STATE(2100),
    [sym_bignum] = STATE(2100),
    [sym_decimal] = STATE(2100),
    [sym_float] = STATE(1487),
    [sym_block_comment] = STATE(454),
    [sym_compiler_directive_decl] = STATE(454),
    [sym_fsi_directive_decl] = STATE(454),
    [sym_preproc_line] = STATE(454),
    [sym_preproc_if_in_expression] = STATE(2230),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(877),
    [anon_sym_return] = ACTIONS(881),
    [anon_sym_do] = ACTIONS(1585),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(885),
    [anon_sym_null] = ACTIONS(889),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(891),
    [anon_sym_LBRACK_PIPE] = ACTIONS(893),
    [anon_sym_LBRACE] = ACTIONS(2048),
    [anon_sym_LT_AT] = ACTIONS(897),
    [anon_sym_LT_AT_AT] = ACTIONS(2050),
    [anon_sym_LBRACE_PIPE] = ACTIONS(903),
    [anon_sym_new] = ACTIONS(881),
    [anon_sym_return_BANG] = ACTIONS(905),
    [anon_sym_yield] = ACTIONS(881),
    [anon_sym_yield_BANG] = ACTIONS(905),
    [anon_sym_lazy] = ACTIONS(881),
    [anon_sym_assert] = ACTIONS(881),
    [anon_sym_upcast] = ACTIONS(881),
    [anon_sym_downcast] = ACTIONS(881),
    [anon_sym_for] = ACTIONS(909),
    [anon_sym_while] = ACTIONS(911),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(913),
    [anon_sym_try] = ACTIONS(915),
    [anon_sym_match] = ACTIONS(917),
    [anon_sym_match_BANG] = ACTIONS(919),
    [anon_sym_function] = ACTIONS(921),
    [anon_sym_use] = ACTIONS(929),
    [anon_sym_use_BANG] = ACTIONS(931),
    [anon_sym_do_BANG] = ACTIONS(933),
    [anon_sym_begin] = ACTIONS(937),
    [aux_sym_char_token1] = ACTIONS(941),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(943),
    [anon_sym_DQUOTE] = ACTIONS(945),
    [anon_sym_AT_DQUOTE] = ACTIONS(947),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(949),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(951),
    [sym_bool] = ACTIONS(953),
    [sym_unit] = ACTIONS(2052),
    [anon_sym_LPAREN_PIPE] = ACTIONS(957),
    [sym_op_identifier] = ACTIONS(2054),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(961),
    [sym_xint] = ACTIONS(963),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(965),
  },
  [455] = {
    [sym_function_or_value_defn] = STATE(509),
    [sym__expression] = STATE(303),
    [sym_literal_expression] = STATE(2230),
    [sym_long_identifier_or_op] = STATE(2230),
    [sym_tuple_expression] = STATE(2230),
    [sym_brace_expression] = STATE(2230),
    [sym_anon_record_expression] = STATE(2230),
    [sym_prefixed_expression] = STATE(2230),
    [sym_typecast_expression] = STATE(2230),
    [sym_for_expression] = STATE(2230),
    [sym_while_expression] = STATE(2230),
    [sym__if_branch] = STATE(6659),
    [sym_if_expression] = STATE(2230),
    [sym_fun_expression] = STATE(2230),
    [sym_try_expression] = STATE(2230),
    [sym_match_expression] = STATE(2230),
    [sym_function_expression] = STATE(2230),
    [sym_mutate_expression] = STATE(2230),
    [sym_index_expression] = STATE(2230),
    [sym_typed_expression] = STATE(2230),
    [sym_declaration_expression] = STATE(2230),
    [sym_do_expression] = STATE(2230),
    [sym_list_expression] = STATE(2230),
    [sym_array_expression] = STATE(2230),
    [sym_begin_end_expression] = STATE(2230),
    [sym_paren_expression] = STATE(2230),
    [sym__high_prec_app] = STATE(2229),
    [sym__low_prec_app] = STATE(2229),
    [sym_application_expression] = STATE(2230),
    [sym_dot_expression] = STATE(2230),
    [sym_infix_expression] = STATE(2230),
    [sym_ce_expression] = STATE(2230),
    [sym_sequential_expression] = STATE(2230),
    [sym_char] = STATE(2100),
    [sym_format_string] = STATE(2106),
    [sym__string_literal] = STATE(2106),
    [sym_string] = STATE(2100),
    [sym_verbatim_string] = STATE(2100),
    [sym_bytearray] = STATE(2100),
    [sym_verbatim_bytearray] = STATE(2100),
    [sym_format_triple_quoted_string] = STATE(2107),
    [sym_triple_quoted_string] = STATE(2100),
    [sym_const] = STATE(2230),
    [sym_long_identifier] = STATE(2232),
    [sym_active_pattern] = STATE(2424),
    [sym__identifier_or_op] = STATE(2305),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(737),
    [sym_sbyte] = STATE(2100),
    [sym_byte] = STATE(2100),
    [sym_int16] = STATE(2100),
    [sym_uint16] = STATE(2100),
    [sym_int32] = STATE(2100),
    [sym_uint32] = STATE(2100),
    [sym_nativeint] = STATE(2100),
    [sym_unativeint] = STATE(2100),
    [sym_int64] = STATE(2100),
    [sym_uint64] = STATE(2100),
    [sym_ieee32] = STATE(2100),
    [sym_ieee64] = STATE(2100),
    [sym_bignum] = STATE(2100),
    [sym_decimal] = STATE(2100),
    [sym_float] = STATE(1487),
    [sym_block_comment] = STATE(455),
    [sym_compiler_directive_decl] = STATE(455),
    [sym_fsi_directive_decl] = STATE(455),
    [sym_preproc_line] = STATE(455),
    [sym_preproc_if_in_expression] = STATE(2230),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(877),
    [anon_sym_return] = ACTIONS(881),
    [anon_sym_do] = ACTIONS(1585),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(885),
    [anon_sym_null] = ACTIONS(889),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(891),
    [anon_sym_LBRACK_PIPE] = ACTIONS(893),
    [anon_sym_LBRACE] = ACTIONS(2048),
    [anon_sym_LT_AT] = ACTIONS(897),
    [anon_sym_LT_AT_AT] = ACTIONS(2050),
    [anon_sym_LBRACE_PIPE] = ACTIONS(903),
    [anon_sym_new] = ACTIONS(881),
    [anon_sym_return_BANG] = ACTIONS(905),
    [anon_sym_yield] = ACTIONS(881),
    [anon_sym_yield_BANG] = ACTIONS(905),
    [anon_sym_lazy] = ACTIONS(881),
    [anon_sym_assert] = ACTIONS(881),
    [anon_sym_upcast] = ACTIONS(881),
    [anon_sym_downcast] = ACTIONS(881),
    [anon_sym_for] = ACTIONS(909),
    [anon_sym_while] = ACTIONS(911),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(913),
    [anon_sym_try] = ACTIONS(915),
    [anon_sym_match] = ACTIONS(917),
    [anon_sym_match_BANG] = ACTIONS(919),
    [anon_sym_function] = ACTIONS(921),
    [anon_sym_use] = ACTIONS(929),
    [anon_sym_use_BANG] = ACTIONS(931),
    [anon_sym_do_BANG] = ACTIONS(933),
    [anon_sym_begin] = ACTIONS(937),
    [aux_sym_char_token1] = ACTIONS(941),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(943),
    [anon_sym_DQUOTE] = ACTIONS(945),
    [anon_sym_AT_DQUOTE] = ACTIONS(947),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(949),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(951),
    [sym_bool] = ACTIONS(953),
    [sym_unit] = ACTIONS(2052),
    [anon_sym_LPAREN_PIPE] = ACTIONS(957),
    [sym_op_identifier] = ACTIONS(2054),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(961),
    [sym_xint] = ACTIONS(963),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(965),
    [sym__tuple_marker] = ACTIONS(2094),
  },
  [456] = {
    [sym_function_or_value_defn] = STATE(509),
    [sym__expression] = STATE(286),
    [sym_literal_expression] = STATE(2230),
    [sym_long_identifier_or_op] = STATE(2230),
    [sym_tuple_expression] = STATE(2230),
    [sym_brace_expression] = STATE(2230),
    [sym_anon_record_expression] = STATE(2230),
    [sym_prefixed_expression] = STATE(2230),
    [sym_typecast_expression] = STATE(2230),
    [sym_for_expression] = STATE(2230),
    [sym_while_expression] = STATE(2230),
    [sym__if_branch] = STATE(6659),
    [sym_if_expression] = STATE(2230),
    [sym_fun_expression] = STATE(2230),
    [sym_try_expression] = STATE(2230),
    [sym_match_expression] = STATE(2230),
    [sym_function_expression] = STATE(2230),
    [sym_mutate_expression] = STATE(2230),
    [sym_index_expression] = STATE(2230),
    [sym_typed_expression] = STATE(2230),
    [sym_declaration_expression] = STATE(2230),
    [sym_do_expression] = STATE(2230),
    [sym_list_expression] = STATE(2230),
    [sym_array_expression] = STATE(2230),
    [sym_range_expression] = STATE(6586),
    [sym_begin_end_expression] = STATE(2230),
    [sym_paren_expression] = STATE(2230),
    [sym__high_prec_app] = STATE(2229),
    [sym__low_prec_app] = STATE(2229),
    [sym_application_expression] = STATE(2230),
    [sym_dot_expression] = STATE(2230),
    [sym_infix_expression] = STATE(2230),
    [sym_ce_expression] = STATE(2230),
    [sym_sequential_expression] = STATE(2230),
    [sym_char] = STATE(2100),
    [sym_format_string] = STATE(2106),
    [sym__string_literal] = STATE(2106),
    [sym_string] = STATE(2100),
    [sym_verbatim_string] = STATE(2100),
    [sym_bytearray] = STATE(2100),
    [sym_verbatim_bytearray] = STATE(2100),
    [sym_format_triple_quoted_string] = STATE(2107),
    [sym_triple_quoted_string] = STATE(2100),
    [sym_const] = STATE(2230),
    [sym_long_identifier] = STATE(2232),
    [sym_active_pattern] = STATE(2424),
    [sym__identifier_or_op] = STATE(2305),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(737),
    [sym_sbyte] = STATE(2100),
    [sym_byte] = STATE(2100),
    [sym_int16] = STATE(2100),
    [sym_uint16] = STATE(2100),
    [sym_int32] = STATE(2100),
    [sym_uint32] = STATE(2100),
    [sym_nativeint] = STATE(2100),
    [sym_unativeint] = STATE(2100),
    [sym_int64] = STATE(2100),
    [sym_uint64] = STATE(2100),
    [sym_ieee32] = STATE(2100),
    [sym_ieee64] = STATE(2100),
    [sym_bignum] = STATE(2100),
    [sym_decimal] = STATE(2100),
    [sym_float] = STATE(1487),
    [sym_block_comment] = STATE(456),
    [sym_compiler_directive_decl] = STATE(456),
    [sym_fsi_directive_decl] = STATE(456),
    [sym_preproc_line] = STATE(456),
    [sym_preproc_if_in_expression] = STATE(2230),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(877),
    [anon_sym_return] = ACTIONS(881),
    [anon_sym_do] = ACTIONS(1585),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(885),
    [anon_sym_null] = ACTIONS(889),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(891),
    [anon_sym_LBRACK_PIPE] = ACTIONS(893),
    [anon_sym_LBRACE] = ACTIONS(2048),
    [anon_sym_LT_AT] = ACTIONS(897),
    [anon_sym_LT_AT_AT] = ACTIONS(2050),
    [anon_sym_LBRACE_PIPE] = ACTIONS(903),
    [anon_sym_new] = ACTIONS(881),
    [anon_sym_return_BANG] = ACTIONS(905),
    [anon_sym_yield] = ACTIONS(881),
    [anon_sym_yield_BANG] = ACTIONS(905),
    [anon_sym_lazy] = ACTIONS(881),
    [anon_sym_assert] = ACTIONS(881),
    [anon_sym_upcast] = ACTIONS(881),
    [anon_sym_downcast] = ACTIONS(881),
    [anon_sym_for] = ACTIONS(909),
    [anon_sym_while] = ACTIONS(911),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(913),
    [anon_sym_try] = ACTIONS(915),
    [anon_sym_match] = ACTIONS(917),
    [anon_sym_match_BANG] = ACTIONS(919),
    [anon_sym_function] = ACTIONS(921),
    [anon_sym_use] = ACTIONS(929),
    [anon_sym_use_BANG] = ACTIONS(931),
    [anon_sym_do_BANG] = ACTIONS(933),
    [anon_sym_begin] = ACTIONS(937),
    [aux_sym_char_token1] = ACTIONS(941),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(943),
    [anon_sym_DQUOTE] = ACTIONS(945),
    [anon_sym_AT_DQUOTE] = ACTIONS(947),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(949),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(951),
    [sym_bool] = ACTIONS(953),
    [sym_unit] = ACTIONS(2052),
    [anon_sym_LPAREN_PIPE] = ACTIONS(957),
    [sym_op_identifier] = ACTIONS(2054),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(961),
    [sym_xint] = ACTIONS(963),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(965),
  },
  [457] = {
    [sym_function_or_value_defn] = STATE(627),
    [sym__expression] = STATE(21),
    [sym_literal_expression] = STATE(1118),
    [sym_long_identifier_or_op] = STATE(1118),
    [sym_tuple_expression] = STATE(1118),
    [sym_brace_expression] = STATE(1118),
    [sym_anon_record_expression] = STATE(1118),
    [sym_prefixed_expression] = STATE(1118),
    [sym_typecast_expression] = STATE(1118),
    [sym_for_expression] = STATE(1118),
    [sym_while_expression] = STATE(1118),
    [sym__if_branch] = STATE(7163),
    [sym_if_expression] = STATE(1118),
    [sym_fun_expression] = STATE(1118),
    [sym_try_expression] = STATE(1118),
    [sym_match_expression] = STATE(1118),
    [sym_function_expression] = STATE(1118),
    [sym_mutate_expression] = STATE(1118),
    [sym_index_expression] = STATE(1118),
    [sym_typed_expression] = STATE(1118),
    [sym_declaration_expression] = STATE(1118),
    [sym_do_expression] = STATE(1118),
    [sym_list_expression] = STATE(1118),
    [sym_array_expression] = STATE(1118),
    [sym_begin_end_expression] = STATE(1118),
    [sym_paren_expression] = STATE(1118),
    [sym__high_prec_app] = STATE(1133),
    [sym__low_prec_app] = STATE(1133),
    [sym_application_expression] = STATE(1118),
    [sym_dot_expression] = STATE(1118),
    [sym_infix_expression] = STATE(1118),
    [sym_ce_expression] = STATE(1118),
    [sym_sequential_expression] = STATE(1118),
    [sym_char] = STATE(1080),
    [sym_format_string] = STATE(1090),
    [sym__string_literal] = STATE(1090),
    [sym_string] = STATE(1080),
    [sym_verbatim_string] = STATE(1080),
    [sym_bytearray] = STATE(1080),
    [sym_verbatim_bytearray] = STATE(1080),
    [sym_format_triple_quoted_string] = STATE(1096),
    [sym_triple_quoted_string] = STATE(1080),
    [sym_const] = STATE(1118),
    [sym_long_identifier] = STATE(1156),
    [sym_active_pattern] = STATE(1085),
    [sym__identifier_or_op] = STATE(1099),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(517),
    [sym_sbyte] = STATE(1080),
    [sym_byte] = STATE(1080),
    [sym_int16] = STATE(1080),
    [sym_uint16] = STATE(1080),
    [sym_int32] = STATE(1080),
    [sym_uint32] = STATE(1080),
    [sym_nativeint] = STATE(1080),
    [sym_unativeint] = STATE(1080),
    [sym_int64] = STATE(1080),
    [sym_uint64] = STATE(1080),
    [sym_ieee32] = STATE(1080),
    [sym_ieee64] = STATE(1080),
    [sym_bignum] = STATE(1080),
    [sym_decimal] = STATE(1080),
    [sym_float] = STATE(979),
    [sym_block_comment] = STATE(457),
    [sym_compiler_directive_decl] = STATE(457),
    [sym_fsi_directive_decl] = STATE(457),
    [sym_preproc_line] = STATE(457),
    [sym_preproc_if_in_expression] = STATE(1118),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(195),
    [anon_sym_return] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_null] = ACTIONS(207),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(209),
    [anon_sym_LBRACK_PIPE] = ACTIONS(211),
    [anon_sym_LBRACE] = ACTIONS(1687),
    [anon_sym_LT_AT] = ACTIONS(213),
    [anon_sym_LT_AT_AT] = ACTIONS(1689),
    [anon_sym_LBRACE_PIPE] = ACTIONS(217),
    [anon_sym_new] = ACTIONS(199),
    [anon_sym_with] = ACTIONS(2096),
    [anon_sym_return_BANG] = ACTIONS(219),
    [anon_sym_yield] = ACTIONS(199),
    [anon_sym_yield_BANG] = ACTIONS(219),
    [anon_sym_lazy] = ACTIONS(199),
    [anon_sym_assert] = ACTIONS(199),
    [anon_sym_upcast] = ACTIONS(199),
    [anon_sym_downcast] = ACTIONS(199),
    [anon_sym_for] = ACTIONS(223),
    [anon_sym_while] = ACTIONS(225),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(229),
    [anon_sym_match] = ACTIONS(231),
    [anon_sym_match_BANG] = ACTIONS(233),
    [anon_sym_function] = ACTIONS(235),
    [anon_sym_use] = ACTIONS(239),
    [anon_sym_use_BANG] = ACTIONS(241),
    [anon_sym_do_BANG] = ACTIONS(243),
    [anon_sym_begin] = ACTIONS(245),
    [aux_sym_char_token1] = ACTIONS(247),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(251),
    [anon_sym_AT_DQUOTE] = ACTIONS(253),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(255),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(257),
    [sym_bool] = ACTIONS(259),
    [sym_unit] = ACTIONS(1699),
    [anon_sym_LPAREN_PIPE] = ACTIONS(261),
    [sym_op_identifier] = ACTIONS(1701),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(265),
    [sym_xint] = ACTIONS(267),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(269),
  },
  [458] = {
    [sym_function_or_value_defn] = STATE(535),
    [sym__expression] = STATE(97),
    [sym_literal_expression] = STATE(2008),
    [sym_long_identifier_or_op] = STATE(2008),
    [sym_tuple_expression] = STATE(2008),
    [sym_brace_expression] = STATE(2008),
    [sym_anon_record_expression] = STATE(2008),
    [sym_prefixed_expression] = STATE(2008),
    [sym_typecast_expression] = STATE(2008),
    [sym_for_expression] = STATE(2008),
    [sym_while_expression] = STATE(2008),
    [sym__if_branch] = STATE(6754),
    [sym_if_expression] = STATE(2008),
    [sym_fun_expression] = STATE(2008),
    [sym_try_expression] = STATE(2008),
    [sym_match_expression] = STATE(2008),
    [sym_function_expression] = STATE(2008),
    [sym_mutate_expression] = STATE(2008),
    [sym_index_expression] = STATE(2008),
    [sym_typed_expression] = STATE(2008),
    [sym_declaration_expression] = STATE(2008),
    [sym_do_expression] = STATE(2008),
    [sym_list_expression] = STATE(2008),
    [sym_array_expression] = STATE(2008),
    [sym_range_expression] = STATE(6013),
    [sym_begin_end_expression] = STATE(2008),
    [sym_paren_expression] = STATE(2008),
    [sym__high_prec_app] = STATE(2007),
    [sym__low_prec_app] = STATE(2007),
    [sym_application_expression] = STATE(2008),
    [sym_dot_expression] = STATE(2008),
    [sym_infix_expression] = STATE(2008),
    [sym_ce_expression] = STATE(2008),
    [sym_sequential_expression] = STATE(2008),
    [sym_char] = STATE(1859),
    [sym_format_string] = STATE(1861),
    [sym__string_literal] = STATE(1861),
    [sym_string] = STATE(1859),
    [sym_verbatim_string] = STATE(1859),
    [sym_bytearray] = STATE(1859),
    [sym_verbatim_bytearray] = STATE(1859),
    [sym_format_triple_quoted_string] = STATE(1862),
    [sym_triple_quoted_string] = STATE(1859),
    [sym_const] = STATE(2008),
    [sym_long_identifier] = STATE(1701),
    [sym_active_pattern] = STATE(1702),
    [sym__identifier_or_op] = STATE(1724),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(664),
    [sym_sbyte] = STATE(1859),
    [sym_byte] = STATE(1859),
    [sym_int16] = STATE(1859),
    [sym_uint16] = STATE(1859),
    [sym_int32] = STATE(1859),
    [sym_uint32] = STATE(1859),
    [sym_nativeint] = STATE(1859),
    [sym_unativeint] = STATE(1859),
    [sym_int64] = STATE(1859),
    [sym_uint64] = STATE(1859),
    [sym_ieee32] = STATE(1859),
    [sym_ieee64] = STATE(1859),
    [sym_bignum] = STATE(1859),
    [sym_decimal] = STATE(1859),
    [sym_float] = STATE(1447),
    [sym_block_comment] = STATE(458),
    [sym_compiler_directive_decl] = STATE(458),
    [sym_fsi_directive_decl] = STATE(458),
    [sym_preproc_line] = STATE(458),
    [sym_preproc_if_in_expression] = STATE(2008),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(503),
    [anon_sym_return] = ACTIONS(507),
    [anon_sym_do] = ACTIONS(599),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(511),
    [anon_sym_null] = ACTIONS(515),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(517),
    [anon_sym_LBRACK_PIPE] = ACTIONS(519),
    [anon_sym_LBRACE] = ACTIONS(2060),
    [anon_sym_LT_AT] = ACTIONS(523),
    [anon_sym_LT_AT_AT] = ACTIONS(2062),
    [anon_sym_LBRACE_PIPE] = ACTIONS(529),
    [anon_sym_new] = ACTIONS(507),
    [anon_sym_return_BANG] = ACTIONS(531),
    [anon_sym_yield] = ACTIONS(507),
    [anon_sym_yield_BANG] = ACTIONS(531),
    [anon_sym_lazy] = ACTIONS(507),
    [anon_sym_assert] = ACTIONS(507),
    [anon_sym_upcast] = ACTIONS(507),
    [anon_sym_downcast] = ACTIONS(507),
    [anon_sym_for] = ACTIONS(535),
    [anon_sym_while] = ACTIONS(537),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(539),
    [anon_sym_try] = ACTIONS(543),
    [anon_sym_match] = ACTIONS(545),
    [anon_sym_match_BANG] = ACTIONS(547),
    [anon_sym_function] = ACTIONS(549),
    [anon_sym_use] = ACTIONS(557),
    [anon_sym_use_BANG] = ACTIONS(559),
    [anon_sym_do_BANG] = ACTIONS(561),
    [anon_sym_begin] = ACTIONS(565),
    [aux_sym_char_token1] = ACTIONS(569),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(571),
    [anon_sym_DQUOTE] = ACTIONS(573),
    [anon_sym_AT_DQUOTE] = ACTIONS(575),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(577),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(579),
    [sym_bool] = ACTIONS(581),
    [sym_unit] = ACTIONS(2064),
    [anon_sym_LPAREN_PIPE] = ACTIONS(585),
    [sym_op_identifier] = ACTIONS(2066),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(589),
    [sym_xint] = ACTIONS(591),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(593),
  },
  [459] = {
    [sym_function_or_value_defn] = STATE(509),
    [sym__expression] = STATE(319),
    [sym_literal_expression] = STATE(2230),
    [sym_long_identifier_or_op] = STATE(2230),
    [sym_tuple_expression] = STATE(2230),
    [sym_brace_expression] = STATE(2230),
    [sym_anon_record_expression] = STATE(2230),
    [sym_prefixed_expression] = STATE(2230),
    [sym_typecast_expression] = STATE(2230),
    [sym_for_expression] = STATE(2230),
    [sym_while_expression] = STATE(2230),
    [sym__if_branch] = STATE(6659),
    [sym_if_expression] = STATE(2230),
    [sym_fun_expression] = STATE(2230),
    [sym_try_expression] = STATE(2230),
    [sym_match_expression] = STATE(2230),
    [sym_function_expression] = STATE(2230),
    [sym_mutate_expression] = STATE(2230),
    [sym_index_expression] = STATE(2230),
    [sym_typed_expression] = STATE(2230),
    [sym_declaration_expression] = STATE(2230),
    [sym_do_expression] = STATE(2230),
    [sym_list_expression] = STATE(2230),
    [sym_array_expression] = STATE(2230),
    [sym_range_expression] = STATE(6775),
    [sym_begin_end_expression] = STATE(2230),
    [sym_paren_expression] = STATE(2230),
    [sym__high_prec_app] = STATE(2229),
    [sym__low_prec_app] = STATE(2229),
    [sym_application_expression] = STATE(2230),
    [sym_dot_expression] = STATE(2230),
    [sym_infix_expression] = STATE(2230),
    [sym_ce_expression] = STATE(2230),
    [sym_sequential_expression] = STATE(2230),
    [sym_char] = STATE(2100),
    [sym_format_string] = STATE(2106),
    [sym__string_literal] = STATE(2106),
    [sym_string] = STATE(2100),
    [sym_verbatim_string] = STATE(2100),
    [sym_bytearray] = STATE(2100),
    [sym_verbatim_bytearray] = STATE(2100),
    [sym_format_triple_quoted_string] = STATE(2107),
    [sym_triple_quoted_string] = STATE(2100),
    [sym_const] = STATE(2230),
    [sym_long_identifier] = STATE(2232),
    [sym_active_pattern] = STATE(2424),
    [sym__identifier_or_op] = STATE(2305),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(737),
    [sym_sbyte] = STATE(2100),
    [sym_byte] = STATE(2100),
    [sym_int16] = STATE(2100),
    [sym_uint16] = STATE(2100),
    [sym_int32] = STATE(2100),
    [sym_uint32] = STATE(2100),
    [sym_nativeint] = STATE(2100),
    [sym_unativeint] = STATE(2100),
    [sym_int64] = STATE(2100),
    [sym_uint64] = STATE(2100),
    [sym_ieee32] = STATE(2100),
    [sym_ieee64] = STATE(2100),
    [sym_bignum] = STATE(2100),
    [sym_decimal] = STATE(2100),
    [sym_float] = STATE(1487),
    [sym_block_comment] = STATE(459),
    [sym_compiler_directive_decl] = STATE(459),
    [sym_fsi_directive_decl] = STATE(459),
    [sym_preproc_line] = STATE(459),
    [sym_preproc_if_in_expression] = STATE(2230),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(877),
    [anon_sym_return] = ACTIONS(881),
    [anon_sym_do] = ACTIONS(1585),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(885),
    [anon_sym_null] = ACTIONS(889),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(891),
    [anon_sym_LBRACK_PIPE] = ACTIONS(893),
    [anon_sym_LBRACE] = ACTIONS(2048),
    [anon_sym_LT_AT] = ACTIONS(897),
    [anon_sym_LT_AT_AT] = ACTIONS(2050),
    [anon_sym_LBRACE_PIPE] = ACTIONS(903),
    [anon_sym_new] = ACTIONS(881),
    [anon_sym_return_BANG] = ACTIONS(905),
    [anon_sym_yield] = ACTIONS(881),
    [anon_sym_yield_BANG] = ACTIONS(905),
    [anon_sym_lazy] = ACTIONS(881),
    [anon_sym_assert] = ACTIONS(881),
    [anon_sym_upcast] = ACTIONS(881),
    [anon_sym_downcast] = ACTIONS(881),
    [anon_sym_for] = ACTIONS(909),
    [anon_sym_while] = ACTIONS(911),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(913),
    [anon_sym_try] = ACTIONS(915),
    [anon_sym_match] = ACTIONS(917),
    [anon_sym_match_BANG] = ACTIONS(919),
    [anon_sym_function] = ACTIONS(921),
    [anon_sym_use] = ACTIONS(929),
    [anon_sym_use_BANG] = ACTIONS(931),
    [anon_sym_do_BANG] = ACTIONS(933),
    [anon_sym_begin] = ACTIONS(937),
    [aux_sym_char_token1] = ACTIONS(941),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(943),
    [anon_sym_DQUOTE] = ACTIONS(945),
    [anon_sym_AT_DQUOTE] = ACTIONS(947),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(949),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(951),
    [sym_bool] = ACTIONS(953),
    [sym_unit] = ACTIONS(2052),
    [anon_sym_LPAREN_PIPE] = ACTIONS(957),
    [sym_op_identifier] = ACTIONS(2054),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(961),
    [sym_xint] = ACTIONS(963),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(965),
  },
  [460] = {
    [sym_function_or_value_defn] = STATE(627),
    [sym__expression] = STATE(21),
    [sym_literal_expression] = STATE(1118),
    [sym_long_identifier_or_op] = STATE(1118),
    [sym_tuple_expression] = STATE(1118),
    [sym_brace_expression] = STATE(1118),
    [sym_anon_record_expression] = STATE(1118),
    [sym_prefixed_expression] = STATE(1118),
    [sym_typecast_expression] = STATE(1118),
    [sym_for_expression] = STATE(1118),
    [sym_while_expression] = STATE(1118),
    [sym__if_branch] = STATE(7163),
    [sym_if_expression] = STATE(1118),
    [sym_fun_expression] = STATE(1118),
    [sym_try_expression] = STATE(1118),
    [sym_match_expression] = STATE(1118),
    [sym_function_expression] = STATE(1118),
    [sym_mutate_expression] = STATE(1118),
    [sym_index_expression] = STATE(1118),
    [sym_typed_expression] = STATE(1118),
    [sym_declaration_expression] = STATE(1118),
    [sym_do_expression] = STATE(1118),
    [sym_list_expression] = STATE(1118),
    [sym_array_expression] = STATE(1118),
    [sym_begin_end_expression] = STATE(1118),
    [sym_paren_expression] = STATE(1118),
    [sym__high_prec_app] = STATE(1133),
    [sym__low_prec_app] = STATE(1133),
    [sym_application_expression] = STATE(1118),
    [sym_dot_expression] = STATE(1118),
    [sym_infix_expression] = STATE(1118),
    [sym_ce_expression] = STATE(1118),
    [sym_sequential_expression] = STATE(1118),
    [sym_char] = STATE(1080),
    [sym_format_string] = STATE(1090),
    [sym__string_literal] = STATE(1090),
    [sym_string] = STATE(1080),
    [sym_verbatim_string] = STATE(1080),
    [sym_bytearray] = STATE(1080),
    [sym_verbatim_bytearray] = STATE(1080),
    [sym_format_triple_quoted_string] = STATE(1096),
    [sym_triple_quoted_string] = STATE(1080),
    [sym_const] = STATE(1118),
    [sym_long_identifier] = STATE(1156),
    [sym_active_pattern] = STATE(1085),
    [sym__identifier_or_op] = STATE(1099),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(517),
    [sym_sbyte] = STATE(1080),
    [sym_byte] = STATE(1080),
    [sym_int16] = STATE(1080),
    [sym_uint16] = STATE(1080),
    [sym_int32] = STATE(1080),
    [sym_uint32] = STATE(1080),
    [sym_nativeint] = STATE(1080),
    [sym_unativeint] = STATE(1080),
    [sym_int64] = STATE(1080),
    [sym_uint64] = STATE(1080),
    [sym_ieee32] = STATE(1080),
    [sym_ieee64] = STATE(1080),
    [sym_bignum] = STATE(1080),
    [sym_decimal] = STATE(1080),
    [sym_float] = STATE(979),
    [sym_block_comment] = STATE(460),
    [sym_compiler_directive_decl] = STATE(460),
    [sym_fsi_directive_decl] = STATE(460),
    [sym_preproc_line] = STATE(460),
    [sym_preproc_if_in_expression] = STATE(1118),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(195),
    [anon_sym_return] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_null] = ACTIONS(207),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(209),
    [anon_sym_LBRACK_PIPE] = ACTIONS(211),
    [anon_sym_LBRACE] = ACTIONS(1687),
    [anon_sym_LT_AT] = ACTIONS(213),
    [anon_sym_LT_AT_AT] = ACTIONS(1689),
    [anon_sym_LBRACE_PIPE] = ACTIONS(217),
    [anon_sym_new] = ACTIONS(199),
    [anon_sym_with] = ACTIONS(2098),
    [anon_sym_return_BANG] = ACTIONS(219),
    [anon_sym_yield] = ACTIONS(199),
    [anon_sym_yield_BANG] = ACTIONS(219),
    [anon_sym_lazy] = ACTIONS(199),
    [anon_sym_assert] = ACTIONS(199),
    [anon_sym_upcast] = ACTIONS(199),
    [anon_sym_downcast] = ACTIONS(199),
    [anon_sym_for] = ACTIONS(223),
    [anon_sym_while] = ACTIONS(225),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(229),
    [anon_sym_match] = ACTIONS(231),
    [anon_sym_match_BANG] = ACTIONS(233),
    [anon_sym_function] = ACTIONS(235),
    [anon_sym_use] = ACTIONS(239),
    [anon_sym_use_BANG] = ACTIONS(241),
    [anon_sym_do_BANG] = ACTIONS(243),
    [anon_sym_begin] = ACTIONS(245),
    [aux_sym_char_token1] = ACTIONS(247),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(251),
    [anon_sym_AT_DQUOTE] = ACTIONS(253),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(255),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(257),
    [sym_bool] = ACTIONS(259),
    [sym_unit] = ACTIONS(1699),
    [anon_sym_LPAREN_PIPE] = ACTIONS(261),
    [sym_op_identifier] = ACTIONS(1701),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(265),
    [sym_xint] = ACTIONS(267),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(269),
  },
  [461] = {
    [sym_function_or_value_defn] = STATE(509),
    [sym__expression] = STATE(255),
    [sym_literal_expression] = STATE(2230),
    [sym_long_identifier_or_op] = STATE(2230),
    [sym_tuple_expression] = STATE(2230),
    [sym_brace_expression] = STATE(2230),
    [sym_anon_record_expression] = STATE(2230),
    [sym_prefixed_expression] = STATE(2230),
    [sym_typecast_expression] = STATE(2230),
    [sym_for_expression] = STATE(2230),
    [sym_while_expression] = STATE(2230),
    [sym__if_branch] = STATE(6659),
    [sym_if_expression] = STATE(2230),
    [sym_fun_expression] = STATE(2230),
    [sym_try_expression] = STATE(2230),
    [sym_match_expression] = STATE(2230),
    [sym_function_expression] = STATE(2230),
    [sym_mutate_expression] = STATE(2230),
    [sym_index_expression] = STATE(2230),
    [sym_typed_expression] = STATE(2230),
    [sym_declaration_expression] = STATE(2230),
    [sym_do_expression] = STATE(2230),
    [sym_list_expression] = STATE(2230),
    [sym_array_expression] = STATE(2230),
    [sym_range_expression] = STATE(6421),
    [sym_begin_end_expression] = STATE(2230),
    [sym_paren_expression] = STATE(2230),
    [sym__high_prec_app] = STATE(2229),
    [sym__low_prec_app] = STATE(2229),
    [sym_application_expression] = STATE(2230),
    [sym_dot_expression] = STATE(2230),
    [sym_infix_expression] = STATE(2230),
    [sym_ce_expression] = STATE(2230),
    [sym_sequential_expression] = STATE(2230),
    [sym_char] = STATE(2100),
    [sym_format_string] = STATE(2106),
    [sym__string_literal] = STATE(2106),
    [sym_string] = STATE(2100),
    [sym_verbatim_string] = STATE(2100),
    [sym_bytearray] = STATE(2100),
    [sym_verbatim_bytearray] = STATE(2100),
    [sym_format_triple_quoted_string] = STATE(2107),
    [sym_triple_quoted_string] = STATE(2100),
    [sym_const] = STATE(2230),
    [sym_long_identifier] = STATE(2232),
    [sym_active_pattern] = STATE(2424),
    [sym__identifier_or_op] = STATE(2305),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(737),
    [sym_sbyte] = STATE(2100),
    [sym_byte] = STATE(2100),
    [sym_int16] = STATE(2100),
    [sym_uint16] = STATE(2100),
    [sym_int32] = STATE(2100),
    [sym_uint32] = STATE(2100),
    [sym_nativeint] = STATE(2100),
    [sym_unativeint] = STATE(2100),
    [sym_int64] = STATE(2100),
    [sym_uint64] = STATE(2100),
    [sym_ieee32] = STATE(2100),
    [sym_ieee64] = STATE(2100),
    [sym_bignum] = STATE(2100),
    [sym_decimal] = STATE(2100),
    [sym_float] = STATE(1487),
    [sym_block_comment] = STATE(461),
    [sym_compiler_directive_decl] = STATE(461),
    [sym_fsi_directive_decl] = STATE(461),
    [sym_preproc_line] = STATE(461),
    [sym_preproc_if_in_expression] = STATE(2230),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(877),
    [anon_sym_return] = ACTIONS(881),
    [anon_sym_do] = ACTIONS(1585),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(885),
    [anon_sym_null] = ACTIONS(889),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(891),
    [anon_sym_LBRACK_PIPE] = ACTIONS(893),
    [anon_sym_LBRACE] = ACTIONS(2048),
    [anon_sym_LT_AT] = ACTIONS(897),
    [anon_sym_LT_AT_AT] = ACTIONS(2050),
    [anon_sym_LBRACE_PIPE] = ACTIONS(903),
    [anon_sym_new] = ACTIONS(881),
    [anon_sym_return_BANG] = ACTIONS(905),
    [anon_sym_yield] = ACTIONS(881),
    [anon_sym_yield_BANG] = ACTIONS(905),
    [anon_sym_lazy] = ACTIONS(881),
    [anon_sym_assert] = ACTIONS(881),
    [anon_sym_upcast] = ACTIONS(881),
    [anon_sym_downcast] = ACTIONS(881),
    [anon_sym_for] = ACTIONS(909),
    [anon_sym_while] = ACTIONS(911),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(913),
    [anon_sym_try] = ACTIONS(915),
    [anon_sym_match] = ACTIONS(917),
    [anon_sym_match_BANG] = ACTIONS(919),
    [anon_sym_function] = ACTIONS(921),
    [anon_sym_use] = ACTIONS(929),
    [anon_sym_use_BANG] = ACTIONS(931),
    [anon_sym_do_BANG] = ACTIONS(933),
    [anon_sym_begin] = ACTIONS(937),
    [aux_sym_char_token1] = ACTIONS(941),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(943),
    [anon_sym_DQUOTE] = ACTIONS(945),
    [anon_sym_AT_DQUOTE] = ACTIONS(947),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(949),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(951),
    [sym_bool] = ACTIONS(953),
    [sym_unit] = ACTIONS(2052),
    [anon_sym_LPAREN_PIPE] = ACTIONS(957),
    [sym_op_identifier] = ACTIONS(2054),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(961),
    [sym_xint] = ACTIONS(963),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(965),
  },
  [462] = {
    [sym_function_or_value_defn] = STATE(509),
    [sym__expression] = STATE(273),
    [sym_literal_expression] = STATE(2230),
    [sym_long_identifier_or_op] = STATE(2230),
    [sym_tuple_expression] = STATE(2230),
    [sym_brace_expression] = STATE(2230),
    [sym_anon_record_expression] = STATE(2230),
    [sym_prefixed_expression] = STATE(2230),
    [sym_typecast_expression] = STATE(2230),
    [sym_for_expression] = STATE(2230),
    [sym_while_expression] = STATE(2230),
    [sym__if_branch] = STATE(6659),
    [sym_if_expression] = STATE(2230),
    [sym_fun_expression] = STATE(2230),
    [sym_try_expression] = STATE(2230),
    [sym_match_expression] = STATE(2230),
    [sym_function_expression] = STATE(2230),
    [sym_mutate_expression] = STATE(2230),
    [sym_index_expression] = STATE(2230),
    [sym_typed_expression] = STATE(2230),
    [sym_declaration_expression] = STATE(2230),
    [sym_do_expression] = STATE(2230),
    [sym_list_expression] = STATE(2230),
    [sym_array_expression] = STATE(2230),
    [sym_range_expression] = STATE(6531),
    [sym_begin_end_expression] = STATE(2230),
    [sym_paren_expression] = STATE(2230),
    [sym__high_prec_app] = STATE(2229),
    [sym__low_prec_app] = STATE(2229),
    [sym_application_expression] = STATE(2230),
    [sym_dot_expression] = STATE(2230),
    [sym_infix_expression] = STATE(2230),
    [sym_ce_expression] = STATE(2230),
    [sym_sequential_expression] = STATE(2230),
    [sym_char] = STATE(2100),
    [sym_format_string] = STATE(2106),
    [sym__string_literal] = STATE(2106),
    [sym_string] = STATE(2100),
    [sym_verbatim_string] = STATE(2100),
    [sym_bytearray] = STATE(2100),
    [sym_verbatim_bytearray] = STATE(2100),
    [sym_format_triple_quoted_string] = STATE(2107),
    [sym_triple_quoted_string] = STATE(2100),
    [sym_const] = STATE(2230),
    [sym_long_identifier] = STATE(2232),
    [sym_active_pattern] = STATE(2424),
    [sym__identifier_or_op] = STATE(2305),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(737),
    [sym_sbyte] = STATE(2100),
    [sym_byte] = STATE(2100),
    [sym_int16] = STATE(2100),
    [sym_uint16] = STATE(2100),
    [sym_int32] = STATE(2100),
    [sym_uint32] = STATE(2100),
    [sym_nativeint] = STATE(2100),
    [sym_unativeint] = STATE(2100),
    [sym_int64] = STATE(2100),
    [sym_uint64] = STATE(2100),
    [sym_ieee32] = STATE(2100),
    [sym_ieee64] = STATE(2100),
    [sym_bignum] = STATE(2100),
    [sym_decimal] = STATE(2100),
    [sym_float] = STATE(1487),
    [sym_block_comment] = STATE(462),
    [sym_compiler_directive_decl] = STATE(462),
    [sym_fsi_directive_decl] = STATE(462),
    [sym_preproc_line] = STATE(462),
    [sym_preproc_if_in_expression] = STATE(2230),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(877),
    [anon_sym_return] = ACTIONS(881),
    [anon_sym_do] = ACTIONS(1585),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(885),
    [anon_sym_null] = ACTIONS(889),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(891),
    [anon_sym_LBRACK_PIPE] = ACTIONS(893),
    [anon_sym_LBRACE] = ACTIONS(2048),
    [anon_sym_LT_AT] = ACTIONS(897),
    [anon_sym_LT_AT_AT] = ACTIONS(2050),
    [anon_sym_LBRACE_PIPE] = ACTIONS(903),
    [anon_sym_new] = ACTIONS(881),
    [anon_sym_return_BANG] = ACTIONS(905),
    [anon_sym_yield] = ACTIONS(881),
    [anon_sym_yield_BANG] = ACTIONS(905),
    [anon_sym_lazy] = ACTIONS(881),
    [anon_sym_assert] = ACTIONS(881),
    [anon_sym_upcast] = ACTIONS(881),
    [anon_sym_downcast] = ACTIONS(881),
    [anon_sym_for] = ACTIONS(909),
    [anon_sym_while] = ACTIONS(911),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(913),
    [anon_sym_try] = ACTIONS(915),
    [anon_sym_match] = ACTIONS(917),
    [anon_sym_match_BANG] = ACTIONS(919),
    [anon_sym_function] = ACTIONS(921),
    [anon_sym_use] = ACTIONS(929),
    [anon_sym_use_BANG] = ACTIONS(931),
    [anon_sym_do_BANG] = ACTIONS(933),
    [anon_sym_begin] = ACTIONS(937),
    [aux_sym_char_token1] = ACTIONS(941),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(943),
    [anon_sym_DQUOTE] = ACTIONS(945),
    [anon_sym_AT_DQUOTE] = ACTIONS(947),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(949),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(951),
    [sym_bool] = ACTIONS(953),
    [sym_unit] = ACTIONS(2052),
    [anon_sym_LPAREN_PIPE] = ACTIONS(957),
    [sym_op_identifier] = ACTIONS(2054),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(961),
    [sym_xint] = ACTIONS(963),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(965),
  },
  [463] = {
    [sym_function_or_value_defn] = STATE(630),
    [sym__expression] = STATE(225),
    [sym_literal_expression] = STATE(2380),
    [sym_long_identifier_or_op] = STATE(2380),
    [sym_tuple_expression] = STATE(2380),
    [sym_brace_expression] = STATE(2380),
    [sym_anon_record_expression] = STATE(2380),
    [sym_prefixed_expression] = STATE(2380),
    [sym_typecast_expression] = STATE(2380),
    [sym_for_expression] = STATE(2380),
    [sym_while_expression] = STATE(2380),
    [sym__if_branch] = STATE(6456),
    [sym_if_expression] = STATE(2380),
    [sym_fun_expression] = STATE(2380),
    [sym_try_expression] = STATE(2380),
    [sym_match_expression] = STATE(2380),
    [sym_function_expression] = STATE(2380),
    [sym_mutate_expression] = STATE(2380),
    [sym_index_expression] = STATE(2380),
    [sym_typed_expression] = STATE(2380),
    [sym_declaration_expression] = STATE(2380),
    [sym_do_expression] = STATE(2380),
    [sym_list_expression] = STATE(2380),
    [sym_array_expression] = STATE(2380),
    [sym_begin_end_expression] = STATE(2380),
    [sym_paren_expression] = STATE(2380),
    [sym__high_prec_app] = STATE(2383),
    [sym__low_prec_app] = STATE(2383),
    [sym_application_expression] = STATE(2380),
    [sym_dot_expression] = STATE(2380),
    [sym_infix_expression] = STATE(2380),
    [sym_ce_expression] = STATE(2380),
    [sym_sequential_expression] = STATE(2380),
    [sym_char] = STATE(2261),
    [sym_format_string] = STATE(2274),
    [sym__string_literal] = STATE(2274),
    [sym_string] = STATE(2261),
    [sym_verbatim_string] = STATE(2261),
    [sym_bytearray] = STATE(2261),
    [sym_verbatim_bytearray] = STATE(2261),
    [sym_format_triple_quoted_string] = STATE(2275),
    [sym_triple_quoted_string] = STATE(2261),
    [sym_const] = STATE(2380),
    [sym_long_identifier] = STATE(2391),
    [sym_active_pattern] = STATE(2470),
    [sym__identifier_or_op] = STATE(2390),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(632),
    [sym_sbyte] = STATE(2261),
    [sym_byte] = STATE(2261),
    [sym_int16] = STATE(2261),
    [sym_uint16] = STATE(2261),
    [sym_int32] = STATE(2261),
    [sym_uint32] = STATE(2261),
    [sym_nativeint] = STATE(2261),
    [sym_unativeint] = STATE(2261),
    [sym_int64] = STATE(2261),
    [sym_uint64] = STATE(2261),
    [sym_ieee32] = STATE(2261),
    [sym_ieee64] = STATE(2261),
    [sym_bignum] = STATE(2261),
    [sym_decimal] = STATE(2261),
    [sym_float] = STATE(1614),
    [sym_block_comment] = STATE(463),
    [sym_compiler_directive_decl] = STATE(463),
    [sym_fsi_directive_decl] = STATE(463),
    [sym_preproc_line] = STATE(463),
    [sym_preproc_if_in_expression] = STATE(2380),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(1081),
    [anon_sym_return] = ACTIONS(1085),
    [anon_sym_do] = ACTIONS(1087),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(1089),
    [anon_sym_null] = ACTIONS(1093),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1095),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1097),
    [anon_sym_LBRACE] = ACTIONS(2100),
    [anon_sym_LT_AT] = ACTIONS(1101),
    [anon_sym_LT_AT_AT] = ACTIONS(2102),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1107),
    [anon_sym_new] = ACTIONS(1085),
    [anon_sym_return_BANG] = ACTIONS(1109),
    [anon_sym_yield] = ACTIONS(1085),
    [anon_sym_yield_BANG] = ACTIONS(1109),
    [anon_sym_lazy] = ACTIONS(1085),
    [anon_sym_assert] = ACTIONS(1085),
    [anon_sym_upcast] = ACTIONS(1085),
    [anon_sym_downcast] = ACTIONS(1085),
    [anon_sym_for] = ACTIONS(1113),
    [anon_sym_while] = ACTIONS(1115),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(1117),
    [anon_sym_try] = ACTIONS(1119),
    [anon_sym_match] = ACTIONS(1121),
    [anon_sym_match_BANG] = ACTIONS(1123),
    [anon_sym_function] = ACTIONS(1125),
    [anon_sym_use] = ACTIONS(1133),
    [anon_sym_use_BANG] = ACTIONS(1135),
    [anon_sym_do_BANG] = ACTIONS(1137),
    [anon_sym_begin] = ACTIONS(1139),
    [aux_sym_char_token1] = ACTIONS(1143),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1145),
    [anon_sym_DQUOTE] = ACTIONS(1147),
    [anon_sym_AT_DQUOTE] = ACTIONS(1149),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1151),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1153),
    [sym_bool] = ACTIONS(1155),
    [sym_unit] = ACTIONS(2104),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1159),
    [sym_op_identifier] = ACTIONS(2106),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(1163),
    [sym_xint] = ACTIONS(1165),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1167),
    [sym__tuple_marker] = ACTIONS(2108),
  },
  [464] = {
    [sym_function_or_value_defn] = STATE(627),
    [sym__expression] = STATE(21),
    [sym_literal_expression] = STATE(1118),
    [sym_long_identifier_or_op] = STATE(1118),
    [sym_tuple_expression] = STATE(1118),
    [sym_brace_expression] = STATE(1118),
    [sym_anon_record_expression] = STATE(1118),
    [sym_prefixed_expression] = STATE(1118),
    [sym_typecast_expression] = STATE(1118),
    [sym_for_expression] = STATE(1118),
    [sym_while_expression] = STATE(1118),
    [sym__if_branch] = STATE(7163),
    [sym_if_expression] = STATE(1118),
    [sym_fun_expression] = STATE(1118),
    [sym_try_expression] = STATE(1118),
    [sym_match_expression] = STATE(1118),
    [sym_function_expression] = STATE(1118),
    [sym_mutate_expression] = STATE(1118),
    [sym_index_expression] = STATE(1118),
    [sym_typed_expression] = STATE(1118),
    [sym_declaration_expression] = STATE(1118),
    [sym_do_expression] = STATE(1118),
    [sym_list_expression] = STATE(1118),
    [sym_array_expression] = STATE(1118),
    [sym_begin_end_expression] = STATE(1118),
    [sym_paren_expression] = STATE(1118),
    [sym__high_prec_app] = STATE(1133),
    [sym__low_prec_app] = STATE(1133),
    [sym_application_expression] = STATE(1118),
    [sym_dot_expression] = STATE(1118),
    [sym_infix_expression] = STATE(1118),
    [sym_ce_expression] = STATE(1118),
    [sym_sequential_expression] = STATE(1118),
    [sym_char] = STATE(1080),
    [sym_format_string] = STATE(1090),
    [sym__string_literal] = STATE(1090),
    [sym_string] = STATE(1080),
    [sym_verbatim_string] = STATE(1080),
    [sym_bytearray] = STATE(1080),
    [sym_verbatim_bytearray] = STATE(1080),
    [sym_format_triple_quoted_string] = STATE(1096),
    [sym_triple_quoted_string] = STATE(1080),
    [sym_const] = STATE(1118),
    [sym_long_identifier] = STATE(1156),
    [sym_active_pattern] = STATE(1085),
    [sym__identifier_or_op] = STATE(1099),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(517),
    [sym_sbyte] = STATE(1080),
    [sym_byte] = STATE(1080),
    [sym_int16] = STATE(1080),
    [sym_uint16] = STATE(1080),
    [sym_int32] = STATE(1080),
    [sym_uint32] = STATE(1080),
    [sym_nativeint] = STATE(1080),
    [sym_unativeint] = STATE(1080),
    [sym_int64] = STATE(1080),
    [sym_uint64] = STATE(1080),
    [sym_ieee32] = STATE(1080),
    [sym_ieee64] = STATE(1080),
    [sym_bignum] = STATE(1080),
    [sym_decimal] = STATE(1080),
    [sym_float] = STATE(979),
    [sym_block_comment] = STATE(464),
    [sym_compiler_directive_decl] = STATE(464),
    [sym_fsi_directive_decl] = STATE(464),
    [sym_preproc_line] = STATE(464),
    [sym_preproc_if_in_expression] = STATE(1118),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(195),
    [anon_sym_return] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_null] = ACTIONS(207),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(209),
    [anon_sym_LBRACK_PIPE] = ACTIONS(211),
    [anon_sym_LBRACE] = ACTIONS(1687),
    [anon_sym_LT_AT] = ACTIONS(213),
    [anon_sym_LT_AT_AT] = ACTIONS(1689),
    [anon_sym_LBRACE_PIPE] = ACTIONS(217),
    [anon_sym_new] = ACTIONS(199),
    [anon_sym_with] = ACTIONS(2110),
    [anon_sym_return_BANG] = ACTIONS(219),
    [anon_sym_yield] = ACTIONS(199),
    [anon_sym_yield_BANG] = ACTIONS(219),
    [anon_sym_lazy] = ACTIONS(199),
    [anon_sym_assert] = ACTIONS(199),
    [anon_sym_upcast] = ACTIONS(199),
    [anon_sym_downcast] = ACTIONS(199),
    [anon_sym_for] = ACTIONS(223),
    [anon_sym_while] = ACTIONS(225),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(229),
    [anon_sym_match] = ACTIONS(231),
    [anon_sym_match_BANG] = ACTIONS(233),
    [anon_sym_function] = ACTIONS(235),
    [anon_sym_use] = ACTIONS(239),
    [anon_sym_use_BANG] = ACTIONS(241),
    [anon_sym_do_BANG] = ACTIONS(243),
    [anon_sym_begin] = ACTIONS(245),
    [aux_sym_char_token1] = ACTIONS(247),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(251),
    [anon_sym_AT_DQUOTE] = ACTIONS(253),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(255),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(257),
    [sym_bool] = ACTIONS(259),
    [sym_unit] = ACTIONS(1699),
    [anon_sym_LPAREN_PIPE] = ACTIONS(261),
    [sym_op_identifier] = ACTIONS(1701),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(265),
    [sym_xint] = ACTIONS(267),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(269),
  },
  [465] = {
    [sym_function_or_value_defn] = STATE(596),
    [sym__expression] = STATE(113),
    [sym_literal_expression] = STATE(1809),
    [sym_long_identifier_or_op] = STATE(1809),
    [sym_tuple_expression] = STATE(1809),
    [sym_brace_expression] = STATE(1809),
    [sym_anon_record_expression] = STATE(1809),
    [sym_prefixed_expression] = STATE(1809),
    [sym_typecast_expression] = STATE(1809),
    [sym_for_expression] = STATE(1809),
    [sym_while_expression] = STATE(1809),
    [sym__if_branch] = STATE(6874),
    [sym_if_expression] = STATE(1809),
    [sym_fun_expression] = STATE(1809),
    [sym_try_expression] = STATE(1809),
    [sym_match_expression] = STATE(1809),
    [sym_function_expression] = STATE(1809),
    [sym_mutate_expression] = STATE(1809),
    [sym_index_expression] = STATE(1809),
    [sym_typed_expression] = STATE(1809),
    [sym_declaration_expression] = STATE(1809),
    [sym_do_expression] = STATE(1809),
    [sym_list_expression] = STATE(1809),
    [sym_array_expression] = STATE(1809),
    [sym_begin_end_expression] = STATE(1809),
    [sym_paren_expression] = STATE(1809),
    [sym__high_prec_app] = STATE(1806),
    [sym__low_prec_app] = STATE(1806),
    [sym_application_expression] = STATE(1809),
    [sym_dot_expression] = STATE(1809),
    [sym_infix_expression] = STATE(1809),
    [sym_ce_expression] = STATE(1809),
    [sym_sequential_expression] = STATE(1809),
    [sym_char] = STATE(2014),
    [sym_format_string] = STATE(2019),
    [sym__string_literal] = STATE(2019),
    [sym_string] = STATE(2014),
    [sym_verbatim_string] = STATE(2014),
    [sym_bytearray] = STATE(2014),
    [sym_verbatim_bytearray] = STATE(2014),
    [sym_format_triple_quoted_string] = STATE(2020),
    [sym_triple_quoted_string] = STATE(2014),
    [sym_const] = STATE(1809),
    [sym_long_identifier] = STATE(1810),
    [sym_active_pattern] = STATE(1860),
    [sym__identifier_or_op] = STATE(1750),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(655),
    [sym_sbyte] = STATE(2014),
    [sym_byte] = STATE(2014),
    [sym_int16] = STATE(2014),
    [sym_uint16] = STATE(2014),
    [sym_int32] = STATE(2014),
    [sym_uint32] = STATE(2014),
    [sym_nativeint] = STATE(2014),
    [sym_unativeint] = STATE(2014),
    [sym_int64] = STATE(2014),
    [sym_uint64] = STATE(2014),
    [sym_ieee32] = STATE(2014),
    [sym_ieee64] = STATE(2014),
    [sym_bignum] = STATE(2014),
    [sym_decimal] = STATE(2014),
    [sym_float] = STATE(1438),
    [sym_block_comment] = STATE(465),
    [sym_compiler_directive_decl] = STATE(465),
    [sym_fsi_directive_decl] = STATE(465),
    [sym_preproc_line] = STATE(465),
    [sym_preproc_if_in_expression] = STATE(1809),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(723),
    [anon_sym_return] = ACTIONS(727),
    [anon_sym_do] = ACTIONS(729),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(731),
    [anon_sym_null] = ACTIONS(735),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(737),
    [anon_sym_LBRACK_PIPE] = ACTIONS(739),
    [anon_sym_LBRACE] = ACTIONS(2112),
    [anon_sym_LT_AT] = ACTIONS(743),
    [anon_sym_LT_AT_AT] = ACTIONS(2114),
    [anon_sym_LBRACE_PIPE] = ACTIONS(749),
    [anon_sym_new] = ACTIONS(727),
    [anon_sym_return_BANG] = ACTIONS(751),
    [anon_sym_yield] = ACTIONS(727),
    [anon_sym_yield_BANG] = ACTIONS(751),
    [anon_sym_lazy] = ACTIONS(727),
    [anon_sym_assert] = ACTIONS(727),
    [anon_sym_upcast] = ACTIONS(727),
    [anon_sym_downcast] = ACTIONS(727),
    [anon_sym_for] = ACTIONS(755),
    [anon_sym_while] = ACTIONS(757),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(759),
    [anon_sym_try] = ACTIONS(761),
    [anon_sym_match] = ACTIONS(763),
    [anon_sym_match_BANG] = ACTIONS(765),
    [anon_sym_function] = ACTIONS(767),
    [anon_sym_use] = ACTIONS(775),
    [anon_sym_use_BANG] = ACTIONS(777),
    [anon_sym_do_BANG] = ACTIONS(779),
    [anon_sym_begin] = ACTIONS(781),
    [aux_sym_char_token1] = ACTIONS(785),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(787),
    [anon_sym_DQUOTE] = ACTIONS(789),
    [anon_sym_AT_DQUOTE] = ACTIONS(791),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(793),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(795),
    [sym_bool] = ACTIONS(797),
    [sym_unit] = ACTIONS(2116),
    [anon_sym_LPAREN_PIPE] = ACTIONS(801),
    [sym_op_identifier] = ACTIONS(2118),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(805),
    [sym_xint] = ACTIONS(807),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(809),
    [sym__tuple_marker] = ACTIONS(2120),
  },
  [466] = {
    [sym_function_or_value_defn] = STATE(627),
    [sym__expression] = STATE(21),
    [sym_literal_expression] = STATE(1118),
    [sym_long_identifier_or_op] = STATE(1118),
    [sym_tuple_expression] = STATE(1118),
    [sym_brace_expression] = STATE(1118),
    [sym_anon_record_expression] = STATE(1118),
    [sym_prefixed_expression] = STATE(1118),
    [sym_typecast_expression] = STATE(1118),
    [sym_for_expression] = STATE(1118),
    [sym_while_expression] = STATE(1118),
    [sym__if_branch] = STATE(7163),
    [sym_if_expression] = STATE(1118),
    [sym_fun_expression] = STATE(1118),
    [sym_try_expression] = STATE(1118),
    [sym_match_expression] = STATE(1118),
    [sym_function_expression] = STATE(1118),
    [sym_mutate_expression] = STATE(1118),
    [sym_index_expression] = STATE(1118),
    [sym_typed_expression] = STATE(1118),
    [sym_declaration_expression] = STATE(1118),
    [sym_do_expression] = STATE(1118),
    [sym_list_expression] = STATE(1118),
    [sym_array_expression] = STATE(1118),
    [sym_begin_end_expression] = STATE(1118),
    [sym_paren_expression] = STATE(1118),
    [sym__high_prec_app] = STATE(1133),
    [sym__low_prec_app] = STATE(1133),
    [sym_application_expression] = STATE(1118),
    [sym_dot_expression] = STATE(1118),
    [sym_infix_expression] = STATE(1118),
    [sym_ce_expression] = STATE(1118),
    [sym_sequential_expression] = STATE(1118),
    [sym_char] = STATE(1080),
    [sym_format_string] = STATE(1090),
    [sym__string_literal] = STATE(1090),
    [sym_string] = STATE(1080),
    [sym_verbatim_string] = STATE(1080),
    [sym_bytearray] = STATE(1080),
    [sym_verbatim_bytearray] = STATE(1080),
    [sym_format_triple_quoted_string] = STATE(1096),
    [sym_triple_quoted_string] = STATE(1080),
    [sym_const] = STATE(1118),
    [sym_long_identifier] = STATE(1156),
    [sym_active_pattern] = STATE(1085),
    [sym__identifier_or_op] = STATE(1099),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(517),
    [sym_sbyte] = STATE(1080),
    [sym_byte] = STATE(1080),
    [sym_int16] = STATE(1080),
    [sym_uint16] = STATE(1080),
    [sym_int32] = STATE(1080),
    [sym_uint32] = STATE(1080),
    [sym_nativeint] = STATE(1080),
    [sym_unativeint] = STATE(1080),
    [sym_int64] = STATE(1080),
    [sym_uint64] = STATE(1080),
    [sym_ieee32] = STATE(1080),
    [sym_ieee64] = STATE(1080),
    [sym_bignum] = STATE(1080),
    [sym_decimal] = STATE(1080),
    [sym_float] = STATE(979),
    [sym_block_comment] = STATE(466),
    [sym_compiler_directive_decl] = STATE(466),
    [sym_fsi_directive_decl] = STATE(466),
    [sym_preproc_line] = STATE(466),
    [sym_preproc_if_in_expression] = STATE(1118),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(195),
    [anon_sym_return] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_null] = ACTIONS(207),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(209),
    [anon_sym_LBRACK_PIPE] = ACTIONS(211),
    [anon_sym_LBRACE] = ACTIONS(1687),
    [anon_sym_LT_AT] = ACTIONS(213),
    [anon_sym_LT_AT_AT] = ACTIONS(1689),
    [anon_sym_LBRACE_PIPE] = ACTIONS(217),
    [anon_sym_new] = ACTIONS(199),
    [anon_sym_with] = ACTIONS(2122),
    [anon_sym_return_BANG] = ACTIONS(219),
    [anon_sym_yield] = ACTIONS(199),
    [anon_sym_yield_BANG] = ACTIONS(219),
    [anon_sym_lazy] = ACTIONS(199),
    [anon_sym_assert] = ACTIONS(199),
    [anon_sym_upcast] = ACTIONS(199),
    [anon_sym_downcast] = ACTIONS(199),
    [anon_sym_for] = ACTIONS(223),
    [anon_sym_while] = ACTIONS(225),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(229),
    [anon_sym_match] = ACTIONS(231),
    [anon_sym_match_BANG] = ACTIONS(233),
    [anon_sym_function] = ACTIONS(235),
    [anon_sym_use] = ACTIONS(239),
    [anon_sym_use_BANG] = ACTIONS(241),
    [anon_sym_do_BANG] = ACTIONS(243),
    [anon_sym_begin] = ACTIONS(245),
    [aux_sym_char_token1] = ACTIONS(247),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(251),
    [anon_sym_AT_DQUOTE] = ACTIONS(253),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(255),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(257),
    [sym_bool] = ACTIONS(259),
    [sym_unit] = ACTIONS(1699),
    [anon_sym_LPAREN_PIPE] = ACTIONS(261),
    [sym_op_identifier] = ACTIONS(1701),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(265),
    [sym_xint] = ACTIONS(267),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(269),
  },
  [467] = {
    [sym_function_or_value_defn] = STATE(509),
    [sym__expression] = STATE(311),
    [sym_literal_expression] = STATE(2230),
    [sym_long_identifier_or_op] = STATE(2230),
    [sym_tuple_expression] = STATE(2230),
    [sym_brace_expression] = STATE(2230),
    [sym_anon_record_expression] = STATE(2230),
    [sym_prefixed_expression] = STATE(2230),
    [sym_typecast_expression] = STATE(2230),
    [sym_for_expression] = STATE(2230),
    [sym_while_expression] = STATE(2230),
    [sym__if_branch] = STATE(6659),
    [sym_if_expression] = STATE(2230),
    [sym_fun_expression] = STATE(2230),
    [sym_try_expression] = STATE(2230),
    [sym_match_expression] = STATE(2230),
    [sym_function_expression] = STATE(2230),
    [sym_mutate_expression] = STATE(2230),
    [sym_index_expression] = STATE(2230),
    [sym_typed_expression] = STATE(2230),
    [sym_declaration_expression] = STATE(2230),
    [sym_do_expression] = STATE(2230),
    [sym_list_expression] = STATE(2230),
    [sym_array_expression] = STATE(2230),
    [sym_range_expression] = STATE(6682),
    [sym_begin_end_expression] = STATE(2230),
    [sym_paren_expression] = STATE(2230),
    [sym__high_prec_app] = STATE(2229),
    [sym__low_prec_app] = STATE(2229),
    [sym_application_expression] = STATE(2230),
    [sym_dot_expression] = STATE(2230),
    [sym_infix_expression] = STATE(2230),
    [sym_ce_expression] = STATE(2230),
    [sym_sequential_expression] = STATE(2230),
    [sym_char] = STATE(2100),
    [sym_format_string] = STATE(2106),
    [sym__string_literal] = STATE(2106),
    [sym_string] = STATE(2100),
    [sym_verbatim_string] = STATE(2100),
    [sym_bytearray] = STATE(2100),
    [sym_verbatim_bytearray] = STATE(2100),
    [sym_format_triple_quoted_string] = STATE(2107),
    [sym_triple_quoted_string] = STATE(2100),
    [sym_const] = STATE(2230),
    [sym_long_identifier] = STATE(2232),
    [sym_active_pattern] = STATE(2424),
    [sym__identifier_or_op] = STATE(2305),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(737),
    [sym_sbyte] = STATE(2100),
    [sym_byte] = STATE(2100),
    [sym_int16] = STATE(2100),
    [sym_uint16] = STATE(2100),
    [sym_int32] = STATE(2100),
    [sym_uint32] = STATE(2100),
    [sym_nativeint] = STATE(2100),
    [sym_unativeint] = STATE(2100),
    [sym_int64] = STATE(2100),
    [sym_uint64] = STATE(2100),
    [sym_ieee32] = STATE(2100),
    [sym_ieee64] = STATE(2100),
    [sym_bignum] = STATE(2100),
    [sym_decimal] = STATE(2100),
    [sym_float] = STATE(1487),
    [sym_block_comment] = STATE(467),
    [sym_compiler_directive_decl] = STATE(467),
    [sym_fsi_directive_decl] = STATE(467),
    [sym_preproc_line] = STATE(467),
    [sym_preproc_if_in_expression] = STATE(2230),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(877),
    [anon_sym_return] = ACTIONS(881),
    [anon_sym_do] = ACTIONS(1585),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(885),
    [anon_sym_null] = ACTIONS(889),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(891),
    [anon_sym_LBRACK_PIPE] = ACTIONS(893),
    [anon_sym_LBRACE] = ACTIONS(2048),
    [anon_sym_LT_AT] = ACTIONS(897),
    [anon_sym_LT_AT_AT] = ACTIONS(2050),
    [anon_sym_LBRACE_PIPE] = ACTIONS(903),
    [anon_sym_new] = ACTIONS(881),
    [anon_sym_return_BANG] = ACTIONS(905),
    [anon_sym_yield] = ACTIONS(881),
    [anon_sym_yield_BANG] = ACTIONS(905),
    [anon_sym_lazy] = ACTIONS(881),
    [anon_sym_assert] = ACTIONS(881),
    [anon_sym_upcast] = ACTIONS(881),
    [anon_sym_downcast] = ACTIONS(881),
    [anon_sym_for] = ACTIONS(909),
    [anon_sym_while] = ACTIONS(911),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(913),
    [anon_sym_try] = ACTIONS(915),
    [anon_sym_match] = ACTIONS(917),
    [anon_sym_match_BANG] = ACTIONS(919),
    [anon_sym_function] = ACTIONS(921),
    [anon_sym_use] = ACTIONS(929),
    [anon_sym_use_BANG] = ACTIONS(931),
    [anon_sym_do_BANG] = ACTIONS(933),
    [anon_sym_begin] = ACTIONS(937),
    [aux_sym_char_token1] = ACTIONS(941),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(943),
    [anon_sym_DQUOTE] = ACTIONS(945),
    [anon_sym_AT_DQUOTE] = ACTIONS(947),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(949),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(951),
    [sym_bool] = ACTIONS(953),
    [sym_unit] = ACTIONS(2052),
    [anon_sym_LPAREN_PIPE] = ACTIONS(957),
    [sym_op_identifier] = ACTIONS(2054),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(961),
    [sym_xint] = ACTIONS(963),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(965),
  },
  [468] = {
    [sym_function_or_value_defn] = STATE(600),
    [sym__expression] = STATE(90),
    [sym_literal_expression] = STATE(867),
    [sym_long_identifier_or_op] = STATE(867),
    [sym_tuple_expression] = STATE(867),
    [sym_brace_expression] = STATE(867),
    [sym_anon_record_expression] = STATE(867),
    [sym_prefixed_expression] = STATE(867),
    [sym_typecast_expression] = STATE(867),
    [sym_for_expression] = STATE(867),
    [sym_while_expression] = STATE(867),
    [sym__if_branch] = STATE(6511),
    [sym_if_expression] = STATE(867),
    [sym_fun_expression] = STATE(867),
    [sym_try_expression] = STATE(867),
    [sym_match_expression] = STATE(867),
    [sym_function_expression] = STATE(867),
    [sym_mutate_expression] = STATE(867),
    [sym_index_expression] = STATE(867),
    [sym_typed_expression] = STATE(867),
    [sym_declaration_expression] = STATE(867),
    [sym_do_expression] = STATE(867),
    [sym_list_expression] = STATE(867),
    [sym_array_expression] = STATE(867),
    [sym_begin_end_expression] = STATE(867),
    [sym_paren_expression] = STATE(867),
    [sym__high_prec_app] = STATE(864),
    [sym__low_prec_app] = STATE(864),
    [sym_application_expression] = STATE(867),
    [sym_dot_expression] = STATE(867),
    [sym_infix_expression] = STATE(867),
    [sym_ce_expression] = STATE(867),
    [sym_sequential_expression] = STATE(867),
    [sym_char] = STATE(868),
    [sym_format_string] = STATE(869),
    [sym__string_literal] = STATE(869),
    [sym_string] = STATE(868),
    [sym_verbatim_string] = STATE(868),
    [sym_bytearray] = STATE(868),
    [sym_verbatim_bytearray] = STATE(868),
    [sym_format_triple_quoted_string] = STATE(870),
    [sym_triple_quoted_string] = STATE(868),
    [sym_const] = STATE(867),
    [sym_long_identifier] = STATE(872),
    [sym_active_pattern] = STATE(871),
    [sym__identifier_or_op] = STATE(873),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(656),
    [sym_sbyte] = STATE(868),
    [sym_byte] = STATE(868),
    [sym_int16] = STATE(868),
    [sym_uint16] = STATE(868),
    [sym_int32] = STATE(868),
    [sym_uint32] = STATE(868),
    [sym_nativeint] = STATE(868),
    [sym_unativeint] = STATE(868),
    [sym_int64] = STATE(868),
    [sym_uint64] = STATE(868),
    [sym_ieee32] = STATE(868),
    [sym_ieee64] = STATE(868),
    [sym_bignum] = STATE(868),
    [sym_decimal] = STATE(868),
    [sym_float] = STATE(1368),
    [sym_block_comment] = STATE(468),
    [sym_compiler_directive_decl] = STATE(468),
    [sym_fsi_directive_decl] = STATE(468),
    [sym_preproc_line] = STATE(468),
    [sym_preproc_if_in_expression] = STATE(867),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(29),
    [anon_sym_return] = ACTIONS(825),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_null] = ACTIONS(49),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACK_PIPE] = ACTIONS(57),
    [anon_sym_LBRACE] = ACTIONS(1663),
    [anon_sym_LT_AT] = ACTIONS(61),
    [anon_sym_LT_AT_AT] = ACTIONS(1665),
    [anon_sym_LBRACE_PIPE] = ACTIONS(67),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_return_BANG] = ACTIONS(829),
    [anon_sym_yield] = ACTIONS(825),
    [anon_sym_yield_BANG] = ACTIONS(829),
    [anon_sym_lazy] = ACTIONS(825),
    [anon_sym_assert] = ACTIONS(825),
    [anon_sym_upcast] = ACTIONS(825),
    [anon_sym_downcast] = ACTIONS(825),
    [anon_sym_for] = ACTIONS(73),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(79),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_match] = ACTIONS(83),
    [anon_sym_match_BANG] = ACTIONS(85),
    [anon_sym_function] = ACTIONS(87),
    [anon_sym_use] = ACTIONS(833),
    [anon_sym_use_BANG] = ACTIONS(835),
    [anon_sym_do_BANG] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(101),
    [aux_sym_char_token1] = ACTIONS(105),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(107),
    [anon_sym_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DQUOTE] = ACTIONS(111),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(115),
    [sym_bool] = ACTIONS(117),
    [sym_unit] = ACTIONS(1673),
    [anon_sym_LPAREN_PIPE] = ACTIONS(121),
    [sym_op_identifier] = ACTIONS(1675),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(837),
    [sym_xint] = ACTIONS(387),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(135),
    [sym__tuple_marker] = ACTIONS(2124),
  },
  [469] = {
    [sym_function_or_value_defn] = STATE(627),
    [sym__expression] = STATE(21),
    [sym_literal_expression] = STATE(1118),
    [sym_long_identifier_or_op] = STATE(1118),
    [sym_tuple_expression] = STATE(1118),
    [sym_brace_expression] = STATE(1118),
    [sym_anon_record_expression] = STATE(1118),
    [sym_prefixed_expression] = STATE(1118),
    [sym_typecast_expression] = STATE(1118),
    [sym_for_expression] = STATE(1118),
    [sym_while_expression] = STATE(1118),
    [sym__if_branch] = STATE(7163),
    [sym_if_expression] = STATE(1118),
    [sym_fun_expression] = STATE(1118),
    [sym_try_expression] = STATE(1118),
    [sym_match_expression] = STATE(1118),
    [sym_function_expression] = STATE(1118),
    [sym_mutate_expression] = STATE(1118),
    [sym_index_expression] = STATE(1118),
    [sym_typed_expression] = STATE(1118),
    [sym_declaration_expression] = STATE(1118),
    [sym_do_expression] = STATE(1118),
    [sym_list_expression] = STATE(1118),
    [sym_array_expression] = STATE(1118),
    [sym_begin_end_expression] = STATE(1118),
    [sym_paren_expression] = STATE(1118),
    [sym__high_prec_app] = STATE(1133),
    [sym__low_prec_app] = STATE(1133),
    [sym_application_expression] = STATE(1118),
    [sym_dot_expression] = STATE(1118),
    [sym_infix_expression] = STATE(1118),
    [sym_ce_expression] = STATE(1118),
    [sym_sequential_expression] = STATE(1118),
    [sym_char] = STATE(1080),
    [sym_format_string] = STATE(1090),
    [sym__string_literal] = STATE(1090),
    [sym_string] = STATE(1080),
    [sym_verbatim_string] = STATE(1080),
    [sym_bytearray] = STATE(1080),
    [sym_verbatim_bytearray] = STATE(1080),
    [sym_format_triple_quoted_string] = STATE(1096),
    [sym_triple_quoted_string] = STATE(1080),
    [sym_const] = STATE(1118),
    [sym_long_identifier] = STATE(1156),
    [sym_active_pattern] = STATE(1085),
    [sym__identifier_or_op] = STATE(1099),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(517),
    [sym_sbyte] = STATE(1080),
    [sym_byte] = STATE(1080),
    [sym_int16] = STATE(1080),
    [sym_uint16] = STATE(1080),
    [sym_int32] = STATE(1080),
    [sym_uint32] = STATE(1080),
    [sym_nativeint] = STATE(1080),
    [sym_unativeint] = STATE(1080),
    [sym_int64] = STATE(1080),
    [sym_uint64] = STATE(1080),
    [sym_ieee32] = STATE(1080),
    [sym_ieee64] = STATE(1080),
    [sym_bignum] = STATE(1080),
    [sym_decimal] = STATE(1080),
    [sym_float] = STATE(979),
    [sym_block_comment] = STATE(469),
    [sym_compiler_directive_decl] = STATE(469),
    [sym_fsi_directive_decl] = STATE(469),
    [sym_preproc_line] = STATE(469),
    [sym_preproc_if_in_expression] = STATE(1118),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(195),
    [anon_sym_return] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_null] = ACTIONS(207),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(209),
    [anon_sym_LBRACK_PIPE] = ACTIONS(211),
    [anon_sym_LBRACE] = ACTIONS(1687),
    [anon_sym_LT_AT] = ACTIONS(213),
    [anon_sym_LT_AT_AT] = ACTIONS(1689),
    [anon_sym_LBRACE_PIPE] = ACTIONS(217),
    [anon_sym_new] = ACTIONS(199),
    [anon_sym_with] = ACTIONS(2126),
    [anon_sym_return_BANG] = ACTIONS(219),
    [anon_sym_yield] = ACTIONS(199),
    [anon_sym_yield_BANG] = ACTIONS(219),
    [anon_sym_lazy] = ACTIONS(199),
    [anon_sym_assert] = ACTIONS(199),
    [anon_sym_upcast] = ACTIONS(199),
    [anon_sym_downcast] = ACTIONS(199),
    [anon_sym_for] = ACTIONS(223),
    [anon_sym_while] = ACTIONS(225),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(229),
    [anon_sym_match] = ACTIONS(231),
    [anon_sym_match_BANG] = ACTIONS(233),
    [anon_sym_function] = ACTIONS(235),
    [anon_sym_use] = ACTIONS(239),
    [anon_sym_use_BANG] = ACTIONS(241),
    [anon_sym_do_BANG] = ACTIONS(243),
    [anon_sym_begin] = ACTIONS(245),
    [aux_sym_char_token1] = ACTIONS(247),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(251),
    [anon_sym_AT_DQUOTE] = ACTIONS(253),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(255),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(257),
    [sym_bool] = ACTIONS(259),
    [sym_unit] = ACTIONS(1699),
    [anon_sym_LPAREN_PIPE] = ACTIONS(261),
    [sym_op_identifier] = ACTIONS(1701),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(265),
    [sym_xint] = ACTIONS(267),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(269),
  },
  [470] = {
    [sym_function_or_value_defn] = STATE(509),
    [sym__expression] = STATE(305),
    [sym_literal_expression] = STATE(2230),
    [sym_long_identifier_or_op] = STATE(2230),
    [sym_tuple_expression] = STATE(2230),
    [sym_brace_expression] = STATE(2230),
    [sym_anon_record_expression] = STATE(2230),
    [sym_prefixed_expression] = STATE(2230),
    [sym_typecast_expression] = STATE(2230),
    [sym_for_expression] = STATE(2230),
    [sym_while_expression] = STATE(2230),
    [sym__if_branch] = STATE(6659),
    [sym_if_expression] = STATE(2230),
    [sym_fun_expression] = STATE(2230),
    [sym_try_expression] = STATE(2230),
    [sym_match_expression] = STATE(2230),
    [sym_function_expression] = STATE(2230),
    [sym_mutate_expression] = STATE(2230),
    [sym_index_expression] = STATE(2230),
    [sym_typed_expression] = STATE(2230),
    [sym_declaration_expression] = STATE(2230),
    [sym_do_expression] = STATE(2230),
    [sym_list_expression] = STATE(2230),
    [sym_array_expression] = STATE(2230),
    [sym_range_expression] = STATE(6730),
    [sym_begin_end_expression] = STATE(2230),
    [sym_paren_expression] = STATE(2230),
    [sym__high_prec_app] = STATE(2229),
    [sym__low_prec_app] = STATE(2229),
    [sym_application_expression] = STATE(2230),
    [sym_dot_expression] = STATE(2230),
    [sym_infix_expression] = STATE(2230),
    [sym_ce_expression] = STATE(2230),
    [sym_sequential_expression] = STATE(2230),
    [sym_char] = STATE(2100),
    [sym_format_string] = STATE(2106),
    [sym__string_literal] = STATE(2106),
    [sym_string] = STATE(2100),
    [sym_verbatim_string] = STATE(2100),
    [sym_bytearray] = STATE(2100),
    [sym_verbatim_bytearray] = STATE(2100),
    [sym_format_triple_quoted_string] = STATE(2107),
    [sym_triple_quoted_string] = STATE(2100),
    [sym_const] = STATE(2230),
    [sym_long_identifier] = STATE(2232),
    [sym_active_pattern] = STATE(2424),
    [sym__identifier_or_op] = STATE(2305),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(737),
    [sym_sbyte] = STATE(2100),
    [sym_byte] = STATE(2100),
    [sym_int16] = STATE(2100),
    [sym_uint16] = STATE(2100),
    [sym_int32] = STATE(2100),
    [sym_uint32] = STATE(2100),
    [sym_nativeint] = STATE(2100),
    [sym_unativeint] = STATE(2100),
    [sym_int64] = STATE(2100),
    [sym_uint64] = STATE(2100),
    [sym_ieee32] = STATE(2100),
    [sym_ieee64] = STATE(2100),
    [sym_bignum] = STATE(2100),
    [sym_decimal] = STATE(2100),
    [sym_float] = STATE(1487),
    [sym_block_comment] = STATE(470),
    [sym_compiler_directive_decl] = STATE(470),
    [sym_fsi_directive_decl] = STATE(470),
    [sym_preproc_line] = STATE(470),
    [sym_preproc_if_in_expression] = STATE(2230),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(877),
    [anon_sym_return] = ACTIONS(881),
    [anon_sym_do] = ACTIONS(1585),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(885),
    [anon_sym_null] = ACTIONS(889),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(891),
    [anon_sym_LBRACK_PIPE] = ACTIONS(893),
    [anon_sym_LBRACE] = ACTIONS(2048),
    [anon_sym_LT_AT] = ACTIONS(897),
    [anon_sym_LT_AT_AT] = ACTIONS(2050),
    [anon_sym_LBRACE_PIPE] = ACTIONS(903),
    [anon_sym_new] = ACTIONS(881),
    [anon_sym_return_BANG] = ACTIONS(905),
    [anon_sym_yield] = ACTIONS(881),
    [anon_sym_yield_BANG] = ACTIONS(905),
    [anon_sym_lazy] = ACTIONS(881),
    [anon_sym_assert] = ACTIONS(881),
    [anon_sym_upcast] = ACTIONS(881),
    [anon_sym_downcast] = ACTIONS(881),
    [anon_sym_for] = ACTIONS(909),
    [anon_sym_while] = ACTIONS(911),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(913),
    [anon_sym_try] = ACTIONS(915),
    [anon_sym_match] = ACTIONS(917),
    [anon_sym_match_BANG] = ACTIONS(919),
    [anon_sym_function] = ACTIONS(921),
    [anon_sym_use] = ACTIONS(929),
    [anon_sym_use_BANG] = ACTIONS(931),
    [anon_sym_do_BANG] = ACTIONS(933),
    [anon_sym_begin] = ACTIONS(937),
    [aux_sym_char_token1] = ACTIONS(941),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(943),
    [anon_sym_DQUOTE] = ACTIONS(945),
    [anon_sym_AT_DQUOTE] = ACTIONS(947),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(949),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(951),
    [sym_bool] = ACTIONS(953),
    [sym_unit] = ACTIONS(2052),
    [anon_sym_LPAREN_PIPE] = ACTIONS(957),
    [sym_op_identifier] = ACTIONS(2054),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(961),
    [sym_xint] = ACTIONS(963),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(965),
  },
  [471] = {
    [sym_function_or_value_defn] = STATE(482),
    [sym__expression] = STATE(33),
    [sym_literal_expression] = STATE(1537),
    [sym_long_identifier_or_op] = STATE(1537),
    [sym_tuple_expression] = STATE(1537),
    [sym_brace_expression] = STATE(1537),
    [sym_anon_record_expression] = STATE(1537),
    [sym_prefixed_expression] = STATE(1537),
    [sym_typecast_expression] = STATE(1537),
    [sym_for_expression] = STATE(1537),
    [sym_while_expression] = STATE(1537),
    [sym__if_branch] = STATE(6834),
    [sym_if_expression] = STATE(1537),
    [sym_fun_expression] = STATE(1537),
    [sym_try_expression] = STATE(1537),
    [sym_match_expression] = STATE(1537),
    [sym_function_expression] = STATE(1537),
    [sym_mutate_expression] = STATE(1537),
    [sym_index_expression] = STATE(1537),
    [sym_typed_expression] = STATE(1537),
    [sym_declaration_expression] = STATE(1537),
    [sym_do_expression] = STATE(1537),
    [sym_list_expression] = STATE(1537),
    [sym_array_expression] = STATE(1537),
    [sym_begin_end_expression] = STATE(1537),
    [sym_paren_expression] = STATE(1537),
    [sym__high_prec_app] = STATE(1538),
    [sym__low_prec_app] = STATE(1538),
    [sym_application_expression] = STATE(1537),
    [sym_dot_expression] = STATE(1537),
    [sym_infix_expression] = STATE(1537),
    [sym_ce_expression] = STATE(1537),
    [sym_sequential_expression] = STATE(1537),
    [sym_char] = STATE(1484),
    [sym_format_string] = STATE(1483),
    [sym__string_literal] = STATE(1483),
    [sym_string] = STATE(1484),
    [sym_verbatim_string] = STATE(1484),
    [sym_bytearray] = STATE(1484),
    [sym_verbatim_bytearray] = STATE(1484),
    [sym_format_triple_quoted_string] = STATE(1482),
    [sym_triple_quoted_string] = STATE(1484),
    [sym_const] = STATE(1537),
    [sym_long_identifier] = STATE(1643),
    [sym_active_pattern] = STATE(1645),
    [sym__identifier_or_op] = STATE(1689),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(670),
    [sym_sbyte] = STATE(1484),
    [sym_byte] = STATE(1484),
    [sym_int16] = STATE(1484),
    [sym_uint16] = STATE(1484),
    [sym_int32] = STATE(1484),
    [sym_uint32] = STATE(1484),
    [sym_nativeint] = STATE(1484),
    [sym_unativeint] = STATE(1484),
    [sym_int64] = STATE(1484),
    [sym_uint64] = STATE(1484),
    [sym_ieee32] = STATE(1484),
    [sym_ieee64] = STATE(1484),
    [sym_bignum] = STATE(1484),
    [sym_decimal] = STATE(1484),
    [sym_float] = STATE(1327),
    [sym_block_comment] = STATE(471),
    [sym_compiler_directive_decl] = STATE(471),
    [sym_fsi_directive_decl] = STATE(471),
    [sym_preproc_line] = STATE(471),
    [sym_preproc_if_in_expression] = STATE(1537),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(275),
    [anon_sym_return] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(281),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(285),
    [anon_sym_null] = ACTIONS(289),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(291),
    [anon_sym_LBRACK_PIPE] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(2128),
    [anon_sym_LT_AT] = ACTIONS(297),
    [anon_sym_LT_AT_AT] = ACTIONS(2130),
    [anon_sym_LBRACE_PIPE] = ACTIONS(303),
    [anon_sym_new] = ACTIONS(279),
    [anon_sym_return_BANG] = ACTIONS(307),
    [anon_sym_yield] = ACTIONS(279),
    [anon_sym_yield_BANG] = ACTIONS(307),
    [anon_sym_lazy] = ACTIONS(279),
    [anon_sym_assert] = ACTIONS(279),
    [anon_sym_upcast] = ACTIONS(279),
    [anon_sym_downcast] = ACTIONS(279),
    [anon_sym_for] = ACTIONS(311),
    [anon_sym_while] = ACTIONS(313),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(315),
    [anon_sym_try] = ACTIONS(317),
    [anon_sym_match] = ACTIONS(319),
    [anon_sym_match_BANG] = ACTIONS(321),
    [anon_sym_function] = ACTIONS(323),
    [anon_sym_use] = ACTIONS(331),
    [anon_sym_use_BANG] = ACTIONS(333),
    [anon_sym_do_BANG] = ACTIONS(335),
    [anon_sym_begin] = ACTIONS(337),
    [aux_sym_char_token1] = ACTIONS(341),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(343),
    [anon_sym_DQUOTE] = ACTIONS(345),
    [anon_sym_AT_DQUOTE] = ACTIONS(347),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(349),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(351),
    [sym_bool] = ACTIONS(353),
    [sym_unit] = ACTIONS(2132),
    [anon_sym_LPAREN_PIPE] = ACTIONS(357),
    [sym_op_identifier] = ACTIONS(2134),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(361),
    [sym_xint] = ACTIONS(363),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(365),
    [sym__tuple_marker] = ACTIONS(2136),
  },
  [472] = {
    [sym_function_or_value_defn] = STATE(527),
    [sym__expression] = STATE(268),
    [sym_literal_expression] = STATE(2384),
    [sym_long_identifier_or_op] = STATE(2384),
    [sym_tuple_expression] = STATE(2384),
    [sym_brace_expression] = STATE(2384),
    [sym_anon_record_expression] = STATE(2384),
    [sym_prefixed_expression] = STATE(2384),
    [sym_typecast_expression] = STATE(2384),
    [sym_for_expression] = STATE(2384),
    [sym_while_expression] = STATE(2384),
    [sym__if_branch] = STATE(6561),
    [sym_if_expression] = STATE(2384),
    [sym_fun_expression] = STATE(2384),
    [sym_try_expression] = STATE(2384),
    [sym_match_expression] = STATE(2384),
    [sym_function_expression] = STATE(2384),
    [sym_mutate_expression] = STATE(2384),
    [sym_index_expression] = STATE(2384),
    [sym_typed_expression] = STATE(2384),
    [sym_declaration_expression] = STATE(2384),
    [sym_do_expression] = STATE(2384),
    [sym_list_expression] = STATE(2384),
    [sym_array_expression] = STATE(2384),
    [sym_begin_end_expression] = STATE(2384),
    [sym_paren_expression] = STATE(2384),
    [sym__high_prec_app] = STATE(2249),
    [sym__low_prec_app] = STATE(2249),
    [sym_application_expression] = STATE(2384),
    [sym_dot_expression] = STATE(2384),
    [sym_infix_expression] = STATE(2384),
    [sym_ce_expression] = STATE(2384),
    [sym_sequential_expression] = STATE(2384),
    [sym_char] = STATE(2144),
    [sym_format_string] = STATE(2142),
    [sym__string_literal] = STATE(2142),
    [sym_string] = STATE(2144),
    [sym_verbatim_string] = STATE(2144),
    [sym_bytearray] = STATE(2144),
    [sym_verbatim_bytearray] = STATE(2144),
    [sym_format_triple_quoted_string] = STATE(2141),
    [sym_triple_quoted_string] = STATE(2144),
    [sym_const] = STATE(2384),
    [sym_long_identifier] = STATE(2400),
    [sym_active_pattern] = STATE(2317),
    [sym__identifier_or_op] = STATE(2392),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(633),
    [sym_sbyte] = STATE(2144),
    [sym_byte] = STATE(2144),
    [sym_int16] = STATE(2144),
    [sym_uint16] = STATE(2144),
    [sym_int32] = STATE(2144),
    [sym_uint32] = STATE(2144),
    [sym_nativeint] = STATE(2144),
    [sym_unativeint] = STATE(2144),
    [sym_int64] = STATE(2144),
    [sym_uint64] = STATE(2144),
    [sym_ieee32] = STATE(2144),
    [sym_ieee64] = STATE(2144),
    [sym_bignum] = STATE(2144),
    [sym_decimal] = STATE(2144),
    [sym_float] = STATE(1672),
    [sym_block_comment] = STATE(472),
    [sym_compiler_directive_decl] = STATE(472),
    [sym_fsi_directive_decl] = STATE(472),
    [sym_preproc_line] = STATE(472),
    [sym_preproc_if_in_expression] = STATE(2384),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(1439),
    [anon_sym_return] = ACTIONS(1443),
    [anon_sym_do] = ACTIONS(1445),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(1447),
    [anon_sym_null] = ACTIONS(1451),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1453),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1455),
    [anon_sym_LBRACE] = ACTIONS(2036),
    [anon_sym_LT_AT] = ACTIONS(1459),
    [anon_sym_LT_AT_AT] = ACTIONS(2038),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1465),
    [anon_sym_new] = ACTIONS(1443),
    [anon_sym_return_BANG] = ACTIONS(1467),
    [anon_sym_yield] = ACTIONS(1443),
    [anon_sym_yield_BANG] = ACTIONS(1467),
    [anon_sym_lazy] = ACTIONS(1443),
    [anon_sym_assert] = ACTIONS(1443),
    [anon_sym_upcast] = ACTIONS(1443),
    [anon_sym_downcast] = ACTIONS(1443),
    [anon_sym_for] = ACTIONS(1471),
    [anon_sym_while] = ACTIONS(1473),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(1475),
    [anon_sym_try] = ACTIONS(1477),
    [anon_sym_match] = ACTIONS(1479),
    [anon_sym_match_BANG] = ACTIONS(1481),
    [anon_sym_function] = ACTIONS(1483),
    [anon_sym_use] = ACTIONS(1491),
    [anon_sym_use_BANG] = ACTIONS(1493),
    [anon_sym_do_BANG] = ACTIONS(1495),
    [anon_sym_begin] = ACTIONS(1497),
    [aux_sym_char_token1] = ACTIONS(1501),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1503),
    [anon_sym_DQUOTE] = ACTIONS(1505),
    [anon_sym_AT_DQUOTE] = ACTIONS(1507),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1509),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1511),
    [sym_bool] = ACTIONS(1513),
    [sym_unit] = ACTIONS(2040),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1517),
    [sym_op_identifier] = ACTIONS(2042),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(1521),
    [sym_xint] = ACTIONS(1523),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1525),
    [sym__tuple_marker] = ACTIONS(2138),
  },
  [473] = {
    [sym_function_or_value_defn] = STATE(532),
    [sym__expression] = STATE(129),
    [sym_literal_expression] = STATE(2000),
    [sym_long_identifier_or_op] = STATE(2000),
    [sym_tuple_expression] = STATE(2000),
    [sym_brace_expression] = STATE(2000),
    [sym_anon_record_expression] = STATE(2000),
    [sym_prefixed_expression] = STATE(2000),
    [sym_typecast_expression] = STATE(2000),
    [sym_for_expression] = STATE(2000),
    [sym_while_expression] = STATE(2000),
    [sym__if_branch] = STATE(6707),
    [sym_if_expression] = STATE(2000),
    [sym_fun_expression] = STATE(2000),
    [sym_try_expression] = STATE(2000),
    [sym_match_expression] = STATE(2000),
    [sym_function_expression] = STATE(2000),
    [sym_mutate_expression] = STATE(2000),
    [sym_index_expression] = STATE(2000),
    [sym_typed_expression] = STATE(2000),
    [sym_declaration_expression] = STATE(2000),
    [sym_do_expression] = STATE(2000),
    [sym_list_expression] = STATE(2000),
    [sym_array_expression] = STATE(2000),
    [sym_begin_end_expression] = STATE(2000),
    [sym_paren_expression] = STATE(2000),
    [sym__high_prec_app] = STATE(2003),
    [sym__low_prec_app] = STATE(2003),
    [sym_application_expression] = STATE(2000),
    [sym_dot_expression] = STATE(2000),
    [sym_infix_expression] = STATE(2000),
    [sym_ce_expression] = STATE(2000),
    [sym_sequential_expression] = STATE(2000),
    [sym_char] = STATE(1801),
    [sym_format_string] = STATE(1804),
    [sym__string_literal] = STATE(1804),
    [sym_string] = STATE(1801),
    [sym_verbatim_string] = STATE(1801),
    [sym_bytearray] = STATE(1801),
    [sym_verbatim_bytearray] = STATE(1801),
    [sym_format_triple_quoted_string] = STATE(1807),
    [sym_triple_quoted_string] = STATE(1801),
    [sym_const] = STATE(2000),
    [sym_long_identifier] = STATE(1725),
    [sym_active_pattern] = STATE(1726),
    [sym__identifier_or_op] = STATE(1751),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(723),
    [sym_sbyte] = STATE(1801),
    [sym_byte] = STATE(1801),
    [sym_int16] = STATE(1801),
    [sym_uint16] = STATE(1801),
    [sym_int32] = STATE(1801),
    [sym_uint32] = STATE(1801),
    [sym_nativeint] = STATE(1801),
    [sym_unativeint] = STATE(1801),
    [sym_int64] = STATE(1801),
    [sym_uint64] = STATE(1801),
    [sym_ieee32] = STATE(1801),
    [sym_ieee64] = STATE(1801),
    [sym_bignum] = STATE(1801),
    [sym_decimal] = STATE(1801),
    [sym_float] = STATE(1427),
    [sym_block_comment] = STATE(473),
    [sym_compiler_directive_decl] = STATE(473),
    [sym_fsi_directive_decl] = STATE(473),
    [sym_preproc_line] = STATE(473),
    [sym_preproc_if_in_expression] = STATE(2000),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(629),
    [anon_sym_return] = ACTIONS(633),
    [anon_sym_do] = ACTIONS(635),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(637),
    [anon_sym_null] = ACTIONS(641),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(643),
    [anon_sym_LBRACK_PIPE] = ACTIONS(645),
    [anon_sym_LBRACE] = ACTIONS(1713),
    [anon_sym_LT_AT] = ACTIONS(647),
    [anon_sym_LT_AT_AT] = ACTIONS(1715),
    [anon_sym_LBRACE_PIPE] = ACTIONS(653),
    [anon_sym_new] = ACTIONS(633),
    [anon_sym_return_BANG] = ACTIONS(655),
    [anon_sym_yield] = ACTIONS(633),
    [anon_sym_yield_BANG] = ACTIONS(655),
    [anon_sym_lazy] = ACTIONS(633),
    [anon_sym_assert] = ACTIONS(633),
    [anon_sym_upcast] = ACTIONS(633),
    [anon_sym_downcast] = ACTIONS(633),
    [anon_sym_for] = ACTIONS(659),
    [anon_sym_while] = ACTIONS(661),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(663),
    [anon_sym_try] = ACTIONS(665),
    [anon_sym_match] = ACTIONS(667),
    [anon_sym_match_BANG] = ACTIONS(669),
    [anon_sym_function] = ACTIONS(671),
    [anon_sym_use] = ACTIONS(679),
    [anon_sym_use_BANG] = ACTIONS(681),
    [anon_sym_do_BANG] = ACTIONS(683),
    [anon_sym_begin] = ACTIONS(685),
    [aux_sym_char_token1] = ACTIONS(689),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(691),
    [anon_sym_DQUOTE] = ACTIONS(693),
    [anon_sym_AT_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(697),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(699),
    [sym_bool] = ACTIONS(701),
    [sym_unit] = ACTIONS(1717),
    [anon_sym_LPAREN_PIPE] = ACTIONS(705),
    [sym_op_identifier] = ACTIONS(1719),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(709),
    [sym_xint] = ACTIONS(711),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(713),
    [sym__tuple_marker] = ACTIONS(2140),
  },
  [474] = {
    [sym_function_or_value_defn] = STATE(535),
    [sym__expression] = STATE(35),
    [sym_literal_expression] = STATE(2008),
    [sym_long_identifier_or_op] = STATE(2008),
    [sym_tuple_expression] = STATE(2008),
    [sym_brace_expression] = STATE(2008),
    [sym_anon_record_expression] = STATE(2008),
    [sym_prefixed_expression] = STATE(2008),
    [sym_typecast_expression] = STATE(2008),
    [sym_for_expression] = STATE(2008),
    [sym_while_expression] = STATE(2008),
    [sym__if_branch] = STATE(6754),
    [sym_if_expression] = STATE(2008),
    [sym_fun_expression] = STATE(2008),
    [sym_try_expression] = STATE(2008),
    [sym_match_expression] = STATE(2008),
    [sym_function_expression] = STATE(2008),
    [sym_mutate_expression] = STATE(2008),
    [sym_index_expression] = STATE(2008),
    [sym_typed_expression] = STATE(2008),
    [sym_declaration_expression] = STATE(2008),
    [sym_do_expression] = STATE(2008),
    [sym_list_expression] = STATE(2008),
    [sym_array_expression] = STATE(2008),
    [sym_range_expression] = STATE(6013),
    [sym_begin_end_expression] = STATE(2008),
    [sym_paren_expression] = STATE(2008),
    [sym__high_prec_app] = STATE(2007),
    [sym__low_prec_app] = STATE(2007),
    [sym_application_expression] = STATE(2008),
    [sym_dot_expression] = STATE(2008),
    [sym_infix_expression] = STATE(2008),
    [sym_ce_expression] = STATE(2008),
    [sym_sequential_expression] = STATE(2008),
    [sym_char] = STATE(1859),
    [sym_format_string] = STATE(1861),
    [sym__string_literal] = STATE(1861),
    [sym_string] = STATE(1859),
    [sym_verbatim_string] = STATE(1859),
    [sym_bytearray] = STATE(1859),
    [sym_verbatim_bytearray] = STATE(1859),
    [sym_format_triple_quoted_string] = STATE(1862),
    [sym_triple_quoted_string] = STATE(1859),
    [sym_const] = STATE(2008),
    [sym_long_identifier] = STATE(1701),
    [sym_active_pattern] = STATE(1702),
    [sym__identifier_or_op] = STATE(1724),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(664),
    [sym_sbyte] = STATE(1859),
    [sym_byte] = STATE(1859),
    [sym_int16] = STATE(1859),
    [sym_uint16] = STATE(1859),
    [sym_int32] = STATE(1859),
    [sym_uint32] = STATE(1859),
    [sym_nativeint] = STATE(1859),
    [sym_unativeint] = STATE(1859),
    [sym_int64] = STATE(1859),
    [sym_uint64] = STATE(1859),
    [sym_ieee32] = STATE(1859),
    [sym_ieee64] = STATE(1859),
    [sym_bignum] = STATE(1859),
    [sym_decimal] = STATE(1859),
    [sym_float] = STATE(1447),
    [sym_block_comment] = STATE(474),
    [sym_compiler_directive_decl] = STATE(474),
    [sym_fsi_directive_decl] = STATE(474),
    [sym_preproc_line] = STATE(474),
    [sym_preproc_if_in_expression] = STATE(2008),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(503),
    [anon_sym_return] = ACTIONS(507),
    [anon_sym_do] = ACTIONS(599),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(511),
    [anon_sym_null] = ACTIONS(515),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(517),
    [anon_sym_LBRACK_PIPE] = ACTIONS(519),
    [anon_sym_LBRACE] = ACTIONS(2060),
    [anon_sym_LT_AT] = ACTIONS(523),
    [anon_sym_LT_AT_AT] = ACTIONS(2062),
    [anon_sym_LBRACE_PIPE] = ACTIONS(529),
    [anon_sym_new] = ACTIONS(507),
    [anon_sym_return_BANG] = ACTIONS(531),
    [anon_sym_yield] = ACTIONS(507),
    [anon_sym_yield_BANG] = ACTIONS(531),
    [anon_sym_lazy] = ACTIONS(507),
    [anon_sym_assert] = ACTIONS(507),
    [anon_sym_upcast] = ACTIONS(507),
    [anon_sym_downcast] = ACTIONS(507),
    [anon_sym_for] = ACTIONS(535),
    [anon_sym_while] = ACTIONS(537),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(539),
    [anon_sym_try] = ACTIONS(543),
    [anon_sym_match] = ACTIONS(545),
    [anon_sym_match_BANG] = ACTIONS(547),
    [anon_sym_function] = ACTIONS(549),
    [anon_sym_use] = ACTIONS(557),
    [anon_sym_use_BANG] = ACTIONS(559),
    [anon_sym_do_BANG] = ACTIONS(561),
    [anon_sym_begin] = ACTIONS(565),
    [aux_sym_char_token1] = ACTIONS(569),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(571),
    [anon_sym_DQUOTE] = ACTIONS(573),
    [anon_sym_AT_DQUOTE] = ACTIONS(575),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(577),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(579),
    [sym_bool] = ACTIONS(581),
    [sym_unit] = ACTIONS(2064),
    [anon_sym_LPAREN_PIPE] = ACTIONS(585),
    [sym_op_identifier] = ACTIONS(2066),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(589),
    [sym_xint] = ACTIONS(591),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(593),
  },
  [475] = {
    [sym_function_or_value_defn] = STATE(535),
    [sym__expression] = STATE(39),
    [sym_literal_expression] = STATE(2008),
    [sym_long_identifier_or_op] = STATE(2008),
    [sym_tuple_expression] = STATE(2008),
    [sym_brace_expression] = STATE(2008),
    [sym_anon_record_expression] = STATE(2008),
    [sym_prefixed_expression] = STATE(2008),
    [sym_typecast_expression] = STATE(2008),
    [sym_for_expression] = STATE(2008),
    [sym_while_expression] = STATE(2008),
    [sym__if_branch] = STATE(6754),
    [sym_if_expression] = STATE(2008),
    [sym_fun_expression] = STATE(2008),
    [sym_try_expression] = STATE(2008),
    [sym_match_expression] = STATE(2008),
    [sym_function_expression] = STATE(2008),
    [sym_mutate_expression] = STATE(2008),
    [sym_index_expression] = STATE(2008),
    [sym_typed_expression] = STATE(2008),
    [sym_declaration_expression] = STATE(2008),
    [sym_do_expression] = STATE(2008),
    [sym_list_expression] = STATE(2008),
    [sym_array_expression] = STATE(2008),
    [sym_begin_end_expression] = STATE(2008),
    [sym_paren_expression] = STATE(2008),
    [sym__high_prec_app] = STATE(2007),
    [sym__low_prec_app] = STATE(2007),
    [sym_application_expression] = STATE(2008),
    [sym_dot_expression] = STATE(2008),
    [sym_infix_expression] = STATE(2008),
    [sym_ce_expression] = STATE(2008),
    [sym_sequential_expression] = STATE(2008),
    [sym_char] = STATE(1859),
    [sym_format_string] = STATE(1861),
    [sym__string_literal] = STATE(1861),
    [sym_string] = STATE(1859),
    [sym_verbatim_string] = STATE(1859),
    [sym_bytearray] = STATE(1859),
    [sym_verbatim_bytearray] = STATE(1859),
    [sym_format_triple_quoted_string] = STATE(1862),
    [sym_triple_quoted_string] = STATE(1859),
    [sym_const] = STATE(2008),
    [sym_long_identifier] = STATE(1701),
    [sym_active_pattern] = STATE(1702),
    [sym__identifier_or_op] = STATE(1724),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(664),
    [sym_sbyte] = STATE(1859),
    [sym_byte] = STATE(1859),
    [sym_int16] = STATE(1859),
    [sym_uint16] = STATE(1859),
    [sym_int32] = STATE(1859),
    [sym_uint32] = STATE(1859),
    [sym_nativeint] = STATE(1859),
    [sym_unativeint] = STATE(1859),
    [sym_int64] = STATE(1859),
    [sym_uint64] = STATE(1859),
    [sym_ieee32] = STATE(1859),
    [sym_ieee64] = STATE(1859),
    [sym_bignum] = STATE(1859),
    [sym_decimal] = STATE(1859),
    [sym_float] = STATE(1447),
    [sym_block_comment] = STATE(475),
    [sym_compiler_directive_decl] = STATE(475),
    [sym_fsi_directive_decl] = STATE(475),
    [sym_preproc_line] = STATE(475),
    [sym_preproc_if_in_expression] = STATE(2008),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(503),
    [anon_sym_return] = ACTIONS(507),
    [anon_sym_do] = ACTIONS(599),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(511),
    [anon_sym_null] = ACTIONS(515),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(517),
    [anon_sym_LBRACK_PIPE] = ACTIONS(519),
    [anon_sym_LBRACE] = ACTIONS(2060),
    [anon_sym_LT_AT] = ACTIONS(523),
    [anon_sym_LT_AT_AT] = ACTIONS(2062),
    [anon_sym_LBRACE_PIPE] = ACTIONS(529),
    [anon_sym_new] = ACTIONS(507),
    [anon_sym_return_BANG] = ACTIONS(531),
    [anon_sym_yield] = ACTIONS(507),
    [anon_sym_yield_BANG] = ACTIONS(531),
    [anon_sym_lazy] = ACTIONS(507),
    [anon_sym_assert] = ACTIONS(507),
    [anon_sym_upcast] = ACTIONS(507),
    [anon_sym_downcast] = ACTIONS(507),
    [anon_sym_for] = ACTIONS(535),
    [anon_sym_while] = ACTIONS(537),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(539),
    [anon_sym_try] = ACTIONS(543),
    [anon_sym_match] = ACTIONS(545),
    [anon_sym_match_BANG] = ACTIONS(547),
    [anon_sym_function] = ACTIONS(549),
    [anon_sym_use] = ACTIONS(557),
    [anon_sym_use_BANG] = ACTIONS(559),
    [anon_sym_do_BANG] = ACTIONS(561),
    [anon_sym_begin] = ACTIONS(565),
    [aux_sym_char_token1] = ACTIONS(569),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(571),
    [anon_sym_DQUOTE] = ACTIONS(573),
    [anon_sym_AT_DQUOTE] = ACTIONS(575),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(577),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(579),
    [sym_bool] = ACTIONS(581),
    [sym_unit] = ACTIONS(2064),
    [anon_sym_LPAREN_PIPE] = ACTIONS(585),
    [sym_op_identifier] = ACTIONS(2066),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(589),
    [sym_xint] = ACTIONS(591),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(593),
    [sym__tuple_marker] = ACTIONS(2142),
  },
  [476] = {
    [sym_function_or_value_defn] = STATE(509),
    [sym__expression] = STATE(134),
    [sym_literal_expression] = STATE(2230),
    [sym_long_identifier_or_op] = STATE(2230),
    [sym_tuple_expression] = STATE(2230),
    [sym_brace_expression] = STATE(2230),
    [sym_anon_record_expression] = STATE(2230),
    [sym_prefixed_expression] = STATE(2230),
    [sym_typecast_expression] = STATE(2230),
    [sym_for_expression] = STATE(2230),
    [sym_while_expression] = STATE(2230),
    [sym__if_branch] = STATE(6659),
    [sym_if_expression] = STATE(2230),
    [sym_fun_expression] = STATE(2230),
    [sym_try_expression] = STATE(2230),
    [sym_match_expression] = STATE(2230),
    [sym_function_expression] = STATE(2230),
    [sym_mutate_expression] = STATE(2230),
    [sym_index_expression] = STATE(2230),
    [sym_typed_expression] = STATE(2230),
    [sym_declaration_expression] = STATE(2230),
    [sym_do_expression] = STATE(2230),
    [sym_list_expression] = STATE(2230),
    [sym_array_expression] = STATE(2230),
    [sym_range_expression] = STATE(6634),
    [sym_begin_end_expression] = STATE(2230),
    [sym_paren_expression] = STATE(2230),
    [sym__high_prec_app] = STATE(2229),
    [sym__low_prec_app] = STATE(2229),
    [sym_application_expression] = STATE(2230),
    [sym_dot_expression] = STATE(2230),
    [sym_infix_expression] = STATE(2230),
    [sym_ce_expression] = STATE(2230),
    [sym_sequential_expression] = STATE(2230),
    [sym_char] = STATE(2100),
    [sym_format_string] = STATE(2106),
    [sym__string_literal] = STATE(2106),
    [sym_string] = STATE(2100),
    [sym_verbatim_string] = STATE(2100),
    [sym_bytearray] = STATE(2100),
    [sym_verbatim_bytearray] = STATE(2100),
    [sym_format_triple_quoted_string] = STATE(2107),
    [sym_triple_quoted_string] = STATE(2100),
    [sym_const] = STATE(2230),
    [sym_long_identifier] = STATE(2232),
    [sym_active_pattern] = STATE(2424),
    [sym__identifier_or_op] = STATE(2305),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(737),
    [sym_sbyte] = STATE(2100),
    [sym_byte] = STATE(2100),
    [sym_int16] = STATE(2100),
    [sym_uint16] = STATE(2100),
    [sym_int32] = STATE(2100),
    [sym_uint32] = STATE(2100),
    [sym_nativeint] = STATE(2100),
    [sym_unativeint] = STATE(2100),
    [sym_int64] = STATE(2100),
    [sym_uint64] = STATE(2100),
    [sym_ieee32] = STATE(2100),
    [sym_ieee64] = STATE(2100),
    [sym_bignum] = STATE(2100),
    [sym_decimal] = STATE(2100),
    [sym_float] = STATE(1487),
    [sym_block_comment] = STATE(476),
    [sym_compiler_directive_decl] = STATE(476),
    [sym_fsi_directive_decl] = STATE(476),
    [sym_preproc_line] = STATE(476),
    [sym_preproc_if_in_expression] = STATE(2230),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(877),
    [anon_sym_return] = ACTIONS(881),
    [anon_sym_do] = ACTIONS(1585),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(885),
    [anon_sym_null] = ACTIONS(889),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(891),
    [anon_sym_LBRACK_PIPE] = ACTIONS(893),
    [anon_sym_LBRACE] = ACTIONS(2048),
    [anon_sym_LT_AT] = ACTIONS(897),
    [anon_sym_LT_AT_AT] = ACTIONS(2050),
    [anon_sym_LBRACE_PIPE] = ACTIONS(903),
    [anon_sym_new] = ACTIONS(881),
    [anon_sym_return_BANG] = ACTIONS(905),
    [anon_sym_yield] = ACTIONS(881),
    [anon_sym_yield_BANG] = ACTIONS(905),
    [anon_sym_lazy] = ACTIONS(881),
    [anon_sym_assert] = ACTIONS(881),
    [anon_sym_upcast] = ACTIONS(881),
    [anon_sym_downcast] = ACTIONS(881),
    [anon_sym_for] = ACTIONS(909),
    [anon_sym_while] = ACTIONS(911),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(913),
    [anon_sym_try] = ACTIONS(915),
    [anon_sym_match] = ACTIONS(917),
    [anon_sym_match_BANG] = ACTIONS(919),
    [anon_sym_function] = ACTIONS(921),
    [anon_sym_use] = ACTIONS(929),
    [anon_sym_use_BANG] = ACTIONS(931),
    [anon_sym_do_BANG] = ACTIONS(933),
    [anon_sym_begin] = ACTIONS(937),
    [aux_sym_char_token1] = ACTIONS(941),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(943),
    [anon_sym_DQUOTE] = ACTIONS(945),
    [anon_sym_AT_DQUOTE] = ACTIONS(947),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(949),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(951),
    [sym_bool] = ACTIONS(953),
    [sym_unit] = ACTIONS(2052),
    [anon_sym_LPAREN_PIPE] = ACTIONS(957),
    [sym_op_identifier] = ACTIONS(2054),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(961),
    [sym_xint] = ACTIONS(963),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(965),
  },
  [477] = {
    [sym_function_or_value_defn] = STATE(627),
    [sym__expression] = STATE(14),
    [sym_literal_expression] = STATE(1118),
    [sym_long_identifier_or_op] = STATE(1118),
    [sym_tuple_expression] = STATE(1118),
    [sym_brace_expression] = STATE(1118),
    [sym_anon_record_expression] = STATE(1118),
    [sym_prefixed_expression] = STATE(1118),
    [sym_typecast_expression] = STATE(1118),
    [sym_for_expression] = STATE(1118),
    [sym_while_expression] = STATE(1118),
    [sym__if_branch] = STATE(7163),
    [sym_if_expression] = STATE(1118),
    [sym_fun_expression] = STATE(1118),
    [sym_try_expression] = STATE(1118),
    [sym_match_expression] = STATE(1118),
    [sym_function_expression] = STATE(1118),
    [sym_mutate_expression] = STATE(1118),
    [sym_index_expression] = STATE(1118),
    [sym_typed_expression] = STATE(1118),
    [sym_declaration_expression] = STATE(1118),
    [sym_do_expression] = STATE(1118),
    [sym_list_expression] = STATE(1118),
    [sym_array_expression] = STATE(1118),
    [sym_begin_end_expression] = STATE(1118),
    [sym_paren_expression] = STATE(1118),
    [sym__high_prec_app] = STATE(1133),
    [sym__low_prec_app] = STATE(1133),
    [sym_application_expression] = STATE(1118),
    [sym_dot_expression] = STATE(1118),
    [sym_infix_expression] = STATE(1118),
    [sym_ce_expression] = STATE(1118),
    [sym_sequential_expression] = STATE(1118),
    [sym_char] = STATE(1080),
    [sym_format_string] = STATE(1090),
    [sym__string_literal] = STATE(1090),
    [sym_string] = STATE(1080),
    [sym_verbatim_string] = STATE(1080),
    [sym_bytearray] = STATE(1080),
    [sym_verbatim_bytearray] = STATE(1080),
    [sym_format_triple_quoted_string] = STATE(1096),
    [sym_triple_quoted_string] = STATE(1080),
    [sym_const] = STATE(1118),
    [sym_long_identifier] = STATE(1156),
    [sym_active_pattern] = STATE(1085),
    [sym__identifier_or_op] = STATE(1099),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(517),
    [sym_sbyte] = STATE(1080),
    [sym_byte] = STATE(1080),
    [sym_int16] = STATE(1080),
    [sym_uint16] = STATE(1080),
    [sym_int32] = STATE(1080),
    [sym_uint32] = STATE(1080),
    [sym_nativeint] = STATE(1080),
    [sym_unativeint] = STATE(1080),
    [sym_int64] = STATE(1080),
    [sym_uint64] = STATE(1080),
    [sym_ieee32] = STATE(1080),
    [sym_ieee64] = STATE(1080),
    [sym_bignum] = STATE(1080),
    [sym_decimal] = STATE(1080),
    [sym_float] = STATE(979),
    [sym_block_comment] = STATE(477),
    [sym_compiler_directive_decl] = STATE(477),
    [sym_fsi_directive_decl] = STATE(477),
    [sym_preproc_line] = STATE(477),
    [sym_preproc_if_in_expression] = STATE(1118),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(195),
    [anon_sym_return] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_null] = ACTIONS(207),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(209),
    [anon_sym_LBRACK_PIPE] = ACTIONS(211),
    [anon_sym_LBRACE] = ACTIONS(1687),
    [anon_sym_LT_AT] = ACTIONS(213),
    [anon_sym_LT_AT_AT] = ACTIONS(1689),
    [anon_sym_LBRACE_PIPE] = ACTIONS(217),
    [anon_sym_new] = ACTIONS(199),
    [anon_sym_return_BANG] = ACTIONS(219),
    [anon_sym_yield] = ACTIONS(199),
    [anon_sym_yield_BANG] = ACTIONS(219),
    [anon_sym_lazy] = ACTIONS(199),
    [anon_sym_assert] = ACTIONS(199),
    [anon_sym_upcast] = ACTIONS(199),
    [anon_sym_downcast] = ACTIONS(199),
    [anon_sym_for] = ACTIONS(223),
    [anon_sym_while] = ACTIONS(225),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(229),
    [anon_sym_match] = ACTIONS(231),
    [anon_sym_match_BANG] = ACTIONS(233),
    [anon_sym_function] = ACTIONS(235),
    [anon_sym_use] = ACTIONS(239),
    [anon_sym_use_BANG] = ACTIONS(241),
    [anon_sym_do_BANG] = ACTIONS(243),
    [anon_sym_begin] = ACTIONS(245),
    [aux_sym_char_token1] = ACTIONS(247),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(251),
    [anon_sym_AT_DQUOTE] = ACTIONS(253),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(255),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(257),
    [sym_bool] = ACTIONS(259),
    [sym_unit] = ACTIONS(1699),
    [anon_sym_LPAREN_PIPE] = ACTIONS(261),
    [sym_op_identifier] = ACTIONS(1701),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(265),
    [sym_xint] = ACTIONS(267),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(269),
    [sym__tuple_marker] = ACTIONS(2144),
  },
  [478] = {
    [sym_function_or_value_defn] = STATE(703),
    [sym__expression] = STATE(116),
    [sym_literal_expression] = STATE(1797),
    [sym_long_identifier_or_op] = STATE(1797),
    [sym_tuple_expression] = STATE(1797),
    [sym_brace_expression] = STATE(1797),
    [sym_anon_record_expression] = STATE(1797),
    [sym_prefixed_expression] = STATE(1797),
    [sym_typecast_expression] = STATE(1797),
    [sym_for_expression] = STATE(1797),
    [sym_while_expression] = STATE(1797),
    [sym__if_branch] = STATE(6611),
    [sym_if_expression] = STATE(1797),
    [sym_fun_expression] = STATE(1797),
    [sym_try_expression] = STATE(1797),
    [sym_match_expression] = STATE(1797),
    [sym_function_expression] = STATE(1797),
    [sym_mutate_expression] = STATE(1797),
    [sym_index_expression] = STATE(1797),
    [sym_typed_expression] = STATE(1797),
    [sym_declaration_expression] = STATE(1797),
    [sym_do_expression] = STATE(1797),
    [sym_list_expression] = STATE(1797),
    [sym_array_expression] = STATE(1797),
    [sym_begin_end_expression] = STATE(1797),
    [sym_paren_expression] = STATE(1797),
    [sym__high_prec_app] = STATE(1800),
    [sym__low_prec_app] = STATE(1800),
    [sym_application_expression] = STATE(1797),
    [sym_dot_expression] = STATE(1797),
    [sym_infix_expression] = STATE(1797),
    [sym_ce_expression] = STATE(1797),
    [sym_sequential_expression] = STATE(1797),
    [sym_char] = STATE(1694),
    [sym_format_string] = STATE(1693),
    [sym__string_literal] = STATE(1693),
    [sym_string] = STATE(1694),
    [sym_verbatim_string] = STATE(1694),
    [sym_bytearray] = STATE(1694),
    [sym_verbatim_bytearray] = STATE(1694),
    [sym_format_triple_quoted_string] = STATE(1692),
    [sym_triple_quoted_string] = STATE(1694),
    [sym_const] = STATE(1797),
    [sym_long_identifier] = STATE(1813),
    [sym_active_pattern] = STATE(1753),
    [sym__identifier_or_op] = STATE(1812),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(756),
    [sym_sbyte] = STATE(1694),
    [sym_byte] = STATE(1694),
    [sym_int16] = STATE(1694),
    [sym_uint16] = STATE(1694),
    [sym_int32] = STATE(1694),
    [sym_uint32] = STATE(1694),
    [sym_nativeint] = STATE(1694),
    [sym_unativeint] = STATE(1694),
    [sym_int64] = STATE(1694),
    [sym_uint64] = STATE(1694),
    [sym_ieee32] = STATE(1694),
    [sym_ieee64] = STATE(1694),
    [sym_bignum] = STATE(1694),
    [sym_decimal] = STATE(1694),
    [sym_float] = STATE(1425),
    [sym_block_comment] = STATE(478),
    [sym_compiler_directive_decl] = STATE(478),
    [sym_fsi_directive_decl] = STATE(478),
    [sym_preproc_line] = STATE(478),
    [sym_preproc_if_in_expression] = STATE(1797),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(393),
    [anon_sym_return] = ACTIONS(397),
    [anon_sym_do] = ACTIONS(399),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(401),
    [anon_sym_null] = ACTIONS(405),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(407),
    [anon_sym_LBRACK_PIPE] = ACTIONS(409),
    [anon_sym_LBRACE] = ACTIONS(2146),
    [anon_sym_LT_AT] = ACTIONS(413),
    [anon_sym_LT_AT_AT] = ACTIONS(2148),
    [anon_sym_LBRACE_PIPE] = ACTIONS(419),
    [anon_sym_new] = ACTIONS(397),
    [anon_sym_return_BANG] = ACTIONS(421),
    [anon_sym_yield] = ACTIONS(397),
    [anon_sym_yield_BANG] = ACTIONS(421),
    [anon_sym_lazy] = ACTIONS(397),
    [anon_sym_assert] = ACTIONS(397),
    [anon_sym_upcast] = ACTIONS(397),
    [anon_sym_downcast] = ACTIONS(397),
    [anon_sym_for] = ACTIONS(425),
    [anon_sym_while] = ACTIONS(427),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(429),
    [anon_sym_try] = ACTIONS(431),
    [anon_sym_match] = ACTIONS(433),
    [anon_sym_match_BANG] = ACTIONS(435),
    [anon_sym_function] = ACTIONS(437),
    [anon_sym_use] = ACTIONS(445),
    [anon_sym_use_BANG] = ACTIONS(447),
    [anon_sym_do_BANG] = ACTIONS(449),
    [anon_sym_begin] = ACTIONS(451),
    [aux_sym_char_token1] = ACTIONS(455),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(457),
    [anon_sym_DQUOTE] = ACTIONS(459),
    [anon_sym_AT_DQUOTE] = ACTIONS(461),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(463),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(465),
    [sym_bool] = ACTIONS(467),
    [sym_unit] = ACTIONS(2150),
    [anon_sym_LPAREN_PIPE] = ACTIONS(471),
    [sym_op_identifier] = ACTIONS(2152),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(475),
    [sym_xint] = ACTIONS(477),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(479),
    [sym__tuple_marker] = ACTIONS(2154),
  },
  [479] = {
    [sym_function_or_value_defn] = STATE(627),
    [sym__expression] = STATE(21),
    [sym_literal_expression] = STATE(1118),
    [sym_long_identifier_or_op] = STATE(1118),
    [sym_tuple_expression] = STATE(1118),
    [sym_brace_expression] = STATE(1118),
    [sym_anon_record_expression] = STATE(1118),
    [sym_prefixed_expression] = STATE(1118),
    [sym_typecast_expression] = STATE(1118),
    [sym_for_expression] = STATE(1118),
    [sym_while_expression] = STATE(1118),
    [sym__if_branch] = STATE(7163),
    [sym_if_expression] = STATE(1118),
    [sym_fun_expression] = STATE(1118),
    [sym_try_expression] = STATE(1118),
    [sym_match_expression] = STATE(1118),
    [sym_function_expression] = STATE(1118),
    [sym_mutate_expression] = STATE(1118),
    [sym_index_expression] = STATE(1118),
    [sym_typed_expression] = STATE(1118),
    [sym_declaration_expression] = STATE(1118),
    [sym_do_expression] = STATE(1118),
    [sym_list_expression] = STATE(1118),
    [sym_array_expression] = STATE(1118),
    [sym_begin_end_expression] = STATE(1118),
    [sym_paren_expression] = STATE(1118),
    [sym__high_prec_app] = STATE(1133),
    [sym__low_prec_app] = STATE(1133),
    [sym_application_expression] = STATE(1118),
    [sym_dot_expression] = STATE(1118),
    [sym_infix_expression] = STATE(1118),
    [sym_ce_expression] = STATE(1118),
    [sym_sequential_expression] = STATE(1118),
    [sym_char] = STATE(1080),
    [sym_format_string] = STATE(1090),
    [sym__string_literal] = STATE(1090),
    [sym_string] = STATE(1080),
    [sym_verbatim_string] = STATE(1080),
    [sym_bytearray] = STATE(1080),
    [sym_verbatim_bytearray] = STATE(1080),
    [sym_format_triple_quoted_string] = STATE(1096),
    [sym_triple_quoted_string] = STATE(1080),
    [sym_const] = STATE(1118),
    [sym_long_identifier] = STATE(1156),
    [sym_active_pattern] = STATE(1085),
    [sym__identifier_or_op] = STATE(1099),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(517),
    [sym_sbyte] = STATE(1080),
    [sym_byte] = STATE(1080),
    [sym_int16] = STATE(1080),
    [sym_uint16] = STATE(1080),
    [sym_int32] = STATE(1080),
    [sym_uint32] = STATE(1080),
    [sym_nativeint] = STATE(1080),
    [sym_unativeint] = STATE(1080),
    [sym_int64] = STATE(1080),
    [sym_uint64] = STATE(1080),
    [sym_ieee32] = STATE(1080),
    [sym_ieee64] = STATE(1080),
    [sym_bignum] = STATE(1080),
    [sym_decimal] = STATE(1080),
    [sym_float] = STATE(979),
    [sym_block_comment] = STATE(479),
    [sym_compiler_directive_decl] = STATE(479),
    [sym_fsi_directive_decl] = STATE(479),
    [sym_preproc_line] = STATE(479),
    [sym_preproc_if_in_expression] = STATE(1118),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(195),
    [anon_sym_return] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_null] = ACTIONS(207),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(209),
    [anon_sym_LBRACK_PIPE] = ACTIONS(211),
    [anon_sym_LBRACE] = ACTIONS(1687),
    [anon_sym_LT_AT] = ACTIONS(213),
    [anon_sym_LT_AT_AT] = ACTIONS(1689),
    [anon_sym_LBRACE_PIPE] = ACTIONS(217),
    [anon_sym_new] = ACTIONS(199),
    [anon_sym_with] = ACTIONS(2156),
    [anon_sym_return_BANG] = ACTIONS(219),
    [anon_sym_yield] = ACTIONS(199),
    [anon_sym_yield_BANG] = ACTIONS(219),
    [anon_sym_lazy] = ACTIONS(199),
    [anon_sym_assert] = ACTIONS(199),
    [anon_sym_upcast] = ACTIONS(199),
    [anon_sym_downcast] = ACTIONS(199),
    [anon_sym_for] = ACTIONS(223),
    [anon_sym_while] = ACTIONS(225),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(229),
    [anon_sym_match] = ACTIONS(231),
    [anon_sym_match_BANG] = ACTIONS(233),
    [anon_sym_function] = ACTIONS(235),
    [anon_sym_use] = ACTIONS(239),
    [anon_sym_use_BANG] = ACTIONS(241),
    [anon_sym_do_BANG] = ACTIONS(243),
    [anon_sym_begin] = ACTIONS(245),
    [aux_sym_char_token1] = ACTIONS(247),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(251),
    [anon_sym_AT_DQUOTE] = ACTIONS(253),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(255),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(257),
    [sym_bool] = ACTIONS(259),
    [sym_unit] = ACTIONS(1699),
    [anon_sym_LPAREN_PIPE] = ACTIONS(261),
    [sym_op_identifier] = ACTIONS(1701),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(265),
    [sym_xint] = ACTIONS(267),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(269),
  },
  [480] = {
    [sym_function_or_value_defn] = STATE(596),
    [sym__expression] = STATE(110),
    [sym_literal_expression] = STATE(1809),
    [sym_long_identifier_or_op] = STATE(1809),
    [sym_tuple_expression] = STATE(1809),
    [sym_brace_expression] = STATE(1809),
    [sym_anon_record_expression] = STATE(1809),
    [sym_prefixed_expression] = STATE(1809),
    [sym_typecast_expression] = STATE(1809),
    [sym_for_expression] = STATE(1809),
    [sym_while_expression] = STATE(1809),
    [sym__if_branch] = STATE(6874),
    [sym_if_expression] = STATE(1809),
    [sym_fun_expression] = STATE(1809),
    [sym_try_expression] = STATE(1809),
    [sym_match_expression] = STATE(1809),
    [sym_function_expression] = STATE(1809),
    [sym_mutate_expression] = STATE(1809),
    [sym_index_expression] = STATE(1809),
    [sym_typed_expression] = STATE(1809),
    [sym_declaration_expression] = STATE(1809),
    [sym_do_expression] = STATE(1809),
    [sym_list_expression] = STATE(1809),
    [sym_array_expression] = STATE(1809),
    [sym_begin_end_expression] = STATE(1809),
    [sym_paren_expression] = STATE(1809),
    [sym__high_prec_app] = STATE(1806),
    [sym__low_prec_app] = STATE(1806),
    [sym_application_expression] = STATE(1809),
    [sym_dot_expression] = STATE(1809),
    [sym_infix_expression] = STATE(1809),
    [sym_ce_expression] = STATE(1809),
    [sym_sequential_expression] = STATE(1809),
    [sym_char] = STATE(2014),
    [sym_format_string] = STATE(2019),
    [sym__string_literal] = STATE(2019),
    [sym_string] = STATE(2014),
    [sym_verbatim_string] = STATE(2014),
    [sym_bytearray] = STATE(2014),
    [sym_verbatim_bytearray] = STATE(2014),
    [sym_format_triple_quoted_string] = STATE(2020),
    [sym_triple_quoted_string] = STATE(2014),
    [sym_const] = STATE(1809),
    [sym_long_identifier] = STATE(1810),
    [sym_active_pattern] = STATE(1860),
    [sym__identifier_or_op] = STATE(1750),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(655),
    [sym_sbyte] = STATE(2014),
    [sym_byte] = STATE(2014),
    [sym_int16] = STATE(2014),
    [sym_uint16] = STATE(2014),
    [sym_int32] = STATE(2014),
    [sym_uint32] = STATE(2014),
    [sym_nativeint] = STATE(2014),
    [sym_unativeint] = STATE(2014),
    [sym_int64] = STATE(2014),
    [sym_uint64] = STATE(2014),
    [sym_ieee32] = STATE(2014),
    [sym_ieee64] = STATE(2014),
    [sym_bignum] = STATE(2014),
    [sym_decimal] = STATE(2014),
    [sym_float] = STATE(1438),
    [sym_block_comment] = STATE(480),
    [sym_compiler_directive_decl] = STATE(480),
    [sym_fsi_directive_decl] = STATE(480),
    [sym_preproc_line] = STATE(480),
    [sym_preproc_if_in_expression] = STATE(1809),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(723),
    [anon_sym_return] = ACTIONS(727),
    [anon_sym_do] = ACTIONS(729),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(731),
    [anon_sym_null] = ACTIONS(735),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(737),
    [anon_sym_LBRACK_PIPE] = ACTIONS(739),
    [anon_sym_LBRACE] = ACTIONS(2112),
    [anon_sym_LT_AT] = ACTIONS(743),
    [anon_sym_LT_AT_AT] = ACTIONS(2114),
    [anon_sym_LBRACE_PIPE] = ACTIONS(749),
    [anon_sym_new] = ACTIONS(727),
    [anon_sym_return_BANG] = ACTIONS(751),
    [anon_sym_yield] = ACTIONS(727),
    [anon_sym_yield_BANG] = ACTIONS(751),
    [anon_sym_lazy] = ACTIONS(727),
    [anon_sym_assert] = ACTIONS(727),
    [anon_sym_upcast] = ACTIONS(727),
    [anon_sym_downcast] = ACTIONS(727),
    [anon_sym_for] = ACTIONS(755),
    [anon_sym_while] = ACTIONS(757),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(759),
    [anon_sym_try] = ACTIONS(761),
    [anon_sym_match] = ACTIONS(763),
    [anon_sym_match_BANG] = ACTIONS(765),
    [anon_sym_function] = ACTIONS(767),
    [anon_sym_use] = ACTIONS(775),
    [anon_sym_use_BANG] = ACTIONS(777),
    [anon_sym_do_BANG] = ACTIONS(779),
    [anon_sym_begin] = ACTIONS(781),
    [aux_sym_char_token1] = ACTIONS(785),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(787),
    [anon_sym_DQUOTE] = ACTIONS(789),
    [anon_sym_AT_DQUOTE] = ACTIONS(791),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(793),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(795),
    [sym_bool] = ACTIONS(797),
    [sym_unit] = ACTIONS(2116),
    [anon_sym_LPAREN_PIPE] = ACTIONS(801),
    [sym_op_identifier] = ACTIONS(2118),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(805),
    [sym_xint] = ACTIONS(807),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(809),
  },
  [481] = {
    [sym_function_or_value_defn] = STATE(596),
    [sym__expression] = STATE(128),
    [sym_literal_expression] = STATE(1809),
    [sym_long_identifier_or_op] = STATE(1809),
    [sym_tuple_expression] = STATE(1809),
    [sym_brace_expression] = STATE(1809),
    [sym_anon_record_expression] = STATE(1809),
    [sym_prefixed_expression] = STATE(1809),
    [sym_typecast_expression] = STATE(1809),
    [sym_for_expression] = STATE(1809),
    [sym_while_expression] = STATE(1809),
    [sym__if_branch] = STATE(6874),
    [sym_if_expression] = STATE(1809),
    [sym_fun_expression] = STATE(1809),
    [sym_try_expression] = STATE(1809),
    [sym_match_expression] = STATE(1809),
    [sym_function_expression] = STATE(1809),
    [sym_mutate_expression] = STATE(1809),
    [sym_index_expression] = STATE(1809),
    [sym_typed_expression] = STATE(1809),
    [sym_declaration_expression] = STATE(1809),
    [sym_do_expression] = STATE(1809),
    [sym_list_expression] = STATE(1809),
    [sym_array_expression] = STATE(1809),
    [sym_begin_end_expression] = STATE(1809),
    [sym_paren_expression] = STATE(1809),
    [sym__high_prec_app] = STATE(1806),
    [sym__low_prec_app] = STATE(1806),
    [sym_application_expression] = STATE(1809),
    [sym_dot_expression] = STATE(1809),
    [sym_infix_expression] = STATE(1809),
    [sym_ce_expression] = STATE(1809),
    [sym_sequential_expression] = STATE(1809),
    [sym_char] = STATE(2014),
    [sym_format_string] = STATE(2019),
    [sym__string_literal] = STATE(2019),
    [sym_string] = STATE(2014),
    [sym_verbatim_string] = STATE(2014),
    [sym_bytearray] = STATE(2014),
    [sym_verbatim_bytearray] = STATE(2014),
    [sym_format_triple_quoted_string] = STATE(2020),
    [sym_triple_quoted_string] = STATE(2014),
    [sym_const] = STATE(1809),
    [sym_long_identifier] = STATE(1810),
    [sym_active_pattern] = STATE(1860),
    [sym__identifier_or_op] = STATE(1750),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(655),
    [sym_sbyte] = STATE(2014),
    [sym_byte] = STATE(2014),
    [sym_int16] = STATE(2014),
    [sym_uint16] = STATE(2014),
    [sym_int32] = STATE(2014),
    [sym_uint32] = STATE(2014),
    [sym_nativeint] = STATE(2014),
    [sym_unativeint] = STATE(2014),
    [sym_int64] = STATE(2014),
    [sym_uint64] = STATE(2014),
    [sym_ieee32] = STATE(2014),
    [sym_ieee64] = STATE(2014),
    [sym_bignum] = STATE(2014),
    [sym_decimal] = STATE(2014),
    [sym_float] = STATE(1438),
    [sym_block_comment] = STATE(481),
    [sym_compiler_directive_decl] = STATE(481),
    [sym_fsi_directive_decl] = STATE(481),
    [sym_preproc_line] = STATE(481),
    [sym_preproc_if_in_expression] = STATE(1809),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(723),
    [anon_sym_return] = ACTIONS(727),
    [anon_sym_do] = ACTIONS(729),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(731),
    [anon_sym_null] = ACTIONS(735),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(737),
    [anon_sym_LBRACK_PIPE] = ACTIONS(739),
    [anon_sym_LBRACE] = ACTIONS(2112),
    [anon_sym_LT_AT] = ACTIONS(743),
    [anon_sym_LT_AT_AT] = ACTIONS(2114),
    [anon_sym_LBRACE_PIPE] = ACTIONS(749),
    [anon_sym_new] = ACTIONS(727),
    [anon_sym_return_BANG] = ACTIONS(751),
    [anon_sym_yield] = ACTIONS(727),
    [anon_sym_yield_BANG] = ACTIONS(751),
    [anon_sym_lazy] = ACTIONS(727),
    [anon_sym_assert] = ACTIONS(727),
    [anon_sym_upcast] = ACTIONS(727),
    [anon_sym_downcast] = ACTIONS(727),
    [anon_sym_for] = ACTIONS(755),
    [anon_sym_while] = ACTIONS(757),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(759),
    [anon_sym_try] = ACTIONS(761),
    [anon_sym_match] = ACTIONS(763),
    [anon_sym_match_BANG] = ACTIONS(765),
    [anon_sym_function] = ACTIONS(767),
    [anon_sym_use] = ACTIONS(775),
    [anon_sym_use_BANG] = ACTIONS(777),
    [anon_sym_do_BANG] = ACTIONS(779),
    [anon_sym_begin] = ACTIONS(781),
    [aux_sym_char_token1] = ACTIONS(785),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(787),
    [anon_sym_DQUOTE] = ACTIONS(789),
    [anon_sym_AT_DQUOTE] = ACTIONS(791),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(793),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(795),
    [sym_bool] = ACTIONS(797),
    [sym_unit] = ACTIONS(2116),
    [anon_sym_LPAREN_PIPE] = ACTIONS(801),
    [sym_op_identifier] = ACTIONS(2118),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(805),
    [sym_xint] = ACTIONS(807),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(809),
  },
  [482] = {
    [sym_function_or_value_defn] = STATE(482),
    [sym__expression] = STATE(27),
    [sym_literal_expression] = STATE(1537),
    [sym_long_identifier_or_op] = STATE(1537),
    [sym_tuple_expression] = STATE(1537),
    [sym_brace_expression] = STATE(1537),
    [sym_anon_record_expression] = STATE(1537),
    [sym_prefixed_expression] = STATE(1537),
    [sym_typecast_expression] = STATE(1537),
    [sym_for_expression] = STATE(1537),
    [sym_while_expression] = STATE(1537),
    [sym__if_branch] = STATE(6834),
    [sym_if_expression] = STATE(1537),
    [sym_fun_expression] = STATE(1537),
    [sym_try_expression] = STATE(1537),
    [sym_match_expression] = STATE(1537),
    [sym_function_expression] = STATE(1537),
    [sym_mutate_expression] = STATE(1537),
    [sym_index_expression] = STATE(1537),
    [sym_typed_expression] = STATE(1537),
    [sym_declaration_expression] = STATE(1537),
    [sym_do_expression] = STATE(1537),
    [sym_list_expression] = STATE(1537),
    [sym_array_expression] = STATE(1537),
    [sym_begin_end_expression] = STATE(1537),
    [sym_paren_expression] = STATE(1537),
    [sym__high_prec_app] = STATE(1538),
    [sym__low_prec_app] = STATE(1538),
    [sym_application_expression] = STATE(1537),
    [sym_dot_expression] = STATE(1537),
    [sym_infix_expression] = STATE(1537),
    [sym_ce_expression] = STATE(1537),
    [sym_sequential_expression] = STATE(1537),
    [sym_char] = STATE(1484),
    [sym_format_string] = STATE(1483),
    [sym__string_literal] = STATE(1483),
    [sym_string] = STATE(1484),
    [sym_verbatim_string] = STATE(1484),
    [sym_bytearray] = STATE(1484),
    [sym_verbatim_bytearray] = STATE(1484),
    [sym_format_triple_quoted_string] = STATE(1482),
    [sym_triple_quoted_string] = STATE(1484),
    [sym_const] = STATE(1537),
    [sym_long_identifier] = STATE(1643),
    [sym_active_pattern] = STATE(1645),
    [sym__identifier_or_op] = STATE(1689),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(670),
    [sym_sbyte] = STATE(1484),
    [sym_byte] = STATE(1484),
    [sym_int16] = STATE(1484),
    [sym_uint16] = STATE(1484),
    [sym_int32] = STATE(1484),
    [sym_uint32] = STATE(1484),
    [sym_nativeint] = STATE(1484),
    [sym_unativeint] = STATE(1484),
    [sym_int64] = STATE(1484),
    [sym_uint64] = STATE(1484),
    [sym_ieee32] = STATE(1484),
    [sym_ieee64] = STATE(1484),
    [sym_bignum] = STATE(1484),
    [sym_decimal] = STATE(1484),
    [sym_float] = STATE(1327),
    [sym_block_comment] = STATE(482),
    [sym_compiler_directive_decl] = STATE(482),
    [sym_fsi_directive_decl] = STATE(482),
    [sym_preproc_line] = STATE(482),
    [sym_preproc_if_in_expression] = STATE(1537),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(275),
    [anon_sym_return] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(281),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(285),
    [anon_sym_null] = ACTIONS(289),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(291),
    [anon_sym_LBRACK_PIPE] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(2128),
    [anon_sym_LT_AT] = ACTIONS(297),
    [anon_sym_LT_AT_AT] = ACTIONS(2130),
    [anon_sym_LBRACE_PIPE] = ACTIONS(303),
    [anon_sym_new] = ACTIONS(279),
    [anon_sym_return_BANG] = ACTIONS(307),
    [anon_sym_yield] = ACTIONS(279),
    [anon_sym_yield_BANG] = ACTIONS(307),
    [anon_sym_lazy] = ACTIONS(279),
    [anon_sym_assert] = ACTIONS(279),
    [anon_sym_upcast] = ACTIONS(279),
    [anon_sym_downcast] = ACTIONS(279),
    [anon_sym_for] = ACTIONS(311),
    [anon_sym_while] = ACTIONS(313),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(315),
    [anon_sym_try] = ACTIONS(317),
    [anon_sym_match] = ACTIONS(319),
    [anon_sym_match_BANG] = ACTIONS(321),
    [anon_sym_function] = ACTIONS(323),
    [anon_sym_use] = ACTIONS(331),
    [anon_sym_use_BANG] = ACTIONS(333),
    [anon_sym_do_BANG] = ACTIONS(335),
    [anon_sym_begin] = ACTIONS(337),
    [aux_sym_char_token1] = ACTIONS(341),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(343),
    [anon_sym_DQUOTE] = ACTIONS(345),
    [anon_sym_AT_DQUOTE] = ACTIONS(347),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(349),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(351),
    [sym_bool] = ACTIONS(353),
    [sym_unit] = ACTIONS(2132),
    [anon_sym_LPAREN_PIPE] = ACTIONS(357),
    [sym_op_identifier] = ACTIONS(2134),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(361),
    [sym_xint] = ACTIONS(363),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(365),
  },
  [483] = {
    [sym_function_or_value_defn] = STATE(705),
    [sym__expression] = STATE(3),
    [sym_literal_expression] = STATE(867),
    [sym_long_identifier_or_op] = STATE(867),
    [sym_tuple_expression] = STATE(867),
    [sym_brace_expression] = STATE(867),
    [sym_anon_record_expression] = STATE(867),
    [sym_prefixed_expression] = STATE(867),
    [sym_typecast_expression] = STATE(867),
    [sym_for_expression] = STATE(867),
    [sym_while_expression] = STATE(867),
    [sym__if_branch] = STATE(6511),
    [sym_if_expression] = STATE(867),
    [sym_fun_expression] = STATE(867),
    [sym_try_expression] = STATE(867),
    [sym_match_expression] = STATE(867),
    [sym_function_expression] = STATE(867),
    [sym_mutate_expression] = STATE(867),
    [sym_index_expression] = STATE(867),
    [sym_typed_expression] = STATE(867),
    [sym_declaration_expression] = STATE(867),
    [sym_do_expression] = STATE(867),
    [sym_list_expression] = STATE(867),
    [sym_array_expression] = STATE(867),
    [sym_begin_end_expression] = STATE(867),
    [sym_paren_expression] = STATE(867),
    [sym__high_prec_app] = STATE(864),
    [sym__low_prec_app] = STATE(864),
    [sym_application_expression] = STATE(867),
    [sym_dot_expression] = STATE(867),
    [sym_infix_expression] = STATE(867),
    [sym_ce_expression] = STATE(867),
    [sym_sequential_expression] = STATE(867),
    [sym_char] = STATE(868),
    [sym_format_string] = STATE(869),
    [sym__string_literal] = STATE(869),
    [sym_string] = STATE(868),
    [sym_verbatim_string] = STATE(868),
    [sym_bytearray] = STATE(868),
    [sym_verbatim_bytearray] = STATE(868),
    [sym_format_triple_quoted_string] = STATE(870),
    [sym_triple_quoted_string] = STATE(868),
    [sym_const] = STATE(867),
    [sym_long_identifier] = STATE(872),
    [sym_active_pattern] = STATE(871),
    [sym__identifier_or_op] = STATE(873),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(658),
    [sym_sbyte] = STATE(868),
    [sym_byte] = STATE(868),
    [sym_int16] = STATE(868),
    [sym_uint16] = STATE(868),
    [sym_int32] = STATE(868),
    [sym_uint32] = STATE(868),
    [sym_nativeint] = STATE(868),
    [sym_unativeint] = STATE(868),
    [sym_int64] = STATE(868),
    [sym_uint64] = STATE(868),
    [sym_ieee32] = STATE(868),
    [sym_ieee64] = STATE(868),
    [sym_bignum] = STATE(868),
    [sym_decimal] = STATE(868),
    [sym_float] = STATE(860),
    [sym_block_comment] = STATE(483),
    [sym_compiler_directive_decl] = STATE(483),
    [sym_fsi_directive_decl] = STATE(483),
    [sym_preproc_line] = STATE(483),
    [sym_preproc_if_in_expression] = STATE(867),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(29),
    [anon_sym_return] = ACTIONS(37),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_null] = ACTIONS(49),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACK_PIPE] = ACTIONS(57),
    [anon_sym_LBRACE] = ACTIONS(1663),
    [anon_sym_LT_AT] = ACTIONS(61),
    [anon_sym_LT_AT_AT] = ACTIONS(1665),
    [anon_sym_LBRACE_PIPE] = ACTIONS(67),
    [anon_sym_new] = ACTIONS(37),
    [anon_sym_return_BANG] = ACTIONS(69),
    [anon_sym_yield] = ACTIONS(37),
    [anon_sym_yield_BANG] = ACTIONS(69),
    [anon_sym_lazy] = ACTIONS(37),
    [anon_sym_assert] = ACTIONS(37),
    [anon_sym_upcast] = ACTIONS(37),
    [anon_sym_downcast] = ACTIONS(37),
    [anon_sym_for] = ACTIONS(73),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(79),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_match] = ACTIONS(83),
    [anon_sym_match_BANG] = ACTIONS(85),
    [anon_sym_function] = ACTIONS(87),
    [anon_sym_use] = ACTIONS(95),
    [anon_sym_use_BANG] = ACTIONS(97),
    [anon_sym_do_BANG] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(101),
    [aux_sym_char_token1] = ACTIONS(105),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(107),
    [anon_sym_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DQUOTE] = ACTIONS(111),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(115),
    [sym_bool] = ACTIONS(117),
    [sym_unit] = ACTIONS(1673),
    [anon_sym_LPAREN_PIPE] = ACTIONS(121),
    [sym_op_identifier] = ACTIONS(1675),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(129),
    [sym_xint] = ACTIONS(131),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(135),
  },
  [484] = {
    [sym_function_or_value_defn] = STATE(600),
    [sym__expression] = STATE(202),
    [sym_literal_expression] = STATE(867),
    [sym_long_identifier_or_op] = STATE(867),
    [sym_tuple_expression] = STATE(867),
    [sym_brace_expression] = STATE(867),
    [sym_anon_record_expression] = STATE(867),
    [sym_prefixed_expression] = STATE(867),
    [sym_typecast_expression] = STATE(867),
    [sym_for_expression] = STATE(867),
    [sym_while_expression] = STATE(867),
    [sym__if_branch] = STATE(6511),
    [sym_if_expression] = STATE(867),
    [sym_fun_expression] = STATE(867),
    [sym_try_expression] = STATE(867),
    [sym_match_expression] = STATE(867),
    [sym_function_expression] = STATE(867),
    [sym_mutate_expression] = STATE(867),
    [sym_index_expression] = STATE(867),
    [sym_typed_expression] = STATE(867),
    [sym_declaration_expression] = STATE(867),
    [sym_do_expression] = STATE(867),
    [sym_list_expression] = STATE(867),
    [sym_array_expression] = STATE(867),
    [sym_begin_end_expression] = STATE(867),
    [sym_paren_expression] = STATE(867),
    [sym__high_prec_app] = STATE(864),
    [sym__low_prec_app] = STATE(864),
    [sym_application_expression] = STATE(867),
    [sym_dot_expression] = STATE(867),
    [sym_infix_expression] = STATE(867),
    [sym_ce_expression] = STATE(867),
    [sym_sequential_expression] = STATE(867),
    [sym_char] = STATE(868),
    [sym_format_string] = STATE(869),
    [sym__string_literal] = STATE(869),
    [sym_string] = STATE(868),
    [sym_verbatim_string] = STATE(868),
    [sym_bytearray] = STATE(868),
    [sym_verbatim_bytearray] = STATE(868),
    [sym_format_triple_quoted_string] = STATE(870),
    [sym_triple_quoted_string] = STATE(868),
    [sym_const] = STATE(867),
    [sym_long_identifier] = STATE(872),
    [sym_active_pattern] = STATE(871),
    [sym__identifier_or_op] = STATE(873),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(656),
    [sym_sbyte] = STATE(868),
    [sym_byte] = STATE(868),
    [sym_int16] = STATE(868),
    [sym_uint16] = STATE(868),
    [sym_int32] = STATE(868),
    [sym_uint32] = STATE(868),
    [sym_nativeint] = STATE(868),
    [sym_unativeint] = STATE(868),
    [sym_int64] = STATE(868),
    [sym_uint64] = STATE(868),
    [sym_ieee32] = STATE(868),
    [sym_ieee64] = STATE(868),
    [sym_bignum] = STATE(868),
    [sym_decimal] = STATE(868),
    [sym_float] = STATE(1368),
    [sym_block_comment] = STATE(484),
    [sym_compiler_directive_decl] = STATE(484),
    [sym_fsi_directive_decl] = STATE(484),
    [sym_preproc_line] = STATE(484),
    [sym_preproc_if_in_expression] = STATE(867),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(29),
    [anon_sym_return] = ACTIONS(825),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_null] = ACTIONS(49),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACK_PIPE] = ACTIONS(57),
    [anon_sym_LBRACE] = ACTIONS(1663),
    [anon_sym_LT_AT] = ACTIONS(61),
    [anon_sym_LT_AT_AT] = ACTIONS(1665),
    [anon_sym_LBRACE_PIPE] = ACTIONS(67),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_return_BANG] = ACTIONS(829),
    [anon_sym_yield] = ACTIONS(825),
    [anon_sym_yield_BANG] = ACTIONS(829),
    [anon_sym_lazy] = ACTIONS(825),
    [anon_sym_assert] = ACTIONS(825),
    [anon_sym_upcast] = ACTIONS(825),
    [anon_sym_downcast] = ACTIONS(825),
    [anon_sym_for] = ACTIONS(73),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(79),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_match] = ACTIONS(83),
    [anon_sym_match_BANG] = ACTIONS(85),
    [anon_sym_function] = ACTIONS(87),
    [anon_sym_use] = ACTIONS(833),
    [anon_sym_use_BANG] = ACTIONS(835),
    [anon_sym_do_BANG] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(101),
    [aux_sym_char_token1] = ACTIONS(105),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(107),
    [anon_sym_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DQUOTE] = ACTIONS(111),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(115),
    [sym_bool] = ACTIONS(117),
    [sym_unit] = ACTIONS(1673),
    [anon_sym_LPAREN_PIPE] = ACTIONS(121),
    [sym_op_identifier] = ACTIONS(1675),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(837),
    [sym_xint] = ACTIONS(387),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(135),
  },
  [485] = {
    [sym_function_or_value_defn] = STATE(630),
    [sym__expression] = STATE(156),
    [sym_literal_expression] = STATE(2380),
    [sym_long_identifier_or_op] = STATE(2380),
    [sym_tuple_expression] = STATE(2380),
    [sym_brace_expression] = STATE(2380),
    [sym_anon_record_expression] = STATE(2380),
    [sym_prefixed_expression] = STATE(2380),
    [sym_typecast_expression] = STATE(2380),
    [sym_for_expression] = STATE(2380),
    [sym_while_expression] = STATE(2380),
    [sym__if_branch] = STATE(6456),
    [sym_if_expression] = STATE(2380),
    [sym_fun_expression] = STATE(2380),
    [sym_try_expression] = STATE(2380),
    [sym_match_expression] = STATE(2380),
    [sym_function_expression] = STATE(2380),
    [sym_mutate_expression] = STATE(2380),
    [sym_index_expression] = STATE(2380),
    [sym_typed_expression] = STATE(2380),
    [sym_declaration_expression] = STATE(2380),
    [sym_do_expression] = STATE(2380),
    [sym_list_expression] = STATE(2380),
    [sym_array_expression] = STATE(2380),
    [sym_begin_end_expression] = STATE(2380),
    [sym_paren_expression] = STATE(2380),
    [sym__high_prec_app] = STATE(2383),
    [sym__low_prec_app] = STATE(2383),
    [sym_application_expression] = STATE(2380),
    [sym_dot_expression] = STATE(2380),
    [sym_infix_expression] = STATE(2380),
    [sym_ce_expression] = STATE(2380),
    [sym_sequential_expression] = STATE(2380),
    [sym_char] = STATE(2261),
    [sym_format_string] = STATE(2274),
    [sym__string_literal] = STATE(2274),
    [sym_string] = STATE(2261),
    [sym_verbatim_string] = STATE(2261),
    [sym_bytearray] = STATE(2261),
    [sym_verbatim_bytearray] = STATE(2261),
    [sym_format_triple_quoted_string] = STATE(2275),
    [sym_triple_quoted_string] = STATE(2261),
    [sym_const] = STATE(2380),
    [sym_long_identifier] = STATE(2391),
    [sym_active_pattern] = STATE(2470),
    [sym__identifier_or_op] = STATE(2390),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(632),
    [sym_sbyte] = STATE(2261),
    [sym_byte] = STATE(2261),
    [sym_int16] = STATE(2261),
    [sym_uint16] = STATE(2261),
    [sym_int32] = STATE(2261),
    [sym_uint32] = STATE(2261),
    [sym_nativeint] = STATE(2261),
    [sym_unativeint] = STATE(2261),
    [sym_int64] = STATE(2261),
    [sym_uint64] = STATE(2261),
    [sym_ieee32] = STATE(2261),
    [sym_ieee64] = STATE(2261),
    [sym_bignum] = STATE(2261),
    [sym_decimal] = STATE(2261),
    [sym_float] = STATE(1614),
    [sym_block_comment] = STATE(485),
    [sym_compiler_directive_decl] = STATE(485),
    [sym_fsi_directive_decl] = STATE(485),
    [sym_preproc_line] = STATE(485),
    [sym_preproc_if_in_expression] = STATE(2380),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(1081),
    [anon_sym_return] = ACTIONS(1085),
    [anon_sym_do] = ACTIONS(1087),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(1089),
    [anon_sym_null] = ACTIONS(1093),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1095),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1097),
    [anon_sym_LBRACE] = ACTIONS(2100),
    [anon_sym_LT_AT] = ACTIONS(1101),
    [anon_sym_LT_AT_AT] = ACTIONS(2102),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1107),
    [anon_sym_new] = ACTIONS(1085),
    [anon_sym_return_BANG] = ACTIONS(1109),
    [anon_sym_yield] = ACTIONS(1085),
    [anon_sym_yield_BANG] = ACTIONS(1109),
    [anon_sym_lazy] = ACTIONS(1085),
    [anon_sym_assert] = ACTIONS(1085),
    [anon_sym_upcast] = ACTIONS(1085),
    [anon_sym_downcast] = ACTIONS(1085),
    [anon_sym_for] = ACTIONS(1113),
    [anon_sym_while] = ACTIONS(1115),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(1117),
    [anon_sym_try] = ACTIONS(1119),
    [anon_sym_match] = ACTIONS(1121),
    [anon_sym_match_BANG] = ACTIONS(1123),
    [anon_sym_function] = ACTIONS(1125),
    [anon_sym_use] = ACTIONS(1133),
    [anon_sym_use_BANG] = ACTIONS(1135),
    [anon_sym_do_BANG] = ACTIONS(1137),
    [anon_sym_begin] = ACTIONS(1139),
    [aux_sym_char_token1] = ACTIONS(1143),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1145),
    [anon_sym_DQUOTE] = ACTIONS(1147),
    [anon_sym_AT_DQUOTE] = ACTIONS(1149),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1151),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1153),
    [sym_bool] = ACTIONS(1155),
    [sym_unit] = ACTIONS(2104),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1159),
    [sym_op_identifier] = ACTIONS(2106),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(1163),
    [sym_xint] = ACTIONS(1165),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1167),
  },
  [486] = {
    [sym_function_or_value_defn] = STATE(600),
    [sym__expression] = STATE(244),
    [sym_literal_expression] = STATE(867),
    [sym_long_identifier_or_op] = STATE(867),
    [sym_tuple_expression] = STATE(867),
    [sym_brace_expression] = STATE(867),
    [sym_anon_record_expression] = STATE(867),
    [sym_prefixed_expression] = STATE(867),
    [sym_typecast_expression] = STATE(867),
    [sym_for_expression] = STATE(867),
    [sym_while_expression] = STATE(867),
    [sym__if_branch] = STATE(6511),
    [sym_if_expression] = STATE(867),
    [sym_fun_expression] = STATE(867),
    [sym_try_expression] = STATE(867),
    [sym_match_expression] = STATE(867),
    [sym_function_expression] = STATE(867),
    [sym_mutate_expression] = STATE(867),
    [sym_index_expression] = STATE(867),
    [sym_typed_expression] = STATE(867),
    [sym_declaration_expression] = STATE(867),
    [sym_do_expression] = STATE(867),
    [sym_list_expression] = STATE(867),
    [sym_array_expression] = STATE(867),
    [sym_begin_end_expression] = STATE(867),
    [sym_paren_expression] = STATE(867),
    [sym__high_prec_app] = STATE(864),
    [sym__low_prec_app] = STATE(864),
    [sym_application_expression] = STATE(867),
    [sym_dot_expression] = STATE(867),
    [sym_infix_expression] = STATE(867),
    [sym_ce_expression] = STATE(867),
    [sym_sequential_expression] = STATE(867),
    [sym_char] = STATE(868),
    [sym_format_string] = STATE(869),
    [sym__string_literal] = STATE(869),
    [sym_string] = STATE(868),
    [sym_verbatim_string] = STATE(868),
    [sym_bytearray] = STATE(868),
    [sym_verbatim_bytearray] = STATE(868),
    [sym_format_triple_quoted_string] = STATE(870),
    [sym_triple_quoted_string] = STATE(868),
    [sym_const] = STATE(867),
    [sym_long_identifier] = STATE(872),
    [sym_active_pattern] = STATE(871),
    [sym__identifier_or_op] = STATE(873),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(656),
    [sym_sbyte] = STATE(868),
    [sym_byte] = STATE(868),
    [sym_int16] = STATE(868),
    [sym_uint16] = STATE(868),
    [sym_int32] = STATE(868),
    [sym_uint32] = STATE(868),
    [sym_nativeint] = STATE(868),
    [sym_unativeint] = STATE(868),
    [sym_int64] = STATE(868),
    [sym_uint64] = STATE(868),
    [sym_ieee32] = STATE(868),
    [sym_ieee64] = STATE(868),
    [sym_bignum] = STATE(868),
    [sym_decimal] = STATE(868),
    [sym_float] = STATE(1368),
    [sym_block_comment] = STATE(486),
    [sym_compiler_directive_decl] = STATE(486),
    [sym_fsi_directive_decl] = STATE(486),
    [sym_preproc_line] = STATE(486),
    [sym_preproc_if_in_expression] = STATE(867),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(29),
    [anon_sym_return] = ACTIONS(825),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_null] = ACTIONS(49),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACK_PIPE] = ACTIONS(57),
    [anon_sym_LBRACE] = ACTIONS(1663),
    [anon_sym_LT_AT] = ACTIONS(61),
    [anon_sym_LT_AT_AT] = ACTIONS(1665),
    [anon_sym_LBRACE_PIPE] = ACTIONS(67),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_return_BANG] = ACTIONS(829),
    [anon_sym_yield] = ACTIONS(825),
    [anon_sym_yield_BANG] = ACTIONS(829),
    [anon_sym_lazy] = ACTIONS(825),
    [anon_sym_assert] = ACTIONS(825),
    [anon_sym_upcast] = ACTIONS(825),
    [anon_sym_downcast] = ACTIONS(825),
    [anon_sym_for] = ACTIONS(73),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(79),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_match] = ACTIONS(83),
    [anon_sym_match_BANG] = ACTIONS(85),
    [anon_sym_function] = ACTIONS(87),
    [anon_sym_use] = ACTIONS(833),
    [anon_sym_use_BANG] = ACTIONS(835),
    [anon_sym_do_BANG] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(101),
    [aux_sym_char_token1] = ACTIONS(105),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(107),
    [anon_sym_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DQUOTE] = ACTIONS(111),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(115),
    [sym_bool] = ACTIONS(117),
    [sym_unit] = ACTIONS(1673),
    [anon_sym_LPAREN_PIPE] = ACTIONS(121),
    [sym_op_identifier] = ACTIONS(1675),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(837),
    [sym_xint] = ACTIONS(387),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(135),
  },
  [487] = {
    [sym_function_or_value_defn] = STATE(627),
    [sym__expression] = STATE(13),
    [sym_literal_expression] = STATE(1118),
    [sym_long_identifier_or_op] = STATE(1118),
    [sym_tuple_expression] = STATE(1118),
    [sym_brace_expression] = STATE(1118),
    [sym_anon_record_expression] = STATE(1118),
    [sym_prefixed_expression] = STATE(1118),
    [sym_typecast_expression] = STATE(1118),
    [sym_for_expression] = STATE(1118),
    [sym_while_expression] = STATE(1118),
    [sym__if_branch] = STATE(7163),
    [sym_if_expression] = STATE(1118),
    [sym_fun_expression] = STATE(1118),
    [sym_try_expression] = STATE(1118),
    [sym_match_expression] = STATE(1118),
    [sym_function_expression] = STATE(1118),
    [sym_mutate_expression] = STATE(1118),
    [sym_index_expression] = STATE(1118),
    [sym_typed_expression] = STATE(1118),
    [sym_declaration_expression] = STATE(1118),
    [sym_do_expression] = STATE(1118),
    [sym_list_expression] = STATE(1118),
    [sym_array_expression] = STATE(1118),
    [sym_begin_end_expression] = STATE(1118),
    [sym_paren_expression] = STATE(1118),
    [sym__high_prec_app] = STATE(1133),
    [sym__low_prec_app] = STATE(1133),
    [sym_application_expression] = STATE(1118),
    [sym_dot_expression] = STATE(1118),
    [sym_infix_expression] = STATE(1118),
    [sym_ce_expression] = STATE(1118),
    [sym_sequential_expression] = STATE(1118),
    [sym_char] = STATE(1080),
    [sym_format_string] = STATE(1090),
    [sym__string_literal] = STATE(1090),
    [sym_string] = STATE(1080),
    [sym_verbatim_string] = STATE(1080),
    [sym_bytearray] = STATE(1080),
    [sym_verbatim_bytearray] = STATE(1080),
    [sym_format_triple_quoted_string] = STATE(1096),
    [sym_triple_quoted_string] = STATE(1080),
    [sym_const] = STATE(1118),
    [sym_long_identifier] = STATE(1156),
    [sym_active_pattern] = STATE(1085),
    [sym__identifier_or_op] = STATE(1099),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(517),
    [sym_sbyte] = STATE(1080),
    [sym_byte] = STATE(1080),
    [sym_int16] = STATE(1080),
    [sym_uint16] = STATE(1080),
    [sym_int32] = STATE(1080),
    [sym_uint32] = STATE(1080),
    [sym_nativeint] = STATE(1080),
    [sym_unativeint] = STATE(1080),
    [sym_int64] = STATE(1080),
    [sym_uint64] = STATE(1080),
    [sym_ieee32] = STATE(1080),
    [sym_ieee64] = STATE(1080),
    [sym_bignum] = STATE(1080),
    [sym_decimal] = STATE(1080),
    [sym_float] = STATE(979),
    [sym_block_comment] = STATE(487),
    [sym_compiler_directive_decl] = STATE(487),
    [sym_fsi_directive_decl] = STATE(487),
    [sym_preproc_line] = STATE(487),
    [sym_preproc_if_in_expression] = STATE(1118),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(195),
    [anon_sym_return] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_null] = ACTIONS(207),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(209),
    [anon_sym_LBRACK_PIPE] = ACTIONS(211),
    [anon_sym_LBRACE] = ACTIONS(1687),
    [anon_sym_LT_AT] = ACTIONS(213),
    [anon_sym_LT_AT_AT] = ACTIONS(1689),
    [anon_sym_LBRACE_PIPE] = ACTIONS(217),
    [anon_sym_new] = ACTIONS(199),
    [anon_sym_return_BANG] = ACTIONS(219),
    [anon_sym_yield] = ACTIONS(199),
    [anon_sym_yield_BANG] = ACTIONS(219),
    [anon_sym_lazy] = ACTIONS(199),
    [anon_sym_assert] = ACTIONS(199),
    [anon_sym_upcast] = ACTIONS(199),
    [anon_sym_downcast] = ACTIONS(199),
    [anon_sym_for] = ACTIONS(223),
    [anon_sym_while] = ACTIONS(225),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(229),
    [anon_sym_match] = ACTIONS(231),
    [anon_sym_match_BANG] = ACTIONS(233),
    [anon_sym_function] = ACTIONS(235),
    [anon_sym_use] = ACTIONS(239),
    [anon_sym_use_BANG] = ACTIONS(241),
    [anon_sym_do_BANG] = ACTIONS(243),
    [anon_sym_begin] = ACTIONS(245),
    [aux_sym_char_token1] = ACTIONS(247),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(251),
    [anon_sym_AT_DQUOTE] = ACTIONS(253),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(255),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(257),
    [sym_bool] = ACTIONS(259),
    [sym_unit] = ACTIONS(1699),
    [anon_sym_LPAREN_PIPE] = ACTIONS(261),
    [sym_op_identifier] = ACTIONS(1701),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(265),
    [sym_xint] = ACTIONS(267),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(269),
  },
  [488] = {
    [sym_function_or_value_defn] = STATE(482),
    [sym__expression] = STATE(23),
    [sym_literal_expression] = STATE(1537),
    [sym_long_identifier_or_op] = STATE(1537),
    [sym_tuple_expression] = STATE(1537),
    [sym_brace_expression] = STATE(1537),
    [sym_anon_record_expression] = STATE(1537),
    [sym_prefixed_expression] = STATE(1537),
    [sym_typecast_expression] = STATE(1537),
    [sym_for_expression] = STATE(1537),
    [sym_while_expression] = STATE(1537),
    [sym__if_branch] = STATE(6834),
    [sym_if_expression] = STATE(1537),
    [sym_fun_expression] = STATE(1537),
    [sym_try_expression] = STATE(1537),
    [sym_match_expression] = STATE(1537),
    [sym_function_expression] = STATE(1537),
    [sym_mutate_expression] = STATE(1537),
    [sym_index_expression] = STATE(1537),
    [sym_typed_expression] = STATE(1537),
    [sym_declaration_expression] = STATE(1537),
    [sym_do_expression] = STATE(1537),
    [sym_list_expression] = STATE(1537),
    [sym_array_expression] = STATE(1537),
    [sym_begin_end_expression] = STATE(1537),
    [sym_paren_expression] = STATE(1537),
    [sym__high_prec_app] = STATE(1538),
    [sym__low_prec_app] = STATE(1538),
    [sym_application_expression] = STATE(1537),
    [sym_dot_expression] = STATE(1537),
    [sym_infix_expression] = STATE(1537),
    [sym_ce_expression] = STATE(1537),
    [sym_sequential_expression] = STATE(1537),
    [sym_char] = STATE(1484),
    [sym_format_string] = STATE(1483),
    [sym__string_literal] = STATE(1483),
    [sym_string] = STATE(1484),
    [sym_verbatim_string] = STATE(1484),
    [sym_bytearray] = STATE(1484),
    [sym_verbatim_bytearray] = STATE(1484),
    [sym_format_triple_quoted_string] = STATE(1482),
    [sym_triple_quoted_string] = STATE(1484),
    [sym_const] = STATE(1537),
    [sym_long_identifier] = STATE(1643),
    [sym_active_pattern] = STATE(1645),
    [sym__identifier_or_op] = STATE(1689),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(670),
    [sym_sbyte] = STATE(1484),
    [sym_byte] = STATE(1484),
    [sym_int16] = STATE(1484),
    [sym_uint16] = STATE(1484),
    [sym_int32] = STATE(1484),
    [sym_uint32] = STATE(1484),
    [sym_nativeint] = STATE(1484),
    [sym_unativeint] = STATE(1484),
    [sym_int64] = STATE(1484),
    [sym_uint64] = STATE(1484),
    [sym_ieee32] = STATE(1484),
    [sym_ieee64] = STATE(1484),
    [sym_bignum] = STATE(1484),
    [sym_decimal] = STATE(1484),
    [sym_float] = STATE(1327),
    [sym_block_comment] = STATE(488),
    [sym_compiler_directive_decl] = STATE(488),
    [sym_fsi_directive_decl] = STATE(488),
    [sym_preproc_line] = STATE(488),
    [sym_preproc_if_in_expression] = STATE(1537),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(275),
    [anon_sym_return] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(281),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(285),
    [anon_sym_null] = ACTIONS(289),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(291),
    [anon_sym_LBRACK_PIPE] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(2128),
    [anon_sym_LT_AT] = ACTIONS(297),
    [anon_sym_LT_AT_AT] = ACTIONS(2130),
    [anon_sym_LBRACE_PIPE] = ACTIONS(303),
    [anon_sym_new] = ACTIONS(279),
    [anon_sym_return_BANG] = ACTIONS(307),
    [anon_sym_yield] = ACTIONS(279),
    [anon_sym_yield_BANG] = ACTIONS(307),
    [anon_sym_lazy] = ACTIONS(279),
    [anon_sym_assert] = ACTIONS(279),
    [anon_sym_upcast] = ACTIONS(279),
    [anon_sym_downcast] = ACTIONS(279),
    [anon_sym_for] = ACTIONS(311),
    [anon_sym_while] = ACTIONS(313),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(315),
    [anon_sym_try] = ACTIONS(317),
    [anon_sym_match] = ACTIONS(319),
    [anon_sym_match_BANG] = ACTIONS(321),
    [anon_sym_function] = ACTIONS(323),
    [anon_sym_use] = ACTIONS(331),
    [anon_sym_use_BANG] = ACTIONS(333),
    [anon_sym_do_BANG] = ACTIONS(335),
    [anon_sym_begin] = ACTIONS(337),
    [aux_sym_char_token1] = ACTIONS(341),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(343),
    [anon_sym_DQUOTE] = ACTIONS(345),
    [anon_sym_AT_DQUOTE] = ACTIONS(347),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(349),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(351),
    [sym_bool] = ACTIONS(353),
    [sym_unit] = ACTIONS(2132),
    [anon_sym_LPAREN_PIPE] = ACTIONS(357),
    [sym_op_identifier] = ACTIONS(2134),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(361),
    [sym_xint] = ACTIONS(363),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(365),
  },
  [489] = {
    [sym_function_or_value_defn] = STATE(600),
    [sym__expression] = STATE(157),
    [sym_literal_expression] = STATE(867),
    [sym_long_identifier_or_op] = STATE(867),
    [sym_tuple_expression] = STATE(867),
    [sym_brace_expression] = STATE(867),
    [sym_anon_record_expression] = STATE(867),
    [sym_prefixed_expression] = STATE(867),
    [sym_typecast_expression] = STATE(867),
    [sym_for_expression] = STATE(867),
    [sym_while_expression] = STATE(867),
    [sym__if_branch] = STATE(6511),
    [sym_if_expression] = STATE(867),
    [sym_fun_expression] = STATE(867),
    [sym_try_expression] = STATE(867),
    [sym_match_expression] = STATE(867),
    [sym_function_expression] = STATE(867),
    [sym_mutate_expression] = STATE(867),
    [sym_index_expression] = STATE(867),
    [sym_typed_expression] = STATE(867),
    [sym_declaration_expression] = STATE(867),
    [sym_do_expression] = STATE(867),
    [sym_list_expression] = STATE(867),
    [sym_array_expression] = STATE(867),
    [sym_begin_end_expression] = STATE(867),
    [sym_paren_expression] = STATE(867),
    [sym__high_prec_app] = STATE(864),
    [sym__low_prec_app] = STATE(864),
    [sym_application_expression] = STATE(867),
    [sym_dot_expression] = STATE(867),
    [sym_infix_expression] = STATE(867),
    [sym_ce_expression] = STATE(867),
    [sym_sequential_expression] = STATE(867),
    [sym_char] = STATE(868),
    [sym_format_string] = STATE(869),
    [sym__string_literal] = STATE(869),
    [sym_string] = STATE(868),
    [sym_verbatim_string] = STATE(868),
    [sym_bytearray] = STATE(868),
    [sym_verbatim_bytearray] = STATE(868),
    [sym_format_triple_quoted_string] = STATE(870),
    [sym_triple_quoted_string] = STATE(868),
    [sym_const] = STATE(867),
    [sym_long_identifier] = STATE(872),
    [sym_active_pattern] = STATE(871),
    [sym__identifier_or_op] = STATE(873),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(656),
    [sym_sbyte] = STATE(868),
    [sym_byte] = STATE(868),
    [sym_int16] = STATE(868),
    [sym_uint16] = STATE(868),
    [sym_int32] = STATE(868),
    [sym_uint32] = STATE(868),
    [sym_nativeint] = STATE(868),
    [sym_unativeint] = STATE(868),
    [sym_int64] = STATE(868),
    [sym_uint64] = STATE(868),
    [sym_ieee32] = STATE(868),
    [sym_ieee64] = STATE(868),
    [sym_bignum] = STATE(868),
    [sym_decimal] = STATE(868),
    [sym_float] = STATE(1368),
    [sym_block_comment] = STATE(489),
    [sym_compiler_directive_decl] = STATE(489),
    [sym_fsi_directive_decl] = STATE(489),
    [sym_preproc_line] = STATE(489),
    [sym_preproc_if_in_expression] = STATE(867),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(29),
    [anon_sym_return] = ACTIONS(825),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_null] = ACTIONS(49),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACK_PIPE] = ACTIONS(57),
    [anon_sym_LBRACE] = ACTIONS(1663),
    [anon_sym_LT_AT] = ACTIONS(61),
    [anon_sym_LT_AT_AT] = ACTIONS(1665),
    [anon_sym_LBRACE_PIPE] = ACTIONS(67),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_return_BANG] = ACTIONS(829),
    [anon_sym_yield] = ACTIONS(825),
    [anon_sym_yield_BANG] = ACTIONS(829),
    [anon_sym_lazy] = ACTIONS(825),
    [anon_sym_assert] = ACTIONS(825),
    [anon_sym_upcast] = ACTIONS(825),
    [anon_sym_downcast] = ACTIONS(825),
    [anon_sym_for] = ACTIONS(73),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(79),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_match] = ACTIONS(83),
    [anon_sym_match_BANG] = ACTIONS(85),
    [anon_sym_function] = ACTIONS(87),
    [anon_sym_use] = ACTIONS(833),
    [anon_sym_use_BANG] = ACTIONS(835),
    [anon_sym_do_BANG] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(101),
    [aux_sym_char_token1] = ACTIONS(105),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(107),
    [anon_sym_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DQUOTE] = ACTIONS(111),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(115),
    [sym_bool] = ACTIONS(117),
    [sym_unit] = ACTIONS(1673),
    [anon_sym_LPAREN_PIPE] = ACTIONS(121),
    [sym_op_identifier] = ACTIONS(1675),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(837),
    [sym_xint] = ACTIONS(387),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(135),
  },
  [490] = {
    [sym_function_or_value_defn] = STATE(482),
    [sym__expression] = STATE(31),
    [sym_literal_expression] = STATE(1537),
    [sym_long_identifier_or_op] = STATE(1537),
    [sym_tuple_expression] = STATE(1537),
    [sym_brace_expression] = STATE(1537),
    [sym_anon_record_expression] = STATE(1537),
    [sym_prefixed_expression] = STATE(1537),
    [sym_typecast_expression] = STATE(1537),
    [sym_for_expression] = STATE(1537),
    [sym_while_expression] = STATE(1537),
    [sym__if_branch] = STATE(6834),
    [sym_if_expression] = STATE(1537),
    [sym_fun_expression] = STATE(1537),
    [sym_try_expression] = STATE(1537),
    [sym_match_expression] = STATE(1537),
    [sym_function_expression] = STATE(1537),
    [sym_mutate_expression] = STATE(1537),
    [sym_index_expression] = STATE(1537),
    [sym_typed_expression] = STATE(1537),
    [sym_declaration_expression] = STATE(1537),
    [sym_do_expression] = STATE(1537),
    [sym_list_expression] = STATE(1537),
    [sym_array_expression] = STATE(1537),
    [sym_begin_end_expression] = STATE(1537),
    [sym_paren_expression] = STATE(1537),
    [sym__high_prec_app] = STATE(1538),
    [sym__low_prec_app] = STATE(1538),
    [sym_application_expression] = STATE(1537),
    [sym_dot_expression] = STATE(1537),
    [sym_infix_expression] = STATE(1537),
    [sym_ce_expression] = STATE(1537),
    [sym_sequential_expression] = STATE(1537),
    [sym_char] = STATE(1484),
    [sym_format_string] = STATE(1483),
    [sym__string_literal] = STATE(1483),
    [sym_string] = STATE(1484),
    [sym_verbatim_string] = STATE(1484),
    [sym_bytearray] = STATE(1484),
    [sym_verbatim_bytearray] = STATE(1484),
    [sym_format_triple_quoted_string] = STATE(1482),
    [sym_triple_quoted_string] = STATE(1484),
    [sym_const] = STATE(1537),
    [sym_long_identifier] = STATE(1643),
    [sym_active_pattern] = STATE(1645),
    [sym__identifier_or_op] = STATE(1689),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(670),
    [sym_sbyte] = STATE(1484),
    [sym_byte] = STATE(1484),
    [sym_int16] = STATE(1484),
    [sym_uint16] = STATE(1484),
    [sym_int32] = STATE(1484),
    [sym_uint32] = STATE(1484),
    [sym_nativeint] = STATE(1484),
    [sym_unativeint] = STATE(1484),
    [sym_int64] = STATE(1484),
    [sym_uint64] = STATE(1484),
    [sym_ieee32] = STATE(1484),
    [sym_ieee64] = STATE(1484),
    [sym_bignum] = STATE(1484),
    [sym_decimal] = STATE(1484),
    [sym_float] = STATE(1327),
    [sym_block_comment] = STATE(490),
    [sym_compiler_directive_decl] = STATE(490),
    [sym_fsi_directive_decl] = STATE(490),
    [sym_preproc_line] = STATE(490),
    [sym_preproc_if_in_expression] = STATE(1537),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(275),
    [anon_sym_return] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(281),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(285),
    [anon_sym_null] = ACTIONS(289),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(291),
    [anon_sym_LBRACK_PIPE] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(2128),
    [anon_sym_LT_AT] = ACTIONS(297),
    [anon_sym_LT_AT_AT] = ACTIONS(2130),
    [anon_sym_LBRACE_PIPE] = ACTIONS(303),
    [anon_sym_new] = ACTIONS(279),
    [anon_sym_return_BANG] = ACTIONS(307),
    [anon_sym_yield] = ACTIONS(279),
    [anon_sym_yield_BANG] = ACTIONS(307),
    [anon_sym_lazy] = ACTIONS(279),
    [anon_sym_assert] = ACTIONS(279),
    [anon_sym_upcast] = ACTIONS(279),
    [anon_sym_downcast] = ACTIONS(279),
    [anon_sym_for] = ACTIONS(311),
    [anon_sym_while] = ACTIONS(313),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(315),
    [anon_sym_try] = ACTIONS(317),
    [anon_sym_match] = ACTIONS(319),
    [anon_sym_match_BANG] = ACTIONS(321),
    [anon_sym_function] = ACTIONS(323),
    [anon_sym_use] = ACTIONS(331),
    [anon_sym_use_BANG] = ACTIONS(333),
    [anon_sym_do_BANG] = ACTIONS(335),
    [anon_sym_begin] = ACTIONS(337),
    [aux_sym_char_token1] = ACTIONS(341),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(343),
    [anon_sym_DQUOTE] = ACTIONS(345),
    [anon_sym_AT_DQUOTE] = ACTIONS(347),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(349),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(351),
    [sym_bool] = ACTIONS(353),
    [sym_unit] = ACTIONS(2132),
    [anon_sym_LPAREN_PIPE] = ACTIONS(357),
    [sym_op_identifier] = ACTIONS(2134),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(361),
    [sym_xint] = ACTIONS(363),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(365),
  },
  [491] = {
    [sym_function_or_value_defn] = STATE(482),
    [sym__expression] = STATE(32),
    [sym_literal_expression] = STATE(1537),
    [sym_long_identifier_or_op] = STATE(1537),
    [sym_tuple_expression] = STATE(1537),
    [sym_brace_expression] = STATE(1537),
    [sym_anon_record_expression] = STATE(1537),
    [sym_prefixed_expression] = STATE(1537),
    [sym_typecast_expression] = STATE(1537),
    [sym_for_expression] = STATE(1537),
    [sym_while_expression] = STATE(1537),
    [sym__if_branch] = STATE(6834),
    [sym_if_expression] = STATE(1537),
    [sym_fun_expression] = STATE(1537),
    [sym_try_expression] = STATE(1537),
    [sym_match_expression] = STATE(1537),
    [sym_function_expression] = STATE(1537),
    [sym_mutate_expression] = STATE(1537),
    [sym_index_expression] = STATE(1537),
    [sym_typed_expression] = STATE(1537),
    [sym_declaration_expression] = STATE(1537),
    [sym_do_expression] = STATE(1537),
    [sym_list_expression] = STATE(1537),
    [sym_array_expression] = STATE(1537),
    [sym_begin_end_expression] = STATE(1537),
    [sym_paren_expression] = STATE(1537),
    [sym__high_prec_app] = STATE(1538),
    [sym__low_prec_app] = STATE(1538),
    [sym_application_expression] = STATE(1537),
    [sym_dot_expression] = STATE(1537),
    [sym_infix_expression] = STATE(1537),
    [sym_ce_expression] = STATE(1537),
    [sym_sequential_expression] = STATE(1537),
    [sym_char] = STATE(1484),
    [sym_format_string] = STATE(1483),
    [sym__string_literal] = STATE(1483),
    [sym_string] = STATE(1484),
    [sym_verbatim_string] = STATE(1484),
    [sym_bytearray] = STATE(1484),
    [sym_verbatim_bytearray] = STATE(1484),
    [sym_format_triple_quoted_string] = STATE(1482),
    [sym_triple_quoted_string] = STATE(1484),
    [sym_const] = STATE(1537),
    [sym_long_identifier] = STATE(1643),
    [sym_active_pattern] = STATE(1645),
    [sym__identifier_or_op] = STATE(1689),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(670),
    [sym_sbyte] = STATE(1484),
    [sym_byte] = STATE(1484),
    [sym_int16] = STATE(1484),
    [sym_uint16] = STATE(1484),
    [sym_int32] = STATE(1484),
    [sym_uint32] = STATE(1484),
    [sym_nativeint] = STATE(1484),
    [sym_unativeint] = STATE(1484),
    [sym_int64] = STATE(1484),
    [sym_uint64] = STATE(1484),
    [sym_ieee32] = STATE(1484),
    [sym_ieee64] = STATE(1484),
    [sym_bignum] = STATE(1484),
    [sym_decimal] = STATE(1484),
    [sym_float] = STATE(1327),
    [sym_block_comment] = STATE(491),
    [sym_compiler_directive_decl] = STATE(491),
    [sym_fsi_directive_decl] = STATE(491),
    [sym_preproc_line] = STATE(491),
    [sym_preproc_if_in_expression] = STATE(1537),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(275),
    [anon_sym_return] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(281),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(285),
    [anon_sym_null] = ACTIONS(289),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(291),
    [anon_sym_LBRACK_PIPE] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(2128),
    [anon_sym_LT_AT] = ACTIONS(297),
    [anon_sym_LT_AT_AT] = ACTIONS(2130),
    [anon_sym_LBRACE_PIPE] = ACTIONS(303),
    [anon_sym_new] = ACTIONS(279),
    [anon_sym_return_BANG] = ACTIONS(307),
    [anon_sym_yield] = ACTIONS(279),
    [anon_sym_yield_BANG] = ACTIONS(307),
    [anon_sym_lazy] = ACTIONS(279),
    [anon_sym_assert] = ACTIONS(279),
    [anon_sym_upcast] = ACTIONS(279),
    [anon_sym_downcast] = ACTIONS(279),
    [anon_sym_for] = ACTIONS(311),
    [anon_sym_while] = ACTIONS(313),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(315),
    [anon_sym_try] = ACTIONS(317),
    [anon_sym_match] = ACTIONS(319),
    [anon_sym_match_BANG] = ACTIONS(321),
    [anon_sym_function] = ACTIONS(323),
    [anon_sym_use] = ACTIONS(331),
    [anon_sym_use_BANG] = ACTIONS(333),
    [anon_sym_do_BANG] = ACTIONS(335),
    [anon_sym_begin] = ACTIONS(337),
    [aux_sym_char_token1] = ACTIONS(341),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(343),
    [anon_sym_DQUOTE] = ACTIONS(345),
    [anon_sym_AT_DQUOTE] = ACTIONS(347),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(349),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(351),
    [sym_bool] = ACTIONS(353),
    [sym_unit] = ACTIONS(2132),
    [anon_sym_LPAREN_PIPE] = ACTIONS(357),
    [sym_op_identifier] = ACTIONS(2134),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(361),
    [sym_xint] = ACTIONS(363),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(365),
  },
  [492] = {
    [sym_function_or_value_defn] = STATE(482),
    [sym__expression] = STATE(30),
    [sym_literal_expression] = STATE(1537),
    [sym_long_identifier_or_op] = STATE(1537),
    [sym_tuple_expression] = STATE(1537),
    [sym_brace_expression] = STATE(1537),
    [sym_anon_record_expression] = STATE(1537),
    [sym_prefixed_expression] = STATE(1537),
    [sym_typecast_expression] = STATE(1537),
    [sym_for_expression] = STATE(1537),
    [sym_while_expression] = STATE(1537),
    [sym__if_branch] = STATE(6834),
    [sym_if_expression] = STATE(1537),
    [sym_fun_expression] = STATE(1537),
    [sym_try_expression] = STATE(1537),
    [sym_match_expression] = STATE(1537),
    [sym_function_expression] = STATE(1537),
    [sym_mutate_expression] = STATE(1537),
    [sym_index_expression] = STATE(1537),
    [sym_typed_expression] = STATE(1537),
    [sym_declaration_expression] = STATE(1537),
    [sym_do_expression] = STATE(1537),
    [sym_list_expression] = STATE(1537),
    [sym_array_expression] = STATE(1537),
    [sym_begin_end_expression] = STATE(1537),
    [sym_paren_expression] = STATE(1537),
    [sym__high_prec_app] = STATE(1538),
    [sym__low_prec_app] = STATE(1538),
    [sym_application_expression] = STATE(1537),
    [sym_dot_expression] = STATE(1537),
    [sym_infix_expression] = STATE(1537),
    [sym_ce_expression] = STATE(1537),
    [sym_sequential_expression] = STATE(1537),
    [sym_char] = STATE(1484),
    [sym_format_string] = STATE(1483),
    [sym__string_literal] = STATE(1483),
    [sym_string] = STATE(1484),
    [sym_verbatim_string] = STATE(1484),
    [sym_bytearray] = STATE(1484),
    [sym_verbatim_bytearray] = STATE(1484),
    [sym_format_triple_quoted_string] = STATE(1482),
    [sym_triple_quoted_string] = STATE(1484),
    [sym_const] = STATE(1537),
    [sym_long_identifier] = STATE(1643),
    [sym_active_pattern] = STATE(1645),
    [sym__identifier_or_op] = STATE(1689),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(670),
    [sym_sbyte] = STATE(1484),
    [sym_byte] = STATE(1484),
    [sym_int16] = STATE(1484),
    [sym_uint16] = STATE(1484),
    [sym_int32] = STATE(1484),
    [sym_uint32] = STATE(1484),
    [sym_nativeint] = STATE(1484),
    [sym_unativeint] = STATE(1484),
    [sym_int64] = STATE(1484),
    [sym_uint64] = STATE(1484),
    [sym_ieee32] = STATE(1484),
    [sym_ieee64] = STATE(1484),
    [sym_bignum] = STATE(1484),
    [sym_decimal] = STATE(1484),
    [sym_float] = STATE(1327),
    [sym_block_comment] = STATE(492),
    [sym_compiler_directive_decl] = STATE(492),
    [sym_fsi_directive_decl] = STATE(492),
    [sym_preproc_line] = STATE(492),
    [sym_preproc_if_in_expression] = STATE(1537),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(275),
    [anon_sym_return] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(281),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(285),
    [anon_sym_null] = ACTIONS(289),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(291),
    [anon_sym_LBRACK_PIPE] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(2128),
    [anon_sym_LT_AT] = ACTIONS(297),
    [anon_sym_LT_AT_AT] = ACTIONS(2130),
    [anon_sym_LBRACE_PIPE] = ACTIONS(303),
    [anon_sym_new] = ACTIONS(279),
    [anon_sym_return_BANG] = ACTIONS(307),
    [anon_sym_yield] = ACTIONS(279),
    [anon_sym_yield_BANG] = ACTIONS(307),
    [anon_sym_lazy] = ACTIONS(279),
    [anon_sym_assert] = ACTIONS(279),
    [anon_sym_upcast] = ACTIONS(279),
    [anon_sym_downcast] = ACTIONS(279),
    [anon_sym_for] = ACTIONS(311),
    [anon_sym_while] = ACTIONS(313),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(315),
    [anon_sym_try] = ACTIONS(317),
    [anon_sym_match] = ACTIONS(319),
    [anon_sym_match_BANG] = ACTIONS(321),
    [anon_sym_function] = ACTIONS(323),
    [anon_sym_use] = ACTIONS(331),
    [anon_sym_use_BANG] = ACTIONS(333),
    [anon_sym_do_BANG] = ACTIONS(335),
    [anon_sym_begin] = ACTIONS(337),
    [aux_sym_char_token1] = ACTIONS(341),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(343),
    [anon_sym_DQUOTE] = ACTIONS(345),
    [anon_sym_AT_DQUOTE] = ACTIONS(347),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(349),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(351),
    [sym_bool] = ACTIONS(353),
    [sym_unit] = ACTIONS(2132),
    [anon_sym_LPAREN_PIPE] = ACTIONS(357),
    [sym_op_identifier] = ACTIONS(2134),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(361),
    [sym_xint] = ACTIONS(363),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(365),
  },
  [493] = {
    [sym_function_or_value_defn] = STATE(527),
    [sym__expression] = STATE(277),
    [sym_literal_expression] = STATE(2384),
    [sym_long_identifier_or_op] = STATE(2384),
    [sym_tuple_expression] = STATE(2384),
    [sym_brace_expression] = STATE(2384),
    [sym_anon_record_expression] = STATE(2384),
    [sym_prefixed_expression] = STATE(2384),
    [sym_typecast_expression] = STATE(2384),
    [sym_for_expression] = STATE(2384),
    [sym_while_expression] = STATE(2384),
    [sym__if_branch] = STATE(6561),
    [sym_if_expression] = STATE(2384),
    [sym_fun_expression] = STATE(2384),
    [sym_try_expression] = STATE(2384),
    [sym_match_expression] = STATE(2384),
    [sym_function_expression] = STATE(2384),
    [sym_mutate_expression] = STATE(2384),
    [sym_index_expression] = STATE(2384),
    [sym_typed_expression] = STATE(2384),
    [sym_declaration_expression] = STATE(2384),
    [sym_do_expression] = STATE(2384),
    [sym_list_expression] = STATE(2384),
    [sym_array_expression] = STATE(2384),
    [sym_begin_end_expression] = STATE(2384),
    [sym_paren_expression] = STATE(2384),
    [sym__high_prec_app] = STATE(2249),
    [sym__low_prec_app] = STATE(2249),
    [sym_application_expression] = STATE(2384),
    [sym_dot_expression] = STATE(2384),
    [sym_infix_expression] = STATE(2384),
    [sym_ce_expression] = STATE(2384),
    [sym_sequential_expression] = STATE(2384),
    [sym_char] = STATE(2144),
    [sym_format_string] = STATE(2142),
    [sym__string_literal] = STATE(2142),
    [sym_string] = STATE(2144),
    [sym_verbatim_string] = STATE(2144),
    [sym_bytearray] = STATE(2144),
    [sym_verbatim_bytearray] = STATE(2144),
    [sym_format_triple_quoted_string] = STATE(2141),
    [sym_triple_quoted_string] = STATE(2144),
    [sym_const] = STATE(2384),
    [sym_long_identifier] = STATE(2400),
    [sym_active_pattern] = STATE(2317),
    [sym__identifier_or_op] = STATE(2392),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(633),
    [sym_sbyte] = STATE(2144),
    [sym_byte] = STATE(2144),
    [sym_int16] = STATE(2144),
    [sym_uint16] = STATE(2144),
    [sym_int32] = STATE(2144),
    [sym_uint32] = STATE(2144),
    [sym_nativeint] = STATE(2144),
    [sym_unativeint] = STATE(2144),
    [sym_int64] = STATE(2144),
    [sym_uint64] = STATE(2144),
    [sym_ieee32] = STATE(2144),
    [sym_ieee64] = STATE(2144),
    [sym_bignum] = STATE(2144),
    [sym_decimal] = STATE(2144),
    [sym_float] = STATE(1672),
    [sym_block_comment] = STATE(493),
    [sym_compiler_directive_decl] = STATE(493),
    [sym_fsi_directive_decl] = STATE(493),
    [sym_preproc_line] = STATE(493),
    [sym_preproc_if_in_expression] = STATE(2384),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(1439),
    [anon_sym_return] = ACTIONS(1443),
    [anon_sym_do] = ACTIONS(1445),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(1447),
    [anon_sym_null] = ACTIONS(1451),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1453),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1455),
    [anon_sym_LBRACE] = ACTIONS(2036),
    [anon_sym_LT_AT] = ACTIONS(1459),
    [anon_sym_LT_AT_AT] = ACTIONS(2038),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1465),
    [anon_sym_new] = ACTIONS(1443),
    [anon_sym_return_BANG] = ACTIONS(1467),
    [anon_sym_yield] = ACTIONS(1443),
    [anon_sym_yield_BANG] = ACTIONS(1467),
    [anon_sym_lazy] = ACTIONS(1443),
    [anon_sym_assert] = ACTIONS(1443),
    [anon_sym_upcast] = ACTIONS(1443),
    [anon_sym_downcast] = ACTIONS(1443),
    [anon_sym_for] = ACTIONS(1471),
    [anon_sym_while] = ACTIONS(1473),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(1475),
    [anon_sym_try] = ACTIONS(1477),
    [anon_sym_match] = ACTIONS(1479),
    [anon_sym_match_BANG] = ACTIONS(1481),
    [anon_sym_function] = ACTIONS(1483),
    [anon_sym_use] = ACTIONS(1491),
    [anon_sym_use_BANG] = ACTIONS(1493),
    [anon_sym_do_BANG] = ACTIONS(1495),
    [anon_sym_begin] = ACTIONS(1497),
    [aux_sym_char_token1] = ACTIONS(1501),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1503),
    [anon_sym_DQUOTE] = ACTIONS(1505),
    [anon_sym_AT_DQUOTE] = ACTIONS(1507),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1509),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1511),
    [sym_bool] = ACTIONS(1513),
    [sym_unit] = ACTIONS(2040),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1517),
    [sym_op_identifier] = ACTIONS(2042),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(1521),
    [sym_xint] = ACTIONS(1523),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1525),
  },
  [494] = {
    [sym_function_or_value_defn] = STATE(482),
    [sym__expression] = STATE(29),
    [sym_literal_expression] = STATE(1537),
    [sym_long_identifier_or_op] = STATE(1537),
    [sym_tuple_expression] = STATE(1537),
    [sym_brace_expression] = STATE(1537),
    [sym_anon_record_expression] = STATE(1537),
    [sym_prefixed_expression] = STATE(1537),
    [sym_typecast_expression] = STATE(1537),
    [sym_for_expression] = STATE(1537),
    [sym_while_expression] = STATE(1537),
    [sym__if_branch] = STATE(6834),
    [sym_if_expression] = STATE(1537),
    [sym_fun_expression] = STATE(1537),
    [sym_try_expression] = STATE(1537),
    [sym_match_expression] = STATE(1537),
    [sym_function_expression] = STATE(1537),
    [sym_mutate_expression] = STATE(1537),
    [sym_index_expression] = STATE(1537),
    [sym_typed_expression] = STATE(1537),
    [sym_declaration_expression] = STATE(1537),
    [sym_do_expression] = STATE(1537),
    [sym_list_expression] = STATE(1537),
    [sym_array_expression] = STATE(1537),
    [sym_begin_end_expression] = STATE(1537),
    [sym_paren_expression] = STATE(1537),
    [sym__high_prec_app] = STATE(1538),
    [sym__low_prec_app] = STATE(1538),
    [sym_application_expression] = STATE(1537),
    [sym_dot_expression] = STATE(1537),
    [sym_infix_expression] = STATE(1537),
    [sym_ce_expression] = STATE(1537),
    [sym_sequential_expression] = STATE(1537),
    [sym_char] = STATE(1484),
    [sym_format_string] = STATE(1483),
    [sym__string_literal] = STATE(1483),
    [sym_string] = STATE(1484),
    [sym_verbatim_string] = STATE(1484),
    [sym_bytearray] = STATE(1484),
    [sym_verbatim_bytearray] = STATE(1484),
    [sym_format_triple_quoted_string] = STATE(1482),
    [sym_triple_quoted_string] = STATE(1484),
    [sym_const] = STATE(1537),
    [sym_long_identifier] = STATE(1643),
    [sym_active_pattern] = STATE(1645),
    [sym__identifier_or_op] = STATE(1689),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(670),
    [sym_sbyte] = STATE(1484),
    [sym_byte] = STATE(1484),
    [sym_int16] = STATE(1484),
    [sym_uint16] = STATE(1484),
    [sym_int32] = STATE(1484),
    [sym_uint32] = STATE(1484),
    [sym_nativeint] = STATE(1484),
    [sym_unativeint] = STATE(1484),
    [sym_int64] = STATE(1484),
    [sym_uint64] = STATE(1484),
    [sym_ieee32] = STATE(1484),
    [sym_ieee64] = STATE(1484),
    [sym_bignum] = STATE(1484),
    [sym_decimal] = STATE(1484),
    [sym_float] = STATE(1327),
    [sym_block_comment] = STATE(494),
    [sym_compiler_directive_decl] = STATE(494),
    [sym_fsi_directive_decl] = STATE(494),
    [sym_preproc_line] = STATE(494),
    [sym_preproc_if_in_expression] = STATE(1537),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(275),
    [anon_sym_return] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(281),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(285),
    [anon_sym_null] = ACTIONS(289),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(291),
    [anon_sym_LBRACK_PIPE] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(2128),
    [anon_sym_LT_AT] = ACTIONS(297),
    [anon_sym_LT_AT_AT] = ACTIONS(2130),
    [anon_sym_LBRACE_PIPE] = ACTIONS(303),
    [anon_sym_new] = ACTIONS(279),
    [anon_sym_return_BANG] = ACTIONS(307),
    [anon_sym_yield] = ACTIONS(279),
    [anon_sym_yield_BANG] = ACTIONS(307),
    [anon_sym_lazy] = ACTIONS(279),
    [anon_sym_assert] = ACTIONS(279),
    [anon_sym_upcast] = ACTIONS(279),
    [anon_sym_downcast] = ACTIONS(279),
    [anon_sym_for] = ACTIONS(311),
    [anon_sym_while] = ACTIONS(313),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(315),
    [anon_sym_try] = ACTIONS(317),
    [anon_sym_match] = ACTIONS(319),
    [anon_sym_match_BANG] = ACTIONS(321),
    [anon_sym_function] = ACTIONS(323),
    [anon_sym_use] = ACTIONS(331),
    [anon_sym_use_BANG] = ACTIONS(333),
    [anon_sym_do_BANG] = ACTIONS(335),
    [anon_sym_begin] = ACTIONS(337),
    [aux_sym_char_token1] = ACTIONS(341),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(343),
    [anon_sym_DQUOTE] = ACTIONS(345),
    [anon_sym_AT_DQUOTE] = ACTIONS(347),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(349),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(351),
    [sym_bool] = ACTIONS(353),
    [sym_unit] = ACTIONS(2132),
    [anon_sym_LPAREN_PIPE] = ACTIONS(357),
    [sym_op_identifier] = ACTIONS(2134),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(361),
    [sym_xint] = ACTIONS(363),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(365),
  },
  [495] = {
    [sym_function_or_value_defn] = STATE(600),
    [sym__expression] = STATE(145),
    [sym_literal_expression] = STATE(867),
    [sym_long_identifier_or_op] = STATE(867),
    [sym_tuple_expression] = STATE(867),
    [sym_brace_expression] = STATE(867),
    [sym_anon_record_expression] = STATE(867),
    [sym_prefixed_expression] = STATE(867),
    [sym_typecast_expression] = STATE(867),
    [sym_for_expression] = STATE(867),
    [sym_while_expression] = STATE(867),
    [sym__if_branch] = STATE(6511),
    [sym_if_expression] = STATE(867),
    [sym_fun_expression] = STATE(867),
    [sym_try_expression] = STATE(867),
    [sym_match_expression] = STATE(867),
    [sym_function_expression] = STATE(867),
    [sym_mutate_expression] = STATE(867),
    [sym_index_expression] = STATE(867),
    [sym_typed_expression] = STATE(867),
    [sym_declaration_expression] = STATE(867),
    [sym_do_expression] = STATE(867),
    [sym_list_expression] = STATE(867),
    [sym_array_expression] = STATE(867),
    [sym_begin_end_expression] = STATE(867),
    [sym_paren_expression] = STATE(867),
    [sym__high_prec_app] = STATE(864),
    [sym__low_prec_app] = STATE(864),
    [sym_application_expression] = STATE(867),
    [sym_dot_expression] = STATE(867),
    [sym_infix_expression] = STATE(867),
    [sym_ce_expression] = STATE(867),
    [sym_sequential_expression] = STATE(867),
    [sym_char] = STATE(868),
    [sym_format_string] = STATE(869),
    [sym__string_literal] = STATE(869),
    [sym_string] = STATE(868),
    [sym_verbatim_string] = STATE(868),
    [sym_bytearray] = STATE(868),
    [sym_verbatim_bytearray] = STATE(868),
    [sym_format_triple_quoted_string] = STATE(870),
    [sym_triple_quoted_string] = STATE(868),
    [sym_const] = STATE(867),
    [sym_long_identifier] = STATE(872),
    [sym_active_pattern] = STATE(871),
    [sym__identifier_or_op] = STATE(873),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(656),
    [sym_sbyte] = STATE(868),
    [sym_byte] = STATE(868),
    [sym_int16] = STATE(868),
    [sym_uint16] = STATE(868),
    [sym_int32] = STATE(868),
    [sym_uint32] = STATE(868),
    [sym_nativeint] = STATE(868),
    [sym_unativeint] = STATE(868),
    [sym_int64] = STATE(868),
    [sym_uint64] = STATE(868),
    [sym_ieee32] = STATE(868),
    [sym_ieee64] = STATE(868),
    [sym_bignum] = STATE(868),
    [sym_decimal] = STATE(868),
    [sym_float] = STATE(1368),
    [sym_block_comment] = STATE(495),
    [sym_compiler_directive_decl] = STATE(495),
    [sym_fsi_directive_decl] = STATE(495),
    [sym_preproc_line] = STATE(495),
    [sym_preproc_if_in_expression] = STATE(867),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(29),
    [anon_sym_return] = ACTIONS(825),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_null] = ACTIONS(49),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACK_PIPE] = ACTIONS(57),
    [anon_sym_LBRACE] = ACTIONS(1663),
    [anon_sym_LT_AT] = ACTIONS(61),
    [anon_sym_LT_AT_AT] = ACTIONS(1665),
    [anon_sym_LBRACE_PIPE] = ACTIONS(67),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_return_BANG] = ACTIONS(829),
    [anon_sym_yield] = ACTIONS(825),
    [anon_sym_yield_BANG] = ACTIONS(829),
    [anon_sym_lazy] = ACTIONS(825),
    [anon_sym_assert] = ACTIONS(825),
    [anon_sym_upcast] = ACTIONS(825),
    [anon_sym_downcast] = ACTIONS(825),
    [anon_sym_for] = ACTIONS(73),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(79),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_match] = ACTIONS(83),
    [anon_sym_match_BANG] = ACTIONS(85),
    [anon_sym_function] = ACTIONS(87),
    [anon_sym_use] = ACTIONS(833),
    [anon_sym_use_BANG] = ACTIONS(835),
    [anon_sym_do_BANG] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(101),
    [aux_sym_char_token1] = ACTIONS(105),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(107),
    [anon_sym_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DQUOTE] = ACTIONS(111),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(115),
    [sym_bool] = ACTIONS(117),
    [sym_unit] = ACTIONS(1673),
    [anon_sym_LPAREN_PIPE] = ACTIONS(121),
    [sym_op_identifier] = ACTIONS(1675),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(837),
    [sym_xint] = ACTIONS(387),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(135),
  },
  [496] = {
    [sym_function_or_value_defn] = STATE(630),
    [sym__expression] = STATE(144),
    [sym_literal_expression] = STATE(2380),
    [sym_long_identifier_or_op] = STATE(2380),
    [sym_tuple_expression] = STATE(2380),
    [sym_brace_expression] = STATE(2380),
    [sym_anon_record_expression] = STATE(2380),
    [sym_prefixed_expression] = STATE(2380),
    [sym_typecast_expression] = STATE(2380),
    [sym_for_expression] = STATE(2380),
    [sym_while_expression] = STATE(2380),
    [sym__if_branch] = STATE(6456),
    [sym_if_expression] = STATE(2380),
    [sym_fun_expression] = STATE(2380),
    [sym_try_expression] = STATE(2380),
    [sym_match_expression] = STATE(2380),
    [sym_function_expression] = STATE(2380),
    [sym_mutate_expression] = STATE(2380),
    [sym_index_expression] = STATE(2380),
    [sym_typed_expression] = STATE(2380),
    [sym_declaration_expression] = STATE(2380),
    [sym_do_expression] = STATE(2380),
    [sym_list_expression] = STATE(2380),
    [sym_array_expression] = STATE(2380),
    [sym_begin_end_expression] = STATE(2380),
    [sym_paren_expression] = STATE(2380),
    [sym__high_prec_app] = STATE(2383),
    [sym__low_prec_app] = STATE(2383),
    [sym_application_expression] = STATE(2380),
    [sym_dot_expression] = STATE(2380),
    [sym_infix_expression] = STATE(2380),
    [sym_ce_expression] = STATE(2380),
    [sym_sequential_expression] = STATE(2380),
    [sym_char] = STATE(2261),
    [sym_format_string] = STATE(2274),
    [sym__string_literal] = STATE(2274),
    [sym_string] = STATE(2261),
    [sym_verbatim_string] = STATE(2261),
    [sym_bytearray] = STATE(2261),
    [sym_verbatim_bytearray] = STATE(2261),
    [sym_format_triple_quoted_string] = STATE(2275),
    [sym_triple_quoted_string] = STATE(2261),
    [sym_const] = STATE(2380),
    [sym_long_identifier] = STATE(2391),
    [sym_active_pattern] = STATE(2470),
    [sym__identifier_or_op] = STATE(2390),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(632),
    [sym_sbyte] = STATE(2261),
    [sym_byte] = STATE(2261),
    [sym_int16] = STATE(2261),
    [sym_uint16] = STATE(2261),
    [sym_int32] = STATE(2261),
    [sym_uint32] = STATE(2261),
    [sym_nativeint] = STATE(2261),
    [sym_unativeint] = STATE(2261),
    [sym_int64] = STATE(2261),
    [sym_uint64] = STATE(2261),
    [sym_ieee32] = STATE(2261),
    [sym_ieee64] = STATE(2261),
    [sym_bignum] = STATE(2261),
    [sym_decimal] = STATE(2261),
    [sym_float] = STATE(1614),
    [sym_block_comment] = STATE(496),
    [sym_compiler_directive_decl] = STATE(496),
    [sym_fsi_directive_decl] = STATE(496),
    [sym_preproc_line] = STATE(496),
    [sym_preproc_if_in_expression] = STATE(2380),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(1081),
    [anon_sym_return] = ACTIONS(1085),
    [anon_sym_do] = ACTIONS(1087),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(1089),
    [anon_sym_null] = ACTIONS(1093),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1095),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1097),
    [anon_sym_LBRACE] = ACTIONS(2100),
    [anon_sym_LT_AT] = ACTIONS(1101),
    [anon_sym_LT_AT_AT] = ACTIONS(2102),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1107),
    [anon_sym_new] = ACTIONS(1085),
    [anon_sym_return_BANG] = ACTIONS(1109),
    [anon_sym_yield] = ACTIONS(1085),
    [anon_sym_yield_BANG] = ACTIONS(1109),
    [anon_sym_lazy] = ACTIONS(1085),
    [anon_sym_assert] = ACTIONS(1085),
    [anon_sym_upcast] = ACTIONS(1085),
    [anon_sym_downcast] = ACTIONS(1085),
    [anon_sym_for] = ACTIONS(1113),
    [anon_sym_while] = ACTIONS(1115),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(1117),
    [anon_sym_try] = ACTIONS(1119),
    [anon_sym_match] = ACTIONS(1121),
    [anon_sym_match_BANG] = ACTIONS(1123),
    [anon_sym_function] = ACTIONS(1125),
    [anon_sym_use] = ACTIONS(1133),
    [anon_sym_use_BANG] = ACTIONS(1135),
    [anon_sym_do_BANG] = ACTIONS(1137),
    [anon_sym_begin] = ACTIONS(1139),
    [aux_sym_char_token1] = ACTIONS(1143),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1145),
    [anon_sym_DQUOTE] = ACTIONS(1147),
    [anon_sym_AT_DQUOTE] = ACTIONS(1149),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1151),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1153),
    [sym_bool] = ACTIONS(1155),
    [sym_unit] = ACTIONS(2104),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1159),
    [sym_op_identifier] = ACTIONS(2106),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(1163),
    [sym_xint] = ACTIONS(1165),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1167),
  },
  [497] = {
    [sym_function_or_value_defn] = STATE(733),
    [sym__expression] = STATE(240),
    [sym_literal_expression] = STATE(2008),
    [sym_long_identifier_or_op] = STATE(2008),
    [sym_tuple_expression] = STATE(2008),
    [sym_brace_expression] = STATE(2008),
    [sym_anon_record_expression] = STATE(2008),
    [sym_prefixed_expression] = STATE(2008),
    [sym_typecast_expression] = STATE(2008),
    [sym_for_expression] = STATE(2008),
    [sym_while_expression] = STATE(2008),
    [sym__if_branch] = STATE(6754),
    [sym_if_expression] = STATE(2008),
    [sym_fun_expression] = STATE(2008),
    [sym_try_expression] = STATE(2008),
    [sym_match_expression] = STATE(2008),
    [sym_function_expression] = STATE(2008),
    [sym_mutate_expression] = STATE(2008),
    [sym_index_expression] = STATE(2008),
    [sym_typed_expression] = STATE(2008),
    [sym_declaration_expression] = STATE(2008),
    [sym_do_expression] = STATE(2008),
    [sym_list_expression] = STATE(2008),
    [sym_array_expression] = STATE(2008),
    [sym_begin_end_expression] = STATE(2008),
    [sym_paren_expression] = STATE(2008),
    [sym__high_prec_app] = STATE(2007),
    [sym__low_prec_app] = STATE(2007),
    [sym_application_expression] = STATE(2008),
    [sym_dot_expression] = STATE(2008),
    [sym_infix_expression] = STATE(2008),
    [sym_ce_expression] = STATE(2008),
    [sym_sequential_expression] = STATE(2008),
    [sym_char] = STATE(1859),
    [sym_format_string] = STATE(1861),
    [sym__string_literal] = STATE(1861),
    [sym_string] = STATE(1859),
    [sym_verbatim_string] = STATE(1859),
    [sym_bytearray] = STATE(1859),
    [sym_verbatim_bytearray] = STATE(1859),
    [sym_format_triple_quoted_string] = STATE(1862),
    [sym_triple_quoted_string] = STATE(1859),
    [sym_const] = STATE(2008),
    [sym_long_identifier] = STATE(1701),
    [sym_active_pattern] = STATE(1702),
    [sym__identifier_or_op] = STATE(1724),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(706),
    [sym_sbyte] = STATE(1859),
    [sym_byte] = STATE(1859),
    [sym_int16] = STATE(1859),
    [sym_uint16] = STATE(1859),
    [sym_int32] = STATE(1859),
    [sym_uint32] = STATE(1859),
    [sym_nativeint] = STATE(1859),
    [sym_unativeint] = STATE(1859),
    [sym_int64] = STATE(1859),
    [sym_uint64] = STATE(1859),
    [sym_ieee32] = STATE(1859),
    [sym_ieee64] = STATE(1859),
    [sym_bignum] = STATE(1859),
    [sym_decimal] = STATE(1859),
    [sym_float] = STATE(1447),
    [sym_block_comment] = STATE(497),
    [sym_compiler_directive_decl] = STATE(497),
    [sym_fsi_directive_decl] = STATE(497),
    [sym_preproc_line] = STATE(497),
    [sym_preproc_if_in_expression] = STATE(2008),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(503),
    [anon_sym_return] = ACTIONS(971),
    [anon_sym_do] = ACTIONS(599),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(511),
    [anon_sym_null] = ACTIONS(515),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(517),
    [anon_sym_LBRACK_PIPE] = ACTIONS(519),
    [anon_sym_LBRACE] = ACTIONS(2060),
    [anon_sym_LT_AT] = ACTIONS(523),
    [anon_sym_LT_AT_AT] = ACTIONS(2062),
    [anon_sym_LBRACE_PIPE] = ACTIONS(529),
    [anon_sym_new] = ACTIONS(971),
    [anon_sym_return_BANG] = ACTIONS(975),
    [anon_sym_yield] = ACTIONS(971),
    [anon_sym_yield_BANG] = ACTIONS(975),
    [anon_sym_lazy] = ACTIONS(971),
    [anon_sym_assert] = ACTIONS(971),
    [anon_sym_upcast] = ACTIONS(971),
    [anon_sym_downcast] = ACTIONS(971),
    [anon_sym_for] = ACTIONS(979),
    [anon_sym_while] = ACTIONS(537),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(539),
    [anon_sym_try] = ACTIONS(543),
    [anon_sym_match] = ACTIONS(545),
    [anon_sym_match_BANG] = ACTIONS(547),
    [anon_sym_function] = ACTIONS(549),
    [anon_sym_use] = ACTIONS(983),
    [anon_sym_use_BANG] = ACTIONS(985),
    [anon_sym_do_BANG] = ACTIONS(561),
    [anon_sym_begin] = ACTIONS(565),
    [aux_sym_char_token1] = ACTIONS(569),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(571),
    [anon_sym_DQUOTE] = ACTIONS(573),
    [anon_sym_AT_DQUOTE] = ACTIONS(575),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(577),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(579),
    [sym_bool] = ACTIONS(581),
    [sym_unit] = ACTIONS(2064),
    [anon_sym_LPAREN_PIPE] = ACTIONS(585),
    [sym_op_identifier] = ACTIONS(2066),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(591),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(593),
  },
  [498] = {
    [sym_function_or_value_defn] = STATE(651),
    [sym__expression] = STATE(143),
    [sym_literal_expression] = STATE(2168),
    [sym_long_identifier_or_op] = STATE(2168),
    [sym_tuple_expression] = STATE(2168),
    [sym_brace_expression] = STATE(2168),
    [sym_anon_record_expression] = STATE(2168),
    [sym_prefixed_expression] = STATE(2168),
    [sym_typecast_expression] = STATE(2168),
    [sym_for_expression] = STATE(2168),
    [sym_while_expression] = STATE(2168),
    [sym__if_branch] = STATE(6406),
    [sym_if_expression] = STATE(2168),
    [sym_fun_expression] = STATE(2168),
    [sym_try_expression] = STATE(2168),
    [sym_match_expression] = STATE(2168),
    [sym_function_expression] = STATE(2168),
    [sym_mutate_expression] = STATE(2168),
    [sym_index_expression] = STATE(2168),
    [sym_typed_expression] = STATE(2168),
    [sym_declaration_expression] = STATE(2168),
    [sym_do_expression] = STATE(2168),
    [sym_list_expression] = STATE(2168),
    [sym_array_expression] = STATE(2168),
    [sym_begin_end_expression] = STATE(2168),
    [sym_paren_expression] = STATE(2168),
    [sym__high_prec_app] = STATE(2179),
    [sym__low_prec_app] = STATE(2179),
    [sym_application_expression] = STATE(2168),
    [sym_dot_expression] = STATE(2168),
    [sym_infix_expression] = STATE(2168),
    [sym_ce_expression] = STATE(2168),
    [sym_sequential_expression] = STATE(2168),
    [sym_char] = STATE(2469),
    [sym_format_string] = STATE(2412),
    [sym__string_literal] = STATE(2412),
    [sym_string] = STATE(2469),
    [sym_verbatim_string] = STATE(2469),
    [sym_bytearray] = STATE(2469),
    [sym_verbatim_bytearray] = STATE(2469),
    [sym_format_triple_quoted_string] = STATE(2408),
    [sym_triple_quoted_string] = STATE(2469),
    [sym_const] = STATE(2168),
    [sym_long_identifier] = STATE(2183),
    [sym_active_pattern] = STATE(2182),
    [sym__identifier_or_op] = STATE(2093),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(650),
    [sym_sbyte] = STATE(2469),
    [sym_byte] = STATE(2469),
    [sym_int16] = STATE(2469),
    [sym_uint16] = STATE(2469),
    [sym_int32] = STATE(2469),
    [sym_uint32] = STATE(2469),
    [sym_nativeint] = STATE(2469),
    [sym_unativeint] = STATE(2469),
    [sym_int64] = STATE(2469),
    [sym_uint64] = STATE(2469),
    [sym_ieee32] = STATE(2469),
    [sym_ieee64] = STATE(2469),
    [sym_bignum] = STATE(2469),
    [sym_decimal] = STATE(2469),
    [sym_float] = STATE(1586),
    [sym_block_comment] = STATE(498),
    [sym_compiler_directive_decl] = STATE(498),
    [sym_fsi_directive_decl] = STATE(498),
    [sym_preproc_line] = STATE(498),
    [sym_preproc_if_in_expression] = STATE(2168),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(989),
    [anon_sym_return] = ACTIONS(993),
    [anon_sym_do] = ACTIONS(995),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(997),
    [anon_sym_null] = ACTIONS(1001),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1003),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1005),
    [anon_sym_LBRACE] = ACTIONS(2070),
    [anon_sym_LT_AT] = ACTIONS(1009),
    [anon_sym_LT_AT_AT] = ACTIONS(2072),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1017),
    [anon_sym_new] = ACTIONS(993),
    [anon_sym_return_BANG] = ACTIONS(1019),
    [anon_sym_yield] = ACTIONS(993),
    [anon_sym_yield_BANG] = ACTIONS(1019),
    [anon_sym_lazy] = ACTIONS(993),
    [anon_sym_assert] = ACTIONS(993),
    [anon_sym_upcast] = ACTIONS(993),
    [anon_sym_downcast] = ACTIONS(993),
    [anon_sym_for] = ACTIONS(1023),
    [anon_sym_while] = ACTIONS(1025),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(1027),
    [anon_sym_try] = ACTIONS(1029),
    [anon_sym_match] = ACTIONS(1031),
    [anon_sym_match_BANG] = ACTIONS(1033),
    [anon_sym_function] = ACTIONS(1035),
    [anon_sym_use] = ACTIONS(1043),
    [anon_sym_use_BANG] = ACTIONS(1045),
    [anon_sym_do_BANG] = ACTIONS(1047),
    [anon_sym_begin] = ACTIONS(1049),
    [aux_sym_char_token1] = ACTIONS(1053),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1055),
    [anon_sym_DQUOTE] = ACTIONS(1057),
    [anon_sym_AT_DQUOTE] = ACTIONS(1059),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1061),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1063),
    [sym_bool] = ACTIONS(1065),
    [sym_unit] = ACTIONS(2074),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1069),
    [sym_op_identifier] = ACTIONS(2076),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(1073),
    [sym_xint] = ACTIONS(1075),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1077),
  },
  [499] = {
    [sym_function_or_value_defn] = STATE(729),
    [sym__expression] = STATE(62),
    [sym_literal_expression] = STATE(867),
    [sym_long_identifier_or_op] = STATE(867),
    [sym_tuple_expression] = STATE(867),
    [sym_brace_expression] = STATE(867),
    [sym_anon_record_expression] = STATE(867),
    [sym_prefixed_expression] = STATE(867),
    [sym_typecast_expression] = STATE(867),
    [sym_for_expression] = STATE(867),
    [sym_while_expression] = STATE(867),
    [sym__if_branch] = STATE(6511),
    [sym_if_expression] = STATE(867),
    [sym_fun_expression] = STATE(867),
    [sym_try_expression] = STATE(867),
    [sym_match_expression] = STATE(867),
    [sym_function_expression] = STATE(867),
    [sym_mutate_expression] = STATE(867),
    [sym_index_expression] = STATE(867),
    [sym_typed_expression] = STATE(867),
    [sym_declaration_expression] = STATE(867),
    [sym_do_expression] = STATE(867),
    [sym_list_expression] = STATE(867),
    [sym_array_expression] = STATE(867),
    [sym_begin_end_expression] = STATE(867),
    [sym_paren_expression] = STATE(867),
    [sym__high_prec_app] = STATE(864),
    [sym__low_prec_app] = STATE(864),
    [sym_application_expression] = STATE(867),
    [sym_dot_expression] = STATE(867),
    [sym_infix_expression] = STATE(867),
    [sym_ce_expression] = STATE(867),
    [sym_sequential_expression] = STATE(867),
    [sym_char] = STATE(868),
    [sym_format_string] = STATE(869),
    [sym__string_literal] = STATE(869),
    [sym_string] = STATE(868),
    [sym_verbatim_string] = STATE(868),
    [sym_bytearray] = STATE(868),
    [sym_verbatim_bytearray] = STATE(868),
    [sym_format_triple_quoted_string] = STATE(870),
    [sym_triple_quoted_string] = STATE(868),
    [sym_const] = STATE(867),
    [sym_long_identifier] = STATE(872),
    [sym_active_pattern] = STATE(871),
    [sym__identifier_or_op] = STATE(873),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(499),
    [sym_sbyte] = STATE(868),
    [sym_byte] = STATE(868),
    [sym_int16] = STATE(868),
    [sym_uint16] = STATE(868),
    [sym_int32] = STATE(868),
    [sym_uint32] = STATE(868),
    [sym_nativeint] = STATE(868),
    [sym_unativeint] = STATE(868),
    [sym_int64] = STATE(868),
    [sym_uint64] = STATE(868),
    [sym_ieee32] = STATE(868),
    [sym_ieee64] = STATE(868),
    [sym_bignum] = STATE(868),
    [sym_decimal] = STATE(868),
    [sym_float] = STATE(1368),
    [sym_block_comment] = STATE(499),
    [sym_compiler_directive_decl] = STATE(499),
    [sym_fsi_directive_decl] = STATE(499),
    [sym_preproc_line] = STATE(499),
    [sym_preproc_if_in_expression] = STATE(867),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(29),
    [anon_sym_return] = ACTIONS(369),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_null] = ACTIONS(49),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACK_PIPE] = ACTIONS(57),
    [anon_sym_LBRACE] = ACTIONS(1663),
    [anon_sym_LT_AT] = ACTIONS(61),
    [anon_sym_LT_AT_AT] = ACTIONS(1665),
    [anon_sym_LBRACE_PIPE] = ACTIONS(67),
    [anon_sym_new] = ACTIONS(369),
    [anon_sym_return_BANG] = ACTIONS(373),
    [anon_sym_yield] = ACTIONS(369),
    [anon_sym_yield_BANG] = ACTIONS(373),
    [anon_sym_lazy] = ACTIONS(369),
    [anon_sym_assert] = ACTIONS(369),
    [anon_sym_upcast] = ACTIONS(369),
    [anon_sym_downcast] = ACTIONS(369),
    [anon_sym_for] = ACTIONS(375),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(79),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_match] = ACTIONS(83),
    [anon_sym_match_BANG] = ACTIONS(85),
    [anon_sym_function] = ACTIONS(87),
    [anon_sym_use] = ACTIONS(379),
    [anon_sym_use_BANG] = ACTIONS(381),
    [anon_sym_do_BANG] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(101),
    [aux_sym_char_token1] = ACTIONS(105),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(107),
    [anon_sym_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DQUOTE] = ACTIONS(111),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(115),
    [sym_bool] = ACTIONS(117),
    [sym_unit] = ACTIONS(1673),
    [anon_sym_LPAREN_PIPE] = ACTIONS(121),
    [sym_op_identifier] = ACTIONS(1675),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(385),
    [sym_xint] = ACTIONS(387),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(135),
  },
  [500] = {
    [sym_function_or_value_defn] = STATE(600),
    [sym__expression] = STATE(203),
    [sym_literal_expression] = STATE(867),
    [sym_long_identifier_or_op] = STATE(867),
    [sym_tuple_expression] = STATE(867),
    [sym_brace_expression] = STATE(867),
    [sym_anon_record_expression] = STATE(867),
    [sym_prefixed_expression] = STATE(867),
    [sym_typecast_expression] = STATE(867),
    [sym_for_expression] = STATE(867),
    [sym_while_expression] = STATE(867),
    [sym__if_branch] = STATE(6511),
    [sym_if_expression] = STATE(867),
    [sym_fun_expression] = STATE(867),
    [sym_try_expression] = STATE(867),
    [sym_match_expression] = STATE(867),
    [sym_function_expression] = STATE(867),
    [sym_mutate_expression] = STATE(867),
    [sym_index_expression] = STATE(867),
    [sym_typed_expression] = STATE(867),
    [sym_declaration_expression] = STATE(867),
    [sym_do_expression] = STATE(867),
    [sym_list_expression] = STATE(867),
    [sym_array_expression] = STATE(867),
    [sym_begin_end_expression] = STATE(867),
    [sym_paren_expression] = STATE(867),
    [sym__high_prec_app] = STATE(864),
    [sym__low_prec_app] = STATE(864),
    [sym_application_expression] = STATE(867),
    [sym_dot_expression] = STATE(867),
    [sym_infix_expression] = STATE(867),
    [sym_ce_expression] = STATE(867),
    [sym_sequential_expression] = STATE(867),
    [sym_char] = STATE(868),
    [sym_format_string] = STATE(869),
    [sym__string_literal] = STATE(869),
    [sym_string] = STATE(868),
    [sym_verbatim_string] = STATE(868),
    [sym_bytearray] = STATE(868),
    [sym_verbatim_bytearray] = STATE(868),
    [sym_format_triple_quoted_string] = STATE(870),
    [sym_triple_quoted_string] = STATE(868),
    [sym_const] = STATE(867),
    [sym_long_identifier] = STATE(872),
    [sym_active_pattern] = STATE(871),
    [sym__identifier_or_op] = STATE(873),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(656),
    [sym_sbyte] = STATE(868),
    [sym_byte] = STATE(868),
    [sym_int16] = STATE(868),
    [sym_uint16] = STATE(868),
    [sym_int32] = STATE(868),
    [sym_uint32] = STATE(868),
    [sym_nativeint] = STATE(868),
    [sym_unativeint] = STATE(868),
    [sym_int64] = STATE(868),
    [sym_uint64] = STATE(868),
    [sym_ieee32] = STATE(868),
    [sym_ieee64] = STATE(868),
    [sym_bignum] = STATE(868),
    [sym_decimal] = STATE(868),
    [sym_float] = STATE(1368),
    [sym_block_comment] = STATE(500),
    [sym_compiler_directive_decl] = STATE(500),
    [sym_fsi_directive_decl] = STATE(500),
    [sym_preproc_line] = STATE(500),
    [sym_preproc_if_in_expression] = STATE(867),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(29),
    [anon_sym_return] = ACTIONS(825),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_null] = ACTIONS(49),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACK_PIPE] = ACTIONS(57),
    [anon_sym_LBRACE] = ACTIONS(1663),
    [anon_sym_LT_AT] = ACTIONS(61),
    [anon_sym_LT_AT_AT] = ACTIONS(1665),
    [anon_sym_LBRACE_PIPE] = ACTIONS(67),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_return_BANG] = ACTIONS(829),
    [anon_sym_yield] = ACTIONS(825),
    [anon_sym_yield_BANG] = ACTIONS(829),
    [anon_sym_lazy] = ACTIONS(825),
    [anon_sym_assert] = ACTIONS(825),
    [anon_sym_upcast] = ACTIONS(825),
    [anon_sym_downcast] = ACTIONS(825),
    [anon_sym_for] = ACTIONS(73),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(79),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_match] = ACTIONS(83),
    [anon_sym_match_BANG] = ACTIONS(85),
    [anon_sym_function] = ACTIONS(87),
    [anon_sym_use] = ACTIONS(833),
    [anon_sym_use_BANG] = ACTIONS(835),
    [anon_sym_do_BANG] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(101),
    [aux_sym_char_token1] = ACTIONS(105),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(107),
    [anon_sym_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DQUOTE] = ACTIONS(111),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(115),
    [sym_bool] = ACTIONS(117),
    [sym_unit] = ACTIONS(1673),
    [anon_sym_LPAREN_PIPE] = ACTIONS(121),
    [sym_op_identifier] = ACTIONS(1675),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(837),
    [sym_xint] = ACTIONS(387),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(135),
  },
  [501] = {
    [sym_function_or_value_defn] = STATE(600),
    [sym__expression] = STATE(206),
    [sym_literal_expression] = STATE(867),
    [sym_long_identifier_or_op] = STATE(867),
    [sym_tuple_expression] = STATE(867),
    [sym_brace_expression] = STATE(867),
    [sym_anon_record_expression] = STATE(867),
    [sym_prefixed_expression] = STATE(867),
    [sym_typecast_expression] = STATE(867),
    [sym_for_expression] = STATE(867),
    [sym_while_expression] = STATE(867),
    [sym__if_branch] = STATE(6511),
    [sym_if_expression] = STATE(867),
    [sym_fun_expression] = STATE(867),
    [sym_try_expression] = STATE(867),
    [sym_match_expression] = STATE(867),
    [sym_function_expression] = STATE(867),
    [sym_mutate_expression] = STATE(867),
    [sym_index_expression] = STATE(867),
    [sym_typed_expression] = STATE(867),
    [sym_declaration_expression] = STATE(867),
    [sym_do_expression] = STATE(867),
    [sym_list_expression] = STATE(867),
    [sym_array_expression] = STATE(867),
    [sym_begin_end_expression] = STATE(867),
    [sym_paren_expression] = STATE(867),
    [sym__high_prec_app] = STATE(864),
    [sym__low_prec_app] = STATE(864),
    [sym_application_expression] = STATE(867),
    [sym_dot_expression] = STATE(867),
    [sym_infix_expression] = STATE(867),
    [sym_ce_expression] = STATE(867),
    [sym_sequential_expression] = STATE(867),
    [sym_char] = STATE(868),
    [sym_format_string] = STATE(869),
    [sym__string_literal] = STATE(869),
    [sym_string] = STATE(868),
    [sym_verbatim_string] = STATE(868),
    [sym_bytearray] = STATE(868),
    [sym_verbatim_bytearray] = STATE(868),
    [sym_format_triple_quoted_string] = STATE(870),
    [sym_triple_quoted_string] = STATE(868),
    [sym_const] = STATE(867),
    [sym_long_identifier] = STATE(872),
    [sym_active_pattern] = STATE(871),
    [sym__identifier_or_op] = STATE(873),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(656),
    [sym_sbyte] = STATE(868),
    [sym_byte] = STATE(868),
    [sym_int16] = STATE(868),
    [sym_uint16] = STATE(868),
    [sym_int32] = STATE(868),
    [sym_uint32] = STATE(868),
    [sym_nativeint] = STATE(868),
    [sym_unativeint] = STATE(868),
    [sym_int64] = STATE(868),
    [sym_uint64] = STATE(868),
    [sym_ieee32] = STATE(868),
    [sym_ieee64] = STATE(868),
    [sym_bignum] = STATE(868),
    [sym_decimal] = STATE(868),
    [sym_float] = STATE(1368),
    [sym_block_comment] = STATE(501),
    [sym_compiler_directive_decl] = STATE(501),
    [sym_fsi_directive_decl] = STATE(501),
    [sym_preproc_line] = STATE(501),
    [sym_preproc_if_in_expression] = STATE(867),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(29),
    [anon_sym_return] = ACTIONS(825),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_null] = ACTIONS(49),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACK_PIPE] = ACTIONS(57),
    [anon_sym_LBRACE] = ACTIONS(1663),
    [anon_sym_LT_AT] = ACTIONS(61),
    [anon_sym_LT_AT_AT] = ACTIONS(1665),
    [anon_sym_LBRACE_PIPE] = ACTIONS(67),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_return_BANG] = ACTIONS(829),
    [anon_sym_yield] = ACTIONS(825),
    [anon_sym_yield_BANG] = ACTIONS(829),
    [anon_sym_lazy] = ACTIONS(825),
    [anon_sym_assert] = ACTIONS(825),
    [anon_sym_upcast] = ACTIONS(825),
    [anon_sym_downcast] = ACTIONS(825),
    [anon_sym_for] = ACTIONS(73),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(79),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_match] = ACTIONS(83),
    [anon_sym_match_BANG] = ACTIONS(85),
    [anon_sym_function] = ACTIONS(87),
    [anon_sym_use] = ACTIONS(833),
    [anon_sym_use_BANG] = ACTIONS(835),
    [anon_sym_do_BANG] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(101),
    [aux_sym_char_token1] = ACTIONS(105),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(107),
    [anon_sym_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DQUOTE] = ACTIONS(111),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(115),
    [sym_bool] = ACTIONS(117),
    [sym_unit] = ACTIONS(1673),
    [anon_sym_LPAREN_PIPE] = ACTIONS(121),
    [sym_op_identifier] = ACTIONS(1675),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(837),
    [sym_xint] = ACTIONS(387),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(135),
  },
  [502] = {
    [sym_function_or_value_defn] = STATE(627),
    [sym__expression] = STATE(20),
    [sym_literal_expression] = STATE(1118),
    [sym_long_identifier_or_op] = STATE(1118),
    [sym_tuple_expression] = STATE(1118),
    [sym_brace_expression] = STATE(1118),
    [sym_anon_record_expression] = STATE(1118),
    [sym_prefixed_expression] = STATE(1118),
    [sym_typecast_expression] = STATE(1118),
    [sym_for_expression] = STATE(1118),
    [sym_while_expression] = STATE(1118),
    [sym__if_branch] = STATE(7163),
    [sym_if_expression] = STATE(1118),
    [sym_fun_expression] = STATE(1118),
    [sym_try_expression] = STATE(1118),
    [sym_match_expression] = STATE(1118),
    [sym_function_expression] = STATE(1118),
    [sym_mutate_expression] = STATE(1118),
    [sym_index_expression] = STATE(1118),
    [sym_typed_expression] = STATE(1118),
    [sym_declaration_expression] = STATE(1118),
    [sym_do_expression] = STATE(1118),
    [sym_list_expression] = STATE(1118),
    [sym_array_expression] = STATE(1118),
    [sym_begin_end_expression] = STATE(1118),
    [sym_paren_expression] = STATE(1118),
    [sym__high_prec_app] = STATE(1133),
    [sym__low_prec_app] = STATE(1133),
    [sym_application_expression] = STATE(1118),
    [sym_dot_expression] = STATE(1118),
    [sym_infix_expression] = STATE(1118),
    [sym_ce_expression] = STATE(1118),
    [sym_sequential_expression] = STATE(1118),
    [sym_char] = STATE(1080),
    [sym_format_string] = STATE(1090),
    [sym__string_literal] = STATE(1090),
    [sym_string] = STATE(1080),
    [sym_verbatim_string] = STATE(1080),
    [sym_bytearray] = STATE(1080),
    [sym_verbatim_bytearray] = STATE(1080),
    [sym_format_triple_quoted_string] = STATE(1096),
    [sym_triple_quoted_string] = STATE(1080),
    [sym_const] = STATE(1118),
    [sym_long_identifier] = STATE(1156),
    [sym_active_pattern] = STATE(1085),
    [sym__identifier_or_op] = STATE(1099),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(517),
    [sym_sbyte] = STATE(1080),
    [sym_byte] = STATE(1080),
    [sym_int16] = STATE(1080),
    [sym_uint16] = STATE(1080),
    [sym_int32] = STATE(1080),
    [sym_uint32] = STATE(1080),
    [sym_nativeint] = STATE(1080),
    [sym_unativeint] = STATE(1080),
    [sym_int64] = STATE(1080),
    [sym_uint64] = STATE(1080),
    [sym_ieee32] = STATE(1080),
    [sym_ieee64] = STATE(1080),
    [sym_bignum] = STATE(1080),
    [sym_decimal] = STATE(1080),
    [sym_float] = STATE(979),
    [sym_block_comment] = STATE(502),
    [sym_compiler_directive_decl] = STATE(502),
    [sym_fsi_directive_decl] = STATE(502),
    [sym_preproc_line] = STATE(502),
    [sym_preproc_if_in_expression] = STATE(1118),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(195),
    [anon_sym_return] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_null] = ACTIONS(207),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(209),
    [anon_sym_LBRACK_PIPE] = ACTIONS(211),
    [anon_sym_LBRACE] = ACTIONS(1687),
    [anon_sym_LT_AT] = ACTIONS(213),
    [anon_sym_LT_AT_AT] = ACTIONS(1689),
    [anon_sym_LBRACE_PIPE] = ACTIONS(217),
    [anon_sym_new] = ACTIONS(199),
    [anon_sym_return_BANG] = ACTIONS(219),
    [anon_sym_yield] = ACTIONS(199),
    [anon_sym_yield_BANG] = ACTIONS(219),
    [anon_sym_lazy] = ACTIONS(199),
    [anon_sym_assert] = ACTIONS(199),
    [anon_sym_upcast] = ACTIONS(199),
    [anon_sym_downcast] = ACTIONS(199),
    [anon_sym_for] = ACTIONS(223),
    [anon_sym_while] = ACTIONS(225),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(229),
    [anon_sym_match] = ACTIONS(231),
    [anon_sym_match_BANG] = ACTIONS(233),
    [anon_sym_function] = ACTIONS(235),
    [anon_sym_use] = ACTIONS(239),
    [anon_sym_use_BANG] = ACTIONS(241),
    [anon_sym_do_BANG] = ACTIONS(243),
    [anon_sym_begin] = ACTIONS(245),
    [aux_sym_char_token1] = ACTIONS(247),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(251),
    [anon_sym_AT_DQUOTE] = ACTIONS(253),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(255),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(257),
    [sym_bool] = ACTIONS(259),
    [sym_unit] = ACTIONS(1699),
    [anon_sym_LPAREN_PIPE] = ACTIONS(261),
    [sym_op_identifier] = ACTIONS(1701),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(265),
    [sym_xint] = ACTIONS(267),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(269),
  },
  [503] = {
    [sym_function_or_value_defn] = STATE(703),
    [sym__expression] = STATE(117),
    [sym_literal_expression] = STATE(1797),
    [sym_long_identifier_or_op] = STATE(1797),
    [sym_tuple_expression] = STATE(1797),
    [sym_brace_expression] = STATE(1797),
    [sym_anon_record_expression] = STATE(1797),
    [sym_prefixed_expression] = STATE(1797),
    [sym_typecast_expression] = STATE(1797),
    [sym_for_expression] = STATE(1797),
    [sym_while_expression] = STATE(1797),
    [sym__if_branch] = STATE(6611),
    [sym_if_expression] = STATE(1797),
    [sym_fun_expression] = STATE(1797),
    [sym_try_expression] = STATE(1797),
    [sym_match_expression] = STATE(1797),
    [sym_function_expression] = STATE(1797),
    [sym_mutate_expression] = STATE(1797),
    [sym_index_expression] = STATE(1797),
    [sym_typed_expression] = STATE(1797),
    [sym_declaration_expression] = STATE(1797),
    [sym_do_expression] = STATE(1797),
    [sym_list_expression] = STATE(1797),
    [sym_array_expression] = STATE(1797),
    [sym_begin_end_expression] = STATE(1797),
    [sym_paren_expression] = STATE(1797),
    [sym__high_prec_app] = STATE(1800),
    [sym__low_prec_app] = STATE(1800),
    [sym_application_expression] = STATE(1797),
    [sym_dot_expression] = STATE(1797),
    [sym_infix_expression] = STATE(1797),
    [sym_ce_expression] = STATE(1797),
    [sym_sequential_expression] = STATE(1797),
    [sym_char] = STATE(1694),
    [sym_format_string] = STATE(1693),
    [sym__string_literal] = STATE(1693),
    [sym_string] = STATE(1694),
    [sym_verbatim_string] = STATE(1694),
    [sym_bytearray] = STATE(1694),
    [sym_verbatim_bytearray] = STATE(1694),
    [sym_format_triple_quoted_string] = STATE(1692),
    [sym_triple_quoted_string] = STATE(1694),
    [sym_const] = STATE(1797),
    [sym_long_identifier] = STATE(1813),
    [sym_active_pattern] = STATE(1753),
    [sym__identifier_or_op] = STATE(1812),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(756),
    [sym_sbyte] = STATE(1694),
    [sym_byte] = STATE(1694),
    [sym_int16] = STATE(1694),
    [sym_uint16] = STATE(1694),
    [sym_int32] = STATE(1694),
    [sym_uint32] = STATE(1694),
    [sym_nativeint] = STATE(1694),
    [sym_unativeint] = STATE(1694),
    [sym_int64] = STATE(1694),
    [sym_uint64] = STATE(1694),
    [sym_ieee32] = STATE(1694),
    [sym_ieee64] = STATE(1694),
    [sym_bignum] = STATE(1694),
    [sym_decimal] = STATE(1694),
    [sym_float] = STATE(1425),
    [sym_block_comment] = STATE(503),
    [sym_compiler_directive_decl] = STATE(503),
    [sym_fsi_directive_decl] = STATE(503),
    [sym_preproc_line] = STATE(503),
    [sym_preproc_if_in_expression] = STATE(1797),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(393),
    [anon_sym_return] = ACTIONS(397),
    [anon_sym_do] = ACTIONS(399),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(401),
    [anon_sym_null] = ACTIONS(405),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(407),
    [anon_sym_LBRACK_PIPE] = ACTIONS(409),
    [anon_sym_LBRACE] = ACTIONS(2146),
    [anon_sym_LT_AT] = ACTIONS(413),
    [anon_sym_LT_AT_AT] = ACTIONS(2148),
    [anon_sym_LBRACE_PIPE] = ACTIONS(419),
    [anon_sym_new] = ACTIONS(397),
    [anon_sym_return_BANG] = ACTIONS(421),
    [anon_sym_yield] = ACTIONS(397),
    [anon_sym_yield_BANG] = ACTIONS(421),
    [anon_sym_lazy] = ACTIONS(397),
    [anon_sym_assert] = ACTIONS(397),
    [anon_sym_upcast] = ACTIONS(397),
    [anon_sym_downcast] = ACTIONS(397),
    [anon_sym_for] = ACTIONS(425),
    [anon_sym_while] = ACTIONS(427),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(429),
    [anon_sym_try] = ACTIONS(431),
    [anon_sym_match] = ACTIONS(433),
    [anon_sym_match_BANG] = ACTIONS(435),
    [anon_sym_function] = ACTIONS(437),
    [anon_sym_use] = ACTIONS(445),
    [anon_sym_use_BANG] = ACTIONS(447),
    [anon_sym_do_BANG] = ACTIONS(449),
    [anon_sym_begin] = ACTIONS(451),
    [aux_sym_char_token1] = ACTIONS(455),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(457),
    [anon_sym_DQUOTE] = ACTIONS(459),
    [anon_sym_AT_DQUOTE] = ACTIONS(461),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(463),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(465),
    [sym_bool] = ACTIONS(467),
    [sym_unit] = ACTIONS(2150),
    [anon_sym_LPAREN_PIPE] = ACTIONS(471),
    [sym_op_identifier] = ACTIONS(2152),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(475),
    [sym_xint] = ACTIONS(477),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(479),
  },
  [504] = {
    [sym_function_or_value_defn] = STATE(627),
    [sym__expression] = STATE(15),
    [sym_literal_expression] = STATE(1118),
    [sym_long_identifier_or_op] = STATE(1118),
    [sym_tuple_expression] = STATE(1118),
    [sym_brace_expression] = STATE(1118),
    [sym_anon_record_expression] = STATE(1118),
    [sym_prefixed_expression] = STATE(1118),
    [sym_typecast_expression] = STATE(1118),
    [sym_for_expression] = STATE(1118),
    [sym_while_expression] = STATE(1118),
    [sym__if_branch] = STATE(7163),
    [sym_if_expression] = STATE(1118),
    [sym_fun_expression] = STATE(1118),
    [sym_try_expression] = STATE(1118),
    [sym_match_expression] = STATE(1118),
    [sym_function_expression] = STATE(1118),
    [sym_mutate_expression] = STATE(1118),
    [sym_index_expression] = STATE(1118),
    [sym_typed_expression] = STATE(1118),
    [sym_declaration_expression] = STATE(1118),
    [sym_do_expression] = STATE(1118),
    [sym_list_expression] = STATE(1118),
    [sym_array_expression] = STATE(1118),
    [sym_begin_end_expression] = STATE(1118),
    [sym_paren_expression] = STATE(1118),
    [sym__high_prec_app] = STATE(1133),
    [sym__low_prec_app] = STATE(1133),
    [sym_application_expression] = STATE(1118),
    [sym_dot_expression] = STATE(1118),
    [sym_infix_expression] = STATE(1118),
    [sym_ce_expression] = STATE(1118),
    [sym_sequential_expression] = STATE(1118),
    [sym_char] = STATE(1080),
    [sym_format_string] = STATE(1090),
    [sym__string_literal] = STATE(1090),
    [sym_string] = STATE(1080),
    [sym_verbatim_string] = STATE(1080),
    [sym_bytearray] = STATE(1080),
    [sym_verbatim_bytearray] = STATE(1080),
    [sym_format_triple_quoted_string] = STATE(1096),
    [sym_triple_quoted_string] = STATE(1080),
    [sym_const] = STATE(1118),
    [sym_long_identifier] = STATE(1156),
    [sym_active_pattern] = STATE(1085),
    [sym__identifier_or_op] = STATE(1099),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(517),
    [sym_sbyte] = STATE(1080),
    [sym_byte] = STATE(1080),
    [sym_int16] = STATE(1080),
    [sym_uint16] = STATE(1080),
    [sym_int32] = STATE(1080),
    [sym_uint32] = STATE(1080),
    [sym_nativeint] = STATE(1080),
    [sym_unativeint] = STATE(1080),
    [sym_int64] = STATE(1080),
    [sym_uint64] = STATE(1080),
    [sym_ieee32] = STATE(1080),
    [sym_ieee64] = STATE(1080),
    [sym_bignum] = STATE(1080),
    [sym_decimal] = STATE(1080),
    [sym_float] = STATE(979),
    [sym_block_comment] = STATE(504),
    [sym_compiler_directive_decl] = STATE(504),
    [sym_fsi_directive_decl] = STATE(504),
    [sym_preproc_line] = STATE(504),
    [sym_preproc_if_in_expression] = STATE(1118),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(195),
    [anon_sym_return] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_null] = ACTIONS(207),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(209),
    [anon_sym_LBRACK_PIPE] = ACTIONS(211),
    [anon_sym_LBRACE] = ACTIONS(1687),
    [anon_sym_LT_AT] = ACTIONS(213),
    [anon_sym_LT_AT_AT] = ACTIONS(1689),
    [anon_sym_LBRACE_PIPE] = ACTIONS(217),
    [anon_sym_new] = ACTIONS(199),
    [anon_sym_return_BANG] = ACTIONS(219),
    [anon_sym_yield] = ACTIONS(199),
    [anon_sym_yield_BANG] = ACTIONS(219),
    [anon_sym_lazy] = ACTIONS(199),
    [anon_sym_assert] = ACTIONS(199),
    [anon_sym_upcast] = ACTIONS(199),
    [anon_sym_downcast] = ACTIONS(199),
    [anon_sym_for] = ACTIONS(223),
    [anon_sym_while] = ACTIONS(225),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(229),
    [anon_sym_match] = ACTIONS(231),
    [anon_sym_match_BANG] = ACTIONS(233),
    [anon_sym_function] = ACTIONS(235),
    [anon_sym_use] = ACTIONS(239),
    [anon_sym_use_BANG] = ACTIONS(241),
    [anon_sym_do_BANG] = ACTIONS(243),
    [anon_sym_begin] = ACTIONS(245),
    [aux_sym_char_token1] = ACTIONS(247),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(251),
    [anon_sym_AT_DQUOTE] = ACTIONS(253),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(255),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(257),
    [sym_bool] = ACTIONS(259),
    [sym_unit] = ACTIONS(1699),
    [anon_sym_LPAREN_PIPE] = ACTIONS(261),
    [sym_op_identifier] = ACTIONS(1701),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(265),
    [sym_xint] = ACTIONS(267),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(269),
  },
  [505] = {
    [sym_function_or_value_defn] = STATE(600),
    [sym__expression] = STATE(207),
    [sym_literal_expression] = STATE(867),
    [sym_long_identifier_or_op] = STATE(867),
    [sym_tuple_expression] = STATE(867),
    [sym_brace_expression] = STATE(867),
    [sym_anon_record_expression] = STATE(867),
    [sym_prefixed_expression] = STATE(867),
    [sym_typecast_expression] = STATE(867),
    [sym_for_expression] = STATE(867),
    [sym_while_expression] = STATE(867),
    [sym__if_branch] = STATE(6511),
    [sym_if_expression] = STATE(867),
    [sym_fun_expression] = STATE(867),
    [sym_try_expression] = STATE(867),
    [sym_match_expression] = STATE(867),
    [sym_function_expression] = STATE(867),
    [sym_mutate_expression] = STATE(867),
    [sym_index_expression] = STATE(867),
    [sym_typed_expression] = STATE(867),
    [sym_declaration_expression] = STATE(867),
    [sym_do_expression] = STATE(867),
    [sym_list_expression] = STATE(867),
    [sym_array_expression] = STATE(867),
    [sym_begin_end_expression] = STATE(867),
    [sym_paren_expression] = STATE(867),
    [sym__high_prec_app] = STATE(864),
    [sym__low_prec_app] = STATE(864),
    [sym_application_expression] = STATE(867),
    [sym_dot_expression] = STATE(867),
    [sym_infix_expression] = STATE(867),
    [sym_ce_expression] = STATE(867),
    [sym_sequential_expression] = STATE(867),
    [sym_char] = STATE(868),
    [sym_format_string] = STATE(869),
    [sym__string_literal] = STATE(869),
    [sym_string] = STATE(868),
    [sym_verbatim_string] = STATE(868),
    [sym_bytearray] = STATE(868),
    [sym_verbatim_bytearray] = STATE(868),
    [sym_format_triple_quoted_string] = STATE(870),
    [sym_triple_quoted_string] = STATE(868),
    [sym_const] = STATE(867),
    [sym_long_identifier] = STATE(872),
    [sym_active_pattern] = STATE(871),
    [sym__identifier_or_op] = STATE(873),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(656),
    [sym_sbyte] = STATE(868),
    [sym_byte] = STATE(868),
    [sym_int16] = STATE(868),
    [sym_uint16] = STATE(868),
    [sym_int32] = STATE(868),
    [sym_uint32] = STATE(868),
    [sym_nativeint] = STATE(868),
    [sym_unativeint] = STATE(868),
    [sym_int64] = STATE(868),
    [sym_uint64] = STATE(868),
    [sym_ieee32] = STATE(868),
    [sym_ieee64] = STATE(868),
    [sym_bignum] = STATE(868),
    [sym_decimal] = STATE(868),
    [sym_float] = STATE(1368),
    [sym_block_comment] = STATE(505),
    [sym_compiler_directive_decl] = STATE(505),
    [sym_fsi_directive_decl] = STATE(505),
    [sym_preproc_line] = STATE(505),
    [sym_preproc_if_in_expression] = STATE(867),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(29),
    [anon_sym_return] = ACTIONS(825),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_null] = ACTIONS(49),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACK_PIPE] = ACTIONS(57),
    [anon_sym_LBRACE] = ACTIONS(1663),
    [anon_sym_LT_AT] = ACTIONS(61),
    [anon_sym_LT_AT_AT] = ACTIONS(1665),
    [anon_sym_LBRACE_PIPE] = ACTIONS(67),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_return_BANG] = ACTIONS(829),
    [anon_sym_yield] = ACTIONS(825),
    [anon_sym_yield_BANG] = ACTIONS(829),
    [anon_sym_lazy] = ACTIONS(825),
    [anon_sym_assert] = ACTIONS(825),
    [anon_sym_upcast] = ACTIONS(825),
    [anon_sym_downcast] = ACTIONS(825),
    [anon_sym_for] = ACTIONS(73),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(79),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_match] = ACTIONS(83),
    [anon_sym_match_BANG] = ACTIONS(85),
    [anon_sym_function] = ACTIONS(87),
    [anon_sym_use] = ACTIONS(833),
    [anon_sym_use_BANG] = ACTIONS(835),
    [anon_sym_do_BANG] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(101),
    [aux_sym_char_token1] = ACTIONS(105),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(107),
    [anon_sym_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DQUOTE] = ACTIONS(111),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(115),
    [sym_bool] = ACTIONS(117),
    [sym_unit] = ACTIONS(1673),
    [anon_sym_LPAREN_PIPE] = ACTIONS(121),
    [sym_op_identifier] = ACTIONS(1675),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(837),
    [sym_xint] = ACTIONS(387),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(135),
  },
  [506] = {
    [sym_function_or_value_defn] = STATE(527),
    [sym__expression] = STATE(271),
    [sym_literal_expression] = STATE(2384),
    [sym_long_identifier_or_op] = STATE(2384),
    [sym_tuple_expression] = STATE(2384),
    [sym_brace_expression] = STATE(2384),
    [sym_anon_record_expression] = STATE(2384),
    [sym_prefixed_expression] = STATE(2384),
    [sym_typecast_expression] = STATE(2384),
    [sym_for_expression] = STATE(2384),
    [sym_while_expression] = STATE(2384),
    [sym__if_branch] = STATE(6561),
    [sym_if_expression] = STATE(2384),
    [sym_fun_expression] = STATE(2384),
    [sym_try_expression] = STATE(2384),
    [sym_match_expression] = STATE(2384),
    [sym_function_expression] = STATE(2384),
    [sym_mutate_expression] = STATE(2384),
    [sym_index_expression] = STATE(2384),
    [sym_typed_expression] = STATE(2384),
    [sym_declaration_expression] = STATE(2384),
    [sym_do_expression] = STATE(2384),
    [sym_list_expression] = STATE(2384),
    [sym_array_expression] = STATE(2384),
    [sym_begin_end_expression] = STATE(2384),
    [sym_paren_expression] = STATE(2384),
    [sym__high_prec_app] = STATE(2249),
    [sym__low_prec_app] = STATE(2249),
    [sym_application_expression] = STATE(2384),
    [sym_dot_expression] = STATE(2384),
    [sym_infix_expression] = STATE(2384),
    [sym_ce_expression] = STATE(2384),
    [sym_sequential_expression] = STATE(2384),
    [sym_char] = STATE(2144),
    [sym_format_string] = STATE(2142),
    [sym__string_literal] = STATE(2142),
    [sym_string] = STATE(2144),
    [sym_verbatim_string] = STATE(2144),
    [sym_bytearray] = STATE(2144),
    [sym_verbatim_bytearray] = STATE(2144),
    [sym_format_triple_quoted_string] = STATE(2141),
    [sym_triple_quoted_string] = STATE(2144),
    [sym_const] = STATE(2384),
    [sym_long_identifier] = STATE(2400),
    [sym_active_pattern] = STATE(2317),
    [sym__identifier_or_op] = STATE(2392),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(633),
    [sym_sbyte] = STATE(2144),
    [sym_byte] = STATE(2144),
    [sym_int16] = STATE(2144),
    [sym_uint16] = STATE(2144),
    [sym_int32] = STATE(2144),
    [sym_uint32] = STATE(2144),
    [sym_nativeint] = STATE(2144),
    [sym_unativeint] = STATE(2144),
    [sym_int64] = STATE(2144),
    [sym_uint64] = STATE(2144),
    [sym_ieee32] = STATE(2144),
    [sym_ieee64] = STATE(2144),
    [sym_bignum] = STATE(2144),
    [sym_decimal] = STATE(2144),
    [sym_float] = STATE(1672),
    [sym_block_comment] = STATE(506),
    [sym_compiler_directive_decl] = STATE(506),
    [sym_fsi_directive_decl] = STATE(506),
    [sym_preproc_line] = STATE(506),
    [sym_preproc_if_in_expression] = STATE(2384),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(1439),
    [anon_sym_return] = ACTIONS(1443),
    [anon_sym_do] = ACTIONS(1445),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(1447),
    [anon_sym_null] = ACTIONS(1451),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1453),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1455),
    [anon_sym_LBRACE] = ACTIONS(2036),
    [anon_sym_LT_AT] = ACTIONS(1459),
    [anon_sym_LT_AT_AT] = ACTIONS(2038),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1465),
    [anon_sym_new] = ACTIONS(1443),
    [anon_sym_return_BANG] = ACTIONS(1467),
    [anon_sym_yield] = ACTIONS(1443),
    [anon_sym_yield_BANG] = ACTIONS(1467),
    [anon_sym_lazy] = ACTIONS(1443),
    [anon_sym_assert] = ACTIONS(1443),
    [anon_sym_upcast] = ACTIONS(1443),
    [anon_sym_downcast] = ACTIONS(1443),
    [anon_sym_for] = ACTIONS(1471),
    [anon_sym_while] = ACTIONS(1473),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(1475),
    [anon_sym_try] = ACTIONS(1477),
    [anon_sym_match] = ACTIONS(1479),
    [anon_sym_match_BANG] = ACTIONS(1481),
    [anon_sym_function] = ACTIONS(1483),
    [anon_sym_use] = ACTIONS(1491),
    [anon_sym_use_BANG] = ACTIONS(1493),
    [anon_sym_do_BANG] = ACTIONS(1495),
    [anon_sym_begin] = ACTIONS(1497),
    [aux_sym_char_token1] = ACTIONS(1501),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1503),
    [anon_sym_DQUOTE] = ACTIONS(1505),
    [anon_sym_AT_DQUOTE] = ACTIONS(1507),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1509),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1511),
    [sym_bool] = ACTIONS(1513),
    [sym_unit] = ACTIONS(2040),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1517),
    [sym_op_identifier] = ACTIONS(2042),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(1521),
    [sym_xint] = ACTIONS(1523),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1525),
  },
  [507] = {
    [sym_function_or_value_defn] = STATE(600),
    [sym__expression] = STATE(209),
    [sym_literal_expression] = STATE(867),
    [sym_long_identifier_or_op] = STATE(867),
    [sym_tuple_expression] = STATE(867),
    [sym_brace_expression] = STATE(867),
    [sym_anon_record_expression] = STATE(867),
    [sym_prefixed_expression] = STATE(867),
    [sym_typecast_expression] = STATE(867),
    [sym_for_expression] = STATE(867),
    [sym_while_expression] = STATE(867),
    [sym__if_branch] = STATE(6511),
    [sym_if_expression] = STATE(867),
    [sym_fun_expression] = STATE(867),
    [sym_try_expression] = STATE(867),
    [sym_match_expression] = STATE(867),
    [sym_function_expression] = STATE(867),
    [sym_mutate_expression] = STATE(867),
    [sym_index_expression] = STATE(867),
    [sym_typed_expression] = STATE(867),
    [sym_declaration_expression] = STATE(867),
    [sym_do_expression] = STATE(867),
    [sym_list_expression] = STATE(867),
    [sym_array_expression] = STATE(867),
    [sym_begin_end_expression] = STATE(867),
    [sym_paren_expression] = STATE(867),
    [sym__high_prec_app] = STATE(864),
    [sym__low_prec_app] = STATE(864),
    [sym_application_expression] = STATE(867),
    [sym_dot_expression] = STATE(867),
    [sym_infix_expression] = STATE(867),
    [sym_ce_expression] = STATE(867),
    [sym_sequential_expression] = STATE(867),
    [sym_char] = STATE(868),
    [sym_format_string] = STATE(869),
    [sym__string_literal] = STATE(869),
    [sym_string] = STATE(868),
    [sym_verbatim_string] = STATE(868),
    [sym_bytearray] = STATE(868),
    [sym_verbatim_bytearray] = STATE(868),
    [sym_format_triple_quoted_string] = STATE(870),
    [sym_triple_quoted_string] = STATE(868),
    [sym_const] = STATE(867),
    [sym_long_identifier] = STATE(872),
    [sym_active_pattern] = STATE(871),
    [sym__identifier_or_op] = STATE(873),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(656),
    [sym_sbyte] = STATE(868),
    [sym_byte] = STATE(868),
    [sym_int16] = STATE(868),
    [sym_uint16] = STATE(868),
    [sym_int32] = STATE(868),
    [sym_uint32] = STATE(868),
    [sym_nativeint] = STATE(868),
    [sym_unativeint] = STATE(868),
    [sym_int64] = STATE(868),
    [sym_uint64] = STATE(868),
    [sym_ieee32] = STATE(868),
    [sym_ieee64] = STATE(868),
    [sym_bignum] = STATE(868),
    [sym_decimal] = STATE(868),
    [sym_float] = STATE(1368),
    [sym_block_comment] = STATE(507),
    [sym_compiler_directive_decl] = STATE(507),
    [sym_fsi_directive_decl] = STATE(507),
    [sym_preproc_line] = STATE(507),
    [sym_preproc_if_in_expression] = STATE(867),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(29),
    [anon_sym_return] = ACTIONS(825),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_null] = ACTIONS(49),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACK_PIPE] = ACTIONS(57),
    [anon_sym_LBRACE] = ACTIONS(1663),
    [anon_sym_LT_AT] = ACTIONS(61),
    [anon_sym_LT_AT_AT] = ACTIONS(1665),
    [anon_sym_LBRACE_PIPE] = ACTIONS(67),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_return_BANG] = ACTIONS(829),
    [anon_sym_yield] = ACTIONS(825),
    [anon_sym_yield_BANG] = ACTIONS(829),
    [anon_sym_lazy] = ACTIONS(825),
    [anon_sym_assert] = ACTIONS(825),
    [anon_sym_upcast] = ACTIONS(825),
    [anon_sym_downcast] = ACTIONS(825),
    [anon_sym_for] = ACTIONS(73),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(79),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_match] = ACTIONS(83),
    [anon_sym_match_BANG] = ACTIONS(85),
    [anon_sym_function] = ACTIONS(87),
    [anon_sym_use] = ACTIONS(833),
    [anon_sym_use_BANG] = ACTIONS(835),
    [anon_sym_do_BANG] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(101),
    [aux_sym_char_token1] = ACTIONS(105),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(107),
    [anon_sym_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DQUOTE] = ACTIONS(111),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(115),
    [sym_bool] = ACTIONS(117),
    [sym_unit] = ACTIONS(1673),
    [anon_sym_LPAREN_PIPE] = ACTIONS(121),
    [sym_op_identifier] = ACTIONS(1675),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(837),
    [sym_xint] = ACTIONS(387),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(135),
  },
  [508] = {
    [sym_function_or_value_defn] = STATE(600),
    [sym__expression] = STATE(290),
    [sym_literal_expression] = STATE(867),
    [sym_long_identifier_or_op] = STATE(867),
    [sym_tuple_expression] = STATE(867),
    [sym_brace_expression] = STATE(867),
    [sym_anon_record_expression] = STATE(867),
    [sym_prefixed_expression] = STATE(867),
    [sym_typecast_expression] = STATE(867),
    [sym_for_expression] = STATE(867),
    [sym_while_expression] = STATE(867),
    [sym__if_branch] = STATE(6511),
    [sym_if_expression] = STATE(867),
    [sym_fun_expression] = STATE(867),
    [sym_try_expression] = STATE(867),
    [sym_match_expression] = STATE(867),
    [sym_function_expression] = STATE(867),
    [sym_mutate_expression] = STATE(867),
    [sym_index_expression] = STATE(867),
    [sym_typed_expression] = STATE(867),
    [sym_declaration_expression] = STATE(867),
    [sym_do_expression] = STATE(867),
    [sym_list_expression] = STATE(867),
    [sym_array_expression] = STATE(867),
    [sym_begin_end_expression] = STATE(867),
    [sym_paren_expression] = STATE(867),
    [sym__high_prec_app] = STATE(864),
    [sym__low_prec_app] = STATE(864),
    [sym_application_expression] = STATE(867),
    [sym_dot_expression] = STATE(867),
    [sym_infix_expression] = STATE(867),
    [sym_ce_expression] = STATE(867),
    [sym_sequential_expression] = STATE(867),
    [sym_char] = STATE(868),
    [sym_format_string] = STATE(869),
    [sym__string_literal] = STATE(869),
    [sym_string] = STATE(868),
    [sym_verbatim_string] = STATE(868),
    [sym_bytearray] = STATE(868),
    [sym_verbatim_bytearray] = STATE(868),
    [sym_format_triple_quoted_string] = STATE(870),
    [sym_triple_quoted_string] = STATE(868),
    [sym_const] = STATE(867),
    [sym_long_identifier] = STATE(872),
    [sym_active_pattern] = STATE(871),
    [sym__identifier_or_op] = STATE(873),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(656),
    [sym_sbyte] = STATE(868),
    [sym_byte] = STATE(868),
    [sym_int16] = STATE(868),
    [sym_uint16] = STATE(868),
    [sym_int32] = STATE(868),
    [sym_uint32] = STATE(868),
    [sym_nativeint] = STATE(868),
    [sym_unativeint] = STATE(868),
    [sym_int64] = STATE(868),
    [sym_uint64] = STATE(868),
    [sym_ieee32] = STATE(868),
    [sym_ieee64] = STATE(868),
    [sym_bignum] = STATE(868),
    [sym_decimal] = STATE(868),
    [sym_float] = STATE(1368),
    [sym_block_comment] = STATE(508),
    [sym_compiler_directive_decl] = STATE(508),
    [sym_fsi_directive_decl] = STATE(508),
    [sym_preproc_line] = STATE(508),
    [sym_preproc_if_in_expression] = STATE(867),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(29),
    [anon_sym_return] = ACTIONS(825),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_null] = ACTIONS(49),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACK_PIPE] = ACTIONS(57),
    [anon_sym_LBRACE] = ACTIONS(1663),
    [anon_sym_LT_AT] = ACTIONS(61),
    [anon_sym_LT_AT_AT] = ACTIONS(1665),
    [anon_sym_LBRACE_PIPE] = ACTIONS(67),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_return_BANG] = ACTIONS(829),
    [anon_sym_yield] = ACTIONS(825),
    [anon_sym_yield_BANG] = ACTIONS(829),
    [anon_sym_lazy] = ACTIONS(825),
    [anon_sym_assert] = ACTIONS(825),
    [anon_sym_upcast] = ACTIONS(825),
    [anon_sym_downcast] = ACTIONS(825),
    [anon_sym_for] = ACTIONS(73),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(79),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_match] = ACTIONS(83),
    [anon_sym_match_BANG] = ACTIONS(85),
    [anon_sym_function] = ACTIONS(87),
    [anon_sym_use] = ACTIONS(833),
    [anon_sym_use_BANG] = ACTIONS(835),
    [anon_sym_do_BANG] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(101),
    [aux_sym_char_token1] = ACTIONS(105),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(107),
    [anon_sym_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DQUOTE] = ACTIONS(111),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(115),
    [sym_bool] = ACTIONS(117),
    [sym_unit] = ACTIONS(1673),
    [anon_sym_LPAREN_PIPE] = ACTIONS(121),
    [sym_op_identifier] = ACTIONS(1675),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(837),
    [sym_xint] = ACTIONS(387),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(135),
  },
  [509] = {
    [sym_function_or_value_defn] = STATE(509),
    [sym__expression] = STATE(315),
    [sym_literal_expression] = STATE(2230),
    [sym_long_identifier_or_op] = STATE(2230),
    [sym_tuple_expression] = STATE(2230),
    [sym_brace_expression] = STATE(2230),
    [sym_anon_record_expression] = STATE(2230),
    [sym_prefixed_expression] = STATE(2230),
    [sym_typecast_expression] = STATE(2230),
    [sym_for_expression] = STATE(2230),
    [sym_while_expression] = STATE(2230),
    [sym__if_branch] = STATE(6659),
    [sym_if_expression] = STATE(2230),
    [sym_fun_expression] = STATE(2230),
    [sym_try_expression] = STATE(2230),
    [sym_match_expression] = STATE(2230),
    [sym_function_expression] = STATE(2230),
    [sym_mutate_expression] = STATE(2230),
    [sym_index_expression] = STATE(2230),
    [sym_typed_expression] = STATE(2230),
    [sym_declaration_expression] = STATE(2230),
    [sym_do_expression] = STATE(2230),
    [sym_list_expression] = STATE(2230),
    [sym_array_expression] = STATE(2230),
    [sym_begin_end_expression] = STATE(2230),
    [sym_paren_expression] = STATE(2230),
    [sym__high_prec_app] = STATE(2229),
    [sym__low_prec_app] = STATE(2229),
    [sym_application_expression] = STATE(2230),
    [sym_dot_expression] = STATE(2230),
    [sym_infix_expression] = STATE(2230),
    [sym_ce_expression] = STATE(2230),
    [sym_sequential_expression] = STATE(2230),
    [sym_char] = STATE(2100),
    [sym_format_string] = STATE(2106),
    [sym__string_literal] = STATE(2106),
    [sym_string] = STATE(2100),
    [sym_verbatim_string] = STATE(2100),
    [sym_bytearray] = STATE(2100),
    [sym_verbatim_bytearray] = STATE(2100),
    [sym_format_triple_quoted_string] = STATE(2107),
    [sym_triple_quoted_string] = STATE(2100),
    [sym_const] = STATE(2230),
    [sym_long_identifier] = STATE(2232),
    [sym_active_pattern] = STATE(2424),
    [sym__identifier_or_op] = STATE(2305),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(737),
    [sym_sbyte] = STATE(2100),
    [sym_byte] = STATE(2100),
    [sym_int16] = STATE(2100),
    [sym_uint16] = STATE(2100),
    [sym_int32] = STATE(2100),
    [sym_uint32] = STATE(2100),
    [sym_nativeint] = STATE(2100),
    [sym_unativeint] = STATE(2100),
    [sym_int64] = STATE(2100),
    [sym_uint64] = STATE(2100),
    [sym_ieee32] = STATE(2100),
    [sym_ieee64] = STATE(2100),
    [sym_bignum] = STATE(2100),
    [sym_decimal] = STATE(2100),
    [sym_float] = STATE(1487),
    [sym_block_comment] = STATE(509),
    [sym_compiler_directive_decl] = STATE(509),
    [sym_fsi_directive_decl] = STATE(509),
    [sym_preproc_line] = STATE(509),
    [sym_preproc_if_in_expression] = STATE(2230),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(877),
    [anon_sym_return] = ACTIONS(881),
    [anon_sym_do] = ACTIONS(1585),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(885),
    [anon_sym_null] = ACTIONS(889),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(891),
    [anon_sym_LBRACK_PIPE] = ACTIONS(893),
    [anon_sym_LBRACE] = ACTIONS(2048),
    [anon_sym_LT_AT] = ACTIONS(897),
    [anon_sym_LT_AT_AT] = ACTIONS(2050),
    [anon_sym_LBRACE_PIPE] = ACTIONS(903),
    [anon_sym_new] = ACTIONS(881),
    [anon_sym_return_BANG] = ACTIONS(905),
    [anon_sym_yield] = ACTIONS(881),
    [anon_sym_yield_BANG] = ACTIONS(905),
    [anon_sym_lazy] = ACTIONS(881),
    [anon_sym_assert] = ACTIONS(881),
    [anon_sym_upcast] = ACTIONS(881),
    [anon_sym_downcast] = ACTIONS(881),
    [anon_sym_for] = ACTIONS(909),
    [anon_sym_while] = ACTIONS(911),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(913),
    [anon_sym_try] = ACTIONS(915),
    [anon_sym_match] = ACTIONS(917),
    [anon_sym_match_BANG] = ACTIONS(919),
    [anon_sym_function] = ACTIONS(921),
    [anon_sym_use] = ACTIONS(929),
    [anon_sym_use_BANG] = ACTIONS(931),
    [anon_sym_do_BANG] = ACTIONS(933),
    [anon_sym_begin] = ACTIONS(937),
    [aux_sym_char_token1] = ACTIONS(941),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(943),
    [anon_sym_DQUOTE] = ACTIONS(945),
    [anon_sym_AT_DQUOTE] = ACTIONS(947),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(949),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(951),
    [sym_bool] = ACTIONS(953),
    [sym_unit] = ACTIONS(2052),
    [anon_sym_LPAREN_PIPE] = ACTIONS(957),
    [sym_op_identifier] = ACTIONS(2054),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(961),
    [sym_xint] = ACTIONS(963),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(965),
  },
  [510] = {
    [sym_function_or_value_defn] = STATE(532),
    [sym__expression] = STATE(84),
    [sym_literal_expression] = STATE(2000),
    [sym_long_identifier_or_op] = STATE(2000),
    [sym_tuple_expression] = STATE(2000),
    [sym_brace_expression] = STATE(2000),
    [sym_anon_record_expression] = STATE(2000),
    [sym_prefixed_expression] = STATE(2000),
    [sym_typecast_expression] = STATE(2000),
    [sym_for_expression] = STATE(2000),
    [sym_while_expression] = STATE(2000),
    [sym__if_branch] = STATE(6707),
    [sym_if_expression] = STATE(2000),
    [sym_fun_expression] = STATE(2000),
    [sym_try_expression] = STATE(2000),
    [sym_match_expression] = STATE(2000),
    [sym_function_expression] = STATE(2000),
    [sym_mutate_expression] = STATE(2000),
    [sym_index_expression] = STATE(2000),
    [sym_typed_expression] = STATE(2000),
    [sym_declaration_expression] = STATE(2000),
    [sym_do_expression] = STATE(2000),
    [sym_list_expression] = STATE(2000),
    [sym_array_expression] = STATE(2000),
    [sym_begin_end_expression] = STATE(2000),
    [sym_paren_expression] = STATE(2000),
    [sym__high_prec_app] = STATE(2003),
    [sym__low_prec_app] = STATE(2003),
    [sym_application_expression] = STATE(2000),
    [sym_dot_expression] = STATE(2000),
    [sym_infix_expression] = STATE(2000),
    [sym_ce_expression] = STATE(2000),
    [sym_sequential_expression] = STATE(2000),
    [sym_char] = STATE(1801),
    [sym_format_string] = STATE(1804),
    [sym__string_literal] = STATE(1804),
    [sym_string] = STATE(1801),
    [sym_verbatim_string] = STATE(1801),
    [sym_bytearray] = STATE(1801),
    [sym_verbatim_bytearray] = STATE(1801),
    [sym_format_triple_quoted_string] = STATE(1807),
    [sym_triple_quoted_string] = STATE(1801),
    [sym_const] = STATE(2000),
    [sym_long_identifier] = STATE(1725),
    [sym_active_pattern] = STATE(1726),
    [sym__identifier_or_op] = STATE(1751),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(723),
    [sym_sbyte] = STATE(1801),
    [sym_byte] = STATE(1801),
    [sym_int16] = STATE(1801),
    [sym_uint16] = STATE(1801),
    [sym_int32] = STATE(1801),
    [sym_uint32] = STATE(1801),
    [sym_nativeint] = STATE(1801),
    [sym_unativeint] = STATE(1801),
    [sym_int64] = STATE(1801),
    [sym_uint64] = STATE(1801),
    [sym_ieee32] = STATE(1801),
    [sym_ieee64] = STATE(1801),
    [sym_bignum] = STATE(1801),
    [sym_decimal] = STATE(1801),
    [sym_float] = STATE(1427),
    [sym_block_comment] = STATE(510),
    [sym_compiler_directive_decl] = STATE(510),
    [sym_fsi_directive_decl] = STATE(510),
    [sym_preproc_line] = STATE(510),
    [sym_preproc_if_in_expression] = STATE(2000),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(629),
    [anon_sym_return] = ACTIONS(633),
    [anon_sym_do] = ACTIONS(635),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(637),
    [anon_sym_null] = ACTIONS(641),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(643),
    [anon_sym_LBRACK_PIPE] = ACTIONS(645),
    [anon_sym_LBRACE] = ACTIONS(1713),
    [anon_sym_LT_AT] = ACTIONS(647),
    [anon_sym_LT_AT_AT] = ACTIONS(1715),
    [anon_sym_LBRACE_PIPE] = ACTIONS(653),
    [anon_sym_new] = ACTIONS(633),
    [anon_sym_return_BANG] = ACTIONS(655),
    [anon_sym_yield] = ACTIONS(633),
    [anon_sym_yield_BANG] = ACTIONS(655),
    [anon_sym_lazy] = ACTIONS(633),
    [anon_sym_assert] = ACTIONS(633),
    [anon_sym_upcast] = ACTIONS(633),
    [anon_sym_downcast] = ACTIONS(633),
    [anon_sym_for] = ACTIONS(659),
    [anon_sym_while] = ACTIONS(661),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(663),
    [anon_sym_try] = ACTIONS(665),
    [anon_sym_match] = ACTIONS(667),
    [anon_sym_match_BANG] = ACTIONS(669),
    [anon_sym_function] = ACTIONS(671),
    [anon_sym_use] = ACTIONS(679),
    [anon_sym_use_BANG] = ACTIONS(681),
    [anon_sym_do_BANG] = ACTIONS(683),
    [anon_sym_begin] = ACTIONS(685),
    [aux_sym_char_token1] = ACTIONS(689),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(691),
    [anon_sym_DQUOTE] = ACTIONS(693),
    [anon_sym_AT_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(697),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(699),
    [sym_bool] = ACTIONS(701),
    [sym_unit] = ACTIONS(1717),
    [anon_sym_LPAREN_PIPE] = ACTIONS(705),
    [sym_op_identifier] = ACTIONS(1719),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(709),
    [sym_xint] = ACTIONS(711),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(713),
  },
  [511] = {
    [sym_function_or_value_defn] = STATE(527),
    [sym__expression] = STATE(270),
    [sym_literal_expression] = STATE(2384),
    [sym_long_identifier_or_op] = STATE(2384),
    [sym_tuple_expression] = STATE(2384),
    [sym_brace_expression] = STATE(2384),
    [sym_anon_record_expression] = STATE(2384),
    [sym_prefixed_expression] = STATE(2384),
    [sym_typecast_expression] = STATE(2384),
    [sym_for_expression] = STATE(2384),
    [sym_while_expression] = STATE(2384),
    [sym__if_branch] = STATE(6561),
    [sym_if_expression] = STATE(2384),
    [sym_fun_expression] = STATE(2384),
    [sym_try_expression] = STATE(2384),
    [sym_match_expression] = STATE(2384),
    [sym_function_expression] = STATE(2384),
    [sym_mutate_expression] = STATE(2384),
    [sym_index_expression] = STATE(2384),
    [sym_typed_expression] = STATE(2384),
    [sym_declaration_expression] = STATE(2384),
    [sym_do_expression] = STATE(2384),
    [sym_list_expression] = STATE(2384),
    [sym_array_expression] = STATE(2384),
    [sym_begin_end_expression] = STATE(2384),
    [sym_paren_expression] = STATE(2384),
    [sym__high_prec_app] = STATE(2249),
    [sym__low_prec_app] = STATE(2249),
    [sym_application_expression] = STATE(2384),
    [sym_dot_expression] = STATE(2384),
    [sym_infix_expression] = STATE(2384),
    [sym_ce_expression] = STATE(2384),
    [sym_sequential_expression] = STATE(2384),
    [sym_char] = STATE(2144),
    [sym_format_string] = STATE(2142),
    [sym__string_literal] = STATE(2142),
    [sym_string] = STATE(2144),
    [sym_verbatim_string] = STATE(2144),
    [sym_bytearray] = STATE(2144),
    [sym_verbatim_bytearray] = STATE(2144),
    [sym_format_triple_quoted_string] = STATE(2141),
    [sym_triple_quoted_string] = STATE(2144),
    [sym_const] = STATE(2384),
    [sym_long_identifier] = STATE(2400),
    [sym_active_pattern] = STATE(2317),
    [sym__identifier_or_op] = STATE(2392),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(633),
    [sym_sbyte] = STATE(2144),
    [sym_byte] = STATE(2144),
    [sym_int16] = STATE(2144),
    [sym_uint16] = STATE(2144),
    [sym_int32] = STATE(2144),
    [sym_uint32] = STATE(2144),
    [sym_nativeint] = STATE(2144),
    [sym_unativeint] = STATE(2144),
    [sym_int64] = STATE(2144),
    [sym_uint64] = STATE(2144),
    [sym_ieee32] = STATE(2144),
    [sym_ieee64] = STATE(2144),
    [sym_bignum] = STATE(2144),
    [sym_decimal] = STATE(2144),
    [sym_float] = STATE(1672),
    [sym_block_comment] = STATE(511),
    [sym_compiler_directive_decl] = STATE(511),
    [sym_fsi_directive_decl] = STATE(511),
    [sym_preproc_line] = STATE(511),
    [sym_preproc_if_in_expression] = STATE(2384),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(1439),
    [anon_sym_return] = ACTIONS(1443),
    [anon_sym_do] = ACTIONS(1445),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(1447),
    [anon_sym_null] = ACTIONS(1451),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1453),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1455),
    [anon_sym_LBRACE] = ACTIONS(2036),
    [anon_sym_LT_AT] = ACTIONS(1459),
    [anon_sym_LT_AT_AT] = ACTIONS(2038),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1465),
    [anon_sym_new] = ACTIONS(1443),
    [anon_sym_return_BANG] = ACTIONS(1467),
    [anon_sym_yield] = ACTIONS(1443),
    [anon_sym_yield_BANG] = ACTIONS(1467),
    [anon_sym_lazy] = ACTIONS(1443),
    [anon_sym_assert] = ACTIONS(1443),
    [anon_sym_upcast] = ACTIONS(1443),
    [anon_sym_downcast] = ACTIONS(1443),
    [anon_sym_for] = ACTIONS(1471),
    [anon_sym_while] = ACTIONS(1473),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(1475),
    [anon_sym_try] = ACTIONS(1477),
    [anon_sym_match] = ACTIONS(1479),
    [anon_sym_match_BANG] = ACTIONS(1481),
    [anon_sym_function] = ACTIONS(1483),
    [anon_sym_use] = ACTIONS(1491),
    [anon_sym_use_BANG] = ACTIONS(1493),
    [anon_sym_do_BANG] = ACTIONS(1495),
    [anon_sym_begin] = ACTIONS(1497),
    [aux_sym_char_token1] = ACTIONS(1501),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1503),
    [anon_sym_DQUOTE] = ACTIONS(1505),
    [anon_sym_AT_DQUOTE] = ACTIONS(1507),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1509),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1511),
    [sym_bool] = ACTIONS(1513),
    [sym_unit] = ACTIONS(2040),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1517),
    [sym_op_identifier] = ACTIONS(2042),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(1521),
    [sym_xint] = ACTIONS(1523),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1525),
  },
  [512] = {
    [sym_function_or_value_defn] = STATE(600),
    [sym__expression] = STATE(192),
    [sym_literal_expression] = STATE(867),
    [sym_long_identifier_or_op] = STATE(867),
    [sym_tuple_expression] = STATE(867),
    [sym_brace_expression] = STATE(867),
    [sym_anon_record_expression] = STATE(867),
    [sym_prefixed_expression] = STATE(867),
    [sym_typecast_expression] = STATE(867),
    [sym_for_expression] = STATE(867),
    [sym_while_expression] = STATE(867),
    [sym__if_branch] = STATE(6511),
    [sym_if_expression] = STATE(867),
    [sym_fun_expression] = STATE(867),
    [sym_try_expression] = STATE(867),
    [sym_match_expression] = STATE(867),
    [sym_function_expression] = STATE(867),
    [sym_mutate_expression] = STATE(867),
    [sym_index_expression] = STATE(867),
    [sym_typed_expression] = STATE(867),
    [sym_declaration_expression] = STATE(867),
    [sym_do_expression] = STATE(867),
    [sym_list_expression] = STATE(867),
    [sym_array_expression] = STATE(867),
    [sym_begin_end_expression] = STATE(867),
    [sym_paren_expression] = STATE(867),
    [sym__high_prec_app] = STATE(864),
    [sym__low_prec_app] = STATE(864),
    [sym_application_expression] = STATE(867),
    [sym_dot_expression] = STATE(867),
    [sym_infix_expression] = STATE(867),
    [sym_ce_expression] = STATE(867),
    [sym_sequential_expression] = STATE(867),
    [sym_char] = STATE(868),
    [sym_format_string] = STATE(869),
    [sym__string_literal] = STATE(869),
    [sym_string] = STATE(868),
    [sym_verbatim_string] = STATE(868),
    [sym_bytearray] = STATE(868),
    [sym_verbatim_bytearray] = STATE(868),
    [sym_format_triple_quoted_string] = STATE(870),
    [sym_triple_quoted_string] = STATE(868),
    [sym_const] = STATE(867),
    [sym_long_identifier] = STATE(872),
    [sym_active_pattern] = STATE(871),
    [sym__identifier_or_op] = STATE(873),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(656),
    [sym_sbyte] = STATE(868),
    [sym_byte] = STATE(868),
    [sym_int16] = STATE(868),
    [sym_uint16] = STATE(868),
    [sym_int32] = STATE(868),
    [sym_uint32] = STATE(868),
    [sym_nativeint] = STATE(868),
    [sym_unativeint] = STATE(868),
    [sym_int64] = STATE(868),
    [sym_uint64] = STATE(868),
    [sym_ieee32] = STATE(868),
    [sym_ieee64] = STATE(868),
    [sym_bignum] = STATE(868),
    [sym_decimal] = STATE(868),
    [sym_float] = STATE(1368),
    [sym_block_comment] = STATE(512),
    [sym_compiler_directive_decl] = STATE(512),
    [sym_fsi_directive_decl] = STATE(512),
    [sym_preproc_line] = STATE(512),
    [sym_preproc_if_in_expression] = STATE(867),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(29),
    [anon_sym_return] = ACTIONS(825),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_null] = ACTIONS(49),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACK_PIPE] = ACTIONS(57),
    [anon_sym_LBRACE] = ACTIONS(1663),
    [anon_sym_LT_AT] = ACTIONS(61),
    [anon_sym_LT_AT_AT] = ACTIONS(1665),
    [anon_sym_LBRACE_PIPE] = ACTIONS(67),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_return_BANG] = ACTIONS(829),
    [anon_sym_yield] = ACTIONS(825),
    [anon_sym_yield_BANG] = ACTIONS(829),
    [anon_sym_lazy] = ACTIONS(825),
    [anon_sym_assert] = ACTIONS(825),
    [anon_sym_upcast] = ACTIONS(825),
    [anon_sym_downcast] = ACTIONS(825),
    [anon_sym_for] = ACTIONS(73),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(79),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_match] = ACTIONS(83),
    [anon_sym_match_BANG] = ACTIONS(85),
    [anon_sym_function] = ACTIONS(87),
    [anon_sym_use] = ACTIONS(833),
    [anon_sym_use_BANG] = ACTIONS(835),
    [anon_sym_do_BANG] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(101),
    [aux_sym_char_token1] = ACTIONS(105),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(107),
    [anon_sym_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DQUOTE] = ACTIONS(111),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(115),
    [sym_bool] = ACTIONS(117),
    [sym_unit] = ACTIONS(1673),
    [anon_sym_LPAREN_PIPE] = ACTIONS(121),
    [sym_op_identifier] = ACTIONS(1675),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(837),
    [sym_xint] = ACTIONS(387),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(135),
  },
  [513] = {
    [sym_function_or_value_defn] = STATE(600),
    [sym__expression] = STATE(211),
    [sym_literal_expression] = STATE(867),
    [sym_long_identifier_or_op] = STATE(867),
    [sym_tuple_expression] = STATE(867),
    [sym_brace_expression] = STATE(867),
    [sym_anon_record_expression] = STATE(867),
    [sym_prefixed_expression] = STATE(867),
    [sym_typecast_expression] = STATE(867),
    [sym_for_expression] = STATE(867),
    [sym_while_expression] = STATE(867),
    [sym__if_branch] = STATE(6511),
    [sym_if_expression] = STATE(867),
    [sym_fun_expression] = STATE(867),
    [sym_try_expression] = STATE(867),
    [sym_match_expression] = STATE(867),
    [sym_function_expression] = STATE(867),
    [sym_mutate_expression] = STATE(867),
    [sym_index_expression] = STATE(867),
    [sym_typed_expression] = STATE(867),
    [sym_declaration_expression] = STATE(867),
    [sym_do_expression] = STATE(867),
    [sym_list_expression] = STATE(867),
    [sym_array_expression] = STATE(867),
    [sym_begin_end_expression] = STATE(867),
    [sym_paren_expression] = STATE(867),
    [sym__high_prec_app] = STATE(864),
    [sym__low_prec_app] = STATE(864),
    [sym_application_expression] = STATE(867),
    [sym_dot_expression] = STATE(867),
    [sym_infix_expression] = STATE(867),
    [sym_ce_expression] = STATE(867),
    [sym_sequential_expression] = STATE(867),
    [sym_char] = STATE(868),
    [sym_format_string] = STATE(869),
    [sym__string_literal] = STATE(869),
    [sym_string] = STATE(868),
    [sym_verbatim_string] = STATE(868),
    [sym_bytearray] = STATE(868),
    [sym_verbatim_bytearray] = STATE(868),
    [sym_format_triple_quoted_string] = STATE(870),
    [sym_triple_quoted_string] = STATE(868),
    [sym_const] = STATE(867),
    [sym_long_identifier] = STATE(872),
    [sym_active_pattern] = STATE(871),
    [sym__identifier_or_op] = STATE(873),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(656),
    [sym_sbyte] = STATE(868),
    [sym_byte] = STATE(868),
    [sym_int16] = STATE(868),
    [sym_uint16] = STATE(868),
    [sym_int32] = STATE(868),
    [sym_uint32] = STATE(868),
    [sym_nativeint] = STATE(868),
    [sym_unativeint] = STATE(868),
    [sym_int64] = STATE(868),
    [sym_uint64] = STATE(868),
    [sym_ieee32] = STATE(868),
    [sym_ieee64] = STATE(868),
    [sym_bignum] = STATE(868),
    [sym_decimal] = STATE(868),
    [sym_float] = STATE(1368),
    [sym_block_comment] = STATE(513),
    [sym_compiler_directive_decl] = STATE(513),
    [sym_fsi_directive_decl] = STATE(513),
    [sym_preproc_line] = STATE(513),
    [sym_preproc_if_in_expression] = STATE(867),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(29),
    [anon_sym_return] = ACTIONS(825),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_null] = ACTIONS(49),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACK_PIPE] = ACTIONS(57),
    [anon_sym_LBRACE] = ACTIONS(1663),
    [anon_sym_LT_AT] = ACTIONS(61),
    [anon_sym_LT_AT_AT] = ACTIONS(1665),
    [anon_sym_LBRACE_PIPE] = ACTIONS(67),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_return_BANG] = ACTIONS(829),
    [anon_sym_yield] = ACTIONS(825),
    [anon_sym_yield_BANG] = ACTIONS(829),
    [anon_sym_lazy] = ACTIONS(825),
    [anon_sym_assert] = ACTIONS(825),
    [anon_sym_upcast] = ACTIONS(825),
    [anon_sym_downcast] = ACTIONS(825),
    [anon_sym_for] = ACTIONS(73),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(79),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_match] = ACTIONS(83),
    [anon_sym_match_BANG] = ACTIONS(85),
    [anon_sym_function] = ACTIONS(87),
    [anon_sym_use] = ACTIONS(833),
    [anon_sym_use_BANG] = ACTIONS(835),
    [anon_sym_do_BANG] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(101),
    [aux_sym_char_token1] = ACTIONS(105),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(107),
    [anon_sym_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DQUOTE] = ACTIONS(111),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(115),
    [sym_bool] = ACTIONS(117),
    [sym_unit] = ACTIONS(1673),
    [anon_sym_LPAREN_PIPE] = ACTIONS(121),
    [sym_op_identifier] = ACTIONS(1675),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(837),
    [sym_xint] = ACTIONS(387),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(135),
  },
  [514] = {
    [sym_function_or_value_defn] = STATE(532),
    [sym__expression] = STATE(127),
    [sym_literal_expression] = STATE(2000),
    [sym_long_identifier_or_op] = STATE(2000),
    [sym_tuple_expression] = STATE(2000),
    [sym_brace_expression] = STATE(2000),
    [sym_anon_record_expression] = STATE(2000),
    [sym_prefixed_expression] = STATE(2000),
    [sym_typecast_expression] = STATE(2000),
    [sym_for_expression] = STATE(2000),
    [sym_while_expression] = STATE(2000),
    [sym__if_branch] = STATE(6707),
    [sym_if_expression] = STATE(2000),
    [sym_fun_expression] = STATE(2000),
    [sym_try_expression] = STATE(2000),
    [sym_match_expression] = STATE(2000),
    [sym_function_expression] = STATE(2000),
    [sym_mutate_expression] = STATE(2000),
    [sym_index_expression] = STATE(2000),
    [sym_typed_expression] = STATE(2000),
    [sym_declaration_expression] = STATE(2000),
    [sym_do_expression] = STATE(2000),
    [sym_list_expression] = STATE(2000),
    [sym_array_expression] = STATE(2000),
    [sym_begin_end_expression] = STATE(2000),
    [sym_paren_expression] = STATE(2000),
    [sym__high_prec_app] = STATE(2003),
    [sym__low_prec_app] = STATE(2003),
    [sym_application_expression] = STATE(2000),
    [sym_dot_expression] = STATE(2000),
    [sym_infix_expression] = STATE(2000),
    [sym_ce_expression] = STATE(2000),
    [sym_sequential_expression] = STATE(2000),
    [sym_char] = STATE(1801),
    [sym_format_string] = STATE(1804),
    [sym__string_literal] = STATE(1804),
    [sym_string] = STATE(1801),
    [sym_verbatim_string] = STATE(1801),
    [sym_bytearray] = STATE(1801),
    [sym_verbatim_bytearray] = STATE(1801),
    [sym_format_triple_quoted_string] = STATE(1807),
    [sym_triple_quoted_string] = STATE(1801),
    [sym_const] = STATE(2000),
    [sym_long_identifier] = STATE(1725),
    [sym_active_pattern] = STATE(1726),
    [sym__identifier_or_op] = STATE(1751),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(723),
    [sym_sbyte] = STATE(1801),
    [sym_byte] = STATE(1801),
    [sym_int16] = STATE(1801),
    [sym_uint16] = STATE(1801),
    [sym_int32] = STATE(1801),
    [sym_uint32] = STATE(1801),
    [sym_nativeint] = STATE(1801),
    [sym_unativeint] = STATE(1801),
    [sym_int64] = STATE(1801),
    [sym_uint64] = STATE(1801),
    [sym_ieee32] = STATE(1801),
    [sym_ieee64] = STATE(1801),
    [sym_bignum] = STATE(1801),
    [sym_decimal] = STATE(1801),
    [sym_float] = STATE(1427),
    [sym_block_comment] = STATE(514),
    [sym_compiler_directive_decl] = STATE(514),
    [sym_fsi_directive_decl] = STATE(514),
    [sym_preproc_line] = STATE(514),
    [sym_preproc_if_in_expression] = STATE(2000),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(629),
    [anon_sym_return] = ACTIONS(633),
    [anon_sym_do] = ACTIONS(635),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(637),
    [anon_sym_null] = ACTIONS(641),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(643),
    [anon_sym_LBRACK_PIPE] = ACTIONS(645),
    [anon_sym_LBRACE] = ACTIONS(1713),
    [anon_sym_LT_AT] = ACTIONS(647),
    [anon_sym_LT_AT_AT] = ACTIONS(1715),
    [anon_sym_LBRACE_PIPE] = ACTIONS(653),
    [anon_sym_new] = ACTIONS(633),
    [anon_sym_return_BANG] = ACTIONS(655),
    [anon_sym_yield] = ACTIONS(633),
    [anon_sym_yield_BANG] = ACTIONS(655),
    [anon_sym_lazy] = ACTIONS(633),
    [anon_sym_assert] = ACTIONS(633),
    [anon_sym_upcast] = ACTIONS(633),
    [anon_sym_downcast] = ACTIONS(633),
    [anon_sym_for] = ACTIONS(659),
    [anon_sym_while] = ACTIONS(661),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(663),
    [anon_sym_try] = ACTIONS(665),
    [anon_sym_match] = ACTIONS(667),
    [anon_sym_match_BANG] = ACTIONS(669),
    [anon_sym_function] = ACTIONS(671),
    [anon_sym_use] = ACTIONS(679),
    [anon_sym_use_BANG] = ACTIONS(681),
    [anon_sym_do_BANG] = ACTIONS(683),
    [anon_sym_begin] = ACTIONS(685),
    [aux_sym_char_token1] = ACTIONS(689),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(691),
    [anon_sym_DQUOTE] = ACTIONS(693),
    [anon_sym_AT_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(697),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(699),
    [sym_bool] = ACTIONS(701),
    [sym_unit] = ACTIONS(1717),
    [anon_sym_LPAREN_PIPE] = ACTIONS(705),
    [sym_op_identifier] = ACTIONS(1719),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(709),
    [sym_xint] = ACTIONS(711),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(713),
  },
  [515] = {
    [sym_function_or_value_defn] = STATE(703),
    [sym__expression] = STATE(118),
    [sym_literal_expression] = STATE(1797),
    [sym_long_identifier_or_op] = STATE(1797),
    [sym_tuple_expression] = STATE(1797),
    [sym_brace_expression] = STATE(1797),
    [sym_anon_record_expression] = STATE(1797),
    [sym_prefixed_expression] = STATE(1797),
    [sym_typecast_expression] = STATE(1797),
    [sym_for_expression] = STATE(1797),
    [sym_while_expression] = STATE(1797),
    [sym__if_branch] = STATE(6611),
    [sym_if_expression] = STATE(1797),
    [sym_fun_expression] = STATE(1797),
    [sym_try_expression] = STATE(1797),
    [sym_match_expression] = STATE(1797),
    [sym_function_expression] = STATE(1797),
    [sym_mutate_expression] = STATE(1797),
    [sym_index_expression] = STATE(1797),
    [sym_typed_expression] = STATE(1797),
    [sym_declaration_expression] = STATE(1797),
    [sym_do_expression] = STATE(1797),
    [sym_list_expression] = STATE(1797),
    [sym_array_expression] = STATE(1797),
    [sym_begin_end_expression] = STATE(1797),
    [sym_paren_expression] = STATE(1797),
    [sym__high_prec_app] = STATE(1800),
    [sym__low_prec_app] = STATE(1800),
    [sym_application_expression] = STATE(1797),
    [sym_dot_expression] = STATE(1797),
    [sym_infix_expression] = STATE(1797),
    [sym_ce_expression] = STATE(1797),
    [sym_sequential_expression] = STATE(1797),
    [sym_char] = STATE(1694),
    [sym_format_string] = STATE(1693),
    [sym__string_literal] = STATE(1693),
    [sym_string] = STATE(1694),
    [sym_verbatim_string] = STATE(1694),
    [sym_bytearray] = STATE(1694),
    [sym_verbatim_bytearray] = STATE(1694),
    [sym_format_triple_quoted_string] = STATE(1692),
    [sym_triple_quoted_string] = STATE(1694),
    [sym_const] = STATE(1797),
    [sym_long_identifier] = STATE(1813),
    [sym_active_pattern] = STATE(1753),
    [sym__identifier_or_op] = STATE(1812),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(756),
    [sym_sbyte] = STATE(1694),
    [sym_byte] = STATE(1694),
    [sym_int16] = STATE(1694),
    [sym_uint16] = STATE(1694),
    [sym_int32] = STATE(1694),
    [sym_uint32] = STATE(1694),
    [sym_nativeint] = STATE(1694),
    [sym_unativeint] = STATE(1694),
    [sym_int64] = STATE(1694),
    [sym_uint64] = STATE(1694),
    [sym_ieee32] = STATE(1694),
    [sym_ieee64] = STATE(1694),
    [sym_bignum] = STATE(1694),
    [sym_decimal] = STATE(1694),
    [sym_float] = STATE(1425),
    [sym_block_comment] = STATE(515),
    [sym_compiler_directive_decl] = STATE(515),
    [sym_fsi_directive_decl] = STATE(515),
    [sym_preproc_line] = STATE(515),
    [sym_preproc_if_in_expression] = STATE(1797),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(393),
    [anon_sym_return] = ACTIONS(397),
    [anon_sym_do] = ACTIONS(399),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(401),
    [anon_sym_null] = ACTIONS(405),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(407),
    [anon_sym_LBRACK_PIPE] = ACTIONS(409),
    [anon_sym_LBRACE] = ACTIONS(2146),
    [anon_sym_LT_AT] = ACTIONS(413),
    [anon_sym_LT_AT_AT] = ACTIONS(2148),
    [anon_sym_LBRACE_PIPE] = ACTIONS(419),
    [anon_sym_new] = ACTIONS(397),
    [anon_sym_return_BANG] = ACTIONS(421),
    [anon_sym_yield] = ACTIONS(397),
    [anon_sym_yield_BANG] = ACTIONS(421),
    [anon_sym_lazy] = ACTIONS(397),
    [anon_sym_assert] = ACTIONS(397),
    [anon_sym_upcast] = ACTIONS(397),
    [anon_sym_downcast] = ACTIONS(397),
    [anon_sym_for] = ACTIONS(425),
    [anon_sym_while] = ACTIONS(427),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(429),
    [anon_sym_try] = ACTIONS(431),
    [anon_sym_match] = ACTIONS(433),
    [anon_sym_match_BANG] = ACTIONS(435),
    [anon_sym_function] = ACTIONS(437),
    [anon_sym_use] = ACTIONS(445),
    [anon_sym_use_BANG] = ACTIONS(447),
    [anon_sym_do_BANG] = ACTIONS(449),
    [anon_sym_begin] = ACTIONS(451),
    [aux_sym_char_token1] = ACTIONS(455),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(457),
    [anon_sym_DQUOTE] = ACTIONS(459),
    [anon_sym_AT_DQUOTE] = ACTIONS(461),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(463),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(465),
    [sym_bool] = ACTIONS(467),
    [sym_unit] = ACTIONS(2150),
    [anon_sym_LPAREN_PIPE] = ACTIONS(471),
    [sym_op_identifier] = ACTIONS(2152),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(475),
    [sym_xint] = ACTIONS(477),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(479),
  },
  [516] = {
    [sym_function_or_value_defn] = STATE(627),
    [sym__expression] = STATE(349),
    [sym_literal_expression] = STATE(1118),
    [sym_long_identifier_or_op] = STATE(1118),
    [sym_tuple_expression] = STATE(1118),
    [sym_brace_expression] = STATE(1118),
    [sym_anon_record_expression] = STATE(1118),
    [sym_prefixed_expression] = STATE(1118),
    [sym_typecast_expression] = STATE(1118),
    [sym_for_expression] = STATE(1118),
    [sym_while_expression] = STATE(1118),
    [sym__if_branch] = STATE(7163),
    [sym_if_expression] = STATE(1118),
    [sym_fun_expression] = STATE(1118),
    [sym_try_expression] = STATE(1118),
    [sym_match_expression] = STATE(1118),
    [sym_function_expression] = STATE(1118),
    [sym_mutate_expression] = STATE(1118),
    [sym_index_expression] = STATE(1118),
    [sym_typed_expression] = STATE(1118),
    [sym_declaration_expression] = STATE(1118),
    [sym_do_expression] = STATE(1118),
    [sym_list_expression] = STATE(1118),
    [sym_array_expression] = STATE(1118),
    [sym_begin_end_expression] = STATE(1118),
    [sym_paren_expression] = STATE(1118),
    [sym__high_prec_app] = STATE(1133),
    [sym__low_prec_app] = STATE(1133),
    [sym_application_expression] = STATE(1118),
    [sym_dot_expression] = STATE(1118),
    [sym_infix_expression] = STATE(1118),
    [sym_ce_expression] = STATE(1118),
    [sym_sequential_expression] = STATE(1118),
    [sym_char] = STATE(1080),
    [sym_format_string] = STATE(1090),
    [sym__string_literal] = STATE(1090),
    [sym_string] = STATE(1080),
    [sym_verbatim_string] = STATE(1080),
    [sym_bytearray] = STATE(1080),
    [sym_verbatim_bytearray] = STATE(1080),
    [sym_format_triple_quoted_string] = STATE(1096),
    [sym_triple_quoted_string] = STATE(1080),
    [sym_const] = STATE(1118),
    [sym_long_identifier] = STATE(1156),
    [sym_active_pattern] = STATE(1085),
    [sym__identifier_or_op] = STATE(1099),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(517),
    [sym_sbyte] = STATE(1080),
    [sym_byte] = STATE(1080),
    [sym_int16] = STATE(1080),
    [sym_uint16] = STATE(1080),
    [sym_int32] = STATE(1080),
    [sym_uint32] = STATE(1080),
    [sym_nativeint] = STATE(1080),
    [sym_unativeint] = STATE(1080),
    [sym_int64] = STATE(1080),
    [sym_uint64] = STATE(1080),
    [sym_ieee32] = STATE(1080),
    [sym_ieee64] = STATE(1080),
    [sym_bignum] = STATE(1080),
    [sym_decimal] = STATE(1080),
    [sym_float] = STATE(979),
    [sym_block_comment] = STATE(516),
    [sym_compiler_directive_decl] = STATE(516),
    [sym_fsi_directive_decl] = STATE(516),
    [sym_preproc_line] = STATE(516),
    [sym_preproc_if_in_expression] = STATE(1118),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(195),
    [anon_sym_return] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_null] = ACTIONS(207),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(209),
    [anon_sym_LBRACK_PIPE] = ACTIONS(211),
    [anon_sym_LBRACE] = ACTIONS(1687),
    [anon_sym_LT_AT] = ACTIONS(213),
    [anon_sym_LT_AT_AT] = ACTIONS(1689),
    [anon_sym_LBRACE_PIPE] = ACTIONS(217),
    [anon_sym_new] = ACTIONS(199),
    [anon_sym_return_BANG] = ACTIONS(219),
    [anon_sym_yield] = ACTIONS(199),
    [anon_sym_yield_BANG] = ACTIONS(219),
    [anon_sym_lazy] = ACTIONS(199),
    [anon_sym_assert] = ACTIONS(199),
    [anon_sym_upcast] = ACTIONS(199),
    [anon_sym_downcast] = ACTIONS(199),
    [anon_sym_for] = ACTIONS(223),
    [anon_sym_while] = ACTIONS(225),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(229),
    [anon_sym_match] = ACTIONS(231),
    [anon_sym_match_BANG] = ACTIONS(233),
    [anon_sym_function] = ACTIONS(235),
    [anon_sym_use] = ACTIONS(239),
    [anon_sym_use_BANG] = ACTIONS(241),
    [anon_sym_do_BANG] = ACTIONS(243),
    [anon_sym_begin] = ACTIONS(245),
    [aux_sym_char_token1] = ACTIONS(247),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(251),
    [anon_sym_AT_DQUOTE] = ACTIONS(253),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(255),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(257),
    [sym_bool] = ACTIONS(259),
    [sym_unit] = ACTIONS(1699),
    [anon_sym_LPAREN_PIPE] = ACTIONS(261),
    [sym_op_identifier] = ACTIONS(1701),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(265),
    [sym_xint] = ACTIONS(267),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(269),
  },
  [517] = {
    [sym_function_or_value_defn] = STATE(627),
    [sym__expression] = STATE(18),
    [sym_literal_expression] = STATE(1118),
    [sym_long_identifier_or_op] = STATE(1118),
    [sym_tuple_expression] = STATE(1118),
    [sym_brace_expression] = STATE(1118),
    [sym_anon_record_expression] = STATE(1118),
    [sym_prefixed_expression] = STATE(1118),
    [sym_typecast_expression] = STATE(1118),
    [sym_for_expression] = STATE(1118),
    [sym_while_expression] = STATE(1118),
    [sym__if_branch] = STATE(7163),
    [sym_if_expression] = STATE(1118),
    [sym_fun_expression] = STATE(1118),
    [sym_try_expression] = STATE(1118),
    [sym_match_expression] = STATE(1118),
    [sym_function_expression] = STATE(1118),
    [sym_mutate_expression] = STATE(1118),
    [sym_index_expression] = STATE(1118),
    [sym_typed_expression] = STATE(1118),
    [sym_declaration_expression] = STATE(1118),
    [sym_do_expression] = STATE(1118),
    [sym_list_expression] = STATE(1118),
    [sym_array_expression] = STATE(1118),
    [sym_begin_end_expression] = STATE(1118),
    [sym_paren_expression] = STATE(1118),
    [sym__high_prec_app] = STATE(1133),
    [sym__low_prec_app] = STATE(1133),
    [sym_application_expression] = STATE(1118),
    [sym_dot_expression] = STATE(1118),
    [sym_infix_expression] = STATE(1118),
    [sym_ce_expression] = STATE(1118),
    [sym_sequential_expression] = STATE(1118),
    [sym_char] = STATE(1080),
    [sym_format_string] = STATE(1090),
    [sym__string_literal] = STATE(1090),
    [sym_string] = STATE(1080),
    [sym_verbatim_string] = STATE(1080),
    [sym_bytearray] = STATE(1080),
    [sym_verbatim_bytearray] = STATE(1080),
    [sym_format_triple_quoted_string] = STATE(1096),
    [sym_triple_quoted_string] = STATE(1080),
    [sym_const] = STATE(1118),
    [sym_long_identifier] = STATE(1156),
    [sym_active_pattern] = STATE(1085),
    [sym__identifier_or_op] = STATE(1099),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(517),
    [sym_sbyte] = STATE(1080),
    [sym_byte] = STATE(1080),
    [sym_int16] = STATE(1080),
    [sym_uint16] = STATE(1080),
    [sym_int32] = STATE(1080),
    [sym_uint32] = STATE(1080),
    [sym_nativeint] = STATE(1080),
    [sym_unativeint] = STATE(1080),
    [sym_int64] = STATE(1080),
    [sym_uint64] = STATE(1080),
    [sym_ieee32] = STATE(1080),
    [sym_ieee64] = STATE(1080),
    [sym_bignum] = STATE(1080),
    [sym_decimal] = STATE(1080),
    [sym_float] = STATE(979),
    [sym_block_comment] = STATE(517),
    [sym_compiler_directive_decl] = STATE(517),
    [sym_fsi_directive_decl] = STATE(517),
    [sym_preproc_line] = STATE(517),
    [sym_preproc_if_in_expression] = STATE(1118),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(195),
    [anon_sym_return] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_null] = ACTIONS(207),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(209),
    [anon_sym_LBRACK_PIPE] = ACTIONS(211),
    [anon_sym_LBRACE] = ACTIONS(1687),
    [anon_sym_LT_AT] = ACTIONS(213),
    [anon_sym_LT_AT_AT] = ACTIONS(1689),
    [anon_sym_LBRACE_PIPE] = ACTIONS(217),
    [anon_sym_new] = ACTIONS(199),
    [anon_sym_return_BANG] = ACTIONS(219),
    [anon_sym_yield] = ACTIONS(199),
    [anon_sym_yield_BANG] = ACTIONS(219),
    [anon_sym_lazy] = ACTIONS(199),
    [anon_sym_assert] = ACTIONS(199),
    [anon_sym_upcast] = ACTIONS(199),
    [anon_sym_downcast] = ACTIONS(199),
    [anon_sym_for] = ACTIONS(223),
    [anon_sym_while] = ACTIONS(225),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(229),
    [anon_sym_match] = ACTIONS(231),
    [anon_sym_match_BANG] = ACTIONS(233),
    [anon_sym_function] = ACTIONS(235),
    [anon_sym_use] = ACTIONS(239),
    [anon_sym_use_BANG] = ACTIONS(241),
    [anon_sym_do_BANG] = ACTIONS(243),
    [anon_sym_begin] = ACTIONS(245),
    [aux_sym_char_token1] = ACTIONS(247),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(251),
    [anon_sym_AT_DQUOTE] = ACTIONS(253),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(255),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(257),
    [sym_bool] = ACTIONS(259),
    [sym_unit] = ACTIONS(1699),
    [anon_sym_LPAREN_PIPE] = ACTIONS(261),
    [sym_op_identifier] = ACTIONS(1701),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(265),
    [sym_xint] = ACTIONS(267),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(269),
  },
  [518] = {
    [sym_function_or_value_defn] = STATE(627),
    [sym__expression] = STATE(21),
    [sym_literal_expression] = STATE(1118),
    [sym_long_identifier_or_op] = STATE(1118),
    [sym_tuple_expression] = STATE(1118),
    [sym_brace_expression] = STATE(1118),
    [sym_anon_record_expression] = STATE(1118),
    [sym_prefixed_expression] = STATE(1118),
    [sym_typecast_expression] = STATE(1118),
    [sym_for_expression] = STATE(1118),
    [sym_while_expression] = STATE(1118),
    [sym__if_branch] = STATE(7163),
    [sym_if_expression] = STATE(1118),
    [sym_fun_expression] = STATE(1118),
    [sym_try_expression] = STATE(1118),
    [sym_match_expression] = STATE(1118),
    [sym_function_expression] = STATE(1118),
    [sym_mutate_expression] = STATE(1118),
    [sym_index_expression] = STATE(1118),
    [sym_typed_expression] = STATE(1118),
    [sym_declaration_expression] = STATE(1118),
    [sym_do_expression] = STATE(1118),
    [sym_list_expression] = STATE(1118),
    [sym_array_expression] = STATE(1118),
    [sym_begin_end_expression] = STATE(1118),
    [sym_paren_expression] = STATE(1118),
    [sym__high_prec_app] = STATE(1133),
    [sym__low_prec_app] = STATE(1133),
    [sym_application_expression] = STATE(1118),
    [sym_dot_expression] = STATE(1118),
    [sym_infix_expression] = STATE(1118),
    [sym_ce_expression] = STATE(1118),
    [sym_sequential_expression] = STATE(1118),
    [sym_char] = STATE(1080),
    [sym_format_string] = STATE(1090),
    [sym__string_literal] = STATE(1090),
    [sym_string] = STATE(1080),
    [sym_verbatim_string] = STATE(1080),
    [sym_bytearray] = STATE(1080),
    [sym_verbatim_bytearray] = STATE(1080),
    [sym_format_triple_quoted_string] = STATE(1096),
    [sym_triple_quoted_string] = STATE(1080),
    [sym_const] = STATE(1118),
    [sym_long_identifier] = STATE(1156),
    [sym_active_pattern] = STATE(1085),
    [sym__identifier_or_op] = STATE(1099),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(517),
    [sym_sbyte] = STATE(1080),
    [sym_byte] = STATE(1080),
    [sym_int16] = STATE(1080),
    [sym_uint16] = STATE(1080),
    [sym_int32] = STATE(1080),
    [sym_uint32] = STATE(1080),
    [sym_nativeint] = STATE(1080),
    [sym_unativeint] = STATE(1080),
    [sym_int64] = STATE(1080),
    [sym_uint64] = STATE(1080),
    [sym_ieee32] = STATE(1080),
    [sym_ieee64] = STATE(1080),
    [sym_bignum] = STATE(1080),
    [sym_decimal] = STATE(1080),
    [sym_float] = STATE(979),
    [sym_block_comment] = STATE(518),
    [sym_compiler_directive_decl] = STATE(518),
    [sym_fsi_directive_decl] = STATE(518),
    [sym_preproc_line] = STATE(518),
    [sym_preproc_if_in_expression] = STATE(1118),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(195),
    [anon_sym_return] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_null] = ACTIONS(207),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(209),
    [anon_sym_LBRACK_PIPE] = ACTIONS(211),
    [anon_sym_LBRACE] = ACTIONS(1687),
    [anon_sym_LT_AT] = ACTIONS(213),
    [anon_sym_LT_AT_AT] = ACTIONS(1689),
    [anon_sym_LBRACE_PIPE] = ACTIONS(217),
    [anon_sym_new] = ACTIONS(199),
    [anon_sym_return_BANG] = ACTIONS(219),
    [anon_sym_yield] = ACTIONS(199),
    [anon_sym_yield_BANG] = ACTIONS(219),
    [anon_sym_lazy] = ACTIONS(199),
    [anon_sym_assert] = ACTIONS(199),
    [anon_sym_upcast] = ACTIONS(199),
    [anon_sym_downcast] = ACTIONS(199),
    [anon_sym_for] = ACTIONS(223),
    [anon_sym_while] = ACTIONS(225),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(229),
    [anon_sym_match] = ACTIONS(231),
    [anon_sym_match_BANG] = ACTIONS(233),
    [anon_sym_function] = ACTIONS(235),
    [anon_sym_use] = ACTIONS(239),
    [anon_sym_use_BANG] = ACTIONS(241),
    [anon_sym_do_BANG] = ACTIONS(243),
    [anon_sym_begin] = ACTIONS(245),
    [aux_sym_char_token1] = ACTIONS(247),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(251),
    [anon_sym_AT_DQUOTE] = ACTIONS(253),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(255),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(257),
    [sym_bool] = ACTIONS(259),
    [sym_unit] = ACTIONS(1699),
    [anon_sym_LPAREN_PIPE] = ACTIONS(261),
    [sym_op_identifier] = ACTIONS(1701),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(265),
    [sym_xint] = ACTIONS(267),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(269),
  },
  [519] = {
    [sym_function_or_value_defn] = STATE(527),
    [sym__expression] = STATE(269),
    [sym_literal_expression] = STATE(2384),
    [sym_long_identifier_or_op] = STATE(2384),
    [sym_tuple_expression] = STATE(2384),
    [sym_brace_expression] = STATE(2384),
    [sym_anon_record_expression] = STATE(2384),
    [sym_prefixed_expression] = STATE(2384),
    [sym_typecast_expression] = STATE(2384),
    [sym_for_expression] = STATE(2384),
    [sym_while_expression] = STATE(2384),
    [sym__if_branch] = STATE(6561),
    [sym_if_expression] = STATE(2384),
    [sym_fun_expression] = STATE(2384),
    [sym_try_expression] = STATE(2384),
    [sym_match_expression] = STATE(2384),
    [sym_function_expression] = STATE(2384),
    [sym_mutate_expression] = STATE(2384),
    [sym_index_expression] = STATE(2384),
    [sym_typed_expression] = STATE(2384),
    [sym_declaration_expression] = STATE(2384),
    [sym_do_expression] = STATE(2384),
    [sym_list_expression] = STATE(2384),
    [sym_array_expression] = STATE(2384),
    [sym_begin_end_expression] = STATE(2384),
    [sym_paren_expression] = STATE(2384),
    [sym__high_prec_app] = STATE(2249),
    [sym__low_prec_app] = STATE(2249),
    [sym_application_expression] = STATE(2384),
    [sym_dot_expression] = STATE(2384),
    [sym_infix_expression] = STATE(2384),
    [sym_ce_expression] = STATE(2384),
    [sym_sequential_expression] = STATE(2384),
    [sym_char] = STATE(2144),
    [sym_format_string] = STATE(2142),
    [sym__string_literal] = STATE(2142),
    [sym_string] = STATE(2144),
    [sym_verbatim_string] = STATE(2144),
    [sym_bytearray] = STATE(2144),
    [sym_verbatim_bytearray] = STATE(2144),
    [sym_format_triple_quoted_string] = STATE(2141),
    [sym_triple_quoted_string] = STATE(2144),
    [sym_const] = STATE(2384),
    [sym_long_identifier] = STATE(2400),
    [sym_active_pattern] = STATE(2317),
    [sym__identifier_or_op] = STATE(2392),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(633),
    [sym_sbyte] = STATE(2144),
    [sym_byte] = STATE(2144),
    [sym_int16] = STATE(2144),
    [sym_uint16] = STATE(2144),
    [sym_int32] = STATE(2144),
    [sym_uint32] = STATE(2144),
    [sym_nativeint] = STATE(2144),
    [sym_unativeint] = STATE(2144),
    [sym_int64] = STATE(2144),
    [sym_uint64] = STATE(2144),
    [sym_ieee32] = STATE(2144),
    [sym_ieee64] = STATE(2144),
    [sym_bignum] = STATE(2144),
    [sym_decimal] = STATE(2144),
    [sym_float] = STATE(1672),
    [sym_block_comment] = STATE(519),
    [sym_compiler_directive_decl] = STATE(519),
    [sym_fsi_directive_decl] = STATE(519),
    [sym_preproc_line] = STATE(519),
    [sym_preproc_if_in_expression] = STATE(2384),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(1439),
    [anon_sym_return] = ACTIONS(1443),
    [anon_sym_do] = ACTIONS(1445),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(1447),
    [anon_sym_null] = ACTIONS(1451),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1453),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1455),
    [anon_sym_LBRACE] = ACTIONS(2036),
    [anon_sym_LT_AT] = ACTIONS(1459),
    [anon_sym_LT_AT_AT] = ACTIONS(2038),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1465),
    [anon_sym_new] = ACTIONS(1443),
    [anon_sym_return_BANG] = ACTIONS(1467),
    [anon_sym_yield] = ACTIONS(1443),
    [anon_sym_yield_BANG] = ACTIONS(1467),
    [anon_sym_lazy] = ACTIONS(1443),
    [anon_sym_assert] = ACTIONS(1443),
    [anon_sym_upcast] = ACTIONS(1443),
    [anon_sym_downcast] = ACTIONS(1443),
    [anon_sym_for] = ACTIONS(1471),
    [anon_sym_while] = ACTIONS(1473),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(1475),
    [anon_sym_try] = ACTIONS(1477),
    [anon_sym_match] = ACTIONS(1479),
    [anon_sym_match_BANG] = ACTIONS(1481),
    [anon_sym_function] = ACTIONS(1483),
    [anon_sym_use] = ACTIONS(1491),
    [anon_sym_use_BANG] = ACTIONS(1493),
    [anon_sym_do_BANG] = ACTIONS(1495),
    [anon_sym_begin] = ACTIONS(1497),
    [aux_sym_char_token1] = ACTIONS(1501),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1503),
    [anon_sym_DQUOTE] = ACTIONS(1505),
    [anon_sym_AT_DQUOTE] = ACTIONS(1507),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1509),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1511),
    [sym_bool] = ACTIONS(1513),
    [sym_unit] = ACTIONS(2040),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1517),
    [sym_op_identifier] = ACTIONS(2042),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(1521),
    [sym_xint] = ACTIONS(1523),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1525),
  },
  [520] = {
    [sym_function_or_value_defn] = STATE(627),
    [sym__expression] = STATE(50),
    [sym_literal_expression] = STATE(1118),
    [sym_long_identifier_or_op] = STATE(1118),
    [sym_tuple_expression] = STATE(1118),
    [sym_brace_expression] = STATE(1118),
    [sym_anon_record_expression] = STATE(1118),
    [sym_prefixed_expression] = STATE(1118),
    [sym_typecast_expression] = STATE(1118),
    [sym_for_expression] = STATE(1118),
    [sym_while_expression] = STATE(1118),
    [sym__if_branch] = STATE(7163),
    [sym_if_expression] = STATE(1118),
    [sym_fun_expression] = STATE(1118),
    [sym_try_expression] = STATE(1118),
    [sym_match_expression] = STATE(1118),
    [sym_function_expression] = STATE(1118),
    [sym_mutate_expression] = STATE(1118),
    [sym_index_expression] = STATE(1118),
    [sym_typed_expression] = STATE(1118),
    [sym_declaration_expression] = STATE(1118),
    [sym_do_expression] = STATE(1118),
    [sym_list_expression] = STATE(1118),
    [sym_array_expression] = STATE(1118),
    [sym_begin_end_expression] = STATE(1118),
    [sym_paren_expression] = STATE(1118),
    [sym__high_prec_app] = STATE(1133),
    [sym__low_prec_app] = STATE(1133),
    [sym_application_expression] = STATE(1118),
    [sym_dot_expression] = STATE(1118),
    [sym_infix_expression] = STATE(1118),
    [sym_ce_expression] = STATE(1118),
    [sym_sequential_expression] = STATE(1118),
    [sym_char] = STATE(1080),
    [sym_format_string] = STATE(1090),
    [sym__string_literal] = STATE(1090),
    [sym_string] = STATE(1080),
    [sym_verbatim_string] = STATE(1080),
    [sym_bytearray] = STATE(1080),
    [sym_verbatim_bytearray] = STATE(1080),
    [sym_format_triple_quoted_string] = STATE(1096),
    [sym_triple_quoted_string] = STATE(1080),
    [sym_const] = STATE(1118),
    [sym_long_identifier] = STATE(1156),
    [sym_active_pattern] = STATE(1085),
    [sym__identifier_or_op] = STATE(1099),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(517),
    [sym_sbyte] = STATE(1080),
    [sym_byte] = STATE(1080),
    [sym_int16] = STATE(1080),
    [sym_uint16] = STATE(1080),
    [sym_int32] = STATE(1080),
    [sym_uint32] = STATE(1080),
    [sym_nativeint] = STATE(1080),
    [sym_unativeint] = STATE(1080),
    [sym_int64] = STATE(1080),
    [sym_uint64] = STATE(1080),
    [sym_ieee32] = STATE(1080),
    [sym_ieee64] = STATE(1080),
    [sym_bignum] = STATE(1080),
    [sym_decimal] = STATE(1080),
    [sym_float] = STATE(979),
    [sym_block_comment] = STATE(520),
    [sym_compiler_directive_decl] = STATE(520),
    [sym_fsi_directive_decl] = STATE(520),
    [sym_preproc_line] = STATE(520),
    [sym_preproc_if_in_expression] = STATE(1118),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(195),
    [anon_sym_return] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_null] = ACTIONS(207),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(209),
    [anon_sym_LBRACK_PIPE] = ACTIONS(211),
    [anon_sym_LBRACE] = ACTIONS(1687),
    [anon_sym_LT_AT] = ACTIONS(213),
    [anon_sym_LT_AT_AT] = ACTIONS(1689),
    [anon_sym_LBRACE_PIPE] = ACTIONS(217),
    [anon_sym_new] = ACTIONS(199),
    [anon_sym_return_BANG] = ACTIONS(219),
    [anon_sym_yield] = ACTIONS(199),
    [anon_sym_yield_BANG] = ACTIONS(219),
    [anon_sym_lazy] = ACTIONS(199),
    [anon_sym_assert] = ACTIONS(199),
    [anon_sym_upcast] = ACTIONS(199),
    [anon_sym_downcast] = ACTIONS(199),
    [anon_sym_for] = ACTIONS(223),
    [anon_sym_while] = ACTIONS(225),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(229),
    [anon_sym_match] = ACTIONS(231),
    [anon_sym_match_BANG] = ACTIONS(233),
    [anon_sym_function] = ACTIONS(235),
    [anon_sym_use] = ACTIONS(239),
    [anon_sym_use_BANG] = ACTIONS(241),
    [anon_sym_do_BANG] = ACTIONS(243),
    [anon_sym_begin] = ACTIONS(245),
    [aux_sym_char_token1] = ACTIONS(247),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(251),
    [anon_sym_AT_DQUOTE] = ACTIONS(253),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(255),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(257),
    [sym_bool] = ACTIONS(259),
    [sym_unit] = ACTIONS(1699),
    [anon_sym_LPAREN_PIPE] = ACTIONS(261),
    [sym_op_identifier] = ACTIONS(1701),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(265),
    [sym_xint] = ACTIONS(267),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(269),
  },
  [521] = {
    [sym_function_or_value_defn] = STATE(527),
    [sym__expression] = STATE(265),
    [sym_literal_expression] = STATE(2384),
    [sym_long_identifier_or_op] = STATE(2384),
    [sym_tuple_expression] = STATE(2384),
    [sym_brace_expression] = STATE(2384),
    [sym_anon_record_expression] = STATE(2384),
    [sym_prefixed_expression] = STATE(2384),
    [sym_typecast_expression] = STATE(2384),
    [sym_for_expression] = STATE(2384),
    [sym_while_expression] = STATE(2384),
    [sym__if_branch] = STATE(6561),
    [sym_if_expression] = STATE(2384),
    [sym_fun_expression] = STATE(2384),
    [sym_try_expression] = STATE(2384),
    [sym_match_expression] = STATE(2384),
    [sym_function_expression] = STATE(2384),
    [sym_mutate_expression] = STATE(2384),
    [sym_index_expression] = STATE(2384),
    [sym_typed_expression] = STATE(2384),
    [sym_declaration_expression] = STATE(2384),
    [sym_do_expression] = STATE(2384),
    [sym_list_expression] = STATE(2384),
    [sym_array_expression] = STATE(2384),
    [sym_begin_end_expression] = STATE(2384),
    [sym_paren_expression] = STATE(2384),
    [sym__high_prec_app] = STATE(2249),
    [sym__low_prec_app] = STATE(2249),
    [sym_application_expression] = STATE(2384),
    [sym_dot_expression] = STATE(2384),
    [sym_infix_expression] = STATE(2384),
    [sym_ce_expression] = STATE(2384),
    [sym_sequential_expression] = STATE(2384),
    [sym_char] = STATE(2144),
    [sym_format_string] = STATE(2142),
    [sym__string_literal] = STATE(2142),
    [sym_string] = STATE(2144),
    [sym_verbatim_string] = STATE(2144),
    [sym_bytearray] = STATE(2144),
    [sym_verbatim_bytearray] = STATE(2144),
    [sym_format_triple_quoted_string] = STATE(2141),
    [sym_triple_quoted_string] = STATE(2144),
    [sym_const] = STATE(2384),
    [sym_long_identifier] = STATE(2400),
    [sym_active_pattern] = STATE(2317),
    [sym__identifier_or_op] = STATE(2392),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(633),
    [sym_sbyte] = STATE(2144),
    [sym_byte] = STATE(2144),
    [sym_int16] = STATE(2144),
    [sym_uint16] = STATE(2144),
    [sym_int32] = STATE(2144),
    [sym_uint32] = STATE(2144),
    [sym_nativeint] = STATE(2144),
    [sym_unativeint] = STATE(2144),
    [sym_int64] = STATE(2144),
    [sym_uint64] = STATE(2144),
    [sym_ieee32] = STATE(2144),
    [sym_ieee64] = STATE(2144),
    [sym_bignum] = STATE(2144),
    [sym_decimal] = STATE(2144),
    [sym_float] = STATE(1672),
    [sym_block_comment] = STATE(521),
    [sym_compiler_directive_decl] = STATE(521),
    [sym_fsi_directive_decl] = STATE(521),
    [sym_preproc_line] = STATE(521),
    [sym_preproc_if_in_expression] = STATE(2384),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(1439),
    [anon_sym_return] = ACTIONS(1443),
    [anon_sym_do] = ACTIONS(1445),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(1447),
    [anon_sym_null] = ACTIONS(1451),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1453),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1455),
    [anon_sym_LBRACE] = ACTIONS(2036),
    [anon_sym_LT_AT] = ACTIONS(1459),
    [anon_sym_LT_AT_AT] = ACTIONS(2038),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1465),
    [anon_sym_new] = ACTIONS(1443),
    [anon_sym_return_BANG] = ACTIONS(1467),
    [anon_sym_yield] = ACTIONS(1443),
    [anon_sym_yield_BANG] = ACTIONS(1467),
    [anon_sym_lazy] = ACTIONS(1443),
    [anon_sym_assert] = ACTIONS(1443),
    [anon_sym_upcast] = ACTIONS(1443),
    [anon_sym_downcast] = ACTIONS(1443),
    [anon_sym_for] = ACTIONS(1471),
    [anon_sym_while] = ACTIONS(1473),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(1475),
    [anon_sym_try] = ACTIONS(1477),
    [anon_sym_match] = ACTIONS(1479),
    [anon_sym_match_BANG] = ACTIONS(1481),
    [anon_sym_function] = ACTIONS(1483),
    [anon_sym_use] = ACTIONS(1491),
    [anon_sym_use_BANG] = ACTIONS(1493),
    [anon_sym_do_BANG] = ACTIONS(1495),
    [anon_sym_begin] = ACTIONS(1497),
    [aux_sym_char_token1] = ACTIONS(1501),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1503),
    [anon_sym_DQUOTE] = ACTIONS(1505),
    [anon_sym_AT_DQUOTE] = ACTIONS(1507),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1509),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1511),
    [sym_bool] = ACTIONS(1513),
    [sym_unit] = ACTIONS(2040),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1517),
    [sym_op_identifier] = ACTIONS(2042),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(1521),
    [sym_xint] = ACTIONS(1523),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1525),
  },
  [522] = {
    [sym_function_or_value_defn] = STATE(600),
    [sym__expression] = STATE(212),
    [sym_literal_expression] = STATE(867),
    [sym_long_identifier_or_op] = STATE(867),
    [sym_tuple_expression] = STATE(867),
    [sym_brace_expression] = STATE(867),
    [sym_anon_record_expression] = STATE(867),
    [sym_prefixed_expression] = STATE(867),
    [sym_typecast_expression] = STATE(867),
    [sym_for_expression] = STATE(867),
    [sym_while_expression] = STATE(867),
    [sym__if_branch] = STATE(6511),
    [sym_if_expression] = STATE(867),
    [sym_fun_expression] = STATE(867),
    [sym_try_expression] = STATE(867),
    [sym_match_expression] = STATE(867),
    [sym_function_expression] = STATE(867),
    [sym_mutate_expression] = STATE(867),
    [sym_index_expression] = STATE(867),
    [sym_typed_expression] = STATE(867),
    [sym_declaration_expression] = STATE(867),
    [sym_do_expression] = STATE(867),
    [sym_list_expression] = STATE(867),
    [sym_array_expression] = STATE(867),
    [sym_begin_end_expression] = STATE(867),
    [sym_paren_expression] = STATE(867),
    [sym__high_prec_app] = STATE(864),
    [sym__low_prec_app] = STATE(864),
    [sym_application_expression] = STATE(867),
    [sym_dot_expression] = STATE(867),
    [sym_infix_expression] = STATE(867),
    [sym_ce_expression] = STATE(867),
    [sym_sequential_expression] = STATE(867),
    [sym_char] = STATE(868),
    [sym_format_string] = STATE(869),
    [sym__string_literal] = STATE(869),
    [sym_string] = STATE(868),
    [sym_verbatim_string] = STATE(868),
    [sym_bytearray] = STATE(868),
    [sym_verbatim_bytearray] = STATE(868),
    [sym_format_triple_quoted_string] = STATE(870),
    [sym_triple_quoted_string] = STATE(868),
    [sym_const] = STATE(867),
    [sym_long_identifier] = STATE(872),
    [sym_active_pattern] = STATE(871),
    [sym__identifier_or_op] = STATE(873),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(656),
    [sym_sbyte] = STATE(868),
    [sym_byte] = STATE(868),
    [sym_int16] = STATE(868),
    [sym_uint16] = STATE(868),
    [sym_int32] = STATE(868),
    [sym_uint32] = STATE(868),
    [sym_nativeint] = STATE(868),
    [sym_unativeint] = STATE(868),
    [sym_int64] = STATE(868),
    [sym_uint64] = STATE(868),
    [sym_ieee32] = STATE(868),
    [sym_ieee64] = STATE(868),
    [sym_bignum] = STATE(868),
    [sym_decimal] = STATE(868),
    [sym_float] = STATE(1368),
    [sym_block_comment] = STATE(522),
    [sym_compiler_directive_decl] = STATE(522),
    [sym_fsi_directive_decl] = STATE(522),
    [sym_preproc_line] = STATE(522),
    [sym_preproc_if_in_expression] = STATE(867),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(29),
    [anon_sym_return] = ACTIONS(825),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_null] = ACTIONS(49),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACK_PIPE] = ACTIONS(57),
    [anon_sym_LBRACE] = ACTIONS(1663),
    [anon_sym_LT_AT] = ACTIONS(61),
    [anon_sym_LT_AT_AT] = ACTIONS(1665),
    [anon_sym_LBRACE_PIPE] = ACTIONS(67),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_return_BANG] = ACTIONS(829),
    [anon_sym_yield] = ACTIONS(825),
    [anon_sym_yield_BANG] = ACTIONS(829),
    [anon_sym_lazy] = ACTIONS(825),
    [anon_sym_assert] = ACTIONS(825),
    [anon_sym_upcast] = ACTIONS(825),
    [anon_sym_downcast] = ACTIONS(825),
    [anon_sym_for] = ACTIONS(73),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(79),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_match] = ACTIONS(83),
    [anon_sym_match_BANG] = ACTIONS(85),
    [anon_sym_function] = ACTIONS(87),
    [anon_sym_use] = ACTIONS(833),
    [anon_sym_use_BANG] = ACTIONS(835),
    [anon_sym_do_BANG] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(101),
    [aux_sym_char_token1] = ACTIONS(105),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(107),
    [anon_sym_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DQUOTE] = ACTIONS(111),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(115),
    [sym_bool] = ACTIONS(117),
    [sym_unit] = ACTIONS(1673),
    [anon_sym_LPAREN_PIPE] = ACTIONS(121),
    [sym_op_identifier] = ACTIONS(1675),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(837),
    [sym_xint] = ACTIONS(387),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(135),
  },
  [523] = {
    [sym_function_or_value_defn] = STATE(600),
    [sym__expression] = STATE(215),
    [sym_literal_expression] = STATE(867),
    [sym_long_identifier_or_op] = STATE(867),
    [sym_tuple_expression] = STATE(867),
    [sym_brace_expression] = STATE(867),
    [sym_anon_record_expression] = STATE(867),
    [sym_prefixed_expression] = STATE(867),
    [sym_typecast_expression] = STATE(867),
    [sym_for_expression] = STATE(867),
    [sym_while_expression] = STATE(867),
    [sym__if_branch] = STATE(6511),
    [sym_if_expression] = STATE(867),
    [sym_fun_expression] = STATE(867),
    [sym_try_expression] = STATE(867),
    [sym_match_expression] = STATE(867),
    [sym_function_expression] = STATE(867),
    [sym_mutate_expression] = STATE(867),
    [sym_index_expression] = STATE(867),
    [sym_typed_expression] = STATE(867),
    [sym_declaration_expression] = STATE(867),
    [sym_do_expression] = STATE(867),
    [sym_list_expression] = STATE(867),
    [sym_array_expression] = STATE(867),
    [sym_begin_end_expression] = STATE(867),
    [sym_paren_expression] = STATE(867),
    [sym__high_prec_app] = STATE(864),
    [sym__low_prec_app] = STATE(864),
    [sym_application_expression] = STATE(867),
    [sym_dot_expression] = STATE(867),
    [sym_infix_expression] = STATE(867),
    [sym_ce_expression] = STATE(867),
    [sym_sequential_expression] = STATE(867),
    [sym_char] = STATE(868),
    [sym_format_string] = STATE(869),
    [sym__string_literal] = STATE(869),
    [sym_string] = STATE(868),
    [sym_verbatim_string] = STATE(868),
    [sym_bytearray] = STATE(868),
    [sym_verbatim_bytearray] = STATE(868),
    [sym_format_triple_quoted_string] = STATE(870),
    [sym_triple_quoted_string] = STATE(868),
    [sym_const] = STATE(867),
    [sym_long_identifier] = STATE(872),
    [sym_active_pattern] = STATE(871),
    [sym__identifier_or_op] = STATE(873),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(656),
    [sym_sbyte] = STATE(868),
    [sym_byte] = STATE(868),
    [sym_int16] = STATE(868),
    [sym_uint16] = STATE(868),
    [sym_int32] = STATE(868),
    [sym_uint32] = STATE(868),
    [sym_nativeint] = STATE(868),
    [sym_unativeint] = STATE(868),
    [sym_int64] = STATE(868),
    [sym_uint64] = STATE(868),
    [sym_ieee32] = STATE(868),
    [sym_ieee64] = STATE(868),
    [sym_bignum] = STATE(868),
    [sym_decimal] = STATE(868),
    [sym_float] = STATE(1368),
    [sym_block_comment] = STATE(523),
    [sym_compiler_directive_decl] = STATE(523),
    [sym_fsi_directive_decl] = STATE(523),
    [sym_preproc_line] = STATE(523),
    [sym_preproc_if_in_expression] = STATE(867),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(29),
    [anon_sym_return] = ACTIONS(825),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_null] = ACTIONS(49),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACK_PIPE] = ACTIONS(57),
    [anon_sym_LBRACE] = ACTIONS(1663),
    [anon_sym_LT_AT] = ACTIONS(61),
    [anon_sym_LT_AT_AT] = ACTIONS(1665),
    [anon_sym_LBRACE_PIPE] = ACTIONS(67),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_return_BANG] = ACTIONS(829),
    [anon_sym_yield] = ACTIONS(825),
    [anon_sym_yield_BANG] = ACTIONS(829),
    [anon_sym_lazy] = ACTIONS(825),
    [anon_sym_assert] = ACTIONS(825),
    [anon_sym_upcast] = ACTIONS(825),
    [anon_sym_downcast] = ACTIONS(825),
    [anon_sym_for] = ACTIONS(73),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(79),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_match] = ACTIONS(83),
    [anon_sym_match_BANG] = ACTIONS(85),
    [anon_sym_function] = ACTIONS(87),
    [anon_sym_use] = ACTIONS(833),
    [anon_sym_use_BANG] = ACTIONS(835),
    [anon_sym_do_BANG] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(101),
    [aux_sym_char_token1] = ACTIONS(105),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(107),
    [anon_sym_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DQUOTE] = ACTIONS(111),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(115),
    [sym_bool] = ACTIONS(117),
    [sym_unit] = ACTIONS(1673),
    [anon_sym_LPAREN_PIPE] = ACTIONS(121),
    [sym_op_identifier] = ACTIONS(1675),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(837),
    [sym_xint] = ACTIONS(387),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(135),
  },
  [524] = {
    [sym_function_or_value_defn] = STATE(627),
    [sym__expression] = STATE(48),
    [sym_literal_expression] = STATE(1118),
    [sym_long_identifier_or_op] = STATE(1118),
    [sym_tuple_expression] = STATE(1118),
    [sym_brace_expression] = STATE(1118),
    [sym_anon_record_expression] = STATE(1118),
    [sym_prefixed_expression] = STATE(1118),
    [sym_typecast_expression] = STATE(1118),
    [sym_for_expression] = STATE(1118),
    [sym_while_expression] = STATE(1118),
    [sym__if_branch] = STATE(7163),
    [sym_if_expression] = STATE(1118),
    [sym_fun_expression] = STATE(1118),
    [sym_try_expression] = STATE(1118),
    [sym_match_expression] = STATE(1118),
    [sym_function_expression] = STATE(1118),
    [sym_mutate_expression] = STATE(1118),
    [sym_index_expression] = STATE(1118),
    [sym_typed_expression] = STATE(1118),
    [sym_declaration_expression] = STATE(1118),
    [sym_do_expression] = STATE(1118),
    [sym_list_expression] = STATE(1118),
    [sym_array_expression] = STATE(1118),
    [sym_begin_end_expression] = STATE(1118),
    [sym_paren_expression] = STATE(1118),
    [sym__high_prec_app] = STATE(1133),
    [sym__low_prec_app] = STATE(1133),
    [sym_application_expression] = STATE(1118),
    [sym_dot_expression] = STATE(1118),
    [sym_infix_expression] = STATE(1118),
    [sym_ce_expression] = STATE(1118),
    [sym_sequential_expression] = STATE(1118),
    [sym_char] = STATE(1080),
    [sym_format_string] = STATE(1090),
    [sym__string_literal] = STATE(1090),
    [sym_string] = STATE(1080),
    [sym_verbatim_string] = STATE(1080),
    [sym_bytearray] = STATE(1080),
    [sym_verbatim_bytearray] = STATE(1080),
    [sym_format_triple_quoted_string] = STATE(1096),
    [sym_triple_quoted_string] = STATE(1080),
    [sym_const] = STATE(1118),
    [sym_long_identifier] = STATE(1156),
    [sym_active_pattern] = STATE(1085),
    [sym__identifier_or_op] = STATE(1099),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(517),
    [sym_sbyte] = STATE(1080),
    [sym_byte] = STATE(1080),
    [sym_int16] = STATE(1080),
    [sym_uint16] = STATE(1080),
    [sym_int32] = STATE(1080),
    [sym_uint32] = STATE(1080),
    [sym_nativeint] = STATE(1080),
    [sym_unativeint] = STATE(1080),
    [sym_int64] = STATE(1080),
    [sym_uint64] = STATE(1080),
    [sym_ieee32] = STATE(1080),
    [sym_ieee64] = STATE(1080),
    [sym_bignum] = STATE(1080),
    [sym_decimal] = STATE(1080),
    [sym_float] = STATE(979),
    [sym_block_comment] = STATE(524),
    [sym_compiler_directive_decl] = STATE(524),
    [sym_fsi_directive_decl] = STATE(524),
    [sym_preproc_line] = STATE(524),
    [sym_preproc_if_in_expression] = STATE(1118),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(195),
    [anon_sym_return] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_null] = ACTIONS(207),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(209),
    [anon_sym_LBRACK_PIPE] = ACTIONS(211),
    [anon_sym_LBRACE] = ACTIONS(1687),
    [anon_sym_LT_AT] = ACTIONS(213),
    [anon_sym_LT_AT_AT] = ACTIONS(1689),
    [anon_sym_LBRACE_PIPE] = ACTIONS(217),
    [anon_sym_new] = ACTIONS(199),
    [anon_sym_return_BANG] = ACTIONS(219),
    [anon_sym_yield] = ACTIONS(199),
    [anon_sym_yield_BANG] = ACTIONS(219),
    [anon_sym_lazy] = ACTIONS(199),
    [anon_sym_assert] = ACTIONS(199),
    [anon_sym_upcast] = ACTIONS(199),
    [anon_sym_downcast] = ACTIONS(199),
    [anon_sym_for] = ACTIONS(223),
    [anon_sym_while] = ACTIONS(225),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(229),
    [anon_sym_match] = ACTIONS(231),
    [anon_sym_match_BANG] = ACTIONS(233),
    [anon_sym_function] = ACTIONS(235),
    [anon_sym_use] = ACTIONS(239),
    [anon_sym_use_BANG] = ACTIONS(241),
    [anon_sym_do_BANG] = ACTIONS(243),
    [anon_sym_begin] = ACTIONS(245),
    [aux_sym_char_token1] = ACTIONS(247),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(251),
    [anon_sym_AT_DQUOTE] = ACTIONS(253),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(255),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(257),
    [sym_bool] = ACTIONS(259),
    [sym_unit] = ACTIONS(1699),
    [anon_sym_LPAREN_PIPE] = ACTIONS(261),
    [sym_op_identifier] = ACTIONS(1701),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(265),
    [sym_xint] = ACTIONS(267),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(269),
  },
  [525] = {
    [sym_function_or_value_defn] = STATE(600),
    [sym__expression] = STATE(141),
    [sym_literal_expression] = STATE(867),
    [sym_long_identifier_or_op] = STATE(867),
    [sym_tuple_expression] = STATE(867),
    [sym_brace_expression] = STATE(867),
    [sym_anon_record_expression] = STATE(867),
    [sym_prefixed_expression] = STATE(867),
    [sym_typecast_expression] = STATE(867),
    [sym_for_expression] = STATE(867),
    [sym_while_expression] = STATE(867),
    [sym__if_branch] = STATE(6511),
    [sym_if_expression] = STATE(867),
    [sym_fun_expression] = STATE(867),
    [sym_try_expression] = STATE(867),
    [sym_match_expression] = STATE(867),
    [sym_function_expression] = STATE(867),
    [sym_mutate_expression] = STATE(867),
    [sym_index_expression] = STATE(867),
    [sym_typed_expression] = STATE(867),
    [sym_declaration_expression] = STATE(867),
    [sym_do_expression] = STATE(867),
    [sym_list_expression] = STATE(867),
    [sym_array_expression] = STATE(867),
    [sym_begin_end_expression] = STATE(867),
    [sym_paren_expression] = STATE(867),
    [sym__high_prec_app] = STATE(864),
    [sym__low_prec_app] = STATE(864),
    [sym_application_expression] = STATE(867),
    [sym_dot_expression] = STATE(867),
    [sym_infix_expression] = STATE(867),
    [sym_ce_expression] = STATE(867),
    [sym_sequential_expression] = STATE(867),
    [sym_char] = STATE(868),
    [sym_format_string] = STATE(869),
    [sym__string_literal] = STATE(869),
    [sym_string] = STATE(868),
    [sym_verbatim_string] = STATE(868),
    [sym_bytearray] = STATE(868),
    [sym_verbatim_bytearray] = STATE(868),
    [sym_format_triple_quoted_string] = STATE(870),
    [sym_triple_quoted_string] = STATE(868),
    [sym_const] = STATE(867),
    [sym_long_identifier] = STATE(872),
    [sym_active_pattern] = STATE(871),
    [sym__identifier_or_op] = STATE(873),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(656),
    [sym_sbyte] = STATE(868),
    [sym_byte] = STATE(868),
    [sym_int16] = STATE(868),
    [sym_uint16] = STATE(868),
    [sym_int32] = STATE(868),
    [sym_uint32] = STATE(868),
    [sym_nativeint] = STATE(868),
    [sym_unativeint] = STATE(868),
    [sym_int64] = STATE(868),
    [sym_uint64] = STATE(868),
    [sym_ieee32] = STATE(868),
    [sym_ieee64] = STATE(868),
    [sym_bignum] = STATE(868),
    [sym_decimal] = STATE(868),
    [sym_float] = STATE(1368),
    [sym_block_comment] = STATE(525),
    [sym_compiler_directive_decl] = STATE(525),
    [sym_fsi_directive_decl] = STATE(525),
    [sym_preproc_line] = STATE(525),
    [sym_preproc_if_in_expression] = STATE(867),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(29),
    [anon_sym_return] = ACTIONS(825),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_null] = ACTIONS(49),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACK_PIPE] = ACTIONS(57),
    [anon_sym_LBRACE] = ACTIONS(1663),
    [anon_sym_LT_AT] = ACTIONS(61),
    [anon_sym_LT_AT_AT] = ACTIONS(1665),
    [anon_sym_LBRACE_PIPE] = ACTIONS(67),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_return_BANG] = ACTIONS(829),
    [anon_sym_yield] = ACTIONS(825),
    [anon_sym_yield_BANG] = ACTIONS(829),
    [anon_sym_lazy] = ACTIONS(825),
    [anon_sym_assert] = ACTIONS(825),
    [anon_sym_upcast] = ACTIONS(825),
    [anon_sym_downcast] = ACTIONS(825),
    [anon_sym_for] = ACTIONS(73),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(79),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_match] = ACTIONS(83),
    [anon_sym_match_BANG] = ACTIONS(85),
    [anon_sym_function] = ACTIONS(87),
    [anon_sym_use] = ACTIONS(833),
    [anon_sym_use_BANG] = ACTIONS(835),
    [anon_sym_do_BANG] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(101),
    [aux_sym_char_token1] = ACTIONS(105),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(107),
    [anon_sym_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DQUOTE] = ACTIONS(111),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(115),
    [sym_bool] = ACTIONS(117),
    [sym_unit] = ACTIONS(1673),
    [anon_sym_LPAREN_PIPE] = ACTIONS(121),
    [sym_op_identifier] = ACTIONS(1675),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(837),
    [sym_xint] = ACTIONS(387),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(135),
  },
  [526] = {
    [sym_function_or_value_defn] = STATE(627),
    [sym__expression] = STATE(42),
    [sym_literal_expression] = STATE(1118),
    [sym_long_identifier_or_op] = STATE(1118),
    [sym_tuple_expression] = STATE(1118),
    [sym_brace_expression] = STATE(1118),
    [sym_anon_record_expression] = STATE(1118),
    [sym_prefixed_expression] = STATE(1118),
    [sym_typecast_expression] = STATE(1118),
    [sym_for_expression] = STATE(1118),
    [sym_while_expression] = STATE(1118),
    [sym__if_branch] = STATE(7163),
    [sym_if_expression] = STATE(1118),
    [sym_fun_expression] = STATE(1118),
    [sym_try_expression] = STATE(1118),
    [sym_match_expression] = STATE(1118),
    [sym_function_expression] = STATE(1118),
    [sym_mutate_expression] = STATE(1118),
    [sym_index_expression] = STATE(1118),
    [sym_typed_expression] = STATE(1118),
    [sym_declaration_expression] = STATE(1118),
    [sym_do_expression] = STATE(1118),
    [sym_list_expression] = STATE(1118),
    [sym_array_expression] = STATE(1118),
    [sym_begin_end_expression] = STATE(1118),
    [sym_paren_expression] = STATE(1118),
    [sym__high_prec_app] = STATE(1133),
    [sym__low_prec_app] = STATE(1133),
    [sym_application_expression] = STATE(1118),
    [sym_dot_expression] = STATE(1118),
    [sym_infix_expression] = STATE(1118),
    [sym_ce_expression] = STATE(1118),
    [sym_sequential_expression] = STATE(1118),
    [sym_char] = STATE(1080),
    [sym_format_string] = STATE(1090),
    [sym__string_literal] = STATE(1090),
    [sym_string] = STATE(1080),
    [sym_verbatim_string] = STATE(1080),
    [sym_bytearray] = STATE(1080),
    [sym_verbatim_bytearray] = STATE(1080),
    [sym_format_triple_quoted_string] = STATE(1096),
    [sym_triple_quoted_string] = STATE(1080),
    [sym_const] = STATE(1118),
    [sym_long_identifier] = STATE(1156),
    [sym_active_pattern] = STATE(1085),
    [sym__identifier_or_op] = STATE(1099),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(517),
    [sym_sbyte] = STATE(1080),
    [sym_byte] = STATE(1080),
    [sym_int16] = STATE(1080),
    [sym_uint16] = STATE(1080),
    [sym_int32] = STATE(1080),
    [sym_uint32] = STATE(1080),
    [sym_nativeint] = STATE(1080),
    [sym_unativeint] = STATE(1080),
    [sym_int64] = STATE(1080),
    [sym_uint64] = STATE(1080),
    [sym_ieee32] = STATE(1080),
    [sym_ieee64] = STATE(1080),
    [sym_bignum] = STATE(1080),
    [sym_decimal] = STATE(1080),
    [sym_float] = STATE(979),
    [sym_block_comment] = STATE(526),
    [sym_compiler_directive_decl] = STATE(526),
    [sym_fsi_directive_decl] = STATE(526),
    [sym_preproc_line] = STATE(526),
    [sym_preproc_if_in_expression] = STATE(1118),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(195),
    [anon_sym_return] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_null] = ACTIONS(207),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(209),
    [anon_sym_LBRACK_PIPE] = ACTIONS(211),
    [anon_sym_LBRACE] = ACTIONS(1687),
    [anon_sym_LT_AT] = ACTIONS(213),
    [anon_sym_LT_AT_AT] = ACTIONS(1689),
    [anon_sym_LBRACE_PIPE] = ACTIONS(217),
    [anon_sym_new] = ACTIONS(199),
    [anon_sym_return_BANG] = ACTIONS(219),
    [anon_sym_yield] = ACTIONS(199),
    [anon_sym_yield_BANG] = ACTIONS(219),
    [anon_sym_lazy] = ACTIONS(199),
    [anon_sym_assert] = ACTIONS(199),
    [anon_sym_upcast] = ACTIONS(199),
    [anon_sym_downcast] = ACTIONS(199),
    [anon_sym_for] = ACTIONS(223),
    [anon_sym_while] = ACTIONS(225),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(229),
    [anon_sym_match] = ACTIONS(231),
    [anon_sym_match_BANG] = ACTIONS(233),
    [anon_sym_function] = ACTIONS(235),
    [anon_sym_use] = ACTIONS(239),
    [anon_sym_use_BANG] = ACTIONS(241),
    [anon_sym_do_BANG] = ACTIONS(243),
    [anon_sym_begin] = ACTIONS(245),
    [aux_sym_char_token1] = ACTIONS(247),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(251),
    [anon_sym_AT_DQUOTE] = ACTIONS(253),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(255),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(257),
    [sym_bool] = ACTIONS(259),
    [sym_unit] = ACTIONS(1699),
    [anon_sym_LPAREN_PIPE] = ACTIONS(261),
    [sym_op_identifier] = ACTIONS(1701),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(265),
    [sym_xint] = ACTIONS(267),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(269),
  },
  [527] = {
    [sym_function_or_value_defn] = STATE(527),
    [sym__expression] = STATE(259),
    [sym_literal_expression] = STATE(2384),
    [sym_long_identifier_or_op] = STATE(2384),
    [sym_tuple_expression] = STATE(2384),
    [sym_brace_expression] = STATE(2384),
    [sym_anon_record_expression] = STATE(2384),
    [sym_prefixed_expression] = STATE(2384),
    [sym_typecast_expression] = STATE(2384),
    [sym_for_expression] = STATE(2384),
    [sym_while_expression] = STATE(2384),
    [sym__if_branch] = STATE(6561),
    [sym_if_expression] = STATE(2384),
    [sym_fun_expression] = STATE(2384),
    [sym_try_expression] = STATE(2384),
    [sym_match_expression] = STATE(2384),
    [sym_function_expression] = STATE(2384),
    [sym_mutate_expression] = STATE(2384),
    [sym_index_expression] = STATE(2384),
    [sym_typed_expression] = STATE(2384),
    [sym_declaration_expression] = STATE(2384),
    [sym_do_expression] = STATE(2384),
    [sym_list_expression] = STATE(2384),
    [sym_array_expression] = STATE(2384),
    [sym_begin_end_expression] = STATE(2384),
    [sym_paren_expression] = STATE(2384),
    [sym__high_prec_app] = STATE(2249),
    [sym__low_prec_app] = STATE(2249),
    [sym_application_expression] = STATE(2384),
    [sym_dot_expression] = STATE(2384),
    [sym_infix_expression] = STATE(2384),
    [sym_ce_expression] = STATE(2384),
    [sym_sequential_expression] = STATE(2384),
    [sym_char] = STATE(2144),
    [sym_format_string] = STATE(2142),
    [sym__string_literal] = STATE(2142),
    [sym_string] = STATE(2144),
    [sym_verbatim_string] = STATE(2144),
    [sym_bytearray] = STATE(2144),
    [sym_verbatim_bytearray] = STATE(2144),
    [sym_format_triple_quoted_string] = STATE(2141),
    [sym_triple_quoted_string] = STATE(2144),
    [sym_const] = STATE(2384),
    [sym_long_identifier] = STATE(2400),
    [sym_active_pattern] = STATE(2317),
    [sym__identifier_or_op] = STATE(2392),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(633),
    [sym_sbyte] = STATE(2144),
    [sym_byte] = STATE(2144),
    [sym_int16] = STATE(2144),
    [sym_uint16] = STATE(2144),
    [sym_int32] = STATE(2144),
    [sym_uint32] = STATE(2144),
    [sym_nativeint] = STATE(2144),
    [sym_unativeint] = STATE(2144),
    [sym_int64] = STATE(2144),
    [sym_uint64] = STATE(2144),
    [sym_ieee32] = STATE(2144),
    [sym_ieee64] = STATE(2144),
    [sym_bignum] = STATE(2144),
    [sym_decimal] = STATE(2144),
    [sym_float] = STATE(1672),
    [sym_block_comment] = STATE(527),
    [sym_compiler_directive_decl] = STATE(527),
    [sym_fsi_directive_decl] = STATE(527),
    [sym_preproc_line] = STATE(527),
    [sym_preproc_if_in_expression] = STATE(2384),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(1439),
    [anon_sym_return] = ACTIONS(1443),
    [anon_sym_do] = ACTIONS(1445),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(1447),
    [anon_sym_null] = ACTIONS(1451),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1453),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1455),
    [anon_sym_LBRACE] = ACTIONS(2036),
    [anon_sym_LT_AT] = ACTIONS(1459),
    [anon_sym_LT_AT_AT] = ACTIONS(2038),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1465),
    [anon_sym_new] = ACTIONS(1443),
    [anon_sym_return_BANG] = ACTIONS(1467),
    [anon_sym_yield] = ACTIONS(1443),
    [anon_sym_yield_BANG] = ACTIONS(1467),
    [anon_sym_lazy] = ACTIONS(1443),
    [anon_sym_assert] = ACTIONS(1443),
    [anon_sym_upcast] = ACTIONS(1443),
    [anon_sym_downcast] = ACTIONS(1443),
    [anon_sym_for] = ACTIONS(1471),
    [anon_sym_while] = ACTIONS(1473),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(1475),
    [anon_sym_try] = ACTIONS(1477),
    [anon_sym_match] = ACTIONS(1479),
    [anon_sym_match_BANG] = ACTIONS(1481),
    [anon_sym_function] = ACTIONS(1483),
    [anon_sym_use] = ACTIONS(1491),
    [anon_sym_use_BANG] = ACTIONS(1493),
    [anon_sym_do_BANG] = ACTIONS(1495),
    [anon_sym_begin] = ACTIONS(1497),
    [aux_sym_char_token1] = ACTIONS(1501),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1503),
    [anon_sym_DQUOTE] = ACTIONS(1505),
    [anon_sym_AT_DQUOTE] = ACTIONS(1507),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1509),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1511),
    [sym_bool] = ACTIONS(1513),
    [sym_unit] = ACTIONS(2040),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1517),
    [sym_op_identifier] = ACTIONS(2042),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(1521),
    [sym_xint] = ACTIONS(1523),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1525),
  },
  [528] = {
    [sym_function_or_value_defn] = STATE(651),
    [sym__expression] = STATE(238),
    [sym_literal_expression] = STATE(2168),
    [sym_long_identifier_or_op] = STATE(2168),
    [sym_tuple_expression] = STATE(2168),
    [sym_brace_expression] = STATE(2168),
    [sym_anon_record_expression] = STATE(2168),
    [sym_prefixed_expression] = STATE(2168),
    [sym_typecast_expression] = STATE(2168),
    [sym_for_expression] = STATE(2168),
    [sym_while_expression] = STATE(2168),
    [sym__if_branch] = STATE(6406),
    [sym_if_expression] = STATE(2168),
    [sym_fun_expression] = STATE(2168),
    [sym_try_expression] = STATE(2168),
    [sym_match_expression] = STATE(2168),
    [sym_function_expression] = STATE(2168),
    [sym_mutate_expression] = STATE(2168),
    [sym_index_expression] = STATE(2168),
    [sym_typed_expression] = STATE(2168),
    [sym_declaration_expression] = STATE(2168),
    [sym_do_expression] = STATE(2168),
    [sym_list_expression] = STATE(2168),
    [sym_array_expression] = STATE(2168),
    [sym_begin_end_expression] = STATE(2168),
    [sym_paren_expression] = STATE(2168),
    [sym__high_prec_app] = STATE(2179),
    [sym__low_prec_app] = STATE(2179),
    [sym_application_expression] = STATE(2168),
    [sym_dot_expression] = STATE(2168),
    [sym_infix_expression] = STATE(2168),
    [sym_ce_expression] = STATE(2168),
    [sym_sequential_expression] = STATE(2168),
    [sym_char] = STATE(2469),
    [sym_format_string] = STATE(2412),
    [sym__string_literal] = STATE(2412),
    [sym_string] = STATE(2469),
    [sym_verbatim_string] = STATE(2469),
    [sym_bytearray] = STATE(2469),
    [sym_verbatim_bytearray] = STATE(2469),
    [sym_format_triple_quoted_string] = STATE(2408),
    [sym_triple_quoted_string] = STATE(2469),
    [sym_const] = STATE(2168),
    [sym_long_identifier] = STATE(2183),
    [sym_active_pattern] = STATE(2182),
    [sym__identifier_or_op] = STATE(2093),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(650),
    [sym_sbyte] = STATE(2469),
    [sym_byte] = STATE(2469),
    [sym_int16] = STATE(2469),
    [sym_uint16] = STATE(2469),
    [sym_int32] = STATE(2469),
    [sym_uint32] = STATE(2469),
    [sym_nativeint] = STATE(2469),
    [sym_unativeint] = STATE(2469),
    [sym_int64] = STATE(2469),
    [sym_uint64] = STATE(2469),
    [sym_ieee32] = STATE(2469),
    [sym_ieee64] = STATE(2469),
    [sym_bignum] = STATE(2469),
    [sym_decimal] = STATE(2469),
    [sym_float] = STATE(1586),
    [sym_block_comment] = STATE(528),
    [sym_compiler_directive_decl] = STATE(528),
    [sym_fsi_directive_decl] = STATE(528),
    [sym_preproc_line] = STATE(528),
    [sym_preproc_if_in_expression] = STATE(2168),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(989),
    [anon_sym_return] = ACTIONS(993),
    [anon_sym_do] = ACTIONS(995),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(997),
    [anon_sym_null] = ACTIONS(1001),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1003),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1005),
    [anon_sym_LBRACE] = ACTIONS(2070),
    [anon_sym_LT_AT] = ACTIONS(1009),
    [anon_sym_LT_AT_AT] = ACTIONS(2072),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1017),
    [anon_sym_new] = ACTIONS(993),
    [anon_sym_return_BANG] = ACTIONS(1019),
    [anon_sym_yield] = ACTIONS(993),
    [anon_sym_yield_BANG] = ACTIONS(1019),
    [anon_sym_lazy] = ACTIONS(993),
    [anon_sym_assert] = ACTIONS(993),
    [anon_sym_upcast] = ACTIONS(993),
    [anon_sym_downcast] = ACTIONS(993),
    [anon_sym_for] = ACTIONS(1023),
    [anon_sym_while] = ACTIONS(1025),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(1027),
    [anon_sym_try] = ACTIONS(1029),
    [anon_sym_match] = ACTIONS(1031),
    [anon_sym_match_BANG] = ACTIONS(1033),
    [anon_sym_function] = ACTIONS(1035),
    [anon_sym_use] = ACTIONS(1043),
    [anon_sym_use_BANG] = ACTIONS(1045),
    [anon_sym_do_BANG] = ACTIONS(1047),
    [anon_sym_begin] = ACTIONS(1049),
    [aux_sym_char_token1] = ACTIONS(1053),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1055),
    [anon_sym_DQUOTE] = ACTIONS(1057),
    [anon_sym_AT_DQUOTE] = ACTIONS(1059),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1061),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1063),
    [sym_bool] = ACTIONS(1065),
    [sym_unit] = ACTIONS(2074),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1069),
    [sym_op_identifier] = ACTIONS(2076),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(1073),
    [sym_xint] = ACTIONS(1075),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1077),
  },
  [529] = {
    [sym_function_or_value_defn] = STATE(630),
    [sym__expression] = STATE(139),
    [sym_literal_expression] = STATE(2380),
    [sym_long_identifier_or_op] = STATE(2380),
    [sym_tuple_expression] = STATE(2380),
    [sym_brace_expression] = STATE(2380),
    [sym_anon_record_expression] = STATE(2380),
    [sym_prefixed_expression] = STATE(2380),
    [sym_typecast_expression] = STATE(2380),
    [sym_for_expression] = STATE(2380),
    [sym_while_expression] = STATE(2380),
    [sym__if_branch] = STATE(6456),
    [sym_if_expression] = STATE(2380),
    [sym_fun_expression] = STATE(2380),
    [sym_try_expression] = STATE(2380),
    [sym_match_expression] = STATE(2380),
    [sym_function_expression] = STATE(2380),
    [sym_mutate_expression] = STATE(2380),
    [sym_index_expression] = STATE(2380),
    [sym_typed_expression] = STATE(2380),
    [sym_declaration_expression] = STATE(2380),
    [sym_do_expression] = STATE(2380),
    [sym_list_expression] = STATE(2380),
    [sym_array_expression] = STATE(2380),
    [sym_begin_end_expression] = STATE(2380),
    [sym_paren_expression] = STATE(2380),
    [sym__high_prec_app] = STATE(2383),
    [sym__low_prec_app] = STATE(2383),
    [sym_application_expression] = STATE(2380),
    [sym_dot_expression] = STATE(2380),
    [sym_infix_expression] = STATE(2380),
    [sym_ce_expression] = STATE(2380),
    [sym_sequential_expression] = STATE(2380),
    [sym_char] = STATE(2261),
    [sym_format_string] = STATE(2274),
    [sym__string_literal] = STATE(2274),
    [sym_string] = STATE(2261),
    [sym_verbatim_string] = STATE(2261),
    [sym_bytearray] = STATE(2261),
    [sym_verbatim_bytearray] = STATE(2261),
    [sym_format_triple_quoted_string] = STATE(2275),
    [sym_triple_quoted_string] = STATE(2261),
    [sym_const] = STATE(2380),
    [sym_long_identifier] = STATE(2391),
    [sym_active_pattern] = STATE(2470),
    [sym__identifier_or_op] = STATE(2390),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(632),
    [sym_sbyte] = STATE(2261),
    [sym_byte] = STATE(2261),
    [sym_int16] = STATE(2261),
    [sym_uint16] = STATE(2261),
    [sym_int32] = STATE(2261),
    [sym_uint32] = STATE(2261),
    [sym_nativeint] = STATE(2261),
    [sym_unativeint] = STATE(2261),
    [sym_int64] = STATE(2261),
    [sym_uint64] = STATE(2261),
    [sym_ieee32] = STATE(2261),
    [sym_ieee64] = STATE(2261),
    [sym_bignum] = STATE(2261),
    [sym_decimal] = STATE(2261),
    [sym_float] = STATE(1614),
    [sym_block_comment] = STATE(529),
    [sym_compiler_directive_decl] = STATE(529),
    [sym_fsi_directive_decl] = STATE(529),
    [sym_preproc_line] = STATE(529),
    [sym_preproc_if_in_expression] = STATE(2380),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(1081),
    [anon_sym_return] = ACTIONS(1085),
    [anon_sym_do] = ACTIONS(1087),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(1089),
    [anon_sym_null] = ACTIONS(1093),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1095),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1097),
    [anon_sym_LBRACE] = ACTIONS(2100),
    [anon_sym_LT_AT] = ACTIONS(1101),
    [anon_sym_LT_AT_AT] = ACTIONS(2102),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1107),
    [anon_sym_new] = ACTIONS(1085),
    [anon_sym_return_BANG] = ACTIONS(1109),
    [anon_sym_yield] = ACTIONS(1085),
    [anon_sym_yield_BANG] = ACTIONS(1109),
    [anon_sym_lazy] = ACTIONS(1085),
    [anon_sym_assert] = ACTIONS(1085),
    [anon_sym_upcast] = ACTIONS(1085),
    [anon_sym_downcast] = ACTIONS(1085),
    [anon_sym_for] = ACTIONS(1113),
    [anon_sym_while] = ACTIONS(1115),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(1117),
    [anon_sym_try] = ACTIONS(1119),
    [anon_sym_match] = ACTIONS(1121),
    [anon_sym_match_BANG] = ACTIONS(1123),
    [anon_sym_function] = ACTIONS(1125),
    [anon_sym_use] = ACTIONS(1133),
    [anon_sym_use_BANG] = ACTIONS(1135),
    [anon_sym_do_BANG] = ACTIONS(1137),
    [anon_sym_begin] = ACTIONS(1139),
    [aux_sym_char_token1] = ACTIONS(1143),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1145),
    [anon_sym_DQUOTE] = ACTIONS(1147),
    [anon_sym_AT_DQUOTE] = ACTIONS(1149),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1151),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1153),
    [sym_bool] = ACTIONS(1155),
    [sym_unit] = ACTIONS(2104),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1159),
    [sym_op_identifier] = ACTIONS(2106),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(1163),
    [sym_xint] = ACTIONS(1165),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1167),
  },
  [530] = {
    [sym_function_or_value_defn] = STATE(651),
    [sym__expression] = STATE(137),
    [sym_literal_expression] = STATE(2168),
    [sym_long_identifier_or_op] = STATE(2168),
    [sym_tuple_expression] = STATE(2168),
    [sym_brace_expression] = STATE(2168),
    [sym_anon_record_expression] = STATE(2168),
    [sym_prefixed_expression] = STATE(2168),
    [sym_typecast_expression] = STATE(2168),
    [sym_for_expression] = STATE(2168),
    [sym_while_expression] = STATE(2168),
    [sym__if_branch] = STATE(6406),
    [sym_if_expression] = STATE(2168),
    [sym_fun_expression] = STATE(2168),
    [sym_try_expression] = STATE(2168),
    [sym_match_expression] = STATE(2168),
    [sym_function_expression] = STATE(2168),
    [sym_mutate_expression] = STATE(2168),
    [sym_index_expression] = STATE(2168),
    [sym_typed_expression] = STATE(2168),
    [sym_declaration_expression] = STATE(2168),
    [sym_do_expression] = STATE(2168),
    [sym_list_expression] = STATE(2168),
    [sym_array_expression] = STATE(2168),
    [sym_begin_end_expression] = STATE(2168),
    [sym_paren_expression] = STATE(2168),
    [sym__high_prec_app] = STATE(2179),
    [sym__low_prec_app] = STATE(2179),
    [sym_application_expression] = STATE(2168),
    [sym_dot_expression] = STATE(2168),
    [sym_infix_expression] = STATE(2168),
    [sym_ce_expression] = STATE(2168),
    [sym_sequential_expression] = STATE(2168),
    [sym_char] = STATE(2469),
    [sym_format_string] = STATE(2412),
    [sym__string_literal] = STATE(2412),
    [sym_string] = STATE(2469),
    [sym_verbatim_string] = STATE(2469),
    [sym_bytearray] = STATE(2469),
    [sym_verbatim_bytearray] = STATE(2469),
    [sym_format_triple_quoted_string] = STATE(2408),
    [sym_triple_quoted_string] = STATE(2469),
    [sym_const] = STATE(2168),
    [sym_long_identifier] = STATE(2183),
    [sym_active_pattern] = STATE(2182),
    [sym__identifier_or_op] = STATE(2093),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(650),
    [sym_sbyte] = STATE(2469),
    [sym_byte] = STATE(2469),
    [sym_int16] = STATE(2469),
    [sym_uint16] = STATE(2469),
    [sym_int32] = STATE(2469),
    [sym_uint32] = STATE(2469),
    [sym_nativeint] = STATE(2469),
    [sym_unativeint] = STATE(2469),
    [sym_int64] = STATE(2469),
    [sym_uint64] = STATE(2469),
    [sym_ieee32] = STATE(2469),
    [sym_ieee64] = STATE(2469),
    [sym_bignum] = STATE(2469),
    [sym_decimal] = STATE(2469),
    [sym_float] = STATE(1586),
    [sym_block_comment] = STATE(530),
    [sym_compiler_directive_decl] = STATE(530),
    [sym_fsi_directive_decl] = STATE(530),
    [sym_preproc_line] = STATE(530),
    [sym_preproc_if_in_expression] = STATE(2168),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(989),
    [anon_sym_return] = ACTIONS(993),
    [anon_sym_do] = ACTIONS(995),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(997),
    [anon_sym_null] = ACTIONS(1001),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1003),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1005),
    [anon_sym_LBRACE] = ACTIONS(2070),
    [anon_sym_LT_AT] = ACTIONS(1009),
    [anon_sym_LT_AT_AT] = ACTIONS(2072),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1017),
    [anon_sym_new] = ACTIONS(993),
    [anon_sym_return_BANG] = ACTIONS(1019),
    [anon_sym_yield] = ACTIONS(993),
    [anon_sym_yield_BANG] = ACTIONS(1019),
    [anon_sym_lazy] = ACTIONS(993),
    [anon_sym_assert] = ACTIONS(993),
    [anon_sym_upcast] = ACTIONS(993),
    [anon_sym_downcast] = ACTIONS(993),
    [anon_sym_for] = ACTIONS(1023),
    [anon_sym_while] = ACTIONS(1025),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(1027),
    [anon_sym_try] = ACTIONS(1029),
    [anon_sym_match] = ACTIONS(1031),
    [anon_sym_match_BANG] = ACTIONS(1033),
    [anon_sym_function] = ACTIONS(1035),
    [anon_sym_use] = ACTIONS(1043),
    [anon_sym_use_BANG] = ACTIONS(1045),
    [anon_sym_do_BANG] = ACTIONS(1047),
    [anon_sym_begin] = ACTIONS(1049),
    [aux_sym_char_token1] = ACTIONS(1053),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1055),
    [anon_sym_DQUOTE] = ACTIONS(1057),
    [anon_sym_AT_DQUOTE] = ACTIONS(1059),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1061),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1063),
    [sym_bool] = ACTIONS(1065),
    [sym_unit] = ACTIONS(2074),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1069),
    [sym_op_identifier] = ACTIONS(2076),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(1073),
    [sym_xint] = ACTIONS(1075),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1077),
  },
  [531] = {
    [sym_function_or_value_defn] = STATE(627),
    [sym__expression] = STATE(60),
    [sym_literal_expression] = STATE(1118),
    [sym_long_identifier_or_op] = STATE(1118),
    [sym_tuple_expression] = STATE(1118),
    [sym_brace_expression] = STATE(1118),
    [sym_anon_record_expression] = STATE(1118),
    [sym_prefixed_expression] = STATE(1118),
    [sym_typecast_expression] = STATE(1118),
    [sym_for_expression] = STATE(1118),
    [sym_while_expression] = STATE(1118),
    [sym__if_branch] = STATE(7163),
    [sym_if_expression] = STATE(1118),
    [sym_fun_expression] = STATE(1118),
    [sym_try_expression] = STATE(1118),
    [sym_match_expression] = STATE(1118),
    [sym_function_expression] = STATE(1118),
    [sym_mutate_expression] = STATE(1118),
    [sym_index_expression] = STATE(1118),
    [sym_typed_expression] = STATE(1118),
    [sym_declaration_expression] = STATE(1118),
    [sym_do_expression] = STATE(1118),
    [sym_list_expression] = STATE(1118),
    [sym_array_expression] = STATE(1118),
    [sym_begin_end_expression] = STATE(1118),
    [sym_paren_expression] = STATE(1118),
    [sym__high_prec_app] = STATE(1133),
    [sym__low_prec_app] = STATE(1133),
    [sym_application_expression] = STATE(1118),
    [sym_dot_expression] = STATE(1118),
    [sym_infix_expression] = STATE(1118),
    [sym_ce_expression] = STATE(1118),
    [sym_sequential_expression] = STATE(1118),
    [sym_char] = STATE(1080),
    [sym_format_string] = STATE(1090),
    [sym__string_literal] = STATE(1090),
    [sym_string] = STATE(1080),
    [sym_verbatim_string] = STATE(1080),
    [sym_bytearray] = STATE(1080),
    [sym_verbatim_bytearray] = STATE(1080),
    [sym_format_triple_quoted_string] = STATE(1096),
    [sym_triple_quoted_string] = STATE(1080),
    [sym_const] = STATE(1118),
    [sym_long_identifier] = STATE(1156),
    [sym_active_pattern] = STATE(1085),
    [sym__identifier_or_op] = STATE(1099),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(517),
    [sym_sbyte] = STATE(1080),
    [sym_byte] = STATE(1080),
    [sym_int16] = STATE(1080),
    [sym_uint16] = STATE(1080),
    [sym_int32] = STATE(1080),
    [sym_uint32] = STATE(1080),
    [sym_nativeint] = STATE(1080),
    [sym_unativeint] = STATE(1080),
    [sym_int64] = STATE(1080),
    [sym_uint64] = STATE(1080),
    [sym_ieee32] = STATE(1080),
    [sym_ieee64] = STATE(1080),
    [sym_bignum] = STATE(1080),
    [sym_decimal] = STATE(1080),
    [sym_float] = STATE(979),
    [sym_block_comment] = STATE(531),
    [sym_compiler_directive_decl] = STATE(531),
    [sym_fsi_directive_decl] = STATE(531),
    [sym_preproc_line] = STATE(531),
    [sym_preproc_if_in_expression] = STATE(1118),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(195),
    [anon_sym_return] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_null] = ACTIONS(207),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(209),
    [anon_sym_LBRACK_PIPE] = ACTIONS(211),
    [anon_sym_LBRACE] = ACTIONS(1687),
    [anon_sym_LT_AT] = ACTIONS(213),
    [anon_sym_LT_AT_AT] = ACTIONS(1689),
    [anon_sym_LBRACE_PIPE] = ACTIONS(217),
    [anon_sym_new] = ACTIONS(199),
    [anon_sym_return_BANG] = ACTIONS(219),
    [anon_sym_yield] = ACTIONS(199),
    [anon_sym_yield_BANG] = ACTIONS(219),
    [anon_sym_lazy] = ACTIONS(199),
    [anon_sym_assert] = ACTIONS(199),
    [anon_sym_upcast] = ACTIONS(199),
    [anon_sym_downcast] = ACTIONS(199),
    [anon_sym_for] = ACTIONS(223),
    [anon_sym_while] = ACTIONS(225),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(229),
    [anon_sym_match] = ACTIONS(231),
    [anon_sym_match_BANG] = ACTIONS(233),
    [anon_sym_function] = ACTIONS(235),
    [anon_sym_use] = ACTIONS(239),
    [anon_sym_use_BANG] = ACTIONS(241),
    [anon_sym_do_BANG] = ACTIONS(243),
    [anon_sym_begin] = ACTIONS(245),
    [aux_sym_char_token1] = ACTIONS(247),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(251),
    [anon_sym_AT_DQUOTE] = ACTIONS(253),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(255),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(257),
    [sym_bool] = ACTIONS(259),
    [sym_unit] = ACTIONS(1699),
    [anon_sym_LPAREN_PIPE] = ACTIONS(261),
    [sym_op_identifier] = ACTIONS(1701),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(265),
    [sym_xint] = ACTIONS(267),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(269),
  },
  [532] = {
    [sym_function_or_value_defn] = STATE(532),
    [sym__expression] = STATE(124),
    [sym_literal_expression] = STATE(2000),
    [sym_long_identifier_or_op] = STATE(2000),
    [sym_tuple_expression] = STATE(2000),
    [sym_brace_expression] = STATE(2000),
    [sym_anon_record_expression] = STATE(2000),
    [sym_prefixed_expression] = STATE(2000),
    [sym_typecast_expression] = STATE(2000),
    [sym_for_expression] = STATE(2000),
    [sym_while_expression] = STATE(2000),
    [sym__if_branch] = STATE(6707),
    [sym_if_expression] = STATE(2000),
    [sym_fun_expression] = STATE(2000),
    [sym_try_expression] = STATE(2000),
    [sym_match_expression] = STATE(2000),
    [sym_function_expression] = STATE(2000),
    [sym_mutate_expression] = STATE(2000),
    [sym_index_expression] = STATE(2000),
    [sym_typed_expression] = STATE(2000),
    [sym_declaration_expression] = STATE(2000),
    [sym_do_expression] = STATE(2000),
    [sym_list_expression] = STATE(2000),
    [sym_array_expression] = STATE(2000),
    [sym_begin_end_expression] = STATE(2000),
    [sym_paren_expression] = STATE(2000),
    [sym__high_prec_app] = STATE(2003),
    [sym__low_prec_app] = STATE(2003),
    [sym_application_expression] = STATE(2000),
    [sym_dot_expression] = STATE(2000),
    [sym_infix_expression] = STATE(2000),
    [sym_ce_expression] = STATE(2000),
    [sym_sequential_expression] = STATE(2000),
    [sym_char] = STATE(1801),
    [sym_format_string] = STATE(1804),
    [sym__string_literal] = STATE(1804),
    [sym_string] = STATE(1801),
    [sym_verbatim_string] = STATE(1801),
    [sym_bytearray] = STATE(1801),
    [sym_verbatim_bytearray] = STATE(1801),
    [sym_format_triple_quoted_string] = STATE(1807),
    [sym_triple_quoted_string] = STATE(1801),
    [sym_const] = STATE(2000),
    [sym_long_identifier] = STATE(1725),
    [sym_active_pattern] = STATE(1726),
    [sym__identifier_or_op] = STATE(1751),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(723),
    [sym_sbyte] = STATE(1801),
    [sym_byte] = STATE(1801),
    [sym_int16] = STATE(1801),
    [sym_uint16] = STATE(1801),
    [sym_int32] = STATE(1801),
    [sym_uint32] = STATE(1801),
    [sym_nativeint] = STATE(1801),
    [sym_unativeint] = STATE(1801),
    [sym_int64] = STATE(1801),
    [sym_uint64] = STATE(1801),
    [sym_ieee32] = STATE(1801),
    [sym_ieee64] = STATE(1801),
    [sym_bignum] = STATE(1801),
    [sym_decimal] = STATE(1801),
    [sym_float] = STATE(1427),
    [sym_block_comment] = STATE(532),
    [sym_compiler_directive_decl] = STATE(532),
    [sym_fsi_directive_decl] = STATE(532),
    [sym_preproc_line] = STATE(532),
    [sym_preproc_if_in_expression] = STATE(2000),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(629),
    [anon_sym_return] = ACTIONS(633),
    [anon_sym_do] = ACTIONS(635),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(637),
    [anon_sym_null] = ACTIONS(641),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(643),
    [anon_sym_LBRACK_PIPE] = ACTIONS(645),
    [anon_sym_LBRACE] = ACTIONS(1713),
    [anon_sym_LT_AT] = ACTIONS(647),
    [anon_sym_LT_AT_AT] = ACTIONS(1715),
    [anon_sym_LBRACE_PIPE] = ACTIONS(653),
    [anon_sym_new] = ACTIONS(633),
    [anon_sym_return_BANG] = ACTIONS(655),
    [anon_sym_yield] = ACTIONS(633),
    [anon_sym_yield_BANG] = ACTIONS(655),
    [anon_sym_lazy] = ACTIONS(633),
    [anon_sym_assert] = ACTIONS(633),
    [anon_sym_upcast] = ACTIONS(633),
    [anon_sym_downcast] = ACTIONS(633),
    [anon_sym_for] = ACTIONS(659),
    [anon_sym_while] = ACTIONS(661),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(663),
    [anon_sym_try] = ACTIONS(665),
    [anon_sym_match] = ACTIONS(667),
    [anon_sym_match_BANG] = ACTIONS(669),
    [anon_sym_function] = ACTIONS(671),
    [anon_sym_use] = ACTIONS(679),
    [anon_sym_use_BANG] = ACTIONS(681),
    [anon_sym_do_BANG] = ACTIONS(683),
    [anon_sym_begin] = ACTIONS(685),
    [aux_sym_char_token1] = ACTIONS(689),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(691),
    [anon_sym_DQUOTE] = ACTIONS(693),
    [anon_sym_AT_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(697),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(699),
    [sym_bool] = ACTIONS(701),
    [sym_unit] = ACTIONS(1717),
    [anon_sym_LPAREN_PIPE] = ACTIONS(705),
    [sym_op_identifier] = ACTIONS(1719),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(709),
    [sym_xint] = ACTIONS(711),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(713),
  },
  [533] = {
    [sym_function_or_value_defn] = STATE(627),
    [sym__expression] = STATE(351),
    [sym_literal_expression] = STATE(1118),
    [sym_long_identifier_or_op] = STATE(1118),
    [sym_tuple_expression] = STATE(1118),
    [sym_brace_expression] = STATE(1118),
    [sym_anon_record_expression] = STATE(1118),
    [sym_prefixed_expression] = STATE(1118),
    [sym_typecast_expression] = STATE(1118),
    [sym_for_expression] = STATE(1118),
    [sym_while_expression] = STATE(1118),
    [sym__if_branch] = STATE(7163),
    [sym_if_expression] = STATE(1118),
    [sym_fun_expression] = STATE(1118),
    [sym_try_expression] = STATE(1118),
    [sym_match_expression] = STATE(1118),
    [sym_function_expression] = STATE(1118),
    [sym_mutate_expression] = STATE(1118),
    [sym_index_expression] = STATE(1118),
    [sym_typed_expression] = STATE(1118),
    [sym_declaration_expression] = STATE(1118),
    [sym_do_expression] = STATE(1118),
    [sym_list_expression] = STATE(1118),
    [sym_array_expression] = STATE(1118),
    [sym_begin_end_expression] = STATE(1118),
    [sym_paren_expression] = STATE(1118),
    [sym__high_prec_app] = STATE(1133),
    [sym__low_prec_app] = STATE(1133),
    [sym_application_expression] = STATE(1118),
    [sym_dot_expression] = STATE(1118),
    [sym_infix_expression] = STATE(1118),
    [sym_ce_expression] = STATE(1118),
    [sym_sequential_expression] = STATE(1118),
    [sym_char] = STATE(1080),
    [sym_format_string] = STATE(1090),
    [sym__string_literal] = STATE(1090),
    [sym_string] = STATE(1080),
    [sym_verbatim_string] = STATE(1080),
    [sym_bytearray] = STATE(1080),
    [sym_verbatim_bytearray] = STATE(1080),
    [sym_format_triple_quoted_string] = STATE(1096),
    [sym_triple_quoted_string] = STATE(1080),
    [sym_const] = STATE(1118),
    [sym_long_identifier] = STATE(1156),
    [sym_active_pattern] = STATE(1085),
    [sym__identifier_or_op] = STATE(1099),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(517),
    [sym_sbyte] = STATE(1080),
    [sym_byte] = STATE(1080),
    [sym_int16] = STATE(1080),
    [sym_uint16] = STATE(1080),
    [sym_int32] = STATE(1080),
    [sym_uint32] = STATE(1080),
    [sym_nativeint] = STATE(1080),
    [sym_unativeint] = STATE(1080),
    [sym_int64] = STATE(1080),
    [sym_uint64] = STATE(1080),
    [sym_ieee32] = STATE(1080),
    [sym_ieee64] = STATE(1080),
    [sym_bignum] = STATE(1080),
    [sym_decimal] = STATE(1080),
    [sym_float] = STATE(979),
    [sym_block_comment] = STATE(533),
    [sym_compiler_directive_decl] = STATE(533),
    [sym_fsi_directive_decl] = STATE(533),
    [sym_preproc_line] = STATE(533),
    [sym_preproc_if_in_expression] = STATE(1118),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(195),
    [anon_sym_return] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_null] = ACTIONS(207),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(209),
    [anon_sym_LBRACK_PIPE] = ACTIONS(211),
    [anon_sym_LBRACE] = ACTIONS(1687),
    [anon_sym_LT_AT] = ACTIONS(213),
    [anon_sym_LT_AT_AT] = ACTIONS(1689),
    [anon_sym_LBRACE_PIPE] = ACTIONS(217),
    [anon_sym_new] = ACTIONS(199),
    [anon_sym_return_BANG] = ACTIONS(219),
    [anon_sym_yield] = ACTIONS(199),
    [anon_sym_yield_BANG] = ACTIONS(219),
    [anon_sym_lazy] = ACTIONS(199),
    [anon_sym_assert] = ACTIONS(199),
    [anon_sym_upcast] = ACTIONS(199),
    [anon_sym_downcast] = ACTIONS(199),
    [anon_sym_for] = ACTIONS(223),
    [anon_sym_while] = ACTIONS(225),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(229),
    [anon_sym_match] = ACTIONS(231),
    [anon_sym_match_BANG] = ACTIONS(233),
    [anon_sym_function] = ACTIONS(235),
    [anon_sym_use] = ACTIONS(239),
    [anon_sym_use_BANG] = ACTIONS(241),
    [anon_sym_do_BANG] = ACTIONS(243),
    [anon_sym_begin] = ACTIONS(245),
    [aux_sym_char_token1] = ACTIONS(247),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(251),
    [anon_sym_AT_DQUOTE] = ACTIONS(253),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(255),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(257),
    [sym_bool] = ACTIONS(259),
    [sym_unit] = ACTIONS(1699),
    [anon_sym_LPAREN_PIPE] = ACTIONS(261),
    [sym_op_identifier] = ACTIONS(1701),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(265),
    [sym_xint] = ACTIONS(267),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(269),
  },
  [534] = {
    [sym_function_or_value_defn] = STATE(600),
    [sym__expression] = STATE(218),
    [sym_literal_expression] = STATE(867),
    [sym_long_identifier_or_op] = STATE(867),
    [sym_tuple_expression] = STATE(867),
    [sym_brace_expression] = STATE(867),
    [sym_anon_record_expression] = STATE(867),
    [sym_prefixed_expression] = STATE(867),
    [sym_typecast_expression] = STATE(867),
    [sym_for_expression] = STATE(867),
    [sym_while_expression] = STATE(867),
    [sym__if_branch] = STATE(6511),
    [sym_if_expression] = STATE(867),
    [sym_fun_expression] = STATE(867),
    [sym_try_expression] = STATE(867),
    [sym_match_expression] = STATE(867),
    [sym_function_expression] = STATE(867),
    [sym_mutate_expression] = STATE(867),
    [sym_index_expression] = STATE(867),
    [sym_typed_expression] = STATE(867),
    [sym_declaration_expression] = STATE(867),
    [sym_do_expression] = STATE(867),
    [sym_list_expression] = STATE(867),
    [sym_array_expression] = STATE(867),
    [sym_begin_end_expression] = STATE(867),
    [sym_paren_expression] = STATE(867),
    [sym__high_prec_app] = STATE(864),
    [sym__low_prec_app] = STATE(864),
    [sym_application_expression] = STATE(867),
    [sym_dot_expression] = STATE(867),
    [sym_infix_expression] = STATE(867),
    [sym_ce_expression] = STATE(867),
    [sym_sequential_expression] = STATE(867),
    [sym_char] = STATE(868),
    [sym_format_string] = STATE(869),
    [sym__string_literal] = STATE(869),
    [sym_string] = STATE(868),
    [sym_verbatim_string] = STATE(868),
    [sym_bytearray] = STATE(868),
    [sym_verbatim_bytearray] = STATE(868),
    [sym_format_triple_quoted_string] = STATE(870),
    [sym_triple_quoted_string] = STATE(868),
    [sym_const] = STATE(867),
    [sym_long_identifier] = STATE(872),
    [sym_active_pattern] = STATE(871),
    [sym__identifier_or_op] = STATE(873),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(656),
    [sym_sbyte] = STATE(868),
    [sym_byte] = STATE(868),
    [sym_int16] = STATE(868),
    [sym_uint16] = STATE(868),
    [sym_int32] = STATE(868),
    [sym_uint32] = STATE(868),
    [sym_nativeint] = STATE(868),
    [sym_unativeint] = STATE(868),
    [sym_int64] = STATE(868),
    [sym_uint64] = STATE(868),
    [sym_ieee32] = STATE(868),
    [sym_ieee64] = STATE(868),
    [sym_bignum] = STATE(868),
    [sym_decimal] = STATE(868),
    [sym_float] = STATE(1368),
    [sym_block_comment] = STATE(534),
    [sym_compiler_directive_decl] = STATE(534),
    [sym_fsi_directive_decl] = STATE(534),
    [sym_preproc_line] = STATE(534),
    [sym_preproc_if_in_expression] = STATE(867),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(29),
    [anon_sym_return] = ACTIONS(825),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_null] = ACTIONS(49),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACK_PIPE] = ACTIONS(57),
    [anon_sym_LBRACE] = ACTIONS(1663),
    [anon_sym_LT_AT] = ACTIONS(61),
    [anon_sym_LT_AT_AT] = ACTIONS(1665),
    [anon_sym_LBRACE_PIPE] = ACTIONS(67),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_return_BANG] = ACTIONS(829),
    [anon_sym_yield] = ACTIONS(825),
    [anon_sym_yield_BANG] = ACTIONS(829),
    [anon_sym_lazy] = ACTIONS(825),
    [anon_sym_assert] = ACTIONS(825),
    [anon_sym_upcast] = ACTIONS(825),
    [anon_sym_downcast] = ACTIONS(825),
    [anon_sym_for] = ACTIONS(73),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(79),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_match] = ACTIONS(83),
    [anon_sym_match_BANG] = ACTIONS(85),
    [anon_sym_function] = ACTIONS(87),
    [anon_sym_use] = ACTIONS(833),
    [anon_sym_use_BANG] = ACTIONS(835),
    [anon_sym_do_BANG] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(101),
    [aux_sym_char_token1] = ACTIONS(105),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(107),
    [anon_sym_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DQUOTE] = ACTIONS(111),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(115),
    [sym_bool] = ACTIONS(117),
    [sym_unit] = ACTIONS(1673),
    [anon_sym_LPAREN_PIPE] = ACTIONS(121),
    [sym_op_identifier] = ACTIONS(1675),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(837),
    [sym_xint] = ACTIONS(387),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(135),
  },
  [535] = {
    [sym_function_or_value_defn] = STATE(535),
    [sym__expression] = STATE(43),
    [sym_literal_expression] = STATE(2008),
    [sym_long_identifier_or_op] = STATE(2008),
    [sym_tuple_expression] = STATE(2008),
    [sym_brace_expression] = STATE(2008),
    [sym_anon_record_expression] = STATE(2008),
    [sym_prefixed_expression] = STATE(2008),
    [sym_typecast_expression] = STATE(2008),
    [sym_for_expression] = STATE(2008),
    [sym_while_expression] = STATE(2008),
    [sym__if_branch] = STATE(6754),
    [sym_if_expression] = STATE(2008),
    [sym_fun_expression] = STATE(2008),
    [sym_try_expression] = STATE(2008),
    [sym_match_expression] = STATE(2008),
    [sym_function_expression] = STATE(2008),
    [sym_mutate_expression] = STATE(2008),
    [sym_index_expression] = STATE(2008),
    [sym_typed_expression] = STATE(2008),
    [sym_declaration_expression] = STATE(2008),
    [sym_do_expression] = STATE(2008),
    [sym_list_expression] = STATE(2008),
    [sym_array_expression] = STATE(2008),
    [sym_begin_end_expression] = STATE(2008),
    [sym_paren_expression] = STATE(2008),
    [sym__high_prec_app] = STATE(2007),
    [sym__low_prec_app] = STATE(2007),
    [sym_application_expression] = STATE(2008),
    [sym_dot_expression] = STATE(2008),
    [sym_infix_expression] = STATE(2008),
    [sym_ce_expression] = STATE(2008),
    [sym_sequential_expression] = STATE(2008),
    [sym_char] = STATE(1859),
    [sym_format_string] = STATE(1861),
    [sym__string_literal] = STATE(1861),
    [sym_string] = STATE(1859),
    [sym_verbatim_string] = STATE(1859),
    [sym_bytearray] = STATE(1859),
    [sym_verbatim_bytearray] = STATE(1859),
    [sym_format_triple_quoted_string] = STATE(1862),
    [sym_triple_quoted_string] = STATE(1859),
    [sym_const] = STATE(2008),
    [sym_long_identifier] = STATE(1701),
    [sym_active_pattern] = STATE(1702),
    [sym__identifier_or_op] = STATE(1724),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(664),
    [sym_sbyte] = STATE(1859),
    [sym_byte] = STATE(1859),
    [sym_int16] = STATE(1859),
    [sym_uint16] = STATE(1859),
    [sym_int32] = STATE(1859),
    [sym_uint32] = STATE(1859),
    [sym_nativeint] = STATE(1859),
    [sym_unativeint] = STATE(1859),
    [sym_int64] = STATE(1859),
    [sym_uint64] = STATE(1859),
    [sym_ieee32] = STATE(1859),
    [sym_ieee64] = STATE(1859),
    [sym_bignum] = STATE(1859),
    [sym_decimal] = STATE(1859),
    [sym_float] = STATE(1447),
    [sym_block_comment] = STATE(535),
    [sym_compiler_directive_decl] = STATE(535),
    [sym_fsi_directive_decl] = STATE(535),
    [sym_preproc_line] = STATE(535),
    [sym_preproc_if_in_expression] = STATE(2008),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(503),
    [anon_sym_return] = ACTIONS(507),
    [anon_sym_do] = ACTIONS(599),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(511),
    [anon_sym_null] = ACTIONS(515),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(517),
    [anon_sym_LBRACK_PIPE] = ACTIONS(519),
    [anon_sym_LBRACE] = ACTIONS(2060),
    [anon_sym_LT_AT] = ACTIONS(523),
    [anon_sym_LT_AT_AT] = ACTIONS(2062),
    [anon_sym_LBRACE_PIPE] = ACTIONS(529),
    [anon_sym_new] = ACTIONS(507),
    [anon_sym_return_BANG] = ACTIONS(531),
    [anon_sym_yield] = ACTIONS(507),
    [anon_sym_yield_BANG] = ACTIONS(531),
    [anon_sym_lazy] = ACTIONS(507),
    [anon_sym_assert] = ACTIONS(507),
    [anon_sym_upcast] = ACTIONS(507),
    [anon_sym_downcast] = ACTIONS(507),
    [anon_sym_for] = ACTIONS(535),
    [anon_sym_while] = ACTIONS(537),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(539),
    [anon_sym_try] = ACTIONS(543),
    [anon_sym_match] = ACTIONS(545),
    [anon_sym_match_BANG] = ACTIONS(547),
    [anon_sym_function] = ACTIONS(549),
    [anon_sym_use] = ACTIONS(557),
    [anon_sym_use_BANG] = ACTIONS(559),
    [anon_sym_do_BANG] = ACTIONS(561),
    [anon_sym_begin] = ACTIONS(565),
    [aux_sym_char_token1] = ACTIONS(569),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(571),
    [anon_sym_DQUOTE] = ACTIONS(573),
    [anon_sym_AT_DQUOTE] = ACTIONS(575),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(577),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(579),
    [sym_bool] = ACTIONS(581),
    [sym_unit] = ACTIONS(2064),
    [anon_sym_LPAREN_PIPE] = ACTIONS(585),
    [sym_op_identifier] = ACTIONS(2066),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(589),
    [sym_xint] = ACTIONS(591),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(593),
  },
  [536] = {
    [sym_function_or_value_defn] = STATE(627),
    [sym__expression] = STATE(40),
    [sym_literal_expression] = STATE(1118),
    [sym_long_identifier_or_op] = STATE(1118),
    [sym_tuple_expression] = STATE(1118),
    [sym_brace_expression] = STATE(1118),
    [sym_anon_record_expression] = STATE(1118),
    [sym_prefixed_expression] = STATE(1118),
    [sym_typecast_expression] = STATE(1118),
    [sym_for_expression] = STATE(1118),
    [sym_while_expression] = STATE(1118),
    [sym__if_branch] = STATE(7163),
    [sym_if_expression] = STATE(1118),
    [sym_fun_expression] = STATE(1118),
    [sym_try_expression] = STATE(1118),
    [sym_match_expression] = STATE(1118),
    [sym_function_expression] = STATE(1118),
    [sym_mutate_expression] = STATE(1118),
    [sym_index_expression] = STATE(1118),
    [sym_typed_expression] = STATE(1118),
    [sym_declaration_expression] = STATE(1118),
    [sym_do_expression] = STATE(1118),
    [sym_list_expression] = STATE(1118),
    [sym_array_expression] = STATE(1118),
    [sym_begin_end_expression] = STATE(1118),
    [sym_paren_expression] = STATE(1118),
    [sym__high_prec_app] = STATE(1133),
    [sym__low_prec_app] = STATE(1133),
    [sym_application_expression] = STATE(1118),
    [sym_dot_expression] = STATE(1118),
    [sym_infix_expression] = STATE(1118),
    [sym_ce_expression] = STATE(1118),
    [sym_sequential_expression] = STATE(1118),
    [sym_char] = STATE(1080),
    [sym_format_string] = STATE(1090),
    [sym__string_literal] = STATE(1090),
    [sym_string] = STATE(1080),
    [sym_verbatim_string] = STATE(1080),
    [sym_bytearray] = STATE(1080),
    [sym_verbatim_bytearray] = STATE(1080),
    [sym_format_triple_quoted_string] = STATE(1096),
    [sym_triple_quoted_string] = STATE(1080),
    [sym_const] = STATE(1118),
    [sym_long_identifier] = STATE(1156),
    [sym_active_pattern] = STATE(1085),
    [sym__identifier_or_op] = STATE(1099),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(517),
    [sym_sbyte] = STATE(1080),
    [sym_byte] = STATE(1080),
    [sym_int16] = STATE(1080),
    [sym_uint16] = STATE(1080),
    [sym_int32] = STATE(1080),
    [sym_uint32] = STATE(1080),
    [sym_nativeint] = STATE(1080),
    [sym_unativeint] = STATE(1080),
    [sym_int64] = STATE(1080),
    [sym_uint64] = STATE(1080),
    [sym_ieee32] = STATE(1080),
    [sym_ieee64] = STATE(1080),
    [sym_bignum] = STATE(1080),
    [sym_decimal] = STATE(1080),
    [sym_float] = STATE(979),
    [sym_block_comment] = STATE(536),
    [sym_compiler_directive_decl] = STATE(536),
    [sym_fsi_directive_decl] = STATE(536),
    [sym_preproc_line] = STATE(536),
    [sym_preproc_if_in_expression] = STATE(1118),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(195),
    [anon_sym_return] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_null] = ACTIONS(207),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(209),
    [anon_sym_LBRACK_PIPE] = ACTIONS(211),
    [anon_sym_LBRACE] = ACTIONS(1687),
    [anon_sym_LT_AT] = ACTIONS(213),
    [anon_sym_LT_AT_AT] = ACTIONS(1689),
    [anon_sym_LBRACE_PIPE] = ACTIONS(217),
    [anon_sym_new] = ACTIONS(199),
    [anon_sym_return_BANG] = ACTIONS(219),
    [anon_sym_yield] = ACTIONS(199),
    [anon_sym_yield_BANG] = ACTIONS(219),
    [anon_sym_lazy] = ACTIONS(199),
    [anon_sym_assert] = ACTIONS(199),
    [anon_sym_upcast] = ACTIONS(199),
    [anon_sym_downcast] = ACTIONS(199),
    [anon_sym_for] = ACTIONS(223),
    [anon_sym_while] = ACTIONS(225),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(229),
    [anon_sym_match] = ACTIONS(231),
    [anon_sym_match_BANG] = ACTIONS(233),
    [anon_sym_function] = ACTIONS(235),
    [anon_sym_use] = ACTIONS(239),
    [anon_sym_use_BANG] = ACTIONS(241),
    [anon_sym_do_BANG] = ACTIONS(243),
    [anon_sym_begin] = ACTIONS(245),
    [aux_sym_char_token1] = ACTIONS(247),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(251),
    [anon_sym_AT_DQUOTE] = ACTIONS(253),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(255),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(257),
    [sym_bool] = ACTIONS(259),
    [sym_unit] = ACTIONS(1699),
    [anon_sym_LPAREN_PIPE] = ACTIONS(261),
    [sym_op_identifier] = ACTIONS(1701),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(265),
    [sym_xint] = ACTIONS(267),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(269),
  },
  [537] = {
    [sym_function_or_value_defn] = STATE(630),
    [sym__expression] = STATE(239),
    [sym_literal_expression] = STATE(2380),
    [sym_long_identifier_or_op] = STATE(2380),
    [sym_tuple_expression] = STATE(2380),
    [sym_brace_expression] = STATE(2380),
    [sym_anon_record_expression] = STATE(2380),
    [sym_prefixed_expression] = STATE(2380),
    [sym_typecast_expression] = STATE(2380),
    [sym_for_expression] = STATE(2380),
    [sym_while_expression] = STATE(2380),
    [sym__if_branch] = STATE(6456),
    [sym_if_expression] = STATE(2380),
    [sym_fun_expression] = STATE(2380),
    [sym_try_expression] = STATE(2380),
    [sym_match_expression] = STATE(2380),
    [sym_function_expression] = STATE(2380),
    [sym_mutate_expression] = STATE(2380),
    [sym_index_expression] = STATE(2380),
    [sym_typed_expression] = STATE(2380),
    [sym_declaration_expression] = STATE(2380),
    [sym_do_expression] = STATE(2380),
    [sym_list_expression] = STATE(2380),
    [sym_array_expression] = STATE(2380),
    [sym_begin_end_expression] = STATE(2380),
    [sym_paren_expression] = STATE(2380),
    [sym__high_prec_app] = STATE(2383),
    [sym__low_prec_app] = STATE(2383),
    [sym_application_expression] = STATE(2380),
    [sym_dot_expression] = STATE(2380),
    [sym_infix_expression] = STATE(2380),
    [sym_ce_expression] = STATE(2380),
    [sym_sequential_expression] = STATE(2380),
    [sym_char] = STATE(2261),
    [sym_format_string] = STATE(2274),
    [sym__string_literal] = STATE(2274),
    [sym_string] = STATE(2261),
    [sym_verbatim_string] = STATE(2261),
    [sym_bytearray] = STATE(2261),
    [sym_verbatim_bytearray] = STATE(2261),
    [sym_format_triple_quoted_string] = STATE(2275),
    [sym_triple_quoted_string] = STATE(2261),
    [sym_const] = STATE(2380),
    [sym_long_identifier] = STATE(2391),
    [sym_active_pattern] = STATE(2470),
    [sym__identifier_or_op] = STATE(2390),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(632),
    [sym_sbyte] = STATE(2261),
    [sym_byte] = STATE(2261),
    [sym_int16] = STATE(2261),
    [sym_uint16] = STATE(2261),
    [sym_int32] = STATE(2261),
    [sym_uint32] = STATE(2261),
    [sym_nativeint] = STATE(2261),
    [sym_unativeint] = STATE(2261),
    [sym_int64] = STATE(2261),
    [sym_uint64] = STATE(2261),
    [sym_ieee32] = STATE(2261),
    [sym_ieee64] = STATE(2261),
    [sym_bignum] = STATE(2261),
    [sym_decimal] = STATE(2261),
    [sym_float] = STATE(1614),
    [sym_block_comment] = STATE(537),
    [sym_compiler_directive_decl] = STATE(537),
    [sym_fsi_directive_decl] = STATE(537),
    [sym_preproc_line] = STATE(537),
    [sym_preproc_if_in_expression] = STATE(2380),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(1081),
    [anon_sym_return] = ACTIONS(1085),
    [anon_sym_do] = ACTIONS(1087),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(1089),
    [anon_sym_null] = ACTIONS(1093),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1095),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1097),
    [anon_sym_LBRACE] = ACTIONS(2100),
    [anon_sym_LT_AT] = ACTIONS(1101),
    [anon_sym_LT_AT_AT] = ACTIONS(2102),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1107),
    [anon_sym_new] = ACTIONS(1085),
    [anon_sym_return_BANG] = ACTIONS(1109),
    [anon_sym_yield] = ACTIONS(1085),
    [anon_sym_yield_BANG] = ACTIONS(1109),
    [anon_sym_lazy] = ACTIONS(1085),
    [anon_sym_assert] = ACTIONS(1085),
    [anon_sym_upcast] = ACTIONS(1085),
    [anon_sym_downcast] = ACTIONS(1085),
    [anon_sym_for] = ACTIONS(1113),
    [anon_sym_while] = ACTIONS(1115),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(1117),
    [anon_sym_try] = ACTIONS(1119),
    [anon_sym_match] = ACTIONS(1121),
    [anon_sym_match_BANG] = ACTIONS(1123),
    [anon_sym_function] = ACTIONS(1125),
    [anon_sym_use] = ACTIONS(1133),
    [anon_sym_use_BANG] = ACTIONS(1135),
    [anon_sym_do_BANG] = ACTIONS(1137),
    [anon_sym_begin] = ACTIONS(1139),
    [aux_sym_char_token1] = ACTIONS(1143),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1145),
    [anon_sym_DQUOTE] = ACTIONS(1147),
    [anon_sym_AT_DQUOTE] = ACTIONS(1149),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1151),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1153),
    [sym_bool] = ACTIONS(1155),
    [sym_unit] = ACTIONS(2104),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1159),
    [sym_op_identifier] = ACTIONS(2106),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(1163),
    [sym_xint] = ACTIONS(1165),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1167),
  },
  [538] = {
    [sym_function_or_value_defn] = STATE(600),
    [sym__expression] = STATE(220),
    [sym_literal_expression] = STATE(867),
    [sym_long_identifier_or_op] = STATE(867),
    [sym_tuple_expression] = STATE(867),
    [sym_brace_expression] = STATE(867),
    [sym_anon_record_expression] = STATE(867),
    [sym_prefixed_expression] = STATE(867),
    [sym_typecast_expression] = STATE(867),
    [sym_for_expression] = STATE(867),
    [sym_while_expression] = STATE(867),
    [sym__if_branch] = STATE(6511),
    [sym_if_expression] = STATE(867),
    [sym_fun_expression] = STATE(867),
    [sym_try_expression] = STATE(867),
    [sym_match_expression] = STATE(867),
    [sym_function_expression] = STATE(867),
    [sym_mutate_expression] = STATE(867),
    [sym_index_expression] = STATE(867),
    [sym_typed_expression] = STATE(867),
    [sym_declaration_expression] = STATE(867),
    [sym_do_expression] = STATE(867),
    [sym_list_expression] = STATE(867),
    [sym_array_expression] = STATE(867),
    [sym_begin_end_expression] = STATE(867),
    [sym_paren_expression] = STATE(867),
    [sym__high_prec_app] = STATE(864),
    [sym__low_prec_app] = STATE(864),
    [sym_application_expression] = STATE(867),
    [sym_dot_expression] = STATE(867),
    [sym_infix_expression] = STATE(867),
    [sym_ce_expression] = STATE(867),
    [sym_sequential_expression] = STATE(867),
    [sym_char] = STATE(868),
    [sym_format_string] = STATE(869),
    [sym__string_literal] = STATE(869),
    [sym_string] = STATE(868),
    [sym_verbatim_string] = STATE(868),
    [sym_bytearray] = STATE(868),
    [sym_verbatim_bytearray] = STATE(868),
    [sym_format_triple_quoted_string] = STATE(870),
    [sym_triple_quoted_string] = STATE(868),
    [sym_const] = STATE(867),
    [sym_long_identifier] = STATE(872),
    [sym_active_pattern] = STATE(871),
    [sym__identifier_or_op] = STATE(873),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(656),
    [sym_sbyte] = STATE(868),
    [sym_byte] = STATE(868),
    [sym_int16] = STATE(868),
    [sym_uint16] = STATE(868),
    [sym_int32] = STATE(868),
    [sym_uint32] = STATE(868),
    [sym_nativeint] = STATE(868),
    [sym_unativeint] = STATE(868),
    [sym_int64] = STATE(868),
    [sym_uint64] = STATE(868),
    [sym_ieee32] = STATE(868),
    [sym_ieee64] = STATE(868),
    [sym_bignum] = STATE(868),
    [sym_decimal] = STATE(868),
    [sym_float] = STATE(1368),
    [sym_block_comment] = STATE(538),
    [sym_compiler_directive_decl] = STATE(538),
    [sym_fsi_directive_decl] = STATE(538),
    [sym_preproc_line] = STATE(538),
    [sym_preproc_if_in_expression] = STATE(867),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(29),
    [anon_sym_return] = ACTIONS(825),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_null] = ACTIONS(49),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACK_PIPE] = ACTIONS(57),
    [anon_sym_LBRACE] = ACTIONS(1663),
    [anon_sym_LT_AT] = ACTIONS(61),
    [anon_sym_LT_AT_AT] = ACTIONS(1665),
    [anon_sym_LBRACE_PIPE] = ACTIONS(67),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_return_BANG] = ACTIONS(829),
    [anon_sym_yield] = ACTIONS(825),
    [anon_sym_yield_BANG] = ACTIONS(829),
    [anon_sym_lazy] = ACTIONS(825),
    [anon_sym_assert] = ACTIONS(825),
    [anon_sym_upcast] = ACTIONS(825),
    [anon_sym_downcast] = ACTIONS(825),
    [anon_sym_for] = ACTIONS(73),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(79),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_match] = ACTIONS(83),
    [anon_sym_match_BANG] = ACTIONS(85),
    [anon_sym_function] = ACTIONS(87),
    [anon_sym_use] = ACTIONS(833),
    [anon_sym_use_BANG] = ACTIONS(835),
    [anon_sym_do_BANG] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(101),
    [aux_sym_char_token1] = ACTIONS(105),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(107),
    [anon_sym_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DQUOTE] = ACTIONS(111),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(115),
    [sym_bool] = ACTIONS(117),
    [sym_unit] = ACTIONS(1673),
    [anon_sym_LPAREN_PIPE] = ACTIONS(121),
    [sym_op_identifier] = ACTIONS(1675),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(837),
    [sym_xint] = ACTIONS(387),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(135),
  },
  [539] = {
    [sym_function_or_value_defn] = STATE(535),
    [sym__expression] = STATE(41),
    [sym_literal_expression] = STATE(2008),
    [sym_long_identifier_or_op] = STATE(2008),
    [sym_tuple_expression] = STATE(2008),
    [sym_brace_expression] = STATE(2008),
    [sym_anon_record_expression] = STATE(2008),
    [sym_prefixed_expression] = STATE(2008),
    [sym_typecast_expression] = STATE(2008),
    [sym_for_expression] = STATE(2008),
    [sym_while_expression] = STATE(2008),
    [sym__if_branch] = STATE(6754),
    [sym_if_expression] = STATE(2008),
    [sym_fun_expression] = STATE(2008),
    [sym_try_expression] = STATE(2008),
    [sym_match_expression] = STATE(2008),
    [sym_function_expression] = STATE(2008),
    [sym_mutate_expression] = STATE(2008),
    [sym_index_expression] = STATE(2008),
    [sym_typed_expression] = STATE(2008),
    [sym_declaration_expression] = STATE(2008),
    [sym_do_expression] = STATE(2008),
    [sym_list_expression] = STATE(2008),
    [sym_array_expression] = STATE(2008),
    [sym_begin_end_expression] = STATE(2008),
    [sym_paren_expression] = STATE(2008),
    [sym__high_prec_app] = STATE(2007),
    [sym__low_prec_app] = STATE(2007),
    [sym_application_expression] = STATE(2008),
    [sym_dot_expression] = STATE(2008),
    [sym_infix_expression] = STATE(2008),
    [sym_ce_expression] = STATE(2008),
    [sym_sequential_expression] = STATE(2008),
    [sym_char] = STATE(1859),
    [sym_format_string] = STATE(1861),
    [sym__string_literal] = STATE(1861),
    [sym_string] = STATE(1859),
    [sym_verbatim_string] = STATE(1859),
    [sym_bytearray] = STATE(1859),
    [sym_verbatim_bytearray] = STATE(1859),
    [sym_format_triple_quoted_string] = STATE(1862),
    [sym_triple_quoted_string] = STATE(1859),
    [sym_const] = STATE(2008),
    [sym_long_identifier] = STATE(1701),
    [sym_active_pattern] = STATE(1702),
    [sym__identifier_or_op] = STATE(1724),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(664),
    [sym_sbyte] = STATE(1859),
    [sym_byte] = STATE(1859),
    [sym_int16] = STATE(1859),
    [sym_uint16] = STATE(1859),
    [sym_int32] = STATE(1859),
    [sym_uint32] = STATE(1859),
    [sym_nativeint] = STATE(1859),
    [sym_unativeint] = STATE(1859),
    [sym_int64] = STATE(1859),
    [sym_uint64] = STATE(1859),
    [sym_ieee32] = STATE(1859),
    [sym_ieee64] = STATE(1859),
    [sym_bignum] = STATE(1859),
    [sym_decimal] = STATE(1859),
    [sym_float] = STATE(1447),
    [sym_block_comment] = STATE(539),
    [sym_compiler_directive_decl] = STATE(539),
    [sym_fsi_directive_decl] = STATE(539),
    [sym_preproc_line] = STATE(539),
    [sym_preproc_if_in_expression] = STATE(2008),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(503),
    [anon_sym_return] = ACTIONS(507),
    [anon_sym_do] = ACTIONS(599),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(511),
    [anon_sym_null] = ACTIONS(515),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(517),
    [anon_sym_LBRACK_PIPE] = ACTIONS(519),
    [anon_sym_LBRACE] = ACTIONS(2060),
    [anon_sym_LT_AT] = ACTIONS(523),
    [anon_sym_LT_AT_AT] = ACTIONS(2062),
    [anon_sym_LBRACE_PIPE] = ACTIONS(529),
    [anon_sym_new] = ACTIONS(507),
    [anon_sym_return_BANG] = ACTIONS(531),
    [anon_sym_yield] = ACTIONS(507),
    [anon_sym_yield_BANG] = ACTIONS(531),
    [anon_sym_lazy] = ACTIONS(507),
    [anon_sym_assert] = ACTIONS(507),
    [anon_sym_upcast] = ACTIONS(507),
    [anon_sym_downcast] = ACTIONS(507),
    [anon_sym_for] = ACTIONS(535),
    [anon_sym_while] = ACTIONS(537),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(539),
    [anon_sym_try] = ACTIONS(543),
    [anon_sym_match] = ACTIONS(545),
    [anon_sym_match_BANG] = ACTIONS(547),
    [anon_sym_function] = ACTIONS(549),
    [anon_sym_use] = ACTIONS(557),
    [anon_sym_use_BANG] = ACTIONS(559),
    [anon_sym_do_BANG] = ACTIONS(561),
    [anon_sym_begin] = ACTIONS(565),
    [aux_sym_char_token1] = ACTIONS(569),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(571),
    [anon_sym_DQUOTE] = ACTIONS(573),
    [anon_sym_AT_DQUOTE] = ACTIONS(575),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(577),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(579),
    [sym_bool] = ACTIONS(581),
    [sym_unit] = ACTIONS(2064),
    [anon_sym_LPAREN_PIPE] = ACTIONS(585),
    [sym_op_identifier] = ACTIONS(2066),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(589),
    [sym_xint] = ACTIONS(591),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(593),
  },
  [540] = {
    [sym_function_or_value_defn] = STATE(705),
    [sym__expression] = STATE(2),
    [sym_literal_expression] = STATE(867),
    [sym_long_identifier_or_op] = STATE(867),
    [sym_tuple_expression] = STATE(867),
    [sym_brace_expression] = STATE(867),
    [sym_anon_record_expression] = STATE(867),
    [sym_prefixed_expression] = STATE(867),
    [sym_typecast_expression] = STATE(867),
    [sym_for_expression] = STATE(867),
    [sym_while_expression] = STATE(867),
    [sym__if_branch] = STATE(6511),
    [sym_if_expression] = STATE(867),
    [sym_fun_expression] = STATE(867),
    [sym_try_expression] = STATE(867),
    [sym_match_expression] = STATE(867),
    [sym_function_expression] = STATE(867),
    [sym_mutate_expression] = STATE(867),
    [sym_index_expression] = STATE(867),
    [sym_typed_expression] = STATE(867),
    [sym_declaration_expression] = STATE(867),
    [sym_do_expression] = STATE(867),
    [sym_list_expression] = STATE(867),
    [sym_array_expression] = STATE(867),
    [sym_begin_end_expression] = STATE(867),
    [sym_paren_expression] = STATE(867),
    [sym__high_prec_app] = STATE(864),
    [sym__low_prec_app] = STATE(864),
    [sym_application_expression] = STATE(867),
    [sym_dot_expression] = STATE(867),
    [sym_infix_expression] = STATE(867),
    [sym_ce_expression] = STATE(867),
    [sym_sequential_expression] = STATE(867),
    [sym_char] = STATE(868),
    [sym_format_string] = STATE(869),
    [sym__string_literal] = STATE(869),
    [sym_string] = STATE(868),
    [sym_verbatim_string] = STATE(868),
    [sym_bytearray] = STATE(868),
    [sym_verbatim_bytearray] = STATE(868),
    [sym_format_triple_quoted_string] = STATE(870),
    [sym_triple_quoted_string] = STATE(868),
    [sym_const] = STATE(867),
    [sym_long_identifier] = STATE(872),
    [sym_active_pattern] = STATE(871),
    [sym__identifier_or_op] = STATE(873),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(658),
    [sym_sbyte] = STATE(868),
    [sym_byte] = STATE(868),
    [sym_int16] = STATE(868),
    [sym_uint16] = STATE(868),
    [sym_int32] = STATE(868),
    [sym_uint32] = STATE(868),
    [sym_nativeint] = STATE(868),
    [sym_unativeint] = STATE(868),
    [sym_int64] = STATE(868),
    [sym_uint64] = STATE(868),
    [sym_ieee32] = STATE(868),
    [sym_ieee64] = STATE(868),
    [sym_bignum] = STATE(868),
    [sym_decimal] = STATE(868),
    [sym_float] = STATE(860),
    [sym_block_comment] = STATE(540),
    [sym_compiler_directive_decl] = STATE(540),
    [sym_fsi_directive_decl] = STATE(540),
    [sym_preproc_line] = STATE(540),
    [sym_preproc_if_in_expression] = STATE(867),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(29),
    [anon_sym_return] = ACTIONS(37),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_null] = ACTIONS(49),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACK_PIPE] = ACTIONS(57),
    [anon_sym_LBRACE] = ACTIONS(1663),
    [anon_sym_LT_AT] = ACTIONS(61),
    [anon_sym_LT_AT_AT] = ACTIONS(1665),
    [anon_sym_LBRACE_PIPE] = ACTIONS(67),
    [anon_sym_new] = ACTIONS(37),
    [anon_sym_return_BANG] = ACTIONS(69),
    [anon_sym_yield] = ACTIONS(37),
    [anon_sym_yield_BANG] = ACTIONS(69),
    [anon_sym_lazy] = ACTIONS(37),
    [anon_sym_assert] = ACTIONS(37),
    [anon_sym_upcast] = ACTIONS(37),
    [anon_sym_downcast] = ACTIONS(37),
    [anon_sym_for] = ACTIONS(73),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(79),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_match] = ACTIONS(83),
    [anon_sym_match_BANG] = ACTIONS(85),
    [anon_sym_function] = ACTIONS(87),
    [anon_sym_use] = ACTIONS(95),
    [anon_sym_use_BANG] = ACTIONS(97),
    [anon_sym_do_BANG] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(101),
    [aux_sym_char_token1] = ACTIONS(105),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(107),
    [anon_sym_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DQUOTE] = ACTIONS(111),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(115),
    [sym_bool] = ACTIONS(117),
    [sym_unit] = ACTIONS(1673),
    [anon_sym_LPAREN_PIPE] = ACTIONS(121),
    [sym_op_identifier] = ACTIONS(1675),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(129),
    [sym_xint] = ACTIONS(131),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(135),
  },
  [541] = {
    [sym_function_or_value_defn] = STATE(600),
    [sym__expression] = STATE(313),
    [sym_literal_expression] = STATE(867),
    [sym_long_identifier_or_op] = STATE(867),
    [sym_tuple_expression] = STATE(867),
    [sym_brace_expression] = STATE(867),
    [sym_anon_record_expression] = STATE(867),
    [sym_prefixed_expression] = STATE(867),
    [sym_typecast_expression] = STATE(867),
    [sym_for_expression] = STATE(867),
    [sym_while_expression] = STATE(867),
    [sym__if_branch] = STATE(6511),
    [sym_if_expression] = STATE(867),
    [sym_fun_expression] = STATE(867),
    [sym_try_expression] = STATE(867),
    [sym_match_expression] = STATE(867),
    [sym_function_expression] = STATE(867),
    [sym_mutate_expression] = STATE(867),
    [sym_index_expression] = STATE(867),
    [sym_typed_expression] = STATE(867),
    [sym_declaration_expression] = STATE(867),
    [sym_do_expression] = STATE(867),
    [sym_list_expression] = STATE(867),
    [sym_array_expression] = STATE(867),
    [sym_begin_end_expression] = STATE(867),
    [sym_paren_expression] = STATE(867),
    [sym__high_prec_app] = STATE(864),
    [sym__low_prec_app] = STATE(864),
    [sym_application_expression] = STATE(867),
    [sym_dot_expression] = STATE(867),
    [sym_infix_expression] = STATE(867),
    [sym_ce_expression] = STATE(867),
    [sym_sequential_expression] = STATE(867),
    [sym_char] = STATE(868),
    [sym_format_string] = STATE(869),
    [sym__string_literal] = STATE(869),
    [sym_string] = STATE(868),
    [sym_verbatim_string] = STATE(868),
    [sym_bytearray] = STATE(868),
    [sym_verbatim_bytearray] = STATE(868),
    [sym_format_triple_quoted_string] = STATE(870),
    [sym_triple_quoted_string] = STATE(868),
    [sym_const] = STATE(867),
    [sym_long_identifier] = STATE(872),
    [sym_active_pattern] = STATE(871),
    [sym__identifier_or_op] = STATE(873),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(656),
    [sym_sbyte] = STATE(868),
    [sym_byte] = STATE(868),
    [sym_int16] = STATE(868),
    [sym_uint16] = STATE(868),
    [sym_int32] = STATE(868),
    [sym_uint32] = STATE(868),
    [sym_nativeint] = STATE(868),
    [sym_unativeint] = STATE(868),
    [sym_int64] = STATE(868),
    [sym_uint64] = STATE(868),
    [sym_ieee32] = STATE(868),
    [sym_ieee64] = STATE(868),
    [sym_bignum] = STATE(868),
    [sym_decimal] = STATE(868),
    [sym_float] = STATE(1368),
    [sym_block_comment] = STATE(541),
    [sym_compiler_directive_decl] = STATE(541),
    [sym_fsi_directive_decl] = STATE(541),
    [sym_preproc_line] = STATE(541),
    [sym_preproc_if_in_expression] = STATE(867),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(29),
    [anon_sym_return] = ACTIONS(825),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_null] = ACTIONS(49),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACK_PIPE] = ACTIONS(57),
    [anon_sym_LBRACE] = ACTIONS(1663),
    [anon_sym_LT_AT] = ACTIONS(61),
    [anon_sym_LT_AT_AT] = ACTIONS(1665),
    [anon_sym_LBRACE_PIPE] = ACTIONS(67),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_return_BANG] = ACTIONS(829),
    [anon_sym_yield] = ACTIONS(825),
    [anon_sym_yield_BANG] = ACTIONS(829),
    [anon_sym_lazy] = ACTIONS(825),
    [anon_sym_assert] = ACTIONS(825),
    [anon_sym_upcast] = ACTIONS(825),
    [anon_sym_downcast] = ACTIONS(825),
    [anon_sym_for] = ACTIONS(73),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(79),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_match] = ACTIONS(83),
    [anon_sym_match_BANG] = ACTIONS(85),
    [anon_sym_function] = ACTIONS(87),
    [anon_sym_use] = ACTIONS(833),
    [anon_sym_use_BANG] = ACTIONS(835),
    [anon_sym_do_BANG] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(101),
    [aux_sym_char_token1] = ACTIONS(105),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(107),
    [anon_sym_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DQUOTE] = ACTIONS(111),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(115),
    [sym_bool] = ACTIONS(117),
    [sym_unit] = ACTIONS(1673),
    [anon_sym_LPAREN_PIPE] = ACTIONS(121),
    [sym_op_identifier] = ACTIONS(1675),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(837),
    [sym_xint] = ACTIONS(387),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(135),
  },
  [542] = {
    [sym_function_or_value_defn] = STATE(535),
    [sym__expression] = STATE(37),
    [sym_literal_expression] = STATE(2008),
    [sym_long_identifier_or_op] = STATE(2008),
    [sym_tuple_expression] = STATE(2008),
    [sym_brace_expression] = STATE(2008),
    [sym_anon_record_expression] = STATE(2008),
    [sym_prefixed_expression] = STATE(2008),
    [sym_typecast_expression] = STATE(2008),
    [sym_for_expression] = STATE(2008),
    [sym_while_expression] = STATE(2008),
    [sym__if_branch] = STATE(6754),
    [sym_if_expression] = STATE(2008),
    [sym_fun_expression] = STATE(2008),
    [sym_try_expression] = STATE(2008),
    [sym_match_expression] = STATE(2008),
    [sym_function_expression] = STATE(2008),
    [sym_mutate_expression] = STATE(2008),
    [sym_index_expression] = STATE(2008),
    [sym_typed_expression] = STATE(2008),
    [sym_declaration_expression] = STATE(2008),
    [sym_do_expression] = STATE(2008),
    [sym_list_expression] = STATE(2008),
    [sym_array_expression] = STATE(2008),
    [sym_begin_end_expression] = STATE(2008),
    [sym_paren_expression] = STATE(2008),
    [sym__high_prec_app] = STATE(2007),
    [sym__low_prec_app] = STATE(2007),
    [sym_application_expression] = STATE(2008),
    [sym_dot_expression] = STATE(2008),
    [sym_infix_expression] = STATE(2008),
    [sym_ce_expression] = STATE(2008),
    [sym_sequential_expression] = STATE(2008),
    [sym_char] = STATE(1859),
    [sym_format_string] = STATE(1861),
    [sym__string_literal] = STATE(1861),
    [sym_string] = STATE(1859),
    [sym_verbatim_string] = STATE(1859),
    [sym_bytearray] = STATE(1859),
    [sym_verbatim_bytearray] = STATE(1859),
    [sym_format_triple_quoted_string] = STATE(1862),
    [sym_triple_quoted_string] = STATE(1859),
    [sym_const] = STATE(2008),
    [sym_long_identifier] = STATE(1701),
    [sym_active_pattern] = STATE(1702),
    [sym__identifier_or_op] = STATE(1724),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(664),
    [sym_sbyte] = STATE(1859),
    [sym_byte] = STATE(1859),
    [sym_int16] = STATE(1859),
    [sym_uint16] = STATE(1859),
    [sym_int32] = STATE(1859),
    [sym_uint32] = STATE(1859),
    [sym_nativeint] = STATE(1859),
    [sym_unativeint] = STATE(1859),
    [sym_int64] = STATE(1859),
    [sym_uint64] = STATE(1859),
    [sym_ieee32] = STATE(1859),
    [sym_ieee64] = STATE(1859),
    [sym_bignum] = STATE(1859),
    [sym_decimal] = STATE(1859),
    [sym_float] = STATE(1447),
    [sym_block_comment] = STATE(542),
    [sym_compiler_directive_decl] = STATE(542),
    [sym_fsi_directive_decl] = STATE(542),
    [sym_preproc_line] = STATE(542),
    [sym_preproc_if_in_expression] = STATE(2008),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(503),
    [anon_sym_return] = ACTIONS(507),
    [anon_sym_do] = ACTIONS(599),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(511),
    [anon_sym_null] = ACTIONS(515),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(517),
    [anon_sym_LBRACK_PIPE] = ACTIONS(519),
    [anon_sym_LBRACE] = ACTIONS(2060),
    [anon_sym_LT_AT] = ACTIONS(523),
    [anon_sym_LT_AT_AT] = ACTIONS(2062),
    [anon_sym_LBRACE_PIPE] = ACTIONS(529),
    [anon_sym_new] = ACTIONS(507),
    [anon_sym_return_BANG] = ACTIONS(531),
    [anon_sym_yield] = ACTIONS(507),
    [anon_sym_yield_BANG] = ACTIONS(531),
    [anon_sym_lazy] = ACTIONS(507),
    [anon_sym_assert] = ACTIONS(507),
    [anon_sym_upcast] = ACTIONS(507),
    [anon_sym_downcast] = ACTIONS(507),
    [anon_sym_for] = ACTIONS(535),
    [anon_sym_while] = ACTIONS(537),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(539),
    [anon_sym_try] = ACTIONS(543),
    [anon_sym_match] = ACTIONS(545),
    [anon_sym_match_BANG] = ACTIONS(547),
    [anon_sym_function] = ACTIONS(549),
    [anon_sym_use] = ACTIONS(557),
    [anon_sym_use_BANG] = ACTIONS(559),
    [anon_sym_do_BANG] = ACTIONS(561),
    [anon_sym_begin] = ACTIONS(565),
    [aux_sym_char_token1] = ACTIONS(569),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(571),
    [anon_sym_DQUOTE] = ACTIONS(573),
    [anon_sym_AT_DQUOTE] = ACTIONS(575),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(577),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(579),
    [sym_bool] = ACTIONS(581),
    [sym_unit] = ACTIONS(2064),
    [anon_sym_LPAREN_PIPE] = ACTIONS(585),
    [sym_op_identifier] = ACTIONS(2066),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(589),
    [sym_xint] = ACTIONS(591),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(593),
  },
  [543] = {
    [sym_function_or_value_defn] = STATE(535),
    [sym__expression] = STATE(99),
    [sym_literal_expression] = STATE(2008),
    [sym_long_identifier_or_op] = STATE(2008),
    [sym_tuple_expression] = STATE(2008),
    [sym_brace_expression] = STATE(2008),
    [sym_anon_record_expression] = STATE(2008),
    [sym_prefixed_expression] = STATE(2008),
    [sym_typecast_expression] = STATE(2008),
    [sym_for_expression] = STATE(2008),
    [sym_while_expression] = STATE(2008),
    [sym__if_branch] = STATE(6754),
    [sym_if_expression] = STATE(2008),
    [sym_fun_expression] = STATE(2008),
    [sym_try_expression] = STATE(2008),
    [sym_match_expression] = STATE(2008),
    [sym_function_expression] = STATE(2008),
    [sym_mutate_expression] = STATE(2008),
    [sym_index_expression] = STATE(2008),
    [sym_typed_expression] = STATE(2008),
    [sym_declaration_expression] = STATE(2008),
    [sym_do_expression] = STATE(2008),
    [sym_list_expression] = STATE(2008),
    [sym_array_expression] = STATE(2008),
    [sym_begin_end_expression] = STATE(2008),
    [sym_paren_expression] = STATE(2008),
    [sym__high_prec_app] = STATE(2007),
    [sym__low_prec_app] = STATE(2007),
    [sym_application_expression] = STATE(2008),
    [sym_dot_expression] = STATE(2008),
    [sym_infix_expression] = STATE(2008),
    [sym_ce_expression] = STATE(2008),
    [sym_sequential_expression] = STATE(2008),
    [sym_char] = STATE(1859),
    [sym_format_string] = STATE(1861),
    [sym__string_literal] = STATE(1861),
    [sym_string] = STATE(1859),
    [sym_verbatim_string] = STATE(1859),
    [sym_bytearray] = STATE(1859),
    [sym_verbatim_bytearray] = STATE(1859),
    [sym_format_triple_quoted_string] = STATE(1862),
    [sym_triple_quoted_string] = STATE(1859),
    [sym_const] = STATE(2008),
    [sym_long_identifier] = STATE(1701),
    [sym_active_pattern] = STATE(1702),
    [sym__identifier_or_op] = STATE(1724),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(664),
    [sym_sbyte] = STATE(1859),
    [sym_byte] = STATE(1859),
    [sym_int16] = STATE(1859),
    [sym_uint16] = STATE(1859),
    [sym_int32] = STATE(1859),
    [sym_uint32] = STATE(1859),
    [sym_nativeint] = STATE(1859),
    [sym_unativeint] = STATE(1859),
    [sym_int64] = STATE(1859),
    [sym_uint64] = STATE(1859),
    [sym_ieee32] = STATE(1859),
    [sym_ieee64] = STATE(1859),
    [sym_bignum] = STATE(1859),
    [sym_decimal] = STATE(1859),
    [sym_float] = STATE(1447),
    [sym_block_comment] = STATE(543),
    [sym_compiler_directive_decl] = STATE(543),
    [sym_fsi_directive_decl] = STATE(543),
    [sym_preproc_line] = STATE(543),
    [sym_preproc_if_in_expression] = STATE(2008),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(503),
    [anon_sym_return] = ACTIONS(507),
    [anon_sym_do] = ACTIONS(599),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(511),
    [anon_sym_null] = ACTIONS(515),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(517),
    [anon_sym_LBRACK_PIPE] = ACTIONS(519),
    [anon_sym_LBRACE] = ACTIONS(2060),
    [anon_sym_LT_AT] = ACTIONS(523),
    [anon_sym_LT_AT_AT] = ACTIONS(2062),
    [anon_sym_LBRACE_PIPE] = ACTIONS(529),
    [anon_sym_new] = ACTIONS(507),
    [anon_sym_return_BANG] = ACTIONS(531),
    [anon_sym_yield] = ACTIONS(507),
    [anon_sym_yield_BANG] = ACTIONS(531),
    [anon_sym_lazy] = ACTIONS(507),
    [anon_sym_assert] = ACTIONS(507),
    [anon_sym_upcast] = ACTIONS(507),
    [anon_sym_downcast] = ACTIONS(507),
    [anon_sym_for] = ACTIONS(535),
    [anon_sym_while] = ACTIONS(537),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(539),
    [anon_sym_try] = ACTIONS(543),
    [anon_sym_match] = ACTIONS(545),
    [anon_sym_match_BANG] = ACTIONS(547),
    [anon_sym_function] = ACTIONS(549),
    [anon_sym_use] = ACTIONS(557),
    [anon_sym_use_BANG] = ACTIONS(559),
    [anon_sym_do_BANG] = ACTIONS(561),
    [anon_sym_begin] = ACTIONS(565),
    [aux_sym_char_token1] = ACTIONS(569),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(571),
    [anon_sym_DQUOTE] = ACTIONS(573),
    [anon_sym_AT_DQUOTE] = ACTIONS(575),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(577),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(579),
    [sym_bool] = ACTIONS(581),
    [sym_unit] = ACTIONS(2064),
    [anon_sym_LPAREN_PIPE] = ACTIONS(585),
    [sym_op_identifier] = ACTIONS(2066),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(589),
    [sym_xint] = ACTIONS(591),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(593),
  },
  [544] = {
    [sym_function_or_value_defn] = STATE(600),
    [sym__expression] = STATE(187),
    [sym_literal_expression] = STATE(867),
    [sym_long_identifier_or_op] = STATE(867),
    [sym_tuple_expression] = STATE(867),
    [sym_brace_expression] = STATE(867),
    [sym_anon_record_expression] = STATE(867),
    [sym_prefixed_expression] = STATE(867),
    [sym_typecast_expression] = STATE(867),
    [sym_for_expression] = STATE(867),
    [sym_while_expression] = STATE(867),
    [sym__if_branch] = STATE(6511),
    [sym_if_expression] = STATE(867),
    [sym_fun_expression] = STATE(867),
    [sym_try_expression] = STATE(867),
    [sym_match_expression] = STATE(867),
    [sym_function_expression] = STATE(867),
    [sym_mutate_expression] = STATE(867),
    [sym_index_expression] = STATE(867),
    [sym_typed_expression] = STATE(867),
    [sym_declaration_expression] = STATE(867),
    [sym_do_expression] = STATE(867),
    [sym_list_expression] = STATE(867),
    [sym_array_expression] = STATE(867),
    [sym_begin_end_expression] = STATE(867),
    [sym_paren_expression] = STATE(867),
    [sym__high_prec_app] = STATE(864),
    [sym__low_prec_app] = STATE(864),
    [sym_application_expression] = STATE(867),
    [sym_dot_expression] = STATE(867),
    [sym_infix_expression] = STATE(867),
    [sym_ce_expression] = STATE(867),
    [sym_sequential_expression] = STATE(867),
    [sym_char] = STATE(868),
    [sym_format_string] = STATE(869),
    [sym__string_literal] = STATE(869),
    [sym_string] = STATE(868),
    [sym_verbatim_string] = STATE(868),
    [sym_bytearray] = STATE(868),
    [sym_verbatim_bytearray] = STATE(868),
    [sym_format_triple_quoted_string] = STATE(870),
    [sym_triple_quoted_string] = STATE(868),
    [sym_const] = STATE(867),
    [sym_long_identifier] = STATE(872),
    [sym_active_pattern] = STATE(871),
    [sym__identifier_or_op] = STATE(873),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(656),
    [sym_sbyte] = STATE(868),
    [sym_byte] = STATE(868),
    [sym_int16] = STATE(868),
    [sym_uint16] = STATE(868),
    [sym_int32] = STATE(868),
    [sym_uint32] = STATE(868),
    [sym_nativeint] = STATE(868),
    [sym_unativeint] = STATE(868),
    [sym_int64] = STATE(868),
    [sym_uint64] = STATE(868),
    [sym_ieee32] = STATE(868),
    [sym_ieee64] = STATE(868),
    [sym_bignum] = STATE(868),
    [sym_decimal] = STATE(868),
    [sym_float] = STATE(1368),
    [sym_block_comment] = STATE(544),
    [sym_compiler_directive_decl] = STATE(544),
    [sym_fsi_directive_decl] = STATE(544),
    [sym_preproc_line] = STATE(544),
    [sym_preproc_if_in_expression] = STATE(867),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(29),
    [anon_sym_return] = ACTIONS(825),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_null] = ACTIONS(49),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACK_PIPE] = ACTIONS(57),
    [anon_sym_LBRACE] = ACTIONS(1663),
    [anon_sym_LT_AT] = ACTIONS(61),
    [anon_sym_LT_AT_AT] = ACTIONS(1665),
    [anon_sym_LBRACE_PIPE] = ACTIONS(67),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_return_BANG] = ACTIONS(829),
    [anon_sym_yield] = ACTIONS(825),
    [anon_sym_yield_BANG] = ACTIONS(829),
    [anon_sym_lazy] = ACTIONS(825),
    [anon_sym_assert] = ACTIONS(825),
    [anon_sym_upcast] = ACTIONS(825),
    [anon_sym_downcast] = ACTIONS(825),
    [anon_sym_for] = ACTIONS(73),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(79),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_match] = ACTIONS(83),
    [anon_sym_match_BANG] = ACTIONS(85),
    [anon_sym_function] = ACTIONS(87),
    [anon_sym_use] = ACTIONS(833),
    [anon_sym_use_BANG] = ACTIONS(835),
    [anon_sym_do_BANG] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(101),
    [aux_sym_char_token1] = ACTIONS(105),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(107),
    [anon_sym_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DQUOTE] = ACTIONS(111),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(115),
    [sym_bool] = ACTIONS(117),
    [sym_unit] = ACTIONS(1673),
    [anon_sym_LPAREN_PIPE] = ACTIONS(121),
    [sym_op_identifier] = ACTIONS(1675),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(837),
    [sym_xint] = ACTIONS(387),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(135),
  },
  [545] = {
    [sym_function_or_value_defn] = STATE(535),
    [sym__expression] = STATE(68),
    [sym_literal_expression] = STATE(2008),
    [sym_long_identifier_or_op] = STATE(2008),
    [sym_tuple_expression] = STATE(2008),
    [sym_brace_expression] = STATE(2008),
    [sym_anon_record_expression] = STATE(2008),
    [sym_prefixed_expression] = STATE(2008),
    [sym_typecast_expression] = STATE(2008),
    [sym_for_expression] = STATE(2008),
    [sym_while_expression] = STATE(2008),
    [sym__if_branch] = STATE(6754),
    [sym_if_expression] = STATE(2008),
    [sym_fun_expression] = STATE(2008),
    [sym_try_expression] = STATE(2008),
    [sym_match_expression] = STATE(2008),
    [sym_function_expression] = STATE(2008),
    [sym_mutate_expression] = STATE(2008),
    [sym_index_expression] = STATE(2008),
    [sym_typed_expression] = STATE(2008),
    [sym_declaration_expression] = STATE(2008),
    [sym_do_expression] = STATE(2008),
    [sym_list_expression] = STATE(2008),
    [sym_array_expression] = STATE(2008),
    [sym_begin_end_expression] = STATE(2008),
    [sym_paren_expression] = STATE(2008),
    [sym__high_prec_app] = STATE(2007),
    [sym__low_prec_app] = STATE(2007),
    [sym_application_expression] = STATE(2008),
    [sym_dot_expression] = STATE(2008),
    [sym_infix_expression] = STATE(2008),
    [sym_ce_expression] = STATE(2008),
    [sym_sequential_expression] = STATE(2008),
    [sym_char] = STATE(1859),
    [sym_format_string] = STATE(1861),
    [sym__string_literal] = STATE(1861),
    [sym_string] = STATE(1859),
    [sym_verbatim_string] = STATE(1859),
    [sym_bytearray] = STATE(1859),
    [sym_verbatim_bytearray] = STATE(1859),
    [sym_format_triple_quoted_string] = STATE(1862),
    [sym_triple_quoted_string] = STATE(1859),
    [sym_const] = STATE(2008),
    [sym_long_identifier] = STATE(1701),
    [sym_active_pattern] = STATE(1702),
    [sym__identifier_or_op] = STATE(1724),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(664),
    [sym_sbyte] = STATE(1859),
    [sym_byte] = STATE(1859),
    [sym_int16] = STATE(1859),
    [sym_uint16] = STATE(1859),
    [sym_int32] = STATE(1859),
    [sym_uint32] = STATE(1859),
    [sym_nativeint] = STATE(1859),
    [sym_unativeint] = STATE(1859),
    [sym_int64] = STATE(1859),
    [sym_uint64] = STATE(1859),
    [sym_ieee32] = STATE(1859),
    [sym_ieee64] = STATE(1859),
    [sym_bignum] = STATE(1859),
    [sym_decimal] = STATE(1859),
    [sym_float] = STATE(1447),
    [sym_block_comment] = STATE(545),
    [sym_compiler_directive_decl] = STATE(545),
    [sym_fsi_directive_decl] = STATE(545),
    [sym_preproc_line] = STATE(545),
    [sym_preproc_if_in_expression] = STATE(2008),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(503),
    [anon_sym_return] = ACTIONS(507),
    [anon_sym_do] = ACTIONS(599),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(511),
    [anon_sym_null] = ACTIONS(515),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(517),
    [anon_sym_LBRACK_PIPE] = ACTIONS(519),
    [anon_sym_LBRACE] = ACTIONS(2060),
    [anon_sym_LT_AT] = ACTIONS(523),
    [anon_sym_LT_AT_AT] = ACTIONS(2062),
    [anon_sym_LBRACE_PIPE] = ACTIONS(529),
    [anon_sym_new] = ACTIONS(507),
    [anon_sym_return_BANG] = ACTIONS(531),
    [anon_sym_yield] = ACTIONS(507),
    [anon_sym_yield_BANG] = ACTIONS(531),
    [anon_sym_lazy] = ACTIONS(507),
    [anon_sym_assert] = ACTIONS(507),
    [anon_sym_upcast] = ACTIONS(507),
    [anon_sym_downcast] = ACTIONS(507),
    [anon_sym_for] = ACTIONS(535),
    [anon_sym_while] = ACTIONS(537),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(539),
    [anon_sym_try] = ACTIONS(543),
    [anon_sym_match] = ACTIONS(545),
    [anon_sym_match_BANG] = ACTIONS(547),
    [anon_sym_function] = ACTIONS(549),
    [anon_sym_use] = ACTIONS(557),
    [anon_sym_use_BANG] = ACTIONS(559),
    [anon_sym_do_BANG] = ACTIONS(561),
    [anon_sym_begin] = ACTIONS(565),
    [aux_sym_char_token1] = ACTIONS(569),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(571),
    [anon_sym_DQUOTE] = ACTIONS(573),
    [anon_sym_AT_DQUOTE] = ACTIONS(575),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(577),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(579),
    [sym_bool] = ACTIONS(581),
    [sym_unit] = ACTIONS(2064),
    [anon_sym_LPAREN_PIPE] = ACTIONS(585),
    [sym_op_identifier] = ACTIONS(2066),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(589),
    [sym_xint] = ACTIONS(591),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(593),
  },
  [546] = {
    [sym_function_or_value_defn] = STATE(535),
    [sym__expression] = STATE(74),
    [sym_literal_expression] = STATE(2008),
    [sym_long_identifier_or_op] = STATE(2008),
    [sym_tuple_expression] = STATE(2008),
    [sym_brace_expression] = STATE(2008),
    [sym_anon_record_expression] = STATE(2008),
    [sym_prefixed_expression] = STATE(2008),
    [sym_typecast_expression] = STATE(2008),
    [sym_for_expression] = STATE(2008),
    [sym_while_expression] = STATE(2008),
    [sym__if_branch] = STATE(6754),
    [sym_if_expression] = STATE(2008),
    [sym_fun_expression] = STATE(2008),
    [sym_try_expression] = STATE(2008),
    [sym_match_expression] = STATE(2008),
    [sym_function_expression] = STATE(2008),
    [sym_mutate_expression] = STATE(2008),
    [sym_index_expression] = STATE(2008),
    [sym_typed_expression] = STATE(2008),
    [sym_declaration_expression] = STATE(2008),
    [sym_do_expression] = STATE(2008),
    [sym_list_expression] = STATE(2008),
    [sym_array_expression] = STATE(2008),
    [sym_begin_end_expression] = STATE(2008),
    [sym_paren_expression] = STATE(2008),
    [sym__high_prec_app] = STATE(2007),
    [sym__low_prec_app] = STATE(2007),
    [sym_application_expression] = STATE(2008),
    [sym_dot_expression] = STATE(2008),
    [sym_infix_expression] = STATE(2008),
    [sym_ce_expression] = STATE(2008),
    [sym_sequential_expression] = STATE(2008),
    [sym_char] = STATE(1859),
    [sym_format_string] = STATE(1861),
    [sym__string_literal] = STATE(1861),
    [sym_string] = STATE(1859),
    [sym_verbatim_string] = STATE(1859),
    [sym_bytearray] = STATE(1859),
    [sym_verbatim_bytearray] = STATE(1859),
    [sym_format_triple_quoted_string] = STATE(1862),
    [sym_triple_quoted_string] = STATE(1859),
    [sym_const] = STATE(2008),
    [sym_long_identifier] = STATE(1701),
    [sym_active_pattern] = STATE(1702),
    [sym__identifier_or_op] = STATE(1724),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(664),
    [sym_sbyte] = STATE(1859),
    [sym_byte] = STATE(1859),
    [sym_int16] = STATE(1859),
    [sym_uint16] = STATE(1859),
    [sym_int32] = STATE(1859),
    [sym_uint32] = STATE(1859),
    [sym_nativeint] = STATE(1859),
    [sym_unativeint] = STATE(1859),
    [sym_int64] = STATE(1859),
    [sym_uint64] = STATE(1859),
    [sym_ieee32] = STATE(1859),
    [sym_ieee64] = STATE(1859),
    [sym_bignum] = STATE(1859),
    [sym_decimal] = STATE(1859),
    [sym_float] = STATE(1447),
    [sym_block_comment] = STATE(546),
    [sym_compiler_directive_decl] = STATE(546),
    [sym_fsi_directive_decl] = STATE(546),
    [sym_preproc_line] = STATE(546),
    [sym_preproc_if_in_expression] = STATE(2008),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(503),
    [anon_sym_return] = ACTIONS(507),
    [anon_sym_do] = ACTIONS(599),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(511),
    [anon_sym_null] = ACTIONS(515),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(517),
    [anon_sym_LBRACK_PIPE] = ACTIONS(519),
    [anon_sym_LBRACE] = ACTIONS(2060),
    [anon_sym_LT_AT] = ACTIONS(523),
    [anon_sym_LT_AT_AT] = ACTIONS(2062),
    [anon_sym_LBRACE_PIPE] = ACTIONS(529),
    [anon_sym_new] = ACTIONS(507),
    [anon_sym_return_BANG] = ACTIONS(531),
    [anon_sym_yield] = ACTIONS(507),
    [anon_sym_yield_BANG] = ACTIONS(531),
    [anon_sym_lazy] = ACTIONS(507),
    [anon_sym_assert] = ACTIONS(507),
    [anon_sym_upcast] = ACTIONS(507),
    [anon_sym_downcast] = ACTIONS(507),
    [anon_sym_for] = ACTIONS(535),
    [anon_sym_while] = ACTIONS(537),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(539),
    [anon_sym_try] = ACTIONS(543),
    [anon_sym_match] = ACTIONS(545),
    [anon_sym_match_BANG] = ACTIONS(547),
    [anon_sym_function] = ACTIONS(549),
    [anon_sym_use] = ACTIONS(557),
    [anon_sym_use_BANG] = ACTIONS(559),
    [anon_sym_do_BANG] = ACTIONS(561),
    [anon_sym_begin] = ACTIONS(565),
    [aux_sym_char_token1] = ACTIONS(569),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(571),
    [anon_sym_DQUOTE] = ACTIONS(573),
    [anon_sym_AT_DQUOTE] = ACTIONS(575),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(577),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(579),
    [sym_bool] = ACTIONS(581),
    [sym_unit] = ACTIONS(2064),
    [anon_sym_LPAREN_PIPE] = ACTIONS(585),
    [sym_op_identifier] = ACTIONS(2066),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(589),
    [sym_xint] = ACTIONS(591),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(593),
  },
  [547] = {
    [sym_function_or_value_defn] = STATE(627),
    [sym__expression] = STATE(344),
    [sym_literal_expression] = STATE(1118),
    [sym_long_identifier_or_op] = STATE(1118),
    [sym_tuple_expression] = STATE(1118),
    [sym_brace_expression] = STATE(1118),
    [sym_anon_record_expression] = STATE(1118),
    [sym_prefixed_expression] = STATE(1118),
    [sym_typecast_expression] = STATE(1118),
    [sym_for_expression] = STATE(1118),
    [sym_while_expression] = STATE(1118),
    [sym__if_branch] = STATE(7163),
    [sym_if_expression] = STATE(1118),
    [sym_fun_expression] = STATE(1118),
    [sym_try_expression] = STATE(1118),
    [sym_match_expression] = STATE(1118),
    [sym_function_expression] = STATE(1118),
    [sym_mutate_expression] = STATE(1118),
    [sym_index_expression] = STATE(1118),
    [sym_typed_expression] = STATE(1118),
    [sym_declaration_expression] = STATE(1118),
    [sym_do_expression] = STATE(1118),
    [sym_list_expression] = STATE(1118),
    [sym_array_expression] = STATE(1118),
    [sym_begin_end_expression] = STATE(1118),
    [sym_paren_expression] = STATE(1118),
    [sym__high_prec_app] = STATE(1133),
    [sym__low_prec_app] = STATE(1133),
    [sym_application_expression] = STATE(1118),
    [sym_dot_expression] = STATE(1118),
    [sym_infix_expression] = STATE(1118),
    [sym_ce_expression] = STATE(1118),
    [sym_sequential_expression] = STATE(1118),
    [sym_char] = STATE(1080),
    [sym_format_string] = STATE(1090),
    [sym__string_literal] = STATE(1090),
    [sym_string] = STATE(1080),
    [sym_verbatim_string] = STATE(1080),
    [sym_bytearray] = STATE(1080),
    [sym_verbatim_bytearray] = STATE(1080),
    [sym_format_triple_quoted_string] = STATE(1096),
    [sym_triple_quoted_string] = STATE(1080),
    [sym_const] = STATE(1118),
    [sym_long_identifier] = STATE(1156),
    [sym_active_pattern] = STATE(1085),
    [sym__identifier_or_op] = STATE(1099),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(517),
    [sym_sbyte] = STATE(1080),
    [sym_byte] = STATE(1080),
    [sym_int16] = STATE(1080),
    [sym_uint16] = STATE(1080),
    [sym_int32] = STATE(1080),
    [sym_uint32] = STATE(1080),
    [sym_nativeint] = STATE(1080),
    [sym_unativeint] = STATE(1080),
    [sym_int64] = STATE(1080),
    [sym_uint64] = STATE(1080),
    [sym_ieee32] = STATE(1080),
    [sym_ieee64] = STATE(1080),
    [sym_bignum] = STATE(1080),
    [sym_decimal] = STATE(1080),
    [sym_float] = STATE(979),
    [sym_block_comment] = STATE(547),
    [sym_compiler_directive_decl] = STATE(547),
    [sym_fsi_directive_decl] = STATE(547),
    [sym_preproc_line] = STATE(547),
    [sym_preproc_if_in_expression] = STATE(1118),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(195),
    [anon_sym_return] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_null] = ACTIONS(207),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(209),
    [anon_sym_LBRACK_PIPE] = ACTIONS(211),
    [anon_sym_LBRACE] = ACTIONS(1687),
    [anon_sym_LT_AT] = ACTIONS(213),
    [anon_sym_LT_AT_AT] = ACTIONS(1689),
    [anon_sym_LBRACE_PIPE] = ACTIONS(217),
    [anon_sym_new] = ACTIONS(199),
    [anon_sym_return_BANG] = ACTIONS(219),
    [anon_sym_yield] = ACTIONS(199),
    [anon_sym_yield_BANG] = ACTIONS(219),
    [anon_sym_lazy] = ACTIONS(199),
    [anon_sym_assert] = ACTIONS(199),
    [anon_sym_upcast] = ACTIONS(199),
    [anon_sym_downcast] = ACTIONS(199),
    [anon_sym_for] = ACTIONS(223),
    [anon_sym_while] = ACTIONS(225),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(229),
    [anon_sym_match] = ACTIONS(231),
    [anon_sym_match_BANG] = ACTIONS(233),
    [anon_sym_function] = ACTIONS(235),
    [anon_sym_use] = ACTIONS(239),
    [anon_sym_use_BANG] = ACTIONS(241),
    [anon_sym_do_BANG] = ACTIONS(243),
    [anon_sym_begin] = ACTIONS(245),
    [aux_sym_char_token1] = ACTIONS(247),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(251),
    [anon_sym_AT_DQUOTE] = ACTIONS(253),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(255),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(257),
    [sym_bool] = ACTIONS(259),
    [sym_unit] = ACTIONS(1699),
    [anon_sym_LPAREN_PIPE] = ACTIONS(261),
    [sym_op_identifier] = ACTIONS(1701),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(265),
    [sym_xint] = ACTIONS(267),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(269),
  },
  [548] = {
    [sym_function_or_value_defn] = STATE(663),
    [sym__expression] = STATE(79),
    [sym_literal_expression] = STATE(1118),
    [sym_long_identifier_or_op] = STATE(1118),
    [sym_tuple_expression] = STATE(1118),
    [sym_brace_expression] = STATE(1118),
    [sym_anon_record_expression] = STATE(1118),
    [sym_prefixed_expression] = STATE(1118),
    [sym_typecast_expression] = STATE(1118),
    [sym_for_expression] = STATE(1118),
    [sym_while_expression] = STATE(1118),
    [sym__if_branch] = STATE(7163),
    [sym_if_expression] = STATE(1118),
    [sym_fun_expression] = STATE(1118),
    [sym_try_expression] = STATE(1118),
    [sym_match_expression] = STATE(1118),
    [sym_function_expression] = STATE(1118),
    [sym_mutate_expression] = STATE(1118),
    [sym_index_expression] = STATE(1118),
    [sym_typed_expression] = STATE(1118),
    [sym_declaration_expression] = STATE(1118),
    [sym_do_expression] = STATE(1118),
    [sym_list_expression] = STATE(1118),
    [sym_array_expression] = STATE(1118),
    [sym_begin_end_expression] = STATE(1118),
    [sym_paren_expression] = STATE(1118),
    [sym__high_prec_app] = STATE(1133),
    [sym__low_prec_app] = STATE(1133),
    [sym_application_expression] = STATE(1118),
    [sym_dot_expression] = STATE(1118),
    [sym_infix_expression] = STATE(1118),
    [sym_ce_expression] = STATE(1118),
    [sym_sequential_expression] = STATE(1118),
    [sym_char] = STATE(1080),
    [sym_format_string] = STATE(1090),
    [sym__string_literal] = STATE(1090),
    [sym_string] = STATE(1080),
    [sym_verbatim_string] = STATE(1080),
    [sym_bytearray] = STATE(1080),
    [sym_verbatim_bytearray] = STATE(1080),
    [sym_format_triple_quoted_string] = STATE(1096),
    [sym_triple_quoted_string] = STATE(1080),
    [sym_const] = STATE(1118),
    [sym_long_identifier] = STATE(1156),
    [sym_active_pattern] = STATE(1085),
    [sym__identifier_or_op] = STATE(1099),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(548),
    [sym_sbyte] = STATE(1080),
    [sym_byte] = STATE(1080),
    [sym_int16] = STATE(1080),
    [sym_uint16] = STATE(1080),
    [sym_int32] = STATE(1080),
    [sym_uint32] = STATE(1080),
    [sym_nativeint] = STATE(1080),
    [sym_unativeint] = STATE(1080),
    [sym_int64] = STATE(1080),
    [sym_uint64] = STATE(1080),
    [sym_ieee32] = STATE(1080),
    [sym_ieee64] = STATE(1080),
    [sym_bignum] = STATE(1080),
    [sym_decimal] = STATE(1080),
    [sym_float] = STATE(979),
    [sym_block_comment] = STATE(548),
    [sym_compiler_directive_decl] = STATE(548),
    [sym_fsi_directive_decl] = STATE(548),
    [sym_preproc_line] = STATE(548),
    [sym_preproc_if_in_expression] = STATE(1118),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(195),
    [anon_sym_return] = ACTIONS(481),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_null] = ACTIONS(207),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(209),
    [anon_sym_LBRACK_PIPE] = ACTIONS(211),
    [anon_sym_LBRACE] = ACTIONS(1687),
    [anon_sym_LT_AT] = ACTIONS(213),
    [anon_sym_LT_AT_AT] = ACTIONS(1689),
    [anon_sym_LBRACE_PIPE] = ACTIONS(217),
    [anon_sym_new] = ACTIONS(481),
    [anon_sym_return_BANG] = ACTIONS(487),
    [anon_sym_yield] = ACTIONS(481),
    [anon_sym_yield_BANG] = ACTIONS(487),
    [anon_sym_lazy] = ACTIONS(481),
    [anon_sym_assert] = ACTIONS(481),
    [anon_sym_upcast] = ACTIONS(481),
    [anon_sym_downcast] = ACTIONS(481),
    [anon_sym_for] = ACTIONS(489),
    [anon_sym_while] = ACTIONS(225),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(229),
    [anon_sym_match] = ACTIONS(231),
    [anon_sym_match_BANG] = ACTIONS(233),
    [anon_sym_function] = ACTIONS(235),
    [anon_sym_use] = ACTIONS(493),
    [anon_sym_use_BANG] = ACTIONS(495),
    [anon_sym_do_BANG] = ACTIONS(243),
    [anon_sym_begin] = ACTIONS(245),
    [aux_sym_char_token1] = ACTIONS(247),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(251),
    [anon_sym_AT_DQUOTE] = ACTIONS(253),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(255),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(257),
    [sym_bool] = ACTIONS(259),
    [sym_unit] = ACTIONS(1699),
    [anon_sym_LPAREN_PIPE] = ACTIONS(261),
    [sym_op_identifier] = ACTIONS(1701),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(499),
    [sym_xint] = ACTIONS(267),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(269),
  },
  [549] = {
    [sym_function_or_value_defn] = STATE(703),
    [sym__expression] = STATE(119),
    [sym_literal_expression] = STATE(1797),
    [sym_long_identifier_or_op] = STATE(1797),
    [sym_tuple_expression] = STATE(1797),
    [sym_brace_expression] = STATE(1797),
    [sym_anon_record_expression] = STATE(1797),
    [sym_prefixed_expression] = STATE(1797),
    [sym_typecast_expression] = STATE(1797),
    [sym_for_expression] = STATE(1797),
    [sym_while_expression] = STATE(1797),
    [sym__if_branch] = STATE(6611),
    [sym_if_expression] = STATE(1797),
    [sym_fun_expression] = STATE(1797),
    [sym_try_expression] = STATE(1797),
    [sym_match_expression] = STATE(1797),
    [sym_function_expression] = STATE(1797),
    [sym_mutate_expression] = STATE(1797),
    [sym_index_expression] = STATE(1797),
    [sym_typed_expression] = STATE(1797),
    [sym_declaration_expression] = STATE(1797),
    [sym_do_expression] = STATE(1797),
    [sym_list_expression] = STATE(1797),
    [sym_array_expression] = STATE(1797),
    [sym_begin_end_expression] = STATE(1797),
    [sym_paren_expression] = STATE(1797),
    [sym__high_prec_app] = STATE(1800),
    [sym__low_prec_app] = STATE(1800),
    [sym_application_expression] = STATE(1797),
    [sym_dot_expression] = STATE(1797),
    [sym_infix_expression] = STATE(1797),
    [sym_ce_expression] = STATE(1797),
    [sym_sequential_expression] = STATE(1797),
    [sym_char] = STATE(1694),
    [sym_format_string] = STATE(1693),
    [sym__string_literal] = STATE(1693),
    [sym_string] = STATE(1694),
    [sym_verbatim_string] = STATE(1694),
    [sym_bytearray] = STATE(1694),
    [sym_verbatim_bytearray] = STATE(1694),
    [sym_format_triple_quoted_string] = STATE(1692),
    [sym_triple_quoted_string] = STATE(1694),
    [sym_const] = STATE(1797),
    [sym_long_identifier] = STATE(1813),
    [sym_active_pattern] = STATE(1753),
    [sym__identifier_or_op] = STATE(1812),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(756),
    [sym_sbyte] = STATE(1694),
    [sym_byte] = STATE(1694),
    [sym_int16] = STATE(1694),
    [sym_uint16] = STATE(1694),
    [sym_int32] = STATE(1694),
    [sym_uint32] = STATE(1694),
    [sym_nativeint] = STATE(1694),
    [sym_unativeint] = STATE(1694),
    [sym_int64] = STATE(1694),
    [sym_uint64] = STATE(1694),
    [sym_ieee32] = STATE(1694),
    [sym_ieee64] = STATE(1694),
    [sym_bignum] = STATE(1694),
    [sym_decimal] = STATE(1694),
    [sym_float] = STATE(1425),
    [sym_block_comment] = STATE(549),
    [sym_compiler_directive_decl] = STATE(549),
    [sym_fsi_directive_decl] = STATE(549),
    [sym_preproc_line] = STATE(549),
    [sym_preproc_if_in_expression] = STATE(1797),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(393),
    [anon_sym_return] = ACTIONS(397),
    [anon_sym_do] = ACTIONS(399),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(401),
    [anon_sym_null] = ACTIONS(405),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(407),
    [anon_sym_LBRACK_PIPE] = ACTIONS(409),
    [anon_sym_LBRACE] = ACTIONS(2146),
    [anon_sym_LT_AT] = ACTIONS(413),
    [anon_sym_LT_AT_AT] = ACTIONS(2148),
    [anon_sym_LBRACE_PIPE] = ACTIONS(419),
    [anon_sym_new] = ACTIONS(397),
    [anon_sym_return_BANG] = ACTIONS(421),
    [anon_sym_yield] = ACTIONS(397),
    [anon_sym_yield_BANG] = ACTIONS(421),
    [anon_sym_lazy] = ACTIONS(397),
    [anon_sym_assert] = ACTIONS(397),
    [anon_sym_upcast] = ACTIONS(397),
    [anon_sym_downcast] = ACTIONS(397),
    [anon_sym_for] = ACTIONS(425),
    [anon_sym_while] = ACTIONS(427),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(429),
    [anon_sym_try] = ACTIONS(431),
    [anon_sym_match] = ACTIONS(433),
    [anon_sym_match_BANG] = ACTIONS(435),
    [anon_sym_function] = ACTIONS(437),
    [anon_sym_use] = ACTIONS(445),
    [anon_sym_use_BANG] = ACTIONS(447),
    [anon_sym_do_BANG] = ACTIONS(449),
    [anon_sym_begin] = ACTIONS(451),
    [aux_sym_char_token1] = ACTIONS(455),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(457),
    [anon_sym_DQUOTE] = ACTIONS(459),
    [anon_sym_AT_DQUOTE] = ACTIONS(461),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(463),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(465),
    [sym_bool] = ACTIONS(467),
    [sym_unit] = ACTIONS(2150),
    [anon_sym_LPAREN_PIPE] = ACTIONS(471),
    [sym_op_identifier] = ACTIONS(2152),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(475),
    [sym_xint] = ACTIONS(477),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(479),
  },
  [550] = {
    [sym_function_or_value_defn] = STATE(600),
    [sym__expression] = STATE(177),
    [sym_literal_expression] = STATE(867),
    [sym_long_identifier_or_op] = STATE(867),
    [sym_tuple_expression] = STATE(867),
    [sym_brace_expression] = STATE(867),
    [sym_anon_record_expression] = STATE(867),
    [sym_prefixed_expression] = STATE(867),
    [sym_typecast_expression] = STATE(867),
    [sym_for_expression] = STATE(867),
    [sym_while_expression] = STATE(867),
    [sym__if_branch] = STATE(6511),
    [sym_if_expression] = STATE(867),
    [sym_fun_expression] = STATE(867),
    [sym_try_expression] = STATE(867),
    [sym_match_expression] = STATE(867),
    [sym_function_expression] = STATE(867),
    [sym_mutate_expression] = STATE(867),
    [sym_index_expression] = STATE(867),
    [sym_typed_expression] = STATE(867),
    [sym_declaration_expression] = STATE(867),
    [sym_do_expression] = STATE(867),
    [sym_list_expression] = STATE(867),
    [sym_array_expression] = STATE(867),
    [sym_begin_end_expression] = STATE(867),
    [sym_paren_expression] = STATE(867),
    [sym__high_prec_app] = STATE(864),
    [sym__low_prec_app] = STATE(864),
    [sym_application_expression] = STATE(867),
    [sym_dot_expression] = STATE(867),
    [sym_infix_expression] = STATE(867),
    [sym_ce_expression] = STATE(867),
    [sym_sequential_expression] = STATE(867),
    [sym_char] = STATE(868),
    [sym_format_string] = STATE(869),
    [sym__string_literal] = STATE(869),
    [sym_string] = STATE(868),
    [sym_verbatim_string] = STATE(868),
    [sym_bytearray] = STATE(868),
    [sym_verbatim_bytearray] = STATE(868),
    [sym_format_triple_quoted_string] = STATE(870),
    [sym_triple_quoted_string] = STATE(868),
    [sym_const] = STATE(867),
    [sym_long_identifier] = STATE(872),
    [sym_active_pattern] = STATE(871),
    [sym__identifier_or_op] = STATE(873),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(656),
    [sym_sbyte] = STATE(868),
    [sym_byte] = STATE(868),
    [sym_int16] = STATE(868),
    [sym_uint16] = STATE(868),
    [sym_int32] = STATE(868),
    [sym_uint32] = STATE(868),
    [sym_nativeint] = STATE(868),
    [sym_unativeint] = STATE(868),
    [sym_int64] = STATE(868),
    [sym_uint64] = STATE(868),
    [sym_ieee32] = STATE(868),
    [sym_ieee64] = STATE(868),
    [sym_bignum] = STATE(868),
    [sym_decimal] = STATE(868),
    [sym_float] = STATE(1368),
    [sym_block_comment] = STATE(550),
    [sym_compiler_directive_decl] = STATE(550),
    [sym_fsi_directive_decl] = STATE(550),
    [sym_preproc_line] = STATE(550),
    [sym_preproc_if_in_expression] = STATE(867),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(29),
    [anon_sym_return] = ACTIONS(825),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_null] = ACTIONS(49),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACK_PIPE] = ACTIONS(57),
    [anon_sym_LBRACE] = ACTIONS(1663),
    [anon_sym_LT_AT] = ACTIONS(61),
    [anon_sym_LT_AT_AT] = ACTIONS(1665),
    [anon_sym_LBRACE_PIPE] = ACTIONS(67),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_return_BANG] = ACTIONS(829),
    [anon_sym_yield] = ACTIONS(825),
    [anon_sym_yield_BANG] = ACTIONS(829),
    [anon_sym_lazy] = ACTIONS(825),
    [anon_sym_assert] = ACTIONS(825),
    [anon_sym_upcast] = ACTIONS(825),
    [anon_sym_downcast] = ACTIONS(825),
    [anon_sym_for] = ACTIONS(73),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(79),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_match] = ACTIONS(83),
    [anon_sym_match_BANG] = ACTIONS(85),
    [anon_sym_function] = ACTIONS(87),
    [anon_sym_use] = ACTIONS(833),
    [anon_sym_use_BANG] = ACTIONS(835),
    [anon_sym_do_BANG] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(101),
    [aux_sym_char_token1] = ACTIONS(105),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(107),
    [anon_sym_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DQUOTE] = ACTIONS(111),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(115),
    [sym_bool] = ACTIONS(117),
    [sym_unit] = ACTIONS(1673),
    [anon_sym_LPAREN_PIPE] = ACTIONS(121),
    [sym_op_identifier] = ACTIONS(1675),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(837),
    [sym_xint] = ACTIONS(387),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(135),
  },
  [551] = {
    [sym_function_or_value_defn] = STATE(705),
    [sym__expression] = STATE(11),
    [sym_literal_expression] = STATE(867),
    [sym_long_identifier_or_op] = STATE(867),
    [sym_tuple_expression] = STATE(867),
    [sym_brace_expression] = STATE(867),
    [sym_anon_record_expression] = STATE(867),
    [sym_prefixed_expression] = STATE(867),
    [sym_typecast_expression] = STATE(867),
    [sym_for_expression] = STATE(867),
    [sym_while_expression] = STATE(867),
    [sym__if_branch] = STATE(6511),
    [sym_if_expression] = STATE(867),
    [sym_fun_expression] = STATE(867),
    [sym_try_expression] = STATE(867),
    [sym_match_expression] = STATE(867),
    [sym_function_expression] = STATE(867),
    [sym_mutate_expression] = STATE(867),
    [sym_index_expression] = STATE(867),
    [sym_typed_expression] = STATE(867),
    [sym_declaration_expression] = STATE(867),
    [sym_do_expression] = STATE(867),
    [sym_list_expression] = STATE(867),
    [sym_array_expression] = STATE(867),
    [sym_begin_end_expression] = STATE(867),
    [sym_paren_expression] = STATE(867),
    [sym__high_prec_app] = STATE(864),
    [sym__low_prec_app] = STATE(864),
    [sym_application_expression] = STATE(867),
    [sym_dot_expression] = STATE(867),
    [sym_infix_expression] = STATE(867),
    [sym_ce_expression] = STATE(867),
    [sym_sequential_expression] = STATE(867),
    [sym_char] = STATE(868),
    [sym_format_string] = STATE(869),
    [sym__string_literal] = STATE(869),
    [sym_string] = STATE(868),
    [sym_verbatim_string] = STATE(868),
    [sym_bytearray] = STATE(868),
    [sym_verbatim_bytearray] = STATE(868),
    [sym_format_triple_quoted_string] = STATE(870),
    [sym_triple_quoted_string] = STATE(868),
    [sym_const] = STATE(867),
    [sym_long_identifier] = STATE(872),
    [sym_active_pattern] = STATE(871),
    [sym__identifier_or_op] = STATE(873),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(658),
    [sym_sbyte] = STATE(868),
    [sym_byte] = STATE(868),
    [sym_int16] = STATE(868),
    [sym_uint16] = STATE(868),
    [sym_int32] = STATE(868),
    [sym_uint32] = STATE(868),
    [sym_nativeint] = STATE(868),
    [sym_unativeint] = STATE(868),
    [sym_int64] = STATE(868),
    [sym_uint64] = STATE(868),
    [sym_ieee32] = STATE(868),
    [sym_ieee64] = STATE(868),
    [sym_bignum] = STATE(868),
    [sym_decimal] = STATE(868),
    [sym_float] = STATE(860),
    [sym_block_comment] = STATE(551),
    [sym_compiler_directive_decl] = STATE(551),
    [sym_fsi_directive_decl] = STATE(551),
    [sym_preproc_line] = STATE(551),
    [sym_preproc_if_in_expression] = STATE(867),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(29),
    [anon_sym_return] = ACTIONS(37),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_null] = ACTIONS(49),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACK_PIPE] = ACTIONS(57),
    [anon_sym_LBRACE] = ACTIONS(1663),
    [anon_sym_LT_AT] = ACTIONS(61),
    [anon_sym_LT_AT_AT] = ACTIONS(1665),
    [anon_sym_LBRACE_PIPE] = ACTIONS(67),
    [anon_sym_new] = ACTIONS(37),
    [anon_sym_return_BANG] = ACTIONS(69),
    [anon_sym_yield] = ACTIONS(37),
    [anon_sym_yield_BANG] = ACTIONS(69),
    [anon_sym_lazy] = ACTIONS(37),
    [anon_sym_assert] = ACTIONS(37),
    [anon_sym_upcast] = ACTIONS(37),
    [anon_sym_downcast] = ACTIONS(37),
    [anon_sym_for] = ACTIONS(73),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(79),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_match] = ACTIONS(83),
    [anon_sym_match_BANG] = ACTIONS(85),
    [anon_sym_function] = ACTIONS(87),
    [anon_sym_use] = ACTIONS(95),
    [anon_sym_use_BANG] = ACTIONS(97),
    [anon_sym_do_BANG] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(101),
    [aux_sym_char_token1] = ACTIONS(105),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(107),
    [anon_sym_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DQUOTE] = ACTIONS(111),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(115),
    [sym_bool] = ACTIONS(117),
    [sym_unit] = ACTIONS(1673),
    [anon_sym_LPAREN_PIPE] = ACTIONS(121),
    [sym_op_identifier] = ACTIONS(1675),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(129),
    [sym_xint] = ACTIONS(131),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(135),
  },
  [552] = {
    [sym_function_or_value_defn] = STATE(600),
    [sym__expression] = STATE(221),
    [sym_literal_expression] = STATE(867),
    [sym_long_identifier_or_op] = STATE(867),
    [sym_tuple_expression] = STATE(867),
    [sym_brace_expression] = STATE(867),
    [sym_anon_record_expression] = STATE(867),
    [sym_prefixed_expression] = STATE(867),
    [sym_typecast_expression] = STATE(867),
    [sym_for_expression] = STATE(867),
    [sym_while_expression] = STATE(867),
    [sym__if_branch] = STATE(6511),
    [sym_if_expression] = STATE(867),
    [sym_fun_expression] = STATE(867),
    [sym_try_expression] = STATE(867),
    [sym_match_expression] = STATE(867),
    [sym_function_expression] = STATE(867),
    [sym_mutate_expression] = STATE(867),
    [sym_index_expression] = STATE(867),
    [sym_typed_expression] = STATE(867),
    [sym_declaration_expression] = STATE(867),
    [sym_do_expression] = STATE(867),
    [sym_list_expression] = STATE(867),
    [sym_array_expression] = STATE(867),
    [sym_begin_end_expression] = STATE(867),
    [sym_paren_expression] = STATE(867),
    [sym__high_prec_app] = STATE(864),
    [sym__low_prec_app] = STATE(864),
    [sym_application_expression] = STATE(867),
    [sym_dot_expression] = STATE(867),
    [sym_infix_expression] = STATE(867),
    [sym_ce_expression] = STATE(867),
    [sym_sequential_expression] = STATE(867),
    [sym_char] = STATE(868),
    [sym_format_string] = STATE(869),
    [sym__string_literal] = STATE(869),
    [sym_string] = STATE(868),
    [sym_verbatim_string] = STATE(868),
    [sym_bytearray] = STATE(868),
    [sym_verbatim_bytearray] = STATE(868),
    [sym_format_triple_quoted_string] = STATE(870),
    [sym_triple_quoted_string] = STATE(868),
    [sym_const] = STATE(867),
    [sym_long_identifier] = STATE(872),
    [sym_active_pattern] = STATE(871),
    [sym__identifier_or_op] = STATE(873),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(656),
    [sym_sbyte] = STATE(868),
    [sym_byte] = STATE(868),
    [sym_int16] = STATE(868),
    [sym_uint16] = STATE(868),
    [sym_int32] = STATE(868),
    [sym_uint32] = STATE(868),
    [sym_nativeint] = STATE(868),
    [sym_unativeint] = STATE(868),
    [sym_int64] = STATE(868),
    [sym_uint64] = STATE(868),
    [sym_ieee32] = STATE(868),
    [sym_ieee64] = STATE(868),
    [sym_bignum] = STATE(868),
    [sym_decimal] = STATE(868),
    [sym_float] = STATE(1368),
    [sym_block_comment] = STATE(552),
    [sym_compiler_directive_decl] = STATE(552),
    [sym_fsi_directive_decl] = STATE(552),
    [sym_preproc_line] = STATE(552),
    [sym_preproc_if_in_expression] = STATE(867),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(29),
    [anon_sym_return] = ACTIONS(825),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_null] = ACTIONS(49),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACK_PIPE] = ACTIONS(57),
    [anon_sym_LBRACE] = ACTIONS(1663),
    [anon_sym_LT_AT] = ACTIONS(61),
    [anon_sym_LT_AT_AT] = ACTIONS(1665),
    [anon_sym_LBRACE_PIPE] = ACTIONS(67),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_return_BANG] = ACTIONS(829),
    [anon_sym_yield] = ACTIONS(825),
    [anon_sym_yield_BANG] = ACTIONS(829),
    [anon_sym_lazy] = ACTIONS(825),
    [anon_sym_assert] = ACTIONS(825),
    [anon_sym_upcast] = ACTIONS(825),
    [anon_sym_downcast] = ACTIONS(825),
    [anon_sym_for] = ACTIONS(73),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(79),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_match] = ACTIONS(83),
    [anon_sym_match_BANG] = ACTIONS(85),
    [anon_sym_function] = ACTIONS(87),
    [anon_sym_use] = ACTIONS(833),
    [anon_sym_use_BANG] = ACTIONS(835),
    [anon_sym_do_BANG] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(101),
    [aux_sym_char_token1] = ACTIONS(105),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(107),
    [anon_sym_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DQUOTE] = ACTIONS(111),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(115),
    [sym_bool] = ACTIONS(117),
    [sym_unit] = ACTIONS(1673),
    [anon_sym_LPAREN_PIPE] = ACTIONS(121),
    [sym_op_identifier] = ACTIONS(1675),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(837),
    [sym_xint] = ACTIONS(387),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(135),
  },
  [553] = {
    [sym_function_or_value_defn] = STATE(600),
    [sym__expression] = STATE(222),
    [sym_literal_expression] = STATE(867),
    [sym_long_identifier_or_op] = STATE(867),
    [sym_tuple_expression] = STATE(867),
    [sym_brace_expression] = STATE(867),
    [sym_anon_record_expression] = STATE(867),
    [sym_prefixed_expression] = STATE(867),
    [sym_typecast_expression] = STATE(867),
    [sym_for_expression] = STATE(867),
    [sym_while_expression] = STATE(867),
    [sym__if_branch] = STATE(6511),
    [sym_if_expression] = STATE(867),
    [sym_fun_expression] = STATE(867),
    [sym_try_expression] = STATE(867),
    [sym_match_expression] = STATE(867),
    [sym_function_expression] = STATE(867),
    [sym_mutate_expression] = STATE(867),
    [sym_index_expression] = STATE(867),
    [sym_typed_expression] = STATE(867),
    [sym_declaration_expression] = STATE(867),
    [sym_do_expression] = STATE(867),
    [sym_list_expression] = STATE(867),
    [sym_array_expression] = STATE(867),
    [sym_begin_end_expression] = STATE(867),
    [sym_paren_expression] = STATE(867),
    [sym__high_prec_app] = STATE(864),
    [sym__low_prec_app] = STATE(864),
    [sym_application_expression] = STATE(867),
    [sym_dot_expression] = STATE(867),
    [sym_infix_expression] = STATE(867),
    [sym_ce_expression] = STATE(867),
    [sym_sequential_expression] = STATE(867),
    [sym_char] = STATE(868),
    [sym_format_string] = STATE(869),
    [sym__string_literal] = STATE(869),
    [sym_string] = STATE(868),
    [sym_verbatim_string] = STATE(868),
    [sym_bytearray] = STATE(868),
    [sym_verbatim_bytearray] = STATE(868),
    [sym_format_triple_quoted_string] = STATE(870),
    [sym_triple_quoted_string] = STATE(868),
    [sym_const] = STATE(867),
    [sym_long_identifier] = STATE(872),
    [sym_active_pattern] = STATE(871),
    [sym__identifier_or_op] = STATE(873),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(656),
    [sym_sbyte] = STATE(868),
    [sym_byte] = STATE(868),
    [sym_int16] = STATE(868),
    [sym_uint16] = STATE(868),
    [sym_int32] = STATE(868),
    [sym_uint32] = STATE(868),
    [sym_nativeint] = STATE(868),
    [sym_unativeint] = STATE(868),
    [sym_int64] = STATE(868),
    [sym_uint64] = STATE(868),
    [sym_ieee32] = STATE(868),
    [sym_ieee64] = STATE(868),
    [sym_bignum] = STATE(868),
    [sym_decimal] = STATE(868),
    [sym_float] = STATE(1368),
    [sym_block_comment] = STATE(553),
    [sym_compiler_directive_decl] = STATE(553),
    [sym_fsi_directive_decl] = STATE(553),
    [sym_preproc_line] = STATE(553),
    [sym_preproc_if_in_expression] = STATE(867),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(29),
    [anon_sym_return] = ACTIONS(825),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_null] = ACTIONS(49),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACK_PIPE] = ACTIONS(57),
    [anon_sym_LBRACE] = ACTIONS(1663),
    [anon_sym_LT_AT] = ACTIONS(61),
    [anon_sym_LT_AT_AT] = ACTIONS(1665),
    [anon_sym_LBRACE_PIPE] = ACTIONS(67),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_return_BANG] = ACTIONS(829),
    [anon_sym_yield] = ACTIONS(825),
    [anon_sym_yield_BANG] = ACTIONS(829),
    [anon_sym_lazy] = ACTIONS(825),
    [anon_sym_assert] = ACTIONS(825),
    [anon_sym_upcast] = ACTIONS(825),
    [anon_sym_downcast] = ACTIONS(825),
    [anon_sym_for] = ACTIONS(73),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(79),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_match] = ACTIONS(83),
    [anon_sym_match_BANG] = ACTIONS(85),
    [anon_sym_function] = ACTIONS(87),
    [anon_sym_use] = ACTIONS(833),
    [anon_sym_use_BANG] = ACTIONS(835),
    [anon_sym_do_BANG] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(101),
    [aux_sym_char_token1] = ACTIONS(105),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(107),
    [anon_sym_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DQUOTE] = ACTIONS(111),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(115),
    [sym_bool] = ACTIONS(117),
    [sym_unit] = ACTIONS(1673),
    [anon_sym_LPAREN_PIPE] = ACTIONS(121),
    [sym_op_identifier] = ACTIONS(1675),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(837),
    [sym_xint] = ACTIONS(387),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(135),
  },
  [554] = {
    [sym_function_or_value_defn] = STATE(630),
    [sym__expression] = STATE(188),
    [sym_literal_expression] = STATE(2380),
    [sym_long_identifier_or_op] = STATE(2380),
    [sym_tuple_expression] = STATE(2380),
    [sym_brace_expression] = STATE(2380),
    [sym_anon_record_expression] = STATE(2380),
    [sym_prefixed_expression] = STATE(2380),
    [sym_typecast_expression] = STATE(2380),
    [sym_for_expression] = STATE(2380),
    [sym_while_expression] = STATE(2380),
    [sym__if_branch] = STATE(6456),
    [sym_if_expression] = STATE(2380),
    [sym_fun_expression] = STATE(2380),
    [sym_try_expression] = STATE(2380),
    [sym_match_expression] = STATE(2380),
    [sym_function_expression] = STATE(2380),
    [sym_mutate_expression] = STATE(2380),
    [sym_index_expression] = STATE(2380),
    [sym_typed_expression] = STATE(2380),
    [sym_declaration_expression] = STATE(2380),
    [sym_do_expression] = STATE(2380),
    [sym_list_expression] = STATE(2380),
    [sym_array_expression] = STATE(2380),
    [sym_begin_end_expression] = STATE(2380),
    [sym_paren_expression] = STATE(2380),
    [sym__high_prec_app] = STATE(2383),
    [sym__low_prec_app] = STATE(2383),
    [sym_application_expression] = STATE(2380),
    [sym_dot_expression] = STATE(2380),
    [sym_infix_expression] = STATE(2380),
    [sym_ce_expression] = STATE(2380),
    [sym_sequential_expression] = STATE(2380),
    [sym_char] = STATE(2261),
    [sym_format_string] = STATE(2274),
    [sym__string_literal] = STATE(2274),
    [sym_string] = STATE(2261),
    [sym_verbatim_string] = STATE(2261),
    [sym_bytearray] = STATE(2261),
    [sym_verbatim_bytearray] = STATE(2261),
    [sym_format_triple_quoted_string] = STATE(2275),
    [sym_triple_quoted_string] = STATE(2261),
    [sym_const] = STATE(2380),
    [sym_long_identifier] = STATE(2391),
    [sym_active_pattern] = STATE(2470),
    [sym__identifier_or_op] = STATE(2390),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(632),
    [sym_sbyte] = STATE(2261),
    [sym_byte] = STATE(2261),
    [sym_int16] = STATE(2261),
    [sym_uint16] = STATE(2261),
    [sym_int32] = STATE(2261),
    [sym_uint32] = STATE(2261),
    [sym_nativeint] = STATE(2261),
    [sym_unativeint] = STATE(2261),
    [sym_int64] = STATE(2261),
    [sym_uint64] = STATE(2261),
    [sym_ieee32] = STATE(2261),
    [sym_ieee64] = STATE(2261),
    [sym_bignum] = STATE(2261),
    [sym_decimal] = STATE(2261),
    [sym_float] = STATE(1614),
    [sym_block_comment] = STATE(554),
    [sym_compiler_directive_decl] = STATE(554),
    [sym_fsi_directive_decl] = STATE(554),
    [sym_preproc_line] = STATE(554),
    [sym_preproc_if_in_expression] = STATE(2380),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(1081),
    [anon_sym_return] = ACTIONS(1085),
    [anon_sym_do] = ACTIONS(1087),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(1089),
    [anon_sym_null] = ACTIONS(1093),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1095),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1097),
    [anon_sym_LBRACE] = ACTIONS(2100),
    [anon_sym_LT_AT] = ACTIONS(1101),
    [anon_sym_LT_AT_AT] = ACTIONS(2102),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1107),
    [anon_sym_new] = ACTIONS(1085),
    [anon_sym_return_BANG] = ACTIONS(1109),
    [anon_sym_yield] = ACTIONS(1085),
    [anon_sym_yield_BANG] = ACTIONS(1109),
    [anon_sym_lazy] = ACTIONS(1085),
    [anon_sym_assert] = ACTIONS(1085),
    [anon_sym_upcast] = ACTIONS(1085),
    [anon_sym_downcast] = ACTIONS(1085),
    [anon_sym_for] = ACTIONS(1113),
    [anon_sym_while] = ACTIONS(1115),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(1117),
    [anon_sym_try] = ACTIONS(1119),
    [anon_sym_match] = ACTIONS(1121),
    [anon_sym_match_BANG] = ACTIONS(1123),
    [anon_sym_function] = ACTIONS(1125),
    [anon_sym_use] = ACTIONS(1133),
    [anon_sym_use_BANG] = ACTIONS(1135),
    [anon_sym_do_BANG] = ACTIONS(1137),
    [anon_sym_begin] = ACTIONS(1139),
    [aux_sym_char_token1] = ACTIONS(1143),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1145),
    [anon_sym_DQUOTE] = ACTIONS(1147),
    [anon_sym_AT_DQUOTE] = ACTIONS(1149),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1151),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1153),
    [sym_bool] = ACTIONS(1155),
    [sym_unit] = ACTIONS(2104),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1159),
    [sym_op_identifier] = ACTIONS(2106),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(1163),
    [sym_xint] = ACTIONS(1165),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1167),
  },
  [555] = {
    [sym_function_or_value_defn] = STATE(627),
    [sym__expression] = STATE(19),
    [sym_literal_expression] = STATE(1118),
    [sym_long_identifier_or_op] = STATE(1118),
    [sym_tuple_expression] = STATE(1118),
    [sym_brace_expression] = STATE(1118),
    [sym_anon_record_expression] = STATE(1118),
    [sym_prefixed_expression] = STATE(1118),
    [sym_typecast_expression] = STATE(1118),
    [sym_for_expression] = STATE(1118),
    [sym_while_expression] = STATE(1118),
    [sym__if_branch] = STATE(7163),
    [sym_if_expression] = STATE(1118),
    [sym_fun_expression] = STATE(1118),
    [sym_try_expression] = STATE(1118),
    [sym_match_expression] = STATE(1118),
    [sym_function_expression] = STATE(1118),
    [sym_mutate_expression] = STATE(1118),
    [sym_index_expression] = STATE(1118),
    [sym_typed_expression] = STATE(1118),
    [sym_declaration_expression] = STATE(1118),
    [sym_do_expression] = STATE(1118),
    [sym_list_expression] = STATE(1118),
    [sym_array_expression] = STATE(1118),
    [sym_begin_end_expression] = STATE(1118),
    [sym_paren_expression] = STATE(1118),
    [sym__high_prec_app] = STATE(1133),
    [sym__low_prec_app] = STATE(1133),
    [sym_application_expression] = STATE(1118),
    [sym_dot_expression] = STATE(1118),
    [sym_infix_expression] = STATE(1118),
    [sym_ce_expression] = STATE(1118),
    [sym_sequential_expression] = STATE(1118),
    [sym_char] = STATE(1080),
    [sym_format_string] = STATE(1090),
    [sym__string_literal] = STATE(1090),
    [sym_string] = STATE(1080),
    [sym_verbatim_string] = STATE(1080),
    [sym_bytearray] = STATE(1080),
    [sym_verbatim_bytearray] = STATE(1080),
    [sym_format_triple_quoted_string] = STATE(1096),
    [sym_triple_quoted_string] = STATE(1080),
    [sym_const] = STATE(1118),
    [sym_long_identifier] = STATE(1156),
    [sym_active_pattern] = STATE(1085),
    [sym__identifier_or_op] = STATE(1099),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(517),
    [sym_sbyte] = STATE(1080),
    [sym_byte] = STATE(1080),
    [sym_int16] = STATE(1080),
    [sym_uint16] = STATE(1080),
    [sym_int32] = STATE(1080),
    [sym_uint32] = STATE(1080),
    [sym_nativeint] = STATE(1080),
    [sym_unativeint] = STATE(1080),
    [sym_int64] = STATE(1080),
    [sym_uint64] = STATE(1080),
    [sym_ieee32] = STATE(1080),
    [sym_ieee64] = STATE(1080),
    [sym_bignum] = STATE(1080),
    [sym_decimal] = STATE(1080),
    [sym_float] = STATE(979),
    [sym_block_comment] = STATE(555),
    [sym_compiler_directive_decl] = STATE(555),
    [sym_fsi_directive_decl] = STATE(555),
    [sym_preproc_line] = STATE(555),
    [sym_preproc_if_in_expression] = STATE(1118),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(195),
    [anon_sym_return] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_null] = ACTIONS(207),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(209),
    [anon_sym_LBRACK_PIPE] = ACTIONS(211),
    [anon_sym_LBRACE] = ACTIONS(1687),
    [anon_sym_LT_AT] = ACTIONS(213),
    [anon_sym_LT_AT_AT] = ACTIONS(1689),
    [anon_sym_LBRACE_PIPE] = ACTIONS(217),
    [anon_sym_new] = ACTIONS(199),
    [anon_sym_return_BANG] = ACTIONS(219),
    [anon_sym_yield] = ACTIONS(199),
    [anon_sym_yield_BANG] = ACTIONS(219),
    [anon_sym_lazy] = ACTIONS(199),
    [anon_sym_assert] = ACTIONS(199),
    [anon_sym_upcast] = ACTIONS(199),
    [anon_sym_downcast] = ACTIONS(199),
    [anon_sym_for] = ACTIONS(223),
    [anon_sym_while] = ACTIONS(225),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(229),
    [anon_sym_match] = ACTIONS(231),
    [anon_sym_match_BANG] = ACTIONS(233),
    [anon_sym_function] = ACTIONS(235),
    [anon_sym_use] = ACTIONS(239),
    [anon_sym_use_BANG] = ACTIONS(241),
    [anon_sym_do_BANG] = ACTIONS(243),
    [anon_sym_begin] = ACTIONS(245),
    [aux_sym_char_token1] = ACTIONS(247),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(251),
    [anon_sym_AT_DQUOTE] = ACTIONS(253),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(255),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(257),
    [sym_bool] = ACTIONS(259),
    [sym_unit] = ACTIONS(1699),
    [anon_sym_LPAREN_PIPE] = ACTIONS(261),
    [sym_op_identifier] = ACTIONS(1701),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(265),
    [sym_xint] = ACTIONS(267),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(269),
  },
  [556] = {
    [sym_function_or_value_defn] = STATE(651),
    [sym__expression] = STATE(189),
    [sym_literal_expression] = STATE(2168),
    [sym_long_identifier_or_op] = STATE(2168),
    [sym_tuple_expression] = STATE(2168),
    [sym_brace_expression] = STATE(2168),
    [sym_anon_record_expression] = STATE(2168),
    [sym_prefixed_expression] = STATE(2168),
    [sym_typecast_expression] = STATE(2168),
    [sym_for_expression] = STATE(2168),
    [sym_while_expression] = STATE(2168),
    [sym__if_branch] = STATE(6406),
    [sym_if_expression] = STATE(2168),
    [sym_fun_expression] = STATE(2168),
    [sym_try_expression] = STATE(2168),
    [sym_match_expression] = STATE(2168),
    [sym_function_expression] = STATE(2168),
    [sym_mutate_expression] = STATE(2168),
    [sym_index_expression] = STATE(2168),
    [sym_typed_expression] = STATE(2168),
    [sym_declaration_expression] = STATE(2168),
    [sym_do_expression] = STATE(2168),
    [sym_list_expression] = STATE(2168),
    [sym_array_expression] = STATE(2168),
    [sym_begin_end_expression] = STATE(2168),
    [sym_paren_expression] = STATE(2168),
    [sym__high_prec_app] = STATE(2179),
    [sym__low_prec_app] = STATE(2179),
    [sym_application_expression] = STATE(2168),
    [sym_dot_expression] = STATE(2168),
    [sym_infix_expression] = STATE(2168),
    [sym_ce_expression] = STATE(2168),
    [sym_sequential_expression] = STATE(2168),
    [sym_char] = STATE(2469),
    [sym_format_string] = STATE(2412),
    [sym__string_literal] = STATE(2412),
    [sym_string] = STATE(2469),
    [sym_verbatim_string] = STATE(2469),
    [sym_bytearray] = STATE(2469),
    [sym_verbatim_bytearray] = STATE(2469),
    [sym_format_triple_quoted_string] = STATE(2408),
    [sym_triple_quoted_string] = STATE(2469),
    [sym_const] = STATE(2168),
    [sym_long_identifier] = STATE(2183),
    [sym_active_pattern] = STATE(2182),
    [sym__identifier_or_op] = STATE(2093),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(650),
    [sym_sbyte] = STATE(2469),
    [sym_byte] = STATE(2469),
    [sym_int16] = STATE(2469),
    [sym_uint16] = STATE(2469),
    [sym_int32] = STATE(2469),
    [sym_uint32] = STATE(2469),
    [sym_nativeint] = STATE(2469),
    [sym_unativeint] = STATE(2469),
    [sym_int64] = STATE(2469),
    [sym_uint64] = STATE(2469),
    [sym_ieee32] = STATE(2469),
    [sym_ieee64] = STATE(2469),
    [sym_bignum] = STATE(2469),
    [sym_decimal] = STATE(2469),
    [sym_float] = STATE(1586),
    [sym_block_comment] = STATE(556),
    [sym_compiler_directive_decl] = STATE(556),
    [sym_fsi_directive_decl] = STATE(556),
    [sym_preproc_line] = STATE(556),
    [sym_preproc_if_in_expression] = STATE(2168),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(989),
    [anon_sym_return] = ACTIONS(993),
    [anon_sym_do] = ACTIONS(995),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(997),
    [anon_sym_null] = ACTIONS(1001),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1003),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1005),
    [anon_sym_LBRACE] = ACTIONS(2070),
    [anon_sym_LT_AT] = ACTIONS(1009),
    [anon_sym_LT_AT_AT] = ACTIONS(2072),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1017),
    [anon_sym_new] = ACTIONS(993),
    [anon_sym_return_BANG] = ACTIONS(1019),
    [anon_sym_yield] = ACTIONS(993),
    [anon_sym_yield_BANG] = ACTIONS(1019),
    [anon_sym_lazy] = ACTIONS(993),
    [anon_sym_assert] = ACTIONS(993),
    [anon_sym_upcast] = ACTIONS(993),
    [anon_sym_downcast] = ACTIONS(993),
    [anon_sym_for] = ACTIONS(1023),
    [anon_sym_while] = ACTIONS(1025),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(1027),
    [anon_sym_try] = ACTIONS(1029),
    [anon_sym_match] = ACTIONS(1031),
    [anon_sym_match_BANG] = ACTIONS(1033),
    [anon_sym_function] = ACTIONS(1035),
    [anon_sym_use] = ACTIONS(1043),
    [anon_sym_use_BANG] = ACTIONS(1045),
    [anon_sym_do_BANG] = ACTIONS(1047),
    [anon_sym_begin] = ACTIONS(1049),
    [aux_sym_char_token1] = ACTIONS(1053),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1055),
    [anon_sym_DQUOTE] = ACTIONS(1057),
    [anon_sym_AT_DQUOTE] = ACTIONS(1059),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1061),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1063),
    [sym_bool] = ACTIONS(1065),
    [sym_unit] = ACTIONS(2074),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1069),
    [sym_op_identifier] = ACTIONS(2076),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(1073),
    [sym_xint] = ACTIONS(1075),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1077),
  },
  [557] = {
    [sym_function_or_value_defn] = STATE(627),
    [sym__expression] = STATE(334),
    [sym_literal_expression] = STATE(1118),
    [sym_long_identifier_or_op] = STATE(1118),
    [sym_tuple_expression] = STATE(1118),
    [sym_brace_expression] = STATE(1118),
    [sym_anon_record_expression] = STATE(1118),
    [sym_prefixed_expression] = STATE(1118),
    [sym_typecast_expression] = STATE(1118),
    [sym_for_expression] = STATE(1118),
    [sym_while_expression] = STATE(1118),
    [sym__if_branch] = STATE(7163),
    [sym_if_expression] = STATE(1118),
    [sym_fun_expression] = STATE(1118),
    [sym_try_expression] = STATE(1118),
    [sym_match_expression] = STATE(1118),
    [sym_function_expression] = STATE(1118),
    [sym_mutate_expression] = STATE(1118),
    [sym_index_expression] = STATE(1118),
    [sym_typed_expression] = STATE(1118),
    [sym_declaration_expression] = STATE(1118),
    [sym_do_expression] = STATE(1118),
    [sym_list_expression] = STATE(1118),
    [sym_array_expression] = STATE(1118),
    [sym_begin_end_expression] = STATE(1118),
    [sym_paren_expression] = STATE(1118),
    [sym__high_prec_app] = STATE(1133),
    [sym__low_prec_app] = STATE(1133),
    [sym_application_expression] = STATE(1118),
    [sym_dot_expression] = STATE(1118),
    [sym_infix_expression] = STATE(1118),
    [sym_ce_expression] = STATE(1118),
    [sym_sequential_expression] = STATE(1118),
    [sym_char] = STATE(1080),
    [sym_format_string] = STATE(1090),
    [sym__string_literal] = STATE(1090),
    [sym_string] = STATE(1080),
    [sym_verbatim_string] = STATE(1080),
    [sym_bytearray] = STATE(1080),
    [sym_verbatim_bytearray] = STATE(1080),
    [sym_format_triple_quoted_string] = STATE(1096),
    [sym_triple_quoted_string] = STATE(1080),
    [sym_const] = STATE(1118),
    [sym_long_identifier] = STATE(1156),
    [sym_active_pattern] = STATE(1085),
    [sym__identifier_or_op] = STATE(1099),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(517),
    [sym_sbyte] = STATE(1080),
    [sym_byte] = STATE(1080),
    [sym_int16] = STATE(1080),
    [sym_uint16] = STATE(1080),
    [sym_int32] = STATE(1080),
    [sym_uint32] = STATE(1080),
    [sym_nativeint] = STATE(1080),
    [sym_unativeint] = STATE(1080),
    [sym_int64] = STATE(1080),
    [sym_uint64] = STATE(1080),
    [sym_ieee32] = STATE(1080),
    [sym_ieee64] = STATE(1080),
    [sym_bignum] = STATE(1080),
    [sym_decimal] = STATE(1080),
    [sym_float] = STATE(979),
    [sym_block_comment] = STATE(557),
    [sym_compiler_directive_decl] = STATE(557),
    [sym_fsi_directive_decl] = STATE(557),
    [sym_preproc_line] = STATE(557),
    [sym_preproc_if_in_expression] = STATE(1118),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(195),
    [anon_sym_return] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_null] = ACTIONS(207),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(209),
    [anon_sym_LBRACK_PIPE] = ACTIONS(211),
    [anon_sym_LBRACE] = ACTIONS(1687),
    [anon_sym_LT_AT] = ACTIONS(213),
    [anon_sym_LT_AT_AT] = ACTIONS(1689),
    [anon_sym_LBRACE_PIPE] = ACTIONS(217),
    [anon_sym_new] = ACTIONS(199),
    [anon_sym_return_BANG] = ACTIONS(219),
    [anon_sym_yield] = ACTIONS(199),
    [anon_sym_yield_BANG] = ACTIONS(219),
    [anon_sym_lazy] = ACTIONS(199),
    [anon_sym_assert] = ACTIONS(199),
    [anon_sym_upcast] = ACTIONS(199),
    [anon_sym_downcast] = ACTIONS(199),
    [anon_sym_for] = ACTIONS(223),
    [anon_sym_while] = ACTIONS(225),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(229),
    [anon_sym_match] = ACTIONS(231),
    [anon_sym_match_BANG] = ACTIONS(233),
    [anon_sym_function] = ACTIONS(235),
    [anon_sym_use] = ACTIONS(239),
    [anon_sym_use_BANG] = ACTIONS(241),
    [anon_sym_do_BANG] = ACTIONS(243),
    [anon_sym_begin] = ACTIONS(245),
    [aux_sym_char_token1] = ACTIONS(247),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(251),
    [anon_sym_AT_DQUOTE] = ACTIONS(253),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(255),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(257),
    [sym_bool] = ACTIONS(259),
    [sym_unit] = ACTIONS(1699),
    [anon_sym_LPAREN_PIPE] = ACTIONS(261),
    [sym_op_identifier] = ACTIONS(1701),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(265),
    [sym_xint] = ACTIONS(267),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(269),
  },
  [558] = {
    [sym_function_or_value_defn] = STATE(532),
    [sym__expression] = STATE(65),
    [sym_literal_expression] = STATE(2000),
    [sym_long_identifier_or_op] = STATE(2000),
    [sym_tuple_expression] = STATE(2000),
    [sym_brace_expression] = STATE(2000),
    [sym_anon_record_expression] = STATE(2000),
    [sym_prefixed_expression] = STATE(2000),
    [sym_typecast_expression] = STATE(2000),
    [sym_for_expression] = STATE(2000),
    [sym_while_expression] = STATE(2000),
    [sym__if_branch] = STATE(6707),
    [sym_if_expression] = STATE(2000),
    [sym_fun_expression] = STATE(2000),
    [sym_try_expression] = STATE(2000),
    [sym_match_expression] = STATE(2000),
    [sym_function_expression] = STATE(2000),
    [sym_mutate_expression] = STATE(2000),
    [sym_index_expression] = STATE(2000),
    [sym_typed_expression] = STATE(2000),
    [sym_declaration_expression] = STATE(2000),
    [sym_do_expression] = STATE(2000),
    [sym_list_expression] = STATE(2000),
    [sym_array_expression] = STATE(2000),
    [sym_begin_end_expression] = STATE(2000),
    [sym_paren_expression] = STATE(2000),
    [sym__high_prec_app] = STATE(2003),
    [sym__low_prec_app] = STATE(2003),
    [sym_application_expression] = STATE(2000),
    [sym_dot_expression] = STATE(2000),
    [sym_infix_expression] = STATE(2000),
    [sym_ce_expression] = STATE(2000),
    [sym_sequential_expression] = STATE(2000),
    [sym_char] = STATE(1801),
    [sym_format_string] = STATE(1804),
    [sym__string_literal] = STATE(1804),
    [sym_string] = STATE(1801),
    [sym_verbatim_string] = STATE(1801),
    [sym_bytearray] = STATE(1801),
    [sym_verbatim_bytearray] = STATE(1801),
    [sym_format_triple_quoted_string] = STATE(1807),
    [sym_triple_quoted_string] = STATE(1801),
    [sym_const] = STATE(2000),
    [sym_long_identifier] = STATE(1725),
    [sym_active_pattern] = STATE(1726),
    [sym__identifier_or_op] = STATE(1751),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(723),
    [sym_sbyte] = STATE(1801),
    [sym_byte] = STATE(1801),
    [sym_int16] = STATE(1801),
    [sym_uint16] = STATE(1801),
    [sym_int32] = STATE(1801),
    [sym_uint32] = STATE(1801),
    [sym_nativeint] = STATE(1801),
    [sym_unativeint] = STATE(1801),
    [sym_int64] = STATE(1801),
    [sym_uint64] = STATE(1801),
    [sym_ieee32] = STATE(1801),
    [sym_ieee64] = STATE(1801),
    [sym_bignum] = STATE(1801),
    [sym_decimal] = STATE(1801),
    [sym_float] = STATE(1427),
    [sym_block_comment] = STATE(558),
    [sym_compiler_directive_decl] = STATE(558),
    [sym_fsi_directive_decl] = STATE(558),
    [sym_preproc_line] = STATE(558),
    [sym_preproc_if_in_expression] = STATE(2000),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(629),
    [anon_sym_return] = ACTIONS(633),
    [anon_sym_do] = ACTIONS(635),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(637),
    [anon_sym_null] = ACTIONS(641),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(643),
    [anon_sym_LBRACK_PIPE] = ACTIONS(645),
    [anon_sym_LBRACE] = ACTIONS(1713),
    [anon_sym_LT_AT] = ACTIONS(647),
    [anon_sym_LT_AT_AT] = ACTIONS(1715),
    [anon_sym_LBRACE_PIPE] = ACTIONS(653),
    [anon_sym_new] = ACTIONS(633),
    [anon_sym_return_BANG] = ACTIONS(655),
    [anon_sym_yield] = ACTIONS(633),
    [anon_sym_yield_BANG] = ACTIONS(655),
    [anon_sym_lazy] = ACTIONS(633),
    [anon_sym_assert] = ACTIONS(633),
    [anon_sym_upcast] = ACTIONS(633),
    [anon_sym_downcast] = ACTIONS(633),
    [anon_sym_for] = ACTIONS(659),
    [anon_sym_while] = ACTIONS(661),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(663),
    [anon_sym_try] = ACTIONS(665),
    [anon_sym_match] = ACTIONS(667),
    [anon_sym_match_BANG] = ACTIONS(669),
    [anon_sym_function] = ACTIONS(671),
    [anon_sym_use] = ACTIONS(679),
    [anon_sym_use_BANG] = ACTIONS(681),
    [anon_sym_do_BANG] = ACTIONS(683),
    [anon_sym_begin] = ACTIONS(685),
    [aux_sym_char_token1] = ACTIONS(689),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(691),
    [anon_sym_DQUOTE] = ACTIONS(693),
    [anon_sym_AT_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(697),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(699),
    [sym_bool] = ACTIONS(701),
    [sym_unit] = ACTIONS(1717),
    [anon_sym_LPAREN_PIPE] = ACTIONS(705),
    [sym_op_identifier] = ACTIONS(1719),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(709),
    [sym_xint] = ACTIONS(711),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(713),
  },
  [559] = {
    [sym_function_or_value_defn] = STATE(600),
    [sym__expression] = STATE(224),
    [sym_literal_expression] = STATE(867),
    [sym_long_identifier_or_op] = STATE(867),
    [sym_tuple_expression] = STATE(867),
    [sym_brace_expression] = STATE(867),
    [sym_anon_record_expression] = STATE(867),
    [sym_prefixed_expression] = STATE(867),
    [sym_typecast_expression] = STATE(867),
    [sym_for_expression] = STATE(867),
    [sym_while_expression] = STATE(867),
    [sym__if_branch] = STATE(6511),
    [sym_if_expression] = STATE(867),
    [sym_fun_expression] = STATE(867),
    [sym_try_expression] = STATE(867),
    [sym_match_expression] = STATE(867),
    [sym_function_expression] = STATE(867),
    [sym_mutate_expression] = STATE(867),
    [sym_index_expression] = STATE(867),
    [sym_typed_expression] = STATE(867),
    [sym_declaration_expression] = STATE(867),
    [sym_do_expression] = STATE(867),
    [sym_list_expression] = STATE(867),
    [sym_array_expression] = STATE(867),
    [sym_begin_end_expression] = STATE(867),
    [sym_paren_expression] = STATE(867),
    [sym__high_prec_app] = STATE(864),
    [sym__low_prec_app] = STATE(864),
    [sym_application_expression] = STATE(867),
    [sym_dot_expression] = STATE(867),
    [sym_infix_expression] = STATE(867),
    [sym_ce_expression] = STATE(867),
    [sym_sequential_expression] = STATE(867),
    [sym_char] = STATE(868),
    [sym_format_string] = STATE(869),
    [sym__string_literal] = STATE(869),
    [sym_string] = STATE(868),
    [sym_verbatim_string] = STATE(868),
    [sym_bytearray] = STATE(868),
    [sym_verbatim_bytearray] = STATE(868),
    [sym_format_triple_quoted_string] = STATE(870),
    [sym_triple_quoted_string] = STATE(868),
    [sym_const] = STATE(867),
    [sym_long_identifier] = STATE(872),
    [sym_active_pattern] = STATE(871),
    [sym__identifier_or_op] = STATE(873),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(656),
    [sym_sbyte] = STATE(868),
    [sym_byte] = STATE(868),
    [sym_int16] = STATE(868),
    [sym_uint16] = STATE(868),
    [sym_int32] = STATE(868),
    [sym_uint32] = STATE(868),
    [sym_nativeint] = STATE(868),
    [sym_unativeint] = STATE(868),
    [sym_int64] = STATE(868),
    [sym_uint64] = STATE(868),
    [sym_ieee32] = STATE(868),
    [sym_ieee64] = STATE(868),
    [sym_bignum] = STATE(868),
    [sym_decimal] = STATE(868),
    [sym_float] = STATE(1368),
    [sym_block_comment] = STATE(559),
    [sym_compiler_directive_decl] = STATE(559),
    [sym_fsi_directive_decl] = STATE(559),
    [sym_preproc_line] = STATE(559),
    [sym_preproc_if_in_expression] = STATE(867),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(29),
    [anon_sym_return] = ACTIONS(825),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_null] = ACTIONS(49),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACK_PIPE] = ACTIONS(57),
    [anon_sym_LBRACE] = ACTIONS(1663),
    [anon_sym_LT_AT] = ACTIONS(61),
    [anon_sym_LT_AT_AT] = ACTIONS(1665),
    [anon_sym_LBRACE_PIPE] = ACTIONS(67),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_return_BANG] = ACTIONS(829),
    [anon_sym_yield] = ACTIONS(825),
    [anon_sym_yield_BANG] = ACTIONS(829),
    [anon_sym_lazy] = ACTIONS(825),
    [anon_sym_assert] = ACTIONS(825),
    [anon_sym_upcast] = ACTIONS(825),
    [anon_sym_downcast] = ACTIONS(825),
    [anon_sym_for] = ACTIONS(73),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(79),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_match] = ACTIONS(83),
    [anon_sym_match_BANG] = ACTIONS(85),
    [anon_sym_function] = ACTIONS(87),
    [anon_sym_use] = ACTIONS(833),
    [anon_sym_use_BANG] = ACTIONS(835),
    [anon_sym_do_BANG] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(101),
    [aux_sym_char_token1] = ACTIONS(105),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(107),
    [anon_sym_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DQUOTE] = ACTIONS(111),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(115),
    [sym_bool] = ACTIONS(117),
    [sym_unit] = ACTIONS(1673),
    [anon_sym_LPAREN_PIPE] = ACTIONS(121),
    [sym_op_identifier] = ACTIONS(1675),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(837),
    [sym_xint] = ACTIONS(387),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(135),
  },
  [560] = {
    [sym_function_or_value_defn] = STATE(627),
    [sym__expression] = STATE(332),
    [sym_literal_expression] = STATE(1118),
    [sym_long_identifier_or_op] = STATE(1118),
    [sym_tuple_expression] = STATE(1118),
    [sym_brace_expression] = STATE(1118),
    [sym_anon_record_expression] = STATE(1118),
    [sym_prefixed_expression] = STATE(1118),
    [sym_typecast_expression] = STATE(1118),
    [sym_for_expression] = STATE(1118),
    [sym_while_expression] = STATE(1118),
    [sym__if_branch] = STATE(7163),
    [sym_if_expression] = STATE(1118),
    [sym_fun_expression] = STATE(1118),
    [sym_try_expression] = STATE(1118),
    [sym_match_expression] = STATE(1118),
    [sym_function_expression] = STATE(1118),
    [sym_mutate_expression] = STATE(1118),
    [sym_index_expression] = STATE(1118),
    [sym_typed_expression] = STATE(1118),
    [sym_declaration_expression] = STATE(1118),
    [sym_do_expression] = STATE(1118),
    [sym_list_expression] = STATE(1118),
    [sym_array_expression] = STATE(1118),
    [sym_begin_end_expression] = STATE(1118),
    [sym_paren_expression] = STATE(1118),
    [sym__high_prec_app] = STATE(1133),
    [sym__low_prec_app] = STATE(1133),
    [sym_application_expression] = STATE(1118),
    [sym_dot_expression] = STATE(1118),
    [sym_infix_expression] = STATE(1118),
    [sym_ce_expression] = STATE(1118),
    [sym_sequential_expression] = STATE(1118),
    [sym_char] = STATE(1080),
    [sym_format_string] = STATE(1090),
    [sym__string_literal] = STATE(1090),
    [sym_string] = STATE(1080),
    [sym_verbatim_string] = STATE(1080),
    [sym_bytearray] = STATE(1080),
    [sym_verbatim_bytearray] = STATE(1080),
    [sym_format_triple_quoted_string] = STATE(1096),
    [sym_triple_quoted_string] = STATE(1080),
    [sym_const] = STATE(1118),
    [sym_long_identifier] = STATE(1156),
    [sym_active_pattern] = STATE(1085),
    [sym__identifier_or_op] = STATE(1099),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(517),
    [sym_sbyte] = STATE(1080),
    [sym_byte] = STATE(1080),
    [sym_int16] = STATE(1080),
    [sym_uint16] = STATE(1080),
    [sym_int32] = STATE(1080),
    [sym_uint32] = STATE(1080),
    [sym_nativeint] = STATE(1080),
    [sym_unativeint] = STATE(1080),
    [sym_int64] = STATE(1080),
    [sym_uint64] = STATE(1080),
    [sym_ieee32] = STATE(1080),
    [sym_ieee64] = STATE(1080),
    [sym_bignum] = STATE(1080),
    [sym_decimal] = STATE(1080),
    [sym_float] = STATE(979),
    [sym_block_comment] = STATE(560),
    [sym_compiler_directive_decl] = STATE(560),
    [sym_fsi_directive_decl] = STATE(560),
    [sym_preproc_line] = STATE(560),
    [sym_preproc_if_in_expression] = STATE(1118),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(195),
    [anon_sym_return] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_null] = ACTIONS(207),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(209),
    [anon_sym_LBRACK_PIPE] = ACTIONS(211),
    [anon_sym_LBRACE] = ACTIONS(1687),
    [anon_sym_LT_AT] = ACTIONS(213),
    [anon_sym_LT_AT_AT] = ACTIONS(1689),
    [anon_sym_LBRACE_PIPE] = ACTIONS(217),
    [anon_sym_new] = ACTIONS(199),
    [anon_sym_return_BANG] = ACTIONS(219),
    [anon_sym_yield] = ACTIONS(199),
    [anon_sym_yield_BANG] = ACTIONS(219),
    [anon_sym_lazy] = ACTIONS(199),
    [anon_sym_assert] = ACTIONS(199),
    [anon_sym_upcast] = ACTIONS(199),
    [anon_sym_downcast] = ACTIONS(199),
    [anon_sym_for] = ACTIONS(223),
    [anon_sym_while] = ACTIONS(225),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(229),
    [anon_sym_match] = ACTIONS(231),
    [anon_sym_match_BANG] = ACTIONS(233),
    [anon_sym_function] = ACTIONS(235),
    [anon_sym_use] = ACTIONS(239),
    [anon_sym_use_BANG] = ACTIONS(241),
    [anon_sym_do_BANG] = ACTIONS(243),
    [anon_sym_begin] = ACTIONS(245),
    [aux_sym_char_token1] = ACTIONS(247),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(251),
    [anon_sym_AT_DQUOTE] = ACTIONS(253),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(255),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(257),
    [sym_bool] = ACTIONS(259),
    [sym_unit] = ACTIONS(1699),
    [anon_sym_LPAREN_PIPE] = ACTIONS(261),
    [sym_op_identifier] = ACTIONS(1701),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(265),
    [sym_xint] = ACTIONS(267),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(269),
  },
  [561] = {
    [sym_function_or_value_defn] = STATE(532),
    [sym__expression] = STATE(132),
    [sym_literal_expression] = STATE(2000),
    [sym_long_identifier_or_op] = STATE(2000),
    [sym_tuple_expression] = STATE(2000),
    [sym_brace_expression] = STATE(2000),
    [sym_anon_record_expression] = STATE(2000),
    [sym_prefixed_expression] = STATE(2000),
    [sym_typecast_expression] = STATE(2000),
    [sym_for_expression] = STATE(2000),
    [sym_while_expression] = STATE(2000),
    [sym__if_branch] = STATE(6707),
    [sym_if_expression] = STATE(2000),
    [sym_fun_expression] = STATE(2000),
    [sym_try_expression] = STATE(2000),
    [sym_match_expression] = STATE(2000),
    [sym_function_expression] = STATE(2000),
    [sym_mutate_expression] = STATE(2000),
    [sym_index_expression] = STATE(2000),
    [sym_typed_expression] = STATE(2000),
    [sym_declaration_expression] = STATE(2000),
    [sym_do_expression] = STATE(2000),
    [sym_list_expression] = STATE(2000),
    [sym_array_expression] = STATE(2000),
    [sym_begin_end_expression] = STATE(2000),
    [sym_paren_expression] = STATE(2000),
    [sym__high_prec_app] = STATE(2003),
    [sym__low_prec_app] = STATE(2003),
    [sym_application_expression] = STATE(2000),
    [sym_dot_expression] = STATE(2000),
    [sym_infix_expression] = STATE(2000),
    [sym_ce_expression] = STATE(2000),
    [sym_sequential_expression] = STATE(2000),
    [sym_char] = STATE(1801),
    [sym_format_string] = STATE(1804),
    [sym__string_literal] = STATE(1804),
    [sym_string] = STATE(1801),
    [sym_verbatim_string] = STATE(1801),
    [sym_bytearray] = STATE(1801),
    [sym_verbatim_bytearray] = STATE(1801),
    [sym_format_triple_quoted_string] = STATE(1807),
    [sym_triple_quoted_string] = STATE(1801),
    [sym_const] = STATE(2000),
    [sym_long_identifier] = STATE(1725),
    [sym_active_pattern] = STATE(1726),
    [sym__identifier_or_op] = STATE(1751),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(723),
    [sym_sbyte] = STATE(1801),
    [sym_byte] = STATE(1801),
    [sym_int16] = STATE(1801),
    [sym_uint16] = STATE(1801),
    [sym_int32] = STATE(1801),
    [sym_uint32] = STATE(1801),
    [sym_nativeint] = STATE(1801),
    [sym_unativeint] = STATE(1801),
    [sym_int64] = STATE(1801),
    [sym_uint64] = STATE(1801),
    [sym_ieee32] = STATE(1801),
    [sym_ieee64] = STATE(1801),
    [sym_bignum] = STATE(1801),
    [sym_decimal] = STATE(1801),
    [sym_float] = STATE(1427),
    [sym_block_comment] = STATE(561),
    [sym_compiler_directive_decl] = STATE(561),
    [sym_fsi_directive_decl] = STATE(561),
    [sym_preproc_line] = STATE(561),
    [sym_preproc_if_in_expression] = STATE(2000),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(629),
    [anon_sym_return] = ACTIONS(633),
    [anon_sym_do] = ACTIONS(635),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(637),
    [anon_sym_null] = ACTIONS(641),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(643),
    [anon_sym_LBRACK_PIPE] = ACTIONS(645),
    [anon_sym_LBRACE] = ACTIONS(1713),
    [anon_sym_LT_AT] = ACTIONS(647),
    [anon_sym_LT_AT_AT] = ACTIONS(1715),
    [anon_sym_LBRACE_PIPE] = ACTIONS(653),
    [anon_sym_new] = ACTIONS(633),
    [anon_sym_return_BANG] = ACTIONS(655),
    [anon_sym_yield] = ACTIONS(633),
    [anon_sym_yield_BANG] = ACTIONS(655),
    [anon_sym_lazy] = ACTIONS(633),
    [anon_sym_assert] = ACTIONS(633),
    [anon_sym_upcast] = ACTIONS(633),
    [anon_sym_downcast] = ACTIONS(633),
    [anon_sym_for] = ACTIONS(659),
    [anon_sym_while] = ACTIONS(661),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(663),
    [anon_sym_try] = ACTIONS(665),
    [anon_sym_match] = ACTIONS(667),
    [anon_sym_match_BANG] = ACTIONS(669),
    [anon_sym_function] = ACTIONS(671),
    [anon_sym_use] = ACTIONS(679),
    [anon_sym_use_BANG] = ACTIONS(681),
    [anon_sym_do_BANG] = ACTIONS(683),
    [anon_sym_begin] = ACTIONS(685),
    [aux_sym_char_token1] = ACTIONS(689),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(691),
    [anon_sym_DQUOTE] = ACTIONS(693),
    [anon_sym_AT_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(697),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(699),
    [sym_bool] = ACTIONS(701),
    [sym_unit] = ACTIONS(1717),
    [anon_sym_LPAREN_PIPE] = ACTIONS(705),
    [sym_op_identifier] = ACTIONS(1719),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(709),
    [sym_xint] = ACTIONS(711),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(713),
  },
  [562] = {
    [sym_function_or_value_defn] = STATE(600),
    [sym__expression] = STATE(226),
    [sym_literal_expression] = STATE(867),
    [sym_long_identifier_or_op] = STATE(867),
    [sym_tuple_expression] = STATE(867),
    [sym_brace_expression] = STATE(867),
    [sym_anon_record_expression] = STATE(867),
    [sym_prefixed_expression] = STATE(867),
    [sym_typecast_expression] = STATE(867),
    [sym_for_expression] = STATE(867),
    [sym_while_expression] = STATE(867),
    [sym__if_branch] = STATE(6511),
    [sym_if_expression] = STATE(867),
    [sym_fun_expression] = STATE(867),
    [sym_try_expression] = STATE(867),
    [sym_match_expression] = STATE(867),
    [sym_function_expression] = STATE(867),
    [sym_mutate_expression] = STATE(867),
    [sym_index_expression] = STATE(867),
    [sym_typed_expression] = STATE(867),
    [sym_declaration_expression] = STATE(867),
    [sym_do_expression] = STATE(867),
    [sym_list_expression] = STATE(867),
    [sym_array_expression] = STATE(867),
    [sym_begin_end_expression] = STATE(867),
    [sym_paren_expression] = STATE(867),
    [sym__high_prec_app] = STATE(864),
    [sym__low_prec_app] = STATE(864),
    [sym_application_expression] = STATE(867),
    [sym_dot_expression] = STATE(867),
    [sym_infix_expression] = STATE(867),
    [sym_ce_expression] = STATE(867),
    [sym_sequential_expression] = STATE(867),
    [sym_char] = STATE(868),
    [sym_format_string] = STATE(869),
    [sym__string_literal] = STATE(869),
    [sym_string] = STATE(868),
    [sym_verbatim_string] = STATE(868),
    [sym_bytearray] = STATE(868),
    [sym_verbatim_bytearray] = STATE(868),
    [sym_format_triple_quoted_string] = STATE(870),
    [sym_triple_quoted_string] = STATE(868),
    [sym_const] = STATE(867),
    [sym_long_identifier] = STATE(872),
    [sym_active_pattern] = STATE(871),
    [sym__identifier_or_op] = STATE(873),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(656),
    [sym_sbyte] = STATE(868),
    [sym_byte] = STATE(868),
    [sym_int16] = STATE(868),
    [sym_uint16] = STATE(868),
    [sym_int32] = STATE(868),
    [sym_uint32] = STATE(868),
    [sym_nativeint] = STATE(868),
    [sym_unativeint] = STATE(868),
    [sym_int64] = STATE(868),
    [sym_uint64] = STATE(868),
    [sym_ieee32] = STATE(868),
    [sym_ieee64] = STATE(868),
    [sym_bignum] = STATE(868),
    [sym_decimal] = STATE(868),
    [sym_float] = STATE(1368),
    [sym_block_comment] = STATE(562),
    [sym_compiler_directive_decl] = STATE(562),
    [sym_fsi_directive_decl] = STATE(562),
    [sym_preproc_line] = STATE(562),
    [sym_preproc_if_in_expression] = STATE(867),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(29),
    [anon_sym_return] = ACTIONS(825),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_null] = ACTIONS(49),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACK_PIPE] = ACTIONS(57),
    [anon_sym_LBRACE] = ACTIONS(1663),
    [anon_sym_LT_AT] = ACTIONS(61),
    [anon_sym_LT_AT_AT] = ACTIONS(1665),
    [anon_sym_LBRACE_PIPE] = ACTIONS(67),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_return_BANG] = ACTIONS(829),
    [anon_sym_yield] = ACTIONS(825),
    [anon_sym_yield_BANG] = ACTIONS(829),
    [anon_sym_lazy] = ACTIONS(825),
    [anon_sym_assert] = ACTIONS(825),
    [anon_sym_upcast] = ACTIONS(825),
    [anon_sym_downcast] = ACTIONS(825),
    [anon_sym_for] = ACTIONS(73),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(79),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_match] = ACTIONS(83),
    [anon_sym_match_BANG] = ACTIONS(85),
    [anon_sym_function] = ACTIONS(87),
    [anon_sym_use] = ACTIONS(833),
    [anon_sym_use_BANG] = ACTIONS(835),
    [anon_sym_do_BANG] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(101),
    [aux_sym_char_token1] = ACTIONS(105),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(107),
    [anon_sym_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DQUOTE] = ACTIONS(111),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(115),
    [sym_bool] = ACTIONS(117),
    [sym_unit] = ACTIONS(1673),
    [anon_sym_LPAREN_PIPE] = ACTIONS(121),
    [sym_op_identifier] = ACTIONS(1675),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(837),
    [sym_xint] = ACTIONS(387),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(135),
  },
  [563] = {
    [sym_function_or_value_defn] = STATE(600),
    [sym__expression] = STATE(228),
    [sym_literal_expression] = STATE(867),
    [sym_long_identifier_or_op] = STATE(867),
    [sym_tuple_expression] = STATE(867),
    [sym_brace_expression] = STATE(867),
    [sym_anon_record_expression] = STATE(867),
    [sym_prefixed_expression] = STATE(867),
    [sym_typecast_expression] = STATE(867),
    [sym_for_expression] = STATE(867),
    [sym_while_expression] = STATE(867),
    [sym__if_branch] = STATE(6511),
    [sym_if_expression] = STATE(867),
    [sym_fun_expression] = STATE(867),
    [sym_try_expression] = STATE(867),
    [sym_match_expression] = STATE(867),
    [sym_function_expression] = STATE(867),
    [sym_mutate_expression] = STATE(867),
    [sym_index_expression] = STATE(867),
    [sym_typed_expression] = STATE(867),
    [sym_declaration_expression] = STATE(867),
    [sym_do_expression] = STATE(867),
    [sym_list_expression] = STATE(867),
    [sym_array_expression] = STATE(867),
    [sym_begin_end_expression] = STATE(867),
    [sym_paren_expression] = STATE(867),
    [sym__high_prec_app] = STATE(864),
    [sym__low_prec_app] = STATE(864),
    [sym_application_expression] = STATE(867),
    [sym_dot_expression] = STATE(867),
    [sym_infix_expression] = STATE(867),
    [sym_ce_expression] = STATE(867),
    [sym_sequential_expression] = STATE(867),
    [sym_char] = STATE(868),
    [sym_format_string] = STATE(869),
    [sym__string_literal] = STATE(869),
    [sym_string] = STATE(868),
    [sym_verbatim_string] = STATE(868),
    [sym_bytearray] = STATE(868),
    [sym_verbatim_bytearray] = STATE(868),
    [sym_format_triple_quoted_string] = STATE(870),
    [sym_triple_quoted_string] = STATE(868),
    [sym_const] = STATE(867),
    [sym_long_identifier] = STATE(872),
    [sym_active_pattern] = STATE(871),
    [sym__identifier_or_op] = STATE(873),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(656),
    [sym_sbyte] = STATE(868),
    [sym_byte] = STATE(868),
    [sym_int16] = STATE(868),
    [sym_uint16] = STATE(868),
    [sym_int32] = STATE(868),
    [sym_uint32] = STATE(868),
    [sym_nativeint] = STATE(868),
    [sym_unativeint] = STATE(868),
    [sym_int64] = STATE(868),
    [sym_uint64] = STATE(868),
    [sym_ieee32] = STATE(868),
    [sym_ieee64] = STATE(868),
    [sym_bignum] = STATE(868),
    [sym_decimal] = STATE(868),
    [sym_float] = STATE(1368),
    [sym_block_comment] = STATE(563),
    [sym_compiler_directive_decl] = STATE(563),
    [sym_fsi_directive_decl] = STATE(563),
    [sym_preproc_line] = STATE(563),
    [sym_preproc_if_in_expression] = STATE(867),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(29),
    [anon_sym_return] = ACTIONS(825),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_null] = ACTIONS(49),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACK_PIPE] = ACTIONS(57),
    [anon_sym_LBRACE] = ACTIONS(1663),
    [anon_sym_LT_AT] = ACTIONS(61),
    [anon_sym_LT_AT_AT] = ACTIONS(1665),
    [anon_sym_LBRACE_PIPE] = ACTIONS(67),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_return_BANG] = ACTIONS(829),
    [anon_sym_yield] = ACTIONS(825),
    [anon_sym_yield_BANG] = ACTIONS(829),
    [anon_sym_lazy] = ACTIONS(825),
    [anon_sym_assert] = ACTIONS(825),
    [anon_sym_upcast] = ACTIONS(825),
    [anon_sym_downcast] = ACTIONS(825),
    [anon_sym_for] = ACTIONS(73),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(79),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_match] = ACTIONS(83),
    [anon_sym_match_BANG] = ACTIONS(85),
    [anon_sym_function] = ACTIONS(87),
    [anon_sym_use] = ACTIONS(833),
    [anon_sym_use_BANG] = ACTIONS(835),
    [anon_sym_do_BANG] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(101),
    [aux_sym_char_token1] = ACTIONS(105),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(107),
    [anon_sym_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DQUOTE] = ACTIONS(111),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(115),
    [sym_bool] = ACTIONS(117),
    [sym_unit] = ACTIONS(1673),
    [anon_sym_LPAREN_PIPE] = ACTIONS(121),
    [sym_op_identifier] = ACTIONS(1675),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(837),
    [sym_xint] = ACTIONS(387),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(135),
  },
  [564] = {
    [sym_function_or_value_defn] = STATE(600),
    [sym__expression] = STATE(231),
    [sym_literal_expression] = STATE(867),
    [sym_long_identifier_or_op] = STATE(867),
    [sym_tuple_expression] = STATE(867),
    [sym_brace_expression] = STATE(867),
    [sym_anon_record_expression] = STATE(867),
    [sym_prefixed_expression] = STATE(867),
    [sym_typecast_expression] = STATE(867),
    [sym_for_expression] = STATE(867),
    [sym_while_expression] = STATE(867),
    [sym__if_branch] = STATE(6511),
    [sym_if_expression] = STATE(867),
    [sym_fun_expression] = STATE(867),
    [sym_try_expression] = STATE(867),
    [sym_match_expression] = STATE(867),
    [sym_function_expression] = STATE(867),
    [sym_mutate_expression] = STATE(867),
    [sym_index_expression] = STATE(867),
    [sym_typed_expression] = STATE(867),
    [sym_declaration_expression] = STATE(867),
    [sym_do_expression] = STATE(867),
    [sym_list_expression] = STATE(867),
    [sym_array_expression] = STATE(867),
    [sym_begin_end_expression] = STATE(867),
    [sym_paren_expression] = STATE(867),
    [sym__high_prec_app] = STATE(864),
    [sym__low_prec_app] = STATE(864),
    [sym_application_expression] = STATE(867),
    [sym_dot_expression] = STATE(867),
    [sym_infix_expression] = STATE(867),
    [sym_ce_expression] = STATE(867),
    [sym_sequential_expression] = STATE(867),
    [sym_char] = STATE(868),
    [sym_format_string] = STATE(869),
    [sym__string_literal] = STATE(869),
    [sym_string] = STATE(868),
    [sym_verbatim_string] = STATE(868),
    [sym_bytearray] = STATE(868),
    [sym_verbatim_bytearray] = STATE(868),
    [sym_format_triple_quoted_string] = STATE(870),
    [sym_triple_quoted_string] = STATE(868),
    [sym_const] = STATE(867),
    [sym_long_identifier] = STATE(872),
    [sym_active_pattern] = STATE(871),
    [sym__identifier_or_op] = STATE(873),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(656),
    [sym_sbyte] = STATE(868),
    [sym_byte] = STATE(868),
    [sym_int16] = STATE(868),
    [sym_uint16] = STATE(868),
    [sym_int32] = STATE(868),
    [sym_uint32] = STATE(868),
    [sym_nativeint] = STATE(868),
    [sym_unativeint] = STATE(868),
    [sym_int64] = STATE(868),
    [sym_uint64] = STATE(868),
    [sym_ieee32] = STATE(868),
    [sym_ieee64] = STATE(868),
    [sym_bignum] = STATE(868),
    [sym_decimal] = STATE(868),
    [sym_float] = STATE(1368),
    [sym_block_comment] = STATE(564),
    [sym_compiler_directive_decl] = STATE(564),
    [sym_fsi_directive_decl] = STATE(564),
    [sym_preproc_line] = STATE(564),
    [sym_preproc_if_in_expression] = STATE(867),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(29),
    [anon_sym_return] = ACTIONS(825),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_null] = ACTIONS(49),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACK_PIPE] = ACTIONS(57),
    [anon_sym_LBRACE] = ACTIONS(1663),
    [anon_sym_LT_AT] = ACTIONS(61),
    [anon_sym_LT_AT_AT] = ACTIONS(1665),
    [anon_sym_LBRACE_PIPE] = ACTIONS(67),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_return_BANG] = ACTIONS(829),
    [anon_sym_yield] = ACTIONS(825),
    [anon_sym_yield_BANG] = ACTIONS(829),
    [anon_sym_lazy] = ACTIONS(825),
    [anon_sym_assert] = ACTIONS(825),
    [anon_sym_upcast] = ACTIONS(825),
    [anon_sym_downcast] = ACTIONS(825),
    [anon_sym_for] = ACTIONS(73),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(79),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_match] = ACTIONS(83),
    [anon_sym_match_BANG] = ACTIONS(85),
    [anon_sym_function] = ACTIONS(87),
    [anon_sym_use] = ACTIONS(833),
    [anon_sym_use_BANG] = ACTIONS(835),
    [anon_sym_do_BANG] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(101),
    [aux_sym_char_token1] = ACTIONS(105),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(107),
    [anon_sym_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DQUOTE] = ACTIONS(111),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(115),
    [sym_bool] = ACTIONS(117),
    [sym_unit] = ACTIONS(1673),
    [anon_sym_LPAREN_PIPE] = ACTIONS(121),
    [sym_op_identifier] = ACTIONS(1675),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(837),
    [sym_xint] = ACTIONS(387),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(135),
  },
  [565] = {
    [sym_function_or_value_defn] = STATE(600),
    [sym__expression] = STATE(96),
    [sym_literal_expression] = STATE(867),
    [sym_long_identifier_or_op] = STATE(867),
    [sym_tuple_expression] = STATE(867),
    [sym_brace_expression] = STATE(867),
    [sym_anon_record_expression] = STATE(867),
    [sym_prefixed_expression] = STATE(867),
    [sym_typecast_expression] = STATE(867),
    [sym_for_expression] = STATE(867),
    [sym_while_expression] = STATE(867),
    [sym__if_branch] = STATE(6511),
    [sym_if_expression] = STATE(867),
    [sym_fun_expression] = STATE(867),
    [sym_try_expression] = STATE(867),
    [sym_match_expression] = STATE(867),
    [sym_function_expression] = STATE(867),
    [sym_mutate_expression] = STATE(867),
    [sym_index_expression] = STATE(867),
    [sym_typed_expression] = STATE(867),
    [sym_declaration_expression] = STATE(867),
    [sym_do_expression] = STATE(867),
    [sym_list_expression] = STATE(867),
    [sym_array_expression] = STATE(867),
    [sym_begin_end_expression] = STATE(867),
    [sym_paren_expression] = STATE(867),
    [sym__high_prec_app] = STATE(864),
    [sym__low_prec_app] = STATE(864),
    [sym_application_expression] = STATE(867),
    [sym_dot_expression] = STATE(867),
    [sym_infix_expression] = STATE(867),
    [sym_ce_expression] = STATE(867),
    [sym_sequential_expression] = STATE(867),
    [sym_char] = STATE(868),
    [sym_format_string] = STATE(869),
    [sym__string_literal] = STATE(869),
    [sym_string] = STATE(868),
    [sym_verbatim_string] = STATE(868),
    [sym_bytearray] = STATE(868),
    [sym_verbatim_bytearray] = STATE(868),
    [sym_format_triple_quoted_string] = STATE(870),
    [sym_triple_quoted_string] = STATE(868),
    [sym_const] = STATE(867),
    [sym_long_identifier] = STATE(872),
    [sym_active_pattern] = STATE(871),
    [sym__identifier_or_op] = STATE(873),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(656),
    [sym_sbyte] = STATE(868),
    [sym_byte] = STATE(868),
    [sym_int16] = STATE(868),
    [sym_uint16] = STATE(868),
    [sym_int32] = STATE(868),
    [sym_uint32] = STATE(868),
    [sym_nativeint] = STATE(868),
    [sym_unativeint] = STATE(868),
    [sym_int64] = STATE(868),
    [sym_uint64] = STATE(868),
    [sym_ieee32] = STATE(868),
    [sym_ieee64] = STATE(868),
    [sym_bignum] = STATE(868),
    [sym_decimal] = STATE(868),
    [sym_float] = STATE(1368),
    [sym_block_comment] = STATE(565),
    [sym_compiler_directive_decl] = STATE(565),
    [sym_fsi_directive_decl] = STATE(565),
    [sym_preproc_line] = STATE(565),
    [sym_preproc_if_in_expression] = STATE(867),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(29),
    [anon_sym_return] = ACTIONS(825),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_null] = ACTIONS(49),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACK_PIPE] = ACTIONS(57),
    [anon_sym_LBRACE] = ACTIONS(1663),
    [anon_sym_LT_AT] = ACTIONS(61),
    [anon_sym_LT_AT_AT] = ACTIONS(1665),
    [anon_sym_LBRACE_PIPE] = ACTIONS(67),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_return_BANG] = ACTIONS(829),
    [anon_sym_yield] = ACTIONS(825),
    [anon_sym_yield_BANG] = ACTIONS(829),
    [anon_sym_lazy] = ACTIONS(825),
    [anon_sym_assert] = ACTIONS(825),
    [anon_sym_upcast] = ACTIONS(825),
    [anon_sym_downcast] = ACTIONS(825),
    [anon_sym_for] = ACTIONS(73),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(79),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_match] = ACTIONS(83),
    [anon_sym_match_BANG] = ACTIONS(85),
    [anon_sym_function] = ACTIONS(87),
    [anon_sym_use] = ACTIONS(833),
    [anon_sym_use_BANG] = ACTIONS(835),
    [anon_sym_do_BANG] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(101),
    [aux_sym_char_token1] = ACTIONS(105),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(107),
    [anon_sym_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DQUOTE] = ACTIONS(111),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(115),
    [sym_bool] = ACTIONS(117),
    [sym_unit] = ACTIONS(1673),
    [anon_sym_LPAREN_PIPE] = ACTIONS(121),
    [sym_op_identifier] = ACTIONS(1675),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(837),
    [sym_xint] = ACTIONS(387),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(135),
  },
  [566] = {
    [sym_function_or_value_defn] = STATE(705),
    [sym__expression] = STATE(12),
    [sym_literal_expression] = STATE(867),
    [sym_long_identifier_or_op] = STATE(867),
    [sym_tuple_expression] = STATE(867),
    [sym_brace_expression] = STATE(867),
    [sym_anon_record_expression] = STATE(867),
    [sym_prefixed_expression] = STATE(867),
    [sym_typecast_expression] = STATE(867),
    [sym_for_expression] = STATE(867),
    [sym_while_expression] = STATE(867),
    [sym__if_branch] = STATE(6511),
    [sym_if_expression] = STATE(867),
    [sym_fun_expression] = STATE(867),
    [sym_try_expression] = STATE(867),
    [sym_match_expression] = STATE(867),
    [sym_function_expression] = STATE(867),
    [sym_mutate_expression] = STATE(867),
    [sym_index_expression] = STATE(867),
    [sym_typed_expression] = STATE(867),
    [sym_declaration_expression] = STATE(867),
    [sym_do_expression] = STATE(867),
    [sym_list_expression] = STATE(867),
    [sym_array_expression] = STATE(867),
    [sym_begin_end_expression] = STATE(867),
    [sym_paren_expression] = STATE(867),
    [sym__high_prec_app] = STATE(864),
    [sym__low_prec_app] = STATE(864),
    [sym_application_expression] = STATE(867),
    [sym_dot_expression] = STATE(867),
    [sym_infix_expression] = STATE(867),
    [sym_ce_expression] = STATE(867),
    [sym_sequential_expression] = STATE(867),
    [sym_char] = STATE(868),
    [sym_format_string] = STATE(869),
    [sym__string_literal] = STATE(869),
    [sym_string] = STATE(868),
    [sym_verbatim_string] = STATE(868),
    [sym_bytearray] = STATE(868),
    [sym_verbatim_bytearray] = STATE(868),
    [sym_format_triple_quoted_string] = STATE(870),
    [sym_triple_quoted_string] = STATE(868),
    [sym_const] = STATE(867),
    [sym_long_identifier] = STATE(872),
    [sym_active_pattern] = STATE(871),
    [sym__identifier_or_op] = STATE(873),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(658),
    [sym_sbyte] = STATE(868),
    [sym_byte] = STATE(868),
    [sym_int16] = STATE(868),
    [sym_uint16] = STATE(868),
    [sym_int32] = STATE(868),
    [sym_uint32] = STATE(868),
    [sym_nativeint] = STATE(868),
    [sym_unativeint] = STATE(868),
    [sym_int64] = STATE(868),
    [sym_uint64] = STATE(868),
    [sym_ieee32] = STATE(868),
    [sym_ieee64] = STATE(868),
    [sym_bignum] = STATE(868),
    [sym_decimal] = STATE(868),
    [sym_float] = STATE(860),
    [sym_block_comment] = STATE(566),
    [sym_compiler_directive_decl] = STATE(566),
    [sym_fsi_directive_decl] = STATE(566),
    [sym_preproc_line] = STATE(566),
    [sym_preproc_if_in_expression] = STATE(867),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(29),
    [anon_sym_return] = ACTIONS(37),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_null] = ACTIONS(49),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACK_PIPE] = ACTIONS(57),
    [anon_sym_LBRACE] = ACTIONS(1663),
    [anon_sym_LT_AT] = ACTIONS(61),
    [anon_sym_LT_AT_AT] = ACTIONS(1665),
    [anon_sym_LBRACE_PIPE] = ACTIONS(67),
    [anon_sym_new] = ACTIONS(37),
    [anon_sym_return_BANG] = ACTIONS(69),
    [anon_sym_yield] = ACTIONS(37),
    [anon_sym_yield_BANG] = ACTIONS(69),
    [anon_sym_lazy] = ACTIONS(37),
    [anon_sym_assert] = ACTIONS(37),
    [anon_sym_upcast] = ACTIONS(37),
    [anon_sym_downcast] = ACTIONS(37),
    [anon_sym_for] = ACTIONS(73),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(79),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_match] = ACTIONS(83),
    [anon_sym_match_BANG] = ACTIONS(85),
    [anon_sym_function] = ACTIONS(87),
    [anon_sym_use] = ACTIONS(95),
    [anon_sym_use_BANG] = ACTIONS(97),
    [anon_sym_do_BANG] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(101),
    [aux_sym_char_token1] = ACTIONS(105),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(107),
    [anon_sym_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DQUOTE] = ACTIONS(111),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(115),
    [sym_bool] = ACTIONS(117),
    [sym_unit] = ACTIONS(1673),
    [anon_sym_LPAREN_PIPE] = ACTIONS(121),
    [sym_op_identifier] = ACTIONS(1675),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(129),
    [sym_xint] = ACTIONS(131),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(135),
  },
  [567] = {
    [sym_function_or_value_defn] = STATE(627),
    [sym__expression] = STATE(176),
    [sym_literal_expression] = STATE(1118),
    [sym_long_identifier_or_op] = STATE(1118),
    [sym_tuple_expression] = STATE(1118),
    [sym_brace_expression] = STATE(1118),
    [sym_anon_record_expression] = STATE(1118),
    [sym_prefixed_expression] = STATE(1118),
    [sym_typecast_expression] = STATE(1118),
    [sym_for_expression] = STATE(1118),
    [sym_while_expression] = STATE(1118),
    [sym__if_branch] = STATE(7163),
    [sym_if_expression] = STATE(1118),
    [sym_fun_expression] = STATE(1118),
    [sym_try_expression] = STATE(1118),
    [sym_match_expression] = STATE(1118),
    [sym_function_expression] = STATE(1118),
    [sym_mutate_expression] = STATE(1118),
    [sym_index_expression] = STATE(1118),
    [sym_typed_expression] = STATE(1118),
    [sym_declaration_expression] = STATE(1118),
    [sym_do_expression] = STATE(1118),
    [sym_list_expression] = STATE(1118),
    [sym_array_expression] = STATE(1118),
    [sym_begin_end_expression] = STATE(1118),
    [sym_paren_expression] = STATE(1118),
    [sym__high_prec_app] = STATE(1133),
    [sym__low_prec_app] = STATE(1133),
    [sym_application_expression] = STATE(1118),
    [sym_dot_expression] = STATE(1118),
    [sym_infix_expression] = STATE(1118),
    [sym_ce_expression] = STATE(1118),
    [sym_sequential_expression] = STATE(1118),
    [sym_char] = STATE(1080),
    [sym_format_string] = STATE(1090),
    [sym__string_literal] = STATE(1090),
    [sym_string] = STATE(1080),
    [sym_verbatim_string] = STATE(1080),
    [sym_bytearray] = STATE(1080),
    [sym_verbatim_bytearray] = STATE(1080),
    [sym_format_triple_quoted_string] = STATE(1096),
    [sym_triple_quoted_string] = STATE(1080),
    [sym_const] = STATE(1118),
    [sym_long_identifier] = STATE(1156),
    [sym_active_pattern] = STATE(1085),
    [sym__identifier_or_op] = STATE(1099),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(517),
    [sym_sbyte] = STATE(1080),
    [sym_byte] = STATE(1080),
    [sym_int16] = STATE(1080),
    [sym_uint16] = STATE(1080),
    [sym_int32] = STATE(1080),
    [sym_uint32] = STATE(1080),
    [sym_nativeint] = STATE(1080),
    [sym_unativeint] = STATE(1080),
    [sym_int64] = STATE(1080),
    [sym_uint64] = STATE(1080),
    [sym_ieee32] = STATE(1080),
    [sym_ieee64] = STATE(1080),
    [sym_bignum] = STATE(1080),
    [sym_decimal] = STATE(1080),
    [sym_float] = STATE(979),
    [sym_block_comment] = STATE(567),
    [sym_compiler_directive_decl] = STATE(567),
    [sym_fsi_directive_decl] = STATE(567),
    [sym_preproc_line] = STATE(567),
    [sym_preproc_if_in_expression] = STATE(1118),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(195),
    [anon_sym_return] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_null] = ACTIONS(207),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(209),
    [anon_sym_LBRACK_PIPE] = ACTIONS(211),
    [anon_sym_LBRACE] = ACTIONS(1687),
    [anon_sym_LT_AT] = ACTIONS(213),
    [anon_sym_LT_AT_AT] = ACTIONS(1689),
    [anon_sym_LBRACE_PIPE] = ACTIONS(217),
    [anon_sym_new] = ACTIONS(199),
    [anon_sym_return_BANG] = ACTIONS(219),
    [anon_sym_yield] = ACTIONS(199),
    [anon_sym_yield_BANG] = ACTIONS(219),
    [anon_sym_lazy] = ACTIONS(199),
    [anon_sym_assert] = ACTIONS(199),
    [anon_sym_upcast] = ACTIONS(199),
    [anon_sym_downcast] = ACTIONS(199),
    [anon_sym_for] = ACTIONS(223),
    [anon_sym_while] = ACTIONS(225),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(229),
    [anon_sym_match] = ACTIONS(231),
    [anon_sym_match_BANG] = ACTIONS(233),
    [anon_sym_function] = ACTIONS(235),
    [anon_sym_use] = ACTIONS(239),
    [anon_sym_use_BANG] = ACTIONS(241),
    [anon_sym_do_BANG] = ACTIONS(243),
    [anon_sym_begin] = ACTIONS(245),
    [aux_sym_char_token1] = ACTIONS(247),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(251),
    [anon_sym_AT_DQUOTE] = ACTIONS(253),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(255),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(257),
    [sym_bool] = ACTIONS(259),
    [sym_unit] = ACTIONS(1699),
    [anon_sym_LPAREN_PIPE] = ACTIONS(261),
    [sym_op_identifier] = ACTIONS(1701),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(265),
    [sym_xint] = ACTIONS(267),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(269),
  },
  [568] = {
    [sym_function_or_value_defn] = STATE(627),
    [sym__expression] = STATE(350),
    [sym_literal_expression] = STATE(1118),
    [sym_long_identifier_or_op] = STATE(1118),
    [sym_tuple_expression] = STATE(1118),
    [sym_brace_expression] = STATE(1118),
    [sym_anon_record_expression] = STATE(1118),
    [sym_prefixed_expression] = STATE(1118),
    [sym_typecast_expression] = STATE(1118),
    [sym_for_expression] = STATE(1118),
    [sym_while_expression] = STATE(1118),
    [sym__if_branch] = STATE(7163),
    [sym_if_expression] = STATE(1118),
    [sym_fun_expression] = STATE(1118),
    [sym_try_expression] = STATE(1118),
    [sym_match_expression] = STATE(1118),
    [sym_function_expression] = STATE(1118),
    [sym_mutate_expression] = STATE(1118),
    [sym_index_expression] = STATE(1118),
    [sym_typed_expression] = STATE(1118),
    [sym_declaration_expression] = STATE(1118),
    [sym_do_expression] = STATE(1118),
    [sym_list_expression] = STATE(1118),
    [sym_array_expression] = STATE(1118),
    [sym_begin_end_expression] = STATE(1118),
    [sym_paren_expression] = STATE(1118),
    [sym__high_prec_app] = STATE(1133),
    [sym__low_prec_app] = STATE(1133),
    [sym_application_expression] = STATE(1118),
    [sym_dot_expression] = STATE(1118),
    [sym_infix_expression] = STATE(1118),
    [sym_ce_expression] = STATE(1118),
    [sym_sequential_expression] = STATE(1118),
    [sym_char] = STATE(1080),
    [sym_format_string] = STATE(1090),
    [sym__string_literal] = STATE(1090),
    [sym_string] = STATE(1080),
    [sym_verbatim_string] = STATE(1080),
    [sym_bytearray] = STATE(1080),
    [sym_verbatim_bytearray] = STATE(1080),
    [sym_format_triple_quoted_string] = STATE(1096),
    [sym_triple_quoted_string] = STATE(1080),
    [sym_const] = STATE(1118),
    [sym_long_identifier] = STATE(1156),
    [sym_active_pattern] = STATE(1085),
    [sym__identifier_or_op] = STATE(1099),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(517),
    [sym_sbyte] = STATE(1080),
    [sym_byte] = STATE(1080),
    [sym_int16] = STATE(1080),
    [sym_uint16] = STATE(1080),
    [sym_int32] = STATE(1080),
    [sym_uint32] = STATE(1080),
    [sym_nativeint] = STATE(1080),
    [sym_unativeint] = STATE(1080),
    [sym_int64] = STATE(1080),
    [sym_uint64] = STATE(1080),
    [sym_ieee32] = STATE(1080),
    [sym_ieee64] = STATE(1080),
    [sym_bignum] = STATE(1080),
    [sym_decimal] = STATE(1080),
    [sym_float] = STATE(979),
    [sym_block_comment] = STATE(568),
    [sym_compiler_directive_decl] = STATE(568),
    [sym_fsi_directive_decl] = STATE(568),
    [sym_preproc_line] = STATE(568),
    [sym_preproc_if_in_expression] = STATE(1118),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(195),
    [anon_sym_return] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_null] = ACTIONS(207),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(209),
    [anon_sym_LBRACK_PIPE] = ACTIONS(211),
    [anon_sym_LBRACE] = ACTIONS(1687),
    [anon_sym_LT_AT] = ACTIONS(213),
    [anon_sym_LT_AT_AT] = ACTIONS(1689),
    [anon_sym_LBRACE_PIPE] = ACTIONS(217),
    [anon_sym_new] = ACTIONS(199),
    [anon_sym_return_BANG] = ACTIONS(219),
    [anon_sym_yield] = ACTIONS(199),
    [anon_sym_yield_BANG] = ACTIONS(219),
    [anon_sym_lazy] = ACTIONS(199),
    [anon_sym_assert] = ACTIONS(199),
    [anon_sym_upcast] = ACTIONS(199),
    [anon_sym_downcast] = ACTIONS(199),
    [anon_sym_for] = ACTIONS(223),
    [anon_sym_while] = ACTIONS(225),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(229),
    [anon_sym_match] = ACTIONS(231),
    [anon_sym_match_BANG] = ACTIONS(233),
    [anon_sym_function] = ACTIONS(235),
    [anon_sym_use] = ACTIONS(239),
    [anon_sym_use_BANG] = ACTIONS(241),
    [anon_sym_do_BANG] = ACTIONS(243),
    [anon_sym_begin] = ACTIONS(245),
    [aux_sym_char_token1] = ACTIONS(247),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(251),
    [anon_sym_AT_DQUOTE] = ACTIONS(253),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(255),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(257),
    [sym_bool] = ACTIONS(259),
    [sym_unit] = ACTIONS(1699),
    [anon_sym_LPAREN_PIPE] = ACTIONS(261),
    [sym_op_identifier] = ACTIONS(1701),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(265),
    [sym_xint] = ACTIONS(267),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(269),
  },
  [569] = {
    [sym_function_or_value_defn] = STATE(600),
    [sym__expression] = STATE(233),
    [sym_literal_expression] = STATE(867),
    [sym_long_identifier_or_op] = STATE(867),
    [sym_tuple_expression] = STATE(867),
    [sym_brace_expression] = STATE(867),
    [sym_anon_record_expression] = STATE(867),
    [sym_prefixed_expression] = STATE(867),
    [sym_typecast_expression] = STATE(867),
    [sym_for_expression] = STATE(867),
    [sym_while_expression] = STATE(867),
    [sym__if_branch] = STATE(6511),
    [sym_if_expression] = STATE(867),
    [sym_fun_expression] = STATE(867),
    [sym_try_expression] = STATE(867),
    [sym_match_expression] = STATE(867),
    [sym_function_expression] = STATE(867),
    [sym_mutate_expression] = STATE(867),
    [sym_index_expression] = STATE(867),
    [sym_typed_expression] = STATE(867),
    [sym_declaration_expression] = STATE(867),
    [sym_do_expression] = STATE(867),
    [sym_list_expression] = STATE(867),
    [sym_array_expression] = STATE(867),
    [sym_begin_end_expression] = STATE(867),
    [sym_paren_expression] = STATE(867),
    [sym__high_prec_app] = STATE(864),
    [sym__low_prec_app] = STATE(864),
    [sym_application_expression] = STATE(867),
    [sym_dot_expression] = STATE(867),
    [sym_infix_expression] = STATE(867),
    [sym_ce_expression] = STATE(867),
    [sym_sequential_expression] = STATE(867),
    [sym_char] = STATE(868),
    [sym_format_string] = STATE(869),
    [sym__string_literal] = STATE(869),
    [sym_string] = STATE(868),
    [sym_verbatim_string] = STATE(868),
    [sym_bytearray] = STATE(868),
    [sym_verbatim_bytearray] = STATE(868),
    [sym_format_triple_quoted_string] = STATE(870),
    [sym_triple_quoted_string] = STATE(868),
    [sym_const] = STATE(867),
    [sym_long_identifier] = STATE(872),
    [sym_active_pattern] = STATE(871),
    [sym__identifier_or_op] = STATE(873),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(656),
    [sym_sbyte] = STATE(868),
    [sym_byte] = STATE(868),
    [sym_int16] = STATE(868),
    [sym_uint16] = STATE(868),
    [sym_int32] = STATE(868),
    [sym_uint32] = STATE(868),
    [sym_nativeint] = STATE(868),
    [sym_unativeint] = STATE(868),
    [sym_int64] = STATE(868),
    [sym_uint64] = STATE(868),
    [sym_ieee32] = STATE(868),
    [sym_ieee64] = STATE(868),
    [sym_bignum] = STATE(868),
    [sym_decimal] = STATE(868),
    [sym_float] = STATE(1368),
    [sym_block_comment] = STATE(569),
    [sym_compiler_directive_decl] = STATE(569),
    [sym_fsi_directive_decl] = STATE(569),
    [sym_preproc_line] = STATE(569),
    [sym_preproc_if_in_expression] = STATE(867),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(29),
    [anon_sym_return] = ACTIONS(825),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_null] = ACTIONS(49),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACK_PIPE] = ACTIONS(57),
    [anon_sym_LBRACE] = ACTIONS(1663),
    [anon_sym_LT_AT] = ACTIONS(61),
    [anon_sym_LT_AT_AT] = ACTIONS(1665),
    [anon_sym_LBRACE_PIPE] = ACTIONS(67),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_return_BANG] = ACTIONS(829),
    [anon_sym_yield] = ACTIONS(825),
    [anon_sym_yield_BANG] = ACTIONS(829),
    [anon_sym_lazy] = ACTIONS(825),
    [anon_sym_assert] = ACTIONS(825),
    [anon_sym_upcast] = ACTIONS(825),
    [anon_sym_downcast] = ACTIONS(825),
    [anon_sym_for] = ACTIONS(73),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(79),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_match] = ACTIONS(83),
    [anon_sym_match_BANG] = ACTIONS(85),
    [anon_sym_function] = ACTIONS(87),
    [anon_sym_use] = ACTIONS(833),
    [anon_sym_use_BANG] = ACTIONS(835),
    [anon_sym_do_BANG] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(101),
    [aux_sym_char_token1] = ACTIONS(105),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(107),
    [anon_sym_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DQUOTE] = ACTIONS(111),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(115),
    [sym_bool] = ACTIONS(117),
    [sym_unit] = ACTIONS(1673),
    [anon_sym_LPAREN_PIPE] = ACTIONS(121),
    [sym_op_identifier] = ACTIONS(1675),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(837),
    [sym_xint] = ACTIONS(387),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(135),
  },
  [570] = {
    [sym_function_or_value_defn] = STATE(509),
    [sym__expression] = STATE(217),
    [sym_literal_expression] = STATE(2230),
    [sym_long_identifier_or_op] = STATE(2230),
    [sym_tuple_expression] = STATE(2230),
    [sym_brace_expression] = STATE(2230),
    [sym_anon_record_expression] = STATE(2230),
    [sym_prefixed_expression] = STATE(2230),
    [sym_typecast_expression] = STATE(2230),
    [sym_for_expression] = STATE(2230),
    [sym_while_expression] = STATE(2230),
    [sym__if_branch] = STATE(6659),
    [sym_if_expression] = STATE(2230),
    [sym_fun_expression] = STATE(2230),
    [sym_try_expression] = STATE(2230),
    [sym_match_expression] = STATE(2230),
    [sym_function_expression] = STATE(2230),
    [sym_mutate_expression] = STATE(2230),
    [sym_index_expression] = STATE(2230),
    [sym_typed_expression] = STATE(2230),
    [sym_declaration_expression] = STATE(2230),
    [sym_do_expression] = STATE(2230),
    [sym_list_expression] = STATE(2230),
    [sym_array_expression] = STATE(2230),
    [sym_begin_end_expression] = STATE(2230),
    [sym_paren_expression] = STATE(2230),
    [sym__high_prec_app] = STATE(2229),
    [sym__low_prec_app] = STATE(2229),
    [sym_application_expression] = STATE(2230),
    [sym_dot_expression] = STATE(2230),
    [sym_infix_expression] = STATE(2230),
    [sym_ce_expression] = STATE(2230),
    [sym_sequential_expression] = STATE(2230),
    [sym_char] = STATE(2100),
    [sym_format_string] = STATE(2106),
    [sym__string_literal] = STATE(2106),
    [sym_string] = STATE(2100),
    [sym_verbatim_string] = STATE(2100),
    [sym_bytearray] = STATE(2100),
    [sym_verbatim_bytearray] = STATE(2100),
    [sym_format_triple_quoted_string] = STATE(2107),
    [sym_triple_quoted_string] = STATE(2100),
    [sym_const] = STATE(2230),
    [sym_long_identifier] = STATE(2232),
    [sym_active_pattern] = STATE(2424),
    [sym__identifier_or_op] = STATE(2305),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(737),
    [sym_sbyte] = STATE(2100),
    [sym_byte] = STATE(2100),
    [sym_int16] = STATE(2100),
    [sym_uint16] = STATE(2100),
    [sym_int32] = STATE(2100),
    [sym_uint32] = STATE(2100),
    [sym_nativeint] = STATE(2100),
    [sym_unativeint] = STATE(2100),
    [sym_int64] = STATE(2100),
    [sym_uint64] = STATE(2100),
    [sym_ieee32] = STATE(2100),
    [sym_ieee64] = STATE(2100),
    [sym_bignum] = STATE(2100),
    [sym_decimal] = STATE(2100),
    [sym_float] = STATE(1487),
    [sym_block_comment] = STATE(570),
    [sym_compiler_directive_decl] = STATE(570),
    [sym_fsi_directive_decl] = STATE(570),
    [sym_preproc_line] = STATE(570),
    [sym_preproc_if_in_expression] = STATE(2230),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(877),
    [anon_sym_return] = ACTIONS(881),
    [anon_sym_do] = ACTIONS(1585),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(885),
    [anon_sym_null] = ACTIONS(889),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(891),
    [anon_sym_LBRACK_PIPE] = ACTIONS(893),
    [anon_sym_LBRACE] = ACTIONS(2048),
    [anon_sym_LT_AT] = ACTIONS(897),
    [anon_sym_LT_AT_AT] = ACTIONS(2050),
    [anon_sym_LBRACE_PIPE] = ACTIONS(903),
    [anon_sym_new] = ACTIONS(881),
    [anon_sym_return_BANG] = ACTIONS(905),
    [anon_sym_yield] = ACTIONS(881),
    [anon_sym_yield_BANG] = ACTIONS(905),
    [anon_sym_lazy] = ACTIONS(881),
    [anon_sym_assert] = ACTIONS(881),
    [anon_sym_upcast] = ACTIONS(881),
    [anon_sym_downcast] = ACTIONS(881),
    [anon_sym_for] = ACTIONS(909),
    [anon_sym_while] = ACTIONS(911),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(913),
    [anon_sym_try] = ACTIONS(915),
    [anon_sym_match] = ACTIONS(917),
    [anon_sym_match_BANG] = ACTIONS(919),
    [anon_sym_function] = ACTIONS(921),
    [anon_sym_use] = ACTIONS(929),
    [anon_sym_use_BANG] = ACTIONS(931),
    [anon_sym_do_BANG] = ACTIONS(933),
    [anon_sym_begin] = ACTIONS(937),
    [aux_sym_char_token1] = ACTIONS(941),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(943),
    [anon_sym_DQUOTE] = ACTIONS(945),
    [anon_sym_AT_DQUOTE] = ACTIONS(947),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(949),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(951),
    [sym_bool] = ACTIONS(953),
    [sym_unit] = ACTIONS(2052),
    [anon_sym_LPAREN_PIPE] = ACTIONS(957),
    [sym_op_identifier] = ACTIONS(2054),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(961),
    [sym_xint] = ACTIONS(963),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(965),
  },
  [571] = {
    [sym_function_or_value_defn] = STATE(627),
    [sym__expression] = STATE(274),
    [sym_literal_expression] = STATE(1118),
    [sym_long_identifier_or_op] = STATE(1118),
    [sym_tuple_expression] = STATE(1118),
    [sym_brace_expression] = STATE(1118),
    [sym_anon_record_expression] = STATE(1118),
    [sym_prefixed_expression] = STATE(1118),
    [sym_typecast_expression] = STATE(1118),
    [sym_for_expression] = STATE(1118),
    [sym_while_expression] = STATE(1118),
    [sym__if_branch] = STATE(7163),
    [sym_if_expression] = STATE(1118),
    [sym_fun_expression] = STATE(1118),
    [sym_try_expression] = STATE(1118),
    [sym_match_expression] = STATE(1118),
    [sym_function_expression] = STATE(1118),
    [sym_mutate_expression] = STATE(1118),
    [sym_index_expression] = STATE(1118),
    [sym_typed_expression] = STATE(1118),
    [sym_declaration_expression] = STATE(1118),
    [sym_do_expression] = STATE(1118),
    [sym_list_expression] = STATE(1118),
    [sym_array_expression] = STATE(1118),
    [sym_begin_end_expression] = STATE(1118),
    [sym_paren_expression] = STATE(1118),
    [sym__high_prec_app] = STATE(1133),
    [sym__low_prec_app] = STATE(1133),
    [sym_application_expression] = STATE(1118),
    [sym_dot_expression] = STATE(1118),
    [sym_infix_expression] = STATE(1118),
    [sym_ce_expression] = STATE(1118),
    [sym_sequential_expression] = STATE(1118),
    [sym_char] = STATE(1080),
    [sym_format_string] = STATE(1090),
    [sym__string_literal] = STATE(1090),
    [sym_string] = STATE(1080),
    [sym_verbatim_string] = STATE(1080),
    [sym_bytearray] = STATE(1080),
    [sym_verbatim_bytearray] = STATE(1080),
    [sym_format_triple_quoted_string] = STATE(1096),
    [sym_triple_quoted_string] = STATE(1080),
    [sym_const] = STATE(1118),
    [sym_long_identifier] = STATE(1156),
    [sym_active_pattern] = STATE(1085),
    [sym__identifier_or_op] = STATE(1099),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(517),
    [sym_sbyte] = STATE(1080),
    [sym_byte] = STATE(1080),
    [sym_int16] = STATE(1080),
    [sym_uint16] = STATE(1080),
    [sym_int32] = STATE(1080),
    [sym_uint32] = STATE(1080),
    [sym_nativeint] = STATE(1080),
    [sym_unativeint] = STATE(1080),
    [sym_int64] = STATE(1080),
    [sym_uint64] = STATE(1080),
    [sym_ieee32] = STATE(1080),
    [sym_ieee64] = STATE(1080),
    [sym_bignum] = STATE(1080),
    [sym_decimal] = STATE(1080),
    [sym_float] = STATE(979),
    [sym_block_comment] = STATE(571),
    [sym_compiler_directive_decl] = STATE(571),
    [sym_fsi_directive_decl] = STATE(571),
    [sym_preproc_line] = STATE(571),
    [sym_preproc_if_in_expression] = STATE(1118),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(195),
    [anon_sym_return] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_null] = ACTIONS(207),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(209),
    [anon_sym_LBRACK_PIPE] = ACTIONS(211),
    [anon_sym_LBRACE] = ACTIONS(1687),
    [anon_sym_LT_AT] = ACTIONS(213),
    [anon_sym_LT_AT_AT] = ACTIONS(1689),
    [anon_sym_LBRACE_PIPE] = ACTIONS(217),
    [anon_sym_new] = ACTIONS(199),
    [anon_sym_return_BANG] = ACTIONS(219),
    [anon_sym_yield] = ACTIONS(199),
    [anon_sym_yield_BANG] = ACTIONS(219),
    [anon_sym_lazy] = ACTIONS(199),
    [anon_sym_assert] = ACTIONS(199),
    [anon_sym_upcast] = ACTIONS(199),
    [anon_sym_downcast] = ACTIONS(199),
    [anon_sym_for] = ACTIONS(223),
    [anon_sym_while] = ACTIONS(225),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(229),
    [anon_sym_match] = ACTIONS(231),
    [anon_sym_match_BANG] = ACTIONS(233),
    [anon_sym_function] = ACTIONS(235),
    [anon_sym_use] = ACTIONS(239),
    [anon_sym_use_BANG] = ACTIONS(241),
    [anon_sym_do_BANG] = ACTIONS(243),
    [anon_sym_begin] = ACTIONS(245),
    [aux_sym_char_token1] = ACTIONS(247),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(251),
    [anon_sym_AT_DQUOTE] = ACTIONS(253),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(255),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(257),
    [sym_bool] = ACTIONS(259),
    [sym_unit] = ACTIONS(1699),
    [anon_sym_LPAREN_PIPE] = ACTIONS(261),
    [sym_op_identifier] = ACTIONS(1701),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(265),
    [sym_xint] = ACTIONS(267),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(269),
  },
  [572] = {
    [sym_function_or_value_defn] = STATE(600),
    [sym__expression] = STATE(308),
    [sym_literal_expression] = STATE(867),
    [sym_long_identifier_or_op] = STATE(867),
    [sym_tuple_expression] = STATE(867),
    [sym_brace_expression] = STATE(867),
    [sym_anon_record_expression] = STATE(867),
    [sym_prefixed_expression] = STATE(867),
    [sym_typecast_expression] = STATE(867),
    [sym_for_expression] = STATE(867),
    [sym_while_expression] = STATE(867),
    [sym__if_branch] = STATE(6511),
    [sym_if_expression] = STATE(867),
    [sym_fun_expression] = STATE(867),
    [sym_try_expression] = STATE(867),
    [sym_match_expression] = STATE(867),
    [sym_function_expression] = STATE(867),
    [sym_mutate_expression] = STATE(867),
    [sym_index_expression] = STATE(867),
    [sym_typed_expression] = STATE(867),
    [sym_declaration_expression] = STATE(867),
    [sym_do_expression] = STATE(867),
    [sym_list_expression] = STATE(867),
    [sym_array_expression] = STATE(867),
    [sym_begin_end_expression] = STATE(867),
    [sym_paren_expression] = STATE(867),
    [sym__high_prec_app] = STATE(864),
    [sym__low_prec_app] = STATE(864),
    [sym_application_expression] = STATE(867),
    [sym_dot_expression] = STATE(867),
    [sym_infix_expression] = STATE(867),
    [sym_ce_expression] = STATE(867),
    [sym_sequential_expression] = STATE(867),
    [sym_char] = STATE(868),
    [sym_format_string] = STATE(869),
    [sym__string_literal] = STATE(869),
    [sym_string] = STATE(868),
    [sym_verbatim_string] = STATE(868),
    [sym_bytearray] = STATE(868),
    [sym_verbatim_bytearray] = STATE(868),
    [sym_format_triple_quoted_string] = STATE(870),
    [sym_triple_quoted_string] = STATE(868),
    [sym_const] = STATE(867),
    [sym_long_identifier] = STATE(872),
    [sym_active_pattern] = STATE(871),
    [sym__identifier_or_op] = STATE(873),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(656),
    [sym_sbyte] = STATE(868),
    [sym_byte] = STATE(868),
    [sym_int16] = STATE(868),
    [sym_uint16] = STATE(868),
    [sym_int32] = STATE(868),
    [sym_uint32] = STATE(868),
    [sym_nativeint] = STATE(868),
    [sym_unativeint] = STATE(868),
    [sym_int64] = STATE(868),
    [sym_uint64] = STATE(868),
    [sym_ieee32] = STATE(868),
    [sym_ieee64] = STATE(868),
    [sym_bignum] = STATE(868),
    [sym_decimal] = STATE(868),
    [sym_float] = STATE(1368),
    [sym_block_comment] = STATE(572),
    [sym_compiler_directive_decl] = STATE(572),
    [sym_fsi_directive_decl] = STATE(572),
    [sym_preproc_line] = STATE(572),
    [sym_preproc_if_in_expression] = STATE(867),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(29),
    [anon_sym_return] = ACTIONS(825),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_null] = ACTIONS(49),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACK_PIPE] = ACTIONS(57),
    [anon_sym_LBRACE] = ACTIONS(1663),
    [anon_sym_LT_AT] = ACTIONS(61),
    [anon_sym_LT_AT_AT] = ACTIONS(1665),
    [anon_sym_LBRACE_PIPE] = ACTIONS(67),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_return_BANG] = ACTIONS(829),
    [anon_sym_yield] = ACTIONS(825),
    [anon_sym_yield_BANG] = ACTIONS(829),
    [anon_sym_lazy] = ACTIONS(825),
    [anon_sym_assert] = ACTIONS(825),
    [anon_sym_upcast] = ACTIONS(825),
    [anon_sym_downcast] = ACTIONS(825),
    [anon_sym_for] = ACTIONS(73),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(79),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_match] = ACTIONS(83),
    [anon_sym_match_BANG] = ACTIONS(85),
    [anon_sym_function] = ACTIONS(87),
    [anon_sym_use] = ACTIONS(833),
    [anon_sym_use_BANG] = ACTIONS(835),
    [anon_sym_do_BANG] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(101),
    [aux_sym_char_token1] = ACTIONS(105),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(107),
    [anon_sym_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DQUOTE] = ACTIONS(111),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(115),
    [sym_bool] = ACTIONS(117),
    [sym_unit] = ACTIONS(1673),
    [anon_sym_LPAREN_PIPE] = ACTIONS(121),
    [sym_op_identifier] = ACTIONS(1675),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(837),
    [sym_xint] = ACTIONS(387),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(135),
  },
  [573] = {
    [sym_function_or_value_defn] = STATE(729),
    [sym__expression] = STATE(95),
    [sym_literal_expression] = STATE(867),
    [sym_long_identifier_or_op] = STATE(867),
    [sym_tuple_expression] = STATE(867),
    [sym_brace_expression] = STATE(867),
    [sym_anon_record_expression] = STATE(867),
    [sym_prefixed_expression] = STATE(867),
    [sym_typecast_expression] = STATE(867),
    [sym_for_expression] = STATE(867),
    [sym_while_expression] = STATE(867),
    [sym__if_branch] = STATE(6511),
    [sym_if_expression] = STATE(867),
    [sym_fun_expression] = STATE(867),
    [sym_try_expression] = STATE(867),
    [sym_match_expression] = STATE(867),
    [sym_function_expression] = STATE(867),
    [sym_mutate_expression] = STATE(867),
    [sym_index_expression] = STATE(867),
    [sym_typed_expression] = STATE(867),
    [sym_declaration_expression] = STATE(867),
    [sym_do_expression] = STATE(867),
    [sym_list_expression] = STATE(867),
    [sym_array_expression] = STATE(867),
    [sym_begin_end_expression] = STATE(867),
    [sym_paren_expression] = STATE(867),
    [sym__high_prec_app] = STATE(864),
    [sym__low_prec_app] = STATE(864),
    [sym_application_expression] = STATE(867),
    [sym_dot_expression] = STATE(867),
    [sym_infix_expression] = STATE(867),
    [sym_ce_expression] = STATE(867),
    [sym_sequential_expression] = STATE(867),
    [sym_char] = STATE(868),
    [sym_format_string] = STATE(869),
    [sym__string_literal] = STATE(869),
    [sym_string] = STATE(868),
    [sym_verbatim_string] = STATE(868),
    [sym_bytearray] = STATE(868),
    [sym_verbatim_bytearray] = STATE(868),
    [sym_format_triple_quoted_string] = STATE(870),
    [sym_triple_quoted_string] = STATE(868),
    [sym_const] = STATE(867),
    [sym_long_identifier] = STATE(872),
    [sym_active_pattern] = STATE(871),
    [sym__identifier_or_op] = STATE(873),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(499),
    [sym_sbyte] = STATE(868),
    [sym_byte] = STATE(868),
    [sym_int16] = STATE(868),
    [sym_uint16] = STATE(868),
    [sym_int32] = STATE(868),
    [sym_uint32] = STATE(868),
    [sym_nativeint] = STATE(868),
    [sym_unativeint] = STATE(868),
    [sym_int64] = STATE(868),
    [sym_uint64] = STATE(868),
    [sym_ieee32] = STATE(868),
    [sym_ieee64] = STATE(868),
    [sym_bignum] = STATE(868),
    [sym_decimal] = STATE(868),
    [sym_float] = STATE(1368),
    [sym_block_comment] = STATE(573),
    [sym_compiler_directive_decl] = STATE(573),
    [sym_fsi_directive_decl] = STATE(573),
    [sym_preproc_line] = STATE(573),
    [sym_preproc_if_in_expression] = STATE(867),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(29),
    [anon_sym_return] = ACTIONS(369),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_null] = ACTIONS(49),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACK_PIPE] = ACTIONS(57),
    [anon_sym_LBRACE] = ACTIONS(1663),
    [anon_sym_LT_AT] = ACTIONS(61),
    [anon_sym_LT_AT_AT] = ACTIONS(1665),
    [anon_sym_LBRACE_PIPE] = ACTIONS(67),
    [anon_sym_new] = ACTIONS(369),
    [anon_sym_return_BANG] = ACTIONS(373),
    [anon_sym_yield] = ACTIONS(369),
    [anon_sym_yield_BANG] = ACTIONS(373),
    [anon_sym_lazy] = ACTIONS(369),
    [anon_sym_assert] = ACTIONS(369),
    [anon_sym_upcast] = ACTIONS(369),
    [anon_sym_downcast] = ACTIONS(369),
    [anon_sym_for] = ACTIONS(375),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(79),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_match] = ACTIONS(83),
    [anon_sym_match_BANG] = ACTIONS(85),
    [anon_sym_function] = ACTIONS(87),
    [anon_sym_use] = ACTIONS(379),
    [anon_sym_use_BANG] = ACTIONS(381),
    [anon_sym_do_BANG] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(101),
    [aux_sym_char_token1] = ACTIONS(105),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(107),
    [anon_sym_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DQUOTE] = ACTIONS(111),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(115),
    [sym_bool] = ACTIONS(117),
    [sym_unit] = ACTIONS(1673),
    [anon_sym_LPAREN_PIPE] = ACTIONS(121),
    [sym_op_identifier] = ACTIONS(1675),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(385),
    [sym_xint] = ACTIONS(387),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(135),
  },
  [574] = {
    [sym_function_or_value_defn] = STATE(627),
    [sym__expression] = STATE(58),
    [sym_literal_expression] = STATE(1118),
    [sym_long_identifier_or_op] = STATE(1118),
    [sym_tuple_expression] = STATE(1118),
    [sym_brace_expression] = STATE(1118),
    [sym_anon_record_expression] = STATE(1118),
    [sym_prefixed_expression] = STATE(1118),
    [sym_typecast_expression] = STATE(1118),
    [sym_for_expression] = STATE(1118),
    [sym_while_expression] = STATE(1118),
    [sym__if_branch] = STATE(7163),
    [sym_if_expression] = STATE(1118),
    [sym_fun_expression] = STATE(1118),
    [sym_try_expression] = STATE(1118),
    [sym_match_expression] = STATE(1118),
    [sym_function_expression] = STATE(1118),
    [sym_mutate_expression] = STATE(1118),
    [sym_index_expression] = STATE(1118),
    [sym_typed_expression] = STATE(1118),
    [sym_declaration_expression] = STATE(1118),
    [sym_do_expression] = STATE(1118),
    [sym_list_expression] = STATE(1118),
    [sym_array_expression] = STATE(1118),
    [sym_begin_end_expression] = STATE(1118),
    [sym_paren_expression] = STATE(1118),
    [sym__high_prec_app] = STATE(1133),
    [sym__low_prec_app] = STATE(1133),
    [sym_application_expression] = STATE(1118),
    [sym_dot_expression] = STATE(1118),
    [sym_infix_expression] = STATE(1118),
    [sym_ce_expression] = STATE(1118),
    [sym_sequential_expression] = STATE(1118),
    [sym_char] = STATE(1080),
    [sym_format_string] = STATE(1090),
    [sym__string_literal] = STATE(1090),
    [sym_string] = STATE(1080),
    [sym_verbatim_string] = STATE(1080),
    [sym_bytearray] = STATE(1080),
    [sym_verbatim_bytearray] = STATE(1080),
    [sym_format_triple_quoted_string] = STATE(1096),
    [sym_triple_quoted_string] = STATE(1080),
    [sym_const] = STATE(1118),
    [sym_long_identifier] = STATE(1156),
    [sym_active_pattern] = STATE(1085),
    [sym__identifier_or_op] = STATE(1099),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(517),
    [sym_sbyte] = STATE(1080),
    [sym_byte] = STATE(1080),
    [sym_int16] = STATE(1080),
    [sym_uint16] = STATE(1080),
    [sym_int32] = STATE(1080),
    [sym_uint32] = STATE(1080),
    [sym_nativeint] = STATE(1080),
    [sym_unativeint] = STATE(1080),
    [sym_int64] = STATE(1080),
    [sym_uint64] = STATE(1080),
    [sym_ieee32] = STATE(1080),
    [sym_ieee64] = STATE(1080),
    [sym_bignum] = STATE(1080),
    [sym_decimal] = STATE(1080),
    [sym_float] = STATE(979),
    [sym_block_comment] = STATE(574),
    [sym_compiler_directive_decl] = STATE(574),
    [sym_fsi_directive_decl] = STATE(574),
    [sym_preproc_line] = STATE(574),
    [sym_preproc_if_in_expression] = STATE(1118),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(195),
    [anon_sym_return] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_null] = ACTIONS(207),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(209),
    [anon_sym_LBRACK_PIPE] = ACTIONS(211),
    [anon_sym_LBRACE] = ACTIONS(1687),
    [anon_sym_LT_AT] = ACTIONS(213),
    [anon_sym_LT_AT_AT] = ACTIONS(1689),
    [anon_sym_LBRACE_PIPE] = ACTIONS(217),
    [anon_sym_new] = ACTIONS(199),
    [anon_sym_return_BANG] = ACTIONS(219),
    [anon_sym_yield] = ACTIONS(199),
    [anon_sym_yield_BANG] = ACTIONS(219),
    [anon_sym_lazy] = ACTIONS(199),
    [anon_sym_assert] = ACTIONS(199),
    [anon_sym_upcast] = ACTIONS(199),
    [anon_sym_downcast] = ACTIONS(199),
    [anon_sym_for] = ACTIONS(223),
    [anon_sym_while] = ACTIONS(225),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(229),
    [anon_sym_match] = ACTIONS(231),
    [anon_sym_match_BANG] = ACTIONS(233),
    [anon_sym_function] = ACTIONS(235),
    [anon_sym_use] = ACTIONS(239),
    [anon_sym_use_BANG] = ACTIONS(241),
    [anon_sym_do_BANG] = ACTIONS(243),
    [anon_sym_begin] = ACTIONS(245),
    [aux_sym_char_token1] = ACTIONS(247),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(251),
    [anon_sym_AT_DQUOTE] = ACTIONS(253),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(255),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(257),
    [sym_bool] = ACTIONS(259),
    [sym_unit] = ACTIONS(1699),
    [anon_sym_LPAREN_PIPE] = ACTIONS(261),
    [sym_op_identifier] = ACTIONS(1701),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(265),
    [sym_xint] = ACTIONS(267),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(269),
  },
  [575] = {
    [sym_function_or_value_defn] = STATE(600),
    [sym__expression] = STATE(93),
    [sym_literal_expression] = STATE(867),
    [sym_long_identifier_or_op] = STATE(867),
    [sym_tuple_expression] = STATE(867),
    [sym_brace_expression] = STATE(867),
    [sym_anon_record_expression] = STATE(867),
    [sym_prefixed_expression] = STATE(867),
    [sym_typecast_expression] = STATE(867),
    [sym_for_expression] = STATE(867),
    [sym_while_expression] = STATE(867),
    [sym__if_branch] = STATE(6511),
    [sym_if_expression] = STATE(867),
    [sym_fun_expression] = STATE(867),
    [sym_try_expression] = STATE(867),
    [sym_match_expression] = STATE(867),
    [sym_function_expression] = STATE(867),
    [sym_mutate_expression] = STATE(867),
    [sym_index_expression] = STATE(867),
    [sym_typed_expression] = STATE(867),
    [sym_declaration_expression] = STATE(867),
    [sym_do_expression] = STATE(867),
    [sym_list_expression] = STATE(867),
    [sym_array_expression] = STATE(867),
    [sym_begin_end_expression] = STATE(867),
    [sym_paren_expression] = STATE(867),
    [sym__high_prec_app] = STATE(864),
    [sym__low_prec_app] = STATE(864),
    [sym_application_expression] = STATE(867),
    [sym_dot_expression] = STATE(867),
    [sym_infix_expression] = STATE(867),
    [sym_ce_expression] = STATE(867),
    [sym_sequential_expression] = STATE(867),
    [sym_char] = STATE(868),
    [sym_format_string] = STATE(869),
    [sym__string_literal] = STATE(869),
    [sym_string] = STATE(868),
    [sym_verbatim_string] = STATE(868),
    [sym_bytearray] = STATE(868),
    [sym_verbatim_bytearray] = STATE(868),
    [sym_format_triple_quoted_string] = STATE(870),
    [sym_triple_quoted_string] = STATE(868),
    [sym_const] = STATE(867),
    [sym_long_identifier] = STATE(872),
    [sym_active_pattern] = STATE(871),
    [sym__identifier_or_op] = STATE(873),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(656),
    [sym_sbyte] = STATE(868),
    [sym_byte] = STATE(868),
    [sym_int16] = STATE(868),
    [sym_uint16] = STATE(868),
    [sym_int32] = STATE(868),
    [sym_uint32] = STATE(868),
    [sym_nativeint] = STATE(868),
    [sym_unativeint] = STATE(868),
    [sym_int64] = STATE(868),
    [sym_uint64] = STATE(868),
    [sym_ieee32] = STATE(868),
    [sym_ieee64] = STATE(868),
    [sym_bignum] = STATE(868),
    [sym_decimal] = STATE(868),
    [sym_float] = STATE(1368),
    [sym_block_comment] = STATE(575),
    [sym_compiler_directive_decl] = STATE(575),
    [sym_fsi_directive_decl] = STATE(575),
    [sym_preproc_line] = STATE(575),
    [sym_preproc_if_in_expression] = STATE(867),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(29),
    [anon_sym_return] = ACTIONS(825),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_null] = ACTIONS(49),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACK_PIPE] = ACTIONS(57),
    [anon_sym_LBRACE] = ACTIONS(1663),
    [anon_sym_LT_AT] = ACTIONS(61),
    [anon_sym_LT_AT_AT] = ACTIONS(1665),
    [anon_sym_LBRACE_PIPE] = ACTIONS(67),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_return_BANG] = ACTIONS(829),
    [anon_sym_yield] = ACTIONS(825),
    [anon_sym_yield_BANG] = ACTIONS(829),
    [anon_sym_lazy] = ACTIONS(825),
    [anon_sym_assert] = ACTIONS(825),
    [anon_sym_upcast] = ACTIONS(825),
    [anon_sym_downcast] = ACTIONS(825),
    [anon_sym_for] = ACTIONS(73),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(79),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_match] = ACTIONS(83),
    [anon_sym_match_BANG] = ACTIONS(85),
    [anon_sym_function] = ACTIONS(87),
    [anon_sym_use] = ACTIONS(833),
    [anon_sym_use_BANG] = ACTIONS(835),
    [anon_sym_do_BANG] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(101),
    [aux_sym_char_token1] = ACTIONS(105),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(107),
    [anon_sym_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DQUOTE] = ACTIONS(111),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(115),
    [sym_bool] = ACTIONS(117),
    [sym_unit] = ACTIONS(1673),
    [anon_sym_LPAREN_PIPE] = ACTIONS(121),
    [sym_op_identifier] = ACTIONS(1675),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(837),
    [sym_xint] = ACTIONS(387),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(135),
  },
  [576] = {
    [sym_function_or_value_defn] = STATE(627),
    [sym__expression] = STATE(247),
    [sym_literal_expression] = STATE(1118),
    [sym_long_identifier_or_op] = STATE(1118),
    [sym_tuple_expression] = STATE(1118),
    [sym_brace_expression] = STATE(1118),
    [sym_anon_record_expression] = STATE(1118),
    [sym_prefixed_expression] = STATE(1118),
    [sym_typecast_expression] = STATE(1118),
    [sym_for_expression] = STATE(1118),
    [sym_while_expression] = STATE(1118),
    [sym__if_branch] = STATE(7163),
    [sym_if_expression] = STATE(1118),
    [sym_fun_expression] = STATE(1118),
    [sym_try_expression] = STATE(1118),
    [sym_match_expression] = STATE(1118),
    [sym_function_expression] = STATE(1118),
    [sym_mutate_expression] = STATE(1118),
    [sym_index_expression] = STATE(1118),
    [sym_typed_expression] = STATE(1118),
    [sym_declaration_expression] = STATE(1118),
    [sym_do_expression] = STATE(1118),
    [sym_list_expression] = STATE(1118),
    [sym_array_expression] = STATE(1118),
    [sym_begin_end_expression] = STATE(1118),
    [sym_paren_expression] = STATE(1118),
    [sym__high_prec_app] = STATE(1133),
    [sym__low_prec_app] = STATE(1133),
    [sym_application_expression] = STATE(1118),
    [sym_dot_expression] = STATE(1118),
    [sym_infix_expression] = STATE(1118),
    [sym_ce_expression] = STATE(1118),
    [sym_sequential_expression] = STATE(1118),
    [sym_char] = STATE(1080),
    [sym_format_string] = STATE(1090),
    [sym__string_literal] = STATE(1090),
    [sym_string] = STATE(1080),
    [sym_verbatim_string] = STATE(1080),
    [sym_bytearray] = STATE(1080),
    [sym_verbatim_bytearray] = STATE(1080),
    [sym_format_triple_quoted_string] = STATE(1096),
    [sym_triple_quoted_string] = STATE(1080),
    [sym_const] = STATE(1118),
    [sym_long_identifier] = STATE(1156),
    [sym_active_pattern] = STATE(1085),
    [sym__identifier_or_op] = STATE(1099),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(517),
    [sym_sbyte] = STATE(1080),
    [sym_byte] = STATE(1080),
    [sym_int16] = STATE(1080),
    [sym_uint16] = STATE(1080),
    [sym_int32] = STATE(1080),
    [sym_uint32] = STATE(1080),
    [sym_nativeint] = STATE(1080),
    [sym_unativeint] = STATE(1080),
    [sym_int64] = STATE(1080),
    [sym_uint64] = STATE(1080),
    [sym_ieee32] = STATE(1080),
    [sym_ieee64] = STATE(1080),
    [sym_bignum] = STATE(1080),
    [sym_decimal] = STATE(1080),
    [sym_float] = STATE(979),
    [sym_block_comment] = STATE(576),
    [sym_compiler_directive_decl] = STATE(576),
    [sym_fsi_directive_decl] = STATE(576),
    [sym_preproc_line] = STATE(576),
    [sym_preproc_if_in_expression] = STATE(1118),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(195),
    [anon_sym_return] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_null] = ACTIONS(207),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(209),
    [anon_sym_LBRACK_PIPE] = ACTIONS(211),
    [anon_sym_LBRACE] = ACTIONS(1687),
    [anon_sym_LT_AT] = ACTIONS(213),
    [anon_sym_LT_AT_AT] = ACTIONS(1689),
    [anon_sym_LBRACE_PIPE] = ACTIONS(217),
    [anon_sym_new] = ACTIONS(199),
    [anon_sym_return_BANG] = ACTIONS(219),
    [anon_sym_yield] = ACTIONS(199),
    [anon_sym_yield_BANG] = ACTIONS(219),
    [anon_sym_lazy] = ACTIONS(199),
    [anon_sym_assert] = ACTIONS(199),
    [anon_sym_upcast] = ACTIONS(199),
    [anon_sym_downcast] = ACTIONS(199),
    [anon_sym_for] = ACTIONS(223),
    [anon_sym_while] = ACTIONS(225),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(229),
    [anon_sym_match] = ACTIONS(231),
    [anon_sym_match_BANG] = ACTIONS(233),
    [anon_sym_function] = ACTIONS(235),
    [anon_sym_use] = ACTIONS(239),
    [anon_sym_use_BANG] = ACTIONS(241),
    [anon_sym_do_BANG] = ACTIONS(243),
    [anon_sym_begin] = ACTIONS(245),
    [aux_sym_char_token1] = ACTIONS(247),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(251),
    [anon_sym_AT_DQUOTE] = ACTIONS(253),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(255),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(257),
    [sym_bool] = ACTIONS(259),
    [sym_unit] = ACTIONS(1699),
    [anon_sym_LPAREN_PIPE] = ACTIONS(261),
    [sym_op_identifier] = ACTIONS(1701),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(265),
    [sym_xint] = ACTIONS(267),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(269),
  },
  [577] = {
    [sym_function_or_value_defn] = STATE(627),
    [sym__expression] = STATE(38),
    [sym_literal_expression] = STATE(1118),
    [sym_long_identifier_or_op] = STATE(1118),
    [sym_tuple_expression] = STATE(1118),
    [sym_brace_expression] = STATE(1118),
    [sym_anon_record_expression] = STATE(1118),
    [sym_prefixed_expression] = STATE(1118),
    [sym_typecast_expression] = STATE(1118),
    [sym_for_expression] = STATE(1118),
    [sym_while_expression] = STATE(1118),
    [sym__if_branch] = STATE(7163),
    [sym_if_expression] = STATE(1118),
    [sym_fun_expression] = STATE(1118),
    [sym_try_expression] = STATE(1118),
    [sym_match_expression] = STATE(1118),
    [sym_function_expression] = STATE(1118),
    [sym_mutate_expression] = STATE(1118),
    [sym_index_expression] = STATE(1118),
    [sym_typed_expression] = STATE(1118),
    [sym_declaration_expression] = STATE(1118),
    [sym_do_expression] = STATE(1118),
    [sym_list_expression] = STATE(1118),
    [sym_array_expression] = STATE(1118),
    [sym_begin_end_expression] = STATE(1118),
    [sym_paren_expression] = STATE(1118),
    [sym__high_prec_app] = STATE(1133),
    [sym__low_prec_app] = STATE(1133),
    [sym_application_expression] = STATE(1118),
    [sym_dot_expression] = STATE(1118),
    [sym_infix_expression] = STATE(1118),
    [sym_ce_expression] = STATE(1118),
    [sym_sequential_expression] = STATE(1118),
    [sym_char] = STATE(1080),
    [sym_format_string] = STATE(1090),
    [sym__string_literal] = STATE(1090),
    [sym_string] = STATE(1080),
    [sym_verbatim_string] = STATE(1080),
    [sym_bytearray] = STATE(1080),
    [sym_verbatim_bytearray] = STATE(1080),
    [sym_format_triple_quoted_string] = STATE(1096),
    [sym_triple_quoted_string] = STATE(1080),
    [sym_const] = STATE(1118),
    [sym_long_identifier] = STATE(1156),
    [sym_active_pattern] = STATE(1085),
    [sym__identifier_or_op] = STATE(1099),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(517),
    [sym_sbyte] = STATE(1080),
    [sym_byte] = STATE(1080),
    [sym_int16] = STATE(1080),
    [sym_uint16] = STATE(1080),
    [sym_int32] = STATE(1080),
    [sym_uint32] = STATE(1080),
    [sym_nativeint] = STATE(1080),
    [sym_unativeint] = STATE(1080),
    [sym_int64] = STATE(1080),
    [sym_uint64] = STATE(1080),
    [sym_ieee32] = STATE(1080),
    [sym_ieee64] = STATE(1080),
    [sym_bignum] = STATE(1080),
    [sym_decimal] = STATE(1080),
    [sym_float] = STATE(979),
    [sym_block_comment] = STATE(577),
    [sym_compiler_directive_decl] = STATE(577),
    [sym_fsi_directive_decl] = STATE(577),
    [sym_preproc_line] = STATE(577),
    [sym_preproc_if_in_expression] = STATE(1118),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(195),
    [anon_sym_return] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_null] = ACTIONS(207),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(209),
    [anon_sym_LBRACK_PIPE] = ACTIONS(211),
    [anon_sym_LBRACE] = ACTIONS(1687),
    [anon_sym_LT_AT] = ACTIONS(213),
    [anon_sym_LT_AT_AT] = ACTIONS(1689),
    [anon_sym_LBRACE_PIPE] = ACTIONS(217),
    [anon_sym_new] = ACTIONS(199),
    [anon_sym_return_BANG] = ACTIONS(219),
    [anon_sym_yield] = ACTIONS(199),
    [anon_sym_yield_BANG] = ACTIONS(219),
    [anon_sym_lazy] = ACTIONS(199),
    [anon_sym_assert] = ACTIONS(199),
    [anon_sym_upcast] = ACTIONS(199),
    [anon_sym_downcast] = ACTIONS(199),
    [anon_sym_for] = ACTIONS(223),
    [anon_sym_while] = ACTIONS(225),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(229),
    [anon_sym_match] = ACTIONS(231),
    [anon_sym_match_BANG] = ACTIONS(233),
    [anon_sym_function] = ACTIONS(235),
    [anon_sym_use] = ACTIONS(239),
    [anon_sym_use_BANG] = ACTIONS(241),
    [anon_sym_do_BANG] = ACTIONS(243),
    [anon_sym_begin] = ACTIONS(245),
    [aux_sym_char_token1] = ACTIONS(247),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(251),
    [anon_sym_AT_DQUOTE] = ACTIONS(253),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(255),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(257),
    [sym_bool] = ACTIONS(259),
    [sym_unit] = ACTIONS(1699),
    [anon_sym_LPAREN_PIPE] = ACTIONS(261),
    [sym_op_identifier] = ACTIONS(1701),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(265),
    [sym_xint] = ACTIONS(267),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(269),
  },
  [578] = {
    [sym_function_or_value_defn] = STATE(733),
    [sym__expression] = STATE(301),
    [sym_literal_expression] = STATE(2008),
    [sym_long_identifier_or_op] = STATE(2008),
    [sym_tuple_expression] = STATE(2008),
    [sym_brace_expression] = STATE(2008),
    [sym_anon_record_expression] = STATE(2008),
    [sym_prefixed_expression] = STATE(2008),
    [sym_typecast_expression] = STATE(2008),
    [sym_for_expression] = STATE(2008),
    [sym_while_expression] = STATE(2008),
    [sym__if_branch] = STATE(6754),
    [sym_if_expression] = STATE(2008),
    [sym_fun_expression] = STATE(2008),
    [sym_try_expression] = STATE(2008),
    [sym_match_expression] = STATE(2008),
    [sym_function_expression] = STATE(2008),
    [sym_mutate_expression] = STATE(2008),
    [sym_index_expression] = STATE(2008),
    [sym_typed_expression] = STATE(2008),
    [sym_declaration_expression] = STATE(2008),
    [sym_do_expression] = STATE(2008),
    [sym_list_expression] = STATE(2008),
    [sym_array_expression] = STATE(2008),
    [sym_begin_end_expression] = STATE(2008),
    [sym_paren_expression] = STATE(2008),
    [sym__high_prec_app] = STATE(2007),
    [sym__low_prec_app] = STATE(2007),
    [sym_application_expression] = STATE(2008),
    [sym_dot_expression] = STATE(2008),
    [sym_infix_expression] = STATE(2008),
    [sym_ce_expression] = STATE(2008),
    [sym_sequential_expression] = STATE(2008),
    [sym_char] = STATE(1859),
    [sym_format_string] = STATE(1861),
    [sym__string_literal] = STATE(1861),
    [sym_string] = STATE(1859),
    [sym_verbatim_string] = STATE(1859),
    [sym_bytearray] = STATE(1859),
    [sym_verbatim_bytearray] = STATE(1859),
    [sym_format_triple_quoted_string] = STATE(1862),
    [sym_triple_quoted_string] = STATE(1859),
    [sym_const] = STATE(2008),
    [sym_long_identifier] = STATE(1701),
    [sym_active_pattern] = STATE(1702),
    [sym__identifier_or_op] = STATE(1724),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(706),
    [sym_sbyte] = STATE(1859),
    [sym_byte] = STATE(1859),
    [sym_int16] = STATE(1859),
    [sym_uint16] = STATE(1859),
    [sym_int32] = STATE(1859),
    [sym_uint32] = STATE(1859),
    [sym_nativeint] = STATE(1859),
    [sym_unativeint] = STATE(1859),
    [sym_int64] = STATE(1859),
    [sym_uint64] = STATE(1859),
    [sym_ieee32] = STATE(1859),
    [sym_ieee64] = STATE(1859),
    [sym_bignum] = STATE(1859),
    [sym_decimal] = STATE(1859),
    [sym_float] = STATE(1447),
    [sym_block_comment] = STATE(578),
    [sym_compiler_directive_decl] = STATE(578),
    [sym_fsi_directive_decl] = STATE(578),
    [sym_preproc_line] = STATE(578),
    [sym_preproc_if_in_expression] = STATE(2008),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(503),
    [anon_sym_return] = ACTIONS(971),
    [anon_sym_do] = ACTIONS(599),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(511),
    [anon_sym_null] = ACTIONS(515),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(517),
    [anon_sym_LBRACK_PIPE] = ACTIONS(519),
    [anon_sym_LBRACE] = ACTIONS(2060),
    [anon_sym_LT_AT] = ACTIONS(523),
    [anon_sym_LT_AT_AT] = ACTIONS(2062),
    [anon_sym_LBRACE_PIPE] = ACTIONS(529),
    [anon_sym_new] = ACTIONS(971),
    [anon_sym_return_BANG] = ACTIONS(975),
    [anon_sym_yield] = ACTIONS(971),
    [anon_sym_yield_BANG] = ACTIONS(975),
    [anon_sym_lazy] = ACTIONS(971),
    [anon_sym_assert] = ACTIONS(971),
    [anon_sym_upcast] = ACTIONS(971),
    [anon_sym_downcast] = ACTIONS(971),
    [anon_sym_for] = ACTIONS(979),
    [anon_sym_while] = ACTIONS(537),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(539),
    [anon_sym_try] = ACTIONS(543),
    [anon_sym_match] = ACTIONS(545),
    [anon_sym_match_BANG] = ACTIONS(547),
    [anon_sym_function] = ACTIONS(549),
    [anon_sym_use] = ACTIONS(983),
    [anon_sym_use_BANG] = ACTIONS(985),
    [anon_sym_do_BANG] = ACTIONS(561),
    [anon_sym_begin] = ACTIONS(565),
    [aux_sym_char_token1] = ACTIONS(569),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(571),
    [anon_sym_DQUOTE] = ACTIONS(573),
    [anon_sym_AT_DQUOTE] = ACTIONS(575),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(577),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(579),
    [sym_bool] = ACTIONS(581),
    [sym_unit] = ACTIONS(2064),
    [anon_sym_LPAREN_PIPE] = ACTIONS(585),
    [sym_op_identifier] = ACTIONS(2066),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(591),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(593),
  },
  [579] = {
    [sym_function_or_value_defn] = STATE(600),
    [sym__expression] = STATE(234),
    [sym_literal_expression] = STATE(867),
    [sym_long_identifier_or_op] = STATE(867),
    [sym_tuple_expression] = STATE(867),
    [sym_brace_expression] = STATE(867),
    [sym_anon_record_expression] = STATE(867),
    [sym_prefixed_expression] = STATE(867),
    [sym_typecast_expression] = STATE(867),
    [sym_for_expression] = STATE(867),
    [sym_while_expression] = STATE(867),
    [sym__if_branch] = STATE(6511),
    [sym_if_expression] = STATE(867),
    [sym_fun_expression] = STATE(867),
    [sym_try_expression] = STATE(867),
    [sym_match_expression] = STATE(867),
    [sym_function_expression] = STATE(867),
    [sym_mutate_expression] = STATE(867),
    [sym_index_expression] = STATE(867),
    [sym_typed_expression] = STATE(867),
    [sym_declaration_expression] = STATE(867),
    [sym_do_expression] = STATE(867),
    [sym_list_expression] = STATE(867),
    [sym_array_expression] = STATE(867),
    [sym_begin_end_expression] = STATE(867),
    [sym_paren_expression] = STATE(867),
    [sym__high_prec_app] = STATE(864),
    [sym__low_prec_app] = STATE(864),
    [sym_application_expression] = STATE(867),
    [sym_dot_expression] = STATE(867),
    [sym_infix_expression] = STATE(867),
    [sym_ce_expression] = STATE(867),
    [sym_sequential_expression] = STATE(867),
    [sym_char] = STATE(868),
    [sym_format_string] = STATE(869),
    [sym__string_literal] = STATE(869),
    [sym_string] = STATE(868),
    [sym_verbatim_string] = STATE(868),
    [sym_bytearray] = STATE(868),
    [sym_verbatim_bytearray] = STATE(868),
    [sym_format_triple_quoted_string] = STATE(870),
    [sym_triple_quoted_string] = STATE(868),
    [sym_const] = STATE(867),
    [sym_long_identifier] = STATE(872),
    [sym_active_pattern] = STATE(871),
    [sym__identifier_or_op] = STATE(873),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(656),
    [sym_sbyte] = STATE(868),
    [sym_byte] = STATE(868),
    [sym_int16] = STATE(868),
    [sym_uint16] = STATE(868),
    [sym_int32] = STATE(868),
    [sym_uint32] = STATE(868),
    [sym_nativeint] = STATE(868),
    [sym_unativeint] = STATE(868),
    [sym_int64] = STATE(868),
    [sym_uint64] = STATE(868),
    [sym_ieee32] = STATE(868),
    [sym_ieee64] = STATE(868),
    [sym_bignum] = STATE(868),
    [sym_decimal] = STATE(868),
    [sym_float] = STATE(1368),
    [sym_block_comment] = STATE(579),
    [sym_compiler_directive_decl] = STATE(579),
    [sym_fsi_directive_decl] = STATE(579),
    [sym_preproc_line] = STATE(579),
    [sym_preproc_if_in_expression] = STATE(867),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(29),
    [anon_sym_return] = ACTIONS(825),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_null] = ACTIONS(49),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACK_PIPE] = ACTIONS(57),
    [anon_sym_LBRACE] = ACTIONS(1663),
    [anon_sym_LT_AT] = ACTIONS(61),
    [anon_sym_LT_AT_AT] = ACTIONS(1665),
    [anon_sym_LBRACE_PIPE] = ACTIONS(67),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_return_BANG] = ACTIONS(829),
    [anon_sym_yield] = ACTIONS(825),
    [anon_sym_yield_BANG] = ACTIONS(829),
    [anon_sym_lazy] = ACTIONS(825),
    [anon_sym_assert] = ACTIONS(825),
    [anon_sym_upcast] = ACTIONS(825),
    [anon_sym_downcast] = ACTIONS(825),
    [anon_sym_for] = ACTIONS(73),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(79),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_match] = ACTIONS(83),
    [anon_sym_match_BANG] = ACTIONS(85),
    [anon_sym_function] = ACTIONS(87),
    [anon_sym_use] = ACTIONS(833),
    [anon_sym_use_BANG] = ACTIONS(835),
    [anon_sym_do_BANG] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(101),
    [aux_sym_char_token1] = ACTIONS(105),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(107),
    [anon_sym_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DQUOTE] = ACTIONS(111),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(115),
    [sym_bool] = ACTIONS(117),
    [sym_unit] = ACTIONS(1673),
    [anon_sym_LPAREN_PIPE] = ACTIONS(121),
    [sym_op_identifier] = ACTIONS(1675),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(837),
    [sym_xint] = ACTIONS(387),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(135),
  },
  [580] = {
    [sym_function_or_value_defn] = STATE(600),
    [sym__expression] = STATE(235),
    [sym_literal_expression] = STATE(867),
    [sym_long_identifier_or_op] = STATE(867),
    [sym_tuple_expression] = STATE(867),
    [sym_brace_expression] = STATE(867),
    [sym_anon_record_expression] = STATE(867),
    [sym_prefixed_expression] = STATE(867),
    [sym_typecast_expression] = STATE(867),
    [sym_for_expression] = STATE(867),
    [sym_while_expression] = STATE(867),
    [sym__if_branch] = STATE(6511),
    [sym_if_expression] = STATE(867),
    [sym_fun_expression] = STATE(867),
    [sym_try_expression] = STATE(867),
    [sym_match_expression] = STATE(867),
    [sym_function_expression] = STATE(867),
    [sym_mutate_expression] = STATE(867),
    [sym_index_expression] = STATE(867),
    [sym_typed_expression] = STATE(867),
    [sym_declaration_expression] = STATE(867),
    [sym_do_expression] = STATE(867),
    [sym_list_expression] = STATE(867),
    [sym_array_expression] = STATE(867),
    [sym_begin_end_expression] = STATE(867),
    [sym_paren_expression] = STATE(867),
    [sym__high_prec_app] = STATE(864),
    [sym__low_prec_app] = STATE(864),
    [sym_application_expression] = STATE(867),
    [sym_dot_expression] = STATE(867),
    [sym_infix_expression] = STATE(867),
    [sym_ce_expression] = STATE(867),
    [sym_sequential_expression] = STATE(867),
    [sym_char] = STATE(868),
    [sym_format_string] = STATE(869),
    [sym__string_literal] = STATE(869),
    [sym_string] = STATE(868),
    [sym_verbatim_string] = STATE(868),
    [sym_bytearray] = STATE(868),
    [sym_verbatim_bytearray] = STATE(868),
    [sym_format_triple_quoted_string] = STATE(870),
    [sym_triple_quoted_string] = STATE(868),
    [sym_const] = STATE(867),
    [sym_long_identifier] = STATE(872),
    [sym_active_pattern] = STATE(871),
    [sym__identifier_or_op] = STATE(873),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(656),
    [sym_sbyte] = STATE(868),
    [sym_byte] = STATE(868),
    [sym_int16] = STATE(868),
    [sym_uint16] = STATE(868),
    [sym_int32] = STATE(868),
    [sym_uint32] = STATE(868),
    [sym_nativeint] = STATE(868),
    [sym_unativeint] = STATE(868),
    [sym_int64] = STATE(868),
    [sym_uint64] = STATE(868),
    [sym_ieee32] = STATE(868),
    [sym_ieee64] = STATE(868),
    [sym_bignum] = STATE(868),
    [sym_decimal] = STATE(868),
    [sym_float] = STATE(1368),
    [sym_block_comment] = STATE(580),
    [sym_compiler_directive_decl] = STATE(580),
    [sym_fsi_directive_decl] = STATE(580),
    [sym_preproc_line] = STATE(580),
    [sym_preproc_if_in_expression] = STATE(867),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(29),
    [anon_sym_return] = ACTIONS(825),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_null] = ACTIONS(49),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACK_PIPE] = ACTIONS(57),
    [anon_sym_LBRACE] = ACTIONS(1663),
    [anon_sym_LT_AT] = ACTIONS(61),
    [anon_sym_LT_AT_AT] = ACTIONS(1665),
    [anon_sym_LBRACE_PIPE] = ACTIONS(67),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_return_BANG] = ACTIONS(829),
    [anon_sym_yield] = ACTIONS(825),
    [anon_sym_yield_BANG] = ACTIONS(829),
    [anon_sym_lazy] = ACTIONS(825),
    [anon_sym_assert] = ACTIONS(825),
    [anon_sym_upcast] = ACTIONS(825),
    [anon_sym_downcast] = ACTIONS(825),
    [anon_sym_for] = ACTIONS(73),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(79),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_match] = ACTIONS(83),
    [anon_sym_match_BANG] = ACTIONS(85),
    [anon_sym_function] = ACTIONS(87),
    [anon_sym_use] = ACTIONS(833),
    [anon_sym_use_BANG] = ACTIONS(835),
    [anon_sym_do_BANG] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(101),
    [aux_sym_char_token1] = ACTIONS(105),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(107),
    [anon_sym_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DQUOTE] = ACTIONS(111),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(115),
    [sym_bool] = ACTIONS(117),
    [sym_unit] = ACTIONS(1673),
    [anon_sym_LPAREN_PIPE] = ACTIONS(121),
    [sym_op_identifier] = ACTIONS(1675),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(837),
    [sym_xint] = ACTIONS(387),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(135),
  },
  [581] = {
    [sym_function_or_value_defn] = STATE(600),
    [sym__expression] = STATE(92),
    [sym_literal_expression] = STATE(867),
    [sym_long_identifier_or_op] = STATE(867),
    [sym_tuple_expression] = STATE(867),
    [sym_brace_expression] = STATE(867),
    [sym_anon_record_expression] = STATE(867),
    [sym_prefixed_expression] = STATE(867),
    [sym_typecast_expression] = STATE(867),
    [sym_for_expression] = STATE(867),
    [sym_while_expression] = STATE(867),
    [sym__if_branch] = STATE(6511),
    [sym_if_expression] = STATE(867),
    [sym_fun_expression] = STATE(867),
    [sym_try_expression] = STATE(867),
    [sym_match_expression] = STATE(867),
    [sym_function_expression] = STATE(867),
    [sym_mutate_expression] = STATE(867),
    [sym_index_expression] = STATE(867),
    [sym_typed_expression] = STATE(867),
    [sym_declaration_expression] = STATE(867),
    [sym_do_expression] = STATE(867),
    [sym_list_expression] = STATE(867),
    [sym_array_expression] = STATE(867),
    [sym_begin_end_expression] = STATE(867),
    [sym_paren_expression] = STATE(867),
    [sym__high_prec_app] = STATE(864),
    [sym__low_prec_app] = STATE(864),
    [sym_application_expression] = STATE(867),
    [sym_dot_expression] = STATE(867),
    [sym_infix_expression] = STATE(867),
    [sym_ce_expression] = STATE(867),
    [sym_sequential_expression] = STATE(867),
    [sym_char] = STATE(868),
    [sym_format_string] = STATE(869),
    [sym__string_literal] = STATE(869),
    [sym_string] = STATE(868),
    [sym_verbatim_string] = STATE(868),
    [sym_bytearray] = STATE(868),
    [sym_verbatim_bytearray] = STATE(868),
    [sym_format_triple_quoted_string] = STATE(870),
    [sym_triple_quoted_string] = STATE(868),
    [sym_const] = STATE(867),
    [sym_long_identifier] = STATE(872),
    [sym_active_pattern] = STATE(871),
    [sym__identifier_or_op] = STATE(873),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(656),
    [sym_sbyte] = STATE(868),
    [sym_byte] = STATE(868),
    [sym_int16] = STATE(868),
    [sym_uint16] = STATE(868),
    [sym_int32] = STATE(868),
    [sym_uint32] = STATE(868),
    [sym_nativeint] = STATE(868),
    [sym_unativeint] = STATE(868),
    [sym_int64] = STATE(868),
    [sym_uint64] = STATE(868),
    [sym_ieee32] = STATE(868),
    [sym_ieee64] = STATE(868),
    [sym_bignum] = STATE(868),
    [sym_decimal] = STATE(868),
    [sym_float] = STATE(1368),
    [sym_block_comment] = STATE(581),
    [sym_compiler_directive_decl] = STATE(581),
    [sym_fsi_directive_decl] = STATE(581),
    [sym_preproc_line] = STATE(581),
    [sym_preproc_if_in_expression] = STATE(867),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(29),
    [anon_sym_return] = ACTIONS(825),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_null] = ACTIONS(49),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACK_PIPE] = ACTIONS(57),
    [anon_sym_LBRACE] = ACTIONS(1663),
    [anon_sym_LT_AT] = ACTIONS(61),
    [anon_sym_LT_AT_AT] = ACTIONS(1665),
    [anon_sym_LBRACE_PIPE] = ACTIONS(67),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_return_BANG] = ACTIONS(829),
    [anon_sym_yield] = ACTIONS(825),
    [anon_sym_yield_BANG] = ACTIONS(829),
    [anon_sym_lazy] = ACTIONS(825),
    [anon_sym_assert] = ACTIONS(825),
    [anon_sym_upcast] = ACTIONS(825),
    [anon_sym_downcast] = ACTIONS(825),
    [anon_sym_for] = ACTIONS(73),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(79),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_match] = ACTIONS(83),
    [anon_sym_match_BANG] = ACTIONS(85),
    [anon_sym_function] = ACTIONS(87),
    [anon_sym_use] = ACTIONS(833),
    [anon_sym_use_BANG] = ACTIONS(835),
    [anon_sym_do_BANG] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(101),
    [aux_sym_char_token1] = ACTIONS(105),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(107),
    [anon_sym_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DQUOTE] = ACTIONS(111),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(115),
    [sym_bool] = ACTIONS(117),
    [sym_unit] = ACTIONS(1673),
    [anon_sym_LPAREN_PIPE] = ACTIONS(121),
    [sym_op_identifier] = ACTIONS(1675),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(837),
    [sym_xint] = ACTIONS(387),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(135),
  },
  [582] = {
    [sym_function_or_value_defn] = STATE(627),
    [sym__expression] = STATE(347),
    [sym_literal_expression] = STATE(1118),
    [sym_long_identifier_or_op] = STATE(1118),
    [sym_tuple_expression] = STATE(1118),
    [sym_brace_expression] = STATE(1118),
    [sym_anon_record_expression] = STATE(1118),
    [sym_prefixed_expression] = STATE(1118),
    [sym_typecast_expression] = STATE(1118),
    [sym_for_expression] = STATE(1118),
    [sym_while_expression] = STATE(1118),
    [sym__if_branch] = STATE(7163),
    [sym_if_expression] = STATE(1118),
    [sym_fun_expression] = STATE(1118),
    [sym_try_expression] = STATE(1118),
    [sym_match_expression] = STATE(1118),
    [sym_function_expression] = STATE(1118),
    [sym_mutate_expression] = STATE(1118),
    [sym_index_expression] = STATE(1118),
    [sym_typed_expression] = STATE(1118),
    [sym_declaration_expression] = STATE(1118),
    [sym_do_expression] = STATE(1118),
    [sym_list_expression] = STATE(1118),
    [sym_array_expression] = STATE(1118),
    [sym_begin_end_expression] = STATE(1118),
    [sym_paren_expression] = STATE(1118),
    [sym__high_prec_app] = STATE(1133),
    [sym__low_prec_app] = STATE(1133),
    [sym_application_expression] = STATE(1118),
    [sym_dot_expression] = STATE(1118),
    [sym_infix_expression] = STATE(1118),
    [sym_ce_expression] = STATE(1118),
    [sym_sequential_expression] = STATE(1118),
    [sym_char] = STATE(1080),
    [sym_format_string] = STATE(1090),
    [sym__string_literal] = STATE(1090),
    [sym_string] = STATE(1080),
    [sym_verbatim_string] = STATE(1080),
    [sym_bytearray] = STATE(1080),
    [sym_verbatim_bytearray] = STATE(1080),
    [sym_format_triple_quoted_string] = STATE(1096),
    [sym_triple_quoted_string] = STATE(1080),
    [sym_const] = STATE(1118),
    [sym_long_identifier] = STATE(1156),
    [sym_active_pattern] = STATE(1085),
    [sym__identifier_or_op] = STATE(1099),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(517),
    [sym_sbyte] = STATE(1080),
    [sym_byte] = STATE(1080),
    [sym_int16] = STATE(1080),
    [sym_uint16] = STATE(1080),
    [sym_int32] = STATE(1080),
    [sym_uint32] = STATE(1080),
    [sym_nativeint] = STATE(1080),
    [sym_unativeint] = STATE(1080),
    [sym_int64] = STATE(1080),
    [sym_uint64] = STATE(1080),
    [sym_ieee32] = STATE(1080),
    [sym_ieee64] = STATE(1080),
    [sym_bignum] = STATE(1080),
    [sym_decimal] = STATE(1080),
    [sym_float] = STATE(979),
    [sym_block_comment] = STATE(582),
    [sym_compiler_directive_decl] = STATE(582),
    [sym_fsi_directive_decl] = STATE(582),
    [sym_preproc_line] = STATE(582),
    [sym_preproc_if_in_expression] = STATE(1118),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(195),
    [anon_sym_return] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_null] = ACTIONS(207),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(209),
    [anon_sym_LBRACK_PIPE] = ACTIONS(211),
    [anon_sym_LBRACE] = ACTIONS(1687),
    [anon_sym_LT_AT] = ACTIONS(213),
    [anon_sym_LT_AT_AT] = ACTIONS(1689),
    [anon_sym_LBRACE_PIPE] = ACTIONS(217),
    [anon_sym_new] = ACTIONS(199),
    [anon_sym_return_BANG] = ACTIONS(219),
    [anon_sym_yield] = ACTIONS(199),
    [anon_sym_yield_BANG] = ACTIONS(219),
    [anon_sym_lazy] = ACTIONS(199),
    [anon_sym_assert] = ACTIONS(199),
    [anon_sym_upcast] = ACTIONS(199),
    [anon_sym_downcast] = ACTIONS(199),
    [anon_sym_for] = ACTIONS(223),
    [anon_sym_while] = ACTIONS(225),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(229),
    [anon_sym_match] = ACTIONS(231),
    [anon_sym_match_BANG] = ACTIONS(233),
    [anon_sym_function] = ACTIONS(235),
    [anon_sym_use] = ACTIONS(239),
    [anon_sym_use_BANG] = ACTIONS(241),
    [anon_sym_do_BANG] = ACTIONS(243),
    [anon_sym_begin] = ACTIONS(245),
    [aux_sym_char_token1] = ACTIONS(247),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(251),
    [anon_sym_AT_DQUOTE] = ACTIONS(253),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(255),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(257),
    [sym_bool] = ACTIONS(259),
    [sym_unit] = ACTIONS(1699),
    [anon_sym_LPAREN_PIPE] = ACTIONS(261),
    [sym_op_identifier] = ACTIONS(1701),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(265),
    [sym_xint] = ACTIONS(267),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(269),
  },
  [583] = {
    [sym_function_or_value_defn] = STATE(651),
    [sym__expression] = STATE(158),
    [sym_literal_expression] = STATE(2168),
    [sym_long_identifier_or_op] = STATE(2168),
    [sym_tuple_expression] = STATE(2168),
    [sym_brace_expression] = STATE(2168),
    [sym_anon_record_expression] = STATE(2168),
    [sym_prefixed_expression] = STATE(2168),
    [sym_typecast_expression] = STATE(2168),
    [sym_for_expression] = STATE(2168),
    [sym_while_expression] = STATE(2168),
    [sym__if_branch] = STATE(6406),
    [sym_if_expression] = STATE(2168),
    [sym_fun_expression] = STATE(2168),
    [sym_try_expression] = STATE(2168),
    [sym_match_expression] = STATE(2168),
    [sym_function_expression] = STATE(2168),
    [sym_mutate_expression] = STATE(2168),
    [sym_index_expression] = STATE(2168),
    [sym_typed_expression] = STATE(2168),
    [sym_declaration_expression] = STATE(2168),
    [sym_do_expression] = STATE(2168),
    [sym_list_expression] = STATE(2168),
    [sym_array_expression] = STATE(2168),
    [sym_begin_end_expression] = STATE(2168),
    [sym_paren_expression] = STATE(2168),
    [sym__high_prec_app] = STATE(2179),
    [sym__low_prec_app] = STATE(2179),
    [sym_application_expression] = STATE(2168),
    [sym_dot_expression] = STATE(2168),
    [sym_infix_expression] = STATE(2168),
    [sym_ce_expression] = STATE(2168),
    [sym_sequential_expression] = STATE(2168),
    [sym_char] = STATE(2469),
    [sym_format_string] = STATE(2412),
    [sym__string_literal] = STATE(2412),
    [sym_string] = STATE(2469),
    [sym_verbatim_string] = STATE(2469),
    [sym_bytearray] = STATE(2469),
    [sym_verbatim_bytearray] = STATE(2469),
    [sym_format_triple_quoted_string] = STATE(2408),
    [sym_triple_quoted_string] = STATE(2469),
    [sym_const] = STATE(2168),
    [sym_long_identifier] = STATE(2183),
    [sym_active_pattern] = STATE(2182),
    [sym__identifier_or_op] = STATE(2093),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(650),
    [sym_sbyte] = STATE(2469),
    [sym_byte] = STATE(2469),
    [sym_int16] = STATE(2469),
    [sym_uint16] = STATE(2469),
    [sym_int32] = STATE(2469),
    [sym_uint32] = STATE(2469),
    [sym_nativeint] = STATE(2469),
    [sym_unativeint] = STATE(2469),
    [sym_int64] = STATE(2469),
    [sym_uint64] = STATE(2469),
    [sym_ieee32] = STATE(2469),
    [sym_ieee64] = STATE(2469),
    [sym_bignum] = STATE(2469),
    [sym_decimal] = STATE(2469),
    [sym_float] = STATE(1586),
    [sym_block_comment] = STATE(583),
    [sym_compiler_directive_decl] = STATE(583),
    [sym_fsi_directive_decl] = STATE(583),
    [sym_preproc_line] = STATE(583),
    [sym_preproc_if_in_expression] = STATE(2168),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(989),
    [anon_sym_return] = ACTIONS(993),
    [anon_sym_do] = ACTIONS(995),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(997),
    [anon_sym_null] = ACTIONS(1001),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1003),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1005),
    [anon_sym_LBRACE] = ACTIONS(2070),
    [anon_sym_LT_AT] = ACTIONS(1009),
    [anon_sym_LT_AT_AT] = ACTIONS(2072),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1017),
    [anon_sym_new] = ACTIONS(993),
    [anon_sym_return_BANG] = ACTIONS(1019),
    [anon_sym_yield] = ACTIONS(993),
    [anon_sym_yield_BANG] = ACTIONS(1019),
    [anon_sym_lazy] = ACTIONS(993),
    [anon_sym_assert] = ACTIONS(993),
    [anon_sym_upcast] = ACTIONS(993),
    [anon_sym_downcast] = ACTIONS(993),
    [anon_sym_for] = ACTIONS(1023),
    [anon_sym_while] = ACTIONS(1025),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(1027),
    [anon_sym_try] = ACTIONS(1029),
    [anon_sym_match] = ACTIONS(1031),
    [anon_sym_match_BANG] = ACTIONS(1033),
    [anon_sym_function] = ACTIONS(1035),
    [anon_sym_use] = ACTIONS(1043),
    [anon_sym_use_BANG] = ACTIONS(1045),
    [anon_sym_do_BANG] = ACTIONS(1047),
    [anon_sym_begin] = ACTIONS(1049),
    [aux_sym_char_token1] = ACTIONS(1053),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1055),
    [anon_sym_DQUOTE] = ACTIONS(1057),
    [anon_sym_AT_DQUOTE] = ACTIONS(1059),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1061),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1063),
    [sym_bool] = ACTIONS(1065),
    [sym_unit] = ACTIONS(2074),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1069),
    [sym_op_identifier] = ACTIONS(2076),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(1073),
    [sym_xint] = ACTIONS(1075),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1077),
  },
  [584] = {
    [sym_function_or_value_defn] = STATE(627),
    [sym__expression] = STATE(343),
    [sym_literal_expression] = STATE(1118),
    [sym_long_identifier_or_op] = STATE(1118),
    [sym_tuple_expression] = STATE(1118),
    [sym_brace_expression] = STATE(1118),
    [sym_anon_record_expression] = STATE(1118),
    [sym_prefixed_expression] = STATE(1118),
    [sym_typecast_expression] = STATE(1118),
    [sym_for_expression] = STATE(1118),
    [sym_while_expression] = STATE(1118),
    [sym__if_branch] = STATE(7163),
    [sym_if_expression] = STATE(1118),
    [sym_fun_expression] = STATE(1118),
    [sym_try_expression] = STATE(1118),
    [sym_match_expression] = STATE(1118),
    [sym_function_expression] = STATE(1118),
    [sym_mutate_expression] = STATE(1118),
    [sym_index_expression] = STATE(1118),
    [sym_typed_expression] = STATE(1118),
    [sym_declaration_expression] = STATE(1118),
    [sym_do_expression] = STATE(1118),
    [sym_list_expression] = STATE(1118),
    [sym_array_expression] = STATE(1118),
    [sym_begin_end_expression] = STATE(1118),
    [sym_paren_expression] = STATE(1118),
    [sym__high_prec_app] = STATE(1133),
    [sym__low_prec_app] = STATE(1133),
    [sym_application_expression] = STATE(1118),
    [sym_dot_expression] = STATE(1118),
    [sym_infix_expression] = STATE(1118),
    [sym_ce_expression] = STATE(1118),
    [sym_sequential_expression] = STATE(1118),
    [sym_char] = STATE(1080),
    [sym_format_string] = STATE(1090),
    [sym__string_literal] = STATE(1090),
    [sym_string] = STATE(1080),
    [sym_verbatim_string] = STATE(1080),
    [sym_bytearray] = STATE(1080),
    [sym_verbatim_bytearray] = STATE(1080),
    [sym_format_triple_quoted_string] = STATE(1096),
    [sym_triple_quoted_string] = STATE(1080),
    [sym_const] = STATE(1118),
    [sym_long_identifier] = STATE(1156),
    [sym_active_pattern] = STATE(1085),
    [sym__identifier_or_op] = STATE(1099),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(517),
    [sym_sbyte] = STATE(1080),
    [sym_byte] = STATE(1080),
    [sym_int16] = STATE(1080),
    [sym_uint16] = STATE(1080),
    [sym_int32] = STATE(1080),
    [sym_uint32] = STATE(1080),
    [sym_nativeint] = STATE(1080),
    [sym_unativeint] = STATE(1080),
    [sym_int64] = STATE(1080),
    [sym_uint64] = STATE(1080),
    [sym_ieee32] = STATE(1080),
    [sym_ieee64] = STATE(1080),
    [sym_bignum] = STATE(1080),
    [sym_decimal] = STATE(1080),
    [sym_float] = STATE(979),
    [sym_block_comment] = STATE(584),
    [sym_compiler_directive_decl] = STATE(584),
    [sym_fsi_directive_decl] = STATE(584),
    [sym_preproc_line] = STATE(584),
    [sym_preproc_if_in_expression] = STATE(1118),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(195),
    [anon_sym_return] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_null] = ACTIONS(207),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(209),
    [anon_sym_LBRACK_PIPE] = ACTIONS(211),
    [anon_sym_LBRACE] = ACTIONS(1687),
    [anon_sym_LT_AT] = ACTIONS(213),
    [anon_sym_LT_AT_AT] = ACTIONS(1689),
    [anon_sym_LBRACE_PIPE] = ACTIONS(217),
    [anon_sym_new] = ACTIONS(199),
    [anon_sym_return_BANG] = ACTIONS(219),
    [anon_sym_yield] = ACTIONS(199),
    [anon_sym_yield_BANG] = ACTIONS(219),
    [anon_sym_lazy] = ACTIONS(199),
    [anon_sym_assert] = ACTIONS(199),
    [anon_sym_upcast] = ACTIONS(199),
    [anon_sym_downcast] = ACTIONS(199),
    [anon_sym_for] = ACTIONS(223),
    [anon_sym_while] = ACTIONS(225),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(229),
    [anon_sym_match] = ACTIONS(231),
    [anon_sym_match_BANG] = ACTIONS(233),
    [anon_sym_function] = ACTIONS(235),
    [anon_sym_use] = ACTIONS(239),
    [anon_sym_use_BANG] = ACTIONS(241),
    [anon_sym_do_BANG] = ACTIONS(243),
    [anon_sym_begin] = ACTIONS(245),
    [aux_sym_char_token1] = ACTIONS(247),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(251),
    [anon_sym_AT_DQUOTE] = ACTIONS(253),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(255),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(257),
    [sym_bool] = ACTIONS(259),
    [sym_unit] = ACTIONS(1699),
    [anon_sym_LPAREN_PIPE] = ACTIONS(261),
    [sym_op_identifier] = ACTIONS(1701),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(265),
    [sym_xint] = ACTIONS(267),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(269),
  },
  [585] = {
    [sym_function_or_value_defn] = STATE(600),
    [sym__expression] = STATE(91),
    [sym_literal_expression] = STATE(867),
    [sym_long_identifier_or_op] = STATE(867),
    [sym_tuple_expression] = STATE(867),
    [sym_brace_expression] = STATE(867),
    [sym_anon_record_expression] = STATE(867),
    [sym_prefixed_expression] = STATE(867),
    [sym_typecast_expression] = STATE(867),
    [sym_for_expression] = STATE(867),
    [sym_while_expression] = STATE(867),
    [sym__if_branch] = STATE(6511),
    [sym_if_expression] = STATE(867),
    [sym_fun_expression] = STATE(867),
    [sym_try_expression] = STATE(867),
    [sym_match_expression] = STATE(867),
    [sym_function_expression] = STATE(867),
    [sym_mutate_expression] = STATE(867),
    [sym_index_expression] = STATE(867),
    [sym_typed_expression] = STATE(867),
    [sym_declaration_expression] = STATE(867),
    [sym_do_expression] = STATE(867),
    [sym_list_expression] = STATE(867),
    [sym_array_expression] = STATE(867),
    [sym_begin_end_expression] = STATE(867),
    [sym_paren_expression] = STATE(867),
    [sym__high_prec_app] = STATE(864),
    [sym__low_prec_app] = STATE(864),
    [sym_application_expression] = STATE(867),
    [sym_dot_expression] = STATE(867),
    [sym_infix_expression] = STATE(867),
    [sym_ce_expression] = STATE(867),
    [sym_sequential_expression] = STATE(867),
    [sym_char] = STATE(868),
    [sym_format_string] = STATE(869),
    [sym__string_literal] = STATE(869),
    [sym_string] = STATE(868),
    [sym_verbatim_string] = STATE(868),
    [sym_bytearray] = STATE(868),
    [sym_verbatim_bytearray] = STATE(868),
    [sym_format_triple_quoted_string] = STATE(870),
    [sym_triple_quoted_string] = STATE(868),
    [sym_const] = STATE(867),
    [sym_long_identifier] = STATE(872),
    [sym_active_pattern] = STATE(871),
    [sym__identifier_or_op] = STATE(873),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(656),
    [sym_sbyte] = STATE(868),
    [sym_byte] = STATE(868),
    [sym_int16] = STATE(868),
    [sym_uint16] = STATE(868),
    [sym_int32] = STATE(868),
    [sym_uint32] = STATE(868),
    [sym_nativeint] = STATE(868),
    [sym_unativeint] = STATE(868),
    [sym_int64] = STATE(868),
    [sym_uint64] = STATE(868),
    [sym_ieee32] = STATE(868),
    [sym_ieee64] = STATE(868),
    [sym_bignum] = STATE(868),
    [sym_decimal] = STATE(868),
    [sym_float] = STATE(1368),
    [sym_block_comment] = STATE(585),
    [sym_compiler_directive_decl] = STATE(585),
    [sym_fsi_directive_decl] = STATE(585),
    [sym_preproc_line] = STATE(585),
    [sym_preproc_if_in_expression] = STATE(867),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(29),
    [anon_sym_return] = ACTIONS(825),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_null] = ACTIONS(49),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACK_PIPE] = ACTIONS(57),
    [anon_sym_LBRACE] = ACTIONS(1663),
    [anon_sym_LT_AT] = ACTIONS(61),
    [anon_sym_LT_AT_AT] = ACTIONS(1665),
    [anon_sym_LBRACE_PIPE] = ACTIONS(67),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_return_BANG] = ACTIONS(829),
    [anon_sym_yield] = ACTIONS(825),
    [anon_sym_yield_BANG] = ACTIONS(829),
    [anon_sym_lazy] = ACTIONS(825),
    [anon_sym_assert] = ACTIONS(825),
    [anon_sym_upcast] = ACTIONS(825),
    [anon_sym_downcast] = ACTIONS(825),
    [anon_sym_for] = ACTIONS(73),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(79),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_match] = ACTIONS(83),
    [anon_sym_match_BANG] = ACTIONS(85),
    [anon_sym_function] = ACTIONS(87),
    [anon_sym_use] = ACTIONS(833),
    [anon_sym_use_BANG] = ACTIONS(835),
    [anon_sym_do_BANG] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(101),
    [aux_sym_char_token1] = ACTIONS(105),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(107),
    [anon_sym_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DQUOTE] = ACTIONS(111),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(115),
    [sym_bool] = ACTIONS(117),
    [sym_unit] = ACTIONS(1673),
    [anon_sym_LPAREN_PIPE] = ACTIONS(121),
    [sym_op_identifier] = ACTIONS(1675),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(837),
    [sym_xint] = ACTIONS(387),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(135),
  },
  [586] = {
    [sym_function_or_value_defn] = STATE(703),
    [sym__expression] = STATE(111),
    [sym_literal_expression] = STATE(1797),
    [sym_long_identifier_or_op] = STATE(1797),
    [sym_tuple_expression] = STATE(1797),
    [sym_brace_expression] = STATE(1797),
    [sym_anon_record_expression] = STATE(1797),
    [sym_prefixed_expression] = STATE(1797),
    [sym_typecast_expression] = STATE(1797),
    [sym_for_expression] = STATE(1797),
    [sym_while_expression] = STATE(1797),
    [sym__if_branch] = STATE(6611),
    [sym_if_expression] = STATE(1797),
    [sym_fun_expression] = STATE(1797),
    [sym_try_expression] = STATE(1797),
    [sym_match_expression] = STATE(1797),
    [sym_function_expression] = STATE(1797),
    [sym_mutate_expression] = STATE(1797),
    [sym_index_expression] = STATE(1797),
    [sym_typed_expression] = STATE(1797),
    [sym_declaration_expression] = STATE(1797),
    [sym_do_expression] = STATE(1797),
    [sym_list_expression] = STATE(1797),
    [sym_array_expression] = STATE(1797),
    [sym_begin_end_expression] = STATE(1797),
    [sym_paren_expression] = STATE(1797),
    [sym__high_prec_app] = STATE(1800),
    [sym__low_prec_app] = STATE(1800),
    [sym_application_expression] = STATE(1797),
    [sym_dot_expression] = STATE(1797),
    [sym_infix_expression] = STATE(1797),
    [sym_ce_expression] = STATE(1797),
    [sym_sequential_expression] = STATE(1797),
    [sym_char] = STATE(1694),
    [sym_format_string] = STATE(1693),
    [sym__string_literal] = STATE(1693),
    [sym_string] = STATE(1694),
    [sym_verbatim_string] = STATE(1694),
    [sym_bytearray] = STATE(1694),
    [sym_verbatim_bytearray] = STATE(1694),
    [sym_format_triple_quoted_string] = STATE(1692),
    [sym_triple_quoted_string] = STATE(1694),
    [sym_const] = STATE(1797),
    [sym_long_identifier] = STATE(1813),
    [sym_active_pattern] = STATE(1753),
    [sym__identifier_or_op] = STATE(1812),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(756),
    [sym_sbyte] = STATE(1694),
    [sym_byte] = STATE(1694),
    [sym_int16] = STATE(1694),
    [sym_uint16] = STATE(1694),
    [sym_int32] = STATE(1694),
    [sym_uint32] = STATE(1694),
    [sym_nativeint] = STATE(1694),
    [sym_unativeint] = STATE(1694),
    [sym_int64] = STATE(1694),
    [sym_uint64] = STATE(1694),
    [sym_ieee32] = STATE(1694),
    [sym_ieee64] = STATE(1694),
    [sym_bignum] = STATE(1694),
    [sym_decimal] = STATE(1694),
    [sym_float] = STATE(1425),
    [sym_block_comment] = STATE(586),
    [sym_compiler_directive_decl] = STATE(586),
    [sym_fsi_directive_decl] = STATE(586),
    [sym_preproc_line] = STATE(586),
    [sym_preproc_if_in_expression] = STATE(1797),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(393),
    [anon_sym_return] = ACTIONS(397),
    [anon_sym_do] = ACTIONS(399),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(401),
    [anon_sym_null] = ACTIONS(405),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(407),
    [anon_sym_LBRACK_PIPE] = ACTIONS(409),
    [anon_sym_LBRACE] = ACTIONS(2146),
    [anon_sym_LT_AT] = ACTIONS(413),
    [anon_sym_LT_AT_AT] = ACTIONS(2148),
    [anon_sym_LBRACE_PIPE] = ACTIONS(419),
    [anon_sym_new] = ACTIONS(397),
    [anon_sym_return_BANG] = ACTIONS(421),
    [anon_sym_yield] = ACTIONS(397),
    [anon_sym_yield_BANG] = ACTIONS(421),
    [anon_sym_lazy] = ACTIONS(397),
    [anon_sym_assert] = ACTIONS(397),
    [anon_sym_upcast] = ACTIONS(397),
    [anon_sym_downcast] = ACTIONS(397),
    [anon_sym_for] = ACTIONS(425),
    [anon_sym_while] = ACTIONS(427),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(429),
    [anon_sym_try] = ACTIONS(431),
    [anon_sym_match] = ACTIONS(433),
    [anon_sym_match_BANG] = ACTIONS(435),
    [anon_sym_function] = ACTIONS(437),
    [anon_sym_use] = ACTIONS(445),
    [anon_sym_use_BANG] = ACTIONS(447),
    [anon_sym_do_BANG] = ACTIONS(449),
    [anon_sym_begin] = ACTIONS(451),
    [aux_sym_char_token1] = ACTIONS(455),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(457),
    [anon_sym_DQUOTE] = ACTIONS(459),
    [anon_sym_AT_DQUOTE] = ACTIONS(461),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(463),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(465),
    [sym_bool] = ACTIONS(467),
    [sym_unit] = ACTIONS(2150),
    [anon_sym_LPAREN_PIPE] = ACTIONS(471),
    [sym_op_identifier] = ACTIONS(2152),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(475),
    [sym_xint] = ACTIONS(477),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(479),
  },
  [587] = {
    [sym_function_or_value_defn] = STATE(630),
    [sym__expression] = STATE(159),
    [sym_literal_expression] = STATE(2380),
    [sym_long_identifier_or_op] = STATE(2380),
    [sym_tuple_expression] = STATE(2380),
    [sym_brace_expression] = STATE(2380),
    [sym_anon_record_expression] = STATE(2380),
    [sym_prefixed_expression] = STATE(2380),
    [sym_typecast_expression] = STATE(2380),
    [sym_for_expression] = STATE(2380),
    [sym_while_expression] = STATE(2380),
    [sym__if_branch] = STATE(6456),
    [sym_if_expression] = STATE(2380),
    [sym_fun_expression] = STATE(2380),
    [sym_try_expression] = STATE(2380),
    [sym_match_expression] = STATE(2380),
    [sym_function_expression] = STATE(2380),
    [sym_mutate_expression] = STATE(2380),
    [sym_index_expression] = STATE(2380),
    [sym_typed_expression] = STATE(2380),
    [sym_declaration_expression] = STATE(2380),
    [sym_do_expression] = STATE(2380),
    [sym_list_expression] = STATE(2380),
    [sym_array_expression] = STATE(2380),
    [sym_begin_end_expression] = STATE(2380),
    [sym_paren_expression] = STATE(2380),
    [sym__high_prec_app] = STATE(2383),
    [sym__low_prec_app] = STATE(2383),
    [sym_application_expression] = STATE(2380),
    [sym_dot_expression] = STATE(2380),
    [sym_infix_expression] = STATE(2380),
    [sym_ce_expression] = STATE(2380),
    [sym_sequential_expression] = STATE(2380),
    [sym_char] = STATE(2261),
    [sym_format_string] = STATE(2274),
    [sym__string_literal] = STATE(2274),
    [sym_string] = STATE(2261),
    [sym_verbatim_string] = STATE(2261),
    [sym_bytearray] = STATE(2261),
    [sym_verbatim_bytearray] = STATE(2261),
    [sym_format_triple_quoted_string] = STATE(2275),
    [sym_triple_quoted_string] = STATE(2261),
    [sym_const] = STATE(2380),
    [sym_long_identifier] = STATE(2391),
    [sym_active_pattern] = STATE(2470),
    [sym__identifier_or_op] = STATE(2390),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(632),
    [sym_sbyte] = STATE(2261),
    [sym_byte] = STATE(2261),
    [sym_int16] = STATE(2261),
    [sym_uint16] = STATE(2261),
    [sym_int32] = STATE(2261),
    [sym_uint32] = STATE(2261),
    [sym_nativeint] = STATE(2261),
    [sym_unativeint] = STATE(2261),
    [sym_int64] = STATE(2261),
    [sym_uint64] = STATE(2261),
    [sym_ieee32] = STATE(2261),
    [sym_ieee64] = STATE(2261),
    [sym_bignum] = STATE(2261),
    [sym_decimal] = STATE(2261),
    [sym_float] = STATE(1614),
    [sym_block_comment] = STATE(587),
    [sym_compiler_directive_decl] = STATE(587),
    [sym_fsi_directive_decl] = STATE(587),
    [sym_preproc_line] = STATE(587),
    [sym_preproc_if_in_expression] = STATE(2380),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(1081),
    [anon_sym_return] = ACTIONS(1085),
    [anon_sym_do] = ACTIONS(1087),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(1089),
    [anon_sym_null] = ACTIONS(1093),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1095),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1097),
    [anon_sym_LBRACE] = ACTIONS(2100),
    [anon_sym_LT_AT] = ACTIONS(1101),
    [anon_sym_LT_AT_AT] = ACTIONS(2102),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1107),
    [anon_sym_new] = ACTIONS(1085),
    [anon_sym_return_BANG] = ACTIONS(1109),
    [anon_sym_yield] = ACTIONS(1085),
    [anon_sym_yield_BANG] = ACTIONS(1109),
    [anon_sym_lazy] = ACTIONS(1085),
    [anon_sym_assert] = ACTIONS(1085),
    [anon_sym_upcast] = ACTIONS(1085),
    [anon_sym_downcast] = ACTIONS(1085),
    [anon_sym_for] = ACTIONS(1113),
    [anon_sym_while] = ACTIONS(1115),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(1117),
    [anon_sym_try] = ACTIONS(1119),
    [anon_sym_match] = ACTIONS(1121),
    [anon_sym_match_BANG] = ACTIONS(1123),
    [anon_sym_function] = ACTIONS(1125),
    [anon_sym_use] = ACTIONS(1133),
    [anon_sym_use_BANG] = ACTIONS(1135),
    [anon_sym_do_BANG] = ACTIONS(1137),
    [anon_sym_begin] = ACTIONS(1139),
    [aux_sym_char_token1] = ACTIONS(1143),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1145),
    [anon_sym_DQUOTE] = ACTIONS(1147),
    [anon_sym_AT_DQUOTE] = ACTIONS(1149),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1151),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1153),
    [sym_bool] = ACTIONS(1155),
    [sym_unit] = ACTIONS(2104),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1159),
    [sym_op_identifier] = ACTIONS(2106),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(1163),
    [sym_xint] = ACTIONS(1165),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1167),
  },
  [588] = {
    [sym_function_or_value_defn] = STATE(600),
    [sym__expression] = STATE(89),
    [sym_literal_expression] = STATE(867),
    [sym_long_identifier_or_op] = STATE(867),
    [sym_tuple_expression] = STATE(867),
    [sym_brace_expression] = STATE(867),
    [sym_anon_record_expression] = STATE(867),
    [sym_prefixed_expression] = STATE(867),
    [sym_typecast_expression] = STATE(867),
    [sym_for_expression] = STATE(867),
    [sym_while_expression] = STATE(867),
    [sym__if_branch] = STATE(6511),
    [sym_if_expression] = STATE(867),
    [sym_fun_expression] = STATE(867),
    [sym_try_expression] = STATE(867),
    [sym_match_expression] = STATE(867),
    [sym_function_expression] = STATE(867),
    [sym_mutate_expression] = STATE(867),
    [sym_index_expression] = STATE(867),
    [sym_typed_expression] = STATE(867),
    [sym_declaration_expression] = STATE(867),
    [sym_do_expression] = STATE(867),
    [sym_list_expression] = STATE(867),
    [sym_array_expression] = STATE(867),
    [sym_begin_end_expression] = STATE(867),
    [sym_paren_expression] = STATE(867),
    [sym__high_prec_app] = STATE(864),
    [sym__low_prec_app] = STATE(864),
    [sym_application_expression] = STATE(867),
    [sym_dot_expression] = STATE(867),
    [sym_infix_expression] = STATE(867),
    [sym_ce_expression] = STATE(867),
    [sym_sequential_expression] = STATE(867),
    [sym_char] = STATE(868),
    [sym_format_string] = STATE(869),
    [sym__string_literal] = STATE(869),
    [sym_string] = STATE(868),
    [sym_verbatim_string] = STATE(868),
    [sym_bytearray] = STATE(868),
    [sym_verbatim_bytearray] = STATE(868),
    [sym_format_triple_quoted_string] = STATE(870),
    [sym_triple_quoted_string] = STATE(868),
    [sym_const] = STATE(867),
    [sym_long_identifier] = STATE(872),
    [sym_active_pattern] = STATE(871),
    [sym__identifier_or_op] = STATE(873),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(656),
    [sym_sbyte] = STATE(868),
    [sym_byte] = STATE(868),
    [sym_int16] = STATE(868),
    [sym_uint16] = STATE(868),
    [sym_int32] = STATE(868),
    [sym_uint32] = STATE(868),
    [sym_nativeint] = STATE(868),
    [sym_unativeint] = STATE(868),
    [sym_int64] = STATE(868),
    [sym_uint64] = STATE(868),
    [sym_ieee32] = STATE(868),
    [sym_ieee64] = STATE(868),
    [sym_bignum] = STATE(868),
    [sym_decimal] = STATE(868),
    [sym_float] = STATE(1368),
    [sym_block_comment] = STATE(588),
    [sym_compiler_directive_decl] = STATE(588),
    [sym_fsi_directive_decl] = STATE(588),
    [sym_preproc_line] = STATE(588),
    [sym_preproc_if_in_expression] = STATE(867),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(29),
    [anon_sym_return] = ACTIONS(825),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_null] = ACTIONS(49),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACK_PIPE] = ACTIONS(57),
    [anon_sym_LBRACE] = ACTIONS(1663),
    [anon_sym_LT_AT] = ACTIONS(61),
    [anon_sym_LT_AT_AT] = ACTIONS(1665),
    [anon_sym_LBRACE_PIPE] = ACTIONS(67),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_return_BANG] = ACTIONS(829),
    [anon_sym_yield] = ACTIONS(825),
    [anon_sym_yield_BANG] = ACTIONS(829),
    [anon_sym_lazy] = ACTIONS(825),
    [anon_sym_assert] = ACTIONS(825),
    [anon_sym_upcast] = ACTIONS(825),
    [anon_sym_downcast] = ACTIONS(825),
    [anon_sym_for] = ACTIONS(73),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(79),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_match] = ACTIONS(83),
    [anon_sym_match_BANG] = ACTIONS(85),
    [anon_sym_function] = ACTIONS(87),
    [anon_sym_use] = ACTIONS(833),
    [anon_sym_use_BANG] = ACTIONS(835),
    [anon_sym_do_BANG] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(101),
    [aux_sym_char_token1] = ACTIONS(105),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(107),
    [anon_sym_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DQUOTE] = ACTIONS(111),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(115),
    [sym_bool] = ACTIONS(117),
    [sym_unit] = ACTIONS(1673),
    [anon_sym_LPAREN_PIPE] = ACTIONS(121),
    [sym_op_identifier] = ACTIONS(1675),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(837),
    [sym_xint] = ACTIONS(387),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(135),
  },
  [589] = {
    [sym_function_or_value_defn] = STATE(600),
    [sym__expression] = STATE(236),
    [sym_literal_expression] = STATE(867),
    [sym_long_identifier_or_op] = STATE(867),
    [sym_tuple_expression] = STATE(867),
    [sym_brace_expression] = STATE(867),
    [sym_anon_record_expression] = STATE(867),
    [sym_prefixed_expression] = STATE(867),
    [sym_typecast_expression] = STATE(867),
    [sym_for_expression] = STATE(867),
    [sym_while_expression] = STATE(867),
    [sym__if_branch] = STATE(6511),
    [sym_if_expression] = STATE(867),
    [sym_fun_expression] = STATE(867),
    [sym_try_expression] = STATE(867),
    [sym_match_expression] = STATE(867),
    [sym_function_expression] = STATE(867),
    [sym_mutate_expression] = STATE(867),
    [sym_index_expression] = STATE(867),
    [sym_typed_expression] = STATE(867),
    [sym_declaration_expression] = STATE(867),
    [sym_do_expression] = STATE(867),
    [sym_list_expression] = STATE(867),
    [sym_array_expression] = STATE(867),
    [sym_begin_end_expression] = STATE(867),
    [sym_paren_expression] = STATE(867),
    [sym__high_prec_app] = STATE(864),
    [sym__low_prec_app] = STATE(864),
    [sym_application_expression] = STATE(867),
    [sym_dot_expression] = STATE(867),
    [sym_infix_expression] = STATE(867),
    [sym_ce_expression] = STATE(867),
    [sym_sequential_expression] = STATE(867),
    [sym_char] = STATE(868),
    [sym_format_string] = STATE(869),
    [sym__string_literal] = STATE(869),
    [sym_string] = STATE(868),
    [sym_verbatim_string] = STATE(868),
    [sym_bytearray] = STATE(868),
    [sym_verbatim_bytearray] = STATE(868),
    [sym_format_triple_quoted_string] = STATE(870),
    [sym_triple_quoted_string] = STATE(868),
    [sym_const] = STATE(867),
    [sym_long_identifier] = STATE(872),
    [sym_active_pattern] = STATE(871),
    [sym__identifier_or_op] = STATE(873),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(656),
    [sym_sbyte] = STATE(868),
    [sym_byte] = STATE(868),
    [sym_int16] = STATE(868),
    [sym_uint16] = STATE(868),
    [sym_int32] = STATE(868),
    [sym_uint32] = STATE(868),
    [sym_nativeint] = STATE(868),
    [sym_unativeint] = STATE(868),
    [sym_int64] = STATE(868),
    [sym_uint64] = STATE(868),
    [sym_ieee32] = STATE(868),
    [sym_ieee64] = STATE(868),
    [sym_bignum] = STATE(868),
    [sym_decimal] = STATE(868),
    [sym_float] = STATE(1368),
    [sym_block_comment] = STATE(589),
    [sym_compiler_directive_decl] = STATE(589),
    [sym_fsi_directive_decl] = STATE(589),
    [sym_preproc_line] = STATE(589),
    [sym_preproc_if_in_expression] = STATE(867),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(29),
    [anon_sym_return] = ACTIONS(825),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_null] = ACTIONS(49),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACK_PIPE] = ACTIONS(57),
    [anon_sym_LBRACE] = ACTIONS(1663),
    [anon_sym_LT_AT] = ACTIONS(61),
    [anon_sym_LT_AT_AT] = ACTIONS(1665),
    [anon_sym_LBRACE_PIPE] = ACTIONS(67),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_return_BANG] = ACTIONS(829),
    [anon_sym_yield] = ACTIONS(825),
    [anon_sym_yield_BANG] = ACTIONS(829),
    [anon_sym_lazy] = ACTIONS(825),
    [anon_sym_assert] = ACTIONS(825),
    [anon_sym_upcast] = ACTIONS(825),
    [anon_sym_downcast] = ACTIONS(825),
    [anon_sym_for] = ACTIONS(73),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(79),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_match] = ACTIONS(83),
    [anon_sym_match_BANG] = ACTIONS(85),
    [anon_sym_function] = ACTIONS(87),
    [anon_sym_use] = ACTIONS(833),
    [anon_sym_use_BANG] = ACTIONS(835),
    [anon_sym_do_BANG] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(101),
    [aux_sym_char_token1] = ACTIONS(105),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(107),
    [anon_sym_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DQUOTE] = ACTIONS(111),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(115),
    [sym_bool] = ACTIONS(117),
    [sym_unit] = ACTIONS(1673),
    [anon_sym_LPAREN_PIPE] = ACTIONS(121),
    [sym_op_identifier] = ACTIONS(1675),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(837),
    [sym_xint] = ACTIONS(387),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(135),
  },
  [590] = {
    [sym_function_or_value_defn] = STATE(600),
    [sym__expression] = STATE(160),
    [sym_literal_expression] = STATE(867),
    [sym_long_identifier_or_op] = STATE(867),
    [sym_tuple_expression] = STATE(867),
    [sym_brace_expression] = STATE(867),
    [sym_anon_record_expression] = STATE(867),
    [sym_prefixed_expression] = STATE(867),
    [sym_typecast_expression] = STATE(867),
    [sym_for_expression] = STATE(867),
    [sym_while_expression] = STATE(867),
    [sym__if_branch] = STATE(6511),
    [sym_if_expression] = STATE(867),
    [sym_fun_expression] = STATE(867),
    [sym_try_expression] = STATE(867),
    [sym_match_expression] = STATE(867),
    [sym_function_expression] = STATE(867),
    [sym_mutate_expression] = STATE(867),
    [sym_index_expression] = STATE(867),
    [sym_typed_expression] = STATE(867),
    [sym_declaration_expression] = STATE(867),
    [sym_do_expression] = STATE(867),
    [sym_list_expression] = STATE(867),
    [sym_array_expression] = STATE(867),
    [sym_begin_end_expression] = STATE(867),
    [sym_paren_expression] = STATE(867),
    [sym__high_prec_app] = STATE(864),
    [sym__low_prec_app] = STATE(864),
    [sym_application_expression] = STATE(867),
    [sym_dot_expression] = STATE(867),
    [sym_infix_expression] = STATE(867),
    [sym_ce_expression] = STATE(867),
    [sym_sequential_expression] = STATE(867),
    [sym_char] = STATE(868),
    [sym_format_string] = STATE(869),
    [sym__string_literal] = STATE(869),
    [sym_string] = STATE(868),
    [sym_verbatim_string] = STATE(868),
    [sym_bytearray] = STATE(868),
    [sym_verbatim_bytearray] = STATE(868),
    [sym_format_triple_quoted_string] = STATE(870),
    [sym_triple_quoted_string] = STATE(868),
    [sym_const] = STATE(867),
    [sym_long_identifier] = STATE(872),
    [sym_active_pattern] = STATE(871),
    [sym__identifier_or_op] = STATE(873),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(656),
    [sym_sbyte] = STATE(868),
    [sym_byte] = STATE(868),
    [sym_int16] = STATE(868),
    [sym_uint16] = STATE(868),
    [sym_int32] = STATE(868),
    [sym_uint32] = STATE(868),
    [sym_nativeint] = STATE(868),
    [sym_unativeint] = STATE(868),
    [sym_int64] = STATE(868),
    [sym_uint64] = STATE(868),
    [sym_ieee32] = STATE(868),
    [sym_ieee64] = STATE(868),
    [sym_bignum] = STATE(868),
    [sym_decimal] = STATE(868),
    [sym_float] = STATE(1368),
    [sym_block_comment] = STATE(590),
    [sym_compiler_directive_decl] = STATE(590),
    [sym_fsi_directive_decl] = STATE(590),
    [sym_preproc_line] = STATE(590),
    [sym_preproc_if_in_expression] = STATE(867),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(29),
    [anon_sym_return] = ACTIONS(825),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_null] = ACTIONS(49),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACK_PIPE] = ACTIONS(57),
    [anon_sym_LBRACE] = ACTIONS(1663),
    [anon_sym_LT_AT] = ACTIONS(61),
    [anon_sym_LT_AT_AT] = ACTIONS(1665),
    [anon_sym_LBRACE_PIPE] = ACTIONS(67),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_return_BANG] = ACTIONS(829),
    [anon_sym_yield] = ACTIONS(825),
    [anon_sym_yield_BANG] = ACTIONS(829),
    [anon_sym_lazy] = ACTIONS(825),
    [anon_sym_assert] = ACTIONS(825),
    [anon_sym_upcast] = ACTIONS(825),
    [anon_sym_downcast] = ACTIONS(825),
    [anon_sym_for] = ACTIONS(73),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(79),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_match] = ACTIONS(83),
    [anon_sym_match_BANG] = ACTIONS(85),
    [anon_sym_function] = ACTIONS(87),
    [anon_sym_use] = ACTIONS(833),
    [anon_sym_use_BANG] = ACTIONS(835),
    [anon_sym_do_BANG] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(101),
    [aux_sym_char_token1] = ACTIONS(105),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(107),
    [anon_sym_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DQUOTE] = ACTIONS(111),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(115),
    [sym_bool] = ACTIONS(117),
    [sym_unit] = ACTIONS(1673),
    [anon_sym_LPAREN_PIPE] = ACTIONS(121),
    [sym_op_identifier] = ACTIONS(1675),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(837),
    [sym_xint] = ACTIONS(387),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(135),
  },
  [591] = {
    [sym_function_or_value_defn] = STATE(627),
    [sym__expression] = STATE(252),
    [sym_literal_expression] = STATE(1118),
    [sym_long_identifier_or_op] = STATE(1118),
    [sym_tuple_expression] = STATE(1118),
    [sym_brace_expression] = STATE(1118),
    [sym_anon_record_expression] = STATE(1118),
    [sym_prefixed_expression] = STATE(1118),
    [sym_typecast_expression] = STATE(1118),
    [sym_for_expression] = STATE(1118),
    [sym_while_expression] = STATE(1118),
    [sym__if_branch] = STATE(7163),
    [sym_if_expression] = STATE(1118),
    [sym_fun_expression] = STATE(1118),
    [sym_try_expression] = STATE(1118),
    [sym_match_expression] = STATE(1118),
    [sym_function_expression] = STATE(1118),
    [sym_mutate_expression] = STATE(1118),
    [sym_index_expression] = STATE(1118),
    [sym_typed_expression] = STATE(1118),
    [sym_declaration_expression] = STATE(1118),
    [sym_do_expression] = STATE(1118),
    [sym_list_expression] = STATE(1118),
    [sym_array_expression] = STATE(1118),
    [sym_begin_end_expression] = STATE(1118),
    [sym_paren_expression] = STATE(1118),
    [sym__high_prec_app] = STATE(1133),
    [sym__low_prec_app] = STATE(1133),
    [sym_application_expression] = STATE(1118),
    [sym_dot_expression] = STATE(1118),
    [sym_infix_expression] = STATE(1118),
    [sym_ce_expression] = STATE(1118),
    [sym_sequential_expression] = STATE(1118),
    [sym_char] = STATE(1080),
    [sym_format_string] = STATE(1090),
    [sym__string_literal] = STATE(1090),
    [sym_string] = STATE(1080),
    [sym_verbatim_string] = STATE(1080),
    [sym_bytearray] = STATE(1080),
    [sym_verbatim_bytearray] = STATE(1080),
    [sym_format_triple_quoted_string] = STATE(1096),
    [sym_triple_quoted_string] = STATE(1080),
    [sym_const] = STATE(1118),
    [sym_long_identifier] = STATE(1156),
    [sym_active_pattern] = STATE(1085),
    [sym__identifier_or_op] = STATE(1099),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(517),
    [sym_sbyte] = STATE(1080),
    [sym_byte] = STATE(1080),
    [sym_int16] = STATE(1080),
    [sym_uint16] = STATE(1080),
    [sym_int32] = STATE(1080),
    [sym_uint32] = STATE(1080),
    [sym_nativeint] = STATE(1080),
    [sym_unativeint] = STATE(1080),
    [sym_int64] = STATE(1080),
    [sym_uint64] = STATE(1080),
    [sym_ieee32] = STATE(1080),
    [sym_ieee64] = STATE(1080),
    [sym_bignum] = STATE(1080),
    [sym_decimal] = STATE(1080),
    [sym_float] = STATE(979),
    [sym_block_comment] = STATE(591),
    [sym_compiler_directive_decl] = STATE(591),
    [sym_fsi_directive_decl] = STATE(591),
    [sym_preproc_line] = STATE(591),
    [sym_preproc_if_in_expression] = STATE(1118),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(195),
    [anon_sym_return] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_null] = ACTIONS(207),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(209),
    [anon_sym_LBRACK_PIPE] = ACTIONS(211),
    [anon_sym_LBRACE] = ACTIONS(1687),
    [anon_sym_LT_AT] = ACTIONS(213),
    [anon_sym_LT_AT_AT] = ACTIONS(1689),
    [anon_sym_LBRACE_PIPE] = ACTIONS(217),
    [anon_sym_new] = ACTIONS(199),
    [anon_sym_return_BANG] = ACTIONS(219),
    [anon_sym_yield] = ACTIONS(199),
    [anon_sym_yield_BANG] = ACTIONS(219),
    [anon_sym_lazy] = ACTIONS(199),
    [anon_sym_assert] = ACTIONS(199),
    [anon_sym_upcast] = ACTIONS(199),
    [anon_sym_downcast] = ACTIONS(199),
    [anon_sym_for] = ACTIONS(223),
    [anon_sym_while] = ACTIONS(225),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(229),
    [anon_sym_match] = ACTIONS(231),
    [anon_sym_match_BANG] = ACTIONS(233),
    [anon_sym_function] = ACTIONS(235),
    [anon_sym_use] = ACTIONS(239),
    [anon_sym_use_BANG] = ACTIONS(241),
    [anon_sym_do_BANG] = ACTIONS(243),
    [anon_sym_begin] = ACTIONS(245),
    [aux_sym_char_token1] = ACTIONS(247),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(251),
    [anon_sym_AT_DQUOTE] = ACTIONS(253),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(255),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(257),
    [sym_bool] = ACTIONS(259),
    [sym_unit] = ACTIONS(1699),
    [anon_sym_LPAREN_PIPE] = ACTIONS(261),
    [sym_op_identifier] = ACTIONS(1701),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(265),
    [sym_xint] = ACTIONS(267),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(269),
  },
  [592] = {
    [sym_function_or_value_defn] = STATE(703),
    [sym__expression] = STATE(120),
    [sym_literal_expression] = STATE(1797),
    [sym_long_identifier_or_op] = STATE(1797),
    [sym_tuple_expression] = STATE(1797),
    [sym_brace_expression] = STATE(1797),
    [sym_anon_record_expression] = STATE(1797),
    [sym_prefixed_expression] = STATE(1797),
    [sym_typecast_expression] = STATE(1797),
    [sym_for_expression] = STATE(1797),
    [sym_while_expression] = STATE(1797),
    [sym__if_branch] = STATE(6611),
    [sym_if_expression] = STATE(1797),
    [sym_fun_expression] = STATE(1797),
    [sym_try_expression] = STATE(1797),
    [sym_match_expression] = STATE(1797),
    [sym_function_expression] = STATE(1797),
    [sym_mutate_expression] = STATE(1797),
    [sym_index_expression] = STATE(1797),
    [sym_typed_expression] = STATE(1797),
    [sym_declaration_expression] = STATE(1797),
    [sym_do_expression] = STATE(1797),
    [sym_list_expression] = STATE(1797),
    [sym_array_expression] = STATE(1797),
    [sym_begin_end_expression] = STATE(1797),
    [sym_paren_expression] = STATE(1797),
    [sym__high_prec_app] = STATE(1800),
    [sym__low_prec_app] = STATE(1800),
    [sym_application_expression] = STATE(1797),
    [sym_dot_expression] = STATE(1797),
    [sym_infix_expression] = STATE(1797),
    [sym_ce_expression] = STATE(1797),
    [sym_sequential_expression] = STATE(1797),
    [sym_char] = STATE(1694),
    [sym_format_string] = STATE(1693),
    [sym__string_literal] = STATE(1693),
    [sym_string] = STATE(1694),
    [sym_verbatim_string] = STATE(1694),
    [sym_bytearray] = STATE(1694),
    [sym_verbatim_bytearray] = STATE(1694),
    [sym_format_triple_quoted_string] = STATE(1692),
    [sym_triple_quoted_string] = STATE(1694),
    [sym_const] = STATE(1797),
    [sym_long_identifier] = STATE(1813),
    [sym_active_pattern] = STATE(1753),
    [sym__identifier_or_op] = STATE(1812),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(756),
    [sym_sbyte] = STATE(1694),
    [sym_byte] = STATE(1694),
    [sym_int16] = STATE(1694),
    [sym_uint16] = STATE(1694),
    [sym_int32] = STATE(1694),
    [sym_uint32] = STATE(1694),
    [sym_nativeint] = STATE(1694),
    [sym_unativeint] = STATE(1694),
    [sym_int64] = STATE(1694),
    [sym_uint64] = STATE(1694),
    [sym_ieee32] = STATE(1694),
    [sym_ieee64] = STATE(1694),
    [sym_bignum] = STATE(1694),
    [sym_decimal] = STATE(1694),
    [sym_float] = STATE(1425),
    [sym_block_comment] = STATE(592),
    [sym_compiler_directive_decl] = STATE(592),
    [sym_fsi_directive_decl] = STATE(592),
    [sym_preproc_line] = STATE(592),
    [sym_preproc_if_in_expression] = STATE(1797),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(393),
    [anon_sym_return] = ACTIONS(397),
    [anon_sym_do] = ACTIONS(399),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(401),
    [anon_sym_null] = ACTIONS(405),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(407),
    [anon_sym_LBRACK_PIPE] = ACTIONS(409),
    [anon_sym_LBRACE] = ACTIONS(2146),
    [anon_sym_LT_AT] = ACTIONS(413),
    [anon_sym_LT_AT_AT] = ACTIONS(2148),
    [anon_sym_LBRACE_PIPE] = ACTIONS(419),
    [anon_sym_new] = ACTIONS(397),
    [anon_sym_return_BANG] = ACTIONS(421),
    [anon_sym_yield] = ACTIONS(397),
    [anon_sym_yield_BANG] = ACTIONS(421),
    [anon_sym_lazy] = ACTIONS(397),
    [anon_sym_assert] = ACTIONS(397),
    [anon_sym_upcast] = ACTIONS(397),
    [anon_sym_downcast] = ACTIONS(397),
    [anon_sym_for] = ACTIONS(425),
    [anon_sym_while] = ACTIONS(427),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(429),
    [anon_sym_try] = ACTIONS(431),
    [anon_sym_match] = ACTIONS(433),
    [anon_sym_match_BANG] = ACTIONS(435),
    [anon_sym_function] = ACTIONS(437),
    [anon_sym_use] = ACTIONS(445),
    [anon_sym_use_BANG] = ACTIONS(447),
    [anon_sym_do_BANG] = ACTIONS(449),
    [anon_sym_begin] = ACTIONS(451),
    [aux_sym_char_token1] = ACTIONS(455),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(457),
    [anon_sym_DQUOTE] = ACTIONS(459),
    [anon_sym_AT_DQUOTE] = ACTIONS(461),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(463),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(465),
    [sym_bool] = ACTIONS(467),
    [sym_unit] = ACTIONS(2150),
    [anon_sym_LPAREN_PIPE] = ACTIONS(471),
    [sym_op_identifier] = ACTIONS(2152),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(475),
    [sym_xint] = ACTIONS(477),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(479),
  },
  [593] = {
    [sym_function_or_value_defn] = STATE(627),
    [sym__expression] = STATE(328),
    [sym_literal_expression] = STATE(1118),
    [sym_long_identifier_or_op] = STATE(1118),
    [sym_tuple_expression] = STATE(1118),
    [sym_brace_expression] = STATE(1118),
    [sym_anon_record_expression] = STATE(1118),
    [sym_prefixed_expression] = STATE(1118),
    [sym_typecast_expression] = STATE(1118),
    [sym_for_expression] = STATE(1118),
    [sym_while_expression] = STATE(1118),
    [sym__if_branch] = STATE(7163),
    [sym_if_expression] = STATE(1118),
    [sym_fun_expression] = STATE(1118),
    [sym_try_expression] = STATE(1118),
    [sym_match_expression] = STATE(1118),
    [sym_function_expression] = STATE(1118),
    [sym_mutate_expression] = STATE(1118),
    [sym_index_expression] = STATE(1118),
    [sym_typed_expression] = STATE(1118),
    [sym_declaration_expression] = STATE(1118),
    [sym_do_expression] = STATE(1118),
    [sym_list_expression] = STATE(1118),
    [sym_array_expression] = STATE(1118),
    [sym_begin_end_expression] = STATE(1118),
    [sym_paren_expression] = STATE(1118),
    [sym__high_prec_app] = STATE(1133),
    [sym__low_prec_app] = STATE(1133),
    [sym_application_expression] = STATE(1118),
    [sym_dot_expression] = STATE(1118),
    [sym_infix_expression] = STATE(1118),
    [sym_ce_expression] = STATE(1118),
    [sym_sequential_expression] = STATE(1118),
    [sym_char] = STATE(1080),
    [sym_format_string] = STATE(1090),
    [sym__string_literal] = STATE(1090),
    [sym_string] = STATE(1080),
    [sym_verbatim_string] = STATE(1080),
    [sym_bytearray] = STATE(1080),
    [sym_verbatim_bytearray] = STATE(1080),
    [sym_format_triple_quoted_string] = STATE(1096),
    [sym_triple_quoted_string] = STATE(1080),
    [sym_const] = STATE(1118),
    [sym_long_identifier] = STATE(1156),
    [sym_active_pattern] = STATE(1085),
    [sym__identifier_or_op] = STATE(1099),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(517),
    [sym_sbyte] = STATE(1080),
    [sym_byte] = STATE(1080),
    [sym_int16] = STATE(1080),
    [sym_uint16] = STATE(1080),
    [sym_int32] = STATE(1080),
    [sym_uint32] = STATE(1080),
    [sym_nativeint] = STATE(1080),
    [sym_unativeint] = STATE(1080),
    [sym_int64] = STATE(1080),
    [sym_uint64] = STATE(1080),
    [sym_ieee32] = STATE(1080),
    [sym_ieee64] = STATE(1080),
    [sym_bignum] = STATE(1080),
    [sym_decimal] = STATE(1080),
    [sym_float] = STATE(979),
    [sym_block_comment] = STATE(593),
    [sym_compiler_directive_decl] = STATE(593),
    [sym_fsi_directive_decl] = STATE(593),
    [sym_preproc_line] = STATE(593),
    [sym_preproc_if_in_expression] = STATE(1118),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(195),
    [anon_sym_return] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_null] = ACTIONS(207),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(209),
    [anon_sym_LBRACK_PIPE] = ACTIONS(211),
    [anon_sym_LBRACE] = ACTIONS(1687),
    [anon_sym_LT_AT] = ACTIONS(213),
    [anon_sym_LT_AT_AT] = ACTIONS(1689),
    [anon_sym_LBRACE_PIPE] = ACTIONS(217),
    [anon_sym_new] = ACTIONS(199),
    [anon_sym_return_BANG] = ACTIONS(219),
    [anon_sym_yield] = ACTIONS(199),
    [anon_sym_yield_BANG] = ACTIONS(219),
    [anon_sym_lazy] = ACTIONS(199),
    [anon_sym_assert] = ACTIONS(199),
    [anon_sym_upcast] = ACTIONS(199),
    [anon_sym_downcast] = ACTIONS(199),
    [anon_sym_for] = ACTIONS(223),
    [anon_sym_while] = ACTIONS(225),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(229),
    [anon_sym_match] = ACTIONS(231),
    [anon_sym_match_BANG] = ACTIONS(233),
    [anon_sym_function] = ACTIONS(235),
    [anon_sym_use] = ACTIONS(239),
    [anon_sym_use_BANG] = ACTIONS(241),
    [anon_sym_do_BANG] = ACTIONS(243),
    [anon_sym_begin] = ACTIONS(245),
    [aux_sym_char_token1] = ACTIONS(247),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(251),
    [anon_sym_AT_DQUOTE] = ACTIONS(253),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(255),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(257),
    [sym_bool] = ACTIONS(259),
    [sym_unit] = ACTIONS(1699),
    [anon_sym_LPAREN_PIPE] = ACTIONS(261),
    [sym_op_identifier] = ACTIONS(1701),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(265),
    [sym_xint] = ACTIONS(267),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(269),
  },
  [594] = {
    [sym_function_or_value_defn] = STATE(600),
    [sym__expression] = STATE(195),
    [sym_literal_expression] = STATE(867),
    [sym_long_identifier_or_op] = STATE(867),
    [sym_tuple_expression] = STATE(867),
    [sym_brace_expression] = STATE(867),
    [sym_anon_record_expression] = STATE(867),
    [sym_prefixed_expression] = STATE(867),
    [sym_typecast_expression] = STATE(867),
    [sym_for_expression] = STATE(867),
    [sym_while_expression] = STATE(867),
    [sym__if_branch] = STATE(6511),
    [sym_if_expression] = STATE(867),
    [sym_fun_expression] = STATE(867),
    [sym_try_expression] = STATE(867),
    [sym_match_expression] = STATE(867),
    [sym_function_expression] = STATE(867),
    [sym_mutate_expression] = STATE(867),
    [sym_index_expression] = STATE(867),
    [sym_typed_expression] = STATE(867),
    [sym_declaration_expression] = STATE(867),
    [sym_do_expression] = STATE(867),
    [sym_list_expression] = STATE(867),
    [sym_array_expression] = STATE(867),
    [sym_begin_end_expression] = STATE(867),
    [sym_paren_expression] = STATE(867),
    [sym__high_prec_app] = STATE(864),
    [sym__low_prec_app] = STATE(864),
    [sym_application_expression] = STATE(867),
    [sym_dot_expression] = STATE(867),
    [sym_infix_expression] = STATE(867),
    [sym_ce_expression] = STATE(867),
    [sym_sequential_expression] = STATE(867),
    [sym_char] = STATE(868),
    [sym_format_string] = STATE(869),
    [sym__string_literal] = STATE(869),
    [sym_string] = STATE(868),
    [sym_verbatim_string] = STATE(868),
    [sym_bytearray] = STATE(868),
    [sym_verbatim_bytearray] = STATE(868),
    [sym_format_triple_quoted_string] = STATE(870),
    [sym_triple_quoted_string] = STATE(868),
    [sym_const] = STATE(867),
    [sym_long_identifier] = STATE(872),
    [sym_active_pattern] = STATE(871),
    [sym__identifier_or_op] = STATE(873),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(656),
    [sym_sbyte] = STATE(868),
    [sym_byte] = STATE(868),
    [sym_int16] = STATE(868),
    [sym_uint16] = STATE(868),
    [sym_int32] = STATE(868),
    [sym_uint32] = STATE(868),
    [sym_nativeint] = STATE(868),
    [sym_unativeint] = STATE(868),
    [sym_int64] = STATE(868),
    [sym_uint64] = STATE(868),
    [sym_ieee32] = STATE(868),
    [sym_ieee64] = STATE(868),
    [sym_bignum] = STATE(868),
    [sym_decimal] = STATE(868),
    [sym_float] = STATE(1368),
    [sym_block_comment] = STATE(594),
    [sym_compiler_directive_decl] = STATE(594),
    [sym_fsi_directive_decl] = STATE(594),
    [sym_preproc_line] = STATE(594),
    [sym_preproc_if_in_expression] = STATE(867),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(29),
    [anon_sym_return] = ACTIONS(825),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_null] = ACTIONS(49),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACK_PIPE] = ACTIONS(57),
    [anon_sym_LBRACE] = ACTIONS(1663),
    [anon_sym_LT_AT] = ACTIONS(61),
    [anon_sym_LT_AT_AT] = ACTIONS(1665),
    [anon_sym_LBRACE_PIPE] = ACTIONS(67),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_return_BANG] = ACTIONS(829),
    [anon_sym_yield] = ACTIONS(825),
    [anon_sym_yield_BANG] = ACTIONS(829),
    [anon_sym_lazy] = ACTIONS(825),
    [anon_sym_assert] = ACTIONS(825),
    [anon_sym_upcast] = ACTIONS(825),
    [anon_sym_downcast] = ACTIONS(825),
    [anon_sym_for] = ACTIONS(73),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(79),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_match] = ACTIONS(83),
    [anon_sym_match_BANG] = ACTIONS(85),
    [anon_sym_function] = ACTIONS(87),
    [anon_sym_use] = ACTIONS(833),
    [anon_sym_use_BANG] = ACTIONS(835),
    [anon_sym_do_BANG] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(101),
    [aux_sym_char_token1] = ACTIONS(105),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(107),
    [anon_sym_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DQUOTE] = ACTIONS(111),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(115),
    [sym_bool] = ACTIONS(117),
    [sym_unit] = ACTIONS(1673),
    [anon_sym_LPAREN_PIPE] = ACTIONS(121),
    [sym_op_identifier] = ACTIONS(1675),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(837),
    [sym_xint] = ACTIONS(387),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(135),
  },
  [595] = {
    [sym_function_or_value_defn] = STATE(733),
    [sym__expression] = STATE(214),
    [sym_literal_expression] = STATE(2008),
    [sym_long_identifier_or_op] = STATE(2008),
    [sym_tuple_expression] = STATE(2008),
    [sym_brace_expression] = STATE(2008),
    [sym_anon_record_expression] = STATE(2008),
    [sym_prefixed_expression] = STATE(2008),
    [sym_typecast_expression] = STATE(2008),
    [sym_for_expression] = STATE(2008),
    [sym_while_expression] = STATE(2008),
    [sym__if_branch] = STATE(6754),
    [sym_if_expression] = STATE(2008),
    [sym_fun_expression] = STATE(2008),
    [sym_try_expression] = STATE(2008),
    [sym_match_expression] = STATE(2008),
    [sym_function_expression] = STATE(2008),
    [sym_mutate_expression] = STATE(2008),
    [sym_index_expression] = STATE(2008),
    [sym_typed_expression] = STATE(2008),
    [sym_declaration_expression] = STATE(2008),
    [sym_do_expression] = STATE(2008),
    [sym_list_expression] = STATE(2008),
    [sym_array_expression] = STATE(2008),
    [sym_begin_end_expression] = STATE(2008),
    [sym_paren_expression] = STATE(2008),
    [sym__high_prec_app] = STATE(2007),
    [sym__low_prec_app] = STATE(2007),
    [sym_application_expression] = STATE(2008),
    [sym_dot_expression] = STATE(2008),
    [sym_infix_expression] = STATE(2008),
    [sym_ce_expression] = STATE(2008),
    [sym_sequential_expression] = STATE(2008),
    [sym_char] = STATE(1859),
    [sym_format_string] = STATE(1861),
    [sym__string_literal] = STATE(1861),
    [sym_string] = STATE(1859),
    [sym_verbatim_string] = STATE(1859),
    [sym_bytearray] = STATE(1859),
    [sym_verbatim_bytearray] = STATE(1859),
    [sym_format_triple_quoted_string] = STATE(1862),
    [sym_triple_quoted_string] = STATE(1859),
    [sym_const] = STATE(2008),
    [sym_long_identifier] = STATE(1701),
    [sym_active_pattern] = STATE(1702),
    [sym__identifier_or_op] = STATE(1724),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(706),
    [sym_sbyte] = STATE(1859),
    [sym_byte] = STATE(1859),
    [sym_int16] = STATE(1859),
    [sym_uint16] = STATE(1859),
    [sym_int32] = STATE(1859),
    [sym_uint32] = STATE(1859),
    [sym_nativeint] = STATE(1859),
    [sym_unativeint] = STATE(1859),
    [sym_int64] = STATE(1859),
    [sym_uint64] = STATE(1859),
    [sym_ieee32] = STATE(1859),
    [sym_ieee64] = STATE(1859),
    [sym_bignum] = STATE(1859),
    [sym_decimal] = STATE(1859),
    [sym_float] = STATE(1447),
    [sym_block_comment] = STATE(595),
    [sym_compiler_directive_decl] = STATE(595),
    [sym_fsi_directive_decl] = STATE(595),
    [sym_preproc_line] = STATE(595),
    [sym_preproc_if_in_expression] = STATE(2008),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(503),
    [anon_sym_return] = ACTIONS(971),
    [anon_sym_do] = ACTIONS(599),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(511),
    [anon_sym_null] = ACTIONS(515),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(517),
    [anon_sym_LBRACK_PIPE] = ACTIONS(519),
    [anon_sym_LBRACE] = ACTIONS(2060),
    [anon_sym_LT_AT] = ACTIONS(523),
    [anon_sym_LT_AT_AT] = ACTIONS(2062),
    [anon_sym_LBRACE_PIPE] = ACTIONS(529),
    [anon_sym_new] = ACTIONS(971),
    [anon_sym_return_BANG] = ACTIONS(975),
    [anon_sym_yield] = ACTIONS(971),
    [anon_sym_yield_BANG] = ACTIONS(975),
    [anon_sym_lazy] = ACTIONS(971),
    [anon_sym_assert] = ACTIONS(971),
    [anon_sym_upcast] = ACTIONS(971),
    [anon_sym_downcast] = ACTIONS(971),
    [anon_sym_for] = ACTIONS(979),
    [anon_sym_while] = ACTIONS(537),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(539),
    [anon_sym_try] = ACTIONS(543),
    [anon_sym_match] = ACTIONS(545),
    [anon_sym_match_BANG] = ACTIONS(547),
    [anon_sym_function] = ACTIONS(549),
    [anon_sym_use] = ACTIONS(983),
    [anon_sym_use_BANG] = ACTIONS(985),
    [anon_sym_do_BANG] = ACTIONS(561),
    [anon_sym_begin] = ACTIONS(565),
    [aux_sym_char_token1] = ACTIONS(569),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(571),
    [anon_sym_DQUOTE] = ACTIONS(573),
    [anon_sym_AT_DQUOTE] = ACTIONS(575),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(577),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(579),
    [sym_bool] = ACTIONS(581),
    [sym_unit] = ACTIONS(2064),
    [anon_sym_LPAREN_PIPE] = ACTIONS(585),
    [sym_op_identifier] = ACTIONS(2066),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(591),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(593),
  },
  [596] = {
    [sym_function_or_value_defn] = STATE(596),
    [sym__expression] = STATE(101),
    [sym_literal_expression] = STATE(1809),
    [sym_long_identifier_or_op] = STATE(1809),
    [sym_tuple_expression] = STATE(1809),
    [sym_brace_expression] = STATE(1809),
    [sym_anon_record_expression] = STATE(1809),
    [sym_prefixed_expression] = STATE(1809),
    [sym_typecast_expression] = STATE(1809),
    [sym_for_expression] = STATE(1809),
    [sym_while_expression] = STATE(1809),
    [sym__if_branch] = STATE(6874),
    [sym_if_expression] = STATE(1809),
    [sym_fun_expression] = STATE(1809),
    [sym_try_expression] = STATE(1809),
    [sym_match_expression] = STATE(1809),
    [sym_function_expression] = STATE(1809),
    [sym_mutate_expression] = STATE(1809),
    [sym_index_expression] = STATE(1809),
    [sym_typed_expression] = STATE(1809),
    [sym_declaration_expression] = STATE(1809),
    [sym_do_expression] = STATE(1809),
    [sym_list_expression] = STATE(1809),
    [sym_array_expression] = STATE(1809),
    [sym_begin_end_expression] = STATE(1809),
    [sym_paren_expression] = STATE(1809),
    [sym__high_prec_app] = STATE(1806),
    [sym__low_prec_app] = STATE(1806),
    [sym_application_expression] = STATE(1809),
    [sym_dot_expression] = STATE(1809),
    [sym_infix_expression] = STATE(1809),
    [sym_ce_expression] = STATE(1809),
    [sym_sequential_expression] = STATE(1809),
    [sym_char] = STATE(2014),
    [sym_format_string] = STATE(2019),
    [sym__string_literal] = STATE(2019),
    [sym_string] = STATE(2014),
    [sym_verbatim_string] = STATE(2014),
    [sym_bytearray] = STATE(2014),
    [sym_verbatim_bytearray] = STATE(2014),
    [sym_format_triple_quoted_string] = STATE(2020),
    [sym_triple_quoted_string] = STATE(2014),
    [sym_const] = STATE(1809),
    [sym_long_identifier] = STATE(1810),
    [sym_active_pattern] = STATE(1860),
    [sym__identifier_or_op] = STATE(1750),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(655),
    [sym_sbyte] = STATE(2014),
    [sym_byte] = STATE(2014),
    [sym_int16] = STATE(2014),
    [sym_uint16] = STATE(2014),
    [sym_int32] = STATE(2014),
    [sym_uint32] = STATE(2014),
    [sym_nativeint] = STATE(2014),
    [sym_unativeint] = STATE(2014),
    [sym_int64] = STATE(2014),
    [sym_uint64] = STATE(2014),
    [sym_ieee32] = STATE(2014),
    [sym_ieee64] = STATE(2014),
    [sym_bignum] = STATE(2014),
    [sym_decimal] = STATE(2014),
    [sym_float] = STATE(1438),
    [sym_block_comment] = STATE(596),
    [sym_compiler_directive_decl] = STATE(596),
    [sym_fsi_directive_decl] = STATE(596),
    [sym_preproc_line] = STATE(596),
    [sym_preproc_if_in_expression] = STATE(1809),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(723),
    [anon_sym_return] = ACTIONS(727),
    [anon_sym_do] = ACTIONS(729),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(731),
    [anon_sym_null] = ACTIONS(735),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(737),
    [anon_sym_LBRACK_PIPE] = ACTIONS(739),
    [anon_sym_LBRACE] = ACTIONS(2112),
    [anon_sym_LT_AT] = ACTIONS(743),
    [anon_sym_LT_AT_AT] = ACTIONS(2114),
    [anon_sym_LBRACE_PIPE] = ACTIONS(749),
    [anon_sym_new] = ACTIONS(727),
    [anon_sym_return_BANG] = ACTIONS(751),
    [anon_sym_yield] = ACTIONS(727),
    [anon_sym_yield_BANG] = ACTIONS(751),
    [anon_sym_lazy] = ACTIONS(727),
    [anon_sym_assert] = ACTIONS(727),
    [anon_sym_upcast] = ACTIONS(727),
    [anon_sym_downcast] = ACTIONS(727),
    [anon_sym_for] = ACTIONS(755),
    [anon_sym_while] = ACTIONS(757),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(759),
    [anon_sym_try] = ACTIONS(761),
    [anon_sym_match] = ACTIONS(763),
    [anon_sym_match_BANG] = ACTIONS(765),
    [anon_sym_function] = ACTIONS(767),
    [anon_sym_use] = ACTIONS(775),
    [anon_sym_use_BANG] = ACTIONS(777),
    [anon_sym_do_BANG] = ACTIONS(779),
    [anon_sym_begin] = ACTIONS(781),
    [aux_sym_char_token1] = ACTIONS(785),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(787),
    [anon_sym_DQUOTE] = ACTIONS(789),
    [anon_sym_AT_DQUOTE] = ACTIONS(791),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(793),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(795),
    [sym_bool] = ACTIONS(797),
    [sym_unit] = ACTIONS(2116),
    [anon_sym_LPAREN_PIPE] = ACTIONS(801),
    [sym_op_identifier] = ACTIONS(2118),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(805),
    [sym_xint] = ACTIONS(807),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(809),
  },
  [597] = {
    [sym_function_or_value_defn] = STATE(627),
    [sym__expression] = STATE(346),
    [sym_literal_expression] = STATE(1118),
    [sym_long_identifier_or_op] = STATE(1118),
    [sym_tuple_expression] = STATE(1118),
    [sym_brace_expression] = STATE(1118),
    [sym_anon_record_expression] = STATE(1118),
    [sym_prefixed_expression] = STATE(1118),
    [sym_typecast_expression] = STATE(1118),
    [sym_for_expression] = STATE(1118),
    [sym_while_expression] = STATE(1118),
    [sym__if_branch] = STATE(7163),
    [sym_if_expression] = STATE(1118),
    [sym_fun_expression] = STATE(1118),
    [sym_try_expression] = STATE(1118),
    [sym_match_expression] = STATE(1118),
    [sym_function_expression] = STATE(1118),
    [sym_mutate_expression] = STATE(1118),
    [sym_index_expression] = STATE(1118),
    [sym_typed_expression] = STATE(1118),
    [sym_declaration_expression] = STATE(1118),
    [sym_do_expression] = STATE(1118),
    [sym_list_expression] = STATE(1118),
    [sym_array_expression] = STATE(1118),
    [sym_begin_end_expression] = STATE(1118),
    [sym_paren_expression] = STATE(1118),
    [sym__high_prec_app] = STATE(1133),
    [sym__low_prec_app] = STATE(1133),
    [sym_application_expression] = STATE(1118),
    [sym_dot_expression] = STATE(1118),
    [sym_infix_expression] = STATE(1118),
    [sym_ce_expression] = STATE(1118),
    [sym_sequential_expression] = STATE(1118),
    [sym_char] = STATE(1080),
    [sym_format_string] = STATE(1090),
    [sym__string_literal] = STATE(1090),
    [sym_string] = STATE(1080),
    [sym_verbatim_string] = STATE(1080),
    [sym_bytearray] = STATE(1080),
    [sym_verbatim_bytearray] = STATE(1080),
    [sym_format_triple_quoted_string] = STATE(1096),
    [sym_triple_quoted_string] = STATE(1080),
    [sym_const] = STATE(1118),
    [sym_long_identifier] = STATE(1156),
    [sym_active_pattern] = STATE(1085),
    [sym__identifier_or_op] = STATE(1099),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(517),
    [sym_sbyte] = STATE(1080),
    [sym_byte] = STATE(1080),
    [sym_int16] = STATE(1080),
    [sym_uint16] = STATE(1080),
    [sym_int32] = STATE(1080),
    [sym_uint32] = STATE(1080),
    [sym_nativeint] = STATE(1080),
    [sym_unativeint] = STATE(1080),
    [sym_int64] = STATE(1080),
    [sym_uint64] = STATE(1080),
    [sym_ieee32] = STATE(1080),
    [sym_ieee64] = STATE(1080),
    [sym_bignum] = STATE(1080),
    [sym_decimal] = STATE(1080),
    [sym_float] = STATE(979),
    [sym_block_comment] = STATE(597),
    [sym_compiler_directive_decl] = STATE(597),
    [sym_fsi_directive_decl] = STATE(597),
    [sym_preproc_line] = STATE(597),
    [sym_preproc_if_in_expression] = STATE(1118),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(195),
    [anon_sym_return] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_null] = ACTIONS(207),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(209),
    [anon_sym_LBRACK_PIPE] = ACTIONS(211),
    [anon_sym_LBRACE] = ACTIONS(1687),
    [anon_sym_LT_AT] = ACTIONS(213),
    [anon_sym_LT_AT_AT] = ACTIONS(1689),
    [anon_sym_LBRACE_PIPE] = ACTIONS(217),
    [anon_sym_new] = ACTIONS(199),
    [anon_sym_return_BANG] = ACTIONS(219),
    [anon_sym_yield] = ACTIONS(199),
    [anon_sym_yield_BANG] = ACTIONS(219),
    [anon_sym_lazy] = ACTIONS(199),
    [anon_sym_assert] = ACTIONS(199),
    [anon_sym_upcast] = ACTIONS(199),
    [anon_sym_downcast] = ACTIONS(199),
    [anon_sym_for] = ACTIONS(223),
    [anon_sym_while] = ACTIONS(225),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(229),
    [anon_sym_match] = ACTIONS(231),
    [anon_sym_match_BANG] = ACTIONS(233),
    [anon_sym_function] = ACTIONS(235),
    [anon_sym_use] = ACTIONS(239),
    [anon_sym_use_BANG] = ACTIONS(241),
    [anon_sym_do_BANG] = ACTIONS(243),
    [anon_sym_begin] = ACTIONS(245),
    [aux_sym_char_token1] = ACTIONS(247),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(251),
    [anon_sym_AT_DQUOTE] = ACTIONS(253),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(255),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(257),
    [sym_bool] = ACTIONS(259),
    [sym_unit] = ACTIONS(1699),
    [anon_sym_LPAREN_PIPE] = ACTIONS(261),
    [sym_op_identifier] = ACTIONS(1701),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(265),
    [sym_xint] = ACTIONS(267),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(269),
  },
  [598] = {
    [sym_function_or_value_defn] = STATE(705),
    [sym__expression] = STATE(10),
    [sym_literal_expression] = STATE(867),
    [sym_long_identifier_or_op] = STATE(867),
    [sym_tuple_expression] = STATE(867),
    [sym_brace_expression] = STATE(867),
    [sym_anon_record_expression] = STATE(867),
    [sym_prefixed_expression] = STATE(867),
    [sym_typecast_expression] = STATE(867),
    [sym_for_expression] = STATE(867),
    [sym_while_expression] = STATE(867),
    [sym__if_branch] = STATE(6511),
    [sym_if_expression] = STATE(867),
    [sym_fun_expression] = STATE(867),
    [sym_try_expression] = STATE(867),
    [sym_match_expression] = STATE(867),
    [sym_function_expression] = STATE(867),
    [sym_mutate_expression] = STATE(867),
    [sym_index_expression] = STATE(867),
    [sym_typed_expression] = STATE(867),
    [sym_declaration_expression] = STATE(867),
    [sym_do_expression] = STATE(867),
    [sym_list_expression] = STATE(867),
    [sym_array_expression] = STATE(867),
    [sym_begin_end_expression] = STATE(867),
    [sym_paren_expression] = STATE(867),
    [sym__high_prec_app] = STATE(864),
    [sym__low_prec_app] = STATE(864),
    [sym_application_expression] = STATE(867),
    [sym_dot_expression] = STATE(867),
    [sym_infix_expression] = STATE(867),
    [sym_ce_expression] = STATE(867),
    [sym_sequential_expression] = STATE(867),
    [sym_char] = STATE(868),
    [sym_format_string] = STATE(869),
    [sym__string_literal] = STATE(869),
    [sym_string] = STATE(868),
    [sym_verbatim_string] = STATE(868),
    [sym_bytearray] = STATE(868),
    [sym_verbatim_bytearray] = STATE(868),
    [sym_format_triple_quoted_string] = STATE(870),
    [sym_triple_quoted_string] = STATE(868),
    [sym_const] = STATE(867),
    [sym_long_identifier] = STATE(872),
    [sym_active_pattern] = STATE(871),
    [sym__identifier_or_op] = STATE(873),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(658),
    [sym_sbyte] = STATE(868),
    [sym_byte] = STATE(868),
    [sym_int16] = STATE(868),
    [sym_uint16] = STATE(868),
    [sym_int32] = STATE(868),
    [sym_uint32] = STATE(868),
    [sym_nativeint] = STATE(868),
    [sym_unativeint] = STATE(868),
    [sym_int64] = STATE(868),
    [sym_uint64] = STATE(868),
    [sym_ieee32] = STATE(868),
    [sym_ieee64] = STATE(868),
    [sym_bignum] = STATE(868),
    [sym_decimal] = STATE(868),
    [sym_float] = STATE(860),
    [sym_block_comment] = STATE(598),
    [sym_compiler_directive_decl] = STATE(598),
    [sym_fsi_directive_decl] = STATE(598),
    [sym_preproc_line] = STATE(598),
    [sym_preproc_if_in_expression] = STATE(867),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(29),
    [anon_sym_return] = ACTIONS(37),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_null] = ACTIONS(49),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACK_PIPE] = ACTIONS(57),
    [anon_sym_LBRACE] = ACTIONS(1663),
    [anon_sym_LT_AT] = ACTIONS(61),
    [anon_sym_LT_AT_AT] = ACTIONS(1665),
    [anon_sym_LBRACE_PIPE] = ACTIONS(67),
    [anon_sym_new] = ACTIONS(37),
    [anon_sym_return_BANG] = ACTIONS(69),
    [anon_sym_yield] = ACTIONS(37),
    [anon_sym_yield_BANG] = ACTIONS(69),
    [anon_sym_lazy] = ACTIONS(37),
    [anon_sym_assert] = ACTIONS(37),
    [anon_sym_upcast] = ACTIONS(37),
    [anon_sym_downcast] = ACTIONS(37),
    [anon_sym_for] = ACTIONS(73),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(79),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_match] = ACTIONS(83),
    [anon_sym_match_BANG] = ACTIONS(85),
    [anon_sym_function] = ACTIONS(87),
    [anon_sym_use] = ACTIONS(95),
    [anon_sym_use_BANG] = ACTIONS(97),
    [anon_sym_do_BANG] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(101),
    [aux_sym_char_token1] = ACTIONS(105),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(107),
    [anon_sym_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DQUOTE] = ACTIONS(111),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(115),
    [sym_bool] = ACTIONS(117),
    [sym_unit] = ACTIONS(1673),
    [anon_sym_LPAREN_PIPE] = ACTIONS(121),
    [sym_op_identifier] = ACTIONS(1675),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(129),
    [sym_xint] = ACTIONS(131),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(135),
  },
  [599] = {
    [sym_function_or_value_defn] = STATE(600),
    [sym__expression] = STATE(237),
    [sym_literal_expression] = STATE(867),
    [sym_long_identifier_or_op] = STATE(867),
    [sym_tuple_expression] = STATE(867),
    [sym_brace_expression] = STATE(867),
    [sym_anon_record_expression] = STATE(867),
    [sym_prefixed_expression] = STATE(867),
    [sym_typecast_expression] = STATE(867),
    [sym_for_expression] = STATE(867),
    [sym_while_expression] = STATE(867),
    [sym__if_branch] = STATE(6511),
    [sym_if_expression] = STATE(867),
    [sym_fun_expression] = STATE(867),
    [sym_try_expression] = STATE(867),
    [sym_match_expression] = STATE(867),
    [sym_function_expression] = STATE(867),
    [sym_mutate_expression] = STATE(867),
    [sym_index_expression] = STATE(867),
    [sym_typed_expression] = STATE(867),
    [sym_declaration_expression] = STATE(867),
    [sym_do_expression] = STATE(867),
    [sym_list_expression] = STATE(867),
    [sym_array_expression] = STATE(867),
    [sym_begin_end_expression] = STATE(867),
    [sym_paren_expression] = STATE(867),
    [sym__high_prec_app] = STATE(864),
    [sym__low_prec_app] = STATE(864),
    [sym_application_expression] = STATE(867),
    [sym_dot_expression] = STATE(867),
    [sym_infix_expression] = STATE(867),
    [sym_ce_expression] = STATE(867),
    [sym_sequential_expression] = STATE(867),
    [sym_char] = STATE(868),
    [sym_format_string] = STATE(869),
    [sym__string_literal] = STATE(869),
    [sym_string] = STATE(868),
    [sym_verbatim_string] = STATE(868),
    [sym_bytearray] = STATE(868),
    [sym_verbatim_bytearray] = STATE(868),
    [sym_format_triple_quoted_string] = STATE(870),
    [sym_triple_quoted_string] = STATE(868),
    [sym_const] = STATE(867),
    [sym_long_identifier] = STATE(872),
    [sym_active_pattern] = STATE(871),
    [sym__identifier_or_op] = STATE(873),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(656),
    [sym_sbyte] = STATE(868),
    [sym_byte] = STATE(868),
    [sym_int16] = STATE(868),
    [sym_uint16] = STATE(868),
    [sym_int32] = STATE(868),
    [sym_uint32] = STATE(868),
    [sym_nativeint] = STATE(868),
    [sym_unativeint] = STATE(868),
    [sym_int64] = STATE(868),
    [sym_uint64] = STATE(868),
    [sym_ieee32] = STATE(868),
    [sym_ieee64] = STATE(868),
    [sym_bignum] = STATE(868),
    [sym_decimal] = STATE(868),
    [sym_float] = STATE(1368),
    [sym_block_comment] = STATE(599),
    [sym_compiler_directive_decl] = STATE(599),
    [sym_fsi_directive_decl] = STATE(599),
    [sym_preproc_line] = STATE(599),
    [sym_preproc_if_in_expression] = STATE(867),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(29),
    [anon_sym_return] = ACTIONS(825),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_null] = ACTIONS(49),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACK_PIPE] = ACTIONS(57),
    [anon_sym_LBRACE] = ACTIONS(1663),
    [anon_sym_LT_AT] = ACTIONS(61),
    [anon_sym_LT_AT_AT] = ACTIONS(1665),
    [anon_sym_LBRACE_PIPE] = ACTIONS(67),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_return_BANG] = ACTIONS(829),
    [anon_sym_yield] = ACTIONS(825),
    [anon_sym_yield_BANG] = ACTIONS(829),
    [anon_sym_lazy] = ACTIONS(825),
    [anon_sym_assert] = ACTIONS(825),
    [anon_sym_upcast] = ACTIONS(825),
    [anon_sym_downcast] = ACTIONS(825),
    [anon_sym_for] = ACTIONS(73),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(79),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_match] = ACTIONS(83),
    [anon_sym_match_BANG] = ACTIONS(85),
    [anon_sym_function] = ACTIONS(87),
    [anon_sym_use] = ACTIONS(833),
    [anon_sym_use_BANG] = ACTIONS(835),
    [anon_sym_do_BANG] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(101),
    [aux_sym_char_token1] = ACTIONS(105),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(107),
    [anon_sym_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DQUOTE] = ACTIONS(111),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(115),
    [sym_bool] = ACTIONS(117),
    [sym_unit] = ACTIONS(1673),
    [anon_sym_LPAREN_PIPE] = ACTIONS(121),
    [sym_op_identifier] = ACTIONS(1675),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(837),
    [sym_xint] = ACTIONS(387),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(135),
  },
  [600] = {
    [sym_function_or_value_defn] = STATE(600),
    [sym__expression] = STATE(86),
    [sym_literal_expression] = STATE(867),
    [sym_long_identifier_or_op] = STATE(867),
    [sym_tuple_expression] = STATE(867),
    [sym_brace_expression] = STATE(867),
    [sym_anon_record_expression] = STATE(867),
    [sym_prefixed_expression] = STATE(867),
    [sym_typecast_expression] = STATE(867),
    [sym_for_expression] = STATE(867),
    [sym_while_expression] = STATE(867),
    [sym__if_branch] = STATE(6511),
    [sym_if_expression] = STATE(867),
    [sym_fun_expression] = STATE(867),
    [sym_try_expression] = STATE(867),
    [sym_match_expression] = STATE(867),
    [sym_function_expression] = STATE(867),
    [sym_mutate_expression] = STATE(867),
    [sym_index_expression] = STATE(867),
    [sym_typed_expression] = STATE(867),
    [sym_declaration_expression] = STATE(867),
    [sym_do_expression] = STATE(867),
    [sym_list_expression] = STATE(867),
    [sym_array_expression] = STATE(867),
    [sym_begin_end_expression] = STATE(867),
    [sym_paren_expression] = STATE(867),
    [sym__high_prec_app] = STATE(864),
    [sym__low_prec_app] = STATE(864),
    [sym_application_expression] = STATE(867),
    [sym_dot_expression] = STATE(867),
    [sym_infix_expression] = STATE(867),
    [sym_ce_expression] = STATE(867),
    [sym_sequential_expression] = STATE(867),
    [sym_char] = STATE(868),
    [sym_format_string] = STATE(869),
    [sym__string_literal] = STATE(869),
    [sym_string] = STATE(868),
    [sym_verbatim_string] = STATE(868),
    [sym_bytearray] = STATE(868),
    [sym_verbatim_bytearray] = STATE(868),
    [sym_format_triple_quoted_string] = STATE(870),
    [sym_triple_quoted_string] = STATE(868),
    [sym_const] = STATE(867),
    [sym_long_identifier] = STATE(872),
    [sym_active_pattern] = STATE(871),
    [sym__identifier_or_op] = STATE(873),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(656),
    [sym_sbyte] = STATE(868),
    [sym_byte] = STATE(868),
    [sym_int16] = STATE(868),
    [sym_uint16] = STATE(868),
    [sym_int32] = STATE(868),
    [sym_uint32] = STATE(868),
    [sym_nativeint] = STATE(868),
    [sym_unativeint] = STATE(868),
    [sym_int64] = STATE(868),
    [sym_uint64] = STATE(868),
    [sym_ieee32] = STATE(868),
    [sym_ieee64] = STATE(868),
    [sym_bignum] = STATE(868),
    [sym_decimal] = STATE(868),
    [sym_float] = STATE(1368),
    [sym_block_comment] = STATE(600),
    [sym_compiler_directive_decl] = STATE(600),
    [sym_fsi_directive_decl] = STATE(600),
    [sym_preproc_line] = STATE(600),
    [sym_preproc_if_in_expression] = STATE(867),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(29),
    [anon_sym_return] = ACTIONS(825),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_null] = ACTIONS(49),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACK_PIPE] = ACTIONS(57),
    [anon_sym_LBRACE] = ACTIONS(1663),
    [anon_sym_LT_AT] = ACTIONS(61),
    [anon_sym_LT_AT_AT] = ACTIONS(1665),
    [anon_sym_LBRACE_PIPE] = ACTIONS(67),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_return_BANG] = ACTIONS(829),
    [anon_sym_yield] = ACTIONS(825),
    [anon_sym_yield_BANG] = ACTIONS(829),
    [anon_sym_lazy] = ACTIONS(825),
    [anon_sym_assert] = ACTIONS(825),
    [anon_sym_upcast] = ACTIONS(825),
    [anon_sym_downcast] = ACTIONS(825),
    [anon_sym_for] = ACTIONS(73),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(79),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_match] = ACTIONS(83),
    [anon_sym_match_BANG] = ACTIONS(85),
    [anon_sym_function] = ACTIONS(87),
    [anon_sym_use] = ACTIONS(833),
    [anon_sym_use_BANG] = ACTIONS(835),
    [anon_sym_do_BANG] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(101),
    [aux_sym_char_token1] = ACTIONS(105),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(107),
    [anon_sym_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DQUOTE] = ACTIONS(111),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(115),
    [sym_bool] = ACTIONS(117),
    [sym_unit] = ACTIONS(1673),
    [anon_sym_LPAREN_PIPE] = ACTIONS(121),
    [sym_op_identifier] = ACTIONS(1675),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(837),
    [sym_xint] = ACTIONS(387),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(135),
  },
  [601] = {
    [sym_function_or_value_defn] = STATE(600),
    [sym__expression] = STATE(314),
    [sym_literal_expression] = STATE(867),
    [sym_long_identifier_or_op] = STATE(867),
    [sym_tuple_expression] = STATE(867),
    [sym_brace_expression] = STATE(867),
    [sym_anon_record_expression] = STATE(867),
    [sym_prefixed_expression] = STATE(867),
    [sym_typecast_expression] = STATE(867),
    [sym_for_expression] = STATE(867),
    [sym_while_expression] = STATE(867),
    [sym__if_branch] = STATE(6511),
    [sym_if_expression] = STATE(867),
    [sym_fun_expression] = STATE(867),
    [sym_try_expression] = STATE(867),
    [sym_match_expression] = STATE(867),
    [sym_function_expression] = STATE(867),
    [sym_mutate_expression] = STATE(867),
    [sym_index_expression] = STATE(867),
    [sym_typed_expression] = STATE(867),
    [sym_declaration_expression] = STATE(867),
    [sym_do_expression] = STATE(867),
    [sym_list_expression] = STATE(867),
    [sym_array_expression] = STATE(867),
    [sym_begin_end_expression] = STATE(867),
    [sym_paren_expression] = STATE(867),
    [sym__high_prec_app] = STATE(864),
    [sym__low_prec_app] = STATE(864),
    [sym_application_expression] = STATE(867),
    [sym_dot_expression] = STATE(867),
    [sym_infix_expression] = STATE(867),
    [sym_ce_expression] = STATE(867),
    [sym_sequential_expression] = STATE(867),
    [sym_char] = STATE(868),
    [sym_format_string] = STATE(869),
    [sym__string_literal] = STATE(869),
    [sym_string] = STATE(868),
    [sym_verbatim_string] = STATE(868),
    [sym_bytearray] = STATE(868),
    [sym_verbatim_bytearray] = STATE(868),
    [sym_format_triple_quoted_string] = STATE(870),
    [sym_triple_quoted_string] = STATE(868),
    [sym_const] = STATE(867),
    [sym_long_identifier] = STATE(872),
    [sym_active_pattern] = STATE(871),
    [sym__identifier_or_op] = STATE(873),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(656),
    [sym_sbyte] = STATE(868),
    [sym_byte] = STATE(868),
    [sym_int16] = STATE(868),
    [sym_uint16] = STATE(868),
    [sym_int32] = STATE(868),
    [sym_uint32] = STATE(868),
    [sym_nativeint] = STATE(868),
    [sym_unativeint] = STATE(868),
    [sym_int64] = STATE(868),
    [sym_uint64] = STATE(868),
    [sym_ieee32] = STATE(868),
    [sym_ieee64] = STATE(868),
    [sym_bignum] = STATE(868),
    [sym_decimal] = STATE(868),
    [sym_float] = STATE(1368),
    [sym_block_comment] = STATE(601),
    [sym_compiler_directive_decl] = STATE(601),
    [sym_fsi_directive_decl] = STATE(601),
    [sym_preproc_line] = STATE(601),
    [sym_preproc_if_in_expression] = STATE(867),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(29),
    [anon_sym_return] = ACTIONS(825),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_null] = ACTIONS(49),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACK_PIPE] = ACTIONS(57),
    [anon_sym_LBRACE] = ACTIONS(1663),
    [anon_sym_LT_AT] = ACTIONS(61),
    [anon_sym_LT_AT_AT] = ACTIONS(1665),
    [anon_sym_LBRACE_PIPE] = ACTIONS(67),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_return_BANG] = ACTIONS(829),
    [anon_sym_yield] = ACTIONS(825),
    [anon_sym_yield_BANG] = ACTIONS(829),
    [anon_sym_lazy] = ACTIONS(825),
    [anon_sym_assert] = ACTIONS(825),
    [anon_sym_upcast] = ACTIONS(825),
    [anon_sym_downcast] = ACTIONS(825),
    [anon_sym_for] = ACTIONS(73),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(79),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_match] = ACTIONS(83),
    [anon_sym_match_BANG] = ACTIONS(85),
    [anon_sym_function] = ACTIONS(87),
    [anon_sym_use] = ACTIONS(833),
    [anon_sym_use_BANG] = ACTIONS(835),
    [anon_sym_do_BANG] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(101),
    [aux_sym_char_token1] = ACTIONS(105),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(107),
    [anon_sym_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DQUOTE] = ACTIONS(111),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(115),
    [sym_bool] = ACTIONS(117),
    [sym_unit] = ACTIONS(1673),
    [anon_sym_LPAREN_PIPE] = ACTIONS(121),
    [sym_op_identifier] = ACTIONS(1675),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(837),
    [sym_xint] = ACTIONS(387),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(135),
  },
  [602] = {
    [sym_function_or_value_defn] = STATE(705),
    [sym__expression] = STATE(9),
    [sym_literal_expression] = STATE(867),
    [sym_long_identifier_or_op] = STATE(867),
    [sym_tuple_expression] = STATE(867),
    [sym_brace_expression] = STATE(867),
    [sym_anon_record_expression] = STATE(867),
    [sym_prefixed_expression] = STATE(867),
    [sym_typecast_expression] = STATE(867),
    [sym_for_expression] = STATE(867),
    [sym_while_expression] = STATE(867),
    [sym__if_branch] = STATE(6511),
    [sym_if_expression] = STATE(867),
    [sym_fun_expression] = STATE(867),
    [sym_try_expression] = STATE(867),
    [sym_match_expression] = STATE(867),
    [sym_function_expression] = STATE(867),
    [sym_mutate_expression] = STATE(867),
    [sym_index_expression] = STATE(867),
    [sym_typed_expression] = STATE(867),
    [sym_declaration_expression] = STATE(867),
    [sym_do_expression] = STATE(867),
    [sym_list_expression] = STATE(867),
    [sym_array_expression] = STATE(867),
    [sym_begin_end_expression] = STATE(867),
    [sym_paren_expression] = STATE(867),
    [sym__high_prec_app] = STATE(864),
    [sym__low_prec_app] = STATE(864),
    [sym_application_expression] = STATE(867),
    [sym_dot_expression] = STATE(867),
    [sym_infix_expression] = STATE(867),
    [sym_ce_expression] = STATE(867),
    [sym_sequential_expression] = STATE(867),
    [sym_char] = STATE(868),
    [sym_format_string] = STATE(869),
    [sym__string_literal] = STATE(869),
    [sym_string] = STATE(868),
    [sym_verbatim_string] = STATE(868),
    [sym_bytearray] = STATE(868),
    [sym_verbatim_bytearray] = STATE(868),
    [sym_format_triple_quoted_string] = STATE(870),
    [sym_triple_quoted_string] = STATE(868),
    [sym_const] = STATE(867),
    [sym_long_identifier] = STATE(872),
    [sym_active_pattern] = STATE(871),
    [sym__identifier_or_op] = STATE(873),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(658),
    [sym_sbyte] = STATE(868),
    [sym_byte] = STATE(868),
    [sym_int16] = STATE(868),
    [sym_uint16] = STATE(868),
    [sym_int32] = STATE(868),
    [sym_uint32] = STATE(868),
    [sym_nativeint] = STATE(868),
    [sym_unativeint] = STATE(868),
    [sym_int64] = STATE(868),
    [sym_uint64] = STATE(868),
    [sym_ieee32] = STATE(868),
    [sym_ieee64] = STATE(868),
    [sym_bignum] = STATE(868),
    [sym_decimal] = STATE(868),
    [sym_float] = STATE(860),
    [sym_block_comment] = STATE(602),
    [sym_compiler_directive_decl] = STATE(602),
    [sym_fsi_directive_decl] = STATE(602),
    [sym_preproc_line] = STATE(602),
    [sym_preproc_if_in_expression] = STATE(867),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(29),
    [anon_sym_return] = ACTIONS(37),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_null] = ACTIONS(49),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACK_PIPE] = ACTIONS(57),
    [anon_sym_LBRACE] = ACTIONS(1663),
    [anon_sym_LT_AT] = ACTIONS(61),
    [anon_sym_LT_AT_AT] = ACTIONS(1665),
    [anon_sym_LBRACE_PIPE] = ACTIONS(67),
    [anon_sym_new] = ACTIONS(37),
    [anon_sym_return_BANG] = ACTIONS(69),
    [anon_sym_yield] = ACTIONS(37),
    [anon_sym_yield_BANG] = ACTIONS(69),
    [anon_sym_lazy] = ACTIONS(37),
    [anon_sym_assert] = ACTIONS(37),
    [anon_sym_upcast] = ACTIONS(37),
    [anon_sym_downcast] = ACTIONS(37),
    [anon_sym_for] = ACTIONS(73),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(79),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_match] = ACTIONS(83),
    [anon_sym_match_BANG] = ACTIONS(85),
    [anon_sym_function] = ACTIONS(87),
    [anon_sym_use] = ACTIONS(95),
    [anon_sym_use_BANG] = ACTIONS(97),
    [anon_sym_do_BANG] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(101),
    [aux_sym_char_token1] = ACTIONS(105),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(107),
    [anon_sym_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DQUOTE] = ACTIONS(111),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(115),
    [sym_bool] = ACTIONS(117),
    [sym_unit] = ACTIONS(1673),
    [anon_sym_LPAREN_PIPE] = ACTIONS(121),
    [sym_op_identifier] = ACTIONS(1675),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(129),
    [sym_xint] = ACTIONS(131),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(135),
  },
  [603] = {
    [sym_function_or_value_defn] = STATE(600),
    [sym__expression] = STATE(241),
    [sym_literal_expression] = STATE(867),
    [sym_long_identifier_or_op] = STATE(867),
    [sym_tuple_expression] = STATE(867),
    [sym_brace_expression] = STATE(867),
    [sym_anon_record_expression] = STATE(867),
    [sym_prefixed_expression] = STATE(867),
    [sym_typecast_expression] = STATE(867),
    [sym_for_expression] = STATE(867),
    [sym_while_expression] = STATE(867),
    [sym__if_branch] = STATE(6511),
    [sym_if_expression] = STATE(867),
    [sym_fun_expression] = STATE(867),
    [sym_try_expression] = STATE(867),
    [sym_match_expression] = STATE(867),
    [sym_function_expression] = STATE(867),
    [sym_mutate_expression] = STATE(867),
    [sym_index_expression] = STATE(867),
    [sym_typed_expression] = STATE(867),
    [sym_declaration_expression] = STATE(867),
    [sym_do_expression] = STATE(867),
    [sym_list_expression] = STATE(867),
    [sym_array_expression] = STATE(867),
    [sym_begin_end_expression] = STATE(867),
    [sym_paren_expression] = STATE(867),
    [sym__high_prec_app] = STATE(864),
    [sym__low_prec_app] = STATE(864),
    [sym_application_expression] = STATE(867),
    [sym_dot_expression] = STATE(867),
    [sym_infix_expression] = STATE(867),
    [sym_ce_expression] = STATE(867),
    [sym_sequential_expression] = STATE(867),
    [sym_char] = STATE(868),
    [sym_format_string] = STATE(869),
    [sym__string_literal] = STATE(869),
    [sym_string] = STATE(868),
    [sym_verbatim_string] = STATE(868),
    [sym_bytearray] = STATE(868),
    [sym_verbatim_bytearray] = STATE(868),
    [sym_format_triple_quoted_string] = STATE(870),
    [sym_triple_quoted_string] = STATE(868),
    [sym_const] = STATE(867),
    [sym_long_identifier] = STATE(872),
    [sym_active_pattern] = STATE(871),
    [sym__identifier_or_op] = STATE(873),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(656),
    [sym_sbyte] = STATE(868),
    [sym_byte] = STATE(868),
    [sym_int16] = STATE(868),
    [sym_uint16] = STATE(868),
    [sym_int32] = STATE(868),
    [sym_uint32] = STATE(868),
    [sym_nativeint] = STATE(868),
    [sym_unativeint] = STATE(868),
    [sym_int64] = STATE(868),
    [sym_uint64] = STATE(868),
    [sym_ieee32] = STATE(868),
    [sym_ieee64] = STATE(868),
    [sym_bignum] = STATE(868),
    [sym_decimal] = STATE(868),
    [sym_float] = STATE(1368),
    [sym_block_comment] = STATE(603),
    [sym_compiler_directive_decl] = STATE(603),
    [sym_fsi_directive_decl] = STATE(603),
    [sym_preproc_line] = STATE(603),
    [sym_preproc_if_in_expression] = STATE(867),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(29),
    [anon_sym_return] = ACTIONS(825),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_null] = ACTIONS(49),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACK_PIPE] = ACTIONS(57),
    [anon_sym_LBRACE] = ACTIONS(1663),
    [anon_sym_LT_AT] = ACTIONS(61),
    [anon_sym_LT_AT_AT] = ACTIONS(1665),
    [anon_sym_LBRACE_PIPE] = ACTIONS(67),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_return_BANG] = ACTIONS(829),
    [anon_sym_yield] = ACTIONS(825),
    [anon_sym_yield_BANG] = ACTIONS(829),
    [anon_sym_lazy] = ACTIONS(825),
    [anon_sym_assert] = ACTIONS(825),
    [anon_sym_upcast] = ACTIONS(825),
    [anon_sym_downcast] = ACTIONS(825),
    [anon_sym_for] = ACTIONS(73),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(79),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_match] = ACTIONS(83),
    [anon_sym_match_BANG] = ACTIONS(85),
    [anon_sym_function] = ACTIONS(87),
    [anon_sym_use] = ACTIONS(833),
    [anon_sym_use_BANG] = ACTIONS(835),
    [anon_sym_do_BANG] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(101),
    [aux_sym_char_token1] = ACTIONS(105),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(107),
    [anon_sym_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DQUOTE] = ACTIONS(111),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(115),
    [sym_bool] = ACTIONS(117),
    [sym_unit] = ACTIONS(1673),
    [anon_sym_LPAREN_PIPE] = ACTIONS(121),
    [sym_op_identifier] = ACTIONS(1675),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(837),
    [sym_xint] = ACTIONS(387),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(135),
  },
  [604] = {
    [sym_function_or_value_defn] = STATE(630),
    [sym__expression] = STATE(232),
    [sym_literal_expression] = STATE(2380),
    [sym_long_identifier_or_op] = STATE(2380),
    [sym_tuple_expression] = STATE(2380),
    [sym_brace_expression] = STATE(2380),
    [sym_anon_record_expression] = STATE(2380),
    [sym_prefixed_expression] = STATE(2380),
    [sym_typecast_expression] = STATE(2380),
    [sym_for_expression] = STATE(2380),
    [sym_while_expression] = STATE(2380),
    [sym__if_branch] = STATE(6456),
    [sym_if_expression] = STATE(2380),
    [sym_fun_expression] = STATE(2380),
    [sym_try_expression] = STATE(2380),
    [sym_match_expression] = STATE(2380),
    [sym_function_expression] = STATE(2380),
    [sym_mutate_expression] = STATE(2380),
    [sym_index_expression] = STATE(2380),
    [sym_typed_expression] = STATE(2380),
    [sym_declaration_expression] = STATE(2380),
    [sym_do_expression] = STATE(2380),
    [sym_list_expression] = STATE(2380),
    [sym_array_expression] = STATE(2380),
    [sym_begin_end_expression] = STATE(2380),
    [sym_paren_expression] = STATE(2380),
    [sym__high_prec_app] = STATE(2383),
    [sym__low_prec_app] = STATE(2383),
    [sym_application_expression] = STATE(2380),
    [sym_dot_expression] = STATE(2380),
    [sym_infix_expression] = STATE(2380),
    [sym_ce_expression] = STATE(2380),
    [sym_sequential_expression] = STATE(2380),
    [sym_char] = STATE(2261),
    [sym_format_string] = STATE(2274),
    [sym__string_literal] = STATE(2274),
    [sym_string] = STATE(2261),
    [sym_verbatim_string] = STATE(2261),
    [sym_bytearray] = STATE(2261),
    [sym_verbatim_bytearray] = STATE(2261),
    [sym_format_triple_quoted_string] = STATE(2275),
    [sym_triple_quoted_string] = STATE(2261),
    [sym_const] = STATE(2380),
    [sym_long_identifier] = STATE(2391),
    [sym_active_pattern] = STATE(2470),
    [sym__identifier_or_op] = STATE(2390),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(632),
    [sym_sbyte] = STATE(2261),
    [sym_byte] = STATE(2261),
    [sym_int16] = STATE(2261),
    [sym_uint16] = STATE(2261),
    [sym_int32] = STATE(2261),
    [sym_uint32] = STATE(2261),
    [sym_nativeint] = STATE(2261),
    [sym_unativeint] = STATE(2261),
    [sym_int64] = STATE(2261),
    [sym_uint64] = STATE(2261),
    [sym_ieee32] = STATE(2261),
    [sym_ieee64] = STATE(2261),
    [sym_bignum] = STATE(2261),
    [sym_decimal] = STATE(2261),
    [sym_float] = STATE(1614),
    [sym_block_comment] = STATE(604),
    [sym_compiler_directive_decl] = STATE(604),
    [sym_fsi_directive_decl] = STATE(604),
    [sym_preproc_line] = STATE(604),
    [sym_preproc_if_in_expression] = STATE(2380),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(1081),
    [anon_sym_return] = ACTIONS(1085),
    [anon_sym_do] = ACTIONS(1087),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(1089),
    [anon_sym_null] = ACTIONS(1093),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1095),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1097),
    [anon_sym_LBRACE] = ACTIONS(2100),
    [anon_sym_LT_AT] = ACTIONS(1101),
    [anon_sym_LT_AT_AT] = ACTIONS(2102),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1107),
    [anon_sym_new] = ACTIONS(1085),
    [anon_sym_return_BANG] = ACTIONS(1109),
    [anon_sym_yield] = ACTIONS(1085),
    [anon_sym_yield_BANG] = ACTIONS(1109),
    [anon_sym_lazy] = ACTIONS(1085),
    [anon_sym_assert] = ACTIONS(1085),
    [anon_sym_upcast] = ACTIONS(1085),
    [anon_sym_downcast] = ACTIONS(1085),
    [anon_sym_for] = ACTIONS(1113),
    [anon_sym_while] = ACTIONS(1115),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(1117),
    [anon_sym_try] = ACTIONS(1119),
    [anon_sym_match] = ACTIONS(1121),
    [anon_sym_match_BANG] = ACTIONS(1123),
    [anon_sym_function] = ACTIONS(1125),
    [anon_sym_use] = ACTIONS(1133),
    [anon_sym_use_BANG] = ACTIONS(1135),
    [anon_sym_do_BANG] = ACTIONS(1137),
    [anon_sym_begin] = ACTIONS(1139),
    [aux_sym_char_token1] = ACTIONS(1143),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1145),
    [anon_sym_DQUOTE] = ACTIONS(1147),
    [anon_sym_AT_DQUOTE] = ACTIONS(1149),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1151),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1153),
    [sym_bool] = ACTIONS(1155),
    [sym_unit] = ACTIONS(2104),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1159),
    [sym_op_identifier] = ACTIONS(2106),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(1163),
    [sym_xint] = ACTIONS(1165),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1167),
  },
  [605] = {
    [sym_function_or_value_defn] = STATE(627),
    [sym__expression] = STATE(330),
    [sym_literal_expression] = STATE(1118),
    [sym_long_identifier_or_op] = STATE(1118),
    [sym_tuple_expression] = STATE(1118),
    [sym_brace_expression] = STATE(1118),
    [sym_anon_record_expression] = STATE(1118),
    [sym_prefixed_expression] = STATE(1118),
    [sym_typecast_expression] = STATE(1118),
    [sym_for_expression] = STATE(1118),
    [sym_while_expression] = STATE(1118),
    [sym__if_branch] = STATE(7163),
    [sym_if_expression] = STATE(1118),
    [sym_fun_expression] = STATE(1118),
    [sym_try_expression] = STATE(1118),
    [sym_match_expression] = STATE(1118),
    [sym_function_expression] = STATE(1118),
    [sym_mutate_expression] = STATE(1118),
    [sym_index_expression] = STATE(1118),
    [sym_typed_expression] = STATE(1118),
    [sym_declaration_expression] = STATE(1118),
    [sym_do_expression] = STATE(1118),
    [sym_list_expression] = STATE(1118),
    [sym_array_expression] = STATE(1118),
    [sym_begin_end_expression] = STATE(1118),
    [sym_paren_expression] = STATE(1118),
    [sym__high_prec_app] = STATE(1133),
    [sym__low_prec_app] = STATE(1133),
    [sym_application_expression] = STATE(1118),
    [sym_dot_expression] = STATE(1118),
    [sym_infix_expression] = STATE(1118),
    [sym_ce_expression] = STATE(1118),
    [sym_sequential_expression] = STATE(1118),
    [sym_char] = STATE(1080),
    [sym_format_string] = STATE(1090),
    [sym__string_literal] = STATE(1090),
    [sym_string] = STATE(1080),
    [sym_verbatim_string] = STATE(1080),
    [sym_bytearray] = STATE(1080),
    [sym_verbatim_bytearray] = STATE(1080),
    [sym_format_triple_quoted_string] = STATE(1096),
    [sym_triple_quoted_string] = STATE(1080),
    [sym_const] = STATE(1118),
    [sym_long_identifier] = STATE(1156),
    [sym_active_pattern] = STATE(1085),
    [sym__identifier_or_op] = STATE(1099),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(517),
    [sym_sbyte] = STATE(1080),
    [sym_byte] = STATE(1080),
    [sym_int16] = STATE(1080),
    [sym_uint16] = STATE(1080),
    [sym_int32] = STATE(1080),
    [sym_uint32] = STATE(1080),
    [sym_nativeint] = STATE(1080),
    [sym_unativeint] = STATE(1080),
    [sym_int64] = STATE(1080),
    [sym_uint64] = STATE(1080),
    [sym_ieee32] = STATE(1080),
    [sym_ieee64] = STATE(1080),
    [sym_bignum] = STATE(1080),
    [sym_decimal] = STATE(1080),
    [sym_float] = STATE(979),
    [sym_block_comment] = STATE(605),
    [sym_compiler_directive_decl] = STATE(605),
    [sym_fsi_directive_decl] = STATE(605),
    [sym_preproc_line] = STATE(605),
    [sym_preproc_if_in_expression] = STATE(1118),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(195),
    [anon_sym_return] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_null] = ACTIONS(207),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(209),
    [anon_sym_LBRACK_PIPE] = ACTIONS(211),
    [anon_sym_LBRACE] = ACTIONS(1687),
    [anon_sym_LT_AT] = ACTIONS(213),
    [anon_sym_LT_AT_AT] = ACTIONS(1689),
    [anon_sym_LBRACE_PIPE] = ACTIONS(217),
    [anon_sym_new] = ACTIONS(199),
    [anon_sym_return_BANG] = ACTIONS(219),
    [anon_sym_yield] = ACTIONS(199),
    [anon_sym_yield_BANG] = ACTIONS(219),
    [anon_sym_lazy] = ACTIONS(199),
    [anon_sym_assert] = ACTIONS(199),
    [anon_sym_upcast] = ACTIONS(199),
    [anon_sym_downcast] = ACTIONS(199),
    [anon_sym_for] = ACTIONS(223),
    [anon_sym_while] = ACTIONS(225),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(229),
    [anon_sym_match] = ACTIONS(231),
    [anon_sym_match_BANG] = ACTIONS(233),
    [anon_sym_function] = ACTIONS(235),
    [anon_sym_use] = ACTIONS(239),
    [anon_sym_use_BANG] = ACTIONS(241),
    [anon_sym_do_BANG] = ACTIONS(243),
    [anon_sym_begin] = ACTIONS(245),
    [aux_sym_char_token1] = ACTIONS(247),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(251),
    [anon_sym_AT_DQUOTE] = ACTIONS(253),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(255),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(257),
    [sym_bool] = ACTIONS(259),
    [sym_unit] = ACTIONS(1699),
    [anon_sym_LPAREN_PIPE] = ACTIONS(261),
    [sym_op_identifier] = ACTIONS(1701),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(265),
    [sym_xint] = ACTIONS(267),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(269),
  },
  [606] = {
    [sym_function_or_value_defn] = STATE(596),
    [sym__expression] = STATE(114),
    [sym_literal_expression] = STATE(1809),
    [sym_long_identifier_or_op] = STATE(1809),
    [sym_tuple_expression] = STATE(1809),
    [sym_brace_expression] = STATE(1809),
    [sym_anon_record_expression] = STATE(1809),
    [sym_prefixed_expression] = STATE(1809),
    [sym_typecast_expression] = STATE(1809),
    [sym_for_expression] = STATE(1809),
    [sym_while_expression] = STATE(1809),
    [sym__if_branch] = STATE(6874),
    [sym_if_expression] = STATE(1809),
    [sym_fun_expression] = STATE(1809),
    [sym_try_expression] = STATE(1809),
    [sym_match_expression] = STATE(1809),
    [sym_function_expression] = STATE(1809),
    [sym_mutate_expression] = STATE(1809),
    [sym_index_expression] = STATE(1809),
    [sym_typed_expression] = STATE(1809),
    [sym_declaration_expression] = STATE(1809),
    [sym_do_expression] = STATE(1809),
    [sym_list_expression] = STATE(1809),
    [sym_array_expression] = STATE(1809),
    [sym_begin_end_expression] = STATE(1809),
    [sym_paren_expression] = STATE(1809),
    [sym__high_prec_app] = STATE(1806),
    [sym__low_prec_app] = STATE(1806),
    [sym_application_expression] = STATE(1809),
    [sym_dot_expression] = STATE(1809),
    [sym_infix_expression] = STATE(1809),
    [sym_ce_expression] = STATE(1809),
    [sym_sequential_expression] = STATE(1809),
    [sym_char] = STATE(2014),
    [sym_format_string] = STATE(2019),
    [sym__string_literal] = STATE(2019),
    [sym_string] = STATE(2014),
    [sym_verbatim_string] = STATE(2014),
    [sym_bytearray] = STATE(2014),
    [sym_verbatim_bytearray] = STATE(2014),
    [sym_format_triple_quoted_string] = STATE(2020),
    [sym_triple_quoted_string] = STATE(2014),
    [sym_const] = STATE(1809),
    [sym_long_identifier] = STATE(1810),
    [sym_active_pattern] = STATE(1860),
    [sym__identifier_or_op] = STATE(1750),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(655),
    [sym_sbyte] = STATE(2014),
    [sym_byte] = STATE(2014),
    [sym_int16] = STATE(2014),
    [sym_uint16] = STATE(2014),
    [sym_int32] = STATE(2014),
    [sym_uint32] = STATE(2014),
    [sym_nativeint] = STATE(2014),
    [sym_unativeint] = STATE(2014),
    [sym_int64] = STATE(2014),
    [sym_uint64] = STATE(2014),
    [sym_ieee32] = STATE(2014),
    [sym_ieee64] = STATE(2014),
    [sym_bignum] = STATE(2014),
    [sym_decimal] = STATE(2014),
    [sym_float] = STATE(1438),
    [sym_block_comment] = STATE(606),
    [sym_compiler_directive_decl] = STATE(606),
    [sym_fsi_directive_decl] = STATE(606),
    [sym_preproc_line] = STATE(606),
    [sym_preproc_if_in_expression] = STATE(1809),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(723),
    [anon_sym_return] = ACTIONS(727),
    [anon_sym_do] = ACTIONS(729),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(731),
    [anon_sym_null] = ACTIONS(735),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(737),
    [anon_sym_LBRACK_PIPE] = ACTIONS(739),
    [anon_sym_LBRACE] = ACTIONS(2112),
    [anon_sym_LT_AT] = ACTIONS(743),
    [anon_sym_LT_AT_AT] = ACTIONS(2114),
    [anon_sym_LBRACE_PIPE] = ACTIONS(749),
    [anon_sym_new] = ACTIONS(727),
    [anon_sym_return_BANG] = ACTIONS(751),
    [anon_sym_yield] = ACTIONS(727),
    [anon_sym_yield_BANG] = ACTIONS(751),
    [anon_sym_lazy] = ACTIONS(727),
    [anon_sym_assert] = ACTIONS(727),
    [anon_sym_upcast] = ACTIONS(727),
    [anon_sym_downcast] = ACTIONS(727),
    [anon_sym_for] = ACTIONS(755),
    [anon_sym_while] = ACTIONS(757),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(759),
    [anon_sym_try] = ACTIONS(761),
    [anon_sym_match] = ACTIONS(763),
    [anon_sym_match_BANG] = ACTIONS(765),
    [anon_sym_function] = ACTIONS(767),
    [anon_sym_use] = ACTIONS(775),
    [anon_sym_use_BANG] = ACTIONS(777),
    [anon_sym_do_BANG] = ACTIONS(779),
    [anon_sym_begin] = ACTIONS(781),
    [aux_sym_char_token1] = ACTIONS(785),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(787),
    [anon_sym_DQUOTE] = ACTIONS(789),
    [anon_sym_AT_DQUOTE] = ACTIONS(791),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(793),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(795),
    [sym_bool] = ACTIONS(797),
    [sym_unit] = ACTIONS(2116),
    [anon_sym_LPAREN_PIPE] = ACTIONS(801),
    [sym_op_identifier] = ACTIONS(2118),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(805),
    [sym_xint] = ACTIONS(807),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(809),
  },
  [607] = {
    [sym_function_or_value_defn] = STATE(600),
    [sym__expression] = STATE(242),
    [sym_literal_expression] = STATE(867),
    [sym_long_identifier_or_op] = STATE(867),
    [sym_tuple_expression] = STATE(867),
    [sym_brace_expression] = STATE(867),
    [sym_anon_record_expression] = STATE(867),
    [sym_prefixed_expression] = STATE(867),
    [sym_typecast_expression] = STATE(867),
    [sym_for_expression] = STATE(867),
    [sym_while_expression] = STATE(867),
    [sym__if_branch] = STATE(6511),
    [sym_if_expression] = STATE(867),
    [sym_fun_expression] = STATE(867),
    [sym_try_expression] = STATE(867),
    [sym_match_expression] = STATE(867),
    [sym_function_expression] = STATE(867),
    [sym_mutate_expression] = STATE(867),
    [sym_index_expression] = STATE(867),
    [sym_typed_expression] = STATE(867),
    [sym_declaration_expression] = STATE(867),
    [sym_do_expression] = STATE(867),
    [sym_list_expression] = STATE(867),
    [sym_array_expression] = STATE(867),
    [sym_begin_end_expression] = STATE(867),
    [sym_paren_expression] = STATE(867),
    [sym__high_prec_app] = STATE(864),
    [sym__low_prec_app] = STATE(864),
    [sym_application_expression] = STATE(867),
    [sym_dot_expression] = STATE(867),
    [sym_infix_expression] = STATE(867),
    [sym_ce_expression] = STATE(867),
    [sym_sequential_expression] = STATE(867),
    [sym_char] = STATE(868),
    [sym_format_string] = STATE(869),
    [sym__string_literal] = STATE(869),
    [sym_string] = STATE(868),
    [sym_verbatim_string] = STATE(868),
    [sym_bytearray] = STATE(868),
    [sym_verbatim_bytearray] = STATE(868),
    [sym_format_triple_quoted_string] = STATE(870),
    [sym_triple_quoted_string] = STATE(868),
    [sym_const] = STATE(867),
    [sym_long_identifier] = STATE(872),
    [sym_active_pattern] = STATE(871),
    [sym__identifier_or_op] = STATE(873),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(656),
    [sym_sbyte] = STATE(868),
    [sym_byte] = STATE(868),
    [sym_int16] = STATE(868),
    [sym_uint16] = STATE(868),
    [sym_int32] = STATE(868),
    [sym_uint32] = STATE(868),
    [sym_nativeint] = STATE(868),
    [sym_unativeint] = STATE(868),
    [sym_int64] = STATE(868),
    [sym_uint64] = STATE(868),
    [sym_ieee32] = STATE(868),
    [sym_ieee64] = STATE(868),
    [sym_bignum] = STATE(868),
    [sym_decimal] = STATE(868),
    [sym_float] = STATE(1368),
    [sym_block_comment] = STATE(607),
    [sym_compiler_directive_decl] = STATE(607),
    [sym_fsi_directive_decl] = STATE(607),
    [sym_preproc_line] = STATE(607),
    [sym_preproc_if_in_expression] = STATE(867),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(29),
    [anon_sym_return] = ACTIONS(825),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_null] = ACTIONS(49),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACK_PIPE] = ACTIONS(57),
    [anon_sym_LBRACE] = ACTIONS(1663),
    [anon_sym_LT_AT] = ACTIONS(61),
    [anon_sym_LT_AT_AT] = ACTIONS(1665),
    [anon_sym_LBRACE_PIPE] = ACTIONS(67),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_return_BANG] = ACTIONS(829),
    [anon_sym_yield] = ACTIONS(825),
    [anon_sym_yield_BANG] = ACTIONS(829),
    [anon_sym_lazy] = ACTIONS(825),
    [anon_sym_assert] = ACTIONS(825),
    [anon_sym_upcast] = ACTIONS(825),
    [anon_sym_downcast] = ACTIONS(825),
    [anon_sym_for] = ACTIONS(73),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(79),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_match] = ACTIONS(83),
    [anon_sym_match_BANG] = ACTIONS(85),
    [anon_sym_function] = ACTIONS(87),
    [anon_sym_use] = ACTIONS(833),
    [anon_sym_use_BANG] = ACTIONS(835),
    [anon_sym_do_BANG] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(101),
    [aux_sym_char_token1] = ACTIONS(105),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(107),
    [anon_sym_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DQUOTE] = ACTIONS(111),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(115),
    [sym_bool] = ACTIONS(117),
    [sym_unit] = ACTIONS(1673),
    [anon_sym_LPAREN_PIPE] = ACTIONS(121),
    [sym_op_identifier] = ACTIONS(1675),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(837),
    [sym_xint] = ACTIONS(387),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(135),
  },
  [608] = {
    [sym_function_or_value_defn] = STATE(596),
    [sym__expression] = STATE(121),
    [sym_literal_expression] = STATE(1809),
    [sym_long_identifier_or_op] = STATE(1809),
    [sym_tuple_expression] = STATE(1809),
    [sym_brace_expression] = STATE(1809),
    [sym_anon_record_expression] = STATE(1809),
    [sym_prefixed_expression] = STATE(1809),
    [sym_typecast_expression] = STATE(1809),
    [sym_for_expression] = STATE(1809),
    [sym_while_expression] = STATE(1809),
    [sym__if_branch] = STATE(6874),
    [sym_if_expression] = STATE(1809),
    [sym_fun_expression] = STATE(1809),
    [sym_try_expression] = STATE(1809),
    [sym_match_expression] = STATE(1809),
    [sym_function_expression] = STATE(1809),
    [sym_mutate_expression] = STATE(1809),
    [sym_index_expression] = STATE(1809),
    [sym_typed_expression] = STATE(1809),
    [sym_declaration_expression] = STATE(1809),
    [sym_do_expression] = STATE(1809),
    [sym_list_expression] = STATE(1809),
    [sym_array_expression] = STATE(1809),
    [sym_begin_end_expression] = STATE(1809),
    [sym_paren_expression] = STATE(1809),
    [sym__high_prec_app] = STATE(1806),
    [sym__low_prec_app] = STATE(1806),
    [sym_application_expression] = STATE(1809),
    [sym_dot_expression] = STATE(1809),
    [sym_infix_expression] = STATE(1809),
    [sym_ce_expression] = STATE(1809),
    [sym_sequential_expression] = STATE(1809),
    [sym_char] = STATE(2014),
    [sym_format_string] = STATE(2019),
    [sym__string_literal] = STATE(2019),
    [sym_string] = STATE(2014),
    [sym_verbatim_string] = STATE(2014),
    [sym_bytearray] = STATE(2014),
    [sym_verbatim_bytearray] = STATE(2014),
    [sym_format_triple_quoted_string] = STATE(2020),
    [sym_triple_quoted_string] = STATE(2014),
    [sym_const] = STATE(1809),
    [sym_long_identifier] = STATE(1810),
    [sym_active_pattern] = STATE(1860),
    [sym__identifier_or_op] = STATE(1750),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(655),
    [sym_sbyte] = STATE(2014),
    [sym_byte] = STATE(2014),
    [sym_int16] = STATE(2014),
    [sym_uint16] = STATE(2014),
    [sym_int32] = STATE(2014),
    [sym_uint32] = STATE(2014),
    [sym_nativeint] = STATE(2014),
    [sym_unativeint] = STATE(2014),
    [sym_int64] = STATE(2014),
    [sym_uint64] = STATE(2014),
    [sym_ieee32] = STATE(2014),
    [sym_ieee64] = STATE(2014),
    [sym_bignum] = STATE(2014),
    [sym_decimal] = STATE(2014),
    [sym_float] = STATE(1438),
    [sym_block_comment] = STATE(608),
    [sym_compiler_directive_decl] = STATE(608),
    [sym_fsi_directive_decl] = STATE(608),
    [sym_preproc_line] = STATE(608),
    [sym_preproc_if_in_expression] = STATE(1809),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(723),
    [anon_sym_return] = ACTIONS(727),
    [anon_sym_do] = ACTIONS(729),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(731),
    [anon_sym_null] = ACTIONS(735),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(737),
    [anon_sym_LBRACK_PIPE] = ACTIONS(739),
    [anon_sym_LBRACE] = ACTIONS(2112),
    [anon_sym_LT_AT] = ACTIONS(743),
    [anon_sym_LT_AT_AT] = ACTIONS(2114),
    [anon_sym_LBRACE_PIPE] = ACTIONS(749),
    [anon_sym_new] = ACTIONS(727),
    [anon_sym_return_BANG] = ACTIONS(751),
    [anon_sym_yield] = ACTIONS(727),
    [anon_sym_yield_BANG] = ACTIONS(751),
    [anon_sym_lazy] = ACTIONS(727),
    [anon_sym_assert] = ACTIONS(727),
    [anon_sym_upcast] = ACTIONS(727),
    [anon_sym_downcast] = ACTIONS(727),
    [anon_sym_for] = ACTIONS(755),
    [anon_sym_while] = ACTIONS(757),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(759),
    [anon_sym_try] = ACTIONS(761),
    [anon_sym_match] = ACTIONS(763),
    [anon_sym_match_BANG] = ACTIONS(765),
    [anon_sym_function] = ACTIONS(767),
    [anon_sym_use] = ACTIONS(775),
    [anon_sym_use_BANG] = ACTIONS(777),
    [anon_sym_do_BANG] = ACTIONS(779),
    [anon_sym_begin] = ACTIONS(781),
    [aux_sym_char_token1] = ACTIONS(785),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(787),
    [anon_sym_DQUOTE] = ACTIONS(789),
    [anon_sym_AT_DQUOTE] = ACTIONS(791),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(793),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(795),
    [sym_bool] = ACTIONS(797),
    [sym_unit] = ACTIONS(2116),
    [anon_sym_LPAREN_PIPE] = ACTIONS(801),
    [sym_op_identifier] = ACTIONS(2118),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(805),
    [sym_xint] = ACTIONS(807),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(809),
  },
  [609] = {
    [sym_function_or_value_defn] = STATE(600),
    [sym__expression] = STATE(243),
    [sym_literal_expression] = STATE(867),
    [sym_long_identifier_or_op] = STATE(867),
    [sym_tuple_expression] = STATE(867),
    [sym_brace_expression] = STATE(867),
    [sym_anon_record_expression] = STATE(867),
    [sym_prefixed_expression] = STATE(867),
    [sym_typecast_expression] = STATE(867),
    [sym_for_expression] = STATE(867),
    [sym_while_expression] = STATE(867),
    [sym__if_branch] = STATE(6511),
    [sym_if_expression] = STATE(867),
    [sym_fun_expression] = STATE(867),
    [sym_try_expression] = STATE(867),
    [sym_match_expression] = STATE(867),
    [sym_function_expression] = STATE(867),
    [sym_mutate_expression] = STATE(867),
    [sym_index_expression] = STATE(867),
    [sym_typed_expression] = STATE(867),
    [sym_declaration_expression] = STATE(867),
    [sym_do_expression] = STATE(867),
    [sym_list_expression] = STATE(867),
    [sym_array_expression] = STATE(867),
    [sym_begin_end_expression] = STATE(867),
    [sym_paren_expression] = STATE(867),
    [sym__high_prec_app] = STATE(864),
    [sym__low_prec_app] = STATE(864),
    [sym_application_expression] = STATE(867),
    [sym_dot_expression] = STATE(867),
    [sym_infix_expression] = STATE(867),
    [sym_ce_expression] = STATE(867),
    [sym_sequential_expression] = STATE(867),
    [sym_char] = STATE(868),
    [sym_format_string] = STATE(869),
    [sym__string_literal] = STATE(869),
    [sym_string] = STATE(868),
    [sym_verbatim_string] = STATE(868),
    [sym_bytearray] = STATE(868),
    [sym_verbatim_bytearray] = STATE(868),
    [sym_format_triple_quoted_string] = STATE(870),
    [sym_triple_quoted_string] = STATE(868),
    [sym_const] = STATE(867),
    [sym_long_identifier] = STATE(872),
    [sym_active_pattern] = STATE(871),
    [sym__identifier_or_op] = STATE(873),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(656),
    [sym_sbyte] = STATE(868),
    [sym_byte] = STATE(868),
    [sym_int16] = STATE(868),
    [sym_uint16] = STATE(868),
    [sym_int32] = STATE(868),
    [sym_uint32] = STATE(868),
    [sym_nativeint] = STATE(868),
    [sym_unativeint] = STATE(868),
    [sym_int64] = STATE(868),
    [sym_uint64] = STATE(868),
    [sym_ieee32] = STATE(868),
    [sym_ieee64] = STATE(868),
    [sym_bignum] = STATE(868),
    [sym_decimal] = STATE(868),
    [sym_float] = STATE(1368),
    [sym_block_comment] = STATE(609),
    [sym_compiler_directive_decl] = STATE(609),
    [sym_fsi_directive_decl] = STATE(609),
    [sym_preproc_line] = STATE(609),
    [sym_preproc_if_in_expression] = STATE(867),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(29),
    [anon_sym_return] = ACTIONS(825),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_null] = ACTIONS(49),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACK_PIPE] = ACTIONS(57),
    [anon_sym_LBRACE] = ACTIONS(1663),
    [anon_sym_LT_AT] = ACTIONS(61),
    [anon_sym_LT_AT_AT] = ACTIONS(1665),
    [anon_sym_LBRACE_PIPE] = ACTIONS(67),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_return_BANG] = ACTIONS(829),
    [anon_sym_yield] = ACTIONS(825),
    [anon_sym_yield_BANG] = ACTIONS(829),
    [anon_sym_lazy] = ACTIONS(825),
    [anon_sym_assert] = ACTIONS(825),
    [anon_sym_upcast] = ACTIONS(825),
    [anon_sym_downcast] = ACTIONS(825),
    [anon_sym_for] = ACTIONS(73),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(79),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_match] = ACTIONS(83),
    [anon_sym_match_BANG] = ACTIONS(85),
    [anon_sym_function] = ACTIONS(87),
    [anon_sym_use] = ACTIONS(833),
    [anon_sym_use_BANG] = ACTIONS(835),
    [anon_sym_do_BANG] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(101),
    [aux_sym_char_token1] = ACTIONS(105),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(107),
    [anon_sym_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DQUOTE] = ACTIONS(111),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(115),
    [sym_bool] = ACTIONS(117),
    [sym_unit] = ACTIONS(1673),
    [anon_sym_LPAREN_PIPE] = ACTIONS(121),
    [sym_op_identifier] = ACTIONS(1675),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(837),
    [sym_xint] = ACTIONS(387),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(135),
  },
  [610] = {
    [sym_function_or_value_defn] = STATE(600),
    [sym__expression] = STATE(300),
    [sym_literal_expression] = STATE(867),
    [sym_long_identifier_or_op] = STATE(867),
    [sym_tuple_expression] = STATE(867),
    [sym_brace_expression] = STATE(867),
    [sym_anon_record_expression] = STATE(867),
    [sym_prefixed_expression] = STATE(867),
    [sym_typecast_expression] = STATE(867),
    [sym_for_expression] = STATE(867),
    [sym_while_expression] = STATE(867),
    [sym__if_branch] = STATE(6511),
    [sym_if_expression] = STATE(867),
    [sym_fun_expression] = STATE(867),
    [sym_try_expression] = STATE(867),
    [sym_match_expression] = STATE(867),
    [sym_function_expression] = STATE(867),
    [sym_mutate_expression] = STATE(867),
    [sym_index_expression] = STATE(867),
    [sym_typed_expression] = STATE(867),
    [sym_declaration_expression] = STATE(867),
    [sym_do_expression] = STATE(867),
    [sym_list_expression] = STATE(867),
    [sym_array_expression] = STATE(867),
    [sym_begin_end_expression] = STATE(867),
    [sym_paren_expression] = STATE(867),
    [sym__high_prec_app] = STATE(864),
    [sym__low_prec_app] = STATE(864),
    [sym_application_expression] = STATE(867),
    [sym_dot_expression] = STATE(867),
    [sym_infix_expression] = STATE(867),
    [sym_ce_expression] = STATE(867),
    [sym_sequential_expression] = STATE(867),
    [sym_char] = STATE(868),
    [sym_format_string] = STATE(869),
    [sym__string_literal] = STATE(869),
    [sym_string] = STATE(868),
    [sym_verbatim_string] = STATE(868),
    [sym_bytearray] = STATE(868),
    [sym_verbatim_bytearray] = STATE(868),
    [sym_format_triple_quoted_string] = STATE(870),
    [sym_triple_quoted_string] = STATE(868),
    [sym_const] = STATE(867),
    [sym_long_identifier] = STATE(872),
    [sym_active_pattern] = STATE(871),
    [sym__identifier_or_op] = STATE(873),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(656),
    [sym_sbyte] = STATE(868),
    [sym_byte] = STATE(868),
    [sym_int16] = STATE(868),
    [sym_uint16] = STATE(868),
    [sym_int32] = STATE(868),
    [sym_uint32] = STATE(868),
    [sym_nativeint] = STATE(868),
    [sym_unativeint] = STATE(868),
    [sym_int64] = STATE(868),
    [sym_uint64] = STATE(868),
    [sym_ieee32] = STATE(868),
    [sym_ieee64] = STATE(868),
    [sym_bignum] = STATE(868),
    [sym_decimal] = STATE(868),
    [sym_float] = STATE(1368),
    [sym_block_comment] = STATE(610),
    [sym_compiler_directive_decl] = STATE(610),
    [sym_fsi_directive_decl] = STATE(610),
    [sym_preproc_line] = STATE(610),
    [sym_preproc_if_in_expression] = STATE(867),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(29),
    [anon_sym_return] = ACTIONS(825),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_null] = ACTIONS(49),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACK_PIPE] = ACTIONS(57),
    [anon_sym_LBRACE] = ACTIONS(1663),
    [anon_sym_LT_AT] = ACTIONS(61),
    [anon_sym_LT_AT_AT] = ACTIONS(1665),
    [anon_sym_LBRACE_PIPE] = ACTIONS(67),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_return_BANG] = ACTIONS(829),
    [anon_sym_yield] = ACTIONS(825),
    [anon_sym_yield_BANG] = ACTIONS(829),
    [anon_sym_lazy] = ACTIONS(825),
    [anon_sym_assert] = ACTIONS(825),
    [anon_sym_upcast] = ACTIONS(825),
    [anon_sym_downcast] = ACTIONS(825),
    [anon_sym_for] = ACTIONS(73),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(79),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_match] = ACTIONS(83),
    [anon_sym_match_BANG] = ACTIONS(85),
    [anon_sym_function] = ACTIONS(87),
    [anon_sym_use] = ACTIONS(833),
    [anon_sym_use_BANG] = ACTIONS(835),
    [anon_sym_do_BANG] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(101),
    [aux_sym_char_token1] = ACTIONS(105),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(107),
    [anon_sym_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DQUOTE] = ACTIONS(111),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(115),
    [sym_bool] = ACTIONS(117),
    [sym_unit] = ACTIONS(1673),
    [anon_sym_LPAREN_PIPE] = ACTIONS(121),
    [sym_op_identifier] = ACTIONS(1675),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(837),
    [sym_xint] = ACTIONS(387),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(135),
  },
  [611] = {
    [sym_function_or_value_defn] = STATE(630),
    [sym__expression] = STATE(230),
    [sym_literal_expression] = STATE(2380),
    [sym_long_identifier_or_op] = STATE(2380),
    [sym_tuple_expression] = STATE(2380),
    [sym_brace_expression] = STATE(2380),
    [sym_anon_record_expression] = STATE(2380),
    [sym_prefixed_expression] = STATE(2380),
    [sym_typecast_expression] = STATE(2380),
    [sym_for_expression] = STATE(2380),
    [sym_while_expression] = STATE(2380),
    [sym__if_branch] = STATE(6456),
    [sym_if_expression] = STATE(2380),
    [sym_fun_expression] = STATE(2380),
    [sym_try_expression] = STATE(2380),
    [sym_match_expression] = STATE(2380),
    [sym_function_expression] = STATE(2380),
    [sym_mutate_expression] = STATE(2380),
    [sym_index_expression] = STATE(2380),
    [sym_typed_expression] = STATE(2380),
    [sym_declaration_expression] = STATE(2380),
    [sym_do_expression] = STATE(2380),
    [sym_list_expression] = STATE(2380),
    [sym_array_expression] = STATE(2380),
    [sym_begin_end_expression] = STATE(2380),
    [sym_paren_expression] = STATE(2380),
    [sym__high_prec_app] = STATE(2383),
    [sym__low_prec_app] = STATE(2383),
    [sym_application_expression] = STATE(2380),
    [sym_dot_expression] = STATE(2380),
    [sym_infix_expression] = STATE(2380),
    [sym_ce_expression] = STATE(2380),
    [sym_sequential_expression] = STATE(2380),
    [sym_char] = STATE(2261),
    [sym_format_string] = STATE(2274),
    [sym__string_literal] = STATE(2274),
    [sym_string] = STATE(2261),
    [sym_verbatim_string] = STATE(2261),
    [sym_bytearray] = STATE(2261),
    [sym_verbatim_bytearray] = STATE(2261),
    [sym_format_triple_quoted_string] = STATE(2275),
    [sym_triple_quoted_string] = STATE(2261),
    [sym_const] = STATE(2380),
    [sym_long_identifier] = STATE(2391),
    [sym_active_pattern] = STATE(2470),
    [sym__identifier_or_op] = STATE(2390),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(632),
    [sym_sbyte] = STATE(2261),
    [sym_byte] = STATE(2261),
    [sym_int16] = STATE(2261),
    [sym_uint16] = STATE(2261),
    [sym_int32] = STATE(2261),
    [sym_uint32] = STATE(2261),
    [sym_nativeint] = STATE(2261),
    [sym_unativeint] = STATE(2261),
    [sym_int64] = STATE(2261),
    [sym_uint64] = STATE(2261),
    [sym_ieee32] = STATE(2261),
    [sym_ieee64] = STATE(2261),
    [sym_bignum] = STATE(2261),
    [sym_decimal] = STATE(2261),
    [sym_float] = STATE(1614),
    [sym_block_comment] = STATE(611),
    [sym_compiler_directive_decl] = STATE(611),
    [sym_fsi_directive_decl] = STATE(611),
    [sym_preproc_line] = STATE(611),
    [sym_preproc_if_in_expression] = STATE(2380),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(1081),
    [anon_sym_return] = ACTIONS(1085),
    [anon_sym_do] = ACTIONS(1087),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(1089),
    [anon_sym_null] = ACTIONS(1093),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1095),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1097),
    [anon_sym_LBRACE] = ACTIONS(2100),
    [anon_sym_LT_AT] = ACTIONS(1101),
    [anon_sym_LT_AT_AT] = ACTIONS(2102),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1107),
    [anon_sym_new] = ACTIONS(1085),
    [anon_sym_return_BANG] = ACTIONS(1109),
    [anon_sym_yield] = ACTIONS(1085),
    [anon_sym_yield_BANG] = ACTIONS(1109),
    [anon_sym_lazy] = ACTIONS(1085),
    [anon_sym_assert] = ACTIONS(1085),
    [anon_sym_upcast] = ACTIONS(1085),
    [anon_sym_downcast] = ACTIONS(1085),
    [anon_sym_for] = ACTIONS(1113),
    [anon_sym_while] = ACTIONS(1115),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(1117),
    [anon_sym_try] = ACTIONS(1119),
    [anon_sym_match] = ACTIONS(1121),
    [anon_sym_match_BANG] = ACTIONS(1123),
    [anon_sym_function] = ACTIONS(1125),
    [anon_sym_use] = ACTIONS(1133),
    [anon_sym_use_BANG] = ACTIONS(1135),
    [anon_sym_do_BANG] = ACTIONS(1137),
    [anon_sym_begin] = ACTIONS(1139),
    [aux_sym_char_token1] = ACTIONS(1143),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1145),
    [anon_sym_DQUOTE] = ACTIONS(1147),
    [anon_sym_AT_DQUOTE] = ACTIONS(1149),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1151),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1153),
    [sym_bool] = ACTIONS(1155),
    [sym_unit] = ACTIONS(2104),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1159),
    [sym_op_identifier] = ACTIONS(2106),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(1163),
    [sym_xint] = ACTIONS(1165),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1167),
  },
  [612] = {
    [sym_function_or_value_defn] = STATE(733),
    [sym__expression] = STATE(294),
    [sym_literal_expression] = STATE(2008),
    [sym_long_identifier_or_op] = STATE(2008),
    [sym_tuple_expression] = STATE(2008),
    [sym_brace_expression] = STATE(2008),
    [sym_anon_record_expression] = STATE(2008),
    [sym_prefixed_expression] = STATE(2008),
    [sym_typecast_expression] = STATE(2008),
    [sym_for_expression] = STATE(2008),
    [sym_while_expression] = STATE(2008),
    [sym__if_branch] = STATE(6754),
    [sym_if_expression] = STATE(2008),
    [sym_fun_expression] = STATE(2008),
    [sym_try_expression] = STATE(2008),
    [sym_match_expression] = STATE(2008),
    [sym_function_expression] = STATE(2008),
    [sym_mutate_expression] = STATE(2008),
    [sym_index_expression] = STATE(2008),
    [sym_typed_expression] = STATE(2008),
    [sym_declaration_expression] = STATE(2008),
    [sym_do_expression] = STATE(2008),
    [sym_list_expression] = STATE(2008),
    [sym_array_expression] = STATE(2008),
    [sym_begin_end_expression] = STATE(2008),
    [sym_paren_expression] = STATE(2008),
    [sym__high_prec_app] = STATE(2007),
    [sym__low_prec_app] = STATE(2007),
    [sym_application_expression] = STATE(2008),
    [sym_dot_expression] = STATE(2008),
    [sym_infix_expression] = STATE(2008),
    [sym_ce_expression] = STATE(2008),
    [sym_sequential_expression] = STATE(2008),
    [sym_char] = STATE(1859),
    [sym_format_string] = STATE(1861),
    [sym__string_literal] = STATE(1861),
    [sym_string] = STATE(1859),
    [sym_verbatim_string] = STATE(1859),
    [sym_bytearray] = STATE(1859),
    [sym_verbatim_bytearray] = STATE(1859),
    [sym_format_triple_quoted_string] = STATE(1862),
    [sym_triple_quoted_string] = STATE(1859),
    [sym_const] = STATE(2008),
    [sym_long_identifier] = STATE(1701),
    [sym_active_pattern] = STATE(1702),
    [sym__identifier_or_op] = STATE(1724),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(706),
    [sym_sbyte] = STATE(1859),
    [sym_byte] = STATE(1859),
    [sym_int16] = STATE(1859),
    [sym_uint16] = STATE(1859),
    [sym_int32] = STATE(1859),
    [sym_uint32] = STATE(1859),
    [sym_nativeint] = STATE(1859),
    [sym_unativeint] = STATE(1859),
    [sym_int64] = STATE(1859),
    [sym_uint64] = STATE(1859),
    [sym_ieee32] = STATE(1859),
    [sym_ieee64] = STATE(1859),
    [sym_bignum] = STATE(1859),
    [sym_decimal] = STATE(1859),
    [sym_float] = STATE(1447),
    [sym_block_comment] = STATE(612),
    [sym_compiler_directive_decl] = STATE(612),
    [sym_fsi_directive_decl] = STATE(612),
    [sym_preproc_line] = STATE(612),
    [sym_preproc_if_in_expression] = STATE(2008),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(503),
    [anon_sym_return] = ACTIONS(971),
    [anon_sym_do] = ACTIONS(599),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(511),
    [anon_sym_null] = ACTIONS(515),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(517),
    [anon_sym_LBRACK_PIPE] = ACTIONS(519),
    [anon_sym_LBRACE] = ACTIONS(2060),
    [anon_sym_LT_AT] = ACTIONS(523),
    [anon_sym_LT_AT_AT] = ACTIONS(2062),
    [anon_sym_LBRACE_PIPE] = ACTIONS(529),
    [anon_sym_new] = ACTIONS(971),
    [anon_sym_return_BANG] = ACTIONS(975),
    [anon_sym_yield] = ACTIONS(971),
    [anon_sym_yield_BANG] = ACTIONS(975),
    [anon_sym_lazy] = ACTIONS(971),
    [anon_sym_assert] = ACTIONS(971),
    [anon_sym_upcast] = ACTIONS(971),
    [anon_sym_downcast] = ACTIONS(971),
    [anon_sym_for] = ACTIONS(979),
    [anon_sym_while] = ACTIONS(537),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(539),
    [anon_sym_try] = ACTIONS(543),
    [anon_sym_match] = ACTIONS(545),
    [anon_sym_match_BANG] = ACTIONS(547),
    [anon_sym_function] = ACTIONS(549),
    [anon_sym_use] = ACTIONS(983),
    [anon_sym_use_BANG] = ACTIONS(985),
    [anon_sym_do_BANG] = ACTIONS(561),
    [anon_sym_begin] = ACTIONS(565),
    [aux_sym_char_token1] = ACTIONS(569),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(571),
    [anon_sym_DQUOTE] = ACTIONS(573),
    [anon_sym_AT_DQUOTE] = ACTIONS(575),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(577),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(579),
    [sym_bool] = ACTIONS(581),
    [sym_unit] = ACTIONS(2064),
    [anon_sym_LPAREN_PIPE] = ACTIONS(585),
    [sym_op_identifier] = ACTIONS(2066),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(591),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(593),
  },
  [613] = {
    [sym_function_or_value_defn] = STATE(532),
    [sym__expression] = STATE(131),
    [sym_literal_expression] = STATE(2000),
    [sym_long_identifier_or_op] = STATE(2000),
    [sym_tuple_expression] = STATE(2000),
    [sym_brace_expression] = STATE(2000),
    [sym_anon_record_expression] = STATE(2000),
    [sym_prefixed_expression] = STATE(2000),
    [sym_typecast_expression] = STATE(2000),
    [sym_for_expression] = STATE(2000),
    [sym_while_expression] = STATE(2000),
    [sym__if_branch] = STATE(6707),
    [sym_if_expression] = STATE(2000),
    [sym_fun_expression] = STATE(2000),
    [sym_try_expression] = STATE(2000),
    [sym_match_expression] = STATE(2000),
    [sym_function_expression] = STATE(2000),
    [sym_mutate_expression] = STATE(2000),
    [sym_index_expression] = STATE(2000),
    [sym_typed_expression] = STATE(2000),
    [sym_declaration_expression] = STATE(2000),
    [sym_do_expression] = STATE(2000),
    [sym_list_expression] = STATE(2000),
    [sym_array_expression] = STATE(2000),
    [sym_begin_end_expression] = STATE(2000),
    [sym_paren_expression] = STATE(2000),
    [sym__high_prec_app] = STATE(2003),
    [sym__low_prec_app] = STATE(2003),
    [sym_application_expression] = STATE(2000),
    [sym_dot_expression] = STATE(2000),
    [sym_infix_expression] = STATE(2000),
    [sym_ce_expression] = STATE(2000),
    [sym_sequential_expression] = STATE(2000),
    [sym_char] = STATE(1801),
    [sym_format_string] = STATE(1804),
    [sym__string_literal] = STATE(1804),
    [sym_string] = STATE(1801),
    [sym_verbatim_string] = STATE(1801),
    [sym_bytearray] = STATE(1801),
    [sym_verbatim_bytearray] = STATE(1801),
    [sym_format_triple_quoted_string] = STATE(1807),
    [sym_triple_quoted_string] = STATE(1801),
    [sym_const] = STATE(2000),
    [sym_long_identifier] = STATE(1725),
    [sym_active_pattern] = STATE(1726),
    [sym__identifier_or_op] = STATE(1751),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(723),
    [sym_sbyte] = STATE(1801),
    [sym_byte] = STATE(1801),
    [sym_int16] = STATE(1801),
    [sym_uint16] = STATE(1801),
    [sym_int32] = STATE(1801),
    [sym_uint32] = STATE(1801),
    [sym_nativeint] = STATE(1801),
    [sym_unativeint] = STATE(1801),
    [sym_int64] = STATE(1801),
    [sym_uint64] = STATE(1801),
    [sym_ieee32] = STATE(1801),
    [sym_ieee64] = STATE(1801),
    [sym_bignum] = STATE(1801),
    [sym_decimal] = STATE(1801),
    [sym_float] = STATE(1427),
    [sym_block_comment] = STATE(613),
    [sym_compiler_directive_decl] = STATE(613),
    [sym_fsi_directive_decl] = STATE(613),
    [sym_preproc_line] = STATE(613),
    [sym_preproc_if_in_expression] = STATE(2000),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(629),
    [anon_sym_return] = ACTIONS(633),
    [anon_sym_do] = ACTIONS(635),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(637),
    [anon_sym_null] = ACTIONS(641),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(643),
    [anon_sym_LBRACK_PIPE] = ACTIONS(645),
    [anon_sym_LBRACE] = ACTIONS(1713),
    [anon_sym_LT_AT] = ACTIONS(647),
    [anon_sym_LT_AT_AT] = ACTIONS(1715),
    [anon_sym_LBRACE_PIPE] = ACTIONS(653),
    [anon_sym_new] = ACTIONS(633),
    [anon_sym_return_BANG] = ACTIONS(655),
    [anon_sym_yield] = ACTIONS(633),
    [anon_sym_yield_BANG] = ACTIONS(655),
    [anon_sym_lazy] = ACTIONS(633),
    [anon_sym_assert] = ACTIONS(633),
    [anon_sym_upcast] = ACTIONS(633),
    [anon_sym_downcast] = ACTIONS(633),
    [anon_sym_for] = ACTIONS(659),
    [anon_sym_while] = ACTIONS(661),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(663),
    [anon_sym_try] = ACTIONS(665),
    [anon_sym_match] = ACTIONS(667),
    [anon_sym_match_BANG] = ACTIONS(669),
    [anon_sym_function] = ACTIONS(671),
    [anon_sym_use] = ACTIONS(679),
    [anon_sym_use_BANG] = ACTIONS(681),
    [anon_sym_do_BANG] = ACTIONS(683),
    [anon_sym_begin] = ACTIONS(685),
    [aux_sym_char_token1] = ACTIONS(689),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(691),
    [anon_sym_DQUOTE] = ACTIONS(693),
    [anon_sym_AT_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(697),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(699),
    [sym_bool] = ACTIONS(701),
    [sym_unit] = ACTIONS(1717),
    [anon_sym_LPAREN_PIPE] = ACTIONS(705),
    [sym_op_identifier] = ACTIONS(1719),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(709),
    [sym_xint] = ACTIONS(711),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(713),
  },
  [614] = {
    [sym_function_or_value_defn] = STATE(600),
    [sym__expression] = STATE(325),
    [sym_literal_expression] = STATE(867),
    [sym_long_identifier_or_op] = STATE(867),
    [sym_tuple_expression] = STATE(867),
    [sym_brace_expression] = STATE(867),
    [sym_anon_record_expression] = STATE(867),
    [sym_prefixed_expression] = STATE(867),
    [sym_typecast_expression] = STATE(867),
    [sym_for_expression] = STATE(867),
    [sym_while_expression] = STATE(867),
    [sym__if_branch] = STATE(6511),
    [sym_if_expression] = STATE(867),
    [sym_fun_expression] = STATE(867),
    [sym_try_expression] = STATE(867),
    [sym_match_expression] = STATE(867),
    [sym_function_expression] = STATE(867),
    [sym_mutate_expression] = STATE(867),
    [sym_index_expression] = STATE(867),
    [sym_typed_expression] = STATE(867),
    [sym_declaration_expression] = STATE(867),
    [sym_do_expression] = STATE(867),
    [sym_list_expression] = STATE(867),
    [sym_array_expression] = STATE(867),
    [sym_begin_end_expression] = STATE(867),
    [sym_paren_expression] = STATE(867),
    [sym__high_prec_app] = STATE(864),
    [sym__low_prec_app] = STATE(864),
    [sym_application_expression] = STATE(867),
    [sym_dot_expression] = STATE(867),
    [sym_infix_expression] = STATE(867),
    [sym_ce_expression] = STATE(867),
    [sym_sequential_expression] = STATE(867),
    [sym_char] = STATE(868),
    [sym_format_string] = STATE(869),
    [sym__string_literal] = STATE(869),
    [sym_string] = STATE(868),
    [sym_verbatim_string] = STATE(868),
    [sym_bytearray] = STATE(868),
    [sym_verbatim_bytearray] = STATE(868),
    [sym_format_triple_quoted_string] = STATE(870),
    [sym_triple_quoted_string] = STATE(868),
    [sym_const] = STATE(867),
    [sym_long_identifier] = STATE(872),
    [sym_active_pattern] = STATE(871),
    [sym__identifier_or_op] = STATE(873),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(656),
    [sym_sbyte] = STATE(868),
    [sym_byte] = STATE(868),
    [sym_int16] = STATE(868),
    [sym_uint16] = STATE(868),
    [sym_int32] = STATE(868),
    [sym_uint32] = STATE(868),
    [sym_nativeint] = STATE(868),
    [sym_unativeint] = STATE(868),
    [sym_int64] = STATE(868),
    [sym_uint64] = STATE(868),
    [sym_ieee32] = STATE(868),
    [sym_ieee64] = STATE(868),
    [sym_bignum] = STATE(868),
    [sym_decimal] = STATE(868),
    [sym_float] = STATE(1368),
    [sym_block_comment] = STATE(614),
    [sym_compiler_directive_decl] = STATE(614),
    [sym_fsi_directive_decl] = STATE(614),
    [sym_preproc_line] = STATE(614),
    [sym_preproc_if_in_expression] = STATE(867),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(29),
    [anon_sym_return] = ACTIONS(825),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_null] = ACTIONS(49),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACK_PIPE] = ACTIONS(57),
    [anon_sym_LBRACE] = ACTIONS(1663),
    [anon_sym_LT_AT] = ACTIONS(61),
    [anon_sym_LT_AT_AT] = ACTIONS(1665),
    [anon_sym_LBRACE_PIPE] = ACTIONS(67),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_return_BANG] = ACTIONS(829),
    [anon_sym_yield] = ACTIONS(825),
    [anon_sym_yield_BANG] = ACTIONS(829),
    [anon_sym_lazy] = ACTIONS(825),
    [anon_sym_assert] = ACTIONS(825),
    [anon_sym_upcast] = ACTIONS(825),
    [anon_sym_downcast] = ACTIONS(825),
    [anon_sym_for] = ACTIONS(73),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(79),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_match] = ACTIONS(83),
    [anon_sym_match_BANG] = ACTIONS(85),
    [anon_sym_function] = ACTIONS(87),
    [anon_sym_use] = ACTIONS(833),
    [anon_sym_use_BANG] = ACTIONS(835),
    [anon_sym_do_BANG] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(101),
    [aux_sym_char_token1] = ACTIONS(105),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(107),
    [anon_sym_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DQUOTE] = ACTIONS(111),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(115),
    [sym_bool] = ACTIONS(117),
    [sym_unit] = ACTIONS(1673),
    [anon_sym_LPAREN_PIPE] = ACTIONS(121),
    [sym_op_identifier] = ACTIONS(1675),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(837),
    [sym_xint] = ACTIONS(387),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(135),
  },
  [615] = {
    [sym_function_or_value_defn] = STATE(733),
    [sym__expression] = STATE(320),
    [sym_literal_expression] = STATE(2008),
    [sym_long_identifier_or_op] = STATE(2008),
    [sym_tuple_expression] = STATE(2008),
    [sym_brace_expression] = STATE(2008),
    [sym_anon_record_expression] = STATE(2008),
    [sym_prefixed_expression] = STATE(2008),
    [sym_typecast_expression] = STATE(2008),
    [sym_for_expression] = STATE(2008),
    [sym_while_expression] = STATE(2008),
    [sym__if_branch] = STATE(6754),
    [sym_if_expression] = STATE(2008),
    [sym_fun_expression] = STATE(2008),
    [sym_try_expression] = STATE(2008),
    [sym_match_expression] = STATE(2008),
    [sym_function_expression] = STATE(2008),
    [sym_mutate_expression] = STATE(2008),
    [sym_index_expression] = STATE(2008),
    [sym_typed_expression] = STATE(2008),
    [sym_declaration_expression] = STATE(2008),
    [sym_do_expression] = STATE(2008),
    [sym_list_expression] = STATE(2008),
    [sym_array_expression] = STATE(2008),
    [sym_begin_end_expression] = STATE(2008),
    [sym_paren_expression] = STATE(2008),
    [sym__high_prec_app] = STATE(2007),
    [sym__low_prec_app] = STATE(2007),
    [sym_application_expression] = STATE(2008),
    [sym_dot_expression] = STATE(2008),
    [sym_infix_expression] = STATE(2008),
    [sym_ce_expression] = STATE(2008),
    [sym_sequential_expression] = STATE(2008),
    [sym_char] = STATE(1859),
    [sym_format_string] = STATE(1861),
    [sym__string_literal] = STATE(1861),
    [sym_string] = STATE(1859),
    [sym_verbatim_string] = STATE(1859),
    [sym_bytearray] = STATE(1859),
    [sym_verbatim_bytearray] = STATE(1859),
    [sym_format_triple_quoted_string] = STATE(1862),
    [sym_triple_quoted_string] = STATE(1859),
    [sym_const] = STATE(2008),
    [sym_long_identifier] = STATE(1701),
    [sym_active_pattern] = STATE(1702),
    [sym__identifier_or_op] = STATE(1724),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(706),
    [sym_sbyte] = STATE(1859),
    [sym_byte] = STATE(1859),
    [sym_int16] = STATE(1859),
    [sym_uint16] = STATE(1859),
    [sym_int32] = STATE(1859),
    [sym_uint32] = STATE(1859),
    [sym_nativeint] = STATE(1859),
    [sym_unativeint] = STATE(1859),
    [sym_int64] = STATE(1859),
    [sym_uint64] = STATE(1859),
    [sym_ieee32] = STATE(1859),
    [sym_ieee64] = STATE(1859),
    [sym_bignum] = STATE(1859),
    [sym_decimal] = STATE(1859),
    [sym_float] = STATE(1447),
    [sym_block_comment] = STATE(615),
    [sym_compiler_directive_decl] = STATE(615),
    [sym_fsi_directive_decl] = STATE(615),
    [sym_preproc_line] = STATE(615),
    [sym_preproc_if_in_expression] = STATE(2008),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(503),
    [anon_sym_return] = ACTIONS(971),
    [anon_sym_do] = ACTIONS(599),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(511),
    [anon_sym_null] = ACTIONS(515),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(517),
    [anon_sym_LBRACK_PIPE] = ACTIONS(519),
    [anon_sym_LBRACE] = ACTIONS(2060),
    [anon_sym_LT_AT] = ACTIONS(523),
    [anon_sym_LT_AT_AT] = ACTIONS(2062),
    [anon_sym_LBRACE_PIPE] = ACTIONS(529),
    [anon_sym_new] = ACTIONS(971),
    [anon_sym_return_BANG] = ACTIONS(975),
    [anon_sym_yield] = ACTIONS(971),
    [anon_sym_yield_BANG] = ACTIONS(975),
    [anon_sym_lazy] = ACTIONS(971),
    [anon_sym_assert] = ACTIONS(971),
    [anon_sym_upcast] = ACTIONS(971),
    [anon_sym_downcast] = ACTIONS(971),
    [anon_sym_for] = ACTIONS(979),
    [anon_sym_while] = ACTIONS(537),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(539),
    [anon_sym_try] = ACTIONS(543),
    [anon_sym_match] = ACTIONS(545),
    [anon_sym_match_BANG] = ACTIONS(547),
    [anon_sym_function] = ACTIONS(549),
    [anon_sym_use] = ACTIONS(983),
    [anon_sym_use_BANG] = ACTIONS(985),
    [anon_sym_do_BANG] = ACTIONS(561),
    [anon_sym_begin] = ACTIONS(565),
    [aux_sym_char_token1] = ACTIONS(569),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(571),
    [anon_sym_DQUOTE] = ACTIONS(573),
    [anon_sym_AT_DQUOTE] = ACTIONS(575),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(577),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(579),
    [sym_bool] = ACTIONS(581),
    [sym_unit] = ACTIONS(2064),
    [anon_sym_LPAREN_PIPE] = ACTIONS(585),
    [sym_op_identifier] = ACTIONS(2066),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(591),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(593),
  },
  [616] = {
    [sym_function_or_value_defn] = STATE(630),
    [sym__expression] = STATE(229),
    [sym_literal_expression] = STATE(2380),
    [sym_long_identifier_or_op] = STATE(2380),
    [sym_tuple_expression] = STATE(2380),
    [sym_brace_expression] = STATE(2380),
    [sym_anon_record_expression] = STATE(2380),
    [sym_prefixed_expression] = STATE(2380),
    [sym_typecast_expression] = STATE(2380),
    [sym_for_expression] = STATE(2380),
    [sym_while_expression] = STATE(2380),
    [sym__if_branch] = STATE(6456),
    [sym_if_expression] = STATE(2380),
    [sym_fun_expression] = STATE(2380),
    [sym_try_expression] = STATE(2380),
    [sym_match_expression] = STATE(2380),
    [sym_function_expression] = STATE(2380),
    [sym_mutate_expression] = STATE(2380),
    [sym_index_expression] = STATE(2380),
    [sym_typed_expression] = STATE(2380),
    [sym_declaration_expression] = STATE(2380),
    [sym_do_expression] = STATE(2380),
    [sym_list_expression] = STATE(2380),
    [sym_array_expression] = STATE(2380),
    [sym_begin_end_expression] = STATE(2380),
    [sym_paren_expression] = STATE(2380),
    [sym__high_prec_app] = STATE(2383),
    [sym__low_prec_app] = STATE(2383),
    [sym_application_expression] = STATE(2380),
    [sym_dot_expression] = STATE(2380),
    [sym_infix_expression] = STATE(2380),
    [sym_ce_expression] = STATE(2380),
    [sym_sequential_expression] = STATE(2380),
    [sym_char] = STATE(2261),
    [sym_format_string] = STATE(2274),
    [sym__string_literal] = STATE(2274),
    [sym_string] = STATE(2261),
    [sym_verbatim_string] = STATE(2261),
    [sym_bytearray] = STATE(2261),
    [sym_verbatim_bytearray] = STATE(2261),
    [sym_format_triple_quoted_string] = STATE(2275),
    [sym_triple_quoted_string] = STATE(2261),
    [sym_const] = STATE(2380),
    [sym_long_identifier] = STATE(2391),
    [sym_active_pattern] = STATE(2470),
    [sym__identifier_or_op] = STATE(2390),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(632),
    [sym_sbyte] = STATE(2261),
    [sym_byte] = STATE(2261),
    [sym_int16] = STATE(2261),
    [sym_uint16] = STATE(2261),
    [sym_int32] = STATE(2261),
    [sym_uint32] = STATE(2261),
    [sym_nativeint] = STATE(2261),
    [sym_unativeint] = STATE(2261),
    [sym_int64] = STATE(2261),
    [sym_uint64] = STATE(2261),
    [sym_ieee32] = STATE(2261),
    [sym_ieee64] = STATE(2261),
    [sym_bignum] = STATE(2261),
    [sym_decimal] = STATE(2261),
    [sym_float] = STATE(1614),
    [sym_block_comment] = STATE(616),
    [sym_compiler_directive_decl] = STATE(616),
    [sym_fsi_directive_decl] = STATE(616),
    [sym_preproc_line] = STATE(616),
    [sym_preproc_if_in_expression] = STATE(2380),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(1081),
    [anon_sym_return] = ACTIONS(1085),
    [anon_sym_do] = ACTIONS(1087),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(1089),
    [anon_sym_null] = ACTIONS(1093),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1095),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1097),
    [anon_sym_LBRACE] = ACTIONS(2100),
    [anon_sym_LT_AT] = ACTIONS(1101),
    [anon_sym_LT_AT_AT] = ACTIONS(2102),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1107),
    [anon_sym_new] = ACTIONS(1085),
    [anon_sym_return_BANG] = ACTIONS(1109),
    [anon_sym_yield] = ACTIONS(1085),
    [anon_sym_yield_BANG] = ACTIONS(1109),
    [anon_sym_lazy] = ACTIONS(1085),
    [anon_sym_assert] = ACTIONS(1085),
    [anon_sym_upcast] = ACTIONS(1085),
    [anon_sym_downcast] = ACTIONS(1085),
    [anon_sym_for] = ACTIONS(1113),
    [anon_sym_while] = ACTIONS(1115),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(1117),
    [anon_sym_try] = ACTIONS(1119),
    [anon_sym_match] = ACTIONS(1121),
    [anon_sym_match_BANG] = ACTIONS(1123),
    [anon_sym_function] = ACTIONS(1125),
    [anon_sym_use] = ACTIONS(1133),
    [anon_sym_use_BANG] = ACTIONS(1135),
    [anon_sym_do_BANG] = ACTIONS(1137),
    [anon_sym_begin] = ACTIONS(1139),
    [aux_sym_char_token1] = ACTIONS(1143),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1145),
    [anon_sym_DQUOTE] = ACTIONS(1147),
    [anon_sym_AT_DQUOTE] = ACTIONS(1149),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1151),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1153),
    [sym_bool] = ACTIONS(1155),
    [sym_unit] = ACTIONS(2104),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1159),
    [sym_op_identifier] = ACTIONS(2106),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(1163),
    [sym_xint] = ACTIONS(1165),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1167),
  },
  [617] = {
    [sym_function_or_value_defn] = STATE(600),
    [sym__expression] = STATE(245),
    [sym_literal_expression] = STATE(867),
    [sym_long_identifier_or_op] = STATE(867),
    [sym_tuple_expression] = STATE(867),
    [sym_brace_expression] = STATE(867),
    [sym_anon_record_expression] = STATE(867),
    [sym_prefixed_expression] = STATE(867),
    [sym_typecast_expression] = STATE(867),
    [sym_for_expression] = STATE(867),
    [sym_while_expression] = STATE(867),
    [sym__if_branch] = STATE(6511),
    [sym_if_expression] = STATE(867),
    [sym_fun_expression] = STATE(867),
    [sym_try_expression] = STATE(867),
    [sym_match_expression] = STATE(867),
    [sym_function_expression] = STATE(867),
    [sym_mutate_expression] = STATE(867),
    [sym_index_expression] = STATE(867),
    [sym_typed_expression] = STATE(867),
    [sym_declaration_expression] = STATE(867),
    [sym_do_expression] = STATE(867),
    [sym_list_expression] = STATE(867),
    [sym_array_expression] = STATE(867),
    [sym_begin_end_expression] = STATE(867),
    [sym_paren_expression] = STATE(867),
    [sym__high_prec_app] = STATE(864),
    [sym__low_prec_app] = STATE(864),
    [sym_application_expression] = STATE(867),
    [sym_dot_expression] = STATE(867),
    [sym_infix_expression] = STATE(867),
    [sym_ce_expression] = STATE(867),
    [sym_sequential_expression] = STATE(867),
    [sym_char] = STATE(868),
    [sym_format_string] = STATE(869),
    [sym__string_literal] = STATE(869),
    [sym_string] = STATE(868),
    [sym_verbatim_string] = STATE(868),
    [sym_bytearray] = STATE(868),
    [sym_verbatim_bytearray] = STATE(868),
    [sym_format_triple_quoted_string] = STATE(870),
    [sym_triple_quoted_string] = STATE(868),
    [sym_const] = STATE(867),
    [sym_long_identifier] = STATE(872),
    [sym_active_pattern] = STATE(871),
    [sym__identifier_or_op] = STATE(873),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(656),
    [sym_sbyte] = STATE(868),
    [sym_byte] = STATE(868),
    [sym_int16] = STATE(868),
    [sym_uint16] = STATE(868),
    [sym_int32] = STATE(868),
    [sym_uint32] = STATE(868),
    [sym_nativeint] = STATE(868),
    [sym_unativeint] = STATE(868),
    [sym_int64] = STATE(868),
    [sym_uint64] = STATE(868),
    [sym_ieee32] = STATE(868),
    [sym_ieee64] = STATE(868),
    [sym_bignum] = STATE(868),
    [sym_decimal] = STATE(868),
    [sym_float] = STATE(1368),
    [sym_block_comment] = STATE(617),
    [sym_compiler_directive_decl] = STATE(617),
    [sym_fsi_directive_decl] = STATE(617),
    [sym_preproc_line] = STATE(617),
    [sym_preproc_if_in_expression] = STATE(867),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(29),
    [anon_sym_return] = ACTIONS(825),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_null] = ACTIONS(49),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACK_PIPE] = ACTIONS(57),
    [anon_sym_LBRACE] = ACTIONS(1663),
    [anon_sym_LT_AT] = ACTIONS(61),
    [anon_sym_LT_AT_AT] = ACTIONS(1665),
    [anon_sym_LBRACE_PIPE] = ACTIONS(67),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_return_BANG] = ACTIONS(829),
    [anon_sym_yield] = ACTIONS(825),
    [anon_sym_yield_BANG] = ACTIONS(829),
    [anon_sym_lazy] = ACTIONS(825),
    [anon_sym_assert] = ACTIONS(825),
    [anon_sym_upcast] = ACTIONS(825),
    [anon_sym_downcast] = ACTIONS(825),
    [anon_sym_for] = ACTIONS(73),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(79),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_match] = ACTIONS(83),
    [anon_sym_match_BANG] = ACTIONS(85),
    [anon_sym_function] = ACTIONS(87),
    [anon_sym_use] = ACTIONS(833),
    [anon_sym_use_BANG] = ACTIONS(835),
    [anon_sym_do_BANG] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(101),
    [aux_sym_char_token1] = ACTIONS(105),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(107),
    [anon_sym_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DQUOTE] = ACTIONS(111),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(115),
    [sym_bool] = ACTIONS(117),
    [sym_unit] = ACTIONS(1673),
    [anon_sym_LPAREN_PIPE] = ACTIONS(121),
    [sym_op_identifier] = ACTIONS(1675),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(837),
    [sym_xint] = ACTIONS(387),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(135),
  },
  [618] = {
    [sym_function_or_value_defn] = STATE(600),
    [sym__expression] = STATE(246),
    [sym_literal_expression] = STATE(867),
    [sym_long_identifier_or_op] = STATE(867),
    [sym_tuple_expression] = STATE(867),
    [sym_brace_expression] = STATE(867),
    [sym_anon_record_expression] = STATE(867),
    [sym_prefixed_expression] = STATE(867),
    [sym_typecast_expression] = STATE(867),
    [sym_for_expression] = STATE(867),
    [sym_while_expression] = STATE(867),
    [sym__if_branch] = STATE(6511),
    [sym_if_expression] = STATE(867),
    [sym_fun_expression] = STATE(867),
    [sym_try_expression] = STATE(867),
    [sym_match_expression] = STATE(867),
    [sym_function_expression] = STATE(867),
    [sym_mutate_expression] = STATE(867),
    [sym_index_expression] = STATE(867),
    [sym_typed_expression] = STATE(867),
    [sym_declaration_expression] = STATE(867),
    [sym_do_expression] = STATE(867),
    [sym_list_expression] = STATE(867),
    [sym_array_expression] = STATE(867),
    [sym_begin_end_expression] = STATE(867),
    [sym_paren_expression] = STATE(867),
    [sym__high_prec_app] = STATE(864),
    [sym__low_prec_app] = STATE(864),
    [sym_application_expression] = STATE(867),
    [sym_dot_expression] = STATE(867),
    [sym_infix_expression] = STATE(867),
    [sym_ce_expression] = STATE(867),
    [sym_sequential_expression] = STATE(867),
    [sym_char] = STATE(868),
    [sym_format_string] = STATE(869),
    [sym__string_literal] = STATE(869),
    [sym_string] = STATE(868),
    [sym_verbatim_string] = STATE(868),
    [sym_bytearray] = STATE(868),
    [sym_verbatim_bytearray] = STATE(868),
    [sym_format_triple_quoted_string] = STATE(870),
    [sym_triple_quoted_string] = STATE(868),
    [sym_const] = STATE(867),
    [sym_long_identifier] = STATE(872),
    [sym_active_pattern] = STATE(871),
    [sym__identifier_or_op] = STATE(873),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(656),
    [sym_sbyte] = STATE(868),
    [sym_byte] = STATE(868),
    [sym_int16] = STATE(868),
    [sym_uint16] = STATE(868),
    [sym_int32] = STATE(868),
    [sym_uint32] = STATE(868),
    [sym_nativeint] = STATE(868),
    [sym_unativeint] = STATE(868),
    [sym_int64] = STATE(868),
    [sym_uint64] = STATE(868),
    [sym_ieee32] = STATE(868),
    [sym_ieee64] = STATE(868),
    [sym_bignum] = STATE(868),
    [sym_decimal] = STATE(868),
    [sym_float] = STATE(1368),
    [sym_block_comment] = STATE(618),
    [sym_compiler_directive_decl] = STATE(618),
    [sym_fsi_directive_decl] = STATE(618),
    [sym_preproc_line] = STATE(618),
    [sym_preproc_if_in_expression] = STATE(867),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(29),
    [anon_sym_return] = ACTIONS(825),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_null] = ACTIONS(49),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACK_PIPE] = ACTIONS(57),
    [anon_sym_LBRACE] = ACTIONS(1663),
    [anon_sym_LT_AT] = ACTIONS(61),
    [anon_sym_LT_AT_AT] = ACTIONS(1665),
    [anon_sym_LBRACE_PIPE] = ACTIONS(67),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_return_BANG] = ACTIONS(829),
    [anon_sym_yield] = ACTIONS(825),
    [anon_sym_yield_BANG] = ACTIONS(829),
    [anon_sym_lazy] = ACTIONS(825),
    [anon_sym_assert] = ACTIONS(825),
    [anon_sym_upcast] = ACTIONS(825),
    [anon_sym_downcast] = ACTIONS(825),
    [anon_sym_for] = ACTIONS(73),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(79),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_match] = ACTIONS(83),
    [anon_sym_match_BANG] = ACTIONS(85),
    [anon_sym_function] = ACTIONS(87),
    [anon_sym_use] = ACTIONS(833),
    [anon_sym_use_BANG] = ACTIONS(835),
    [anon_sym_do_BANG] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(101),
    [aux_sym_char_token1] = ACTIONS(105),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(107),
    [anon_sym_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DQUOTE] = ACTIONS(111),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(115),
    [sym_bool] = ACTIONS(117),
    [sym_unit] = ACTIONS(1673),
    [anon_sym_LPAREN_PIPE] = ACTIONS(121),
    [sym_op_identifier] = ACTIONS(1675),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(837),
    [sym_xint] = ACTIONS(387),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(135),
  },
  [619] = {
    [sym_function_or_value_defn] = STATE(600),
    [sym__expression] = STATE(248),
    [sym_literal_expression] = STATE(867),
    [sym_long_identifier_or_op] = STATE(867),
    [sym_tuple_expression] = STATE(867),
    [sym_brace_expression] = STATE(867),
    [sym_anon_record_expression] = STATE(867),
    [sym_prefixed_expression] = STATE(867),
    [sym_typecast_expression] = STATE(867),
    [sym_for_expression] = STATE(867),
    [sym_while_expression] = STATE(867),
    [sym__if_branch] = STATE(6511),
    [sym_if_expression] = STATE(867),
    [sym_fun_expression] = STATE(867),
    [sym_try_expression] = STATE(867),
    [sym_match_expression] = STATE(867),
    [sym_function_expression] = STATE(867),
    [sym_mutate_expression] = STATE(867),
    [sym_index_expression] = STATE(867),
    [sym_typed_expression] = STATE(867),
    [sym_declaration_expression] = STATE(867),
    [sym_do_expression] = STATE(867),
    [sym_list_expression] = STATE(867),
    [sym_array_expression] = STATE(867),
    [sym_begin_end_expression] = STATE(867),
    [sym_paren_expression] = STATE(867),
    [sym__high_prec_app] = STATE(864),
    [sym__low_prec_app] = STATE(864),
    [sym_application_expression] = STATE(867),
    [sym_dot_expression] = STATE(867),
    [sym_infix_expression] = STATE(867),
    [sym_ce_expression] = STATE(867),
    [sym_sequential_expression] = STATE(867),
    [sym_char] = STATE(868),
    [sym_format_string] = STATE(869),
    [sym__string_literal] = STATE(869),
    [sym_string] = STATE(868),
    [sym_verbatim_string] = STATE(868),
    [sym_bytearray] = STATE(868),
    [sym_verbatim_bytearray] = STATE(868),
    [sym_format_triple_quoted_string] = STATE(870),
    [sym_triple_quoted_string] = STATE(868),
    [sym_const] = STATE(867),
    [sym_long_identifier] = STATE(872),
    [sym_active_pattern] = STATE(871),
    [sym__identifier_or_op] = STATE(873),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(656),
    [sym_sbyte] = STATE(868),
    [sym_byte] = STATE(868),
    [sym_int16] = STATE(868),
    [sym_uint16] = STATE(868),
    [sym_int32] = STATE(868),
    [sym_uint32] = STATE(868),
    [sym_nativeint] = STATE(868),
    [sym_unativeint] = STATE(868),
    [sym_int64] = STATE(868),
    [sym_uint64] = STATE(868),
    [sym_ieee32] = STATE(868),
    [sym_ieee64] = STATE(868),
    [sym_bignum] = STATE(868),
    [sym_decimal] = STATE(868),
    [sym_float] = STATE(1368),
    [sym_block_comment] = STATE(619),
    [sym_compiler_directive_decl] = STATE(619),
    [sym_fsi_directive_decl] = STATE(619),
    [sym_preproc_line] = STATE(619),
    [sym_preproc_if_in_expression] = STATE(867),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(29),
    [anon_sym_return] = ACTIONS(825),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_null] = ACTIONS(49),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACK_PIPE] = ACTIONS(57),
    [anon_sym_LBRACE] = ACTIONS(1663),
    [anon_sym_LT_AT] = ACTIONS(61),
    [anon_sym_LT_AT_AT] = ACTIONS(1665),
    [anon_sym_LBRACE_PIPE] = ACTIONS(67),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_return_BANG] = ACTIONS(829),
    [anon_sym_yield] = ACTIONS(825),
    [anon_sym_yield_BANG] = ACTIONS(829),
    [anon_sym_lazy] = ACTIONS(825),
    [anon_sym_assert] = ACTIONS(825),
    [anon_sym_upcast] = ACTIONS(825),
    [anon_sym_downcast] = ACTIONS(825),
    [anon_sym_for] = ACTIONS(73),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(79),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_match] = ACTIONS(83),
    [anon_sym_match_BANG] = ACTIONS(85),
    [anon_sym_function] = ACTIONS(87),
    [anon_sym_use] = ACTIONS(833),
    [anon_sym_use_BANG] = ACTIONS(835),
    [anon_sym_do_BANG] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(101),
    [aux_sym_char_token1] = ACTIONS(105),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(107),
    [anon_sym_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DQUOTE] = ACTIONS(111),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(115),
    [sym_bool] = ACTIONS(117),
    [sym_unit] = ACTIONS(1673),
    [anon_sym_LPAREN_PIPE] = ACTIONS(121),
    [sym_op_identifier] = ACTIONS(1675),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(837),
    [sym_xint] = ACTIONS(387),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(135),
  },
  [620] = {
    [sym_function_or_value_defn] = STATE(630),
    [sym__expression] = STATE(227),
    [sym_literal_expression] = STATE(2380),
    [sym_long_identifier_or_op] = STATE(2380),
    [sym_tuple_expression] = STATE(2380),
    [sym_brace_expression] = STATE(2380),
    [sym_anon_record_expression] = STATE(2380),
    [sym_prefixed_expression] = STATE(2380),
    [sym_typecast_expression] = STATE(2380),
    [sym_for_expression] = STATE(2380),
    [sym_while_expression] = STATE(2380),
    [sym__if_branch] = STATE(6456),
    [sym_if_expression] = STATE(2380),
    [sym_fun_expression] = STATE(2380),
    [sym_try_expression] = STATE(2380),
    [sym_match_expression] = STATE(2380),
    [sym_function_expression] = STATE(2380),
    [sym_mutate_expression] = STATE(2380),
    [sym_index_expression] = STATE(2380),
    [sym_typed_expression] = STATE(2380),
    [sym_declaration_expression] = STATE(2380),
    [sym_do_expression] = STATE(2380),
    [sym_list_expression] = STATE(2380),
    [sym_array_expression] = STATE(2380),
    [sym_begin_end_expression] = STATE(2380),
    [sym_paren_expression] = STATE(2380),
    [sym__high_prec_app] = STATE(2383),
    [sym__low_prec_app] = STATE(2383),
    [sym_application_expression] = STATE(2380),
    [sym_dot_expression] = STATE(2380),
    [sym_infix_expression] = STATE(2380),
    [sym_ce_expression] = STATE(2380),
    [sym_sequential_expression] = STATE(2380),
    [sym_char] = STATE(2261),
    [sym_format_string] = STATE(2274),
    [sym__string_literal] = STATE(2274),
    [sym_string] = STATE(2261),
    [sym_verbatim_string] = STATE(2261),
    [sym_bytearray] = STATE(2261),
    [sym_verbatim_bytearray] = STATE(2261),
    [sym_format_triple_quoted_string] = STATE(2275),
    [sym_triple_quoted_string] = STATE(2261),
    [sym_const] = STATE(2380),
    [sym_long_identifier] = STATE(2391),
    [sym_active_pattern] = STATE(2470),
    [sym__identifier_or_op] = STATE(2390),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(632),
    [sym_sbyte] = STATE(2261),
    [sym_byte] = STATE(2261),
    [sym_int16] = STATE(2261),
    [sym_uint16] = STATE(2261),
    [sym_int32] = STATE(2261),
    [sym_uint32] = STATE(2261),
    [sym_nativeint] = STATE(2261),
    [sym_unativeint] = STATE(2261),
    [sym_int64] = STATE(2261),
    [sym_uint64] = STATE(2261),
    [sym_ieee32] = STATE(2261),
    [sym_ieee64] = STATE(2261),
    [sym_bignum] = STATE(2261),
    [sym_decimal] = STATE(2261),
    [sym_float] = STATE(1614),
    [sym_block_comment] = STATE(620),
    [sym_compiler_directive_decl] = STATE(620),
    [sym_fsi_directive_decl] = STATE(620),
    [sym_preproc_line] = STATE(620),
    [sym_preproc_if_in_expression] = STATE(2380),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(1081),
    [anon_sym_return] = ACTIONS(1085),
    [anon_sym_do] = ACTIONS(1087),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(1089),
    [anon_sym_null] = ACTIONS(1093),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1095),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1097),
    [anon_sym_LBRACE] = ACTIONS(2100),
    [anon_sym_LT_AT] = ACTIONS(1101),
    [anon_sym_LT_AT_AT] = ACTIONS(2102),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1107),
    [anon_sym_new] = ACTIONS(1085),
    [anon_sym_return_BANG] = ACTIONS(1109),
    [anon_sym_yield] = ACTIONS(1085),
    [anon_sym_yield_BANG] = ACTIONS(1109),
    [anon_sym_lazy] = ACTIONS(1085),
    [anon_sym_assert] = ACTIONS(1085),
    [anon_sym_upcast] = ACTIONS(1085),
    [anon_sym_downcast] = ACTIONS(1085),
    [anon_sym_for] = ACTIONS(1113),
    [anon_sym_while] = ACTIONS(1115),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(1117),
    [anon_sym_try] = ACTIONS(1119),
    [anon_sym_match] = ACTIONS(1121),
    [anon_sym_match_BANG] = ACTIONS(1123),
    [anon_sym_function] = ACTIONS(1125),
    [anon_sym_use] = ACTIONS(1133),
    [anon_sym_use_BANG] = ACTIONS(1135),
    [anon_sym_do_BANG] = ACTIONS(1137),
    [anon_sym_begin] = ACTIONS(1139),
    [aux_sym_char_token1] = ACTIONS(1143),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1145),
    [anon_sym_DQUOTE] = ACTIONS(1147),
    [anon_sym_AT_DQUOTE] = ACTIONS(1149),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1151),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1153),
    [sym_bool] = ACTIONS(1155),
    [sym_unit] = ACTIONS(2104),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1159),
    [sym_op_identifier] = ACTIONS(2106),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(1163),
    [sym_xint] = ACTIONS(1165),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1167),
  },
  [621] = {
    [sym_function_or_value_defn] = STATE(651),
    [sym__expression] = STATE(155),
    [sym_literal_expression] = STATE(2168),
    [sym_long_identifier_or_op] = STATE(2168),
    [sym_tuple_expression] = STATE(2168),
    [sym_brace_expression] = STATE(2168),
    [sym_anon_record_expression] = STATE(2168),
    [sym_prefixed_expression] = STATE(2168),
    [sym_typecast_expression] = STATE(2168),
    [sym_for_expression] = STATE(2168),
    [sym_while_expression] = STATE(2168),
    [sym__if_branch] = STATE(6406),
    [sym_if_expression] = STATE(2168),
    [sym_fun_expression] = STATE(2168),
    [sym_try_expression] = STATE(2168),
    [sym_match_expression] = STATE(2168),
    [sym_function_expression] = STATE(2168),
    [sym_mutate_expression] = STATE(2168),
    [sym_index_expression] = STATE(2168),
    [sym_typed_expression] = STATE(2168),
    [sym_declaration_expression] = STATE(2168),
    [sym_do_expression] = STATE(2168),
    [sym_list_expression] = STATE(2168),
    [sym_array_expression] = STATE(2168),
    [sym_begin_end_expression] = STATE(2168),
    [sym_paren_expression] = STATE(2168),
    [sym__high_prec_app] = STATE(2179),
    [sym__low_prec_app] = STATE(2179),
    [sym_application_expression] = STATE(2168),
    [sym_dot_expression] = STATE(2168),
    [sym_infix_expression] = STATE(2168),
    [sym_ce_expression] = STATE(2168),
    [sym_sequential_expression] = STATE(2168),
    [sym_char] = STATE(2469),
    [sym_format_string] = STATE(2412),
    [sym__string_literal] = STATE(2412),
    [sym_string] = STATE(2469),
    [sym_verbatim_string] = STATE(2469),
    [sym_bytearray] = STATE(2469),
    [sym_verbatim_bytearray] = STATE(2469),
    [sym_format_triple_quoted_string] = STATE(2408),
    [sym_triple_quoted_string] = STATE(2469),
    [sym_const] = STATE(2168),
    [sym_long_identifier] = STATE(2183),
    [sym_active_pattern] = STATE(2182),
    [sym__identifier_or_op] = STATE(2093),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(650),
    [sym_sbyte] = STATE(2469),
    [sym_byte] = STATE(2469),
    [sym_int16] = STATE(2469),
    [sym_uint16] = STATE(2469),
    [sym_int32] = STATE(2469),
    [sym_uint32] = STATE(2469),
    [sym_nativeint] = STATE(2469),
    [sym_unativeint] = STATE(2469),
    [sym_int64] = STATE(2469),
    [sym_uint64] = STATE(2469),
    [sym_ieee32] = STATE(2469),
    [sym_ieee64] = STATE(2469),
    [sym_bignum] = STATE(2469),
    [sym_decimal] = STATE(2469),
    [sym_float] = STATE(1586),
    [sym_block_comment] = STATE(621),
    [sym_compiler_directive_decl] = STATE(621),
    [sym_fsi_directive_decl] = STATE(621),
    [sym_preproc_line] = STATE(621),
    [sym_preproc_if_in_expression] = STATE(2168),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(989),
    [anon_sym_return] = ACTIONS(993),
    [anon_sym_do] = ACTIONS(995),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(997),
    [anon_sym_null] = ACTIONS(1001),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1003),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1005),
    [anon_sym_LBRACE] = ACTIONS(2070),
    [anon_sym_LT_AT] = ACTIONS(1009),
    [anon_sym_LT_AT_AT] = ACTIONS(2072),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1017),
    [anon_sym_new] = ACTIONS(993),
    [anon_sym_return_BANG] = ACTIONS(1019),
    [anon_sym_yield] = ACTIONS(993),
    [anon_sym_yield_BANG] = ACTIONS(1019),
    [anon_sym_lazy] = ACTIONS(993),
    [anon_sym_assert] = ACTIONS(993),
    [anon_sym_upcast] = ACTIONS(993),
    [anon_sym_downcast] = ACTIONS(993),
    [anon_sym_for] = ACTIONS(1023),
    [anon_sym_while] = ACTIONS(1025),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(1027),
    [anon_sym_try] = ACTIONS(1029),
    [anon_sym_match] = ACTIONS(1031),
    [anon_sym_match_BANG] = ACTIONS(1033),
    [anon_sym_function] = ACTIONS(1035),
    [anon_sym_use] = ACTIONS(1043),
    [anon_sym_use_BANG] = ACTIONS(1045),
    [anon_sym_do_BANG] = ACTIONS(1047),
    [anon_sym_begin] = ACTIONS(1049),
    [aux_sym_char_token1] = ACTIONS(1053),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1055),
    [anon_sym_DQUOTE] = ACTIONS(1057),
    [anon_sym_AT_DQUOTE] = ACTIONS(1059),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1061),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1063),
    [sym_bool] = ACTIONS(1065),
    [sym_unit] = ACTIONS(2074),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1069),
    [sym_op_identifier] = ACTIONS(2076),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(1073),
    [sym_xint] = ACTIONS(1075),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1077),
  },
  [622] = {
    [sym_function_or_value_defn] = STATE(627),
    [sym__expression] = STATE(52),
    [sym_literal_expression] = STATE(1118),
    [sym_long_identifier_or_op] = STATE(1118),
    [sym_tuple_expression] = STATE(1118),
    [sym_brace_expression] = STATE(1118),
    [sym_anon_record_expression] = STATE(1118),
    [sym_prefixed_expression] = STATE(1118),
    [sym_typecast_expression] = STATE(1118),
    [sym_for_expression] = STATE(1118),
    [sym_while_expression] = STATE(1118),
    [sym__if_branch] = STATE(7163),
    [sym_if_expression] = STATE(1118),
    [sym_fun_expression] = STATE(1118),
    [sym_try_expression] = STATE(1118),
    [sym_match_expression] = STATE(1118),
    [sym_function_expression] = STATE(1118),
    [sym_mutate_expression] = STATE(1118),
    [sym_index_expression] = STATE(1118),
    [sym_typed_expression] = STATE(1118),
    [sym_declaration_expression] = STATE(1118),
    [sym_do_expression] = STATE(1118),
    [sym_list_expression] = STATE(1118),
    [sym_array_expression] = STATE(1118),
    [sym_begin_end_expression] = STATE(1118),
    [sym_paren_expression] = STATE(1118),
    [sym__high_prec_app] = STATE(1133),
    [sym__low_prec_app] = STATE(1133),
    [sym_application_expression] = STATE(1118),
    [sym_dot_expression] = STATE(1118),
    [sym_infix_expression] = STATE(1118),
    [sym_ce_expression] = STATE(1118),
    [sym_sequential_expression] = STATE(1118),
    [sym_char] = STATE(1080),
    [sym_format_string] = STATE(1090),
    [sym__string_literal] = STATE(1090),
    [sym_string] = STATE(1080),
    [sym_verbatim_string] = STATE(1080),
    [sym_bytearray] = STATE(1080),
    [sym_verbatim_bytearray] = STATE(1080),
    [sym_format_triple_quoted_string] = STATE(1096),
    [sym_triple_quoted_string] = STATE(1080),
    [sym_const] = STATE(1118),
    [sym_long_identifier] = STATE(1156),
    [sym_active_pattern] = STATE(1085),
    [sym__identifier_or_op] = STATE(1099),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(517),
    [sym_sbyte] = STATE(1080),
    [sym_byte] = STATE(1080),
    [sym_int16] = STATE(1080),
    [sym_uint16] = STATE(1080),
    [sym_int32] = STATE(1080),
    [sym_uint32] = STATE(1080),
    [sym_nativeint] = STATE(1080),
    [sym_unativeint] = STATE(1080),
    [sym_int64] = STATE(1080),
    [sym_uint64] = STATE(1080),
    [sym_ieee32] = STATE(1080),
    [sym_ieee64] = STATE(1080),
    [sym_bignum] = STATE(1080),
    [sym_decimal] = STATE(1080),
    [sym_float] = STATE(979),
    [sym_block_comment] = STATE(622),
    [sym_compiler_directive_decl] = STATE(622),
    [sym_fsi_directive_decl] = STATE(622),
    [sym_preproc_line] = STATE(622),
    [sym_preproc_if_in_expression] = STATE(1118),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(195),
    [anon_sym_return] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_null] = ACTIONS(207),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(209),
    [anon_sym_LBRACK_PIPE] = ACTIONS(211),
    [anon_sym_LBRACE] = ACTIONS(1687),
    [anon_sym_LT_AT] = ACTIONS(213),
    [anon_sym_LT_AT_AT] = ACTIONS(1689),
    [anon_sym_LBRACE_PIPE] = ACTIONS(217),
    [anon_sym_new] = ACTIONS(199),
    [anon_sym_return_BANG] = ACTIONS(219),
    [anon_sym_yield] = ACTIONS(199),
    [anon_sym_yield_BANG] = ACTIONS(219),
    [anon_sym_lazy] = ACTIONS(199),
    [anon_sym_assert] = ACTIONS(199),
    [anon_sym_upcast] = ACTIONS(199),
    [anon_sym_downcast] = ACTIONS(199),
    [anon_sym_for] = ACTIONS(223),
    [anon_sym_while] = ACTIONS(225),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(229),
    [anon_sym_match] = ACTIONS(231),
    [anon_sym_match_BANG] = ACTIONS(233),
    [anon_sym_function] = ACTIONS(235),
    [anon_sym_use] = ACTIONS(239),
    [anon_sym_use_BANG] = ACTIONS(241),
    [anon_sym_do_BANG] = ACTIONS(243),
    [anon_sym_begin] = ACTIONS(245),
    [aux_sym_char_token1] = ACTIONS(247),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(251),
    [anon_sym_AT_DQUOTE] = ACTIONS(253),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(255),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(257),
    [sym_bool] = ACTIONS(259),
    [sym_unit] = ACTIONS(1699),
    [anon_sym_LPAREN_PIPE] = ACTIONS(261),
    [sym_op_identifier] = ACTIONS(1701),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(265),
    [sym_xint] = ACTIONS(267),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(269),
  },
  [623] = {
    [sym_function_or_value_defn] = STATE(600),
    [sym__expression] = STATE(249),
    [sym_literal_expression] = STATE(867),
    [sym_long_identifier_or_op] = STATE(867),
    [sym_tuple_expression] = STATE(867),
    [sym_brace_expression] = STATE(867),
    [sym_anon_record_expression] = STATE(867),
    [sym_prefixed_expression] = STATE(867),
    [sym_typecast_expression] = STATE(867),
    [sym_for_expression] = STATE(867),
    [sym_while_expression] = STATE(867),
    [sym__if_branch] = STATE(6511),
    [sym_if_expression] = STATE(867),
    [sym_fun_expression] = STATE(867),
    [sym_try_expression] = STATE(867),
    [sym_match_expression] = STATE(867),
    [sym_function_expression] = STATE(867),
    [sym_mutate_expression] = STATE(867),
    [sym_index_expression] = STATE(867),
    [sym_typed_expression] = STATE(867),
    [sym_declaration_expression] = STATE(867),
    [sym_do_expression] = STATE(867),
    [sym_list_expression] = STATE(867),
    [sym_array_expression] = STATE(867),
    [sym_begin_end_expression] = STATE(867),
    [sym_paren_expression] = STATE(867),
    [sym__high_prec_app] = STATE(864),
    [sym__low_prec_app] = STATE(864),
    [sym_application_expression] = STATE(867),
    [sym_dot_expression] = STATE(867),
    [sym_infix_expression] = STATE(867),
    [sym_ce_expression] = STATE(867),
    [sym_sequential_expression] = STATE(867),
    [sym_char] = STATE(868),
    [sym_format_string] = STATE(869),
    [sym__string_literal] = STATE(869),
    [sym_string] = STATE(868),
    [sym_verbatim_string] = STATE(868),
    [sym_bytearray] = STATE(868),
    [sym_verbatim_bytearray] = STATE(868),
    [sym_format_triple_quoted_string] = STATE(870),
    [sym_triple_quoted_string] = STATE(868),
    [sym_const] = STATE(867),
    [sym_long_identifier] = STATE(872),
    [sym_active_pattern] = STATE(871),
    [sym__identifier_or_op] = STATE(873),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(656),
    [sym_sbyte] = STATE(868),
    [sym_byte] = STATE(868),
    [sym_int16] = STATE(868),
    [sym_uint16] = STATE(868),
    [sym_int32] = STATE(868),
    [sym_uint32] = STATE(868),
    [sym_nativeint] = STATE(868),
    [sym_unativeint] = STATE(868),
    [sym_int64] = STATE(868),
    [sym_uint64] = STATE(868),
    [sym_ieee32] = STATE(868),
    [sym_ieee64] = STATE(868),
    [sym_bignum] = STATE(868),
    [sym_decimal] = STATE(868),
    [sym_float] = STATE(1368),
    [sym_block_comment] = STATE(623),
    [sym_compiler_directive_decl] = STATE(623),
    [sym_fsi_directive_decl] = STATE(623),
    [sym_preproc_line] = STATE(623),
    [sym_preproc_if_in_expression] = STATE(867),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(29),
    [anon_sym_return] = ACTIONS(825),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_null] = ACTIONS(49),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACK_PIPE] = ACTIONS(57),
    [anon_sym_LBRACE] = ACTIONS(1663),
    [anon_sym_LT_AT] = ACTIONS(61),
    [anon_sym_LT_AT_AT] = ACTIONS(1665),
    [anon_sym_LBRACE_PIPE] = ACTIONS(67),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_return_BANG] = ACTIONS(829),
    [anon_sym_yield] = ACTIONS(825),
    [anon_sym_yield_BANG] = ACTIONS(829),
    [anon_sym_lazy] = ACTIONS(825),
    [anon_sym_assert] = ACTIONS(825),
    [anon_sym_upcast] = ACTIONS(825),
    [anon_sym_downcast] = ACTIONS(825),
    [anon_sym_for] = ACTIONS(73),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(79),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_match] = ACTIONS(83),
    [anon_sym_match_BANG] = ACTIONS(85),
    [anon_sym_function] = ACTIONS(87),
    [anon_sym_use] = ACTIONS(833),
    [anon_sym_use_BANG] = ACTIONS(835),
    [anon_sym_do_BANG] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(101),
    [aux_sym_char_token1] = ACTIONS(105),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(107),
    [anon_sym_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DQUOTE] = ACTIONS(111),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(115),
    [sym_bool] = ACTIONS(117),
    [sym_unit] = ACTIONS(1673),
    [anon_sym_LPAREN_PIPE] = ACTIONS(121),
    [sym_op_identifier] = ACTIONS(1675),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(837),
    [sym_xint] = ACTIONS(387),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(135),
  },
  [624] = {
    [sym_function_or_value_defn] = STATE(630),
    [sym__expression] = STATE(223),
    [sym_literal_expression] = STATE(2380),
    [sym_long_identifier_or_op] = STATE(2380),
    [sym_tuple_expression] = STATE(2380),
    [sym_brace_expression] = STATE(2380),
    [sym_anon_record_expression] = STATE(2380),
    [sym_prefixed_expression] = STATE(2380),
    [sym_typecast_expression] = STATE(2380),
    [sym_for_expression] = STATE(2380),
    [sym_while_expression] = STATE(2380),
    [sym__if_branch] = STATE(6456),
    [sym_if_expression] = STATE(2380),
    [sym_fun_expression] = STATE(2380),
    [sym_try_expression] = STATE(2380),
    [sym_match_expression] = STATE(2380),
    [sym_function_expression] = STATE(2380),
    [sym_mutate_expression] = STATE(2380),
    [sym_index_expression] = STATE(2380),
    [sym_typed_expression] = STATE(2380),
    [sym_declaration_expression] = STATE(2380),
    [sym_do_expression] = STATE(2380),
    [sym_list_expression] = STATE(2380),
    [sym_array_expression] = STATE(2380),
    [sym_begin_end_expression] = STATE(2380),
    [sym_paren_expression] = STATE(2380),
    [sym__high_prec_app] = STATE(2383),
    [sym__low_prec_app] = STATE(2383),
    [sym_application_expression] = STATE(2380),
    [sym_dot_expression] = STATE(2380),
    [sym_infix_expression] = STATE(2380),
    [sym_ce_expression] = STATE(2380),
    [sym_sequential_expression] = STATE(2380),
    [sym_char] = STATE(2261),
    [sym_format_string] = STATE(2274),
    [sym__string_literal] = STATE(2274),
    [sym_string] = STATE(2261),
    [sym_verbatim_string] = STATE(2261),
    [sym_bytearray] = STATE(2261),
    [sym_verbatim_bytearray] = STATE(2261),
    [sym_format_triple_quoted_string] = STATE(2275),
    [sym_triple_quoted_string] = STATE(2261),
    [sym_const] = STATE(2380),
    [sym_long_identifier] = STATE(2391),
    [sym_active_pattern] = STATE(2470),
    [sym__identifier_or_op] = STATE(2390),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(632),
    [sym_sbyte] = STATE(2261),
    [sym_byte] = STATE(2261),
    [sym_int16] = STATE(2261),
    [sym_uint16] = STATE(2261),
    [sym_int32] = STATE(2261),
    [sym_uint32] = STATE(2261),
    [sym_nativeint] = STATE(2261),
    [sym_unativeint] = STATE(2261),
    [sym_int64] = STATE(2261),
    [sym_uint64] = STATE(2261),
    [sym_ieee32] = STATE(2261),
    [sym_ieee64] = STATE(2261),
    [sym_bignum] = STATE(2261),
    [sym_decimal] = STATE(2261),
    [sym_float] = STATE(1614),
    [sym_block_comment] = STATE(624),
    [sym_compiler_directive_decl] = STATE(624),
    [sym_fsi_directive_decl] = STATE(624),
    [sym_preproc_line] = STATE(624),
    [sym_preproc_if_in_expression] = STATE(2380),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(1081),
    [anon_sym_return] = ACTIONS(1085),
    [anon_sym_do] = ACTIONS(1087),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(1089),
    [anon_sym_null] = ACTIONS(1093),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1095),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1097),
    [anon_sym_LBRACE] = ACTIONS(2100),
    [anon_sym_LT_AT] = ACTIONS(1101),
    [anon_sym_LT_AT_AT] = ACTIONS(2102),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1107),
    [anon_sym_new] = ACTIONS(1085),
    [anon_sym_return_BANG] = ACTIONS(1109),
    [anon_sym_yield] = ACTIONS(1085),
    [anon_sym_yield_BANG] = ACTIONS(1109),
    [anon_sym_lazy] = ACTIONS(1085),
    [anon_sym_assert] = ACTIONS(1085),
    [anon_sym_upcast] = ACTIONS(1085),
    [anon_sym_downcast] = ACTIONS(1085),
    [anon_sym_for] = ACTIONS(1113),
    [anon_sym_while] = ACTIONS(1115),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(1117),
    [anon_sym_try] = ACTIONS(1119),
    [anon_sym_match] = ACTIONS(1121),
    [anon_sym_match_BANG] = ACTIONS(1123),
    [anon_sym_function] = ACTIONS(1125),
    [anon_sym_use] = ACTIONS(1133),
    [anon_sym_use_BANG] = ACTIONS(1135),
    [anon_sym_do_BANG] = ACTIONS(1137),
    [anon_sym_begin] = ACTIONS(1139),
    [aux_sym_char_token1] = ACTIONS(1143),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1145),
    [anon_sym_DQUOTE] = ACTIONS(1147),
    [anon_sym_AT_DQUOTE] = ACTIONS(1149),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1151),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1153),
    [sym_bool] = ACTIONS(1155),
    [sym_unit] = ACTIONS(2104),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1159),
    [sym_op_identifier] = ACTIONS(2106),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(1163),
    [sym_xint] = ACTIONS(1165),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1167),
  },
  [625] = {
    [sym_function_or_value_defn] = STATE(600),
    [sym__expression] = STATE(250),
    [sym_literal_expression] = STATE(867),
    [sym_long_identifier_or_op] = STATE(867),
    [sym_tuple_expression] = STATE(867),
    [sym_brace_expression] = STATE(867),
    [sym_anon_record_expression] = STATE(867),
    [sym_prefixed_expression] = STATE(867),
    [sym_typecast_expression] = STATE(867),
    [sym_for_expression] = STATE(867),
    [sym_while_expression] = STATE(867),
    [sym__if_branch] = STATE(6511),
    [sym_if_expression] = STATE(867),
    [sym_fun_expression] = STATE(867),
    [sym_try_expression] = STATE(867),
    [sym_match_expression] = STATE(867),
    [sym_function_expression] = STATE(867),
    [sym_mutate_expression] = STATE(867),
    [sym_index_expression] = STATE(867),
    [sym_typed_expression] = STATE(867),
    [sym_declaration_expression] = STATE(867),
    [sym_do_expression] = STATE(867),
    [sym_list_expression] = STATE(867),
    [sym_array_expression] = STATE(867),
    [sym_begin_end_expression] = STATE(867),
    [sym_paren_expression] = STATE(867),
    [sym__high_prec_app] = STATE(864),
    [sym__low_prec_app] = STATE(864),
    [sym_application_expression] = STATE(867),
    [sym_dot_expression] = STATE(867),
    [sym_infix_expression] = STATE(867),
    [sym_ce_expression] = STATE(867),
    [sym_sequential_expression] = STATE(867),
    [sym_char] = STATE(868),
    [sym_format_string] = STATE(869),
    [sym__string_literal] = STATE(869),
    [sym_string] = STATE(868),
    [sym_verbatim_string] = STATE(868),
    [sym_bytearray] = STATE(868),
    [sym_verbatim_bytearray] = STATE(868),
    [sym_format_triple_quoted_string] = STATE(870),
    [sym_triple_quoted_string] = STATE(868),
    [sym_const] = STATE(867),
    [sym_long_identifier] = STATE(872),
    [sym_active_pattern] = STATE(871),
    [sym__identifier_or_op] = STATE(873),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(656),
    [sym_sbyte] = STATE(868),
    [sym_byte] = STATE(868),
    [sym_int16] = STATE(868),
    [sym_uint16] = STATE(868),
    [sym_int32] = STATE(868),
    [sym_uint32] = STATE(868),
    [sym_nativeint] = STATE(868),
    [sym_unativeint] = STATE(868),
    [sym_int64] = STATE(868),
    [sym_uint64] = STATE(868),
    [sym_ieee32] = STATE(868),
    [sym_ieee64] = STATE(868),
    [sym_bignum] = STATE(868),
    [sym_decimal] = STATE(868),
    [sym_float] = STATE(1368),
    [sym_block_comment] = STATE(625),
    [sym_compiler_directive_decl] = STATE(625),
    [sym_fsi_directive_decl] = STATE(625),
    [sym_preproc_line] = STATE(625),
    [sym_preproc_if_in_expression] = STATE(867),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(29),
    [anon_sym_return] = ACTIONS(825),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_null] = ACTIONS(49),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACK_PIPE] = ACTIONS(57),
    [anon_sym_LBRACE] = ACTIONS(1663),
    [anon_sym_LT_AT] = ACTIONS(61),
    [anon_sym_LT_AT_AT] = ACTIONS(1665),
    [anon_sym_LBRACE_PIPE] = ACTIONS(67),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_return_BANG] = ACTIONS(829),
    [anon_sym_yield] = ACTIONS(825),
    [anon_sym_yield_BANG] = ACTIONS(829),
    [anon_sym_lazy] = ACTIONS(825),
    [anon_sym_assert] = ACTIONS(825),
    [anon_sym_upcast] = ACTIONS(825),
    [anon_sym_downcast] = ACTIONS(825),
    [anon_sym_for] = ACTIONS(73),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(79),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_match] = ACTIONS(83),
    [anon_sym_match_BANG] = ACTIONS(85),
    [anon_sym_function] = ACTIONS(87),
    [anon_sym_use] = ACTIONS(833),
    [anon_sym_use_BANG] = ACTIONS(835),
    [anon_sym_do_BANG] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(101),
    [aux_sym_char_token1] = ACTIONS(105),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(107),
    [anon_sym_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DQUOTE] = ACTIONS(111),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(115),
    [sym_bool] = ACTIONS(117),
    [sym_unit] = ACTIONS(1673),
    [anon_sym_LPAREN_PIPE] = ACTIONS(121),
    [sym_op_identifier] = ACTIONS(1675),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(837),
    [sym_xint] = ACTIONS(387),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(135),
  },
  [626] = {
    [sym_function_or_value_defn] = STATE(600),
    [sym__expression] = STATE(251),
    [sym_literal_expression] = STATE(867),
    [sym_long_identifier_or_op] = STATE(867),
    [sym_tuple_expression] = STATE(867),
    [sym_brace_expression] = STATE(867),
    [sym_anon_record_expression] = STATE(867),
    [sym_prefixed_expression] = STATE(867),
    [sym_typecast_expression] = STATE(867),
    [sym_for_expression] = STATE(867),
    [sym_while_expression] = STATE(867),
    [sym__if_branch] = STATE(6511),
    [sym_if_expression] = STATE(867),
    [sym_fun_expression] = STATE(867),
    [sym_try_expression] = STATE(867),
    [sym_match_expression] = STATE(867),
    [sym_function_expression] = STATE(867),
    [sym_mutate_expression] = STATE(867),
    [sym_index_expression] = STATE(867),
    [sym_typed_expression] = STATE(867),
    [sym_declaration_expression] = STATE(867),
    [sym_do_expression] = STATE(867),
    [sym_list_expression] = STATE(867),
    [sym_array_expression] = STATE(867),
    [sym_begin_end_expression] = STATE(867),
    [sym_paren_expression] = STATE(867),
    [sym__high_prec_app] = STATE(864),
    [sym__low_prec_app] = STATE(864),
    [sym_application_expression] = STATE(867),
    [sym_dot_expression] = STATE(867),
    [sym_infix_expression] = STATE(867),
    [sym_ce_expression] = STATE(867),
    [sym_sequential_expression] = STATE(867),
    [sym_char] = STATE(868),
    [sym_format_string] = STATE(869),
    [sym__string_literal] = STATE(869),
    [sym_string] = STATE(868),
    [sym_verbatim_string] = STATE(868),
    [sym_bytearray] = STATE(868),
    [sym_verbatim_bytearray] = STATE(868),
    [sym_format_triple_quoted_string] = STATE(870),
    [sym_triple_quoted_string] = STATE(868),
    [sym_const] = STATE(867),
    [sym_long_identifier] = STATE(872),
    [sym_active_pattern] = STATE(871),
    [sym__identifier_or_op] = STATE(873),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(656),
    [sym_sbyte] = STATE(868),
    [sym_byte] = STATE(868),
    [sym_int16] = STATE(868),
    [sym_uint16] = STATE(868),
    [sym_int32] = STATE(868),
    [sym_uint32] = STATE(868),
    [sym_nativeint] = STATE(868),
    [sym_unativeint] = STATE(868),
    [sym_int64] = STATE(868),
    [sym_uint64] = STATE(868),
    [sym_ieee32] = STATE(868),
    [sym_ieee64] = STATE(868),
    [sym_bignum] = STATE(868),
    [sym_decimal] = STATE(868),
    [sym_float] = STATE(1368),
    [sym_block_comment] = STATE(626),
    [sym_compiler_directive_decl] = STATE(626),
    [sym_fsi_directive_decl] = STATE(626),
    [sym_preproc_line] = STATE(626),
    [sym_preproc_if_in_expression] = STATE(867),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(29),
    [anon_sym_return] = ACTIONS(825),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_null] = ACTIONS(49),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACK_PIPE] = ACTIONS(57),
    [anon_sym_LBRACE] = ACTIONS(1663),
    [anon_sym_LT_AT] = ACTIONS(61),
    [anon_sym_LT_AT_AT] = ACTIONS(1665),
    [anon_sym_LBRACE_PIPE] = ACTIONS(67),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_return_BANG] = ACTIONS(829),
    [anon_sym_yield] = ACTIONS(825),
    [anon_sym_yield_BANG] = ACTIONS(829),
    [anon_sym_lazy] = ACTIONS(825),
    [anon_sym_assert] = ACTIONS(825),
    [anon_sym_upcast] = ACTIONS(825),
    [anon_sym_downcast] = ACTIONS(825),
    [anon_sym_for] = ACTIONS(73),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(79),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_match] = ACTIONS(83),
    [anon_sym_match_BANG] = ACTIONS(85),
    [anon_sym_function] = ACTIONS(87),
    [anon_sym_use] = ACTIONS(833),
    [anon_sym_use_BANG] = ACTIONS(835),
    [anon_sym_do_BANG] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(101),
    [aux_sym_char_token1] = ACTIONS(105),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(107),
    [anon_sym_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DQUOTE] = ACTIONS(111),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(115),
    [sym_bool] = ACTIONS(117),
    [sym_unit] = ACTIONS(1673),
    [anon_sym_LPAREN_PIPE] = ACTIONS(121),
    [sym_op_identifier] = ACTIONS(1675),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(837),
    [sym_xint] = ACTIONS(387),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(135),
  },
  [627] = {
    [sym_function_or_value_defn] = STATE(627),
    [sym__expression] = STATE(16),
    [sym_literal_expression] = STATE(1118),
    [sym_long_identifier_or_op] = STATE(1118),
    [sym_tuple_expression] = STATE(1118),
    [sym_brace_expression] = STATE(1118),
    [sym_anon_record_expression] = STATE(1118),
    [sym_prefixed_expression] = STATE(1118),
    [sym_typecast_expression] = STATE(1118),
    [sym_for_expression] = STATE(1118),
    [sym_while_expression] = STATE(1118),
    [sym__if_branch] = STATE(7163),
    [sym_if_expression] = STATE(1118),
    [sym_fun_expression] = STATE(1118),
    [sym_try_expression] = STATE(1118),
    [sym_match_expression] = STATE(1118),
    [sym_function_expression] = STATE(1118),
    [sym_mutate_expression] = STATE(1118),
    [sym_index_expression] = STATE(1118),
    [sym_typed_expression] = STATE(1118),
    [sym_declaration_expression] = STATE(1118),
    [sym_do_expression] = STATE(1118),
    [sym_list_expression] = STATE(1118),
    [sym_array_expression] = STATE(1118),
    [sym_begin_end_expression] = STATE(1118),
    [sym_paren_expression] = STATE(1118),
    [sym__high_prec_app] = STATE(1133),
    [sym__low_prec_app] = STATE(1133),
    [sym_application_expression] = STATE(1118),
    [sym_dot_expression] = STATE(1118),
    [sym_infix_expression] = STATE(1118),
    [sym_ce_expression] = STATE(1118),
    [sym_sequential_expression] = STATE(1118),
    [sym_char] = STATE(1080),
    [sym_format_string] = STATE(1090),
    [sym__string_literal] = STATE(1090),
    [sym_string] = STATE(1080),
    [sym_verbatim_string] = STATE(1080),
    [sym_bytearray] = STATE(1080),
    [sym_verbatim_bytearray] = STATE(1080),
    [sym_format_triple_quoted_string] = STATE(1096),
    [sym_triple_quoted_string] = STATE(1080),
    [sym_const] = STATE(1118),
    [sym_long_identifier] = STATE(1156),
    [sym_active_pattern] = STATE(1085),
    [sym__identifier_or_op] = STATE(1099),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(517),
    [sym_sbyte] = STATE(1080),
    [sym_byte] = STATE(1080),
    [sym_int16] = STATE(1080),
    [sym_uint16] = STATE(1080),
    [sym_int32] = STATE(1080),
    [sym_uint32] = STATE(1080),
    [sym_nativeint] = STATE(1080),
    [sym_unativeint] = STATE(1080),
    [sym_int64] = STATE(1080),
    [sym_uint64] = STATE(1080),
    [sym_ieee32] = STATE(1080),
    [sym_ieee64] = STATE(1080),
    [sym_bignum] = STATE(1080),
    [sym_decimal] = STATE(1080),
    [sym_float] = STATE(979),
    [sym_block_comment] = STATE(627),
    [sym_compiler_directive_decl] = STATE(627),
    [sym_fsi_directive_decl] = STATE(627),
    [sym_preproc_line] = STATE(627),
    [sym_preproc_if_in_expression] = STATE(1118),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(195),
    [anon_sym_return] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_null] = ACTIONS(207),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(209),
    [anon_sym_LBRACK_PIPE] = ACTIONS(211),
    [anon_sym_LBRACE] = ACTIONS(1687),
    [anon_sym_LT_AT] = ACTIONS(213),
    [anon_sym_LT_AT_AT] = ACTIONS(1689),
    [anon_sym_LBRACE_PIPE] = ACTIONS(217),
    [anon_sym_new] = ACTIONS(199),
    [anon_sym_return_BANG] = ACTIONS(219),
    [anon_sym_yield] = ACTIONS(199),
    [anon_sym_yield_BANG] = ACTIONS(219),
    [anon_sym_lazy] = ACTIONS(199),
    [anon_sym_assert] = ACTIONS(199),
    [anon_sym_upcast] = ACTIONS(199),
    [anon_sym_downcast] = ACTIONS(199),
    [anon_sym_for] = ACTIONS(223),
    [anon_sym_while] = ACTIONS(225),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(229),
    [anon_sym_match] = ACTIONS(231),
    [anon_sym_match_BANG] = ACTIONS(233),
    [anon_sym_function] = ACTIONS(235),
    [anon_sym_use] = ACTIONS(239),
    [anon_sym_use_BANG] = ACTIONS(241),
    [anon_sym_do_BANG] = ACTIONS(243),
    [anon_sym_begin] = ACTIONS(245),
    [aux_sym_char_token1] = ACTIONS(247),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(251),
    [anon_sym_AT_DQUOTE] = ACTIONS(253),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(255),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(257),
    [sym_bool] = ACTIONS(259),
    [sym_unit] = ACTIONS(1699),
    [anon_sym_LPAREN_PIPE] = ACTIONS(261),
    [sym_op_identifier] = ACTIONS(1701),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(265),
    [sym_xint] = ACTIONS(267),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(269),
  },
  [628] = {
    [sym_function_or_value_defn] = STATE(596),
    [sym__expression] = STATE(123),
    [sym_literal_expression] = STATE(1809),
    [sym_long_identifier_or_op] = STATE(1809),
    [sym_tuple_expression] = STATE(1809),
    [sym_brace_expression] = STATE(1809),
    [sym_anon_record_expression] = STATE(1809),
    [sym_prefixed_expression] = STATE(1809),
    [sym_typecast_expression] = STATE(1809),
    [sym_for_expression] = STATE(1809),
    [sym_while_expression] = STATE(1809),
    [sym__if_branch] = STATE(6874),
    [sym_if_expression] = STATE(1809),
    [sym_fun_expression] = STATE(1809),
    [sym_try_expression] = STATE(1809),
    [sym_match_expression] = STATE(1809),
    [sym_function_expression] = STATE(1809),
    [sym_mutate_expression] = STATE(1809),
    [sym_index_expression] = STATE(1809),
    [sym_typed_expression] = STATE(1809),
    [sym_declaration_expression] = STATE(1809),
    [sym_do_expression] = STATE(1809),
    [sym_list_expression] = STATE(1809),
    [sym_array_expression] = STATE(1809),
    [sym_begin_end_expression] = STATE(1809),
    [sym_paren_expression] = STATE(1809),
    [sym__high_prec_app] = STATE(1806),
    [sym__low_prec_app] = STATE(1806),
    [sym_application_expression] = STATE(1809),
    [sym_dot_expression] = STATE(1809),
    [sym_infix_expression] = STATE(1809),
    [sym_ce_expression] = STATE(1809),
    [sym_sequential_expression] = STATE(1809),
    [sym_char] = STATE(2014),
    [sym_format_string] = STATE(2019),
    [sym__string_literal] = STATE(2019),
    [sym_string] = STATE(2014),
    [sym_verbatim_string] = STATE(2014),
    [sym_bytearray] = STATE(2014),
    [sym_verbatim_bytearray] = STATE(2014),
    [sym_format_triple_quoted_string] = STATE(2020),
    [sym_triple_quoted_string] = STATE(2014),
    [sym_const] = STATE(1809),
    [sym_long_identifier] = STATE(1810),
    [sym_active_pattern] = STATE(1860),
    [sym__identifier_or_op] = STATE(1750),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(655),
    [sym_sbyte] = STATE(2014),
    [sym_byte] = STATE(2014),
    [sym_int16] = STATE(2014),
    [sym_uint16] = STATE(2014),
    [sym_int32] = STATE(2014),
    [sym_uint32] = STATE(2014),
    [sym_nativeint] = STATE(2014),
    [sym_unativeint] = STATE(2014),
    [sym_int64] = STATE(2014),
    [sym_uint64] = STATE(2014),
    [sym_ieee32] = STATE(2014),
    [sym_ieee64] = STATE(2014),
    [sym_bignum] = STATE(2014),
    [sym_decimal] = STATE(2014),
    [sym_float] = STATE(1438),
    [sym_block_comment] = STATE(628),
    [sym_compiler_directive_decl] = STATE(628),
    [sym_fsi_directive_decl] = STATE(628),
    [sym_preproc_line] = STATE(628),
    [sym_preproc_if_in_expression] = STATE(1809),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(723),
    [anon_sym_return] = ACTIONS(727),
    [anon_sym_do] = ACTIONS(729),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(731),
    [anon_sym_null] = ACTIONS(735),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(737),
    [anon_sym_LBRACK_PIPE] = ACTIONS(739),
    [anon_sym_LBRACE] = ACTIONS(2112),
    [anon_sym_LT_AT] = ACTIONS(743),
    [anon_sym_LT_AT_AT] = ACTIONS(2114),
    [anon_sym_LBRACE_PIPE] = ACTIONS(749),
    [anon_sym_new] = ACTIONS(727),
    [anon_sym_return_BANG] = ACTIONS(751),
    [anon_sym_yield] = ACTIONS(727),
    [anon_sym_yield_BANG] = ACTIONS(751),
    [anon_sym_lazy] = ACTIONS(727),
    [anon_sym_assert] = ACTIONS(727),
    [anon_sym_upcast] = ACTIONS(727),
    [anon_sym_downcast] = ACTIONS(727),
    [anon_sym_for] = ACTIONS(755),
    [anon_sym_while] = ACTIONS(757),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(759),
    [anon_sym_try] = ACTIONS(761),
    [anon_sym_match] = ACTIONS(763),
    [anon_sym_match_BANG] = ACTIONS(765),
    [anon_sym_function] = ACTIONS(767),
    [anon_sym_use] = ACTIONS(775),
    [anon_sym_use_BANG] = ACTIONS(777),
    [anon_sym_do_BANG] = ACTIONS(779),
    [anon_sym_begin] = ACTIONS(781),
    [aux_sym_char_token1] = ACTIONS(785),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(787),
    [anon_sym_DQUOTE] = ACTIONS(789),
    [anon_sym_AT_DQUOTE] = ACTIONS(791),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(793),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(795),
    [sym_bool] = ACTIONS(797),
    [sym_unit] = ACTIONS(2116),
    [anon_sym_LPAREN_PIPE] = ACTIONS(801),
    [sym_op_identifier] = ACTIONS(2118),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(805),
    [sym_xint] = ACTIONS(807),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(809),
  },
  [629] = {
    [sym_function_or_value_defn] = STATE(627),
    [sym__expression] = STATE(340),
    [sym_literal_expression] = STATE(1118),
    [sym_long_identifier_or_op] = STATE(1118),
    [sym_tuple_expression] = STATE(1118),
    [sym_brace_expression] = STATE(1118),
    [sym_anon_record_expression] = STATE(1118),
    [sym_prefixed_expression] = STATE(1118),
    [sym_typecast_expression] = STATE(1118),
    [sym_for_expression] = STATE(1118),
    [sym_while_expression] = STATE(1118),
    [sym__if_branch] = STATE(7163),
    [sym_if_expression] = STATE(1118),
    [sym_fun_expression] = STATE(1118),
    [sym_try_expression] = STATE(1118),
    [sym_match_expression] = STATE(1118),
    [sym_function_expression] = STATE(1118),
    [sym_mutate_expression] = STATE(1118),
    [sym_index_expression] = STATE(1118),
    [sym_typed_expression] = STATE(1118),
    [sym_declaration_expression] = STATE(1118),
    [sym_do_expression] = STATE(1118),
    [sym_list_expression] = STATE(1118),
    [sym_array_expression] = STATE(1118),
    [sym_begin_end_expression] = STATE(1118),
    [sym_paren_expression] = STATE(1118),
    [sym__high_prec_app] = STATE(1133),
    [sym__low_prec_app] = STATE(1133),
    [sym_application_expression] = STATE(1118),
    [sym_dot_expression] = STATE(1118),
    [sym_infix_expression] = STATE(1118),
    [sym_ce_expression] = STATE(1118),
    [sym_sequential_expression] = STATE(1118),
    [sym_char] = STATE(1080),
    [sym_format_string] = STATE(1090),
    [sym__string_literal] = STATE(1090),
    [sym_string] = STATE(1080),
    [sym_verbatim_string] = STATE(1080),
    [sym_bytearray] = STATE(1080),
    [sym_verbatim_bytearray] = STATE(1080),
    [sym_format_triple_quoted_string] = STATE(1096),
    [sym_triple_quoted_string] = STATE(1080),
    [sym_const] = STATE(1118),
    [sym_long_identifier] = STATE(1156),
    [sym_active_pattern] = STATE(1085),
    [sym__identifier_or_op] = STATE(1099),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(517),
    [sym_sbyte] = STATE(1080),
    [sym_byte] = STATE(1080),
    [sym_int16] = STATE(1080),
    [sym_uint16] = STATE(1080),
    [sym_int32] = STATE(1080),
    [sym_uint32] = STATE(1080),
    [sym_nativeint] = STATE(1080),
    [sym_unativeint] = STATE(1080),
    [sym_int64] = STATE(1080),
    [sym_uint64] = STATE(1080),
    [sym_ieee32] = STATE(1080),
    [sym_ieee64] = STATE(1080),
    [sym_bignum] = STATE(1080),
    [sym_decimal] = STATE(1080),
    [sym_float] = STATE(979),
    [sym_block_comment] = STATE(629),
    [sym_compiler_directive_decl] = STATE(629),
    [sym_fsi_directive_decl] = STATE(629),
    [sym_preproc_line] = STATE(629),
    [sym_preproc_if_in_expression] = STATE(1118),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(195),
    [anon_sym_return] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_null] = ACTIONS(207),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(209),
    [anon_sym_LBRACK_PIPE] = ACTIONS(211),
    [anon_sym_LBRACE] = ACTIONS(1687),
    [anon_sym_LT_AT] = ACTIONS(213),
    [anon_sym_LT_AT_AT] = ACTIONS(1689),
    [anon_sym_LBRACE_PIPE] = ACTIONS(217),
    [anon_sym_new] = ACTIONS(199),
    [anon_sym_return_BANG] = ACTIONS(219),
    [anon_sym_yield] = ACTIONS(199),
    [anon_sym_yield_BANG] = ACTIONS(219),
    [anon_sym_lazy] = ACTIONS(199),
    [anon_sym_assert] = ACTIONS(199),
    [anon_sym_upcast] = ACTIONS(199),
    [anon_sym_downcast] = ACTIONS(199),
    [anon_sym_for] = ACTIONS(223),
    [anon_sym_while] = ACTIONS(225),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(229),
    [anon_sym_match] = ACTIONS(231),
    [anon_sym_match_BANG] = ACTIONS(233),
    [anon_sym_function] = ACTIONS(235),
    [anon_sym_use] = ACTIONS(239),
    [anon_sym_use_BANG] = ACTIONS(241),
    [anon_sym_do_BANG] = ACTIONS(243),
    [anon_sym_begin] = ACTIONS(245),
    [aux_sym_char_token1] = ACTIONS(247),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(251),
    [anon_sym_AT_DQUOTE] = ACTIONS(253),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(255),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(257),
    [sym_bool] = ACTIONS(259),
    [sym_unit] = ACTIONS(1699),
    [anon_sym_LPAREN_PIPE] = ACTIONS(261),
    [sym_op_identifier] = ACTIONS(1701),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(265),
    [sym_xint] = ACTIONS(267),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(269),
  },
  [630] = {
    [sym_function_or_value_defn] = STATE(630),
    [sym__expression] = STATE(216),
    [sym_literal_expression] = STATE(2380),
    [sym_long_identifier_or_op] = STATE(2380),
    [sym_tuple_expression] = STATE(2380),
    [sym_brace_expression] = STATE(2380),
    [sym_anon_record_expression] = STATE(2380),
    [sym_prefixed_expression] = STATE(2380),
    [sym_typecast_expression] = STATE(2380),
    [sym_for_expression] = STATE(2380),
    [sym_while_expression] = STATE(2380),
    [sym__if_branch] = STATE(6456),
    [sym_if_expression] = STATE(2380),
    [sym_fun_expression] = STATE(2380),
    [sym_try_expression] = STATE(2380),
    [sym_match_expression] = STATE(2380),
    [sym_function_expression] = STATE(2380),
    [sym_mutate_expression] = STATE(2380),
    [sym_index_expression] = STATE(2380),
    [sym_typed_expression] = STATE(2380),
    [sym_declaration_expression] = STATE(2380),
    [sym_do_expression] = STATE(2380),
    [sym_list_expression] = STATE(2380),
    [sym_array_expression] = STATE(2380),
    [sym_begin_end_expression] = STATE(2380),
    [sym_paren_expression] = STATE(2380),
    [sym__high_prec_app] = STATE(2383),
    [sym__low_prec_app] = STATE(2383),
    [sym_application_expression] = STATE(2380),
    [sym_dot_expression] = STATE(2380),
    [sym_infix_expression] = STATE(2380),
    [sym_ce_expression] = STATE(2380),
    [sym_sequential_expression] = STATE(2380),
    [sym_char] = STATE(2261),
    [sym_format_string] = STATE(2274),
    [sym__string_literal] = STATE(2274),
    [sym_string] = STATE(2261),
    [sym_verbatim_string] = STATE(2261),
    [sym_bytearray] = STATE(2261),
    [sym_verbatim_bytearray] = STATE(2261),
    [sym_format_triple_quoted_string] = STATE(2275),
    [sym_triple_quoted_string] = STATE(2261),
    [sym_const] = STATE(2380),
    [sym_long_identifier] = STATE(2391),
    [sym_active_pattern] = STATE(2470),
    [sym__identifier_or_op] = STATE(2390),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(632),
    [sym_sbyte] = STATE(2261),
    [sym_byte] = STATE(2261),
    [sym_int16] = STATE(2261),
    [sym_uint16] = STATE(2261),
    [sym_int32] = STATE(2261),
    [sym_uint32] = STATE(2261),
    [sym_nativeint] = STATE(2261),
    [sym_unativeint] = STATE(2261),
    [sym_int64] = STATE(2261),
    [sym_uint64] = STATE(2261),
    [sym_ieee32] = STATE(2261),
    [sym_ieee64] = STATE(2261),
    [sym_bignum] = STATE(2261),
    [sym_decimal] = STATE(2261),
    [sym_float] = STATE(1614),
    [sym_block_comment] = STATE(630),
    [sym_compiler_directive_decl] = STATE(630),
    [sym_fsi_directive_decl] = STATE(630),
    [sym_preproc_line] = STATE(630),
    [sym_preproc_if_in_expression] = STATE(2380),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(1081),
    [anon_sym_return] = ACTIONS(1085),
    [anon_sym_do] = ACTIONS(1087),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(1089),
    [anon_sym_null] = ACTIONS(1093),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1095),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1097),
    [anon_sym_LBRACE] = ACTIONS(2100),
    [anon_sym_LT_AT] = ACTIONS(1101),
    [anon_sym_LT_AT_AT] = ACTIONS(2102),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1107),
    [anon_sym_new] = ACTIONS(1085),
    [anon_sym_return_BANG] = ACTIONS(1109),
    [anon_sym_yield] = ACTIONS(1085),
    [anon_sym_yield_BANG] = ACTIONS(1109),
    [anon_sym_lazy] = ACTIONS(1085),
    [anon_sym_assert] = ACTIONS(1085),
    [anon_sym_upcast] = ACTIONS(1085),
    [anon_sym_downcast] = ACTIONS(1085),
    [anon_sym_for] = ACTIONS(1113),
    [anon_sym_while] = ACTIONS(1115),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(1117),
    [anon_sym_try] = ACTIONS(1119),
    [anon_sym_match] = ACTIONS(1121),
    [anon_sym_match_BANG] = ACTIONS(1123),
    [anon_sym_function] = ACTIONS(1125),
    [anon_sym_use] = ACTIONS(1133),
    [anon_sym_use_BANG] = ACTIONS(1135),
    [anon_sym_do_BANG] = ACTIONS(1137),
    [anon_sym_begin] = ACTIONS(1139),
    [aux_sym_char_token1] = ACTIONS(1143),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1145),
    [anon_sym_DQUOTE] = ACTIONS(1147),
    [anon_sym_AT_DQUOTE] = ACTIONS(1149),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1151),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1153),
    [sym_bool] = ACTIONS(1155),
    [sym_unit] = ACTIONS(2104),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1159),
    [sym_op_identifier] = ACTIONS(2106),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(1163),
    [sym_xint] = ACTIONS(1165),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1167),
  },
  [631] = {
    [sym_function_or_value_defn] = STATE(596),
    [sym__expression] = STATE(125),
    [sym_literal_expression] = STATE(1809),
    [sym_long_identifier_or_op] = STATE(1809),
    [sym_tuple_expression] = STATE(1809),
    [sym_brace_expression] = STATE(1809),
    [sym_anon_record_expression] = STATE(1809),
    [sym_prefixed_expression] = STATE(1809),
    [sym_typecast_expression] = STATE(1809),
    [sym_for_expression] = STATE(1809),
    [sym_while_expression] = STATE(1809),
    [sym__if_branch] = STATE(6874),
    [sym_if_expression] = STATE(1809),
    [sym_fun_expression] = STATE(1809),
    [sym_try_expression] = STATE(1809),
    [sym_match_expression] = STATE(1809),
    [sym_function_expression] = STATE(1809),
    [sym_mutate_expression] = STATE(1809),
    [sym_index_expression] = STATE(1809),
    [sym_typed_expression] = STATE(1809),
    [sym_declaration_expression] = STATE(1809),
    [sym_do_expression] = STATE(1809),
    [sym_list_expression] = STATE(1809),
    [sym_array_expression] = STATE(1809),
    [sym_begin_end_expression] = STATE(1809),
    [sym_paren_expression] = STATE(1809),
    [sym__high_prec_app] = STATE(1806),
    [sym__low_prec_app] = STATE(1806),
    [sym_application_expression] = STATE(1809),
    [sym_dot_expression] = STATE(1809),
    [sym_infix_expression] = STATE(1809),
    [sym_ce_expression] = STATE(1809),
    [sym_sequential_expression] = STATE(1809),
    [sym_char] = STATE(2014),
    [sym_format_string] = STATE(2019),
    [sym__string_literal] = STATE(2019),
    [sym_string] = STATE(2014),
    [sym_verbatim_string] = STATE(2014),
    [sym_bytearray] = STATE(2014),
    [sym_verbatim_bytearray] = STATE(2014),
    [sym_format_triple_quoted_string] = STATE(2020),
    [sym_triple_quoted_string] = STATE(2014),
    [sym_const] = STATE(1809),
    [sym_long_identifier] = STATE(1810),
    [sym_active_pattern] = STATE(1860),
    [sym__identifier_or_op] = STATE(1750),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(655),
    [sym_sbyte] = STATE(2014),
    [sym_byte] = STATE(2014),
    [sym_int16] = STATE(2014),
    [sym_uint16] = STATE(2014),
    [sym_int32] = STATE(2014),
    [sym_uint32] = STATE(2014),
    [sym_nativeint] = STATE(2014),
    [sym_unativeint] = STATE(2014),
    [sym_int64] = STATE(2014),
    [sym_uint64] = STATE(2014),
    [sym_ieee32] = STATE(2014),
    [sym_ieee64] = STATE(2014),
    [sym_bignum] = STATE(2014),
    [sym_decimal] = STATE(2014),
    [sym_float] = STATE(1438),
    [sym_block_comment] = STATE(631),
    [sym_compiler_directive_decl] = STATE(631),
    [sym_fsi_directive_decl] = STATE(631),
    [sym_preproc_line] = STATE(631),
    [sym_preproc_if_in_expression] = STATE(1809),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(723),
    [anon_sym_return] = ACTIONS(727),
    [anon_sym_do] = ACTIONS(729),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(731),
    [anon_sym_null] = ACTIONS(735),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(737),
    [anon_sym_LBRACK_PIPE] = ACTIONS(739),
    [anon_sym_LBRACE] = ACTIONS(2112),
    [anon_sym_LT_AT] = ACTIONS(743),
    [anon_sym_LT_AT_AT] = ACTIONS(2114),
    [anon_sym_LBRACE_PIPE] = ACTIONS(749),
    [anon_sym_new] = ACTIONS(727),
    [anon_sym_return_BANG] = ACTIONS(751),
    [anon_sym_yield] = ACTIONS(727),
    [anon_sym_yield_BANG] = ACTIONS(751),
    [anon_sym_lazy] = ACTIONS(727),
    [anon_sym_assert] = ACTIONS(727),
    [anon_sym_upcast] = ACTIONS(727),
    [anon_sym_downcast] = ACTIONS(727),
    [anon_sym_for] = ACTIONS(755),
    [anon_sym_while] = ACTIONS(757),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(759),
    [anon_sym_try] = ACTIONS(761),
    [anon_sym_match] = ACTIONS(763),
    [anon_sym_match_BANG] = ACTIONS(765),
    [anon_sym_function] = ACTIONS(767),
    [anon_sym_use] = ACTIONS(775),
    [anon_sym_use_BANG] = ACTIONS(777),
    [anon_sym_do_BANG] = ACTIONS(779),
    [anon_sym_begin] = ACTIONS(781),
    [aux_sym_char_token1] = ACTIONS(785),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(787),
    [anon_sym_DQUOTE] = ACTIONS(789),
    [anon_sym_AT_DQUOTE] = ACTIONS(791),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(793),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(795),
    [sym_bool] = ACTIONS(797),
    [sym_unit] = ACTIONS(2116),
    [anon_sym_LPAREN_PIPE] = ACTIONS(801),
    [sym_op_identifier] = ACTIONS(2118),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(805),
    [sym_xint] = ACTIONS(807),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(809),
  },
  [632] = {
    [sym_function_or_value_defn] = STATE(630),
    [sym__expression] = STATE(213),
    [sym_literal_expression] = STATE(2380),
    [sym_long_identifier_or_op] = STATE(2380),
    [sym_tuple_expression] = STATE(2380),
    [sym_brace_expression] = STATE(2380),
    [sym_anon_record_expression] = STATE(2380),
    [sym_prefixed_expression] = STATE(2380),
    [sym_typecast_expression] = STATE(2380),
    [sym_for_expression] = STATE(2380),
    [sym_while_expression] = STATE(2380),
    [sym__if_branch] = STATE(6456),
    [sym_if_expression] = STATE(2380),
    [sym_fun_expression] = STATE(2380),
    [sym_try_expression] = STATE(2380),
    [sym_match_expression] = STATE(2380),
    [sym_function_expression] = STATE(2380),
    [sym_mutate_expression] = STATE(2380),
    [sym_index_expression] = STATE(2380),
    [sym_typed_expression] = STATE(2380),
    [sym_declaration_expression] = STATE(2380),
    [sym_do_expression] = STATE(2380),
    [sym_list_expression] = STATE(2380),
    [sym_array_expression] = STATE(2380),
    [sym_begin_end_expression] = STATE(2380),
    [sym_paren_expression] = STATE(2380),
    [sym__high_prec_app] = STATE(2383),
    [sym__low_prec_app] = STATE(2383),
    [sym_application_expression] = STATE(2380),
    [sym_dot_expression] = STATE(2380),
    [sym_infix_expression] = STATE(2380),
    [sym_ce_expression] = STATE(2380),
    [sym_sequential_expression] = STATE(2380),
    [sym_char] = STATE(2261),
    [sym_format_string] = STATE(2274),
    [sym__string_literal] = STATE(2274),
    [sym_string] = STATE(2261),
    [sym_verbatim_string] = STATE(2261),
    [sym_bytearray] = STATE(2261),
    [sym_verbatim_bytearray] = STATE(2261),
    [sym_format_triple_quoted_string] = STATE(2275),
    [sym_triple_quoted_string] = STATE(2261),
    [sym_const] = STATE(2380),
    [sym_long_identifier] = STATE(2391),
    [sym_active_pattern] = STATE(2470),
    [sym__identifier_or_op] = STATE(2390),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(632),
    [sym_sbyte] = STATE(2261),
    [sym_byte] = STATE(2261),
    [sym_int16] = STATE(2261),
    [sym_uint16] = STATE(2261),
    [sym_int32] = STATE(2261),
    [sym_uint32] = STATE(2261),
    [sym_nativeint] = STATE(2261),
    [sym_unativeint] = STATE(2261),
    [sym_int64] = STATE(2261),
    [sym_uint64] = STATE(2261),
    [sym_ieee32] = STATE(2261),
    [sym_ieee64] = STATE(2261),
    [sym_bignum] = STATE(2261),
    [sym_decimal] = STATE(2261),
    [sym_float] = STATE(1614),
    [sym_block_comment] = STATE(632),
    [sym_compiler_directive_decl] = STATE(632),
    [sym_fsi_directive_decl] = STATE(632),
    [sym_preproc_line] = STATE(632),
    [sym_preproc_if_in_expression] = STATE(2380),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(1081),
    [anon_sym_return] = ACTIONS(1085),
    [anon_sym_do] = ACTIONS(1087),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(1089),
    [anon_sym_null] = ACTIONS(1093),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1095),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1097),
    [anon_sym_LBRACE] = ACTIONS(2100),
    [anon_sym_LT_AT] = ACTIONS(1101),
    [anon_sym_LT_AT_AT] = ACTIONS(2102),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1107),
    [anon_sym_new] = ACTIONS(1085),
    [anon_sym_return_BANG] = ACTIONS(1109),
    [anon_sym_yield] = ACTIONS(1085),
    [anon_sym_yield_BANG] = ACTIONS(1109),
    [anon_sym_lazy] = ACTIONS(1085),
    [anon_sym_assert] = ACTIONS(1085),
    [anon_sym_upcast] = ACTIONS(1085),
    [anon_sym_downcast] = ACTIONS(1085),
    [anon_sym_for] = ACTIONS(1113),
    [anon_sym_while] = ACTIONS(1115),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(1117),
    [anon_sym_try] = ACTIONS(1119),
    [anon_sym_match] = ACTIONS(1121),
    [anon_sym_match_BANG] = ACTIONS(1123),
    [anon_sym_function] = ACTIONS(1125),
    [anon_sym_use] = ACTIONS(1133),
    [anon_sym_use_BANG] = ACTIONS(1135),
    [anon_sym_do_BANG] = ACTIONS(1137),
    [anon_sym_begin] = ACTIONS(1139),
    [aux_sym_char_token1] = ACTIONS(1143),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1145),
    [anon_sym_DQUOTE] = ACTIONS(1147),
    [anon_sym_AT_DQUOTE] = ACTIONS(1149),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1151),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1153),
    [sym_bool] = ACTIONS(1155),
    [sym_unit] = ACTIONS(2104),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1159),
    [sym_op_identifier] = ACTIONS(2106),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(1163),
    [sym_xint] = ACTIONS(1165),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1167),
  },
  [633] = {
    [sym_function_or_value_defn] = STATE(527),
    [sym__expression] = STATE(258),
    [sym_literal_expression] = STATE(2384),
    [sym_long_identifier_or_op] = STATE(2384),
    [sym_tuple_expression] = STATE(2384),
    [sym_brace_expression] = STATE(2384),
    [sym_anon_record_expression] = STATE(2384),
    [sym_prefixed_expression] = STATE(2384),
    [sym_typecast_expression] = STATE(2384),
    [sym_for_expression] = STATE(2384),
    [sym_while_expression] = STATE(2384),
    [sym__if_branch] = STATE(6561),
    [sym_if_expression] = STATE(2384),
    [sym_fun_expression] = STATE(2384),
    [sym_try_expression] = STATE(2384),
    [sym_match_expression] = STATE(2384),
    [sym_function_expression] = STATE(2384),
    [sym_mutate_expression] = STATE(2384),
    [sym_index_expression] = STATE(2384),
    [sym_typed_expression] = STATE(2384),
    [sym_declaration_expression] = STATE(2384),
    [sym_do_expression] = STATE(2384),
    [sym_list_expression] = STATE(2384),
    [sym_array_expression] = STATE(2384),
    [sym_begin_end_expression] = STATE(2384),
    [sym_paren_expression] = STATE(2384),
    [sym__high_prec_app] = STATE(2249),
    [sym__low_prec_app] = STATE(2249),
    [sym_application_expression] = STATE(2384),
    [sym_dot_expression] = STATE(2384),
    [sym_infix_expression] = STATE(2384),
    [sym_ce_expression] = STATE(2384),
    [sym_sequential_expression] = STATE(2384),
    [sym_char] = STATE(2144),
    [sym_format_string] = STATE(2142),
    [sym__string_literal] = STATE(2142),
    [sym_string] = STATE(2144),
    [sym_verbatim_string] = STATE(2144),
    [sym_bytearray] = STATE(2144),
    [sym_verbatim_bytearray] = STATE(2144),
    [sym_format_triple_quoted_string] = STATE(2141),
    [sym_triple_quoted_string] = STATE(2144),
    [sym_const] = STATE(2384),
    [sym_long_identifier] = STATE(2400),
    [sym_active_pattern] = STATE(2317),
    [sym__identifier_or_op] = STATE(2392),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(633),
    [sym_sbyte] = STATE(2144),
    [sym_byte] = STATE(2144),
    [sym_int16] = STATE(2144),
    [sym_uint16] = STATE(2144),
    [sym_int32] = STATE(2144),
    [sym_uint32] = STATE(2144),
    [sym_nativeint] = STATE(2144),
    [sym_unativeint] = STATE(2144),
    [sym_int64] = STATE(2144),
    [sym_uint64] = STATE(2144),
    [sym_ieee32] = STATE(2144),
    [sym_ieee64] = STATE(2144),
    [sym_bignum] = STATE(2144),
    [sym_decimal] = STATE(2144),
    [sym_float] = STATE(1672),
    [sym_block_comment] = STATE(633),
    [sym_compiler_directive_decl] = STATE(633),
    [sym_fsi_directive_decl] = STATE(633),
    [sym_preproc_line] = STATE(633),
    [sym_preproc_if_in_expression] = STATE(2384),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(1439),
    [anon_sym_return] = ACTIONS(1443),
    [anon_sym_do] = ACTIONS(1445),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(1447),
    [anon_sym_null] = ACTIONS(1451),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1453),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1455),
    [anon_sym_LBRACE] = ACTIONS(2036),
    [anon_sym_LT_AT] = ACTIONS(1459),
    [anon_sym_LT_AT_AT] = ACTIONS(2038),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1465),
    [anon_sym_new] = ACTIONS(1443),
    [anon_sym_return_BANG] = ACTIONS(1467),
    [anon_sym_yield] = ACTIONS(1443),
    [anon_sym_yield_BANG] = ACTIONS(1467),
    [anon_sym_lazy] = ACTIONS(1443),
    [anon_sym_assert] = ACTIONS(1443),
    [anon_sym_upcast] = ACTIONS(1443),
    [anon_sym_downcast] = ACTIONS(1443),
    [anon_sym_for] = ACTIONS(1471),
    [anon_sym_while] = ACTIONS(1473),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(1475),
    [anon_sym_try] = ACTIONS(1477),
    [anon_sym_match] = ACTIONS(1479),
    [anon_sym_match_BANG] = ACTIONS(1481),
    [anon_sym_function] = ACTIONS(1483),
    [anon_sym_use] = ACTIONS(1491),
    [anon_sym_use_BANG] = ACTIONS(1493),
    [anon_sym_do_BANG] = ACTIONS(1495),
    [anon_sym_begin] = ACTIONS(1497),
    [aux_sym_char_token1] = ACTIONS(1501),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1503),
    [anon_sym_DQUOTE] = ACTIONS(1505),
    [anon_sym_AT_DQUOTE] = ACTIONS(1507),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1509),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1511),
    [sym_bool] = ACTIONS(1513),
    [sym_unit] = ACTIONS(2040),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1517),
    [sym_op_identifier] = ACTIONS(2042),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(1521),
    [sym_xint] = ACTIONS(1523),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1525),
  },
  [634] = {
    [sym_function_or_value_defn] = STATE(733),
    [sym__expression] = STATE(210),
    [sym_literal_expression] = STATE(2008),
    [sym_long_identifier_or_op] = STATE(2008),
    [sym_tuple_expression] = STATE(2008),
    [sym_brace_expression] = STATE(2008),
    [sym_anon_record_expression] = STATE(2008),
    [sym_prefixed_expression] = STATE(2008),
    [sym_typecast_expression] = STATE(2008),
    [sym_for_expression] = STATE(2008),
    [sym_while_expression] = STATE(2008),
    [sym__if_branch] = STATE(6754),
    [sym_if_expression] = STATE(2008),
    [sym_fun_expression] = STATE(2008),
    [sym_try_expression] = STATE(2008),
    [sym_match_expression] = STATE(2008),
    [sym_function_expression] = STATE(2008),
    [sym_mutate_expression] = STATE(2008),
    [sym_index_expression] = STATE(2008),
    [sym_typed_expression] = STATE(2008),
    [sym_declaration_expression] = STATE(2008),
    [sym_do_expression] = STATE(2008),
    [sym_list_expression] = STATE(2008),
    [sym_array_expression] = STATE(2008),
    [sym_begin_end_expression] = STATE(2008),
    [sym_paren_expression] = STATE(2008),
    [sym__high_prec_app] = STATE(2007),
    [sym__low_prec_app] = STATE(2007),
    [sym_application_expression] = STATE(2008),
    [sym_dot_expression] = STATE(2008),
    [sym_infix_expression] = STATE(2008),
    [sym_ce_expression] = STATE(2008),
    [sym_sequential_expression] = STATE(2008),
    [sym_char] = STATE(1859),
    [sym_format_string] = STATE(1861),
    [sym__string_literal] = STATE(1861),
    [sym_string] = STATE(1859),
    [sym_verbatim_string] = STATE(1859),
    [sym_bytearray] = STATE(1859),
    [sym_verbatim_bytearray] = STATE(1859),
    [sym_format_triple_quoted_string] = STATE(1862),
    [sym_triple_quoted_string] = STATE(1859),
    [sym_const] = STATE(2008),
    [sym_long_identifier] = STATE(1701),
    [sym_active_pattern] = STATE(1702),
    [sym__identifier_or_op] = STATE(1724),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(706),
    [sym_sbyte] = STATE(1859),
    [sym_byte] = STATE(1859),
    [sym_int16] = STATE(1859),
    [sym_uint16] = STATE(1859),
    [sym_int32] = STATE(1859),
    [sym_uint32] = STATE(1859),
    [sym_nativeint] = STATE(1859),
    [sym_unativeint] = STATE(1859),
    [sym_int64] = STATE(1859),
    [sym_uint64] = STATE(1859),
    [sym_ieee32] = STATE(1859),
    [sym_ieee64] = STATE(1859),
    [sym_bignum] = STATE(1859),
    [sym_decimal] = STATE(1859),
    [sym_float] = STATE(1447),
    [sym_block_comment] = STATE(634),
    [sym_compiler_directive_decl] = STATE(634),
    [sym_fsi_directive_decl] = STATE(634),
    [sym_preproc_line] = STATE(634),
    [sym_preproc_if_in_expression] = STATE(2008),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(503),
    [anon_sym_return] = ACTIONS(971),
    [anon_sym_do] = ACTIONS(599),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(511),
    [anon_sym_null] = ACTIONS(515),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(517),
    [anon_sym_LBRACK_PIPE] = ACTIONS(519),
    [anon_sym_LBRACE] = ACTIONS(2060),
    [anon_sym_LT_AT] = ACTIONS(523),
    [anon_sym_LT_AT_AT] = ACTIONS(2062),
    [anon_sym_LBRACE_PIPE] = ACTIONS(529),
    [anon_sym_new] = ACTIONS(971),
    [anon_sym_return_BANG] = ACTIONS(975),
    [anon_sym_yield] = ACTIONS(971),
    [anon_sym_yield_BANG] = ACTIONS(975),
    [anon_sym_lazy] = ACTIONS(971),
    [anon_sym_assert] = ACTIONS(971),
    [anon_sym_upcast] = ACTIONS(971),
    [anon_sym_downcast] = ACTIONS(971),
    [anon_sym_for] = ACTIONS(979),
    [anon_sym_while] = ACTIONS(537),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(539),
    [anon_sym_try] = ACTIONS(543),
    [anon_sym_match] = ACTIONS(545),
    [anon_sym_match_BANG] = ACTIONS(547),
    [anon_sym_function] = ACTIONS(549),
    [anon_sym_use] = ACTIONS(983),
    [anon_sym_use_BANG] = ACTIONS(985),
    [anon_sym_do_BANG] = ACTIONS(561),
    [anon_sym_begin] = ACTIONS(565),
    [aux_sym_char_token1] = ACTIONS(569),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(571),
    [anon_sym_DQUOTE] = ACTIONS(573),
    [anon_sym_AT_DQUOTE] = ACTIONS(575),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(577),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(579),
    [sym_bool] = ACTIONS(581),
    [sym_unit] = ACTIONS(2064),
    [anon_sym_LPAREN_PIPE] = ACTIONS(585),
    [sym_op_identifier] = ACTIONS(2066),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(591),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(593),
  },
  [635] = {
    [sym_function_or_value_defn] = STATE(651),
    [sym__expression] = STATE(146),
    [sym_literal_expression] = STATE(2168),
    [sym_long_identifier_or_op] = STATE(2168),
    [sym_tuple_expression] = STATE(2168),
    [sym_brace_expression] = STATE(2168),
    [sym_anon_record_expression] = STATE(2168),
    [sym_prefixed_expression] = STATE(2168),
    [sym_typecast_expression] = STATE(2168),
    [sym_for_expression] = STATE(2168),
    [sym_while_expression] = STATE(2168),
    [sym__if_branch] = STATE(6406),
    [sym_if_expression] = STATE(2168),
    [sym_fun_expression] = STATE(2168),
    [sym_try_expression] = STATE(2168),
    [sym_match_expression] = STATE(2168),
    [sym_function_expression] = STATE(2168),
    [sym_mutate_expression] = STATE(2168),
    [sym_index_expression] = STATE(2168),
    [sym_typed_expression] = STATE(2168),
    [sym_declaration_expression] = STATE(2168),
    [sym_do_expression] = STATE(2168),
    [sym_list_expression] = STATE(2168),
    [sym_array_expression] = STATE(2168),
    [sym_begin_end_expression] = STATE(2168),
    [sym_paren_expression] = STATE(2168),
    [sym__high_prec_app] = STATE(2179),
    [sym__low_prec_app] = STATE(2179),
    [sym_application_expression] = STATE(2168),
    [sym_dot_expression] = STATE(2168),
    [sym_infix_expression] = STATE(2168),
    [sym_ce_expression] = STATE(2168),
    [sym_sequential_expression] = STATE(2168),
    [sym_char] = STATE(2469),
    [sym_format_string] = STATE(2412),
    [sym__string_literal] = STATE(2412),
    [sym_string] = STATE(2469),
    [sym_verbatim_string] = STATE(2469),
    [sym_bytearray] = STATE(2469),
    [sym_verbatim_bytearray] = STATE(2469),
    [sym_format_triple_quoted_string] = STATE(2408),
    [sym_triple_quoted_string] = STATE(2469),
    [sym_const] = STATE(2168),
    [sym_long_identifier] = STATE(2183),
    [sym_active_pattern] = STATE(2182),
    [sym__identifier_or_op] = STATE(2093),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(650),
    [sym_sbyte] = STATE(2469),
    [sym_byte] = STATE(2469),
    [sym_int16] = STATE(2469),
    [sym_uint16] = STATE(2469),
    [sym_int32] = STATE(2469),
    [sym_uint32] = STATE(2469),
    [sym_nativeint] = STATE(2469),
    [sym_unativeint] = STATE(2469),
    [sym_int64] = STATE(2469),
    [sym_uint64] = STATE(2469),
    [sym_ieee32] = STATE(2469),
    [sym_ieee64] = STATE(2469),
    [sym_bignum] = STATE(2469),
    [sym_decimal] = STATE(2469),
    [sym_float] = STATE(1586),
    [sym_block_comment] = STATE(635),
    [sym_compiler_directive_decl] = STATE(635),
    [sym_fsi_directive_decl] = STATE(635),
    [sym_preproc_line] = STATE(635),
    [sym_preproc_if_in_expression] = STATE(2168),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(989),
    [anon_sym_return] = ACTIONS(993),
    [anon_sym_do] = ACTIONS(995),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(997),
    [anon_sym_null] = ACTIONS(1001),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1003),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1005),
    [anon_sym_LBRACE] = ACTIONS(2070),
    [anon_sym_LT_AT] = ACTIONS(1009),
    [anon_sym_LT_AT_AT] = ACTIONS(2072),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1017),
    [anon_sym_new] = ACTIONS(993),
    [anon_sym_return_BANG] = ACTIONS(1019),
    [anon_sym_yield] = ACTIONS(993),
    [anon_sym_yield_BANG] = ACTIONS(1019),
    [anon_sym_lazy] = ACTIONS(993),
    [anon_sym_assert] = ACTIONS(993),
    [anon_sym_upcast] = ACTIONS(993),
    [anon_sym_downcast] = ACTIONS(993),
    [anon_sym_for] = ACTIONS(1023),
    [anon_sym_while] = ACTIONS(1025),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(1027),
    [anon_sym_try] = ACTIONS(1029),
    [anon_sym_match] = ACTIONS(1031),
    [anon_sym_match_BANG] = ACTIONS(1033),
    [anon_sym_function] = ACTIONS(1035),
    [anon_sym_use] = ACTIONS(1043),
    [anon_sym_use_BANG] = ACTIONS(1045),
    [anon_sym_do_BANG] = ACTIONS(1047),
    [anon_sym_begin] = ACTIONS(1049),
    [aux_sym_char_token1] = ACTIONS(1053),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1055),
    [anon_sym_DQUOTE] = ACTIONS(1057),
    [anon_sym_AT_DQUOTE] = ACTIONS(1059),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1061),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1063),
    [sym_bool] = ACTIONS(1065),
    [sym_unit] = ACTIONS(2074),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1069),
    [sym_op_identifier] = ACTIONS(2076),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(1073),
    [sym_xint] = ACTIONS(1075),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1077),
  },
  [636] = {
    [sym_function_or_value_defn] = STATE(600),
    [sym__expression] = STATE(321),
    [sym_literal_expression] = STATE(867),
    [sym_long_identifier_or_op] = STATE(867),
    [sym_tuple_expression] = STATE(867),
    [sym_brace_expression] = STATE(867),
    [sym_anon_record_expression] = STATE(867),
    [sym_prefixed_expression] = STATE(867),
    [sym_typecast_expression] = STATE(867),
    [sym_for_expression] = STATE(867),
    [sym_while_expression] = STATE(867),
    [sym__if_branch] = STATE(6511),
    [sym_if_expression] = STATE(867),
    [sym_fun_expression] = STATE(867),
    [sym_try_expression] = STATE(867),
    [sym_match_expression] = STATE(867),
    [sym_function_expression] = STATE(867),
    [sym_mutate_expression] = STATE(867),
    [sym_index_expression] = STATE(867),
    [sym_typed_expression] = STATE(867),
    [sym_declaration_expression] = STATE(867),
    [sym_do_expression] = STATE(867),
    [sym_list_expression] = STATE(867),
    [sym_array_expression] = STATE(867),
    [sym_begin_end_expression] = STATE(867),
    [sym_paren_expression] = STATE(867),
    [sym__high_prec_app] = STATE(864),
    [sym__low_prec_app] = STATE(864),
    [sym_application_expression] = STATE(867),
    [sym_dot_expression] = STATE(867),
    [sym_infix_expression] = STATE(867),
    [sym_ce_expression] = STATE(867),
    [sym_sequential_expression] = STATE(867),
    [sym_char] = STATE(868),
    [sym_format_string] = STATE(869),
    [sym__string_literal] = STATE(869),
    [sym_string] = STATE(868),
    [sym_verbatim_string] = STATE(868),
    [sym_bytearray] = STATE(868),
    [sym_verbatim_bytearray] = STATE(868),
    [sym_format_triple_quoted_string] = STATE(870),
    [sym_triple_quoted_string] = STATE(868),
    [sym_const] = STATE(867),
    [sym_long_identifier] = STATE(872),
    [sym_active_pattern] = STATE(871),
    [sym__identifier_or_op] = STATE(873),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(656),
    [sym_sbyte] = STATE(868),
    [sym_byte] = STATE(868),
    [sym_int16] = STATE(868),
    [sym_uint16] = STATE(868),
    [sym_int32] = STATE(868),
    [sym_uint32] = STATE(868),
    [sym_nativeint] = STATE(868),
    [sym_unativeint] = STATE(868),
    [sym_int64] = STATE(868),
    [sym_uint64] = STATE(868),
    [sym_ieee32] = STATE(868),
    [sym_ieee64] = STATE(868),
    [sym_bignum] = STATE(868),
    [sym_decimal] = STATE(868),
    [sym_float] = STATE(1368),
    [sym_block_comment] = STATE(636),
    [sym_compiler_directive_decl] = STATE(636),
    [sym_fsi_directive_decl] = STATE(636),
    [sym_preproc_line] = STATE(636),
    [sym_preproc_if_in_expression] = STATE(867),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(29),
    [anon_sym_return] = ACTIONS(825),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_null] = ACTIONS(49),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACK_PIPE] = ACTIONS(57),
    [anon_sym_LBRACE] = ACTIONS(1663),
    [anon_sym_LT_AT] = ACTIONS(61),
    [anon_sym_LT_AT_AT] = ACTIONS(1665),
    [anon_sym_LBRACE_PIPE] = ACTIONS(67),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_return_BANG] = ACTIONS(829),
    [anon_sym_yield] = ACTIONS(825),
    [anon_sym_yield_BANG] = ACTIONS(829),
    [anon_sym_lazy] = ACTIONS(825),
    [anon_sym_assert] = ACTIONS(825),
    [anon_sym_upcast] = ACTIONS(825),
    [anon_sym_downcast] = ACTIONS(825),
    [anon_sym_for] = ACTIONS(73),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(79),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_match] = ACTIONS(83),
    [anon_sym_match_BANG] = ACTIONS(85),
    [anon_sym_function] = ACTIONS(87),
    [anon_sym_use] = ACTIONS(833),
    [anon_sym_use_BANG] = ACTIONS(835),
    [anon_sym_do_BANG] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(101),
    [aux_sym_char_token1] = ACTIONS(105),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(107),
    [anon_sym_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DQUOTE] = ACTIONS(111),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(115),
    [sym_bool] = ACTIONS(117),
    [sym_unit] = ACTIONS(1673),
    [anon_sym_LPAREN_PIPE] = ACTIONS(121),
    [sym_op_identifier] = ACTIONS(1675),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(837),
    [sym_xint] = ACTIONS(387),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(135),
  },
  [637] = {
    [sym_function_or_value_defn] = STATE(600),
    [sym__expression] = STATE(254),
    [sym_literal_expression] = STATE(867),
    [sym_long_identifier_or_op] = STATE(867),
    [sym_tuple_expression] = STATE(867),
    [sym_brace_expression] = STATE(867),
    [sym_anon_record_expression] = STATE(867),
    [sym_prefixed_expression] = STATE(867),
    [sym_typecast_expression] = STATE(867),
    [sym_for_expression] = STATE(867),
    [sym_while_expression] = STATE(867),
    [sym__if_branch] = STATE(6511),
    [sym_if_expression] = STATE(867),
    [sym_fun_expression] = STATE(867),
    [sym_try_expression] = STATE(867),
    [sym_match_expression] = STATE(867),
    [sym_function_expression] = STATE(867),
    [sym_mutate_expression] = STATE(867),
    [sym_index_expression] = STATE(867),
    [sym_typed_expression] = STATE(867),
    [sym_declaration_expression] = STATE(867),
    [sym_do_expression] = STATE(867),
    [sym_list_expression] = STATE(867),
    [sym_array_expression] = STATE(867),
    [sym_begin_end_expression] = STATE(867),
    [sym_paren_expression] = STATE(867),
    [sym__high_prec_app] = STATE(864),
    [sym__low_prec_app] = STATE(864),
    [sym_application_expression] = STATE(867),
    [sym_dot_expression] = STATE(867),
    [sym_infix_expression] = STATE(867),
    [sym_ce_expression] = STATE(867),
    [sym_sequential_expression] = STATE(867),
    [sym_char] = STATE(868),
    [sym_format_string] = STATE(869),
    [sym__string_literal] = STATE(869),
    [sym_string] = STATE(868),
    [sym_verbatim_string] = STATE(868),
    [sym_bytearray] = STATE(868),
    [sym_verbatim_bytearray] = STATE(868),
    [sym_format_triple_quoted_string] = STATE(870),
    [sym_triple_quoted_string] = STATE(868),
    [sym_const] = STATE(867),
    [sym_long_identifier] = STATE(872),
    [sym_active_pattern] = STATE(871),
    [sym__identifier_or_op] = STATE(873),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(656),
    [sym_sbyte] = STATE(868),
    [sym_byte] = STATE(868),
    [sym_int16] = STATE(868),
    [sym_uint16] = STATE(868),
    [sym_int32] = STATE(868),
    [sym_uint32] = STATE(868),
    [sym_nativeint] = STATE(868),
    [sym_unativeint] = STATE(868),
    [sym_int64] = STATE(868),
    [sym_uint64] = STATE(868),
    [sym_ieee32] = STATE(868),
    [sym_ieee64] = STATE(868),
    [sym_bignum] = STATE(868),
    [sym_decimal] = STATE(868),
    [sym_float] = STATE(1368),
    [sym_block_comment] = STATE(637),
    [sym_compiler_directive_decl] = STATE(637),
    [sym_fsi_directive_decl] = STATE(637),
    [sym_preproc_line] = STATE(637),
    [sym_preproc_if_in_expression] = STATE(867),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(29),
    [anon_sym_return] = ACTIONS(825),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_null] = ACTIONS(49),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACK_PIPE] = ACTIONS(57),
    [anon_sym_LBRACE] = ACTIONS(1663),
    [anon_sym_LT_AT] = ACTIONS(61),
    [anon_sym_LT_AT_AT] = ACTIONS(1665),
    [anon_sym_LBRACE_PIPE] = ACTIONS(67),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_return_BANG] = ACTIONS(829),
    [anon_sym_yield] = ACTIONS(825),
    [anon_sym_yield_BANG] = ACTIONS(829),
    [anon_sym_lazy] = ACTIONS(825),
    [anon_sym_assert] = ACTIONS(825),
    [anon_sym_upcast] = ACTIONS(825),
    [anon_sym_downcast] = ACTIONS(825),
    [anon_sym_for] = ACTIONS(73),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(79),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_match] = ACTIONS(83),
    [anon_sym_match_BANG] = ACTIONS(85),
    [anon_sym_function] = ACTIONS(87),
    [anon_sym_use] = ACTIONS(833),
    [anon_sym_use_BANG] = ACTIONS(835),
    [anon_sym_do_BANG] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(101),
    [aux_sym_char_token1] = ACTIONS(105),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(107),
    [anon_sym_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DQUOTE] = ACTIONS(111),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(115),
    [sym_bool] = ACTIONS(117),
    [sym_unit] = ACTIONS(1673),
    [anon_sym_LPAREN_PIPE] = ACTIONS(121),
    [sym_op_identifier] = ACTIONS(1675),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(837),
    [sym_xint] = ACTIONS(387),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(135),
  },
  [638] = {
    [sym_function_or_value_defn] = STATE(627),
    [sym__expression] = STATE(103),
    [sym_literal_expression] = STATE(1118),
    [sym_long_identifier_or_op] = STATE(1118),
    [sym_tuple_expression] = STATE(1118),
    [sym_brace_expression] = STATE(1118),
    [sym_anon_record_expression] = STATE(1118),
    [sym_prefixed_expression] = STATE(1118),
    [sym_typecast_expression] = STATE(1118),
    [sym_for_expression] = STATE(1118),
    [sym_while_expression] = STATE(1118),
    [sym__if_branch] = STATE(7163),
    [sym_if_expression] = STATE(1118),
    [sym_fun_expression] = STATE(1118),
    [sym_try_expression] = STATE(1118),
    [sym_match_expression] = STATE(1118),
    [sym_function_expression] = STATE(1118),
    [sym_mutate_expression] = STATE(1118),
    [sym_index_expression] = STATE(1118),
    [sym_typed_expression] = STATE(1118),
    [sym_declaration_expression] = STATE(1118),
    [sym_do_expression] = STATE(1118),
    [sym_list_expression] = STATE(1118),
    [sym_array_expression] = STATE(1118),
    [sym_begin_end_expression] = STATE(1118),
    [sym_paren_expression] = STATE(1118),
    [sym__high_prec_app] = STATE(1133),
    [sym__low_prec_app] = STATE(1133),
    [sym_application_expression] = STATE(1118),
    [sym_dot_expression] = STATE(1118),
    [sym_infix_expression] = STATE(1118),
    [sym_ce_expression] = STATE(1118),
    [sym_sequential_expression] = STATE(1118),
    [sym_char] = STATE(1080),
    [sym_format_string] = STATE(1090),
    [sym__string_literal] = STATE(1090),
    [sym_string] = STATE(1080),
    [sym_verbatim_string] = STATE(1080),
    [sym_bytearray] = STATE(1080),
    [sym_verbatim_bytearray] = STATE(1080),
    [sym_format_triple_quoted_string] = STATE(1096),
    [sym_triple_quoted_string] = STATE(1080),
    [sym_const] = STATE(1118),
    [sym_long_identifier] = STATE(1156),
    [sym_active_pattern] = STATE(1085),
    [sym__identifier_or_op] = STATE(1099),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(517),
    [sym_sbyte] = STATE(1080),
    [sym_byte] = STATE(1080),
    [sym_int16] = STATE(1080),
    [sym_uint16] = STATE(1080),
    [sym_int32] = STATE(1080),
    [sym_uint32] = STATE(1080),
    [sym_nativeint] = STATE(1080),
    [sym_unativeint] = STATE(1080),
    [sym_int64] = STATE(1080),
    [sym_uint64] = STATE(1080),
    [sym_ieee32] = STATE(1080),
    [sym_ieee64] = STATE(1080),
    [sym_bignum] = STATE(1080),
    [sym_decimal] = STATE(1080),
    [sym_float] = STATE(979),
    [sym_block_comment] = STATE(638),
    [sym_compiler_directive_decl] = STATE(638),
    [sym_fsi_directive_decl] = STATE(638),
    [sym_preproc_line] = STATE(638),
    [sym_preproc_if_in_expression] = STATE(1118),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(195),
    [anon_sym_return] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_null] = ACTIONS(207),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(209),
    [anon_sym_LBRACK_PIPE] = ACTIONS(211),
    [anon_sym_LBRACE] = ACTIONS(1687),
    [anon_sym_LT_AT] = ACTIONS(213),
    [anon_sym_LT_AT_AT] = ACTIONS(1689),
    [anon_sym_LBRACE_PIPE] = ACTIONS(217),
    [anon_sym_new] = ACTIONS(199),
    [anon_sym_return_BANG] = ACTIONS(219),
    [anon_sym_yield] = ACTIONS(199),
    [anon_sym_yield_BANG] = ACTIONS(219),
    [anon_sym_lazy] = ACTIONS(199),
    [anon_sym_assert] = ACTIONS(199),
    [anon_sym_upcast] = ACTIONS(199),
    [anon_sym_downcast] = ACTIONS(199),
    [anon_sym_for] = ACTIONS(223),
    [anon_sym_while] = ACTIONS(225),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(229),
    [anon_sym_match] = ACTIONS(231),
    [anon_sym_match_BANG] = ACTIONS(233),
    [anon_sym_function] = ACTIONS(235),
    [anon_sym_use] = ACTIONS(239),
    [anon_sym_use_BANG] = ACTIONS(241),
    [anon_sym_do_BANG] = ACTIONS(243),
    [anon_sym_begin] = ACTIONS(245),
    [aux_sym_char_token1] = ACTIONS(247),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(251),
    [anon_sym_AT_DQUOTE] = ACTIONS(253),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(255),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(257),
    [sym_bool] = ACTIONS(259),
    [sym_unit] = ACTIONS(1699),
    [anon_sym_LPAREN_PIPE] = ACTIONS(261),
    [sym_op_identifier] = ACTIONS(1701),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(265),
    [sym_xint] = ACTIONS(267),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(269),
  },
  [639] = {
    [sym_function_or_value_defn] = STATE(596),
    [sym__expression] = STATE(115),
    [sym_literal_expression] = STATE(1809),
    [sym_long_identifier_or_op] = STATE(1809),
    [sym_tuple_expression] = STATE(1809),
    [sym_brace_expression] = STATE(1809),
    [sym_anon_record_expression] = STATE(1809),
    [sym_prefixed_expression] = STATE(1809),
    [sym_typecast_expression] = STATE(1809),
    [sym_for_expression] = STATE(1809),
    [sym_while_expression] = STATE(1809),
    [sym__if_branch] = STATE(6874),
    [sym_if_expression] = STATE(1809),
    [sym_fun_expression] = STATE(1809),
    [sym_try_expression] = STATE(1809),
    [sym_match_expression] = STATE(1809),
    [sym_function_expression] = STATE(1809),
    [sym_mutate_expression] = STATE(1809),
    [sym_index_expression] = STATE(1809),
    [sym_typed_expression] = STATE(1809),
    [sym_declaration_expression] = STATE(1809),
    [sym_do_expression] = STATE(1809),
    [sym_list_expression] = STATE(1809),
    [sym_array_expression] = STATE(1809),
    [sym_begin_end_expression] = STATE(1809),
    [sym_paren_expression] = STATE(1809),
    [sym__high_prec_app] = STATE(1806),
    [sym__low_prec_app] = STATE(1806),
    [sym_application_expression] = STATE(1809),
    [sym_dot_expression] = STATE(1809),
    [sym_infix_expression] = STATE(1809),
    [sym_ce_expression] = STATE(1809),
    [sym_sequential_expression] = STATE(1809),
    [sym_char] = STATE(2014),
    [sym_format_string] = STATE(2019),
    [sym__string_literal] = STATE(2019),
    [sym_string] = STATE(2014),
    [sym_verbatim_string] = STATE(2014),
    [sym_bytearray] = STATE(2014),
    [sym_verbatim_bytearray] = STATE(2014),
    [sym_format_triple_quoted_string] = STATE(2020),
    [sym_triple_quoted_string] = STATE(2014),
    [sym_const] = STATE(1809),
    [sym_long_identifier] = STATE(1810),
    [sym_active_pattern] = STATE(1860),
    [sym__identifier_or_op] = STATE(1750),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(655),
    [sym_sbyte] = STATE(2014),
    [sym_byte] = STATE(2014),
    [sym_int16] = STATE(2014),
    [sym_uint16] = STATE(2014),
    [sym_int32] = STATE(2014),
    [sym_uint32] = STATE(2014),
    [sym_nativeint] = STATE(2014),
    [sym_unativeint] = STATE(2014),
    [sym_int64] = STATE(2014),
    [sym_uint64] = STATE(2014),
    [sym_ieee32] = STATE(2014),
    [sym_ieee64] = STATE(2014),
    [sym_bignum] = STATE(2014),
    [sym_decimal] = STATE(2014),
    [sym_float] = STATE(1438),
    [sym_block_comment] = STATE(639),
    [sym_compiler_directive_decl] = STATE(639),
    [sym_fsi_directive_decl] = STATE(639),
    [sym_preproc_line] = STATE(639),
    [sym_preproc_if_in_expression] = STATE(1809),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(723),
    [anon_sym_return] = ACTIONS(727),
    [anon_sym_do] = ACTIONS(729),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(731),
    [anon_sym_null] = ACTIONS(735),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(737),
    [anon_sym_LBRACK_PIPE] = ACTIONS(739),
    [anon_sym_LBRACE] = ACTIONS(2112),
    [anon_sym_LT_AT] = ACTIONS(743),
    [anon_sym_LT_AT_AT] = ACTIONS(2114),
    [anon_sym_LBRACE_PIPE] = ACTIONS(749),
    [anon_sym_new] = ACTIONS(727),
    [anon_sym_return_BANG] = ACTIONS(751),
    [anon_sym_yield] = ACTIONS(727),
    [anon_sym_yield_BANG] = ACTIONS(751),
    [anon_sym_lazy] = ACTIONS(727),
    [anon_sym_assert] = ACTIONS(727),
    [anon_sym_upcast] = ACTIONS(727),
    [anon_sym_downcast] = ACTIONS(727),
    [anon_sym_for] = ACTIONS(755),
    [anon_sym_while] = ACTIONS(757),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(759),
    [anon_sym_try] = ACTIONS(761),
    [anon_sym_match] = ACTIONS(763),
    [anon_sym_match_BANG] = ACTIONS(765),
    [anon_sym_function] = ACTIONS(767),
    [anon_sym_use] = ACTIONS(775),
    [anon_sym_use_BANG] = ACTIONS(777),
    [anon_sym_do_BANG] = ACTIONS(779),
    [anon_sym_begin] = ACTIONS(781),
    [aux_sym_char_token1] = ACTIONS(785),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(787),
    [anon_sym_DQUOTE] = ACTIONS(789),
    [anon_sym_AT_DQUOTE] = ACTIONS(791),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(793),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(795),
    [sym_bool] = ACTIONS(797),
    [sym_unit] = ACTIONS(2116),
    [anon_sym_LPAREN_PIPE] = ACTIONS(801),
    [sym_op_identifier] = ACTIONS(2118),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(805),
    [sym_xint] = ACTIONS(807),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(809),
  },
  [640] = {
    [sym_function_or_value_defn] = STATE(630),
    [sym__expression] = STATE(147),
    [sym_literal_expression] = STATE(2380),
    [sym_long_identifier_or_op] = STATE(2380),
    [sym_tuple_expression] = STATE(2380),
    [sym_brace_expression] = STATE(2380),
    [sym_anon_record_expression] = STATE(2380),
    [sym_prefixed_expression] = STATE(2380),
    [sym_typecast_expression] = STATE(2380),
    [sym_for_expression] = STATE(2380),
    [sym_while_expression] = STATE(2380),
    [sym__if_branch] = STATE(6456),
    [sym_if_expression] = STATE(2380),
    [sym_fun_expression] = STATE(2380),
    [sym_try_expression] = STATE(2380),
    [sym_match_expression] = STATE(2380),
    [sym_function_expression] = STATE(2380),
    [sym_mutate_expression] = STATE(2380),
    [sym_index_expression] = STATE(2380),
    [sym_typed_expression] = STATE(2380),
    [sym_declaration_expression] = STATE(2380),
    [sym_do_expression] = STATE(2380),
    [sym_list_expression] = STATE(2380),
    [sym_array_expression] = STATE(2380),
    [sym_begin_end_expression] = STATE(2380),
    [sym_paren_expression] = STATE(2380),
    [sym__high_prec_app] = STATE(2383),
    [sym__low_prec_app] = STATE(2383),
    [sym_application_expression] = STATE(2380),
    [sym_dot_expression] = STATE(2380),
    [sym_infix_expression] = STATE(2380),
    [sym_ce_expression] = STATE(2380),
    [sym_sequential_expression] = STATE(2380),
    [sym_char] = STATE(2261),
    [sym_format_string] = STATE(2274),
    [sym__string_literal] = STATE(2274),
    [sym_string] = STATE(2261),
    [sym_verbatim_string] = STATE(2261),
    [sym_bytearray] = STATE(2261),
    [sym_verbatim_bytearray] = STATE(2261),
    [sym_format_triple_quoted_string] = STATE(2275),
    [sym_triple_quoted_string] = STATE(2261),
    [sym_const] = STATE(2380),
    [sym_long_identifier] = STATE(2391),
    [sym_active_pattern] = STATE(2470),
    [sym__identifier_or_op] = STATE(2390),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(632),
    [sym_sbyte] = STATE(2261),
    [sym_byte] = STATE(2261),
    [sym_int16] = STATE(2261),
    [sym_uint16] = STATE(2261),
    [sym_int32] = STATE(2261),
    [sym_uint32] = STATE(2261),
    [sym_nativeint] = STATE(2261),
    [sym_unativeint] = STATE(2261),
    [sym_int64] = STATE(2261),
    [sym_uint64] = STATE(2261),
    [sym_ieee32] = STATE(2261),
    [sym_ieee64] = STATE(2261),
    [sym_bignum] = STATE(2261),
    [sym_decimal] = STATE(2261),
    [sym_float] = STATE(1614),
    [sym_block_comment] = STATE(640),
    [sym_compiler_directive_decl] = STATE(640),
    [sym_fsi_directive_decl] = STATE(640),
    [sym_preproc_line] = STATE(640),
    [sym_preproc_if_in_expression] = STATE(2380),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(1081),
    [anon_sym_return] = ACTIONS(1085),
    [anon_sym_do] = ACTIONS(1087),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(1089),
    [anon_sym_null] = ACTIONS(1093),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1095),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1097),
    [anon_sym_LBRACE] = ACTIONS(2100),
    [anon_sym_LT_AT] = ACTIONS(1101),
    [anon_sym_LT_AT_AT] = ACTIONS(2102),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1107),
    [anon_sym_new] = ACTIONS(1085),
    [anon_sym_return_BANG] = ACTIONS(1109),
    [anon_sym_yield] = ACTIONS(1085),
    [anon_sym_yield_BANG] = ACTIONS(1109),
    [anon_sym_lazy] = ACTIONS(1085),
    [anon_sym_assert] = ACTIONS(1085),
    [anon_sym_upcast] = ACTIONS(1085),
    [anon_sym_downcast] = ACTIONS(1085),
    [anon_sym_for] = ACTIONS(1113),
    [anon_sym_while] = ACTIONS(1115),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(1117),
    [anon_sym_try] = ACTIONS(1119),
    [anon_sym_match] = ACTIONS(1121),
    [anon_sym_match_BANG] = ACTIONS(1123),
    [anon_sym_function] = ACTIONS(1125),
    [anon_sym_use] = ACTIONS(1133),
    [anon_sym_use_BANG] = ACTIONS(1135),
    [anon_sym_do_BANG] = ACTIONS(1137),
    [anon_sym_begin] = ACTIONS(1139),
    [aux_sym_char_token1] = ACTIONS(1143),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1145),
    [anon_sym_DQUOTE] = ACTIONS(1147),
    [anon_sym_AT_DQUOTE] = ACTIONS(1149),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1151),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1153),
    [sym_bool] = ACTIONS(1155),
    [sym_unit] = ACTIONS(2104),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1159),
    [sym_op_identifier] = ACTIONS(2106),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(1163),
    [sym_xint] = ACTIONS(1165),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1167),
  },
  [641] = {
    [sym_function_or_value_defn] = STATE(733),
    [sym__expression] = STATE(256),
    [sym_literal_expression] = STATE(2008),
    [sym_long_identifier_or_op] = STATE(2008),
    [sym_tuple_expression] = STATE(2008),
    [sym_brace_expression] = STATE(2008),
    [sym_anon_record_expression] = STATE(2008),
    [sym_prefixed_expression] = STATE(2008),
    [sym_typecast_expression] = STATE(2008),
    [sym_for_expression] = STATE(2008),
    [sym_while_expression] = STATE(2008),
    [sym__if_branch] = STATE(6754),
    [sym_if_expression] = STATE(2008),
    [sym_fun_expression] = STATE(2008),
    [sym_try_expression] = STATE(2008),
    [sym_match_expression] = STATE(2008),
    [sym_function_expression] = STATE(2008),
    [sym_mutate_expression] = STATE(2008),
    [sym_index_expression] = STATE(2008),
    [sym_typed_expression] = STATE(2008),
    [sym_declaration_expression] = STATE(2008),
    [sym_do_expression] = STATE(2008),
    [sym_list_expression] = STATE(2008),
    [sym_array_expression] = STATE(2008),
    [sym_begin_end_expression] = STATE(2008),
    [sym_paren_expression] = STATE(2008),
    [sym__high_prec_app] = STATE(2007),
    [sym__low_prec_app] = STATE(2007),
    [sym_application_expression] = STATE(2008),
    [sym_dot_expression] = STATE(2008),
    [sym_infix_expression] = STATE(2008),
    [sym_ce_expression] = STATE(2008),
    [sym_sequential_expression] = STATE(2008),
    [sym_char] = STATE(1859),
    [sym_format_string] = STATE(1861),
    [sym__string_literal] = STATE(1861),
    [sym_string] = STATE(1859),
    [sym_verbatim_string] = STATE(1859),
    [sym_bytearray] = STATE(1859),
    [sym_verbatim_bytearray] = STATE(1859),
    [sym_format_triple_quoted_string] = STATE(1862),
    [sym_triple_quoted_string] = STATE(1859),
    [sym_const] = STATE(2008),
    [sym_long_identifier] = STATE(1701),
    [sym_active_pattern] = STATE(1702),
    [sym__identifier_or_op] = STATE(1724),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(706),
    [sym_sbyte] = STATE(1859),
    [sym_byte] = STATE(1859),
    [sym_int16] = STATE(1859),
    [sym_uint16] = STATE(1859),
    [sym_int32] = STATE(1859),
    [sym_uint32] = STATE(1859),
    [sym_nativeint] = STATE(1859),
    [sym_unativeint] = STATE(1859),
    [sym_int64] = STATE(1859),
    [sym_uint64] = STATE(1859),
    [sym_ieee32] = STATE(1859),
    [sym_ieee64] = STATE(1859),
    [sym_bignum] = STATE(1859),
    [sym_decimal] = STATE(1859),
    [sym_float] = STATE(1447),
    [sym_block_comment] = STATE(641),
    [sym_compiler_directive_decl] = STATE(641),
    [sym_fsi_directive_decl] = STATE(641),
    [sym_preproc_line] = STATE(641),
    [sym_preproc_if_in_expression] = STATE(2008),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(503),
    [anon_sym_return] = ACTIONS(971),
    [anon_sym_do] = ACTIONS(599),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(511),
    [anon_sym_null] = ACTIONS(515),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(517),
    [anon_sym_LBRACK_PIPE] = ACTIONS(519),
    [anon_sym_LBRACE] = ACTIONS(2060),
    [anon_sym_LT_AT] = ACTIONS(523),
    [anon_sym_LT_AT_AT] = ACTIONS(2062),
    [anon_sym_LBRACE_PIPE] = ACTIONS(529),
    [anon_sym_new] = ACTIONS(971),
    [anon_sym_return_BANG] = ACTIONS(975),
    [anon_sym_yield] = ACTIONS(971),
    [anon_sym_yield_BANG] = ACTIONS(975),
    [anon_sym_lazy] = ACTIONS(971),
    [anon_sym_assert] = ACTIONS(971),
    [anon_sym_upcast] = ACTIONS(971),
    [anon_sym_downcast] = ACTIONS(971),
    [anon_sym_for] = ACTIONS(979),
    [anon_sym_while] = ACTIONS(537),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(539),
    [anon_sym_try] = ACTIONS(543),
    [anon_sym_match] = ACTIONS(545),
    [anon_sym_match_BANG] = ACTIONS(547),
    [anon_sym_function] = ACTIONS(549),
    [anon_sym_use] = ACTIONS(983),
    [anon_sym_use_BANG] = ACTIONS(985),
    [anon_sym_do_BANG] = ACTIONS(561),
    [anon_sym_begin] = ACTIONS(565),
    [aux_sym_char_token1] = ACTIONS(569),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(571),
    [anon_sym_DQUOTE] = ACTIONS(573),
    [anon_sym_AT_DQUOTE] = ACTIONS(575),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(577),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(579),
    [sym_bool] = ACTIONS(581),
    [sym_unit] = ACTIONS(2064),
    [anon_sym_LPAREN_PIPE] = ACTIONS(585),
    [sym_op_identifier] = ACTIONS(2066),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(591),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(593),
  },
  [642] = {
    [sym_function_or_value_defn] = STATE(733),
    [sym__expression] = STATE(298),
    [sym_literal_expression] = STATE(2008),
    [sym_long_identifier_or_op] = STATE(2008),
    [sym_tuple_expression] = STATE(2008),
    [sym_brace_expression] = STATE(2008),
    [sym_anon_record_expression] = STATE(2008),
    [sym_prefixed_expression] = STATE(2008),
    [sym_typecast_expression] = STATE(2008),
    [sym_for_expression] = STATE(2008),
    [sym_while_expression] = STATE(2008),
    [sym__if_branch] = STATE(6754),
    [sym_if_expression] = STATE(2008),
    [sym_fun_expression] = STATE(2008),
    [sym_try_expression] = STATE(2008),
    [sym_match_expression] = STATE(2008),
    [sym_function_expression] = STATE(2008),
    [sym_mutate_expression] = STATE(2008),
    [sym_index_expression] = STATE(2008),
    [sym_typed_expression] = STATE(2008),
    [sym_declaration_expression] = STATE(2008),
    [sym_do_expression] = STATE(2008),
    [sym_list_expression] = STATE(2008),
    [sym_array_expression] = STATE(2008),
    [sym_begin_end_expression] = STATE(2008),
    [sym_paren_expression] = STATE(2008),
    [sym__high_prec_app] = STATE(2007),
    [sym__low_prec_app] = STATE(2007),
    [sym_application_expression] = STATE(2008),
    [sym_dot_expression] = STATE(2008),
    [sym_infix_expression] = STATE(2008),
    [sym_ce_expression] = STATE(2008),
    [sym_sequential_expression] = STATE(2008),
    [sym_char] = STATE(1859),
    [sym_format_string] = STATE(1861),
    [sym__string_literal] = STATE(1861),
    [sym_string] = STATE(1859),
    [sym_verbatim_string] = STATE(1859),
    [sym_bytearray] = STATE(1859),
    [sym_verbatim_bytearray] = STATE(1859),
    [sym_format_triple_quoted_string] = STATE(1862),
    [sym_triple_quoted_string] = STATE(1859),
    [sym_const] = STATE(2008),
    [sym_long_identifier] = STATE(1701),
    [sym_active_pattern] = STATE(1702),
    [sym__identifier_or_op] = STATE(1724),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(706),
    [sym_sbyte] = STATE(1859),
    [sym_byte] = STATE(1859),
    [sym_int16] = STATE(1859),
    [sym_uint16] = STATE(1859),
    [sym_int32] = STATE(1859),
    [sym_uint32] = STATE(1859),
    [sym_nativeint] = STATE(1859),
    [sym_unativeint] = STATE(1859),
    [sym_int64] = STATE(1859),
    [sym_uint64] = STATE(1859),
    [sym_ieee32] = STATE(1859),
    [sym_ieee64] = STATE(1859),
    [sym_bignum] = STATE(1859),
    [sym_decimal] = STATE(1859),
    [sym_float] = STATE(1447),
    [sym_block_comment] = STATE(642),
    [sym_compiler_directive_decl] = STATE(642),
    [sym_fsi_directive_decl] = STATE(642),
    [sym_preproc_line] = STATE(642),
    [sym_preproc_if_in_expression] = STATE(2008),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(503),
    [anon_sym_return] = ACTIONS(971),
    [anon_sym_do] = ACTIONS(599),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(511),
    [anon_sym_null] = ACTIONS(515),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(517),
    [anon_sym_LBRACK_PIPE] = ACTIONS(519),
    [anon_sym_LBRACE] = ACTIONS(2060),
    [anon_sym_LT_AT] = ACTIONS(523),
    [anon_sym_LT_AT_AT] = ACTIONS(2062),
    [anon_sym_LBRACE_PIPE] = ACTIONS(529),
    [anon_sym_new] = ACTIONS(971),
    [anon_sym_return_BANG] = ACTIONS(975),
    [anon_sym_yield] = ACTIONS(971),
    [anon_sym_yield_BANG] = ACTIONS(975),
    [anon_sym_lazy] = ACTIONS(971),
    [anon_sym_assert] = ACTIONS(971),
    [anon_sym_upcast] = ACTIONS(971),
    [anon_sym_downcast] = ACTIONS(971),
    [anon_sym_for] = ACTIONS(979),
    [anon_sym_while] = ACTIONS(537),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(539),
    [anon_sym_try] = ACTIONS(543),
    [anon_sym_match] = ACTIONS(545),
    [anon_sym_match_BANG] = ACTIONS(547),
    [anon_sym_function] = ACTIONS(549),
    [anon_sym_use] = ACTIONS(983),
    [anon_sym_use_BANG] = ACTIONS(985),
    [anon_sym_do_BANG] = ACTIONS(561),
    [anon_sym_begin] = ACTIONS(565),
    [aux_sym_char_token1] = ACTIONS(569),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(571),
    [anon_sym_DQUOTE] = ACTIONS(573),
    [anon_sym_AT_DQUOTE] = ACTIONS(575),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(577),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(579),
    [sym_bool] = ACTIONS(581),
    [sym_unit] = ACTIONS(2064),
    [anon_sym_LPAREN_PIPE] = ACTIONS(585),
    [sym_op_identifier] = ACTIONS(2066),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(591),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(593),
  },
  [643] = {
    [sym_function_or_value_defn] = STATE(600),
    [sym__expression] = STATE(186),
    [sym_literal_expression] = STATE(867),
    [sym_long_identifier_or_op] = STATE(867),
    [sym_tuple_expression] = STATE(867),
    [sym_brace_expression] = STATE(867),
    [sym_anon_record_expression] = STATE(867),
    [sym_prefixed_expression] = STATE(867),
    [sym_typecast_expression] = STATE(867),
    [sym_for_expression] = STATE(867),
    [sym_while_expression] = STATE(867),
    [sym__if_branch] = STATE(6511),
    [sym_if_expression] = STATE(867),
    [sym_fun_expression] = STATE(867),
    [sym_try_expression] = STATE(867),
    [sym_match_expression] = STATE(867),
    [sym_function_expression] = STATE(867),
    [sym_mutate_expression] = STATE(867),
    [sym_index_expression] = STATE(867),
    [sym_typed_expression] = STATE(867),
    [sym_declaration_expression] = STATE(867),
    [sym_do_expression] = STATE(867),
    [sym_list_expression] = STATE(867),
    [sym_array_expression] = STATE(867),
    [sym_begin_end_expression] = STATE(867),
    [sym_paren_expression] = STATE(867),
    [sym__high_prec_app] = STATE(864),
    [sym__low_prec_app] = STATE(864),
    [sym_application_expression] = STATE(867),
    [sym_dot_expression] = STATE(867),
    [sym_infix_expression] = STATE(867),
    [sym_ce_expression] = STATE(867),
    [sym_sequential_expression] = STATE(867),
    [sym_char] = STATE(868),
    [sym_format_string] = STATE(869),
    [sym__string_literal] = STATE(869),
    [sym_string] = STATE(868),
    [sym_verbatim_string] = STATE(868),
    [sym_bytearray] = STATE(868),
    [sym_verbatim_bytearray] = STATE(868),
    [sym_format_triple_quoted_string] = STATE(870),
    [sym_triple_quoted_string] = STATE(868),
    [sym_const] = STATE(867),
    [sym_long_identifier] = STATE(872),
    [sym_active_pattern] = STATE(871),
    [sym__identifier_or_op] = STATE(873),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(656),
    [sym_sbyte] = STATE(868),
    [sym_byte] = STATE(868),
    [sym_int16] = STATE(868),
    [sym_uint16] = STATE(868),
    [sym_int32] = STATE(868),
    [sym_uint32] = STATE(868),
    [sym_nativeint] = STATE(868),
    [sym_unativeint] = STATE(868),
    [sym_int64] = STATE(868),
    [sym_uint64] = STATE(868),
    [sym_ieee32] = STATE(868),
    [sym_ieee64] = STATE(868),
    [sym_bignum] = STATE(868),
    [sym_decimal] = STATE(868),
    [sym_float] = STATE(1368),
    [sym_block_comment] = STATE(643),
    [sym_compiler_directive_decl] = STATE(643),
    [sym_fsi_directive_decl] = STATE(643),
    [sym_preproc_line] = STATE(643),
    [sym_preproc_if_in_expression] = STATE(867),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(29),
    [anon_sym_return] = ACTIONS(825),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_null] = ACTIONS(49),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACK_PIPE] = ACTIONS(57),
    [anon_sym_LBRACE] = ACTIONS(1663),
    [anon_sym_LT_AT] = ACTIONS(61),
    [anon_sym_LT_AT_AT] = ACTIONS(1665),
    [anon_sym_LBRACE_PIPE] = ACTIONS(67),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_return_BANG] = ACTIONS(829),
    [anon_sym_yield] = ACTIONS(825),
    [anon_sym_yield_BANG] = ACTIONS(829),
    [anon_sym_lazy] = ACTIONS(825),
    [anon_sym_assert] = ACTIONS(825),
    [anon_sym_upcast] = ACTIONS(825),
    [anon_sym_downcast] = ACTIONS(825),
    [anon_sym_for] = ACTIONS(73),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(79),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_match] = ACTIONS(83),
    [anon_sym_match_BANG] = ACTIONS(85),
    [anon_sym_function] = ACTIONS(87),
    [anon_sym_use] = ACTIONS(833),
    [anon_sym_use_BANG] = ACTIONS(835),
    [anon_sym_do_BANG] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(101),
    [aux_sym_char_token1] = ACTIONS(105),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(107),
    [anon_sym_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DQUOTE] = ACTIONS(111),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(115),
    [sym_bool] = ACTIONS(117),
    [sym_unit] = ACTIONS(1673),
    [anon_sym_LPAREN_PIPE] = ACTIONS(121),
    [sym_op_identifier] = ACTIONS(1675),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(837),
    [sym_xint] = ACTIONS(387),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(135),
  },
  [644] = {
    [sym_function_or_value_defn] = STATE(627),
    [sym__expression] = STATE(342),
    [sym_literal_expression] = STATE(1118),
    [sym_long_identifier_or_op] = STATE(1118),
    [sym_tuple_expression] = STATE(1118),
    [sym_brace_expression] = STATE(1118),
    [sym_anon_record_expression] = STATE(1118),
    [sym_prefixed_expression] = STATE(1118),
    [sym_typecast_expression] = STATE(1118),
    [sym_for_expression] = STATE(1118),
    [sym_while_expression] = STATE(1118),
    [sym__if_branch] = STATE(7163),
    [sym_if_expression] = STATE(1118),
    [sym_fun_expression] = STATE(1118),
    [sym_try_expression] = STATE(1118),
    [sym_match_expression] = STATE(1118),
    [sym_function_expression] = STATE(1118),
    [sym_mutate_expression] = STATE(1118),
    [sym_index_expression] = STATE(1118),
    [sym_typed_expression] = STATE(1118),
    [sym_declaration_expression] = STATE(1118),
    [sym_do_expression] = STATE(1118),
    [sym_list_expression] = STATE(1118),
    [sym_array_expression] = STATE(1118),
    [sym_begin_end_expression] = STATE(1118),
    [sym_paren_expression] = STATE(1118),
    [sym__high_prec_app] = STATE(1133),
    [sym__low_prec_app] = STATE(1133),
    [sym_application_expression] = STATE(1118),
    [sym_dot_expression] = STATE(1118),
    [sym_infix_expression] = STATE(1118),
    [sym_ce_expression] = STATE(1118),
    [sym_sequential_expression] = STATE(1118),
    [sym_char] = STATE(1080),
    [sym_format_string] = STATE(1090),
    [sym__string_literal] = STATE(1090),
    [sym_string] = STATE(1080),
    [sym_verbatim_string] = STATE(1080),
    [sym_bytearray] = STATE(1080),
    [sym_verbatim_bytearray] = STATE(1080),
    [sym_format_triple_quoted_string] = STATE(1096),
    [sym_triple_quoted_string] = STATE(1080),
    [sym_const] = STATE(1118),
    [sym_long_identifier] = STATE(1156),
    [sym_active_pattern] = STATE(1085),
    [sym__identifier_or_op] = STATE(1099),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(517),
    [sym_sbyte] = STATE(1080),
    [sym_byte] = STATE(1080),
    [sym_int16] = STATE(1080),
    [sym_uint16] = STATE(1080),
    [sym_int32] = STATE(1080),
    [sym_uint32] = STATE(1080),
    [sym_nativeint] = STATE(1080),
    [sym_unativeint] = STATE(1080),
    [sym_int64] = STATE(1080),
    [sym_uint64] = STATE(1080),
    [sym_ieee32] = STATE(1080),
    [sym_ieee64] = STATE(1080),
    [sym_bignum] = STATE(1080),
    [sym_decimal] = STATE(1080),
    [sym_float] = STATE(979),
    [sym_block_comment] = STATE(644),
    [sym_compiler_directive_decl] = STATE(644),
    [sym_fsi_directive_decl] = STATE(644),
    [sym_preproc_line] = STATE(644),
    [sym_preproc_if_in_expression] = STATE(1118),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(195),
    [anon_sym_return] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_null] = ACTIONS(207),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(209),
    [anon_sym_LBRACK_PIPE] = ACTIONS(211),
    [anon_sym_LBRACE] = ACTIONS(1687),
    [anon_sym_LT_AT] = ACTIONS(213),
    [anon_sym_LT_AT_AT] = ACTIONS(1689),
    [anon_sym_LBRACE_PIPE] = ACTIONS(217),
    [anon_sym_new] = ACTIONS(199),
    [anon_sym_return_BANG] = ACTIONS(219),
    [anon_sym_yield] = ACTIONS(199),
    [anon_sym_yield_BANG] = ACTIONS(219),
    [anon_sym_lazy] = ACTIONS(199),
    [anon_sym_assert] = ACTIONS(199),
    [anon_sym_upcast] = ACTIONS(199),
    [anon_sym_downcast] = ACTIONS(199),
    [anon_sym_for] = ACTIONS(223),
    [anon_sym_while] = ACTIONS(225),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(229),
    [anon_sym_match] = ACTIONS(231),
    [anon_sym_match_BANG] = ACTIONS(233),
    [anon_sym_function] = ACTIONS(235),
    [anon_sym_use] = ACTIONS(239),
    [anon_sym_use_BANG] = ACTIONS(241),
    [anon_sym_do_BANG] = ACTIONS(243),
    [anon_sym_begin] = ACTIONS(245),
    [aux_sym_char_token1] = ACTIONS(247),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(251),
    [anon_sym_AT_DQUOTE] = ACTIONS(253),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(255),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(257),
    [sym_bool] = ACTIONS(259),
    [sym_unit] = ACTIONS(1699),
    [anon_sym_LPAREN_PIPE] = ACTIONS(261),
    [sym_op_identifier] = ACTIONS(1701),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(265),
    [sym_xint] = ACTIONS(267),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(269),
  },
  [645] = {
    [sym_function_or_value_defn] = STATE(733),
    [sym__expression] = STATE(140),
    [sym_literal_expression] = STATE(2008),
    [sym_long_identifier_or_op] = STATE(2008),
    [sym_tuple_expression] = STATE(2008),
    [sym_brace_expression] = STATE(2008),
    [sym_anon_record_expression] = STATE(2008),
    [sym_prefixed_expression] = STATE(2008),
    [sym_typecast_expression] = STATE(2008),
    [sym_for_expression] = STATE(2008),
    [sym_while_expression] = STATE(2008),
    [sym__if_branch] = STATE(6754),
    [sym_if_expression] = STATE(2008),
    [sym_fun_expression] = STATE(2008),
    [sym_try_expression] = STATE(2008),
    [sym_match_expression] = STATE(2008),
    [sym_function_expression] = STATE(2008),
    [sym_mutate_expression] = STATE(2008),
    [sym_index_expression] = STATE(2008),
    [sym_typed_expression] = STATE(2008),
    [sym_declaration_expression] = STATE(2008),
    [sym_do_expression] = STATE(2008),
    [sym_list_expression] = STATE(2008),
    [sym_array_expression] = STATE(2008),
    [sym_begin_end_expression] = STATE(2008),
    [sym_paren_expression] = STATE(2008),
    [sym__high_prec_app] = STATE(2007),
    [sym__low_prec_app] = STATE(2007),
    [sym_application_expression] = STATE(2008),
    [sym_dot_expression] = STATE(2008),
    [sym_infix_expression] = STATE(2008),
    [sym_ce_expression] = STATE(2008),
    [sym_sequential_expression] = STATE(2008),
    [sym_char] = STATE(1859),
    [sym_format_string] = STATE(1861),
    [sym__string_literal] = STATE(1861),
    [sym_string] = STATE(1859),
    [sym_verbatim_string] = STATE(1859),
    [sym_bytearray] = STATE(1859),
    [sym_verbatim_bytearray] = STATE(1859),
    [sym_format_triple_quoted_string] = STATE(1862),
    [sym_triple_quoted_string] = STATE(1859),
    [sym_const] = STATE(2008),
    [sym_long_identifier] = STATE(1701),
    [sym_active_pattern] = STATE(1702),
    [sym__identifier_or_op] = STATE(1724),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(706),
    [sym_sbyte] = STATE(1859),
    [sym_byte] = STATE(1859),
    [sym_int16] = STATE(1859),
    [sym_uint16] = STATE(1859),
    [sym_int32] = STATE(1859),
    [sym_uint32] = STATE(1859),
    [sym_nativeint] = STATE(1859),
    [sym_unativeint] = STATE(1859),
    [sym_int64] = STATE(1859),
    [sym_uint64] = STATE(1859),
    [sym_ieee32] = STATE(1859),
    [sym_ieee64] = STATE(1859),
    [sym_bignum] = STATE(1859),
    [sym_decimal] = STATE(1859),
    [sym_float] = STATE(1447),
    [sym_block_comment] = STATE(645),
    [sym_compiler_directive_decl] = STATE(645),
    [sym_fsi_directive_decl] = STATE(645),
    [sym_preproc_line] = STATE(645),
    [sym_preproc_if_in_expression] = STATE(2008),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(503),
    [anon_sym_return] = ACTIONS(971),
    [anon_sym_do] = ACTIONS(599),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(511),
    [anon_sym_null] = ACTIONS(515),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(517),
    [anon_sym_LBRACK_PIPE] = ACTIONS(519),
    [anon_sym_LBRACE] = ACTIONS(2060),
    [anon_sym_LT_AT] = ACTIONS(523),
    [anon_sym_LT_AT_AT] = ACTIONS(2062),
    [anon_sym_LBRACE_PIPE] = ACTIONS(529),
    [anon_sym_new] = ACTIONS(971),
    [anon_sym_return_BANG] = ACTIONS(975),
    [anon_sym_yield] = ACTIONS(971),
    [anon_sym_yield_BANG] = ACTIONS(975),
    [anon_sym_lazy] = ACTIONS(971),
    [anon_sym_assert] = ACTIONS(971),
    [anon_sym_upcast] = ACTIONS(971),
    [anon_sym_downcast] = ACTIONS(971),
    [anon_sym_for] = ACTIONS(979),
    [anon_sym_while] = ACTIONS(537),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(539),
    [anon_sym_try] = ACTIONS(543),
    [anon_sym_match] = ACTIONS(545),
    [anon_sym_match_BANG] = ACTIONS(547),
    [anon_sym_function] = ACTIONS(549),
    [anon_sym_use] = ACTIONS(983),
    [anon_sym_use_BANG] = ACTIONS(985),
    [anon_sym_do_BANG] = ACTIONS(561),
    [anon_sym_begin] = ACTIONS(565),
    [aux_sym_char_token1] = ACTIONS(569),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(571),
    [anon_sym_DQUOTE] = ACTIONS(573),
    [anon_sym_AT_DQUOTE] = ACTIONS(575),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(577),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(579),
    [sym_bool] = ACTIONS(581),
    [sym_unit] = ACTIONS(2064),
    [anon_sym_LPAREN_PIPE] = ACTIONS(585),
    [sym_op_identifier] = ACTIONS(2066),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(591),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(593),
  },
  [646] = {
    [sym_function_or_value_defn] = STATE(627),
    [sym__expression] = STATE(338),
    [sym_literal_expression] = STATE(1118),
    [sym_long_identifier_or_op] = STATE(1118),
    [sym_tuple_expression] = STATE(1118),
    [sym_brace_expression] = STATE(1118),
    [sym_anon_record_expression] = STATE(1118),
    [sym_prefixed_expression] = STATE(1118),
    [sym_typecast_expression] = STATE(1118),
    [sym_for_expression] = STATE(1118),
    [sym_while_expression] = STATE(1118),
    [sym__if_branch] = STATE(7163),
    [sym_if_expression] = STATE(1118),
    [sym_fun_expression] = STATE(1118),
    [sym_try_expression] = STATE(1118),
    [sym_match_expression] = STATE(1118),
    [sym_function_expression] = STATE(1118),
    [sym_mutate_expression] = STATE(1118),
    [sym_index_expression] = STATE(1118),
    [sym_typed_expression] = STATE(1118),
    [sym_declaration_expression] = STATE(1118),
    [sym_do_expression] = STATE(1118),
    [sym_list_expression] = STATE(1118),
    [sym_array_expression] = STATE(1118),
    [sym_begin_end_expression] = STATE(1118),
    [sym_paren_expression] = STATE(1118),
    [sym__high_prec_app] = STATE(1133),
    [sym__low_prec_app] = STATE(1133),
    [sym_application_expression] = STATE(1118),
    [sym_dot_expression] = STATE(1118),
    [sym_infix_expression] = STATE(1118),
    [sym_ce_expression] = STATE(1118),
    [sym_sequential_expression] = STATE(1118),
    [sym_char] = STATE(1080),
    [sym_format_string] = STATE(1090),
    [sym__string_literal] = STATE(1090),
    [sym_string] = STATE(1080),
    [sym_verbatim_string] = STATE(1080),
    [sym_bytearray] = STATE(1080),
    [sym_verbatim_bytearray] = STATE(1080),
    [sym_format_triple_quoted_string] = STATE(1096),
    [sym_triple_quoted_string] = STATE(1080),
    [sym_const] = STATE(1118),
    [sym_long_identifier] = STATE(1156),
    [sym_active_pattern] = STATE(1085),
    [sym__identifier_or_op] = STATE(1099),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(517),
    [sym_sbyte] = STATE(1080),
    [sym_byte] = STATE(1080),
    [sym_int16] = STATE(1080),
    [sym_uint16] = STATE(1080),
    [sym_int32] = STATE(1080),
    [sym_uint32] = STATE(1080),
    [sym_nativeint] = STATE(1080),
    [sym_unativeint] = STATE(1080),
    [sym_int64] = STATE(1080),
    [sym_uint64] = STATE(1080),
    [sym_ieee32] = STATE(1080),
    [sym_ieee64] = STATE(1080),
    [sym_bignum] = STATE(1080),
    [sym_decimal] = STATE(1080),
    [sym_float] = STATE(979),
    [sym_block_comment] = STATE(646),
    [sym_compiler_directive_decl] = STATE(646),
    [sym_fsi_directive_decl] = STATE(646),
    [sym_preproc_line] = STATE(646),
    [sym_preproc_if_in_expression] = STATE(1118),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(195),
    [anon_sym_return] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_null] = ACTIONS(207),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(209),
    [anon_sym_LBRACK_PIPE] = ACTIONS(211),
    [anon_sym_LBRACE] = ACTIONS(1687),
    [anon_sym_LT_AT] = ACTIONS(213),
    [anon_sym_LT_AT_AT] = ACTIONS(1689),
    [anon_sym_LBRACE_PIPE] = ACTIONS(217),
    [anon_sym_new] = ACTIONS(199),
    [anon_sym_return_BANG] = ACTIONS(219),
    [anon_sym_yield] = ACTIONS(199),
    [anon_sym_yield_BANG] = ACTIONS(219),
    [anon_sym_lazy] = ACTIONS(199),
    [anon_sym_assert] = ACTIONS(199),
    [anon_sym_upcast] = ACTIONS(199),
    [anon_sym_downcast] = ACTIONS(199),
    [anon_sym_for] = ACTIONS(223),
    [anon_sym_while] = ACTIONS(225),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(229),
    [anon_sym_match] = ACTIONS(231),
    [anon_sym_match_BANG] = ACTIONS(233),
    [anon_sym_function] = ACTIONS(235),
    [anon_sym_use] = ACTIONS(239),
    [anon_sym_use_BANG] = ACTIONS(241),
    [anon_sym_do_BANG] = ACTIONS(243),
    [anon_sym_begin] = ACTIONS(245),
    [aux_sym_char_token1] = ACTIONS(247),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(251),
    [anon_sym_AT_DQUOTE] = ACTIONS(253),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(255),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(257),
    [sym_bool] = ACTIONS(259),
    [sym_unit] = ACTIONS(1699),
    [anon_sym_LPAREN_PIPE] = ACTIONS(261),
    [sym_op_identifier] = ACTIONS(1701),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(265),
    [sym_xint] = ACTIONS(267),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(269),
  },
  [647] = {
    [sym_function_or_value_defn] = STATE(733),
    [sym__expression] = STATE(267),
    [sym_literal_expression] = STATE(2008),
    [sym_long_identifier_or_op] = STATE(2008),
    [sym_tuple_expression] = STATE(2008),
    [sym_brace_expression] = STATE(2008),
    [sym_anon_record_expression] = STATE(2008),
    [sym_prefixed_expression] = STATE(2008),
    [sym_typecast_expression] = STATE(2008),
    [sym_for_expression] = STATE(2008),
    [sym_while_expression] = STATE(2008),
    [sym__if_branch] = STATE(6754),
    [sym_if_expression] = STATE(2008),
    [sym_fun_expression] = STATE(2008),
    [sym_try_expression] = STATE(2008),
    [sym_match_expression] = STATE(2008),
    [sym_function_expression] = STATE(2008),
    [sym_mutate_expression] = STATE(2008),
    [sym_index_expression] = STATE(2008),
    [sym_typed_expression] = STATE(2008),
    [sym_declaration_expression] = STATE(2008),
    [sym_do_expression] = STATE(2008),
    [sym_list_expression] = STATE(2008),
    [sym_array_expression] = STATE(2008),
    [sym_begin_end_expression] = STATE(2008),
    [sym_paren_expression] = STATE(2008),
    [sym__high_prec_app] = STATE(2007),
    [sym__low_prec_app] = STATE(2007),
    [sym_application_expression] = STATE(2008),
    [sym_dot_expression] = STATE(2008),
    [sym_infix_expression] = STATE(2008),
    [sym_ce_expression] = STATE(2008),
    [sym_sequential_expression] = STATE(2008),
    [sym_char] = STATE(1859),
    [sym_format_string] = STATE(1861),
    [sym__string_literal] = STATE(1861),
    [sym_string] = STATE(1859),
    [sym_verbatim_string] = STATE(1859),
    [sym_bytearray] = STATE(1859),
    [sym_verbatim_bytearray] = STATE(1859),
    [sym_format_triple_quoted_string] = STATE(1862),
    [sym_triple_quoted_string] = STATE(1859),
    [sym_const] = STATE(2008),
    [sym_long_identifier] = STATE(1701),
    [sym_active_pattern] = STATE(1702),
    [sym__identifier_or_op] = STATE(1724),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(706),
    [sym_sbyte] = STATE(1859),
    [sym_byte] = STATE(1859),
    [sym_int16] = STATE(1859),
    [sym_uint16] = STATE(1859),
    [sym_int32] = STATE(1859),
    [sym_uint32] = STATE(1859),
    [sym_nativeint] = STATE(1859),
    [sym_unativeint] = STATE(1859),
    [sym_int64] = STATE(1859),
    [sym_uint64] = STATE(1859),
    [sym_ieee32] = STATE(1859),
    [sym_ieee64] = STATE(1859),
    [sym_bignum] = STATE(1859),
    [sym_decimal] = STATE(1859),
    [sym_float] = STATE(1447),
    [sym_block_comment] = STATE(647),
    [sym_compiler_directive_decl] = STATE(647),
    [sym_fsi_directive_decl] = STATE(647),
    [sym_preproc_line] = STATE(647),
    [sym_preproc_if_in_expression] = STATE(2008),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(503),
    [anon_sym_return] = ACTIONS(971),
    [anon_sym_do] = ACTIONS(599),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(511),
    [anon_sym_null] = ACTIONS(515),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(517),
    [anon_sym_LBRACK_PIPE] = ACTIONS(519),
    [anon_sym_LBRACE] = ACTIONS(2060),
    [anon_sym_LT_AT] = ACTIONS(523),
    [anon_sym_LT_AT_AT] = ACTIONS(2062),
    [anon_sym_LBRACE_PIPE] = ACTIONS(529),
    [anon_sym_new] = ACTIONS(971),
    [anon_sym_return_BANG] = ACTIONS(975),
    [anon_sym_yield] = ACTIONS(971),
    [anon_sym_yield_BANG] = ACTIONS(975),
    [anon_sym_lazy] = ACTIONS(971),
    [anon_sym_assert] = ACTIONS(971),
    [anon_sym_upcast] = ACTIONS(971),
    [anon_sym_downcast] = ACTIONS(971),
    [anon_sym_for] = ACTIONS(979),
    [anon_sym_while] = ACTIONS(537),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(539),
    [anon_sym_try] = ACTIONS(543),
    [anon_sym_match] = ACTIONS(545),
    [anon_sym_match_BANG] = ACTIONS(547),
    [anon_sym_function] = ACTIONS(549),
    [anon_sym_use] = ACTIONS(983),
    [anon_sym_use_BANG] = ACTIONS(985),
    [anon_sym_do_BANG] = ACTIONS(561),
    [anon_sym_begin] = ACTIONS(565),
    [aux_sym_char_token1] = ACTIONS(569),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(571),
    [anon_sym_DQUOTE] = ACTIONS(573),
    [anon_sym_AT_DQUOTE] = ACTIONS(575),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(577),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(579),
    [sym_bool] = ACTIONS(581),
    [sym_unit] = ACTIONS(2064),
    [anon_sym_LPAREN_PIPE] = ACTIONS(585),
    [sym_op_identifier] = ACTIONS(2066),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(591),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(593),
  },
  [648] = {
    [sym_function_or_value_defn] = STATE(627),
    [sym__expression] = STATE(337),
    [sym_literal_expression] = STATE(1118),
    [sym_long_identifier_or_op] = STATE(1118),
    [sym_tuple_expression] = STATE(1118),
    [sym_brace_expression] = STATE(1118),
    [sym_anon_record_expression] = STATE(1118),
    [sym_prefixed_expression] = STATE(1118),
    [sym_typecast_expression] = STATE(1118),
    [sym_for_expression] = STATE(1118),
    [sym_while_expression] = STATE(1118),
    [sym__if_branch] = STATE(7163),
    [sym_if_expression] = STATE(1118),
    [sym_fun_expression] = STATE(1118),
    [sym_try_expression] = STATE(1118),
    [sym_match_expression] = STATE(1118),
    [sym_function_expression] = STATE(1118),
    [sym_mutate_expression] = STATE(1118),
    [sym_index_expression] = STATE(1118),
    [sym_typed_expression] = STATE(1118),
    [sym_declaration_expression] = STATE(1118),
    [sym_do_expression] = STATE(1118),
    [sym_list_expression] = STATE(1118),
    [sym_array_expression] = STATE(1118),
    [sym_begin_end_expression] = STATE(1118),
    [sym_paren_expression] = STATE(1118),
    [sym__high_prec_app] = STATE(1133),
    [sym__low_prec_app] = STATE(1133),
    [sym_application_expression] = STATE(1118),
    [sym_dot_expression] = STATE(1118),
    [sym_infix_expression] = STATE(1118),
    [sym_ce_expression] = STATE(1118),
    [sym_sequential_expression] = STATE(1118),
    [sym_char] = STATE(1080),
    [sym_format_string] = STATE(1090),
    [sym__string_literal] = STATE(1090),
    [sym_string] = STATE(1080),
    [sym_verbatim_string] = STATE(1080),
    [sym_bytearray] = STATE(1080),
    [sym_verbatim_bytearray] = STATE(1080),
    [sym_format_triple_quoted_string] = STATE(1096),
    [sym_triple_quoted_string] = STATE(1080),
    [sym_const] = STATE(1118),
    [sym_long_identifier] = STATE(1156),
    [sym_active_pattern] = STATE(1085),
    [sym__identifier_or_op] = STATE(1099),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(517),
    [sym_sbyte] = STATE(1080),
    [sym_byte] = STATE(1080),
    [sym_int16] = STATE(1080),
    [sym_uint16] = STATE(1080),
    [sym_int32] = STATE(1080),
    [sym_uint32] = STATE(1080),
    [sym_nativeint] = STATE(1080),
    [sym_unativeint] = STATE(1080),
    [sym_int64] = STATE(1080),
    [sym_uint64] = STATE(1080),
    [sym_ieee32] = STATE(1080),
    [sym_ieee64] = STATE(1080),
    [sym_bignum] = STATE(1080),
    [sym_decimal] = STATE(1080),
    [sym_float] = STATE(979),
    [sym_block_comment] = STATE(648),
    [sym_compiler_directive_decl] = STATE(648),
    [sym_fsi_directive_decl] = STATE(648),
    [sym_preproc_line] = STATE(648),
    [sym_preproc_if_in_expression] = STATE(1118),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(195),
    [anon_sym_return] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_null] = ACTIONS(207),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(209),
    [anon_sym_LBRACK_PIPE] = ACTIONS(211),
    [anon_sym_LBRACE] = ACTIONS(1687),
    [anon_sym_LT_AT] = ACTIONS(213),
    [anon_sym_LT_AT_AT] = ACTIONS(1689),
    [anon_sym_LBRACE_PIPE] = ACTIONS(217),
    [anon_sym_new] = ACTIONS(199),
    [anon_sym_return_BANG] = ACTIONS(219),
    [anon_sym_yield] = ACTIONS(199),
    [anon_sym_yield_BANG] = ACTIONS(219),
    [anon_sym_lazy] = ACTIONS(199),
    [anon_sym_assert] = ACTIONS(199),
    [anon_sym_upcast] = ACTIONS(199),
    [anon_sym_downcast] = ACTIONS(199),
    [anon_sym_for] = ACTIONS(223),
    [anon_sym_while] = ACTIONS(225),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(229),
    [anon_sym_match] = ACTIONS(231),
    [anon_sym_match_BANG] = ACTIONS(233),
    [anon_sym_function] = ACTIONS(235),
    [anon_sym_use] = ACTIONS(239),
    [anon_sym_use_BANG] = ACTIONS(241),
    [anon_sym_do_BANG] = ACTIONS(243),
    [anon_sym_begin] = ACTIONS(245),
    [aux_sym_char_token1] = ACTIONS(247),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(251),
    [anon_sym_AT_DQUOTE] = ACTIONS(253),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(255),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(257),
    [sym_bool] = ACTIONS(259),
    [sym_unit] = ACTIONS(1699),
    [anon_sym_LPAREN_PIPE] = ACTIONS(261),
    [sym_op_identifier] = ACTIONS(1701),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(265),
    [sym_xint] = ACTIONS(267),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(269),
  },
  [649] = {
    [sym_function_or_value_defn] = STATE(733),
    [sym__expression] = STATE(287),
    [sym_literal_expression] = STATE(2008),
    [sym_long_identifier_or_op] = STATE(2008),
    [sym_tuple_expression] = STATE(2008),
    [sym_brace_expression] = STATE(2008),
    [sym_anon_record_expression] = STATE(2008),
    [sym_prefixed_expression] = STATE(2008),
    [sym_typecast_expression] = STATE(2008),
    [sym_for_expression] = STATE(2008),
    [sym_while_expression] = STATE(2008),
    [sym__if_branch] = STATE(6754),
    [sym_if_expression] = STATE(2008),
    [sym_fun_expression] = STATE(2008),
    [sym_try_expression] = STATE(2008),
    [sym_match_expression] = STATE(2008),
    [sym_function_expression] = STATE(2008),
    [sym_mutate_expression] = STATE(2008),
    [sym_index_expression] = STATE(2008),
    [sym_typed_expression] = STATE(2008),
    [sym_declaration_expression] = STATE(2008),
    [sym_do_expression] = STATE(2008),
    [sym_list_expression] = STATE(2008),
    [sym_array_expression] = STATE(2008),
    [sym_begin_end_expression] = STATE(2008),
    [sym_paren_expression] = STATE(2008),
    [sym__high_prec_app] = STATE(2007),
    [sym__low_prec_app] = STATE(2007),
    [sym_application_expression] = STATE(2008),
    [sym_dot_expression] = STATE(2008),
    [sym_infix_expression] = STATE(2008),
    [sym_ce_expression] = STATE(2008),
    [sym_sequential_expression] = STATE(2008),
    [sym_char] = STATE(1859),
    [sym_format_string] = STATE(1861),
    [sym__string_literal] = STATE(1861),
    [sym_string] = STATE(1859),
    [sym_verbatim_string] = STATE(1859),
    [sym_bytearray] = STATE(1859),
    [sym_verbatim_bytearray] = STATE(1859),
    [sym_format_triple_quoted_string] = STATE(1862),
    [sym_triple_quoted_string] = STATE(1859),
    [sym_const] = STATE(2008),
    [sym_long_identifier] = STATE(1701),
    [sym_active_pattern] = STATE(1702),
    [sym__identifier_or_op] = STATE(1724),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(706),
    [sym_sbyte] = STATE(1859),
    [sym_byte] = STATE(1859),
    [sym_int16] = STATE(1859),
    [sym_uint16] = STATE(1859),
    [sym_int32] = STATE(1859),
    [sym_uint32] = STATE(1859),
    [sym_nativeint] = STATE(1859),
    [sym_unativeint] = STATE(1859),
    [sym_int64] = STATE(1859),
    [sym_uint64] = STATE(1859),
    [sym_ieee32] = STATE(1859),
    [sym_ieee64] = STATE(1859),
    [sym_bignum] = STATE(1859),
    [sym_decimal] = STATE(1859),
    [sym_float] = STATE(1447),
    [sym_block_comment] = STATE(649),
    [sym_compiler_directive_decl] = STATE(649),
    [sym_fsi_directive_decl] = STATE(649),
    [sym_preproc_line] = STATE(649),
    [sym_preproc_if_in_expression] = STATE(2008),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(503),
    [anon_sym_return] = ACTIONS(971),
    [anon_sym_do] = ACTIONS(599),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(511),
    [anon_sym_null] = ACTIONS(515),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(517),
    [anon_sym_LBRACK_PIPE] = ACTIONS(519),
    [anon_sym_LBRACE] = ACTIONS(2060),
    [anon_sym_LT_AT] = ACTIONS(523),
    [anon_sym_LT_AT_AT] = ACTIONS(2062),
    [anon_sym_LBRACE_PIPE] = ACTIONS(529),
    [anon_sym_new] = ACTIONS(971),
    [anon_sym_return_BANG] = ACTIONS(975),
    [anon_sym_yield] = ACTIONS(971),
    [anon_sym_yield_BANG] = ACTIONS(975),
    [anon_sym_lazy] = ACTIONS(971),
    [anon_sym_assert] = ACTIONS(971),
    [anon_sym_upcast] = ACTIONS(971),
    [anon_sym_downcast] = ACTIONS(971),
    [anon_sym_for] = ACTIONS(979),
    [anon_sym_while] = ACTIONS(537),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(539),
    [anon_sym_try] = ACTIONS(543),
    [anon_sym_match] = ACTIONS(545),
    [anon_sym_match_BANG] = ACTIONS(547),
    [anon_sym_function] = ACTIONS(549),
    [anon_sym_use] = ACTIONS(983),
    [anon_sym_use_BANG] = ACTIONS(985),
    [anon_sym_do_BANG] = ACTIONS(561),
    [anon_sym_begin] = ACTIONS(565),
    [aux_sym_char_token1] = ACTIONS(569),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(571),
    [anon_sym_DQUOTE] = ACTIONS(573),
    [anon_sym_AT_DQUOTE] = ACTIONS(575),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(577),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(579),
    [sym_bool] = ACTIONS(581),
    [sym_unit] = ACTIONS(2064),
    [anon_sym_LPAREN_PIPE] = ACTIONS(585),
    [sym_op_identifier] = ACTIONS(2066),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(591),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(593),
  },
  [650] = {
    [sym_function_or_value_defn] = STATE(651),
    [sym__expression] = STATE(165),
    [sym_literal_expression] = STATE(2168),
    [sym_long_identifier_or_op] = STATE(2168),
    [sym_tuple_expression] = STATE(2168),
    [sym_brace_expression] = STATE(2168),
    [sym_anon_record_expression] = STATE(2168),
    [sym_prefixed_expression] = STATE(2168),
    [sym_typecast_expression] = STATE(2168),
    [sym_for_expression] = STATE(2168),
    [sym_while_expression] = STATE(2168),
    [sym__if_branch] = STATE(6406),
    [sym_if_expression] = STATE(2168),
    [sym_fun_expression] = STATE(2168),
    [sym_try_expression] = STATE(2168),
    [sym_match_expression] = STATE(2168),
    [sym_function_expression] = STATE(2168),
    [sym_mutate_expression] = STATE(2168),
    [sym_index_expression] = STATE(2168),
    [sym_typed_expression] = STATE(2168),
    [sym_declaration_expression] = STATE(2168),
    [sym_do_expression] = STATE(2168),
    [sym_list_expression] = STATE(2168),
    [sym_array_expression] = STATE(2168),
    [sym_begin_end_expression] = STATE(2168),
    [sym_paren_expression] = STATE(2168),
    [sym__high_prec_app] = STATE(2179),
    [sym__low_prec_app] = STATE(2179),
    [sym_application_expression] = STATE(2168),
    [sym_dot_expression] = STATE(2168),
    [sym_infix_expression] = STATE(2168),
    [sym_ce_expression] = STATE(2168),
    [sym_sequential_expression] = STATE(2168),
    [sym_char] = STATE(2469),
    [sym_format_string] = STATE(2412),
    [sym__string_literal] = STATE(2412),
    [sym_string] = STATE(2469),
    [sym_verbatim_string] = STATE(2469),
    [sym_bytearray] = STATE(2469),
    [sym_verbatim_bytearray] = STATE(2469),
    [sym_format_triple_quoted_string] = STATE(2408),
    [sym_triple_quoted_string] = STATE(2469),
    [sym_const] = STATE(2168),
    [sym_long_identifier] = STATE(2183),
    [sym_active_pattern] = STATE(2182),
    [sym__identifier_or_op] = STATE(2093),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(650),
    [sym_sbyte] = STATE(2469),
    [sym_byte] = STATE(2469),
    [sym_int16] = STATE(2469),
    [sym_uint16] = STATE(2469),
    [sym_int32] = STATE(2469),
    [sym_uint32] = STATE(2469),
    [sym_nativeint] = STATE(2469),
    [sym_unativeint] = STATE(2469),
    [sym_int64] = STATE(2469),
    [sym_uint64] = STATE(2469),
    [sym_ieee32] = STATE(2469),
    [sym_ieee64] = STATE(2469),
    [sym_bignum] = STATE(2469),
    [sym_decimal] = STATE(2469),
    [sym_float] = STATE(1586),
    [sym_block_comment] = STATE(650),
    [sym_compiler_directive_decl] = STATE(650),
    [sym_fsi_directive_decl] = STATE(650),
    [sym_preproc_line] = STATE(650),
    [sym_preproc_if_in_expression] = STATE(2168),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(989),
    [anon_sym_return] = ACTIONS(993),
    [anon_sym_do] = ACTIONS(995),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(997),
    [anon_sym_null] = ACTIONS(1001),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1003),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1005),
    [anon_sym_LBRACE] = ACTIONS(2070),
    [anon_sym_LT_AT] = ACTIONS(1009),
    [anon_sym_LT_AT_AT] = ACTIONS(2072),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1017),
    [anon_sym_new] = ACTIONS(993),
    [anon_sym_return_BANG] = ACTIONS(1019),
    [anon_sym_yield] = ACTIONS(993),
    [anon_sym_yield_BANG] = ACTIONS(1019),
    [anon_sym_lazy] = ACTIONS(993),
    [anon_sym_assert] = ACTIONS(993),
    [anon_sym_upcast] = ACTIONS(993),
    [anon_sym_downcast] = ACTIONS(993),
    [anon_sym_for] = ACTIONS(1023),
    [anon_sym_while] = ACTIONS(1025),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(1027),
    [anon_sym_try] = ACTIONS(1029),
    [anon_sym_match] = ACTIONS(1031),
    [anon_sym_match_BANG] = ACTIONS(1033),
    [anon_sym_function] = ACTIONS(1035),
    [anon_sym_use] = ACTIONS(1043),
    [anon_sym_use_BANG] = ACTIONS(1045),
    [anon_sym_do_BANG] = ACTIONS(1047),
    [anon_sym_begin] = ACTIONS(1049),
    [aux_sym_char_token1] = ACTIONS(1053),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1055),
    [anon_sym_DQUOTE] = ACTIONS(1057),
    [anon_sym_AT_DQUOTE] = ACTIONS(1059),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1061),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1063),
    [sym_bool] = ACTIONS(1065),
    [sym_unit] = ACTIONS(2074),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1069),
    [sym_op_identifier] = ACTIONS(2076),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(1073),
    [sym_xint] = ACTIONS(1075),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1077),
  },
  [651] = {
    [sym_function_or_value_defn] = STATE(651),
    [sym__expression] = STATE(166),
    [sym_literal_expression] = STATE(2168),
    [sym_long_identifier_or_op] = STATE(2168),
    [sym_tuple_expression] = STATE(2168),
    [sym_brace_expression] = STATE(2168),
    [sym_anon_record_expression] = STATE(2168),
    [sym_prefixed_expression] = STATE(2168),
    [sym_typecast_expression] = STATE(2168),
    [sym_for_expression] = STATE(2168),
    [sym_while_expression] = STATE(2168),
    [sym__if_branch] = STATE(6406),
    [sym_if_expression] = STATE(2168),
    [sym_fun_expression] = STATE(2168),
    [sym_try_expression] = STATE(2168),
    [sym_match_expression] = STATE(2168),
    [sym_function_expression] = STATE(2168),
    [sym_mutate_expression] = STATE(2168),
    [sym_index_expression] = STATE(2168),
    [sym_typed_expression] = STATE(2168),
    [sym_declaration_expression] = STATE(2168),
    [sym_do_expression] = STATE(2168),
    [sym_list_expression] = STATE(2168),
    [sym_array_expression] = STATE(2168),
    [sym_begin_end_expression] = STATE(2168),
    [sym_paren_expression] = STATE(2168),
    [sym__high_prec_app] = STATE(2179),
    [sym__low_prec_app] = STATE(2179),
    [sym_application_expression] = STATE(2168),
    [sym_dot_expression] = STATE(2168),
    [sym_infix_expression] = STATE(2168),
    [sym_ce_expression] = STATE(2168),
    [sym_sequential_expression] = STATE(2168),
    [sym_char] = STATE(2469),
    [sym_format_string] = STATE(2412),
    [sym__string_literal] = STATE(2412),
    [sym_string] = STATE(2469),
    [sym_verbatim_string] = STATE(2469),
    [sym_bytearray] = STATE(2469),
    [sym_verbatim_bytearray] = STATE(2469),
    [sym_format_triple_quoted_string] = STATE(2408),
    [sym_triple_quoted_string] = STATE(2469),
    [sym_const] = STATE(2168),
    [sym_long_identifier] = STATE(2183),
    [sym_active_pattern] = STATE(2182),
    [sym__identifier_or_op] = STATE(2093),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(650),
    [sym_sbyte] = STATE(2469),
    [sym_byte] = STATE(2469),
    [sym_int16] = STATE(2469),
    [sym_uint16] = STATE(2469),
    [sym_int32] = STATE(2469),
    [sym_uint32] = STATE(2469),
    [sym_nativeint] = STATE(2469),
    [sym_unativeint] = STATE(2469),
    [sym_int64] = STATE(2469),
    [sym_uint64] = STATE(2469),
    [sym_ieee32] = STATE(2469),
    [sym_ieee64] = STATE(2469),
    [sym_bignum] = STATE(2469),
    [sym_decimal] = STATE(2469),
    [sym_float] = STATE(1586),
    [sym_block_comment] = STATE(651),
    [sym_compiler_directive_decl] = STATE(651),
    [sym_fsi_directive_decl] = STATE(651),
    [sym_preproc_line] = STATE(651),
    [sym_preproc_if_in_expression] = STATE(2168),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(989),
    [anon_sym_return] = ACTIONS(993),
    [anon_sym_do] = ACTIONS(995),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(997),
    [anon_sym_null] = ACTIONS(1001),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1003),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1005),
    [anon_sym_LBRACE] = ACTIONS(2070),
    [anon_sym_LT_AT] = ACTIONS(1009),
    [anon_sym_LT_AT_AT] = ACTIONS(2072),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1017),
    [anon_sym_new] = ACTIONS(993),
    [anon_sym_return_BANG] = ACTIONS(1019),
    [anon_sym_yield] = ACTIONS(993),
    [anon_sym_yield_BANG] = ACTIONS(1019),
    [anon_sym_lazy] = ACTIONS(993),
    [anon_sym_assert] = ACTIONS(993),
    [anon_sym_upcast] = ACTIONS(993),
    [anon_sym_downcast] = ACTIONS(993),
    [anon_sym_for] = ACTIONS(1023),
    [anon_sym_while] = ACTIONS(1025),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(1027),
    [anon_sym_try] = ACTIONS(1029),
    [anon_sym_match] = ACTIONS(1031),
    [anon_sym_match_BANG] = ACTIONS(1033),
    [anon_sym_function] = ACTIONS(1035),
    [anon_sym_use] = ACTIONS(1043),
    [anon_sym_use_BANG] = ACTIONS(1045),
    [anon_sym_do_BANG] = ACTIONS(1047),
    [anon_sym_begin] = ACTIONS(1049),
    [aux_sym_char_token1] = ACTIONS(1053),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1055),
    [anon_sym_DQUOTE] = ACTIONS(1057),
    [anon_sym_AT_DQUOTE] = ACTIONS(1059),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1061),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1063),
    [sym_bool] = ACTIONS(1065),
    [sym_unit] = ACTIONS(2074),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1069),
    [sym_op_identifier] = ACTIONS(2076),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(1073),
    [sym_xint] = ACTIONS(1075),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1077),
  },
  [652] = {
    [sym_function_or_value_defn] = STATE(651),
    [sym__expression] = STATE(204),
    [sym_literal_expression] = STATE(2168),
    [sym_long_identifier_or_op] = STATE(2168),
    [sym_tuple_expression] = STATE(2168),
    [sym_brace_expression] = STATE(2168),
    [sym_anon_record_expression] = STATE(2168),
    [sym_prefixed_expression] = STATE(2168),
    [sym_typecast_expression] = STATE(2168),
    [sym_for_expression] = STATE(2168),
    [sym_while_expression] = STATE(2168),
    [sym__if_branch] = STATE(6406),
    [sym_if_expression] = STATE(2168),
    [sym_fun_expression] = STATE(2168),
    [sym_try_expression] = STATE(2168),
    [sym_match_expression] = STATE(2168),
    [sym_function_expression] = STATE(2168),
    [sym_mutate_expression] = STATE(2168),
    [sym_index_expression] = STATE(2168),
    [sym_typed_expression] = STATE(2168),
    [sym_declaration_expression] = STATE(2168),
    [sym_do_expression] = STATE(2168),
    [sym_list_expression] = STATE(2168),
    [sym_array_expression] = STATE(2168),
    [sym_begin_end_expression] = STATE(2168),
    [sym_paren_expression] = STATE(2168),
    [sym__high_prec_app] = STATE(2179),
    [sym__low_prec_app] = STATE(2179),
    [sym_application_expression] = STATE(2168),
    [sym_dot_expression] = STATE(2168),
    [sym_infix_expression] = STATE(2168),
    [sym_ce_expression] = STATE(2168),
    [sym_sequential_expression] = STATE(2168),
    [sym_char] = STATE(2469),
    [sym_format_string] = STATE(2412),
    [sym__string_literal] = STATE(2412),
    [sym_string] = STATE(2469),
    [sym_verbatim_string] = STATE(2469),
    [sym_bytearray] = STATE(2469),
    [sym_verbatim_bytearray] = STATE(2469),
    [sym_format_triple_quoted_string] = STATE(2408),
    [sym_triple_quoted_string] = STATE(2469),
    [sym_const] = STATE(2168),
    [sym_long_identifier] = STATE(2183),
    [sym_active_pattern] = STATE(2182),
    [sym__identifier_or_op] = STATE(2093),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(650),
    [sym_sbyte] = STATE(2469),
    [sym_byte] = STATE(2469),
    [sym_int16] = STATE(2469),
    [sym_uint16] = STATE(2469),
    [sym_int32] = STATE(2469),
    [sym_uint32] = STATE(2469),
    [sym_nativeint] = STATE(2469),
    [sym_unativeint] = STATE(2469),
    [sym_int64] = STATE(2469),
    [sym_uint64] = STATE(2469),
    [sym_ieee32] = STATE(2469),
    [sym_ieee64] = STATE(2469),
    [sym_bignum] = STATE(2469),
    [sym_decimal] = STATE(2469),
    [sym_float] = STATE(1586),
    [sym_block_comment] = STATE(652),
    [sym_compiler_directive_decl] = STATE(652),
    [sym_fsi_directive_decl] = STATE(652),
    [sym_preproc_line] = STATE(652),
    [sym_preproc_if_in_expression] = STATE(2168),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(989),
    [anon_sym_return] = ACTIONS(993),
    [anon_sym_do] = ACTIONS(995),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(997),
    [anon_sym_null] = ACTIONS(1001),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1003),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1005),
    [anon_sym_LBRACE] = ACTIONS(2070),
    [anon_sym_LT_AT] = ACTIONS(1009),
    [anon_sym_LT_AT_AT] = ACTIONS(2072),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1017),
    [anon_sym_new] = ACTIONS(993),
    [anon_sym_return_BANG] = ACTIONS(1019),
    [anon_sym_yield] = ACTIONS(993),
    [anon_sym_yield_BANG] = ACTIONS(1019),
    [anon_sym_lazy] = ACTIONS(993),
    [anon_sym_assert] = ACTIONS(993),
    [anon_sym_upcast] = ACTIONS(993),
    [anon_sym_downcast] = ACTIONS(993),
    [anon_sym_for] = ACTIONS(1023),
    [anon_sym_while] = ACTIONS(1025),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(1027),
    [anon_sym_try] = ACTIONS(1029),
    [anon_sym_match] = ACTIONS(1031),
    [anon_sym_match_BANG] = ACTIONS(1033),
    [anon_sym_function] = ACTIONS(1035),
    [anon_sym_use] = ACTIONS(1043),
    [anon_sym_use_BANG] = ACTIONS(1045),
    [anon_sym_do_BANG] = ACTIONS(1047),
    [anon_sym_begin] = ACTIONS(1049),
    [aux_sym_char_token1] = ACTIONS(1053),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1055),
    [anon_sym_DQUOTE] = ACTIONS(1057),
    [anon_sym_AT_DQUOTE] = ACTIONS(1059),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1061),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1063),
    [sym_bool] = ACTIONS(1065),
    [sym_unit] = ACTIONS(2074),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1069),
    [sym_op_identifier] = ACTIONS(2076),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(1073),
    [sym_xint] = ACTIONS(1075),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1077),
  },
  [653] = {
    [sym_function_or_value_defn] = STATE(651),
    [sym__expression] = STATE(162),
    [sym_literal_expression] = STATE(2168),
    [sym_long_identifier_or_op] = STATE(2168),
    [sym_tuple_expression] = STATE(2168),
    [sym_brace_expression] = STATE(2168),
    [sym_anon_record_expression] = STATE(2168),
    [sym_prefixed_expression] = STATE(2168),
    [sym_typecast_expression] = STATE(2168),
    [sym_for_expression] = STATE(2168),
    [sym_while_expression] = STATE(2168),
    [sym__if_branch] = STATE(6406),
    [sym_if_expression] = STATE(2168),
    [sym_fun_expression] = STATE(2168),
    [sym_try_expression] = STATE(2168),
    [sym_match_expression] = STATE(2168),
    [sym_function_expression] = STATE(2168),
    [sym_mutate_expression] = STATE(2168),
    [sym_index_expression] = STATE(2168),
    [sym_typed_expression] = STATE(2168),
    [sym_declaration_expression] = STATE(2168),
    [sym_do_expression] = STATE(2168),
    [sym_list_expression] = STATE(2168),
    [sym_array_expression] = STATE(2168),
    [sym_begin_end_expression] = STATE(2168),
    [sym_paren_expression] = STATE(2168),
    [sym__high_prec_app] = STATE(2179),
    [sym__low_prec_app] = STATE(2179),
    [sym_application_expression] = STATE(2168),
    [sym_dot_expression] = STATE(2168),
    [sym_infix_expression] = STATE(2168),
    [sym_ce_expression] = STATE(2168),
    [sym_sequential_expression] = STATE(2168),
    [sym_char] = STATE(2469),
    [sym_format_string] = STATE(2412),
    [sym__string_literal] = STATE(2412),
    [sym_string] = STATE(2469),
    [sym_verbatim_string] = STATE(2469),
    [sym_bytearray] = STATE(2469),
    [sym_verbatim_bytearray] = STATE(2469),
    [sym_format_triple_quoted_string] = STATE(2408),
    [sym_triple_quoted_string] = STATE(2469),
    [sym_const] = STATE(2168),
    [sym_long_identifier] = STATE(2183),
    [sym_active_pattern] = STATE(2182),
    [sym__identifier_or_op] = STATE(2093),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(650),
    [sym_sbyte] = STATE(2469),
    [sym_byte] = STATE(2469),
    [sym_int16] = STATE(2469),
    [sym_uint16] = STATE(2469),
    [sym_int32] = STATE(2469),
    [sym_uint32] = STATE(2469),
    [sym_nativeint] = STATE(2469),
    [sym_unativeint] = STATE(2469),
    [sym_int64] = STATE(2469),
    [sym_uint64] = STATE(2469),
    [sym_ieee32] = STATE(2469),
    [sym_ieee64] = STATE(2469),
    [sym_bignum] = STATE(2469),
    [sym_decimal] = STATE(2469),
    [sym_float] = STATE(1586),
    [sym_block_comment] = STATE(653),
    [sym_compiler_directive_decl] = STATE(653),
    [sym_fsi_directive_decl] = STATE(653),
    [sym_preproc_line] = STATE(653),
    [sym_preproc_if_in_expression] = STATE(2168),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(989),
    [anon_sym_return] = ACTIONS(993),
    [anon_sym_do] = ACTIONS(995),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(997),
    [anon_sym_null] = ACTIONS(1001),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1003),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1005),
    [anon_sym_LBRACE] = ACTIONS(2070),
    [anon_sym_LT_AT] = ACTIONS(1009),
    [anon_sym_LT_AT_AT] = ACTIONS(2072),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1017),
    [anon_sym_new] = ACTIONS(993),
    [anon_sym_return_BANG] = ACTIONS(1019),
    [anon_sym_yield] = ACTIONS(993),
    [anon_sym_yield_BANG] = ACTIONS(1019),
    [anon_sym_lazy] = ACTIONS(993),
    [anon_sym_assert] = ACTIONS(993),
    [anon_sym_upcast] = ACTIONS(993),
    [anon_sym_downcast] = ACTIONS(993),
    [anon_sym_for] = ACTIONS(1023),
    [anon_sym_while] = ACTIONS(1025),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(1027),
    [anon_sym_try] = ACTIONS(1029),
    [anon_sym_match] = ACTIONS(1031),
    [anon_sym_match_BANG] = ACTIONS(1033),
    [anon_sym_function] = ACTIONS(1035),
    [anon_sym_use] = ACTIONS(1043),
    [anon_sym_use_BANG] = ACTIONS(1045),
    [anon_sym_do_BANG] = ACTIONS(1047),
    [anon_sym_begin] = ACTIONS(1049),
    [aux_sym_char_token1] = ACTIONS(1053),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1055),
    [anon_sym_DQUOTE] = ACTIONS(1057),
    [anon_sym_AT_DQUOTE] = ACTIONS(1059),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1061),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1063),
    [sym_bool] = ACTIONS(1065),
    [sym_unit] = ACTIONS(2074),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1069),
    [sym_op_identifier] = ACTIONS(2076),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(1073),
    [sym_xint] = ACTIONS(1075),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1077),
  },
  [654] = {
    [sym_function_or_value_defn] = STATE(600),
    [sym__expression] = STATE(148),
    [sym_literal_expression] = STATE(867),
    [sym_long_identifier_or_op] = STATE(867),
    [sym_tuple_expression] = STATE(867),
    [sym_brace_expression] = STATE(867),
    [sym_anon_record_expression] = STATE(867),
    [sym_prefixed_expression] = STATE(867),
    [sym_typecast_expression] = STATE(867),
    [sym_for_expression] = STATE(867),
    [sym_while_expression] = STATE(867),
    [sym__if_branch] = STATE(6511),
    [sym_if_expression] = STATE(867),
    [sym_fun_expression] = STATE(867),
    [sym_try_expression] = STATE(867),
    [sym_match_expression] = STATE(867),
    [sym_function_expression] = STATE(867),
    [sym_mutate_expression] = STATE(867),
    [sym_index_expression] = STATE(867),
    [sym_typed_expression] = STATE(867),
    [sym_declaration_expression] = STATE(867),
    [sym_do_expression] = STATE(867),
    [sym_list_expression] = STATE(867),
    [sym_array_expression] = STATE(867),
    [sym_begin_end_expression] = STATE(867),
    [sym_paren_expression] = STATE(867),
    [sym__high_prec_app] = STATE(864),
    [sym__low_prec_app] = STATE(864),
    [sym_application_expression] = STATE(867),
    [sym_dot_expression] = STATE(867),
    [sym_infix_expression] = STATE(867),
    [sym_ce_expression] = STATE(867),
    [sym_sequential_expression] = STATE(867),
    [sym_char] = STATE(868),
    [sym_format_string] = STATE(869),
    [sym__string_literal] = STATE(869),
    [sym_string] = STATE(868),
    [sym_verbatim_string] = STATE(868),
    [sym_bytearray] = STATE(868),
    [sym_verbatim_bytearray] = STATE(868),
    [sym_format_triple_quoted_string] = STATE(870),
    [sym_triple_quoted_string] = STATE(868),
    [sym_const] = STATE(867),
    [sym_long_identifier] = STATE(872),
    [sym_active_pattern] = STATE(871),
    [sym__identifier_or_op] = STATE(873),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(656),
    [sym_sbyte] = STATE(868),
    [sym_byte] = STATE(868),
    [sym_int16] = STATE(868),
    [sym_uint16] = STATE(868),
    [sym_int32] = STATE(868),
    [sym_uint32] = STATE(868),
    [sym_nativeint] = STATE(868),
    [sym_unativeint] = STATE(868),
    [sym_int64] = STATE(868),
    [sym_uint64] = STATE(868),
    [sym_ieee32] = STATE(868),
    [sym_ieee64] = STATE(868),
    [sym_bignum] = STATE(868),
    [sym_decimal] = STATE(868),
    [sym_float] = STATE(1368),
    [sym_block_comment] = STATE(654),
    [sym_compiler_directive_decl] = STATE(654),
    [sym_fsi_directive_decl] = STATE(654),
    [sym_preproc_line] = STATE(654),
    [sym_preproc_if_in_expression] = STATE(867),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(29),
    [anon_sym_return] = ACTIONS(825),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_null] = ACTIONS(49),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACK_PIPE] = ACTIONS(57),
    [anon_sym_LBRACE] = ACTIONS(1663),
    [anon_sym_LT_AT] = ACTIONS(61),
    [anon_sym_LT_AT_AT] = ACTIONS(1665),
    [anon_sym_LBRACE_PIPE] = ACTIONS(67),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_return_BANG] = ACTIONS(829),
    [anon_sym_yield] = ACTIONS(825),
    [anon_sym_yield_BANG] = ACTIONS(829),
    [anon_sym_lazy] = ACTIONS(825),
    [anon_sym_assert] = ACTIONS(825),
    [anon_sym_upcast] = ACTIONS(825),
    [anon_sym_downcast] = ACTIONS(825),
    [anon_sym_for] = ACTIONS(73),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(79),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_match] = ACTIONS(83),
    [anon_sym_match_BANG] = ACTIONS(85),
    [anon_sym_function] = ACTIONS(87),
    [anon_sym_use] = ACTIONS(833),
    [anon_sym_use_BANG] = ACTIONS(835),
    [anon_sym_do_BANG] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(101),
    [aux_sym_char_token1] = ACTIONS(105),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(107),
    [anon_sym_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DQUOTE] = ACTIONS(111),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(115),
    [sym_bool] = ACTIONS(117),
    [sym_unit] = ACTIONS(1673),
    [anon_sym_LPAREN_PIPE] = ACTIONS(121),
    [sym_op_identifier] = ACTIONS(1675),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(837),
    [sym_xint] = ACTIONS(387),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(135),
  },
  [655] = {
    [sym_function_or_value_defn] = STATE(596),
    [sym__expression] = STATE(80),
    [sym_literal_expression] = STATE(1809),
    [sym_long_identifier_or_op] = STATE(1809),
    [sym_tuple_expression] = STATE(1809),
    [sym_brace_expression] = STATE(1809),
    [sym_anon_record_expression] = STATE(1809),
    [sym_prefixed_expression] = STATE(1809),
    [sym_typecast_expression] = STATE(1809),
    [sym_for_expression] = STATE(1809),
    [sym_while_expression] = STATE(1809),
    [sym__if_branch] = STATE(6874),
    [sym_if_expression] = STATE(1809),
    [sym_fun_expression] = STATE(1809),
    [sym_try_expression] = STATE(1809),
    [sym_match_expression] = STATE(1809),
    [sym_function_expression] = STATE(1809),
    [sym_mutate_expression] = STATE(1809),
    [sym_index_expression] = STATE(1809),
    [sym_typed_expression] = STATE(1809),
    [sym_declaration_expression] = STATE(1809),
    [sym_do_expression] = STATE(1809),
    [sym_list_expression] = STATE(1809),
    [sym_array_expression] = STATE(1809),
    [sym_begin_end_expression] = STATE(1809),
    [sym_paren_expression] = STATE(1809),
    [sym__high_prec_app] = STATE(1806),
    [sym__low_prec_app] = STATE(1806),
    [sym_application_expression] = STATE(1809),
    [sym_dot_expression] = STATE(1809),
    [sym_infix_expression] = STATE(1809),
    [sym_ce_expression] = STATE(1809),
    [sym_sequential_expression] = STATE(1809),
    [sym_char] = STATE(2014),
    [sym_format_string] = STATE(2019),
    [sym__string_literal] = STATE(2019),
    [sym_string] = STATE(2014),
    [sym_verbatim_string] = STATE(2014),
    [sym_bytearray] = STATE(2014),
    [sym_verbatim_bytearray] = STATE(2014),
    [sym_format_triple_quoted_string] = STATE(2020),
    [sym_triple_quoted_string] = STATE(2014),
    [sym_const] = STATE(1809),
    [sym_long_identifier] = STATE(1810),
    [sym_active_pattern] = STATE(1860),
    [sym__identifier_or_op] = STATE(1750),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(655),
    [sym_sbyte] = STATE(2014),
    [sym_byte] = STATE(2014),
    [sym_int16] = STATE(2014),
    [sym_uint16] = STATE(2014),
    [sym_int32] = STATE(2014),
    [sym_uint32] = STATE(2014),
    [sym_nativeint] = STATE(2014),
    [sym_unativeint] = STATE(2014),
    [sym_int64] = STATE(2014),
    [sym_uint64] = STATE(2014),
    [sym_ieee32] = STATE(2014),
    [sym_ieee64] = STATE(2014),
    [sym_bignum] = STATE(2014),
    [sym_decimal] = STATE(2014),
    [sym_float] = STATE(1438),
    [sym_block_comment] = STATE(655),
    [sym_compiler_directive_decl] = STATE(655),
    [sym_fsi_directive_decl] = STATE(655),
    [sym_preproc_line] = STATE(655),
    [sym_preproc_if_in_expression] = STATE(1809),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(723),
    [anon_sym_return] = ACTIONS(727),
    [anon_sym_do] = ACTIONS(729),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(731),
    [anon_sym_null] = ACTIONS(735),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(737),
    [anon_sym_LBRACK_PIPE] = ACTIONS(739),
    [anon_sym_LBRACE] = ACTIONS(2112),
    [anon_sym_LT_AT] = ACTIONS(743),
    [anon_sym_LT_AT_AT] = ACTIONS(2114),
    [anon_sym_LBRACE_PIPE] = ACTIONS(749),
    [anon_sym_new] = ACTIONS(727),
    [anon_sym_return_BANG] = ACTIONS(751),
    [anon_sym_yield] = ACTIONS(727),
    [anon_sym_yield_BANG] = ACTIONS(751),
    [anon_sym_lazy] = ACTIONS(727),
    [anon_sym_assert] = ACTIONS(727),
    [anon_sym_upcast] = ACTIONS(727),
    [anon_sym_downcast] = ACTIONS(727),
    [anon_sym_for] = ACTIONS(755),
    [anon_sym_while] = ACTIONS(757),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(759),
    [anon_sym_try] = ACTIONS(761),
    [anon_sym_match] = ACTIONS(763),
    [anon_sym_match_BANG] = ACTIONS(765),
    [anon_sym_function] = ACTIONS(767),
    [anon_sym_use] = ACTIONS(775),
    [anon_sym_use_BANG] = ACTIONS(777),
    [anon_sym_do_BANG] = ACTIONS(779),
    [anon_sym_begin] = ACTIONS(781),
    [aux_sym_char_token1] = ACTIONS(785),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(787),
    [anon_sym_DQUOTE] = ACTIONS(789),
    [anon_sym_AT_DQUOTE] = ACTIONS(791),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(793),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(795),
    [sym_bool] = ACTIONS(797),
    [sym_unit] = ACTIONS(2116),
    [anon_sym_LPAREN_PIPE] = ACTIONS(801),
    [sym_op_identifier] = ACTIONS(2118),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(805),
    [sym_xint] = ACTIONS(807),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(809),
  },
  [656] = {
    [sym_function_or_value_defn] = STATE(600),
    [sym__expression] = STATE(85),
    [sym_literal_expression] = STATE(867),
    [sym_long_identifier_or_op] = STATE(867),
    [sym_tuple_expression] = STATE(867),
    [sym_brace_expression] = STATE(867),
    [sym_anon_record_expression] = STATE(867),
    [sym_prefixed_expression] = STATE(867),
    [sym_typecast_expression] = STATE(867),
    [sym_for_expression] = STATE(867),
    [sym_while_expression] = STATE(867),
    [sym__if_branch] = STATE(6511),
    [sym_if_expression] = STATE(867),
    [sym_fun_expression] = STATE(867),
    [sym_try_expression] = STATE(867),
    [sym_match_expression] = STATE(867),
    [sym_function_expression] = STATE(867),
    [sym_mutate_expression] = STATE(867),
    [sym_index_expression] = STATE(867),
    [sym_typed_expression] = STATE(867),
    [sym_declaration_expression] = STATE(867),
    [sym_do_expression] = STATE(867),
    [sym_list_expression] = STATE(867),
    [sym_array_expression] = STATE(867),
    [sym_begin_end_expression] = STATE(867),
    [sym_paren_expression] = STATE(867),
    [sym__high_prec_app] = STATE(864),
    [sym__low_prec_app] = STATE(864),
    [sym_application_expression] = STATE(867),
    [sym_dot_expression] = STATE(867),
    [sym_infix_expression] = STATE(867),
    [sym_ce_expression] = STATE(867),
    [sym_sequential_expression] = STATE(867),
    [sym_char] = STATE(868),
    [sym_format_string] = STATE(869),
    [sym__string_literal] = STATE(869),
    [sym_string] = STATE(868),
    [sym_verbatim_string] = STATE(868),
    [sym_bytearray] = STATE(868),
    [sym_verbatim_bytearray] = STATE(868),
    [sym_format_triple_quoted_string] = STATE(870),
    [sym_triple_quoted_string] = STATE(868),
    [sym_const] = STATE(867),
    [sym_long_identifier] = STATE(872),
    [sym_active_pattern] = STATE(871),
    [sym__identifier_or_op] = STATE(873),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(656),
    [sym_sbyte] = STATE(868),
    [sym_byte] = STATE(868),
    [sym_int16] = STATE(868),
    [sym_uint16] = STATE(868),
    [sym_int32] = STATE(868),
    [sym_uint32] = STATE(868),
    [sym_nativeint] = STATE(868),
    [sym_unativeint] = STATE(868),
    [sym_int64] = STATE(868),
    [sym_uint64] = STATE(868),
    [sym_ieee32] = STATE(868),
    [sym_ieee64] = STATE(868),
    [sym_bignum] = STATE(868),
    [sym_decimal] = STATE(868),
    [sym_float] = STATE(1368),
    [sym_block_comment] = STATE(656),
    [sym_compiler_directive_decl] = STATE(656),
    [sym_fsi_directive_decl] = STATE(656),
    [sym_preproc_line] = STATE(656),
    [sym_preproc_if_in_expression] = STATE(867),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(29),
    [anon_sym_return] = ACTIONS(825),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_null] = ACTIONS(49),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACK_PIPE] = ACTIONS(57),
    [anon_sym_LBRACE] = ACTIONS(1663),
    [anon_sym_LT_AT] = ACTIONS(61),
    [anon_sym_LT_AT_AT] = ACTIONS(1665),
    [anon_sym_LBRACE_PIPE] = ACTIONS(67),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_return_BANG] = ACTIONS(829),
    [anon_sym_yield] = ACTIONS(825),
    [anon_sym_yield_BANG] = ACTIONS(829),
    [anon_sym_lazy] = ACTIONS(825),
    [anon_sym_assert] = ACTIONS(825),
    [anon_sym_upcast] = ACTIONS(825),
    [anon_sym_downcast] = ACTIONS(825),
    [anon_sym_for] = ACTIONS(73),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(79),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_match] = ACTIONS(83),
    [anon_sym_match_BANG] = ACTIONS(85),
    [anon_sym_function] = ACTIONS(87),
    [anon_sym_use] = ACTIONS(833),
    [anon_sym_use_BANG] = ACTIONS(835),
    [anon_sym_do_BANG] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(101),
    [aux_sym_char_token1] = ACTIONS(105),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(107),
    [anon_sym_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DQUOTE] = ACTIONS(111),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(115),
    [sym_bool] = ACTIONS(117),
    [sym_unit] = ACTIONS(1673),
    [anon_sym_LPAREN_PIPE] = ACTIONS(121),
    [sym_op_identifier] = ACTIONS(1675),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(837),
    [sym_xint] = ACTIONS(387),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(135),
  },
  [657] = {
    [sym_function_or_value_defn] = STATE(703),
    [sym__expression] = STATE(25),
    [sym_literal_expression] = STATE(1797),
    [sym_long_identifier_or_op] = STATE(1797),
    [sym_tuple_expression] = STATE(1797),
    [sym_brace_expression] = STATE(1797),
    [sym_anon_record_expression] = STATE(1797),
    [sym_prefixed_expression] = STATE(1797),
    [sym_typecast_expression] = STATE(1797),
    [sym_for_expression] = STATE(1797),
    [sym_while_expression] = STATE(1797),
    [sym__if_branch] = STATE(6611),
    [sym_if_expression] = STATE(1797),
    [sym_fun_expression] = STATE(1797),
    [sym_try_expression] = STATE(1797),
    [sym_match_expression] = STATE(1797),
    [sym_function_expression] = STATE(1797),
    [sym_mutate_expression] = STATE(1797),
    [sym_index_expression] = STATE(1797),
    [sym_typed_expression] = STATE(1797),
    [sym_declaration_expression] = STATE(1797),
    [sym_do_expression] = STATE(1797),
    [sym_list_expression] = STATE(1797),
    [sym_array_expression] = STATE(1797),
    [sym_begin_end_expression] = STATE(1797),
    [sym_paren_expression] = STATE(1797),
    [sym__high_prec_app] = STATE(1800),
    [sym__low_prec_app] = STATE(1800),
    [sym_application_expression] = STATE(1797),
    [sym_dot_expression] = STATE(1797),
    [sym_infix_expression] = STATE(1797),
    [sym_ce_expression] = STATE(1797),
    [sym_sequential_expression] = STATE(1797),
    [sym_char] = STATE(1694),
    [sym_format_string] = STATE(1693),
    [sym__string_literal] = STATE(1693),
    [sym_string] = STATE(1694),
    [sym_verbatim_string] = STATE(1694),
    [sym_bytearray] = STATE(1694),
    [sym_verbatim_bytearray] = STATE(1694),
    [sym_format_triple_quoted_string] = STATE(1692),
    [sym_triple_quoted_string] = STATE(1694),
    [sym_const] = STATE(1797),
    [sym_long_identifier] = STATE(1813),
    [sym_active_pattern] = STATE(1753),
    [sym__identifier_or_op] = STATE(1812),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(756),
    [sym_sbyte] = STATE(1694),
    [sym_byte] = STATE(1694),
    [sym_int16] = STATE(1694),
    [sym_uint16] = STATE(1694),
    [sym_int32] = STATE(1694),
    [sym_uint32] = STATE(1694),
    [sym_nativeint] = STATE(1694),
    [sym_unativeint] = STATE(1694),
    [sym_int64] = STATE(1694),
    [sym_uint64] = STATE(1694),
    [sym_ieee32] = STATE(1694),
    [sym_ieee64] = STATE(1694),
    [sym_bignum] = STATE(1694),
    [sym_decimal] = STATE(1694),
    [sym_float] = STATE(1425),
    [sym_block_comment] = STATE(657),
    [sym_compiler_directive_decl] = STATE(657),
    [sym_fsi_directive_decl] = STATE(657),
    [sym_preproc_line] = STATE(657),
    [sym_preproc_if_in_expression] = STATE(1797),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(393),
    [anon_sym_return] = ACTIONS(397),
    [anon_sym_do] = ACTIONS(399),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(401),
    [anon_sym_null] = ACTIONS(405),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(407),
    [anon_sym_LBRACK_PIPE] = ACTIONS(409),
    [anon_sym_LBRACE] = ACTIONS(2146),
    [anon_sym_LT_AT] = ACTIONS(413),
    [anon_sym_LT_AT_AT] = ACTIONS(2148),
    [anon_sym_LBRACE_PIPE] = ACTIONS(419),
    [anon_sym_new] = ACTIONS(397),
    [anon_sym_return_BANG] = ACTIONS(421),
    [anon_sym_yield] = ACTIONS(397),
    [anon_sym_yield_BANG] = ACTIONS(421),
    [anon_sym_lazy] = ACTIONS(397),
    [anon_sym_assert] = ACTIONS(397),
    [anon_sym_upcast] = ACTIONS(397),
    [anon_sym_downcast] = ACTIONS(397),
    [anon_sym_for] = ACTIONS(425),
    [anon_sym_while] = ACTIONS(427),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(429),
    [anon_sym_try] = ACTIONS(431),
    [anon_sym_match] = ACTIONS(433),
    [anon_sym_match_BANG] = ACTIONS(435),
    [anon_sym_function] = ACTIONS(437),
    [anon_sym_use] = ACTIONS(445),
    [anon_sym_use_BANG] = ACTIONS(447),
    [anon_sym_do_BANG] = ACTIONS(449),
    [anon_sym_begin] = ACTIONS(451),
    [aux_sym_char_token1] = ACTIONS(455),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(457),
    [anon_sym_DQUOTE] = ACTIONS(459),
    [anon_sym_AT_DQUOTE] = ACTIONS(461),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(463),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(465),
    [sym_bool] = ACTIONS(467),
    [sym_unit] = ACTIONS(2150),
    [anon_sym_LPAREN_PIPE] = ACTIONS(471),
    [sym_op_identifier] = ACTIONS(2152),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(475),
    [sym_xint] = ACTIONS(477),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(479),
  },
  [658] = {
    [sym_function_or_value_defn] = STATE(705),
    [sym__expression] = STATE(4),
    [sym_literal_expression] = STATE(867),
    [sym_long_identifier_or_op] = STATE(867),
    [sym_tuple_expression] = STATE(867),
    [sym_brace_expression] = STATE(867),
    [sym_anon_record_expression] = STATE(867),
    [sym_prefixed_expression] = STATE(867),
    [sym_typecast_expression] = STATE(867),
    [sym_for_expression] = STATE(867),
    [sym_while_expression] = STATE(867),
    [sym__if_branch] = STATE(6511),
    [sym_if_expression] = STATE(867),
    [sym_fun_expression] = STATE(867),
    [sym_try_expression] = STATE(867),
    [sym_match_expression] = STATE(867),
    [sym_function_expression] = STATE(867),
    [sym_mutate_expression] = STATE(867),
    [sym_index_expression] = STATE(867),
    [sym_typed_expression] = STATE(867),
    [sym_declaration_expression] = STATE(867),
    [sym_do_expression] = STATE(867),
    [sym_list_expression] = STATE(867),
    [sym_array_expression] = STATE(867),
    [sym_begin_end_expression] = STATE(867),
    [sym_paren_expression] = STATE(867),
    [sym__high_prec_app] = STATE(864),
    [sym__low_prec_app] = STATE(864),
    [sym_application_expression] = STATE(867),
    [sym_dot_expression] = STATE(867),
    [sym_infix_expression] = STATE(867),
    [sym_ce_expression] = STATE(867),
    [sym_sequential_expression] = STATE(867),
    [sym_char] = STATE(868),
    [sym_format_string] = STATE(869),
    [sym__string_literal] = STATE(869),
    [sym_string] = STATE(868),
    [sym_verbatim_string] = STATE(868),
    [sym_bytearray] = STATE(868),
    [sym_verbatim_bytearray] = STATE(868),
    [sym_format_triple_quoted_string] = STATE(870),
    [sym_triple_quoted_string] = STATE(868),
    [sym_const] = STATE(867),
    [sym_long_identifier] = STATE(872),
    [sym_active_pattern] = STATE(871),
    [sym__identifier_or_op] = STATE(873),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(658),
    [sym_sbyte] = STATE(868),
    [sym_byte] = STATE(868),
    [sym_int16] = STATE(868),
    [sym_uint16] = STATE(868),
    [sym_int32] = STATE(868),
    [sym_uint32] = STATE(868),
    [sym_nativeint] = STATE(868),
    [sym_unativeint] = STATE(868),
    [sym_int64] = STATE(868),
    [sym_uint64] = STATE(868),
    [sym_ieee32] = STATE(868),
    [sym_ieee64] = STATE(868),
    [sym_bignum] = STATE(868),
    [sym_decimal] = STATE(868),
    [sym_float] = STATE(860),
    [sym_block_comment] = STATE(658),
    [sym_compiler_directive_decl] = STATE(658),
    [sym_fsi_directive_decl] = STATE(658),
    [sym_preproc_line] = STATE(658),
    [sym_preproc_if_in_expression] = STATE(867),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(29),
    [anon_sym_return] = ACTIONS(37),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_null] = ACTIONS(49),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACK_PIPE] = ACTIONS(57),
    [anon_sym_LBRACE] = ACTIONS(1663),
    [anon_sym_LT_AT] = ACTIONS(61),
    [anon_sym_LT_AT_AT] = ACTIONS(1665),
    [anon_sym_LBRACE_PIPE] = ACTIONS(67),
    [anon_sym_new] = ACTIONS(37),
    [anon_sym_return_BANG] = ACTIONS(69),
    [anon_sym_yield] = ACTIONS(37),
    [anon_sym_yield_BANG] = ACTIONS(69),
    [anon_sym_lazy] = ACTIONS(37),
    [anon_sym_assert] = ACTIONS(37),
    [anon_sym_upcast] = ACTIONS(37),
    [anon_sym_downcast] = ACTIONS(37),
    [anon_sym_for] = ACTIONS(73),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(79),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_match] = ACTIONS(83),
    [anon_sym_match_BANG] = ACTIONS(85),
    [anon_sym_function] = ACTIONS(87),
    [anon_sym_use] = ACTIONS(95),
    [anon_sym_use_BANG] = ACTIONS(97),
    [anon_sym_do_BANG] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(101),
    [aux_sym_char_token1] = ACTIONS(105),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(107),
    [anon_sym_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DQUOTE] = ACTIONS(111),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(115),
    [sym_bool] = ACTIONS(117),
    [sym_unit] = ACTIONS(1673),
    [anon_sym_LPAREN_PIPE] = ACTIONS(121),
    [sym_op_identifier] = ACTIONS(1675),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(129),
    [sym_xint] = ACTIONS(131),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(135),
  },
  [659] = {
    [sym_function_or_value_defn] = STATE(532),
    [sym__expression] = STATE(130),
    [sym_literal_expression] = STATE(2000),
    [sym_long_identifier_or_op] = STATE(2000),
    [sym_tuple_expression] = STATE(2000),
    [sym_brace_expression] = STATE(2000),
    [sym_anon_record_expression] = STATE(2000),
    [sym_prefixed_expression] = STATE(2000),
    [sym_typecast_expression] = STATE(2000),
    [sym_for_expression] = STATE(2000),
    [sym_while_expression] = STATE(2000),
    [sym__if_branch] = STATE(6707),
    [sym_if_expression] = STATE(2000),
    [sym_fun_expression] = STATE(2000),
    [sym_try_expression] = STATE(2000),
    [sym_match_expression] = STATE(2000),
    [sym_function_expression] = STATE(2000),
    [sym_mutate_expression] = STATE(2000),
    [sym_index_expression] = STATE(2000),
    [sym_typed_expression] = STATE(2000),
    [sym_declaration_expression] = STATE(2000),
    [sym_do_expression] = STATE(2000),
    [sym_list_expression] = STATE(2000),
    [sym_array_expression] = STATE(2000),
    [sym_begin_end_expression] = STATE(2000),
    [sym_paren_expression] = STATE(2000),
    [sym__high_prec_app] = STATE(2003),
    [sym__low_prec_app] = STATE(2003),
    [sym_application_expression] = STATE(2000),
    [sym_dot_expression] = STATE(2000),
    [sym_infix_expression] = STATE(2000),
    [sym_ce_expression] = STATE(2000),
    [sym_sequential_expression] = STATE(2000),
    [sym_char] = STATE(1801),
    [sym_format_string] = STATE(1804),
    [sym__string_literal] = STATE(1804),
    [sym_string] = STATE(1801),
    [sym_verbatim_string] = STATE(1801),
    [sym_bytearray] = STATE(1801),
    [sym_verbatim_bytearray] = STATE(1801),
    [sym_format_triple_quoted_string] = STATE(1807),
    [sym_triple_quoted_string] = STATE(1801),
    [sym_const] = STATE(2000),
    [sym_long_identifier] = STATE(1725),
    [sym_active_pattern] = STATE(1726),
    [sym__identifier_or_op] = STATE(1751),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(723),
    [sym_sbyte] = STATE(1801),
    [sym_byte] = STATE(1801),
    [sym_int16] = STATE(1801),
    [sym_uint16] = STATE(1801),
    [sym_int32] = STATE(1801),
    [sym_uint32] = STATE(1801),
    [sym_nativeint] = STATE(1801),
    [sym_unativeint] = STATE(1801),
    [sym_int64] = STATE(1801),
    [sym_uint64] = STATE(1801),
    [sym_ieee32] = STATE(1801),
    [sym_ieee64] = STATE(1801),
    [sym_bignum] = STATE(1801),
    [sym_decimal] = STATE(1801),
    [sym_float] = STATE(1427),
    [sym_block_comment] = STATE(659),
    [sym_compiler_directive_decl] = STATE(659),
    [sym_fsi_directive_decl] = STATE(659),
    [sym_preproc_line] = STATE(659),
    [sym_preproc_if_in_expression] = STATE(2000),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(629),
    [anon_sym_return] = ACTIONS(633),
    [anon_sym_do] = ACTIONS(635),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(637),
    [anon_sym_null] = ACTIONS(641),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(643),
    [anon_sym_LBRACK_PIPE] = ACTIONS(645),
    [anon_sym_LBRACE] = ACTIONS(1713),
    [anon_sym_LT_AT] = ACTIONS(647),
    [anon_sym_LT_AT_AT] = ACTIONS(1715),
    [anon_sym_LBRACE_PIPE] = ACTIONS(653),
    [anon_sym_new] = ACTIONS(633),
    [anon_sym_return_BANG] = ACTIONS(655),
    [anon_sym_yield] = ACTIONS(633),
    [anon_sym_yield_BANG] = ACTIONS(655),
    [anon_sym_lazy] = ACTIONS(633),
    [anon_sym_assert] = ACTIONS(633),
    [anon_sym_upcast] = ACTIONS(633),
    [anon_sym_downcast] = ACTIONS(633),
    [anon_sym_for] = ACTIONS(659),
    [anon_sym_while] = ACTIONS(661),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(663),
    [anon_sym_try] = ACTIONS(665),
    [anon_sym_match] = ACTIONS(667),
    [anon_sym_match_BANG] = ACTIONS(669),
    [anon_sym_function] = ACTIONS(671),
    [anon_sym_use] = ACTIONS(679),
    [anon_sym_use_BANG] = ACTIONS(681),
    [anon_sym_do_BANG] = ACTIONS(683),
    [anon_sym_begin] = ACTIONS(685),
    [aux_sym_char_token1] = ACTIONS(689),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(691),
    [anon_sym_DQUOTE] = ACTIONS(693),
    [anon_sym_AT_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(697),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(699),
    [sym_bool] = ACTIONS(701),
    [sym_unit] = ACTIONS(1717),
    [anon_sym_LPAREN_PIPE] = ACTIONS(705),
    [sym_op_identifier] = ACTIONS(1719),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(709),
    [sym_xint] = ACTIONS(711),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(713),
  },
  [660] = {
    [sym_function_or_value_defn] = STATE(509),
    [sym__expression] = STATE(324),
    [sym_literal_expression] = STATE(2230),
    [sym_long_identifier_or_op] = STATE(2230),
    [sym_tuple_expression] = STATE(2230),
    [sym_brace_expression] = STATE(2230),
    [sym_anon_record_expression] = STATE(2230),
    [sym_prefixed_expression] = STATE(2230),
    [sym_typecast_expression] = STATE(2230),
    [sym_for_expression] = STATE(2230),
    [sym_while_expression] = STATE(2230),
    [sym__if_branch] = STATE(6659),
    [sym_if_expression] = STATE(2230),
    [sym_fun_expression] = STATE(2230),
    [sym_try_expression] = STATE(2230),
    [sym_match_expression] = STATE(2230),
    [sym_function_expression] = STATE(2230),
    [sym_mutate_expression] = STATE(2230),
    [sym_index_expression] = STATE(2230),
    [sym_typed_expression] = STATE(2230),
    [sym_declaration_expression] = STATE(2230),
    [sym_do_expression] = STATE(2230),
    [sym_list_expression] = STATE(2230),
    [sym_array_expression] = STATE(2230),
    [sym_begin_end_expression] = STATE(2230),
    [sym_paren_expression] = STATE(2230),
    [sym__high_prec_app] = STATE(2229),
    [sym__low_prec_app] = STATE(2229),
    [sym_application_expression] = STATE(2230),
    [sym_dot_expression] = STATE(2230),
    [sym_infix_expression] = STATE(2230),
    [sym_ce_expression] = STATE(2230),
    [sym_sequential_expression] = STATE(2230),
    [sym_char] = STATE(2100),
    [sym_format_string] = STATE(2106),
    [sym__string_literal] = STATE(2106),
    [sym_string] = STATE(2100),
    [sym_verbatim_string] = STATE(2100),
    [sym_bytearray] = STATE(2100),
    [sym_verbatim_bytearray] = STATE(2100),
    [sym_format_triple_quoted_string] = STATE(2107),
    [sym_triple_quoted_string] = STATE(2100),
    [sym_const] = STATE(2230),
    [sym_long_identifier] = STATE(2232),
    [sym_active_pattern] = STATE(2424),
    [sym__identifier_or_op] = STATE(2305),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(737),
    [sym_sbyte] = STATE(2100),
    [sym_byte] = STATE(2100),
    [sym_int16] = STATE(2100),
    [sym_uint16] = STATE(2100),
    [sym_int32] = STATE(2100),
    [sym_uint32] = STATE(2100),
    [sym_nativeint] = STATE(2100),
    [sym_unativeint] = STATE(2100),
    [sym_int64] = STATE(2100),
    [sym_uint64] = STATE(2100),
    [sym_ieee32] = STATE(2100),
    [sym_ieee64] = STATE(2100),
    [sym_bignum] = STATE(2100),
    [sym_decimal] = STATE(2100),
    [sym_float] = STATE(1487),
    [sym_block_comment] = STATE(660),
    [sym_compiler_directive_decl] = STATE(660),
    [sym_fsi_directive_decl] = STATE(660),
    [sym_preproc_line] = STATE(660),
    [sym_preproc_if_in_expression] = STATE(2230),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(877),
    [anon_sym_return] = ACTIONS(881),
    [anon_sym_do] = ACTIONS(1585),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(885),
    [anon_sym_null] = ACTIONS(889),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(891),
    [anon_sym_LBRACK_PIPE] = ACTIONS(893),
    [anon_sym_LBRACE] = ACTIONS(2048),
    [anon_sym_LT_AT] = ACTIONS(897),
    [anon_sym_LT_AT_AT] = ACTIONS(2050),
    [anon_sym_LBRACE_PIPE] = ACTIONS(903),
    [anon_sym_new] = ACTIONS(881),
    [anon_sym_return_BANG] = ACTIONS(905),
    [anon_sym_yield] = ACTIONS(881),
    [anon_sym_yield_BANG] = ACTIONS(905),
    [anon_sym_lazy] = ACTIONS(881),
    [anon_sym_assert] = ACTIONS(881),
    [anon_sym_upcast] = ACTIONS(881),
    [anon_sym_downcast] = ACTIONS(881),
    [anon_sym_for] = ACTIONS(909),
    [anon_sym_while] = ACTIONS(911),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(913),
    [anon_sym_try] = ACTIONS(915),
    [anon_sym_match] = ACTIONS(917),
    [anon_sym_match_BANG] = ACTIONS(919),
    [anon_sym_function] = ACTIONS(921),
    [anon_sym_use] = ACTIONS(929),
    [anon_sym_use_BANG] = ACTIONS(931),
    [anon_sym_do_BANG] = ACTIONS(933),
    [anon_sym_begin] = ACTIONS(937),
    [aux_sym_char_token1] = ACTIONS(941),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(943),
    [anon_sym_DQUOTE] = ACTIONS(945),
    [anon_sym_AT_DQUOTE] = ACTIONS(947),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(949),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(951),
    [sym_bool] = ACTIONS(953),
    [sym_unit] = ACTIONS(2052),
    [anon_sym_LPAREN_PIPE] = ACTIONS(957),
    [sym_op_identifier] = ACTIONS(2054),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(961),
    [sym_xint] = ACTIONS(963),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(965),
  },
  [661] = {
    [sym_function_or_value_defn] = STATE(627),
    [sym__expression] = STATE(348),
    [sym_literal_expression] = STATE(1118),
    [sym_long_identifier_or_op] = STATE(1118),
    [sym_tuple_expression] = STATE(1118),
    [sym_brace_expression] = STATE(1118),
    [sym_anon_record_expression] = STATE(1118),
    [sym_prefixed_expression] = STATE(1118),
    [sym_typecast_expression] = STATE(1118),
    [sym_for_expression] = STATE(1118),
    [sym_while_expression] = STATE(1118),
    [sym__if_branch] = STATE(7163),
    [sym_if_expression] = STATE(1118),
    [sym_fun_expression] = STATE(1118),
    [sym_try_expression] = STATE(1118),
    [sym_match_expression] = STATE(1118),
    [sym_function_expression] = STATE(1118),
    [sym_mutate_expression] = STATE(1118),
    [sym_index_expression] = STATE(1118),
    [sym_typed_expression] = STATE(1118),
    [sym_declaration_expression] = STATE(1118),
    [sym_do_expression] = STATE(1118),
    [sym_list_expression] = STATE(1118),
    [sym_array_expression] = STATE(1118),
    [sym_begin_end_expression] = STATE(1118),
    [sym_paren_expression] = STATE(1118),
    [sym__high_prec_app] = STATE(1133),
    [sym__low_prec_app] = STATE(1133),
    [sym_application_expression] = STATE(1118),
    [sym_dot_expression] = STATE(1118),
    [sym_infix_expression] = STATE(1118),
    [sym_ce_expression] = STATE(1118),
    [sym_sequential_expression] = STATE(1118),
    [sym_char] = STATE(1080),
    [sym_format_string] = STATE(1090),
    [sym__string_literal] = STATE(1090),
    [sym_string] = STATE(1080),
    [sym_verbatim_string] = STATE(1080),
    [sym_bytearray] = STATE(1080),
    [sym_verbatim_bytearray] = STATE(1080),
    [sym_format_triple_quoted_string] = STATE(1096),
    [sym_triple_quoted_string] = STATE(1080),
    [sym_const] = STATE(1118),
    [sym_long_identifier] = STATE(1156),
    [sym_active_pattern] = STATE(1085),
    [sym__identifier_or_op] = STATE(1099),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(517),
    [sym_sbyte] = STATE(1080),
    [sym_byte] = STATE(1080),
    [sym_int16] = STATE(1080),
    [sym_uint16] = STATE(1080),
    [sym_int32] = STATE(1080),
    [sym_uint32] = STATE(1080),
    [sym_nativeint] = STATE(1080),
    [sym_unativeint] = STATE(1080),
    [sym_int64] = STATE(1080),
    [sym_uint64] = STATE(1080),
    [sym_ieee32] = STATE(1080),
    [sym_ieee64] = STATE(1080),
    [sym_bignum] = STATE(1080),
    [sym_decimal] = STATE(1080),
    [sym_float] = STATE(979),
    [sym_block_comment] = STATE(661),
    [sym_compiler_directive_decl] = STATE(661),
    [sym_fsi_directive_decl] = STATE(661),
    [sym_preproc_line] = STATE(661),
    [sym_preproc_if_in_expression] = STATE(1118),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(195),
    [anon_sym_return] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_null] = ACTIONS(207),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(209),
    [anon_sym_LBRACK_PIPE] = ACTIONS(211),
    [anon_sym_LBRACE] = ACTIONS(1687),
    [anon_sym_LT_AT] = ACTIONS(213),
    [anon_sym_LT_AT_AT] = ACTIONS(1689),
    [anon_sym_LBRACE_PIPE] = ACTIONS(217),
    [anon_sym_new] = ACTIONS(199),
    [anon_sym_return_BANG] = ACTIONS(219),
    [anon_sym_yield] = ACTIONS(199),
    [anon_sym_yield_BANG] = ACTIONS(219),
    [anon_sym_lazy] = ACTIONS(199),
    [anon_sym_assert] = ACTIONS(199),
    [anon_sym_upcast] = ACTIONS(199),
    [anon_sym_downcast] = ACTIONS(199),
    [anon_sym_for] = ACTIONS(223),
    [anon_sym_while] = ACTIONS(225),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(229),
    [anon_sym_match] = ACTIONS(231),
    [anon_sym_match_BANG] = ACTIONS(233),
    [anon_sym_function] = ACTIONS(235),
    [anon_sym_use] = ACTIONS(239),
    [anon_sym_use_BANG] = ACTIONS(241),
    [anon_sym_do_BANG] = ACTIONS(243),
    [anon_sym_begin] = ACTIONS(245),
    [aux_sym_char_token1] = ACTIONS(247),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(251),
    [anon_sym_AT_DQUOTE] = ACTIONS(253),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(255),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(257),
    [sym_bool] = ACTIONS(259),
    [sym_unit] = ACTIONS(1699),
    [anon_sym_LPAREN_PIPE] = ACTIONS(261),
    [sym_op_identifier] = ACTIONS(1701),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(265),
    [sym_xint] = ACTIONS(267),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(269),
  },
  [662] = {
    [sym_function_or_value_defn] = STATE(704),
    [sym__expression] = STATE(257),
    [sym_literal_expression] = STATE(2403),
    [sym_long_identifier_or_op] = STATE(2403),
    [sym_tuple_expression] = STATE(2403),
    [sym_brace_expression] = STATE(2403),
    [sym_anon_record_expression] = STATE(2403),
    [sym_prefixed_expression] = STATE(2403),
    [sym_typecast_expression] = STATE(2403),
    [sym_for_expression] = STATE(2403),
    [sym_while_expression] = STATE(2403),
    [sym__if_branch] = STATE(6794),
    [sym_if_expression] = STATE(2403),
    [sym_fun_expression] = STATE(2403),
    [sym_try_expression] = STATE(2403),
    [sym_match_expression] = STATE(2403),
    [sym_function_expression] = STATE(2403),
    [sym_mutate_expression] = STATE(2403),
    [sym_index_expression] = STATE(2403),
    [sym_typed_expression] = STATE(2403),
    [sym_declaration_expression] = STATE(2403),
    [sym_do_expression] = STATE(2403),
    [sym_list_expression] = STATE(2403),
    [sym_array_expression] = STATE(2403),
    [sym_begin_end_expression] = STATE(2403),
    [sym_paren_expression] = STATE(2403),
    [sym__high_prec_app] = STATE(2405),
    [sym__low_prec_app] = STATE(2405),
    [sym_application_expression] = STATE(2403),
    [sym_dot_expression] = STATE(2403),
    [sym_infix_expression] = STATE(2403),
    [sym_ce_expression] = STATE(2403),
    [sym_sequential_expression] = STATE(2403),
    [sym_char] = STATE(2425),
    [sym_format_string] = STATE(2420),
    [sym__string_literal] = STATE(2420),
    [sym_string] = STATE(2425),
    [sym_verbatim_string] = STATE(2425),
    [sym_bytearray] = STATE(2425),
    [sym_verbatim_bytearray] = STATE(2425),
    [sym_format_triple_quoted_string] = STATE(2419),
    [sym_triple_quoted_string] = STATE(2425),
    [sym_const] = STATE(2403),
    [sym_long_identifier] = STATE(2079),
    [sym_active_pattern] = STATE(2080),
    [sym__identifier_or_op] = STATE(2089),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(688),
    [sym_sbyte] = STATE(2425),
    [sym_byte] = STATE(2425),
    [sym_int16] = STATE(2425),
    [sym_uint16] = STATE(2425),
    [sym_int32] = STATE(2425),
    [sym_uint32] = STATE(2425),
    [sym_nativeint] = STATE(2425),
    [sym_unativeint] = STATE(2425),
    [sym_int64] = STATE(2425),
    [sym_uint64] = STATE(2425),
    [sym_ieee32] = STATE(2425),
    [sym_ieee64] = STATE(2425),
    [sym_bignum] = STATE(2425),
    [sym_decimal] = STATE(2425),
    [sym_float] = STATE(1511),
    [sym_block_comment] = STATE(662),
    [sym_compiler_directive_decl] = STATE(662),
    [sym_fsi_directive_decl] = STATE(662),
    [sym_preproc_line] = STATE(662),
    [sym_preproc_if_in_expression] = STATE(2403),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(1261),
    [anon_sym_return] = ACTIONS(1265),
    [anon_sym_do] = ACTIONS(1267),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(1269),
    [anon_sym_null] = ACTIONS(1273),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1275),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1277),
    [anon_sym_LBRACE] = ACTIONS(1909),
    [anon_sym_LT_AT] = ACTIONS(1281),
    [anon_sym_LT_AT_AT] = ACTIONS(1911),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1287),
    [anon_sym_new] = ACTIONS(1265),
    [anon_sym_return_BANG] = ACTIONS(1289),
    [anon_sym_yield] = ACTIONS(1265),
    [anon_sym_yield_BANG] = ACTIONS(1289),
    [anon_sym_lazy] = ACTIONS(1265),
    [anon_sym_assert] = ACTIONS(1265),
    [anon_sym_upcast] = ACTIONS(1265),
    [anon_sym_downcast] = ACTIONS(1265),
    [anon_sym_for] = ACTIONS(1293),
    [anon_sym_while] = ACTIONS(1295),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(1297),
    [anon_sym_try] = ACTIONS(1299),
    [anon_sym_match] = ACTIONS(1301),
    [anon_sym_match_BANG] = ACTIONS(1303),
    [anon_sym_function] = ACTIONS(1305),
    [anon_sym_use] = ACTIONS(1313),
    [anon_sym_use_BANG] = ACTIONS(1315),
    [anon_sym_do_BANG] = ACTIONS(1317),
    [anon_sym_begin] = ACTIONS(1319),
    [aux_sym_char_token1] = ACTIONS(1323),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1325),
    [anon_sym_DQUOTE] = ACTIONS(1327),
    [anon_sym_AT_DQUOTE] = ACTIONS(1329),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1331),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1333),
    [sym_bool] = ACTIONS(1335),
    [sym_unit] = ACTIONS(1913),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1339),
    [sym_op_identifier] = ACTIONS(1915),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(1343),
    [sym_xint] = ACTIONS(1345),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1347),
  },
  [663] = {
    [sym_function_or_value_defn] = STATE(663),
    [sym__expression] = STATE(78),
    [sym_literal_expression] = STATE(1118),
    [sym_long_identifier_or_op] = STATE(1118),
    [sym_tuple_expression] = STATE(1118),
    [sym_brace_expression] = STATE(1118),
    [sym_anon_record_expression] = STATE(1118),
    [sym_prefixed_expression] = STATE(1118),
    [sym_typecast_expression] = STATE(1118),
    [sym_for_expression] = STATE(1118),
    [sym_while_expression] = STATE(1118),
    [sym__if_branch] = STATE(7163),
    [sym_if_expression] = STATE(1118),
    [sym_fun_expression] = STATE(1118),
    [sym_try_expression] = STATE(1118),
    [sym_match_expression] = STATE(1118),
    [sym_function_expression] = STATE(1118),
    [sym_mutate_expression] = STATE(1118),
    [sym_index_expression] = STATE(1118),
    [sym_typed_expression] = STATE(1118),
    [sym_declaration_expression] = STATE(1118),
    [sym_do_expression] = STATE(1118),
    [sym_list_expression] = STATE(1118),
    [sym_array_expression] = STATE(1118),
    [sym_begin_end_expression] = STATE(1118),
    [sym_paren_expression] = STATE(1118),
    [sym__high_prec_app] = STATE(1133),
    [sym__low_prec_app] = STATE(1133),
    [sym_application_expression] = STATE(1118),
    [sym_dot_expression] = STATE(1118),
    [sym_infix_expression] = STATE(1118),
    [sym_ce_expression] = STATE(1118),
    [sym_sequential_expression] = STATE(1118),
    [sym_char] = STATE(1080),
    [sym_format_string] = STATE(1090),
    [sym__string_literal] = STATE(1090),
    [sym_string] = STATE(1080),
    [sym_verbatim_string] = STATE(1080),
    [sym_bytearray] = STATE(1080),
    [sym_verbatim_bytearray] = STATE(1080),
    [sym_format_triple_quoted_string] = STATE(1096),
    [sym_triple_quoted_string] = STATE(1080),
    [sym_const] = STATE(1118),
    [sym_long_identifier] = STATE(1156),
    [sym_active_pattern] = STATE(1085),
    [sym__identifier_or_op] = STATE(1099),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(548),
    [sym_sbyte] = STATE(1080),
    [sym_byte] = STATE(1080),
    [sym_int16] = STATE(1080),
    [sym_uint16] = STATE(1080),
    [sym_int32] = STATE(1080),
    [sym_uint32] = STATE(1080),
    [sym_nativeint] = STATE(1080),
    [sym_unativeint] = STATE(1080),
    [sym_int64] = STATE(1080),
    [sym_uint64] = STATE(1080),
    [sym_ieee32] = STATE(1080),
    [sym_ieee64] = STATE(1080),
    [sym_bignum] = STATE(1080),
    [sym_decimal] = STATE(1080),
    [sym_float] = STATE(979),
    [sym_block_comment] = STATE(663),
    [sym_compiler_directive_decl] = STATE(663),
    [sym_fsi_directive_decl] = STATE(663),
    [sym_preproc_line] = STATE(663),
    [sym_preproc_if_in_expression] = STATE(1118),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(195),
    [anon_sym_return] = ACTIONS(481),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_null] = ACTIONS(207),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(209),
    [anon_sym_LBRACK_PIPE] = ACTIONS(211),
    [anon_sym_LBRACE] = ACTIONS(1687),
    [anon_sym_LT_AT] = ACTIONS(213),
    [anon_sym_LT_AT_AT] = ACTIONS(1689),
    [anon_sym_LBRACE_PIPE] = ACTIONS(217),
    [anon_sym_new] = ACTIONS(481),
    [anon_sym_return_BANG] = ACTIONS(487),
    [anon_sym_yield] = ACTIONS(481),
    [anon_sym_yield_BANG] = ACTIONS(487),
    [anon_sym_lazy] = ACTIONS(481),
    [anon_sym_assert] = ACTIONS(481),
    [anon_sym_upcast] = ACTIONS(481),
    [anon_sym_downcast] = ACTIONS(481),
    [anon_sym_for] = ACTIONS(489),
    [anon_sym_while] = ACTIONS(225),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(229),
    [anon_sym_match] = ACTIONS(231),
    [anon_sym_match_BANG] = ACTIONS(233),
    [anon_sym_function] = ACTIONS(235),
    [anon_sym_use] = ACTIONS(493),
    [anon_sym_use_BANG] = ACTIONS(495),
    [anon_sym_do_BANG] = ACTIONS(243),
    [anon_sym_begin] = ACTIONS(245),
    [aux_sym_char_token1] = ACTIONS(247),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(251),
    [anon_sym_AT_DQUOTE] = ACTIONS(253),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(255),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(257),
    [sym_bool] = ACTIONS(259),
    [sym_unit] = ACTIONS(1699),
    [anon_sym_LPAREN_PIPE] = ACTIONS(261),
    [sym_op_identifier] = ACTIONS(1701),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(499),
    [sym_xint] = ACTIONS(267),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(269),
  },
  [664] = {
    [sym_function_or_value_defn] = STATE(535),
    [sym__expression] = STATE(44),
    [sym_literal_expression] = STATE(2008),
    [sym_long_identifier_or_op] = STATE(2008),
    [sym_tuple_expression] = STATE(2008),
    [sym_brace_expression] = STATE(2008),
    [sym_anon_record_expression] = STATE(2008),
    [sym_prefixed_expression] = STATE(2008),
    [sym_typecast_expression] = STATE(2008),
    [sym_for_expression] = STATE(2008),
    [sym_while_expression] = STATE(2008),
    [sym__if_branch] = STATE(6754),
    [sym_if_expression] = STATE(2008),
    [sym_fun_expression] = STATE(2008),
    [sym_try_expression] = STATE(2008),
    [sym_match_expression] = STATE(2008),
    [sym_function_expression] = STATE(2008),
    [sym_mutate_expression] = STATE(2008),
    [sym_index_expression] = STATE(2008),
    [sym_typed_expression] = STATE(2008),
    [sym_declaration_expression] = STATE(2008),
    [sym_do_expression] = STATE(2008),
    [sym_list_expression] = STATE(2008),
    [sym_array_expression] = STATE(2008),
    [sym_begin_end_expression] = STATE(2008),
    [sym_paren_expression] = STATE(2008),
    [sym__high_prec_app] = STATE(2007),
    [sym__low_prec_app] = STATE(2007),
    [sym_application_expression] = STATE(2008),
    [sym_dot_expression] = STATE(2008),
    [sym_infix_expression] = STATE(2008),
    [sym_ce_expression] = STATE(2008),
    [sym_sequential_expression] = STATE(2008),
    [sym_char] = STATE(1859),
    [sym_format_string] = STATE(1861),
    [sym__string_literal] = STATE(1861),
    [sym_string] = STATE(1859),
    [sym_verbatim_string] = STATE(1859),
    [sym_bytearray] = STATE(1859),
    [sym_verbatim_bytearray] = STATE(1859),
    [sym_format_triple_quoted_string] = STATE(1862),
    [sym_triple_quoted_string] = STATE(1859),
    [sym_const] = STATE(2008),
    [sym_long_identifier] = STATE(1701),
    [sym_active_pattern] = STATE(1702),
    [sym__identifier_or_op] = STATE(1724),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(664),
    [sym_sbyte] = STATE(1859),
    [sym_byte] = STATE(1859),
    [sym_int16] = STATE(1859),
    [sym_uint16] = STATE(1859),
    [sym_int32] = STATE(1859),
    [sym_uint32] = STATE(1859),
    [sym_nativeint] = STATE(1859),
    [sym_unativeint] = STATE(1859),
    [sym_int64] = STATE(1859),
    [sym_uint64] = STATE(1859),
    [sym_ieee32] = STATE(1859),
    [sym_ieee64] = STATE(1859),
    [sym_bignum] = STATE(1859),
    [sym_decimal] = STATE(1859),
    [sym_float] = STATE(1447),
    [sym_block_comment] = STATE(664),
    [sym_compiler_directive_decl] = STATE(664),
    [sym_fsi_directive_decl] = STATE(664),
    [sym_preproc_line] = STATE(664),
    [sym_preproc_if_in_expression] = STATE(2008),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(503),
    [anon_sym_return] = ACTIONS(507),
    [anon_sym_do] = ACTIONS(599),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(511),
    [anon_sym_null] = ACTIONS(515),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(517),
    [anon_sym_LBRACK_PIPE] = ACTIONS(519),
    [anon_sym_LBRACE] = ACTIONS(2060),
    [anon_sym_LT_AT] = ACTIONS(523),
    [anon_sym_LT_AT_AT] = ACTIONS(2062),
    [anon_sym_LBRACE_PIPE] = ACTIONS(529),
    [anon_sym_new] = ACTIONS(507),
    [anon_sym_return_BANG] = ACTIONS(531),
    [anon_sym_yield] = ACTIONS(507),
    [anon_sym_yield_BANG] = ACTIONS(531),
    [anon_sym_lazy] = ACTIONS(507),
    [anon_sym_assert] = ACTIONS(507),
    [anon_sym_upcast] = ACTIONS(507),
    [anon_sym_downcast] = ACTIONS(507),
    [anon_sym_for] = ACTIONS(535),
    [anon_sym_while] = ACTIONS(537),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(539),
    [anon_sym_try] = ACTIONS(543),
    [anon_sym_match] = ACTIONS(545),
    [anon_sym_match_BANG] = ACTIONS(547),
    [anon_sym_function] = ACTIONS(549),
    [anon_sym_use] = ACTIONS(557),
    [anon_sym_use_BANG] = ACTIONS(559),
    [anon_sym_do_BANG] = ACTIONS(561),
    [anon_sym_begin] = ACTIONS(565),
    [aux_sym_char_token1] = ACTIONS(569),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(571),
    [anon_sym_DQUOTE] = ACTIONS(573),
    [anon_sym_AT_DQUOTE] = ACTIONS(575),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(577),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(579),
    [sym_bool] = ACTIONS(581),
    [sym_unit] = ACTIONS(2064),
    [anon_sym_LPAREN_PIPE] = ACTIONS(585),
    [sym_op_identifier] = ACTIONS(2066),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(589),
    [sym_xint] = ACTIONS(591),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(593),
  },
  [665] = {
    [sym_function_or_value_defn] = STATE(733),
    [sym__expression] = STATE(316),
    [sym_literal_expression] = STATE(2008),
    [sym_long_identifier_or_op] = STATE(2008),
    [sym_tuple_expression] = STATE(2008),
    [sym_brace_expression] = STATE(2008),
    [sym_anon_record_expression] = STATE(2008),
    [sym_prefixed_expression] = STATE(2008),
    [sym_typecast_expression] = STATE(2008),
    [sym_for_expression] = STATE(2008),
    [sym_while_expression] = STATE(2008),
    [sym__if_branch] = STATE(6754),
    [sym_if_expression] = STATE(2008),
    [sym_fun_expression] = STATE(2008),
    [sym_try_expression] = STATE(2008),
    [sym_match_expression] = STATE(2008),
    [sym_function_expression] = STATE(2008),
    [sym_mutate_expression] = STATE(2008),
    [sym_index_expression] = STATE(2008),
    [sym_typed_expression] = STATE(2008),
    [sym_declaration_expression] = STATE(2008),
    [sym_do_expression] = STATE(2008),
    [sym_list_expression] = STATE(2008),
    [sym_array_expression] = STATE(2008),
    [sym_begin_end_expression] = STATE(2008),
    [sym_paren_expression] = STATE(2008),
    [sym__high_prec_app] = STATE(2007),
    [sym__low_prec_app] = STATE(2007),
    [sym_application_expression] = STATE(2008),
    [sym_dot_expression] = STATE(2008),
    [sym_infix_expression] = STATE(2008),
    [sym_ce_expression] = STATE(2008),
    [sym_sequential_expression] = STATE(2008),
    [sym_char] = STATE(1859),
    [sym_format_string] = STATE(1861),
    [sym__string_literal] = STATE(1861),
    [sym_string] = STATE(1859),
    [sym_verbatim_string] = STATE(1859),
    [sym_bytearray] = STATE(1859),
    [sym_verbatim_bytearray] = STATE(1859),
    [sym_format_triple_quoted_string] = STATE(1862),
    [sym_triple_quoted_string] = STATE(1859),
    [sym_const] = STATE(2008),
    [sym_long_identifier] = STATE(1701),
    [sym_active_pattern] = STATE(1702),
    [sym__identifier_or_op] = STATE(1724),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(706),
    [sym_sbyte] = STATE(1859),
    [sym_byte] = STATE(1859),
    [sym_int16] = STATE(1859),
    [sym_uint16] = STATE(1859),
    [sym_int32] = STATE(1859),
    [sym_uint32] = STATE(1859),
    [sym_nativeint] = STATE(1859),
    [sym_unativeint] = STATE(1859),
    [sym_int64] = STATE(1859),
    [sym_uint64] = STATE(1859),
    [sym_ieee32] = STATE(1859),
    [sym_ieee64] = STATE(1859),
    [sym_bignum] = STATE(1859),
    [sym_decimal] = STATE(1859),
    [sym_float] = STATE(1447),
    [sym_block_comment] = STATE(665),
    [sym_compiler_directive_decl] = STATE(665),
    [sym_fsi_directive_decl] = STATE(665),
    [sym_preproc_line] = STATE(665),
    [sym_preproc_if_in_expression] = STATE(2008),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(503),
    [anon_sym_return] = ACTIONS(971),
    [anon_sym_do] = ACTIONS(599),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(511),
    [anon_sym_null] = ACTIONS(515),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(517),
    [anon_sym_LBRACK_PIPE] = ACTIONS(519),
    [anon_sym_LBRACE] = ACTIONS(2060),
    [anon_sym_LT_AT] = ACTIONS(523),
    [anon_sym_LT_AT_AT] = ACTIONS(2062),
    [anon_sym_LBRACE_PIPE] = ACTIONS(529),
    [anon_sym_new] = ACTIONS(971),
    [anon_sym_return_BANG] = ACTIONS(975),
    [anon_sym_yield] = ACTIONS(971),
    [anon_sym_yield_BANG] = ACTIONS(975),
    [anon_sym_lazy] = ACTIONS(971),
    [anon_sym_assert] = ACTIONS(971),
    [anon_sym_upcast] = ACTIONS(971),
    [anon_sym_downcast] = ACTIONS(971),
    [anon_sym_for] = ACTIONS(979),
    [anon_sym_while] = ACTIONS(537),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(539),
    [anon_sym_try] = ACTIONS(543),
    [anon_sym_match] = ACTIONS(545),
    [anon_sym_match_BANG] = ACTIONS(547),
    [anon_sym_function] = ACTIONS(549),
    [anon_sym_use] = ACTIONS(983),
    [anon_sym_use_BANG] = ACTIONS(985),
    [anon_sym_do_BANG] = ACTIONS(561),
    [anon_sym_begin] = ACTIONS(565),
    [aux_sym_char_token1] = ACTIONS(569),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(571),
    [anon_sym_DQUOTE] = ACTIONS(573),
    [anon_sym_AT_DQUOTE] = ACTIONS(575),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(577),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(579),
    [sym_bool] = ACTIONS(581),
    [sym_unit] = ACTIONS(2064),
    [anon_sym_LPAREN_PIPE] = ACTIONS(585),
    [sym_op_identifier] = ACTIONS(2066),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(591),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(593),
  },
  [666] = {
    [sym_function_or_value_defn] = STATE(600),
    [sym__expression] = STATE(262),
    [sym_literal_expression] = STATE(867),
    [sym_long_identifier_or_op] = STATE(867),
    [sym_tuple_expression] = STATE(867),
    [sym_brace_expression] = STATE(867),
    [sym_anon_record_expression] = STATE(867),
    [sym_prefixed_expression] = STATE(867),
    [sym_typecast_expression] = STATE(867),
    [sym_for_expression] = STATE(867),
    [sym_while_expression] = STATE(867),
    [sym__if_branch] = STATE(6511),
    [sym_if_expression] = STATE(867),
    [sym_fun_expression] = STATE(867),
    [sym_try_expression] = STATE(867),
    [sym_match_expression] = STATE(867),
    [sym_function_expression] = STATE(867),
    [sym_mutate_expression] = STATE(867),
    [sym_index_expression] = STATE(867),
    [sym_typed_expression] = STATE(867),
    [sym_declaration_expression] = STATE(867),
    [sym_do_expression] = STATE(867),
    [sym_list_expression] = STATE(867),
    [sym_array_expression] = STATE(867),
    [sym_begin_end_expression] = STATE(867),
    [sym_paren_expression] = STATE(867),
    [sym__high_prec_app] = STATE(864),
    [sym__low_prec_app] = STATE(864),
    [sym_application_expression] = STATE(867),
    [sym_dot_expression] = STATE(867),
    [sym_infix_expression] = STATE(867),
    [sym_ce_expression] = STATE(867),
    [sym_sequential_expression] = STATE(867),
    [sym_char] = STATE(868),
    [sym_format_string] = STATE(869),
    [sym__string_literal] = STATE(869),
    [sym_string] = STATE(868),
    [sym_verbatim_string] = STATE(868),
    [sym_bytearray] = STATE(868),
    [sym_verbatim_bytearray] = STATE(868),
    [sym_format_triple_quoted_string] = STATE(870),
    [sym_triple_quoted_string] = STATE(868),
    [sym_const] = STATE(867),
    [sym_long_identifier] = STATE(872),
    [sym_active_pattern] = STATE(871),
    [sym__identifier_or_op] = STATE(873),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(656),
    [sym_sbyte] = STATE(868),
    [sym_byte] = STATE(868),
    [sym_int16] = STATE(868),
    [sym_uint16] = STATE(868),
    [sym_int32] = STATE(868),
    [sym_uint32] = STATE(868),
    [sym_nativeint] = STATE(868),
    [sym_unativeint] = STATE(868),
    [sym_int64] = STATE(868),
    [sym_uint64] = STATE(868),
    [sym_ieee32] = STATE(868),
    [sym_ieee64] = STATE(868),
    [sym_bignum] = STATE(868),
    [sym_decimal] = STATE(868),
    [sym_float] = STATE(1368),
    [sym_block_comment] = STATE(666),
    [sym_compiler_directive_decl] = STATE(666),
    [sym_fsi_directive_decl] = STATE(666),
    [sym_preproc_line] = STATE(666),
    [sym_preproc_if_in_expression] = STATE(867),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(29),
    [anon_sym_return] = ACTIONS(825),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_null] = ACTIONS(49),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACK_PIPE] = ACTIONS(57),
    [anon_sym_LBRACE] = ACTIONS(1663),
    [anon_sym_LT_AT] = ACTIONS(61),
    [anon_sym_LT_AT_AT] = ACTIONS(1665),
    [anon_sym_LBRACE_PIPE] = ACTIONS(67),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_return_BANG] = ACTIONS(829),
    [anon_sym_yield] = ACTIONS(825),
    [anon_sym_yield_BANG] = ACTIONS(829),
    [anon_sym_lazy] = ACTIONS(825),
    [anon_sym_assert] = ACTIONS(825),
    [anon_sym_upcast] = ACTIONS(825),
    [anon_sym_downcast] = ACTIONS(825),
    [anon_sym_for] = ACTIONS(73),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(79),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_match] = ACTIONS(83),
    [anon_sym_match_BANG] = ACTIONS(85),
    [anon_sym_function] = ACTIONS(87),
    [anon_sym_use] = ACTIONS(833),
    [anon_sym_use_BANG] = ACTIONS(835),
    [anon_sym_do_BANG] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(101),
    [aux_sym_char_token1] = ACTIONS(105),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(107),
    [anon_sym_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DQUOTE] = ACTIONS(111),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(115),
    [sym_bool] = ACTIONS(117),
    [sym_unit] = ACTIONS(1673),
    [anon_sym_LPAREN_PIPE] = ACTIONS(121),
    [sym_op_identifier] = ACTIONS(1675),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(837),
    [sym_xint] = ACTIONS(387),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(135),
  },
  [667] = {
    [sym_function_or_value_defn] = STATE(704),
    [sym__expression] = STATE(263),
    [sym_literal_expression] = STATE(2403),
    [sym_long_identifier_or_op] = STATE(2403),
    [sym_tuple_expression] = STATE(2403),
    [sym_brace_expression] = STATE(2403),
    [sym_anon_record_expression] = STATE(2403),
    [sym_prefixed_expression] = STATE(2403),
    [sym_typecast_expression] = STATE(2403),
    [sym_for_expression] = STATE(2403),
    [sym_while_expression] = STATE(2403),
    [sym__if_branch] = STATE(6794),
    [sym_if_expression] = STATE(2403),
    [sym_fun_expression] = STATE(2403),
    [sym_try_expression] = STATE(2403),
    [sym_match_expression] = STATE(2403),
    [sym_function_expression] = STATE(2403),
    [sym_mutate_expression] = STATE(2403),
    [sym_index_expression] = STATE(2403),
    [sym_typed_expression] = STATE(2403),
    [sym_declaration_expression] = STATE(2403),
    [sym_do_expression] = STATE(2403),
    [sym_list_expression] = STATE(2403),
    [sym_array_expression] = STATE(2403),
    [sym_begin_end_expression] = STATE(2403),
    [sym_paren_expression] = STATE(2403),
    [sym__high_prec_app] = STATE(2405),
    [sym__low_prec_app] = STATE(2405),
    [sym_application_expression] = STATE(2403),
    [sym_dot_expression] = STATE(2403),
    [sym_infix_expression] = STATE(2403),
    [sym_ce_expression] = STATE(2403),
    [sym_sequential_expression] = STATE(2403),
    [sym_char] = STATE(2425),
    [sym_format_string] = STATE(2420),
    [sym__string_literal] = STATE(2420),
    [sym_string] = STATE(2425),
    [sym_verbatim_string] = STATE(2425),
    [sym_bytearray] = STATE(2425),
    [sym_verbatim_bytearray] = STATE(2425),
    [sym_format_triple_quoted_string] = STATE(2419),
    [sym_triple_quoted_string] = STATE(2425),
    [sym_const] = STATE(2403),
    [sym_long_identifier] = STATE(2079),
    [sym_active_pattern] = STATE(2080),
    [sym__identifier_or_op] = STATE(2089),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(688),
    [sym_sbyte] = STATE(2425),
    [sym_byte] = STATE(2425),
    [sym_int16] = STATE(2425),
    [sym_uint16] = STATE(2425),
    [sym_int32] = STATE(2425),
    [sym_uint32] = STATE(2425),
    [sym_nativeint] = STATE(2425),
    [sym_unativeint] = STATE(2425),
    [sym_int64] = STATE(2425),
    [sym_uint64] = STATE(2425),
    [sym_ieee32] = STATE(2425),
    [sym_ieee64] = STATE(2425),
    [sym_bignum] = STATE(2425),
    [sym_decimal] = STATE(2425),
    [sym_float] = STATE(1511),
    [sym_block_comment] = STATE(667),
    [sym_compiler_directive_decl] = STATE(667),
    [sym_fsi_directive_decl] = STATE(667),
    [sym_preproc_line] = STATE(667),
    [sym_preproc_if_in_expression] = STATE(2403),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(1261),
    [anon_sym_return] = ACTIONS(1265),
    [anon_sym_do] = ACTIONS(1267),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(1269),
    [anon_sym_null] = ACTIONS(1273),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1275),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1277),
    [anon_sym_LBRACE] = ACTIONS(1909),
    [anon_sym_LT_AT] = ACTIONS(1281),
    [anon_sym_LT_AT_AT] = ACTIONS(1911),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1287),
    [anon_sym_new] = ACTIONS(1265),
    [anon_sym_return_BANG] = ACTIONS(1289),
    [anon_sym_yield] = ACTIONS(1265),
    [anon_sym_yield_BANG] = ACTIONS(1289),
    [anon_sym_lazy] = ACTIONS(1265),
    [anon_sym_assert] = ACTIONS(1265),
    [anon_sym_upcast] = ACTIONS(1265),
    [anon_sym_downcast] = ACTIONS(1265),
    [anon_sym_for] = ACTIONS(1293),
    [anon_sym_while] = ACTIONS(1295),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(1297),
    [anon_sym_try] = ACTIONS(1299),
    [anon_sym_match] = ACTIONS(1301),
    [anon_sym_match_BANG] = ACTIONS(1303),
    [anon_sym_function] = ACTIONS(1305),
    [anon_sym_use] = ACTIONS(1313),
    [anon_sym_use_BANG] = ACTIONS(1315),
    [anon_sym_do_BANG] = ACTIONS(1317),
    [anon_sym_begin] = ACTIONS(1319),
    [aux_sym_char_token1] = ACTIONS(1323),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1325),
    [anon_sym_DQUOTE] = ACTIONS(1327),
    [anon_sym_AT_DQUOTE] = ACTIONS(1329),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1331),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1333),
    [sym_bool] = ACTIONS(1335),
    [sym_unit] = ACTIONS(1913),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1339),
    [sym_op_identifier] = ACTIONS(1915),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(1343),
    [sym_xint] = ACTIONS(1345),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1347),
  },
  [668] = {
    [sym_function_or_value_defn] = STATE(704),
    [sym__expression] = STATE(278),
    [sym_literal_expression] = STATE(2403),
    [sym_long_identifier_or_op] = STATE(2403),
    [sym_tuple_expression] = STATE(2403),
    [sym_brace_expression] = STATE(2403),
    [sym_anon_record_expression] = STATE(2403),
    [sym_prefixed_expression] = STATE(2403),
    [sym_typecast_expression] = STATE(2403),
    [sym_for_expression] = STATE(2403),
    [sym_while_expression] = STATE(2403),
    [sym__if_branch] = STATE(6794),
    [sym_if_expression] = STATE(2403),
    [sym_fun_expression] = STATE(2403),
    [sym_try_expression] = STATE(2403),
    [sym_match_expression] = STATE(2403),
    [sym_function_expression] = STATE(2403),
    [sym_mutate_expression] = STATE(2403),
    [sym_index_expression] = STATE(2403),
    [sym_typed_expression] = STATE(2403),
    [sym_declaration_expression] = STATE(2403),
    [sym_do_expression] = STATE(2403),
    [sym_list_expression] = STATE(2403),
    [sym_array_expression] = STATE(2403),
    [sym_begin_end_expression] = STATE(2403),
    [sym_paren_expression] = STATE(2403),
    [sym__high_prec_app] = STATE(2405),
    [sym__low_prec_app] = STATE(2405),
    [sym_application_expression] = STATE(2403),
    [sym_dot_expression] = STATE(2403),
    [sym_infix_expression] = STATE(2403),
    [sym_ce_expression] = STATE(2403),
    [sym_sequential_expression] = STATE(2403),
    [sym_char] = STATE(2425),
    [sym_format_string] = STATE(2420),
    [sym__string_literal] = STATE(2420),
    [sym_string] = STATE(2425),
    [sym_verbatim_string] = STATE(2425),
    [sym_bytearray] = STATE(2425),
    [sym_verbatim_bytearray] = STATE(2425),
    [sym_format_triple_quoted_string] = STATE(2419),
    [sym_triple_quoted_string] = STATE(2425),
    [sym_const] = STATE(2403),
    [sym_long_identifier] = STATE(2079),
    [sym_active_pattern] = STATE(2080),
    [sym__identifier_or_op] = STATE(2089),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(688),
    [sym_sbyte] = STATE(2425),
    [sym_byte] = STATE(2425),
    [sym_int16] = STATE(2425),
    [sym_uint16] = STATE(2425),
    [sym_int32] = STATE(2425),
    [sym_uint32] = STATE(2425),
    [sym_nativeint] = STATE(2425),
    [sym_unativeint] = STATE(2425),
    [sym_int64] = STATE(2425),
    [sym_uint64] = STATE(2425),
    [sym_ieee32] = STATE(2425),
    [sym_ieee64] = STATE(2425),
    [sym_bignum] = STATE(2425),
    [sym_decimal] = STATE(2425),
    [sym_float] = STATE(1511),
    [sym_block_comment] = STATE(668),
    [sym_compiler_directive_decl] = STATE(668),
    [sym_fsi_directive_decl] = STATE(668),
    [sym_preproc_line] = STATE(668),
    [sym_preproc_if_in_expression] = STATE(2403),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(1261),
    [anon_sym_return] = ACTIONS(1265),
    [anon_sym_do] = ACTIONS(1267),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(1269),
    [anon_sym_null] = ACTIONS(1273),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1275),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1277),
    [anon_sym_LBRACE] = ACTIONS(1909),
    [anon_sym_LT_AT] = ACTIONS(1281),
    [anon_sym_LT_AT_AT] = ACTIONS(1911),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1287),
    [anon_sym_new] = ACTIONS(1265),
    [anon_sym_return_BANG] = ACTIONS(1289),
    [anon_sym_yield] = ACTIONS(1265),
    [anon_sym_yield_BANG] = ACTIONS(1289),
    [anon_sym_lazy] = ACTIONS(1265),
    [anon_sym_assert] = ACTIONS(1265),
    [anon_sym_upcast] = ACTIONS(1265),
    [anon_sym_downcast] = ACTIONS(1265),
    [anon_sym_for] = ACTIONS(1293),
    [anon_sym_while] = ACTIONS(1295),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(1297),
    [anon_sym_try] = ACTIONS(1299),
    [anon_sym_match] = ACTIONS(1301),
    [anon_sym_match_BANG] = ACTIONS(1303),
    [anon_sym_function] = ACTIONS(1305),
    [anon_sym_use] = ACTIONS(1313),
    [anon_sym_use_BANG] = ACTIONS(1315),
    [anon_sym_do_BANG] = ACTIONS(1317),
    [anon_sym_begin] = ACTIONS(1319),
    [aux_sym_char_token1] = ACTIONS(1323),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1325),
    [anon_sym_DQUOTE] = ACTIONS(1327),
    [anon_sym_AT_DQUOTE] = ACTIONS(1329),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1331),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1333),
    [sym_bool] = ACTIONS(1335),
    [sym_unit] = ACTIONS(1913),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1339),
    [sym_op_identifier] = ACTIONS(1915),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(1343),
    [sym_xint] = ACTIONS(1345),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1347),
  },
  [669] = {
    [sym_function_or_value_defn] = STATE(627),
    [sym__expression] = STATE(339),
    [sym_literal_expression] = STATE(1118),
    [sym_long_identifier_or_op] = STATE(1118),
    [sym_tuple_expression] = STATE(1118),
    [sym_brace_expression] = STATE(1118),
    [sym_anon_record_expression] = STATE(1118),
    [sym_prefixed_expression] = STATE(1118),
    [sym_typecast_expression] = STATE(1118),
    [sym_for_expression] = STATE(1118),
    [sym_while_expression] = STATE(1118),
    [sym__if_branch] = STATE(7163),
    [sym_if_expression] = STATE(1118),
    [sym_fun_expression] = STATE(1118),
    [sym_try_expression] = STATE(1118),
    [sym_match_expression] = STATE(1118),
    [sym_function_expression] = STATE(1118),
    [sym_mutate_expression] = STATE(1118),
    [sym_index_expression] = STATE(1118),
    [sym_typed_expression] = STATE(1118),
    [sym_declaration_expression] = STATE(1118),
    [sym_do_expression] = STATE(1118),
    [sym_list_expression] = STATE(1118),
    [sym_array_expression] = STATE(1118),
    [sym_begin_end_expression] = STATE(1118),
    [sym_paren_expression] = STATE(1118),
    [sym__high_prec_app] = STATE(1133),
    [sym__low_prec_app] = STATE(1133),
    [sym_application_expression] = STATE(1118),
    [sym_dot_expression] = STATE(1118),
    [sym_infix_expression] = STATE(1118),
    [sym_ce_expression] = STATE(1118),
    [sym_sequential_expression] = STATE(1118),
    [sym_char] = STATE(1080),
    [sym_format_string] = STATE(1090),
    [sym__string_literal] = STATE(1090),
    [sym_string] = STATE(1080),
    [sym_verbatim_string] = STATE(1080),
    [sym_bytearray] = STATE(1080),
    [sym_verbatim_bytearray] = STATE(1080),
    [sym_format_triple_quoted_string] = STATE(1096),
    [sym_triple_quoted_string] = STATE(1080),
    [sym_const] = STATE(1118),
    [sym_long_identifier] = STATE(1156),
    [sym_active_pattern] = STATE(1085),
    [sym__identifier_or_op] = STATE(1099),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(517),
    [sym_sbyte] = STATE(1080),
    [sym_byte] = STATE(1080),
    [sym_int16] = STATE(1080),
    [sym_uint16] = STATE(1080),
    [sym_int32] = STATE(1080),
    [sym_uint32] = STATE(1080),
    [sym_nativeint] = STATE(1080),
    [sym_unativeint] = STATE(1080),
    [sym_int64] = STATE(1080),
    [sym_uint64] = STATE(1080),
    [sym_ieee32] = STATE(1080),
    [sym_ieee64] = STATE(1080),
    [sym_bignum] = STATE(1080),
    [sym_decimal] = STATE(1080),
    [sym_float] = STATE(979),
    [sym_block_comment] = STATE(669),
    [sym_compiler_directive_decl] = STATE(669),
    [sym_fsi_directive_decl] = STATE(669),
    [sym_preproc_line] = STATE(669),
    [sym_preproc_if_in_expression] = STATE(1118),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(195),
    [anon_sym_return] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_null] = ACTIONS(207),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(209),
    [anon_sym_LBRACK_PIPE] = ACTIONS(211),
    [anon_sym_LBRACE] = ACTIONS(1687),
    [anon_sym_LT_AT] = ACTIONS(213),
    [anon_sym_LT_AT_AT] = ACTIONS(1689),
    [anon_sym_LBRACE_PIPE] = ACTIONS(217),
    [anon_sym_new] = ACTIONS(199),
    [anon_sym_return_BANG] = ACTIONS(219),
    [anon_sym_yield] = ACTIONS(199),
    [anon_sym_yield_BANG] = ACTIONS(219),
    [anon_sym_lazy] = ACTIONS(199),
    [anon_sym_assert] = ACTIONS(199),
    [anon_sym_upcast] = ACTIONS(199),
    [anon_sym_downcast] = ACTIONS(199),
    [anon_sym_for] = ACTIONS(223),
    [anon_sym_while] = ACTIONS(225),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(229),
    [anon_sym_match] = ACTIONS(231),
    [anon_sym_match_BANG] = ACTIONS(233),
    [anon_sym_function] = ACTIONS(235),
    [anon_sym_use] = ACTIONS(239),
    [anon_sym_use_BANG] = ACTIONS(241),
    [anon_sym_do_BANG] = ACTIONS(243),
    [anon_sym_begin] = ACTIONS(245),
    [aux_sym_char_token1] = ACTIONS(247),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(251),
    [anon_sym_AT_DQUOTE] = ACTIONS(253),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(255),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(257),
    [sym_bool] = ACTIONS(259),
    [sym_unit] = ACTIONS(1699),
    [anon_sym_LPAREN_PIPE] = ACTIONS(261),
    [sym_op_identifier] = ACTIONS(1701),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(265),
    [sym_xint] = ACTIONS(267),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(269),
  },
  [670] = {
    [sym_function_or_value_defn] = STATE(482),
    [sym__expression] = STATE(26),
    [sym_literal_expression] = STATE(1537),
    [sym_long_identifier_or_op] = STATE(1537),
    [sym_tuple_expression] = STATE(1537),
    [sym_brace_expression] = STATE(1537),
    [sym_anon_record_expression] = STATE(1537),
    [sym_prefixed_expression] = STATE(1537),
    [sym_typecast_expression] = STATE(1537),
    [sym_for_expression] = STATE(1537),
    [sym_while_expression] = STATE(1537),
    [sym__if_branch] = STATE(6834),
    [sym_if_expression] = STATE(1537),
    [sym_fun_expression] = STATE(1537),
    [sym_try_expression] = STATE(1537),
    [sym_match_expression] = STATE(1537),
    [sym_function_expression] = STATE(1537),
    [sym_mutate_expression] = STATE(1537),
    [sym_index_expression] = STATE(1537),
    [sym_typed_expression] = STATE(1537),
    [sym_declaration_expression] = STATE(1537),
    [sym_do_expression] = STATE(1537),
    [sym_list_expression] = STATE(1537),
    [sym_array_expression] = STATE(1537),
    [sym_begin_end_expression] = STATE(1537),
    [sym_paren_expression] = STATE(1537),
    [sym__high_prec_app] = STATE(1538),
    [sym__low_prec_app] = STATE(1538),
    [sym_application_expression] = STATE(1537),
    [sym_dot_expression] = STATE(1537),
    [sym_infix_expression] = STATE(1537),
    [sym_ce_expression] = STATE(1537),
    [sym_sequential_expression] = STATE(1537),
    [sym_char] = STATE(1484),
    [sym_format_string] = STATE(1483),
    [sym__string_literal] = STATE(1483),
    [sym_string] = STATE(1484),
    [sym_verbatim_string] = STATE(1484),
    [sym_bytearray] = STATE(1484),
    [sym_verbatim_bytearray] = STATE(1484),
    [sym_format_triple_quoted_string] = STATE(1482),
    [sym_triple_quoted_string] = STATE(1484),
    [sym_const] = STATE(1537),
    [sym_long_identifier] = STATE(1643),
    [sym_active_pattern] = STATE(1645),
    [sym__identifier_or_op] = STATE(1689),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(670),
    [sym_sbyte] = STATE(1484),
    [sym_byte] = STATE(1484),
    [sym_int16] = STATE(1484),
    [sym_uint16] = STATE(1484),
    [sym_int32] = STATE(1484),
    [sym_uint32] = STATE(1484),
    [sym_nativeint] = STATE(1484),
    [sym_unativeint] = STATE(1484),
    [sym_int64] = STATE(1484),
    [sym_uint64] = STATE(1484),
    [sym_ieee32] = STATE(1484),
    [sym_ieee64] = STATE(1484),
    [sym_bignum] = STATE(1484),
    [sym_decimal] = STATE(1484),
    [sym_float] = STATE(1327),
    [sym_block_comment] = STATE(670),
    [sym_compiler_directive_decl] = STATE(670),
    [sym_fsi_directive_decl] = STATE(670),
    [sym_preproc_line] = STATE(670),
    [sym_preproc_if_in_expression] = STATE(1537),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(275),
    [anon_sym_return] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(281),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(285),
    [anon_sym_null] = ACTIONS(289),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(291),
    [anon_sym_LBRACK_PIPE] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(2128),
    [anon_sym_LT_AT] = ACTIONS(297),
    [anon_sym_LT_AT_AT] = ACTIONS(2130),
    [anon_sym_LBRACE_PIPE] = ACTIONS(303),
    [anon_sym_new] = ACTIONS(279),
    [anon_sym_return_BANG] = ACTIONS(307),
    [anon_sym_yield] = ACTIONS(279),
    [anon_sym_yield_BANG] = ACTIONS(307),
    [anon_sym_lazy] = ACTIONS(279),
    [anon_sym_assert] = ACTIONS(279),
    [anon_sym_upcast] = ACTIONS(279),
    [anon_sym_downcast] = ACTIONS(279),
    [anon_sym_for] = ACTIONS(311),
    [anon_sym_while] = ACTIONS(313),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(315),
    [anon_sym_try] = ACTIONS(317),
    [anon_sym_match] = ACTIONS(319),
    [anon_sym_match_BANG] = ACTIONS(321),
    [anon_sym_function] = ACTIONS(323),
    [anon_sym_use] = ACTIONS(331),
    [anon_sym_use_BANG] = ACTIONS(333),
    [anon_sym_do_BANG] = ACTIONS(335),
    [anon_sym_begin] = ACTIONS(337),
    [aux_sym_char_token1] = ACTIONS(341),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(343),
    [anon_sym_DQUOTE] = ACTIONS(345),
    [anon_sym_AT_DQUOTE] = ACTIONS(347),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(349),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(351),
    [sym_bool] = ACTIONS(353),
    [sym_unit] = ACTIONS(2132),
    [anon_sym_LPAREN_PIPE] = ACTIONS(357),
    [sym_op_identifier] = ACTIONS(2134),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(361),
    [sym_xint] = ACTIONS(363),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(365),
  },
  [671] = {
    [sym_function_or_value_defn] = STATE(663),
    [sym__expression] = STATE(75),
    [sym_literal_expression] = STATE(1118),
    [sym_long_identifier_or_op] = STATE(1118),
    [sym_tuple_expression] = STATE(1118),
    [sym_brace_expression] = STATE(1118),
    [sym_anon_record_expression] = STATE(1118),
    [sym_prefixed_expression] = STATE(1118),
    [sym_typecast_expression] = STATE(1118),
    [sym_for_expression] = STATE(1118),
    [sym_while_expression] = STATE(1118),
    [sym__if_branch] = STATE(7163),
    [sym_if_expression] = STATE(1118),
    [sym_fun_expression] = STATE(1118),
    [sym_try_expression] = STATE(1118),
    [sym_match_expression] = STATE(1118),
    [sym_function_expression] = STATE(1118),
    [sym_mutate_expression] = STATE(1118),
    [sym_index_expression] = STATE(1118),
    [sym_typed_expression] = STATE(1118),
    [sym_declaration_expression] = STATE(1118),
    [sym_do_expression] = STATE(1118),
    [sym_list_expression] = STATE(1118),
    [sym_array_expression] = STATE(1118),
    [sym_begin_end_expression] = STATE(1118),
    [sym_paren_expression] = STATE(1118),
    [sym__high_prec_app] = STATE(1133),
    [sym__low_prec_app] = STATE(1133),
    [sym_application_expression] = STATE(1118),
    [sym_dot_expression] = STATE(1118),
    [sym_infix_expression] = STATE(1118),
    [sym_ce_expression] = STATE(1118),
    [sym_sequential_expression] = STATE(1118),
    [sym_char] = STATE(1080),
    [sym_format_string] = STATE(1090),
    [sym__string_literal] = STATE(1090),
    [sym_string] = STATE(1080),
    [sym_verbatim_string] = STATE(1080),
    [sym_bytearray] = STATE(1080),
    [sym_verbatim_bytearray] = STATE(1080),
    [sym_format_triple_quoted_string] = STATE(1096),
    [sym_triple_quoted_string] = STATE(1080),
    [sym_const] = STATE(1118),
    [sym_long_identifier] = STATE(1156),
    [sym_active_pattern] = STATE(1085),
    [sym__identifier_or_op] = STATE(1099),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(548),
    [sym_sbyte] = STATE(1080),
    [sym_byte] = STATE(1080),
    [sym_int16] = STATE(1080),
    [sym_uint16] = STATE(1080),
    [sym_int32] = STATE(1080),
    [sym_uint32] = STATE(1080),
    [sym_nativeint] = STATE(1080),
    [sym_unativeint] = STATE(1080),
    [sym_int64] = STATE(1080),
    [sym_uint64] = STATE(1080),
    [sym_ieee32] = STATE(1080),
    [sym_ieee64] = STATE(1080),
    [sym_bignum] = STATE(1080),
    [sym_decimal] = STATE(1080),
    [sym_float] = STATE(979),
    [sym_block_comment] = STATE(671),
    [sym_compiler_directive_decl] = STATE(671),
    [sym_fsi_directive_decl] = STATE(671),
    [sym_preproc_line] = STATE(671),
    [sym_preproc_if_in_expression] = STATE(1118),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(195),
    [anon_sym_return] = ACTIONS(481),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_null] = ACTIONS(207),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(209),
    [anon_sym_LBRACK_PIPE] = ACTIONS(211),
    [anon_sym_LBRACE] = ACTIONS(1687),
    [anon_sym_LT_AT] = ACTIONS(213),
    [anon_sym_LT_AT_AT] = ACTIONS(1689),
    [anon_sym_LBRACE_PIPE] = ACTIONS(217),
    [anon_sym_new] = ACTIONS(481),
    [anon_sym_return_BANG] = ACTIONS(487),
    [anon_sym_yield] = ACTIONS(481),
    [anon_sym_yield_BANG] = ACTIONS(487),
    [anon_sym_lazy] = ACTIONS(481),
    [anon_sym_assert] = ACTIONS(481),
    [anon_sym_upcast] = ACTIONS(481),
    [anon_sym_downcast] = ACTIONS(481),
    [anon_sym_for] = ACTIONS(489),
    [anon_sym_while] = ACTIONS(225),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(229),
    [anon_sym_match] = ACTIONS(231),
    [anon_sym_match_BANG] = ACTIONS(233),
    [anon_sym_function] = ACTIONS(235),
    [anon_sym_use] = ACTIONS(493),
    [anon_sym_use_BANG] = ACTIONS(495),
    [anon_sym_do_BANG] = ACTIONS(243),
    [anon_sym_begin] = ACTIONS(245),
    [aux_sym_char_token1] = ACTIONS(247),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(251),
    [anon_sym_AT_DQUOTE] = ACTIONS(253),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(255),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(257),
    [sym_bool] = ACTIONS(259),
    [sym_unit] = ACTIONS(1699),
    [anon_sym_LPAREN_PIPE] = ACTIONS(261),
    [sym_op_identifier] = ACTIONS(1701),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(499),
    [sym_xint] = ACTIONS(267),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(269),
  },
  [672] = {
    [sym_function_or_value_defn] = STATE(627),
    [sym__expression] = STATE(56),
    [sym_literal_expression] = STATE(1118),
    [sym_long_identifier_or_op] = STATE(1118),
    [sym_tuple_expression] = STATE(1118),
    [sym_brace_expression] = STATE(1118),
    [sym_anon_record_expression] = STATE(1118),
    [sym_prefixed_expression] = STATE(1118),
    [sym_typecast_expression] = STATE(1118),
    [sym_for_expression] = STATE(1118),
    [sym_while_expression] = STATE(1118),
    [sym__if_branch] = STATE(7163),
    [sym_if_expression] = STATE(1118),
    [sym_fun_expression] = STATE(1118),
    [sym_try_expression] = STATE(1118),
    [sym_match_expression] = STATE(1118),
    [sym_function_expression] = STATE(1118),
    [sym_mutate_expression] = STATE(1118),
    [sym_index_expression] = STATE(1118),
    [sym_typed_expression] = STATE(1118),
    [sym_declaration_expression] = STATE(1118),
    [sym_do_expression] = STATE(1118),
    [sym_list_expression] = STATE(1118),
    [sym_array_expression] = STATE(1118),
    [sym_begin_end_expression] = STATE(1118),
    [sym_paren_expression] = STATE(1118),
    [sym__high_prec_app] = STATE(1133),
    [sym__low_prec_app] = STATE(1133),
    [sym_application_expression] = STATE(1118),
    [sym_dot_expression] = STATE(1118),
    [sym_infix_expression] = STATE(1118),
    [sym_ce_expression] = STATE(1118),
    [sym_sequential_expression] = STATE(1118),
    [sym_char] = STATE(1080),
    [sym_format_string] = STATE(1090),
    [sym__string_literal] = STATE(1090),
    [sym_string] = STATE(1080),
    [sym_verbatim_string] = STATE(1080),
    [sym_bytearray] = STATE(1080),
    [sym_verbatim_bytearray] = STATE(1080),
    [sym_format_triple_quoted_string] = STATE(1096),
    [sym_triple_quoted_string] = STATE(1080),
    [sym_const] = STATE(1118),
    [sym_long_identifier] = STATE(1156),
    [sym_active_pattern] = STATE(1085),
    [sym__identifier_or_op] = STATE(1099),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(517),
    [sym_sbyte] = STATE(1080),
    [sym_byte] = STATE(1080),
    [sym_int16] = STATE(1080),
    [sym_uint16] = STATE(1080),
    [sym_int32] = STATE(1080),
    [sym_uint32] = STATE(1080),
    [sym_nativeint] = STATE(1080),
    [sym_unativeint] = STATE(1080),
    [sym_int64] = STATE(1080),
    [sym_uint64] = STATE(1080),
    [sym_ieee32] = STATE(1080),
    [sym_ieee64] = STATE(1080),
    [sym_bignum] = STATE(1080),
    [sym_decimal] = STATE(1080),
    [sym_float] = STATE(979),
    [sym_block_comment] = STATE(672),
    [sym_compiler_directive_decl] = STATE(672),
    [sym_fsi_directive_decl] = STATE(672),
    [sym_preproc_line] = STATE(672),
    [sym_preproc_if_in_expression] = STATE(1118),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(195),
    [anon_sym_return] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_null] = ACTIONS(207),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(209),
    [anon_sym_LBRACK_PIPE] = ACTIONS(211),
    [anon_sym_LBRACE] = ACTIONS(1687),
    [anon_sym_LT_AT] = ACTIONS(213),
    [anon_sym_LT_AT_AT] = ACTIONS(1689),
    [anon_sym_LBRACE_PIPE] = ACTIONS(217),
    [anon_sym_new] = ACTIONS(199),
    [anon_sym_return_BANG] = ACTIONS(219),
    [anon_sym_yield] = ACTIONS(199),
    [anon_sym_yield_BANG] = ACTIONS(219),
    [anon_sym_lazy] = ACTIONS(199),
    [anon_sym_assert] = ACTIONS(199),
    [anon_sym_upcast] = ACTIONS(199),
    [anon_sym_downcast] = ACTIONS(199),
    [anon_sym_for] = ACTIONS(223),
    [anon_sym_while] = ACTIONS(225),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(229),
    [anon_sym_match] = ACTIONS(231),
    [anon_sym_match_BANG] = ACTIONS(233),
    [anon_sym_function] = ACTIONS(235),
    [anon_sym_use] = ACTIONS(239),
    [anon_sym_use_BANG] = ACTIONS(241),
    [anon_sym_do_BANG] = ACTIONS(243),
    [anon_sym_begin] = ACTIONS(245),
    [aux_sym_char_token1] = ACTIONS(247),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(251),
    [anon_sym_AT_DQUOTE] = ACTIONS(253),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(255),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(257),
    [sym_bool] = ACTIONS(259),
    [sym_unit] = ACTIONS(1699),
    [anon_sym_LPAREN_PIPE] = ACTIONS(261),
    [sym_op_identifier] = ACTIONS(1701),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(265),
    [sym_xint] = ACTIONS(267),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(269),
  },
  [673] = {
    [sym_function_or_value_defn] = STATE(733),
    [sym__expression] = STATE(266),
    [sym_literal_expression] = STATE(2008),
    [sym_long_identifier_or_op] = STATE(2008),
    [sym_tuple_expression] = STATE(2008),
    [sym_brace_expression] = STATE(2008),
    [sym_anon_record_expression] = STATE(2008),
    [sym_prefixed_expression] = STATE(2008),
    [sym_typecast_expression] = STATE(2008),
    [sym_for_expression] = STATE(2008),
    [sym_while_expression] = STATE(2008),
    [sym__if_branch] = STATE(6754),
    [sym_if_expression] = STATE(2008),
    [sym_fun_expression] = STATE(2008),
    [sym_try_expression] = STATE(2008),
    [sym_match_expression] = STATE(2008),
    [sym_function_expression] = STATE(2008),
    [sym_mutate_expression] = STATE(2008),
    [sym_index_expression] = STATE(2008),
    [sym_typed_expression] = STATE(2008),
    [sym_declaration_expression] = STATE(2008),
    [sym_do_expression] = STATE(2008),
    [sym_list_expression] = STATE(2008),
    [sym_array_expression] = STATE(2008),
    [sym_begin_end_expression] = STATE(2008),
    [sym_paren_expression] = STATE(2008),
    [sym__high_prec_app] = STATE(2007),
    [sym__low_prec_app] = STATE(2007),
    [sym_application_expression] = STATE(2008),
    [sym_dot_expression] = STATE(2008),
    [sym_infix_expression] = STATE(2008),
    [sym_ce_expression] = STATE(2008),
    [sym_sequential_expression] = STATE(2008),
    [sym_char] = STATE(1859),
    [sym_format_string] = STATE(1861),
    [sym__string_literal] = STATE(1861),
    [sym_string] = STATE(1859),
    [sym_verbatim_string] = STATE(1859),
    [sym_bytearray] = STATE(1859),
    [sym_verbatim_bytearray] = STATE(1859),
    [sym_format_triple_quoted_string] = STATE(1862),
    [sym_triple_quoted_string] = STATE(1859),
    [sym_const] = STATE(2008),
    [sym_long_identifier] = STATE(1701),
    [sym_active_pattern] = STATE(1702),
    [sym__identifier_or_op] = STATE(1724),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(706),
    [sym_sbyte] = STATE(1859),
    [sym_byte] = STATE(1859),
    [sym_int16] = STATE(1859),
    [sym_uint16] = STATE(1859),
    [sym_int32] = STATE(1859),
    [sym_uint32] = STATE(1859),
    [sym_nativeint] = STATE(1859),
    [sym_unativeint] = STATE(1859),
    [sym_int64] = STATE(1859),
    [sym_uint64] = STATE(1859),
    [sym_ieee32] = STATE(1859),
    [sym_ieee64] = STATE(1859),
    [sym_bignum] = STATE(1859),
    [sym_decimal] = STATE(1859),
    [sym_float] = STATE(1447),
    [sym_block_comment] = STATE(673),
    [sym_compiler_directive_decl] = STATE(673),
    [sym_fsi_directive_decl] = STATE(673),
    [sym_preproc_line] = STATE(673),
    [sym_preproc_if_in_expression] = STATE(2008),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(503),
    [anon_sym_return] = ACTIONS(971),
    [anon_sym_do] = ACTIONS(599),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(511),
    [anon_sym_null] = ACTIONS(515),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(517),
    [anon_sym_LBRACK_PIPE] = ACTIONS(519),
    [anon_sym_LBRACE] = ACTIONS(2060),
    [anon_sym_LT_AT] = ACTIONS(523),
    [anon_sym_LT_AT_AT] = ACTIONS(2062),
    [anon_sym_LBRACE_PIPE] = ACTIONS(529),
    [anon_sym_new] = ACTIONS(971),
    [anon_sym_return_BANG] = ACTIONS(975),
    [anon_sym_yield] = ACTIONS(971),
    [anon_sym_yield_BANG] = ACTIONS(975),
    [anon_sym_lazy] = ACTIONS(971),
    [anon_sym_assert] = ACTIONS(971),
    [anon_sym_upcast] = ACTIONS(971),
    [anon_sym_downcast] = ACTIONS(971),
    [anon_sym_for] = ACTIONS(979),
    [anon_sym_while] = ACTIONS(537),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(539),
    [anon_sym_try] = ACTIONS(543),
    [anon_sym_match] = ACTIONS(545),
    [anon_sym_match_BANG] = ACTIONS(547),
    [anon_sym_function] = ACTIONS(549),
    [anon_sym_use] = ACTIONS(983),
    [anon_sym_use_BANG] = ACTIONS(985),
    [anon_sym_do_BANG] = ACTIONS(561),
    [anon_sym_begin] = ACTIONS(565),
    [aux_sym_char_token1] = ACTIONS(569),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(571),
    [anon_sym_DQUOTE] = ACTIONS(573),
    [anon_sym_AT_DQUOTE] = ACTIONS(575),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(577),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(579),
    [sym_bool] = ACTIONS(581),
    [sym_unit] = ACTIONS(2064),
    [anon_sym_LPAREN_PIPE] = ACTIONS(585),
    [sym_op_identifier] = ACTIONS(2066),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(591),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(593),
  },
  [674] = {
    [sym_function_or_value_defn] = STATE(663),
    [sym__expression] = STATE(71),
    [sym_literal_expression] = STATE(1118),
    [sym_long_identifier_or_op] = STATE(1118),
    [sym_tuple_expression] = STATE(1118),
    [sym_brace_expression] = STATE(1118),
    [sym_anon_record_expression] = STATE(1118),
    [sym_prefixed_expression] = STATE(1118),
    [sym_typecast_expression] = STATE(1118),
    [sym_for_expression] = STATE(1118),
    [sym_while_expression] = STATE(1118),
    [sym__if_branch] = STATE(7163),
    [sym_if_expression] = STATE(1118),
    [sym_fun_expression] = STATE(1118),
    [sym_try_expression] = STATE(1118),
    [sym_match_expression] = STATE(1118),
    [sym_function_expression] = STATE(1118),
    [sym_mutate_expression] = STATE(1118),
    [sym_index_expression] = STATE(1118),
    [sym_typed_expression] = STATE(1118),
    [sym_declaration_expression] = STATE(1118),
    [sym_do_expression] = STATE(1118),
    [sym_list_expression] = STATE(1118),
    [sym_array_expression] = STATE(1118),
    [sym_begin_end_expression] = STATE(1118),
    [sym_paren_expression] = STATE(1118),
    [sym__high_prec_app] = STATE(1133),
    [sym__low_prec_app] = STATE(1133),
    [sym_application_expression] = STATE(1118),
    [sym_dot_expression] = STATE(1118),
    [sym_infix_expression] = STATE(1118),
    [sym_ce_expression] = STATE(1118),
    [sym_sequential_expression] = STATE(1118),
    [sym_char] = STATE(1080),
    [sym_format_string] = STATE(1090),
    [sym__string_literal] = STATE(1090),
    [sym_string] = STATE(1080),
    [sym_verbatim_string] = STATE(1080),
    [sym_bytearray] = STATE(1080),
    [sym_verbatim_bytearray] = STATE(1080),
    [sym_format_triple_quoted_string] = STATE(1096),
    [sym_triple_quoted_string] = STATE(1080),
    [sym_const] = STATE(1118),
    [sym_long_identifier] = STATE(1156),
    [sym_active_pattern] = STATE(1085),
    [sym__identifier_or_op] = STATE(1099),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(548),
    [sym_sbyte] = STATE(1080),
    [sym_byte] = STATE(1080),
    [sym_int16] = STATE(1080),
    [sym_uint16] = STATE(1080),
    [sym_int32] = STATE(1080),
    [sym_uint32] = STATE(1080),
    [sym_nativeint] = STATE(1080),
    [sym_unativeint] = STATE(1080),
    [sym_int64] = STATE(1080),
    [sym_uint64] = STATE(1080),
    [sym_ieee32] = STATE(1080),
    [sym_ieee64] = STATE(1080),
    [sym_bignum] = STATE(1080),
    [sym_decimal] = STATE(1080),
    [sym_float] = STATE(979),
    [sym_block_comment] = STATE(674),
    [sym_compiler_directive_decl] = STATE(674),
    [sym_fsi_directive_decl] = STATE(674),
    [sym_preproc_line] = STATE(674),
    [sym_preproc_if_in_expression] = STATE(1118),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(195),
    [anon_sym_return] = ACTIONS(481),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_null] = ACTIONS(207),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(209),
    [anon_sym_LBRACK_PIPE] = ACTIONS(211),
    [anon_sym_LBRACE] = ACTIONS(1687),
    [anon_sym_LT_AT] = ACTIONS(213),
    [anon_sym_LT_AT_AT] = ACTIONS(1689),
    [anon_sym_LBRACE_PIPE] = ACTIONS(217),
    [anon_sym_new] = ACTIONS(481),
    [anon_sym_return_BANG] = ACTIONS(487),
    [anon_sym_yield] = ACTIONS(481),
    [anon_sym_yield_BANG] = ACTIONS(487),
    [anon_sym_lazy] = ACTIONS(481),
    [anon_sym_assert] = ACTIONS(481),
    [anon_sym_upcast] = ACTIONS(481),
    [anon_sym_downcast] = ACTIONS(481),
    [anon_sym_for] = ACTIONS(489),
    [anon_sym_while] = ACTIONS(225),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(229),
    [anon_sym_match] = ACTIONS(231),
    [anon_sym_match_BANG] = ACTIONS(233),
    [anon_sym_function] = ACTIONS(235),
    [anon_sym_use] = ACTIONS(493),
    [anon_sym_use_BANG] = ACTIONS(495),
    [anon_sym_do_BANG] = ACTIONS(243),
    [anon_sym_begin] = ACTIONS(245),
    [aux_sym_char_token1] = ACTIONS(247),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(251),
    [anon_sym_AT_DQUOTE] = ACTIONS(253),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(255),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(257),
    [sym_bool] = ACTIONS(259),
    [sym_unit] = ACTIONS(1699),
    [anon_sym_LPAREN_PIPE] = ACTIONS(261),
    [sym_op_identifier] = ACTIONS(1701),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(499),
    [sym_xint] = ACTIONS(267),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(269),
  },
  [675] = {
    [sym_function_or_value_defn] = STATE(630),
    [sym__expression] = STATE(163),
    [sym_literal_expression] = STATE(2380),
    [sym_long_identifier_or_op] = STATE(2380),
    [sym_tuple_expression] = STATE(2380),
    [sym_brace_expression] = STATE(2380),
    [sym_anon_record_expression] = STATE(2380),
    [sym_prefixed_expression] = STATE(2380),
    [sym_typecast_expression] = STATE(2380),
    [sym_for_expression] = STATE(2380),
    [sym_while_expression] = STATE(2380),
    [sym__if_branch] = STATE(6456),
    [sym_if_expression] = STATE(2380),
    [sym_fun_expression] = STATE(2380),
    [sym_try_expression] = STATE(2380),
    [sym_match_expression] = STATE(2380),
    [sym_function_expression] = STATE(2380),
    [sym_mutate_expression] = STATE(2380),
    [sym_index_expression] = STATE(2380),
    [sym_typed_expression] = STATE(2380),
    [sym_declaration_expression] = STATE(2380),
    [sym_do_expression] = STATE(2380),
    [sym_list_expression] = STATE(2380),
    [sym_array_expression] = STATE(2380),
    [sym_begin_end_expression] = STATE(2380),
    [sym_paren_expression] = STATE(2380),
    [sym__high_prec_app] = STATE(2383),
    [sym__low_prec_app] = STATE(2383),
    [sym_application_expression] = STATE(2380),
    [sym_dot_expression] = STATE(2380),
    [sym_infix_expression] = STATE(2380),
    [sym_ce_expression] = STATE(2380),
    [sym_sequential_expression] = STATE(2380),
    [sym_char] = STATE(2261),
    [sym_format_string] = STATE(2274),
    [sym__string_literal] = STATE(2274),
    [sym_string] = STATE(2261),
    [sym_verbatim_string] = STATE(2261),
    [sym_bytearray] = STATE(2261),
    [sym_verbatim_bytearray] = STATE(2261),
    [sym_format_triple_quoted_string] = STATE(2275),
    [sym_triple_quoted_string] = STATE(2261),
    [sym_const] = STATE(2380),
    [sym_long_identifier] = STATE(2391),
    [sym_active_pattern] = STATE(2470),
    [sym__identifier_or_op] = STATE(2390),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(632),
    [sym_sbyte] = STATE(2261),
    [sym_byte] = STATE(2261),
    [sym_int16] = STATE(2261),
    [sym_uint16] = STATE(2261),
    [sym_int32] = STATE(2261),
    [sym_uint32] = STATE(2261),
    [sym_nativeint] = STATE(2261),
    [sym_unativeint] = STATE(2261),
    [sym_int64] = STATE(2261),
    [sym_uint64] = STATE(2261),
    [sym_ieee32] = STATE(2261),
    [sym_ieee64] = STATE(2261),
    [sym_bignum] = STATE(2261),
    [sym_decimal] = STATE(2261),
    [sym_float] = STATE(1614),
    [sym_block_comment] = STATE(675),
    [sym_compiler_directive_decl] = STATE(675),
    [sym_fsi_directive_decl] = STATE(675),
    [sym_preproc_line] = STATE(675),
    [sym_preproc_if_in_expression] = STATE(2380),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(1081),
    [anon_sym_return] = ACTIONS(1085),
    [anon_sym_do] = ACTIONS(1087),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(1089),
    [anon_sym_null] = ACTIONS(1093),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1095),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1097),
    [anon_sym_LBRACE] = ACTIONS(2100),
    [anon_sym_LT_AT] = ACTIONS(1101),
    [anon_sym_LT_AT_AT] = ACTIONS(2102),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1107),
    [anon_sym_new] = ACTIONS(1085),
    [anon_sym_return_BANG] = ACTIONS(1109),
    [anon_sym_yield] = ACTIONS(1085),
    [anon_sym_yield_BANG] = ACTIONS(1109),
    [anon_sym_lazy] = ACTIONS(1085),
    [anon_sym_assert] = ACTIONS(1085),
    [anon_sym_upcast] = ACTIONS(1085),
    [anon_sym_downcast] = ACTIONS(1085),
    [anon_sym_for] = ACTIONS(1113),
    [anon_sym_while] = ACTIONS(1115),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(1117),
    [anon_sym_try] = ACTIONS(1119),
    [anon_sym_match] = ACTIONS(1121),
    [anon_sym_match_BANG] = ACTIONS(1123),
    [anon_sym_function] = ACTIONS(1125),
    [anon_sym_use] = ACTIONS(1133),
    [anon_sym_use_BANG] = ACTIONS(1135),
    [anon_sym_do_BANG] = ACTIONS(1137),
    [anon_sym_begin] = ACTIONS(1139),
    [aux_sym_char_token1] = ACTIONS(1143),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1145),
    [anon_sym_DQUOTE] = ACTIONS(1147),
    [anon_sym_AT_DQUOTE] = ACTIONS(1149),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1151),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1153),
    [sym_bool] = ACTIONS(1155),
    [sym_unit] = ACTIONS(2104),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1159),
    [sym_op_identifier] = ACTIONS(2106),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(1163),
    [sym_xint] = ACTIONS(1165),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1167),
  },
  [676] = {
    [sym_function_or_value_defn] = STATE(627),
    [sym__expression] = STATE(327),
    [sym_literal_expression] = STATE(1118),
    [sym_long_identifier_or_op] = STATE(1118),
    [sym_tuple_expression] = STATE(1118),
    [sym_brace_expression] = STATE(1118),
    [sym_anon_record_expression] = STATE(1118),
    [sym_prefixed_expression] = STATE(1118),
    [sym_typecast_expression] = STATE(1118),
    [sym_for_expression] = STATE(1118),
    [sym_while_expression] = STATE(1118),
    [sym__if_branch] = STATE(7163),
    [sym_if_expression] = STATE(1118),
    [sym_fun_expression] = STATE(1118),
    [sym_try_expression] = STATE(1118),
    [sym_match_expression] = STATE(1118),
    [sym_function_expression] = STATE(1118),
    [sym_mutate_expression] = STATE(1118),
    [sym_index_expression] = STATE(1118),
    [sym_typed_expression] = STATE(1118),
    [sym_declaration_expression] = STATE(1118),
    [sym_do_expression] = STATE(1118),
    [sym_list_expression] = STATE(1118),
    [sym_array_expression] = STATE(1118),
    [sym_begin_end_expression] = STATE(1118),
    [sym_paren_expression] = STATE(1118),
    [sym__high_prec_app] = STATE(1133),
    [sym__low_prec_app] = STATE(1133),
    [sym_application_expression] = STATE(1118),
    [sym_dot_expression] = STATE(1118),
    [sym_infix_expression] = STATE(1118),
    [sym_ce_expression] = STATE(1118),
    [sym_sequential_expression] = STATE(1118),
    [sym_char] = STATE(1080),
    [sym_format_string] = STATE(1090),
    [sym__string_literal] = STATE(1090),
    [sym_string] = STATE(1080),
    [sym_verbatim_string] = STATE(1080),
    [sym_bytearray] = STATE(1080),
    [sym_verbatim_bytearray] = STATE(1080),
    [sym_format_triple_quoted_string] = STATE(1096),
    [sym_triple_quoted_string] = STATE(1080),
    [sym_const] = STATE(1118),
    [sym_long_identifier] = STATE(1156),
    [sym_active_pattern] = STATE(1085),
    [sym__identifier_or_op] = STATE(1099),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(517),
    [sym_sbyte] = STATE(1080),
    [sym_byte] = STATE(1080),
    [sym_int16] = STATE(1080),
    [sym_uint16] = STATE(1080),
    [sym_int32] = STATE(1080),
    [sym_uint32] = STATE(1080),
    [sym_nativeint] = STATE(1080),
    [sym_unativeint] = STATE(1080),
    [sym_int64] = STATE(1080),
    [sym_uint64] = STATE(1080),
    [sym_ieee32] = STATE(1080),
    [sym_ieee64] = STATE(1080),
    [sym_bignum] = STATE(1080),
    [sym_decimal] = STATE(1080),
    [sym_float] = STATE(979),
    [sym_block_comment] = STATE(676),
    [sym_compiler_directive_decl] = STATE(676),
    [sym_fsi_directive_decl] = STATE(676),
    [sym_preproc_line] = STATE(676),
    [sym_preproc_if_in_expression] = STATE(1118),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(195),
    [anon_sym_return] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_null] = ACTIONS(207),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(209),
    [anon_sym_LBRACK_PIPE] = ACTIONS(211),
    [anon_sym_LBRACE] = ACTIONS(1687),
    [anon_sym_LT_AT] = ACTIONS(213),
    [anon_sym_LT_AT_AT] = ACTIONS(1689),
    [anon_sym_LBRACE_PIPE] = ACTIONS(217),
    [anon_sym_new] = ACTIONS(199),
    [anon_sym_return_BANG] = ACTIONS(219),
    [anon_sym_yield] = ACTIONS(199),
    [anon_sym_yield_BANG] = ACTIONS(219),
    [anon_sym_lazy] = ACTIONS(199),
    [anon_sym_assert] = ACTIONS(199),
    [anon_sym_upcast] = ACTIONS(199),
    [anon_sym_downcast] = ACTIONS(199),
    [anon_sym_for] = ACTIONS(223),
    [anon_sym_while] = ACTIONS(225),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(229),
    [anon_sym_match] = ACTIONS(231),
    [anon_sym_match_BANG] = ACTIONS(233),
    [anon_sym_function] = ACTIONS(235),
    [anon_sym_use] = ACTIONS(239),
    [anon_sym_use_BANG] = ACTIONS(241),
    [anon_sym_do_BANG] = ACTIONS(243),
    [anon_sym_begin] = ACTIONS(245),
    [aux_sym_char_token1] = ACTIONS(247),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(251),
    [anon_sym_AT_DQUOTE] = ACTIONS(253),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(255),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(257),
    [sym_bool] = ACTIONS(259),
    [sym_unit] = ACTIONS(1699),
    [anon_sym_LPAREN_PIPE] = ACTIONS(261),
    [sym_op_identifier] = ACTIONS(1701),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(265),
    [sym_xint] = ACTIONS(267),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(269),
  },
  [677] = {
    [sym_function_or_value_defn] = STATE(627),
    [sym__expression] = STATE(336),
    [sym_literal_expression] = STATE(1118),
    [sym_long_identifier_or_op] = STATE(1118),
    [sym_tuple_expression] = STATE(1118),
    [sym_brace_expression] = STATE(1118),
    [sym_anon_record_expression] = STATE(1118),
    [sym_prefixed_expression] = STATE(1118),
    [sym_typecast_expression] = STATE(1118),
    [sym_for_expression] = STATE(1118),
    [sym_while_expression] = STATE(1118),
    [sym__if_branch] = STATE(7163),
    [sym_if_expression] = STATE(1118),
    [sym_fun_expression] = STATE(1118),
    [sym_try_expression] = STATE(1118),
    [sym_match_expression] = STATE(1118),
    [sym_function_expression] = STATE(1118),
    [sym_mutate_expression] = STATE(1118),
    [sym_index_expression] = STATE(1118),
    [sym_typed_expression] = STATE(1118),
    [sym_declaration_expression] = STATE(1118),
    [sym_do_expression] = STATE(1118),
    [sym_list_expression] = STATE(1118),
    [sym_array_expression] = STATE(1118),
    [sym_begin_end_expression] = STATE(1118),
    [sym_paren_expression] = STATE(1118),
    [sym__high_prec_app] = STATE(1133),
    [sym__low_prec_app] = STATE(1133),
    [sym_application_expression] = STATE(1118),
    [sym_dot_expression] = STATE(1118),
    [sym_infix_expression] = STATE(1118),
    [sym_ce_expression] = STATE(1118),
    [sym_sequential_expression] = STATE(1118),
    [sym_char] = STATE(1080),
    [sym_format_string] = STATE(1090),
    [sym__string_literal] = STATE(1090),
    [sym_string] = STATE(1080),
    [sym_verbatim_string] = STATE(1080),
    [sym_bytearray] = STATE(1080),
    [sym_verbatim_bytearray] = STATE(1080),
    [sym_format_triple_quoted_string] = STATE(1096),
    [sym_triple_quoted_string] = STATE(1080),
    [sym_const] = STATE(1118),
    [sym_long_identifier] = STATE(1156),
    [sym_active_pattern] = STATE(1085),
    [sym__identifier_or_op] = STATE(1099),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(517),
    [sym_sbyte] = STATE(1080),
    [sym_byte] = STATE(1080),
    [sym_int16] = STATE(1080),
    [sym_uint16] = STATE(1080),
    [sym_int32] = STATE(1080),
    [sym_uint32] = STATE(1080),
    [sym_nativeint] = STATE(1080),
    [sym_unativeint] = STATE(1080),
    [sym_int64] = STATE(1080),
    [sym_uint64] = STATE(1080),
    [sym_ieee32] = STATE(1080),
    [sym_ieee64] = STATE(1080),
    [sym_bignum] = STATE(1080),
    [sym_decimal] = STATE(1080),
    [sym_float] = STATE(979),
    [sym_block_comment] = STATE(677),
    [sym_compiler_directive_decl] = STATE(677),
    [sym_fsi_directive_decl] = STATE(677),
    [sym_preproc_line] = STATE(677),
    [sym_preproc_if_in_expression] = STATE(1118),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(195),
    [anon_sym_return] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_null] = ACTIONS(207),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(209),
    [anon_sym_LBRACK_PIPE] = ACTIONS(211),
    [anon_sym_LBRACE] = ACTIONS(1687),
    [anon_sym_LT_AT] = ACTIONS(213),
    [anon_sym_LT_AT_AT] = ACTIONS(1689),
    [anon_sym_LBRACE_PIPE] = ACTIONS(217),
    [anon_sym_new] = ACTIONS(199),
    [anon_sym_return_BANG] = ACTIONS(219),
    [anon_sym_yield] = ACTIONS(199),
    [anon_sym_yield_BANG] = ACTIONS(219),
    [anon_sym_lazy] = ACTIONS(199),
    [anon_sym_assert] = ACTIONS(199),
    [anon_sym_upcast] = ACTIONS(199),
    [anon_sym_downcast] = ACTIONS(199),
    [anon_sym_for] = ACTIONS(223),
    [anon_sym_while] = ACTIONS(225),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(229),
    [anon_sym_match] = ACTIONS(231),
    [anon_sym_match_BANG] = ACTIONS(233),
    [anon_sym_function] = ACTIONS(235),
    [anon_sym_use] = ACTIONS(239),
    [anon_sym_use_BANG] = ACTIONS(241),
    [anon_sym_do_BANG] = ACTIONS(243),
    [anon_sym_begin] = ACTIONS(245),
    [aux_sym_char_token1] = ACTIONS(247),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(251),
    [anon_sym_AT_DQUOTE] = ACTIONS(253),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(255),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(257),
    [sym_bool] = ACTIONS(259),
    [sym_unit] = ACTIONS(1699),
    [anon_sym_LPAREN_PIPE] = ACTIONS(261),
    [sym_op_identifier] = ACTIONS(1701),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(265),
    [sym_xint] = ACTIONS(267),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(269),
  },
  [678] = {
    [sym_function_or_value_defn] = STATE(733),
    [sym__expression] = STATE(135),
    [sym_literal_expression] = STATE(2008),
    [sym_long_identifier_or_op] = STATE(2008),
    [sym_tuple_expression] = STATE(2008),
    [sym_brace_expression] = STATE(2008),
    [sym_anon_record_expression] = STATE(2008),
    [sym_prefixed_expression] = STATE(2008),
    [sym_typecast_expression] = STATE(2008),
    [sym_for_expression] = STATE(2008),
    [sym_while_expression] = STATE(2008),
    [sym__if_branch] = STATE(6754),
    [sym_if_expression] = STATE(2008),
    [sym_fun_expression] = STATE(2008),
    [sym_try_expression] = STATE(2008),
    [sym_match_expression] = STATE(2008),
    [sym_function_expression] = STATE(2008),
    [sym_mutate_expression] = STATE(2008),
    [sym_index_expression] = STATE(2008),
    [sym_typed_expression] = STATE(2008),
    [sym_declaration_expression] = STATE(2008),
    [sym_do_expression] = STATE(2008),
    [sym_list_expression] = STATE(2008),
    [sym_array_expression] = STATE(2008),
    [sym_begin_end_expression] = STATE(2008),
    [sym_paren_expression] = STATE(2008),
    [sym__high_prec_app] = STATE(2007),
    [sym__low_prec_app] = STATE(2007),
    [sym_application_expression] = STATE(2008),
    [sym_dot_expression] = STATE(2008),
    [sym_infix_expression] = STATE(2008),
    [sym_ce_expression] = STATE(2008),
    [sym_sequential_expression] = STATE(2008),
    [sym_char] = STATE(1859),
    [sym_format_string] = STATE(1861),
    [sym__string_literal] = STATE(1861),
    [sym_string] = STATE(1859),
    [sym_verbatim_string] = STATE(1859),
    [sym_bytearray] = STATE(1859),
    [sym_verbatim_bytearray] = STATE(1859),
    [sym_format_triple_quoted_string] = STATE(1862),
    [sym_triple_quoted_string] = STATE(1859),
    [sym_const] = STATE(2008),
    [sym_long_identifier] = STATE(1701),
    [sym_active_pattern] = STATE(1702),
    [sym__identifier_or_op] = STATE(1724),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(706),
    [sym_sbyte] = STATE(1859),
    [sym_byte] = STATE(1859),
    [sym_int16] = STATE(1859),
    [sym_uint16] = STATE(1859),
    [sym_int32] = STATE(1859),
    [sym_uint32] = STATE(1859),
    [sym_nativeint] = STATE(1859),
    [sym_unativeint] = STATE(1859),
    [sym_int64] = STATE(1859),
    [sym_uint64] = STATE(1859),
    [sym_ieee32] = STATE(1859),
    [sym_ieee64] = STATE(1859),
    [sym_bignum] = STATE(1859),
    [sym_decimal] = STATE(1859),
    [sym_float] = STATE(1447),
    [sym_block_comment] = STATE(678),
    [sym_compiler_directive_decl] = STATE(678),
    [sym_fsi_directive_decl] = STATE(678),
    [sym_preproc_line] = STATE(678),
    [sym_preproc_if_in_expression] = STATE(2008),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(503),
    [anon_sym_return] = ACTIONS(971),
    [anon_sym_do] = ACTIONS(599),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(511),
    [anon_sym_null] = ACTIONS(515),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(517),
    [anon_sym_LBRACK_PIPE] = ACTIONS(519),
    [anon_sym_LBRACE] = ACTIONS(2060),
    [anon_sym_LT_AT] = ACTIONS(523),
    [anon_sym_LT_AT_AT] = ACTIONS(2062),
    [anon_sym_LBRACE_PIPE] = ACTIONS(529),
    [anon_sym_new] = ACTIONS(971),
    [anon_sym_return_BANG] = ACTIONS(975),
    [anon_sym_yield] = ACTIONS(971),
    [anon_sym_yield_BANG] = ACTIONS(975),
    [anon_sym_lazy] = ACTIONS(971),
    [anon_sym_assert] = ACTIONS(971),
    [anon_sym_upcast] = ACTIONS(971),
    [anon_sym_downcast] = ACTIONS(971),
    [anon_sym_for] = ACTIONS(979),
    [anon_sym_while] = ACTIONS(537),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(539),
    [anon_sym_try] = ACTIONS(543),
    [anon_sym_match] = ACTIONS(545),
    [anon_sym_match_BANG] = ACTIONS(547),
    [anon_sym_function] = ACTIONS(549),
    [anon_sym_use] = ACTIONS(983),
    [anon_sym_use_BANG] = ACTIONS(985),
    [anon_sym_do_BANG] = ACTIONS(561),
    [anon_sym_begin] = ACTIONS(565),
    [aux_sym_char_token1] = ACTIONS(569),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(571),
    [anon_sym_DQUOTE] = ACTIONS(573),
    [anon_sym_AT_DQUOTE] = ACTIONS(575),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(577),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(579),
    [sym_bool] = ACTIONS(581),
    [sym_unit] = ACTIONS(2064),
    [anon_sym_LPAREN_PIPE] = ACTIONS(585),
    [sym_op_identifier] = ACTIONS(2066),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(591),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(593),
  },
  [679] = {
    [sym_function_or_value_defn] = STATE(651),
    [sym__expression] = STATE(201),
    [sym_literal_expression] = STATE(2168),
    [sym_long_identifier_or_op] = STATE(2168),
    [sym_tuple_expression] = STATE(2168),
    [sym_brace_expression] = STATE(2168),
    [sym_anon_record_expression] = STATE(2168),
    [sym_prefixed_expression] = STATE(2168),
    [sym_typecast_expression] = STATE(2168),
    [sym_for_expression] = STATE(2168),
    [sym_while_expression] = STATE(2168),
    [sym__if_branch] = STATE(6406),
    [sym_if_expression] = STATE(2168),
    [sym_fun_expression] = STATE(2168),
    [sym_try_expression] = STATE(2168),
    [sym_match_expression] = STATE(2168),
    [sym_function_expression] = STATE(2168),
    [sym_mutate_expression] = STATE(2168),
    [sym_index_expression] = STATE(2168),
    [sym_typed_expression] = STATE(2168),
    [sym_declaration_expression] = STATE(2168),
    [sym_do_expression] = STATE(2168),
    [sym_list_expression] = STATE(2168),
    [sym_array_expression] = STATE(2168),
    [sym_begin_end_expression] = STATE(2168),
    [sym_paren_expression] = STATE(2168),
    [sym__high_prec_app] = STATE(2179),
    [sym__low_prec_app] = STATE(2179),
    [sym_application_expression] = STATE(2168),
    [sym_dot_expression] = STATE(2168),
    [sym_infix_expression] = STATE(2168),
    [sym_ce_expression] = STATE(2168),
    [sym_sequential_expression] = STATE(2168),
    [sym_char] = STATE(2469),
    [sym_format_string] = STATE(2412),
    [sym__string_literal] = STATE(2412),
    [sym_string] = STATE(2469),
    [sym_verbatim_string] = STATE(2469),
    [sym_bytearray] = STATE(2469),
    [sym_verbatim_bytearray] = STATE(2469),
    [sym_format_triple_quoted_string] = STATE(2408),
    [sym_triple_quoted_string] = STATE(2469),
    [sym_const] = STATE(2168),
    [sym_long_identifier] = STATE(2183),
    [sym_active_pattern] = STATE(2182),
    [sym__identifier_or_op] = STATE(2093),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(650),
    [sym_sbyte] = STATE(2469),
    [sym_byte] = STATE(2469),
    [sym_int16] = STATE(2469),
    [sym_uint16] = STATE(2469),
    [sym_int32] = STATE(2469),
    [sym_uint32] = STATE(2469),
    [sym_nativeint] = STATE(2469),
    [sym_unativeint] = STATE(2469),
    [sym_int64] = STATE(2469),
    [sym_uint64] = STATE(2469),
    [sym_ieee32] = STATE(2469),
    [sym_ieee64] = STATE(2469),
    [sym_bignum] = STATE(2469),
    [sym_decimal] = STATE(2469),
    [sym_float] = STATE(1586),
    [sym_block_comment] = STATE(679),
    [sym_compiler_directive_decl] = STATE(679),
    [sym_fsi_directive_decl] = STATE(679),
    [sym_preproc_line] = STATE(679),
    [sym_preproc_if_in_expression] = STATE(2168),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(989),
    [anon_sym_return] = ACTIONS(993),
    [anon_sym_do] = ACTIONS(995),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(997),
    [anon_sym_null] = ACTIONS(1001),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1003),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1005),
    [anon_sym_LBRACE] = ACTIONS(2070),
    [anon_sym_LT_AT] = ACTIONS(1009),
    [anon_sym_LT_AT_AT] = ACTIONS(2072),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1017),
    [anon_sym_new] = ACTIONS(993),
    [anon_sym_return_BANG] = ACTIONS(1019),
    [anon_sym_yield] = ACTIONS(993),
    [anon_sym_yield_BANG] = ACTIONS(1019),
    [anon_sym_lazy] = ACTIONS(993),
    [anon_sym_assert] = ACTIONS(993),
    [anon_sym_upcast] = ACTIONS(993),
    [anon_sym_downcast] = ACTIONS(993),
    [anon_sym_for] = ACTIONS(1023),
    [anon_sym_while] = ACTIONS(1025),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(1027),
    [anon_sym_try] = ACTIONS(1029),
    [anon_sym_match] = ACTIONS(1031),
    [anon_sym_match_BANG] = ACTIONS(1033),
    [anon_sym_function] = ACTIONS(1035),
    [anon_sym_use] = ACTIONS(1043),
    [anon_sym_use_BANG] = ACTIONS(1045),
    [anon_sym_do_BANG] = ACTIONS(1047),
    [anon_sym_begin] = ACTIONS(1049),
    [aux_sym_char_token1] = ACTIONS(1053),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1055),
    [anon_sym_DQUOTE] = ACTIONS(1057),
    [anon_sym_AT_DQUOTE] = ACTIONS(1059),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1061),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1063),
    [sym_bool] = ACTIONS(1065),
    [sym_unit] = ACTIONS(2074),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1069),
    [sym_op_identifier] = ACTIONS(2076),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(1073),
    [sym_xint] = ACTIONS(1075),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1077),
  },
  [680] = {
    [sym_function_or_value_defn] = STATE(627),
    [sym__expression] = STATE(335),
    [sym_literal_expression] = STATE(1118),
    [sym_long_identifier_or_op] = STATE(1118),
    [sym_tuple_expression] = STATE(1118),
    [sym_brace_expression] = STATE(1118),
    [sym_anon_record_expression] = STATE(1118),
    [sym_prefixed_expression] = STATE(1118),
    [sym_typecast_expression] = STATE(1118),
    [sym_for_expression] = STATE(1118),
    [sym_while_expression] = STATE(1118),
    [sym__if_branch] = STATE(7163),
    [sym_if_expression] = STATE(1118),
    [sym_fun_expression] = STATE(1118),
    [sym_try_expression] = STATE(1118),
    [sym_match_expression] = STATE(1118),
    [sym_function_expression] = STATE(1118),
    [sym_mutate_expression] = STATE(1118),
    [sym_index_expression] = STATE(1118),
    [sym_typed_expression] = STATE(1118),
    [sym_declaration_expression] = STATE(1118),
    [sym_do_expression] = STATE(1118),
    [sym_list_expression] = STATE(1118),
    [sym_array_expression] = STATE(1118),
    [sym_begin_end_expression] = STATE(1118),
    [sym_paren_expression] = STATE(1118),
    [sym__high_prec_app] = STATE(1133),
    [sym__low_prec_app] = STATE(1133),
    [sym_application_expression] = STATE(1118),
    [sym_dot_expression] = STATE(1118),
    [sym_infix_expression] = STATE(1118),
    [sym_ce_expression] = STATE(1118),
    [sym_sequential_expression] = STATE(1118),
    [sym_char] = STATE(1080),
    [sym_format_string] = STATE(1090),
    [sym__string_literal] = STATE(1090),
    [sym_string] = STATE(1080),
    [sym_verbatim_string] = STATE(1080),
    [sym_bytearray] = STATE(1080),
    [sym_verbatim_bytearray] = STATE(1080),
    [sym_format_triple_quoted_string] = STATE(1096),
    [sym_triple_quoted_string] = STATE(1080),
    [sym_const] = STATE(1118),
    [sym_long_identifier] = STATE(1156),
    [sym_active_pattern] = STATE(1085),
    [sym__identifier_or_op] = STATE(1099),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(517),
    [sym_sbyte] = STATE(1080),
    [sym_byte] = STATE(1080),
    [sym_int16] = STATE(1080),
    [sym_uint16] = STATE(1080),
    [sym_int32] = STATE(1080),
    [sym_uint32] = STATE(1080),
    [sym_nativeint] = STATE(1080),
    [sym_unativeint] = STATE(1080),
    [sym_int64] = STATE(1080),
    [sym_uint64] = STATE(1080),
    [sym_ieee32] = STATE(1080),
    [sym_ieee64] = STATE(1080),
    [sym_bignum] = STATE(1080),
    [sym_decimal] = STATE(1080),
    [sym_float] = STATE(979),
    [sym_block_comment] = STATE(680),
    [sym_compiler_directive_decl] = STATE(680),
    [sym_fsi_directive_decl] = STATE(680),
    [sym_preproc_line] = STATE(680),
    [sym_preproc_if_in_expression] = STATE(1118),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(195),
    [anon_sym_return] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_null] = ACTIONS(207),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(209),
    [anon_sym_LBRACK_PIPE] = ACTIONS(211),
    [anon_sym_LBRACE] = ACTIONS(1687),
    [anon_sym_LT_AT] = ACTIONS(213),
    [anon_sym_LT_AT_AT] = ACTIONS(1689),
    [anon_sym_LBRACE_PIPE] = ACTIONS(217),
    [anon_sym_new] = ACTIONS(199),
    [anon_sym_return_BANG] = ACTIONS(219),
    [anon_sym_yield] = ACTIONS(199),
    [anon_sym_yield_BANG] = ACTIONS(219),
    [anon_sym_lazy] = ACTIONS(199),
    [anon_sym_assert] = ACTIONS(199),
    [anon_sym_upcast] = ACTIONS(199),
    [anon_sym_downcast] = ACTIONS(199),
    [anon_sym_for] = ACTIONS(223),
    [anon_sym_while] = ACTIONS(225),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(229),
    [anon_sym_match] = ACTIONS(231),
    [anon_sym_match_BANG] = ACTIONS(233),
    [anon_sym_function] = ACTIONS(235),
    [anon_sym_use] = ACTIONS(239),
    [anon_sym_use_BANG] = ACTIONS(241),
    [anon_sym_do_BANG] = ACTIONS(243),
    [anon_sym_begin] = ACTIONS(245),
    [aux_sym_char_token1] = ACTIONS(247),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(251),
    [anon_sym_AT_DQUOTE] = ACTIONS(253),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(255),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(257),
    [sym_bool] = ACTIONS(259),
    [sym_unit] = ACTIONS(1699),
    [anon_sym_LPAREN_PIPE] = ACTIONS(261),
    [sym_op_identifier] = ACTIONS(1701),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(265),
    [sym_xint] = ACTIONS(267),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(269),
  },
  [681] = {
    [sym_function_or_value_defn] = STATE(600),
    [sym__expression] = STATE(164),
    [sym_literal_expression] = STATE(867),
    [sym_long_identifier_or_op] = STATE(867),
    [sym_tuple_expression] = STATE(867),
    [sym_brace_expression] = STATE(867),
    [sym_anon_record_expression] = STATE(867),
    [sym_prefixed_expression] = STATE(867),
    [sym_typecast_expression] = STATE(867),
    [sym_for_expression] = STATE(867),
    [sym_while_expression] = STATE(867),
    [sym__if_branch] = STATE(6511),
    [sym_if_expression] = STATE(867),
    [sym_fun_expression] = STATE(867),
    [sym_try_expression] = STATE(867),
    [sym_match_expression] = STATE(867),
    [sym_function_expression] = STATE(867),
    [sym_mutate_expression] = STATE(867),
    [sym_index_expression] = STATE(867),
    [sym_typed_expression] = STATE(867),
    [sym_declaration_expression] = STATE(867),
    [sym_do_expression] = STATE(867),
    [sym_list_expression] = STATE(867),
    [sym_array_expression] = STATE(867),
    [sym_begin_end_expression] = STATE(867),
    [sym_paren_expression] = STATE(867),
    [sym__high_prec_app] = STATE(864),
    [sym__low_prec_app] = STATE(864),
    [sym_application_expression] = STATE(867),
    [sym_dot_expression] = STATE(867),
    [sym_infix_expression] = STATE(867),
    [sym_ce_expression] = STATE(867),
    [sym_sequential_expression] = STATE(867),
    [sym_char] = STATE(868),
    [sym_format_string] = STATE(869),
    [sym__string_literal] = STATE(869),
    [sym_string] = STATE(868),
    [sym_verbatim_string] = STATE(868),
    [sym_bytearray] = STATE(868),
    [sym_verbatim_bytearray] = STATE(868),
    [sym_format_triple_quoted_string] = STATE(870),
    [sym_triple_quoted_string] = STATE(868),
    [sym_const] = STATE(867),
    [sym_long_identifier] = STATE(872),
    [sym_active_pattern] = STATE(871),
    [sym__identifier_or_op] = STATE(873),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(656),
    [sym_sbyte] = STATE(868),
    [sym_byte] = STATE(868),
    [sym_int16] = STATE(868),
    [sym_uint16] = STATE(868),
    [sym_int32] = STATE(868),
    [sym_uint32] = STATE(868),
    [sym_nativeint] = STATE(868),
    [sym_unativeint] = STATE(868),
    [sym_int64] = STATE(868),
    [sym_uint64] = STATE(868),
    [sym_ieee32] = STATE(868),
    [sym_ieee64] = STATE(868),
    [sym_bignum] = STATE(868),
    [sym_decimal] = STATE(868),
    [sym_float] = STATE(1368),
    [sym_block_comment] = STATE(681),
    [sym_compiler_directive_decl] = STATE(681),
    [sym_fsi_directive_decl] = STATE(681),
    [sym_preproc_line] = STATE(681),
    [sym_preproc_if_in_expression] = STATE(867),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(29),
    [anon_sym_return] = ACTIONS(825),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_null] = ACTIONS(49),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACK_PIPE] = ACTIONS(57),
    [anon_sym_LBRACE] = ACTIONS(1663),
    [anon_sym_LT_AT] = ACTIONS(61),
    [anon_sym_LT_AT_AT] = ACTIONS(1665),
    [anon_sym_LBRACE_PIPE] = ACTIONS(67),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_return_BANG] = ACTIONS(829),
    [anon_sym_yield] = ACTIONS(825),
    [anon_sym_yield_BANG] = ACTIONS(829),
    [anon_sym_lazy] = ACTIONS(825),
    [anon_sym_assert] = ACTIONS(825),
    [anon_sym_upcast] = ACTIONS(825),
    [anon_sym_downcast] = ACTIONS(825),
    [anon_sym_for] = ACTIONS(73),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(79),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_match] = ACTIONS(83),
    [anon_sym_match_BANG] = ACTIONS(85),
    [anon_sym_function] = ACTIONS(87),
    [anon_sym_use] = ACTIONS(833),
    [anon_sym_use_BANG] = ACTIONS(835),
    [anon_sym_do_BANG] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(101),
    [aux_sym_char_token1] = ACTIONS(105),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(107),
    [anon_sym_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DQUOTE] = ACTIONS(111),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(115),
    [sym_bool] = ACTIONS(117),
    [sym_unit] = ACTIONS(1673),
    [anon_sym_LPAREN_PIPE] = ACTIONS(121),
    [sym_op_identifier] = ACTIONS(1675),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(837),
    [sym_xint] = ACTIONS(387),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(135),
  },
  [682] = {
    [sym_function_or_value_defn] = STATE(509),
    [sym__expression] = STATE(302),
    [sym_literal_expression] = STATE(2230),
    [sym_long_identifier_or_op] = STATE(2230),
    [sym_tuple_expression] = STATE(2230),
    [sym_brace_expression] = STATE(2230),
    [sym_anon_record_expression] = STATE(2230),
    [sym_prefixed_expression] = STATE(2230),
    [sym_typecast_expression] = STATE(2230),
    [sym_for_expression] = STATE(2230),
    [sym_while_expression] = STATE(2230),
    [sym__if_branch] = STATE(6659),
    [sym_if_expression] = STATE(2230),
    [sym_fun_expression] = STATE(2230),
    [sym_try_expression] = STATE(2230),
    [sym_match_expression] = STATE(2230),
    [sym_function_expression] = STATE(2230),
    [sym_mutate_expression] = STATE(2230),
    [sym_index_expression] = STATE(2230),
    [sym_typed_expression] = STATE(2230),
    [sym_declaration_expression] = STATE(2230),
    [sym_do_expression] = STATE(2230),
    [sym_list_expression] = STATE(2230),
    [sym_array_expression] = STATE(2230),
    [sym_begin_end_expression] = STATE(2230),
    [sym_paren_expression] = STATE(2230),
    [sym__high_prec_app] = STATE(2229),
    [sym__low_prec_app] = STATE(2229),
    [sym_application_expression] = STATE(2230),
    [sym_dot_expression] = STATE(2230),
    [sym_infix_expression] = STATE(2230),
    [sym_ce_expression] = STATE(2230),
    [sym_sequential_expression] = STATE(2230),
    [sym_char] = STATE(2100),
    [sym_format_string] = STATE(2106),
    [sym__string_literal] = STATE(2106),
    [sym_string] = STATE(2100),
    [sym_verbatim_string] = STATE(2100),
    [sym_bytearray] = STATE(2100),
    [sym_verbatim_bytearray] = STATE(2100),
    [sym_format_triple_quoted_string] = STATE(2107),
    [sym_triple_quoted_string] = STATE(2100),
    [sym_const] = STATE(2230),
    [sym_long_identifier] = STATE(2232),
    [sym_active_pattern] = STATE(2424),
    [sym__identifier_or_op] = STATE(2305),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(737),
    [sym_sbyte] = STATE(2100),
    [sym_byte] = STATE(2100),
    [sym_int16] = STATE(2100),
    [sym_uint16] = STATE(2100),
    [sym_int32] = STATE(2100),
    [sym_uint32] = STATE(2100),
    [sym_nativeint] = STATE(2100),
    [sym_unativeint] = STATE(2100),
    [sym_int64] = STATE(2100),
    [sym_uint64] = STATE(2100),
    [sym_ieee32] = STATE(2100),
    [sym_ieee64] = STATE(2100),
    [sym_bignum] = STATE(2100),
    [sym_decimal] = STATE(2100),
    [sym_float] = STATE(1487),
    [sym_block_comment] = STATE(682),
    [sym_compiler_directive_decl] = STATE(682),
    [sym_fsi_directive_decl] = STATE(682),
    [sym_preproc_line] = STATE(682),
    [sym_preproc_if_in_expression] = STATE(2230),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(877),
    [anon_sym_return] = ACTIONS(881),
    [anon_sym_do] = ACTIONS(1585),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(885),
    [anon_sym_null] = ACTIONS(889),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(891),
    [anon_sym_LBRACK_PIPE] = ACTIONS(893),
    [anon_sym_LBRACE] = ACTIONS(2048),
    [anon_sym_LT_AT] = ACTIONS(897),
    [anon_sym_LT_AT_AT] = ACTIONS(2050),
    [anon_sym_LBRACE_PIPE] = ACTIONS(903),
    [anon_sym_new] = ACTIONS(881),
    [anon_sym_return_BANG] = ACTIONS(905),
    [anon_sym_yield] = ACTIONS(881),
    [anon_sym_yield_BANG] = ACTIONS(905),
    [anon_sym_lazy] = ACTIONS(881),
    [anon_sym_assert] = ACTIONS(881),
    [anon_sym_upcast] = ACTIONS(881),
    [anon_sym_downcast] = ACTIONS(881),
    [anon_sym_for] = ACTIONS(909),
    [anon_sym_while] = ACTIONS(911),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(913),
    [anon_sym_try] = ACTIONS(915),
    [anon_sym_match] = ACTIONS(917),
    [anon_sym_match_BANG] = ACTIONS(919),
    [anon_sym_function] = ACTIONS(921),
    [anon_sym_use] = ACTIONS(929),
    [anon_sym_use_BANG] = ACTIONS(931),
    [anon_sym_do_BANG] = ACTIONS(933),
    [anon_sym_begin] = ACTIONS(937),
    [aux_sym_char_token1] = ACTIONS(941),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(943),
    [anon_sym_DQUOTE] = ACTIONS(945),
    [anon_sym_AT_DQUOTE] = ACTIONS(947),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(949),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(951),
    [sym_bool] = ACTIONS(953),
    [sym_unit] = ACTIONS(2052),
    [anon_sym_LPAREN_PIPE] = ACTIONS(957),
    [sym_op_identifier] = ACTIONS(2054),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(961),
    [sym_xint] = ACTIONS(963),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(965),
  },
  [683] = {
    [sym_function_or_value_defn] = STATE(733),
    [sym__expression] = STATE(136),
    [sym_literal_expression] = STATE(2008),
    [sym_long_identifier_or_op] = STATE(2008),
    [sym_tuple_expression] = STATE(2008),
    [sym_brace_expression] = STATE(2008),
    [sym_anon_record_expression] = STATE(2008),
    [sym_prefixed_expression] = STATE(2008),
    [sym_typecast_expression] = STATE(2008),
    [sym_for_expression] = STATE(2008),
    [sym_while_expression] = STATE(2008),
    [sym__if_branch] = STATE(6754),
    [sym_if_expression] = STATE(2008),
    [sym_fun_expression] = STATE(2008),
    [sym_try_expression] = STATE(2008),
    [sym_match_expression] = STATE(2008),
    [sym_function_expression] = STATE(2008),
    [sym_mutate_expression] = STATE(2008),
    [sym_index_expression] = STATE(2008),
    [sym_typed_expression] = STATE(2008),
    [sym_declaration_expression] = STATE(2008),
    [sym_do_expression] = STATE(2008),
    [sym_list_expression] = STATE(2008),
    [sym_array_expression] = STATE(2008),
    [sym_begin_end_expression] = STATE(2008),
    [sym_paren_expression] = STATE(2008),
    [sym__high_prec_app] = STATE(2007),
    [sym__low_prec_app] = STATE(2007),
    [sym_application_expression] = STATE(2008),
    [sym_dot_expression] = STATE(2008),
    [sym_infix_expression] = STATE(2008),
    [sym_ce_expression] = STATE(2008),
    [sym_sequential_expression] = STATE(2008),
    [sym_char] = STATE(1859),
    [sym_format_string] = STATE(1861),
    [sym__string_literal] = STATE(1861),
    [sym_string] = STATE(1859),
    [sym_verbatim_string] = STATE(1859),
    [sym_bytearray] = STATE(1859),
    [sym_verbatim_bytearray] = STATE(1859),
    [sym_format_triple_quoted_string] = STATE(1862),
    [sym_triple_quoted_string] = STATE(1859),
    [sym_const] = STATE(2008),
    [sym_long_identifier] = STATE(1701),
    [sym_active_pattern] = STATE(1702),
    [sym__identifier_or_op] = STATE(1724),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(706),
    [sym_sbyte] = STATE(1859),
    [sym_byte] = STATE(1859),
    [sym_int16] = STATE(1859),
    [sym_uint16] = STATE(1859),
    [sym_int32] = STATE(1859),
    [sym_uint32] = STATE(1859),
    [sym_nativeint] = STATE(1859),
    [sym_unativeint] = STATE(1859),
    [sym_int64] = STATE(1859),
    [sym_uint64] = STATE(1859),
    [sym_ieee32] = STATE(1859),
    [sym_ieee64] = STATE(1859),
    [sym_bignum] = STATE(1859),
    [sym_decimal] = STATE(1859),
    [sym_float] = STATE(1447),
    [sym_block_comment] = STATE(683),
    [sym_compiler_directive_decl] = STATE(683),
    [sym_fsi_directive_decl] = STATE(683),
    [sym_preproc_line] = STATE(683),
    [sym_preproc_if_in_expression] = STATE(2008),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(503),
    [anon_sym_return] = ACTIONS(971),
    [anon_sym_do] = ACTIONS(599),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(511),
    [anon_sym_null] = ACTIONS(515),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(517),
    [anon_sym_LBRACK_PIPE] = ACTIONS(519),
    [anon_sym_LBRACE] = ACTIONS(2060),
    [anon_sym_LT_AT] = ACTIONS(523),
    [anon_sym_LT_AT_AT] = ACTIONS(2062),
    [anon_sym_LBRACE_PIPE] = ACTIONS(529),
    [anon_sym_new] = ACTIONS(971),
    [anon_sym_return_BANG] = ACTIONS(975),
    [anon_sym_yield] = ACTIONS(971),
    [anon_sym_yield_BANG] = ACTIONS(975),
    [anon_sym_lazy] = ACTIONS(971),
    [anon_sym_assert] = ACTIONS(971),
    [anon_sym_upcast] = ACTIONS(971),
    [anon_sym_downcast] = ACTIONS(971),
    [anon_sym_for] = ACTIONS(979),
    [anon_sym_while] = ACTIONS(537),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(539),
    [anon_sym_try] = ACTIONS(543),
    [anon_sym_match] = ACTIONS(545),
    [anon_sym_match_BANG] = ACTIONS(547),
    [anon_sym_function] = ACTIONS(549),
    [anon_sym_use] = ACTIONS(983),
    [anon_sym_use_BANG] = ACTIONS(985),
    [anon_sym_do_BANG] = ACTIONS(561),
    [anon_sym_begin] = ACTIONS(565),
    [aux_sym_char_token1] = ACTIONS(569),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(571),
    [anon_sym_DQUOTE] = ACTIONS(573),
    [anon_sym_AT_DQUOTE] = ACTIONS(575),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(577),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(579),
    [sym_bool] = ACTIONS(581),
    [sym_unit] = ACTIONS(2064),
    [anon_sym_LPAREN_PIPE] = ACTIONS(585),
    [sym_op_identifier] = ACTIONS(2066),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(591),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(593),
  },
  [684] = {
    [sym_function_or_value_defn] = STATE(733),
    [sym__expression] = STATE(322),
    [sym_literal_expression] = STATE(2008),
    [sym_long_identifier_or_op] = STATE(2008),
    [sym_tuple_expression] = STATE(2008),
    [sym_brace_expression] = STATE(2008),
    [sym_anon_record_expression] = STATE(2008),
    [sym_prefixed_expression] = STATE(2008),
    [sym_typecast_expression] = STATE(2008),
    [sym_for_expression] = STATE(2008),
    [sym_while_expression] = STATE(2008),
    [sym__if_branch] = STATE(6754),
    [sym_if_expression] = STATE(2008),
    [sym_fun_expression] = STATE(2008),
    [sym_try_expression] = STATE(2008),
    [sym_match_expression] = STATE(2008),
    [sym_function_expression] = STATE(2008),
    [sym_mutate_expression] = STATE(2008),
    [sym_index_expression] = STATE(2008),
    [sym_typed_expression] = STATE(2008),
    [sym_declaration_expression] = STATE(2008),
    [sym_do_expression] = STATE(2008),
    [sym_list_expression] = STATE(2008),
    [sym_array_expression] = STATE(2008),
    [sym_begin_end_expression] = STATE(2008),
    [sym_paren_expression] = STATE(2008),
    [sym__high_prec_app] = STATE(2007),
    [sym__low_prec_app] = STATE(2007),
    [sym_application_expression] = STATE(2008),
    [sym_dot_expression] = STATE(2008),
    [sym_infix_expression] = STATE(2008),
    [sym_ce_expression] = STATE(2008),
    [sym_sequential_expression] = STATE(2008),
    [sym_char] = STATE(1859),
    [sym_format_string] = STATE(1861),
    [sym__string_literal] = STATE(1861),
    [sym_string] = STATE(1859),
    [sym_verbatim_string] = STATE(1859),
    [sym_bytearray] = STATE(1859),
    [sym_verbatim_bytearray] = STATE(1859),
    [sym_format_triple_quoted_string] = STATE(1862),
    [sym_triple_quoted_string] = STATE(1859),
    [sym_const] = STATE(2008),
    [sym_long_identifier] = STATE(1701),
    [sym_active_pattern] = STATE(1702),
    [sym__identifier_or_op] = STATE(1724),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(706),
    [sym_sbyte] = STATE(1859),
    [sym_byte] = STATE(1859),
    [sym_int16] = STATE(1859),
    [sym_uint16] = STATE(1859),
    [sym_int32] = STATE(1859),
    [sym_uint32] = STATE(1859),
    [sym_nativeint] = STATE(1859),
    [sym_unativeint] = STATE(1859),
    [sym_int64] = STATE(1859),
    [sym_uint64] = STATE(1859),
    [sym_ieee32] = STATE(1859),
    [sym_ieee64] = STATE(1859),
    [sym_bignum] = STATE(1859),
    [sym_decimal] = STATE(1859),
    [sym_float] = STATE(1447),
    [sym_block_comment] = STATE(684),
    [sym_compiler_directive_decl] = STATE(684),
    [sym_fsi_directive_decl] = STATE(684),
    [sym_preproc_line] = STATE(684),
    [sym_preproc_if_in_expression] = STATE(2008),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(503),
    [anon_sym_return] = ACTIONS(971),
    [anon_sym_do] = ACTIONS(599),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(511),
    [anon_sym_null] = ACTIONS(515),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(517),
    [anon_sym_LBRACK_PIPE] = ACTIONS(519),
    [anon_sym_LBRACE] = ACTIONS(2060),
    [anon_sym_LT_AT] = ACTIONS(523),
    [anon_sym_LT_AT_AT] = ACTIONS(2062),
    [anon_sym_LBRACE_PIPE] = ACTIONS(529),
    [anon_sym_new] = ACTIONS(971),
    [anon_sym_return_BANG] = ACTIONS(975),
    [anon_sym_yield] = ACTIONS(971),
    [anon_sym_yield_BANG] = ACTIONS(975),
    [anon_sym_lazy] = ACTIONS(971),
    [anon_sym_assert] = ACTIONS(971),
    [anon_sym_upcast] = ACTIONS(971),
    [anon_sym_downcast] = ACTIONS(971),
    [anon_sym_for] = ACTIONS(979),
    [anon_sym_while] = ACTIONS(537),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(539),
    [anon_sym_try] = ACTIONS(543),
    [anon_sym_match] = ACTIONS(545),
    [anon_sym_match_BANG] = ACTIONS(547),
    [anon_sym_function] = ACTIONS(549),
    [anon_sym_use] = ACTIONS(983),
    [anon_sym_use_BANG] = ACTIONS(985),
    [anon_sym_do_BANG] = ACTIONS(561),
    [anon_sym_begin] = ACTIONS(565),
    [aux_sym_char_token1] = ACTIONS(569),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(571),
    [anon_sym_DQUOTE] = ACTIONS(573),
    [anon_sym_AT_DQUOTE] = ACTIONS(575),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(577),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(579),
    [sym_bool] = ACTIONS(581),
    [sym_unit] = ACTIONS(2064),
    [anon_sym_LPAREN_PIPE] = ACTIONS(585),
    [sym_op_identifier] = ACTIONS(2066),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(591),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(593),
  },
  [685] = {
    [sym_function_or_value_defn] = STATE(600),
    [sym__expression] = STATE(275),
    [sym_literal_expression] = STATE(867),
    [sym_long_identifier_or_op] = STATE(867),
    [sym_tuple_expression] = STATE(867),
    [sym_brace_expression] = STATE(867),
    [sym_anon_record_expression] = STATE(867),
    [sym_prefixed_expression] = STATE(867),
    [sym_typecast_expression] = STATE(867),
    [sym_for_expression] = STATE(867),
    [sym_while_expression] = STATE(867),
    [sym__if_branch] = STATE(6511),
    [sym_if_expression] = STATE(867),
    [sym_fun_expression] = STATE(867),
    [sym_try_expression] = STATE(867),
    [sym_match_expression] = STATE(867),
    [sym_function_expression] = STATE(867),
    [sym_mutate_expression] = STATE(867),
    [sym_index_expression] = STATE(867),
    [sym_typed_expression] = STATE(867),
    [sym_declaration_expression] = STATE(867),
    [sym_do_expression] = STATE(867),
    [sym_list_expression] = STATE(867),
    [sym_array_expression] = STATE(867),
    [sym_begin_end_expression] = STATE(867),
    [sym_paren_expression] = STATE(867),
    [sym__high_prec_app] = STATE(864),
    [sym__low_prec_app] = STATE(864),
    [sym_application_expression] = STATE(867),
    [sym_dot_expression] = STATE(867),
    [sym_infix_expression] = STATE(867),
    [sym_ce_expression] = STATE(867),
    [sym_sequential_expression] = STATE(867),
    [sym_char] = STATE(868),
    [sym_format_string] = STATE(869),
    [sym__string_literal] = STATE(869),
    [sym_string] = STATE(868),
    [sym_verbatim_string] = STATE(868),
    [sym_bytearray] = STATE(868),
    [sym_verbatim_bytearray] = STATE(868),
    [sym_format_triple_quoted_string] = STATE(870),
    [sym_triple_quoted_string] = STATE(868),
    [sym_const] = STATE(867),
    [sym_long_identifier] = STATE(872),
    [sym_active_pattern] = STATE(871),
    [sym__identifier_or_op] = STATE(873),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(656),
    [sym_sbyte] = STATE(868),
    [sym_byte] = STATE(868),
    [sym_int16] = STATE(868),
    [sym_uint16] = STATE(868),
    [sym_int32] = STATE(868),
    [sym_uint32] = STATE(868),
    [sym_nativeint] = STATE(868),
    [sym_unativeint] = STATE(868),
    [sym_int64] = STATE(868),
    [sym_uint64] = STATE(868),
    [sym_ieee32] = STATE(868),
    [sym_ieee64] = STATE(868),
    [sym_bignum] = STATE(868),
    [sym_decimal] = STATE(868),
    [sym_float] = STATE(1368),
    [sym_block_comment] = STATE(685),
    [sym_compiler_directive_decl] = STATE(685),
    [sym_fsi_directive_decl] = STATE(685),
    [sym_preproc_line] = STATE(685),
    [sym_preproc_if_in_expression] = STATE(867),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(29),
    [anon_sym_return] = ACTIONS(825),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_null] = ACTIONS(49),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACK_PIPE] = ACTIONS(57),
    [anon_sym_LBRACE] = ACTIONS(1663),
    [anon_sym_LT_AT] = ACTIONS(61),
    [anon_sym_LT_AT_AT] = ACTIONS(1665),
    [anon_sym_LBRACE_PIPE] = ACTIONS(67),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_return_BANG] = ACTIONS(829),
    [anon_sym_yield] = ACTIONS(825),
    [anon_sym_yield_BANG] = ACTIONS(829),
    [anon_sym_lazy] = ACTIONS(825),
    [anon_sym_assert] = ACTIONS(825),
    [anon_sym_upcast] = ACTIONS(825),
    [anon_sym_downcast] = ACTIONS(825),
    [anon_sym_for] = ACTIONS(73),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(79),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_match] = ACTIONS(83),
    [anon_sym_match_BANG] = ACTIONS(85),
    [anon_sym_function] = ACTIONS(87),
    [anon_sym_use] = ACTIONS(833),
    [anon_sym_use_BANG] = ACTIONS(835),
    [anon_sym_do_BANG] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(101),
    [aux_sym_char_token1] = ACTIONS(105),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(107),
    [anon_sym_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DQUOTE] = ACTIONS(111),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(115),
    [sym_bool] = ACTIONS(117),
    [sym_unit] = ACTIONS(1673),
    [anon_sym_LPAREN_PIPE] = ACTIONS(121),
    [sym_op_identifier] = ACTIONS(1675),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(837),
    [sym_xint] = ACTIONS(387),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(135),
  },
  [686] = {
    [sym_function_or_value_defn] = STATE(704),
    [sym__expression] = STATE(281),
    [sym_literal_expression] = STATE(2403),
    [sym_long_identifier_or_op] = STATE(2403),
    [sym_tuple_expression] = STATE(2403),
    [sym_brace_expression] = STATE(2403),
    [sym_anon_record_expression] = STATE(2403),
    [sym_prefixed_expression] = STATE(2403),
    [sym_typecast_expression] = STATE(2403),
    [sym_for_expression] = STATE(2403),
    [sym_while_expression] = STATE(2403),
    [sym__if_branch] = STATE(6794),
    [sym_if_expression] = STATE(2403),
    [sym_fun_expression] = STATE(2403),
    [sym_try_expression] = STATE(2403),
    [sym_match_expression] = STATE(2403),
    [sym_function_expression] = STATE(2403),
    [sym_mutate_expression] = STATE(2403),
    [sym_index_expression] = STATE(2403),
    [sym_typed_expression] = STATE(2403),
    [sym_declaration_expression] = STATE(2403),
    [sym_do_expression] = STATE(2403),
    [sym_list_expression] = STATE(2403),
    [sym_array_expression] = STATE(2403),
    [sym_begin_end_expression] = STATE(2403),
    [sym_paren_expression] = STATE(2403),
    [sym__high_prec_app] = STATE(2405),
    [sym__low_prec_app] = STATE(2405),
    [sym_application_expression] = STATE(2403),
    [sym_dot_expression] = STATE(2403),
    [sym_infix_expression] = STATE(2403),
    [sym_ce_expression] = STATE(2403),
    [sym_sequential_expression] = STATE(2403),
    [sym_char] = STATE(2425),
    [sym_format_string] = STATE(2420),
    [sym__string_literal] = STATE(2420),
    [sym_string] = STATE(2425),
    [sym_verbatim_string] = STATE(2425),
    [sym_bytearray] = STATE(2425),
    [sym_verbatim_bytearray] = STATE(2425),
    [sym_format_triple_quoted_string] = STATE(2419),
    [sym_triple_quoted_string] = STATE(2425),
    [sym_const] = STATE(2403),
    [sym_long_identifier] = STATE(2079),
    [sym_active_pattern] = STATE(2080),
    [sym__identifier_or_op] = STATE(2089),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(688),
    [sym_sbyte] = STATE(2425),
    [sym_byte] = STATE(2425),
    [sym_int16] = STATE(2425),
    [sym_uint16] = STATE(2425),
    [sym_int32] = STATE(2425),
    [sym_uint32] = STATE(2425),
    [sym_nativeint] = STATE(2425),
    [sym_unativeint] = STATE(2425),
    [sym_int64] = STATE(2425),
    [sym_uint64] = STATE(2425),
    [sym_ieee32] = STATE(2425),
    [sym_ieee64] = STATE(2425),
    [sym_bignum] = STATE(2425),
    [sym_decimal] = STATE(2425),
    [sym_float] = STATE(1511),
    [sym_block_comment] = STATE(686),
    [sym_compiler_directive_decl] = STATE(686),
    [sym_fsi_directive_decl] = STATE(686),
    [sym_preproc_line] = STATE(686),
    [sym_preproc_if_in_expression] = STATE(2403),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(1261),
    [anon_sym_return] = ACTIONS(1265),
    [anon_sym_do] = ACTIONS(1267),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(1269),
    [anon_sym_null] = ACTIONS(1273),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1275),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1277),
    [anon_sym_LBRACE] = ACTIONS(1909),
    [anon_sym_LT_AT] = ACTIONS(1281),
    [anon_sym_LT_AT_AT] = ACTIONS(1911),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1287),
    [anon_sym_new] = ACTIONS(1265),
    [anon_sym_return_BANG] = ACTIONS(1289),
    [anon_sym_yield] = ACTIONS(1265),
    [anon_sym_yield_BANG] = ACTIONS(1289),
    [anon_sym_lazy] = ACTIONS(1265),
    [anon_sym_assert] = ACTIONS(1265),
    [anon_sym_upcast] = ACTIONS(1265),
    [anon_sym_downcast] = ACTIONS(1265),
    [anon_sym_for] = ACTIONS(1293),
    [anon_sym_while] = ACTIONS(1295),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(1297),
    [anon_sym_try] = ACTIONS(1299),
    [anon_sym_match] = ACTIONS(1301),
    [anon_sym_match_BANG] = ACTIONS(1303),
    [anon_sym_function] = ACTIONS(1305),
    [anon_sym_use] = ACTIONS(1313),
    [anon_sym_use_BANG] = ACTIONS(1315),
    [anon_sym_do_BANG] = ACTIONS(1317),
    [anon_sym_begin] = ACTIONS(1319),
    [aux_sym_char_token1] = ACTIONS(1323),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1325),
    [anon_sym_DQUOTE] = ACTIONS(1327),
    [anon_sym_AT_DQUOTE] = ACTIONS(1329),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1331),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1333),
    [sym_bool] = ACTIONS(1335),
    [sym_unit] = ACTIONS(1913),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1339),
    [sym_op_identifier] = ACTIONS(1915),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(1343),
    [sym_xint] = ACTIONS(1345),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1347),
  },
  [687] = {
    [sym_function_or_value_defn] = STATE(663),
    [sym__expression] = STATE(69),
    [sym_literal_expression] = STATE(1118),
    [sym_long_identifier_or_op] = STATE(1118),
    [sym_tuple_expression] = STATE(1118),
    [sym_brace_expression] = STATE(1118),
    [sym_anon_record_expression] = STATE(1118),
    [sym_prefixed_expression] = STATE(1118),
    [sym_typecast_expression] = STATE(1118),
    [sym_for_expression] = STATE(1118),
    [sym_while_expression] = STATE(1118),
    [sym__if_branch] = STATE(7163),
    [sym_if_expression] = STATE(1118),
    [sym_fun_expression] = STATE(1118),
    [sym_try_expression] = STATE(1118),
    [sym_match_expression] = STATE(1118),
    [sym_function_expression] = STATE(1118),
    [sym_mutate_expression] = STATE(1118),
    [sym_index_expression] = STATE(1118),
    [sym_typed_expression] = STATE(1118),
    [sym_declaration_expression] = STATE(1118),
    [sym_do_expression] = STATE(1118),
    [sym_list_expression] = STATE(1118),
    [sym_array_expression] = STATE(1118),
    [sym_begin_end_expression] = STATE(1118),
    [sym_paren_expression] = STATE(1118),
    [sym__high_prec_app] = STATE(1133),
    [sym__low_prec_app] = STATE(1133),
    [sym_application_expression] = STATE(1118),
    [sym_dot_expression] = STATE(1118),
    [sym_infix_expression] = STATE(1118),
    [sym_ce_expression] = STATE(1118),
    [sym_sequential_expression] = STATE(1118),
    [sym_char] = STATE(1080),
    [sym_format_string] = STATE(1090),
    [sym__string_literal] = STATE(1090),
    [sym_string] = STATE(1080),
    [sym_verbatim_string] = STATE(1080),
    [sym_bytearray] = STATE(1080),
    [sym_verbatim_bytearray] = STATE(1080),
    [sym_format_triple_quoted_string] = STATE(1096),
    [sym_triple_quoted_string] = STATE(1080),
    [sym_const] = STATE(1118),
    [sym_long_identifier] = STATE(1156),
    [sym_active_pattern] = STATE(1085),
    [sym__identifier_or_op] = STATE(1099),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(548),
    [sym_sbyte] = STATE(1080),
    [sym_byte] = STATE(1080),
    [sym_int16] = STATE(1080),
    [sym_uint16] = STATE(1080),
    [sym_int32] = STATE(1080),
    [sym_uint32] = STATE(1080),
    [sym_nativeint] = STATE(1080),
    [sym_unativeint] = STATE(1080),
    [sym_int64] = STATE(1080),
    [sym_uint64] = STATE(1080),
    [sym_ieee32] = STATE(1080),
    [sym_ieee64] = STATE(1080),
    [sym_bignum] = STATE(1080),
    [sym_decimal] = STATE(1080),
    [sym_float] = STATE(979),
    [sym_block_comment] = STATE(687),
    [sym_compiler_directive_decl] = STATE(687),
    [sym_fsi_directive_decl] = STATE(687),
    [sym_preproc_line] = STATE(687),
    [sym_preproc_if_in_expression] = STATE(1118),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(195),
    [anon_sym_return] = ACTIONS(481),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_null] = ACTIONS(207),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(209),
    [anon_sym_LBRACK_PIPE] = ACTIONS(211),
    [anon_sym_LBRACE] = ACTIONS(1687),
    [anon_sym_LT_AT] = ACTIONS(213),
    [anon_sym_LT_AT_AT] = ACTIONS(1689),
    [anon_sym_LBRACE_PIPE] = ACTIONS(217),
    [anon_sym_new] = ACTIONS(481),
    [anon_sym_return_BANG] = ACTIONS(487),
    [anon_sym_yield] = ACTIONS(481),
    [anon_sym_yield_BANG] = ACTIONS(487),
    [anon_sym_lazy] = ACTIONS(481),
    [anon_sym_assert] = ACTIONS(481),
    [anon_sym_upcast] = ACTIONS(481),
    [anon_sym_downcast] = ACTIONS(481),
    [anon_sym_for] = ACTIONS(489),
    [anon_sym_while] = ACTIONS(225),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(229),
    [anon_sym_match] = ACTIONS(231),
    [anon_sym_match_BANG] = ACTIONS(233),
    [anon_sym_function] = ACTIONS(235),
    [anon_sym_use] = ACTIONS(493),
    [anon_sym_use_BANG] = ACTIONS(495),
    [anon_sym_do_BANG] = ACTIONS(243),
    [anon_sym_begin] = ACTIONS(245),
    [aux_sym_char_token1] = ACTIONS(247),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(251),
    [anon_sym_AT_DQUOTE] = ACTIONS(253),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(255),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(257),
    [sym_bool] = ACTIONS(259),
    [sym_unit] = ACTIONS(1699),
    [anon_sym_LPAREN_PIPE] = ACTIONS(261),
    [sym_op_identifier] = ACTIONS(1701),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(499),
    [sym_xint] = ACTIONS(267),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(269),
  },
  [688] = {
    [sym_function_or_value_defn] = STATE(704),
    [sym__expression] = STATE(261),
    [sym_literal_expression] = STATE(2403),
    [sym_long_identifier_or_op] = STATE(2403),
    [sym_tuple_expression] = STATE(2403),
    [sym_brace_expression] = STATE(2403),
    [sym_anon_record_expression] = STATE(2403),
    [sym_prefixed_expression] = STATE(2403),
    [sym_typecast_expression] = STATE(2403),
    [sym_for_expression] = STATE(2403),
    [sym_while_expression] = STATE(2403),
    [sym__if_branch] = STATE(6794),
    [sym_if_expression] = STATE(2403),
    [sym_fun_expression] = STATE(2403),
    [sym_try_expression] = STATE(2403),
    [sym_match_expression] = STATE(2403),
    [sym_function_expression] = STATE(2403),
    [sym_mutate_expression] = STATE(2403),
    [sym_index_expression] = STATE(2403),
    [sym_typed_expression] = STATE(2403),
    [sym_declaration_expression] = STATE(2403),
    [sym_do_expression] = STATE(2403),
    [sym_list_expression] = STATE(2403),
    [sym_array_expression] = STATE(2403),
    [sym_begin_end_expression] = STATE(2403),
    [sym_paren_expression] = STATE(2403),
    [sym__high_prec_app] = STATE(2405),
    [sym__low_prec_app] = STATE(2405),
    [sym_application_expression] = STATE(2403),
    [sym_dot_expression] = STATE(2403),
    [sym_infix_expression] = STATE(2403),
    [sym_ce_expression] = STATE(2403),
    [sym_sequential_expression] = STATE(2403),
    [sym_char] = STATE(2425),
    [sym_format_string] = STATE(2420),
    [sym__string_literal] = STATE(2420),
    [sym_string] = STATE(2425),
    [sym_verbatim_string] = STATE(2425),
    [sym_bytearray] = STATE(2425),
    [sym_verbatim_bytearray] = STATE(2425),
    [sym_format_triple_quoted_string] = STATE(2419),
    [sym_triple_quoted_string] = STATE(2425),
    [sym_const] = STATE(2403),
    [sym_long_identifier] = STATE(2079),
    [sym_active_pattern] = STATE(2080),
    [sym__identifier_or_op] = STATE(2089),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(688),
    [sym_sbyte] = STATE(2425),
    [sym_byte] = STATE(2425),
    [sym_int16] = STATE(2425),
    [sym_uint16] = STATE(2425),
    [sym_int32] = STATE(2425),
    [sym_uint32] = STATE(2425),
    [sym_nativeint] = STATE(2425),
    [sym_unativeint] = STATE(2425),
    [sym_int64] = STATE(2425),
    [sym_uint64] = STATE(2425),
    [sym_ieee32] = STATE(2425),
    [sym_ieee64] = STATE(2425),
    [sym_bignum] = STATE(2425),
    [sym_decimal] = STATE(2425),
    [sym_float] = STATE(1511),
    [sym_block_comment] = STATE(688),
    [sym_compiler_directive_decl] = STATE(688),
    [sym_fsi_directive_decl] = STATE(688),
    [sym_preproc_line] = STATE(688),
    [sym_preproc_if_in_expression] = STATE(2403),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(1261),
    [anon_sym_return] = ACTIONS(1265),
    [anon_sym_do] = ACTIONS(1267),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(1269),
    [anon_sym_null] = ACTIONS(1273),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1275),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1277),
    [anon_sym_LBRACE] = ACTIONS(1909),
    [anon_sym_LT_AT] = ACTIONS(1281),
    [anon_sym_LT_AT_AT] = ACTIONS(1911),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1287),
    [anon_sym_new] = ACTIONS(1265),
    [anon_sym_return_BANG] = ACTIONS(1289),
    [anon_sym_yield] = ACTIONS(1265),
    [anon_sym_yield_BANG] = ACTIONS(1289),
    [anon_sym_lazy] = ACTIONS(1265),
    [anon_sym_assert] = ACTIONS(1265),
    [anon_sym_upcast] = ACTIONS(1265),
    [anon_sym_downcast] = ACTIONS(1265),
    [anon_sym_for] = ACTIONS(1293),
    [anon_sym_while] = ACTIONS(1295),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(1297),
    [anon_sym_try] = ACTIONS(1299),
    [anon_sym_match] = ACTIONS(1301),
    [anon_sym_match_BANG] = ACTIONS(1303),
    [anon_sym_function] = ACTIONS(1305),
    [anon_sym_use] = ACTIONS(1313),
    [anon_sym_use_BANG] = ACTIONS(1315),
    [anon_sym_do_BANG] = ACTIONS(1317),
    [anon_sym_begin] = ACTIONS(1319),
    [aux_sym_char_token1] = ACTIONS(1323),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1325),
    [anon_sym_DQUOTE] = ACTIONS(1327),
    [anon_sym_AT_DQUOTE] = ACTIONS(1329),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1331),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1333),
    [sym_bool] = ACTIONS(1335),
    [sym_unit] = ACTIONS(1913),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1339),
    [sym_op_identifier] = ACTIONS(1915),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(1343),
    [sym_xint] = ACTIONS(1345),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1347),
  },
  [689] = {
    [sym_function_or_value_defn] = STATE(704),
    [sym__expression] = STATE(297),
    [sym_literal_expression] = STATE(2403),
    [sym_long_identifier_or_op] = STATE(2403),
    [sym_tuple_expression] = STATE(2403),
    [sym_brace_expression] = STATE(2403),
    [sym_anon_record_expression] = STATE(2403),
    [sym_prefixed_expression] = STATE(2403),
    [sym_typecast_expression] = STATE(2403),
    [sym_for_expression] = STATE(2403),
    [sym_while_expression] = STATE(2403),
    [sym__if_branch] = STATE(6794),
    [sym_if_expression] = STATE(2403),
    [sym_fun_expression] = STATE(2403),
    [sym_try_expression] = STATE(2403),
    [sym_match_expression] = STATE(2403),
    [sym_function_expression] = STATE(2403),
    [sym_mutate_expression] = STATE(2403),
    [sym_index_expression] = STATE(2403),
    [sym_typed_expression] = STATE(2403),
    [sym_declaration_expression] = STATE(2403),
    [sym_do_expression] = STATE(2403),
    [sym_list_expression] = STATE(2403),
    [sym_array_expression] = STATE(2403),
    [sym_begin_end_expression] = STATE(2403),
    [sym_paren_expression] = STATE(2403),
    [sym__high_prec_app] = STATE(2405),
    [sym__low_prec_app] = STATE(2405),
    [sym_application_expression] = STATE(2403),
    [sym_dot_expression] = STATE(2403),
    [sym_infix_expression] = STATE(2403),
    [sym_ce_expression] = STATE(2403),
    [sym_sequential_expression] = STATE(2403),
    [sym_char] = STATE(2425),
    [sym_format_string] = STATE(2420),
    [sym__string_literal] = STATE(2420),
    [sym_string] = STATE(2425),
    [sym_verbatim_string] = STATE(2425),
    [sym_bytearray] = STATE(2425),
    [sym_verbatim_bytearray] = STATE(2425),
    [sym_format_triple_quoted_string] = STATE(2419),
    [sym_triple_quoted_string] = STATE(2425),
    [sym_const] = STATE(2403),
    [sym_long_identifier] = STATE(2079),
    [sym_active_pattern] = STATE(2080),
    [sym__identifier_or_op] = STATE(2089),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(688),
    [sym_sbyte] = STATE(2425),
    [sym_byte] = STATE(2425),
    [sym_int16] = STATE(2425),
    [sym_uint16] = STATE(2425),
    [sym_int32] = STATE(2425),
    [sym_uint32] = STATE(2425),
    [sym_nativeint] = STATE(2425),
    [sym_unativeint] = STATE(2425),
    [sym_int64] = STATE(2425),
    [sym_uint64] = STATE(2425),
    [sym_ieee32] = STATE(2425),
    [sym_ieee64] = STATE(2425),
    [sym_bignum] = STATE(2425),
    [sym_decimal] = STATE(2425),
    [sym_float] = STATE(1511),
    [sym_block_comment] = STATE(689),
    [sym_compiler_directive_decl] = STATE(689),
    [sym_fsi_directive_decl] = STATE(689),
    [sym_preproc_line] = STATE(689),
    [sym_preproc_if_in_expression] = STATE(2403),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(1261),
    [anon_sym_return] = ACTIONS(1265),
    [anon_sym_do] = ACTIONS(1267),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(1269),
    [anon_sym_null] = ACTIONS(1273),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1275),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1277),
    [anon_sym_LBRACE] = ACTIONS(1909),
    [anon_sym_LT_AT] = ACTIONS(1281),
    [anon_sym_LT_AT_AT] = ACTIONS(1911),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1287),
    [anon_sym_new] = ACTIONS(1265),
    [anon_sym_return_BANG] = ACTIONS(1289),
    [anon_sym_yield] = ACTIONS(1265),
    [anon_sym_yield_BANG] = ACTIONS(1289),
    [anon_sym_lazy] = ACTIONS(1265),
    [anon_sym_assert] = ACTIONS(1265),
    [anon_sym_upcast] = ACTIONS(1265),
    [anon_sym_downcast] = ACTIONS(1265),
    [anon_sym_for] = ACTIONS(1293),
    [anon_sym_while] = ACTIONS(1295),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(1297),
    [anon_sym_try] = ACTIONS(1299),
    [anon_sym_match] = ACTIONS(1301),
    [anon_sym_match_BANG] = ACTIONS(1303),
    [anon_sym_function] = ACTIONS(1305),
    [anon_sym_use] = ACTIONS(1313),
    [anon_sym_use_BANG] = ACTIONS(1315),
    [anon_sym_do_BANG] = ACTIONS(1317),
    [anon_sym_begin] = ACTIONS(1319),
    [aux_sym_char_token1] = ACTIONS(1323),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1325),
    [anon_sym_DQUOTE] = ACTIONS(1327),
    [anon_sym_AT_DQUOTE] = ACTIONS(1329),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1331),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1333),
    [sym_bool] = ACTIONS(1335),
    [sym_unit] = ACTIONS(1913),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1339),
    [sym_op_identifier] = ACTIONS(1915),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(1343),
    [sym_xint] = ACTIONS(1345),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1347),
  },
  [690] = {
    [sym_function_or_value_defn] = STATE(482),
    [sym__expression] = STATE(22),
    [sym_literal_expression] = STATE(1537),
    [sym_long_identifier_or_op] = STATE(1537),
    [sym_tuple_expression] = STATE(1537),
    [sym_brace_expression] = STATE(1537),
    [sym_anon_record_expression] = STATE(1537),
    [sym_prefixed_expression] = STATE(1537),
    [sym_typecast_expression] = STATE(1537),
    [sym_for_expression] = STATE(1537),
    [sym_while_expression] = STATE(1537),
    [sym__if_branch] = STATE(6834),
    [sym_if_expression] = STATE(1537),
    [sym_fun_expression] = STATE(1537),
    [sym_try_expression] = STATE(1537),
    [sym_match_expression] = STATE(1537),
    [sym_function_expression] = STATE(1537),
    [sym_mutate_expression] = STATE(1537),
    [sym_index_expression] = STATE(1537),
    [sym_typed_expression] = STATE(1537),
    [sym_declaration_expression] = STATE(1537),
    [sym_do_expression] = STATE(1537),
    [sym_list_expression] = STATE(1537),
    [sym_array_expression] = STATE(1537),
    [sym_begin_end_expression] = STATE(1537),
    [sym_paren_expression] = STATE(1537),
    [sym__high_prec_app] = STATE(1538),
    [sym__low_prec_app] = STATE(1538),
    [sym_application_expression] = STATE(1537),
    [sym_dot_expression] = STATE(1537),
    [sym_infix_expression] = STATE(1537),
    [sym_ce_expression] = STATE(1537),
    [sym_sequential_expression] = STATE(1537),
    [sym_char] = STATE(1484),
    [sym_format_string] = STATE(1483),
    [sym__string_literal] = STATE(1483),
    [sym_string] = STATE(1484),
    [sym_verbatim_string] = STATE(1484),
    [sym_bytearray] = STATE(1484),
    [sym_verbatim_bytearray] = STATE(1484),
    [sym_format_triple_quoted_string] = STATE(1482),
    [sym_triple_quoted_string] = STATE(1484),
    [sym_const] = STATE(1537),
    [sym_long_identifier] = STATE(1643),
    [sym_active_pattern] = STATE(1645),
    [sym__identifier_or_op] = STATE(1689),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(670),
    [sym_sbyte] = STATE(1484),
    [sym_byte] = STATE(1484),
    [sym_int16] = STATE(1484),
    [sym_uint16] = STATE(1484),
    [sym_int32] = STATE(1484),
    [sym_uint32] = STATE(1484),
    [sym_nativeint] = STATE(1484),
    [sym_unativeint] = STATE(1484),
    [sym_int64] = STATE(1484),
    [sym_uint64] = STATE(1484),
    [sym_ieee32] = STATE(1484),
    [sym_ieee64] = STATE(1484),
    [sym_bignum] = STATE(1484),
    [sym_decimal] = STATE(1484),
    [sym_float] = STATE(1327),
    [sym_block_comment] = STATE(690),
    [sym_compiler_directive_decl] = STATE(690),
    [sym_fsi_directive_decl] = STATE(690),
    [sym_preproc_line] = STATE(690),
    [sym_preproc_if_in_expression] = STATE(1537),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(275),
    [anon_sym_return] = ACTIONS(279),
    [anon_sym_do] = ACTIONS(281),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(285),
    [anon_sym_null] = ACTIONS(289),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(291),
    [anon_sym_LBRACK_PIPE] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(2128),
    [anon_sym_LT_AT] = ACTIONS(297),
    [anon_sym_LT_AT_AT] = ACTIONS(2130),
    [anon_sym_LBRACE_PIPE] = ACTIONS(303),
    [anon_sym_new] = ACTIONS(279),
    [anon_sym_return_BANG] = ACTIONS(307),
    [anon_sym_yield] = ACTIONS(279),
    [anon_sym_yield_BANG] = ACTIONS(307),
    [anon_sym_lazy] = ACTIONS(279),
    [anon_sym_assert] = ACTIONS(279),
    [anon_sym_upcast] = ACTIONS(279),
    [anon_sym_downcast] = ACTIONS(279),
    [anon_sym_for] = ACTIONS(311),
    [anon_sym_while] = ACTIONS(313),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(315),
    [anon_sym_try] = ACTIONS(317),
    [anon_sym_match] = ACTIONS(319),
    [anon_sym_match_BANG] = ACTIONS(321),
    [anon_sym_function] = ACTIONS(323),
    [anon_sym_use] = ACTIONS(331),
    [anon_sym_use_BANG] = ACTIONS(333),
    [anon_sym_do_BANG] = ACTIONS(335),
    [anon_sym_begin] = ACTIONS(337),
    [aux_sym_char_token1] = ACTIONS(341),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(343),
    [anon_sym_DQUOTE] = ACTIONS(345),
    [anon_sym_AT_DQUOTE] = ACTIONS(347),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(349),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(351),
    [sym_bool] = ACTIONS(353),
    [sym_unit] = ACTIONS(2132),
    [anon_sym_LPAREN_PIPE] = ACTIONS(357),
    [sym_op_identifier] = ACTIONS(2134),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(361),
    [sym_xint] = ACTIONS(363),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(365),
  },
  [691] = {
    [sym_function_or_value_defn] = STATE(600),
    [sym__expression] = STATE(280),
    [sym_literal_expression] = STATE(867),
    [sym_long_identifier_or_op] = STATE(867),
    [sym_tuple_expression] = STATE(867),
    [sym_brace_expression] = STATE(867),
    [sym_anon_record_expression] = STATE(867),
    [sym_prefixed_expression] = STATE(867),
    [sym_typecast_expression] = STATE(867),
    [sym_for_expression] = STATE(867),
    [sym_while_expression] = STATE(867),
    [sym__if_branch] = STATE(6511),
    [sym_if_expression] = STATE(867),
    [sym_fun_expression] = STATE(867),
    [sym_try_expression] = STATE(867),
    [sym_match_expression] = STATE(867),
    [sym_function_expression] = STATE(867),
    [sym_mutate_expression] = STATE(867),
    [sym_index_expression] = STATE(867),
    [sym_typed_expression] = STATE(867),
    [sym_declaration_expression] = STATE(867),
    [sym_do_expression] = STATE(867),
    [sym_list_expression] = STATE(867),
    [sym_array_expression] = STATE(867),
    [sym_begin_end_expression] = STATE(867),
    [sym_paren_expression] = STATE(867),
    [sym__high_prec_app] = STATE(864),
    [sym__low_prec_app] = STATE(864),
    [sym_application_expression] = STATE(867),
    [sym_dot_expression] = STATE(867),
    [sym_infix_expression] = STATE(867),
    [sym_ce_expression] = STATE(867),
    [sym_sequential_expression] = STATE(867),
    [sym_char] = STATE(868),
    [sym_format_string] = STATE(869),
    [sym__string_literal] = STATE(869),
    [sym_string] = STATE(868),
    [sym_verbatim_string] = STATE(868),
    [sym_bytearray] = STATE(868),
    [sym_verbatim_bytearray] = STATE(868),
    [sym_format_triple_quoted_string] = STATE(870),
    [sym_triple_quoted_string] = STATE(868),
    [sym_const] = STATE(867),
    [sym_long_identifier] = STATE(872),
    [sym_active_pattern] = STATE(871),
    [sym__identifier_or_op] = STATE(873),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(656),
    [sym_sbyte] = STATE(868),
    [sym_byte] = STATE(868),
    [sym_int16] = STATE(868),
    [sym_uint16] = STATE(868),
    [sym_int32] = STATE(868),
    [sym_uint32] = STATE(868),
    [sym_nativeint] = STATE(868),
    [sym_unativeint] = STATE(868),
    [sym_int64] = STATE(868),
    [sym_uint64] = STATE(868),
    [sym_ieee32] = STATE(868),
    [sym_ieee64] = STATE(868),
    [sym_bignum] = STATE(868),
    [sym_decimal] = STATE(868),
    [sym_float] = STATE(1368),
    [sym_block_comment] = STATE(691),
    [sym_compiler_directive_decl] = STATE(691),
    [sym_fsi_directive_decl] = STATE(691),
    [sym_preproc_line] = STATE(691),
    [sym_preproc_if_in_expression] = STATE(867),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(29),
    [anon_sym_return] = ACTIONS(825),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_null] = ACTIONS(49),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACK_PIPE] = ACTIONS(57),
    [anon_sym_LBRACE] = ACTIONS(1663),
    [anon_sym_LT_AT] = ACTIONS(61),
    [anon_sym_LT_AT_AT] = ACTIONS(1665),
    [anon_sym_LBRACE_PIPE] = ACTIONS(67),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_return_BANG] = ACTIONS(829),
    [anon_sym_yield] = ACTIONS(825),
    [anon_sym_yield_BANG] = ACTIONS(829),
    [anon_sym_lazy] = ACTIONS(825),
    [anon_sym_assert] = ACTIONS(825),
    [anon_sym_upcast] = ACTIONS(825),
    [anon_sym_downcast] = ACTIONS(825),
    [anon_sym_for] = ACTIONS(73),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(79),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_match] = ACTIONS(83),
    [anon_sym_match_BANG] = ACTIONS(85),
    [anon_sym_function] = ACTIONS(87),
    [anon_sym_use] = ACTIONS(833),
    [anon_sym_use_BANG] = ACTIONS(835),
    [anon_sym_do_BANG] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(101),
    [aux_sym_char_token1] = ACTIONS(105),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(107),
    [anon_sym_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DQUOTE] = ACTIONS(111),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(115),
    [sym_bool] = ACTIONS(117),
    [sym_unit] = ACTIONS(1673),
    [anon_sym_LPAREN_PIPE] = ACTIONS(121),
    [sym_op_identifier] = ACTIONS(1675),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(837),
    [sym_xint] = ACTIONS(387),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(135),
  },
  [692] = {
    [sym_function_or_value_defn] = STATE(627),
    [sym__expression] = STATE(190),
    [sym_literal_expression] = STATE(1118),
    [sym_long_identifier_or_op] = STATE(1118),
    [sym_tuple_expression] = STATE(1118),
    [sym_brace_expression] = STATE(1118),
    [sym_anon_record_expression] = STATE(1118),
    [sym_prefixed_expression] = STATE(1118),
    [sym_typecast_expression] = STATE(1118),
    [sym_for_expression] = STATE(1118),
    [sym_while_expression] = STATE(1118),
    [sym__if_branch] = STATE(7163),
    [sym_if_expression] = STATE(1118),
    [sym_fun_expression] = STATE(1118),
    [sym_try_expression] = STATE(1118),
    [sym_match_expression] = STATE(1118),
    [sym_function_expression] = STATE(1118),
    [sym_mutate_expression] = STATE(1118),
    [sym_index_expression] = STATE(1118),
    [sym_typed_expression] = STATE(1118),
    [sym_declaration_expression] = STATE(1118),
    [sym_do_expression] = STATE(1118),
    [sym_list_expression] = STATE(1118),
    [sym_array_expression] = STATE(1118),
    [sym_begin_end_expression] = STATE(1118),
    [sym_paren_expression] = STATE(1118),
    [sym__high_prec_app] = STATE(1133),
    [sym__low_prec_app] = STATE(1133),
    [sym_application_expression] = STATE(1118),
    [sym_dot_expression] = STATE(1118),
    [sym_infix_expression] = STATE(1118),
    [sym_ce_expression] = STATE(1118),
    [sym_sequential_expression] = STATE(1118),
    [sym_char] = STATE(1080),
    [sym_format_string] = STATE(1090),
    [sym__string_literal] = STATE(1090),
    [sym_string] = STATE(1080),
    [sym_verbatim_string] = STATE(1080),
    [sym_bytearray] = STATE(1080),
    [sym_verbatim_bytearray] = STATE(1080),
    [sym_format_triple_quoted_string] = STATE(1096),
    [sym_triple_quoted_string] = STATE(1080),
    [sym_const] = STATE(1118),
    [sym_long_identifier] = STATE(1156),
    [sym_active_pattern] = STATE(1085),
    [sym__identifier_or_op] = STATE(1099),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(517),
    [sym_sbyte] = STATE(1080),
    [sym_byte] = STATE(1080),
    [sym_int16] = STATE(1080),
    [sym_uint16] = STATE(1080),
    [sym_int32] = STATE(1080),
    [sym_uint32] = STATE(1080),
    [sym_nativeint] = STATE(1080),
    [sym_unativeint] = STATE(1080),
    [sym_int64] = STATE(1080),
    [sym_uint64] = STATE(1080),
    [sym_ieee32] = STATE(1080),
    [sym_ieee64] = STATE(1080),
    [sym_bignum] = STATE(1080),
    [sym_decimal] = STATE(1080),
    [sym_float] = STATE(979),
    [sym_block_comment] = STATE(692),
    [sym_compiler_directive_decl] = STATE(692),
    [sym_fsi_directive_decl] = STATE(692),
    [sym_preproc_line] = STATE(692),
    [sym_preproc_if_in_expression] = STATE(1118),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(195),
    [anon_sym_return] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_null] = ACTIONS(207),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(209),
    [anon_sym_LBRACK_PIPE] = ACTIONS(211),
    [anon_sym_LBRACE] = ACTIONS(1687),
    [anon_sym_LT_AT] = ACTIONS(213),
    [anon_sym_LT_AT_AT] = ACTIONS(1689),
    [anon_sym_LBRACE_PIPE] = ACTIONS(217),
    [anon_sym_new] = ACTIONS(199),
    [anon_sym_return_BANG] = ACTIONS(219),
    [anon_sym_yield] = ACTIONS(199),
    [anon_sym_yield_BANG] = ACTIONS(219),
    [anon_sym_lazy] = ACTIONS(199),
    [anon_sym_assert] = ACTIONS(199),
    [anon_sym_upcast] = ACTIONS(199),
    [anon_sym_downcast] = ACTIONS(199),
    [anon_sym_for] = ACTIONS(223),
    [anon_sym_while] = ACTIONS(225),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(229),
    [anon_sym_match] = ACTIONS(231),
    [anon_sym_match_BANG] = ACTIONS(233),
    [anon_sym_function] = ACTIONS(235),
    [anon_sym_use] = ACTIONS(239),
    [anon_sym_use_BANG] = ACTIONS(241),
    [anon_sym_do_BANG] = ACTIONS(243),
    [anon_sym_begin] = ACTIONS(245),
    [aux_sym_char_token1] = ACTIONS(247),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(251),
    [anon_sym_AT_DQUOTE] = ACTIONS(253),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(255),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(257),
    [sym_bool] = ACTIONS(259),
    [sym_unit] = ACTIONS(1699),
    [anon_sym_LPAREN_PIPE] = ACTIONS(261),
    [sym_op_identifier] = ACTIONS(1701),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(265),
    [sym_xint] = ACTIONS(267),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(269),
  },
  [693] = {
    [sym_function_or_value_defn] = STATE(600),
    [sym__expression] = STATE(105),
    [sym_literal_expression] = STATE(867),
    [sym_long_identifier_or_op] = STATE(867),
    [sym_tuple_expression] = STATE(867),
    [sym_brace_expression] = STATE(867),
    [sym_anon_record_expression] = STATE(867),
    [sym_prefixed_expression] = STATE(867),
    [sym_typecast_expression] = STATE(867),
    [sym_for_expression] = STATE(867),
    [sym_while_expression] = STATE(867),
    [sym__if_branch] = STATE(6511),
    [sym_if_expression] = STATE(867),
    [sym_fun_expression] = STATE(867),
    [sym_try_expression] = STATE(867),
    [sym_match_expression] = STATE(867),
    [sym_function_expression] = STATE(867),
    [sym_mutate_expression] = STATE(867),
    [sym_index_expression] = STATE(867),
    [sym_typed_expression] = STATE(867),
    [sym_declaration_expression] = STATE(867),
    [sym_do_expression] = STATE(867),
    [sym_list_expression] = STATE(867),
    [sym_array_expression] = STATE(867),
    [sym_begin_end_expression] = STATE(867),
    [sym_paren_expression] = STATE(867),
    [sym__high_prec_app] = STATE(864),
    [sym__low_prec_app] = STATE(864),
    [sym_application_expression] = STATE(867),
    [sym_dot_expression] = STATE(867),
    [sym_infix_expression] = STATE(867),
    [sym_ce_expression] = STATE(867),
    [sym_sequential_expression] = STATE(867),
    [sym_char] = STATE(868),
    [sym_format_string] = STATE(869),
    [sym__string_literal] = STATE(869),
    [sym_string] = STATE(868),
    [sym_verbatim_string] = STATE(868),
    [sym_bytearray] = STATE(868),
    [sym_verbatim_bytearray] = STATE(868),
    [sym_format_triple_quoted_string] = STATE(870),
    [sym_triple_quoted_string] = STATE(868),
    [sym_const] = STATE(867),
    [sym_long_identifier] = STATE(872),
    [sym_active_pattern] = STATE(871),
    [sym__identifier_or_op] = STATE(873),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(656),
    [sym_sbyte] = STATE(868),
    [sym_byte] = STATE(868),
    [sym_int16] = STATE(868),
    [sym_uint16] = STATE(868),
    [sym_int32] = STATE(868),
    [sym_uint32] = STATE(868),
    [sym_nativeint] = STATE(868),
    [sym_unativeint] = STATE(868),
    [sym_int64] = STATE(868),
    [sym_uint64] = STATE(868),
    [sym_ieee32] = STATE(868),
    [sym_ieee64] = STATE(868),
    [sym_bignum] = STATE(868),
    [sym_decimal] = STATE(868),
    [sym_float] = STATE(1368),
    [sym_block_comment] = STATE(693),
    [sym_compiler_directive_decl] = STATE(693),
    [sym_fsi_directive_decl] = STATE(693),
    [sym_preproc_line] = STATE(693),
    [sym_preproc_if_in_expression] = STATE(867),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(29),
    [anon_sym_return] = ACTIONS(825),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_null] = ACTIONS(49),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACK_PIPE] = ACTIONS(57),
    [anon_sym_LBRACE] = ACTIONS(1663),
    [anon_sym_LT_AT] = ACTIONS(61),
    [anon_sym_LT_AT_AT] = ACTIONS(1665),
    [anon_sym_LBRACE_PIPE] = ACTIONS(67),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_return_BANG] = ACTIONS(829),
    [anon_sym_yield] = ACTIONS(825),
    [anon_sym_yield_BANG] = ACTIONS(829),
    [anon_sym_lazy] = ACTIONS(825),
    [anon_sym_assert] = ACTIONS(825),
    [anon_sym_upcast] = ACTIONS(825),
    [anon_sym_downcast] = ACTIONS(825),
    [anon_sym_for] = ACTIONS(73),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(79),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_match] = ACTIONS(83),
    [anon_sym_match_BANG] = ACTIONS(85),
    [anon_sym_function] = ACTIONS(87),
    [anon_sym_use] = ACTIONS(833),
    [anon_sym_use_BANG] = ACTIONS(835),
    [anon_sym_do_BANG] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(101),
    [aux_sym_char_token1] = ACTIONS(105),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(107),
    [anon_sym_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DQUOTE] = ACTIONS(111),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(115),
    [sym_bool] = ACTIONS(117),
    [sym_unit] = ACTIONS(1673),
    [anon_sym_LPAREN_PIPE] = ACTIONS(121),
    [sym_op_identifier] = ACTIONS(1675),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(837),
    [sym_xint] = ACTIONS(387),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(135),
  },
  [694] = {
    [sym_function_or_value_defn] = STATE(509),
    [sym__expression] = STATE(323),
    [sym_literal_expression] = STATE(2230),
    [sym_long_identifier_or_op] = STATE(2230),
    [sym_tuple_expression] = STATE(2230),
    [sym_brace_expression] = STATE(2230),
    [sym_anon_record_expression] = STATE(2230),
    [sym_prefixed_expression] = STATE(2230),
    [sym_typecast_expression] = STATE(2230),
    [sym_for_expression] = STATE(2230),
    [sym_while_expression] = STATE(2230),
    [sym__if_branch] = STATE(6659),
    [sym_if_expression] = STATE(2230),
    [sym_fun_expression] = STATE(2230),
    [sym_try_expression] = STATE(2230),
    [sym_match_expression] = STATE(2230),
    [sym_function_expression] = STATE(2230),
    [sym_mutate_expression] = STATE(2230),
    [sym_index_expression] = STATE(2230),
    [sym_typed_expression] = STATE(2230),
    [sym_declaration_expression] = STATE(2230),
    [sym_do_expression] = STATE(2230),
    [sym_list_expression] = STATE(2230),
    [sym_array_expression] = STATE(2230),
    [sym_begin_end_expression] = STATE(2230),
    [sym_paren_expression] = STATE(2230),
    [sym__high_prec_app] = STATE(2229),
    [sym__low_prec_app] = STATE(2229),
    [sym_application_expression] = STATE(2230),
    [sym_dot_expression] = STATE(2230),
    [sym_infix_expression] = STATE(2230),
    [sym_ce_expression] = STATE(2230),
    [sym_sequential_expression] = STATE(2230),
    [sym_char] = STATE(2100),
    [sym_format_string] = STATE(2106),
    [sym__string_literal] = STATE(2106),
    [sym_string] = STATE(2100),
    [sym_verbatim_string] = STATE(2100),
    [sym_bytearray] = STATE(2100),
    [sym_verbatim_bytearray] = STATE(2100),
    [sym_format_triple_quoted_string] = STATE(2107),
    [sym_triple_quoted_string] = STATE(2100),
    [sym_const] = STATE(2230),
    [sym_long_identifier] = STATE(2232),
    [sym_active_pattern] = STATE(2424),
    [sym__identifier_or_op] = STATE(2305),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(737),
    [sym_sbyte] = STATE(2100),
    [sym_byte] = STATE(2100),
    [sym_int16] = STATE(2100),
    [sym_uint16] = STATE(2100),
    [sym_int32] = STATE(2100),
    [sym_uint32] = STATE(2100),
    [sym_nativeint] = STATE(2100),
    [sym_unativeint] = STATE(2100),
    [sym_int64] = STATE(2100),
    [sym_uint64] = STATE(2100),
    [sym_ieee32] = STATE(2100),
    [sym_ieee64] = STATE(2100),
    [sym_bignum] = STATE(2100),
    [sym_decimal] = STATE(2100),
    [sym_float] = STATE(1487),
    [sym_block_comment] = STATE(694),
    [sym_compiler_directive_decl] = STATE(694),
    [sym_fsi_directive_decl] = STATE(694),
    [sym_preproc_line] = STATE(694),
    [sym_preproc_if_in_expression] = STATE(2230),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(877),
    [anon_sym_return] = ACTIONS(881),
    [anon_sym_do] = ACTIONS(1585),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(885),
    [anon_sym_null] = ACTIONS(889),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(891),
    [anon_sym_LBRACK_PIPE] = ACTIONS(893),
    [anon_sym_LBRACE] = ACTIONS(2048),
    [anon_sym_LT_AT] = ACTIONS(897),
    [anon_sym_LT_AT_AT] = ACTIONS(2050),
    [anon_sym_LBRACE_PIPE] = ACTIONS(903),
    [anon_sym_new] = ACTIONS(881),
    [anon_sym_return_BANG] = ACTIONS(905),
    [anon_sym_yield] = ACTIONS(881),
    [anon_sym_yield_BANG] = ACTIONS(905),
    [anon_sym_lazy] = ACTIONS(881),
    [anon_sym_assert] = ACTIONS(881),
    [anon_sym_upcast] = ACTIONS(881),
    [anon_sym_downcast] = ACTIONS(881),
    [anon_sym_for] = ACTIONS(909),
    [anon_sym_while] = ACTIONS(911),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(913),
    [anon_sym_try] = ACTIONS(915),
    [anon_sym_match] = ACTIONS(917),
    [anon_sym_match_BANG] = ACTIONS(919),
    [anon_sym_function] = ACTIONS(921),
    [anon_sym_use] = ACTIONS(929),
    [anon_sym_use_BANG] = ACTIONS(931),
    [anon_sym_do_BANG] = ACTIONS(933),
    [anon_sym_begin] = ACTIONS(937),
    [aux_sym_char_token1] = ACTIONS(941),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(943),
    [anon_sym_DQUOTE] = ACTIONS(945),
    [anon_sym_AT_DQUOTE] = ACTIONS(947),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(949),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(951),
    [sym_bool] = ACTIONS(953),
    [sym_unit] = ACTIONS(2052),
    [anon_sym_LPAREN_PIPE] = ACTIONS(957),
    [sym_op_identifier] = ACTIONS(2054),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(961),
    [sym_xint] = ACTIONS(963),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(965),
  },
  [695] = {
    [sym_function_or_value_defn] = STATE(600),
    [sym__expression] = STATE(200),
    [sym_literal_expression] = STATE(867),
    [sym_long_identifier_or_op] = STATE(867),
    [sym_tuple_expression] = STATE(867),
    [sym_brace_expression] = STATE(867),
    [sym_anon_record_expression] = STATE(867),
    [sym_prefixed_expression] = STATE(867),
    [sym_typecast_expression] = STATE(867),
    [sym_for_expression] = STATE(867),
    [sym_while_expression] = STATE(867),
    [sym__if_branch] = STATE(6511),
    [sym_if_expression] = STATE(867),
    [sym_fun_expression] = STATE(867),
    [sym_try_expression] = STATE(867),
    [sym_match_expression] = STATE(867),
    [sym_function_expression] = STATE(867),
    [sym_mutate_expression] = STATE(867),
    [sym_index_expression] = STATE(867),
    [sym_typed_expression] = STATE(867),
    [sym_declaration_expression] = STATE(867),
    [sym_do_expression] = STATE(867),
    [sym_list_expression] = STATE(867),
    [sym_array_expression] = STATE(867),
    [sym_begin_end_expression] = STATE(867),
    [sym_paren_expression] = STATE(867),
    [sym__high_prec_app] = STATE(864),
    [sym__low_prec_app] = STATE(864),
    [sym_application_expression] = STATE(867),
    [sym_dot_expression] = STATE(867),
    [sym_infix_expression] = STATE(867),
    [sym_ce_expression] = STATE(867),
    [sym_sequential_expression] = STATE(867),
    [sym_char] = STATE(868),
    [sym_format_string] = STATE(869),
    [sym__string_literal] = STATE(869),
    [sym_string] = STATE(868),
    [sym_verbatim_string] = STATE(868),
    [sym_bytearray] = STATE(868),
    [sym_verbatim_bytearray] = STATE(868),
    [sym_format_triple_quoted_string] = STATE(870),
    [sym_triple_quoted_string] = STATE(868),
    [sym_const] = STATE(867),
    [sym_long_identifier] = STATE(872),
    [sym_active_pattern] = STATE(871),
    [sym__identifier_or_op] = STATE(873),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(656),
    [sym_sbyte] = STATE(868),
    [sym_byte] = STATE(868),
    [sym_int16] = STATE(868),
    [sym_uint16] = STATE(868),
    [sym_int32] = STATE(868),
    [sym_uint32] = STATE(868),
    [sym_nativeint] = STATE(868),
    [sym_unativeint] = STATE(868),
    [sym_int64] = STATE(868),
    [sym_uint64] = STATE(868),
    [sym_ieee32] = STATE(868),
    [sym_ieee64] = STATE(868),
    [sym_bignum] = STATE(868),
    [sym_decimal] = STATE(868),
    [sym_float] = STATE(1368),
    [sym_block_comment] = STATE(695),
    [sym_compiler_directive_decl] = STATE(695),
    [sym_fsi_directive_decl] = STATE(695),
    [sym_preproc_line] = STATE(695),
    [sym_preproc_if_in_expression] = STATE(867),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(29),
    [anon_sym_return] = ACTIONS(825),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_null] = ACTIONS(49),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACK_PIPE] = ACTIONS(57),
    [anon_sym_LBRACE] = ACTIONS(1663),
    [anon_sym_LT_AT] = ACTIONS(61),
    [anon_sym_LT_AT_AT] = ACTIONS(1665),
    [anon_sym_LBRACE_PIPE] = ACTIONS(67),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_return_BANG] = ACTIONS(829),
    [anon_sym_yield] = ACTIONS(825),
    [anon_sym_yield_BANG] = ACTIONS(829),
    [anon_sym_lazy] = ACTIONS(825),
    [anon_sym_assert] = ACTIONS(825),
    [anon_sym_upcast] = ACTIONS(825),
    [anon_sym_downcast] = ACTIONS(825),
    [anon_sym_for] = ACTIONS(73),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(79),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_match] = ACTIONS(83),
    [anon_sym_match_BANG] = ACTIONS(85),
    [anon_sym_function] = ACTIONS(87),
    [anon_sym_use] = ACTIONS(833),
    [anon_sym_use_BANG] = ACTIONS(835),
    [anon_sym_do_BANG] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(101),
    [aux_sym_char_token1] = ACTIONS(105),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(107),
    [anon_sym_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DQUOTE] = ACTIONS(111),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(115),
    [sym_bool] = ACTIONS(117),
    [sym_unit] = ACTIONS(1673),
    [anon_sym_LPAREN_PIPE] = ACTIONS(121),
    [sym_op_identifier] = ACTIONS(1675),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(837),
    [sym_xint] = ACTIONS(387),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(135),
  },
  [696] = {
    [sym_function_or_value_defn] = STATE(705),
    [sym__expression] = STATE(7),
    [sym_literal_expression] = STATE(867),
    [sym_long_identifier_or_op] = STATE(867),
    [sym_tuple_expression] = STATE(867),
    [sym_brace_expression] = STATE(867),
    [sym_anon_record_expression] = STATE(867),
    [sym_prefixed_expression] = STATE(867),
    [sym_typecast_expression] = STATE(867),
    [sym_for_expression] = STATE(867),
    [sym_while_expression] = STATE(867),
    [sym__if_branch] = STATE(6511),
    [sym_if_expression] = STATE(867),
    [sym_fun_expression] = STATE(867),
    [sym_try_expression] = STATE(867),
    [sym_match_expression] = STATE(867),
    [sym_function_expression] = STATE(867),
    [sym_mutate_expression] = STATE(867),
    [sym_index_expression] = STATE(867),
    [sym_typed_expression] = STATE(867),
    [sym_declaration_expression] = STATE(867),
    [sym_do_expression] = STATE(867),
    [sym_list_expression] = STATE(867),
    [sym_array_expression] = STATE(867),
    [sym_begin_end_expression] = STATE(867),
    [sym_paren_expression] = STATE(867),
    [sym__high_prec_app] = STATE(864),
    [sym__low_prec_app] = STATE(864),
    [sym_application_expression] = STATE(867),
    [sym_dot_expression] = STATE(867),
    [sym_infix_expression] = STATE(867),
    [sym_ce_expression] = STATE(867),
    [sym_sequential_expression] = STATE(867),
    [sym_char] = STATE(868),
    [sym_format_string] = STATE(869),
    [sym__string_literal] = STATE(869),
    [sym_string] = STATE(868),
    [sym_verbatim_string] = STATE(868),
    [sym_bytearray] = STATE(868),
    [sym_verbatim_bytearray] = STATE(868),
    [sym_format_triple_quoted_string] = STATE(870),
    [sym_triple_quoted_string] = STATE(868),
    [sym_const] = STATE(867),
    [sym_long_identifier] = STATE(872),
    [sym_active_pattern] = STATE(871),
    [sym__identifier_or_op] = STATE(873),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(658),
    [sym_sbyte] = STATE(868),
    [sym_byte] = STATE(868),
    [sym_int16] = STATE(868),
    [sym_uint16] = STATE(868),
    [sym_int32] = STATE(868),
    [sym_uint32] = STATE(868),
    [sym_nativeint] = STATE(868),
    [sym_unativeint] = STATE(868),
    [sym_int64] = STATE(868),
    [sym_uint64] = STATE(868),
    [sym_ieee32] = STATE(868),
    [sym_ieee64] = STATE(868),
    [sym_bignum] = STATE(868),
    [sym_decimal] = STATE(868),
    [sym_float] = STATE(860),
    [sym_block_comment] = STATE(696),
    [sym_compiler_directive_decl] = STATE(696),
    [sym_fsi_directive_decl] = STATE(696),
    [sym_preproc_line] = STATE(696),
    [sym_preproc_if_in_expression] = STATE(867),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(29),
    [anon_sym_return] = ACTIONS(37),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_null] = ACTIONS(49),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACK_PIPE] = ACTIONS(57),
    [anon_sym_LBRACE] = ACTIONS(1663),
    [anon_sym_LT_AT] = ACTIONS(61),
    [anon_sym_LT_AT_AT] = ACTIONS(1665),
    [anon_sym_LBRACE_PIPE] = ACTIONS(67),
    [anon_sym_new] = ACTIONS(37),
    [anon_sym_return_BANG] = ACTIONS(69),
    [anon_sym_yield] = ACTIONS(37),
    [anon_sym_yield_BANG] = ACTIONS(69),
    [anon_sym_lazy] = ACTIONS(37),
    [anon_sym_assert] = ACTIONS(37),
    [anon_sym_upcast] = ACTIONS(37),
    [anon_sym_downcast] = ACTIONS(37),
    [anon_sym_for] = ACTIONS(73),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(79),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_match] = ACTIONS(83),
    [anon_sym_match_BANG] = ACTIONS(85),
    [anon_sym_function] = ACTIONS(87),
    [anon_sym_use] = ACTIONS(95),
    [anon_sym_use_BANG] = ACTIONS(97),
    [anon_sym_do_BANG] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(101),
    [aux_sym_char_token1] = ACTIONS(105),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(107),
    [anon_sym_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DQUOTE] = ACTIONS(111),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(115),
    [sym_bool] = ACTIONS(117),
    [sym_unit] = ACTIONS(1673),
    [anon_sym_LPAREN_PIPE] = ACTIONS(121),
    [sym_op_identifier] = ACTIONS(1675),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(129),
    [sym_xint] = ACTIONS(131),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(135),
  },
  [697] = {
    [sym_function_or_value_defn] = STATE(663),
    [sym__expression] = STATE(67),
    [sym_literal_expression] = STATE(1118),
    [sym_long_identifier_or_op] = STATE(1118),
    [sym_tuple_expression] = STATE(1118),
    [sym_brace_expression] = STATE(1118),
    [sym_anon_record_expression] = STATE(1118),
    [sym_prefixed_expression] = STATE(1118),
    [sym_typecast_expression] = STATE(1118),
    [sym_for_expression] = STATE(1118),
    [sym_while_expression] = STATE(1118),
    [sym__if_branch] = STATE(7163),
    [sym_if_expression] = STATE(1118),
    [sym_fun_expression] = STATE(1118),
    [sym_try_expression] = STATE(1118),
    [sym_match_expression] = STATE(1118),
    [sym_function_expression] = STATE(1118),
    [sym_mutate_expression] = STATE(1118),
    [sym_index_expression] = STATE(1118),
    [sym_typed_expression] = STATE(1118),
    [sym_declaration_expression] = STATE(1118),
    [sym_do_expression] = STATE(1118),
    [sym_list_expression] = STATE(1118),
    [sym_array_expression] = STATE(1118),
    [sym_begin_end_expression] = STATE(1118),
    [sym_paren_expression] = STATE(1118),
    [sym__high_prec_app] = STATE(1133),
    [sym__low_prec_app] = STATE(1133),
    [sym_application_expression] = STATE(1118),
    [sym_dot_expression] = STATE(1118),
    [sym_infix_expression] = STATE(1118),
    [sym_ce_expression] = STATE(1118),
    [sym_sequential_expression] = STATE(1118),
    [sym_char] = STATE(1080),
    [sym_format_string] = STATE(1090),
    [sym__string_literal] = STATE(1090),
    [sym_string] = STATE(1080),
    [sym_verbatim_string] = STATE(1080),
    [sym_bytearray] = STATE(1080),
    [sym_verbatim_bytearray] = STATE(1080),
    [sym_format_triple_quoted_string] = STATE(1096),
    [sym_triple_quoted_string] = STATE(1080),
    [sym_const] = STATE(1118),
    [sym_long_identifier] = STATE(1156),
    [sym_active_pattern] = STATE(1085),
    [sym__identifier_or_op] = STATE(1099),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(548),
    [sym_sbyte] = STATE(1080),
    [sym_byte] = STATE(1080),
    [sym_int16] = STATE(1080),
    [sym_uint16] = STATE(1080),
    [sym_int32] = STATE(1080),
    [sym_uint32] = STATE(1080),
    [sym_nativeint] = STATE(1080),
    [sym_unativeint] = STATE(1080),
    [sym_int64] = STATE(1080),
    [sym_uint64] = STATE(1080),
    [sym_ieee32] = STATE(1080),
    [sym_ieee64] = STATE(1080),
    [sym_bignum] = STATE(1080),
    [sym_decimal] = STATE(1080),
    [sym_float] = STATE(979),
    [sym_block_comment] = STATE(697),
    [sym_compiler_directive_decl] = STATE(697),
    [sym_fsi_directive_decl] = STATE(697),
    [sym_preproc_line] = STATE(697),
    [sym_preproc_if_in_expression] = STATE(1118),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(195),
    [anon_sym_return] = ACTIONS(481),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_null] = ACTIONS(207),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(209),
    [anon_sym_LBRACK_PIPE] = ACTIONS(211),
    [anon_sym_LBRACE] = ACTIONS(1687),
    [anon_sym_LT_AT] = ACTIONS(213),
    [anon_sym_LT_AT_AT] = ACTIONS(1689),
    [anon_sym_LBRACE_PIPE] = ACTIONS(217),
    [anon_sym_new] = ACTIONS(481),
    [anon_sym_return_BANG] = ACTIONS(487),
    [anon_sym_yield] = ACTIONS(481),
    [anon_sym_yield_BANG] = ACTIONS(487),
    [anon_sym_lazy] = ACTIONS(481),
    [anon_sym_assert] = ACTIONS(481),
    [anon_sym_upcast] = ACTIONS(481),
    [anon_sym_downcast] = ACTIONS(481),
    [anon_sym_for] = ACTIONS(489),
    [anon_sym_while] = ACTIONS(225),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(229),
    [anon_sym_match] = ACTIONS(231),
    [anon_sym_match_BANG] = ACTIONS(233),
    [anon_sym_function] = ACTIONS(235),
    [anon_sym_use] = ACTIONS(493),
    [anon_sym_use_BANG] = ACTIONS(495),
    [anon_sym_do_BANG] = ACTIONS(243),
    [anon_sym_begin] = ACTIONS(245),
    [aux_sym_char_token1] = ACTIONS(247),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(251),
    [anon_sym_AT_DQUOTE] = ACTIONS(253),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(255),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(257),
    [sym_bool] = ACTIONS(259),
    [sym_unit] = ACTIONS(1699),
    [anon_sym_LPAREN_PIPE] = ACTIONS(261),
    [sym_op_identifier] = ACTIONS(1701),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(499),
    [sym_xint] = ACTIONS(267),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(269),
  },
  [698] = {
    [sym_function_or_value_defn] = STATE(733),
    [sym__expression] = STATE(279),
    [sym_literal_expression] = STATE(2008),
    [sym_long_identifier_or_op] = STATE(2008),
    [sym_tuple_expression] = STATE(2008),
    [sym_brace_expression] = STATE(2008),
    [sym_anon_record_expression] = STATE(2008),
    [sym_prefixed_expression] = STATE(2008),
    [sym_typecast_expression] = STATE(2008),
    [sym_for_expression] = STATE(2008),
    [sym_while_expression] = STATE(2008),
    [sym__if_branch] = STATE(6754),
    [sym_if_expression] = STATE(2008),
    [sym_fun_expression] = STATE(2008),
    [sym_try_expression] = STATE(2008),
    [sym_match_expression] = STATE(2008),
    [sym_function_expression] = STATE(2008),
    [sym_mutate_expression] = STATE(2008),
    [sym_index_expression] = STATE(2008),
    [sym_typed_expression] = STATE(2008),
    [sym_declaration_expression] = STATE(2008),
    [sym_do_expression] = STATE(2008),
    [sym_list_expression] = STATE(2008),
    [sym_array_expression] = STATE(2008),
    [sym_begin_end_expression] = STATE(2008),
    [sym_paren_expression] = STATE(2008),
    [sym__high_prec_app] = STATE(2007),
    [sym__low_prec_app] = STATE(2007),
    [sym_application_expression] = STATE(2008),
    [sym_dot_expression] = STATE(2008),
    [sym_infix_expression] = STATE(2008),
    [sym_ce_expression] = STATE(2008),
    [sym_sequential_expression] = STATE(2008),
    [sym_char] = STATE(1859),
    [sym_format_string] = STATE(1861),
    [sym__string_literal] = STATE(1861),
    [sym_string] = STATE(1859),
    [sym_verbatim_string] = STATE(1859),
    [sym_bytearray] = STATE(1859),
    [sym_verbatim_bytearray] = STATE(1859),
    [sym_format_triple_quoted_string] = STATE(1862),
    [sym_triple_quoted_string] = STATE(1859),
    [sym_const] = STATE(2008),
    [sym_long_identifier] = STATE(1701),
    [sym_active_pattern] = STATE(1702),
    [sym__identifier_or_op] = STATE(1724),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(706),
    [sym_sbyte] = STATE(1859),
    [sym_byte] = STATE(1859),
    [sym_int16] = STATE(1859),
    [sym_uint16] = STATE(1859),
    [sym_int32] = STATE(1859),
    [sym_uint32] = STATE(1859),
    [sym_nativeint] = STATE(1859),
    [sym_unativeint] = STATE(1859),
    [sym_int64] = STATE(1859),
    [sym_uint64] = STATE(1859),
    [sym_ieee32] = STATE(1859),
    [sym_ieee64] = STATE(1859),
    [sym_bignum] = STATE(1859),
    [sym_decimal] = STATE(1859),
    [sym_float] = STATE(1447),
    [sym_block_comment] = STATE(698),
    [sym_compiler_directive_decl] = STATE(698),
    [sym_fsi_directive_decl] = STATE(698),
    [sym_preproc_line] = STATE(698),
    [sym_preproc_if_in_expression] = STATE(2008),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(503),
    [anon_sym_return] = ACTIONS(971),
    [anon_sym_do] = ACTIONS(599),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(511),
    [anon_sym_null] = ACTIONS(515),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(517),
    [anon_sym_LBRACK_PIPE] = ACTIONS(519),
    [anon_sym_LBRACE] = ACTIONS(2060),
    [anon_sym_LT_AT] = ACTIONS(523),
    [anon_sym_LT_AT_AT] = ACTIONS(2062),
    [anon_sym_LBRACE_PIPE] = ACTIONS(529),
    [anon_sym_new] = ACTIONS(971),
    [anon_sym_return_BANG] = ACTIONS(975),
    [anon_sym_yield] = ACTIONS(971),
    [anon_sym_yield_BANG] = ACTIONS(975),
    [anon_sym_lazy] = ACTIONS(971),
    [anon_sym_assert] = ACTIONS(971),
    [anon_sym_upcast] = ACTIONS(971),
    [anon_sym_downcast] = ACTIONS(971),
    [anon_sym_for] = ACTIONS(979),
    [anon_sym_while] = ACTIONS(537),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(539),
    [anon_sym_try] = ACTIONS(543),
    [anon_sym_match] = ACTIONS(545),
    [anon_sym_match_BANG] = ACTIONS(547),
    [anon_sym_function] = ACTIONS(549),
    [anon_sym_use] = ACTIONS(983),
    [anon_sym_use_BANG] = ACTIONS(985),
    [anon_sym_do_BANG] = ACTIONS(561),
    [anon_sym_begin] = ACTIONS(565),
    [aux_sym_char_token1] = ACTIONS(569),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(571),
    [anon_sym_DQUOTE] = ACTIONS(573),
    [anon_sym_AT_DQUOTE] = ACTIONS(575),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(577),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(579),
    [sym_bool] = ACTIONS(581),
    [sym_unit] = ACTIONS(2064),
    [anon_sym_LPAREN_PIPE] = ACTIONS(585),
    [sym_op_identifier] = ACTIONS(2066),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(591),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(593),
  },
  [699] = {
    [sym_function_or_value_defn] = STATE(600),
    [sym__expression] = STATE(306),
    [sym_literal_expression] = STATE(867),
    [sym_long_identifier_or_op] = STATE(867),
    [sym_tuple_expression] = STATE(867),
    [sym_brace_expression] = STATE(867),
    [sym_anon_record_expression] = STATE(867),
    [sym_prefixed_expression] = STATE(867),
    [sym_typecast_expression] = STATE(867),
    [sym_for_expression] = STATE(867),
    [sym_while_expression] = STATE(867),
    [sym__if_branch] = STATE(6511),
    [sym_if_expression] = STATE(867),
    [sym_fun_expression] = STATE(867),
    [sym_try_expression] = STATE(867),
    [sym_match_expression] = STATE(867),
    [sym_function_expression] = STATE(867),
    [sym_mutate_expression] = STATE(867),
    [sym_index_expression] = STATE(867),
    [sym_typed_expression] = STATE(867),
    [sym_declaration_expression] = STATE(867),
    [sym_do_expression] = STATE(867),
    [sym_list_expression] = STATE(867),
    [sym_array_expression] = STATE(867),
    [sym_begin_end_expression] = STATE(867),
    [sym_paren_expression] = STATE(867),
    [sym__high_prec_app] = STATE(864),
    [sym__low_prec_app] = STATE(864),
    [sym_application_expression] = STATE(867),
    [sym_dot_expression] = STATE(867),
    [sym_infix_expression] = STATE(867),
    [sym_ce_expression] = STATE(867),
    [sym_sequential_expression] = STATE(867),
    [sym_char] = STATE(868),
    [sym_format_string] = STATE(869),
    [sym__string_literal] = STATE(869),
    [sym_string] = STATE(868),
    [sym_verbatim_string] = STATE(868),
    [sym_bytearray] = STATE(868),
    [sym_verbatim_bytearray] = STATE(868),
    [sym_format_triple_quoted_string] = STATE(870),
    [sym_triple_quoted_string] = STATE(868),
    [sym_const] = STATE(867),
    [sym_long_identifier] = STATE(872),
    [sym_active_pattern] = STATE(871),
    [sym__identifier_or_op] = STATE(873),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(656),
    [sym_sbyte] = STATE(868),
    [sym_byte] = STATE(868),
    [sym_int16] = STATE(868),
    [sym_uint16] = STATE(868),
    [sym_int32] = STATE(868),
    [sym_uint32] = STATE(868),
    [sym_nativeint] = STATE(868),
    [sym_unativeint] = STATE(868),
    [sym_int64] = STATE(868),
    [sym_uint64] = STATE(868),
    [sym_ieee32] = STATE(868),
    [sym_ieee64] = STATE(868),
    [sym_bignum] = STATE(868),
    [sym_decimal] = STATE(868),
    [sym_float] = STATE(1368),
    [sym_block_comment] = STATE(699),
    [sym_compiler_directive_decl] = STATE(699),
    [sym_fsi_directive_decl] = STATE(699),
    [sym_preproc_line] = STATE(699),
    [sym_preproc_if_in_expression] = STATE(867),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(29),
    [anon_sym_return] = ACTIONS(825),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_null] = ACTIONS(49),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACK_PIPE] = ACTIONS(57),
    [anon_sym_LBRACE] = ACTIONS(1663),
    [anon_sym_LT_AT] = ACTIONS(61),
    [anon_sym_LT_AT_AT] = ACTIONS(1665),
    [anon_sym_LBRACE_PIPE] = ACTIONS(67),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_return_BANG] = ACTIONS(829),
    [anon_sym_yield] = ACTIONS(825),
    [anon_sym_yield_BANG] = ACTIONS(829),
    [anon_sym_lazy] = ACTIONS(825),
    [anon_sym_assert] = ACTIONS(825),
    [anon_sym_upcast] = ACTIONS(825),
    [anon_sym_downcast] = ACTIONS(825),
    [anon_sym_for] = ACTIONS(73),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(79),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_match] = ACTIONS(83),
    [anon_sym_match_BANG] = ACTIONS(85),
    [anon_sym_function] = ACTIONS(87),
    [anon_sym_use] = ACTIONS(833),
    [anon_sym_use_BANG] = ACTIONS(835),
    [anon_sym_do_BANG] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(101),
    [aux_sym_char_token1] = ACTIONS(105),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(107),
    [anon_sym_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DQUOTE] = ACTIONS(111),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(115),
    [sym_bool] = ACTIONS(117),
    [sym_unit] = ACTIONS(1673),
    [anon_sym_LPAREN_PIPE] = ACTIONS(121),
    [sym_op_identifier] = ACTIONS(1675),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(837),
    [sym_xint] = ACTIONS(387),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(135),
  },
  [700] = {
    [sym_function_or_value_defn] = STATE(627),
    [sym__expression] = STATE(333),
    [sym_literal_expression] = STATE(1118),
    [sym_long_identifier_or_op] = STATE(1118),
    [sym_tuple_expression] = STATE(1118),
    [sym_brace_expression] = STATE(1118),
    [sym_anon_record_expression] = STATE(1118),
    [sym_prefixed_expression] = STATE(1118),
    [sym_typecast_expression] = STATE(1118),
    [sym_for_expression] = STATE(1118),
    [sym_while_expression] = STATE(1118),
    [sym__if_branch] = STATE(7163),
    [sym_if_expression] = STATE(1118),
    [sym_fun_expression] = STATE(1118),
    [sym_try_expression] = STATE(1118),
    [sym_match_expression] = STATE(1118),
    [sym_function_expression] = STATE(1118),
    [sym_mutate_expression] = STATE(1118),
    [sym_index_expression] = STATE(1118),
    [sym_typed_expression] = STATE(1118),
    [sym_declaration_expression] = STATE(1118),
    [sym_do_expression] = STATE(1118),
    [sym_list_expression] = STATE(1118),
    [sym_array_expression] = STATE(1118),
    [sym_begin_end_expression] = STATE(1118),
    [sym_paren_expression] = STATE(1118),
    [sym__high_prec_app] = STATE(1133),
    [sym__low_prec_app] = STATE(1133),
    [sym_application_expression] = STATE(1118),
    [sym_dot_expression] = STATE(1118),
    [sym_infix_expression] = STATE(1118),
    [sym_ce_expression] = STATE(1118),
    [sym_sequential_expression] = STATE(1118),
    [sym_char] = STATE(1080),
    [sym_format_string] = STATE(1090),
    [sym__string_literal] = STATE(1090),
    [sym_string] = STATE(1080),
    [sym_verbatim_string] = STATE(1080),
    [sym_bytearray] = STATE(1080),
    [sym_verbatim_bytearray] = STATE(1080),
    [sym_format_triple_quoted_string] = STATE(1096),
    [sym_triple_quoted_string] = STATE(1080),
    [sym_const] = STATE(1118),
    [sym_long_identifier] = STATE(1156),
    [sym_active_pattern] = STATE(1085),
    [sym__identifier_or_op] = STATE(1099),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(517),
    [sym_sbyte] = STATE(1080),
    [sym_byte] = STATE(1080),
    [sym_int16] = STATE(1080),
    [sym_uint16] = STATE(1080),
    [sym_int32] = STATE(1080),
    [sym_uint32] = STATE(1080),
    [sym_nativeint] = STATE(1080),
    [sym_unativeint] = STATE(1080),
    [sym_int64] = STATE(1080),
    [sym_uint64] = STATE(1080),
    [sym_ieee32] = STATE(1080),
    [sym_ieee64] = STATE(1080),
    [sym_bignum] = STATE(1080),
    [sym_decimal] = STATE(1080),
    [sym_float] = STATE(979),
    [sym_block_comment] = STATE(700),
    [sym_compiler_directive_decl] = STATE(700),
    [sym_fsi_directive_decl] = STATE(700),
    [sym_preproc_line] = STATE(700),
    [sym_preproc_if_in_expression] = STATE(1118),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(195),
    [anon_sym_return] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_null] = ACTIONS(207),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(209),
    [anon_sym_LBRACK_PIPE] = ACTIONS(211),
    [anon_sym_LBRACE] = ACTIONS(1687),
    [anon_sym_LT_AT] = ACTIONS(213),
    [anon_sym_LT_AT_AT] = ACTIONS(1689),
    [anon_sym_LBRACE_PIPE] = ACTIONS(217),
    [anon_sym_new] = ACTIONS(199),
    [anon_sym_return_BANG] = ACTIONS(219),
    [anon_sym_yield] = ACTIONS(199),
    [anon_sym_yield_BANG] = ACTIONS(219),
    [anon_sym_lazy] = ACTIONS(199),
    [anon_sym_assert] = ACTIONS(199),
    [anon_sym_upcast] = ACTIONS(199),
    [anon_sym_downcast] = ACTIONS(199),
    [anon_sym_for] = ACTIONS(223),
    [anon_sym_while] = ACTIONS(225),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(229),
    [anon_sym_match] = ACTIONS(231),
    [anon_sym_match_BANG] = ACTIONS(233),
    [anon_sym_function] = ACTIONS(235),
    [anon_sym_use] = ACTIONS(239),
    [anon_sym_use_BANG] = ACTIONS(241),
    [anon_sym_do_BANG] = ACTIONS(243),
    [anon_sym_begin] = ACTIONS(245),
    [aux_sym_char_token1] = ACTIONS(247),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(251),
    [anon_sym_AT_DQUOTE] = ACTIONS(253),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(255),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(257),
    [sym_bool] = ACTIONS(259),
    [sym_unit] = ACTIONS(1699),
    [anon_sym_LPAREN_PIPE] = ACTIONS(261),
    [sym_op_identifier] = ACTIONS(1701),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(265),
    [sym_xint] = ACTIONS(267),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(269),
  },
  [701] = {
    [sym_function_or_value_defn] = STATE(627),
    [sym__expression] = STATE(331),
    [sym_literal_expression] = STATE(1118),
    [sym_long_identifier_or_op] = STATE(1118),
    [sym_tuple_expression] = STATE(1118),
    [sym_brace_expression] = STATE(1118),
    [sym_anon_record_expression] = STATE(1118),
    [sym_prefixed_expression] = STATE(1118),
    [sym_typecast_expression] = STATE(1118),
    [sym_for_expression] = STATE(1118),
    [sym_while_expression] = STATE(1118),
    [sym__if_branch] = STATE(7163),
    [sym_if_expression] = STATE(1118),
    [sym_fun_expression] = STATE(1118),
    [sym_try_expression] = STATE(1118),
    [sym_match_expression] = STATE(1118),
    [sym_function_expression] = STATE(1118),
    [sym_mutate_expression] = STATE(1118),
    [sym_index_expression] = STATE(1118),
    [sym_typed_expression] = STATE(1118),
    [sym_declaration_expression] = STATE(1118),
    [sym_do_expression] = STATE(1118),
    [sym_list_expression] = STATE(1118),
    [sym_array_expression] = STATE(1118),
    [sym_begin_end_expression] = STATE(1118),
    [sym_paren_expression] = STATE(1118),
    [sym__high_prec_app] = STATE(1133),
    [sym__low_prec_app] = STATE(1133),
    [sym_application_expression] = STATE(1118),
    [sym_dot_expression] = STATE(1118),
    [sym_infix_expression] = STATE(1118),
    [sym_ce_expression] = STATE(1118),
    [sym_sequential_expression] = STATE(1118),
    [sym_char] = STATE(1080),
    [sym_format_string] = STATE(1090),
    [sym__string_literal] = STATE(1090),
    [sym_string] = STATE(1080),
    [sym_verbatim_string] = STATE(1080),
    [sym_bytearray] = STATE(1080),
    [sym_verbatim_bytearray] = STATE(1080),
    [sym_format_triple_quoted_string] = STATE(1096),
    [sym_triple_quoted_string] = STATE(1080),
    [sym_const] = STATE(1118),
    [sym_long_identifier] = STATE(1156),
    [sym_active_pattern] = STATE(1085),
    [sym__identifier_or_op] = STATE(1099),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(517),
    [sym_sbyte] = STATE(1080),
    [sym_byte] = STATE(1080),
    [sym_int16] = STATE(1080),
    [sym_uint16] = STATE(1080),
    [sym_int32] = STATE(1080),
    [sym_uint32] = STATE(1080),
    [sym_nativeint] = STATE(1080),
    [sym_unativeint] = STATE(1080),
    [sym_int64] = STATE(1080),
    [sym_uint64] = STATE(1080),
    [sym_ieee32] = STATE(1080),
    [sym_ieee64] = STATE(1080),
    [sym_bignum] = STATE(1080),
    [sym_decimal] = STATE(1080),
    [sym_float] = STATE(979),
    [sym_block_comment] = STATE(701),
    [sym_compiler_directive_decl] = STATE(701),
    [sym_fsi_directive_decl] = STATE(701),
    [sym_preproc_line] = STATE(701),
    [sym_preproc_if_in_expression] = STATE(1118),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(195),
    [anon_sym_return] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_null] = ACTIONS(207),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(209),
    [anon_sym_LBRACK_PIPE] = ACTIONS(211),
    [anon_sym_LBRACE] = ACTIONS(1687),
    [anon_sym_LT_AT] = ACTIONS(213),
    [anon_sym_LT_AT_AT] = ACTIONS(1689),
    [anon_sym_LBRACE_PIPE] = ACTIONS(217),
    [anon_sym_new] = ACTIONS(199),
    [anon_sym_return_BANG] = ACTIONS(219),
    [anon_sym_yield] = ACTIONS(199),
    [anon_sym_yield_BANG] = ACTIONS(219),
    [anon_sym_lazy] = ACTIONS(199),
    [anon_sym_assert] = ACTIONS(199),
    [anon_sym_upcast] = ACTIONS(199),
    [anon_sym_downcast] = ACTIONS(199),
    [anon_sym_for] = ACTIONS(223),
    [anon_sym_while] = ACTIONS(225),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(229),
    [anon_sym_match] = ACTIONS(231),
    [anon_sym_match_BANG] = ACTIONS(233),
    [anon_sym_function] = ACTIONS(235),
    [anon_sym_use] = ACTIONS(239),
    [anon_sym_use_BANG] = ACTIONS(241),
    [anon_sym_do_BANG] = ACTIONS(243),
    [anon_sym_begin] = ACTIONS(245),
    [aux_sym_char_token1] = ACTIONS(247),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(251),
    [anon_sym_AT_DQUOTE] = ACTIONS(253),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(255),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(257),
    [sym_bool] = ACTIONS(259),
    [sym_unit] = ACTIONS(1699),
    [anon_sym_LPAREN_PIPE] = ACTIONS(261),
    [sym_op_identifier] = ACTIONS(1701),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(265),
    [sym_xint] = ACTIONS(267),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(269),
  },
  [702] = {
    [sym_function_or_value_defn] = STATE(627),
    [sym__expression] = STATE(83),
    [sym_literal_expression] = STATE(1118),
    [sym_long_identifier_or_op] = STATE(1118),
    [sym_tuple_expression] = STATE(1118),
    [sym_brace_expression] = STATE(1118),
    [sym_anon_record_expression] = STATE(1118),
    [sym_prefixed_expression] = STATE(1118),
    [sym_typecast_expression] = STATE(1118),
    [sym_for_expression] = STATE(1118),
    [sym_while_expression] = STATE(1118),
    [sym__if_branch] = STATE(7163),
    [sym_if_expression] = STATE(1118),
    [sym_fun_expression] = STATE(1118),
    [sym_try_expression] = STATE(1118),
    [sym_match_expression] = STATE(1118),
    [sym_function_expression] = STATE(1118),
    [sym_mutate_expression] = STATE(1118),
    [sym_index_expression] = STATE(1118),
    [sym_typed_expression] = STATE(1118),
    [sym_declaration_expression] = STATE(1118),
    [sym_do_expression] = STATE(1118),
    [sym_list_expression] = STATE(1118),
    [sym_array_expression] = STATE(1118),
    [sym_begin_end_expression] = STATE(1118),
    [sym_paren_expression] = STATE(1118),
    [sym__high_prec_app] = STATE(1133),
    [sym__low_prec_app] = STATE(1133),
    [sym_application_expression] = STATE(1118),
    [sym_dot_expression] = STATE(1118),
    [sym_infix_expression] = STATE(1118),
    [sym_ce_expression] = STATE(1118),
    [sym_sequential_expression] = STATE(1118),
    [sym_char] = STATE(1080),
    [sym_format_string] = STATE(1090),
    [sym__string_literal] = STATE(1090),
    [sym_string] = STATE(1080),
    [sym_verbatim_string] = STATE(1080),
    [sym_bytearray] = STATE(1080),
    [sym_verbatim_bytearray] = STATE(1080),
    [sym_format_triple_quoted_string] = STATE(1096),
    [sym_triple_quoted_string] = STATE(1080),
    [sym_const] = STATE(1118),
    [sym_long_identifier] = STATE(1156),
    [sym_active_pattern] = STATE(1085),
    [sym__identifier_or_op] = STATE(1099),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(517),
    [sym_sbyte] = STATE(1080),
    [sym_byte] = STATE(1080),
    [sym_int16] = STATE(1080),
    [sym_uint16] = STATE(1080),
    [sym_int32] = STATE(1080),
    [sym_uint32] = STATE(1080),
    [sym_nativeint] = STATE(1080),
    [sym_unativeint] = STATE(1080),
    [sym_int64] = STATE(1080),
    [sym_uint64] = STATE(1080),
    [sym_ieee32] = STATE(1080),
    [sym_ieee64] = STATE(1080),
    [sym_bignum] = STATE(1080),
    [sym_decimal] = STATE(1080),
    [sym_float] = STATE(979),
    [sym_block_comment] = STATE(702),
    [sym_compiler_directive_decl] = STATE(702),
    [sym_fsi_directive_decl] = STATE(702),
    [sym_preproc_line] = STATE(702),
    [sym_preproc_if_in_expression] = STATE(1118),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(195),
    [anon_sym_return] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_null] = ACTIONS(207),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(209),
    [anon_sym_LBRACK_PIPE] = ACTIONS(211),
    [anon_sym_LBRACE] = ACTIONS(1687),
    [anon_sym_LT_AT] = ACTIONS(213),
    [anon_sym_LT_AT_AT] = ACTIONS(1689),
    [anon_sym_LBRACE_PIPE] = ACTIONS(217),
    [anon_sym_new] = ACTIONS(199),
    [anon_sym_return_BANG] = ACTIONS(219),
    [anon_sym_yield] = ACTIONS(199),
    [anon_sym_yield_BANG] = ACTIONS(219),
    [anon_sym_lazy] = ACTIONS(199),
    [anon_sym_assert] = ACTIONS(199),
    [anon_sym_upcast] = ACTIONS(199),
    [anon_sym_downcast] = ACTIONS(199),
    [anon_sym_for] = ACTIONS(223),
    [anon_sym_while] = ACTIONS(225),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(229),
    [anon_sym_match] = ACTIONS(231),
    [anon_sym_match_BANG] = ACTIONS(233),
    [anon_sym_function] = ACTIONS(235),
    [anon_sym_use] = ACTIONS(239),
    [anon_sym_use_BANG] = ACTIONS(241),
    [anon_sym_do_BANG] = ACTIONS(243),
    [anon_sym_begin] = ACTIONS(245),
    [aux_sym_char_token1] = ACTIONS(247),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(251),
    [anon_sym_AT_DQUOTE] = ACTIONS(253),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(255),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(257),
    [sym_bool] = ACTIONS(259),
    [sym_unit] = ACTIONS(1699),
    [anon_sym_LPAREN_PIPE] = ACTIONS(261),
    [sym_op_identifier] = ACTIONS(1701),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(265),
    [sym_xint] = ACTIONS(267),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(269),
  },
  [703] = {
    [sym_function_or_value_defn] = STATE(703),
    [sym__expression] = STATE(107),
    [sym_literal_expression] = STATE(1797),
    [sym_long_identifier_or_op] = STATE(1797),
    [sym_tuple_expression] = STATE(1797),
    [sym_brace_expression] = STATE(1797),
    [sym_anon_record_expression] = STATE(1797),
    [sym_prefixed_expression] = STATE(1797),
    [sym_typecast_expression] = STATE(1797),
    [sym_for_expression] = STATE(1797),
    [sym_while_expression] = STATE(1797),
    [sym__if_branch] = STATE(6611),
    [sym_if_expression] = STATE(1797),
    [sym_fun_expression] = STATE(1797),
    [sym_try_expression] = STATE(1797),
    [sym_match_expression] = STATE(1797),
    [sym_function_expression] = STATE(1797),
    [sym_mutate_expression] = STATE(1797),
    [sym_index_expression] = STATE(1797),
    [sym_typed_expression] = STATE(1797),
    [sym_declaration_expression] = STATE(1797),
    [sym_do_expression] = STATE(1797),
    [sym_list_expression] = STATE(1797),
    [sym_array_expression] = STATE(1797),
    [sym_begin_end_expression] = STATE(1797),
    [sym_paren_expression] = STATE(1797),
    [sym__high_prec_app] = STATE(1800),
    [sym__low_prec_app] = STATE(1800),
    [sym_application_expression] = STATE(1797),
    [sym_dot_expression] = STATE(1797),
    [sym_infix_expression] = STATE(1797),
    [sym_ce_expression] = STATE(1797),
    [sym_sequential_expression] = STATE(1797),
    [sym_char] = STATE(1694),
    [sym_format_string] = STATE(1693),
    [sym__string_literal] = STATE(1693),
    [sym_string] = STATE(1694),
    [sym_verbatim_string] = STATE(1694),
    [sym_bytearray] = STATE(1694),
    [sym_verbatim_bytearray] = STATE(1694),
    [sym_format_triple_quoted_string] = STATE(1692),
    [sym_triple_quoted_string] = STATE(1694),
    [sym_const] = STATE(1797),
    [sym_long_identifier] = STATE(1813),
    [sym_active_pattern] = STATE(1753),
    [sym__identifier_or_op] = STATE(1812),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(756),
    [sym_sbyte] = STATE(1694),
    [sym_byte] = STATE(1694),
    [sym_int16] = STATE(1694),
    [sym_uint16] = STATE(1694),
    [sym_int32] = STATE(1694),
    [sym_uint32] = STATE(1694),
    [sym_nativeint] = STATE(1694),
    [sym_unativeint] = STATE(1694),
    [sym_int64] = STATE(1694),
    [sym_uint64] = STATE(1694),
    [sym_ieee32] = STATE(1694),
    [sym_ieee64] = STATE(1694),
    [sym_bignum] = STATE(1694),
    [sym_decimal] = STATE(1694),
    [sym_float] = STATE(1425),
    [sym_block_comment] = STATE(703),
    [sym_compiler_directive_decl] = STATE(703),
    [sym_fsi_directive_decl] = STATE(703),
    [sym_preproc_line] = STATE(703),
    [sym_preproc_if_in_expression] = STATE(1797),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(393),
    [anon_sym_return] = ACTIONS(397),
    [anon_sym_do] = ACTIONS(399),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(401),
    [anon_sym_null] = ACTIONS(405),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(407),
    [anon_sym_LBRACK_PIPE] = ACTIONS(409),
    [anon_sym_LBRACE] = ACTIONS(2146),
    [anon_sym_LT_AT] = ACTIONS(413),
    [anon_sym_LT_AT_AT] = ACTIONS(2148),
    [anon_sym_LBRACE_PIPE] = ACTIONS(419),
    [anon_sym_new] = ACTIONS(397),
    [anon_sym_return_BANG] = ACTIONS(421),
    [anon_sym_yield] = ACTIONS(397),
    [anon_sym_yield_BANG] = ACTIONS(421),
    [anon_sym_lazy] = ACTIONS(397),
    [anon_sym_assert] = ACTIONS(397),
    [anon_sym_upcast] = ACTIONS(397),
    [anon_sym_downcast] = ACTIONS(397),
    [anon_sym_for] = ACTIONS(425),
    [anon_sym_while] = ACTIONS(427),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(429),
    [anon_sym_try] = ACTIONS(431),
    [anon_sym_match] = ACTIONS(433),
    [anon_sym_match_BANG] = ACTIONS(435),
    [anon_sym_function] = ACTIONS(437),
    [anon_sym_use] = ACTIONS(445),
    [anon_sym_use_BANG] = ACTIONS(447),
    [anon_sym_do_BANG] = ACTIONS(449),
    [anon_sym_begin] = ACTIONS(451),
    [aux_sym_char_token1] = ACTIONS(455),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(457),
    [anon_sym_DQUOTE] = ACTIONS(459),
    [anon_sym_AT_DQUOTE] = ACTIONS(461),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(463),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(465),
    [sym_bool] = ACTIONS(467),
    [sym_unit] = ACTIONS(2150),
    [anon_sym_LPAREN_PIPE] = ACTIONS(471),
    [sym_op_identifier] = ACTIONS(2152),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(475),
    [sym_xint] = ACTIONS(477),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(479),
  },
  [704] = {
    [sym_function_or_value_defn] = STATE(704),
    [sym__expression] = STATE(272),
    [sym_literal_expression] = STATE(2403),
    [sym_long_identifier_or_op] = STATE(2403),
    [sym_tuple_expression] = STATE(2403),
    [sym_brace_expression] = STATE(2403),
    [sym_anon_record_expression] = STATE(2403),
    [sym_prefixed_expression] = STATE(2403),
    [sym_typecast_expression] = STATE(2403),
    [sym_for_expression] = STATE(2403),
    [sym_while_expression] = STATE(2403),
    [sym__if_branch] = STATE(6794),
    [sym_if_expression] = STATE(2403),
    [sym_fun_expression] = STATE(2403),
    [sym_try_expression] = STATE(2403),
    [sym_match_expression] = STATE(2403),
    [sym_function_expression] = STATE(2403),
    [sym_mutate_expression] = STATE(2403),
    [sym_index_expression] = STATE(2403),
    [sym_typed_expression] = STATE(2403),
    [sym_declaration_expression] = STATE(2403),
    [sym_do_expression] = STATE(2403),
    [sym_list_expression] = STATE(2403),
    [sym_array_expression] = STATE(2403),
    [sym_begin_end_expression] = STATE(2403),
    [sym_paren_expression] = STATE(2403),
    [sym__high_prec_app] = STATE(2405),
    [sym__low_prec_app] = STATE(2405),
    [sym_application_expression] = STATE(2403),
    [sym_dot_expression] = STATE(2403),
    [sym_infix_expression] = STATE(2403),
    [sym_ce_expression] = STATE(2403),
    [sym_sequential_expression] = STATE(2403),
    [sym_char] = STATE(2425),
    [sym_format_string] = STATE(2420),
    [sym__string_literal] = STATE(2420),
    [sym_string] = STATE(2425),
    [sym_verbatim_string] = STATE(2425),
    [sym_bytearray] = STATE(2425),
    [sym_verbatim_bytearray] = STATE(2425),
    [sym_format_triple_quoted_string] = STATE(2419),
    [sym_triple_quoted_string] = STATE(2425),
    [sym_const] = STATE(2403),
    [sym_long_identifier] = STATE(2079),
    [sym_active_pattern] = STATE(2080),
    [sym__identifier_or_op] = STATE(2089),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(688),
    [sym_sbyte] = STATE(2425),
    [sym_byte] = STATE(2425),
    [sym_int16] = STATE(2425),
    [sym_uint16] = STATE(2425),
    [sym_int32] = STATE(2425),
    [sym_uint32] = STATE(2425),
    [sym_nativeint] = STATE(2425),
    [sym_unativeint] = STATE(2425),
    [sym_int64] = STATE(2425),
    [sym_uint64] = STATE(2425),
    [sym_ieee32] = STATE(2425),
    [sym_ieee64] = STATE(2425),
    [sym_bignum] = STATE(2425),
    [sym_decimal] = STATE(2425),
    [sym_float] = STATE(1511),
    [sym_block_comment] = STATE(704),
    [sym_compiler_directive_decl] = STATE(704),
    [sym_fsi_directive_decl] = STATE(704),
    [sym_preproc_line] = STATE(704),
    [sym_preproc_if_in_expression] = STATE(2403),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(1261),
    [anon_sym_return] = ACTIONS(1265),
    [anon_sym_do] = ACTIONS(1267),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(1269),
    [anon_sym_null] = ACTIONS(1273),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1275),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1277),
    [anon_sym_LBRACE] = ACTIONS(1909),
    [anon_sym_LT_AT] = ACTIONS(1281),
    [anon_sym_LT_AT_AT] = ACTIONS(1911),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1287),
    [anon_sym_new] = ACTIONS(1265),
    [anon_sym_return_BANG] = ACTIONS(1289),
    [anon_sym_yield] = ACTIONS(1265),
    [anon_sym_yield_BANG] = ACTIONS(1289),
    [anon_sym_lazy] = ACTIONS(1265),
    [anon_sym_assert] = ACTIONS(1265),
    [anon_sym_upcast] = ACTIONS(1265),
    [anon_sym_downcast] = ACTIONS(1265),
    [anon_sym_for] = ACTIONS(1293),
    [anon_sym_while] = ACTIONS(1295),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(1297),
    [anon_sym_try] = ACTIONS(1299),
    [anon_sym_match] = ACTIONS(1301),
    [anon_sym_match_BANG] = ACTIONS(1303),
    [anon_sym_function] = ACTIONS(1305),
    [anon_sym_use] = ACTIONS(1313),
    [anon_sym_use_BANG] = ACTIONS(1315),
    [anon_sym_do_BANG] = ACTIONS(1317),
    [anon_sym_begin] = ACTIONS(1319),
    [aux_sym_char_token1] = ACTIONS(1323),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1325),
    [anon_sym_DQUOTE] = ACTIONS(1327),
    [anon_sym_AT_DQUOTE] = ACTIONS(1329),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1331),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1333),
    [sym_bool] = ACTIONS(1335),
    [sym_unit] = ACTIONS(1913),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1339),
    [sym_op_identifier] = ACTIONS(1915),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(1343),
    [sym_xint] = ACTIONS(1345),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1347),
  },
  [705] = {
    [sym_function_or_value_defn] = STATE(705),
    [sym__expression] = STATE(5),
    [sym_literal_expression] = STATE(867),
    [sym_long_identifier_or_op] = STATE(867),
    [sym_tuple_expression] = STATE(867),
    [sym_brace_expression] = STATE(867),
    [sym_anon_record_expression] = STATE(867),
    [sym_prefixed_expression] = STATE(867),
    [sym_typecast_expression] = STATE(867),
    [sym_for_expression] = STATE(867),
    [sym_while_expression] = STATE(867),
    [sym__if_branch] = STATE(6511),
    [sym_if_expression] = STATE(867),
    [sym_fun_expression] = STATE(867),
    [sym_try_expression] = STATE(867),
    [sym_match_expression] = STATE(867),
    [sym_function_expression] = STATE(867),
    [sym_mutate_expression] = STATE(867),
    [sym_index_expression] = STATE(867),
    [sym_typed_expression] = STATE(867),
    [sym_declaration_expression] = STATE(867),
    [sym_do_expression] = STATE(867),
    [sym_list_expression] = STATE(867),
    [sym_array_expression] = STATE(867),
    [sym_begin_end_expression] = STATE(867),
    [sym_paren_expression] = STATE(867),
    [sym__high_prec_app] = STATE(864),
    [sym__low_prec_app] = STATE(864),
    [sym_application_expression] = STATE(867),
    [sym_dot_expression] = STATE(867),
    [sym_infix_expression] = STATE(867),
    [sym_ce_expression] = STATE(867),
    [sym_sequential_expression] = STATE(867),
    [sym_char] = STATE(868),
    [sym_format_string] = STATE(869),
    [sym__string_literal] = STATE(869),
    [sym_string] = STATE(868),
    [sym_verbatim_string] = STATE(868),
    [sym_bytearray] = STATE(868),
    [sym_verbatim_bytearray] = STATE(868),
    [sym_format_triple_quoted_string] = STATE(870),
    [sym_triple_quoted_string] = STATE(868),
    [sym_const] = STATE(867),
    [sym_long_identifier] = STATE(872),
    [sym_active_pattern] = STATE(871),
    [sym__identifier_or_op] = STATE(873),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(658),
    [sym_sbyte] = STATE(868),
    [sym_byte] = STATE(868),
    [sym_int16] = STATE(868),
    [sym_uint16] = STATE(868),
    [sym_int32] = STATE(868),
    [sym_uint32] = STATE(868),
    [sym_nativeint] = STATE(868),
    [sym_unativeint] = STATE(868),
    [sym_int64] = STATE(868),
    [sym_uint64] = STATE(868),
    [sym_ieee32] = STATE(868),
    [sym_ieee64] = STATE(868),
    [sym_bignum] = STATE(868),
    [sym_decimal] = STATE(868),
    [sym_float] = STATE(860),
    [sym_block_comment] = STATE(705),
    [sym_compiler_directive_decl] = STATE(705),
    [sym_fsi_directive_decl] = STATE(705),
    [sym_preproc_line] = STATE(705),
    [sym_preproc_if_in_expression] = STATE(867),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(29),
    [anon_sym_return] = ACTIONS(37),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_null] = ACTIONS(49),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACK_PIPE] = ACTIONS(57),
    [anon_sym_LBRACE] = ACTIONS(1663),
    [anon_sym_LT_AT] = ACTIONS(61),
    [anon_sym_LT_AT_AT] = ACTIONS(1665),
    [anon_sym_LBRACE_PIPE] = ACTIONS(67),
    [anon_sym_new] = ACTIONS(37),
    [anon_sym_return_BANG] = ACTIONS(69),
    [anon_sym_yield] = ACTIONS(37),
    [anon_sym_yield_BANG] = ACTIONS(69),
    [anon_sym_lazy] = ACTIONS(37),
    [anon_sym_assert] = ACTIONS(37),
    [anon_sym_upcast] = ACTIONS(37),
    [anon_sym_downcast] = ACTIONS(37),
    [anon_sym_for] = ACTIONS(73),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(79),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_match] = ACTIONS(83),
    [anon_sym_match_BANG] = ACTIONS(85),
    [anon_sym_function] = ACTIONS(87),
    [anon_sym_use] = ACTIONS(95),
    [anon_sym_use_BANG] = ACTIONS(97),
    [anon_sym_do_BANG] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(101),
    [aux_sym_char_token1] = ACTIONS(105),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(107),
    [anon_sym_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DQUOTE] = ACTIONS(111),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(115),
    [sym_bool] = ACTIONS(117),
    [sym_unit] = ACTIONS(1673),
    [anon_sym_LPAREN_PIPE] = ACTIONS(121),
    [sym_op_identifier] = ACTIONS(1675),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(129),
    [sym_xint] = ACTIONS(131),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(135),
  },
  [706] = {
    [sym_function_or_value_defn] = STATE(733),
    [sym__expression] = STATE(153),
    [sym_literal_expression] = STATE(2008),
    [sym_long_identifier_or_op] = STATE(2008),
    [sym_tuple_expression] = STATE(2008),
    [sym_brace_expression] = STATE(2008),
    [sym_anon_record_expression] = STATE(2008),
    [sym_prefixed_expression] = STATE(2008),
    [sym_typecast_expression] = STATE(2008),
    [sym_for_expression] = STATE(2008),
    [sym_while_expression] = STATE(2008),
    [sym__if_branch] = STATE(6754),
    [sym_if_expression] = STATE(2008),
    [sym_fun_expression] = STATE(2008),
    [sym_try_expression] = STATE(2008),
    [sym_match_expression] = STATE(2008),
    [sym_function_expression] = STATE(2008),
    [sym_mutate_expression] = STATE(2008),
    [sym_index_expression] = STATE(2008),
    [sym_typed_expression] = STATE(2008),
    [sym_declaration_expression] = STATE(2008),
    [sym_do_expression] = STATE(2008),
    [sym_list_expression] = STATE(2008),
    [sym_array_expression] = STATE(2008),
    [sym_begin_end_expression] = STATE(2008),
    [sym_paren_expression] = STATE(2008),
    [sym__high_prec_app] = STATE(2007),
    [sym__low_prec_app] = STATE(2007),
    [sym_application_expression] = STATE(2008),
    [sym_dot_expression] = STATE(2008),
    [sym_infix_expression] = STATE(2008),
    [sym_ce_expression] = STATE(2008),
    [sym_sequential_expression] = STATE(2008),
    [sym_char] = STATE(1859),
    [sym_format_string] = STATE(1861),
    [sym__string_literal] = STATE(1861),
    [sym_string] = STATE(1859),
    [sym_verbatim_string] = STATE(1859),
    [sym_bytearray] = STATE(1859),
    [sym_verbatim_bytearray] = STATE(1859),
    [sym_format_triple_quoted_string] = STATE(1862),
    [sym_triple_quoted_string] = STATE(1859),
    [sym_const] = STATE(2008),
    [sym_long_identifier] = STATE(1701),
    [sym_active_pattern] = STATE(1702),
    [sym__identifier_or_op] = STATE(1724),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(706),
    [sym_sbyte] = STATE(1859),
    [sym_byte] = STATE(1859),
    [sym_int16] = STATE(1859),
    [sym_uint16] = STATE(1859),
    [sym_int32] = STATE(1859),
    [sym_uint32] = STATE(1859),
    [sym_nativeint] = STATE(1859),
    [sym_unativeint] = STATE(1859),
    [sym_int64] = STATE(1859),
    [sym_uint64] = STATE(1859),
    [sym_ieee32] = STATE(1859),
    [sym_ieee64] = STATE(1859),
    [sym_bignum] = STATE(1859),
    [sym_decimal] = STATE(1859),
    [sym_float] = STATE(1447),
    [sym_block_comment] = STATE(706),
    [sym_compiler_directive_decl] = STATE(706),
    [sym_fsi_directive_decl] = STATE(706),
    [sym_preproc_line] = STATE(706),
    [sym_preproc_if_in_expression] = STATE(2008),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(503),
    [anon_sym_return] = ACTIONS(971),
    [anon_sym_do] = ACTIONS(599),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(511),
    [anon_sym_null] = ACTIONS(515),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(517),
    [anon_sym_LBRACK_PIPE] = ACTIONS(519),
    [anon_sym_LBRACE] = ACTIONS(2060),
    [anon_sym_LT_AT] = ACTIONS(523),
    [anon_sym_LT_AT_AT] = ACTIONS(2062),
    [anon_sym_LBRACE_PIPE] = ACTIONS(529),
    [anon_sym_new] = ACTIONS(971),
    [anon_sym_return_BANG] = ACTIONS(975),
    [anon_sym_yield] = ACTIONS(971),
    [anon_sym_yield_BANG] = ACTIONS(975),
    [anon_sym_lazy] = ACTIONS(971),
    [anon_sym_assert] = ACTIONS(971),
    [anon_sym_upcast] = ACTIONS(971),
    [anon_sym_downcast] = ACTIONS(971),
    [anon_sym_for] = ACTIONS(979),
    [anon_sym_while] = ACTIONS(537),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(539),
    [anon_sym_try] = ACTIONS(543),
    [anon_sym_match] = ACTIONS(545),
    [anon_sym_match_BANG] = ACTIONS(547),
    [anon_sym_function] = ACTIONS(549),
    [anon_sym_use] = ACTIONS(983),
    [anon_sym_use_BANG] = ACTIONS(985),
    [anon_sym_do_BANG] = ACTIONS(561),
    [anon_sym_begin] = ACTIONS(565),
    [aux_sym_char_token1] = ACTIONS(569),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(571),
    [anon_sym_DQUOTE] = ACTIONS(573),
    [anon_sym_AT_DQUOTE] = ACTIONS(575),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(577),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(579),
    [sym_bool] = ACTIONS(581),
    [sym_unit] = ACTIONS(2064),
    [anon_sym_LPAREN_PIPE] = ACTIONS(585),
    [sym_op_identifier] = ACTIONS(2066),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(591),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(593),
  },
  [707] = {
    [sym_function_or_value_defn] = STATE(600),
    [sym__expression] = STATE(172),
    [sym_literal_expression] = STATE(867),
    [sym_long_identifier_or_op] = STATE(867),
    [sym_tuple_expression] = STATE(867),
    [sym_brace_expression] = STATE(867),
    [sym_anon_record_expression] = STATE(867),
    [sym_prefixed_expression] = STATE(867),
    [sym_typecast_expression] = STATE(867),
    [sym_for_expression] = STATE(867),
    [sym_while_expression] = STATE(867),
    [sym__if_branch] = STATE(6511),
    [sym_if_expression] = STATE(867),
    [sym_fun_expression] = STATE(867),
    [sym_try_expression] = STATE(867),
    [sym_match_expression] = STATE(867),
    [sym_function_expression] = STATE(867),
    [sym_mutate_expression] = STATE(867),
    [sym_index_expression] = STATE(867),
    [sym_typed_expression] = STATE(867),
    [sym_declaration_expression] = STATE(867),
    [sym_do_expression] = STATE(867),
    [sym_list_expression] = STATE(867),
    [sym_array_expression] = STATE(867),
    [sym_begin_end_expression] = STATE(867),
    [sym_paren_expression] = STATE(867),
    [sym__high_prec_app] = STATE(864),
    [sym__low_prec_app] = STATE(864),
    [sym_application_expression] = STATE(867),
    [sym_dot_expression] = STATE(867),
    [sym_infix_expression] = STATE(867),
    [sym_ce_expression] = STATE(867),
    [sym_sequential_expression] = STATE(867),
    [sym_char] = STATE(868),
    [sym_format_string] = STATE(869),
    [sym__string_literal] = STATE(869),
    [sym_string] = STATE(868),
    [sym_verbatim_string] = STATE(868),
    [sym_bytearray] = STATE(868),
    [sym_verbatim_bytearray] = STATE(868),
    [sym_format_triple_quoted_string] = STATE(870),
    [sym_triple_quoted_string] = STATE(868),
    [sym_const] = STATE(867),
    [sym_long_identifier] = STATE(872),
    [sym_active_pattern] = STATE(871),
    [sym__identifier_or_op] = STATE(873),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(656),
    [sym_sbyte] = STATE(868),
    [sym_byte] = STATE(868),
    [sym_int16] = STATE(868),
    [sym_uint16] = STATE(868),
    [sym_int32] = STATE(868),
    [sym_uint32] = STATE(868),
    [sym_nativeint] = STATE(868),
    [sym_unativeint] = STATE(868),
    [sym_int64] = STATE(868),
    [sym_uint64] = STATE(868),
    [sym_ieee32] = STATE(868),
    [sym_ieee64] = STATE(868),
    [sym_bignum] = STATE(868),
    [sym_decimal] = STATE(868),
    [sym_float] = STATE(1368),
    [sym_block_comment] = STATE(707),
    [sym_compiler_directive_decl] = STATE(707),
    [sym_fsi_directive_decl] = STATE(707),
    [sym_preproc_line] = STATE(707),
    [sym_preproc_if_in_expression] = STATE(867),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(29),
    [anon_sym_return] = ACTIONS(825),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_null] = ACTIONS(49),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACK_PIPE] = ACTIONS(57),
    [anon_sym_LBRACE] = ACTIONS(1663),
    [anon_sym_LT_AT] = ACTIONS(61),
    [anon_sym_LT_AT_AT] = ACTIONS(1665),
    [anon_sym_LBRACE_PIPE] = ACTIONS(67),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_return_BANG] = ACTIONS(829),
    [anon_sym_yield] = ACTIONS(825),
    [anon_sym_yield_BANG] = ACTIONS(829),
    [anon_sym_lazy] = ACTIONS(825),
    [anon_sym_assert] = ACTIONS(825),
    [anon_sym_upcast] = ACTIONS(825),
    [anon_sym_downcast] = ACTIONS(825),
    [anon_sym_for] = ACTIONS(73),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(79),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_match] = ACTIONS(83),
    [anon_sym_match_BANG] = ACTIONS(85),
    [anon_sym_function] = ACTIONS(87),
    [anon_sym_use] = ACTIONS(833),
    [anon_sym_use_BANG] = ACTIONS(835),
    [anon_sym_do_BANG] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(101),
    [aux_sym_char_token1] = ACTIONS(105),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(107),
    [anon_sym_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DQUOTE] = ACTIONS(111),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(115),
    [sym_bool] = ACTIONS(117),
    [sym_unit] = ACTIONS(1673),
    [anon_sym_LPAREN_PIPE] = ACTIONS(121),
    [sym_op_identifier] = ACTIONS(1675),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(837),
    [sym_xint] = ACTIONS(387),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(135),
  },
  [708] = {
    [sym_function_or_value_defn] = STATE(663),
    [sym__expression] = STATE(64),
    [sym_literal_expression] = STATE(1118),
    [sym_long_identifier_or_op] = STATE(1118),
    [sym_tuple_expression] = STATE(1118),
    [sym_brace_expression] = STATE(1118),
    [sym_anon_record_expression] = STATE(1118),
    [sym_prefixed_expression] = STATE(1118),
    [sym_typecast_expression] = STATE(1118),
    [sym_for_expression] = STATE(1118),
    [sym_while_expression] = STATE(1118),
    [sym__if_branch] = STATE(7163),
    [sym_if_expression] = STATE(1118),
    [sym_fun_expression] = STATE(1118),
    [sym_try_expression] = STATE(1118),
    [sym_match_expression] = STATE(1118),
    [sym_function_expression] = STATE(1118),
    [sym_mutate_expression] = STATE(1118),
    [sym_index_expression] = STATE(1118),
    [sym_typed_expression] = STATE(1118),
    [sym_declaration_expression] = STATE(1118),
    [sym_do_expression] = STATE(1118),
    [sym_list_expression] = STATE(1118),
    [sym_array_expression] = STATE(1118),
    [sym_begin_end_expression] = STATE(1118),
    [sym_paren_expression] = STATE(1118),
    [sym__high_prec_app] = STATE(1133),
    [sym__low_prec_app] = STATE(1133),
    [sym_application_expression] = STATE(1118),
    [sym_dot_expression] = STATE(1118),
    [sym_infix_expression] = STATE(1118),
    [sym_ce_expression] = STATE(1118),
    [sym_sequential_expression] = STATE(1118),
    [sym_char] = STATE(1080),
    [sym_format_string] = STATE(1090),
    [sym__string_literal] = STATE(1090),
    [sym_string] = STATE(1080),
    [sym_verbatim_string] = STATE(1080),
    [sym_bytearray] = STATE(1080),
    [sym_verbatim_bytearray] = STATE(1080),
    [sym_format_triple_quoted_string] = STATE(1096),
    [sym_triple_quoted_string] = STATE(1080),
    [sym_const] = STATE(1118),
    [sym_long_identifier] = STATE(1156),
    [sym_active_pattern] = STATE(1085),
    [sym__identifier_or_op] = STATE(1099),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(548),
    [sym_sbyte] = STATE(1080),
    [sym_byte] = STATE(1080),
    [sym_int16] = STATE(1080),
    [sym_uint16] = STATE(1080),
    [sym_int32] = STATE(1080),
    [sym_uint32] = STATE(1080),
    [sym_nativeint] = STATE(1080),
    [sym_unativeint] = STATE(1080),
    [sym_int64] = STATE(1080),
    [sym_uint64] = STATE(1080),
    [sym_ieee32] = STATE(1080),
    [sym_ieee64] = STATE(1080),
    [sym_bignum] = STATE(1080),
    [sym_decimal] = STATE(1080),
    [sym_float] = STATE(979),
    [sym_block_comment] = STATE(708),
    [sym_compiler_directive_decl] = STATE(708),
    [sym_fsi_directive_decl] = STATE(708),
    [sym_preproc_line] = STATE(708),
    [sym_preproc_if_in_expression] = STATE(1118),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(195),
    [anon_sym_return] = ACTIONS(481),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_null] = ACTIONS(207),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(209),
    [anon_sym_LBRACK_PIPE] = ACTIONS(211),
    [anon_sym_LBRACE] = ACTIONS(1687),
    [anon_sym_LT_AT] = ACTIONS(213),
    [anon_sym_LT_AT_AT] = ACTIONS(1689),
    [anon_sym_LBRACE_PIPE] = ACTIONS(217),
    [anon_sym_new] = ACTIONS(481),
    [anon_sym_return_BANG] = ACTIONS(487),
    [anon_sym_yield] = ACTIONS(481),
    [anon_sym_yield_BANG] = ACTIONS(487),
    [anon_sym_lazy] = ACTIONS(481),
    [anon_sym_assert] = ACTIONS(481),
    [anon_sym_upcast] = ACTIONS(481),
    [anon_sym_downcast] = ACTIONS(481),
    [anon_sym_for] = ACTIONS(489),
    [anon_sym_while] = ACTIONS(225),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(229),
    [anon_sym_match] = ACTIONS(231),
    [anon_sym_match_BANG] = ACTIONS(233),
    [anon_sym_function] = ACTIONS(235),
    [anon_sym_use] = ACTIONS(493),
    [anon_sym_use_BANG] = ACTIONS(495),
    [anon_sym_do_BANG] = ACTIONS(243),
    [anon_sym_begin] = ACTIONS(245),
    [aux_sym_char_token1] = ACTIONS(247),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(251),
    [anon_sym_AT_DQUOTE] = ACTIONS(253),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(255),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(257),
    [sym_bool] = ACTIONS(259),
    [sym_unit] = ACTIONS(1699),
    [anon_sym_LPAREN_PIPE] = ACTIONS(261),
    [sym_op_identifier] = ACTIONS(1701),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(499),
    [sym_xint] = ACTIONS(267),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(269),
  },
  [709] = {
    [sym_function_or_value_defn] = STATE(651),
    [sym__expression] = STATE(168),
    [sym_literal_expression] = STATE(2168),
    [sym_long_identifier_or_op] = STATE(2168),
    [sym_tuple_expression] = STATE(2168),
    [sym_brace_expression] = STATE(2168),
    [sym_anon_record_expression] = STATE(2168),
    [sym_prefixed_expression] = STATE(2168),
    [sym_typecast_expression] = STATE(2168),
    [sym_for_expression] = STATE(2168),
    [sym_while_expression] = STATE(2168),
    [sym__if_branch] = STATE(6406),
    [sym_if_expression] = STATE(2168),
    [sym_fun_expression] = STATE(2168),
    [sym_try_expression] = STATE(2168),
    [sym_match_expression] = STATE(2168),
    [sym_function_expression] = STATE(2168),
    [sym_mutate_expression] = STATE(2168),
    [sym_index_expression] = STATE(2168),
    [sym_typed_expression] = STATE(2168),
    [sym_declaration_expression] = STATE(2168),
    [sym_do_expression] = STATE(2168),
    [sym_list_expression] = STATE(2168),
    [sym_array_expression] = STATE(2168),
    [sym_begin_end_expression] = STATE(2168),
    [sym_paren_expression] = STATE(2168),
    [sym__high_prec_app] = STATE(2179),
    [sym__low_prec_app] = STATE(2179),
    [sym_application_expression] = STATE(2168),
    [sym_dot_expression] = STATE(2168),
    [sym_infix_expression] = STATE(2168),
    [sym_ce_expression] = STATE(2168),
    [sym_sequential_expression] = STATE(2168),
    [sym_char] = STATE(2469),
    [sym_format_string] = STATE(2412),
    [sym__string_literal] = STATE(2412),
    [sym_string] = STATE(2469),
    [sym_verbatim_string] = STATE(2469),
    [sym_bytearray] = STATE(2469),
    [sym_verbatim_bytearray] = STATE(2469),
    [sym_format_triple_quoted_string] = STATE(2408),
    [sym_triple_quoted_string] = STATE(2469),
    [sym_const] = STATE(2168),
    [sym_long_identifier] = STATE(2183),
    [sym_active_pattern] = STATE(2182),
    [sym__identifier_or_op] = STATE(2093),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(650),
    [sym_sbyte] = STATE(2469),
    [sym_byte] = STATE(2469),
    [sym_int16] = STATE(2469),
    [sym_uint16] = STATE(2469),
    [sym_int32] = STATE(2469),
    [sym_uint32] = STATE(2469),
    [sym_nativeint] = STATE(2469),
    [sym_unativeint] = STATE(2469),
    [sym_int64] = STATE(2469),
    [sym_uint64] = STATE(2469),
    [sym_ieee32] = STATE(2469),
    [sym_ieee64] = STATE(2469),
    [sym_bignum] = STATE(2469),
    [sym_decimal] = STATE(2469),
    [sym_float] = STATE(1586),
    [sym_block_comment] = STATE(709),
    [sym_compiler_directive_decl] = STATE(709),
    [sym_fsi_directive_decl] = STATE(709),
    [sym_preproc_line] = STATE(709),
    [sym_preproc_if_in_expression] = STATE(2168),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(989),
    [anon_sym_return] = ACTIONS(993),
    [anon_sym_do] = ACTIONS(995),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(997),
    [anon_sym_null] = ACTIONS(1001),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1003),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1005),
    [anon_sym_LBRACE] = ACTIONS(2070),
    [anon_sym_LT_AT] = ACTIONS(1009),
    [anon_sym_LT_AT_AT] = ACTIONS(2072),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1017),
    [anon_sym_new] = ACTIONS(993),
    [anon_sym_return_BANG] = ACTIONS(1019),
    [anon_sym_yield] = ACTIONS(993),
    [anon_sym_yield_BANG] = ACTIONS(1019),
    [anon_sym_lazy] = ACTIONS(993),
    [anon_sym_assert] = ACTIONS(993),
    [anon_sym_upcast] = ACTIONS(993),
    [anon_sym_downcast] = ACTIONS(993),
    [anon_sym_for] = ACTIONS(1023),
    [anon_sym_while] = ACTIONS(1025),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(1027),
    [anon_sym_try] = ACTIONS(1029),
    [anon_sym_match] = ACTIONS(1031),
    [anon_sym_match_BANG] = ACTIONS(1033),
    [anon_sym_function] = ACTIONS(1035),
    [anon_sym_use] = ACTIONS(1043),
    [anon_sym_use_BANG] = ACTIONS(1045),
    [anon_sym_do_BANG] = ACTIONS(1047),
    [anon_sym_begin] = ACTIONS(1049),
    [aux_sym_char_token1] = ACTIONS(1053),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1055),
    [anon_sym_DQUOTE] = ACTIONS(1057),
    [anon_sym_AT_DQUOTE] = ACTIONS(1059),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1061),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1063),
    [sym_bool] = ACTIONS(1065),
    [sym_unit] = ACTIONS(2074),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1069),
    [sym_op_identifier] = ACTIONS(2076),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(1073),
    [sym_xint] = ACTIONS(1075),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1077),
  },
  [710] = {
    [sym_function_or_value_defn] = STATE(704),
    [sym__expression] = STATE(205),
    [sym_literal_expression] = STATE(2403),
    [sym_long_identifier_or_op] = STATE(2403),
    [sym_tuple_expression] = STATE(2403),
    [sym_brace_expression] = STATE(2403),
    [sym_anon_record_expression] = STATE(2403),
    [sym_prefixed_expression] = STATE(2403),
    [sym_typecast_expression] = STATE(2403),
    [sym_for_expression] = STATE(2403),
    [sym_while_expression] = STATE(2403),
    [sym__if_branch] = STATE(6794),
    [sym_if_expression] = STATE(2403),
    [sym_fun_expression] = STATE(2403),
    [sym_try_expression] = STATE(2403),
    [sym_match_expression] = STATE(2403),
    [sym_function_expression] = STATE(2403),
    [sym_mutate_expression] = STATE(2403),
    [sym_index_expression] = STATE(2403),
    [sym_typed_expression] = STATE(2403),
    [sym_declaration_expression] = STATE(2403),
    [sym_do_expression] = STATE(2403),
    [sym_list_expression] = STATE(2403),
    [sym_array_expression] = STATE(2403),
    [sym_begin_end_expression] = STATE(2403),
    [sym_paren_expression] = STATE(2403),
    [sym__high_prec_app] = STATE(2405),
    [sym__low_prec_app] = STATE(2405),
    [sym_application_expression] = STATE(2403),
    [sym_dot_expression] = STATE(2403),
    [sym_infix_expression] = STATE(2403),
    [sym_ce_expression] = STATE(2403),
    [sym_sequential_expression] = STATE(2403),
    [sym_char] = STATE(2425),
    [sym_format_string] = STATE(2420),
    [sym__string_literal] = STATE(2420),
    [sym_string] = STATE(2425),
    [sym_verbatim_string] = STATE(2425),
    [sym_bytearray] = STATE(2425),
    [sym_verbatim_bytearray] = STATE(2425),
    [sym_format_triple_quoted_string] = STATE(2419),
    [sym_triple_quoted_string] = STATE(2425),
    [sym_const] = STATE(2403),
    [sym_long_identifier] = STATE(2079),
    [sym_active_pattern] = STATE(2080),
    [sym__identifier_or_op] = STATE(2089),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(688),
    [sym_sbyte] = STATE(2425),
    [sym_byte] = STATE(2425),
    [sym_int16] = STATE(2425),
    [sym_uint16] = STATE(2425),
    [sym_int32] = STATE(2425),
    [sym_uint32] = STATE(2425),
    [sym_nativeint] = STATE(2425),
    [sym_unativeint] = STATE(2425),
    [sym_int64] = STATE(2425),
    [sym_uint64] = STATE(2425),
    [sym_ieee32] = STATE(2425),
    [sym_ieee64] = STATE(2425),
    [sym_bignum] = STATE(2425),
    [sym_decimal] = STATE(2425),
    [sym_float] = STATE(1511),
    [sym_block_comment] = STATE(710),
    [sym_compiler_directive_decl] = STATE(710),
    [sym_fsi_directive_decl] = STATE(710),
    [sym_preproc_line] = STATE(710),
    [sym_preproc_if_in_expression] = STATE(2403),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(1261),
    [anon_sym_return] = ACTIONS(1265),
    [anon_sym_do] = ACTIONS(1267),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(1269),
    [anon_sym_null] = ACTIONS(1273),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1275),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1277),
    [anon_sym_LBRACE] = ACTIONS(1909),
    [anon_sym_LT_AT] = ACTIONS(1281),
    [anon_sym_LT_AT_AT] = ACTIONS(1911),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1287),
    [anon_sym_new] = ACTIONS(1265),
    [anon_sym_return_BANG] = ACTIONS(1289),
    [anon_sym_yield] = ACTIONS(1265),
    [anon_sym_yield_BANG] = ACTIONS(1289),
    [anon_sym_lazy] = ACTIONS(1265),
    [anon_sym_assert] = ACTIONS(1265),
    [anon_sym_upcast] = ACTIONS(1265),
    [anon_sym_downcast] = ACTIONS(1265),
    [anon_sym_for] = ACTIONS(1293),
    [anon_sym_while] = ACTIONS(1295),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(1297),
    [anon_sym_try] = ACTIONS(1299),
    [anon_sym_match] = ACTIONS(1301),
    [anon_sym_match_BANG] = ACTIONS(1303),
    [anon_sym_function] = ACTIONS(1305),
    [anon_sym_use] = ACTIONS(1313),
    [anon_sym_use_BANG] = ACTIONS(1315),
    [anon_sym_do_BANG] = ACTIONS(1317),
    [anon_sym_begin] = ACTIONS(1319),
    [aux_sym_char_token1] = ACTIONS(1323),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1325),
    [anon_sym_DQUOTE] = ACTIONS(1327),
    [anon_sym_AT_DQUOTE] = ACTIONS(1329),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1331),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1333),
    [sym_bool] = ACTIONS(1335),
    [sym_unit] = ACTIONS(1913),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1339),
    [sym_op_identifier] = ACTIONS(1915),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(1343),
    [sym_xint] = ACTIONS(1345),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1347),
  },
  [711] = {
    [sym_function_or_value_defn] = STATE(630),
    [sym__expression] = STATE(169),
    [sym_literal_expression] = STATE(2380),
    [sym_long_identifier_or_op] = STATE(2380),
    [sym_tuple_expression] = STATE(2380),
    [sym_brace_expression] = STATE(2380),
    [sym_anon_record_expression] = STATE(2380),
    [sym_prefixed_expression] = STATE(2380),
    [sym_typecast_expression] = STATE(2380),
    [sym_for_expression] = STATE(2380),
    [sym_while_expression] = STATE(2380),
    [sym__if_branch] = STATE(6456),
    [sym_if_expression] = STATE(2380),
    [sym_fun_expression] = STATE(2380),
    [sym_try_expression] = STATE(2380),
    [sym_match_expression] = STATE(2380),
    [sym_function_expression] = STATE(2380),
    [sym_mutate_expression] = STATE(2380),
    [sym_index_expression] = STATE(2380),
    [sym_typed_expression] = STATE(2380),
    [sym_declaration_expression] = STATE(2380),
    [sym_do_expression] = STATE(2380),
    [sym_list_expression] = STATE(2380),
    [sym_array_expression] = STATE(2380),
    [sym_begin_end_expression] = STATE(2380),
    [sym_paren_expression] = STATE(2380),
    [sym__high_prec_app] = STATE(2383),
    [sym__low_prec_app] = STATE(2383),
    [sym_application_expression] = STATE(2380),
    [sym_dot_expression] = STATE(2380),
    [sym_infix_expression] = STATE(2380),
    [sym_ce_expression] = STATE(2380),
    [sym_sequential_expression] = STATE(2380),
    [sym_char] = STATE(2261),
    [sym_format_string] = STATE(2274),
    [sym__string_literal] = STATE(2274),
    [sym_string] = STATE(2261),
    [sym_verbatim_string] = STATE(2261),
    [sym_bytearray] = STATE(2261),
    [sym_verbatim_bytearray] = STATE(2261),
    [sym_format_triple_quoted_string] = STATE(2275),
    [sym_triple_quoted_string] = STATE(2261),
    [sym_const] = STATE(2380),
    [sym_long_identifier] = STATE(2391),
    [sym_active_pattern] = STATE(2470),
    [sym__identifier_or_op] = STATE(2390),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(632),
    [sym_sbyte] = STATE(2261),
    [sym_byte] = STATE(2261),
    [sym_int16] = STATE(2261),
    [sym_uint16] = STATE(2261),
    [sym_int32] = STATE(2261),
    [sym_uint32] = STATE(2261),
    [sym_nativeint] = STATE(2261),
    [sym_unativeint] = STATE(2261),
    [sym_int64] = STATE(2261),
    [sym_uint64] = STATE(2261),
    [sym_ieee32] = STATE(2261),
    [sym_ieee64] = STATE(2261),
    [sym_bignum] = STATE(2261),
    [sym_decimal] = STATE(2261),
    [sym_float] = STATE(1614),
    [sym_block_comment] = STATE(711),
    [sym_compiler_directive_decl] = STATE(711),
    [sym_fsi_directive_decl] = STATE(711),
    [sym_preproc_line] = STATE(711),
    [sym_preproc_if_in_expression] = STATE(2380),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(1081),
    [anon_sym_return] = ACTIONS(1085),
    [anon_sym_do] = ACTIONS(1087),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(1089),
    [anon_sym_null] = ACTIONS(1093),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1095),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1097),
    [anon_sym_LBRACE] = ACTIONS(2100),
    [anon_sym_LT_AT] = ACTIONS(1101),
    [anon_sym_LT_AT_AT] = ACTIONS(2102),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1107),
    [anon_sym_new] = ACTIONS(1085),
    [anon_sym_return_BANG] = ACTIONS(1109),
    [anon_sym_yield] = ACTIONS(1085),
    [anon_sym_yield_BANG] = ACTIONS(1109),
    [anon_sym_lazy] = ACTIONS(1085),
    [anon_sym_assert] = ACTIONS(1085),
    [anon_sym_upcast] = ACTIONS(1085),
    [anon_sym_downcast] = ACTIONS(1085),
    [anon_sym_for] = ACTIONS(1113),
    [anon_sym_while] = ACTIONS(1115),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(1117),
    [anon_sym_try] = ACTIONS(1119),
    [anon_sym_match] = ACTIONS(1121),
    [anon_sym_match_BANG] = ACTIONS(1123),
    [anon_sym_function] = ACTIONS(1125),
    [anon_sym_use] = ACTIONS(1133),
    [anon_sym_use_BANG] = ACTIONS(1135),
    [anon_sym_do_BANG] = ACTIONS(1137),
    [anon_sym_begin] = ACTIONS(1139),
    [aux_sym_char_token1] = ACTIONS(1143),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1145),
    [anon_sym_DQUOTE] = ACTIONS(1147),
    [anon_sym_AT_DQUOTE] = ACTIONS(1149),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1151),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1153),
    [sym_bool] = ACTIONS(1155),
    [sym_unit] = ACTIONS(2104),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1159),
    [sym_op_identifier] = ACTIONS(2106),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(1163),
    [sym_xint] = ACTIONS(1165),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1167),
  },
  [712] = {
    [sym_function_or_value_defn] = STATE(733),
    [sym__expression] = STATE(299),
    [sym_literal_expression] = STATE(2008),
    [sym_long_identifier_or_op] = STATE(2008),
    [sym_tuple_expression] = STATE(2008),
    [sym_brace_expression] = STATE(2008),
    [sym_anon_record_expression] = STATE(2008),
    [sym_prefixed_expression] = STATE(2008),
    [sym_typecast_expression] = STATE(2008),
    [sym_for_expression] = STATE(2008),
    [sym_while_expression] = STATE(2008),
    [sym__if_branch] = STATE(6754),
    [sym_if_expression] = STATE(2008),
    [sym_fun_expression] = STATE(2008),
    [sym_try_expression] = STATE(2008),
    [sym_match_expression] = STATE(2008),
    [sym_function_expression] = STATE(2008),
    [sym_mutate_expression] = STATE(2008),
    [sym_index_expression] = STATE(2008),
    [sym_typed_expression] = STATE(2008),
    [sym_declaration_expression] = STATE(2008),
    [sym_do_expression] = STATE(2008),
    [sym_list_expression] = STATE(2008),
    [sym_array_expression] = STATE(2008),
    [sym_begin_end_expression] = STATE(2008),
    [sym_paren_expression] = STATE(2008),
    [sym__high_prec_app] = STATE(2007),
    [sym__low_prec_app] = STATE(2007),
    [sym_application_expression] = STATE(2008),
    [sym_dot_expression] = STATE(2008),
    [sym_infix_expression] = STATE(2008),
    [sym_ce_expression] = STATE(2008),
    [sym_sequential_expression] = STATE(2008),
    [sym_char] = STATE(1859),
    [sym_format_string] = STATE(1861),
    [sym__string_literal] = STATE(1861),
    [sym_string] = STATE(1859),
    [sym_verbatim_string] = STATE(1859),
    [sym_bytearray] = STATE(1859),
    [sym_verbatim_bytearray] = STATE(1859),
    [sym_format_triple_quoted_string] = STATE(1862),
    [sym_triple_quoted_string] = STATE(1859),
    [sym_const] = STATE(2008),
    [sym_long_identifier] = STATE(1701),
    [sym_active_pattern] = STATE(1702),
    [sym__identifier_or_op] = STATE(1724),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(706),
    [sym_sbyte] = STATE(1859),
    [sym_byte] = STATE(1859),
    [sym_int16] = STATE(1859),
    [sym_uint16] = STATE(1859),
    [sym_int32] = STATE(1859),
    [sym_uint32] = STATE(1859),
    [sym_nativeint] = STATE(1859),
    [sym_unativeint] = STATE(1859),
    [sym_int64] = STATE(1859),
    [sym_uint64] = STATE(1859),
    [sym_ieee32] = STATE(1859),
    [sym_ieee64] = STATE(1859),
    [sym_bignum] = STATE(1859),
    [sym_decimal] = STATE(1859),
    [sym_float] = STATE(1447),
    [sym_block_comment] = STATE(712),
    [sym_compiler_directive_decl] = STATE(712),
    [sym_fsi_directive_decl] = STATE(712),
    [sym_preproc_line] = STATE(712),
    [sym_preproc_if_in_expression] = STATE(2008),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(503),
    [anon_sym_return] = ACTIONS(971),
    [anon_sym_do] = ACTIONS(599),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(511),
    [anon_sym_null] = ACTIONS(515),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(517),
    [anon_sym_LBRACK_PIPE] = ACTIONS(519),
    [anon_sym_LBRACE] = ACTIONS(2060),
    [anon_sym_LT_AT] = ACTIONS(523),
    [anon_sym_LT_AT_AT] = ACTIONS(2062),
    [anon_sym_LBRACE_PIPE] = ACTIONS(529),
    [anon_sym_new] = ACTIONS(971),
    [anon_sym_return_BANG] = ACTIONS(975),
    [anon_sym_yield] = ACTIONS(971),
    [anon_sym_yield_BANG] = ACTIONS(975),
    [anon_sym_lazy] = ACTIONS(971),
    [anon_sym_assert] = ACTIONS(971),
    [anon_sym_upcast] = ACTIONS(971),
    [anon_sym_downcast] = ACTIONS(971),
    [anon_sym_for] = ACTIONS(979),
    [anon_sym_while] = ACTIONS(537),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(539),
    [anon_sym_try] = ACTIONS(543),
    [anon_sym_match] = ACTIONS(545),
    [anon_sym_match_BANG] = ACTIONS(547),
    [anon_sym_function] = ACTIONS(549),
    [anon_sym_use] = ACTIONS(983),
    [anon_sym_use_BANG] = ACTIONS(985),
    [anon_sym_do_BANG] = ACTIONS(561),
    [anon_sym_begin] = ACTIONS(565),
    [aux_sym_char_token1] = ACTIONS(569),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(571),
    [anon_sym_DQUOTE] = ACTIONS(573),
    [anon_sym_AT_DQUOTE] = ACTIONS(575),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(577),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(579),
    [sym_bool] = ACTIONS(581),
    [sym_unit] = ACTIONS(2064),
    [anon_sym_LPAREN_PIPE] = ACTIONS(585),
    [sym_op_identifier] = ACTIONS(2066),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(591),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(593),
  },
  [713] = {
    [sym_function_or_value_defn] = STATE(627),
    [sym__expression] = STATE(341),
    [sym_literal_expression] = STATE(1118),
    [sym_long_identifier_or_op] = STATE(1118),
    [sym_tuple_expression] = STATE(1118),
    [sym_brace_expression] = STATE(1118),
    [sym_anon_record_expression] = STATE(1118),
    [sym_prefixed_expression] = STATE(1118),
    [sym_typecast_expression] = STATE(1118),
    [sym_for_expression] = STATE(1118),
    [sym_while_expression] = STATE(1118),
    [sym__if_branch] = STATE(7163),
    [sym_if_expression] = STATE(1118),
    [sym_fun_expression] = STATE(1118),
    [sym_try_expression] = STATE(1118),
    [sym_match_expression] = STATE(1118),
    [sym_function_expression] = STATE(1118),
    [sym_mutate_expression] = STATE(1118),
    [sym_index_expression] = STATE(1118),
    [sym_typed_expression] = STATE(1118),
    [sym_declaration_expression] = STATE(1118),
    [sym_do_expression] = STATE(1118),
    [sym_list_expression] = STATE(1118),
    [sym_array_expression] = STATE(1118),
    [sym_begin_end_expression] = STATE(1118),
    [sym_paren_expression] = STATE(1118),
    [sym__high_prec_app] = STATE(1133),
    [sym__low_prec_app] = STATE(1133),
    [sym_application_expression] = STATE(1118),
    [sym_dot_expression] = STATE(1118),
    [sym_infix_expression] = STATE(1118),
    [sym_ce_expression] = STATE(1118),
    [sym_sequential_expression] = STATE(1118),
    [sym_char] = STATE(1080),
    [sym_format_string] = STATE(1090),
    [sym__string_literal] = STATE(1090),
    [sym_string] = STATE(1080),
    [sym_verbatim_string] = STATE(1080),
    [sym_bytearray] = STATE(1080),
    [sym_verbatim_bytearray] = STATE(1080),
    [sym_format_triple_quoted_string] = STATE(1096),
    [sym_triple_quoted_string] = STATE(1080),
    [sym_const] = STATE(1118),
    [sym_long_identifier] = STATE(1156),
    [sym_active_pattern] = STATE(1085),
    [sym__identifier_or_op] = STATE(1099),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(517),
    [sym_sbyte] = STATE(1080),
    [sym_byte] = STATE(1080),
    [sym_int16] = STATE(1080),
    [sym_uint16] = STATE(1080),
    [sym_int32] = STATE(1080),
    [sym_uint32] = STATE(1080),
    [sym_nativeint] = STATE(1080),
    [sym_unativeint] = STATE(1080),
    [sym_int64] = STATE(1080),
    [sym_uint64] = STATE(1080),
    [sym_ieee32] = STATE(1080),
    [sym_ieee64] = STATE(1080),
    [sym_bignum] = STATE(1080),
    [sym_decimal] = STATE(1080),
    [sym_float] = STATE(979),
    [sym_block_comment] = STATE(713),
    [sym_compiler_directive_decl] = STATE(713),
    [sym_fsi_directive_decl] = STATE(713),
    [sym_preproc_line] = STATE(713),
    [sym_preproc_if_in_expression] = STATE(1118),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(195),
    [anon_sym_return] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_null] = ACTIONS(207),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(209),
    [anon_sym_LBRACK_PIPE] = ACTIONS(211),
    [anon_sym_LBRACE] = ACTIONS(1687),
    [anon_sym_LT_AT] = ACTIONS(213),
    [anon_sym_LT_AT_AT] = ACTIONS(1689),
    [anon_sym_LBRACE_PIPE] = ACTIONS(217),
    [anon_sym_new] = ACTIONS(199),
    [anon_sym_return_BANG] = ACTIONS(219),
    [anon_sym_yield] = ACTIONS(199),
    [anon_sym_yield_BANG] = ACTIONS(219),
    [anon_sym_lazy] = ACTIONS(199),
    [anon_sym_assert] = ACTIONS(199),
    [anon_sym_upcast] = ACTIONS(199),
    [anon_sym_downcast] = ACTIONS(199),
    [anon_sym_for] = ACTIONS(223),
    [anon_sym_while] = ACTIONS(225),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(229),
    [anon_sym_match] = ACTIONS(231),
    [anon_sym_match_BANG] = ACTIONS(233),
    [anon_sym_function] = ACTIONS(235),
    [anon_sym_use] = ACTIONS(239),
    [anon_sym_use_BANG] = ACTIONS(241),
    [anon_sym_do_BANG] = ACTIONS(243),
    [anon_sym_begin] = ACTIONS(245),
    [aux_sym_char_token1] = ACTIONS(247),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(251),
    [anon_sym_AT_DQUOTE] = ACTIONS(253),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(255),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(257),
    [sym_bool] = ACTIONS(259),
    [sym_unit] = ACTIONS(1699),
    [anon_sym_LPAREN_PIPE] = ACTIONS(261),
    [sym_op_identifier] = ACTIONS(1701),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(265),
    [sym_xint] = ACTIONS(267),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(269),
  },
  [714] = {
    [sym_function_or_value_defn] = STATE(600),
    [sym__expression] = STATE(170),
    [sym_literal_expression] = STATE(867),
    [sym_long_identifier_or_op] = STATE(867),
    [sym_tuple_expression] = STATE(867),
    [sym_brace_expression] = STATE(867),
    [sym_anon_record_expression] = STATE(867),
    [sym_prefixed_expression] = STATE(867),
    [sym_typecast_expression] = STATE(867),
    [sym_for_expression] = STATE(867),
    [sym_while_expression] = STATE(867),
    [sym__if_branch] = STATE(6511),
    [sym_if_expression] = STATE(867),
    [sym_fun_expression] = STATE(867),
    [sym_try_expression] = STATE(867),
    [sym_match_expression] = STATE(867),
    [sym_function_expression] = STATE(867),
    [sym_mutate_expression] = STATE(867),
    [sym_index_expression] = STATE(867),
    [sym_typed_expression] = STATE(867),
    [sym_declaration_expression] = STATE(867),
    [sym_do_expression] = STATE(867),
    [sym_list_expression] = STATE(867),
    [sym_array_expression] = STATE(867),
    [sym_begin_end_expression] = STATE(867),
    [sym_paren_expression] = STATE(867),
    [sym__high_prec_app] = STATE(864),
    [sym__low_prec_app] = STATE(864),
    [sym_application_expression] = STATE(867),
    [sym_dot_expression] = STATE(867),
    [sym_infix_expression] = STATE(867),
    [sym_ce_expression] = STATE(867),
    [sym_sequential_expression] = STATE(867),
    [sym_char] = STATE(868),
    [sym_format_string] = STATE(869),
    [sym__string_literal] = STATE(869),
    [sym_string] = STATE(868),
    [sym_verbatim_string] = STATE(868),
    [sym_bytearray] = STATE(868),
    [sym_verbatim_bytearray] = STATE(868),
    [sym_format_triple_quoted_string] = STATE(870),
    [sym_triple_quoted_string] = STATE(868),
    [sym_const] = STATE(867),
    [sym_long_identifier] = STATE(872),
    [sym_active_pattern] = STATE(871),
    [sym__identifier_or_op] = STATE(873),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(656),
    [sym_sbyte] = STATE(868),
    [sym_byte] = STATE(868),
    [sym_int16] = STATE(868),
    [sym_uint16] = STATE(868),
    [sym_int32] = STATE(868),
    [sym_uint32] = STATE(868),
    [sym_nativeint] = STATE(868),
    [sym_unativeint] = STATE(868),
    [sym_int64] = STATE(868),
    [sym_uint64] = STATE(868),
    [sym_ieee32] = STATE(868),
    [sym_ieee64] = STATE(868),
    [sym_bignum] = STATE(868),
    [sym_decimal] = STATE(868),
    [sym_float] = STATE(1368),
    [sym_block_comment] = STATE(714),
    [sym_compiler_directive_decl] = STATE(714),
    [sym_fsi_directive_decl] = STATE(714),
    [sym_preproc_line] = STATE(714),
    [sym_preproc_if_in_expression] = STATE(867),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(29),
    [anon_sym_return] = ACTIONS(825),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_null] = ACTIONS(49),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACK_PIPE] = ACTIONS(57),
    [anon_sym_LBRACE] = ACTIONS(1663),
    [anon_sym_LT_AT] = ACTIONS(61),
    [anon_sym_LT_AT_AT] = ACTIONS(1665),
    [anon_sym_LBRACE_PIPE] = ACTIONS(67),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_return_BANG] = ACTIONS(829),
    [anon_sym_yield] = ACTIONS(825),
    [anon_sym_yield_BANG] = ACTIONS(829),
    [anon_sym_lazy] = ACTIONS(825),
    [anon_sym_assert] = ACTIONS(825),
    [anon_sym_upcast] = ACTIONS(825),
    [anon_sym_downcast] = ACTIONS(825),
    [anon_sym_for] = ACTIONS(73),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(79),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_match] = ACTIONS(83),
    [anon_sym_match_BANG] = ACTIONS(85),
    [anon_sym_function] = ACTIONS(87),
    [anon_sym_use] = ACTIONS(833),
    [anon_sym_use_BANG] = ACTIONS(835),
    [anon_sym_do_BANG] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(101),
    [aux_sym_char_token1] = ACTIONS(105),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(107),
    [anon_sym_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DQUOTE] = ACTIONS(111),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(115),
    [sym_bool] = ACTIONS(117),
    [sym_unit] = ACTIONS(1673),
    [anon_sym_LPAREN_PIPE] = ACTIONS(121),
    [sym_op_identifier] = ACTIONS(1675),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(837),
    [sym_xint] = ACTIONS(387),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(135),
  },
  [715] = {
    [sym_function_or_value_defn] = STATE(509),
    [sym__expression] = STATE(317),
    [sym_literal_expression] = STATE(2230),
    [sym_long_identifier_or_op] = STATE(2230),
    [sym_tuple_expression] = STATE(2230),
    [sym_brace_expression] = STATE(2230),
    [sym_anon_record_expression] = STATE(2230),
    [sym_prefixed_expression] = STATE(2230),
    [sym_typecast_expression] = STATE(2230),
    [sym_for_expression] = STATE(2230),
    [sym_while_expression] = STATE(2230),
    [sym__if_branch] = STATE(6659),
    [sym_if_expression] = STATE(2230),
    [sym_fun_expression] = STATE(2230),
    [sym_try_expression] = STATE(2230),
    [sym_match_expression] = STATE(2230),
    [sym_function_expression] = STATE(2230),
    [sym_mutate_expression] = STATE(2230),
    [sym_index_expression] = STATE(2230),
    [sym_typed_expression] = STATE(2230),
    [sym_declaration_expression] = STATE(2230),
    [sym_do_expression] = STATE(2230),
    [sym_list_expression] = STATE(2230),
    [sym_array_expression] = STATE(2230),
    [sym_begin_end_expression] = STATE(2230),
    [sym_paren_expression] = STATE(2230),
    [sym__high_prec_app] = STATE(2229),
    [sym__low_prec_app] = STATE(2229),
    [sym_application_expression] = STATE(2230),
    [sym_dot_expression] = STATE(2230),
    [sym_infix_expression] = STATE(2230),
    [sym_ce_expression] = STATE(2230),
    [sym_sequential_expression] = STATE(2230),
    [sym_char] = STATE(2100),
    [sym_format_string] = STATE(2106),
    [sym__string_literal] = STATE(2106),
    [sym_string] = STATE(2100),
    [sym_verbatim_string] = STATE(2100),
    [sym_bytearray] = STATE(2100),
    [sym_verbatim_bytearray] = STATE(2100),
    [sym_format_triple_quoted_string] = STATE(2107),
    [sym_triple_quoted_string] = STATE(2100),
    [sym_const] = STATE(2230),
    [sym_long_identifier] = STATE(2232),
    [sym_active_pattern] = STATE(2424),
    [sym__identifier_or_op] = STATE(2305),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(737),
    [sym_sbyte] = STATE(2100),
    [sym_byte] = STATE(2100),
    [sym_int16] = STATE(2100),
    [sym_uint16] = STATE(2100),
    [sym_int32] = STATE(2100),
    [sym_uint32] = STATE(2100),
    [sym_nativeint] = STATE(2100),
    [sym_unativeint] = STATE(2100),
    [sym_int64] = STATE(2100),
    [sym_uint64] = STATE(2100),
    [sym_ieee32] = STATE(2100),
    [sym_ieee64] = STATE(2100),
    [sym_bignum] = STATE(2100),
    [sym_decimal] = STATE(2100),
    [sym_float] = STATE(1487),
    [sym_block_comment] = STATE(715),
    [sym_compiler_directive_decl] = STATE(715),
    [sym_fsi_directive_decl] = STATE(715),
    [sym_preproc_line] = STATE(715),
    [sym_preproc_if_in_expression] = STATE(2230),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(877),
    [anon_sym_return] = ACTIONS(881),
    [anon_sym_do] = ACTIONS(1585),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(885),
    [anon_sym_null] = ACTIONS(889),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(891),
    [anon_sym_LBRACK_PIPE] = ACTIONS(893),
    [anon_sym_LBRACE] = ACTIONS(2048),
    [anon_sym_LT_AT] = ACTIONS(897),
    [anon_sym_LT_AT_AT] = ACTIONS(2050),
    [anon_sym_LBRACE_PIPE] = ACTIONS(903),
    [anon_sym_new] = ACTIONS(881),
    [anon_sym_return_BANG] = ACTIONS(905),
    [anon_sym_yield] = ACTIONS(881),
    [anon_sym_yield_BANG] = ACTIONS(905),
    [anon_sym_lazy] = ACTIONS(881),
    [anon_sym_assert] = ACTIONS(881),
    [anon_sym_upcast] = ACTIONS(881),
    [anon_sym_downcast] = ACTIONS(881),
    [anon_sym_for] = ACTIONS(909),
    [anon_sym_while] = ACTIONS(911),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(913),
    [anon_sym_try] = ACTIONS(915),
    [anon_sym_match] = ACTIONS(917),
    [anon_sym_match_BANG] = ACTIONS(919),
    [anon_sym_function] = ACTIONS(921),
    [anon_sym_use] = ACTIONS(929),
    [anon_sym_use_BANG] = ACTIONS(931),
    [anon_sym_do_BANG] = ACTIONS(933),
    [anon_sym_begin] = ACTIONS(937),
    [aux_sym_char_token1] = ACTIONS(941),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(943),
    [anon_sym_DQUOTE] = ACTIONS(945),
    [anon_sym_AT_DQUOTE] = ACTIONS(947),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(949),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(951),
    [sym_bool] = ACTIONS(953),
    [sym_unit] = ACTIONS(2052),
    [anon_sym_LPAREN_PIPE] = ACTIONS(957),
    [sym_op_identifier] = ACTIONS(2054),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(961),
    [sym_xint] = ACTIONS(963),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(965),
  },
  [716] = {
    [sym_function_or_value_defn] = STATE(535),
    [sym__expression] = STATE(82),
    [sym_literal_expression] = STATE(2008),
    [sym_long_identifier_or_op] = STATE(2008),
    [sym_tuple_expression] = STATE(2008),
    [sym_brace_expression] = STATE(2008),
    [sym_anon_record_expression] = STATE(2008),
    [sym_prefixed_expression] = STATE(2008),
    [sym_typecast_expression] = STATE(2008),
    [sym_for_expression] = STATE(2008),
    [sym_while_expression] = STATE(2008),
    [sym__if_branch] = STATE(6754),
    [sym_if_expression] = STATE(2008),
    [sym_fun_expression] = STATE(2008),
    [sym_try_expression] = STATE(2008),
    [sym_match_expression] = STATE(2008),
    [sym_function_expression] = STATE(2008),
    [sym_mutate_expression] = STATE(2008),
    [sym_index_expression] = STATE(2008),
    [sym_typed_expression] = STATE(2008),
    [sym_declaration_expression] = STATE(2008),
    [sym_do_expression] = STATE(2008),
    [sym_list_expression] = STATE(2008),
    [sym_array_expression] = STATE(2008),
    [sym_begin_end_expression] = STATE(2008),
    [sym_paren_expression] = STATE(2008),
    [sym__high_prec_app] = STATE(2007),
    [sym__low_prec_app] = STATE(2007),
    [sym_application_expression] = STATE(2008),
    [sym_dot_expression] = STATE(2008),
    [sym_infix_expression] = STATE(2008),
    [sym_ce_expression] = STATE(2008),
    [sym_sequential_expression] = STATE(2008),
    [sym_char] = STATE(1859),
    [sym_format_string] = STATE(1861),
    [sym__string_literal] = STATE(1861),
    [sym_string] = STATE(1859),
    [sym_verbatim_string] = STATE(1859),
    [sym_bytearray] = STATE(1859),
    [sym_verbatim_bytearray] = STATE(1859),
    [sym_format_triple_quoted_string] = STATE(1862),
    [sym_triple_quoted_string] = STATE(1859),
    [sym_const] = STATE(2008),
    [sym_long_identifier] = STATE(1701),
    [sym_active_pattern] = STATE(1702),
    [sym__identifier_or_op] = STATE(1724),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(664),
    [sym_sbyte] = STATE(1859),
    [sym_byte] = STATE(1859),
    [sym_int16] = STATE(1859),
    [sym_uint16] = STATE(1859),
    [sym_int32] = STATE(1859),
    [sym_uint32] = STATE(1859),
    [sym_nativeint] = STATE(1859),
    [sym_unativeint] = STATE(1859),
    [sym_int64] = STATE(1859),
    [sym_uint64] = STATE(1859),
    [sym_ieee32] = STATE(1859),
    [sym_ieee64] = STATE(1859),
    [sym_bignum] = STATE(1859),
    [sym_decimal] = STATE(1859),
    [sym_float] = STATE(1447),
    [sym_block_comment] = STATE(716),
    [sym_compiler_directive_decl] = STATE(716),
    [sym_fsi_directive_decl] = STATE(716),
    [sym_preproc_line] = STATE(716),
    [sym_preproc_if_in_expression] = STATE(2008),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(503),
    [anon_sym_return] = ACTIONS(507),
    [anon_sym_do] = ACTIONS(599),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(511),
    [anon_sym_null] = ACTIONS(515),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(517),
    [anon_sym_LBRACK_PIPE] = ACTIONS(519),
    [anon_sym_LBRACE] = ACTIONS(2060),
    [anon_sym_LT_AT] = ACTIONS(523),
    [anon_sym_LT_AT_AT] = ACTIONS(2062),
    [anon_sym_LBRACE_PIPE] = ACTIONS(529),
    [anon_sym_new] = ACTIONS(507),
    [anon_sym_return_BANG] = ACTIONS(531),
    [anon_sym_yield] = ACTIONS(507),
    [anon_sym_yield_BANG] = ACTIONS(531),
    [anon_sym_lazy] = ACTIONS(507),
    [anon_sym_assert] = ACTIONS(507),
    [anon_sym_upcast] = ACTIONS(507),
    [anon_sym_downcast] = ACTIONS(507),
    [anon_sym_for] = ACTIONS(535),
    [anon_sym_while] = ACTIONS(537),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(539),
    [anon_sym_try] = ACTIONS(543),
    [anon_sym_match] = ACTIONS(545),
    [anon_sym_match_BANG] = ACTIONS(547),
    [anon_sym_function] = ACTIONS(549),
    [anon_sym_use] = ACTIONS(557),
    [anon_sym_use_BANG] = ACTIONS(559),
    [anon_sym_do_BANG] = ACTIONS(561),
    [anon_sym_begin] = ACTIONS(565),
    [aux_sym_char_token1] = ACTIONS(569),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(571),
    [anon_sym_DQUOTE] = ACTIONS(573),
    [anon_sym_AT_DQUOTE] = ACTIONS(575),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(577),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(579),
    [sym_bool] = ACTIONS(581),
    [sym_unit] = ACTIONS(2064),
    [anon_sym_LPAREN_PIPE] = ACTIONS(585),
    [sym_op_identifier] = ACTIONS(2066),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(589),
    [sym_xint] = ACTIONS(591),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(593),
  },
  [717] = {
    [sym_function_or_value_defn] = STATE(651),
    [sym__expression] = STATE(173),
    [sym_literal_expression] = STATE(2168),
    [sym_long_identifier_or_op] = STATE(2168),
    [sym_tuple_expression] = STATE(2168),
    [sym_brace_expression] = STATE(2168),
    [sym_anon_record_expression] = STATE(2168),
    [sym_prefixed_expression] = STATE(2168),
    [sym_typecast_expression] = STATE(2168),
    [sym_for_expression] = STATE(2168),
    [sym_while_expression] = STATE(2168),
    [sym__if_branch] = STATE(6406),
    [sym_if_expression] = STATE(2168),
    [sym_fun_expression] = STATE(2168),
    [sym_try_expression] = STATE(2168),
    [sym_match_expression] = STATE(2168),
    [sym_function_expression] = STATE(2168),
    [sym_mutate_expression] = STATE(2168),
    [sym_index_expression] = STATE(2168),
    [sym_typed_expression] = STATE(2168),
    [sym_declaration_expression] = STATE(2168),
    [sym_do_expression] = STATE(2168),
    [sym_list_expression] = STATE(2168),
    [sym_array_expression] = STATE(2168),
    [sym_begin_end_expression] = STATE(2168),
    [sym_paren_expression] = STATE(2168),
    [sym__high_prec_app] = STATE(2179),
    [sym__low_prec_app] = STATE(2179),
    [sym_application_expression] = STATE(2168),
    [sym_dot_expression] = STATE(2168),
    [sym_infix_expression] = STATE(2168),
    [sym_ce_expression] = STATE(2168),
    [sym_sequential_expression] = STATE(2168),
    [sym_char] = STATE(2469),
    [sym_format_string] = STATE(2412),
    [sym__string_literal] = STATE(2412),
    [sym_string] = STATE(2469),
    [sym_verbatim_string] = STATE(2469),
    [sym_bytearray] = STATE(2469),
    [sym_verbatim_bytearray] = STATE(2469),
    [sym_format_triple_quoted_string] = STATE(2408),
    [sym_triple_quoted_string] = STATE(2469),
    [sym_const] = STATE(2168),
    [sym_long_identifier] = STATE(2183),
    [sym_active_pattern] = STATE(2182),
    [sym__identifier_or_op] = STATE(2093),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(650),
    [sym_sbyte] = STATE(2469),
    [sym_byte] = STATE(2469),
    [sym_int16] = STATE(2469),
    [sym_uint16] = STATE(2469),
    [sym_int32] = STATE(2469),
    [sym_uint32] = STATE(2469),
    [sym_nativeint] = STATE(2469),
    [sym_unativeint] = STATE(2469),
    [sym_int64] = STATE(2469),
    [sym_uint64] = STATE(2469),
    [sym_ieee32] = STATE(2469),
    [sym_ieee64] = STATE(2469),
    [sym_bignum] = STATE(2469),
    [sym_decimal] = STATE(2469),
    [sym_float] = STATE(1586),
    [sym_block_comment] = STATE(717),
    [sym_compiler_directive_decl] = STATE(717),
    [sym_fsi_directive_decl] = STATE(717),
    [sym_preproc_line] = STATE(717),
    [sym_preproc_if_in_expression] = STATE(2168),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(989),
    [anon_sym_return] = ACTIONS(993),
    [anon_sym_do] = ACTIONS(995),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(997),
    [anon_sym_null] = ACTIONS(1001),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1003),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1005),
    [anon_sym_LBRACE] = ACTIONS(2070),
    [anon_sym_LT_AT] = ACTIONS(1009),
    [anon_sym_LT_AT_AT] = ACTIONS(2072),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1017),
    [anon_sym_new] = ACTIONS(993),
    [anon_sym_return_BANG] = ACTIONS(1019),
    [anon_sym_yield] = ACTIONS(993),
    [anon_sym_yield_BANG] = ACTIONS(1019),
    [anon_sym_lazy] = ACTIONS(993),
    [anon_sym_assert] = ACTIONS(993),
    [anon_sym_upcast] = ACTIONS(993),
    [anon_sym_downcast] = ACTIONS(993),
    [anon_sym_for] = ACTIONS(1023),
    [anon_sym_while] = ACTIONS(1025),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(1027),
    [anon_sym_try] = ACTIONS(1029),
    [anon_sym_match] = ACTIONS(1031),
    [anon_sym_match_BANG] = ACTIONS(1033),
    [anon_sym_function] = ACTIONS(1035),
    [anon_sym_use] = ACTIONS(1043),
    [anon_sym_use_BANG] = ACTIONS(1045),
    [anon_sym_do_BANG] = ACTIONS(1047),
    [anon_sym_begin] = ACTIONS(1049),
    [aux_sym_char_token1] = ACTIONS(1053),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1055),
    [anon_sym_DQUOTE] = ACTIONS(1057),
    [anon_sym_AT_DQUOTE] = ACTIONS(1059),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1061),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1063),
    [sym_bool] = ACTIONS(1065),
    [sym_unit] = ACTIONS(2074),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1069),
    [sym_op_identifier] = ACTIONS(2076),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(1073),
    [sym_xint] = ACTIONS(1075),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1077),
  },
  [718] = {
    [sym_function_or_value_defn] = STATE(600),
    [sym__expression] = STATE(282),
    [sym_literal_expression] = STATE(867),
    [sym_long_identifier_or_op] = STATE(867),
    [sym_tuple_expression] = STATE(867),
    [sym_brace_expression] = STATE(867),
    [sym_anon_record_expression] = STATE(867),
    [sym_prefixed_expression] = STATE(867),
    [sym_typecast_expression] = STATE(867),
    [sym_for_expression] = STATE(867),
    [sym_while_expression] = STATE(867),
    [sym__if_branch] = STATE(6511),
    [sym_if_expression] = STATE(867),
    [sym_fun_expression] = STATE(867),
    [sym_try_expression] = STATE(867),
    [sym_match_expression] = STATE(867),
    [sym_function_expression] = STATE(867),
    [sym_mutate_expression] = STATE(867),
    [sym_index_expression] = STATE(867),
    [sym_typed_expression] = STATE(867),
    [sym_declaration_expression] = STATE(867),
    [sym_do_expression] = STATE(867),
    [sym_list_expression] = STATE(867),
    [sym_array_expression] = STATE(867),
    [sym_begin_end_expression] = STATE(867),
    [sym_paren_expression] = STATE(867),
    [sym__high_prec_app] = STATE(864),
    [sym__low_prec_app] = STATE(864),
    [sym_application_expression] = STATE(867),
    [sym_dot_expression] = STATE(867),
    [sym_infix_expression] = STATE(867),
    [sym_ce_expression] = STATE(867),
    [sym_sequential_expression] = STATE(867),
    [sym_char] = STATE(868),
    [sym_format_string] = STATE(869),
    [sym__string_literal] = STATE(869),
    [sym_string] = STATE(868),
    [sym_verbatim_string] = STATE(868),
    [sym_bytearray] = STATE(868),
    [sym_verbatim_bytearray] = STATE(868),
    [sym_format_triple_quoted_string] = STATE(870),
    [sym_triple_quoted_string] = STATE(868),
    [sym_const] = STATE(867),
    [sym_long_identifier] = STATE(872),
    [sym_active_pattern] = STATE(871),
    [sym__identifier_or_op] = STATE(873),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(656),
    [sym_sbyte] = STATE(868),
    [sym_byte] = STATE(868),
    [sym_int16] = STATE(868),
    [sym_uint16] = STATE(868),
    [sym_int32] = STATE(868),
    [sym_uint32] = STATE(868),
    [sym_nativeint] = STATE(868),
    [sym_unativeint] = STATE(868),
    [sym_int64] = STATE(868),
    [sym_uint64] = STATE(868),
    [sym_ieee32] = STATE(868),
    [sym_ieee64] = STATE(868),
    [sym_bignum] = STATE(868),
    [sym_decimal] = STATE(868),
    [sym_float] = STATE(1368),
    [sym_block_comment] = STATE(718),
    [sym_compiler_directive_decl] = STATE(718),
    [sym_fsi_directive_decl] = STATE(718),
    [sym_preproc_line] = STATE(718),
    [sym_preproc_if_in_expression] = STATE(867),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(29),
    [anon_sym_return] = ACTIONS(825),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_null] = ACTIONS(49),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACK_PIPE] = ACTIONS(57),
    [anon_sym_LBRACE] = ACTIONS(1663),
    [anon_sym_LT_AT] = ACTIONS(61),
    [anon_sym_LT_AT_AT] = ACTIONS(1665),
    [anon_sym_LBRACE_PIPE] = ACTIONS(67),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_return_BANG] = ACTIONS(829),
    [anon_sym_yield] = ACTIONS(825),
    [anon_sym_yield_BANG] = ACTIONS(829),
    [anon_sym_lazy] = ACTIONS(825),
    [anon_sym_assert] = ACTIONS(825),
    [anon_sym_upcast] = ACTIONS(825),
    [anon_sym_downcast] = ACTIONS(825),
    [anon_sym_for] = ACTIONS(73),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(79),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_match] = ACTIONS(83),
    [anon_sym_match_BANG] = ACTIONS(85),
    [anon_sym_function] = ACTIONS(87),
    [anon_sym_use] = ACTIONS(833),
    [anon_sym_use_BANG] = ACTIONS(835),
    [anon_sym_do_BANG] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(101),
    [aux_sym_char_token1] = ACTIONS(105),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(107),
    [anon_sym_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DQUOTE] = ACTIONS(111),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(115),
    [sym_bool] = ACTIONS(117),
    [sym_unit] = ACTIONS(1673),
    [anon_sym_LPAREN_PIPE] = ACTIONS(121),
    [sym_op_identifier] = ACTIONS(1675),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(837),
    [sym_xint] = ACTIONS(387),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(135),
  },
  [719] = {
    [sym_function_or_value_defn] = STATE(600),
    [sym__expression] = STATE(198),
    [sym_literal_expression] = STATE(867),
    [sym_long_identifier_or_op] = STATE(867),
    [sym_tuple_expression] = STATE(867),
    [sym_brace_expression] = STATE(867),
    [sym_anon_record_expression] = STATE(867),
    [sym_prefixed_expression] = STATE(867),
    [sym_typecast_expression] = STATE(867),
    [sym_for_expression] = STATE(867),
    [sym_while_expression] = STATE(867),
    [sym__if_branch] = STATE(6511),
    [sym_if_expression] = STATE(867),
    [sym_fun_expression] = STATE(867),
    [sym_try_expression] = STATE(867),
    [sym_match_expression] = STATE(867),
    [sym_function_expression] = STATE(867),
    [sym_mutate_expression] = STATE(867),
    [sym_index_expression] = STATE(867),
    [sym_typed_expression] = STATE(867),
    [sym_declaration_expression] = STATE(867),
    [sym_do_expression] = STATE(867),
    [sym_list_expression] = STATE(867),
    [sym_array_expression] = STATE(867),
    [sym_begin_end_expression] = STATE(867),
    [sym_paren_expression] = STATE(867),
    [sym__high_prec_app] = STATE(864),
    [sym__low_prec_app] = STATE(864),
    [sym_application_expression] = STATE(867),
    [sym_dot_expression] = STATE(867),
    [sym_infix_expression] = STATE(867),
    [sym_ce_expression] = STATE(867),
    [sym_sequential_expression] = STATE(867),
    [sym_char] = STATE(868),
    [sym_format_string] = STATE(869),
    [sym__string_literal] = STATE(869),
    [sym_string] = STATE(868),
    [sym_verbatim_string] = STATE(868),
    [sym_bytearray] = STATE(868),
    [sym_verbatim_bytearray] = STATE(868),
    [sym_format_triple_quoted_string] = STATE(870),
    [sym_triple_quoted_string] = STATE(868),
    [sym_const] = STATE(867),
    [sym_long_identifier] = STATE(872),
    [sym_active_pattern] = STATE(871),
    [sym__identifier_or_op] = STATE(873),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(656),
    [sym_sbyte] = STATE(868),
    [sym_byte] = STATE(868),
    [sym_int16] = STATE(868),
    [sym_uint16] = STATE(868),
    [sym_int32] = STATE(868),
    [sym_uint32] = STATE(868),
    [sym_nativeint] = STATE(868),
    [sym_unativeint] = STATE(868),
    [sym_int64] = STATE(868),
    [sym_uint64] = STATE(868),
    [sym_ieee32] = STATE(868),
    [sym_ieee64] = STATE(868),
    [sym_bignum] = STATE(868),
    [sym_decimal] = STATE(868),
    [sym_float] = STATE(1368),
    [sym_block_comment] = STATE(719),
    [sym_compiler_directive_decl] = STATE(719),
    [sym_fsi_directive_decl] = STATE(719),
    [sym_preproc_line] = STATE(719),
    [sym_preproc_if_in_expression] = STATE(867),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(29),
    [anon_sym_return] = ACTIONS(825),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_null] = ACTIONS(49),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACK_PIPE] = ACTIONS(57),
    [anon_sym_LBRACE] = ACTIONS(1663),
    [anon_sym_LT_AT] = ACTIONS(61),
    [anon_sym_LT_AT_AT] = ACTIONS(1665),
    [anon_sym_LBRACE_PIPE] = ACTIONS(67),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_return_BANG] = ACTIONS(829),
    [anon_sym_yield] = ACTIONS(825),
    [anon_sym_yield_BANG] = ACTIONS(829),
    [anon_sym_lazy] = ACTIONS(825),
    [anon_sym_assert] = ACTIONS(825),
    [anon_sym_upcast] = ACTIONS(825),
    [anon_sym_downcast] = ACTIONS(825),
    [anon_sym_for] = ACTIONS(73),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(79),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_match] = ACTIONS(83),
    [anon_sym_match_BANG] = ACTIONS(85),
    [anon_sym_function] = ACTIONS(87),
    [anon_sym_use] = ACTIONS(833),
    [anon_sym_use_BANG] = ACTIONS(835),
    [anon_sym_do_BANG] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(101),
    [aux_sym_char_token1] = ACTIONS(105),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(107),
    [anon_sym_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DQUOTE] = ACTIONS(111),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(115),
    [sym_bool] = ACTIONS(117),
    [sym_unit] = ACTIONS(1673),
    [anon_sym_LPAREN_PIPE] = ACTIONS(121),
    [sym_op_identifier] = ACTIONS(1675),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(837),
    [sym_xint] = ACTIONS(387),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(135),
  },
  [720] = {
    [sym_function_or_value_defn] = STATE(627),
    [sym__expression] = STATE(54),
    [sym_literal_expression] = STATE(1118),
    [sym_long_identifier_or_op] = STATE(1118),
    [sym_tuple_expression] = STATE(1118),
    [sym_brace_expression] = STATE(1118),
    [sym_anon_record_expression] = STATE(1118),
    [sym_prefixed_expression] = STATE(1118),
    [sym_typecast_expression] = STATE(1118),
    [sym_for_expression] = STATE(1118),
    [sym_while_expression] = STATE(1118),
    [sym__if_branch] = STATE(7163),
    [sym_if_expression] = STATE(1118),
    [sym_fun_expression] = STATE(1118),
    [sym_try_expression] = STATE(1118),
    [sym_match_expression] = STATE(1118),
    [sym_function_expression] = STATE(1118),
    [sym_mutate_expression] = STATE(1118),
    [sym_index_expression] = STATE(1118),
    [sym_typed_expression] = STATE(1118),
    [sym_declaration_expression] = STATE(1118),
    [sym_do_expression] = STATE(1118),
    [sym_list_expression] = STATE(1118),
    [sym_array_expression] = STATE(1118),
    [sym_begin_end_expression] = STATE(1118),
    [sym_paren_expression] = STATE(1118),
    [sym__high_prec_app] = STATE(1133),
    [sym__low_prec_app] = STATE(1133),
    [sym_application_expression] = STATE(1118),
    [sym_dot_expression] = STATE(1118),
    [sym_infix_expression] = STATE(1118),
    [sym_ce_expression] = STATE(1118),
    [sym_sequential_expression] = STATE(1118),
    [sym_char] = STATE(1080),
    [sym_format_string] = STATE(1090),
    [sym__string_literal] = STATE(1090),
    [sym_string] = STATE(1080),
    [sym_verbatim_string] = STATE(1080),
    [sym_bytearray] = STATE(1080),
    [sym_verbatim_bytearray] = STATE(1080),
    [sym_format_triple_quoted_string] = STATE(1096),
    [sym_triple_quoted_string] = STATE(1080),
    [sym_const] = STATE(1118),
    [sym_long_identifier] = STATE(1156),
    [sym_active_pattern] = STATE(1085),
    [sym__identifier_or_op] = STATE(1099),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(517),
    [sym_sbyte] = STATE(1080),
    [sym_byte] = STATE(1080),
    [sym_int16] = STATE(1080),
    [sym_uint16] = STATE(1080),
    [sym_int32] = STATE(1080),
    [sym_uint32] = STATE(1080),
    [sym_nativeint] = STATE(1080),
    [sym_unativeint] = STATE(1080),
    [sym_int64] = STATE(1080),
    [sym_uint64] = STATE(1080),
    [sym_ieee32] = STATE(1080),
    [sym_ieee64] = STATE(1080),
    [sym_bignum] = STATE(1080),
    [sym_decimal] = STATE(1080),
    [sym_float] = STATE(979),
    [sym_block_comment] = STATE(720),
    [sym_compiler_directive_decl] = STATE(720),
    [sym_fsi_directive_decl] = STATE(720),
    [sym_preproc_line] = STATE(720),
    [sym_preproc_if_in_expression] = STATE(1118),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(195),
    [anon_sym_return] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_null] = ACTIONS(207),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(209),
    [anon_sym_LBRACK_PIPE] = ACTIONS(211),
    [anon_sym_LBRACE] = ACTIONS(1687),
    [anon_sym_LT_AT] = ACTIONS(213),
    [anon_sym_LT_AT_AT] = ACTIONS(1689),
    [anon_sym_LBRACE_PIPE] = ACTIONS(217),
    [anon_sym_new] = ACTIONS(199),
    [anon_sym_return_BANG] = ACTIONS(219),
    [anon_sym_yield] = ACTIONS(199),
    [anon_sym_yield_BANG] = ACTIONS(219),
    [anon_sym_lazy] = ACTIONS(199),
    [anon_sym_assert] = ACTIONS(199),
    [anon_sym_upcast] = ACTIONS(199),
    [anon_sym_downcast] = ACTIONS(199),
    [anon_sym_for] = ACTIONS(223),
    [anon_sym_while] = ACTIONS(225),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(229),
    [anon_sym_match] = ACTIONS(231),
    [anon_sym_match_BANG] = ACTIONS(233),
    [anon_sym_function] = ACTIONS(235),
    [anon_sym_use] = ACTIONS(239),
    [anon_sym_use_BANG] = ACTIONS(241),
    [anon_sym_do_BANG] = ACTIONS(243),
    [anon_sym_begin] = ACTIONS(245),
    [aux_sym_char_token1] = ACTIONS(247),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(251),
    [anon_sym_AT_DQUOTE] = ACTIONS(253),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(255),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(257),
    [sym_bool] = ACTIONS(259),
    [sym_unit] = ACTIONS(1699),
    [anon_sym_LPAREN_PIPE] = ACTIONS(261),
    [sym_op_identifier] = ACTIONS(1701),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(265),
    [sym_xint] = ACTIONS(267),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(269),
  },
  [721] = {
    [sym_function_or_value_defn] = STATE(651),
    [sym__expression] = STATE(185),
    [sym_literal_expression] = STATE(2168),
    [sym_long_identifier_or_op] = STATE(2168),
    [sym_tuple_expression] = STATE(2168),
    [sym_brace_expression] = STATE(2168),
    [sym_anon_record_expression] = STATE(2168),
    [sym_prefixed_expression] = STATE(2168),
    [sym_typecast_expression] = STATE(2168),
    [sym_for_expression] = STATE(2168),
    [sym_while_expression] = STATE(2168),
    [sym__if_branch] = STATE(6406),
    [sym_if_expression] = STATE(2168),
    [sym_fun_expression] = STATE(2168),
    [sym_try_expression] = STATE(2168),
    [sym_match_expression] = STATE(2168),
    [sym_function_expression] = STATE(2168),
    [sym_mutate_expression] = STATE(2168),
    [sym_index_expression] = STATE(2168),
    [sym_typed_expression] = STATE(2168),
    [sym_declaration_expression] = STATE(2168),
    [sym_do_expression] = STATE(2168),
    [sym_list_expression] = STATE(2168),
    [sym_array_expression] = STATE(2168),
    [sym_begin_end_expression] = STATE(2168),
    [sym_paren_expression] = STATE(2168),
    [sym__high_prec_app] = STATE(2179),
    [sym__low_prec_app] = STATE(2179),
    [sym_application_expression] = STATE(2168),
    [sym_dot_expression] = STATE(2168),
    [sym_infix_expression] = STATE(2168),
    [sym_ce_expression] = STATE(2168),
    [sym_sequential_expression] = STATE(2168),
    [sym_char] = STATE(2469),
    [sym_format_string] = STATE(2412),
    [sym__string_literal] = STATE(2412),
    [sym_string] = STATE(2469),
    [sym_verbatim_string] = STATE(2469),
    [sym_bytearray] = STATE(2469),
    [sym_verbatim_bytearray] = STATE(2469),
    [sym_format_triple_quoted_string] = STATE(2408),
    [sym_triple_quoted_string] = STATE(2469),
    [sym_const] = STATE(2168),
    [sym_long_identifier] = STATE(2183),
    [sym_active_pattern] = STATE(2182),
    [sym__identifier_or_op] = STATE(2093),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(650),
    [sym_sbyte] = STATE(2469),
    [sym_byte] = STATE(2469),
    [sym_int16] = STATE(2469),
    [sym_uint16] = STATE(2469),
    [sym_int32] = STATE(2469),
    [sym_uint32] = STATE(2469),
    [sym_nativeint] = STATE(2469),
    [sym_unativeint] = STATE(2469),
    [sym_int64] = STATE(2469),
    [sym_uint64] = STATE(2469),
    [sym_ieee32] = STATE(2469),
    [sym_ieee64] = STATE(2469),
    [sym_bignum] = STATE(2469),
    [sym_decimal] = STATE(2469),
    [sym_float] = STATE(1586),
    [sym_block_comment] = STATE(721),
    [sym_compiler_directive_decl] = STATE(721),
    [sym_fsi_directive_decl] = STATE(721),
    [sym_preproc_line] = STATE(721),
    [sym_preproc_if_in_expression] = STATE(2168),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(989),
    [anon_sym_return] = ACTIONS(993),
    [anon_sym_do] = ACTIONS(995),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(997),
    [anon_sym_null] = ACTIONS(1001),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1003),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1005),
    [anon_sym_LBRACE] = ACTIONS(2070),
    [anon_sym_LT_AT] = ACTIONS(1009),
    [anon_sym_LT_AT_AT] = ACTIONS(2072),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1017),
    [anon_sym_new] = ACTIONS(993),
    [anon_sym_return_BANG] = ACTIONS(1019),
    [anon_sym_yield] = ACTIONS(993),
    [anon_sym_yield_BANG] = ACTIONS(1019),
    [anon_sym_lazy] = ACTIONS(993),
    [anon_sym_assert] = ACTIONS(993),
    [anon_sym_upcast] = ACTIONS(993),
    [anon_sym_downcast] = ACTIONS(993),
    [anon_sym_for] = ACTIONS(1023),
    [anon_sym_while] = ACTIONS(1025),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(1027),
    [anon_sym_try] = ACTIONS(1029),
    [anon_sym_match] = ACTIONS(1031),
    [anon_sym_match_BANG] = ACTIONS(1033),
    [anon_sym_function] = ACTIONS(1035),
    [anon_sym_use] = ACTIONS(1043),
    [anon_sym_use_BANG] = ACTIONS(1045),
    [anon_sym_do_BANG] = ACTIONS(1047),
    [anon_sym_begin] = ACTIONS(1049),
    [aux_sym_char_token1] = ACTIONS(1053),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1055),
    [anon_sym_DQUOTE] = ACTIONS(1057),
    [anon_sym_AT_DQUOTE] = ACTIONS(1059),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1061),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1063),
    [sym_bool] = ACTIONS(1065),
    [sym_unit] = ACTIONS(2074),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1069),
    [sym_op_identifier] = ACTIONS(2076),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(1073),
    [sym_xint] = ACTIONS(1075),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1077),
  },
  [722] = {
    [sym_function_or_value_defn] = STATE(651),
    [sym__expression] = STATE(150),
    [sym_literal_expression] = STATE(2168),
    [sym_long_identifier_or_op] = STATE(2168),
    [sym_tuple_expression] = STATE(2168),
    [sym_brace_expression] = STATE(2168),
    [sym_anon_record_expression] = STATE(2168),
    [sym_prefixed_expression] = STATE(2168),
    [sym_typecast_expression] = STATE(2168),
    [sym_for_expression] = STATE(2168),
    [sym_while_expression] = STATE(2168),
    [sym__if_branch] = STATE(6406),
    [sym_if_expression] = STATE(2168),
    [sym_fun_expression] = STATE(2168),
    [sym_try_expression] = STATE(2168),
    [sym_match_expression] = STATE(2168),
    [sym_function_expression] = STATE(2168),
    [sym_mutate_expression] = STATE(2168),
    [sym_index_expression] = STATE(2168),
    [sym_typed_expression] = STATE(2168),
    [sym_declaration_expression] = STATE(2168),
    [sym_do_expression] = STATE(2168),
    [sym_list_expression] = STATE(2168),
    [sym_array_expression] = STATE(2168),
    [sym_begin_end_expression] = STATE(2168),
    [sym_paren_expression] = STATE(2168),
    [sym__high_prec_app] = STATE(2179),
    [sym__low_prec_app] = STATE(2179),
    [sym_application_expression] = STATE(2168),
    [sym_dot_expression] = STATE(2168),
    [sym_infix_expression] = STATE(2168),
    [sym_ce_expression] = STATE(2168),
    [sym_sequential_expression] = STATE(2168),
    [sym_char] = STATE(2469),
    [sym_format_string] = STATE(2412),
    [sym__string_literal] = STATE(2412),
    [sym_string] = STATE(2469),
    [sym_verbatim_string] = STATE(2469),
    [sym_bytearray] = STATE(2469),
    [sym_verbatim_bytearray] = STATE(2469),
    [sym_format_triple_quoted_string] = STATE(2408),
    [sym_triple_quoted_string] = STATE(2469),
    [sym_const] = STATE(2168),
    [sym_long_identifier] = STATE(2183),
    [sym_active_pattern] = STATE(2182),
    [sym__identifier_or_op] = STATE(2093),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(650),
    [sym_sbyte] = STATE(2469),
    [sym_byte] = STATE(2469),
    [sym_int16] = STATE(2469),
    [sym_uint16] = STATE(2469),
    [sym_int32] = STATE(2469),
    [sym_uint32] = STATE(2469),
    [sym_nativeint] = STATE(2469),
    [sym_unativeint] = STATE(2469),
    [sym_int64] = STATE(2469),
    [sym_uint64] = STATE(2469),
    [sym_ieee32] = STATE(2469),
    [sym_ieee64] = STATE(2469),
    [sym_bignum] = STATE(2469),
    [sym_decimal] = STATE(2469),
    [sym_float] = STATE(1586),
    [sym_block_comment] = STATE(722),
    [sym_compiler_directive_decl] = STATE(722),
    [sym_fsi_directive_decl] = STATE(722),
    [sym_preproc_line] = STATE(722),
    [sym_preproc_if_in_expression] = STATE(2168),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(989),
    [anon_sym_return] = ACTIONS(993),
    [anon_sym_do] = ACTIONS(995),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(997),
    [anon_sym_null] = ACTIONS(1001),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1003),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1005),
    [anon_sym_LBRACE] = ACTIONS(2070),
    [anon_sym_LT_AT] = ACTIONS(1009),
    [anon_sym_LT_AT_AT] = ACTIONS(2072),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1017),
    [anon_sym_new] = ACTIONS(993),
    [anon_sym_return_BANG] = ACTIONS(1019),
    [anon_sym_yield] = ACTIONS(993),
    [anon_sym_yield_BANG] = ACTIONS(1019),
    [anon_sym_lazy] = ACTIONS(993),
    [anon_sym_assert] = ACTIONS(993),
    [anon_sym_upcast] = ACTIONS(993),
    [anon_sym_downcast] = ACTIONS(993),
    [anon_sym_for] = ACTIONS(1023),
    [anon_sym_while] = ACTIONS(1025),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(1027),
    [anon_sym_try] = ACTIONS(1029),
    [anon_sym_match] = ACTIONS(1031),
    [anon_sym_match_BANG] = ACTIONS(1033),
    [anon_sym_function] = ACTIONS(1035),
    [anon_sym_use] = ACTIONS(1043),
    [anon_sym_use_BANG] = ACTIONS(1045),
    [anon_sym_do_BANG] = ACTIONS(1047),
    [anon_sym_begin] = ACTIONS(1049),
    [aux_sym_char_token1] = ACTIONS(1053),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1055),
    [anon_sym_DQUOTE] = ACTIONS(1057),
    [anon_sym_AT_DQUOTE] = ACTIONS(1059),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1061),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1063),
    [sym_bool] = ACTIONS(1065),
    [sym_unit] = ACTIONS(2074),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1069),
    [sym_op_identifier] = ACTIONS(2076),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(1073),
    [sym_xint] = ACTIONS(1075),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1077),
  },
  [723] = {
    [sym_function_or_value_defn] = STATE(532),
    [sym__expression] = STATE(122),
    [sym_literal_expression] = STATE(2000),
    [sym_long_identifier_or_op] = STATE(2000),
    [sym_tuple_expression] = STATE(2000),
    [sym_brace_expression] = STATE(2000),
    [sym_anon_record_expression] = STATE(2000),
    [sym_prefixed_expression] = STATE(2000),
    [sym_typecast_expression] = STATE(2000),
    [sym_for_expression] = STATE(2000),
    [sym_while_expression] = STATE(2000),
    [sym__if_branch] = STATE(6707),
    [sym_if_expression] = STATE(2000),
    [sym_fun_expression] = STATE(2000),
    [sym_try_expression] = STATE(2000),
    [sym_match_expression] = STATE(2000),
    [sym_function_expression] = STATE(2000),
    [sym_mutate_expression] = STATE(2000),
    [sym_index_expression] = STATE(2000),
    [sym_typed_expression] = STATE(2000),
    [sym_declaration_expression] = STATE(2000),
    [sym_do_expression] = STATE(2000),
    [sym_list_expression] = STATE(2000),
    [sym_array_expression] = STATE(2000),
    [sym_begin_end_expression] = STATE(2000),
    [sym_paren_expression] = STATE(2000),
    [sym__high_prec_app] = STATE(2003),
    [sym__low_prec_app] = STATE(2003),
    [sym_application_expression] = STATE(2000),
    [sym_dot_expression] = STATE(2000),
    [sym_infix_expression] = STATE(2000),
    [sym_ce_expression] = STATE(2000),
    [sym_sequential_expression] = STATE(2000),
    [sym_char] = STATE(1801),
    [sym_format_string] = STATE(1804),
    [sym__string_literal] = STATE(1804),
    [sym_string] = STATE(1801),
    [sym_verbatim_string] = STATE(1801),
    [sym_bytearray] = STATE(1801),
    [sym_verbatim_bytearray] = STATE(1801),
    [sym_format_triple_quoted_string] = STATE(1807),
    [sym_triple_quoted_string] = STATE(1801),
    [sym_const] = STATE(2000),
    [sym_long_identifier] = STATE(1725),
    [sym_active_pattern] = STATE(1726),
    [sym__identifier_or_op] = STATE(1751),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(723),
    [sym_sbyte] = STATE(1801),
    [sym_byte] = STATE(1801),
    [sym_int16] = STATE(1801),
    [sym_uint16] = STATE(1801),
    [sym_int32] = STATE(1801),
    [sym_uint32] = STATE(1801),
    [sym_nativeint] = STATE(1801),
    [sym_unativeint] = STATE(1801),
    [sym_int64] = STATE(1801),
    [sym_uint64] = STATE(1801),
    [sym_ieee32] = STATE(1801),
    [sym_ieee64] = STATE(1801),
    [sym_bignum] = STATE(1801),
    [sym_decimal] = STATE(1801),
    [sym_float] = STATE(1427),
    [sym_block_comment] = STATE(723),
    [sym_compiler_directive_decl] = STATE(723),
    [sym_fsi_directive_decl] = STATE(723),
    [sym_preproc_line] = STATE(723),
    [sym_preproc_if_in_expression] = STATE(2000),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(629),
    [anon_sym_return] = ACTIONS(633),
    [anon_sym_do] = ACTIONS(635),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(637),
    [anon_sym_null] = ACTIONS(641),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(643),
    [anon_sym_LBRACK_PIPE] = ACTIONS(645),
    [anon_sym_LBRACE] = ACTIONS(1713),
    [anon_sym_LT_AT] = ACTIONS(647),
    [anon_sym_LT_AT_AT] = ACTIONS(1715),
    [anon_sym_LBRACE_PIPE] = ACTIONS(653),
    [anon_sym_new] = ACTIONS(633),
    [anon_sym_return_BANG] = ACTIONS(655),
    [anon_sym_yield] = ACTIONS(633),
    [anon_sym_yield_BANG] = ACTIONS(655),
    [anon_sym_lazy] = ACTIONS(633),
    [anon_sym_assert] = ACTIONS(633),
    [anon_sym_upcast] = ACTIONS(633),
    [anon_sym_downcast] = ACTIONS(633),
    [anon_sym_for] = ACTIONS(659),
    [anon_sym_while] = ACTIONS(661),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(663),
    [anon_sym_try] = ACTIONS(665),
    [anon_sym_match] = ACTIONS(667),
    [anon_sym_match_BANG] = ACTIONS(669),
    [anon_sym_function] = ACTIONS(671),
    [anon_sym_use] = ACTIONS(679),
    [anon_sym_use_BANG] = ACTIONS(681),
    [anon_sym_do_BANG] = ACTIONS(683),
    [anon_sym_begin] = ACTIONS(685),
    [aux_sym_char_token1] = ACTIONS(689),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(691),
    [anon_sym_DQUOTE] = ACTIONS(693),
    [anon_sym_AT_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(697),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(699),
    [sym_bool] = ACTIONS(701),
    [sym_unit] = ACTIONS(1717),
    [anon_sym_LPAREN_PIPE] = ACTIONS(705),
    [sym_op_identifier] = ACTIONS(1719),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(709),
    [sym_xint] = ACTIONS(711),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(713),
  },
  [724] = {
    [sym_function_or_value_defn] = STATE(651),
    [sym__expression] = STATE(184),
    [sym_literal_expression] = STATE(2168),
    [sym_long_identifier_or_op] = STATE(2168),
    [sym_tuple_expression] = STATE(2168),
    [sym_brace_expression] = STATE(2168),
    [sym_anon_record_expression] = STATE(2168),
    [sym_prefixed_expression] = STATE(2168),
    [sym_typecast_expression] = STATE(2168),
    [sym_for_expression] = STATE(2168),
    [sym_while_expression] = STATE(2168),
    [sym__if_branch] = STATE(6406),
    [sym_if_expression] = STATE(2168),
    [sym_fun_expression] = STATE(2168),
    [sym_try_expression] = STATE(2168),
    [sym_match_expression] = STATE(2168),
    [sym_function_expression] = STATE(2168),
    [sym_mutate_expression] = STATE(2168),
    [sym_index_expression] = STATE(2168),
    [sym_typed_expression] = STATE(2168),
    [sym_declaration_expression] = STATE(2168),
    [sym_do_expression] = STATE(2168),
    [sym_list_expression] = STATE(2168),
    [sym_array_expression] = STATE(2168),
    [sym_begin_end_expression] = STATE(2168),
    [sym_paren_expression] = STATE(2168),
    [sym__high_prec_app] = STATE(2179),
    [sym__low_prec_app] = STATE(2179),
    [sym_application_expression] = STATE(2168),
    [sym_dot_expression] = STATE(2168),
    [sym_infix_expression] = STATE(2168),
    [sym_ce_expression] = STATE(2168),
    [sym_sequential_expression] = STATE(2168),
    [sym_char] = STATE(2469),
    [sym_format_string] = STATE(2412),
    [sym__string_literal] = STATE(2412),
    [sym_string] = STATE(2469),
    [sym_verbatim_string] = STATE(2469),
    [sym_bytearray] = STATE(2469),
    [sym_verbatim_bytearray] = STATE(2469),
    [sym_format_triple_quoted_string] = STATE(2408),
    [sym_triple_quoted_string] = STATE(2469),
    [sym_const] = STATE(2168),
    [sym_long_identifier] = STATE(2183),
    [sym_active_pattern] = STATE(2182),
    [sym__identifier_or_op] = STATE(2093),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(650),
    [sym_sbyte] = STATE(2469),
    [sym_byte] = STATE(2469),
    [sym_int16] = STATE(2469),
    [sym_uint16] = STATE(2469),
    [sym_int32] = STATE(2469),
    [sym_uint32] = STATE(2469),
    [sym_nativeint] = STATE(2469),
    [sym_unativeint] = STATE(2469),
    [sym_int64] = STATE(2469),
    [sym_uint64] = STATE(2469),
    [sym_ieee32] = STATE(2469),
    [sym_ieee64] = STATE(2469),
    [sym_bignum] = STATE(2469),
    [sym_decimal] = STATE(2469),
    [sym_float] = STATE(1586),
    [sym_block_comment] = STATE(724),
    [sym_compiler_directive_decl] = STATE(724),
    [sym_fsi_directive_decl] = STATE(724),
    [sym_preproc_line] = STATE(724),
    [sym_preproc_if_in_expression] = STATE(2168),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(989),
    [anon_sym_return] = ACTIONS(993),
    [anon_sym_do] = ACTIONS(995),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(997),
    [anon_sym_null] = ACTIONS(1001),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1003),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1005),
    [anon_sym_LBRACE] = ACTIONS(2070),
    [anon_sym_LT_AT] = ACTIONS(1009),
    [anon_sym_LT_AT_AT] = ACTIONS(2072),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1017),
    [anon_sym_new] = ACTIONS(993),
    [anon_sym_return_BANG] = ACTIONS(1019),
    [anon_sym_yield] = ACTIONS(993),
    [anon_sym_yield_BANG] = ACTIONS(1019),
    [anon_sym_lazy] = ACTIONS(993),
    [anon_sym_assert] = ACTIONS(993),
    [anon_sym_upcast] = ACTIONS(993),
    [anon_sym_downcast] = ACTIONS(993),
    [anon_sym_for] = ACTIONS(1023),
    [anon_sym_while] = ACTIONS(1025),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(1027),
    [anon_sym_try] = ACTIONS(1029),
    [anon_sym_match] = ACTIONS(1031),
    [anon_sym_match_BANG] = ACTIONS(1033),
    [anon_sym_function] = ACTIONS(1035),
    [anon_sym_use] = ACTIONS(1043),
    [anon_sym_use_BANG] = ACTIONS(1045),
    [anon_sym_do_BANG] = ACTIONS(1047),
    [anon_sym_begin] = ACTIONS(1049),
    [aux_sym_char_token1] = ACTIONS(1053),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1055),
    [anon_sym_DQUOTE] = ACTIONS(1057),
    [anon_sym_AT_DQUOTE] = ACTIONS(1059),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1061),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1063),
    [sym_bool] = ACTIONS(1065),
    [sym_unit] = ACTIONS(2074),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1069),
    [sym_op_identifier] = ACTIONS(2076),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(1073),
    [sym_xint] = ACTIONS(1075),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1077),
  },
  [725] = {
    [sym_function_or_value_defn] = STATE(630),
    [sym__expression] = STATE(151),
    [sym_literal_expression] = STATE(2380),
    [sym_long_identifier_or_op] = STATE(2380),
    [sym_tuple_expression] = STATE(2380),
    [sym_brace_expression] = STATE(2380),
    [sym_anon_record_expression] = STATE(2380),
    [sym_prefixed_expression] = STATE(2380),
    [sym_typecast_expression] = STATE(2380),
    [sym_for_expression] = STATE(2380),
    [sym_while_expression] = STATE(2380),
    [sym__if_branch] = STATE(6456),
    [sym_if_expression] = STATE(2380),
    [sym_fun_expression] = STATE(2380),
    [sym_try_expression] = STATE(2380),
    [sym_match_expression] = STATE(2380),
    [sym_function_expression] = STATE(2380),
    [sym_mutate_expression] = STATE(2380),
    [sym_index_expression] = STATE(2380),
    [sym_typed_expression] = STATE(2380),
    [sym_declaration_expression] = STATE(2380),
    [sym_do_expression] = STATE(2380),
    [sym_list_expression] = STATE(2380),
    [sym_array_expression] = STATE(2380),
    [sym_begin_end_expression] = STATE(2380),
    [sym_paren_expression] = STATE(2380),
    [sym__high_prec_app] = STATE(2383),
    [sym__low_prec_app] = STATE(2383),
    [sym_application_expression] = STATE(2380),
    [sym_dot_expression] = STATE(2380),
    [sym_infix_expression] = STATE(2380),
    [sym_ce_expression] = STATE(2380),
    [sym_sequential_expression] = STATE(2380),
    [sym_char] = STATE(2261),
    [sym_format_string] = STATE(2274),
    [sym__string_literal] = STATE(2274),
    [sym_string] = STATE(2261),
    [sym_verbatim_string] = STATE(2261),
    [sym_bytearray] = STATE(2261),
    [sym_verbatim_bytearray] = STATE(2261),
    [sym_format_triple_quoted_string] = STATE(2275),
    [sym_triple_quoted_string] = STATE(2261),
    [sym_const] = STATE(2380),
    [sym_long_identifier] = STATE(2391),
    [sym_active_pattern] = STATE(2470),
    [sym__identifier_or_op] = STATE(2390),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(632),
    [sym_sbyte] = STATE(2261),
    [sym_byte] = STATE(2261),
    [sym_int16] = STATE(2261),
    [sym_uint16] = STATE(2261),
    [sym_int32] = STATE(2261),
    [sym_uint32] = STATE(2261),
    [sym_nativeint] = STATE(2261),
    [sym_unativeint] = STATE(2261),
    [sym_int64] = STATE(2261),
    [sym_uint64] = STATE(2261),
    [sym_ieee32] = STATE(2261),
    [sym_ieee64] = STATE(2261),
    [sym_bignum] = STATE(2261),
    [sym_decimal] = STATE(2261),
    [sym_float] = STATE(1614),
    [sym_block_comment] = STATE(725),
    [sym_compiler_directive_decl] = STATE(725),
    [sym_fsi_directive_decl] = STATE(725),
    [sym_preproc_line] = STATE(725),
    [sym_preproc_if_in_expression] = STATE(2380),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(1081),
    [anon_sym_return] = ACTIONS(1085),
    [anon_sym_do] = ACTIONS(1087),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(1089),
    [anon_sym_null] = ACTIONS(1093),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1095),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1097),
    [anon_sym_LBRACE] = ACTIONS(2100),
    [anon_sym_LT_AT] = ACTIONS(1101),
    [anon_sym_LT_AT_AT] = ACTIONS(2102),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1107),
    [anon_sym_new] = ACTIONS(1085),
    [anon_sym_return_BANG] = ACTIONS(1109),
    [anon_sym_yield] = ACTIONS(1085),
    [anon_sym_yield_BANG] = ACTIONS(1109),
    [anon_sym_lazy] = ACTIONS(1085),
    [anon_sym_assert] = ACTIONS(1085),
    [anon_sym_upcast] = ACTIONS(1085),
    [anon_sym_downcast] = ACTIONS(1085),
    [anon_sym_for] = ACTIONS(1113),
    [anon_sym_while] = ACTIONS(1115),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(1117),
    [anon_sym_try] = ACTIONS(1119),
    [anon_sym_match] = ACTIONS(1121),
    [anon_sym_match_BANG] = ACTIONS(1123),
    [anon_sym_function] = ACTIONS(1125),
    [anon_sym_use] = ACTIONS(1133),
    [anon_sym_use_BANG] = ACTIONS(1135),
    [anon_sym_do_BANG] = ACTIONS(1137),
    [anon_sym_begin] = ACTIONS(1139),
    [aux_sym_char_token1] = ACTIONS(1143),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1145),
    [anon_sym_DQUOTE] = ACTIONS(1147),
    [anon_sym_AT_DQUOTE] = ACTIONS(1149),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1151),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1153),
    [sym_bool] = ACTIONS(1155),
    [sym_unit] = ACTIONS(2104),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1159),
    [sym_op_identifier] = ACTIONS(2106),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(1163),
    [sym_xint] = ACTIONS(1165),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1167),
  },
  [726] = {
    [sym_function_or_value_defn] = STATE(630),
    [sym__expression] = STATE(174),
    [sym_literal_expression] = STATE(2380),
    [sym_long_identifier_or_op] = STATE(2380),
    [sym_tuple_expression] = STATE(2380),
    [sym_brace_expression] = STATE(2380),
    [sym_anon_record_expression] = STATE(2380),
    [sym_prefixed_expression] = STATE(2380),
    [sym_typecast_expression] = STATE(2380),
    [sym_for_expression] = STATE(2380),
    [sym_while_expression] = STATE(2380),
    [sym__if_branch] = STATE(6456),
    [sym_if_expression] = STATE(2380),
    [sym_fun_expression] = STATE(2380),
    [sym_try_expression] = STATE(2380),
    [sym_match_expression] = STATE(2380),
    [sym_function_expression] = STATE(2380),
    [sym_mutate_expression] = STATE(2380),
    [sym_index_expression] = STATE(2380),
    [sym_typed_expression] = STATE(2380),
    [sym_declaration_expression] = STATE(2380),
    [sym_do_expression] = STATE(2380),
    [sym_list_expression] = STATE(2380),
    [sym_array_expression] = STATE(2380),
    [sym_begin_end_expression] = STATE(2380),
    [sym_paren_expression] = STATE(2380),
    [sym__high_prec_app] = STATE(2383),
    [sym__low_prec_app] = STATE(2383),
    [sym_application_expression] = STATE(2380),
    [sym_dot_expression] = STATE(2380),
    [sym_infix_expression] = STATE(2380),
    [sym_ce_expression] = STATE(2380),
    [sym_sequential_expression] = STATE(2380),
    [sym_char] = STATE(2261),
    [sym_format_string] = STATE(2274),
    [sym__string_literal] = STATE(2274),
    [sym_string] = STATE(2261),
    [sym_verbatim_string] = STATE(2261),
    [sym_bytearray] = STATE(2261),
    [sym_verbatim_bytearray] = STATE(2261),
    [sym_format_triple_quoted_string] = STATE(2275),
    [sym_triple_quoted_string] = STATE(2261),
    [sym_const] = STATE(2380),
    [sym_long_identifier] = STATE(2391),
    [sym_active_pattern] = STATE(2470),
    [sym__identifier_or_op] = STATE(2390),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(632),
    [sym_sbyte] = STATE(2261),
    [sym_byte] = STATE(2261),
    [sym_int16] = STATE(2261),
    [sym_uint16] = STATE(2261),
    [sym_int32] = STATE(2261),
    [sym_uint32] = STATE(2261),
    [sym_nativeint] = STATE(2261),
    [sym_unativeint] = STATE(2261),
    [sym_int64] = STATE(2261),
    [sym_uint64] = STATE(2261),
    [sym_ieee32] = STATE(2261),
    [sym_ieee64] = STATE(2261),
    [sym_bignum] = STATE(2261),
    [sym_decimal] = STATE(2261),
    [sym_float] = STATE(1614),
    [sym_block_comment] = STATE(726),
    [sym_compiler_directive_decl] = STATE(726),
    [sym_fsi_directive_decl] = STATE(726),
    [sym_preproc_line] = STATE(726),
    [sym_preproc_if_in_expression] = STATE(2380),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(1081),
    [anon_sym_return] = ACTIONS(1085),
    [anon_sym_do] = ACTIONS(1087),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(1089),
    [anon_sym_null] = ACTIONS(1093),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1095),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1097),
    [anon_sym_LBRACE] = ACTIONS(2100),
    [anon_sym_LT_AT] = ACTIONS(1101),
    [anon_sym_LT_AT_AT] = ACTIONS(2102),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1107),
    [anon_sym_new] = ACTIONS(1085),
    [anon_sym_return_BANG] = ACTIONS(1109),
    [anon_sym_yield] = ACTIONS(1085),
    [anon_sym_yield_BANG] = ACTIONS(1109),
    [anon_sym_lazy] = ACTIONS(1085),
    [anon_sym_assert] = ACTIONS(1085),
    [anon_sym_upcast] = ACTIONS(1085),
    [anon_sym_downcast] = ACTIONS(1085),
    [anon_sym_for] = ACTIONS(1113),
    [anon_sym_while] = ACTIONS(1115),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(1117),
    [anon_sym_try] = ACTIONS(1119),
    [anon_sym_match] = ACTIONS(1121),
    [anon_sym_match_BANG] = ACTIONS(1123),
    [anon_sym_function] = ACTIONS(1125),
    [anon_sym_use] = ACTIONS(1133),
    [anon_sym_use_BANG] = ACTIONS(1135),
    [anon_sym_do_BANG] = ACTIONS(1137),
    [anon_sym_begin] = ACTIONS(1139),
    [aux_sym_char_token1] = ACTIONS(1143),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1145),
    [anon_sym_DQUOTE] = ACTIONS(1147),
    [anon_sym_AT_DQUOTE] = ACTIONS(1149),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1151),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1153),
    [sym_bool] = ACTIONS(1155),
    [sym_unit] = ACTIONS(2104),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1159),
    [sym_op_identifier] = ACTIONS(2106),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(1163),
    [sym_xint] = ACTIONS(1165),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1167),
  },
  [727] = {
    [sym_function_or_value_defn] = STATE(651),
    [sym__expression] = STATE(182),
    [sym_literal_expression] = STATE(2168),
    [sym_long_identifier_or_op] = STATE(2168),
    [sym_tuple_expression] = STATE(2168),
    [sym_brace_expression] = STATE(2168),
    [sym_anon_record_expression] = STATE(2168),
    [sym_prefixed_expression] = STATE(2168),
    [sym_typecast_expression] = STATE(2168),
    [sym_for_expression] = STATE(2168),
    [sym_while_expression] = STATE(2168),
    [sym__if_branch] = STATE(6406),
    [sym_if_expression] = STATE(2168),
    [sym_fun_expression] = STATE(2168),
    [sym_try_expression] = STATE(2168),
    [sym_match_expression] = STATE(2168),
    [sym_function_expression] = STATE(2168),
    [sym_mutate_expression] = STATE(2168),
    [sym_index_expression] = STATE(2168),
    [sym_typed_expression] = STATE(2168),
    [sym_declaration_expression] = STATE(2168),
    [sym_do_expression] = STATE(2168),
    [sym_list_expression] = STATE(2168),
    [sym_array_expression] = STATE(2168),
    [sym_begin_end_expression] = STATE(2168),
    [sym_paren_expression] = STATE(2168),
    [sym__high_prec_app] = STATE(2179),
    [sym__low_prec_app] = STATE(2179),
    [sym_application_expression] = STATE(2168),
    [sym_dot_expression] = STATE(2168),
    [sym_infix_expression] = STATE(2168),
    [sym_ce_expression] = STATE(2168),
    [sym_sequential_expression] = STATE(2168),
    [sym_char] = STATE(2469),
    [sym_format_string] = STATE(2412),
    [sym__string_literal] = STATE(2412),
    [sym_string] = STATE(2469),
    [sym_verbatim_string] = STATE(2469),
    [sym_bytearray] = STATE(2469),
    [sym_verbatim_bytearray] = STATE(2469),
    [sym_format_triple_quoted_string] = STATE(2408),
    [sym_triple_quoted_string] = STATE(2469),
    [sym_const] = STATE(2168),
    [sym_long_identifier] = STATE(2183),
    [sym_active_pattern] = STATE(2182),
    [sym__identifier_or_op] = STATE(2093),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(650),
    [sym_sbyte] = STATE(2469),
    [sym_byte] = STATE(2469),
    [sym_int16] = STATE(2469),
    [sym_uint16] = STATE(2469),
    [sym_int32] = STATE(2469),
    [sym_uint32] = STATE(2469),
    [sym_nativeint] = STATE(2469),
    [sym_unativeint] = STATE(2469),
    [sym_int64] = STATE(2469),
    [sym_uint64] = STATE(2469),
    [sym_ieee32] = STATE(2469),
    [sym_ieee64] = STATE(2469),
    [sym_bignum] = STATE(2469),
    [sym_decimal] = STATE(2469),
    [sym_float] = STATE(1586),
    [sym_block_comment] = STATE(727),
    [sym_compiler_directive_decl] = STATE(727),
    [sym_fsi_directive_decl] = STATE(727),
    [sym_preproc_line] = STATE(727),
    [sym_preproc_if_in_expression] = STATE(2168),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(989),
    [anon_sym_return] = ACTIONS(993),
    [anon_sym_do] = ACTIONS(995),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(997),
    [anon_sym_null] = ACTIONS(1001),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1003),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1005),
    [anon_sym_LBRACE] = ACTIONS(2070),
    [anon_sym_LT_AT] = ACTIONS(1009),
    [anon_sym_LT_AT_AT] = ACTIONS(2072),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1017),
    [anon_sym_new] = ACTIONS(993),
    [anon_sym_return_BANG] = ACTIONS(1019),
    [anon_sym_yield] = ACTIONS(993),
    [anon_sym_yield_BANG] = ACTIONS(1019),
    [anon_sym_lazy] = ACTIONS(993),
    [anon_sym_assert] = ACTIONS(993),
    [anon_sym_upcast] = ACTIONS(993),
    [anon_sym_downcast] = ACTIONS(993),
    [anon_sym_for] = ACTIONS(1023),
    [anon_sym_while] = ACTIONS(1025),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(1027),
    [anon_sym_try] = ACTIONS(1029),
    [anon_sym_match] = ACTIONS(1031),
    [anon_sym_match_BANG] = ACTIONS(1033),
    [anon_sym_function] = ACTIONS(1035),
    [anon_sym_use] = ACTIONS(1043),
    [anon_sym_use_BANG] = ACTIONS(1045),
    [anon_sym_do_BANG] = ACTIONS(1047),
    [anon_sym_begin] = ACTIONS(1049),
    [aux_sym_char_token1] = ACTIONS(1053),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1055),
    [anon_sym_DQUOTE] = ACTIONS(1057),
    [anon_sym_AT_DQUOTE] = ACTIONS(1059),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1061),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1063),
    [sym_bool] = ACTIONS(1065),
    [sym_unit] = ACTIONS(2074),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1069),
    [sym_op_identifier] = ACTIONS(2076),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(1073),
    [sym_xint] = ACTIONS(1075),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1077),
  },
  [728] = {
    [sym_function_or_value_defn] = STATE(733),
    [sym__expression] = STATE(284),
    [sym_literal_expression] = STATE(2008),
    [sym_long_identifier_or_op] = STATE(2008),
    [sym_tuple_expression] = STATE(2008),
    [sym_brace_expression] = STATE(2008),
    [sym_anon_record_expression] = STATE(2008),
    [sym_prefixed_expression] = STATE(2008),
    [sym_typecast_expression] = STATE(2008),
    [sym_for_expression] = STATE(2008),
    [sym_while_expression] = STATE(2008),
    [sym__if_branch] = STATE(6754),
    [sym_if_expression] = STATE(2008),
    [sym_fun_expression] = STATE(2008),
    [sym_try_expression] = STATE(2008),
    [sym_match_expression] = STATE(2008),
    [sym_function_expression] = STATE(2008),
    [sym_mutate_expression] = STATE(2008),
    [sym_index_expression] = STATE(2008),
    [sym_typed_expression] = STATE(2008),
    [sym_declaration_expression] = STATE(2008),
    [sym_do_expression] = STATE(2008),
    [sym_list_expression] = STATE(2008),
    [sym_array_expression] = STATE(2008),
    [sym_begin_end_expression] = STATE(2008),
    [sym_paren_expression] = STATE(2008),
    [sym__high_prec_app] = STATE(2007),
    [sym__low_prec_app] = STATE(2007),
    [sym_application_expression] = STATE(2008),
    [sym_dot_expression] = STATE(2008),
    [sym_infix_expression] = STATE(2008),
    [sym_ce_expression] = STATE(2008),
    [sym_sequential_expression] = STATE(2008),
    [sym_char] = STATE(1859),
    [sym_format_string] = STATE(1861),
    [sym__string_literal] = STATE(1861),
    [sym_string] = STATE(1859),
    [sym_verbatim_string] = STATE(1859),
    [sym_bytearray] = STATE(1859),
    [sym_verbatim_bytearray] = STATE(1859),
    [sym_format_triple_quoted_string] = STATE(1862),
    [sym_triple_quoted_string] = STATE(1859),
    [sym_const] = STATE(2008),
    [sym_long_identifier] = STATE(1701),
    [sym_active_pattern] = STATE(1702),
    [sym__identifier_or_op] = STATE(1724),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(706),
    [sym_sbyte] = STATE(1859),
    [sym_byte] = STATE(1859),
    [sym_int16] = STATE(1859),
    [sym_uint16] = STATE(1859),
    [sym_int32] = STATE(1859),
    [sym_uint32] = STATE(1859),
    [sym_nativeint] = STATE(1859),
    [sym_unativeint] = STATE(1859),
    [sym_int64] = STATE(1859),
    [sym_uint64] = STATE(1859),
    [sym_ieee32] = STATE(1859),
    [sym_ieee64] = STATE(1859),
    [sym_bignum] = STATE(1859),
    [sym_decimal] = STATE(1859),
    [sym_float] = STATE(1447),
    [sym_block_comment] = STATE(728),
    [sym_compiler_directive_decl] = STATE(728),
    [sym_fsi_directive_decl] = STATE(728),
    [sym_preproc_line] = STATE(728),
    [sym_preproc_if_in_expression] = STATE(2008),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(503),
    [anon_sym_return] = ACTIONS(971),
    [anon_sym_do] = ACTIONS(599),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(511),
    [anon_sym_null] = ACTIONS(515),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(517),
    [anon_sym_LBRACK_PIPE] = ACTIONS(519),
    [anon_sym_LBRACE] = ACTIONS(2060),
    [anon_sym_LT_AT] = ACTIONS(523),
    [anon_sym_LT_AT_AT] = ACTIONS(2062),
    [anon_sym_LBRACE_PIPE] = ACTIONS(529),
    [anon_sym_new] = ACTIONS(971),
    [anon_sym_return_BANG] = ACTIONS(975),
    [anon_sym_yield] = ACTIONS(971),
    [anon_sym_yield_BANG] = ACTIONS(975),
    [anon_sym_lazy] = ACTIONS(971),
    [anon_sym_assert] = ACTIONS(971),
    [anon_sym_upcast] = ACTIONS(971),
    [anon_sym_downcast] = ACTIONS(971),
    [anon_sym_for] = ACTIONS(979),
    [anon_sym_while] = ACTIONS(537),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(539),
    [anon_sym_try] = ACTIONS(543),
    [anon_sym_match] = ACTIONS(545),
    [anon_sym_match_BANG] = ACTIONS(547),
    [anon_sym_function] = ACTIONS(549),
    [anon_sym_use] = ACTIONS(983),
    [anon_sym_use_BANG] = ACTIONS(985),
    [anon_sym_do_BANG] = ACTIONS(561),
    [anon_sym_begin] = ACTIONS(565),
    [aux_sym_char_token1] = ACTIONS(569),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(571),
    [anon_sym_DQUOTE] = ACTIONS(573),
    [anon_sym_AT_DQUOTE] = ACTIONS(575),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(577),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(579),
    [sym_bool] = ACTIONS(581),
    [sym_unit] = ACTIONS(2064),
    [anon_sym_LPAREN_PIPE] = ACTIONS(585),
    [sym_op_identifier] = ACTIONS(2066),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(591),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(593),
  },
  [729] = {
    [sym_function_or_value_defn] = STATE(729),
    [sym__expression] = STATE(61),
    [sym_literal_expression] = STATE(867),
    [sym_long_identifier_or_op] = STATE(867),
    [sym_tuple_expression] = STATE(867),
    [sym_brace_expression] = STATE(867),
    [sym_anon_record_expression] = STATE(867),
    [sym_prefixed_expression] = STATE(867),
    [sym_typecast_expression] = STATE(867),
    [sym_for_expression] = STATE(867),
    [sym_while_expression] = STATE(867),
    [sym__if_branch] = STATE(6511),
    [sym_if_expression] = STATE(867),
    [sym_fun_expression] = STATE(867),
    [sym_try_expression] = STATE(867),
    [sym_match_expression] = STATE(867),
    [sym_function_expression] = STATE(867),
    [sym_mutate_expression] = STATE(867),
    [sym_index_expression] = STATE(867),
    [sym_typed_expression] = STATE(867),
    [sym_declaration_expression] = STATE(867),
    [sym_do_expression] = STATE(867),
    [sym_list_expression] = STATE(867),
    [sym_array_expression] = STATE(867),
    [sym_begin_end_expression] = STATE(867),
    [sym_paren_expression] = STATE(867),
    [sym__high_prec_app] = STATE(864),
    [sym__low_prec_app] = STATE(864),
    [sym_application_expression] = STATE(867),
    [sym_dot_expression] = STATE(867),
    [sym_infix_expression] = STATE(867),
    [sym_ce_expression] = STATE(867),
    [sym_sequential_expression] = STATE(867),
    [sym_char] = STATE(868),
    [sym_format_string] = STATE(869),
    [sym__string_literal] = STATE(869),
    [sym_string] = STATE(868),
    [sym_verbatim_string] = STATE(868),
    [sym_bytearray] = STATE(868),
    [sym_verbatim_bytearray] = STATE(868),
    [sym_format_triple_quoted_string] = STATE(870),
    [sym_triple_quoted_string] = STATE(868),
    [sym_const] = STATE(867),
    [sym_long_identifier] = STATE(872),
    [sym_active_pattern] = STATE(871),
    [sym__identifier_or_op] = STATE(873),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(499),
    [sym_sbyte] = STATE(868),
    [sym_byte] = STATE(868),
    [sym_int16] = STATE(868),
    [sym_uint16] = STATE(868),
    [sym_int32] = STATE(868),
    [sym_uint32] = STATE(868),
    [sym_nativeint] = STATE(868),
    [sym_unativeint] = STATE(868),
    [sym_int64] = STATE(868),
    [sym_uint64] = STATE(868),
    [sym_ieee32] = STATE(868),
    [sym_ieee64] = STATE(868),
    [sym_bignum] = STATE(868),
    [sym_decimal] = STATE(868),
    [sym_float] = STATE(1368),
    [sym_block_comment] = STATE(729),
    [sym_compiler_directive_decl] = STATE(729),
    [sym_fsi_directive_decl] = STATE(729),
    [sym_preproc_line] = STATE(729),
    [sym_preproc_if_in_expression] = STATE(867),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(29),
    [anon_sym_return] = ACTIONS(369),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_null] = ACTIONS(49),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACK_PIPE] = ACTIONS(57),
    [anon_sym_LBRACE] = ACTIONS(1663),
    [anon_sym_LT_AT] = ACTIONS(61),
    [anon_sym_LT_AT_AT] = ACTIONS(1665),
    [anon_sym_LBRACE_PIPE] = ACTIONS(67),
    [anon_sym_new] = ACTIONS(369),
    [anon_sym_return_BANG] = ACTIONS(373),
    [anon_sym_yield] = ACTIONS(369),
    [anon_sym_yield_BANG] = ACTIONS(373),
    [anon_sym_lazy] = ACTIONS(369),
    [anon_sym_assert] = ACTIONS(369),
    [anon_sym_upcast] = ACTIONS(369),
    [anon_sym_downcast] = ACTIONS(369),
    [anon_sym_for] = ACTIONS(375),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(79),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_match] = ACTIONS(83),
    [anon_sym_match_BANG] = ACTIONS(85),
    [anon_sym_function] = ACTIONS(87),
    [anon_sym_use] = ACTIONS(379),
    [anon_sym_use_BANG] = ACTIONS(381),
    [anon_sym_do_BANG] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(101),
    [aux_sym_char_token1] = ACTIONS(105),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(107),
    [anon_sym_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DQUOTE] = ACTIONS(111),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(115),
    [sym_bool] = ACTIONS(117),
    [sym_unit] = ACTIONS(1673),
    [anon_sym_LPAREN_PIPE] = ACTIONS(121),
    [sym_op_identifier] = ACTIONS(1675),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(385),
    [sym_xint] = ACTIONS(387),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(135),
  },
  [730] = {
    [sym_function_or_value_defn] = STATE(600),
    [sym__expression] = STATE(154),
    [sym_literal_expression] = STATE(867),
    [sym_long_identifier_or_op] = STATE(867),
    [sym_tuple_expression] = STATE(867),
    [sym_brace_expression] = STATE(867),
    [sym_anon_record_expression] = STATE(867),
    [sym_prefixed_expression] = STATE(867),
    [sym_typecast_expression] = STATE(867),
    [sym_for_expression] = STATE(867),
    [sym_while_expression] = STATE(867),
    [sym__if_branch] = STATE(6511),
    [sym_if_expression] = STATE(867),
    [sym_fun_expression] = STATE(867),
    [sym_try_expression] = STATE(867),
    [sym_match_expression] = STATE(867),
    [sym_function_expression] = STATE(867),
    [sym_mutate_expression] = STATE(867),
    [sym_index_expression] = STATE(867),
    [sym_typed_expression] = STATE(867),
    [sym_declaration_expression] = STATE(867),
    [sym_do_expression] = STATE(867),
    [sym_list_expression] = STATE(867),
    [sym_array_expression] = STATE(867),
    [sym_begin_end_expression] = STATE(867),
    [sym_paren_expression] = STATE(867),
    [sym__high_prec_app] = STATE(864),
    [sym__low_prec_app] = STATE(864),
    [sym_application_expression] = STATE(867),
    [sym_dot_expression] = STATE(867),
    [sym_infix_expression] = STATE(867),
    [sym_ce_expression] = STATE(867),
    [sym_sequential_expression] = STATE(867),
    [sym_char] = STATE(868),
    [sym_format_string] = STATE(869),
    [sym__string_literal] = STATE(869),
    [sym_string] = STATE(868),
    [sym_verbatim_string] = STATE(868),
    [sym_bytearray] = STATE(868),
    [sym_verbatim_bytearray] = STATE(868),
    [sym_format_triple_quoted_string] = STATE(870),
    [sym_triple_quoted_string] = STATE(868),
    [sym_const] = STATE(867),
    [sym_long_identifier] = STATE(872),
    [sym_active_pattern] = STATE(871),
    [sym__identifier_or_op] = STATE(873),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(656),
    [sym_sbyte] = STATE(868),
    [sym_byte] = STATE(868),
    [sym_int16] = STATE(868),
    [sym_uint16] = STATE(868),
    [sym_int32] = STATE(868),
    [sym_uint32] = STATE(868),
    [sym_nativeint] = STATE(868),
    [sym_unativeint] = STATE(868),
    [sym_int64] = STATE(868),
    [sym_uint64] = STATE(868),
    [sym_ieee32] = STATE(868),
    [sym_ieee64] = STATE(868),
    [sym_bignum] = STATE(868),
    [sym_decimal] = STATE(868),
    [sym_float] = STATE(1368),
    [sym_block_comment] = STATE(730),
    [sym_compiler_directive_decl] = STATE(730),
    [sym_fsi_directive_decl] = STATE(730),
    [sym_preproc_line] = STATE(730),
    [sym_preproc_if_in_expression] = STATE(867),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(29),
    [anon_sym_return] = ACTIONS(825),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_null] = ACTIONS(49),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACK_PIPE] = ACTIONS(57),
    [anon_sym_LBRACE] = ACTIONS(1663),
    [anon_sym_LT_AT] = ACTIONS(61),
    [anon_sym_LT_AT_AT] = ACTIONS(1665),
    [anon_sym_LBRACE_PIPE] = ACTIONS(67),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_return_BANG] = ACTIONS(829),
    [anon_sym_yield] = ACTIONS(825),
    [anon_sym_yield_BANG] = ACTIONS(829),
    [anon_sym_lazy] = ACTIONS(825),
    [anon_sym_assert] = ACTIONS(825),
    [anon_sym_upcast] = ACTIONS(825),
    [anon_sym_downcast] = ACTIONS(825),
    [anon_sym_for] = ACTIONS(73),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(79),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_match] = ACTIONS(83),
    [anon_sym_match_BANG] = ACTIONS(85),
    [anon_sym_function] = ACTIONS(87),
    [anon_sym_use] = ACTIONS(833),
    [anon_sym_use_BANG] = ACTIONS(835),
    [anon_sym_do_BANG] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(101),
    [aux_sym_char_token1] = ACTIONS(105),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(107),
    [anon_sym_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DQUOTE] = ACTIONS(111),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(115),
    [sym_bool] = ACTIONS(117),
    [sym_unit] = ACTIONS(1673),
    [anon_sym_LPAREN_PIPE] = ACTIONS(121),
    [sym_op_identifier] = ACTIONS(1675),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(837),
    [sym_xint] = ACTIONS(387),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(135),
  },
  [731] = {
    [sym_function_or_value_defn] = STATE(600),
    [sym__expression] = STATE(175),
    [sym_literal_expression] = STATE(867),
    [sym_long_identifier_or_op] = STATE(867),
    [sym_tuple_expression] = STATE(867),
    [sym_brace_expression] = STATE(867),
    [sym_anon_record_expression] = STATE(867),
    [sym_prefixed_expression] = STATE(867),
    [sym_typecast_expression] = STATE(867),
    [sym_for_expression] = STATE(867),
    [sym_while_expression] = STATE(867),
    [sym__if_branch] = STATE(6511),
    [sym_if_expression] = STATE(867),
    [sym_fun_expression] = STATE(867),
    [sym_try_expression] = STATE(867),
    [sym_match_expression] = STATE(867),
    [sym_function_expression] = STATE(867),
    [sym_mutate_expression] = STATE(867),
    [sym_index_expression] = STATE(867),
    [sym_typed_expression] = STATE(867),
    [sym_declaration_expression] = STATE(867),
    [sym_do_expression] = STATE(867),
    [sym_list_expression] = STATE(867),
    [sym_array_expression] = STATE(867),
    [sym_begin_end_expression] = STATE(867),
    [sym_paren_expression] = STATE(867),
    [sym__high_prec_app] = STATE(864),
    [sym__low_prec_app] = STATE(864),
    [sym_application_expression] = STATE(867),
    [sym_dot_expression] = STATE(867),
    [sym_infix_expression] = STATE(867),
    [sym_ce_expression] = STATE(867),
    [sym_sequential_expression] = STATE(867),
    [sym_char] = STATE(868),
    [sym_format_string] = STATE(869),
    [sym__string_literal] = STATE(869),
    [sym_string] = STATE(868),
    [sym_verbatim_string] = STATE(868),
    [sym_bytearray] = STATE(868),
    [sym_verbatim_bytearray] = STATE(868),
    [sym_format_triple_quoted_string] = STATE(870),
    [sym_triple_quoted_string] = STATE(868),
    [sym_const] = STATE(867),
    [sym_long_identifier] = STATE(872),
    [sym_active_pattern] = STATE(871),
    [sym__identifier_or_op] = STATE(873),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(656),
    [sym_sbyte] = STATE(868),
    [sym_byte] = STATE(868),
    [sym_int16] = STATE(868),
    [sym_uint16] = STATE(868),
    [sym_int32] = STATE(868),
    [sym_uint32] = STATE(868),
    [sym_nativeint] = STATE(868),
    [sym_unativeint] = STATE(868),
    [sym_int64] = STATE(868),
    [sym_uint64] = STATE(868),
    [sym_ieee32] = STATE(868),
    [sym_ieee64] = STATE(868),
    [sym_bignum] = STATE(868),
    [sym_decimal] = STATE(868),
    [sym_float] = STATE(1368),
    [sym_block_comment] = STATE(731),
    [sym_compiler_directive_decl] = STATE(731),
    [sym_fsi_directive_decl] = STATE(731),
    [sym_preproc_line] = STATE(731),
    [sym_preproc_if_in_expression] = STATE(867),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(29),
    [anon_sym_return] = ACTIONS(825),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_null] = ACTIONS(49),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACK_PIPE] = ACTIONS(57),
    [anon_sym_LBRACE] = ACTIONS(1663),
    [anon_sym_LT_AT] = ACTIONS(61),
    [anon_sym_LT_AT_AT] = ACTIONS(1665),
    [anon_sym_LBRACE_PIPE] = ACTIONS(67),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_return_BANG] = ACTIONS(829),
    [anon_sym_yield] = ACTIONS(825),
    [anon_sym_yield_BANG] = ACTIONS(829),
    [anon_sym_lazy] = ACTIONS(825),
    [anon_sym_assert] = ACTIONS(825),
    [anon_sym_upcast] = ACTIONS(825),
    [anon_sym_downcast] = ACTIONS(825),
    [anon_sym_for] = ACTIONS(73),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(79),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_match] = ACTIONS(83),
    [anon_sym_match_BANG] = ACTIONS(85),
    [anon_sym_function] = ACTIONS(87),
    [anon_sym_use] = ACTIONS(833),
    [anon_sym_use_BANG] = ACTIONS(835),
    [anon_sym_do_BANG] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(101),
    [aux_sym_char_token1] = ACTIONS(105),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(107),
    [anon_sym_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DQUOTE] = ACTIONS(111),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(115),
    [sym_bool] = ACTIONS(117),
    [sym_unit] = ACTIONS(1673),
    [anon_sym_LPAREN_PIPE] = ACTIONS(121),
    [sym_op_identifier] = ACTIONS(1675),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(837),
    [sym_xint] = ACTIONS(387),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(135),
  },
  [732] = {
    [sym_function_or_value_defn] = STATE(627),
    [sym__expression] = STATE(329),
    [sym_literal_expression] = STATE(1118),
    [sym_long_identifier_or_op] = STATE(1118),
    [sym_tuple_expression] = STATE(1118),
    [sym_brace_expression] = STATE(1118),
    [sym_anon_record_expression] = STATE(1118),
    [sym_prefixed_expression] = STATE(1118),
    [sym_typecast_expression] = STATE(1118),
    [sym_for_expression] = STATE(1118),
    [sym_while_expression] = STATE(1118),
    [sym__if_branch] = STATE(7163),
    [sym_if_expression] = STATE(1118),
    [sym_fun_expression] = STATE(1118),
    [sym_try_expression] = STATE(1118),
    [sym_match_expression] = STATE(1118),
    [sym_function_expression] = STATE(1118),
    [sym_mutate_expression] = STATE(1118),
    [sym_index_expression] = STATE(1118),
    [sym_typed_expression] = STATE(1118),
    [sym_declaration_expression] = STATE(1118),
    [sym_do_expression] = STATE(1118),
    [sym_list_expression] = STATE(1118),
    [sym_array_expression] = STATE(1118),
    [sym_begin_end_expression] = STATE(1118),
    [sym_paren_expression] = STATE(1118),
    [sym__high_prec_app] = STATE(1133),
    [sym__low_prec_app] = STATE(1133),
    [sym_application_expression] = STATE(1118),
    [sym_dot_expression] = STATE(1118),
    [sym_infix_expression] = STATE(1118),
    [sym_ce_expression] = STATE(1118),
    [sym_sequential_expression] = STATE(1118),
    [sym_char] = STATE(1080),
    [sym_format_string] = STATE(1090),
    [sym__string_literal] = STATE(1090),
    [sym_string] = STATE(1080),
    [sym_verbatim_string] = STATE(1080),
    [sym_bytearray] = STATE(1080),
    [sym_verbatim_bytearray] = STATE(1080),
    [sym_format_triple_quoted_string] = STATE(1096),
    [sym_triple_quoted_string] = STATE(1080),
    [sym_const] = STATE(1118),
    [sym_long_identifier] = STATE(1156),
    [sym_active_pattern] = STATE(1085),
    [sym__identifier_or_op] = STATE(1099),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(517),
    [sym_sbyte] = STATE(1080),
    [sym_byte] = STATE(1080),
    [sym_int16] = STATE(1080),
    [sym_uint16] = STATE(1080),
    [sym_int32] = STATE(1080),
    [sym_uint32] = STATE(1080),
    [sym_nativeint] = STATE(1080),
    [sym_unativeint] = STATE(1080),
    [sym_int64] = STATE(1080),
    [sym_uint64] = STATE(1080),
    [sym_ieee32] = STATE(1080),
    [sym_ieee64] = STATE(1080),
    [sym_bignum] = STATE(1080),
    [sym_decimal] = STATE(1080),
    [sym_float] = STATE(979),
    [sym_block_comment] = STATE(732),
    [sym_compiler_directive_decl] = STATE(732),
    [sym_fsi_directive_decl] = STATE(732),
    [sym_preproc_line] = STATE(732),
    [sym_preproc_if_in_expression] = STATE(1118),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(195),
    [anon_sym_return] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_null] = ACTIONS(207),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(209),
    [anon_sym_LBRACK_PIPE] = ACTIONS(211),
    [anon_sym_LBRACE] = ACTIONS(1687),
    [anon_sym_LT_AT] = ACTIONS(213),
    [anon_sym_LT_AT_AT] = ACTIONS(1689),
    [anon_sym_LBRACE_PIPE] = ACTIONS(217),
    [anon_sym_new] = ACTIONS(199),
    [anon_sym_return_BANG] = ACTIONS(219),
    [anon_sym_yield] = ACTIONS(199),
    [anon_sym_yield_BANG] = ACTIONS(219),
    [anon_sym_lazy] = ACTIONS(199),
    [anon_sym_assert] = ACTIONS(199),
    [anon_sym_upcast] = ACTIONS(199),
    [anon_sym_downcast] = ACTIONS(199),
    [anon_sym_for] = ACTIONS(223),
    [anon_sym_while] = ACTIONS(225),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(229),
    [anon_sym_match] = ACTIONS(231),
    [anon_sym_match_BANG] = ACTIONS(233),
    [anon_sym_function] = ACTIONS(235),
    [anon_sym_use] = ACTIONS(239),
    [anon_sym_use_BANG] = ACTIONS(241),
    [anon_sym_do_BANG] = ACTIONS(243),
    [anon_sym_begin] = ACTIONS(245),
    [aux_sym_char_token1] = ACTIONS(247),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(251),
    [anon_sym_AT_DQUOTE] = ACTIONS(253),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(255),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(257),
    [sym_bool] = ACTIONS(259),
    [sym_unit] = ACTIONS(1699),
    [anon_sym_LPAREN_PIPE] = ACTIONS(261),
    [sym_op_identifier] = ACTIONS(1701),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(265),
    [sym_xint] = ACTIONS(267),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(269),
  },
  [733] = {
    [sym_function_or_value_defn] = STATE(733),
    [sym__expression] = STATE(152),
    [sym_literal_expression] = STATE(2008),
    [sym_long_identifier_or_op] = STATE(2008),
    [sym_tuple_expression] = STATE(2008),
    [sym_brace_expression] = STATE(2008),
    [sym_anon_record_expression] = STATE(2008),
    [sym_prefixed_expression] = STATE(2008),
    [sym_typecast_expression] = STATE(2008),
    [sym_for_expression] = STATE(2008),
    [sym_while_expression] = STATE(2008),
    [sym__if_branch] = STATE(6754),
    [sym_if_expression] = STATE(2008),
    [sym_fun_expression] = STATE(2008),
    [sym_try_expression] = STATE(2008),
    [sym_match_expression] = STATE(2008),
    [sym_function_expression] = STATE(2008),
    [sym_mutate_expression] = STATE(2008),
    [sym_index_expression] = STATE(2008),
    [sym_typed_expression] = STATE(2008),
    [sym_declaration_expression] = STATE(2008),
    [sym_do_expression] = STATE(2008),
    [sym_list_expression] = STATE(2008),
    [sym_array_expression] = STATE(2008),
    [sym_begin_end_expression] = STATE(2008),
    [sym_paren_expression] = STATE(2008),
    [sym__high_prec_app] = STATE(2007),
    [sym__low_prec_app] = STATE(2007),
    [sym_application_expression] = STATE(2008),
    [sym_dot_expression] = STATE(2008),
    [sym_infix_expression] = STATE(2008),
    [sym_ce_expression] = STATE(2008),
    [sym_sequential_expression] = STATE(2008),
    [sym_char] = STATE(1859),
    [sym_format_string] = STATE(1861),
    [sym__string_literal] = STATE(1861),
    [sym_string] = STATE(1859),
    [sym_verbatim_string] = STATE(1859),
    [sym_bytearray] = STATE(1859),
    [sym_verbatim_bytearray] = STATE(1859),
    [sym_format_triple_quoted_string] = STATE(1862),
    [sym_triple_quoted_string] = STATE(1859),
    [sym_const] = STATE(2008),
    [sym_long_identifier] = STATE(1701),
    [sym_active_pattern] = STATE(1702),
    [sym__identifier_or_op] = STATE(1724),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(706),
    [sym_sbyte] = STATE(1859),
    [sym_byte] = STATE(1859),
    [sym_int16] = STATE(1859),
    [sym_uint16] = STATE(1859),
    [sym_int32] = STATE(1859),
    [sym_uint32] = STATE(1859),
    [sym_nativeint] = STATE(1859),
    [sym_unativeint] = STATE(1859),
    [sym_int64] = STATE(1859),
    [sym_uint64] = STATE(1859),
    [sym_ieee32] = STATE(1859),
    [sym_ieee64] = STATE(1859),
    [sym_bignum] = STATE(1859),
    [sym_decimal] = STATE(1859),
    [sym_float] = STATE(1447),
    [sym_block_comment] = STATE(733),
    [sym_compiler_directive_decl] = STATE(733),
    [sym_fsi_directive_decl] = STATE(733),
    [sym_preproc_line] = STATE(733),
    [sym_preproc_if_in_expression] = STATE(2008),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(503),
    [anon_sym_return] = ACTIONS(971),
    [anon_sym_do] = ACTIONS(599),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(511),
    [anon_sym_null] = ACTIONS(515),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(517),
    [anon_sym_LBRACK_PIPE] = ACTIONS(519),
    [anon_sym_LBRACE] = ACTIONS(2060),
    [anon_sym_LT_AT] = ACTIONS(523),
    [anon_sym_LT_AT_AT] = ACTIONS(2062),
    [anon_sym_LBRACE_PIPE] = ACTIONS(529),
    [anon_sym_new] = ACTIONS(971),
    [anon_sym_return_BANG] = ACTIONS(975),
    [anon_sym_yield] = ACTIONS(971),
    [anon_sym_yield_BANG] = ACTIONS(975),
    [anon_sym_lazy] = ACTIONS(971),
    [anon_sym_assert] = ACTIONS(971),
    [anon_sym_upcast] = ACTIONS(971),
    [anon_sym_downcast] = ACTIONS(971),
    [anon_sym_for] = ACTIONS(979),
    [anon_sym_while] = ACTIONS(537),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(539),
    [anon_sym_try] = ACTIONS(543),
    [anon_sym_match] = ACTIONS(545),
    [anon_sym_match_BANG] = ACTIONS(547),
    [anon_sym_function] = ACTIONS(549),
    [anon_sym_use] = ACTIONS(983),
    [anon_sym_use_BANG] = ACTIONS(985),
    [anon_sym_do_BANG] = ACTIONS(561),
    [anon_sym_begin] = ACTIONS(565),
    [aux_sym_char_token1] = ACTIONS(569),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(571),
    [anon_sym_DQUOTE] = ACTIONS(573),
    [anon_sym_AT_DQUOTE] = ACTIONS(575),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(577),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(579),
    [sym_bool] = ACTIONS(581),
    [sym_unit] = ACTIONS(2064),
    [anon_sym_LPAREN_PIPE] = ACTIONS(585),
    [sym_op_identifier] = ACTIONS(2066),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(987),
    [sym_xint] = ACTIONS(591),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(593),
  },
  [734] = {
    [sym_function_or_value_defn] = STATE(509),
    [sym__expression] = STATE(309),
    [sym_literal_expression] = STATE(2230),
    [sym_long_identifier_or_op] = STATE(2230),
    [sym_tuple_expression] = STATE(2230),
    [sym_brace_expression] = STATE(2230),
    [sym_anon_record_expression] = STATE(2230),
    [sym_prefixed_expression] = STATE(2230),
    [sym_typecast_expression] = STATE(2230),
    [sym_for_expression] = STATE(2230),
    [sym_while_expression] = STATE(2230),
    [sym__if_branch] = STATE(6659),
    [sym_if_expression] = STATE(2230),
    [sym_fun_expression] = STATE(2230),
    [sym_try_expression] = STATE(2230),
    [sym_match_expression] = STATE(2230),
    [sym_function_expression] = STATE(2230),
    [sym_mutate_expression] = STATE(2230),
    [sym_index_expression] = STATE(2230),
    [sym_typed_expression] = STATE(2230),
    [sym_declaration_expression] = STATE(2230),
    [sym_do_expression] = STATE(2230),
    [sym_list_expression] = STATE(2230),
    [sym_array_expression] = STATE(2230),
    [sym_begin_end_expression] = STATE(2230),
    [sym_paren_expression] = STATE(2230),
    [sym__high_prec_app] = STATE(2229),
    [sym__low_prec_app] = STATE(2229),
    [sym_application_expression] = STATE(2230),
    [sym_dot_expression] = STATE(2230),
    [sym_infix_expression] = STATE(2230),
    [sym_ce_expression] = STATE(2230),
    [sym_sequential_expression] = STATE(2230),
    [sym_char] = STATE(2100),
    [sym_format_string] = STATE(2106),
    [sym__string_literal] = STATE(2106),
    [sym_string] = STATE(2100),
    [sym_verbatim_string] = STATE(2100),
    [sym_bytearray] = STATE(2100),
    [sym_verbatim_bytearray] = STATE(2100),
    [sym_format_triple_quoted_string] = STATE(2107),
    [sym_triple_quoted_string] = STATE(2100),
    [sym_const] = STATE(2230),
    [sym_long_identifier] = STATE(2232),
    [sym_active_pattern] = STATE(2424),
    [sym__identifier_or_op] = STATE(2305),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(737),
    [sym_sbyte] = STATE(2100),
    [sym_byte] = STATE(2100),
    [sym_int16] = STATE(2100),
    [sym_uint16] = STATE(2100),
    [sym_int32] = STATE(2100),
    [sym_uint32] = STATE(2100),
    [sym_nativeint] = STATE(2100),
    [sym_unativeint] = STATE(2100),
    [sym_int64] = STATE(2100),
    [sym_uint64] = STATE(2100),
    [sym_ieee32] = STATE(2100),
    [sym_ieee64] = STATE(2100),
    [sym_bignum] = STATE(2100),
    [sym_decimal] = STATE(2100),
    [sym_float] = STATE(1487),
    [sym_block_comment] = STATE(734),
    [sym_compiler_directive_decl] = STATE(734),
    [sym_fsi_directive_decl] = STATE(734),
    [sym_preproc_line] = STATE(734),
    [sym_preproc_if_in_expression] = STATE(2230),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(877),
    [anon_sym_return] = ACTIONS(881),
    [anon_sym_do] = ACTIONS(1585),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(885),
    [anon_sym_null] = ACTIONS(889),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(891),
    [anon_sym_LBRACK_PIPE] = ACTIONS(893),
    [anon_sym_LBRACE] = ACTIONS(2048),
    [anon_sym_LT_AT] = ACTIONS(897),
    [anon_sym_LT_AT_AT] = ACTIONS(2050),
    [anon_sym_LBRACE_PIPE] = ACTIONS(903),
    [anon_sym_new] = ACTIONS(881),
    [anon_sym_return_BANG] = ACTIONS(905),
    [anon_sym_yield] = ACTIONS(881),
    [anon_sym_yield_BANG] = ACTIONS(905),
    [anon_sym_lazy] = ACTIONS(881),
    [anon_sym_assert] = ACTIONS(881),
    [anon_sym_upcast] = ACTIONS(881),
    [anon_sym_downcast] = ACTIONS(881),
    [anon_sym_for] = ACTIONS(909),
    [anon_sym_while] = ACTIONS(911),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(913),
    [anon_sym_try] = ACTIONS(915),
    [anon_sym_match] = ACTIONS(917),
    [anon_sym_match_BANG] = ACTIONS(919),
    [anon_sym_function] = ACTIONS(921),
    [anon_sym_use] = ACTIONS(929),
    [anon_sym_use_BANG] = ACTIONS(931),
    [anon_sym_do_BANG] = ACTIONS(933),
    [anon_sym_begin] = ACTIONS(937),
    [aux_sym_char_token1] = ACTIONS(941),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(943),
    [anon_sym_DQUOTE] = ACTIONS(945),
    [anon_sym_AT_DQUOTE] = ACTIONS(947),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(949),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(951),
    [sym_bool] = ACTIONS(953),
    [sym_unit] = ACTIONS(2052),
    [anon_sym_LPAREN_PIPE] = ACTIONS(957),
    [sym_op_identifier] = ACTIONS(2054),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(961),
    [sym_xint] = ACTIONS(963),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(965),
  },
  [735] = {
    [sym_function_or_value_defn] = STATE(651),
    [sym__expression] = STATE(178),
    [sym_literal_expression] = STATE(2168),
    [sym_long_identifier_or_op] = STATE(2168),
    [sym_tuple_expression] = STATE(2168),
    [sym_brace_expression] = STATE(2168),
    [sym_anon_record_expression] = STATE(2168),
    [sym_prefixed_expression] = STATE(2168),
    [sym_typecast_expression] = STATE(2168),
    [sym_for_expression] = STATE(2168),
    [sym_while_expression] = STATE(2168),
    [sym__if_branch] = STATE(6406),
    [sym_if_expression] = STATE(2168),
    [sym_fun_expression] = STATE(2168),
    [sym_try_expression] = STATE(2168),
    [sym_match_expression] = STATE(2168),
    [sym_function_expression] = STATE(2168),
    [sym_mutate_expression] = STATE(2168),
    [sym_index_expression] = STATE(2168),
    [sym_typed_expression] = STATE(2168),
    [sym_declaration_expression] = STATE(2168),
    [sym_do_expression] = STATE(2168),
    [sym_list_expression] = STATE(2168),
    [sym_array_expression] = STATE(2168),
    [sym_begin_end_expression] = STATE(2168),
    [sym_paren_expression] = STATE(2168),
    [sym__high_prec_app] = STATE(2179),
    [sym__low_prec_app] = STATE(2179),
    [sym_application_expression] = STATE(2168),
    [sym_dot_expression] = STATE(2168),
    [sym_infix_expression] = STATE(2168),
    [sym_ce_expression] = STATE(2168),
    [sym_sequential_expression] = STATE(2168),
    [sym_char] = STATE(2469),
    [sym_format_string] = STATE(2412),
    [sym__string_literal] = STATE(2412),
    [sym_string] = STATE(2469),
    [sym_verbatim_string] = STATE(2469),
    [sym_bytearray] = STATE(2469),
    [sym_verbatim_bytearray] = STATE(2469),
    [sym_format_triple_quoted_string] = STATE(2408),
    [sym_triple_quoted_string] = STATE(2469),
    [sym_const] = STATE(2168),
    [sym_long_identifier] = STATE(2183),
    [sym_active_pattern] = STATE(2182),
    [sym__identifier_or_op] = STATE(2093),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(650),
    [sym_sbyte] = STATE(2469),
    [sym_byte] = STATE(2469),
    [sym_int16] = STATE(2469),
    [sym_uint16] = STATE(2469),
    [sym_int32] = STATE(2469),
    [sym_uint32] = STATE(2469),
    [sym_nativeint] = STATE(2469),
    [sym_unativeint] = STATE(2469),
    [sym_int64] = STATE(2469),
    [sym_uint64] = STATE(2469),
    [sym_ieee32] = STATE(2469),
    [sym_ieee64] = STATE(2469),
    [sym_bignum] = STATE(2469),
    [sym_decimal] = STATE(2469),
    [sym_float] = STATE(1586),
    [sym_block_comment] = STATE(735),
    [sym_compiler_directive_decl] = STATE(735),
    [sym_fsi_directive_decl] = STATE(735),
    [sym_preproc_line] = STATE(735),
    [sym_preproc_if_in_expression] = STATE(2168),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(989),
    [anon_sym_return] = ACTIONS(993),
    [anon_sym_do] = ACTIONS(995),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(997),
    [anon_sym_null] = ACTIONS(1001),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1003),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1005),
    [anon_sym_LBRACE] = ACTIONS(2070),
    [anon_sym_LT_AT] = ACTIONS(1009),
    [anon_sym_LT_AT_AT] = ACTIONS(2072),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1017),
    [anon_sym_new] = ACTIONS(993),
    [anon_sym_return_BANG] = ACTIONS(1019),
    [anon_sym_yield] = ACTIONS(993),
    [anon_sym_yield_BANG] = ACTIONS(1019),
    [anon_sym_lazy] = ACTIONS(993),
    [anon_sym_assert] = ACTIONS(993),
    [anon_sym_upcast] = ACTIONS(993),
    [anon_sym_downcast] = ACTIONS(993),
    [anon_sym_for] = ACTIONS(1023),
    [anon_sym_while] = ACTIONS(1025),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(1027),
    [anon_sym_try] = ACTIONS(1029),
    [anon_sym_match] = ACTIONS(1031),
    [anon_sym_match_BANG] = ACTIONS(1033),
    [anon_sym_function] = ACTIONS(1035),
    [anon_sym_use] = ACTIONS(1043),
    [anon_sym_use_BANG] = ACTIONS(1045),
    [anon_sym_do_BANG] = ACTIONS(1047),
    [anon_sym_begin] = ACTIONS(1049),
    [aux_sym_char_token1] = ACTIONS(1053),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1055),
    [anon_sym_DQUOTE] = ACTIONS(1057),
    [anon_sym_AT_DQUOTE] = ACTIONS(1059),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1061),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1063),
    [sym_bool] = ACTIONS(1065),
    [sym_unit] = ACTIONS(2074),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1069),
    [sym_op_identifier] = ACTIONS(2076),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(1073),
    [sym_xint] = ACTIONS(1075),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1077),
  },
  [736] = {
    [sym_function_or_value_defn] = STATE(600),
    [sym__expression] = STATE(197),
    [sym_literal_expression] = STATE(867),
    [sym_long_identifier_or_op] = STATE(867),
    [sym_tuple_expression] = STATE(867),
    [sym_brace_expression] = STATE(867),
    [sym_anon_record_expression] = STATE(867),
    [sym_prefixed_expression] = STATE(867),
    [sym_typecast_expression] = STATE(867),
    [sym_for_expression] = STATE(867),
    [sym_while_expression] = STATE(867),
    [sym__if_branch] = STATE(6511),
    [sym_if_expression] = STATE(867),
    [sym_fun_expression] = STATE(867),
    [sym_try_expression] = STATE(867),
    [sym_match_expression] = STATE(867),
    [sym_function_expression] = STATE(867),
    [sym_mutate_expression] = STATE(867),
    [sym_index_expression] = STATE(867),
    [sym_typed_expression] = STATE(867),
    [sym_declaration_expression] = STATE(867),
    [sym_do_expression] = STATE(867),
    [sym_list_expression] = STATE(867),
    [sym_array_expression] = STATE(867),
    [sym_begin_end_expression] = STATE(867),
    [sym_paren_expression] = STATE(867),
    [sym__high_prec_app] = STATE(864),
    [sym__low_prec_app] = STATE(864),
    [sym_application_expression] = STATE(867),
    [sym_dot_expression] = STATE(867),
    [sym_infix_expression] = STATE(867),
    [sym_ce_expression] = STATE(867),
    [sym_sequential_expression] = STATE(867),
    [sym_char] = STATE(868),
    [sym_format_string] = STATE(869),
    [sym__string_literal] = STATE(869),
    [sym_string] = STATE(868),
    [sym_verbatim_string] = STATE(868),
    [sym_bytearray] = STATE(868),
    [sym_verbatim_bytearray] = STATE(868),
    [sym_format_triple_quoted_string] = STATE(870),
    [sym_triple_quoted_string] = STATE(868),
    [sym_const] = STATE(867),
    [sym_long_identifier] = STATE(872),
    [sym_active_pattern] = STATE(871),
    [sym__identifier_or_op] = STATE(873),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(656),
    [sym_sbyte] = STATE(868),
    [sym_byte] = STATE(868),
    [sym_int16] = STATE(868),
    [sym_uint16] = STATE(868),
    [sym_int32] = STATE(868),
    [sym_uint32] = STATE(868),
    [sym_nativeint] = STATE(868),
    [sym_unativeint] = STATE(868),
    [sym_int64] = STATE(868),
    [sym_uint64] = STATE(868),
    [sym_ieee32] = STATE(868),
    [sym_ieee64] = STATE(868),
    [sym_bignum] = STATE(868),
    [sym_decimal] = STATE(868),
    [sym_float] = STATE(1368),
    [sym_block_comment] = STATE(736),
    [sym_compiler_directive_decl] = STATE(736),
    [sym_fsi_directive_decl] = STATE(736),
    [sym_preproc_line] = STATE(736),
    [sym_preproc_if_in_expression] = STATE(867),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(29),
    [anon_sym_return] = ACTIONS(825),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_null] = ACTIONS(49),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACK_PIPE] = ACTIONS(57),
    [anon_sym_LBRACE] = ACTIONS(1663),
    [anon_sym_LT_AT] = ACTIONS(61),
    [anon_sym_LT_AT_AT] = ACTIONS(1665),
    [anon_sym_LBRACE_PIPE] = ACTIONS(67),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_return_BANG] = ACTIONS(829),
    [anon_sym_yield] = ACTIONS(825),
    [anon_sym_yield_BANG] = ACTIONS(829),
    [anon_sym_lazy] = ACTIONS(825),
    [anon_sym_assert] = ACTIONS(825),
    [anon_sym_upcast] = ACTIONS(825),
    [anon_sym_downcast] = ACTIONS(825),
    [anon_sym_for] = ACTIONS(73),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(79),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_match] = ACTIONS(83),
    [anon_sym_match_BANG] = ACTIONS(85),
    [anon_sym_function] = ACTIONS(87),
    [anon_sym_use] = ACTIONS(833),
    [anon_sym_use_BANG] = ACTIONS(835),
    [anon_sym_do_BANG] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(101),
    [aux_sym_char_token1] = ACTIONS(105),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(107),
    [anon_sym_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DQUOTE] = ACTIONS(111),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(115),
    [sym_bool] = ACTIONS(117),
    [sym_unit] = ACTIONS(1673),
    [anon_sym_LPAREN_PIPE] = ACTIONS(121),
    [sym_op_identifier] = ACTIONS(1675),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(837),
    [sym_xint] = ACTIONS(387),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(135),
  },
  [737] = {
    [sym_function_or_value_defn] = STATE(509),
    [sym__expression] = STATE(318),
    [sym_literal_expression] = STATE(2230),
    [sym_long_identifier_or_op] = STATE(2230),
    [sym_tuple_expression] = STATE(2230),
    [sym_brace_expression] = STATE(2230),
    [sym_anon_record_expression] = STATE(2230),
    [sym_prefixed_expression] = STATE(2230),
    [sym_typecast_expression] = STATE(2230),
    [sym_for_expression] = STATE(2230),
    [sym_while_expression] = STATE(2230),
    [sym__if_branch] = STATE(6659),
    [sym_if_expression] = STATE(2230),
    [sym_fun_expression] = STATE(2230),
    [sym_try_expression] = STATE(2230),
    [sym_match_expression] = STATE(2230),
    [sym_function_expression] = STATE(2230),
    [sym_mutate_expression] = STATE(2230),
    [sym_index_expression] = STATE(2230),
    [sym_typed_expression] = STATE(2230),
    [sym_declaration_expression] = STATE(2230),
    [sym_do_expression] = STATE(2230),
    [sym_list_expression] = STATE(2230),
    [sym_array_expression] = STATE(2230),
    [sym_begin_end_expression] = STATE(2230),
    [sym_paren_expression] = STATE(2230),
    [sym__high_prec_app] = STATE(2229),
    [sym__low_prec_app] = STATE(2229),
    [sym_application_expression] = STATE(2230),
    [sym_dot_expression] = STATE(2230),
    [sym_infix_expression] = STATE(2230),
    [sym_ce_expression] = STATE(2230),
    [sym_sequential_expression] = STATE(2230),
    [sym_char] = STATE(2100),
    [sym_format_string] = STATE(2106),
    [sym__string_literal] = STATE(2106),
    [sym_string] = STATE(2100),
    [sym_verbatim_string] = STATE(2100),
    [sym_bytearray] = STATE(2100),
    [sym_verbatim_bytearray] = STATE(2100),
    [sym_format_triple_quoted_string] = STATE(2107),
    [sym_triple_quoted_string] = STATE(2100),
    [sym_const] = STATE(2230),
    [sym_long_identifier] = STATE(2232),
    [sym_active_pattern] = STATE(2424),
    [sym__identifier_or_op] = STATE(2305),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(737),
    [sym_sbyte] = STATE(2100),
    [sym_byte] = STATE(2100),
    [sym_int16] = STATE(2100),
    [sym_uint16] = STATE(2100),
    [sym_int32] = STATE(2100),
    [sym_uint32] = STATE(2100),
    [sym_nativeint] = STATE(2100),
    [sym_unativeint] = STATE(2100),
    [sym_int64] = STATE(2100),
    [sym_uint64] = STATE(2100),
    [sym_ieee32] = STATE(2100),
    [sym_ieee64] = STATE(2100),
    [sym_bignum] = STATE(2100),
    [sym_decimal] = STATE(2100),
    [sym_float] = STATE(1487),
    [sym_block_comment] = STATE(737),
    [sym_compiler_directive_decl] = STATE(737),
    [sym_fsi_directive_decl] = STATE(737),
    [sym_preproc_line] = STATE(737),
    [sym_preproc_if_in_expression] = STATE(2230),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(877),
    [anon_sym_return] = ACTIONS(881),
    [anon_sym_do] = ACTIONS(1585),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(885),
    [anon_sym_null] = ACTIONS(889),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(891),
    [anon_sym_LBRACK_PIPE] = ACTIONS(893),
    [anon_sym_LBRACE] = ACTIONS(2048),
    [anon_sym_LT_AT] = ACTIONS(897),
    [anon_sym_LT_AT_AT] = ACTIONS(2050),
    [anon_sym_LBRACE_PIPE] = ACTIONS(903),
    [anon_sym_new] = ACTIONS(881),
    [anon_sym_return_BANG] = ACTIONS(905),
    [anon_sym_yield] = ACTIONS(881),
    [anon_sym_yield_BANG] = ACTIONS(905),
    [anon_sym_lazy] = ACTIONS(881),
    [anon_sym_assert] = ACTIONS(881),
    [anon_sym_upcast] = ACTIONS(881),
    [anon_sym_downcast] = ACTIONS(881),
    [anon_sym_for] = ACTIONS(909),
    [anon_sym_while] = ACTIONS(911),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(913),
    [anon_sym_try] = ACTIONS(915),
    [anon_sym_match] = ACTIONS(917),
    [anon_sym_match_BANG] = ACTIONS(919),
    [anon_sym_function] = ACTIONS(921),
    [anon_sym_use] = ACTIONS(929),
    [anon_sym_use_BANG] = ACTIONS(931),
    [anon_sym_do_BANG] = ACTIONS(933),
    [anon_sym_begin] = ACTIONS(937),
    [aux_sym_char_token1] = ACTIONS(941),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(943),
    [anon_sym_DQUOTE] = ACTIONS(945),
    [anon_sym_AT_DQUOTE] = ACTIONS(947),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(949),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(951),
    [sym_bool] = ACTIONS(953),
    [sym_unit] = ACTIONS(2052),
    [anon_sym_LPAREN_PIPE] = ACTIONS(957),
    [sym_op_identifier] = ACTIONS(2054),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(961),
    [sym_xint] = ACTIONS(963),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(965),
  },
  [738] = {
    [sym_function_or_value_defn] = STATE(729),
    [sym__expression] = STATE(57),
    [sym_literal_expression] = STATE(867),
    [sym_long_identifier_or_op] = STATE(867),
    [sym_tuple_expression] = STATE(867),
    [sym_brace_expression] = STATE(867),
    [sym_anon_record_expression] = STATE(867),
    [sym_prefixed_expression] = STATE(867),
    [sym_typecast_expression] = STATE(867),
    [sym_for_expression] = STATE(867),
    [sym_while_expression] = STATE(867),
    [sym__if_branch] = STATE(6511),
    [sym_if_expression] = STATE(867),
    [sym_fun_expression] = STATE(867),
    [sym_try_expression] = STATE(867),
    [sym_match_expression] = STATE(867),
    [sym_function_expression] = STATE(867),
    [sym_mutate_expression] = STATE(867),
    [sym_index_expression] = STATE(867),
    [sym_typed_expression] = STATE(867),
    [sym_declaration_expression] = STATE(867),
    [sym_do_expression] = STATE(867),
    [sym_list_expression] = STATE(867),
    [sym_array_expression] = STATE(867),
    [sym_begin_end_expression] = STATE(867),
    [sym_paren_expression] = STATE(867),
    [sym__high_prec_app] = STATE(864),
    [sym__low_prec_app] = STATE(864),
    [sym_application_expression] = STATE(867),
    [sym_dot_expression] = STATE(867),
    [sym_infix_expression] = STATE(867),
    [sym_ce_expression] = STATE(867),
    [sym_sequential_expression] = STATE(867),
    [sym_char] = STATE(868),
    [sym_format_string] = STATE(869),
    [sym__string_literal] = STATE(869),
    [sym_string] = STATE(868),
    [sym_verbatim_string] = STATE(868),
    [sym_bytearray] = STATE(868),
    [sym_verbatim_bytearray] = STATE(868),
    [sym_format_triple_quoted_string] = STATE(870),
    [sym_triple_quoted_string] = STATE(868),
    [sym_const] = STATE(867),
    [sym_long_identifier] = STATE(872),
    [sym_active_pattern] = STATE(871),
    [sym__identifier_or_op] = STATE(873),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(499),
    [sym_sbyte] = STATE(868),
    [sym_byte] = STATE(868),
    [sym_int16] = STATE(868),
    [sym_uint16] = STATE(868),
    [sym_int32] = STATE(868),
    [sym_uint32] = STATE(868),
    [sym_nativeint] = STATE(868),
    [sym_unativeint] = STATE(868),
    [sym_int64] = STATE(868),
    [sym_uint64] = STATE(868),
    [sym_ieee32] = STATE(868),
    [sym_ieee64] = STATE(868),
    [sym_bignum] = STATE(868),
    [sym_decimal] = STATE(868),
    [sym_float] = STATE(1368),
    [sym_block_comment] = STATE(738),
    [sym_compiler_directive_decl] = STATE(738),
    [sym_fsi_directive_decl] = STATE(738),
    [sym_preproc_line] = STATE(738),
    [sym_preproc_if_in_expression] = STATE(867),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(29),
    [anon_sym_return] = ACTIONS(369),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_null] = ACTIONS(49),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACK_PIPE] = ACTIONS(57),
    [anon_sym_LBRACE] = ACTIONS(1663),
    [anon_sym_LT_AT] = ACTIONS(61),
    [anon_sym_LT_AT_AT] = ACTIONS(1665),
    [anon_sym_LBRACE_PIPE] = ACTIONS(67),
    [anon_sym_new] = ACTIONS(369),
    [anon_sym_return_BANG] = ACTIONS(373),
    [anon_sym_yield] = ACTIONS(369),
    [anon_sym_yield_BANG] = ACTIONS(373),
    [anon_sym_lazy] = ACTIONS(369),
    [anon_sym_assert] = ACTIONS(369),
    [anon_sym_upcast] = ACTIONS(369),
    [anon_sym_downcast] = ACTIONS(369),
    [anon_sym_for] = ACTIONS(375),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(79),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_match] = ACTIONS(83),
    [anon_sym_match_BANG] = ACTIONS(85),
    [anon_sym_function] = ACTIONS(87),
    [anon_sym_use] = ACTIONS(379),
    [anon_sym_use_BANG] = ACTIONS(381),
    [anon_sym_do_BANG] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(101),
    [aux_sym_char_token1] = ACTIONS(105),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(107),
    [anon_sym_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DQUOTE] = ACTIONS(111),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(115),
    [sym_bool] = ACTIONS(117),
    [sym_unit] = ACTIONS(1673),
    [anon_sym_LPAREN_PIPE] = ACTIONS(121),
    [sym_op_identifier] = ACTIONS(1675),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(385),
    [sym_xint] = ACTIONS(387),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(135),
  },
  [739] = {
    [sym_function_or_value_defn] = STATE(600),
    [sym__expression] = STATE(196),
    [sym_literal_expression] = STATE(867),
    [sym_long_identifier_or_op] = STATE(867),
    [sym_tuple_expression] = STATE(867),
    [sym_brace_expression] = STATE(867),
    [sym_anon_record_expression] = STATE(867),
    [sym_prefixed_expression] = STATE(867),
    [sym_typecast_expression] = STATE(867),
    [sym_for_expression] = STATE(867),
    [sym_while_expression] = STATE(867),
    [sym__if_branch] = STATE(6511),
    [sym_if_expression] = STATE(867),
    [sym_fun_expression] = STATE(867),
    [sym_try_expression] = STATE(867),
    [sym_match_expression] = STATE(867),
    [sym_function_expression] = STATE(867),
    [sym_mutate_expression] = STATE(867),
    [sym_index_expression] = STATE(867),
    [sym_typed_expression] = STATE(867),
    [sym_declaration_expression] = STATE(867),
    [sym_do_expression] = STATE(867),
    [sym_list_expression] = STATE(867),
    [sym_array_expression] = STATE(867),
    [sym_begin_end_expression] = STATE(867),
    [sym_paren_expression] = STATE(867),
    [sym__high_prec_app] = STATE(864),
    [sym__low_prec_app] = STATE(864),
    [sym_application_expression] = STATE(867),
    [sym_dot_expression] = STATE(867),
    [sym_infix_expression] = STATE(867),
    [sym_ce_expression] = STATE(867),
    [sym_sequential_expression] = STATE(867),
    [sym_char] = STATE(868),
    [sym_format_string] = STATE(869),
    [sym__string_literal] = STATE(869),
    [sym_string] = STATE(868),
    [sym_verbatim_string] = STATE(868),
    [sym_bytearray] = STATE(868),
    [sym_verbatim_bytearray] = STATE(868),
    [sym_format_triple_quoted_string] = STATE(870),
    [sym_triple_quoted_string] = STATE(868),
    [sym_const] = STATE(867),
    [sym_long_identifier] = STATE(872),
    [sym_active_pattern] = STATE(871),
    [sym__identifier_or_op] = STATE(873),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(656),
    [sym_sbyte] = STATE(868),
    [sym_byte] = STATE(868),
    [sym_int16] = STATE(868),
    [sym_uint16] = STATE(868),
    [sym_int32] = STATE(868),
    [sym_uint32] = STATE(868),
    [sym_nativeint] = STATE(868),
    [sym_unativeint] = STATE(868),
    [sym_int64] = STATE(868),
    [sym_uint64] = STATE(868),
    [sym_ieee32] = STATE(868),
    [sym_ieee64] = STATE(868),
    [sym_bignum] = STATE(868),
    [sym_decimal] = STATE(868),
    [sym_float] = STATE(1368),
    [sym_block_comment] = STATE(739),
    [sym_compiler_directive_decl] = STATE(739),
    [sym_fsi_directive_decl] = STATE(739),
    [sym_preproc_line] = STATE(739),
    [sym_preproc_if_in_expression] = STATE(867),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(29),
    [anon_sym_return] = ACTIONS(825),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_null] = ACTIONS(49),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACK_PIPE] = ACTIONS(57),
    [anon_sym_LBRACE] = ACTIONS(1663),
    [anon_sym_LT_AT] = ACTIONS(61),
    [anon_sym_LT_AT_AT] = ACTIONS(1665),
    [anon_sym_LBRACE_PIPE] = ACTIONS(67),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_return_BANG] = ACTIONS(829),
    [anon_sym_yield] = ACTIONS(825),
    [anon_sym_yield_BANG] = ACTIONS(829),
    [anon_sym_lazy] = ACTIONS(825),
    [anon_sym_assert] = ACTIONS(825),
    [anon_sym_upcast] = ACTIONS(825),
    [anon_sym_downcast] = ACTIONS(825),
    [anon_sym_for] = ACTIONS(73),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(79),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_match] = ACTIONS(83),
    [anon_sym_match_BANG] = ACTIONS(85),
    [anon_sym_function] = ACTIONS(87),
    [anon_sym_use] = ACTIONS(833),
    [anon_sym_use_BANG] = ACTIONS(835),
    [anon_sym_do_BANG] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(101),
    [aux_sym_char_token1] = ACTIONS(105),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(107),
    [anon_sym_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DQUOTE] = ACTIONS(111),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(115),
    [sym_bool] = ACTIONS(117),
    [sym_unit] = ACTIONS(1673),
    [anon_sym_LPAREN_PIPE] = ACTIONS(121),
    [sym_op_identifier] = ACTIONS(1675),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(837),
    [sym_xint] = ACTIONS(387),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(135),
  },
  [740] = {
    [sym_function_or_value_defn] = STATE(630),
    [sym__expression] = STATE(179),
    [sym_literal_expression] = STATE(2380),
    [sym_long_identifier_or_op] = STATE(2380),
    [sym_tuple_expression] = STATE(2380),
    [sym_brace_expression] = STATE(2380),
    [sym_anon_record_expression] = STATE(2380),
    [sym_prefixed_expression] = STATE(2380),
    [sym_typecast_expression] = STATE(2380),
    [sym_for_expression] = STATE(2380),
    [sym_while_expression] = STATE(2380),
    [sym__if_branch] = STATE(6456),
    [sym_if_expression] = STATE(2380),
    [sym_fun_expression] = STATE(2380),
    [sym_try_expression] = STATE(2380),
    [sym_match_expression] = STATE(2380),
    [sym_function_expression] = STATE(2380),
    [sym_mutate_expression] = STATE(2380),
    [sym_index_expression] = STATE(2380),
    [sym_typed_expression] = STATE(2380),
    [sym_declaration_expression] = STATE(2380),
    [sym_do_expression] = STATE(2380),
    [sym_list_expression] = STATE(2380),
    [sym_array_expression] = STATE(2380),
    [sym_begin_end_expression] = STATE(2380),
    [sym_paren_expression] = STATE(2380),
    [sym__high_prec_app] = STATE(2383),
    [sym__low_prec_app] = STATE(2383),
    [sym_application_expression] = STATE(2380),
    [sym_dot_expression] = STATE(2380),
    [sym_infix_expression] = STATE(2380),
    [sym_ce_expression] = STATE(2380),
    [sym_sequential_expression] = STATE(2380),
    [sym_char] = STATE(2261),
    [sym_format_string] = STATE(2274),
    [sym__string_literal] = STATE(2274),
    [sym_string] = STATE(2261),
    [sym_verbatim_string] = STATE(2261),
    [sym_bytearray] = STATE(2261),
    [sym_verbatim_bytearray] = STATE(2261),
    [sym_format_triple_quoted_string] = STATE(2275),
    [sym_triple_quoted_string] = STATE(2261),
    [sym_const] = STATE(2380),
    [sym_long_identifier] = STATE(2391),
    [sym_active_pattern] = STATE(2470),
    [sym__identifier_or_op] = STATE(2390),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(632),
    [sym_sbyte] = STATE(2261),
    [sym_byte] = STATE(2261),
    [sym_int16] = STATE(2261),
    [sym_uint16] = STATE(2261),
    [sym_int32] = STATE(2261),
    [sym_uint32] = STATE(2261),
    [sym_nativeint] = STATE(2261),
    [sym_unativeint] = STATE(2261),
    [sym_int64] = STATE(2261),
    [sym_uint64] = STATE(2261),
    [sym_ieee32] = STATE(2261),
    [sym_ieee64] = STATE(2261),
    [sym_bignum] = STATE(2261),
    [sym_decimal] = STATE(2261),
    [sym_float] = STATE(1614),
    [sym_block_comment] = STATE(740),
    [sym_compiler_directive_decl] = STATE(740),
    [sym_fsi_directive_decl] = STATE(740),
    [sym_preproc_line] = STATE(740),
    [sym_preproc_if_in_expression] = STATE(2380),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(1081),
    [anon_sym_return] = ACTIONS(1085),
    [anon_sym_do] = ACTIONS(1087),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(1089),
    [anon_sym_null] = ACTIONS(1093),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1095),
    [anon_sym_LBRACK_PIPE] = ACTIONS(1097),
    [anon_sym_LBRACE] = ACTIONS(2100),
    [anon_sym_LT_AT] = ACTIONS(1101),
    [anon_sym_LT_AT_AT] = ACTIONS(2102),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1107),
    [anon_sym_new] = ACTIONS(1085),
    [anon_sym_return_BANG] = ACTIONS(1109),
    [anon_sym_yield] = ACTIONS(1085),
    [anon_sym_yield_BANG] = ACTIONS(1109),
    [anon_sym_lazy] = ACTIONS(1085),
    [anon_sym_assert] = ACTIONS(1085),
    [anon_sym_upcast] = ACTIONS(1085),
    [anon_sym_downcast] = ACTIONS(1085),
    [anon_sym_for] = ACTIONS(1113),
    [anon_sym_while] = ACTIONS(1115),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(1117),
    [anon_sym_try] = ACTIONS(1119),
    [anon_sym_match] = ACTIONS(1121),
    [anon_sym_match_BANG] = ACTIONS(1123),
    [anon_sym_function] = ACTIONS(1125),
    [anon_sym_use] = ACTIONS(1133),
    [anon_sym_use_BANG] = ACTIONS(1135),
    [anon_sym_do_BANG] = ACTIONS(1137),
    [anon_sym_begin] = ACTIONS(1139),
    [aux_sym_char_token1] = ACTIONS(1143),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1145),
    [anon_sym_DQUOTE] = ACTIONS(1147),
    [anon_sym_AT_DQUOTE] = ACTIONS(1149),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1151),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1153),
    [sym_bool] = ACTIONS(1155),
    [sym_unit] = ACTIONS(2104),
    [anon_sym_LPAREN_PIPE] = ACTIONS(1159),
    [sym_op_identifier] = ACTIONS(2106),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(1163),
    [sym_xint] = ACTIONS(1165),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(1167),
  },
  [741] = {
    [sym_function_or_value_defn] = STATE(729),
    [sym__expression] = STATE(51),
    [sym_literal_expression] = STATE(867),
    [sym_long_identifier_or_op] = STATE(867),
    [sym_tuple_expression] = STATE(867),
    [sym_brace_expression] = STATE(867),
    [sym_anon_record_expression] = STATE(867),
    [sym_prefixed_expression] = STATE(867),
    [sym_typecast_expression] = STATE(867),
    [sym_for_expression] = STATE(867),
    [sym_while_expression] = STATE(867),
    [sym__if_branch] = STATE(6511),
    [sym_if_expression] = STATE(867),
    [sym_fun_expression] = STATE(867),
    [sym_try_expression] = STATE(867),
    [sym_match_expression] = STATE(867),
    [sym_function_expression] = STATE(867),
    [sym_mutate_expression] = STATE(867),
    [sym_index_expression] = STATE(867),
    [sym_typed_expression] = STATE(867),
    [sym_declaration_expression] = STATE(867),
    [sym_do_expression] = STATE(867),
    [sym_list_expression] = STATE(867),
    [sym_array_expression] = STATE(867),
    [sym_begin_end_expression] = STATE(867),
    [sym_paren_expression] = STATE(867),
    [sym__high_prec_app] = STATE(864),
    [sym__low_prec_app] = STATE(864),
    [sym_application_expression] = STATE(867),
    [sym_dot_expression] = STATE(867),
    [sym_infix_expression] = STATE(867),
    [sym_ce_expression] = STATE(867),
    [sym_sequential_expression] = STATE(867),
    [sym_char] = STATE(868),
    [sym_format_string] = STATE(869),
    [sym__string_literal] = STATE(869),
    [sym_string] = STATE(868),
    [sym_verbatim_string] = STATE(868),
    [sym_bytearray] = STATE(868),
    [sym_verbatim_bytearray] = STATE(868),
    [sym_format_triple_quoted_string] = STATE(870),
    [sym_triple_quoted_string] = STATE(868),
    [sym_const] = STATE(867),
    [sym_long_identifier] = STATE(872),
    [sym_active_pattern] = STATE(871),
    [sym__identifier_or_op] = STATE(873),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(499),
    [sym_sbyte] = STATE(868),
    [sym_byte] = STATE(868),
    [sym_int16] = STATE(868),
    [sym_uint16] = STATE(868),
    [sym_int32] = STATE(868),
    [sym_uint32] = STATE(868),
    [sym_nativeint] = STATE(868),
    [sym_unativeint] = STATE(868),
    [sym_int64] = STATE(868),
    [sym_uint64] = STATE(868),
    [sym_ieee32] = STATE(868),
    [sym_ieee64] = STATE(868),
    [sym_bignum] = STATE(868),
    [sym_decimal] = STATE(868),
    [sym_float] = STATE(1368),
    [sym_block_comment] = STATE(741),
    [sym_compiler_directive_decl] = STATE(741),
    [sym_fsi_directive_decl] = STATE(741),
    [sym_preproc_line] = STATE(741),
    [sym_preproc_if_in_expression] = STATE(867),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(29),
    [anon_sym_return] = ACTIONS(369),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_null] = ACTIONS(49),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACK_PIPE] = ACTIONS(57),
    [anon_sym_LBRACE] = ACTIONS(1663),
    [anon_sym_LT_AT] = ACTIONS(61),
    [anon_sym_LT_AT_AT] = ACTIONS(1665),
    [anon_sym_LBRACE_PIPE] = ACTIONS(67),
    [anon_sym_new] = ACTIONS(369),
    [anon_sym_return_BANG] = ACTIONS(373),
    [anon_sym_yield] = ACTIONS(369),
    [anon_sym_yield_BANG] = ACTIONS(373),
    [anon_sym_lazy] = ACTIONS(369),
    [anon_sym_assert] = ACTIONS(369),
    [anon_sym_upcast] = ACTIONS(369),
    [anon_sym_downcast] = ACTIONS(369),
    [anon_sym_for] = ACTIONS(375),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(79),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_match] = ACTIONS(83),
    [anon_sym_match_BANG] = ACTIONS(85),
    [anon_sym_function] = ACTIONS(87),
    [anon_sym_use] = ACTIONS(379),
    [anon_sym_use_BANG] = ACTIONS(381),
    [anon_sym_do_BANG] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(101),
    [aux_sym_char_token1] = ACTIONS(105),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(107),
    [anon_sym_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DQUOTE] = ACTIONS(111),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(115),
    [sym_bool] = ACTIONS(117),
    [sym_unit] = ACTIONS(1673),
    [anon_sym_LPAREN_PIPE] = ACTIONS(121),
    [sym_op_identifier] = ACTIONS(1675),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(385),
    [sym_xint] = ACTIONS(387),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(135),
  },
  [742] = {
    [sym_function_or_value_defn] = STATE(627),
    [sym__expression] = STATE(208),
    [sym_literal_expression] = STATE(1118),
    [sym_long_identifier_or_op] = STATE(1118),
    [sym_tuple_expression] = STATE(1118),
    [sym_brace_expression] = STATE(1118),
    [sym_anon_record_expression] = STATE(1118),
    [sym_prefixed_expression] = STATE(1118),
    [sym_typecast_expression] = STATE(1118),
    [sym_for_expression] = STATE(1118),
    [sym_while_expression] = STATE(1118),
    [sym__if_branch] = STATE(7163),
    [sym_if_expression] = STATE(1118),
    [sym_fun_expression] = STATE(1118),
    [sym_try_expression] = STATE(1118),
    [sym_match_expression] = STATE(1118),
    [sym_function_expression] = STATE(1118),
    [sym_mutate_expression] = STATE(1118),
    [sym_index_expression] = STATE(1118),
    [sym_typed_expression] = STATE(1118),
    [sym_declaration_expression] = STATE(1118),
    [sym_do_expression] = STATE(1118),
    [sym_list_expression] = STATE(1118),
    [sym_array_expression] = STATE(1118),
    [sym_begin_end_expression] = STATE(1118),
    [sym_paren_expression] = STATE(1118),
    [sym__high_prec_app] = STATE(1133),
    [sym__low_prec_app] = STATE(1133),
    [sym_application_expression] = STATE(1118),
    [sym_dot_expression] = STATE(1118),
    [sym_infix_expression] = STATE(1118),
    [sym_ce_expression] = STATE(1118),
    [sym_sequential_expression] = STATE(1118),
    [sym_char] = STATE(1080),
    [sym_format_string] = STATE(1090),
    [sym__string_literal] = STATE(1090),
    [sym_string] = STATE(1080),
    [sym_verbatim_string] = STATE(1080),
    [sym_bytearray] = STATE(1080),
    [sym_verbatim_bytearray] = STATE(1080),
    [sym_format_triple_quoted_string] = STATE(1096),
    [sym_triple_quoted_string] = STATE(1080),
    [sym_const] = STATE(1118),
    [sym_long_identifier] = STATE(1156),
    [sym_active_pattern] = STATE(1085),
    [sym__identifier_or_op] = STATE(1099),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(517),
    [sym_sbyte] = STATE(1080),
    [sym_byte] = STATE(1080),
    [sym_int16] = STATE(1080),
    [sym_uint16] = STATE(1080),
    [sym_int32] = STATE(1080),
    [sym_uint32] = STATE(1080),
    [sym_nativeint] = STATE(1080),
    [sym_unativeint] = STATE(1080),
    [sym_int64] = STATE(1080),
    [sym_uint64] = STATE(1080),
    [sym_ieee32] = STATE(1080),
    [sym_ieee64] = STATE(1080),
    [sym_bignum] = STATE(1080),
    [sym_decimal] = STATE(1080),
    [sym_float] = STATE(979),
    [sym_block_comment] = STATE(742),
    [sym_compiler_directive_decl] = STATE(742),
    [sym_fsi_directive_decl] = STATE(742),
    [sym_preproc_line] = STATE(742),
    [sym_preproc_if_in_expression] = STATE(1118),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(195),
    [anon_sym_return] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_null] = ACTIONS(207),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(209),
    [anon_sym_LBRACK_PIPE] = ACTIONS(211),
    [anon_sym_LBRACE] = ACTIONS(1687),
    [anon_sym_LT_AT] = ACTIONS(213),
    [anon_sym_LT_AT_AT] = ACTIONS(1689),
    [anon_sym_LBRACE_PIPE] = ACTIONS(217),
    [anon_sym_new] = ACTIONS(199),
    [anon_sym_return_BANG] = ACTIONS(219),
    [anon_sym_yield] = ACTIONS(199),
    [anon_sym_yield_BANG] = ACTIONS(219),
    [anon_sym_lazy] = ACTIONS(199),
    [anon_sym_assert] = ACTIONS(199),
    [anon_sym_upcast] = ACTIONS(199),
    [anon_sym_downcast] = ACTIONS(199),
    [anon_sym_for] = ACTIONS(223),
    [anon_sym_while] = ACTIONS(225),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(229),
    [anon_sym_match] = ACTIONS(231),
    [anon_sym_match_BANG] = ACTIONS(233),
    [anon_sym_function] = ACTIONS(235),
    [anon_sym_use] = ACTIONS(239),
    [anon_sym_use_BANG] = ACTIONS(241),
    [anon_sym_do_BANG] = ACTIONS(243),
    [anon_sym_begin] = ACTIONS(245),
    [aux_sym_char_token1] = ACTIONS(247),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(251),
    [anon_sym_AT_DQUOTE] = ACTIONS(253),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(255),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(257),
    [sym_bool] = ACTIONS(259),
    [sym_unit] = ACTIONS(1699),
    [anon_sym_LPAREN_PIPE] = ACTIONS(261),
    [sym_op_identifier] = ACTIONS(1701),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(265),
    [sym_xint] = ACTIONS(267),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(269),
  },
  [743] = {
    [sym_function_or_value_defn] = STATE(729),
    [sym__expression] = STATE(49),
    [sym_literal_expression] = STATE(867),
    [sym_long_identifier_or_op] = STATE(867),
    [sym_tuple_expression] = STATE(867),
    [sym_brace_expression] = STATE(867),
    [sym_anon_record_expression] = STATE(867),
    [sym_prefixed_expression] = STATE(867),
    [sym_typecast_expression] = STATE(867),
    [sym_for_expression] = STATE(867),
    [sym_while_expression] = STATE(867),
    [sym__if_branch] = STATE(6511),
    [sym_if_expression] = STATE(867),
    [sym_fun_expression] = STATE(867),
    [sym_try_expression] = STATE(867),
    [sym_match_expression] = STATE(867),
    [sym_function_expression] = STATE(867),
    [sym_mutate_expression] = STATE(867),
    [sym_index_expression] = STATE(867),
    [sym_typed_expression] = STATE(867),
    [sym_declaration_expression] = STATE(867),
    [sym_do_expression] = STATE(867),
    [sym_list_expression] = STATE(867),
    [sym_array_expression] = STATE(867),
    [sym_begin_end_expression] = STATE(867),
    [sym_paren_expression] = STATE(867),
    [sym__high_prec_app] = STATE(864),
    [sym__low_prec_app] = STATE(864),
    [sym_application_expression] = STATE(867),
    [sym_dot_expression] = STATE(867),
    [sym_infix_expression] = STATE(867),
    [sym_ce_expression] = STATE(867),
    [sym_sequential_expression] = STATE(867),
    [sym_char] = STATE(868),
    [sym_format_string] = STATE(869),
    [sym__string_literal] = STATE(869),
    [sym_string] = STATE(868),
    [sym_verbatim_string] = STATE(868),
    [sym_bytearray] = STATE(868),
    [sym_verbatim_bytearray] = STATE(868),
    [sym_format_triple_quoted_string] = STATE(870),
    [sym_triple_quoted_string] = STATE(868),
    [sym_const] = STATE(867),
    [sym_long_identifier] = STATE(872),
    [sym_active_pattern] = STATE(871),
    [sym__identifier_or_op] = STATE(873),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(499),
    [sym_sbyte] = STATE(868),
    [sym_byte] = STATE(868),
    [sym_int16] = STATE(868),
    [sym_uint16] = STATE(868),
    [sym_int32] = STATE(868),
    [sym_uint32] = STATE(868),
    [sym_nativeint] = STATE(868),
    [sym_unativeint] = STATE(868),
    [sym_int64] = STATE(868),
    [sym_uint64] = STATE(868),
    [sym_ieee32] = STATE(868),
    [sym_ieee64] = STATE(868),
    [sym_bignum] = STATE(868),
    [sym_decimal] = STATE(868),
    [sym_float] = STATE(1368),
    [sym_block_comment] = STATE(743),
    [sym_compiler_directive_decl] = STATE(743),
    [sym_fsi_directive_decl] = STATE(743),
    [sym_preproc_line] = STATE(743),
    [sym_preproc_if_in_expression] = STATE(867),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(29),
    [anon_sym_return] = ACTIONS(369),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_null] = ACTIONS(49),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACK_PIPE] = ACTIONS(57),
    [anon_sym_LBRACE] = ACTIONS(1663),
    [anon_sym_LT_AT] = ACTIONS(61),
    [anon_sym_LT_AT_AT] = ACTIONS(1665),
    [anon_sym_LBRACE_PIPE] = ACTIONS(67),
    [anon_sym_new] = ACTIONS(369),
    [anon_sym_return_BANG] = ACTIONS(373),
    [anon_sym_yield] = ACTIONS(369),
    [anon_sym_yield_BANG] = ACTIONS(373),
    [anon_sym_lazy] = ACTIONS(369),
    [anon_sym_assert] = ACTIONS(369),
    [anon_sym_upcast] = ACTIONS(369),
    [anon_sym_downcast] = ACTIONS(369),
    [anon_sym_for] = ACTIONS(375),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(79),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_match] = ACTIONS(83),
    [anon_sym_match_BANG] = ACTIONS(85),
    [anon_sym_function] = ACTIONS(87),
    [anon_sym_use] = ACTIONS(379),
    [anon_sym_use_BANG] = ACTIONS(381),
    [anon_sym_do_BANG] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(101),
    [aux_sym_char_token1] = ACTIONS(105),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(107),
    [anon_sym_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DQUOTE] = ACTIONS(111),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(115),
    [sym_bool] = ACTIONS(117),
    [sym_unit] = ACTIONS(1673),
    [anon_sym_LPAREN_PIPE] = ACTIONS(121),
    [sym_op_identifier] = ACTIONS(1675),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(385),
    [sym_xint] = ACTIONS(387),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(135),
  },
  [744] = {
    [sym_function_or_value_defn] = STATE(627),
    [sym__expression] = STATE(191),
    [sym_literal_expression] = STATE(1118),
    [sym_long_identifier_or_op] = STATE(1118),
    [sym_tuple_expression] = STATE(1118),
    [sym_brace_expression] = STATE(1118),
    [sym_anon_record_expression] = STATE(1118),
    [sym_prefixed_expression] = STATE(1118),
    [sym_typecast_expression] = STATE(1118),
    [sym_for_expression] = STATE(1118),
    [sym_while_expression] = STATE(1118),
    [sym__if_branch] = STATE(7163),
    [sym_if_expression] = STATE(1118),
    [sym_fun_expression] = STATE(1118),
    [sym_try_expression] = STATE(1118),
    [sym_match_expression] = STATE(1118),
    [sym_function_expression] = STATE(1118),
    [sym_mutate_expression] = STATE(1118),
    [sym_index_expression] = STATE(1118),
    [sym_typed_expression] = STATE(1118),
    [sym_declaration_expression] = STATE(1118),
    [sym_do_expression] = STATE(1118),
    [sym_list_expression] = STATE(1118),
    [sym_array_expression] = STATE(1118),
    [sym_begin_end_expression] = STATE(1118),
    [sym_paren_expression] = STATE(1118),
    [sym__high_prec_app] = STATE(1133),
    [sym__low_prec_app] = STATE(1133),
    [sym_application_expression] = STATE(1118),
    [sym_dot_expression] = STATE(1118),
    [sym_infix_expression] = STATE(1118),
    [sym_ce_expression] = STATE(1118),
    [sym_sequential_expression] = STATE(1118),
    [sym_char] = STATE(1080),
    [sym_format_string] = STATE(1090),
    [sym__string_literal] = STATE(1090),
    [sym_string] = STATE(1080),
    [sym_verbatim_string] = STATE(1080),
    [sym_bytearray] = STATE(1080),
    [sym_verbatim_bytearray] = STATE(1080),
    [sym_format_triple_quoted_string] = STATE(1096),
    [sym_triple_quoted_string] = STATE(1080),
    [sym_const] = STATE(1118),
    [sym_long_identifier] = STATE(1156),
    [sym_active_pattern] = STATE(1085),
    [sym__identifier_or_op] = STATE(1099),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(517),
    [sym_sbyte] = STATE(1080),
    [sym_byte] = STATE(1080),
    [sym_int16] = STATE(1080),
    [sym_uint16] = STATE(1080),
    [sym_int32] = STATE(1080),
    [sym_uint32] = STATE(1080),
    [sym_nativeint] = STATE(1080),
    [sym_unativeint] = STATE(1080),
    [sym_int64] = STATE(1080),
    [sym_uint64] = STATE(1080),
    [sym_ieee32] = STATE(1080),
    [sym_ieee64] = STATE(1080),
    [sym_bignum] = STATE(1080),
    [sym_decimal] = STATE(1080),
    [sym_float] = STATE(979),
    [sym_block_comment] = STATE(744),
    [sym_compiler_directive_decl] = STATE(744),
    [sym_fsi_directive_decl] = STATE(744),
    [sym_preproc_line] = STATE(744),
    [sym_preproc_if_in_expression] = STATE(1118),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(195),
    [anon_sym_return] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_null] = ACTIONS(207),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(209),
    [anon_sym_LBRACK_PIPE] = ACTIONS(211),
    [anon_sym_LBRACE] = ACTIONS(1687),
    [anon_sym_LT_AT] = ACTIONS(213),
    [anon_sym_LT_AT_AT] = ACTIONS(1689),
    [anon_sym_LBRACE_PIPE] = ACTIONS(217),
    [anon_sym_new] = ACTIONS(199),
    [anon_sym_return_BANG] = ACTIONS(219),
    [anon_sym_yield] = ACTIONS(199),
    [anon_sym_yield_BANG] = ACTIONS(219),
    [anon_sym_lazy] = ACTIONS(199),
    [anon_sym_assert] = ACTIONS(199),
    [anon_sym_upcast] = ACTIONS(199),
    [anon_sym_downcast] = ACTIONS(199),
    [anon_sym_for] = ACTIONS(223),
    [anon_sym_while] = ACTIONS(225),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(229),
    [anon_sym_match] = ACTIONS(231),
    [anon_sym_match_BANG] = ACTIONS(233),
    [anon_sym_function] = ACTIONS(235),
    [anon_sym_use] = ACTIONS(239),
    [anon_sym_use_BANG] = ACTIONS(241),
    [anon_sym_do_BANG] = ACTIONS(243),
    [anon_sym_begin] = ACTIONS(245),
    [aux_sym_char_token1] = ACTIONS(247),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(251),
    [anon_sym_AT_DQUOTE] = ACTIONS(253),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(255),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(257),
    [sym_bool] = ACTIONS(259),
    [sym_unit] = ACTIONS(1699),
    [anon_sym_LPAREN_PIPE] = ACTIONS(261),
    [sym_op_identifier] = ACTIONS(1701),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(265),
    [sym_xint] = ACTIONS(267),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(269),
  },
  [745] = {
    [sym_function_or_value_defn] = STATE(627),
    [sym__expression] = STATE(181),
    [sym_literal_expression] = STATE(1118),
    [sym_long_identifier_or_op] = STATE(1118),
    [sym_tuple_expression] = STATE(1118),
    [sym_brace_expression] = STATE(1118),
    [sym_anon_record_expression] = STATE(1118),
    [sym_prefixed_expression] = STATE(1118),
    [sym_typecast_expression] = STATE(1118),
    [sym_for_expression] = STATE(1118),
    [sym_while_expression] = STATE(1118),
    [sym__if_branch] = STATE(7163),
    [sym_if_expression] = STATE(1118),
    [sym_fun_expression] = STATE(1118),
    [sym_try_expression] = STATE(1118),
    [sym_match_expression] = STATE(1118),
    [sym_function_expression] = STATE(1118),
    [sym_mutate_expression] = STATE(1118),
    [sym_index_expression] = STATE(1118),
    [sym_typed_expression] = STATE(1118),
    [sym_declaration_expression] = STATE(1118),
    [sym_do_expression] = STATE(1118),
    [sym_list_expression] = STATE(1118),
    [sym_array_expression] = STATE(1118),
    [sym_begin_end_expression] = STATE(1118),
    [sym_paren_expression] = STATE(1118),
    [sym__high_prec_app] = STATE(1133),
    [sym__low_prec_app] = STATE(1133),
    [sym_application_expression] = STATE(1118),
    [sym_dot_expression] = STATE(1118),
    [sym_infix_expression] = STATE(1118),
    [sym_ce_expression] = STATE(1118),
    [sym_sequential_expression] = STATE(1118),
    [sym_char] = STATE(1080),
    [sym_format_string] = STATE(1090),
    [sym__string_literal] = STATE(1090),
    [sym_string] = STATE(1080),
    [sym_verbatim_string] = STATE(1080),
    [sym_bytearray] = STATE(1080),
    [sym_verbatim_bytearray] = STATE(1080),
    [sym_format_triple_quoted_string] = STATE(1096),
    [sym_triple_quoted_string] = STATE(1080),
    [sym_const] = STATE(1118),
    [sym_long_identifier] = STATE(1156),
    [sym_active_pattern] = STATE(1085),
    [sym__identifier_or_op] = STATE(1099),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(517),
    [sym_sbyte] = STATE(1080),
    [sym_byte] = STATE(1080),
    [sym_int16] = STATE(1080),
    [sym_uint16] = STATE(1080),
    [sym_int32] = STATE(1080),
    [sym_uint32] = STATE(1080),
    [sym_nativeint] = STATE(1080),
    [sym_unativeint] = STATE(1080),
    [sym_int64] = STATE(1080),
    [sym_uint64] = STATE(1080),
    [sym_ieee32] = STATE(1080),
    [sym_ieee64] = STATE(1080),
    [sym_bignum] = STATE(1080),
    [sym_decimal] = STATE(1080),
    [sym_float] = STATE(979),
    [sym_block_comment] = STATE(745),
    [sym_compiler_directive_decl] = STATE(745),
    [sym_fsi_directive_decl] = STATE(745),
    [sym_preproc_line] = STATE(745),
    [sym_preproc_if_in_expression] = STATE(1118),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(195),
    [anon_sym_return] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_null] = ACTIONS(207),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(209),
    [anon_sym_LBRACK_PIPE] = ACTIONS(211),
    [anon_sym_LBRACE] = ACTIONS(1687),
    [anon_sym_LT_AT] = ACTIONS(213),
    [anon_sym_LT_AT_AT] = ACTIONS(1689),
    [anon_sym_LBRACE_PIPE] = ACTIONS(217),
    [anon_sym_new] = ACTIONS(199),
    [anon_sym_return_BANG] = ACTIONS(219),
    [anon_sym_yield] = ACTIONS(199),
    [anon_sym_yield_BANG] = ACTIONS(219),
    [anon_sym_lazy] = ACTIONS(199),
    [anon_sym_assert] = ACTIONS(199),
    [anon_sym_upcast] = ACTIONS(199),
    [anon_sym_downcast] = ACTIONS(199),
    [anon_sym_for] = ACTIONS(223),
    [anon_sym_while] = ACTIONS(225),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(229),
    [anon_sym_match] = ACTIONS(231),
    [anon_sym_match_BANG] = ACTIONS(233),
    [anon_sym_function] = ACTIONS(235),
    [anon_sym_use] = ACTIONS(239),
    [anon_sym_use_BANG] = ACTIONS(241),
    [anon_sym_do_BANG] = ACTIONS(243),
    [anon_sym_begin] = ACTIONS(245),
    [aux_sym_char_token1] = ACTIONS(247),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(251),
    [anon_sym_AT_DQUOTE] = ACTIONS(253),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(255),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(257),
    [sym_bool] = ACTIONS(259),
    [sym_unit] = ACTIONS(1699),
    [anon_sym_LPAREN_PIPE] = ACTIONS(261),
    [sym_op_identifier] = ACTIONS(1701),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(265),
    [sym_xint] = ACTIONS(267),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(269),
  },
  [746] = {
    [sym_function_or_value_defn] = STATE(600),
    [sym__expression] = STATE(180),
    [sym_literal_expression] = STATE(867),
    [sym_long_identifier_or_op] = STATE(867),
    [sym_tuple_expression] = STATE(867),
    [sym_brace_expression] = STATE(867),
    [sym_anon_record_expression] = STATE(867),
    [sym_prefixed_expression] = STATE(867),
    [sym_typecast_expression] = STATE(867),
    [sym_for_expression] = STATE(867),
    [sym_while_expression] = STATE(867),
    [sym__if_branch] = STATE(6511),
    [sym_if_expression] = STATE(867),
    [sym_fun_expression] = STATE(867),
    [sym_try_expression] = STATE(867),
    [sym_match_expression] = STATE(867),
    [sym_function_expression] = STATE(867),
    [sym_mutate_expression] = STATE(867),
    [sym_index_expression] = STATE(867),
    [sym_typed_expression] = STATE(867),
    [sym_declaration_expression] = STATE(867),
    [sym_do_expression] = STATE(867),
    [sym_list_expression] = STATE(867),
    [sym_array_expression] = STATE(867),
    [sym_begin_end_expression] = STATE(867),
    [sym_paren_expression] = STATE(867),
    [sym__high_prec_app] = STATE(864),
    [sym__low_prec_app] = STATE(864),
    [sym_application_expression] = STATE(867),
    [sym_dot_expression] = STATE(867),
    [sym_infix_expression] = STATE(867),
    [sym_ce_expression] = STATE(867),
    [sym_sequential_expression] = STATE(867),
    [sym_char] = STATE(868),
    [sym_format_string] = STATE(869),
    [sym__string_literal] = STATE(869),
    [sym_string] = STATE(868),
    [sym_verbatim_string] = STATE(868),
    [sym_bytearray] = STATE(868),
    [sym_verbatim_bytearray] = STATE(868),
    [sym_format_triple_quoted_string] = STATE(870),
    [sym_triple_quoted_string] = STATE(868),
    [sym_const] = STATE(867),
    [sym_long_identifier] = STATE(872),
    [sym_active_pattern] = STATE(871),
    [sym__identifier_or_op] = STATE(873),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(656),
    [sym_sbyte] = STATE(868),
    [sym_byte] = STATE(868),
    [sym_int16] = STATE(868),
    [sym_uint16] = STATE(868),
    [sym_int32] = STATE(868),
    [sym_uint32] = STATE(868),
    [sym_nativeint] = STATE(868),
    [sym_unativeint] = STATE(868),
    [sym_int64] = STATE(868),
    [sym_uint64] = STATE(868),
    [sym_ieee32] = STATE(868),
    [sym_ieee64] = STATE(868),
    [sym_bignum] = STATE(868),
    [sym_decimal] = STATE(868),
    [sym_float] = STATE(1368),
    [sym_block_comment] = STATE(746),
    [sym_compiler_directive_decl] = STATE(746),
    [sym_fsi_directive_decl] = STATE(746),
    [sym_preproc_line] = STATE(746),
    [sym_preproc_if_in_expression] = STATE(867),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(29),
    [anon_sym_return] = ACTIONS(825),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_null] = ACTIONS(49),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACK_PIPE] = ACTIONS(57),
    [anon_sym_LBRACE] = ACTIONS(1663),
    [anon_sym_LT_AT] = ACTIONS(61),
    [anon_sym_LT_AT_AT] = ACTIONS(1665),
    [anon_sym_LBRACE_PIPE] = ACTIONS(67),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_return_BANG] = ACTIONS(829),
    [anon_sym_yield] = ACTIONS(825),
    [anon_sym_yield_BANG] = ACTIONS(829),
    [anon_sym_lazy] = ACTIONS(825),
    [anon_sym_assert] = ACTIONS(825),
    [anon_sym_upcast] = ACTIONS(825),
    [anon_sym_downcast] = ACTIONS(825),
    [anon_sym_for] = ACTIONS(73),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(79),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_match] = ACTIONS(83),
    [anon_sym_match_BANG] = ACTIONS(85),
    [anon_sym_function] = ACTIONS(87),
    [anon_sym_use] = ACTIONS(833),
    [anon_sym_use_BANG] = ACTIONS(835),
    [anon_sym_do_BANG] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(101),
    [aux_sym_char_token1] = ACTIONS(105),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(107),
    [anon_sym_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DQUOTE] = ACTIONS(111),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(115),
    [sym_bool] = ACTIONS(117),
    [sym_unit] = ACTIONS(1673),
    [anon_sym_LPAREN_PIPE] = ACTIONS(121),
    [sym_op_identifier] = ACTIONS(1675),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(837),
    [sym_xint] = ACTIONS(387),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(135),
  },
  [747] = {
    [sym_function_or_value_defn] = STATE(729),
    [sym__expression] = STATE(47),
    [sym_literal_expression] = STATE(867),
    [sym_long_identifier_or_op] = STATE(867),
    [sym_tuple_expression] = STATE(867),
    [sym_brace_expression] = STATE(867),
    [sym_anon_record_expression] = STATE(867),
    [sym_prefixed_expression] = STATE(867),
    [sym_typecast_expression] = STATE(867),
    [sym_for_expression] = STATE(867),
    [sym_while_expression] = STATE(867),
    [sym__if_branch] = STATE(6511),
    [sym_if_expression] = STATE(867),
    [sym_fun_expression] = STATE(867),
    [sym_try_expression] = STATE(867),
    [sym_match_expression] = STATE(867),
    [sym_function_expression] = STATE(867),
    [sym_mutate_expression] = STATE(867),
    [sym_index_expression] = STATE(867),
    [sym_typed_expression] = STATE(867),
    [sym_declaration_expression] = STATE(867),
    [sym_do_expression] = STATE(867),
    [sym_list_expression] = STATE(867),
    [sym_array_expression] = STATE(867),
    [sym_begin_end_expression] = STATE(867),
    [sym_paren_expression] = STATE(867),
    [sym__high_prec_app] = STATE(864),
    [sym__low_prec_app] = STATE(864),
    [sym_application_expression] = STATE(867),
    [sym_dot_expression] = STATE(867),
    [sym_infix_expression] = STATE(867),
    [sym_ce_expression] = STATE(867),
    [sym_sequential_expression] = STATE(867),
    [sym_char] = STATE(868),
    [sym_format_string] = STATE(869),
    [sym__string_literal] = STATE(869),
    [sym_string] = STATE(868),
    [sym_verbatim_string] = STATE(868),
    [sym_bytearray] = STATE(868),
    [sym_verbatim_bytearray] = STATE(868),
    [sym_format_triple_quoted_string] = STATE(870),
    [sym_triple_quoted_string] = STATE(868),
    [sym_const] = STATE(867),
    [sym_long_identifier] = STATE(872),
    [sym_active_pattern] = STATE(871),
    [sym__identifier_or_op] = STATE(873),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(499),
    [sym_sbyte] = STATE(868),
    [sym_byte] = STATE(868),
    [sym_int16] = STATE(868),
    [sym_uint16] = STATE(868),
    [sym_int32] = STATE(868),
    [sym_uint32] = STATE(868),
    [sym_nativeint] = STATE(868),
    [sym_unativeint] = STATE(868),
    [sym_int64] = STATE(868),
    [sym_uint64] = STATE(868),
    [sym_ieee32] = STATE(868),
    [sym_ieee64] = STATE(868),
    [sym_bignum] = STATE(868),
    [sym_decimal] = STATE(868),
    [sym_float] = STATE(1368),
    [sym_block_comment] = STATE(747),
    [sym_compiler_directive_decl] = STATE(747),
    [sym_fsi_directive_decl] = STATE(747),
    [sym_preproc_line] = STATE(747),
    [sym_preproc_if_in_expression] = STATE(867),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(29),
    [anon_sym_return] = ACTIONS(369),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_null] = ACTIONS(49),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACK_PIPE] = ACTIONS(57),
    [anon_sym_LBRACE] = ACTIONS(1663),
    [anon_sym_LT_AT] = ACTIONS(61),
    [anon_sym_LT_AT_AT] = ACTIONS(1665),
    [anon_sym_LBRACE_PIPE] = ACTIONS(67),
    [anon_sym_new] = ACTIONS(369),
    [anon_sym_return_BANG] = ACTIONS(373),
    [anon_sym_yield] = ACTIONS(369),
    [anon_sym_yield_BANG] = ACTIONS(373),
    [anon_sym_lazy] = ACTIONS(369),
    [anon_sym_assert] = ACTIONS(369),
    [anon_sym_upcast] = ACTIONS(369),
    [anon_sym_downcast] = ACTIONS(369),
    [anon_sym_for] = ACTIONS(375),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(79),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_match] = ACTIONS(83),
    [anon_sym_match_BANG] = ACTIONS(85),
    [anon_sym_function] = ACTIONS(87),
    [anon_sym_use] = ACTIONS(379),
    [anon_sym_use_BANG] = ACTIONS(381),
    [anon_sym_do_BANG] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(101),
    [aux_sym_char_token1] = ACTIONS(105),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(107),
    [anon_sym_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DQUOTE] = ACTIONS(111),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(115),
    [sym_bool] = ACTIONS(117),
    [sym_unit] = ACTIONS(1673),
    [anon_sym_LPAREN_PIPE] = ACTIONS(121),
    [sym_op_identifier] = ACTIONS(1675),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(385),
    [sym_xint] = ACTIONS(387),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(135),
  },
  [748] = {
    [sym_function_or_value_defn] = STATE(627),
    [sym__expression] = STATE(171),
    [sym_literal_expression] = STATE(1118),
    [sym_long_identifier_or_op] = STATE(1118),
    [sym_tuple_expression] = STATE(1118),
    [sym_brace_expression] = STATE(1118),
    [sym_anon_record_expression] = STATE(1118),
    [sym_prefixed_expression] = STATE(1118),
    [sym_typecast_expression] = STATE(1118),
    [sym_for_expression] = STATE(1118),
    [sym_while_expression] = STATE(1118),
    [sym__if_branch] = STATE(7163),
    [sym_if_expression] = STATE(1118),
    [sym_fun_expression] = STATE(1118),
    [sym_try_expression] = STATE(1118),
    [sym_match_expression] = STATE(1118),
    [sym_function_expression] = STATE(1118),
    [sym_mutate_expression] = STATE(1118),
    [sym_index_expression] = STATE(1118),
    [sym_typed_expression] = STATE(1118),
    [sym_declaration_expression] = STATE(1118),
    [sym_do_expression] = STATE(1118),
    [sym_list_expression] = STATE(1118),
    [sym_array_expression] = STATE(1118),
    [sym_begin_end_expression] = STATE(1118),
    [sym_paren_expression] = STATE(1118),
    [sym__high_prec_app] = STATE(1133),
    [sym__low_prec_app] = STATE(1133),
    [sym_application_expression] = STATE(1118),
    [sym_dot_expression] = STATE(1118),
    [sym_infix_expression] = STATE(1118),
    [sym_ce_expression] = STATE(1118),
    [sym_sequential_expression] = STATE(1118),
    [sym_char] = STATE(1080),
    [sym_format_string] = STATE(1090),
    [sym__string_literal] = STATE(1090),
    [sym_string] = STATE(1080),
    [sym_verbatim_string] = STATE(1080),
    [sym_bytearray] = STATE(1080),
    [sym_verbatim_bytearray] = STATE(1080),
    [sym_format_triple_quoted_string] = STATE(1096),
    [sym_triple_quoted_string] = STATE(1080),
    [sym_const] = STATE(1118),
    [sym_long_identifier] = STATE(1156),
    [sym_active_pattern] = STATE(1085),
    [sym__identifier_or_op] = STATE(1099),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(517),
    [sym_sbyte] = STATE(1080),
    [sym_byte] = STATE(1080),
    [sym_int16] = STATE(1080),
    [sym_uint16] = STATE(1080),
    [sym_int32] = STATE(1080),
    [sym_uint32] = STATE(1080),
    [sym_nativeint] = STATE(1080),
    [sym_unativeint] = STATE(1080),
    [sym_int64] = STATE(1080),
    [sym_uint64] = STATE(1080),
    [sym_ieee32] = STATE(1080),
    [sym_ieee64] = STATE(1080),
    [sym_bignum] = STATE(1080),
    [sym_decimal] = STATE(1080),
    [sym_float] = STATE(979),
    [sym_block_comment] = STATE(748),
    [sym_compiler_directive_decl] = STATE(748),
    [sym_fsi_directive_decl] = STATE(748),
    [sym_preproc_line] = STATE(748),
    [sym_preproc_if_in_expression] = STATE(1118),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(195),
    [anon_sym_return] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_null] = ACTIONS(207),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(209),
    [anon_sym_LBRACK_PIPE] = ACTIONS(211),
    [anon_sym_LBRACE] = ACTIONS(1687),
    [anon_sym_LT_AT] = ACTIONS(213),
    [anon_sym_LT_AT_AT] = ACTIONS(1689),
    [anon_sym_LBRACE_PIPE] = ACTIONS(217),
    [anon_sym_new] = ACTIONS(199),
    [anon_sym_return_BANG] = ACTIONS(219),
    [anon_sym_yield] = ACTIONS(199),
    [anon_sym_yield_BANG] = ACTIONS(219),
    [anon_sym_lazy] = ACTIONS(199),
    [anon_sym_assert] = ACTIONS(199),
    [anon_sym_upcast] = ACTIONS(199),
    [anon_sym_downcast] = ACTIONS(199),
    [anon_sym_for] = ACTIONS(223),
    [anon_sym_while] = ACTIONS(225),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(229),
    [anon_sym_match] = ACTIONS(231),
    [anon_sym_match_BANG] = ACTIONS(233),
    [anon_sym_function] = ACTIONS(235),
    [anon_sym_use] = ACTIONS(239),
    [anon_sym_use_BANG] = ACTIONS(241),
    [anon_sym_do_BANG] = ACTIONS(243),
    [anon_sym_begin] = ACTIONS(245),
    [aux_sym_char_token1] = ACTIONS(247),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(251),
    [anon_sym_AT_DQUOTE] = ACTIONS(253),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(255),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(257),
    [sym_bool] = ACTIONS(259),
    [sym_unit] = ACTIONS(1699),
    [anon_sym_LPAREN_PIPE] = ACTIONS(261),
    [sym_op_identifier] = ACTIONS(1701),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(265),
    [sym_xint] = ACTIONS(267),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(269),
  },
  [749] = {
    [sym_function_or_value_defn] = STATE(627),
    [sym__expression] = STATE(345),
    [sym_literal_expression] = STATE(1118),
    [sym_long_identifier_or_op] = STATE(1118),
    [sym_tuple_expression] = STATE(1118),
    [sym_brace_expression] = STATE(1118),
    [sym_anon_record_expression] = STATE(1118),
    [sym_prefixed_expression] = STATE(1118),
    [sym_typecast_expression] = STATE(1118),
    [sym_for_expression] = STATE(1118),
    [sym_while_expression] = STATE(1118),
    [sym__if_branch] = STATE(7163),
    [sym_if_expression] = STATE(1118),
    [sym_fun_expression] = STATE(1118),
    [sym_try_expression] = STATE(1118),
    [sym_match_expression] = STATE(1118),
    [sym_function_expression] = STATE(1118),
    [sym_mutate_expression] = STATE(1118),
    [sym_index_expression] = STATE(1118),
    [sym_typed_expression] = STATE(1118),
    [sym_declaration_expression] = STATE(1118),
    [sym_do_expression] = STATE(1118),
    [sym_list_expression] = STATE(1118),
    [sym_array_expression] = STATE(1118),
    [sym_begin_end_expression] = STATE(1118),
    [sym_paren_expression] = STATE(1118),
    [sym__high_prec_app] = STATE(1133),
    [sym__low_prec_app] = STATE(1133),
    [sym_application_expression] = STATE(1118),
    [sym_dot_expression] = STATE(1118),
    [sym_infix_expression] = STATE(1118),
    [sym_ce_expression] = STATE(1118),
    [sym_sequential_expression] = STATE(1118),
    [sym_char] = STATE(1080),
    [sym_format_string] = STATE(1090),
    [sym__string_literal] = STATE(1090),
    [sym_string] = STATE(1080),
    [sym_verbatim_string] = STATE(1080),
    [sym_bytearray] = STATE(1080),
    [sym_verbatim_bytearray] = STATE(1080),
    [sym_format_triple_quoted_string] = STATE(1096),
    [sym_triple_quoted_string] = STATE(1080),
    [sym_const] = STATE(1118),
    [sym_long_identifier] = STATE(1156),
    [sym_active_pattern] = STATE(1085),
    [sym__identifier_or_op] = STATE(1099),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(517),
    [sym_sbyte] = STATE(1080),
    [sym_byte] = STATE(1080),
    [sym_int16] = STATE(1080),
    [sym_uint16] = STATE(1080),
    [sym_int32] = STATE(1080),
    [sym_uint32] = STATE(1080),
    [sym_nativeint] = STATE(1080),
    [sym_unativeint] = STATE(1080),
    [sym_int64] = STATE(1080),
    [sym_uint64] = STATE(1080),
    [sym_ieee32] = STATE(1080),
    [sym_ieee64] = STATE(1080),
    [sym_bignum] = STATE(1080),
    [sym_decimal] = STATE(1080),
    [sym_float] = STATE(979),
    [sym_block_comment] = STATE(749),
    [sym_compiler_directive_decl] = STATE(749),
    [sym_fsi_directive_decl] = STATE(749),
    [sym_preproc_line] = STATE(749),
    [sym_preproc_if_in_expression] = STATE(1118),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(195),
    [anon_sym_return] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_null] = ACTIONS(207),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(209),
    [anon_sym_LBRACK_PIPE] = ACTIONS(211),
    [anon_sym_LBRACE] = ACTIONS(1687),
    [anon_sym_LT_AT] = ACTIONS(213),
    [anon_sym_LT_AT_AT] = ACTIONS(1689),
    [anon_sym_LBRACE_PIPE] = ACTIONS(217),
    [anon_sym_new] = ACTIONS(199),
    [anon_sym_return_BANG] = ACTIONS(219),
    [anon_sym_yield] = ACTIONS(199),
    [anon_sym_yield_BANG] = ACTIONS(219),
    [anon_sym_lazy] = ACTIONS(199),
    [anon_sym_assert] = ACTIONS(199),
    [anon_sym_upcast] = ACTIONS(199),
    [anon_sym_downcast] = ACTIONS(199),
    [anon_sym_for] = ACTIONS(223),
    [anon_sym_while] = ACTIONS(225),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(229),
    [anon_sym_match] = ACTIONS(231),
    [anon_sym_match_BANG] = ACTIONS(233),
    [anon_sym_function] = ACTIONS(235),
    [anon_sym_use] = ACTIONS(239),
    [anon_sym_use_BANG] = ACTIONS(241),
    [anon_sym_do_BANG] = ACTIONS(243),
    [anon_sym_begin] = ACTIONS(245),
    [aux_sym_char_token1] = ACTIONS(247),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(251),
    [anon_sym_AT_DQUOTE] = ACTIONS(253),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(255),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(257),
    [sym_bool] = ACTIONS(259),
    [sym_unit] = ACTIONS(1699),
    [anon_sym_LPAREN_PIPE] = ACTIONS(261),
    [sym_op_identifier] = ACTIONS(1701),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(265),
    [sym_xint] = ACTIONS(267),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(269),
  },
  [750] = {
    [sym_function_or_value_defn] = STATE(627),
    [sym__expression] = STATE(310),
    [sym_literal_expression] = STATE(1118),
    [sym_long_identifier_or_op] = STATE(1118),
    [sym_tuple_expression] = STATE(1118),
    [sym_brace_expression] = STATE(1118),
    [sym_anon_record_expression] = STATE(1118),
    [sym_prefixed_expression] = STATE(1118),
    [sym_typecast_expression] = STATE(1118),
    [sym_for_expression] = STATE(1118),
    [sym_while_expression] = STATE(1118),
    [sym__if_branch] = STATE(7163),
    [sym_if_expression] = STATE(1118),
    [sym_fun_expression] = STATE(1118),
    [sym_try_expression] = STATE(1118),
    [sym_match_expression] = STATE(1118),
    [sym_function_expression] = STATE(1118),
    [sym_mutate_expression] = STATE(1118),
    [sym_index_expression] = STATE(1118),
    [sym_typed_expression] = STATE(1118),
    [sym_declaration_expression] = STATE(1118),
    [sym_do_expression] = STATE(1118),
    [sym_list_expression] = STATE(1118),
    [sym_array_expression] = STATE(1118),
    [sym_begin_end_expression] = STATE(1118),
    [sym_paren_expression] = STATE(1118),
    [sym__high_prec_app] = STATE(1133),
    [sym__low_prec_app] = STATE(1133),
    [sym_application_expression] = STATE(1118),
    [sym_dot_expression] = STATE(1118),
    [sym_infix_expression] = STATE(1118),
    [sym_ce_expression] = STATE(1118),
    [sym_sequential_expression] = STATE(1118),
    [sym_char] = STATE(1080),
    [sym_format_string] = STATE(1090),
    [sym__string_literal] = STATE(1090),
    [sym_string] = STATE(1080),
    [sym_verbatim_string] = STATE(1080),
    [sym_bytearray] = STATE(1080),
    [sym_verbatim_bytearray] = STATE(1080),
    [sym_format_triple_quoted_string] = STATE(1096),
    [sym_triple_quoted_string] = STATE(1080),
    [sym_const] = STATE(1118),
    [sym_long_identifier] = STATE(1156),
    [sym_active_pattern] = STATE(1085),
    [sym__identifier_or_op] = STATE(1099),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(517),
    [sym_sbyte] = STATE(1080),
    [sym_byte] = STATE(1080),
    [sym_int16] = STATE(1080),
    [sym_uint16] = STATE(1080),
    [sym_int32] = STATE(1080),
    [sym_uint32] = STATE(1080),
    [sym_nativeint] = STATE(1080),
    [sym_unativeint] = STATE(1080),
    [sym_int64] = STATE(1080),
    [sym_uint64] = STATE(1080),
    [sym_ieee32] = STATE(1080),
    [sym_ieee64] = STATE(1080),
    [sym_bignum] = STATE(1080),
    [sym_decimal] = STATE(1080),
    [sym_float] = STATE(979),
    [sym_block_comment] = STATE(750),
    [sym_compiler_directive_decl] = STATE(750),
    [sym_fsi_directive_decl] = STATE(750),
    [sym_preproc_line] = STATE(750),
    [sym_preproc_if_in_expression] = STATE(1118),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(195),
    [anon_sym_return] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_null] = ACTIONS(207),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(209),
    [anon_sym_LBRACK_PIPE] = ACTIONS(211),
    [anon_sym_LBRACE] = ACTIONS(1687),
    [anon_sym_LT_AT] = ACTIONS(213),
    [anon_sym_LT_AT_AT] = ACTIONS(1689),
    [anon_sym_LBRACE_PIPE] = ACTIONS(217),
    [anon_sym_new] = ACTIONS(199),
    [anon_sym_return_BANG] = ACTIONS(219),
    [anon_sym_yield] = ACTIONS(199),
    [anon_sym_yield_BANG] = ACTIONS(219),
    [anon_sym_lazy] = ACTIONS(199),
    [anon_sym_assert] = ACTIONS(199),
    [anon_sym_upcast] = ACTIONS(199),
    [anon_sym_downcast] = ACTIONS(199),
    [anon_sym_for] = ACTIONS(223),
    [anon_sym_while] = ACTIONS(225),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(229),
    [anon_sym_match] = ACTIONS(231),
    [anon_sym_match_BANG] = ACTIONS(233),
    [anon_sym_function] = ACTIONS(235),
    [anon_sym_use] = ACTIONS(239),
    [anon_sym_use_BANG] = ACTIONS(241),
    [anon_sym_do_BANG] = ACTIONS(243),
    [anon_sym_begin] = ACTIONS(245),
    [aux_sym_char_token1] = ACTIONS(247),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(251),
    [anon_sym_AT_DQUOTE] = ACTIONS(253),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(255),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(257),
    [sym_bool] = ACTIONS(259),
    [sym_unit] = ACTIONS(1699),
    [anon_sym_LPAREN_PIPE] = ACTIONS(261),
    [sym_op_identifier] = ACTIONS(1701),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(265),
    [sym_xint] = ACTIONS(267),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(269),
  },
  [751] = {
    [sym_function_or_value_defn] = STATE(600),
    [sym__expression] = STATE(285),
    [sym_literal_expression] = STATE(867),
    [sym_long_identifier_or_op] = STATE(867),
    [sym_tuple_expression] = STATE(867),
    [sym_brace_expression] = STATE(867),
    [sym_anon_record_expression] = STATE(867),
    [sym_prefixed_expression] = STATE(867),
    [sym_typecast_expression] = STATE(867),
    [sym_for_expression] = STATE(867),
    [sym_while_expression] = STATE(867),
    [sym__if_branch] = STATE(6511),
    [sym_if_expression] = STATE(867),
    [sym_fun_expression] = STATE(867),
    [sym_try_expression] = STATE(867),
    [sym_match_expression] = STATE(867),
    [sym_function_expression] = STATE(867),
    [sym_mutate_expression] = STATE(867),
    [sym_index_expression] = STATE(867),
    [sym_typed_expression] = STATE(867),
    [sym_declaration_expression] = STATE(867),
    [sym_do_expression] = STATE(867),
    [sym_list_expression] = STATE(867),
    [sym_array_expression] = STATE(867),
    [sym_begin_end_expression] = STATE(867),
    [sym_paren_expression] = STATE(867),
    [sym__high_prec_app] = STATE(864),
    [sym__low_prec_app] = STATE(864),
    [sym_application_expression] = STATE(867),
    [sym_dot_expression] = STATE(867),
    [sym_infix_expression] = STATE(867),
    [sym_ce_expression] = STATE(867),
    [sym_sequential_expression] = STATE(867),
    [sym_char] = STATE(868),
    [sym_format_string] = STATE(869),
    [sym__string_literal] = STATE(869),
    [sym_string] = STATE(868),
    [sym_verbatim_string] = STATE(868),
    [sym_bytearray] = STATE(868),
    [sym_verbatim_bytearray] = STATE(868),
    [sym_format_triple_quoted_string] = STATE(870),
    [sym_triple_quoted_string] = STATE(868),
    [sym_const] = STATE(867),
    [sym_long_identifier] = STATE(872),
    [sym_active_pattern] = STATE(871),
    [sym__identifier_or_op] = STATE(873),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(656),
    [sym_sbyte] = STATE(868),
    [sym_byte] = STATE(868),
    [sym_int16] = STATE(868),
    [sym_uint16] = STATE(868),
    [sym_int32] = STATE(868),
    [sym_uint32] = STATE(868),
    [sym_nativeint] = STATE(868),
    [sym_unativeint] = STATE(868),
    [sym_int64] = STATE(868),
    [sym_uint64] = STATE(868),
    [sym_ieee32] = STATE(868),
    [sym_ieee64] = STATE(868),
    [sym_bignum] = STATE(868),
    [sym_decimal] = STATE(868),
    [sym_float] = STATE(1368),
    [sym_block_comment] = STATE(751),
    [sym_compiler_directive_decl] = STATE(751),
    [sym_fsi_directive_decl] = STATE(751),
    [sym_preproc_line] = STATE(751),
    [sym_preproc_if_in_expression] = STATE(867),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(29),
    [anon_sym_return] = ACTIONS(825),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_null] = ACTIONS(49),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACK_PIPE] = ACTIONS(57),
    [anon_sym_LBRACE] = ACTIONS(1663),
    [anon_sym_LT_AT] = ACTIONS(61),
    [anon_sym_LT_AT_AT] = ACTIONS(1665),
    [anon_sym_LBRACE_PIPE] = ACTIONS(67),
    [anon_sym_new] = ACTIONS(825),
    [anon_sym_return_BANG] = ACTIONS(829),
    [anon_sym_yield] = ACTIONS(825),
    [anon_sym_yield_BANG] = ACTIONS(829),
    [anon_sym_lazy] = ACTIONS(825),
    [anon_sym_assert] = ACTIONS(825),
    [anon_sym_upcast] = ACTIONS(825),
    [anon_sym_downcast] = ACTIONS(825),
    [anon_sym_for] = ACTIONS(73),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(79),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_match] = ACTIONS(83),
    [anon_sym_match_BANG] = ACTIONS(85),
    [anon_sym_function] = ACTIONS(87),
    [anon_sym_use] = ACTIONS(833),
    [anon_sym_use_BANG] = ACTIONS(835),
    [anon_sym_do_BANG] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(101),
    [aux_sym_char_token1] = ACTIONS(105),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(107),
    [anon_sym_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DQUOTE] = ACTIONS(111),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(115),
    [sym_bool] = ACTIONS(117),
    [sym_unit] = ACTIONS(1673),
    [anon_sym_LPAREN_PIPE] = ACTIONS(121),
    [sym_op_identifier] = ACTIONS(1675),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(837),
    [sym_xint] = ACTIONS(387),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(135),
  },
  [752] = {
    [sym_function_or_value_defn] = STATE(627),
    [sym__expression] = STATE(161),
    [sym_literal_expression] = STATE(1118),
    [sym_long_identifier_or_op] = STATE(1118),
    [sym_tuple_expression] = STATE(1118),
    [sym_brace_expression] = STATE(1118),
    [sym_anon_record_expression] = STATE(1118),
    [sym_prefixed_expression] = STATE(1118),
    [sym_typecast_expression] = STATE(1118),
    [sym_for_expression] = STATE(1118),
    [sym_while_expression] = STATE(1118),
    [sym__if_branch] = STATE(7163),
    [sym_if_expression] = STATE(1118),
    [sym_fun_expression] = STATE(1118),
    [sym_try_expression] = STATE(1118),
    [sym_match_expression] = STATE(1118),
    [sym_function_expression] = STATE(1118),
    [sym_mutate_expression] = STATE(1118),
    [sym_index_expression] = STATE(1118),
    [sym_typed_expression] = STATE(1118),
    [sym_declaration_expression] = STATE(1118),
    [sym_do_expression] = STATE(1118),
    [sym_list_expression] = STATE(1118),
    [sym_array_expression] = STATE(1118),
    [sym_begin_end_expression] = STATE(1118),
    [sym_paren_expression] = STATE(1118),
    [sym__high_prec_app] = STATE(1133),
    [sym__low_prec_app] = STATE(1133),
    [sym_application_expression] = STATE(1118),
    [sym_dot_expression] = STATE(1118),
    [sym_infix_expression] = STATE(1118),
    [sym_ce_expression] = STATE(1118),
    [sym_sequential_expression] = STATE(1118),
    [sym_char] = STATE(1080),
    [sym_format_string] = STATE(1090),
    [sym__string_literal] = STATE(1090),
    [sym_string] = STATE(1080),
    [sym_verbatim_string] = STATE(1080),
    [sym_bytearray] = STATE(1080),
    [sym_verbatim_bytearray] = STATE(1080),
    [sym_format_triple_quoted_string] = STATE(1096),
    [sym_triple_quoted_string] = STATE(1080),
    [sym_const] = STATE(1118),
    [sym_long_identifier] = STATE(1156),
    [sym_active_pattern] = STATE(1085),
    [sym__identifier_or_op] = STATE(1099),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(517),
    [sym_sbyte] = STATE(1080),
    [sym_byte] = STATE(1080),
    [sym_int16] = STATE(1080),
    [sym_uint16] = STATE(1080),
    [sym_int32] = STATE(1080),
    [sym_uint32] = STATE(1080),
    [sym_nativeint] = STATE(1080),
    [sym_unativeint] = STATE(1080),
    [sym_int64] = STATE(1080),
    [sym_uint64] = STATE(1080),
    [sym_ieee32] = STATE(1080),
    [sym_ieee64] = STATE(1080),
    [sym_bignum] = STATE(1080),
    [sym_decimal] = STATE(1080),
    [sym_float] = STATE(979),
    [sym_block_comment] = STATE(752),
    [sym_compiler_directive_decl] = STATE(752),
    [sym_fsi_directive_decl] = STATE(752),
    [sym_preproc_line] = STATE(752),
    [sym_preproc_if_in_expression] = STATE(1118),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(195),
    [anon_sym_return] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_null] = ACTIONS(207),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(209),
    [anon_sym_LBRACK_PIPE] = ACTIONS(211),
    [anon_sym_LBRACE] = ACTIONS(1687),
    [anon_sym_LT_AT] = ACTIONS(213),
    [anon_sym_LT_AT_AT] = ACTIONS(1689),
    [anon_sym_LBRACE_PIPE] = ACTIONS(217),
    [anon_sym_new] = ACTIONS(199),
    [anon_sym_return_BANG] = ACTIONS(219),
    [anon_sym_yield] = ACTIONS(199),
    [anon_sym_yield_BANG] = ACTIONS(219),
    [anon_sym_lazy] = ACTIONS(199),
    [anon_sym_assert] = ACTIONS(199),
    [anon_sym_upcast] = ACTIONS(199),
    [anon_sym_downcast] = ACTIONS(199),
    [anon_sym_for] = ACTIONS(223),
    [anon_sym_while] = ACTIONS(225),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(229),
    [anon_sym_match] = ACTIONS(231),
    [anon_sym_match_BANG] = ACTIONS(233),
    [anon_sym_function] = ACTIONS(235),
    [anon_sym_use] = ACTIONS(239),
    [anon_sym_use_BANG] = ACTIONS(241),
    [anon_sym_do_BANG] = ACTIONS(243),
    [anon_sym_begin] = ACTIONS(245),
    [aux_sym_char_token1] = ACTIONS(247),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(251),
    [anon_sym_AT_DQUOTE] = ACTIONS(253),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(255),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(257),
    [sym_bool] = ACTIONS(259),
    [sym_unit] = ACTIONS(1699),
    [anon_sym_LPAREN_PIPE] = ACTIONS(261),
    [sym_op_identifier] = ACTIONS(1701),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(265),
    [sym_xint] = ACTIONS(267),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(269),
  },
  [753] = {
    [sym_function_or_value_defn] = STATE(627),
    [sym__expression] = STATE(149),
    [sym_literal_expression] = STATE(1118),
    [sym_long_identifier_or_op] = STATE(1118),
    [sym_tuple_expression] = STATE(1118),
    [sym_brace_expression] = STATE(1118),
    [sym_anon_record_expression] = STATE(1118),
    [sym_prefixed_expression] = STATE(1118),
    [sym_typecast_expression] = STATE(1118),
    [sym_for_expression] = STATE(1118),
    [sym_while_expression] = STATE(1118),
    [sym__if_branch] = STATE(7163),
    [sym_if_expression] = STATE(1118),
    [sym_fun_expression] = STATE(1118),
    [sym_try_expression] = STATE(1118),
    [sym_match_expression] = STATE(1118),
    [sym_function_expression] = STATE(1118),
    [sym_mutate_expression] = STATE(1118),
    [sym_index_expression] = STATE(1118),
    [sym_typed_expression] = STATE(1118),
    [sym_declaration_expression] = STATE(1118),
    [sym_do_expression] = STATE(1118),
    [sym_list_expression] = STATE(1118),
    [sym_array_expression] = STATE(1118),
    [sym_begin_end_expression] = STATE(1118),
    [sym_paren_expression] = STATE(1118),
    [sym__high_prec_app] = STATE(1133),
    [sym__low_prec_app] = STATE(1133),
    [sym_application_expression] = STATE(1118),
    [sym_dot_expression] = STATE(1118),
    [sym_infix_expression] = STATE(1118),
    [sym_ce_expression] = STATE(1118),
    [sym_sequential_expression] = STATE(1118),
    [sym_char] = STATE(1080),
    [sym_format_string] = STATE(1090),
    [sym__string_literal] = STATE(1090),
    [sym_string] = STATE(1080),
    [sym_verbatim_string] = STATE(1080),
    [sym_bytearray] = STATE(1080),
    [sym_verbatim_bytearray] = STATE(1080),
    [sym_format_triple_quoted_string] = STATE(1096),
    [sym_triple_quoted_string] = STATE(1080),
    [sym_const] = STATE(1118),
    [sym_long_identifier] = STATE(1156),
    [sym_active_pattern] = STATE(1085),
    [sym__identifier_or_op] = STATE(1099),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(517),
    [sym_sbyte] = STATE(1080),
    [sym_byte] = STATE(1080),
    [sym_int16] = STATE(1080),
    [sym_uint16] = STATE(1080),
    [sym_int32] = STATE(1080),
    [sym_uint32] = STATE(1080),
    [sym_nativeint] = STATE(1080),
    [sym_unativeint] = STATE(1080),
    [sym_int64] = STATE(1080),
    [sym_uint64] = STATE(1080),
    [sym_ieee32] = STATE(1080),
    [sym_ieee64] = STATE(1080),
    [sym_bignum] = STATE(1080),
    [sym_decimal] = STATE(1080),
    [sym_float] = STATE(979),
    [sym_block_comment] = STATE(753),
    [sym_compiler_directive_decl] = STATE(753),
    [sym_fsi_directive_decl] = STATE(753),
    [sym_preproc_line] = STATE(753),
    [sym_preproc_if_in_expression] = STATE(1118),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(195),
    [anon_sym_return] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_null] = ACTIONS(207),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(209),
    [anon_sym_LBRACK_PIPE] = ACTIONS(211),
    [anon_sym_LBRACE] = ACTIONS(1687),
    [anon_sym_LT_AT] = ACTIONS(213),
    [anon_sym_LT_AT_AT] = ACTIONS(1689),
    [anon_sym_LBRACE_PIPE] = ACTIONS(217),
    [anon_sym_new] = ACTIONS(199),
    [anon_sym_return_BANG] = ACTIONS(219),
    [anon_sym_yield] = ACTIONS(199),
    [anon_sym_yield_BANG] = ACTIONS(219),
    [anon_sym_lazy] = ACTIONS(199),
    [anon_sym_assert] = ACTIONS(199),
    [anon_sym_upcast] = ACTIONS(199),
    [anon_sym_downcast] = ACTIONS(199),
    [anon_sym_for] = ACTIONS(223),
    [anon_sym_while] = ACTIONS(225),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(229),
    [anon_sym_match] = ACTIONS(231),
    [anon_sym_match_BANG] = ACTIONS(233),
    [anon_sym_function] = ACTIONS(235),
    [anon_sym_use] = ACTIONS(239),
    [anon_sym_use_BANG] = ACTIONS(241),
    [anon_sym_do_BANG] = ACTIONS(243),
    [anon_sym_begin] = ACTIONS(245),
    [aux_sym_char_token1] = ACTIONS(247),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(251),
    [anon_sym_AT_DQUOTE] = ACTIONS(253),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(255),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(257),
    [sym_bool] = ACTIONS(259),
    [sym_unit] = ACTIONS(1699),
    [anon_sym_LPAREN_PIPE] = ACTIONS(261),
    [sym_op_identifier] = ACTIONS(1701),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(265),
    [sym_xint] = ACTIONS(267),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(269),
  },
  [754] = {
    [sym_function_or_value_defn] = STATE(729),
    [sym__expression] = STATE(46),
    [sym_literal_expression] = STATE(867),
    [sym_long_identifier_or_op] = STATE(867),
    [sym_tuple_expression] = STATE(867),
    [sym_brace_expression] = STATE(867),
    [sym_anon_record_expression] = STATE(867),
    [sym_prefixed_expression] = STATE(867),
    [sym_typecast_expression] = STATE(867),
    [sym_for_expression] = STATE(867),
    [sym_while_expression] = STATE(867),
    [sym__if_branch] = STATE(6511),
    [sym_if_expression] = STATE(867),
    [sym_fun_expression] = STATE(867),
    [sym_try_expression] = STATE(867),
    [sym_match_expression] = STATE(867),
    [sym_function_expression] = STATE(867),
    [sym_mutate_expression] = STATE(867),
    [sym_index_expression] = STATE(867),
    [sym_typed_expression] = STATE(867),
    [sym_declaration_expression] = STATE(867),
    [sym_do_expression] = STATE(867),
    [sym_list_expression] = STATE(867),
    [sym_array_expression] = STATE(867),
    [sym_begin_end_expression] = STATE(867),
    [sym_paren_expression] = STATE(867),
    [sym__high_prec_app] = STATE(864),
    [sym__low_prec_app] = STATE(864),
    [sym_application_expression] = STATE(867),
    [sym_dot_expression] = STATE(867),
    [sym_infix_expression] = STATE(867),
    [sym_ce_expression] = STATE(867),
    [sym_sequential_expression] = STATE(867),
    [sym_char] = STATE(868),
    [sym_format_string] = STATE(869),
    [sym__string_literal] = STATE(869),
    [sym_string] = STATE(868),
    [sym_verbatim_string] = STATE(868),
    [sym_bytearray] = STATE(868),
    [sym_verbatim_bytearray] = STATE(868),
    [sym_format_triple_quoted_string] = STATE(870),
    [sym_triple_quoted_string] = STATE(868),
    [sym_const] = STATE(867),
    [sym_long_identifier] = STATE(872),
    [sym_active_pattern] = STATE(871),
    [sym__identifier_or_op] = STATE(873),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(499),
    [sym_sbyte] = STATE(868),
    [sym_byte] = STATE(868),
    [sym_int16] = STATE(868),
    [sym_uint16] = STATE(868),
    [sym_int32] = STATE(868),
    [sym_uint32] = STATE(868),
    [sym_nativeint] = STATE(868),
    [sym_unativeint] = STATE(868),
    [sym_int64] = STATE(868),
    [sym_uint64] = STATE(868),
    [sym_ieee32] = STATE(868),
    [sym_ieee64] = STATE(868),
    [sym_bignum] = STATE(868),
    [sym_decimal] = STATE(868),
    [sym_float] = STATE(1368),
    [sym_block_comment] = STATE(754),
    [sym_compiler_directive_decl] = STATE(754),
    [sym_fsi_directive_decl] = STATE(754),
    [sym_preproc_line] = STATE(754),
    [sym_preproc_if_in_expression] = STATE(867),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(29),
    [anon_sym_return] = ACTIONS(369),
    [anon_sym_do] = ACTIONS(39),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(45),
    [anon_sym_null] = ACTIONS(49),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACK_PIPE] = ACTIONS(57),
    [anon_sym_LBRACE] = ACTIONS(1663),
    [anon_sym_LT_AT] = ACTIONS(61),
    [anon_sym_LT_AT_AT] = ACTIONS(1665),
    [anon_sym_LBRACE_PIPE] = ACTIONS(67),
    [anon_sym_new] = ACTIONS(369),
    [anon_sym_return_BANG] = ACTIONS(373),
    [anon_sym_yield] = ACTIONS(369),
    [anon_sym_yield_BANG] = ACTIONS(373),
    [anon_sym_lazy] = ACTIONS(369),
    [anon_sym_assert] = ACTIONS(369),
    [anon_sym_upcast] = ACTIONS(369),
    [anon_sym_downcast] = ACTIONS(369),
    [anon_sym_for] = ACTIONS(375),
    [anon_sym_while] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(79),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_match] = ACTIONS(83),
    [anon_sym_match_BANG] = ACTIONS(85),
    [anon_sym_function] = ACTIONS(87),
    [anon_sym_use] = ACTIONS(379),
    [anon_sym_use_BANG] = ACTIONS(381),
    [anon_sym_do_BANG] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(101),
    [aux_sym_char_token1] = ACTIONS(105),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(107),
    [anon_sym_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DQUOTE] = ACTIONS(111),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(113),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(115),
    [sym_bool] = ACTIONS(117),
    [sym_unit] = ACTIONS(1673),
    [anon_sym_LPAREN_PIPE] = ACTIONS(121),
    [sym_op_identifier] = ACTIONS(1675),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(385),
    [sym_xint] = ACTIONS(387),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(135),
  },
  [755] = {
    [sym_function_or_value_defn] = STATE(627),
    [sym__expression] = STATE(194),
    [sym_literal_expression] = STATE(1118),
    [sym_long_identifier_or_op] = STATE(1118),
    [sym_tuple_expression] = STATE(1118),
    [sym_brace_expression] = STATE(1118),
    [sym_anon_record_expression] = STATE(1118),
    [sym_prefixed_expression] = STATE(1118),
    [sym_typecast_expression] = STATE(1118),
    [sym_for_expression] = STATE(1118),
    [sym_while_expression] = STATE(1118),
    [sym__if_branch] = STATE(7163),
    [sym_if_expression] = STATE(1118),
    [sym_fun_expression] = STATE(1118),
    [sym_try_expression] = STATE(1118),
    [sym_match_expression] = STATE(1118),
    [sym_function_expression] = STATE(1118),
    [sym_mutate_expression] = STATE(1118),
    [sym_index_expression] = STATE(1118),
    [sym_typed_expression] = STATE(1118),
    [sym_declaration_expression] = STATE(1118),
    [sym_do_expression] = STATE(1118),
    [sym_list_expression] = STATE(1118),
    [sym_array_expression] = STATE(1118),
    [sym_begin_end_expression] = STATE(1118),
    [sym_paren_expression] = STATE(1118),
    [sym__high_prec_app] = STATE(1133),
    [sym__low_prec_app] = STATE(1133),
    [sym_application_expression] = STATE(1118),
    [sym_dot_expression] = STATE(1118),
    [sym_infix_expression] = STATE(1118),
    [sym_ce_expression] = STATE(1118),
    [sym_sequential_expression] = STATE(1118),
    [sym_char] = STATE(1080),
    [sym_format_string] = STATE(1090),
    [sym__string_literal] = STATE(1090),
    [sym_string] = STATE(1080),
    [sym_verbatim_string] = STATE(1080),
    [sym_bytearray] = STATE(1080),
    [sym_verbatim_bytearray] = STATE(1080),
    [sym_format_triple_quoted_string] = STATE(1096),
    [sym_triple_quoted_string] = STATE(1080),
    [sym_const] = STATE(1118),
    [sym_long_identifier] = STATE(1156),
    [sym_active_pattern] = STATE(1085),
    [sym__identifier_or_op] = STATE(1099),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(517),
    [sym_sbyte] = STATE(1080),
    [sym_byte] = STATE(1080),
    [sym_int16] = STATE(1080),
    [sym_uint16] = STATE(1080),
    [sym_int32] = STATE(1080),
    [sym_uint32] = STATE(1080),
    [sym_nativeint] = STATE(1080),
    [sym_unativeint] = STATE(1080),
    [sym_int64] = STATE(1080),
    [sym_uint64] = STATE(1080),
    [sym_ieee32] = STATE(1080),
    [sym_ieee64] = STATE(1080),
    [sym_bignum] = STATE(1080),
    [sym_decimal] = STATE(1080),
    [sym_float] = STATE(979),
    [sym_block_comment] = STATE(755),
    [sym_compiler_directive_decl] = STATE(755),
    [sym_fsi_directive_decl] = STATE(755),
    [sym_preproc_line] = STATE(755),
    [sym_preproc_if_in_expression] = STATE(1118),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(195),
    [anon_sym_return] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_null] = ACTIONS(207),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(209),
    [anon_sym_LBRACK_PIPE] = ACTIONS(211),
    [anon_sym_LBRACE] = ACTIONS(1687),
    [anon_sym_LT_AT] = ACTIONS(213),
    [anon_sym_LT_AT_AT] = ACTIONS(1689),
    [anon_sym_LBRACE_PIPE] = ACTIONS(217),
    [anon_sym_new] = ACTIONS(199),
    [anon_sym_return_BANG] = ACTIONS(219),
    [anon_sym_yield] = ACTIONS(199),
    [anon_sym_yield_BANG] = ACTIONS(219),
    [anon_sym_lazy] = ACTIONS(199),
    [anon_sym_assert] = ACTIONS(199),
    [anon_sym_upcast] = ACTIONS(199),
    [anon_sym_downcast] = ACTIONS(199),
    [anon_sym_for] = ACTIONS(223),
    [anon_sym_while] = ACTIONS(225),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(229),
    [anon_sym_match] = ACTIONS(231),
    [anon_sym_match_BANG] = ACTIONS(233),
    [anon_sym_function] = ACTIONS(235),
    [anon_sym_use] = ACTIONS(239),
    [anon_sym_use_BANG] = ACTIONS(241),
    [anon_sym_do_BANG] = ACTIONS(243),
    [anon_sym_begin] = ACTIONS(245),
    [aux_sym_char_token1] = ACTIONS(247),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(251),
    [anon_sym_AT_DQUOTE] = ACTIONS(253),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(255),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(257),
    [sym_bool] = ACTIONS(259),
    [sym_unit] = ACTIONS(1699),
    [anon_sym_LPAREN_PIPE] = ACTIONS(261),
    [sym_op_identifier] = ACTIONS(1701),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(265),
    [sym_xint] = ACTIONS(267),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(269),
  },
  [756] = {
    [sym_function_or_value_defn] = STATE(703),
    [sym__expression] = STATE(106),
    [sym_literal_expression] = STATE(1797),
    [sym_long_identifier_or_op] = STATE(1797),
    [sym_tuple_expression] = STATE(1797),
    [sym_brace_expression] = STATE(1797),
    [sym_anon_record_expression] = STATE(1797),
    [sym_prefixed_expression] = STATE(1797),
    [sym_typecast_expression] = STATE(1797),
    [sym_for_expression] = STATE(1797),
    [sym_while_expression] = STATE(1797),
    [sym__if_branch] = STATE(6611),
    [sym_if_expression] = STATE(1797),
    [sym_fun_expression] = STATE(1797),
    [sym_try_expression] = STATE(1797),
    [sym_match_expression] = STATE(1797),
    [sym_function_expression] = STATE(1797),
    [sym_mutate_expression] = STATE(1797),
    [sym_index_expression] = STATE(1797),
    [sym_typed_expression] = STATE(1797),
    [sym_declaration_expression] = STATE(1797),
    [sym_do_expression] = STATE(1797),
    [sym_list_expression] = STATE(1797),
    [sym_array_expression] = STATE(1797),
    [sym_begin_end_expression] = STATE(1797),
    [sym_paren_expression] = STATE(1797),
    [sym__high_prec_app] = STATE(1800),
    [sym__low_prec_app] = STATE(1800),
    [sym_application_expression] = STATE(1797),
    [sym_dot_expression] = STATE(1797),
    [sym_infix_expression] = STATE(1797),
    [sym_ce_expression] = STATE(1797),
    [sym_sequential_expression] = STATE(1797),
    [sym_char] = STATE(1694),
    [sym_format_string] = STATE(1693),
    [sym__string_literal] = STATE(1693),
    [sym_string] = STATE(1694),
    [sym_verbatim_string] = STATE(1694),
    [sym_bytearray] = STATE(1694),
    [sym_verbatim_bytearray] = STATE(1694),
    [sym_format_triple_quoted_string] = STATE(1692),
    [sym_triple_quoted_string] = STATE(1694),
    [sym_const] = STATE(1797),
    [sym_long_identifier] = STATE(1813),
    [sym_active_pattern] = STATE(1753),
    [sym__identifier_or_op] = STATE(1812),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(756),
    [sym_sbyte] = STATE(1694),
    [sym_byte] = STATE(1694),
    [sym_int16] = STATE(1694),
    [sym_uint16] = STATE(1694),
    [sym_int32] = STATE(1694),
    [sym_uint32] = STATE(1694),
    [sym_nativeint] = STATE(1694),
    [sym_unativeint] = STATE(1694),
    [sym_int64] = STATE(1694),
    [sym_uint64] = STATE(1694),
    [sym_ieee32] = STATE(1694),
    [sym_ieee64] = STATE(1694),
    [sym_bignum] = STATE(1694),
    [sym_decimal] = STATE(1694),
    [sym_float] = STATE(1425),
    [sym_block_comment] = STATE(756),
    [sym_compiler_directive_decl] = STATE(756),
    [sym_fsi_directive_decl] = STATE(756),
    [sym_preproc_line] = STATE(756),
    [sym_preproc_if_in_expression] = STATE(1797),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(393),
    [anon_sym_return] = ACTIONS(397),
    [anon_sym_do] = ACTIONS(399),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(401),
    [anon_sym_null] = ACTIONS(405),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(407),
    [anon_sym_LBRACK_PIPE] = ACTIONS(409),
    [anon_sym_LBRACE] = ACTIONS(2146),
    [anon_sym_LT_AT] = ACTIONS(413),
    [anon_sym_LT_AT_AT] = ACTIONS(2148),
    [anon_sym_LBRACE_PIPE] = ACTIONS(419),
    [anon_sym_new] = ACTIONS(397),
    [anon_sym_return_BANG] = ACTIONS(421),
    [anon_sym_yield] = ACTIONS(397),
    [anon_sym_yield_BANG] = ACTIONS(421),
    [anon_sym_lazy] = ACTIONS(397),
    [anon_sym_assert] = ACTIONS(397),
    [anon_sym_upcast] = ACTIONS(397),
    [anon_sym_downcast] = ACTIONS(397),
    [anon_sym_for] = ACTIONS(425),
    [anon_sym_while] = ACTIONS(427),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(429),
    [anon_sym_try] = ACTIONS(431),
    [anon_sym_match] = ACTIONS(433),
    [anon_sym_match_BANG] = ACTIONS(435),
    [anon_sym_function] = ACTIONS(437),
    [anon_sym_use] = ACTIONS(445),
    [anon_sym_use_BANG] = ACTIONS(447),
    [anon_sym_do_BANG] = ACTIONS(449),
    [anon_sym_begin] = ACTIONS(451),
    [aux_sym_char_token1] = ACTIONS(455),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(457),
    [anon_sym_DQUOTE] = ACTIONS(459),
    [anon_sym_AT_DQUOTE] = ACTIONS(461),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(463),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(465),
    [sym_bool] = ACTIONS(467),
    [sym_unit] = ACTIONS(2150),
    [anon_sym_LPAREN_PIPE] = ACTIONS(471),
    [sym_op_identifier] = ACTIONS(2152),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(475),
    [sym_xint] = ACTIONS(477),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(479),
  },
  [757] = {
    [sym_function_or_value_defn] = STATE(627),
    [sym__expression] = STATE(293),
    [sym_literal_expression] = STATE(1118),
    [sym_long_identifier_or_op] = STATE(1118),
    [sym_tuple_expression] = STATE(1118),
    [sym_brace_expression] = STATE(1118),
    [sym_anon_record_expression] = STATE(1118),
    [sym_prefixed_expression] = STATE(1118),
    [sym_typecast_expression] = STATE(1118),
    [sym_for_expression] = STATE(1118),
    [sym_while_expression] = STATE(1118),
    [sym__if_branch] = STATE(7163),
    [sym_if_expression] = STATE(1118),
    [sym_fun_expression] = STATE(1118),
    [sym_try_expression] = STATE(1118),
    [sym_match_expression] = STATE(1118),
    [sym_function_expression] = STATE(1118),
    [sym_mutate_expression] = STATE(1118),
    [sym_index_expression] = STATE(1118),
    [sym_typed_expression] = STATE(1118),
    [sym_declaration_expression] = STATE(1118),
    [sym_do_expression] = STATE(1118),
    [sym_list_expression] = STATE(1118),
    [sym_array_expression] = STATE(1118),
    [sym_begin_end_expression] = STATE(1118),
    [sym_paren_expression] = STATE(1118),
    [sym__high_prec_app] = STATE(1133),
    [sym__low_prec_app] = STATE(1133),
    [sym_application_expression] = STATE(1118),
    [sym_dot_expression] = STATE(1118),
    [sym_infix_expression] = STATE(1118),
    [sym_ce_expression] = STATE(1118),
    [sym_sequential_expression] = STATE(1118),
    [sym_char] = STATE(1080),
    [sym_format_string] = STATE(1090),
    [sym__string_literal] = STATE(1090),
    [sym_string] = STATE(1080),
    [sym_verbatim_string] = STATE(1080),
    [sym_bytearray] = STATE(1080),
    [sym_verbatim_bytearray] = STATE(1080),
    [sym_format_triple_quoted_string] = STATE(1096),
    [sym_triple_quoted_string] = STATE(1080),
    [sym_const] = STATE(1118),
    [sym_long_identifier] = STATE(1156),
    [sym_active_pattern] = STATE(1085),
    [sym__identifier_or_op] = STATE(1099),
    [sym__infix_or_prefix_op] = STATE(2838),
    [sym_prefix_op] = STATE(517),
    [sym_sbyte] = STATE(1080),
    [sym_byte] = STATE(1080),
    [sym_int16] = STATE(1080),
    [sym_uint16] = STATE(1080),
    [sym_int32] = STATE(1080),
    [sym_uint32] = STATE(1080),
    [sym_nativeint] = STATE(1080),
    [sym_unativeint] = STATE(1080),
    [sym_int64] = STATE(1080),
    [sym_uint64] = STATE(1080),
    [sym_ieee32] = STATE(1080),
    [sym_ieee64] = STATE(1080),
    [sym_bignum] = STATE(1080),
    [sym_decimal] = STATE(1080),
    [sym_float] = STATE(979),
    [sym_block_comment] = STATE(757),
    [sym_compiler_directive_decl] = STATE(757),
    [sym_fsi_directive_decl] = STATE(757),
    [sym_preproc_line] = STATE(757),
    [sym_preproc_if_in_expression] = STATE(1118),
    [aux_sym_prefix_op_repeat1] = STATE(2834),
    [sym_identifier] = ACTIONS(195),
    [anon_sym_return] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_let_BANG] = ACTIONS(43),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_null] = ACTIONS(207),
    [anon_sym_AMP] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(209),
    [anon_sym_LBRACK_PIPE] = ACTIONS(211),
    [anon_sym_LBRACE] = ACTIONS(1687),
    [anon_sym_LT_AT] = ACTIONS(213),
    [anon_sym_LT_AT_AT] = ACTIONS(1689),
    [anon_sym_LBRACE_PIPE] = ACTIONS(217),
    [anon_sym_new] = ACTIONS(199),
    [anon_sym_return_BANG] = ACTIONS(219),
    [anon_sym_yield] = ACTIONS(199),
    [anon_sym_yield_BANG] = ACTIONS(219),
    [anon_sym_lazy] = ACTIONS(199),
    [anon_sym_assert] = ACTIONS(199),
    [anon_sym_upcast] = ACTIONS(199),
    [anon_sym_downcast] = ACTIONS(199),
    [anon_sym_for] = ACTIONS(223),
    [anon_sym_while] = ACTIONS(225),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_fun] = ACTIONS(227),
    [anon_sym_try] = ACTIONS(229),
    [anon_sym_match] = ACTIONS(231),
    [anon_sym_match_BANG] = ACTIONS(233),
    [anon_sym_function] = ACTIONS(235),
    [anon_sym_use] = ACTIONS(239),
    [anon_sym_use_BANG] = ACTIONS(241),
    [anon_sym_do_BANG] = ACTIONS(243),
    [anon_sym_begin] = ACTIONS(245),
    [aux_sym_char_token1] = ACTIONS(247),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(249),
    [anon_sym_DQUOTE] = ACTIONS(251),
    [anon_sym_AT_DQUOTE] = ACTIONS(253),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(255),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(257),
    [sym_bool] = ACTIONS(259),
    [sym_unit] = ACTIONS(1699),
    [anon_sym_LPAREN_PIPE] = ACTIONS(261),
    [sym_op_identifier] = ACTIONS(1701),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_PLUS_DOT] = ACTIONS(1677),
    [anon_sym_DASH_DOT] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(125),
    [aux_sym_prefix_op_token1] = ACTIONS(1679),
    [sym_int] = ACTIONS(265),
    [sym_xint] = ACTIONS(267),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(269),
  },
  [758] = {
    [sym_block_comment] = STATE(758),
    [sym_compiler_directive_decl] = STATE(758),
    [sym_fsi_directive_decl] = STATE(758),
    [sym_preproc_line] = STATE(758),
    [sym_identifier] = ACTIONS(2158),
    [anon_sym_EQ] = ACTIONS(2160),
    [anon_sym_LBRACK_LT] = ACTIONS(2160),
    [anon_sym_COLON] = ACTIONS(2158),
    [anon_sym_return] = ACTIONS(2158),
    [anon_sym_do] = ACTIONS(2158),
    [anon_sym_let] = ACTIONS(2158),
    [anon_sym_let_BANG] = ACTIONS(2160),
    [aux_sym_access_modifier_token1] = ACTIONS(2160),
    [anon_sym_LPAREN] = ACTIONS(2158),
    [anon_sym_COMMA] = ACTIONS(2160),
    [anon_sym_null] = ACTIONS(2158),
    [anon_sym_QMARK] = ACTIONS(2158),
    [anon_sym_COLON_QMARK] = ACTIONS(2158),
    [anon_sym_COLON_COLON] = ACTIONS(2160),
    [anon_sym_AMP] = ACTIONS(2158),
    [anon_sym_LBRACK] = ACTIONS(2158),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2160),
    [anon_sym_LBRACE] = ACTIONS(2158),
    [anon_sym_LT_AT] = ACTIONS(2158),
    [anon_sym_LT_AT_AT] = ACTIONS(2158),
    [anon_sym_DOT] = ACTIONS(2158),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2160),
    [anon_sym_new] = ACTIONS(2158),
    [anon_sym_with] = ACTIONS(2158),
    [anon_sym_return_BANG] = ACTIONS(2160),
    [anon_sym_yield] = ACTIONS(2158),
    [anon_sym_yield_BANG] = ACTIONS(2160),
    [anon_sym_lazy] = ACTIONS(2158),
    [anon_sym_assert] = ACTIONS(2158),
    [anon_sym_upcast] = ACTIONS(2158),
    [anon_sym_downcast] = ACTIONS(2158),
    [anon_sym_COLON_GT] = ACTIONS(2160),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2160),
    [anon_sym_for] = ACTIONS(2158),
    [anon_sym_while] = ACTIONS(2158),
    [anon_sym_if] = ACTIONS(2158),
    [anon_sym_fun] = ACTIONS(2158),
    [anon_sym_try] = ACTIONS(2158),
    [anon_sym_match] = ACTIONS(2158),
    [anon_sym_match_BANG] = ACTIONS(2160),
    [anon_sym_function] = ACTIONS(2158),
    [anon_sym_LT_DASH] = ACTIONS(2158),
    [anon_sym_DOT_LBRACK] = ACTIONS(2160),
    [anon_sym_LT] = ACTIONS(2160),
    [anon_sym_use] = ACTIONS(2158),
    [anon_sym_use_BANG] = ACTIONS(2160),
    [anon_sym_do_BANG] = ACTIONS(2160),
    [anon_sym_begin] = ACTIONS(2158),
    [anon_sym_LPAREN2] = ACTIONS(2158),
    [anon_sym_default] = ACTIONS(2158),
    [anon_sym_or] = ACTIONS(2158),
    [anon_sym_static] = ACTIONS(2158),
    [anon_sym_member] = ACTIONS(2158),
    [anon_sym_abstract] = ACTIONS(2158),
    [anon_sym_val] = ACTIONS(2158),
    [anon_sym_override] = ACTIONS(2158),
    [aux_sym_char_token1] = ACTIONS(2160),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2158),
    [anon_sym_DQUOTE] = ACTIONS(2158),
    [anon_sym_AT_DQUOTE] = ACTIONS(2160),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2160),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2160),
    [sym_bool] = ACTIONS(2158),
    [sym_unit] = ACTIONS(2160),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2158),
    [sym_op_identifier] = ACTIONS(2158),
    [anon_sym_PLUS] = ACTIONS(2158),
    [anon_sym_DASH] = ACTIONS(2158),
    [anon_sym_PLUS_DOT] = ACTIONS(2158),
    [anon_sym_DASH_DOT] = ACTIONS(2158),
    [anon_sym_PERCENT] = ACTIONS(2158),
    [anon_sym_AMP_AMP] = ACTIONS(2158),
    [anon_sym_TILDE] = ACTIONS(2160),
    [aux_sym_prefix_op_token1] = ACTIONS(2158),
    [aux_sym_infix_op_token1] = ACTIONS(2160),
    [aux_sym_infix_op_token2] = ACTIONS(2158),
    [anon_sym_PIPE_PIPE] = ACTIONS(2158),
    [anon_sym_BANG_EQ] = ACTIONS(2158),
    [anon_sym_COLON_EQ] = ACTIONS(2160),
    [anon_sym_DOLLAR] = ACTIONS(2158),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2158),
    [sym_int] = ACTIONS(2158),
    [sym_xint] = ACTIONS(2160),
    [anon_sym_y] = ACTIONS(2162),
    [anon_sym_uy] = ACTIONS(2164),
    [anon_sym_s] = ACTIONS(2166),
    [anon_sym_us] = ACTIONS(2168),
    [anon_sym_l] = ACTIONS(2170),
    [aux_sym_uint32_token1] = ACTIONS(2172),
    [anon_sym_n] = ACTIONS(2174),
    [anon_sym_un] = ACTIONS(2176),
    [anon_sym_L] = ACTIONS(2178),
    [aux_sym_uint64_token1] = ACTIONS(2180),
    [aux_sym_bignum_token1] = ACTIONS(2182),
    [aux_sym_decimal_token1] = ACTIONS(2184),
    [anon_sym_DOT2] = ACTIONS(2186),
    [aux_sym_float_token1] = ACTIONS(2188),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2160),
    [sym__newline] = ACTIONS(2160),
    [sym__dedent] = ACTIONS(2160),
  },
  [759] = {
    [sym_block_comment] = STATE(759),
    [sym_compiler_directive_decl] = STATE(759),
    [sym_fsi_directive_decl] = STATE(759),
    [sym_preproc_line] = STATE(759),
    [sym_identifier] = ACTIONS(2158),
    [anon_sym_EQ] = ACTIONS(2160),
    [anon_sym_LBRACK_LT] = ACTIONS(2160),
    [anon_sym_COLON] = ACTIONS(2158),
    [anon_sym_return] = ACTIONS(2158),
    [anon_sym_do] = ACTIONS(2158),
    [anon_sym_let] = ACTIONS(2158),
    [anon_sym_let_BANG] = ACTIONS(2160),
    [aux_sym_access_modifier_token1] = ACTIONS(2160),
    [anon_sym_LPAREN] = ACTIONS(2158),
    [anon_sym_COMMA] = ACTIONS(2160),
    [anon_sym_null] = ACTIONS(2158),
    [anon_sym_QMARK] = ACTIONS(2158),
    [anon_sym_COLON_QMARK] = ACTIONS(2158),
    [anon_sym_COLON_COLON] = ACTIONS(2160),
    [anon_sym_AMP] = ACTIONS(2158),
    [anon_sym_LBRACK] = ACTIONS(2158),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2160),
    [anon_sym_LBRACE] = ACTIONS(2158),
    [anon_sym_LT_AT] = ACTIONS(2158),
    [anon_sym_LT_AT_AT] = ACTIONS(2158),
    [anon_sym_DOT] = ACTIONS(2158),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2160),
    [anon_sym_new] = ACTIONS(2158),
    [anon_sym_with] = ACTIONS(2158),
    [anon_sym_return_BANG] = ACTIONS(2160),
    [anon_sym_yield] = ACTIONS(2158),
    [anon_sym_yield_BANG] = ACTIONS(2160),
    [anon_sym_lazy] = ACTIONS(2158),
    [anon_sym_assert] = ACTIONS(2158),
    [anon_sym_upcast] = ACTIONS(2158),
    [anon_sym_downcast] = ACTIONS(2158),
    [anon_sym_COLON_GT] = ACTIONS(2160),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2160),
    [anon_sym_for] = ACTIONS(2158),
    [anon_sym_while] = ACTIONS(2158),
    [anon_sym_if] = ACTIONS(2158),
    [anon_sym_fun] = ACTIONS(2158),
    [anon_sym_try] = ACTIONS(2158),
    [anon_sym_match] = ACTIONS(2158),
    [anon_sym_match_BANG] = ACTIONS(2160),
    [anon_sym_function] = ACTIONS(2158),
    [anon_sym_LT_DASH] = ACTIONS(2158),
    [anon_sym_DOT_LBRACK] = ACTIONS(2160),
    [anon_sym_LT] = ACTIONS(2160),
    [anon_sym_use] = ACTIONS(2158),
    [anon_sym_use_BANG] = ACTIONS(2160),
    [anon_sym_do_BANG] = ACTIONS(2160),
    [anon_sym_begin] = ACTIONS(2158),
    [anon_sym_LPAREN2] = ACTIONS(2158),
    [anon_sym_default] = ACTIONS(2158),
    [anon_sym_or] = ACTIONS(2158),
    [anon_sym_static] = ACTIONS(2158),
    [anon_sym_member] = ACTIONS(2158),
    [anon_sym_abstract] = ACTIONS(2158),
    [anon_sym_val] = ACTIONS(2158),
    [anon_sym_override] = ACTIONS(2158),
    [aux_sym_char_token1] = ACTIONS(2160),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2158),
    [anon_sym_DQUOTE] = ACTIONS(2158),
    [anon_sym_AT_DQUOTE] = ACTIONS(2160),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2160),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2160),
    [sym_bool] = ACTIONS(2158),
    [sym_unit] = ACTIONS(2160),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2158),
    [sym_op_identifier] = ACTIONS(2158),
    [anon_sym_PLUS] = ACTIONS(2158),
    [anon_sym_DASH] = ACTIONS(2158),
    [anon_sym_PLUS_DOT] = ACTIONS(2158),
    [anon_sym_DASH_DOT] = ACTIONS(2158),
    [anon_sym_PERCENT] = ACTIONS(2158),
    [anon_sym_AMP_AMP] = ACTIONS(2158),
    [anon_sym_TILDE] = ACTIONS(2160),
    [aux_sym_prefix_op_token1] = ACTIONS(2158),
    [aux_sym_infix_op_token1] = ACTIONS(2160),
    [aux_sym_infix_op_token2] = ACTIONS(2158),
    [anon_sym_PIPE_PIPE] = ACTIONS(2158),
    [anon_sym_BANG_EQ] = ACTIONS(2158),
    [anon_sym_COLON_EQ] = ACTIONS(2160),
    [anon_sym_DOLLAR] = ACTIONS(2158),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2158),
    [sym_int] = ACTIONS(2158),
    [sym_xint] = ACTIONS(2160),
    [anon_sym_y] = ACTIONS(2162),
    [anon_sym_uy] = ACTIONS(2164),
    [anon_sym_s] = ACTIONS(2166),
    [anon_sym_us] = ACTIONS(2168),
    [anon_sym_l] = ACTIONS(2170),
    [aux_sym_uint32_token1] = ACTIONS(2172),
    [anon_sym_n] = ACTIONS(2174),
    [anon_sym_un] = ACTIONS(2176),
    [anon_sym_L] = ACTIONS(2178),
    [aux_sym_uint64_token1] = ACTIONS(2180),
    [anon_sym_lf] = ACTIONS(2190),
    [anon_sym_LF] = ACTIONS(2192),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2160),
    [sym__newline] = ACTIONS(2160),
    [sym__dedent] = ACTIONS(2160),
  },
  [760] = {
    [sym_block_comment] = STATE(760),
    [sym_compiler_directive_decl] = STATE(760),
    [sym_fsi_directive_decl] = STATE(760),
    [sym_preproc_line] = STATE(760),
    [sym_identifier] = ACTIONS(2158),
    [anon_sym_EQ] = ACTIONS(2160),
    [anon_sym_GT_RBRACK] = ACTIONS(2160),
    [anon_sym_COLON] = ACTIONS(2158),
    [anon_sym_return] = ACTIONS(2158),
    [anon_sym_do] = ACTIONS(2158),
    [anon_sym_let] = ACTIONS(2158),
    [anon_sym_let_BANG] = ACTIONS(2160),
    [anon_sym_LPAREN] = ACTIONS(2158),
    [anon_sym_COMMA] = ACTIONS(2160),
    [anon_sym_null] = ACTIONS(2158),
    [anon_sym_QMARK] = ACTIONS(2158),
    [anon_sym_COLON_QMARK] = ACTIONS(2158),
    [anon_sym_COLON_COLON] = ACTIONS(2160),
    [anon_sym_AMP] = ACTIONS(2158),
    [anon_sym_LBRACK] = ACTIONS(2158),
    [anon_sym_RBRACK] = ACTIONS(2160),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2160),
    [anon_sym_LBRACE] = ACTIONS(2158),
    [anon_sym_RBRACE] = ACTIONS(2160),
    [anon_sym_LT_AT] = ACTIONS(2158),
    [anon_sym_LT_AT_AT] = ACTIONS(2158),
    [anon_sym_DOT] = ACTIONS(2158),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2160),
    [anon_sym_new] = ACTIONS(2158),
    [anon_sym_with] = ACTIONS(2158),
    [anon_sym_return_BANG] = ACTIONS(2160),
    [anon_sym_yield] = ACTIONS(2158),
    [anon_sym_yield_BANG] = ACTIONS(2160),
    [anon_sym_lazy] = ACTIONS(2158),
    [anon_sym_assert] = ACTIONS(2158),
    [anon_sym_upcast] = ACTIONS(2158),
    [anon_sym_downcast] = ACTIONS(2158),
    [anon_sym_COLON_GT] = ACTIONS(2160),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2160),
    [anon_sym_for] = ACTIONS(2158),
    [anon_sym_to] = ACTIONS(2158),
    [anon_sym_downto] = ACTIONS(2158),
    [anon_sym_while] = ACTIONS(2158),
    [anon_sym_if] = ACTIONS(2158),
    [anon_sym_fun] = ACTIONS(2158),
    [anon_sym_try] = ACTIONS(2158),
    [anon_sym_match] = ACTIONS(2158),
    [anon_sym_match_BANG] = ACTIONS(2160),
    [anon_sym_function] = ACTIONS(2158),
    [anon_sym_LT_DASH] = ACTIONS(2158),
    [anon_sym_DOT_LBRACK] = ACTIONS(2160),
    [anon_sym_LT] = ACTIONS(2160),
    [anon_sym_use] = ACTIONS(2158),
    [anon_sym_use_BANG] = ACTIONS(2160),
    [anon_sym_do_BANG] = ACTIONS(2160),
    [anon_sym_begin] = ACTIONS(2158),
    [anon_sym_LPAREN2] = ACTIONS(2158),
    [anon_sym_or] = ACTIONS(2158),
    [aux_sym_char_token1] = ACTIONS(2160),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2158),
    [anon_sym_DQUOTE] = ACTIONS(2158),
    [anon_sym_AT_DQUOTE] = ACTIONS(2160),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2160),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2160),
    [sym_bool] = ACTIONS(2158),
    [sym_unit] = ACTIONS(2160),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2158),
    [sym_op_identifier] = ACTIONS(2158),
    [anon_sym_PLUS] = ACTIONS(2158),
    [anon_sym_DASH] = ACTIONS(2158),
    [anon_sym_PLUS_DOT] = ACTIONS(2158),
    [anon_sym_DASH_DOT] = ACTIONS(2158),
    [anon_sym_PERCENT] = ACTIONS(2158),
    [anon_sym_AMP_AMP] = ACTIONS(2158),
    [anon_sym_TILDE] = ACTIONS(2160),
    [aux_sym_prefix_op_token1] = ACTIONS(2158),
    [aux_sym_infix_op_token1] = ACTIONS(2160),
    [aux_sym_infix_op_token2] = ACTIONS(2158),
    [anon_sym_PIPE_PIPE] = ACTIONS(2158),
    [anon_sym_BANG_EQ] = ACTIONS(2158),
    [anon_sym_COLON_EQ] = ACTIONS(2160),
    [anon_sym_DOLLAR] = ACTIONS(2158),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2158),
    [sym_int] = ACTIONS(2158),
    [sym_xint] = ACTIONS(2160),
    [anon_sym_y] = ACTIONS(2194),
    [anon_sym_uy] = ACTIONS(2196),
    [anon_sym_s] = ACTIONS(2198),
    [anon_sym_us] = ACTIONS(2200),
    [anon_sym_l] = ACTIONS(2202),
    [aux_sym_uint32_token1] = ACTIONS(2204),
    [anon_sym_n] = ACTIONS(2206),
    [anon_sym_un] = ACTIONS(2208),
    [anon_sym_L] = ACTIONS(2210),
    [aux_sym_uint64_token1] = ACTIONS(2212),
    [aux_sym_bignum_token1] = ACTIONS(2214),
    [aux_sym_decimal_token1] = ACTIONS(2216),
    [anon_sym_DOT2] = ACTIONS(2218),
    [aux_sym_float_token1] = ACTIONS(2220),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2160),
    [sym__newline] = ACTIONS(2160),
  },
  [761] = {
    [sym_block_comment] = STATE(761),
    [sym_compiler_directive_decl] = STATE(761),
    [sym_fsi_directive_decl] = STATE(761),
    [sym_preproc_line] = STATE(761),
    [sym_identifier] = ACTIONS(2158),
    [anon_sym_EQ] = ACTIONS(2160),
    [anon_sym_GT_RBRACK] = ACTIONS(2160),
    [anon_sym_COLON] = ACTIONS(2158),
    [anon_sym_return] = ACTIONS(2158),
    [anon_sym_do] = ACTIONS(2158),
    [anon_sym_let] = ACTIONS(2158),
    [anon_sym_let_BANG] = ACTIONS(2160),
    [anon_sym_LPAREN] = ACTIONS(2158),
    [anon_sym_COMMA] = ACTIONS(2160),
    [anon_sym_null] = ACTIONS(2158),
    [anon_sym_QMARK] = ACTIONS(2158),
    [anon_sym_COLON_QMARK] = ACTIONS(2158),
    [anon_sym_COLON_COLON] = ACTIONS(2160),
    [anon_sym_AMP] = ACTIONS(2158),
    [anon_sym_LBRACK] = ACTIONS(2158),
    [anon_sym_RBRACK] = ACTIONS(2160),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2160),
    [anon_sym_LBRACE] = ACTIONS(2158),
    [anon_sym_RBRACE] = ACTIONS(2160),
    [anon_sym_LT_AT] = ACTIONS(2158),
    [anon_sym_LT_AT_AT] = ACTIONS(2158),
    [anon_sym_DOT] = ACTIONS(2158),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2160),
    [anon_sym_new] = ACTIONS(2158),
    [anon_sym_with] = ACTIONS(2158),
    [anon_sym_return_BANG] = ACTIONS(2160),
    [anon_sym_yield] = ACTIONS(2158),
    [anon_sym_yield_BANG] = ACTIONS(2160),
    [anon_sym_lazy] = ACTIONS(2158),
    [anon_sym_assert] = ACTIONS(2158),
    [anon_sym_upcast] = ACTIONS(2158),
    [anon_sym_downcast] = ACTIONS(2158),
    [anon_sym_COLON_GT] = ACTIONS(2160),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2160),
    [anon_sym_for] = ACTIONS(2158),
    [anon_sym_to] = ACTIONS(2158),
    [anon_sym_downto] = ACTIONS(2158),
    [anon_sym_while] = ACTIONS(2158),
    [anon_sym_if] = ACTIONS(2158),
    [anon_sym_fun] = ACTIONS(2158),
    [anon_sym_try] = ACTIONS(2158),
    [anon_sym_match] = ACTIONS(2158),
    [anon_sym_match_BANG] = ACTIONS(2160),
    [anon_sym_function] = ACTIONS(2158),
    [anon_sym_LT_DASH] = ACTIONS(2158),
    [anon_sym_DOT_LBRACK] = ACTIONS(2160),
    [anon_sym_LT] = ACTIONS(2160),
    [anon_sym_use] = ACTIONS(2158),
    [anon_sym_use_BANG] = ACTIONS(2160),
    [anon_sym_do_BANG] = ACTIONS(2160),
    [anon_sym_begin] = ACTIONS(2158),
    [anon_sym_LPAREN2] = ACTIONS(2158),
    [anon_sym_DOT_DOT2] = ACTIONS(2160),
    [anon_sym_or] = ACTIONS(2158),
    [aux_sym_char_token1] = ACTIONS(2160),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2158),
    [anon_sym_DQUOTE] = ACTIONS(2158),
    [anon_sym_AT_DQUOTE] = ACTIONS(2160),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2160),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2160),
    [sym_bool] = ACTIONS(2158),
    [sym_unit] = ACTIONS(2160),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2158),
    [sym_op_identifier] = ACTIONS(2158),
    [anon_sym_PLUS] = ACTIONS(2158),
    [anon_sym_DASH] = ACTIONS(2158),
    [anon_sym_PLUS_DOT] = ACTIONS(2158),
    [anon_sym_DASH_DOT] = ACTIONS(2158),
    [anon_sym_PERCENT] = ACTIONS(2158),
    [anon_sym_AMP_AMP] = ACTIONS(2158),
    [anon_sym_TILDE] = ACTIONS(2160),
    [aux_sym_prefix_op_token1] = ACTIONS(2158),
    [aux_sym_infix_op_token1] = ACTIONS(2160),
    [aux_sym_infix_op_token2] = ACTIONS(2158),
    [anon_sym_PIPE_PIPE] = ACTIONS(2158),
    [anon_sym_BANG_EQ] = ACTIONS(2158),
    [anon_sym_COLON_EQ] = ACTIONS(2160),
    [anon_sym_DOLLAR] = ACTIONS(2158),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2158),
    [sym_int] = ACTIONS(2158),
    [sym_xint] = ACTIONS(2160),
    [anon_sym_y] = ACTIONS(2194),
    [anon_sym_uy] = ACTIONS(2196),
    [anon_sym_s] = ACTIONS(2198),
    [anon_sym_us] = ACTIONS(2200),
    [anon_sym_l] = ACTIONS(2202),
    [aux_sym_uint32_token1] = ACTIONS(2204),
    [anon_sym_n] = ACTIONS(2206),
    [anon_sym_un] = ACTIONS(2208),
    [anon_sym_L] = ACTIONS(2210),
    [aux_sym_uint64_token1] = ACTIONS(2212),
    [anon_sym_lf] = ACTIONS(2222),
    [anon_sym_LF] = ACTIONS(2224),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2160),
    [sym__newline] = ACTIONS(2160),
  },
  [762] = {
    [sym_type_arguments] = STATE(792),
    [sym_long_identifier] = STATE(809),
    [sym_block_comment] = STATE(762),
    [sym_compiler_directive_decl] = STATE(762),
    [sym_fsi_directive_decl] = STATE(762),
    [sym_preproc_line] = STATE(762),
    [aux_sym_compound_type_repeat1] = STATE(779),
    [sym_identifier] = ACTIONS(2226),
    [anon_sym_EQ] = ACTIONS(2228),
    [anon_sym_LBRACK_LT] = ACTIONS(2228),
    [anon_sym_COLON] = ACTIONS(2230),
    [anon_sym_return] = ACTIONS(2230),
    [anon_sym_do] = ACTIONS(2230),
    [anon_sym_let] = ACTIONS(2230),
    [anon_sym_let_BANG] = ACTIONS(2228),
    [aux_sym_access_modifier_token1] = ACTIONS(2228),
    [anon_sym_LPAREN] = ACTIONS(2230),
    [anon_sym_COMMA] = ACTIONS(2228),
    [anon_sym_null] = ACTIONS(2230),
    [anon_sym_QMARK] = ACTIONS(2230),
    [anon_sym_COLON_QMARK] = ACTIONS(2230),
    [anon_sym_COLON_COLON] = ACTIONS(2228),
    [anon_sym_AMP] = ACTIONS(2230),
    [anon_sym_LBRACK] = ACTIONS(2230),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2228),
    [anon_sym_LBRACE] = ACTIONS(2230),
    [anon_sym_LT_AT] = ACTIONS(2230),
    [anon_sym_LT_AT_AT] = ACTIONS(2230),
    [anon_sym_DOT] = ACTIONS(2230),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2228),
    [anon_sym_new] = ACTIONS(2230),
    [anon_sym_with] = ACTIONS(2230),
    [anon_sym_return_BANG] = ACTIONS(2228),
    [anon_sym_yield] = ACTIONS(2230),
    [anon_sym_yield_BANG] = ACTIONS(2228),
    [anon_sym_lazy] = ACTIONS(2230),
    [anon_sym_assert] = ACTIONS(2230),
    [anon_sym_upcast] = ACTIONS(2230),
    [anon_sym_downcast] = ACTIONS(2230),
    [anon_sym_COLON_GT] = ACTIONS(2228),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2228),
    [anon_sym_for] = ACTIONS(2230),
    [anon_sym_while] = ACTIONS(2230),
    [anon_sym_if] = ACTIONS(2230),
    [anon_sym_fun] = ACTIONS(2230),
    [anon_sym_DASH_GT] = ACTIONS(2232),
    [anon_sym_try] = ACTIONS(2230),
    [anon_sym_match] = ACTIONS(2230),
    [anon_sym_match_BANG] = ACTIONS(2228),
    [anon_sym_function] = ACTIONS(2230),
    [anon_sym_LT_DASH] = ACTIONS(2230),
    [anon_sym_DOT_LBRACK] = ACTIONS(2228),
    [anon_sym_LT] = ACTIONS(2228),
    [anon_sym_use] = ACTIONS(2230),
    [anon_sym_use_BANG] = ACTIONS(2228),
    [anon_sym_do_BANG] = ACTIONS(2228),
    [anon_sym_begin] = ACTIONS(2230),
    [anon_sym_LPAREN2] = ACTIONS(2230),
    [anon_sym_DOT_DOT2] = ACTIONS(2228),
    [anon_sym_STAR] = ACTIONS(2234),
    [anon_sym_LT2] = ACTIONS(2236),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2238),
    [anon_sym_default] = ACTIONS(2230),
    [anon_sym_or] = ACTIONS(2230),
    [anon_sym_static] = ACTIONS(2230),
    [anon_sym_member] = ACTIONS(2230),
    [anon_sym_abstract] = ACTIONS(2230),
    [anon_sym_val] = ACTIONS(2230),
    [anon_sym_override] = ACTIONS(2230),
    [aux_sym_char_token1] = ACTIONS(2228),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2230),
    [anon_sym_DQUOTE] = ACTIONS(2230),
    [anon_sym_AT_DQUOTE] = ACTIONS(2228),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2228),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2228),
    [sym_bool] = ACTIONS(2230),
    [sym_unit] = ACTIONS(2228),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2230),
    [sym_op_identifier] = ACTIONS(2230),
    [anon_sym_PLUS] = ACTIONS(2230),
    [anon_sym_DASH] = ACTIONS(2230),
    [anon_sym_PLUS_DOT] = ACTIONS(2230),
    [anon_sym_DASH_DOT] = ACTIONS(2230),
    [anon_sym_PERCENT] = ACTIONS(2230),
    [anon_sym_AMP_AMP] = ACTIONS(2230),
    [anon_sym_TILDE] = ACTIONS(2228),
    [aux_sym_prefix_op_token1] = ACTIONS(2230),
    [aux_sym_infix_op_token1] = ACTIONS(2228),
    [aux_sym_infix_op_token2] = ACTIONS(2230),
    [anon_sym_PIPE_PIPE] = ACTIONS(2230),
    [anon_sym_BANG_EQ] = ACTIONS(2230),
    [anon_sym_COLON_EQ] = ACTIONS(2228),
    [anon_sym_DOLLAR] = ACTIONS(2230),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2230),
    [sym_int] = ACTIONS(2230),
    [sym_xint] = ACTIONS(2228),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2228),
    [sym__newline] = ACTIONS(2228),
    [sym__dedent] = ACTIONS(2228),
  },
  [763] = {
    [sym_type_arguments] = STATE(792),
    [sym_long_identifier] = STATE(809),
    [sym_block_comment] = STATE(763),
    [sym_compiler_directive_decl] = STATE(763),
    [sym_fsi_directive_decl] = STATE(763),
    [sym_preproc_line] = STATE(763),
    [aux_sym_compound_type_repeat1] = STATE(779),
    [sym_identifier] = ACTIONS(2226),
    [anon_sym_EQ] = ACTIONS(2240),
    [anon_sym_LBRACK_LT] = ACTIONS(2240),
    [anon_sym_COLON] = ACTIONS(2242),
    [anon_sym_return] = ACTIONS(2242),
    [anon_sym_do] = ACTIONS(2242),
    [anon_sym_let] = ACTIONS(2242),
    [anon_sym_let_BANG] = ACTIONS(2240),
    [aux_sym_access_modifier_token1] = ACTIONS(2240),
    [anon_sym_LPAREN] = ACTIONS(2242),
    [anon_sym_COMMA] = ACTIONS(2240),
    [anon_sym_null] = ACTIONS(2242),
    [anon_sym_QMARK] = ACTIONS(2242),
    [anon_sym_COLON_QMARK] = ACTIONS(2242),
    [anon_sym_COLON_COLON] = ACTIONS(2240),
    [anon_sym_AMP] = ACTIONS(2242),
    [anon_sym_LBRACK] = ACTIONS(2242),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2240),
    [anon_sym_LBRACE] = ACTIONS(2242),
    [anon_sym_LT_AT] = ACTIONS(2242),
    [anon_sym_LT_AT_AT] = ACTIONS(2242),
    [anon_sym_DOT] = ACTIONS(2242),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2240),
    [anon_sym_new] = ACTIONS(2242),
    [anon_sym_with] = ACTIONS(2242),
    [anon_sym_return_BANG] = ACTIONS(2240),
    [anon_sym_yield] = ACTIONS(2242),
    [anon_sym_yield_BANG] = ACTIONS(2240),
    [anon_sym_lazy] = ACTIONS(2242),
    [anon_sym_assert] = ACTIONS(2242),
    [anon_sym_upcast] = ACTIONS(2242),
    [anon_sym_downcast] = ACTIONS(2242),
    [anon_sym_COLON_GT] = ACTIONS(2240),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2240),
    [anon_sym_for] = ACTIONS(2242),
    [anon_sym_while] = ACTIONS(2242),
    [anon_sym_if] = ACTIONS(2242),
    [anon_sym_fun] = ACTIONS(2242),
    [anon_sym_DASH_GT] = ACTIONS(2232),
    [anon_sym_try] = ACTIONS(2242),
    [anon_sym_match] = ACTIONS(2242),
    [anon_sym_match_BANG] = ACTIONS(2240),
    [anon_sym_function] = ACTIONS(2242),
    [anon_sym_LT_DASH] = ACTIONS(2242),
    [anon_sym_DOT_LBRACK] = ACTIONS(2240),
    [anon_sym_LT] = ACTIONS(2240),
    [anon_sym_use] = ACTIONS(2242),
    [anon_sym_use_BANG] = ACTIONS(2240),
    [anon_sym_do_BANG] = ACTIONS(2240),
    [anon_sym_begin] = ACTIONS(2242),
    [anon_sym_LPAREN2] = ACTIONS(2242),
    [anon_sym_DOT_DOT2] = ACTIONS(2240),
    [anon_sym_STAR] = ACTIONS(2234),
    [anon_sym_LT2] = ACTIONS(2236),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2238),
    [anon_sym_default] = ACTIONS(2242),
    [anon_sym_or] = ACTIONS(2242),
    [anon_sym_static] = ACTIONS(2242),
    [anon_sym_member] = ACTIONS(2242),
    [anon_sym_abstract] = ACTIONS(2242),
    [anon_sym_val] = ACTIONS(2242),
    [anon_sym_override] = ACTIONS(2242),
    [aux_sym_char_token1] = ACTIONS(2240),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2242),
    [anon_sym_DQUOTE] = ACTIONS(2242),
    [anon_sym_AT_DQUOTE] = ACTIONS(2240),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2240),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2240),
    [sym_bool] = ACTIONS(2242),
    [sym_unit] = ACTIONS(2240),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2242),
    [sym_op_identifier] = ACTIONS(2242),
    [anon_sym_PLUS] = ACTIONS(2242),
    [anon_sym_DASH] = ACTIONS(2242),
    [anon_sym_PLUS_DOT] = ACTIONS(2242),
    [anon_sym_DASH_DOT] = ACTIONS(2242),
    [anon_sym_PERCENT] = ACTIONS(2242),
    [anon_sym_AMP_AMP] = ACTIONS(2242),
    [anon_sym_TILDE] = ACTIONS(2240),
    [aux_sym_prefix_op_token1] = ACTIONS(2242),
    [aux_sym_infix_op_token1] = ACTIONS(2240),
    [aux_sym_infix_op_token2] = ACTIONS(2242),
    [anon_sym_PIPE_PIPE] = ACTIONS(2242),
    [anon_sym_BANG_EQ] = ACTIONS(2242),
    [anon_sym_COLON_EQ] = ACTIONS(2240),
    [anon_sym_DOLLAR] = ACTIONS(2242),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2242),
    [sym_int] = ACTIONS(2242),
    [sym_xint] = ACTIONS(2240),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2240),
    [sym__newline] = ACTIONS(2240),
    [sym__dedent] = ACTIONS(2240),
  },
  [764] = {
    [sym_type_arguments] = STATE(792),
    [sym_long_identifier] = STATE(809),
    [sym_block_comment] = STATE(764),
    [sym_compiler_directive_decl] = STATE(764),
    [sym_fsi_directive_decl] = STATE(764),
    [sym_preproc_line] = STATE(764),
    [aux_sym_compound_type_repeat1] = STATE(779),
    [sym_identifier] = ACTIONS(2226),
    [anon_sym_EQ] = ACTIONS(2244),
    [anon_sym_LBRACK_LT] = ACTIONS(2244),
    [anon_sym_COLON] = ACTIONS(2246),
    [anon_sym_return] = ACTIONS(2246),
    [anon_sym_do] = ACTIONS(2246),
    [anon_sym_let] = ACTIONS(2246),
    [anon_sym_let_BANG] = ACTIONS(2244),
    [aux_sym_access_modifier_token1] = ACTIONS(2244),
    [anon_sym_LPAREN] = ACTIONS(2246),
    [anon_sym_COMMA] = ACTIONS(2244),
    [anon_sym_null] = ACTIONS(2246),
    [anon_sym_QMARK] = ACTIONS(2246),
    [anon_sym_COLON_QMARK] = ACTIONS(2246),
    [anon_sym_COLON_COLON] = ACTIONS(2244),
    [anon_sym_AMP] = ACTIONS(2246),
    [anon_sym_LBRACK] = ACTIONS(2246),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2244),
    [anon_sym_LBRACE] = ACTIONS(2246),
    [anon_sym_LT_AT] = ACTIONS(2246),
    [anon_sym_LT_AT_AT] = ACTIONS(2246),
    [anon_sym_DOT] = ACTIONS(2246),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2244),
    [anon_sym_new] = ACTIONS(2246),
    [anon_sym_with] = ACTIONS(2246),
    [anon_sym_return_BANG] = ACTIONS(2244),
    [anon_sym_yield] = ACTIONS(2246),
    [anon_sym_yield_BANG] = ACTIONS(2244),
    [anon_sym_lazy] = ACTIONS(2246),
    [anon_sym_assert] = ACTIONS(2246),
    [anon_sym_upcast] = ACTIONS(2246),
    [anon_sym_downcast] = ACTIONS(2246),
    [anon_sym_COLON_GT] = ACTIONS(2244),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2244),
    [anon_sym_for] = ACTIONS(2246),
    [anon_sym_while] = ACTIONS(2246),
    [anon_sym_if] = ACTIONS(2246),
    [anon_sym_fun] = ACTIONS(2246),
    [anon_sym_DASH_GT] = ACTIONS(2232),
    [anon_sym_try] = ACTIONS(2246),
    [anon_sym_match] = ACTIONS(2246),
    [anon_sym_match_BANG] = ACTIONS(2244),
    [anon_sym_function] = ACTIONS(2246),
    [anon_sym_LT_DASH] = ACTIONS(2246),
    [anon_sym_DOT_LBRACK] = ACTIONS(2244),
    [anon_sym_LT] = ACTIONS(2244),
    [anon_sym_use] = ACTIONS(2246),
    [anon_sym_use_BANG] = ACTIONS(2244),
    [anon_sym_do_BANG] = ACTIONS(2244),
    [anon_sym_begin] = ACTIONS(2246),
    [anon_sym_LPAREN2] = ACTIONS(2246),
    [anon_sym_DOT_DOT2] = ACTIONS(2244),
    [anon_sym_STAR] = ACTIONS(2234),
    [anon_sym_LT2] = ACTIONS(2236),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2238),
    [anon_sym_default] = ACTIONS(2246),
    [anon_sym_or] = ACTIONS(2246),
    [anon_sym_static] = ACTIONS(2246),
    [anon_sym_member] = ACTIONS(2246),
    [anon_sym_abstract] = ACTIONS(2246),
    [anon_sym_val] = ACTIONS(2246),
    [anon_sym_override] = ACTIONS(2246),
    [aux_sym_char_token1] = ACTIONS(2244),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2246),
    [anon_sym_DQUOTE] = ACTIONS(2246),
    [anon_sym_AT_DQUOTE] = ACTIONS(2244),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2244),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2244),
    [sym_bool] = ACTIONS(2246),
    [sym_unit] = ACTIONS(2244),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2246),
    [sym_op_identifier] = ACTIONS(2246),
    [anon_sym_PLUS] = ACTIONS(2246),
    [anon_sym_DASH] = ACTIONS(2246),
    [anon_sym_PLUS_DOT] = ACTIONS(2246),
    [anon_sym_DASH_DOT] = ACTIONS(2246),
    [anon_sym_PERCENT] = ACTIONS(2246),
    [anon_sym_AMP_AMP] = ACTIONS(2246),
    [anon_sym_TILDE] = ACTIONS(2244),
    [aux_sym_prefix_op_token1] = ACTIONS(2246),
    [aux_sym_infix_op_token1] = ACTIONS(2244),
    [aux_sym_infix_op_token2] = ACTIONS(2246),
    [anon_sym_PIPE_PIPE] = ACTIONS(2246),
    [anon_sym_BANG_EQ] = ACTIONS(2246),
    [anon_sym_COLON_EQ] = ACTIONS(2244),
    [anon_sym_DOLLAR] = ACTIONS(2246),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2246),
    [sym_int] = ACTIONS(2246),
    [sym_xint] = ACTIONS(2244),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2244),
    [sym__newline] = ACTIONS(2244),
    [sym__dedent] = ACTIONS(2244),
  },
  [765] = {
    [sym_type_arguments] = STATE(792),
    [sym_long_identifier] = STATE(809),
    [sym_block_comment] = STATE(765),
    [sym_compiler_directive_decl] = STATE(765),
    [sym_fsi_directive_decl] = STATE(765),
    [sym_preproc_line] = STATE(765),
    [aux_sym_compound_type_repeat1] = STATE(779),
    [sym_identifier] = ACTIONS(2226),
    [anon_sym_EQ] = ACTIONS(2248),
    [anon_sym_LBRACK_LT] = ACTIONS(2248),
    [anon_sym_COLON] = ACTIONS(2250),
    [anon_sym_return] = ACTIONS(2250),
    [anon_sym_do] = ACTIONS(2250),
    [anon_sym_let] = ACTIONS(2250),
    [anon_sym_let_BANG] = ACTIONS(2248),
    [aux_sym_access_modifier_token1] = ACTIONS(2248),
    [anon_sym_LPAREN] = ACTIONS(2250),
    [anon_sym_COMMA] = ACTIONS(2248),
    [anon_sym_null] = ACTIONS(2250),
    [anon_sym_QMARK] = ACTIONS(2250),
    [anon_sym_COLON_QMARK] = ACTIONS(2250),
    [anon_sym_COLON_COLON] = ACTIONS(2248),
    [anon_sym_AMP] = ACTIONS(2250),
    [anon_sym_LBRACK] = ACTIONS(2250),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2248),
    [anon_sym_LBRACE] = ACTIONS(2250),
    [anon_sym_LT_AT] = ACTIONS(2250),
    [anon_sym_LT_AT_AT] = ACTIONS(2250),
    [anon_sym_DOT] = ACTIONS(2250),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2248),
    [anon_sym_new] = ACTIONS(2250),
    [anon_sym_with] = ACTIONS(2250),
    [anon_sym_return_BANG] = ACTIONS(2248),
    [anon_sym_yield] = ACTIONS(2250),
    [anon_sym_yield_BANG] = ACTIONS(2248),
    [anon_sym_lazy] = ACTIONS(2250),
    [anon_sym_assert] = ACTIONS(2250),
    [anon_sym_upcast] = ACTIONS(2250),
    [anon_sym_downcast] = ACTIONS(2250),
    [anon_sym_COLON_GT] = ACTIONS(2248),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2248),
    [anon_sym_for] = ACTIONS(2250),
    [anon_sym_while] = ACTIONS(2250),
    [anon_sym_if] = ACTIONS(2250),
    [anon_sym_fun] = ACTIONS(2250),
    [anon_sym_DASH_GT] = ACTIONS(2232),
    [anon_sym_try] = ACTIONS(2250),
    [anon_sym_match] = ACTIONS(2250),
    [anon_sym_match_BANG] = ACTIONS(2248),
    [anon_sym_function] = ACTIONS(2250),
    [anon_sym_LT_DASH] = ACTIONS(2250),
    [anon_sym_DOT_LBRACK] = ACTIONS(2248),
    [anon_sym_LT] = ACTIONS(2248),
    [anon_sym_use] = ACTIONS(2250),
    [anon_sym_use_BANG] = ACTIONS(2248),
    [anon_sym_do_BANG] = ACTIONS(2248),
    [anon_sym_begin] = ACTIONS(2250),
    [anon_sym_LPAREN2] = ACTIONS(2250),
    [anon_sym_DOT_DOT2] = ACTIONS(2248),
    [anon_sym_STAR] = ACTIONS(2234),
    [anon_sym_LT2] = ACTIONS(2236),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2238),
    [anon_sym_default] = ACTIONS(2250),
    [anon_sym_or] = ACTIONS(2250),
    [anon_sym_static] = ACTIONS(2250),
    [anon_sym_member] = ACTIONS(2250),
    [anon_sym_abstract] = ACTIONS(2250),
    [anon_sym_val] = ACTIONS(2250),
    [anon_sym_override] = ACTIONS(2250),
    [aux_sym_char_token1] = ACTIONS(2248),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2250),
    [anon_sym_DQUOTE] = ACTIONS(2250),
    [anon_sym_AT_DQUOTE] = ACTIONS(2248),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2248),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2248),
    [sym_bool] = ACTIONS(2250),
    [sym_unit] = ACTIONS(2248),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2250),
    [sym_op_identifier] = ACTIONS(2250),
    [anon_sym_PLUS] = ACTIONS(2250),
    [anon_sym_DASH] = ACTIONS(2250),
    [anon_sym_PLUS_DOT] = ACTIONS(2250),
    [anon_sym_DASH_DOT] = ACTIONS(2250),
    [anon_sym_PERCENT] = ACTIONS(2250),
    [anon_sym_AMP_AMP] = ACTIONS(2250),
    [anon_sym_TILDE] = ACTIONS(2248),
    [aux_sym_prefix_op_token1] = ACTIONS(2250),
    [aux_sym_infix_op_token1] = ACTIONS(2248),
    [aux_sym_infix_op_token2] = ACTIONS(2250),
    [anon_sym_PIPE_PIPE] = ACTIONS(2250),
    [anon_sym_BANG_EQ] = ACTIONS(2250),
    [anon_sym_COLON_EQ] = ACTIONS(2248),
    [anon_sym_DOLLAR] = ACTIONS(2250),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2250),
    [sym_int] = ACTIONS(2250),
    [sym_xint] = ACTIONS(2248),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2248),
    [sym__newline] = ACTIONS(2248),
    [sym__dedent] = ACTIONS(2248),
  },
  [766] = {
    [sym_type_arguments] = STATE(792),
    [sym_long_identifier] = STATE(809),
    [sym_block_comment] = STATE(766),
    [sym_compiler_directive_decl] = STATE(766),
    [sym_fsi_directive_decl] = STATE(766),
    [sym_preproc_line] = STATE(766),
    [aux_sym_compound_type_repeat1] = STATE(779),
    [sym_identifier] = ACTIONS(2252),
    [anon_sym_EQ] = ACTIONS(2254),
    [anon_sym_LBRACK_LT] = ACTIONS(2254),
    [anon_sym_COLON] = ACTIONS(2252),
    [anon_sym_return] = ACTIONS(2252),
    [anon_sym_do] = ACTIONS(2252),
    [anon_sym_let] = ACTIONS(2252),
    [anon_sym_let_BANG] = ACTIONS(2254),
    [aux_sym_access_modifier_token1] = ACTIONS(2254),
    [anon_sym_LPAREN] = ACTIONS(2252),
    [anon_sym_COMMA] = ACTIONS(2254),
    [anon_sym_null] = ACTIONS(2252),
    [anon_sym_QMARK] = ACTIONS(2252),
    [anon_sym_COLON_QMARK] = ACTIONS(2252),
    [anon_sym_COLON_COLON] = ACTIONS(2254),
    [anon_sym_AMP] = ACTIONS(2252),
    [anon_sym_LBRACK] = ACTIONS(2252),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2254),
    [anon_sym_LBRACE] = ACTIONS(2252),
    [anon_sym_LT_AT] = ACTIONS(2252),
    [anon_sym_LT_AT_AT] = ACTIONS(2252),
    [anon_sym_DOT] = ACTIONS(2252),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2254),
    [anon_sym_new] = ACTIONS(2252),
    [anon_sym_with] = ACTIONS(2252),
    [anon_sym_return_BANG] = ACTIONS(2254),
    [anon_sym_yield] = ACTIONS(2252),
    [anon_sym_yield_BANG] = ACTIONS(2254),
    [anon_sym_lazy] = ACTIONS(2252),
    [anon_sym_assert] = ACTIONS(2252),
    [anon_sym_upcast] = ACTIONS(2252),
    [anon_sym_downcast] = ACTIONS(2252),
    [anon_sym_COLON_GT] = ACTIONS(2254),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2254),
    [anon_sym_for] = ACTIONS(2252),
    [anon_sym_while] = ACTIONS(2252),
    [anon_sym_if] = ACTIONS(2252),
    [anon_sym_fun] = ACTIONS(2252),
    [anon_sym_DASH_GT] = ACTIONS(2232),
    [anon_sym_try] = ACTIONS(2252),
    [anon_sym_match] = ACTIONS(2252),
    [anon_sym_match_BANG] = ACTIONS(2254),
    [anon_sym_function] = ACTIONS(2252),
    [anon_sym_LT_DASH] = ACTIONS(2252),
    [anon_sym_DOT_LBRACK] = ACTIONS(2254),
    [anon_sym_LT] = ACTIONS(2254),
    [anon_sym_use] = ACTIONS(2252),
    [anon_sym_use_BANG] = ACTIONS(2254),
    [anon_sym_do_BANG] = ACTIONS(2254),
    [anon_sym_begin] = ACTIONS(2252),
    [anon_sym_LPAREN2] = ACTIONS(2252),
    [anon_sym_DOT_DOT2] = ACTIONS(2254),
    [anon_sym_STAR] = ACTIONS(2234),
    [anon_sym_LT2] = ACTIONS(2236),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2238),
    [anon_sym_default] = ACTIONS(2252),
    [anon_sym_or] = ACTIONS(2252),
    [anon_sym_static] = ACTIONS(2252),
    [anon_sym_member] = ACTIONS(2252),
    [anon_sym_abstract] = ACTIONS(2252),
    [anon_sym_val] = ACTIONS(2252),
    [anon_sym_override] = ACTIONS(2252),
    [aux_sym_char_token1] = ACTIONS(2254),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2252),
    [anon_sym_DQUOTE] = ACTIONS(2252),
    [anon_sym_AT_DQUOTE] = ACTIONS(2254),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2254),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2254),
    [sym_bool] = ACTIONS(2252),
    [sym_unit] = ACTIONS(2254),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2252),
    [sym_op_identifier] = ACTIONS(2252),
    [anon_sym_PLUS] = ACTIONS(2252),
    [anon_sym_DASH] = ACTIONS(2252),
    [anon_sym_PLUS_DOT] = ACTIONS(2252),
    [anon_sym_DASH_DOT] = ACTIONS(2252),
    [anon_sym_PERCENT] = ACTIONS(2252),
    [anon_sym_AMP_AMP] = ACTIONS(2252),
    [anon_sym_TILDE] = ACTIONS(2254),
    [aux_sym_prefix_op_token1] = ACTIONS(2252),
    [aux_sym_infix_op_token1] = ACTIONS(2254),
    [aux_sym_infix_op_token2] = ACTIONS(2252),
    [anon_sym_PIPE_PIPE] = ACTIONS(2252),
    [anon_sym_BANG_EQ] = ACTIONS(2252),
    [anon_sym_COLON_EQ] = ACTIONS(2254),
    [anon_sym_DOLLAR] = ACTIONS(2252),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2252),
    [sym_int] = ACTIONS(2252),
    [sym_xint] = ACTIONS(2254),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2254),
    [sym__newline] = ACTIONS(2254),
    [sym__dedent] = ACTIONS(2254),
  },
  [767] = {
    [sym_block_comment] = STATE(767),
    [sym_compiler_directive_decl] = STATE(767),
    [sym_fsi_directive_decl] = STATE(767),
    [sym_preproc_line] = STATE(767),
    [sym_identifier] = ACTIONS(2158),
    [anon_sym_EQ] = ACTIONS(2160),
    [anon_sym_COLON] = ACTIONS(2158),
    [anon_sym_return] = ACTIONS(2158),
    [anon_sym_do] = ACTIONS(2158),
    [anon_sym_let] = ACTIONS(2158),
    [anon_sym_let_BANG] = ACTIONS(2160),
    [anon_sym_as] = ACTIONS(2158),
    [anon_sym_LPAREN] = ACTIONS(2158),
    [anon_sym_COMMA] = ACTIONS(2160),
    [anon_sym_null] = ACTIONS(2158),
    [anon_sym_QMARK] = ACTIONS(2158),
    [anon_sym_COLON_QMARK] = ACTIONS(2158),
    [anon_sym_COLON_COLON] = ACTIONS(2160),
    [anon_sym_AMP] = ACTIONS(2158),
    [anon_sym_LBRACK] = ACTIONS(2158),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2160),
    [anon_sym_LBRACE] = ACTIONS(2158),
    [anon_sym_LT_AT] = ACTIONS(2158),
    [anon_sym_LT_AT_AT] = ACTIONS(2158),
    [anon_sym_DOT] = ACTIONS(2158),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2160),
    [anon_sym_new] = ACTIONS(2158),
    [anon_sym_with] = ACTIONS(2158),
    [anon_sym_return_BANG] = ACTIONS(2160),
    [anon_sym_yield] = ACTIONS(2158),
    [anon_sym_yield_BANG] = ACTIONS(2160),
    [anon_sym_lazy] = ACTIONS(2158),
    [anon_sym_assert] = ACTIONS(2158),
    [anon_sym_upcast] = ACTIONS(2158),
    [anon_sym_downcast] = ACTIONS(2158),
    [anon_sym_COLON_GT] = ACTIONS(2160),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2160),
    [anon_sym_for] = ACTIONS(2158),
    [anon_sym_while] = ACTIONS(2158),
    [anon_sym_if] = ACTIONS(2158),
    [anon_sym_fun] = ACTIONS(2158),
    [anon_sym_try] = ACTIONS(2158),
    [anon_sym_match] = ACTIONS(2158),
    [anon_sym_match_BANG] = ACTIONS(2160),
    [anon_sym_function] = ACTIONS(2158),
    [anon_sym_LT_DASH] = ACTIONS(2158),
    [anon_sym_DOT_LBRACK] = ACTIONS(2160),
    [anon_sym_LT] = ACTIONS(2160),
    [anon_sym_use] = ACTIONS(2158),
    [anon_sym_use_BANG] = ACTIONS(2160),
    [anon_sym_do_BANG] = ACTIONS(2160),
    [anon_sym_begin] = ACTIONS(2158),
    [anon_sym_LPAREN2] = ACTIONS(2158),
    [anon_sym_or] = ACTIONS(2158),
    [aux_sym_char_token1] = ACTIONS(2160),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2158),
    [anon_sym_DQUOTE] = ACTIONS(2158),
    [anon_sym_AT_DQUOTE] = ACTIONS(2160),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2160),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2160),
    [sym_bool] = ACTIONS(2158),
    [sym_unit] = ACTIONS(2160),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2158),
    [sym_op_identifier] = ACTIONS(2158),
    [anon_sym_PLUS] = ACTIONS(2158),
    [anon_sym_DASH] = ACTIONS(2158),
    [anon_sym_PLUS_DOT] = ACTIONS(2158),
    [anon_sym_DASH_DOT] = ACTIONS(2158),
    [anon_sym_PERCENT] = ACTIONS(2158),
    [anon_sym_AMP_AMP] = ACTIONS(2158),
    [anon_sym_TILDE] = ACTIONS(2160),
    [aux_sym_prefix_op_token1] = ACTIONS(2158),
    [aux_sym_infix_op_token1] = ACTIONS(2160),
    [aux_sym_infix_op_token2] = ACTIONS(2158),
    [anon_sym_PIPE_PIPE] = ACTIONS(2158),
    [anon_sym_BANG_EQ] = ACTIONS(2158),
    [anon_sym_COLON_EQ] = ACTIONS(2160),
    [anon_sym_DOLLAR] = ACTIONS(2158),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2158),
    [sym_int] = ACTIONS(2158),
    [sym_xint] = ACTIONS(2160),
    [anon_sym_y] = ACTIONS(2256),
    [anon_sym_uy] = ACTIONS(2258),
    [anon_sym_s] = ACTIONS(2260),
    [anon_sym_us] = ACTIONS(2262),
    [anon_sym_l] = ACTIONS(2264),
    [aux_sym_uint32_token1] = ACTIONS(2266),
    [anon_sym_n] = ACTIONS(2268),
    [anon_sym_un] = ACTIONS(2270),
    [anon_sym_L] = ACTIONS(2272),
    [aux_sym_uint64_token1] = ACTIONS(2274),
    [aux_sym_bignum_token1] = ACTIONS(2276),
    [aux_sym_decimal_token1] = ACTIONS(2278),
    [anon_sym_DOT2] = ACTIONS(2280),
    [aux_sym_float_token1] = ACTIONS(2282),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2160),
    [sym__newline] = ACTIONS(2160),
    [sym__dedent] = ACTIONS(2160),
  },
  [768] = {
    [sym_block_comment] = STATE(768),
    [sym_compiler_directive_decl] = STATE(768),
    [sym_fsi_directive_decl] = STATE(768),
    [sym_preproc_line] = STATE(768),
    [sym_identifier] = ACTIONS(2158),
    [anon_sym_EQ] = ACTIONS(2160),
    [anon_sym_COLON] = ACTIONS(2158),
    [anon_sym_return] = ACTIONS(2158),
    [anon_sym_do] = ACTIONS(2158),
    [anon_sym_let] = ACTIONS(2158),
    [anon_sym_let_BANG] = ACTIONS(2160),
    [anon_sym_LPAREN] = ACTIONS(2158),
    [anon_sym_COMMA] = ACTIONS(2160),
    [anon_sym_null] = ACTIONS(2158),
    [anon_sym_QMARK] = ACTIONS(2158),
    [anon_sym_COLON_QMARK] = ACTIONS(2158),
    [anon_sym_COLON_COLON] = ACTIONS(2160),
    [anon_sym_AMP] = ACTIONS(2158),
    [anon_sym_LBRACK] = ACTIONS(2158),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2160),
    [anon_sym_LBRACE] = ACTIONS(2158),
    [anon_sym_LT_AT] = ACTIONS(2158),
    [anon_sym_LT_AT_AT] = ACTIONS(2158),
    [anon_sym_DOT] = ACTIONS(2158),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2160),
    [anon_sym_new] = ACTIONS(2158),
    [anon_sym_return_BANG] = ACTIONS(2160),
    [anon_sym_yield] = ACTIONS(2158),
    [anon_sym_yield_BANG] = ACTIONS(2160),
    [anon_sym_lazy] = ACTIONS(2158),
    [anon_sym_assert] = ACTIONS(2158),
    [anon_sym_upcast] = ACTIONS(2158),
    [anon_sym_downcast] = ACTIONS(2158),
    [anon_sym_COLON_GT] = ACTIONS(2160),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2160),
    [anon_sym_for] = ACTIONS(2158),
    [anon_sym_while] = ACTIONS(2158),
    [anon_sym_if] = ACTIONS(2158),
    [anon_sym_fun] = ACTIONS(2158),
    [anon_sym_DASH_GT] = ACTIONS(2158),
    [anon_sym_try] = ACTIONS(2158),
    [anon_sym_match] = ACTIONS(2158),
    [anon_sym_match_BANG] = ACTIONS(2160),
    [anon_sym_function] = ACTIONS(2158),
    [anon_sym_LT_DASH] = ACTIONS(2158),
    [anon_sym_DOT_LBRACK] = ACTIONS(2160),
    [anon_sym_LT] = ACTIONS(2160),
    [anon_sym_use] = ACTIONS(2158),
    [anon_sym_use_BANG] = ACTIONS(2160),
    [anon_sym_do_BANG] = ACTIONS(2160),
    [anon_sym_DOT_DOT] = ACTIONS(2160),
    [anon_sym_begin] = ACTIONS(2158),
    [anon_sym_LPAREN2] = ACTIONS(2158),
    [anon_sym_or] = ACTIONS(2158),
    [aux_sym_char_token1] = ACTIONS(2160),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2158),
    [anon_sym_DQUOTE] = ACTIONS(2158),
    [anon_sym_AT_DQUOTE] = ACTIONS(2160),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2160),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2160),
    [sym_bool] = ACTIONS(2158),
    [sym_unit] = ACTIONS(2160),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2158),
    [sym_op_identifier] = ACTIONS(2158),
    [anon_sym_PLUS] = ACTIONS(2158),
    [anon_sym_DASH] = ACTIONS(2158),
    [anon_sym_PLUS_DOT] = ACTIONS(2158),
    [anon_sym_DASH_DOT] = ACTIONS(2158),
    [anon_sym_PERCENT] = ACTIONS(2158),
    [anon_sym_AMP_AMP] = ACTIONS(2158),
    [anon_sym_TILDE] = ACTIONS(2160),
    [aux_sym_prefix_op_token1] = ACTIONS(2158),
    [aux_sym_infix_op_token1] = ACTIONS(2160),
    [aux_sym_infix_op_token2] = ACTIONS(2158),
    [anon_sym_PIPE_PIPE] = ACTIONS(2158),
    [anon_sym_BANG_EQ] = ACTIONS(2158),
    [anon_sym_COLON_EQ] = ACTIONS(2160),
    [anon_sym_DOLLAR] = ACTIONS(2158),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2158),
    [sym_int] = ACTIONS(2158),
    [sym_xint] = ACTIONS(2160),
    [anon_sym_y] = ACTIONS(2284),
    [anon_sym_uy] = ACTIONS(2286),
    [anon_sym_s] = ACTIONS(2288),
    [anon_sym_us] = ACTIONS(2290),
    [anon_sym_l] = ACTIONS(2292),
    [aux_sym_uint32_token1] = ACTIONS(2294),
    [anon_sym_n] = ACTIONS(2296),
    [anon_sym_un] = ACTIONS(2298),
    [anon_sym_L] = ACTIONS(2300),
    [aux_sym_uint64_token1] = ACTIONS(2302),
    [aux_sym_bignum_token1] = ACTIONS(2304),
    [aux_sym_decimal_token1] = ACTIONS(2306),
    [anon_sym_DOT2] = ACTIONS(2308),
    [aux_sym_float_token1] = ACTIONS(2310),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2160),
    [sym__newline] = ACTIONS(2160),
  },
  [769] = {
    [sym_block_comment] = STATE(769),
    [sym_compiler_directive_decl] = STATE(769),
    [sym_fsi_directive_decl] = STATE(769),
    [sym_preproc_line] = STATE(769),
    [aux_sym_long_identifier_repeat1] = STATE(781),
    [sym_identifier] = ACTIONS(2312),
    [anon_sym_EQ] = ACTIONS(2314),
    [anon_sym_LBRACK_LT] = ACTIONS(2314),
    [anon_sym_COLON] = ACTIONS(2312),
    [anon_sym_return] = ACTIONS(2312),
    [anon_sym_do] = ACTIONS(2312),
    [anon_sym_let] = ACTIONS(2312),
    [anon_sym_let_BANG] = ACTIONS(2314),
    [aux_sym_access_modifier_token1] = ACTIONS(2314),
    [anon_sym_LPAREN] = ACTIONS(2312),
    [anon_sym_COMMA] = ACTIONS(2314),
    [anon_sym_null] = ACTIONS(2312),
    [anon_sym_QMARK] = ACTIONS(2312),
    [anon_sym_COLON_QMARK] = ACTIONS(2312),
    [anon_sym_COLON_COLON] = ACTIONS(2314),
    [anon_sym_AMP] = ACTIONS(2312),
    [anon_sym_LBRACK] = ACTIONS(2312),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2314),
    [anon_sym_LBRACE] = ACTIONS(2312),
    [anon_sym_LT_AT] = ACTIONS(2312),
    [anon_sym_LT_AT_AT] = ACTIONS(2312),
    [anon_sym_DOT] = ACTIONS(2316),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2314),
    [anon_sym_new] = ACTIONS(2312),
    [anon_sym_with] = ACTIONS(2312),
    [anon_sym_return_BANG] = ACTIONS(2314),
    [anon_sym_yield] = ACTIONS(2312),
    [anon_sym_yield_BANG] = ACTIONS(2314),
    [anon_sym_lazy] = ACTIONS(2312),
    [anon_sym_assert] = ACTIONS(2312),
    [anon_sym_upcast] = ACTIONS(2312),
    [anon_sym_downcast] = ACTIONS(2312),
    [anon_sym_COLON_GT] = ACTIONS(2314),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2314),
    [anon_sym_for] = ACTIONS(2312),
    [anon_sym_while] = ACTIONS(2312),
    [anon_sym_if] = ACTIONS(2312),
    [anon_sym_fun] = ACTIONS(2312),
    [anon_sym_DASH_GT] = ACTIONS(2312),
    [anon_sym_try] = ACTIONS(2312),
    [anon_sym_match] = ACTIONS(2312),
    [anon_sym_match_BANG] = ACTIONS(2314),
    [anon_sym_function] = ACTIONS(2312),
    [anon_sym_LT_DASH] = ACTIONS(2312),
    [anon_sym_DOT_LBRACK] = ACTIONS(2314),
    [anon_sym_LT] = ACTIONS(2314),
    [anon_sym_use] = ACTIONS(2312),
    [anon_sym_use_BANG] = ACTIONS(2314),
    [anon_sym_do_BANG] = ACTIONS(2314),
    [anon_sym_begin] = ACTIONS(2312),
    [anon_sym_LPAREN2] = ACTIONS(2312),
    [anon_sym_DOT_DOT2] = ACTIONS(2314),
    [anon_sym_STAR] = ACTIONS(2312),
    [anon_sym_LT2] = ACTIONS(2312),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2314),
    [anon_sym_default] = ACTIONS(2312),
    [anon_sym_or] = ACTIONS(2312),
    [anon_sym_static] = ACTIONS(2312),
    [anon_sym_member] = ACTIONS(2312),
    [anon_sym_abstract] = ACTIONS(2312),
    [anon_sym_val] = ACTIONS(2312),
    [anon_sym_override] = ACTIONS(2312),
    [aux_sym_char_token1] = ACTIONS(2314),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2312),
    [anon_sym_DQUOTE] = ACTIONS(2312),
    [anon_sym_AT_DQUOTE] = ACTIONS(2314),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2314),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2314),
    [sym_bool] = ACTIONS(2312),
    [sym_unit] = ACTIONS(2314),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2312),
    [sym_op_identifier] = ACTIONS(2312),
    [anon_sym_PLUS] = ACTIONS(2312),
    [anon_sym_DASH] = ACTIONS(2312),
    [anon_sym_PLUS_DOT] = ACTIONS(2312),
    [anon_sym_DASH_DOT] = ACTIONS(2312),
    [anon_sym_PERCENT] = ACTIONS(2312),
    [anon_sym_AMP_AMP] = ACTIONS(2312),
    [anon_sym_TILDE] = ACTIONS(2314),
    [aux_sym_prefix_op_token1] = ACTIONS(2312),
    [aux_sym_infix_op_token1] = ACTIONS(2314),
    [aux_sym_infix_op_token2] = ACTIONS(2312),
    [anon_sym_PIPE_PIPE] = ACTIONS(2312),
    [anon_sym_BANG_EQ] = ACTIONS(2312),
    [anon_sym_COLON_EQ] = ACTIONS(2314),
    [anon_sym_DOLLAR] = ACTIONS(2312),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2312),
    [sym_int] = ACTIONS(2312),
    [sym_xint] = ACTIONS(2314),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2314),
    [sym__newline] = ACTIONS(2314),
    [sym__dedent] = ACTIONS(2314),
  },
  [770] = {
    [sym_block_comment] = STATE(770),
    [sym_compiler_directive_decl] = STATE(770),
    [sym_fsi_directive_decl] = STATE(770),
    [sym_preproc_line] = STATE(770),
    [sym_identifier] = ACTIONS(2158),
    [anon_sym_EQ] = ACTIONS(2160),
    [anon_sym_COLON] = ACTIONS(2158),
    [anon_sym_return] = ACTIONS(2158),
    [anon_sym_do] = ACTIONS(2158),
    [anon_sym_let] = ACTIONS(2158),
    [anon_sym_let_BANG] = ACTIONS(2160),
    [anon_sym_LPAREN] = ACTIONS(2158),
    [anon_sym_COMMA] = ACTIONS(2160),
    [anon_sym_null] = ACTIONS(2158),
    [anon_sym_QMARK] = ACTIONS(2158),
    [anon_sym_COLON_QMARK] = ACTIONS(2158),
    [anon_sym_COLON_COLON] = ACTIONS(2160),
    [anon_sym_AMP] = ACTIONS(2158),
    [anon_sym_LBRACK] = ACTIONS(2158),
    [anon_sym_RBRACK] = ACTIONS(2160),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2160),
    [anon_sym_LBRACE] = ACTIONS(2158),
    [anon_sym_LT_AT] = ACTIONS(2158),
    [anon_sym_LT_AT_AT] = ACTIONS(2158),
    [anon_sym_DOT] = ACTIONS(2158),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2160),
    [anon_sym_new] = ACTIONS(2158),
    [anon_sym_return_BANG] = ACTIONS(2160),
    [anon_sym_yield] = ACTIONS(2158),
    [anon_sym_yield_BANG] = ACTIONS(2160),
    [anon_sym_lazy] = ACTIONS(2158),
    [anon_sym_assert] = ACTIONS(2158),
    [anon_sym_upcast] = ACTIONS(2158),
    [anon_sym_downcast] = ACTIONS(2158),
    [anon_sym_COLON_GT] = ACTIONS(2160),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2160),
    [anon_sym_for] = ACTIONS(2158),
    [anon_sym_while] = ACTIONS(2158),
    [anon_sym_if] = ACTIONS(2158),
    [anon_sym_fun] = ACTIONS(2158),
    [anon_sym_try] = ACTIONS(2158),
    [anon_sym_match] = ACTIONS(2158),
    [anon_sym_match_BANG] = ACTIONS(2160),
    [anon_sym_function] = ACTIONS(2158),
    [anon_sym_LT_DASH] = ACTIONS(2158),
    [anon_sym_DOT_LBRACK] = ACTIONS(2160),
    [anon_sym_LT] = ACTIONS(2160),
    [anon_sym_use] = ACTIONS(2158),
    [anon_sym_use_BANG] = ACTIONS(2160),
    [anon_sym_do_BANG] = ACTIONS(2160),
    [anon_sym_begin] = ACTIONS(2158),
    [anon_sym_LPAREN2] = ACTIONS(2158),
    [anon_sym_DOT_DOT2] = ACTIONS(2160),
    [anon_sym_or] = ACTIONS(2158),
    [aux_sym_char_token1] = ACTIONS(2160),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2158),
    [anon_sym_DQUOTE] = ACTIONS(2158),
    [anon_sym_AT_DQUOTE] = ACTIONS(2160),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2160),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2160),
    [sym_bool] = ACTIONS(2158),
    [sym_unit] = ACTIONS(2160),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2158),
    [sym_op_identifier] = ACTIONS(2158),
    [anon_sym_PLUS] = ACTIONS(2158),
    [anon_sym_DASH] = ACTIONS(2158),
    [anon_sym_PLUS_DOT] = ACTIONS(2158),
    [anon_sym_DASH_DOT] = ACTIONS(2158),
    [anon_sym_PERCENT] = ACTIONS(2158),
    [anon_sym_AMP_AMP] = ACTIONS(2158),
    [anon_sym_TILDE] = ACTIONS(2160),
    [aux_sym_prefix_op_token1] = ACTIONS(2158),
    [aux_sym_infix_op_token1] = ACTIONS(2160),
    [aux_sym_infix_op_token2] = ACTIONS(2158),
    [anon_sym_PIPE_PIPE] = ACTIONS(2158),
    [anon_sym_BANG_EQ] = ACTIONS(2158),
    [anon_sym_COLON_EQ] = ACTIONS(2160),
    [anon_sym_DOLLAR] = ACTIONS(2158),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2158),
    [sym_int] = ACTIONS(2158),
    [sym_xint] = ACTIONS(2160),
    [anon_sym_y] = ACTIONS(2194),
    [anon_sym_uy] = ACTIONS(2196),
    [anon_sym_s] = ACTIONS(2198),
    [anon_sym_us] = ACTIONS(2200),
    [anon_sym_l] = ACTIONS(2202),
    [aux_sym_uint32_token1] = ACTIONS(2204),
    [anon_sym_n] = ACTIONS(2206),
    [anon_sym_un] = ACTIONS(2208),
    [anon_sym_L] = ACTIONS(2210),
    [aux_sym_uint64_token1] = ACTIONS(2212),
    [aux_sym_bignum_token1] = ACTIONS(2214),
    [aux_sym_decimal_token1] = ACTIONS(2216),
    [anon_sym_DOT2] = ACTIONS(2218),
    [aux_sym_float_token1] = ACTIONS(2220),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2160),
    [sym__newline] = ACTIONS(2160),
  },
  [771] = {
    [sym_block_comment] = STATE(771),
    [sym_compiler_directive_decl] = STATE(771),
    [sym_fsi_directive_decl] = STATE(771),
    [sym_preproc_line] = STATE(771),
    [aux_sym_compound_type_repeat1] = STATE(771),
    [sym_identifier] = ACTIONS(2250),
    [anon_sym_EQ] = ACTIONS(2248),
    [anon_sym_LBRACK_LT] = ACTIONS(2248),
    [anon_sym_COLON] = ACTIONS(2250),
    [anon_sym_return] = ACTIONS(2250),
    [anon_sym_do] = ACTIONS(2250),
    [anon_sym_let] = ACTIONS(2250),
    [anon_sym_let_BANG] = ACTIONS(2248),
    [aux_sym_access_modifier_token1] = ACTIONS(2248),
    [anon_sym_LPAREN] = ACTIONS(2250),
    [anon_sym_COMMA] = ACTIONS(2248),
    [anon_sym_null] = ACTIONS(2250),
    [anon_sym_QMARK] = ACTIONS(2250),
    [anon_sym_COLON_QMARK] = ACTIONS(2250),
    [anon_sym_COLON_COLON] = ACTIONS(2248),
    [anon_sym_AMP] = ACTIONS(2250),
    [anon_sym_LBRACK] = ACTIONS(2250),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2248),
    [anon_sym_LBRACE] = ACTIONS(2250),
    [anon_sym_LT_AT] = ACTIONS(2250),
    [anon_sym_LT_AT_AT] = ACTIONS(2250),
    [anon_sym_DOT] = ACTIONS(2250),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2248),
    [anon_sym_new] = ACTIONS(2250),
    [anon_sym_with] = ACTIONS(2250),
    [anon_sym_return_BANG] = ACTIONS(2248),
    [anon_sym_yield] = ACTIONS(2250),
    [anon_sym_yield_BANG] = ACTIONS(2248),
    [anon_sym_lazy] = ACTIONS(2250),
    [anon_sym_assert] = ACTIONS(2250),
    [anon_sym_upcast] = ACTIONS(2250),
    [anon_sym_downcast] = ACTIONS(2250),
    [anon_sym_COLON_GT] = ACTIONS(2248),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2248),
    [anon_sym_for] = ACTIONS(2250),
    [anon_sym_while] = ACTIONS(2250),
    [anon_sym_if] = ACTIONS(2250),
    [anon_sym_fun] = ACTIONS(2250),
    [anon_sym_DASH_GT] = ACTIONS(2250),
    [anon_sym_try] = ACTIONS(2250),
    [anon_sym_match] = ACTIONS(2250),
    [anon_sym_match_BANG] = ACTIONS(2248),
    [anon_sym_function] = ACTIONS(2250),
    [anon_sym_LT_DASH] = ACTIONS(2250),
    [anon_sym_DOT_LBRACK] = ACTIONS(2248),
    [anon_sym_LT] = ACTIONS(2248),
    [anon_sym_use] = ACTIONS(2250),
    [anon_sym_use_BANG] = ACTIONS(2248),
    [anon_sym_do_BANG] = ACTIONS(2248),
    [anon_sym_begin] = ACTIONS(2250),
    [anon_sym_LPAREN2] = ACTIONS(2250),
    [anon_sym_DOT_DOT2] = ACTIONS(2248),
    [anon_sym_STAR] = ACTIONS(2318),
    [anon_sym_LT2] = ACTIONS(2250),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2248),
    [anon_sym_default] = ACTIONS(2250),
    [anon_sym_or] = ACTIONS(2250),
    [anon_sym_static] = ACTIONS(2250),
    [anon_sym_member] = ACTIONS(2250),
    [anon_sym_abstract] = ACTIONS(2250),
    [anon_sym_val] = ACTIONS(2250),
    [anon_sym_override] = ACTIONS(2250),
    [aux_sym_char_token1] = ACTIONS(2248),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2250),
    [anon_sym_DQUOTE] = ACTIONS(2250),
    [anon_sym_AT_DQUOTE] = ACTIONS(2248),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2248),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2248),
    [sym_bool] = ACTIONS(2250),
    [sym_unit] = ACTIONS(2248),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2250),
    [sym_op_identifier] = ACTIONS(2250),
    [anon_sym_PLUS] = ACTIONS(2250),
    [anon_sym_DASH] = ACTIONS(2250),
    [anon_sym_PLUS_DOT] = ACTIONS(2250),
    [anon_sym_DASH_DOT] = ACTIONS(2250),
    [anon_sym_PERCENT] = ACTIONS(2250),
    [anon_sym_AMP_AMP] = ACTIONS(2250),
    [anon_sym_TILDE] = ACTIONS(2248),
    [aux_sym_prefix_op_token1] = ACTIONS(2250),
    [aux_sym_infix_op_token1] = ACTIONS(2248),
    [aux_sym_infix_op_token2] = ACTIONS(2250),
    [anon_sym_PIPE_PIPE] = ACTIONS(2250),
    [anon_sym_BANG_EQ] = ACTIONS(2250),
    [anon_sym_COLON_EQ] = ACTIONS(2248),
    [anon_sym_DOLLAR] = ACTIONS(2250),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2250),
    [sym_int] = ACTIONS(2250),
    [sym_xint] = ACTIONS(2248),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2248),
    [sym__newline] = ACTIONS(2248),
    [sym__dedent] = ACTIONS(2248),
  },
  [772] = {
    [sym_block_comment] = STATE(772),
    [sym_compiler_directive_decl] = STATE(772),
    [sym_fsi_directive_decl] = STATE(772),
    [sym_preproc_line] = STATE(772),
    [aux_sym_type_argument_repeat1] = STATE(773),
    [sym_identifier] = ACTIONS(2321),
    [anon_sym_EQ] = ACTIONS(2323),
    [anon_sym_LBRACK_LT] = ACTIONS(2323),
    [anon_sym_COLON] = ACTIONS(2321),
    [anon_sym_return] = ACTIONS(2321),
    [anon_sym_do] = ACTIONS(2321),
    [anon_sym_let] = ACTIONS(2321),
    [anon_sym_let_BANG] = ACTIONS(2323),
    [aux_sym_access_modifier_token1] = ACTIONS(2323),
    [anon_sym_LPAREN] = ACTIONS(2321),
    [anon_sym_COMMA] = ACTIONS(2323),
    [anon_sym_null] = ACTIONS(2321),
    [anon_sym_QMARK] = ACTIONS(2321),
    [anon_sym_COLON_QMARK] = ACTIONS(2321),
    [anon_sym_COLON_COLON] = ACTIONS(2323),
    [anon_sym_AMP] = ACTIONS(2321),
    [anon_sym_LBRACK] = ACTIONS(2321),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2323),
    [anon_sym_LBRACE] = ACTIONS(2321),
    [anon_sym_LT_AT] = ACTIONS(2321),
    [anon_sym_LT_AT_AT] = ACTIONS(2321),
    [anon_sym_DOT] = ACTIONS(2321),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2323),
    [anon_sym_new] = ACTIONS(2321),
    [anon_sym_with] = ACTIONS(2321),
    [anon_sym_return_BANG] = ACTIONS(2323),
    [anon_sym_yield] = ACTIONS(2321),
    [anon_sym_yield_BANG] = ACTIONS(2323),
    [anon_sym_lazy] = ACTIONS(2321),
    [anon_sym_assert] = ACTIONS(2321),
    [anon_sym_upcast] = ACTIONS(2321),
    [anon_sym_downcast] = ACTIONS(2321),
    [anon_sym_COLON_GT] = ACTIONS(2323),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2323),
    [anon_sym_for] = ACTIONS(2321),
    [anon_sym_while] = ACTIONS(2321),
    [anon_sym_if] = ACTIONS(2321),
    [anon_sym_fun] = ACTIONS(2321),
    [anon_sym_DASH_GT] = ACTIONS(2321),
    [anon_sym_try] = ACTIONS(2321),
    [anon_sym_match] = ACTIONS(2321),
    [anon_sym_match_BANG] = ACTIONS(2323),
    [anon_sym_function] = ACTIONS(2321),
    [anon_sym_LT_DASH] = ACTIONS(2321),
    [anon_sym_DOT_LBRACK] = ACTIONS(2323),
    [anon_sym_LT] = ACTIONS(2323),
    [anon_sym_use] = ACTIONS(2321),
    [anon_sym_use_BANG] = ACTIONS(2323),
    [anon_sym_do_BANG] = ACTIONS(2323),
    [anon_sym_begin] = ACTIONS(2321),
    [anon_sym_LPAREN2] = ACTIONS(2321),
    [anon_sym_DOT_DOT2] = ACTIONS(2323),
    [anon_sym_STAR] = ACTIONS(2321),
    [anon_sym_LT2] = ACTIONS(2321),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2323),
    [anon_sym_default] = ACTIONS(2321),
    [anon_sym_or] = ACTIONS(2325),
    [anon_sym_static] = ACTIONS(2321),
    [anon_sym_member] = ACTIONS(2321),
    [anon_sym_abstract] = ACTIONS(2321),
    [anon_sym_val] = ACTIONS(2321),
    [anon_sym_override] = ACTIONS(2321),
    [aux_sym_char_token1] = ACTIONS(2323),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2321),
    [anon_sym_DQUOTE] = ACTIONS(2321),
    [anon_sym_AT_DQUOTE] = ACTIONS(2323),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2323),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2323),
    [sym_bool] = ACTIONS(2321),
    [sym_unit] = ACTIONS(2323),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2321),
    [sym_op_identifier] = ACTIONS(2321),
    [anon_sym_PLUS] = ACTIONS(2321),
    [anon_sym_DASH] = ACTIONS(2321),
    [anon_sym_PLUS_DOT] = ACTIONS(2321),
    [anon_sym_DASH_DOT] = ACTIONS(2321),
    [anon_sym_PERCENT] = ACTIONS(2321),
    [anon_sym_AMP_AMP] = ACTIONS(2321),
    [anon_sym_TILDE] = ACTIONS(2323),
    [aux_sym_prefix_op_token1] = ACTIONS(2321),
    [aux_sym_infix_op_token1] = ACTIONS(2323),
    [aux_sym_infix_op_token2] = ACTIONS(2321),
    [anon_sym_PIPE_PIPE] = ACTIONS(2321),
    [anon_sym_BANG_EQ] = ACTIONS(2321),
    [anon_sym_COLON_EQ] = ACTIONS(2323),
    [anon_sym_DOLLAR] = ACTIONS(2321),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2321),
    [sym_int] = ACTIONS(2321),
    [sym_xint] = ACTIONS(2323),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2323),
    [sym__newline] = ACTIONS(2323),
    [sym__dedent] = ACTIONS(2323),
  },
  [773] = {
    [sym_block_comment] = STATE(773),
    [sym_compiler_directive_decl] = STATE(773),
    [sym_fsi_directive_decl] = STATE(773),
    [sym_preproc_line] = STATE(773),
    [aux_sym_type_argument_repeat1] = STATE(775),
    [sym_identifier] = ACTIONS(2328),
    [anon_sym_EQ] = ACTIONS(2330),
    [anon_sym_LBRACK_LT] = ACTIONS(2330),
    [anon_sym_COLON] = ACTIONS(2328),
    [anon_sym_return] = ACTIONS(2328),
    [anon_sym_do] = ACTIONS(2328),
    [anon_sym_let] = ACTIONS(2328),
    [anon_sym_let_BANG] = ACTIONS(2330),
    [aux_sym_access_modifier_token1] = ACTIONS(2330),
    [anon_sym_LPAREN] = ACTIONS(2328),
    [anon_sym_COMMA] = ACTIONS(2330),
    [anon_sym_null] = ACTIONS(2328),
    [anon_sym_QMARK] = ACTIONS(2328),
    [anon_sym_COLON_QMARK] = ACTIONS(2328),
    [anon_sym_COLON_COLON] = ACTIONS(2330),
    [anon_sym_AMP] = ACTIONS(2328),
    [anon_sym_LBRACK] = ACTIONS(2328),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2330),
    [anon_sym_LBRACE] = ACTIONS(2328),
    [anon_sym_LT_AT] = ACTIONS(2328),
    [anon_sym_LT_AT_AT] = ACTIONS(2328),
    [anon_sym_DOT] = ACTIONS(2328),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2330),
    [anon_sym_new] = ACTIONS(2328),
    [anon_sym_with] = ACTIONS(2328),
    [anon_sym_return_BANG] = ACTIONS(2330),
    [anon_sym_yield] = ACTIONS(2328),
    [anon_sym_yield_BANG] = ACTIONS(2330),
    [anon_sym_lazy] = ACTIONS(2328),
    [anon_sym_assert] = ACTIONS(2328),
    [anon_sym_upcast] = ACTIONS(2328),
    [anon_sym_downcast] = ACTIONS(2328),
    [anon_sym_COLON_GT] = ACTIONS(2330),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2330),
    [anon_sym_for] = ACTIONS(2328),
    [anon_sym_while] = ACTIONS(2328),
    [anon_sym_if] = ACTIONS(2328),
    [anon_sym_fun] = ACTIONS(2328),
    [anon_sym_DASH_GT] = ACTIONS(2328),
    [anon_sym_try] = ACTIONS(2328),
    [anon_sym_match] = ACTIONS(2328),
    [anon_sym_match_BANG] = ACTIONS(2330),
    [anon_sym_function] = ACTIONS(2328),
    [anon_sym_LT_DASH] = ACTIONS(2328),
    [anon_sym_DOT_LBRACK] = ACTIONS(2330),
    [anon_sym_LT] = ACTIONS(2330),
    [anon_sym_use] = ACTIONS(2328),
    [anon_sym_use_BANG] = ACTIONS(2330),
    [anon_sym_do_BANG] = ACTIONS(2330),
    [anon_sym_begin] = ACTIONS(2328),
    [anon_sym_LPAREN2] = ACTIONS(2328),
    [anon_sym_DOT_DOT2] = ACTIONS(2330),
    [anon_sym_STAR] = ACTIONS(2328),
    [anon_sym_LT2] = ACTIONS(2328),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2330),
    [anon_sym_default] = ACTIONS(2328),
    [anon_sym_or] = ACTIONS(2328),
    [anon_sym_static] = ACTIONS(2328),
    [anon_sym_member] = ACTIONS(2328),
    [anon_sym_abstract] = ACTIONS(2328),
    [anon_sym_val] = ACTIONS(2328),
    [anon_sym_override] = ACTIONS(2328),
    [aux_sym_char_token1] = ACTIONS(2330),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2328),
    [anon_sym_DQUOTE] = ACTIONS(2328),
    [anon_sym_AT_DQUOTE] = ACTIONS(2330),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2330),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2330),
    [sym_bool] = ACTIONS(2328),
    [sym_unit] = ACTIONS(2330),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2328),
    [sym_op_identifier] = ACTIONS(2328),
    [anon_sym_PLUS] = ACTIONS(2328),
    [anon_sym_DASH] = ACTIONS(2328),
    [anon_sym_PLUS_DOT] = ACTIONS(2328),
    [anon_sym_DASH_DOT] = ACTIONS(2328),
    [anon_sym_PERCENT] = ACTIONS(2328),
    [anon_sym_AMP_AMP] = ACTIONS(2328),
    [anon_sym_TILDE] = ACTIONS(2330),
    [aux_sym_prefix_op_token1] = ACTIONS(2328),
    [aux_sym_infix_op_token1] = ACTIONS(2330),
    [aux_sym_infix_op_token2] = ACTIONS(2328),
    [anon_sym_PIPE_PIPE] = ACTIONS(2328),
    [anon_sym_BANG_EQ] = ACTIONS(2328),
    [anon_sym_COLON_EQ] = ACTIONS(2330),
    [anon_sym_DOLLAR] = ACTIONS(2328),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2328),
    [sym_int] = ACTIONS(2328),
    [sym_xint] = ACTIONS(2330),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2330),
    [sym__newline] = ACTIONS(2330),
    [sym__dedent] = ACTIONS(2330),
  },
  [774] = {
    [sym__else_expression] = STATE(954),
    [sym_elif_expression] = STATE(833),
    [sym_block_comment] = STATE(774),
    [sym_compiler_directive_decl] = STATE(774),
    [sym_fsi_directive_decl] = STATE(774),
    [sym_preproc_line] = STATE(774),
    [aux_sym_if_expression_repeat1] = STATE(799),
    [sym_identifier] = ACTIONS(2332),
    [anon_sym_EQ] = ACTIONS(2334),
    [anon_sym_LBRACK_LT] = ACTIONS(2334),
    [anon_sym_COLON] = ACTIONS(2332),
    [anon_sym_return] = ACTIONS(2332),
    [anon_sym_do] = ACTIONS(2332),
    [anon_sym_let] = ACTIONS(2332),
    [anon_sym_let_BANG] = ACTIONS(2334),
    [aux_sym_access_modifier_token1] = ACTIONS(2334),
    [anon_sym_LPAREN] = ACTIONS(2332),
    [anon_sym_COMMA] = ACTIONS(2334),
    [anon_sym_null] = ACTIONS(2332),
    [anon_sym_QMARK] = ACTIONS(2332),
    [anon_sym_COLON_QMARK] = ACTIONS(2332),
    [anon_sym_COLON_COLON] = ACTIONS(2334),
    [anon_sym_AMP] = ACTIONS(2332),
    [anon_sym_LBRACK] = ACTIONS(2332),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2334),
    [anon_sym_LBRACE] = ACTIONS(2332),
    [anon_sym_LT_AT] = ACTIONS(2332),
    [anon_sym_LT_AT_AT] = ACTIONS(2332),
    [anon_sym_DOT] = ACTIONS(2332),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2334),
    [anon_sym_new] = ACTIONS(2332),
    [anon_sym_with] = ACTIONS(2332),
    [anon_sym_return_BANG] = ACTIONS(2334),
    [anon_sym_yield] = ACTIONS(2332),
    [anon_sym_yield_BANG] = ACTIONS(2334),
    [anon_sym_lazy] = ACTIONS(2332),
    [anon_sym_assert] = ACTIONS(2332),
    [anon_sym_upcast] = ACTIONS(2332),
    [anon_sym_downcast] = ACTIONS(2332),
    [anon_sym_COLON_GT] = ACTIONS(2334),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2334),
    [anon_sym_for] = ACTIONS(2332),
    [anon_sym_while] = ACTIONS(2332),
    [anon_sym_else] = ACTIONS(2336),
    [anon_sym_elif] = ACTIONS(2338),
    [anon_sym_if] = ACTIONS(2332),
    [anon_sym_fun] = ACTIONS(2332),
    [anon_sym_try] = ACTIONS(2332),
    [anon_sym_match] = ACTIONS(2332),
    [anon_sym_match_BANG] = ACTIONS(2334),
    [anon_sym_function] = ACTIONS(2332),
    [anon_sym_LT_DASH] = ACTIONS(2332),
    [anon_sym_DOT_LBRACK] = ACTIONS(2334),
    [anon_sym_LT] = ACTIONS(2334),
    [anon_sym_use] = ACTIONS(2332),
    [anon_sym_use_BANG] = ACTIONS(2334),
    [anon_sym_do_BANG] = ACTIONS(2334),
    [anon_sym_begin] = ACTIONS(2332),
    [anon_sym_LPAREN2] = ACTIONS(2332),
    [anon_sym_DOT_DOT2] = ACTIONS(2334),
    [anon_sym_default] = ACTIONS(2332),
    [anon_sym_or] = ACTIONS(2332),
    [anon_sym_static] = ACTIONS(2332),
    [anon_sym_member] = ACTIONS(2332),
    [anon_sym_abstract] = ACTIONS(2332),
    [anon_sym_val] = ACTIONS(2332),
    [anon_sym_override] = ACTIONS(2332),
    [aux_sym_char_token1] = ACTIONS(2334),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2332),
    [anon_sym_DQUOTE] = ACTIONS(2332),
    [anon_sym_AT_DQUOTE] = ACTIONS(2334),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2334),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2334),
    [sym_bool] = ACTIONS(2332),
    [sym_unit] = ACTIONS(2334),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2332),
    [sym_op_identifier] = ACTIONS(2332),
    [anon_sym_PLUS] = ACTIONS(2332),
    [anon_sym_DASH] = ACTIONS(2332),
    [anon_sym_PLUS_DOT] = ACTIONS(2332),
    [anon_sym_DASH_DOT] = ACTIONS(2332),
    [anon_sym_PERCENT] = ACTIONS(2332),
    [anon_sym_AMP_AMP] = ACTIONS(2332),
    [anon_sym_TILDE] = ACTIONS(2334),
    [aux_sym_prefix_op_token1] = ACTIONS(2332),
    [aux_sym_infix_op_token1] = ACTIONS(2334),
    [aux_sym_infix_op_token2] = ACTIONS(2332),
    [anon_sym_PIPE_PIPE] = ACTIONS(2332),
    [anon_sym_BANG_EQ] = ACTIONS(2332),
    [anon_sym_COLON_EQ] = ACTIONS(2334),
    [anon_sym_DOLLAR] = ACTIONS(2332),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2332),
    [sym_int] = ACTIONS(2332),
    [sym_xint] = ACTIONS(2334),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2334),
    [sym__newline] = ACTIONS(2334),
    [sym__dedent] = ACTIONS(2334),
  },
  [775] = {
    [sym_block_comment] = STATE(775),
    [sym_compiler_directive_decl] = STATE(775),
    [sym_fsi_directive_decl] = STATE(775),
    [sym_preproc_line] = STATE(775),
    [aux_sym_type_argument_repeat1] = STATE(775),
    [sym_identifier] = ACTIONS(2340),
    [anon_sym_EQ] = ACTIONS(2342),
    [anon_sym_LBRACK_LT] = ACTIONS(2342),
    [anon_sym_COLON] = ACTIONS(2340),
    [anon_sym_return] = ACTIONS(2340),
    [anon_sym_do] = ACTIONS(2340),
    [anon_sym_let] = ACTIONS(2340),
    [anon_sym_let_BANG] = ACTIONS(2342),
    [aux_sym_access_modifier_token1] = ACTIONS(2342),
    [anon_sym_LPAREN] = ACTIONS(2340),
    [anon_sym_COMMA] = ACTIONS(2342),
    [anon_sym_null] = ACTIONS(2340),
    [anon_sym_QMARK] = ACTIONS(2340),
    [anon_sym_COLON_QMARK] = ACTIONS(2340),
    [anon_sym_COLON_COLON] = ACTIONS(2342),
    [anon_sym_AMP] = ACTIONS(2340),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2342),
    [anon_sym_LBRACE] = ACTIONS(2340),
    [anon_sym_LT_AT] = ACTIONS(2340),
    [anon_sym_LT_AT_AT] = ACTIONS(2340),
    [anon_sym_DOT] = ACTIONS(2340),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2342),
    [anon_sym_new] = ACTIONS(2340),
    [anon_sym_with] = ACTIONS(2340),
    [anon_sym_return_BANG] = ACTIONS(2342),
    [anon_sym_yield] = ACTIONS(2340),
    [anon_sym_yield_BANG] = ACTIONS(2342),
    [anon_sym_lazy] = ACTIONS(2340),
    [anon_sym_assert] = ACTIONS(2340),
    [anon_sym_upcast] = ACTIONS(2340),
    [anon_sym_downcast] = ACTIONS(2340),
    [anon_sym_COLON_GT] = ACTIONS(2342),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2342),
    [anon_sym_for] = ACTIONS(2340),
    [anon_sym_while] = ACTIONS(2340),
    [anon_sym_if] = ACTIONS(2340),
    [anon_sym_fun] = ACTIONS(2340),
    [anon_sym_DASH_GT] = ACTIONS(2340),
    [anon_sym_try] = ACTIONS(2340),
    [anon_sym_match] = ACTIONS(2340),
    [anon_sym_match_BANG] = ACTIONS(2342),
    [anon_sym_function] = ACTIONS(2340),
    [anon_sym_LT_DASH] = ACTIONS(2340),
    [anon_sym_DOT_LBRACK] = ACTIONS(2342),
    [anon_sym_LT] = ACTIONS(2342),
    [anon_sym_use] = ACTIONS(2340),
    [anon_sym_use_BANG] = ACTIONS(2342),
    [anon_sym_do_BANG] = ACTIONS(2342),
    [anon_sym_begin] = ACTIONS(2340),
    [anon_sym_LPAREN2] = ACTIONS(2340),
    [anon_sym_DOT_DOT2] = ACTIONS(2342),
    [anon_sym_STAR] = ACTIONS(2340),
    [anon_sym_LT2] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2342),
    [anon_sym_default] = ACTIONS(2340),
    [anon_sym_or] = ACTIONS(2344),
    [anon_sym_static] = ACTIONS(2340),
    [anon_sym_member] = ACTIONS(2340),
    [anon_sym_abstract] = ACTIONS(2340),
    [anon_sym_val] = ACTIONS(2340),
    [anon_sym_override] = ACTIONS(2340),
    [aux_sym_char_token1] = ACTIONS(2342),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2340),
    [anon_sym_DQUOTE] = ACTIONS(2340),
    [anon_sym_AT_DQUOTE] = ACTIONS(2342),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2342),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2342),
    [sym_bool] = ACTIONS(2340),
    [sym_unit] = ACTIONS(2342),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2340),
    [sym_op_identifier] = ACTIONS(2340),
    [anon_sym_PLUS] = ACTIONS(2340),
    [anon_sym_DASH] = ACTIONS(2340),
    [anon_sym_PLUS_DOT] = ACTIONS(2340),
    [anon_sym_DASH_DOT] = ACTIONS(2340),
    [anon_sym_PERCENT] = ACTIONS(2340),
    [anon_sym_AMP_AMP] = ACTIONS(2340),
    [anon_sym_TILDE] = ACTIONS(2342),
    [aux_sym_prefix_op_token1] = ACTIONS(2340),
    [aux_sym_infix_op_token1] = ACTIONS(2342),
    [aux_sym_infix_op_token2] = ACTIONS(2340),
    [anon_sym_PIPE_PIPE] = ACTIONS(2340),
    [anon_sym_BANG_EQ] = ACTIONS(2340),
    [anon_sym_COLON_EQ] = ACTIONS(2342),
    [anon_sym_DOLLAR] = ACTIONS(2340),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2340),
    [sym_int] = ACTIONS(2340),
    [sym_xint] = ACTIONS(2342),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2342),
    [sym__newline] = ACTIONS(2342),
    [sym__dedent] = ACTIONS(2342),
  },
  [776] = {
    [sym_block_comment] = STATE(776),
    [sym_compiler_directive_decl] = STATE(776),
    [sym_fsi_directive_decl] = STATE(776),
    [sym_preproc_line] = STATE(776),
    [sym_identifier] = ACTIONS(2158),
    [anon_sym_EQ] = ACTIONS(2160),
    [anon_sym_COLON] = ACTIONS(2158),
    [anon_sym_return] = ACTIONS(2158),
    [anon_sym_do] = ACTIONS(2158),
    [anon_sym_and] = ACTIONS(2158),
    [anon_sym_let] = ACTIONS(2158),
    [anon_sym_let_BANG] = ACTIONS(2160),
    [anon_sym_LPAREN] = ACTIONS(2158),
    [anon_sym_COMMA] = ACTIONS(2160),
    [anon_sym_null] = ACTIONS(2158),
    [anon_sym_QMARK] = ACTIONS(2158),
    [anon_sym_COLON_QMARK] = ACTIONS(2158),
    [anon_sym_COLON_COLON] = ACTIONS(2160),
    [anon_sym_AMP] = ACTIONS(2158),
    [anon_sym_LBRACK] = ACTIONS(2158),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2160),
    [anon_sym_LBRACE] = ACTIONS(2158),
    [anon_sym_LT_AT] = ACTIONS(2158),
    [anon_sym_LT_AT_AT] = ACTIONS(2158),
    [anon_sym_DOT] = ACTIONS(2158),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2160),
    [anon_sym_new] = ACTIONS(2158),
    [anon_sym_return_BANG] = ACTIONS(2160),
    [anon_sym_yield] = ACTIONS(2158),
    [anon_sym_yield_BANG] = ACTIONS(2160),
    [anon_sym_lazy] = ACTIONS(2158),
    [anon_sym_assert] = ACTIONS(2158),
    [anon_sym_upcast] = ACTIONS(2158),
    [anon_sym_downcast] = ACTIONS(2158),
    [anon_sym_COLON_GT] = ACTIONS(2160),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2160),
    [anon_sym_for] = ACTIONS(2158),
    [anon_sym_while] = ACTIONS(2158),
    [anon_sym_if] = ACTIONS(2158),
    [anon_sym_fun] = ACTIONS(2158),
    [anon_sym_try] = ACTIONS(2158),
    [anon_sym_match] = ACTIONS(2158),
    [anon_sym_match_BANG] = ACTIONS(2160),
    [anon_sym_function] = ACTIONS(2158),
    [anon_sym_LT_DASH] = ACTIONS(2158),
    [anon_sym_DOT_LBRACK] = ACTIONS(2160),
    [anon_sym_LT] = ACTIONS(2160),
    [anon_sym_use] = ACTIONS(2158),
    [anon_sym_use_BANG] = ACTIONS(2160),
    [anon_sym_do_BANG] = ACTIONS(2160),
    [anon_sym_begin] = ACTIONS(2158),
    [anon_sym_LPAREN2] = ACTIONS(2158),
    [anon_sym_or] = ACTIONS(2158),
    [aux_sym_char_token1] = ACTIONS(2160),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2158),
    [anon_sym_DQUOTE] = ACTIONS(2158),
    [anon_sym_AT_DQUOTE] = ACTIONS(2160),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2160),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2160),
    [sym_bool] = ACTIONS(2158),
    [sym_unit] = ACTIONS(2160),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2158),
    [sym_op_identifier] = ACTIONS(2158),
    [anon_sym_PLUS] = ACTIONS(2158),
    [anon_sym_DASH] = ACTIONS(2158),
    [anon_sym_PLUS_DOT] = ACTIONS(2158),
    [anon_sym_DASH_DOT] = ACTIONS(2158),
    [anon_sym_PERCENT] = ACTIONS(2158),
    [anon_sym_AMP_AMP] = ACTIONS(2158),
    [anon_sym_TILDE] = ACTIONS(2160),
    [aux_sym_prefix_op_token1] = ACTIONS(2158),
    [aux_sym_infix_op_token1] = ACTIONS(2160),
    [aux_sym_infix_op_token2] = ACTIONS(2158),
    [anon_sym_PIPE_PIPE] = ACTIONS(2158),
    [anon_sym_BANG_EQ] = ACTIONS(2158),
    [anon_sym_COLON_EQ] = ACTIONS(2160),
    [anon_sym_DOLLAR] = ACTIONS(2158),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2158),
    [sym_int] = ACTIONS(2158),
    [sym_xint] = ACTIONS(2160),
    [anon_sym_y] = ACTIONS(2347),
    [anon_sym_uy] = ACTIONS(2349),
    [anon_sym_s] = ACTIONS(2351),
    [anon_sym_us] = ACTIONS(2353),
    [anon_sym_l] = ACTIONS(2355),
    [aux_sym_uint32_token1] = ACTIONS(2357),
    [anon_sym_n] = ACTIONS(2359),
    [anon_sym_un] = ACTIONS(2361),
    [anon_sym_L] = ACTIONS(2363),
    [aux_sym_uint64_token1] = ACTIONS(2365),
    [aux_sym_bignum_token1] = ACTIONS(2367),
    [aux_sym_decimal_token1] = ACTIONS(2369),
    [anon_sym_DOT2] = ACTIONS(2371),
    [aux_sym_float_token1] = ACTIONS(2373),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2160),
    [sym__newline] = ACTIONS(2160),
    [sym__dedent] = ACTIONS(2160),
  },
  [777] = {
    [sym_block_comment] = STATE(777),
    [sym_compiler_directive_decl] = STATE(777),
    [sym_fsi_directive_decl] = STATE(777),
    [sym_preproc_line] = STATE(777),
    [sym_identifier] = ACTIONS(2158),
    [anon_sym_EQ] = ACTIONS(2160),
    [anon_sym_COLON] = ACTIONS(2158),
    [anon_sym_return] = ACTIONS(2158),
    [anon_sym_do] = ACTIONS(2158),
    [anon_sym_let] = ACTIONS(2158),
    [anon_sym_let_BANG] = ACTIONS(2160),
    [anon_sym_LPAREN] = ACTIONS(2158),
    [anon_sym_COMMA] = ACTIONS(2160),
    [anon_sym_null] = ACTIONS(2158),
    [anon_sym_QMARK] = ACTIONS(2158),
    [anon_sym_COLON_QMARK] = ACTIONS(2158),
    [anon_sym_COLON_COLON] = ACTIONS(2160),
    [anon_sym_AMP] = ACTIONS(2158),
    [anon_sym_LBRACK] = ACTIONS(2158),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2160),
    [anon_sym_LBRACE] = ACTIONS(2158),
    [anon_sym_LT_AT] = ACTIONS(2158),
    [anon_sym_LT_AT_AT] = ACTIONS(2158),
    [anon_sym_DOT] = ACTIONS(2158),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2160),
    [anon_sym_new] = ACTIONS(2158),
    [anon_sym_return_BANG] = ACTIONS(2160),
    [anon_sym_yield] = ACTIONS(2158),
    [anon_sym_yield_BANG] = ACTIONS(2160),
    [anon_sym_lazy] = ACTIONS(2158),
    [anon_sym_assert] = ACTIONS(2158),
    [anon_sym_upcast] = ACTIONS(2158),
    [anon_sym_downcast] = ACTIONS(2158),
    [anon_sym_COLON_GT] = ACTIONS(2160),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2160),
    [anon_sym_for] = ACTIONS(2158),
    [anon_sym_while] = ACTIONS(2158),
    [anon_sym_if] = ACTIONS(2158),
    [anon_sym_fun] = ACTIONS(2158),
    [anon_sym_try] = ACTIONS(2158),
    [anon_sym_match] = ACTIONS(2158),
    [anon_sym_match_BANG] = ACTIONS(2160),
    [anon_sym_function] = ACTIONS(2158),
    [anon_sym_LT_DASH] = ACTIONS(2158),
    [anon_sym_DOT_LBRACK] = ACTIONS(2160),
    [anon_sym_LT] = ACTIONS(2160),
    [anon_sym_use] = ACTIONS(2158),
    [anon_sym_use_BANG] = ACTIONS(2160),
    [anon_sym_do_BANG] = ACTIONS(2160),
    [anon_sym_begin] = ACTIONS(2158),
    [anon_sym_LPAREN2] = ACTIONS(2158),
    [anon_sym_or] = ACTIONS(2158),
    [aux_sym_char_token1] = ACTIONS(2160),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2158),
    [anon_sym_DQUOTE] = ACTIONS(2158),
    [anon_sym_AT_DQUOTE] = ACTIONS(2160),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2160),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2160),
    [sym_bool] = ACTIONS(2158),
    [sym_unit] = ACTIONS(2160),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2158),
    [sym_op_identifier] = ACTIONS(2158),
    [anon_sym_PLUS] = ACTIONS(2158),
    [anon_sym_DASH] = ACTIONS(2158),
    [anon_sym_PLUS_DOT] = ACTIONS(2158),
    [anon_sym_DASH_DOT] = ACTIONS(2158),
    [anon_sym_PERCENT] = ACTIONS(2158),
    [anon_sym_AMP_AMP] = ACTIONS(2158),
    [anon_sym_TILDE] = ACTIONS(2160),
    [aux_sym_prefix_op_token1] = ACTIONS(2158),
    [aux_sym_infix_op_token1] = ACTIONS(2160),
    [aux_sym_infix_op_token2] = ACTIONS(2158),
    [anon_sym_PIPE_PIPE] = ACTIONS(2158),
    [anon_sym_BANG_EQ] = ACTIONS(2158),
    [anon_sym_COLON_EQ] = ACTIONS(2160),
    [anon_sym_DOLLAR] = ACTIONS(2158),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2158),
    [sym_int] = ACTIONS(2158),
    [sym_xint] = ACTIONS(2160),
    [anon_sym_y] = ACTIONS(2375),
    [anon_sym_uy] = ACTIONS(2377),
    [anon_sym_s] = ACTIONS(2379),
    [anon_sym_us] = ACTIONS(2381),
    [anon_sym_l] = ACTIONS(2383),
    [aux_sym_uint32_token1] = ACTIONS(2385),
    [anon_sym_n] = ACTIONS(2387),
    [anon_sym_un] = ACTIONS(2389),
    [anon_sym_L] = ACTIONS(2391),
    [aux_sym_uint64_token1] = ACTIONS(2393),
    [aux_sym_bignum_token1] = ACTIONS(2395),
    [aux_sym_decimal_token1] = ACTIONS(2397),
    [anon_sym_DOT2] = ACTIONS(2399),
    [aux_sym_float_token1] = ACTIONS(2401),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2160),
    [anon_sym_POUNDendif] = ACTIONS(2160),
    [anon_sym_POUNDelse] = ACTIONS(2160),
    [sym__newline] = ACTIONS(2160),
  },
  [778] = {
    [sym_block_comment] = STATE(778),
    [sym_compiler_directive_decl] = STATE(778),
    [sym_fsi_directive_decl] = STATE(778),
    [sym_preproc_line] = STATE(778),
    [sym_identifier] = ACTIONS(2158),
    [anon_sym_EQ] = ACTIONS(2160),
    [anon_sym_COLON] = ACTIONS(2158),
    [anon_sym_return] = ACTIONS(2158),
    [anon_sym_do] = ACTIONS(2158),
    [anon_sym_let] = ACTIONS(2158),
    [anon_sym_let_BANG] = ACTIONS(2160),
    [anon_sym_LPAREN] = ACTIONS(2158),
    [anon_sym_COMMA] = ACTIONS(2160),
    [anon_sym_null] = ACTIONS(2158),
    [anon_sym_QMARK] = ACTIONS(2158),
    [anon_sym_COLON_QMARK] = ACTIONS(2158),
    [anon_sym_COLON_COLON] = ACTIONS(2160),
    [anon_sym_AMP] = ACTIONS(2158),
    [anon_sym_LBRACK] = ACTIONS(2158),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2160),
    [anon_sym_LBRACE] = ACTIONS(2158),
    [anon_sym_LT_AT] = ACTIONS(2158),
    [anon_sym_LT_AT_AT] = ACTIONS(2158),
    [anon_sym_DOT] = ACTIONS(2158),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2160),
    [anon_sym_new] = ACTIONS(2158),
    [anon_sym_with] = ACTIONS(2158),
    [anon_sym_return_BANG] = ACTIONS(2160),
    [anon_sym_yield] = ACTIONS(2158),
    [anon_sym_yield_BANG] = ACTIONS(2160),
    [anon_sym_lazy] = ACTIONS(2158),
    [anon_sym_assert] = ACTIONS(2158),
    [anon_sym_upcast] = ACTIONS(2158),
    [anon_sym_downcast] = ACTIONS(2158),
    [anon_sym_COLON_GT] = ACTIONS(2160),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2160),
    [anon_sym_for] = ACTIONS(2158),
    [anon_sym_while] = ACTIONS(2158),
    [anon_sym_if] = ACTIONS(2158),
    [anon_sym_fun] = ACTIONS(2158),
    [anon_sym_try] = ACTIONS(2158),
    [anon_sym_match] = ACTIONS(2158),
    [anon_sym_match_BANG] = ACTIONS(2160),
    [anon_sym_function] = ACTIONS(2158),
    [anon_sym_LT_DASH] = ACTIONS(2158),
    [anon_sym_DOT_LBRACK] = ACTIONS(2160),
    [anon_sym_LT] = ACTIONS(2160),
    [anon_sym_use] = ACTIONS(2158),
    [anon_sym_use_BANG] = ACTIONS(2160),
    [anon_sym_do_BANG] = ACTIONS(2160),
    [anon_sym_begin] = ACTIONS(2158),
    [anon_sym_LPAREN2] = ACTIONS(2158),
    [anon_sym_or] = ACTIONS(2158),
    [aux_sym_char_token1] = ACTIONS(2160),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2158),
    [anon_sym_DQUOTE] = ACTIONS(2158),
    [anon_sym_AT_DQUOTE] = ACTIONS(2160),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2160),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2160),
    [sym_bool] = ACTIONS(2158),
    [sym_unit] = ACTIONS(2160),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2158),
    [sym_op_identifier] = ACTIONS(2158),
    [anon_sym_PLUS] = ACTIONS(2158),
    [anon_sym_DASH] = ACTIONS(2158),
    [anon_sym_PLUS_DOT] = ACTIONS(2158),
    [anon_sym_DASH_DOT] = ACTIONS(2158),
    [anon_sym_PERCENT] = ACTIONS(2158),
    [anon_sym_AMP_AMP] = ACTIONS(2158),
    [anon_sym_TILDE] = ACTIONS(2160),
    [aux_sym_prefix_op_token1] = ACTIONS(2158),
    [aux_sym_infix_op_token1] = ACTIONS(2160),
    [aux_sym_infix_op_token2] = ACTIONS(2158),
    [anon_sym_PIPE_PIPE] = ACTIONS(2158),
    [anon_sym_BANG_EQ] = ACTIONS(2158),
    [anon_sym_COLON_EQ] = ACTIONS(2160),
    [anon_sym_DOLLAR] = ACTIONS(2158),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2158),
    [sym_int] = ACTIONS(2158),
    [sym_xint] = ACTIONS(2160),
    [anon_sym_y] = ACTIONS(2162),
    [anon_sym_uy] = ACTIONS(2164),
    [anon_sym_s] = ACTIONS(2166),
    [anon_sym_us] = ACTIONS(2168),
    [anon_sym_l] = ACTIONS(2170),
    [aux_sym_uint32_token1] = ACTIONS(2172),
    [anon_sym_n] = ACTIONS(2174),
    [anon_sym_un] = ACTIONS(2176),
    [anon_sym_L] = ACTIONS(2178),
    [aux_sym_uint64_token1] = ACTIONS(2180),
    [aux_sym_bignum_token1] = ACTIONS(2182),
    [aux_sym_decimal_token1] = ACTIONS(2184),
    [anon_sym_DOT2] = ACTIONS(2403),
    [aux_sym_float_token1] = ACTIONS(2405),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2160),
    [sym__newline] = ACTIONS(2160),
    [sym__dedent] = ACTIONS(2160),
  },
  [779] = {
    [sym_block_comment] = STATE(779),
    [sym_compiler_directive_decl] = STATE(779),
    [sym_fsi_directive_decl] = STATE(779),
    [sym_preproc_line] = STATE(779),
    [aux_sym_compound_type_repeat1] = STATE(771),
    [sym_identifier] = ACTIONS(2407),
    [anon_sym_EQ] = ACTIONS(2409),
    [anon_sym_LBRACK_LT] = ACTIONS(2409),
    [anon_sym_COLON] = ACTIONS(2407),
    [anon_sym_return] = ACTIONS(2407),
    [anon_sym_do] = ACTIONS(2407),
    [anon_sym_let] = ACTIONS(2407),
    [anon_sym_let_BANG] = ACTIONS(2409),
    [aux_sym_access_modifier_token1] = ACTIONS(2409),
    [anon_sym_LPAREN] = ACTIONS(2407),
    [anon_sym_COMMA] = ACTIONS(2409),
    [anon_sym_null] = ACTIONS(2407),
    [anon_sym_QMARK] = ACTIONS(2407),
    [anon_sym_COLON_QMARK] = ACTIONS(2407),
    [anon_sym_COLON_COLON] = ACTIONS(2409),
    [anon_sym_AMP] = ACTIONS(2407),
    [anon_sym_LBRACK] = ACTIONS(2407),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2409),
    [anon_sym_LBRACE] = ACTIONS(2407),
    [anon_sym_LT_AT] = ACTIONS(2407),
    [anon_sym_LT_AT_AT] = ACTIONS(2407),
    [anon_sym_DOT] = ACTIONS(2407),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2409),
    [anon_sym_new] = ACTIONS(2407),
    [anon_sym_with] = ACTIONS(2407),
    [anon_sym_return_BANG] = ACTIONS(2409),
    [anon_sym_yield] = ACTIONS(2407),
    [anon_sym_yield_BANG] = ACTIONS(2409),
    [anon_sym_lazy] = ACTIONS(2407),
    [anon_sym_assert] = ACTIONS(2407),
    [anon_sym_upcast] = ACTIONS(2407),
    [anon_sym_downcast] = ACTIONS(2407),
    [anon_sym_COLON_GT] = ACTIONS(2409),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2409),
    [anon_sym_for] = ACTIONS(2407),
    [anon_sym_while] = ACTIONS(2407),
    [anon_sym_if] = ACTIONS(2407),
    [anon_sym_fun] = ACTIONS(2407),
    [anon_sym_DASH_GT] = ACTIONS(2407),
    [anon_sym_try] = ACTIONS(2407),
    [anon_sym_match] = ACTIONS(2407),
    [anon_sym_match_BANG] = ACTIONS(2409),
    [anon_sym_function] = ACTIONS(2407),
    [anon_sym_LT_DASH] = ACTIONS(2407),
    [anon_sym_DOT_LBRACK] = ACTIONS(2409),
    [anon_sym_LT] = ACTIONS(2409),
    [anon_sym_use] = ACTIONS(2407),
    [anon_sym_use_BANG] = ACTIONS(2409),
    [anon_sym_do_BANG] = ACTIONS(2409),
    [anon_sym_begin] = ACTIONS(2407),
    [anon_sym_LPAREN2] = ACTIONS(2407),
    [anon_sym_DOT_DOT2] = ACTIONS(2409),
    [anon_sym_STAR] = ACTIONS(2234),
    [anon_sym_LT2] = ACTIONS(2407),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2409),
    [anon_sym_default] = ACTIONS(2407),
    [anon_sym_or] = ACTIONS(2407),
    [anon_sym_static] = ACTIONS(2407),
    [anon_sym_member] = ACTIONS(2407),
    [anon_sym_abstract] = ACTIONS(2407),
    [anon_sym_val] = ACTIONS(2407),
    [anon_sym_override] = ACTIONS(2407),
    [aux_sym_char_token1] = ACTIONS(2409),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2407),
    [anon_sym_DQUOTE] = ACTIONS(2407),
    [anon_sym_AT_DQUOTE] = ACTIONS(2409),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2409),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2409),
    [sym_bool] = ACTIONS(2407),
    [sym_unit] = ACTIONS(2409),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2407),
    [sym_op_identifier] = ACTIONS(2407),
    [anon_sym_PLUS] = ACTIONS(2407),
    [anon_sym_DASH] = ACTIONS(2407),
    [anon_sym_PLUS_DOT] = ACTIONS(2407),
    [anon_sym_DASH_DOT] = ACTIONS(2407),
    [anon_sym_PERCENT] = ACTIONS(2407),
    [anon_sym_AMP_AMP] = ACTIONS(2407),
    [anon_sym_TILDE] = ACTIONS(2409),
    [aux_sym_prefix_op_token1] = ACTIONS(2407),
    [aux_sym_infix_op_token1] = ACTIONS(2409),
    [aux_sym_infix_op_token2] = ACTIONS(2407),
    [anon_sym_PIPE_PIPE] = ACTIONS(2407),
    [anon_sym_BANG_EQ] = ACTIONS(2407),
    [anon_sym_COLON_EQ] = ACTIONS(2409),
    [anon_sym_DOLLAR] = ACTIONS(2407),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2407),
    [sym_int] = ACTIONS(2407),
    [sym_xint] = ACTIONS(2409),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2409),
    [sym__newline] = ACTIONS(2409),
    [sym__dedent] = ACTIONS(2409),
  },
  [780] = {
    [sym_block_comment] = STATE(780),
    [sym_compiler_directive_decl] = STATE(780),
    [sym_fsi_directive_decl] = STATE(780),
    [sym_preproc_line] = STATE(780),
    [aux_sym_long_identifier_repeat1] = STATE(780),
    [sym_identifier] = ACTIONS(2411),
    [anon_sym_EQ] = ACTIONS(2413),
    [anon_sym_LBRACK_LT] = ACTIONS(2413),
    [anon_sym_COLON] = ACTIONS(2411),
    [anon_sym_return] = ACTIONS(2411),
    [anon_sym_do] = ACTIONS(2411),
    [anon_sym_let] = ACTIONS(2411),
    [anon_sym_let_BANG] = ACTIONS(2413),
    [aux_sym_access_modifier_token1] = ACTIONS(2413),
    [anon_sym_LPAREN] = ACTIONS(2411),
    [anon_sym_COMMA] = ACTIONS(2413),
    [anon_sym_null] = ACTIONS(2411),
    [anon_sym_QMARK] = ACTIONS(2411),
    [anon_sym_COLON_QMARK] = ACTIONS(2411),
    [anon_sym_COLON_COLON] = ACTIONS(2413),
    [anon_sym_AMP] = ACTIONS(2411),
    [anon_sym_LBRACK] = ACTIONS(2411),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2413),
    [anon_sym_LBRACE] = ACTIONS(2411),
    [anon_sym_LT_AT] = ACTIONS(2411),
    [anon_sym_LT_AT_AT] = ACTIONS(2411),
    [anon_sym_DOT] = ACTIONS(2415),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2413),
    [anon_sym_new] = ACTIONS(2411),
    [anon_sym_with] = ACTIONS(2411),
    [anon_sym_return_BANG] = ACTIONS(2413),
    [anon_sym_yield] = ACTIONS(2411),
    [anon_sym_yield_BANG] = ACTIONS(2413),
    [anon_sym_lazy] = ACTIONS(2411),
    [anon_sym_assert] = ACTIONS(2411),
    [anon_sym_upcast] = ACTIONS(2411),
    [anon_sym_downcast] = ACTIONS(2411),
    [anon_sym_COLON_GT] = ACTIONS(2413),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2413),
    [anon_sym_for] = ACTIONS(2411),
    [anon_sym_while] = ACTIONS(2411),
    [anon_sym_if] = ACTIONS(2411),
    [anon_sym_fun] = ACTIONS(2411),
    [anon_sym_DASH_GT] = ACTIONS(2411),
    [anon_sym_try] = ACTIONS(2411),
    [anon_sym_match] = ACTIONS(2411),
    [anon_sym_match_BANG] = ACTIONS(2413),
    [anon_sym_function] = ACTIONS(2411),
    [anon_sym_LT_DASH] = ACTIONS(2411),
    [anon_sym_DOT_LBRACK] = ACTIONS(2413),
    [anon_sym_LT] = ACTIONS(2413),
    [anon_sym_use] = ACTIONS(2411),
    [anon_sym_use_BANG] = ACTIONS(2413),
    [anon_sym_do_BANG] = ACTIONS(2413),
    [anon_sym_begin] = ACTIONS(2411),
    [anon_sym_LPAREN2] = ACTIONS(2411),
    [anon_sym_DOT_DOT2] = ACTIONS(2413),
    [anon_sym_STAR] = ACTIONS(2411),
    [anon_sym_LT2] = ACTIONS(2411),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2413),
    [anon_sym_default] = ACTIONS(2411),
    [anon_sym_or] = ACTIONS(2411),
    [anon_sym_static] = ACTIONS(2411),
    [anon_sym_member] = ACTIONS(2411),
    [anon_sym_abstract] = ACTIONS(2411),
    [anon_sym_val] = ACTIONS(2411),
    [anon_sym_override] = ACTIONS(2411),
    [aux_sym_char_token1] = ACTIONS(2413),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2411),
    [anon_sym_DQUOTE] = ACTIONS(2411),
    [anon_sym_AT_DQUOTE] = ACTIONS(2413),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2413),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2413),
    [sym_bool] = ACTIONS(2411),
    [sym_unit] = ACTIONS(2413),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2411),
    [sym_op_identifier] = ACTIONS(2411),
    [anon_sym_PLUS] = ACTIONS(2411),
    [anon_sym_DASH] = ACTIONS(2411),
    [anon_sym_PLUS_DOT] = ACTIONS(2411),
    [anon_sym_DASH_DOT] = ACTIONS(2411),
    [anon_sym_PERCENT] = ACTIONS(2411),
    [anon_sym_AMP_AMP] = ACTIONS(2411),
    [anon_sym_TILDE] = ACTIONS(2413),
    [aux_sym_prefix_op_token1] = ACTIONS(2411),
    [aux_sym_infix_op_token1] = ACTIONS(2413),
    [aux_sym_infix_op_token2] = ACTIONS(2411),
    [anon_sym_PIPE_PIPE] = ACTIONS(2411),
    [anon_sym_BANG_EQ] = ACTIONS(2411),
    [anon_sym_COLON_EQ] = ACTIONS(2413),
    [anon_sym_DOLLAR] = ACTIONS(2411),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2411),
    [sym_int] = ACTIONS(2411),
    [sym_xint] = ACTIONS(2413),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2413),
    [sym__newline] = ACTIONS(2413),
    [sym__dedent] = ACTIONS(2413),
  },
  [781] = {
    [sym_block_comment] = STATE(781),
    [sym_compiler_directive_decl] = STATE(781),
    [sym_fsi_directive_decl] = STATE(781),
    [sym_preproc_line] = STATE(781),
    [aux_sym_long_identifier_repeat1] = STATE(780),
    [sym_identifier] = ACTIONS(2418),
    [anon_sym_EQ] = ACTIONS(2420),
    [anon_sym_LBRACK_LT] = ACTIONS(2420),
    [anon_sym_COLON] = ACTIONS(2418),
    [anon_sym_return] = ACTIONS(2418),
    [anon_sym_do] = ACTIONS(2418),
    [anon_sym_let] = ACTIONS(2418),
    [anon_sym_let_BANG] = ACTIONS(2420),
    [aux_sym_access_modifier_token1] = ACTIONS(2420),
    [anon_sym_LPAREN] = ACTIONS(2418),
    [anon_sym_COMMA] = ACTIONS(2420),
    [anon_sym_null] = ACTIONS(2418),
    [anon_sym_QMARK] = ACTIONS(2418),
    [anon_sym_COLON_QMARK] = ACTIONS(2418),
    [anon_sym_COLON_COLON] = ACTIONS(2420),
    [anon_sym_AMP] = ACTIONS(2418),
    [anon_sym_LBRACK] = ACTIONS(2418),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2420),
    [anon_sym_LBRACE] = ACTIONS(2418),
    [anon_sym_LT_AT] = ACTIONS(2418),
    [anon_sym_LT_AT_AT] = ACTIONS(2418),
    [anon_sym_DOT] = ACTIONS(2316),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2420),
    [anon_sym_new] = ACTIONS(2418),
    [anon_sym_with] = ACTIONS(2418),
    [anon_sym_return_BANG] = ACTIONS(2420),
    [anon_sym_yield] = ACTIONS(2418),
    [anon_sym_yield_BANG] = ACTIONS(2420),
    [anon_sym_lazy] = ACTIONS(2418),
    [anon_sym_assert] = ACTIONS(2418),
    [anon_sym_upcast] = ACTIONS(2418),
    [anon_sym_downcast] = ACTIONS(2418),
    [anon_sym_COLON_GT] = ACTIONS(2420),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2420),
    [anon_sym_for] = ACTIONS(2418),
    [anon_sym_while] = ACTIONS(2418),
    [anon_sym_if] = ACTIONS(2418),
    [anon_sym_fun] = ACTIONS(2418),
    [anon_sym_DASH_GT] = ACTIONS(2418),
    [anon_sym_try] = ACTIONS(2418),
    [anon_sym_match] = ACTIONS(2418),
    [anon_sym_match_BANG] = ACTIONS(2420),
    [anon_sym_function] = ACTIONS(2418),
    [anon_sym_LT_DASH] = ACTIONS(2418),
    [anon_sym_DOT_LBRACK] = ACTIONS(2420),
    [anon_sym_LT] = ACTIONS(2420),
    [anon_sym_use] = ACTIONS(2418),
    [anon_sym_use_BANG] = ACTIONS(2420),
    [anon_sym_do_BANG] = ACTIONS(2420),
    [anon_sym_begin] = ACTIONS(2418),
    [anon_sym_LPAREN2] = ACTIONS(2418),
    [anon_sym_DOT_DOT2] = ACTIONS(2420),
    [anon_sym_STAR] = ACTIONS(2418),
    [anon_sym_LT2] = ACTIONS(2418),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2420),
    [anon_sym_default] = ACTIONS(2418),
    [anon_sym_or] = ACTIONS(2418),
    [anon_sym_static] = ACTIONS(2418),
    [anon_sym_member] = ACTIONS(2418),
    [anon_sym_abstract] = ACTIONS(2418),
    [anon_sym_val] = ACTIONS(2418),
    [anon_sym_override] = ACTIONS(2418),
    [aux_sym_char_token1] = ACTIONS(2420),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2418),
    [anon_sym_DQUOTE] = ACTIONS(2418),
    [anon_sym_AT_DQUOTE] = ACTIONS(2420),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2420),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2420),
    [sym_bool] = ACTIONS(2418),
    [sym_unit] = ACTIONS(2420),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2418),
    [sym_op_identifier] = ACTIONS(2418),
    [anon_sym_PLUS] = ACTIONS(2418),
    [anon_sym_DASH] = ACTIONS(2418),
    [anon_sym_PLUS_DOT] = ACTIONS(2418),
    [anon_sym_DASH_DOT] = ACTIONS(2418),
    [anon_sym_PERCENT] = ACTIONS(2418),
    [anon_sym_AMP_AMP] = ACTIONS(2418),
    [anon_sym_TILDE] = ACTIONS(2420),
    [aux_sym_prefix_op_token1] = ACTIONS(2418),
    [aux_sym_infix_op_token1] = ACTIONS(2420),
    [aux_sym_infix_op_token2] = ACTIONS(2418),
    [anon_sym_PIPE_PIPE] = ACTIONS(2418),
    [anon_sym_BANG_EQ] = ACTIONS(2418),
    [anon_sym_COLON_EQ] = ACTIONS(2420),
    [anon_sym_DOLLAR] = ACTIONS(2418),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2418),
    [sym_int] = ACTIONS(2418),
    [sym_xint] = ACTIONS(2420),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2420),
    [sym__newline] = ACTIONS(2420),
    [sym__dedent] = ACTIONS(2420),
  },
  [782] = {
    [sym_block_comment] = STATE(782),
    [sym_compiler_directive_decl] = STATE(782),
    [sym_fsi_directive_decl] = STATE(782),
    [sym_preproc_line] = STATE(782),
    [sym_identifier] = ACTIONS(2158),
    [anon_sym_EQ] = ACTIONS(2160),
    [anon_sym_COLON] = ACTIONS(2158),
    [anon_sym_return] = ACTIONS(2158),
    [anon_sym_do] = ACTIONS(2158),
    [anon_sym_let] = ACTIONS(2158),
    [anon_sym_let_BANG] = ACTIONS(2160),
    [anon_sym_LPAREN] = ACTIONS(2158),
    [anon_sym_COMMA] = ACTIONS(2160),
    [anon_sym_null] = ACTIONS(2158),
    [anon_sym_QMARK] = ACTIONS(2158),
    [anon_sym_COLON_QMARK] = ACTIONS(2158),
    [anon_sym_COLON_COLON] = ACTIONS(2160),
    [anon_sym_AMP] = ACTIONS(2158),
    [anon_sym_LBRACK] = ACTIONS(2158),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2160),
    [anon_sym_LBRACE] = ACTIONS(2158),
    [anon_sym_LT_AT] = ACTIONS(2158),
    [anon_sym_LT_AT_AT] = ACTIONS(2158),
    [anon_sym_DOT] = ACTIONS(2158),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2160),
    [anon_sym_new] = ACTIONS(2158),
    [anon_sym_return_BANG] = ACTIONS(2160),
    [anon_sym_yield] = ACTIONS(2158),
    [anon_sym_yield_BANG] = ACTIONS(2160),
    [anon_sym_lazy] = ACTIONS(2158),
    [anon_sym_assert] = ACTIONS(2158),
    [anon_sym_upcast] = ACTIONS(2158),
    [anon_sym_downcast] = ACTIONS(2158),
    [anon_sym_COLON_GT] = ACTIONS(2160),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2160),
    [anon_sym_for] = ACTIONS(2158),
    [anon_sym_while] = ACTIONS(2158),
    [anon_sym_if] = ACTIONS(2158),
    [anon_sym_fun] = ACTIONS(2158),
    [anon_sym_try] = ACTIONS(2158),
    [anon_sym_match] = ACTIONS(2158),
    [anon_sym_match_BANG] = ACTIONS(2160),
    [anon_sym_function] = ACTIONS(2158),
    [anon_sym_LT_DASH] = ACTIONS(2158),
    [anon_sym_DOT_LBRACK] = ACTIONS(2160),
    [anon_sym_LT] = ACTIONS(2160),
    [anon_sym_use] = ACTIONS(2158),
    [anon_sym_use_BANG] = ACTIONS(2160),
    [anon_sym_do_BANG] = ACTIONS(2160),
    [anon_sym_begin] = ACTIONS(2158),
    [anon_sym_LPAREN2] = ACTIONS(2158),
    [anon_sym_DOT_DOT2] = ACTIONS(2160),
    [anon_sym_or] = ACTIONS(2158),
    [aux_sym_char_token1] = ACTIONS(2160),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2158),
    [anon_sym_DQUOTE] = ACTIONS(2158),
    [anon_sym_AT_DQUOTE] = ACTIONS(2160),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2160),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2160),
    [sym_bool] = ACTIONS(2158),
    [sym_unit] = ACTIONS(2160),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2158),
    [sym_op_identifier] = ACTIONS(2158),
    [anon_sym_PLUS] = ACTIONS(2158),
    [anon_sym_DASH] = ACTIONS(2158),
    [anon_sym_PLUS_DOT] = ACTIONS(2158),
    [anon_sym_DASH_DOT] = ACTIONS(2158),
    [anon_sym_PERCENT] = ACTIONS(2158),
    [anon_sym_AMP_AMP] = ACTIONS(2158),
    [anon_sym_TILDE] = ACTIONS(2160),
    [aux_sym_prefix_op_token1] = ACTIONS(2158),
    [aux_sym_infix_op_token1] = ACTIONS(2160),
    [aux_sym_infix_op_token2] = ACTIONS(2158),
    [anon_sym_PIPE_PIPE] = ACTIONS(2158),
    [anon_sym_BANG_EQ] = ACTIONS(2158),
    [anon_sym_COLON_EQ] = ACTIONS(2160),
    [anon_sym_DOLLAR] = ACTIONS(2158),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2158),
    [sym_int] = ACTIONS(2158),
    [sym_xint] = ACTIONS(2160),
    [anon_sym_y] = ACTIONS(2162),
    [anon_sym_uy] = ACTIONS(2164),
    [anon_sym_s] = ACTIONS(2166),
    [anon_sym_us] = ACTIONS(2168),
    [anon_sym_l] = ACTIONS(2170),
    [aux_sym_uint32_token1] = ACTIONS(2172),
    [anon_sym_n] = ACTIONS(2174),
    [anon_sym_un] = ACTIONS(2176),
    [anon_sym_L] = ACTIONS(2178),
    [aux_sym_uint64_token1] = ACTIONS(2180),
    [aux_sym_bignum_token1] = ACTIONS(2182),
    [aux_sym_decimal_token1] = ACTIONS(2184),
    [anon_sym_DOT2] = ACTIONS(2403),
    [aux_sym_float_token1] = ACTIONS(2405),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2160),
    [sym__newline] = ACTIONS(2160),
    [sym__dedent] = ACTIONS(2160),
  },
  [783] = {
    [sym__else_expression] = STATE(946),
    [sym_elif_expression] = STATE(833),
    [sym_block_comment] = STATE(783),
    [sym_compiler_directive_decl] = STATE(783),
    [sym_fsi_directive_decl] = STATE(783),
    [sym_preproc_line] = STATE(783),
    [aux_sym_if_expression_repeat1] = STATE(774),
    [sym_identifier] = ACTIONS(2422),
    [anon_sym_EQ] = ACTIONS(2424),
    [anon_sym_LBRACK_LT] = ACTIONS(2424),
    [anon_sym_COLON] = ACTIONS(2422),
    [anon_sym_return] = ACTIONS(2422),
    [anon_sym_do] = ACTIONS(2422),
    [anon_sym_let] = ACTIONS(2422),
    [anon_sym_let_BANG] = ACTIONS(2424),
    [aux_sym_access_modifier_token1] = ACTIONS(2424),
    [anon_sym_LPAREN] = ACTIONS(2422),
    [anon_sym_COMMA] = ACTIONS(2424),
    [anon_sym_null] = ACTIONS(2422),
    [anon_sym_QMARK] = ACTIONS(2422),
    [anon_sym_COLON_QMARK] = ACTIONS(2422),
    [anon_sym_COLON_COLON] = ACTIONS(2424),
    [anon_sym_AMP] = ACTIONS(2422),
    [anon_sym_LBRACK] = ACTIONS(2422),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2424),
    [anon_sym_LBRACE] = ACTIONS(2422),
    [anon_sym_LT_AT] = ACTIONS(2422),
    [anon_sym_LT_AT_AT] = ACTIONS(2422),
    [anon_sym_DOT] = ACTIONS(2422),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2424),
    [anon_sym_new] = ACTIONS(2422),
    [anon_sym_with] = ACTIONS(2422),
    [anon_sym_return_BANG] = ACTIONS(2424),
    [anon_sym_yield] = ACTIONS(2422),
    [anon_sym_yield_BANG] = ACTIONS(2424),
    [anon_sym_lazy] = ACTIONS(2422),
    [anon_sym_assert] = ACTIONS(2422),
    [anon_sym_upcast] = ACTIONS(2422),
    [anon_sym_downcast] = ACTIONS(2422),
    [anon_sym_COLON_GT] = ACTIONS(2424),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2424),
    [anon_sym_for] = ACTIONS(2422),
    [anon_sym_while] = ACTIONS(2422),
    [anon_sym_else] = ACTIONS(2336),
    [anon_sym_elif] = ACTIONS(2338),
    [anon_sym_if] = ACTIONS(2422),
    [anon_sym_fun] = ACTIONS(2422),
    [anon_sym_try] = ACTIONS(2422),
    [anon_sym_match] = ACTIONS(2422),
    [anon_sym_match_BANG] = ACTIONS(2424),
    [anon_sym_function] = ACTIONS(2422),
    [anon_sym_LT_DASH] = ACTIONS(2422),
    [anon_sym_DOT_LBRACK] = ACTIONS(2424),
    [anon_sym_LT] = ACTIONS(2424),
    [anon_sym_use] = ACTIONS(2422),
    [anon_sym_use_BANG] = ACTIONS(2424),
    [anon_sym_do_BANG] = ACTIONS(2424),
    [anon_sym_begin] = ACTIONS(2422),
    [anon_sym_LPAREN2] = ACTIONS(2422),
    [anon_sym_DOT_DOT2] = ACTIONS(2424),
    [anon_sym_default] = ACTIONS(2422),
    [anon_sym_or] = ACTIONS(2422),
    [anon_sym_static] = ACTIONS(2422),
    [anon_sym_member] = ACTIONS(2422),
    [anon_sym_abstract] = ACTIONS(2422),
    [anon_sym_val] = ACTIONS(2422),
    [anon_sym_override] = ACTIONS(2422),
    [aux_sym_char_token1] = ACTIONS(2424),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2422),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_AT_DQUOTE] = ACTIONS(2424),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2424),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2424),
    [sym_bool] = ACTIONS(2422),
    [sym_unit] = ACTIONS(2424),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2422),
    [sym_op_identifier] = ACTIONS(2422),
    [anon_sym_PLUS] = ACTIONS(2422),
    [anon_sym_DASH] = ACTIONS(2422),
    [anon_sym_PLUS_DOT] = ACTIONS(2422),
    [anon_sym_DASH_DOT] = ACTIONS(2422),
    [anon_sym_PERCENT] = ACTIONS(2422),
    [anon_sym_AMP_AMP] = ACTIONS(2422),
    [anon_sym_TILDE] = ACTIONS(2424),
    [aux_sym_prefix_op_token1] = ACTIONS(2422),
    [aux_sym_infix_op_token1] = ACTIONS(2424),
    [aux_sym_infix_op_token2] = ACTIONS(2422),
    [anon_sym_PIPE_PIPE] = ACTIONS(2422),
    [anon_sym_BANG_EQ] = ACTIONS(2422),
    [anon_sym_COLON_EQ] = ACTIONS(2424),
    [anon_sym_DOLLAR] = ACTIONS(2422),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2422),
    [sym_int] = ACTIONS(2422),
    [sym_xint] = ACTIONS(2424),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2424),
    [sym__newline] = ACTIONS(2424),
    [sym__dedent] = ACTIONS(2424),
  },
  [784] = {
    [sym_block_comment] = STATE(784),
    [sym_compiler_directive_decl] = STATE(784),
    [sym_fsi_directive_decl] = STATE(784),
    [sym_preproc_line] = STATE(784),
    [sym_identifier] = ACTIONS(2158),
    [anon_sym_EQ] = ACTIONS(2160),
    [anon_sym_COLON] = ACTIONS(2158),
    [anon_sym_return] = ACTIONS(2158),
    [anon_sym_do] = ACTIONS(2158),
    [anon_sym_let] = ACTIONS(2158),
    [anon_sym_let_BANG] = ACTIONS(2160),
    [anon_sym_as] = ACTIONS(2158),
    [anon_sym_LPAREN] = ACTIONS(2158),
    [anon_sym_COMMA] = ACTIONS(2160),
    [anon_sym_null] = ACTIONS(2158),
    [anon_sym_QMARK] = ACTIONS(2158),
    [anon_sym_COLON_QMARK] = ACTIONS(2158),
    [anon_sym_COLON_COLON] = ACTIONS(2160),
    [anon_sym_AMP] = ACTIONS(2158),
    [anon_sym_LBRACK] = ACTIONS(2158),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2160),
    [anon_sym_LBRACE] = ACTIONS(2158),
    [anon_sym_LT_AT] = ACTIONS(2158),
    [anon_sym_LT_AT_AT] = ACTIONS(2158),
    [anon_sym_DOT] = ACTIONS(2158),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2160),
    [anon_sym_new] = ACTIONS(2158),
    [anon_sym_with] = ACTIONS(2158),
    [anon_sym_return_BANG] = ACTIONS(2160),
    [anon_sym_yield] = ACTIONS(2158),
    [anon_sym_yield_BANG] = ACTIONS(2160),
    [anon_sym_lazy] = ACTIONS(2158),
    [anon_sym_assert] = ACTIONS(2158),
    [anon_sym_upcast] = ACTIONS(2158),
    [anon_sym_downcast] = ACTIONS(2158),
    [anon_sym_COLON_GT] = ACTIONS(2160),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2160),
    [anon_sym_for] = ACTIONS(2158),
    [anon_sym_while] = ACTIONS(2158),
    [anon_sym_if] = ACTIONS(2158),
    [anon_sym_fun] = ACTIONS(2158),
    [anon_sym_try] = ACTIONS(2158),
    [anon_sym_match] = ACTIONS(2158),
    [anon_sym_match_BANG] = ACTIONS(2160),
    [anon_sym_function] = ACTIONS(2158),
    [anon_sym_LT_DASH] = ACTIONS(2158),
    [anon_sym_DOT_LBRACK] = ACTIONS(2160),
    [anon_sym_LT] = ACTIONS(2160),
    [anon_sym_use] = ACTIONS(2158),
    [anon_sym_use_BANG] = ACTIONS(2160),
    [anon_sym_do_BANG] = ACTIONS(2160),
    [anon_sym_begin] = ACTIONS(2158),
    [anon_sym_LPAREN2] = ACTIONS(2158),
    [anon_sym_or] = ACTIONS(2158),
    [aux_sym_char_token1] = ACTIONS(2160),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2158),
    [anon_sym_DQUOTE] = ACTIONS(2158),
    [anon_sym_AT_DQUOTE] = ACTIONS(2160),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2160),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2160),
    [sym_bool] = ACTIONS(2158),
    [sym_unit] = ACTIONS(2160),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2158),
    [sym_op_identifier] = ACTIONS(2158),
    [anon_sym_PLUS] = ACTIONS(2158),
    [anon_sym_DASH] = ACTIONS(2158),
    [anon_sym_PLUS_DOT] = ACTIONS(2158),
    [anon_sym_DASH_DOT] = ACTIONS(2158),
    [anon_sym_PERCENT] = ACTIONS(2158),
    [anon_sym_AMP_AMP] = ACTIONS(2158),
    [anon_sym_TILDE] = ACTIONS(2160),
    [aux_sym_prefix_op_token1] = ACTIONS(2158),
    [aux_sym_infix_op_token1] = ACTIONS(2160),
    [aux_sym_infix_op_token2] = ACTIONS(2158),
    [anon_sym_PIPE_PIPE] = ACTIONS(2158),
    [anon_sym_BANG_EQ] = ACTIONS(2158),
    [anon_sym_COLON_EQ] = ACTIONS(2160),
    [anon_sym_DOLLAR] = ACTIONS(2158),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2158),
    [sym_int] = ACTIONS(2158),
    [sym_xint] = ACTIONS(2160),
    [anon_sym_y] = ACTIONS(2426),
    [anon_sym_uy] = ACTIONS(2428),
    [anon_sym_s] = ACTIONS(2430),
    [anon_sym_us] = ACTIONS(2432),
    [anon_sym_l] = ACTIONS(2434),
    [aux_sym_uint32_token1] = ACTIONS(2436),
    [anon_sym_n] = ACTIONS(2438),
    [anon_sym_un] = ACTIONS(2440),
    [anon_sym_L] = ACTIONS(2442),
    [aux_sym_uint64_token1] = ACTIONS(2444),
    [aux_sym_bignum_token1] = ACTIONS(2446),
    [aux_sym_decimal_token1] = ACTIONS(2448),
    [anon_sym_DOT2] = ACTIONS(2450),
    [aux_sym_float_token1] = ACTIONS(2452),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2160),
    [sym__newline] = ACTIONS(2160),
  },
  [785] = {
    [sym_block_comment] = STATE(785),
    [sym_compiler_directive_decl] = STATE(785),
    [sym_fsi_directive_decl] = STATE(785),
    [sym_preproc_line] = STATE(785),
    [sym_identifier] = ACTIONS(2454),
    [anon_sym_EQ] = ACTIONS(2456),
    [anon_sym_LBRACK_LT] = ACTIONS(2456),
    [anon_sym_COLON] = ACTIONS(2454),
    [anon_sym_return] = ACTIONS(2454),
    [anon_sym_do] = ACTIONS(2454),
    [anon_sym_let] = ACTIONS(2454),
    [anon_sym_let_BANG] = ACTIONS(2456),
    [aux_sym_access_modifier_token1] = ACTIONS(2456),
    [anon_sym_LPAREN] = ACTIONS(2454),
    [anon_sym_COMMA] = ACTIONS(2456),
    [anon_sym_null] = ACTIONS(2454),
    [anon_sym_QMARK] = ACTIONS(2454),
    [anon_sym_COLON_QMARK] = ACTIONS(2454),
    [anon_sym_COLON_COLON] = ACTIONS(2456),
    [anon_sym_AMP] = ACTIONS(2454),
    [anon_sym_LBRACK] = ACTIONS(2454),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2456),
    [anon_sym_LBRACE] = ACTIONS(2454),
    [anon_sym_LT_AT] = ACTIONS(2454),
    [anon_sym_LT_AT_AT] = ACTIONS(2454),
    [anon_sym_DOT] = ACTIONS(2454),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2456),
    [anon_sym_new] = ACTIONS(2454),
    [anon_sym_with] = ACTIONS(2454),
    [anon_sym_return_BANG] = ACTIONS(2456),
    [anon_sym_yield] = ACTIONS(2454),
    [anon_sym_yield_BANG] = ACTIONS(2456),
    [anon_sym_lazy] = ACTIONS(2454),
    [anon_sym_assert] = ACTIONS(2454),
    [anon_sym_upcast] = ACTIONS(2454),
    [anon_sym_downcast] = ACTIONS(2454),
    [anon_sym_COLON_GT] = ACTIONS(2456),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2456),
    [anon_sym_for] = ACTIONS(2454),
    [anon_sym_while] = ACTIONS(2454),
    [anon_sym_if] = ACTIONS(2454),
    [anon_sym_fun] = ACTIONS(2454),
    [anon_sym_DASH_GT] = ACTIONS(2454),
    [anon_sym_try] = ACTIONS(2454),
    [anon_sym_match] = ACTIONS(2454),
    [anon_sym_match_BANG] = ACTIONS(2456),
    [anon_sym_function] = ACTIONS(2454),
    [anon_sym_LT_DASH] = ACTIONS(2454),
    [anon_sym_DOT_LBRACK] = ACTIONS(2456),
    [anon_sym_LT] = ACTIONS(2456),
    [anon_sym_use] = ACTIONS(2454),
    [anon_sym_use_BANG] = ACTIONS(2456),
    [anon_sym_do_BANG] = ACTIONS(2456),
    [anon_sym_begin] = ACTIONS(2454),
    [anon_sym_LPAREN2] = ACTIONS(2454),
    [anon_sym_DOT_DOT2] = ACTIONS(2456),
    [anon_sym_STAR] = ACTIONS(2454),
    [anon_sym_LT2] = ACTIONS(2454),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2456),
    [anon_sym_default] = ACTIONS(2454),
    [anon_sym_or] = ACTIONS(2454),
    [anon_sym_static] = ACTIONS(2454),
    [anon_sym_member] = ACTIONS(2454),
    [anon_sym_abstract] = ACTIONS(2454),
    [anon_sym_val] = ACTIONS(2454),
    [anon_sym_override] = ACTIONS(2454),
    [aux_sym_char_token1] = ACTIONS(2456),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2454),
    [anon_sym_DQUOTE] = ACTIONS(2454),
    [anon_sym_AT_DQUOTE] = ACTIONS(2456),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2456),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2456),
    [sym_bool] = ACTIONS(2454),
    [sym_unit] = ACTIONS(2456),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2454),
    [sym_op_identifier] = ACTIONS(2454),
    [anon_sym_PLUS] = ACTIONS(2454),
    [anon_sym_DASH] = ACTIONS(2454),
    [anon_sym_PLUS_DOT] = ACTIONS(2454),
    [anon_sym_DASH_DOT] = ACTIONS(2454),
    [anon_sym_PERCENT] = ACTIONS(2454),
    [anon_sym_AMP_AMP] = ACTIONS(2454),
    [anon_sym_TILDE] = ACTIONS(2456),
    [aux_sym_prefix_op_token1] = ACTIONS(2454),
    [aux_sym_infix_op_token1] = ACTIONS(2456),
    [aux_sym_infix_op_token2] = ACTIONS(2454),
    [anon_sym_PIPE_PIPE] = ACTIONS(2454),
    [anon_sym_BANG_EQ] = ACTIONS(2454),
    [anon_sym_COLON_EQ] = ACTIONS(2456),
    [anon_sym_DOLLAR] = ACTIONS(2454),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2454),
    [sym_int] = ACTIONS(2454),
    [sym_xint] = ACTIONS(2456),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2456),
    [sym__newline] = ACTIONS(2456),
    [sym__dedent] = ACTIONS(2456),
  },
  [786] = {
    [sym_block_comment] = STATE(786),
    [sym_compiler_directive_decl] = STATE(786),
    [sym_fsi_directive_decl] = STATE(786),
    [sym_preproc_line] = STATE(786),
    [sym_identifier] = ACTIONS(2158),
    [anon_sym_EQ] = ACTIONS(2160),
    [anon_sym_COLON] = ACTIONS(2158),
    [anon_sym_return] = ACTIONS(2158),
    [anon_sym_do] = ACTIONS(2158),
    [anon_sym_let] = ACTIONS(2158),
    [anon_sym_let_BANG] = ACTIONS(2160),
    [anon_sym_as] = ACTIONS(2158),
    [anon_sym_LPAREN] = ACTIONS(2158),
    [anon_sym_COMMA] = ACTIONS(2160),
    [anon_sym_null] = ACTIONS(2158),
    [anon_sym_QMARK] = ACTIONS(2158),
    [anon_sym_COLON_QMARK] = ACTIONS(2158),
    [anon_sym_COLON_COLON] = ACTIONS(2160),
    [anon_sym_AMP] = ACTIONS(2158),
    [anon_sym_LBRACK] = ACTIONS(2158),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2160),
    [anon_sym_LBRACE] = ACTIONS(2158),
    [anon_sym_LT_AT] = ACTIONS(2158),
    [anon_sym_LT_AT_AT] = ACTIONS(2158),
    [anon_sym_DOT] = ACTIONS(2158),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2160),
    [anon_sym_new] = ACTIONS(2158),
    [anon_sym_with] = ACTIONS(2158),
    [anon_sym_return_BANG] = ACTIONS(2160),
    [anon_sym_yield] = ACTIONS(2158),
    [anon_sym_yield_BANG] = ACTIONS(2160),
    [anon_sym_lazy] = ACTIONS(2158),
    [anon_sym_assert] = ACTIONS(2158),
    [anon_sym_upcast] = ACTIONS(2158),
    [anon_sym_downcast] = ACTIONS(2158),
    [anon_sym_COLON_GT] = ACTIONS(2160),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2160),
    [anon_sym_for] = ACTIONS(2158),
    [anon_sym_while] = ACTIONS(2158),
    [anon_sym_if] = ACTIONS(2158),
    [anon_sym_fun] = ACTIONS(2158),
    [anon_sym_try] = ACTIONS(2158),
    [anon_sym_match] = ACTIONS(2158),
    [anon_sym_match_BANG] = ACTIONS(2160),
    [anon_sym_function] = ACTIONS(2158),
    [anon_sym_LT_DASH] = ACTIONS(2158),
    [anon_sym_DOT_LBRACK] = ACTIONS(2160),
    [anon_sym_LT] = ACTIONS(2160),
    [anon_sym_use] = ACTIONS(2158),
    [anon_sym_use_BANG] = ACTIONS(2160),
    [anon_sym_do_BANG] = ACTIONS(2160),
    [anon_sym_begin] = ACTIONS(2158),
    [anon_sym_LPAREN2] = ACTIONS(2158),
    [anon_sym_or] = ACTIONS(2158),
    [aux_sym_char_token1] = ACTIONS(2160),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2158),
    [anon_sym_DQUOTE] = ACTIONS(2158),
    [anon_sym_AT_DQUOTE] = ACTIONS(2160),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2160),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2160),
    [sym_bool] = ACTIONS(2158),
    [sym_unit] = ACTIONS(2160),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2158),
    [sym_op_identifier] = ACTIONS(2158),
    [anon_sym_PLUS] = ACTIONS(2158),
    [anon_sym_DASH] = ACTIONS(2158),
    [anon_sym_PLUS_DOT] = ACTIONS(2158),
    [anon_sym_DASH_DOT] = ACTIONS(2158),
    [anon_sym_PERCENT] = ACTIONS(2158),
    [anon_sym_AMP_AMP] = ACTIONS(2158),
    [anon_sym_TILDE] = ACTIONS(2160),
    [aux_sym_prefix_op_token1] = ACTIONS(2158),
    [aux_sym_infix_op_token1] = ACTIONS(2160),
    [aux_sym_infix_op_token2] = ACTIONS(2158),
    [anon_sym_PIPE_PIPE] = ACTIONS(2158),
    [anon_sym_BANG_EQ] = ACTIONS(2158),
    [anon_sym_COLON_EQ] = ACTIONS(2160),
    [anon_sym_DOLLAR] = ACTIONS(2158),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2158),
    [sym_int] = ACTIONS(2158),
    [sym_xint] = ACTIONS(2160),
    [anon_sym_y] = ACTIONS(2256),
    [anon_sym_uy] = ACTIONS(2258),
    [anon_sym_s] = ACTIONS(2260),
    [anon_sym_us] = ACTIONS(2262),
    [anon_sym_l] = ACTIONS(2264),
    [aux_sym_uint32_token1] = ACTIONS(2266),
    [anon_sym_n] = ACTIONS(2268),
    [anon_sym_un] = ACTIONS(2270),
    [anon_sym_L] = ACTIONS(2272),
    [aux_sym_uint64_token1] = ACTIONS(2274),
    [anon_sym_lf] = ACTIONS(2458),
    [anon_sym_LF] = ACTIONS(2460),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2160),
    [sym__newline] = ACTIONS(2160),
    [sym__dedent] = ACTIONS(2160),
  },
  [787] = {
    [sym_block_comment] = STATE(787),
    [sym_compiler_directive_decl] = STATE(787),
    [sym_fsi_directive_decl] = STATE(787),
    [sym_preproc_line] = STATE(787),
    [sym_identifier] = ACTIONS(2462),
    [anon_sym_EQ] = ACTIONS(2464),
    [anon_sym_LBRACK_LT] = ACTIONS(2464),
    [anon_sym_COLON] = ACTIONS(2462),
    [anon_sym_return] = ACTIONS(2462),
    [anon_sym_do] = ACTIONS(2462),
    [anon_sym_let] = ACTIONS(2462),
    [anon_sym_let_BANG] = ACTIONS(2464),
    [aux_sym_access_modifier_token1] = ACTIONS(2464),
    [anon_sym_LPAREN] = ACTIONS(2462),
    [anon_sym_COMMA] = ACTIONS(2464),
    [anon_sym_null] = ACTIONS(2462),
    [anon_sym_QMARK] = ACTIONS(2462),
    [anon_sym_COLON_QMARK] = ACTIONS(2462),
    [anon_sym_COLON_COLON] = ACTIONS(2464),
    [anon_sym_AMP] = ACTIONS(2462),
    [anon_sym_LBRACK] = ACTIONS(2462),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2464),
    [anon_sym_LBRACE] = ACTIONS(2462),
    [anon_sym_LT_AT] = ACTIONS(2462),
    [anon_sym_LT_AT_AT] = ACTIONS(2462),
    [anon_sym_DOT] = ACTIONS(2462),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2464),
    [anon_sym_new] = ACTIONS(2462),
    [anon_sym_with] = ACTIONS(2462),
    [anon_sym_return_BANG] = ACTIONS(2464),
    [anon_sym_yield] = ACTIONS(2462),
    [anon_sym_yield_BANG] = ACTIONS(2464),
    [anon_sym_lazy] = ACTIONS(2462),
    [anon_sym_assert] = ACTIONS(2462),
    [anon_sym_upcast] = ACTIONS(2462),
    [anon_sym_downcast] = ACTIONS(2462),
    [anon_sym_COLON_GT] = ACTIONS(2464),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2464),
    [anon_sym_for] = ACTIONS(2462),
    [anon_sym_while] = ACTIONS(2462),
    [anon_sym_if] = ACTIONS(2462),
    [anon_sym_fun] = ACTIONS(2462),
    [anon_sym_DASH_GT] = ACTIONS(2462),
    [anon_sym_try] = ACTIONS(2462),
    [anon_sym_match] = ACTIONS(2462),
    [anon_sym_match_BANG] = ACTIONS(2464),
    [anon_sym_function] = ACTIONS(2462),
    [anon_sym_LT_DASH] = ACTIONS(2462),
    [anon_sym_DOT_LBRACK] = ACTIONS(2464),
    [anon_sym_LT] = ACTIONS(2464),
    [anon_sym_use] = ACTIONS(2462),
    [anon_sym_use_BANG] = ACTIONS(2464),
    [anon_sym_do_BANG] = ACTIONS(2464),
    [anon_sym_begin] = ACTIONS(2462),
    [anon_sym_LPAREN2] = ACTIONS(2462),
    [anon_sym_DOT_DOT2] = ACTIONS(2464),
    [anon_sym_STAR] = ACTIONS(2462),
    [anon_sym_LT2] = ACTIONS(2462),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2464),
    [anon_sym_default] = ACTIONS(2462),
    [anon_sym_or] = ACTIONS(2462),
    [anon_sym_static] = ACTIONS(2462),
    [anon_sym_member] = ACTIONS(2462),
    [anon_sym_abstract] = ACTIONS(2462),
    [anon_sym_val] = ACTIONS(2462),
    [anon_sym_override] = ACTIONS(2462),
    [aux_sym_char_token1] = ACTIONS(2464),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2462),
    [anon_sym_DQUOTE] = ACTIONS(2462),
    [anon_sym_AT_DQUOTE] = ACTIONS(2464),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2464),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2464),
    [sym_bool] = ACTIONS(2462),
    [sym_unit] = ACTIONS(2464),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2462),
    [sym_op_identifier] = ACTIONS(2462),
    [anon_sym_PLUS] = ACTIONS(2462),
    [anon_sym_DASH] = ACTIONS(2462),
    [anon_sym_PLUS_DOT] = ACTIONS(2462),
    [anon_sym_DASH_DOT] = ACTIONS(2462),
    [anon_sym_PERCENT] = ACTIONS(2462),
    [anon_sym_AMP_AMP] = ACTIONS(2462),
    [anon_sym_TILDE] = ACTIONS(2464),
    [aux_sym_prefix_op_token1] = ACTIONS(2462),
    [aux_sym_infix_op_token1] = ACTIONS(2464),
    [aux_sym_infix_op_token2] = ACTIONS(2462),
    [anon_sym_PIPE_PIPE] = ACTIONS(2462),
    [anon_sym_BANG_EQ] = ACTIONS(2462),
    [anon_sym_COLON_EQ] = ACTIONS(2464),
    [anon_sym_DOLLAR] = ACTIONS(2462),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2462),
    [sym_int] = ACTIONS(2462),
    [sym_xint] = ACTIONS(2464),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2464),
    [sym__newline] = ACTIONS(2464),
    [sym__dedent] = ACTIONS(2464),
  },
  [788] = {
    [sym_block_comment] = STATE(788),
    [sym_compiler_directive_decl] = STATE(788),
    [sym_fsi_directive_decl] = STATE(788),
    [sym_preproc_line] = STATE(788),
    [sym_identifier] = ACTIONS(2158),
    [anon_sym_EQ] = ACTIONS(2160),
    [anon_sym_COLON] = ACTIONS(2158),
    [anon_sym_return] = ACTIONS(2158),
    [anon_sym_do] = ACTIONS(2158),
    [anon_sym_let] = ACTIONS(2158),
    [anon_sym_let_BANG] = ACTIONS(2160),
    [anon_sym_LPAREN] = ACTIONS(2158),
    [anon_sym_COMMA] = ACTIONS(2160),
    [anon_sym_null] = ACTIONS(2158),
    [anon_sym_QMARK] = ACTIONS(2158),
    [anon_sym_COLON_QMARK] = ACTIONS(2158),
    [anon_sym_COLON_COLON] = ACTIONS(2160),
    [anon_sym_AMP] = ACTIONS(2158),
    [anon_sym_LBRACK] = ACTIONS(2158),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2160),
    [anon_sym_LBRACE] = ACTIONS(2158),
    [anon_sym_LT_AT] = ACTIONS(2158),
    [anon_sym_LT_AT_AT] = ACTIONS(2158),
    [anon_sym_DOT] = ACTIONS(2158),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2160),
    [anon_sym_new] = ACTIONS(2158),
    [anon_sym_return_BANG] = ACTIONS(2160),
    [anon_sym_yield] = ACTIONS(2158),
    [anon_sym_yield_BANG] = ACTIONS(2160),
    [anon_sym_lazy] = ACTIONS(2158),
    [anon_sym_assert] = ACTIONS(2158),
    [anon_sym_upcast] = ACTIONS(2158),
    [anon_sym_downcast] = ACTIONS(2158),
    [anon_sym_COLON_GT] = ACTIONS(2160),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2160),
    [anon_sym_for] = ACTIONS(2158),
    [anon_sym_while] = ACTIONS(2158),
    [anon_sym_if] = ACTIONS(2158),
    [anon_sym_fun] = ACTIONS(2158),
    [anon_sym_DASH_GT] = ACTIONS(2158),
    [anon_sym_try] = ACTIONS(2158),
    [anon_sym_match] = ACTIONS(2158),
    [anon_sym_match_BANG] = ACTIONS(2160),
    [anon_sym_function] = ACTIONS(2158),
    [anon_sym_LT_DASH] = ACTIONS(2158),
    [anon_sym_DOT_LBRACK] = ACTIONS(2160),
    [anon_sym_LT] = ACTIONS(2160),
    [anon_sym_use] = ACTIONS(2158),
    [anon_sym_use_BANG] = ACTIONS(2160),
    [anon_sym_do_BANG] = ACTIONS(2160),
    [anon_sym_begin] = ACTIONS(2158),
    [anon_sym_LPAREN2] = ACTIONS(2158),
    [anon_sym_or] = ACTIONS(2158),
    [aux_sym_char_token1] = ACTIONS(2160),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2158),
    [anon_sym_DQUOTE] = ACTIONS(2158),
    [anon_sym_AT_DQUOTE] = ACTIONS(2160),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2160),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2160),
    [sym_bool] = ACTIONS(2158),
    [sym_unit] = ACTIONS(2160),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2158),
    [sym_op_identifier] = ACTIONS(2158),
    [anon_sym_PLUS] = ACTIONS(2158),
    [anon_sym_DASH] = ACTIONS(2158),
    [anon_sym_PLUS_DOT] = ACTIONS(2158),
    [anon_sym_DASH_DOT] = ACTIONS(2158),
    [anon_sym_PERCENT] = ACTIONS(2158),
    [anon_sym_AMP_AMP] = ACTIONS(2158),
    [anon_sym_TILDE] = ACTIONS(2160),
    [aux_sym_prefix_op_token1] = ACTIONS(2158),
    [aux_sym_infix_op_token1] = ACTIONS(2160),
    [aux_sym_infix_op_token2] = ACTIONS(2158),
    [anon_sym_PIPE_PIPE] = ACTIONS(2158),
    [anon_sym_BANG_EQ] = ACTIONS(2158),
    [anon_sym_COLON_EQ] = ACTIONS(2160),
    [anon_sym_DOLLAR] = ACTIONS(2158),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2158),
    [sym_int] = ACTIONS(2158),
    [sym_xint] = ACTIONS(2160),
    [anon_sym_y] = ACTIONS(2284),
    [anon_sym_uy] = ACTIONS(2286),
    [anon_sym_s] = ACTIONS(2288),
    [anon_sym_us] = ACTIONS(2290),
    [anon_sym_l] = ACTIONS(2292),
    [aux_sym_uint32_token1] = ACTIONS(2294),
    [anon_sym_n] = ACTIONS(2296),
    [anon_sym_un] = ACTIONS(2298),
    [anon_sym_L] = ACTIONS(2300),
    [aux_sym_uint64_token1] = ACTIONS(2302),
    [aux_sym_bignum_token1] = ACTIONS(2304),
    [aux_sym_decimal_token1] = ACTIONS(2306),
    [anon_sym_DOT2] = ACTIONS(2308),
    [aux_sym_float_token1] = ACTIONS(2310),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2160),
    [sym__newline] = ACTIONS(2160),
  },
  [789] = {
    [sym_block_comment] = STATE(789),
    [sym_compiler_directive_decl] = STATE(789),
    [sym_fsi_directive_decl] = STATE(789),
    [sym_preproc_line] = STATE(789),
    [sym_identifier] = ACTIONS(2466),
    [anon_sym_EQ] = ACTIONS(2468),
    [anon_sym_LBRACK_LT] = ACTIONS(2468),
    [anon_sym_COLON] = ACTIONS(2466),
    [anon_sym_return] = ACTIONS(2466),
    [anon_sym_do] = ACTIONS(2466),
    [anon_sym_let] = ACTIONS(2466),
    [anon_sym_let_BANG] = ACTIONS(2468),
    [aux_sym_access_modifier_token1] = ACTIONS(2468),
    [anon_sym_LPAREN] = ACTIONS(2466),
    [anon_sym_COMMA] = ACTIONS(2468),
    [anon_sym_null] = ACTIONS(2466),
    [anon_sym_QMARK] = ACTIONS(2466),
    [anon_sym_COLON_QMARK] = ACTIONS(2466),
    [anon_sym_COLON_COLON] = ACTIONS(2468),
    [anon_sym_AMP] = ACTIONS(2466),
    [anon_sym_LBRACK] = ACTIONS(2466),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2468),
    [anon_sym_LBRACE] = ACTIONS(2466),
    [anon_sym_LT_AT] = ACTIONS(2466),
    [anon_sym_LT_AT_AT] = ACTIONS(2466),
    [anon_sym_DOT] = ACTIONS(2466),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2468),
    [anon_sym_new] = ACTIONS(2466),
    [anon_sym_with] = ACTIONS(2466),
    [anon_sym_return_BANG] = ACTIONS(2468),
    [anon_sym_yield] = ACTIONS(2466),
    [anon_sym_yield_BANG] = ACTIONS(2468),
    [anon_sym_lazy] = ACTIONS(2466),
    [anon_sym_assert] = ACTIONS(2466),
    [anon_sym_upcast] = ACTIONS(2466),
    [anon_sym_downcast] = ACTIONS(2466),
    [anon_sym_COLON_GT] = ACTIONS(2468),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2468),
    [anon_sym_for] = ACTIONS(2466),
    [anon_sym_while] = ACTIONS(2466),
    [anon_sym_if] = ACTIONS(2466),
    [anon_sym_fun] = ACTIONS(2466),
    [anon_sym_DASH_GT] = ACTIONS(2466),
    [anon_sym_try] = ACTIONS(2466),
    [anon_sym_match] = ACTIONS(2466),
    [anon_sym_match_BANG] = ACTIONS(2468),
    [anon_sym_function] = ACTIONS(2466),
    [anon_sym_LT_DASH] = ACTIONS(2466),
    [anon_sym_DOT_LBRACK] = ACTIONS(2468),
    [anon_sym_LT] = ACTIONS(2468),
    [anon_sym_use] = ACTIONS(2466),
    [anon_sym_use_BANG] = ACTIONS(2468),
    [anon_sym_do_BANG] = ACTIONS(2468),
    [anon_sym_begin] = ACTIONS(2466),
    [anon_sym_LPAREN2] = ACTIONS(2466),
    [anon_sym_DOT_DOT2] = ACTIONS(2468),
    [anon_sym_STAR] = ACTIONS(2466),
    [anon_sym_LT2] = ACTIONS(2466),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2468),
    [anon_sym_default] = ACTIONS(2466),
    [anon_sym_or] = ACTIONS(2466),
    [anon_sym_static] = ACTIONS(2466),
    [anon_sym_member] = ACTIONS(2466),
    [anon_sym_abstract] = ACTIONS(2466),
    [anon_sym_val] = ACTIONS(2466),
    [anon_sym_override] = ACTIONS(2466),
    [aux_sym_char_token1] = ACTIONS(2468),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2466),
    [anon_sym_DQUOTE] = ACTIONS(2466),
    [anon_sym_AT_DQUOTE] = ACTIONS(2468),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2468),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2468),
    [sym_bool] = ACTIONS(2466),
    [sym_unit] = ACTIONS(2468),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2466),
    [sym_op_identifier] = ACTIONS(2466),
    [anon_sym_PLUS] = ACTIONS(2466),
    [anon_sym_DASH] = ACTIONS(2466),
    [anon_sym_PLUS_DOT] = ACTIONS(2466),
    [anon_sym_DASH_DOT] = ACTIONS(2466),
    [anon_sym_PERCENT] = ACTIONS(2466),
    [anon_sym_AMP_AMP] = ACTIONS(2466),
    [anon_sym_TILDE] = ACTIONS(2468),
    [aux_sym_prefix_op_token1] = ACTIONS(2466),
    [aux_sym_infix_op_token1] = ACTIONS(2468),
    [aux_sym_infix_op_token2] = ACTIONS(2466),
    [anon_sym_PIPE_PIPE] = ACTIONS(2466),
    [anon_sym_BANG_EQ] = ACTIONS(2466),
    [anon_sym_COLON_EQ] = ACTIONS(2468),
    [anon_sym_DOLLAR] = ACTIONS(2466),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2466),
    [sym_int] = ACTIONS(2466),
    [sym_xint] = ACTIONS(2468),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2468),
    [sym__newline] = ACTIONS(2468),
    [sym__dedent] = ACTIONS(2468),
  },
  [790] = {
    [sym_block_comment] = STATE(790),
    [sym_compiler_directive_decl] = STATE(790),
    [sym_fsi_directive_decl] = STATE(790),
    [sym_preproc_line] = STATE(790),
    [sym_identifier] = ACTIONS(2411),
    [anon_sym_EQ] = ACTIONS(2413),
    [anon_sym_LBRACK_LT] = ACTIONS(2413),
    [anon_sym_COLON] = ACTIONS(2411),
    [anon_sym_return] = ACTIONS(2411),
    [anon_sym_do] = ACTIONS(2411),
    [anon_sym_let] = ACTIONS(2411),
    [anon_sym_let_BANG] = ACTIONS(2413),
    [aux_sym_access_modifier_token1] = ACTIONS(2413),
    [anon_sym_LPAREN] = ACTIONS(2411),
    [anon_sym_COMMA] = ACTIONS(2413),
    [anon_sym_null] = ACTIONS(2411),
    [anon_sym_QMARK] = ACTIONS(2411),
    [anon_sym_COLON_QMARK] = ACTIONS(2411),
    [anon_sym_COLON_COLON] = ACTIONS(2413),
    [anon_sym_AMP] = ACTIONS(2411),
    [anon_sym_LBRACK] = ACTIONS(2411),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2413),
    [anon_sym_LBRACE] = ACTIONS(2411),
    [anon_sym_LT_AT] = ACTIONS(2411),
    [anon_sym_LT_AT_AT] = ACTIONS(2411),
    [anon_sym_DOT] = ACTIONS(2411),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2413),
    [anon_sym_new] = ACTIONS(2411),
    [anon_sym_with] = ACTIONS(2411),
    [anon_sym_return_BANG] = ACTIONS(2413),
    [anon_sym_yield] = ACTIONS(2411),
    [anon_sym_yield_BANG] = ACTIONS(2413),
    [anon_sym_lazy] = ACTIONS(2411),
    [anon_sym_assert] = ACTIONS(2411),
    [anon_sym_upcast] = ACTIONS(2411),
    [anon_sym_downcast] = ACTIONS(2411),
    [anon_sym_COLON_GT] = ACTIONS(2413),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2413),
    [anon_sym_for] = ACTIONS(2411),
    [anon_sym_while] = ACTIONS(2411),
    [anon_sym_if] = ACTIONS(2411),
    [anon_sym_fun] = ACTIONS(2411),
    [anon_sym_DASH_GT] = ACTIONS(2411),
    [anon_sym_try] = ACTIONS(2411),
    [anon_sym_match] = ACTIONS(2411),
    [anon_sym_match_BANG] = ACTIONS(2413),
    [anon_sym_function] = ACTIONS(2411),
    [anon_sym_LT_DASH] = ACTIONS(2411),
    [anon_sym_DOT_LBRACK] = ACTIONS(2413),
    [anon_sym_LT] = ACTIONS(2413),
    [anon_sym_use] = ACTIONS(2411),
    [anon_sym_use_BANG] = ACTIONS(2413),
    [anon_sym_do_BANG] = ACTIONS(2413),
    [anon_sym_begin] = ACTIONS(2411),
    [anon_sym_LPAREN2] = ACTIONS(2411),
    [anon_sym_DOT_DOT2] = ACTIONS(2413),
    [anon_sym_STAR] = ACTIONS(2411),
    [anon_sym_LT2] = ACTIONS(2411),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2413),
    [anon_sym_default] = ACTIONS(2411),
    [anon_sym_or] = ACTIONS(2411),
    [anon_sym_static] = ACTIONS(2411),
    [anon_sym_member] = ACTIONS(2411),
    [anon_sym_abstract] = ACTIONS(2411),
    [anon_sym_val] = ACTIONS(2411),
    [anon_sym_override] = ACTIONS(2411),
    [aux_sym_char_token1] = ACTIONS(2413),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2411),
    [anon_sym_DQUOTE] = ACTIONS(2411),
    [anon_sym_AT_DQUOTE] = ACTIONS(2413),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2413),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2413),
    [sym_bool] = ACTIONS(2411),
    [sym_unit] = ACTIONS(2413),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2411),
    [sym_op_identifier] = ACTIONS(2411),
    [anon_sym_PLUS] = ACTIONS(2411),
    [anon_sym_DASH] = ACTIONS(2411),
    [anon_sym_PLUS_DOT] = ACTIONS(2411),
    [anon_sym_DASH_DOT] = ACTIONS(2411),
    [anon_sym_PERCENT] = ACTIONS(2411),
    [anon_sym_AMP_AMP] = ACTIONS(2411),
    [anon_sym_TILDE] = ACTIONS(2413),
    [aux_sym_prefix_op_token1] = ACTIONS(2411),
    [aux_sym_infix_op_token1] = ACTIONS(2413),
    [aux_sym_infix_op_token2] = ACTIONS(2411),
    [anon_sym_PIPE_PIPE] = ACTIONS(2411),
    [anon_sym_BANG_EQ] = ACTIONS(2411),
    [anon_sym_COLON_EQ] = ACTIONS(2413),
    [anon_sym_DOLLAR] = ACTIONS(2411),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2411),
    [sym_int] = ACTIONS(2411),
    [sym_xint] = ACTIONS(2413),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2413),
    [sym__newline] = ACTIONS(2413),
    [sym__dedent] = ACTIONS(2413),
  },
  [791] = {
    [sym_block_comment] = STATE(791),
    [sym_compiler_directive_decl] = STATE(791),
    [sym_fsi_directive_decl] = STATE(791),
    [sym_preproc_line] = STATE(791),
    [sym_identifier] = ACTIONS(2470),
    [anon_sym_EQ] = ACTIONS(2472),
    [anon_sym_LBRACK_LT] = ACTIONS(2472),
    [anon_sym_COLON] = ACTIONS(2470),
    [anon_sym_return] = ACTIONS(2470),
    [anon_sym_do] = ACTIONS(2470),
    [anon_sym_let] = ACTIONS(2470),
    [anon_sym_let_BANG] = ACTIONS(2472),
    [aux_sym_access_modifier_token1] = ACTIONS(2472),
    [anon_sym_LPAREN] = ACTIONS(2470),
    [anon_sym_COMMA] = ACTIONS(2472),
    [anon_sym_null] = ACTIONS(2470),
    [anon_sym_QMARK] = ACTIONS(2470),
    [anon_sym_COLON_QMARK] = ACTIONS(2470),
    [anon_sym_COLON_COLON] = ACTIONS(2472),
    [anon_sym_AMP] = ACTIONS(2470),
    [anon_sym_LBRACK] = ACTIONS(2470),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2472),
    [anon_sym_LBRACE] = ACTIONS(2470),
    [anon_sym_LT_AT] = ACTIONS(2470),
    [anon_sym_LT_AT_AT] = ACTIONS(2470),
    [anon_sym_DOT] = ACTIONS(2470),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2472),
    [anon_sym_new] = ACTIONS(2470),
    [anon_sym_with] = ACTIONS(2470),
    [anon_sym_return_BANG] = ACTIONS(2472),
    [anon_sym_yield] = ACTIONS(2470),
    [anon_sym_yield_BANG] = ACTIONS(2472),
    [anon_sym_lazy] = ACTIONS(2470),
    [anon_sym_assert] = ACTIONS(2470),
    [anon_sym_upcast] = ACTIONS(2470),
    [anon_sym_downcast] = ACTIONS(2470),
    [anon_sym_COLON_GT] = ACTIONS(2472),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2472),
    [anon_sym_for] = ACTIONS(2470),
    [anon_sym_while] = ACTIONS(2470),
    [anon_sym_if] = ACTIONS(2470),
    [anon_sym_fun] = ACTIONS(2470),
    [anon_sym_DASH_GT] = ACTIONS(2470),
    [anon_sym_try] = ACTIONS(2470),
    [anon_sym_match] = ACTIONS(2470),
    [anon_sym_match_BANG] = ACTIONS(2472),
    [anon_sym_function] = ACTIONS(2470),
    [anon_sym_LT_DASH] = ACTIONS(2470),
    [anon_sym_DOT_LBRACK] = ACTIONS(2472),
    [anon_sym_LT] = ACTIONS(2472),
    [anon_sym_use] = ACTIONS(2470),
    [anon_sym_use_BANG] = ACTIONS(2472),
    [anon_sym_do_BANG] = ACTIONS(2472),
    [anon_sym_begin] = ACTIONS(2470),
    [anon_sym_LPAREN2] = ACTIONS(2470),
    [anon_sym_DOT_DOT2] = ACTIONS(2472),
    [anon_sym_STAR] = ACTIONS(2470),
    [anon_sym_LT2] = ACTIONS(2470),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2472),
    [anon_sym_default] = ACTIONS(2470),
    [anon_sym_or] = ACTIONS(2470),
    [anon_sym_static] = ACTIONS(2470),
    [anon_sym_member] = ACTIONS(2470),
    [anon_sym_abstract] = ACTIONS(2470),
    [anon_sym_val] = ACTIONS(2470),
    [anon_sym_override] = ACTIONS(2470),
    [aux_sym_char_token1] = ACTIONS(2472),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2470),
    [anon_sym_DQUOTE] = ACTIONS(2470),
    [anon_sym_AT_DQUOTE] = ACTIONS(2472),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2472),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2472),
    [sym_bool] = ACTIONS(2470),
    [sym_unit] = ACTIONS(2472),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2470),
    [sym_op_identifier] = ACTIONS(2470),
    [anon_sym_PLUS] = ACTIONS(2470),
    [anon_sym_DASH] = ACTIONS(2470),
    [anon_sym_PLUS_DOT] = ACTIONS(2470),
    [anon_sym_DASH_DOT] = ACTIONS(2470),
    [anon_sym_PERCENT] = ACTIONS(2470),
    [anon_sym_AMP_AMP] = ACTIONS(2470),
    [anon_sym_TILDE] = ACTIONS(2472),
    [aux_sym_prefix_op_token1] = ACTIONS(2470),
    [aux_sym_infix_op_token1] = ACTIONS(2472),
    [aux_sym_infix_op_token2] = ACTIONS(2470),
    [anon_sym_PIPE_PIPE] = ACTIONS(2470),
    [anon_sym_BANG_EQ] = ACTIONS(2470),
    [anon_sym_COLON_EQ] = ACTIONS(2472),
    [anon_sym_DOLLAR] = ACTIONS(2470),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2470),
    [sym_int] = ACTIONS(2470),
    [sym_xint] = ACTIONS(2472),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2472),
    [sym__newline] = ACTIONS(2472),
    [sym__dedent] = ACTIONS(2472),
  },
  [792] = {
    [sym_block_comment] = STATE(792),
    [sym_compiler_directive_decl] = STATE(792),
    [sym_fsi_directive_decl] = STATE(792),
    [sym_preproc_line] = STATE(792),
    [sym_identifier] = ACTIONS(2474),
    [anon_sym_EQ] = ACTIONS(2476),
    [anon_sym_LBRACK_LT] = ACTIONS(2476),
    [anon_sym_COLON] = ACTIONS(2474),
    [anon_sym_return] = ACTIONS(2474),
    [anon_sym_do] = ACTIONS(2474),
    [anon_sym_let] = ACTIONS(2474),
    [anon_sym_let_BANG] = ACTIONS(2476),
    [aux_sym_access_modifier_token1] = ACTIONS(2476),
    [anon_sym_LPAREN] = ACTIONS(2474),
    [anon_sym_COMMA] = ACTIONS(2476),
    [anon_sym_null] = ACTIONS(2474),
    [anon_sym_QMARK] = ACTIONS(2474),
    [anon_sym_COLON_QMARK] = ACTIONS(2474),
    [anon_sym_COLON_COLON] = ACTIONS(2476),
    [anon_sym_AMP] = ACTIONS(2474),
    [anon_sym_LBRACK] = ACTIONS(2474),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2476),
    [anon_sym_LBRACE] = ACTIONS(2474),
    [anon_sym_LT_AT] = ACTIONS(2474),
    [anon_sym_LT_AT_AT] = ACTIONS(2474),
    [anon_sym_DOT] = ACTIONS(2474),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2476),
    [anon_sym_new] = ACTIONS(2474),
    [anon_sym_with] = ACTIONS(2474),
    [anon_sym_return_BANG] = ACTIONS(2476),
    [anon_sym_yield] = ACTIONS(2474),
    [anon_sym_yield_BANG] = ACTIONS(2476),
    [anon_sym_lazy] = ACTIONS(2474),
    [anon_sym_assert] = ACTIONS(2474),
    [anon_sym_upcast] = ACTIONS(2474),
    [anon_sym_downcast] = ACTIONS(2474),
    [anon_sym_COLON_GT] = ACTIONS(2476),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2476),
    [anon_sym_for] = ACTIONS(2474),
    [anon_sym_while] = ACTIONS(2474),
    [anon_sym_if] = ACTIONS(2474),
    [anon_sym_fun] = ACTIONS(2474),
    [anon_sym_DASH_GT] = ACTIONS(2474),
    [anon_sym_try] = ACTIONS(2474),
    [anon_sym_match] = ACTIONS(2474),
    [anon_sym_match_BANG] = ACTIONS(2476),
    [anon_sym_function] = ACTIONS(2474),
    [anon_sym_LT_DASH] = ACTIONS(2474),
    [anon_sym_DOT_LBRACK] = ACTIONS(2476),
    [anon_sym_LT] = ACTIONS(2476),
    [anon_sym_use] = ACTIONS(2474),
    [anon_sym_use_BANG] = ACTIONS(2476),
    [anon_sym_do_BANG] = ACTIONS(2476),
    [anon_sym_begin] = ACTIONS(2474),
    [anon_sym_LPAREN2] = ACTIONS(2474),
    [anon_sym_DOT_DOT2] = ACTIONS(2476),
    [anon_sym_STAR] = ACTIONS(2474),
    [anon_sym_LT2] = ACTIONS(2474),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2476),
    [anon_sym_default] = ACTIONS(2474),
    [anon_sym_or] = ACTIONS(2474),
    [anon_sym_static] = ACTIONS(2474),
    [anon_sym_member] = ACTIONS(2474),
    [anon_sym_abstract] = ACTIONS(2474),
    [anon_sym_val] = ACTIONS(2474),
    [anon_sym_override] = ACTIONS(2474),
    [aux_sym_char_token1] = ACTIONS(2476),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2474),
    [anon_sym_DQUOTE] = ACTIONS(2474),
    [anon_sym_AT_DQUOTE] = ACTIONS(2476),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2476),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2476),
    [sym_bool] = ACTIONS(2474),
    [sym_unit] = ACTIONS(2476),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2474),
    [sym_op_identifier] = ACTIONS(2474),
    [anon_sym_PLUS] = ACTIONS(2474),
    [anon_sym_DASH] = ACTIONS(2474),
    [anon_sym_PLUS_DOT] = ACTIONS(2474),
    [anon_sym_DASH_DOT] = ACTIONS(2474),
    [anon_sym_PERCENT] = ACTIONS(2474),
    [anon_sym_AMP_AMP] = ACTIONS(2474),
    [anon_sym_TILDE] = ACTIONS(2476),
    [aux_sym_prefix_op_token1] = ACTIONS(2474),
    [aux_sym_infix_op_token1] = ACTIONS(2476),
    [aux_sym_infix_op_token2] = ACTIONS(2474),
    [anon_sym_PIPE_PIPE] = ACTIONS(2474),
    [anon_sym_BANG_EQ] = ACTIONS(2474),
    [anon_sym_COLON_EQ] = ACTIONS(2476),
    [anon_sym_DOLLAR] = ACTIONS(2474),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2474),
    [sym_int] = ACTIONS(2474),
    [sym_xint] = ACTIONS(2476),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2476),
    [sym__newline] = ACTIONS(2476),
    [sym__dedent] = ACTIONS(2476),
  },
  [793] = {
    [sym_block_comment] = STATE(793),
    [sym_compiler_directive_decl] = STATE(793),
    [sym_fsi_directive_decl] = STATE(793),
    [sym_preproc_line] = STATE(793),
    [sym_identifier] = ACTIONS(2158),
    [anon_sym_EQ] = ACTIONS(2160),
    [anon_sym_COLON] = ACTIONS(2158),
    [anon_sym_return] = ACTIONS(2158),
    [anon_sym_do] = ACTIONS(2158),
    [anon_sym_let] = ACTIONS(2158),
    [anon_sym_let_BANG] = ACTIONS(2160),
    [anon_sym_LPAREN] = ACTIONS(2158),
    [anon_sym_COMMA] = ACTIONS(2160),
    [anon_sym_null] = ACTIONS(2158),
    [anon_sym_QMARK] = ACTIONS(2158),
    [anon_sym_COLON_QMARK] = ACTIONS(2158),
    [anon_sym_COLON_COLON] = ACTIONS(2160),
    [anon_sym_AMP] = ACTIONS(2158),
    [anon_sym_LBRACK] = ACTIONS(2158),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2160),
    [anon_sym_LBRACE] = ACTIONS(2158),
    [anon_sym_LT_AT] = ACTIONS(2158),
    [anon_sym_LT_AT_AT] = ACTIONS(2158),
    [anon_sym_DOT] = ACTIONS(2158),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2160),
    [anon_sym_new] = ACTIONS(2158),
    [anon_sym_return_BANG] = ACTIONS(2160),
    [anon_sym_yield] = ACTIONS(2158),
    [anon_sym_yield_BANG] = ACTIONS(2160),
    [anon_sym_lazy] = ACTIONS(2158),
    [anon_sym_assert] = ACTIONS(2158),
    [anon_sym_upcast] = ACTIONS(2158),
    [anon_sym_downcast] = ACTIONS(2158),
    [anon_sym_COLON_GT] = ACTIONS(2160),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2160),
    [anon_sym_for] = ACTIONS(2158),
    [anon_sym_while] = ACTIONS(2158),
    [anon_sym_if] = ACTIONS(2158),
    [anon_sym_fun] = ACTIONS(2158),
    [anon_sym_try] = ACTIONS(2158),
    [anon_sym_match] = ACTIONS(2158),
    [anon_sym_match_BANG] = ACTIONS(2160),
    [anon_sym_function] = ACTIONS(2158),
    [anon_sym_LT_DASH] = ACTIONS(2158),
    [anon_sym_DOT_LBRACK] = ACTIONS(2160),
    [anon_sym_LT] = ACTIONS(2160),
    [anon_sym_use] = ACTIONS(2158),
    [anon_sym_use_BANG] = ACTIONS(2160),
    [anon_sym_do_BANG] = ACTIONS(2160),
    [anon_sym_DOT_DOT] = ACTIONS(2160),
    [anon_sym_begin] = ACTIONS(2158),
    [anon_sym_LPAREN2] = ACTIONS(2158),
    [anon_sym_or] = ACTIONS(2158),
    [aux_sym_char_token1] = ACTIONS(2160),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2158),
    [anon_sym_DQUOTE] = ACTIONS(2158),
    [anon_sym_AT_DQUOTE] = ACTIONS(2160),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2160),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2160),
    [sym_bool] = ACTIONS(2158),
    [sym_unit] = ACTIONS(2160),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2158),
    [sym_op_identifier] = ACTIONS(2158),
    [anon_sym_PLUS] = ACTIONS(2158),
    [anon_sym_DASH] = ACTIONS(2158),
    [anon_sym_PLUS_DOT] = ACTIONS(2158),
    [anon_sym_DASH_DOT] = ACTIONS(2158),
    [anon_sym_PERCENT] = ACTIONS(2158),
    [anon_sym_AMP_AMP] = ACTIONS(2158),
    [anon_sym_TILDE] = ACTIONS(2160),
    [aux_sym_prefix_op_token1] = ACTIONS(2158),
    [aux_sym_infix_op_token1] = ACTIONS(2160),
    [aux_sym_infix_op_token2] = ACTIONS(2158),
    [anon_sym_PIPE_PIPE] = ACTIONS(2158),
    [anon_sym_BANG_EQ] = ACTIONS(2158),
    [anon_sym_COLON_EQ] = ACTIONS(2160),
    [anon_sym_DOLLAR] = ACTIONS(2158),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2158),
    [sym_int] = ACTIONS(2158),
    [sym_xint] = ACTIONS(2160),
    [anon_sym_y] = ACTIONS(2478),
    [anon_sym_uy] = ACTIONS(2480),
    [anon_sym_s] = ACTIONS(2482),
    [anon_sym_us] = ACTIONS(2484),
    [anon_sym_l] = ACTIONS(2486),
    [aux_sym_uint32_token1] = ACTIONS(2488),
    [anon_sym_n] = ACTIONS(2490),
    [anon_sym_un] = ACTIONS(2492),
    [anon_sym_L] = ACTIONS(2494),
    [aux_sym_uint64_token1] = ACTIONS(2496),
    [aux_sym_bignum_token1] = ACTIONS(2498),
    [aux_sym_decimal_token1] = ACTIONS(2500),
    [anon_sym_DOT2] = ACTIONS(2502),
    [aux_sym_float_token1] = ACTIONS(2504),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2160),
    [sym__newline] = ACTIONS(2160),
  },
  [794] = {
    [sym_block_comment] = STATE(794),
    [sym_compiler_directive_decl] = STATE(794),
    [sym_fsi_directive_decl] = STATE(794),
    [sym_preproc_line] = STATE(794),
    [sym_identifier] = ACTIONS(2321),
    [anon_sym_EQ] = ACTIONS(2323),
    [anon_sym_LBRACK_LT] = ACTIONS(2323),
    [anon_sym_COLON] = ACTIONS(2321),
    [anon_sym_return] = ACTIONS(2321),
    [anon_sym_do] = ACTIONS(2321),
    [anon_sym_let] = ACTIONS(2321),
    [anon_sym_let_BANG] = ACTIONS(2323),
    [aux_sym_access_modifier_token1] = ACTIONS(2323),
    [anon_sym_LPAREN] = ACTIONS(2321),
    [anon_sym_COMMA] = ACTIONS(2323),
    [anon_sym_null] = ACTIONS(2321),
    [anon_sym_QMARK] = ACTIONS(2321),
    [anon_sym_COLON_QMARK] = ACTIONS(2321),
    [anon_sym_COLON_COLON] = ACTIONS(2323),
    [anon_sym_AMP] = ACTIONS(2321),
    [anon_sym_LBRACK] = ACTIONS(2321),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2323),
    [anon_sym_LBRACE] = ACTIONS(2321),
    [anon_sym_LT_AT] = ACTIONS(2321),
    [anon_sym_LT_AT_AT] = ACTIONS(2321),
    [anon_sym_DOT] = ACTIONS(2321),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2323),
    [anon_sym_new] = ACTIONS(2321),
    [anon_sym_with] = ACTIONS(2321),
    [anon_sym_return_BANG] = ACTIONS(2323),
    [anon_sym_yield] = ACTIONS(2321),
    [anon_sym_yield_BANG] = ACTIONS(2323),
    [anon_sym_lazy] = ACTIONS(2321),
    [anon_sym_assert] = ACTIONS(2321),
    [anon_sym_upcast] = ACTIONS(2321),
    [anon_sym_downcast] = ACTIONS(2321),
    [anon_sym_COLON_GT] = ACTIONS(2323),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2323),
    [anon_sym_for] = ACTIONS(2321),
    [anon_sym_while] = ACTIONS(2321),
    [anon_sym_if] = ACTIONS(2321),
    [anon_sym_fun] = ACTIONS(2321),
    [anon_sym_DASH_GT] = ACTIONS(2321),
    [anon_sym_try] = ACTIONS(2321),
    [anon_sym_match] = ACTIONS(2321),
    [anon_sym_match_BANG] = ACTIONS(2323),
    [anon_sym_function] = ACTIONS(2321),
    [anon_sym_LT_DASH] = ACTIONS(2321),
    [anon_sym_DOT_LBRACK] = ACTIONS(2323),
    [anon_sym_LT] = ACTIONS(2323),
    [anon_sym_use] = ACTIONS(2321),
    [anon_sym_use_BANG] = ACTIONS(2323),
    [anon_sym_do_BANG] = ACTIONS(2323),
    [anon_sym_begin] = ACTIONS(2321),
    [anon_sym_LPAREN2] = ACTIONS(2321),
    [anon_sym_DOT_DOT2] = ACTIONS(2323),
    [anon_sym_STAR] = ACTIONS(2321),
    [anon_sym_LT2] = ACTIONS(2321),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2323),
    [anon_sym_default] = ACTIONS(2321),
    [anon_sym_or] = ACTIONS(2321),
    [anon_sym_static] = ACTIONS(2321),
    [anon_sym_member] = ACTIONS(2321),
    [anon_sym_abstract] = ACTIONS(2321),
    [anon_sym_val] = ACTIONS(2321),
    [anon_sym_override] = ACTIONS(2321),
    [aux_sym_char_token1] = ACTIONS(2323),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2321),
    [anon_sym_DQUOTE] = ACTIONS(2321),
    [anon_sym_AT_DQUOTE] = ACTIONS(2323),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2323),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2323),
    [sym_bool] = ACTIONS(2321),
    [sym_unit] = ACTIONS(2323),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2321),
    [sym_op_identifier] = ACTIONS(2321),
    [anon_sym_PLUS] = ACTIONS(2321),
    [anon_sym_DASH] = ACTIONS(2321),
    [anon_sym_PLUS_DOT] = ACTIONS(2321),
    [anon_sym_DASH_DOT] = ACTIONS(2321),
    [anon_sym_PERCENT] = ACTIONS(2321),
    [anon_sym_AMP_AMP] = ACTIONS(2321),
    [anon_sym_TILDE] = ACTIONS(2323),
    [aux_sym_prefix_op_token1] = ACTIONS(2321),
    [aux_sym_infix_op_token1] = ACTIONS(2323),
    [aux_sym_infix_op_token2] = ACTIONS(2321),
    [anon_sym_PIPE_PIPE] = ACTIONS(2321),
    [anon_sym_BANG_EQ] = ACTIONS(2321),
    [anon_sym_COLON_EQ] = ACTIONS(2323),
    [anon_sym_DOLLAR] = ACTIONS(2321),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2321),
    [sym_int] = ACTIONS(2321),
    [sym_xint] = ACTIONS(2323),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2323),
    [sym__newline] = ACTIONS(2323),
    [sym__dedent] = ACTIONS(2323),
  },
  [795] = {
    [sym_block_comment] = STATE(795),
    [sym_compiler_directive_decl] = STATE(795),
    [sym_fsi_directive_decl] = STATE(795),
    [sym_preproc_line] = STATE(795),
    [sym_identifier] = ACTIONS(2506),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_LBRACK_LT] = ACTIONS(2508),
    [anon_sym_COLON] = ACTIONS(2506),
    [anon_sym_return] = ACTIONS(2506),
    [anon_sym_do] = ACTIONS(2506),
    [anon_sym_let] = ACTIONS(2506),
    [anon_sym_let_BANG] = ACTIONS(2508),
    [aux_sym_access_modifier_token1] = ACTIONS(2508),
    [anon_sym_LPAREN] = ACTIONS(2506),
    [anon_sym_COMMA] = ACTIONS(2508),
    [anon_sym_null] = ACTIONS(2506),
    [anon_sym_QMARK] = ACTIONS(2506),
    [anon_sym_COLON_QMARK] = ACTIONS(2506),
    [anon_sym_COLON_COLON] = ACTIONS(2508),
    [anon_sym_AMP] = ACTIONS(2506),
    [anon_sym_LBRACK] = ACTIONS(2506),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2508),
    [anon_sym_LBRACE] = ACTIONS(2506),
    [anon_sym_LT_AT] = ACTIONS(2506),
    [anon_sym_LT_AT_AT] = ACTIONS(2506),
    [anon_sym_DOT] = ACTIONS(2506),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2508),
    [anon_sym_new] = ACTIONS(2506),
    [anon_sym_with] = ACTIONS(2506),
    [anon_sym_return_BANG] = ACTIONS(2508),
    [anon_sym_yield] = ACTIONS(2506),
    [anon_sym_yield_BANG] = ACTIONS(2508),
    [anon_sym_lazy] = ACTIONS(2506),
    [anon_sym_assert] = ACTIONS(2506),
    [anon_sym_upcast] = ACTIONS(2506),
    [anon_sym_downcast] = ACTIONS(2506),
    [anon_sym_COLON_GT] = ACTIONS(2508),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2508),
    [anon_sym_for] = ACTIONS(2506),
    [anon_sym_while] = ACTIONS(2506),
    [anon_sym_if] = ACTIONS(2506),
    [anon_sym_fun] = ACTIONS(2506),
    [anon_sym_DASH_GT] = ACTIONS(2506),
    [anon_sym_try] = ACTIONS(2506),
    [anon_sym_match] = ACTIONS(2506),
    [anon_sym_match_BANG] = ACTIONS(2508),
    [anon_sym_function] = ACTIONS(2506),
    [anon_sym_LT_DASH] = ACTIONS(2506),
    [anon_sym_DOT_LBRACK] = ACTIONS(2508),
    [anon_sym_LT] = ACTIONS(2508),
    [anon_sym_use] = ACTIONS(2506),
    [anon_sym_use_BANG] = ACTIONS(2508),
    [anon_sym_do_BANG] = ACTIONS(2508),
    [anon_sym_begin] = ACTIONS(2506),
    [anon_sym_LPAREN2] = ACTIONS(2506),
    [anon_sym_DOT_DOT2] = ACTIONS(2508),
    [anon_sym_STAR] = ACTIONS(2506),
    [anon_sym_LT2] = ACTIONS(2506),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2508),
    [anon_sym_default] = ACTIONS(2506),
    [anon_sym_or] = ACTIONS(2506),
    [anon_sym_static] = ACTIONS(2506),
    [anon_sym_member] = ACTIONS(2506),
    [anon_sym_abstract] = ACTIONS(2506),
    [anon_sym_val] = ACTIONS(2506),
    [anon_sym_override] = ACTIONS(2506),
    [aux_sym_char_token1] = ACTIONS(2508),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2506),
    [anon_sym_DQUOTE] = ACTIONS(2506),
    [anon_sym_AT_DQUOTE] = ACTIONS(2508),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2508),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2508),
    [sym_bool] = ACTIONS(2506),
    [sym_unit] = ACTIONS(2508),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2506),
    [sym_op_identifier] = ACTIONS(2506),
    [anon_sym_PLUS] = ACTIONS(2506),
    [anon_sym_DASH] = ACTIONS(2506),
    [anon_sym_PLUS_DOT] = ACTIONS(2506),
    [anon_sym_DASH_DOT] = ACTIONS(2506),
    [anon_sym_PERCENT] = ACTIONS(2506),
    [anon_sym_AMP_AMP] = ACTIONS(2506),
    [anon_sym_TILDE] = ACTIONS(2508),
    [aux_sym_prefix_op_token1] = ACTIONS(2506),
    [aux_sym_infix_op_token1] = ACTIONS(2508),
    [aux_sym_infix_op_token2] = ACTIONS(2506),
    [anon_sym_PIPE_PIPE] = ACTIONS(2506),
    [anon_sym_BANG_EQ] = ACTIONS(2506),
    [anon_sym_COLON_EQ] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(2506),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2506),
    [sym_int] = ACTIONS(2506),
    [sym_xint] = ACTIONS(2508),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2508),
    [sym__newline] = ACTIONS(2508),
    [sym__dedent] = ACTIONS(2508),
  },
  [796] = {
    [sym_block_comment] = STATE(796),
    [sym_compiler_directive_decl] = STATE(796),
    [sym_fsi_directive_decl] = STATE(796),
    [sym_preproc_line] = STATE(796),
    [sym_identifier] = ACTIONS(2158),
    [anon_sym_EQ] = ACTIONS(2160),
    [anon_sym_COLON] = ACTIONS(2158),
    [anon_sym_return] = ACTIONS(2158),
    [anon_sym_do] = ACTIONS(2158),
    [anon_sym_let] = ACTIONS(2158),
    [anon_sym_let_BANG] = ACTIONS(2160),
    [anon_sym_LPAREN] = ACTIONS(2158),
    [anon_sym_COMMA] = ACTIONS(2160),
    [anon_sym_null] = ACTIONS(2158),
    [anon_sym_QMARK] = ACTIONS(2158),
    [anon_sym_COLON_QMARK] = ACTIONS(2158),
    [anon_sym_COLON_COLON] = ACTIONS(2160),
    [anon_sym_AMP] = ACTIONS(2158),
    [anon_sym_LBRACK] = ACTIONS(2158),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2160),
    [anon_sym_LBRACE] = ACTIONS(2158),
    [anon_sym_LT_AT] = ACTIONS(2158),
    [anon_sym_LT_AT_AT] = ACTIONS(2158),
    [anon_sym_DOT] = ACTIONS(2158),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2160),
    [anon_sym_new] = ACTIONS(2158),
    [anon_sym_with] = ACTIONS(2158),
    [anon_sym_return_BANG] = ACTIONS(2160),
    [anon_sym_yield] = ACTIONS(2158),
    [anon_sym_yield_BANG] = ACTIONS(2160),
    [anon_sym_lazy] = ACTIONS(2158),
    [anon_sym_assert] = ACTIONS(2158),
    [anon_sym_upcast] = ACTIONS(2158),
    [anon_sym_downcast] = ACTIONS(2158),
    [anon_sym_COLON_GT] = ACTIONS(2160),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2160),
    [anon_sym_for] = ACTIONS(2158),
    [anon_sym_while] = ACTIONS(2158),
    [anon_sym_if] = ACTIONS(2158),
    [anon_sym_fun] = ACTIONS(2158),
    [anon_sym_try] = ACTIONS(2158),
    [anon_sym_match] = ACTIONS(2158),
    [anon_sym_match_BANG] = ACTIONS(2160),
    [anon_sym_function] = ACTIONS(2158),
    [anon_sym_LT_DASH] = ACTIONS(2158),
    [anon_sym_DOT_LBRACK] = ACTIONS(2160),
    [anon_sym_LT] = ACTIONS(2160),
    [anon_sym_use] = ACTIONS(2158),
    [anon_sym_use_BANG] = ACTIONS(2160),
    [anon_sym_do_BANG] = ACTIONS(2160),
    [anon_sym_begin] = ACTIONS(2158),
    [anon_sym_LPAREN2] = ACTIONS(2158),
    [anon_sym_DOT_DOT2] = ACTIONS(2160),
    [anon_sym_or] = ACTIONS(2158),
    [aux_sym_char_token1] = ACTIONS(2160),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2158),
    [anon_sym_DQUOTE] = ACTIONS(2158),
    [anon_sym_AT_DQUOTE] = ACTIONS(2160),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2160),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2160),
    [sym_bool] = ACTIONS(2158),
    [sym_unit] = ACTIONS(2160),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2158),
    [sym_op_identifier] = ACTIONS(2158),
    [anon_sym_PLUS] = ACTIONS(2158),
    [anon_sym_DASH] = ACTIONS(2158),
    [anon_sym_PLUS_DOT] = ACTIONS(2158),
    [anon_sym_DASH_DOT] = ACTIONS(2158),
    [anon_sym_PERCENT] = ACTIONS(2158),
    [anon_sym_AMP_AMP] = ACTIONS(2158),
    [anon_sym_TILDE] = ACTIONS(2160),
    [aux_sym_prefix_op_token1] = ACTIONS(2158),
    [aux_sym_infix_op_token1] = ACTIONS(2160),
    [aux_sym_infix_op_token2] = ACTIONS(2158),
    [anon_sym_PIPE_PIPE] = ACTIONS(2158),
    [anon_sym_BANG_EQ] = ACTIONS(2158),
    [anon_sym_COLON_EQ] = ACTIONS(2160),
    [anon_sym_DOLLAR] = ACTIONS(2158),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2158),
    [sym_int] = ACTIONS(2158),
    [sym_xint] = ACTIONS(2160),
    [anon_sym_y] = ACTIONS(2162),
    [anon_sym_uy] = ACTIONS(2164),
    [anon_sym_s] = ACTIONS(2166),
    [anon_sym_us] = ACTIONS(2168),
    [anon_sym_l] = ACTIONS(2170),
    [aux_sym_uint32_token1] = ACTIONS(2172),
    [anon_sym_n] = ACTIONS(2174),
    [anon_sym_un] = ACTIONS(2176),
    [anon_sym_L] = ACTIONS(2178),
    [aux_sym_uint64_token1] = ACTIONS(2180),
    [anon_sym_lf] = ACTIONS(2190),
    [anon_sym_LF] = ACTIONS(2192),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2160),
    [sym__newline] = ACTIONS(2160),
    [sym__dedent] = ACTIONS(2160),
  },
  [797] = {
    [sym_block_comment] = STATE(797),
    [sym_compiler_directive_decl] = STATE(797),
    [sym_fsi_directive_decl] = STATE(797),
    [sym_preproc_line] = STATE(797),
    [sym_identifier] = ACTIONS(2510),
    [anon_sym_EQ] = ACTIONS(2512),
    [anon_sym_LBRACK_LT] = ACTIONS(2512),
    [anon_sym_COLON] = ACTIONS(2510),
    [anon_sym_return] = ACTIONS(2510),
    [anon_sym_do] = ACTIONS(2510),
    [anon_sym_let] = ACTIONS(2510),
    [anon_sym_let_BANG] = ACTIONS(2512),
    [aux_sym_access_modifier_token1] = ACTIONS(2512),
    [anon_sym_LPAREN] = ACTIONS(2510),
    [anon_sym_COMMA] = ACTIONS(2512),
    [anon_sym_null] = ACTIONS(2510),
    [anon_sym_QMARK] = ACTIONS(2510),
    [anon_sym_COLON_QMARK] = ACTIONS(2510),
    [anon_sym_COLON_COLON] = ACTIONS(2512),
    [anon_sym_AMP] = ACTIONS(2510),
    [anon_sym_LBRACK] = ACTIONS(2510),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2512),
    [anon_sym_LBRACE] = ACTIONS(2510),
    [anon_sym_LT_AT] = ACTIONS(2510),
    [anon_sym_LT_AT_AT] = ACTIONS(2510),
    [anon_sym_DOT] = ACTIONS(2510),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2512),
    [anon_sym_new] = ACTIONS(2510),
    [anon_sym_with] = ACTIONS(2510),
    [anon_sym_return_BANG] = ACTIONS(2512),
    [anon_sym_yield] = ACTIONS(2510),
    [anon_sym_yield_BANG] = ACTIONS(2512),
    [anon_sym_lazy] = ACTIONS(2510),
    [anon_sym_assert] = ACTIONS(2510),
    [anon_sym_upcast] = ACTIONS(2510),
    [anon_sym_downcast] = ACTIONS(2510),
    [anon_sym_COLON_GT] = ACTIONS(2512),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2512),
    [anon_sym_for] = ACTIONS(2510),
    [anon_sym_while] = ACTIONS(2510),
    [anon_sym_if] = ACTIONS(2510),
    [anon_sym_fun] = ACTIONS(2510),
    [anon_sym_DASH_GT] = ACTIONS(2510),
    [anon_sym_try] = ACTIONS(2510),
    [anon_sym_match] = ACTIONS(2510),
    [anon_sym_match_BANG] = ACTIONS(2512),
    [anon_sym_function] = ACTIONS(2510),
    [anon_sym_LT_DASH] = ACTIONS(2510),
    [anon_sym_DOT_LBRACK] = ACTIONS(2512),
    [anon_sym_LT] = ACTIONS(2512),
    [anon_sym_use] = ACTIONS(2510),
    [anon_sym_use_BANG] = ACTIONS(2512),
    [anon_sym_do_BANG] = ACTIONS(2512),
    [anon_sym_begin] = ACTIONS(2510),
    [anon_sym_LPAREN2] = ACTIONS(2510),
    [anon_sym_DOT_DOT2] = ACTIONS(2512),
    [anon_sym_STAR] = ACTIONS(2510),
    [anon_sym_LT2] = ACTIONS(2510),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2512),
    [anon_sym_default] = ACTIONS(2510),
    [anon_sym_or] = ACTIONS(2510),
    [anon_sym_static] = ACTIONS(2510),
    [anon_sym_member] = ACTIONS(2510),
    [anon_sym_abstract] = ACTIONS(2510),
    [anon_sym_val] = ACTIONS(2510),
    [anon_sym_override] = ACTIONS(2510),
    [aux_sym_char_token1] = ACTIONS(2512),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2510),
    [anon_sym_DQUOTE] = ACTIONS(2510),
    [anon_sym_AT_DQUOTE] = ACTIONS(2512),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2512),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2512),
    [sym_bool] = ACTIONS(2510),
    [sym_unit] = ACTIONS(2512),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2510),
    [sym_op_identifier] = ACTIONS(2510),
    [anon_sym_PLUS] = ACTIONS(2510),
    [anon_sym_DASH] = ACTIONS(2510),
    [anon_sym_PLUS_DOT] = ACTIONS(2510),
    [anon_sym_DASH_DOT] = ACTIONS(2510),
    [anon_sym_PERCENT] = ACTIONS(2510),
    [anon_sym_AMP_AMP] = ACTIONS(2510),
    [anon_sym_TILDE] = ACTIONS(2512),
    [aux_sym_prefix_op_token1] = ACTIONS(2510),
    [aux_sym_infix_op_token1] = ACTIONS(2512),
    [aux_sym_infix_op_token2] = ACTIONS(2510),
    [anon_sym_PIPE_PIPE] = ACTIONS(2510),
    [anon_sym_BANG_EQ] = ACTIONS(2510),
    [anon_sym_COLON_EQ] = ACTIONS(2512),
    [anon_sym_DOLLAR] = ACTIONS(2510),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2510),
    [sym_int] = ACTIONS(2510),
    [sym_xint] = ACTIONS(2512),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2512),
    [sym__newline] = ACTIONS(2512),
    [sym__dedent] = ACTIONS(2512),
  },
  [798] = {
    [sym_block_comment] = STATE(798),
    [sym_compiler_directive_decl] = STATE(798),
    [sym_fsi_directive_decl] = STATE(798),
    [sym_preproc_line] = STATE(798),
    [sym_identifier] = ACTIONS(2514),
    [anon_sym_EQ] = ACTIONS(2516),
    [anon_sym_LBRACK_LT] = ACTIONS(2516),
    [anon_sym_COLON] = ACTIONS(2514),
    [anon_sym_return] = ACTIONS(2514),
    [anon_sym_do] = ACTIONS(2514),
    [anon_sym_let] = ACTIONS(2514),
    [anon_sym_let_BANG] = ACTIONS(2516),
    [aux_sym_access_modifier_token1] = ACTIONS(2516),
    [anon_sym_LPAREN] = ACTIONS(2514),
    [anon_sym_COMMA] = ACTIONS(2516),
    [anon_sym_null] = ACTIONS(2514),
    [anon_sym_QMARK] = ACTIONS(2514),
    [anon_sym_COLON_QMARK] = ACTIONS(2514),
    [anon_sym_COLON_COLON] = ACTIONS(2516),
    [anon_sym_AMP] = ACTIONS(2514),
    [anon_sym_LBRACK] = ACTIONS(2514),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2516),
    [anon_sym_LBRACE] = ACTIONS(2514),
    [anon_sym_LT_AT] = ACTIONS(2514),
    [anon_sym_LT_AT_AT] = ACTIONS(2514),
    [anon_sym_DOT] = ACTIONS(2514),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2516),
    [anon_sym_new] = ACTIONS(2514),
    [anon_sym_with] = ACTIONS(2514),
    [anon_sym_return_BANG] = ACTIONS(2516),
    [anon_sym_yield] = ACTIONS(2514),
    [anon_sym_yield_BANG] = ACTIONS(2516),
    [anon_sym_lazy] = ACTIONS(2514),
    [anon_sym_assert] = ACTIONS(2514),
    [anon_sym_upcast] = ACTIONS(2514),
    [anon_sym_downcast] = ACTIONS(2514),
    [anon_sym_COLON_GT] = ACTIONS(2516),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2516),
    [anon_sym_for] = ACTIONS(2514),
    [anon_sym_while] = ACTIONS(2514),
    [anon_sym_if] = ACTIONS(2514),
    [anon_sym_fun] = ACTIONS(2514),
    [anon_sym_DASH_GT] = ACTIONS(2514),
    [anon_sym_try] = ACTIONS(2514),
    [anon_sym_match] = ACTIONS(2514),
    [anon_sym_match_BANG] = ACTIONS(2516),
    [anon_sym_function] = ACTIONS(2514),
    [anon_sym_LT_DASH] = ACTIONS(2514),
    [anon_sym_DOT_LBRACK] = ACTIONS(2516),
    [anon_sym_LT] = ACTIONS(2516),
    [anon_sym_use] = ACTIONS(2514),
    [anon_sym_use_BANG] = ACTIONS(2516),
    [anon_sym_do_BANG] = ACTIONS(2516),
    [anon_sym_begin] = ACTIONS(2514),
    [anon_sym_LPAREN2] = ACTIONS(2514),
    [anon_sym_DOT_DOT2] = ACTIONS(2516),
    [anon_sym_STAR] = ACTIONS(2514),
    [anon_sym_LT2] = ACTIONS(2514),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2516),
    [anon_sym_default] = ACTIONS(2514),
    [anon_sym_or] = ACTIONS(2514),
    [anon_sym_static] = ACTIONS(2514),
    [anon_sym_member] = ACTIONS(2514),
    [anon_sym_abstract] = ACTIONS(2514),
    [anon_sym_val] = ACTIONS(2514),
    [anon_sym_override] = ACTIONS(2514),
    [aux_sym_char_token1] = ACTIONS(2516),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2514),
    [anon_sym_DQUOTE] = ACTIONS(2514),
    [anon_sym_AT_DQUOTE] = ACTIONS(2516),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2516),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2516),
    [sym_bool] = ACTIONS(2514),
    [sym_unit] = ACTIONS(2516),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2514),
    [sym_op_identifier] = ACTIONS(2514),
    [anon_sym_PLUS] = ACTIONS(2514),
    [anon_sym_DASH] = ACTIONS(2514),
    [anon_sym_PLUS_DOT] = ACTIONS(2514),
    [anon_sym_DASH_DOT] = ACTIONS(2514),
    [anon_sym_PERCENT] = ACTIONS(2514),
    [anon_sym_AMP_AMP] = ACTIONS(2514),
    [anon_sym_TILDE] = ACTIONS(2516),
    [aux_sym_prefix_op_token1] = ACTIONS(2514),
    [aux_sym_infix_op_token1] = ACTIONS(2516),
    [aux_sym_infix_op_token2] = ACTIONS(2514),
    [anon_sym_PIPE_PIPE] = ACTIONS(2514),
    [anon_sym_BANG_EQ] = ACTIONS(2514),
    [anon_sym_COLON_EQ] = ACTIONS(2516),
    [anon_sym_DOLLAR] = ACTIONS(2514),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2514),
    [sym_int] = ACTIONS(2514),
    [sym_xint] = ACTIONS(2516),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2516),
    [sym__newline] = ACTIONS(2516),
    [sym__dedent] = ACTIONS(2516),
  },
  [799] = {
    [sym_elif_expression] = STATE(833),
    [sym_block_comment] = STATE(799),
    [sym_compiler_directive_decl] = STATE(799),
    [sym_fsi_directive_decl] = STATE(799),
    [sym_preproc_line] = STATE(799),
    [aux_sym_if_expression_repeat1] = STATE(799),
    [sym_identifier] = ACTIONS(2518),
    [anon_sym_EQ] = ACTIONS(2520),
    [anon_sym_LBRACK_LT] = ACTIONS(2520),
    [anon_sym_COLON] = ACTIONS(2518),
    [anon_sym_return] = ACTIONS(2518),
    [anon_sym_do] = ACTIONS(2518),
    [anon_sym_let] = ACTIONS(2518),
    [anon_sym_let_BANG] = ACTIONS(2520),
    [aux_sym_access_modifier_token1] = ACTIONS(2520),
    [anon_sym_LPAREN] = ACTIONS(2518),
    [anon_sym_COMMA] = ACTIONS(2520),
    [anon_sym_null] = ACTIONS(2518),
    [anon_sym_QMARK] = ACTIONS(2518),
    [anon_sym_COLON_QMARK] = ACTIONS(2518),
    [anon_sym_COLON_COLON] = ACTIONS(2520),
    [anon_sym_AMP] = ACTIONS(2518),
    [anon_sym_LBRACK] = ACTIONS(2518),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2520),
    [anon_sym_LBRACE] = ACTIONS(2518),
    [anon_sym_LT_AT] = ACTIONS(2518),
    [anon_sym_LT_AT_AT] = ACTIONS(2518),
    [anon_sym_DOT] = ACTIONS(2518),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2520),
    [anon_sym_new] = ACTIONS(2518),
    [anon_sym_with] = ACTIONS(2518),
    [anon_sym_return_BANG] = ACTIONS(2520),
    [anon_sym_yield] = ACTIONS(2518),
    [anon_sym_yield_BANG] = ACTIONS(2520),
    [anon_sym_lazy] = ACTIONS(2518),
    [anon_sym_assert] = ACTIONS(2518),
    [anon_sym_upcast] = ACTIONS(2518),
    [anon_sym_downcast] = ACTIONS(2518),
    [anon_sym_COLON_GT] = ACTIONS(2520),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2520),
    [anon_sym_for] = ACTIONS(2518),
    [anon_sym_while] = ACTIONS(2518),
    [anon_sym_else] = ACTIONS(2518),
    [anon_sym_elif] = ACTIONS(2522),
    [anon_sym_if] = ACTIONS(2518),
    [anon_sym_fun] = ACTIONS(2518),
    [anon_sym_try] = ACTIONS(2518),
    [anon_sym_match] = ACTIONS(2518),
    [anon_sym_match_BANG] = ACTIONS(2520),
    [anon_sym_function] = ACTIONS(2518),
    [anon_sym_LT_DASH] = ACTIONS(2518),
    [anon_sym_DOT_LBRACK] = ACTIONS(2520),
    [anon_sym_LT] = ACTIONS(2520),
    [anon_sym_use] = ACTIONS(2518),
    [anon_sym_use_BANG] = ACTIONS(2520),
    [anon_sym_do_BANG] = ACTIONS(2520),
    [anon_sym_begin] = ACTIONS(2518),
    [anon_sym_LPAREN2] = ACTIONS(2518),
    [anon_sym_DOT_DOT2] = ACTIONS(2520),
    [anon_sym_default] = ACTIONS(2518),
    [anon_sym_or] = ACTIONS(2518),
    [anon_sym_static] = ACTIONS(2518),
    [anon_sym_member] = ACTIONS(2518),
    [anon_sym_abstract] = ACTIONS(2518),
    [anon_sym_val] = ACTIONS(2518),
    [anon_sym_override] = ACTIONS(2518),
    [aux_sym_char_token1] = ACTIONS(2520),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2518),
    [anon_sym_DQUOTE] = ACTIONS(2518),
    [anon_sym_AT_DQUOTE] = ACTIONS(2520),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2520),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2520),
    [sym_bool] = ACTIONS(2518),
    [sym_unit] = ACTIONS(2520),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2518),
    [sym_op_identifier] = ACTIONS(2518),
    [anon_sym_PLUS] = ACTIONS(2518),
    [anon_sym_DASH] = ACTIONS(2518),
    [anon_sym_PLUS_DOT] = ACTIONS(2518),
    [anon_sym_DASH_DOT] = ACTIONS(2518),
    [anon_sym_PERCENT] = ACTIONS(2518),
    [anon_sym_AMP_AMP] = ACTIONS(2518),
    [anon_sym_TILDE] = ACTIONS(2520),
    [aux_sym_prefix_op_token1] = ACTIONS(2518),
    [aux_sym_infix_op_token1] = ACTIONS(2520),
    [aux_sym_infix_op_token2] = ACTIONS(2518),
    [anon_sym_PIPE_PIPE] = ACTIONS(2518),
    [anon_sym_BANG_EQ] = ACTIONS(2518),
    [anon_sym_COLON_EQ] = ACTIONS(2520),
    [anon_sym_DOLLAR] = ACTIONS(2518),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2518),
    [sym_int] = ACTIONS(2518),
    [sym_xint] = ACTIONS(2520),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2520),
    [sym__newline] = ACTIONS(2520),
    [sym__dedent] = ACTIONS(2520),
  },
  [800] = {
    [sym_block_comment] = STATE(800),
    [sym_compiler_directive_decl] = STATE(800),
    [sym_fsi_directive_decl] = STATE(800),
    [sym_preproc_line] = STATE(800),
    [sym_identifier] = ACTIONS(2158),
    [anon_sym_EQ] = ACTIONS(2160),
    [anon_sym_COLON] = ACTIONS(2158),
    [anon_sym_return] = ACTIONS(2158),
    [anon_sym_do] = ACTIONS(2158),
    [anon_sym_let] = ACTIONS(2158),
    [anon_sym_let_BANG] = ACTIONS(2160),
    [anon_sym_LPAREN] = ACTIONS(2158),
    [anon_sym_COMMA] = ACTIONS(2160),
    [anon_sym_null] = ACTIONS(2158),
    [anon_sym_QMARK] = ACTIONS(2158),
    [anon_sym_COLON_QMARK] = ACTIONS(2158),
    [anon_sym_COLON_COLON] = ACTIONS(2160),
    [anon_sym_AMP] = ACTIONS(2158),
    [anon_sym_LBRACK] = ACTIONS(2158),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2160),
    [anon_sym_LBRACE] = ACTIONS(2158),
    [anon_sym_LT_AT] = ACTIONS(2158),
    [anon_sym_LT_AT_AT] = ACTIONS(2158),
    [anon_sym_AT_AT_GT] = ACTIONS(2158),
    [anon_sym_DOT] = ACTIONS(2158),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2160),
    [anon_sym_new] = ACTIONS(2158),
    [anon_sym_return_BANG] = ACTIONS(2160),
    [anon_sym_yield] = ACTIONS(2158),
    [anon_sym_yield_BANG] = ACTIONS(2160),
    [anon_sym_lazy] = ACTIONS(2158),
    [anon_sym_assert] = ACTIONS(2158),
    [anon_sym_upcast] = ACTIONS(2158),
    [anon_sym_downcast] = ACTIONS(2158),
    [anon_sym_COLON_GT] = ACTIONS(2160),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2160),
    [anon_sym_for] = ACTIONS(2158),
    [anon_sym_while] = ACTIONS(2158),
    [anon_sym_if] = ACTIONS(2158),
    [anon_sym_fun] = ACTIONS(2158),
    [anon_sym_try] = ACTIONS(2158),
    [anon_sym_match] = ACTIONS(2158),
    [anon_sym_match_BANG] = ACTIONS(2160),
    [anon_sym_function] = ACTIONS(2158),
    [anon_sym_LT_DASH] = ACTIONS(2158),
    [anon_sym_DOT_LBRACK] = ACTIONS(2160),
    [anon_sym_LT] = ACTIONS(2160),
    [anon_sym_use] = ACTIONS(2158),
    [anon_sym_use_BANG] = ACTIONS(2160),
    [anon_sym_do_BANG] = ACTIONS(2160),
    [anon_sym_begin] = ACTIONS(2158),
    [anon_sym_LPAREN2] = ACTIONS(2158),
    [anon_sym_or] = ACTIONS(2158),
    [aux_sym_char_token1] = ACTIONS(2160),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2158),
    [anon_sym_DQUOTE] = ACTIONS(2158),
    [anon_sym_AT_DQUOTE] = ACTIONS(2160),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2160),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2160),
    [sym_bool] = ACTIONS(2158),
    [sym_unit] = ACTIONS(2160),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2158),
    [sym_op_identifier] = ACTIONS(2158),
    [anon_sym_PLUS] = ACTIONS(2158),
    [anon_sym_DASH] = ACTIONS(2158),
    [anon_sym_PLUS_DOT] = ACTIONS(2158),
    [anon_sym_DASH_DOT] = ACTIONS(2158),
    [anon_sym_PERCENT] = ACTIONS(2158),
    [anon_sym_AMP_AMP] = ACTIONS(2158),
    [anon_sym_TILDE] = ACTIONS(2160),
    [aux_sym_prefix_op_token1] = ACTIONS(2158),
    [aux_sym_infix_op_token1] = ACTIONS(2160),
    [aux_sym_infix_op_token2] = ACTIONS(2158),
    [anon_sym_PIPE_PIPE] = ACTIONS(2158),
    [anon_sym_BANG_EQ] = ACTIONS(2158),
    [anon_sym_COLON_EQ] = ACTIONS(2160),
    [anon_sym_DOLLAR] = ACTIONS(2158),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2158),
    [sym_int] = ACTIONS(2158),
    [sym_xint] = ACTIONS(2160),
    [anon_sym_y] = ACTIONS(2525),
    [anon_sym_uy] = ACTIONS(2527),
    [anon_sym_s] = ACTIONS(2529),
    [anon_sym_us] = ACTIONS(2531),
    [anon_sym_l] = ACTIONS(2533),
    [aux_sym_uint32_token1] = ACTIONS(2535),
    [anon_sym_n] = ACTIONS(2537),
    [anon_sym_un] = ACTIONS(2539),
    [anon_sym_L] = ACTIONS(2541),
    [aux_sym_uint64_token1] = ACTIONS(2543),
    [aux_sym_bignum_token1] = ACTIONS(2545),
    [aux_sym_decimal_token1] = ACTIONS(2547),
    [anon_sym_DOT2] = ACTIONS(2549),
    [aux_sym_float_token1] = ACTIONS(2551),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2160),
    [sym__newline] = ACTIONS(2160),
  },
  [801] = {
    [sym_block_comment] = STATE(801),
    [sym_compiler_directive_decl] = STATE(801),
    [sym_fsi_directive_decl] = STATE(801),
    [sym_preproc_line] = STATE(801),
    [sym_identifier] = ACTIONS(2553),
    [anon_sym_EQ] = ACTIONS(2555),
    [anon_sym_LBRACK_LT] = ACTIONS(2555),
    [anon_sym_COLON] = ACTIONS(2553),
    [anon_sym_return] = ACTIONS(2553),
    [anon_sym_do] = ACTIONS(2553),
    [anon_sym_let] = ACTIONS(2553),
    [anon_sym_let_BANG] = ACTIONS(2555),
    [aux_sym_access_modifier_token1] = ACTIONS(2555),
    [anon_sym_LPAREN] = ACTIONS(2553),
    [anon_sym_COMMA] = ACTIONS(2555),
    [anon_sym_null] = ACTIONS(2553),
    [anon_sym_QMARK] = ACTIONS(2553),
    [anon_sym_COLON_QMARK] = ACTIONS(2553),
    [anon_sym_COLON_COLON] = ACTIONS(2555),
    [anon_sym_AMP] = ACTIONS(2553),
    [anon_sym_LBRACK] = ACTIONS(2553),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2555),
    [anon_sym_LBRACE] = ACTIONS(2553),
    [anon_sym_LT_AT] = ACTIONS(2553),
    [anon_sym_LT_AT_AT] = ACTIONS(2553),
    [anon_sym_DOT] = ACTIONS(2553),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2555),
    [anon_sym_new] = ACTIONS(2553),
    [anon_sym_with] = ACTIONS(2553),
    [anon_sym_return_BANG] = ACTIONS(2555),
    [anon_sym_yield] = ACTIONS(2553),
    [anon_sym_yield_BANG] = ACTIONS(2555),
    [anon_sym_lazy] = ACTIONS(2553),
    [anon_sym_assert] = ACTIONS(2553),
    [anon_sym_upcast] = ACTIONS(2553),
    [anon_sym_downcast] = ACTIONS(2553),
    [anon_sym_COLON_GT] = ACTIONS(2555),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2555),
    [anon_sym_for] = ACTIONS(2553),
    [anon_sym_while] = ACTIONS(2553),
    [anon_sym_if] = ACTIONS(2553),
    [anon_sym_fun] = ACTIONS(2553),
    [anon_sym_DASH_GT] = ACTIONS(2553),
    [anon_sym_try] = ACTIONS(2553),
    [anon_sym_match] = ACTIONS(2553),
    [anon_sym_match_BANG] = ACTIONS(2555),
    [anon_sym_function] = ACTIONS(2553),
    [anon_sym_LT_DASH] = ACTIONS(2553),
    [anon_sym_DOT_LBRACK] = ACTIONS(2555),
    [anon_sym_LT] = ACTIONS(2555),
    [anon_sym_use] = ACTIONS(2553),
    [anon_sym_use_BANG] = ACTIONS(2555),
    [anon_sym_do_BANG] = ACTIONS(2555),
    [anon_sym_begin] = ACTIONS(2553),
    [anon_sym_LPAREN2] = ACTIONS(2553),
    [anon_sym_DOT_DOT2] = ACTIONS(2555),
    [anon_sym_STAR] = ACTIONS(2553),
    [anon_sym_LT2] = ACTIONS(2553),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2555),
    [anon_sym_default] = ACTIONS(2553),
    [anon_sym_or] = ACTIONS(2553),
    [anon_sym_static] = ACTIONS(2553),
    [anon_sym_member] = ACTIONS(2553),
    [anon_sym_abstract] = ACTIONS(2553),
    [anon_sym_val] = ACTIONS(2553),
    [anon_sym_override] = ACTIONS(2553),
    [aux_sym_char_token1] = ACTIONS(2555),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2553),
    [anon_sym_DQUOTE] = ACTIONS(2553),
    [anon_sym_AT_DQUOTE] = ACTIONS(2555),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2555),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2555),
    [sym_bool] = ACTIONS(2553),
    [sym_unit] = ACTIONS(2555),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2553),
    [sym_op_identifier] = ACTIONS(2553),
    [anon_sym_PLUS] = ACTIONS(2553),
    [anon_sym_DASH] = ACTIONS(2553),
    [anon_sym_PLUS_DOT] = ACTIONS(2553),
    [anon_sym_DASH_DOT] = ACTIONS(2553),
    [anon_sym_PERCENT] = ACTIONS(2553),
    [anon_sym_AMP_AMP] = ACTIONS(2553),
    [anon_sym_TILDE] = ACTIONS(2555),
    [aux_sym_prefix_op_token1] = ACTIONS(2553),
    [aux_sym_infix_op_token1] = ACTIONS(2555),
    [aux_sym_infix_op_token2] = ACTIONS(2553),
    [anon_sym_PIPE_PIPE] = ACTIONS(2553),
    [anon_sym_BANG_EQ] = ACTIONS(2553),
    [anon_sym_COLON_EQ] = ACTIONS(2555),
    [anon_sym_DOLLAR] = ACTIONS(2553),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2553),
    [sym_int] = ACTIONS(2553),
    [sym_xint] = ACTIONS(2555),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2555),
    [sym__newline] = ACTIONS(2555),
    [sym__dedent] = ACTIONS(2555),
  },
  [802] = {
    [sym_block_comment] = STATE(802),
    [sym_compiler_directive_decl] = STATE(802),
    [sym_fsi_directive_decl] = STATE(802),
    [sym_preproc_line] = STATE(802),
    [sym_identifier] = ACTIONS(2557),
    [anon_sym_EQ] = ACTIONS(2559),
    [anon_sym_LBRACK_LT] = ACTIONS(2559),
    [anon_sym_COLON] = ACTIONS(2557),
    [anon_sym_return] = ACTIONS(2557),
    [anon_sym_do] = ACTIONS(2557),
    [anon_sym_let] = ACTIONS(2557),
    [anon_sym_let_BANG] = ACTIONS(2559),
    [aux_sym_access_modifier_token1] = ACTIONS(2559),
    [anon_sym_LPAREN] = ACTIONS(2557),
    [anon_sym_COMMA] = ACTIONS(2559),
    [anon_sym_null] = ACTIONS(2557),
    [anon_sym_QMARK] = ACTIONS(2557),
    [anon_sym_COLON_QMARK] = ACTIONS(2557),
    [anon_sym_COLON_COLON] = ACTIONS(2559),
    [anon_sym_AMP] = ACTIONS(2557),
    [anon_sym_LBRACK] = ACTIONS(2557),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2559),
    [anon_sym_LBRACE] = ACTIONS(2557),
    [anon_sym_LT_AT] = ACTIONS(2557),
    [anon_sym_LT_AT_AT] = ACTIONS(2557),
    [anon_sym_DOT] = ACTIONS(2557),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2559),
    [anon_sym_new] = ACTIONS(2557),
    [anon_sym_with] = ACTIONS(2557),
    [anon_sym_return_BANG] = ACTIONS(2559),
    [anon_sym_yield] = ACTIONS(2557),
    [anon_sym_yield_BANG] = ACTIONS(2559),
    [anon_sym_lazy] = ACTIONS(2557),
    [anon_sym_assert] = ACTIONS(2557),
    [anon_sym_upcast] = ACTIONS(2557),
    [anon_sym_downcast] = ACTIONS(2557),
    [anon_sym_COLON_GT] = ACTIONS(2559),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2559),
    [anon_sym_for] = ACTIONS(2557),
    [anon_sym_while] = ACTIONS(2557),
    [anon_sym_if] = ACTIONS(2557),
    [anon_sym_fun] = ACTIONS(2557),
    [anon_sym_DASH_GT] = ACTIONS(2557),
    [anon_sym_try] = ACTIONS(2557),
    [anon_sym_match] = ACTIONS(2557),
    [anon_sym_match_BANG] = ACTIONS(2559),
    [anon_sym_function] = ACTIONS(2557),
    [anon_sym_LT_DASH] = ACTIONS(2557),
    [anon_sym_DOT_LBRACK] = ACTIONS(2559),
    [anon_sym_LT] = ACTIONS(2559),
    [anon_sym_use] = ACTIONS(2557),
    [anon_sym_use_BANG] = ACTIONS(2559),
    [anon_sym_do_BANG] = ACTIONS(2559),
    [anon_sym_begin] = ACTIONS(2557),
    [anon_sym_LPAREN2] = ACTIONS(2557),
    [anon_sym_DOT_DOT2] = ACTIONS(2559),
    [anon_sym_STAR] = ACTIONS(2557),
    [anon_sym_LT2] = ACTIONS(2561),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2559),
    [anon_sym_default] = ACTIONS(2557),
    [anon_sym_or] = ACTIONS(2557),
    [anon_sym_static] = ACTIONS(2557),
    [anon_sym_member] = ACTIONS(2557),
    [anon_sym_abstract] = ACTIONS(2557),
    [anon_sym_val] = ACTIONS(2557),
    [anon_sym_override] = ACTIONS(2557),
    [aux_sym_char_token1] = ACTIONS(2559),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2557),
    [anon_sym_DQUOTE] = ACTIONS(2557),
    [anon_sym_AT_DQUOTE] = ACTIONS(2559),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2559),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2559),
    [sym_bool] = ACTIONS(2557),
    [sym_unit] = ACTIONS(2559),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2557),
    [sym_op_identifier] = ACTIONS(2557),
    [anon_sym_PLUS] = ACTIONS(2557),
    [anon_sym_DASH] = ACTIONS(2557),
    [anon_sym_PLUS_DOT] = ACTIONS(2557),
    [anon_sym_DASH_DOT] = ACTIONS(2557),
    [anon_sym_PERCENT] = ACTIONS(2557),
    [anon_sym_AMP_AMP] = ACTIONS(2557),
    [anon_sym_TILDE] = ACTIONS(2559),
    [aux_sym_prefix_op_token1] = ACTIONS(2557),
    [aux_sym_infix_op_token1] = ACTIONS(2559),
    [aux_sym_infix_op_token2] = ACTIONS(2557),
    [anon_sym_PIPE_PIPE] = ACTIONS(2557),
    [anon_sym_BANG_EQ] = ACTIONS(2557),
    [anon_sym_COLON_EQ] = ACTIONS(2559),
    [anon_sym_DOLLAR] = ACTIONS(2557),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2557),
    [sym_int] = ACTIONS(2557),
    [sym_xint] = ACTIONS(2559),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2559),
    [sym__newline] = ACTIONS(2559),
    [sym__dedent] = ACTIONS(2559),
  },
  [803] = {
    [sym_block_comment] = STATE(803),
    [sym_compiler_directive_decl] = STATE(803),
    [sym_fsi_directive_decl] = STATE(803),
    [sym_preproc_line] = STATE(803),
    [sym_identifier] = ACTIONS(2563),
    [anon_sym_EQ] = ACTIONS(2565),
    [anon_sym_LBRACK_LT] = ACTIONS(2565),
    [anon_sym_COLON] = ACTIONS(2563),
    [anon_sym_return] = ACTIONS(2563),
    [anon_sym_do] = ACTIONS(2563),
    [anon_sym_let] = ACTIONS(2563),
    [anon_sym_let_BANG] = ACTIONS(2565),
    [aux_sym_access_modifier_token1] = ACTIONS(2565),
    [anon_sym_LPAREN] = ACTIONS(2563),
    [anon_sym_COMMA] = ACTIONS(2565),
    [anon_sym_null] = ACTIONS(2563),
    [anon_sym_QMARK] = ACTIONS(2563),
    [anon_sym_COLON_QMARK] = ACTIONS(2563),
    [anon_sym_COLON_COLON] = ACTIONS(2565),
    [anon_sym_AMP] = ACTIONS(2563),
    [anon_sym_LBRACK] = ACTIONS(2563),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2565),
    [anon_sym_LBRACE] = ACTIONS(2563),
    [anon_sym_LT_AT] = ACTIONS(2563),
    [anon_sym_LT_AT_AT] = ACTIONS(2563),
    [anon_sym_DOT] = ACTIONS(2563),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2565),
    [anon_sym_new] = ACTIONS(2563),
    [anon_sym_with] = ACTIONS(2563),
    [anon_sym_return_BANG] = ACTIONS(2565),
    [anon_sym_yield] = ACTIONS(2563),
    [anon_sym_yield_BANG] = ACTIONS(2565),
    [anon_sym_lazy] = ACTIONS(2563),
    [anon_sym_assert] = ACTIONS(2563),
    [anon_sym_upcast] = ACTIONS(2563),
    [anon_sym_downcast] = ACTIONS(2563),
    [anon_sym_COLON_GT] = ACTIONS(2565),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2565),
    [anon_sym_for] = ACTIONS(2563),
    [anon_sym_while] = ACTIONS(2563),
    [anon_sym_if] = ACTIONS(2563),
    [anon_sym_fun] = ACTIONS(2563),
    [anon_sym_DASH_GT] = ACTIONS(2563),
    [anon_sym_try] = ACTIONS(2563),
    [anon_sym_match] = ACTIONS(2563),
    [anon_sym_match_BANG] = ACTIONS(2565),
    [anon_sym_function] = ACTIONS(2563),
    [anon_sym_LT_DASH] = ACTIONS(2563),
    [anon_sym_DOT_LBRACK] = ACTIONS(2565),
    [anon_sym_LT] = ACTIONS(2565),
    [anon_sym_use] = ACTIONS(2563),
    [anon_sym_use_BANG] = ACTIONS(2565),
    [anon_sym_do_BANG] = ACTIONS(2565),
    [anon_sym_begin] = ACTIONS(2563),
    [anon_sym_LPAREN2] = ACTIONS(2563),
    [anon_sym_DOT_DOT2] = ACTIONS(2565),
    [anon_sym_STAR] = ACTIONS(2563),
    [anon_sym_LT2] = ACTIONS(2563),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2565),
    [anon_sym_default] = ACTIONS(2563),
    [anon_sym_or] = ACTIONS(2563),
    [anon_sym_static] = ACTIONS(2563),
    [anon_sym_member] = ACTIONS(2563),
    [anon_sym_abstract] = ACTIONS(2563),
    [anon_sym_val] = ACTIONS(2563),
    [anon_sym_override] = ACTIONS(2563),
    [aux_sym_char_token1] = ACTIONS(2565),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2563),
    [anon_sym_DQUOTE] = ACTIONS(2563),
    [anon_sym_AT_DQUOTE] = ACTIONS(2565),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2565),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2565),
    [sym_bool] = ACTIONS(2563),
    [sym_unit] = ACTIONS(2565),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2563),
    [sym_op_identifier] = ACTIONS(2563),
    [anon_sym_PLUS] = ACTIONS(2563),
    [anon_sym_DASH] = ACTIONS(2563),
    [anon_sym_PLUS_DOT] = ACTIONS(2563),
    [anon_sym_DASH_DOT] = ACTIONS(2563),
    [anon_sym_PERCENT] = ACTIONS(2563),
    [anon_sym_AMP_AMP] = ACTIONS(2563),
    [anon_sym_TILDE] = ACTIONS(2565),
    [aux_sym_prefix_op_token1] = ACTIONS(2563),
    [aux_sym_infix_op_token1] = ACTIONS(2565),
    [aux_sym_infix_op_token2] = ACTIONS(2563),
    [anon_sym_PIPE_PIPE] = ACTIONS(2563),
    [anon_sym_BANG_EQ] = ACTIONS(2563),
    [anon_sym_COLON_EQ] = ACTIONS(2565),
    [anon_sym_DOLLAR] = ACTIONS(2563),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2563),
    [sym_int] = ACTIONS(2563),
    [sym_xint] = ACTIONS(2565),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2565),
    [sym__newline] = ACTIONS(2565),
    [sym__dedent] = ACTIONS(2565),
  },
  [804] = {
    [sym_block_comment] = STATE(804),
    [sym_compiler_directive_decl] = STATE(804),
    [sym_fsi_directive_decl] = STATE(804),
    [sym_preproc_line] = STATE(804),
    [sym_identifier] = ACTIONS(2567),
    [anon_sym_EQ] = ACTIONS(2569),
    [anon_sym_LBRACK_LT] = ACTIONS(2569),
    [anon_sym_COLON] = ACTIONS(2567),
    [anon_sym_return] = ACTIONS(2567),
    [anon_sym_do] = ACTIONS(2567),
    [anon_sym_let] = ACTIONS(2567),
    [anon_sym_let_BANG] = ACTIONS(2569),
    [aux_sym_access_modifier_token1] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2567),
    [anon_sym_COMMA] = ACTIONS(2569),
    [anon_sym_null] = ACTIONS(2567),
    [anon_sym_QMARK] = ACTIONS(2567),
    [anon_sym_COLON_QMARK] = ACTIONS(2567),
    [anon_sym_COLON_COLON] = ACTIONS(2569),
    [anon_sym_AMP] = ACTIONS(2567),
    [anon_sym_LBRACK] = ACTIONS(2567),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2569),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_LT_AT] = ACTIONS(2567),
    [anon_sym_LT_AT_AT] = ACTIONS(2567),
    [anon_sym_DOT] = ACTIONS(2567),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2569),
    [anon_sym_new] = ACTIONS(2567),
    [anon_sym_with] = ACTIONS(2567),
    [anon_sym_return_BANG] = ACTIONS(2569),
    [anon_sym_yield] = ACTIONS(2567),
    [anon_sym_yield_BANG] = ACTIONS(2569),
    [anon_sym_lazy] = ACTIONS(2567),
    [anon_sym_assert] = ACTIONS(2567),
    [anon_sym_upcast] = ACTIONS(2567),
    [anon_sym_downcast] = ACTIONS(2567),
    [anon_sym_COLON_GT] = ACTIONS(2569),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2569),
    [anon_sym_for] = ACTIONS(2567),
    [anon_sym_while] = ACTIONS(2567),
    [anon_sym_if] = ACTIONS(2567),
    [anon_sym_fun] = ACTIONS(2567),
    [anon_sym_DASH_GT] = ACTIONS(2567),
    [anon_sym_try] = ACTIONS(2567),
    [anon_sym_match] = ACTIONS(2567),
    [anon_sym_match_BANG] = ACTIONS(2569),
    [anon_sym_function] = ACTIONS(2567),
    [anon_sym_LT_DASH] = ACTIONS(2567),
    [anon_sym_DOT_LBRACK] = ACTIONS(2569),
    [anon_sym_LT] = ACTIONS(2569),
    [anon_sym_use] = ACTIONS(2567),
    [anon_sym_use_BANG] = ACTIONS(2569),
    [anon_sym_do_BANG] = ACTIONS(2569),
    [anon_sym_begin] = ACTIONS(2567),
    [anon_sym_LPAREN2] = ACTIONS(2567),
    [anon_sym_DOT_DOT2] = ACTIONS(2569),
    [anon_sym_STAR] = ACTIONS(2567),
    [anon_sym_LT2] = ACTIONS(2567),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2569),
    [anon_sym_default] = ACTIONS(2567),
    [anon_sym_or] = ACTIONS(2567),
    [anon_sym_static] = ACTIONS(2567),
    [anon_sym_member] = ACTIONS(2567),
    [anon_sym_abstract] = ACTIONS(2567),
    [anon_sym_val] = ACTIONS(2567),
    [anon_sym_override] = ACTIONS(2567),
    [aux_sym_char_token1] = ACTIONS(2569),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2567),
    [anon_sym_DQUOTE] = ACTIONS(2567),
    [anon_sym_AT_DQUOTE] = ACTIONS(2569),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2569),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2569),
    [sym_bool] = ACTIONS(2567),
    [sym_unit] = ACTIONS(2569),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2567),
    [sym_op_identifier] = ACTIONS(2567),
    [anon_sym_PLUS] = ACTIONS(2567),
    [anon_sym_DASH] = ACTIONS(2567),
    [anon_sym_PLUS_DOT] = ACTIONS(2567),
    [anon_sym_DASH_DOT] = ACTIONS(2567),
    [anon_sym_PERCENT] = ACTIONS(2567),
    [anon_sym_AMP_AMP] = ACTIONS(2567),
    [anon_sym_TILDE] = ACTIONS(2569),
    [aux_sym_prefix_op_token1] = ACTIONS(2567),
    [aux_sym_infix_op_token1] = ACTIONS(2569),
    [aux_sym_infix_op_token2] = ACTIONS(2567),
    [anon_sym_PIPE_PIPE] = ACTIONS(2567),
    [anon_sym_BANG_EQ] = ACTIONS(2567),
    [anon_sym_COLON_EQ] = ACTIONS(2569),
    [anon_sym_DOLLAR] = ACTIONS(2567),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2567),
    [sym_int] = ACTIONS(2567),
    [sym_xint] = ACTIONS(2569),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2569),
    [sym__newline] = ACTIONS(2569),
    [sym__dedent] = ACTIONS(2569),
  },
  [805] = {
    [sym_block_comment] = STATE(805),
    [sym_compiler_directive_decl] = STATE(805),
    [sym_fsi_directive_decl] = STATE(805),
    [sym_preproc_line] = STATE(805),
    [sym_identifier] = ACTIONS(2158),
    [anon_sym_EQ] = ACTIONS(2160),
    [anon_sym_COLON] = ACTIONS(2158),
    [anon_sym_return] = ACTIONS(2158),
    [anon_sym_do] = ACTIONS(2158),
    [anon_sym_let] = ACTIONS(2158),
    [anon_sym_let_BANG] = ACTIONS(2160),
    [anon_sym_LPAREN] = ACTIONS(2158),
    [anon_sym_COMMA] = ACTIONS(2160),
    [anon_sym_null] = ACTIONS(2158),
    [anon_sym_QMARK] = ACTIONS(2158),
    [anon_sym_COLON_QMARK] = ACTIONS(2158),
    [anon_sym_COLON_COLON] = ACTIONS(2160),
    [anon_sym_AMP] = ACTIONS(2158),
    [anon_sym_LBRACK] = ACTIONS(2158),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2160),
    [anon_sym_LBRACE] = ACTIONS(2158),
    [anon_sym_LT_AT] = ACTIONS(2158),
    [anon_sym_AT_GT] = ACTIONS(2158),
    [anon_sym_LT_AT_AT] = ACTIONS(2158),
    [anon_sym_DOT] = ACTIONS(2158),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2160),
    [anon_sym_new] = ACTIONS(2158),
    [anon_sym_return_BANG] = ACTIONS(2160),
    [anon_sym_yield] = ACTIONS(2158),
    [anon_sym_yield_BANG] = ACTIONS(2160),
    [anon_sym_lazy] = ACTIONS(2158),
    [anon_sym_assert] = ACTIONS(2158),
    [anon_sym_upcast] = ACTIONS(2158),
    [anon_sym_downcast] = ACTIONS(2158),
    [anon_sym_COLON_GT] = ACTIONS(2160),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2160),
    [anon_sym_for] = ACTIONS(2158),
    [anon_sym_while] = ACTIONS(2158),
    [anon_sym_if] = ACTIONS(2158),
    [anon_sym_fun] = ACTIONS(2158),
    [anon_sym_try] = ACTIONS(2158),
    [anon_sym_match] = ACTIONS(2158),
    [anon_sym_match_BANG] = ACTIONS(2160),
    [anon_sym_function] = ACTIONS(2158),
    [anon_sym_LT_DASH] = ACTIONS(2158),
    [anon_sym_DOT_LBRACK] = ACTIONS(2160),
    [anon_sym_LT] = ACTIONS(2160),
    [anon_sym_use] = ACTIONS(2158),
    [anon_sym_use_BANG] = ACTIONS(2160),
    [anon_sym_do_BANG] = ACTIONS(2160),
    [anon_sym_begin] = ACTIONS(2158),
    [anon_sym_LPAREN2] = ACTIONS(2158),
    [anon_sym_or] = ACTIONS(2158),
    [aux_sym_char_token1] = ACTIONS(2160),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2158),
    [anon_sym_DQUOTE] = ACTIONS(2158),
    [anon_sym_AT_DQUOTE] = ACTIONS(2160),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2160),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2160),
    [sym_bool] = ACTIONS(2158),
    [sym_unit] = ACTIONS(2160),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2158),
    [sym_op_identifier] = ACTIONS(2158),
    [anon_sym_PLUS] = ACTIONS(2158),
    [anon_sym_DASH] = ACTIONS(2158),
    [anon_sym_PLUS_DOT] = ACTIONS(2158),
    [anon_sym_DASH_DOT] = ACTIONS(2158),
    [anon_sym_PERCENT] = ACTIONS(2158),
    [anon_sym_AMP_AMP] = ACTIONS(2158),
    [anon_sym_TILDE] = ACTIONS(2160),
    [aux_sym_prefix_op_token1] = ACTIONS(2158),
    [aux_sym_infix_op_token1] = ACTIONS(2160),
    [aux_sym_infix_op_token2] = ACTIONS(2158),
    [anon_sym_PIPE_PIPE] = ACTIONS(2158),
    [anon_sym_BANG_EQ] = ACTIONS(2158),
    [anon_sym_COLON_EQ] = ACTIONS(2160),
    [anon_sym_DOLLAR] = ACTIONS(2158),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2158),
    [sym_int] = ACTIONS(2158),
    [sym_xint] = ACTIONS(2160),
    [anon_sym_y] = ACTIONS(2571),
    [anon_sym_uy] = ACTIONS(2573),
    [anon_sym_s] = ACTIONS(2575),
    [anon_sym_us] = ACTIONS(2577),
    [anon_sym_l] = ACTIONS(2579),
    [aux_sym_uint32_token1] = ACTIONS(2581),
    [anon_sym_n] = ACTIONS(2583),
    [anon_sym_un] = ACTIONS(2585),
    [anon_sym_L] = ACTIONS(2587),
    [aux_sym_uint64_token1] = ACTIONS(2589),
    [aux_sym_bignum_token1] = ACTIONS(2591),
    [aux_sym_decimal_token1] = ACTIONS(2593),
    [anon_sym_DOT2] = ACTIONS(2595),
    [aux_sym_float_token1] = ACTIONS(2597),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2160),
    [sym__newline] = ACTIONS(2160),
  },
  [806] = {
    [sym_block_comment] = STATE(806),
    [sym_compiler_directive_decl] = STATE(806),
    [sym_fsi_directive_decl] = STATE(806),
    [sym_preproc_line] = STATE(806),
    [sym_identifier] = ACTIONS(2158),
    [anon_sym_EQ] = ACTIONS(2160),
    [anon_sym_COLON] = ACTIONS(2158),
    [anon_sym_return] = ACTIONS(2158),
    [anon_sym_do] = ACTIONS(2158),
    [anon_sym_let] = ACTIONS(2158),
    [anon_sym_let_BANG] = ACTIONS(2160),
    [anon_sym_LPAREN] = ACTIONS(2158),
    [anon_sym_COMMA] = ACTIONS(2160),
    [anon_sym_null] = ACTIONS(2158),
    [anon_sym_QMARK] = ACTIONS(2158),
    [anon_sym_COLON_QMARK] = ACTIONS(2158),
    [anon_sym_COLON_COLON] = ACTIONS(2160),
    [anon_sym_AMP] = ACTIONS(2158),
    [anon_sym_LBRACK] = ACTIONS(2158),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2160),
    [anon_sym_LBRACE] = ACTIONS(2158),
    [anon_sym_LT_AT] = ACTIONS(2158),
    [anon_sym_LT_AT_AT] = ACTIONS(2158),
    [anon_sym_DOT] = ACTIONS(2158),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2160),
    [anon_sym_new] = ACTIONS(2158),
    [anon_sym_return_BANG] = ACTIONS(2160),
    [anon_sym_yield] = ACTIONS(2158),
    [anon_sym_yield_BANG] = ACTIONS(2160),
    [anon_sym_lazy] = ACTIONS(2158),
    [anon_sym_assert] = ACTIONS(2158),
    [anon_sym_upcast] = ACTIONS(2158),
    [anon_sym_downcast] = ACTIONS(2158),
    [anon_sym_COLON_GT] = ACTIONS(2160),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2160),
    [anon_sym_for] = ACTIONS(2158),
    [anon_sym_while] = ACTIONS(2158),
    [anon_sym_if] = ACTIONS(2158),
    [anon_sym_fun] = ACTIONS(2158),
    [anon_sym_try] = ACTIONS(2158),
    [anon_sym_match] = ACTIONS(2158),
    [anon_sym_match_BANG] = ACTIONS(2160),
    [anon_sym_function] = ACTIONS(2158),
    [anon_sym_LT_DASH] = ACTIONS(2158),
    [anon_sym_DOT_LBRACK] = ACTIONS(2160),
    [anon_sym_LT] = ACTIONS(2160),
    [anon_sym_use] = ACTIONS(2158),
    [anon_sym_use_BANG] = ACTIONS(2160),
    [anon_sym_do_BANG] = ACTIONS(2160),
    [anon_sym_begin] = ACTIONS(2158),
    [anon_sym_LPAREN2] = ACTIONS(2158),
    [anon_sym_or] = ACTIONS(2158),
    [aux_sym_char_token1] = ACTIONS(2160),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2158),
    [anon_sym_DQUOTE] = ACTIONS(2158),
    [anon_sym_AT_DQUOTE] = ACTIONS(2160),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2160),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2160),
    [sym_bool] = ACTIONS(2158),
    [sym_unit] = ACTIONS(2160),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2158),
    [sym_op_identifier] = ACTIONS(2158),
    [anon_sym_PLUS] = ACTIONS(2158),
    [anon_sym_DASH] = ACTIONS(2158),
    [anon_sym_PLUS_DOT] = ACTIONS(2158),
    [anon_sym_DASH_DOT] = ACTIONS(2158),
    [anon_sym_PERCENT] = ACTIONS(2158),
    [anon_sym_AMP_AMP] = ACTIONS(2158),
    [anon_sym_TILDE] = ACTIONS(2160),
    [aux_sym_prefix_op_token1] = ACTIONS(2158),
    [aux_sym_infix_op_token1] = ACTIONS(2160),
    [aux_sym_infix_op_token2] = ACTIONS(2158),
    [anon_sym_PIPE_PIPE] = ACTIONS(2158),
    [anon_sym_BANG_EQ] = ACTIONS(2158),
    [anon_sym_COLON_EQ] = ACTIONS(2160),
    [anon_sym_DOLLAR] = ACTIONS(2158),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2158),
    [sym_int] = ACTIONS(2158),
    [sym_xint] = ACTIONS(2160),
    [anon_sym_y] = ACTIONS(2599),
    [anon_sym_uy] = ACTIONS(2601),
    [anon_sym_s] = ACTIONS(2603),
    [anon_sym_us] = ACTIONS(2605),
    [anon_sym_l] = ACTIONS(2607),
    [aux_sym_uint32_token1] = ACTIONS(2609),
    [anon_sym_n] = ACTIONS(2611),
    [anon_sym_un] = ACTIONS(2613),
    [anon_sym_L] = ACTIONS(2615),
    [aux_sym_uint64_token1] = ACTIONS(2617),
    [aux_sym_bignum_token1] = ACTIONS(2619),
    [aux_sym_decimal_token1] = ACTIONS(2621),
    [anon_sym_DOT2] = ACTIONS(2623),
    [aux_sym_float_token1] = ACTIONS(2625),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2160),
    [anon_sym_POUNDendif] = ACTIONS(2160),
    [sym__newline] = ACTIONS(2160),
  },
  [807] = {
    [sym_block_comment] = STATE(807),
    [sym_compiler_directive_decl] = STATE(807),
    [sym_fsi_directive_decl] = STATE(807),
    [sym_preproc_line] = STATE(807),
    [sym_identifier] = ACTIONS(2567),
    [anon_sym_EQ] = ACTIONS(2569),
    [anon_sym_LBRACK_LT] = ACTIONS(2569),
    [anon_sym_COLON] = ACTIONS(2567),
    [anon_sym_return] = ACTIONS(2567),
    [anon_sym_do] = ACTIONS(2567),
    [anon_sym_let] = ACTIONS(2567),
    [anon_sym_let_BANG] = ACTIONS(2569),
    [aux_sym_access_modifier_token1] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2567),
    [anon_sym_COMMA] = ACTIONS(2569),
    [anon_sym_null] = ACTIONS(2567),
    [anon_sym_QMARK] = ACTIONS(2567),
    [anon_sym_COLON_QMARK] = ACTIONS(2567),
    [anon_sym_COLON_COLON] = ACTIONS(2569),
    [anon_sym_AMP] = ACTIONS(2567),
    [anon_sym_LBRACK] = ACTIONS(2567),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2569),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_LT_AT] = ACTIONS(2567),
    [anon_sym_LT_AT_AT] = ACTIONS(2567),
    [anon_sym_DOT] = ACTIONS(2567),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2569),
    [anon_sym_new] = ACTIONS(2567),
    [anon_sym_with] = ACTIONS(2567),
    [anon_sym_return_BANG] = ACTIONS(2569),
    [anon_sym_yield] = ACTIONS(2567),
    [anon_sym_yield_BANG] = ACTIONS(2569),
    [anon_sym_lazy] = ACTIONS(2567),
    [anon_sym_assert] = ACTIONS(2567),
    [anon_sym_upcast] = ACTIONS(2567),
    [anon_sym_downcast] = ACTIONS(2567),
    [anon_sym_COLON_GT] = ACTIONS(2569),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2569),
    [anon_sym_for] = ACTIONS(2567),
    [anon_sym_while] = ACTIONS(2567),
    [anon_sym_if] = ACTIONS(2567),
    [anon_sym_fun] = ACTIONS(2567),
    [anon_sym_DASH_GT] = ACTIONS(2567),
    [anon_sym_try] = ACTIONS(2567),
    [anon_sym_match] = ACTIONS(2567),
    [anon_sym_match_BANG] = ACTIONS(2569),
    [anon_sym_function] = ACTIONS(2567),
    [anon_sym_LT_DASH] = ACTIONS(2567),
    [anon_sym_DOT_LBRACK] = ACTIONS(2569),
    [anon_sym_LT] = ACTIONS(2569),
    [anon_sym_use] = ACTIONS(2567),
    [anon_sym_use_BANG] = ACTIONS(2569),
    [anon_sym_do_BANG] = ACTIONS(2569),
    [anon_sym_begin] = ACTIONS(2567),
    [anon_sym_LPAREN2] = ACTIONS(2567),
    [anon_sym_DOT_DOT2] = ACTIONS(2569),
    [anon_sym_STAR] = ACTIONS(2567),
    [anon_sym_LT2] = ACTIONS(2567),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2569),
    [anon_sym_default] = ACTIONS(2567),
    [anon_sym_or] = ACTIONS(2567),
    [anon_sym_static] = ACTIONS(2567),
    [anon_sym_member] = ACTIONS(2567),
    [anon_sym_abstract] = ACTIONS(2567),
    [anon_sym_val] = ACTIONS(2567),
    [anon_sym_override] = ACTIONS(2567),
    [aux_sym_char_token1] = ACTIONS(2569),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2567),
    [anon_sym_DQUOTE] = ACTIONS(2567),
    [anon_sym_AT_DQUOTE] = ACTIONS(2569),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2569),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2569),
    [sym_bool] = ACTIONS(2567),
    [sym_unit] = ACTIONS(2569),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2567),
    [sym_op_identifier] = ACTIONS(2567),
    [anon_sym_PLUS] = ACTIONS(2567),
    [anon_sym_DASH] = ACTIONS(2567),
    [anon_sym_PLUS_DOT] = ACTIONS(2567),
    [anon_sym_DASH_DOT] = ACTIONS(2567),
    [anon_sym_PERCENT] = ACTIONS(2567),
    [anon_sym_AMP_AMP] = ACTIONS(2567),
    [anon_sym_TILDE] = ACTIONS(2569),
    [aux_sym_prefix_op_token1] = ACTIONS(2567),
    [aux_sym_infix_op_token1] = ACTIONS(2569),
    [aux_sym_infix_op_token2] = ACTIONS(2567),
    [anon_sym_PIPE_PIPE] = ACTIONS(2567),
    [anon_sym_BANG_EQ] = ACTIONS(2567),
    [anon_sym_COLON_EQ] = ACTIONS(2569),
    [anon_sym_DOLLAR] = ACTIONS(2567),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2567),
    [sym_int] = ACTIONS(2567),
    [sym_xint] = ACTIONS(2569),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2569),
    [sym__newline] = ACTIONS(2569),
    [sym__dedent] = ACTIONS(2569),
  },
  [808] = {
    [sym_block_comment] = STATE(808),
    [sym_compiler_directive_decl] = STATE(808),
    [sym_fsi_directive_decl] = STATE(808),
    [sym_preproc_line] = STATE(808),
    [sym_identifier] = ACTIONS(2340),
    [anon_sym_EQ] = ACTIONS(2342),
    [anon_sym_LBRACK_LT] = ACTIONS(2342),
    [anon_sym_COLON] = ACTIONS(2340),
    [anon_sym_return] = ACTIONS(2340),
    [anon_sym_do] = ACTIONS(2340),
    [anon_sym_let] = ACTIONS(2340),
    [anon_sym_let_BANG] = ACTIONS(2342),
    [aux_sym_access_modifier_token1] = ACTIONS(2342),
    [anon_sym_LPAREN] = ACTIONS(2340),
    [anon_sym_COMMA] = ACTIONS(2342),
    [anon_sym_null] = ACTIONS(2340),
    [anon_sym_QMARK] = ACTIONS(2340),
    [anon_sym_COLON_QMARK] = ACTIONS(2340),
    [anon_sym_COLON_COLON] = ACTIONS(2342),
    [anon_sym_AMP] = ACTIONS(2340),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2342),
    [anon_sym_LBRACE] = ACTIONS(2340),
    [anon_sym_LT_AT] = ACTIONS(2340),
    [anon_sym_LT_AT_AT] = ACTIONS(2340),
    [anon_sym_DOT] = ACTIONS(2340),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2342),
    [anon_sym_new] = ACTIONS(2340),
    [anon_sym_with] = ACTIONS(2340),
    [anon_sym_return_BANG] = ACTIONS(2342),
    [anon_sym_yield] = ACTIONS(2340),
    [anon_sym_yield_BANG] = ACTIONS(2342),
    [anon_sym_lazy] = ACTIONS(2340),
    [anon_sym_assert] = ACTIONS(2340),
    [anon_sym_upcast] = ACTIONS(2340),
    [anon_sym_downcast] = ACTIONS(2340),
    [anon_sym_COLON_GT] = ACTIONS(2342),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2342),
    [anon_sym_for] = ACTIONS(2340),
    [anon_sym_while] = ACTIONS(2340),
    [anon_sym_if] = ACTIONS(2340),
    [anon_sym_fun] = ACTIONS(2340),
    [anon_sym_DASH_GT] = ACTIONS(2340),
    [anon_sym_try] = ACTIONS(2340),
    [anon_sym_match] = ACTIONS(2340),
    [anon_sym_match_BANG] = ACTIONS(2342),
    [anon_sym_function] = ACTIONS(2340),
    [anon_sym_LT_DASH] = ACTIONS(2340),
    [anon_sym_DOT_LBRACK] = ACTIONS(2342),
    [anon_sym_LT] = ACTIONS(2342),
    [anon_sym_use] = ACTIONS(2340),
    [anon_sym_use_BANG] = ACTIONS(2342),
    [anon_sym_do_BANG] = ACTIONS(2342),
    [anon_sym_begin] = ACTIONS(2340),
    [anon_sym_LPAREN2] = ACTIONS(2340),
    [anon_sym_DOT_DOT2] = ACTIONS(2342),
    [anon_sym_STAR] = ACTIONS(2340),
    [anon_sym_LT2] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2342),
    [anon_sym_default] = ACTIONS(2340),
    [anon_sym_or] = ACTIONS(2340),
    [anon_sym_static] = ACTIONS(2340),
    [anon_sym_member] = ACTIONS(2340),
    [anon_sym_abstract] = ACTIONS(2340),
    [anon_sym_val] = ACTIONS(2340),
    [anon_sym_override] = ACTIONS(2340),
    [aux_sym_char_token1] = ACTIONS(2342),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2340),
    [anon_sym_DQUOTE] = ACTIONS(2340),
    [anon_sym_AT_DQUOTE] = ACTIONS(2342),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2342),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2342),
    [sym_bool] = ACTIONS(2340),
    [sym_unit] = ACTIONS(2342),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2340),
    [sym_op_identifier] = ACTIONS(2340),
    [anon_sym_PLUS] = ACTIONS(2340),
    [anon_sym_DASH] = ACTIONS(2340),
    [anon_sym_PLUS_DOT] = ACTIONS(2340),
    [anon_sym_DASH_DOT] = ACTIONS(2340),
    [anon_sym_PERCENT] = ACTIONS(2340),
    [anon_sym_AMP_AMP] = ACTIONS(2340),
    [anon_sym_TILDE] = ACTIONS(2342),
    [aux_sym_prefix_op_token1] = ACTIONS(2340),
    [aux_sym_infix_op_token1] = ACTIONS(2342),
    [aux_sym_infix_op_token2] = ACTIONS(2340),
    [anon_sym_PIPE_PIPE] = ACTIONS(2340),
    [anon_sym_BANG_EQ] = ACTIONS(2340),
    [anon_sym_COLON_EQ] = ACTIONS(2342),
    [anon_sym_DOLLAR] = ACTIONS(2340),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2340),
    [sym_int] = ACTIONS(2340),
    [sym_xint] = ACTIONS(2342),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2342),
    [sym__newline] = ACTIONS(2342),
    [sym__dedent] = ACTIONS(2342),
  },
  [809] = {
    [sym_block_comment] = STATE(809),
    [sym_compiler_directive_decl] = STATE(809),
    [sym_fsi_directive_decl] = STATE(809),
    [sym_preproc_line] = STATE(809),
    [sym_identifier] = ACTIONS(2627),
    [anon_sym_EQ] = ACTIONS(2629),
    [anon_sym_LBRACK_LT] = ACTIONS(2629),
    [anon_sym_COLON] = ACTIONS(2627),
    [anon_sym_return] = ACTIONS(2627),
    [anon_sym_do] = ACTIONS(2627),
    [anon_sym_let] = ACTIONS(2627),
    [anon_sym_let_BANG] = ACTIONS(2629),
    [aux_sym_access_modifier_token1] = ACTIONS(2629),
    [anon_sym_LPAREN] = ACTIONS(2627),
    [anon_sym_COMMA] = ACTIONS(2629),
    [anon_sym_null] = ACTIONS(2627),
    [anon_sym_QMARK] = ACTIONS(2627),
    [anon_sym_COLON_QMARK] = ACTIONS(2627),
    [anon_sym_COLON_COLON] = ACTIONS(2629),
    [anon_sym_AMP] = ACTIONS(2627),
    [anon_sym_LBRACK] = ACTIONS(2627),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2629),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_LT_AT] = ACTIONS(2627),
    [anon_sym_LT_AT_AT] = ACTIONS(2627),
    [anon_sym_DOT] = ACTIONS(2627),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2629),
    [anon_sym_new] = ACTIONS(2627),
    [anon_sym_with] = ACTIONS(2627),
    [anon_sym_return_BANG] = ACTIONS(2629),
    [anon_sym_yield] = ACTIONS(2627),
    [anon_sym_yield_BANG] = ACTIONS(2629),
    [anon_sym_lazy] = ACTIONS(2627),
    [anon_sym_assert] = ACTIONS(2627),
    [anon_sym_upcast] = ACTIONS(2627),
    [anon_sym_downcast] = ACTIONS(2627),
    [anon_sym_COLON_GT] = ACTIONS(2629),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2629),
    [anon_sym_for] = ACTIONS(2627),
    [anon_sym_while] = ACTIONS(2627),
    [anon_sym_if] = ACTIONS(2627),
    [anon_sym_fun] = ACTIONS(2627),
    [anon_sym_DASH_GT] = ACTIONS(2627),
    [anon_sym_try] = ACTIONS(2627),
    [anon_sym_match] = ACTIONS(2627),
    [anon_sym_match_BANG] = ACTIONS(2629),
    [anon_sym_function] = ACTIONS(2627),
    [anon_sym_LT_DASH] = ACTIONS(2627),
    [anon_sym_DOT_LBRACK] = ACTIONS(2629),
    [anon_sym_LT] = ACTIONS(2629),
    [anon_sym_use] = ACTIONS(2627),
    [anon_sym_use_BANG] = ACTIONS(2629),
    [anon_sym_do_BANG] = ACTIONS(2629),
    [anon_sym_begin] = ACTIONS(2627),
    [anon_sym_LPAREN2] = ACTIONS(2627),
    [anon_sym_DOT_DOT2] = ACTIONS(2629),
    [anon_sym_STAR] = ACTIONS(2627),
    [anon_sym_LT2] = ACTIONS(2627),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2629),
    [anon_sym_default] = ACTIONS(2627),
    [anon_sym_or] = ACTIONS(2627),
    [anon_sym_static] = ACTIONS(2627),
    [anon_sym_member] = ACTIONS(2627),
    [anon_sym_abstract] = ACTIONS(2627),
    [anon_sym_val] = ACTIONS(2627),
    [anon_sym_override] = ACTIONS(2627),
    [aux_sym_char_token1] = ACTIONS(2629),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2627),
    [anon_sym_DQUOTE] = ACTIONS(2627),
    [anon_sym_AT_DQUOTE] = ACTIONS(2629),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2629),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2629),
    [sym_bool] = ACTIONS(2627),
    [sym_unit] = ACTIONS(2629),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2627),
    [sym_op_identifier] = ACTIONS(2627),
    [anon_sym_PLUS] = ACTIONS(2627),
    [anon_sym_DASH] = ACTIONS(2627),
    [anon_sym_PLUS_DOT] = ACTIONS(2627),
    [anon_sym_DASH_DOT] = ACTIONS(2627),
    [anon_sym_PERCENT] = ACTIONS(2627),
    [anon_sym_AMP_AMP] = ACTIONS(2627),
    [anon_sym_TILDE] = ACTIONS(2629),
    [aux_sym_prefix_op_token1] = ACTIONS(2627),
    [aux_sym_infix_op_token1] = ACTIONS(2629),
    [aux_sym_infix_op_token2] = ACTIONS(2627),
    [anon_sym_PIPE_PIPE] = ACTIONS(2627),
    [anon_sym_BANG_EQ] = ACTIONS(2627),
    [anon_sym_COLON_EQ] = ACTIONS(2629),
    [anon_sym_DOLLAR] = ACTIONS(2627),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2627),
    [sym_int] = ACTIONS(2627),
    [sym_xint] = ACTIONS(2629),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2629),
    [sym__newline] = ACTIONS(2629),
    [sym__dedent] = ACTIONS(2629),
  },
  [810] = {
    [sym_block_comment] = STATE(810),
    [sym_compiler_directive_decl] = STATE(810),
    [sym_fsi_directive_decl] = STATE(810),
    [sym_preproc_line] = STATE(810),
    [sym_identifier] = ACTIONS(2158),
    [anon_sym_EQ] = ACTIONS(2160),
    [anon_sym_COLON] = ACTIONS(2158),
    [anon_sym_return] = ACTIONS(2158),
    [anon_sym_do] = ACTIONS(2158),
    [anon_sym_let] = ACTIONS(2158),
    [anon_sym_let_BANG] = ACTIONS(2160),
    [anon_sym_LPAREN] = ACTIONS(2158),
    [anon_sym_COMMA] = ACTIONS(2160),
    [anon_sym_null] = ACTIONS(2158),
    [anon_sym_QMARK] = ACTIONS(2158),
    [anon_sym_COLON_QMARK] = ACTIONS(2158),
    [anon_sym_COLON_COLON] = ACTIONS(2160),
    [anon_sym_AMP] = ACTIONS(2158),
    [anon_sym_LBRACK] = ACTIONS(2158),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2160),
    [anon_sym_LBRACE] = ACTIONS(2158),
    [anon_sym_LT_AT] = ACTIONS(2158),
    [anon_sym_LT_AT_AT] = ACTIONS(2158),
    [anon_sym_DOT] = ACTIONS(2158),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2160),
    [anon_sym_new] = ACTIONS(2158),
    [anon_sym_return_BANG] = ACTIONS(2160),
    [anon_sym_yield] = ACTIONS(2158),
    [anon_sym_yield_BANG] = ACTIONS(2160),
    [anon_sym_lazy] = ACTIONS(2158),
    [anon_sym_assert] = ACTIONS(2158),
    [anon_sym_upcast] = ACTIONS(2158),
    [anon_sym_downcast] = ACTIONS(2158),
    [anon_sym_COLON_GT] = ACTIONS(2160),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2160),
    [anon_sym_for] = ACTIONS(2158),
    [anon_sym_while] = ACTIONS(2158),
    [anon_sym_if] = ACTIONS(2158),
    [anon_sym_fun] = ACTIONS(2158),
    [anon_sym_try] = ACTIONS(2158),
    [anon_sym_match] = ACTIONS(2158),
    [anon_sym_match_BANG] = ACTIONS(2160),
    [anon_sym_function] = ACTIONS(2158),
    [anon_sym_LT_DASH] = ACTIONS(2158),
    [anon_sym_DOT_LBRACK] = ACTIONS(2160),
    [anon_sym_LT] = ACTIONS(2160),
    [anon_sym_GT] = ACTIONS(2158),
    [anon_sym_use] = ACTIONS(2158),
    [anon_sym_use_BANG] = ACTIONS(2160),
    [anon_sym_do_BANG] = ACTIONS(2160),
    [anon_sym_begin] = ACTIONS(2158),
    [anon_sym_LPAREN2] = ACTIONS(2158),
    [anon_sym_or] = ACTIONS(2158),
    [aux_sym_char_token1] = ACTIONS(2160),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2158),
    [anon_sym_DQUOTE] = ACTIONS(2158),
    [anon_sym_AT_DQUOTE] = ACTIONS(2160),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2160),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2160),
    [sym_bool] = ACTIONS(2158),
    [sym_unit] = ACTIONS(2160),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2158),
    [sym_op_identifier] = ACTIONS(2158),
    [anon_sym_PLUS] = ACTIONS(2158),
    [anon_sym_DASH] = ACTIONS(2158),
    [anon_sym_PLUS_DOT] = ACTIONS(2158),
    [anon_sym_DASH_DOT] = ACTIONS(2158),
    [anon_sym_PERCENT] = ACTIONS(2158),
    [anon_sym_AMP_AMP] = ACTIONS(2158),
    [anon_sym_TILDE] = ACTIONS(2160),
    [aux_sym_prefix_op_token1] = ACTIONS(2158),
    [aux_sym_infix_op_token1] = ACTIONS(2160),
    [aux_sym_infix_op_token2] = ACTIONS(2158),
    [anon_sym_PIPE_PIPE] = ACTIONS(2158),
    [anon_sym_BANG_EQ] = ACTIONS(2158),
    [anon_sym_COLON_EQ] = ACTIONS(2160),
    [anon_sym_DOLLAR] = ACTIONS(2158),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2158),
    [sym_int] = ACTIONS(2158),
    [sym_xint] = ACTIONS(2160),
    [anon_sym_y] = ACTIONS(2631),
    [anon_sym_uy] = ACTIONS(2633),
    [anon_sym_s] = ACTIONS(2635),
    [anon_sym_us] = ACTIONS(2637),
    [anon_sym_l] = ACTIONS(2639),
    [aux_sym_uint32_token1] = ACTIONS(2641),
    [anon_sym_n] = ACTIONS(2643),
    [anon_sym_un] = ACTIONS(2645),
    [anon_sym_L] = ACTIONS(2647),
    [aux_sym_uint64_token1] = ACTIONS(2649),
    [aux_sym_bignum_token1] = ACTIONS(2651),
    [aux_sym_decimal_token1] = ACTIONS(2653),
    [anon_sym_DOT2] = ACTIONS(2655),
    [aux_sym_float_token1] = ACTIONS(2657),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2160),
    [sym__newline] = ACTIONS(2160),
  },
  [811] = {
    [sym_type_arguments] = STATE(920),
    [sym_long_identifier] = STATE(923),
    [sym_block_comment] = STATE(811),
    [sym_compiler_directive_decl] = STATE(811),
    [sym_fsi_directive_decl] = STATE(811),
    [sym_preproc_line] = STATE(811),
    [aux_sym_compound_type_repeat1] = STATE(848),
    [sym_identifier] = ACTIONS(2659),
    [anon_sym_EQ] = ACTIONS(2240),
    [anon_sym_GT_RBRACK] = ACTIONS(2240),
    [anon_sym_COLON] = ACTIONS(2242),
    [anon_sym_return] = ACTIONS(2242),
    [anon_sym_do] = ACTIONS(2242),
    [anon_sym_let] = ACTIONS(2242),
    [anon_sym_let_BANG] = ACTIONS(2240),
    [anon_sym_LPAREN] = ACTIONS(2242),
    [anon_sym_COMMA] = ACTIONS(2240),
    [anon_sym_null] = ACTIONS(2242),
    [anon_sym_QMARK] = ACTIONS(2242),
    [anon_sym_COLON_QMARK] = ACTIONS(2242),
    [anon_sym_COLON_COLON] = ACTIONS(2240),
    [anon_sym_AMP] = ACTIONS(2242),
    [anon_sym_LBRACK] = ACTIONS(2242),
    [anon_sym_RBRACK] = ACTIONS(2240),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2240),
    [anon_sym_LBRACE] = ACTIONS(2242),
    [anon_sym_RBRACE] = ACTIONS(2240),
    [anon_sym_LT_AT] = ACTIONS(2242),
    [anon_sym_LT_AT_AT] = ACTIONS(2242),
    [anon_sym_DOT] = ACTIONS(2242),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2240),
    [anon_sym_new] = ACTIONS(2242),
    [anon_sym_with] = ACTIONS(2242),
    [anon_sym_return_BANG] = ACTIONS(2240),
    [anon_sym_yield] = ACTIONS(2242),
    [anon_sym_yield_BANG] = ACTIONS(2240),
    [anon_sym_lazy] = ACTIONS(2242),
    [anon_sym_assert] = ACTIONS(2242),
    [anon_sym_upcast] = ACTIONS(2242),
    [anon_sym_downcast] = ACTIONS(2242),
    [anon_sym_COLON_GT] = ACTIONS(2240),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2240),
    [anon_sym_for] = ACTIONS(2242),
    [anon_sym_to] = ACTIONS(2242),
    [anon_sym_downto] = ACTIONS(2242),
    [anon_sym_while] = ACTIONS(2242),
    [anon_sym_if] = ACTIONS(2242),
    [anon_sym_fun] = ACTIONS(2242),
    [anon_sym_DASH_GT] = ACTIONS(2661),
    [anon_sym_try] = ACTIONS(2242),
    [anon_sym_match] = ACTIONS(2242),
    [anon_sym_match_BANG] = ACTIONS(2240),
    [anon_sym_function] = ACTIONS(2242),
    [anon_sym_LT_DASH] = ACTIONS(2242),
    [anon_sym_DOT_LBRACK] = ACTIONS(2240),
    [anon_sym_LT] = ACTIONS(2240),
    [anon_sym_use] = ACTIONS(2242),
    [anon_sym_use_BANG] = ACTIONS(2240),
    [anon_sym_do_BANG] = ACTIONS(2240),
    [anon_sym_begin] = ACTIONS(2242),
    [anon_sym_LPAREN2] = ACTIONS(2242),
    [anon_sym_DOT_DOT2] = ACTIONS(2240),
    [anon_sym_STAR] = ACTIONS(2663),
    [anon_sym_LT2] = ACTIONS(2665),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2667),
    [anon_sym_or] = ACTIONS(2242),
    [aux_sym_char_token1] = ACTIONS(2240),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2242),
    [anon_sym_DQUOTE] = ACTIONS(2242),
    [anon_sym_AT_DQUOTE] = ACTIONS(2240),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2240),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2240),
    [sym_bool] = ACTIONS(2242),
    [sym_unit] = ACTIONS(2240),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2242),
    [sym_op_identifier] = ACTIONS(2242),
    [anon_sym_PLUS] = ACTIONS(2242),
    [anon_sym_DASH] = ACTIONS(2242),
    [anon_sym_PLUS_DOT] = ACTIONS(2242),
    [anon_sym_DASH_DOT] = ACTIONS(2242),
    [anon_sym_PERCENT] = ACTIONS(2242),
    [anon_sym_AMP_AMP] = ACTIONS(2242),
    [anon_sym_TILDE] = ACTIONS(2240),
    [aux_sym_prefix_op_token1] = ACTIONS(2242),
    [aux_sym_infix_op_token1] = ACTIONS(2240),
    [aux_sym_infix_op_token2] = ACTIONS(2242),
    [anon_sym_PIPE_PIPE] = ACTIONS(2242),
    [anon_sym_BANG_EQ] = ACTIONS(2242),
    [anon_sym_COLON_EQ] = ACTIONS(2240),
    [anon_sym_DOLLAR] = ACTIONS(2242),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2242),
    [sym_int] = ACTIONS(2242),
    [sym_xint] = ACTIONS(2240),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2240),
    [sym__newline] = ACTIONS(2240),
  },
  [812] = {
    [sym_type_arguments] = STATE(920),
    [sym_long_identifier] = STATE(923),
    [sym_block_comment] = STATE(812),
    [sym_compiler_directive_decl] = STATE(812),
    [sym_fsi_directive_decl] = STATE(812),
    [sym_preproc_line] = STATE(812),
    [aux_sym_compound_type_repeat1] = STATE(848),
    [sym_identifier] = ACTIONS(2252),
    [anon_sym_EQ] = ACTIONS(2254),
    [anon_sym_GT_RBRACK] = ACTIONS(2254),
    [anon_sym_COLON] = ACTIONS(2252),
    [anon_sym_return] = ACTIONS(2252),
    [anon_sym_do] = ACTIONS(2252),
    [anon_sym_let] = ACTIONS(2252),
    [anon_sym_let_BANG] = ACTIONS(2254),
    [anon_sym_LPAREN] = ACTIONS(2252),
    [anon_sym_COMMA] = ACTIONS(2254),
    [anon_sym_null] = ACTIONS(2252),
    [anon_sym_QMARK] = ACTIONS(2252),
    [anon_sym_COLON_QMARK] = ACTIONS(2252),
    [anon_sym_COLON_COLON] = ACTIONS(2254),
    [anon_sym_AMP] = ACTIONS(2252),
    [anon_sym_LBRACK] = ACTIONS(2252),
    [anon_sym_RBRACK] = ACTIONS(2254),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2254),
    [anon_sym_LBRACE] = ACTIONS(2252),
    [anon_sym_RBRACE] = ACTIONS(2254),
    [anon_sym_LT_AT] = ACTIONS(2252),
    [anon_sym_LT_AT_AT] = ACTIONS(2252),
    [anon_sym_DOT] = ACTIONS(2252),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2254),
    [anon_sym_new] = ACTIONS(2252),
    [anon_sym_with] = ACTIONS(2252),
    [anon_sym_return_BANG] = ACTIONS(2254),
    [anon_sym_yield] = ACTIONS(2252),
    [anon_sym_yield_BANG] = ACTIONS(2254),
    [anon_sym_lazy] = ACTIONS(2252),
    [anon_sym_assert] = ACTIONS(2252),
    [anon_sym_upcast] = ACTIONS(2252),
    [anon_sym_downcast] = ACTIONS(2252),
    [anon_sym_COLON_GT] = ACTIONS(2254),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2254),
    [anon_sym_for] = ACTIONS(2252),
    [anon_sym_to] = ACTIONS(2252),
    [anon_sym_downto] = ACTIONS(2252),
    [anon_sym_while] = ACTIONS(2252),
    [anon_sym_if] = ACTIONS(2252),
    [anon_sym_fun] = ACTIONS(2252),
    [anon_sym_DASH_GT] = ACTIONS(2661),
    [anon_sym_try] = ACTIONS(2252),
    [anon_sym_match] = ACTIONS(2252),
    [anon_sym_match_BANG] = ACTIONS(2254),
    [anon_sym_function] = ACTIONS(2252),
    [anon_sym_LT_DASH] = ACTIONS(2252),
    [anon_sym_DOT_LBRACK] = ACTIONS(2254),
    [anon_sym_LT] = ACTIONS(2254),
    [anon_sym_use] = ACTIONS(2252),
    [anon_sym_use_BANG] = ACTIONS(2254),
    [anon_sym_do_BANG] = ACTIONS(2254),
    [anon_sym_begin] = ACTIONS(2252),
    [anon_sym_LPAREN2] = ACTIONS(2252),
    [anon_sym_DOT_DOT2] = ACTIONS(2254),
    [anon_sym_STAR] = ACTIONS(2663),
    [anon_sym_LT2] = ACTIONS(2665),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2667),
    [anon_sym_or] = ACTIONS(2252),
    [aux_sym_char_token1] = ACTIONS(2254),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2252),
    [anon_sym_DQUOTE] = ACTIONS(2252),
    [anon_sym_AT_DQUOTE] = ACTIONS(2254),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2254),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2254),
    [sym_bool] = ACTIONS(2252),
    [sym_unit] = ACTIONS(2254),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2252),
    [sym_op_identifier] = ACTIONS(2252),
    [anon_sym_PLUS] = ACTIONS(2252),
    [anon_sym_DASH] = ACTIONS(2252),
    [anon_sym_PLUS_DOT] = ACTIONS(2252),
    [anon_sym_DASH_DOT] = ACTIONS(2252),
    [anon_sym_PERCENT] = ACTIONS(2252),
    [anon_sym_AMP_AMP] = ACTIONS(2252),
    [anon_sym_TILDE] = ACTIONS(2254),
    [aux_sym_prefix_op_token1] = ACTIONS(2252),
    [aux_sym_infix_op_token1] = ACTIONS(2254),
    [aux_sym_infix_op_token2] = ACTIONS(2252),
    [anon_sym_PIPE_PIPE] = ACTIONS(2252),
    [anon_sym_BANG_EQ] = ACTIONS(2252),
    [anon_sym_COLON_EQ] = ACTIONS(2254),
    [anon_sym_DOLLAR] = ACTIONS(2252),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2252),
    [sym_int] = ACTIONS(2252),
    [sym_xint] = ACTIONS(2254),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2254),
    [sym__newline] = ACTIONS(2254),
  },
  [813] = {
    [sym_type_arguments] = STATE(920),
    [sym_long_identifier] = STATE(923),
    [sym_block_comment] = STATE(813),
    [sym_compiler_directive_decl] = STATE(813),
    [sym_fsi_directive_decl] = STATE(813),
    [sym_preproc_line] = STATE(813),
    [aux_sym_compound_type_repeat1] = STATE(848),
    [sym_identifier] = ACTIONS(2659),
    [anon_sym_EQ] = ACTIONS(2248),
    [anon_sym_GT_RBRACK] = ACTIONS(2248),
    [anon_sym_COLON] = ACTIONS(2250),
    [anon_sym_return] = ACTIONS(2250),
    [anon_sym_do] = ACTIONS(2250),
    [anon_sym_let] = ACTIONS(2250),
    [anon_sym_let_BANG] = ACTIONS(2248),
    [anon_sym_LPAREN] = ACTIONS(2250),
    [anon_sym_COMMA] = ACTIONS(2248),
    [anon_sym_null] = ACTIONS(2250),
    [anon_sym_QMARK] = ACTIONS(2250),
    [anon_sym_COLON_QMARK] = ACTIONS(2250),
    [anon_sym_COLON_COLON] = ACTIONS(2248),
    [anon_sym_AMP] = ACTIONS(2250),
    [anon_sym_LBRACK] = ACTIONS(2250),
    [anon_sym_RBRACK] = ACTIONS(2248),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2248),
    [anon_sym_LBRACE] = ACTIONS(2250),
    [anon_sym_RBRACE] = ACTIONS(2248),
    [anon_sym_LT_AT] = ACTIONS(2250),
    [anon_sym_LT_AT_AT] = ACTIONS(2250),
    [anon_sym_DOT] = ACTIONS(2250),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2248),
    [anon_sym_new] = ACTIONS(2250),
    [anon_sym_with] = ACTIONS(2250),
    [anon_sym_return_BANG] = ACTIONS(2248),
    [anon_sym_yield] = ACTIONS(2250),
    [anon_sym_yield_BANG] = ACTIONS(2248),
    [anon_sym_lazy] = ACTIONS(2250),
    [anon_sym_assert] = ACTIONS(2250),
    [anon_sym_upcast] = ACTIONS(2250),
    [anon_sym_downcast] = ACTIONS(2250),
    [anon_sym_COLON_GT] = ACTIONS(2248),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2248),
    [anon_sym_for] = ACTIONS(2250),
    [anon_sym_to] = ACTIONS(2250),
    [anon_sym_downto] = ACTIONS(2250),
    [anon_sym_while] = ACTIONS(2250),
    [anon_sym_if] = ACTIONS(2250),
    [anon_sym_fun] = ACTIONS(2250),
    [anon_sym_DASH_GT] = ACTIONS(2661),
    [anon_sym_try] = ACTIONS(2250),
    [anon_sym_match] = ACTIONS(2250),
    [anon_sym_match_BANG] = ACTIONS(2248),
    [anon_sym_function] = ACTIONS(2250),
    [anon_sym_LT_DASH] = ACTIONS(2250),
    [anon_sym_DOT_LBRACK] = ACTIONS(2248),
    [anon_sym_LT] = ACTIONS(2248),
    [anon_sym_use] = ACTIONS(2250),
    [anon_sym_use_BANG] = ACTIONS(2248),
    [anon_sym_do_BANG] = ACTIONS(2248),
    [anon_sym_begin] = ACTIONS(2250),
    [anon_sym_LPAREN2] = ACTIONS(2250),
    [anon_sym_DOT_DOT2] = ACTIONS(2248),
    [anon_sym_STAR] = ACTIONS(2663),
    [anon_sym_LT2] = ACTIONS(2665),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2667),
    [anon_sym_or] = ACTIONS(2250),
    [aux_sym_char_token1] = ACTIONS(2248),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2250),
    [anon_sym_DQUOTE] = ACTIONS(2250),
    [anon_sym_AT_DQUOTE] = ACTIONS(2248),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2248),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2248),
    [sym_bool] = ACTIONS(2250),
    [sym_unit] = ACTIONS(2248),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2250),
    [sym_op_identifier] = ACTIONS(2250),
    [anon_sym_PLUS] = ACTIONS(2250),
    [anon_sym_DASH] = ACTIONS(2250),
    [anon_sym_PLUS_DOT] = ACTIONS(2250),
    [anon_sym_DASH_DOT] = ACTIONS(2250),
    [anon_sym_PERCENT] = ACTIONS(2250),
    [anon_sym_AMP_AMP] = ACTIONS(2250),
    [anon_sym_TILDE] = ACTIONS(2248),
    [aux_sym_prefix_op_token1] = ACTIONS(2250),
    [aux_sym_infix_op_token1] = ACTIONS(2248),
    [aux_sym_infix_op_token2] = ACTIONS(2250),
    [anon_sym_PIPE_PIPE] = ACTIONS(2250),
    [anon_sym_BANG_EQ] = ACTIONS(2250),
    [anon_sym_COLON_EQ] = ACTIONS(2248),
    [anon_sym_DOLLAR] = ACTIONS(2250),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2250),
    [sym_int] = ACTIONS(2250),
    [sym_xint] = ACTIONS(2248),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2248),
    [sym__newline] = ACTIONS(2248),
  },
  [814] = {
    [sym_block_comment] = STATE(814),
    [sym_compiler_directive_decl] = STATE(814),
    [sym_fsi_directive_decl] = STATE(814),
    [sym_preproc_line] = STATE(814),
    [sym_identifier] = ACTIONS(2158),
    [anon_sym_EQ] = ACTIONS(2160),
    [anon_sym_COLON] = ACTIONS(2158),
    [anon_sym_return] = ACTIONS(2158),
    [anon_sym_do] = ACTIONS(2158),
    [anon_sym_let] = ACTIONS(2158),
    [anon_sym_let_BANG] = ACTIONS(2160),
    [anon_sym_as] = ACTIONS(2158),
    [anon_sym_LPAREN] = ACTIONS(2158),
    [anon_sym_COMMA] = ACTIONS(2160),
    [anon_sym_null] = ACTIONS(2158),
    [anon_sym_QMARK] = ACTIONS(2158),
    [anon_sym_COLON_QMARK] = ACTIONS(2158),
    [anon_sym_COLON_COLON] = ACTIONS(2160),
    [anon_sym_AMP] = ACTIONS(2158),
    [anon_sym_LBRACK] = ACTIONS(2158),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2160),
    [anon_sym_LBRACE] = ACTIONS(2158),
    [anon_sym_LT_AT] = ACTIONS(2158),
    [anon_sym_LT_AT_AT] = ACTIONS(2158),
    [anon_sym_DOT] = ACTIONS(2158),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2160),
    [anon_sym_new] = ACTIONS(2158),
    [anon_sym_with] = ACTIONS(2158),
    [anon_sym_return_BANG] = ACTIONS(2160),
    [anon_sym_yield] = ACTIONS(2158),
    [anon_sym_yield_BANG] = ACTIONS(2160),
    [anon_sym_lazy] = ACTIONS(2158),
    [anon_sym_assert] = ACTIONS(2158),
    [anon_sym_upcast] = ACTIONS(2158),
    [anon_sym_downcast] = ACTIONS(2158),
    [anon_sym_COLON_GT] = ACTIONS(2160),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2160),
    [anon_sym_for] = ACTIONS(2158),
    [anon_sym_while] = ACTIONS(2158),
    [anon_sym_if] = ACTIONS(2158),
    [anon_sym_fun] = ACTIONS(2158),
    [anon_sym_try] = ACTIONS(2158),
    [anon_sym_match] = ACTIONS(2158),
    [anon_sym_match_BANG] = ACTIONS(2160),
    [anon_sym_function] = ACTIONS(2158),
    [anon_sym_LT_DASH] = ACTIONS(2158),
    [anon_sym_DOT_LBRACK] = ACTIONS(2160),
    [anon_sym_LT] = ACTIONS(2160),
    [anon_sym_use] = ACTIONS(2158),
    [anon_sym_use_BANG] = ACTIONS(2160),
    [anon_sym_do_BANG] = ACTIONS(2160),
    [anon_sym_begin] = ACTIONS(2158),
    [anon_sym_LPAREN2] = ACTIONS(2158),
    [anon_sym_or] = ACTIONS(2158),
    [aux_sym_char_token1] = ACTIONS(2160),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2158),
    [anon_sym_DQUOTE] = ACTIONS(2158),
    [anon_sym_AT_DQUOTE] = ACTIONS(2160),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2160),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2160),
    [sym_bool] = ACTIONS(2158),
    [sym_unit] = ACTIONS(2160),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2158),
    [sym_op_identifier] = ACTIONS(2158),
    [anon_sym_PLUS] = ACTIONS(2158),
    [anon_sym_DASH] = ACTIONS(2158),
    [anon_sym_PLUS_DOT] = ACTIONS(2158),
    [anon_sym_DASH_DOT] = ACTIONS(2158),
    [anon_sym_PERCENT] = ACTIONS(2158),
    [anon_sym_AMP_AMP] = ACTIONS(2158),
    [anon_sym_TILDE] = ACTIONS(2160),
    [aux_sym_prefix_op_token1] = ACTIONS(2158),
    [aux_sym_infix_op_token1] = ACTIONS(2160),
    [aux_sym_infix_op_token2] = ACTIONS(2158),
    [anon_sym_PIPE_PIPE] = ACTIONS(2158),
    [anon_sym_BANG_EQ] = ACTIONS(2158),
    [anon_sym_COLON_EQ] = ACTIONS(2160),
    [anon_sym_DOLLAR] = ACTIONS(2158),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2158),
    [sym_int] = ACTIONS(2158),
    [sym_xint] = ACTIONS(2160),
    [anon_sym_y] = ACTIONS(2426),
    [anon_sym_uy] = ACTIONS(2428),
    [anon_sym_s] = ACTIONS(2430),
    [anon_sym_us] = ACTIONS(2432),
    [anon_sym_l] = ACTIONS(2434),
    [aux_sym_uint32_token1] = ACTIONS(2436),
    [anon_sym_n] = ACTIONS(2438),
    [anon_sym_un] = ACTIONS(2440),
    [anon_sym_L] = ACTIONS(2442),
    [aux_sym_uint64_token1] = ACTIONS(2444),
    [anon_sym_lf] = ACTIONS(2669),
    [anon_sym_LF] = ACTIONS(2671),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2160),
    [sym__newline] = ACTIONS(2160),
  },
  [815] = {
    [sym_type_arguments] = STATE(920),
    [sym_long_identifier] = STATE(923),
    [sym_block_comment] = STATE(815),
    [sym_compiler_directive_decl] = STATE(815),
    [sym_fsi_directive_decl] = STATE(815),
    [sym_preproc_line] = STATE(815),
    [aux_sym_compound_type_repeat1] = STATE(848),
    [sym_identifier] = ACTIONS(2659),
    [anon_sym_EQ] = ACTIONS(2228),
    [anon_sym_GT_RBRACK] = ACTIONS(2228),
    [anon_sym_COLON] = ACTIONS(2230),
    [anon_sym_return] = ACTIONS(2230),
    [anon_sym_do] = ACTIONS(2230),
    [anon_sym_let] = ACTIONS(2230),
    [anon_sym_let_BANG] = ACTIONS(2228),
    [anon_sym_LPAREN] = ACTIONS(2230),
    [anon_sym_COMMA] = ACTIONS(2228),
    [anon_sym_null] = ACTIONS(2230),
    [anon_sym_QMARK] = ACTIONS(2230),
    [anon_sym_COLON_QMARK] = ACTIONS(2230),
    [anon_sym_COLON_COLON] = ACTIONS(2228),
    [anon_sym_AMP] = ACTIONS(2230),
    [anon_sym_LBRACK] = ACTIONS(2230),
    [anon_sym_RBRACK] = ACTIONS(2228),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2228),
    [anon_sym_LBRACE] = ACTIONS(2230),
    [anon_sym_RBRACE] = ACTIONS(2228),
    [anon_sym_LT_AT] = ACTIONS(2230),
    [anon_sym_LT_AT_AT] = ACTIONS(2230),
    [anon_sym_DOT] = ACTIONS(2230),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2228),
    [anon_sym_new] = ACTIONS(2230),
    [anon_sym_with] = ACTIONS(2230),
    [anon_sym_return_BANG] = ACTIONS(2228),
    [anon_sym_yield] = ACTIONS(2230),
    [anon_sym_yield_BANG] = ACTIONS(2228),
    [anon_sym_lazy] = ACTIONS(2230),
    [anon_sym_assert] = ACTIONS(2230),
    [anon_sym_upcast] = ACTIONS(2230),
    [anon_sym_downcast] = ACTIONS(2230),
    [anon_sym_COLON_GT] = ACTIONS(2228),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2228),
    [anon_sym_for] = ACTIONS(2230),
    [anon_sym_to] = ACTIONS(2230),
    [anon_sym_downto] = ACTIONS(2230),
    [anon_sym_while] = ACTIONS(2230),
    [anon_sym_if] = ACTIONS(2230),
    [anon_sym_fun] = ACTIONS(2230),
    [anon_sym_DASH_GT] = ACTIONS(2661),
    [anon_sym_try] = ACTIONS(2230),
    [anon_sym_match] = ACTIONS(2230),
    [anon_sym_match_BANG] = ACTIONS(2228),
    [anon_sym_function] = ACTIONS(2230),
    [anon_sym_LT_DASH] = ACTIONS(2230),
    [anon_sym_DOT_LBRACK] = ACTIONS(2228),
    [anon_sym_LT] = ACTIONS(2228),
    [anon_sym_use] = ACTIONS(2230),
    [anon_sym_use_BANG] = ACTIONS(2228),
    [anon_sym_do_BANG] = ACTIONS(2228),
    [anon_sym_begin] = ACTIONS(2230),
    [anon_sym_LPAREN2] = ACTIONS(2230),
    [anon_sym_DOT_DOT2] = ACTIONS(2228),
    [anon_sym_STAR] = ACTIONS(2663),
    [anon_sym_LT2] = ACTIONS(2665),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2667),
    [anon_sym_or] = ACTIONS(2230),
    [aux_sym_char_token1] = ACTIONS(2228),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2230),
    [anon_sym_DQUOTE] = ACTIONS(2230),
    [anon_sym_AT_DQUOTE] = ACTIONS(2228),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2228),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2228),
    [sym_bool] = ACTIONS(2230),
    [sym_unit] = ACTIONS(2228),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2230),
    [sym_op_identifier] = ACTIONS(2230),
    [anon_sym_PLUS] = ACTIONS(2230),
    [anon_sym_DASH] = ACTIONS(2230),
    [anon_sym_PLUS_DOT] = ACTIONS(2230),
    [anon_sym_DASH_DOT] = ACTIONS(2230),
    [anon_sym_PERCENT] = ACTIONS(2230),
    [anon_sym_AMP_AMP] = ACTIONS(2230),
    [anon_sym_TILDE] = ACTIONS(2228),
    [aux_sym_prefix_op_token1] = ACTIONS(2230),
    [aux_sym_infix_op_token1] = ACTIONS(2228),
    [aux_sym_infix_op_token2] = ACTIONS(2230),
    [anon_sym_PIPE_PIPE] = ACTIONS(2230),
    [anon_sym_BANG_EQ] = ACTIONS(2230),
    [anon_sym_COLON_EQ] = ACTIONS(2228),
    [anon_sym_DOLLAR] = ACTIONS(2230),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2230),
    [sym_int] = ACTIONS(2230),
    [sym_xint] = ACTIONS(2228),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2228),
    [sym__newline] = ACTIONS(2228),
  },
  [816] = {
    [sym_type_arguments] = STATE(920),
    [sym_long_identifier] = STATE(923),
    [sym_block_comment] = STATE(816),
    [sym_compiler_directive_decl] = STATE(816),
    [sym_fsi_directive_decl] = STATE(816),
    [sym_preproc_line] = STATE(816),
    [aux_sym_compound_type_repeat1] = STATE(848),
    [sym_identifier] = ACTIONS(2659),
    [anon_sym_EQ] = ACTIONS(2244),
    [anon_sym_GT_RBRACK] = ACTIONS(2244),
    [anon_sym_COLON] = ACTIONS(2246),
    [anon_sym_return] = ACTIONS(2246),
    [anon_sym_do] = ACTIONS(2246),
    [anon_sym_let] = ACTIONS(2246),
    [anon_sym_let_BANG] = ACTIONS(2244),
    [anon_sym_LPAREN] = ACTIONS(2246),
    [anon_sym_COMMA] = ACTIONS(2244),
    [anon_sym_null] = ACTIONS(2246),
    [anon_sym_QMARK] = ACTIONS(2246),
    [anon_sym_COLON_QMARK] = ACTIONS(2246),
    [anon_sym_COLON_COLON] = ACTIONS(2244),
    [anon_sym_AMP] = ACTIONS(2246),
    [anon_sym_LBRACK] = ACTIONS(2246),
    [anon_sym_RBRACK] = ACTIONS(2244),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2244),
    [anon_sym_LBRACE] = ACTIONS(2246),
    [anon_sym_RBRACE] = ACTIONS(2244),
    [anon_sym_LT_AT] = ACTIONS(2246),
    [anon_sym_LT_AT_AT] = ACTIONS(2246),
    [anon_sym_DOT] = ACTIONS(2246),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2244),
    [anon_sym_new] = ACTIONS(2246),
    [anon_sym_with] = ACTIONS(2246),
    [anon_sym_return_BANG] = ACTIONS(2244),
    [anon_sym_yield] = ACTIONS(2246),
    [anon_sym_yield_BANG] = ACTIONS(2244),
    [anon_sym_lazy] = ACTIONS(2246),
    [anon_sym_assert] = ACTIONS(2246),
    [anon_sym_upcast] = ACTIONS(2246),
    [anon_sym_downcast] = ACTIONS(2246),
    [anon_sym_COLON_GT] = ACTIONS(2244),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2244),
    [anon_sym_for] = ACTIONS(2246),
    [anon_sym_to] = ACTIONS(2246),
    [anon_sym_downto] = ACTIONS(2246),
    [anon_sym_while] = ACTIONS(2246),
    [anon_sym_if] = ACTIONS(2246),
    [anon_sym_fun] = ACTIONS(2246),
    [anon_sym_DASH_GT] = ACTIONS(2661),
    [anon_sym_try] = ACTIONS(2246),
    [anon_sym_match] = ACTIONS(2246),
    [anon_sym_match_BANG] = ACTIONS(2244),
    [anon_sym_function] = ACTIONS(2246),
    [anon_sym_LT_DASH] = ACTIONS(2246),
    [anon_sym_DOT_LBRACK] = ACTIONS(2244),
    [anon_sym_LT] = ACTIONS(2244),
    [anon_sym_use] = ACTIONS(2246),
    [anon_sym_use_BANG] = ACTIONS(2244),
    [anon_sym_do_BANG] = ACTIONS(2244),
    [anon_sym_begin] = ACTIONS(2246),
    [anon_sym_LPAREN2] = ACTIONS(2246),
    [anon_sym_DOT_DOT2] = ACTIONS(2244),
    [anon_sym_STAR] = ACTIONS(2663),
    [anon_sym_LT2] = ACTIONS(2665),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2667),
    [anon_sym_or] = ACTIONS(2246),
    [aux_sym_char_token1] = ACTIONS(2244),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2246),
    [anon_sym_DQUOTE] = ACTIONS(2246),
    [anon_sym_AT_DQUOTE] = ACTIONS(2244),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2244),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2244),
    [sym_bool] = ACTIONS(2246),
    [sym_unit] = ACTIONS(2244),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2246),
    [sym_op_identifier] = ACTIONS(2246),
    [anon_sym_PLUS] = ACTIONS(2246),
    [anon_sym_DASH] = ACTIONS(2246),
    [anon_sym_PLUS_DOT] = ACTIONS(2246),
    [anon_sym_DASH_DOT] = ACTIONS(2246),
    [anon_sym_PERCENT] = ACTIONS(2246),
    [anon_sym_AMP_AMP] = ACTIONS(2246),
    [anon_sym_TILDE] = ACTIONS(2244),
    [aux_sym_prefix_op_token1] = ACTIONS(2246),
    [aux_sym_infix_op_token1] = ACTIONS(2244),
    [aux_sym_infix_op_token2] = ACTIONS(2246),
    [anon_sym_PIPE_PIPE] = ACTIONS(2246),
    [anon_sym_BANG_EQ] = ACTIONS(2246),
    [anon_sym_COLON_EQ] = ACTIONS(2244),
    [anon_sym_DOLLAR] = ACTIONS(2246),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2246),
    [sym_int] = ACTIONS(2246),
    [sym_xint] = ACTIONS(2244),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2244),
    [sym__newline] = ACTIONS(2244),
  },
  [817] = {
    [sym_block_comment] = STATE(817),
    [sym_compiler_directive_decl] = STATE(817),
    [sym_fsi_directive_decl] = STATE(817),
    [sym_preproc_line] = STATE(817),
    [sym_identifier] = ACTIONS(2158),
    [anon_sym_EQ] = ACTIONS(2160),
    [anon_sym_COLON] = ACTIONS(2158),
    [anon_sym_return] = ACTIONS(2158),
    [anon_sym_do] = ACTIONS(2158),
    [anon_sym_let] = ACTIONS(2158),
    [anon_sym_let_BANG] = ACTIONS(2160),
    [anon_sym_LPAREN] = ACTIONS(2158),
    [anon_sym_COMMA] = ACTIONS(2160),
    [anon_sym_null] = ACTIONS(2158),
    [anon_sym_QMARK] = ACTIONS(2158),
    [anon_sym_COLON_QMARK] = ACTIONS(2158),
    [anon_sym_COLON_COLON] = ACTIONS(2160),
    [anon_sym_AMP] = ACTIONS(2158),
    [anon_sym_LBRACK] = ACTIONS(2158),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2160),
    [anon_sym_LBRACE] = ACTIONS(2158),
    [anon_sym_LT_AT] = ACTIONS(2158),
    [anon_sym_LT_AT_AT] = ACTIONS(2158),
    [anon_sym_DOT] = ACTIONS(2158),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2160),
    [anon_sym_new] = ACTIONS(2158),
    [anon_sym_return_BANG] = ACTIONS(2160),
    [anon_sym_yield] = ACTIONS(2158),
    [anon_sym_yield_BANG] = ACTIONS(2160),
    [anon_sym_lazy] = ACTIONS(2158),
    [anon_sym_assert] = ACTIONS(2158),
    [anon_sym_upcast] = ACTIONS(2158),
    [anon_sym_downcast] = ACTIONS(2158),
    [anon_sym_COLON_GT] = ACTIONS(2160),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2160),
    [anon_sym_for] = ACTIONS(2158),
    [anon_sym_while] = ACTIONS(2158),
    [anon_sym_if] = ACTIONS(2158),
    [anon_sym_fun] = ACTIONS(2158),
    [anon_sym_try] = ACTIONS(2158),
    [anon_sym_match] = ACTIONS(2158),
    [anon_sym_match_BANG] = ACTIONS(2160),
    [anon_sym_function] = ACTIONS(2158),
    [anon_sym_LT_DASH] = ACTIONS(2158),
    [anon_sym_DOT_LBRACK] = ACTIONS(2160),
    [anon_sym_LT] = ACTIONS(2160),
    [anon_sym_use] = ACTIONS(2158),
    [anon_sym_use_BANG] = ACTIONS(2160),
    [anon_sym_do_BANG] = ACTIONS(2160),
    [anon_sym_begin] = ACTIONS(2158),
    [anon_sym_LPAREN2] = ACTIONS(2158),
    [anon_sym_or] = ACTIONS(2158),
    [aux_sym_char_token1] = ACTIONS(2160),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2158),
    [anon_sym_DQUOTE] = ACTIONS(2158),
    [anon_sym_AT_DQUOTE] = ACTIONS(2160),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2160),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2160),
    [sym_bool] = ACTIONS(2158),
    [sym_unit] = ACTIONS(2160),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2158),
    [sym_op_identifier] = ACTIONS(2158),
    [anon_sym_PLUS] = ACTIONS(2158),
    [anon_sym_DASH] = ACTIONS(2158),
    [anon_sym_PLUS_DOT] = ACTIONS(2158),
    [anon_sym_DASH_DOT] = ACTIONS(2158),
    [anon_sym_PERCENT] = ACTIONS(2158),
    [anon_sym_AMP_AMP] = ACTIONS(2158),
    [anon_sym_TILDE] = ACTIONS(2160),
    [aux_sym_prefix_op_token1] = ACTIONS(2158),
    [aux_sym_infix_op_token1] = ACTIONS(2160),
    [aux_sym_infix_op_token2] = ACTIONS(2158),
    [anon_sym_PIPE_PIPE] = ACTIONS(2158),
    [anon_sym_BANG_EQ] = ACTIONS(2158),
    [anon_sym_COLON_EQ] = ACTIONS(2160),
    [anon_sym_DOLLAR] = ACTIONS(2158),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2158),
    [sym_int] = ACTIONS(2158),
    [sym_xint] = ACTIONS(2160),
    [anon_sym_y] = ACTIONS(2375),
    [anon_sym_uy] = ACTIONS(2377),
    [anon_sym_s] = ACTIONS(2379),
    [anon_sym_us] = ACTIONS(2381),
    [anon_sym_l] = ACTIONS(2383),
    [aux_sym_uint32_token1] = ACTIONS(2385),
    [anon_sym_n] = ACTIONS(2387),
    [anon_sym_un] = ACTIONS(2389),
    [anon_sym_L] = ACTIONS(2391),
    [aux_sym_uint64_token1] = ACTIONS(2393),
    [anon_sym_lf] = ACTIONS(2673),
    [anon_sym_LF] = ACTIONS(2675),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2160),
    [anon_sym_POUNDendif] = ACTIONS(2160),
    [anon_sym_POUNDelse] = ACTIONS(2160),
    [sym__newline] = ACTIONS(2160),
  },
  [818] = {
    [sym_block_comment] = STATE(818),
    [sym_compiler_directive_decl] = STATE(818),
    [sym_fsi_directive_decl] = STATE(818),
    [sym_preproc_line] = STATE(818),
    [sym_identifier] = ACTIONS(2158),
    [anon_sym_EQ] = ACTIONS(2160),
    [anon_sym_COLON] = ACTIONS(2158),
    [anon_sym_return] = ACTIONS(2158),
    [anon_sym_do] = ACTIONS(2158),
    [anon_sym_let] = ACTIONS(2158),
    [anon_sym_let_BANG] = ACTIONS(2160),
    [anon_sym_LPAREN] = ACTIONS(2158),
    [anon_sym_COMMA] = ACTIONS(2160),
    [anon_sym_null] = ACTIONS(2158),
    [anon_sym_QMARK] = ACTIONS(2158),
    [anon_sym_COLON_QMARK] = ACTIONS(2158),
    [anon_sym_COLON_COLON] = ACTIONS(2160),
    [anon_sym_AMP] = ACTIONS(2158),
    [anon_sym_LBRACK] = ACTIONS(2158),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2160),
    [anon_sym_LBRACE] = ACTIONS(2158),
    [anon_sym_LT_AT] = ACTIONS(2158),
    [anon_sym_LT_AT_AT] = ACTIONS(2158),
    [anon_sym_DOT] = ACTIONS(2158),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2160),
    [anon_sym_new] = ACTIONS(2158),
    [anon_sym_return_BANG] = ACTIONS(2160),
    [anon_sym_yield] = ACTIONS(2158),
    [anon_sym_yield_BANG] = ACTIONS(2160),
    [anon_sym_lazy] = ACTIONS(2158),
    [anon_sym_assert] = ACTIONS(2158),
    [anon_sym_upcast] = ACTIONS(2158),
    [anon_sym_downcast] = ACTIONS(2158),
    [anon_sym_COLON_GT] = ACTIONS(2160),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2160),
    [anon_sym_for] = ACTIONS(2158),
    [anon_sym_while] = ACTIONS(2158),
    [anon_sym_if] = ACTIONS(2158),
    [anon_sym_fun] = ACTIONS(2158),
    [anon_sym_DASH_GT] = ACTIONS(2158),
    [anon_sym_try] = ACTIONS(2158),
    [anon_sym_match] = ACTIONS(2158),
    [anon_sym_match_BANG] = ACTIONS(2160),
    [anon_sym_function] = ACTIONS(2158),
    [anon_sym_LT_DASH] = ACTIONS(2158),
    [anon_sym_DOT_LBRACK] = ACTIONS(2160),
    [anon_sym_LT] = ACTIONS(2160),
    [anon_sym_use] = ACTIONS(2158),
    [anon_sym_use_BANG] = ACTIONS(2160),
    [anon_sym_do_BANG] = ACTIONS(2160),
    [anon_sym_DOT_DOT] = ACTIONS(2160),
    [anon_sym_begin] = ACTIONS(2158),
    [anon_sym_LPAREN2] = ACTIONS(2158),
    [anon_sym_or] = ACTIONS(2158),
    [aux_sym_char_token1] = ACTIONS(2160),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2158),
    [anon_sym_DQUOTE] = ACTIONS(2158),
    [anon_sym_AT_DQUOTE] = ACTIONS(2160),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2160),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2160),
    [sym_bool] = ACTIONS(2158),
    [sym_unit] = ACTIONS(2160),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2158),
    [sym_op_identifier] = ACTIONS(2158),
    [anon_sym_PLUS] = ACTIONS(2158),
    [anon_sym_DASH] = ACTIONS(2158),
    [anon_sym_PLUS_DOT] = ACTIONS(2158),
    [anon_sym_DASH_DOT] = ACTIONS(2158),
    [anon_sym_PERCENT] = ACTIONS(2158),
    [anon_sym_AMP_AMP] = ACTIONS(2158),
    [anon_sym_TILDE] = ACTIONS(2160),
    [aux_sym_prefix_op_token1] = ACTIONS(2158),
    [aux_sym_infix_op_token1] = ACTIONS(2160),
    [aux_sym_infix_op_token2] = ACTIONS(2158),
    [anon_sym_PIPE_PIPE] = ACTIONS(2158),
    [anon_sym_BANG_EQ] = ACTIONS(2158),
    [anon_sym_COLON_EQ] = ACTIONS(2160),
    [anon_sym_DOLLAR] = ACTIONS(2158),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2158),
    [sym_int] = ACTIONS(2158),
    [sym_xint] = ACTIONS(2160),
    [anon_sym_y] = ACTIONS(2284),
    [anon_sym_uy] = ACTIONS(2286),
    [anon_sym_s] = ACTIONS(2288),
    [anon_sym_us] = ACTIONS(2290),
    [anon_sym_l] = ACTIONS(2292),
    [aux_sym_uint32_token1] = ACTIONS(2294),
    [anon_sym_n] = ACTIONS(2296),
    [anon_sym_un] = ACTIONS(2298),
    [anon_sym_L] = ACTIONS(2300),
    [aux_sym_uint64_token1] = ACTIONS(2302),
    [anon_sym_lf] = ACTIONS(2677),
    [anon_sym_LF] = ACTIONS(2679),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2160),
    [sym__newline] = ACTIONS(2160),
  },
  [819] = {
    [sym_block_comment] = STATE(819),
    [sym_compiler_directive_decl] = STATE(819),
    [sym_fsi_directive_decl] = STATE(819),
    [sym_preproc_line] = STATE(819),
    [sym_identifier] = ACTIONS(2158),
    [anon_sym_EQ] = ACTIONS(2160),
    [anon_sym_COLON] = ACTIONS(2158),
    [anon_sym_return] = ACTIONS(2158),
    [anon_sym_do] = ACTIONS(2158),
    [anon_sym_and] = ACTIONS(2158),
    [anon_sym_let] = ACTIONS(2158),
    [anon_sym_let_BANG] = ACTIONS(2160),
    [anon_sym_LPAREN] = ACTIONS(2158),
    [anon_sym_COMMA] = ACTIONS(2160),
    [anon_sym_null] = ACTIONS(2158),
    [anon_sym_QMARK] = ACTIONS(2158),
    [anon_sym_COLON_QMARK] = ACTIONS(2158),
    [anon_sym_COLON_COLON] = ACTIONS(2160),
    [anon_sym_AMP] = ACTIONS(2158),
    [anon_sym_LBRACK] = ACTIONS(2158),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2160),
    [anon_sym_LBRACE] = ACTIONS(2158),
    [anon_sym_LT_AT] = ACTIONS(2158),
    [anon_sym_LT_AT_AT] = ACTIONS(2158),
    [anon_sym_DOT] = ACTIONS(2158),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2160),
    [anon_sym_new] = ACTIONS(2158),
    [anon_sym_return_BANG] = ACTIONS(2160),
    [anon_sym_yield] = ACTIONS(2158),
    [anon_sym_yield_BANG] = ACTIONS(2160),
    [anon_sym_lazy] = ACTIONS(2158),
    [anon_sym_assert] = ACTIONS(2158),
    [anon_sym_upcast] = ACTIONS(2158),
    [anon_sym_downcast] = ACTIONS(2158),
    [anon_sym_COLON_GT] = ACTIONS(2160),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2160),
    [anon_sym_for] = ACTIONS(2158),
    [anon_sym_while] = ACTIONS(2158),
    [anon_sym_if] = ACTIONS(2158),
    [anon_sym_fun] = ACTIONS(2158),
    [anon_sym_try] = ACTIONS(2158),
    [anon_sym_match] = ACTIONS(2158),
    [anon_sym_match_BANG] = ACTIONS(2160),
    [anon_sym_function] = ACTIONS(2158),
    [anon_sym_LT_DASH] = ACTIONS(2158),
    [anon_sym_DOT_LBRACK] = ACTIONS(2160),
    [anon_sym_LT] = ACTIONS(2160),
    [anon_sym_use] = ACTIONS(2158),
    [anon_sym_use_BANG] = ACTIONS(2160),
    [anon_sym_do_BANG] = ACTIONS(2160),
    [anon_sym_begin] = ACTIONS(2158),
    [anon_sym_LPAREN2] = ACTIONS(2158),
    [anon_sym_or] = ACTIONS(2158),
    [aux_sym_char_token1] = ACTIONS(2160),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2158),
    [anon_sym_DQUOTE] = ACTIONS(2158),
    [anon_sym_AT_DQUOTE] = ACTIONS(2160),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2160),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2160),
    [sym_bool] = ACTIONS(2158),
    [sym_unit] = ACTIONS(2160),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2158),
    [sym_op_identifier] = ACTIONS(2158),
    [anon_sym_PLUS] = ACTIONS(2158),
    [anon_sym_DASH] = ACTIONS(2158),
    [anon_sym_PLUS_DOT] = ACTIONS(2158),
    [anon_sym_DASH_DOT] = ACTIONS(2158),
    [anon_sym_PERCENT] = ACTIONS(2158),
    [anon_sym_AMP_AMP] = ACTIONS(2158),
    [anon_sym_TILDE] = ACTIONS(2160),
    [aux_sym_prefix_op_token1] = ACTIONS(2158),
    [aux_sym_infix_op_token1] = ACTIONS(2160),
    [aux_sym_infix_op_token2] = ACTIONS(2158),
    [anon_sym_PIPE_PIPE] = ACTIONS(2158),
    [anon_sym_BANG_EQ] = ACTIONS(2158),
    [anon_sym_COLON_EQ] = ACTIONS(2160),
    [anon_sym_DOLLAR] = ACTIONS(2158),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2158),
    [sym_int] = ACTIONS(2158),
    [sym_xint] = ACTIONS(2160),
    [anon_sym_y] = ACTIONS(2347),
    [anon_sym_uy] = ACTIONS(2349),
    [anon_sym_s] = ACTIONS(2351),
    [anon_sym_us] = ACTIONS(2353),
    [anon_sym_l] = ACTIONS(2355),
    [aux_sym_uint32_token1] = ACTIONS(2357),
    [anon_sym_n] = ACTIONS(2359),
    [anon_sym_un] = ACTIONS(2361),
    [anon_sym_L] = ACTIONS(2363),
    [aux_sym_uint64_token1] = ACTIONS(2365),
    [anon_sym_lf] = ACTIONS(2681),
    [anon_sym_LF] = ACTIONS(2683),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2160),
    [sym__newline] = ACTIONS(2160),
    [sym__dedent] = ACTIONS(2160),
  },
  [820] = {
    [sym_block_comment] = STATE(820),
    [sym_compiler_directive_decl] = STATE(820),
    [sym_fsi_directive_decl] = STATE(820),
    [sym_preproc_line] = STATE(820),
    [sym_identifier] = ACTIONS(2685),
    [anon_sym_EQ] = ACTIONS(2687),
    [anon_sym_LBRACK_LT] = ACTIONS(2687),
    [anon_sym_COLON] = ACTIONS(2685),
    [anon_sym_return] = ACTIONS(2685),
    [anon_sym_do] = ACTIONS(2685),
    [anon_sym_let] = ACTIONS(2685),
    [anon_sym_let_BANG] = ACTIONS(2687),
    [aux_sym_access_modifier_token1] = ACTIONS(2687),
    [anon_sym_LPAREN] = ACTIONS(2685),
    [anon_sym_COMMA] = ACTIONS(2687),
    [anon_sym_null] = ACTIONS(2685),
    [anon_sym_QMARK] = ACTIONS(2685),
    [anon_sym_COLON_QMARK] = ACTIONS(2685),
    [anon_sym_COLON_COLON] = ACTIONS(2687),
    [anon_sym_AMP] = ACTIONS(2685),
    [anon_sym_LBRACK] = ACTIONS(2685),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2687),
    [anon_sym_LBRACE] = ACTIONS(2685),
    [anon_sym_LT_AT] = ACTIONS(2685),
    [anon_sym_LT_AT_AT] = ACTIONS(2685),
    [anon_sym_DOT] = ACTIONS(2685),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2687),
    [anon_sym_new] = ACTIONS(2685),
    [anon_sym_with] = ACTIONS(2685),
    [anon_sym_return_BANG] = ACTIONS(2687),
    [anon_sym_yield] = ACTIONS(2685),
    [anon_sym_yield_BANG] = ACTIONS(2687),
    [anon_sym_lazy] = ACTIONS(2685),
    [anon_sym_assert] = ACTIONS(2685),
    [anon_sym_upcast] = ACTIONS(2685),
    [anon_sym_downcast] = ACTIONS(2685),
    [anon_sym_COLON_GT] = ACTIONS(2687),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2687),
    [anon_sym_for] = ACTIONS(2685),
    [anon_sym_while] = ACTIONS(2685),
    [anon_sym_else] = ACTIONS(2685),
    [anon_sym_elif] = ACTIONS(2685),
    [anon_sym_if] = ACTIONS(2685),
    [anon_sym_fun] = ACTIONS(2685),
    [anon_sym_try] = ACTIONS(2685),
    [anon_sym_match] = ACTIONS(2685),
    [anon_sym_match_BANG] = ACTIONS(2687),
    [anon_sym_function] = ACTIONS(2685),
    [anon_sym_LT_DASH] = ACTIONS(2685),
    [anon_sym_DOT_LBRACK] = ACTIONS(2687),
    [anon_sym_LT] = ACTIONS(2687),
    [anon_sym_use] = ACTIONS(2685),
    [anon_sym_use_BANG] = ACTIONS(2687),
    [anon_sym_do_BANG] = ACTIONS(2687),
    [anon_sym_begin] = ACTIONS(2685),
    [anon_sym_LPAREN2] = ACTIONS(2685),
    [anon_sym_DOT_DOT2] = ACTIONS(2687),
    [anon_sym_default] = ACTIONS(2685),
    [anon_sym_or] = ACTIONS(2685),
    [anon_sym_static] = ACTIONS(2685),
    [anon_sym_member] = ACTIONS(2685),
    [anon_sym_abstract] = ACTIONS(2685),
    [anon_sym_val] = ACTIONS(2685),
    [anon_sym_override] = ACTIONS(2685),
    [aux_sym_char_token1] = ACTIONS(2687),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2685),
    [anon_sym_DQUOTE] = ACTIONS(2685),
    [anon_sym_AT_DQUOTE] = ACTIONS(2687),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2687),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2687),
    [sym_bool] = ACTIONS(2685),
    [sym_unit] = ACTIONS(2687),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2685),
    [sym_op_identifier] = ACTIONS(2685),
    [anon_sym_PLUS] = ACTIONS(2685),
    [anon_sym_DASH] = ACTIONS(2685),
    [anon_sym_PLUS_DOT] = ACTIONS(2685),
    [anon_sym_DASH_DOT] = ACTIONS(2685),
    [anon_sym_PERCENT] = ACTIONS(2685),
    [anon_sym_AMP_AMP] = ACTIONS(2685),
    [anon_sym_TILDE] = ACTIONS(2687),
    [aux_sym_prefix_op_token1] = ACTIONS(2685),
    [aux_sym_infix_op_token1] = ACTIONS(2687),
    [aux_sym_infix_op_token2] = ACTIONS(2685),
    [anon_sym_PIPE_PIPE] = ACTIONS(2685),
    [anon_sym_BANG_EQ] = ACTIONS(2685),
    [anon_sym_COLON_EQ] = ACTIONS(2687),
    [anon_sym_DOLLAR] = ACTIONS(2685),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2685),
    [sym_int] = ACTIONS(2685),
    [sym_xint] = ACTIONS(2687),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2687),
    [sym__newline] = ACTIONS(2687),
    [sym__dedent] = ACTIONS(2687),
  },
  [821] = {
    [sym_block_comment] = STATE(821),
    [sym_compiler_directive_decl] = STATE(821),
    [sym_fsi_directive_decl] = STATE(821),
    [sym_preproc_line] = STATE(821),
    [aux_sym_rules_repeat1] = STATE(832),
    [sym_identifier] = ACTIONS(2689),
    [anon_sym_EQ] = ACTIONS(2691),
    [anon_sym_LBRACK_LT] = ACTIONS(2691),
    [anon_sym_COLON] = ACTIONS(2689),
    [anon_sym_return] = ACTIONS(2689),
    [anon_sym_do] = ACTIONS(2689),
    [anon_sym_let] = ACTIONS(2689),
    [anon_sym_let_BANG] = ACTIONS(2691),
    [aux_sym_access_modifier_token1] = ACTIONS(2691),
    [anon_sym_LPAREN] = ACTIONS(2689),
    [anon_sym_COMMA] = ACTIONS(2691),
    [anon_sym_null] = ACTIONS(2689),
    [anon_sym_QMARK] = ACTIONS(2689),
    [anon_sym_COLON_QMARK] = ACTIONS(2689),
    [anon_sym_COLON_COLON] = ACTIONS(2691),
    [anon_sym_PIPE] = ACTIONS(2693),
    [anon_sym_AMP] = ACTIONS(2689),
    [anon_sym_LBRACK] = ACTIONS(2689),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2691),
    [anon_sym_LBRACE] = ACTIONS(2689),
    [anon_sym_LT_AT] = ACTIONS(2689),
    [anon_sym_LT_AT_AT] = ACTIONS(2689),
    [anon_sym_DOT] = ACTIONS(2689),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2691),
    [anon_sym_new] = ACTIONS(2689),
    [anon_sym_with] = ACTIONS(2689),
    [anon_sym_return_BANG] = ACTIONS(2691),
    [anon_sym_yield] = ACTIONS(2689),
    [anon_sym_yield_BANG] = ACTIONS(2691),
    [anon_sym_lazy] = ACTIONS(2689),
    [anon_sym_assert] = ACTIONS(2689),
    [anon_sym_upcast] = ACTIONS(2689),
    [anon_sym_downcast] = ACTIONS(2689),
    [anon_sym_COLON_GT] = ACTIONS(2691),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2691),
    [anon_sym_for] = ACTIONS(2689),
    [anon_sym_while] = ACTIONS(2689),
    [anon_sym_if] = ACTIONS(2689),
    [anon_sym_fun] = ACTIONS(2689),
    [anon_sym_try] = ACTIONS(2689),
    [anon_sym_match] = ACTIONS(2689),
    [anon_sym_match_BANG] = ACTIONS(2691),
    [anon_sym_function] = ACTIONS(2689),
    [anon_sym_LT_DASH] = ACTIONS(2689),
    [anon_sym_DOT_LBRACK] = ACTIONS(2691),
    [anon_sym_LT] = ACTIONS(2691),
    [anon_sym_use] = ACTIONS(2689),
    [anon_sym_use_BANG] = ACTIONS(2691),
    [anon_sym_do_BANG] = ACTIONS(2691),
    [anon_sym_begin] = ACTIONS(2689),
    [anon_sym_LPAREN2] = ACTIONS(2689),
    [anon_sym_DOT_DOT2] = ACTIONS(2691),
    [anon_sym_default] = ACTIONS(2689),
    [anon_sym_or] = ACTIONS(2689),
    [anon_sym_static] = ACTIONS(2689),
    [anon_sym_member] = ACTIONS(2689),
    [anon_sym_abstract] = ACTIONS(2689),
    [anon_sym_val] = ACTIONS(2689),
    [anon_sym_override] = ACTIONS(2689),
    [aux_sym_char_token1] = ACTIONS(2691),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2689),
    [anon_sym_DQUOTE] = ACTIONS(2689),
    [anon_sym_AT_DQUOTE] = ACTIONS(2691),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2691),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2691),
    [sym_bool] = ACTIONS(2689),
    [sym_unit] = ACTIONS(2691),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2689),
    [sym_op_identifier] = ACTIONS(2689),
    [anon_sym_PLUS] = ACTIONS(2689),
    [anon_sym_DASH] = ACTIONS(2689),
    [anon_sym_PLUS_DOT] = ACTIONS(2689),
    [anon_sym_DASH_DOT] = ACTIONS(2689),
    [anon_sym_PERCENT] = ACTIONS(2689),
    [anon_sym_AMP_AMP] = ACTIONS(2689),
    [anon_sym_TILDE] = ACTIONS(2691),
    [aux_sym_prefix_op_token1] = ACTIONS(2689),
    [aux_sym_infix_op_token1] = ACTIONS(2691),
    [aux_sym_infix_op_token2] = ACTIONS(2689),
    [anon_sym_PIPE_PIPE] = ACTIONS(2689),
    [anon_sym_BANG_EQ] = ACTIONS(2689),
    [anon_sym_COLON_EQ] = ACTIONS(2691),
    [anon_sym_DOLLAR] = ACTIONS(2689),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2689),
    [sym_int] = ACTIONS(2689),
    [sym_xint] = ACTIONS(2691),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2691),
    [sym__newline] = ACTIONS(2695),
    [sym__dedent] = ACTIONS(2691),
  },
  [822] = {
    [sym_block_comment] = STATE(822),
    [sym_compiler_directive_decl] = STATE(822),
    [sym_fsi_directive_decl] = STATE(822),
    [sym_preproc_line] = STATE(822),
    [sym_identifier] = ACTIONS(2685),
    [anon_sym_EQ] = ACTIONS(2687),
    [anon_sym_LBRACK_LT] = ACTIONS(2687),
    [anon_sym_COLON] = ACTIONS(2685),
    [anon_sym_return] = ACTIONS(2685),
    [anon_sym_do] = ACTIONS(2685),
    [anon_sym_let] = ACTIONS(2685),
    [anon_sym_let_BANG] = ACTIONS(2687),
    [aux_sym_access_modifier_token1] = ACTIONS(2687),
    [anon_sym_LPAREN] = ACTIONS(2685),
    [anon_sym_COMMA] = ACTIONS(2687),
    [anon_sym_null] = ACTIONS(2685),
    [anon_sym_QMARK] = ACTIONS(2685),
    [anon_sym_COLON_QMARK] = ACTIONS(2685),
    [anon_sym_COLON_COLON] = ACTIONS(2687),
    [anon_sym_AMP] = ACTIONS(2685),
    [anon_sym_LBRACK] = ACTIONS(2685),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2687),
    [anon_sym_LBRACE] = ACTIONS(2685),
    [anon_sym_LT_AT] = ACTIONS(2685),
    [anon_sym_LT_AT_AT] = ACTIONS(2685),
    [anon_sym_DOT] = ACTIONS(2685),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2687),
    [anon_sym_new] = ACTIONS(2685),
    [anon_sym_with] = ACTIONS(2685),
    [anon_sym_return_BANG] = ACTIONS(2687),
    [anon_sym_yield] = ACTIONS(2685),
    [anon_sym_yield_BANG] = ACTIONS(2687),
    [anon_sym_lazy] = ACTIONS(2685),
    [anon_sym_assert] = ACTIONS(2685),
    [anon_sym_upcast] = ACTIONS(2685),
    [anon_sym_downcast] = ACTIONS(2685),
    [anon_sym_COLON_GT] = ACTIONS(2687),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2687),
    [anon_sym_for] = ACTIONS(2685),
    [anon_sym_done] = ACTIONS(2685),
    [anon_sym_while] = ACTIONS(2685),
    [anon_sym_if] = ACTIONS(2685),
    [anon_sym_fun] = ACTIONS(2685),
    [anon_sym_try] = ACTIONS(2685),
    [anon_sym_match] = ACTIONS(2685),
    [anon_sym_match_BANG] = ACTIONS(2687),
    [anon_sym_function] = ACTIONS(2685),
    [anon_sym_LT_DASH] = ACTIONS(2685),
    [anon_sym_DOT_LBRACK] = ACTIONS(2687),
    [anon_sym_LT] = ACTIONS(2687),
    [anon_sym_use] = ACTIONS(2685),
    [anon_sym_use_BANG] = ACTIONS(2687),
    [anon_sym_do_BANG] = ACTIONS(2687),
    [anon_sym_DOT_DOT] = ACTIONS(2685),
    [anon_sym_begin] = ACTIONS(2685),
    [anon_sym_LPAREN2] = ACTIONS(2685),
    [anon_sym_DOT_DOT2] = ACTIONS(2687),
    [anon_sym_default] = ACTIONS(2685),
    [anon_sym_or] = ACTIONS(2685),
    [anon_sym_static] = ACTIONS(2685),
    [anon_sym_member] = ACTIONS(2685),
    [anon_sym_abstract] = ACTIONS(2685),
    [anon_sym_val] = ACTIONS(2685),
    [anon_sym_override] = ACTIONS(2685),
    [aux_sym_char_token1] = ACTIONS(2687),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2685),
    [anon_sym_DQUOTE] = ACTIONS(2685),
    [anon_sym_AT_DQUOTE] = ACTIONS(2687),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2687),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2687),
    [sym_bool] = ACTIONS(2685),
    [sym_unit] = ACTIONS(2687),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2685),
    [sym_op_identifier] = ACTIONS(2685),
    [anon_sym_PLUS] = ACTIONS(2685),
    [anon_sym_DASH] = ACTIONS(2685),
    [anon_sym_PLUS_DOT] = ACTIONS(2685),
    [anon_sym_DASH_DOT] = ACTIONS(2685),
    [anon_sym_PERCENT] = ACTIONS(2685),
    [anon_sym_AMP_AMP] = ACTIONS(2685),
    [anon_sym_TILDE] = ACTIONS(2687),
    [aux_sym_prefix_op_token1] = ACTIONS(2685),
    [aux_sym_infix_op_token1] = ACTIONS(2687),
    [aux_sym_infix_op_token2] = ACTIONS(2685),
    [anon_sym_PIPE_PIPE] = ACTIONS(2685),
    [anon_sym_BANG_EQ] = ACTIONS(2685),
    [anon_sym_COLON_EQ] = ACTIONS(2687),
    [anon_sym_DOLLAR] = ACTIONS(2685),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2685),
    [sym_int] = ACTIONS(2685),
    [sym_xint] = ACTIONS(2687),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2687),
    [sym__newline] = ACTIONS(2687),
    [sym__dedent] = ACTIONS(2687),
  },
  [823] = {
    [sym_block_comment] = STATE(823),
    [sym_compiler_directive_decl] = STATE(823),
    [sym_fsi_directive_decl] = STATE(823),
    [sym_preproc_line] = STATE(823),
    [aux_sym_rules_repeat1] = STATE(830),
    [sym_identifier] = ACTIONS(2698),
    [anon_sym_EQ] = ACTIONS(2700),
    [anon_sym_LBRACK_LT] = ACTIONS(2700),
    [anon_sym_COLON] = ACTIONS(2698),
    [anon_sym_return] = ACTIONS(2698),
    [anon_sym_do] = ACTIONS(2698),
    [anon_sym_let] = ACTIONS(2698),
    [anon_sym_let_BANG] = ACTIONS(2700),
    [aux_sym_access_modifier_token1] = ACTIONS(2700),
    [anon_sym_LPAREN] = ACTIONS(2698),
    [anon_sym_COMMA] = ACTIONS(2700),
    [anon_sym_null] = ACTIONS(2698),
    [anon_sym_QMARK] = ACTIONS(2698),
    [anon_sym_COLON_QMARK] = ACTIONS(2698),
    [anon_sym_COLON_COLON] = ACTIONS(2700),
    [anon_sym_PIPE] = ACTIONS(2693),
    [anon_sym_AMP] = ACTIONS(2698),
    [anon_sym_LBRACK] = ACTIONS(2698),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2700),
    [anon_sym_LBRACE] = ACTIONS(2698),
    [anon_sym_LT_AT] = ACTIONS(2698),
    [anon_sym_LT_AT_AT] = ACTIONS(2698),
    [anon_sym_DOT] = ACTIONS(2698),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2700),
    [anon_sym_new] = ACTIONS(2698),
    [anon_sym_with] = ACTIONS(2698),
    [anon_sym_return_BANG] = ACTIONS(2700),
    [anon_sym_yield] = ACTIONS(2698),
    [anon_sym_yield_BANG] = ACTIONS(2700),
    [anon_sym_lazy] = ACTIONS(2698),
    [anon_sym_assert] = ACTIONS(2698),
    [anon_sym_upcast] = ACTIONS(2698),
    [anon_sym_downcast] = ACTIONS(2698),
    [anon_sym_COLON_GT] = ACTIONS(2700),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2700),
    [anon_sym_for] = ACTIONS(2698),
    [anon_sym_while] = ACTIONS(2698),
    [anon_sym_if] = ACTIONS(2698),
    [anon_sym_fun] = ACTIONS(2698),
    [anon_sym_try] = ACTIONS(2698),
    [anon_sym_match] = ACTIONS(2698),
    [anon_sym_match_BANG] = ACTIONS(2700),
    [anon_sym_function] = ACTIONS(2698),
    [anon_sym_LT_DASH] = ACTIONS(2698),
    [anon_sym_DOT_LBRACK] = ACTIONS(2700),
    [anon_sym_LT] = ACTIONS(2700),
    [anon_sym_use] = ACTIONS(2698),
    [anon_sym_use_BANG] = ACTIONS(2700),
    [anon_sym_do_BANG] = ACTIONS(2700),
    [anon_sym_begin] = ACTIONS(2698),
    [anon_sym_LPAREN2] = ACTIONS(2698),
    [anon_sym_DOT_DOT2] = ACTIONS(2700),
    [anon_sym_default] = ACTIONS(2698),
    [anon_sym_or] = ACTIONS(2698),
    [anon_sym_static] = ACTIONS(2698),
    [anon_sym_member] = ACTIONS(2698),
    [anon_sym_abstract] = ACTIONS(2698),
    [anon_sym_val] = ACTIONS(2698),
    [anon_sym_override] = ACTIONS(2698),
    [aux_sym_char_token1] = ACTIONS(2700),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2698),
    [anon_sym_DQUOTE] = ACTIONS(2698),
    [anon_sym_AT_DQUOTE] = ACTIONS(2700),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2700),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2700),
    [sym_bool] = ACTIONS(2698),
    [sym_unit] = ACTIONS(2700),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2698),
    [sym_op_identifier] = ACTIONS(2698),
    [anon_sym_PLUS] = ACTIONS(2698),
    [anon_sym_DASH] = ACTIONS(2698),
    [anon_sym_PLUS_DOT] = ACTIONS(2698),
    [anon_sym_DASH_DOT] = ACTIONS(2698),
    [anon_sym_PERCENT] = ACTIONS(2698),
    [anon_sym_AMP_AMP] = ACTIONS(2698),
    [anon_sym_TILDE] = ACTIONS(2700),
    [aux_sym_prefix_op_token1] = ACTIONS(2698),
    [aux_sym_infix_op_token1] = ACTIONS(2700),
    [aux_sym_infix_op_token2] = ACTIONS(2698),
    [anon_sym_PIPE_PIPE] = ACTIONS(2698),
    [anon_sym_BANG_EQ] = ACTIONS(2698),
    [anon_sym_COLON_EQ] = ACTIONS(2700),
    [anon_sym_DOLLAR] = ACTIONS(2698),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2698),
    [sym_int] = ACTIONS(2698),
    [sym_xint] = ACTIONS(2700),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2700),
    [sym__newline] = ACTIONS(2702),
    [sym__dedent] = ACTIONS(2700),
  },
  [824] = {
    [sym_block_comment] = STATE(824),
    [sym_compiler_directive_decl] = STATE(824),
    [sym_fsi_directive_decl] = STATE(824),
    [sym_preproc_line] = STATE(824),
    [sym_identifier] = ACTIONS(2158),
    [anon_sym_EQ] = ACTIONS(2160),
    [anon_sym_COLON] = ACTIONS(2158),
    [anon_sym_return] = ACTIONS(2158),
    [anon_sym_do] = ACTIONS(2158),
    [anon_sym_let] = ACTIONS(2158),
    [anon_sym_let_BANG] = ACTIONS(2160),
    [anon_sym_LPAREN] = ACTIONS(2158),
    [anon_sym_COMMA] = ACTIONS(2160),
    [anon_sym_null] = ACTIONS(2158),
    [anon_sym_QMARK] = ACTIONS(2158),
    [anon_sym_COLON_QMARK] = ACTIONS(2158),
    [anon_sym_COLON_COLON] = ACTIONS(2160),
    [anon_sym_AMP] = ACTIONS(2158),
    [anon_sym_LBRACK] = ACTIONS(2158),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2160),
    [anon_sym_LBRACE] = ACTIONS(2158),
    [anon_sym_LT_AT] = ACTIONS(2158),
    [anon_sym_AT_GT] = ACTIONS(2158),
    [anon_sym_LT_AT_AT] = ACTIONS(2158),
    [anon_sym_DOT] = ACTIONS(2158),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2160),
    [anon_sym_new] = ACTIONS(2158),
    [anon_sym_return_BANG] = ACTIONS(2160),
    [anon_sym_yield] = ACTIONS(2158),
    [anon_sym_yield_BANG] = ACTIONS(2160),
    [anon_sym_lazy] = ACTIONS(2158),
    [anon_sym_assert] = ACTIONS(2158),
    [anon_sym_upcast] = ACTIONS(2158),
    [anon_sym_downcast] = ACTIONS(2158),
    [anon_sym_COLON_GT] = ACTIONS(2160),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2160),
    [anon_sym_for] = ACTIONS(2158),
    [anon_sym_while] = ACTIONS(2158),
    [anon_sym_if] = ACTIONS(2158),
    [anon_sym_fun] = ACTIONS(2158),
    [anon_sym_try] = ACTIONS(2158),
    [anon_sym_match] = ACTIONS(2158),
    [anon_sym_match_BANG] = ACTIONS(2160),
    [anon_sym_function] = ACTIONS(2158),
    [anon_sym_LT_DASH] = ACTIONS(2158),
    [anon_sym_DOT_LBRACK] = ACTIONS(2160),
    [anon_sym_LT] = ACTIONS(2160),
    [anon_sym_use] = ACTIONS(2158),
    [anon_sym_use_BANG] = ACTIONS(2160),
    [anon_sym_do_BANG] = ACTIONS(2160),
    [anon_sym_begin] = ACTIONS(2158),
    [anon_sym_LPAREN2] = ACTIONS(2158),
    [anon_sym_or] = ACTIONS(2158),
    [aux_sym_char_token1] = ACTIONS(2160),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2158),
    [anon_sym_DQUOTE] = ACTIONS(2158),
    [anon_sym_AT_DQUOTE] = ACTIONS(2160),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2160),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2160),
    [sym_bool] = ACTIONS(2158),
    [sym_unit] = ACTIONS(2160),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2158),
    [sym_op_identifier] = ACTIONS(2158),
    [anon_sym_PLUS] = ACTIONS(2158),
    [anon_sym_DASH] = ACTIONS(2158),
    [anon_sym_PLUS_DOT] = ACTIONS(2158),
    [anon_sym_DASH_DOT] = ACTIONS(2158),
    [anon_sym_PERCENT] = ACTIONS(2158),
    [anon_sym_AMP_AMP] = ACTIONS(2158),
    [anon_sym_TILDE] = ACTIONS(2160),
    [aux_sym_prefix_op_token1] = ACTIONS(2158),
    [aux_sym_infix_op_token1] = ACTIONS(2160),
    [aux_sym_infix_op_token2] = ACTIONS(2158),
    [anon_sym_PIPE_PIPE] = ACTIONS(2158),
    [anon_sym_BANG_EQ] = ACTIONS(2158),
    [anon_sym_COLON_EQ] = ACTIONS(2160),
    [anon_sym_DOLLAR] = ACTIONS(2158),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2158),
    [sym_int] = ACTIONS(2158),
    [sym_xint] = ACTIONS(2160),
    [anon_sym_y] = ACTIONS(2571),
    [anon_sym_uy] = ACTIONS(2573),
    [anon_sym_s] = ACTIONS(2575),
    [anon_sym_us] = ACTIONS(2577),
    [anon_sym_l] = ACTIONS(2579),
    [aux_sym_uint32_token1] = ACTIONS(2581),
    [anon_sym_n] = ACTIONS(2583),
    [anon_sym_un] = ACTIONS(2585),
    [anon_sym_L] = ACTIONS(2587),
    [aux_sym_uint64_token1] = ACTIONS(2589),
    [anon_sym_lf] = ACTIONS(2705),
    [anon_sym_LF] = ACTIONS(2707),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2160),
    [sym__newline] = ACTIONS(2160),
  },
  [825] = {
    [sym_block_comment] = STATE(825),
    [sym_compiler_directive_decl] = STATE(825),
    [sym_fsi_directive_decl] = STATE(825),
    [sym_preproc_line] = STATE(825),
    [sym_identifier] = ACTIONS(2158),
    [anon_sym_EQ] = ACTIONS(2160),
    [anon_sym_COLON] = ACTIONS(2158),
    [anon_sym_return] = ACTIONS(2158),
    [anon_sym_do] = ACTIONS(2158),
    [anon_sym_let] = ACTIONS(2158),
    [anon_sym_let_BANG] = ACTIONS(2160),
    [anon_sym_LPAREN] = ACTIONS(2158),
    [anon_sym_COMMA] = ACTIONS(2160),
    [anon_sym_null] = ACTIONS(2158),
    [anon_sym_QMARK] = ACTIONS(2158),
    [anon_sym_COLON_QMARK] = ACTIONS(2158),
    [anon_sym_COLON_COLON] = ACTIONS(2160),
    [anon_sym_AMP] = ACTIONS(2158),
    [anon_sym_LBRACK] = ACTIONS(2158),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2160),
    [anon_sym_LBRACE] = ACTIONS(2158),
    [anon_sym_LT_AT] = ACTIONS(2158),
    [anon_sym_LT_AT_AT] = ACTIONS(2158),
    [anon_sym_DOT] = ACTIONS(2158),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2160),
    [anon_sym_new] = ACTIONS(2158),
    [anon_sym_return_BANG] = ACTIONS(2160),
    [anon_sym_yield] = ACTIONS(2158),
    [anon_sym_yield_BANG] = ACTIONS(2160),
    [anon_sym_lazy] = ACTIONS(2158),
    [anon_sym_assert] = ACTIONS(2158),
    [anon_sym_upcast] = ACTIONS(2158),
    [anon_sym_downcast] = ACTIONS(2158),
    [anon_sym_COLON_GT] = ACTIONS(2160),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2160),
    [anon_sym_for] = ACTIONS(2158),
    [anon_sym_while] = ACTIONS(2158),
    [anon_sym_if] = ACTIONS(2158),
    [anon_sym_fun] = ACTIONS(2158),
    [anon_sym_try] = ACTIONS(2158),
    [anon_sym_match] = ACTIONS(2158),
    [anon_sym_match_BANG] = ACTIONS(2160),
    [anon_sym_function] = ACTIONS(2158),
    [anon_sym_LT_DASH] = ACTIONS(2158),
    [anon_sym_DOT_LBRACK] = ACTIONS(2160),
    [anon_sym_LT] = ACTIONS(2160),
    [anon_sym_use] = ACTIONS(2158),
    [anon_sym_use_BANG] = ACTIONS(2160),
    [anon_sym_do_BANG] = ACTIONS(2160),
    [anon_sym_DOT_DOT] = ACTIONS(2160),
    [anon_sym_begin] = ACTIONS(2158),
    [anon_sym_LPAREN2] = ACTIONS(2158),
    [anon_sym_or] = ACTIONS(2158),
    [aux_sym_char_token1] = ACTIONS(2160),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2158),
    [anon_sym_DQUOTE] = ACTIONS(2158),
    [anon_sym_AT_DQUOTE] = ACTIONS(2160),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2160),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2160),
    [sym_bool] = ACTIONS(2158),
    [sym_unit] = ACTIONS(2160),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2158),
    [sym_op_identifier] = ACTIONS(2158),
    [anon_sym_PLUS] = ACTIONS(2158),
    [anon_sym_DASH] = ACTIONS(2158),
    [anon_sym_PLUS_DOT] = ACTIONS(2158),
    [anon_sym_DASH_DOT] = ACTIONS(2158),
    [anon_sym_PERCENT] = ACTIONS(2158),
    [anon_sym_AMP_AMP] = ACTIONS(2158),
    [anon_sym_TILDE] = ACTIONS(2160),
    [aux_sym_prefix_op_token1] = ACTIONS(2158),
    [aux_sym_infix_op_token1] = ACTIONS(2160),
    [aux_sym_infix_op_token2] = ACTIONS(2158),
    [anon_sym_PIPE_PIPE] = ACTIONS(2158),
    [anon_sym_BANG_EQ] = ACTIONS(2158),
    [anon_sym_COLON_EQ] = ACTIONS(2160),
    [anon_sym_DOLLAR] = ACTIONS(2158),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2158),
    [sym_int] = ACTIONS(2158),
    [sym_xint] = ACTIONS(2160),
    [anon_sym_y] = ACTIONS(2478),
    [anon_sym_uy] = ACTIONS(2480),
    [anon_sym_s] = ACTIONS(2482),
    [anon_sym_us] = ACTIONS(2484),
    [anon_sym_l] = ACTIONS(2486),
    [aux_sym_uint32_token1] = ACTIONS(2488),
    [anon_sym_n] = ACTIONS(2490),
    [anon_sym_un] = ACTIONS(2492),
    [anon_sym_L] = ACTIONS(2494),
    [aux_sym_uint64_token1] = ACTIONS(2496),
    [anon_sym_lf] = ACTIONS(2709),
    [anon_sym_LF] = ACTIONS(2711),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2160),
    [sym__newline] = ACTIONS(2160),
  },
  [826] = {
    [sym_block_comment] = STATE(826),
    [sym_compiler_directive_decl] = STATE(826),
    [sym_fsi_directive_decl] = STATE(826),
    [sym_preproc_line] = STATE(826),
    [aux_sym_rules_repeat1] = STATE(826),
    [sym_identifier] = ACTIONS(2713),
    [anon_sym_EQ] = ACTIONS(2715),
    [anon_sym_LBRACK_LT] = ACTIONS(2715),
    [anon_sym_COLON] = ACTIONS(2713),
    [anon_sym_return] = ACTIONS(2713),
    [anon_sym_do] = ACTIONS(2713),
    [anon_sym_let] = ACTIONS(2713),
    [anon_sym_let_BANG] = ACTIONS(2715),
    [aux_sym_access_modifier_token1] = ACTIONS(2715),
    [anon_sym_LPAREN] = ACTIONS(2713),
    [anon_sym_COMMA] = ACTIONS(2715),
    [anon_sym_null] = ACTIONS(2713),
    [anon_sym_QMARK] = ACTIONS(2713),
    [anon_sym_COLON_QMARK] = ACTIONS(2713),
    [anon_sym_COLON_COLON] = ACTIONS(2715),
    [anon_sym_PIPE] = ACTIONS(2717),
    [anon_sym_AMP] = ACTIONS(2713),
    [anon_sym_LBRACK] = ACTIONS(2713),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2715),
    [anon_sym_LBRACE] = ACTIONS(2713),
    [anon_sym_LT_AT] = ACTIONS(2713),
    [anon_sym_LT_AT_AT] = ACTIONS(2713),
    [anon_sym_DOT] = ACTIONS(2713),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2715),
    [anon_sym_new] = ACTIONS(2713),
    [anon_sym_with] = ACTIONS(2713),
    [anon_sym_return_BANG] = ACTIONS(2715),
    [anon_sym_yield] = ACTIONS(2713),
    [anon_sym_yield_BANG] = ACTIONS(2715),
    [anon_sym_lazy] = ACTIONS(2713),
    [anon_sym_assert] = ACTIONS(2713),
    [anon_sym_upcast] = ACTIONS(2713),
    [anon_sym_downcast] = ACTIONS(2713),
    [anon_sym_COLON_GT] = ACTIONS(2715),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2715),
    [anon_sym_for] = ACTIONS(2713),
    [anon_sym_while] = ACTIONS(2713),
    [anon_sym_if] = ACTIONS(2713),
    [anon_sym_fun] = ACTIONS(2713),
    [anon_sym_try] = ACTIONS(2713),
    [anon_sym_match] = ACTIONS(2713),
    [anon_sym_match_BANG] = ACTIONS(2715),
    [anon_sym_function] = ACTIONS(2713),
    [anon_sym_LT_DASH] = ACTIONS(2713),
    [anon_sym_DOT_LBRACK] = ACTIONS(2715),
    [anon_sym_LT] = ACTIONS(2715),
    [anon_sym_use] = ACTIONS(2713),
    [anon_sym_use_BANG] = ACTIONS(2715),
    [anon_sym_do_BANG] = ACTIONS(2715),
    [anon_sym_begin] = ACTIONS(2713),
    [anon_sym_LPAREN2] = ACTIONS(2713),
    [anon_sym_DOT_DOT2] = ACTIONS(2715),
    [anon_sym_default] = ACTIONS(2713),
    [anon_sym_or] = ACTIONS(2713),
    [anon_sym_static] = ACTIONS(2713),
    [anon_sym_member] = ACTIONS(2713),
    [anon_sym_abstract] = ACTIONS(2713),
    [anon_sym_val] = ACTIONS(2713),
    [anon_sym_override] = ACTIONS(2713),
    [aux_sym_char_token1] = ACTIONS(2715),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2713),
    [anon_sym_DQUOTE] = ACTIONS(2713),
    [anon_sym_AT_DQUOTE] = ACTIONS(2715),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2715),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2715),
    [sym_bool] = ACTIONS(2713),
    [sym_unit] = ACTIONS(2715),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2713),
    [sym_op_identifier] = ACTIONS(2713),
    [anon_sym_PLUS] = ACTIONS(2713),
    [anon_sym_DASH] = ACTIONS(2713),
    [anon_sym_PLUS_DOT] = ACTIONS(2713),
    [anon_sym_DASH_DOT] = ACTIONS(2713),
    [anon_sym_PERCENT] = ACTIONS(2713),
    [anon_sym_AMP_AMP] = ACTIONS(2713),
    [anon_sym_TILDE] = ACTIONS(2715),
    [aux_sym_prefix_op_token1] = ACTIONS(2713),
    [aux_sym_infix_op_token1] = ACTIONS(2715),
    [aux_sym_infix_op_token2] = ACTIONS(2713),
    [anon_sym_PIPE_PIPE] = ACTIONS(2713),
    [anon_sym_BANG_EQ] = ACTIONS(2713),
    [anon_sym_COLON_EQ] = ACTIONS(2715),
    [anon_sym_DOLLAR] = ACTIONS(2713),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2713),
    [sym_int] = ACTIONS(2713),
    [sym_xint] = ACTIONS(2715),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2715),
    [sym__newline] = ACTIONS(2720),
    [sym__dedent] = ACTIONS(2715),
  },
  [827] = {
    [sym_block_comment] = STATE(827),
    [sym_compiler_directive_decl] = STATE(827),
    [sym_fsi_directive_decl] = STATE(827),
    [sym_preproc_line] = STATE(827),
    [sym_identifier] = ACTIONS(2723),
    [anon_sym_EQ] = ACTIONS(2725),
    [anon_sym_LBRACK_LT] = ACTIONS(2725),
    [anon_sym_COLON] = ACTIONS(2723),
    [anon_sym_return] = ACTIONS(2723),
    [anon_sym_do] = ACTIONS(2723),
    [anon_sym_let] = ACTIONS(2723),
    [anon_sym_let_BANG] = ACTIONS(2725),
    [aux_sym_access_modifier_token1] = ACTIONS(2725),
    [anon_sym_LPAREN] = ACTIONS(2723),
    [anon_sym_COMMA] = ACTIONS(2725),
    [anon_sym_null] = ACTIONS(2723),
    [anon_sym_QMARK] = ACTIONS(2723),
    [anon_sym_COLON_QMARK] = ACTIONS(2723),
    [anon_sym_COLON_COLON] = ACTIONS(2725),
    [anon_sym_AMP] = ACTIONS(2723),
    [anon_sym_LBRACK] = ACTIONS(2723),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2725),
    [anon_sym_LBRACE] = ACTIONS(2723),
    [anon_sym_LT_AT] = ACTIONS(2723),
    [anon_sym_LT_AT_AT] = ACTIONS(2723),
    [anon_sym_DOT] = ACTIONS(2723),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2725),
    [anon_sym_new] = ACTIONS(2723),
    [anon_sym_with] = ACTIONS(2723),
    [anon_sym_return_BANG] = ACTIONS(2725),
    [anon_sym_yield] = ACTIONS(2723),
    [anon_sym_yield_BANG] = ACTIONS(2725),
    [anon_sym_lazy] = ACTIONS(2723),
    [anon_sym_assert] = ACTIONS(2723),
    [anon_sym_upcast] = ACTIONS(2723),
    [anon_sym_downcast] = ACTIONS(2723),
    [anon_sym_COLON_GT] = ACTIONS(2725),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2725),
    [anon_sym_for] = ACTIONS(2723),
    [anon_sym_while] = ACTIONS(2723),
    [anon_sym_if] = ACTIONS(2723),
    [anon_sym_fun] = ACTIONS(2723),
    [anon_sym_try] = ACTIONS(2723),
    [anon_sym_match] = ACTIONS(2723),
    [anon_sym_match_BANG] = ACTIONS(2725),
    [anon_sym_function] = ACTIONS(2723),
    [anon_sym_LT_DASH] = ACTIONS(2723),
    [anon_sym_DOT_LBRACK] = ACTIONS(2725),
    [anon_sym_LT] = ACTIONS(2725),
    [anon_sym_use] = ACTIONS(2723),
    [anon_sym_use_BANG] = ACTIONS(2725),
    [anon_sym_do_BANG] = ACTIONS(2725),
    [anon_sym_begin] = ACTIONS(2723),
    [anon_sym_LPAREN2] = ACTIONS(2723),
    [anon_sym_default] = ACTIONS(2723),
    [anon_sym_or] = ACTIONS(2723),
    [anon_sym_static] = ACTIONS(2723),
    [anon_sym_member] = ACTIONS(2723),
    [anon_sym_abstract] = ACTIONS(2723),
    [anon_sym_val] = ACTIONS(2723),
    [anon_sym_override] = ACTIONS(2723),
    [aux_sym_char_token1] = ACTIONS(2725),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2723),
    [anon_sym_DQUOTE] = ACTIONS(2723),
    [anon_sym_AT_DQUOTE] = ACTIONS(2725),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2725),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2725),
    [sym_bool] = ACTIONS(2723),
    [sym_unit] = ACTIONS(2725),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2723),
    [sym_op_identifier] = ACTIONS(2723),
    [anon_sym_PLUS] = ACTIONS(2723),
    [anon_sym_DASH] = ACTIONS(2723),
    [anon_sym_PLUS_DOT] = ACTIONS(2723),
    [anon_sym_DASH_DOT] = ACTIONS(2723),
    [anon_sym_PERCENT] = ACTIONS(2723),
    [anon_sym_AMP_AMP] = ACTIONS(2723),
    [anon_sym_TILDE] = ACTIONS(2725),
    [aux_sym_prefix_op_token1] = ACTIONS(2723),
    [aux_sym_infix_op_token1] = ACTIONS(2725),
    [aux_sym_infix_op_token2] = ACTIONS(2723),
    [anon_sym_PIPE_PIPE] = ACTIONS(2723),
    [anon_sym_BANG_EQ] = ACTIONS(2723),
    [anon_sym_COLON_EQ] = ACTIONS(2725),
    [anon_sym_DOLLAR] = ACTIONS(2723),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2723),
    [sym_int] = ACTIONS(2723),
    [sym_xint] = ACTIONS(2725),
    [anon_sym_f] = ACTIONS(2723),
    [aux_sym_decimal_token1] = ACTIONS(2723),
    [aux_sym_float_token1] = ACTIONS(2727),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2725),
    [sym__newline] = ACTIONS(2725),
    [sym__dedent] = ACTIONS(2725),
  },
  [828] = {
    [sym_block_comment] = STATE(828),
    [sym_compiler_directive_decl] = STATE(828),
    [sym_fsi_directive_decl] = STATE(828),
    [sym_preproc_line] = STATE(828),
    [sym_identifier] = ACTIONS(2729),
    [anon_sym_EQ] = ACTIONS(2731),
    [anon_sym_LBRACK_LT] = ACTIONS(2731),
    [anon_sym_COLON] = ACTIONS(2729),
    [anon_sym_return] = ACTIONS(2729),
    [anon_sym_do] = ACTIONS(2729),
    [anon_sym_let] = ACTIONS(2729),
    [anon_sym_let_BANG] = ACTIONS(2731),
    [aux_sym_access_modifier_token1] = ACTIONS(2731),
    [anon_sym_LPAREN] = ACTIONS(2729),
    [anon_sym_COMMA] = ACTIONS(2731),
    [anon_sym_null] = ACTIONS(2729),
    [anon_sym_QMARK] = ACTIONS(2729),
    [anon_sym_COLON_QMARK] = ACTIONS(2729),
    [anon_sym_COLON_COLON] = ACTIONS(2731),
    [anon_sym_AMP] = ACTIONS(2729),
    [anon_sym_LBRACK] = ACTIONS(2729),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2731),
    [anon_sym_LBRACE] = ACTIONS(2729),
    [anon_sym_LT_AT] = ACTIONS(2729),
    [anon_sym_LT_AT_AT] = ACTIONS(2729),
    [anon_sym_DOT] = ACTIONS(2729),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2731),
    [anon_sym_new] = ACTIONS(2729),
    [anon_sym_with] = ACTIONS(2729),
    [anon_sym_return_BANG] = ACTIONS(2731),
    [anon_sym_yield] = ACTIONS(2729),
    [anon_sym_yield_BANG] = ACTIONS(2731),
    [anon_sym_lazy] = ACTIONS(2729),
    [anon_sym_assert] = ACTIONS(2729),
    [anon_sym_upcast] = ACTIONS(2729),
    [anon_sym_downcast] = ACTIONS(2729),
    [anon_sym_COLON_GT] = ACTIONS(2731),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2731),
    [anon_sym_for] = ACTIONS(2729),
    [anon_sym_while] = ACTIONS(2729),
    [anon_sym_else] = ACTIONS(2729),
    [anon_sym_elif] = ACTIONS(2729),
    [anon_sym_if] = ACTIONS(2729),
    [anon_sym_fun] = ACTIONS(2729),
    [anon_sym_try] = ACTIONS(2729),
    [anon_sym_match] = ACTIONS(2729),
    [anon_sym_match_BANG] = ACTIONS(2731),
    [anon_sym_function] = ACTIONS(2729),
    [anon_sym_LT_DASH] = ACTIONS(2729),
    [anon_sym_DOT_LBRACK] = ACTIONS(2731),
    [anon_sym_LT] = ACTIONS(2731),
    [anon_sym_use] = ACTIONS(2729),
    [anon_sym_use_BANG] = ACTIONS(2731),
    [anon_sym_do_BANG] = ACTIONS(2731),
    [anon_sym_begin] = ACTIONS(2729),
    [anon_sym_LPAREN2] = ACTIONS(2729),
    [anon_sym_DOT_DOT2] = ACTIONS(2731),
    [anon_sym_default] = ACTIONS(2729),
    [anon_sym_or] = ACTIONS(2729),
    [anon_sym_static] = ACTIONS(2729),
    [anon_sym_member] = ACTIONS(2729),
    [anon_sym_abstract] = ACTIONS(2729),
    [anon_sym_val] = ACTIONS(2729),
    [anon_sym_override] = ACTIONS(2729),
    [aux_sym_char_token1] = ACTIONS(2731),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2729),
    [anon_sym_DQUOTE] = ACTIONS(2729),
    [anon_sym_AT_DQUOTE] = ACTIONS(2731),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2731),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2731),
    [sym_bool] = ACTIONS(2729),
    [sym_unit] = ACTIONS(2731),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2729),
    [sym_op_identifier] = ACTIONS(2729),
    [anon_sym_PLUS] = ACTIONS(2729),
    [anon_sym_DASH] = ACTIONS(2729),
    [anon_sym_PLUS_DOT] = ACTIONS(2729),
    [anon_sym_DASH_DOT] = ACTIONS(2729),
    [anon_sym_PERCENT] = ACTIONS(2729),
    [anon_sym_AMP_AMP] = ACTIONS(2729),
    [anon_sym_TILDE] = ACTIONS(2731),
    [aux_sym_prefix_op_token1] = ACTIONS(2729),
    [aux_sym_infix_op_token1] = ACTIONS(2731),
    [aux_sym_infix_op_token2] = ACTIONS(2729),
    [anon_sym_PIPE_PIPE] = ACTIONS(2729),
    [anon_sym_BANG_EQ] = ACTIONS(2729),
    [anon_sym_COLON_EQ] = ACTIONS(2731),
    [anon_sym_DOLLAR] = ACTIONS(2729),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2729),
    [sym_int] = ACTIONS(2729),
    [sym_xint] = ACTIONS(2731),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2731),
    [sym__newline] = ACTIONS(2731),
    [sym__dedent] = ACTIONS(2731),
  },
  [829] = {
    [sym_block_comment] = STATE(829),
    [sym_compiler_directive_decl] = STATE(829),
    [sym_fsi_directive_decl] = STATE(829),
    [sym_preproc_line] = STATE(829),
    [sym_identifier] = ACTIONS(2158),
    [anon_sym_EQ] = ACTIONS(2160),
    [anon_sym_COLON] = ACTIONS(2158),
    [anon_sym_return] = ACTIONS(2158),
    [anon_sym_do] = ACTIONS(2158),
    [anon_sym_let] = ACTIONS(2158),
    [anon_sym_let_BANG] = ACTIONS(2160),
    [anon_sym_LPAREN] = ACTIONS(2158),
    [anon_sym_COMMA] = ACTIONS(2160),
    [anon_sym_null] = ACTIONS(2158),
    [anon_sym_QMARK] = ACTIONS(2158),
    [anon_sym_COLON_QMARK] = ACTIONS(2158),
    [anon_sym_COLON_COLON] = ACTIONS(2160),
    [anon_sym_AMP] = ACTIONS(2158),
    [anon_sym_LBRACK] = ACTIONS(2158),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2160),
    [anon_sym_LBRACE] = ACTIONS(2158),
    [anon_sym_LT_AT] = ACTIONS(2158),
    [anon_sym_LT_AT_AT] = ACTIONS(2158),
    [anon_sym_DOT] = ACTIONS(2158),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2160),
    [anon_sym_new] = ACTIONS(2158),
    [anon_sym_return_BANG] = ACTIONS(2160),
    [anon_sym_yield] = ACTIONS(2158),
    [anon_sym_yield_BANG] = ACTIONS(2160),
    [anon_sym_lazy] = ACTIONS(2158),
    [anon_sym_assert] = ACTIONS(2158),
    [anon_sym_upcast] = ACTIONS(2158),
    [anon_sym_downcast] = ACTIONS(2158),
    [anon_sym_COLON_GT] = ACTIONS(2160),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2160),
    [anon_sym_for] = ACTIONS(2158),
    [anon_sym_while] = ACTIONS(2158),
    [anon_sym_if] = ACTIONS(2158),
    [anon_sym_fun] = ACTIONS(2158),
    [anon_sym_try] = ACTIONS(2158),
    [anon_sym_match] = ACTIONS(2158),
    [anon_sym_match_BANG] = ACTIONS(2160),
    [anon_sym_function] = ACTIONS(2158),
    [anon_sym_LT_DASH] = ACTIONS(2158),
    [anon_sym_DOT_LBRACK] = ACTIONS(2160),
    [anon_sym_LT] = ACTIONS(2160),
    [anon_sym_GT] = ACTIONS(2158),
    [anon_sym_use] = ACTIONS(2158),
    [anon_sym_use_BANG] = ACTIONS(2160),
    [anon_sym_do_BANG] = ACTIONS(2160),
    [anon_sym_begin] = ACTIONS(2158),
    [anon_sym_LPAREN2] = ACTIONS(2158),
    [anon_sym_or] = ACTIONS(2158),
    [aux_sym_char_token1] = ACTIONS(2160),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2158),
    [anon_sym_DQUOTE] = ACTIONS(2158),
    [anon_sym_AT_DQUOTE] = ACTIONS(2160),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2160),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2160),
    [sym_bool] = ACTIONS(2158),
    [sym_unit] = ACTIONS(2160),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2158),
    [sym_op_identifier] = ACTIONS(2158),
    [anon_sym_PLUS] = ACTIONS(2158),
    [anon_sym_DASH] = ACTIONS(2158),
    [anon_sym_PLUS_DOT] = ACTIONS(2158),
    [anon_sym_DASH_DOT] = ACTIONS(2158),
    [anon_sym_PERCENT] = ACTIONS(2158),
    [anon_sym_AMP_AMP] = ACTIONS(2158),
    [anon_sym_TILDE] = ACTIONS(2160),
    [aux_sym_prefix_op_token1] = ACTIONS(2158),
    [aux_sym_infix_op_token1] = ACTIONS(2160),
    [aux_sym_infix_op_token2] = ACTIONS(2158),
    [anon_sym_PIPE_PIPE] = ACTIONS(2158),
    [anon_sym_BANG_EQ] = ACTIONS(2158),
    [anon_sym_COLON_EQ] = ACTIONS(2160),
    [anon_sym_DOLLAR] = ACTIONS(2158),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2158),
    [sym_int] = ACTIONS(2158),
    [sym_xint] = ACTIONS(2160),
    [anon_sym_y] = ACTIONS(2631),
    [anon_sym_uy] = ACTIONS(2633),
    [anon_sym_s] = ACTIONS(2635),
    [anon_sym_us] = ACTIONS(2637),
    [anon_sym_l] = ACTIONS(2639),
    [aux_sym_uint32_token1] = ACTIONS(2641),
    [anon_sym_n] = ACTIONS(2643),
    [anon_sym_un] = ACTIONS(2645),
    [anon_sym_L] = ACTIONS(2647),
    [aux_sym_uint64_token1] = ACTIONS(2649),
    [anon_sym_lf] = ACTIONS(2733),
    [anon_sym_LF] = ACTIONS(2735),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2160),
    [sym__newline] = ACTIONS(2160),
  },
  [830] = {
    [sym_block_comment] = STATE(830),
    [sym_compiler_directive_decl] = STATE(830),
    [sym_fsi_directive_decl] = STATE(830),
    [sym_preproc_line] = STATE(830),
    [aux_sym_rules_repeat1] = STATE(826),
    [sym_identifier] = ACTIONS(2737),
    [anon_sym_EQ] = ACTIONS(2739),
    [anon_sym_LBRACK_LT] = ACTIONS(2739),
    [anon_sym_COLON] = ACTIONS(2737),
    [anon_sym_return] = ACTIONS(2737),
    [anon_sym_do] = ACTIONS(2737),
    [anon_sym_let] = ACTIONS(2737),
    [anon_sym_let_BANG] = ACTIONS(2739),
    [aux_sym_access_modifier_token1] = ACTIONS(2739),
    [anon_sym_LPAREN] = ACTIONS(2737),
    [anon_sym_COMMA] = ACTIONS(2739),
    [anon_sym_null] = ACTIONS(2737),
    [anon_sym_QMARK] = ACTIONS(2737),
    [anon_sym_COLON_QMARK] = ACTIONS(2737),
    [anon_sym_COLON_COLON] = ACTIONS(2739),
    [anon_sym_PIPE] = ACTIONS(2693),
    [anon_sym_AMP] = ACTIONS(2737),
    [anon_sym_LBRACK] = ACTIONS(2737),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2739),
    [anon_sym_LBRACE] = ACTIONS(2737),
    [anon_sym_LT_AT] = ACTIONS(2737),
    [anon_sym_LT_AT_AT] = ACTIONS(2737),
    [anon_sym_DOT] = ACTIONS(2737),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2739),
    [anon_sym_new] = ACTIONS(2737),
    [anon_sym_with] = ACTIONS(2737),
    [anon_sym_return_BANG] = ACTIONS(2739),
    [anon_sym_yield] = ACTIONS(2737),
    [anon_sym_yield_BANG] = ACTIONS(2739),
    [anon_sym_lazy] = ACTIONS(2737),
    [anon_sym_assert] = ACTIONS(2737),
    [anon_sym_upcast] = ACTIONS(2737),
    [anon_sym_downcast] = ACTIONS(2737),
    [anon_sym_COLON_GT] = ACTIONS(2739),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2739),
    [anon_sym_for] = ACTIONS(2737),
    [anon_sym_while] = ACTIONS(2737),
    [anon_sym_if] = ACTIONS(2737),
    [anon_sym_fun] = ACTIONS(2737),
    [anon_sym_try] = ACTIONS(2737),
    [anon_sym_match] = ACTIONS(2737),
    [anon_sym_match_BANG] = ACTIONS(2739),
    [anon_sym_function] = ACTIONS(2737),
    [anon_sym_LT_DASH] = ACTIONS(2737),
    [anon_sym_DOT_LBRACK] = ACTIONS(2739),
    [anon_sym_LT] = ACTIONS(2739),
    [anon_sym_use] = ACTIONS(2737),
    [anon_sym_use_BANG] = ACTIONS(2739),
    [anon_sym_do_BANG] = ACTIONS(2739),
    [anon_sym_begin] = ACTIONS(2737),
    [anon_sym_LPAREN2] = ACTIONS(2737),
    [anon_sym_DOT_DOT2] = ACTIONS(2739),
    [anon_sym_default] = ACTIONS(2737),
    [anon_sym_or] = ACTIONS(2737),
    [anon_sym_static] = ACTIONS(2737),
    [anon_sym_member] = ACTIONS(2737),
    [anon_sym_abstract] = ACTIONS(2737),
    [anon_sym_val] = ACTIONS(2737),
    [anon_sym_override] = ACTIONS(2737),
    [aux_sym_char_token1] = ACTIONS(2739),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2737),
    [anon_sym_DQUOTE] = ACTIONS(2737),
    [anon_sym_AT_DQUOTE] = ACTIONS(2739),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2739),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2739),
    [sym_bool] = ACTIONS(2737),
    [sym_unit] = ACTIONS(2739),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2737),
    [sym_op_identifier] = ACTIONS(2737),
    [anon_sym_PLUS] = ACTIONS(2737),
    [anon_sym_DASH] = ACTIONS(2737),
    [anon_sym_PLUS_DOT] = ACTIONS(2737),
    [anon_sym_DASH_DOT] = ACTIONS(2737),
    [anon_sym_PERCENT] = ACTIONS(2737),
    [anon_sym_AMP_AMP] = ACTIONS(2737),
    [anon_sym_TILDE] = ACTIONS(2739),
    [aux_sym_prefix_op_token1] = ACTIONS(2737),
    [aux_sym_infix_op_token1] = ACTIONS(2739),
    [aux_sym_infix_op_token2] = ACTIONS(2737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2737),
    [anon_sym_BANG_EQ] = ACTIONS(2737),
    [anon_sym_COLON_EQ] = ACTIONS(2739),
    [anon_sym_DOLLAR] = ACTIONS(2737),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2737),
    [sym_int] = ACTIONS(2737),
    [sym_xint] = ACTIONS(2739),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2739),
    [sym__newline] = ACTIONS(2741),
    [sym__dedent] = ACTIONS(2739),
  },
  [831] = {
    [sym_block_comment] = STATE(831),
    [sym_compiler_directive_decl] = STATE(831),
    [sym_fsi_directive_decl] = STATE(831),
    [sym_preproc_line] = STATE(831),
    [sym_identifier] = ACTIONS(2158),
    [anon_sym_EQ] = ACTIONS(2160),
    [anon_sym_COLON] = ACTIONS(2158),
    [anon_sym_return] = ACTIONS(2158),
    [anon_sym_do] = ACTIONS(2158),
    [anon_sym_let] = ACTIONS(2158),
    [anon_sym_let_BANG] = ACTIONS(2160),
    [anon_sym_LPAREN] = ACTIONS(2158),
    [anon_sym_COMMA] = ACTIONS(2160),
    [anon_sym_null] = ACTIONS(2158),
    [anon_sym_QMARK] = ACTIONS(2158),
    [anon_sym_COLON_QMARK] = ACTIONS(2158),
    [anon_sym_COLON_COLON] = ACTIONS(2160),
    [anon_sym_AMP] = ACTIONS(2158),
    [anon_sym_LBRACK] = ACTIONS(2158),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2160),
    [anon_sym_LBRACE] = ACTIONS(2158),
    [anon_sym_LT_AT] = ACTIONS(2158),
    [anon_sym_LT_AT_AT] = ACTIONS(2158),
    [anon_sym_AT_AT_GT] = ACTIONS(2158),
    [anon_sym_DOT] = ACTIONS(2158),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2160),
    [anon_sym_new] = ACTIONS(2158),
    [anon_sym_return_BANG] = ACTIONS(2160),
    [anon_sym_yield] = ACTIONS(2158),
    [anon_sym_yield_BANG] = ACTIONS(2160),
    [anon_sym_lazy] = ACTIONS(2158),
    [anon_sym_assert] = ACTIONS(2158),
    [anon_sym_upcast] = ACTIONS(2158),
    [anon_sym_downcast] = ACTIONS(2158),
    [anon_sym_COLON_GT] = ACTIONS(2160),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2160),
    [anon_sym_for] = ACTIONS(2158),
    [anon_sym_while] = ACTIONS(2158),
    [anon_sym_if] = ACTIONS(2158),
    [anon_sym_fun] = ACTIONS(2158),
    [anon_sym_try] = ACTIONS(2158),
    [anon_sym_match] = ACTIONS(2158),
    [anon_sym_match_BANG] = ACTIONS(2160),
    [anon_sym_function] = ACTIONS(2158),
    [anon_sym_LT_DASH] = ACTIONS(2158),
    [anon_sym_DOT_LBRACK] = ACTIONS(2160),
    [anon_sym_LT] = ACTIONS(2160),
    [anon_sym_use] = ACTIONS(2158),
    [anon_sym_use_BANG] = ACTIONS(2160),
    [anon_sym_do_BANG] = ACTIONS(2160),
    [anon_sym_begin] = ACTIONS(2158),
    [anon_sym_LPAREN2] = ACTIONS(2158),
    [anon_sym_or] = ACTIONS(2158),
    [aux_sym_char_token1] = ACTIONS(2160),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2158),
    [anon_sym_DQUOTE] = ACTIONS(2158),
    [anon_sym_AT_DQUOTE] = ACTIONS(2160),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2160),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2160),
    [sym_bool] = ACTIONS(2158),
    [sym_unit] = ACTIONS(2160),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2158),
    [sym_op_identifier] = ACTIONS(2158),
    [anon_sym_PLUS] = ACTIONS(2158),
    [anon_sym_DASH] = ACTIONS(2158),
    [anon_sym_PLUS_DOT] = ACTIONS(2158),
    [anon_sym_DASH_DOT] = ACTIONS(2158),
    [anon_sym_PERCENT] = ACTIONS(2158),
    [anon_sym_AMP_AMP] = ACTIONS(2158),
    [anon_sym_TILDE] = ACTIONS(2160),
    [aux_sym_prefix_op_token1] = ACTIONS(2158),
    [aux_sym_infix_op_token1] = ACTIONS(2160),
    [aux_sym_infix_op_token2] = ACTIONS(2158),
    [anon_sym_PIPE_PIPE] = ACTIONS(2158),
    [anon_sym_BANG_EQ] = ACTIONS(2158),
    [anon_sym_COLON_EQ] = ACTIONS(2160),
    [anon_sym_DOLLAR] = ACTIONS(2158),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2158),
    [sym_int] = ACTIONS(2158),
    [sym_xint] = ACTIONS(2160),
    [anon_sym_y] = ACTIONS(2525),
    [anon_sym_uy] = ACTIONS(2527),
    [anon_sym_s] = ACTIONS(2529),
    [anon_sym_us] = ACTIONS(2531),
    [anon_sym_l] = ACTIONS(2533),
    [aux_sym_uint32_token1] = ACTIONS(2535),
    [anon_sym_n] = ACTIONS(2537),
    [anon_sym_un] = ACTIONS(2539),
    [anon_sym_L] = ACTIONS(2541),
    [aux_sym_uint64_token1] = ACTIONS(2543),
    [anon_sym_lf] = ACTIONS(2744),
    [anon_sym_LF] = ACTIONS(2746),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2160),
    [sym__newline] = ACTIONS(2160),
  },
  [832] = {
    [sym_block_comment] = STATE(832),
    [sym_compiler_directive_decl] = STATE(832),
    [sym_fsi_directive_decl] = STATE(832),
    [sym_preproc_line] = STATE(832),
    [aux_sym_rules_repeat1] = STATE(826),
    [sym_identifier] = ACTIONS(2698),
    [anon_sym_EQ] = ACTIONS(2700),
    [anon_sym_LBRACK_LT] = ACTIONS(2700),
    [anon_sym_COLON] = ACTIONS(2698),
    [anon_sym_return] = ACTIONS(2698),
    [anon_sym_do] = ACTIONS(2698),
    [anon_sym_let] = ACTIONS(2698),
    [anon_sym_let_BANG] = ACTIONS(2700),
    [aux_sym_access_modifier_token1] = ACTIONS(2700),
    [anon_sym_LPAREN] = ACTIONS(2698),
    [anon_sym_COMMA] = ACTIONS(2700),
    [anon_sym_null] = ACTIONS(2698),
    [anon_sym_QMARK] = ACTIONS(2698),
    [anon_sym_COLON_QMARK] = ACTIONS(2698),
    [anon_sym_COLON_COLON] = ACTIONS(2700),
    [anon_sym_PIPE] = ACTIONS(2693),
    [anon_sym_AMP] = ACTIONS(2698),
    [anon_sym_LBRACK] = ACTIONS(2698),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2700),
    [anon_sym_LBRACE] = ACTIONS(2698),
    [anon_sym_LT_AT] = ACTIONS(2698),
    [anon_sym_LT_AT_AT] = ACTIONS(2698),
    [anon_sym_DOT] = ACTIONS(2698),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2700),
    [anon_sym_new] = ACTIONS(2698),
    [anon_sym_with] = ACTIONS(2698),
    [anon_sym_return_BANG] = ACTIONS(2700),
    [anon_sym_yield] = ACTIONS(2698),
    [anon_sym_yield_BANG] = ACTIONS(2700),
    [anon_sym_lazy] = ACTIONS(2698),
    [anon_sym_assert] = ACTIONS(2698),
    [anon_sym_upcast] = ACTIONS(2698),
    [anon_sym_downcast] = ACTIONS(2698),
    [anon_sym_COLON_GT] = ACTIONS(2700),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2700),
    [anon_sym_for] = ACTIONS(2698),
    [anon_sym_while] = ACTIONS(2698),
    [anon_sym_if] = ACTIONS(2698),
    [anon_sym_fun] = ACTIONS(2698),
    [anon_sym_try] = ACTIONS(2698),
    [anon_sym_match] = ACTIONS(2698),
    [anon_sym_match_BANG] = ACTIONS(2700),
    [anon_sym_function] = ACTIONS(2698),
    [anon_sym_LT_DASH] = ACTIONS(2698),
    [anon_sym_DOT_LBRACK] = ACTIONS(2700),
    [anon_sym_LT] = ACTIONS(2700),
    [anon_sym_use] = ACTIONS(2698),
    [anon_sym_use_BANG] = ACTIONS(2700),
    [anon_sym_do_BANG] = ACTIONS(2700),
    [anon_sym_begin] = ACTIONS(2698),
    [anon_sym_LPAREN2] = ACTIONS(2698),
    [anon_sym_DOT_DOT2] = ACTIONS(2700),
    [anon_sym_default] = ACTIONS(2698),
    [anon_sym_or] = ACTIONS(2698),
    [anon_sym_static] = ACTIONS(2698),
    [anon_sym_member] = ACTIONS(2698),
    [anon_sym_abstract] = ACTIONS(2698),
    [anon_sym_val] = ACTIONS(2698),
    [anon_sym_override] = ACTIONS(2698),
    [aux_sym_char_token1] = ACTIONS(2700),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2698),
    [anon_sym_DQUOTE] = ACTIONS(2698),
    [anon_sym_AT_DQUOTE] = ACTIONS(2700),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2700),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2700),
    [sym_bool] = ACTIONS(2698),
    [sym_unit] = ACTIONS(2700),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2698),
    [sym_op_identifier] = ACTIONS(2698),
    [anon_sym_PLUS] = ACTIONS(2698),
    [anon_sym_DASH] = ACTIONS(2698),
    [anon_sym_PLUS_DOT] = ACTIONS(2698),
    [anon_sym_DASH_DOT] = ACTIONS(2698),
    [anon_sym_PERCENT] = ACTIONS(2698),
    [anon_sym_AMP_AMP] = ACTIONS(2698),
    [anon_sym_TILDE] = ACTIONS(2700),
    [aux_sym_prefix_op_token1] = ACTIONS(2698),
    [aux_sym_infix_op_token1] = ACTIONS(2700),
    [aux_sym_infix_op_token2] = ACTIONS(2698),
    [anon_sym_PIPE_PIPE] = ACTIONS(2698),
    [anon_sym_BANG_EQ] = ACTIONS(2698),
    [anon_sym_COLON_EQ] = ACTIONS(2700),
    [anon_sym_DOLLAR] = ACTIONS(2698),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2698),
    [sym_int] = ACTIONS(2698),
    [sym_xint] = ACTIONS(2700),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2700),
    [sym__newline] = ACTIONS(2702),
    [sym__dedent] = ACTIONS(2700),
  },
  [833] = {
    [sym_block_comment] = STATE(833),
    [sym_compiler_directive_decl] = STATE(833),
    [sym_fsi_directive_decl] = STATE(833),
    [sym_preproc_line] = STATE(833),
    [sym_identifier] = ACTIONS(2748),
    [anon_sym_EQ] = ACTIONS(2750),
    [anon_sym_LBRACK_LT] = ACTIONS(2750),
    [anon_sym_COLON] = ACTIONS(2748),
    [anon_sym_return] = ACTIONS(2748),
    [anon_sym_do] = ACTIONS(2748),
    [anon_sym_let] = ACTIONS(2748),
    [anon_sym_let_BANG] = ACTIONS(2750),
    [aux_sym_access_modifier_token1] = ACTIONS(2750),
    [anon_sym_LPAREN] = ACTIONS(2748),
    [anon_sym_COMMA] = ACTIONS(2750),
    [anon_sym_null] = ACTIONS(2748),
    [anon_sym_QMARK] = ACTIONS(2748),
    [anon_sym_COLON_QMARK] = ACTIONS(2748),
    [anon_sym_COLON_COLON] = ACTIONS(2750),
    [anon_sym_AMP] = ACTIONS(2748),
    [anon_sym_LBRACK] = ACTIONS(2748),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2750),
    [anon_sym_LBRACE] = ACTIONS(2748),
    [anon_sym_LT_AT] = ACTIONS(2748),
    [anon_sym_LT_AT_AT] = ACTIONS(2748),
    [anon_sym_DOT] = ACTIONS(2748),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2750),
    [anon_sym_new] = ACTIONS(2748),
    [anon_sym_with] = ACTIONS(2748),
    [anon_sym_return_BANG] = ACTIONS(2750),
    [anon_sym_yield] = ACTIONS(2748),
    [anon_sym_yield_BANG] = ACTIONS(2750),
    [anon_sym_lazy] = ACTIONS(2748),
    [anon_sym_assert] = ACTIONS(2748),
    [anon_sym_upcast] = ACTIONS(2748),
    [anon_sym_downcast] = ACTIONS(2748),
    [anon_sym_COLON_GT] = ACTIONS(2750),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2750),
    [anon_sym_for] = ACTIONS(2748),
    [anon_sym_while] = ACTIONS(2748),
    [anon_sym_else] = ACTIONS(2748),
    [anon_sym_elif] = ACTIONS(2748),
    [anon_sym_if] = ACTIONS(2748),
    [anon_sym_fun] = ACTIONS(2748),
    [anon_sym_try] = ACTIONS(2748),
    [anon_sym_match] = ACTIONS(2748),
    [anon_sym_match_BANG] = ACTIONS(2750),
    [anon_sym_function] = ACTIONS(2748),
    [anon_sym_LT_DASH] = ACTIONS(2748),
    [anon_sym_DOT_LBRACK] = ACTIONS(2750),
    [anon_sym_LT] = ACTIONS(2750),
    [anon_sym_use] = ACTIONS(2748),
    [anon_sym_use_BANG] = ACTIONS(2750),
    [anon_sym_do_BANG] = ACTIONS(2750),
    [anon_sym_begin] = ACTIONS(2748),
    [anon_sym_LPAREN2] = ACTIONS(2748),
    [anon_sym_DOT_DOT2] = ACTIONS(2750),
    [anon_sym_default] = ACTIONS(2748),
    [anon_sym_or] = ACTIONS(2748),
    [anon_sym_static] = ACTIONS(2748),
    [anon_sym_member] = ACTIONS(2748),
    [anon_sym_abstract] = ACTIONS(2748),
    [anon_sym_val] = ACTIONS(2748),
    [anon_sym_override] = ACTIONS(2748),
    [aux_sym_char_token1] = ACTIONS(2750),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2748),
    [anon_sym_DQUOTE] = ACTIONS(2748),
    [anon_sym_AT_DQUOTE] = ACTIONS(2750),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2750),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2750),
    [sym_bool] = ACTIONS(2748),
    [sym_unit] = ACTIONS(2750),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2748),
    [sym_op_identifier] = ACTIONS(2748),
    [anon_sym_PLUS] = ACTIONS(2748),
    [anon_sym_DASH] = ACTIONS(2748),
    [anon_sym_PLUS_DOT] = ACTIONS(2748),
    [anon_sym_DASH_DOT] = ACTIONS(2748),
    [anon_sym_PERCENT] = ACTIONS(2748),
    [anon_sym_AMP_AMP] = ACTIONS(2748),
    [anon_sym_TILDE] = ACTIONS(2750),
    [aux_sym_prefix_op_token1] = ACTIONS(2748),
    [aux_sym_infix_op_token1] = ACTIONS(2750),
    [aux_sym_infix_op_token2] = ACTIONS(2748),
    [anon_sym_PIPE_PIPE] = ACTIONS(2748),
    [anon_sym_BANG_EQ] = ACTIONS(2748),
    [anon_sym_COLON_EQ] = ACTIONS(2750),
    [anon_sym_DOLLAR] = ACTIONS(2748),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2748),
    [sym_int] = ACTIONS(2748),
    [sym_xint] = ACTIONS(2750),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2750),
    [sym__newline] = ACTIONS(2750),
    [sym__dedent] = ACTIONS(2750),
  },
  [834] = {
    [sym_block_comment] = STATE(834),
    [sym_compiler_directive_decl] = STATE(834),
    [sym_fsi_directive_decl] = STATE(834),
    [sym_preproc_line] = STATE(834),
    [sym_identifier] = ACTIONS(2158),
    [anon_sym_EQ] = ACTIONS(2160),
    [anon_sym_COLON] = ACTIONS(2158),
    [anon_sym_return] = ACTIONS(2158),
    [anon_sym_do] = ACTIONS(2158),
    [anon_sym_let] = ACTIONS(2158),
    [anon_sym_let_BANG] = ACTIONS(2160),
    [anon_sym_LPAREN] = ACTIONS(2158),
    [anon_sym_COMMA] = ACTIONS(2160),
    [anon_sym_null] = ACTIONS(2158),
    [anon_sym_QMARK] = ACTIONS(2158),
    [anon_sym_COLON_QMARK] = ACTIONS(2158),
    [anon_sym_COLON_COLON] = ACTIONS(2160),
    [anon_sym_AMP] = ACTIONS(2158),
    [anon_sym_LBRACK] = ACTIONS(2158),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2160),
    [anon_sym_LBRACE] = ACTIONS(2158),
    [anon_sym_LT_AT] = ACTIONS(2158),
    [anon_sym_LT_AT_AT] = ACTIONS(2158),
    [anon_sym_DOT] = ACTIONS(2158),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2160),
    [anon_sym_new] = ACTIONS(2158),
    [anon_sym_return_BANG] = ACTIONS(2160),
    [anon_sym_yield] = ACTIONS(2158),
    [anon_sym_yield_BANG] = ACTIONS(2160),
    [anon_sym_lazy] = ACTIONS(2158),
    [anon_sym_assert] = ACTIONS(2158),
    [anon_sym_upcast] = ACTIONS(2158),
    [anon_sym_downcast] = ACTIONS(2158),
    [anon_sym_COLON_GT] = ACTIONS(2160),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2160),
    [anon_sym_for] = ACTIONS(2158),
    [anon_sym_while] = ACTIONS(2158),
    [anon_sym_if] = ACTIONS(2158),
    [anon_sym_fun] = ACTIONS(2158),
    [anon_sym_try] = ACTIONS(2158),
    [anon_sym_match] = ACTIONS(2158),
    [anon_sym_match_BANG] = ACTIONS(2160),
    [anon_sym_function] = ACTIONS(2158),
    [anon_sym_LT_DASH] = ACTIONS(2158),
    [anon_sym_DOT_LBRACK] = ACTIONS(2160),
    [anon_sym_LT] = ACTIONS(2160),
    [anon_sym_use] = ACTIONS(2158),
    [anon_sym_use_BANG] = ACTIONS(2160),
    [anon_sym_do_BANG] = ACTIONS(2160),
    [anon_sym_begin] = ACTIONS(2158),
    [anon_sym_LPAREN2] = ACTIONS(2158),
    [anon_sym_or] = ACTIONS(2158),
    [aux_sym_char_token1] = ACTIONS(2160),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2158),
    [anon_sym_DQUOTE] = ACTIONS(2158),
    [anon_sym_AT_DQUOTE] = ACTIONS(2160),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2160),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2160),
    [sym_bool] = ACTIONS(2158),
    [sym_unit] = ACTIONS(2160),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2158),
    [sym_op_identifier] = ACTIONS(2158),
    [anon_sym_PLUS] = ACTIONS(2158),
    [anon_sym_DASH] = ACTIONS(2158),
    [anon_sym_PLUS_DOT] = ACTIONS(2158),
    [anon_sym_DASH_DOT] = ACTIONS(2158),
    [anon_sym_PERCENT] = ACTIONS(2158),
    [anon_sym_AMP_AMP] = ACTIONS(2158),
    [anon_sym_TILDE] = ACTIONS(2160),
    [aux_sym_prefix_op_token1] = ACTIONS(2158),
    [aux_sym_infix_op_token1] = ACTIONS(2160),
    [aux_sym_infix_op_token2] = ACTIONS(2158),
    [anon_sym_PIPE_PIPE] = ACTIONS(2158),
    [anon_sym_BANG_EQ] = ACTIONS(2158),
    [anon_sym_COLON_EQ] = ACTIONS(2160),
    [anon_sym_DOLLAR] = ACTIONS(2158),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2158),
    [sym_int] = ACTIONS(2158),
    [sym_xint] = ACTIONS(2160),
    [anon_sym_y] = ACTIONS(2599),
    [anon_sym_uy] = ACTIONS(2601),
    [anon_sym_s] = ACTIONS(2603),
    [anon_sym_us] = ACTIONS(2605),
    [anon_sym_l] = ACTIONS(2607),
    [aux_sym_uint32_token1] = ACTIONS(2609),
    [anon_sym_n] = ACTIONS(2611),
    [anon_sym_un] = ACTIONS(2613),
    [anon_sym_L] = ACTIONS(2615),
    [aux_sym_uint64_token1] = ACTIONS(2617),
    [anon_sym_lf] = ACTIONS(2752),
    [anon_sym_LF] = ACTIONS(2754),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2160),
    [anon_sym_POUNDendif] = ACTIONS(2160),
    [sym__newline] = ACTIONS(2160),
  },
  [835] = {
    [sym_block_comment] = STATE(835),
    [sym_compiler_directive_decl] = STATE(835),
    [sym_fsi_directive_decl] = STATE(835),
    [sym_preproc_line] = STATE(835),
    [sym_identifier] = ACTIONS(2756),
    [anon_sym_EQ] = ACTIONS(2758),
    [anon_sym_LBRACK_LT] = ACTIONS(2758),
    [anon_sym_COLON] = ACTIONS(2756),
    [anon_sym_return] = ACTIONS(2756),
    [anon_sym_do] = ACTIONS(2756),
    [anon_sym_let] = ACTIONS(2756),
    [anon_sym_let_BANG] = ACTIONS(2758),
    [aux_sym_access_modifier_token1] = ACTIONS(2758),
    [anon_sym_LPAREN] = ACTIONS(2756),
    [anon_sym_COMMA] = ACTIONS(2758),
    [anon_sym_null] = ACTIONS(2756),
    [anon_sym_QMARK] = ACTIONS(2756),
    [anon_sym_COLON_QMARK] = ACTIONS(2756),
    [anon_sym_COLON_COLON] = ACTIONS(2758),
    [anon_sym_PIPE] = ACTIONS(2756),
    [anon_sym_AMP] = ACTIONS(2756),
    [anon_sym_LBRACK] = ACTIONS(2756),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2758),
    [anon_sym_LBRACE] = ACTIONS(2756),
    [anon_sym_LT_AT] = ACTIONS(2756),
    [anon_sym_LT_AT_AT] = ACTIONS(2756),
    [anon_sym_DOT] = ACTIONS(2756),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2758),
    [anon_sym_new] = ACTIONS(2756),
    [anon_sym_with] = ACTIONS(2756),
    [anon_sym_return_BANG] = ACTIONS(2758),
    [anon_sym_yield] = ACTIONS(2756),
    [anon_sym_yield_BANG] = ACTIONS(2758),
    [anon_sym_lazy] = ACTIONS(2756),
    [anon_sym_assert] = ACTIONS(2756),
    [anon_sym_upcast] = ACTIONS(2756),
    [anon_sym_downcast] = ACTIONS(2756),
    [anon_sym_COLON_GT] = ACTIONS(2758),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2758),
    [anon_sym_for] = ACTIONS(2756),
    [anon_sym_while] = ACTIONS(2756),
    [anon_sym_if] = ACTIONS(2756),
    [anon_sym_fun] = ACTIONS(2756),
    [anon_sym_try] = ACTIONS(2756),
    [anon_sym_match] = ACTIONS(2756),
    [anon_sym_match_BANG] = ACTIONS(2758),
    [anon_sym_function] = ACTIONS(2756),
    [anon_sym_LT_DASH] = ACTIONS(2756),
    [anon_sym_DOT_LBRACK] = ACTIONS(2758),
    [anon_sym_LT] = ACTIONS(2758),
    [anon_sym_use] = ACTIONS(2756),
    [anon_sym_use_BANG] = ACTIONS(2758),
    [anon_sym_do_BANG] = ACTIONS(2758),
    [anon_sym_begin] = ACTIONS(2756),
    [anon_sym_LPAREN2] = ACTIONS(2756),
    [anon_sym_DOT_DOT2] = ACTIONS(2758),
    [anon_sym_default] = ACTIONS(2756),
    [anon_sym_or] = ACTIONS(2756),
    [anon_sym_static] = ACTIONS(2756),
    [anon_sym_member] = ACTIONS(2756),
    [anon_sym_abstract] = ACTIONS(2756),
    [anon_sym_val] = ACTIONS(2756),
    [anon_sym_override] = ACTIONS(2756),
    [aux_sym_char_token1] = ACTIONS(2758),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2756),
    [anon_sym_DQUOTE] = ACTIONS(2756),
    [anon_sym_AT_DQUOTE] = ACTIONS(2758),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2758),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2758),
    [sym_bool] = ACTIONS(2756),
    [sym_unit] = ACTIONS(2758),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2756),
    [sym_op_identifier] = ACTIONS(2756),
    [anon_sym_PLUS] = ACTIONS(2756),
    [anon_sym_DASH] = ACTIONS(2756),
    [anon_sym_PLUS_DOT] = ACTIONS(2756),
    [anon_sym_DASH_DOT] = ACTIONS(2756),
    [anon_sym_PERCENT] = ACTIONS(2756),
    [anon_sym_AMP_AMP] = ACTIONS(2756),
    [anon_sym_TILDE] = ACTIONS(2758),
    [aux_sym_prefix_op_token1] = ACTIONS(2756),
    [aux_sym_infix_op_token1] = ACTIONS(2758),
    [aux_sym_infix_op_token2] = ACTIONS(2756),
    [anon_sym_PIPE_PIPE] = ACTIONS(2756),
    [anon_sym_BANG_EQ] = ACTIONS(2756),
    [anon_sym_COLON_EQ] = ACTIONS(2758),
    [anon_sym_DOLLAR] = ACTIONS(2756),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2756),
    [sym_int] = ACTIONS(2756),
    [sym_xint] = ACTIONS(2758),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2758),
    [sym__newline] = ACTIONS(2758),
    [sym__dedent] = ACTIONS(2758),
  },
  [836] = {
    [sym_block_comment] = STATE(836),
    [sym_compiler_directive_decl] = STATE(836),
    [sym_fsi_directive_decl] = STATE(836),
    [sym_preproc_line] = STATE(836),
    [sym_identifier] = ACTIONS(2760),
    [anon_sym_EQ] = ACTIONS(2762),
    [anon_sym_LBRACK_LT] = ACTIONS(2762),
    [anon_sym_COLON] = ACTIONS(2760),
    [anon_sym_return] = ACTIONS(2760),
    [anon_sym_do] = ACTIONS(2760),
    [anon_sym_let] = ACTIONS(2760),
    [anon_sym_let_BANG] = ACTIONS(2762),
    [aux_sym_access_modifier_token1] = ACTIONS(2762),
    [anon_sym_LPAREN] = ACTIONS(2760),
    [anon_sym_COMMA] = ACTIONS(2762),
    [anon_sym_null] = ACTIONS(2760),
    [anon_sym_QMARK] = ACTIONS(2760),
    [anon_sym_COLON_QMARK] = ACTIONS(2760),
    [anon_sym_COLON_COLON] = ACTIONS(2762),
    [anon_sym_PIPE] = ACTIONS(2760),
    [anon_sym_AMP] = ACTIONS(2760),
    [anon_sym_LBRACK] = ACTIONS(2760),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2762),
    [anon_sym_LBRACE] = ACTIONS(2760),
    [anon_sym_LT_AT] = ACTIONS(2760),
    [anon_sym_LT_AT_AT] = ACTIONS(2760),
    [anon_sym_DOT] = ACTIONS(2760),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2762),
    [anon_sym_new] = ACTIONS(2760),
    [anon_sym_with] = ACTIONS(2760),
    [anon_sym_return_BANG] = ACTIONS(2762),
    [anon_sym_yield] = ACTIONS(2760),
    [anon_sym_yield_BANG] = ACTIONS(2762),
    [anon_sym_lazy] = ACTIONS(2760),
    [anon_sym_assert] = ACTIONS(2760),
    [anon_sym_upcast] = ACTIONS(2760),
    [anon_sym_downcast] = ACTIONS(2760),
    [anon_sym_COLON_GT] = ACTIONS(2762),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2762),
    [anon_sym_for] = ACTIONS(2760),
    [anon_sym_while] = ACTIONS(2760),
    [anon_sym_if] = ACTIONS(2760),
    [anon_sym_fun] = ACTIONS(2760),
    [anon_sym_try] = ACTIONS(2760),
    [anon_sym_match] = ACTIONS(2760),
    [anon_sym_match_BANG] = ACTIONS(2762),
    [anon_sym_function] = ACTIONS(2760),
    [anon_sym_LT_DASH] = ACTIONS(2760),
    [anon_sym_DOT_LBRACK] = ACTIONS(2762),
    [anon_sym_LT] = ACTIONS(2762),
    [anon_sym_use] = ACTIONS(2760),
    [anon_sym_use_BANG] = ACTIONS(2762),
    [anon_sym_do_BANG] = ACTIONS(2762),
    [anon_sym_begin] = ACTIONS(2760),
    [anon_sym_LPAREN2] = ACTIONS(2760),
    [anon_sym_DOT_DOT2] = ACTIONS(2762),
    [anon_sym_default] = ACTIONS(2760),
    [anon_sym_or] = ACTIONS(2760),
    [anon_sym_static] = ACTIONS(2760),
    [anon_sym_member] = ACTIONS(2760),
    [anon_sym_abstract] = ACTIONS(2760),
    [anon_sym_val] = ACTIONS(2760),
    [anon_sym_override] = ACTIONS(2760),
    [aux_sym_char_token1] = ACTIONS(2762),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2760),
    [anon_sym_DQUOTE] = ACTIONS(2760),
    [anon_sym_AT_DQUOTE] = ACTIONS(2762),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2762),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2762),
    [sym_bool] = ACTIONS(2760),
    [sym_unit] = ACTIONS(2762),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2760),
    [sym_op_identifier] = ACTIONS(2760),
    [anon_sym_PLUS] = ACTIONS(2760),
    [anon_sym_DASH] = ACTIONS(2760),
    [anon_sym_PLUS_DOT] = ACTIONS(2760),
    [anon_sym_DASH_DOT] = ACTIONS(2760),
    [anon_sym_PERCENT] = ACTIONS(2760),
    [anon_sym_AMP_AMP] = ACTIONS(2760),
    [anon_sym_TILDE] = ACTIONS(2762),
    [aux_sym_prefix_op_token1] = ACTIONS(2760),
    [aux_sym_infix_op_token1] = ACTIONS(2762),
    [aux_sym_infix_op_token2] = ACTIONS(2760),
    [anon_sym_PIPE_PIPE] = ACTIONS(2760),
    [anon_sym_BANG_EQ] = ACTIONS(2760),
    [anon_sym_COLON_EQ] = ACTIONS(2762),
    [anon_sym_DOLLAR] = ACTIONS(2760),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2760),
    [sym_int] = ACTIONS(2760),
    [sym_xint] = ACTIONS(2762),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2762),
    [sym__newline] = ACTIONS(2762),
    [sym__dedent] = ACTIONS(2762),
  },
  [837] = {
    [sym_block_comment] = STATE(837),
    [sym_compiler_directive_decl] = STATE(837),
    [sym_fsi_directive_decl] = STATE(837),
    [sym_preproc_line] = STATE(837),
    [aux_sym_long_identifier_repeat1] = STATE(861),
    [sym_identifier] = ACTIONS(2418),
    [anon_sym_EQ] = ACTIONS(2420),
    [anon_sym_LBRACK_LT] = ACTIONS(2420),
    [anon_sym_COLON] = ACTIONS(2418),
    [anon_sym_return] = ACTIONS(2418),
    [anon_sym_do] = ACTIONS(2418),
    [anon_sym_let] = ACTIONS(2418),
    [anon_sym_let_BANG] = ACTIONS(2420),
    [aux_sym_access_modifier_token1] = ACTIONS(2420),
    [anon_sym_LPAREN] = ACTIONS(2418),
    [anon_sym_COMMA] = ACTIONS(2420),
    [anon_sym_null] = ACTIONS(2418),
    [anon_sym_QMARK] = ACTIONS(2418),
    [anon_sym_COLON_QMARK] = ACTIONS(2418),
    [anon_sym_COLON_COLON] = ACTIONS(2420),
    [anon_sym_AMP] = ACTIONS(2418),
    [anon_sym_LBRACK] = ACTIONS(2418),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2420),
    [anon_sym_LBRACE] = ACTIONS(2418),
    [anon_sym_LT_AT] = ACTIONS(2418),
    [anon_sym_LT_AT_AT] = ACTIONS(2418),
    [anon_sym_DOT] = ACTIONS(2764),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2420),
    [anon_sym_new] = ACTIONS(2418),
    [anon_sym_with] = ACTIONS(2418),
    [anon_sym_return_BANG] = ACTIONS(2420),
    [anon_sym_yield] = ACTIONS(2418),
    [anon_sym_yield_BANG] = ACTIONS(2420),
    [anon_sym_lazy] = ACTIONS(2418),
    [anon_sym_assert] = ACTIONS(2418),
    [anon_sym_upcast] = ACTIONS(2418),
    [anon_sym_downcast] = ACTIONS(2418),
    [anon_sym_COLON_GT] = ACTIONS(2420),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2420),
    [anon_sym_for] = ACTIONS(2418),
    [anon_sym_while] = ACTIONS(2418),
    [anon_sym_if] = ACTIONS(2418),
    [anon_sym_fun] = ACTIONS(2418),
    [anon_sym_try] = ACTIONS(2418),
    [anon_sym_match] = ACTIONS(2418),
    [anon_sym_match_BANG] = ACTIONS(2420),
    [anon_sym_function] = ACTIONS(2418),
    [anon_sym_LT_DASH] = ACTIONS(2418),
    [anon_sym_DOT_LBRACK] = ACTIONS(2420),
    [anon_sym_LT] = ACTIONS(2420),
    [anon_sym_use] = ACTIONS(2418),
    [anon_sym_use_BANG] = ACTIONS(2420),
    [anon_sym_do_BANG] = ACTIONS(2420),
    [anon_sym_begin] = ACTIONS(2418),
    [anon_sym_LPAREN2] = ACTIONS(2418),
    [anon_sym_DOT_DOT2] = ACTIONS(2420),
    [anon_sym_default] = ACTIONS(2418),
    [anon_sym_or] = ACTIONS(2418),
    [anon_sym_static] = ACTIONS(2418),
    [anon_sym_member] = ACTIONS(2418),
    [anon_sym_abstract] = ACTIONS(2418),
    [anon_sym_val] = ACTIONS(2418),
    [anon_sym_override] = ACTIONS(2418),
    [aux_sym_char_token1] = ACTIONS(2420),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2418),
    [anon_sym_DQUOTE] = ACTIONS(2418),
    [anon_sym_AT_DQUOTE] = ACTIONS(2420),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2420),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2420),
    [sym_bool] = ACTIONS(2418),
    [sym_unit] = ACTIONS(2420),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2418),
    [sym_op_identifier] = ACTIONS(2418),
    [anon_sym_PLUS] = ACTIONS(2418),
    [anon_sym_DASH] = ACTIONS(2418),
    [anon_sym_PLUS_DOT] = ACTIONS(2418),
    [anon_sym_DASH_DOT] = ACTIONS(2418),
    [anon_sym_PERCENT] = ACTIONS(2418),
    [anon_sym_AMP_AMP] = ACTIONS(2418),
    [anon_sym_TILDE] = ACTIONS(2420),
    [aux_sym_prefix_op_token1] = ACTIONS(2418),
    [aux_sym_infix_op_token1] = ACTIONS(2420),
    [aux_sym_infix_op_token2] = ACTIONS(2418),
    [anon_sym_PIPE_PIPE] = ACTIONS(2418),
    [anon_sym_BANG_EQ] = ACTIONS(2418),
    [anon_sym_COLON_EQ] = ACTIONS(2420),
    [anon_sym_DOLLAR] = ACTIONS(2418),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2418),
    [sym_int] = ACTIONS(2418),
    [sym_xint] = ACTIONS(2420),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2420),
    [sym__newline] = ACTIONS(2420),
    [sym__dedent] = ACTIONS(2420),
  },
  [838] = {
    [sym_block_comment] = STATE(838),
    [sym_compiler_directive_decl] = STATE(838),
    [sym_fsi_directive_decl] = STATE(838),
    [sym_preproc_line] = STATE(838),
    [sym_identifier] = ACTIONS(2766),
    [anon_sym_EQ] = ACTIONS(2768),
    [anon_sym_LBRACK_LT] = ACTIONS(2768),
    [anon_sym_COLON] = ACTIONS(2766),
    [anon_sym_return] = ACTIONS(2766),
    [anon_sym_do] = ACTIONS(2766),
    [anon_sym_let] = ACTIONS(2766),
    [anon_sym_let_BANG] = ACTIONS(2768),
    [aux_sym_access_modifier_token1] = ACTIONS(2768),
    [anon_sym_LPAREN] = ACTIONS(2766),
    [anon_sym_COMMA] = ACTIONS(2768),
    [anon_sym_null] = ACTIONS(2766),
    [anon_sym_QMARK] = ACTIONS(2766),
    [anon_sym_COLON_QMARK] = ACTIONS(2766),
    [anon_sym_COLON_COLON] = ACTIONS(2768),
    [anon_sym_PIPE] = ACTIONS(2766),
    [anon_sym_AMP] = ACTIONS(2766),
    [anon_sym_LBRACK] = ACTIONS(2766),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2768),
    [anon_sym_LBRACE] = ACTIONS(2766),
    [anon_sym_LT_AT] = ACTIONS(2766),
    [anon_sym_LT_AT_AT] = ACTIONS(2766),
    [anon_sym_DOT] = ACTIONS(2766),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2768),
    [anon_sym_new] = ACTIONS(2766),
    [anon_sym_with] = ACTIONS(2766),
    [anon_sym_return_BANG] = ACTIONS(2768),
    [anon_sym_yield] = ACTIONS(2766),
    [anon_sym_yield_BANG] = ACTIONS(2768),
    [anon_sym_lazy] = ACTIONS(2766),
    [anon_sym_assert] = ACTIONS(2766),
    [anon_sym_upcast] = ACTIONS(2766),
    [anon_sym_downcast] = ACTIONS(2766),
    [anon_sym_COLON_GT] = ACTIONS(2768),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2768),
    [anon_sym_for] = ACTIONS(2766),
    [anon_sym_while] = ACTIONS(2766),
    [anon_sym_if] = ACTIONS(2766),
    [anon_sym_fun] = ACTIONS(2766),
    [anon_sym_try] = ACTIONS(2766),
    [anon_sym_match] = ACTIONS(2766),
    [anon_sym_match_BANG] = ACTIONS(2768),
    [anon_sym_function] = ACTIONS(2766),
    [anon_sym_LT_DASH] = ACTIONS(2766),
    [anon_sym_DOT_LBRACK] = ACTIONS(2768),
    [anon_sym_LT] = ACTIONS(2768),
    [anon_sym_use] = ACTIONS(2766),
    [anon_sym_use_BANG] = ACTIONS(2768),
    [anon_sym_do_BANG] = ACTIONS(2768),
    [anon_sym_begin] = ACTIONS(2766),
    [anon_sym_LPAREN2] = ACTIONS(2766),
    [anon_sym_DOT_DOT2] = ACTIONS(2768),
    [anon_sym_default] = ACTIONS(2766),
    [anon_sym_or] = ACTIONS(2766),
    [anon_sym_static] = ACTIONS(2766),
    [anon_sym_member] = ACTIONS(2766),
    [anon_sym_abstract] = ACTIONS(2766),
    [anon_sym_val] = ACTIONS(2766),
    [anon_sym_override] = ACTIONS(2766),
    [aux_sym_char_token1] = ACTIONS(2768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2766),
    [anon_sym_DQUOTE] = ACTIONS(2766),
    [anon_sym_AT_DQUOTE] = ACTIONS(2768),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2768),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2768),
    [sym_bool] = ACTIONS(2766),
    [sym_unit] = ACTIONS(2768),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2766),
    [sym_op_identifier] = ACTIONS(2766),
    [anon_sym_PLUS] = ACTIONS(2766),
    [anon_sym_DASH] = ACTIONS(2766),
    [anon_sym_PLUS_DOT] = ACTIONS(2766),
    [anon_sym_DASH_DOT] = ACTIONS(2766),
    [anon_sym_PERCENT] = ACTIONS(2766),
    [anon_sym_AMP_AMP] = ACTIONS(2766),
    [anon_sym_TILDE] = ACTIONS(2768),
    [aux_sym_prefix_op_token1] = ACTIONS(2766),
    [aux_sym_infix_op_token1] = ACTIONS(2768),
    [aux_sym_infix_op_token2] = ACTIONS(2766),
    [anon_sym_PIPE_PIPE] = ACTIONS(2766),
    [anon_sym_BANG_EQ] = ACTIONS(2766),
    [anon_sym_COLON_EQ] = ACTIONS(2768),
    [anon_sym_DOLLAR] = ACTIONS(2766),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2766),
    [sym_int] = ACTIONS(2766),
    [sym_xint] = ACTIONS(2768),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2768),
    [sym__newline] = ACTIONS(2768),
    [sym__dedent] = ACTIONS(2768),
  },
  [839] = {
    [sym_block_comment] = STATE(839),
    [sym_compiler_directive_decl] = STATE(839),
    [sym_fsi_directive_decl] = STATE(839),
    [sym_preproc_line] = STATE(839),
    [sym_identifier] = ACTIONS(2770),
    [anon_sym_EQ] = ACTIONS(2772),
    [anon_sym_LBRACK_LT] = ACTIONS(2772),
    [anon_sym_COLON] = ACTIONS(2770),
    [anon_sym_return] = ACTIONS(2770),
    [anon_sym_do] = ACTIONS(2770),
    [anon_sym_let] = ACTIONS(2770),
    [anon_sym_let_BANG] = ACTIONS(2772),
    [aux_sym_access_modifier_token1] = ACTIONS(2772),
    [anon_sym_LPAREN] = ACTIONS(2770),
    [anon_sym_COMMA] = ACTIONS(2772),
    [anon_sym_null] = ACTIONS(2770),
    [anon_sym_QMARK] = ACTIONS(2770),
    [anon_sym_COLON_QMARK] = ACTIONS(2770),
    [anon_sym_COLON_COLON] = ACTIONS(2772),
    [anon_sym_AMP] = ACTIONS(2770),
    [anon_sym_LBRACK] = ACTIONS(2770),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2772),
    [anon_sym_LBRACE] = ACTIONS(2770),
    [anon_sym_LT_AT] = ACTIONS(2770),
    [anon_sym_LT_AT_AT] = ACTIONS(2770),
    [anon_sym_DOT] = ACTIONS(2770),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2772),
    [anon_sym_new] = ACTIONS(2770),
    [anon_sym_with] = ACTIONS(2770),
    [anon_sym_return_BANG] = ACTIONS(2772),
    [anon_sym_yield] = ACTIONS(2770),
    [anon_sym_yield_BANG] = ACTIONS(2772),
    [anon_sym_lazy] = ACTIONS(2770),
    [anon_sym_assert] = ACTIONS(2770),
    [anon_sym_upcast] = ACTIONS(2770),
    [anon_sym_downcast] = ACTIONS(2770),
    [anon_sym_COLON_GT] = ACTIONS(2772),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2772),
    [anon_sym_for] = ACTIONS(2770),
    [anon_sym_done] = ACTIONS(2774),
    [anon_sym_while] = ACTIONS(2770),
    [anon_sym_if] = ACTIONS(2770),
    [anon_sym_fun] = ACTIONS(2770),
    [anon_sym_try] = ACTIONS(2770),
    [anon_sym_match] = ACTIONS(2770),
    [anon_sym_match_BANG] = ACTIONS(2772),
    [anon_sym_function] = ACTIONS(2770),
    [anon_sym_LT_DASH] = ACTIONS(2770),
    [anon_sym_DOT_LBRACK] = ACTIONS(2772),
    [anon_sym_LT] = ACTIONS(2772),
    [anon_sym_use] = ACTIONS(2770),
    [anon_sym_use_BANG] = ACTIONS(2772),
    [anon_sym_do_BANG] = ACTIONS(2772),
    [anon_sym_begin] = ACTIONS(2770),
    [anon_sym_LPAREN2] = ACTIONS(2770),
    [anon_sym_DOT_DOT2] = ACTIONS(2772),
    [anon_sym_default] = ACTIONS(2770),
    [anon_sym_or] = ACTIONS(2770),
    [anon_sym_static] = ACTIONS(2770),
    [anon_sym_member] = ACTIONS(2770),
    [anon_sym_abstract] = ACTIONS(2770),
    [anon_sym_val] = ACTIONS(2770),
    [anon_sym_override] = ACTIONS(2770),
    [aux_sym_char_token1] = ACTIONS(2772),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2770),
    [anon_sym_DQUOTE] = ACTIONS(2770),
    [anon_sym_AT_DQUOTE] = ACTIONS(2772),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2772),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2772),
    [sym_bool] = ACTIONS(2770),
    [sym_unit] = ACTIONS(2772),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2770),
    [sym_op_identifier] = ACTIONS(2770),
    [anon_sym_PLUS] = ACTIONS(2770),
    [anon_sym_DASH] = ACTIONS(2770),
    [anon_sym_PLUS_DOT] = ACTIONS(2770),
    [anon_sym_DASH_DOT] = ACTIONS(2770),
    [anon_sym_PERCENT] = ACTIONS(2770),
    [anon_sym_AMP_AMP] = ACTIONS(2770),
    [anon_sym_TILDE] = ACTIONS(2772),
    [aux_sym_prefix_op_token1] = ACTIONS(2770),
    [aux_sym_infix_op_token1] = ACTIONS(2772),
    [aux_sym_infix_op_token2] = ACTIONS(2770),
    [anon_sym_PIPE_PIPE] = ACTIONS(2770),
    [anon_sym_BANG_EQ] = ACTIONS(2770),
    [anon_sym_COLON_EQ] = ACTIONS(2772),
    [anon_sym_DOLLAR] = ACTIONS(2770),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2770),
    [sym_int] = ACTIONS(2770),
    [sym_xint] = ACTIONS(2772),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2772),
    [sym__newline] = ACTIONS(2772),
    [sym__dedent] = ACTIONS(2772),
  },
  [840] = {
    [sym_block_comment] = STATE(840),
    [sym_compiler_directive_decl] = STATE(840),
    [sym_fsi_directive_decl] = STATE(840),
    [sym_preproc_line] = STATE(840),
    [aux_sym_compound_type_repeat1] = STATE(840),
    [sym_identifier] = ACTIONS(2250),
    [anon_sym_EQ] = ACTIONS(2248),
    [anon_sym_GT_RBRACK] = ACTIONS(2248),
    [anon_sym_COLON] = ACTIONS(2250),
    [anon_sym_return] = ACTIONS(2250),
    [anon_sym_do] = ACTIONS(2250),
    [anon_sym_let] = ACTIONS(2250),
    [anon_sym_let_BANG] = ACTIONS(2248),
    [anon_sym_LPAREN] = ACTIONS(2250),
    [anon_sym_COMMA] = ACTIONS(2248),
    [anon_sym_null] = ACTIONS(2250),
    [anon_sym_QMARK] = ACTIONS(2250),
    [anon_sym_COLON_QMARK] = ACTIONS(2250),
    [anon_sym_COLON_COLON] = ACTIONS(2248),
    [anon_sym_AMP] = ACTIONS(2250),
    [anon_sym_LBRACK] = ACTIONS(2250),
    [anon_sym_RBRACK] = ACTIONS(2248),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2248),
    [anon_sym_LBRACE] = ACTIONS(2250),
    [anon_sym_RBRACE] = ACTIONS(2248),
    [anon_sym_LT_AT] = ACTIONS(2250),
    [anon_sym_LT_AT_AT] = ACTIONS(2250),
    [anon_sym_DOT] = ACTIONS(2250),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2248),
    [anon_sym_new] = ACTIONS(2250),
    [anon_sym_with] = ACTIONS(2250),
    [anon_sym_return_BANG] = ACTIONS(2248),
    [anon_sym_yield] = ACTIONS(2250),
    [anon_sym_yield_BANG] = ACTIONS(2248),
    [anon_sym_lazy] = ACTIONS(2250),
    [anon_sym_assert] = ACTIONS(2250),
    [anon_sym_upcast] = ACTIONS(2250),
    [anon_sym_downcast] = ACTIONS(2250),
    [anon_sym_COLON_GT] = ACTIONS(2248),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2248),
    [anon_sym_for] = ACTIONS(2250),
    [anon_sym_to] = ACTIONS(2250),
    [anon_sym_downto] = ACTIONS(2250),
    [anon_sym_while] = ACTIONS(2250),
    [anon_sym_if] = ACTIONS(2250),
    [anon_sym_fun] = ACTIONS(2250),
    [anon_sym_DASH_GT] = ACTIONS(2250),
    [anon_sym_try] = ACTIONS(2250),
    [anon_sym_match] = ACTIONS(2250),
    [anon_sym_match_BANG] = ACTIONS(2248),
    [anon_sym_function] = ACTIONS(2250),
    [anon_sym_LT_DASH] = ACTIONS(2250),
    [anon_sym_DOT_LBRACK] = ACTIONS(2248),
    [anon_sym_LT] = ACTIONS(2248),
    [anon_sym_use] = ACTIONS(2250),
    [anon_sym_use_BANG] = ACTIONS(2248),
    [anon_sym_do_BANG] = ACTIONS(2248),
    [anon_sym_begin] = ACTIONS(2250),
    [anon_sym_LPAREN2] = ACTIONS(2250),
    [anon_sym_DOT_DOT2] = ACTIONS(2248),
    [anon_sym_STAR] = ACTIONS(2776),
    [anon_sym_LT2] = ACTIONS(2250),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2248),
    [anon_sym_or] = ACTIONS(2250),
    [aux_sym_char_token1] = ACTIONS(2248),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2250),
    [anon_sym_DQUOTE] = ACTIONS(2250),
    [anon_sym_AT_DQUOTE] = ACTIONS(2248),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2248),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2248),
    [sym_bool] = ACTIONS(2250),
    [sym_unit] = ACTIONS(2248),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2250),
    [sym_op_identifier] = ACTIONS(2250),
    [anon_sym_PLUS] = ACTIONS(2250),
    [anon_sym_DASH] = ACTIONS(2250),
    [anon_sym_PLUS_DOT] = ACTIONS(2250),
    [anon_sym_DASH_DOT] = ACTIONS(2250),
    [anon_sym_PERCENT] = ACTIONS(2250),
    [anon_sym_AMP_AMP] = ACTIONS(2250),
    [anon_sym_TILDE] = ACTIONS(2248),
    [aux_sym_prefix_op_token1] = ACTIONS(2250),
    [aux_sym_infix_op_token1] = ACTIONS(2248),
    [aux_sym_infix_op_token2] = ACTIONS(2250),
    [anon_sym_PIPE_PIPE] = ACTIONS(2250),
    [anon_sym_BANG_EQ] = ACTIONS(2250),
    [anon_sym_COLON_EQ] = ACTIONS(2248),
    [anon_sym_DOLLAR] = ACTIONS(2250),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2250),
    [sym_int] = ACTIONS(2250),
    [sym_xint] = ACTIONS(2248),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2248),
    [sym__newline] = ACTIONS(2248),
  },
  [841] = {
    [sym__else_expression] = STATE(1131),
    [sym_elif_expression] = STATE(985),
    [sym_block_comment] = STATE(841),
    [sym_compiler_directive_decl] = STATE(841),
    [sym_fsi_directive_decl] = STATE(841),
    [sym_preproc_line] = STATE(841),
    [aux_sym_if_expression_repeat1] = STATE(851),
    [sym_identifier] = ACTIONS(2422),
    [anon_sym_EQ] = ACTIONS(2424),
    [anon_sym_GT_RBRACK] = ACTIONS(2424),
    [anon_sym_COLON] = ACTIONS(2422),
    [anon_sym_return] = ACTIONS(2422),
    [anon_sym_do] = ACTIONS(2422),
    [anon_sym_let] = ACTIONS(2422),
    [anon_sym_let_BANG] = ACTIONS(2424),
    [anon_sym_LPAREN] = ACTIONS(2422),
    [anon_sym_COMMA] = ACTIONS(2424),
    [anon_sym_null] = ACTIONS(2422),
    [anon_sym_QMARK] = ACTIONS(2422),
    [anon_sym_COLON_QMARK] = ACTIONS(2422),
    [anon_sym_COLON_COLON] = ACTIONS(2424),
    [anon_sym_AMP] = ACTIONS(2422),
    [anon_sym_LBRACK] = ACTIONS(2422),
    [anon_sym_RBRACK] = ACTIONS(2424),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2424),
    [anon_sym_LBRACE] = ACTIONS(2422),
    [anon_sym_RBRACE] = ACTIONS(2424),
    [anon_sym_LT_AT] = ACTIONS(2422),
    [anon_sym_LT_AT_AT] = ACTIONS(2422),
    [anon_sym_DOT] = ACTIONS(2422),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2424),
    [anon_sym_new] = ACTIONS(2422),
    [anon_sym_with] = ACTIONS(2422),
    [anon_sym_return_BANG] = ACTIONS(2424),
    [anon_sym_yield] = ACTIONS(2422),
    [anon_sym_yield_BANG] = ACTIONS(2424),
    [anon_sym_lazy] = ACTIONS(2422),
    [anon_sym_assert] = ACTIONS(2422),
    [anon_sym_upcast] = ACTIONS(2422),
    [anon_sym_downcast] = ACTIONS(2422),
    [anon_sym_COLON_GT] = ACTIONS(2424),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2424),
    [anon_sym_for] = ACTIONS(2422),
    [anon_sym_to] = ACTIONS(2422),
    [anon_sym_downto] = ACTIONS(2422),
    [anon_sym_while] = ACTIONS(2422),
    [anon_sym_else] = ACTIONS(2779),
    [anon_sym_elif] = ACTIONS(2781),
    [anon_sym_if] = ACTIONS(2422),
    [anon_sym_fun] = ACTIONS(2422),
    [anon_sym_try] = ACTIONS(2422),
    [anon_sym_match] = ACTIONS(2422),
    [anon_sym_match_BANG] = ACTIONS(2424),
    [anon_sym_function] = ACTIONS(2422),
    [anon_sym_LT_DASH] = ACTIONS(2422),
    [anon_sym_DOT_LBRACK] = ACTIONS(2424),
    [anon_sym_LT] = ACTIONS(2424),
    [anon_sym_use] = ACTIONS(2422),
    [anon_sym_use_BANG] = ACTIONS(2424),
    [anon_sym_do_BANG] = ACTIONS(2424),
    [anon_sym_begin] = ACTIONS(2422),
    [anon_sym_LPAREN2] = ACTIONS(2422),
    [anon_sym_DOT_DOT2] = ACTIONS(2424),
    [anon_sym_or] = ACTIONS(2422),
    [aux_sym_char_token1] = ACTIONS(2424),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2422),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_AT_DQUOTE] = ACTIONS(2424),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2424),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2424),
    [sym_bool] = ACTIONS(2422),
    [sym_unit] = ACTIONS(2424),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2422),
    [sym_op_identifier] = ACTIONS(2422),
    [anon_sym_PLUS] = ACTIONS(2422),
    [anon_sym_DASH] = ACTIONS(2422),
    [anon_sym_PLUS_DOT] = ACTIONS(2422),
    [anon_sym_DASH_DOT] = ACTIONS(2422),
    [anon_sym_PERCENT] = ACTIONS(2422),
    [anon_sym_AMP_AMP] = ACTIONS(2422),
    [anon_sym_TILDE] = ACTIONS(2424),
    [aux_sym_prefix_op_token1] = ACTIONS(2422),
    [aux_sym_infix_op_token1] = ACTIONS(2424),
    [aux_sym_infix_op_token2] = ACTIONS(2422),
    [anon_sym_PIPE_PIPE] = ACTIONS(2422),
    [anon_sym_BANG_EQ] = ACTIONS(2422),
    [anon_sym_COLON_EQ] = ACTIONS(2424),
    [anon_sym_DOLLAR] = ACTIONS(2422),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2422),
    [sym_int] = ACTIONS(2422),
    [sym_xint] = ACTIONS(2424),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2424),
    [sym__newline] = ACTIONS(2424),
  },
  [842] = {
    [sym_block_comment] = STATE(842),
    [sym_compiler_directive_decl] = STATE(842),
    [sym_fsi_directive_decl] = STATE(842),
    [sym_preproc_line] = STATE(842),
    [sym_identifier] = ACTIONS(2783),
    [anon_sym_EQ] = ACTIONS(2785),
    [anon_sym_LBRACK_LT] = ACTIONS(2785),
    [anon_sym_COLON] = ACTIONS(2783),
    [anon_sym_return] = ACTIONS(2783),
    [anon_sym_do] = ACTIONS(2783),
    [anon_sym_let] = ACTIONS(2783),
    [anon_sym_let_BANG] = ACTIONS(2785),
    [aux_sym_access_modifier_token1] = ACTIONS(2785),
    [anon_sym_LPAREN] = ACTIONS(2783),
    [anon_sym_COMMA] = ACTIONS(2785),
    [anon_sym_null] = ACTIONS(2783),
    [anon_sym_QMARK] = ACTIONS(2783),
    [anon_sym_COLON_QMARK] = ACTIONS(2783),
    [anon_sym_COLON_COLON] = ACTIONS(2785),
    [anon_sym_AMP] = ACTIONS(2783),
    [anon_sym_LBRACK] = ACTIONS(2783),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2785),
    [anon_sym_LBRACE] = ACTIONS(2783),
    [anon_sym_LT_AT] = ACTIONS(2783),
    [anon_sym_LT_AT_AT] = ACTIONS(2783),
    [anon_sym_DOT] = ACTIONS(2783),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2785),
    [anon_sym_new] = ACTIONS(2783),
    [anon_sym_with] = ACTIONS(2783),
    [anon_sym_return_BANG] = ACTIONS(2785),
    [anon_sym_yield] = ACTIONS(2783),
    [anon_sym_yield_BANG] = ACTIONS(2785),
    [anon_sym_lazy] = ACTIONS(2783),
    [anon_sym_assert] = ACTIONS(2783),
    [anon_sym_upcast] = ACTIONS(2783),
    [anon_sym_downcast] = ACTIONS(2783),
    [anon_sym_COLON_GT] = ACTIONS(2785),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2785),
    [anon_sym_for] = ACTIONS(2783),
    [anon_sym_done] = ACTIONS(2787),
    [anon_sym_while] = ACTIONS(2783),
    [anon_sym_if] = ACTIONS(2783),
    [anon_sym_fun] = ACTIONS(2783),
    [anon_sym_try] = ACTIONS(2783),
    [anon_sym_match] = ACTIONS(2783),
    [anon_sym_match_BANG] = ACTIONS(2785),
    [anon_sym_function] = ACTIONS(2783),
    [anon_sym_LT_DASH] = ACTIONS(2783),
    [anon_sym_DOT_LBRACK] = ACTIONS(2785),
    [anon_sym_LT] = ACTIONS(2785),
    [anon_sym_use] = ACTIONS(2783),
    [anon_sym_use_BANG] = ACTIONS(2785),
    [anon_sym_do_BANG] = ACTIONS(2785),
    [anon_sym_DOT_DOT] = ACTIONS(2789),
    [anon_sym_begin] = ACTIONS(2783),
    [anon_sym_LPAREN2] = ACTIONS(2783),
    [anon_sym_default] = ACTIONS(2783),
    [anon_sym_or] = ACTIONS(2783),
    [anon_sym_static] = ACTIONS(2783),
    [anon_sym_member] = ACTIONS(2783),
    [anon_sym_abstract] = ACTIONS(2783),
    [anon_sym_val] = ACTIONS(2783),
    [anon_sym_override] = ACTIONS(2783),
    [aux_sym_char_token1] = ACTIONS(2785),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2783),
    [anon_sym_DQUOTE] = ACTIONS(2783),
    [anon_sym_AT_DQUOTE] = ACTIONS(2785),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2785),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2785),
    [sym_bool] = ACTIONS(2783),
    [sym_unit] = ACTIONS(2785),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2783),
    [sym_op_identifier] = ACTIONS(2783),
    [anon_sym_PLUS] = ACTIONS(2783),
    [anon_sym_DASH] = ACTIONS(2783),
    [anon_sym_PLUS_DOT] = ACTIONS(2783),
    [anon_sym_DASH_DOT] = ACTIONS(2783),
    [anon_sym_PERCENT] = ACTIONS(2783),
    [anon_sym_AMP_AMP] = ACTIONS(2783),
    [anon_sym_TILDE] = ACTIONS(2785),
    [aux_sym_prefix_op_token1] = ACTIONS(2783),
    [aux_sym_infix_op_token1] = ACTIONS(2785),
    [aux_sym_infix_op_token2] = ACTIONS(2783),
    [anon_sym_PIPE_PIPE] = ACTIONS(2783),
    [anon_sym_BANG_EQ] = ACTIONS(2783),
    [anon_sym_COLON_EQ] = ACTIONS(2785),
    [anon_sym_DOLLAR] = ACTIONS(2783),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2783),
    [sym_int] = ACTIONS(2783),
    [sym_xint] = ACTIONS(2785),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2785),
    [sym__newline] = ACTIONS(2785),
    [sym__dedent] = ACTIONS(2785),
  },
  [843] = {
    [sym_block_comment] = STATE(843),
    [sym_compiler_directive_decl] = STATE(843),
    [sym_fsi_directive_decl] = STATE(843),
    [sym_preproc_line] = STATE(843),
    [sym_identifier] = ACTIONS(2685),
    [anon_sym_EQ] = ACTIONS(2687),
    [anon_sym_LBRACK_LT] = ACTIONS(2687),
    [anon_sym_COLON] = ACTIONS(2685),
    [anon_sym_return] = ACTIONS(2685),
    [anon_sym_do] = ACTIONS(2685),
    [anon_sym_let] = ACTIONS(2685),
    [anon_sym_let_BANG] = ACTIONS(2687),
    [aux_sym_access_modifier_token1] = ACTIONS(2687),
    [anon_sym_LPAREN] = ACTIONS(2685),
    [anon_sym_COMMA] = ACTIONS(2687),
    [anon_sym_null] = ACTIONS(2685),
    [anon_sym_QMARK] = ACTIONS(2685),
    [anon_sym_COLON_QMARK] = ACTIONS(2685),
    [anon_sym_COLON_COLON] = ACTIONS(2687),
    [anon_sym_AMP] = ACTIONS(2685),
    [anon_sym_LBRACK] = ACTIONS(2685),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2687),
    [anon_sym_LBRACE] = ACTIONS(2685),
    [anon_sym_LT_AT] = ACTIONS(2685),
    [anon_sym_LT_AT_AT] = ACTIONS(2685),
    [anon_sym_DOT] = ACTIONS(2685),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2687),
    [anon_sym_new] = ACTIONS(2685),
    [anon_sym_with] = ACTIONS(2685),
    [anon_sym_return_BANG] = ACTIONS(2687),
    [anon_sym_yield] = ACTIONS(2685),
    [anon_sym_yield_BANG] = ACTIONS(2687),
    [anon_sym_lazy] = ACTIONS(2685),
    [anon_sym_assert] = ACTIONS(2685),
    [anon_sym_upcast] = ACTIONS(2685),
    [anon_sym_downcast] = ACTIONS(2685),
    [anon_sym_COLON_GT] = ACTIONS(2687),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2687),
    [anon_sym_for] = ACTIONS(2685),
    [anon_sym_done] = ACTIONS(2685),
    [anon_sym_while] = ACTIONS(2685),
    [anon_sym_if] = ACTIONS(2685),
    [anon_sym_fun] = ACTIONS(2685),
    [anon_sym_try] = ACTIONS(2685),
    [anon_sym_match] = ACTIONS(2685),
    [anon_sym_match_BANG] = ACTIONS(2687),
    [anon_sym_function] = ACTIONS(2685),
    [anon_sym_LT_DASH] = ACTIONS(2685),
    [anon_sym_DOT_LBRACK] = ACTIONS(2687),
    [anon_sym_LT] = ACTIONS(2687),
    [anon_sym_use] = ACTIONS(2685),
    [anon_sym_use_BANG] = ACTIONS(2687),
    [anon_sym_do_BANG] = ACTIONS(2687),
    [anon_sym_DOT_DOT] = ACTIONS(2687),
    [anon_sym_begin] = ACTIONS(2685),
    [anon_sym_LPAREN2] = ACTIONS(2685),
    [anon_sym_default] = ACTIONS(2685),
    [anon_sym_or] = ACTIONS(2685),
    [anon_sym_static] = ACTIONS(2685),
    [anon_sym_member] = ACTIONS(2685),
    [anon_sym_abstract] = ACTIONS(2685),
    [anon_sym_val] = ACTIONS(2685),
    [anon_sym_override] = ACTIONS(2685),
    [aux_sym_char_token1] = ACTIONS(2687),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2685),
    [anon_sym_DQUOTE] = ACTIONS(2685),
    [anon_sym_AT_DQUOTE] = ACTIONS(2687),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2687),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2687),
    [sym_bool] = ACTIONS(2685),
    [sym_unit] = ACTIONS(2687),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2685),
    [sym_op_identifier] = ACTIONS(2685),
    [anon_sym_PLUS] = ACTIONS(2685),
    [anon_sym_DASH] = ACTIONS(2685),
    [anon_sym_PLUS_DOT] = ACTIONS(2685),
    [anon_sym_DASH_DOT] = ACTIONS(2685),
    [anon_sym_PERCENT] = ACTIONS(2685),
    [anon_sym_AMP_AMP] = ACTIONS(2685),
    [anon_sym_TILDE] = ACTIONS(2687),
    [aux_sym_prefix_op_token1] = ACTIONS(2685),
    [aux_sym_infix_op_token1] = ACTIONS(2687),
    [aux_sym_infix_op_token2] = ACTIONS(2685),
    [anon_sym_PIPE_PIPE] = ACTIONS(2685),
    [anon_sym_BANG_EQ] = ACTIONS(2685),
    [anon_sym_COLON_EQ] = ACTIONS(2687),
    [anon_sym_DOLLAR] = ACTIONS(2685),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2685),
    [sym_int] = ACTIONS(2685),
    [sym_xint] = ACTIONS(2687),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2687),
    [sym__newline] = ACTIONS(2687),
    [sym__dedent] = ACTIONS(2687),
  },
  [844] = {
    [sym_block_comment] = STATE(844),
    [sym_compiler_directive_decl] = STATE(844),
    [sym_fsi_directive_decl] = STATE(844),
    [sym_preproc_line] = STATE(844),
    [sym_identifier] = ACTIONS(2783),
    [anon_sym_EQ] = ACTIONS(2785),
    [anon_sym_LBRACK_LT] = ACTIONS(2785),
    [anon_sym_COLON] = ACTIONS(2783),
    [anon_sym_return] = ACTIONS(2783),
    [anon_sym_do] = ACTIONS(2783),
    [anon_sym_let] = ACTIONS(2783),
    [anon_sym_let_BANG] = ACTIONS(2785),
    [aux_sym_access_modifier_token1] = ACTIONS(2785),
    [anon_sym_LPAREN] = ACTIONS(2783),
    [anon_sym_COMMA] = ACTIONS(2785),
    [anon_sym_null] = ACTIONS(2783),
    [anon_sym_QMARK] = ACTIONS(2783),
    [anon_sym_COLON_QMARK] = ACTIONS(2783),
    [anon_sym_COLON_COLON] = ACTIONS(2785),
    [anon_sym_AMP] = ACTIONS(2783),
    [anon_sym_LBRACK] = ACTIONS(2783),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2785),
    [anon_sym_LBRACE] = ACTIONS(2783),
    [anon_sym_LT_AT] = ACTIONS(2783),
    [anon_sym_LT_AT_AT] = ACTIONS(2783),
    [anon_sym_DOT] = ACTIONS(2783),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2785),
    [anon_sym_new] = ACTIONS(2783),
    [anon_sym_with] = ACTIONS(2783),
    [anon_sym_return_BANG] = ACTIONS(2785),
    [anon_sym_yield] = ACTIONS(2783),
    [anon_sym_yield_BANG] = ACTIONS(2785),
    [anon_sym_lazy] = ACTIONS(2783),
    [anon_sym_assert] = ACTIONS(2783),
    [anon_sym_upcast] = ACTIONS(2783),
    [anon_sym_downcast] = ACTIONS(2783),
    [anon_sym_COLON_GT] = ACTIONS(2785),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2785),
    [anon_sym_for] = ACTIONS(2783),
    [anon_sym_done] = ACTIONS(2787),
    [anon_sym_while] = ACTIONS(2783),
    [anon_sym_if] = ACTIONS(2783),
    [anon_sym_fun] = ACTIONS(2783),
    [anon_sym_try] = ACTIONS(2783),
    [anon_sym_match] = ACTIONS(2783),
    [anon_sym_match_BANG] = ACTIONS(2785),
    [anon_sym_function] = ACTIONS(2783),
    [anon_sym_LT_DASH] = ACTIONS(2783),
    [anon_sym_DOT_LBRACK] = ACTIONS(2785),
    [anon_sym_LT] = ACTIONS(2785),
    [anon_sym_use] = ACTIONS(2783),
    [anon_sym_use_BANG] = ACTIONS(2785),
    [anon_sym_do_BANG] = ACTIONS(2785),
    [anon_sym_begin] = ACTIONS(2783),
    [anon_sym_LPAREN2] = ACTIONS(2783),
    [anon_sym_DOT_DOT2] = ACTIONS(2785),
    [anon_sym_default] = ACTIONS(2783),
    [anon_sym_or] = ACTIONS(2783),
    [anon_sym_static] = ACTIONS(2783),
    [anon_sym_member] = ACTIONS(2783),
    [anon_sym_abstract] = ACTIONS(2783),
    [anon_sym_val] = ACTIONS(2783),
    [anon_sym_override] = ACTIONS(2783),
    [aux_sym_char_token1] = ACTIONS(2785),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2783),
    [anon_sym_DQUOTE] = ACTIONS(2783),
    [anon_sym_AT_DQUOTE] = ACTIONS(2785),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2785),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2785),
    [sym_bool] = ACTIONS(2783),
    [sym_unit] = ACTIONS(2785),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2783),
    [sym_op_identifier] = ACTIONS(2783),
    [anon_sym_PLUS] = ACTIONS(2783),
    [anon_sym_DASH] = ACTIONS(2783),
    [anon_sym_PLUS_DOT] = ACTIONS(2783),
    [anon_sym_DASH_DOT] = ACTIONS(2783),
    [anon_sym_PERCENT] = ACTIONS(2783),
    [anon_sym_AMP_AMP] = ACTIONS(2783),
    [anon_sym_TILDE] = ACTIONS(2785),
    [aux_sym_prefix_op_token1] = ACTIONS(2783),
    [aux_sym_infix_op_token1] = ACTIONS(2785),
    [aux_sym_infix_op_token2] = ACTIONS(2783),
    [anon_sym_PIPE_PIPE] = ACTIONS(2783),
    [anon_sym_BANG_EQ] = ACTIONS(2783),
    [anon_sym_COLON_EQ] = ACTIONS(2785),
    [anon_sym_DOLLAR] = ACTIONS(2783),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2783),
    [sym_int] = ACTIONS(2783),
    [sym_xint] = ACTIONS(2785),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2785),
    [sym__newline] = ACTIONS(2785),
    [sym__dedent] = ACTIONS(2785),
  },
  [845] = {
    [sym_block_comment] = STATE(845),
    [sym_compiler_directive_decl] = STATE(845),
    [sym_fsi_directive_decl] = STATE(845),
    [sym_preproc_line] = STATE(845),
    [aux_sym_long_identifier_repeat1] = STATE(837),
    [sym_identifier] = ACTIONS(2791),
    [anon_sym_EQ] = ACTIONS(2794),
    [anon_sym_LBRACK_LT] = ACTIONS(2794),
    [anon_sym_COLON] = ACTIONS(2791),
    [anon_sym_return] = ACTIONS(2791),
    [anon_sym_do] = ACTIONS(2791),
    [anon_sym_let] = ACTIONS(2791),
    [anon_sym_let_BANG] = ACTIONS(2794),
    [aux_sym_access_modifier_token1] = ACTIONS(2794),
    [anon_sym_LPAREN] = ACTIONS(2791),
    [anon_sym_COMMA] = ACTIONS(2794),
    [anon_sym_null] = ACTIONS(2791),
    [anon_sym_QMARK] = ACTIONS(2791),
    [anon_sym_COLON_QMARK] = ACTIONS(2791),
    [anon_sym_COLON_COLON] = ACTIONS(2794),
    [anon_sym_AMP] = ACTIONS(2791),
    [anon_sym_LBRACK] = ACTIONS(2791),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2794),
    [anon_sym_LBRACE] = ACTIONS(2791),
    [anon_sym_LT_AT] = ACTIONS(2791),
    [anon_sym_LT_AT_AT] = ACTIONS(2791),
    [anon_sym_DOT] = ACTIONS(2797),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2794),
    [anon_sym_new] = ACTIONS(2791),
    [anon_sym_with] = ACTIONS(2791),
    [anon_sym_return_BANG] = ACTIONS(2794),
    [anon_sym_yield] = ACTIONS(2791),
    [anon_sym_yield_BANG] = ACTIONS(2794),
    [anon_sym_lazy] = ACTIONS(2791),
    [anon_sym_assert] = ACTIONS(2791),
    [anon_sym_upcast] = ACTIONS(2791),
    [anon_sym_downcast] = ACTIONS(2791),
    [anon_sym_COLON_GT] = ACTIONS(2794),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2794),
    [anon_sym_for] = ACTIONS(2791),
    [anon_sym_while] = ACTIONS(2791),
    [anon_sym_if] = ACTIONS(2791),
    [anon_sym_fun] = ACTIONS(2791),
    [anon_sym_try] = ACTIONS(2791),
    [anon_sym_match] = ACTIONS(2791),
    [anon_sym_match_BANG] = ACTIONS(2794),
    [anon_sym_function] = ACTIONS(2791),
    [anon_sym_LT_DASH] = ACTIONS(2791),
    [anon_sym_DOT_LBRACK] = ACTIONS(2794),
    [anon_sym_LT] = ACTIONS(2794),
    [anon_sym_use] = ACTIONS(2791),
    [anon_sym_use_BANG] = ACTIONS(2794),
    [anon_sym_do_BANG] = ACTIONS(2794),
    [anon_sym_begin] = ACTIONS(2791),
    [anon_sym_LPAREN2] = ACTIONS(2791),
    [anon_sym_DOT_DOT2] = ACTIONS(2794),
    [anon_sym_default] = ACTIONS(2791),
    [anon_sym_or] = ACTIONS(2791),
    [anon_sym_static] = ACTIONS(2791),
    [anon_sym_member] = ACTIONS(2791),
    [anon_sym_abstract] = ACTIONS(2791),
    [anon_sym_val] = ACTIONS(2791),
    [anon_sym_override] = ACTIONS(2791),
    [aux_sym_char_token1] = ACTIONS(2794),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2791),
    [anon_sym_DQUOTE] = ACTIONS(2791),
    [anon_sym_AT_DQUOTE] = ACTIONS(2794),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2794),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2794),
    [sym_bool] = ACTIONS(2791),
    [sym_unit] = ACTIONS(2794),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2791),
    [sym_op_identifier] = ACTIONS(2791),
    [anon_sym_PLUS] = ACTIONS(2791),
    [anon_sym_DASH] = ACTIONS(2791),
    [anon_sym_PLUS_DOT] = ACTIONS(2791),
    [anon_sym_DASH_DOT] = ACTIONS(2791),
    [anon_sym_PERCENT] = ACTIONS(2791),
    [anon_sym_AMP_AMP] = ACTIONS(2791),
    [anon_sym_TILDE] = ACTIONS(2794),
    [aux_sym_prefix_op_token1] = ACTIONS(2791),
    [aux_sym_infix_op_token1] = ACTIONS(2794),
    [aux_sym_infix_op_token2] = ACTIONS(2791),
    [anon_sym_PIPE_PIPE] = ACTIONS(2791),
    [anon_sym_BANG_EQ] = ACTIONS(2791),
    [anon_sym_COLON_EQ] = ACTIONS(2794),
    [anon_sym_DOLLAR] = ACTIONS(2791),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2791),
    [sym_int] = ACTIONS(2791),
    [sym_xint] = ACTIONS(2794),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2794),
    [sym__newline] = ACTIONS(2794),
    [sym__dedent] = ACTIONS(2794),
  },
  [846] = {
    [sym_block_comment] = STATE(846),
    [sym_compiler_directive_decl] = STATE(846),
    [sym_fsi_directive_decl] = STATE(846),
    [sym_preproc_line] = STATE(846),
    [aux_sym_type_argument_repeat1] = STATE(853),
    [sym_identifier] = ACTIONS(2321),
    [anon_sym_EQ] = ACTIONS(2323),
    [anon_sym_GT_RBRACK] = ACTIONS(2323),
    [anon_sym_COLON] = ACTIONS(2321),
    [anon_sym_return] = ACTIONS(2321),
    [anon_sym_do] = ACTIONS(2321),
    [anon_sym_let] = ACTIONS(2321),
    [anon_sym_let_BANG] = ACTIONS(2323),
    [anon_sym_LPAREN] = ACTIONS(2321),
    [anon_sym_COMMA] = ACTIONS(2323),
    [anon_sym_null] = ACTIONS(2321),
    [anon_sym_QMARK] = ACTIONS(2321),
    [anon_sym_COLON_QMARK] = ACTIONS(2321),
    [anon_sym_COLON_COLON] = ACTIONS(2323),
    [anon_sym_AMP] = ACTIONS(2321),
    [anon_sym_LBRACK] = ACTIONS(2321),
    [anon_sym_RBRACK] = ACTIONS(2323),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2323),
    [anon_sym_LBRACE] = ACTIONS(2321),
    [anon_sym_RBRACE] = ACTIONS(2323),
    [anon_sym_LT_AT] = ACTIONS(2321),
    [anon_sym_LT_AT_AT] = ACTIONS(2321),
    [anon_sym_DOT] = ACTIONS(2321),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2323),
    [anon_sym_new] = ACTIONS(2321),
    [anon_sym_with] = ACTIONS(2321),
    [anon_sym_return_BANG] = ACTIONS(2323),
    [anon_sym_yield] = ACTIONS(2321),
    [anon_sym_yield_BANG] = ACTIONS(2323),
    [anon_sym_lazy] = ACTIONS(2321),
    [anon_sym_assert] = ACTIONS(2321),
    [anon_sym_upcast] = ACTIONS(2321),
    [anon_sym_downcast] = ACTIONS(2321),
    [anon_sym_COLON_GT] = ACTIONS(2323),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2323),
    [anon_sym_for] = ACTIONS(2321),
    [anon_sym_to] = ACTIONS(2321),
    [anon_sym_downto] = ACTIONS(2321),
    [anon_sym_while] = ACTIONS(2321),
    [anon_sym_if] = ACTIONS(2321),
    [anon_sym_fun] = ACTIONS(2321),
    [anon_sym_DASH_GT] = ACTIONS(2321),
    [anon_sym_try] = ACTIONS(2321),
    [anon_sym_match] = ACTIONS(2321),
    [anon_sym_match_BANG] = ACTIONS(2323),
    [anon_sym_function] = ACTIONS(2321),
    [anon_sym_LT_DASH] = ACTIONS(2321),
    [anon_sym_DOT_LBRACK] = ACTIONS(2323),
    [anon_sym_LT] = ACTIONS(2323),
    [anon_sym_use] = ACTIONS(2321),
    [anon_sym_use_BANG] = ACTIONS(2323),
    [anon_sym_do_BANG] = ACTIONS(2323),
    [anon_sym_begin] = ACTIONS(2321),
    [anon_sym_LPAREN2] = ACTIONS(2321),
    [anon_sym_DOT_DOT2] = ACTIONS(2323),
    [anon_sym_STAR] = ACTIONS(2321),
    [anon_sym_LT2] = ACTIONS(2321),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2323),
    [anon_sym_or] = ACTIONS(2801),
    [aux_sym_char_token1] = ACTIONS(2323),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2321),
    [anon_sym_DQUOTE] = ACTIONS(2321),
    [anon_sym_AT_DQUOTE] = ACTIONS(2323),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2323),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2323),
    [sym_bool] = ACTIONS(2321),
    [sym_unit] = ACTIONS(2323),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2321),
    [sym_op_identifier] = ACTIONS(2321),
    [anon_sym_PLUS] = ACTIONS(2321),
    [anon_sym_DASH] = ACTIONS(2321),
    [anon_sym_PLUS_DOT] = ACTIONS(2321),
    [anon_sym_DASH_DOT] = ACTIONS(2321),
    [anon_sym_PERCENT] = ACTIONS(2321),
    [anon_sym_AMP_AMP] = ACTIONS(2321),
    [anon_sym_TILDE] = ACTIONS(2323),
    [aux_sym_prefix_op_token1] = ACTIONS(2321),
    [aux_sym_infix_op_token1] = ACTIONS(2323),
    [aux_sym_infix_op_token2] = ACTIONS(2321),
    [anon_sym_PIPE_PIPE] = ACTIONS(2321),
    [anon_sym_BANG_EQ] = ACTIONS(2321),
    [anon_sym_COLON_EQ] = ACTIONS(2323),
    [anon_sym_DOLLAR] = ACTIONS(2321),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2321),
    [sym_int] = ACTIONS(2321),
    [sym_xint] = ACTIONS(2323),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2323),
    [sym__newline] = ACTIONS(2323),
  },
  [847] = {
    [sym_block_comment] = STATE(847),
    [sym_compiler_directive_decl] = STATE(847),
    [sym_fsi_directive_decl] = STATE(847),
    [sym_preproc_line] = STATE(847),
    [sym_identifier] = ACTIONS(2804),
    [anon_sym_EQ] = ACTIONS(2806),
    [anon_sym_LBRACK_LT] = ACTIONS(2806),
    [anon_sym_COLON] = ACTIONS(2804),
    [anon_sym_return] = ACTIONS(2804),
    [anon_sym_do] = ACTIONS(2804),
    [anon_sym_let] = ACTIONS(2804),
    [anon_sym_let_BANG] = ACTIONS(2806),
    [aux_sym_access_modifier_token1] = ACTIONS(2806),
    [anon_sym_LPAREN] = ACTIONS(2804),
    [anon_sym_COMMA] = ACTIONS(2806),
    [anon_sym_null] = ACTIONS(2804),
    [anon_sym_QMARK] = ACTIONS(2804),
    [anon_sym_COLON_QMARK] = ACTIONS(2804),
    [anon_sym_COLON_COLON] = ACTIONS(2806),
    [anon_sym_AMP] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2804),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(2804),
    [anon_sym_LT_AT] = ACTIONS(2804),
    [anon_sym_LT_AT_AT] = ACTIONS(2804),
    [anon_sym_DOT] = ACTIONS(2804),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2806),
    [anon_sym_new] = ACTIONS(2804),
    [anon_sym_with] = ACTIONS(2804),
    [anon_sym_return_BANG] = ACTIONS(2806),
    [anon_sym_yield] = ACTIONS(2804),
    [anon_sym_yield_BANG] = ACTIONS(2806),
    [anon_sym_lazy] = ACTIONS(2804),
    [anon_sym_assert] = ACTIONS(2804),
    [anon_sym_upcast] = ACTIONS(2804),
    [anon_sym_downcast] = ACTIONS(2804),
    [anon_sym_COLON_GT] = ACTIONS(2806),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2806),
    [anon_sym_for] = ACTIONS(2804),
    [anon_sym_done] = ACTIONS(2808),
    [anon_sym_while] = ACTIONS(2804),
    [anon_sym_if] = ACTIONS(2804),
    [anon_sym_fun] = ACTIONS(2804),
    [anon_sym_try] = ACTIONS(2804),
    [anon_sym_match] = ACTIONS(2804),
    [anon_sym_match_BANG] = ACTIONS(2806),
    [anon_sym_function] = ACTIONS(2804),
    [anon_sym_LT_DASH] = ACTIONS(2804),
    [anon_sym_DOT_LBRACK] = ACTIONS(2806),
    [anon_sym_LT] = ACTIONS(2806),
    [anon_sym_use] = ACTIONS(2804),
    [anon_sym_use_BANG] = ACTIONS(2806),
    [anon_sym_do_BANG] = ACTIONS(2806),
    [anon_sym_begin] = ACTIONS(2804),
    [anon_sym_LPAREN2] = ACTIONS(2804),
    [anon_sym_DOT_DOT2] = ACTIONS(2806),
    [anon_sym_default] = ACTIONS(2804),
    [anon_sym_or] = ACTIONS(2804),
    [anon_sym_static] = ACTIONS(2804),
    [anon_sym_member] = ACTIONS(2804),
    [anon_sym_abstract] = ACTIONS(2804),
    [anon_sym_val] = ACTIONS(2804),
    [anon_sym_override] = ACTIONS(2804),
    [aux_sym_char_token1] = ACTIONS(2806),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2804),
    [anon_sym_DQUOTE] = ACTIONS(2804),
    [anon_sym_AT_DQUOTE] = ACTIONS(2806),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2806),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2806),
    [sym_bool] = ACTIONS(2804),
    [sym_unit] = ACTIONS(2806),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2804),
    [sym_op_identifier] = ACTIONS(2804),
    [anon_sym_PLUS] = ACTIONS(2804),
    [anon_sym_DASH] = ACTIONS(2804),
    [anon_sym_PLUS_DOT] = ACTIONS(2804),
    [anon_sym_DASH_DOT] = ACTIONS(2804),
    [anon_sym_PERCENT] = ACTIONS(2804),
    [anon_sym_AMP_AMP] = ACTIONS(2804),
    [anon_sym_TILDE] = ACTIONS(2806),
    [aux_sym_prefix_op_token1] = ACTIONS(2804),
    [aux_sym_infix_op_token1] = ACTIONS(2806),
    [aux_sym_infix_op_token2] = ACTIONS(2804),
    [anon_sym_PIPE_PIPE] = ACTIONS(2804),
    [anon_sym_BANG_EQ] = ACTIONS(2804),
    [anon_sym_COLON_EQ] = ACTIONS(2806),
    [anon_sym_DOLLAR] = ACTIONS(2804),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2804),
    [sym_int] = ACTIONS(2804),
    [sym_xint] = ACTIONS(2806),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2806),
    [sym__newline] = ACTIONS(2806),
    [sym__dedent] = ACTIONS(2806),
  },
  [848] = {
    [sym_block_comment] = STATE(848),
    [sym_compiler_directive_decl] = STATE(848),
    [sym_fsi_directive_decl] = STATE(848),
    [sym_preproc_line] = STATE(848),
    [aux_sym_compound_type_repeat1] = STATE(840),
    [sym_identifier] = ACTIONS(2407),
    [anon_sym_EQ] = ACTIONS(2409),
    [anon_sym_GT_RBRACK] = ACTIONS(2409),
    [anon_sym_COLON] = ACTIONS(2407),
    [anon_sym_return] = ACTIONS(2407),
    [anon_sym_do] = ACTIONS(2407),
    [anon_sym_let] = ACTIONS(2407),
    [anon_sym_let_BANG] = ACTIONS(2409),
    [anon_sym_LPAREN] = ACTIONS(2407),
    [anon_sym_COMMA] = ACTIONS(2409),
    [anon_sym_null] = ACTIONS(2407),
    [anon_sym_QMARK] = ACTIONS(2407),
    [anon_sym_COLON_QMARK] = ACTIONS(2407),
    [anon_sym_COLON_COLON] = ACTIONS(2409),
    [anon_sym_AMP] = ACTIONS(2407),
    [anon_sym_LBRACK] = ACTIONS(2407),
    [anon_sym_RBRACK] = ACTIONS(2409),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2409),
    [anon_sym_LBRACE] = ACTIONS(2407),
    [anon_sym_RBRACE] = ACTIONS(2409),
    [anon_sym_LT_AT] = ACTIONS(2407),
    [anon_sym_LT_AT_AT] = ACTIONS(2407),
    [anon_sym_DOT] = ACTIONS(2407),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2409),
    [anon_sym_new] = ACTIONS(2407),
    [anon_sym_with] = ACTIONS(2407),
    [anon_sym_return_BANG] = ACTIONS(2409),
    [anon_sym_yield] = ACTIONS(2407),
    [anon_sym_yield_BANG] = ACTIONS(2409),
    [anon_sym_lazy] = ACTIONS(2407),
    [anon_sym_assert] = ACTIONS(2407),
    [anon_sym_upcast] = ACTIONS(2407),
    [anon_sym_downcast] = ACTIONS(2407),
    [anon_sym_COLON_GT] = ACTIONS(2409),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2409),
    [anon_sym_for] = ACTIONS(2407),
    [anon_sym_to] = ACTIONS(2407),
    [anon_sym_downto] = ACTIONS(2407),
    [anon_sym_while] = ACTIONS(2407),
    [anon_sym_if] = ACTIONS(2407),
    [anon_sym_fun] = ACTIONS(2407),
    [anon_sym_DASH_GT] = ACTIONS(2407),
    [anon_sym_try] = ACTIONS(2407),
    [anon_sym_match] = ACTIONS(2407),
    [anon_sym_match_BANG] = ACTIONS(2409),
    [anon_sym_function] = ACTIONS(2407),
    [anon_sym_LT_DASH] = ACTIONS(2407),
    [anon_sym_DOT_LBRACK] = ACTIONS(2409),
    [anon_sym_LT] = ACTIONS(2409),
    [anon_sym_use] = ACTIONS(2407),
    [anon_sym_use_BANG] = ACTIONS(2409),
    [anon_sym_do_BANG] = ACTIONS(2409),
    [anon_sym_begin] = ACTIONS(2407),
    [anon_sym_LPAREN2] = ACTIONS(2407),
    [anon_sym_DOT_DOT2] = ACTIONS(2409),
    [anon_sym_STAR] = ACTIONS(2663),
    [anon_sym_LT2] = ACTIONS(2407),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2409),
    [anon_sym_or] = ACTIONS(2407),
    [aux_sym_char_token1] = ACTIONS(2409),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2407),
    [anon_sym_DQUOTE] = ACTIONS(2407),
    [anon_sym_AT_DQUOTE] = ACTIONS(2409),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2409),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2409),
    [sym_bool] = ACTIONS(2407),
    [sym_unit] = ACTIONS(2409),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2407),
    [sym_op_identifier] = ACTIONS(2407),
    [anon_sym_PLUS] = ACTIONS(2407),
    [anon_sym_DASH] = ACTIONS(2407),
    [anon_sym_PLUS_DOT] = ACTIONS(2407),
    [anon_sym_DASH_DOT] = ACTIONS(2407),
    [anon_sym_PERCENT] = ACTIONS(2407),
    [anon_sym_AMP_AMP] = ACTIONS(2407),
    [anon_sym_TILDE] = ACTIONS(2409),
    [aux_sym_prefix_op_token1] = ACTIONS(2407),
    [aux_sym_infix_op_token1] = ACTIONS(2409),
    [aux_sym_infix_op_token2] = ACTIONS(2407),
    [anon_sym_PIPE_PIPE] = ACTIONS(2407),
    [anon_sym_BANG_EQ] = ACTIONS(2407),
    [anon_sym_COLON_EQ] = ACTIONS(2409),
    [anon_sym_DOLLAR] = ACTIONS(2407),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2407),
    [sym_int] = ACTIONS(2407),
    [sym_xint] = ACTIONS(2409),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2409),
    [sym__newline] = ACTIONS(2409),
  },
  [849] = {
    [sym_block_comment] = STATE(849),
    [sym_compiler_directive_decl] = STATE(849),
    [sym_fsi_directive_decl] = STATE(849),
    [sym_preproc_line] = STATE(849),
    [sym_identifier] = ACTIONS(2685),
    [anon_sym_EQ] = ACTIONS(2687),
    [anon_sym_LBRACK_LT] = ACTIONS(2687),
    [anon_sym_COLON] = ACTIONS(2685),
    [anon_sym_return] = ACTIONS(2685),
    [anon_sym_do] = ACTIONS(2685),
    [anon_sym_let] = ACTIONS(2685),
    [anon_sym_let_BANG] = ACTIONS(2687),
    [aux_sym_access_modifier_token1] = ACTIONS(2687),
    [anon_sym_LPAREN] = ACTIONS(2685),
    [anon_sym_COMMA] = ACTIONS(2687),
    [anon_sym_null] = ACTIONS(2685),
    [anon_sym_QMARK] = ACTIONS(2685),
    [anon_sym_COLON_QMARK] = ACTIONS(2685),
    [anon_sym_COLON_COLON] = ACTIONS(2687),
    [anon_sym_PIPE] = ACTIONS(2685),
    [anon_sym_AMP] = ACTIONS(2685),
    [anon_sym_LBRACK] = ACTIONS(2685),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2687),
    [anon_sym_LBRACE] = ACTIONS(2685),
    [anon_sym_LT_AT] = ACTIONS(2685),
    [anon_sym_LT_AT_AT] = ACTIONS(2685),
    [anon_sym_DOT] = ACTIONS(2685),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2687),
    [anon_sym_new] = ACTIONS(2685),
    [anon_sym_with] = ACTIONS(2685),
    [anon_sym_return_BANG] = ACTIONS(2687),
    [anon_sym_yield] = ACTIONS(2685),
    [anon_sym_yield_BANG] = ACTIONS(2687),
    [anon_sym_lazy] = ACTIONS(2685),
    [anon_sym_assert] = ACTIONS(2685),
    [anon_sym_upcast] = ACTIONS(2685),
    [anon_sym_downcast] = ACTIONS(2685),
    [anon_sym_COLON_GT] = ACTIONS(2687),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2687),
    [anon_sym_for] = ACTIONS(2685),
    [anon_sym_while] = ACTIONS(2685),
    [anon_sym_if] = ACTIONS(2685),
    [anon_sym_fun] = ACTIONS(2685),
    [anon_sym_try] = ACTIONS(2685),
    [anon_sym_match] = ACTIONS(2685),
    [anon_sym_match_BANG] = ACTIONS(2687),
    [anon_sym_function] = ACTIONS(2685),
    [anon_sym_LT_DASH] = ACTIONS(2685),
    [anon_sym_DOT_LBRACK] = ACTIONS(2687),
    [anon_sym_LT] = ACTIONS(2687),
    [anon_sym_use] = ACTIONS(2685),
    [anon_sym_use_BANG] = ACTIONS(2687),
    [anon_sym_do_BANG] = ACTIONS(2687),
    [anon_sym_begin] = ACTIONS(2685),
    [anon_sym_LPAREN2] = ACTIONS(2685),
    [anon_sym_DOT_DOT2] = ACTIONS(2687),
    [anon_sym_default] = ACTIONS(2685),
    [anon_sym_or] = ACTIONS(2685),
    [anon_sym_static] = ACTIONS(2685),
    [anon_sym_member] = ACTIONS(2685),
    [anon_sym_abstract] = ACTIONS(2685),
    [anon_sym_val] = ACTIONS(2685),
    [anon_sym_override] = ACTIONS(2685),
    [aux_sym_char_token1] = ACTIONS(2687),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2685),
    [anon_sym_DQUOTE] = ACTIONS(2685),
    [anon_sym_AT_DQUOTE] = ACTIONS(2687),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2687),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2687),
    [sym_bool] = ACTIONS(2685),
    [sym_unit] = ACTIONS(2687),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2685),
    [sym_op_identifier] = ACTIONS(2685),
    [anon_sym_PLUS] = ACTIONS(2685),
    [anon_sym_DASH] = ACTIONS(2685),
    [anon_sym_PLUS_DOT] = ACTIONS(2685),
    [anon_sym_DASH_DOT] = ACTIONS(2685),
    [anon_sym_PERCENT] = ACTIONS(2685),
    [anon_sym_AMP_AMP] = ACTIONS(2685),
    [anon_sym_TILDE] = ACTIONS(2687),
    [aux_sym_prefix_op_token1] = ACTIONS(2685),
    [aux_sym_infix_op_token1] = ACTIONS(2687),
    [aux_sym_infix_op_token2] = ACTIONS(2685),
    [anon_sym_PIPE_PIPE] = ACTIONS(2685),
    [anon_sym_BANG_EQ] = ACTIONS(2685),
    [anon_sym_COLON_EQ] = ACTIONS(2687),
    [anon_sym_DOLLAR] = ACTIONS(2685),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2685),
    [sym_int] = ACTIONS(2685),
    [sym_xint] = ACTIONS(2687),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2687),
    [sym__newline] = ACTIONS(2687),
    [sym__dedent] = ACTIONS(2687),
  },
  [850] = {
    [sym_block_comment] = STATE(850),
    [sym_compiler_directive_decl] = STATE(850),
    [sym_fsi_directive_decl] = STATE(850),
    [sym_preproc_line] = STATE(850),
    [aux_sym_long_identifier_repeat1] = STATE(856),
    [sym_identifier] = ACTIONS(2418),
    [anon_sym_EQ] = ACTIONS(2420),
    [anon_sym_GT_RBRACK] = ACTIONS(2420),
    [anon_sym_COLON] = ACTIONS(2418),
    [anon_sym_return] = ACTIONS(2418),
    [anon_sym_do] = ACTIONS(2418),
    [anon_sym_let] = ACTIONS(2418),
    [anon_sym_let_BANG] = ACTIONS(2420),
    [anon_sym_LPAREN] = ACTIONS(2418),
    [anon_sym_COMMA] = ACTIONS(2420),
    [anon_sym_null] = ACTIONS(2418),
    [anon_sym_QMARK] = ACTIONS(2418),
    [anon_sym_COLON_QMARK] = ACTIONS(2418),
    [anon_sym_COLON_COLON] = ACTIONS(2420),
    [anon_sym_AMP] = ACTIONS(2418),
    [anon_sym_LBRACK] = ACTIONS(2418),
    [anon_sym_RBRACK] = ACTIONS(2420),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2420),
    [anon_sym_LBRACE] = ACTIONS(2418),
    [anon_sym_RBRACE] = ACTIONS(2420),
    [anon_sym_LT_AT] = ACTIONS(2418),
    [anon_sym_LT_AT_AT] = ACTIONS(2418),
    [anon_sym_DOT] = ACTIONS(2810),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2420),
    [anon_sym_new] = ACTIONS(2418),
    [anon_sym_with] = ACTIONS(2418),
    [anon_sym_return_BANG] = ACTIONS(2420),
    [anon_sym_yield] = ACTIONS(2418),
    [anon_sym_yield_BANG] = ACTIONS(2420),
    [anon_sym_lazy] = ACTIONS(2418),
    [anon_sym_assert] = ACTIONS(2418),
    [anon_sym_upcast] = ACTIONS(2418),
    [anon_sym_downcast] = ACTIONS(2418),
    [anon_sym_COLON_GT] = ACTIONS(2420),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2420),
    [anon_sym_for] = ACTIONS(2418),
    [anon_sym_to] = ACTIONS(2418),
    [anon_sym_downto] = ACTIONS(2418),
    [anon_sym_while] = ACTIONS(2418),
    [anon_sym_if] = ACTIONS(2418),
    [anon_sym_fun] = ACTIONS(2418),
    [anon_sym_DASH_GT] = ACTIONS(2418),
    [anon_sym_try] = ACTIONS(2418),
    [anon_sym_match] = ACTIONS(2418),
    [anon_sym_match_BANG] = ACTIONS(2420),
    [anon_sym_function] = ACTIONS(2418),
    [anon_sym_LT_DASH] = ACTIONS(2418),
    [anon_sym_DOT_LBRACK] = ACTIONS(2420),
    [anon_sym_LT] = ACTIONS(2420),
    [anon_sym_use] = ACTIONS(2418),
    [anon_sym_use_BANG] = ACTIONS(2420),
    [anon_sym_do_BANG] = ACTIONS(2420),
    [anon_sym_begin] = ACTIONS(2418),
    [anon_sym_LPAREN2] = ACTIONS(2418),
    [anon_sym_DOT_DOT2] = ACTIONS(2420),
    [anon_sym_STAR] = ACTIONS(2418),
    [anon_sym_LT2] = ACTIONS(2418),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2420),
    [anon_sym_or] = ACTIONS(2418),
    [aux_sym_char_token1] = ACTIONS(2420),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2418),
    [anon_sym_DQUOTE] = ACTIONS(2418),
    [anon_sym_AT_DQUOTE] = ACTIONS(2420),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2420),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2420),
    [sym_bool] = ACTIONS(2418),
    [sym_unit] = ACTIONS(2420),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2418),
    [sym_op_identifier] = ACTIONS(2418),
    [anon_sym_PLUS] = ACTIONS(2418),
    [anon_sym_DASH] = ACTIONS(2418),
    [anon_sym_PLUS_DOT] = ACTIONS(2418),
    [anon_sym_DASH_DOT] = ACTIONS(2418),
    [anon_sym_PERCENT] = ACTIONS(2418),
    [anon_sym_AMP_AMP] = ACTIONS(2418),
    [anon_sym_TILDE] = ACTIONS(2420),
    [aux_sym_prefix_op_token1] = ACTIONS(2418),
    [aux_sym_infix_op_token1] = ACTIONS(2420),
    [aux_sym_infix_op_token2] = ACTIONS(2418),
    [anon_sym_PIPE_PIPE] = ACTIONS(2418),
    [anon_sym_BANG_EQ] = ACTIONS(2418),
    [anon_sym_COLON_EQ] = ACTIONS(2420),
    [anon_sym_DOLLAR] = ACTIONS(2418),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2418),
    [sym_int] = ACTIONS(2418),
    [sym_xint] = ACTIONS(2420),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2420),
    [sym__newline] = ACTIONS(2420),
  },
  [851] = {
    [sym__else_expression] = STATE(1142),
    [sym_elif_expression] = STATE(985),
    [sym_block_comment] = STATE(851),
    [sym_compiler_directive_decl] = STATE(851),
    [sym_fsi_directive_decl] = STATE(851),
    [sym_preproc_line] = STATE(851),
    [aux_sym_if_expression_repeat1] = STATE(908),
    [sym_identifier] = ACTIONS(2332),
    [anon_sym_EQ] = ACTIONS(2334),
    [anon_sym_GT_RBRACK] = ACTIONS(2334),
    [anon_sym_COLON] = ACTIONS(2332),
    [anon_sym_return] = ACTIONS(2332),
    [anon_sym_do] = ACTIONS(2332),
    [anon_sym_let] = ACTIONS(2332),
    [anon_sym_let_BANG] = ACTIONS(2334),
    [anon_sym_LPAREN] = ACTIONS(2332),
    [anon_sym_COMMA] = ACTIONS(2334),
    [anon_sym_null] = ACTIONS(2332),
    [anon_sym_QMARK] = ACTIONS(2332),
    [anon_sym_COLON_QMARK] = ACTIONS(2332),
    [anon_sym_COLON_COLON] = ACTIONS(2334),
    [anon_sym_AMP] = ACTIONS(2332),
    [anon_sym_LBRACK] = ACTIONS(2332),
    [anon_sym_RBRACK] = ACTIONS(2334),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2334),
    [anon_sym_LBRACE] = ACTIONS(2332),
    [anon_sym_RBRACE] = ACTIONS(2334),
    [anon_sym_LT_AT] = ACTIONS(2332),
    [anon_sym_LT_AT_AT] = ACTIONS(2332),
    [anon_sym_DOT] = ACTIONS(2332),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2334),
    [anon_sym_new] = ACTIONS(2332),
    [anon_sym_with] = ACTIONS(2332),
    [anon_sym_return_BANG] = ACTIONS(2334),
    [anon_sym_yield] = ACTIONS(2332),
    [anon_sym_yield_BANG] = ACTIONS(2334),
    [anon_sym_lazy] = ACTIONS(2332),
    [anon_sym_assert] = ACTIONS(2332),
    [anon_sym_upcast] = ACTIONS(2332),
    [anon_sym_downcast] = ACTIONS(2332),
    [anon_sym_COLON_GT] = ACTIONS(2334),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2334),
    [anon_sym_for] = ACTIONS(2332),
    [anon_sym_to] = ACTIONS(2332),
    [anon_sym_downto] = ACTIONS(2332),
    [anon_sym_while] = ACTIONS(2332),
    [anon_sym_else] = ACTIONS(2779),
    [anon_sym_elif] = ACTIONS(2781),
    [anon_sym_if] = ACTIONS(2332),
    [anon_sym_fun] = ACTIONS(2332),
    [anon_sym_try] = ACTIONS(2332),
    [anon_sym_match] = ACTIONS(2332),
    [anon_sym_match_BANG] = ACTIONS(2334),
    [anon_sym_function] = ACTIONS(2332),
    [anon_sym_LT_DASH] = ACTIONS(2332),
    [anon_sym_DOT_LBRACK] = ACTIONS(2334),
    [anon_sym_LT] = ACTIONS(2334),
    [anon_sym_use] = ACTIONS(2332),
    [anon_sym_use_BANG] = ACTIONS(2334),
    [anon_sym_do_BANG] = ACTIONS(2334),
    [anon_sym_begin] = ACTIONS(2332),
    [anon_sym_LPAREN2] = ACTIONS(2332),
    [anon_sym_DOT_DOT2] = ACTIONS(2334),
    [anon_sym_or] = ACTIONS(2332),
    [aux_sym_char_token1] = ACTIONS(2334),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2332),
    [anon_sym_DQUOTE] = ACTIONS(2332),
    [anon_sym_AT_DQUOTE] = ACTIONS(2334),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2334),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2334),
    [sym_bool] = ACTIONS(2332),
    [sym_unit] = ACTIONS(2334),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2332),
    [sym_op_identifier] = ACTIONS(2332),
    [anon_sym_PLUS] = ACTIONS(2332),
    [anon_sym_DASH] = ACTIONS(2332),
    [anon_sym_PLUS_DOT] = ACTIONS(2332),
    [anon_sym_DASH_DOT] = ACTIONS(2332),
    [anon_sym_PERCENT] = ACTIONS(2332),
    [anon_sym_AMP_AMP] = ACTIONS(2332),
    [anon_sym_TILDE] = ACTIONS(2334),
    [aux_sym_prefix_op_token1] = ACTIONS(2332),
    [aux_sym_infix_op_token1] = ACTIONS(2334),
    [aux_sym_infix_op_token2] = ACTIONS(2332),
    [anon_sym_PIPE_PIPE] = ACTIONS(2332),
    [anon_sym_BANG_EQ] = ACTIONS(2332),
    [anon_sym_COLON_EQ] = ACTIONS(2334),
    [anon_sym_DOLLAR] = ACTIONS(2332),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2332),
    [sym_int] = ACTIONS(2332),
    [sym_xint] = ACTIONS(2334),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2334),
    [sym__newline] = ACTIONS(2334),
  },
  [852] = {
    [sym_block_comment] = STATE(852),
    [sym_compiler_directive_decl] = STATE(852),
    [sym_fsi_directive_decl] = STATE(852),
    [sym_preproc_line] = STATE(852),
    [aux_sym_long_identifier_repeat1] = STATE(850),
    [sym_identifier] = ACTIONS(2312),
    [anon_sym_EQ] = ACTIONS(2314),
    [anon_sym_GT_RBRACK] = ACTIONS(2314),
    [anon_sym_COLON] = ACTIONS(2312),
    [anon_sym_return] = ACTIONS(2312),
    [anon_sym_do] = ACTIONS(2312),
    [anon_sym_let] = ACTIONS(2312),
    [anon_sym_let_BANG] = ACTIONS(2314),
    [anon_sym_LPAREN] = ACTIONS(2312),
    [anon_sym_COMMA] = ACTIONS(2314),
    [anon_sym_null] = ACTIONS(2312),
    [anon_sym_QMARK] = ACTIONS(2312),
    [anon_sym_COLON_QMARK] = ACTIONS(2312),
    [anon_sym_COLON_COLON] = ACTIONS(2314),
    [anon_sym_AMP] = ACTIONS(2312),
    [anon_sym_LBRACK] = ACTIONS(2312),
    [anon_sym_RBRACK] = ACTIONS(2314),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2314),
    [anon_sym_LBRACE] = ACTIONS(2312),
    [anon_sym_RBRACE] = ACTIONS(2314),
    [anon_sym_LT_AT] = ACTIONS(2312),
    [anon_sym_LT_AT_AT] = ACTIONS(2312),
    [anon_sym_DOT] = ACTIONS(2810),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2314),
    [anon_sym_new] = ACTIONS(2312),
    [anon_sym_with] = ACTIONS(2312),
    [anon_sym_return_BANG] = ACTIONS(2314),
    [anon_sym_yield] = ACTIONS(2312),
    [anon_sym_yield_BANG] = ACTIONS(2314),
    [anon_sym_lazy] = ACTIONS(2312),
    [anon_sym_assert] = ACTIONS(2312),
    [anon_sym_upcast] = ACTIONS(2312),
    [anon_sym_downcast] = ACTIONS(2312),
    [anon_sym_COLON_GT] = ACTIONS(2314),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2314),
    [anon_sym_for] = ACTIONS(2312),
    [anon_sym_to] = ACTIONS(2312),
    [anon_sym_downto] = ACTIONS(2312),
    [anon_sym_while] = ACTIONS(2312),
    [anon_sym_if] = ACTIONS(2312),
    [anon_sym_fun] = ACTIONS(2312),
    [anon_sym_DASH_GT] = ACTIONS(2312),
    [anon_sym_try] = ACTIONS(2312),
    [anon_sym_match] = ACTIONS(2312),
    [anon_sym_match_BANG] = ACTIONS(2314),
    [anon_sym_function] = ACTIONS(2312),
    [anon_sym_LT_DASH] = ACTIONS(2312),
    [anon_sym_DOT_LBRACK] = ACTIONS(2314),
    [anon_sym_LT] = ACTIONS(2314),
    [anon_sym_use] = ACTIONS(2312),
    [anon_sym_use_BANG] = ACTIONS(2314),
    [anon_sym_do_BANG] = ACTIONS(2314),
    [anon_sym_begin] = ACTIONS(2312),
    [anon_sym_LPAREN2] = ACTIONS(2312),
    [anon_sym_DOT_DOT2] = ACTIONS(2314),
    [anon_sym_STAR] = ACTIONS(2312),
    [anon_sym_LT2] = ACTIONS(2312),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2314),
    [anon_sym_or] = ACTIONS(2312),
    [aux_sym_char_token1] = ACTIONS(2314),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2312),
    [anon_sym_DQUOTE] = ACTIONS(2312),
    [anon_sym_AT_DQUOTE] = ACTIONS(2314),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2314),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2314),
    [sym_bool] = ACTIONS(2312),
    [sym_unit] = ACTIONS(2314),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2312),
    [sym_op_identifier] = ACTIONS(2312),
    [anon_sym_PLUS] = ACTIONS(2312),
    [anon_sym_DASH] = ACTIONS(2312),
    [anon_sym_PLUS_DOT] = ACTIONS(2312),
    [anon_sym_DASH_DOT] = ACTIONS(2312),
    [anon_sym_PERCENT] = ACTIONS(2312),
    [anon_sym_AMP_AMP] = ACTIONS(2312),
    [anon_sym_TILDE] = ACTIONS(2314),
    [aux_sym_prefix_op_token1] = ACTIONS(2312),
    [aux_sym_infix_op_token1] = ACTIONS(2314),
    [aux_sym_infix_op_token2] = ACTIONS(2312),
    [anon_sym_PIPE_PIPE] = ACTIONS(2312),
    [anon_sym_BANG_EQ] = ACTIONS(2312),
    [anon_sym_COLON_EQ] = ACTIONS(2314),
    [anon_sym_DOLLAR] = ACTIONS(2312),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2312),
    [sym_int] = ACTIONS(2312),
    [sym_xint] = ACTIONS(2314),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2314),
    [sym__newline] = ACTIONS(2314),
  },
  [853] = {
    [sym_block_comment] = STATE(853),
    [sym_compiler_directive_decl] = STATE(853),
    [sym_fsi_directive_decl] = STATE(853),
    [sym_preproc_line] = STATE(853),
    [aux_sym_type_argument_repeat1] = STATE(859),
    [sym_identifier] = ACTIONS(2328),
    [anon_sym_EQ] = ACTIONS(2330),
    [anon_sym_GT_RBRACK] = ACTIONS(2330),
    [anon_sym_COLON] = ACTIONS(2328),
    [anon_sym_return] = ACTIONS(2328),
    [anon_sym_do] = ACTIONS(2328),
    [anon_sym_let] = ACTIONS(2328),
    [anon_sym_let_BANG] = ACTIONS(2330),
    [anon_sym_LPAREN] = ACTIONS(2328),
    [anon_sym_COMMA] = ACTIONS(2330),
    [anon_sym_null] = ACTIONS(2328),
    [anon_sym_QMARK] = ACTIONS(2328),
    [anon_sym_COLON_QMARK] = ACTIONS(2328),
    [anon_sym_COLON_COLON] = ACTIONS(2330),
    [anon_sym_AMP] = ACTIONS(2328),
    [anon_sym_LBRACK] = ACTIONS(2328),
    [anon_sym_RBRACK] = ACTIONS(2330),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2330),
    [anon_sym_LBRACE] = ACTIONS(2328),
    [anon_sym_RBRACE] = ACTIONS(2330),
    [anon_sym_LT_AT] = ACTIONS(2328),
    [anon_sym_LT_AT_AT] = ACTIONS(2328),
    [anon_sym_DOT] = ACTIONS(2328),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2330),
    [anon_sym_new] = ACTIONS(2328),
    [anon_sym_with] = ACTIONS(2328),
    [anon_sym_return_BANG] = ACTIONS(2330),
    [anon_sym_yield] = ACTIONS(2328),
    [anon_sym_yield_BANG] = ACTIONS(2330),
    [anon_sym_lazy] = ACTIONS(2328),
    [anon_sym_assert] = ACTIONS(2328),
    [anon_sym_upcast] = ACTIONS(2328),
    [anon_sym_downcast] = ACTIONS(2328),
    [anon_sym_COLON_GT] = ACTIONS(2330),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2330),
    [anon_sym_for] = ACTIONS(2328),
    [anon_sym_to] = ACTIONS(2328),
    [anon_sym_downto] = ACTIONS(2328),
    [anon_sym_while] = ACTIONS(2328),
    [anon_sym_if] = ACTIONS(2328),
    [anon_sym_fun] = ACTIONS(2328),
    [anon_sym_DASH_GT] = ACTIONS(2328),
    [anon_sym_try] = ACTIONS(2328),
    [anon_sym_match] = ACTIONS(2328),
    [anon_sym_match_BANG] = ACTIONS(2330),
    [anon_sym_function] = ACTIONS(2328),
    [anon_sym_LT_DASH] = ACTIONS(2328),
    [anon_sym_DOT_LBRACK] = ACTIONS(2330),
    [anon_sym_LT] = ACTIONS(2330),
    [anon_sym_use] = ACTIONS(2328),
    [anon_sym_use_BANG] = ACTIONS(2330),
    [anon_sym_do_BANG] = ACTIONS(2330),
    [anon_sym_begin] = ACTIONS(2328),
    [anon_sym_LPAREN2] = ACTIONS(2328),
    [anon_sym_DOT_DOT2] = ACTIONS(2330),
    [anon_sym_STAR] = ACTIONS(2328),
    [anon_sym_LT2] = ACTIONS(2328),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2330),
    [anon_sym_or] = ACTIONS(2328),
    [aux_sym_char_token1] = ACTIONS(2330),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2328),
    [anon_sym_DQUOTE] = ACTIONS(2328),
    [anon_sym_AT_DQUOTE] = ACTIONS(2330),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2330),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2330),
    [sym_bool] = ACTIONS(2328),
    [sym_unit] = ACTIONS(2330),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2328),
    [sym_op_identifier] = ACTIONS(2328),
    [anon_sym_PLUS] = ACTIONS(2328),
    [anon_sym_DASH] = ACTIONS(2328),
    [anon_sym_PLUS_DOT] = ACTIONS(2328),
    [anon_sym_DASH_DOT] = ACTIONS(2328),
    [anon_sym_PERCENT] = ACTIONS(2328),
    [anon_sym_AMP_AMP] = ACTIONS(2328),
    [anon_sym_TILDE] = ACTIONS(2330),
    [aux_sym_prefix_op_token1] = ACTIONS(2328),
    [aux_sym_infix_op_token1] = ACTIONS(2330),
    [aux_sym_infix_op_token2] = ACTIONS(2328),
    [anon_sym_PIPE_PIPE] = ACTIONS(2328),
    [anon_sym_BANG_EQ] = ACTIONS(2328),
    [anon_sym_COLON_EQ] = ACTIONS(2330),
    [anon_sym_DOLLAR] = ACTIONS(2328),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2328),
    [sym_int] = ACTIONS(2328),
    [sym_xint] = ACTIONS(2330),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2330),
    [sym__newline] = ACTIONS(2330),
  },
  [854] = {
    [sym_block_comment] = STATE(854),
    [sym_compiler_directive_decl] = STATE(854),
    [sym_fsi_directive_decl] = STATE(854),
    [sym_preproc_line] = STATE(854),
    [sym_identifier] = ACTIONS(2812),
    [anon_sym_EQ] = ACTIONS(2814),
    [anon_sym_LBRACK_LT] = ACTIONS(2814),
    [anon_sym_COLON] = ACTIONS(2812),
    [anon_sym_return] = ACTIONS(2812),
    [anon_sym_do] = ACTIONS(2812),
    [anon_sym_let] = ACTIONS(2812),
    [anon_sym_let_BANG] = ACTIONS(2814),
    [aux_sym_access_modifier_token1] = ACTIONS(2814),
    [anon_sym_LPAREN] = ACTIONS(2812),
    [anon_sym_COMMA] = ACTIONS(2814),
    [anon_sym_null] = ACTIONS(2812),
    [anon_sym_QMARK] = ACTIONS(2812),
    [anon_sym_COLON_QMARK] = ACTIONS(2812),
    [anon_sym_COLON_COLON] = ACTIONS(2814),
    [anon_sym_AMP] = ACTIONS(2812),
    [anon_sym_LBRACK] = ACTIONS(2812),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2814),
    [anon_sym_LBRACE] = ACTIONS(2812),
    [anon_sym_LT_AT] = ACTIONS(2812),
    [anon_sym_LT_AT_AT] = ACTIONS(2812),
    [anon_sym_DOT] = ACTIONS(2812),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2814),
    [anon_sym_new] = ACTIONS(2812),
    [anon_sym_with] = ACTIONS(2812),
    [anon_sym_return_BANG] = ACTIONS(2814),
    [anon_sym_yield] = ACTIONS(2812),
    [anon_sym_yield_BANG] = ACTIONS(2814),
    [anon_sym_lazy] = ACTIONS(2812),
    [anon_sym_assert] = ACTIONS(2812),
    [anon_sym_upcast] = ACTIONS(2812),
    [anon_sym_downcast] = ACTIONS(2812),
    [anon_sym_COLON_GT] = ACTIONS(2814),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2814),
    [anon_sym_for] = ACTIONS(2812),
    [anon_sym_while] = ACTIONS(2812),
    [anon_sym_if] = ACTIONS(2812),
    [anon_sym_fun] = ACTIONS(2812),
    [anon_sym_try] = ACTIONS(2812),
    [anon_sym_match] = ACTIONS(2812),
    [anon_sym_match_BANG] = ACTIONS(2814),
    [anon_sym_function] = ACTIONS(2812),
    [anon_sym_LT_DASH] = ACTIONS(2812),
    [anon_sym_DOT_LBRACK] = ACTIONS(2814),
    [anon_sym_LT] = ACTIONS(2814),
    [anon_sym_use] = ACTIONS(2812),
    [anon_sym_use_BANG] = ACTIONS(2814),
    [anon_sym_do_BANG] = ACTIONS(2814),
    [anon_sym_begin] = ACTIONS(2812),
    [anon_sym_LPAREN2] = ACTIONS(2812),
    [anon_sym_default] = ACTIONS(2812),
    [anon_sym_or] = ACTIONS(2812),
    [anon_sym_static] = ACTIONS(2812),
    [anon_sym_member] = ACTIONS(2812),
    [anon_sym_abstract] = ACTIONS(2812),
    [anon_sym_val] = ACTIONS(2812),
    [anon_sym_override] = ACTIONS(2812),
    [aux_sym_char_token1] = ACTIONS(2814),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2812),
    [anon_sym_DQUOTE] = ACTIONS(2812),
    [anon_sym_AT_DQUOTE] = ACTIONS(2814),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2814),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2814),
    [sym_bool] = ACTIONS(2812),
    [sym_unit] = ACTIONS(2814),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2812),
    [sym_op_identifier] = ACTIONS(2812),
    [anon_sym_PLUS] = ACTIONS(2812),
    [anon_sym_DASH] = ACTIONS(2812),
    [anon_sym_PLUS_DOT] = ACTIONS(2812),
    [anon_sym_DASH_DOT] = ACTIONS(2812),
    [anon_sym_PERCENT] = ACTIONS(2812),
    [anon_sym_AMP_AMP] = ACTIONS(2812),
    [anon_sym_TILDE] = ACTIONS(2814),
    [aux_sym_prefix_op_token1] = ACTIONS(2812),
    [aux_sym_infix_op_token1] = ACTIONS(2814),
    [aux_sym_infix_op_token2] = ACTIONS(2812),
    [anon_sym_PIPE_PIPE] = ACTIONS(2812),
    [anon_sym_BANG_EQ] = ACTIONS(2812),
    [anon_sym_COLON_EQ] = ACTIONS(2814),
    [anon_sym_DOLLAR] = ACTIONS(2812),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2812),
    [sym_int] = ACTIONS(2812),
    [sym_xint] = ACTIONS(2814),
    [anon_sym_f] = ACTIONS(2812),
    [aux_sym_decimal_token1] = ACTIONS(2812),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2814),
    [sym__newline] = ACTIONS(2814),
    [sym__dedent] = ACTIONS(2814),
  },
  [855] = {
    [sym_block_comment] = STATE(855),
    [sym_compiler_directive_decl] = STATE(855),
    [sym_fsi_directive_decl] = STATE(855),
    [sym_preproc_line] = STATE(855),
    [sym_identifier] = ACTIONS(2723),
    [anon_sym_EQ] = ACTIONS(2725),
    [anon_sym_LBRACK_LT] = ACTIONS(2725),
    [anon_sym_COLON] = ACTIONS(2723),
    [anon_sym_return] = ACTIONS(2723),
    [anon_sym_do] = ACTIONS(2723),
    [anon_sym_let] = ACTIONS(2723),
    [anon_sym_let_BANG] = ACTIONS(2725),
    [aux_sym_access_modifier_token1] = ACTIONS(2725),
    [anon_sym_LPAREN] = ACTIONS(2723),
    [anon_sym_COMMA] = ACTIONS(2725),
    [anon_sym_null] = ACTIONS(2723),
    [anon_sym_QMARK] = ACTIONS(2723),
    [anon_sym_COLON_QMARK] = ACTIONS(2723),
    [anon_sym_COLON_COLON] = ACTIONS(2725),
    [anon_sym_AMP] = ACTIONS(2723),
    [anon_sym_LBRACK] = ACTIONS(2723),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2725),
    [anon_sym_LBRACE] = ACTIONS(2723),
    [anon_sym_LT_AT] = ACTIONS(2723),
    [anon_sym_LT_AT_AT] = ACTIONS(2723),
    [anon_sym_DOT] = ACTIONS(2723),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2725),
    [anon_sym_new] = ACTIONS(2723),
    [anon_sym_with] = ACTIONS(2723),
    [anon_sym_return_BANG] = ACTIONS(2725),
    [anon_sym_yield] = ACTIONS(2723),
    [anon_sym_yield_BANG] = ACTIONS(2725),
    [anon_sym_lazy] = ACTIONS(2723),
    [anon_sym_assert] = ACTIONS(2723),
    [anon_sym_upcast] = ACTIONS(2723),
    [anon_sym_downcast] = ACTIONS(2723),
    [anon_sym_COLON_GT] = ACTIONS(2725),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2725),
    [anon_sym_for] = ACTIONS(2723),
    [anon_sym_while] = ACTIONS(2723),
    [anon_sym_if] = ACTIONS(2723),
    [anon_sym_fun] = ACTIONS(2723),
    [anon_sym_try] = ACTIONS(2723),
    [anon_sym_match] = ACTIONS(2723),
    [anon_sym_match_BANG] = ACTIONS(2725),
    [anon_sym_function] = ACTIONS(2723),
    [anon_sym_LT_DASH] = ACTIONS(2723),
    [anon_sym_DOT_LBRACK] = ACTIONS(2725),
    [anon_sym_LT] = ACTIONS(2725),
    [anon_sym_use] = ACTIONS(2723),
    [anon_sym_use_BANG] = ACTIONS(2725),
    [anon_sym_do_BANG] = ACTIONS(2725),
    [anon_sym_begin] = ACTIONS(2723),
    [anon_sym_LPAREN2] = ACTIONS(2723),
    [anon_sym_default] = ACTIONS(2723),
    [anon_sym_or] = ACTIONS(2723),
    [anon_sym_static] = ACTIONS(2723),
    [anon_sym_member] = ACTIONS(2723),
    [anon_sym_abstract] = ACTIONS(2723),
    [anon_sym_val] = ACTIONS(2723),
    [anon_sym_override] = ACTIONS(2723),
    [aux_sym_char_token1] = ACTIONS(2725),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2723),
    [anon_sym_DQUOTE] = ACTIONS(2723),
    [anon_sym_AT_DQUOTE] = ACTIONS(2725),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2725),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2725),
    [sym_bool] = ACTIONS(2723),
    [sym_unit] = ACTIONS(2725),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2723),
    [sym_op_identifier] = ACTIONS(2723),
    [anon_sym_PLUS] = ACTIONS(2723),
    [anon_sym_DASH] = ACTIONS(2723),
    [anon_sym_PLUS_DOT] = ACTIONS(2723),
    [anon_sym_DASH_DOT] = ACTIONS(2723),
    [anon_sym_PERCENT] = ACTIONS(2723),
    [anon_sym_AMP_AMP] = ACTIONS(2723),
    [anon_sym_TILDE] = ACTIONS(2725),
    [aux_sym_prefix_op_token1] = ACTIONS(2723),
    [aux_sym_infix_op_token1] = ACTIONS(2725),
    [aux_sym_infix_op_token2] = ACTIONS(2723),
    [anon_sym_PIPE_PIPE] = ACTIONS(2723),
    [anon_sym_BANG_EQ] = ACTIONS(2723),
    [anon_sym_COLON_EQ] = ACTIONS(2725),
    [anon_sym_DOLLAR] = ACTIONS(2723),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2723),
    [sym_int] = ACTIONS(2723),
    [sym_xint] = ACTIONS(2725),
    [anon_sym_f] = ACTIONS(2723),
    [aux_sym_decimal_token1] = ACTIONS(2723),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2725),
    [sym__newline] = ACTIONS(2725),
    [sym__dedent] = ACTIONS(2725),
  },
  [856] = {
    [sym_block_comment] = STATE(856),
    [sym_compiler_directive_decl] = STATE(856),
    [sym_fsi_directive_decl] = STATE(856),
    [sym_preproc_line] = STATE(856),
    [aux_sym_long_identifier_repeat1] = STATE(856),
    [sym_identifier] = ACTIONS(2411),
    [anon_sym_EQ] = ACTIONS(2413),
    [anon_sym_GT_RBRACK] = ACTIONS(2413),
    [anon_sym_COLON] = ACTIONS(2411),
    [anon_sym_return] = ACTIONS(2411),
    [anon_sym_do] = ACTIONS(2411),
    [anon_sym_let] = ACTIONS(2411),
    [anon_sym_let_BANG] = ACTIONS(2413),
    [anon_sym_LPAREN] = ACTIONS(2411),
    [anon_sym_COMMA] = ACTIONS(2413),
    [anon_sym_null] = ACTIONS(2411),
    [anon_sym_QMARK] = ACTIONS(2411),
    [anon_sym_COLON_QMARK] = ACTIONS(2411),
    [anon_sym_COLON_COLON] = ACTIONS(2413),
    [anon_sym_AMP] = ACTIONS(2411),
    [anon_sym_LBRACK] = ACTIONS(2411),
    [anon_sym_RBRACK] = ACTIONS(2413),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2413),
    [anon_sym_LBRACE] = ACTIONS(2411),
    [anon_sym_RBRACE] = ACTIONS(2413),
    [anon_sym_LT_AT] = ACTIONS(2411),
    [anon_sym_LT_AT_AT] = ACTIONS(2411),
    [anon_sym_DOT] = ACTIONS(2816),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2413),
    [anon_sym_new] = ACTIONS(2411),
    [anon_sym_with] = ACTIONS(2411),
    [anon_sym_return_BANG] = ACTIONS(2413),
    [anon_sym_yield] = ACTIONS(2411),
    [anon_sym_yield_BANG] = ACTIONS(2413),
    [anon_sym_lazy] = ACTIONS(2411),
    [anon_sym_assert] = ACTIONS(2411),
    [anon_sym_upcast] = ACTIONS(2411),
    [anon_sym_downcast] = ACTIONS(2411),
    [anon_sym_COLON_GT] = ACTIONS(2413),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2413),
    [anon_sym_for] = ACTIONS(2411),
    [anon_sym_to] = ACTIONS(2411),
    [anon_sym_downto] = ACTIONS(2411),
    [anon_sym_while] = ACTIONS(2411),
    [anon_sym_if] = ACTIONS(2411),
    [anon_sym_fun] = ACTIONS(2411),
    [anon_sym_DASH_GT] = ACTIONS(2411),
    [anon_sym_try] = ACTIONS(2411),
    [anon_sym_match] = ACTIONS(2411),
    [anon_sym_match_BANG] = ACTIONS(2413),
    [anon_sym_function] = ACTIONS(2411),
    [anon_sym_LT_DASH] = ACTIONS(2411),
    [anon_sym_DOT_LBRACK] = ACTIONS(2413),
    [anon_sym_LT] = ACTIONS(2413),
    [anon_sym_use] = ACTIONS(2411),
    [anon_sym_use_BANG] = ACTIONS(2413),
    [anon_sym_do_BANG] = ACTIONS(2413),
    [anon_sym_begin] = ACTIONS(2411),
    [anon_sym_LPAREN2] = ACTIONS(2411),
    [anon_sym_DOT_DOT2] = ACTIONS(2413),
    [anon_sym_STAR] = ACTIONS(2411),
    [anon_sym_LT2] = ACTIONS(2411),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2413),
    [anon_sym_or] = ACTIONS(2411),
    [aux_sym_char_token1] = ACTIONS(2413),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2411),
    [anon_sym_DQUOTE] = ACTIONS(2411),
    [anon_sym_AT_DQUOTE] = ACTIONS(2413),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2413),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2413),
    [sym_bool] = ACTIONS(2411),
    [sym_unit] = ACTIONS(2413),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2411),
    [sym_op_identifier] = ACTIONS(2411),
    [anon_sym_PLUS] = ACTIONS(2411),
    [anon_sym_DASH] = ACTIONS(2411),
    [anon_sym_PLUS_DOT] = ACTIONS(2411),
    [anon_sym_DASH_DOT] = ACTIONS(2411),
    [anon_sym_PERCENT] = ACTIONS(2411),
    [anon_sym_AMP_AMP] = ACTIONS(2411),
    [anon_sym_TILDE] = ACTIONS(2413),
    [aux_sym_prefix_op_token1] = ACTIONS(2411),
    [aux_sym_infix_op_token1] = ACTIONS(2413),
    [aux_sym_infix_op_token2] = ACTIONS(2411),
    [anon_sym_PIPE_PIPE] = ACTIONS(2411),
    [anon_sym_BANG_EQ] = ACTIONS(2411),
    [anon_sym_COLON_EQ] = ACTIONS(2413),
    [anon_sym_DOLLAR] = ACTIONS(2411),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2411),
    [sym_int] = ACTIONS(2411),
    [sym_xint] = ACTIONS(2413),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2413),
    [sym__newline] = ACTIONS(2413),
  },
  [857] = {
    [sym_block_comment] = STATE(857),
    [sym_compiler_directive_decl] = STATE(857),
    [sym_fsi_directive_decl] = STATE(857),
    [sym_preproc_line] = STATE(857),
    [sym_identifier] = ACTIONS(2713),
    [anon_sym_EQ] = ACTIONS(2715),
    [anon_sym_LBRACK_LT] = ACTIONS(2715),
    [anon_sym_COLON] = ACTIONS(2713),
    [anon_sym_return] = ACTIONS(2713),
    [anon_sym_do] = ACTIONS(2713),
    [anon_sym_let] = ACTIONS(2713),
    [anon_sym_let_BANG] = ACTIONS(2715),
    [aux_sym_access_modifier_token1] = ACTIONS(2715),
    [anon_sym_LPAREN] = ACTIONS(2713),
    [anon_sym_COMMA] = ACTIONS(2715),
    [anon_sym_null] = ACTIONS(2713),
    [anon_sym_QMARK] = ACTIONS(2713),
    [anon_sym_COLON_QMARK] = ACTIONS(2713),
    [anon_sym_COLON_COLON] = ACTIONS(2715),
    [anon_sym_PIPE] = ACTIONS(2713),
    [anon_sym_AMP] = ACTIONS(2713),
    [anon_sym_LBRACK] = ACTIONS(2713),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2715),
    [anon_sym_LBRACE] = ACTIONS(2713),
    [anon_sym_LT_AT] = ACTIONS(2713),
    [anon_sym_LT_AT_AT] = ACTIONS(2713),
    [anon_sym_DOT] = ACTIONS(2713),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2715),
    [anon_sym_new] = ACTIONS(2713),
    [anon_sym_with] = ACTIONS(2713),
    [anon_sym_return_BANG] = ACTIONS(2715),
    [anon_sym_yield] = ACTIONS(2713),
    [anon_sym_yield_BANG] = ACTIONS(2715),
    [anon_sym_lazy] = ACTIONS(2713),
    [anon_sym_assert] = ACTIONS(2713),
    [anon_sym_upcast] = ACTIONS(2713),
    [anon_sym_downcast] = ACTIONS(2713),
    [anon_sym_COLON_GT] = ACTIONS(2715),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2715),
    [anon_sym_for] = ACTIONS(2713),
    [anon_sym_while] = ACTIONS(2713),
    [anon_sym_if] = ACTIONS(2713),
    [anon_sym_fun] = ACTIONS(2713),
    [anon_sym_try] = ACTIONS(2713),
    [anon_sym_match] = ACTIONS(2713),
    [anon_sym_match_BANG] = ACTIONS(2715),
    [anon_sym_function] = ACTIONS(2713),
    [anon_sym_LT_DASH] = ACTIONS(2713),
    [anon_sym_DOT_LBRACK] = ACTIONS(2715),
    [anon_sym_LT] = ACTIONS(2715),
    [anon_sym_use] = ACTIONS(2713),
    [anon_sym_use_BANG] = ACTIONS(2715),
    [anon_sym_do_BANG] = ACTIONS(2715),
    [anon_sym_begin] = ACTIONS(2713),
    [anon_sym_LPAREN2] = ACTIONS(2713),
    [anon_sym_DOT_DOT2] = ACTIONS(2715),
    [anon_sym_default] = ACTIONS(2713),
    [anon_sym_or] = ACTIONS(2713),
    [anon_sym_static] = ACTIONS(2713),
    [anon_sym_member] = ACTIONS(2713),
    [anon_sym_abstract] = ACTIONS(2713),
    [anon_sym_val] = ACTIONS(2713),
    [anon_sym_override] = ACTIONS(2713),
    [aux_sym_char_token1] = ACTIONS(2715),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2713),
    [anon_sym_DQUOTE] = ACTIONS(2713),
    [anon_sym_AT_DQUOTE] = ACTIONS(2715),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2715),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2715),
    [sym_bool] = ACTIONS(2713),
    [sym_unit] = ACTIONS(2715),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2713),
    [sym_op_identifier] = ACTIONS(2713),
    [anon_sym_PLUS] = ACTIONS(2713),
    [anon_sym_DASH] = ACTIONS(2713),
    [anon_sym_PLUS_DOT] = ACTIONS(2713),
    [anon_sym_DASH_DOT] = ACTIONS(2713),
    [anon_sym_PERCENT] = ACTIONS(2713),
    [anon_sym_AMP_AMP] = ACTIONS(2713),
    [anon_sym_TILDE] = ACTIONS(2715),
    [aux_sym_prefix_op_token1] = ACTIONS(2713),
    [aux_sym_infix_op_token1] = ACTIONS(2715),
    [aux_sym_infix_op_token2] = ACTIONS(2713),
    [anon_sym_PIPE_PIPE] = ACTIONS(2713),
    [anon_sym_BANG_EQ] = ACTIONS(2713),
    [anon_sym_COLON_EQ] = ACTIONS(2715),
    [anon_sym_DOLLAR] = ACTIONS(2713),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2713),
    [sym_int] = ACTIONS(2713),
    [sym_xint] = ACTIONS(2715),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2715),
    [sym__newline] = ACTIONS(2715),
    [sym__dedent] = ACTIONS(2715),
  },
  [858] = {
    [sym_block_comment] = STATE(858),
    [sym_compiler_directive_decl] = STATE(858),
    [sym_fsi_directive_decl] = STATE(858),
    [sym_preproc_line] = STATE(858),
    [sym_identifier] = ACTIONS(2819),
    [anon_sym_EQ] = ACTIONS(2821),
    [anon_sym_LBRACK_LT] = ACTIONS(2821),
    [anon_sym_COLON] = ACTIONS(2819),
    [anon_sym_return] = ACTIONS(2819),
    [anon_sym_do] = ACTIONS(2819),
    [anon_sym_let] = ACTIONS(2819),
    [anon_sym_let_BANG] = ACTIONS(2821),
    [aux_sym_access_modifier_token1] = ACTIONS(2821),
    [anon_sym_LPAREN] = ACTIONS(2819),
    [anon_sym_COMMA] = ACTIONS(2821),
    [anon_sym_null] = ACTIONS(2819),
    [anon_sym_QMARK] = ACTIONS(2819),
    [anon_sym_COLON_QMARK] = ACTIONS(2819),
    [anon_sym_COLON_COLON] = ACTIONS(2821),
    [anon_sym_AMP] = ACTIONS(2819),
    [anon_sym_LBRACK] = ACTIONS(2819),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2821),
    [anon_sym_LBRACE] = ACTIONS(2819),
    [anon_sym_LT_AT] = ACTIONS(2819),
    [anon_sym_LT_AT_AT] = ACTIONS(2819),
    [anon_sym_DOT] = ACTIONS(2819),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2821),
    [anon_sym_new] = ACTIONS(2819),
    [anon_sym_with] = ACTIONS(2819),
    [anon_sym_return_BANG] = ACTIONS(2821),
    [anon_sym_yield] = ACTIONS(2819),
    [anon_sym_yield_BANG] = ACTIONS(2821),
    [anon_sym_lazy] = ACTIONS(2819),
    [anon_sym_assert] = ACTIONS(2819),
    [anon_sym_upcast] = ACTIONS(2819),
    [anon_sym_downcast] = ACTIONS(2819),
    [anon_sym_COLON_GT] = ACTIONS(2821),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2821),
    [anon_sym_for] = ACTIONS(2819),
    [anon_sym_while] = ACTIONS(2819),
    [anon_sym_if] = ACTIONS(2819),
    [anon_sym_fun] = ACTIONS(2819),
    [anon_sym_try] = ACTIONS(2819),
    [anon_sym_match] = ACTIONS(2819),
    [anon_sym_match_BANG] = ACTIONS(2821),
    [anon_sym_function] = ACTIONS(2819),
    [anon_sym_LT_DASH] = ACTIONS(2819),
    [anon_sym_DOT_LBRACK] = ACTIONS(2821),
    [anon_sym_LT] = ACTIONS(2821),
    [anon_sym_use] = ACTIONS(2819),
    [anon_sym_use_BANG] = ACTIONS(2821),
    [anon_sym_do_BANG] = ACTIONS(2821),
    [anon_sym_begin] = ACTIONS(2819),
    [anon_sym_LPAREN2] = ACTIONS(2819),
    [anon_sym_default] = ACTIONS(2819),
    [anon_sym_or] = ACTIONS(2819),
    [anon_sym_static] = ACTIONS(2819),
    [anon_sym_member] = ACTIONS(2819),
    [anon_sym_abstract] = ACTIONS(2819),
    [anon_sym_val] = ACTIONS(2819),
    [anon_sym_override] = ACTIONS(2819),
    [aux_sym_char_token1] = ACTIONS(2821),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2819),
    [anon_sym_DQUOTE] = ACTIONS(2819),
    [anon_sym_AT_DQUOTE] = ACTIONS(2821),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2821),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2821),
    [sym_bool] = ACTIONS(2819),
    [sym_unit] = ACTIONS(2821),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2819),
    [sym_op_identifier] = ACTIONS(2819),
    [anon_sym_PLUS] = ACTIONS(2819),
    [anon_sym_DASH] = ACTIONS(2819),
    [anon_sym_PLUS_DOT] = ACTIONS(2819),
    [anon_sym_DASH_DOT] = ACTIONS(2819),
    [anon_sym_PERCENT] = ACTIONS(2819),
    [anon_sym_AMP_AMP] = ACTIONS(2819),
    [anon_sym_TILDE] = ACTIONS(2821),
    [aux_sym_prefix_op_token1] = ACTIONS(2819),
    [aux_sym_infix_op_token1] = ACTIONS(2821),
    [aux_sym_infix_op_token2] = ACTIONS(2819),
    [anon_sym_PIPE_PIPE] = ACTIONS(2819),
    [anon_sym_BANG_EQ] = ACTIONS(2819),
    [anon_sym_COLON_EQ] = ACTIONS(2821),
    [anon_sym_DOLLAR] = ACTIONS(2819),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2819),
    [sym_int] = ACTIONS(2823),
    [sym_xint] = ACTIONS(2821),
    [anon_sym_f] = ACTIONS(2819),
    [aux_sym_decimal_token1] = ACTIONS(2819),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2821),
    [sym__newline] = ACTIONS(2821),
    [sym__dedent] = ACTIONS(2821),
  },
  [859] = {
    [sym_block_comment] = STATE(859),
    [sym_compiler_directive_decl] = STATE(859),
    [sym_fsi_directive_decl] = STATE(859),
    [sym_preproc_line] = STATE(859),
    [aux_sym_type_argument_repeat1] = STATE(859),
    [sym_identifier] = ACTIONS(2340),
    [anon_sym_EQ] = ACTIONS(2342),
    [anon_sym_GT_RBRACK] = ACTIONS(2342),
    [anon_sym_COLON] = ACTIONS(2340),
    [anon_sym_return] = ACTIONS(2340),
    [anon_sym_do] = ACTIONS(2340),
    [anon_sym_let] = ACTIONS(2340),
    [anon_sym_let_BANG] = ACTIONS(2342),
    [anon_sym_LPAREN] = ACTIONS(2340),
    [anon_sym_COMMA] = ACTIONS(2342),
    [anon_sym_null] = ACTIONS(2340),
    [anon_sym_QMARK] = ACTIONS(2340),
    [anon_sym_COLON_QMARK] = ACTIONS(2340),
    [anon_sym_COLON_COLON] = ACTIONS(2342),
    [anon_sym_AMP] = ACTIONS(2340),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_RBRACK] = ACTIONS(2342),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2342),
    [anon_sym_LBRACE] = ACTIONS(2340),
    [anon_sym_RBRACE] = ACTIONS(2342),
    [anon_sym_LT_AT] = ACTIONS(2340),
    [anon_sym_LT_AT_AT] = ACTIONS(2340),
    [anon_sym_DOT] = ACTIONS(2340),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2342),
    [anon_sym_new] = ACTIONS(2340),
    [anon_sym_with] = ACTIONS(2340),
    [anon_sym_return_BANG] = ACTIONS(2342),
    [anon_sym_yield] = ACTIONS(2340),
    [anon_sym_yield_BANG] = ACTIONS(2342),
    [anon_sym_lazy] = ACTIONS(2340),
    [anon_sym_assert] = ACTIONS(2340),
    [anon_sym_upcast] = ACTIONS(2340),
    [anon_sym_downcast] = ACTIONS(2340),
    [anon_sym_COLON_GT] = ACTIONS(2342),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2342),
    [anon_sym_for] = ACTIONS(2340),
    [anon_sym_to] = ACTIONS(2340),
    [anon_sym_downto] = ACTIONS(2340),
    [anon_sym_while] = ACTIONS(2340),
    [anon_sym_if] = ACTIONS(2340),
    [anon_sym_fun] = ACTIONS(2340),
    [anon_sym_DASH_GT] = ACTIONS(2340),
    [anon_sym_try] = ACTIONS(2340),
    [anon_sym_match] = ACTIONS(2340),
    [anon_sym_match_BANG] = ACTIONS(2342),
    [anon_sym_function] = ACTIONS(2340),
    [anon_sym_LT_DASH] = ACTIONS(2340),
    [anon_sym_DOT_LBRACK] = ACTIONS(2342),
    [anon_sym_LT] = ACTIONS(2342),
    [anon_sym_use] = ACTIONS(2340),
    [anon_sym_use_BANG] = ACTIONS(2342),
    [anon_sym_do_BANG] = ACTIONS(2342),
    [anon_sym_begin] = ACTIONS(2340),
    [anon_sym_LPAREN2] = ACTIONS(2340),
    [anon_sym_DOT_DOT2] = ACTIONS(2342),
    [anon_sym_STAR] = ACTIONS(2340),
    [anon_sym_LT2] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2342),
    [anon_sym_or] = ACTIONS(2825),
    [aux_sym_char_token1] = ACTIONS(2342),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2340),
    [anon_sym_DQUOTE] = ACTIONS(2340),
    [anon_sym_AT_DQUOTE] = ACTIONS(2342),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2342),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2342),
    [sym_bool] = ACTIONS(2340),
    [sym_unit] = ACTIONS(2342),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2340),
    [sym_op_identifier] = ACTIONS(2340),
    [anon_sym_PLUS] = ACTIONS(2340),
    [anon_sym_DASH] = ACTIONS(2340),
    [anon_sym_PLUS_DOT] = ACTIONS(2340),
    [anon_sym_DASH_DOT] = ACTIONS(2340),
    [anon_sym_PERCENT] = ACTIONS(2340),
    [anon_sym_AMP_AMP] = ACTIONS(2340),
    [anon_sym_TILDE] = ACTIONS(2342),
    [aux_sym_prefix_op_token1] = ACTIONS(2340),
    [aux_sym_infix_op_token1] = ACTIONS(2342),
    [aux_sym_infix_op_token2] = ACTIONS(2340),
    [anon_sym_PIPE_PIPE] = ACTIONS(2340),
    [anon_sym_BANG_EQ] = ACTIONS(2340),
    [anon_sym_COLON_EQ] = ACTIONS(2342),
    [anon_sym_DOLLAR] = ACTIONS(2340),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2340),
    [sym_int] = ACTIONS(2340),
    [sym_xint] = ACTIONS(2342),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2342),
    [sym__newline] = ACTIONS(2342),
  },
  [860] = {
    [sym_block_comment] = STATE(860),
    [sym_compiler_directive_decl] = STATE(860),
    [sym_fsi_directive_decl] = STATE(860),
    [sym_preproc_line] = STATE(860),
    [sym_identifier] = ACTIONS(2158),
    [anon_sym_EQ] = ACTIONS(2160),
    [anon_sym_LBRACK_LT] = ACTIONS(2160),
    [anon_sym_COLON] = ACTIONS(2158),
    [anon_sym_return] = ACTIONS(2158),
    [anon_sym_do] = ACTIONS(2158),
    [anon_sym_let] = ACTIONS(2158),
    [anon_sym_let_BANG] = ACTIONS(2160),
    [aux_sym_access_modifier_token1] = ACTIONS(2160),
    [anon_sym_LPAREN] = ACTIONS(2158),
    [anon_sym_COMMA] = ACTIONS(2160),
    [anon_sym_null] = ACTIONS(2158),
    [anon_sym_QMARK] = ACTIONS(2158),
    [anon_sym_COLON_QMARK] = ACTIONS(2158),
    [anon_sym_COLON_COLON] = ACTIONS(2160),
    [anon_sym_AMP] = ACTIONS(2158),
    [anon_sym_LBRACK] = ACTIONS(2158),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2160),
    [anon_sym_LBRACE] = ACTIONS(2158),
    [anon_sym_LT_AT] = ACTIONS(2158),
    [anon_sym_LT_AT_AT] = ACTIONS(2158),
    [anon_sym_DOT] = ACTIONS(2158),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2160),
    [anon_sym_new] = ACTIONS(2158),
    [anon_sym_with] = ACTIONS(2158),
    [anon_sym_return_BANG] = ACTIONS(2160),
    [anon_sym_yield] = ACTIONS(2158),
    [anon_sym_yield_BANG] = ACTIONS(2160),
    [anon_sym_lazy] = ACTIONS(2158),
    [anon_sym_assert] = ACTIONS(2158),
    [anon_sym_upcast] = ACTIONS(2158),
    [anon_sym_downcast] = ACTIONS(2158),
    [anon_sym_COLON_GT] = ACTIONS(2160),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2160),
    [anon_sym_for] = ACTIONS(2158),
    [anon_sym_while] = ACTIONS(2158),
    [anon_sym_if] = ACTIONS(2158),
    [anon_sym_fun] = ACTIONS(2158),
    [anon_sym_try] = ACTIONS(2158),
    [anon_sym_match] = ACTIONS(2158),
    [anon_sym_match_BANG] = ACTIONS(2160),
    [anon_sym_function] = ACTIONS(2158),
    [anon_sym_LT_DASH] = ACTIONS(2158),
    [anon_sym_DOT_LBRACK] = ACTIONS(2160),
    [anon_sym_LT] = ACTIONS(2160),
    [anon_sym_use] = ACTIONS(2158),
    [anon_sym_use_BANG] = ACTIONS(2160),
    [anon_sym_do_BANG] = ACTIONS(2160),
    [anon_sym_begin] = ACTIONS(2158),
    [anon_sym_LPAREN2] = ACTIONS(2158),
    [anon_sym_default] = ACTIONS(2158),
    [anon_sym_or] = ACTIONS(2158),
    [anon_sym_static] = ACTIONS(2158),
    [anon_sym_member] = ACTIONS(2158),
    [anon_sym_abstract] = ACTIONS(2158),
    [anon_sym_val] = ACTIONS(2158),
    [anon_sym_override] = ACTIONS(2158),
    [aux_sym_char_token1] = ACTIONS(2160),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2158),
    [anon_sym_DQUOTE] = ACTIONS(2158),
    [anon_sym_AT_DQUOTE] = ACTIONS(2160),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2160),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2160),
    [sym_bool] = ACTIONS(2158),
    [sym_unit] = ACTIONS(2160),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2158),
    [sym_op_identifier] = ACTIONS(2158),
    [anon_sym_PLUS] = ACTIONS(2158),
    [anon_sym_DASH] = ACTIONS(2158),
    [anon_sym_PLUS_DOT] = ACTIONS(2158),
    [anon_sym_DASH_DOT] = ACTIONS(2158),
    [anon_sym_PERCENT] = ACTIONS(2158),
    [anon_sym_AMP_AMP] = ACTIONS(2158),
    [anon_sym_TILDE] = ACTIONS(2160),
    [aux_sym_prefix_op_token1] = ACTIONS(2158),
    [aux_sym_infix_op_token1] = ACTIONS(2160),
    [aux_sym_infix_op_token2] = ACTIONS(2158),
    [anon_sym_PIPE_PIPE] = ACTIONS(2158),
    [anon_sym_BANG_EQ] = ACTIONS(2158),
    [anon_sym_COLON_EQ] = ACTIONS(2160),
    [anon_sym_DOLLAR] = ACTIONS(2158),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2158),
    [sym_int] = ACTIONS(2158),
    [sym_xint] = ACTIONS(2160),
    [anon_sym_f] = ACTIONS(2190),
    [aux_sym_decimal_token1] = ACTIONS(2184),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2160),
    [sym__newline] = ACTIONS(2160),
    [sym__dedent] = ACTIONS(2160),
  },
  [861] = {
    [sym_block_comment] = STATE(861),
    [sym_compiler_directive_decl] = STATE(861),
    [sym_fsi_directive_decl] = STATE(861),
    [sym_preproc_line] = STATE(861),
    [aux_sym_long_identifier_repeat1] = STATE(861),
    [sym_identifier] = ACTIONS(2411),
    [anon_sym_EQ] = ACTIONS(2413),
    [anon_sym_LBRACK_LT] = ACTIONS(2413),
    [anon_sym_COLON] = ACTIONS(2411),
    [anon_sym_return] = ACTIONS(2411),
    [anon_sym_do] = ACTIONS(2411),
    [anon_sym_let] = ACTIONS(2411),
    [anon_sym_let_BANG] = ACTIONS(2413),
    [aux_sym_access_modifier_token1] = ACTIONS(2413),
    [anon_sym_LPAREN] = ACTIONS(2411),
    [anon_sym_COMMA] = ACTIONS(2413),
    [anon_sym_null] = ACTIONS(2411),
    [anon_sym_QMARK] = ACTIONS(2411),
    [anon_sym_COLON_QMARK] = ACTIONS(2411),
    [anon_sym_COLON_COLON] = ACTIONS(2413),
    [anon_sym_AMP] = ACTIONS(2411),
    [anon_sym_LBRACK] = ACTIONS(2411),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2413),
    [anon_sym_LBRACE] = ACTIONS(2411),
    [anon_sym_LT_AT] = ACTIONS(2411),
    [anon_sym_LT_AT_AT] = ACTIONS(2411),
    [anon_sym_DOT] = ACTIONS(2828),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2413),
    [anon_sym_new] = ACTIONS(2411),
    [anon_sym_with] = ACTIONS(2411),
    [anon_sym_return_BANG] = ACTIONS(2413),
    [anon_sym_yield] = ACTIONS(2411),
    [anon_sym_yield_BANG] = ACTIONS(2413),
    [anon_sym_lazy] = ACTIONS(2411),
    [anon_sym_assert] = ACTIONS(2411),
    [anon_sym_upcast] = ACTIONS(2411),
    [anon_sym_downcast] = ACTIONS(2411),
    [anon_sym_COLON_GT] = ACTIONS(2413),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2413),
    [anon_sym_for] = ACTIONS(2411),
    [anon_sym_while] = ACTIONS(2411),
    [anon_sym_if] = ACTIONS(2411),
    [anon_sym_fun] = ACTIONS(2411),
    [anon_sym_try] = ACTIONS(2411),
    [anon_sym_match] = ACTIONS(2411),
    [anon_sym_match_BANG] = ACTIONS(2413),
    [anon_sym_function] = ACTIONS(2411),
    [anon_sym_LT_DASH] = ACTIONS(2411),
    [anon_sym_DOT_LBRACK] = ACTIONS(2413),
    [anon_sym_LT] = ACTIONS(2413),
    [anon_sym_use] = ACTIONS(2411),
    [anon_sym_use_BANG] = ACTIONS(2413),
    [anon_sym_do_BANG] = ACTIONS(2413),
    [anon_sym_begin] = ACTIONS(2411),
    [anon_sym_LPAREN2] = ACTIONS(2411),
    [anon_sym_DOT_DOT2] = ACTIONS(2413),
    [anon_sym_default] = ACTIONS(2411),
    [anon_sym_or] = ACTIONS(2411),
    [anon_sym_static] = ACTIONS(2411),
    [anon_sym_member] = ACTIONS(2411),
    [anon_sym_abstract] = ACTIONS(2411),
    [anon_sym_val] = ACTIONS(2411),
    [anon_sym_override] = ACTIONS(2411),
    [aux_sym_char_token1] = ACTIONS(2413),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2411),
    [anon_sym_DQUOTE] = ACTIONS(2411),
    [anon_sym_AT_DQUOTE] = ACTIONS(2413),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2413),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2413),
    [sym_bool] = ACTIONS(2411),
    [sym_unit] = ACTIONS(2413),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2411),
    [sym_op_identifier] = ACTIONS(2411),
    [anon_sym_PLUS] = ACTIONS(2411),
    [anon_sym_DASH] = ACTIONS(2411),
    [anon_sym_PLUS_DOT] = ACTIONS(2411),
    [anon_sym_DASH_DOT] = ACTIONS(2411),
    [anon_sym_PERCENT] = ACTIONS(2411),
    [anon_sym_AMP_AMP] = ACTIONS(2411),
    [anon_sym_TILDE] = ACTIONS(2413),
    [aux_sym_prefix_op_token1] = ACTIONS(2411),
    [aux_sym_infix_op_token1] = ACTIONS(2413),
    [aux_sym_infix_op_token2] = ACTIONS(2411),
    [anon_sym_PIPE_PIPE] = ACTIONS(2411),
    [anon_sym_BANG_EQ] = ACTIONS(2411),
    [anon_sym_COLON_EQ] = ACTIONS(2413),
    [anon_sym_DOLLAR] = ACTIONS(2411),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2411),
    [sym_int] = ACTIONS(2411),
    [sym_xint] = ACTIONS(2413),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2413),
    [sym__newline] = ACTIONS(2413),
    [sym__dedent] = ACTIONS(2413),
  },
  [862] = {
    [sym_block_comment] = STATE(862),
    [sym_compiler_directive_decl] = STATE(862),
    [sym_fsi_directive_decl] = STATE(862),
    [sym_preproc_line] = STATE(862),
    [sym_identifier] = ACTIONS(2831),
    [anon_sym_EQ] = ACTIONS(2833),
    [anon_sym_LBRACK_LT] = ACTIONS(2833),
    [anon_sym_COLON] = ACTIONS(2831),
    [anon_sym_return] = ACTIONS(2831),
    [anon_sym_do] = ACTIONS(2831),
    [anon_sym_let] = ACTIONS(2831),
    [anon_sym_let_BANG] = ACTIONS(2833),
    [aux_sym_access_modifier_token1] = ACTIONS(2833),
    [anon_sym_LPAREN] = ACTIONS(2831),
    [anon_sym_COMMA] = ACTIONS(2833),
    [anon_sym_null] = ACTIONS(2831),
    [anon_sym_QMARK] = ACTIONS(2831),
    [anon_sym_COLON_QMARK] = ACTIONS(2831),
    [anon_sym_COLON_COLON] = ACTIONS(2833),
    [anon_sym_AMP] = ACTIONS(2831),
    [anon_sym_LBRACK] = ACTIONS(2831),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2833),
    [anon_sym_LBRACE] = ACTIONS(2831),
    [anon_sym_LT_AT] = ACTIONS(2831),
    [anon_sym_LT_AT_AT] = ACTIONS(2831),
    [anon_sym_DOT] = ACTIONS(2831),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2833),
    [anon_sym_new] = ACTIONS(2831),
    [anon_sym_with] = ACTIONS(2831),
    [anon_sym_return_BANG] = ACTIONS(2833),
    [anon_sym_yield] = ACTIONS(2831),
    [anon_sym_yield_BANG] = ACTIONS(2833),
    [anon_sym_lazy] = ACTIONS(2831),
    [anon_sym_assert] = ACTIONS(2831),
    [anon_sym_upcast] = ACTIONS(2831),
    [anon_sym_downcast] = ACTIONS(2831),
    [anon_sym_COLON_GT] = ACTIONS(2833),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2833),
    [anon_sym_for] = ACTIONS(2831),
    [anon_sym_while] = ACTIONS(2831),
    [anon_sym_if] = ACTIONS(2831),
    [anon_sym_fun] = ACTIONS(2831),
    [anon_sym_try] = ACTIONS(2831),
    [anon_sym_match] = ACTIONS(2831),
    [anon_sym_match_BANG] = ACTIONS(2833),
    [anon_sym_function] = ACTIONS(2831),
    [anon_sym_LT_DASH] = ACTIONS(2831),
    [anon_sym_DOT_LBRACK] = ACTIONS(2833),
    [anon_sym_LT] = ACTIONS(2833),
    [anon_sym_use] = ACTIONS(2831),
    [anon_sym_use_BANG] = ACTIONS(2833),
    [anon_sym_do_BANG] = ACTIONS(2833),
    [anon_sym_begin] = ACTIONS(2831),
    [anon_sym_LPAREN2] = ACTIONS(2831),
    [anon_sym_DOT_DOT2] = ACTIONS(2833),
    [anon_sym_default] = ACTIONS(2831),
    [anon_sym_or] = ACTIONS(2831),
    [anon_sym_static] = ACTIONS(2831),
    [anon_sym_member] = ACTIONS(2831),
    [anon_sym_abstract] = ACTIONS(2831),
    [anon_sym_val] = ACTIONS(2831),
    [anon_sym_override] = ACTIONS(2831),
    [aux_sym_char_token1] = ACTIONS(2833),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2831),
    [anon_sym_DQUOTE] = ACTIONS(2831),
    [anon_sym_AT_DQUOTE] = ACTIONS(2833),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2833),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2833),
    [sym_bool] = ACTIONS(2831),
    [sym_unit] = ACTIONS(2833),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2831),
    [sym_op_identifier] = ACTIONS(2831),
    [anon_sym_PLUS] = ACTIONS(2831),
    [anon_sym_DASH] = ACTIONS(2831),
    [anon_sym_PLUS_DOT] = ACTIONS(2831),
    [anon_sym_DASH_DOT] = ACTIONS(2831),
    [anon_sym_PERCENT] = ACTIONS(2831),
    [anon_sym_AMP_AMP] = ACTIONS(2831),
    [anon_sym_TILDE] = ACTIONS(2833),
    [aux_sym_prefix_op_token1] = ACTIONS(2831),
    [aux_sym_infix_op_token1] = ACTIONS(2833),
    [aux_sym_infix_op_token2] = ACTIONS(2831),
    [anon_sym_PIPE_PIPE] = ACTIONS(2831),
    [anon_sym_BANG_EQ] = ACTIONS(2831),
    [anon_sym_COLON_EQ] = ACTIONS(2833),
    [anon_sym_DOLLAR] = ACTIONS(2831),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2831),
    [sym_int] = ACTIONS(2831),
    [sym_xint] = ACTIONS(2833),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2833),
    [sym__newline] = ACTIONS(2833),
    [sym__dedent] = ACTIONS(2833),
  },
  [863] = {
    [sym_block_comment] = STATE(863),
    [sym_compiler_directive_decl] = STATE(863),
    [sym_fsi_directive_decl] = STATE(863),
    [sym_preproc_line] = STATE(863),
    [sym_identifier] = ACTIONS(2835),
    [anon_sym_EQ] = ACTIONS(2837),
    [anon_sym_LBRACK_LT] = ACTIONS(2837),
    [anon_sym_COLON] = ACTIONS(2835),
    [anon_sym_return] = ACTIONS(2835),
    [anon_sym_do] = ACTIONS(2835),
    [anon_sym_let] = ACTIONS(2835),
    [anon_sym_let_BANG] = ACTIONS(2837),
    [aux_sym_access_modifier_token1] = ACTIONS(2837),
    [anon_sym_LPAREN] = ACTIONS(2835),
    [anon_sym_COMMA] = ACTIONS(2837),
    [anon_sym_null] = ACTIONS(2835),
    [anon_sym_QMARK] = ACTIONS(2835),
    [anon_sym_COLON_QMARK] = ACTIONS(2835),
    [anon_sym_COLON_COLON] = ACTIONS(2837),
    [anon_sym_AMP] = ACTIONS(2835),
    [anon_sym_LBRACK] = ACTIONS(2835),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2837),
    [anon_sym_LBRACE] = ACTIONS(2835),
    [anon_sym_LT_AT] = ACTIONS(2835),
    [anon_sym_LT_AT_AT] = ACTIONS(2835),
    [anon_sym_DOT] = ACTIONS(2835),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2837),
    [anon_sym_new] = ACTIONS(2835),
    [anon_sym_with] = ACTIONS(2835),
    [anon_sym_return_BANG] = ACTIONS(2837),
    [anon_sym_yield] = ACTIONS(2835),
    [anon_sym_yield_BANG] = ACTIONS(2837),
    [anon_sym_lazy] = ACTIONS(2835),
    [anon_sym_assert] = ACTIONS(2835),
    [anon_sym_upcast] = ACTIONS(2835),
    [anon_sym_downcast] = ACTIONS(2835),
    [anon_sym_COLON_GT] = ACTIONS(2837),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2837),
    [anon_sym_for] = ACTIONS(2835),
    [anon_sym_while] = ACTIONS(2835),
    [anon_sym_if] = ACTIONS(2835),
    [anon_sym_fun] = ACTIONS(2835),
    [anon_sym_try] = ACTIONS(2835),
    [anon_sym_match] = ACTIONS(2835),
    [anon_sym_match_BANG] = ACTIONS(2837),
    [anon_sym_function] = ACTIONS(2835),
    [anon_sym_LT_DASH] = ACTIONS(2835),
    [anon_sym_DOT_LBRACK] = ACTIONS(2837),
    [anon_sym_LT] = ACTIONS(2837),
    [anon_sym_use] = ACTIONS(2835),
    [anon_sym_use_BANG] = ACTIONS(2837),
    [anon_sym_do_BANG] = ACTIONS(2837),
    [anon_sym_begin] = ACTIONS(2835),
    [anon_sym_LPAREN2] = ACTIONS(2835),
    [anon_sym_DOT_DOT2] = ACTIONS(2837),
    [anon_sym_default] = ACTIONS(2835),
    [anon_sym_or] = ACTIONS(2835),
    [anon_sym_static] = ACTIONS(2835),
    [anon_sym_member] = ACTIONS(2835),
    [anon_sym_abstract] = ACTIONS(2835),
    [anon_sym_val] = ACTIONS(2835),
    [anon_sym_override] = ACTIONS(2835),
    [aux_sym_char_token1] = ACTIONS(2837),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2835),
    [anon_sym_DQUOTE] = ACTIONS(2835),
    [anon_sym_AT_DQUOTE] = ACTIONS(2837),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2837),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2837),
    [sym_bool] = ACTIONS(2835),
    [sym_unit] = ACTIONS(2837),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2835),
    [sym_op_identifier] = ACTIONS(2835),
    [anon_sym_PLUS] = ACTIONS(2835),
    [anon_sym_DASH] = ACTIONS(2835),
    [anon_sym_PLUS_DOT] = ACTIONS(2835),
    [anon_sym_DASH_DOT] = ACTIONS(2835),
    [anon_sym_PERCENT] = ACTIONS(2835),
    [anon_sym_AMP_AMP] = ACTIONS(2835),
    [anon_sym_TILDE] = ACTIONS(2837),
    [aux_sym_prefix_op_token1] = ACTIONS(2835),
    [aux_sym_infix_op_token1] = ACTIONS(2837),
    [aux_sym_infix_op_token2] = ACTIONS(2835),
    [anon_sym_PIPE_PIPE] = ACTIONS(2835),
    [anon_sym_BANG_EQ] = ACTIONS(2835),
    [anon_sym_COLON_EQ] = ACTIONS(2837),
    [anon_sym_DOLLAR] = ACTIONS(2835),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2835),
    [sym_int] = ACTIONS(2835),
    [sym_xint] = ACTIONS(2837),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2837),
    [sym__newline] = ACTIONS(2837),
    [sym__dedent] = ACTIONS(2837),
  },
  [864] = {
    [sym_block_comment] = STATE(864),
    [sym_compiler_directive_decl] = STATE(864),
    [sym_fsi_directive_decl] = STATE(864),
    [sym_preproc_line] = STATE(864),
    [sym_identifier] = ACTIONS(2839),
    [anon_sym_EQ] = ACTIONS(2841),
    [anon_sym_LBRACK_LT] = ACTIONS(2841),
    [anon_sym_COLON] = ACTIONS(2839),
    [anon_sym_return] = ACTIONS(2839),
    [anon_sym_do] = ACTIONS(2839),
    [anon_sym_let] = ACTIONS(2839),
    [anon_sym_let_BANG] = ACTIONS(2841),
    [aux_sym_access_modifier_token1] = ACTIONS(2841),
    [anon_sym_LPAREN] = ACTIONS(2839),
    [anon_sym_COMMA] = ACTIONS(2841),
    [anon_sym_null] = ACTIONS(2839),
    [anon_sym_QMARK] = ACTIONS(2839),
    [anon_sym_COLON_QMARK] = ACTIONS(2839),
    [anon_sym_COLON_COLON] = ACTIONS(2841),
    [anon_sym_AMP] = ACTIONS(2839),
    [anon_sym_LBRACK] = ACTIONS(2839),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2841),
    [anon_sym_LBRACE] = ACTIONS(2839),
    [anon_sym_LT_AT] = ACTIONS(2839),
    [anon_sym_LT_AT_AT] = ACTIONS(2839),
    [anon_sym_DOT] = ACTIONS(2839),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2841),
    [anon_sym_new] = ACTIONS(2839),
    [anon_sym_with] = ACTIONS(2839),
    [anon_sym_return_BANG] = ACTIONS(2841),
    [anon_sym_yield] = ACTIONS(2839),
    [anon_sym_yield_BANG] = ACTIONS(2841),
    [anon_sym_lazy] = ACTIONS(2839),
    [anon_sym_assert] = ACTIONS(2839),
    [anon_sym_upcast] = ACTIONS(2839),
    [anon_sym_downcast] = ACTIONS(2839),
    [anon_sym_COLON_GT] = ACTIONS(2841),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2841),
    [anon_sym_for] = ACTIONS(2839),
    [anon_sym_while] = ACTIONS(2839),
    [anon_sym_if] = ACTIONS(2839),
    [anon_sym_fun] = ACTIONS(2839),
    [anon_sym_try] = ACTIONS(2839),
    [anon_sym_match] = ACTIONS(2839),
    [anon_sym_match_BANG] = ACTIONS(2841),
    [anon_sym_function] = ACTIONS(2839),
    [anon_sym_LT_DASH] = ACTIONS(2839),
    [anon_sym_DOT_LBRACK] = ACTIONS(2841),
    [anon_sym_LT] = ACTIONS(2841),
    [anon_sym_use] = ACTIONS(2839),
    [anon_sym_use_BANG] = ACTIONS(2841),
    [anon_sym_do_BANG] = ACTIONS(2841),
    [anon_sym_begin] = ACTIONS(2839),
    [anon_sym_LPAREN2] = ACTIONS(2839),
    [anon_sym_DOT_DOT2] = ACTIONS(2841),
    [anon_sym_default] = ACTIONS(2839),
    [anon_sym_or] = ACTIONS(2839),
    [anon_sym_static] = ACTIONS(2839),
    [anon_sym_member] = ACTIONS(2839),
    [anon_sym_abstract] = ACTIONS(2839),
    [anon_sym_val] = ACTIONS(2839),
    [anon_sym_override] = ACTIONS(2839),
    [aux_sym_char_token1] = ACTIONS(2841),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2839),
    [anon_sym_DQUOTE] = ACTIONS(2839),
    [anon_sym_AT_DQUOTE] = ACTIONS(2841),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2841),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2841),
    [sym_bool] = ACTIONS(2839),
    [sym_unit] = ACTIONS(2841),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2839),
    [sym_op_identifier] = ACTIONS(2839),
    [anon_sym_PLUS] = ACTIONS(2839),
    [anon_sym_DASH] = ACTIONS(2839),
    [anon_sym_PLUS_DOT] = ACTIONS(2839),
    [anon_sym_DASH_DOT] = ACTIONS(2839),
    [anon_sym_PERCENT] = ACTIONS(2839),
    [anon_sym_AMP_AMP] = ACTIONS(2839),
    [anon_sym_TILDE] = ACTIONS(2841),
    [aux_sym_prefix_op_token1] = ACTIONS(2839),
    [aux_sym_infix_op_token1] = ACTIONS(2841),
    [aux_sym_infix_op_token2] = ACTIONS(2839),
    [anon_sym_PIPE_PIPE] = ACTIONS(2839),
    [anon_sym_BANG_EQ] = ACTIONS(2839),
    [anon_sym_COLON_EQ] = ACTIONS(2841),
    [anon_sym_DOLLAR] = ACTIONS(2839),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2839),
    [sym_int] = ACTIONS(2839),
    [sym_xint] = ACTIONS(2841),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2841),
    [sym__newline] = ACTIONS(2841),
    [sym__dedent] = ACTIONS(2841),
  },
  [865] = {
    [sym_block_comment] = STATE(865),
    [sym_compiler_directive_decl] = STATE(865),
    [sym_fsi_directive_decl] = STATE(865),
    [sym_preproc_line] = STATE(865),
    [sym_identifier] = ACTIONS(2843),
    [anon_sym_EQ] = ACTIONS(2845),
    [anon_sym_LBRACK_LT] = ACTIONS(2845),
    [anon_sym_COLON] = ACTIONS(2843),
    [anon_sym_return] = ACTIONS(2843),
    [anon_sym_do] = ACTIONS(2843),
    [anon_sym_let] = ACTIONS(2843),
    [anon_sym_let_BANG] = ACTIONS(2845),
    [aux_sym_access_modifier_token1] = ACTIONS(2845),
    [anon_sym_LPAREN] = ACTIONS(2843),
    [anon_sym_COMMA] = ACTIONS(2845),
    [anon_sym_null] = ACTIONS(2843),
    [anon_sym_QMARK] = ACTIONS(2843),
    [anon_sym_COLON_QMARK] = ACTIONS(2843),
    [anon_sym_COLON_COLON] = ACTIONS(2845),
    [anon_sym_AMP] = ACTIONS(2843),
    [anon_sym_LBRACK] = ACTIONS(2843),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2845),
    [anon_sym_LBRACE] = ACTIONS(2843),
    [anon_sym_LT_AT] = ACTIONS(2843),
    [anon_sym_LT_AT_AT] = ACTIONS(2843),
    [anon_sym_DOT] = ACTIONS(2843),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2845),
    [anon_sym_new] = ACTIONS(2843),
    [anon_sym_with] = ACTIONS(2843),
    [anon_sym_return_BANG] = ACTIONS(2845),
    [anon_sym_yield] = ACTIONS(2843),
    [anon_sym_yield_BANG] = ACTIONS(2845),
    [anon_sym_lazy] = ACTIONS(2843),
    [anon_sym_assert] = ACTIONS(2843),
    [anon_sym_upcast] = ACTIONS(2843),
    [anon_sym_downcast] = ACTIONS(2843),
    [anon_sym_COLON_GT] = ACTIONS(2845),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2845),
    [anon_sym_for] = ACTIONS(2843),
    [anon_sym_while] = ACTIONS(2843),
    [anon_sym_if] = ACTIONS(2843),
    [anon_sym_fun] = ACTIONS(2843),
    [anon_sym_try] = ACTIONS(2843),
    [anon_sym_match] = ACTIONS(2843),
    [anon_sym_match_BANG] = ACTIONS(2845),
    [anon_sym_function] = ACTIONS(2843),
    [anon_sym_LT_DASH] = ACTIONS(2843),
    [anon_sym_DOT_LBRACK] = ACTIONS(2845),
    [anon_sym_LT] = ACTIONS(2845),
    [anon_sym_use] = ACTIONS(2843),
    [anon_sym_use_BANG] = ACTIONS(2845),
    [anon_sym_do_BANG] = ACTIONS(2845),
    [anon_sym_begin] = ACTIONS(2843),
    [anon_sym_LPAREN2] = ACTIONS(2843),
    [anon_sym_DOT_DOT2] = ACTIONS(2845),
    [anon_sym_default] = ACTIONS(2843),
    [anon_sym_or] = ACTIONS(2843),
    [anon_sym_static] = ACTIONS(2843),
    [anon_sym_member] = ACTIONS(2843),
    [anon_sym_abstract] = ACTIONS(2843),
    [anon_sym_val] = ACTIONS(2843),
    [anon_sym_override] = ACTIONS(2843),
    [aux_sym_char_token1] = ACTIONS(2845),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2843),
    [anon_sym_DQUOTE] = ACTIONS(2843),
    [anon_sym_AT_DQUOTE] = ACTIONS(2845),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2845),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2845),
    [sym_bool] = ACTIONS(2843),
    [sym_unit] = ACTIONS(2845),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2843),
    [sym_op_identifier] = ACTIONS(2843),
    [anon_sym_PLUS] = ACTIONS(2843),
    [anon_sym_DASH] = ACTIONS(2843),
    [anon_sym_PLUS_DOT] = ACTIONS(2843),
    [anon_sym_DASH_DOT] = ACTIONS(2843),
    [anon_sym_PERCENT] = ACTIONS(2843),
    [anon_sym_AMP_AMP] = ACTIONS(2843),
    [anon_sym_TILDE] = ACTIONS(2845),
    [aux_sym_prefix_op_token1] = ACTIONS(2843),
    [aux_sym_infix_op_token1] = ACTIONS(2845),
    [aux_sym_infix_op_token2] = ACTIONS(2843),
    [anon_sym_PIPE_PIPE] = ACTIONS(2843),
    [anon_sym_BANG_EQ] = ACTIONS(2843),
    [anon_sym_COLON_EQ] = ACTIONS(2845),
    [anon_sym_DOLLAR] = ACTIONS(2843),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2843),
    [sym_int] = ACTIONS(2843),
    [sym_xint] = ACTIONS(2845),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2845),
    [sym__newline] = ACTIONS(2845),
    [sym__dedent] = ACTIONS(2845),
  },
  [866] = {
    [sym_block_comment] = STATE(866),
    [sym_compiler_directive_decl] = STATE(866),
    [sym_fsi_directive_decl] = STATE(866),
    [sym_preproc_line] = STATE(866),
    [aux_sym_sequential_expression_repeat1] = STATE(880),
    [sym_identifier] = ACTIONS(2847),
    [anon_sym_EQ] = ACTIONS(2849),
    [anon_sym_LBRACK_LT] = ACTIONS(2849),
    [anon_sym_COLON] = ACTIONS(2847),
    [anon_sym_return] = ACTIONS(2847),
    [anon_sym_do] = ACTIONS(2847),
    [anon_sym_let] = ACTIONS(2847),
    [anon_sym_let_BANG] = ACTIONS(2849),
    [aux_sym_access_modifier_token1] = ACTIONS(2849),
    [anon_sym_LPAREN] = ACTIONS(2847),
    [anon_sym_COMMA] = ACTIONS(2849),
    [anon_sym_null] = ACTIONS(2847),
    [anon_sym_QMARK] = ACTIONS(2847),
    [anon_sym_COLON_QMARK] = ACTIONS(2847),
    [anon_sym_COLON_COLON] = ACTIONS(2849),
    [anon_sym_AMP] = ACTIONS(2847),
    [anon_sym_LBRACK] = ACTIONS(2847),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2849),
    [anon_sym_LBRACE] = ACTIONS(2847),
    [anon_sym_LT_AT] = ACTIONS(2847),
    [anon_sym_LT_AT_AT] = ACTIONS(2847),
    [anon_sym_DOT] = ACTIONS(2847),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2849),
    [anon_sym_new] = ACTIONS(2847),
    [anon_sym_with] = ACTIONS(2847),
    [anon_sym_return_BANG] = ACTIONS(2849),
    [anon_sym_yield] = ACTIONS(2847),
    [anon_sym_yield_BANG] = ACTIONS(2849),
    [anon_sym_lazy] = ACTIONS(2847),
    [anon_sym_assert] = ACTIONS(2847),
    [anon_sym_upcast] = ACTIONS(2847),
    [anon_sym_downcast] = ACTIONS(2847),
    [anon_sym_COLON_GT] = ACTIONS(2849),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2849),
    [anon_sym_for] = ACTIONS(2847),
    [anon_sym_while] = ACTIONS(2847),
    [anon_sym_if] = ACTIONS(2847),
    [anon_sym_fun] = ACTIONS(2847),
    [anon_sym_try] = ACTIONS(2847),
    [anon_sym_match] = ACTIONS(2847),
    [anon_sym_match_BANG] = ACTIONS(2849),
    [anon_sym_function] = ACTIONS(2847),
    [anon_sym_LT_DASH] = ACTIONS(2847),
    [anon_sym_DOT_LBRACK] = ACTIONS(2849),
    [anon_sym_LT] = ACTIONS(2849),
    [anon_sym_use] = ACTIONS(2847),
    [anon_sym_use_BANG] = ACTIONS(2849),
    [anon_sym_do_BANG] = ACTIONS(2849),
    [anon_sym_begin] = ACTIONS(2847),
    [anon_sym_LPAREN2] = ACTIONS(2847),
    [anon_sym_default] = ACTIONS(2847),
    [anon_sym_or] = ACTIONS(2847),
    [anon_sym_static] = ACTIONS(2847),
    [anon_sym_member] = ACTIONS(2847),
    [anon_sym_abstract] = ACTIONS(2847),
    [anon_sym_val] = ACTIONS(2847),
    [anon_sym_override] = ACTIONS(2847),
    [aux_sym_char_token1] = ACTIONS(2849),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2847),
    [anon_sym_DQUOTE] = ACTIONS(2847),
    [anon_sym_AT_DQUOTE] = ACTIONS(2849),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2849),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2849),
    [sym_bool] = ACTIONS(2847),
    [sym_unit] = ACTIONS(2849),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2847),
    [sym_op_identifier] = ACTIONS(2847),
    [anon_sym_PLUS] = ACTIONS(2847),
    [anon_sym_DASH] = ACTIONS(2847),
    [anon_sym_PLUS_DOT] = ACTIONS(2847),
    [anon_sym_DASH_DOT] = ACTIONS(2847),
    [anon_sym_PERCENT] = ACTIONS(2847),
    [anon_sym_AMP_AMP] = ACTIONS(2847),
    [anon_sym_TILDE] = ACTIONS(2849),
    [aux_sym_prefix_op_token1] = ACTIONS(2847),
    [aux_sym_infix_op_token1] = ACTIONS(2849),
    [aux_sym_infix_op_token2] = ACTIONS(2847),
    [anon_sym_PIPE_PIPE] = ACTIONS(2847),
    [anon_sym_BANG_EQ] = ACTIONS(2847),
    [anon_sym_COLON_EQ] = ACTIONS(2849),
    [anon_sym_DOLLAR] = ACTIONS(2847),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2847),
    [sym_int] = ACTIONS(2847),
    [sym_xint] = ACTIONS(2849),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2849),
    [sym__newline] = ACTIONS(2849),
    [sym__dedent] = ACTIONS(2849),
  },
  [867] = {
    [sym_block_comment] = STATE(867),
    [sym_compiler_directive_decl] = STATE(867),
    [sym_fsi_directive_decl] = STATE(867),
    [sym_preproc_line] = STATE(867),
    [sym_identifier] = ACTIONS(2851),
    [anon_sym_EQ] = ACTIONS(2853),
    [anon_sym_LBRACK_LT] = ACTIONS(2853),
    [anon_sym_COLON] = ACTIONS(2851),
    [anon_sym_return] = ACTIONS(2851),
    [anon_sym_do] = ACTIONS(2851),
    [anon_sym_let] = ACTIONS(2851),
    [anon_sym_let_BANG] = ACTIONS(2853),
    [aux_sym_access_modifier_token1] = ACTIONS(2853),
    [anon_sym_LPAREN] = ACTIONS(2851),
    [anon_sym_COMMA] = ACTIONS(2853),
    [anon_sym_null] = ACTIONS(2851),
    [anon_sym_QMARK] = ACTIONS(2851),
    [anon_sym_COLON_QMARK] = ACTIONS(2851),
    [anon_sym_COLON_COLON] = ACTIONS(2853),
    [anon_sym_AMP] = ACTIONS(2851),
    [anon_sym_LBRACK] = ACTIONS(2851),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2853),
    [anon_sym_LBRACE] = ACTIONS(2851),
    [anon_sym_LT_AT] = ACTIONS(2851),
    [anon_sym_LT_AT_AT] = ACTIONS(2851),
    [anon_sym_DOT] = ACTIONS(2851),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2853),
    [anon_sym_new] = ACTIONS(2851),
    [anon_sym_with] = ACTIONS(2851),
    [anon_sym_return_BANG] = ACTIONS(2853),
    [anon_sym_yield] = ACTIONS(2851),
    [anon_sym_yield_BANG] = ACTIONS(2853),
    [anon_sym_lazy] = ACTIONS(2851),
    [anon_sym_assert] = ACTIONS(2851),
    [anon_sym_upcast] = ACTIONS(2851),
    [anon_sym_downcast] = ACTIONS(2851),
    [anon_sym_COLON_GT] = ACTIONS(2853),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2853),
    [anon_sym_for] = ACTIONS(2851),
    [anon_sym_while] = ACTIONS(2851),
    [anon_sym_if] = ACTIONS(2851),
    [anon_sym_fun] = ACTIONS(2851),
    [anon_sym_try] = ACTIONS(2851),
    [anon_sym_match] = ACTIONS(2851),
    [anon_sym_match_BANG] = ACTIONS(2853),
    [anon_sym_function] = ACTIONS(2851),
    [anon_sym_LT_DASH] = ACTIONS(2851),
    [anon_sym_DOT_LBRACK] = ACTIONS(2853),
    [anon_sym_LT] = ACTIONS(2853),
    [anon_sym_use] = ACTIONS(2851),
    [anon_sym_use_BANG] = ACTIONS(2853),
    [anon_sym_do_BANG] = ACTIONS(2853),
    [anon_sym_begin] = ACTIONS(2851),
    [anon_sym_LPAREN2] = ACTIONS(2851),
    [anon_sym_DOT_DOT2] = ACTIONS(2853),
    [anon_sym_default] = ACTIONS(2851),
    [anon_sym_or] = ACTIONS(2851),
    [anon_sym_static] = ACTIONS(2851),
    [anon_sym_member] = ACTIONS(2851),
    [anon_sym_abstract] = ACTIONS(2851),
    [anon_sym_val] = ACTIONS(2851),
    [anon_sym_override] = ACTIONS(2851),
    [aux_sym_char_token1] = ACTIONS(2853),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2851),
    [anon_sym_DQUOTE] = ACTIONS(2851),
    [anon_sym_AT_DQUOTE] = ACTIONS(2853),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2853),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2853),
    [sym_bool] = ACTIONS(2851),
    [sym_unit] = ACTIONS(2853),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2851),
    [sym_op_identifier] = ACTIONS(2851),
    [anon_sym_PLUS] = ACTIONS(2851),
    [anon_sym_DASH] = ACTIONS(2851),
    [anon_sym_PLUS_DOT] = ACTIONS(2851),
    [anon_sym_DASH_DOT] = ACTIONS(2851),
    [anon_sym_PERCENT] = ACTIONS(2851),
    [anon_sym_AMP_AMP] = ACTIONS(2851),
    [anon_sym_TILDE] = ACTIONS(2853),
    [aux_sym_prefix_op_token1] = ACTIONS(2851),
    [aux_sym_infix_op_token1] = ACTIONS(2853),
    [aux_sym_infix_op_token2] = ACTIONS(2851),
    [anon_sym_PIPE_PIPE] = ACTIONS(2851),
    [anon_sym_BANG_EQ] = ACTIONS(2851),
    [anon_sym_COLON_EQ] = ACTIONS(2853),
    [anon_sym_DOLLAR] = ACTIONS(2851),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2851),
    [sym_int] = ACTIONS(2851),
    [sym_xint] = ACTIONS(2853),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2853),
    [sym__newline] = ACTIONS(2853),
    [sym__dedent] = ACTIONS(2853),
  },
  [868] = {
    [sym_block_comment] = STATE(868),
    [sym_compiler_directive_decl] = STATE(868),
    [sym_fsi_directive_decl] = STATE(868),
    [sym_preproc_line] = STATE(868),
    [sym_identifier] = ACTIONS(2158),
    [anon_sym_EQ] = ACTIONS(2160),
    [anon_sym_LBRACK_LT] = ACTIONS(2160),
    [anon_sym_COLON] = ACTIONS(2158),
    [anon_sym_return] = ACTIONS(2158),
    [anon_sym_do] = ACTIONS(2158),
    [anon_sym_let] = ACTIONS(2158),
    [anon_sym_let_BANG] = ACTIONS(2160),
    [aux_sym_access_modifier_token1] = ACTIONS(2160),
    [anon_sym_LPAREN] = ACTIONS(2158),
    [anon_sym_COMMA] = ACTIONS(2160),
    [anon_sym_null] = ACTIONS(2158),
    [anon_sym_QMARK] = ACTIONS(2158),
    [anon_sym_COLON_QMARK] = ACTIONS(2158),
    [anon_sym_COLON_COLON] = ACTIONS(2160),
    [anon_sym_AMP] = ACTIONS(2158),
    [anon_sym_LBRACK] = ACTIONS(2158),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2160),
    [anon_sym_LBRACE] = ACTIONS(2158),
    [anon_sym_LT_AT] = ACTIONS(2158),
    [anon_sym_LT_AT_AT] = ACTIONS(2158),
    [anon_sym_DOT] = ACTIONS(2158),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2160),
    [anon_sym_new] = ACTIONS(2158),
    [anon_sym_with] = ACTIONS(2158),
    [anon_sym_return_BANG] = ACTIONS(2160),
    [anon_sym_yield] = ACTIONS(2158),
    [anon_sym_yield_BANG] = ACTIONS(2160),
    [anon_sym_lazy] = ACTIONS(2158),
    [anon_sym_assert] = ACTIONS(2158),
    [anon_sym_upcast] = ACTIONS(2158),
    [anon_sym_downcast] = ACTIONS(2158),
    [anon_sym_COLON_GT] = ACTIONS(2160),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2160),
    [anon_sym_for] = ACTIONS(2158),
    [anon_sym_while] = ACTIONS(2158),
    [anon_sym_if] = ACTIONS(2158),
    [anon_sym_fun] = ACTIONS(2158),
    [anon_sym_try] = ACTIONS(2158),
    [anon_sym_match] = ACTIONS(2158),
    [anon_sym_match_BANG] = ACTIONS(2160),
    [anon_sym_function] = ACTIONS(2158),
    [anon_sym_LT_DASH] = ACTIONS(2158),
    [anon_sym_DOT_LBRACK] = ACTIONS(2160),
    [anon_sym_LT] = ACTIONS(2160),
    [anon_sym_use] = ACTIONS(2158),
    [anon_sym_use_BANG] = ACTIONS(2160),
    [anon_sym_do_BANG] = ACTIONS(2160),
    [anon_sym_begin] = ACTIONS(2158),
    [anon_sym_LPAREN2] = ACTIONS(2158),
    [anon_sym_DOT_DOT2] = ACTIONS(2160),
    [anon_sym_default] = ACTIONS(2158),
    [anon_sym_or] = ACTIONS(2158),
    [anon_sym_static] = ACTIONS(2158),
    [anon_sym_member] = ACTIONS(2158),
    [anon_sym_abstract] = ACTIONS(2158),
    [anon_sym_val] = ACTIONS(2158),
    [anon_sym_override] = ACTIONS(2158),
    [aux_sym_char_token1] = ACTIONS(2160),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2158),
    [anon_sym_DQUOTE] = ACTIONS(2158),
    [anon_sym_AT_DQUOTE] = ACTIONS(2160),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2160),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2160),
    [sym_bool] = ACTIONS(2158),
    [sym_unit] = ACTIONS(2160),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2158),
    [sym_op_identifier] = ACTIONS(2158),
    [anon_sym_PLUS] = ACTIONS(2158),
    [anon_sym_DASH] = ACTIONS(2158),
    [anon_sym_PLUS_DOT] = ACTIONS(2158),
    [anon_sym_DASH_DOT] = ACTIONS(2158),
    [anon_sym_PERCENT] = ACTIONS(2158),
    [anon_sym_AMP_AMP] = ACTIONS(2158),
    [anon_sym_TILDE] = ACTIONS(2160),
    [aux_sym_prefix_op_token1] = ACTIONS(2158),
    [aux_sym_infix_op_token1] = ACTIONS(2160),
    [aux_sym_infix_op_token2] = ACTIONS(2158),
    [anon_sym_PIPE_PIPE] = ACTIONS(2158),
    [anon_sym_BANG_EQ] = ACTIONS(2158),
    [anon_sym_COLON_EQ] = ACTIONS(2160),
    [anon_sym_DOLLAR] = ACTIONS(2158),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2158),
    [sym_int] = ACTIONS(2158),
    [sym_xint] = ACTIONS(2160),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2160),
    [sym__newline] = ACTIONS(2160),
    [sym__dedent] = ACTIONS(2160),
  },
  [869] = {
    [sym_block_comment] = STATE(869),
    [sym_compiler_directive_decl] = STATE(869),
    [sym_fsi_directive_decl] = STATE(869),
    [sym_preproc_line] = STATE(869),
    [sym_identifier] = ACTIONS(2855),
    [anon_sym_EQ] = ACTIONS(2857),
    [anon_sym_LBRACK_LT] = ACTIONS(2857),
    [anon_sym_COLON] = ACTIONS(2855),
    [anon_sym_return] = ACTIONS(2855),
    [anon_sym_do] = ACTIONS(2855),
    [anon_sym_let] = ACTIONS(2855),
    [anon_sym_let_BANG] = ACTIONS(2857),
    [aux_sym_access_modifier_token1] = ACTIONS(2857),
    [anon_sym_LPAREN] = ACTIONS(2855),
    [anon_sym_COMMA] = ACTIONS(2857),
    [anon_sym_null] = ACTIONS(2855),
    [anon_sym_QMARK] = ACTIONS(2855),
    [anon_sym_COLON_QMARK] = ACTIONS(2855),
    [anon_sym_COLON_COLON] = ACTIONS(2857),
    [anon_sym_AMP] = ACTIONS(2855),
    [anon_sym_LBRACK] = ACTIONS(2855),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2857),
    [anon_sym_LBRACE] = ACTIONS(2855),
    [anon_sym_LT_AT] = ACTIONS(2855),
    [anon_sym_LT_AT_AT] = ACTIONS(2855),
    [anon_sym_DOT] = ACTIONS(2855),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2857),
    [anon_sym_new] = ACTIONS(2855),
    [anon_sym_with] = ACTIONS(2855),
    [anon_sym_return_BANG] = ACTIONS(2857),
    [anon_sym_yield] = ACTIONS(2855),
    [anon_sym_yield_BANG] = ACTIONS(2857),
    [anon_sym_lazy] = ACTIONS(2855),
    [anon_sym_assert] = ACTIONS(2855),
    [anon_sym_upcast] = ACTIONS(2855),
    [anon_sym_downcast] = ACTIONS(2855),
    [anon_sym_COLON_GT] = ACTIONS(2857),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2857),
    [anon_sym_for] = ACTIONS(2855),
    [anon_sym_while] = ACTIONS(2855),
    [anon_sym_if] = ACTIONS(2855),
    [anon_sym_fun] = ACTIONS(2855),
    [anon_sym_try] = ACTIONS(2855),
    [anon_sym_match] = ACTIONS(2855),
    [anon_sym_match_BANG] = ACTIONS(2857),
    [anon_sym_function] = ACTIONS(2855),
    [anon_sym_LT_DASH] = ACTIONS(2855),
    [anon_sym_DOT_LBRACK] = ACTIONS(2857),
    [anon_sym_LT] = ACTIONS(2857),
    [anon_sym_use] = ACTIONS(2855),
    [anon_sym_use_BANG] = ACTIONS(2857),
    [anon_sym_do_BANG] = ACTIONS(2857),
    [anon_sym_begin] = ACTIONS(2855),
    [anon_sym_LPAREN2] = ACTIONS(2855),
    [anon_sym_DOT_DOT2] = ACTIONS(2857),
    [anon_sym_default] = ACTIONS(2855),
    [anon_sym_or] = ACTIONS(2855),
    [anon_sym_static] = ACTIONS(2855),
    [anon_sym_member] = ACTIONS(2855),
    [anon_sym_abstract] = ACTIONS(2855),
    [anon_sym_val] = ACTIONS(2855),
    [anon_sym_override] = ACTIONS(2855),
    [aux_sym_char_token1] = ACTIONS(2857),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2855),
    [anon_sym_DQUOTE] = ACTIONS(2855),
    [anon_sym_AT_DQUOTE] = ACTIONS(2857),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2857),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2857),
    [sym_bool] = ACTIONS(2855),
    [sym_unit] = ACTIONS(2857),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2855),
    [sym_op_identifier] = ACTIONS(2855),
    [anon_sym_PLUS] = ACTIONS(2855),
    [anon_sym_DASH] = ACTIONS(2855),
    [anon_sym_PLUS_DOT] = ACTIONS(2855),
    [anon_sym_DASH_DOT] = ACTIONS(2855),
    [anon_sym_PERCENT] = ACTIONS(2855),
    [anon_sym_AMP_AMP] = ACTIONS(2855),
    [anon_sym_TILDE] = ACTIONS(2857),
    [aux_sym_prefix_op_token1] = ACTIONS(2855),
    [aux_sym_infix_op_token1] = ACTIONS(2857),
    [aux_sym_infix_op_token2] = ACTIONS(2855),
    [anon_sym_PIPE_PIPE] = ACTIONS(2855),
    [anon_sym_BANG_EQ] = ACTIONS(2855),
    [anon_sym_COLON_EQ] = ACTIONS(2857),
    [anon_sym_DOLLAR] = ACTIONS(2855),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2855),
    [sym_int] = ACTIONS(2855),
    [sym_xint] = ACTIONS(2857),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2857),
    [sym__newline] = ACTIONS(2857),
    [sym__dedent] = ACTIONS(2857),
  },
  [870] = {
    [sym_block_comment] = STATE(870),
    [sym_compiler_directive_decl] = STATE(870),
    [sym_fsi_directive_decl] = STATE(870),
    [sym_preproc_line] = STATE(870),
    [sym_identifier] = ACTIONS(2859),
    [anon_sym_EQ] = ACTIONS(2861),
    [anon_sym_LBRACK_LT] = ACTIONS(2861),
    [anon_sym_COLON] = ACTIONS(2859),
    [anon_sym_return] = ACTIONS(2859),
    [anon_sym_do] = ACTIONS(2859),
    [anon_sym_let] = ACTIONS(2859),
    [anon_sym_let_BANG] = ACTIONS(2861),
    [aux_sym_access_modifier_token1] = ACTIONS(2861),
    [anon_sym_LPAREN] = ACTIONS(2859),
    [anon_sym_COMMA] = ACTIONS(2861),
    [anon_sym_null] = ACTIONS(2859),
    [anon_sym_QMARK] = ACTIONS(2859),
    [anon_sym_COLON_QMARK] = ACTIONS(2859),
    [anon_sym_COLON_COLON] = ACTIONS(2861),
    [anon_sym_AMP] = ACTIONS(2859),
    [anon_sym_LBRACK] = ACTIONS(2859),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2861),
    [anon_sym_LBRACE] = ACTIONS(2859),
    [anon_sym_LT_AT] = ACTIONS(2859),
    [anon_sym_LT_AT_AT] = ACTIONS(2859),
    [anon_sym_DOT] = ACTIONS(2859),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2861),
    [anon_sym_new] = ACTIONS(2859),
    [anon_sym_with] = ACTIONS(2859),
    [anon_sym_return_BANG] = ACTIONS(2861),
    [anon_sym_yield] = ACTIONS(2859),
    [anon_sym_yield_BANG] = ACTIONS(2861),
    [anon_sym_lazy] = ACTIONS(2859),
    [anon_sym_assert] = ACTIONS(2859),
    [anon_sym_upcast] = ACTIONS(2859),
    [anon_sym_downcast] = ACTIONS(2859),
    [anon_sym_COLON_GT] = ACTIONS(2861),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2861),
    [anon_sym_for] = ACTIONS(2859),
    [anon_sym_while] = ACTIONS(2859),
    [anon_sym_if] = ACTIONS(2859),
    [anon_sym_fun] = ACTIONS(2859),
    [anon_sym_try] = ACTIONS(2859),
    [anon_sym_match] = ACTIONS(2859),
    [anon_sym_match_BANG] = ACTIONS(2861),
    [anon_sym_function] = ACTIONS(2859),
    [anon_sym_LT_DASH] = ACTIONS(2859),
    [anon_sym_DOT_LBRACK] = ACTIONS(2861),
    [anon_sym_LT] = ACTIONS(2861),
    [anon_sym_use] = ACTIONS(2859),
    [anon_sym_use_BANG] = ACTIONS(2861),
    [anon_sym_do_BANG] = ACTIONS(2861),
    [anon_sym_begin] = ACTIONS(2859),
    [anon_sym_LPAREN2] = ACTIONS(2859),
    [anon_sym_DOT_DOT2] = ACTIONS(2861),
    [anon_sym_default] = ACTIONS(2859),
    [anon_sym_or] = ACTIONS(2859),
    [anon_sym_static] = ACTIONS(2859),
    [anon_sym_member] = ACTIONS(2859),
    [anon_sym_abstract] = ACTIONS(2859),
    [anon_sym_val] = ACTIONS(2859),
    [anon_sym_override] = ACTIONS(2859),
    [aux_sym_char_token1] = ACTIONS(2861),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2859),
    [anon_sym_DQUOTE] = ACTIONS(2859),
    [anon_sym_AT_DQUOTE] = ACTIONS(2861),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2861),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2861),
    [sym_bool] = ACTIONS(2859),
    [sym_unit] = ACTIONS(2861),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2859),
    [sym_op_identifier] = ACTIONS(2859),
    [anon_sym_PLUS] = ACTIONS(2859),
    [anon_sym_DASH] = ACTIONS(2859),
    [anon_sym_PLUS_DOT] = ACTIONS(2859),
    [anon_sym_DASH_DOT] = ACTIONS(2859),
    [anon_sym_PERCENT] = ACTIONS(2859),
    [anon_sym_AMP_AMP] = ACTIONS(2859),
    [anon_sym_TILDE] = ACTIONS(2861),
    [aux_sym_prefix_op_token1] = ACTIONS(2859),
    [aux_sym_infix_op_token1] = ACTIONS(2861),
    [aux_sym_infix_op_token2] = ACTIONS(2859),
    [anon_sym_PIPE_PIPE] = ACTIONS(2859),
    [anon_sym_BANG_EQ] = ACTIONS(2859),
    [anon_sym_COLON_EQ] = ACTIONS(2861),
    [anon_sym_DOLLAR] = ACTIONS(2859),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2859),
    [sym_int] = ACTIONS(2859),
    [sym_xint] = ACTIONS(2861),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2861),
    [sym__newline] = ACTIONS(2861),
    [sym__dedent] = ACTIONS(2861),
  },
  [871] = {
    [sym_block_comment] = STATE(871),
    [sym_compiler_directive_decl] = STATE(871),
    [sym_fsi_directive_decl] = STATE(871),
    [sym_preproc_line] = STATE(871),
    [sym_identifier] = ACTIONS(2863),
    [anon_sym_EQ] = ACTIONS(2865),
    [anon_sym_LBRACK_LT] = ACTIONS(2865),
    [anon_sym_COLON] = ACTIONS(2863),
    [anon_sym_return] = ACTIONS(2863),
    [anon_sym_do] = ACTIONS(2863),
    [anon_sym_let] = ACTIONS(2863),
    [anon_sym_let_BANG] = ACTIONS(2865),
    [aux_sym_access_modifier_token1] = ACTIONS(2865),
    [anon_sym_LPAREN] = ACTIONS(2863),
    [anon_sym_COMMA] = ACTIONS(2865),
    [anon_sym_null] = ACTIONS(2863),
    [anon_sym_QMARK] = ACTIONS(2863),
    [anon_sym_COLON_QMARK] = ACTIONS(2863),
    [anon_sym_COLON_COLON] = ACTIONS(2865),
    [anon_sym_AMP] = ACTIONS(2863),
    [anon_sym_LBRACK] = ACTIONS(2863),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2865),
    [anon_sym_LBRACE] = ACTIONS(2863),
    [anon_sym_LT_AT] = ACTIONS(2863),
    [anon_sym_LT_AT_AT] = ACTIONS(2863),
    [anon_sym_DOT] = ACTIONS(2863),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2865),
    [anon_sym_new] = ACTIONS(2863),
    [anon_sym_with] = ACTIONS(2863),
    [anon_sym_return_BANG] = ACTIONS(2865),
    [anon_sym_yield] = ACTIONS(2863),
    [anon_sym_yield_BANG] = ACTIONS(2865),
    [anon_sym_lazy] = ACTIONS(2863),
    [anon_sym_assert] = ACTIONS(2863),
    [anon_sym_upcast] = ACTIONS(2863),
    [anon_sym_downcast] = ACTIONS(2863),
    [anon_sym_COLON_GT] = ACTIONS(2865),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2865),
    [anon_sym_for] = ACTIONS(2863),
    [anon_sym_while] = ACTIONS(2863),
    [anon_sym_if] = ACTIONS(2863),
    [anon_sym_fun] = ACTIONS(2863),
    [anon_sym_try] = ACTIONS(2863),
    [anon_sym_match] = ACTIONS(2863),
    [anon_sym_match_BANG] = ACTIONS(2865),
    [anon_sym_function] = ACTIONS(2863),
    [anon_sym_LT_DASH] = ACTIONS(2863),
    [anon_sym_DOT_LBRACK] = ACTIONS(2865),
    [anon_sym_LT] = ACTIONS(2865),
    [anon_sym_use] = ACTIONS(2863),
    [anon_sym_use_BANG] = ACTIONS(2865),
    [anon_sym_do_BANG] = ACTIONS(2865),
    [anon_sym_begin] = ACTIONS(2863),
    [anon_sym_LPAREN2] = ACTIONS(2863),
    [anon_sym_DOT_DOT2] = ACTIONS(2865),
    [anon_sym_default] = ACTIONS(2863),
    [anon_sym_or] = ACTIONS(2863),
    [anon_sym_static] = ACTIONS(2863),
    [anon_sym_member] = ACTIONS(2863),
    [anon_sym_abstract] = ACTIONS(2863),
    [anon_sym_val] = ACTIONS(2863),
    [anon_sym_override] = ACTIONS(2863),
    [aux_sym_char_token1] = ACTIONS(2865),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2863),
    [anon_sym_DQUOTE] = ACTIONS(2863),
    [anon_sym_AT_DQUOTE] = ACTIONS(2865),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2865),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2865),
    [sym_bool] = ACTIONS(2863),
    [sym_unit] = ACTIONS(2865),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2863),
    [sym_op_identifier] = ACTIONS(2863),
    [anon_sym_PLUS] = ACTIONS(2863),
    [anon_sym_DASH] = ACTIONS(2863),
    [anon_sym_PLUS_DOT] = ACTIONS(2863),
    [anon_sym_DASH_DOT] = ACTIONS(2863),
    [anon_sym_PERCENT] = ACTIONS(2863),
    [anon_sym_AMP_AMP] = ACTIONS(2863),
    [anon_sym_TILDE] = ACTIONS(2865),
    [aux_sym_prefix_op_token1] = ACTIONS(2863),
    [aux_sym_infix_op_token1] = ACTIONS(2865),
    [aux_sym_infix_op_token2] = ACTIONS(2863),
    [anon_sym_PIPE_PIPE] = ACTIONS(2863),
    [anon_sym_BANG_EQ] = ACTIONS(2863),
    [anon_sym_COLON_EQ] = ACTIONS(2865),
    [anon_sym_DOLLAR] = ACTIONS(2863),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2863),
    [sym_int] = ACTIONS(2863),
    [sym_xint] = ACTIONS(2865),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2865),
    [sym__newline] = ACTIONS(2865),
    [sym__dedent] = ACTIONS(2865),
  },
  [872] = {
    [sym_block_comment] = STATE(872),
    [sym_compiler_directive_decl] = STATE(872),
    [sym_fsi_directive_decl] = STATE(872),
    [sym_preproc_line] = STATE(872),
    [sym_identifier] = ACTIONS(2867),
    [anon_sym_EQ] = ACTIONS(2869),
    [anon_sym_LBRACK_LT] = ACTIONS(2869),
    [anon_sym_COLON] = ACTIONS(2867),
    [anon_sym_return] = ACTIONS(2867),
    [anon_sym_do] = ACTIONS(2867),
    [anon_sym_let] = ACTIONS(2867),
    [anon_sym_let_BANG] = ACTIONS(2869),
    [aux_sym_access_modifier_token1] = ACTIONS(2869),
    [anon_sym_LPAREN] = ACTIONS(2867),
    [anon_sym_COMMA] = ACTIONS(2869),
    [anon_sym_null] = ACTIONS(2867),
    [anon_sym_QMARK] = ACTIONS(2867),
    [anon_sym_COLON_QMARK] = ACTIONS(2867),
    [anon_sym_COLON_COLON] = ACTIONS(2869),
    [anon_sym_AMP] = ACTIONS(2867),
    [anon_sym_LBRACK] = ACTIONS(2867),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2869),
    [anon_sym_LBRACE] = ACTIONS(2867),
    [anon_sym_LT_AT] = ACTIONS(2867),
    [anon_sym_LT_AT_AT] = ACTIONS(2867),
    [anon_sym_DOT] = ACTIONS(2871),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2869),
    [anon_sym_new] = ACTIONS(2867),
    [anon_sym_with] = ACTIONS(2867),
    [anon_sym_return_BANG] = ACTIONS(2869),
    [anon_sym_yield] = ACTIONS(2867),
    [anon_sym_yield_BANG] = ACTIONS(2869),
    [anon_sym_lazy] = ACTIONS(2867),
    [anon_sym_assert] = ACTIONS(2867),
    [anon_sym_upcast] = ACTIONS(2867),
    [anon_sym_downcast] = ACTIONS(2867),
    [anon_sym_COLON_GT] = ACTIONS(2869),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2869),
    [anon_sym_for] = ACTIONS(2867),
    [anon_sym_while] = ACTIONS(2867),
    [anon_sym_if] = ACTIONS(2867),
    [anon_sym_fun] = ACTIONS(2867),
    [anon_sym_try] = ACTIONS(2867),
    [anon_sym_match] = ACTIONS(2867),
    [anon_sym_match_BANG] = ACTIONS(2869),
    [anon_sym_function] = ACTIONS(2867),
    [anon_sym_LT_DASH] = ACTIONS(2867),
    [anon_sym_DOT_LBRACK] = ACTIONS(2869),
    [anon_sym_LT] = ACTIONS(2869),
    [anon_sym_use] = ACTIONS(2867),
    [anon_sym_use_BANG] = ACTIONS(2869),
    [anon_sym_do_BANG] = ACTIONS(2869),
    [anon_sym_begin] = ACTIONS(2867),
    [anon_sym_LPAREN2] = ACTIONS(2867),
    [anon_sym_DOT_DOT2] = ACTIONS(2869),
    [anon_sym_default] = ACTIONS(2867),
    [anon_sym_or] = ACTIONS(2867),
    [anon_sym_static] = ACTIONS(2867),
    [anon_sym_member] = ACTIONS(2867),
    [anon_sym_abstract] = ACTIONS(2867),
    [anon_sym_val] = ACTIONS(2867),
    [anon_sym_override] = ACTIONS(2867),
    [aux_sym_char_token1] = ACTIONS(2869),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2867),
    [anon_sym_DQUOTE] = ACTIONS(2867),
    [anon_sym_AT_DQUOTE] = ACTIONS(2869),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2869),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2869),
    [sym_bool] = ACTIONS(2867),
    [sym_unit] = ACTIONS(2869),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2867),
    [sym_op_identifier] = ACTIONS(2867),
    [anon_sym_PLUS] = ACTIONS(2867),
    [anon_sym_DASH] = ACTIONS(2867),
    [anon_sym_PLUS_DOT] = ACTIONS(2867),
    [anon_sym_DASH_DOT] = ACTIONS(2867),
    [anon_sym_PERCENT] = ACTIONS(2867),
    [anon_sym_AMP_AMP] = ACTIONS(2867),
    [anon_sym_TILDE] = ACTIONS(2869),
    [aux_sym_prefix_op_token1] = ACTIONS(2867),
    [aux_sym_infix_op_token1] = ACTIONS(2869),
    [aux_sym_infix_op_token2] = ACTIONS(2867),
    [anon_sym_PIPE_PIPE] = ACTIONS(2867),
    [anon_sym_BANG_EQ] = ACTIONS(2867),
    [anon_sym_COLON_EQ] = ACTIONS(2869),
    [anon_sym_DOLLAR] = ACTIONS(2867),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2867),
    [sym_int] = ACTIONS(2867),
    [sym_xint] = ACTIONS(2869),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2869),
    [sym__newline] = ACTIONS(2869),
    [sym__dedent] = ACTIONS(2869),
  },
  [873] = {
    [sym_block_comment] = STATE(873),
    [sym_compiler_directive_decl] = STATE(873),
    [sym_fsi_directive_decl] = STATE(873),
    [sym_preproc_line] = STATE(873),
    [sym_identifier] = ACTIONS(2867),
    [anon_sym_EQ] = ACTIONS(2869),
    [anon_sym_LBRACK_LT] = ACTIONS(2869),
    [anon_sym_COLON] = ACTIONS(2867),
    [anon_sym_return] = ACTIONS(2867),
    [anon_sym_do] = ACTIONS(2867),
    [anon_sym_let] = ACTIONS(2867),
    [anon_sym_let_BANG] = ACTIONS(2869),
    [aux_sym_access_modifier_token1] = ACTIONS(2869),
    [anon_sym_LPAREN] = ACTIONS(2867),
    [anon_sym_COMMA] = ACTIONS(2869),
    [anon_sym_null] = ACTIONS(2867),
    [anon_sym_QMARK] = ACTIONS(2867),
    [anon_sym_COLON_QMARK] = ACTIONS(2867),
    [anon_sym_COLON_COLON] = ACTIONS(2869),
    [anon_sym_AMP] = ACTIONS(2867),
    [anon_sym_LBRACK] = ACTIONS(2867),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2869),
    [anon_sym_LBRACE] = ACTIONS(2867),
    [anon_sym_LT_AT] = ACTIONS(2867),
    [anon_sym_LT_AT_AT] = ACTIONS(2867),
    [anon_sym_DOT] = ACTIONS(2867),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2869),
    [anon_sym_new] = ACTIONS(2867),
    [anon_sym_with] = ACTIONS(2867),
    [anon_sym_return_BANG] = ACTIONS(2869),
    [anon_sym_yield] = ACTIONS(2867),
    [anon_sym_yield_BANG] = ACTIONS(2869),
    [anon_sym_lazy] = ACTIONS(2867),
    [anon_sym_assert] = ACTIONS(2867),
    [anon_sym_upcast] = ACTIONS(2867),
    [anon_sym_downcast] = ACTIONS(2867),
    [anon_sym_COLON_GT] = ACTIONS(2869),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2869),
    [anon_sym_for] = ACTIONS(2867),
    [anon_sym_while] = ACTIONS(2867),
    [anon_sym_if] = ACTIONS(2867),
    [anon_sym_fun] = ACTIONS(2867),
    [anon_sym_try] = ACTIONS(2867),
    [anon_sym_match] = ACTIONS(2867),
    [anon_sym_match_BANG] = ACTIONS(2869),
    [anon_sym_function] = ACTIONS(2867),
    [anon_sym_LT_DASH] = ACTIONS(2867),
    [anon_sym_DOT_LBRACK] = ACTIONS(2869),
    [anon_sym_LT] = ACTIONS(2869),
    [anon_sym_use] = ACTIONS(2867),
    [anon_sym_use_BANG] = ACTIONS(2869),
    [anon_sym_do_BANG] = ACTIONS(2869),
    [anon_sym_begin] = ACTIONS(2867),
    [anon_sym_LPAREN2] = ACTIONS(2867),
    [anon_sym_DOT_DOT2] = ACTIONS(2869),
    [anon_sym_default] = ACTIONS(2867),
    [anon_sym_or] = ACTIONS(2867),
    [anon_sym_static] = ACTIONS(2867),
    [anon_sym_member] = ACTIONS(2867),
    [anon_sym_abstract] = ACTIONS(2867),
    [anon_sym_val] = ACTIONS(2867),
    [anon_sym_override] = ACTIONS(2867),
    [aux_sym_char_token1] = ACTIONS(2869),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2867),
    [anon_sym_DQUOTE] = ACTIONS(2867),
    [anon_sym_AT_DQUOTE] = ACTIONS(2869),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2869),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2869),
    [sym_bool] = ACTIONS(2867),
    [sym_unit] = ACTIONS(2869),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2867),
    [sym_op_identifier] = ACTIONS(2867),
    [anon_sym_PLUS] = ACTIONS(2867),
    [anon_sym_DASH] = ACTIONS(2867),
    [anon_sym_PLUS_DOT] = ACTIONS(2867),
    [anon_sym_DASH_DOT] = ACTIONS(2867),
    [anon_sym_PERCENT] = ACTIONS(2867),
    [anon_sym_AMP_AMP] = ACTIONS(2867),
    [anon_sym_TILDE] = ACTIONS(2869),
    [aux_sym_prefix_op_token1] = ACTIONS(2867),
    [aux_sym_infix_op_token1] = ACTIONS(2869),
    [aux_sym_infix_op_token2] = ACTIONS(2867),
    [anon_sym_PIPE_PIPE] = ACTIONS(2867),
    [anon_sym_BANG_EQ] = ACTIONS(2867),
    [anon_sym_COLON_EQ] = ACTIONS(2869),
    [anon_sym_DOLLAR] = ACTIONS(2867),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2867),
    [sym_int] = ACTIONS(2867),
    [sym_xint] = ACTIONS(2869),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2869),
    [sym__newline] = ACTIONS(2869),
    [sym__dedent] = ACTIONS(2869),
  },
  [874] = {
    [sym_block_comment] = STATE(874),
    [sym_compiler_directive_decl] = STATE(874),
    [sym_fsi_directive_decl] = STATE(874),
    [sym_preproc_line] = STATE(874),
    [sym_identifier] = ACTIONS(2873),
    [anon_sym_EQ] = ACTIONS(2875),
    [anon_sym_LBRACK_LT] = ACTIONS(2875),
    [anon_sym_COLON] = ACTIONS(2873),
    [anon_sym_return] = ACTIONS(2873),
    [anon_sym_do] = ACTIONS(2873),
    [anon_sym_let] = ACTIONS(2873),
    [anon_sym_let_BANG] = ACTIONS(2875),
    [aux_sym_access_modifier_token1] = ACTIONS(2875),
    [anon_sym_LPAREN] = ACTIONS(2873),
    [anon_sym_COMMA] = ACTIONS(2875),
    [anon_sym_null] = ACTIONS(2873),
    [anon_sym_QMARK] = ACTIONS(2873),
    [anon_sym_COLON_QMARK] = ACTIONS(2873),
    [anon_sym_COLON_COLON] = ACTIONS(2875),
    [anon_sym_AMP] = ACTIONS(2873),
    [anon_sym_LBRACK] = ACTIONS(2873),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2875),
    [anon_sym_LBRACE] = ACTIONS(2873),
    [anon_sym_LT_AT] = ACTIONS(2873),
    [anon_sym_LT_AT_AT] = ACTIONS(2873),
    [anon_sym_DOT] = ACTIONS(2873),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2875),
    [anon_sym_new] = ACTIONS(2873),
    [anon_sym_with] = ACTIONS(2873),
    [anon_sym_return_BANG] = ACTIONS(2875),
    [anon_sym_yield] = ACTIONS(2873),
    [anon_sym_yield_BANG] = ACTIONS(2875),
    [anon_sym_lazy] = ACTIONS(2873),
    [anon_sym_assert] = ACTIONS(2873),
    [anon_sym_upcast] = ACTIONS(2873),
    [anon_sym_downcast] = ACTIONS(2873),
    [anon_sym_COLON_GT] = ACTIONS(2875),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2875),
    [anon_sym_for] = ACTIONS(2873),
    [anon_sym_while] = ACTIONS(2873),
    [anon_sym_if] = ACTIONS(2873),
    [anon_sym_fun] = ACTIONS(2873),
    [anon_sym_try] = ACTIONS(2873),
    [anon_sym_match] = ACTIONS(2873),
    [anon_sym_match_BANG] = ACTIONS(2875),
    [anon_sym_function] = ACTIONS(2873),
    [anon_sym_LT_DASH] = ACTIONS(2873),
    [anon_sym_DOT_LBRACK] = ACTIONS(2875),
    [anon_sym_LT] = ACTIONS(2875),
    [anon_sym_use] = ACTIONS(2873),
    [anon_sym_use_BANG] = ACTIONS(2875),
    [anon_sym_do_BANG] = ACTIONS(2875),
    [anon_sym_begin] = ACTIONS(2873),
    [anon_sym_LPAREN2] = ACTIONS(2873),
    [anon_sym_DOT_DOT2] = ACTIONS(2875),
    [anon_sym_default] = ACTIONS(2873),
    [anon_sym_or] = ACTIONS(2873),
    [anon_sym_static] = ACTIONS(2873),
    [anon_sym_member] = ACTIONS(2873),
    [anon_sym_abstract] = ACTIONS(2873),
    [anon_sym_val] = ACTIONS(2873),
    [anon_sym_override] = ACTIONS(2873),
    [aux_sym_char_token1] = ACTIONS(2875),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2873),
    [anon_sym_DQUOTE] = ACTIONS(2873),
    [anon_sym_AT_DQUOTE] = ACTIONS(2875),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2875),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2875),
    [sym_bool] = ACTIONS(2873),
    [sym_unit] = ACTIONS(2875),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2873),
    [sym_op_identifier] = ACTIONS(2873),
    [anon_sym_PLUS] = ACTIONS(2873),
    [anon_sym_DASH] = ACTIONS(2873),
    [anon_sym_PLUS_DOT] = ACTIONS(2873),
    [anon_sym_DASH_DOT] = ACTIONS(2873),
    [anon_sym_PERCENT] = ACTIONS(2873),
    [anon_sym_AMP_AMP] = ACTIONS(2873),
    [anon_sym_TILDE] = ACTIONS(2875),
    [aux_sym_prefix_op_token1] = ACTIONS(2873),
    [aux_sym_infix_op_token1] = ACTIONS(2875),
    [aux_sym_infix_op_token2] = ACTIONS(2873),
    [anon_sym_PIPE_PIPE] = ACTIONS(2873),
    [anon_sym_BANG_EQ] = ACTIONS(2873),
    [anon_sym_COLON_EQ] = ACTIONS(2875),
    [anon_sym_DOLLAR] = ACTIONS(2873),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2873),
    [sym_int] = ACTIONS(2873),
    [sym_xint] = ACTIONS(2875),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2875),
    [sym__newline] = ACTIONS(2875),
    [sym__dedent] = ACTIONS(2875),
  },
  [875] = {
    [sym_block_comment] = STATE(875),
    [sym_compiler_directive_decl] = STATE(875),
    [sym_fsi_directive_decl] = STATE(875),
    [sym_preproc_line] = STATE(875),
    [sym_identifier] = ACTIONS(2877),
    [anon_sym_EQ] = ACTIONS(2879),
    [anon_sym_LBRACK_LT] = ACTIONS(2879),
    [anon_sym_COLON] = ACTIONS(2877),
    [anon_sym_return] = ACTIONS(2877),
    [anon_sym_do] = ACTIONS(2877),
    [anon_sym_let] = ACTIONS(2877),
    [anon_sym_let_BANG] = ACTIONS(2879),
    [aux_sym_access_modifier_token1] = ACTIONS(2879),
    [anon_sym_LPAREN] = ACTIONS(2877),
    [anon_sym_COMMA] = ACTIONS(2879),
    [anon_sym_null] = ACTIONS(2877),
    [anon_sym_QMARK] = ACTIONS(2877),
    [anon_sym_COLON_QMARK] = ACTIONS(2877),
    [anon_sym_COLON_COLON] = ACTIONS(2879),
    [anon_sym_AMP] = ACTIONS(2877),
    [anon_sym_LBRACK] = ACTIONS(2877),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2879),
    [anon_sym_LBRACE] = ACTIONS(2877),
    [anon_sym_LT_AT] = ACTIONS(2877),
    [anon_sym_LT_AT_AT] = ACTIONS(2877),
    [anon_sym_DOT] = ACTIONS(2877),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2879),
    [anon_sym_new] = ACTIONS(2877),
    [anon_sym_with] = ACTIONS(2877),
    [anon_sym_return_BANG] = ACTIONS(2879),
    [anon_sym_yield] = ACTIONS(2877),
    [anon_sym_yield_BANG] = ACTIONS(2879),
    [anon_sym_lazy] = ACTIONS(2877),
    [anon_sym_assert] = ACTIONS(2877),
    [anon_sym_upcast] = ACTIONS(2877),
    [anon_sym_downcast] = ACTIONS(2877),
    [anon_sym_COLON_GT] = ACTIONS(2879),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2879),
    [anon_sym_for] = ACTIONS(2877),
    [anon_sym_while] = ACTIONS(2877),
    [anon_sym_if] = ACTIONS(2877),
    [anon_sym_fun] = ACTIONS(2877),
    [anon_sym_try] = ACTIONS(2877),
    [anon_sym_match] = ACTIONS(2877),
    [anon_sym_match_BANG] = ACTIONS(2879),
    [anon_sym_function] = ACTIONS(2877),
    [anon_sym_LT_DASH] = ACTIONS(2877),
    [anon_sym_DOT_LBRACK] = ACTIONS(2879),
    [anon_sym_LT] = ACTIONS(2879),
    [anon_sym_use] = ACTIONS(2877),
    [anon_sym_use_BANG] = ACTIONS(2879),
    [anon_sym_do_BANG] = ACTIONS(2879),
    [anon_sym_begin] = ACTIONS(2877),
    [anon_sym_LPAREN2] = ACTIONS(2877),
    [anon_sym_DOT_DOT2] = ACTIONS(2879),
    [anon_sym_default] = ACTIONS(2877),
    [anon_sym_or] = ACTIONS(2877),
    [anon_sym_static] = ACTIONS(2877),
    [anon_sym_member] = ACTIONS(2877),
    [anon_sym_abstract] = ACTIONS(2877),
    [anon_sym_val] = ACTIONS(2877),
    [anon_sym_override] = ACTIONS(2877),
    [aux_sym_char_token1] = ACTIONS(2879),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2877),
    [anon_sym_DQUOTE] = ACTIONS(2877),
    [anon_sym_AT_DQUOTE] = ACTIONS(2879),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2879),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2879),
    [sym_bool] = ACTIONS(2877),
    [sym_unit] = ACTIONS(2879),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2877),
    [sym_op_identifier] = ACTIONS(2877),
    [anon_sym_PLUS] = ACTIONS(2877),
    [anon_sym_DASH] = ACTIONS(2877),
    [anon_sym_PLUS_DOT] = ACTIONS(2877),
    [anon_sym_DASH_DOT] = ACTIONS(2877),
    [anon_sym_PERCENT] = ACTIONS(2877),
    [anon_sym_AMP_AMP] = ACTIONS(2877),
    [anon_sym_TILDE] = ACTIONS(2879),
    [aux_sym_prefix_op_token1] = ACTIONS(2877),
    [aux_sym_infix_op_token1] = ACTIONS(2879),
    [aux_sym_infix_op_token2] = ACTIONS(2877),
    [anon_sym_PIPE_PIPE] = ACTIONS(2877),
    [anon_sym_BANG_EQ] = ACTIONS(2877),
    [anon_sym_COLON_EQ] = ACTIONS(2879),
    [anon_sym_DOLLAR] = ACTIONS(2877),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2877),
    [sym_int] = ACTIONS(2877),
    [sym_xint] = ACTIONS(2879),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2879),
    [sym__newline] = ACTIONS(2879),
    [sym__dedent] = ACTIONS(2879),
  },
  [876] = {
    [sym_block_comment] = STATE(876),
    [sym_compiler_directive_decl] = STATE(876),
    [sym_fsi_directive_decl] = STATE(876),
    [sym_preproc_line] = STATE(876),
    [sym_identifier] = ACTIONS(2881),
    [anon_sym_EQ] = ACTIONS(2789),
    [anon_sym_LBRACK_LT] = ACTIONS(2789),
    [anon_sym_COLON] = ACTIONS(2881),
    [anon_sym_return] = ACTIONS(2881),
    [anon_sym_do] = ACTIONS(2881),
    [anon_sym_let] = ACTIONS(2881),
    [anon_sym_let_BANG] = ACTIONS(2789),
    [aux_sym_access_modifier_token1] = ACTIONS(2789),
    [anon_sym_LPAREN] = ACTIONS(2881),
    [anon_sym_COMMA] = ACTIONS(2789),
    [anon_sym_null] = ACTIONS(2881),
    [anon_sym_QMARK] = ACTIONS(2881),
    [anon_sym_COLON_QMARK] = ACTIONS(2881),
    [anon_sym_COLON_COLON] = ACTIONS(2789),
    [anon_sym_AMP] = ACTIONS(2881),
    [anon_sym_LBRACK] = ACTIONS(2881),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2789),
    [anon_sym_LBRACE] = ACTIONS(2881),
    [anon_sym_LT_AT] = ACTIONS(2881),
    [anon_sym_LT_AT_AT] = ACTIONS(2881),
    [anon_sym_DOT] = ACTIONS(2881),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2789),
    [anon_sym_new] = ACTIONS(2881),
    [anon_sym_with] = ACTIONS(2881),
    [anon_sym_return_BANG] = ACTIONS(2789),
    [anon_sym_yield] = ACTIONS(2881),
    [anon_sym_yield_BANG] = ACTIONS(2789),
    [anon_sym_lazy] = ACTIONS(2881),
    [anon_sym_assert] = ACTIONS(2881),
    [anon_sym_upcast] = ACTIONS(2881),
    [anon_sym_downcast] = ACTIONS(2881),
    [anon_sym_COLON_GT] = ACTIONS(2789),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2789),
    [anon_sym_for] = ACTIONS(2881),
    [anon_sym_while] = ACTIONS(2881),
    [anon_sym_if] = ACTIONS(2881),
    [anon_sym_fun] = ACTIONS(2881),
    [anon_sym_try] = ACTIONS(2881),
    [anon_sym_match] = ACTIONS(2881),
    [anon_sym_match_BANG] = ACTIONS(2789),
    [anon_sym_function] = ACTIONS(2881),
    [anon_sym_LT_DASH] = ACTIONS(2881),
    [anon_sym_DOT_LBRACK] = ACTIONS(2789),
    [anon_sym_LT] = ACTIONS(2789),
    [anon_sym_use] = ACTIONS(2881),
    [anon_sym_use_BANG] = ACTIONS(2789),
    [anon_sym_do_BANG] = ACTIONS(2789),
    [anon_sym_begin] = ACTIONS(2881),
    [anon_sym_LPAREN2] = ACTIONS(2881),
    [anon_sym_DOT_DOT2] = ACTIONS(2789),
    [anon_sym_default] = ACTIONS(2881),
    [anon_sym_or] = ACTIONS(2881),
    [anon_sym_static] = ACTIONS(2881),
    [anon_sym_member] = ACTIONS(2881),
    [anon_sym_abstract] = ACTIONS(2881),
    [anon_sym_val] = ACTIONS(2881),
    [anon_sym_override] = ACTIONS(2881),
    [aux_sym_char_token1] = ACTIONS(2789),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2881),
    [anon_sym_DQUOTE] = ACTIONS(2881),
    [anon_sym_AT_DQUOTE] = ACTIONS(2789),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2789),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2789),
    [sym_bool] = ACTIONS(2881),
    [sym_unit] = ACTIONS(2789),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2881),
    [sym_op_identifier] = ACTIONS(2881),
    [anon_sym_PLUS] = ACTIONS(2881),
    [anon_sym_DASH] = ACTIONS(2881),
    [anon_sym_PLUS_DOT] = ACTIONS(2881),
    [anon_sym_DASH_DOT] = ACTIONS(2881),
    [anon_sym_PERCENT] = ACTIONS(2881),
    [anon_sym_AMP_AMP] = ACTIONS(2881),
    [anon_sym_TILDE] = ACTIONS(2789),
    [aux_sym_prefix_op_token1] = ACTIONS(2881),
    [aux_sym_infix_op_token1] = ACTIONS(2789),
    [aux_sym_infix_op_token2] = ACTIONS(2881),
    [anon_sym_PIPE_PIPE] = ACTIONS(2881),
    [anon_sym_BANG_EQ] = ACTIONS(2881),
    [anon_sym_COLON_EQ] = ACTIONS(2789),
    [anon_sym_DOLLAR] = ACTIONS(2881),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2881),
    [sym_int] = ACTIONS(2881),
    [sym_xint] = ACTIONS(2789),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2789),
    [sym__newline] = ACTIONS(2789),
    [sym__dedent] = ACTIONS(2789),
  },
  [877] = {
    [sym_block_comment] = STATE(877),
    [sym_compiler_directive_decl] = STATE(877),
    [sym_fsi_directive_decl] = STATE(877),
    [sym_preproc_line] = STATE(877),
    [sym_identifier] = ACTIONS(2883),
    [anon_sym_EQ] = ACTIONS(2885),
    [anon_sym_LBRACK_LT] = ACTIONS(2885),
    [anon_sym_COLON] = ACTIONS(2883),
    [anon_sym_return] = ACTIONS(2883),
    [anon_sym_do] = ACTIONS(2883),
    [anon_sym_let] = ACTIONS(2883),
    [anon_sym_let_BANG] = ACTIONS(2885),
    [aux_sym_access_modifier_token1] = ACTIONS(2885),
    [anon_sym_LPAREN] = ACTIONS(2883),
    [anon_sym_COMMA] = ACTIONS(2885),
    [anon_sym_null] = ACTIONS(2883),
    [anon_sym_QMARK] = ACTIONS(2883),
    [anon_sym_COLON_QMARK] = ACTIONS(2883),
    [anon_sym_COLON_COLON] = ACTIONS(2885),
    [anon_sym_AMP] = ACTIONS(2883),
    [anon_sym_LBRACK] = ACTIONS(2883),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2885),
    [anon_sym_LBRACE] = ACTIONS(2883),
    [anon_sym_LT_AT] = ACTIONS(2883),
    [anon_sym_LT_AT_AT] = ACTIONS(2883),
    [anon_sym_DOT] = ACTIONS(2883),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2885),
    [anon_sym_new] = ACTIONS(2883),
    [anon_sym_with] = ACTIONS(2883),
    [anon_sym_return_BANG] = ACTIONS(2885),
    [anon_sym_yield] = ACTIONS(2883),
    [anon_sym_yield_BANG] = ACTIONS(2885),
    [anon_sym_lazy] = ACTIONS(2883),
    [anon_sym_assert] = ACTIONS(2883),
    [anon_sym_upcast] = ACTIONS(2883),
    [anon_sym_downcast] = ACTIONS(2883),
    [anon_sym_COLON_GT] = ACTIONS(2885),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2885),
    [anon_sym_for] = ACTIONS(2883),
    [anon_sym_while] = ACTIONS(2883),
    [anon_sym_if] = ACTIONS(2883),
    [anon_sym_fun] = ACTIONS(2883),
    [anon_sym_try] = ACTIONS(2883),
    [anon_sym_match] = ACTIONS(2883),
    [anon_sym_match_BANG] = ACTIONS(2885),
    [anon_sym_function] = ACTIONS(2883),
    [anon_sym_LT_DASH] = ACTIONS(2883),
    [anon_sym_DOT_LBRACK] = ACTIONS(2885),
    [anon_sym_LT] = ACTIONS(2885),
    [anon_sym_use] = ACTIONS(2883),
    [anon_sym_use_BANG] = ACTIONS(2885),
    [anon_sym_do_BANG] = ACTIONS(2885),
    [anon_sym_begin] = ACTIONS(2883),
    [anon_sym_LPAREN2] = ACTIONS(2883),
    [anon_sym_DOT_DOT2] = ACTIONS(2885),
    [anon_sym_default] = ACTIONS(2883),
    [anon_sym_or] = ACTIONS(2883),
    [anon_sym_static] = ACTIONS(2883),
    [anon_sym_member] = ACTIONS(2883),
    [anon_sym_abstract] = ACTIONS(2883),
    [anon_sym_val] = ACTIONS(2883),
    [anon_sym_override] = ACTIONS(2883),
    [aux_sym_char_token1] = ACTIONS(2885),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2883),
    [anon_sym_DQUOTE] = ACTIONS(2883),
    [anon_sym_AT_DQUOTE] = ACTIONS(2885),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2885),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2885),
    [sym_bool] = ACTIONS(2883),
    [sym_unit] = ACTIONS(2885),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2883),
    [sym_op_identifier] = ACTIONS(2883),
    [anon_sym_PLUS] = ACTIONS(2883),
    [anon_sym_DASH] = ACTIONS(2883),
    [anon_sym_PLUS_DOT] = ACTIONS(2883),
    [anon_sym_DASH_DOT] = ACTIONS(2883),
    [anon_sym_PERCENT] = ACTIONS(2883),
    [anon_sym_AMP_AMP] = ACTIONS(2883),
    [anon_sym_TILDE] = ACTIONS(2885),
    [aux_sym_prefix_op_token1] = ACTIONS(2883),
    [aux_sym_infix_op_token1] = ACTIONS(2885),
    [aux_sym_infix_op_token2] = ACTIONS(2883),
    [anon_sym_PIPE_PIPE] = ACTIONS(2883),
    [anon_sym_BANG_EQ] = ACTIONS(2883),
    [anon_sym_COLON_EQ] = ACTIONS(2885),
    [anon_sym_DOLLAR] = ACTIONS(2883),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2883),
    [sym_int] = ACTIONS(2883),
    [sym_xint] = ACTIONS(2885),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2885),
    [sym__newline] = ACTIONS(2885),
    [sym__dedent] = ACTIONS(2885),
  },
  [878] = {
    [sym_block_comment] = STATE(878),
    [sym_compiler_directive_decl] = STATE(878),
    [sym_fsi_directive_decl] = STATE(878),
    [sym_preproc_line] = STATE(878),
    [sym_identifier] = ACTIONS(2887),
    [anon_sym_EQ] = ACTIONS(2889),
    [anon_sym_LBRACK_LT] = ACTIONS(2889),
    [anon_sym_COLON] = ACTIONS(2887),
    [anon_sym_return] = ACTIONS(2887),
    [anon_sym_do] = ACTIONS(2887),
    [anon_sym_let] = ACTIONS(2887),
    [anon_sym_let_BANG] = ACTIONS(2889),
    [aux_sym_access_modifier_token1] = ACTIONS(2889),
    [anon_sym_LPAREN] = ACTIONS(2887),
    [anon_sym_COMMA] = ACTIONS(2889),
    [anon_sym_null] = ACTIONS(2887),
    [anon_sym_QMARK] = ACTIONS(2887),
    [anon_sym_COLON_QMARK] = ACTIONS(2887),
    [anon_sym_COLON_COLON] = ACTIONS(2889),
    [anon_sym_AMP] = ACTIONS(2887),
    [anon_sym_LBRACK] = ACTIONS(2887),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2889),
    [anon_sym_LBRACE] = ACTIONS(2887),
    [anon_sym_LT_AT] = ACTIONS(2887),
    [anon_sym_LT_AT_AT] = ACTIONS(2887),
    [anon_sym_DOT] = ACTIONS(2887),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2889),
    [anon_sym_new] = ACTIONS(2887),
    [anon_sym_with] = ACTIONS(2887),
    [anon_sym_return_BANG] = ACTIONS(2889),
    [anon_sym_yield] = ACTIONS(2887),
    [anon_sym_yield_BANG] = ACTIONS(2889),
    [anon_sym_lazy] = ACTIONS(2887),
    [anon_sym_assert] = ACTIONS(2887),
    [anon_sym_upcast] = ACTIONS(2887),
    [anon_sym_downcast] = ACTIONS(2887),
    [anon_sym_COLON_GT] = ACTIONS(2889),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2889),
    [anon_sym_for] = ACTIONS(2887),
    [anon_sym_while] = ACTIONS(2887),
    [anon_sym_if] = ACTIONS(2887),
    [anon_sym_fun] = ACTIONS(2887),
    [anon_sym_try] = ACTIONS(2887),
    [anon_sym_match] = ACTIONS(2887),
    [anon_sym_match_BANG] = ACTIONS(2889),
    [anon_sym_function] = ACTIONS(2887),
    [anon_sym_LT_DASH] = ACTIONS(2887),
    [anon_sym_DOT_LBRACK] = ACTIONS(2889),
    [anon_sym_LT] = ACTIONS(2889),
    [anon_sym_use] = ACTIONS(2887),
    [anon_sym_use_BANG] = ACTIONS(2889),
    [anon_sym_do_BANG] = ACTIONS(2889),
    [anon_sym_begin] = ACTIONS(2887),
    [anon_sym_LPAREN2] = ACTIONS(2887),
    [anon_sym_DOT_DOT2] = ACTIONS(2889),
    [anon_sym_default] = ACTIONS(2887),
    [anon_sym_or] = ACTIONS(2887),
    [anon_sym_static] = ACTIONS(2887),
    [anon_sym_member] = ACTIONS(2887),
    [anon_sym_abstract] = ACTIONS(2887),
    [anon_sym_val] = ACTIONS(2887),
    [anon_sym_override] = ACTIONS(2887),
    [aux_sym_char_token1] = ACTIONS(2889),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2887),
    [anon_sym_DQUOTE] = ACTIONS(2887),
    [anon_sym_AT_DQUOTE] = ACTIONS(2889),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2889),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2889),
    [sym_bool] = ACTIONS(2887),
    [sym_unit] = ACTIONS(2889),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2887),
    [sym_op_identifier] = ACTIONS(2887),
    [anon_sym_PLUS] = ACTIONS(2887),
    [anon_sym_DASH] = ACTIONS(2887),
    [anon_sym_PLUS_DOT] = ACTIONS(2887),
    [anon_sym_DASH_DOT] = ACTIONS(2887),
    [anon_sym_PERCENT] = ACTIONS(2887),
    [anon_sym_AMP_AMP] = ACTIONS(2887),
    [anon_sym_TILDE] = ACTIONS(2889),
    [aux_sym_prefix_op_token1] = ACTIONS(2887),
    [aux_sym_infix_op_token1] = ACTIONS(2889),
    [aux_sym_infix_op_token2] = ACTIONS(2887),
    [anon_sym_PIPE_PIPE] = ACTIONS(2887),
    [anon_sym_BANG_EQ] = ACTIONS(2887),
    [anon_sym_COLON_EQ] = ACTIONS(2889),
    [anon_sym_DOLLAR] = ACTIONS(2887),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2887),
    [sym_int] = ACTIONS(2887),
    [sym_xint] = ACTIONS(2889),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2889),
    [sym__newline] = ACTIONS(2889),
    [sym__dedent] = ACTIONS(2889),
  },
  [879] = {
    [sym_block_comment] = STATE(879),
    [sym_compiler_directive_decl] = STATE(879),
    [sym_fsi_directive_decl] = STATE(879),
    [sym_preproc_line] = STATE(879),
    [sym_identifier] = ACTIONS(2891),
    [anon_sym_EQ] = ACTIONS(2893),
    [anon_sym_LBRACK_LT] = ACTIONS(2893),
    [anon_sym_COLON] = ACTIONS(2891),
    [anon_sym_return] = ACTIONS(2891),
    [anon_sym_do] = ACTIONS(2891),
    [anon_sym_let] = ACTIONS(2891),
    [anon_sym_let_BANG] = ACTIONS(2893),
    [aux_sym_access_modifier_token1] = ACTIONS(2893),
    [anon_sym_LPAREN] = ACTIONS(2891),
    [anon_sym_COMMA] = ACTIONS(2893),
    [anon_sym_null] = ACTIONS(2891),
    [anon_sym_QMARK] = ACTIONS(2891),
    [anon_sym_COLON_QMARK] = ACTIONS(2891),
    [anon_sym_COLON_COLON] = ACTIONS(2893),
    [anon_sym_AMP] = ACTIONS(2891),
    [anon_sym_LBRACK] = ACTIONS(2891),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2893),
    [anon_sym_LBRACE] = ACTIONS(2891),
    [anon_sym_LT_AT] = ACTIONS(2891),
    [anon_sym_LT_AT_AT] = ACTIONS(2891),
    [anon_sym_DOT] = ACTIONS(2891),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2893),
    [anon_sym_new] = ACTIONS(2891),
    [anon_sym_with] = ACTIONS(2891),
    [anon_sym_return_BANG] = ACTIONS(2893),
    [anon_sym_yield] = ACTIONS(2891),
    [anon_sym_yield_BANG] = ACTIONS(2893),
    [anon_sym_lazy] = ACTIONS(2891),
    [anon_sym_assert] = ACTIONS(2891),
    [anon_sym_upcast] = ACTIONS(2891),
    [anon_sym_downcast] = ACTIONS(2891),
    [anon_sym_COLON_GT] = ACTIONS(2893),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2893),
    [anon_sym_for] = ACTIONS(2891),
    [anon_sym_while] = ACTIONS(2891),
    [anon_sym_if] = ACTIONS(2891),
    [anon_sym_fun] = ACTIONS(2891),
    [anon_sym_try] = ACTIONS(2891),
    [anon_sym_match] = ACTIONS(2891),
    [anon_sym_match_BANG] = ACTIONS(2893),
    [anon_sym_function] = ACTIONS(2891),
    [anon_sym_LT_DASH] = ACTIONS(2891),
    [anon_sym_DOT_LBRACK] = ACTIONS(2893),
    [anon_sym_LT] = ACTIONS(2893),
    [anon_sym_use] = ACTIONS(2891),
    [anon_sym_use_BANG] = ACTIONS(2893),
    [anon_sym_do_BANG] = ACTIONS(2893),
    [anon_sym_begin] = ACTIONS(2891),
    [anon_sym_LPAREN2] = ACTIONS(2891),
    [anon_sym_DOT_DOT2] = ACTIONS(2893),
    [anon_sym_default] = ACTIONS(2891),
    [anon_sym_or] = ACTIONS(2891),
    [anon_sym_static] = ACTIONS(2891),
    [anon_sym_member] = ACTIONS(2891),
    [anon_sym_abstract] = ACTIONS(2891),
    [anon_sym_val] = ACTIONS(2891),
    [anon_sym_override] = ACTIONS(2891),
    [aux_sym_char_token1] = ACTIONS(2893),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2891),
    [anon_sym_DQUOTE] = ACTIONS(2891),
    [anon_sym_AT_DQUOTE] = ACTIONS(2893),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2893),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2893),
    [sym_bool] = ACTIONS(2891),
    [sym_unit] = ACTIONS(2893),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2891),
    [sym_op_identifier] = ACTIONS(2891),
    [anon_sym_PLUS] = ACTIONS(2891),
    [anon_sym_DASH] = ACTIONS(2891),
    [anon_sym_PLUS_DOT] = ACTIONS(2891),
    [anon_sym_DASH_DOT] = ACTIONS(2891),
    [anon_sym_PERCENT] = ACTIONS(2891),
    [anon_sym_AMP_AMP] = ACTIONS(2891),
    [anon_sym_TILDE] = ACTIONS(2893),
    [aux_sym_prefix_op_token1] = ACTIONS(2891),
    [aux_sym_infix_op_token1] = ACTIONS(2893),
    [aux_sym_infix_op_token2] = ACTIONS(2891),
    [anon_sym_PIPE_PIPE] = ACTIONS(2891),
    [anon_sym_BANG_EQ] = ACTIONS(2891),
    [anon_sym_COLON_EQ] = ACTIONS(2893),
    [anon_sym_DOLLAR] = ACTIONS(2891),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2891),
    [sym_int] = ACTIONS(2891),
    [sym_xint] = ACTIONS(2893),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2893),
    [sym__newline] = ACTIONS(2893),
    [sym__dedent] = ACTIONS(2893),
  },
  [880] = {
    [sym_block_comment] = STATE(880),
    [sym_compiler_directive_decl] = STATE(880),
    [sym_fsi_directive_decl] = STATE(880),
    [sym_preproc_line] = STATE(880),
    [aux_sym_sequential_expression_repeat1] = STATE(880),
    [sym_identifier] = ACTIONS(2895),
    [anon_sym_EQ] = ACTIONS(2897),
    [anon_sym_LBRACK_LT] = ACTIONS(2897),
    [anon_sym_COLON] = ACTIONS(2895),
    [anon_sym_return] = ACTIONS(2895),
    [anon_sym_do] = ACTIONS(2895),
    [anon_sym_let] = ACTIONS(2895),
    [anon_sym_let_BANG] = ACTIONS(2897),
    [aux_sym_access_modifier_token1] = ACTIONS(2897),
    [anon_sym_LPAREN] = ACTIONS(2895),
    [anon_sym_COMMA] = ACTIONS(2897),
    [anon_sym_null] = ACTIONS(2895),
    [anon_sym_QMARK] = ACTIONS(2895),
    [anon_sym_COLON_QMARK] = ACTIONS(2895),
    [anon_sym_COLON_COLON] = ACTIONS(2897),
    [anon_sym_AMP] = ACTIONS(2895),
    [anon_sym_LBRACK] = ACTIONS(2895),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2897),
    [anon_sym_LBRACE] = ACTIONS(2895),
    [anon_sym_LT_AT] = ACTIONS(2895),
    [anon_sym_LT_AT_AT] = ACTIONS(2895),
    [anon_sym_DOT] = ACTIONS(2895),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2897),
    [anon_sym_new] = ACTIONS(2895),
    [anon_sym_with] = ACTIONS(2895),
    [anon_sym_return_BANG] = ACTIONS(2897),
    [anon_sym_yield] = ACTIONS(2895),
    [anon_sym_yield_BANG] = ACTIONS(2897),
    [anon_sym_lazy] = ACTIONS(2895),
    [anon_sym_assert] = ACTIONS(2895),
    [anon_sym_upcast] = ACTIONS(2895),
    [anon_sym_downcast] = ACTIONS(2895),
    [anon_sym_COLON_GT] = ACTIONS(2897),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2897),
    [anon_sym_for] = ACTIONS(2895),
    [anon_sym_while] = ACTIONS(2895),
    [anon_sym_if] = ACTIONS(2895),
    [anon_sym_fun] = ACTIONS(2895),
    [anon_sym_try] = ACTIONS(2895),
    [anon_sym_match] = ACTIONS(2895),
    [anon_sym_match_BANG] = ACTIONS(2897),
    [anon_sym_function] = ACTIONS(2895),
    [anon_sym_LT_DASH] = ACTIONS(2895),
    [anon_sym_DOT_LBRACK] = ACTIONS(2897),
    [anon_sym_LT] = ACTIONS(2897),
    [anon_sym_use] = ACTIONS(2895),
    [anon_sym_use_BANG] = ACTIONS(2897),
    [anon_sym_do_BANG] = ACTIONS(2897),
    [anon_sym_begin] = ACTIONS(2895),
    [anon_sym_LPAREN2] = ACTIONS(2895),
    [anon_sym_default] = ACTIONS(2895),
    [anon_sym_or] = ACTIONS(2895),
    [anon_sym_static] = ACTIONS(2895),
    [anon_sym_member] = ACTIONS(2895),
    [anon_sym_abstract] = ACTIONS(2895),
    [anon_sym_val] = ACTIONS(2895),
    [anon_sym_override] = ACTIONS(2895),
    [aux_sym_char_token1] = ACTIONS(2897),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2895),
    [anon_sym_DQUOTE] = ACTIONS(2895),
    [anon_sym_AT_DQUOTE] = ACTIONS(2897),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2897),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2897),
    [sym_bool] = ACTIONS(2895),
    [sym_unit] = ACTIONS(2897),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2895),
    [sym_op_identifier] = ACTIONS(2895),
    [anon_sym_PLUS] = ACTIONS(2895),
    [anon_sym_DASH] = ACTIONS(2895),
    [anon_sym_PLUS_DOT] = ACTIONS(2895),
    [anon_sym_DASH_DOT] = ACTIONS(2895),
    [anon_sym_PERCENT] = ACTIONS(2895),
    [anon_sym_AMP_AMP] = ACTIONS(2895),
    [anon_sym_TILDE] = ACTIONS(2897),
    [aux_sym_prefix_op_token1] = ACTIONS(2895),
    [aux_sym_infix_op_token1] = ACTIONS(2897),
    [aux_sym_infix_op_token2] = ACTIONS(2895),
    [anon_sym_PIPE_PIPE] = ACTIONS(2895),
    [anon_sym_BANG_EQ] = ACTIONS(2895),
    [anon_sym_COLON_EQ] = ACTIONS(2897),
    [anon_sym_DOLLAR] = ACTIONS(2895),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2895),
    [sym_int] = ACTIONS(2895),
    [sym_xint] = ACTIONS(2897),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2897),
    [sym__newline] = ACTIONS(2899),
    [sym__dedent] = ACTIONS(2897),
  },
  [881] = {
    [sym_block_comment] = STATE(881),
    [sym_compiler_directive_decl] = STATE(881),
    [sym_fsi_directive_decl] = STATE(881),
    [sym_preproc_line] = STATE(881),
    [sym_identifier] = ACTIONS(2902),
    [anon_sym_EQ] = ACTIONS(2904),
    [anon_sym_LBRACK_LT] = ACTIONS(2904),
    [anon_sym_COLON] = ACTIONS(2902),
    [anon_sym_return] = ACTIONS(2902),
    [anon_sym_do] = ACTIONS(2902),
    [anon_sym_let] = ACTIONS(2902),
    [anon_sym_let_BANG] = ACTIONS(2904),
    [aux_sym_access_modifier_token1] = ACTIONS(2904),
    [anon_sym_LPAREN] = ACTIONS(2902),
    [anon_sym_COMMA] = ACTIONS(2904),
    [anon_sym_null] = ACTIONS(2902),
    [anon_sym_QMARK] = ACTIONS(2902),
    [anon_sym_COLON_QMARK] = ACTIONS(2902),
    [anon_sym_COLON_COLON] = ACTIONS(2904),
    [anon_sym_AMP] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2902),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2902),
    [anon_sym_LT_AT] = ACTIONS(2902),
    [anon_sym_LT_AT_AT] = ACTIONS(2902),
    [anon_sym_DOT] = ACTIONS(2902),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2904),
    [anon_sym_new] = ACTIONS(2902),
    [anon_sym_with] = ACTIONS(2902),
    [anon_sym_return_BANG] = ACTIONS(2904),
    [anon_sym_yield] = ACTIONS(2902),
    [anon_sym_yield_BANG] = ACTIONS(2904),
    [anon_sym_lazy] = ACTIONS(2902),
    [anon_sym_assert] = ACTIONS(2902),
    [anon_sym_upcast] = ACTIONS(2902),
    [anon_sym_downcast] = ACTIONS(2902),
    [anon_sym_COLON_GT] = ACTIONS(2904),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2904),
    [anon_sym_for] = ACTIONS(2902),
    [anon_sym_while] = ACTIONS(2902),
    [anon_sym_if] = ACTIONS(2902),
    [anon_sym_fun] = ACTIONS(2902),
    [anon_sym_try] = ACTIONS(2902),
    [anon_sym_match] = ACTIONS(2902),
    [anon_sym_match_BANG] = ACTIONS(2904),
    [anon_sym_function] = ACTIONS(2902),
    [anon_sym_LT_DASH] = ACTIONS(2902),
    [anon_sym_DOT_LBRACK] = ACTIONS(2904),
    [anon_sym_LT] = ACTIONS(2904),
    [anon_sym_use] = ACTIONS(2902),
    [anon_sym_use_BANG] = ACTIONS(2904),
    [anon_sym_do_BANG] = ACTIONS(2904),
    [anon_sym_begin] = ACTIONS(2902),
    [anon_sym_LPAREN2] = ACTIONS(2902),
    [anon_sym_DOT_DOT2] = ACTIONS(2904),
    [anon_sym_default] = ACTIONS(2902),
    [anon_sym_or] = ACTIONS(2902),
    [anon_sym_static] = ACTIONS(2902),
    [anon_sym_member] = ACTIONS(2902),
    [anon_sym_abstract] = ACTIONS(2902),
    [anon_sym_val] = ACTIONS(2902),
    [anon_sym_override] = ACTIONS(2902),
    [aux_sym_char_token1] = ACTIONS(2904),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2902),
    [anon_sym_DQUOTE] = ACTIONS(2902),
    [anon_sym_AT_DQUOTE] = ACTIONS(2904),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2904),
    [sym_bool] = ACTIONS(2902),
    [sym_unit] = ACTIONS(2904),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2902),
    [sym_op_identifier] = ACTIONS(2902),
    [anon_sym_PLUS] = ACTIONS(2902),
    [anon_sym_DASH] = ACTIONS(2902),
    [anon_sym_PLUS_DOT] = ACTIONS(2902),
    [anon_sym_DASH_DOT] = ACTIONS(2902),
    [anon_sym_PERCENT] = ACTIONS(2902),
    [anon_sym_AMP_AMP] = ACTIONS(2902),
    [anon_sym_TILDE] = ACTIONS(2904),
    [aux_sym_prefix_op_token1] = ACTIONS(2902),
    [aux_sym_infix_op_token1] = ACTIONS(2904),
    [aux_sym_infix_op_token2] = ACTIONS(2902),
    [anon_sym_PIPE_PIPE] = ACTIONS(2902),
    [anon_sym_BANG_EQ] = ACTIONS(2902),
    [anon_sym_COLON_EQ] = ACTIONS(2904),
    [anon_sym_DOLLAR] = ACTIONS(2902),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2902),
    [sym_int] = ACTIONS(2902),
    [sym_xint] = ACTIONS(2904),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2904),
    [sym__newline] = ACTIONS(2904),
    [sym__dedent] = ACTIONS(2904),
  },
  [882] = {
    [sym_block_comment] = STATE(882),
    [sym_compiler_directive_decl] = STATE(882),
    [sym_fsi_directive_decl] = STATE(882),
    [sym_preproc_line] = STATE(882),
    [sym_identifier] = ACTIONS(2906),
    [anon_sym_EQ] = ACTIONS(2908),
    [anon_sym_LBRACK_LT] = ACTIONS(2908),
    [anon_sym_COLON] = ACTIONS(2906),
    [anon_sym_return] = ACTIONS(2906),
    [anon_sym_do] = ACTIONS(2906),
    [anon_sym_let] = ACTIONS(2906),
    [anon_sym_let_BANG] = ACTIONS(2908),
    [aux_sym_access_modifier_token1] = ACTIONS(2908),
    [anon_sym_LPAREN] = ACTIONS(2906),
    [anon_sym_COMMA] = ACTIONS(2908),
    [anon_sym_null] = ACTIONS(2906),
    [anon_sym_QMARK] = ACTIONS(2906),
    [anon_sym_COLON_QMARK] = ACTIONS(2906),
    [anon_sym_COLON_COLON] = ACTIONS(2908),
    [anon_sym_AMP] = ACTIONS(2906),
    [anon_sym_LBRACK] = ACTIONS(2906),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2908),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_LT_AT] = ACTIONS(2906),
    [anon_sym_LT_AT_AT] = ACTIONS(2906),
    [anon_sym_DOT] = ACTIONS(2906),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2908),
    [anon_sym_new] = ACTIONS(2906),
    [anon_sym_with] = ACTIONS(2906),
    [anon_sym_return_BANG] = ACTIONS(2908),
    [anon_sym_yield] = ACTIONS(2906),
    [anon_sym_yield_BANG] = ACTIONS(2908),
    [anon_sym_lazy] = ACTIONS(2906),
    [anon_sym_assert] = ACTIONS(2906),
    [anon_sym_upcast] = ACTIONS(2906),
    [anon_sym_downcast] = ACTIONS(2906),
    [anon_sym_COLON_GT] = ACTIONS(2908),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2908),
    [anon_sym_for] = ACTIONS(2906),
    [anon_sym_while] = ACTIONS(2906),
    [anon_sym_if] = ACTIONS(2906),
    [anon_sym_fun] = ACTIONS(2906),
    [anon_sym_try] = ACTIONS(2906),
    [anon_sym_match] = ACTIONS(2906),
    [anon_sym_match_BANG] = ACTIONS(2908),
    [anon_sym_function] = ACTIONS(2906),
    [anon_sym_LT_DASH] = ACTIONS(2906),
    [anon_sym_DOT_LBRACK] = ACTIONS(2908),
    [anon_sym_LT] = ACTIONS(2908),
    [anon_sym_use] = ACTIONS(2906),
    [anon_sym_use_BANG] = ACTIONS(2908),
    [anon_sym_do_BANG] = ACTIONS(2908),
    [anon_sym_begin] = ACTIONS(2906),
    [anon_sym_LPAREN2] = ACTIONS(2906),
    [anon_sym_DOT_DOT2] = ACTIONS(2908),
    [anon_sym_default] = ACTIONS(2906),
    [anon_sym_or] = ACTIONS(2906),
    [anon_sym_static] = ACTIONS(2906),
    [anon_sym_member] = ACTIONS(2906),
    [anon_sym_abstract] = ACTIONS(2906),
    [anon_sym_val] = ACTIONS(2906),
    [anon_sym_override] = ACTIONS(2906),
    [aux_sym_char_token1] = ACTIONS(2908),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2906),
    [anon_sym_DQUOTE] = ACTIONS(2906),
    [anon_sym_AT_DQUOTE] = ACTIONS(2908),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2908),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2908),
    [sym_bool] = ACTIONS(2906),
    [sym_unit] = ACTIONS(2908),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2906),
    [sym_op_identifier] = ACTIONS(2906),
    [anon_sym_PLUS] = ACTIONS(2906),
    [anon_sym_DASH] = ACTIONS(2906),
    [anon_sym_PLUS_DOT] = ACTIONS(2906),
    [anon_sym_DASH_DOT] = ACTIONS(2906),
    [anon_sym_PERCENT] = ACTIONS(2906),
    [anon_sym_AMP_AMP] = ACTIONS(2906),
    [anon_sym_TILDE] = ACTIONS(2908),
    [aux_sym_prefix_op_token1] = ACTIONS(2906),
    [aux_sym_infix_op_token1] = ACTIONS(2908),
    [aux_sym_infix_op_token2] = ACTIONS(2906),
    [anon_sym_PIPE_PIPE] = ACTIONS(2906),
    [anon_sym_BANG_EQ] = ACTIONS(2906),
    [anon_sym_COLON_EQ] = ACTIONS(2908),
    [anon_sym_DOLLAR] = ACTIONS(2906),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2906),
    [sym_int] = ACTIONS(2906),
    [sym_xint] = ACTIONS(2908),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2908),
    [sym__newline] = ACTIONS(2908),
    [sym__dedent] = ACTIONS(2908),
  },
  [883] = {
    [sym_block_comment] = STATE(883),
    [sym_compiler_directive_decl] = STATE(883),
    [sym_fsi_directive_decl] = STATE(883),
    [sym_preproc_line] = STATE(883),
    [sym_identifier] = ACTIONS(2910),
    [anon_sym_EQ] = ACTIONS(2912),
    [anon_sym_LBRACK_LT] = ACTIONS(2912),
    [anon_sym_COLON] = ACTIONS(2910),
    [anon_sym_return] = ACTIONS(2910),
    [anon_sym_do] = ACTIONS(2910),
    [anon_sym_let] = ACTIONS(2910),
    [anon_sym_let_BANG] = ACTIONS(2912),
    [aux_sym_access_modifier_token1] = ACTIONS(2912),
    [anon_sym_LPAREN] = ACTIONS(2910),
    [anon_sym_COMMA] = ACTIONS(2912),
    [anon_sym_null] = ACTIONS(2910),
    [anon_sym_QMARK] = ACTIONS(2910),
    [anon_sym_COLON_QMARK] = ACTIONS(2910),
    [anon_sym_COLON_COLON] = ACTIONS(2912),
    [anon_sym_AMP] = ACTIONS(2910),
    [anon_sym_LBRACK] = ACTIONS(2910),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2912),
    [anon_sym_LBRACE] = ACTIONS(2910),
    [anon_sym_LT_AT] = ACTIONS(2910),
    [anon_sym_LT_AT_AT] = ACTIONS(2910),
    [anon_sym_DOT] = ACTIONS(2910),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2912),
    [anon_sym_new] = ACTIONS(2910),
    [anon_sym_with] = ACTIONS(2910),
    [anon_sym_return_BANG] = ACTIONS(2912),
    [anon_sym_yield] = ACTIONS(2910),
    [anon_sym_yield_BANG] = ACTIONS(2912),
    [anon_sym_lazy] = ACTIONS(2910),
    [anon_sym_assert] = ACTIONS(2910),
    [anon_sym_upcast] = ACTIONS(2910),
    [anon_sym_downcast] = ACTIONS(2910),
    [anon_sym_COLON_GT] = ACTIONS(2912),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2912),
    [anon_sym_for] = ACTIONS(2910),
    [anon_sym_while] = ACTIONS(2910),
    [anon_sym_if] = ACTIONS(2910),
    [anon_sym_fun] = ACTIONS(2910),
    [anon_sym_try] = ACTIONS(2910),
    [anon_sym_match] = ACTIONS(2910),
    [anon_sym_match_BANG] = ACTIONS(2912),
    [anon_sym_function] = ACTIONS(2910),
    [anon_sym_LT_DASH] = ACTIONS(2910),
    [anon_sym_DOT_LBRACK] = ACTIONS(2912),
    [anon_sym_LT] = ACTIONS(2912),
    [anon_sym_use] = ACTIONS(2910),
    [anon_sym_use_BANG] = ACTIONS(2912),
    [anon_sym_do_BANG] = ACTIONS(2912),
    [anon_sym_begin] = ACTIONS(2910),
    [anon_sym_LPAREN2] = ACTIONS(2910),
    [anon_sym_DOT_DOT2] = ACTIONS(2912),
    [anon_sym_default] = ACTIONS(2910),
    [anon_sym_or] = ACTIONS(2910),
    [anon_sym_static] = ACTIONS(2910),
    [anon_sym_member] = ACTIONS(2910),
    [anon_sym_abstract] = ACTIONS(2910),
    [anon_sym_val] = ACTIONS(2910),
    [anon_sym_override] = ACTIONS(2910),
    [aux_sym_char_token1] = ACTIONS(2912),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2910),
    [anon_sym_DQUOTE] = ACTIONS(2910),
    [anon_sym_AT_DQUOTE] = ACTIONS(2912),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2912),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2912),
    [sym_bool] = ACTIONS(2910),
    [sym_unit] = ACTIONS(2912),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2910),
    [sym_op_identifier] = ACTIONS(2910),
    [anon_sym_PLUS] = ACTIONS(2910),
    [anon_sym_DASH] = ACTIONS(2910),
    [anon_sym_PLUS_DOT] = ACTIONS(2910),
    [anon_sym_DASH_DOT] = ACTIONS(2910),
    [anon_sym_PERCENT] = ACTIONS(2910),
    [anon_sym_AMP_AMP] = ACTIONS(2910),
    [anon_sym_TILDE] = ACTIONS(2912),
    [aux_sym_prefix_op_token1] = ACTIONS(2910),
    [aux_sym_infix_op_token1] = ACTIONS(2912),
    [aux_sym_infix_op_token2] = ACTIONS(2910),
    [anon_sym_PIPE_PIPE] = ACTIONS(2910),
    [anon_sym_BANG_EQ] = ACTIONS(2910),
    [anon_sym_COLON_EQ] = ACTIONS(2912),
    [anon_sym_DOLLAR] = ACTIONS(2910),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2910),
    [sym_int] = ACTIONS(2910),
    [sym_xint] = ACTIONS(2912),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2912),
    [sym__newline] = ACTIONS(2912),
    [sym__dedent] = ACTIONS(2912),
  },
  [884] = {
    [sym_block_comment] = STATE(884),
    [sym_compiler_directive_decl] = STATE(884),
    [sym_fsi_directive_decl] = STATE(884),
    [sym_preproc_line] = STATE(884),
    [sym_identifier] = ACTIONS(2914),
    [anon_sym_EQ] = ACTIONS(2916),
    [anon_sym_LBRACK_LT] = ACTIONS(2916),
    [anon_sym_COLON] = ACTIONS(2914),
    [anon_sym_return] = ACTIONS(2914),
    [anon_sym_do] = ACTIONS(2914),
    [anon_sym_let] = ACTIONS(2914),
    [anon_sym_let_BANG] = ACTIONS(2916),
    [aux_sym_access_modifier_token1] = ACTIONS(2916),
    [anon_sym_LPAREN] = ACTIONS(2914),
    [anon_sym_COMMA] = ACTIONS(2916),
    [anon_sym_null] = ACTIONS(2914),
    [anon_sym_QMARK] = ACTIONS(2914),
    [anon_sym_COLON_QMARK] = ACTIONS(2914),
    [anon_sym_COLON_COLON] = ACTIONS(2916),
    [anon_sym_AMP] = ACTIONS(2914),
    [anon_sym_LBRACK] = ACTIONS(2914),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2916),
    [anon_sym_LBRACE] = ACTIONS(2914),
    [anon_sym_LT_AT] = ACTIONS(2914),
    [anon_sym_LT_AT_AT] = ACTIONS(2914),
    [anon_sym_DOT] = ACTIONS(2914),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2916),
    [anon_sym_new] = ACTIONS(2914),
    [anon_sym_with] = ACTIONS(2914),
    [anon_sym_return_BANG] = ACTIONS(2916),
    [anon_sym_yield] = ACTIONS(2914),
    [anon_sym_yield_BANG] = ACTIONS(2916),
    [anon_sym_lazy] = ACTIONS(2914),
    [anon_sym_assert] = ACTIONS(2914),
    [anon_sym_upcast] = ACTIONS(2914),
    [anon_sym_downcast] = ACTIONS(2914),
    [anon_sym_COLON_GT] = ACTIONS(2916),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2916),
    [anon_sym_for] = ACTIONS(2914),
    [anon_sym_while] = ACTIONS(2914),
    [anon_sym_if] = ACTIONS(2914),
    [anon_sym_fun] = ACTIONS(2914),
    [anon_sym_try] = ACTIONS(2914),
    [anon_sym_match] = ACTIONS(2914),
    [anon_sym_match_BANG] = ACTIONS(2916),
    [anon_sym_function] = ACTIONS(2914),
    [anon_sym_LT_DASH] = ACTIONS(2914),
    [anon_sym_DOT_LBRACK] = ACTIONS(2916),
    [anon_sym_LT] = ACTIONS(2916),
    [anon_sym_use] = ACTIONS(2914),
    [anon_sym_use_BANG] = ACTIONS(2916),
    [anon_sym_do_BANG] = ACTIONS(2916),
    [anon_sym_begin] = ACTIONS(2914),
    [anon_sym_LPAREN2] = ACTIONS(2914),
    [anon_sym_DOT_DOT2] = ACTIONS(2916),
    [anon_sym_default] = ACTIONS(2914),
    [anon_sym_or] = ACTIONS(2914),
    [anon_sym_static] = ACTIONS(2914),
    [anon_sym_member] = ACTIONS(2914),
    [anon_sym_abstract] = ACTIONS(2914),
    [anon_sym_val] = ACTIONS(2914),
    [anon_sym_override] = ACTIONS(2914),
    [aux_sym_char_token1] = ACTIONS(2916),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2914),
    [anon_sym_DQUOTE] = ACTIONS(2914),
    [anon_sym_AT_DQUOTE] = ACTIONS(2916),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2916),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2916),
    [sym_bool] = ACTIONS(2914),
    [sym_unit] = ACTIONS(2916),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2914),
    [sym_op_identifier] = ACTIONS(2914),
    [anon_sym_PLUS] = ACTIONS(2914),
    [anon_sym_DASH] = ACTIONS(2914),
    [anon_sym_PLUS_DOT] = ACTIONS(2914),
    [anon_sym_DASH_DOT] = ACTIONS(2914),
    [anon_sym_PERCENT] = ACTIONS(2914),
    [anon_sym_AMP_AMP] = ACTIONS(2914),
    [anon_sym_TILDE] = ACTIONS(2916),
    [aux_sym_prefix_op_token1] = ACTIONS(2914),
    [aux_sym_infix_op_token1] = ACTIONS(2916),
    [aux_sym_infix_op_token2] = ACTIONS(2914),
    [anon_sym_PIPE_PIPE] = ACTIONS(2914),
    [anon_sym_BANG_EQ] = ACTIONS(2914),
    [anon_sym_COLON_EQ] = ACTIONS(2916),
    [anon_sym_DOLLAR] = ACTIONS(2914),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2914),
    [sym_int] = ACTIONS(2914),
    [sym_xint] = ACTIONS(2916),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2916),
    [sym__newline] = ACTIONS(2916),
    [sym__dedent] = ACTIONS(2916),
  },
  [885] = {
    [sym_block_comment] = STATE(885),
    [sym_compiler_directive_decl] = STATE(885),
    [sym_fsi_directive_decl] = STATE(885),
    [sym_preproc_line] = STATE(885),
    [sym_identifier] = ACTIONS(2918),
    [anon_sym_EQ] = ACTIONS(2920),
    [anon_sym_LBRACK_LT] = ACTIONS(2920),
    [anon_sym_COLON] = ACTIONS(2918),
    [anon_sym_return] = ACTIONS(2918),
    [anon_sym_do] = ACTIONS(2918),
    [anon_sym_let] = ACTIONS(2918),
    [anon_sym_let_BANG] = ACTIONS(2920),
    [aux_sym_access_modifier_token1] = ACTIONS(2920),
    [anon_sym_LPAREN] = ACTIONS(2918),
    [anon_sym_COMMA] = ACTIONS(2920),
    [anon_sym_null] = ACTIONS(2918),
    [anon_sym_QMARK] = ACTIONS(2918),
    [anon_sym_COLON_QMARK] = ACTIONS(2918),
    [anon_sym_COLON_COLON] = ACTIONS(2920),
    [anon_sym_AMP] = ACTIONS(2918),
    [anon_sym_LBRACK] = ACTIONS(2918),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2920),
    [anon_sym_LBRACE] = ACTIONS(2918),
    [anon_sym_LT_AT] = ACTIONS(2918),
    [anon_sym_LT_AT_AT] = ACTIONS(2918),
    [anon_sym_DOT] = ACTIONS(2918),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2920),
    [anon_sym_new] = ACTIONS(2918),
    [anon_sym_with] = ACTIONS(2918),
    [anon_sym_return_BANG] = ACTIONS(2920),
    [anon_sym_yield] = ACTIONS(2918),
    [anon_sym_yield_BANG] = ACTIONS(2920),
    [anon_sym_lazy] = ACTIONS(2918),
    [anon_sym_assert] = ACTIONS(2918),
    [anon_sym_upcast] = ACTIONS(2918),
    [anon_sym_downcast] = ACTIONS(2918),
    [anon_sym_COLON_GT] = ACTIONS(2920),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2920),
    [anon_sym_for] = ACTIONS(2918),
    [anon_sym_while] = ACTIONS(2918),
    [anon_sym_if] = ACTIONS(2918),
    [anon_sym_fun] = ACTIONS(2918),
    [anon_sym_try] = ACTIONS(2918),
    [anon_sym_match] = ACTIONS(2918),
    [anon_sym_match_BANG] = ACTIONS(2920),
    [anon_sym_function] = ACTIONS(2918),
    [anon_sym_LT_DASH] = ACTIONS(2918),
    [anon_sym_DOT_LBRACK] = ACTIONS(2920),
    [anon_sym_LT] = ACTIONS(2920),
    [anon_sym_use] = ACTIONS(2918),
    [anon_sym_use_BANG] = ACTIONS(2920),
    [anon_sym_do_BANG] = ACTIONS(2920),
    [anon_sym_begin] = ACTIONS(2918),
    [anon_sym_LPAREN2] = ACTIONS(2918),
    [anon_sym_DOT_DOT2] = ACTIONS(2920),
    [anon_sym_default] = ACTIONS(2918),
    [anon_sym_or] = ACTIONS(2918),
    [anon_sym_static] = ACTIONS(2918),
    [anon_sym_member] = ACTIONS(2918),
    [anon_sym_abstract] = ACTIONS(2918),
    [anon_sym_val] = ACTIONS(2918),
    [anon_sym_override] = ACTIONS(2918),
    [aux_sym_char_token1] = ACTIONS(2920),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2918),
    [anon_sym_DQUOTE] = ACTIONS(2918),
    [anon_sym_AT_DQUOTE] = ACTIONS(2920),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2920),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2920),
    [sym_bool] = ACTIONS(2918),
    [sym_unit] = ACTIONS(2920),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2918),
    [sym_op_identifier] = ACTIONS(2918),
    [anon_sym_PLUS] = ACTIONS(2918),
    [anon_sym_DASH] = ACTIONS(2918),
    [anon_sym_PLUS_DOT] = ACTIONS(2918),
    [anon_sym_DASH_DOT] = ACTIONS(2918),
    [anon_sym_PERCENT] = ACTIONS(2918),
    [anon_sym_AMP_AMP] = ACTIONS(2918),
    [anon_sym_TILDE] = ACTIONS(2920),
    [aux_sym_prefix_op_token1] = ACTIONS(2918),
    [aux_sym_infix_op_token1] = ACTIONS(2920),
    [aux_sym_infix_op_token2] = ACTIONS(2918),
    [anon_sym_PIPE_PIPE] = ACTIONS(2918),
    [anon_sym_BANG_EQ] = ACTIONS(2918),
    [anon_sym_COLON_EQ] = ACTIONS(2920),
    [anon_sym_DOLLAR] = ACTIONS(2918),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2918),
    [sym_int] = ACTIONS(2918),
    [sym_xint] = ACTIONS(2920),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2920),
    [sym__newline] = ACTIONS(2920),
    [sym__dedent] = ACTIONS(2920),
  },
  [886] = {
    [sym_block_comment] = STATE(886),
    [sym_compiler_directive_decl] = STATE(886),
    [sym_fsi_directive_decl] = STATE(886),
    [sym_preproc_line] = STATE(886),
    [sym_identifier] = ACTIONS(2922),
    [anon_sym_EQ] = ACTIONS(2924),
    [anon_sym_LBRACK_LT] = ACTIONS(2924),
    [anon_sym_COLON] = ACTIONS(2922),
    [anon_sym_return] = ACTIONS(2922),
    [anon_sym_do] = ACTIONS(2922),
    [anon_sym_let] = ACTIONS(2922),
    [anon_sym_let_BANG] = ACTIONS(2924),
    [aux_sym_access_modifier_token1] = ACTIONS(2924),
    [anon_sym_LPAREN] = ACTIONS(2922),
    [anon_sym_COMMA] = ACTIONS(2924),
    [anon_sym_null] = ACTIONS(2922),
    [anon_sym_QMARK] = ACTIONS(2922),
    [anon_sym_COLON_QMARK] = ACTIONS(2922),
    [anon_sym_COLON_COLON] = ACTIONS(2924),
    [anon_sym_AMP] = ACTIONS(2922),
    [anon_sym_LBRACK] = ACTIONS(2922),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2924),
    [anon_sym_LBRACE] = ACTIONS(2922),
    [anon_sym_LT_AT] = ACTIONS(2922),
    [anon_sym_LT_AT_AT] = ACTIONS(2922),
    [anon_sym_DOT] = ACTIONS(2922),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2924),
    [anon_sym_new] = ACTIONS(2922),
    [anon_sym_with] = ACTIONS(2922),
    [anon_sym_return_BANG] = ACTIONS(2924),
    [anon_sym_yield] = ACTIONS(2922),
    [anon_sym_yield_BANG] = ACTIONS(2924),
    [anon_sym_lazy] = ACTIONS(2922),
    [anon_sym_assert] = ACTIONS(2922),
    [anon_sym_upcast] = ACTIONS(2922),
    [anon_sym_downcast] = ACTIONS(2922),
    [anon_sym_COLON_GT] = ACTIONS(2924),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2924),
    [anon_sym_for] = ACTIONS(2922),
    [anon_sym_while] = ACTIONS(2922),
    [anon_sym_if] = ACTIONS(2922),
    [anon_sym_fun] = ACTIONS(2922),
    [anon_sym_try] = ACTIONS(2922),
    [anon_sym_match] = ACTIONS(2922),
    [anon_sym_match_BANG] = ACTIONS(2924),
    [anon_sym_function] = ACTIONS(2922),
    [anon_sym_LT_DASH] = ACTIONS(2922),
    [anon_sym_DOT_LBRACK] = ACTIONS(2924),
    [anon_sym_LT] = ACTIONS(2924),
    [anon_sym_use] = ACTIONS(2922),
    [anon_sym_use_BANG] = ACTIONS(2924),
    [anon_sym_do_BANG] = ACTIONS(2924),
    [anon_sym_begin] = ACTIONS(2922),
    [anon_sym_LPAREN2] = ACTIONS(2922),
    [anon_sym_DOT_DOT2] = ACTIONS(2924),
    [anon_sym_default] = ACTIONS(2922),
    [anon_sym_or] = ACTIONS(2922),
    [anon_sym_static] = ACTIONS(2922),
    [anon_sym_member] = ACTIONS(2922),
    [anon_sym_abstract] = ACTIONS(2922),
    [anon_sym_val] = ACTIONS(2922),
    [anon_sym_override] = ACTIONS(2922),
    [aux_sym_char_token1] = ACTIONS(2924),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2922),
    [anon_sym_DQUOTE] = ACTIONS(2922),
    [anon_sym_AT_DQUOTE] = ACTIONS(2924),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2924),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2924),
    [sym_bool] = ACTIONS(2922),
    [sym_unit] = ACTIONS(2924),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2922),
    [sym_op_identifier] = ACTIONS(2922),
    [anon_sym_PLUS] = ACTIONS(2922),
    [anon_sym_DASH] = ACTIONS(2922),
    [anon_sym_PLUS_DOT] = ACTIONS(2922),
    [anon_sym_DASH_DOT] = ACTIONS(2922),
    [anon_sym_PERCENT] = ACTIONS(2922),
    [anon_sym_AMP_AMP] = ACTIONS(2922),
    [anon_sym_TILDE] = ACTIONS(2924),
    [aux_sym_prefix_op_token1] = ACTIONS(2922),
    [aux_sym_infix_op_token1] = ACTIONS(2924),
    [aux_sym_infix_op_token2] = ACTIONS(2922),
    [anon_sym_PIPE_PIPE] = ACTIONS(2922),
    [anon_sym_BANG_EQ] = ACTIONS(2922),
    [anon_sym_COLON_EQ] = ACTIONS(2924),
    [anon_sym_DOLLAR] = ACTIONS(2922),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2922),
    [sym_int] = ACTIONS(2922),
    [sym_xint] = ACTIONS(2924),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2924),
    [sym__newline] = ACTIONS(2924),
    [sym__dedent] = ACTIONS(2924),
  },
  [887] = {
    [sym_block_comment] = STATE(887),
    [sym_compiler_directive_decl] = STATE(887),
    [sym_fsi_directive_decl] = STATE(887),
    [sym_preproc_line] = STATE(887),
    [sym_identifier] = ACTIONS(2926),
    [anon_sym_EQ] = ACTIONS(2928),
    [anon_sym_LBRACK_LT] = ACTIONS(2928),
    [anon_sym_COLON] = ACTIONS(2926),
    [anon_sym_return] = ACTIONS(2926),
    [anon_sym_do] = ACTIONS(2926),
    [anon_sym_let] = ACTIONS(2926),
    [anon_sym_let_BANG] = ACTIONS(2928),
    [aux_sym_access_modifier_token1] = ACTIONS(2928),
    [anon_sym_LPAREN] = ACTIONS(2926),
    [anon_sym_COMMA] = ACTIONS(2928),
    [anon_sym_null] = ACTIONS(2926),
    [anon_sym_QMARK] = ACTIONS(2926),
    [anon_sym_COLON_QMARK] = ACTIONS(2926),
    [anon_sym_COLON_COLON] = ACTIONS(2928),
    [anon_sym_AMP] = ACTIONS(2926),
    [anon_sym_LBRACK] = ACTIONS(2926),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2928),
    [anon_sym_LBRACE] = ACTIONS(2926),
    [anon_sym_LT_AT] = ACTIONS(2926),
    [anon_sym_LT_AT_AT] = ACTIONS(2926),
    [anon_sym_DOT] = ACTIONS(2926),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2928),
    [anon_sym_new] = ACTIONS(2926),
    [anon_sym_with] = ACTIONS(2926),
    [anon_sym_return_BANG] = ACTIONS(2928),
    [anon_sym_yield] = ACTIONS(2926),
    [anon_sym_yield_BANG] = ACTIONS(2928),
    [anon_sym_lazy] = ACTIONS(2926),
    [anon_sym_assert] = ACTIONS(2926),
    [anon_sym_upcast] = ACTIONS(2926),
    [anon_sym_downcast] = ACTIONS(2926),
    [anon_sym_COLON_GT] = ACTIONS(2928),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2928),
    [anon_sym_for] = ACTIONS(2926),
    [anon_sym_while] = ACTIONS(2926),
    [anon_sym_if] = ACTIONS(2926),
    [anon_sym_fun] = ACTIONS(2926),
    [anon_sym_try] = ACTIONS(2926),
    [anon_sym_match] = ACTIONS(2926),
    [anon_sym_match_BANG] = ACTIONS(2928),
    [anon_sym_function] = ACTIONS(2926),
    [anon_sym_LT_DASH] = ACTIONS(2926),
    [anon_sym_DOT_LBRACK] = ACTIONS(2928),
    [anon_sym_LT] = ACTIONS(2928),
    [anon_sym_use] = ACTIONS(2926),
    [anon_sym_use_BANG] = ACTIONS(2928),
    [anon_sym_do_BANG] = ACTIONS(2928),
    [anon_sym_begin] = ACTIONS(2926),
    [anon_sym_LPAREN2] = ACTIONS(2926),
    [anon_sym_DOT_DOT2] = ACTIONS(2928),
    [anon_sym_default] = ACTIONS(2926),
    [anon_sym_or] = ACTIONS(2926),
    [anon_sym_static] = ACTIONS(2926),
    [anon_sym_member] = ACTIONS(2926),
    [anon_sym_abstract] = ACTIONS(2926),
    [anon_sym_val] = ACTIONS(2926),
    [anon_sym_override] = ACTIONS(2926),
    [aux_sym_char_token1] = ACTIONS(2928),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2926),
    [anon_sym_DQUOTE] = ACTIONS(2926),
    [anon_sym_AT_DQUOTE] = ACTIONS(2928),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2928),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2928),
    [sym_bool] = ACTIONS(2926),
    [sym_unit] = ACTIONS(2928),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2926),
    [sym_op_identifier] = ACTIONS(2926),
    [anon_sym_PLUS] = ACTIONS(2926),
    [anon_sym_DASH] = ACTIONS(2926),
    [anon_sym_PLUS_DOT] = ACTIONS(2926),
    [anon_sym_DASH_DOT] = ACTIONS(2926),
    [anon_sym_PERCENT] = ACTIONS(2926),
    [anon_sym_AMP_AMP] = ACTIONS(2926),
    [anon_sym_TILDE] = ACTIONS(2928),
    [aux_sym_prefix_op_token1] = ACTIONS(2926),
    [aux_sym_infix_op_token1] = ACTIONS(2928),
    [aux_sym_infix_op_token2] = ACTIONS(2926),
    [anon_sym_PIPE_PIPE] = ACTIONS(2926),
    [anon_sym_BANG_EQ] = ACTIONS(2926),
    [anon_sym_COLON_EQ] = ACTIONS(2928),
    [anon_sym_DOLLAR] = ACTIONS(2926),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2926),
    [sym_int] = ACTIONS(2926),
    [sym_xint] = ACTIONS(2928),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2928),
    [sym__newline] = ACTIONS(2928),
    [sym__dedent] = ACTIONS(2928),
  },
  [888] = {
    [sym_block_comment] = STATE(888),
    [sym_compiler_directive_decl] = STATE(888),
    [sym_fsi_directive_decl] = STATE(888),
    [sym_preproc_line] = STATE(888),
    [sym_identifier] = ACTIONS(2930),
    [anon_sym_EQ] = ACTIONS(2932),
    [anon_sym_LBRACK_LT] = ACTIONS(2932),
    [anon_sym_COLON] = ACTIONS(2930),
    [anon_sym_return] = ACTIONS(2930),
    [anon_sym_do] = ACTIONS(2930),
    [anon_sym_let] = ACTIONS(2930),
    [anon_sym_let_BANG] = ACTIONS(2932),
    [aux_sym_access_modifier_token1] = ACTIONS(2932),
    [anon_sym_LPAREN] = ACTIONS(2930),
    [anon_sym_COMMA] = ACTIONS(2932),
    [anon_sym_null] = ACTIONS(2930),
    [anon_sym_QMARK] = ACTIONS(2930),
    [anon_sym_COLON_QMARK] = ACTIONS(2930),
    [anon_sym_COLON_COLON] = ACTIONS(2932),
    [anon_sym_AMP] = ACTIONS(2930),
    [anon_sym_LBRACK] = ACTIONS(2930),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2932),
    [anon_sym_LBRACE] = ACTIONS(2930),
    [anon_sym_LT_AT] = ACTIONS(2930),
    [anon_sym_LT_AT_AT] = ACTIONS(2930),
    [anon_sym_DOT] = ACTIONS(2930),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2932),
    [anon_sym_new] = ACTIONS(2930),
    [anon_sym_with] = ACTIONS(2930),
    [anon_sym_return_BANG] = ACTIONS(2932),
    [anon_sym_yield] = ACTIONS(2930),
    [anon_sym_yield_BANG] = ACTIONS(2932),
    [anon_sym_lazy] = ACTIONS(2930),
    [anon_sym_assert] = ACTIONS(2930),
    [anon_sym_upcast] = ACTIONS(2930),
    [anon_sym_downcast] = ACTIONS(2930),
    [anon_sym_COLON_GT] = ACTIONS(2932),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2932),
    [anon_sym_for] = ACTIONS(2930),
    [anon_sym_while] = ACTIONS(2930),
    [anon_sym_if] = ACTIONS(2930),
    [anon_sym_fun] = ACTIONS(2930),
    [anon_sym_try] = ACTIONS(2930),
    [anon_sym_match] = ACTIONS(2930),
    [anon_sym_match_BANG] = ACTIONS(2932),
    [anon_sym_function] = ACTIONS(2930),
    [anon_sym_LT_DASH] = ACTIONS(2930),
    [anon_sym_DOT_LBRACK] = ACTIONS(2932),
    [anon_sym_LT] = ACTIONS(2932),
    [anon_sym_use] = ACTIONS(2930),
    [anon_sym_use_BANG] = ACTIONS(2932),
    [anon_sym_do_BANG] = ACTIONS(2932),
    [anon_sym_begin] = ACTIONS(2930),
    [anon_sym_LPAREN2] = ACTIONS(2930),
    [anon_sym_DOT_DOT2] = ACTIONS(2932),
    [anon_sym_default] = ACTIONS(2930),
    [anon_sym_or] = ACTIONS(2930),
    [anon_sym_static] = ACTIONS(2930),
    [anon_sym_member] = ACTIONS(2930),
    [anon_sym_abstract] = ACTIONS(2930),
    [anon_sym_val] = ACTIONS(2930),
    [anon_sym_override] = ACTIONS(2930),
    [aux_sym_char_token1] = ACTIONS(2932),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2930),
    [anon_sym_DQUOTE] = ACTIONS(2930),
    [anon_sym_AT_DQUOTE] = ACTIONS(2932),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2932),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2932),
    [sym_bool] = ACTIONS(2930),
    [sym_unit] = ACTIONS(2932),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2930),
    [sym_op_identifier] = ACTIONS(2930),
    [anon_sym_PLUS] = ACTIONS(2930),
    [anon_sym_DASH] = ACTIONS(2930),
    [anon_sym_PLUS_DOT] = ACTIONS(2930),
    [anon_sym_DASH_DOT] = ACTIONS(2930),
    [anon_sym_PERCENT] = ACTIONS(2930),
    [anon_sym_AMP_AMP] = ACTIONS(2930),
    [anon_sym_TILDE] = ACTIONS(2932),
    [aux_sym_prefix_op_token1] = ACTIONS(2930),
    [aux_sym_infix_op_token1] = ACTIONS(2932),
    [aux_sym_infix_op_token2] = ACTIONS(2930),
    [anon_sym_PIPE_PIPE] = ACTIONS(2930),
    [anon_sym_BANG_EQ] = ACTIONS(2930),
    [anon_sym_COLON_EQ] = ACTIONS(2932),
    [anon_sym_DOLLAR] = ACTIONS(2930),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2930),
    [sym_int] = ACTIONS(2930),
    [sym_xint] = ACTIONS(2932),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2932),
    [sym__newline] = ACTIONS(2932),
    [sym__dedent] = ACTIONS(2932),
  },
  [889] = {
    [sym_block_comment] = STATE(889),
    [sym_compiler_directive_decl] = STATE(889),
    [sym_fsi_directive_decl] = STATE(889),
    [sym_preproc_line] = STATE(889),
    [sym_identifier] = ACTIONS(2934),
    [anon_sym_EQ] = ACTIONS(2936),
    [anon_sym_LBRACK_LT] = ACTIONS(2936),
    [anon_sym_COLON] = ACTIONS(2934),
    [anon_sym_return] = ACTIONS(2934),
    [anon_sym_do] = ACTIONS(2934),
    [anon_sym_let] = ACTIONS(2934),
    [anon_sym_let_BANG] = ACTIONS(2936),
    [aux_sym_access_modifier_token1] = ACTIONS(2936),
    [anon_sym_LPAREN] = ACTIONS(2934),
    [anon_sym_COMMA] = ACTIONS(2936),
    [anon_sym_null] = ACTIONS(2934),
    [anon_sym_QMARK] = ACTIONS(2934),
    [anon_sym_COLON_QMARK] = ACTIONS(2934),
    [anon_sym_COLON_COLON] = ACTIONS(2936),
    [anon_sym_AMP] = ACTIONS(2934),
    [anon_sym_LBRACK] = ACTIONS(2934),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2936),
    [anon_sym_LBRACE] = ACTIONS(2934),
    [anon_sym_LT_AT] = ACTIONS(2934),
    [anon_sym_LT_AT_AT] = ACTIONS(2934),
    [anon_sym_DOT] = ACTIONS(2934),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2936),
    [anon_sym_new] = ACTIONS(2934),
    [anon_sym_with] = ACTIONS(2934),
    [anon_sym_return_BANG] = ACTIONS(2936),
    [anon_sym_yield] = ACTIONS(2934),
    [anon_sym_yield_BANG] = ACTIONS(2936),
    [anon_sym_lazy] = ACTIONS(2934),
    [anon_sym_assert] = ACTIONS(2934),
    [anon_sym_upcast] = ACTIONS(2934),
    [anon_sym_downcast] = ACTIONS(2934),
    [anon_sym_COLON_GT] = ACTIONS(2936),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2936),
    [anon_sym_for] = ACTIONS(2934),
    [anon_sym_while] = ACTIONS(2934),
    [anon_sym_if] = ACTIONS(2934),
    [anon_sym_fun] = ACTIONS(2934),
    [anon_sym_try] = ACTIONS(2934),
    [anon_sym_match] = ACTIONS(2934),
    [anon_sym_match_BANG] = ACTIONS(2936),
    [anon_sym_function] = ACTIONS(2934),
    [anon_sym_LT_DASH] = ACTIONS(2934),
    [anon_sym_DOT_LBRACK] = ACTIONS(2936),
    [anon_sym_LT] = ACTIONS(2936),
    [anon_sym_use] = ACTIONS(2934),
    [anon_sym_use_BANG] = ACTIONS(2936),
    [anon_sym_do_BANG] = ACTIONS(2936),
    [anon_sym_begin] = ACTIONS(2934),
    [anon_sym_LPAREN2] = ACTIONS(2934),
    [anon_sym_DOT_DOT2] = ACTIONS(2936),
    [anon_sym_default] = ACTIONS(2934),
    [anon_sym_or] = ACTIONS(2934),
    [anon_sym_static] = ACTIONS(2934),
    [anon_sym_member] = ACTIONS(2934),
    [anon_sym_abstract] = ACTIONS(2934),
    [anon_sym_val] = ACTIONS(2934),
    [anon_sym_override] = ACTIONS(2934),
    [aux_sym_char_token1] = ACTIONS(2936),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2934),
    [anon_sym_DQUOTE] = ACTIONS(2934),
    [anon_sym_AT_DQUOTE] = ACTIONS(2936),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2936),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2936),
    [sym_bool] = ACTIONS(2934),
    [sym_unit] = ACTIONS(2936),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2934),
    [sym_op_identifier] = ACTIONS(2934),
    [anon_sym_PLUS] = ACTIONS(2934),
    [anon_sym_DASH] = ACTIONS(2934),
    [anon_sym_PLUS_DOT] = ACTIONS(2934),
    [anon_sym_DASH_DOT] = ACTIONS(2934),
    [anon_sym_PERCENT] = ACTIONS(2934),
    [anon_sym_AMP_AMP] = ACTIONS(2934),
    [anon_sym_TILDE] = ACTIONS(2936),
    [aux_sym_prefix_op_token1] = ACTIONS(2934),
    [aux_sym_infix_op_token1] = ACTIONS(2936),
    [aux_sym_infix_op_token2] = ACTIONS(2934),
    [anon_sym_PIPE_PIPE] = ACTIONS(2934),
    [anon_sym_BANG_EQ] = ACTIONS(2934),
    [anon_sym_COLON_EQ] = ACTIONS(2936),
    [anon_sym_DOLLAR] = ACTIONS(2934),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2934),
    [sym_int] = ACTIONS(2934),
    [sym_xint] = ACTIONS(2936),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2936),
    [sym__newline] = ACTIONS(2936),
    [sym__dedent] = ACTIONS(2936),
  },
  [890] = {
    [sym_block_comment] = STATE(890),
    [sym_compiler_directive_decl] = STATE(890),
    [sym_fsi_directive_decl] = STATE(890),
    [sym_preproc_line] = STATE(890),
    [sym_identifier] = ACTIONS(2938),
    [anon_sym_EQ] = ACTIONS(2940),
    [anon_sym_LBRACK_LT] = ACTIONS(2940),
    [anon_sym_COLON] = ACTIONS(2938),
    [anon_sym_return] = ACTIONS(2938),
    [anon_sym_do] = ACTIONS(2938),
    [anon_sym_let] = ACTIONS(2938),
    [anon_sym_let_BANG] = ACTIONS(2940),
    [aux_sym_access_modifier_token1] = ACTIONS(2940),
    [anon_sym_LPAREN] = ACTIONS(2938),
    [anon_sym_COMMA] = ACTIONS(2940),
    [anon_sym_null] = ACTIONS(2938),
    [anon_sym_QMARK] = ACTIONS(2938),
    [anon_sym_COLON_QMARK] = ACTIONS(2938),
    [anon_sym_COLON_COLON] = ACTIONS(2940),
    [anon_sym_AMP] = ACTIONS(2938),
    [anon_sym_LBRACK] = ACTIONS(2938),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2940),
    [anon_sym_LBRACE] = ACTIONS(2938),
    [anon_sym_LT_AT] = ACTIONS(2938),
    [anon_sym_LT_AT_AT] = ACTIONS(2938),
    [anon_sym_DOT] = ACTIONS(2938),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2940),
    [anon_sym_new] = ACTIONS(2938),
    [anon_sym_with] = ACTIONS(2938),
    [anon_sym_return_BANG] = ACTIONS(2940),
    [anon_sym_yield] = ACTIONS(2938),
    [anon_sym_yield_BANG] = ACTIONS(2940),
    [anon_sym_lazy] = ACTIONS(2938),
    [anon_sym_assert] = ACTIONS(2938),
    [anon_sym_upcast] = ACTIONS(2938),
    [anon_sym_downcast] = ACTIONS(2938),
    [anon_sym_COLON_GT] = ACTIONS(2940),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2940),
    [anon_sym_for] = ACTIONS(2938),
    [anon_sym_while] = ACTIONS(2938),
    [anon_sym_if] = ACTIONS(2938),
    [anon_sym_fun] = ACTIONS(2938),
    [anon_sym_try] = ACTIONS(2938),
    [anon_sym_match] = ACTIONS(2938),
    [anon_sym_match_BANG] = ACTIONS(2940),
    [anon_sym_function] = ACTIONS(2938),
    [anon_sym_LT_DASH] = ACTIONS(2938),
    [anon_sym_DOT_LBRACK] = ACTIONS(2940),
    [anon_sym_LT] = ACTIONS(2940),
    [anon_sym_use] = ACTIONS(2938),
    [anon_sym_use_BANG] = ACTIONS(2940),
    [anon_sym_do_BANG] = ACTIONS(2940),
    [anon_sym_begin] = ACTIONS(2938),
    [anon_sym_LPAREN2] = ACTIONS(2938),
    [anon_sym_DOT_DOT2] = ACTIONS(2940),
    [anon_sym_default] = ACTIONS(2938),
    [anon_sym_or] = ACTIONS(2938),
    [anon_sym_static] = ACTIONS(2938),
    [anon_sym_member] = ACTIONS(2938),
    [anon_sym_abstract] = ACTIONS(2938),
    [anon_sym_val] = ACTIONS(2938),
    [anon_sym_override] = ACTIONS(2938),
    [aux_sym_char_token1] = ACTIONS(2940),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2938),
    [anon_sym_DQUOTE] = ACTIONS(2938),
    [anon_sym_AT_DQUOTE] = ACTIONS(2940),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2940),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2940),
    [sym_bool] = ACTIONS(2938),
    [sym_unit] = ACTIONS(2940),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2938),
    [sym_op_identifier] = ACTIONS(2938),
    [anon_sym_PLUS] = ACTIONS(2938),
    [anon_sym_DASH] = ACTIONS(2938),
    [anon_sym_PLUS_DOT] = ACTIONS(2938),
    [anon_sym_DASH_DOT] = ACTIONS(2938),
    [anon_sym_PERCENT] = ACTIONS(2938),
    [anon_sym_AMP_AMP] = ACTIONS(2938),
    [anon_sym_TILDE] = ACTIONS(2940),
    [aux_sym_prefix_op_token1] = ACTIONS(2938),
    [aux_sym_infix_op_token1] = ACTIONS(2940),
    [aux_sym_infix_op_token2] = ACTIONS(2938),
    [anon_sym_PIPE_PIPE] = ACTIONS(2938),
    [anon_sym_BANG_EQ] = ACTIONS(2938),
    [anon_sym_COLON_EQ] = ACTIONS(2940),
    [anon_sym_DOLLAR] = ACTIONS(2938),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2938),
    [sym_int] = ACTIONS(2938),
    [sym_xint] = ACTIONS(2940),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2940),
    [sym__newline] = ACTIONS(2940),
    [sym__dedent] = ACTIONS(2940),
  },
  [891] = {
    [sym_block_comment] = STATE(891),
    [sym_compiler_directive_decl] = STATE(891),
    [sym_fsi_directive_decl] = STATE(891),
    [sym_preproc_line] = STATE(891),
    [sym_identifier] = ACTIONS(2942),
    [anon_sym_EQ] = ACTIONS(2944),
    [anon_sym_LBRACK_LT] = ACTIONS(2944),
    [anon_sym_COLON] = ACTIONS(2942),
    [anon_sym_return] = ACTIONS(2942),
    [anon_sym_do] = ACTIONS(2942),
    [anon_sym_let] = ACTIONS(2942),
    [anon_sym_let_BANG] = ACTIONS(2944),
    [aux_sym_access_modifier_token1] = ACTIONS(2944),
    [anon_sym_LPAREN] = ACTIONS(2942),
    [anon_sym_COMMA] = ACTIONS(2944),
    [anon_sym_null] = ACTIONS(2942),
    [anon_sym_QMARK] = ACTIONS(2942),
    [anon_sym_COLON_QMARK] = ACTIONS(2942),
    [anon_sym_COLON_COLON] = ACTIONS(2944),
    [anon_sym_AMP] = ACTIONS(2942),
    [anon_sym_LBRACK] = ACTIONS(2942),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2944),
    [anon_sym_LBRACE] = ACTIONS(2942),
    [anon_sym_LT_AT] = ACTIONS(2942),
    [anon_sym_LT_AT_AT] = ACTIONS(2942),
    [anon_sym_DOT] = ACTIONS(2942),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2944),
    [anon_sym_new] = ACTIONS(2942),
    [anon_sym_with] = ACTIONS(2942),
    [anon_sym_return_BANG] = ACTIONS(2944),
    [anon_sym_yield] = ACTIONS(2942),
    [anon_sym_yield_BANG] = ACTIONS(2944),
    [anon_sym_lazy] = ACTIONS(2942),
    [anon_sym_assert] = ACTIONS(2942),
    [anon_sym_upcast] = ACTIONS(2942),
    [anon_sym_downcast] = ACTIONS(2942),
    [anon_sym_COLON_GT] = ACTIONS(2944),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2944),
    [anon_sym_for] = ACTIONS(2942),
    [anon_sym_while] = ACTIONS(2942),
    [anon_sym_if] = ACTIONS(2942),
    [anon_sym_fun] = ACTIONS(2942),
    [anon_sym_try] = ACTIONS(2942),
    [anon_sym_match] = ACTIONS(2942),
    [anon_sym_match_BANG] = ACTIONS(2944),
    [anon_sym_function] = ACTIONS(2942),
    [anon_sym_LT_DASH] = ACTIONS(2942),
    [anon_sym_DOT_LBRACK] = ACTIONS(2944),
    [anon_sym_LT] = ACTIONS(2944),
    [anon_sym_use] = ACTIONS(2942),
    [anon_sym_use_BANG] = ACTIONS(2944),
    [anon_sym_do_BANG] = ACTIONS(2944),
    [anon_sym_begin] = ACTIONS(2942),
    [anon_sym_LPAREN2] = ACTIONS(2942),
    [anon_sym_DOT_DOT2] = ACTIONS(2944),
    [anon_sym_default] = ACTIONS(2942),
    [anon_sym_or] = ACTIONS(2942),
    [anon_sym_static] = ACTIONS(2942),
    [anon_sym_member] = ACTIONS(2942),
    [anon_sym_abstract] = ACTIONS(2942),
    [anon_sym_val] = ACTIONS(2942),
    [anon_sym_override] = ACTIONS(2942),
    [aux_sym_char_token1] = ACTIONS(2944),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2942),
    [anon_sym_DQUOTE] = ACTIONS(2942),
    [anon_sym_AT_DQUOTE] = ACTIONS(2944),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2944),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2944),
    [sym_bool] = ACTIONS(2942),
    [sym_unit] = ACTIONS(2944),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2942),
    [sym_op_identifier] = ACTIONS(2942),
    [anon_sym_PLUS] = ACTIONS(2942),
    [anon_sym_DASH] = ACTIONS(2942),
    [anon_sym_PLUS_DOT] = ACTIONS(2942),
    [anon_sym_DASH_DOT] = ACTIONS(2942),
    [anon_sym_PERCENT] = ACTIONS(2942),
    [anon_sym_AMP_AMP] = ACTIONS(2942),
    [anon_sym_TILDE] = ACTIONS(2944),
    [aux_sym_prefix_op_token1] = ACTIONS(2942),
    [aux_sym_infix_op_token1] = ACTIONS(2944),
    [aux_sym_infix_op_token2] = ACTIONS(2942),
    [anon_sym_PIPE_PIPE] = ACTIONS(2942),
    [anon_sym_BANG_EQ] = ACTIONS(2942),
    [anon_sym_COLON_EQ] = ACTIONS(2944),
    [anon_sym_DOLLAR] = ACTIONS(2942),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2942),
    [sym_int] = ACTIONS(2942),
    [sym_xint] = ACTIONS(2944),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2944),
    [sym__newline] = ACTIONS(2944),
    [sym__dedent] = ACTIONS(2944),
  },
  [892] = {
    [sym_block_comment] = STATE(892),
    [sym_compiler_directive_decl] = STATE(892),
    [sym_fsi_directive_decl] = STATE(892),
    [sym_preproc_line] = STATE(892),
    [sym_identifier] = ACTIONS(2946),
    [anon_sym_EQ] = ACTIONS(2948),
    [anon_sym_LBRACK_LT] = ACTIONS(2948),
    [anon_sym_COLON] = ACTIONS(2946),
    [anon_sym_return] = ACTIONS(2946),
    [anon_sym_do] = ACTIONS(2946),
    [anon_sym_let] = ACTIONS(2946),
    [anon_sym_let_BANG] = ACTIONS(2948),
    [aux_sym_access_modifier_token1] = ACTIONS(2948),
    [anon_sym_LPAREN] = ACTIONS(2946),
    [anon_sym_COMMA] = ACTIONS(2948),
    [anon_sym_null] = ACTIONS(2946),
    [anon_sym_QMARK] = ACTIONS(2946),
    [anon_sym_COLON_QMARK] = ACTIONS(2946),
    [anon_sym_COLON_COLON] = ACTIONS(2948),
    [anon_sym_AMP] = ACTIONS(2946),
    [anon_sym_LBRACK] = ACTIONS(2946),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2948),
    [anon_sym_LBRACE] = ACTIONS(2946),
    [anon_sym_LT_AT] = ACTIONS(2946),
    [anon_sym_LT_AT_AT] = ACTIONS(2946),
    [anon_sym_DOT] = ACTIONS(2946),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2948),
    [anon_sym_new] = ACTIONS(2946),
    [anon_sym_with] = ACTIONS(2946),
    [anon_sym_return_BANG] = ACTIONS(2948),
    [anon_sym_yield] = ACTIONS(2946),
    [anon_sym_yield_BANG] = ACTIONS(2948),
    [anon_sym_lazy] = ACTIONS(2946),
    [anon_sym_assert] = ACTIONS(2946),
    [anon_sym_upcast] = ACTIONS(2946),
    [anon_sym_downcast] = ACTIONS(2946),
    [anon_sym_COLON_GT] = ACTIONS(2948),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2948),
    [anon_sym_for] = ACTIONS(2946),
    [anon_sym_while] = ACTIONS(2946),
    [anon_sym_if] = ACTIONS(2946),
    [anon_sym_fun] = ACTIONS(2946),
    [anon_sym_try] = ACTIONS(2946),
    [anon_sym_match] = ACTIONS(2946),
    [anon_sym_match_BANG] = ACTIONS(2948),
    [anon_sym_function] = ACTIONS(2946),
    [anon_sym_LT_DASH] = ACTIONS(2946),
    [anon_sym_DOT_LBRACK] = ACTIONS(2948),
    [anon_sym_LT] = ACTIONS(2948),
    [anon_sym_use] = ACTIONS(2946),
    [anon_sym_use_BANG] = ACTIONS(2948),
    [anon_sym_do_BANG] = ACTIONS(2948),
    [anon_sym_begin] = ACTIONS(2946),
    [anon_sym_LPAREN2] = ACTIONS(2946),
    [anon_sym_DOT_DOT2] = ACTIONS(2948),
    [anon_sym_default] = ACTIONS(2946),
    [anon_sym_or] = ACTIONS(2946),
    [anon_sym_static] = ACTIONS(2946),
    [anon_sym_member] = ACTIONS(2946),
    [anon_sym_abstract] = ACTIONS(2946),
    [anon_sym_val] = ACTIONS(2946),
    [anon_sym_override] = ACTIONS(2946),
    [aux_sym_char_token1] = ACTIONS(2948),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2946),
    [anon_sym_DQUOTE] = ACTIONS(2946),
    [anon_sym_AT_DQUOTE] = ACTIONS(2948),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2948),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2948),
    [sym_bool] = ACTIONS(2946),
    [sym_unit] = ACTIONS(2948),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2946),
    [sym_op_identifier] = ACTIONS(2946),
    [anon_sym_PLUS] = ACTIONS(2946),
    [anon_sym_DASH] = ACTIONS(2946),
    [anon_sym_PLUS_DOT] = ACTIONS(2946),
    [anon_sym_DASH_DOT] = ACTIONS(2946),
    [anon_sym_PERCENT] = ACTIONS(2946),
    [anon_sym_AMP_AMP] = ACTIONS(2946),
    [anon_sym_TILDE] = ACTIONS(2948),
    [aux_sym_prefix_op_token1] = ACTIONS(2946),
    [aux_sym_infix_op_token1] = ACTIONS(2948),
    [aux_sym_infix_op_token2] = ACTIONS(2946),
    [anon_sym_PIPE_PIPE] = ACTIONS(2946),
    [anon_sym_BANG_EQ] = ACTIONS(2946),
    [anon_sym_COLON_EQ] = ACTIONS(2948),
    [anon_sym_DOLLAR] = ACTIONS(2946),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2946),
    [sym_int] = ACTIONS(2946),
    [sym_xint] = ACTIONS(2948),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2948),
    [sym__newline] = ACTIONS(2948),
    [sym__dedent] = ACTIONS(2948),
  },
  [893] = {
    [sym_block_comment] = STATE(893),
    [sym_compiler_directive_decl] = STATE(893),
    [sym_fsi_directive_decl] = STATE(893),
    [sym_preproc_line] = STATE(893),
    [sym_identifier] = ACTIONS(2950),
    [anon_sym_EQ] = ACTIONS(2952),
    [anon_sym_LBRACK_LT] = ACTIONS(2952),
    [anon_sym_COLON] = ACTIONS(2950),
    [anon_sym_return] = ACTIONS(2950),
    [anon_sym_do] = ACTIONS(2950),
    [anon_sym_let] = ACTIONS(2950),
    [anon_sym_let_BANG] = ACTIONS(2952),
    [aux_sym_access_modifier_token1] = ACTIONS(2952),
    [anon_sym_LPAREN] = ACTIONS(2950),
    [anon_sym_COMMA] = ACTIONS(2952),
    [anon_sym_null] = ACTIONS(2950),
    [anon_sym_QMARK] = ACTIONS(2950),
    [anon_sym_COLON_QMARK] = ACTIONS(2950),
    [anon_sym_COLON_COLON] = ACTIONS(2952),
    [anon_sym_AMP] = ACTIONS(2950),
    [anon_sym_LBRACK] = ACTIONS(2950),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2952),
    [anon_sym_LBRACE] = ACTIONS(2950),
    [anon_sym_LT_AT] = ACTIONS(2950),
    [anon_sym_LT_AT_AT] = ACTIONS(2950),
    [anon_sym_DOT] = ACTIONS(2950),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2952),
    [anon_sym_new] = ACTIONS(2950),
    [anon_sym_with] = ACTIONS(2950),
    [anon_sym_return_BANG] = ACTIONS(2952),
    [anon_sym_yield] = ACTIONS(2950),
    [anon_sym_yield_BANG] = ACTIONS(2952),
    [anon_sym_lazy] = ACTIONS(2950),
    [anon_sym_assert] = ACTIONS(2950),
    [anon_sym_upcast] = ACTIONS(2950),
    [anon_sym_downcast] = ACTIONS(2950),
    [anon_sym_COLON_GT] = ACTIONS(2952),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2952),
    [anon_sym_for] = ACTIONS(2950),
    [anon_sym_while] = ACTIONS(2950),
    [anon_sym_if] = ACTIONS(2950),
    [anon_sym_fun] = ACTIONS(2950),
    [anon_sym_try] = ACTIONS(2950),
    [anon_sym_match] = ACTIONS(2950),
    [anon_sym_match_BANG] = ACTIONS(2952),
    [anon_sym_function] = ACTIONS(2950),
    [anon_sym_LT_DASH] = ACTIONS(2950),
    [anon_sym_DOT_LBRACK] = ACTIONS(2952),
    [anon_sym_LT] = ACTIONS(2952),
    [anon_sym_use] = ACTIONS(2950),
    [anon_sym_use_BANG] = ACTIONS(2952),
    [anon_sym_do_BANG] = ACTIONS(2952),
    [anon_sym_begin] = ACTIONS(2950),
    [anon_sym_LPAREN2] = ACTIONS(2950),
    [anon_sym_DOT_DOT2] = ACTIONS(2952),
    [anon_sym_default] = ACTIONS(2950),
    [anon_sym_or] = ACTIONS(2950),
    [anon_sym_static] = ACTIONS(2950),
    [anon_sym_member] = ACTIONS(2950),
    [anon_sym_abstract] = ACTIONS(2950),
    [anon_sym_val] = ACTIONS(2950),
    [anon_sym_override] = ACTIONS(2950),
    [aux_sym_char_token1] = ACTIONS(2952),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2950),
    [anon_sym_DQUOTE] = ACTIONS(2950),
    [anon_sym_AT_DQUOTE] = ACTIONS(2952),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2952),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2952),
    [sym_bool] = ACTIONS(2950),
    [sym_unit] = ACTIONS(2952),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2950),
    [sym_op_identifier] = ACTIONS(2950),
    [anon_sym_PLUS] = ACTIONS(2950),
    [anon_sym_DASH] = ACTIONS(2950),
    [anon_sym_PLUS_DOT] = ACTIONS(2950),
    [anon_sym_DASH_DOT] = ACTIONS(2950),
    [anon_sym_PERCENT] = ACTIONS(2950),
    [anon_sym_AMP_AMP] = ACTIONS(2950),
    [anon_sym_TILDE] = ACTIONS(2952),
    [aux_sym_prefix_op_token1] = ACTIONS(2950),
    [aux_sym_infix_op_token1] = ACTIONS(2952),
    [aux_sym_infix_op_token2] = ACTIONS(2950),
    [anon_sym_PIPE_PIPE] = ACTIONS(2950),
    [anon_sym_BANG_EQ] = ACTIONS(2950),
    [anon_sym_COLON_EQ] = ACTIONS(2952),
    [anon_sym_DOLLAR] = ACTIONS(2950),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2950),
    [sym_int] = ACTIONS(2950),
    [sym_xint] = ACTIONS(2952),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2952),
    [sym__newline] = ACTIONS(2952),
    [sym__dedent] = ACTIONS(2952),
  },
  [894] = {
    [sym_block_comment] = STATE(894),
    [sym_compiler_directive_decl] = STATE(894),
    [sym_fsi_directive_decl] = STATE(894),
    [sym_preproc_line] = STATE(894),
    [sym_identifier] = ACTIONS(2954),
    [anon_sym_EQ] = ACTIONS(2956),
    [anon_sym_LBRACK_LT] = ACTIONS(2956),
    [anon_sym_COLON] = ACTIONS(2954),
    [anon_sym_return] = ACTIONS(2954),
    [anon_sym_do] = ACTIONS(2954),
    [anon_sym_let] = ACTIONS(2954),
    [anon_sym_let_BANG] = ACTIONS(2956),
    [aux_sym_access_modifier_token1] = ACTIONS(2956),
    [anon_sym_LPAREN] = ACTIONS(2954),
    [anon_sym_COMMA] = ACTIONS(2956),
    [anon_sym_null] = ACTIONS(2954),
    [anon_sym_QMARK] = ACTIONS(2954),
    [anon_sym_COLON_QMARK] = ACTIONS(2954),
    [anon_sym_COLON_COLON] = ACTIONS(2956),
    [anon_sym_AMP] = ACTIONS(2954),
    [anon_sym_LBRACK] = ACTIONS(2954),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2956),
    [anon_sym_LBRACE] = ACTIONS(2954),
    [anon_sym_LT_AT] = ACTIONS(2954),
    [anon_sym_LT_AT_AT] = ACTIONS(2954),
    [anon_sym_DOT] = ACTIONS(2954),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2956),
    [anon_sym_new] = ACTIONS(2954),
    [anon_sym_with] = ACTIONS(2954),
    [anon_sym_return_BANG] = ACTIONS(2956),
    [anon_sym_yield] = ACTIONS(2954),
    [anon_sym_yield_BANG] = ACTIONS(2956),
    [anon_sym_lazy] = ACTIONS(2954),
    [anon_sym_assert] = ACTIONS(2954),
    [anon_sym_upcast] = ACTIONS(2954),
    [anon_sym_downcast] = ACTIONS(2954),
    [anon_sym_COLON_GT] = ACTIONS(2956),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2956),
    [anon_sym_for] = ACTIONS(2954),
    [anon_sym_while] = ACTIONS(2954),
    [anon_sym_if] = ACTIONS(2954),
    [anon_sym_fun] = ACTIONS(2954),
    [anon_sym_try] = ACTIONS(2954),
    [anon_sym_match] = ACTIONS(2954),
    [anon_sym_match_BANG] = ACTIONS(2956),
    [anon_sym_function] = ACTIONS(2954),
    [anon_sym_LT_DASH] = ACTIONS(2954),
    [anon_sym_DOT_LBRACK] = ACTIONS(2956),
    [anon_sym_LT] = ACTIONS(2956),
    [anon_sym_use] = ACTIONS(2954),
    [anon_sym_use_BANG] = ACTIONS(2956),
    [anon_sym_do_BANG] = ACTIONS(2956),
    [anon_sym_begin] = ACTIONS(2954),
    [anon_sym_LPAREN2] = ACTIONS(2954),
    [anon_sym_DOT_DOT2] = ACTIONS(2956),
    [anon_sym_default] = ACTIONS(2954),
    [anon_sym_or] = ACTIONS(2954),
    [anon_sym_static] = ACTIONS(2954),
    [anon_sym_member] = ACTIONS(2954),
    [anon_sym_abstract] = ACTIONS(2954),
    [anon_sym_val] = ACTIONS(2954),
    [anon_sym_override] = ACTIONS(2954),
    [aux_sym_char_token1] = ACTIONS(2956),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2954),
    [anon_sym_DQUOTE] = ACTIONS(2954),
    [anon_sym_AT_DQUOTE] = ACTIONS(2956),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2956),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2956),
    [sym_bool] = ACTIONS(2954),
    [sym_unit] = ACTIONS(2956),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2954),
    [sym_op_identifier] = ACTIONS(2954),
    [anon_sym_PLUS] = ACTIONS(2954),
    [anon_sym_DASH] = ACTIONS(2954),
    [anon_sym_PLUS_DOT] = ACTIONS(2954),
    [anon_sym_DASH_DOT] = ACTIONS(2954),
    [anon_sym_PERCENT] = ACTIONS(2954),
    [anon_sym_AMP_AMP] = ACTIONS(2954),
    [anon_sym_TILDE] = ACTIONS(2956),
    [aux_sym_prefix_op_token1] = ACTIONS(2954),
    [aux_sym_infix_op_token1] = ACTIONS(2956),
    [aux_sym_infix_op_token2] = ACTIONS(2954),
    [anon_sym_PIPE_PIPE] = ACTIONS(2954),
    [anon_sym_BANG_EQ] = ACTIONS(2954),
    [anon_sym_COLON_EQ] = ACTIONS(2956),
    [anon_sym_DOLLAR] = ACTIONS(2954),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2954),
    [sym_int] = ACTIONS(2954),
    [sym_xint] = ACTIONS(2956),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2956),
    [sym__newline] = ACTIONS(2956),
    [sym__dedent] = ACTIONS(2956),
  },
  [895] = {
    [sym_block_comment] = STATE(895),
    [sym_compiler_directive_decl] = STATE(895),
    [sym_fsi_directive_decl] = STATE(895),
    [sym_preproc_line] = STATE(895),
    [sym_identifier] = ACTIONS(2454),
    [anon_sym_EQ] = ACTIONS(2456),
    [anon_sym_GT_RBRACK] = ACTIONS(2456),
    [anon_sym_COLON] = ACTIONS(2454),
    [anon_sym_return] = ACTIONS(2454),
    [anon_sym_do] = ACTIONS(2454),
    [anon_sym_let] = ACTIONS(2454),
    [anon_sym_let_BANG] = ACTIONS(2456),
    [anon_sym_LPAREN] = ACTIONS(2454),
    [anon_sym_COMMA] = ACTIONS(2456),
    [anon_sym_null] = ACTIONS(2454),
    [anon_sym_QMARK] = ACTIONS(2454),
    [anon_sym_COLON_QMARK] = ACTIONS(2454),
    [anon_sym_COLON_COLON] = ACTIONS(2456),
    [anon_sym_AMP] = ACTIONS(2454),
    [anon_sym_LBRACK] = ACTIONS(2454),
    [anon_sym_RBRACK] = ACTIONS(2456),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2456),
    [anon_sym_LBRACE] = ACTIONS(2454),
    [anon_sym_RBRACE] = ACTIONS(2456),
    [anon_sym_LT_AT] = ACTIONS(2454),
    [anon_sym_LT_AT_AT] = ACTIONS(2454),
    [anon_sym_DOT] = ACTIONS(2454),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2456),
    [anon_sym_new] = ACTIONS(2454),
    [anon_sym_with] = ACTIONS(2454),
    [anon_sym_return_BANG] = ACTIONS(2456),
    [anon_sym_yield] = ACTIONS(2454),
    [anon_sym_yield_BANG] = ACTIONS(2456),
    [anon_sym_lazy] = ACTIONS(2454),
    [anon_sym_assert] = ACTIONS(2454),
    [anon_sym_upcast] = ACTIONS(2454),
    [anon_sym_downcast] = ACTIONS(2454),
    [anon_sym_COLON_GT] = ACTIONS(2456),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2456),
    [anon_sym_for] = ACTIONS(2454),
    [anon_sym_to] = ACTIONS(2454),
    [anon_sym_downto] = ACTIONS(2454),
    [anon_sym_while] = ACTIONS(2454),
    [anon_sym_if] = ACTIONS(2454),
    [anon_sym_fun] = ACTIONS(2454),
    [anon_sym_DASH_GT] = ACTIONS(2454),
    [anon_sym_try] = ACTIONS(2454),
    [anon_sym_match] = ACTIONS(2454),
    [anon_sym_match_BANG] = ACTIONS(2456),
    [anon_sym_function] = ACTIONS(2454),
    [anon_sym_LT_DASH] = ACTIONS(2454),
    [anon_sym_DOT_LBRACK] = ACTIONS(2456),
    [anon_sym_LT] = ACTIONS(2456),
    [anon_sym_use] = ACTIONS(2454),
    [anon_sym_use_BANG] = ACTIONS(2456),
    [anon_sym_do_BANG] = ACTIONS(2456),
    [anon_sym_begin] = ACTIONS(2454),
    [anon_sym_LPAREN2] = ACTIONS(2454),
    [anon_sym_DOT_DOT2] = ACTIONS(2456),
    [anon_sym_STAR] = ACTIONS(2454),
    [anon_sym_LT2] = ACTIONS(2454),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2456),
    [anon_sym_or] = ACTIONS(2454),
    [aux_sym_char_token1] = ACTIONS(2456),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2454),
    [anon_sym_DQUOTE] = ACTIONS(2454),
    [anon_sym_AT_DQUOTE] = ACTIONS(2456),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2456),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2456),
    [sym_bool] = ACTIONS(2454),
    [sym_unit] = ACTIONS(2456),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2454),
    [sym_op_identifier] = ACTIONS(2454),
    [anon_sym_PLUS] = ACTIONS(2454),
    [anon_sym_DASH] = ACTIONS(2454),
    [anon_sym_PLUS_DOT] = ACTIONS(2454),
    [anon_sym_DASH_DOT] = ACTIONS(2454),
    [anon_sym_PERCENT] = ACTIONS(2454),
    [anon_sym_AMP_AMP] = ACTIONS(2454),
    [anon_sym_TILDE] = ACTIONS(2456),
    [aux_sym_prefix_op_token1] = ACTIONS(2454),
    [aux_sym_infix_op_token1] = ACTIONS(2456),
    [aux_sym_infix_op_token2] = ACTIONS(2454),
    [anon_sym_PIPE_PIPE] = ACTIONS(2454),
    [anon_sym_BANG_EQ] = ACTIONS(2454),
    [anon_sym_COLON_EQ] = ACTIONS(2456),
    [anon_sym_DOLLAR] = ACTIONS(2454),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2454),
    [sym_int] = ACTIONS(2454),
    [sym_xint] = ACTIONS(2456),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2456),
    [sym__newline] = ACTIONS(2456),
  },
  [896] = {
    [sym_block_comment] = STATE(896),
    [sym_compiler_directive_decl] = STATE(896),
    [sym_fsi_directive_decl] = STATE(896),
    [sym_preproc_line] = STATE(896),
    [sym_identifier] = ACTIONS(2958),
    [anon_sym_EQ] = ACTIONS(2960),
    [anon_sym_LBRACK_LT] = ACTIONS(2960),
    [anon_sym_COLON] = ACTIONS(2958),
    [anon_sym_return] = ACTIONS(2958),
    [anon_sym_do] = ACTIONS(2958),
    [anon_sym_let] = ACTIONS(2958),
    [anon_sym_let_BANG] = ACTIONS(2960),
    [aux_sym_access_modifier_token1] = ACTIONS(2960),
    [anon_sym_LPAREN] = ACTIONS(2958),
    [anon_sym_COMMA] = ACTIONS(2960),
    [anon_sym_null] = ACTIONS(2958),
    [anon_sym_QMARK] = ACTIONS(2958),
    [anon_sym_COLON_QMARK] = ACTIONS(2958),
    [anon_sym_COLON_COLON] = ACTIONS(2960),
    [anon_sym_AMP] = ACTIONS(2958),
    [anon_sym_LBRACK] = ACTIONS(2958),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2960),
    [anon_sym_LBRACE] = ACTIONS(2958),
    [anon_sym_LT_AT] = ACTIONS(2958),
    [anon_sym_LT_AT_AT] = ACTIONS(2958),
    [anon_sym_DOT] = ACTIONS(2958),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2960),
    [anon_sym_new] = ACTIONS(2958),
    [anon_sym_with] = ACTIONS(2958),
    [anon_sym_return_BANG] = ACTIONS(2960),
    [anon_sym_yield] = ACTIONS(2958),
    [anon_sym_yield_BANG] = ACTIONS(2960),
    [anon_sym_lazy] = ACTIONS(2958),
    [anon_sym_assert] = ACTIONS(2958),
    [anon_sym_upcast] = ACTIONS(2958),
    [anon_sym_downcast] = ACTIONS(2958),
    [anon_sym_COLON_GT] = ACTIONS(2960),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2960),
    [anon_sym_for] = ACTIONS(2958),
    [anon_sym_while] = ACTIONS(2958),
    [anon_sym_if] = ACTIONS(2958),
    [anon_sym_fun] = ACTIONS(2958),
    [anon_sym_try] = ACTIONS(2958),
    [anon_sym_match] = ACTIONS(2958),
    [anon_sym_match_BANG] = ACTIONS(2960),
    [anon_sym_function] = ACTIONS(2958),
    [anon_sym_LT_DASH] = ACTIONS(2958),
    [anon_sym_DOT_LBRACK] = ACTIONS(2960),
    [anon_sym_LT] = ACTIONS(2960),
    [anon_sym_use] = ACTIONS(2958),
    [anon_sym_use_BANG] = ACTIONS(2960),
    [anon_sym_do_BANG] = ACTIONS(2960),
    [anon_sym_begin] = ACTIONS(2958),
    [anon_sym_LPAREN2] = ACTIONS(2958),
    [anon_sym_DOT_DOT2] = ACTIONS(2960),
    [anon_sym_default] = ACTIONS(2958),
    [anon_sym_or] = ACTIONS(2958),
    [anon_sym_static] = ACTIONS(2958),
    [anon_sym_member] = ACTIONS(2958),
    [anon_sym_abstract] = ACTIONS(2958),
    [anon_sym_val] = ACTIONS(2958),
    [anon_sym_override] = ACTIONS(2958),
    [aux_sym_char_token1] = ACTIONS(2960),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2958),
    [anon_sym_DQUOTE] = ACTIONS(2958),
    [anon_sym_AT_DQUOTE] = ACTIONS(2960),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2960),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2960),
    [sym_bool] = ACTIONS(2958),
    [sym_unit] = ACTIONS(2960),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2958),
    [sym_op_identifier] = ACTIONS(2958),
    [anon_sym_PLUS] = ACTIONS(2958),
    [anon_sym_DASH] = ACTIONS(2958),
    [anon_sym_PLUS_DOT] = ACTIONS(2958),
    [anon_sym_DASH_DOT] = ACTIONS(2958),
    [anon_sym_PERCENT] = ACTIONS(2958),
    [anon_sym_AMP_AMP] = ACTIONS(2958),
    [anon_sym_TILDE] = ACTIONS(2960),
    [aux_sym_prefix_op_token1] = ACTIONS(2958),
    [aux_sym_infix_op_token1] = ACTIONS(2960),
    [aux_sym_infix_op_token2] = ACTIONS(2958),
    [anon_sym_PIPE_PIPE] = ACTIONS(2958),
    [anon_sym_BANG_EQ] = ACTIONS(2958),
    [anon_sym_COLON_EQ] = ACTIONS(2960),
    [anon_sym_DOLLAR] = ACTIONS(2958),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2958),
    [sym_int] = ACTIONS(2958),
    [sym_xint] = ACTIONS(2960),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2960),
    [sym__newline] = ACTIONS(2960),
    [sym__dedent] = ACTIONS(2960),
  },
  [897] = {
    [sym_block_comment] = STATE(897),
    [sym_compiler_directive_decl] = STATE(897),
    [sym_fsi_directive_decl] = STATE(897),
    [sym_preproc_line] = STATE(897),
    [sym_identifier] = ACTIONS(2962),
    [anon_sym_EQ] = ACTIONS(2964),
    [anon_sym_LBRACK_LT] = ACTIONS(2964),
    [anon_sym_COLON] = ACTIONS(2962),
    [anon_sym_return] = ACTIONS(2962),
    [anon_sym_do] = ACTIONS(2962),
    [anon_sym_let] = ACTIONS(2962),
    [anon_sym_let_BANG] = ACTIONS(2964),
    [aux_sym_access_modifier_token1] = ACTIONS(2964),
    [anon_sym_LPAREN] = ACTIONS(2962),
    [anon_sym_COMMA] = ACTIONS(2964),
    [anon_sym_null] = ACTIONS(2962),
    [anon_sym_QMARK] = ACTIONS(2962),
    [anon_sym_COLON_QMARK] = ACTIONS(2962),
    [anon_sym_COLON_COLON] = ACTIONS(2964),
    [anon_sym_AMP] = ACTIONS(2962),
    [anon_sym_LBRACK] = ACTIONS(2962),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2964),
    [anon_sym_LBRACE] = ACTIONS(2962),
    [anon_sym_LT_AT] = ACTIONS(2962),
    [anon_sym_LT_AT_AT] = ACTIONS(2962),
    [anon_sym_DOT] = ACTIONS(2962),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2964),
    [anon_sym_new] = ACTIONS(2962),
    [anon_sym_with] = ACTIONS(2962),
    [anon_sym_return_BANG] = ACTIONS(2964),
    [anon_sym_yield] = ACTIONS(2962),
    [anon_sym_yield_BANG] = ACTIONS(2964),
    [anon_sym_lazy] = ACTIONS(2962),
    [anon_sym_assert] = ACTIONS(2962),
    [anon_sym_upcast] = ACTIONS(2962),
    [anon_sym_downcast] = ACTIONS(2962),
    [anon_sym_COLON_GT] = ACTIONS(2964),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2964),
    [anon_sym_for] = ACTIONS(2962),
    [anon_sym_while] = ACTIONS(2962),
    [anon_sym_if] = ACTIONS(2962),
    [anon_sym_fun] = ACTIONS(2962),
    [anon_sym_try] = ACTIONS(2962),
    [anon_sym_match] = ACTIONS(2962),
    [anon_sym_match_BANG] = ACTIONS(2964),
    [anon_sym_function] = ACTIONS(2962),
    [anon_sym_LT_DASH] = ACTIONS(2962),
    [anon_sym_DOT_LBRACK] = ACTIONS(2964),
    [anon_sym_LT] = ACTIONS(2964),
    [anon_sym_use] = ACTIONS(2962),
    [anon_sym_use_BANG] = ACTIONS(2964),
    [anon_sym_do_BANG] = ACTIONS(2964),
    [anon_sym_begin] = ACTIONS(2962),
    [anon_sym_LPAREN2] = ACTIONS(2962),
    [anon_sym_DOT_DOT2] = ACTIONS(2964),
    [anon_sym_default] = ACTIONS(2962),
    [anon_sym_or] = ACTIONS(2962),
    [anon_sym_static] = ACTIONS(2962),
    [anon_sym_member] = ACTIONS(2962),
    [anon_sym_abstract] = ACTIONS(2962),
    [anon_sym_val] = ACTIONS(2962),
    [anon_sym_override] = ACTIONS(2962),
    [aux_sym_char_token1] = ACTIONS(2964),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2962),
    [anon_sym_DQUOTE] = ACTIONS(2962),
    [anon_sym_AT_DQUOTE] = ACTIONS(2964),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2964),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2964),
    [sym_bool] = ACTIONS(2962),
    [sym_unit] = ACTIONS(2964),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2962),
    [sym_op_identifier] = ACTIONS(2962),
    [anon_sym_PLUS] = ACTIONS(2962),
    [anon_sym_DASH] = ACTIONS(2962),
    [anon_sym_PLUS_DOT] = ACTIONS(2962),
    [anon_sym_DASH_DOT] = ACTIONS(2962),
    [anon_sym_PERCENT] = ACTIONS(2962),
    [anon_sym_AMP_AMP] = ACTIONS(2962),
    [anon_sym_TILDE] = ACTIONS(2964),
    [aux_sym_prefix_op_token1] = ACTIONS(2962),
    [aux_sym_infix_op_token1] = ACTIONS(2964),
    [aux_sym_infix_op_token2] = ACTIONS(2962),
    [anon_sym_PIPE_PIPE] = ACTIONS(2962),
    [anon_sym_BANG_EQ] = ACTIONS(2962),
    [anon_sym_COLON_EQ] = ACTIONS(2964),
    [anon_sym_DOLLAR] = ACTIONS(2962),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2962),
    [sym_int] = ACTIONS(2962),
    [sym_xint] = ACTIONS(2964),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2964),
    [sym__newline] = ACTIONS(2964),
    [sym__dedent] = ACTIONS(2964),
  },
  [898] = {
    [sym_block_comment] = STATE(898),
    [sym_compiler_directive_decl] = STATE(898),
    [sym_fsi_directive_decl] = STATE(898),
    [sym_preproc_line] = STATE(898),
    [sym_identifier] = ACTIONS(2966),
    [anon_sym_EQ] = ACTIONS(2968),
    [anon_sym_LBRACK_LT] = ACTIONS(2968),
    [anon_sym_COLON] = ACTIONS(2966),
    [anon_sym_return] = ACTIONS(2966),
    [anon_sym_do] = ACTIONS(2966),
    [anon_sym_let] = ACTIONS(2966),
    [anon_sym_let_BANG] = ACTIONS(2968),
    [aux_sym_access_modifier_token1] = ACTIONS(2968),
    [anon_sym_LPAREN] = ACTIONS(2966),
    [anon_sym_COMMA] = ACTIONS(2968),
    [anon_sym_null] = ACTIONS(2966),
    [anon_sym_QMARK] = ACTIONS(2966),
    [anon_sym_COLON_QMARK] = ACTIONS(2966),
    [anon_sym_COLON_COLON] = ACTIONS(2968),
    [anon_sym_AMP] = ACTIONS(2966),
    [anon_sym_LBRACK] = ACTIONS(2966),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2968),
    [anon_sym_LBRACE] = ACTIONS(2966),
    [anon_sym_LT_AT] = ACTIONS(2966),
    [anon_sym_LT_AT_AT] = ACTIONS(2966),
    [anon_sym_DOT] = ACTIONS(2966),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2968),
    [anon_sym_new] = ACTIONS(2966),
    [anon_sym_with] = ACTIONS(2966),
    [anon_sym_return_BANG] = ACTIONS(2968),
    [anon_sym_yield] = ACTIONS(2966),
    [anon_sym_yield_BANG] = ACTIONS(2968),
    [anon_sym_lazy] = ACTIONS(2966),
    [anon_sym_assert] = ACTIONS(2966),
    [anon_sym_upcast] = ACTIONS(2966),
    [anon_sym_downcast] = ACTIONS(2966),
    [anon_sym_COLON_GT] = ACTIONS(2968),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2968),
    [anon_sym_for] = ACTIONS(2966),
    [anon_sym_while] = ACTIONS(2966),
    [anon_sym_if] = ACTIONS(2966),
    [anon_sym_fun] = ACTIONS(2966),
    [anon_sym_try] = ACTIONS(2966),
    [anon_sym_match] = ACTIONS(2966),
    [anon_sym_match_BANG] = ACTIONS(2968),
    [anon_sym_function] = ACTIONS(2966),
    [anon_sym_LT_DASH] = ACTIONS(2966),
    [anon_sym_DOT_LBRACK] = ACTIONS(2968),
    [anon_sym_LT] = ACTIONS(2968),
    [anon_sym_use] = ACTIONS(2966),
    [anon_sym_use_BANG] = ACTIONS(2968),
    [anon_sym_do_BANG] = ACTIONS(2968),
    [anon_sym_begin] = ACTIONS(2966),
    [anon_sym_LPAREN2] = ACTIONS(2966),
    [anon_sym_DOT_DOT2] = ACTIONS(2968),
    [anon_sym_default] = ACTIONS(2966),
    [anon_sym_or] = ACTIONS(2966),
    [anon_sym_static] = ACTIONS(2966),
    [anon_sym_member] = ACTIONS(2966),
    [anon_sym_abstract] = ACTIONS(2966),
    [anon_sym_val] = ACTIONS(2966),
    [anon_sym_override] = ACTIONS(2966),
    [aux_sym_char_token1] = ACTIONS(2968),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2966),
    [anon_sym_DQUOTE] = ACTIONS(2966),
    [anon_sym_AT_DQUOTE] = ACTIONS(2968),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2968),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2968),
    [sym_bool] = ACTIONS(2966),
    [sym_unit] = ACTIONS(2968),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2966),
    [sym_op_identifier] = ACTIONS(2966),
    [anon_sym_PLUS] = ACTIONS(2966),
    [anon_sym_DASH] = ACTIONS(2966),
    [anon_sym_PLUS_DOT] = ACTIONS(2966),
    [anon_sym_DASH_DOT] = ACTIONS(2966),
    [anon_sym_PERCENT] = ACTIONS(2966),
    [anon_sym_AMP_AMP] = ACTIONS(2966),
    [anon_sym_TILDE] = ACTIONS(2968),
    [aux_sym_prefix_op_token1] = ACTIONS(2966),
    [aux_sym_infix_op_token1] = ACTIONS(2968),
    [aux_sym_infix_op_token2] = ACTIONS(2966),
    [anon_sym_PIPE_PIPE] = ACTIONS(2966),
    [anon_sym_BANG_EQ] = ACTIONS(2966),
    [anon_sym_COLON_EQ] = ACTIONS(2968),
    [anon_sym_DOLLAR] = ACTIONS(2966),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2966),
    [sym_int] = ACTIONS(2966),
    [sym_xint] = ACTIONS(2968),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2968),
    [sym__newline] = ACTIONS(2968),
    [sym__dedent] = ACTIONS(2968),
  },
  [899] = {
    [sym_block_comment] = STATE(899),
    [sym_compiler_directive_decl] = STATE(899),
    [sym_fsi_directive_decl] = STATE(899),
    [sym_preproc_line] = STATE(899),
    [sym_identifier] = ACTIONS(2970),
    [anon_sym_EQ] = ACTIONS(2972),
    [anon_sym_LBRACK_LT] = ACTIONS(2972),
    [anon_sym_COLON] = ACTIONS(2970),
    [anon_sym_return] = ACTIONS(2970),
    [anon_sym_do] = ACTIONS(2970),
    [anon_sym_let] = ACTIONS(2970),
    [anon_sym_let_BANG] = ACTIONS(2972),
    [aux_sym_access_modifier_token1] = ACTIONS(2972),
    [anon_sym_LPAREN] = ACTIONS(2970),
    [anon_sym_COMMA] = ACTIONS(2972),
    [anon_sym_null] = ACTIONS(2970),
    [anon_sym_QMARK] = ACTIONS(2970),
    [anon_sym_COLON_QMARK] = ACTIONS(2970),
    [anon_sym_COLON_COLON] = ACTIONS(2972),
    [anon_sym_AMP] = ACTIONS(2970),
    [anon_sym_LBRACK] = ACTIONS(2970),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2972),
    [anon_sym_LBRACE] = ACTIONS(2970),
    [anon_sym_LT_AT] = ACTIONS(2970),
    [anon_sym_LT_AT_AT] = ACTIONS(2970),
    [anon_sym_DOT] = ACTIONS(2970),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2972),
    [anon_sym_new] = ACTIONS(2970),
    [anon_sym_with] = ACTIONS(2970),
    [anon_sym_return_BANG] = ACTIONS(2972),
    [anon_sym_yield] = ACTIONS(2970),
    [anon_sym_yield_BANG] = ACTIONS(2972),
    [anon_sym_lazy] = ACTIONS(2970),
    [anon_sym_assert] = ACTIONS(2970),
    [anon_sym_upcast] = ACTIONS(2970),
    [anon_sym_downcast] = ACTIONS(2970),
    [anon_sym_COLON_GT] = ACTIONS(2972),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2972),
    [anon_sym_for] = ACTIONS(2970),
    [anon_sym_while] = ACTIONS(2970),
    [anon_sym_if] = ACTIONS(2970),
    [anon_sym_fun] = ACTIONS(2970),
    [anon_sym_try] = ACTIONS(2970),
    [anon_sym_match] = ACTIONS(2970),
    [anon_sym_match_BANG] = ACTIONS(2972),
    [anon_sym_function] = ACTIONS(2970),
    [anon_sym_LT_DASH] = ACTIONS(2970),
    [anon_sym_DOT_LBRACK] = ACTIONS(2972),
    [anon_sym_LT] = ACTIONS(2972),
    [anon_sym_use] = ACTIONS(2970),
    [anon_sym_use_BANG] = ACTIONS(2972),
    [anon_sym_do_BANG] = ACTIONS(2972),
    [anon_sym_begin] = ACTIONS(2970),
    [anon_sym_LPAREN2] = ACTIONS(2970),
    [anon_sym_DOT_DOT2] = ACTIONS(2972),
    [anon_sym_default] = ACTIONS(2970),
    [anon_sym_or] = ACTIONS(2970),
    [anon_sym_static] = ACTIONS(2970),
    [anon_sym_member] = ACTIONS(2970),
    [anon_sym_abstract] = ACTIONS(2970),
    [anon_sym_val] = ACTIONS(2970),
    [anon_sym_override] = ACTIONS(2970),
    [aux_sym_char_token1] = ACTIONS(2972),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2970),
    [anon_sym_DQUOTE] = ACTIONS(2970),
    [anon_sym_AT_DQUOTE] = ACTIONS(2972),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2972),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2972),
    [sym_bool] = ACTIONS(2970),
    [sym_unit] = ACTIONS(2972),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2970),
    [sym_op_identifier] = ACTIONS(2970),
    [anon_sym_PLUS] = ACTIONS(2970),
    [anon_sym_DASH] = ACTIONS(2970),
    [anon_sym_PLUS_DOT] = ACTIONS(2970),
    [anon_sym_DASH_DOT] = ACTIONS(2970),
    [anon_sym_PERCENT] = ACTIONS(2970),
    [anon_sym_AMP_AMP] = ACTIONS(2970),
    [anon_sym_TILDE] = ACTIONS(2972),
    [aux_sym_prefix_op_token1] = ACTIONS(2970),
    [aux_sym_infix_op_token1] = ACTIONS(2972),
    [aux_sym_infix_op_token2] = ACTIONS(2970),
    [anon_sym_PIPE_PIPE] = ACTIONS(2970),
    [anon_sym_BANG_EQ] = ACTIONS(2970),
    [anon_sym_COLON_EQ] = ACTIONS(2972),
    [anon_sym_DOLLAR] = ACTIONS(2970),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2970),
    [sym_int] = ACTIONS(2970),
    [sym_xint] = ACTIONS(2972),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2972),
    [sym__newline] = ACTIONS(2972),
    [sym__dedent] = ACTIONS(2972),
  },
  [900] = {
    [sym_block_comment] = STATE(900),
    [sym_compiler_directive_decl] = STATE(900),
    [sym_fsi_directive_decl] = STATE(900),
    [sym_preproc_line] = STATE(900),
    [sym_identifier] = ACTIONS(2974),
    [anon_sym_EQ] = ACTIONS(2976),
    [anon_sym_LBRACK_LT] = ACTIONS(2976),
    [anon_sym_COLON] = ACTIONS(2974),
    [anon_sym_return] = ACTIONS(2974),
    [anon_sym_do] = ACTIONS(2974),
    [anon_sym_let] = ACTIONS(2974),
    [anon_sym_let_BANG] = ACTIONS(2976),
    [aux_sym_access_modifier_token1] = ACTIONS(2976),
    [anon_sym_LPAREN] = ACTIONS(2974),
    [anon_sym_COMMA] = ACTIONS(2976),
    [anon_sym_null] = ACTIONS(2974),
    [anon_sym_QMARK] = ACTIONS(2974),
    [anon_sym_COLON_QMARK] = ACTIONS(2974),
    [anon_sym_COLON_COLON] = ACTIONS(2976),
    [anon_sym_AMP] = ACTIONS(2974),
    [anon_sym_LBRACK] = ACTIONS(2974),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2976),
    [anon_sym_LBRACE] = ACTIONS(2974),
    [anon_sym_LT_AT] = ACTIONS(2974),
    [anon_sym_LT_AT_AT] = ACTIONS(2974),
    [anon_sym_DOT] = ACTIONS(2974),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2976),
    [anon_sym_new] = ACTIONS(2974),
    [anon_sym_with] = ACTIONS(2974),
    [anon_sym_return_BANG] = ACTIONS(2976),
    [anon_sym_yield] = ACTIONS(2974),
    [anon_sym_yield_BANG] = ACTIONS(2976),
    [anon_sym_lazy] = ACTIONS(2974),
    [anon_sym_assert] = ACTIONS(2974),
    [anon_sym_upcast] = ACTIONS(2974),
    [anon_sym_downcast] = ACTIONS(2974),
    [anon_sym_COLON_GT] = ACTIONS(2976),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2976),
    [anon_sym_for] = ACTIONS(2974),
    [anon_sym_while] = ACTIONS(2974),
    [anon_sym_if] = ACTIONS(2974),
    [anon_sym_fun] = ACTIONS(2974),
    [anon_sym_try] = ACTIONS(2974),
    [anon_sym_match] = ACTIONS(2974),
    [anon_sym_match_BANG] = ACTIONS(2976),
    [anon_sym_function] = ACTIONS(2974),
    [anon_sym_LT_DASH] = ACTIONS(2974),
    [anon_sym_DOT_LBRACK] = ACTIONS(2976),
    [anon_sym_LT] = ACTIONS(2976),
    [anon_sym_use] = ACTIONS(2974),
    [anon_sym_use_BANG] = ACTIONS(2976),
    [anon_sym_do_BANG] = ACTIONS(2976),
    [anon_sym_begin] = ACTIONS(2974),
    [anon_sym_LPAREN2] = ACTIONS(2974),
    [anon_sym_DOT_DOT2] = ACTIONS(2976),
    [anon_sym_default] = ACTIONS(2974),
    [anon_sym_or] = ACTIONS(2974),
    [anon_sym_static] = ACTIONS(2974),
    [anon_sym_member] = ACTIONS(2974),
    [anon_sym_abstract] = ACTIONS(2974),
    [anon_sym_val] = ACTIONS(2974),
    [anon_sym_override] = ACTIONS(2974),
    [aux_sym_char_token1] = ACTIONS(2976),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2974),
    [anon_sym_DQUOTE] = ACTIONS(2974),
    [anon_sym_AT_DQUOTE] = ACTIONS(2976),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2976),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2976),
    [sym_bool] = ACTIONS(2974),
    [sym_unit] = ACTIONS(2976),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2974),
    [sym_op_identifier] = ACTIONS(2974),
    [anon_sym_PLUS] = ACTIONS(2974),
    [anon_sym_DASH] = ACTIONS(2974),
    [anon_sym_PLUS_DOT] = ACTIONS(2974),
    [anon_sym_DASH_DOT] = ACTIONS(2974),
    [anon_sym_PERCENT] = ACTIONS(2974),
    [anon_sym_AMP_AMP] = ACTIONS(2974),
    [anon_sym_TILDE] = ACTIONS(2976),
    [aux_sym_prefix_op_token1] = ACTIONS(2974),
    [aux_sym_infix_op_token1] = ACTIONS(2976),
    [aux_sym_infix_op_token2] = ACTIONS(2974),
    [anon_sym_PIPE_PIPE] = ACTIONS(2974),
    [anon_sym_BANG_EQ] = ACTIONS(2974),
    [anon_sym_COLON_EQ] = ACTIONS(2976),
    [anon_sym_DOLLAR] = ACTIONS(2974),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2974),
    [sym_int] = ACTIONS(2974),
    [sym_xint] = ACTIONS(2976),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2976),
    [sym__newline] = ACTIONS(2976),
    [sym__dedent] = ACTIONS(2976),
  },
  [901] = {
    [sym_block_comment] = STATE(901),
    [sym_compiler_directive_decl] = STATE(901),
    [sym_fsi_directive_decl] = STATE(901),
    [sym_preproc_line] = STATE(901),
    [sym_identifier] = ACTIONS(2978),
    [anon_sym_EQ] = ACTIONS(2980),
    [anon_sym_LBRACK_LT] = ACTIONS(2980),
    [anon_sym_COLON] = ACTIONS(2978),
    [anon_sym_return] = ACTIONS(2978),
    [anon_sym_do] = ACTIONS(2978),
    [anon_sym_let] = ACTIONS(2978),
    [anon_sym_let_BANG] = ACTIONS(2980),
    [aux_sym_access_modifier_token1] = ACTIONS(2980),
    [anon_sym_LPAREN] = ACTIONS(2978),
    [anon_sym_COMMA] = ACTIONS(2980),
    [anon_sym_null] = ACTIONS(2978),
    [anon_sym_QMARK] = ACTIONS(2978),
    [anon_sym_COLON_QMARK] = ACTIONS(2978),
    [anon_sym_COLON_COLON] = ACTIONS(2980),
    [anon_sym_AMP] = ACTIONS(2978),
    [anon_sym_LBRACK] = ACTIONS(2978),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2980),
    [anon_sym_LBRACE] = ACTIONS(2978),
    [anon_sym_LT_AT] = ACTIONS(2978),
    [anon_sym_LT_AT_AT] = ACTIONS(2978),
    [anon_sym_DOT] = ACTIONS(2978),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2980),
    [anon_sym_new] = ACTIONS(2978),
    [anon_sym_with] = ACTIONS(2978),
    [anon_sym_return_BANG] = ACTIONS(2980),
    [anon_sym_yield] = ACTIONS(2978),
    [anon_sym_yield_BANG] = ACTIONS(2980),
    [anon_sym_lazy] = ACTIONS(2978),
    [anon_sym_assert] = ACTIONS(2978),
    [anon_sym_upcast] = ACTIONS(2978),
    [anon_sym_downcast] = ACTIONS(2978),
    [anon_sym_COLON_GT] = ACTIONS(2980),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2980),
    [anon_sym_for] = ACTIONS(2978),
    [anon_sym_while] = ACTIONS(2978),
    [anon_sym_if] = ACTIONS(2978),
    [anon_sym_fun] = ACTIONS(2978),
    [anon_sym_try] = ACTIONS(2978),
    [anon_sym_match] = ACTIONS(2978),
    [anon_sym_match_BANG] = ACTIONS(2980),
    [anon_sym_function] = ACTIONS(2978),
    [anon_sym_LT_DASH] = ACTIONS(2978),
    [anon_sym_DOT_LBRACK] = ACTIONS(2980),
    [anon_sym_LT] = ACTIONS(2980),
    [anon_sym_use] = ACTIONS(2978),
    [anon_sym_use_BANG] = ACTIONS(2980),
    [anon_sym_do_BANG] = ACTIONS(2980),
    [anon_sym_begin] = ACTIONS(2978),
    [anon_sym_LPAREN2] = ACTIONS(2978),
    [anon_sym_DOT_DOT2] = ACTIONS(2980),
    [anon_sym_default] = ACTIONS(2978),
    [anon_sym_or] = ACTIONS(2978),
    [anon_sym_static] = ACTIONS(2978),
    [anon_sym_member] = ACTIONS(2978),
    [anon_sym_abstract] = ACTIONS(2978),
    [anon_sym_val] = ACTIONS(2978),
    [anon_sym_override] = ACTIONS(2978),
    [aux_sym_char_token1] = ACTIONS(2980),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2978),
    [anon_sym_DQUOTE] = ACTIONS(2978),
    [anon_sym_AT_DQUOTE] = ACTIONS(2980),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2980),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2980),
    [sym_bool] = ACTIONS(2978),
    [sym_unit] = ACTIONS(2980),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2978),
    [sym_op_identifier] = ACTIONS(2978),
    [anon_sym_PLUS] = ACTIONS(2978),
    [anon_sym_DASH] = ACTIONS(2978),
    [anon_sym_PLUS_DOT] = ACTIONS(2978),
    [anon_sym_DASH_DOT] = ACTIONS(2978),
    [anon_sym_PERCENT] = ACTIONS(2978),
    [anon_sym_AMP_AMP] = ACTIONS(2978),
    [anon_sym_TILDE] = ACTIONS(2980),
    [aux_sym_prefix_op_token1] = ACTIONS(2978),
    [aux_sym_infix_op_token1] = ACTIONS(2980),
    [aux_sym_infix_op_token2] = ACTIONS(2978),
    [anon_sym_PIPE_PIPE] = ACTIONS(2978),
    [anon_sym_BANG_EQ] = ACTIONS(2978),
    [anon_sym_COLON_EQ] = ACTIONS(2980),
    [anon_sym_DOLLAR] = ACTIONS(2978),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2978),
    [sym_int] = ACTIONS(2978),
    [sym_xint] = ACTIONS(2980),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2980),
    [sym__newline] = ACTIONS(2980),
    [sym__dedent] = ACTIONS(2980),
  },
  [902] = {
    [sym_block_comment] = STATE(902),
    [sym_compiler_directive_decl] = STATE(902),
    [sym_fsi_directive_decl] = STATE(902),
    [sym_preproc_line] = STATE(902),
    [sym_identifier] = ACTIONS(2557),
    [anon_sym_EQ] = ACTIONS(2559),
    [anon_sym_GT_RBRACK] = ACTIONS(2559),
    [anon_sym_COLON] = ACTIONS(2557),
    [anon_sym_return] = ACTIONS(2557),
    [anon_sym_do] = ACTIONS(2557),
    [anon_sym_let] = ACTIONS(2557),
    [anon_sym_let_BANG] = ACTIONS(2559),
    [anon_sym_LPAREN] = ACTIONS(2557),
    [anon_sym_COMMA] = ACTIONS(2559),
    [anon_sym_null] = ACTIONS(2557),
    [anon_sym_QMARK] = ACTIONS(2557),
    [anon_sym_COLON_QMARK] = ACTIONS(2557),
    [anon_sym_COLON_COLON] = ACTIONS(2559),
    [anon_sym_AMP] = ACTIONS(2557),
    [anon_sym_LBRACK] = ACTIONS(2557),
    [anon_sym_RBRACK] = ACTIONS(2559),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2559),
    [anon_sym_LBRACE] = ACTIONS(2557),
    [anon_sym_RBRACE] = ACTIONS(2559),
    [anon_sym_LT_AT] = ACTIONS(2557),
    [anon_sym_LT_AT_AT] = ACTIONS(2557),
    [anon_sym_DOT] = ACTIONS(2557),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2559),
    [anon_sym_new] = ACTIONS(2557),
    [anon_sym_with] = ACTIONS(2557),
    [anon_sym_return_BANG] = ACTIONS(2559),
    [anon_sym_yield] = ACTIONS(2557),
    [anon_sym_yield_BANG] = ACTIONS(2559),
    [anon_sym_lazy] = ACTIONS(2557),
    [anon_sym_assert] = ACTIONS(2557),
    [anon_sym_upcast] = ACTIONS(2557),
    [anon_sym_downcast] = ACTIONS(2557),
    [anon_sym_COLON_GT] = ACTIONS(2559),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2559),
    [anon_sym_for] = ACTIONS(2557),
    [anon_sym_to] = ACTIONS(2557),
    [anon_sym_downto] = ACTIONS(2557),
    [anon_sym_while] = ACTIONS(2557),
    [anon_sym_if] = ACTIONS(2557),
    [anon_sym_fun] = ACTIONS(2557),
    [anon_sym_DASH_GT] = ACTIONS(2557),
    [anon_sym_try] = ACTIONS(2557),
    [anon_sym_match] = ACTIONS(2557),
    [anon_sym_match_BANG] = ACTIONS(2559),
    [anon_sym_function] = ACTIONS(2557),
    [anon_sym_LT_DASH] = ACTIONS(2557),
    [anon_sym_DOT_LBRACK] = ACTIONS(2559),
    [anon_sym_LT] = ACTIONS(2559),
    [anon_sym_use] = ACTIONS(2557),
    [anon_sym_use_BANG] = ACTIONS(2559),
    [anon_sym_do_BANG] = ACTIONS(2559),
    [anon_sym_begin] = ACTIONS(2557),
    [anon_sym_LPAREN2] = ACTIONS(2557),
    [anon_sym_DOT_DOT2] = ACTIONS(2559),
    [anon_sym_STAR] = ACTIONS(2557),
    [anon_sym_LT2] = ACTIONS(2982),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2559),
    [anon_sym_or] = ACTIONS(2557),
    [aux_sym_char_token1] = ACTIONS(2559),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2557),
    [anon_sym_DQUOTE] = ACTIONS(2557),
    [anon_sym_AT_DQUOTE] = ACTIONS(2559),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2559),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2559),
    [sym_bool] = ACTIONS(2557),
    [sym_unit] = ACTIONS(2559),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2557),
    [sym_op_identifier] = ACTIONS(2557),
    [anon_sym_PLUS] = ACTIONS(2557),
    [anon_sym_DASH] = ACTIONS(2557),
    [anon_sym_PLUS_DOT] = ACTIONS(2557),
    [anon_sym_DASH_DOT] = ACTIONS(2557),
    [anon_sym_PERCENT] = ACTIONS(2557),
    [anon_sym_AMP_AMP] = ACTIONS(2557),
    [anon_sym_TILDE] = ACTIONS(2559),
    [aux_sym_prefix_op_token1] = ACTIONS(2557),
    [aux_sym_infix_op_token1] = ACTIONS(2559),
    [aux_sym_infix_op_token2] = ACTIONS(2557),
    [anon_sym_PIPE_PIPE] = ACTIONS(2557),
    [anon_sym_BANG_EQ] = ACTIONS(2557),
    [anon_sym_COLON_EQ] = ACTIONS(2559),
    [anon_sym_DOLLAR] = ACTIONS(2557),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2557),
    [sym_int] = ACTIONS(2557),
    [sym_xint] = ACTIONS(2559),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2559),
    [sym__newline] = ACTIONS(2559),
  },
  [903] = {
    [sym_block_comment] = STATE(903),
    [sym_compiler_directive_decl] = STATE(903),
    [sym_fsi_directive_decl] = STATE(903),
    [sym_preproc_line] = STATE(903),
    [sym_identifier] = ACTIONS(2984),
    [anon_sym_EQ] = ACTIONS(2986),
    [anon_sym_LBRACK_LT] = ACTIONS(2986),
    [anon_sym_COLON] = ACTIONS(2984),
    [anon_sym_return] = ACTIONS(2984),
    [anon_sym_do] = ACTIONS(2984),
    [anon_sym_let] = ACTIONS(2984),
    [anon_sym_let_BANG] = ACTIONS(2986),
    [aux_sym_access_modifier_token1] = ACTIONS(2986),
    [anon_sym_LPAREN] = ACTIONS(2984),
    [anon_sym_COMMA] = ACTIONS(2986),
    [anon_sym_null] = ACTIONS(2984),
    [anon_sym_QMARK] = ACTIONS(2984),
    [anon_sym_COLON_QMARK] = ACTIONS(2984),
    [anon_sym_COLON_COLON] = ACTIONS(2986),
    [anon_sym_AMP] = ACTIONS(2984),
    [anon_sym_LBRACK] = ACTIONS(2984),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2986),
    [anon_sym_LBRACE] = ACTIONS(2984),
    [anon_sym_LT_AT] = ACTIONS(2984),
    [anon_sym_LT_AT_AT] = ACTIONS(2984),
    [anon_sym_DOT] = ACTIONS(2984),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2986),
    [anon_sym_new] = ACTIONS(2984),
    [anon_sym_with] = ACTIONS(2984),
    [anon_sym_return_BANG] = ACTIONS(2986),
    [anon_sym_yield] = ACTIONS(2984),
    [anon_sym_yield_BANG] = ACTIONS(2986),
    [anon_sym_lazy] = ACTIONS(2984),
    [anon_sym_assert] = ACTIONS(2984),
    [anon_sym_upcast] = ACTIONS(2984),
    [anon_sym_downcast] = ACTIONS(2984),
    [anon_sym_COLON_GT] = ACTIONS(2986),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2986),
    [anon_sym_for] = ACTIONS(2984),
    [anon_sym_while] = ACTIONS(2984),
    [anon_sym_if] = ACTIONS(2984),
    [anon_sym_fun] = ACTIONS(2984),
    [anon_sym_try] = ACTIONS(2984),
    [anon_sym_match] = ACTIONS(2984),
    [anon_sym_match_BANG] = ACTIONS(2986),
    [anon_sym_function] = ACTIONS(2984),
    [anon_sym_LT_DASH] = ACTIONS(2984),
    [anon_sym_DOT_LBRACK] = ACTIONS(2986),
    [anon_sym_LT] = ACTIONS(2986),
    [anon_sym_use] = ACTIONS(2984),
    [anon_sym_use_BANG] = ACTIONS(2986),
    [anon_sym_do_BANG] = ACTIONS(2986),
    [anon_sym_begin] = ACTIONS(2984),
    [anon_sym_LPAREN2] = ACTIONS(2984),
    [anon_sym_DOT_DOT2] = ACTIONS(2986),
    [anon_sym_default] = ACTIONS(2984),
    [anon_sym_or] = ACTIONS(2984),
    [anon_sym_static] = ACTIONS(2984),
    [anon_sym_member] = ACTIONS(2984),
    [anon_sym_abstract] = ACTIONS(2984),
    [anon_sym_val] = ACTIONS(2984),
    [anon_sym_override] = ACTIONS(2984),
    [aux_sym_char_token1] = ACTIONS(2986),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2984),
    [anon_sym_DQUOTE] = ACTIONS(2984),
    [anon_sym_AT_DQUOTE] = ACTIONS(2986),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2986),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2986),
    [sym_bool] = ACTIONS(2984),
    [sym_unit] = ACTIONS(2986),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2984),
    [sym_op_identifier] = ACTIONS(2984),
    [anon_sym_PLUS] = ACTIONS(2984),
    [anon_sym_DASH] = ACTIONS(2984),
    [anon_sym_PLUS_DOT] = ACTIONS(2984),
    [anon_sym_DASH_DOT] = ACTIONS(2984),
    [anon_sym_PERCENT] = ACTIONS(2984),
    [anon_sym_AMP_AMP] = ACTIONS(2984),
    [anon_sym_TILDE] = ACTIONS(2986),
    [aux_sym_prefix_op_token1] = ACTIONS(2984),
    [aux_sym_infix_op_token1] = ACTIONS(2986),
    [aux_sym_infix_op_token2] = ACTIONS(2984),
    [anon_sym_PIPE_PIPE] = ACTIONS(2984),
    [anon_sym_BANG_EQ] = ACTIONS(2984),
    [anon_sym_COLON_EQ] = ACTIONS(2986),
    [anon_sym_DOLLAR] = ACTIONS(2984),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2984),
    [sym_int] = ACTIONS(2984),
    [sym_xint] = ACTIONS(2986),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2986),
    [sym__newline] = ACTIONS(2986),
    [sym__dedent] = ACTIONS(2986),
  },
  [904] = {
    [sym_block_comment] = STATE(904),
    [sym_compiler_directive_decl] = STATE(904),
    [sym_fsi_directive_decl] = STATE(904),
    [sym_preproc_line] = STATE(904),
    [sym_identifier] = ACTIONS(2567),
    [anon_sym_EQ] = ACTIONS(2569),
    [anon_sym_GT_RBRACK] = ACTIONS(2569),
    [anon_sym_COLON] = ACTIONS(2567),
    [anon_sym_return] = ACTIONS(2567),
    [anon_sym_do] = ACTIONS(2567),
    [anon_sym_let] = ACTIONS(2567),
    [anon_sym_let_BANG] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2567),
    [anon_sym_COMMA] = ACTIONS(2569),
    [anon_sym_null] = ACTIONS(2567),
    [anon_sym_QMARK] = ACTIONS(2567),
    [anon_sym_COLON_QMARK] = ACTIONS(2567),
    [anon_sym_COLON_COLON] = ACTIONS(2569),
    [anon_sym_AMP] = ACTIONS(2567),
    [anon_sym_LBRACK] = ACTIONS(2567),
    [anon_sym_RBRACK] = ACTIONS(2569),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2569),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_RBRACE] = ACTIONS(2569),
    [anon_sym_LT_AT] = ACTIONS(2567),
    [anon_sym_LT_AT_AT] = ACTIONS(2567),
    [anon_sym_DOT] = ACTIONS(2567),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2569),
    [anon_sym_new] = ACTIONS(2567),
    [anon_sym_with] = ACTIONS(2567),
    [anon_sym_return_BANG] = ACTIONS(2569),
    [anon_sym_yield] = ACTIONS(2567),
    [anon_sym_yield_BANG] = ACTIONS(2569),
    [anon_sym_lazy] = ACTIONS(2567),
    [anon_sym_assert] = ACTIONS(2567),
    [anon_sym_upcast] = ACTIONS(2567),
    [anon_sym_downcast] = ACTIONS(2567),
    [anon_sym_COLON_GT] = ACTIONS(2569),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2569),
    [anon_sym_for] = ACTIONS(2567),
    [anon_sym_to] = ACTIONS(2567),
    [anon_sym_downto] = ACTIONS(2567),
    [anon_sym_while] = ACTIONS(2567),
    [anon_sym_if] = ACTIONS(2567),
    [anon_sym_fun] = ACTIONS(2567),
    [anon_sym_DASH_GT] = ACTIONS(2567),
    [anon_sym_try] = ACTIONS(2567),
    [anon_sym_match] = ACTIONS(2567),
    [anon_sym_match_BANG] = ACTIONS(2569),
    [anon_sym_function] = ACTIONS(2567),
    [anon_sym_LT_DASH] = ACTIONS(2567),
    [anon_sym_DOT_LBRACK] = ACTIONS(2569),
    [anon_sym_LT] = ACTIONS(2569),
    [anon_sym_use] = ACTIONS(2567),
    [anon_sym_use_BANG] = ACTIONS(2569),
    [anon_sym_do_BANG] = ACTIONS(2569),
    [anon_sym_begin] = ACTIONS(2567),
    [anon_sym_LPAREN2] = ACTIONS(2567),
    [anon_sym_DOT_DOT2] = ACTIONS(2569),
    [anon_sym_STAR] = ACTIONS(2567),
    [anon_sym_LT2] = ACTIONS(2567),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2569),
    [anon_sym_or] = ACTIONS(2567),
    [aux_sym_char_token1] = ACTIONS(2569),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2567),
    [anon_sym_DQUOTE] = ACTIONS(2567),
    [anon_sym_AT_DQUOTE] = ACTIONS(2569),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2569),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2569),
    [sym_bool] = ACTIONS(2567),
    [sym_unit] = ACTIONS(2569),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2567),
    [sym_op_identifier] = ACTIONS(2567),
    [anon_sym_PLUS] = ACTIONS(2567),
    [anon_sym_DASH] = ACTIONS(2567),
    [anon_sym_PLUS_DOT] = ACTIONS(2567),
    [anon_sym_DASH_DOT] = ACTIONS(2567),
    [anon_sym_PERCENT] = ACTIONS(2567),
    [anon_sym_AMP_AMP] = ACTIONS(2567),
    [anon_sym_TILDE] = ACTIONS(2569),
    [aux_sym_prefix_op_token1] = ACTIONS(2567),
    [aux_sym_infix_op_token1] = ACTIONS(2569),
    [aux_sym_infix_op_token2] = ACTIONS(2567),
    [anon_sym_PIPE_PIPE] = ACTIONS(2567),
    [anon_sym_BANG_EQ] = ACTIONS(2567),
    [anon_sym_COLON_EQ] = ACTIONS(2569),
    [anon_sym_DOLLAR] = ACTIONS(2567),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2567),
    [sym_int] = ACTIONS(2567),
    [sym_xint] = ACTIONS(2569),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2569),
    [sym__newline] = ACTIONS(2569),
  },
  [905] = {
    [sym_block_comment] = STATE(905),
    [sym_compiler_directive_decl] = STATE(905),
    [sym_fsi_directive_decl] = STATE(905),
    [sym_preproc_line] = STATE(905),
    [sym_identifier] = ACTIONS(2988),
    [anon_sym_EQ] = ACTIONS(2990),
    [anon_sym_LBRACK_LT] = ACTIONS(2990),
    [anon_sym_COLON] = ACTIONS(2988),
    [anon_sym_return] = ACTIONS(2988),
    [anon_sym_do] = ACTIONS(2988),
    [anon_sym_let] = ACTIONS(2988),
    [anon_sym_let_BANG] = ACTIONS(2990),
    [aux_sym_access_modifier_token1] = ACTIONS(2990),
    [anon_sym_LPAREN] = ACTIONS(2988),
    [anon_sym_COMMA] = ACTIONS(2990),
    [anon_sym_null] = ACTIONS(2988),
    [anon_sym_QMARK] = ACTIONS(2988),
    [anon_sym_COLON_QMARK] = ACTIONS(2988),
    [anon_sym_COLON_COLON] = ACTIONS(2990),
    [anon_sym_AMP] = ACTIONS(2988),
    [anon_sym_LBRACK] = ACTIONS(2988),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2990),
    [anon_sym_LBRACE] = ACTIONS(2988),
    [anon_sym_LT_AT] = ACTIONS(2988),
    [anon_sym_LT_AT_AT] = ACTIONS(2988),
    [anon_sym_DOT] = ACTIONS(2988),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2990),
    [anon_sym_new] = ACTIONS(2988),
    [anon_sym_with] = ACTIONS(2988),
    [anon_sym_return_BANG] = ACTIONS(2990),
    [anon_sym_yield] = ACTIONS(2988),
    [anon_sym_yield_BANG] = ACTIONS(2990),
    [anon_sym_lazy] = ACTIONS(2988),
    [anon_sym_assert] = ACTIONS(2988),
    [anon_sym_upcast] = ACTIONS(2988),
    [anon_sym_downcast] = ACTIONS(2988),
    [anon_sym_COLON_GT] = ACTIONS(2990),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2990),
    [anon_sym_for] = ACTIONS(2988),
    [anon_sym_while] = ACTIONS(2988),
    [anon_sym_if] = ACTIONS(2988),
    [anon_sym_fun] = ACTIONS(2988),
    [anon_sym_try] = ACTIONS(2988),
    [anon_sym_match] = ACTIONS(2988),
    [anon_sym_match_BANG] = ACTIONS(2990),
    [anon_sym_function] = ACTIONS(2988),
    [anon_sym_LT_DASH] = ACTIONS(2988),
    [anon_sym_DOT_LBRACK] = ACTIONS(2990),
    [anon_sym_LT] = ACTIONS(2990),
    [anon_sym_use] = ACTIONS(2988),
    [anon_sym_use_BANG] = ACTIONS(2990),
    [anon_sym_do_BANG] = ACTIONS(2990),
    [anon_sym_begin] = ACTIONS(2988),
    [anon_sym_LPAREN2] = ACTIONS(2988),
    [anon_sym_DOT_DOT2] = ACTIONS(2990),
    [anon_sym_default] = ACTIONS(2988),
    [anon_sym_or] = ACTIONS(2988),
    [anon_sym_static] = ACTIONS(2988),
    [anon_sym_member] = ACTIONS(2988),
    [anon_sym_abstract] = ACTIONS(2988),
    [anon_sym_val] = ACTIONS(2988),
    [anon_sym_override] = ACTIONS(2988),
    [aux_sym_char_token1] = ACTIONS(2990),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2988),
    [anon_sym_DQUOTE] = ACTIONS(2988),
    [anon_sym_AT_DQUOTE] = ACTIONS(2990),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2990),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2990),
    [sym_bool] = ACTIONS(2988),
    [sym_unit] = ACTIONS(2990),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2988),
    [sym_op_identifier] = ACTIONS(2988),
    [anon_sym_PLUS] = ACTIONS(2988),
    [anon_sym_DASH] = ACTIONS(2988),
    [anon_sym_PLUS_DOT] = ACTIONS(2988),
    [anon_sym_DASH_DOT] = ACTIONS(2988),
    [anon_sym_PERCENT] = ACTIONS(2988),
    [anon_sym_AMP_AMP] = ACTIONS(2988),
    [anon_sym_TILDE] = ACTIONS(2990),
    [aux_sym_prefix_op_token1] = ACTIONS(2988),
    [aux_sym_infix_op_token1] = ACTIONS(2990),
    [aux_sym_infix_op_token2] = ACTIONS(2988),
    [anon_sym_PIPE_PIPE] = ACTIONS(2988),
    [anon_sym_BANG_EQ] = ACTIONS(2988),
    [anon_sym_COLON_EQ] = ACTIONS(2990),
    [anon_sym_DOLLAR] = ACTIONS(2988),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2988),
    [sym_int] = ACTIONS(2988),
    [sym_xint] = ACTIONS(2990),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2990),
    [sym__newline] = ACTIONS(2990),
    [sym__dedent] = ACTIONS(2990),
  },
  [906] = {
    [sym_block_comment] = STATE(906),
    [sym_compiler_directive_decl] = STATE(906),
    [sym_fsi_directive_decl] = STATE(906),
    [sym_preproc_line] = STATE(906),
    [sym_identifier] = ACTIONS(2992),
    [anon_sym_EQ] = ACTIONS(2994),
    [anon_sym_LBRACK_LT] = ACTIONS(2994),
    [anon_sym_COLON] = ACTIONS(2992),
    [anon_sym_return] = ACTIONS(2992),
    [anon_sym_do] = ACTIONS(2992),
    [anon_sym_let] = ACTIONS(2992),
    [anon_sym_let_BANG] = ACTIONS(2994),
    [aux_sym_access_modifier_token1] = ACTIONS(2994),
    [anon_sym_LPAREN] = ACTIONS(2992),
    [anon_sym_COMMA] = ACTIONS(2994),
    [anon_sym_null] = ACTIONS(2992),
    [anon_sym_QMARK] = ACTIONS(2992),
    [anon_sym_COLON_QMARK] = ACTIONS(2992),
    [anon_sym_COLON_COLON] = ACTIONS(2994),
    [anon_sym_AMP] = ACTIONS(2992),
    [anon_sym_LBRACK] = ACTIONS(2992),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2994),
    [anon_sym_LBRACE] = ACTIONS(2992),
    [anon_sym_LT_AT] = ACTIONS(2992),
    [anon_sym_LT_AT_AT] = ACTIONS(2992),
    [anon_sym_DOT] = ACTIONS(2992),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2994),
    [anon_sym_new] = ACTIONS(2992),
    [anon_sym_with] = ACTIONS(2992),
    [anon_sym_return_BANG] = ACTIONS(2994),
    [anon_sym_yield] = ACTIONS(2992),
    [anon_sym_yield_BANG] = ACTIONS(2994),
    [anon_sym_lazy] = ACTIONS(2992),
    [anon_sym_assert] = ACTIONS(2992),
    [anon_sym_upcast] = ACTIONS(2992),
    [anon_sym_downcast] = ACTIONS(2992),
    [anon_sym_COLON_GT] = ACTIONS(2994),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2994),
    [anon_sym_for] = ACTIONS(2992),
    [anon_sym_while] = ACTIONS(2992),
    [anon_sym_if] = ACTIONS(2992),
    [anon_sym_fun] = ACTIONS(2992),
    [anon_sym_try] = ACTIONS(2992),
    [anon_sym_match] = ACTIONS(2992),
    [anon_sym_match_BANG] = ACTIONS(2994),
    [anon_sym_function] = ACTIONS(2992),
    [anon_sym_LT_DASH] = ACTIONS(2992),
    [anon_sym_DOT_LBRACK] = ACTIONS(2994),
    [anon_sym_LT] = ACTIONS(2994),
    [anon_sym_use] = ACTIONS(2992),
    [anon_sym_use_BANG] = ACTIONS(2994),
    [anon_sym_do_BANG] = ACTIONS(2994),
    [anon_sym_begin] = ACTIONS(2992),
    [anon_sym_LPAREN2] = ACTIONS(2992),
    [anon_sym_DOT_DOT2] = ACTIONS(2994),
    [anon_sym_default] = ACTIONS(2992),
    [anon_sym_or] = ACTIONS(2992),
    [anon_sym_static] = ACTIONS(2992),
    [anon_sym_member] = ACTIONS(2992),
    [anon_sym_abstract] = ACTIONS(2992),
    [anon_sym_val] = ACTIONS(2992),
    [anon_sym_override] = ACTIONS(2992),
    [aux_sym_char_token1] = ACTIONS(2994),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2992),
    [anon_sym_DQUOTE] = ACTIONS(2992),
    [anon_sym_AT_DQUOTE] = ACTIONS(2994),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2994),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2994),
    [sym_bool] = ACTIONS(2992),
    [sym_unit] = ACTIONS(2994),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2992),
    [sym_op_identifier] = ACTIONS(2992),
    [anon_sym_PLUS] = ACTIONS(2992),
    [anon_sym_DASH] = ACTIONS(2992),
    [anon_sym_PLUS_DOT] = ACTIONS(2992),
    [anon_sym_DASH_DOT] = ACTIONS(2992),
    [anon_sym_PERCENT] = ACTIONS(2992),
    [anon_sym_AMP_AMP] = ACTIONS(2992),
    [anon_sym_TILDE] = ACTIONS(2994),
    [aux_sym_prefix_op_token1] = ACTIONS(2992),
    [aux_sym_infix_op_token1] = ACTIONS(2994),
    [aux_sym_infix_op_token2] = ACTIONS(2992),
    [anon_sym_PIPE_PIPE] = ACTIONS(2992),
    [anon_sym_BANG_EQ] = ACTIONS(2992),
    [anon_sym_COLON_EQ] = ACTIONS(2994),
    [anon_sym_DOLLAR] = ACTIONS(2992),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2992),
    [sym_int] = ACTIONS(2992),
    [sym_xint] = ACTIONS(2994),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2994),
    [sym__newline] = ACTIONS(2994),
    [sym__dedent] = ACTIONS(2994),
  },
  [907] = {
    [sym_block_comment] = STATE(907),
    [sym_compiler_directive_decl] = STATE(907),
    [sym_fsi_directive_decl] = STATE(907),
    [sym_preproc_line] = STATE(907),
    [sym_identifier] = ACTIONS(2996),
    [anon_sym_EQ] = ACTIONS(2998),
    [anon_sym_LBRACK_LT] = ACTIONS(2998),
    [anon_sym_COLON] = ACTIONS(2996),
    [anon_sym_return] = ACTIONS(2996),
    [anon_sym_do] = ACTIONS(2996),
    [anon_sym_let] = ACTIONS(2996),
    [anon_sym_let_BANG] = ACTIONS(2998),
    [aux_sym_access_modifier_token1] = ACTIONS(2998),
    [anon_sym_LPAREN] = ACTIONS(2996),
    [anon_sym_COMMA] = ACTIONS(2998),
    [anon_sym_null] = ACTIONS(2996),
    [anon_sym_QMARK] = ACTIONS(2996),
    [anon_sym_COLON_QMARK] = ACTIONS(2996),
    [anon_sym_COLON_COLON] = ACTIONS(2998),
    [anon_sym_AMP] = ACTIONS(2996),
    [anon_sym_LBRACK] = ACTIONS(2996),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2998),
    [anon_sym_LBRACE] = ACTIONS(2996),
    [anon_sym_LT_AT] = ACTIONS(2996),
    [anon_sym_LT_AT_AT] = ACTIONS(2996),
    [anon_sym_DOT] = ACTIONS(2996),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2998),
    [anon_sym_new] = ACTIONS(2996),
    [anon_sym_with] = ACTIONS(2996),
    [anon_sym_return_BANG] = ACTIONS(2998),
    [anon_sym_yield] = ACTIONS(2996),
    [anon_sym_yield_BANG] = ACTIONS(2998),
    [anon_sym_lazy] = ACTIONS(2996),
    [anon_sym_assert] = ACTIONS(2996),
    [anon_sym_upcast] = ACTIONS(2996),
    [anon_sym_downcast] = ACTIONS(2996),
    [anon_sym_COLON_GT] = ACTIONS(2998),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2998),
    [anon_sym_for] = ACTIONS(2996),
    [anon_sym_while] = ACTIONS(2996),
    [anon_sym_if] = ACTIONS(2996),
    [anon_sym_fun] = ACTIONS(2996),
    [anon_sym_try] = ACTIONS(2996),
    [anon_sym_match] = ACTIONS(2996),
    [anon_sym_match_BANG] = ACTIONS(2998),
    [anon_sym_function] = ACTIONS(2996),
    [anon_sym_LT_DASH] = ACTIONS(2996),
    [anon_sym_DOT_LBRACK] = ACTIONS(2998),
    [anon_sym_LT] = ACTIONS(2998),
    [anon_sym_use] = ACTIONS(2996),
    [anon_sym_use_BANG] = ACTIONS(2998),
    [anon_sym_do_BANG] = ACTIONS(2998),
    [anon_sym_begin] = ACTIONS(2996),
    [anon_sym_LPAREN2] = ACTIONS(2996),
    [anon_sym_DOT_DOT2] = ACTIONS(2998),
    [anon_sym_default] = ACTIONS(2996),
    [anon_sym_or] = ACTIONS(2996),
    [anon_sym_static] = ACTIONS(2996),
    [anon_sym_member] = ACTIONS(2996),
    [anon_sym_abstract] = ACTIONS(2996),
    [anon_sym_val] = ACTIONS(2996),
    [anon_sym_override] = ACTIONS(2996),
    [aux_sym_char_token1] = ACTIONS(2998),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2996),
    [anon_sym_DQUOTE] = ACTIONS(2996),
    [anon_sym_AT_DQUOTE] = ACTIONS(2998),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2998),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2998),
    [sym_bool] = ACTIONS(2996),
    [sym_unit] = ACTIONS(2998),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2996),
    [sym_op_identifier] = ACTIONS(2996),
    [anon_sym_PLUS] = ACTIONS(2996),
    [anon_sym_DASH] = ACTIONS(2996),
    [anon_sym_PLUS_DOT] = ACTIONS(2996),
    [anon_sym_DASH_DOT] = ACTIONS(2996),
    [anon_sym_PERCENT] = ACTIONS(2996),
    [anon_sym_AMP_AMP] = ACTIONS(2996),
    [anon_sym_TILDE] = ACTIONS(2998),
    [aux_sym_prefix_op_token1] = ACTIONS(2996),
    [aux_sym_infix_op_token1] = ACTIONS(2998),
    [aux_sym_infix_op_token2] = ACTIONS(2996),
    [anon_sym_PIPE_PIPE] = ACTIONS(2996),
    [anon_sym_BANG_EQ] = ACTIONS(2996),
    [anon_sym_COLON_EQ] = ACTIONS(2998),
    [anon_sym_DOLLAR] = ACTIONS(2996),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2996),
    [sym_int] = ACTIONS(2996),
    [sym_xint] = ACTIONS(2998),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2998),
    [sym__newline] = ACTIONS(2998),
    [sym__dedent] = ACTIONS(2998),
  },
  [908] = {
    [sym_elif_expression] = STATE(985),
    [sym_block_comment] = STATE(908),
    [sym_compiler_directive_decl] = STATE(908),
    [sym_fsi_directive_decl] = STATE(908),
    [sym_preproc_line] = STATE(908),
    [aux_sym_if_expression_repeat1] = STATE(908),
    [sym_identifier] = ACTIONS(2518),
    [anon_sym_EQ] = ACTIONS(2520),
    [anon_sym_GT_RBRACK] = ACTIONS(2520),
    [anon_sym_COLON] = ACTIONS(2518),
    [anon_sym_return] = ACTIONS(2518),
    [anon_sym_do] = ACTIONS(2518),
    [anon_sym_let] = ACTIONS(2518),
    [anon_sym_let_BANG] = ACTIONS(2520),
    [anon_sym_LPAREN] = ACTIONS(2518),
    [anon_sym_COMMA] = ACTIONS(2520),
    [anon_sym_null] = ACTIONS(2518),
    [anon_sym_QMARK] = ACTIONS(2518),
    [anon_sym_COLON_QMARK] = ACTIONS(2518),
    [anon_sym_COLON_COLON] = ACTIONS(2520),
    [anon_sym_AMP] = ACTIONS(2518),
    [anon_sym_LBRACK] = ACTIONS(2518),
    [anon_sym_RBRACK] = ACTIONS(2520),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2520),
    [anon_sym_LBRACE] = ACTIONS(2518),
    [anon_sym_RBRACE] = ACTIONS(2520),
    [anon_sym_LT_AT] = ACTIONS(2518),
    [anon_sym_LT_AT_AT] = ACTIONS(2518),
    [anon_sym_DOT] = ACTIONS(2518),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2520),
    [anon_sym_new] = ACTIONS(2518),
    [anon_sym_with] = ACTIONS(2518),
    [anon_sym_return_BANG] = ACTIONS(2520),
    [anon_sym_yield] = ACTIONS(2518),
    [anon_sym_yield_BANG] = ACTIONS(2520),
    [anon_sym_lazy] = ACTIONS(2518),
    [anon_sym_assert] = ACTIONS(2518),
    [anon_sym_upcast] = ACTIONS(2518),
    [anon_sym_downcast] = ACTIONS(2518),
    [anon_sym_COLON_GT] = ACTIONS(2520),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2520),
    [anon_sym_for] = ACTIONS(2518),
    [anon_sym_to] = ACTIONS(2518),
    [anon_sym_downto] = ACTIONS(2518),
    [anon_sym_while] = ACTIONS(2518),
    [anon_sym_else] = ACTIONS(2518),
    [anon_sym_elif] = ACTIONS(3000),
    [anon_sym_if] = ACTIONS(2518),
    [anon_sym_fun] = ACTIONS(2518),
    [anon_sym_try] = ACTIONS(2518),
    [anon_sym_match] = ACTIONS(2518),
    [anon_sym_match_BANG] = ACTIONS(2520),
    [anon_sym_function] = ACTIONS(2518),
    [anon_sym_LT_DASH] = ACTIONS(2518),
    [anon_sym_DOT_LBRACK] = ACTIONS(2520),
    [anon_sym_LT] = ACTIONS(2520),
    [anon_sym_use] = ACTIONS(2518),
    [anon_sym_use_BANG] = ACTIONS(2520),
    [anon_sym_do_BANG] = ACTIONS(2520),
    [anon_sym_begin] = ACTIONS(2518),
    [anon_sym_LPAREN2] = ACTIONS(2518),
    [anon_sym_DOT_DOT2] = ACTIONS(2520),
    [anon_sym_or] = ACTIONS(2518),
    [aux_sym_char_token1] = ACTIONS(2520),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2518),
    [anon_sym_DQUOTE] = ACTIONS(2518),
    [anon_sym_AT_DQUOTE] = ACTIONS(2520),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2520),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2520),
    [sym_bool] = ACTIONS(2518),
    [sym_unit] = ACTIONS(2520),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2518),
    [sym_op_identifier] = ACTIONS(2518),
    [anon_sym_PLUS] = ACTIONS(2518),
    [anon_sym_DASH] = ACTIONS(2518),
    [anon_sym_PLUS_DOT] = ACTIONS(2518),
    [anon_sym_DASH_DOT] = ACTIONS(2518),
    [anon_sym_PERCENT] = ACTIONS(2518),
    [anon_sym_AMP_AMP] = ACTIONS(2518),
    [anon_sym_TILDE] = ACTIONS(2520),
    [aux_sym_prefix_op_token1] = ACTIONS(2518),
    [aux_sym_infix_op_token1] = ACTIONS(2520),
    [aux_sym_infix_op_token2] = ACTIONS(2518),
    [anon_sym_PIPE_PIPE] = ACTIONS(2518),
    [anon_sym_BANG_EQ] = ACTIONS(2518),
    [anon_sym_COLON_EQ] = ACTIONS(2520),
    [anon_sym_DOLLAR] = ACTIONS(2518),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2518),
    [sym_int] = ACTIONS(2518),
    [sym_xint] = ACTIONS(2520),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2520),
    [sym__newline] = ACTIONS(2520),
  },
  [909] = {
    [sym_block_comment] = STATE(909),
    [sym_compiler_directive_decl] = STATE(909),
    [sym_fsi_directive_decl] = STATE(909),
    [sym_preproc_line] = STATE(909),
    [sym_identifier] = ACTIONS(3003),
    [anon_sym_EQ] = ACTIONS(3005),
    [anon_sym_LBRACK_LT] = ACTIONS(3005),
    [anon_sym_COLON] = ACTIONS(3003),
    [anon_sym_return] = ACTIONS(3003),
    [anon_sym_do] = ACTIONS(3003),
    [anon_sym_let] = ACTIONS(3003),
    [anon_sym_let_BANG] = ACTIONS(3005),
    [aux_sym_access_modifier_token1] = ACTIONS(3005),
    [anon_sym_LPAREN] = ACTIONS(3003),
    [anon_sym_COMMA] = ACTIONS(3005),
    [anon_sym_null] = ACTIONS(3003),
    [anon_sym_QMARK] = ACTIONS(3003),
    [anon_sym_COLON_QMARK] = ACTIONS(3003),
    [anon_sym_COLON_COLON] = ACTIONS(3005),
    [anon_sym_AMP] = ACTIONS(3003),
    [anon_sym_LBRACK] = ACTIONS(3003),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3005),
    [anon_sym_LBRACE] = ACTIONS(3003),
    [anon_sym_LT_AT] = ACTIONS(3003),
    [anon_sym_LT_AT_AT] = ACTIONS(3003),
    [anon_sym_DOT] = ACTIONS(3003),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3005),
    [anon_sym_new] = ACTIONS(3003),
    [anon_sym_with] = ACTIONS(3003),
    [anon_sym_return_BANG] = ACTIONS(3005),
    [anon_sym_yield] = ACTIONS(3003),
    [anon_sym_yield_BANG] = ACTIONS(3005),
    [anon_sym_lazy] = ACTIONS(3003),
    [anon_sym_assert] = ACTIONS(3003),
    [anon_sym_upcast] = ACTIONS(3003),
    [anon_sym_downcast] = ACTIONS(3003),
    [anon_sym_COLON_GT] = ACTIONS(3005),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3005),
    [anon_sym_for] = ACTIONS(3003),
    [anon_sym_while] = ACTIONS(3003),
    [anon_sym_if] = ACTIONS(3003),
    [anon_sym_fun] = ACTIONS(3003),
    [anon_sym_try] = ACTIONS(3003),
    [anon_sym_match] = ACTIONS(3003),
    [anon_sym_match_BANG] = ACTIONS(3005),
    [anon_sym_function] = ACTIONS(3003),
    [anon_sym_LT_DASH] = ACTIONS(3003),
    [anon_sym_DOT_LBRACK] = ACTIONS(3005),
    [anon_sym_LT] = ACTIONS(3005),
    [anon_sym_use] = ACTIONS(3003),
    [anon_sym_use_BANG] = ACTIONS(3005),
    [anon_sym_do_BANG] = ACTIONS(3005),
    [anon_sym_begin] = ACTIONS(3003),
    [anon_sym_LPAREN2] = ACTIONS(3003),
    [anon_sym_DOT_DOT2] = ACTIONS(3005),
    [anon_sym_default] = ACTIONS(3003),
    [anon_sym_or] = ACTIONS(3003),
    [anon_sym_static] = ACTIONS(3003),
    [anon_sym_member] = ACTIONS(3003),
    [anon_sym_abstract] = ACTIONS(3003),
    [anon_sym_val] = ACTIONS(3003),
    [anon_sym_override] = ACTIONS(3003),
    [aux_sym_char_token1] = ACTIONS(3005),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3003),
    [anon_sym_DQUOTE] = ACTIONS(3003),
    [anon_sym_AT_DQUOTE] = ACTIONS(3005),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3005),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3005),
    [sym_bool] = ACTIONS(3003),
    [sym_unit] = ACTIONS(3005),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3003),
    [sym_op_identifier] = ACTIONS(3003),
    [anon_sym_PLUS] = ACTIONS(3003),
    [anon_sym_DASH] = ACTIONS(3003),
    [anon_sym_PLUS_DOT] = ACTIONS(3003),
    [anon_sym_DASH_DOT] = ACTIONS(3003),
    [anon_sym_PERCENT] = ACTIONS(3003),
    [anon_sym_AMP_AMP] = ACTIONS(3003),
    [anon_sym_TILDE] = ACTIONS(3005),
    [aux_sym_prefix_op_token1] = ACTIONS(3003),
    [aux_sym_infix_op_token1] = ACTIONS(3005),
    [aux_sym_infix_op_token2] = ACTIONS(3003),
    [anon_sym_PIPE_PIPE] = ACTIONS(3003),
    [anon_sym_BANG_EQ] = ACTIONS(3003),
    [anon_sym_COLON_EQ] = ACTIONS(3005),
    [anon_sym_DOLLAR] = ACTIONS(3003),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3003),
    [sym_int] = ACTIONS(3003),
    [sym_xint] = ACTIONS(3005),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3005),
    [sym__newline] = ACTIONS(3005),
    [sym__dedent] = ACTIONS(3005),
  },
  [910] = {
    [sym_block_comment] = STATE(910),
    [sym_compiler_directive_decl] = STATE(910),
    [sym_fsi_directive_decl] = STATE(910),
    [sym_preproc_line] = STATE(910),
    [sym_identifier] = ACTIONS(2470),
    [anon_sym_EQ] = ACTIONS(2472),
    [anon_sym_GT_RBRACK] = ACTIONS(2472),
    [anon_sym_COLON] = ACTIONS(2470),
    [anon_sym_return] = ACTIONS(2470),
    [anon_sym_do] = ACTIONS(2470),
    [anon_sym_let] = ACTIONS(2470),
    [anon_sym_let_BANG] = ACTIONS(2472),
    [anon_sym_LPAREN] = ACTIONS(2470),
    [anon_sym_COMMA] = ACTIONS(2472),
    [anon_sym_null] = ACTIONS(2470),
    [anon_sym_QMARK] = ACTIONS(2470),
    [anon_sym_COLON_QMARK] = ACTIONS(2470),
    [anon_sym_COLON_COLON] = ACTIONS(2472),
    [anon_sym_AMP] = ACTIONS(2470),
    [anon_sym_LBRACK] = ACTIONS(2470),
    [anon_sym_RBRACK] = ACTIONS(2472),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2472),
    [anon_sym_LBRACE] = ACTIONS(2470),
    [anon_sym_RBRACE] = ACTIONS(2472),
    [anon_sym_LT_AT] = ACTIONS(2470),
    [anon_sym_LT_AT_AT] = ACTIONS(2470),
    [anon_sym_DOT] = ACTIONS(2470),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2472),
    [anon_sym_new] = ACTIONS(2470),
    [anon_sym_with] = ACTIONS(2470),
    [anon_sym_return_BANG] = ACTIONS(2472),
    [anon_sym_yield] = ACTIONS(2470),
    [anon_sym_yield_BANG] = ACTIONS(2472),
    [anon_sym_lazy] = ACTIONS(2470),
    [anon_sym_assert] = ACTIONS(2470),
    [anon_sym_upcast] = ACTIONS(2470),
    [anon_sym_downcast] = ACTIONS(2470),
    [anon_sym_COLON_GT] = ACTIONS(2472),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2472),
    [anon_sym_for] = ACTIONS(2470),
    [anon_sym_to] = ACTIONS(2470),
    [anon_sym_downto] = ACTIONS(2470),
    [anon_sym_while] = ACTIONS(2470),
    [anon_sym_if] = ACTIONS(2470),
    [anon_sym_fun] = ACTIONS(2470),
    [anon_sym_DASH_GT] = ACTIONS(2470),
    [anon_sym_try] = ACTIONS(2470),
    [anon_sym_match] = ACTIONS(2470),
    [anon_sym_match_BANG] = ACTIONS(2472),
    [anon_sym_function] = ACTIONS(2470),
    [anon_sym_LT_DASH] = ACTIONS(2470),
    [anon_sym_DOT_LBRACK] = ACTIONS(2472),
    [anon_sym_LT] = ACTIONS(2472),
    [anon_sym_use] = ACTIONS(2470),
    [anon_sym_use_BANG] = ACTIONS(2472),
    [anon_sym_do_BANG] = ACTIONS(2472),
    [anon_sym_begin] = ACTIONS(2470),
    [anon_sym_LPAREN2] = ACTIONS(2470),
    [anon_sym_DOT_DOT2] = ACTIONS(2472),
    [anon_sym_STAR] = ACTIONS(2470),
    [anon_sym_LT2] = ACTIONS(2470),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2472),
    [anon_sym_or] = ACTIONS(2470),
    [aux_sym_char_token1] = ACTIONS(2472),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2470),
    [anon_sym_DQUOTE] = ACTIONS(2470),
    [anon_sym_AT_DQUOTE] = ACTIONS(2472),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2472),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2472),
    [sym_bool] = ACTIONS(2470),
    [sym_unit] = ACTIONS(2472),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2470),
    [sym_op_identifier] = ACTIONS(2470),
    [anon_sym_PLUS] = ACTIONS(2470),
    [anon_sym_DASH] = ACTIONS(2470),
    [anon_sym_PLUS_DOT] = ACTIONS(2470),
    [anon_sym_DASH_DOT] = ACTIONS(2470),
    [anon_sym_PERCENT] = ACTIONS(2470),
    [anon_sym_AMP_AMP] = ACTIONS(2470),
    [anon_sym_TILDE] = ACTIONS(2472),
    [aux_sym_prefix_op_token1] = ACTIONS(2470),
    [aux_sym_infix_op_token1] = ACTIONS(2472),
    [aux_sym_infix_op_token2] = ACTIONS(2470),
    [anon_sym_PIPE_PIPE] = ACTIONS(2470),
    [anon_sym_BANG_EQ] = ACTIONS(2470),
    [anon_sym_COLON_EQ] = ACTIONS(2472),
    [anon_sym_DOLLAR] = ACTIONS(2470),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2470),
    [sym_int] = ACTIONS(2470),
    [sym_xint] = ACTIONS(2472),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2472),
    [sym__newline] = ACTIONS(2472),
  },
  [911] = {
    [sym_block_comment] = STATE(911),
    [sym_compiler_directive_decl] = STATE(911),
    [sym_fsi_directive_decl] = STATE(911),
    [sym_preproc_line] = STATE(911),
    [sym_identifier] = ACTIONS(2567),
    [anon_sym_EQ] = ACTIONS(2569),
    [anon_sym_GT_RBRACK] = ACTIONS(2569),
    [anon_sym_COLON] = ACTIONS(2567),
    [anon_sym_return] = ACTIONS(2567),
    [anon_sym_do] = ACTIONS(2567),
    [anon_sym_let] = ACTIONS(2567),
    [anon_sym_let_BANG] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2567),
    [anon_sym_COMMA] = ACTIONS(2569),
    [anon_sym_null] = ACTIONS(2567),
    [anon_sym_QMARK] = ACTIONS(2567),
    [anon_sym_COLON_QMARK] = ACTIONS(2567),
    [anon_sym_COLON_COLON] = ACTIONS(2569),
    [anon_sym_AMP] = ACTIONS(2567),
    [anon_sym_LBRACK] = ACTIONS(2567),
    [anon_sym_RBRACK] = ACTIONS(2569),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2569),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_RBRACE] = ACTIONS(2569),
    [anon_sym_LT_AT] = ACTIONS(2567),
    [anon_sym_LT_AT_AT] = ACTIONS(2567),
    [anon_sym_DOT] = ACTIONS(2567),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2569),
    [anon_sym_new] = ACTIONS(2567),
    [anon_sym_with] = ACTIONS(2567),
    [anon_sym_return_BANG] = ACTIONS(2569),
    [anon_sym_yield] = ACTIONS(2567),
    [anon_sym_yield_BANG] = ACTIONS(2569),
    [anon_sym_lazy] = ACTIONS(2567),
    [anon_sym_assert] = ACTIONS(2567),
    [anon_sym_upcast] = ACTIONS(2567),
    [anon_sym_downcast] = ACTIONS(2567),
    [anon_sym_COLON_GT] = ACTIONS(2569),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2569),
    [anon_sym_for] = ACTIONS(2567),
    [anon_sym_to] = ACTIONS(2567),
    [anon_sym_downto] = ACTIONS(2567),
    [anon_sym_while] = ACTIONS(2567),
    [anon_sym_if] = ACTIONS(2567),
    [anon_sym_fun] = ACTIONS(2567),
    [anon_sym_DASH_GT] = ACTIONS(2567),
    [anon_sym_try] = ACTIONS(2567),
    [anon_sym_match] = ACTIONS(2567),
    [anon_sym_match_BANG] = ACTIONS(2569),
    [anon_sym_function] = ACTIONS(2567),
    [anon_sym_LT_DASH] = ACTIONS(2567),
    [anon_sym_DOT_LBRACK] = ACTIONS(2569),
    [anon_sym_LT] = ACTIONS(2569),
    [anon_sym_use] = ACTIONS(2567),
    [anon_sym_use_BANG] = ACTIONS(2569),
    [anon_sym_do_BANG] = ACTIONS(2569),
    [anon_sym_begin] = ACTIONS(2567),
    [anon_sym_LPAREN2] = ACTIONS(2567),
    [anon_sym_DOT_DOT2] = ACTIONS(2569),
    [anon_sym_STAR] = ACTIONS(2567),
    [anon_sym_LT2] = ACTIONS(2567),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2569),
    [anon_sym_or] = ACTIONS(2567),
    [aux_sym_char_token1] = ACTIONS(2569),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2567),
    [anon_sym_DQUOTE] = ACTIONS(2567),
    [anon_sym_AT_DQUOTE] = ACTIONS(2569),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2569),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2569),
    [sym_bool] = ACTIONS(2567),
    [sym_unit] = ACTIONS(2569),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2567),
    [sym_op_identifier] = ACTIONS(2567),
    [anon_sym_PLUS] = ACTIONS(2567),
    [anon_sym_DASH] = ACTIONS(2567),
    [anon_sym_PLUS_DOT] = ACTIONS(2567),
    [anon_sym_DASH_DOT] = ACTIONS(2567),
    [anon_sym_PERCENT] = ACTIONS(2567),
    [anon_sym_AMP_AMP] = ACTIONS(2567),
    [anon_sym_TILDE] = ACTIONS(2569),
    [aux_sym_prefix_op_token1] = ACTIONS(2567),
    [aux_sym_infix_op_token1] = ACTIONS(2569),
    [aux_sym_infix_op_token2] = ACTIONS(2567),
    [anon_sym_PIPE_PIPE] = ACTIONS(2567),
    [anon_sym_BANG_EQ] = ACTIONS(2567),
    [anon_sym_COLON_EQ] = ACTIONS(2569),
    [anon_sym_DOLLAR] = ACTIONS(2567),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2567),
    [sym_int] = ACTIONS(2567),
    [sym_xint] = ACTIONS(2569),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2569),
    [sym__newline] = ACTIONS(2569),
  },
  [912] = {
    [sym_block_comment] = STATE(912),
    [sym_compiler_directive_decl] = STATE(912),
    [sym_fsi_directive_decl] = STATE(912),
    [sym_preproc_line] = STATE(912),
    [sym_identifier] = ACTIONS(3007),
    [anon_sym_EQ] = ACTIONS(3009),
    [anon_sym_LBRACK_LT] = ACTIONS(3009),
    [anon_sym_COLON] = ACTIONS(3007),
    [anon_sym_return] = ACTIONS(3007),
    [anon_sym_do] = ACTIONS(3007),
    [anon_sym_let] = ACTIONS(3007),
    [anon_sym_let_BANG] = ACTIONS(3009),
    [aux_sym_access_modifier_token1] = ACTIONS(3009),
    [anon_sym_LPAREN] = ACTIONS(3007),
    [anon_sym_COMMA] = ACTIONS(3009),
    [anon_sym_null] = ACTIONS(3007),
    [anon_sym_QMARK] = ACTIONS(3007),
    [anon_sym_COLON_QMARK] = ACTIONS(3007),
    [anon_sym_COLON_COLON] = ACTIONS(3009),
    [anon_sym_AMP] = ACTIONS(3007),
    [anon_sym_LBRACK] = ACTIONS(3007),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3009),
    [anon_sym_LBRACE] = ACTIONS(3007),
    [anon_sym_LT_AT] = ACTIONS(3007),
    [anon_sym_LT_AT_AT] = ACTIONS(3007),
    [anon_sym_DOT] = ACTIONS(3007),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3009),
    [anon_sym_new] = ACTIONS(3007),
    [anon_sym_with] = ACTIONS(3007),
    [anon_sym_return_BANG] = ACTIONS(3009),
    [anon_sym_yield] = ACTIONS(3007),
    [anon_sym_yield_BANG] = ACTIONS(3009),
    [anon_sym_lazy] = ACTIONS(3007),
    [anon_sym_assert] = ACTIONS(3007),
    [anon_sym_upcast] = ACTIONS(3007),
    [anon_sym_downcast] = ACTIONS(3007),
    [anon_sym_COLON_GT] = ACTIONS(3009),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3009),
    [anon_sym_for] = ACTIONS(3007),
    [anon_sym_while] = ACTIONS(3007),
    [anon_sym_if] = ACTIONS(3007),
    [anon_sym_fun] = ACTIONS(3007),
    [anon_sym_try] = ACTIONS(3007),
    [anon_sym_match] = ACTIONS(3007),
    [anon_sym_match_BANG] = ACTIONS(3009),
    [anon_sym_function] = ACTIONS(3007),
    [anon_sym_LT_DASH] = ACTIONS(3007),
    [anon_sym_DOT_LBRACK] = ACTIONS(3009),
    [anon_sym_LT] = ACTIONS(3009),
    [anon_sym_use] = ACTIONS(3007),
    [anon_sym_use_BANG] = ACTIONS(3009),
    [anon_sym_do_BANG] = ACTIONS(3009),
    [anon_sym_begin] = ACTIONS(3007),
    [anon_sym_LPAREN2] = ACTIONS(3007),
    [anon_sym_DOT_DOT2] = ACTIONS(3009),
    [anon_sym_default] = ACTIONS(3007),
    [anon_sym_or] = ACTIONS(3007),
    [anon_sym_static] = ACTIONS(3007),
    [anon_sym_member] = ACTIONS(3007),
    [anon_sym_abstract] = ACTIONS(3007),
    [anon_sym_val] = ACTIONS(3007),
    [anon_sym_override] = ACTIONS(3007),
    [aux_sym_char_token1] = ACTIONS(3009),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3007),
    [anon_sym_DQUOTE] = ACTIONS(3007),
    [anon_sym_AT_DQUOTE] = ACTIONS(3009),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3009),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3009),
    [sym_bool] = ACTIONS(3007),
    [sym_unit] = ACTIONS(3009),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3007),
    [sym_op_identifier] = ACTIONS(3007),
    [anon_sym_PLUS] = ACTIONS(3007),
    [anon_sym_DASH] = ACTIONS(3007),
    [anon_sym_PLUS_DOT] = ACTIONS(3007),
    [anon_sym_DASH_DOT] = ACTIONS(3007),
    [anon_sym_PERCENT] = ACTIONS(3007),
    [anon_sym_AMP_AMP] = ACTIONS(3007),
    [anon_sym_TILDE] = ACTIONS(3009),
    [aux_sym_prefix_op_token1] = ACTIONS(3007),
    [aux_sym_infix_op_token1] = ACTIONS(3009),
    [aux_sym_infix_op_token2] = ACTIONS(3007),
    [anon_sym_PIPE_PIPE] = ACTIONS(3007),
    [anon_sym_BANG_EQ] = ACTIONS(3007),
    [anon_sym_COLON_EQ] = ACTIONS(3009),
    [anon_sym_DOLLAR] = ACTIONS(3007),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3007),
    [sym_int] = ACTIONS(3007),
    [sym_xint] = ACTIONS(3009),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3009),
    [sym__newline] = ACTIONS(3009),
    [sym__dedent] = ACTIONS(3009),
  },
  [913] = {
    [sym_block_comment] = STATE(913),
    [sym_compiler_directive_decl] = STATE(913),
    [sym_fsi_directive_decl] = STATE(913),
    [sym_preproc_line] = STATE(913),
    [sym_identifier] = ACTIONS(3011),
    [anon_sym_EQ] = ACTIONS(3013),
    [anon_sym_LBRACK_LT] = ACTIONS(3013),
    [anon_sym_COLON] = ACTIONS(3011),
    [anon_sym_return] = ACTIONS(3011),
    [anon_sym_do] = ACTIONS(3011),
    [anon_sym_let] = ACTIONS(3011),
    [anon_sym_let_BANG] = ACTIONS(3013),
    [aux_sym_access_modifier_token1] = ACTIONS(3013),
    [anon_sym_LPAREN] = ACTIONS(3011),
    [anon_sym_COMMA] = ACTIONS(3013),
    [anon_sym_null] = ACTIONS(3011),
    [anon_sym_QMARK] = ACTIONS(3011),
    [anon_sym_COLON_QMARK] = ACTIONS(3011),
    [anon_sym_COLON_COLON] = ACTIONS(3013),
    [anon_sym_AMP] = ACTIONS(3011),
    [anon_sym_LBRACK] = ACTIONS(3011),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3013),
    [anon_sym_LBRACE] = ACTIONS(3011),
    [anon_sym_LT_AT] = ACTIONS(3011),
    [anon_sym_LT_AT_AT] = ACTIONS(3011),
    [anon_sym_DOT] = ACTIONS(3011),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3013),
    [anon_sym_new] = ACTIONS(3011),
    [anon_sym_with] = ACTIONS(3011),
    [anon_sym_return_BANG] = ACTIONS(3013),
    [anon_sym_yield] = ACTIONS(3011),
    [anon_sym_yield_BANG] = ACTIONS(3013),
    [anon_sym_lazy] = ACTIONS(3011),
    [anon_sym_assert] = ACTIONS(3011),
    [anon_sym_upcast] = ACTIONS(3011),
    [anon_sym_downcast] = ACTIONS(3011),
    [anon_sym_COLON_GT] = ACTIONS(3013),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3013),
    [anon_sym_for] = ACTIONS(3011),
    [anon_sym_while] = ACTIONS(3011),
    [anon_sym_if] = ACTIONS(3011),
    [anon_sym_fun] = ACTIONS(3011),
    [anon_sym_try] = ACTIONS(3011),
    [anon_sym_match] = ACTIONS(3011),
    [anon_sym_match_BANG] = ACTIONS(3013),
    [anon_sym_function] = ACTIONS(3011),
    [anon_sym_LT_DASH] = ACTIONS(3011),
    [anon_sym_DOT_LBRACK] = ACTIONS(3013),
    [anon_sym_LT] = ACTIONS(3013),
    [anon_sym_use] = ACTIONS(3011),
    [anon_sym_use_BANG] = ACTIONS(3013),
    [anon_sym_do_BANG] = ACTIONS(3013),
    [anon_sym_begin] = ACTIONS(3011),
    [anon_sym_LPAREN2] = ACTIONS(3011),
    [anon_sym_DOT_DOT2] = ACTIONS(3013),
    [anon_sym_default] = ACTIONS(3011),
    [anon_sym_or] = ACTIONS(3011),
    [anon_sym_static] = ACTIONS(3011),
    [anon_sym_member] = ACTIONS(3011),
    [anon_sym_abstract] = ACTIONS(3011),
    [anon_sym_val] = ACTIONS(3011),
    [anon_sym_override] = ACTIONS(3011),
    [aux_sym_char_token1] = ACTIONS(3013),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3011),
    [anon_sym_DQUOTE] = ACTIONS(3011),
    [anon_sym_AT_DQUOTE] = ACTIONS(3013),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3013),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3013),
    [sym_bool] = ACTIONS(3011),
    [sym_unit] = ACTIONS(3013),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3011),
    [sym_op_identifier] = ACTIONS(3011),
    [anon_sym_PLUS] = ACTIONS(3011),
    [anon_sym_DASH] = ACTIONS(3011),
    [anon_sym_PLUS_DOT] = ACTIONS(3011),
    [anon_sym_DASH_DOT] = ACTIONS(3011),
    [anon_sym_PERCENT] = ACTIONS(3011),
    [anon_sym_AMP_AMP] = ACTIONS(3011),
    [anon_sym_TILDE] = ACTIONS(3013),
    [aux_sym_prefix_op_token1] = ACTIONS(3011),
    [aux_sym_infix_op_token1] = ACTIONS(3013),
    [aux_sym_infix_op_token2] = ACTIONS(3011),
    [anon_sym_PIPE_PIPE] = ACTIONS(3011),
    [anon_sym_BANG_EQ] = ACTIONS(3011),
    [anon_sym_COLON_EQ] = ACTIONS(3013),
    [anon_sym_DOLLAR] = ACTIONS(3011),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3011),
    [sym_int] = ACTIONS(3011),
    [sym_xint] = ACTIONS(3013),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3013),
    [sym__newline] = ACTIONS(3013),
    [sym__dedent] = ACTIONS(3013),
  },
  [914] = {
    [sym_block_comment] = STATE(914),
    [sym_compiler_directive_decl] = STATE(914),
    [sym_fsi_directive_decl] = STATE(914),
    [sym_preproc_line] = STATE(914),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_EQ] = ACTIONS(3017),
    [anon_sym_LBRACK_LT] = ACTIONS(3017),
    [anon_sym_COLON] = ACTIONS(3015),
    [anon_sym_return] = ACTIONS(3015),
    [anon_sym_do] = ACTIONS(3015),
    [anon_sym_let] = ACTIONS(3015),
    [anon_sym_let_BANG] = ACTIONS(3017),
    [aux_sym_access_modifier_token1] = ACTIONS(3017),
    [anon_sym_LPAREN] = ACTIONS(3015),
    [anon_sym_COMMA] = ACTIONS(3017),
    [anon_sym_null] = ACTIONS(3015),
    [anon_sym_QMARK] = ACTIONS(3015),
    [anon_sym_COLON_QMARK] = ACTIONS(3015),
    [anon_sym_COLON_COLON] = ACTIONS(3017),
    [anon_sym_AMP] = ACTIONS(3015),
    [anon_sym_LBRACK] = ACTIONS(3015),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3017),
    [anon_sym_LBRACE] = ACTIONS(3015),
    [anon_sym_LT_AT] = ACTIONS(3015),
    [anon_sym_LT_AT_AT] = ACTIONS(3015),
    [anon_sym_DOT] = ACTIONS(3015),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3017),
    [anon_sym_new] = ACTIONS(3015),
    [anon_sym_with] = ACTIONS(3015),
    [anon_sym_return_BANG] = ACTIONS(3017),
    [anon_sym_yield] = ACTIONS(3015),
    [anon_sym_yield_BANG] = ACTIONS(3017),
    [anon_sym_lazy] = ACTIONS(3015),
    [anon_sym_assert] = ACTIONS(3015),
    [anon_sym_upcast] = ACTIONS(3015),
    [anon_sym_downcast] = ACTIONS(3015),
    [anon_sym_COLON_GT] = ACTIONS(3017),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3017),
    [anon_sym_for] = ACTIONS(3015),
    [anon_sym_while] = ACTIONS(3015),
    [anon_sym_if] = ACTIONS(3015),
    [anon_sym_fun] = ACTIONS(3015),
    [anon_sym_try] = ACTIONS(3015),
    [anon_sym_match] = ACTIONS(3015),
    [anon_sym_match_BANG] = ACTIONS(3017),
    [anon_sym_function] = ACTIONS(3015),
    [anon_sym_LT_DASH] = ACTIONS(3015),
    [anon_sym_DOT_LBRACK] = ACTIONS(3017),
    [anon_sym_LT] = ACTIONS(3017),
    [anon_sym_use] = ACTIONS(3015),
    [anon_sym_use_BANG] = ACTIONS(3017),
    [anon_sym_do_BANG] = ACTIONS(3017),
    [anon_sym_begin] = ACTIONS(3015),
    [anon_sym_LPAREN2] = ACTIONS(3015),
    [anon_sym_DOT_DOT2] = ACTIONS(3017),
    [anon_sym_default] = ACTIONS(3015),
    [anon_sym_or] = ACTIONS(3015),
    [anon_sym_static] = ACTIONS(3015),
    [anon_sym_member] = ACTIONS(3015),
    [anon_sym_abstract] = ACTIONS(3015),
    [anon_sym_val] = ACTIONS(3015),
    [anon_sym_override] = ACTIONS(3015),
    [aux_sym_char_token1] = ACTIONS(3017),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3015),
    [anon_sym_DQUOTE] = ACTIONS(3015),
    [anon_sym_AT_DQUOTE] = ACTIONS(3017),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3017),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3017),
    [sym_bool] = ACTIONS(3015),
    [sym_unit] = ACTIONS(3017),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3015),
    [sym_op_identifier] = ACTIONS(3015),
    [anon_sym_PLUS] = ACTIONS(3015),
    [anon_sym_DASH] = ACTIONS(3015),
    [anon_sym_PLUS_DOT] = ACTIONS(3015),
    [anon_sym_DASH_DOT] = ACTIONS(3015),
    [anon_sym_PERCENT] = ACTIONS(3015),
    [anon_sym_AMP_AMP] = ACTIONS(3015),
    [anon_sym_TILDE] = ACTIONS(3017),
    [aux_sym_prefix_op_token1] = ACTIONS(3015),
    [aux_sym_infix_op_token1] = ACTIONS(3017),
    [aux_sym_infix_op_token2] = ACTIONS(3015),
    [anon_sym_PIPE_PIPE] = ACTIONS(3015),
    [anon_sym_BANG_EQ] = ACTIONS(3015),
    [anon_sym_COLON_EQ] = ACTIONS(3017),
    [anon_sym_DOLLAR] = ACTIONS(3015),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3015),
    [sym_int] = ACTIONS(3015),
    [sym_xint] = ACTIONS(3017),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3017),
    [sym__newline] = ACTIONS(3017),
    [sym__dedent] = ACTIONS(3017),
  },
  [915] = {
    [sym_block_comment] = STATE(915),
    [sym_compiler_directive_decl] = STATE(915),
    [sym_fsi_directive_decl] = STATE(915),
    [sym_preproc_line] = STATE(915),
    [sym_identifier] = ACTIONS(3019),
    [anon_sym_EQ] = ACTIONS(3021),
    [anon_sym_LBRACK_LT] = ACTIONS(3021),
    [anon_sym_COLON] = ACTIONS(3019),
    [anon_sym_return] = ACTIONS(3019),
    [anon_sym_do] = ACTIONS(3019),
    [anon_sym_let] = ACTIONS(3019),
    [anon_sym_let_BANG] = ACTIONS(3021),
    [aux_sym_access_modifier_token1] = ACTIONS(3021),
    [anon_sym_LPAREN] = ACTIONS(3019),
    [anon_sym_COMMA] = ACTIONS(3021),
    [anon_sym_null] = ACTIONS(3019),
    [anon_sym_QMARK] = ACTIONS(3019),
    [anon_sym_COLON_QMARK] = ACTIONS(3019),
    [anon_sym_COLON_COLON] = ACTIONS(3021),
    [anon_sym_AMP] = ACTIONS(3019),
    [anon_sym_LBRACK] = ACTIONS(3019),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3021),
    [anon_sym_LBRACE] = ACTIONS(3019),
    [anon_sym_LT_AT] = ACTIONS(3019),
    [anon_sym_LT_AT_AT] = ACTIONS(3019),
    [anon_sym_DOT] = ACTIONS(3019),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3021),
    [anon_sym_new] = ACTIONS(3019),
    [anon_sym_with] = ACTIONS(3019),
    [anon_sym_return_BANG] = ACTIONS(3021),
    [anon_sym_yield] = ACTIONS(3019),
    [anon_sym_yield_BANG] = ACTIONS(3021),
    [anon_sym_lazy] = ACTIONS(3019),
    [anon_sym_assert] = ACTIONS(3019),
    [anon_sym_upcast] = ACTIONS(3019),
    [anon_sym_downcast] = ACTIONS(3019),
    [anon_sym_COLON_GT] = ACTIONS(3021),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3021),
    [anon_sym_for] = ACTIONS(3019),
    [anon_sym_while] = ACTIONS(3019),
    [anon_sym_if] = ACTIONS(3019),
    [anon_sym_fun] = ACTIONS(3019),
    [anon_sym_try] = ACTIONS(3019),
    [anon_sym_match] = ACTIONS(3019),
    [anon_sym_match_BANG] = ACTIONS(3021),
    [anon_sym_function] = ACTIONS(3019),
    [anon_sym_LT_DASH] = ACTIONS(3019),
    [anon_sym_DOT_LBRACK] = ACTIONS(3021),
    [anon_sym_LT] = ACTIONS(3021),
    [anon_sym_use] = ACTIONS(3019),
    [anon_sym_use_BANG] = ACTIONS(3021),
    [anon_sym_do_BANG] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3019),
    [anon_sym_LPAREN2] = ACTIONS(3019),
    [anon_sym_DOT_DOT2] = ACTIONS(3021),
    [anon_sym_default] = ACTIONS(3019),
    [anon_sym_or] = ACTIONS(3019),
    [anon_sym_static] = ACTIONS(3019),
    [anon_sym_member] = ACTIONS(3019),
    [anon_sym_abstract] = ACTIONS(3019),
    [anon_sym_val] = ACTIONS(3019),
    [anon_sym_override] = ACTIONS(3019),
    [aux_sym_char_token1] = ACTIONS(3021),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3019),
    [anon_sym_DQUOTE] = ACTIONS(3019),
    [anon_sym_AT_DQUOTE] = ACTIONS(3021),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3021),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3021),
    [sym_bool] = ACTIONS(3019),
    [sym_unit] = ACTIONS(3021),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3019),
    [sym_op_identifier] = ACTIONS(3019),
    [anon_sym_PLUS] = ACTIONS(3019),
    [anon_sym_DASH] = ACTIONS(3019),
    [anon_sym_PLUS_DOT] = ACTIONS(3019),
    [anon_sym_DASH_DOT] = ACTIONS(3019),
    [anon_sym_PERCENT] = ACTIONS(3019),
    [anon_sym_AMP_AMP] = ACTIONS(3019),
    [anon_sym_TILDE] = ACTIONS(3021),
    [aux_sym_prefix_op_token1] = ACTIONS(3019),
    [aux_sym_infix_op_token1] = ACTIONS(3021),
    [aux_sym_infix_op_token2] = ACTIONS(3019),
    [anon_sym_PIPE_PIPE] = ACTIONS(3019),
    [anon_sym_BANG_EQ] = ACTIONS(3019),
    [anon_sym_COLON_EQ] = ACTIONS(3021),
    [anon_sym_DOLLAR] = ACTIONS(3019),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3019),
    [sym_int] = ACTIONS(3019),
    [sym_xint] = ACTIONS(3021),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3021),
    [sym__newline] = ACTIONS(3021),
    [sym__dedent] = ACTIONS(3021),
  },
  [916] = {
    [sym_block_comment] = STATE(916),
    [sym_compiler_directive_decl] = STATE(916),
    [sym_fsi_directive_decl] = STATE(916),
    [sym_preproc_line] = STATE(916),
    [sym_identifier] = ACTIONS(3023),
    [anon_sym_EQ] = ACTIONS(3025),
    [anon_sym_LBRACK_LT] = ACTIONS(3025),
    [anon_sym_COLON] = ACTIONS(3023),
    [anon_sym_return] = ACTIONS(3023),
    [anon_sym_do] = ACTIONS(3023),
    [anon_sym_let] = ACTIONS(3023),
    [anon_sym_let_BANG] = ACTIONS(3025),
    [aux_sym_access_modifier_token1] = ACTIONS(3025),
    [anon_sym_LPAREN] = ACTIONS(3023),
    [anon_sym_COMMA] = ACTIONS(3025),
    [anon_sym_null] = ACTIONS(3023),
    [anon_sym_QMARK] = ACTIONS(3023),
    [anon_sym_COLON_QMARK] = ACTIONS(3023),
    [anon_sym_COLON_COLON] = ACTIONS(3025),
    [anon_sym_AMP] = ACTIONS(3023),
    [anon_sym_LBRACK] = ACTIONS(3023),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3025),
    [anon_sym_LBRACE] = ACTIONS(3023),
    [anon_sym_LT_AT] = ACTIONS(3023),
    [anon_sym_LT_AT_AT] = ACTIONS(3023),
    [anon_sym_DOT] = ACTIONS(3023),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3025),
    [anon_sym_new] = ACTIONS(3023),
    [anon_sym_with] = ACTIONS(3023),
    [anon_sym_return_BANG] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(3023),
    [anon_sym_yield_BANG] = ACTIONS(3025),
    [anon_sym_lazy] = ACTIONS(3023),
    [anon_sym_assert] = ACTIONS(3023),
    [anon_sym_upcast] = ACTIONS(3023),
    [anon_sym_downcast] = ACTIONS(3023),
    [anon_sym_COLON_GT] = ACTIONS(3025),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3025),
    [anon_sym_for] = ACTIONS(3023),
    [anon_sym_while] = ACTIONS(3023),
    [anon_sym_if] = ACTIONS(3023),
    [anon_sym_fun] = ACTIONS(3023),
    [anon_sym_try] = ACTIONS(3023),
    [anon_sym_match] = ACTIONS(3023),
    [anon_sym_match_BANG] = ACTIONS(3025),
    [anon_sym_function] = ACTIONS(3023),
    [anon_sym_LT_DASH] = ACTIONS(3023),
    [anon_sym_DOT_LBRACK] = ACTIONS(3025),
    [anon_sym_LT] = ACTIONS(3025),
    [anon_sym_use] = ACTIONS(3023),
    [anon_sym_use_BANG] = ACTIONS(3025),
    [anon_sym_do_BANG] = ACTIONS(3025),
    [anon_sym_begin] = ACTIONS(3023),
    [anon_sym_LPAREN2] = ACTIONS(3023),
    [anon_sym_DOT_DOT2] = ACTIONS(3025),
    [anon_sym_default] = ACTIONS(3023),
    [anon_sym_or] = ACTIONS(3023),
    [anon_sym_static] = ACTIONS(3023),
    [anon_sym_member] = ACTIONS(3023),
    [anon_sym_abstract] = ACTIONS(3023),
    [anon_sym_val] = ACTIONS(3023),
    [anon_sym_override] = ACTIONS(3023),
    [aux_sym_char_token1] = ACTIONS(3025),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3023),
    [anon_sym_DQUOTE] = ACTIONS(3023),
    [anon_sym_AT_DQUOTE] = ACTIONS(3025),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3025),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3025),
    [sym_bool] = ACTIONS(3023),
    [sym_unit] = ACTIONS(3025),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3023),
    [sym_op_identifier] = ACTIONS(3023),
    [anon_sym_PLUS] = ACTIONS(3023),
    [anon_sym_DASH] = ACTIONS(3023),
    [anon_sym_PLUS_DOT] = ACTIONS(3023),
    [anon_sym_DASH_DOT] = ACTIONS(3023),
    [anon_sym_PERCENT] = ACTIONS(3023),
    [anon_sym_AMP_AMP] = ACTIONS(3023),
    [anon_sym_TILDE] = ACTIONS(3025),
    [aux_sym_prefix_op_token1] = ACTIONS(3023),
    [aux_sym_infix_op_token1] = ACTIONS(3025),
    [aux_sym_infix_op_token2] = ACTIONS(3023),
    [anon_sym_PIPE_PIPE] = ACTIONS(3023),
    [anon_sym_BANG_EQ] = ACTIONS(3023),
    [anon_sym_COLON_EQ] = ACTIONS(3025),
    [anon_sym_DOLLAR] = ACTIONS(3023),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3023),
    [sym_int] = ACTIONS(3023),
    [sym_xint] = ACTIONS(3025),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3025),
    [sym__newline] = ACTIONS(3025),
    [sym__dedent] = ACTIONS(3025),
  },
  [917] = {
    [sym_block_comment] = STATE(917),
    [sym_compiler_directive_decl] = STATE(917),
    [sym_fsi_directive_decl] = STATE(917),
    [sym_preproc_line] = STATE(917),
    [sym_identifier] = ACTIONS(3027),
    [anon_sym_EQ] = ACTIONS(3029),
    [anon_sym_LBRACK_LT] = ACTIONS(3029),
    [anon_sym_COLON] = ACTIONS(3027),
    [anon_sym_return] = ACTIONS(3027),
    [anon_sym_do] = ACTIONS(3027),
    [anon_sym_let] = ACTIONS(3027),
    [anon_sym_let_BANG] = ACTIONS(3029),
    [aux_sym_access_modifier_token1] = ACTIONS(3029),
    [anon_sym_LPAREN] = ACTIONS(3027),
    [anon_sym_COMMA] = ACTIONS(3029),
    [anon_sym_null] = ACTIONS(3027),
    [anon_sym_QMARK] = ACTIONS(3027),
    [anon_sym_COLON_QMARK] = ACTIONS(3027),
    [anon_sym_COLON_COLON] = ACTIONS(3029),
    [anon_sym_AMP] = ACTIONS(3027),
    [anon_sym_LBRACK] = ACTIONS(3027),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3027),
    [anon_sym_LT_AT] = ACTIONS(3027),
    [anon_sym_LT_AT_AT] = ACTIONS(3027),
    [anon_sym_DOT] = ACTIONS(3027),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3029),
    [anon_sym_new] = ACTIONS(3027),
    [anon_sym_with] = ACTIONS(3027),
    [anon_sym_return_BANG] = ACTIONS(3029),
    [anon_sym_yield] = ACTIONS(3027),
    [anon_sym_yield_BANG] = ACTIONS(3029),
    [anon_sym_lazy] = ACTIONS(3027),
    [anon_sym_assert] = ACTIONS(3027),
    [anon_sym_upcast] = ACTIONS(3027),
    [anon_sym_downcast] = ACTIONS(3027),
    [anon_sym_COLON_GT] = ACTIONS(3029),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3029),
    [anon_sym_for] = ACTIONS(3027),
    [anon_sym_while] = ACTIONS(3027),
    [anon_sym_if] = ACTIONS(3027),
    [anon_sym_fun] = ACTIONS(3027),
    [anon_sym_try] = ACTIONS(3027),
    [anon_sym_match] = ACTIONS(3027),
    [anon_sym_match_BANG] = ACTIONS(3029),
    [anon_sym_function] = ACTIONS(3027),
    [anon_sym_LT_DASH] = ACTIONS(3027),
    [anon_sym_DOT_LBRACK] = ACTIONS(3029),
    [anon_sym_LT] = ACTIONS(3029),
    [anon_sym_use] = ACTIONS(3027),
    [anon_sym_use_BANG] = ACTIONS(3029),
    [anon_sym_do_BANG] = ACTIONS(3029),
    [anon_sym_begin] = ACTIONS(3027),
    [anon_sym_LPAREN2] = ACTIONS(3027),
    [anon_sym_DOT_DOT2] = ACTIONS(3029),
    [anon_sym_default] = ACTIONS(3027),
    [anon_sym_or] = ACTIONS(3027),
    [anon_sym_static] = ACTIONS(3027),
    [anon_sym_member] = ACTIONS(3027),
    [anon_sym_abstract] = ACTIONS(3027),
    [anon_sym_val] = ACTIONS(3027),
    [anon_sym_override] = ACTIONS(3027),
    [aux_sym_char_token1] = ACTIONS(3029),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3027),
    [anon_sym_DQUOTE] = ACTIONS(3027),
    [anon_sym_AT_DQUOTE] = ACTIONS(3029),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3029),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3029),
    [sym_bool] = ACTIONS(3027),
    [sym_unit] = ACTIONS(3029),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3027),
    [sym_op_identifier] = ACTIONS(3027),
    [anon_sym_PLUS] = ACTIONS(3027),
    [anon_sym_DASH] = ACTIONS(3027),
    [anon_sym_PLUS_DOT] = ACTIONS(3027),
    [anon_sym_DASH_DOT] = ACTIONS(3027),
    [anon_sym_PERCENT] = ACTIONS(3027),
    [anon_sym_AMP_AMP] = ACTIONS(3027),
    [anon_sym_TILDE] = ACTIONS(3029),
    [aux_sym_prefix_op_token1] = ACTIONS(3027),
    [aux_sym_infix_op_token1] = ACTIONS(3029),
    [aux_sym_infix_op_token2] = ACTIONS(3027),
    [anon_sym_PIPE_PIPE] = ACTIONS(3027),
    [anon_sym_BANG_EQ] = ACTIONS(3027),
    [anon_sym_COLON_EQ] = ACTIONS(3029),
    [anon_sym_DOLLAR] = ACTIONS(3027),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3027),
    [sym_int] = ACTIONS(3027),
    [sym_xint] = ACTIONS(3029),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3029),
    [sym__newline] = ACTIONS(3029),
    [sym__dedent] = ACTIONS(3029),
  },
  [918] = {
    [sym_block_comment] = STATE(918),
    [sym_compiler_directive_decl] = STATE(918),
    [sym_fsi_directive_decl] = STATE(918),
    [sym_preproc_line] = STATE(918),
    [sym_identifier] = ACTIONS(3031),
    [anon_sym_EQ] = ACTIONS(3033),
    [anon_sym_LBRACK_LT] = ACTIONS(3033),
    [anon_sym_COLON] = ACTIONS(3031),
    [anon_sym_return] = ACTIONS(3031),
    [anon_sym_do] = ACTIONS(3031),
    [anon_sym_let] = ACTIONS(3031),
    [anon_sym_let_BANG] = ACTIONS(3033),
    [aux_sym_access_modifier_token1] = ACTIONS(3033),
    [anon_sym_LPAREN] = ACTIONS(3031),
    [anon_sym_COMMA] = ACTIONS(3033),
    [anon_sym_null] = ACTIONS(3031),
    [anon_sym_QMARK] = ACTIONS(3031),
    [anon_sym_COLON_QMARK] = ACTIONS(3031),
    [anon_sym_COLON_COLON] = ACTIONS(3033),
    [anon_sym_AMP] = ACTIONS(3031),
    [anon_sym_LBRACK] = ACTIONS(3031),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3033),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [anon_sym_LT_AT] = ACTIONS(3031),
    [anon_sym_LT_AT_AT] = ACTIONS(3031),
    [anon_sym_DOT] = ACTIONS(3031),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3033),
    [anon_sym_new] = ACTIONS(3031),
    [anon_sym_with] = ACTIONS(3031),
    [anon_sym_return_BANG] = ACTIONS(3033),
    [anon_sym_yield] = ACTIONS(3031),
    [anon_sym_yield_BANG] = ACTIONS(3033),
    [anon_sym_lazy] = ACTIONS(3031),
    [anon_sym_assert] = ACTIONS(3031),
    [anon_sym_upcast] = ACTIONS(3031),
    [anon_sym_downcast] = ACTIONS(3031),
    [anon_sym_COLON_GT] = ACTIONS(3033),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3033),
    [anon_sym_for] = ACTIONS(3031),
    [anon_sym_while] = ACTIONS(3031),
    [anon_sym_if] = ACTIONS(3031),
    [anon_sym_fun] = ACTIONS(3031),
    [anon_sym_try] = ACTIONS(3031),
    [anon_sym_match] = ACTIONS(3031),
    [anon_sym_match_BANG] = ACTIONS(3033),
    [anon_sym_function] = ACTIONS(3031),
    [anon_sym_LT_DASH] = ACTIONS(3031),
    [anon_sym_DOT_LBRACK] = ACTIONS(3033),
    [anon_sym_LT] = ACTIONS(3033),
    [anon_sym_use] = ACTIONS(3031),
    [anon_sym_use_BANG] = ACTIONS(3033),
    [anon_sym_do_BANG] = ACTIONS(3033),
    [anon_sym_begin] = ACTIONS(3031),
    [anon_sym_LPAREN2] = ACTIONS(3031),
    [anon_sym_DOT_DOT2] = ACTIONS(3033),
    [anon_sym_default] = ACTIONS(3031),
    [anon_sym_or] = ACTIONS(3031),
    [anon_sym_static] = ACTIONS(3031),
    [anon_sym_member] = ACTIONS(3031),
    [anon_sym_abstract] = ACTIONS(3031),
    [anon_sym_val] = ACTIONS(3031),
    [anon_sym_override] = ACTIONS(3031),
    [aux_sym_char_token1] = ACTIONS(3033),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3031),
    [anon_sym_DQUOTE] = ACTIONS(3031),
    [anon_sym_AT_DQUOTE] = ACTIONS(3033),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3033),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3033),
    [sym_bool] = ACTIONS(3031),
    [sym_unit] = ACTIONS(3033),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3031),
    [sym_op_identifier] = ACTIONS(3031),
    [anon_sym_PLUS] = ACTIONS(3031),
    [anon_sym_DASH] = ACTIONS(3031),
    [anon_sym_PLUS_DOT] = ACTIONS(3031),
    [anon_sym_DASH_DOT] = ACTIONS(3031),
    [anon_sym_PERCENT] = ACTIONS(3031),
    [anon_sym_AMP_AMP] = ACTIONS(3031),
    [anon_sym_TILDE] = ACTIONS(3033),
    [aux_sym_prefix_op_token1] = ACTIONS(3031),
    [aux_sym_infix_op_token1] = ACTIONS(3033),
    [aux_sym_infix_op_token2] = ACTIONS(3031),
    [anon_sym_PIPE_PIPE] = ACTIONS(3031),
    [anon_sym_BANG_EQ] = ACTIONS(3031),
    [anon_sym_COLON_EQ] = ACTIONS(3033),
    [anon_sym_DOLLAR] = ACTIONS(3031),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3031),
    [sym_int] = ACTIONS(3031),
    [sym_xint] = ACTIONS(3033),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3033),
    [sym__newline] = ACTIONS(3033),
    [sym__dedent] = ACTIONS(3033),
  },
  [919] = {
    [sym_block_comment] = STATE(919),
    [sym_compiler_directive_decl] = STATE(919),
    [sym_fsi_directive_decl] = STATE(919),
    [sym_preproc_line] = STATE(919),
    [sym_identifier] = ACTIONS(3035),
    [anon_sym_EQ] = ACTIONS(3037),
    [anon_sym_LBRACK_LT] = ACTIONS(3037),
    [anon_sym_COLON] = ACTIONS(3035),
    [anon_sym_return] = ACTIONS(3035),
    [anon_sym_do] = ACTIONS(3035),
    [anon_sym_let] = ACTIONS(3035),
    [anon_sym_let_BANG] = ACTIONS(3037),
    [aux_sym_access_modifier_token1] = ACTIONS(3037),
    [anon_sym_LPAREN] = ACTIONS(3035),
    [anon_sym_COMMA] = ACTIONS(3037),
    [anon_sym_null] = ACTIONS(3035),
    [anon_sym_QMARK] = ACTIONS(3035),
    [anon_sym_COLON_QMARK] = ACTIONS(3035),
    [anon_sym_COLON_COLON] = ACTIONS(3037),
    [anon_sym_AMP] = ACTIONS(3035),
    [anon_sym_LBRACK] = ACTIONS(3035),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3037),
    [anon_sym_LBRACE] = ACTIONS(3035),
    [anon_sym_LT_AT] = ACTIONS(3035),
    [anon_sym_LT_AT_AT] = ACTIONS(3035),
    [anon_sym_DOT] = ACTIONS(3035),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3037),
    [anon_sym_new] = ACTIONS(3035),
    [anon_sym_with] = ACTIONS(3035),
    [anon_sym_return_BANG] = ACTIONS(3037),
    [anon_sym_yield] = ACTIONS(3035),
    [anon_sym_yield_BANG] = ACTIONS(3037),
    [anon_sym_lazy] = ACTIONS(3035),
    [anon_sym_assert] = ACTIONS(3035),
    [anon_sym_upcast] = ACTIONS(3035),
    [anon_sym_downcast] = ACTIONS(3035),
    [anon_sym_COLON_GT] = ACTIONS(3037),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3037),
    [anon_sym_for] = ACTIONS(3035),
    [anon_sym_while] = ACTIONS(3035),
    [anon_sym_if] = ACTIONS(3035),
    [anon_sym_fun] = ACTIONS(3035),
    [anon_sym_try] = ACTIONS(3035),
    [anon_sym_match] = ACTIONS(3035),
    [anon_sym_match_BANG] = ACTIONS(3037),
    [anon_sym_function] = ACTIONS(3035),
    [anon_sym_LT_DASH] = ACTIONS(3035),
    [anon_sym_DOT_LBRACK] = ACTIONS(3037),
    [anon_sym_LT] = ACTIONS(3037),
    [anon_sym_use] = ACTIONS(3035),
    [anon_sym_use_BANG] = ACTIONS(3037),
    [anon_sym_do_BANG] = ACTIONS(3037),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_LPAREN2] = ACTIONS(3035),
    [anon_sym_DOT_DOT2] = ACTIONS(3037),
    [anon_sym_default] = ACTIONS(3035),
    [anon_sym_or] = ACTIONS(3035),
    [anon_sym_static] = ACTIONS(3035),
    [anon_sym_member] = ACTIONS(3035),
    [anon_sym_abstract] = ACTIONS(3035),
    [anon_sym_val] = ACTIONS(3035),
    [anon_sym_override] = ACTIONS(3035),
    [aux_sym_char_token1] = ACTIONS(3037),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3035),
    [anon_sym_DQUOTE] = ACTIONS(3035),
    [anon_sym_AT_DQUOTE] = ACTIONS(3037),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3037),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3037),
    [sym_bool] = ACTIONS(3035),
    [sym_unit] = ACTIONS(3037),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3035),
    [sym_op_identifier] = ACTIONS(3035),
    [anon_sym_PLUS] = ACTIONS(3035),
    [anon_sym_DASH] = ACTIONS(3035),
    [anon_sym_PLUS_DOT] = ACTIONS(3035),
    [anon_sym_DASH_DOT] = ACTIONS(3035),
    [anon_sym_PERCENT] = ACTIONS(3035),
    [anon_sym_AMP_AMP] = ACTIONS(3035),
    [anon_sym_TILDE] = ACTIONS(3037),
    [aux_sym_prefix_op_token1] = ACTIONS(3035),
    [aux_sym_infix_op_token1] = ACTIONS(3037),
    [aux_sym_infix_op_token2] = ACTIONS(3035),
    [anon_sym_PIPE_PIPE] = ACTIONS(3035),
    [anon_sym_BANG_EQ] = ACTIONS(3035),
    [anon_sym_COLON_EQ] = ACTIONS(3037),
    [anon_sym_DOLLAR] = ACTIONS(3035),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3035),
    [sym_int] = ACTIONS(3035),
    [sym_xint] = ACTIONS(3037),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3037),
    [sym__newline] = ACTIONS(3037),
    [sym__dedent] = ACTIONS(3037),
  },
  [920] = {
    [sym_block_comment] = STATE(920),
    [sym_compiler_directive_decl] = STATE(920),
    [sym_fsi_directive_decl] = STATE(920),
    [sym_preproc_line] = STATE(920),
    [sym_identifier] = ACTIONS(2474),
    [anon_sym_EQ] = ACTIONS(2476),
    [anon_sym_GT_RBRACK] = ACTIONS(2476),
    [anon_sym_COLON] = ACTIONS(2474),
    [anon_sym_return] = ACTIONS(2474),
    [anon_sym_do] = ACTIONS(2474),
    [anon_sym_let] = ACTIONS(2474),
    [anon_sym_let_BANG] = ACTIONS(2476),
    [anon_sym_LPAREN] = ACTIONS(2474),
    [anon_sym_COMMA] = ACTIONS(2476),
    [anon_sym_null] = ACTIONS(2474),
    [anon_sym_QMARK] = ACTIONS(2474),
    [anon_sym_COLON_QMARK] = ACTIONS(2474),
    [anon_sym_COLON_COLON] = ACTIONS(2476),
    [anon_sym_AMP] = ACTIONS(2474),
    [anon_sym_LBRACK] = ACTIONS(2474),
    [anon_sym_RBRACK] = ACTIONS(2476),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2476),
    [anon_sym_LBRACE] = ACTIONS(2474),
    [anon_sym_RBRACE] = ACTIONS(2476),
    [anon_sym_LT_AT] = ACTIONS(2474),
    [anon_sym_LT_AT_AT] = ACTIONS(2474),
    [anon_sym_DOT] = ACTIONS(2474),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2476),
    [anon_sym_new] = ACTIONS(2474),
    [anon_sym_with] = ACTIONS(2474),
    [anon_sym_return_BANG] = ACTIONS(2476),
    [anon_sym_yield] = ACTIONS(2474),
    [anon_sym_yield_BANG] = ACTIONS(2476),
    [anon_sym_lazy] = ACTIONS(2474),
    [anon_sym_assert] = ACTIONS(2474),
    [anon_sym_upcast] = ACTIONS(2474),
    [anon_sym_downcast] = ACTIONS(2474),
    [anon_sym_COLON_GT] = ACTIONS(2476),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2476),
    [anon_sym_for] = ACTIONS(2474),
    [anon_sym_to] = ACTIONS(2474),
    [anon_sym_downto] = ACTIONS(2474),
    [anon_sym_while] = ACTIONS(2474),
    [anon_sym_if] = ACTIONS(2474),
    [anon_sym_fun] = ACTIONS(2474),
    [anon_sym_DASH_GT] = ACTIONS(2474),
    [anon_sym_try] = ACTIONS(2474),
    [anon_sym_match] = ACTIONS(2474),
    [anon_sym_match_BANG] = ACTIONS(2476),
    [anon_sym_function] = ACTIONS(2474),
    [anon_sym_LT_DASH] = ACTIONS(2474),
    [anon_sym_DOT_LBRACK] = ACTIONS(2476),
    [anon_sym_LT] = ACTIONS(2476),
    [anon_sym_use] = ACTIONS(2474),
    [anon_sym_use_BANG] = ACTIONS(2476),
    [anon_sym_do_BANG] = ACTIONS(2476),
    [anon_sym_begin] = ACTIONS(2474),
    [anon_sym_LPAREN2] = ACTIONS(2474),
    [anon_sym_DOT_DOT2] = ACTIONS(2476),
    [anon_sym_STAR] = ACTIONS(2474),
    [anon_sym_LT2] = ACTIONS(2474),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2476),
    [anon_sym_or] = ACTIONS(2474),
    [aux_sym_char_token1] = ACTIONS(2476),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2474),
    [anon_sym_DQUOTE] = ACTIONS(2474),
    [anon_sym_AT_DQUOTE] = ACTIONS(2476),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2476),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2476),
    [sym_bool] = ACTIONS(2474),
    [sym_unit] = ACTIONS(2476),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2474),
    [sym_op_identifier] = ACTIONS(2474),
    [anon_sym_PLUS] = ACTIONS(2474),
    [anon_sym_DASH] = ACTIONS(2474),
    [anon_sym_PLUS_DOT] = ACTIONS(2474),
    [anon_sym_DASH_DOT] = ACTIONS(2474),
    [anon_sym_PERCENT] = ACTIONS(2474),
    [anon_sym_AMP_AMP] = ACTIONS(2474),
    [anon_sym_TILDE] = ACTIONS(2476),
    [aux_sym_prefix_op_token1] = ACTIONS(2474),
    [aux_sym_infix_op_token1] = ACTIONS(2476),
    [aux_sym_infix_op_token2] = ACTIONS(2474),
    [anon_sym_PIPE_PIPE] = ACTIONS(2474),
    [anon_sym_BANG_EQ] = ACTIONS(2474),
    [anon_sym_COLON_EQ] = ACTIONS(2476),
    [anon_sym_DOLLAR] = ACTIONS(2474),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2474),
    [sym_int] = ACTIONS(2474),
    [sym_xint] = ACTIONS(2476),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2476),
    [sym__newline] = ACTIONS(2476),
  },
  [921] = {
    [sym_block_comment] = STATE(921),
    [sym_compiler_directive_decl] = STATE(921),
    [sym_fsi_directive_decl] = STATE(921),
    [sym_preproc_line] = STATE(921),
    [sym_identifier] = ACTIONS(2321),
    [anon_sym_EQ] = ACTIONS(2323),
    [anon_sym_GT_RBRACK] = ACTIONS(2323),
    [anon_sym_COLON] = ACTIONS(2321),
    [anon_sym_return] = ACTIONS(2321),
    [anon_sym_do] = ACTIONS(2321),
    [anon_sym_let] = ACTIONS(2321),
    [anon_sym_let_BANG] = ACTIONS(2323),
    [anon_sym_LPAREN] = ACTIONS(2321),
    [anon_sym_COMMA] = ACTIONS(2323),
    [anon_sym_null] = ACTIONS(2321),
    [anon_sym_QMARK] = ACTIONS(2321),
    [anon_sym_COLON_QMARK] = ACTIONS(2321),
    [anon_sym_COLON_COLON] = ACTIONS(2323),
    [anon_sym_AMP] = ACTIONS(2321),
    [anon_sym_LBRACK] = ACTIONS(2321),
    [anon_sym_RBRACK] = ACTIONS(2323),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2323),
    [anon_sym_LBRACE] = ACTIONS(2321),
    [anon_sym_RBRACE] = ACTIONS(2323),
    [anon_sym_LT_AT] = ACTIONS(2321),
    [anon_sym_LT_AT_AT] = ACTIONS(2321),
    [anon_sym_DOT] = ACTIONS(2321),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2323),
    [anon_sym_new] = ACTIONS(2321),
    [anon_sym_with] = ACTIONS(2321),
    [anon_sym_return_BANG] = ACTIONS(2323),
    [anon_sym_yield] = ACTIONS(2321),
    [anon_sym_yield_BANG] = ACTIONS(2323),
    [anon_sym_lazy] = ACTIONS(2321),
    [anon_sym_assert] = ACTIONS(2321),
    [anon_sym_upcast] = ACTIONS(2321),
    [anon_sym_downcast] = ACTIONS(2321),
    [anon_sym_COLON_GT] = ACTIONS(2323),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2323),
    [anon_sym_for] = ACTIONS(2321),
    [anon_sym_to] = ACTIONS(2321),
    [anon_sym_downto] = ACTIONS(2321),
    [anon_sym_while] = ACTIONS(2321),
    [anon_sym_if] = ACTIONS(2321),
    [anon_sym_fun] = ACTIONS(2321),
    [anon_sym_DASH_GT] = ACTIONS(2321),
    [anon_sym_try] = ACTIONS(2321),
    [anon_sym_match] = ACTIONS(2321),
    [anon_sym_match_BANG] = ACTIONS(2323),
    [anon_sym_function] = ACTIONS(2321),
    [anon_sym_LT_DASH] = ACTIONS(2321),
    [anon_sym_DOT_LBRACK] = ACTIONS(2323),
    [anon_sym_LT] = ACTIONS(2323),
    [anon_sym_use] = ACTIONS(2321),
    [anon_sym_use_BANG] = ACTIONS(2323),
    [anon_sym_do_BANG] = ACTIONS(2323),
    [anon_sym_begin] = ACTIONS(2321),
    [anon_sym_LPAREN2] = ACTIONS(2321),
    [anon_sym_DOT_DOT2] = ACTIONS(2323),
    [anon_sym_STAR] = ACTIONS(2321),
    [anon_sym_LT2] = ACTIONS(2321),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2323),
    [anon_sym_or] = ACTIONS(2321),
    [aux_sym_char_token1] = ACTIONS(2323),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2321),
    [anon_sym_DQUOTE] = ACTIONS(2321),
    [anon_sym_AT_DQUOTE] = ACTIONS(2323),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2323),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2323),
    [sym_bool] = ACTIONS(2321),
    [sym_unit] = ACTIONS(2323),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2321),
    [sym_op_identifier] = ACTIONS(2321),
    [anon_sym_PLUS] = ACTIONS(2321),
    [anon_sym_DASH] = ACTIONS(2321),
    [anon_sym_PLUS_DOT] = ACTIONS(2321),
    [anon_sym_DASH_DOT] = ACTIONS(2321),
    [anon_sym_PERCENT] = ACTIONS(2321),
    [anon_sym_AMP_AMP] = ACTIONS(2321),
    [anon_sym_TILDE] = ACTIONS(2323),
    [aux_sym_prefix_op_token1] = ACTIONS(2321),
    [aux_sym_infix_op_token1] = ACTIONS(2323),
    [aux_sym_infix_op_token2] = ACTIONS(2321),
    [anon_sym_PIPE_PIPE] = ACTIONS(2321),
    [anon_sym_BANG_EQ] = ACTIONS(2321),
    [anon_sym_COLON_EQ] = ACTIONS(2323),
    [anon_sym_DOLLAR] = ACTIONS(2321),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2321),
    [sym_int] = ACTIONS(2321),
    [sym_xint] = ACTIONS(2323),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2323),
    [sym__newline] = ACTIONS(2323),
  },
  [922] = {
    [sym_block_comment] = STATE(922),
    [sym_compiler_directive_decl] = STATE(922),
    [sym_fsi_directive_decl] = STATE(922),
    [sym_preproc_line] = STATE(922),
    [sym_identifier] = ACTIONS(2466),
    [anon_sym_EQ] = ACTIONS(2468),
    [anon_sym_GT_RBRACK] = ACTIONS(2468),
    [anon_sym_COLON] = ACTIONS(2466),
    [anon_sym_return] = ACTIONS(2466),
    [anon_sym_do] = ACTIONS(2466),
    [anon_sym_let] = ACTIONS(2466),
    [anon_sym_let_BANG] = ACTIONS(2468),
    [anon_sym_LPAREN] = ACTIONS(2466),
    [anon_sym_COMMA] = ACTIONS(2468),
    [anon_sym_null] = ACTIONS(2466),
    [anon_sym_QMARK] = ACTIONS(2466),
    [anon_sym_COLON_QMARK] = ACTIONS(2466),
    [anon_sym_COLON_COLON] = ACTIONS(2468),
    [anon_sym_AMP] = ACTIONS(2466),
    [anon_sym_LBRACK] = ACTIONS(2466),
    [anon_sym_RBRACK] = ACTIONS(2468),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2468),
    [anon_sym_LBRACE] = ACTIONS(2466),
    [anon_sym_RBRACE] = ACTIONS(2468),
    [anon_sym_LT_AT] = ACTIONS(2466),
    [anon_sym_LT_AT_AT] = ACTIONS(2466),
    [anon_sym_DOT] = ACTIONS(2466),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2468),
    [anon_sym_new] = ACTIONS(2466),
    [anon_sym_with] = ACTIONS(2466),
    [anon_sym_return_BANG] = ACTIONS(2468),
    [anon_sym_yield] = ACTIONS(2466),
    [anon_sym_yield_BANG] = ACTIONS(2468),
    [anon_sym_lazy] = ACTIONS(2466),
    [anon_sym_assert] = ACTIONS(2466),
    [anon_sym_upcast] = ACTIONS(2466),
    [anon_sym_downcast] = ACTIONS(2466),
    [anon_sym_COLON_GT] = ACTIONS(2468),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2468),
    [anon_sym_for] = ACTIONS(2466),
    [anon_sym_to] = ACTIONS(2466),
    [anon_sym_downto] = ACTIONS(2466),
    [anon_sym_while] = ACTIONS(2466),
    [anon_sym_if] = ACTIONS(2466),
    [anon_sym_fun] = ACTIONS(2466),
    [anon_sym_DASH_GT] = ACTIONS(2466),
    [anon_sym_try] = ACTIONS(2466),
    [anon_sym_match] = ACTIONS(2466),
    [anon_sym_match_BANG] = ACTIONS(2468),
    [anon_sym_function] = ACTIONS(2466),
    [anon_sym_LT_DASH] = ACTIONS(2466),
    [anon_sym_DOT_LBRACK] = ACTIONS(2468),
    [anon_sym_LT] = ACTIONS(2468),
    [anon_sym_use] = ACTIONS(2466),
    [anon_sym_use_BANG] = ACTIONS(2468),
    [anon_sym_do_BANG] = ACTIONS(2468),
    [anon_sym_begin] = ACTIONS(2466),
    [anon_sym_LPAREN2] = ACTIONS(2466),
    [anon_sym_DOT_DOT2] = ACTIONS(2468),
    [anon_sym_STAR] = ACTIONS(2466),
    [anon_sym_LT2] = ACTIONS(2466),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2468),
    [anon_sym_or] = ACTIONS(2466),
    [aux_sym_char_token1] = ACTIONS(2468),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2466),
    [anon_sym_DQUOTE] = ACTIONS(2466),
    [anon_sym_AT_DQUOTE] = ACTIONS(2468),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2468),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2468),
    [sym_bool] = ACTIONS(2466),
    [sym_unit] = ACTIONS(2468),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2466),
    [sym_op_identifier] = ACTIONS(2466),
    [anon_sym_PLUS] = ACTIONS(2466),
    [anon_sym_DASH] = ACTIONS(2466),
    [anon_sym_PLUS_DOT] = ACTIONS(2466),
    [anon_sym_DASH_DOT] = ACTIONS(2466),
    [anon_sym_PERCENT] = ACTIONS(2466),
    [anon_sym_AMP_AMP] = ACTIONS(2466),
    [anon_sym_TILDE] = ACTIONS(2468),
    [aux_sym_prefix_op_token1] = ACTIONS(2466),
    [aux_sym_infix_op_token1] = ACTIONS(2468),
    [aux_sym_infix_op_token2] = ACTIONS(2466),
    [anon_sym_PIPE_PIPE] = ACTIONS(2466),
    [anon_sym_BANG_EQ] = ACTIONS(2466),
    [anon_sym_COLON_EQ] = ACTIONS(2468),
    [anon_sym_DOLLAR] = ACTIONS(2466),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2466),
    [sym_int] = ACTIONS(2466),
    [sym_xint] = ACTIONS(2468),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2468),
    [sym__newline] = ACTIONS(2468),
  },
  [923] = {
    [sym_block_comment] = STATE(923),
    [sym_compiler_directive_decl] = STATE(923),
    [sym_fsi_directive_decl] = STATE(923),
    [sym_preproc_line] = STATE(923),
    [sym_identifier] = ACTIONS(2627),
    [anon_sym_EQ] = ACTIONS(2629),
    [anon_sym_GT_RBRACK] = ACTIONS(2629),
    [anon_sym_COLON] = ACTIONS(2627),
    [anon_sym_return] = ACTIONS(2627),
    [anon_sym_do] = ACTIONS(2627),
    [anon_sym_let] = ACTIONS(2627),
    [anon_sym_let_BANG] = ACTIONS(2629),
    [anon_sym_LPAREN] = ACTIONS(2627),
    [anon_sym_COMMA] = ACTIONS(2629),
    [anon_sym_null] = ACTIONS(2627),
    [anon_sym_QMARK] = ACTIONS(2627),
    [anon_sym_COLON_QMARK] = ACTIONS(2627),
    [anon_sym_COLON_COLON] = ACTIONS(2629),
    [anon_sym_AMP] = ACTIONS(2627),
    [anon_sym_LBRACK] = ACTIONS(2627),
    [anon_sym_RBRACK] = ACTIONS(2629),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2629),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_RBRACE] = ACTIONS(2629),
    [anon_sym_LT_AT] = ACTIONS(2627),
    [anon_sym_LT_AT_AT] = ACTIONS(2627),
    [anon_sym_DOT] = ACTIONS(2627),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2629),
    [anon_sym_new] = ACTIONS(2627),
    [anon_sym_with] = ACTIONS(2627),
    [anon_sym_return_BANG] = ACTIONS(2629),
    [anon_sym_yield] = ACTIONS(2627),
    [anon_sym_yield_BANG] = ACTIONS(2629),
    [anon_sym_lazy] = ACTIONS(2627),
    [anon_sym_assert] = ACTIONS(2627),
    [anon_sym_upcast] = ACTIONS(2627),
    [anon_sym_downcast] = ACTIONS(2627),
    [anon_sym_COLON_GT] = ACTIONS(2629),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2629),
    [anon_sym_for] = ACTIONS(2627),
    [anon_sym_to] = ACTIONS(2627),
    [anon_sym_downto] = ACTIONS(2627),
    [anon_sym_while] = ACTIONS(2627),
    [anon_sym_if] = ACTIONS(2627),
    [anon_sym_fun] = ACTIONS(2627),
    [anon_sym_DASH_GT] = ACTIONS(2627),
    [anon_sym_try] = ACTIONS(2627),
    [anon_sym_match] = ACTIONS(2627),
    [anon_sym_match_BANG] = ACTIONS(2629),
    [anon_sym_function] = ACTIONS(2627),
    [anon_sym_LT_DASH] = ACTIONS(2627),
    [anon_sym_DOT_LBRACK] = ACTIONS(2629),
    [anon_sym_LT] = ACTIONS(2629),
    [anon_sym_use] = ACTIONS(2627),
    [anon_sym_use_BANG] = ACTIONS(2629),
    [anon_sym_do_BANG] = ACTIONS(2629),
    [anon_sym_begin] = ACTIONS(2627),
    [anon_sym_LPAREN2] = ACTIONS(2627),
    [anon_sym_DOT_DOT2] = ACTIONS(2629),
    [anon_sym_STAR] = ACTIONS(2627),
    [anon_sym_LT2] = ACTIONS(2627),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2629),
    [anon_sym_or] = ACTIONS(2627),
    [aux_sym_char_token1] = ACTIONS(2629),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2627),
    [anon_sym_DQUOTE] = ACTIONS(2627),
    [anon_sym_AT_DQUOTE] = ACTIONS(2629),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2629),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2629),
    [sym_bool] = ACTIONS(2627),
    [sym_unit] = ACTIONS(2629),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2627),
    [sym_op_identifier] = ACTIONS(2627),
    [anon_sym_PLUS] = ACTIONS(2627),
    [anon_sym_DASH] = ACTIONS(2627),
    [anon_sym_PLUS_DOT] = ACTIONS(2627),
    [anon_sym_DASH_DOT] = ACTIONS(2627),
    [anon_sym_PERCENT] = ACTIONS(2627),
    [anon_sym_AMP_AMP] = ACTIONS(2627),
    [anon_sym_TILDE] = ACTIONS(2629),
    [aux_sym_prefix_op_token1] = ACTIONS(2627),
    [aux_sym_infix_op_token1] = ACTIONS(2629),
    [aux_sym_infix_op_token2] = ACTIONS(2627),
    [anon_sym_PIPE_PIPE] = ACTIONS(2627),
    [anon_sym_BANG_EQ] = ACTIONS(2627),
    [anon_sym_COLON_EQ] = ACTIONS(2629),
    [anon_sym_DOLLAR] = ACTIONS(2627),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2627),
    [sym_int] = ACTIONS(2627),
    [sym_xint] = ACTIONS(2629),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2629),
    [sym__newline] = ACTIONS(2629),
  },
  [924] = {
    [sym_block_comment] = STATE(924),
    [sym_compiler_directive_decl] = STATE(924),
    [sym_fsi_directive_decl] = STATE(924),
    [sym_preproc_line] = STATE(924),
    [sym_identifier] = ACTIONS(2462),
    [anon_sym_EQ] = ACTIONS(2464),
    [anon_sym_GT_RBRACK] = ACTIONS(2464),
    [anon_sym_COLON] = ACTIONS(2462),
    [anon_sym_return] = ACTIONS(2462),
    [anon_sym_do] = ACTIONS(2462),
    [anon_sym_let] = ACTIONS(2462),
    [anon_sym_let_BANG] = ACTIONS(2464),
    [anon_sym_LPAREN] = ACTIONS(2462),
    [anon_sym_COMMA] = ACTIONS(2464),
    [anon_sym_null] = ACTIONS(2462),
    [anon_sym_QMARK] = ACTIONS(2462),
    [anon_sym_COLON_QMARK] = ACTIONS(2462),
    [anon_sym_COLON_COLON] = ACTIONS(2464),
    [anon_sym_AMP] = ACTIONS(2462),
    [anon_sym_LBRACK] = ACTIONS(2462),
    [anon_sym_RBRACK] = ACTIONS(2464),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2464),
    [anon_sym_LBRACE] = ACTIONS(2462),
    [anon_sym_RBRACE] = ACTIONS(2464),
    [anon_sym_LT_AT] = ACTIONS(2462),
    [anon_sym_LT_AT_AT] = ACTIONS(2462),
    [anon_sym_DOT] = ACTIONS(2462),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2464),
    [anon_sym_new] = ACTIONS(2462),
    [anon_sym_with] = ACTIONS(2462),
    [anon_sym_return_BANG] = ACTIONS(2464),
    [anon_sym_yield] = ACTIONS(2462),
    [anon_sym_yield_BANG] = ACTIONS(2464),
    [anon_sym_lazy] = ACTIONS(2462),
    [anon_sym_assert] = ACTIONS(2462),
    [anon_sym_upcast] = ACTIONS(2462),
    [anon_sym_downcast] = ACTIONS(2462),
    [anon_sym_COLON_GT] = ACTIONS(2464),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2464),
    [anon_sym_for] = ACTIONS(2462),
    [anon_sym_to] = ACTIONS(2462),
    [anon_sym_downto] = ACTIONS(2462),
    [anon_sym_while] = ACTIONS(2462),
    [anon_sym_if] = ACTIONS(2462),
    [anon_sym_fun] = ACTIONS(2462),
    [anon_sym_DASH_GT] = ACTIONS(2462),
    [anon_sym_try] = ACTIONS(2462),
    [anon_sym_match] = ACTIONS(2462),
    [anon_sym_match_BANG] = ACTIONS(2464),
    [anon_sym_function] = ACTIONS(2462),
    [anon_sym_LT_DASH] = ACTIONS(2462),
    [anon_sym_DOT_LBRACK] = ACTIONS(2464),
    [anon_sym_LT] = ACTIONS(2464),
    [anon_sym_use] = ACTIONS(2462),
    [anon_sym_use_BANG] = ACTIONS(2464),
    [anon_sym_do_BANG] = ACTIONS(2464),
    [anon_sym_begin] = ACTIONS(2462),
    [anon_sym_LPAREN2] = ACTIONS(2462),
    [anon_sym_DOT_DOT2] = ACTIONS(2464),
    [anon_sym_STAR] = ACTIONS(2462),
    [anon_sym_LT2] = ACTIONS(2462),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2464),
    [anon_sym_or] = ACTIONS(2462),
    [aux_sym_char_token1] = ACTIONS(2464),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2462),
    [anon_sym_DQUOTE] = ACTIONS(2462),
    [anon_sym_AT_DQUOTE] = ACTIONS(2464),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2464),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2464),
    [sym_bool] = ACTIONS(2462),
    [sym_unit] = ACTIONS(2464),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2462),
    [sym_op_identifier] = ACTIONS(2462),
    [anon_sym_PLUS] = ACTIONS(2462),
    [anon_sym_DASH] = ACTIONS(2462),
    [anon_sym_PLUS_DOT] = ACTIONS(2462),
    [anon_sym_DASH_DOT] = ACTIONS(2462),
    [anon_sym_PERCENT] = ACTIONS(2462),
    [anon_sym_AMP_AMP] = ACTIONS(2462),
    [anon_sym_TILDE] = ACTIONS(2464),
    [aux_sym_prefix_op_token1] = ACTIONS(2462),
    [aux_sym_infix_op_token1] = ACTIONS(2464),
    [aux_sym_infix_op_token2] = ACTIONS(2462),
    [anon_sym_PIPE_PIPE] = ACTIONS(2462),
    [anon_sym_BANG_EQ] = ACTIONS(2462),
    [anon_sym_COLON_EQ] = ACTIONS(2464),
    [anon_sym_DOLLAR] = ACTIONS(2462),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2462),
    [sym_int] = ACTIONS(2462),
    [sym_xint] = ACTIONS(2464),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2464),
    [sym__newline] = ACTIONS(2464),
  },
  [925] = {
    [sym_block_comment] = STATE(925),
    [sym_compiler_directive_decl] = STATE(925),
    [sym_fsi_directive_decl] = STATE(925),
    [sym_preproc_line] = STATE(925),
    [sym_identifier] = ACTIONS(2411),
    [anon_sym_EQ] = ACTIONS(2413),
    [anon_sym_GT_RBRACK] = ACTIONS(2413),
    [anon_sym_COLON] = ACTIONS(2411),
    [anon_sym_return] = ACTIONS(2411),
    [anon_sym_do] = ACTIONS(2411),
    [anon_sym_let] = ACTIONS(2411),
    [anon_sym_let_BANG] = ACTIONS(2413),
    [anon_sym_LPAREN] = ACTIONS(2411),
    [anon_sym_COMMA] = ACTIONS(2413),
    [anon_sym_null] = ACTIONS(2411),
    [anon_sym_QMARK] = ACTIONS(2411),
    [anon_sym_COLON_QMARK] = ACTIONS(2411),
    [anon_sym_COLON_COLON] = ACTIONS(2413),
    [anon_sym_AMP] = ACTIONS(2411),
    [anon_sym_LBRACK] = ACTIONS(2411),
    [anon_sym_RBRACK] = ACTIONS(2413),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2413),
    [anon_sym_LBRACE] = ACTIONS(2411),
    [anon_sym_RBRACE] = ACTIONS(2413),
    [anon_sym_LT_AT] = ACTIONS(2411),
    [anon_sym_LT_AT_AT] = ACTIONS(2411),
    [anon_sym_DOT] = ACTIONS(2411),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2413),
    [anon_sym_new] = ACTIONS(2411),
    [anon_sym_with] = ACTIONS(2411),
    [anon_sym_return_BANG] = ACTIONS(2413),
    [anon_sym_yield] = ACTIONS(2411),
    [anon_sym_yield_BANG] = ACTIONS(2413),
    [anon_sym_lazy] = ACTIONS(2411),
    [anon_sym_assert] = ACTIONS(2411),
    [anon_sym_upcast] = ACTIONS(2411),
    [anon_sym_downcast] = ACTIONS(2411),
    [anon_sym_COLON_GT] = ACTIONS(2413),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2413),
    [anon_sym_for] = ACTIONS(2411),
    [anon_sym_to] = ACTIONS(2411),
    [anon_sym_downto] = ACTIONS(2411),
    [anon_sym_while] = ACTIONS(2411),
    [anon_sym_if] = ACTIONS(2411),
    [anon_sym_fun] = ACTIONS(2411),
    [anon_sym_DASH_GT] = ACTIONS(2411),
    [anon_sym_try] = ACTIONS(2411),
    [anon_sym_match] = ACTIONS(2411),
    [anon_sym_match_BANG] = ACTIONS(2413),
    [anon_sym_function] = ACTIONS(2411),
    [anon_sym_LT_DASH] = ACTIONS(2411),
    [anon_sym_DOT_LBRACK] = ACTIONS(2413),
    [anon_sym_LT] = ACTIONS(2413),
    [anon_sym_use] = ACTIONS(2411),
    [anon_sym_use_BANG] = ACTIONS(2413),
    [anon_sym_do_BANG] = ACTIONS(2413),
    [anon_sym_begin] = ACTIONS(2411),
    [anon_sym_LPAREN2] = ACTIONS(2411),
    [anon_sym_DOT_DOT2] = ACTIONS(2413),
    [anon_sym_STAR] = ACTIONS(2411),
    [anon_sym_LT2] = ACTIONS(2411),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2413),
    [anon_sym_or] = ACTIONS(2411),
    [aux_sym_char_token1] = ACTIONS(2413),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2411),
    [anon_sym_DQUOTE] = ACTIONS(2411),
    [anon_sym_AT_DQUOTE] = ACTIONS(2413),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2413),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2413),
    [sym_bool] = ACTIONS(2411),
    [sym_unit] = ACTIONS(2413),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2411),
    [sym_op_identifier] = ACTIONS(2411),
    [anon_sym_PLUS] = ACTIONS(2411),
    [anon_sym_DASH] = ACTIONS(2411),
    [anon_sym_PLUS_DOT] = ACTIONS(2411),
    [anon_sym_DASH_DOT] = ACTIONS(2411),
    [anon_sym_PERCENT] = ACTIONS(2411),
    [anon_sym_AMP_AMP] = ACTIONS(2411),
    [anon_sym_TILDE] = ACTIONS(2413),
    [aux_sym_prefix_op_token1] = ACTIONS(2411),
    [aux_sym_infix_op_token1] = ACTIONS(2413),
    [aux_sym_infix_op_token2] = ACTIONS(2411),
    [anon_sym_PIPE_PIPE] = ACTIONS(2411),
    [anon_sym_BANG_EQ] = ACTIONS(2411),
    [anon_sym_COLON_EQ] = ACTIONS(2413),
    [anon_sym_DOLLAR] = ACTIONS(2411),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2411),
    [sym_int] = ACTIONS(2411),
    [sym_xint] = ACTIONS(2413),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2413),
    [sym__newline] = ACTIONS(2413),
  },
  [926] = {
    [sym_block_comment] = STATE(926),
    [sym_compiler_directive_decl] = STATE(926),
    [sym_fsi_directive_decl] = STATE(926),
    [sym_preproc_line] = STATE(926),
    [sym_identifier] = ACTIONS(2506),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_GT_RBRACK] = ACTIONS(2508),
    [anon_sym_COLON] = ACTIONS(2506),
    [anon_sym_return] = ACTIONS(2506),
    [anon_sym_do] = ACTIONS(2506),
    [anon_sym_let] = ACTIONS(2506),
    [anon_sym_let_BANG] = ACTIONS(2508),
    [anon_sym_LPAREN] = ACTIONS(2506),
    [anon_sym_COMMA] = ACTIONS(2508),
    [anon_sym_null] = ACTIONS(2506),
    [anon_sym_QMARK] = ACTIONS(2506),
    [anon_sym_COLON_QMARK] = ACTIONS(2506),
    [anon_sym_COLON_COLON] = ACTIONS(2508),
    [anon_sym_AMP] = ACTIONS(2506),
    [anon_sym_LBRACK] = ACTIONS(2506),
    [anon_sym_RBRACK] = ACTIONS(2508),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2508),
    [anon_sym_LBRACE] = ACTIONS(2506),
    [anon_sym_RBRACE] = ACTIONS(2508),
    [anon_sym_LT_AT] = ACTIONS(2506),
    [anon_sym_LT_AT_AT] = ACTIONS(2506),
    [anon_sym_DOT] = ACTIONS(2506),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2508),
    [anon_sym_new] = ACTIONS(2506),
    [anon_sym_with] = ACTIONS(2506),
    [anon_sym_return_BANG] = ACTIONS(2508),
    [anon_sym_yield] = ACTIONS(2506),
    [anon_sym_yield_BANG] = ACTIONS(2508),
    [anon_sym_lazy] = ACTIONS(2506),
    [anon_sym_assert] = ACTIONS(2506),
    [anon_sym_upcast] = ACTIONS(2506),
    [anon_sym_downcast] = ACTIONS(2506),
    [anon_sym_COLON_GT] = ACTIONS(2508),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2508),
    [anon_sym_for] = ACTIONS(2506),
    [anon_sym_to] = ACTIONS(2506),
    [anon_sym_downto] = ACTIONS(2506),
    [anon_sym_while] = ACTIONS(2506),
    [anon_sym_if] = ACTIONS(2506),
    [anon_sym_fun] = ACTIONS(2506),
    [anon_sym_DASH_GT] = ACTIONS(2506),
    [anon_sym_try] = ACTIONS(2506),
    [anon_sym_match] = ACTIONS(2506),
    [anon_sym_match_BANG] = ACTIONS(2508),
    [anon_sym_function] = ACTIONS(2506),
    [anon_sym_LT_DASH] = ACTIONS(2506),
    [anon_sym_DOT_LBRACK] = ACTIONS(2508),
    [anon_sym_LT] = ACTIONS(2508),
    [anon_sym_use] = ACTIONS(2506),
    [anon_sym_use_BANG] = ACTIONS(2508),
    [anon_sym_do_BANG] = ACTIONS(2508),
    [anon_sym_begin] = ACTIONS(2506),
    [anon_sym_LPAREN2] = ACTIONS(2506),
    [anon_sym_DOT_DOT2] = ACTIONS(2508),
    [anon_sym_STAR] = ACTIONS(2506),
    [anon_sym_LT2] = ACTIONS(2506),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2508),
    [anon_sym_or] = ACTIONS(2506),
    [aux_sym_char_token1] = ACTIONS(2508),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2506),
    [anon_sym_DQUOTE] = ACTIONS(2506),
    [anon_sym_AT_DQUOTE] = ACTIONS(2508),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2508),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2508),
    [sym_bool] = ACTIONS(2506),
    [sym_unit] = ACTIONS(2508),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2506),
    [sym_op_identifier] = ACTIONS(2506),
    [anon_sym_PLUS] = ACTIONS(2506),
    [anon_sym_DASH] = ACTIONS(2506),
    [anon_sym_PLUS_DOT] = ACTIONS(2506),
    [anon_sym_DASH_DOT] = ACTIONS(2506),
    [anon_sym_PERCENT] = ACTIONS(2506),
    [anon_sym_AMP_AMP] = ACTIONS(2506),
    [anon_sym_TILDE] = ACTIONS(2508),
    [aux_sym_prefix_op_token1] = ACTIONS(2506),
    [aux_sym_infix_op_token1] = ACTIONS(2508),
    [aux_sym_infix_op_token2] = ACTIONS(2506),
    [anon_sym_PIPE_PIPE] = ACTIONS(2506),
    [anon_sym_BANG_EQ] = ACTIONS(2506),
    [anon_sym_COLON_EQ] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(2506),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2506),
    [sym_int] = ACTIONS(2506),
    [sym_xint] = ACTIONS(2508),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2508),
    [sym__newline] = ACTIONS(2508),
  },
  [927] = {
    [sym_block_comment] = STATE(927),
    [sym_compiler_directive_decl] = STATE(927),
    [sym_fsi_directive_decl] = STATE(927),
    [sym_preproc_line] = STATE(927),
    [sym_identifier] = ACTIONS(3039),
    [anon_sym_EQ] = ACTIONS(3041),
    [anon_sym_LBRACK_LT] = ACTIONS(3041),
    [anon_sym_COLON] = ACTIONS(3039),
    [anon_sym_return] = ACTIONS(3039),
    [anon_sym_do] = ACTIONS(3039),
    [anon_sym_let] = ACTIONS(3039),
    [anon_sym_let_BANG] = ACTIONS(3041),
    [aux_sym_access_modifier_token1] = ACTIONS(3041),
    [anon_sym_LPAREN] = ACTIONS(3039),
    [anon_sym_COMMA] = ACTIONS(3041),
    [anon_sym_null] = ACTIONS(3039),
    [anon_sym_QMARK] = ACTIONS(3039),
    [anon_sym_COLON_QMARK] = ACTIONS(3039),
    [anon_sym_COLON_COLON] = ACTIONS(3041),
    [anon_sym_AMP] = ACTIONS(3039),
    [anon_sym_LBRACK] = ACTIONS(3039),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3041),
    [anon_sym_LBRACE] = ACTIONS(3039),
    [anon_sym_LT_AT] = ACTIONS(3039),
    [anon_sym_LT_AT_AT] = ACTIONS(3039),
    [anon_sym_DOT] = ACTIONS(3039),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3041),
    [anon_sym_new] = ACTIONS(3039),
    [anon_sym_with] = ACTIONS(3039),
    [anon_sym_return_BANG] = ACTIONS(3041),
    [anon_sym_yield] = ACTIONS(3039),
    [anon_sym_yield_BANG] = ACTIONS(3041),
    [anon_sym_lazy] = ACTIONS(3039),
    [anon_sym_assert] = ACTIONS(3039),
    [anon_sym_upcast] = ACTIONS(3039),
    [anon_sym_downcast] = ACTIONS(3039),
    [anon_sym_COLON_GT] = ACTIONS(3041),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3041),
    [anon_sym_for] = ACTIONS(3039),
    [anon_sym_while] = ACTIONS(3039),
    [anon_sym_if] = ACTIONS(3039),
    [anon_sym_fun] = ACTIONS(3039),
    [anon_sym_try] = ACTIONS(3039),
    [anon_sym_match] = ACTIONS(3039),
    [anon_sym_match_BANG] = ACTIONS(3041),
    [anon_sym_function] = ACTIONS(3039),
    [anon_sym_LT_DASH] = ACTIONS(3039),
    [anon_sym_DOT_LBRACK] = ACTIONS(3041),
    [anon_sym_LT] = ACTIONS(3041),
    [anon_sym_use] = ACTIONS(3039),
    [anon_sym_use_BANG] = ACTIONS(3041),
    [anon_sym_do_BANG] = ACTIONS(3041),
    [anon_sym_begin] = ACTIONS(3039),
    [anon_sym_LPAREN2] = ACTIONS(3039),
    [anon_sym_DOT_DOT2] = ACTIONS(3041),
    [anon_sym_default] = ACTIONS(3039),
    [anon_sym_or] = ACTIONS(3039),
    [anon_sym_static] = ACTIONS(3039),
    [anon_sym_member] = ACTIONS(3039),
    [anon_sym_abstract] = ACTIONS(3039),
    [anon_sym_val] = ACTIONS(3039),
    [anon_sym_override] = ACTIONS(3039),
    [aux_sym_char_token1] = ACTIONS(3041),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3039),
    [anon_sym_DQUOTE] = ACTIONS(3039),
    [anon_sym_AT_DQUOTE] = ACTIONS(3041),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3041),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3041),
    [sym_bool] = ACTIONS(3039),
    [sym_unit] = ACTIONS(3041),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3039),
    [sym_op_identifier] = ACTIONS(3039),
    [anon_sym_PLUS] = ACTIONS(3039),
    [anon_sym_DASH] = ACTIONS(3039),
    [anon_sym_PLUS_DOT] = ACTIONS(3039),
    [anon_sym_DASH_DOT] = ACTIONS(3039),
    [anon_sym_PERCENT] = ACTIONS(3039),
    [anon_sym_AMP_AMP] = ACTIONS(3039),
    [anon_sym_TILDE] = ACTIONS(3041),
    [aux_sym_prefix_op_token1] = ACTIONS(3039),
    [aux_sym_infix_op_token1] = ACTIONS(3041),
    [aux_sym_infix_op_token2] = ACTIONS(3039),
    [anon_sym_PIPE_PIPE] = ACTIONS(3039),
    [anon_sym_BANG_EQ] = ACTIONS(3039),
    [anon_sym_COLON_EQ] = ACTIONS(3041),
    [anon_sym_DOLLAR] = ACTIONS(3039),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3039),
    [sym_int] = ACTIONS(3039),
    [sym_xint] = ACTIONS(3041),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3041),
    [sym__newline] = ACTIONS(3041),
    [sym__dedent] = ACTIONS(3041),
  },
  [928] = {
    [sym_block_comment] = STATE(928),
    [sym_compiler_directive_decl] = STATE(928),
    [sym_fsi_directive_decl] = STATE(928),
    [sym_preproc_line] = STATE(928),
    [sym_identifier] = ACTIONS(3043),
    [anon_sym_EQ] = ACTIONS(3045),
    [anon_sym_LBRACK_LT] = ACTIONS(3045),
    [anon_sym_COLON] = ACTIONS(3043),
    [anon_sym_return] = ACTIONS(3043),
    [anon_sym_do] = ACTIONS(3043),
    [anon_sym_let] = ACTIONS(3043),
    [anon_sym_let_BANG] = ACTIONS(3045),
    [aux_sym_access_modifier_token1] = ACTIONS(3045),
    [anon_sym_LPAREN] = ACTIONS(3043),
    [anon_sym_COMMA] = ACTIONS(3045),
    [anon_sym_null] = ACTIONS(3043),
    [anon_sym_QMARK] = ACTIONS(3043),
    [anon_sym_COLON_QMARK] = ACTIONS(3043),
    [anon_sym_COLON_COLON] = ACTIONS(3045),
    [anon_sym_AMP] = ACTIONS(3043),
    [anon_sym_LBRACK] = ACTIONS(3043),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3045),
    [anon_sym_LBRACE] = ACTIONS(3043),
    [anon_sym_LT_AT] = ACTIONS(3043),
    [anon_sym_LT_AT_AT] = ACTIONS(3043),
    [anon_sym_DOT] = ACTIONS(3043),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3045),
    [anon_sym_new] = ACTIONS(3043),
    [anon_sym_with] = ACTIONS(3043),
    [anon_sym_return_BANG] = ACTIONS(3045),
    [anon_sym_yield] = ACTIONS(3043),
    [anon_sym_yield_BANG] = ACTIONS(3045),
    [anon_sym_lazy] = ACTIONS(3043),
    [anon_sym_assert] = ACTIONS(3043),
    [anon_sym_upcast] = ACTIONS(3043),
    [anon_sym_downcast] = ACTIONS(3043),
    [anon_sym_COLON_GT] = ACTIONS(3045),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3045),
    [anon_sym_for] = ACTIONS(3043),
    [anon_sym_while] = ACTIONS(3043),
    [anon_sym_if] = ACTIONS(3043),
    [anon_sym_fun] = ACTIONS(3043),
    [anon_sym_try] = ACTIONS(3043),
    [anon_sym_match] = ACTIONS(3043),
    [anon_sym_match_BANG] = ACTIONS(3045),
    [anon_sym_function] = ACTIONS(3043),
    [anon_sym_LT_DASH] = ACTIONS(3043),
    [anon_sym_DOT_LBRACK] = ACTIONS(3045),
    [anon_sym_LT] = ACTIONS(3045),
    [anon_sym_use] = ACTIONS(3043),
    [anon_sym_use_BANG] = ACTIONS(3045),
    [anon_sym_do_BANG] = ACTIONS(3045),
    [anon_sym_begin] = ACTIONS(3043),
    [anon_sym_LPAREN2] = ACTIONS(3043),
    [anon_sym_DOT_DOT2] = ACTIONS(3045),
    [anon_sym_default] = ACTIONS(3043),
    [anon_sym_or] = ACTIONS(3043),
    [anon_sym_static] = ACTIONS(3043),
    [anon_sym_member] = ACTIONS(3043),
    [anon_sym_abstract] = ACTIONS(3043),
    [anon_sym_val] = ACTIONS(3043),
    [anon_sym_override] = ACTIONS(3043),
    [aux_sym_char_token1] = ACTIONS(3045),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3043),
    [anon_sym_DQUOTE] = ACTIONS(3043),
    [anon_sym_AT_DQUOTE] = ACTIONS(3045),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3045),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3045),
    [sym_bool] = ACTIONS(3043),
    [sym_unit] = ACTIONS(3045),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3043),
    [sym_op_identifier] = ACTIONS(3043),
    [anon_sym_PLUS] = ACTIONS(3043),
    [anon_sym_DASH] = ACTIONS(3043),
    [anon_sym_PLUS_DOT] = ACTIONS(3043),
    [anon_sym_DASH_DOT] = ACTIONS(3043),
    [anon_sym_PERCENT] = ACTIONS(3043),
    [anon_sym_AMP_AMP] = ACTIONS(3043),
    [anon_sym_TILDE] = ACTIONS(3045),
    [aux_sym_prefix_op_token1] = ACTIONS(3043),
    [aux_sym_infix_op_token1] = ACTIONS(3045),
    [aux_sym_infix_op_token2] = ACTIONS(3043),
    [anon_sym_PIPE_PIPE] = ACTIONS(3043),
    [anon_sym_BANG_EQ] = ACTIONS(3043),
    [anon_sym_COLON_EQ] = ACTIONS(3045),
    [anon_sym_DOLLAR] = ACTIONS(3043),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3043),
    [sym_int] = ACTIONS(3043),
    [sym_xint] = ACTIONS(3045),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3045),
    [sym__newline] = ACTIONS(3045),
    [sym__dedent] = ACTIONS(3045),
  },
  [929] = {
    [sym_block_comment] = STATE(929),
    [sym_compiler_directive_decl] = STATE(929),
    [sym_fsi_directive_decl] = STATE(929),
    [sym_preproc_line] = STATE(929),
    [sym_identifier] = ACTIONS(3047),
    [anon_sym_EQ] = ACTIONS(3049),
    [anon_sym_LBRACK_LT] = ACTIONS(3049),
    [anon_sym_COLON] = ACTIONS(3047),
    [anon_sym_return] = ACTIONS(3047),
    [anon_sym_do] = ACTIONS(3047),
    [anon_sym_let] = ACTIONS(3047),
    [anon_sym_let_BANG] = ACTIONS(3049),
    [aux_sym_access_modifier_token1] = ACTIONS(3049),
    [anon_sym_LPAREN] = ACTIONS(3047),
    [anon_sym_COMMA] = ACTIONS(3049),
    [anon_sym_null] = ACTIONS(3047),
    [anon_sym_QMARK] = ACTIONS(3047),
    [anon_sym_COLON_QMARK] = ACTIONS(3047),
    [anon_sym_COLON_COLON] = ACTIONS(3049),
    [anon_sym_AMP] = ACTIONS(3047),
    [anon_sym_LBRACK] = ACTIONS(3047),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3049),
    [anon_sym_LBRACE] = ACTIONS(3047),
    [anon_sym_LT_AT] = ACTIONS(3047),
    [anon_sym_LT_AT_AT] = ACTIONS(3047),
    [anon_sym_DOT] = ACTIONS(3047),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3049),
    [anon_sym_new] = ACTIONS(3047),
    [anon_sym_with] = ACTIONS(3047),
    [anon_sym_return_BANG] = ACTIONS(3049),
    [anon_sym_yield] = ACTIONS(3047),
    [anon_sym_yield_BANG] = ACTIONS(3049),
    [anon_sym_lazy] = ACTIONS(3047),
    [anon_sym_assert] = ACTIONS(3047),
    [anon_sym_upcast] = ACTIONS(3047),
    [anon_sym_downcast] = ACTIONS(3047),
    [anon_sym_COLON_GT] = ACTIONS(3049),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3049),
    [anon_sym_for] = ACTIONS(3047),
    [anon_sym_while] = ACTIONS(3047),
    [anon_sym_if] = ACTIONS(3047),
    [anon_sym_fun] = ACTIONS(3047),
    [anon_sym_try] = ACTIONS(3047),
    [anon_sym_match] = ACTIONS(3047),
    [anon_sym_match_BANG] = ACTIONS(3049),
    [anon_sym_function] = ACTIONS(3047),
    [anon_sym_LT_DASH] = ACTIONS(3047),
    [anon_sym_DOT_LBRACK] = ACTIONS(3049),
    [anon_sym_LT] = ACTIONS(3049),
    [anon_sym_use] = ACTIONS(3047),
    [anon_sym_use_BANG] = ACTIONS(3049),
    [anon_sym_do_BANG] = ACTIONS(3049),
    [anon_sym_begin] = ACTIONS(3047),
    [anon_sym_LPAREN2] = ACTIONS(3047),
    [anon_sym_DOT_DOT2] = ACTIONS(3049),
    [anon_sym_default] = ACTIONS(3047),
    [anon_sym_or] = ACTIONS(3047),
    [anon_sym_static] = ACTIONS(3047),
    [anon_sym_member] = ACTIONS(3047),
    [anon_sym_abstract] = ACTIONS(3047),
    [anon_sym_val] = ACTIONS(3047),
    [anon_sym_override] = ACTIONS(3047),
    [aux_sym_char_token1] = ACTIONS(3049),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3047),
    [anon_sym_DQUOTE] = ACTIONS(3047),
    [anon_sym_AT_DQUOTE] = ACTIONS(3049),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3049),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3049),
    [sym_bool] = ACTIONS(3047),
    [sym_unit] = ACTIONS(3049),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3047),
    [sym_op_identifier] = ACTIONS(3047),
    [anon_sym_PLUS] = ACTIONS(3047),
    [anon_sym_DASH] = ACTIONS(3047),
    [anon_sym_PLUS_DOT] = ACTIONS(3047),
    [anon_sym_DASH_DOT] = ACTIONS(3047),
    [anon_sym_PERCENT] = ACTIONS(3047),
    [anon_sym_AMP_AMP] = ACTIONS(3047),
    [anon_sym_TILDE] = ACTIONS(3049),
    [aux_sym_prefix_op_token1] = ACTIONS(3047),
    [aux_sym_infix_op_token1] = ACTIONS(3049),
    [aux_sym_infix_op_token2] = ACTIONS(3047),
    [anon_sym_PIPE_PIPE] = ACTIONS(3047),
    [anon_sym_BANG_EQ] = ACTIONS(3047),
    [anon_sym_COLON_EQ] = ACTIONS(3049),
    [anon_sym_DOLLAR] = ACTIONS(3047),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3047),
    [sym_int] = ACTIONS(3047),
    [sym_xint] = ACTIONS(3049),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3049),
    [sym__newline] = ACTIONS(3049),
    [sym__dedent] = ACTIONS(3049),
  },
  [930] = {
    [sym_block_comment] = STATE(930),
    [sym_compiler_directive_decl] = STATE(930),
    [sym_fsi_directive_decl] = STATE(930),
    [sym_preproc_line] = STATE(930),
    [sym_identifier] = ACTIONS(2514),
    [anon_sym_EQ] = ACTIONS(2516),
    [anon_sym_GT_RBRACK] = ACTIONS(2516),
    [anon_sym_COLON] = ACTIONS(2514),
    [anon_sym_return] = ACTIONS(2514),
    [anon_sym_do] = ACTIONS(2514),
    [anon_sym_let] = ACTIONS(2514),
    [anon_sym_let_BANG] = ACTIONS(2516),
    [anon_sym_LPAREN] = ACTIONS(2514),
    [anon_sym_COMMA] = ACTIONS(2516),
    [anon_sym_null] = ACTIONS(2514),
    [anon_sym_QMARK] = ACTIONS(2514),
    [anon_sym_COLON_QMARK] = ACTIONS(2514),
    [anon_sym_COLON_COLON] = ACTIONS(2516),
    [anon_sym_AMP] = ACTIONS(2514),
    [anon_sym_LBRACK] = ACTIONS(2514),
    [anon_sym_RBRACK] = ACTIONS(2516),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2516),
    [anon_sym_LBRACE] = ACTIONS(2514),
    [anon_sym_RBRACE] = ACTIONS(2516),
    [anon_sym_LT_AT] = ACTIONS(2514),
    [anon_sym_LT_AT_AT] = ACTIONS(2514),
    [anon_sym_DOT] = ACTIONS(2514),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2516),
    [anon_sym_new] = ACTIONS(2514),
    [anon_sym_with] = ACTIONS(2514),
    [anon_sym_return_BANG] = ACTIONS(2516),
    [anon_sym_yield] = ACTIONS(2514),
    [anon_sym_yield_BANG] = ACTIONS(2516),
    [anon_sym_lazy] = ACTIONS(2514),
    [anon_sym_assert] = ACTIONS(2514),
    [anon_sym_upcast] = ACTIONS(2514),
    [anon_sym_downcast] = ACTIONS(2514),
    [anon_sym_COLON_GT] = ACTIONS(2516),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2516),
    [anon_sym_for] = ACTIONS(2514),
    [anon_sym_to] = ACTIONS(2514),
    [anon_sym_downto] = ACTIONS(2514),
    [anon_sym_while] = ACTIONS(2514),
    [anon_sym_if] = ACTIONS(2514),
    [anon_sym_fun] = ACTIONS(2514),
    [anon_sym_DASH_GT] = ACTIONS(2514),
    [anon_sym_try] = ACTIONS(2514),
    [anon_sym_match] = ACTIONS(2514),
    [anon_sym_match_BANG] = ACTIONS(2516),
    [anon_sym_function] = ACTIONS(2514),
    [anon_sym_LT_DASH] = ACTIONS(2514),
    [anon_sym_DOT_LBRACK] = ACTIONS(2516),
    [anon_sym_LT] = ACTIONS(2516),
    [anon_sym_use] = ACTIONS(2514),
    [anon_sym_use_BANG] = ACTIONS(2516),
    [anon_sym_do_BANG] = ACTIONS(2516),
    [anon_sym_begin] = ACTIONS(2514),
    [anon_sym_LPAREN2] = ACTIONS(2514),
    [anon_sym_DOT_DOT2] = ACTIONS(2516),
    [anon_sym_STAR] = ACTIONS(2514),
    [anon_sym_LT2] = ACTIONS(2514),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2516),
    [anon_sym_or] = ACTIONS(2514),
    [aux_sym_char_token1] = ACTIONS(2516),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2514),
    [anon_sym_DQUOTE] = ACTIONS(2514),
    [anon_sym_AT_DQUOTE] = ACTIONS(2516),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2516),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2516),
    [sym_bool] = ACTIONS(2514),
    [sym_unit] = ACTIONS(2516),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2514),
    [sym_op_identifier] = ACTIONS(2514),
    [anon_sym_PLUS] = ACTIONS(2514),
    [anon_sym_DASH] = ACTIONS(2514),
    [anon_sym_PLUS_DOT] = ACTIONS(2514),
    [anon_sym_DASH_DOT] = ACTIONS(2514),
    [anon_sym_PERCENT] = ACTIONS(2514),
    [anon_sym_AMP_AMP] = ACTIONS(2514),
    [anon_sym_TILDE] = ACTIONS(2516),
    [aux_sym_prefix_op_token1] = ACTIONS(2514),
    [aux_sym_infix_op_token1] = ACTIONS(2516),
    [aux_sym_infix_op_token2] = ACTIONS(2514),
    [anon_sym_PIPE_PIPE] = ACTIONS(2514),
    [anon_sym_BANG_EQ] = ACTIONS(2514),
    [anon_sym_COLON_EQ] = ACTIONS(2516),
    [anon_sym_DOLLAR] = ACTIONS(2514),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2514),
    [sym_int] = ACTIONS(2514),
    [sym_xint] = ACTIONS(2516),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2516),
    [sym__newline] = ACTIONS(2516),
  },
  [931] = {
    [sym_block_comment] = STATE(931),
    [sym_compiler_directive_decl] = STATE(931),
    [sym_fsi_directive_decl] = STATE(931),
    [sym_preproc_line] = STATE(931),
    [sym_identifier] = ACTIONS(3051),
    [anon_sym_EQ] = ACTIONS(3053),
    [anon_sym_LBRACK_LT] = ACTIONS(3053),
    [anon_sym_COLON] = ACTIONS(3051),
    [anon_sym_return] = ACTIONS(3051),
    [anon_sym_do] = ACTIONS(3051),
    [anon_sym_let] = ACTIONS(3051),
    [anon_sym_let_BANG] = ACTIONS(3053),
    [aux_sym_access_modifier_token1] = ACTIONS(3053),
    [anon_sym_LPAREN] = ACTIONS(3051),
    [anon_sym_COMMA] = ACTIONS(3053),
    [anon_sym_null] = ACTIONS(3051),
    [anon_sym_QMARK] = ACTIONS(3051),
    [anon_sym_COLON_QMARK] = ACTIONS(3051),
    [anon_sym_COLON_COLON] = ACTIONS(3053),
    [anon_sym_AMP] = ACTIONS(3051),
    [anon_sym_LBRACK] = ACTIONS(3051),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3053),
    [anon_sym_LBRACE] = ACTIONS(3051),
    [anon_sym_LT_AT] = ACTIONS(3051),
    [anon_sym_LT_AT_AT] = ACTIONS(3051),
    [anon_sym_DOT] = ACTIONS(3051),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3053),
    [anon_sym_new] = ACTIONS(3051),
    [anon_sym_with] = ACTIONS(3051),
    [anon_sym_return_BANG] = ACTIONS(3053),
    [anon_sym_yield] = ACTIONS(3051),
    [anon_sym_yield_BANG] = ACTIONS(3053),
    [anon_sym_lazy] = ACTIONS(3051),
    [anon_sym_assert] = ACTIONS(3051),
    [anon_sym_upcast] = ACTIONS(3051),
    [anon_sym_downcast] = ACTIONS(3051),
    [anon_sym_COLON_GT] = ACTIONS(3053),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3053),
    [anon_sym_for] = ACTIONS(3051),
    [anon_sym_while] = ACTIONS(3051),
    [anon_sym_if] = ACTIONS(3051),
    [anon_sym_fun] = ACTIONS(3051),
    [anon_sym_try] = ACTIONS(3051),
    [anon_sym_match] = ACTIONS(3051),
    [anon_sym_match_BANG] = ACTIONS(3053),
    [anon_sym_function] = ACTIONS(3051),
    [anon_sym_LT_DASH] = ACTIONS(3051),
    [anon_sym_DOT_LBRACK] = ACTIONS(3053),
    [anon_sym_LT] = ACTIONS(3053),
    [anon_sym_use] = ACTIONS(3051),
    [anon_sym_use_BANG] = ACTIONS(3053),
    [anon_sym_do_BANG] = ACTIONS(3053),
    [anon_sym_begin] = ACTIONS(3051),
    [anon_sym_LPAREN2] = ACTIONS(3051),
    [anon_sym_DOT_DOT2] = ACTIONS(3053),
    [anon_sym_default] = ACTIONS(3051),
    [anon_sym_or] = ACTIONS(3051),
    [anon_sym_static] = ACTIONS(3051),
    [anon_sym_member] = ACTIONS(3051),
    [anon_sym_abstract] = ACTIONS(3051),
    [anon_sym_val] = ACTIONS(3051),
    [anon_sym_override] = ACTIONS(3051),
    [aux_sym_char_token1] = ACTIONS(3053),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3051),
    [anon_sym_DQUOTE] = ACTIONS(3051),
    [anon_sym_AT_DQUOTE] = ACTIONS(3053),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3053),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3053),
    [sym_bool] = ACTIONS(3051),
    [sym_unit] = ACTIONS(3053),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3051),
    [sym_op_identifier] = ACTIONS(3051),
    [anon_sym_PLUS] = ACTIONS(3051),
    [anon_sym_DASH] = ACTIONS(3051),
    [anon_sym_PLUS_DOT] = ACTIONS(3051),
    [anon_sym_DASH_DOT] = ACTIONS(3051),
    [anon_sym_PERCENT] = ACTIONS(3051),
    [anon_sym_AMP_AMP] = ACTIONS(3051),
    [anon_sym_TILDE] = ACTIONS(3053),
    [aux_sym_prefix_op_token1] = ACTIONS(3051),
    [aux_sym_infix_op_token1] = ACTIONS(3053),
    [aux_sym_infix_op_token2] = ACTIONS(3051),
    [anon_sym_PIPE_PIPE] = ACTIONS(3051),
    [anon_sym_BANG_EQ] = ACTIONS(3051),
    [anon_sym_COLON_EQ] = ACTIONS(3053),
    [anon_sym_DOLLAR] = ACTIONS(3051),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3051),
    [sym_int] = ACTIONS(3051),
    [sym_xint] = ACTIONS(3053),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3053),
    [sym__newline] = ACTIONS(3053),
    [sym__dedent] = ACTIONS(3053),
  },
  [932] = {
    [sym_block_comment] = STATE(932),
    [sym_compiler_directive_decl] = STATE(932),
    [sym_fsi_directive_decl] = STATE(932),
    [sym_preproc_line] = STATE(932),
    [sym_identifier] = ACTIONS(3055),
    [anon_sym_EQ] = ACTIONS(3057),
    [anon_sym_LBRACK_LT] = ACTIONS(3057),
    [anon_sym_COLON] = ACTIONS(3055),
    [anon_sym_return] = ACTIONS(3055),
    [anon_sym_do] = ACTIONS(3055),
    [anon_sym_let] = ACTIONS(3055),
    [anon_sym_let_BANG] = ACTIONS(3057),
    [aux_sym_access_modifier_token1] = ACTIONS(3057),
    [anon_sym_LPAREN] = ACTIONS(3055),
    [anon_sym_COMMA] = ACTIONS(3057),
    [anon_sym_null] = ACTIONS(3055),
    [anon_sym_QMARK] = ACTIONS(3055),
    [anon_sym_COLON_QMARK] = ACTIONS(3055),
    [anon_sym_COLON_COLON] = ACTIONS(3057),
    [anon_sym_AMP] = ACTIONS(3055),
    [anon_sym_LBRACK] = ACTIONS(3055),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3057),
    [anon_sym_LBRACE] = ACTIONS(3055),
    [anon_sym_LT_AT] = ACTIONS(3055),
    [anon_sym_LT_AT_AT] = ACTIONS(3055),
    [anon_sym_DOT] = ACTIONS(3055),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3057),
    [anon_sym_new] = ACTIONS(3055),
    [anon_sym_with] = ACTIONS(3055),
    [anon_sym_return_BANG] = ACTIONS(3057),
    [anon_sym_yield] = ACTIONS(3055),
    [anon_sym_yield_BANG] = ACTIONS(3057),
    [anon_sym_lazy] = ACTIONS(3055),
    [anon_sym_assert] = ACTIONS(3055),
    [anon_sym_upcast] = ACTIONS(3055),
    [anon_sym_downcast] = ACTIONS(3055),
    [anon_sym_COLON_GT] = ACTIONS(3057),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3057),
    [anon_sym_for] = ACTIONS(3055),
    [anon_sym_while] = ACTIONS(3055),
    [anon_sym_if] = ACTIONS(3055),
    [anon_sym_fun] = ACTIONS(3055),
    [anon_sym_try] = ACTIONS(3055),
    [anon_sym_match] = ACTIONS(3055),
    [anon_sym_match_BANG] = ACTIONS(3057),
    [anon_sym_function] = ACTIONS(3055),
    [anon_sym_LT_DASH] = ACTIONS(3055),
    [anon_sym_DOT_LBRACK] = ACTIONS(3057),
    [anon_sym_LT] = ACTIONS(3057),
    [anon_sym_use] = ACTIONS(3055),
    [anon_sym_use_BANG] = ACTIONS(3057),
    [anon_sym_do_BANG] = ACTIONS(3057),
    [anon_sym_begin] = ACTIONS(3055),
    [anon_sym_LPAREN2] = ACTIONS(3055),
    [anon_sym_DOT_DOT2] = ACTIONS(3057),
    [anon_sym_default] = ACTIONS(3055),
    [anon_sym_or] = ACTIONS(3055),
    [anon_sym_static] = ACTIONS(3055),
    [anon_sym_member] = ACTIONS(3055),
    [anon_sym_abstract] = ACTIONS(3055),
    [anon_sym_val] = ACTIONS(3055),
    [anon_sym_override] = ACTIONS(3055),
    [aux_sym_char_token1] = ACTIONS(3057),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3055),
    [anon_sym_DQUOTE] = ACTIONS(3055),
    [anon_sym_AT_DQUOTE] = ACTIONS(3057),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3057),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3057),
    [sym_bool] = ACTIONS(3055),
    [sym_unit] = ACTIONS(3057),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3055),
    [sym_op_identifier] = ACTIONS(3055),
    [anon_sym_PLUS] = ACTIONS(3055),
    [anon_sym_DASH] = ACTIONS(3055),
    [anon_sym_PLUS_DOT] = ACTIONS(3055),
    [anon_sym_DASH_DOT] = ACTIONS(3055),
    [anon_sym_PERCENT] = ACTIONS(3055),
    [anon_sym_AMP_AMP] = ACTIONS(3055),
    [anon_sym_TILDE] = ACTIONS(3057),
    [aux_sym_prefix_op_token1] = ACTIONS(3055),
    [aux_sym_infix_op_token1] = ACTIONS(3057),
    [aux_sym_infix_op_token2] = ACTIONS(3055),
    [anon_sym_PIPE_PIPE] = ACTIONS(3055),
    [anon_sym_BANG_EQ] = ACTIONS(3055),
    [anon_sym_COLON_EQ] = ACTIONS(3057),
    [anon_sym_DOLLAR] = ACTIONS(3055),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3055),
    [sym_int] = ACTIONS(3055),
    [sym_xint] = ACTIONS(3057),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3057),
    [sym__newline] = ACTIONS(3057),
    [sym__dedent] = ACTIONS(3057),
  },
  [933] = {
    [sym_block_comment] = STATE(933),
    [sym_compiler_directive_decl] = STATE(933),
    [sym_fsi_directive_decl] = STATE(933),
    [sym_preproc_line] = STATE(933),
    [sym_identifier] = ACTIONS(2563),
    [anon_sym_EQ] = ACTIONS(2565),
    [anon_sym_GT_RBRACK] = ACTIONS(2565),
    [anon_sym_COLON] = ACTIONS(2563),
    [anon_sym_return] = ACTIONS(2563),
    [anon_sym_do] = ACTIONS(2563),
    [anon_sym_let] = ACTIONS(2563),
    [anon_sym_let_BANG] = ACTIONS(2565),
    [anon_sym_LPAREN] = ACTIONS(2563),
    [anon_sym_COMMA] = ACTIONS(2565),
    [anon_sym_null] = ACTIONS(2563),
    [anon_sym_QMARK] = ACTIONS(2563),
    [anon_sym_COLON_QMARK] = ACTIONS(2563),
    [anon_sym_COLON_COLON] = ACTIONS(2565),
    [anon_sym_AMP] = ACTIONS(2563),
    [anon_sym_LBRACK] = ACTIONS(2563),
    [anon_sym_RBRACK] = ACTIONS(2565),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2565),
    [anon_sym_LBRACE] = ACTIONS(2563),
    [anon_sym_RBRACE] = ACTIONS(2565),
    [anon_sym_LT_AT] = ACTIONS(2563),
    [anon_sym_LT_AT_AT] = ACTIONS(2563),
    [anon_sym_DOT] = ACTIONS(2563),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2565),
    [anon_sym_new] = ACTIONS(2563),
    [anon_sym_with] = ACTIONS(2563),
    [anon_sym_return_BANG] = ACTIONS(2565),
    [anon_sym_yield] = ACTIONS(2563),
    [anon_sym_yield_BANG] = ACTIONS(2565),
    [anon_sym_lazy] = ACTIONS(2563),
    [anon_sym_assert] = ACTIONS(2563),
    [anon_sym_upcast] = ACTIONS(2563),
    [anon_sym_downcast] = ACTIONS(2563),
    [anon_sym_COLON_GT] = ACTIONS(2565),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2565),
    [anon_sym_for] = ACTIONS(2563),
    [anon_sym_to] = ACTIONS(2563),
    [anon_sym_downto] = ACTIONS(2563),
    [anon_sym_while] = ACTIONS(2563),
    [anon_sym_if] = ACTIONS(2563),
    [anon_sym_fun] = ACTIONS(2563),
    [anon_sym_DASH_GT] = ACTIONS(2563),
    [anon_sym_try] = ACTIONS(2563),
    [anon_sym_match] = ACTIONS(2563),
    [anon_sym_match_BANG] = ACTIONS(2565),
    [anon_sym_function] = ACTIONS(2563),
    [anon_sym_LT_DASH] = ACTIONS(2563),
    [anon_sym_DOT_LBRACK] = ACTIONS(2565),
    [anon_sym_LT] = ACTIONS(2565),
    [anon_sym_use] = ACTIONS(2563),
    [anon_sym_use_BANG] = ACTIONS(2565),
    [anon_sym_do_BANG] = ACTIONS(2565),
    [anon_sym_begin] = ACTIONS(2563),
    [anon_sym_LPAREN2] = ACTIONS(2563),
    [anon_sym_DOT_DOT2] = ACTIONS(2565),
    [anon_sym_STAR] = ACTIONS(2563),
    [anon_sym_LT2] = ACTIONS(2563),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2565),
    [anon_sym_or] = ACTIONS(2563),
    [aux_sym_char_token1] = ACTIONS(2565),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2563),
    [anon_sym_DQUOTE] = ACTIONS(2563),
    [anon_sym_AT_DQUOTE] = ACTIONS(2565),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2565),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2565),
    [sym_bool] = ACTIONS(2563),
    [sym_unit] = ACTIONS(2565),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2563),
    [sym_op_identifier] = ACTIONS(2563),
    [anon_sym_PLUS] = ACTIONS(2563),
    [anon_sym_DASH] = ACTIONS(2563),
    [anon_sym_PLUS_DOT] = ACTIONS(2563),
    [anon_sym_DASH_DOT] = ACTIONS(2563),
    [anon_sym_PERCENT] = ACTIONS(2563),
    [anon_sym_AMP_AMP] = ACTIONS(2563),
    [anon_sym_TILDE] = ACTIONS(2565),
    [aux_sym_prefix_op_token1] = ACTIONS(2563),
    [aux_sym_infix_op_token1] = ACTIONS(2565),
    [aux_sym_infix_op_token2] = ACTIONS(2563),
    [anon_sym_PIPE_PIPE] = ACTIONS(2563),
    [anon_sym_BANG_EQ] = ACTIONS(2563),
    [anon_sym_COLON_EQ] = ACTIONS(2565),
    [anon_sym_DOLLAR] = ACTIONS(2563),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2563),
    [sym_int] = ACTIONS(2563),
    [sym_xint] = ACTIONS(2565),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2565),
    [sym__newline] = ACTIONS(2565),
  },
  [934] = {
    [sym_block_comment] = STATE(934),
    [sym_compiler_directive_decl] = STATE(934),
    [sym_fsi_directive_decl] = STATE(934),
    [sym_preproc_line] = STATE(934),
    [sym_identifier] = ACTIONS(2340),
    [anon_sym_EQ] = ACTIONS(2342),
    [anon_sym_GT_RBRACK] = ACTIONS(2342),
    [anon_sym_COLON] = ACTIONS(2340),
    [anon_sym_return] = ACTIONS(2340),
    [anon_sym_do] = ACTIONS(2340),
    [anon_sym_let] = ACTIONS(2340),
    [anon_sym_let_BANG] = ACTIONS(2342),
    [anon_sym_LPAREN] = ACTIONS(2340),
    [anon_sym_COMMA] = ACTIONS(2342),
    [anon_sym_null] = ACTIONS(2340),
    [anon_sym_QMARK] = ACTIONS(2340),
    [anon_sym_COLON_QMARK] = ACTIONS(2340),
    [anon_sym_COLON_COLON] = ACTIONS(2342),
    [anon_sym_AMP] = ACTIONS(2340),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_RBRACK] = ACTIONS(2342),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2342),
    [anon_sym_LBRACE] = ACTIONS(2340),
    [anon_sym_RBRACE] = ACTIONS(2342),
    [anon_sym_LT_AT] = ACTIONS(2340),
    [anon_sym_LT_AT_AT] = ACTIONS(2340),
    [anon_sym_DOT] = ACTIONS(2340),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2342),
    [anon_sym_new] = ACTIONS(2340),
    [anon_sym_with] = ACTIONS(2340),
    [anon_sym_return_BANG] = ACTIONS(2342),
    [anon_sym_yield] = ACTIONS(2340),
    [anon_sym_yield_BANG] = ACTIONS(2342),
    [anon_sym_lazy] = ACTIONS(2340),
    [anon_sym_assert] = ACTIONS(2340),
    [anon_sym_upcast] = ACTIONS(2340),
    [anon_sym_downcast] = ACTIONS(2340),
    [anon_sym_COLON_GT] = ACTIONS(2342),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2342),
    [anon_sym_for] = ACTIONS(2340),
    [anon_sym_to] = ACTIONS(2340),
    [anon_sym_downto] = ACTIONS(2340),
    [anon_sym_while] = ACTIONS(2340),
    [anon_sym_if] = ACTIONS(2340),
    [anon_sym_fun] = ACTIONS(2340),
    [anon_sym_DASH_GT] = ACTIONS(2340),
    [anon_sym_try] = ACTIONS(2340),
    [anon_sym_match] = ACTIONS(2340),
    [anon_sym_match_BANG] = ACTIONS(2342),
    [anon_sym_function] = ACTIONS(2340),
    [anon_sym_LT_DASH] = ACTIONS(2340),
    [anon_sym_DOT_LBRACK] = ACTIONS(2342),
    [anon_sym_LT] = ACTIONS(2342),
    [anon_sym_use] = ACTIONS(2340),
    [anon_sym_use_BANG] = ACTIONS(2342),
    [anon_sym_do_BANG] = ACTIONS(2342),
    [anon_sym_begin] = ACTIONS(2340),
    [anon_sym_LPAREN2] = ACTIONS(2340),
    [anon_sym_DOT_DOT2] = ACTIONS(2342),
    [anon_sym_STAR] = ACTIONS(2340),
    [anon_sym_LT2] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2342),
    [anon_sym_or] = ACTIONS(2340),
    [aux_sym_char_token1] = ACTIONS(2342),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2340),
    [anon_sym_DQUOTE] = ACTIONS(2340),
    [anon_sym_AT_DQUOTE] = ACTIONS(2342),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2342),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2342),
    [sym_bool] = ACTIONS(2340),
    [sym_unit] = ACTIONS(2342),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2340),
    [sym_op_identifier] = ACTIONS(2340),
    [anon_sym_PLUS] = ACTIONS(2340),
    [anon_sym_DASH] = ACTIONS(2340),
    [anon_sym_PLUS_DOT] = ACTIONS(2340),
    [anon_sym_DASH_DOT] = ACTIONS(2340),
    [anon_sym_PERCENT] = ACTIONS(2340),
    [anon_sym_AMP_AMP] = ACTIONS(2340),
    [anon_sym_TILDE] = ACTIONS(2342),
    [aux_sym_prefix_op_token1] = ACTIONS(2340),
    [aux_sym_infix_op_token1] = ACTIONS(2342),
    [aux_sym_infix_op_token2] = ACTIONS(2340),
    [anon_sym_PIPE_PIPE] = ACTIONS(2340),
    [anon_sym_BANG_EQ] = ACTIONS(2340),
    [anon_sym_COLON_EQ] = ACTIONS(2342),
    [anon_sym_DOLLAR] = ACTIONS(2340),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2340),
    [sym_int] = ACTIONS(2340),
    [sym_xint] = ACTIONS(2342),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2342),
    [sym__newline] = ACTIONS(2342),
  },
  [935] = {
    [sym_block_comment] = STATE(935),
    [sym_compiler_directive_decl] = STATE(935),
    [sym_fsi_directive_decl] = STATE(935),
    [sym_preproc_line] = STATE(935),
    [sym_identifier] = ACTIONS(3059),
    [anon_sym_EQ] = ACTIONS(3061),
    [anon_sym_LBRACK_LT] = ACTIONS(3061),
    [anon_sym_COLON] = ACTIONS(3059),
    [anon_sym_return] = ACTIONS(3059),
    [anon_sym_do] = ACTIONS(3059),
    [anon_sym_let] = ACTIONS(3059),
    [anon_sym_let_BANG] = ACTIONS(3061),
    [aux_sym_access_modifier_token1] = ACTIONS(3061),
    [anon_sym_LPAREN] = ACTIONS(3059),
    [anon_sym_COMMA] = ACTIONS(3061),
    [anon_sym_null] = ACTIONS(3059),
    [anon_sym_QMARK] = ACTIONS(3059),
    [anon_sym_COLON_QMARK] = ACTIONS(3059),
    [anon_sym_COLON_COLON] = ACTIONS(3061),
    [anon_sym_AMP] = ACTIONS(3059),
    [anon_sym_LBRACK] = ACTIONS(3059),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3061),
    [anon_sym_LBRACE] = ACTIONS(3059),
    [anon_sym_LT_AT] = ACTIONS(3059),
    [anon_sym_LT_AT_AT] = ACTIONS(3059),
    [anon_sym_DOT] = ACTIONS(3059),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3061),
    [anon_sym_new] = ACTIONS(3059),
    [anon_sym_with] = ACTIONS(3059),
    [anon_sym_return_BANG] = ACTIONS(3061),
    [anon_sym_yield] = ACTIONS(3059),
    [anon_sym_yield_BANG] = ACTIONS(3061),
    [anon_sym_lazy] = ACTIONS(3059),
    [anon_sym_assert] = ACTIONS(3059),
    [anon_sym_upcast] = ACTIONS(3059),
    [anon_sym_downcast] = ACTIONS(3059),
    [anon_sym_COLON_GT] = ACTIONS(3061),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3061),
    [anon_sym_for] = ACTIONS(3059),
    [anon_sym_while] = ACTIONS(3059),
    [anon_sym_if] = ACTIONS(3059),
    [anon_sym_fun] = ACTIONS(3059),
    [anon_sym_try] = ACTIONS(3059),
    [anon_sym_match] = ACTIONS(3059),
    [anon_sym_match_BANG] = ACTIONS(3061),
    [anon_sym_function] = ACTIONS(3059),
    [anon_sym_LT_DASH] = ACTIONS(3059),
    [anon_sym_DOT_LBRACK] = ACTIONS(3061),
    [anon_sym_LT] = ACTIONS(3061),
    [anon_sym_use] = ACTIONS(3059),
    [anon_sym_use_BANG] = ACTIONS(3061),
    [anon_sym_do_BANG] = ACTIONS(3061),
    [anon_sym_begin] = ACTIONS(3059),
    [anon_sym_LPAREN2] = ACTIONS(3059),
    [anon_sym_DOT_DOT2] = ACTIONS(3061),
    [anon_sym_default] = ACTIONS(3059),
    [anon_sym_or] = ACTIONS(3059),
    [anon_sym_static] = ACTIONS(3059),
    [anon_sym_member] = ACTIONS(3059),
    [anon_sym_abstract] = ACTIONS(3059),
    [anon_sym_val] = ACTIONS(3059),
    [anon_sym_override] = ACTIONS(3059),
    [aux_sym_char_token1] = ACTIONS(3061),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3059),
    [anon_sym_DQUOTE] = ACTIONS(3059),
    [anon_sym_AT_DQUOTE] = ACTIONS(3061),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3061),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3061),
    [sym_bool] = ACTIONS(3059),
    [sym_unit] = ACTIONS(3061),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3059),
    [sym_op_identifier] = ACTIONS(3059),
    [anon_sym_PLUS] = ACTIONS(3059),
    [anon_sym_DASH] = ACTIONS(3059),
    [anon_sym_PLUS_DOT] = ACTIONS(3059),
    [anon_sym_DASH_DOT] = ACTIONS(3059),
    [anon_sym_PERCENT] = ACTIONS(3059),
    [anon_sym_AMP_AMP] = ACTIONS(3059),
    [anon_sym_TILDE] = ACTIONS(3061),
    [aux_sym_prefix_op_token1] = ACTIONS(3059),
    [aux_sym_infix_op_token1] = ACTIONS(3061),
    [aux_sym_infix_op_token2] = ACTIONS(3059),
    [anon_sym_PIPE_PIPE] = ACTIONS(3059),
    [anon_sym_BANG_EQ] = ACTIONS(3059),
    [anon_sym_COLON_EQ] = ACTIONS(3061),
    [anon_sym_DOLLAR] = ACTIONS(3059),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3059),
    [sym_int] = ACTIONS(3059),
    [sym_xint] = ACTIONS(3061),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3061),
    [sym__newline] = ACTIONS(3061),
    [sym__dedent] = ACTIONS(3061),
  },
  [936] = {
    [sym_block_comment] = STATE(936),
    [sym_compiler_directive_decl] = STATE(936),
    [sym_fsi_directive_decl] = STATE(936),
    [sym_preproc_line] = STATE(936),
    [sym_identifier] = ACTIONS(3063),
    [anon_sym_EQ] = ACTIONS(3065),
    [anon_sym_LBRACK_LT] = ACTIONS(3065),
    [anon_sym_COLON] = ACTIONS(3063),
    [anon_sym_return] = ACTIONS(3063),
    [anon_sym_do] = ACTIONS(3063),
    [anon_sym_let] = ACTIONS(3063),
    [anon_sym_let_BANG] = ACTIONS(3065),
    [aux_sym_access_modifier_token1] = ACTIONS(3065),
    [anon_sym_LPAREN] = ACTIONS(3063),
    [anon_sym_COMMA] = ACTIONS(3065),
    [anon_sym_null] = ACTIONS(3063),
    [anon_sym_QMARK] = ACTIONS(3063),
    [anon_sym_COLON_QMARK] = ACTIONS(3063),
    [anon_sym_COLON_COLON] = ACTIONS(3065),
    [anon_sym_AMP] = ACTIONS(3063),
    [anon_sym_LBRACK] = ACTIONS(3063),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3065),
    [anon_sym_LBRACE] = ACTIONS(3063),
    [anon_sym_LT_AT] = ACTIONS(3063),
    [anon_sym_LT_AT_AT] = ACTIONS(3063),
    [anon_sym_DOT] = ACTIONS(3063),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3065),
    [anon_sym_new] = ACTIONS(3063),
    [anon_sym_with] = ACTIONS(3063),
    [anon_sym_return_BANG] = ACTIONS(3065),
    [anon_sym_yield] = ACTIONS(3063),
    [anon_sym_yield_BANG] = ACTIONS(3065),
    [anon_sym_lazy] = ACTIONS(3063),
    [anon_sym_assert] = ACTIONS(3063),
    [anon_sym_upcast] = ACTIONS(3063),
    [anon_sym_downcast] = ACTIONS(3063),
    [anon_sym_COLON_GT] = ACTIONS(3065),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3065),
    [anon_sym_for] = ACTIONS(3063),
    [anon_sym_while] = ACTIONS(3063),
    [anon_sym_if] = ACTIONS(3063),
    [anon_sym_fun] = ACTIONS(3063),
    [anon_sym_try] = ACTIONS(3063),
    [anon_sym_match] = ACTIONS(3063),
    [anon_sym_match_BANG] = ACTIONS(3065),
    [anon_sym_function] = ACTIONS(3063),
    [anon_sym_LT_DASH] = ACTIONS(3063),
    [anon_sym_DOT_LBRACK] = ACTIONS(3065),
    [anon_sym_LT] = ACTIONS(3065),
    [anon_sym_use] = ACTIONS(3063),
    [anon_sym_use_BANG] = ACTIONS(3065),
    [anon_sym_do_BANG] = ACTIONS(3065),
    [anon_sym_begin] = ACTIONS(3063),
    [anon_sym_LPAREN2] = ACTIONS(3063),
    [anon_sym_DOT_DOT2] = ACTIONS(3065),
    [anon_sym_default] = ACTIONS(3063),
    [anon_sym_or] = ACTIONS(3063),
    [anon_sym_static] = ACTIONS(3063),
    [anon_sym_member] = ACTIONS(3063),
    [anon_sym_abstract] = ACTIONS(3063),
    [anon_sym_val] = ACTIONS(3063),
    [anon_sym_override] = ACTIONS(3063),
    [aux_sym_char_token1] = ACTIONS(3065),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3063),
    [anon_sym_DQUOTE] = ACTIONS(3063),
    [anon_sym_AT_DQUOTE] = ACTIONS(3065),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3065),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3065),
    [sym_bool] = ACTIONS(3063),
    [sym_unit] = ACTIONS(3065),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3063),
    [sym_op_identifier] = ACTIONS(3063),
    [anon_sym_PLUS] = ACTIONS(3063),
    [anon_sym_DASH] = ACTIONS(3063),
    [anon_sym_PLUS_DOT] = ACTIONS(3063),
    [anon_sym_DASH_DOT] = ACTIONS(3063),
    [anon_sym_PERCENT] = ACTIONS(3063),
    [anon_sym_AMP_AMP] = ACTIONS(3063),
    [anon_sym_TILDE] = ACTIONS(3065),
    [aux_sym_prefix_op_token1] = ACTIONS(3063),
    [aux_sym_infix_op_token1] = ACTIONS(3065),
    [aux_sym_infix_op_token2] = ACTIONS(3063),
    [anon_sym_PIPE_PIPE] = ACTIONS(3063),
    [anon_sym_BANG_EQ] = ACTIONS(3063),
    [anon_sym_COLON_EQ] = ACTIONS(3065),
    [anon_sym_DOLLAR] = ACTIONS(3063),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3063),
    [sym_int] = ACTIONS(3063),
    [sym_xint] = ACTIONS(3065),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3065),
    [sym__newline] = ACTIONS(3065),
    [sym__dedent] = ACTIONS(3065),
  },
  [937] = {
    [sym_block_comment] = STATE(937),
    [sym_compiler_directive_decl] = STATE(937),
    [sym_fsi_directive_decl] = STATE(937),
    [sym_preproc_line] = STATE(937),
    [sym_identifier] = ACTIONS(2411),
    [anon_sym_EQ] = ACTIONS(2413),
    [anon_sym_LBRACK_LT] = ACTIONS(2413),
    [anon_sym_COLON] = ACTIONS(2411),
    [anon_sym_return] = ACTIONS(2411),
    [anon_sym_do] = ACTIONS(2411),
    [anon_sym_let] = ACTIONS(2411),
    [anon_sym_let_BANG] = ACTIONS(2413),
    [aux_sym_access_modifier_token1] = ACTIONS(2413),
    [anon_sym_LPAREN] = ACTIONS(2411),
    [anon_sym_COMMA] = ACTIONS(2413),
    [anon_sym_null] = ACTIONS(2411),
    [anon_sym_QMARK] = ACTIONS(2411),
    [anon_sym_COLON_QMARK] = ACTIONS(2411),
    [anon_sym_COLON_COLON] = ACTIONS(2413),
    [anon_sym_AMP] = ACTIONS(2411),
    [anon_sym_LBRACK] = ACTIONS(2411),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2413),
    [anon_sym_LBRACE] = ACTIONS(2411),
    [anon_sym_LT_AT] = ACTIONS(2411),
    [anon_sym_LT_AT_AT] = ACTIONS(2411),
    [anon_sym_DOT] = ACTIONS(2411),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2413),
    [anon_sym_new] = ACTIONS(2411),
    [anon_sym_with] = ACTIONS(2411),
    [anon_sym_return_BANG] = ACTIONS(2413),
    [anon_sym_yield] = ACTIONS(2411),
    [anon_sym_yield_BANG] = ACTIONS(2413),
    [anon_sym_lazy] = ACTIONS(2411),
    [anon_sym_assert] = ACTIONS(2411),
    [anon_sym_upcast] = ACTIONS(2411),
    [anon_sym_downcast] = ACTIONS(2411),
    [anon_sym_COLON_GT] = ACTIONS(2413),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2413),
    [anon_sym_for] = ACTIONS(2411),
    [anon_sym_while] = ACTIONS(2411),
    [anon_sym_if] = ACTIONS(2411),
    [anon_sym_fun] = ACTIONS(2411),
    [anon_sym_try] = ACTIONS(2411),
    [anon_sym_match] = ACTIONS(2411),
    [anon_sym_match_BANG] = ACTIONS(2413),
    [anon_sym_function] = ACTIONS(2411),
    [anon_sym_LT_DASH] = ACTIONS(2411),
    [anon_sym_DOT_LBRACK] = ACTIONS(2413),
    [anon_sym_LT] = ACTIONS(2413),
    [anon_sym_use] = ACTIONS(2411),
    [anon_sym_use_BANG] = ACTIONS(2413),
    [anon_sym_do_BANG] = ACTIONS(2413),
    [anon_sym_begin] = ACTIONS(2411),
    [anon_sym_LPAREN2] = ACTIONS(2411),
    [anon_sym_DOT_DOT2] = ACTIONS(2413),
    [anon_sym_default] = ACTIONS(2411),
    [anon_sym_or] = ACTIONS(2411),
    [anon_sym_static] = ACTIONS(2411),
    [anon_sym_member] = ACTIONS(2411),
    [anon_sym_abstract] = ACTIONS(2411),
    [anon_sym_val] = ACTIONS(2411),
    [anon_sym_override] = ACTIONS(2411),
    [aux_sym_char_token1] = ACTIONS(2413),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2411),
    [anon_sym_DQUOTE] = ACTIONS(2411),
    [anon_sym_AT_DQUOTE] = ACTIONS(2413),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2413),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2413),
    [sym_bool] = ACTIONS(2411),
    [sym_unit] = ACTIONS(2413),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2411),
    [sym_op_identifier] = ACTIONS(2411),
    [anon_sym_PLUS] = ACTIONS(2411),
    [anon_sym_DASH] = ACTIONS(2411),
    [anon_sym_PLUS_DOT] = ACTIONS(2411),
    [anon_sym_DASH_DOT] = ACTIONS(2411),
    [anon_sym_PERCENT] = ACTIONS(2411),
    [anon_sym_AMP_AMP] = ACTIONS(2411),
    [anon_sym_TILDE] = ACTIONS(2413),
    [aux_sym_prefix_op_token1] = ACTIONS(2411),
    [aux_sym_infix_op_token1] = ACTIONS(2413),
    [aux_sym_infix_op_token2] = ACTIONS(2411),
    [anon_sym_PIPE_PIPE] = ACTIONS(2411),
    [anon_sym_BANG_EQ] = ACTIONS(2411),
    [anon_sym_COLON_EQ] = ACTIONS(2413),
    [anon_sym_DOLLAR] = ACTIONS(2411),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2411),
    [sym_int] = ACTIONS(2411),
    [sym_xint] = ACTIONS(2413),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2413),
    [sym__newline] = ACTIONS(2413),
    [sym__dedent] = ACTIONS(2413),
  },
  [938] = {
    [sym_block_comment] = STATE(938),
    [sym_compiler_directive_decl] = STATE(938),
    [sym_fsi_directive_decl] = STATE(938),
    [sym_preproc_line] = STATE(938),
    [sym_identifier] = ACTIONS(3067),
    [anon_sym_EQ] = ACTIONS(3069),
    [anon_sym_LBRACK_LT] = ACTIONS(3069),
    [anon_sym_COLON] = ACTIONS(3067),
    [anon_sym_return] = ACTIONS(3067),
    [anon_sym_do] = ACTIONS(3067),
    [anon_sym_let] = ACTIONS(3067),
    [anon_sym_let_BANG] = ACTIONS(3069),
    [aux_sym_access_modifier_token1] = ACTIONS(3069),
    [anon_sym_LPAREN] = ACTIONS(3067),
    [anon_sym_COMMA] = ACTIONS(3069),
    [anon_sym_null] = ACTIONS(3067),
    [anon_sym_QMARK] = ACTIONS(3067),
    [anon_sym_COLON_QMARK] = ACTIONS(3067),
    [anon_sym_COLON_COLON] = ACTIONS(3069),
    [anon_sym_AMP] = ACTIONS(3067),
    [anon_sym_LBRACK] = ACTIONS(3067),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3069),
    [anon_sym_LBRACE] = ACTIONS(3067),
    [anon_sym_LT_AT] = ACTIONS(3067),
    [anon_sym_LT_AT_AT] = ACTIONS(3067),
    [anon_sym_DOT] = ACTIONS(3067),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3069),
    [anon_sym_new] = ACTIONS(3067),
    [anon_sym_with] = ACTIONS(3067),
    [anon_sym_return_BANG] = ACTIONS(3069),
    [anon_sym_yield] = ACTIONS(3067),
    [anon_sym_yield_BANG] = ACTIONS(3069),
    [anon_sym_lazy] = ACTIONS(3067),
    [anon_sym_assert] = ACTIONS(3067),
    [anon_sym_upcast] = ACTIONS(3067),
    [anon_sym_downcast] = ACTIONS(3067),
    [anon_sym_COLON_GT] = ACTIONS(3069),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3069),
    [anon_sym_for] = ACTIONS(3067),
    [anon_sym_while] = ACTIONS(3067),
    [anon_sym_if] = ACTIONS(3067),
    [anon_sym_fun] = ACTIONS(3067),
    [anon_sym_try] = ACTIONS(3067),
    [anon_sym_match] = ACTIONS(3067),
    [anon_sym_match_BANG] = ACTIONS(3069),
    [anon_sym_function] = ACTIONS(3067),
    [anon_sym_LT_DASH] = ACTIONS(3067),
    [anon_sym_DOT_LBRACK] = ACTIONS(3069),
    [anon_sym_LT] = ACTIONS(3069),
    [anon_sym_use] = ACTIONS(3067),
    [anon_sym_use_BANG] = ACTIONS(3069),
    [anon_sym_do_BANG] = ACTIONS(3069),
    [anon_sym_begin] = ACTIONS(3067),
    [anon_sym_LPAREN2] = ACTIONS(3067),
    [anon_sym_DOT_DOT2] = ACTIONS(3069),
    [anon_sym_default] = ACTIONS(3067),
    [anon_sym_or] = ACTIONS(3067),
    [anon_sym_static] = ACTIONS(3067),
    [anon_sym_member] = ACTIONS(3067),
    [anon_sym_abstract] = ACTIONS(3067),
    [anon_sym_val] = ACTIONS(3067),
    [anon_sym_override] = ACTIONS(3067),
    [aux_sym_char_token1] = ACTIONS(3069),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3067),
    [anon_sym_DQUOTE] = ACTIONS(3067),
    [anon_sym_AT_DQUOTE] = ACTIONS(3069),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3069),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3069),
    [sym_bool] = ACTIONS(3067),
    [sym_unit] = ACTIONS(3069),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3067),
    [sym_op_identifier] = ACTIONS(3067),
    [anon_sym_PLUS] = ACTIONS(3067),
    [anon_sym_DASH] = ACTIONS(3067),
    [anon_sym_PLUS_DOT] = ACTIONS(3067),
    [anon_sym_DASH_DOT] = ACTIONS(3067),
    [anon_sym_PERCENT] = ACTIONS(3067),
    [anon_sym_AMP_AMP] = ACTIONS(3067),
    [anon_sym_TILDE] = ACTIONS(3069),
    [aux_sym_prefix_op_token1] = ACTIONS(3067),
    [aux_sym_infix_op_token1] = ACTIONS(3069),
    [aux_sym_infix_op_token2] = ACTIONS(3067),
    [anon_sym_PIPE_PIPE] = ACTIONS(3067),
    [anon_sym_BANG_EQ] = ACTIONS(3067),
    [anon_sym_COLON_EQ] = ACTIONS(3069),
    [anon_sym_DOLLAR] = ACTIONS(3067),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3067),
    [sym_int] = ACTIONS(3067),
    [sym_xint] = ACTIONS(3069),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3069),
    [sym__newline] = ACTIONS(3069),
    [sym__dedent] = ACTIONS(3069),
  },
  [939] = {
    [sym_block_comment] = STATE(939),
    [sym_compiler_directive_decl] = STATE(939),
    [sym_fsi_directive_decl] = STATE(939),
    [sym_preproc_line] = STATE(939),
    [sym_identifier] = ACTIONS(3071),
    [anon_sym_EQ] = ACTIONS(3073),
    [anon_sym_LBRACK_LT] = ACTIONS(3073),
    [anon_sym_COLON] = ACTIONS(3071),
    [anon_sym_return] = ACTIONS(3071),
    [anon_sym_do] = ACTIONS(3071),
    [anon_sym_let] = ACTIONS(3071),
    [anon_sym_let_BANG] = ACTIONS(3073),
    [aux_sym_access_modifier_token1] = ACTIONS(3073),
    [anon_sym_LPAREN] = ACTIONS(3071),
    [anon_sym_COMMA] = ACTIONS(3073),
    [anon_sym_null] = ACTIONS(3071),
    [anon_sym_QMARK] = ACTIONS(3071),
    [anon_sym_COLON_QMARK] = ACTIONS(3071),
    [anon_sym_COLON_COLON] = ACTIONS(3073),
    [anon_sym_AMP] = ACTIONS(3071),
    [anon_sym_LBRACK] = ACTIONS(3071),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3073),
    [anon_sym_LBRACE] = ACTIONS(3071),
    [anon_sym_LT_AT] = ACTIONS(3071),
    [anon_sym_LT_AT_AT] = ACTIONS(3071),
    [anon_sym_DOT] = ACTIONS(3071),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3073),
    [anon_sym_new] = ACTIONS(3071),
    [anon_sym_with] = ACTIONS(3071),
    [anon_sym_return_BANG] = ACTIONS(3073),
    [anon_sym_yield] = ACTIONS(3071),
    [anon_sym_yield_BANG] = ACTIONS(3073),
    [anon_sym_lazy] = ACTIONS(3071),
    [anon_sym_assert] = ACTIONS(3071),
    [anon_sym_upcast] = ACTIONS(3071),
    [anon_sym_downcast] = ACTIONS(3071),
    [anon_sym_COLON_GT] = ACTIONS(3073),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3073),
    [anon_sym_for] = ACTIONS(3071),
    [anon_sym_while] = ACTIONS(3071),
    [anon_sym_if] = ACTIONS(3071),
    [anon_sym_fun] = ACTIONS(3071),
    [anon_sym_try] = ACTIONS(3071),
    [anon_sym_match] = ACTIONS(3071),
    [anon_sym_match_BANG] = ACTIONS(3073),
    [anon_sym_function] = ACTIONS(3071),
    [anon_sym_LT_DASH] = ACTIONS(3071),
    [anon_sym_DOT_LBRACK] = ACTIONS(3073),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_use] = ACTIONS(3071),
    [anon_sym_use_BANG] = ACTIONS(3073),
    [anon_sym_do_BANG] = ACTIONS(3073),
    [anon_sym_begin] = ACTIONS(3071),
    [anon_sym_LPAREN2] = ACTIONS(3071),
    [anon_sym_DOT_DOT2] = ACTIONS(3073),
    [anon_sym_default] = ACTIONS(3071),
    [anon_sym_or] = ACTIONS(3071),
    [anon_sym_static] = ACTIONS(3071),
    [anon_sym_member] = ACTIONS(3071),
    [anon_sym_abstract] = ACTIONS(3071),
    [anon_sym_val] = ACTIONS(3071),
    [anon_sym_override] = ACTIONS(3071),
    [aux_sym_char_token1] = ACTIONS(3073),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3071),
    [anon_sym_DQUOTE] = ACTIONS(3071),
    [anon_sym_AT_DQUOTE] = ACTIONS(3073),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3073),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3073),
    [sym_bool] = ACTIONS(3071),
    [sym_unit] = ACTIONS(3073),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3071),
    [sym_op_identifier] = ACTIONS(3071),
    [anon_sym_PLUS] = ACTIONS(3071),
    [anon_sym_DASH] = ACTIONS(3071),
    [anon_sym_PLUS_DOT] = ACTIONS(3071),
    [anon_sym_DASH_DOT] = ACTIONS(3071),
    [anon_sym_PERCENT] = ACTIONS(3071),
    [anon_sym_AMP_AMP] = ACTIONS(3071),
    [anon_sym_TILDE] = ACTIONS(3073),
    [aux_sym_prefix_op_token1] = ACTIONS(3071),
    [aux_sym_infix_op_token1] = ACTIONS(3073),
    [aux_sym_infix_op_token2] = ACTIONS(3071),
    [anon_sym_PIPE_PIPE] = ACTIONS(3071),
    [anon_sym_BANG_EQ] = ACTIONS(3071),
    [anon_sym_COLON_EQ] = ACTIONS(3073),
    [anon_sym_DOLLAR] = ACTIONS(3071),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3071),
    [sym_int] = ACTIONS(3071),
    [sym_xint] = ACTIONS(3073),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3073),
    [sym__newline] = ACTIONS(3073),
    [sym__dedent] = ACTIONS(3073),
  },
  [940] = {
    [sym_block_comment] = STATE(940),
    [sym_compiler_directive_decl] = STATE(940),
    [sym_fsi_directive_decl] = STATE(940),
    [sym_preproc_line] = STATE(940),
    [sym_identifier] = ACTIONS(3075),
    [anon_sym_EQ] = ACTIONS(3077),
    [anon_sym_LBRACK_LT] = ACTIONS(3077),
    [anon_sym_COLON] = ACTIONS(3075),
    [anon_sym_return] = ACTIONS(3075),
    [anon_sym_do] = ACTIONS(3075),
    [anon_sym_let] = ACTIONS(3075),
    [anon_sym_let_BANG] = ACTIONS(3077),
    [aux_sym_access_modifier_token1] = ACTIONS(3077),
    [anon_sym_LPAREN] = ACTIONS(3075),
    [anon_sym_COMMA] = ACTIONS(3077),
    [anon_sym_null] = ACTIONS(3075),
    [anon_sym_QMARK] = ACTIONS(3075),
    [anon_sym_COLON_QMARK] = ACTIONS(3075),
    [anon_sym_COLON_COLON] = ACTIONS(3077),
    [anon_sym_AMP] = ACTIONS(3075),
    [anon_sym_LBRACK] = ACTIONS(3075),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3077),
    [anon_sym_LBRACE] = ACTIONS(3075),
    [anon_sym_LT_AT] = ACTIONS(3075),
    [anon_sym_LT_AT_AT] = ACTIONS(3075),
    [anon_sym_DOT] = ACTIONS(3075),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3077),
    [anon_sym_new] = ACTIONS(3075),
    [anon_sym_with] = ACTIONS(3075),
    [anon_sym_return_BANG] = ACTIONS(3077),
    [anon_sym_yield] = ACTIONS(3075),
    [anon_sym_yield_BANG] = ACTIONS(3077),
    [anon_sym_lazy] = ACTIONS(3075),
    [anon_sym_assert] = ACTIONS(3075),
    [anon_sym_upcast] = ACTIONS(3075),
    [anon_sym_downcast] = ACTIONS(3075),
    [anon_sym_COLON_GT] = ACTIONS(3077),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3077),
    [anon_sym_for] = ACTIONS(3075),
    [anon_sym_while] = ACTIONS(3075),
    [anon_sym_if] = ACTIONS(3075),
    [anon_sym_fun] = ACTIONS(3075),
    [anon_sym_try] = ACTIONS(3075),
    [anon_sym_match] = ACTIONS(3075),
    [anon_sym_match_BANG] = ACTIONS(3077),
    [anon_sym_function] = ACTIONS(3075),
    [anon_sym_LT_DASH] = ACTIONS(3075),
    [anon_sym_DOT_LBRACK] = ACTIONS(3077),
    [anon_sym_LT] = ACTIONS(3077),
    [anon_sym_use] = ACTIONS(3075),
    [anon_sym_use_BANG] = ACTIONS(3077),
    [anon_sym_do_BANG] = ACTIONS(3077),
    [anon_sym_begin] = ACTIONS(3075),
    [anon_sym_LPAREN2] = ACTIONS(3075),
    [anon_sym_DOT_DOT2] = ACTIONS(3077),
    [anon_sym_default] = ACTIONS(3075),
    [anon_sym_or] = ACTIONS(3075),
    [anon_sym_static] = ACTIONS(3075),
    [anon_sym_member] = ACTIONS(3075),
    [anon_sym_abstract] = ACTIONS(3075),
    [anon_sym_val] = ACTIONS(3075),
    [anon_sym_override] = ACTIONS(3075),
    [aux_sym_char_token1] = ACTIONS(3077),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3075),
    [anon_sym_DQUOTE] = ACTIONS(3075),
    [anon_sym_AT_DQUOTE] = ACTIONS(3077),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3077),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3077),
    [sym_bool] = ACTIONS(3075),
    [sym_unit] = ACTIONS(3077),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3075),
    [sym_op_identifier] = ACTIONS(3075),
    [anon_sym_PLUS] = ACTIONS(3075),
    [anon_sym_DASH] = ACTIONS(3075),
    [anon_sym_PLUS_DOT] = ACTIONS(3075),
    [anon_sym_DASH_DOT] = ACTIONS(3075),
    [anon_sym_PERCENT] = ACTIONS(3075),
    [anon_sym_AMP_AMP] = ACTIONS(3075),
    [anon_sym_TILDE] = ACTIONS(3077),
    [aux_sym_prefix_op_token1] = ACTIONS(3075),
    [aux_sym_infix_op_token1] = ACTIONS(3077),
    [aux_sym_infix_op_token2] = ACTIONS(3075),
    [anon_sym_PIPE_PIPE] = ACTIONS(3075),
    [anon_sym_BANG_EQ] = ACTIONS(3075),
    [anon_sym_COLON_EQ] = ACTIONS(3077),
    [anon_sym_DOLLAR] = ACTIONS(3075),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3075),
    [sym_int] = ACTIONS(3075),
    [sym_xint] = ACTIONS(3077),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3077),
    [sym__newline] = ACTIONS(3077),
    [sym__dedent] = ACTIONS(3077),
  },
  [941] = {
    [sym_block_comment] = STATE(941),
    [sym_compiler_directive_decl] = STATE(941),
    [sym_fsi_directive_decl] = STATE(941),
    [sym_preproc_line] = STATE(941),
    [sym_identifier] = ACTIONS(3079),
    [anon_sym_EQ] = ACTIONS(3081),
    [anon_sym_LBRACK_LT] = ACTIONS(3081),
    [anon_sym_COLON] = ACTIONS(3079),
    [anon_sym_return] = ACTIONS(3079),
    [anon_sym_do] = ACTIONS(3079),
    [anon_sym_let] = ACTIONS(3079),
    [anon_sym_let_BANG] = ACTIONS(3081),
    [aux_sym_access_modifier_token1] = ACTIONS(3081),
    [anon_sym_LPAREN] = ACTIONS(3079),
    [anon_sym_COMMA] = ACTIONS(3081),
    [anon_sym_null] = ACTIONS(3079),
    [anon_sym_QMARK] = ACTIONS(3079),
    [anon_sym_COLON_QMARK] = ACTIONS(3079),
    [anon_sym_COLON_COLON] = ACTIONS(3081),
    [anon_sym_AMP] = ACTIONS(3079),
    [anon_sym_LBRACK] = ACTIONS(3079),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3081),
    [anon_sym_LBRACE] = ACTIONS(3079),
    [anon_sym_LT_AT] = ACTIONS(3079),
    [anon_sym_LT_AT_AT] = ACTIONS(3079),
    [anon_sym_DOT] = ACTIONS(3079),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3081),
    [anon_sym_new] = ACTIONS(3079),
    [anon_sym_with] = ACTIONS(3079),
    [anon_sym_return_BANG] = ACTIONS(3081),
    [anon_sym_yield] = ACTIONS(3079),
    [anon_sym_yield_BANG] = ACTIONS(3081),
    [anon_sym_lazy] = ACTIONS(3079),
    [anon_sym_assert] = ACTIONS(3079),
    [anon_sym_upcast] = ACTIONS(3079),
    [anon_sym_downcast] = ACTIONS(3079),
    [anon_sym_COLON_GT] = ACTIONS(3081),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3081),
    [anon_sym_for] = ACTIONS(3079),
    [anon_sym_while] = ACTIONS(3079),
    [anon_sym_if] = ACTIONS(3079),
    [anon_sym_fun] = ACTIONS(3079),
    [anon_sym_try] = ACTIONS(3079),
    [anon_sym_match] = ACTIONS(3079),
    [anon_sym_match_BANG] = ACTIONS(3081),
    [anon_sym_function] = ACTIONS(3079),
    [anon_sym_LT_DASH] = ACTIONS(3079),
    [anon_sym_DOT_LBRACK] = ACTIONS(3081),
    [anon_sym_LT] = ACTIONS(3081),
    [anon_sym_use] = ACTIONS(3079),
    [anon_sym_use_BANG] = ACTIONS(3081),
    [anon_sym_do_BANG] = ACTIONS(3081),
    [anon_sym_begin] = ACTIONS(3079),
    [anon_sym_LPAREN2] = ACTIONS(3079),
    [anon_sym_DOT_DOT2] = ACTIONS(3081),
    [anon_sym_default] = ACTIONS(3079),
    [anon_sym_or] = ACTIONS(3079),
    [anon_sym_static] = ACTIONS(3079),
    [anon_sym_member] = ACTIONS(3079),
    [anon_sym_abstract] = ACTIONS(3079),
    [anon_sym_val] = ACTIONS(3079),
    [anon_sym_override] = ACTIONS(3079),
    [aux_sym_char_token1] = ACTIONS(3081),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3079),
    [anon_sym_DQUOTE] = ACTIONS(3079),
    [anon_sym_AT_DQUOTE] = ACTIONS(3081),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3081),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3081),
    [sym_bool] = ACTIONS(3079),
    [sym_unit] = ACTIONS(3081),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3079),
    [sym_op_identifier] = ACTIONS(3079),
    [anon_sym_PLUS] = ACTIONS(3079),
    [anon_sym_DASH] = ACTIONS(3079),
    [anon_sym_PLUS_DOT] = ACTIONS(3079),
    [anon_sym_DASH_DOT] = ACTIONS(3079),
    [anon_sym_PERCENT] = ACTIONS(3079),
    [anon_sym_AMP_AMP] = ACTIONS(3079),
    [anon_sym_TILDE] = ACTIONS(3081),
    [aux_sym_prefix_op_token1] = ACTIONS(3079),
    [aux_sym_infix_op_token1] = ACTIONS(3081),
    [aux_sym_infix_op_token2] = ACTIONS(3079),
    [anon_sym_PIPE_PIPE] = ACTIONS(3079),
    [anon_sym_BANG_EQ] = ACTIONS(3079),
    [anon_sym_COLON_EQ] = ACTIONS(3081),
    [anon_sym_DOLLAR] = ACTIONS(3079),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3079),
    [sym_int] = ACTIONS(3079),
    [sym_xint] = ACTIONS(3081),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3081),
    [sym__newline] = ACTIONS(3081),
    [sym__dedent] = ACTIONS(3081),
  },
  [942] = {
    [sym_block_comment] = STATE(942),
    [sym_compiler_directive_decl] = STATE(942),
    [sym_fsi_directive_decl] = STATE(942),
    [sym_preproc_line] = STATE(942),
    [sym_identifier] = ACTIONS(3083),
    [anon_sym_EQ] = ACTIONS(3085),
    [anon_sym_LBRACK_LT] = ACTIONS(3085),
    [anon_sym_COLON] = ACTIONS(3083),
    [anon_sym_return] = ACTIONS(3083),
    [anon_sym_do] = ACTIONS(3083),
    [anon_sym_let] = ACTIONS(3083),
    [anon_sym_let_BANG] = ACTIONS(3085),
    [aux_sym_access_modifier_token1] = ACTIONS(3085),
    [anon_sym_LPAREN] = ACTIONS(3083),
    [anon_sym_COMMA] = ACTIONS(3085),
    [anon_sym_null] = ACTIONS(3083),
    [anon_sym_QMARK] = ACTIONS(3083),
    [anon_sym_COLON_QMARK] = ACTIONS(3083),
    [anon_sym_COLON_COLON] = ACTIONS(3085),
    [anon_sym_AMP] = ACTIONS(3083),
    [anon_sym_LBRACK] = ACTIONS(3083),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3085),
    [anon_sym_LBRACE] = ACTIONS(3083),
    [anon_sym_LT_AT] = ACTIONS(3083),
    [anon_sym_LT_AT_AT] = ACTIONS(3083),
    [anon_sym_DOT] = ACTIONS(3083),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3085),
    [anon_sym_new] = ACTIONS(3083),
    [anon_sym_with] = ACTIONS(3083),
    [anon_sym_return_BANG] = ACTIONS(3085),
    [anon_sym_yield] = ACTIONS(3083),
    [anon_sym_yield_BANG] = ACTIONS(3085),
    [anon_sym_lazy] = ACTIONS(3083),
    [anon_sym_assert] = ACTIONS(3083),
    [anon_sym_upcast] = ACTIONS(3083),
    [anon_sym_downcast] = ACTIONS(3083),
    [anon_sym_COLON_GT] = ACTIONS(3085),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3085),
    [anon_sym_for] = ACTIONS(3083),
    [anon_sym_while] = ACTIONS(3083),
    [anon_sym_if] = ACTIONS(3083),
    [anon_sym_fun] = ACTIONS(3083),
    [anon_sym_try] = ACTIONS(3083),
    [anon_sym_match] = ACTIONS(3083),
    [anon_sym_match_BANG] = ACTIONS(3085),
    [anon_sym_function] = ACTIONS(3083),
    [anon_sym_LT_DASH] = ACTIONS(3083),
    [anon_sym_DOT_LBRACK] = ACTIONS(3085),
    [anon_sym_LT] = ACTIONS(3085),
    [anon_sym_use] = ACTIONS(3083),
    [anon_sym_use_BANG] = ACTIONS(3085),
    [anon_sym_do_BANG] = ACTIONS(3085),
    [anon_sym_begin] = ACTIONS(3083),
    [anon_sym_LPAREN2] = ACTIONS(3083),
    [anon_sym_DOT_DOT2] = ACTIONS(3085),
    [anon_sym_default] = ACTIONS(3083),
    [anon_sym_or] = ACTIONS(3083),
    [anon_sym_static] = ACTIONS(3083),
    [anon_sym_member] = ACTIONS(3083),
    [anon_sym_abstract] = ACTIONS(3083),
    [anon_sym_val] = ACTIONS(3083),
    [anon_sym_override] = ACTIONS(3083),
    [aux_sym_char_token1] = ACTIONS(3085),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3083),
    [anon_sym_DQUOTE] = ACTIONS(3083),
    [anon_sym_AT_DQUOTE] = ACTIONS(3085),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3085),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3085),
    [sym_bool] = ACTIONS(3083),
    [sym_unit] = ACTIONS(3085),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3083),
    [sym_op_identifier] = ACTIONS(3083),
    [anon_sym_PLUS] = ACTIONS(3083),
    [anon_sym_DASH] = ACTIONS(3083),
    [anon_sym_PLUS_DOT] = ACTIONS(3083),
    [anon_sym_DASH_DOT] = ACTIONS(3083),
    [anon_sym_PERCENT] = ACTIONS(3083),
    [anon_sym_AMP_AMP] = ACTIONS(3083),
    [anon_sym_TILDE] = ACTIONS(3085),
    [aux_sym_prefix_op_token1] = ACTIONS(3083),
    [aux_sym_infix_op_token1] = ACTIONS(3085),
    [aux_sym_infix_op_token2] = ACTIONS(3083),
    [anon_sym_PIPE_PIPE] = ACTIONS(3083),
    [anon_sym_BANG_EQ] = ACTIONS(3083),
    [anon_sym_COLON_EQ] = ACTIONS(3085),
    [anon_sym_DOLLAR] = ACTIONS(3083),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3083),
    [sym_int] = ACTIONS(3083),
    [sym_xint] = ACTIONS(3085),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3085),
    [sym__newline] = ACTIONS(3085),
    [sym__dedent] = ACTIONS(3085),
  },
  [943] = {
    [sym_block_comment] = STATE(943),
    [sym_compiler_directive_decl] = STATE(943),
    [sym_fsi_directive_decl] = STATE(943),
    [sym_preproc_line] = STATE(943),
    [sym_identifier] = ACTIONS(3087),
    [anon_sym_EQ] = ACTIONS(3089),
    [anon_sym_LBRACK_LT] = ACTIONS(3089),
    [anon_sym_COLON] = ACTIONS(3087),
    [anon_sym_return] = ACTIONS(3087),
    [anon_sym_do] = ACTIONS(3087),
    [anon_sym_let] = ACTIONS(3087),
    [anon_sym_let_BANG] = ACTIONS(3089),
    [aux_sym_access_modifier_token1] = ACTIONS(3089),
    [anon_sym_LPAREN] = ACTIONS(3087),
    [anon_sym_COMMA] = ACTIONS(3089),
    [anon_sym_null] = ACTIONS(3087),
    [anon_sym_QMARK] = ACTIONS(3087),
    [anon_sym_COLON_QMARK] = ACTIONS(3087),
    [anon_sym_COLON_COLON] = ACTIONS(3089),
    [anon_sym_AMP] = ACTIONS(3087),
    [anon_sym_LBRACK] = ACTIONS(3087),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3089),
    [anon_sym_LBRACE] = ACTIONS(3087),
    [anon_sym_LT_AT] = ACTIONS(3087),
    [anon_sym_LT_AT_AT] = ACTIONS(3087),
    [anon_sym_DOT] = ACTIONS(3087),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3089),
    [anon_sym_new] = ACTIONS(3087),
    [anon_sym_with] = ACTIONS(3087),
    [anon_sym_return_BANG] = ACTIONS(3089),
    [anon_sym_yield] = ACTIONS(3087),
    [anon_sym_yield_BANG] = ACTIONS(3089),
    [anon_sym_lazy] = ACTIONS(3087),
    [anon_sym_assert] = ACTIONS(3087),
    [anon_sym_upcast] = ACTIONS(3087),
    [anon_sym_downcast] = ACTIONS(3087),
    [anon_sym_COLON_GT] = ACTIONS(3089),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3089),
    [anon_sym_for] = ACTIONS(3087),
    [anon_sym_while] = ACTIONS(3087),
    [anon_sym_if] = ACTIONS(3087),
    [anon_sym_fun] = ACTIONS(3087),
    [anon_sym_try] = ACTIONS(3087),
    [anon_sym_match] = ACTIONS(3087),
    [anon_sym_match_BANG] = ACTIONS(3089),
    [anon_sym_function] = ACTIONS(3087),
    [anon_sym_LT_DASH] = ACTIONS(3087),
    [anon_sym_DOT_LBRACK] = ACTIONS(3089),
    [anon_sym_LT] = ACTIONS(3089),
    [anon_sym_use] = ACTIONS(3087),
    [anon_sym_use_BANG] = ACTIONS(3089),
    [anon_sym_do_BANG] = ACTIONS(3089),
    [anon_sym_begin] = ACTIONS(3087),
    [anon_sym_LPAREN2] = ACTIONS(3087),
    [anon_sym_DOT_DOT2] = ACTIONS(3089),
    [anon_sym_default] = ACTIONS(3087),
    [anon_sym_or] = ACTIONS(3087),
    [anon_sym_static] = ACTIONS(3087),
    [anon_sym_member] = ACTIONS(3087),
    [anon_sym_abstract] = ACTIONS(3087),
    [anon_sym_val] = ACTIONS(3087),
    [anon_sym_override] = ACTIONS(3087),
    [aux_sym_char_token1] = ACTIONS(3089),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3087),
    [anon_sym_DQUOTE] = ACTIONS(3087),
    [anon_sym_AT_DQUOTE] = ACTIONS(3089),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3089),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3089),
    [sym_bool] = ACTIONS(3087),
    [sym_unit] = ACTIONS(3089),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3087),
    [sym_op_identifier] = ACTIONS(3087),
    [anon_sym_PLUS] = ACTIONS(3087),
    [anon_sym_DASH] = ACTIONS(3087),
    [anon_sym_PLUS_DOT] = ACTIONS(3087),
    [anon_sym_DASH_DOT] = ACTIONS(3087),
    [anon_sym_PERCENT] = ACTIONS(3087),
    [anon_sym_AMP_AMP] = ACTIONS(3087),
    [anon_sym_TILDE] = ACTIONS(3089),
    [aux_sym_prefix_op_token1] = ACTIONS(3087),
    [aux_sym_infix_op_token1] = ACTIONS(3089),
    [aux_sym_infix_op_token2] = ACTIONS(3087),
    [anon_sym_PIPE_PIPE] = ACTIONS(3087),
    [anon_sym_BANG_EQ] = ACTIONS(3087),
    [anon_sym_COLON_EQ] = ACTIONS(3089),
    [anon_sym_DOLLAR] = ACTIONS(3087),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3087),
    [sym_int] = ACTIONS(3087),
    [sym_xint] = ACTIONS(3089),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3089),
    [sym__newline] = ACTIONS(3089),
    [sym__dedent] = ACTIONS(3089),
  },
  [944] = {
    [sym_block_comment] = STATE(944),
    [sym_compiler_directive_decl] = STATE(944),
    [sym_fsi_directive_decl] = STATE(944),
    [sym_preproc_line] = STATE(944),
    [sym_identifier] = ACTIONS(3091),
    [anon_sym_EQ] = ACTIONS(3093),
    [anon_sym_LBRACK_LT] = ACTIONS(3093),
    [anon_sym_COLON] = ACTIONS(3091),
    [anon_sym_return] = ACTIONS(3091),
    [anon_sym_do] = ACTIONS(3091),
    [anon_sym_let] = ACTIONS(3091),
    [anon_sym_let_BANG] = ACTIONS(3093),
    [aux_sym_access_modifier_token1] = ACTIONS(3093),
    [anon_sym_LPAREN] = ACTIONS(3091),
    [anon_sym_COMMA] = ACTIONS(3093),
    [anon_sym_null] = ACTIONS(3091),
    [anon_sym_QMARK] = ACTIONS(3091),
    [anon_sym_COLON_QMARK] = ACTIONS(3091),
    [anon_sym_COLON_COLON] = ACTIONS(3093),
    [anon_sym_AMP] = ACTIONS(3091),
    [anon_sym_LBRACK] = ACTIONS(3091),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3093),
    [anon_sym_LBRACE] = ACTIONS(3091),
    [anon_sym_LT_AT] = ACTIONS(3091),
    [anon_sym_LT_AT_AT] = ACTIONS(3091),
    [anon_sym_DOT] = ACTIONS(3091),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3093),
    [anon_sym_new] = ACTIONS(3091),
    [anon_sym_with] = ACTIONS(3091),
    [anon_sym_return_BANG] = ACTIONS(3093),
    [anon_sym_yield] = ACTIONS(3091),
    [anon_sym_yield_BANG] = ACTIONS(3093),
    [anon_sym_lazy] = ACTIONS(3091),
    [anon_sym_assert] = ACTIONS(3091),
    [anon_sym_upcast] = ACTIONS(3091),
    [anon_sym_downcast] = ACTIONS(3091),
    [anon_sym_COLON_GT] = ACTIONS(3093),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3093),
    [anon_sym_for] = ACTIONS(3091),
    [anon_sym_while] = ACTIONS(3091),
    [anon_sym_if] = ACTIONS(3091),
    [anon_sym_fun] = ACTIONS(3091),
    [anon_sym_try] = ACTIONS(3091),
    [anon_sym_match] = ACTIONS(3091),
    [anon_sym_match_BANG] = ACTIONS(3093),
    [anon_sym_function] = ACTIONS(3091),
    [anon_sym_LT_DASH] = ACTIONS(3091),
    [anon_sym_DOT_LBRACK] = ACTIONS(3093),
    [anon_sym_LT] = ACTIONS(3093),
    [anon_sym_use] = ACTIONS(3091),
    [anon_sym_use_BANG] = ACTIONS(3093),
    [anon_sym_do_BANG] = ACTIONS(3093),
    [anon_sym_begin] = ACTIONS(3091),
    [anon_sym_LPAREN2] = ACTIONS(3091),
    [anon_sym_DOT_DOT2] = ACTIONS(3093),
    [anon_sym_default] = ACTIONS(3091),
    [anon_sym_or] = ACTIONS(3091),
    [anon_sym_static] = ACTIONS(3091),
    [anon_sym_member] = ACTIONS(3091),
    [anon_sym_abstract] = ACTIONS(3091),
    [anon_sym_val] = ACTIONS(3091),
    [anon_sym_override] = ACTIONS(3091),
    [aux_sym_char_token1] = ACTIONS(3093),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3091),
    [anon_sym_DQUOTE] = ACTIONS(3091),
    [anon_sym_AT_DQUOTE] = ACTIONS(3093),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3093),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3093),
    [sym_bool] = ACTIONS(3091),
    [sym_unit] = ACTIONS(3093),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3091),
    [sym_op_identifier] = ACTIONS(3091),
    [anon_sym_PLUS] = ACTIONS(3091),
    [anon_sym_DASH] = ACTIONS(3091),
    [anon_sym_PLUS_DOT] = ACTIONS(3091),
    [anon_sym_DASH_DOT] = ACTIONS(3091),
    [anon_sym_PERCENT] = ACTIONS(3091),
    [anon_sym_AMP_AMP] = ACTIONS(3091),
    [anon_sym_TILDE] = ACTIONS(3093),
    [aux_sym_prefix_op_token1] = ACTIONS(3091),
    [aux_sym_infix_op_token1] = ACTIONS(3093),
    [aux_sym_infix_op_token2] = ACTIONS(3091),
    [anon_sym_PIPE_PIPE] = ACTIONS(3091),
    [anon_sym_BANG_EQ] = ACTIONS(3091),
    [anon_sym_COLON_EQ] = ACTIONS(3093),
    [anon_sym_DOLLAR] = ACTIONS(3091),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3091),
    [sym_int] = ACTIONS(3091),
    [sym_xint] = ACTIONS(3093),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3093),
    [sym__newline] = ACTIONS(3093),
    [sym__dedent] = ACTIONS(3093),
  },
  [945] = {
    [sym_block_comment] = STATE(945),
    [sym_compiler_directive_decl] = STATE(945),
    [sym_fsi_directive_decl] = STATE(945),
    [sym_preproc_line] = STATE(945),
    [sym_identifier] = ACTIONS(3095),
    [anon_sym_EQ] = ACTIONS(3097),
    [anon_sym_LBRACK_LT] = ACTIONS(3097),
    [anon_sym_COLON] = ACTIONS(3095),
    [anon_sym_return] = ACTIONS(3095),
    [anon_sym_do] = ACTIONS(3095),
    [anon_sym_let] = ACTIONS(3095),
    [anon_sym_let_BANG] = ACTIONS(3097),
    [aux_sym_access_modifier_token1] = ACTIONS(3097),
    [anon_sym_LPAREN] = ACTIONS(3095),
    [anon_sym_COMMA] = ACTIONS(3097),
    [anon_sym_null] = ACTIONS(3095),
    [anon_sym_QMARK] = ACTIONS(3095),
    [anon_sym_COLON_QMARK] = ACTIONS(3095),
    [anon_sym_COLON_COLON] = ACTIONS(3097),
    [anon_sym_AMP] = ACTIONS(3095),
    [anon_sym_LBRACK] = ACTIONS(3095),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3097),
    [anon_sym_LBRACE] = ACTIONS(3095),
    [anon_sym_LT_AT] = ACTIONS(3095),
    [anon_sym_LT_AT_AT] = ACTIONS(3095),
    [anon_sym_DOT] = ACTIONS(3095),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3097),
    [anon_sym_new] = ACTIONS(3095),
    [anon_sym_with] = ACTIONS(3095),
    [anon_sym_return_BANG] = ACTIONS(3097),
    [anon_sym_yield] = ACTIONS(3095),
    [anon_sym_yield_BANG] = ACTIONS(3097),
    [anon_sym_lazy] = ACTIONS(3095),
    [anon_sym_assert] = ACTIONS(3095),
    [anon_sym_upcast] = ACTIONS(3095),
    [anon_sym_downcast] = ACTIONS(3095),
    [anon_sym_COLON_GT] = ACTIONS(3097),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3097),
    [anon_sym_for] = ACTIONS(3095),
    [anon_sym_while] = ACTIONS(3095),
    [anon_sym_if] = ACTIONS(3095),
    [anon_sym_fun] = ACTIONS(3095),
    [anon_sym_try] = ACTIONS(3095),
    [anon_sym_match] = ACTIONS(3095),
    [anon_sym_match_BANG] = ACTIONS(3097),
    [anon_sym_function] = ACTIONS(3095),
    [anon_sym_LT_DASH] = ACTIONS(3095),
    [anon_sym_DOT_LBRACK] = ACTIONS(3097),
    [anon_sym_LT] = ACTIONS(3097),
    [anon_sym_use] = ACTIONS(3095),
    [anon_sym_use_BANG] = ACTIONS(3097),
    [anon_sym_do_BANG] = ACTIONS(3097),
    [anon_sym_begin] = ACTIONS(3095),
    [anon_sym_LPAREN2] = ACTIONS(3095),
    [anon_sym_DOT_DOT2] = ACTIONS(3097),
    [anon_sym_default] = ACTIONS(3095),
    [anon_sym_or] = ACTIONS(3095),
    [anon_sym_static] = ACTIONS(3095),
    [anon_sym_member] = ACTIONS(3095),
    [anon_sym_abstract] = ACTIONS(3095),
    [anon_sym_val] = ACTIONS(3095),
    [anon_sym_override] = ACTIONS(3095),
    [aux_sym_char_token1] = ACTIONS(3097),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3095),
    [anon_sym_DQUOTE] = ACTIONS(3095),
    [anon_sym_AT_DQUOTE] = ACTIONS(3097),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3097),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3097),
    [sym_bool] = ACTIONS(3095),
    [sym_unit] = ACTIONS(3097),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3095),
    [sym_op_identifier] = ACTIONS(3095),
    [anon_sym_PLUS] = ACTIONS(3095),
    [anon_sym_DASH] = ACTIONS(3095),
    [anon_sym_PLUS_DOT] = ACTIONS(3095),
    [anon_sym_DASH_DOT] = ACTIONS(3095),
    [anon_sym_PERCENT] = ACTIONS(3095),
    [anon_sym_AMP_AMP] = ACTIONS(3095),
    [anon_sym_TILDE] = ACTIONS(3097),
    [aux_sym_prefix_op_token1] = ACTIONS(3095),
    [aux_sym_infix_op_token1] = ACTIONS(3097),
    [aux_sym_infix_op_token2] = ACTIONS(3095),
    [anon_sym_PIPE_PIPE] = ACTIONS(3095),
    [anon_sym_BANG_EQ] = ACTIONS(3095),
    [anon_sym_COLON_EQ] = ACTIONS(3097),
    [anon_sym_DOLLAR] = ACTIONS(3095),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3095),
    [sym_int] = ACTIONS(3095),
    [sym_xint] = ACTIONS(3097),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3097),
    [sym__newline] = ACTIONS(3097),
    [sym__dedent] = ACTIONS(3097),
  },
  [946] = {
    [sym_block_comment] = STATE(946),
    [sym_compiler_directive_decl] = STATE(946),
    [sym_fsi_directive_decl] = STATE(946),
    [sym_preproc_line] = STATE(946),
    [sym_identifier] = ACTIONS(3099),
    [anon_sym_EQ] = ACTIONS(3101),
    [anon_sym_LBRACK_LT] = ACTIONS(3101),
    [anon_sym_COLON] = ACTIONS(3099),
    [anon_sym_return] = ACTIONS(3099),
    [anon_sym_do] = ACTIONS(3099),
    [anon_sym_let] = ACTIONS(3099),
    [anon_sym_let_BANG] = ACTIONS(3101),
    [aux_sym_access_modifier_token1] = ACTIONS(3101),
    [anon_sym_LPAREN] = ACTIONS(3099),
    [anon_sym_COMMA] = ACTIONS(3101),
    [anon_sym_null] = ACTIONS(3099),
    [anon_sym_QMARK] = ACTIONS(3099),
    [anon_sym_COLON_QMARK] = ACTIONS(3099),
    [anon_sym_COLON_COLON] = ACTIONS(3101),
    [anon_sym_AMP] = ACTIONS(3099),
    [anon_sym_LBRACK] = ACTIONS(3099),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3101),
    [anon_sym_LBRACE] = ACTIONS(3099),
    [anon_sym_LT_AT] = ACTIONS(3099),
    [anon_sym_LT_AT_AT] = ACTIONS(3099),
    [anon_sym_DOT] = ACTIONS(3099),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3101),
    [anon_sym_new] = ACTIONS(3099),
    [anon_sym_with] = ACTIONS(3099),
    [anon_sym_return_BANG] = ACTIONS(3101),
    [anon_sym_yield] = ACTIONS(3099),
    [anon_sym_yield_BANG] = ACTIONS(3101),
    [anon_sym_lazy] = ACTIONS(3099),
    [anon_sym_assert] = ACTIONS(3099),
    [anon_sym_upcast] = ACTIONS(3099),
    [anon_sym_downcast] = ACTIONS(3099),
    [anon_sym_COLON_GT] = ACTIONS(3101),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3101),
    [anon_sym_for] = ACTIONS(3099),
    [anon_sym_while] = ACTIONS(3099),
    [anon_sym_if] = ACTIONS(3099),
    [anon_sym_fun] = ACTIONS(3099),
    [anon_sym_try] = ACTIONS(3099),
    [anon_sym_match] = ACTIONS(3099),
    [anon_sym_match_BANG] = ACTIONS(3101),
    [anon_sym_function] = ACTIONS(3099),
    [anon_sym_LT_DASH] = ACTIONS(3099),
    [anon_sym_DOT_LBRACK] = ACTIONS(3101),
    [anon_sym_LT] = ACTIONS(3101),
    [anon_sym_use] = ACTIONS(3099),
    [anon_sym_use_BANG] = ACTIONS(3101),
    [anon_sym_do_BANG] = ACTIONS(3101),
    [anon_sym_begin] = ACTIONS(3099),
    [anon_sym_LPAREN2] = ACTIONS(3099),
    [anon_sym_DOT_DOT2] = ACTIONS(3101),
    [anon_sym_default] = ACTIONS(3099),
    [anon_sym_or] = ACTIONS(3099),
    [anon_sym_static] = ACTIONS(3099),
    [anon_sym_member] = ACTIONS(3099),
    [anon_sym_abstract] = ACTIONS(3099),
    [anon_sym_val] = ACTIONS(3099),
    [anon_sym_override] = ACTIONS(3099),
    [aux_sym_char_token1] = ACTIONS(3101),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3099),
    [anon_sym_DQUOTE] = ACTIONS(3099),
    [anon_sym_AT_DQUOTE] = ACTIONS(3101),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3101),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3101),
    [sym_bool] = ACTIONS(3099),
    [sym_unit] = ACTIONS(3101),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3099),
    [sym_op_identifier] = ACTIONS(3099),
    [anon_sym_PLUS] = ACTIONS(3099),
    [anon_sym_DASH] = ACTIONS(3099),
    [anon_sym_PLUS_DOT] = ACTIONS(3099),
    [anon_sym_DASH_DOT] = ACTIONS(3099),
    [anon_sym_PERCENT] = ACTIONS(3099),
    [anon_sym_AMP_AMP] = ACTIONS(3099),
    [anon_sym_TILDE] = ACTIONS(3101),
    [aux_sym_prefix_op_token1] = ACTIONS(3099),
    [aux_sym_infix_op_token1] = ACTIONS(3101),
    [aux_sym_infix_op_token2] = ACTIONS(3099),
    [anon_sym_PIPE_PIPE] = ACTIONS(3099),
    [anon_sym_BANG_EQ] = ACTIONS(3099),
    [anon_sym_COLON_EQ] = ACTIONS(3101),
    [anon_sym_DOLLAR] = ACTIONS(3099),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3099),
    [sym_int] = ACTIONS(3099),
    [sym_xint] = ACTIONS(3101),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3101),
    [sym__newline] = ACTIONS(3101),
    [sym__dedent] = ACTIONS(3101),
  },
  [947] = {
    [sym_block_comment] = STATE(947),
    [sym_compiler_directive_decl] = STATE(947),
    [sym_fsi_directive_decl] = STATE(947),
    [sym_preproc_line] = STATE(947),
    [sym_identifier] = ACTIONS(3103),
    [anon_sym_EQ] = ACTIONS(3105),
    [anon_sym_LBRACK_LT] = ACTIONS(3105),
    [anon_sym_COLON] = ACTIONS(3103),
    [anon_sym_return] = ACTIONS(3103),
    [anon_sym_do] = ACTIONS(3103),
    [anon_sym_let] = ACTIONS(3103),
    [anon_sym_let_BANG] = ACTIONS(3105),
    [aux_sym_access_modifier_token1] = ACTIONS(3105),
    [anon_sym_LPAREN] = ACTIONS(3103),
    [anon_sym_COMMA] = ACTIONS(3105),
    [anon_sym_null] = ACTIONS(3103),
    [anon_sym_QMARK] = ACTIONS(3103),
    [anon_sym_COLON_QMARK] = ACTIONS(3103),
    [anon_sym_COLON_COLON] = ACTIONS(3105),
    [anon_sym_AMP] = ACTIONS(3103),
    [anon_sym_LBRACK] = ACTIONS(3103),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3105),
    [anon_sym_LBRACE] = ACTIONS(3103),
    [anon_sym_LT_AT] = ACTIONS(3103),
    [anon_sym_LT_AT_AT] = ACTIONS(3103),
    [anon_sym_DOT] = ACTIONS(3103),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3105),
    [anon_sym_new] = ACTIONS(3103),
    [anon_sym_with] = ACTIONS(3103),
    [anon_sym_return_BANG] = ACTIONS(3105),
    [anon_sym_yield] = ACTIONS(3103),
    [anon_sym_yield_BANG] = ACTIONS(3105),
    [anon_sym_lazy] = ACTIONS(3103),
    [anon_sym_assert] = ACTIONS(3103),
    [anon_sym_upcast] = ACTIONS(3103),
    [anon_sym_downcast] = ACTIONS(3103),
    [anon_sym_COLON_GT] = ACTIONS(3105),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3105),
    [anon_sym_for] = ACTIONS(3103),
    [anon_sym_while] = ACTIONS(3103),
    [anon_sym_if] = ACTIONS(3103),
    [anon_sym_fun] = ACTIONS(3103),
    [anon_sym_try] = ACTIONS(3103),
    [anon_sym_match] = ACTIONS(3103),
    [anon_sym_match_BANG] = ACTIONS(3105),
    [anon_sym_function] = ACTIONS(3103),
    [anon_sym_LT_DASH] = ACTIONS(3103),
    [anon_sym_DOT_LBRACK] = ACTIONS(3105),
    [anon_sym_LT] = ACTIONS(3105),
    [anon_sym_use] = ACTIONS(3103),
    [anon_sym_use_BANG] = ACTIONS(3105),
    [anon_sym_do_BANG] = ACTIONS(3105),
    [anon_sym_begin] = ACTIONS(3103),
    [anon_sym_LPAREN2] = ACTIONS(3103),
    [anon_sym_DOT_DOT2] = ACTIONS(3105),
    [anon_sym_default] = ACTIONS(3103),
    [anon_sym_or] = ACTIONS(3103),
    [anon_sym_static] = ACTIONS(3103),
    [anon_sym_member] = ACTIONS(3103),
    [anon_sym_abstract] = ACTIONS(3103),
    [anon_sym_val] = ACTIONS(3103),
    [anon_sym_override] = ACTIONS(3103),
    [aux_sym_char_token1] = ACTIONS(3105),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3103),
    [anon_sym_DQUOTE] = ACTIONS(3103),
    [anon_sym_AT_DQUOTE] = ACTIONS(3105),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3105),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3105),
    [sym_bool] = ACTIONS(3103),
    [sym_unit] = ACTIONS(3105),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3103),
    [sym_op_identifier] = ACTIONS(3103),
    [anon_sym_PLUS] = ACTIONS(3103),
    [anon_sym_DASH] = ACTIONS(3103),
    [anon_sym_PLUS_DOT] = ACTIONS(3103),
    [anon_sym_DASH_DOT] = ACTIONS(3103),
    [anon_sym_PERCENT] = ACTIONS(3103),
    [anon_sym_AMP_AMP] = ACTIONS(3103),
    [anon_sym_TILDE] = ACTIONS(3105),
    [aux_sym_prefix_op_token1] = ACTIONS(3103),
    [aux_sym_infix_op_token1] = ACTIONS(3105),
    [aux_sym_infix_op_token2] = ACTIONS(3103),
    [anon_sym_PIPE_PIPE] = ACTIONS(3103),
    [anon_sym_BANG_EQ] = ACTIONS(3103),
    [anon_sym_COLON_EQ] = ACTIONS(3105),
    [anon_sym_DOLLAR] = ACTIONS(3103),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3103),
    [sym_int] = ACTIONS(3103),
    [sym_xint] = ACTIONS(3105),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3105),
    [sym__newline] = ACTIONS(3105),
    [sym__dedent] = ACTIONS(3105),
  },
  [948] = {
    [sym_block_comment] = STATE(948),
    [sym_compiler_directive_decl] = STATE(948),
    [sym_fsi_directive_decl] = STATE(948),
    [sym_preproc_line] = STATE(948),
    [sym_identifier] = ACTIONS(2553),
    [anon_sym_EQ] = ACTIONS(2555),
    [anon_sym_GT_RBRACK] = ACTIONS(2555),
    [anon_sym_COLON] = ACTIONS(2553),
    [anon_sym_return] = ACTIONS(2553),
    [anon_sym_do] = ACTIONS(2553),
    [anon_sym_let] = ACTIONS(2553),
    [anon_sym_let_BANG] = ACTIONS(2555),
    [anon_sym_LPAREN] = ACTIONS(2553),
    [anon_sym_COMMA] = ACTIONS(2555),
    [anon_sym_null] = ACTIONS(2553),
    [anon_sym_QMARK] = ACTIONS(2553),
    [anon_sym_COLON_QMARK] = ACTIONS(2553),
    [anon_sym_COLON_COLON] = ACTIONS(2555),
    [anon_sym_AMP] = ACTIONS(2553),
    [anon_sym_LBRACK] = ACTIONS(2553),
    [anon_sym_RBRACK] = ACTIONS(2555),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2555),
    [anon_sym_LBRACE] = ACTIONS(2553),
    [anon_sym_RBRACE] = ACTIONS(2555),
    [anon_sym_LT_AT] = ACTIONS(2553),
    [anon_sym_LT_AT_AT] = ACTIONS(2553),
    [anon_sym_DOT] = ACTIONS(2553),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2555),
    [anon_sym_new] = ACTIONS(2553),
    [anon_sym_with] = ACTIONS(2553),
    [anon_sym_return_BANG] = ACTIONS(2555),
    [anon_sym_yield] = ACTIONS(2553),
    [anon_sym_yield_BANG] = ACTIONS(2555),
    [anon_sym_lazy] = ACTIONS(2553),
    [anon_sym_assert] = ACTIONS(2553),
    [anon_sym_upcast] = ACTIONS(2553),
    [anon_sym_downcast] = ACTIONS(2553),
    [anon_sym_COLON_GT] = ACTIONS(2555),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2555),
    [anon_sym_for] = ACTIONS(2553),
    [anon_sym_to] = ACTIONS(2553),
    [anon_sym_downto] = ACTIONS(2553),
    [anon_sym_while] = ACTIONS(2553),
    [anon_sym_if] = ACTIONS(2553),
    [anon_sym_fun] = ACTIONS(2553),
    [anon_sym_DASH_GT] = ACTIONS(2553),
    [anon_sym_try] = ACTIONS(2553),
    [anon_sym_match] = ACTIONS(2553),
    [anon_sym_match_BANG] = ACTIONS(2555),
    [anon_sym_function] = ACTIONS(2553),
    [anon_sym_LT_DASH] = ACTIONS(2553),
    [anon_sym_DOT_LBRACK] = ACTIONS(2555),
    [anon_sym_LT] = ACTIONS(2555),
    [anon_sym_use] = ACTIONS(2553),
    [anon_sym_use_BANG] = ACTIONS(2555),
    [anon_sym_do_BANG] = ACTIONS(2555),
    [anon_sym_begin] = ACTIONS(2553),
    [anon_sym_LPAREN2] = ACTIONS(2553),
    [anon_sym_DOT_DOT2] = ACTIONS(2555),
    [anon_sym_STAR] = ACTIONS(2553),
    [anon_sym_LT2] = ACTIONS(2553),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2555),
    [anon_sym_or] = ACTIONS(2553),
    [aux_sym_char_token1] = ACTIONS(2555),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2553),
    [anon_sym_DQUOTE] = ACTIONS(2553),
    [anon_sym_AT_DQUOTE] = ACTIONS(2555),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2555),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2555),
    [sym_bool] = ACTIONS(2553),
    [sym_unit] = ACTIONS(2555),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2553),
    [sym_op_identifier] = ACTIONS(2553),
    [anon_sym_PLUS] = ACTIONS(2553),
    [anon_sym_DASH] = ACTIONS(2553),
    [anon_sym_PLUS_DOT] = ACTIONS(2553),
    [anon_sym_DASH_DOT] = ACTIONS(2553),
    [anon_sym_PERCENT] = ACTIONS(2553),
    [anon_sym_AMP_AMP] = ACTIONS(2553),
    [anon_sym_TILDE] = ACTIONS(2555),
    [aux_sym_prefix_op_token1] = ACTIONS(2553),
    [aux_sym_infix_op_token1] = ACTIONS(2555),
    [aux_sym_infix_op_token2] = ACTIONS(2553),
    [anon_sym_PIPE_PIPE] = ACTIONS(2553),
    [anon_sym_BANG_EQ] = ACTIONS(2553),
    [anon_sym_COLON_EQ] = ACTIONS(2555),
    [anon_sym_DOLLAR] = ACTIONS(2553),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2553),
    [sym_int] = ACTIONS(2553),
    [sym_xint] = ACTIONS(2555),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2555),
    [sym__newline] = ACTIONS(2555),
  },
  [949] = {
    [sym_block_comment] = STATE(949),
    [sym_compiler_directive_decl] = STATE(949),
    [sym_fsi_directive_decl] = STATE(949),
    [sym_preproc_line] = STATE(949),
    [sym_identifier] = ACTIONS(3107),
    [anon_sym_EQ] = ACTIONS(3109),
    [anon_sym_LBRACK_LT] = ACTIONS(3109),
    [anon_sym_COLON] = ACTIONS(3107),
    [anon_sym_return] = ACTIONS(3107),
    [anon_sym_do] = ACTIONS(3107),
    [anon_sym_let] = ACTIONS(3107),
    [anon_sym_let_BANG] = ACTIONS(3109),
    [aux_sym_access_modifier_token1] = ACTIONS(3109),
    [anon_sym_LPAREN] = ACTIONS(3107),
    [anon_sym_COMMA] = ACTIONS(3109),
    [anon_sym_null] = ACTIONS(3107),
    [anon_sym_QMARK] = ACTIONS(3107),
    [anon_sym_COLON_QMARK] = ACTIONS(3107),
    [anon_sym_COLON_COLON] = ACTIONS(3109),
    [anon_sym_AMP] = ACTIONS(3107),
    [anon_sym_LBRACK] = ACTIONS(3107),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3109),
    [anon_sym_LBRACE] = ACTIONS(3107),
    [anon_sym_LT_AT] = ACTIONS(3107),
    [anon_sym_LT_AT_AT] = ACTIONS(3107),
    [anon_sym_DOT] = ACTIONS(3107),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3109),
    [anon_sym_new] = ACTIONS(3107),
    [anon_sym_with] = ACTIONS(3107),
    [anon_sym_return_BANG] = ACTIONS(3109),
    [anon_sym_yield] = ACTIONS(3107),
    [anon_sym_yield_BANG] = ACTIONS(3109),
    [anon_sym_lazy] = ACTIONS(3107),
    [anon_sym_assert] = ACTIONS(3107),
    [anon_sym_upcast] = ACTIONS(3107),
    [anon_sym_downcast] = ACTIONS(3107),
    [anon_sym_COLON_GT] = ACTIONS(3109),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3109),
    [anon_sym_for] = ACTIONS(3107),
    [anon_sym_while] = ACTIONS(3107),
    [anon_sym_if] = ACTIONS(3107),
    [anon_sym_fun] = ACTIONS(3107),
    [anon_sym_try] = ACTIONS(3107),
    [anon_sym_match] = ACTIONS(3107),
    [anon_sym_match_BANG] = ACTIONS(3109),
    [anon_sym_function] = ACTIONS(3107),
    [anon_sym_LT_DASH] = ACTIONS(3107),
    [anon_sym_DOT_LBRACK] = ACTIONS(3109),
    [anon_sym_LT] = ACTIONS(3109),
    [anon_sym_use] = ACTIONS(3107),
    [anon_sym_use_BANG] = ACTIONS(3109),
    [anon_sym_do_BANG] = ACTIONS(3109),
    [anon_sym_begin] = ACTIONS(3107),
    [anon_sym_LPAREN2] = ACTIONS(3107),
    [anon_sym_DOT_DOT2] = ACTIONS(3109),
    [anon_sym_default] = ACTIONS(3107),
    [anon_sym_or] = ACTIONS(3107),
    [anon_sym_static] = ACTIONS(3107),
    [anon_sym_member] = ACTIONS(3107),
    [anon_sym_abstract] = ACTIONS(3107),
    [anon_sym_val] = ACTIONS(3107),
    [anon_sym_override] = ACTIONS(3107),
    [aux_sym_char_token1] = ACTIONS(3109),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3107),
    [anon_sym_DQUOTE] = ACTIONS(3107),
    [anon_sym_AT_DQUOTE] = ACTIONS(3109),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3109),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3109),
    [sym_bool] = ACTIONS(3107),
    [sym_unit] = ACTIONS(3109),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3107),
    [sym_op_identifier] = ACTIONS(3107),
    [anon_sym_PLUS] = ACTIONS(3107),
    [anon_sym_DASH] = ACTIONS(3107),
    [anon_sym_PLUS_DOT] = ACTIONS(3107),
    [anon_sym_DASH_DOT] = ACTIONS(3107),
    [anon_sym_PERCENT] = ACTIONS(3107),
    [anon_sym_AMP_AMP] = ACTIONS(3107),
    [anon_sym_TILDE] = ACTIONS(3109),
    [aux_sym_prefix_op_token1] = ACTIONS(3107),
    [aux_sym_infix_op_token1] = ACTIONS(3109),
    [aux_sym_infix_op_token2] = ACTIONS(3107),
    [anon_sym_PIPE_PIPE] = ACTIONS(3107),
    [anon_sym_BANG_EQ] = ACTIONS(3107),
    [anon_sym_COLON_EQ] = ACTIONS(3109),
    [anon_sym_DOLLAR] = ACTIONS(3107),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3107),
    [sym_int] = ACTIONS(3107),
    [sym_xint] = ACTIONS(3109),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3109),
    [sym__newline] = ACTIONS(3109),
    [sym__dedent] = ACTIONS(3109),
  },
  [950] = {
    [sym_block_comment] = STATE(950),
    [sym_compiler_directive_decl] = STATE(950),
    [sym_fsi_directive_decl] = STATE(950),
    [sym_preproc_line] = STATE(950),
    [sym_identifier] = ACTIONS(3111),
    [anon_sym_EQ] = ACTIONS(3113),
    [anon_sym_LBRACK_LT] = ACTIONS(3113),
    [anon_sym_COLON] = ACTIONS(3111),
    [anon_sym_return] = ACTIONS(3111),
    [anon_sym_do] = ACTIONS(3111),
    [anon_sym_let] = ACTIONS(3111),
    [anon_sym_let_BANG] = ACTIONS(3113),
    [aux_sym_access_modifier_token1] = ACTIONS(3113),
    [anon_sym_LPAREN] = ACTIONS(3111),
    [anon_sym_COMMA] = ACTIONS(3113),
    [anon_sym_null] = ACTIONS(3111),
    [anon_sym_QMARK] = ACTIONS(3111),
    [anon_sym_COLON_QMARK] = ACTIONS(3111),
    [anon_sym_COLON_COLON] = ACTIONS(3113),
    [anon_sym_AMP] = ACTIONS(3111),
    [anon_sym_LBRACK] = ACTIONS(3111),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3113),
    [anon_sym_LBRACE] = ACTIONS(3111),
    [anon_sym_LT_AT] = ACTIONS(3111),
    [anon_sym_LT_AT_AT] = ACTIONS(3111),
    [anon_sym_DOT] = ACTIONS(3111),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3113),
    [anon_sym_new] = ACTIONS(3111),
    [anon_sym_with] = ACTIONS(3111),
    [anon_sym_return_BANG] = ACTIONS(3113),
    [anon_sym_yield] = ACTIONS(3111),
    [anon_sym_yield_BANG] = ACTIONS(3113),
    [anon_sym_lazy] = ACTIONS(3111),
    [anon_sym_assert] = ACTIONS(3111),
    [anon_sym_upcast] = ACTIONS(3111),
    [anon_sym_downcast] = ACTIONS(3111),
    [anon_sym_COLON_GT] = ACTIONS(3113),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3113),
    [anon_sym_for] = ACTIONS(3111),
    [anon_sym_while] = ACTIONS(3111),
    [anon_sym_if] = ACTIONS(3111),
    [anon_sym_fun] = ACTIONS(3111),
    [anon_sym_try] = ACTIONS(3111),
    [anon_sym_match] = ACTIONS(3111),
    [anon_sym_match_BANG] = ACTIONS(3113),
    [anon_sym_function] = ACTIONS(3111),
    [anon_sym_LT_DASH] = ACTIONS(3111),
    [anon_sym_DOT_LBRACK] = ACTIONS(3113),
    [anon_sym_LT] = ACTIONS(3113),
    [anon_sym_use] = ACTIONS(3111),
    [anon_sym_use_BANG] = ACTIONS(3113),
    [anon_sym_do_BANG] = ACTIONS(3113),
    [anon_sym_begin] = ACTIONS(3111),
    [anon_sym_LPAREN2] = ACTIONS(3111),
    [anon_sym_DOT_DOT2] = ACTIONS(3113),
    [anon_sym_default] = ACTIONS(3111),
    [anon_sym_or] = ACTIONS(3111),
    [anon_sym_static] = ACTIONS(3111),
    [anon_sym_member] = ACTIONS(3111),
    [anon_sym_abstract] = ACTIONS(3111),
    [anon_sym_val] = ACTIONS(3111),
    [anon_sym_override] = ACTIONS(3111),
    [aux_sym_char_token1] = ACTIONS(3113),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3111),
    [anon_sym_DQUOTE] = ACTIONS(3111),
    [anon_sym_AT_DQUOTE] = ACTIONS(3113),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3113),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3113),
    [sym_bool] = ACTIONS(3111),
    [sym_unit] = ACTIONS(3113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3111),
    [sym_op_identifier] = ACTIONS(3111),
    [anon_sym_PLUS] = ACTIONS(3111),
    [anon_sym_DASH] = ACTIONS(3111),
    [anon_sym_PLUS_DOT] = ACTIONS(3111),
    [anon_sym_DASH_DOT] = ACTIONS(3111),
    [anon_sym_PERCENT] = ACTIONS(3111),
    [anon_sym_AMP_AMP] = ACTIONS(3111),
    [anon_sym_TILDE] = ACTIONS(3113),
    [aux_sym_prefix_op_token1] = ACTIONS(3111),
    [aux_sym_infix_op_token1] = ACTIONS(3113),
    [aux_sym_infix_op_token2] = ACTIONS(3111),
    [anon_sym_PIPE_PIPE] = ACTIONS(3111),
    [anon_sym_BANG_EQ] = ACTIONS(3111),
    [anon_sym_COLON_EQ] = ACTIONS(3113),
    [anon_sym_DOLLAR] = ACTIONS(3111),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3111),
    [sym_int] = ACTIONS(3111),
    [sym_xint] = ACTIONS(3113),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3113),
    [sym__newline] = ACTIONS(3113),
    [sym__dedent] = ACTIONS(3113),
  },
  [951] = {
    [sym_block_comment] = STATE(951),
    [sym_compiler_directive_decl] = STATE(951),
    [sym_fsi_directive_decl] = STATE(951),
    [sym_preproc_line] = STATE(951),
    [sym_identifier] = ACTIONS(2510),
    [anon_sym_EQ] = ACTIONS(2512),
    [anon_sym_GT_RBRACK] = ACTIONS(2512),
    [anon_sym_COLON] = ACTIONS(2510),
    [anon_sym_return] = ACTIONS(2510),
    [anon_sym_do] = ACTIONS(2510),
    [anon_sym_let] = ACTIONS(2510),
    [anon_sym_let_BANG] = ACTIONS(2512),
    [anon_sym_LPAREN] = ACTIONS(2510),
    [anon_sym_COMMA] = ACTIONS(2512),
    [anon_sym_null] = ACTIONS(2510),
    [anon_sym_QMARK] = ACTIONS(2510),
    [anon_sym_COLON_QMARK] = ACTIONS(2510),
    [anon_sym_COLON_COLON] = ACTIONS(2512),
    [anon_sym_AMP] = ACTIONS(2510),
    [anon_sym_LBRACK] = ACTIONS(2510),
    [anon_sym_RBRACK] = ACTIONS(2512),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2512),
    [anon_sym_LBRACE] = ACTIONS(2510),
    [anon_sym_RBRACE] = ACTIONS(2512),
    [anon_sym_LT_AT] = ACTIONS(2510),
    [anon_sym_LT_AT_AT] = ACTIONS(2510),
    [anon_sym_DOT] = ACTIONS(2510),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2512),
    [anon_sym_new] = ACTIONS(2510),
    [anon_sym_with] = ACTIONS(2510),
    [anon_sym_return_BANG] = ACTIONS(2512),
    [anon_sym_yield] = ACTIONS(2510),
    [anon_sym_yield_BANG] = ACTIONS(2512),
    [anon_sym_lazy] = ACTIONS(2510),
    [anon_sym_assert] = ACTIONS(2510),
    [anon_sym_upcast] = ACTIONS(2510),
    [anon_sym_downcast] = ACTIONS(2510),
    [anon_sym_COLON_GT] = ACTIONS(2512),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2512),
    [anon_sym_for] = ACTIONS(2510),
    [anon_sym_to] = ACTIONS(2510),
    [anon_sym_downto] = ACTIONS(2510),
    [anon_sym_while] = ACTIONS(2510),
    [anon_sym_if] = ACTIONS(2510),
    [anon_sym_fun] = ACTIONS(2510),
    [anon_sym_DASH_GT] = ACTIONS(2510),
    [anon_sym_try] = ACTIONS(2510),
    [anon_sym_match] = ACTIONS(2510),
    [anon_sym_match_BANG] = ACTIONS(2512),
    [anon_sym_function] = ACTIONS(2510),
    [anon_sym_LT_DASH] = ACTIONS(2510),
    [anon_sym_DOT_LBRACK] = ACTIONS(2512),
    [anon_sym_LT] = ACTIONS(2512),
    [anon_sym_use] = ACTIONS(2510),
    [anon_sym_use_BANG] = ACTIONS(2512),
    [anon_sym_do_BANG] = ACTIONS(2512),
    [anon_sym_begin] = ACTIONS(2510),
    [anon_sym_LPAREN2] = ACTIONS(2510),
    [anon_sym_DOT_DOT2] = ACTIONS(2512),
    [anon_sym_STAR] = ACTIONS(2510),
    [anon_sym_LT2] = ACTIONS(2510),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2512),
    [anon_sym_or] = ACTIONS(2510),
    [aux_sym_char_token1] = ACTIONS(2512),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2510),
    [anon_sym_DQUOTE] = ACTIONS(2510),
    [anon_sym_AT_DQUOTE] = ACTIONS(2512),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2512),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2512),
    [sym_bool] = ACTIONS(2510),
    [sym_unit] = ACTIONS(2512),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2510),
    [sym_op_identifier] = ACTIONS(2510),
    [anon_sym_PLUS] = ACTIONS(2510),
    [anon_sym_DASH] = ACTIONS(2510),
    [anon_sym_PLUS_DOT] = ACTIONS(2510),
    [anon_sym_DASH_DOT] = ACTIONS(2510),
    [anon_sym_PERCENT] = ACTIONS(2510),
    [anon_sym_AMP_AMP] = ACTIONS(2510),
    [anon_sym_TILDE] = ACTIONS(2512),
    [aux_sym_prefix_op_token1] = ACTIONS(2510),
    [aux_sym_infix_op_token1] = ACTIONS(2512),
    [aux_sym_infix_op_token2] = ACTIONS(2510),
    [anon_sym_PIPE_PIPE] = ACTIONS(2510),
    [anon_sym_BANG_EQ] = ACTIONS(2510),
    [anon_sym_COLON_EQ] = ACTIONS(2512),
    [anon_sym_DOLLAR] = ACTIONS(2510),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2510),
    [sym_int] = ACTIONS(2510),
    [sym_xint] = ACTIONS(2512),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2512),
    [sym__newline] = ACTIONS(2512),
  },
  [952] = {
    [sym_block_comment] = STATE(952),
    [sym_compiler_directive_decl] = STATE(952),
    [sym_fsi_directive_decl] = STATE(952),
    [sym_preproc_line] = STATE(952),
    [sym_identifier] = ACTIONS(3115),
    [anon_sym_EQ] = ACTIONS(3117),
    [anon_sym_LBRACK_LT] = ACTIONS(3117),
    [anon_sym_COLON] = ACTIONS(3115),
    [anon_sym_return] = ACTIONS(3115),
    [anon_sym_do] = ACTIONS(3115),
    [anon_sym_let] = ACTIONS(3115),
    [anon_sym_let_BANG] = ACTIONS(3117),
    [aux_sym_access_modifier_token1] = ACTIONS(3117),
    [anon_sym_LPAREN] = ACTIONS(3115),
    [anon_sym_COMMA] = ACTIONS(3117),
    [anon_sym_null] = ACTIONS(3115),
    [anon_sym_QMARK] = ACTIONS(3115),
    [anon_sym_COLON_QMARK] = ACTIONS(3115),
    [anon_sym_COLON_COLON] = ACTIONS(3117),
    [anon_sym_AMP] = ACTIONS(3115),
    [anon_sym_LBRACK] = ACTIONS(3115),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3117),
    [anon_sym_LBRACE] = ACTIONS(3115),
    [anon_sym_LT_AT] = ACTIONS(3115),
    [anon_sym_LT_AT_AT] = ACTIONS(3115),
    [anon_sym_DOT] = ACTIONS(3115),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3117),
    [anon_sym_new] = ACTIONS(3115),
    [anon_sym_with] = ACTIONS(3115),
    [anon_sym_return_BANG] = ACTIONS(3117),
    [anon_sym_yield] = ACTIONS(3115),
    [anon_sym_yield_BANG] = ACTIONS(3117),
    [anon_sym_lazy] = ACTIONS(3115),
    [anon_sym_assert] = ACTIONS(3115),
    [anon_sym_upcast] = ACTIONS(3115),
    [anon_sym_downcast] = ACTIONS(3115),
    [anon_sym_COLON_GT] = ACTIONS(3117),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3117),
    [anon_sym_for] = ACTIONS(3115),
    [anon_sym_while] = ACTIONS(3115),
    [anon_sym_if] = ACTIONS(3115),
    [anon_sym_fun] = ACTIONS(3115),
    [anon_sym_try] = ACTIONS(3115),
    [anon_sym_match] = ACTIONS(3115),
    [anon_sym_match_BANG] = ACTIONS(3117),
    [anon_sym_function] = ACTIONS(3115),
    [anon_sym_LT_DASH] = ACTIONS(3115),
    [anon_sym_DOT_LBRACK] = ACTIONS(3117),
    [anon_sym_LT] = ACTIONS(3117),
    [anon_sym_use] = ACTIONS(3115),
    [anon_sym_use_BANG] = ACTIONS(3117),
    [anon_sym_do_BANG] = ACTIONS(3117),
    [anon_sym_begin] = ACTIONS(3115),
    [anon_sym_LPAREN2] = ACTIONS(3115),
    [anon_sym_DOT_DOT2] = ACTIONS(3117),
    [anon_sym_default] = ACTIONS(3115),
    [anon_sym_or] = ACTIONS(3115),
    [anon_sym_static] = ACTIONS(3115),
    [anon_sym_member] = ACTIONS(3115),
    [anon_sym_abstract] = ACTIONS(3115),
    [anon_sym_val] = ACTIONS(3115),
    [anon_sym_override] = ACTIONS(3115),
    [aux_sym_char_token1] = ACTIONS(3117),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3115),
    [anon_sym_DQUOTE] = ACTIONS(3115),
    [anon_sym_AT_DQUOTE] = ACTIONS(3117),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3117),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3117),
    [sym_bool] = ACTIONS(3115),
    [sym_unit] = ACTIONS(3117),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3115),
    [sym_op_identifier] = ACTIONS(3115),
    [anon_sym_PLUS] = ACTIONS(3115),
    [anon_sym_DASH] = ACTIONS(3115),
    [anon_sym_PLUS_DOT] = ACTIONS(3115),
    [anon_sym_DASH_DOT] = ACTIONS(3115),
    [anon_sym_PERCENT] = ACTIONS(3115),
    [anon_sym_AMP_AMP] = ACTIONS(3115),
    [anon_sym_TILDE] = ACTIONS(3117),
    [aux_sym_prefix_op_token1] = ACTIONS(3115),
    [aux_sym_infix_op_token1] = ACTIONS(3117),
    [aux_sym_infix_op_token2] = ACTIONS(3115),
    [anon_sym_PIPE_PIPE] = ACTIONS(3115),
    [anon_sym_BANG_EQ] = ACTIONS(3115),
    [anon_sym_COLON_EQ] = ACTIONS(3117),
    [anon_sym_DOLLAR] = ACTIONS(3115),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3115),
    [sym_int] = ACTIONS(3115),
    [sym_xint] = ACTIONS(3117),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3117),
    [sym__newline] = ACTIONS(3117),
    [sym__dedent] = ACTIONS(3117),
  },
  [953] = {
    [sym_block_comment] = STATE(953),
    [sym_compiler_directive_decl] = STATE(953),
    [sym_fsi_directive_decl] = STATE(953),
    [sym_preproc_line] = STATE(953),
    [sym_identifier] = ACTIONS(3119),
    [anon_sym_EQ] = ACTIONS(3121),
    [anon_sym_LBRACK_LT] = ACTIONS(3121),
    [anon_sym_COLON] = ACTIONS(3119),
    [anon_sym_return] = ACTIONS(3119),
    [anon_sym_do] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_let_BANG] = ACTIONS(3121),
    [aux_sym_access_modifier_token1] = ACTIONS(3121),
    [anon_sym_LPAREN] = ACTIONS(3119),
    [anon_sym_COMMA] = ACTIONS(3121),
    [anon_sym_null] = ACTIONS(3119),
    [anon_sym_QMARK] = ACTIONS(3119),
    [anon_sym_COLON_QMARK] = ACTIONS(3119),
    [anon_sym_COLON_COLON] = ACTIONS(3121),
    [anon_sym_AMP] = ACTIONS(3119),
    [anon_sym_LBRACK] = ACTIONS(3119),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3121),
    [anon_sym_LBRACE] = ACTIONS(3119),
    [anon_sym_LT_AT] = ACTIONS(3119),
    [anon_sym_LT_AT_AT] = ACTIONS(3119),
    [anon_sym_DOT] = ACTIONS(3119),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3121),
    [anon_sym_new] = ACTIONS(3119),
    [anon_sym_with] = ACTIONS(3119),
    [anon_sym_return_BANG] = ACTIONS(3121),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_yield_BANG] = ACTIONS(3121),
    [anon_sym_lazy] = ACTIONS(3119),
    [anon_sym_assert] = ACTIONS(3119),
    [anon_sym_upcast] = ACTIONS(3119),
    [anon_sym_downcast] = ACTIONS(3119),
    [anon_sym_COLON_GT] = ACTIONS(3121),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3121),
    [anon_sym_for] = ACTIONS(3119),
    [anon_sym_while] = ACTIONS(3119),
    [anon_sym_if] = ACTIONS(3119),
    [anon_sym_fun] = ACTIONS(3119),
    [anon_sym_try] = ACTIONS(3119),
    [anon_sym_match] = ACTIONS(3119),
    [anon_sym_match_BANG] = ACTIONS(3121),
    [anon_sym_function] = ACTIONS(3119),
    [anon_sym_LT_DASH] = ACTIONS(3119),
    [anon_sym_DOT_LBRACK] = ACTIONS(3121),
    [anon_sym_LT] = ACTIONS(3121),
    [anon_sym_use] = ACTIONS(3119),
    [anon_sym_use_BANG] = ACTIONS(3121),
    [anon_sym_do_BANG] = ACTIONS(3121),
    [anon_sym_begin] = ACTIONS(3119),
    [anon_sym_LPAREN2] = ACTIONS(3119),
    [anon_sym_DOT_DOT2] = ACTIONS(3121),
    [anon_sym_default] = ACTIONS(3119),
    [anon_sym_or] = ACTIONS(3119),
    [anon_sym_static] = ACTIONS(3119),
    [anon_sym_member] = ACTIONS(3119),
    [anon_sym_abstract] = ACTIONS(3119),
    [anon_sym_val] = ACTIONS(3119),
    [anon_sym_override] = ACTIONS(3119),
    [aux_sym_char_token1] = ACTIONS(3121),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3119),
    [anon_sym_DQUOTE] = ACTIONS(3119),
    [anon_sym_AT_DQUOTE] = ACTIONS(3121),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3121),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3121),
    [sym_bool] = ACTIONS(3119),
    [sym_unit] = ACTIONS(3121),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3119),
    [sym_op_identifier] = ACTIONS(3119),
    [anon_sym_PLUS] = ACTIONS(3119),
    [anon_sym_DASH] = ACTIONS(3119),
    [anon_sym_PLUS_DOT] = ACTIONS(3119),
    [anon_sym_DASH_DOT] = ACTIONS(3119),
    [anon_sym_PERCENT] = ACTIONS(3119),
    [anon_sym_AMP_AMP] = ACTIONS(3119),
    [anon_sym_TILDE] = ACTIONS(3121),
    [aux_sym_prefix_op_token1] = ACTIONS(3119),
    [aux_sym_infix_op_token1] = ACTIONS(3121),
    [aux_sym_infix_op_token2] = ACTIONS(3119),
    [anon_sym_PIPE_PIPE] = ACTIONS(3119),
    [anon_sym_BANG_EQ] = ACTIONS(3119),
    [anon_sym_COLON_EQ] = ACTIONS(3121),
    [anon_sym_DOLLAR] = ACTIONS(3119),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3119),
    [sym_int] = ACTIONS(3119),
    [sym_xint] = ACTIONS(3121),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3121),
    [sym__newline] = ACTIONS(3121),
    [sym__dedent] = ACTIONS(3121),
  },
  [954] = {
    [sym_block_comment] = STATE(954),
    [sym_compiler_directive_decl] = STATE(954),
    [sym_fsi_directive_decl] = STATE(954),
    [sym_preproc_line] = STATE(954),
    [sym_identifier] = ACTIONS(3123),
    [anon_sym_EQ] = ACTIONS(3125),
    [anon_sym_LBRACK_LT] = ACTIONS(3125),
    [anon_sym_COLON] = ACTIONS(3123),
    [anon_sym_return] = ACTIONS(3123),
    [anon_sym_do] = ACTIONS(3123),
    [anon_sym_let] = ACTIONS(3123),
    [anon_sym_let_BANG] = ACTIONS(3125),
    [aux_sym_access_modifier_token1] = ACTIONS(3125),
    [anon_sym_LPAREN] = ACTIONS(3123),
    [anon_sym_COMMA] = ACTIONS(3125),
    [anon_sym_null] = ACTIONS(3123),
    [anon_sym_QMARK] = ACTIONS(3123),
    [anon_sym_COLON_QMARK] = ACTIONS(3123),
    [anon_sym_COLON_COLON] = ACTIONS(3125),
    [anon_sym_AMP] = ACTIONS(3123),
    [anon_sym_LBRACK] = ACTIONS(3123),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3125),
    [anon_sym_LBRACE] = ACTIONS(3123),
    [anon_sym_LT_AT] = ACTIONS(3123),
    [anon_sym_LT_AT_AT] = ACTIONS(3123),
    [anon_sym_DOT] = ACTIONS(3123),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3125),
    [anon_sym_new] = ACTIONS(3123),
    [anon_sym_with] = ACTIONS(3123),
    [anon_sym_return_BANG] = ACTIONS(3125),
    [anon_sym_yield] = ACTIONS(3123),
    [anon_sym_yield_BANG] = ACTIONS(3125),
    [anon_sym_lazy] = ACTIONS(3123),
    [anon_sym_assert] = ACTIONS(3123),
    [anon_sym_upcast] = ACTIONS(3123),
    [anon_sym_downcast] = ACTIONS(3123),
    [anon_sym_COLON_GT] = ACTIONS(3125),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3125),
    [anon_sym_for] = ACTIONS(3123),
    [anon_sym_while] = ACTIONS(3123),
    [anon_sym_if] = ACTIONS(3123),
    [anon_sym_fun] = ACTIONS(3123),
    [anon_sym_try] = ACTIONS(3123),
    [anon_sym_match] = ACTIONS(3123),
    [anon_sym_match_BANG] = ACTIONS(3125),
    [anon_sym_function] = ACTIONS(3123),
    [anon_sym_LT_DASH] = ACTIONS(3123),
    [anon_sym_DOT_LBRACK] = ACTIONS(3125),
    [anon_sym_LT] = ACTIONS(3125),
    [anon_sym_use] = ACTIONS(3123),
    [anon_sym_use_BANG] = ACTIONS(3125),
    [anon_sym_do_BANG] = ACTIONS(3125),
    [anon_sym_begin] = ACTIONS(3123),
    [anon_sym_LPAREN2] = ACTIONS(3123),
    [anon_sym_DOT_DOT2] = ACTIONS(3125),
    [anon_sym_default] = ACTIONS(3123),
    [anon_sym_or] = ACTIONS(3123),
    [anon_sym_static] = ACTIONS(3123),
    [anon_sym_member] = ACTIONS(3123),
    [anon_sym_abstract] = ACTIONS(3123),
    [anon_sym_val] = ACTIONS(3123),
    [anon_sym_override] = ACTIONS(3123),
    [aux_sym_char_token1] = ACTIONS(3125),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3123),
    [anon_sym_DQUOTE] = ACTIONS(3123),
    [anon_sym_AT_DQUOTE] = ACTIONS(3125),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3125),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3125),
    [sym_bool] = ACTIONS(3123),
    [sym_unit] = ACTIONS(3125),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3123),
    [sym_op_identifier] = ACTIONS(3123),
    [anon_sym_PLUS] = ACTIONS(3123),
    [anon_sym_DASH] = ACTIONS(3123),
    [anon_sym_PLUS_DOT] = ACTIONS(3123),
    [anon_sym_DASH_DOT] = ACTIONS(3123),
    [anon_sym_PERCENT] = ACTIONS(3123),
    [anon_sym_AMP_AMP] = ACTIONS(3123),
    [anon_sym_TILDE] = ACTIONS(3125),
    [aux_sym_prefix_op_token1] = ACTIONS(3123),
    [aux_sym_infix_op_token1] = ACTIONS(3125),
    [aux_sym_infix_op_token2] = ACTIONS(3123),
    [anon_sym_PIPE_PIPE] = ACTIONS(3123),
    [anon_sym_BANG_EQ] = ACTIONS(3123),
    [anon_sym_COLON_EQ] = ACTIONS(3125),
    [anon_sym_DOLLAR] = ACTIONS(3123),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3123),
    [sym_int] = ACTIONS(3123),
    [sym_xint] = ACTIONS(3125),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3125),
    [sym__newline] = ACTIONS(3125),
    [sym__dedent] = ACTIONS(3125),
  },
  [955] = {
    [sym_block_comment] = STATE(955),
    [sym_compiler_directive_decl] = STATE(955),
    [sym_fsi_directive_decl] = STATE(955),
    [sym_preproc_line] = STATE(955),
    [sym_identifier] = ACTIONS(3127),
    [anon_sym_EQ] = ACTIONS(3129),
    [anon_sym_LBRACK_LT] = ACTIONS(3129),
    [anon_sym_COLON] = ACTIONS(3127),
    [anon_sym_return] = ACTIONS(3127),
    [anon_sym_do] = ACTIONS(3127),
    [anon_sym_let] = ACTIONS(3127),
    [anon_sym_let_BANG] = ACTIONS(3129),
    [aux_sym_access_modifier_token1] = ACTIONS(3129),
    [anon_sym_LPAREN] = ACTIONS(3127),
    [anon_sym_COMMA] = ACTIONS(3129),
    [anon_sym_null] = ACTIONS(3127),
    [anon_sym_QMARK] = ACTIONS(3127),
    [anon_sym_COLON_QMARK] = ACTIONS(3127),
    [anon_sym_COLON_COLON] = ACTIONS(3129),
    [anon_sym_AMP] = ACTIONS(3127),
    [anon_sym_LBRACK] = ACTIONS(3127),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3129),
    [anon_sym_LBRACE] = ACTIONS(3127),
    [anon_sym_LT_AT] = ACTIONS(3127),
    [anon_sym_LT_AT_AT] = ACTIONS(3127),
    [anon_sym_DOT] = ACTIONS(3127),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3129),
    [anon_sym_new] = ACTIONS(3127),
    [anon_sym_with] = ACTIONS(3127),
    [anon_sym_return_BANG] = ACTIONS(3129),
    [anon_sym_yield] = ACTIONS(3127),
    [anon_sym_yield_BANG] = ACTIONS(3129),
    [anon_sym_lazy] = ACTIONS(3127),
    [anon_sym_assert] = ACTIONS(3127),
    [anon_sym_upcast] = ACTIONS(3127),
    [anon_sym_downcast] = ACTIONS(3127),
    [anon_sym_COLON_GT] = ACTIONS(3129),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3129),
    [anon_sym_for] = ACTIONS(3127),
    [anon_sym_while] = ACTIONS(3127),
    [anon_sym_if] = ACTIONS(3127),
    [anon_sym_fun] = ACTIONS(3127),
    [anon_sym_try] = ACTIONS(3127),
    [anon_sym_match] = ACTIONS(3127),
    [anon_sym_match_BANG] = ACTIONS(3129),
    [anon_sym_function] = ACTIONS(3127),
    [anon_sym_LT_DASH] = ACTIONS(3127),
    [anon_sym_DOT_LBRACK] = ACTIONS(3129),
    [anon_sym_LT] = ACTIONS(3129),
    [anon_sym_use] = ACTIONS(3127),
    [anon_sym_use_BANG] = ACTIONS(3129),
    [anon_sym_do_BANG] = ACTIONS(3129),
    [anon_sym_begin] = ACTIONS(3127),
    [anon_sym_LPAREN2] = ACTIONS(3127),
    [anon_sym_DOT_DOT2] = ACTIONS(3129),
    [anon_sym_default] = ACTIONS(3127),
    [anon_sym_or] = ACTIONS(3127),
    [anon_sym_static] = ACTIONS(3127),
    [anon_sym_member] = ACTIONS(3127),
    [anon_sym_abstract] = ACTIONS(3127),
    [anon_sym_val] = ACTIONS(3127),
    [anon_sym_override] = ACTIONS(3127),
    [aux_sym_char_token1] = ACTIONS(3129),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3127),
    [anon_sym_DQUOTE] = ACTIONS(3127),
    [anon_sym_AT_DQUOTE] = ACTIONS(3129),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3129),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3129),
    [sym_bool] = ACTIONS(3127),
    [sym_unit] = ACTIONS(3129),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3127),
    [sym_op_identifier] = ACTIONS(3127),
    [anon_sym_PLUS] = ACTIONS(3127),
    [anon_sym_DASH] = ACTIONS(3127),
    [anon_sym_PLUS_DOT] = ACTIONS(3127),
    [anon_sym_DASH_DOT] = ACTIONS(3127),
    [anon_sym_PERCENT] = ACTIONS(3127),
    [anon_sym_AMP_AMP] = ACTIONS(3127),
    [anon_sym_TILDE] = ACTIONS(3129),
    [aux_sym_prefix_op_token1] = ACTIONS(3127),
    [aux_sym_infix_op_token1] = ACTIONS(3129),
    [aux_sym_infix_op_token2] = ACTIONS(3127),
    [anon_sym_PIPE_PIPE] = ACTIONS(3127),
    [anon_sym_BANG_EQ] = ACTIONS(3127),
    [anon_sym_COLON_EQ] = ACTIONS(3129),
    [anon_sym_DOLLAR] = ACTIONS(3127),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3127),
    [sym_int] = ACTIONS(3127),
    [sym_xint] = ACTIONS(3129),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3129),
    [sym__newline] = ACTIONS(3129),
    [sym__dedent] = ACTIONS(3129),
  },
  [956] = {
    [sym_block_comment] = STATE(956),
    [sym_compiler_directive_decl] = STATE(956),
    [sym_fsi_directive_decl] = STATE(956),
    [sym_preproc_line] = STATE(956),
    [sym_identifier] = ACTIONS(3131),
    [anon_sym_EQ] = ACTIONS(3133),
    [anon_sym_LBRACK_LT] = ACTIONS(3133),
    [anon_sym_COLON] = ACTIONS(3131),
    [anon_sym_return] = ACTIONS(3131),
    [anon_sym_do] = ACTIONS(3131),
    [anon_sym_let] = ACTIONS(3131),
    [anon_sym_let_BANG] = ACTIONS(3133),
    [aux_sym_access_modifier_token1] = ACTIONS(3133),
    [anon_sym_LPAREN] = ACTIONS(3131),
    [anon_sym_COMMA] = ACTIONS(3133),
    [anon_sym_null] = ACTIONS(3131),
    [anon_sym_QMARK] = ACTIONS(3131),
    [anon_sym_COLON_QMARK] = ACTIONS(3131),
    [anon_sym_COLON_COLON] = ACTIONS(3133),
    [anon_sym_AMP] = ACTIONS(3131),
    [anon_sym_LBRACK] = ACTIONS(3131),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3133),
    [anon_sym_LBRACE] = ACTIONS(3131),
    [anon_sym_LT_AT] = ACTIONS(3131),
    [anon_sym_LT_AT_AT] = ACTIONS(3131),
    [anon_sym_DOT] = ACTIONS(3131),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3133),
    [anon_sym_new] = ACTIONS(3131),
    [anon_sym_with] = ACTIONS(3131),
    [anon_sym_return_BANG] = ACTIONS(3133),
    [anon_sym_yield] = ACTIONS(3131),
    [anon_sym_yield_BANG] = ACTIONS(3133),
    [anon_sym_lazy] = ACTIONS(3131),
    [anon_sym_assert] = ACTIONS(3131),
    [anon_sym_upcast] = ACTIONS(3131),
    [anon_sym_downcast] = ACTIONS(3131),
    [anon_sym_COLON_GT] = ACTIONS(3133),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3133),
    [anon_sym_for] = ACTIONS(3131),
    [anon_sym_while] = ACTIONS(3131),
    [anon_sym_if] = ACTIONS(3131),
    [anon_sym_fun] = ACTIONS(3131),
    [anon_sym_try] = ACTIONS(3131),
    [anon_sym_match] = ACTIONS(3131),
    [anon_sym_match_BANG] = ACTIONS(3133),
    [anon_sym_function] = ACTIONS(3131),
    [anon_sym_LT_DASH] = ACTIONS(3131),
    [anon_sym_DOT_LBRACK] = ACTIONS(3133),
    [anon_sym_LT] = ACTIONS(3133),
    [anon_sym_use] = ACTIONS(3131),
    [anon_sym_use_BANG] = ACTIONS(3133),
    [anon_sym_do_BANG] = ACTIONS(3133),
    [anon_sym_begin] = ACTIONS(3131),
    [anon_sym_LPAREN2] = ACTIONS(3131),
    [anon_sym_DOT_DOT2] = ACTIONS(3133),
    [anon_sym_default] = ACTIONS(3131),
    [anon_sym_or] = ACTIONS(3131),
    [anon_sym_static] = ACTIONS(3131),
    [anon_sym_member] = ACTIONS(3131),
    [anon_sym_abstract] = ACTIONS(3131),
    [anon_sym_val] = ACTIONS(3131),
    [anon_sym_override] = ACTIONS(3131),
    [aux_sym_char_token1] = ACTIONS(3133),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3131),
    [anon_sym_DQUOTE] = ACTIONS(3131),
    [anon_sym_AT_DQUOTE] = ACTIONS(3133),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3133),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3133),
    [sym_bool] = ACTIONS(3131),
    [sym_unit] = ACTIONS(3133),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3131),
    [sym_op_identifier] = ACTIONS(3131),
    [anon_sym_PLUS] = ACTIONS(3131),
    [anon_sym_DASH] = ACTIONS(3131),
    [anon_sym_PLUS_DOT] = ACTIONS(3131),
    [anon_sym_DASH_DOT] = ACTIONS(3131),
    [anon_sym_PERCENT] = ACTIONS(3131),
    [anon_sym_AMP_AMP] = ACTIONS(3131),
    [anon_sym_TILDE] = ACTIONS(3133),
    [aux_sym_prefix_op_token1] = ACTIONS(3131),
    [aux_sym_infix_op_token1] = ACTIONS(3133),
    [aux_sym_infix_op_token2] = ACTIONS(3131),
    [anon_sym_PIPE_PIPE] = ACTIONS(3131),
    [anon_sym_BANG_EQ] = ACTIONS(3131),
    [anon_sym_COLON_EQ] = ACTIONS(3133),
    [anon_sym_DOLLAR] = ACTIONS(3131),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3131),
    [sym_int] = ACTIONS(3131),
    [sym_xint] = ACTIONS(3133),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3133),
    [sym__newline] = ACTIONS(3133),
    [sym__dedent] = ACTIONS(3133),
  },
  [957] = {
    [sym_block_comment] = STATE(957),
    [sym_compiler_directive_decl] = STATE(957),
    [sym_fsi_directive_decl] = STATE(957),
    [sym_preproc_line] = STATE(957),
    [sym_identifier] = ACTIONS(3135),
    [anon_sym_EQ] = ACTIONS(3137),
    [anon_sym_LBRACK_LT] = ACTIONS(3137),
    [anon_sym_COLON] = ACTIONS(3135),
    [anon_sym_return] = ACTIONS(3135),
    [anon_sym_do] = ACTIONS(3135),
    [anon_sym_let] = ACTIONS(3135),
    [anon_sym_let_BANG] = ACTIONS(3137),
    [aux_sym_access_modifier_token1] = ACTIONS(3137),
    [anon_sym_LPAREN] = ACTIONS(3135),
    [anon_sym_COMMA] = ACTIONS(3137),
    [anon_sym_null] = ACTIONS(3135),
    [anon_sym_QMARK] = ACTIONS(3135),
    [anon_sym_COLON_QMARK] = ACTIONS(3135),
    [anon_sym_COLON_COLON] = ACTIONS(3137),
    [anon_sym_AMP] = ACTIONS(3135),
    [anon_sym_LBRACK] = ACTIONS(3135),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3137),
    [anon_sym_LBRACE] = ACTIONS(3135),
    [anon_sym_LT_AT] = ACTIONS(3135),
    [anon_sym_LT_AT_AT] = ACTIONS(3135),
    [anon_sym_DOT] = ACTIONS(3135),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3137),
    [anon_sym_new] = ACTIONS(3135),
    [anon_sym_with] = ACTIONS(3135),
    [anon_sym_return_BANG] = ACTIONS(3137),
    [anon_sym_yield] = ACTIONS(3135),
    [anon_sym_yield_BANG] = ACTIONS(3137),
    [anon_sym_lazy] = ACTIONS(3135),
    [anon_sym_assert] = ACTIONS(3135),
    [anon_sym_upcast] = ACTIONS(3135),
    [anon_sym_downcast] = ACTIONS(3135),
    [anon_sym_COLON_GT] = ACTIONS(3137),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3137),
    [anon_sym_for] = ACTIONS(3135),
    [anon_sym_while] = ACTIONS(3135),
    [anon_sym_if] = ACTIONS(3135),
    [anon_sym_fun] = ACTIONS(3135),
    [anon_sym_try] = ACTIONS(3135),
    [anon_sym_match] = ACTIONS(3135),
    [anon_sym_match_BANG] = ACTIONS(3137),
    [anon_sym_function] = ACTIONS(3135),
    [anon_sym_LT_DASH] = ACTIONS(3135),
    [anon_sym_DOT_LBRACK] = ACTIONS(3137),
    [anon_sym_LT] = ACTIONS(3137),
    [anon_sym_use] = ACTIONS(3135),
    [anon_sym_use_BANG] = ACTIONS(3137),
    [anon_sym_do_BANG] = ACTIONS(3137),
    [anon_sym_begin] = ACTIONS(3135),
    [anon_sym_LPAREN2] = ACTIONS(3135),
    [anon_sym_DOT_DOT2] = ACTIONS(3137),
    [anon_sym_default] = ACTIONS(3135),
    [anon_sym_or] = ACTIONS(3135),
    [anon_sym_static] = ACTIONS(3135),
    [anon_sym_member] = ACTIONS(3135),
    [anon_sym_abstract] = ACTIONS(3135),
    [anon_sym_val] = ACTIONS(3135),
    [anon_sym_override] = ACTIONS(3135),
    [aux_sym_char_token1] = ACTIONS(3137),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3135),
    [anon_sym_DQUOTE] = ACTIONS(3135),
    [anon_sym_AT_DQUOTE] = ACTIONS(3137),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3137),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3137),
    [sym_bool] = ACTIONS(3135),
    [sym_unit] = ACTIONS(3137),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3135),
    [sym_op_identifier] = ACTIONS(3135),
    [anon_sym_PLUS] = ACTIONS(3135),
    [anon_sym_DASH] = ACTIONS(3135),
    [anon_sym_PLUS_DOT] = ACTIONS(3135),
    [anon_sym_DASH_DOT] = ACTIONS(3135),
    [anon_sym_PERCENT] = ACTIONS(3135),
    [anon_sym_AMP_AMP] = ACTIONS(3135),
    [anon_sym_TILDE] = ACTIONS(3137),
    [aux_sym_prefix_op_token1] = ACTIONS(3135),
    [aux_sym_infix_op_token1] = ACTIONS(3137),
    [aux_sym_infix_op_token2] = ACTIONS(3135),
    [anon_sym_PIPE_PIPE] = ACTIONS(3135),
    [anon_sym_BANG_EQ] = ACTIONS(3135),
    [anon_sym_COLON_EQ] = ACTIONS(3137),
    [anon_sym_DOLLAR] = ACTIONS(3135),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3135),
    [sym_int] = ACTIONS(3135),
    [sym_xint] = ACTIONS(3137),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3137),
    [sym__newline] = ACTIONS(3137),
    [sym__dedent] = ACTIONS(3137),
  },
  [958] = {
    [sym_block_comment] = STATE(958),
    [sym_compiler_directive_decl] = STATE(958),
    [sym_fsi_directive_decl] = STATE(958),
    [sym_preproc_line] = STATE(958),
    [sym_identifier] = ACTIONS(3139),
    [anon_sym_EQ] = ACTIONS(3141),
    [anon_sym_LBRACK_LT] = ACTIONS(3141),
    [anon_sym_COLON] = ACTIONS(3139),
    [anon_sym_return] = ACTIONS(3139),
    [anon_sym_do] = ACTIONS(3139),
    [anon_sym_let] = ACTIONS(3139),
    [anon_sym_let_BANG] = ACTIONS(3141),
    [aux_sym_access_modifier_token1] = ACTIONS(3141),
    [anon_sym_LPAREN] = ACTIONS(3139),
    [anon_sym_COMMA] = ACTIONS(3141),
    [anon_sym_null] = ACTIONS(3139),
    [anon_sym_QMARK] = ACTIONS(3139),
    [anon_sym_COLON_QMARK] = ACTIONS(3139),
    [anon_sym_COLON_COLON] = ACTIONS(3141),
    [anon_sym_AMP] = ACTIONS(3139),
    [anon_sym_LBRACK] = ACTIONS(3139),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3141),
    [anon_sym_LBRACE] = ACTIONS(3139),
    [anon_sym_LT_AT] = ACTIONS(3139),
    [anon_sym_LT_AT_AT] = ACTIONS(3139),
    [anon_sym_DOT] = ACTIONS(3139),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3141),
    [anon_sym_new] = ACTIONS(3139),
    [anon_sym_with] = ACTIONS(3139),
    [anon_sym_return_BANG] = ACTIONS(3141),
    [anon_sym_yield] = ACTIONS(3139),
    [anon_sym_yield_BANG] = ACTIONS(3141),
    [anon_sym_lazy] = ACTIONS(3139),
    [anon_sym_assert] = ACTIONS(3139),
    [anon_sym_upcast] = ACTIONS(3139),
    [anon_sym_downcast] = ACTIONS(3139),
    [anon_sym_COLON_GT] = ACTIONS(3141),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3141),
    [anon_sym_for] = ACTIONS(3139),
    [anon_sym_while] = ACTIONS(3139),
    [anon_sym_if] = ACTIONS(3139),
    [anon_sym_fun] = ACTIONS(3139),
    [anon_sym_try] = ACTIONS(3139),
    [anon_sym_match] = ACTIONS(3139),
    [anon_sym_match_BANG] = ACTIONS(3141),
    [anon_sym_function] = ACTIONS(3139),
    [anon_sym_LT_DASH] = ACTIONS(3139),
    [anon_sym_DOT_LBRACK] = ACTIONS(3141),
    [anon_sym_LT] = ACTIONS(3141),
    [anon_sym_use] = ACTIONS(3139),
    [anon_sym_use_BANG] = ACTIONS(3141),
    [anon_sym_do_BANG] = ACTIONS(3141),
    [anon_sym_begin] = ACTIONS(3139),
    [anon_sym_LPAREN2] = ACTIONS(3139),
    [anon_sym_DOT_DOT2] = ACTIONS(3141),
    [anon_sym_default] = ACTIONS(3139),
    [anon_sym_or] = ACTIONS(3139),
    [anon_sym_static] = ACTIONS(3139),
    [anon_sym_member] = ACTIONS(3139),
    [anon_sym_abstract] = ACTIONS(3139),
    [anon_sym_val] = ACTIONS(3139),
    [anon_sym_override] = ACTIONS(3139),
    [aux_sym_char_token1] = ACTIONS(3141),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3139),
    [anon_sym_DQUOTE] = ACTIONS(3139),
    [anon_sym_AT_DQUOTE] = ACTIONS(3141),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3141),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3141),
    [sym_bool] = ACTIONS(3139),
    [sym_unit] = ACTIONS(3141),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3139),
    [sym_op_identifier] = ACTIONS(3139),
    [anon_sym_PLUS] = ACTIONS(3139),
    [anon_sym_DASH] = ACTIONS(3139),
    [anon_sym_PLUS_DOT] = ACTIONS(3139),
    [anon_sym_DASH_DOT] = ACTIONS(3139),
    [anon_sym_PERCENT] = ACTIONS(3139),
    [anon_sym_AMP_AMP] = ACTIONS(3139),
    [anon_sym_TILDE] = ACTIONS(3141),
    [aux_sym_prefix_op_token1] = ACTIONS(3139),
    [aux_sym_infix_op_token1] = ACTIONS(3141),
    [aux_sym_infix_op_token2] = ACTIONS(3139),
    [anon_sym_PIPE_PIPE] = ACTIONS(3139),
    [anon_sym_BANG_EQ] = ACTIONS(3139),
    [anon_sym_COLON_EQ] = ACTIONS(3141),
    [anon_sym_DOLLAR] = ACTIONS(3139),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3139),
    [sym_int] = ACTIONS(3139),
    [sym_xint] = ACTIONS(3141),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3141),
    [sym__newline] = ACTIONS(3141),
    [sym__dedent] = ACTIONS(3141),
  },
  [959] = {
    [sym_type_arguments] = STATE(1151),
    [sym_long_identifier] = STATE(1116),
    [sym_block_comment] = STATE(959),
    [sym_compiler_directive_decl] = STATE(959),
    [sym_fsi_directive_decl] = STATE(959),
    [sym_preproc_line] = STATE(959),
    [aux_sym_compound_type_repeat1] = STATE(1011),
    [sym_identifier] = ACTIONS(2252),
    [anon_sym_EQ] = ACTIONS(2254),
    [anon_sym_COLON] = ACTIONS(2252),
    [anon_sym_return] = ACTIONS(2252),
    [anon_sym_do] = ACTIONS(2252),
    [anon_sym_let] = ACTIONS(2252),
    [anon_sym_let_BANG] = ACTIONS(2254),
    [anon_sym_as] = ACTIONS(2252),
    [anon_sym_LPAREN] = ACTIONS(2252),
    [anon_sym_COMMA] = ACTIONS(2254),
    [anon_sym_null] = ACTIONS(2252),
    [anon_sym_QMARK] = ACTIONS(2252),
    [anon_sym_COLON_QMARK] = ACTIONS(2252),
    [anon_sym_COLON_COLON] = ACTIONS(2254),
    [anon_sym_AMP] = ACTIONS(2252),
    [anon_sym_LBRACK] = ACTIONS(2252),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2254),
    [anon_sym_LBRACE] = ACTIONS(2252),
    [anon_sym_LT_AT] = ACTIONS(2252),
    [anon_sym_LT_AT_AT] = ACTIONS(2252),
    [anon_sym_DOT] = ACTIONS(2252),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2254),
    [anon_sym_new] = ACTIONS(2252),
    [anon_sym_with] = ACTIONS(2252),
    [anon_sym_return_BANG] = ACTIONS(2254),
    [anon_sym_yield] = ACTIONS(2252),
    [anon_sym_yield_BANG] = ACTIONS(2254),
    [anon_sym_lazy] = ACTIONS(2252),
    [anon_sym_assert] = ACTIONS(2252),
    [anon_sym_upcast] = ACTIONS(2252),
    [anon_sym_downcast] = ACTIONS(2252),
    [anon_sym_COLON_GT] = ACTIONS(2254),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2254),
    [anon_sym_for] = ACTIONS(2252),
    [anon_sym_while] = ACTIONS(2252),
    [anon_sym_if] = ACTIONS(2252),
    [anon_sym_fun] = ACTIONS(2252),
    [anon_sym_DASH_GT] = ACTIONS(3143),
    [anon_sym_try] = ACTIONS(2252),
    [anon_sym_match] = ACTIONS(2252),
    [anon_sym_match_BANG] = ACTIONS(2254),
    [anon_sym_function] = ACTIONS(2252),
    [anon_sym_LT_DASH] = ACTIONS(2252),
    [anon_sym_DOT_LBRACK] = ACTIONS(2254),
    [anon_sym_LT] = ACTIONS(2254),
    [anon_sym_use] = ACTIONS(2252),
    [anon_sym_use_BANG] = ACTIONS(2254),
    [anon_sym_do_BANG] = ACTIONS(2254),
    [anon_sym_begin] = ACTIONS(2252),
    [anon_sym_LPAREN2] = ACTIONS(2252),
    [anon_sym_STAR] = ACTIONS(3145),
    [anon_sym_LT2] = ACTIONS(3147),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3149),
    [anon_sym_or] = ACTIONS(2252),
    [aux_sym_char_token1] = ACTIONS(2254),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2252),
    [anon_sym_DQUOTE] = ACTIONS(2252),
    [anon_sym_AT_DQUOTE] = ACTIONS(2254),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2254),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2254),
    [sym_bool] = ACTIONS(2252),
    [sym_unit] = ACTIONS(2254),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2252),
    [sym_op_identifier] = ACTIONS(2252),
    [anon_sym_PLUS] = ACTIONS(2252),
    [anon_sym_DASH] = ACTIONS(2252),
    [anon_sym_PLUS_DOT] = ACTIONS(2252),
    [anon_sym_DASH_DOT] = ACTIONS(2252),
    [anon_sym_PERCENT] = ACTIONS(2252),
    [anon_sym_AMP_AMP] = ACTIONS(2252),
    [anon_sym_TILDE] = ACTIONS(2254),
    [aux_sym_prefix_op_token1] = ACTIONS(2252),
    [aux_sym_infix_op_token1] = ACTIONS(2254),
    [aux_sym_infix_op_token2] = ACTIONS(2252),
    [anon_sym_PIPE_PIPE] = ACTIONS(2252),
    [anon_sym_BANG_EQ] = ACTIONS(2252),
    [anon_sym_COLON_EQ] = ACTIONS(2254),
    [anon_sym_DOLLAR] = ACTIONS(2252),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2252),
    [sym_int] = ACTIONS(2252),
    [sym_xint] = ACTIONS(2254),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2254),
    [sym__newline] = ACTIONS(2254),
    [sym__dedent] = ACTIONS(2254),
  },
  [960] = {
    [sym_type_arguments] = STATE(1151),
    [sym_long_identifier] = STATE(1116),
    [sym_block_comment] = STATE(960),
    [sym_compiler_directive_decl] = STATE(960),
    [sym_fsi_directive_decl] = STATE(960),
    [sym_preproc_line] = STATE(960),
    [aux_sym_compound_type_repeat1] = STATE(1011),
    [sym_identifier] = ACTIONS(3151),
    [anon_sym_EQ] = ACTIONS(2240),
    [anon_sym_COLON] = ACTIONS(2242),
    [anon_sym_return] = ACTIONS(2242),
    [anon_sym_do] = ACTIONS(2242),
    [anon_sym_let] = ACTIONS(2242),
    [anon_sym_let_BANG] = ACTIONS(2240),
    [anon_sym_as] = ACTIONS(2242),
    [anon_sym_LPAREN] = ACTIONS(2242),
    [anon_sym_COMMA] = ACTIONS(2240),
    [anon_sym_null] = ACTIONS(2242),
    [anon_sym_QMARK] = ACTIONS(2242),
    [anon_sym_COLON_QMARK] = ACTIONS(2242),
    [anon_sym_COLON_COLON] = ACTIONS(2240),
    [anon_sym_AMP] = ACTIONS(2242),
    [anon_sym_LBRACK] = ACTIONS(2242),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2240),
    [anon_sym_LBRACE] = ACTIONS(2242),
    [anon_sym_LT_AT] = ACTIONS(2242),
    [anon_sym_LT_AT_AT] = ACTIONS(2242),
    [anon_sym_DOT] = ACTIONS(2242),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2240),
    [anon_sym_new] = ACTIONS(2242),
    [anon_sym_with] = ACTIONS(2242),
    [anon_sym_return_BANG] = ACTIONS(2240),
    [anon_sym_yield] = ACTIONS(2242),
    [anon_sym_yield_BANG] = ACTIONS(2240),
    [anon_sym_lazy] = ACTIONS(2242),
    [anon_sym_assert] = ACTIONS(2242),
    [anon_sym_upcast] = ACTIONS(2242),
    [anon_sym_downcast] = ACTIONS(2242),
    [anon_sym_COLON_GT] = ACTIONS(2240),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2240),
    [anon_sym_for] = ACTIONS(2242),
    [anon_sym_while] = ACTIONS(2242),
    [anon_sym_if] = ACTIONS(2242),
    [anon_sym_fun] = ACTIONS(2242),
    [anon_sym_DASH_GT] = ACTIONS(3143),
    [anon_sym_try] = ACTIONS(2242),
    [anon_sym_match] = ACTIONS(2242),
    [anon_sym_match_BANG] = ACTIONS(2240),
    [anon_sym_function] = ACTIONS(2242),
    [anon_sym_LT_DASH] = ACTIONS(2242),
    [anon_sym_DOT_LBRACK] = ACTIONS(2240),
    [anon_sym_LT] = ACTIONS(2240),
    [anon_sym_use] = ACTIONS(2242),
    [anon_sym_use_BANG] = ACTIONS(2240),
    [anon_sym_do_BANG] = ACTIONS(2240),
    [anon_sym_begin] = ACTIONS(2242),
    [anon_sym_LPAREN2] = ACTIONS(2242),
    [anon_sym_STAR] = ACTIONS(3145),
    [anon_sym_LT2] = ACTIONS(3147),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3149),
    [anon_sym_or] = ACTIONS(2242),
    [aux_sym_char_token1] = ACTIONS(2240),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2242),
    [anon_sym_DQUOTE] = ACTIONS(2242),
    [anon_sym_AT_DQUOTE] = ACTIONS(2240),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2240),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2240),
    [sym_bool] = ACTIONS(2242),
    [sym_unit] = ACTIONS(2240),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2242),
    [sym_op_identifier] = ACTIONS(2242),
    [anon_sym_PLUS] = ACTIONS(2242),
    [anon_sym_DASH] = ACTIONS(2242),
    [anon_sym_PLUS_DOT] = ACTIONS(2242),
    [anon_sym_DASH_DOT] = ACTIONS(2242),
    [anon_sym_PERCENT] = ACTIONS(2242),
    [anon_sym_AMP_AMP] = ACTIONS(2242),
    [anon_sym_TILDE] = ACTIONS(2240),
    [aux_sym_prefix_op_token1] = ACTIONS(2242),
    [aux_sym_infix_op_token1] = ACTIONS(2240),
    [aux_sym_infix_op_token2] = ACTIONS(2242),
    [anon_sym_PIPE_PIPE] = ACTIONS(2242),
    [anon_sym_BANG_EQ] = ACTIONS(2242),
    [anon_sym_COLON_EQ] = ACTIONS(2240),
    [anon_sym_DOLLAR] = ACTIONS(2242),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2242),
    [sym_int] = ACTIONS(2242),
    [sym_xint] = ACTIONS(2240),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2240),
    [sym__newline] = ACTIONS(2240),
    [sym__dedent] = ACTIONS(2240),
  },
  [961] = {
    [sym_type_arguments] = STATE(1151),
    [sym_long_identifier] = STATE(1116),
    [sym_block_comment] = STATE(961),
    [sym_compiler_directive_decl] = STATE(961),
    [sym_fsi_directive_decl] = STATE(961),
    [sym_preproc_line] = STATE(961),
    [aux_sym_compound_type_repeat1] = STATE(1011),
    [sym_identifier] = ACTIONS(3151),
    [anon_sym_EQ] = ACTIONS(2228),
    [anon_sym_COLON] = ACTIONS(2230),
    [anon_sym_return] = ACTIONS(2230),
    [anon_sym_do] = ACTIONS(2230),
    [anon_sym_let] = ACTIONS(2230),
    [anon_sym_let_BANG] = ACTIONS(2228),
    [anon_sym_as] = ACTIONS(2230),
    [anon_sym_LPAREN] = ACTIONS(2230),
    [anon_sym_COMMA] = ACTIONS(2228),
    [anon_sym_null] = ACTIONS(2230),
    [anon_sym_QMARK] = ACTIONS(2230),
    [anon_sym_COLON_QMARK] = ACTIONS(2230),
    [anon_sym_COLON_COLON] = ACTIONS(2228),
    [anon_sym_AMP] = ACTIONS(2230),
    [anon_sym_LBRACK] = ACTIONS(2230),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2228),
    [anon_sym_LBRACE] = ACTIONS(2230),
    [anon_sym_LT_AT] = ACTIONS(2230),
    [anon_sym_LT_AT_AT] = ACTIONS(2230),
    [anon_sym_DOT] = ACTIONS(2230),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2228),
    [anon_sym_new] = ACTIONS(2230),
    [anon_sym_with] = ACTIONS(2230),
    [anon_sym_return_BANG] = ACTIONS(2228),
    [anon_sym_yield] = ACTIONS(2230),
    [anon_sym_yield_BANG] = ACTIONS(2228),
    [anon_sym_lazy] = ACTIONS(2230),
    [anon_sym_assert] = ACTIONS(2230),
    [anon_sym_upcast] = ACTIONS(2230),
    [anon_sym_downcast] = ACTIONS(2230),
    [anon_sym_COLON_GT] = ACTIONS(2228),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2228),
    [anon_sym_for] = ACTIONS(2230),
    [anon_sym_while] = ACTIONS(2230),
    [anon_sym_if] = ACTIONS(2230),
    [anon_sym_fun] = ACTIONS(2230),
    [anon_sym_DASH_GT] = ACTIONS(3143),
    [anon_sym_try] = ACTIONS(2230),
    [anon_sym_match] = ACTIONS(2230),
    [anon_sym_match_BANG] = ACTIONS(2228),
    [anon_sym_function] = ACTIONS(2230),
    [anon_sym_LT_DASH] = ACTIONS(2230),
    [anon_sym_DOT_LBRACK] = ACTIONS(2228),
    [anon_sym_LT] = ACTIONS(2228),
    [anon_sym_use] = ACTIONS(2230),
    [anon_sym_use_BANG] = ACTIONS(2228),
    [anon_sym_do_BANG] = ACTIONS(2228),
    [anon_sym_begin] = ACTIONS(2230),
    [anon_sym_LPAREN2] = ACTIONS(2230),
    [anon_sym_STAR] = ACTIONS(3145),
    [anon_sym_LT2] = ACTIONS(3147),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3149),
    [anon_sym_or] = ACTIONS(2230),
    [aux_sym_char_token1] = ACTIONS(2228),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2230),
    [anon_sym_DQUOTE] = ACTIONS(2230),
    [anon_sym_AT_DQUOTE] = ACTIONS(2228),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2228),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2228),
    [sym_bool] = ACTIONS(2230),
    [sym_unit] = ACTIONS(2228),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2230),
    [sym_op_identifier] = ACTIONS(2230),
    [anon_sym_PLUS] = ACTIONS(2230),
    [anon_sym_DASH] = ACTIONS(2230),
    [anon_sym_PLUS_DOT] = ACTIONS(2230),
    [anon_sym_DASH_DOT] = ACTIONS(2230),
    [anon_sym_PERCENT] = ACTIONS(2230),
    [anon_sym_AMP_AMP] = ACTIONS(2230),
    [anon_sym_TILDE] = ACTIONS(2228),
    [aux_sym_prefix_op_token1] = ACTIONS(2230),
    [aux_sym_infix_op_token1] = ACTIONS(2228),
    [aux_sym_infix_op_token2] = ACTIONS(2230),
    [anon_sym_PIPE_PIPE] = ACTIONS(2230),
    [anon_sym_BANG_EQ] = ACTIONS(2230),
    [anon_sym_COLON_EQ] = ACTIONS(2228),
    [anon_sym_DOLLAR] = ACTIONS(2230),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2230),
    [sym_int] = ACTIONS(2230),
    [sym_xint] = ACTIONS(2228),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2228),
    [sym__newline] = ACTIONS(2228),
    [sym__dedent] = ACTIONS(2228),
  },
  [962] = {
    [sym_type_arguments] = STATE(1151),
    [sym_long_identifier] = STATE(1116),
    [sym_block_comment] = STATE(962),
    [sym_compiler_directive_decl] = STATE(962),
    [sym_fsi_directive_decl] = STATE(962),
    [sym_preproc_line] = STATE(962),
    [aux_sym_compound_type_repeat1] = STATE(1011),
    [sym_identifier] = ACTIONS(3151),
    [anon_sym_EQ] = ACTIONS(2248),
    [anon_sym_COLON] = ACTIONS(2250),
    [anon_sym_return] = ACTIONS(2250),
    [anon_sym_do] = ACTIONS(2250),
    [anon_sym_let] = ACTIONS(2250),
    [anon_sym_let_BANG] = ACTIONS(2248),
    [anon_sym_as] = ACTIONS(2250),
    [anon_sym_LPAREN] = ACTIONS(2250),
    [anon_sym_COMMA] = ACTIONS(2248),
    [anon_sym_null] = ACTIONS(2250),
    [anon_sym_QMARK] = ACTIONS(2250),
    [anon_sym_COLON_QMARK] = ACTIONS(2250),
    [anon_sym_COLON_COLON] = ACTIONS(2248),
    [anon_sym_AMP] = ACTIONS(2250),
    [anon_sym_LBRACK] = ACTIONS(2250),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2248),
    [anon_sym_LBRACE] = ACTIONS(2250),
    [anon_sym_LT_AT] = ACTIONS(2250),
    [anon_sym_LT_AT_AT] = ACTIONS(2250),
    [anon_sym_DOT] = ACTIONS(2250),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2248),
    [anon_sym_new] = ACTIONS(2250),
    [anon_sym_with] = ACTIONS(2250),
    [anon_sym_return_BANG] = ACTIONS(2248),
    [anon_sym_yield] = ACTIONS(2250),
    [anon_sym_yield_BANG] = ACTIONS(2248),
    [anon_sym_lazy] = ACTIONS(2250),
    [anon_sym_assert] = ACTIONS(2250),
    [anon_sym_upcast] = ACTIONS(2250),
    [anon_sym_downcast] = ACTIONS(2250),
    [anon_sym_COLON_GT] = ACTIONS(2248),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2248),
    [anon_sym_for] = ACTIONS(2250),
    [anon_sym_while] = ACTIONS(2250),
    [anon_sym_if] = ACTIONS(2250),
    [anon_sym_fun] = ACTIONS(2250),
    [anon_sym_DASH_GT] = ACTIONS(3143),
    [anon_sym_try] = ACTIONS(2250),
    [anon_sym_match] = ACTIONS(2250),
    [anon_sym_match_BANG] = ACTIONS(2248),
    [anon_sym_function] = ACTIONS(2250),
    [anon_sym_LT_DASH] = ACTIONS(2250),
    [anon_sym_DOT_LBRACK] = ACTIONS(2248),
    [anon_sym_LT] = ACTIONS(2248),
    [anon_sym_use] = ACTIONS(2250),
    [anon_sym_use_BANG] = ACTIONS(2248),
    [anon_sym_do_BANG] = ACTIONS(2248),
    [anon_sym_begin] = ACTIONS(2250),
    [anon_sym_LPAREN2] = ACTIONS(2250),
    [anon_sym_STAR] = ACTIONS(3145),
    [anon_sym_LT2] = ACTIONS(3147),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3149),
    [anon_sym_or] = ACTIONS(2250),
    [aux_sym_char_token1] = ACTIONS(2248),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2250),
    [anon_sym_DQUOTE] = ACTIONS(2250),
    [anon_sym_AT_DQUOTE] = ACTIONS(2248),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2248),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2248),
    [sym_bool] = ACTIONS(2250),
    [sym_unit] = ACTIONS(2248),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2250),
    [sym_op_identifier] = ACTIONS(2250),
    [anon_sym_PLUS] = ACTIONS(2250),
    [anon_sym_DASH] = ACTIONS(2250),
    [anon_sym_PLUS_DOT] = ACTIONS(2250),
    [anon_sym_DASH_DOT] = ACTIONS(2250),
    [anon_sym_PERCENT] = ACTIONS(2250),
    [anon_sym_AMP_AMP] = ACTIONS(2250),
    [anon_sym_TILDE] = ACTIONS(2248),
    [aux_sym_prefix_op_token1] = ACTIONS(2250),
    [aux_sym_infix_op_token1] = ACTIONS(2248),
    [aux_sym_infix_op_token2] = ACTIONS(2250),
    [anon_sym_PIPE_PIPE] = ACTIONS(2250),
    [anon_sym_BANG_EQ] = ACTIONS(2250),
    [anon_sym_COLON_EQ] = ACTIONS(2248),
    [anon_sym_DOLLAR] = ACTIONS(2250),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2250),
    [sym_int] = ACTIONS(2250),
    [sym_xint] = ACTIONS(2248),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2248),
    [sym__newline] = ACTIONS(2248),
    [sym__dedent] = ACTIONS(2248),
  },
  [963] = {
    [sym_type_arguments] = STATE(1151),
    [sym_long_identifier] = STATE(1116),
    [sym_block_comment] = STATE(963),
    [sym_compiler_directive_decl] = STATE(963),
    [sym_fsi_directive_decl] = STATE(963),
    [sym_preproc_line] = STATE(963),
    [aux_sym_compound_type_repeat1] = STATE(1011),
    [sym_identifier] = ACTIONS(3151),
    [anon_sym_EQ] = ACTIONS(2244),
    [anon_sym_COLON] = ACTIONS(2246),
    [anon_sym_return] = ACTIONS(2246),
    [anon_sym_do] = ACTIONS(2246),
    [anon_sym_let] = ACTIONS(2246),
    [anon_sym_let_BANG] = ACTIONS(2244),
    [anon_sym_as] = ACTIONS(2246),
    [anon_sym_LPAREN] = ACTIONS(2246),
    [anon_sym_COMMA] = ACTIONS(2244),
    [anon_sym_null] = ACTIONS(2246),
    [anon_sym_QMARK] = ACTIONS(2246),
    [anon_sym_COLON_QMARK] = ACTIONS(2246),
    [anon_sym_COLON_COLON] = ACTIONS(2244),
    [anon_sym_AMP] = ACTIONS(2246),
    [anon_sym_LBRACK] = ACTIONS(2246),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2244),
    [anon_sym_LBRACE] = ACTIONS(2246),
    [anon_sym_LT_AT] = ACTIONS(2246),
    [anon_sym_LT_AT_AT] = ACTIONS(2246),
    [anon_sym_DOT] = ACTIONS(2246),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2244),
    [anon_sym_new] = ACTIONS(2246),
    [anon_sym_with] = ACTIONS(2246),
    [anon_sym_return_BANG] = ACTIONS(2244),
    [anon_sym_yield] = ACTIONS(2246),
    [anon_sym_yield_BANG] = ACTIONS(2244),
    [anon_sym_lazy] = ACTIONS(2246),
    [anon_sym_assert] = ACTIONS(2246),
    [anon_sym_upcast] = ACTIONS(2246),
    [anon_sym_downcast] = ACTIONS(2246),
    [anon_sym_COLON_GT] = ACTIONS(2244),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2244),
    [anon_sym_for] = ACTIONS(2246),
    [anon_sym_while] = ACTIONS(2246),
    [anon_sym_if] = ACTIONS(2246),
    [anon_sym_fun] = ACTIONS(2246),
    [anon_sym_DASH_GT] = ACTIONS(3143),
    [anon_sym_try] = ACTIONS(2246),
    [anon_sym_match] = ACTIONS(2246),
    [anon_sym_match_BANG] = ACTIONS(2244),
    [anon_sym_function] = ACTIONS(2246),
    [anon_sym_LT_DASH] = ACTIONS(2246),
    [anon_sym_DOT_LBRACK] = ACTIONS(2244),
    [anon_sym_LT] = ACTIONS(2244),
    [anon_sym_use] = ACTIONS(2246),
    [anon_sym_use_BANG] = ACTIONS(2244),
    [anon_sym_do_BANG] = ACTIONS(2244),
    [anon_sym_begin] = ACTIONS(2246),
    [anon_sym_LPAREN2] = ACTIONS(2246),
    [anon_sym_STAR] = ACTIONS(3145),
    [anon_sym_LT2] = ACTIONS(3147),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3149),
    [anon_sym_or] = ACTIONS(2246),
    [aux_sym_char_token1] = ACTIONS(2244),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2246),
    [anon_sym_DQUOTE] = ACTIONS(2246),
    [anon_sym_AT_DQUOTE] = ACTIONS(2244),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2244),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2244),
    [sym_bool] = ACTIONS(2246),
    [sym_unit] = ACTIONS(2244),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2246),
    [sym_op_identifier] = ACTIONS(2246),
    [anon_sym_PLUS] = ACTIONS(2246),
    [anon_sym_DASH] = ACTIONS(2246),
    [anon_sym_PLUS_DOT] = ACTIONS(2246),
    [anon_sym_DASH_DOT] = ACTIONS(2246),
    [anon_sym_PERCENT] = ACTIONS(2246),
    [anon_sym_AMP_AMP] = ACTIONS(2246),
    [anon_sym_TILDE] = ACTIONS(2244),
    [aux_sym_prefix_op_token1] = ACTIONS(2246),
    [aux_sym_infix_op_token1] = ACTIONS(2244),
    [aux_sym_infix_op_token2] = ACTIONS(2246),
    [anon_sym_PIPE_PIPE] = ACTIONS(2246),
    [anon_sym_BANG_EQ] = ACTIONS(2246),
    [anon_sym_COLON_EQ] = ACTIONS(2244),
    [anon_sym_DOLLAR] = ACTIONS(2246),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2246),
    [sym_int] = ACTIONS(2246),
    [sym_xint] = ACTIONS(2244),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2244),
    [sym__newline] = ACTIONS(2244),
    [sym__dedent] = ACTIONS(2244),
  },
  [964] = {
    [sym_block_comment] = STATE(964),
    [sym_compiler_directive_decl] = STATE(964),
    [sym_fsi_directive_decl] = STATE(964),
    [sym_preproc_line] = STATE(964),
    [sym_identifier] = ACTIONS(2723),
    [anon_sym_EQ] = ACTIONS(2725),
    [anon_sym_GT_RBRACK] = ACTIONS(2725),
    [anon_sym_COLON] = ACTIONS(2723),
    [anon_sym_return] = ACTIONS(2723),
    [anon_sym_do] = ACTIONS(2723),
    [anon_sym_let] = ACTIONS(2723),
    [anon_sym_let_BANG] = ACTIONS(2725),
    [anon_sym_LPAREN] = ACTIONS(2723),
    [anon_sym_COMMA] = ACTIONS(2725),
    [anon_sym_null] = ACTIONS(2723),
    [anon_sym_QMARK] = ACTIONS(2723),
    [anon_sym_COLON_QMARK] = ACTIONS(2723),
    [anon_sym_COLON_COLON] = ACTIONS(2725),
    [anon_sym_AMP] = ACTIONS(2723),
    [anon_sym_LBRACK] = ACTIONS(2723),
    [anon_sym_RBRACK] = ACTIONS(2725),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2725),
    [anon_sym_LBRACE] = ACTIONS(2723),
    [anon_sym_RBRACE] = ACTIONS(2725),
    [anon_sym_LT_AT] = ACTIONS(2723),
    [anon_sym_LT_AT_AT] = ACTIONS(2723),
    [anon_sym_DOT] = ACTIONS(2723),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2725),
    [anon_sym_new] = ACTIONS(2723),
    [anon_sym_with] = ACTIONS(2723),
    [anon_sym_return_BANG] = ACTIONS(2725),
    [anon_sym_yield] = ACTIONS(2723),
    [anon_sym_yield_BANG] = ACTIONS(2725),
    [anon_sym_lazy] = ACTIONS(2723),
    [anon_sym_assert] = ACTIONS(2723),
    [anon_sym_upcast] = ACTIONS(2723),
    [anon_sym_downcast] = ACTIONS(2723),
    [anon_sym_COLON_GT] = ACTIONS(2725),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2725),
    [anon_sym_for] = ACTIONS(2723),
    [anon_sym_to] = ACTIONS(2723),
    [anon_sym_downto] = ACTIONS(2723),
    [anon_sym_while] = ACTIONS(2723),
    [anon_sym_if] = ACTIONS(2723),
    [anon_sym_fun] = ACTIONS(2723),
    [anon_sym_try] = ACTIONS(2723),
    [anon_sym_match] = ACTIONS(2723),
    [anon_sym_match_BANG] = ACTIONS(2725),
    [anon_sym_function] = ACTIONS(2723),
    [anon_sym_LT_DASH] = ACTIONS(2723),
    [anon_sym_DOT_LBRACK] = ACTIONS(2725),
    [anon_sym_LT] = ACTIONS(2725),
    [anon_sym_use] = ACTIONS(2723),
    [anon_sym_use_BANG] = ACTIONS(2725),
    [anon_sym_do_BANG] = ACTIONS(2725),
    [anon_sym_begin] = ACTIONS(2723),
    [anon_sym_LPAREN2] = ACTIONS(2723),
    [anon_sym_DOT_DOT2] = ACTIONS(2725),
    [anon_sym_or] = ACTIONS(2723),
    [aux_sym_char_token1] = ACTIONS(2725),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2723),
    [anon_sym_DQUOTE] = ACTIONS(2723),
    [anon_sym_AT_DQUOTE] = ACTIONS(2725),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2725),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2725),
    [sym_bool] = ACTIONS(2723),
    [sym_unit] = ACTIONS(2725),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2723),
    [sym_op_identifier] = ACTIONS(2723),
    [anon_sym_PLUS] = ACTIONS(2723),
    [anon_sym_DASH] = ACTIONS(2723),
    [anon_sym_PLUS_DOT] = ACTIONS(2723),
    [anon_sym_DASH_DOT] = ACTIONS(2723),
    [anon_sym_PERCENT] = ACTIONS(2723),
    [anon_sym_AMP_AMP] = ACTIONS(2723),
    [anon_sym_TILDE] = ACTIONS(2725),
    [aux_sym_prefix_op_token1] = ACTIONS(2723),
    [aux_sym_infix_op_token1] = ACTIONS(2725),
    [aux_sym_infix_op_token2] = ACTIONS(2723),
    [anon_sym_PIPE_PIPE] = ACTIONS(2723),
    [anon_sym_BANG_EQ] = ACTIONS(2723),
    [anon_sym_COLON_EQ] = ACTIONS(2725),
    [anon_sym_DOLLAR] = ACTIONS(2723),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2723),
    [sym_int] = ACTIONS(2723),
    [sym_xint] = ACTIONS(2725),
    [anon_sym_f] = ACTIONS(2723),
    [aux_sym_decimal_token1] = ACTIONS(2723),
    [aux_sym_float_token1] = ACTIONS(3153),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2725),
    [sym__newline] = ACTIONS(2725),
  },
  [965] = {
    [sym_type_arguments] = STATE(1272),
    [sym_long_identifier] = STATE(1184),
    [sym_block_comment] = STATE(965),
    [sym_compiler_directive_decl] = STATE(965),
    [sym_fsi_directive_decl] = STATE(965),
    [sym_preproc_line] = STATE(965),
    [aux_sym_compound_type_repeat1] = STATE(1115),
    [sym_identifier] = ACTIONS(3155),
    [anon_sym_EQ] = ACTIONS(2248),
    [anon_sym_COLON] = ACTIONS(2250),
    [anon_sym_return] = ACTIONS(2250),
    [anon_sym_do] = ACTIONS(2250),
    [anon_sym_let] = ACTIONS(2250),
    [anon_sym_let_BANG] = ACTIONS(2248),
    [anon_sym_LPAREN] = ACTIONS(2250),
    [anon_sym_COMMA] = ACTIONS(2248),
    [anon_sym_null] = ACTIONS(2250),
    [anon_sym_QMARK] = ACTIONS(2250),
    [anon_sym_COLON_QMARK] = ACTIONS(2250),
    [anon_sym_COLON_COLON] = ACTIONS(2248),
    [anon_sym_AMP] = ACTIONS(2250),
    [anon_sym_LBRACK] = ACTIONS(2250),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2248),
    [anon_sym_LBRACE] = ACTIONS(2250),
    [anon_sym_LT_AT] = ACTIONS(2250),
    [anon_sym_LT_AT_AT] = ACTIONS(2250),
    [anon_sym_DOT] = ACTIONS(2250),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2248),
    [anon_sym_new] = ACTIONS(2250),
    [anon_sym_return_BANG] = ACTIONS(2248),
    [anon_sym_yield] = ACTIONS(2250),
    [anon_sym_yield_BANG] = ACTIONS(2248),
    [anon_sym_lazy] = ACTIONS(2250),
    [anon_sym_assert] = ACTIONS(2250),
    [anon_sym_upcast] = ACTIONS(2250),
    [anon_sym_downcast] = ACTIONS(2250),
    [anon_sym_COLON_GT] = ACTIONS(2248),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2248),
    [anon_sym_for] = ACTIONS(2250),
    [anon_sym_while] = ACTIONS(2250),
    [anon_sym_if] = ACTIONS(2250),
    [anon_sym_fun] = ACTIONS(2250),
    [anon_sym_DASH_GT] = ACTIONS(3157),
    [anon_sym_try] = ACTIONS(2250),
    [anon_sym_match] = ACTIONS(2250),
    [anon_sym_match_BANG] = ACTIONS(2248),
    [anon_sym_function] = ACTIONS(2250),
    [anon_sym_LT_DASH] = ACTIONS(2250),
    [anon_sym_DOT_LBRACK] = ACTIONS(2248),
    [anon_sym_LT] = ACTIONS(2248),
    [anon_sym_use] = ACTIONS(2250),
    [anon_sym_use_BANG] = ACTIONS(2248),
    [anon_sym_do_BANG] = ACTIONS(2248),
    [anon_sym_begin] = ACTIONS(2250),
    [anon_sym_LPAREN2] = ACTIONS(2250),
    [anon_sym_STAR] = ACTIONS(3159),
    [anon_sym_LT2] = ACTIONS(3161),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3163),
    [anon_sym_or] = ACTIONS(2250),
    [aux_sym_char_token1] = ACTIONS(2248),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2250),
    [anon_sym_DQUOTE] = ACTIONS(2250),
    [anon_sym_AT_DQUOTE] = ACTIONS(2248),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2248),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2248),
    [sym_bool] = ACTIONS(2250),
    [sym_unit] = ACTIONS(2248),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2250),
    [sym_op_identifier] = ACTIONS(2250),
    [anon_sym_PLUS] = ACTIONS(2250),
    [anon_sym_DASH] = ACTIONS(2250),
    [anon_sym_PLUS_DOT] = ACTIONS(2250),
    [anon_sym_DASH_DOT] = ACTIONS(2250),
    [anon_sym_PERCENT] = ACTIONS(2250),
    [anon_sym_AMP_AMP] = ACTIONS(2250),
    [anon_sym_TILDE] = ACTIONS(2248),
    [aux_sym_prefix_op_token1] = ACTIONS(2250),
    [aux_sym_infix_op_token1] = ACTIONS(2248),
    [aux_sym_infix_op_token2] = ACTIONS(2250),
    [anon_sym_PIPE_PIPE] = ACTIONS(2250),
    [anon_sym_BANG_EQ] = ACTIONS(2250),
    [anon_sym_COLON_EQ] = ACTIONS(2248),
    [anon_sym_DOLLAR] = ACTIONS(2250),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2250),
    [sym_int] = ACTIONS(2250),
    [sym_xint] = ACTIONS(2248),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2248),
    [anon_sym_POUNDendif] = ACTIONS(2248),
    [anon_sym_POUNDelse] = ACTIONS(2248),
    [sym__newline] = ACTIONS(2248),
  },
  [966] = {
    [sym_block_comment] = STATE(966),
    [sym_compiler_directive_decl] = STATE(966),
    [sym_fsi_directive_decl] = STATE(966),
    [sym_preproc_line] = STATE(966),
    [aux_sym_rules_repeat1] = STATE(966),
    [sym_identifier] = ACTIONS(2713),
    [anon_sym_EQ] = ACTIONS(2715),
    [anon_sym_GT_RBRACK] = ACTIONS(2715),
    [anon_sym_COLON] = ACTIONS(2713),
    [anon_sym_return] = ACTIONS(2713),
    [anon_sym_do] = ACTIONS(2713),
    [anon_sym_let] = ACTIONS(2713),
    [anon_sym_let_BANG] = ACTIONS(2715),
    [anon_sym_LPAREN] = ACTIONS(2713),
    [anon_sym_COMMA] = ACTIONS(2715),
    [anon_sym_null] = ACTIONS(2713),
    [anon_sym_QMARK] = ACTIONS(2713),
    [anon_sym_COLON_QMARK] = ACTIONS(2713),
    [anon_sym_COLON_COLON] = ACTIONS(2715),
    [anon_sym_PIPE] = ACTIONS(3165),
    [anon_sym_AMP] = ACTIONS(2713),
    [anon_sym_LBRACK] = ACTIONS(2713),
    [anon_sym_RBRACK] = ACTIONS(2715),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2715),
    [anon_sym_LBRACE] = ACTIONS(2713),
    [anon_sym_RBRACE] = ACTIONS(2715),
    [anon_sym_LT_AT] = ACTIONS(2713),
    [anon_sym_LT_AT_AT] = ACTIONS(2713),
    [anon_sym_DOT] = ACTIONS(2713),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2715),
    [anon_sym_new] = ACTIONS(2713),
    [anon_sym_with] = ACTIONS(2713),
    [anon_sym_return_BANG] = ACTIONS(2715),
    [anon_sym_yield] = ACTIONS(2713),
    [anon_sym_yield_BANG] = ACTIONS(2715),
    [anon_sym_lazy] = ACTIONS(2713),
    [anon_sym_assert] = ACTIONS(2713),
    [anon_sym_upcast] = ACTIONS(2713),
    [anon_sym_downcast] = ACTIONS(2713),
    [anon_sym_COLON_GT] = ACTIONS(2715),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2715),
    [anon_sym_for] = ACTIONS(2713),
    [anon_sym_to] = ACTIONS(2713),
    [anon_sym_downto] = ACTIONS(2713),
    [anon_sym_while] = ACTIONS(2713),
    [anon_sym_if] = ACTIONS(2713),
    [anon_sym_fun] = ACTIONS(2713),
    [anon_sym_try] = ACTIONS(2713),
    [anon_sym_match] = ACTIONS(2713),
    [anon_sym_match_BANG] = ACTIONS(2715),
    [anon_sym_function] = ACTIONS(2713),
    [anon_sym_LT_DASH] = ACTIONS(2713),
    [anon_sym_DOT_LBRACK] = ACTIONS(2715),
    [anon_sym_LT] = ACTIONS(2715),
    [anon_sym_use] = ACTIONS(2713),
    [anon_sym_use_BANG] = ACTIONS(2715),
    [anon_sym_do_BANG] = ACTIONS(2715),
    [anon_sym_begin] = ACTIONS(2713),
    [anon_sym_LPAREN2] = ACTIONS(2713),
    [anon_sym_DOT_DOT2] = ACTIONS(2715),
    [anon_sym_or] = ACTIONS(2713),
    [aux_sym_char_token1] = ACTIONS(2715),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2713),
    [anon_sym_DQUOTE] = ACTIONS(2713),
    [anon_sym_AT_DQUOTE] = ACTIONS(2715),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2715),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2715),
    [sym_bool] = ACTIONS(2713),
    [sym_unit] = ACTIONS(2715),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2713),
    [sym_op_identifier] = ACTIONS(2713),
    [anon_sym_PLUS] = ACTIONS(2713),
    [anon_sym_DASH] = ACTIONS(2713),
    [anon_sym_PLUS_DOT] = ACTIONS(2713),
    [anon_sym_DASH_DOT] = ACTIONS(2713),
    [anon_sym_PERCENT] = ACTIONS(2713),
    [anon_sym_AMP_AMP] = ACTIONS(2713),
    [anon_sym_TILDE] = ACTIONS(2715),
    [aux_sym_prefix_op_token1] = ACTIONS(2713),
    [aux_sym_infix_op_token1] = ACTIONS(2715),
    [aux_sym_infix_op_token2] = ACTIONS(2713),
    [anon_sym_PIPE_PIPE] = ACTIONS(2713),
    [anon_sym_BANG_EQ] = ACTIONS(2713),
    [anon_sym_COLON_EQ] = ACTIONS(2715),
    [anon_sym_DOLLAR] = ACTIONS(2713),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2713),
    [sym_int] = ACTIONS(2713),
    [sym_xint] = ACTIONS(2715),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2715),
    [sym__newline] = ACTIONS(3168),
  },
  [967] = {
    [sym_block_comment] = STATE(967),
    [sym_compiler_directive_decl] = STATE(967),
    [sym_fsi_directive_decl] = STATE(967),
    [sym_preproc_line] = STATE(967),
    [sym_identifier] = ACTIONS(2819),
    [anon_sym_EQ] = ACTIONS(2821),
    [anon_sym_GT_RBRACK] = ACTIONS(2821),
    [anon_sym_COLON] = ACTIONS(2819),
    [anon_sym_return] = ACTIONS(2819),
    [anon_sym_do] = ACTIONS(2819),
    [anon_sym_let] = ACTIONS(2819),
    [anon_sym_let_BANG] = ACTIONS(2821),
    [anon_sym_LPAREN] = ACTIONS(2819),
    [anon_sym_COMMA] = ACTIONS(2821),
    [anon_sym_null] = ACTIONS(2819),
    [anon_sym_QMARK] = ACTIONS(2819),
    [anon_sym_COLON_QMARK] = ACTIONS(2819),
    [anon_sym_COLON_COLON] = ACTIONS(2821),
    [anon_sym_AMP] = ACTIONS(2819),
    [anon_sym_LBRACK] = ACTIONS(2819),
    [anon_sym_RBRACK] = ACTIONS(2821),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2821),
    [anon_sym_LBRACE] = ACTIONS(2819),
    [anon_sym_RBRACE] = ACTIONS(2821),
    [anon_sym_LT_AT] = ACTIONS(2819),
    [anon_sym_LT_AT_AT] = ACTIONS(2819),
    [anon_sym_DOT] = ACTIONS(2819),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2821),
    [anon_sym_new] = ACTIONS(2819),
    [anon_sym_with] = ACTIONS(2819),
    [anon_sym_return_BANG] = ACTIONS(2821),
    [anon_sym_yield] = ACTIONS(2819),
    [anon_sym_yield_BANG] = ACTIONS(2821),
    [anon_sym_lazy] = ACTIONS(2819),
    [anon_sym_assert] = ACTIONS(2819),
    [anon_sym_upcast] = ACTIONS(2819),
    [anon_sym_downcast] = ACTIONS(2819),
    [anon_sym_COLON_GT] = ACTIONS(2821),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2821),
    [anon_sym_for] = ACTIONS(2819),
    [anon_sym_to] = ACTIONS(2819),
    [anon_sym_downto] = ACTIONS(2819),
    [anon_sym_while] = ACTIONS(2819),
    [anon_sym_if] = ACTIONS(2819),
    [anon_sym_fun] = ACTIONS(2819),
    [anon_sym_try] = ACTIONS(2819),
    [anon_sym_match] = ACTIONS(2819),
    [anon_sym_match_BANG] = ACTIONS(2821),
    [anon_sym_function] = ACTIONS(2819),
    [anon_sym_LT_DASH] = ACTIONS(2819),
    [anon_sym_DOT_LBRACK] = ACTIONS(2821),
    [anon_sym_LT] = ACTIONS(2821),
    [anon_sym_use] = ACTIONS(2819),
    [anon_sym_use_BANG] = ACTIONS(2821),
    [anon_sym_do_BANG] = ACTIONS(2821),
    [anon_sym_begin] = ACTIONS(2819),
    [anon_sym_LPAREN2] = ACTIONS(2819),
    [anon_sym_DOT_DOT2] = ACTIONS(2821),
    [anon_sym_or] = ACTIONS(2819),
    [aux_sym_char_token1] = ACTIONS(2821),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2819),
    [anon_sym_DQUOTE] = ACTIONS(2819),
    [anon_sym_AT_DQUOTE] = ACTIONS(2821),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2821),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2821),
    [sym_bool] = ACTIONS(2819),
    [sym_unit] = ACTIONS(2821),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2819),
    [sym_op_identifier] = ACTIONS(2819),
    [anon_sym_PLUS] = ACTIONS(2819),
    [anon_sym_DASH] = ACTIONS(2819),
    [anon_sym_PLUS_DOT] = ACTIONS(2819),
    [anon_sym_DASH_DOT] = ACTIONS(2819),
    [anon_sym_PERCENT] = ACTIONS(2819),
    [anon_sym_AMP_AMP] = ACTIONS(2819),
    [anon_sym_TILDE] = ACTIONS(2821),
    [aux_sym_prefix_op_token1] = ACTIONS(2819),
    [aux_sym_infix_op_token1] = ACTIONS(2821),
    [aux_sym_infix_op_token2] = ACTIONS(2819),
    [anon_sym_PIPE_PIPE] = ACTIONS(2819),
    [anon_sym_BANG_EQ] = ACTIONS(2819),
    [anon_sym_COLON_EQ] = ACTIONS(2821),
    [anon_sym_DOLLAR] = ACTIONS(2819),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2819),
    [sym_int] = ACTIONS(3171),
    [sym_xint] = ACTIONS(2821),
    [anon_sym_f] = ACTIONS(2819),
    [aux_sym_decimal_token1] = ACTIONS(2819),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2821),
    [sym__newline] = ACTIONS(2821),
  },
  [968] = {
    [sym_type_arguments] = STATE(1277),
    [sym_long_identifier] = STATE(1255),
    [sym_block_comment] = STATE(968),
    [sym_compiler_directive_decl] = STATE(968),
    [sym_fsi_directive_decl] = STATE(968),
    [sym_preproc_line] = STATE(968),
    [aux_sym_compound_type_repeat1] = STATE(1121),
    [sym_identifier] = ACTIONS(3173),
    [anon_sym_EQ] = ACTIONS(2228),
    [anon_sym_COLON] = ACTIONS(2230),
    [anon_sym_return] = ACTIONS(2230),
    [anon_sym_do] = ACTIONS(2230),
    [anon_sym_and] = ACTIONS(2230),
    [anon_sym_let] = ACTIONS(2230),
    [anon_sym_let_BANG] = ACTIONS(2228),
    [anon_sym_LPAREN] = ACTIONS(2230),
    [anon_sym_COMMA] = ACTIONS(2228),
    [anon_sym_null] = ACTIONS(2230),
    [anon_sym_QMARK] = ACTIONS(2230),
    [anon_sym_COLON_QMARK] = ACTIONS(2230),
    [anon_sym_COLON_COLON] = ACTIONS(2228),
    [anon_sym_AMP] = ACTIONS(2230),
    [anon_sym_LBRACK] = ACTIONS(2230),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2228),
    [anon_sym_LBRACE] = ACTIONS(2230),
    [anon_sym_LT_AT] = ACTIONS(2230),
    [anon_sym_LT_AT_AT] = ACTIONS(2230),
    [anon_sym_DOT] = ACTIONS(2230),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2228),
    [anon_sym_new] = ACTIONS(2230),
    [anon_sym_return_BANG] = ACTIONS(2228),
    [anon_sym_yield] = ACTIONS(2230),
    [anon_sym_yield_BANG] = ACTIONS(2228),
    [anon_sym_lazy] = ACTIONS(2230),
    [anon_sym_assert] = ACTIONS(2230),
    [anon_sym_upcast] = ACTIONS(2230),
    [anon_sym_downcast] = ACTIONS(2230),
    [anon_sym_COLON_GT] = ACTIONS(2228),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2228),
    [anon_sym_for] = ACTIONS(2230),
    [anon_sym_while] = ACTIONS(2230),
    [anon_sym_if] = ACTIONS(2230),
    [anon_sym_fun] = ACTIONS(2230),
    [anon_sym_DASH_GT] = ACTIONS(3175),
    [anon_sym_try] = ACTIONS(2230),
    [anon_sym_match] = ACTIONS(2230),
    [anon_sym_match_BANG] = ACTIONS(2228),
    [anon_sym_function] = ACTIONS(2230),
    [anon_sym_LT_DASH] = ACTIONS(2230),
    [anon_sym_DOT_LBRACK] = ACTIONS(2228),
    [anon_sym_LT] = ACTIONS(2228),
    [anon_sym_use] = ACTIONS(2230),
    [anon_sym_use_BANG] = ACTIONS(2228),
    [anon_sym_do_BANG] = ACTIONS(2228),
    [anon_sym_begin] = ACTIONS(2230),
    [anon_sym_LPAREN2] = ACTIONS(2230),
    [anon_sym_STAR] = ACTIONS(3177),
    [anon_sym_LT2] = ACTIONS(3179),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3181),
    [anon_sym_or] = ACTIONS(2230),
    [aux_sym_char_token1] = ACTIONS(2228),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2230),
    [anon_sym_DQUOTE] = ACTIONS(2230),
    [anon_sym_AT_DQUOTE] = ACTIONS(2228),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2228),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2228),
    [sym_bool] = ACTIONS(2230),
    [sym_unit] = ACTIONS(2228),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2230),
    [sym_op_identifier] = ACTIONS(2230),
    [anon_sym_PLUS] = ACTIONS(2230),
    [anon_sym_DASH] = ACTIONS(2230),
    [anon_sym_PLUS_DOT] = ACTIONS(2230),
    [anon_sym_DASH_DOT] = ACTIONS(2230),
    [anon_sym_PERCENT] = ACTIONS(2230),
    [anon_sym_AMP_AMP] = ACTIONS(2230),
    [anon_sym_TILDE] = ACTIONS(2228),
    [aux_sym_prefix_op_token1] = ACTIONS(2230),
    [aux_sym_infix_op_token1] = ACTIONS(2228),
    [aux_sym_infix_op_token2] = ACTIONS(2230),
    [anon_sym_PIPE_PIPE] = ACTIONS(2230),
    [anon_sym_BANG_EQ] = ACTIONS(2230),
    [anon_sym_COLON_EQ] = ACTIONS(2228),
    [anon_sym_DOLLAR] = ACTIONS(2230),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2230),
    [sym_int] = ACTIONS(2230),
    [sym_xint] = ACTIONS(2228),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2228),
    [sym__newline] = ACTIONS(2228),
    [sym__dedent] = ACTIONS(2228),
  },
  [969] = {
    [sym_type_arguments] = STATE(1277),
    [sym_long_identifier] = STATE(1255),
    [sym_block_comment] = STATE(969),
    [sym_compiler_directive_decl] = STATE(969),
    [sym_fsi_directive_decl] = STATE(969),
    [sym_preproc_line] = STATE(969),
    [aux_sym_compound_type_repeat1] = STATE(1121),
    [sym_identifier] = ACTIONS(3173),
    [anon_sym_EQ] = ACTIONS(2248),
    [anon_sym_COLON] = ACTIONS(2250),
    [anon_sym_return] = ACTIONS(2250),
    [anon_sym_do] = ACTIONS(2250),
    [anon_sym_and] = ACTIONS(2250),
    [anon_sym_let] = ACTIONS(2250),
    [anon_sym_let_BANG] = ACTIONS(2248),
    [anon_sym_LPAREN] = ACTIONS(2250),
    [anon_sym_COMMA] = ACTIONS(2248),
    [anon_sym_null] = ACTIONS(2250),
    [anon_sym_QMARK] = ACTIONS(2250),
    [anon_sym_COLON_QMARK] = ACTIONS(2250),
    [anon_sym_COLON_COLON] = ACTIONS(2248),
    [anon_sym_AMP] = ACTIONS(2250),
    [anon_sym_LBRACK] = ACTIONS(2250),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2248),
    [anon_sym_LBRACE] = ACTIONS(2250),
    [anon_sym_LT_AT] = ACTIONS(2250),
    [anon_sym_LT_AT_AT] = ACTIONS(2250),
    [anon_sym_DOT] = ACTIONS(2250),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2248),
    [anon_sym_new] = ACTIONS(2250),
    [anon_sym_return_BANG] = ACTIONS(2248),
    [anon_sym_yield] = ACTIONS(2250),
    [anon_sym_yield_BANG] = ACTIONS(2248),
    [anon_sym_lazy] = ACTIONS(2250),
    [anon_sym_assert] = ACTIONS(2250),
    [anon_sym_upcast] = ACTIONS(2250),
    [anon_sym_downcast] = ACTIONS(2250),
    [anon_sym_COLON_GT] = ACTIONS(2248),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2248),
    [anon_sym_for] = ACTIONS(2250),
    [anon_sym_while] = ACTIONS(2250),
    [anon_sym_if] = ACTIONS(2250),
    [anon_sym_fun] = ACTIONS(2250),
    [anon_sym_DASH_GT] = ACTIONS(3175),
    [anon_sym_try] = ACTIONS(2250),
    [anon_sym_match] = ACTIONS(2250),
    [anon_sym_match_BANG] = ACTIONS(2248),
    [anon_sym_function] = ACTIONS(2250),
    [anon_sym_LT_DASH] = ACTIONS(2250),
    [anon_sym_DOT_LBRACK] = ACTIONS(2248),
    [anon_sym_LT] = ACTIONS(2248),
    [anon_sym_use] = ACTIONS(2250),
    [anon_sym_use_BANG] = ACTIONS(2248),
    [anon_sym_do_BANG] = ACTIONS(2248),
    [anon_sym_begin] = ACTIONS(2250),
    [anon_sym_LPAREN2] = ACTIONS(2250),
    [anon_sym_STAR] = ACTIONS(3177),
    [anon_sym_LT2] = ACTIONS(3179),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3181),
    [anon_sym_or] = ACTIONS(2250),
    [aux_sym_char_token1] = ACTIONS(2248),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2250),
    [anon_sym_DQUOTE] = ACTIONS(2250),
    [anon_sym_AT_DQUOTE] = ACTIONS(2248),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2248),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2248),
    [sym_bool] = ACTIONS(2250),
    [sym_unit] = ACTIONS(2248),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2250),
    [sym_op_identifier] = ACTIONS(2250),
    [anon_sym_PLUS] = ACTIONS(2250),
    [anon_sym_DASH] = ACTIONS(2250),
    [anon_sym_PLUS_DOT] = ACTIONS(2250),
    [anon_sym_DASH_DOT] = ACTIONS(2250),
    [anon_sym_PERCENT] = ACTIONS(2250),
    [anon_sym_AMP_AMP] = ACTIONS(2250),
    [anon_sym_TILDE] = ACTIONS(2248),
    [aux_sym_prefix_op_token1] = ACTIONS(2250),
    [aux_sym_infix_op_token1] = ACTIONS(2248),
    [aux_sym_infix_op_token2] = ACTIONS(2250),
    [anon_sym_PIPE_PIPE] = ACTIONS(2250),
    [anon_sym_BANG_EQ] = ACTIONS(2250),
    [anon_sym_COLON_EQ] = ACTIONS(2248),
    [anon_sym_DOLLAR] = ACTIONS(2250),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2250),
    [sym_int] = ACTIONS(2250),
    [sym_xint] = ACTIONS(2248),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2248),
    [sym__newline] = ACTIONS(2248),
    [sym__dedent] = ACTIONS(2248),
  },
  [970] = {
    [sym_type_arguments] = STATE(1277),
    [sym_long_identifier] = STATE(1255),
    [sym_block_comment] = STATE(970),
    [sym_compiler_directive_decl] = STATE(970),
    [sym_fsi_directive_decl] = STATE(970),
    [sym_preproc_line] = STATE(970),
    [aux_sym_compound_type_repeat1] = STATE(1121),
    [sym_identifier] = ACTIONS(3173),
    [anon_sym_EQ] = ACTIONS(2244),
    [anon_sym_COLON] = ACTIONS(2246),
    [anon_sym_return] = ACTIONS(2246),
    [anon_sym_do] = ACTIONS(2246),
    [anon_sym_and] = ACTIONS(2246),
    [anon_sym_let] = ACTIONS(2246),
    [anon_sym_let_BANG] = ACTIONS(2244),
    [anon_sym_LPAREN] = ACTIONS(2246),
    [anon_sym_COMMA] = ACTIONS(2244),
    [anon_sym_null] = ACTIONS(2246),
    [anon_sym_QMARK] = ACTIONS(2246),
    [anon_sym_COLON_QMARK] = ACTIONS(2246),
    [anon_sym_COLON_COLON] = ACTIONS(2244),
    [anon_sym_AMP] = ACTIONS(2246),
    [anon_sym_LBRACK] = ACTIONS(2246),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2244),
    [anon_sym_LBRACE] = ACTIONS(2246),
    [anon_sym_LT_AT] = ACTIONS(2246),
    [anon_sym_LT_AT_AT] = ACTIONS(2246),
    [anon_sym_DOT] = ACTIONS(2246),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2244),
    [anon_sym_new] = ACTIONS(2246),
    [anon_sym_return_BANG] = ACTIONS(2244),
    [anon_sym_yield] = ACTIONS(2246),
    [anon_sym_yield_BANG] = ACTIONS(2244),
    [anon_sym_lazy] = ACTIONS(2246),
    [anon_sym_assert] = ACTIONS(2246),
    [anon_sym_upcast] = ACTIONS(2246),
    [anon_sym_downcast] = ACTIONS(2246),
    [anon_sym_COLON_GT] = ACTIONS(2244),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2244),
    [anon_sym_for] = ACTIONS(2246),
    [anon_sym_while] = ACTIONS(2246),
    [anon_sym_if] = ACTIONS(2246),
    [anon_sym_fun] = ACTIONS(2246),
    [anon_sym_DASH_GT] = ACTIONS(3175),
    [anon_sym_try] = ACTIONS(2246),
    [anon_sym_match] = ACTIONS(2246),
    [anon_sym_match_BANG] = ACTIONS(2244),
    [anon_sym_function] = ACTIONS(2246),
    [anon_sym_LT_DASH] = ACTIONS(2246),
    [anon_sym_DOT_LBRACK] = ACTIONS(2244),
    [anon_sym_LT] = ACTIONS(2244),
    [anon_sym_use] = ACTIONS(2246),
    [anon_sym_use_BANG] = ACTIONS(2244),
    [anon_sym_do_BANG] = ACTIONS(2244),
    [anon_sym_begin] = ACTIONS(2246),
    [anon_sym_LPAREN2] = ACTIONS(2246),
    [anon_sym_STAR] = ACTIONS(3177),
    [anon_sym_LT2] = ACTIONS(3179),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3181),
    [anon_sym_or] = ACTIONS(2246),
    [aux_sym_char_token1] = ACTIONS(2244),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2246),
    [anon_sym_DQUOTE] = ACTIONS(2246),
    [anon_sym_AT_DQUOTE] = ACTIONS(2244),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2244),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2244),
    [sym_bool] = ACTIONS(2246),
    [sym_unit] = ACTIONS(2244),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2246),
    [sym_op_identifier] = ACTIONS(2246),
    [anon_sym_PLUS] = ACTIONS(2246),
    [anon_sym_DASH] = ACTIONS(2246),
    [anon_sym_PLUS_DOT] = ACTIONS(2246),
    [anon_sym_DASH_DOT] = ACTIONS(2246),
    [anon_sym_PERCENT] = ACTIONS(2246),
    [anon_sym_AMP_AMP] = ACTIONS(2246),
    [anon_sym_TILDE] = ACTIONS(2244),
    [aux_sym_prefix_op_token1] = ACTIONS(2246),
    [aux_sym_infix_op_token1] = ACTIONS(2244),
    [aux_sym_infix_op_token2] = ACTIONS(2246),
    [anon_sym_PIPE_PIPE] = ACTIONS(2246),
    [anon_sym_BANG_EQ] = ACTIONS(2246),
    [anon_sym_COLON_EQ] = ACTIONS(2244),
    [anon_sym_DOLLAR] = ACTIONS(2246),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2246),
    [sym_int] = ACTIONS(2246),
    [sym_xint] = ACTIONS(2244),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2244),
    [sym__newline] = ACTIONS(2244),
    [sym__dedent] = ACTIONS(2244),
  },
  [971] = {
    [sym_block_comment] = STATE(971),
    [sym_compiler_directive_decl] = STATE(971),
    [sym_fsi_directive_decl] = STATE(971),
    [sym_preproc_line] = STATE(971),
    [sym_identifier] = ACTIONS(2685),
    [anon_sym_EQ] = ACTIONS(2687),
    [anon_sym_GT_RBRACK] = ACTIONS(2687),
    [anon_sym_COLON] = ACTIONS(2685),
    [anon_sym_return] = ACTIONS(2685),
    [anon_sym_do] = ACTIONS(2685),
    [anon_sym_let] = ACTIONS(2685),
    [anon_sym_let_BANG] = ACTIONS(2687),
    [anon_sym_LPAREN] = ACTIONS(2685),
    [anon_sym_COMMA] = ACTIONS(2687),
    [anon_sym_null] = ACTIONS(2685),
    [anon_sym_QMARK] = ACTIONS(2685),
    [anon_sym_COLON_QMARK] = ACTIONS(2685),
    [anon_sym_COLON_COLON] = ACTIONS(2687),
    [anon_sym_AMP] = ACTIONS(2685),
    [anon_sym_LBRACK] = ACTIONS(2685),
    [anon_sym_RBRACK] = ACTIONS(2687),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2687),
    [anon_sym_LBRACE] = ACTIONS(2685),
    [anon_sym_RBRACE] = ACTIONS(2687),
    [anon_sym_LT_AT] = ACTIONS(2685),
    [anon_sym_LT_AT_AT] = ACTIONS(2685),
    [anon_sym_DOT] = ACTIONS(2685),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2687),
    [anon_sym_new] = ACTIONS(2685),
    [anon_sym_with] = ACTIONS(2685),
    [anon_sym_return_BANG] = ACTIONS(2687),
    [anon_sym_yield] = ACTIONS(2685),
    [anon_sym_yield_BANG] = ACTIONS(2687),
    [anon_sym_lazy] = ACTIONS(2685),
    [anon_sym_assert] = ACTIONS(2685),
    [anon_sym_upcast] = ACTIONS(2685),
    [anon_sym_downcast] = ACTIONS(2685),
    [anon_sym_COLON_GT] = ACTIONS(2687),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2687),
    [anon_sym_for] = ACTIONS(2685),
    [anon_sym_to] = ACTIONS(2685),
    [anon_sym_downto] = ACTIONS(2685),
    [anon_sym_done] = ACTIONS(2685),
    [anon_sym_while] = ACTIONS(2685),
    [anon_sym_if] = ACTIONS(2685),
    [anon_sym_fun] = ACTIONS(2685),
    [anon_sym_try] = ACTIONS(2685),
    [anon_sym_match] = ACTIONS(2685),
    [anon_sym_match_BANG] = ACTIONS(2687),
    [anon_sym_function] = ACTIONS(2685),
    [anon_sym_LT_DASH] = ACTIONS(2685),
    [anon_sym_DOT_LBRACK] = ACTIONS(2687),
    [anon_sym_LT] = ACTIONS(2687),
    [anon_sym_use] = ACTIONS(2685),
    [anon_sym_use_BANG] = ACTIONS(2687),
    [anon_sym_do_BANG] = ACTIONS(2687),
    [anon_sym_DOT_DOT] = ACTIONS(2685),
    [anon_sym_begin] = ACTIONS(2685),
    [anon_sym_LPAREN2] = ACTIONS(2685),
    [anon_sym_DOT_DOT2] = ACTIONS(2687),
    [anon_sym_or] = ACTIONS(2685),
    [aux_sym_char_token1] = ACTIONS(2687),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2685),
    [anon_sym_DQUOTE] = ACTIONS(2685),
    [anon_sym_AT_DQUOTE] = ACTIONS(2687),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2687),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2687),
    [sym_bool] = ACTIONS(2685),
    [sym_unit] = ACTIONS(2687),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2685),
    [sym_op_identifier] = ACTIONS(2685),
    [anon_sym_PLUS] = ACTIONS(2685),
    [anon_sym_DASH] = ACTIONS(2685),
    [anon_sym_PLUS_DOT] = ACTIONS(2685),
    [anon_sym_DASH_DOT] = ACTIONS(2685),
    [anon_sym_PERCENT] = ACTIONS(2685),
    [anon_sym_AMP_AMP] = ACTIONS(2685),
    [anon_sym_TILDE] = ACTIONS(2687),
    [aux_sym_prefix_op_token1] = ACTIONS(2685),
    [aux_sym_infix_op_token1] = ACTIONS(2687),
    [aux_sym_infix_op_token2] = ACTIONS(2685),
    [anon_sym_PIPE_PIPE] = ACTIONS(2685),
    [anon_sym_BANG_EQ] = ACTIONS(2685),
    [anon_sym_COLON_EQ] = ACTIONS(2687),
    [anon_sym_DOLLAR] = ACTIONS(2685),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2685),
    [sym_int] = ACTIONS(2685),
    [sym_xint] = ACTIONS(2687),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2687),
    [sym__newline] = ACTIONS(2687),
  },
  [972] = {
    [sym_block_comment] = STATE(972),
    [sym_compiler_directive_decl] = STATE(972),
    [sym_fsi_directive_decl] = STATE(972),
    [sym_preproc_line] = STATE(972),
    [sym_identifier] = ACTIONS(2685),
    [anon_sym_EQ] = ACTIONS(2687),
    [anon_sym_GT_RBRACK] = ACTIONS(2687),
    [anon_sym_COLON] = ACTIONS(2685),
    [anon_sym_return] = ACTIONS(2685),
    [anon_sym_do] = ACTIONS(2685),
    [anon_sym_let] = ACTIONS(2685),
    [anon_sym_let_BANG] = ACTIONS(2687),
    [anon_sym_LPAREN] = ACTIONS(2685),
    [anon_sym_COMMA] = ACTIONS(2687),
    [anon_sym_null] = ACTIONS(2685),
    [anon_sym_QMARK] = ACTIONS(2685),
    [anon_sym_COLON_QMARK] = ACTIONS(2685),
    [anon_sym_COLON_COLON] = ACTIONS(2687),
    [anon_sym_AMP] = ACTIONS(2685),
    [anon_sym_LBRACK] = ACTIONS(2685),
    [anon_sym_RBRACK] = ACTIONS(2687),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2687),
    [anon_sym_LBRACE] = ACTIONS(2685),
    [anon_sym_RBRACE] = ACTIONS(2687),
    [anon_sym_LT_AT] = ACTIONS(2685),
    [anon_sym_LT_AT_AT] = ACTIONS(2685),
    [anon_sym_DOT] = ACTIONS(2685),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2687),
    [anon_sym_new] = ACTIONS(2685),
    [anon_sym_with] = ACTIONS(2685),
    [anon_sym_return_BANG] = ACTIONS(2687),
    [anon_sym_yield] = ACTIONS(2685),
    [anon_sym_yield_BANG] = ACTIONS(2687),
    [anon_sym_lazy] = ACTIONS(2685),
    [anon_sym_assert] = ACTIONS(2685),
    [anon_sym_upcast] = ACTIONS(2685),
    [anon_sym_downcast] = ACTIONS(2685),
    [anon_sym_COLON_GT] = ACTIONS(2687),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2687),
    [anon_sym_for] = ACTIONS(2685),
    [anon_sym_to] = ACTIONS(2685),
    [anon_sym_downto] = ACTIONS(2685),
    [anon_sym_while] = ACTIONS(2685),
    [anon_sym_else] = ACTIONS(2685),
    [anon_sym_elif] = ACTIONS(2685),
    [anon_sym_if] = ACTIONS(2685),
    [anon_sym_fun] = ACTIONS(2685),
    [anon_sym_try] = ACTIONS(2685),
    [anon_sym_match] = ACTIONS(2685),
    [anon_sym_match_BANG] = ACTIONS(2687),
    [anon_sym_function] = ACTIONS(2685),
    [anon_sym_LT_DASH] = ACTIONS(2685),
    [anon_sym_DOT_LBRACK] = ACTIONS(2687),
    [anon_sym_LT] = ACTIONS(2687),
    [anon_sym_use] = ACTIONS(2685),
    [anon_sym_use_BANG] = ACTIONS(2687),
    [anon_sym_do_BANG] = ACTIONS(2687),
    [anon_sym_begin] = ACTIONS(2685),
    [anon_sym_LPAREN2] = ACTIONS(2685),
    [anon_sym_DOT_DOT2] = ACTIONS(2687),
    [anon_sym_or] = ACTIONS(2685),
    [aux_sym_char_token1] = ACTIONS(2687),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2685),
    [anon_sym_DQUOTE] = ACTIONS(2685),
    [anon_sym_AT_DQUOTE] = ACTIONS(2687),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2687),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2687),
    [sym_bool] = ACTIONS(2685),
    [sym_unit] = ACTIONS(2687),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2685),
    [sym_op_identifier] = ACTIONS(2685),
    [anon_sym_PLUS] = ACTIONS(2685),
    [anon_sym_DASH] = ACTIONS(2685),
    [anon_sym_PLUS_DOT] = ACTIONS(2685),
    [anon_sym_DASH_DOT] = ACTIONS(2685),
    [anon_sym_PERCENT] = ACTIONS(2685),
    [anon_sym_AMP_AMP] = ACTIONS(2685),
    [anon_sym_TILDE] = ACTIONS(2687),
    [aux_sym_prefix_op_token1] = ACTIONS(2685),
    [aux_sym_infix_op_token1] = ACTIONS(2687),
    [aux_sym_infix_op_token2] = ACTIONS(2685),
    [anon_sym_PIPE_PIPE] = ACTIONS(2685),
    [anon_sym_BANG_EQ] = ACTIONS(2685),
    [anon_sym_COLON_EQ] = ACTIONS(2687),
    [anon_sym_DOLLAR] = ACTIONS(2685),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2685),
    [sym_int] = ACTIONS(2685),
    [sym_xint] = ACTIONS(2687),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2687),
    [sym__newline] = ACTIONS(2687),
  },
  [973] = {
    [sym_type_arguments] = STATE(1272),
    [sym_long_identifier] = STATE(1184),
    [sym_block_comment] = STATE(973),
    [sym_compiler_directive_decl] = STATE(973),
    [sym_fsi_directive_decl] = STATE(973),
    [sym_preproc_line] = STATE(973),
    [aux_sym_compound_type_repeat1] = STATE(1115),
    [sym_identifier] = ACTIONS(2252),
    [anon_sym_EQ] = ACTIONS(2254),
    [anon_sym_COLON] = ACTIONS(2252),
    [anon_sym_return] = ACTIONS(2252),
    [anon_sym_do] = ACTIONS(2252),
    [anon_sym_let] = ACTIONS(2252),
    [anon_sym_let_BANG] = ACTIONS(2254),
    [anon_sym_LPAREN] = ACTIONS(2252),
    [anon_sym_COMMA] = ACTIONS(2254),
    [anon_sym_null] = ACTIONS(2252),
    [anon_sym_QMARK] = ACTIONS(2252),
    [anon_sym_COLON_QMARK] = ACTIONS(2252),
    [anon_sym_COLON_COLON] = ACTIONS(2254),
    [anon_sym_AMP] = ACTIONS(2252),
    [anon_sym_LBRACK] = ACTIONS(2252),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2254),
    [anon_sym_LBRACE] = ACTIONS(2252),
    [anon_sym_LT_AT] = ACTIONS(2252),
    [anon_sym_LT_AT_AT] = ACTIONS(2252),
    [anon_sym_DOT] = ACTIONS(2252),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2254),
    [anon_sym_new] = ACTIONS(2252),
    [anon_sym_return_BANG] = ACTIONS(2254),
    [anon_sym_yield] = ACTIONS(2252),
    [anon_sym_yield_BANG] = ACTIONS(2254),
    [anon_sym_lazy] = ACTIONS(2252),
    [anon_sym_assert] = ACTIONS(2252),
    [anon_sym_upcast] = ACTIONS(2252),
    [anon_sym_downcast] = ACTIONS(2252),
    [anon_sym_COLON_GT] = ACTIONS(2254),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2254),
    [anon_sym_for] = ACTIONS(2252),
    [anon_sym_while] = ACTIONS(2252),
    [anon_sym_if] = ACTIONS(2252),
    [anon_sym_fun] = ACTIONS(2252),
    [anon_sym_DASH_GT] = ACTIONS(3157),
    [anon_sym_try] = ACTIONS(2252),
    [anon_sym_match] = ACTIONS(2252),
    [anon_sym_match_BANG] = ACTIONS(2254),
    [anon_sym_function] = ACTIONS(2252),
    [anon_sym_LT_DASH] = ACTIONS(2252),
    [anon_sym_DOT_LBRACK] = ACTIONS(2254),
    [anon_sym_LT] = ACTIONS(2254),
    [anon_sym_use] = ACTIONS(2252),
    [anon_sym_use_BANG] = ACTIONS(2254),
    [anon_sym_do_BANG] = ACTIONS(2254),
    [anon_sym_begin] = ACTIONS(2252),
    [anon_sym_LPAREN2] = ACTIONS(2252),
    [anon_sym_STAR] = ACTIONS(3159),
    [anon_sym_LT2] = ACTIONS(3161),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3163),
    [anon_sym_or] = ACTIONS(2252),
    [aux_sym_char_token1] = ACTIONS(2254),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2252),
    [anon_sym_DQUOTE] = ACTIONS(2252),
    [anon_sym_AT_DQUOTE] = ACTIONS(2254),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2254),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2254),
    [sym_bool] = ACTIONS(2252),
    [sym_unit] = ACTIONS(2254),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2252),
    [sym_op_identifier] = ACTIONS(2252),
    [anon_sym_PLUS] = ACTIONS(2252),
    [anon_sym_DASH] = ACTIONS(2252),
    [anon_sym_PLUS_DOT] = ACTIONS(2252),
    [anon_sym_DASH_DOT] = ACTIONS(2252),
    [anon_sym_PERCENT] = ACTIONS(2252),
    [anon_sym_AMP_AMP] = ACTIONS(2252),
    [anon_sym_TILDE] = ACTIONS(2254),
    [aux_sym_prefix_op_token1] = ACTIONS(2252),
    [aux_sym_infix_op_token1] = ACTIONS(2254),
    [aux_sym_infix_op_token2] = ACTIONS(2252),
    [anon_sym_PIPE_PIPE] = ACTIONS(2252),
    [anon_sym_BANG_EQ] = ACTIONS(2252),
    [anon_sym_COLON_EQ] = ACTIONS(2254),
    [anon_sym_DOLLAR] = ACTIONS(2252),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2252),
    [sym_int] = ACTIONS(2252),
    [sym_xint] = ACTIONS(2254),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2254),
    [anon_sym_POUNDendif] = ACTIONS(2254),
    [anon_sym_POUNDelse] = ACTIONS(2254),
    [sym__newline] = ACTIONS(2254),
  },
  [974] = {
    [sym_block_comment] = STATE(974),
    [sym_compiler_directive_decl] = STATE(974),
    [sym_fsi_directive_decl] = STATE(974),
    [sym_preproc_line] = STATE(974),
    [aux_sym_rules_repeat1] = STATE(966),
    [sym_identifier] = ACTIONS(2698),
    [anon_sym_EQ] = ACTIONS(2700),
    [anon_sym_GT_RBRACK] = ACTIONS(2700),
    [anon_sym_COLON] = ACTIONS(2698),
    [anon_sym_return] = ACTIONS(2698),
    [anon_sym_do] = ACTIONS(2698),
    [anon_sym_let] = ACTIONS(2698),
    [anon_sym_let_BANG] = ACTIONS(2700),
    [anon_sym_LPAREN] = ACTIONS(2698),
    [anon_sym_COMMA] = ACTIONS(2700),
    [anon_sym_null] = ACTIONS(2698),
    [anon_sym_QMARK] = ACTIONS(2698),
    [anon_sym_COLON_QMARK] = ACTIONS(2698),
    [anon_sym_COLON_COLON] = ACTIONS(2700),
    [anon_sym_PIPE] = ACTIONS(3183),
    [anon_sym_AMP] = ACTIONS(2698),
    [anon_sym_LBRACK] = ACTIONS(2698),
    [anon_sym_RBRACK] = ACTIONS(2700),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2700),
    [anon_sym_LBRACE] = ACTIONS(2698),
    [anon_sym_RBRACE] = ACTIONS(2700),
    [anon_sym_LT_AT] = ACTIONS(2698),
    [anon_sym_LT_AT_AT] = ACTIONS(2698),
    [anon_sym_DOT] = ACTIONS(2698),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2700),
    [anon_sym_new] = ACTIONS(2698),
    [anon_sym_with] = ACTIONS(2698),
    [anon_sym_return_BANG] = ACTIONS(2700),
    [anon_sym_yield] = ACTIONS(2698),
    [anon_sym_yield_BANG] = ACTIONS(2700),
    [anon_sym_lazy] = ACTIONS(2698),
    [anon_sym_assert] = ACTIONS(2698),
    [anon_sym_upcast] = ACTIONS(2698),
    [anon_sym_downcast] = ACTIONS(2698),
    [anon_sym_COLON_GT] = ACTIONS(2700),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2700),
    [anon_sym_for] = ACTIONS(2698),
    [anon_sym_to] = ACTIONS(2698),
    [anon_sym_downto] = ACTIONS(2698),
    [anon_sym_while] = ACTIONS(2698),
    [anon_sym_if] = ACTIONS(2698),
    [anon_sym_fun] = ACTIONS(2698),
    [anon_sym_try] = ACTIONS(2698),
    [anon_sym_match] = ACTIONS(2698),
    [anon_sym_match_BANG] = ACTIONS(2700),
    [anon_sym_function] = ACTIONS(2698),
    [anon_sym_LT_DASH] = ACTIONS(2698),
    [anon_sym_DOT_LBRACK] = ACTIONS(2700),
    [anon_sym_LT] = ACTIONS(2700),
    [anon_sym_use] = ACTIONS(2698),
    [anon_sym_use_BANG] = ACTIONS(2700),
    [anon_sym_do_BANG] = ACTIONS(2700),
    [anon_sym_begin] = ACTIONS(2698),
    [anon_sym_LPAREN2] = ACTIONS(2698),
    [anon_sym_DOT_DOT2] = ACTIONS(2700),
    [anon_sym_or] = ACTIONS(2698),
    [aux_sym_char_token1] = ACTIONS(2700),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2698),
    [anon_sym_DQUOTE] = ACTIONS(2698),
    [anon_sym_AT_DQUOTE] = ACTIONS(2700),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2700),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2700),
    [sym_bool] = ACTIONS(2698),
    [sym_unit] = ACTIONS(2700),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2698),
    [sym_op_identifier] = ACTIONS(2698),
    [anon_sym_PLUS] = ACTIONS(2698),
    [anon_sym_DASH] = ACTIONS(2698),
    [anon_sym_PLUS_DOT] = ACTIONS(2698),
    [anon_sym_DASH_DOT] = ACTIONS(2698),
    [anon_sym_PERCENT] = ACTIONS(2698),
    [anon_sym_AMP_AMP] = ACTIONS(2698),
    [anon_sym_TILDE] = ACTIONS(2700),
    [aux_sym_prefix_op_token1] = ACTIONS(2698),
    [aux_sym_infix_op_token1] = ACTIONS(2700),
    [aux_sym_infix_op_token2] = ACTIONS(2698),
    [anon_sym_PIPE_PIPE] = ACTIONS(2698),
    [anon_sym_BANG_EQ] = ACTIONS(2698),
    [anon_sym_COLON_EQ] = ACTIONS(2700),
    [anon_sym_DOLLAR] = ACTIONS(2698),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2698),
    [sym_int] = ACTIONS(2698),
    [sym_xint] = ACTIONS(2700),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2700),
    [sym__newline] = ACTIONS(3185),
  },
  [975] = {
    [sym_block_comment] = STATE(975),
    [sym_compiler_directive_decl] = STATE(975),
    [sym_fsi_directive_decl] = STATE(975),
    [sym_preproc_line] = STATE(975),
    [aux_sym_rules_repeat1] = STATE(987),
    [sym_identifier] = ACTIONS(2698),
    [anon_sym_EQ] = ACTIONS(2700),
    [anon_sym_GT_RBRACK] = ACTIONS(2700),
    [anon_sym_COLON] = ACTIONS(2698),
    [anon_sym_return] = ACTIONS(2698),
    [anon_sym_do] = ACTIONS(2698),
    [anon_sym_let] = ACTIONS(2698),
    [anon_sym_let_BANG] = ACTIONS(2700),
    [anon_sym_LPAREN] = ACTIONS(2698),
    [anon_sym_COMMA] = ACTIONS(2700),
    [anon_sym_null] = ACTIONS(2698),
    [anon_sym_QMARK] = ACTIONS(2698),
    [anon_sym_COLON_QMARK] = ACTIONS(2698),
    [anon_sym_COLON_COLON] = ACTIONS(2700),
    [anon_sym_PIPE] = ACTIONS(3183),
    [anon_sym_AMP] = ACTIONS(2698),
    [anon_sym_LBRACK] = ACTIONS(2698),
    [anon_sym_RBRACK] = ACTIONS(2700),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2700),
    [anon_sym_LBRACE] = ACTIONS(2698),
    [anon_sym_RBRACE] = ACTIONS(2700),
    [anon_sym_LT_AT] = ACTIONS(2698),
    [anon_sym_LT_AT_AT] = ACTIONS(2698),
    [anon_sym_DOT] = ACTIONS(2698),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2700),
    [anon_sym_new] = ACTIONS(2698),
    [anon_sym_with] = ACTIONS(2698),
    [anon_sym_return_BANG] = ACTIONS(2700),
    [anon_sym_yield] = ACTIONS(2698),
    [anon_sym_yield_BANG] = ACTIONS(2700),
    [anon_sym_lazy] = ACTIONS(2698),
    [anon_sym_assert] = ACTIONS(2698),
    [anon_sym_upcast] = ACTIONS(2698),
    [anon_sym_downcast] = ACTIONS(2698),
    [anon_sym_COLON_GT] = ACTIONS(2700),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2700),
    [anon_sym_for] = ACTIONS(2698),
    [anon_sym_to] = ACTIONS(2698),
    [anon_sym_downto] = ACTIONS(2698),
    [anon_sym_while] = ACTIONS(2698),
    [anon_sym_if] = ACTIONS(2698),
    [anon_sym_fun] = ACTIONS(2698),
    [anon_sym_try] = ACTIONS(2698),
    [anon_sym_match] = ACTIONS(2698),
    [anon_sym_match_BANG] = ACTIONS(2700),
    [anon_sym_function] = ACTIONS(2698),
    [anon_sym_LT_DASH] = ACTIONS(2698),
    [anon_sym_DOT_LBRACK] = ACTIONS(2700),
    [anon_sym_LT] = ACTIONS(2700),
    [anon_sym_use] = ACTIONS(2698),
    [anon_sym_use_BANG] = ACTIONS(2700),
    [anon_sym_do_BANG] = ACTIONS(2700),
    [anon_sym_begin] = ACTIONS(2698),
    [anon_sym_LPAREN2] = ACTIONS(2698),
    [anon_sym_DOT_DOT2] = ACTIONS(2700),
    [anon_sym_or] = ACTIONS(2698),
    [aux_sym_char_token1] = ACTIONS(2700),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2698),
    [anon_sym_DQUOTE] = ACTIONS(2698),
    [anon_sym_AT_DQUOTE] = ACTIONS(2700),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2700),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2700),
    [sym_bool] = ACTIONS(2698),
    [sym_unit] = ACTIONS(2700),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2698),
    [sym_op_identifier] = ACTIONS(2698),
    [anon_sym_PLUS] = ACTIONS(2698),
    [anon_sym_DASH] = ACTIONS(2698),
    [anon_sym_PLUS_DOT] = ACTIONS(2698),
    [anon_sym_DASH_DOT] = ACTIONS(2698),
    [anon_sym_PERCENT] = ACTIONS(2698),
    [anon_sym_AMP_AMP] = ACTIONS(2698),
    [anon_sym_TILDE] = ACTIONS(2700),
    [aux_sym_prefix_op_token1] = ACTIONS(2698),
    [aux_sym_infix_op_token1] = ACTIONS(2700),
    [aux_sym_infix_op_token2] = ACTIONS(2698),
    [anon_sym_PIPE_PIPE] = ACTIONS(2698),
    [anon_sym_BANG_EQ] = ACTIONS(2698),
    [anon_sym_COLON_EQ] = ACTIONS(2700),
    [anon_sym_DOLLAR] = ACTIONS(2698),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2698),
    [sym_int] = ACTIONS(2698),
    [sym_xint] = ACTIONS(2700),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2700),
    [sym__newline] = ACTIONS(3185),
  },
  [976] = {
    [sym_block_comment] = STATE(976),
    [sym_compiler_directive_decl] = STATE(976),
    [sym_fsi_directive_decl] = STATE(976),
    [sym_preproc_line] = STATE(976),
    [sym_identifier] = ACTIONS(2729),
    [anon_sym_EQ] = ACTIONS(2731),
    [anon_sym_GT_RBRACK] = ACTIONS(2731),
    [anon_sym_COLON] = ACTIONS(2729),
    [anon_sym_return] = ACTIONS(2729),
    [anon_sym_do] = ACTIONS(2729),
    [anon_sym_let] = ACTIONS(2729),
    [anon_sym_let_BANG] = ACTIONS(2731),
    [anon_sym_LPAREN] = ACTIONS(2729),
    [anon_sym_COMMA] = ACTIONS(2731),
    [anon_sym_null] = ACTIONS(2729),
    [anon_sym_QMARK] = ACTIONS(2729),
    [anon_sym_COLON_QMARK] = ACTIONS(2729),
    [anon_sym_COLON_COLON] = ACTIONS(2731),
    [anon_sym_AMP] = ACTIONS(2729),
    [anon_sym_LBRACK] = ACTIONS(2729),
    [anon_sym_RBRACK] = ACTIONS(2731),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2731),
    [anon_sym_LBRACE] = ACTIONS(2729),
    [anon_sym_RBRACE] = ACTIONS(2731),
    [anon_sym_LT_AT] = ACTIONS(2729),
    [anon_sym_LT_AT_AT] = ACTIONS(2729),
    [anon_sym_DOT] = ACTIONS(2729),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2731),
    [anon_sym_new] = ACTIONS(2729),
    [anon_sym_with] = ACTIONS(2729),
    [anon_sym_return_BANG] = ACTIONS(2731),
    [anon_sym_yield] = ACTIONS(2729),
    [anon_sym_yield_BANG] = ACTIONS(2731),
    [anon_sym_lazy] = ACTIONS(2729),
    [anon_sym_assert] = ACTIONS(2729),
    [anon_sym_upcast] = ACTIONS(2729),
    [anon_sym_downcast] = ACTIONS(2729),
    [anon_sym_COLON_GT] = ACTIONS(2731),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2731),
    [anon_sym_for] = ACTIONS(2729),
    [anon_sym_to] = ACTIONS(2729),
    [anon_sym_downto] = ACTIONS(2729),
    [anon_sym_while] = ACTIONS(2729),
    [anon_sym_else] = ACTIONS(2729),
    [anon_sym_elif] = ACTIONS(2729),
    [anon_sym_if] = ACTIONS(2729),
    [anon_sym_fun] = ACTIONS(2729),
    [anon_sym_try] = ACTIONS(2729),
    [anon_sym_match] = ACTIONS(2729),
    [anon_sym_match_BANG] = ACTIONS(2731),
    [anon_sym_function] = ACTIONS(2729),
    [anon_sym_LT_DASH] = ACTIONS(2729),
    [anon_sym_DOT_LBRACK] = ACTIONS(2731),
    [anon_sym_LT] = ACTIONS(2731),
    [anon_sym_use] = ACTIONS(2729),
    [anon_sym_use_BANG] = ACTIONS(2731),
    [anon_sym_do_BANG] = ACTIONS(2731),
    [anon_sym_begin] = ACTIONS(2729),
    [anon_sym_LPAREN2] = ACTIONS(2729),
    [anon_sym_DOT_DOT2] = ACTIONS(2731),
    [anon_sym_or] = ACTIONS(2729),
    [aux_sym_char_token1] = ACTIONS(2731),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2729),
    [anon_sym_DQUOTE] = ACTIONS(2729),
    [anon_sym_AT_DQUOTE] = ACTIONS(2731),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2731),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2731),
    [sym_bool] = ACTIONS(2729),
    [sym_unit] = ACTIONS(2731),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2729),
    [sym_op_identifier] = ACTIONS(2729),
    [anon_sym_PLUS] = ACTIONS(2729),
    [anon_sym_DASH] = ACTIONS(2729),
    [anon_sym_PLUS_DOT] = ACTIONS(2729),
    [anon_sym_DASH_DOT] = ACTIONS(2729),
    [anon_sym_PERCENT] = ACTIONS(2729),
    [anon_sym_AMP_AMP] = ACTIONS(2729),
    [anon_sym_TILDE] = ACTIONS(2731),
    [aux_sym_prefix_op_token1] = ACTIONS(2729),
    [aux_sym_infix_op_token1] = ACTIONS(2731),
    [aux_sym_infix_op_token2] = ACTIONS(2729),
    [anon_sym_PIPE_PIPE] = ACTIONS(2729),
    [anon_sym_BANG_EQ] = ACTIONS(2729),
    [anon_sym_COLON_EQ] = ACTIONS(2731),
    [anon_sym_DOLLAR] = ACTIONS(2729),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2729),
    [sym_int] = ACTIONS(2729),
    [sym_xint] = ACTIONS(2731),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2731),
    [sym__newline] = ACTIONS(2731),
  },
  [977] = {
    [sym_type_arguments] = STATE(1175),
    [sym_long_identifier] = STATE(1226),
    [sym_block_comment] = STATE(977),
    [sym_compiler_directive_decl] = STATE(977),
    [sym_fsi_directive_decl] = STATE(977),
    [sym_preproc_line] = STATE(977),
    [aux_sym_compound_type_repeat1] = STATE(1061),
    [sym_identifier] = ACTIONS(3188),
    [anon_sym_EQ] = ACTIONS(2248),
    [anon_sym_COLON] = ACTIONS(2250),
    [anon_sym_return] = ACTIONS(2250),
    [anon_sym_do] = ACTIONS(2250),
    [anon_sym_let] = ACTIONS(2250),
    [anon_sym_let_BANG] = ACTIONS(2248),
    [anon_sym_as] = ACTIONS(2250),
    [anon_sym_LPAREN] = ACTIONS(2250),
    [anon_sym_COMMA] = ACTIONS(2248),
    [anon_sym_null] = ACTIONS(2250),
    [anon_sym_QMARK] = ACTIONS(2250),
    [anon_sym_COLON_QMARK] = ACTIONS(2250),
    [anon_sym_COLON_COLON] = ACTIONS(2248),
    [anon_sym_AMP] = ACTIONS(2250),
    [anon_sym_LBRACK] = ACTIONS(2250),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2248),
    [anon_sym_LBRACE] = ACTIONS(2250),
    [anon_sym_LT_AT] = ACTIONS(2250),
    [anon_sym_LT_AT_AT] = ACTIONS(2250),
    [anon_sym_DOT] = ACTIONS(2250),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2248),
    [anon_sym_new] = ACTIONS(2250),
    [anon_sym_with] = ACTIONS(2250),
    [anon_sym_return_BANG] = ACTIONS(2248),
    [anon_sym_yield] = ACTIONS(2250),
    [anon_sym_yield_BANG] = ACTIONS(2248),
    [anon_sym_lazy] = ACTIONS(2250),
    [anon_sym_assert] = ACTIONS(2250),
    [anon_sym_upcast] = ACTIONS(2250),
    [anon_sym_downcast] = ACTIONS(2250),
    [anon_sym_COLON_GT] = ACTIONS(2248),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2248),
    [anon_sym_for] = ACTIONS(2250),
    [anon_sym_while] = ACTIONS(2250),
    [anon_sym_if] = ACTIONS(2250),
    [anon_sym_fun] = ACTIONS(2250),
    [anon_sym_DASH_GT] = ACTIONS(3190),
    [anon_sym_try] = ACTIONS(2250),
    [anon_sym_match] = ACTIONS(2250),
    [anon_sym_match_BANG] = ACTIONS(2248),
    [anon_sym_function] = ACTIONS(2250),
    [anon_sym_LT_DASH] = ACTIONS(2250),
    [anon_sym_DOT_LBRACK] = ACTIONS(2248),
    [anon_sym_LT] = ACTIONS(2248),
    [anon_sym_use] = ACTIONS(2250),
    [anon_sym_use_BANG] = ACTIONS(2248),
    [anon_sym_do_BANG] = ACTIONS(2248),
    [anon_sym_begin] = ACTIONS(2250),
    [anon_sym_LPAREN2] = ACTIONS(2250),
    [anon_sym_STAR] = ACTIONS(3192),
    [anon_sym_LT2] = ACTIONS(3194),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3196),
    [anon_sym_or] = ACTIONS(2250),
    [aux_sym_char_token1] = ACTIONS(2248),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2250),
    [anon_sym_DQUOTE] = ACTIONS(2250),
    [anon_sym_AT_DQUOTE] = ACTIONS(2248),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2248),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2248),
    [sym_bool] = ACTIONS(2250),
    [sym_unit] = ACTIONS(2248),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2250),
    [sym_op_identifier] = ACTIONS(2250),
    [anon_sym_PLUS] = ACTIONS(2250),
    [anon_sym_DASH] = ACTIONS(2250),
    [anon_sym_PLUS_DOT] = ACTIONS(2250),
    [anon_sym_DASH_DOT] = ACTIONS(2250),
    [anon_sym_PERCENT] = ACTIONS(2250),
    [anon_sym_AMP_AMP] = ACTIONS(2250),
    [anon_sym_TILDE] = ACTIONS(2248),
    [aux_sym_prefix_op_token1] = ACTIONS(2250),
    [aux_sym_infix_op_token1] = ACTIONS(2248),
    [aux_sym_infix_op_token2] = ACTIONS(2250),
    [anon_sym_PIPE_PIPE] = ACTIONS(2250),
    [anon_sym_BANG_EQ] = ACTIONS(2250),
    [anon_sym_COLON_EQ] = ACTIONS(2248),
    [anon_sym_DOLLAR] = ACTIONS(2250),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2250),
    [sym_int] = ACTIONS(2250),
    [sym_xint] = ACTIONS(2248),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2248),
    [sym__newline] = ACTIONS(2248),
  },
  [978] = {
    [sym_type_arguments] = STATE(1175),
    [sym_long_identifier] = STATE(1226),
    [sym_block_comment] = STATE(978),
    [sym_compiler_directive_decl] = STATE(978),
    [sym_fsi_directive_decl] = STATE(978),
    [sym_preproc_line] = STATE(978),
    [aux_sym_compound_type_repeat1] = STATE(1061),
    [sym_identifier] = ACTIONS(3188),
    [anon_sym_EQ] = ACTIONS(2244),
    [anon_sym_COLON] = ACTIONS(2246),
    [anon_sym_return] = ACTIONS(2246),
    [anon_sym_do] = ACTIONS(2246),
    [anon_sym_let] = ACTIONS(2246),
    [anon_sym_let_BANG] = ACTIONS(2244),
    [anon_sym_as] = ACTIONS(2246),
    [anon_sym_LPAREN] = ACTIONS(2246),
    [anon_sym_COMMA] = ACTIONS(2244),
    [anon_sym_null] = ACTIONS(2246),
    [anon_sym_QMARK] = ACTIONS(2246),
    [anon_sym_COLON_QMARK] = ACTIONS(2246),
    [anon_sym_COLON_COLON] = ACTIONS(2244),
    [anon_sym_AMP] = ACTIONS(2246),
    [anon_sym_LBRACK] = ACTIONS(2246),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2244),
    [anon_sym_LBRACE] = ACTIONS(2246),
    [anon_sym_LT_AT] = ACTIONS(2246),
    [anon_sym_LT_AT_AT] = ACTIONS(2246),
    [anon_sym_DOT] = ACTIONS(2246),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2244),
    [anon_sym_new] = ACTIONS(2246),
    [anon_sym_with] = ACTIONS(2246),
    [anon_sym_return_BANG] = ACTIONS(2244),
    [anon_sym_yield] = ACTIONS(2246),
    [anon_sym_yield_BANG] = ACTIONS(2244),
    [anon_sym_lazy] = ACTIONS(2246),
    [anon_sym_assert] = ACTIONS(2246),
    [anon_sym_upcast] = ACTIONS(2246),
    [anon_sym_downcast] = ACTIONS(2246),
    [anon_sym_COLON_GT] = ACTIONS(2244),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2244),
    [anon_sym_for] = ACTIONS(2246),
    [anon_sym_while] = ACTIONS(2246),
    [anon_sym_if] = ACTIONS(2246),
    [anon_sym_fun] = ACTIONS(2246),
    [anon_sym_DASH_GT] = ACTIONS(3190),
    [anon_sym_try] = ACTIONS(2246),
    [anon_sym_match] = ACTIONS(2246),
    [anon_sym_match_BANG] = ACTIONS(2244),
    [anon_sym_function] = ACTIONS(2246),
    [anon_sym_LT_DASH] = ACTIONS(2246),
    [anon_sym_DOT_LBRACK] = ACTIONS(2244),
    [anon_sym_LT] = ACTIONS(2244),
    [anon_sym_use] = ACTIONS(2246),
    [anon_sym_use_BANG] = ACTIONS(2244),
    [anon_sym_do_BANG] = ACTIONS(2244),
    [anon_sym_begin] = ACTIONS(2246),
    [anon_sym_LPAREN2] = ACTIONS(2246),
    [anon_sym_STAR] = ACTIONS(3192),
    [anon_sym_LT2] = ACTIONS(3194),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3196),
    [anon_sym_or] = ACTIONS(2246),
    [aux_sym_char_token1] = ACTIONS(2244),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2246),
    [anon_sym_DQUOTE] = ACTIONS(2246),
    [anon_sym_AT_DQUOTE] = ACTIONS(2244),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2244),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2244),
    [sym_bool] = ACTIONS(2246),
    [sym_unit] = ACTIONS(2244),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2246),
    [sym_op_identifier] = ACTIONS(2246),
    [anon_sym_PLUS] = ACTIONS(2246),
    [anon_sym_DASH] = ACTIONS(2246),
    [anon_sym_PLUS_DOT] = ACTIONS(2246),
    [anon_sym_DASH_DOT] = ACTIONS(2246),
    [anon_sym_PERCENT] = ACTIONS(2246),
    [anon_sym_AMP_AMP] = ACTIONS(2246),
    [anon_sym_TILDE] = ACTIONS(2244),
    [aux_sym_prefix_op_token1] = ACTIONS(2246),
    [aux_sym_infix_op_token1] = ACTIONS(2244),
    [aux_sym_infix_op_token2] = ACTIONS(2246),
    [anon_sym_PIPE_PIPE] = ACTIONS(2246),
    [anon_sym_BANG_EQ] = ACTIONS(2246),
    [anon_sym_COLON_EQ] = ACTIONS(2244),
    [anon_sym_DOLLAR] = ACTIONS(2246),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2246),
    [sym_int] = ACTIONS(2246),
    [sym_xint] = ACTIONS(2244),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2244),
    [sym__newline] = ACTIONS(2244),
  },
  [979] = {
    [sym_block_comment] = STATE(979),
    [sym_compiler_directive_decl] = STATE(979),
    [sym_fsi_directive_decl] = STATE(979),
    [sym_preproc_line] = STATE(979),
    [sym_identifier] = ACTIONS(2158),
    [anon_sym_EQ] = ACTIONS(2160),
    [anon_sym_GT_RBRACK] = ACTIONS(2160),
    [anon_sym_COLON] = ACTIONS(2158),
    [anon_sym_return] = ACTIONS(2158),
    [anon_sym_do] = ACTIONS(2158),
    [anon_sym_let] = ACTIONS(2158),
    [anon_sym_let_BANG] = ACTIONS(2160),
    [anon_sym_LPAREN] = ACTIONS(2158),
    [anon_sym_COMMA] = ACTIONS(2160),
    [anon_sym_null] = ACTIONS(2158),
    [anon_sym_QMARK] = ACTIONS(2158),
    [anon_sym_COLON_QMARK] = ACTIONS(2158),
    [anon_sym_COLON_COLON] = ACTIONS(2160),
    [anon_sym_AMP] = ACTIONS(2158),
    [anon_sym_LBRACK] = ACTIONS(2158),
    [anon_sym_RBRACK] = ACTIONS(2160),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2160),
    [anon_sym_LBRACE] = ACTIONS(2158),
    [anon_sym_RBRACE] = ACTIONS(2160),
    [anon_sym_LT_AT] = ACTIONS(2158),
    [anon_sym_LT_AT_AT] = ACTIONS(2158),
    [anon_sym_DOT] = ACTIONS(2158),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2160),
    [anon_sym_new] = ACTIONS(2158),
    [anon_sym_with] = ACTIONS(2158),
    [anon_sym_return_BANG] = ACTIONS(2160),
    [anon_sym_yield] = ACTIONS(2158),
    [anon_sym_yield_BANG] = ACTIONS(2160),
    [anon_sym_lazy] = ACTIONS(2158),
    [anon_sym_assert] = ACTIONS(2158),
    [anon_sym_upcast] = ACTIONS(2158),
    [anon_sym_downcast] = ACTIONS(2158),
    [anon_sym_COLON_GT] = ACTIONS(2160),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2160),
    [anon_sym_for] = ACTIONS(2158),
    [anon_sym_to] = ACTIONS(2158),
    [anon_sym_downto] = ACTIONS(2158),
    [anon_sym_while] = ACTIONS(2158),
    [anon_sym_if] = ACTIONS(2158),
    [anon_sym_fun] = ACTIONS(2158),
    [anon_sym_try] = ACTIONS(2158),
    [anon_sym_match] = ACTIONS(2158),
    [anon_sym_match_BANG] = ACTIONS(2160),
    [anon_sym_function] = ACTIONS(2158),
    [anon_sym_LT_DASH] = ACTIONS(2158),
    [anon_sym_DOT_LBRACK] = ACTIONS(2160),
    [anon_sym_LT] = ACTIONS(2160),
    [anon_sym_use] = ACTIONS(2158),
    [anon_sym_use_BANG] = ACTIONS(2160),
    [anon_sym_do_BANG] = ACTIONS(2160),
    [anon_sym_begin] = ACTIONS(2158),
    [anon_sym_LPAREN2] = ACTIONS(2158),
    [anon_sym_DOT_DOT2] = ACTIONS(2160),
    [anon_sym_or] = ACTIONS(2158),
    [aux_sym_char_token1] = ACTIONS(2160),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2158),
    [anon_sym_DQUOTE] = ACTIONS(2158),
    [anon_sym_AT_DQUOTE] = ACTIONS(2160),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2160),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2160),
    [sym_bool] = ACTIONS(2158),
    [sym_unit] = ACTIONS(2160),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2158),
    [sym_op_identifier] = ACTIONS(2158),
    [anon_sym_PLUS] = ACTIONS(2158),
    [anon_sym_DASH] = ACTIONS(2158),
    [anon_sym_PLUS_DOT] = ACTIONS(2158),
    [anon_sym_DASH_DOT] = ACTIONS(2158),
    [anon_sym_PERCENT] = ACTIONS(2158),
    [anon_sym_AMP_AMP] = ACTIONS(2158),
    [anon_sym_TILDE] = ACTIONS(2160),
    [aux_sym_prefix_op_token1] = ACTIONS(2158),
    [aux_sym_infix_op_token1] = ACTIONS(2160),
    [aux_sym_infix_op_token2] = ACTIONS(2158),
    [anon_sym_PIPE_PIPE] = ACTIONS(2158),
    [anon_sym_BANG_EQ] = ACTIONS(2158),
    [anon_sym_COLON_EQ] = ACTIONS(2160),
    [anon_sym_DOLLAR] = ACTIONS(2158),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2158),
    [sym_int] = ACTIONS(2158),
    [sym_xint] = ACTIONS(2160),
    [anon_sym_f] = ACTIONS(2222),
    [aux_sym_decimal_token1] = ACTIONS(2216),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2160),
    [sym__newline] = ACTIONS(2160),
  },
  [980] = {
    [sym_type_arguments] = STATE(1175),
    [sym_long_identifier] = STATE(1226),
    [sym_block_comment] = STATE(980),
    [sym_compiler_directive_decl] = STATE(980),
    [sym_fsi_directive_decl] = STATE(980),
    [sym_preproc_line] = STATE(980),
    [aux_sym_compound_type_repeat1] = STATE(1061),
    [sym_identifier] = ACTIONS(3188),
    [anon_sym_EQ] = ACTIONS(2228),
    [anon_sym_COLON] = ACTIONS(2230),
    [anon_sym_return] = ACTIONS(2230),
    [anon_sym_do] = ACTIONS(2230),
    [anon_sym_let] = ACTIONS(2230),
    [anon_sym_let_BANG] = ACTIONS(2228),
    [anon_sym_as] = ACTIONS(2230),
    [anon_sym_LPAREN] = ACTIONS(2230),
    [anon_sym_COMMA] = ACTIONS(2228),
    [anon_sym_null] = ACTIONS(2230),
    [anon_sym_QMARK] = ACTIONS(2230),
    [anon_sym_COLON_QMARK] = ACTIONS(2230),
    [anon_sym_COLON_COLON] = ACTIONS(2228),
    [anon_sym_AMP] = ACTIONS(2230),
    [anon_sym_LBRACK] = ACTIONS(2230),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2228),
    [anon_sym_LBRACE] = ACTIONS(2230),
    [anon_sym_LT_AT] = ACTIONS(2230),
    [anon_sym_LT_AT_AT] = ACTIONS(2230),
    [anon_sym_DOT] = ACTIONS(2230),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2228),
    [anon_sym_new] = ACTIONS(2230),
    [anon_sym_with] = ACTIONS(2230),
    [anon_sym_return_BANG] = ACTIONS(2228),
    [anon_sym_yield] = ACTIONS(2230),
    [anon_sym_yield_BANG] = ACTIONS(2228),
    [anon_sym_lazy] = ACTIONS(2230),
    [anon_sym_assert] = ACTIONS(2230),
    [anon_sym_upcast] = ACTIONS(2230),
    [anon_sym_downcast] = ACTIONS(2230),
    [anon_sym_COLON_GT] = ACTIONS(2228),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2228),
    [anon_sym_for] = ACTIONS(2230),
    [anon_sym_while] = ACTIONS(2230),
    [anon_sym_if] = ACTIONS(2230),
    [anon_sym_fun] = ACTIONS(2230),
    [anon_sym_DASH_GT] = ACTIONS(3190),
    [anon_sym_try] = ACTIONS(2230),
    [anon_sym_match] = ACTIONS(2230),
    [anon_sym_match_BANG] = ACTIONS(2228),
    [anon_sym_function] = ACTIONS(2230),
    [anon_sym_LT_DASH] = ACTIONS(2230),
    [anon_sym_DOT_LBRACK] = ACTIONS(2228),
    [anon_sym_LT] = ACTIONS(2228),
    [anon_sym_use] = ACTIONS(2230),
    [anon_sym_use_BANG] = ACTIONS(2228),
    [anon_sym_do_BANG] = ACTIONS(2228),
    [anon_sym_begin] = ACTIONS(2230),
    [anon_sym_LPAREN2] = ACTIONS(2230),
    [anon_sym_STAR] = ACTIONS(3192),
    [anon_sym_LT2] = ACTIONS(3194),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3196),
    [anon_sym_or] = ACTIONS(2230),
    [aux_sym_char_token1] = ACTIONS(2228),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2230),
    [anon_sym_DQUOTE] = ACTIONS(2230),
    [anon_sym_AT_DQUOTE] = ACTIONS(2228),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2228),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2228),
    [sym_bool] = ACTIONS(2230),
    [sym_unit] = ACTIONS(2228),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2230),
    [sym_op_identifier] = ACTIONS(2230),
    [anon_sym_PLUS] = ACTIONS(2230),
    [anon_sym_DASH] = ACTIONS(2230),
    [anon_sym_PLUS_DOT] = ACTIONS(2230),
    [anon_sym_DASH_DOT] = ACTIONS(2230),
    [anon_sym_PERCENT] = ACTIONS(2230),
    [anon_sym_AMP_AMP] = ACTIONS(2230),
    [anon_sym_TILDE] = ACTIONS(2228),
    [aux_sym_prefix_op_token1] = ACTIONS(2230),
    [aux_sym_infix_op_token1] = ACTIONS(2228),
    [aux_sym_infix_op_token2] = ACTIONS(2230),
    [anon_sym_PIPE_PIPE] = ACTIONS(2230),
    [anon_sym_BANG_EQ] = ACTIONS(2230),
    [anon_sym_COLON_EQ] = ACTIONS(2228),
    [anon_sym_DOLLAR] = ACTIONS(2230),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2230),
    [sym_int] = ACTIONS(2230),
    [sym_xint] = ACTIONS(2228),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2228),
    [sym__newline] = ACTIONS(2228),
  },
  [981] = {
    [sym_type_arguments] = STATE(1277),
    [sym_long_identifier] = STATE(1255),
    [sym_block_comment] = STATE(981),
    [sym_compiler_directive_decl] = STATE(981),
    [sym_fsi_directive_decl] = STATE(981),
    [sym_preproc_line] = STATE(981),
    [aux_sym_compound_type_repeat1] = STATE(1121),
    [sym_identifier] = ACTIONS(2252),
    [anon_sym_EQ] = ACTIONS(2254),
    [anon_sym_COLON] = ACTIONS(2252),
    [anon_sym_return] = ACTIONS(2252),
    [anon_sym_do] = ACTIONS(2252),
    [anon_sym_and] = ACTIONS(2252),
    [anon_sym_let] = ACTIONS(2252),
    [anon_sym_let_BANG] = ACTIONS(2254),
    [anon_sym_LPAREN] = ACTIONS(2252),
    [anon_sym_COMMA] = ACTIONS(2254),
    [anon_sym_null] = ACTIONS(2252),
    [anon_sym_QMARK] = ACTIONS(2252),
    [anon_sym_COLON_QMARK] = ACTIONS(2252),
    [anon_sym_COLON_COLON] = ACTIONS(2254),
    [anon_sym_AMP] = ACTIONS(2252),
    [anon_sym_LBRACK] = ACTIONS(2252),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2254),
    [anon_sym_LBRACE] = ACTIONS(2252),
    [anon_sym_LT_AT] = ACTIONS(2252),
    [anon_sym_LT_AT_AT] = ACTIONS(2252),
    [anon_sym_DOT] = ACTIONS(2252),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2254),
    [anon_sym_new] = ACTIONS(2252),
    [anon_sym_return_BANG] = ACTIONS(2254),
    [anon_sym_yield] = ACTIONS(2252),
    [anon_sym_yield_BANG] = ACTIONS(2254),
    [anon_sym_lazy] = ACTIONS(2252),
    [anon_sym_assert] = ACTIONS(2252),
    [anon_sym_upcast] = ACTIONS(2252),
    [anon_sym_downcast] = ACTIONS(2252),
    [anon_sym_COLON_GT] = ACTIONS(2254),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2254),
    [anon_sym_for] = ACTIONS(2252),
    [anon_sym_while] = ACTIONS(2252),
    [anon_sym_if] = ACTIONS(2252),
    [anon_sym_fun] = ACTIONS(2252),
    [anon_sym_DASH_GT] = ACTIONS(3175),
    [anon_sym_try] = ACTIONS(2252),
    [anon_sym_match] = ACTIONS(2252),
    [anon_sym_match_BANG] = ACTIONS(2254),
    [anon_sym_function] = ACTIONS(2252),
    [anon_sym_LT_DASH] = ACTIONS(2252),
    [anon_sym_DOT_LBRACK] = ACTIONS(2254),
    [anon_sym_LT] = ACTIONS(2254),
    [anon_sym_use] = ACTIONS(2252),
    [anon_sym_use_BANG] = ACTIONS(2254),
    [anon_sym_do_BANG] = ACTIONS(2254),
    [anon_sym_begin] = ACTIONS(2252),
    [anon_sym_LPAREN2] = ACTIONS(2252),
    [anon_sym_STAR] = ACTIONS(3177),
    [anon_sym_LT2] = ACTIONS(3179),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3181),
    [anon_sym_or] = ACTIONS(2252),
    [aux_sym_char_token1] = ACTIONS(2254),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2252),
    [anon_sym_DQUOTE] = ACTIONS(2252),
    [anon_sym_AT_DQUOTE] = ACTIONS(2254),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2254),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2254),
    [sym_bool] = ACTIONS(2252),
    [sym_unit] = ACTIONS(2254),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2252),
    [sym_op_identifier] = ACTIONS(2252),
    [anon_sym_PLUS] = ACTIONS(2252),
    [anon_sym_DASH] = ACTIONS(2252),
    [anon_sym_PLUS_DOT] = ACTIONS(2252),
    [anon_sym_DASH_DOT] = ACTIONS(2252),
    [anon_sym_PERCENT] = ACTIONS(2252),
    [anon_sym_AMP_AMP] = ACTIONS(2252),
    [anon_sym_TILDE] = ACTIONS(2254),
    [aux_sym_prefix_op_token1] = ACTIONS(2252),
    [aux_sym_infix_op_token1] = ACTIONS(2254),
    [aux_sym_infix_op_token2] = ACTIONS(2252),
    [anon_sym_PIPE_PIPE] = ACTIONS(2252),
    [anon_sym_BANG_EQ] = ACTIONS(2252),
    [anon_sym_COLON_EQ] = ACTIONS(2254),
    [anon_sym_DOLLAR] = ACTIONS(2252),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2252),
    [sym_int] = ACTIONS(2252),
    [sym_xint] = ACTIONS(2254),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2254),
    [sym__newline] = ACTIONS(2254),
    [sym__dedent] = ACTIONS(2254),
  },
  [982] = {
    [sym_type_arguments] = STATE(1175),
    [sym_long_identifier] = STATE(1226),
    [sym_block_comment] = STATE(982),
    [sym_compiler_directive_decl] = STATE(982),
    [sym_fsi_directive_decl] = STATE(982),
    [sym_preproc_line] = STATE(982),
    [aux_sym_compound_type_repeat1] = STATE(1061),
    [sym_identifier] = ACTIONS(2252),
    [anon_sym_EQ] = ACTIONS(2254),
    [anon_sym_COLON] = ACTIONS(2252),
    [anon_sym_return] = ACTIONS(2252),
    [anon_sym_do] = ACTIONS(2252),
    [anon_sym_let] = ACTIONS(2252),
    [anon_sym_let_BANG] = ACTIONS(2254),
    [anon_sym_as] = ACTIONS(2252),
    [anon_sym_LPAREN] = ACTIONS(2252),
    [anon_sym_COMMA] = ACTIONS(2254),
    [anon_sym_null] = ACTIONS(2252),
    [anon_sym_QMARK] = ACTIONS(2252),
    [anon_sym_COLON_QMARK] = ACTIONS(2252),
    [anon_sym_COLON_COLON] = ACTIONS(2254),
    [anon_sym_AMP] = ACTIONS(2252),
    [anon_sym_LBRACK] = ACTIONS(2252),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2254),
    [anon_sym_LBRACE] = ACTIONS(2252),
    [anon_sym_LT_AT] = ACTIONS(2252),
    [anon_sym_LT_AT_AT] = ACTIONS(2252),
    [anon_sym_DOT] = ACTIONS(2252),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2254),
    [anon_sym_new] = ACTIONS(2252),
    [anon_sym_with] = ACTIONS(2252),
    [anon_sym_return_BANG] = ACTIONS(2254),
    [anon_sym_yield] = ACTIONS(2252),
    [anon_sym_yield_BANG] = ACTIONS(2254),
    [anon_sym_lazy] = ACTIONS(2252),
    [anon_sym_assert] = ACTIONS(2252),
    [anon_sym_upcast] = ACTIONS(2252),
    [anon_sym_downcast] = ACTIONS(2252),
    [anon_sym_COLON_GT] = ACTIONS(2254),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2254),
    [anon_sym_for] = ACTIONS(2252),
    [anon_sym_while] = ACTIONS(2252),
    [anon_sym_if] = ACTIONS(2252),
    [anon_sym_fun] = ACTIONS(2252),
    [anon_sym_DASH_GT] = ACTIONS(3190),
    [anon_sym_try] = ACTIONS(2252),
    [anon_sym_match] = ACTIONS(2252),
    [anon_sym_match_BANG] = ACTIONS(2254),
    [anon_sym_function] = ACTIONS(2252),
    [anon_sym_LT_DASH] = ACTIONS(2252),
    [anon_sym_DOT_LBRACK] = ACTIONS(2254),
    [anon_sym_LT] = ACTIONS(2254),
    [anon_sym_use] = ACTIONS(2252),
    [anon_sym_use_BANG] = ACTIONS(2254),
    [anon_sym_do_BANG] = ACTIONS(2254),
    [anon_sym_begin] = ACTIONS(2252),
    [anon_sym_LPAREN2] = ACTIONS(2252),
    [anon_sym_STAR] = ACTIONS(3192),
    [anon_sym_LT2] = ACTIONS(3194),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3196),
    [anon_sym_or] = ACTIONS(2252),
    [aux_sym_char_token1] = ACTIONS(2254),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2252),
    [anon_sym_DQUOTE] = ACTIONS(2252),
    [anon_sym_AT_DQUOTE] = ACTIONS(2254),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2254),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2254),
    [sym_bool] = ACTIONS(2252),
    [sym_unit] = ACTIONS(2254),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2252),
    [sym_op_identifier] = ACTIONS(2252),
    [anon_sym_PLUS] = ACTIONS(2252),
    [anon_sym_DASH] = ACTIONS(2252),
    [anon_sym_PLUS_DOT] = ACTIONS(2252),
    [anon_sym_DASH_DOT] = ACTIONS(2252),
    [anon_sym_PERCENT] = ACTIONS(2252),
    [anon_sym_AMP_AMP] = ACTIONS(2252),
    [anon_sym_TILDE] = ACTIONS(2254),
    [aux_sym_prefix_op_token1] = ACTIONS(2252),
    [aux_sym_infix_op_token1] = ACTIONS(2254),
    [aux_sym_infix_op_token2] = ACTIONS(2252),
    [anon_sym_PIPE_PIPE] = ACTIONS(2252),
    [anon_sym_BANG_EQ] = ACTIONS(2252),
    [anon_sym_COLON_EQ] = ACTIONS(2254),
    [anon_sym_DOLLAR] = ACTIONS(2252),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2252),
    [sym_int] = ACTIONS(2252),
    [sym_xint] = ACTIONS(2254),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2254),
    [sym__newline] = ACTIONS(2254),
  },
  [983] = {
    [sym_block_comment] = STATE(983),
    [sym_compiler_directive_decl] = STATE(983),
    [sym_fsi_directive_decl] = STATE(983),
    [sym_preproc_line] = STATE(983),
    [aux_sym_rules_repeat1] = STATE(974),
    [sym_identifier] = ACTIONS(2689),
    [anon_sym_EQ] = ACTIONS(2691),
    [anon_sym_GT_RBRACK] = ACTIONS(2691),
    [anon_sym_COLON] = ACTIONS(2689),
    [anon_sym_return] = ACTIONS(2689),
    [anon_sym_do] = ACTIONS(2689),
    [anon_sym_let] = ACTIONS(2689),
    [anon_sym_let_BANG] = ACTIONS(2691),
    [anon_sym_LPAREN] = ACTIONS(2689),
    [anon_sym_COMMA] = ACTIONS(2691),
    [anon_sym_null] = ACTIONS(2689),
    [anon_sym_QMARK] = ACTIONS(2689),
    [anon_sym_COLON_QMARK] = ACTIONS(2689),
    [anon_sym_COLON_COLON] = ACTIONS(2691),
    [anon_sym_PIPE] = ACTIONS(3183),
    [anon_sym_AMP] = ACTIONS(2689),
    [anon_sym_LBRACK] = ACTIONS(2689),
    [anon_sym_RBRACK] = ACTIONS(2691),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2691),
    [anon_sym_LBRACE] = ACTIONS(2689),
    [anon_sym_RBRACE] = ACTIONS(2691),
    [anon_sym_LT_AT] = ACTIONS(2689),
    [anon_sym_LT_AT_AT] = ACTIONS(2689),
    [anon_sym_DOT] = ACTIONS(2689),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2691),
    [anon_sym_new] = ACTIONS(2689),
    [anon_sym_with] = ACTIONS(2689),
    [anon_sym_return_BANG] = ACTIONS(2691),
    [anon_sym_yield] = ACTIONS(2689),
    [anon_sym_yield_BANG] = ACTIONS(2691),
    [anon_sym_lazy] = ACTIONS(2689),
    [anon_sym_assert] = ACTIONS(2689),
    [anon_sym_upcast] = ACTIONS(2689),
    [anon_sym_downcast] = ACTIONS(2689),
    [anon_sym_COLON_GT] = ACTIONS(2691),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2691),
    [anon_sym_for] = ACTIONS(2689),
    [anon_sym_to] = ACTIONS(2689),
    [anon_sym_downto] = ACTIONS(2689),
    [anon_sym_while] = ACTIONS(2689),
    [anon_sym_if] = ACTIONS(2689),
    [anon_sym_fun] = ACTIONS(2689),
    [anon_sym_try] = ACTIONS(2689),
    [anon_sym_match] = ACTIONS(2689),
    [anon_sym_match_BANG] = ACTIONS(2691),
    [anon_sym_function] = ACTIONS(2689),
    [anon_sym_LT_DASH] = ACTIONS(2689),
    [anon_sym_DOT_LBRACK] = ACTIONS(2691),
    [anon_sym_LT] = ACTIONS(2691),
    [anon_sym_use] = ACTIONS(2689),
    [anon_sym_use_BANG] = ACTIONS(2691),
    [anon_sym_do_BANG] = ACTIONS(2691),
    [anon_sym_begin] = ACTIONS(2689),
    [anon_sym_LPAREN2] = ACTIONS(2689),
    [anon_sym_DOT_DOT2] = ACTIONS(2691),
    [anon_sym_or] = ACTIONS(2689),
    [aux_sym_char_token1] = ACTIONS(2691),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2689),
    [anon_sym_DQUOTE] = ACTIONS(2689),
    [anon_sym_AT_DQUOTE] = ACTIONS(2691),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2691),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2691),
    [sym_bool] = ACTIONS(2689),
    [sym_unit] = ACTIONS(2691),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2689),
    [sym_op_identifier] = ACTIONS(2689),
    [anon_sym_PLUS] = ACTIONS(2689),
    [anon_sym_DASH] = ACTIONS(2689),
    [anon_sym_PLUS_DOT] = ACTIONS(2689),
    [anon_sym_DASH_DOT] = ACTIONS(2689),
    [anon_sym_PERCENT] = ACTIONS(2689),
    [anon_sym_AMP_AMP] = ACTIONS(2689),
    [anon_sym_TILDE] = ACTIONS(2691),
    [aux_sym_prefix_op_token1] = ACTIONS(2689),
    [aux_sym_infix_op_token1] = ACTIONS(2691),
    [aux_sym_infix_op_token2] = ACTIONS(2689),
    [anon_sym_PIPE_PIPE] = ACTIONS(2689),
    [anon_sym_BANG_EQ] = ACTIONS(2689),
    [anon_sym_COLON_EQ] = ACTIONS(2691),
    [anon_sym_DOLLAR] = ACTIONS(2689),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2689),
    [sym_int] = ACTIONS(2689),
    [sym_xint] = ACTIONS(2691),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2691),
    [sym__newline] = ACTIONS(3198),
  },
  [984] = {
    [sym_type_arguments] = STATE(1277),
    [sym_long_identifier] = STATE(1255),
    [sym_block_comment] = STATE(984),
    [sym_compiler_directive_decl] = STATE(984),
    [sym_fsi_directive_decl] = STATE(984),
    [sym_preproc_line] = STATE(984),
    [aux_sym_compound_type_repeat1] = STATE(1121),
    [sym_identifier] = ACTIONS(3173),
    [anon_sym_EQ] = ACTIONS(2240),
    [anon_sym_COLON] = ACTIONS(2242),
    [anon_sym_return] = ACTIONS(2242),
    [anon_sym_do] = ACTIONS(2242),
    [anon_sym_and] = ACTIONS(2242),
    [anon_sym_let] = ACTIONS(2242),
    [anon_sym_let_BANG] = ACTIONS(2240),
    [anon_sym_LPAREN] = ACTIONS(2242),
    [anon_sym_COMMA] = ACTIONS(2240),
    [anon_sym_null] = ACTIONS(2242),
    [anon_sym_QMARK] = ACTIONS(2242),
    [anon_sym_COLON_QMARK] = ACTIONS(2242),
    [anon_sym_COLON_COLON] = ACTIONS(2240),
    [anon_sym_AMP] = ACTIONS(2242),
    [anon_sym_LBRACK] = ACTIONS(2242),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2240),
    [anon_sym_LBRACE] = ACTIONS(2242),
    [anon_sym_LT_AT] = ACTIONS(2242),
    [anon_sym_LT_AT_AT] = ACTIONS(2242),
    [anon_sym_DOT] = ACTIONS(2242),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2240),
    [anon_sym_new] = ACTIONS(2242),
    [anon_sym_return_BANG] = ACTIONS(2240),
    [anon_sym_yield] = ACTIONS(2242),
    [anon_sym_yield_BANG] = ACTIONS(2240),
    [anon_sym_lazy] = ACTIONS(2242),
    [anon_sym_assert] = ACTIONS(2242),
    [anon_sym_upcast] = ACTIONS(2242),
    [anon_sym_downcast] = ACTIONS(2242),
    [anon_sym_COLON_GT] = ACTIONS(2240),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2240),
    [anon_sym_for] = ACTIONS(2242),
    [anon_sym_while] = ACTIONS(2242),
    [anon_sym_if] = ACTIONS(2242),
    [anon_sym_fun] = ACTIONS(2242),
    [anon_sym_DASH_GT] = ACTIONS(3175),
    [anon_sym_try] = ACTIONS(2242),
    [anon_sym_match] = ACTIONS(2242),
    [anon_sym_match_BANG] = ACTIONS(2240),
    [anon_sym_function] = ACTIONS(2242),
    [anon_sym_LT_DASH] = ACTIONS(2242),
    [anon_sym_DOT_LBRACK] = ACTIONS(2240),
    [anon_sym_LT] = ACTIONS(2240),
    [anon_sym_use] = ACTIONS(2242),
    [anon_sym_use_BANG] = ACTIONS(2240),
    [anon_sym_do_BANG] = ACTIONS(2240),
    [anon_sym_begin] = ACTIONS(2242),
    [anon_sym_LPAREN2] = ACTIONS(2242),
    [anon_sym_STAR] = ACTIONS(3177),
    [anon_sym_LT2] = ACTIONS(3179),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3181),
    [anon_sym_or] = ACTIONS(2242),
    [aux_sym_char_token1] = ACTIONS(2240),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2242),
    [anon_sym_DQUOTE] = ACTIONS(2242),
    [anon_sym_AT_DQUOTE] = ACTIONS(2240),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2240),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2240),
    [sym_bool] = ACTIONS(2242),
    [sym_unit] = ACTIONS(2240),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2242),
    [sym_op_identifier] = ACTIONS(2242),
    [anon_sym_PLUS] = ACTIONS(2242),
    [anon_sym_DASH] = ACTIONS(2242),
    [anon_sym_PLUS_DOT] = ACTIONS(2242),
    [anon_sym_DASH_DOT] = ACTIONS(2242),
    [anon_sym_PERCENT] = ACTIONS(2242),
    [anon_sym_AMP_AMP] = ACTIONS(2242),
    [anon_sym_TILDE] = ACTIONS(2240),
    [aux_sym_prefix_op_token1] = ACTIONS(2242),
    [aux_sym_infix_op_token1] = ACTIONS(2240),
    [aux_sym_infix_op_token2] = ACTIONS(2242),
    [anon_sym_PIPE_PIPE] = ACTIONS(2242),
    [anon_sym_BANG_EQ] = ACTIONS(2242),
    [anon_sym_COLON_EQ] = ACTIONS(2240),
    [anon_sym_DOLLAR] = ACTIONS(2242),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2242),
    [sym_int] = ACTIONS(2242),
    [sym_xint] = ACTIONS(2240),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2240),
    [sym__newline] = ACTIONS(2240),
    [sym__dedent] = ACTIONS(2240),
  },
  [985] = {
    [sym_block_comment] = STATE(985),
    [sym_compiler_directive_decl] = STATE(985),
    [sym_fsi_directive_decl] = STATE(985),
    [sym_preproc_line] = STATE(985),
    [sym_identifier] = ACTIONS(2748),
    [anon_sym_EQ] = ACTIONS(2750),
    [anon_sym_GT_RBRACK] = ACTIONS(2750),
    [anon_sym_COLON] = ACTIONS(2748),
    [anon_sym_return] = ACTIONS(2748),
    [anon_sym_do] = ACTIONS(2748),
    [anon_sym_let] = ACTIONS(2748),
    [anon_sym_let_BANG] = ACTIONS(2750),
    [anon_sym_LPAREN] = ACTIONS(2748),
    [anon_sym_COMMA] = ACTIONS(2750),
    [anon_sym_null] = ACTIONS(2748),
    [anon_sym_QMARK] = ACTIONS(2748),
    [anon_sym_COLON_QMARK] = ACTIONS(2748),
    [anon_sym_COLON_COLON] = ACTIONS(2750),
    [anon_sym_AMP] = ACTIONS(2748),
    [anon_sym_LBRACK] = ACTIONS(2748),
    [anon_sym_RBRACK] = ACTIONS(2750),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2750),
    [anon_sym_LBRACE] = ACTIONS(2748),
    [anon_sym_RBRACE] = ACTIONS(2750),
    [anon_sym_LT_AT] = ACTIONS(2748),
    [anon_sym_LT_AT_AT] = ACTIONS(2748),
    [anon_sym_DOT] = ACTIONS(2748),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2750),
    [anon_sym_new] = ACTIONS(2748),
    [anon_sym_with] = ACTIONS(2748),
    [anon_sym_return_BANG] = ACTIONS(2750),
    [anon_sym_yield] = ACTIONS(2748),
    [anon_sym_yield_BANG] = ACTIONS(2750),
    [anon_sym_lazy] = ACTIONS(2748),
    [anon_sym_assert] = ACTIONS(2748),
    [anon_sym_upcast] = ACTIONS(2748),
    [anon_sym_downcast] = ACTIONS(2748),
    [anon_sym_COLON_GT] = ACTIONS(2750),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2750),
    [anon_sym_for] = ACTIONS(2748),
    [anon_sym_to] = ACTIONS(2748),
    [anon_sym_downto] = ACTIONS(2748),
    [anon_sym_while] = ACTIONS(2748),
    [anon_sym_else] = ACTIONS(2748),
    [anon_sym_elif] = ACTIONS(2748),
    [anon_sym_if] = ACTIONS(2748),
    [anon_sym_fun] = ACTIONS(2748),
    [anon_sym_try] = ACTIONS(2748),
    [anon_sym_match] = ACTIONS(2748),
    [anon_sym_match_BANG] = ACTIONS(2750),
    [anon_sym_function] = ACTIONS(2748),
    [anon_sym_LT_DASH] = ACTIONS(2748),
    [anon_sym_DOT_LBRACK] = ACTIONS(2750),
    [anon_sym_LT] = ACTIONS(2750),
    [anon_sym_use] = ACTIONS(2748),
    [anon_sym_use_BANG] = ACTIONS(2750),
    [anon_sym_do_BANG] = ACTIONS(2750),
    [anon_sym_begin] = ACTIONS(2748),
    [anon_sym_LPAREN2] = ACTIONS(2748),
    [anon_sym_DOT_DOT2] = ACTIONS(2750),
    [anon_sym_or] = ACTIONS(2748),
    [aux_sym_char_token1] = ACTIONS(2750),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2748),
    [anon_sym_DQUOTE] = ACTIONS(2748),
    [anon_sym_AT_DQUOTE] = ACTIONS(2750),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2750),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2750),
    [sym_bool] = ACTIONS(2748),
    [sym_unit] = ACTIONS(2750),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2748),
    [sym_op_identifier] = ACTIONS(2748),
    [anon_sym_PLUS] = ACTIONS(2748),
    [anon_sym_DASH] = ACTIONS(2748),
    [anon_sym_PLUS_DOT] = ACTIONS(2748),
    [anon_sym_DASH_DOT] = ACTIONS(2748),
    [anon_sym_PERCENT] = ACTIONS(2748),
    [anon_sym_AMP_AMP] = ACTIONS(2748),
    [anon_sym_TILDE] = ACTIONS(2750),
    [aux_sym_prefix_op_token1] = ACTIONS(2748),
    [aux_sym_infix_op_token1] = ACTIONS(2750),
    [aux_sym_infix_op_token2] = ACTIONS(2748),
    [anon_sym_PIPE_PIPE] = ACTIONS(2748),
    [anon_sym_BANG_EQ] = ACTIONS(2748),
    [anon_sym_COLON_EQ] = ACTIONS(2750),
    [anon_sym_DOLLAR] = ACTIONS(2748),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2748),
    [sym_int] = ACTIONS(2748),
    [sym_xint] = ACTIONS(2750),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2750),
    [sym__newline] = ACTIONS(2750),
  },
  [986] = {
    [sym_type_arguments] = STATE(1175),
    [sym_long_identifier] = STATE(1226),
    [sym_block_comment] = STATE(986),
    [sym_compiler_directive_decl] = STATE(986),
    [sym_fsi_directive_decl] = STATE(986),
    [sym_preproc_line] = STATE(986),
    [aux_sym_compound_type_repeat1] = STATE(1061),
    [sym_identifier] = ACTIONS(3188),
    [anon_sym_EQ] = ACTIONS(2240),
    [anon_sym_COLON] = ACTIONS(2242),
    [anon_sym_return] = ACTIONS(2242),
    [anon_sym_do] = ACTIONS(2242),
    [anon_sym_let] = ACTIONS(2242),
    [anon_sym_let_BANG] = ACTIONS(2240),
    [anon_sym_as] = ACTIONS(2242),
    [anon_sym_LPAREN] = ACTIONS(2242),
    [anon_sym_COMMA] = ACTIONS(2240),
    [anon_sym_null] = ACTIONS(2242),
    [anon_sym_QMARK] = ACTIONS(2242),
    [anon_sym_COLON_QMARK] = ACTIONS(2242),
    [anon_sym_COLON_COLON] = ACTIONS(2240),
    [anon_sym_AMP] = ACTIONS(2242),
    [anon_sym_LBRACK] = ACTIONS(2242),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2240),
    [anon_sym_LBRACE] = ACTIONS(2242),
    [anon_sym_LT_AT] = ACTIONS(2242),
    [anon_sym_LT_AT_AT] = ACTIONS(2242),
    [anon_sym_DOT] = ACTIONS(2242),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2240),
    [anon_sym_new] = ACTIONS(2242),
    [anon_sym_with] = ACTIONS(2242),
    [anon_sym_return_BANG] = ACTIONS(2240),
    [anon_sym_yield] = ACTIONS(2242),
    [anon_sym_yield_BANG] = ACTIONS(2240),
    [anon_sym_lazy] = ACTIONS(2242),
    [anon_sym_assert] = ACTIONS(2242),
    [anon_sym_upcast] = ACTIONS(2242),
    [anon_sym_downcast] = ACTIONS(2242),
    [anon_sym_COLON_GT] = ACTIONS(2240),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2240),
    [anon_sym_for] = ACTIONS(2242),
    [anon_sym_while] = ACTIONS(2242),
    [anon_sym_if] = ACTIONS(2242),
    [anon_sym_fun] = ACTIONS(2242),
    [anon_sym_DASH_GT] = ACTIONS(3190),
    [anon_sym_try] = ACTIONS(2242),
    [anon_sym_match] = ACTIONS(2242),
    [anon_sym_match_BANG] = ACTIONS(2240),
    [anon_sym_function] = ACTIONS(2242),
    [anon_sym_LT_DASH] = ACTIONS(2242),
    [anon_sym_DOT_LBRACK] = ACTIONS(2240),
    [anon_sym_LT] = ACTIONS(2240),
    [anon_sym_use] = ACTIONS(2242),
    [anon_sym_use_BANG] = ACTIONS(2240),
    [anon_sym_do_BANG] = ACTIONS(2240),
    [anon_sym_begin] = ACTIONS(2242),
    [anon_sym_LPAREN2] = ACTIONS(2242),
    [anon_sym_STAR] = ACTIONS(3192),
    [anon_sym_LT2] = ACTIONS(3194),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3196),
    [anon_sym_or] = ACTIONS(2242),
    [aux_sym_char_token1] = ACTIONS(2240),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2242),
    [anon_sym_DQUOTE] = ACTIONS(2242),
    [anon_sym_AT_DQUOTE] = ACTIONS(2240),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2240),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2240),
    [sym_bool] = ACTIONS(2242),
    [sym_unit] = ACTIONS(2240),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2242),
    [sym_op_identifier] = ACTIONS(2242),
    [anon_sym_PLUS] = ACTIONS(2242),
    [anon_sym_DASH] = ACTIONS(2242),
    [anon_sym_PLUS_DOT] = ACTIONS(2242),
    [anon_sym_DASH_DOT] = ACTIONS(2242),
    [anon_sym_PERCENT] = ACTIONS(2242),
    [anon_sym_AMP_AMP] = ACTIONS(2242),
    [anon_sym_TILDE] = ACTIONS(2240),
    [aux_sym_prefix_op_token1] = ACTIONS(2242),
    [aux_sym_infix_op_token1] = ACTIONS(2240),
    [aux_sym_infix_op_token2] = ACTIONS(2242),
    [anon_sym_PIPE_PIPE] = ACTIONS(2242),
    [anon_sym_BANG_EQ] = ACTIONS(2242),
    [anon_sym_COLON_EQ] = ACTIONS(2240),
    [anon_sym_DOLLAR] = ACTIONS(2242),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2242),
    [sym_int] = ACTIONS(2242),
    [sym_xint] = ACTIONS(2240),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2240),
    [sym__newline] = ACTIONS(2240),
  },
  [987] = {
    [sym_block_comment] = STATE(987),
    [sym_compiler_directive_decl] = STATE(987),
    [sym_fsi_directive_decl] = STATE(987),
    [sym_preproc_line] = STATE(987),
    [aux_sym_rules_repeat1] = STATE(966),
    [sym_identifier] = ACTIONS(2737),
    [anon_sym_EQ] = ACTIONS(2739),
    [anon_sym_GT_RBRACK] = ACTIONS(2739),
    [anon_sym_COLON] = ACTIONS(2737),
    [anon_sym_return] = ACTIONS(2737),
    [anon_sym_do] = ACTIONS(2737),
    [anon_sym_let] = ACTIONS(2737),
    [anon_sym_let_BANG] = ACTIONS(2739),
    [anon_sym_LPAREN] = ACTIONS(2737),
    [anon_sym_COMMA] = ACTIONS(2739),
    [anon_sym_null] = ACTIONS(2737),
    [anon_sym_QMARK] = ACTIONS(2737),
    [anon_sym_COLON_QMARK] = ACTIONS(2737),
    [anon_sym_COLON_COLON] = ACTIONS(2739),
    [anon_sym_PIPE] = ACTIONS(3183),
    [anon_sym_AMP] = ACTIONS(2737),
    [anon_sym_LBRACK] = ACTIONS(2737),
    [anon_sym_RBRACK] = ACTIONS(2739),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2739),
    [anon_sym_LBRACE] = ACTIONS(2737),
    [anon_sym_RBRACE] = ACTIONS(2739),
    [anon_sym_LT_AT] = ACTIONS(2737),
    [anon_sym_LT_AT_AT] = ACTIONS(2737),
    [anon_sym_DOT] = ACTIONS(2737),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2739),
    [anon_sym_new] = ACTIONS(2737),
    [anon_sym_with] = ACTIONS(2737),
    [anon_sym_return_BANG] = ACTIONS(2739),
    [anon_sym_yield] = ACTIONS(2737),
    [anon_sym_yield_BANG] = ACTIONS(2739),
    [anon_sym_lazy] = ACTIONS(2737),
    [anon_sym_assert] = ACTIONS(2737),
    [anon_sym_upcast] = ACTIONS(2737),
    [anon_sym_downcast] = ACTIONS(2737),
    [anon_sym_COLON_GT] = ACTIONS(2739),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2739),
    [anon_sym_for] = ACTIONS(2737),
    [anon_sym_to] = ACTIONS(2737),
    [anon_sym_downto] = ACTIONS(2737),
    [anon_sym_while] = ACTIONS(2737),
    [anon_sym_if] = ACTIONS(2737),
    [anon_sym_fun] = ACTIONS(2737),
    [anon_sym_try] = ACTIONS(2737),
    [anon_sym_match] = ACTIONS(2737),
    [anon_sym_match_BANG] = ACTIONS(2739),
    [anon_sym_function] = ACTIONS(2737),
    [anon_sym_LT_DASH] = ACTIONS(2737),
    [anon_sym_DOT_LBRACK] = ACTIONS(2739),
    [anon_sym_LT] = ACTIONS(2739),
    [anon_sym_use] = ACTIONS(2737),
    [anon_sym_use_BANG] = ACTIONS(2739),
    [anon_sym_do_BANG] = ACTIONS(2739),
    [anon_sym_begin] = ACTIONS(2737),
    [anon_sym_LPAREN2] = ACTIONS(2737),
    [anon_sym_DOT_DOT2] = ACTIONS(2739),
    [anon_sym_or] = ACTIONS(2737),
    [aux_sym_char_token1] = ACTIONS(2739),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2737),
    [anon_sym_DQUOTE] = ACTIONS(2737),
    [anon_sym_AT_DQUOTE] = ACTIONS(2739),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2739),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2739),
    [sym_bool] = ACTIONS(2737),
    [sym_unit] = ACTIONS(2739),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2737),
    [sym_op_identifier] = ACTIONS(2737),
    [anon_sym_PLUS] = ACTIONS(2737),
    [anon_sym_DASH] = ACTIONS(2737),
    [anon_sym_PLUS_DOT] = ACTIONS(2737),
    [anon_sym_DASH_DOT] = ACTIONS(2737),
    [anon_sym_PERCENT] = ACTIONS(2737),
    [anon_sym_AMP_AMP] = ACTIONS(2737),
    [anon_sym_TILDE] = ACTIONS(2739),
    [aux_sym_prefix_op_token1] = ACTIONS(2737),
    [aux_sym_infix_op_token1] = ACTIONS(2739),
    [aux_sym_infix_op_token2] = ACTIONS(2737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2737),
    [anon_sym_BANG_EQ] = ACTIONS(2737),
    [anon_sym_COLON_EQ] = ACTIONS(2739),
    [anon_sym_DOLLAR] = ACTIONS(2737),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2737),
    [sym_int] = ACTIONS(2737),
    [sym_xint] = ACTIONS(2739),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2739),
    [sym__newline] = ACTIONS(3201),
  },
  [988] = {
    [sym_block_comment] = STATE(988),
    [sym_compiler_directive_decl] = STATE(988),
    [sym_fsi_directive_decl] = STATE(988),
    [sym_preproc_line] = STATE(988),
    [sym_identifier] = ACTIONS(2723),
    [anon_sym_EQ] = ACTIONS(2725),
    [anon_sym_GT_RBRACK] = ACTIONS(2725),
    [anon_sym_COLON] = ACTIONS(2723),
    [anon_sym_return] = ACTIONS(2723),
    [anon_sym_do] = ACTIONS(2723),
    [anon_sym_let] = ACTIONS(2723),
    [anon_sym_let_BANG] = ACTIONS(2725),
    [anon_sym_LPAREN] = ACTIONS(2723),
    [anon_sym_COMMA] = ACTIONS(2725),
    [anon_sym_null] = ACTIONS(2723),
    [anon_sym_QMARK] = ACTIONS(2723),
    [anon_sym_COLON_QMARK] = ACTIONS(2723),
    [anon_sym_COLON_COLON] = ACTIONS(2725),
    [anon_sym_AMP] = ACTIONS(2723),
    [anon_sym_LBRACK] = ACTIONS(2723),
    [anon_sym_RBRACK] = ACTIONS(2725),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2725),
    [anon_sym_LBRACE] = ACTIONS(2723),
    [anon_sym_RBRACE] = ACTIONS(2725),
    [anon_sym_LT_AT] = ACTIONS(2723),
    [anon_sym_LT_AT_AT] = ACTIONS(2723),
    [anon_sym_DOT] = ACTIONS(2723),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2725),
    [anon_sym_new] = ACTIONS(2723),
    [anon_sym_with] = ACTIONS(2723),
    [anon_sym_return_BANG] = ACTIONS(2725),
    [anon_sym_yield] = ACTIONS(2723),
    [anon_sym_yield_BANG] = ACTIONS(2725),
    [anon_sym_lazy] = ACTIONS(2723),
    [anon_sym_assert] = ACTIONS(2723),
    [anon_sym_upcast] = ACTIONS(2723),
    [anon_sym_downcast] = ACTIONS(2723),
    [anon_sym_COLON_GT] = ACTIONS(2725),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2725),
    [anon_sym_for] = ACTIONS(2723),
    [anon_sym_to] = ACTIONS(2723),
    [anon_sym_downto] = ACTIONS(2723),
    [anon_sym_while] = ACTIONS(2723),
    [anon_sym_if] = ACTIONS(2723),
    [anon_sym_fun] = ACTIONS(2723),
    [anon_sym_try] = ACTIONS(2723),
    [anon_sym_match] = ACTIONS(2723),
    [anon_sym_match_BANG] = ACTIONS(2725),
    [anon_sym_function] = ACTIONS(2723),
    [anon_sym_LT_DASH] = ACTIONS(2723),
    [anon_sym_DOT_LBRACK] = ACTIONS(2725),
    [anon_sym_LT] = ACTIONS(2725),
    [anon_sym_use] = ACTIONS(2723),
    [anon_sym_use_BANG] = ACTIONS(2725),
    [anon_sym_do_BANG] = ACTIONS(2725),
    [anon_sym_begin] = ACTIONS(2723),
    [anon_sym_LPAREN2] = ACTIONS(2723),
    [anon_sym_DOT_DOT2] = ACTIONS(2725),
    [anon_sym_or] = ACTIONS(2723),
    [aux_sym_char_token1] = ACTIONS(2725),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2723),
    [anon_sym_DQUOTE] = ACTIONS(2723),
    [anon_sym_AT_DQUOTE] = ACTIONS(2725),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2725),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2725),
    [sym_bool] = ACTIONS(2723),
    [sym_unit] = ACTIONS(2725),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2723),
    [sym_op_identifier] = ACTIONS(2723),
    [anon_sym_PLUS] = ACTIONS(2723),
    [anon_sym_DASH] = ACTIONS(2723),
    [anon_sym_PLUS_DOT] = ACTIONS(2723),
    [anon_sym_DASH_DOT] = ACTIONS(2723),
    [anon_sym_PERCENT] = ACTIONS(2723),
    [anon_sym_AMP_AMP] = ACTIONS(2723),
    [anon_sym_TILDE] = ACTIONS(2725),
    [aux_sym_prefix_op_token1] = ACTIONS(2723),
    [aux_sym_infix_op_token1] = ACTIONS(2725),
    [aux_sym_infix_op_token2] = ACTIONS(2723),
    [anon_sym_PIPE_PIPE] = ACTIONS(2723),
    [anon_sym_BANG_EQ] = ACTIONS(2723),
    [anon_sym_COLON_EQ] = ACTIONS(2725),
    [anon_sym_DOLLAR] = ACTIONS(2723),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2723),
    [sym_int] = ACTIONS(2723),
    [sym_xint] = ACTIONS(2725),
    [anon_sym_f] = ACTIONS(2723),
    [aux_sym_decimal_token1] = ACTIONS(2723),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2725),
    [sym__newline] = ACTIONS(2725),
  },
  [989] = {
    [sym_type_arguments] = STATE(1272),
    [sym_long_identifier] = STATE(1184),
    [sym_block_comment] = STATE(989),
    [sym_compiler_directive_decl] = STATE(989),
    [sym_fsi_directive_decl] = STATE(989),
    [sym_preproc_line] = STATE(989),
    [aux_sym_compound_type_repeat1] = STATE(1115),
    [sym_identifier] = ACTIONS(3155),
    [anon_sym_EQ] = ACTIONS(2240),
    [anon_sym_COLON] = ACTIONS(2242),
    [anon_sym_return] = ACTIONS(2242),
    [anon_sym_do] = ACTIONS(2242),
    [anon_sym_let] = ACTIONS(2242),
    [anon_sym_let_BANG] = ACTIONS(2240),
    [anon_sym_LPAREN] = ACTIONS(2242),
    [anon_sym_COMMA] = ACTIONS(2240),
    [anon_sym_null] = ACTIONS(2242),
    [anon_sym_QMARK] = ACTIONS(2242),
    [anon_sym_COLON_QMARK] = ACTIONS(2242),
    [anon_sym_COLON_COLON] = ACTIONS(2240),
    [anon_sym_AMP] = ACTIONS(2242),
    [anon_sym_LBRACK] = ACTIONS(2242),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2240),
    [anon_sym_LBRACE] = ACTIONS(2242),
    [anon_sym_LT_AT] = ACTIONS(2242),
    [anon_sym_LT_AT_AT] = ACTIONS(2242),
    [anon_sym_DOT] = ACTIONS(2242),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2240),
    [anon_sym_new] = ACTIONS(2242),
    [anon_sym_return_BANG] = ACTIONS(2240),
    [anon_sym_yield] = ACTIONS(2242),
    [anon_sym_yield_BANG] = ACTIONS(2240),
    [anon_sym_lazy] = ACTIONS(2242),
    [anon_sym_assert] = ACTIONS(2242),
    [anon_sym_upcast] = ACTIONS(2242),
    [anon_sym_downcast] = ACTIONS(2242),
    [anon_sym_COLON_GT] = ACTIONS(2240),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2240),
    [anon_sym_for] = ACTIONS(2242),
    [anon_sym_while] = ACTIONS(2242),
    [anon_sym_if] = ACTIONS(2242),
    [anon_sym_fun] = ACTIONS(2242),
    [anon_sym_DASH_GT] = ACTIONS(3157),
    [anon_sym_try] = ACTIONS(2242),
    [anon_sym_match] = ACTIONS(2242),
    [anon_sym_match_BANG] = ACTIONS(2240),
    [anon_sym_function] = ACTIONS(2242),
    [anon_sym_LT_DASH] = ACTIONS(2242),
    [anon_sym_DOT_LBRACK] = ACTIONS(2240),
    [anon_sym_LT] = ACTIONS(2240),
    [anon_sym_use] = ACTIONS(2242),
    [anon_sym_use_BANG] = ACTIONS(2240),
    [anon_sym_do_BANG] = ACTIONS(2240),
    [anon_sym_begin] = ACTIONS(2242),
    [anon_sym_LPAREN2] = ACTIONS(2242),
    [anon_sym_STAR] = ACTIONS(3159),
    [anon_sym_LT2] = ACTIONS(3161),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3163),
    [anon_sym_or] = ACTIONS(2242),
    [aux_sym_char_token1] = ACTIONS(2240),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2242),
    [anon_sym_DQUOTE] = ACTIONS(2242),
    [anon_sym_AT_DQUOTE] = ACTIONS(2240),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2240),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2240),
    [sym_bool] = ACTIONS(2242),
    [sym_unit] = ACTIONS(2240),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2242),
    [sym_op_identifier] = ACTIONS(2242),
    [anon_sym_PLUS] = ACTIONS(2242),
    [anon_sym_DASH] = ACTIONS(2242),
    [anon_sym_PLUS_DOT] = ACTIONS(2242),
    [anon_sym_DASH_DOT] = ACTIONS(2242),
    [anon_sym_PERCENT] = ACTIONS(2242),
    [anon_sym_AMP_AMP] = ACTIONS(2242),
    [anon_sym_TILDE] = ACTIONS(2240),
    [aux_sym_prefix_op_token1] = ACTIONS(2242),
    [aux_sym_infix_op_token1] = ACTIONS(2240),
    [aux_sym_infix_op_token2] = ACTIONS(2242),
    [anon_sym_PIPE_PIPE] = ACTIONS(2242),
    [anon_sym_BANG_EQ] = ACTIONS(2242),
    [anon_sym_COLON_EQ] = ACTIONS(2240),
    [anon_sym_DOLLAR] = ACTIONS(2242),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2242),
    [sym_int] = ACTIONS(2242),
    [sym_xint] = ACTIONS(2240),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2240),
    [anon_sym_POUNDendif] = ACTIONS(2240),
    [anon_sym_POUNDelse] = ACTIONS(2240),
    [sym__newline] = ACTIONS(2240),
  },
  [990] = {
    [sym_type_arguments] = STATE(1272),
    [sym_long_identifier] = STATE(1184),
    [sym_block_comment] = STATE(990),
    [sym_compiler_directive_decl] = STATE(990),
    [sym_fsi_directive_decl] = STATE(990),
    [sym_preproc_line] = STATE(990),
    [aux_sym_compound_type_repeat1] = STATE(1115),
    [sym_identifier] = ACTIONS(3155),
    [anon_sym_EQ] = ACTIONS(2228),
    [anon_sym_COLON] = ACTIONS(2230),
    [anon_sym_return] = ACTIONS(2230),
    [anon_sym_do] = ACTIONS(2230),
    [anon_sym_let] = ACTIONS(2230),
    [anon_sym_let_BANG] = ACTIONS(2228),
    [anon_sym_LPAREN] = ACTIONS(2230),
    [anon_sym_COMMA] = ACTIONS(2228),
    [anon_sym_null] = ACTIONS(2230),
    [anon_sym_QMARK] = ACTIONS(2230),
    [anon_sym_COLON_QMARK] = ACTIONS(2230),
    [anon_sym_COLON_COLON] = ACTIONS(2228),
    [anon_sym_AMP] = ACTIONS(2230),
    [anon_sym_LBRACK] = ACTIONS(2230),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2228),
    [anon_sym_LBRACE] = ACTIONS(2230),
    [anon_sym_LT_AT] = ACTIONS(2230),
    [anon_sym_LT_AT_AT] = ACTIONS(2230),
    [anon_sym_DOT] = ACTIONS(2230),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2228),
    [anon_sym_new] = ACTIONS(2230),
    [anon_sym_return_BANG] = ACTIONS(2228),
    [anon_sym_yield] = ACTIONS(2230),
    [anon_sym_yield_BANG] = ACTIONS(2228),
    [anon_sym_lazy] = ACTIONS(2230),
    [anon_sym_assert] = ACTIONS(2230),
    [anon_sym_upcast] = ACTIONS(2230),
    [anon_sym_downcast] = ACTIONS(2230),
    [anon_sym_COLON_GT] = ACTIONS(2228),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2228),
    [anon_sym_for] = ACTIONS(2230),
    [anon_sym_while] = ACTIONS(2230),
    [anon_sym_if] = ACTIONS(2230),
    [anon_sym_fun] = ACTIONS(2230),
    [anon_sym_DASH_GT] = ACTIONS(3157),
    [anon_sym_try] = ACTIONS(2230),
    [anon_sym_match] = ACTIONS(2230),
    [anon_sym_match_BANG] = ACTIONS(2228),
    [anon_sym_function] = ACTIONS(2230),
    [anon_sym_LT_DASH] = ACTIONS(2230),
    [anon_sym_DOT_LBRACK] = ACTIONS(2228),
    [anon_sym_LT] = ACTIONS(2228),
    [anon_sym_use] = ACTIONS(2230),
    [anon_sym_use_BANG] = ACTIONS(2228),
    [anon_sym_do_BANG] = ACTIONS(2228),
    [anon_sym_begin] = ACTIONS(2230),
    [anon_sym_LPAREN2] = ACTIONS(2230),
    [anon_sym_STAR] = ACTIONS(3159),
    [anon_sym_LT2] = ACTIONS(3161),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3163),
    [anon_sym_or] = ACTIONS(2230),
    [aux_sym_char_token1] = ACTIONS(2228),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2230),
    [anon_sym_DQUOTE] = ACTIONS(2230),
    [anon_sym_AT_DQUOTE] = ACTIONS(2228),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2228),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2228),
    [sym_bool] = ACTIONS(2230),
    [sym_unit] = ACTIONS(2228),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2230),
    [sym_op_identifier] = ACTIONS(2230),
    [anon_sym_PLUS] = ACTIONS(2230),
    [anon_sym_DASH] = ACTIONS(2230),
    [anon_sym_PLUS_DOT] = ACTIONS(2230),
    [anon_sym_DASH_DOT] = ACTIONS(2230),
    [anon_sym_PERCENT] = ACTIONS(2230),
    [anon_sym_AMP_AMP] = ACTIONS(2230),
    [anon_sym_TILDE] = ACTIONS(2228),
    [aux_sym_prefix_op_token1] = ACTIONS(2230),
    [aux_sym_infix_op_token1] = ACTIONS(2228),
    [aux_sym_infix_op_token2] = ACTIONS(2230),
    [anon_sym_PIPE_PIPE] = ACTIONS(2230),
    [anon_sym_BANG_EQ] = ACTIONS(2230),
    [anon_sym_COLON_EQ] = ACTIONS(2228),
    [anon_sym_DOLLAR] = ACTIONS(2230),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2230),
    [sym_int] = ACTIONS(2230),
    [sym_xint] = ACTIONS(2228),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2228),
    [anon_sym_POUNDendif] = ACTIONS(2228),
    [anon_sym_POUNDelse] = ACTIONS(2228),
    [sym__newline] = ACTIONS(2228),
  },
  [991] = {
    [sym_block_comment] = STATE(991),
    [sym_compiler_directive_decl] = STATE(991),
    [sym_fsi_directive_decl] = STATE(991),
    [sym_preproc_line] = STATE(991),
    [sym_identifier] = ACTIONS(2812),
    [anon_sym_EQ] = ACTIONS(2814),
    [anon_sym_GT_RBRACK] = ACTIONS(2814),
    [anon_sym_COLON] = ACTIONS(2812),
    [anon_sym_return] = ACTIONS(2812),
    [anon_sym_do] = ACTIONS(2812),
    [anon_sym_let] = ACTIONS(2812),
    [anon_sym_let_BANG] = ACTIONS(2814),
    [anon_sym_LPAREN] = ACTIONS(2812),
    [anon_sym_COMMA] = ACTIONS(2814),
    [anon_sym_null] = ACTIONS(2812),
    [anon_sym_QMARK] = ACTIONS(2812),
    [anon_sym_COLON_QMARK] = ACTIONS(2812),
    [anon_sym_COLON_COLON] = ACTIONS(2814),
    [anon_sym_AMP] = ACTIONS(2812),
    [anon_sym_LBRACK] = ACTIONS(2812),
    [anon_sym_RBRACK] = ACTIONS(2814),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2814),
    [anon_sym_LBRACE] = ACTIONS(2812),
    [anon_sym_RBRACE] = ACTIONS(2814),
    [anon_sym_LT_AT] = ACTIONS(2812),
    [anon_sym_LT_AT_AT] = ACTIONS(2812),
    [anon_sym_DOT] = ACTIONS(2812),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2814),
    [anon_sym_new] = ACTIONS(2812),
    [anon_sym_with] = ACTIONS(2812),
    [anon_sym_return_BANG] = ACTIONS(2814),
    [anon_sym_yield] = ACTIONS(2812),
    [anon_sym_yield_BANG] = ACTIONS(2814),
    [anon_sym_lazy] = ACTIONS(2812),
    [anon_sym_assert] = ACTIONS(2812),
    [anon_sym_upcast] = ACTIONS(2812),
    [anon_sym_downcast] = ACTIONS(2812),
    [anon_sym_COLON_GT] = ACTIONS(2814),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2814),
    [anon_sym_for] = ACTIONS(2812),
    [anon_sym_to] = ACTIONS(2812),
    [anon_sym_downto] = ACTIONS(2812),
    [anon_sym_while] = ACTIONS(2812),
    [anon_sym_if] = ACTIONS(2812),
    [anon_sym_fun] = ACTIONS(2812),
    [anon_sym_try] = ACTIONS(2812),
    [anon_sym_match] = ACTIONS(2812),
    [anon_sym_match_BANG] = ACTIONS(2814),
    [anon_sym_function] = ACTIONS(2812),
    [anon_sym_LT_DASH] = ACTIONS(2812),
    [anon_sym_DOT_LBRACK] = ACTIONS(2814),
    [anon_sym_LT] = ACTIONS(2814),
    [anon_sym_use] = ACTIONS(2812),
    [anon_sym_use_BANG] = ACTIONS(2814),
    [anon_sym_do_BANG] = ACTIONS(2814),
    [anon_sym_begin] = ACTIONS(2812),
    [anon_sym_LPAREN2] = ACTIONS(2812),
    [anon_sym_DOT_DOT2] = ACTIONS(2814),
    [anon_sym_or] = ACTIONS(2812),
    [aux_sym_char_token1] = ACTIONS(2814),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2812),
    [anon_sym_DQUOTE] = ACTIONS(2812),
    [anon_sym_AT_DQUOTE] = ACTIONS(2814),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2814),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2814),
    [sym_bool] = ACTIONS(2812),
    [sym_unit] = ACTIONS(2814),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2812),
    [sym_op_identifier] = ACTIONS(2812),
    [anon_sym_PLUS] = ACTIONS(2812),
    [anon_sym_DASH] = ACTIONS(2812),
    [anon_sym_PLUS_DOT] = ACTIONS(2812),
    [anon_sym_DASH_DOT] = ACTIONS(2812),
    [anon_sym_PERCENT] = ACTIONS(2812),
    [anon_sym_AMP_AMP] = ACTIONS(2812),
    [anon_sym_TILDE] = ACTIONS(2814),
    [aux_sym_prefix_op_token1] = ACTIONS(2812),
    [aux_sym_infix_op_token1] = ACTIONS(2814),
    [aux_sym_infix_op_token2] = ACTIONS(2812),
    [anon_sym_PIPE_PIPE] = ACTIONS(2812),
    [anon_sym_BANG_EQ] = ACTIONS(2812),
    [anon_sym_COLON_EQ] = ACTIONS(2814),
    [anon_sym_DOLLAR] = ACTIONS(2812),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2812),
    [sym_int] = ACTIONS(2812),
    [sym_xint] = ACTIONS(2814),
    [anon_sym_f] = ACTIONS(2812),
    [aux_sym_decimal_token1] = ACTIONS(2812),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2814),
    [sym__newline] = ACTIONS(2814),
  },
  [992] = {
    [sym_type_arguments] = STATE(1272),
    [sym_long_identifier] = STATE(1184),
    [sym_block_comment] = STATE(992),
    [sym_compiler_directive_decl] = STATE(992),
    [sym_fsi_directive_decl] = STATE(992),
    [sym_preproc_line] = STATE(992),
    [aux_sym_compound_type_repeat1] = STATE(1115),
    [sym_identifier] = ACTIONS(3155),
    [anon_sym_EQ] = ACTIONS(2244),
    [anon_sym_COLON] = ACTIONS(2246),
    [anon_sym_return] = ACTIONS(2246),
    [anon_sym_do] = ACTIONS(2246),
    [anon_sym_let] = ACTIONS(2246),
    [anon_sym_let_BANG] = ACTIONS(2244),
    [anon_sym_LPAREN] = ACTIONS(2246),
    [anon_sym_COMMA] = ACTIONS(2244),
    [anon_sym_null] = ACTIONS(2246),
    [anon_sym_QMARK] = ACTIONS(2246),
    [anon_sym_COLON_QMARK] = ACTIONS(2246),
    [anon_sym_COLON_COLON] = ACTIONS(2244),
    [anon_sym_AMP] = ACTIONS(2246),
    [anon_sym_LBRACK] = ACTIONS(2246),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2244),
    [anon_sym_LBRACE] = ACTIONS(2246),
    [anon_sym_LT_AT] = ACTIONS(2246),
    [anon_sym_LT_AT_AT] = ACTIONS(2246),
    [anon_sym_DOT] = ACTIONS(2246),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2244),
    [anon_sym_new] = ACTIONS(2246),
    [anon_sym_return_BANG] = ACTIONS(2244),
    [anon_sym_yield] = ACTIONS(2246),
    [anon_sym_yield_BANG] = ACTIONS(2244),
    [anon_sym_lazy] = ACTIONS(2246),
    [anon_sym_assert] = ACTIONS(2246),
    [anon_sym_upcast] = ACTIONS(2246),
    [anon_sym_downcast] = ACTIONS(2246),
    [anon_sym_COLON_GT] = ACTIONS(2244),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2244),
    [anon_sym_for] = ACTIONS(2246),
    [anon_sym_while] = ACTIONS(2246),
    [anon_sym_if] = ACTIONS(2246),
    [anon_sym_fun] = ACTIONS(2246),
    [anon_sym_DASH_GT] = ACTIONS(3157),
    [anon_sym_try] = ACTIONS(2246),
    [anon_sym_match] = ACTIONS(2246),
    [anon_sym_match_BANG] = ACTIONS(2244),
    [anon_sym_function] = ACTIONS(2246),
    [anon_sym_LT_DASH] = ACTIONS(2246),
    [anon_sym_DOT_LBRACK] = ACTIONS(2244),
    [anon_sym_LT] = ACTIONS(2244),
    [anon_sym_use] = ACTIONS(2246),
    [anon_sym_use_BANG] = ACTIONS(2244),
    [anon_sym_do_BANG] = ACTIONS(2244),
    [anon_sym_begin] = ACTIONS(2246),
    [anon_sym_LPAREN2] = ACTIONS(2246),
    [anon_sym_STAR] = ACTIONS(3159),
    [anon_sym_LT2] = ACTIONS(3161),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3163),
    [anon_sym_or] = ACTIONS(2246),
    [aux_sym_char_token1] = ACTIONS(2244),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2246),
    [anon_sym_DQUOTE] = ACTIONS(2246),
    [anon_sym_AT_DQUOTE] = ACTIONS(2244),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2244),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2244),
    [sym_bool] = ACTIONS(2246),
    [sym_unit] = ACTIONS(2244),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2246),
    [sym_op_identifier] = ACTIONS(2246),
    [anon_sym_PLUS] = ACTIONS(2246),
    [anon_sym_DASH] = ACTIONS(2246),
    [anon_sym_PLUS_DOT] = ACTIONS(2246),
    [anon_sym_DASH_DOT] = ACTIONS(2246),
    [anon_sym_PERCENT] = ACTIONS(2246),
    [anon_sym_AMP_AMP] = ACTIONS(2246),
    [anon_sym_TILDE] = ACTIONS(2244),
    [aux_sym_prefix_op_token1] = ACTIONS(2246),
    [aux_sym_infix_op_token1] = ACTIONS(2244),
    [aux_sym_infix_op_token2] = ACTIONS(2246),
    [anon_sym_PIPE_PIPE] = ACTIONS(2246),
    [anon_sym_BANG_EQ] = ACTIONS(2246),
    [anon_sym_COLON_EQ] = ACTIONS(2244),
    [anon_sym_DOLLAR] = ACTIONS(2246),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2246),
    [sym_int] = ACTIONS(2246),
    [sym_xint] = ACTIONS(2244),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2244),
    [anon_sym_POUNDendif] = ACTIONS(2244),
    [anon_sym_POUNDelse] = ACTIONS(2244),
    [sym__newline] = ACTIONS(2244),
  },
  [993] = {
    [sym_type_arguments] = STATE(1285),
    [sym_long_identifier] = STATE(1378),
    [sym_block_comment] = STATE(993),
    [sym_compiler_directive_decl] = STATE(993),
    [sym_fsi_directive_decl] = STATE(993),
    [sym_preproc_line] = STATE(993),
    [aux_sym_compound_type_repeat1] = STATE(1268),
    [sym_identifier] = ACTIONS(3204),
    [anon_sym_EQ] = ACTIONS(2228),
    [anon_sym_COLON] = ACTIONS(2230),
    [anon_sym_return] = ACTIONS(2230),
    [anon_sym_do] = ACTIONS(2230),
    [anon_sym_let] = ACTIONS(2230),
    [anon_sym_let_BANG] = ACTIONS(2228),
    [anon_sym_LPAREN] = ACTIONS(2230),
    [anon_sym_COMMA] = ACTIONS(2228),
    [anon_sym_null] = ACTIONS(2230),
    [anon_sym_QMARK] = ACTIONS(2230),
    [anon_sym_COLON_QMARK] = ACTIONS(2230),
    [anon_sym_COLON_COLON] = ACTIONS(2228),
    [anon_sym_AMP] = ACTIONS(2230),
    [anon_sym_LBRACK] = ACTIONS(2230),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2228),
    [anon_sym_LBRACE] = ACTIONS(2230),
    [anon_sym_LT_AT] = ACTIONS(2230),
    [anon_sym_AT_GT] = ACTIONS(2230),
    [anon_sym_LT_AT_AT] = ACTIONS(2230),
    [anon_sym_DOT] = ACTIONS(2230),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2228),
    [anon_sym_new] = ACTIONS(2230),
    [anon_sym_return_BANG] = ACTIONS(2228),
    [anon_sym_yield] = ACTIONS(2230),
    [anon_sym_yield_BANG] = ACTIONS(2228),
    [anon_sym_lazy] = ACTIONS(2230),
    [anon_sym_assert] = ACTIONS(2230),
    [anon_sym_upcast] = ACTIONS(2230),
    [anon_sym_downcast] = ACTIONS(2230),
    [anon_sym_COLON_GT] = ACTIONS(2228),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2228),
    [anon_sym_for] = ACTIONS(2230),
    [anon_sym_while] = ACTIONS(2230),
    [anon_sym_if] = ACTIONS(2230),
    [anon_sym_fun] = ACTIONS(2230),
    [anon_sym_DASH_GT] = ACTIONS(3206),
    [anon_sym_try] = ACTIONS(2230),
    [anon_sym_match] = ACTIONS(2230),
    [anon_sym_match_BANG] = ACTIONS(2228),
    [anon_sym_function] = ACTIONS(2230),
    [anon_sym_LT_DASH] = ACTIONS(2230),
    [anon_sym_DOT_LBRACK] = ACTIONS(2228),
    [anon_sym_LT] = ACTIONS(2228),
    [anon_sym_use] = ACTIONS(2230),
    [anon_sym_use_BANG] = ACTIONS(2228),
    [anon_sym_do_BANG] = ACTIONS(2228),
    [anon_sym_begin] = ACTIONS(2230),
    [anon_sym_LPAREN2] = ACTIONS(2230),
    [anon_sym_STAR] = ACTIONS(3208),
    [anon_sym_LT2] = ACTIONS(3210),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3212),
    [anon_sym_or] = ACTIONS(2230),
    [aux_sym_char_token1] = ACTIONS(2228),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2230),
    [anon_sym_DQUOTE] = ACTIONS(2230),
    [anon_sym_AT_DQUOTE] = ACTIONS(2228),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2228),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2228),
    [sym_bool] = ACTIONS(2230),
    [sym_unit] = ACTIONS(2228),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2230),
    [sym_op_identifier] = ACTIONS(2230),
    [anon_sym_PLUS] = ACTIONS(2230),
    [anon_sym_DASH] = ACTIONS(2230),
    [anon_sym_PLUS_DOT] = ACTIONS(2230),
    [anon_sym_DASH_DOT] = ACTIONS(2230),
    [anon_sym_PERCENT] = ACTIONS(2230),
    [anon_sym_AMP_AMP] = ACTIONS(2230),
    [anon_sym_TILDE] = ACTIONS(2228),
    [aux_sym_prefix_op_token1] = ACTIONS(2230),
    [aux_sym_infix_op_token1] = ACTIONS(2228),
    [aux_sym_infix_op_token2] = ACTIONS(2230),
    [anon_sym_PIPE_PIPE] = ACTIONS(2230),
    [anon_sym_BANG_EQ] = ACTIONS(2230),
    [anon_sym_COLON_EQ] = ACTIONS(2228),
    [anon_sym_DOLLAR] = ACTIONS(2230),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2230),
    [sym_int] = ACTIONS(2230),
    [sym_xint] = ACTIONS(2228),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2228),
    [sym__newline] = ACTIONS(2228),
  },
  [994] = {
    [sym_type_arguments] = STATE(1312),
    [sym_long_identifier] = STATE(1292),
    [sym_block_comment] = STATE(994),
    [sym_compiler_directive_decl] = STATE(994),
    [sym_fsi_directive_decl] = STATE(994),
    [sym_preproc_line] = STATE(994),
    [aux_sym_compound_type_repeat1] = STATE(1249),
    [sym_identifier] = ACTIONS(3214),
    [anon_sym_EQ] = ACTIONS(2240),
    [anon_sym_COLON] = ACTIONS(2242),
    [anon_sym_return] = ACTIONS(2242),
    [anon_sym_do] = ACTIONS(2242),
    [anon_sym_let] = ACTIONS(2242),
    [anon_sym_let_BANG] = ACTIONS(2240),
    [anon_sym_LPAREN] = ACTIONS(2242),
    [anon_sym_COMMA] = ACTIONS(2240),
    [anon_sym_null] = ACTIONS(2242),
    [anon_sym_QMARK] = ACTIONS(2242),
    [anon_sym_COLON_QMARK] = ACTIONS(2242),
    [anon_sym_COLON_COLON] = ACTIONS(2240),
    [anon_sym_AMP] = ACTIONS(2242),
    [anon_sym_LBRACK] = ACTIONS(2242),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2240),
    [anon_sym_LBRACE] = ACTIONS(2242),
    [anon_sym_LT_AT] = ACTIONS(2242),
    [anon_sym_LT_AT_AT] = ACTIONS(2242),
    [anon_sym_DOT] = ACTIONS(2242),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2240),
    [anon_sym_new] = ACTIONS(2242),
    [anon_sym_return_BANG] = ACTIONS(2240),
    [anon_sym_yield] = ACTIONS(2242),
    [anon_sym_yield_BANG] = ACTIONS(2240),
    [anon_sym_lazy] = ACTIONS(2242),
    [anon_sym_assert] = ACTIONS(2242),
    [anon_sym_upcast] = ACTIONS(2242),
    [anon_sym_downcast] = ACTIONS(2242),
    [anon_sym_COLON_GT] = ACTIONS(2240),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2240),
    [anon_sym_for] = ACTIONS(2242),
    [anon_sym_while] = ACTIONS(2242),
    [anon_sym_if] = ACTIONS(2242),
    [anon_sym_fun] = ACTIONS(2242),
    [anon_sym_DASH_GT] = ACTIONS(3216),
    [anon_sym_try] = ACTIONS(2242),
    [anon_sym_match] = ACTIONS(2242),
    [anon_sym_match_BANG] = ACTIONS(2240),
    [anon_sym_function] = ACTIONS(2242),
    [anon_sym_LT_DASH] = ACTIONS(2242),
    [anon_sym_DOT_LBRACK] = ACTIONS(2240),
    [anon_sym_LT] = ACTIONS(2240),
    [anon_sym_GT] = ACTIONS(2242),
    [anon_sym_use] = ACTIONS(2242),
    [anon_sym_use_BANG] = ACTIONS(2240),
    [anon_sym_do_BANG] = ACTIONS(2240),
    [anon_sym_begin] = ACTIONS(2242),
    [anon_sym_LPAREN2] = ACTIONS(2242),
    [anon_sym_STAR] = ACTIONS(3218),
    [anon_sym_LT2] = ACTIONS(3220),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3222),
    [anon_sym_or] = ACTIONS(2242),
    [aux_sym_char_token1] = ACTIONS(2240),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2242),
    [anon_sym_DQUOTE] = ACTIONS(2242),
    [anon_sym_AT_DQUOTE] = ACTIONS(2240),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2240),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2240),
    [sym_bool] = ACTIONS(2242),
    [sym_unit] = ACTIONS(2240),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2242),
    [sym_op_identifier] = ACTIONS(2242),
    [anon_sym_PLUS] = ACTIONS(2242),
    [anon_sym_DASH] = ACTIONS(2242),
    [anon_sym_PLUS_DOT] = ACTIONS(2242),
    [anon_sym_DASH_DOT] = ACTIONS(2242),
    [anon_sym_PERCENT] = ACTIONS(2242),
    [anon_sym_AMP_AMP] = ACTIONS(2242),
    [anon_sym_TILDE] = ACTIONS(2240),
    [aux_sym_prefix_op_token1] = ACTIONS(2242),
    [aux_sym_infix_op_token1] = ACTIONS(2240),
    [aux_sym_infix_op_token2] = ACTIONS(2242),
    [anon_sym_PIPE_PIPE] = ACTIONS(2242),
    [anon_sym_BANG_EQ] = ACTIONS(2242),
    [anon_sym_COLON_EQ] = ACTIONS(2240),
    [anon_sym_DOLLAR] = ACTIONS(2242),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2242),
    [sym_int] = ACTIONS(2242),
    [sym_xint] = ACTIONS(2240),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2240),
    [sym__newline] = ACTIONS(2240),
  },
  [995] = {
    [sym_type_arguments] = STATE(1323),
    [sym_long_identifier] = STATE(1345),
    [sym_block_comment] = STATE(995),
    [sym_compiler_directive_decl] = STATE(995),
    [sym_fsi_directive_decl] = STATE(995),
    [sym_preproc_line] = STATE(995),
    [aux_sym_compound_type_repeat1] = STATE(1235),
    [sym_identifier] = ACTIONS(2252),
    [anon_sym_EQ] = ACTIONS(2254),
    [anon_sym_COLON] = ACTIONS(2252),
    [anon_sym_return] = ACTIONS(2252),
    [anon_sym_do] = ACTIONS(2252),
    [anon_sym_let] = ACTIONS(2252),
    [anon_sym_let_BANG] = ACTIONS(2254),
    [anon_sym_LPAREN] = ACTIONS(2252),
    [anon_sym_COMMA] = ACTIONS(2254),
    [anon_sym_null] = ACTIONS(2252),
    [anon_sym_QMARK] = ACTIONS(2252),
    [anon_sym_COLON_QMARK] = ACTIONS(2252),
    [anon_sym_COLON_COLON] = ACTIONS(2254),
    [anon_sym_AMP] = ACTIONS(2252),
    [anon_sym_LBRACK] = ACTIONS(2252),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2254),
    [anon_sym_LBRACE] = ACTIONS(2252),
    [anon_sym_LT_AT] = ACTIONS(2252),
    [anon_sym_LT_AT_AT] = ACTIONS(2252),
    [anon_sym_AT_AT_GT] = ACTIONS(2252),
    [anon_sym_DOT] = ACTIONS(2252),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2254),
    [anon_sym_new] = ACTIONS(2252),
    [anon_sym_return_BANG] = ACTIONS(2254),
    [anon_sym_yield] = ACTIONS(2252),
    [anon_sym_yield_BANG] = ACTIONS(2254),
    [anon_sym_lazy] = ACTIONS(2252),
    [anon_sym_assert] = ACTIONS(2252),
    [anon_sym_upcast] = ACTIONS(2252),
    [anon_sym_downcast] = ACTIONS(2252),
    [anon_sym_COLON_GT] = ACTIONS(2254),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2254),
    [anon_sym_for] = ACTIONS(2252),
    [anon_sym_while] = ACTIONS(2252),
    [anon_sym_if] = ACTIONS(2252),
    [anon_sym_fun] = ACTIONS(2252),
    [anon_sym_DASH_GT] = ACTIONS(3224),
    [anon_sym_try] = ACTIONS(2252),
    [anon_sym_match] = ACTIONS(2252),
    [anon_sym_match_BANG] = ACTIONS(2254),
    [anon_sym_function] = ACTIONS(2252),
    [anon_sym_LT_DASH] = ACTIONS(2252),
    [anon_sym_DOT_LBRACK] = ACTIONS(2254),
    [anon_sym_LT] = ACTIONS(2254),
    [anon_sym_use] = ACTIONS(2252),
    [anon_sym_use_BANG] = ACTIONS(2254),
    [anon_sym_do_BANG] = ACTIONS(2254),
    [anon_sym_begin] = ACTIONS(2252),
    [anon_sym_LPAREN2] = ACTIONS(2252),
    [anon_sym_STAR] = ACTIONS(3226),
    [anon_sym_LT2] = ACTIONS(3228),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3230),
    [anon_sym_or] = ACTIONS(2252),
    [aux_sym_char_token1] = ACTIONS(2254),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2252),
    [anon_sym_DQUOTE] = ACTIONS(2252),
    [anon_sym_AT_DQUOTE] = ACTIONS(2254),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2254),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2254),
    [sym_bool] = ACTIONS(2252),
    [sym_unit] = ACTIONS(2254),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2252),
    [sym_op_identifier] = ACTIONS(2252),
    [anon_sym_PLUS] = ACTIONS(2252),
    [anon_sym_DASH] = ACTIONS(2252),
    [anon_sym_PLUS_DOT] = ACTIONS(2252),
    [anon_sym_DASH_DOT] = ACTIONS(2252),
    [anon_sym_PERCENT] = ACTIONS(2252),
    [anon_sym_AMP_AMP] = ACTIONS(2252),
    [anon_sym_TILDE] = ACTIONS(2254),
    [aux_sym_prefix_op_token1] = ACTIONS(2252),
    [aux_sym_infix_op_token1] = ACTIONS(2254),
    [aux_sym_infix_op_token2] = ACTIONS(2252),
    [anon_sym_PIPE_PIPE] = ACTIONS(2252),
    [anon_sym_BANG_EQ] = ACTIONS(2252),
    [anon_sym_COLON_EQ] = ACTIONS(2254),
    [anon_sym_DOLLAR] = ACTIONS(2252),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2252),
    [sym_int] = ACTIONS(2252),
    [sym_xint] = ACTIONS(2254),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2254),
    [sym__newline] = ACTIONS(2254),
  },
  [996] = {
    [sym__else_expression] = STATE(1604),
    [sym_elif_expression] = STATE(1391),
    [sym_block_comment] = STATE(996),
    [sym_compiler_directive_decl] = STATE(996),
    [sym_fsi_directive_decl] = STATE(996),
    [sym_preproc_line] = STATE(996),
    [aux_sym_if_expression_repeat1] = STATE(1082),
    [sym_identifier] = ACTIONS(2332),
    [anon_sym_EQ] = ACTIONS(2334),
    [anon_sym_COLON] = ACTIONS(2332),
    [anon_sym_return] = ACTIONS(2332),
    [anon_sym_do] = ACTIONS(2332),
    [anon_sym_let] = ACTIONS(2332),
    [anon_sym_let_BANG] = ACTIONS(2334),
    [anon_sym_as] = ACTIONS(2332),
    [anon_sym_LPAREN] = ACTIONS(2332),
    [anon_sym_COMMA] = ACTIONS(2334),
    [anon_sym_null] = ACTIONS(2332),
    [anon_sym_QMARK] = ACTIONS(2332),
    [anon_sym_COLON_QMARK] = ACTIONS(2332),
    [anon_sym_COLON_COLON] = ACTIONS(2334),
    [anon_sym_AMP] = ACTIONS(2332),
    [anon_sym_LBRACK] = ACTIONS(2332),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2334),
    [anon_sym_LBRACE] = ACTIONS(2332),
    [anon_sym_LT_AT] = ACTIONS(2332),
    [anon_sym_LT_AT_AT] = ACTIONS(2332),
    [anon_sym_DOT] = ACTIONS(2332),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2334),
    [anon_sym_new] = ACTIONS(2332),
    [anon_sym_with] = ACTIONS(2332),
    [anon_sym_return_BANG] = ACTIONS(2334),
    [anon_sym_yield] = ACTIONS(2332),
    [anon_sym_yield_BANG] = ACTIONS(2334),
    [anon_sym_lazy] = ACTIONS(2332),
    [anon_sym_assert] = ACTIONS(2332),
    [anon_sym_upcast] = ACTIONS(2332),
    [anon_sym_downcast] = ACTIONS(2332),
    [anon_sym_COLON_GT] = ACTIONS(2334),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2334),
    [anon_sym_for] = ACTIONS(2332),
    [anon_sym_while] = ACTIONS(2332),
    [anon_sym_else] = ACTIONS(3232),
    [anon_sym_elif] = ACTIONS(3234),
    [anon_sym_if] = ACTIONS(2332),
    [anon_sym_fun] = ACTIONS(2332),
    [anon_sym_try] = ACTIONS(2332),
    [anon_sym_match] = ACTIONS(2332),
    [anon_sym_match_BANG] = ACTIONS(2334),
    [anon_sym_function] = ACTIONS(2332),
    [anon_sym_LT_DASH] = ACTIONS(2332),
    [anon_sym_DOT_LBRACK] = ACTIONS(2334),
    [anon_sym_LT] = ACTIONS(2334),
    [anon_sym_use] = ACTIONS(2332),
    [anon_sym_use_BANG] = ACTIONS(2334),
    [anon_sym_do_BANG] = ACTIONS(2334),
    [anon_sym_begin] = ACTIONS(2332),
    [anon_sym_LPAREN2] = ACTIONS(2332),
    [anon_sym_or] = ACTIONS(2332),
    [aux_sym_char_token1] = ACTIONS(2334),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2332),
    [anon_sym_DQUOTE] = ACTIONS(2332),
    [anon_sym_AT_DQUOTE] = ACTIONS(2334),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2334),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2334),
    [sym_bool] = ACTIONS(2332),
    [sym_unit] = ACTIONS(2334),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2332),
    [sym_op_identifier] = ACTIONS(2332),
    [anon_sym_PLUS] = ACTIONS(2332),
    [anon_sym_DASH] = ACTIONS(2332),
    [anon_sym_PLUS_DOT] = ACTIONS(2332),
    [anon_sym_DASH_DOT] = ACTIONS(2332),
    [anon_sym_PERCENT] = ACTIONS(2332),
    [anon_sym_AMP_AMP] = ACTIONS(2332),
    [anon_sym_TILDE] = ACTIONS(2334),
    [aux_sym_prefix_op_token1] = ACTIONS(2332),
    [aux_sym_infix_op_token1] = ACTIONS(2334),
    [aux_sym_infix_op_token2] = ACTIONS(2332),
    [anon_sym_PIPE_PIPE] = ACTIONS(2332),
    [anon_sym_BANG_EQ] = ACTIONS(2332),
    [anon_sym_COLON_EQ] = ACTIONS(2334),
    [anon_sym_DOLLAR] = ACTIONS(2332),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2332),
    [sym_int] = ACTIONS(2332),
    [sym_xint] = ACTIONS(2334),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2334),
    [sym__newline] = ACTIONS(2334),
    [sym__dedent] = ACTIONS(2334),
  },
  [997] = {
    [sym_type_arguments] = STATE(1297),
    [sym_long_identifier] = STATE(1303),
    [sym_block_comment] = STATE(997),
    [sym_compiler_directive_decl] = STATE(997),
    [sym_fsi_directive_decl] = STATE(997),
    [sym_preproc_line] = STATE(997),
    [aux_sym_compound_type_repeat1] = STATE(1259),
    [sym_identifier] = ACTIONS(3236),
    [anon_sym_EQ] = ACTIONS(2244),
    [anon_sym_COLON] = ACTIONS(2246),
    [anon_sym_return] = ACTIONS(2246),
    [anon_sym_do] = ACTIONS(2246),
    [anon_sym_let] = ACTIONS(2246),
    [anon_sym_let_BANG] = ACTIONS(2244),
    [anon_sym_LPAREN] = ACTIONS(2246),
    [anon_sym_COMMA] = ACTIONS(2244),
    [anon_sym_null] = ACTIONS(2246),
    [anon_sym_QMARK] = ACTIONS(2246),
    [anon_sym_COLON_QMARK] = ACTIONS(2246),
    [anon_sym_COLON_COLON] = ACTIONS(2244),
    [anon_sym_AMP] = ACTIONS(2246),
    [anon_sym_LBRACK] = ACTIONS(2246),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2244),
    [anon_sym_LBRACE] = ACTIONS(2246),
    [anon_sym_LT_AT] = ACTIONS(2246),
    [anon_sym_LT_AT_AT] = ACTIONS(2246),
    [anon_sym_DOT] = ACTIONS(2246),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2244),
    [anon_sym_new] = ACTIONS(2246),
    [anon_sym_return_BANG] = ACTIONS(2244),
    [anon_sym_yield] = ACTIONS(2246),
    [anon_sym_yield_BANG] = ACTIONS(2244),
    [anon_sym_lazy] = ACTIONS(2246),
    [anon_sym_assert] = ACTIONS(2246),
    [anon_sym_upcast] = ACTIONS(2246),
    [anon_sym_downcast] = ACTIONS(2246),
    [anon_sym_COLON_GT] = ACTIONS(2244),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2244),
    [anon_sym_for] = ACTIONS(2246),
    [anon_sym_while] = ACTIONS(2246),
    [anon_sym_if] = ACTIONS(2246),
    [anon_sym_fun] = ACTIONS(2246),
    [anon_sym_DASH_GT] = ACTIONS(3238),
    [anon_sym_try] = ACTIONS(2246),
    [anon_sym_match] = ACTIONS(2246),
    [anon_sym_match_BANG] = ACTIONS(2244),
    [anon_sym_function] = ACTIONS(2246),
    [anon_sym_LT_DASH] = ACTIONS(2246),
    [anon_sym_DOT_LBRACK] = ACTIONS(2244),
    [anon_sym_LT] = ACTIONS(2244),
    [anon_sym_use] = ACTIONS(2246),
    [anon_sym_use_BANG] = ACTIONS(2244),
    [anon_sym_do_BANG] = ACTIONS(2244),
    [anon_sym_begin] = ACTIONS(2246),
    [anon_sym_LPAREN2] = ACTIONS(2246),
    [anon_sym_STAR] = ACTIONS(3240),
    [anon_sym_LT2] = ACTIONS(3242),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3244),
    [anon_sym_or] = ACTIONS(2246),
    [aux_sym_char_token1] = ACTIONS(2244),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2246),
    [anon_sym_DQUOTE] = ACTIONS(2246),
    [anon_sym_AT_DQUOTE] = ACTIONS(2244),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2244),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2244),
    [sym_bool] = ACTIONS(2246),
    [sym_unit] = ACTIONS(2244),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2246),
    [sym_op_identifier] = ACTIONS(2246),
    [anon_sym_PLUS] = ACTIONS(2246),
    [anon_sym_DASH] = ACTIONS(2246),
    [anon_sym_PLUS_DOT] = ACTIONS(2246),
    [anon_sym_DASH_DOT] = ACTIONS(2246),
    [anon_sym_PERCENT] = ACTIONS(2246),
    [anon_sym_AMP_AMP] = ACTIONS(2246),
    [anon_sym_TILDE] = ACTIONS(2244),
    [aux_sym_prefix_op_token1] = ACTIONS(2246),
    [aux_sym_infix_op_token1] = ACTIONS(2244),
    [aux_sym_infix_op_token2] = ACTIONS(2246),
    [anon_sym_PIPE_PIPE] = ACTIONS(2246),
    [anon_sym_BANG_EQ] = ACTIONS(2246),
    [anon_sym_COLON_EQ] = ACTIONS(2244),
    [anon_sym_DOLLAR] = ACTIONS(2246),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2246),
    [sym_int] = ACTIONS(2246),
    [sym_xint] = ACTIONS(2244),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2244),
    [anon_sym_POUNDendif] = ACTIONS(2244),
    [sym__newline] = ACTIONS(2244),
  },
  [998] = {
    [sym_type_arguments] = STATE(1297),
    [sym_long_identifier] = STATE(1303),
    [sym_block_comment] = STATE(998),
    [sym_compiler_directive_decl] = STATE(998),
    [sym_fsi_directive_decl] = STATE(998),
    [sym_preproc_line] = STATE(998),
    [aux_sym_compound_type_repeat1] = STATE(1259),
    [sym_identifier] = ACTIONS(3236),
    [anon_sym_EQ] = ACTIONS(2248),
    [anon_sym_COLON] = ACTIONS(2250),
    [anon_sym_return] = ACTIONS(2250),
    [anon_sym_do] = ACTIONS(2250),
    [anon_sym_let] = ACTIONS(2250),
    [anon_sym_let_BANG] = ACTIONS(2248),
    [anon_sym_LPAREN] = ACTIONS(2250),
    [anon_sym_COMMA] = ACTIONS(2248),
    [anon_sym_null] = ACTIONS(2250),
    [anon_sym_QMARK] = ACTIONS(2250),
    [anon_sym_COLON_QMARK] = ACTIONS(2250),
    [anon_sym_COLON_COLON] = ACTIONS(2248),
    [anon_sym_AMP] = ACTIONS(2250),
    [anon_sym_LBRACK] = ACTIONS(2250),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2248),
    [anon_sym_LBRACE] = ACTIONS(2250),
    [anon_sym_LT_AT] = ACTIONS(2250),
    [anon_sym_LT_AT_AT] = ACTIONS(2250),
    [anon_sym_DOT] = ACTIONS(2250),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2248),
    [anon_sym_new] = ACTIONS(2250),
    [anon_sym_return_BANG] = ACTIONS(2248),
    [anon_sym_yield] = ACTIONS(2250),
    [anon_sym_yield_BANG] = ACTIONS(2248),
    [anon_sym_lazy] = ACTIONS(2250),
    [anon_sym_assert] = ACTIONS(2250),
    [anon_sym_upcast] = ACTIONS(2250),
    [anon_sym_downcast] = ACTIONS(2250),
    [anon_sym_COLON_GT] = ACTIONS(2248),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2248),
    [anon_sym_for] = ACTIONS(2250),
    [anon_sym_while] = ACTIONS(2250),
    [anon_sym_if] = ACTIONS(2250),
    [anon_sym_fun] = ACTIONS(2250),
    [anon_sym_DASH_GT] = ACTIONS(3238),
    [anon_sym_try] = ACTIONS(2250),
    [anon_sym_match] = ACTIONS(2250),
    [anon_sym_match_BANG] = ACTIONS(2248),
    [anon_sym_function] = ACTIONS(2250),
    [anon_sym_LT_DASH] = ACTIONS(2250),
    [anon_sym_DOT_LBRACK] = ACTIONS(2248),
    [anon_sym_LT] = ACTIONS(2248),
    [anon_sym_use] = ACTIONS(2250),
    [anon_sym_use_BANG] = ACTIONS(2248),
    [anon_sym_do_BANG] = ACTIONS(2248),
    [anon_sym_begin] = ACTIONS(2250),
    [anon_sym_LPAREN2] = ACTIONS(2250),
    [anon_sym_STAR] = ACTIONS(3240),
    [anon_sym_LT2] = ACTIONS(3242),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3244),
    [anon_sym_or] = ACTIONS(2250),
    [aux_sym_char_token1] = ACTIONS(2248),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2250),
    [anon_sym_DQUOTE] = ACTIONS(2250),
    [anon_sym_AT_DQUOTE] = ACTIONS(2248),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2248),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2248),
    [sym_bool] = ACTIONS(2250),
    [sym_unit] = ACTIONS(2248),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2250),
    [sym_op_identifier] = ACTIONS(2250),
    [anon_sym_PLUS] = ACTIONS(2250),
    [anon_sym_DASH] = ACTIONS(2250),
    [anon_sym_PLUS_DOT] = ACTIONS(2250),
    [anon_sym_DASH_DOT] = ACTIONS(2250),
    [anon_sym_PERCENT] = ACTIONS(2250),
    [anon_sym_AMP_AMP] = ACTIONS(2250),
    [anon_sym_TILDE] = ACTIONS(2248),
    [aux_sym_prefix_op_token1] = ACTIONS(2250),
    [aux_sym_infix_op_token1] = ACTIONS(2248),
    [aux_sym_infix_op_token2] = ACTIONS(2250),
    [anon_sym_PIPE_PIPE] = ACTIONS(2250),
    [anon_sym_BANG_EQ] = ACTIONS(2250),
    [anon_sym_COLON_EQ] = ACTIONS(2248),
    [anon_sym_DOLLAR] = ACTIONS(2250),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2250),
    [sym_int] = ACTIONS(2250),
    [sym_xint] = ACTIONS(2248),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2248),
    [anon_sym_POUNDendif] = ACTIONS(2248),
    [sym__newline] = ACTIONS(2248),
  },
  [999] = {
    [sym_type_arguments] = STATE(1297),
    [sym_long_identifier] = STATE(1303),
    [sym_block_comment] = STATE(999),
    [sym_compiler_directive_decl] = STATE(999),
    [sym_fsi_directive_decl] = STATE(999),
    [sym_preproc_line] = STATE(999),
    [aux_sym_compound_type_repeat1] = STATE(1259),
    [sym_identifier] = ACTIONS(3236),
    [anon_sym_EQ] = ACTIONS(2240),
    [anon_sym_COLON] = ACTIONS(2242),
    [anon_sym_return] = ACTIONS(2242),
    [anon_sym_do] = ACTIONS(2242),
    [anon_sym_let] = ACTIONS(2242),
    [anon_sym_let_BANG] = ACTIONS(2240),
    [anon_sym_LPAREN] = ACTIONS(2242),
    [anon_sym_COMMA] = ACTIONS(2240),
    [anon_sym_null] = ACTIONS(2242),
    [anon_sym_QMARK] = ACTIONS(2242),
    [anon_sym_COLON_QMARK] = ACTIONS(2242),
    [anon_sym_COLON_COLON] = ACTIONS(2240),
    [anon_sym_AMP] = ACTIONS(2242),
    [anon_sym_LBRACK] = ACTIONS(2242),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2240),
    [anon_sym_LBRACE] = ACTIONS(2242),
    [anon_sym_LT_AT] = ACTIONS(2242),
    [anon_sym_LT_AT_AT] = ACTIONS(2242),
    [anon_sym_DOT] = ACTIONS(2242),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2240),
    [anon_sym_new] = ACTIONS(2242),
    [anon_sym_return_BANG] = ACTIONS(2240),
    [anon_sym_yield] = ACTIONS(2242),
    [anon_sym_yield_BANG] = ACTIONS(2240),
    [anon_sym_lazy] = ACTIONS(2242),
    [anon_sym_assert] = ACTIONS(2242),
    [anon_sym_upcast] = ACTIONS(2242),
    [anon_sym_downcast] = ACTIONS(2242),
    [anon_sym_COLON_GT] = ACTIONS(2240),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2240),
    [anon_sym_for] = ACTIONS(2242),
    [anon_sym_while] = ACTIONS(2242),
    [anon_sym_if] = ACTIONS(2242),
    [anon_sym_fun] = ACTIONS(2242),
    [anon_sym_DASH_GT] = ACTIONS(3238),
    [anon_sym_try] = ACTIONS(2242),
    [anon_sym_match] = ACTIONS(2242),
    [anon_sym_match_BANG] = ACTIONS(2240),
    [anon_sym_function] = ACTIONS(2242),
    [anon_sym_LT_DASH] = ACTIONS(2242),
    [anon_sym_DOT_LBRACK] = ACTIONS(2240),
    [anon_sym_LT] = ACTIONS(2240),
    [anon_sym_use] = ACTIONS(2242),
    [anon_sym_use_BANG] = ACTIONS(2240),
    [anon_sym_do_BANG] = ACTIONS(2240),
    [anon_sym_begin] = ACTIONS(2242),
    [anon_sym_LPAREN2] = ACTIONS(2242),
    [anon_sym_STAR] = ACTIONS(3240),
    [anon_sym_LT2] = ACTIONS(3242),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3244),
    [anon_sym_or] = ACTIONS(2242),
    [aux_sym_char_token1] = ACTIONS(2240),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2242),
    [anon_sym_DQUOTE] = ACTIONS(2242),
    [anon_sym_AT_DQUOTE] = ACTIONS(2240),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2240),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2240),
    [sym_bool] = ACTIONS(2242),
    [sym_unit] = ACTIONS(2240),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2242),
    [sym_op_identifier] = ACTIONS(2242),
    [anon_sym_PLUS] = ACTIONS(2242),
    [anon_sym_DASH] = ACTIONS(2242),
    [anon_sym_PLUS_DOT] = ACTIONS(2242),
    [anon_sym_DASH_DOT] = ACTIONS(2242),
    [anon_sym_PERCENT] = ACTIONS(2242),
    [anon_sym_AMP_AMP] = ACTIONS(2242),
    [anon_sym_TILDE] = ACTIONS(2240),
    [aux_sym_prefix_op_token1] = ACTIONS(2242),
    [aux_sym_infix_op_token1] = ACTIONS(2240),
    [aux_sym_infix_op_token2] = ACTIONS(2242),
    [anon_sym_PIPE_PIPE] = ACTIONS(2242),
    [anon_sym_BANG_EQ] = ACTIONS(2242),
    [anon_sym_COLON_EQ] = ACTIONS(2240),
    [anon_sym_DOLLAR] = ACTIONS(2242),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2242),
    [sym_int] = ACTIONS(2242),
    [sym_xint] = ACTIONS(2240),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2240),
    [anon_sym_POUNDendif] = ACTIONS(2240),
    [sym__newline] = ACTIONS(2240),
  },
  [1000] = {
    [sym_block_comment] = STATE(1000),
    [sym_compiler_directive_decl] = STATE(1000),
    [sym_fsi_directive_decl] = STATE(1000),
    [sym_preproc_line] = STATE(1000),
    [sym_identifier] = ACTIONS(2713),
    [anon_sym_EQ] = ACTIONS(2715),
    [anon_sym_GT_RBRACK] = ACTIONS(2715),
    [anon_sym_COLON] = ACTIONS(2713),
    [anon_sym_return] = ACTIONS(2713),
    [anon_sym_do] = ACTIONS(2713),
    [anon_sym_let] = ACTIONS(2713),
    [anon_sym_let_BANG] = ACTIONS(2715),
    [anon_sym_LPAREN] = ACTIONS(2713),
    [anon_sym_COMMA] = ACTIONS(2715),
    [anon_sym_null] = ACTIONS(2713),
    [anon_sym_QMARK] = ACTIONS(2713),
    [anon_sym_COLON_QMARK] = ACTIONS(2713),
    [anon_sym_COLON_COLON] = ACTIONS(2715),
    [anon_sym_PIPE] = ACTIONS(2713),
    [anon_sym_AMP] = ACTIONS(2713),
    [anon_sym_LBRACK] = ACTIONS(2713),
    [anon_sym_RBRACK] = ACTIONS(2715),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2715),
    [anon_sym_LBRACE] = ACTIONS(2713),
    [anon_sym_RBRACE] = ACTIONS(2715),
    [anon_sym_LT_AT] = ACTIONS(2713),
    [anon_sym_LT_AT_AT] = ACTIONS(2713),
    [anon_sym_DOT] = ACTIONS(2713),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2715),
    [anon_sym_new] = ACTIONS(2713),
    [anon_sym_with] = ACTIONS(2713),
    [anon_sym_return_BANG] = ACTIONS(2715),
    [anon_sym_yield] = ACTIONS(2713),
    [anon_sym_yield_BANG] = ACTIONS(2715),
    [anon_sym_lazy] = ACTIONS(2713),
    [anon_sym_assert] = ACTIONS(2713),
    [anon_sym_upcast] = ACTIONS(2713),
    [anon_sym_downcast] = ACTIONS(2713),
    [anon_sym_COLON_GT] = ACTIONS(2715),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2715),
    [anon_sym_for] = ACTIONS(2713),
    [anon_sym_to] = ACTIONS(2713),
    [anon_sym_downto] = ACTIONS(2713),
    [anon_sym_while] = ACTIONS(2713),
    [anon_sym_if] = ACTIONS(2713),
    [anon_sym_fun] = ACTIONS(2713),
    [anon_sym_try] = ACTIONS(2713),
    [anon_sym_match] = ACTIONS(2713),
    [anon_sym_match_BANG] = ACTIONS(2715),
    [anon_sym_function] = ACTIONS(2713),
    [anon_sym_LT_DASH] = ACTIONS(2713),
    [anon_sym_DOT_LBRACK] = ACTIONS(2715),
    [anon_sym_LT] = ACTIONS(2715),
    [anon_sym_use] = ACTIONS(2713),
    [anon_sym_use_BANG] = ACTIONS(2715),
    [anon_sym_do_BANG] = ACTIONS(2715),
    [anon_sym_begin] = ACTIONS(2713),
    [anon_sym_LPAREN2] = ACTIONS(2713),
    [anon_sym_DOT_DOT2] = ACTIONS(2715),
    [anon_sym_or] = ACTIONS(2713),
    [aux_sym_char_token1] = ACTIONS(2715),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2713),
    [anon_sym_DQUOTE] = ACTIONS(2713),
    [anon_sym_AT_DQUOTE] = ACTIONS(2715),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2715),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2715),
    [sym_bool] = ACTIONS(2713),
    [sym_unit] = ACTIONS(2715),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2713),
    [sym_op_identifier] = ACTIONS(2713),
    [anon_sym_PLUS] = ACTIONS(2713),
    [anon_sym_DASH] = ACTIONS(2713),
    [anon_sym_PLUS_DOT] = ACTIONS(2713),
    [anon_sym_DASH_DOT] = ACTIONS(2713),
    [anon_sym_PERCENT] = ACTIONS(2713),
    [anon_sym_AMP_AMP] = ACTIONS(2713),
    [anon_sym_TILDE] = ACTIONS(2715),
    [aux_sym_prefix_op_token1] = ACTIONS(2713),
    [aux_sym_infix_op_token1] = ACTIONS(2715),
    [aux_sym_infix_op_token2] = ACTIONS(2713),
    [anon_sym_PIPE_PIPE] = ACTIONS(2713),
    [anon_sym_BANG_EQ] = ACTIONS(2713),
    [anon_sym_COLON_EQ] = ACTIONS(2715),
    [anon_sym_DOLLAR] = ACTIONS(2713),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2713),
    [sym_int] = ACTIONS(2713),
    [sym_xint] = ACTIONS(2715),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2715),
    [sym__newline] = ACTIONS(2715),
  },
  [1001] = {
    [sym_block_comment] = STATE(1001),
    [sym_compiler_directive_decl] = STATE(1001),
    [sym_fsi_directive_decl] = STATE(1001),
    [sym_preproc_line] = STATE(1001),
    [sym_identifier] = ACTIONS(2766),
    [anon_sym_EQ] = ACTIONS(2768),
    [anon_sym_GT_RBRACK] = ACTIONS(2768),
    [anon_sym_COLON] = ACTIONS(2766),
    [anon_sym_return] = ACTIONS(2766),
    [anon_sym_do] = ACTIONS(2766),
    [anon_sym_let] = ACTIONS(2766),
    [anon_sym_let_BANG] = ACTIONS(2768),
    [anon_sym_LPAREN] = ACTIONS(2766),
    [anon_sym_COMMA] = ACTIONS(2768),
    [anon_sym_null] = ACTIONS(2766),
    [anon_sym_QMARK] = ACTIONS(2766),
    [anon_sym_COLON_QMARK] = ACTIONS(2766),
    [anon_sym_COLON_COLON] = ACTIONS(2768),
    [anon_sym_PIPE] = ACTIONS(2766),
    [anon_sym_AMP] = ACTIONS(2766),
    [anon_sym_LBRACK] = ACTIONS(2766),
    [anon_sym_RBRACK] = ACTIONS(2768),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2768),
    [anon_sym_LBRACE] = ACTIONS(2766),
    [anon_sym_RBRACE] = ACTIONS(2768),
    [anon_sym_LT_AT] = ACTIONS(2766),
    [anon_sym_LT_AT_AT] = ACTIONS(2766),
    [anon_sym_DOT] = ACTIONS(2766),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2768),
    [anon_sym_new] = ACTIONS(2766),
    [anon_sym_with] = ACTIONS(2766),
    [anon_sym_return_BANG] = ACTIONS(2768),
    [anon_sym_yield] = ACTIONS(2766),
    [anon_sym_yield_BANG] = ACTIONS(2768),
    [anon_sym_lazy] = ACTIONS(2766),
    [anon_sym_assert] = ACTIONS(2766),
    [anon_sym_upcast] = ACTIONS(2766),
    [anon_sym_downcast] = ACTIONS(2766),
    [anon_sym_COLON_GT] = ACTIONS(2768),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2768),
    [anon_sym_for] = ACTIONS(2766),
    [anon_sym_to] = ACTIONS(2766),
    [anon_sym_downto] = ACTIONS(2766),
    [anon_sym_while] = ACTIONS(2766),
    [anon_sym_if] = ACTIONS(2766),
    [anon_sym_fun] = ACTIONS(2766),
    [anon_sym_try] = ACTIONS(2766),
    [anon_sym_match] = ACTIONS(2766),
    [anon_sym_match_BANG] = ACTIONS(2768),
    [anon_sym_function] = ACTIONS(2766),
    [anon_sym_LT_DASH] = ACTIONS(2766),
    [anon_sym_DOT_LBRACK] = ACTIONS(2768),
    [anon_sym_LT] = ACTIONS(2768),
    [anon_sym_use] = ACTIONS(2766),
    [anon_sym_use_BANG] = ACTIONS(2768),
    [anon_sym_do_BANG] = ACTIONS(2768),
    [anon_sym_begin] = ACTIONS(2766),
    [anon_sym_LPAREN2] = ACTIONS(2766),
    [anon_sym_DOT_DOT2] = ACTIONS(2768),
    [anon_sym_or] = ACTIONS(2766),
    [aux_sym_char_token1] = ACTIONS(2768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2766),
    [anon_sym_DQUOTE] = ACTIONS(2766),
    [anon_sym_AT_DQUOTE] = ACTIONS(2768),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2768),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2768),
    [sym_bool] = ACTIONS(2766),
    [sym_unit] = ACTIONS(2768),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2766),
    [sym_op_identifier] = ACTIONS(2766),
    [anon_sym_PLUS] = ACTIONS(2766),
    [anon_sym_DASH] = ACTIONS(2766),
    [anon_sym_PLUS_DOT] = ACTIONS(2766),
    [anon_sym_DASH_DOT] = ACTIONS(2766),
    [anon_sym_PERCENT] = ACTIONS(2766),
    [anon_sym_AMP_AMP] = ACTIONS(2766),
    [anon_sym_TILDE] = ACTIONS(2768),
    [aux_sym_prefix_op_token1] = ACTIONS(2766),
    [aux_sym_infix_op_token1] = ACTIONS(2768),
    [aux_sym_infix_op_token2] = ACTIONS(2766),
    [anon_sym_PIPE_PIPE] = ACTIONS(2766),
    [anon_sym_BANG_EQ] = ACTIONS(2766),
    [anon_sym_COLON_EQ] = ACTIONS(2768),
    [anon_sym_DOLLAR] = ACTIONS(2766),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2766),
    [sym_int] = ACTIONS(2766),
    [sym_xint] = ACTIONS(2768),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2768),
    [sym__newline] = ACTIONS(2768),
  },
  [1002] = {
    [sym_block_comment] = STATE(1002),
    [sym_compiler_directive_decl] = STATE(1002),
    [sym_fsi_directive_decl] = STATE(1002),
    [sym_preproc_line] = STATE(1002),
    [sym_identifier] = ACTIONS(2804),
    [anon_sym_EQ] = ACTIONS(2806),
    [anon_sym_GT_RBRACK] = ACTIONS(2806),
    [anon_sym_COLON] = ACTIONS(2804),
    [anon_sym_return] = ACTIONS(2804),
    [anon_sym_do] = ACTIONS(2804),
    [anon_sym_let] = ACTIONS(2804),
    [anon_sym_let_BANG] = ACTIONS(2806),
    [anon_sym_LPAREN] = ACTIONS(2804),
    [anon_sym_COMMA] = ACTIONS(2806),
    [anon_sym_null] = ACTIONS(2804),
    [anon_sym_QMARK] = ACTIONS(2804),
    [anon_sym_COLON_QMARK] = ACTIONS(2804),
    [anon_sym_COLON_COLON] = ACTIONS(2806),
    [anon_sym_AMP] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2804),
    [anon_sym_RBRACK] = ACTIONS(2806),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(2804),
    [anon_sym_RBRACE] = ACTIONS(2806),
    [anon_sym_LT_AT] = ACTIONS(2804),
    [anon_sym_LT_AT_AT] = ACTIONS(2804),
    [anon_sym_DOT] = ACTIONS(2804),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2806),
    [anon_sym_new] = ACTIONS(2804),
    [anon_sym_with] = ACTIONS(2804),
    [anon_sym_return_BANG] = ACTIONS(2806),
    [anon_sym_yield] = ACTIONS(2804),
    [anon_sym_yield_BANG] = ACTIONS(2806),
    [anon_sym_lazy] = ACTIONS(2804),
    [anon_sym_assert] = ACTIONS(2804),
    [anon_sym_upcast] = ACTIONS(2804),
    [anon_sym_downcast] = ACTIONS(2804),
    [anon_sym_COLON_GT] = ACTIONS(2806),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2806),
    [anon_sym_for] = ACTIONS(2804),
    [anon_sym_to] = ACTIONS(2804),
    [anon_sym_downto] = ACTIONS(2804),
    [anon_sym_done] = ACTIONS(3246),
    [anon_sym_while] = ACTIONS(2804),
    [anon_sym_if] = ACTIONS(2804),
    [anon_sym_fun] = ACTIONS(2804),
    [anon_sym_try] = ACTIONS(2804),
    [anon_sym_match] = ACTIONS(2804),
    [anon_sym_match_BANG] = ACTIONS(2806),
    [anon_sym_function] = ACTIONS(2804),
    [anon_sym_LT_DASH] = ACTIONS(2804),
    [anon_sym_DOT_LBRACK] = ACTIONS(2806),
    [anon_sym_LT] = ACTIONS(2806),
    [anon_sym_use] = ACTIONS(2804),
    [anon_sym_use_BANG] = ACTIONS(2806),
    [anon_sym_do_BANG] = ACTIONS(2806),
    [anon_sym_begin] = ACTIONS(2804),
    [anon_sym_LPAREN2] = ACTIONS(2804),
    [anon_sym_DOT_DOT2] = ACTIONS(2806),
    [anon_sym_or] = ACTIONS(2804),
    [aux_sym_char_token1] = ACTIONS(2806),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2804),
    [anon_sym_DQUOTE] = ACTIONS(2804),
    [anon_sym_AT_DQUOTE] = ACTIONS(2806),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2806),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2806),
    [sym_bool] = ACTIONS(2804),
    [sym_unit] = ACTIONS(2806),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2804),
    [sym_op_identifier] = ACTIONS(2804),
    [anon_sym_PLUS] = ACTIONS(2804),
    [anon_sym_DASH] = ACTIONS(2804),
    [anon_sym_PLUS_DOT] = ACTIONS(2804),
    [anon_sym_DASH_DOT] = ACTIONS(2804),
    [anon_sym_PERCENT] = ACTIONS(2804),
    [anon_sym_AMP_AMP] = ACTIONS(2804),
    [anon_sym_TILDE] = ACTIONS(2806),
    [aux_sym_prefix_op_token1] = ACTIONS(2804),
    [aux_sym_infix_op_token1] = ACTIONS(2806),
    [aux_sym_infix_op_token2] = ACTIONS(2804),
    [anon_sym_PIPE_PIPE] = ACTIONS(2804),
    [anon_sym_BANG_EQ] = ACTIONS(2804),
    [anon_sym_COLON_EQ] = ACTIONS(2806),
    [anon_sym_DOLLAR] = ACTIONS(2804),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2804),
    [sym_int] = ACTIONS(2804),
    [sym_xint] = ACTIONS(2806),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2806),
    [sym__newline] = ACTIONS(2806),
  },
  [1003] = {
    [sym_block_comment] = STATE(1003),
    [sym_compiler_directive_decl] = STATE(1003),
    [sym_fsi_directive_decl] = STATE(1003),
    [sym_preproc_line] = STATE(1003),
    [sym_identifier] = ACTIONS(2685),
    [anon_sym_EQ] = ACTIONS(2687),
    [anon_sym_GT_RBRACK] = ACTIONS(2687),
    [anon_sym_COLON] = ACTIONS(2685),
    [anon_sym_return] = ACTIONS(2685),
    [anon_sym_do] = ACTIONS(2685),
    [anon_sym_let] = ACTIONS(2685),
    [anon_sym_let_BANG] = ACTIONS(2687),
    [anon_sym_LPAREN] = ACTIONS(2685),
    [anon_sym_COMMA] = ACTIONS(2687),
    [anon_sym_null] = ACTIONS(2685),
    [anon_sym_QMARK] = ACTIONS(2685),
    [anon_sym_COLON_QMARK] = ACTIONS(2685),
    [anon_sym_COLON_COLON] = ACTIONS(2687),
    [anon_sym_AMP] = ACTIONS(2685),
    [anon_sym_LBRACK] = ACTIONS(2685),
    [anon_sym_RBRACK] = ACTIONS(2687),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2687),
    [anon_sym_LBRACE] = ACTIONS(2685),
    [anon_sym_RBRACE] = ACTIONS(2687),
    [anon_sym_LT_AT] = ACTIONS(2685),
    [anon_sym_LT_AT_AT] = ACTIONS(2685),
    [anon_sym_DOT] = ACTIONS(2685),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2687),
    [anon_sym_new] = ACTIONS(2685),
    [anon_sym_with] = ACTIONS(2685),
    [anon_sym_return_BANG] = ACTIONS(2687),
    [anon_sym_yield] = ACTIONS(2685),
    [anon_sym_yield_BANG] = ACTIONS(2687),
    [anon_sym_lazy] = ACTIONS(2685),
    [anon_sym_assert] = ACTIONS(2685),
    [anon_sym_upcast] = ACTIONS(2685),
    [anon_sym_downcast] = ACTIONS(2685),
    [anon_sym_COLON_GT] = ACTIONS(2687),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2687),
    [anon_sym_for] = ACTIONS(2685),
    [anon_sym_to] = ACTIONS(2685),
    [anon_sym_downto] = ACTIONS(2685),
    [anon_sym_done] = ACTIONS(2685),
    [anon_sym_while] = ACTIONS(2685),
    [anon_sym_if] = ACTIONS(2685),
    [anon_sym_fun] = ACTIONS(2685),
    [anon_sym_try] = ACTIONS(2685),
    [anon_sym_match] = ACTIONS(2685),
    [anon_sym_match_BANG] = ACTIONS(2687),
    [anon_sym_function] = ACTIONS(2685),
    [anon_sym_LT_DASH] = ACTIONS(2685),
    [anon_sym_DOT_LBRACK] = ACTIONS(2687),
    [anon_sym_LT] = ACTIONS(2687),
    [anon_sym_use] = ACTIONS(2685),
    [anon_sym_use_BANG] = ACTIONS(2687),
    [anon_sym_do_BANG] = ACTIONS(2687),
    [anon_sym_DOT_DOT] = ACTIONS(2687),
    [anon_sym_begin] = ACTIONS(2685),
    [anon_sym_LPAREN2] = ACTIONS(2685),
    [anon_sym_or] = ACTIONS(2685),
    [aux_sym_char_token1] = ACTIONS(2687),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2685),
    [anon_sym_DQUOTE] = ACTIONS(2685),
    [anon_sym_AT_DQUOTE] = ACTIONS(2687),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2687),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2687),
    [sym_bool] = ACTIONS(2685),
    [sym_unit] = ACTIONS(2687),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2685),
    [sym_op_identifier] = ACTIONS(2685),
    [anon_sym_PLUS] = ACTIONS(2685),
    [anon_sym_DASH] = ACTIONS(2685),
    [anon_sym_PLUS_DOT] = ACTIONS(2685),
    [anon_sym_DASH_DOT] = ACTIONS(2685),
    [anon_sym_PERCENT] = ACTIONS(2685),
    [anon_sym_AMP_AMP] = ACTIONS(2685),
    [anon_sym_TILDE] = ACTIONS(2687),
    [aux_sym_prefix_op_token1] = ACTIONS(2685),
    [aux_sym_infix_op_token1] = ACTIONS(2687),
    [aux_sym_infix_op_token2] = ACTIONS(2685),
    [anon_sym_PIPE_PIPE] = ACTIONS(2685),
    [anon_sym_BANG_EQ] = ACTIONS(2685),
    [anon_sym_COLON_EQ] = ACTIONS(2687),
    [anon_sym_DOLLAR] = ACTIONS(2685),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2685),
    [sym_int] = ACTIONS(2685),
    [sym_xint] = ACTIONS(2687),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2687),
    [sym__newline] = ACTIONS(2687),
  },
  [1004] = {
    [sym_type_arguments] = STATE(1285),
    [sym_long_identifier] = STATE(1378),
    [sym_block_comment] = STATE(1004),
    [sym_compiler_directive_decl] = STATE(1004),
    [sym_fsi_directive_decl] = STATE(1004),
    [sym_preproc_line] = STATE(1004),
    [aux_sym_compound_type_repeat1] = STATE(1268),
    [sym_identifier] = ACTIONS(3204),
    [anon_sym_EQ] = ACTIONS(2244),
    [anon_sym_COLON] = ACTIONS(2246),
    [anon_sym_return] = ACTIONS(2246),
    [anon_sym_do] = ACTIONS(2246),
    [anon_sym_let] = ACTIONS(2246),
    [anon_sym_let_BANG] = ACTIONS(2244),
    [anon_sym_LPAREN] = ACTIONS(2246),
    [anon_sym_COMMA] = ACTIONS(2244),
    [anon_sym_null] = ACTIONS(2246),
    [anon_sym_QMARK] = ACTIONS(2246),
    [anon_sym_COLON_QMARK] = ACTIONS(2246),
    [anon_sym_COLON_COLON] = ACTIONS(2244),
    [anon_sym_AMP] = ACTIONS(2246),
    [anon_sym_LBRACK] = ACTIONS(2246),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2244),
    [anon_sym_LBRACE] = ACTIONS(2246),
    [anon_sym_LT_AT] = ACTIONS(2246),
    [anon_sym_AT_GT] = ACTIONS(2246),
    [anon_sym_LT_AT_AT] = ACTIONS(2246),
    [anon_sym_DOT] = ACTIONS(2246),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2244),
    [anon_sym_new] = ACTIONS(2246),
    [anon_sym_return_BANG] = ACTIONS(2244),
    [anon_sym_yield] = ACTIONS(2246),
    [anon_sym_yield_BANG] = ACTIONS(2244),
    [anon_sym_lazy] = ACTIONS(2246),
    [anon_sym_assert] = ACTIONS(2246),
    [anon_sym_upcast] = ACTIONS(2246),
    [anon_sym_downcast] = ACTIONS(2246),
    [anon_sym_COLON_GT] = ACTIONS(2244),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2244),
    [anon_sym_for] = ACTIONS(2246),
    [anon_sym_while] = ACTIONS(2246),
    [anon_sym_if] = ACTIONS(2246),
    [anon_sym_fun] = ACTIONS(2246),
    [anon_sym_DASH_GT] = ACTIONS(3206),
    [anon_sym_try] = ACTIONS(2246),
    [anon_sym_match] = ACTIONS(2246),
    [anon_sym_match_BANG] = ACTIONS(2244),
    [anon_sym_function] = ACTIONS(2246),
    [anon_sym_LT_DASH] = ACTIONS(2246),
    [anon_sym_DOT_LBRACK] = ACTIONS(2244),
    [anon_sym_LT] = ACTIONS(2244),
    [anon_sym_use] = ACTIONS(2246),
    [anon_sym_use_BANG] = ACTIONS(2244),
    [anon_sym_do_BANG] = ACTIONS(2244),
    [anon_sym_begin] = ACTIONS(2246),
    [anon_sym_LPAREN2] = ACTIONS(2246),
    [anon_sym_STAR] = ACTIONS(3208),
    [anon_sym_LT2] = ACTIONS(3210),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3212),
    [anon_sym_or] = ACTIONS(2246),
    [aux_sym_char_token1] = ACTIONS(2244),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2246),
    [anon_sym_DQUOTE] = ACTIONS(2246),
    [anon_sym_AT_DQUOTE] = ACTIONS(2244),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2244),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2244),
    [sym_bool] = ACTIONS(2246),
    [sym_unit] = ACTIONS(2244),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2246),
    [sym_op_identifier] = ACTIONS(2246),
    [anon_sym_PLUS] = ACTIONS(2246),
    [anon_sym_DASH] = ACTIONS(2246),
    [anon_sym_PLUS_DOT] = ACTIONS(2246),
    [anon_sym_DASH_DOT] = ACTIONS(2246),
    [anon_sym_PERCENT] = ACTIONS(2246),
    [anon_sym_AMP_AMP] = ACTIONS(2246),
    [anon_sym_TILDE] = ACTIONS(2244),
    [aux_sym_prefix_op_token1] = ACTIONS(2246),
    [aux_sym_infix_op_token1] = ACTIONS(2244),
    [aux_sym_infix_op_token2] = ACTIONS(2246),
    [anon_sym_PIPE_PIPE] = ACTIONS(2246),
    [anon_sym_BANG_EQ] = ACTIONS(2246),
    [anon_sym_COLON_EQ] = ACTIONS(2244),
    [anon_sym_DOLLAR] = ACTIONS(2246),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2246),
    [sym_int] = ACTIONS(2246),
    [sym_xint] = ACTIONS(2244),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2244),
    [sym__newline] = ACTIONS(2244),
  },
  [1005] = {
    [sym_type_arguments] = STATE(1312),
    [sym_long_identifier] = STATE(1292),
    [sym_block_comment] = STATE(1005),
    [sym_compiler_directive_decl] = STATE(1005),
    [sym_fsi_directive_decl] = STATE(1005),
    [sym_preproc_line] = STATE(1005),
    [aux_sym_compound_type_repeat1] = STATE(1249),
    [sym_identifier] = ACTIONS(3214),
    [anon_sym_EQ] = ACTIONS(2244),
    [anon_sym_COLON] = ACTIONS(2246),
    [anon_sym_return] = ACTIONS(2246),
    [anon_sym_do] = ACTIONS(2246),
    [anon_sym_let] = ACTIONS(2246),
    [anon_sym_let_BANG] = ACTIONS(2244),
    [anon_sym_LPAREN] = ACTIONS(2246),
    [anon_sym_COMMA] = ACTIONS(2244),
    [anon_sym_null] = ACTIONS(2246),
    [anon_sym_QMARK] = ACTIONS(2246),
    [anon_sym_COLON_QMARK] = ACTIONS(2246),
    [anon_sym_COLON_COLON] = ACTIONS(2244),
    [anon_sym_AMP] = ACTIONS(2246),
    [anon_sym_LBRACK] = ACTIONS(2246),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2244),
    [anon_sym_LBRACE] = ACTIONS(2246),
    [anon_sym_LT_AT] = ACTIONS(2246),
    [anon_sym_LT_AT_AT] = ACTIONS(2246),
    [anon_sym_DOT] = ACTIONS(2246),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2244),
    [anon_sym_new] = ACTIONS(2246),
    [anon_sym_return_BANG] = ACTIONS(2244),
    [anon_sym_yield] = ACTIONS(2246),
    [anon_sym_yield_BANG] = ACTIONS(2244),
    [anon_sym_lazy] = ACTIONS(2246),
    [anon_sym_assert] = ACTIONS(2246),
    [anon_sym_upcast] = ACTIONS(2246),
    [anon_sym_downcast] = ACTIONS(2246),
    [anon_sym_COLON_GT] = ACTIONS(2244),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2244),
    [anon_sym_for] = ACTIONS(2246),
    [anon_sym_while] = ACTIONS(2246),
    [anon_sym_if] = ACTIONS(2246),
    [anon_sym_fun] = ACTIONS(2246),
    [anon_sym_DASH_GT] = ACTIONS(3216),
    [anon_sym_try] = ACTIONS(2246),
    [anon_sym_match] = ACTIONS(2246),
    [anon_sym_match_BANG] = ACTIONS(2244),
    [anon_sym_function] = ACTIONS(2246),
    [anon_sym_LT_DASH] = ACTIONS(2246),
    [anon_sym_DOT_LBRACK] = ACTIONS(2244),
    [anon_sym_LT] = ACTIONS(2244),
    [anon_sym_GT] = ACTIONS(2246),
    [anon_sym_use] = ACTIONS(2246),
    [anon_sym_use_BANG] = ACTIONS(2244),
    [anon_sym_do_BANG] = ACTIONS(2244),
    [anon_sym_begin] = ACTIONS(2246),
    [anon_sym_LPAREN2] = ACTIONS(2246),
    [anon_sym_STAR] = ACTIONS(3218),
    [anon_sym_LT2] = ACTIONS(3220),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3222),
    [anon_sym_or] = ACTIONS(2246),
    [aux_sym_char_token1] = ACTIONS(2244),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2246),
    [anon_sym_DQUOTE] = ACTIONS(2246),
    [anon_sym_AT_DQUOTE] = ACTIONS(2244),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2244),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2244),
    [sym_bool] = ACTIONS(2246),
    [sym_unit] = ACTIONS(2244),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2246),
    [sym_op_identifier] = ACTIONS(2246),
    [anon_sym_PLUS] = ACTIONS(2246),
    [anon_sym_DASH] = ACTIONS(2246),
    [anon_sym_PLUS_DOT] = ACTIONS(2246),
    [anon_sym_DASH_DOT] = ACTIONS(2246),
    [anon_sym_PERCENT] = ACTIONS(2246),
    [anon_sym_AMP_AMP] = ACTIONS(2246),
    [anon_sym_TILDE] = ACTIONS(2244),
    [aux_sym_prefix_op_token1] = ACTIONS(2246),
    [aux_sym_infix_op_token1] = ACTIONS(2244),
    [aux_sym_infix_op_token2] = ACTIONS(2246),
    [anon_sym_PIPE_PIPE] = ACTIONS(2246),
    [anon_sym_BANG_EQ] = ACTIONS(2246),
    [anon_sym_COLON_EQ] = ACTIONS(2244),
    [anon_sym_DOLLAR] = ACTIONS(2246),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2246),
    [sym_int] = ACTIONS(2246),
    [sym_xint] = ACTIONS(2244),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2244),
    [sym__newline] = ACTIONS(2244),
  },
  [1006] = {
    [sym_block_comment] = STATE(1006),
    [sym_compiler_directive_decl] = STATE(1006),
    [sym_fsi_directive_decl] = STATE(1006),
    [sym_preproc_line] = STATE(1006),
    [aux_sym_type_argument_repeat1] = STATE(1028),
    [sym_identifier] = ACTIONS(2321),
    [anon_sym_EQ] = ACTIONS(2323),
    [anon_sym_COLON] = ACTIONS(2321),
    [anon_sym_return] = ACTIONS(2321),
    [anon_sym_do] = ACTIONS(2321),
    [anon_sym_let] = ACTIONS(2321),
    [anon_sym_let_BANG] = ACTIONS(2323),
    [anon_sym_as] = ACTIONS(2321),
    [anon_sym_LPAREN] = ACTIONS(2321),
    [anon_sym_COMMA] = ACTIONS(2323),
    [anon_sym_null] = ACTIONS(2321),
    [anon_sym_QMARK] = ACTIONS(2321),
    [anon_sym_COLON_QMARK] = ACTIONS(2321),
    [anon_sym_COLON_COLON] = ACTIONS(2323),
    [anon_sym_AMP] = ACTIONS(2321),
    [anon_sym_LBRACK] = ACTIONS(2321),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2323),
    [anon_sym_LBRACE] = ACTIONS(2321),
    [anon_sym_LT_AT] = ACTIONS(2321),
    [anon_sym_LT_AT_AT] = ACTIONS(2321),
    [anon_sym_DOT] = ACTIONS(2321),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2323),
    [anon_sym_new] = ACTIONS(2321),
    [anon_sym_with] = ACTIONS(2321),
    [anon_sym_return_BANG] = ACTIONS(2323),
    [anon_sym_yield] = ACTIONS(2321),
    [anon_sym_yield_BANG] = ACTIONS(2323),
    [anon_sym_lazy] = ACTIONS(2321),
    [anon_sym_assert] = ACTIONS(2321),
    [anon_sym_upcast] = ACTIONS(2321),
    [anon_sym_downcast] = ACTIONS(2321),
    [anon_sym_COLON_GT] = ACTIONS(2323),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2323),
    [anon_sym_for] = ACTIONS(2321),
    [anon_sym_while] = ACTIONS(2321),
    [anon_sym_if] = ACTIONS(2321),
    [anon_sym_fun] = ACTIONS(2321),
    [anon_sym_DASH_GT] = ACTIONS(2321),
    [anon_sym_try] = ACTIONS(2321),
    [anon_sym_match] = ACTIONS(2321),
    [anon_sym_match_BANG] = ACTIONS(2323),
    [anon_sym_function] = ACTIONS(2321),
    [anon_sym_LT_DASH] = ACTIONS(2321),
    [anon_sym_DOT_LBRACK] = ACTIONS(2323),
    [anon_sym_LT] = ACTIONS(2323),
    [anon_sym_use] = ACTIONS(2321),
    [anon_sym_use_BANG] = ACTIONS(2323),
    [anon_sym_do_BANG] = ACTIONS(2323),
    [anon_sym_begin] = ACTIONS(2321),
    [anon_sym_LPAREN2] = ACTIONS(2321),
    [anon_sym_STAR] = ACTIONS(2321),
    [anon_sym_LT2] = ACTIONS(2321),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2323),
    [anon_sym_or] = ACTIONS(3248),
    [aux_sym_char_token1] = ACTIONS(2323),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2321),
    [anon_sym_DQUOTE] = ACTIONS(2321),
    [anon_sym_AT_DQUOTE] = ACTIONS(2323),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2323),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2323),
    [sym_bool] = ACTIONS(2321),
    [sym_unit] = ACTIONS(2323),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2321),
    [sym_op_identifier] = ACTIONS(2321),
    [anon_sym_PLUS] = ACTIONS(2321),
    [anon_sym_DASH] = ACTIONS(2321),
    [anon_sym_PLUS_DOT] = ACTIONS(2321),
    [anon_sym_DASH_DOT] = ACTIONS(2321),
    [anon_sym_PERCENT] = ACTIONS(2321),
    [anon_sym_AMP_AMP] = ACTIONS(2321),
    [anon_sym_TILDE] = ACTIONS(2323),
    [aux_sym_prefix_op_token1] = ACTIONS(2321),
    [aux_sym_infix_op_token1] = ACTIONS(2323),
    [aux_sym_infix_op_token2] = ACTIONS(2321),
    [anon_sym_PIPE_PIPE] = ACTIONS(2321),
    [anon_sym_BANG_EQ] = ACTIONS(2321),
    [anon_sym_COLON_EQ] = ACTIONS(2323),
    [anon_sym_DOLLAR] = ACTIONS(2321),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2321),
    [sym_int] = ACTIONS(2321),
    [sym_xint] = ACTIONS(2323),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2323),
    [sym__newline] = ACTIONS(2323),
    [sym__dedent] = ACTIONS(2323),
  },
  [1007] = {
    [sym_block_comment] = STATE(1007),
    [sym_compiler_directive_decl] = STATE(1007),
    [sym_fsi_directive_decl] = STATE(1007),
    [sym_preproc_line] = STATE(1007),
    [aux_sym_compound_type_repeat1] = STATE(1007),
    [sym_identifier] = ACTIONS(2250),
    [anon_sym_EQ] = ACTIONS(2248),
    [anon_sym_COLON] = ACTIONS(2250),
    [anon_sym_return] = ACTIONS(2250),
    [anon_sym_do] = ACTIONS(2250),
    [anon_sym_let] = ACTIONS(2250),
    [anon_sym_let_BANG] = ACTIONS(2248),
    [anon_sym_as] = ACTIONS(2250),
    [anon_sym_LPAREN] = ACTIONS(2250),
    [anon_sym_COMMA] = ACTIONS(2248),
    [anon_sym_null] = ACTIONS(2250),
    [anon_sym_QMARK] = ACTIONS(2250),
    [anon_sym_COLON_QMARK] = ACTIONS(2250),
    [anon_sym_COLON_COLON] = ACTIONS(2248),
    [anon_sym_AMP] = ACTIONS(2250),
    [anon_sym_LBRACK] = ACTIONS(2250),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2248),
    [anon_sym_LBRACE] = ACTIONS(2250),
    [anon_sym_LT_AT] = ACTIONS(2250),
    [anon_sym_LT_AT_AT] = ACTIONS(2250),
    [anon_sym_DOT] = ACTIONS(2250),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2248),
    [anon_sym_new] = ACTIONS(2250),
    [anon_sym_with] = ACTIONS(2250),
    [anon_sym_return_BANG] = ACTIONS(2248),
    [anon_sym_yield] = ACTIONS(2250),
    [anon_sym_yield_BANG] = ACTIONS(2248),
    [anon_sym_lazy] = ACTIONS(2250),
    [anon_sym_assert] = ACTIONS(2250),
    [anon_sym_upcast] = ACTIONS(2250),
    [anon_sym_downcast] = ACTIONS(2250),
    [anon_sym_COLON_GT] = ACTIONS(2248),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2248),
    [anon_sym_for] = ACTIONS(2250),
    [anon_sym_while] = ACTIONS(2250),
    [anon_sym_if] = ACTIONS(2250),
    [anon_sym_fun] = ACTIONS(2250),
    [anon_sym_DASH_GT] = ACTIONS(2250),
    [anon_sym_try] = ACTIONS(2250),
    [anon_sym_match] = ACTIONS(2250),
    [anon_sym_match_BANG] = ACTIONS(2248),
    [anon_sym_function] = ACTIONS(2250),
    [anon_sym_LT_DASH] = ACTIONS(2250),
    [anon_sym_DOT_LBRACK] = ACTIONS(2248),
    [anon_sym_LT] = ACTIONS(2248),
    [anon_sym_use] = ACTIONS(2250),
    [anon_sym_use_BANG] = ACTIONS(2248),
    [anon_sym_do_BANG] = ACTIONS(2248),
    [anon_sym_begin] = ACTIONS(2250),
    [anon_sym_LPAREN2] = ACTIONS(2250),
    [anon_sym_STAR] = ACTIONS(3251),
    [anon_sym_LT2] = ACTIONS(2250),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2248),
    [anon_sym_or] = ACTIONS(2250),
    [aux_sym_char_token1] = ACTIONS(2248),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2250),
    [anon_sym_DQUOTE] = ACTIONS(2250),
    [anon_sym_AT_DQUOTE] = ACTIONS(2248),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2248),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2248),
    [sym_bool] = ACTIONS(2250),
    [sym_unit] = ACTIONS(2248),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2250),
    [sym_op_identifier] = ACTIONS(2250),
    [anon_sym_PLUS] = ACTIONS(2250),
    [anon_sym_DASH] = ACTIONS(2250),
    [anon_sym_PLUS_DOT] = ACTIONS(2250),
    [anon_sym_DASH_DOT] = ACTIONS(2250),
    [anon_sym_PERCENT] = ACTIONS(2250),
    [anon_sym_AMP_AMP] = ACTIONS(2250),
    [anon_sym_TILDE] = ACTIONS(2248),
    [aux_sym_prefix_op_token1] = ACTIONS(2250),
    [aux_sym_infix_op_token1] = ACTIONS(2248),
    [aux_sym_infix_op_token2] = ACTIONS(2250),
    [anon_sym_PIPE_PIPE] = ACTIONS(2250),
    [anon_sym_BANG_EQ] = ACTIONS(2250),
    [anon_sym_COLON_EQ] = ACTIONS(2248),
    [anon_sym_DOLLAR] = ACTIONS(2250),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2250),
    [sym_int] = ACTIONS(2250),
    [sym_xint] = ACTIONS(2248),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2248),
    [sym__newline] = ACTIONS(2248),
    [sym__dedent] = ACTIONS(2248),
  },
  [1008] = {
    [sym_block_comment] = STATE(1008),
    [sym_compiler_directive_decl] = STATE(1008),
    [sym_fsi_directive_decl] = STATE(1008),
    [sym_preproc_line] = STATE(1008),
    [sym_identifier] = ACTIONS(2770),
    [anon_sym_EQ] = ACTIONS(2772),
    [anon_sym_GT_RBRACK] = ACTIONS(2772),
    [anon_sym_COLON] = ACTIONS(2770),
    [anon_sym_return] = ACTIONS(2770),
    [anon_sym_do] = ACTIONS(2770),
    [anon_sym_let] = ACTIONS(2770),
    [anon_sym_let_BANG] = ACTIONS(2772),
    [anon_sym_LPAREN] = ACTIONS(2770),
    [anon_sym_COMMA] = ACTIONS(2772),
    [anon_sym_null] = ACTIONS(2770),
    [anon_sym_QMARK] = ACTIONS(2770),
    [anon_sym_COLON_QMARK] = ACTIONS(2770),
    [anon_sym_COLON_COLON] = ACTIONS(2772),
    [anon_sym_AMP] = ACTIONS(2770),
    [anon_sym_LBRACK] = ACTIONS(2770),
    [anon_sym_RBRACK] = ACTIONS(2772),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2772),
    [anon_sym_LBRACE] = ACTIONS(2770),
    [anon_sym_RBRACE] = ACTIONS(2772),
    [anon_sym_LT_AT] = ACTIONS(2770),
    [anon_sym_LT_AT_AT] = ACTIONS(2770),
    [anon_sym_DOT] = ACTIONS(2770),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2772),
    [anon_sym_new] = ACTIONS(2770),
    [anon_sym_with] = ACTIONS(2770),
    [anon_sym_return_BANG] = ACTIONS(2772),
    [anon_sym_yield] = ACTIONS(2770),
    [anon_sym_yield_BANG] = ACTIONS(2772),
    [anon_sym_lazy] = ACTIONS(2770),
    [anon_sym_assert] = ACTIONS(2770),
    [anon_sym_upcast] = ACTIONS(2770),
    [anon_sym_downcast] = ACTIONS(2770),
    [anon_sym_COLON_GT] = ACTIONS(2772),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2772),
    [anon_sym_for] = ACTIONS(2770),
    [anon_sym_to] = ACTIONS(2770),
    [anon_sym_downto] = ACTIONS(2770),
    [anon_sym_done] = ACTIONS(3254),
    [anon_sym_while] = ACTIONS(2770),
    [anon_sym_if] = ACTIONS(2770),
    [anon_sym_fun] = ACTIONS(2770),
    [anon_sym_try] = ACTIONS(2770),
    [anon_sym_match] = ACTIONS(2770),
    [anon_sym_match_BANG] = ACTIONS(2772),
    [anon_sym_function] = ACTIONS(2770),
    [anon_sym_LT_DASH] = ACTIONS(2770),
    [anon_sym_DOT_LBRACK] = ACTIONS(2772),
    [anon_sym_LT] = ACTIONS(2772),
    [anon_sym_use] = ACTIONS(2770),
    [anon_sym_use_BANG] = ACTIONS(2772),
    [anon_sym_do_BANG] = ACTIONS(2772),
    [anon_sym_begin] = ACTIONS(2770),
    [anon_sym_LPAREN2] = ACTIONS(2770),
    [anon_sym_DOT_DOT2] = ACTIONS(2772),
    [anon_sym_or] = ACTIONS(2770),
    [aux_sym_char_token1] = ACTIONS(2772),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2770),
    [anon_sym_DQUOTE] = ACTIONS(2770),
    [anon_sym_AT_DQUOTE] = ACTIONS(2772),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2772),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2772),
    [sym_bool] = ACTIONS(2770),
    [sym_unit] = ACTIONS(2772),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2770),
    [sym_op_identifier] = ACTIONS(2770),
    [anon_sym_PLUS] = ACTIONS(2770),
    [anon_sym_DASH] = ACTIONS(2770),
    [anon_sym_PLUS_DOT] = ACTIONS(2770),
    [anon_sym_DASH_DOT] = ACTIONS(2770),
    [anon_sym_PERCENT] = ACTIONS(2770),
    [anon_sym_AMP_AMP] = ACTIONS(2770),
    [anon_sym_TILDE] = ACTIONS(2772),
    [aux_sym_prefix_op_token1] = ACTIONS(2770),
    [aux_sym_infix_op_token1] = ACTIONS(2772),
    [aux_sym_infix_op_token2] = ACTIONS(2770),
    [anon_sym_PIPE_PIPE] = ACTIONS(2770),
    [anon_sym_BANG_EQ] = ACTIONS(2770),
    [anon_sym_COLON_EQ] = ACTIONS(2772),
    [anon_sym_DOLLAR] = ACTIONS(2770),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2770),
    [sym_int] = ACTIONS(2770),
    [sym_xint] = ACTIONS(2772),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2772),
    [sym__newline] = ACTIONS(2772),
  },
  [1009] = {
    [sym_type_arguments] = STATE(1312),
    [sym_long_identifier] = STATE(1292),
    [sym_block_comment] = STATE(1009),
    [sym_compiler_directive_decl] = STATE(1009),
    [sym_fsi_directive_decl] = STATE(1009),
    [sym_preproc_line] = STATE(1009),
    [aux_sym_compound_type_repeat1] = STATE(1249),
    [sym_identifier] = ACTIONS(3214),
    [anon_sym_EQ] = ACTIONS(2248),
    [anon_sym_COLON] = ACTIONS(2250),
    [anon_sym_return] = ACTIONS(2250),
    [anon_sym_do] = ACTIONS(2250),
    [anon_sym_let] = ACTIONS(2250),
    [anon_sym_let_BANG] = ACTIONS(2248),
    [anon_sym_LPAREN] = ACTIONS(2250),
    [anon_sym_COMMA] = ACTIONS(2248),
    [anon_sym_null] = ACTIONS(2250),
    [anon_sym_QMARK] = ACTIONS(2250),
    [anon_sym_COLON_QMARK] = ACTIONS(2250),
    [anon_sym_COLON_COLON] = ACTIONS(2248),
    [anon_sym_AMP] = ACTIONS(2250),
    [anon_sym_LBRACK] = ACTIONS(2250),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2248),
    [anon_sym_LBRACE] = ACTIONS(2250),
    [anon_sym_LT_AT] = ACTIONS(2250),
    [anon_sym_LT_AT_AT] = ACTIONS(2250),
    [anon_sym_DOT] = ACTIONS(2250),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2248),
    [anon_sym_new] = ACTIONS(2250),
    [anon_sym_return_BANG] = ACTIONS(2248),
    [anon_sym_yield] = ACTIONS(2250),
    [anon_sym_yield_BANG] = ACTIONS(2248),
    [anon_sym_lazy] = ACTIONS(2250),
    [anon_sym_assert] = ACTIONS(2250),
    [anon_sym_upcast] = ACTIONS(2250),
    [anon_sym_downcast] = ACTIONS(2250),
    [anon_sym_COLON_GT] = ACTIONS(2248),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2248),
    [anon_sym_for] = ACTIONS(2250),
    [anon_sym_while] = ACTIONS(2250),
    [anon_sym_if] = ACTIONS(2250),
    [anon_sym_fun] = ACTIONS(2250),
    [anon_sym_DASH_GT] = ACTIONS(3216),
    [anon_sym_try] = ACTIONS(2250),
    [anon_sym_match] = ACTIONS(2250),
    [anon_sym_match_BANG] = ACTIONS(2248),
    [anon_sym_function] = ACTIONS(2250),
    [anon_sym_LT_DASH] = ACTIONS(2250),
    [anon_sym_DOT_LBRACK] = ACTIONS(2248),
    [anon_sym_LT] = ACTIONS(2248),
    [anon_sym_GT] = ACTIONS(2250),
    [anon_sym_use] = ACTIONS(2250),
    [anon_sym_use_BANG] = ACTIONS(2248),
    [anon_sym_do_BANG] = ACTIONS(2248),
    [anon_sym_begin] = ACTIONS(2250),
    [anon_sym_LPAREN2] = ACTIONS(2250),
    [anon_sym_STAR] = ACTIONS(3218),
    [anon_sym_LT2] = ACTIONS(3220),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3222),
    [anon_sym_or] = ACTIONS(2250),
    [aux_sym_char_token1] = ACTIONS(2248),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2250),
    [anon_sym_DQUOTE] = ACTIONS(2250),
    [anon_sym_AT_DQUOTE] = ACTIONS(2248),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2248),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2248),
    [sym_bool] = ACTIONS(2250),
    [sym_unit] = ACTIONS(2248),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2250),
    [sym_op_identifier] = ACTIONS(2250),
    [anon_sym_PLUS] = ACTIONS(2250),
    [anon_sym_DASH] = ACTIONS(2250),
    [anon_sym_PLUS_DOT] = ACTIONS(2250),
    [anon_sym_DASH_DOT] = ACTIONS(2250),
    [anon_sym_PERCENT] = ACTIONS(2250),
    [anon_sym_AMP_AMP] = ACTIONS(2250),
    [anon_sym_TILDE] = ACTIONS(2248),
    [aux_sym_prefix_op_token1] = ACTIONS(2250),
    [aux_sym_infix_op_token1] = ACTIONS(2248),
    [aux_sym_infix_op_token2] = ACTIONS(2250),
    [anon_sym_PIPE_PIPE] = ACTIONS(2250),
    [anon_sym_BANG_EQ] = ACTIONS(2250),
    [anon_sym_COLON_EQ] = ACTIONS(2248),
    [anon_sym_DOLLAR] = ACTIONS(2250),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2250),
    [sym_int] = ACTIONS(2250),
    [sym_xint] = ACTIONS(2248),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2248),
    [sym__newline] = ACTIONS(2248),
  },
  [1010] = {
    [sym_type_arguments] = STATE(1334),
    [sym_long_identifier] = STATE(1346),
    [sym_block_comment] = STATE(1010),
    [sym_compiler_directive_decl] = STATE(1010),
    [sym_fsi_directive_decl] = STATE(1010),
    [sym_preproc_line] = STATE(1010),
    [aux_sym_compound_type_repeat1] = STATE(1233),
    [sym_identifier] = ACTIONS(2252),
    [anon_sym_EQ] = ACTIONS(2254),
    [anon_sym_COLON] = ACTIONS(2252),
    [anon_sym_return] = ACTIONS(2252),
    [anon_sym_do] = ACTIONS(2252),
    [anon_sym_let] = ACTIONS(2252),
    [anon_sym_let_BANG] = ACTIONS(2254),
    [anon_sym_LPAREN] = ACTIONS(2252),
    [anon_sym_COMMA] = ACTIONS(2254),
    [anon_sym_null] = ACTIONS(2252),
    [anon_sym_QMARK] = ACTIONS(2252),
    [anon_sym_COLON_QMARK] = ACTIONS(2252),
    [anon_sym_COLON_COLON] = ACTIONS(2254),
    [anon_sym_AMP] = ACTIONS(2252),
    [anon_sym_LBRACK] = ACTIONS(2252),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2254),
    [anon_sym_LBRACE] = ACTIONS(2252),
    [anon_sym_LT_AT] = ACTIONS(2252),
    [anon_sym_LT_AT_AT] = ACTIONS(2252),
    [anon_sym_DOT] = ACTIONS(2252),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2254),
    [anon_sym_new] = ACTIONS(2252),
    [anon_sym_return_BANG] = ACTIONS(2254),
    [anon_sym_yield] = ACTIONS(2252),
    [anon_sym_yield_BANG] = ACTIONS(2254),
    [anon_sym_lazy] = ACTIONS(2252),
    [anon_sym_assert] = ACTIONS(2252),
    [anon_sym_upcast] = ACTIONS(2252),
    [anon_sym_downcast] = ACTIONS(2252),
    [anon_sym_COLON_GT] = ACTIONS(2254),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2254),
    [anon_sym_for] = ACTIONS(2252),
    [anon_sym_while] = ACTIONS(2252),
    [anon_sym_if] = ACTIONS(2252),
    [anon_sym_fun] = ACTIONS(2252),
    [anon_sym_DASH_GT] = ACTIONS(2252),
    [anon_sym_try] = ACTIONS(2252),
    [anon_sym_match] = ACTIONS(2252),
    [anon_sym_match_BANG] = ACTIONS(2254),
    [anon_sym_function] = ACTIONS(2252),
    [anon_sym_LT_DASH] = ACTIONS(2252),
    [anon_sym_DOT_LBRACK] = ACTIONS(2254),
    [anon_sym_LT] = ACTIONS(2254),
    [anon_sym_use] = ACTIONS(2252),
    [anon_sym_use_BANG] = ACTIONS(2254),
    [anon_sym_do_BANG] = ACTIONS(2254),
    [anon_sym_DOT_DOT] = ACTIONS(2254),
    [anon_sym_begin] = ACTIONS(2252),
    [anon_sym_LPAREN2] = ACTIONS(2252),
    [anon_sym_STAR] = ACTIONS(3256),
    [anon_sym_LT2] = ACTIONS(3258),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3260),
    [anon_sym_or] = ACTIONS(2252),
    [aux_sym_char_token1] = ACTIONS(2254),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2252),
    [anon_sym_DQUOTE] = ACTIONS(2252),
    [anon_sym_AT_DQUOTE] = ACTIONS(2254),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2254),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2254),
    [sym_bool] = ACTIONS(2252),
    [sym_unit] = ACTIONS(2254),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2252),
    [sym_op_identifier] = ACTIONS(2252),
    [anon_sym_PLUS] = ACTIONS(2252),
    [anon_sym_DASH] = ACTIONS(2252),
    [anon_sym_PLUS_DOT] = ACTIONS(2252),
    [anon_sym_DASH_DOT] = ACTIONS(2252),
    [anon_sym_PERCENT] = ACTIONS(2252),
    [anon_sym_AMP_AMP] = ACTIONS(2252),
    [anon_sym_TILDE] = ACTIONS(2254),
    [aux_sym_prefix_op_token1] = ACTIONS(2252),
    [aux_sym_infix_op_token1] = ACTIONS(2254),
    [aux_sym_infix_op_token2] = ACTIONS(2252),
    [anon_sym_PIPE_PIPE] = ACTIONS(2252),
    [anon_sym_BANG_EQ] = ACTIONS(2252),
    [anon_sym_COLON_EQ] = ACTIONS(2254),
    [anon_sym_DOLLAR] = ACTIONS(2252),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2252),
    [sym_int] = ACTIONS(2252),
    [sym_xint] = ACTIONS(2254),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2254),
    [sym__newline] = ACTIONS(2254),
  },
  [1011] = {
    [sym_block_comment] = STATE(1011),
    [sym_compiler_directive_decl] = STATE(1011),
    [sym_fsi_directive_decl] = STATE(1011),
    [sym_preproc_line] = STATE(1011),
    [aux_sym_compound_type_repeat1] = STATE(1007),
    [sym_identifier] = ACTIONS(2407),
    [anon_sym_EQ] = ACTIONS(2409),
    [anon_sym_COLON] = ACTIONS(2407),
    [anon_sym_return] = ACTIONS(2407),
    [anon_sym_do] = ACTIONS(2407),
    [anon_sym_let] = ACTIONS(2407),
    [anon_sym_let_BANG] = ACTIONS(2409),
    [anon_sym_as] = ACTIONS(2407),
    [anon_sym_LPAREN] = ACTIONS(2407),
    [anon_sym_COMMA] = ACTIONS(2409),
    [anon_sym_null] = ACTIONS(2407),
    [anon_sym_QMARK] = ACTIONS(2407),
    [anon_sym_COLON_QMARK] = ACTIONS(2407),
    [anon_sym_COLON_COLON] = ACTIONS(2409),
    [anon_sym_AMP] = ACTIONS(2407),
    [anon_sym_LBRACK] = ACTIONS(2407),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2409),
    [anon_sym_LBRACE] = ACTIONS(2407),
    [anon_sym_LT_AT] = ACTIONS(2407),
    [anon_sym_LT_AT_AT] = ACTIONS(2407),
    [anon_sym_DOT] = ACTIONS(2407),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2409),
    [anon_sym_new] = ACTIONS(2407),
    [anon_sym_with] = ACTIONS(2407),
    [anon_sym_return_BANG] = ACTIONS(2409),
    [anon_sym_yield] = ACTIONS(2407),
    [anon_sym_yield_BANG] = ACTIONS(2409),
    [anon_sym_lazy] = ACTIONS(2407),
    [anon_sym_assert] = ACTIONS(2407),
    [anon_sym_upcast] = ACTIONS(2407),
    [anon_sym_downcast] = ACTIONS(2407),
    [anon_sym_COLON_GT] = ACTIONS(2409),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2409),
    [anon_sym_for] = ACTIONS(2407),
    [anon_sym_while] = ACTIONS(2407),
    [anon_sym_if] = ACTIONS(2407),
    [anon_sym_fun] = ACTIONS(2407),
    [anon_sym_DASH_GT] = ACTIONS(2407),
    [anon_sym_try] = ACTIONS(2407),
    [anon_sym_match] = ACTIONS(2407),
    [anon_sym_match_BANG] = ACTIONS(2409),
    [anon_sym_function] = ACTIONS(2407),
    [anon_sym_LT_DASH] = ACTIONS(2407),
    [anon_sym_DOT_LBRACK] = ACTIONS(2409),
    [anon_sym_LT] = ACTIONS(2409),
    [anon_sym_use] = ACTIONS(2407),
    [anon_sym_use_BANG] = ACTIONS(2409),
    [anon_sym_do_BANG] = ACTIONS(2409),
    [anon_sym_begin] = ACTIONS(2407),
    [anon_sym_LPAREN2] = ACTIONS(2407),
    [anon_sym_STAR] = ACTIONS(3145),
    [anon_sym_LT2] = ACTIONS(2407),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2409),
    [anon_sym_or] = ACTIONS(2407),
    [aux_sym_char_token1] = ACTIONS(2409),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2407),
    [anon_sym_DQUOTE] = ACTIONS(2407),
    [anon_sym_AT_DQUOTE] = ACTIONS(2409),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2409),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2409),
    [sym_bool] = ACTIONS(2407),
    [sym_unit] = ACTIONS(2409),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2407),
    [sym_op_identifier] = ACTIONS(2407),
    [anon_sym_PLUS] = ACTIONS(2407),
    [anon_sym_DASH] = ACTIONS(2407),
    [anon_sym_PLUS_DOT] = ACTIONS(2407),
    [anon_sym_DASH_DOT] = ACTIONS(2407),
    [anon_sym_PERCENT] = ACTIONS(2407),
    [anon_sym_AMP_AMP] = ACTIONS(2407),
    [anon_sym_TILDE] = ACTIONS(2409),
    [aux_sym_prefix_op_token1] = ACTIONS(2407),
    [aux_sym_infix_op_token1] = ACTIONS(2409),
    [aux_sym_infix_op_token2] = ACTIONS(2407),
    [anon_sym_PIPE_PIPE] = ACTIONS(2407),
    [anon_sym_BANG_EQ] = ACTIONS(2407),
    [anon_sym_COLON_EQ] = ACTIONS(2409),
    [anon_sym_DOLLAR] = ACTIONS(2407),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2407),
    [sym_int] = ACTIONS(2407),
    [sym_xint] = ACTIONS(2409),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2409),
    [sym__newline] = ACTIONS(2409),
    [sym__dedent] = ACTIONS(2409),
  },
  [1012] = {
    [sym_block_comment] = STATE(1012),
    [sym_compiler_directive_decl] = STATE(1012),
    [sym_fsi_directive_decl] = STATE(1012),
    [sym_preproc_line] = STATE(1012),
    [sym_identifier] = ACTIONS(2760),
    [anon_sym_EQ] = ACTIONS(2762),
    [anon_sym_GT_RBRACK] = ACTIONS(2762),
    [anon_sym_COLON] = ACTIONS(2760),
    [anon_sym_return] = ACTIONS(2760),
    [anon_sym_do] = ACTIONS(2760),
    [anon_sym_let] = ACTIONS(2760),
    [anon_sym_let_BANG] = ACTIONS(2762),
    [anon_sym_LPAREN] = ACTIONS(2760),
    [anon_sym_COMMA] = ACTIONS(2762),
    [anon_sym_null] = ACTIONS(2760),
    [anon_sym_QMARK] = ACTIONS(2760),
    [anon_sym_COLON_QMARK] = ACTIONS(2760),
    [anon_sym_COLON_COLON] = ACTIONS(2762),
    [anon_sym_PIPE] = ACTIONS(2760),
    [anon_sym_AMP] = ACTIONS(2760),
    [anon_sym_LBRACK] = ACTIONS(2760),
    [anon_sym_RBRACK] = ACTIONS(2762),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2762),
    [anon_sym_LBRACE] = ACTIONS(2760),
    [anon_sym_RBRACE] = ACTIONS(2762),
    [anon_sym_LT_AT] = ACTIONS(2760),
    [anon_sym_LT_AT_AT] = ACTIONS(2760),
    [anon_sym_DOT] = ACTIONS(2760),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2762),
    [anon_sym_new] = ACTIONS(2760),
    [anon_sym_with] = ACTIONS(2760),
    [anon_sym_return_BANG] = ACTIONS(2762),
    [anon_sym_yield] = ACTIONS(2760),
    [anon_sym_yield_BANG] = ACTIONS(2762),
    [anon_sym_lazy] = ACTIONS(2760),
    [anon_sym_assert] = ACTIONS(2760),
    [anon_sym_upcast] = ACTIONS(2760),
    [anon_sym_downcast] = ACTIONS(2760),
    [anon_sym_COLON_GT] = ACTIONS(2762),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2762),
    [anon_sym_for] = ACTIONS(2760),
    [anon_sym_to] = ACTIONS(2760),
    [anon_sym_downto] = ACTIONS(2760),
    [anon_sym_while] = ACTIONS(2760),
    [anon_sym_if] = ACTIONS(2760),
    [anon_sym_fun] = ACTIONS(2760),
    [anon_sym_try] = ACTIONS(2760),
    [anon_sym_match] = ACTIONS(2760),
    [anon_sym_match_BANG] = ACTIONS(2762),
    [anon_sym_function] = ACTIONS(2760),
    [anon_sym_LT_DASH] = ACTIONS(2760),
    [anon_sym_DOT_LBRACK] = ACTIONS(2762),
    [anon_sym_LT] = ACTIONS(2762),
    [anon_sym_use] = ACTIONS(2760),
    [anon_sym_use_BANG] = ACTIONS(2762),
    [anon_sym_do_BANG] = ACTIONS(2762),
    [anon_sym_begin] = ACTIONS(2760),
    [anon_sym_LPAREN2] = ACTIONS(2760),
    [anon_sym_DOT_DOT2] = ACTIONS(2762),
    [anon_sym_or] = ACTIONS(2760),
    [aux_sym_char_token1] = ACTIONS(2762),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2760),
    [anon_sym_DQUOTE] = ACTIONS(2760),
    [anon_sym_AT_DQUOTE] = ACTIONS(2762),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2762),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2762),
    [sym_bool] = ACTIONS(2760),
    [sym_unit] = ACTIONS(2762),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2760),
    [sym_op_identifier] = ACTIONS(2760),
    [anon_sym_PLUS] = ACTIONS(2760),
    [anon_sym_DASH] = ACTIONS(2760),
    [anon_sym_PLUS_DOT] = ACTIONS(2760),
    [anon_sym_DASH_DOT] = ACTIONS(2760),
    [anon_sym_PERCENT] = ACTIONS(2760),
    [anon_sym_AMP_AMP] = ACTIONS(2760),
    [anon_sym_TILDE] = ACTIONS(2762),
    [aux_sym_prefix_op_token1] = ACTIONS(2760),
    [aux_sym_infix_op_token1] = ACTIONS(2762),
    [aux_sym_infix_op_token2] = ACTIONS(2760),
    [anon_sym_PIPE_PIPE] = ACTIONS(2760),
    [anon_sym_BANG_EQ] = ACTIONS(2760),
    [anon_sym_COLON_EQ] = ACTIONS(2762),
    [anon_sym_DOLLAR] = ACTIONS(2760),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2760),
    [sym_int] = ACTIONS(2760),
    [sym_xint] = ACTIONS(2762),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2762),
    [sym__newline] = ACTIONS(2762),
  },
  [1013] = {
    [sym_type_arguments] = STATE(1297),
    [sym_long_identifier] = STATE(1303),
    [sym_block_comment] = STATE(1013),
    [sym_compiler_directive_decl] = STATE(1013),
    [sym_fsi_directive_decl] = STATE(1013),
    [sym_preproc_line] = STATE(1013),
    [aux_sym_compound_type_repeat1] = STATE(1259),
    [sym_identifier] = ACTIONS(3236),
    [anon_sym_EQ] = ACTIONS(2228),
    [anon_sym_COLON] = ACTIONS(2230),
    [anon_sym_return] = ACTIONS(2230),
    [anon_sym_do] = ACTIONS(2230),
    [anon_sym_let] = ACTIONS(2230),
    [anon_sym_let_BANG] = ACTIONS(2228),
    [anon_sym_LPAREN] = ACTIONS(2230),
    [anon_sym_COMMA] = ACTIONS(2228),
    [anon_sym_null] = ACTIONS(2230),
    [anon_sym_QMARK] = ACTIONS(2230),
    [anon_sym_COLON_QMARK] = ACTIONS(2230),
    [anon_sym_COLON_COLON] = ACTIONS(2228),
    [anon_sym_AMP] = ACTIONS(2230),
    [anon_sym_LBRACK] = ACTIONS(2230),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2228),
    [anon_sym_LBRACE] = ACTIONS(2230),
    [anon_sym_LT_AT] = ACTIONS(2230),
    [anon_sym_LT_AT_AT] = ACTIONS(2230),
    [anon_sym_DOT] = ACTIONS(2230),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2228),
    [anon_sym_new] = ACTIONS(2230),
    [anon_sym_return_BANG] = ACTIONS(2228),
    [anon_sym_yield] = ACTIONS(2230),
    [anon_sym_yield_BANG] = ACTIONS(2228),
    [anon_sym_lazy] = ACTIONS(2230),
    [anon_sym_assert] = ACTIONS(2230),
    [anon_sym_upcast] = ACTIONS(2230),
    [anon_sym_downcast] = ACTIONS(2230),
    [anon_sym_COLON_GT] = ACTIONS(2228),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2228),
    [anon_sym_for] = ACTIONS(2230),
    [anon_sym_while] = ACTIONS(2230),
    [anon_sym_if] = ACTIONS(2230),
    [anon_sym_fun] = ACTIONS(2230),
    [anon_sym_DASH_GT] = ACTIONS(3238),
    [anon_sym_try] = ACTIONS(2230),
    [anon_sym_match] = ACTIONS(2230),
    [anon_sym_match_BANG] = ACTIONS(2228),
    [anon_sym_function] = ACTIONS(2230),
    [anon_sym_LT_DASH] = ACTIONS(2230),
    [anon_sym_DOT_LBRACK] = ACTIONS(2228),
    [anon_sym_LT] = ACTIONS(2228),
    [anon_sym_use] = ACTIONS(2230),
    [anon_sym_use_BANG] = ACTIONS(2228),
    [anon_sym_do_BANG] = ACTIONS(2228),
    [anon_sym_begin] = ACTIONS(2230),
    [anon_sym_LPAREN2] = ACTIONS(2230),
    [anon_sym_STAR] = ACTIONS(3240),
    [anon_sym_LT2] = ACTIONS(3242),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3244),
    [anon_sym_or] = ACTIONS(2230),
    [aux_sym_char_token1] = ACTIONS(2228),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2230),
    [anon_sym_DQUOTE] = ACTIONS(2230),
    [anon_sym_AT_DQUOTE] = ACTIONS(2228),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2228),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2228),
    [sym_bool] = ACTIONS(2230),
    [sym_unit] = ACTIONS(2228),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2230),
    [sym_op_identifier] = ACTIONS(2230),
    [anon_sym_PLUS] = ACTIONS(2230),
    [anon_sym_DASH] = ACTIONS(2230),
    [anon_sym_PLUS_DOT] = ACTIONS(2230),
    [anon_sym_DASH_DOT] = ACTIONS(2230),
    [anon_sym_PERCENT] = ACTIONS(2230),
    [anon_sym_AMP_AMP] = ACTIONS(2230),
    [anon_sym_TILDE] = ACTIONS(2228),
    [aux_sym_prefix_op_token1] = ACTIONS(2230),
    [aux_sym_infix_op_token1] = ACTIONS(2228),
    [aux_sym_infix_op_token2] = ACTIONS(2230),
    [anon_sym_PIPE_PIPE] = ACTIONS(2230),
    [anon_sym_BANG_EQ] = ACTIONS(2230),
    [anon_sym_COLON_EQ] = ACTIONS(2228),
    [anon_sym_DOLLAR] = ACTIONS(2230),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2230),
    [sym_int] = ACTIONS(2230),
    [sym_xint] = ACTIONS(2228),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2228),
    [anon_sym_POUNDendif] = ACTIONS(2228),
    [sym__newline] = ACTIONS(2228),
  },
  [1014] = {
    [sym__else_expression] = STATE(1584),
    [sym_elif_expression] = STATE(1391),
    [sym_block_comment] = STATE(1014),
    [sym_compiler_directive_decl] = STATE(1014),
    [sym_fsi_directive_decl] = STATE(1014),
    [sym_preproc_line] = STATE(1014),
    [aux_sym_if_expression_repeat1] = STATE(996),
    [sym_identifier] = ACTIONS(2422),
    [anon_sym_EQ] = ACTIONS(2424),
    [anon_sym_COLON] = ACTIONS(2422),
    [anon_sym_return] = ACTIONS(2422),
    [anon_sym_do] = ACTIONS(2422),
    [anon_sym_let] = ACTIONS(2422),
    [anon_sym_let_BANG] = ACTIONS(2424),
    [anon_sym_as] = ACTIONS(2422),
    [anon_sym_LPAREN] = ACTIONS(2422),
    [anon_sym_COMMA] = ACTIONS(2424),
    [anon_sym_null] = ACTIONS(2422),
    [anon_sym_QMARK] = ACTIONS(2422),
    [anon_sym_COLON_QMARK] = ACTIONS(2422),
    [anon_sym_COLON_COLON] = ACTIONS(2424),
    [anon_sym_AMP] = ACTIONS(2422),
    [anon_sym_LBRACK] = ACTIONS(2422),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2424),
    [anon_sym_LBRACE] = ACTIONS(2422),
    [anon_sym_LT_AT] = ACTIONS(2422),
    [anon_sym_LT_AT_AT] = ACTIONS(2422),
    [anon_sym_DOT] = ACTIONS(2422),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2424),
    [anon_sym_new] = ACTIONS(2422),
    [anon_sym_with] = ACTIONS(2422),
    [anon_sym_return_BANG] = ACTIONS(2424),
    [anon_sym_yield] = ACTIONS(2422),
    [anon_sym_yield_BANG] = ACTIONS(2424),
    [anon_sym_lazy] = ACTIONS(2422),
    [anon_sym_assert] = ACTIONS(2422),
    [anon_sym_upcast] = ACTIONS(2422),
    [anon_sym_downcast] = ACTIONS(2422),
    [anon_sym_COLON_GT] = ACTIONS(2424),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2424),
    [anon_sym_for] = ACTIONS(2422),
    [anon_sym_while] = ACTIONS(2422),
    [anon_sym_else] = ACTIONS(3232),
    [anon_sym_elif] = ACTIONS(3234),
    [anon_sym_if] = ACTIONS(2422),
    [anon_sym_fun] = ACTIONS(2422),
    [anon_sym_try] = ACTIONS(2422),
    [anon_sym_match] = ACTIONS(2422),
    [anon_sym_match_BANG] = ACTIONS(2424),
    [anon_sym_function] = ACTIONS(2422),
    [anon_sym_LT_DASH] = ACTIONS(2422),
    [anon_sym_DOT_LBRACK] = ACTIONS(2424),
    [anon_sym_LT] = ACTIONS(2424),
    [anon_sym_use] = ACTIONS(2422),
    [anon_sym_use_BANG] = ACTIONS(2424),
    [anon_sym_do_BANG] = ACTIONS(2424),
    [anon_sym_begin] = ACTIONS(2422),
    [anon_sym_LPAREN2] = ACTIONS(2422),
    [anon_sym_or] = ACTIONS(2422),
    [aux_sym_char_token1] = ACTIONS(2424),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2422),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_AT_DQUOTE] = ACTIONS(2424),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2424),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2424),
    [sym_bool] = ACTIONS(2422),
    [sym_unit] = ACTIONS(2424),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2422),
    [sym_op_identifier] = ACTIONS(2422),
    [anon_sym_PLUS] = ACTIONS(2422),
    [anon_sym_DASH] = ACTIONS(2422),
    [anon_sym_PLUS_DOT] = ACTIONS(2422),
    [anon_sym_DASH_DOT] = ACTIONS(2422),
    [anon_sym_PERCENT] = ACTIONS(2422),
    [anon_sym_AMP_AMP] = ACTIONS(2422),
    [anon_sym_TILDE] = ACTIONS(2424),
    [aux_sym_prefix_op_token1] = ACTIONS(2422),
    [aux_sym_infix_op_token1] = ACTIONS(2424),
    [aux_sym_infix_op_token2] = ACTIONS(2422),
    [anon_sym_PIPE_PIPE] = ACTIONS(2422),
    [anon_sym_BANG_EQ] = ACTIONS(2422),
    [anon_sym_COLON_EQ] = ACTIONS(2424),
    [anon_sym_DOLLAR] = ACTIONS(2422),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2422),
    [sym_int] = ACTIONS(2422),
    [sym_xint] = ACTIONS(2424),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2424),
    [sym__newline] = ACTIONS(2424),
    [sym__dedent] = ACTIONS(2424),
  },
  [1015] = {
    [sym_type_arguments] = STATE(1285),
    [sym_long_identifier] = STATE(1378),
    [sym_block_comment] = STATE(1015),
    [sym_compiler_directive_decl] = STATE(1015),
    [sym_fsi_directive_decl] = STATE(1015),
    [sym_preproc_line] = STATE(1015),
    [aux_sym_compound_type_repeat1] = STATE(1268),
    [sym_identifier] = ACTIONS(2252),
    [anon_sym_EQ] = ACTIONS(2254),
    [anon_sym_COLON] = ACTIONS(2252),
    [anon_sym_return] = ACTIONS(2252),
    [anon_sym_do] = ACTIONS(2252),
    [anon_sym_let] = ACTIONS(2252),
    [anon_sym_let_BANG] = ACTIONS(2254),
    [anon_sym_LPAREN] = ACTIONS(2252),
    [anon_sym_COMMA] = ACTIONS(2254),
    [anon_sym_null] = ACTIONS(2252),
    [anon_sym_QMARK] = ACTIONS(2252),
    [anon_sym_COLON_QMARK] = ACTIONS(2252),
    [anon_sym_COLON_COLON] = ACTIONS(2254),
    [anon_sym_AMP] = ACTIONS(2252),
    [anon_sym_LBRACK] = ACTIONS(2252),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2254),
    [anon_sym_LBRACE] = ACTIONS(2252),
    [anon_sym_LT_AT] = ACTIONS(2252),
    [anon_sym_AT_GT] = ACTIONS(2252),
    [anon_sym_LT_AT_AT] = ACTIONS(2252),
    [anon_sym_DOT] = ACTIONS(2252),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2254),
    [anon_sym_new] = ACTIONS(2252),
    [anon_sym_return_BANG] = ACTIONS(2254),
    [anon_sym_yield] = ACTIONS(2252),
    [anon_sym_yield_BANG] = ACTIONS(2254),
    [anon_sym_lazy] = ACTIONS(2252),
    [anon_sym_assert] = ACTIONS(2252),
    [anon_sym_upcast] = ACTIONS(2252),
    [anon_sym_downcast] = ACTIONS(2252),
    [anon_sym_COLON_GT] = ACTIONS(2254),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2254),
    [anon_sym_for] = ACTIONS(2252),
    [anon_sym_while] = ACTIONS(2252),
    [anon_sym_if] = ACTIONS(2252),
    [anon_sym_fun] = ACTIONS(2252),
    [anon_sym_DASH_GT] = ACTIONS(3206),
    [anon_sym_try] = ACTIONS(2252),
    [anon_sym_match] = ACTIONS(2252),
    [anon_sym_match_BANG] = ACTIONS(2254),
    [anon_sym_function] = ACTIONS(2252),
    [anon_sym_LT_DASH] = ACTIONS(2252),
    [anon_sym_DOT_LBRACK] = ACTIONS(2254),
    [anon_sym_LT] = ACTIONS(2254),
    [anon_sym_use] = ACTIONS(2252),
    [anon_sym_use_BANG] = ACTIONS(2254),
    [anon_sym_do_BANG] = ACTIONS(2254),
    [anon_sym_begin] = ACTIONS(2252),
    [anon_sym_LPAREN2] = ACTIONS(2252),
    [anon_sym_STAR] = ACTIONS(3208),
    [anon_sym_LT2] = ACTIONS(3210),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3212),
    [anon_sym_or] = ACTIONS(2252),
    [aux_sym_char_token1] = ACTIONS(2254),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2252),
    [anon_sym_DQUOTE] = ACTIONS(2252),
    [anon_sym_AT_DQUOTE] = ACTIONS(2254),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2254),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2254),
    [sym_bool] = ACTIONS(2252),
    [sym_unit] = ACTIONS(2254),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2252),
    [sym_op_identifier] = ACTIONS(2252),
    [anon_sym_PLUS] = ACTIONS(2252),
    [anon_sym_DASH] = ACTIONS(2252),
    [anon_sym_PLUS_DOT] = ACTIONS(2252),
    [anon_sym_DASH_DOT] = ACTIONS(2252),
    [anon_sym_PERCENT] = ACTIONS(2252),
    [anon_sym_AMP_AMP] = ACTIONS(2252),
    [anon_sym_TILDE] = ACTIONS(2254),
    [aux_sym_prefix_op_token1] = ACTIONS(2252),
    [aux_sym_infix_op_token1] = ACTIONS(2254),
    [aux_sym_infix_op_token2] = ACTIONS(2252),
    [anon_sym_PIPE_PIPE] = ACTIONS(2252),
    [anon_sym_BANG_EQ] = ACTIONS(2252),
    [anon_sym_COLON_EQ] = ACTIONS(2254),
    [anon_sym_DOLLAR] = ACTIONS(2252),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2252),
    [sym_int] = ACTIONS(2252),
    [sym_xint] = ACTIONS(2254),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2254),
    [sym__newline] = ACTIONS(2254),
  },
  [1016] = {
    [sym_block_comment] = STATE(1016),
    [sym_compiler_directive_decl] = STATE(1016),
    [sym_fsi_directive_decl] = STATE(1016),
    [sym_preproc_line] = STATE(1016),
    [aux_sym_long_identifier_repeat1] = STATE(1016),
    [sym_identifier] = ACTIONS(2411),
    [anon_sym_EQ] = ACTIONS(2413),
    [anon_sym_COLON] = ACTIONS(2411),
    [anon_sym_return] = ACTIONS(2411),
    [anon_sym_do] = ACTIONS(2411),
    [anon_sym_let] = ACTIONS(2411),
    [anon_sym_let_BANG] = ACTIONS(2413),
    [anon_sym_as] = ACTIONS(2411),
    [anon_sym_LPAREN] = ACTIONS(2411),
    [anon_sym_COMMA] = ACTIONS(2413),
    [anon_sym_null] = ACTIONS(2411),
    [anon_sym_QMARK] = ACTIONS(2411),
    [anon_sym_COLON_QMARK] = ACTIONS(2411),
    [anon_sym_COLON_COLON] = ACTIONS(2413),
    [anon_sym_AMP] = ACTIONS(2411),
    [anon_sym_LBRACK] = ACTIONS(2411),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2413),
    [anon_sym_LBRACE] = ACTIONS(2411),
    [anon_sym_LT_AT] = ACTIONS(2411),
    [anon_sym_LT_AT_AT] = ACTIONS(2411),
    [anon_sym_DOT] = ACTIONS(3262),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2413),
    [anon_sym_new] = ACTIONS(2411),
    [anon_sym_with] = ACTIONS(2411),
    [anon_sym_return_BANG] = ACTIONS(2413),
    [anon_sym_yield] = ACTIONS(2411),
    [anon_sym_yield_BANG] = ACTIONS(2413),
    [anon_sym_lazy] = ACTIONS(2411),
    [anon_sym_assert] = ACTIONS(2411),
    [anon_sym_upcast] = ACTIONS(2411),
    [anon_sym_downcast] = ACTIONS(2411),
    [anon_sym_COLON_GT] = ACTIONS(2413),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2413),
    [anon_sym_for] = ACTIONS(2411),
    [anon_sym_while] = ACTIONS(2411),
    [anon_sym_if] = ACTIONS(2411),
    [anon_sym_fun] = ACTIONS(2411),
    [anon_sym_DASH_GT] = ACTIONS(2411),
    [anon_sym_try] = ACTIONS(2411),
    [anon_sym_match] = ACTIONS(2411),
    [anon_sym_match_BANG] = ACTIONS(2413),
    [anon_sym_function] = ACTIONS(2411),
    [anon_sym_LT_DASH] = ACTIONS(2411),
    [anon_sym_DOT_LBRACK] = ACTIONS(2413),
    [anon_sym_LT] = ACTIONS(2413),
    [anon_sym_use] = ACTIONS(2411),
    [anon_sym_use_BANG] = ACTIONS(2413),
    [anon_sym_do_BANG] = ACTIONS(2413),
    [anon_sym_begin] = ACTIONS(2411),
    [anon_sym_LPAREN2] = ACTIONS(2411),
    [anon_sym_STAR] = ACTIONS(2411),
    [anon_sym_LT2] = ACTIONS(2411),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2413),
    [anon_sym_or] = ACTIONS(2411),
    [aux_sym_char_token1] = ACTIONS(2413),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2411),
    [anon_sym_DQUOTE] = ACTIONS(2411),
    [anon_sym_AT_DQUOTE] = ACTIONS(2413),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2413),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2413),
    [sym_bool] = ACTIONS(2411),
    [sym_unit] = ACTIONS(2413),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2411),
    [sym_op_identifier] = ACTIONS(2411),
    [anon_sym_PLUS] = ACTIONS(2411),
    [anon_sym_DASH] = ACTIONS(2411),
    [anon_sym_PLUS_DOT] = ACTIONS(2411),
    [anon_sym_DASH_DOT] = ACTIONS(2411),
    [anon_sym_PERCENT] = ACTIONS(2411),
    [anon_sym_AMP_AMP] = ACTIONS(2411),
    [anon_sym_TILDE] = ACTIONS(2413),
    [aux_sym_prefix_op_token1] = ACTIONS(2411),
    [aux_sym_infix_op_token1] = ACTIONS(2413),
    [aux_sym_infix_op_token2] = ACTIONS(2411),
    [anon_sym_PIPE_PIPE] = ACTIONS(2411),
    [anon_sym_BANG_EQ] = ACTIONS(2411),
    [anon_sym_COLON_EQ] = ACTIONS(2413),
    [anon_sym_DOLLAR] = ACTIONS(2411),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2411),
    [sym_int] = ACTIONS(2411),
    [sym_xint] = ACTIONS(2413),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2413),
    [sym__newline] = ACTIONS(2413),
    [sym__dedent] = ACTIONS(2413),
  },
  [1017] = {
    [sym_type_arguments] = STATE(1323),
    [sym_long_identifier] = STATE(1345),
    [sym_block_comment] = STATE(1017),
    [sym_compiler_directive_decl] = STATE(1017),
    [sym_fsi_directive_decl] = STATE(1017),
    [sym_preproc_line] = STATE(1017),
    [aux_sym_compound_type_repeat1] = STATE(1235),
    [sym_identifier] = ACTIONS(3265),
    [anon_sym_EQ] = ACTIONS(2240),
    [anon_sym_COLON] = ACTIONS(2242),
    [anon_sym_return] = ACTIONS(2242),
    [anon_sym_do] = ACTIONS(2242),
    [anon_sym_let] = ACTIONS(2242),
    [anon_sym_let_BANG] = ACTIONS(2240),
    [anon_sym_LPAREN] = ACTIONS(2242),
    [anon_sym_COMMA] = ACTIONS(2240),
    [anon_sym_null] = ACTIONS(2242),
    [anon_sym_QMARK] = ACTIONS(2242),
    [anon_sym_COLON_QMARK] = ACTIONS(2242),
    [anon_sym_COLON_COLON] = ACTIONS(2240),
    [anon_sym_AMP] = ACTIONS(2242),
    [anon_sym_LBRACK] = ACTIONS(2242),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2240),
    [anon_sym_LBRACE] = ACTIONS(2242),
    [anon_sym_LT_AT] = ACTIONS(2242),
    [anon_sym_LT_AT_AT] = ACTIONS(2242),
    [anon_sym_AT_AT_GT] = ACTIONS(2242),
    [anon_sym_DOT] = ACTIONS(2242),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2240),
    [anon_sym_new] = ACTIONS(2242),
    [anon_sym_return_BANG] = ACTIONS(2240),
    [anon_sym_yield] = ACTIONS(2242),
    [anon_sym_yield_BANG] = ACTIONS(2240),
    [anon_sym_lazy] = ACTIONS(2242),
    [anon_sym_assert] = ACTIONS(2242),
    [anon_sym_upcast] = ACTIONS(2242),
    [anon_sym_downcast] = ACTIONS(2242),
    [anon_sym_COLON_GT] = ACTIONS(2240),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2240),
    [anon_sym_for] = ACTIONS(2242),
    [anon_sym_while] = ACTIONS(2242),
    [anon_sym_if] = ACTIONS(2242),
    [anon_sym_fun] = ACTIONS(2242),
    [anon_sym_DASH_GT] = ACTIONS(3224),
    [anon_sym_try] = ACTIONS(2242),
    [anon_sym_match] = ACTIONS(2242),
    [anon_sym_match_BANG] = ACTIONS(2240),
    [anon_sym_function] = ACTIONS(2242),
    [anon_sym_LT_DASH] = ACTIONS(2242),
    [anon_sym_DOT_LBRACK] = ACTIONS(2240),
    [anon_sym_LT] = ACTIONS(2240),
    [anon_sym_use] = ACTIONS(2242),
    [anon_sym_use_BANG] = ACTIONS(2240),
    [anon_sym_do_BANG] = ACTIONS(2240),
    [anon_sym_begin] = ACTIONS(2242),
    [anon_sym_LPAREN2] = ACTIONS(2242),
    [anon_sym_STAR] = ACTIONS(3226),
    [anon_sym_LT2] = ACTIONS(3228),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3230),
    [anon_sym_or] = ACTIONS(2242),
    [aux_sym_char_token1] = ACTIONS(2240),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2242),
    [anon_sym_DQUOTE] = ACTIONS(2242),
    [anon_sym_AT_DQUOTE] = ACTIONS(2240),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2240),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2240),
    [sym_bool] = ACTIONS(2242),
    [sym_unit] = ACTIONS(2240),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2242),
    [sym_op_identifier] = ACTIONS(2242),
    [anon_sym_PLUS] = ACTIONS(2242),
    [anon_sym_DASH] = ACTIONS(2242),
    [anon_sym_PLUS_DOT] = ACTIONS(2242),
    [anon_sym_DASH_DOT] = ACTIONS(2242),
    [anon_sym_PERCENT] = ACTIONS(2242),
    [anon_sym_AMP_AMP] = ACTIONS(2242),
    [anon_sym_TILDE] = ACTIONS(2240),
    [aux_sym_prefix_op_token1] = ACTIONS(2242),
    [aux_sym_infix_op_token1] = ACTIONS(2240),
    [aux_sym_infix_op_token2] = ACTIONS(2242),
    [anon_sym_PIPE_PIPE] = ACTIONS(2242),
    [anon_sym_BANG_EQ] = ACTIONS(2242),
    [anon_sym_COLON_EQ] = ACTIONS(2240),
    [anon_sym_DOLLAR] = ACTIONS(2242),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2242),
    [sym_int] = ACTIONS(2242),
    [sym_xint] = ACTIONS(2240),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2240),
    [sym__newline] = ACTIONS(2240),
  },
  [1018] = {
    [sym_block_comment] = STATE(1018),
    [sym_compiler_directive_decl] = STATE(1018),
    [sym_fsi_directive_decl] = STATE(1018),
    [sym_preproc_line] = STATE(1018),
    [sym_identifier] = ACTIONS(2756),
    [anon_sym_EQ] = ACTIONS(2758),
    [anon_sym_GT_RBRACK] = ACTIONS(2758),
    [anon_sym_COLON] = ACTIONS(2756),
    [anon_sym_return] = ACTIONS(2756),
    [anon_sym_do] = ACTIONS(2756),
    [anon_sym_let] = ACTIONS(2756),
    [anon_sym_let_BANG] = ACTIONS(2758),
    [anon_sym_LPAREN] = ACTIONS(2756),
    [anon_sym_COMMA] = ACTIONS(2758),
    [anon_sym_null] = ACTIONS(2756),
    [anon_sym_QMARK] = ACTIONS(2756),
    [anon_sym_COLON_QMARK] = ACTIONS(2756),
    [anon_sym_COLON_COLON] = ACTIONS(2758),
    [anon_sym_PIPE] = ACTIONS(2756),
    [anon_sym_AMP] = ACTIONS(2756),
    [anon_sym_LBRACK] = ACTIONS(2756),
    [anon_sym_RBRACK] = ACTIONS(2758),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2758),
    [anon_sym_LBRACE] = ACTIONS(2756),
    [anon_sym_RBRACE] = ACTIONS(2758),
    [anon_sym_LT_AT] = ACTIONS(2756),
    [anon_sym_LT_AT_AT] = ACTIONS(2756),
    [anon_sym_DOT] = ACTIONS(2756),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2758),
    [anon_sym_new] = ACTIONS(2756),
    [anon_sym_with] = ACTIONS(2756),
    [anon_sym_return_BANG] = ACTIONS(2758),
    [anon_sym_yield] = ACTIONS(2756),
    [anon_sym_yield_BANG] = ACTIONS(2758),
    [anon_sym_lazy] = ACTIONS(2756),
    [anon_sym_assert] = ACTIONS(2756),
    [anon_sym_upcast] = ACTIONS(2756),
    [anon_sym_downcast] = ACTIONS(2756),
    [anon_sym_COLON_GT] = ACTIONS(2758),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2758),
    [anon_sym_for] = ACTIONS(2756),
    [anon_sym_to] = ACTIONS(2756),
    [anon_sym_downto] = ACTIONS(2756),
    [anon_sym_while] = ACTIONS(2756),
    [anon_sym_if] = ACTIONS(2756),
    [anon_sym_fun] = ACTIONS(2756),
    [anon_sym_try] = ACTIONS(2756),
    [anon_sym_match] = ACTIONS(2756),
    [anon_sym_match_BANG] = ACTIONS(2758),
    [anon_sym_function] = ACTIONS(2756),
    [anon_sym_LT_DASH] = ACTIONS(2756),
    [anon_sym_DOT_LBRACK] = ACTIONS(2758),
    [anon_sym_LT] = ACTIONS(2758),
    [anon_sym_use] = ACTIONS(2756),
    [anon_sym_use_BANG] = ACTIONS(2758),
    [anon_sym_do_BANG] = ACTIONS(2758),
    [anon_sym_begin] = ACTIONS(2756),
    [anon_sym_LPAREN2] = ACTIONS(2756),
    [anon_sym_DOT_DOT2] = ACTIONS(2758),
    [anon_sym_or] = ACTIONS(2756),
    [aux_sym_char_token1] = ACTIONS(2758),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2756),
    [anon_sym_DQUOTE] = ACTIONS(2756),
    [anon_sym_AT_DQUOTE] = ACTIONS(2758),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2758),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2758),
    [sym_bool] = ACTIONS(2756),
    [sym_unit] = ACTIONS(2758),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2756),
    [sym_op_identifier] = ACTIONS(2756),
    [anon_sym_PLUS] = ACTIONS(2756),
    [anon_sym_DASH] = ACTIONS(2756),
    [anon_sym_PLUS_DOT] = ACTIONS(2756),
    [anon_sym_DASH_DOT] = ACTIONS(2756),
    [anon_sym_PERCENT] = ACTIONS(2756),
    [anon_sym_AMP_AMP] = ACTIONS(2756),
    [anon_sym_TILDE] = ACTIONS(2758),
    [aux_sym_prefix_op_token1] = ACTIONS(2756),
    [aux_sym_infix_op_token1] = ACTIONS(2758),
    [aux_sym_infix_op_token2] = ACTIONS(2756),
    [anon_sym_PIPE_PIPE] = ACTIONS(2756),
    [anon_sym_BANG_EQ] = ACTIONS(2756),
    [anon_sym_COLON_EQ] = ACTIONS(2758),
    [anon_sym_DOLLAR] = ACTIONS(2756),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2756),
    [sym_int] = ACTIONS(2756),
    [sym_xint] = ACTIONS(2758),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2758),
    [sym__newline] = ACTIONS(2758),
  },
  [1019] = {
    [sym_block_comment] = STATE(1019),
    [sym_compiler_directive_decl] = STATE(1019),
    [sym_fsi_directive_decl] = STATE(1019),
    [sym_preproc_line] = STATE(1019),
    [aux_sym_long_identifier_repeat1] = STATE(1016),
    [sym_identifier] = ACTIONS(2418),
    [anon_sym_EQ] = ACTIONS(2420),
    [anon_sym_COLON] = ACTIONS(2418),
    [anon_sym_return] = ACTIONS(2418),
    [anon_sym_do] = ACTIONS(2418),
    [anon_sym_let] = ACTIONS(2418),
    [anon_sym_let_BANG] = ACTIONS(2420),
    [anon_sym_as] = ACTIONS(2418),
    [anon_sym_LPAREN] = ACTIONS(2418),
    [anon_sym_COMMA] = ACTIONS(2420),
    [anon_sym_null] = ACTIONS(2418),
    [anon_sym_QMARK] = ACTIONS(2418),
    [anon_sym_COLON_QMARK] = ACTIONS(2418),
    [anon_sym_COLON_COLON] = ACTIONS(2420),
    [anon_sym_AMP] = ACTIONS(2418),
    [anon_sym_LBRACK] = ACTIONS(2418),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2420),
    [anon_sym_LBRACE] = ACTIONS(2418),
    [anon_sym_LT_AT] = ACTIONS(2418),
    [anon_sym_LT_AT_AT] = ACTIONS(2418),
    [anon_sym_DOT] = ACTIONS(3267),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2420),
    [anon_sym_new] = ACTIONS(2418),
    [anon_sym_with] = ACTIONS(2418),
    [anon_sym_return_BANG] = ACTIONS(2420),
    [anon_sym_yield] = ACTIONS(2418),
    [anon_sym_yield_BANG] = ACTIONS(2420),
    [anon_sym_lazy] = ACTIONS(2418),
    [anon_sym_assert] = ACTIONS(2418),
    [anon_sym_upcast] = ACTIONS(2418),
    [anon_sym_downcast] = ACTIONS(2418),
    [anon_sym_COLON_GT] = ACTIONS(2420),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2420),
    [anon_sym_for] = ACTIONS(2418),
    [anon_sym_while] = ACTIONS(2418),
    [anon_sym_if] = ACTIONS(2418),
    [anon_sym_fun] = ACTIONS(2418),
    [anon_sym_DASH_GT] = ACTIONS(2418),
    [anon_sym_try] = ACTIONS(2418),
    [anon_sym_match] = ACTIONS(2418),
    [anon_sym_match_BANG] = ACTIONS(2420),
    [anon_sym_function] = ACTIONS(2418),
    [anon_sym_LT_DASH] = ACTIONS(2418),
    [anon_sym_DOT_LBRACK] = ACTIONS(2420),
    [anon_sym_LT] = ACTIONS(2420),
    [anon_sym_use] = ACTIONS(2418),
    [anon_sym_use_BANG] = ACTIONS(2420),
    [anon_sym_do_BANG] = ACTIONS(2420),
    [anon_sym_begin] = ACTIONS(2418),
    [anon_sym_LPAREN2] = ACTIONS(2418),
    [anon_sym_STAR] = ACTIONS(2418),
    [anon_sym_LT2] = ACTIONS(2418),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2420),
    [anon_sym_or] = ACTIONS(2418),
    [aux_sym_char_token1] = ACTIONS(2420),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2418),
    [anon_sym_DQUOTE] = ACTIONS(2418),
    [anon_sym_AT_DQUOTE] = ACTIONS(2420),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2420),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2420),
    [sym_bool] = ACTIONS(2418),
    [sym_unit] = ACTIONS(2420),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2418),
    [sym_op_identifier] = ACTIONS(2418),
    [anon_sym_PLUS] = ACTIONS(2418),
    [anon_sym_DASH] = ACTIONS(2418),
    [anon_sym_PLUS_DOT] = ACTIONS(2418),
    [anon_sym_DASH_DOT] = ACTIONS(2418),
    [anon_sym_PERCENT] = ACTIONS(2418),
    [anon_sym_AMP_AMP] = ACTIONS(2418),
    [anon_sym_TILDE] = ACTIONS(2420),
    [aux_sym_prefix_op_token1] = ACTIONS(2418),
    [aux_sym_infix_op_token1] = ACTIONS(2420),
    [aux_sym_infix_op_token2] = ACTIONS(2418),
    [anon_sym_PIPE_PIPE] = ACTIONS(2418),
    [anon_sym_BANG_EQ] = ACTIONS(2418),
    [anon_sym_COLON_EQ] = ACTIONS(2420),
    [anon_sym_DOLLAR] = ACTIONS(2418),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2418),
    [sym_int] = ACTIONS(2418),
    [sym_xint] = ACTIONS(2420),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2420),
    [sym__newline] = ACTIONS(2420),
    [sym__dedent] = ACTIONS(2420),
  },
  [1020] = {
    [sym_type_arguments] = STATE(1312),
    [sym_long_identifier] = STATE(1292),
    [sym_block_comment] = STATE(1020),
    [sym_compiler_directive_decl] = STATE(1020),
    [sym_fsi_directive_decl] = STATE(1020),
    [sym_preproc_line] = STATE(1020),
    [aux_sym_compound_type_repeat1] = STATE(1249),
    [sym_identifier] = ACTIONS(3214),
    [anon_sym_EQ] = ACTIONS(2228),
    [anon_sym_COLON] = ACTIONS(2230),
    [anon_sym_return] = ACTIONS(2230),
    [anon_sym_do] = ACTIONS(2230),
    [anon_sym_let] = ACTIONS(2230),
    [anon_sym_let_BANG] = ACTIONS(2228),
    [anon_sym_LPAREN] = ACTIONS(2230),
    [anon_sym_COMMA] = ACTIONS(2228),
    [anon_sym_null] = ACTIONS(2230),
    [anon_sym_QMARK] = ACTIONS(2230),
    [anon_sym_COLON_QMARK] = ACTIONS(2230),
    [anon_sym_COLON_COLON] = ACTIONS(2228),
    [anon_sym_AMP] = ACTIONS(2230),
    [anon_sym_LBRACK] = ACTIONS(2230),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2228),
    [anon_sym_LBRACE] = ACTIONS(2230),
    [anon_sym_LT_AT] = ACTIONS(2230),
    [anon_sym_LT_AT_AT] = ACTIONS(2230),
    [anon_sym_DOT] = ACTIONS(2230),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2228),
    [anon_sym_new] = ACTIONS(2230),
    [anon_sym_return_BANG] = ACTIONS(2228),
    [anon_sym_yield] = ACTIONS(2230),
    [anon_sym_yield_BANG] = ACTIONS(2228),
    [anon_sym_lazy] = ACTIONS(2230),
    [anon_sym_assert] = ACTIONS(2230),
    [anon_sym_upcast] = ACTIONS(2230),
    [anon_sym_downcast] = ACTIONS(2230),
    [anon_sym_COLON_GT] = ACTIONS(2228),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2228),
    [anon_sym_for] = ACTIONS(2230),
    [anon_sym_while] = ACTIONS(2230),
    [anon_sym_if] = ACTIONS(2230),
    [anon_sym_fun] = ACTIONS(2230),
    [anon_sym_DASH_GT] = ACTIONS(3216),
    [anon_sym_try] = ACTIONS(2230),
    [anon_sym_match] = ACTIONS(2230),
    [anon_sym_match_BANG] = ACTIONS(2228),
    [anon_sym_function] = ACTIONS(2230),
    [anon_sym_LT_DASH] = ACTIONS(2230),
    [anon_sym_DOT_LBRACK] = ACTIONS(2228),
    [anon_sym_LT] = ACTIONS(2228),
    [anon_sym_GT] = ACTIONS(2230),
    [anon_sym_use] = ACTIONS(2230),
    [anon_sym_use_BANG] = ACTIONS(2228),
    [anon_sym_do_BANG] = ACTIONS(2228),
    [anon_sym_begin] = ACTIONS(2230),
    [anon_sym_LPAREN2] = ACTIONS(2230),
    [anon_sym_STAR] = ACTIONS(3218),
    [anon_sym_LT2] = ACTIONS(3220),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3222),
    [anon_sym_or] = ACTIONS(2230),
    [aux_sym_char_token1] = ACTIONS(2228),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2230),
    [anon_sym_DQUOTE] = ACTIONS(2230),
    [anon_sym_AT_DQUOTE] = ACTIONS(2228),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2228),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2228),
    [sym_bool] = ACTIONS(2230),
    [sym_unit] = ACTIONS(2228),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2230),
    [sym_op_identifier] = ACTIONS(2230),
    [anon_sym_PLUS] = ACTIONS(2230),
    [anon_sym_DASH] = ACTIONS(2230),
    [anon_sym_PLUS_DOT] = ACTIONS(2230),
    [anon_sym_DASH_DOT] = ACTIONS(2230),
    [anon_sym_PERCENT] = ACTIONS(2230),
    [anon_sym_AMP_AMP] = ACTIONS(2230),
    [anon_sym_TILDE] = ACTIONS(2228),
    [aux_sym_prefix_op_token1] = ACTIONS(2230),
    [aux_sym_infix_op_token1] = ACTIONS(2228),
    [aux_sym_infix_op_token2] = ACTIONS(2230),
    [anon_sym_PIPE_PIPE] = ACTIONS(2230),
    [anon_sym_BANG_EQ] = ACTIONS(2230),
    [anon_sym_COLON_EQ] = ACTIONS(2228),
    [anon_sym_DOLLAR] = ACTIONS(2230),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2230),
    [sym_int] = ACTIONS(2230),
    [sym_xint] = ACTIONS(2228),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2228),
    [sym__newline] = ACTIONS(2228),
  },
  [1021] = {
    [sym_block_comment] = STATE(1021),
    [sym_compiler_directive_decl] = STATE(1021),
    [sym_fsi_directive_decl] = STATE(1021),
    [sym_preproc_line] = STATE(1021),
    [aux_sym_long_identifier_repeat1] = STATE(1024),
    [sym_identifier] = ACTIONS(2791),
    [anon_sym_EQ] = ACTIONS(2794),
    [anon_sym_GT_RBRACK] = ACTIONS(2794),
    [anon_sym_COLON] = ACTIONS(2791),
    [anon_sym_return] = ACTIONS(2791),
    [anon_sym_do] = ACTIONS(2791),
    [anon_sym_let] = ACTIONS(2791),
    [anon_sym_let_BANG] = ACTIONS(2794),
    [anon_sym_LPAREN] = ACTIONS(2791),
    [anon_sym_COMMA] = ACTIONS(2794),
    [anon_sym_null] = ACTIONS(2791),
    [anon_sym_QMARK] = ACTIONS(2791),
    [anon_sym_COLON_QMARK] = ACTIONS(2791),
    [anon_sym_COLON_COLON] = ACTIONS(2794),
    [anon_sym_AMP] = ACTIONS(2791),
    [anon_sym_LBRACK] = ACTIONS(2791),
    [anon_sym_RBRACK] = ACTIONS(2794),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2794),
    [anon_sym_LBRACE] = ACTIONS(2791),
    [anon_sym_RBRACE] = ACTIONS(2794),
    [anon_sym_LT_AT] = ACTIONS(2791),
    [anon_sym_LT_AT_AT] = ACTIONS(2791),
    [anon_sym_DOT] = ACTIONS(3269),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2794),
    [anon_sym_new] = ACTIONS(2791),
    [anon_sym_with] = ACTIONS(2791),
    [anon_sym_return_BANG] = ACTIONS(2794),
    [anon_sym_yield] = ACTIONS(2791),
    [anon_sym_yield_BANG] = ACTIONS(2794),
    [anon_sym_lazy] = ACTIONS(2791),
    [anon_sym_assert] = ACTIONS(2791),
    [anon_sym_upcast] = ACTIONS(2791),
    [anon_sym_downcast] = ACTIONS(2791),
    [anon_sym_COLON_GT] = ACTIONS(2794),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2794),
    [anon_sym_for] = ACTIONS(2791),
    [anon_sym_to] = ACTIONS(2791),
    [anon_sym_downto] = ACTIONS(2791),
    [anon_sym_while] = ACTIONS(2791),
    [anon_sym_if] = ACTIONS(2791),
    [anon_sym_fun] = ACTIONS(2791),
    [anon_sym_try] = ACTIONS(2791),
    [anon_sym_match] = ACTIONS(2791),
    [anon_sym_match_BANG] = ACTIONS(2794),
    [anon_sym_function] = ACTIONS(2791),
    [anon_sym_LT_DASH] = ACTIONS(2791),
    [anon_sym_DOT_LBRACK] = ACTIONS(2794),
    [anon_sym_LT] = ACTIONS(2794),
    [anon_sym_use] = ACTIONS(2791),
    [anon_sym_use_BANG] = ACTIONS(2794),
    [anon_sym_do_BANG] = ACTIONS(2794),
    [anon_sym_begin] = ACTIONS(2791),
    [anon_sym_LPAREN2] = ACTIONS(2791),
    [anon_sym_DOT_DOT2] = ACTIONS(2794),
    [anon_sym_or] = ACTIONS(2791),
    [aux_sym_char_token1] = ACTIONS(2794),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2791),
    [anon_sym_DQUOTE] = ACTIONS(2791),
    [anon_sym_AT_DQUOTE] = ACTIONS(2794),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2794),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2794),
    [sym_bool] = ACTIONS(2791),
    [sym_unit] = ACTIONS(2794),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2791),
    [sym_op_identifier] = ACTIONS(2791),
    [anon_sym_PLUS] = ACTIONS(2791),
    [anon_sym_DASH] = ACTIONS(2791),
    [anon_sym_PLUS_DOT] = ACTIONS(2791),
    [anon_sym_DASH_DOT] = ACTIONS(2791),
    [anon_sym_PERCENT] = ACTIONS(2791),
    [anon_sym_AMP_AMP] = ACTIONS(2791),
    [anon_sym_TILDE] = ACTIONS(2794),
    [aux_sym_prefix_op_token1] = ACTIONS(2791),
    [aux_sym_infix_op_token1] = ACTIONS(2794),
    [aux_sym_infix_op_token2] = ACTIONS(2791),
    [anon_sym_PIPE_PIPE] = ACTIONS(2791),
    [anon_sym_BANG_EQ] = ACTIONS(2791),
    [anon_sym_COLON_EQ] = ACTIONS(2794),
    [anon_sym_DOLLAR] = ACTIONS(2791),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2791),
    [sym_int] = ACTIONS(2791),
    [sym_xint] = ACTIONS(2794),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2794),
    [sym__newline] = ACTIONS(2794),
  },
  [1022] = {
    [sym_block_comment] = STATE(1022),
    [sym_compiler_directive_decl] = STATE(1022),
    [sym_fsi_directive_decl] = STATE(1022),
    [sym_preproc_line] = STATE(1022),
    [aux_sym_type_argument_repeat1] = STATE(1022),
    [sym_identifier] = ACTIONS(2340),
    [anon_sym_EQ] = ACTIONS(2342),
    [anon_sym_COLON] = ACTIONS(2340),
    [anon_sym_return] = ACTIONS(2340),
    [anon_sym_do] = ACTIONS(2340),
    [anon_sym_let] = ACTIONS(2340),
    [anon_sym_let_BANG] = ACTIONS(2342),
    [anon_sym_as] = ACTIONS(2340),
    [anon_sym_LPAREN] = ACTIONS(2340),
    [anon_sym_COMMA] = ACTIONS(2342),
    [anon_sym_null] = ACTIONS(2340),
    [anon_sym_QMARK] = ACTIONS(2340),
    [anon_sym_COLON_QMARK] = ACTIONS(2340),
    [anon_sym_COLON_COLON] = ACTIONS(2342),
    [anon_sym_AMP] = ACTIONS(2340),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2342),
    [anon_sym_LBRACE] = ACTIONS(2340),
    [anon_sym_LT_AT] = ACTIONS(2340),
    [anon_sym_LT_AT_AT] = ACTIONS(2340),
    [anon_sym_DOT] = ACTIONS(2340),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2342),
    [anon_sym_new] = ACTIONS(2340),
    [anon_sym_with] = ACTIONS(2340),
    [anon_sym_return_BANG] = ACTIONS(2342),
    [anon_sym_yield] = ACTIONS(2340),
    [anon_sym_yield_BANG] = ACTIONS(2342),
    [anon_sym_lazy] = ACTIONS(2340),
    [anon_sym_assert] = ACTIONS(2340),
    [anon_sym_upcast] = ACTIONS(2340),
    [anon_sym_downcast] = ACTIONS(2340),
    [anon_sym_COLON_GT] = ACTIONS(2342),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2342),
    [anon_sym_for] = ACTIONS(2340),
    [anon_sym_while] = ACTIONS(2340),
    [anon_sym_if] = ACTIONS(2340),
    [anon_sym_fun] = ACTIONS(2340),
    [anon_sym_DASH_GT] = ACTIONS(2340),
    [anon_sym_try] = ACTIONS(2340),
    [anon_sym_match] = ACTIONS(2340),
    [anon_sym_match_BANG] = ACTIONS(2342),
    [anon_sym_function] = ACTIONS(2340),
    [anon_sym_LT_DASH] = ACTIONS(2340),
    [anon_sym_DOT_LBRACK] = ACTIONS(2342),
    [anon_sym_LT] = ACTIONS(2342),
    [anon_sym_use] = ACTIONS(2340),
    [anon_sym_use_BANG] = ACTIONS(2342),
    [anon_sym_do_BANG] = ACTIONS(2342),
    [anon_sym_begin] = ACTIONS(2340),
    [anon_sym_LPAREN2] = ACTIONS(2340),
    [anon_sym_STAR] = ACTIONS(2340),
    [anon_sym_LT2] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2342),
    [anon_sym_or] = ACTIONS(3273),
    [aux_sym_char_token1] = ACTIONS(2342),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2340),
    [anon_sym_DQUOTE] = ACTIONS(2340),
    [anon_sym_AT_DQUOTE] = ACTIONS(2342),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2342),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2342),
    [sym_bool] = ACTIONS(2340),
    [sym_unit] = ACTIONS(2342),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2340),
    [sym_op_identifier] = ACTIONS(2340),
    [anon_sym_PLUS] = ACTIONS(2340),
    [anon_sym_DASH] = ACTIONS(2340),
    [anon_sym_PLUS_DOT] = ACTIONS(2340),
    [anon_sym_DASH_DOT] = ACTIONS(2340),
    [anon_sym_PERCENT] = ACTIONS(2340),
    [anon_sym_AMP_AMP] = ACTIONS(2340),
    [anon_sym_TILDE] = ACTIONS(2342),
    [aux_sym_prefix_op_token1] = ACTIONS(2340),
    [aux_sym_infix_op_token1] = ACTIONS(2342),
    [aux_sym_infix_op_token2] = ACTIONS(2340),
    [anon_sym_PIPE_PIPE] = ACTIONS(2340),
    [anon_sym_BANG_EQ] = ACTIONS(2340),
    [anon_sym_COLON_EQ] = ACTIONS(2342),
    [anon_sym_DOLLAR] = ACTIONS(2340),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2340),
    [sym_int] = ACTIONS(2340),
    [sym_xint] = ACTIONS(2342),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2342),
    [sym__newline] = ACTIONS(2342),
    [sym__dedent] = ACTIONS(2342),
  },
  [1023] = {
    [sym_type_arguments] = STATE(1285),
    [sym_long_identifier] = STATE(1378),
    [sym_block_comment] = STATE(1023),
    [sym_compiler_directive_decl] = STATE(1023),
    [sym_fsi_directive_decl] = STATE(1023),
    [sym_preproc_line] = STATE(1023),
    [aux_sym_compound_type_repeat1] = STATE(1268),
    [sym_identifier] = ACTIONS(3204),
    [anon_sym_EQ] = ACTIONS(2248),
    [anon_sym_COLON] = ACTIONS(2250),
    [anon_sym_return] = ACTIONS(2250),
    [anon_sym_do] = ACTIONS(2250),
    [anon_sym_let] = ACTIONS(2250),
    [anon_sym_let_BANG] = ACTIONS(2248),
    [anon_sym_LPAREN] = ACTIONS(2250),
    [anon_sym_COMMA] = ACTIONS(2248),
    [anon_sym_null] = ACTIONS(2250),
    [anon_sym_QMARK] = ACTIONS(2250),
    [anon_sym_COLON_QMARK] = ACTIONS(2250),
    [anon_sym_COLON_COLON] = ACTIONS(2248),
    [anon_sym_AMP] = ACTIONS(2250),
    [anon_sym_LBRACK] = ACTIONS(2250),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2248),
    [anon_sym_LBRACE] = ACTIONS(2250),
    [anon_sym_LT_AT] = ACTIONS(2250),
    [anon_sym_AT_GT] = ACTIONS(2250),
    [anon_sym_LT_AT_AT] = ACTIONS(2250),
    [anon_sym_DOT] = ACTIONS(2250),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2248),
    [anon_sym_new] = ACTIONS(2250),
    [anon_sym_return_BANG] = ACTIONS(2248),
    [anon_sym_yield] = ACTIONS(2250),
    [anon_sym_yield_BANG] = ACTIONS(2248),
    [anon_sym_lazy] = ACTIONS(2250),
    [anon_sym_assert] = ACTIONS(2250),
    [anon_sym_upcast] = ACTIONS(2250),
    [anon_sym_downcast] = ACTIONS(2250),
    [anon_sym_COLON_GT] = ACTIONS(2248),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2248),
    [anon_sym_for] = ACTIONS(2250),
    [anon_sym_while] = ACTIONS(2250),
    [anon_sym_if] = ACTIONS(2250),
    [anon_sym_fun] = ACTIONS(2250),
    [anon_sym_DASH_GT] = ACTIONS(3206),
    [anon_sym_try] = ACTIONS(2250),
    [anon_sym_match] = ACTIONS(2250),
    [anon_sym_match_BANG] = ACTIONS(2248),
    [anon_sym_function] = ACTIONS(2250),
    [anon_sym_LT_DASH] = ACTIONS(2250),
    [anon_sym_DOT_LBRACK] = ACTIONS(2248),
    [anon_sym_LT] = ACTIONS(2248),
    [anon_sym_use] = ACTIONS(2250),
    [anon_sym_use_BANG] = ACTIONS(2248),
    [anon_sym_do_BANG] = ACTIONS(2248),
    [anon_sym_begin] = ACTIONS(2250),
    [anon_sym_LPAREN2] = ACTIONS(2250),
    [anon_sym_STAR] = ACTIONS(3208),
    [anon_sym_LT2] = ACTIONS(3210),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3212),
    [anon_sym_or] = ACTIONS(2250),
    [aux_sym_char_token1] = ACTIONS(2248),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2250),
    [anon_sym_DQUOTE] = ACTIONS(2250),
    [anon_sym_AT_DQUOTE] = ACTIONS(2248),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2248),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2248),
    [sym_bool] = ACTIONS(2250),
    [sym_unit] = ACTIONS(2248),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2250),
    [sym_op_identifier] = ACTIONS(2250),
    [anon_sym_PLUS] = ACTIONS(2250),
    [anon_sym_DASH] = ACTIONS(2250),
    [anon_sym_PLUS_DOT] = ACTIONS(2250),
    [anon_sym_DASH_DOT] = ACTIONS(2250),
    [anon_sym_PERCENT] = ACTIONS(2250),
    [anon_sym_AMP_AMP] = ACTIONS(2250),
    [anon_sym_TILDE] = ACTIONS(2248),
    [aux_sym_prefix_op_token1] = ACTIONS(2250),
    [aux_sym_infix_op_token1] = ACTIONS(2248),
    [aux_sym_infix_op_token2] = ACTIONS(2250),
    [anon_sym_PIPE_PIPE] = ACTIONS(2250),
    [anon_sym_BANG_EQ] = ACTIONS(2250),
    [anon_sym_COLON_EQ] = ACTIONS(2248),
    [anon_sym_DOLLAR] = ACTIONS(2250),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2250),
    [sym_int] = ACTIONS(2250),
    [sym_xint] = ACTIONS(2248),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2248),
    [sym__newline] = ACTIONS(2248),
  },
  [1024] = {
    [sym_block_comment] = STATE(1024),
    [sym_compiler_directive_decl] = STATE(1024),
    [sym_fsi_directive_decl] = STATE(1024),
    [sym_preproc_line] = STATE(1024),
    [aux_sym_long_identifier_repeat1] = STATE(1025),
    [sym_identifier] = ACTIONS(2418),
    [anon_sym_EQ] = ACTIONS(2420),
    [anon_sym_GT_RBRACK] = ACTIONS(2420),
    [anon_sym_COLON] = ACTIONS(2418),
    [anon_sym_return] = ACTIONS(2418),
    [anon_sym_do] = ACTIONS(2418),
    [anon_sym_let] = ACTIONS(2418),
    [anon_sym_let_BANG] = ACTIONS(2420),
    [anon_sym_LPAREN] = ACTIONS(2418),
    [anon_sym_COMMA] = ACTIONS(2420),
    [anon_sym_null] = ACTIONS(2418),
    [anon_sym_QMARK] = ACTIONS(2418),
    [anon_sym_COLON_QMARK] = ACTIONS(2418),
    [anon_sym_COLON_COLON] = ACTIONS(2420),
    [anon_sym_AMP] = ACTIONS(2418),
    [anon_sym_LBRACK] = ACTIONS(2418),
    [anon_sym_RBRACK] = ACTIONS(2420),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2420),
    [anon_sym_LBRACE] = ACTIONS(2418),
    [anon_sym_RBRACE] = ACTIONS(2420),
    [anon_sym_LT_AT] = ACTIONS(2418),
    [anon_sym_LT_AT_AT] = ACTIONS(2418),
    [anon_sym_DOT] = ACTIONS(3276),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2420),
    [anon_sym_new] = ACTIONS(2418),
    [anon_sym_with] = ACTIONS(2418),
    [anon_sym_return_BANG] = ACTIONS(2420),
    [anon_sym_yield] = ACTIONS(2418),
    [anon_sym_yield_BANG] = ACTIONS(2420),
    [anon_sym_lazy] = ACTIONS(2418),
    [anon_sym_assert] = ACTIONS(2418),
    [anon_sym_upcast] = ACTIONS(2418),
    [anon_sym_downcast] = ACTIONS(2418),
    [anon_sym_COLON_GT] = ACTIONS(2420),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2420),
    [anon_sym_for] = ACTIONS(2418),
    [anon_sym_to] = ACTIONS(2418),
    [anon_sym_downto] = ACTIONS(2418),
    [anon_sym_while] = ACTIONS(2418),
    [anon_sym_if] = ACTIONS(2418),
    [anon_sym_fun] = ACTIONS(2418),
    [anon_sym_try] = ACTIONS(2418),
    [anon_sym_match] = ACTIONS(2418),
    [anon_sym_match_BANG] = ACTIONS(2420),
    [anon_sym_function] = ACTIONS(2418),
    [anon_sym_LT_DASH] = ACTIONS(2418),
    [anon_sym_DOT_LBRACK] = ACTIONS(2420),
    [anon_sym_LT] = ACTIONS(2420),
    [anon_sym_use] = ACTIONS(2418),
    [anon_sym_use_BANG] = ACTIONS(2420),
    [anon_sym_do_BANG] = ACTIONS(2420),
    [anon_sym_begin] = ACTIONS(2418),
    [anon_sym_LPAREN2] = ACTIONS(2418),
    [anon_sym_DOT_DOT2] = ACTIONS(2420),
    [anon_sym_or] = ACTIONS(2418),
    [aux_sym_char_token1] = ACTIONS(2420),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2418),
    [anon_sym_DQUOTE] = ACTIONS(2418),
    [anon_sym_AT_DQUOTE] = ACTIONS(2420),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2420),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2420),
    [sym_bool] = ACTIONS(2418),
    [sym_unit] = ACTIONS(2420),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2418),
    [sym_op_identifier] = ACTIONS(2418),
    [anon_sym_PLUS] = ACTIONS(2418),
    [anon_sym_DASH] = ACTIONS(2418),
    [anon_sym_PLUS_DOT] = ACTIONS(2418),
    [anon_sym_DASH_DOT] = ACTIONS(2418),
    [anon_sym_PERCENT] = ACTIONS(2418),
    [anon_sym_AMP_AMP] = ACTIONS(2418),
    [anon_sym_TILDE] = ACTIONS(2420),
    [aux_sym_prefix_op_token1] = ACTIONS(2418),
    [aux_sym_infix_op_token1] = ACTIONS(2420),
    [aux_sym_infix_op_token2] = ACTIONS(2418),
    [anon_sym_PIPE_PIPE] = ACTIONS(2418),
    [anon_sym_BANG_EQ] = ACTIONS(2418),
    [anon_sym_COLON_EQ] = ACTIONS(2420),
    [anon_sym_DOLLAR] = ACTIONS(2418),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2418),
    [sym_int] = ACTIONS(2418),
    [sym_xint] = ACTIONS(2420),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2420),
    [sym__newline] = ACTIONS(2420),
  },
  [1025] = {
    [sym_block_comment] = STATE(1025),
    [sym_compiler_directive_decl] = STATE(1025),
    [sym_fsi_directive_decl] = STATE(1025),
    [sym_preproc_line] = STATE(1025),
    [aux_sym_long_identifier_repeat1] = STATE(1025),
    [sym_identifier] = ACTIONS(2411),
    [anon_sym_EQ] = ACTIONS(2413),
    [anon_sym_GT_RBRACK] = ACTIONS(2413),
    [anon_sym_COLON] = ACTIONS(2411),
    [anon_sym_return] = ACTIONS(2411),
    [anon_sym_do] = ACTIONS(2411),
    [anon_sym_let] = ACTIONS(2411),
    [anon_sym_let_BANG] = ACTIONS(2413),
    [anon_sym_LPAREN] = ACTIONS(2411),
    [anon_sym_COMMA] = ACTIONS(2413),
    [anon_sym_null] = ACTIONS(2411),
    [anon_sym_QMARK] = ACTIONS(2411),
    [anon_sym_COLON_QMARK] = ACTIONS(2411),
    [anon_sym_COLON_COLON] = ACTIONS(2413),
    [anon_sym_AMP] = ACTIONS(2411),
    [anon_sym_LBRACK] = ACTIONS(2411),
    [anon_sym_RBRACK] = ACTIONS(2413),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2413),
    [anon_sym_LBRACE] = ACTIONS(2411),
    [anon_sym_RBRACE] = ACTIONS(2413),
    [anon_sym_LT_AT] = ACTIONS(2411),
    [anon_sym_LT_AT_AT] = ACTIONS(2411),
    [anon_sym_DOT] = ACTIONS(3278),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2413),
    [anon_sym_new] = ACTIONS(2411),
    [anon_sym_with] = ACTIONS(2411),
    [anon_sym_return_BANG] = ACTIONS(2413),
    [anon_sym_yield] = ACTIONS(2411),
    [anon_sym_yield_BANG] = ACTIONS(2413),
    [anon_sym_lazy] = ACTIONS(2411),
    [anon_sym_assert] = ACTIONS(2411),
    [anon_sym_upcast] = ACTIONS(2411),
    [anon_sym_downcast] = ACTIONS(2411),
    [anon_sym_COLON_GT] = ACTIONS(2413),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2413),
    [anon_sym_for] = ACTIONS(2411),
    [anon_sym_to] = ACTIONS(2411),
    [anon_sym_downto] = ACTIONS(2411),
    [anon_sym_while] = ACTIONS(2411),
    [anon_sym_if] = ACTIONS(2411),
    [anon_sym_fun] = ACTIONS(2411),
    [anon_sym_try] = ACTIONS(2411),
    [anon_sym_match] = ACTIONS(2411),
    [anon_sym_match_BANG] = ACTIONS(2413),
    [anon_sym_function] = ACTIONS(2411),
    [anon_sym_LT_DASH] = ACTIONS(2411),
    [anon_sym_DOT_LBRACK] = ACTIONS(2413),
    [anon_sym_LT] = ACTIONS(2413),
    [anon_sym_use] = ACTIONS(2411),
    [anon_sym_use_BANG] = ACTIONS(2413),
    [anon_sym_do_BANG] = ACTIONS(2413),
    [anon_sym_begin] = ACTIONS(2411),
    [anon_sym_LPAREN2] = ACTIONS(2411),
    [anon_sym_DOT_DOT2] = ACTIONS(2413),
    [anon_sym_or] = ACTIONS(2411),
    [aux_sym_char_token1] = ACTIONS(2413),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2411),
    [anon_sym_DQUOTE] = ACTIONS(2411),
    [anon_sym_AT_DQUOTE] = ACTIONS(2413),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2413),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2413),
    [sym_bool] = ACTIONS(2411),
    [sym_unit] = ACTIONS(2413),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2411),
    [sym_op_identifier] = ACTIONS(2411),
    [anon_sym_PLUS] = ACTIONS(2411),
    [anon_sym_DASH] = ACTIONS(2411),
    [anon_sym_PLUS_DOT] = ACTIONS(2411),
    [anon_sym_DASH_DOT] = ACTIONS(2411),
    [anon_sym_PERCENT] = ACTIONS(2411),
    [anon_sym_AMP_AMP] = ACTIONS(2411),
    [anon_sym_TILDE] = ACTIONS(2413),
    [aux_sym_prefix_op_token1] = ACTIONS(2411),
    [aux_sym_infix_op_token1] = ACTIONS(2413),
    [aux_sym_infix_op_token2] = ACTIONS(2411),
    [anon_sym_PIPE_PIPE] = ACTIONS(2411),
    [anon_sym_BANG_EQ] = ACTIONS(2411),
    [anon_sym_COLON_EQ] = ACTIONS(2413),
    [anon_sym_DOLLAR] = ACTIONS(2411),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2411),
    [sym_int] = ACTIONS(2411),
    [sym_xint] = ACTIONS(2413),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2413),
    [sym__newline] = ACTIONS(2413),
  },
  [1026] = {
    [sym_type_arguments] = STATE(1323),
    [sym_long_identifier] = STATE(1345),
    [sym_block_comment] = STATE(1026),
    [sym_compiler_directive_decl] = STATE(1026),
    [sym_fsi_directive_decl] = STATE(1026),
    [sym_preproc_line] = STATE(1026),
    [aux_sym_compound_type_repeat1] = STATE(1235),
    [sym_identifier] = ACTIONS(3265),
    [anon_sym_EQ] = ACTIONS(2244),
    [anon_sym_COLON] = ACTIONS(2246),
    [anon_sym_return] = ACTIONS(2246),
    [anon_sym_do] = ACTIONS(2246),
    [anon_sym_let] = ACTIONS(2246),
    [anon_sym_let_BANG] = ACTIONS(2244),
    [anon_sym_LPAREN] = ACTIONS(2246),
    [anon_sym_COMMA] = ACTIONS(2244),
    [anon_sym_null] = ACTIONS(2246),
    [anon_sym_QMARK] = ACTIONS(2246),
    [anon_sym_COLON_QMARK] = ACTIONS(2246),
    [anon_sym_COLON_COLON] = ACTIONS(2244),
    [anon_sym_AMP] = ACTIONS(2246),
    [anon_sym_LBRACK] = ACTIONS(2246),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2244),
    [anon_sym_LBRACE] = ACTIONS(2246),
    [anon_sym_LT_AT] = ACTIONS(2246),
    [anon_sym_LT_AT_AT] = ACTIONS(2246),
    [anon_sym_AT_AT_GT] = ACTIONS(2246),
    [anon_sym_DOT] = ACTIONS(2246),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2244),
    [anon_sym_new] = ACTIONS(2246),
    [anon_sym_return_BANG] = ACTIONS(2244),
    [anon_sym_yield] = ACTIONS(2246),
    [anon_sym_yield_BANG] = ACTIONS(2244),
    [anon_sym_lazy] = ACTIONS(2246),
    [anon_sym_assert] = ACTIONS(2246),
    [anon_sym_upcast] = ACTIONS(2246),
    [anon_sym_downcast] = ACTIONS(2246),
    [anon_sym_COLON_GT] = ACTIONS(2244),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2244),
    [anon_sym_for] = ACTIONS(2246),
    [anon_sym_while] = ACTIONS(2246),
    [anon_sym_if] = ACTIONS(2246),
    [anon_sym_fun] = ACTIONS(2246),
    [anon_sym_DASH_GT] = ACTIONS(3224),
    [anon_sym_try] = ACTIONS(2246),
    [anon_sym_match] = ACTIONS(2246),
    [anon_sym_match_BANG] = ACTIONS(2244),
    [anon_sym_function] = ACTIONS(2246),
    [anon_sym_LT_DASH] = ACTIONS(2246),
    [anon_sym_DOT_LBRACK] = ACTIONS(2244),
    [anon_sym_LT] = ACTIONS(2244),
    [anon_sym_use] = ACTIONS(2246),
    [anon_sym_use_BANG] = ACTIONS(2244),
    [anon_sym_do_BANG] = ACTIONS(2244),
    [anon_sym_begin] = ACTIONS(2246),
    [anon_sym_LPAREN2] = ACTIONS(2246),
    [anon_sym_STAR] = ACTIONS(3226),
    [anon_sym_LT2] = ACTIONS(3228),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3230),
    [anon_sym_or] = ACTIONS(2246),
    [aux_sym_char_token1] = ACTIONS(2244),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2246),
    [anon_sym_DQUOTE] = ACTIONS(2246),
    [anon_sym_AT_DQUOTE] = ACTIONS(2244),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2244),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2244),
    [sym_bool] = ACTIONS(2246),
    [sym_unit] = ACTIONS(2244),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2246),
    [sym_op_identifier] = ACTIONS(2246),
    [anon_sym_PLUS] = ACTIONS(2246),
    [anon_sym_DASH] = ACTIONS(2246),
    [anon_sym_PLUS_DOT] = ACTIONS(2246),
    [anon_sym_DASH_DOT] = ACTIONS(2246),
    [anon_sym_PERCENT] = ACTIONS(2246),
    [anon_sym_AMP_AMP] = ACTIONS(2246),
    [anon_sym_TILDE] = ACTIONS(2244),
    [aux_sym_prefix_op_token1] = ACTIONS(2246),
    [aux_sym_infix_op_token1] = ACTIONS(2244),
    [aux_sym_infix_op_token2] = ACTIONS(2246),
    [anon_sym_PIPE_PIPE] = ACTIONS(2246),
    [anon_sym_BANG_EQ] = ACTIONS(2246),
    [anon_sym_COLON_EQ] = ACTIONS(2244),
    [anon_sym_DOLLAR] = ACTIONS(2246),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2246),
    [sym_int] = ACTIONS(2246),
    [sym_xint] = ACTIONS(2244),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2244),
    [sym__newline] = ACTIONS(2244),
  },
  [1027] = {
    [sym_type_arguments] = STATE(1323),
    [sym_long_identifier] = STATE(1345),
    [sym_block_comment] = STATE(1027),
    [sym_compiler_directive_decl] = STATE(1027),
    [sym_fsi_directive_decl] = STATE(1027),
    [sym_preproc_line] = STATE(1027),
    [aux_sym_compound_type_repeat1] = STATE(1235),
    [sym_identifier] = ACTIONS(3265),
    [anon_sym_EQ] = ACTIONS(2248),
    [anon_sym_COLON] = ACTIONS(2250),
    [anon_sym_return] = ACTIONS(2250),
    [anon_sym_do] = ACTIONS(2250),
    [anon_sym_let] = ACTIONS(2250),
    [anon_sym_let_BANG] = ACTIONS(2248),
    [anon_sym_LPAREN] = ACTIONS(2250),
    [anon_sym_COMMA] = ACTIONS(2248),
    [anon_sym_null] = ACTIONS(2250),
    [anon_sym_QMARK] = ACTIONS(2250),
    [anon_sym_COLON_QMARK] = ACTIONS(2250),
    [anon_sym_COLON_COLON] = ACTIONS(2248),
    [anon_sym_AMP] = ACTIONS(2250),
    [anon_sym_LBRACK] = ACTIONS(2250),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2248),
    [anon_sym_LBRACE] = ACTIONS(2250),
    [anon_sym_LT_AT] = ACTIONS(2250),
    [anon_sym_LT_AT_AT] = ACTIONS(2250),
    [anon_sym_AT_AT_GT] = ACTIONS(2250),
    [anon_sym_DOT] = ACTIONS(2250),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2248),
    [anon_sym_new] = ACTIONS(2250),
    [anon_sym_return_BANG] = ACTIONS(2248),
    [anon_sym_yield] = ACTIONS(2250),
    [anon_sym_yield_BANG] = ACTIONS(2248),
    [anon_sym_lazy] = ACTIONS(2250),
    [anon_sym_assert] = ACTIONS(2250),
    [anon_sym_upcast] = ACTIONS(2250),
    [anon_sym_downcast] = ACTIONS(2250),
    [anon_sym_COLON_GT] = ACTIONS(2248),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2248),
    [anon_sym_for] = ACTIONS(2250),
    [anon_sym_while] = ACTIONS(2250),
    [anon_sym_if] = ACTIONS(2250),
    [anon_sym_fun] = ACTIONS(2250),
    [anon_sym_DASH_GT] = ACTIONS(3224),
    [anon_sym_try] = ACTIONS(2250),
    [anon_sym_match] = ACTIONS(2250),
    [anon_sym_match_BANG] = ACTIONS(2248),
    [anon_sym_function] = ACTIONS(2250),
    [anon_sym_LT_DASH] = ACTIONS(2250),
    [anon_sym_DOT_LBRACK] = ACTIONS(2248),
    [anon_sym_LT] = ACTIONS(2248),
    [anon_sym_use] = ACTIONS(2250),
    [anon_sym_use_BANG] = ACTIONS(2248),
    [anon_sym_do_BANG] = ACTIONS(2248),
    [anon_sym_begin] = ACTIONS(2250),
    [anon_sym_LPAREN2] = ACTIONS(2250),
    [anon_sym_STAR] = ACTIONS(3226),
    [anon_sym_LT2] = ACTIONS(3228),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3230),
    [anon_sym_or] = ACTIONS(2250),
    [aux_sym_char_token1] = ACTIONS(2248),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2250),
    [anon_sym_DQUOTE] = ACTIONS(2250),
    [anon_sym_AT_DQUOTE] = ACTIONS(2248),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2248),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2248),
    [sym_bool] = ACTIONS(2250),
    [sym_unit] = ACTIONS(2248),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2250),
    [sym_op_identifier] = ACTIONS(2250),
    [anon_sym_PLUS] = ACTIONS(2250),
    [anon_sym_DASH] = ACTIONS(2250),
    [anon_sym_PLUS_DOT] = ACTIONS(2250),
    [anon_sym_DASH_DOT] = ACTIONS(2250),
    [anon_sym_PERCENT] = ACTIONS(2250),
    [anon_sym_AMP_AMP] = ACTIONS(2250),
    [anon_sym_TILDE] = ACTIONS(2248),
    [aux_sym_prefix_op_token1] = ACTIONS(2250),
    [aux_sym_infix_op_token1] = ACTIONS(2248),
    [aux_sym_infix_op_token2] = ACTIONS(2250),
    [anon_sym_PIPE_PIPE] = ACTIONS(2250),
    [anon_sym_BANG_EQ] = ACTIONS(2250),
    [anon_sym_COLON_EQ] = ACTIONS(2248),
    [anon_sym_DOLLAR] = ACTIONS(2250),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2250),
    [sym_int] = ACTIONS(2250),
    [sym_xint] = ACTIONS(2248),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2248),
    [sym__newline] = ACTIONS(2248),
  },
  [1028] = {
    [sym_block_comment] = STATE(1028),
    [sym_compiler_directive_decl] = STATE(1028),
    [sym_fsi_directive_decl] = STATE(1028),
    [sym_preproc_line] = STATE(1028),
    [aux_sym_type_argument_repeat1] = STATE(1022),
    [sym_identifier] = ACTIONS(2328),
    [anon_sym_EQ] = ACTIONS(2330),
    [anon_sym_COLON] = ACTIONS(2328),
    [anon_sym_return] = ACTIONS(2328),
    [anon_sym_do] = ACTIONS(2328),
    [anon_sym_let] = ACTIONS(2328),
    [anon_sym_let_BANG] = ACTIONS(2330),
    [anon_sym_as] = ACTIONS(2328),
    [anon_sym_LPAREN] = ACTIONS(2328),
    [anon_sym_COMMA] = ACTIONS(2330),
    [anon_sym_null] = ACTIONS(2328),
    [anon_sym_QMARK] = ACTIONS(2328),
    [anon_sym_COLON_QMARK] = ACTIONS(2328),
    [anon_sym_COLON_COLON] = ACTIONS(2330),
    [anon_sym_AMP] = ACTIONS(2328),
    [anon_sym_LBRACK] = ACTIONS(2328),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2330),
    [anon_sym_LBRACE] = ACTIONS(2328),
    [anon_sym_LT_AT] = ACTIONS(2328),
    [anon_sym_LT_AT_AT] = ACTIONS(2328),
    [anon_sym_DOT] = ACTIONS(2328),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2330),
    [anon_sym_new] = ACTIONS(2328),
    [anon_sym_with] = ACTIONS(2328),
    [anon_sym_return_BANG] = ACTIONS(2330),
    [anon_sym_yield] = ACTIONS(2328),
    [anon_sym_yield_BANG] = ACTIONS(2330),
    [anon_sym_lazy] = ACTIONS(2328),
    [anon_sym_assert] = ACTIONS(2328),
    [anon_sym_upcast] = ACTIONS(2328),
    [anon_sym_downcast] = ACTIONS(2328),
    [anon_sym_COLON_GT] = ACTIONS(2330),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2330),
    [anon_sym_for] = ACTIONS(2328),
    [anon_sym_while] = ACTIONS(2328),
    [anon_sym_if] = ACTIONS(2328),
    [anon_sym_fun] = ACTIONS(2328),
    [anon_sym_DASH_GT] = ACTIONS(2328),
    [anon_sym_try] = ACTIONS(2328),
    [anon_sym_match] = ACTIONS(2328),
    [anon_sym_match_BANG] = ACTIONS(2330),
    [anon_sym_function] = ACTIONS(2328),
    [anon_sym_LT_DASH] = ACTIONS(2328),
    [anon_sym_DOT_LBRACK] = ACTIONS(2330),
    [anon_sym_LT] = ACTIONS(2330),
    [anon_sym_use] = ACTIONS(2328),
    [anon_sym_use_BANG] = ACTIONS(2330),
    [anon_sym_do_BANG] = ACTIONS(2330),
    [anon_sym_begin] = ACTIONS(2328),
    [anon_sym_LPAREN2] = ACTIONS(2328),
    [anon_sym_STAR] = ACTIONS(2328),
    [anon_sym_LT2] = ACTIONS(2328),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2330),
    [anon_sym_or] = ACTIONS(2328),
    [aux_sym_char_token1] = ACTIONS(2330),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2328),
    [anon_sym_DQUOTE] = ACTIONS(2328),
    [anon_sym_AT_DQUOTE] = ACTIONS(2330),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2330),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2330),
    [sym_bool] = ACTIONS(2328),
    [sym_unit] = ACTIONS(2330),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2328),
    [sym_op_identifier] = ACTIONS(2328),
    [anon_sym_PLUS] = ACTIONS(2328),
    [anon_sym_DASH] = ACTIONS(2328),
    [anon_sym_PLUS_DOT] = ACTIONS(2328),
    [anon_sym_DASH_DOT] = ACTIONS(2328),
    [anon_sym_PERCENT] = ACTIONS(2328),
    [anon_sym_AMP_AMP] = ACTIONS(2328),
    [anon_sym_TILDE] = ACTIONS(2330),
    [aux_sym_prefix_op_token1] = ACTIONS(2328),
    [aux_sym_infix_op_token1] = ACTIONS(2330),
    [aux_sym_infix_op_token2] = ACTIONS(2328),
    [anon_sym_PIPE_PIPE] = ACTIONS(2328),
    [anon_sym_BANG_EQ] = ACTIONS(2328),
    [anon_sym_COLON_EQ] = ACTIONS(2330),
    [anon_sym_DOLLAR] = ACTIONS(2328),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2328),
    [sym_int] = ACTIONS(2328),
    [sym_xint] = ACTIONS(2330),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2330),
    [sym__newline] = ACTIONS(2330),
    [sym__dedent] = ACTIONS(2330),
  },
  [1029] = {
    [sym_type_arguments] = STATE(1323),
    [sym_long_identifier] = STATE(1345),
    [sym_block_comment] = STATE(1029),
    [sym_compiler_directive_decl] = STATE(1029),
    [sym_fsi_directive_decl] = STATE(1029),
    [sym_preproc_line] = STATE(1029),
    [aux_sym_compound_type_repeat1] = STATE(1235),
    [sym_identifier] = ACTIONS(3265),
    [anon_sym_EQ] = ACTIONS(2228),
    [anon_sym_COLON] = ACTIONS(2230),
    [anon_sym_return] = ACTIONS(2230),
    [anon_sym_do] = ACTIONS(2230),
    [anon_sym_let] = ACTIONS(2230),
    [anon_sym_let_BANG] = ACTIONS(2228),
    [anon_sym_LPAREN] = ACTIONS(2230),
    [anon_sym_COMMA] = ACTIONS(2228),
    [anon_sym_null] = ACTIONS(2230),
    [anon_sym_QMARK] = ACTIONS(2230),
    [anon_sym_COLON_QMARK] = ACTIONS(2230),
    [anon_sym_COLON_COLON] = ACTIONS(2228),
    [anon_sym_AMP] = ACTIONS(2230),
    [anon_sym_LBRACK] = ACTIONS(2230),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2228),
    [anon_sym_LBRACE] = ACTIONS(2230),
    [anon_sym_LT_AT] = ACTIONS(2230),
    [anon_sym_LT_AT_AT] = ACTIONS(2230),
    [anon_sym_AT_AT_GT] = ACTIONS(2230),
    [anon_sym_DOT] = ACTIONS(2230),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2228),
    [anon_sym_new] = ACTIONS(2230),
    [anon_sym_return_BANG] = ACTIONS(2228),
    [anon_sym_yield] = ACTIONS(2230),
    [anon_sym_yield_BANG] = ACTIONS(2228),
    [anon_sym_lazy] = ACTIONS(2230),
    [anon_sym_assert] = ACTIONS(2230),
    [anon_sym_upcast] = ACTIONS(2230),
    [anon_sym_downcast] = ACTIONS(2230),
    [anon_sym_COLON_GT] = ACTIONS(2228),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2228),
    [anon_sym_for] = ACTIONS(2230),
    [anon_sym_while] = ACTIONS(2230),
    [anon_sym_if] = ACTIONS(2230),
    [anon_sym_fun] = ACTIONS(2230),
    [anon_sym_DASH_GT] = ACTIONS(3224),
    [anon_sym_try] = ACTIONS(2230),
    [anon_sym_match] = ACTIONS(2230),
    [anon_sym_match_BANG] = ACTIONS(2228),
    [anon_sym_function] = ACTIONS(2230),
    [anon_sym_LT_DASH] = ACTIONS(2230),
    [anon_sym_DOT_LBRACK] = ACTIONS(2228),
    [anon_sym_LT] = ACTIONS(2228),
    [anon_sym_use] = ACTIONS(2230),
    [anon_sym_use_BANG] = ACTIONS(2228),
    [anon_sym_do_BANG] = ACTIONS(2228),
    [anon_sym_begin] = ACTIONS(2230),
    [anon_sym_LPAREN2] = ACTIONS(2230),
    [anon_sym_STAR] = ACTIONS(3226),
    [anon_sym_LT2] = ACTIONS(3228),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3230),
    [anon_sym_or] = ACTIONS(2230),
    [aux_sym_char_token1] = ACTIONS(2228),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2230),
    [anon_sym_DQUOTE] = ACTIONS(2230),
    [anon_sym_AT_DQUOTE] = ACTIONS(2228),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2228),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2228),
    [sym_bool] = ACTIONS(2230),
    [sym_unit] = ACTIONS(2228),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2230),
    [sym_op_identifier] = ACTIONS(2230),
    [anon_sym_PLUS] = ACTIONS(2230),
    [anon_sym_DASH] = ACTIONS(2230),
    [anon_sym_PLUS_DOT] = ACTIONS(2230),
    [anon_sym_DASH_DOT] = ACTIONS(2230),
    [anon_sym_PERCENT] = ACTIONS(2230),
    [anon_sym_AMP_AMP] = ACTIONS(2230),
    [anon_sym_TILDE] = ACTIONS(2228),
    [aux_sym_prefix_op_token1] = ACTIONS(2230),
    [aux_sym_infix_op_token1] = ACTIONS(2228),
    [aux_sym_infix_op_token2] = ACTIONS(2230),
    [anon_sym_PIPE_PIPE] = ACTIONS(2230),
    [anon_sym_BANG_EQ] = ACTIONS(2230),
    [anon_sym_COLON_EQ] = ACTIONS(2228),
    [anon_sym_DOLLAR] = ACTIONS(2230),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2230),
    [sym_int] = ACTIONS(2230),
    [sym_xint] = ACTIONS(2228),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2228),
    [sym__newline] = ACTIONS(2228),
  },
  [1030] = {
    [sym_type_arguments] = STATE(1334),
    [sym_long_identifier] = STATE(1346),
    [sym_block_comment] = STATE(1030),
    [sym_compiler_directive_decl] = STATE(1030),
    [sym_fsi_directive_decl] = STATE(1030),
    [sym_preproc_line] = STATE(1030),
    [aux_sym_compound_type_repeat1] = STATE(1233),
    [sym_identifier] = ACTIONS(3281),
    [anon_sym_EQ] = ACTIONS(2228),
    [anon_sym_COLON] = ACTIONS(2230),
    [anon_sym_return] = ACTIONS(2230),
    [anon_sym_do] = ACTIONS(2230),
    [anon_sym_let] = ACTIONS(2230),
    [anon_sym_let_BANG] = ACTIONS(2228),
    [anon_sym_LPAREN] = ACTIONS(2230),
    [anon_sym_COMMA] = ACTIONS(2228),
    [anon_sym_null] = ACTIONS(2230),
    [anon_sym_QMARK] = ACTIONS(2230),
    [anon_sym_COLON_QMARK] = ACTIONS(2230),
    [anon_sym_COLON_COLON] = ACTIONS(2228),
    [anon_sym_AMP] = ACTIONS(2230),
    [anon_sym_LBRACK] = ACTIONS(2230),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2228),
    [anon_sym_LBRACE] = ACTIONS(2230),
    [anon_sym_LT_AT] = ACTIONS(2230),
    [anon_sym_LT_AT_AT] = ACTIONS(2230),
    [anon_sym_DOT] = ACTIONS(2230),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2228),
    [anon_sym_new] = ACTIONS(2230),
    [anon_sym_return_BANG] = ACTIONS(2228),
    [anon_sym_yield] = ACTIONS(2230),
    [anon_sym_yield_BANG] = ACTIONS(2228),
    [anon_sym_lazy] = ACTIONS(2230),
    [anon_sym_assert] = ACTIONS(2230),
    [anon_sym_upcast] = ACTIONS(2230),
    [anon_sym_downcast] = ACTIONS(2230),
    [anon_sym_COLON_GT] = ACTIONS(2228),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2228),
    [anon_sym_for] = ACTIONS(2230),
    [anon_sym_while] = ACTIONS(2230),
    [anon_sym_if] = ACTIONS(2230),
    [anon_sym_fun] = ACTIONS(2230),
    [anon_sym_DASH_GT] = ACTIONS(3283),
    [anon_sym_try] = ACTIONS(2230),
    [anon_sym_match] = ACTIONS(2230),
    [anon_sym_match_BANG] = ACTIONS(2228),
    [anon_sym_function] = ACTIONS(2230),
    [anon_sym_LT_DASH] = ACTIONS(2230),
    [anon_sym_DOT_LBRACK] = ACTIONS(2228),
    [anon_sym_LT] = ACTIONS(2228),
    [anon_sym_use] = ACTIONS(2230),
    [anon_sym_use_BANG] = ACTIONS(2228),
    [anon_sym_do_BANG] = ACTIONS(2228),
    [anon_sym_DOT_DOT] = ACTIONS(2228),
    [anon_sym_begin] = ACTIONS(2230),
    [anon_sym_LPAREN2] = ACTIONS(2230),
    [anon_sym_STAR] = ACTIONS(3256),
    [anon_sym_LT2] = ACTIONS(3258),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3260),
    [anon_sym_or] = ACTIONS(2230),
    [aux_sym_char_token1] = ACTIONS(2228),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2230),
    [anon_sym_DQUOTE] = ACTIONS(2230),
    [anon_sym_AT_DQUOTE] = ACTIONS(2228),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2228),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2228),
    [sym_bool] = ACTIONS(2230),
    [sym_unit] = ACTIONS(2228),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2230),
    [sym_op_identifier] = ACTIONS(2230),
    [anon_sym_PLUS] = ACTIONS(2230),
    [anon_sym_DASH] = ACTIONS(2230),
    [anon_sym_PLUS_DOT] = ACTIONS(2230),
    [anon_sym_DASH_DOT] = ACTIONS(2230),
    [anon_sym_PERCENT] = ACTIONS(2230),
    [anon_sym_AMP_AMP] = ACTIONS(2230),
    [anon_sym_TILDE] = ACTIONS(2228),
    [aux_sym_prefix_op_token1] = ACTIONS(2230),
    [aux_sym_infix_op_token1] = ACTIONS(2228),
    [aux_sym_infix_op_token2] = ACTIONS(2230),
    [anon_sym_PIPE_PIPE] = ACTIONS(2230),
    [anon_sym_BANG_EQ] = ACTIONS(2230),
    [anon_sym_COLON_EQ] = ACTIONS(2228),
    [anon_sym_DOLLAR] = ACTIONS(2230),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2230),
    [sym_int] = ACTIONS(2230),
    [sym_xint] = ACTIONS(2228),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2228),
    [sym__newline] = ACTIONS(2228),
  },
  [1031] = {
    [sym_type_arguments] = STATE(1334),
    [sym_long_identifier] = STATE(1346),
    [sym_block_comment] = STATE(1031),
    [sym_compiler_directive_decl] = STATE(1031),
    [sym_fsi_directive_decl] = STATE(1031),
    [sym_preproc_line] = STATE(1031),
    [aux_sym_compound_type_repeat1] = STATE(1233),
    [sym_identifier] = ACTIONS(3281),
    [anon_sym_EQ] = ACTIONS(2248),
    [anon_sym_COLON] = ACTIONS(2250),
    [anon_sym_return] = ACTIONS(2250),
    [anon_sym_do] = ACTIONS(2250),
    [anon_sym_let] = ACTIONS(2250),
    [anon_sym_let_BANG] = ACTIONS(2248),
    [anon_sym_LPAREN] = ACTIONS(2250),
    [anon_sym_COMMA] = ACTIONS(2248),
    [anon_sym_null] = ACTIONS(2250),
    [anon_sym_QMARK] = ACTIONS(2250),
    [anon_sym_COLON_QMARK] = ACTIONS(2250),
    [anon_sym_COLON_COLON] = ACTIONS(2248),
    [anon_sym_AMP] = ACTIONS(2250),
    [anon_sym_LBRACK] = ACTIONS(2250),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2248),
    [anon_sym_LBRACE] = ACTIONS(2250),
    [anon_sym_LT_AT] = ACTIONS(2250),
    [anon_sym_LT_AT_AT] = ACTIONS(2250),
    [anon_sym_DOT] = ACTIONS(2250),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2248),
    [anon_sym_new] = ACTIONS(2250),
    [anon_sym_return_BANG] = ACTIONS(2248),
    [anon_sym_yield] = ACTIONS(2250),
    [anon_sym_yield_BANG] = ACTIONS(2248),
    [anon_sym_lazy] = ACTIONS(2250),
    [anon_sym_assert] = ACTIONS(2250),
    [anon_sym_upcast] = ACTIONS(2250),
    [anon_sym_downcast] = ACTIONS(2250),
    [anon_sym_COLON_GT] = ACTIONS(2248),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2248),
    [anon_sym_for] = ACTIONS(2250),
    [anon_sym_while] = ACTIONS(2250),
    [anon_sym_if] = ACTIONS(2250),
    [anon_sym_fun] = ACTIONS(2250),
    [anon_sym_DASH_GT] = ACTIONS(3283),
    [anon_sym_try] = ACTIONS(2250),
    [anon_sym_match] = ACTIONS(2250),
    [anon_sym_match_BANG] = ACTIONS(2248),
    [anon_sym_function] = ACTIONS(2250),
    [anon_sym_LT_DASH] = ACTIONS(2250),
    [anon_sym_DOT_LBRACK] = ACTIONS(2248),
    [anon_sym_LT] = ACTIONS(2248),
    [anon_sym_use] = ACTIONS(2250),
    [anon_sym_use_BANG] = ACTIONS(2248),
    [anon_sym_do_BANG] = ACTIONS(2248),
    [anon_sym_DOT_DOT] = ACTIONS(2248),
    [anon_sym_begin] = ACTIONS(2250),
    [anon_sym_LPAREN2] = ACTIONS(2250),
    [anon_sym_STAR] = ACTIONS(3256),
    [anon_sym_LT2] = ACTIONS(3258),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3260),
    [anon_sym_or] = ACTIONS(2250),
    [aux_sym_char_token1] = ACTIONS(2248),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2250),
    [anon_sym_DQUOTE] = ACTIONS(2250),
    [anon_sym_AT_DQUOTE] = ACTIONS(2248),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2248),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2248),
    [sym_bool] = ACTIONS(2250),
    [sym_unit] = ACTIONS(2248),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2250),
    [sym_op_identifier] = ACTIONS(2250),
    [anon_sym_PLUS] = ACTIONS(2250),
    [anon_sym_DASH] = ACTIONS(2250),
    [anon_sym_PLUS_DOT] = ACTIONS(2250),
    [anon_sym_DASH_DOT] = ACTIONS(2250),
    [anon_sym_PERCENT] = ACTIONS(2250),
    [anon_sym_AMP_AMP] = ACTIONS(2250),
    [anon_sym_TILDE] = ACTIONS(2248),
    [aux_sym_prefix_op_token1] = ACTIONS(2250),
    [aux_sym_infix_op_token1] = ACTIONS(2248),
    [aux_sym_infix_op_token2] = ACTIONS(2250),
    [anon_sym_PIPE_PIPE] = ACTIONS(2250),
    [anon_sym_BANG_EQ] = ACTIONS(2250),
    [anon_sym_COLON_EQ] = ACTIONS(2248),
    [anon_sym_DOLLAR] = ACTIONS(2250),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2250),
    [sym_int] = ACTIONS(2250),
    [sym_xint] = ACTIONS(2248),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2248),
    [sym__newline] = ACTIONS(2248),
  },
  [1032] = {
    [sym_type_arguments] = STATE(1334),
    [sym_long_identifier] = STATE(1346),
    [sym_block_comment] = STATE(1032),
    [sym_compiler_directive_decl] = STATE(1032),
    [sym_fsi_directive_decl] = STATE(1032),
    [sym_preproc_line] = STATE(1032),
    [aux_sym_compound_type_repeat1] = STATE(1233),
    [sym_identifier] = ACTIONS(2252),
    [anon_sym_EQ] = ACTIONS(2254),
    [anon_sym_COLON] = ACTIONS(2252),
    [anon_sym_return] = ACTIONS(2252),
    [anon_sym_do] = ACTIONS(2252),
    [anon_sym_let] = ACTIONS(2252),
    [anon_sym_let_BANG] = ACTIONS(2254),
    [anon_sym_LPAREN] = ACTIONS(2252),
    [anon_sym_COMMA] = ACTIONS(2254),
    [anon_sym_null] = ACTIONS(2252),
    [anon_sym_QMARK] = ACTIONS(2252),
    [anon_sym_COLON_QMARK] = ACTIONS(2252),
    [anon_sym_COLON_COLON] = ACTIONS(2254),
    [anon_sym_AMP] = ACTIONS(2252),
    [anon_sym_LBRACK] = ACTIONS(2252),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2254),
    [anon_sym_LBRACE] = ACTIONS(2252),
    [anon_sym_LT_AT] = ACTIONS(2252),
    [anon_sym_LT_AT_AT] = ACTIONS(2252),
    [anon_sym_DOT] = ACTIONS(2252),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2254),
    [anon_sym_new] = ACTIONS(2252),
    [anon_sym_return_BANG] = ACTIONS(2254),
    [anon_sym_yield] = ACTIONS(2252),
    [anon_sym_yield_BANG] = ACTIONS(2254),
    [anon_sym_lazy] = ACTIONS(2252),
    [anon_sym_assert] = ACTIONS(2252),
    [anon_sym_upcast] = ACTIONS(2252),
    [anon_sym_downcast] = ACTIONS(2252),
    [anon_sym_COLON_GT] = ACTIONS(2254),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2254),
    [anon_sym_for] = ACTIONS(2252),
    [anon_sym_while] = ACTIONS(2252),
    [anon_sym_if] = ACTIONS(2252),
    [anon_sym_fun] = ACTIONS(2252),
    [anon_sym_DASH_GT] = ACTIONS(3283),
    [anon_sym_try] = ACTIONS(2252),
    [anon_sym_match] = ACTIONS(2252),
    [anon_sym_match_BANG] = ACTIONS(2254),
    [anon_sym_function] = ACTIONS(2252),
    [anon_sym_LT_DASH] = ACTIONS(2252),
    [anon_sym_DOT_LBRACK] = ACTIONS(2254),
    [anon_sym_LT] = ACTIONS(2254),
    [anon_sym_use] = ACTIONS(2252),
    [anon_sym_use_BANG] = ACTIONS(2254),
    [anon_sym_do_BANG] = ACTIONS(2254),
    [anon_sym_DOT_DOT] = ACTIONS(2254),
    [anon_sym_begin] = ACTIONS(2252),
    [anon_sym_LPAREN2] = ACTIONS(2252),
    [anon_sym_STAR] = ACTIONS(3256),
    [anon_sym_LT2] = ACTIONS(3258),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3260),
    [anon_sym_or] = ACTIONS(2252),
    [aux_sym_char_token1] = ACTIONS(2254),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2252),
    [anon_sym_DQUOTE] = ACTIONS(2252),
    [anon_sym_AT_DQUOTE] = ACTIONS(2254),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2254),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2254),
    [sym_bool] = ACTIONS(2252),
    [sym_unit] = ACTIONS(2254),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2252),
    [sym_op_identifier] = ACTIONS(2252),
    [anon_sym_PLUS] = ACTIONS(2252),
    [anon_sym_DASH] = ACTIONS(2252),
    [anon_sym_PLUS_DOT] = ACTIONS(2252),
    [anon_sym_DASH_DOT] = ACTIONS(2252),
    [anon_sym_PERCENT] = ACTIONS(2252),
    [anon_sym_AMP_AMP] = ACTIONS(2252),
    [anon_sym_TILDE] = ACTIONS(2254),
    [aux_sym_prefix_op_token1] = ACTIONS(2252),
    [aux_sym_infix_op_token1] = ACTIONS(2254),
    [aux_sym_infix_op_token2] = ACTIONS(2252),
    [anon_sym_PIPE_PIPE] = ACTIONS(2252),
    [anon_sym_BANG_EQ] = ACTIONS(2252),
    [anon_sym_COLON_EQ] = ACTIONS(2254),
    [anon_sym_DOLLAR] = ACTIONS(2252),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2252),
    [sym_int] = ACTIONS(2252),
    [sym_xint] = ACTIONS(2254),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2254),
    [sym__newline] = ACTIONS(2254),
  },
  [1033] = {
    [sym_block_comment] = STATE(1033),
    [sym_compiler_directive_decl] = STATE(1033),
    [sym_fsi_directive_decl] = STATE(1033),
    [sym_preproc_line] = STATE(1033),
    [aux_sym_long_identifier_repeat1] = STATE(1019),
    [sym_identifier] = ACTIONS(2312),
    [anon_sym_EQ] = ACTIONS(2314),
    [anon_sym_COLON] = ACTIONS(2312),
    [anon_sym_return] = ACTIONS(2312),
    [anon_sym_do] = ACTIONS(2312),
    [anon_sym_let] = ACTIONS(2312),
    [anon_sym_let_BANG] = ACTIONS(2314),
    [anon_sym_as] = ACTIONS(2312),
    [anon_sym_LPAREN] = ACTIONS(2312),
    [anon_sym_COMMA] = ACTIONS(2314),
    [anon_sym_null] = ACTIONS(2312),
    [anon_sym_QMARK] = ACTIONS(2312),
    [anon_sym_COLON_QMARK] = ACTIONS(2312),
    [anon_sym_COLON_COLON] = ACTIONS(2314),
    [anon_sym_AMP] = ACTIONS(2312),
    [anon_sym_LBRACK] = ACTIONS(2312),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2314),
    [anon_sym_LBRACE] = ACTIONS(2312),
    [anon_sym_LT_AT] = ACTIONS(2312),
    [anon_sym_LT_AT_AT] = ACTIONS(2312),
    [anon_sym_DOT] = ACTIONS(3267),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2314),
    [anon_sym_new] = ACTIONS(2312),
    [anon_sym_with] = ACTIONS(2312),
    [anon_sym_return_BANG] = ACTIONS(2314),
    [anon_sym_yield] = ACTIONS(2312),
    [anon_sym_yield_BANG] = ACTIONS(2314),
    [anon_sym_lazy] = ACTIONS(2312),
    [anon_sym_assert] = ACTIONS(2312),
    [anon_sym_upcast] = ACTIONS(2312),
    [anon_sym_downcast] = ACTIONS(2312),
    [anon_sym_COLON_GT] = ACTIONS(2314),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2314),
    [anon_sym_for] = ACTIONS(2312),
    [anon_sym_while] = ACTIONS(2312),
    [anon_sym_if] = ACTIONS(2312),
    [anon_sym_fun] = ACTIONS(2312),
    [anon_sym_DASH_GT] = ACTIONS(2312),
    [anon_sym_try] = ACTIONS(2312),
    [anon_sym_match] = ACTIONS(2312),
    [anon_sym_match_BANG] = ACTIONS(2314),
    [anon_sym_function] = ACTIONS(2312),
    [anon_sym_LT_DASH] = ACTIONS(2312),
    [anon_sym_DOT_LBRACK] = ACTIONS(2314),
    [anon_sym_LT] = ACTIONS(2314),
    [anon_sym_use] = ACTIONS(2312),
    [anon_sym_use_BANG] = ACTIONS(2314),
    [anon_sym_do_BANG] = ACTIONS(2314),
    [anon_sym_begin] = ACTIONS(2312),
    [anon_sym_LPAREN2] = ACTIONS(2312),
    [anon_sym_STAR] = ACTIONS(2312),
    [anon_sym_LT2] = ACTIONS(2312),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2314),
    [anon_sym_or] = ACTIONS(2312),
    [aux_sym_char_token1] = ACTIONS(2314),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2312),
    [anon_sym_DQUOTE] = ACTIONS(2312),
    [anon_sym_AT_DQUOTE] = ACTIONS(2314),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2314),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2314),
    [sym_bool] = ACTIONS(2312),
    [sym_unit] = ACTIONS(2314),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2312),
    [sym_op_identifier] = ACTIONS(2312),
    [anon_sym_PLUS] = ACTIONS(2312),
    [anon_sym_DASH] = ACTIONS(2312),
    [anon_sym_PLUS_DOT] = ACTIONS(2312),
    [anon_sym_DASH_DOT] = ACTIONS(2312),
    [anon_sym_PERCENT] = ACTIONS(2312),
    [anon_sym_AMP_AMP] = ACTIONS(2312),
    [anon_sym_TILDE] = ACTIONS(2314),
    [aux_sym_prefix_op_token1] = ACTIONS(2312),
    [aux_sym_infix_op_token1] = ACTIONS(2314),
    [aux_sym_infix_op_token2] = ACTIONS(2312),
    [anon_sym_PIPE_PIPE] = ACTIONS(2312),
    [anon_sym_BANG_EQ] = ACTIONS(2312),
    [anon_sym_COLON_EQ] = ACTIONS(2314),
    [anon_sym_DOLLAR] = ACTIONS(2312),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2312),
    [sym_int] = ACTIONS(2312),
    [sym_xint] = ACTIONS(2314),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2314),
    [sym__newline] = ACTIONS(2314),
    [sym__dedent] = ACTIONS(2314),
  },
  [1034] = {
    [sym_type_arguments] = STATE(1334),
    [sym_long_identifier] = STATE(1346),
    [sym_block_comment] = STATE(1034),
    [sym_compiler_directive_decl] = STATE(1034),
    [sym_fsi_directive_decl] = STATE(1034),
    [sym_preproc_line] = STATE(1034),
    [aux_sym_compound_type_repeat1] = STATE(1233),
    [sym_identifier] = ACTIONS(3281),
    [anon_sym_EQ] = ACTIONS(2244),
    [anon_sym_COLON] = ACTIONS(2246),
    [anon_sym_return] = ACTIONS(2246),
    [anon_sym_do] = ACTIONS(2246),
    [anon_sym_let] = ACTIONS(2246),
    [anon_sym_let_BANG] = ACTIONS(2244),
    [anon_sym_LPAREN] = ACTIONS(2246),
    [anon_sym_COMMA] = ACTIONS(2244),
    [anon_sym_null] = ACTIONS(2246),
    [anon_sym_QMARK] = ACTIONS(2246),
    [anon_sym_COLON_QMARK] = ACTIONS(2246),
    [anon_sym_COLON_COLON] = ACTIONS(2244),
    [anon_sym_AMP] = ACTIONS(2246),
    [anon_sym_LBRACK] = ACTIONS(2246),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2244),
    [anon_sym_LBRACE] = ACTIONS(2246),
    [anon_sym_LT_AT] = ACTIONS(2246),
    [anon_sym_LT_AT_AT] = ACTIONS(2246),
    [anon_sym_DOT] = ACTIONS(2246),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2244),
    [anon_sym_new] = ACTIONS(2246),
    [anon_sym_return_BANG] = ACTIONS(2244),
    [anon_sym_yield] = ACTIONS(2246),
    [anon_sym_yield_BANG] = ACTIONS(2244),
    [anon_sym_lazy] = ACTIONS(2246),
    [anon_sym_assert] = ACTIONS(2246),
    [anon_sym_upcast] = ACTIONS(2246),
    [anon_sym_downcast] = ACTIONS(2246),
    [anon_sym_COLON_GT] = ACTIONS(2244),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2244),
    [anon_sym_for] = ACTIONS(2246),
    [anon_sym_while] = ACTIONS(2246),
    [anon_sym_if] = ACTIONS(2246),
    [anon_sym_fun] = ACTIONS(2246),
    [anon_sym_DASH_GT] = ACTIONS(3283),
    [anon_sym_try] = ACTIONS(2246),
    [anon_sym_match] = ACTIONS(2246),
    [anon_sym_match_BANG] = ACTIONS(2244),
    [anon_sym_function] = ACTIONS(2246),
    [anon_sym_LT_DASH] = ACTIONS(2246),
    [anon_sym_DOT_LBRACK] = ACTIONS(2244),
    [anon_sym_LT] = ACTIONS(2244),
    [anon_sym_use] = ACTIONS(2246),
    [anon_sym_use_BANG] = ACTIONS(2244),
    [anon_sym_do_BANG] = ACTIONS(2244),
    [anon_sym_DOT_DOT] = ACTIONS(2244),
    [anon_sym_begin] = ACTIONS(2246),
    [anon_sym_LPAREN2] = ACTIONS(2246),
    [anon_sym_STAR] = ACTIONS(3256),
    [anon_sym_LT2] = ACTIONS(3258),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3260),
    [anon_sym_or] = ACTIONS(2246),
    [aux_sym_char_token1] = ACTIONS(2244),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2246),
    [anon_sym_DQUOTE] = ACTIONS(2246),
    [anon_sym_AT_DQUOTE] = ACTIONS(2244),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2244),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2244),
    [sym_bool] = ACTIONS(2246),
    [sym_unit] = ACTIONS(2244),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2246),
    [sym_op_identifier] = ACTIONS(2246),
    [anon_sym_PLUS] = ACTIONS(2246),
    [anon_sym_DASH] = ACTIONS(2246),
    [anon_sym_PLUS_DOT] = ACTIONS(2246),
    [anon_sym_DASH_DOT] = ACTIONS(2246),
    [anon_sym_PERCENT] = ACTIONS(2246),
    [anon_sym_AMP_AMP] = ACTIONS(2246),
    [anon_sym_TILDE] = ACTIONS(2244),
    [aux_sym_prefix_op_token1] = ACTIONS(2246),
    [aux_sym_infix_op_token1] = ACTIONS(2244),
    [aux_sym_infix_op_token2] = ACTIONS(2246),
    [anon_sym_PIPE_PIPE] = ACTIONS(2246),
    [anon_sym_BANG_EQ] = ACTIONS(2246),
    [anon_sym_COLON_EQ] = ACTIONS(2244),
    [anon_sym_DOLLAR] = ACTIONS(2246),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2246),
    [sym_int] = ACTIONS(2246),
    [sym_xint] = ACTIONS(2244),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2244),
    [sym__newline] = ACTIONS(2244),
  },
  [1035] = {
    [sym_type_arguments] = STATE(1334),
    [sym_long_identifier] = STATE(1346),
    [sym_block_comment] = STATE(1035),
    [sym_compiler_directive_decl] = STATE(1035),
    [sym_fsi_directive_decl] = STATE(1035),
    [sym_preproc_line] = STATE(1035),
    [aux_sym_compound_type_repeat1] = STATE(1233),
    [sym_identifier] = ACTIONS(3281),
    [anon_sym_EQ] = ACTIONS(2240),
    [anon_sym_COLON] = ACTIONS(2242),
    [anon_sym_return] = ACTIONS(2242),
    [anon_sym_do] = ACTIONS(2242),
    [anon_sym_let] = ACTIONS(2242),
    [anon_sym_let_BANG] = ACTIONS(2240),
    [anon_sym_LPAREN] = ACTIONS(2242),
    [anon_sym_COMMA] = ACTIONS(2240),
    [anon_sym_null] = ACTIONS(2242),
    [anon_sym_QMARK] = ACTIONS(2242),
    [anon_sym_COLON_QMARK] = ACTIONS(2242),
    [anon_sym_COLON_COLON] = ACTIONS(2240),
    [anon_sym_AMP] = ACTIONS(2242),
    [anon_sym_LBRACK] = ACTIONS(2242),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2240),
    [anon_sym_LBRACE] = ACTIONS(2242),
    [anon_sym_LT_AT] = ACTIONS(2242),
    [anon_sym_LT_AT_AT] = ACTIONS(2242),
    [anon_sym_DOT] = ACTIONS(2242),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2240),
    [anon_sym_new] = ACTIONS(2242),
    [anon_sym_return_BANG] = ACTIONS(2240),
    [anon_sym_yield] = ACTIONS(2242),
    [anon_sym_yield_BANG] = ACTIONS(2240),
    [anon_sym_lazy] = ACTIONS(2242),
    [anon_sym_assert] = ACTIONS(2242),
    [anon_sym_upcast] = ACTIONS(2242),
    [anon_sym_downcast] = ACTIONS(2242),
    [anon_sym_COLON_GT] = ACTIONS(2240),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2240),
    [anon_sym_for] = ACTIONS(2242),
    [anon_sym_while] = ACTIONS(2242),
    [anon_sym_if] = ACTIONS(2242),
    [anon_sym_fun] = ACTIONS(2242),
    [anon_sym_DASH_GT] = ACTIONS(3283),
    [anon_sym_try] = ACTIONS(2242),
    [anon_sym_match] = ACTIONS(2242),
    [anon_sym_match_BANG] = ACTIONS(2240),
    [anon_sym_function] = ACTIONS(2242),
    [anon_sym_LT_DASH] = ACTIONS(2242),
    [anon_sym_DOT_LBRACK] = ACTIONS(2240),
    [anon_sym_LT] = ACTIONS(2240),
    [anon_sym_use] = ACTIONS(2242),
    [anon_sym_use_BANG] = ACTIONS(2240),
    [anon_sym_do_BANG] = ACTIONS(2240),
    [anon_sym_DOT_DOT] = ACTIONS(2240),
    [anon_sym_begin] = ACTIONS(2242),
    [anon_sym_LPAREN2] = ACTIONS(2242),
    [anon_sym_STAR] = ACTIONS(3256),
    [anon_sym_LT2] = ACTIONS(3258),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3260),
    [anon_sym_or] = ACTIONS(2242),
    [aux_sym_char_token1] = ACTIONS(2240),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2242),
    [anon_sym_DQUOTE] = ACTIONS(2242),
    [anon_sym_AT_DQUOTE] = ACTIONS(2240),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2240),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2240),
    [sym_bool] = ACTIONS(2242),
    [sym_unit] = ACTIONS(2240),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2242),
    [sym_op_identifier] = ACTIONS(2242),
    [anon_sym_PLUS] = ACTIONS(2242),
    [anon_sym_DASH] = ACTIONS(2242),
    [anon_sym_PLUS_DOT] = ACTIONS(2242),
    [anon_sym_DASH_DOT] = ACTIONS(2242),
    [anon_sym_PERCENT] = ACTIONS(2242),
    [anon_sym_AMP_AMP] = ACTIONS(2242),
    [anon_sym_TILDE] = ACTIONS(2240),
    [aux_sym_prefix_op_token1] = ACTIONS(2242),
    [aux_sym_infix_op_token1] = ACTIONS(2240),
    [aux_sym_infix_op_token2] = ACTIONS(2242),
    [anon_sym_PIPE_PIPE] = ACTIONS(2242),
    [anon_sym_BANG_EQ] = ACTIONS(2242),
    [anon_sym_COLON_EQ] = ACTIONS(2240),
    [anon_sym_DOLLAR] = ACTIONS(2242),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2242),
    [sym_int] = ACTIONS(2242),
    [sym_xint] = ACTIONS(2240),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2240),
    [sym__newline] = ACTIONS(2240),
  },
  [1036] = {
    [sym_type_arguments] = STATE(1297),
    [sym_long_identifier] = STATE(1303),
    [sym_block_comment] = STATE(1036),
    [sym_compiler_directive_decl] = STATE(1036),
    [sym_fsi_directive_decl] = STATE(1036),
    [sym_preproc_line] = STATE(1036),
    [aux_sym_compound_type_repeat1] = STATE(1259),
    [sym_identifier] = ACTIONS(2252),
    [anon_sym_EQ] = ACTIONS(2254),
    [anon_sym_COLON] = ACTIONS(2252),
    [anon_sym_return] = ACTIONS(2252),
    [anon_sym_do] = ACTIONS(2252),
    [anon_sym_let] = ACTIONS(2252),
    [anon_sym_let_BANG] = ACTIONS(2254),
    [anon_sym_LPAREN] = ACTIONS(2252),
    [anon_sym_COMMA] = ACTIONS(2254),
    [anon_sym_null] = ACTIONS(2252),
    [anon_sym_QMARK] = ACTIONS(2252),
    [anon_sym_COLON_QMARK] = ACTIONS(2252),
    [anon_sym_COLON_COLON] = ACTIONS(2254),
    [anon_sym_AMP] = ACTIONS(2252),
    [anon_sym_LBRACK] = ACTIONS(2252),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2254),
    [anon_sym_LBRACE] = ACTIONS(2252),
    [anon_sym_LT_AT] = ACTIONS(2252),
    [anon_sym_LT_AT_AT] = ACTIONS(2252),
    [anon_sym_DOT] = ACTIONS(2252),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2254),
    [anon_sym_new] = ACTIONS(2252),
    [anon_sym_return_BANG] = ACTIONS(2254),
    [anon_sym_yield] = ACTIONS(2252),
    [anon_sym_yield_BANG] = ACTIONS(2254),
    [anon_sym_lazy] = ACTIONS(2252),
    [anon_sym_assert] = ACTIONS(2252),
    [anon_sym_upcast] = ACTIONS(2252),
    [anon_sym_downcast] = ACTIONS(2252),
    [anon_sym_COLON_GT] = ACTIONS(2254),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2254),
    [anon_sym_for] = ACTIONS(2252),
    [anon_sym_while] = ACTIONS(2252),
    [anon_sym_if] = ACTIONS(2252),
    [anon_sym_fun] = ACTIONS(2252),
    [anon_sym_DASH_GT] = ACTIONS(3238),
    [anon_sym_try] = ACTIONS(2252),
    [anon_sym_match] = ACTIONS(2252),
    [anon_sym_match_BANG] = ACTIONS(2254),
    [anon_sym_function] = ACTIONS(2252),
    [anon_sym_LT_DASH] = ACTIONS(2252),
    [anon_sym_DOT_LBRACK] = ACTIONS(2254),
    [anon_sym_LT] = ACTIONS(2254),
    [anon_sym_use] = ACTIONS(2252),
    [anon_sym_use_BANG] = ACTIONS(2254),
    [anon_sym_do_BANG] = ACTIONS(2254),
    [anon_sym_begin] = ACTIONS(2252),
    [anon_sym_LPAREN2] = ACTIONS(2252),
    [anon_sym_STAR] = ACTIONS(3240),
    [anon_sym_LT2] = ACTIONS(3242),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3244),
    [anon_sym_or] = ACTIONS(2252),
    [aux_sym_char_token1] = ACTIONS(2254),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2252),
    [anon_sym_DQUOTE] = ACTIONS(2252),
    [anon_sym_AT_DQUOTE] = ACTIONS(2254),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2254),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2254),
    [sym_bool] = ACTIONS(2252),
    [sym_unit] = ACTIONS(2254),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2252),
    [sym_op_identifier] = ACTIONS(2252),
    [anon_sym_PLUS] = ACTIONS(2252),
    [anon_sym_DASH] = ACTIONS(2252),
    [anon_sym_PLUS_DOT] = ACTIONS(2252),
    [anon_sym_DASH_DOT] = ACTIONS(2252),
    [anon_sym_PERCENT] = ACTIONS(2252),
    [anon_sym_AMP_AMP] = ACTIONS(2252),
    [anon_sym_TILDE] = ACTIONS(2254),
    [aux_sym_prefix_op_token1] = ACTIONS(2252),
    [aux_sym_infix_op_token1] = ACTIONS(2254),
    [aux_sym_infix_op_token2] = ACTIONS(2252),
    [anon_sym_PIPE_PIPE] = ACTIONS(2252),
    [anon_sym_BANG_EQ] = ACTIONS(2252),
    [anon_sym_COLON_EQ] = ACTIONS(2254),
    [anon_sym_DOLLAR] = ACTIONS(2252),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2252),
    [sym_int] = ACTIONS(2252),
    [sym_xint] = ACTIONS(2254),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2254),
    [anon_sym_POUNDendif] = ACTIONS(2254),
    [sym__newline] = ACTIONS(2254),
  },
  [1037] = {
    [sym_type_arguments] = STATE(1285),
    [sym_long_identifier] = STATE(1378),
    [sym_block_comment] = STATE(1037),
    [sym_compiler_directive_decl] = STATE(1037),
    [sym_fsi_directive_decl] = STATE(1037),
    [sym_preproc_line] = STATE(1037),
    [aux_sym_compound_type_repeat1] = STATE(1268),
    [sym_identifier] = ACTIONS(3204),
    [anon_sym_EQ] = ACTIONS(2240),
    [anon_sym_COLON] = ACTIONS(2242),
    [anon_sym_return] = ACTIONS(2242),
    [anon_sym_do] = ACTIONS(2242),
    [anon_sym_let] = ACTIONS(2242),
    [anon_sym_let_BANG] = ACTIONS(2240),
    [anon_sym_LPAREN] = ACTIONS(2242),
    [anon_sym_COMMA] = ACTIONS(2240),
    [anon_sym_null] = ACTIONS(2242),
    [anon_sym_QMARK] = ACTIONS(2242),
    [anon_sym_COLON_QMARK] = ACTIONS(2242),
    [anon_sym_COLON_COLON] = ACTIONS(2240),
    [anon_sym_AMP] = ACTIONS(2242),
    [anon_sym_LBRACK] = ACTIONS(2242),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2240),
    [anon_sym_LBRACE] = ACTIONS(2242),
    [anon_sym_LT_AT] = ACTIONS(2242),
    [anon_sym_AT_GT] = ACTIONS(2242),
    [anon_sym_LT_AT_AT] = ACTIONS(2242),
    [anon_sym_DOT] = ACTIONS(2242),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2240),
    [anon_sym_new] = ACTIONS(2242),
    [anon_sym_return_BANG] = ACTIONS(2240),
    [anon_sym_yield] = ACTIONS(2242),
    [anon_sym_yield_BANG] = ACTIONS(2240),
    [anon_sym_lazy] = ACTIONS(2242),
    [anon_sym_assert] = ACTIONS(2242),
    [anon_sym_upcast] = ACTIONS(2242),
    [anon_sym_downcast] = ACTIONS(2242),
    [anon_sym_COLON_GT] = ACTIONS(2240),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2240),
    [anon_sym_for] = ACTIONS(2242),
    [anon_sym_while] = ACTIONS(2242),
    [anon_sym_if] = ACTIONS(2242),
    [anon_sym_fun] = ACTIONS(2242),
    [anon_sym_DASH_GT] = ACTIONS(3206),
    [anon_sym_try] = ACTIONS(2242),
    [anon_sym_match] = ACTIONS(2242),
    [anon_sym_match_BANG] = ACTIONS(2240),
    [anon_sym_function] = ACTIONS(2242),
    [anon_sym_LT_DASH] = ACTIONS(2242),
    [anon_sym_DOT_LBRACK] = ACTIONS(2240),
    [anon_sym_LT] = ACTIONS(2240),
    [anon_sym_use] = ACTIONS(2242),
    [anon_sym_use_BANG] = ACTIONS(2240),
    [anon_sym_do_BANG] = ACTIONS(2240),
    [anon_sym_begin] = ACTIONS(2242),
    [anon_sym_LPAREN2] = ACTIONS(2242),
    [anon_sym_STAR] = ACTIONS(3208),
    [anon_sym_LT2] = ACTIONS(3210),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3212),
    [anon_sym_or] = ACTIONS(2242),
    [aux_sym_char_token1] = ACTIONS(2240),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2242),
    [anon_sym_DQUOTE] = ACTIONS(2242),
    [anon_sym_AT_DQUOTE] = ACTIONS(2240),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2240),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2240),
    [sym_bool] = ACTIONS(2242),
    [sym_unit] = ACTIONS(2240),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2242),
    [sym_op_identifier] = ACTIONS(2242),
    [anon_sym_PLUS] = ACTIONS(2242),
    [anon_sym_DASH] = ACTIONS(2242),
    [anon_sym_PLUS_DOT] = ACTIONS(2242),
    [anon_sym_DASH_DOT] = ACTIONS(2242),
    [anon_sym_PERCENT] = ACTIONS(2242),
    [anon_sym_AMP_AMP] = ACTIONS(2242),
    [anon_sym_TILDE] = ACTIONS(2240),
    [aux_sym_prefix_op_token1] = ACTIONS(2242),
    [aux_sym_infix_op_token1] = ACTIONS(2240),
    [aux_sym_infix_op_token2] = ACTIONS(2242),
    [anon_sym_PIPE_PIPE] = ACTIONS(2242),
    [anon_sym_BANG_EQ] = ACTIONS(2242),
    [anon_sym_COLON_EQ] = ACTIONS(2240),
    [anon_sym_DOLLAR] = ACTIONS(2242),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2242),
    [sym_int] = ACTIONS(2242),
    [sym_xint] = ACTIONS(2240),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2240),
    [sym__newline] = ACTIONS(2240),
  },
  [1038] = {
    [sym_block_comment] = STATE(1038),
    [sym_compiler_directive_decl] = STATE(1038),
    [sym_fsi_directive_decl] = STATE(1038),
    [sym_preproc_line] = STATE(1038),
    [sym_identifier] = ACTIONS(2783),
    [anon_sym_EQ] = ACTIONS(2785),
    [anon_sym_GT_RBRACK] = ACTIONS(2785),
    [anon_sym_COLON] = ACTIONS(2783),
    [anon_sym_return] = ACTIONS(2783),
    [anon_sym_do] = ACTIONS(2783),
    [anon_sym_let] = ACTIONS(2783),
    [anon_sym_let_BANG] = ACTIONS(2785),
    [anon_sym_LPAREN] = ACTIONS(2783),
    [anon_sym_COMMA] = ACTIONS(2785),
    [anon_sym_null] = ACTIONS(2783),
    [anon_sym_QMARK] = ACTIONS(2783),
    [anon_sym_COLON_QMARK] = ACTIONS(2783),
    [anon_sym_COLON_COLON] = ACTIONS(2785),
    [anon_sym_AMP] = ACTIONS(2783),
    [anon_sym_LBRACK] = ACTIONS(2783),
    [anon_sym_RBRACK] = ACTIONS(2785),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2785),
    [anon_sym_LBRACE] = ACTIONS(2783),
    [anon_sym_RBRACE] = ACTIONS(2785),
    [anon_sym_LT_AT] = ACTIONS(2783),
    [anon_sym_LT_AT_AT] = ACTIONS(2783),
    [anon_sym_DOT] = ACTIONS(2783),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2785),
    [anon_sym_new] = ACTIONS(2783),
    [anon_sym_with] = ACTIONS(2783),
    [anon_sym_return_BANG] = ACTIONS(2785),
    [anon_sym_yield] = ACTIONS(2783),
    [anon_sym_yield_BANG] = ACTIONS(2785),
    [anon_sym_lazy] = ACTIONS(2783),
    [anon_sym_assert] = ACTIONS(2783),
    [anon_sym_upcast] = ACTIONS(2783),
    [anon_sym_downcast] = ACTIONS(2783),
    [anon_sym_COLON_GT] = ACTIONS(2785),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2785),
    [anon_sym_for] = ACTIONS(2783),
    [anon_sym_to] = ACTIONS(2783),
    [anon_sym_downto] = ACTIONS(2783),
    [anon_sym_done] = ACTIONS(3285),
    [anon_sym_while] = ACTIONS(2783),
    [anon_sym_if] = ACTIONS(2783),
    [anon_sym_fun] = ACTIONS(2783),
    [anon_sym_try] = ACTIONS(2783),
    [anon_sym_match] = ACTIONS(2783),
    [anon_sym_match_BANG] = ACTIONS(2785),
    [anon_sym_function] = ACTIONS(2783),
    [anon_sym_LT_DASH] = ACTIONS(2783),
    [anon_sym_DOT_LBRACK] = ACTIONS(2785),
    [anon_sym_LT] = ACTIONS(2785),
    [anon_sym_use] = ACTIONS(2783),
    [anon_sym_use_BANG] = ACTIONS(2785),
    [anon_sym_do_BANG] = ACTIONS(2785),
    [anon_sym_DOT_DOT] = ACTIONS(2789),
    [anon_sym_begin] = ACTIONS(2783),
    [anon_sym_LPAREN2] = ACTIONS(2783),
    [anon_sym_or] = ACTIONS(2783),
    [aux_sym_char_token1] = ACTIONS(2785),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2783),
    [anon_sym_DQUOTE] = ACTIONS(2783),
    [anon_sym_AT_DQUOTE] = ACTIONS(2785),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2785),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2785),
    [sym_bool] = ACTIONS(2783),
    [sym_unit] = ACTIONS(2785),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2783),
    [sym_op_identifier] = ACTIONS(2783),
    [anon_sym_PLUS] = ACTIONS(2783),
    [anon_sym_DASH] = ACTIONS(2783),
    [anon_sym_PLUS_DOT] = ACTIONS(2783),
    [anon_sym_DASH_DOT] = ACTIONS(2783),
    [anon_sym_PERCENT] = ACTIONS(2783),
    [anon_sym_AMP_AMP] = ACTIONS(2783),
    [anon_sym_TILDE] = ACTIONS(2785),
    [aux_sym_prefix_op_token1] = ACTIONS(2783),
    [aux_sym_infix_op_token1] = ACTIONS(2785),
    [aux_sym_infix_op_token2] = ACTIONS(2783),
    [anon_sym_PIPE_PIPE] = ACTIONS(2783),
    [anon_sym_BANG_EQ] = ACTIONS(2783),
    [anon_sym_COLON_EQ] = ACTIONS(2785),
    [anon_sym_DOLLAR] = ACTIONS(2783),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2783),
    [sym_int] = ACTIONS(2783),
    [sym_xint] = ACTIONS(2785),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2785),
    [sym__newline] = ACTIONS(2785),
  },
  [1039] = {
    [sym_block_comment] = STATE(1039),
    [sym_compiler_directive_decl] = STATE(1039),
    [sym_fsi_directive_decl] = STATE(1039),
    [sym_preproc_line] = STATE(1039),
    [sym_identifier] = ACTIONS(2685),
    [anon_sym_EQ] = ACTIONS(2687),
    [anon_sym_GT_RBRACK] = ACTIONS(2687),
    [anon_sym_COLON] = ACTIONS(2685),
    [anon_sym_return] = ACTIONS(2685),
    [anon_sym_do] = ACTIONS(2685),
    [anon_sym_let] = ACTIONS(2685),
    [anon_sym_let_BANG] = ACTIONS(2687),
    [anon_sym_LPAREN] = ACTIONS(2685),
    [anon_sym_COMMA] = ACTIONS(2687),
    [anon_sym_null] = ACTIONS(2685),
    [anon_sym_QMARK] = ACTIONS(2685),
    [anon_sym_COLON_QMARK] = ACTIONS(2685),
    [anon_sym_COLON_COLON] = ACTIONS(2687),
    [anon_sym_PIPE] = ACTIONS(2685),
    [anon_sym_AMP] = ACTIONS(2685),
    [anon_sym_LBRACK] = ACTIONS(2685),
    [anon_sym_RBRACK] = ACTIONS(2687),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2687),
    [anon_sym_LBRACE] = ACTIONS(2685),
    [anon_sym_RBRACE] = ACTIONS(2687),
    [anon_sym_LT_AT] = ACTIONS(2685),
    [anon_sym_LT_AT_AT] = ACTIONS(2685),
    [anon_sym_DOT] = ACTIONS(2685),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2687),
    [anon_sym_new] = ACTIONS(2685),
    [anon_sym_with] = ACTIONS(2685),
    [anon_sym_return_BANG] = ACTIONS(2687),
    [anon_sym_yield] = ACTIONS(2685),
    [anon_sym_yield_BANG] = ACTIONS(2687),
    [anon_sym_lazy] = ACTIONS(2685),
    [anon_sym_assert] = ACTIONS(2685),
    [anon_sym_upcast] = ACTIONS(2685),
    [anon_sym_downcast] = ACTIONS(2685),
    [anon_sym_COLON_GT] = ACTIONS(2687),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2687),
    [anon_sym_for] = ACTIONS(2685),
    [anon_sym_to] = ACTIONS(2685),
    [anon_sym_downto] = ACTIONS(2685),
    [anon_sym_while] = ACTIONS(2685),
    [anon_sym_if] = ACTIONS(2685),
    [anon_sym_fun] = ACTIONS(2685),
    [anon_sym_try] = ACTIONS(2685),
    [anon_sym_match] = ACTIONS(2685),
    [anon_sym_match_BANG] = ACTIONS(2687),
    [anon_sym_function] = ACTIONS(2685),
    [anon_sym_LT_DASH] = ACTIONS(2685),
    [anon_sym_DOT_LBRACK] = ACTIONS(2687),
    [anon_sym_LT] = ACTIONS(2687),
    [anon_sym_use] = ACTIONS(2685),
    [anon_sym_use_BANG] = ACTIONS(2687),
    [anon_sym_do_BANG] = ACTIONS(2687),
    [anon_sym_begin] = ACTIONS(2685),
    [anon_sym_LPAREN2] = ACTIONS(2685),
    [anon_sym_DOT_DOT2] = ACTIONS(2687),
    [anon_sym_or] = ACTIONS(2685),
    [aux_sym_char_token1] = ACTIONS(2687),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2685),
    [anon_sym_DQUOTE] = ACTIONS(2685),
    [anon_sym_AT_DQUOTE] = ACTIONS(2687),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2687),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2687),
    [sym_bool] = ACTIONS(2685),
    [sym_unit] = ACTIONS(2687),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2685),
    [sym_op_identifier] = ACTIONS(2685),
    [anon_sym_PLUS] = ACTIONS(2685),
    [anon_sym_DASH] = ACTIONS(2685),
    [anon_sym_PLUS_DOT] = ACTIONS(2685),
    [anon_sym_DASH_DOT] = ACTIONS(2685),
    [anon_sym_PERCENT] = ACTIONS(2685),
    [anon_sym_AMP_AMP] = ACTIONS(2685),
    [anon_sym_TILDE] = ACTIONS(2687),
    [aux_sym_prefix_op_token1] = ACTIONS(2685),
    [aux_sym_infix_op_token1] = ACTIONS(2687),
    [aux_sym_infix_op_token2] = ACTIONS(2685),
    [anon_sym_PIPE_PIPE] = ACTIONS(2685),
    [anon_sym_BANG_EQ] = ACTIONS(2685),
    [anon_sym_COLON_EQ] = ACTIONS(2687),
    [anon_sym_DOLLAR] = ACTIONS(2685),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2685),
    [sym_int] = ACTIONS(2685),
    [sym_xint] = ACTIONS(2687),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2687),
    [sym__newline] = ACTIONS(2687),
  },
  [1040] = {
    [sym_type_arguments] = STATE(1312),
    [sym_long_identifier] = STATE(1292),
    [sym_block_comment] = STATE(1040),
    [sym_compiler_directive_decl] = STATE(1040),
    [sym_fsi_directive_decl] = STATE(1040),
    [sym_preproc_line] = STATE(1040),
    [aux_sym_compound_type_repeat1] = STATE(1249),
    [sym_identifier] = ACTIONS(2252),
    [anon_sym_EQ] = ACTIONS(2254),
    [anon_sym_COLON] = ACTIONS(2252),
    [anon_sym_return] = ACTIONS(2252),
    [anon_sym_do] = ACTIONS(2252),
    [anon_sym_let] = ACTIONS(2252),
    [anon_sym_let_BANG] = ACTIONS(2254),
    [anon_sym_LPAREN] = ACTIONS(2252),
    [anon_sym_COMMA] = ACTIONS(2254),
    [anon_sym_null] = ACTIONS(2252),
    [anon_sym_QMARK] = ACTIONS(2252),
    [anon_sym_COLON_QMARK] = ACTIONS(2252),
    [anon_sym_COLON_COLON] = ACTIONS(2254),
    [anon_sym_AMP] = ACTIONS(2252),
    [anon_sym_LBRACK] = ACTIONS(2252),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2254),
    [anon_sym_LBRACE] = ACTIONS(2252),
    [anon_sym_LT_AT] = ACTIONS(2252),
    [anon_sym_LT_AT_AT] = ACTIONS(2252),
    [anon_sym_DOT] = ACTIONS(2252),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2254),
    [anon_sym_new] = ACTIONS(2252),
    [anon_sym_return_BANG] = ACTIONS(2254),
    [anon_sym_yield] = ACTIONS(2252),
    [anon_sym_yield_BANG] = ACTIONS(2254),
    [anon_sym_lazy] = ACTIONS(2252),
    [anon_sym_assert] = ACTIONS(2252),
    [anon_sym_upcast] = ACTIONS(2252),
    [anon_sym_downcast] = ACTIONS(2252),
    [anon_sym_COLON_GT] = ACTIONS(2254),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2254),
    [anon_sym_for] = ACTIONS(2252),
    [anon_sym_while] = ACTIONS(2252),
    [anon_sym_if] = ACTIONS(2252),
    [anon_sym_fun] = ACTIONS(2252),
    [anon_sym_DASH_GT] = ACTIONS(3216),
    [anon_sym_try] = ACTIONS(2252),
    [anon_sym_match] = ACTIONS(2252),
    [anon_sym_match_BANG] = ACTIONS(2254),
    [anon_sym_function] = ACTIONS(2252),
    [anon_sym_LT_DASH] = ACTIONS(2252),
    [anon_sym_DOT_LBRACK] = ACTIONS(2254),
    [anon_sym_LT] = ACTIONS(2254),
    [anon_sym_GT] = ACTIONS(2252),
    [anon_sym_use] = ACTIONS(2252),
    [anon_sym_use_BANG] = ACTIONS(2254),
    [anon_sym_do_BANG] = ACTIONS(2254),
    [anon_sym_begin] = ACTIONS(2252),
    [anon_sym_LPAREN2] = ACTIONS(2252),
    [anon_sym_STAR] = ACTIONS(3218),
    [anon_sym_LT2] = ACTIONS(3220),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3222),
    [anon_sym_or] = ACTIONS(2252),
    [aux_sym_char_token1] = ACTIONS(2254),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2252),
    [anon_sym_DQUOTE] = ACTIONS(2252),
    [anon_sym_AT_DQUOTE] = ACTIONS(2254),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2254),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2254),
    [sym_bool] = ACTIONS(2252),
    [sym_unit] = ACTIONS(2254),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2252),
    [sym_op_identifier] = ACTIONS(2252),
    [anon_sym_PLUS] = ACTIONS(2252),
    [anon_sym_DASH] = ACTIONS(2252),
    [anon_sym_PLUS_DOT] = ACTIONS(2252),
    [anon_sym_DASH_DOT] = ACTIONS(2252),
    [anon_sym_PERCENT] = ACTIONS(2252),
    [anon_sym_AMP_AMP] = ACTIONS(2252),
    [anon_sym_TILDE] = ACTIONS(2254),
    [aux_sym_prefix_op_token1] = ACTIONS(2252),
    [aux_sym_infix_op_token1] = ACTIONS(2254),
    [aux_sym_infix_op_token2] = ACTIONS(2252),
    [anon_sym_PIPE_PIPE] = ACTIONS(2252),
    [anon_sym_BANG_EQ] = ACTIONS(2252),
    [anon_sym_COLON_EQ] = ACTIONS(2254),
    [anon_sym_DOLLAR] = ACTIONS(2252),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2252),
    [sym_int] = ACTIONS(2252),
    [sym_xint] = ACTIONS(2254),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2254),
    [sym__newline] = ACTIONS(2254),
  },
  [1041] = {
    [sym_block_comment] = STATE(1041),
    [sym_compiler_directive_decl] = STATE(1041),
    [sym_fsi_directive_decl] = STATE(1041),
    [sym_preproc_line] = STATE(1041),
    [sym_identifier] = ACTIONS(2783),
    [anon_sym_EQ] = ACTIONS(2785),
    [anon_sym_GT_RBRACK] = ACTIONS(2785),
    [anon_sym_COLON] = ACTIONS(2783),
    [anon_sym_return] = ACTIONS(2783),
    [anon_sym_do] = ACTIONS(2783),
    [anon_sym_let] = ACTIONS(2783),
    [anon_sym_let_BANG] = ACTIONS(2785),
    [anon_sym_LPAREN] = ACTIONS(2783),
    [anon_sym_COMMA] = ACTIONS(2785),
    [anon_sym_null] = ACTIONS(2783),
    [anon_sym_QMARK] = ACTIONS(2783),
    [anon_sym_COLON_QMARK] = ACTIONS(2783),
    [anon_sym_COLON_COLON] = ACTIONS(2785),
    [anon_sym_AMP] = ACTIONS(2783),
    [anon_sym_LBRACK] = ACTIONS(2783),
    [anon_sym_RBRACK] = ACTIONS(2785),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2785),
    [anon_sym_LBRACE] = ACTIONS(2783),
    [anon_sym_RBRACE] = ACTIONS(2785),
    [anon_sym_LT_AT] = ACTIONS(2783),
    [anon_sym_LT_AT_AT] = ACTIONS(2783),
    [anon_sym_DOT] = ACTIONS(2783),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2785),
    [anon_sym_new] = ACTIONS(2783),
    [anon_sym_with] = ACTIONS(2783),
    [anon_sym_return_BANG] = ACTIONS(2785),
    [anon_sym_yield] = ACTIONS(2783),
    [anon_sym_yield_BANG] = ACTIONS(2785),
    [anon_sym_lazy] = ACTIONS(2783),
    [anon_sym_assert] = ACTIONS(2783),
    [anon_sym_upcast] = ACTIONS(2783),
    [anon_sym_downcast] = ACTIONS(2783),
    [anon_sym_COLON_GT] = ACTIONS(2785),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2785),
    [anon_sym_for] = ACTIONS(2783),
    [anon_sym_to] = ACTIONS(2783),
    [anon_sym_downto] = ACTIONS(2783),
    [anon_sym_done] = ACTIONS(3285),
    [anon_sym_while] = ACTIONS(2783),
    [anon_sym_if] = ACTIONS(2783),
    [anon_sym_fun] = ACTIONS(2783),
    [anon_sym_try] = ACTIONS(2783),
    [anon_sym_match] = ACTIONS(2783),
    [anon_sym_match_BANG] = ACTIONS(2785),
    [anon_sym_function] = ACTIONS(2783),
    [anon_sym_LT_DASH] = ACTIONS(2783),
    [anon_sym_DOT_LBRACK] = ACTIONS(2785),
    [anon_sym_LT] = ACTIONS(2785),
    [anon_sym_use] = ACTIONS(2783),
    [anon_sym_use_BANG] = ACTIONS(2785),
    [anon_sym_do_BANG] = ACTIONS(2785),
    [anon_sym_begin] = ACTIONS(2783),
    [anon_sym_LPAREN2] = ACTIONS(2783),
    [anon_sym_DOT_DOT2] = ACTIONS(2785),
    [anon_sym_or] = ACTIONS(2783),
    [aux_sym_char_token1] = ACTIONS(2785),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2783),
    [anon_sym_DQUOTE] = ACTIONS(2783),
    [anon_sym_AT_DQUOTE] = ACTIONS(2785),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2785),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2785),
    [sym_bool] = ACTIONS(2783),
    [sym_unit] = ACTIONS(2785),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2783),
    [sym_op_identifier] = ACTIONS(2783),
    [anon_sym_PLUS] = ACTIONS(2783),
    [anon_sym_DASH] = ACTIONS(2783),
    [anon_sym_PLUS_DOT] = ACTIONS(2783),
    [anon_sym_DASH_DOT] = ACTIONS(2783),
    [anon_sym_PERCENT] = ACTIONS(2783),
    [anon_sym_AMP_AMP] = ACTIONS(2783),
    [anon_sym_TILDE] = ACTIONS(2785),
    [aux_sym_prefix_op_token1] = ACTIONS(2783),
    [aux_sym_infix_op_token1] = ACTIONS(2785),
    [aux_sym_infix_op_token2] = ACTIONS(2783),
    [anon_sym_PIPE_PIPE] = ACTIONS(2783),
    [anon_sym_BANG_EQ] = ACTIONS(2783),
    [anon_sym_COLON_EQ] = ACTIONS(2785),
    [anon_sym_DOLLAR] = ACTIONS(2783),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2783),
    [sym_int] = ACTIONS(2783),
    [sym_xint] = ACTIONS(2785),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2785),
    [sym__newline] = ACTIONS(2785),
  },
  [1042] = {
    [sym_block_comment] = STATE(1042),
    [sym_compiler_directive_decl] = STATE(1042),
    [sym_fsi_directive_decl] = STATE(1042),
    [sym_preproc_line] = STATE(1042),
    [sym_identifier] = ACTIONS(3031),
    [anon_sym_EQ] = ACTIONS(3033),
    [anon_sym_GT_RBRACK] = ACTIONS(3033),
    [anon_sym_COLON] = ACTIONS(3031),
    [anon_sym_return] = ACTIONS(3031),
    [anon_sym_do] = ACTIONS(3031),
    [anon_sym_let] = ACTIONS(3031),
    [anon_sym_let_BANG] = ACTIONS(3033),
    [anon_sym_LPAREN] = ACTIONS(3031),
    [anon_sym_COMMA] = ACTIONS(3033),
    [anon_sym_null] = ACTIONS(3031),
    [anon_sym_QMARK] = ACTIONS(3031),
    [anon_sym_COLON_QMARK] = ACTIONS(3031),
    [anon_sym_COLON_COLON] = ACTIONS(3033),
    [anon_sym_AMP] = ACTIONS(3031),
    [anon_sym_LBRACK] = ACTIONS(3031),
    [anon_sym_RBRACK] = ACTIONS(3033),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3033),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [anon_sym_RBRACE] = ACTIONS(3033),
    [anon_sym_LT_AT] = ACTIONS(3031),
    [anon_sym_LT_AT_AT] = ACTIONS(3031),
    [anon_sym_DOT] = ACTIONS(3031),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3033),
    [anon_sym_new] = ACTIONS(3031),
    [anon_sym_with] = ACTIONS(3031),
    [anon_sym_return_BANG] = ACTIONS(3033),
    [anon_sym_yield] = ACTIONS(3031),
    [anon_sym_yield_BANG] = ACTIONS(3033),
    [anon_sym_lazy] = ACTIONS(3031),
    [anon_sym_assert] = ACTIONS(3031),
    [anon_sym_upcast] = ACTIONS(3031),
    [anon_sym_downcast] = ACTIONS(3031),
    [anon_sym_COLON_GT] = ACTIONS(3033),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3033),
    [anon_sym_for] = ACTIONS(3031),
    [anon_sym_to] = ACTIONS(3031),
    [anon_sym_downto] = ACTIONS(3031),
    [anon_sym_while] = ACTIONS(3031),
    [anon_sym_if] = ACTIONS(3031),
    [anon_sym_fun] = ACTIONS(3031),
    [anon_sym_try] = ACTIONS(3031),
    [anon_sym_match] = ACTIONS(3031),
    [anon_sym_match_BANG] = ACTIONS(3033),
    [anon_sym_function] = ACTIONS(3031),
    [anon_sym_LT_DASH] = ACTIONS(3031),
    [anon_sym_DOT_LBRACK] = ACTIONS(3033),
    [anon_sym_LT] = ACTIONS(3033),
    [anon_sym_use] = ACTIONS(3031),
    [anon_sym_use_BANG] = ACTIONS(3033),
    [anon_sym_do_BANG] = ACTIONS(3033),
    [anon_sym_begin] = ACTIONS(3031),
    [anon_sym_LPAREN2] = ACTIONS(3031),
    [anon_sym_DOT_DOT2] = ACTIONS(3033),
    [anon_sym_or] = ACTIONS(3031),
    [aux_sym_char_token1] = ACTIONS(3033),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3031),
    [anon_sym_DQUOTE] = ACTIONS(3031),
    [anon_sym_AT_DQUOTE] = ACTIONS(3033),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3033),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3033),
    [sym_bool] = ACTIONS(3031),
    [sym_unit] = ACTIONS(3033),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3031),
    [sym_op_identifier] = ACTIONS(3031),
    [anon_sym_PLUS] = ACTIONS(3031),
    [anon_sym_DASH] = ACTIONS(3031),
    [anon_sym_PLUS_DOT] = ACTIONS(3031),
    [anon_sym_DASH_DOT] = ACTIONS(3031),
    [anon_sym_PERCENT] = ACTIONS(3031),
    [anon_sym_AMP_AMP] = ACTIONS(3031),
    [anon_sym_TILDE] = ACTIONS(3033),
    [aux_sym_prefix_op_token1] = ACTIONS(3031),
    [aux_sym_infix_op_token1] = ACTIONS(3033),
    [aux_sym_infix_op_token2] = ACTIONS(3031),
    [anon_sym_PIPE_PIPE] = ACTIONS(3031),
    [anon_sym_BANG_EQ] = ACTIONS(3031),
    [anon_sym_COLON_EQ] = ACTIONS(3033),
    [anon_sym_DOLLAR] = ACTIONS(3031),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3031),
    [sym_int] = ACTIONS(3031),
    [sym_xint] = ACTIONS(3033),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3033),
    [sym__newline] = ACTIONS(3033),
  },
  [1043] = {
    [sym_block_comment] = STATE(1043),
    [sym_compiler_directive_decl] = STATE(1043),
    [sym_fsi_directive_decl] = STATE(1043),
    [sym_preproc_line] = STATE(1043),
    [sym_identifier] = ACTIONS(2926),
    [anon_sym_EQ] = ACTIONS(2928),
    [anon_sym_GT_RBRACK] = ACTIONS(2928),
    [anon_sym_COLON] = ACTIONS(2926),
    [anon_sym_return] = ACTIONS(2926),
    [anon_sym_do] = ACTIONS(2926),
    [anon_sym_let] = ACTIONS(2926),
    [anon_sym_let_BANG] = ACTIONS(2928),
    [anon_sym_LPAREN] = ACTIONS(2926),
    [anon_sym_COMMA] = ACTIONS(2928),
    [anon_sym_null] = ACTIONS(2926),
    [anon_sym_QMARK] = ACTIONS(2926),
    [anon_sym_COLON_QMARK] = ACTIONS(2926),
    [anon_sym_COLON_COLON] = ACTIONS(2928),
    [anon_sym_AMP] = ACTIONS(2926),
    [anon_sym_LBRACK] = ACTIONS(2926),
    [anon_sym_RBRACK] = ACTIONS(2928),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2928),
    [anon_sym_LBRACE] = ACTIONS(2926),
    [anon_sym_RBRACE] = ACTIONS(2928),
    [anon_sym_LT_AT] = ACTIONS(2926),
    [anon_sym_LT_AT_AT] = ACTIONS(2926),
    [anon_sym_DOT] = ACTIONS(2926),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2928),
    [anon_sym_new] = ACTIONS(2926),
    [anon_sym_with] = ACTIONS(2926),
    [anon_sym_return_BANG] = ACTIONS(2928),
    [anon_sym_yield] = ACTIONS(2926),
    [anon_sym_yield_BANG] = ACTIONS(2928),
    [anon_sym_lazy] = ACTIONS(2926),
    [anon_sym_assert] = ACTIONS(2926),
    [anon_sym_upcast] = ACTIONS(2926),
    [anon_sym_downcast] = ACTIONS(2926),
    [anon_sym_COLON_GT] = ACTIONS(2928),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2928),
    [anon_sym_for] = ACTIONS(2926),
    [anon_sym_to] = ACTIONS(2926),
    [anon_sym_downto] = ACTIONS(2926),
    [anon_sym_while] = ACTIONS(2926),
    [anon_sym_if] = ACTIONS(2926),
    [anon_sym_fun] = ACTIONS(2926),
    [anon_sym_try] = ACTIONS(2926),
    [anon_sym_match] = ACTIONS(2926),
    [anon_sym_match_BANG] = ACTIONS(2928),
    [anon_sym_function] = ACTIONS(2926),
    [anon_sym_LT_DASH] = ACTIONS(2926),
    [anon_sym_DOT_LBRACK] = ACTIONS(2928),
    [anon_sym_LT] = ACTIONS(2928),
    [anon_sym_use] = ACTIONS(2926),
    [anon_sym_use_BANG] = ACTIONS(2928),
    [anon_sym_do_BANG] = ACTIONS(2928),
    [anon_sym_begin] = ACTIONS(2926),
    [anon_sym_LPAREN2] = ACTIONS(2926),
    [anon_sym_DOT_DOT2] = ACTIONS(2928),
    [anon_sym_or] = ACTIONS(2926),
    [aux_sym_char_token1] = ACTIONS(2928),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2926),
    [anon_sym_DQUOTE] = ACTIONS(2926),
    [anon_sym_AT_DQUOTE] = ACTIONS(2928),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2928),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2928),
    [sym_bool] = ACTIONS(2926),
    [sym_unit] = ACTIONS(2928),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2926),
    [sym_op_identifier] = ACTIONS(2926),
    [anon_sym_PLUS] = ACTIONS(2926),
    [anon_sym_DASH] = ACTIONS(2926),
    [anon_sym_PLUS_DOT] = ACTIONS(2926),
    [anon_sym_DASH_DOT] = ACTIONS(2926),
    [anon_sym_PERCENT] = ACTIONS(2926),
    [anon_sym_AMP_AMP] = ACTIONS(2926),
    [anon_sym_TILDE] = ACTIONS(2928),
    [aux_sym_prefix_op_token1] = ACTIONS(2926),
    [aux_sym_infix_op_token1] = ACTIONS(2928),
    [aux_sym_infix_op_token2] = ACTIONS(2926),
    [anon_sym_PIPE_PIPE] = ACTIONS(2926),
    [anon_sym_BANG_EQ] = ACTIONS(2926),
    [anon_sym_COLON_EQ] = ACTIONS(2928),
    [anon_sym_DOLLAR] = ACTIONS(2926),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2926),
    [sym_int] = ACTIONS(2926),
    [sym_xint] = ACTIONS(2928),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2928),
    [sym__newline] = ACTIONS(2928),
  },
  [1044] = {
    [sym_block_comment] = STATE(1044),
    [sym_compiler_directive_decl] = STATE(1044),
    [sym_fsi_directive_decl] = STATE(1044),
    [sym_preproc_line] = STATE(1044),
    [aux_sym_long_identifier_repeat1] = STATE(1165),
    [sym_identifier] = ACTIONS(2312),
    [anon_sym_EQ] = ACTIONS(2314),
    [anon_sym_COLON] = ACTIONS(2312),
    [anon_sym_return] = ACTIONS(2312),
    [anon_sym_do] = ACTIONS(2312),
    [anon_sym_let] = ACTIONS(2312),
    [anon_sym_let_BANG] = ACTIONS(2314),
    [anon_sym_LPAREN] = ACTIONS(2312),
    [anon_sym_COMMA] = ACTIONS(2314),
    [anon_sym_null] = ACTIONS(2312),
    [anon_sym_QMARK] = ACTIONS(2312),
    [anon_sym_COLON_QMARK] = ACTIONS(2312),
    [anon_sym_COLON_COLON] = ACTIONS(2314),
    [anon_sym_AMP] = ACTIONS(2312),
    [anon_sym_LBRACK] = ACTIONS(2312),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2314),
    [anon_sym_LBRACE] = ACTIONS(2312),
    [anon_sym_LT_AT] = ACTIONS(2312),
    [anon_sym_LT_AT_AT] = ACTIONS(2312),
    [anon_sym_DOT] = ACTIONS(3287),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2314),
    [anon_sym_new] = ACTIONS(2312),
    [anon_sym_return_BANG] = ACTIONS(2314),
    [anon_sym_yield] = ACTIONS(2312),
    [anon_sym_yield_BANG] = ACTIONS(2314),
    [anon_sym_lazy] = ACTIONS(2312),
    [anon_sym_assert] = ACTIONS(2312),
    [anon_sym_upcast] = ACTIONS(2312),
    [anon_sym_downcast] = ACTIONS(2312),
    [anon_sym_COLON_GT] = ACTIONS(2314),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2314),
    [anon_sym_for] = ACTIONS(2312),
    [anon_sym_while] = ACTIONS(2312),
    [anon_sym_if] = ACTIONS(2312),
    [anon_sym_fun] = ACTIONS(2312),
    [anon_sym_DASH_GT] = ACTIONS(2312),
    [anon_sym_try] = ACTIONS(2312),
    [anon_sym_match] = ACTIONS(2312),
    [anon_sym_match_BANG] = ACTIONS(2314),
    [anon_sym_function] = ACTIONS(2312),
    [anon_sym_LT_DASH] = ACTIONS(2312),
    [anon_sym_DOT_LBRACK] = ACTIONS(2314),
    [anon_sym_LT] = ACTIONS(2314),
    [anon_sym_use] = ACTIONS(2312),
    [anon_sym_use_BANG] = ACTIONS(2314),
    [anon_sym_do_BANG] = ACTIONS(2314),
    [anon_sym_begin] = ACTIONS(2312),
    [anon_sym_LPAREN2] = ACTIONS(2312),
    [anon_sym_STAR] = ACTIONS(2312),
    [anon_sym_LT2] = ACTIONS(2312),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2314),
    [anon_sym_or] = ACTIONS(2312),
    [aux_sym_char_token1] = ACTIONS(2314),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2312),
    [anon_sym_DQUOTE] = ACTIONS(2312),
    [anon_sym_AT_DQUOTE] = ACTIONS(2314),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2314),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2314),
    [sym_bool] = ACTIONS(2312),
    [sym_unit] = ACTIONS(2314),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2312),
    [sym_op_identifier] = ACTIONS(2312),
    [anon_sym_PLUS] = ACTIONS(2312),
    [anon_sym_DASH] = ACTIONS(2312),
    [anon_sym_PLUS_DOT] = ACTIONS(2312),
    [anon_sym_DASH_DOT] = ACTIONS(2312),
    [anon_sym_PERCENT] = ACTIONS(2312),
    [anon_sym_AMP_AMP] = ACTIONS(2312),
    [anon_sym_TILDE] = ACTIONS(2314),
    [aux_sym_prefix_op_token1] = ACTIONS(2312),
    [aux_sym_infix_op_token1] = ACTIONS(2314),
    [aux_sym_infix_op_token2] = ACTIONS(2312),
    [anon_sym_PIPE_PIPE] = ACTIONS(2312),
    [anon_sym_BANG_EQ] = ACTIONS(2312),
    [anon_sym_COLON_EQ] = ACTIONS(2314),
    [anon_sym_DOLLAR] = ACTIONS(2312),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2312),
    [sym_int] = ACTIONS(2312),
    [sym_xint] = ACTIONS(2314),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2314),
    [anon_sym_POUNDendif] = ACTIONS(2314),
    [anon_sym_POUNDelse] = ACTIONS(2314),
    [sym__newline] = ACTIONS(2314),
  },
  [1045] = {
    [sym_block_comment] = STATE(1045),
    [sym_compiler_directive_decl] = STATE(1045),
    [sym_fsi_directive_decl] = STATE(1045),
    [sym_preproc_line] = STATE(1045),
    [sym_identifier] = ACTIONS(3131),
    [anon_sym_EQ] = ACTIONS(3133),
    [anon_sym_GT_RBRACK] = ACTIONS(3133),
    [anon_sym_COLON] = ACTIONS(3131),
    [anon_sym_return] = ACTIONS(3131),
    [anon_sym_do] = ACTIONS(3131),
    [anon_sym_let] = ACTIONS(3131),
    [anon_sym_let_BANG] = ACTIONS(3133),
    [anon_sym_LPAREN] = ACTIONS(3131),
    [anon_sym_COMMA] = ACTIONS(3133),
    [anon_sym_null] = ACTIONS(3131),
    [anon_sym_QMARK] = ACTIONS(3131),
    [anon_sym_COLON_QMARK] = ACTIONS(3131),
    [anon_sym_COLON_COLON] = ACTIONS(3133),
    [anon_sym_AMP] = ACTIONS(3131),
    [anon_sym_LBRACK] = ACTIONS(3131),
    [anon_sym_RBRACK] = ACTIONS(3133),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3133),
    [anon_sym_LBRACE] = ACTIONS(3131),
    [anon_sym_RBRACE] = ACTIONS(3133),
    [anon_sym_LT_AT] = ACTIONS(3131),
    [anon_sym_LT_AT_AT] = ACTIONS(3131),
    [anon_sym_DOT] = ACTIONS(3131),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3133),
    [anon_sym_new] = ACTIONS(3131),
    [anon_sym_with] = ACTIONS(3131),
    [anon_sym_return_BANG] = ACTIONS(3133),
    [anon_sym_yield] = ACTIONS(3131),
    [anon_sym_yield_BANG] = ACTIONS(3133),
    [anon_sym_lazy] = ACTIONS(3131),
    [anon_sym_assert] = ACTIONS(3131),
    [anon_sym_upcast] = ACTIONS(3131),
    [anon_sym_downcast] = ACTIONS(3131),
    [anon_sym_COLON_GT] = ACTIONS(3133),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3133),
    [anon_sym_for] = ACTIONS(3131),
    [anon_sym_to] = ACTIONS(3131),
    [anon_sym_downto] = ACTIONS(3131),
    [anon_sym_while] = ACTIONS(3131),
    [anon_sym_if] = ACTIONS(3131),
    [anon_sym_fun] = ACTIONS(3131),
    [anon_sym_try] = ACTIONS(3131),
    [anon_sym_match] = ACTIONS(3131),
    [anon_sym_match_BANG] = ACTIONS(3133),
    [anon_sym_function] = ACTIONS(3131),
    [anon_sym_LT_DASH] = ACTIONS(3131),
    [anon_sym_DOT_LBRACK] = ACTIONS(3133),
    [anon_sym_LT] = ACTIONS(3133),
    [anon_sym_use] = ACTIONS(3131),
    [anon_sym_use_BANG] = ACTIONS(3133),
    [anon_sym_do_BANG] = ACTIONS(3133),
    [anon_sym_begin] = ACTIONS(3131),
    [anon_sym_LPAREN2] = ACTIONS(3131),
    [anon_sym_DOT_DOT2] = ACTIONS(3133),
    [anon_sym_or] = ACTIONS(3131),
    [aux_sym_char_token1] = ACTIONS(3133),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3131),
    [anon_sym_DQUOTE] = ACTIONS(3131),
    [anon_sym_AT_DQUOTE] = ACTIONS(3133),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3133),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3133),
    [sym_bool] = ACTIONS(3131),
    [sym_unit] = ACTIONS(3133),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3131),
    [sym_op_identifier] = ACTIONS(3131),
    [anon_sym_PLUS] = ACTIONS(3131),
    [anon_sym_DASH] = ACTIONS(3131),
    [anon_sym_PLUS_DOT] = ACTIONS(3131),
    [anon_sym_DASH_DOT] = ACTIONS(3131),
    [anon_sym_PERCENT] = ACTIONS(3131),
    [anon_sym_AMP_AMP] = ACTIONS(3131),
    [anon_sym_TILDE] = ACTIONS(3133),
    [aux_sym_prefix_op_token1] = ACTIONS(3131),
    [aux_sym_infix_op_token1] = ACTIONS(3133),
    [aux_sym_infix_op_token2] = ACTIONS(3131),
    [anon_sym_PIPE_PIPE] = ACTIONS(3131),
    [anon_sym_BANG_EQ] = ACTIONS(3131),
    [anon_sym_COLON_EQ] = ACTIONS(3133),
    [anon_sym_DOLLAR] = ACTIONS(3131),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3131),
    [sym_int] = ACTIONS(3131),
    [sym_xint] = ACTIONS(3133),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3133),
    [sym__newline] = ACTIONS(3133),
  },
  [1046] = {
    [sym_block_comment] = STATE(1046),
    [sym_compiler_directive_decl] = STATE(1046),
    [sym_fsi_directive_decl] = STATE(1046),
    [sym_preproc_line] = STATE(1046),
    [aux_sym_type_argument_repeat1] = STATE(1047),
    [sym_identifier] = ACTIONS(2328),
    [anon_sym_EQ] = ACTIONS(2330),
    [anon_sym_COLON] = ACTIONS(2328),
    [anon_sym_return] = ACTIONS(2328),
    [anon_sym_do] = ACTIONS(2328),
    [anon_sym_let] = ACTIONS(2328),
    [anon_sym_let_BANG] = ACTIONS(2330),
    [anon_sym_LPAREN] = ACTIONS(2328),
    [anon_sym_COMMA] = ACTIONS(2330),
    [anon_sym_null] = ACTIONS(2328),
    [anon_sym_QMARK] = ACTIONS(2328),
    [anon_sym_COLON_QMARK] = ACTIONS(2328),
    [anon_sym_COLON_COLON] = ACTIONS(2330),
    [anon_sym_AMP] = ACTIONS(2328),
    [anon_sym_LBRACK] = ACTIONS(2328),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2330),
    [anon_sym_LBRACE] = ACTIONS(2328),
    [anon_sym_LT_AT] = ACTIONS(2328),
    [anon_sym_LT_AT_AT] = ACTIONS(2328),
    [anon_sym_DOT] = ACTIONS(2328),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2330),
    [anon_sym_new] = ACTIONS(2328),
    [anon_sym_return_BANG] = ACTIONS(2330),
    [anon_sym_yield] = ACTIONS(2328),
    [anon_sym_yield_BANG] = ACTIONS(2330),
    [anon_sym_lazy] = ACTIONS(2328),
    [anon_sym_assert] = ACTIONS(2328),
    [anon_sym_upcast] = ACTIONS(2328),
    [anon_sym_downcast] = ACTIONS(2328),
    [anon_sym_COLON_GT] = ACTIONS(2330),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2330),
    [anon_sym_for] = ACTIONS(2328),
    [anon_sym_while] = ACTIONS(2328),
    [anon_sym_if] = ACTIONS(2328),
    [anon_sym_fun] = ACTIONS(2328),
    [anon_sym_DASH_GT] = ACTIONS(2328),
    [anon_sym_try] = ACTIONS(2328),
    [anon_sym_match] = ACTIONS(2328),
    [anon_sym_match_BANG] = ACTIONS(2330),
    [anon_sym_function] = ACTIONS(2328),
    [anon_sym_LT_DASH] = ACTIONS(2328),
    [anon_sym_DOT_LBRACK] = ACTIONS(2330),
    [anon_sym_LT] = ACTIONS(2330),
    [anon_sym_use] = ACTIONS(2328),
    [anon_sym_use_BANG] = ACTIONS(2330),
    [anon_sym_do_BANG] = ACTIONS(2330),
    [anon_sym_begin] = ACTIONS(2328),
    [anon_sym_LPAREN2] = ACTIONS(2328),
    [anon_sym_STAR] = ACTIONS(2328),
    [anon_sym_LT2] = ACTIONS(2328),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2330),
    [anon_sym_or] = ACTIONS(2328),
    [aux_sym_char_token1] = ACTIONS(2330),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2328),
    [anon_sym_DQUOTE] = ACTIONS(2328),
    [anon_sym_AT_DQUOTE] = ACTIONS(2330),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2330),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2330),
    [sym_bool] = ACTIONS(2328),
    [sym_unit] = ACTIONS(2330),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2328),
    [sym_op_identifier] = ACTIONS(2328),
    [anon_sym_PLUS] = ACTIONS(2328),
    [anon_sym_DASH] = ACTIONS(2328),
    [anon_sym_PLUS_DOT] = ACTIONS(2328),
    [anon_sym_DASH_DOT] = ACTIONS(2328),
    [anon_sym_PERCENT] = ACTIONS(2328),
    [anon_sym_AMP_AMP] = ACTIONS(2328),
    [anon_sym_TILDE] = ACTIONS(2330),
    [aux_sym_prefix_op_token1] = ACTIONS(2328),
    [aux_sym_infix_op_token1] = ACTIONS(2330),
    [aux_sym_infix_op_token2] = ACTIONS(2328),
    [anon_sym_PIPE_PIPE] = ACTIONS(2328),
    [anon_sym_BANG_EQ] = ACTIONS(2328),
    [anon_sym_COLON_EQ] = ACTIONS(2330),
    [anon_sym_DOLLAR] = ACTIONS(2328),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2328),
    [sym_int] = ACTIONS(2328),
    [sym_xint] = ACTIONS(2330),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2330),
    [anon_sym_POUNDendif] = ACTIONS(2330),
    [anon_sym_POUNDelse] = ACTIONS(2330),
    [sym__newline] = ACTIONS(2330),
  },
  [1047] = {
    [sym_block_comment] = STATE(1047),
    [sym_compiler_directive_decl] = STATE(1047),
    [sym_fsi_directive_decl] = STATE(1047),
    [sym_preproc_line] = STATE(1047),
    [aux_sym_type_argument_repeat1] = STATE(1047),
    [sym_identifier] = ACTIONS(2340),
    [anon_sym_EQ] = ACTIONS(2342),
    [anon_sym_COLON] = ACTIONS(2340),
    [anon_sym_return] = ACTIONS(2340),
    [anon_sym_do] = ACTIONS(2340),
    [anon_sym_let] = ACTIONS(2340),
    [anon_sym_let_BANG] = ACTIONS(2342),
    [anon_sym_LPAREN] = ACTIONS(2340),
    [anon_sym_COMMA] = ACTIONS(2342),
    [anon_sym_null] = ACTIONS(2340),
    [anon_sym_QMARK] = ACTIONS(2340),
    [anon_sym_COLON_QMARK] = ACTIONS(2340),
    [anon_sym_COLON_COLON] = ACTIONS(2342),
    [anon_sym_AMP] = ACTIONS(2340),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2342),
    [anon_sym_LBRACE] = ACTIONS(2340),
    [anon_sym_LT_AT] = ACTIONS(2340),
    [anon_sym_LT_AT_AT] = ACTIONS(2340),
    [anon_sym_DOT] = ACTIONS(2340),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2342),
    [anon_sym_new] = ACTIONS(2340),
    [anon_sym_return_BANG] = ACTIONS(2342),
    [anon_sym_yield] = ACTIONS(2340),
    [anon_sym_yield_BANG] = ACTIONS(2342),
    [anon_sym_lazy] = ACTIONS(2340),
    [anon_sym_assert] = ACTIONS(2340),
    [anon_sym_upcast] = ACTIONS(2340),
    [anon_sym_downcast] = ACTIONS(2340),
    [anon_sym_COLON_GT] = ACTIONS(2342),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2342),
    [anon_sym_for] = ACTIONS(2340),
    [anon_sym_while] = ACTIONS(2340),
    [anon_sym_if] = ACTIONS(2340),
    [anon_sym_fun] = ACTIONS(2340),
    [anon_sym_DASH_GT] = ACTIONS(2340),
    [anon_sym_try] = ACTIONS(2340),
    [anon_sym_match] = ACTIONS(2340),
    [anon_sym_match_BANG] = ACTIONS(2342),
    [anon_sym_function] = ACTIONS(2340),
    [anon_sym_LT_DASH] = ACTIONS(2340),
    [anon_sym_DOT_LBRACK] = ACTIONS(2342),
    [anon_sym_LT] = ACTIONS(2342),
    [anon_sym_use] = ACTIONS(2340),
    [anon_sym_use_BANG] = ACTIONS(2342),
    [anon_sym_do_BANG] = ACTIONS(2342),
    [anon_sym_begin] = ACTIONS(2340),
    [anon_sym_LPAREN2] = ACTIONS(2340),
    [anon_sym_STAR] = ACTIONS(2340),
    [anon_sym_LT2] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2342),
    [anon_sym_or] = ACTIONS(3289),
    [aux_sym_char_token1] = ACTIONS(2342),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2340),
    [anon_sym_DQUOTE] = ACTIONS(2340),
    [anon_sym_AT_DQUOTE] = ACTIONS(2342),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2342),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2342),
    [sym_bool] = ACTIONS(2340),
    [sym_unit] = ACTIONS(2342),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2340),
    [sym_op_identifier] = ACTIONS(2340),
    [anon_sym_PLUS] = ACTIONS(2340),
    [anon_sym_DASH] = ACTIONS(2340),
    [anon_sym_PLUS_DOT] = ACTIONS(2340),
    [anon_sym_DASH_DOT] = ACTIONS(2340),
    [anon_sym_PERCENT] = ACTIONS(2340),
    [anon_sym_AMP_AMP] = ACTIONS(2340),
    [anon_sym_TILDE] = ACTIONS(2342),
    [aux_sym_prefix_op_token1] = ACTIONS(2340),
    [aux_sym_infix_op_token1] = ACTIONS(2342),
    [aux_sym_infix_op_token2] = ACTIONS(2340),
    [anon_sym_PIPE_PIPE] = ACTIONS(2340),
    [anon_sym_BANG_EQ] = ACTIONS(2340),
    [anon_sym_COLON_EQ] = ACTIONS(2342),
    [anon_sym_DOLLAR] = ACTIONS(2340),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2340),
    [sym_int] = ACTIONS(2340),
    [sym_xint] = ACTIONS(2342),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2342),
    [anon_sym_POUNDendif] = ACTIONS(2342),
    [anon_sym_POUNDelse] = ACTIONS(2342),
    [sym__newline] = ACTIONS(2342),
  },
  [1048] = {
    [sym_block_comment] = STATE(1048),
    [sym_compiler_directive_decl] = STATE(1048),
    [sym_fsi_directive_decl] = STATE(1048),
    [sym_preproc_line] = STATE(1048),
    [sym_identifier] = ACTIONS(2831),
    [anon_sym_EQ] = ACTIONS(2833),
    [anon_sym_GT_RBRACK] = ACTIONS(2833),
    [anon_sym_COLON] = ACTIONS(2831),
    [anon_sym_return] = ACTIONS(2831),
    [anon_sym_do] = ACTIONS(2831),
    [anon_sym_let] = ACTIONS(2831),
    [anon_sym_let_BANG] = ACTIONS(2833),
    [anon_sym_LPAREN] = ACTIONS(2831),
    [anon_sym_COMMA] = ACTIONS(2833),
    [anon_sym_null] = ACTIONS(2831),
    [anon_sym_QMARK] = ACTIONS(2831),
    [anon_sym_COLON_QMARK] = ACTIONS(2831),
    [anon_sym_COLON_COLON] = ACTIONS(2833),
    [anon_sym_AMP] = ACTIONS(2831),
    [anon_sym_LBRACK] = ACTIONS(2831),
    [anon_sym_RBRACK] = ACTIONS(2833),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2833),
    [anon_sym_LBRACE] = ACTIONS(2831),
    [anon_sym_RBRACE] = ACTIONS(2833),
    [anon_sym_LT_AT] = ACTIONS(2831),
    [anon_sym_LT_AT_AT] = ACTIONS(2831),
    [anon_sym_DOT] = ACTIONS(2831),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2833),
    [anon_sym_new] = ACTIONS(2831),
    [anon_sym_with] = ACTIONS(2831),
    [anon_sym_return_BANG] = ACTIONS(2833),
    [anon_sym_yield] = ACTIONS(2831),
    [anon_sym_yield_BANG] = ACTIONS(2833),
    [anon_sym_lazy] = ACTIONS(2831),
    [anon_sym_assert] = ACTIONS(2831),
    [anon_sym_upcast] = ACTIONS(2831),
    [anon_sym_downcast] = ACTIONS(2831),
    [anon_sym_COLON_GT] = ACTIONS(2833),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2833),
    [anon_sym_for] = ACTIONS(2831),
    [anon_sym_to] = ACTIONS(2831),
    [anon_sym_downto] = ACTIONS(2831),
    [anon_sym_while] = ACTIONS(2831),
    [anon_sym_if] = ACTIONS(2831),
    [anon_sym_fun] = ACTIONS(2831),
    [anon_sym_try] = ACTIONS(2831),
    [anon_sym_match] = ACTIONS(2831),
    [anon_sym_match_BANG] = ACTIONS(2833),
    [anon_sym_function] = ACTIONS(2831),
    [anon_sym_LT_DASH] = ACTIONS(2831),
    [anon_sym_DOT_LBRACK] = ACTIONS(2833),
    [anon_sym_LT] = ACTIONS(2833),
    [anon_sym_use] = ACTIONS(2831),
    [anon_sym_use_BANG] = ACTIONS(2833),
    [anon_sym_do_BANG] = ACTIONS(2833),
    [anon_sym_begin] = ACTIONS(2831),
    [anon_sym_LPAREN2] = ACTIONS(2831),
    [anon_sym_DOT_DOT2] = ACTIONS(2833),
    [anon_sym_or] = ACTIONS(2831),
    [aux_sym_char_token1] = ACTIONS(2833),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2831),
    [anon_sym_DQUOTE] = ACTIONS(2831),
    [anon_sym_AT_DQUOTE] = ACTIONS(2833),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2833),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2833),
    [sym_bool] = ACTIONS(2831),
    [sym_unit] = ACTIONS(2833),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2831),
    [sym_op_identifier] = ACTIONS(2831),
    [anon_sym_PLUS] = ACTIONS(2831),
    [anon_sym_DASH] = ACTIONS(2831),
    [anon_sym_PLUS_DOT] = ACTIONS(2831),
    [anon_sym_DASH_DOT] = ACTIONS(2831),
    [anon_sym_PERCENT] = ACTIONS(2831),
    [anon_sym_AMP_AMP] = ACTIONS(2831),
    [anon_sym_TILDE] = ACTIONS(2833),
    [aux_sym_prefix_op_token1] = ACTIONS(2831),
    [aux_sym_infix_op_token1] = ACTIONS(2833),
    [aux_sym_infix_op_token2] = ACTIONS(2831),
    [anon_sym_PIPE_PIPE] = ACTIONS(2831),
    [anon_sym_BANG_EQ] = ACTIONS(2831),
    [anon_sym_COLON_EQ] = ACTIONS(2833),
    [anon_sym_DOLLAR] = ACTIONS(2831),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2831),
    [sym_int] = ACTIONS(2831),
    [sym_xint] = ACTIONS(2833),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2833),
    [sym__newline] = ACTIONS(2833),
  },
  [1049] = {
    [sym_block_comment] = STATE(1049),
    [sym_compiler_directive_decl] = STATE(1049),
    [sym_fsi_directive_decl] = STATE(1049),
    [sym_preproc_line] = STATE(1049),
    [sym_identifier] = ACTIONS(3067),
    [anon_sym_EQ] = ACTIONS(3069),
    [anon_sym_GT_RBRACK] = ACTIONS(3069),
    [anon_sym_COLON] = ACTIONS(3067),
    [anon_sym_return] = ACTIONS(3067),
    [anon_sym_do] = ACTIONS(3067),
    [anon_sym_let] = ACTIONS(3067),
    [anon_sym_let_BANG] = ACTIONS(3069),
    [anon_sym_LPAREN] = ACTIONS(3067),
    [anon_sym_COMMA] = ACTIONS(3069),
    [anon_sym_null] = ACTIONS(3067),
    [anon_sym_QMARK] = ACTIONS(3067),
    [anon_sym_COLON_QMARK] = ACTIONS(3067),
    [anon_sym_COLON_COLON] = ACTIONS(3069),
    [anon_sym_AMP] = ACTIONS(3067),
    [anon_sym_LBRACK] = ACTIONS(3067),
    [anon_sym_RBRACK] = ACTIONS(3069),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3069),
    [anon_sym_LBRACE] = ACTIONS(3067),
    [anon_sym_RBRACE] = ACTIONS(3069),
    [anon_sym_LT_AT] = ACTIONS(3067),
    [anon_sym_LT_AT_AT] = ACTIONS(3067),
    [anon_sym_DOT] = ACTIONS(3067),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3069),
    [anon_sym_new] = ACTIONS(3067),
    [anon_sym_with] = ACTIONS(3067),
    [anon_sym_return_BANG] = ACTIONS(3069),
    [anon_sym_yield] = ACTIONS(3067),
    [anon_sym_yield_BANG] = ACTIONS(3069),
    [anon_sym_lazy] = ACTIONS(3067),
    [anon_sym_assert] = ACTIONS(3067),
    [anon_sym_upcast] = ACTIONS(3067),
    [anon_sym_downcast] = ACTIONS(3067),
    [anon_sym_COLON_GT] = ACTIONS(3069),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3069),
    [anon_sym_for] = ACTIONS(3067),
    [anon_sym_to] = ACTIONS(3067),
    [anon_sym_downto] = ACTIONS(3067),
    [anon_sym_while] = ACTIONS(3067),
    [anon_sym_if] = ACTIONS(3067),
    [anon_sym_fun] = ACTIONS(3067),
    [anon_sym_try] = ACTIONS(3067),
    [anon_sym_match] = ACTIONS(3067),
    [anon_sym_match_BANG] = ACTIONS(3069),
    [anon_sym_function] = ACTIONS(3067),
    [anon_sym_LT_DASH] = ACTIONS(3067),
    [anon_sym_DOT_LBRACK] = ACTIONS(3069),
    [anon_sym_LT] = ACTIONS(3069),
    [anon_sym_use] = ACTIONS(3067),
    [anon_sym_use_BANG] = ACTIONS(3069),
    [anon_sym_do_BANG] = ACTIONS(3069),
    [anon_sym_begin] = ACTIONS(3067),
    [anon_sym_LPAREN2] = ACTIONS(3067),
    [anon_sym_DOT_DOT2] = ACTIONS(3069),
    [anon_sym_or] = ACTIONS(3067),
    [aux_sym_char_token1] = ACTIONS(3069),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3067),
    [anon_sym_DQUOTE] = ACTIONS(3067),
    [anon_sym_AT_DQUOTE] = ACTIONS(3069),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3069),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3069),
    [sym_bool] = ACTIONS(3067),
    [sym_unit] = ACTIONS(3069),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3067),
    [sym_op_identifier] = ACTIONS(3067),
    [anon_sym_PLUS] = ACTIONS(3067),
    [anon_sym_DASH] = ACTIONS(3067),
    [anon_sym_PLUS_DOT] = ACTIONS(3067),
    [anon_sym_DASH_DOT] = ACTIONS(3067),
    [anon_sym_PERCENT] = ACTIONS(3067),
    [anon_sym_AMP_AMP] = ACTIONS(3067),
    [anon_sym_TILDE] = ACTIONS(3069),
    [aux_sym_prefix_op_token1] = ACTIONS(3067),
    [aux_sym_infix_op_token1] = ACTIONS(3069),
    [aux_sym_infix_op_token2] = ACTIONS(3067),
    [anon_sym_PIPE_PIPE] = ACTIONS(3067),
    [anon_sym_BANG_EQ] = ACTIONS(3067),
    [anon_sym_COLON_EQ] = ACTIONS(3069),
    [anon_sym_DOLLAR] = ACTIONS(3067),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3067),
    [sym_int] = ACTIONS(3067),
    [sym_xint] = ACTIONS(3069),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3069),
    [sym__newline] = ACTIONS(3069),
  },
  [1050] = {
    [sym__else_expression] = STATE(1774),
    [sym_elif_expression] = STATE(1432),
    [sym_block_comment] = STATE(1050),
    [sym_compiler_directive_decl] = STATE(1050),
    [sym_fsi_directive_decl] = STATE(1050),
    [sym_preproc_line] = STATE(1050),
    [aux_sym_if_expression_repeat1] = STATE(1089),
    [sym_identifier] = ACTIONS(2422),
    [anon_sym_EQ] = ACTIONS(2424),
    [anon_sym_COLON] = ACTIONS(2422),
    [anon_sym_return] = ACTIONS(2422),
    [anon_sym_do] = ACTIONS(2422),
    [anon_sym_and] = ACTIONS(2422),
    [anon_sym_let] = ACTIONS(2422),
    [anon_sym_let_BANG] = ACTIONS(2424),
    [anon_sym_LPAREN] = ACTIONS(2422),
    [anon_sym_COMMA] = ACTIONS(2424),
    [anon_sym_null] = ACTIONS(2422),
    [anon_sym_QMARK] = ACTIONS(2422),
    [anon_sym_COLON_QMARK] = ACTIONS(2422),
    [anon_sym_COLON_COLON] = ACTIONS(2424),
    [anon_sym_AMP] = ACTIONS(2422),
    [anon_sym_LBRACK] = ACTIONS(2422),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2424),
    [anon_sym_LBRACE] = ACTIONS(2422),
    [anon_sym_LT_AT] = ACTIONS(2422),
    [anon_sym_LT_AT_AT] = ACTIONS(2422),
    [anon_sym_DOT] = ACTIONS(2422),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2424),
    [anon_sym_new] = ACTIONS(2422),
    [anon_sym_return_BANG] = ACTIONS(2424),
    [anon_sym_yield] = ACTIONS(2422),
    [anon_sym_yield_BANG] = ACTIONS(2424),
    [anon_sym_lazy] = ACTIONS(2422),
    [anon_sym_assert] = ACTIONS(2422),
    [anon_sym_upcast] = ACTIONS(2422),
    [anon_sym_downcast] = ACTIONS(2422),
    [anon_sym_COLON_GT] = ACTIONS(2424),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2424),
    [anon_sym_for] = ACTIONS(2422),
    [anon_sym_while] = ACTIONS(2422),
    [anon_sym_else] = ACTIONS(3292),
    [anon_sym_elif] = ACTIONS(3294),
    [anon_sym_if] = ACTIONS(2422),
    [anon_sym_fun] = ACTIONS(2422),
    [anon_sym_try] = ACTIONS(2422),
    [anon_sym_match] = ACTIONS(2422),
    [anon_sym_match_BANG] = ACTIONS(2424),
    [anon_sym_function] = ACTIONS(2422),
    [anon_sym_LT_DASH] = ACTIONS(2422),
    [anon_sym_DOT_LBRACK] = ACTIONS(2424),
    [anon_sym_LT] = ACTIONS(2424),
    [anon_sym_use] = ACTIONS(2422),
    [anon_sym_use_BANG] = ACTIONS(2424),
    [anon_sym_do_BANG] = ACTIONS(2424),
    [anon_sym_begin] = ACTIONS(2422),
    [anon_sym_LPAREN2] = ACTIONS(2422),
    [anon_sym_or] = ACTIONS(2422),
    [aux_sym_char_token1] = ACTIONS(2424),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2422),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_AT_DQUOTE] = ACTIONS(2424),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2424),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2424),
    [sym_bool] = ACTIONS(2422),
    [sym_unit] = ACTIONS(2424),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2422),
    [sym_op_identifier] = ACTIONS(2422),
    [anon_sym_PLUS] = ACTIONS(2422),
    [anon_sym_DASH] = ACTIONS(2422),
    [anon_sym_PLUS_DOT] = ACTIONS(2422),
    [anon_sym_DASH_DOT] = ACTIONS(2422),
    [anon_sym_PERCENT] = ACTIONS(2422),
    [anon_sym_AMP_AMP] = ACTIONS(2422),
    [anon_sym_TILDE] = ACTIONS(2424),
    [aux_sym_prefix_op_token1] = ACTIONS(2422),
    [aux_sym_infix_op_token1] = ACTIONS(2424),
    [aux_sym_infix_op_token2] = ACTIONS(2422),
    [anon_sym_PIPE_PIPE] = ACTIONS(2422),
    [anon_sym_BANG_EQ] = ACTIONS(2422),
    [anon_sym_COLON_EQ] = ACTIONS(2424),
    [anon_sym_DOLLAR] = ACTIONS(2422),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2422),
    [sym_int] = ACTIONS(2422),
    [sym_xint] = ACTIONS(2424),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2424),
    [sym__newline] = ACTIONS(2424),
    [sym__dedent] = ACTIONS(2424),
  },
  [1051] = {
    [sym_block_comment] = STATE(1051),
    [sym_compiler_directive_decl] = STATE(1051),
    [sym_fsi_directive_decl] = STATE(1051),
    [sym_preproc_line] = STATE(1051),
    [sym_identifier] = ACTIONS(3127),
    [anon_sym_EQ] = ACTIONS(3129),
    [anon_sym_GT_RBRACK] = ACTIONS(3129),
    [anon_sym_COLON] = ACTIONS(3127),
    [anon_sym_return] = ACTIONS(3127),
    [anon_sym_do] = ACTIONS(3127),
    [anon_sym_let] = ACTIONS(3127),
    [anon_sym_let_BANG] = ACTIONS(3129),
    [anon_sym_LPAREN] = ACTIONS(3127),
    [anon_sym_COMMA] = ACTIONS(3129),
    [anon_sym_null] = ACTIONS(3127),
    [anon_sym_QMARK] = ACTIONS(3127),
    [anon_sym_COLON_QMARK] = ACTIONS(3127),
    [anon_sym_COLON_COLON] = ACTIONS(3129),
    [anon_sym_AMP] = ACTIONS(3127),
    [anon_sym_LBRACK] = ACTIONS(3127),
    [anon_sym_RBRACK] = ACTIONS(3129),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3129),
    [anon_sym_LBRACE] = ACTIONS(3127),
    [anon_sym_RBRACE] = ACTIONS(3129),
    [anon_sym_LT_AT] = ACTIONS(3127),
    [anon_sym_LT_AT_AT] = ACTIONS(3127),
    [anon_sym_DOT] = ACTIONS(3127),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3129),
    [anon_sym_new] = ACTIONS(3127),
    [anon_sym_with] = ACTIONS(3127),
    [anon_sym_return_BANG] = ACTIONS(3129),
    [anon_sym_yield] = ACTIONS(3127),
    [anon_sym_yield_BANG] = ACTIONS(3129),
    [anon_sym_lazy] = ACTIONS(3127),
    [anon_sym_assert] = ACTIONS(3127),
    [anon_sym_upcast] = ACTIONS(3127),
    [anon_sym_downcast] = ACTIONS(3127),
    [anon_sym_COLON_GT] = ACTIONS(3129),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3129),
    [anon_sym_for] = ACTIONS(3127),
    [anon_sym_to] = ACTIONS(3127),
    [anon_sym_downto] = ACTIONS(3127),
    [anon_sym_while] = ACTIONS(3127),
    [anon_sym_if] = ACTIONS(3127),
    [anon_sym_fun] = ACTIONS(3127),
    [anon_sym_try] = ACTIONS(3127),
    [anon_sym_match] = ACTIONS(3127),
    [anon_sym_match_BANG] = ACTIONS(3129),
    [anon_sym_function] = ACTIONS(3127),
    [anon_sym_LT_DASH] = ACTIONS(3127),
    [anon_sym_DOT_LBRACK] = ACTIONS(3129),
    [anon_sym_LT] = ACTIONS(3129),
    [anon_sym_use] = ACTIONS(3127),
    [anon_sym_use_BANG] = ACTIONS(3129),
    [anon_sym_do_BANG] = ACTIONS(3129),
    [anon_sym_begin] = ACTIONS(3127),
    [anon_sym_LPAREN2] = ACTIONS(3127),
    [anon_sym_DOT_DOT2] = ACTIONS(3129),
    [anon_sym_or] = ACTIONS(3127),
    [aux_sym_char_token1] = ACTIONS(3129),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3127),
    [anon_sym_DQUOTE] = ACTIONS(3127),
    [anon_sym_AT_DQUOTE] = ACTIONS(3129),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3129),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3129),
    [sym_bool] = ACTIONS(3127),
    [sym_unit] = ACTIONS(3129),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3127),
    [sym_op_identifier] = ACTIONS(3127),
    [anon_sym_PLUS] = ACTIONS(3127),
    [anon_sym_DASH] = ACTIONS(3127),
    [anon_sym_PLUS_DOT] = ACTIONS(3127),
    [anon_sym_DASH_DOT] = ACTIONS(3127),
    [anon_sym_PERCENT] = ACTIONS(3127),
    [anon_sym_AMP_AMP] = ACTIONS(3127),
    [anon_sym_TILDE] = ACTIONS(3129),
    [aux_sym_prefix_op_token1] = ACTIONS(3127),
    [aux_sym_infix_op_token1] = ACTIONS(3129),
    [aux_sym_infix_op_token2] = ACTIONS(3127),
    [anon_sym_PIPE_PIPE] = ACTIONS(3127),
    [anon_sym_BANG_EQ] = ACTIONS(3127),
    [anon_sym_COLON_EQ] = ACTIONS(3129),
    [anon_sym_DOLLAR] = ACTIONS(3127),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3127),
    [sym_int] = ACTIONS(3127),
    [sym_xint] = ACTIONS(3129),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3129),
    [sym__newline] = ACTIONS(3129),
  },
  [1052] = {
    [sym_block_comment] = STATE(1052),
    [sym_compiler_directive_decl] = STATE(1052),
    [sym_fsi_directive_decl] = STATE(1052),
    [sym_preproc_line] = STATE(1052),
    [sym_identifier] = ACTIONS(3051),
    [anon_sym_EQ] = ACTIONS(3053),
    [anon_sym_GT_RBRACK] = ACTIONS(3053),
    [anon_sym_COLON] = ACTIONS(3051),
    [anon_sym_return] = ACTIONS(3051),
    [anon_sym_do] = ACTIONS(3051),
    [anon_sym_let] = ACTIONS(3051),
    [anon_sym_let_BANG] = ACTIONS(3053),
    [anon_sym_LPAREN] = ACTIONS(3051),
    [anon_sym_COMMA] = ACTIONS(3053),
    [anon_sym_null] = ACTIONS(3051),
    [anon_sym_QMARK] = ACTIONS(3051),
    [anon_sym_COLON_QMARK] = ACTIONS(3051),
    [anon_sym_COLON_COLON] = ACTIONS(3053),
    [anon_sym_AMP] = ACTIONS(3051),
    [anon_sym_LBRACK] = ACTIONS(3051),
    [anon_sym_RBRACK] = ACTIONS(3053),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3053),
    [anon_sym_LBRACE] = ACTIONS(3051),
    [anon_sym_RBRACE] = ACTIONS(3053),
    [anon_sym_LT_AT] = ACTIONS(3051),
    [anon_sym_LT_AT_AT] = ACTIONS(3051),
    [anon_sym_DOT] = ACTIONS(3051),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3053),
    [anon_sym_new] = ACTIONS(3051),
    [anon_sym_with] = ACTIONS(3051),
    [anon_sym_return_BANG] = ACTIONS(3053),
    [anon_sym_yield] = ACTIONS(3051),
    [anon_sym_yield_BANG] = ACTIONS(3053),
    [anon_sym_lazy] = ACTIONS(3051),
    [anon_sym_assert] = ACTIONS(3051),
    [anon_sym_upcast] = ACTIONS(3051),
    [anon_sym_downcast] = ACTIONS(3051),
    [anon_sym_COLON_GT] = ACTIONS(3053),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3053),
    [anon_sym_for] = ACTIONS(3051),
    [anon_sym_to] = ACTIONS(3051),
    [anon_sym_downto] = ACTIONS(3051),
    [anon_sym_while] = ACTIONS(3051),
    [anon_sym_if] = ACTIONS(3051),
    [anon_sym_fun] = ACTIONS(3051),
    [anon_sym_try] = ACTIONS(3051),
    [anon_sym_match] = ACTIONS(3051),
    [anon_sym_match_BANG] = ACTIONS(3053),
    [anon_sym_function] = ACTIONS(3051),
    [anon_sym_LT_DASH] = ACTIONS(3051),
    [anon_sym_DOT_LBRACK] = ACTIONS(3053),
    [anon_sym_LT] = ACTIONS(3053),
    [anon_sym_use] = ACTIONS(3051),
    [anon_sym_use_BANG] = ACTIONS(3053),
    [anon_sym_do_BANG] = ACTIONS(3053),
    [anon_sym_begin] = ACTIONS(3051),
    [anon_sym_LPAREN2] = ACTIONS(3051),
    [anon_sym_DOT_DOT2] = ACTIONS(3053),
    [anon_sym_or] = ACTIONS(3051),
    [aux_sym_char_token1] = ACTIONS(3053),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3051),
    [anon_sym_DQUOTE] = ACTIONS(3051),
    [anon_sym_AT_DQUOTE] = ACTIONS(3053),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3053),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3053),
    [sym_bool] = ACTIONS(3051),
    [sym_unit] = ACTIONS(3053),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3051),
    [sym_op_identifier] = ACTIONS(3051),
    [anon_sym_PLUS] = ACTIONS(3051),
    [anon_sym_DASH] = ACTIONS(3051),
    [anon_sym_PLUS_DOT] = ACTIONS(3051),
    [anon_sym_DASH_DOT] = ACTIONS(3051),
    [anon_sym_PERCENT] = ACTIONS(3051),
    [anon_sym_AMP_AMP] = ACTIONS(3051),
    [anon_sym_TILDE] = ACTIONS(3053),
    [aux_sym_prefix_op_token1] = ACTIONS(3051),
    [aux_sym_infix_op_token1] = ACTIONS(3053),
    [aux_sym_infix_op_token2] = ACTIONS(3051),
    [anon_sym_PIPE_PIPE] = ACTIONS(3051),
    [anon_sym_BANG_EQ] = ACTIONS(3051),
    [anon_sym_COLON_EQ] = ACTIONS(3053),
    [anon_sym_DOLLAR] = ACTIONS(3051),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3051),
    [sym_int] = ACTIONS(3051),
    [sym_xint] = ACTIONS(3053),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3053),
    [sym__newline] = ACTIONS(3053),
  },
  [1053] = {
    [sym_block_comment] = STATE(1053),
    [sym_compiler_directive_decl] = STATE(1053),
    [sym_fsi_directive_decl] = STATE(1053),
    [sym_preproc_line] = STATE(1053),
    [sym_identifier] = ACTIONS(2984),
    [anon_sym_EQ] = ACTIONS(2986),
    [anon_sym_GT_RBRACK] = ACTIONS(2986),
    [anon_sym_COLON] = ACTIONS(2984),
    [anon_sym_return] = ACTIONS(2984),
    [anon_sym_do] = ACTIONS(2984),
    [anon_sym_let] = ACTIONS(2984),
    [anon_sym_let_BANG] = ACTIONS(2986),
    [anon_sym_LPAREN] = ACTIONS(2984),
    [anon_sym_COMMA] = ACTIONS(2986),
    [anon_sym_null] = ACTIONS(2984),
    [anon_sym_QMARK] = ACTIONS(2984),
    [anon_sym_COLON_QMARK] = ACTIONS(2984),
    [anon_sym_COLON_COLON] = ACTIONS(2986),
    [anon_sym_AMP] = ACTIONS(2984),
    [anon_sym_LBRACK] = ACTIONS(2984),
    [anon_sym_RBRACK] = ACTIONS(2986),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2986),
    [anon_sym_LBRACE] = ACTIONS(2984),
    [anon_sym_RBRACE] = ACTIONS(2986),
    [anon_sym_LT_AT] = ACTIONS(2984),
    [anon_sym_LT_AT_AT] = ACTIONS(2984),
    [anon_sym_DOT] = ACTIONS(2984),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2986),
    [anon_sym_new] = ACTIONS(2984),
    [anon_sym_with] = ACTIONS(2984),
    [anon_sym_return_BANG] = ACTIONS(2986),
    [anon_sym_yield] = ACTIONS(2984),
    [anon_sym_yield_BANG] = ACTIONS(2986),
    [anon_sym_lazy] = ACTIONS(2984),
    [anon_sym_assert] = ACTIONS(2984),
    [anon_sym_upcast] = ACTIONS(2984),
    [anon_sym_downcast] = ACTIONS(2984),
    [anon_sym_COLON_GT] = ACTIONS(2986),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2986),
    [anon_sym_for] = ACTIONS(2984),
    [anon_sym_to] = ACTIONS(2984),
    [anon_sym_downto] = ACTIONS(2984),
    [anon_sym_while] = ACTIONS(2984),
    [anon_sym_if] = ACTIONS(2984),
    [anon_sym_fun] = ACTIONS(2984),
    [anon_sym_try] = ACTIONS(2984),
    [anon_sym_match] = ACTIONS(2984),
    [anon_sym_match_BANG] = ACTIONS(2986),
    [anon_sym_function] = ACTIONS(2984),
    [anon_sym_LT_DASH] = ACTIONS(2984),
    [anon_sym_DOT_LBRACK] = ACTIONS(2986),
    [anon_sym_LT] = ACTIONS(2986),
    [anon_sym_use] = ACTIONS(2984),
    [anon_sym_use_BANG] = ACTIONS(2986),
    [anon_sym_do_BANG] = ACTIONS(2986),
    [anon_sym_begin] = ACTIONS(2984),
    [anon_sym_LPAREN2] = ACTIONS(2984),
    [anon_sym_DOT_DOT2] = ACTIONS(2986),
    [anon_sym_or] = ACTIONS(2984),
    [aux_sym_char_token1] = ACTIONS(2986),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2984),
    [anon_sym_DQUOTE] = ACTIONS(2984),
    [anon_sym_AT_DQUOTE] = ACTIONS(2986),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2986),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2986),
    [sym_bool] = ACTIONS(2984),
    [sym_unit] = ACTIONS(2986),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2984),
    [sym_op_identifier] = ACTIONS(2984),
    [anon_sym_PLUS] = ACTIONS(2984),
    [anon_sym_DASH] = ACTIONS(2984),
    [anon_sym_PLUS_DOT] = ACTIONS(2984),
    [anon_sym_DASH_DOT] = ACTIONS(2984),
    [anon_sym_PERCENT] = ACTIONS(2984),
    [anon_sym_AMP_AMP] = ACTIONS(2984),
    [anon_sym_TILDE] = ACTIONS(2986),
    [aux_sym_prefix_op_token1] = ACTIONS(2984),
    [aux_sym_infix_op_token1] = ACTIONS(2986),
    [aux_sym_infix_op_token2] = ACTIONS(2984),
    [anon_sym_PIPE_PIPE] = ACTIONS(2984),
    [anon_sym_BANG_EQ] = ACTIONS(2984),
    [anon_sym_COLON_EQ] = ACTIONS(2986),
    [anon_sym_DOLLAR] = ACTIONS(2984),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2984),
    [sym_int] = ACTIONS(2984),
    [sym_xint] = ACTIONS(2986),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2986),
    [sym__newline] = ACTIONS(2986),
  },
  [1054] = {
    [sym_block_comment] = STATE(1054),
    [sym_compiler_directive_decl] = STATE(1054),
    [sym_fsi_directive_decl] = STATE(1054),
    [sym_preproc_line] = STATE(1054),
    [sym_identifier] = ACTIONS(2470),
    [anon_sym_EQ] = ACTIONS(2472),
    [anon_sym_COLON] = ACTIONS(2470),
    [anon_sym_return] = ACTIONS(2470),
    [anon_sym_do] = ACTIONS(2470),
    [anon_sym_let] = ACTIONS(2470),
    [anon_sym_let_BANG] = ACTIONS(2472),
    [anon_sym_as] = ACTIONS(2470),
    [anon_sym_LPAREN] = ACTIONS(2470),
    [anon_sym_COMMA] = ACTIONS(2472),
    [anon_sym_null] = ACTIONS(2470),
    [anon_sym_QMARK] = ACTIONS(2470),
    [anon_sym_COLON_QMARK] = ACTIONS(2470),
    [anon_sym_COLON_COLON] = ACTIONS(2472),
    [anon_sym_AMP] = ACTIONS(2470),
    [anon_sym_LBRACK] = ACTIONS(2470),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2472),
    [anon_sym_LBRACE] = ACTIONS(2470),
    [anon_sym_LT_AT] = ACTIONS(2470),
    [anon_sym_LT_AT_AT] = ACTIONS(2470),
    [anon_sym_DOT] = ACTIONS(2470),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2472),
    [anon_sym_new] = ACTIONS(2470),
    [anon_sym_with] = ACTIONS(2470),
    [anon_sym_return_BANG] = ACTIONS(2472),
    [anon_sym_yield] = ACTIONS(2470),
    [anon_sym_yield_BANG] = ACTIONS(2472),
    [anon_sym_lazy] = ACTIONS(2470),
    [anon_sym_assert] = ACTIONS(2470),
    [anon_sym_upcast] = ACTIONS(2470),
    [anon_sym_downcast] = ACTIONS(2470),
    [anon_sym_COLON_GT] = ACTIONS(2472),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2472),
    [anon_sym_for] = ACTIONS(2470),
    [anon_sym_while] = ACTIONS(2470),
    [anon_sym_if] = ACTIONS(2470),
    [anon_sym_fun] = ACTIONS(2470),
    [anon_sym_DASH_GT] = ACTIONS(2470),
    [anon_sym_try] = ACTIONS(2470),
    [anon_sym_match] = ACTIONS(2470),
    [anon_sym_match_BANG] = ACTIONS(2472),
    [anon_sym_function] = ACTIONS(2470),
    [anon_sym_LT_DASH] = ACTIONS(2470),
    [anon_sym_DOT_LBRACK] = ACTIONS(2472),
    [anon_sym_LT] = ACTIONS(2472),
    [anon_sym_use] = ACTIONS(2470),
    [anon_sym_use_BANG] = ACTIONS(2472),
    [anon_sym_do_BANG] = ACTIONS(2472),
    [anon_sym_begin] = ACTIONS(2470),
    [anon_sym_LPAREN2] = ACTIONS(2470),
    [anon_sym_STAR] = ACTIONS(2470),
    [anon_sym_LT2] = ACTIONS(2470),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2472),
    [anon_sym_or] = ACTIONS(2470),
    [aux_sym_char_token1] = ACTIONS(2472),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2470),
    [anon_sym_DQUOTE] = ACTIONS(2470),
    [anon_sym_AT_DQUOTE] = ACTIONS(2472),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2472),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2472),
    [sym_bool] = ACTIONS(2470),
    [sym_unit] = ACTIONS(2472),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2470),
    [sym_op_identifier] = ACTIONS(2470),
    [anon_sym_PLUS] = ACTIONS(2470),
    [anon_sym_DASH] = ACTIONS(2470),
    [anon_sym_PLUS_DOT] = ACTIONS(2470),
    [anon_sym_DASH_DOT] = ACTIONS(2470),
    [anon_sym_PERCENT] = ACTIONS(2470),
    [anon_sym_AMP_AMP] = ACTIONS(2470),
    [anon_sym_TILDE] = ACTIONS(2472),
    [aux_sym_prefix_op_token1] = ACTIONS(2470),
    [aux_sym_infix_op_token1] = ACTIONS(2472),
    [aux_sym_infix_op_token2] = ACTIONS(2470),
    [anon_sym_PIPE_PIPE] = ACTIONS(2470),
    [anon_sym_BANG_EQ] = ACTIONS(2470),
    [anon_sym_COLON_EQ] = ACTIONS(2472),
    [anon_sym_DOLLAR] = ACTIONS(2470),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2470),
    [sym_int] = ACTIONS(2470),
    [sym_xint] = ACTIONS(2472),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2472),
    [sym__newline] = ACTIONS(2472),
    [sym__dedent] = ACTIONS(2472),
  },
  [1055] = {
    [sym__else_expression] = STATE(2038),
    [sym_elif_expression] = STATE(1410),
    [sym_block_comment] = STATE(1055),
    [sym_compiler_directive_decl] = STATE(1055),
    [sym_fsi_directive_decl] = STATE(1055),
    [sym_preproc_line] = STATE(1055),
    [aux_sym_if_expression_repeat1] = STATE(1086),
    [sym_identifier] = ACTIONS(2422),
    [anon_sym_EQ] = ACTIONS(2424),
    [anon_sym_COLON] = ACTIONS(2422),
    [anon_sym_return] = ACTIONS(2422),
    [anon_sym_do] = ACTIONS(2422),
    [anon_sym_let] = ACTIONS(2422),
    [anon_sym_let_BANG] = ACTIONS(2424),
    [anon_sym_LPAREN] = ACTIONS(2422),
    [anon_sym_COMMA] = ACTIONS(2424),
    [anon_sym_null] = ACTIONS(2422),
    [anon_sym_QMARK] = ACTIONS(2422),
    [anon_sym_COLON_QMARK] = ACTIONS(2422),
    [anon_sym_COLON_COLON] = ACTIONS(2424),
    [anon_sym_AMP] = ACTIONS(2422),
    [anon_sym_LBRACK] = ACTIONS(2422),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2424),
    [anon_sym_LBRACE] = ACTIONS(2422),
    [anon_sym_LT_AT] = ACTIONS(2422),
    [anon_sym_LT_AT_AT] = ACTIONS(2422),
    [anon_sym_DOT] = ACTIONS(2422),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2424),
    [anon_sym_new] = ACTIONS(2422),
    [anon_sym_return_BANG] = ACTIONS(2424),
    [anon_sym_yield] = ACTIONS(2422),
    [anon_sym_yield_BANG] = ACTIONS(2424),
    [anon_sym_lazy] = ACTIONS(2422),
    [anon_sym_assert] = ACTIONS(2422),
    [anon_sym_upcast] = ACTIONS(2422),
    [anon_sym_downcast] = ACTIONS(2422),
    [anon_sym_COLON_GT] = ACTIONS(2424),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2424),
    [anon_sym_for] = ACTIONS(2422),
    [anon_sym_while] = ACTIONS(2422),
    [anon_sym_else] = ACTIONS(3296),
    [anon_sym_elif] = ACTIONS(3298),
    [anon_sym_if] = ACTIONS(2422),
    [anon_sym_fun] = ACTIONS(2422),
    [anon_sym_try] = ACTIONS(2422),
    [anon_sym_match] = ACTIONS(2422),
    [anon_sym_match_BANG] = ACTIONS(2424),
    [anon_sym_function] = ACTIONS(2422),
    [anon_sym_LT_DASH] = ACTIONS(2422),
    [anon_sym_DOT_LBRACK] = ACTIONS(2424),
    [anon_sym_LT] = ACTIONS(2424),
    [anon_sym_use] = ACTIONS(2422),
    [anon_sym_use_BANG] = ACTIONS(2424),
    [anon_sym_do_BANG] = ACTIONS(2424),
    [anon_sym_begin] = ACTIONS(2422),
    [anon_sym_LPAREN2] = ACTIONS(2422),
    [anon_sym_or] = ACTIONS(2422),
    [aux_sym_char_token1] = ACTIONS(2424),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2422),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_AT_DQUOTE] = ACTIONS(2424),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2424),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2424),
    [sym_bool] = ACTIONS(2422),
    [sym_unit] = ACTIONS(2424),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2422),
    [sym_op_identifier] = ACTIONS(2422),
    [anon_sym_PLUS] = ACTIONS(2422),
    [anon_sym_DASH] = ACTIONS(2422),
    [anon_sym_PLUS_DOT] = ACTIONS(2422),
    [anon_sym_DASH_DOT] = ACTIONS(2422),
    [anon_sym_PERCENT] = ACTIONS(2422),
    [anon_sym_AMP_AMP] = ACTIONS(2422),
    [anon_sym_TILDE] = ACTIONS(2424),
    [aux_sym_prefix_op_token1] = ACTIONS(2422),
    [aux_sym_infix_op_token1] = ACTIONS(2424),
    [aux_sym_infix_op_token2] = ACTIONS(2422),
    [anon_sym_PIPE_PIPE] = ACTIONS(2422),
    [anon_sym_BANG_EQ] = ACTIONS(2422),
    [anon_sym_COLON_EQ] = ACTIONS(2424),
    [anon_sym_DOLLAR] = ACTIONS(2422),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2422),
    [sym_int] = ACTIONS(2422),
    [sym_xint] = ACTIONS(2424),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2424),
    [anon_sym_POUNDendif] = ACTIONS(2424),
    [anon_sym_POUNDelse] = ACTIONS(2424),
    [sym__newline] = ACTIONS(2424),
  },
  [1056] = {
    [sym_block_comment] = STATE(1056),
    [sym_compiler_directive_decl] = STATE(1056),
    [sym_fsi_directive_decl] = STATE(1056),
    [sym_preproc_line] = STATE(1056),
    [sym_identifier] = ACTIONS(2954),
    [anon_sym_EQ] = ACTIONS(2956),
    [anon_sym_GT_RBRACK] = ACTIONS(2956),
    [anon_sym_COLON] = ACTIONS(2954),
    [anon_sym_return] = ACTIONS(2954),
    [anon_sym_do] = ACTIONS(2954),
    [anon_sym_let] = ACTIONS(2954),
    [anon_sym_let_BANG] = ACTIONS(2956),
    [anon_sym_LPAREN] = ACTIONS(2954),
    [anon_sym_COMMA] = ACTIONS(2956),
    [anon_sym_null] = ACTIONS(2954),
    [anon_sym_QMARK] = ACTIONS(2954),
    [anon_sym_COLON_QMARK] = ACTIONS(2954),
    [anon_sym_COLON_COLON] = ACTIONS(2956),
    [anon_sym_AMP] = ACTIONS(2954),
    [anon_sym_LBRACK] = ACTIONS(2954),
    [anon_sym_RBRACK] = ACTIONS(2956),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2956),
    [anon_sym_LBRACE] = ACTIONS(2954),
    [anon_sym_RBRACE] = ACTIONS(2956),
    [anon_sym_LT_AT] = ACTIONS(2954),
    [anon_sym_LT_AT_AT] = ACTIONS(2954),
    [anon_sym_DOT] = ACTIONS(2954),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2956),
    [anon_sym_new] = ACTIONS(2954),
    [anon_sym_with] = ACTIONS(2954),
    [anon_sym_return_BANG] = ACTIONS(2956),
    [anon_sym_yield] = ACTIONS(2954),
    [anon_sym_yield_BANG] = ACTIONS(2956),
    [anon_sym_lazy] = ACTIONS(2954),
    [anon_sym_assert] = ACTIONS(2954),
    [anon_sym_upcast] = ACTIONS(2954),
    [anon_sym_downcast] = ACTIONS(2954),
    [anon_sym_COLON_GT] = ACTIONS(2956),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2956),
    [anon_sym_for] = ACTIONS(2954),
    [anon_sym_to] = ACTIONS(2954),
    [anon_sym_downto] = ACTIONS(2954),
    [anon_sym_while] = ACTIONS(2954),
    [anon_sym_if] = ACTIONS(2954),
    [anon_sym_fun] = ACTIONS(2954),
    [anon_sym_try] = ACTIONS(2954),
    [anon_sym_match] = ACTIONS(2954),
    [anon_sym_match_BANG] = ACTIONS(2956),
    [anon_sym_function] = ACTIONS(2954),
    [anon_sym_LT_DASH] = ACTIONS(2954),
    [anon_sym_DOT_LBRACK] = ACTIONS(2956),
    [anon_sym_LT] = ACTIONS(2956),
    [anon_sym_use] = ACTIONS(2954),
    [anon_sym_use_BANG] = ACTIONS(2956),
    [anon_sym_do_BANG] = ACTIONS(2956),
    [anon_sym_begin] = ACTIONS(2954),
    [anon_sym_LPAREN2] = ACTIONS(2954),
    [anon_sym_DOT_DOT2] = ACTIONS(2956),
    [anon_sym_or] = ACTIONS(2954),
    [aux_sym_char_token1] = ACTIONS(2956),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2954),
    [anon_sym_DQUOTE] = ACTIONS(2954),
    [anon_sym_AT_DQUOTE] = ACTIONS(2956),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2956),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2956),
    [sym_bool] = ACTIONS(2954),
    [sym_unit] = ACTIONS(2956),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2954),
    [sym_op_identifier] = ACTIONS(2954),
    [anon_sym_PLUS] = ACTIONS(2954),
    [anon_sym_DASH] = ACTIONS(2954),
    [anon_sym_PLUS_DOT] = ACTIONS(2954),
    [anon_sym_DASH_DOT] = ACTIONS(2954),
    [anon_sym_PERCENT] = ACTIONS(2954),
    [anon_sym_AMP_AMP] = ACTIONS(2954),
    [anon_sym_TILDE] = ACTIONS(2956),
    [aux_sym_prefix_op_token1] = ACTIONS(2954),
    [aux_sym_infix_op_token1] = ACTIONS(2956),
    [aux_sym_infix_op_token2] = ACTIONS(2954),
    [anon_sym_PIPE_PIPE] = ACTIONS(2954),
    [anon_sym_BANG_EQ] = ACTIONS(2954),
    [anon_sym_COLON_EQ] = ACTIONS(2956),
    [anon_sym_DOLLAR] = ACTIONS(2954),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2954),
    [sym_int] = ACTIONS(2954),
    [sym_xint] = ACTIONS(2956),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2956),
    [sym__newline] = ACTIONS(2956),
  },
  [1057] = {
    [sym_block_comment] = STATE(1057),
    [sym_compiler_directive_decl] = STATE(1057),
    [sym_fsi_directive_decl] = STATE(1057),
    [sym_preproc_line] = STATE(1057),
    [aux_sym_type_argument_repeat1] = STATE(1057),
    [sym_identifier] = ACTIONS(2340),
    [anon_sym_EQ] = ACTIONS(2342),
    [anon_sym_COLON] = ACTIONS(2340),
    [anon_sym_return] = ACTIONS(2340),
    [anon_sym_do] = ACTIONS(2340),
    [anon_sym_let] = ACTIONS(2340),
    [anon_sym_let_BANG] = ACTIONS(2342),
    [anon_sym_as] = ACTIONS(2340),
    [anon_sym_LPAREN] = ACTIONS(2340),
    [anon_sym_COMMA] = ACTIONS(2342),
    [anon_sym_null] = ACTIONS(2340),
    [anon_sym_QMARK] = ACTIONS(2340),
    [anon_sym_COLON_QMARK] = ACTIONS(2340),
    [anon_sym_COLON_COLON] = ACTIONS(2342),
    [anon_sym_AMP] = ACTIONS(2340),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2342),
    [anon_sym_LBRACE] = ACTIONS(2340),
    [anon_sym_LT_AT] = ACTIONS(2340),
    [anon_sym_LT_AT_AT] = ACTIONS(2340),
    [anon_sym_DOT] = ACTIONS(2340),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2342),
    [anon_sym_new] = ACTIONS(2340),
    [anon_sym_with] = ACTIONS(2340),
    [anon_sym_return_BANG] = ACTIONS(2342),
    [anon_sym_yield] = ACTIONS(2340),
    [anon_sym_yield_BANG] = ACTIONS(2342),
    [anon_sym_lazy] = ACTIONS(2340),
    [anon_sym_assert] = ACTIONS(2340),
    [anon_sym_upcast] = ACTIONS(2340),
    [anon_sym_downcast] = ACTIONS(2340),
    [anon_sym_COLON_GT] = ACTIONS(2342),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2342),
    [anon_sym_for] = ACTIONS(2340),
    [anon_sym_while] = ACTIONS(2340),
    [anon_sym_if] = ACTIONS(2340),
    [anon_sym_fun] = ACTIONS(2340),
    [anon_sym_DASH_GT] = ACTIONS(2340),
    [anon_sym_try] = ACTIONS(2340),
    [anon_sym_match] = ACTIONS(2340),
    [anon_sym_match_BANG] = ACTIONS(2342),
    [anon_sym_function] = ACTIONS(2340),
    [anon_sym_LT_DASH] = ACTIONS(2340),
    [anon_sym_DOT_LBRACK] = ACTIONS(2342),
    [anon_sym_LT] = ACTIONS(2342),
    [anon_sym_use] = ACTIONS(2340),
    [anon_sym_use_BANG] = ACTIONS(2342),
    [anon_sym_do_BANG] = ACTIONS(2342),
    [anon_sym_begin] = ACTIONS(2340),
    [anon_sym_LPAREN2] = ACTIONS(2340),
    [anon_sym_STAR] = ACTIONS(2340),
    [anon_sym_LT2] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2342),
    [anon_sym_or] = ACTIONS(3300),
    [aux_sym_char_token1] = ACTIONS(2342),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2340),
    [anon_sym_DQUOTE] = ACTIONS(2340),
    [anon_sym_AT_DQUOTE] = ACTIONS(2342),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2342),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2342),
    [sym_bool] = ACTIONS(2340),
    [sym_unit] = ACTIONS(2342),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2340),
    [sym_op_identifier] = ACTIONS(2340),
    [anon_sym_PLUS] = ACTIONS(2340),
    [anon_sym_DASH] = ACTIONS(2340),
    [anon_sym_PLUS_DOT] = ACTIONS(2340),
    [anon_sym_DASH_DOT] = ACTIONS(2340),
    [anon_sym_PERCENT] = ACTIONS(2340),
    [anon_sym_AMP_AMP] = ACTIONS(2340),
    [anon_sym_TILDE] = ACTIONS(2342),
    [aux_sym_prefix_op_token1] = ACTIONS(2340),
    [aux_sym_infix_op_token1] = ACTIONS(2342),
    [aux_sym_infix_op_token2] = ACTIONS(2340),
    [anon_sym_PIPE_PIPE] = ACTIONS(2340),
    [anon_sym_BANG_EQ] = ACTIONS(2340),
    [anon_sym_COLON_EQ] = ACTIONS(2342),
    [anon_sym_DOLLAR] = ACTIONS(2340),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2340),
    [sym_int] = ACTIONS(2340),
    [sym_xint] = ACTIONS(2342),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2342),
    [sym__newline] = ACTIONS(2342),
  },
  [1058] = {
    [sym_block_comment] = STATE(1058),
    [sym_compiler_directive_decl] = STATE(1058),
    [sym_fsi_directive_decl] = STATE(1058),
    [sym_preproc_line] = STATE(1058),
    [sym_identifier] = ACTIONS(2978),
    [anon_sym_EQ] = ACTIONS(2980),
    [anon_sym_GT_RBRACK] = ACTIONS(2980),
    [anon_sym_COLON] = ACTIONS(2978),
    [anon_sym_return] = ACTIONS(2978),
    [anon_sym_do] = ACTIONS(2978),
    [anon_sym_let] = ACTIONS(2978),
    [anon_sym_let_BANG] = ACTIONS(2980),
    [anon_sym_LPAREN] = ACTIONS(2978),
    [anon_sym_COMMA] = ACTIONS(2980),
    [anon_sym_null] = ACTIONS(2978),
    [anon_sym_QMARK] = ACTIONS(2978),
    [anon_sym_COLON_QMARK] = ACTIONS(2978),
    [anon_sym_COLON_COLON] = ACTIONS(2980),
    [anon_sym_AMP] = ACTIONS(2978),
    [anon_sym_LBRACK] = ACTIONS(2978),
    [anon_sym_RBRACK] = ACTIONS(2980),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2980),
    [anon_sym_LBRACE] = ACTIONS(2978),
    [anon_sym_RBRACE] = ACTIONS(2980),
    [anon_sym_LT_AT] = ACTIONS(2978),
    [anon_sym_LT_AT_AT] = ACTIONS(2978),
    [anon_sym_DOT] = ACTIONS(2978),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2980),
    [anon_sym_new] = ACTIONS(2978),
    [anon_sym_with] = ACTIONS(2978),
    [anon_sym_return_BANG] = ACTIONS(2980),
    [anon_sym_yield] = ACTIONS(2978),
    [anon_sym_yield_BANG] = ACTIONS(2980),
    [anon_sym_lazy] = ACTIONS(2978),
    [anon_sym_assert] = ACTIONS(2978),
    [anon_sym_upcast] = ACTIONS(2978),
    [anon_sym_downcast] = ACTIONS(2978),
    [anon_sym_COLON_GT] = ACTIONS(2980),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2980),
    [anon_sym_for] = ACTIONS(2978),
    [anon_sym_to] = ACTIONS(2978),
    [anon_sym_downto] = ACTIONS(2978),
    [anon_sym_while] = ACTIONS(2978),
    [anon_sym_if] = ACTIONS(2978),
    [anon_sym_fun] = ACTIONS(2978),
    [anon_sym_try] = ACTIONS(2978),
    [anon_sym_match] = ACTIONS(2978),
    [anon_sym_match_BANG] = ACTIONS(2980),
    [anon_sym_function] = ACTIONS(2978),
    [anon_sym_LT_DASH] = ACTIONS(2978),
    [anon_sym_DOT_LBRACK] = ACTIONS(2980),
    [anon_sym_LT] = ACTIONS(2980),
    [anon_sym_use] = ACTIONS(2978),
    [anon_sym_use_BANG] = ACTIONS(2980),
    [anon_sym_do_BANG] = ACTIONS(2980),
    [anon_sym_begin] = ACTIONS(2978),
    [anon_sym_LPAREN2] = ACTIONS(2978),
    [anon_sym_DOT_DOT2] = ACTIONS(2980),
    [anon_sym_or] = ACTIONS(2978),
    [aux_sym_char_token1] = ACTIONS(2980),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2978),
    [anon_sym_DQUOTE] = ACTIONS(2978),
    [anon_sym_AT_DQUOTE] = ACTIONS(2980),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2980),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2980),
    [sym_bool] = ACTIONS(2978),
    [sym_unit] = ACTIONS(2980),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2978),
    [sym_op_identifier] = ACTIONS(2978),
    [anon_sym_PLUS] = ACTIONS(2978),
    [anon_sym_DASH] = ACTIONS(2978),
    [anon_sym_PLUS_DOT] = ACTIONS(2978),
    [anon_sym_DASH_DOT] = ACTIONS(2978),
    [anon_sym_PERCENT] = ACTIONS(2978),
    [anon_sym_AMP_AMP] = ACTIONS(2978),
    [anon_sym_TILDE] = ACTIONS(2980),
    [aux_sym_prefix_op_token1] = ACTIONS(2978),
    [aux_sym_infix_op_token1] = ACTIONS(2980),
    [aux_sym_infix_op_token2] = ACTIONS(2978),
    [anon_sym_PIPE_PIPE] = ACTIONS(2978),
    [anon_sym_BANG_EQ] = ACTIONS(2978),
    [anon_sym_COLON_EQ] = ACTIONS(2980),
    [anon_sym_DOLLAR] = ACTIONS(2978),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2978),
    [sym_int] = ACTIONS(2978),
    [sym_xint] = ACTIONS(2980),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2980),
    [sym__newline] = ACTIONS(2980),
  },
  [1059] = {
    [sym_block_comment] = STATE(1059),
    [sym_compiler_directive_decl] = STATE(1059),
    [sym_fsi_directive_decl] = STATE(1059),
    [sym_preproc_line] = STATE(1059),
    [sym_identifier] = ACTIONS(2992),
    [anon_sym_EQ] = ACTIONS(2994),
    [anon_sym_GT_RBRACK] = ACTIONS(2994),
    [anon_sym_COLON] = ACTIONS(2992),
    [anon_sym_return] = ACTIONS(2992),
    [anon_sym_do] = ACTIONS(2992),
    [anon_sym_let] = ACTIONS(2992),
    [anon_sym_let_BANG] = ACTIONS(2994),
    [anon_sym_LPAREN] = ACTIONS(2992),
    [anon_sym_COMMA] = ACTIONS(2994),
    [anon_sym_null] = ACTIONS(2992),
    [anon_sym_QMARK] = ACTIONS(2992),
    [anon_sym_COLON_QMARK] = ACTIONS(2992),
    [anon_sym_COLON_COLON] = ACTIONS(2994),
    [anon_sym_AMP] = ACTIONS(2992),
    [anon_sym_LBRACK] = ACTIONS(2992),
    [anon_sym_RBRACK] = ACTIONS(2994),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2994),
    [anon_sym_LBRACE] = ACTIONS(2992),
    [anon_sym_RBRACE] = ACTIONS(2994),
    [anon_sym_LT_AT] = ACTIONS(2992),
    [anon_sym_LT_AT_AT] = ACTIONS(2992),
    [anon_sym_DOT] = ACTIONS(2992),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2994),
    [anon_sym_new] = ACTIONS(2992),
    [anon_sym_with] = ACTIONS(2992),
    [anon_sym_return_BANG] = ACTIONS(2994),
    [anon_sym_yield] = ACTIONS(2992),
    [anon_sym_yield_BANG] = ACTIONS(2994),
    [anon_sym_lazy] = ACTIONS(2992),
    [anon_sym_assert] = ACTIONS(2992),
    [anon_sym_upcast] = ACTIONS(2992),
    [anon_sym_downcast] = ACTIONS(2992),
    [anon_sym_COLON_GT] = ACTIONS(2994),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2994),
    [anon_sym_for] = ACTIONS(2992),
    [anon_sym_to] = ACTIONS(2992),
    [anon_sym_downto] = ACTIONS(2992),
    [anon_sym_while] = ACTIONS(2992),
    [anon_sym_if] = ACTIONS(2992),
    [anon_sym_fun] = ACTIONS(2992),
    [anon_sym_try] = ACTIONS(2992),
    [anon_sym_match] = ACTIONS(2992),
    [anon_sym_match_BANG] = ACTIONS(2994),
    [anon_sym_function] = ACTIONS(2992),
    [anon_sym_LT_DASH] = ACTIONS(2992),
    [anon_sym_DOT_LBRACK] = ACTIONS(2994),
    [anon_sym_LT] = ACTIONS(2994),
    [anon_sym_use] = ACTIONS(2992),
    [anon_sym_use_BANG] = ACTIONS(2994),
    [anon_sym_do_BANG] = ACTIONS(2994),
    [anon_sym_begin] = ACTIONS(2992),
    [anon_sym_LPAREN2] = ACTIONS(2992),
    [anon_sym_DOT_DOT2] = ACTIONS(2994),
    [anon_sym_or] = ACTIONS(2992),
    [aux_sym_char_token1] = ACTIONS(2994),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2992),
    [anon_sym_DQUOTE] = ACTIONS(2992),
    [anon_sym_AT_DQUOTE] = ACTIONS(2994),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2994),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2994),
    [sym_bool] = ACTIONS(2992),
    [sym_unit] = ACTIONS(2994),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2992),
    [sym_op_identifier] = ACTIONS(2992),
    [anon_sym_PLUS] = ACTIONS(2992),
    [anon_sym_DASH] = ACTIONS(2992),
    [anon_sym_PLUS_DOT] = ACTIONS(2992),
    [anon_sym_DASH_DOT] = ACTIONS(2992),
    [anon_sym_PERCENT] = ACTIONS(2992),
    [anon_sym_AMP_AMP] = ACTIONS(2992),
    [anon_sym_TILDE] = ACTIONS(2994),
    [aux_sym_prefix_op_token1] = ACTIONS(2992),
    [aux_sym_infix_op_token1] = ACTIONS(2994),
    [aux_sym_infix_op_token2] = ACTIONS(2992),
    [anon_sym_PIPE_PIPE] = ACTIONS(2992),
    [anon_sym_BANG_EQ] = ACTIONS(2992),
    [anon_sym_COLON_EQ] = ACTIONS(2994),
    [anon_sym_DOLLAR] = ACTIONS(2992),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2992),
    [sym_int] = ACTIONS(2992),
    [sym_xint] = ACTIONS(2994),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2994),
    [sym__newline] = ACTIONS(2994),
  },
  [1060] = {
    [sym_block_comment] = STATE(1060),
    [sym_compiler_directive_decl] = STATE(1060),
    [sym_fsi_directive_decl] = STATE(1060),
    [sym_preproc_line] = STATE(1060),
    [aux_sym_type_argument_repeat1] = STATE(1065),
    [sym_identifier] = ACTIONS(2321),
    [anon_sym_EQ] = ACTIONS(2323),
    [anon_sym_COLON] = ACTIONS(2321),
    [anon_sym_return] = ACTIONS(2321),
    [anon_sym_do] = ACTIONS(2321),
    [anon_sym_let] = ACTIONS(2321),
    [anon_sym_let_BANG] = ACTIONS(2323),
    [anon_sym_as] = ACTIONS(2321),
    [anon_sym_LPAREN] = ACTIONS(2321),
    [anon_sym_COMMA] = ACTIONS(2323),
    [anon_sym_null] = ACTIONS(2321),
    [anon_sym_QMARK] = ACTIONS(2321),
    [anon_sym_COLON_QMARK] = ACTIONS(2321),
    [anon_sym_COLON_COLON] = ACTIONS(2323),
    [anon_sym_AMP] = ACTIONS(2321),
    [anon_sym_LBRACK] = ACTIONS(2321),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2323),
    [anon_sym_LBRACE] = ACTIONS(2321),
    [anon_sym_LT_AT] = ACTIONS(2321),
    [anon_sym_LT_AT_AT] = ACTIONS(2321),
    [anon_sym_DOT] = ACTIONS(2321),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2323),
    [anon_sym_new] = ACTIONS(2321),
    [anon_sym_with] = ACTIONS(2321),
    [anon_sym_return_BANG] = ACTIONS(2323),
    [anon_sym_yield] = ACTIONS(2321),
    [anon_sym_yield_BANG] = ACTIONS(2323),
    [anon_sym_lazy] = ACTIONS(2321),
    [anon_sym_assert] = ACTIONS(2321),
    [anon_sym_upcast] = ACTIONS(2321),
    [anon_sym_downcast] = ACTIONS(2321),
    [anon_sym_COLON_GT] = ACTIONS(2323),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2323),
    [anon_sym_for] = ACTIONS(2321),
    [anon_sym_while] = ACTIONS(2321),
    [anon_sym_if] = ACTIONS(2321),
    [anon_sym_fun] = ACTIONS(2321),
    [anon_sym_DASH_GT] = ACTIONS(2321),
    [anon_sym_try] = ACTIONS(2321),
    [anon_sym_match] = ACTIONS(2321),
    [anon_sym_match_BANG] = ACTIONS(2323),
    [anon_sym_function] = ACTIONS(2321),
    [anon_sym_LT_DASH] = ACTIONS(2321),
    [anon_sym_DOT_LBRACK] = ACTIONS(2323),
    [anon_sym_LT] = ACTIONS(2323),
    [anon_sym_use] = ACTIONS(2321),
    [anon_sym_use_BANG] = ACTIONS(2323),
    [anon_sym_do_BANG] = ACTIONS(2323),
    [anon_sym_begin] = ACTIONS(2321),
    [anon_sym_LPAREN2] = ACTIONS(2321),
    [anon_sym_STAR] = ACTIONS(2321),
    [anon_sym_LT2] = ACTIONS(2321),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2323),
    [anon_sym_or] = ACTIONS(3303),
    [aux_sym_char_token1] = ACTIONS(2323),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2321),
    [anon_sym_DQUOTE] = ACTIONS(2321),
    [anon_sym_AT_DQUOTE] = ACTIONS(2323),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2323),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2323),
    [sym_bool] = ACTIONS(2321),
    [sym_unit] = ACTIONS(2323),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2321),
    [sym_op_identifier] = ACTIONS(2321),
    [anon_sym_PLUS] = ACTIONS(2321),
    [anon_sym_DASH] = ACTIONS(2321),
    [anon_sym_PLUS_DOT] = ACTIONS(2321),
    [anon_sym_DASH_DOT] = ACTIONS(2321),
    [anon_sym_PERCENT] = ACTIONS(2321),
    [anon_sym_AMP_AMP] = ACTIONS(2321),
    [anon_sym_TILDE] = ACTIONS(2323),
    [aux_sym_prefix_op_token1] = ACTIONS(2321),
    [aux_sym_infix_op_token1] = ACTIONS(2323),
    [aux_sym_infix_op_token2] = ACTIONS(2321),
    [anon_sym_PIPE_PIPE] = ACTIONS(2321),
    [anon_sym_BANG_EQ] = ACTIONS(2321),
    [anon_sym_COLON_EQ] = ACTIONS(2323),
    [anon_sym_DOLLAR] = ACTIONS(2321),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2321),
    [sym_int] = ACTIONS(2321),
    [sym_xint] = ACTIONS(2323),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2323),
    [sym__newline] = ACTIONS(2323),
  },
  [1061] = {
    [sym_block_comment] = STATE(1061),
    [sym_compiler_directive_decl] = STATE(1061),
    [sym_fsi_directive_decl] = STATE(1061),
    [sym_preproc_line] = STATE(1061),
    [aux_sym_compound_type_repeat1] = STATE(1114),
    [sym_identifier] = ACTIONS(2407),
    [anon_sym_EQ] = ACTIONS(2409),
    [anon_sym_COLON] = ACTIONS(2407),
    [anon_sym_return] = ACTIONS(2407),
    [anon_sym_do] = ACTIONS(2407),
    [anon_sym_let] = ACTIONS(2407),
    [anon_sym_let_BANG] = ACTIONS(2409),
    [anon_sym_as] = ACTIONS(2407),
    [anon_sym_LPAREN] = ACTIONS(2407),
    [anon_sym_COMMA] = ACTIONS(2409),
    [anon_sym_null] = ACTIONS(2407),
    [anon_sym_QMARK] = ACTIONS(2407),
    [anon_sym_COLON_QMARK] = ACTIONS(2407),
    [anon_sym_COLON_COLON] = ACTIONS(2409),
    [anon_sym_AMP] = ACTIONS(2407),
    [anon_sym_LBRACK] = ACTIONS(2407),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2409),
    [anon_sym_LBRACE] = ACTIONS(2407),
    [anon_sym_LT_AT] = ACTIONS(2407),
    [anon_sym_LT_AT_AT] = ACTIONS(2407),
    [anon_sym_DOT] = ACTIONS(2407),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2409),
    [anon_sym_new] = ACTIONS(2407),
    [anon_sym_with] = ACTIONS(2407),
    [anon_sym_return_BANG] = ACTIONS(2409),
    [anon_sym_yield] = ACTIONS(2407),
    [anon_sym_yield_BANG] = ACTIONS(2409),
    [anon_sym_lazy] = ACTIONS(2407),
    [anon_sym_assert] = ACTIONS(2407),
    [anon_sym_upcast] = ACTIONS(2407),
    [anon_sym_downcast] = ACTIONS(2407),
    [anon_sym_COLON_GT] = ACTIONS(2409),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2409),
    [anon_sym_for] = ACTIONS(2407),
    [anon_sym_while] = ACTIONS(2407),
    [anon_sym_if] = ACTIONS(2407),
    [anon_sym_fun] = ACTIONS(2407),
    [anon_sym_DASH_GT] = ACTIONS(2407),
    [anon_sym_try] = ACTIONS(2407),
    [anon_sym_match] = ACTIONS(2407),
    [anon_sym_match_BANG] = ACTIONS(2409),
    [anon_sym_function] = ACTIONS(2407),
    [anon_sym_LT_DASH] = ACTIONS(2407),
    [anon_sym_DOT_LBRACK] = ACTIONS(2409),
    [anon_sym_LT] = ACTIONS(2409),
    [anon_sym_use] = ACTIONS(2407),
    [anon_sym_use_BANG] = ACTIONS(2409),
    [anon_sym_do_BANG] = ACTIONS(2409),
    [anon_sym_begin] = ACTIONS(2407),
    [anon_sym_LPAREN2] = ACTIONS(2407),
    [anon_sym_STAR] = ACTIONS(3192),
    [anon_sym_LT2] = ACTIONS(2407),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2409),
    [anon_sym_or] = ACTIONS(2407),
    [aux_sym_char_token1] = ACTIONS(2409),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2407),
    [anon_sym_DQUOTE] = ACTIONS(2407),
    [anon_sym_AT_DQUOTE] = ACTIONS(2409),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2409),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2409),
    [sym_bool] = ACTIONS(2407),
    [sym_unit] = ACTIONS(2409),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2407),
    [sym_op_identifier] = ACTIONS(2407),
    [anon_sym_PLUS] = ACTIONS(2407),
    [anon_sym_DASH] = ACTIONS(2407),
    [anon_sym_PLUS_DOT] = ACTIONS(2407),
    [anon_sym_DASH_DOT] = ACTIONS(2407),
    [anon_sym_PERCENT] = ACTIONS(2407),
    [anon_sym_AMP_AMP] = ACTIONS(2407),
    [anon_sym_TILDE] = ACTIONS(2409),
    [aux_sym_prefix_op_token1] = ACTIONS(2407),
    [aux_sym_infix_op_token1] = ACTIONS(2409),
    [aux_sym_infix_op_token2] = ACTIONS(2407),
    [anon_sym_PIPE_PIPE] = ACTIONS(2407),
    [anon_sym_BANG_EQ] = ACTIONS(2407),
    [anon_sym_COLON_EQ] = ACTIONS(2409),
    [anon_sym_DOLLAR] = ACTIONS(2407),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2407),
    [sym_int] = ACTIONS(2407),
    [sym_xint] = ACTIONS(2409),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2409),
    [sym__newline] = ACTIONS(2409),
  },
  [1062] = {
    [sym_block_comment] = STATE(1062),
    [sym_compiler_directive_decl] = STATE(1062),
    [sym_fsi_directive_decl] = STATE(1062),
    [sym_preproc_line] = STATE(1062),
    [sym_identifier] = ACTIONS(2970),
    [anon_sym_EQ] = ACTIONS(2972),
    [anon_sym_GT_RBRACK] = ACTIONS(2972),
    [anon_sym_COLON] = ACTIONS(2970),
    [anon_sym_return] = ACTIONS(2970),
    [anon_sym_do] = ACTIONS(2970),
    [anon_sym_let] = ACTIONS(2970),
    [anon_sym_let_BANG] = ACTIONS(2972),
    [anon_sym_LPAREN] = ACTIONS(2970),
    [anon_sym_COMMA] = ACTIONS(2972),
    [anon_sym_null] = ACTIONS(2970),
    [anon_sym_QMARK] = ACTIONS(2970),
    [anon_sym_COLON_QMARK] = ACTIONS(2970),
    [anon_sym_COLON_COLON] = ACTIONS(2972),
    [anon_sym_AMP] = ACTIONS(2970),
    [anon_sym_LBRACK] = ACTIONS(2970),
    [anon_sym_RBRACK] = ACTIONS(2972),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2972),
    [anon_sym_LBRACE] = ACTIONS(2970),
    [anon_sym_RBRACE] = ACTIONS(2972),
    [anon_sym_LT_AT] = ACTIONS(2970),
    [anon_sym_LT_AT_AT] = ACTIONS(2970),
    [anon_sym_DOT] = ACTIONS(2970),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2972),
    [anon_sym_new] = ACTIONS(2970),
    [anon_sym_with] = ACTIONS(2970),
    [anon_sym_return_BANG] = ACTIONS(2972),
    [anon_sym_yield] = ACTIONS(2970),
    [anon_sym_yield_BANG] = ACTIONS(2972),
    [anon_sym_lazy] = ACTIONS(2970),
    [anon_sym_assert] = ACTIONS(2970),
    [anon_sym_upcast] = ACTIONS(2970),
    [anon_sym_downcast] = ACTIONS(2970),
    [anon_sym_COLON_GT] = ACTIONS(2972),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2972),
    [anon_sym_for] = ACTIONS(2970),
    [anon_sym_to] = ACTIONS(2970),
    [anon_sym_downto] = ACTIONS(2970),
    [anon_sym_while] = ACTIONS(2970),
    [anon_sym_if] = ACTIONS(2970),
    [anon_sym_fun] = ACTIONS(2970),
    [anon_sym_try] = ACTIONS(2970),
    [anon_sym_match] = ACTIONS(2970),
    [anon_sym_match_BANG] = ACTIONS(2972),
    [anon_sym_function] = ACTIONS(2970),
    [anon_sym_LT_DASH] = ACTIONS(2970),
    [anon_sym_DOT_LBRACK] = ACTIONS(2972),
    [anon_sym_LT] = ACTIONS(2972),
    [anon_sym_use] = ACTIONS(2970),
    [anon_sym_use_BANG] = ACTIONS(2972),
    [anon_sym_do_BANG] = ACTIONS(2972),
    [anon_sym_begin] = ACTIONS(2970),
    [anon_sym_LPAREN2] = ACTIONS(2970),
    [anon_sym_DOT_DOT2] = ACTIONS(2972),
    [anon_sym_or] = ACTIONS(2970),
    [aux_sym_char_token1] = ACTIONS(2972),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2970),
    [anon_sym_DQUOTE] = ACTIONS(2970),
    [anon_sym_AT_DQUOTE] = ACTIONS(2972),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2972),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2972),
    [sym_bool] = ACTIONS(2970),
    [sym_unit] = ACTIONS(2972),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2970),
    [sym_op_identifier] = ACTIONS(2970),
    [anon_sym_PLUS] = ACTIONS(2970),
    [anon_sym_DASH] = ACTIONS(2970),
    [anon_sym_PLUS_DOT] = ACTIONS(2970),
    [anon_sym_DASH_DOT] = ACTIONS(2970),
    [anon_sym_PERCENT] = ACTIONS(2970),
    [anon_sym_AMP_AMP] = ACTIONS(2970),
    [anon_sym_TILDE] = ACTIONS(2972),
    [aux_sym_prefix_op_token1] = ACTIONS(2970),
    [aux_sym_infix_op_token1] = ACTIONS(2972),
    [aux_sym_infix_op_token2] = ACTIONS(2970),
    [anon_sym_PIPE_PIPE] = ACTIONS(2970),
    [anon_sym_BANG_EQ] = ACTIONS(2970),
    [anon_sym_COLON_EQ] = ACTIONS(2972),
    [anon_sym_DOLLAR] = ACTIONS(2970),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2970),
    [sym_int] = ACTIONS(2970),
    [sym_xint] = ACTIONS(2972),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2972),
    [sym__newline] = ACTIONS(2972),
  },
  [1063] = {
    [sym_block_comment] = STATE(1063),
    [sym_compiler_directive_decl] = STATE(1063),
    [sym_fsi_directive_decl] = STATE(1063),
    [sym_preproc_line] = STATE(1063),
    [sym_identifier] = ACTIONS(2934),
    [anon_sym_EQ] = ACTIONS(2936),
    [anon_sym_GT_RBRACK] = ACTIONS(2936),
    [anon_sym_COLON] = ACTIONS(2934),
    [anon_sym_return] = ACTIONS(2934),
    [anon_sym_do] = ACTIONS(2934),
    [anon_sym_let] = ACTIONS(2934),
    [anon_sym_let_BANG] = ACTIONS(2936),
    [anon_sym_LPAREN] = ACTIONS(2934),
    [anon_sym_COMMA] = ACTIONS(2936),
    [anon_sym_null] = ACTIONS(2934),
    [anon_sym_QMARK] = ACTIONS(2934),
    [anon_sym_COLON_QMARK] = ACTIONS(2934),
    [anon_sym_COLON_COLON] = ACTIONS(2936),
    [anon_sym_AMP] = ACTIONS(2934),
    [anon_sym_LBRACK] = ACTIONS(2934),
    [anon_sym_RBRACK] = ACTIONS(2936),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2936),
    [anon_sym_LBRACE] = ACTIONS(2934),
    [anon_sym_RBRACE] = ACTIONS(2936),
    [anon_sym_LT_AT] = ACTIONS(2934),
    [anon_sym_LT_AT_AT] = ACTIONS(2934),
    [anon_sym_DOT] = ACTIONS(2934),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2936),
    [anon_sym_new] = ACTIONS(2934),
    [anon_sym_with] = ACTIONS(2934),
    [anon_sym_return_BANG] = ACTIONS(2936),
    [anon_sym_yield] = ACTIONS(2934),
    [anon_sym_yield_BANG] = ACTIONS(2936),
    [anon_sym_lazy] = ACTIONS(2934),
    [anon_sym_assert] = ACTIONS(2934),
    [anon_sym_upcast] = ACTIONS(2934),
    [anon_sym_downcast] = ACTIONS(2934),
    [anon_sym_COLON_GT] = ACTIONS(2936),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2936),
    [anon_sym_for] = ACTIONS(2934),
    [anon_sym_to] = ACTIONS(2934),
    [anon_sym_downto] = ACTIONS(2934),
    [anon_sym_while] = ACTIONS(2934),
    [anon_sym_if] = ACTIONS(2934),
    [anon_sym_fun] = ACTIONS(2934),
    [anon_sym_try] = ACTIONS(2934),
    [anon_sym_match] = ACTIONS(2934),
    [anon_sym_match_BANG] = ACTIONS(2936),
    [anon_sym_function] = ACTIONS(2934),
    [anon_sym_LT_DASH] = ACTIONS(2934),
    [anon_sym_DOT_LBRACK] = ACTIONS(2936),
    [anon_sym_LT] = ACTIONS(2936),
    [anon_sym_use] = ACTIONS(2934),
    [anon_sym_use_BANG] = ACTIONS(2936),
    [anon_sym_do_BANG] = ACTIONS(2936),
    [anon_sym_begin] = ACTIONS(2934),
    [anon_sym_LPAREN2] = ACTIONS(2934),
    [anon_sym_DOT_DOT2] = ACTIONS(2936),
    [anon_sym_or] = ACTIONS(2934),
    [aux_sym_char_token1] = ACTIONS(2936),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2934),
    [anon_sym_DQUOTE] = ACTIONS(2934),
    [anon_sym_AT_DQUOTE] = ACTIONS(2936),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2936),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2936),
    [sym_bool] = ACTIONS(2934),
    [sym_unit] = ACTIONS(2936),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2934),
    [sym_op_identifier] = ACTIONS(2934),
    [anon_sym_PLUS] = ACTIONS(2934),
    [anon_sym_DASH] = ACTIONS(2934),
    [anon_sym_PLUS_DOT] = ACTIONS(2934),
    [anon_sym_DASH_DOT] = ACTIONS(2934),
    [anon_sym_PERCENT] = ACTIONS(2934),
    [anon_sym_AMP_AMP] = ACTIONS(2934),
    [anon_sym_TILDE] = ACTIONS(2936),
    [aux_sym_prefix_op_token1] = ACTIONS(2934),
    [aux_sym_infix_op_token1] = ACTIONS(2936),
    [aux_sym_infix_op_token2] = ACTIONS(2934),
    [anon_sym_PIPE_PIPE] = ACTIONS(2934),
    [anon_sym_BANG_EQ] = ACTIONS(2934),
    [anon_sym_COLON_EQ] = ACTIONS(2936),
    [anon_sym_DOLLAR] = ACTIONS(2934),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2934),
    [sym_int] = ACTIONS(2934),
    [sym_xint] = ACTIONS(2936),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2936),
    [sym__newline] = ACTIONS(2936),
  },
  [1064] = {
    [sym_block_comment] = STATE(1064),
    [sym_compiler_directive_decl] = STATE(1064),
    [sym_fsi_directive_decl] = STATE(1064),
    [sym_preproc_line] = STATE(1064),
    [sym_identifier] = ACTIONS(2996),
    [anon_sym_EQ] = ACTIONS(2998),
    [anon_sym_GT_RBRACK] = ACTIONS(2998),
    [anon_sym_COLON] = ACTIONS(2996),
    [anon_sym_return] = ACTIONS(2996),
    [anon_sym_do] = ACTIONS(2996),
    [anon_sym_let] = ACTIONS(2996),
    [anon_sym_let_BANG] = ACTIONS(2998),
    [anon_sym_LPAREN] = ACTIONS(2996),
    [anon_sym_COMMA] = ACTIONS(2998),
    [anon_sym_null] = ACTIONS(2996),
    [anon_sym_QMARK] = ACTIONS(2996),
    [anon_sym_COLON_QMARK] = ACTIONS(2996),
    [anon_sym_COLON_COLON] = ACTIONS(2998),
    [anon_sym_AMP] = ACTIONS(2996),
    [anon_sym_LBRACK] = ACTIONS(2996),
    [anon_sym_RBRACK] = ACTIONS(2998),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2998),
    [anon_sym_LBRACE] = ACTIONS(2996),
    [anon_sym_RBRACE] = ACTIONS(2998),
    [anon_sym_LT_AT] = ACTIONS(2996),
    [anon_sym_LT_AT_AT] = ACTIONS(2996),
    [anon_sym_DOT] = ACTIONS(2996),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2998),
    [anon_sym_new] = ACTIONS(2996),
    [anon_sym_with] = ACTIONS(2996),
    [anon_sym_return_BANG] = ACTIONS(2998),
    [anon_sym_yield] = ACTIONS(2996),
    [anon_sym_yield_BANG] = ACTIONS(2998),
    [anon_sym_lazy] = ACTIONS(2996),
    [anon_sym_assert] = ACTIONS(2996),
    [anon_sym_upcast] = ACTIONS(2996),
    [anon_sym_downcast] = ACTIONS(2996),
    [anon_sym_COLON_GT] = ACTIONS(2998),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2998),
    [anon_sym_for] = ACTIONS(2996),
    [anon_sym_to] = ACTIONS(2996),
    [anon_sym_downto] = ACTIONS(2996),
    [anon_sym_while] = ACTIONS(2996),
    [anon_sym_if] = ACTIONS(2996),
    [anon_sym_fun] = ACTIONS(2996),
    [anon_sym_try] = ACTIONS(2996),
    [anon_sym_match] = ACTIONS(2996),
    [anon_sym_match_BANG] = ACTIONS(2998),
    [anon_sym_function] = ACTIONS(2996),
    [anon_sym_LT_DASH] = ACTIONS(2996),
    [anon_sym_DOT_LBRACK] = ACTIONS(2998),
    [anon_sym_LT] = ACTIONS(2998),
    [anon_sym_use] = ACTIONS(2996),
    [anon_sym_use_BANG] = ACTIONS(2998),
    [anon_sym_do_BANG] = ACTIONS(2998),
    [anon_sym_begin] = ACTIONS(2996),
    [anon_sym_LPAREN2] = ACTIONS(2996),
    [anon_sym_DOT_DOT2] = ACTIONS(2998),
    [anon_sym_or] = ACTIONS(2996),
    [aux_sym_char_token1] = ACTIONS(2998),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2996),
    [anon_sym_DQUOTE] = ACTIONS(2996),
    [anon_sym_AT_DQUOTE] = ACTIONS(2998),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2998),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2998),
    [sym_bool] = ACTIONS(2996),
    [sym_unit] = ACTIONS(2998),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2996),
    [sym_op_identifier] = ACTIONS(2996),
    [anon_sym_PLUS] = ACTIONS(2996),
    [anon_sym_DASH] = ACTIONS(2996),
    [anon_sym_PLUS_DOT] = ACTIONS(2996),
    [anon_sym_DASH_DOT] = ACTIONS(2996),
    [anon_sym_PERCENT] = ACTIONS(2996),
    [anon_sym_AMP_AMP] = ACTIONS(2996),
    [anon_sym_TILDE] = ACTIONS(2998),
    [aux_sym_prefix_op_token1] = ACTIONS(2996),
    [aux_sym_infix_op_token1] = ACTIONS(2998),
    [aux_sym_infix_op_token2] = ACTIONS(2996),
    [anon_sym_PIPE_PIPE] = ACTIONS(2996),
    [anon_sym_BANG_EQ] = ACTIONS(2996),
    [anon_sym_COLON_EQ] = ACTIONS(2998),
    [anon_sym_DOLLAR] = ACTIONS(2996),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2996),
    [sym_int] = ACTIONS(2996),
    [sym_xint] = ACTIONS(2998),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2998),
    [sym__newline] = ACTIONS(2998),
  },
  [1065] = {
    [sym_block_comment] = STATE(1065),
    [sym_compiler_directive_decl] = STATE(1065),
    [sym_fsi_directive_decl] = STATE(1065),
    [sym_preproc_line] = STATE(1065),
    [aux_sym_type_argument_repeat1] = STATE(1057),
    [sym_identifier] = ACTIONS(2328),
    [anon_sym_EQ] = ACTIONS(2330),
    [anon_sym_COLON] = ACTIONS(2328),
    [anon_sym_return] = ACTIONS(2328),
    [anon_sym_do] = ACTIONS(2328),
    [anon_sym_let] = ACTIONS(2328),
    [anon_sym_let_BANG] = ACTIONS(2330),
    [anon_sym_as] = ACTIONS(2328),
    [anon_sym_LPAREN] = ACTIONS(2328),
    [anon_sym_COMMA] = ACTIONS(2330),
    [anon_sym_null] = ACTIONS(2328),
    [anon_sym_QMARK] = ACTIONS(2328),
    [anon_sym_COLON_QMARK] = ACTIONS(2328),
    [anon_sym_COLON_COLON] = ACTIONS(2330),
    [anon_sym_AMP] = ACTIONS(2328),
    [anon_sym_LBRACK] = ACTIONS(2328),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2330),
    [anon_sym_LBRACE] = ACTIONS(2328),
    [anon_sym_LT_AT] = ACTIONS(2328),
    [anon_sym_LT_AT_AT] = ACTIONS(2328),
    [anon_sym_DOT] = ACTIONS(2328),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2330),
    [anon_sym_new] = ACTIONS(2328),
    [anon_sym_with] = ACTIONS(2328),
    [anon_sym_return_BANG] = ACTIONS(2330),
    [anon_sym_yield] = ACTIONS(2328),
    [anon_sym_yield_BANG] = ACTIONS(2330),
    [anon_sym_lazy] = ACTIONS(2328),
    [anon_sym_assert] = ACTIONS(2328),
    [anon_sym_upcast] = ACTIONS(2328),
    [anon_sym_downcast] = ACTIONS(2328),
    [anon_sym_COLON_GT] = ACTIONS(2330),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2330),
    [anon_sym_for] = ACTIONS(2328),
    [anon_sym_while] = ACTIONS(2328),
    [anon_sym_if] = ACTIONS(2328),
    [anon_sym_fun] = ACTIONS(2328),
    [anon_sym_DASH_GT] = ACTIONS(2328),
    [anon_sym_try] = ACTIONS(2328),
    [anon_sym_match] = ACTIONS(2328),
    [anon_sym_match_BANG] = ACTIONS(2330),
    [anon_sym_function] = ACTIONS(2328),
    [anon_sym_LT_DASH] = ACTIONS(2328),
    [anon_sym_DOT_LBRACK] = ACTIONS(2330),
    [anon_sym_LT] = ACTIONS(2330),
    [anon_sym_use] = ACTIONS(2328),
    [anon_sym_use_BANG] = ACTIONS(2330),
    [anon_sym_do_BANG] = ACTIONS(2330),
    [anon_sym_begin] = ACTIONS(2328),
    [anon_sym_LPAREN2] = ACTIONS(2328),
    [anon_sym_STAR] = ACTIONS(2328),
    [anon_sym_LT2] = ACTIONS(2328),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2330),
    [anon_sym_or] = ACTIONS(2328),
    [aux_sym_char_token1] = ACTIONS(2330),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2328),
    [anon_sym_DQUOTE] = ACTIONS(2328),
    [anon_sym_AT_DQUOTE] = ACTIONS(2330),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2330),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2330),
    [sym_bool] = ACTIONS(2328),
    [sym_unit] = ACTIONS(2330),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2328),
    [sym_op_identifier] = ACTIONS(2328),
    [anon_sym_PLUS] = ACTIONS(2328),
    [anon_sym_DASH] = ACTIONS(2328),
    [anon_sym_PLUS_DOT] = ACTIONS(2328),
    [anon_sym_DASH_DOT] = ACTIONS(2328),
    [anon_sym_PERCENT] = ACTIONS(2328),
    [anon_sym_AMP_AMP] = ACTIONS(2328),
    [anon_sym_TILDE] = ACTIONS(2330),
    [aux_sym_prefix_op_token1] = ACTIONS(2328),
    [aux_sym_infix_op_token1] = ACTIONS(2330),
    [aux_sym_infix_op_token2] = ACTIONS(2328),
    [anon_sym_PIPE_PIPE] = ACTIONS(2328),
    [anon_sym_BANG_EQ] = ACTIONS(2328),
    [anon_sym_COLON_EQ] = ACTIONS(2330),
    [anon_sym_DOLLAR] = ACTIONS(2328),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2328),
    [sym_int] = ACTIONS(2328),
    [sym_xint] = ACTIONS(2330),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2330),
    [sym__newline] = ACTIONS(2330),
  },
  [1066] = {
    [sym_block_comment] = STATE(1066),
    [sym_compiler_directive_decl] = STATE(1066),
    [sym_fsi_directive_decl] = STATE(1066),
    [sym_preproc_line] = STATE(1066),
    [sym_identifier] = ACTIONS(2321),
    [anon_sym_EQ] = ACTIONS(2323),
    [anon_sym_COLON] = ACTIONS(2321),
    [anon_sym_return] = ACTIONS(2321),
    [anon_sym_do] = ACTIONS(2321),
    [anon_sym_let] = ACTIONS(2321),
    [anon_sym_let_BANG] = ACTIONS(2323),
    [anon_sym_as] = ACTIONS(2321),
    [anon_sym_LPAREN] = ACTIONS(2321),
    [anon_sym_COMMA] = ACTIONS(2323),
    [anon_sym_null] = ACTIONS(2321),
    [anon_sym_QMARK] = ACTIONS(2321),
    [anon_sym_COLON_QMARK] = ACTIONS(2321),
    [anon_sym_COLON_COLON] = ACTIONS(2323),
    [anon_sym_AMP] = ACTIONS(2321),
    [anon_sym_LBRACK] = ACTIONS(2321),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2323),
    [anon_sym_LBRACE] = ACTIONS(2321),
    [anon_sym_LT_AT] = ACTIONS(2321),
    [anon_sym_LT_AT_AT] = ACTIONS(2321),
    [anon_sym_DOT] = ACTIONS(2321),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2323),
    [anon_sym_new] = ACTIONS(2321),
    [anon_sym_with] = ACTIONS(2321),
    [anon_sym_return_BANG] = ACTIONS(2323),
    [anon_sym_yield] = ACTIONS(2321),
    [anon_sym_yield_BANG] = ACTIONS(2323),
    [anon_sym_lazy] = ACTIONS(2321),
    [anon_sym_assert] = ACTIONS(2321),
    [anon_sym_upcast] = ACTIONS(2321),
    [anon_sym_downcast] = ACTIONS(2321),
    [anon_sym_COLON_GT] = ACTIONS(2323),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2323),
    [anon_sym_for] = ACTIONS(2321),
    [anon_sym_while] = ACTIONS(2321),
    [anon_sym_if] = ACTIONS(2321),
    [anon_sym_fun] = ACTIONS(2321),
    [anon_sym_DASH_GT] = ACTIONS(2321),
    [anon_sym_try] = ACTIONS(2321),
    [anon_sym_match] = ACTIONS(2321),
    [anon_sym_match_BANG] = ACTIONS(2323),
    [anon_sym_function] = ACTIONS(2321),
    [anon_sym_LT_DASH] = ACTIONS(2321),
    [anon_sym_DOT_LBRACK] = ACTIONS(2323),
    [anon_sym_LT] = ACTIONS(2323),
    [anon_sym_use] = ACTIONS(2321),
    [anon_sym_use_BANG] = ACTIONS(2323),
    [anon_sym_do_BANG] = ACTIONS(2323),
    [anon_sym_begin] = ACTIONS(2321),
    [anon_sym_LPAREN2] = ACTIONS(2321),
    [anon_sym_STAR] = ACTIONS(2321),
    [anon_sym_LT2] = ACTIONS(2321),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2323),
    [anon_sym_or] = ACTIONS(2321),
    [aux_sym_char_token1] = ACTIONS(2323),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2321),
    [anon_sym_DQUOTE] = ACTIONS(2321),
    [anon_sym_AT_DQUOTE] = ACTIONS(2323),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2323),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2323),
    [sym_bool] = ACTIONS(2321),
    [sym_unit] = ACTIONS(2323),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2321),
    [sym_op_identifier] = ACTIONS(2321),
    [anon_sym_PLUS] = ACTIONS(2321),
    [anon_sym_DASH] = ACTIONS(2321),
    [anon_sym_PLUS_DOT] = ACTIONS(2321),
    [anon_sym_DASH_DOT] = ACTIONS(2321),
    [anon_sym_PERCENT] = ACTIONS(2321),
    [anon_sym_AMP_AMP] = ACTIONS(2321),
    [anon_sym_TILDE] = ACTIONS(2323),
    [aux_sym_prefix_op_token1] = ACTIONS(2321),
    [aux_sym_infix_op_token1] = ACTIONS(2323),
    [aux_sym_infix_op_token2] = ACTIONS(2321),
    [anon_sym_PIPE_PIPE] = ACTIONS(2321),
    [anon_sym_BANG_EQ] = ACTIONS(2321),
    [anon_sym_COLON_EQ] = ACTIONS(2323),
    [anon_sym_DOLLAR] = ACTIONS(2321),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2321),
    [sym_int] = ACTIONS(2321),
    [sym_xint] = ACTIONS(2323),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2323),
    [sym__newline] = ACTIONS(2323),
    [sym__dedent] = ACTIONS(2323),
  },
  [1067] = {
    [sym_block_comment] = STATE(1067),
    [sym_compiler_directive_decl] = STATE(1067),
    [sym_fsi_directive_decl] = STATE(1067),
    [sym_preproc_line] = STATE(1067),
    [aux_sym_long_identifier_repeat1] = STATE(1167),
    [sym_identifier] = ACTIONS(2312),
    [anon_sym_EQ] = ACTIONS(2314),
    [anon_sym_COLON] = ACTIONS(2312),
    [anon_sym_return] = ACTIONS(2312),
    [anon_sym_do] = ACTIONS(2312),
    [anon_sym_let] = ACTIONS(2312),
    [anon_sym_let_BANG] = ACTIONS(2314),
    [anon_sym_as] = ACTIONS(2312),
    [anon_sym_LPAREN] = ACTIONS(2312),
    [anon_sym_COMMA] = ACTIONS(2314),
    [anon_sym_null] = ACTIONS(2312),
    [anon_sym_QMARK] = ACTIONS(2312),
    [anon_sym_COLON_QMARK] = ACTIONS(2312),
    [anon_sym_COLON_COLON] = ACTIONS(2314),
    [anon_sym_AMP] = ACTIONS(2312),
    [anon_sym_LBRACK] = ACTIONS(2312),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2314),
    [anon_sym_LBRACE] = ACTIONS(2312),
    [anon_sym_LT_AT] = ACTIONS(2312),
    [anon_sym_LT_AT_AT] = ACTIONS(2312),
    [anon_sym_DOT] = ACTIONS(3306),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2314),
    [anon_sym_new] = ACTIONS(2312),
    [anon_sym_with] = ACTIONS(2312),
    [anon_sym_return_BANG] = ACTIONS(2314),
    [anon_sym_yield] = ACTIONS(2312),
    [anon_sym_yield_BANG] = ACTIONS(2314),
    [anon_sym_lazy] = ACTIONS(2312),
    [anon_sym_assert] = ACTIONS(2312),
    [anon_sym_upcast] = ACTIONS(2312),
    [anon_sym_downcast] = ACTIONS(2312),
    [anon_sym_COLON_GT] = ACTIONS(2314),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2314),
    [anon_sym_for] = ACTIONS(2312),
    [anon_sym_while] = ACTIONS(2312),
    [anon_sym_if] = ACTIONS(2312),
    [anon_sym_fun] = ACTIONS(2312),
    [anon_sym_DASH_GT] = ACTIONS(2312),
    [anon_sym_try] = ACTIONS(2312),
    [anon_sym_match] = ACTIONS(2312),
    [anon_sym_match_BANG] = ACTIONS(2314),
    [anon_sym_function] = ACTIONS(2312),
    [anon_sym_LT_DASH] = ACTIONS(2312),
    [anon_sym_DOT_LBRACK] = ACTIONS(2314),
    [anon_sym_LT] = ACTIONS(2314),
    [anon_sym_use] = ACTIONS(2312),
    [anon_sym_use_BANG] = ACTIONS(2314),
    [anon_sym_do_BANG] = ACTIONS(2314),
    [anon_sym_begin] = ACTIONS(2312),
    [anon_sym_LPAREN2] = ACTIONS(2312),
    [anon_sym_STAR] = ACTIONS(2312),
    [anon_sym_LT2] = ACTIONS(2312),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2314),
    [anon_sym_or] = ACTIONS(2312),
    [aux_sym_char_token1] = ACTIONS(2314),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2312),
    [anon_sym_DQUOTE] = ACTIONS(2312),
    [anon_sym_AT_DQUOTE] = ACTIONS(2314),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2314),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2314),
    [sym_bool] = ACTIONS(2312),
    [sym_unit] = ACTIONS(2314),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2312),
    [sym_op_identifier] = ACTIONS(2312),
    [anon_sym_PLUS] = ACTIONS(2312),
    [anon_sym_DASH] = ACTIONS(2312),
    [anon_sym_PLUS_DOT] = ACTIONS(2312),
    [anon_sym_DASH_DOT] = ACTIONS(2312),
    [anon_sym_PERCENT] = ACTIONS(2312),
    [anon_sym_AMP_AMP] = ACTIONS(2312),
    [anon_sym_TILDE] = ACTIONS(2314),
    [aux_sym_prefix_op_token1] = ACTIONS(2312),
    [aux_sym_infix_op_token1] = ACTIONS(2314),
    [aux_sym_infix_op_token2] = ACTIONS(2312),
    [anon_sym_PIPE_PIPE] = ACTIONS(2312),
    [anon_sym_BANG_EQ] = ACTIONS(2312),
    [anon_sym_COLON_EQ] = ACTIONS(2314),
    [anon_sym_DOLLAR] = ACTIONS(2312),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2312),
    [sym_int] = ACTIONS(2312),
    [sym_xint] = ACTIONS(2314),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2314),
    [sym__newline] = ACTIONS(2314),
  },
  [1068] = {
    [sym_block_comment] = STATE(1068),
    [sym_compiler_directive_decl] = STATE(1068),
    [sym_fsi_directive_decl] = STATE(1068),
    [sym_preproc_line] = STATE(1068),
    [sym_identifier] = ACTIONS(3139),
    [anon_sym_EQ] = ACTIONS(3141),
    [anon_sym_GT_RBRACK] = ACTIONS(3141),
    [anon_sym_COLON] = ACTIONS(3139),
    [anon_sym_return] = ACTIONS(3139),
    [anon_sym_do] = ACTIONS(3139),
    [anon_sym_let] = ACTIONS(3139),
    [anon_sym_let_BANG] = ACTIONS(3141),
    [anon_sym_LPAREN] = ACTIONS(3139),
    [anon_sym_COMMA] = ACTIONS(3141),
    [anon_sym_null] = ACTIONS(3139),
    [anon_sym_QMARK] = ACTIONS(3139),
    [anon_sym_COLON_QMARK] = ACTIONS(3139),
    [anon_sym_COLON_COLON] = ACTIONS(3141),
    [anon_sym_AMP] = ACTIONS(3139),
    [anon_sym_LBRACK] = ACTIONS(3139),
    [anon_sym_RBRACK] = ACTIONS(3141),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3141),
    [anon_sym_LBRACE] = ACTIONS(3139),
    [anon_sym_RBRACE] = ACTIONS(3141),
    [anon_sym_LT_AT] = ACTIONS(3139),
    [anon_sym_LT_AT_AT] = ACTIONS(3139),
    [anon_sym_DOT] = ACTIONS(3139),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3141),
    [anon_sym_new] = ACTIONS(3139),
    [anon_sym_with] = ACTIONS(3139),
    [anon_sym_return_BANG] = ACTIONS(3141),
    [anon_sym_yield] = ACTIONS(3139),
    [anon_sym_yield_BANG] = ACTIONS(3141),
    [anon_sym_lazy] = ACTIONS(3139),
    [anon_sym_assert] = ACTIONS(3139),
    [anon_sym_upcast] = ACTIONS(3139),
    [anon_sym_downcast] = ACTIONS(3139),
    [anon_sym_COLON_GT] = ACTIONS(3141),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3141),
    [anon_sym_for] = ACTIONS(3139),
    [anon_sym_to] = ACTIONS(3139),
    [anon_sym_downto] = ACTIONS(3139),
    [anon_sym_while] = ACTIONS(3139),
    [anon_sym_if] = ACTIONS(3139),
    [anon_sym_fun] = ACTIONS(3139),
    [anon_sym_try] = ACTIONS(3139),
    [anon_sym_match] = ACTIONS(3139),
    [anon_sym_match_BANG] = ACTIONS(3141),
    [anon_sym_function] = ACTIONS(3139),
    [anon_sym_LT_DASH] = ACTIONS(3139),
    [anon_sym_DOT_LBRACK] = ACTIONS(3141),
    [anon_sym_LT] = ACTIONS(3141),
    [anon_sym_use] = ACTIONS(3139),
    [anon_sym_use_BANG] = ACTIONS(3141),
    [anon_sym_do_BANG] = ACTIONS(3141),
    [anon_sym_begin] = ACTIONS(3139),
    [anon_sym_LPAREN2] = ACTIONS(3139),
    [anon_sym_DOT_DOT2] = ACTIONS(3141),
    [anon_sym_or] = ACTIONS(3139),
    [aux_sym_char_token1] = ACTIONS(3141),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3139),
    [anon_sym_DQUOTE] = ACTIONS(3139),
    [anon_sym_AT_DQUOTE] = ACTIONS(3141),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3141),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3141),
    [sym_bool] = ACTIONS(3139),
    [sym_unit] = ACTIONS(3141),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3139),
    [sym_op_identifier] = ACTIONS(3139),
    [anon_sym_PLUS] = ACTIONS(3139),
    [anon_sym_DASH] = ACTIONS(3139),
    [anon_sym_PLUS_DOT] = ACTIONS(3139),
    [anon_sym_DASH_DOT] = ACTIONS(3139),
    [anon_sym_PERCENT] = ACTIONS(3139),
    [anon_sym_AMP_AMP] = ACTIONS(3139),
    [anon_sym_TILDE] = ACTIONS(3141),
    [aux_sym_prefix_op_token1] = ACTIONS(3139),
    [aux_sym_infix_op_token1] = ACTIONS(3141),
    [aux_sym_infix_op_token2] = ACTIONS(3139),
    [anon_sym_PIPE_PIPE] = ACTIONS(3139),
    [anon_sym_BANG_EQ] = ACTIONS(3139),
    [anon_sym_COLON_EQ] = ACTIONS(3141),
    [anon_sym_DOLLAR] = ACTIONS(3139),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3139),
    [sym_int] = ACTIONS(3139),
    [sym_xint] = ACTIONS(3141),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3141),
    [sym__newline] = ACTIONS(3141),
  },
  [1069] = {
    [sym_block_comment] = STATE(1069),
    [sym_compiler_directive_decl] = STATE(1069),
    [sym_fsi_directive_decl] = STATE(1069),
    [sym_preproc_line] = STATE(1069),
    [aux_sym_sequential_expression_repeat1] = STATE(1117),
    [sym_identifier] = ACTIONS(2847),
    [anon_sym_EQ] = ACTIONS(2849),
    [anon_sym_GT_RBRACK] = ACTIONS(2849),
    [anon_sym_COLON] = ACTIONS(2847),
    [anon_sym_return] = ACTIONS(2847),
    [anon_sym_do] = ACTIONS(2847),
    [anon_sym_let] = ACTIONS(2847),
    [anon_sym_let_BANG] = ACTIONS(2849),
    [anon_sym_LPAREN] = ACTIONS(2847),
    [anon_sym_COMMA] = ACTIONS(2849),
    [anon_sym_null] = ACTIONS(2847),
    [anon_sym_QMARK] = ACTIONS(2847),
    [anon_sym_COLON_QMARK] = ACTIONS(2847),
    [anon_sym_COLON_COLON] = ACTIONS(2849),
    [anon_sym_AMP] = ACTIONS(2847),
    [anon_sym_LBRACK] = ACTIONS(2847),
    [anon_sym_RBRACK] = ACTIONS(2849),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2849),
    [anon_sym_LBRACE] = ACTIONS(2847),
    [anon_sym_RBRACE] = ACTIONS(2849),
    [anon_sym_LT_AT] = ACTIONS(2847),
    [anon_sym_LT_AT_AT] = ACTIONS(2847),
    [anon_sym_DOT] = ACTIONS(2847),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2849),
    [anon_sym_new] = ACTIONS(2847),
    [anon_sym_with] = ACTIONS(2847),
    [anon_sym_return_BANG] = ACTIONS(2849),
    [anon_sym_yield] = ACTIONS(2847),
    [anon_sym_yield_BANG] = ACTIONS(2849),
    [anon_sym_lazy] = ACTIONS(2847),
    [anon_sym_assert] = ACTIONS(2847),
    [anon_sym_upcast] = ACTIONS(2847),
    [anon_sym_downcast] = ACTIONS(2847),
    [anon_sym_COLON_GT] = ACTIONS(2849),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2849),
    [anon_sym_for] = ACTIONS(2847),
    [anon_sym_to] = ACTIONS(2847),
    [anon_sym_downto] = ACTIONS(2847),
    [anon_sym_while] = ACTIONS(2847),
    [anon_sym_if] = ACTIONS(2847),
    [anon_sym_fun] = ACTIONS(2847),
    [anon_sym_try] = ACTIONS(2847),
    [anon_sym_match] = ACTIONS(2847),
    [anon_sym_match_BANG] = ACTIONS(2849),
    [anon_sym_function] = ACTIONS(2847),
    [anon_sym_LT_DASH] = ACTIONS(2847),
    [anon_sym_DOT_LBRACK] = ACTIONS(2849),
    [anon_sym_LT] = ACTIONS(2849),
    [anon_sym_use] = ACTIONS(2847),
    [anon_sym_use_BANG] = ACTIONS(2849),
    [anon_sym_do_BANG] = ACTIONS(2849),
    [anon_sym_begin] = ACTIONS(2847),
    [anon_sym_LPAREN2] = ACTIONS(2847),
    [anon_sym_or] = ACTIONS(2847),
    [aux_sym_char_token1] = ACTIONS(2849),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2847),
    [anon_sym_DQUOTE] = ACTIONS(2847),
    [anon_sym_AT_DQUOTE] = ACTIONS(2849),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2849),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2849),
    [sym_bool] = ACTIONS(2847),
    [sym_unit] = ACTIONS(2849),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2847),
    [sym_op_identifier] = ACTIONS(2847),
    [anon_sym_PLUS] = ACTIONS(2847),
    [anon_sym_DASH] = ACTIONS(2847),
    [anon_sym_PLUS_DOT] = ACTIONS(2847),
    [anon_sym_DASH_DOT] = ACTIONS(2847),
    [anon_sym_PERCENT] = ACTIONS(2847),
    [anon_sym_AMP_AMP] = ACTIONS(2847),
    [anon_sym_TILDE] = ACTIONS(2849),
    [aux_sym_prefix_op_token1] = ACTIONS(2847),
    [aux_sym_infix_op_token1] = ACTIONS(2849),
    [aux_sym_infix_op_token2] = ACTIONS(2847),
    [anon_sym_PIPE_PIPE] = ACTIONS(2847),
    [anon_sym_BANG_EQ] = ACTIONS(2847),
    [anon_sym_COLON_EQ] = ACTIONS(2849),
    [anon_sym_DOLLAR] = ACTIONS(2847),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2847),
    [sym_int] = ACTIONS(2847),
    [sym_xint] = ACTIONS(2849),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2849),
    [sym__newline] = ACTIONS(2849),
  },
  [1070] = {
    [sym_block_comment] = STATE(1070),
    [sym_compiler_directive_decl] = STATE(1070),
    [sym_fsi_directive_decl] = STATE(1070),
    [sym_preproc_line] = STATE(1070),
    [sym_identifier] = ACTIONS(2462),
    [anon_sym_EQ] = ACTIONS(2464),
    [anon_sym_COLON] = ACTIONS(2462),
    [anon_sym_return] = ACTIONS(2462),
    [anon_sym_do] = ACTIONS(2462),
    [anon_sym_let] = ACTIONS(2462),
    [anon_sym_let_BANG] = ACTIONS(2464),
    [anon_sym_as] = ACTIONS(2462),
    [anon_sym_LPAREN] = ACTIONS(2462),
    [anon_sym_COMMA] = ACTIONS(2464),
    [anon_sym_null] = ACTIONS(2462),
    [anon_sym_QMARK] = ACTIONS(2462),
    [anon_sym_COLON_QMARK] = ACTIONS(2462),
    [anon_sym_COLON_COLON] = ACTIONS(2464),
    [anon_sym_AMP] = ACTIONS(2462),
    [anon_sym_LBRACK] = ACTIONS(2462),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2464),
    [anon_sym_LBRACE] = ACTIONS(2462),
    [anon_sym_LT_AT] = ACTIONS(2462),
    [anon_sym_LT_AT_AT] = ACTIONS(2462),
    [anon_sym_DOT] = ACTIONS(2462),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2464),
    [anon_sym_new] = ACTIONS(2462),
    [anon_sym_with] = ACTIONS(2462),
    [anon_sym_return_BANG] = ACTIONS(2464),
    [anon_sym_yield] = ACTIONS(2462),
    [anon_sym_yield_BANG] = ACTIONS(2464),
    [anon_sym_lazy] = ACTIONS(2462),
    [anon_sym_assert] = ACTIONS(2462),
    [anon_sym_upcast] = ACTIONS(2462),
    [anon_sym_downcast] = ACTIONS(2462),
    [anon_sym_COLON_GT] = ACTIONS(2464),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2464),
    [anon_sym_for] = ACTIONS(2462),
    [anon_sym_while] = ACTIONS(2462),
    [anon_sym_if] = ACTIONS(2462),
    [anon_sym_fun] = ACTIONS(2462),
    [anon_sym_DASH_GT] = ACTIONS(2462),
    [anon_sym_try] = ACTIONS(2462),
    [anon_sym_match] = ACTIONS(2462),
    [anon_sym_match_BANG] = ACTIONS(2464),
    [anon_sym_function] = ACTIONS(2462),
    [anon_sym_LT_DASH] = ACTIONS(2462),
    [anon_sym_DOT_LBRACK] = ACTIONS(2464),
    [anon_sym_LT] = ACTIONS(2464),
    [anon_sym_use] = ACTIONS(2462),
    [anon_sym_use_BANG] = ACTIONS(2464),
    [anon_sym_do_BANG] = ACTIONS(2464),
    [anon_sym_begin] = ACTIONS(2462),
    [anon_sym_LPAREN2] = ACTIONS(2462),
    [anon_sym_STAR] = ACTIONS(2462),
    [anon_sym_LT2] = ACTIONS(2462),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2464),
    [anon_sym_or] = ACTIONS(2462),
    [aux_sym_char_token1] = ACTIONS(2464),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2462),
    [anon_sym_DQUOTE] = ACTIONS(2462),
    [anon_sym_AT_DQUOTE] = ACTIONS(2464),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2464),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2464),
    [sym_bool] = ACTIONS(2462),
    [sym_unit] = ACTIONS(2464),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2462),
    [sym_op_identifier] = ACTIONS(2462),
    [anon_sym_PLUS] = ACTIONS(2462),
    [anon_sym_DASH] = ACTIONS(2462),
    [anon_sym_PLUS_DOT] = ACTIONS(2462),
    [anon_sym_DASH_DOT] = ACTIONS(2462),
    [anon_sym_PERCENT] = ACTIONS(2462),
    [anon_sym_AMP_AMP] = ACTIONS(2462),
    [anon_sym_TILDE] = ACTIONS(2464),
    [aux_sym_prefix_op_token1] = ACTIONS(2462),
    [aux_sym_infix_op_token1] = ACTIONS(2464),
    [aux_sym_infix_op_token2] = ACTIONS(2462),
    [anon_sym_PIPE_PIPE] = ACTIONS(2462),
    [anon_sym_BANG_EQ] = ACTIONS(2462),
    [anon_sym_COLON_EQ] = ACTIONS(2464),
    [anon_sym_DOLLAR] = ACTIONS(2462),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2462),
    [sym_int] = ACTIONS(2462),
    [sym_xint] = ACTIONS(2464),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2464),
    [sym__newline] = ACTIONS(2464),
    [sym__dedent] = ACTIONS(2464),
  },
  [1071] = {
    [sym_block_comment] = STATE(1071),
    [sym_compiler_directive_decl] = STATE(1071),
    [sym_fsi_directive_decl] = STATE(1071),
    [sym_preproc_line] = STATE(1071),
    [sym_identifier] = ACTIONS(2506),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_COLON] = ACTIONS(2506),
    [anon_sym_return] = ACTIONS(2506),
    [anon_sym_do] = ACTIONS(2506),
    [anon_sym_let] = ACTIONS(2506),
    [anon_sym_let_BANG] = ACTIONS(2508),
    [anon_sym_as] = ACTIONS(2506),
    [anon_sym_LPAREN] = ACTIONS(2506),
    [anon_sym_COMMA] = ACTIONS(2508),
    [anon_sym_null] = ACTIONS(2506),
    [anon_sym_QMARK] = ACTIONS(2506),
    [anon_sym_COLON_QMARK] = ACTIONS(2506),
    [anon_sym_COLON_COLON] = ACTIONS(2508),
    [anon_sym_AMP] = ACTIONS(2506),
    [anon_sym_LBRACK] = ACTIONS(2506),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2508),
    [anon_sym_LBRACE] = ACTIONS(2506),
    [anon_sym_LT_AT] = ACTIONS(2506),
    [anon_sym_LT_AT_AT] = ACTIONS(2506),
    [anon_sym_DOT] = ACTIONS(2506),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2508),
    [anon_sym_new] = ACTIONS(2506),
    [anon_sym_with] = ACTIONS(2506),
    [anon_sym_return_BANG] = ACTIONS(2508),
    [anon_sym_yield] = ACTIONS(2506),
    [anon_sym_yield_BANG] = ACTIONS(2508),
    [anon_sym_lazy] = ACTIONS(2506),
    [anon_sym_assert] = ACTIONS(2506),
    [anon_sym_upcast] = ACTIONS(2506),
    [anon_sym_downcast] = ACTIONS(2506),
    [anon_sym_COLON_GT] = ACTIONS(2508),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2508),
    [anon_sym_for] = ACTIONS(2506),
    [anon_sym_while] = ACTIONS(2506),
    [anon_sym_if] = ACTIONS(2506),
    [anon_sym_fun] = ACTIONS(2506),
    [anon_sym_DASH_GT] = ACTIONS(2506),
    [anon_sym_try] = ACTIONS(2506),
    [anon_sym_match] = ACTIONS(2506),
    [anon_sym_match_BANG] = ACTIONS(2508),
    [anon_sym_function] = ACTIONS(2506),
    [anon_sym_LT_DASH] = ACTIONS(2506),
    [anon_sym_DOT_LBRACK] = ACTIONS(2508),
    [anon_sym_LT] = ACTIONS(2508),
    [anon_sym_use] = ACTIONS(2506),
    [anon_sym_use_BANG] = ACTIONS(2508),
    [anon_sym_do_BANG] = ACTIONS(2508),
    [anon_sym_begin] = ACTIONS(2506),
    [anon_sym_LPAREN2] = ACTIONS(2506),
    [anon_sym_STAR] = ACTIONS(2506),
    [anon_sym_LT2] = ACTIONS(2506),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2508),
    [anon_sym_or] = ACTIONS(2506),
    [aux_sym_char_token1] = ACTIONS(2508),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2506),
    [anon_sym_DQUOTE] = ACTIONS(2506),
    [anon_sym_AT_DQUOTE] = ACTIONS(2508),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2508),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2508),
    [sym_bool] = ACTIONS(2506),
    [sym_unit] = ACTIONS(2508),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2506),
    [sym_op_identifier] = ACTIONS(2506),
    [anon_sym_PLUS] = ACTIONS(2506),
    [anon_sym_DASH] = ACTIONS(2506),
    [anon_sym_PLUS_DOT] = ACTIONS(2506),
    [anon_sym_DASH_DOT] = ACTIONS(2506),
    [anon_sym_PERCENT] = ACTIONS(2506),
    [anon_sym_AMP_AMP] = ACTIONS(2506),
    [anon_sym_TILDE] = ACTIONS(2508),
    [aux_sym_prefix_op_token1] = ACTIONS(2506),
    [aux_sym_infix_op_token1] = ACTIONS(2508),
    [aux_sym_infix_op_token2] = ACTIONS(2506),
    [anon_sym_PIPE_PIPE] = ACTIONS(2506),
    [anon_sym_BANG_EQ] = ACTIONS(2506),
    [anon_sym_COLON_EQ] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(2506),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2506),
    [sym_int] = ACTIONS(2506),
    [sym_xint] = ACTIONS(2508),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2508),
    [sym__newline] = ACTIONS(2508),
    [sym__dedent] = ACTIONS(2508),
  },
  [1072] = {
    [sym_block_comment] = STATE(1072),
    [sym_compiler_directive_decl] = STATE(1072),
    [sym_fsi_directive_decl] = STATE(1072),
    [sym_preproc_line] = STATE(1072),
    [sym_identifier] = ACTIONS(2988),
    [anon_sym_EQ] = ACTIONS(2990),
    [anon_sym_GT_RBRACK] = ACTIONS(2990),
    [anon_sym_COLON] = ACTIONS(2988),
    [anon_sym_return] = ACTIONS(2988),
    [anon_sym_do] = ACTIONS(2988),
    [anon_sym_let] = ACTIONS(2988),
    [anon_sym_let_BANG] = ACTIONS(2990),
    [anon_sym_LPAREN] = ACTIONS(2988),
    [anon_sym_COMMA] = ACTIONS(2990),
    [anon_sym_null] = ACTIONS(2988),
    [anon_sym_QMARK] = ACTIONS(2988),
    [anon_sym_COLON_QMARK] = ACTIONS(2988),
    [anon_sym_COLON_COLON] = ACTIONS(2990),
    [anon_sym_AMP] = ACTIONS(2988),
    [anon_sym_LBRACK] = ACTIONS(2988),
    [anon_sym_RBRACK] = ACTIONS(2990),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2990),
    [anon_sym_LBRACE] = ACTIONS(2988),
    [anon_sym_RBRACE] = ACTIONS(2990),
    [anon_sym_LT_AT] = ACTIONS(2988),
    [anon_sym_LT_AT_AT] = ACTIONS(2988),
    [anon_sym_DOT] = ACTIONS(2988),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2990),
    [anon_sym_new] = ACTIONS(2988),
    [anon_sym_with] = ACTIONS(2988),
    [anon_sym_return_BANG] = ACTIONS(2990),
    [anon_sym_yield] = ACTIONS(2988),
    [anon_sym_yield_BANG] = ACTIONS(2990),
    [anon_sym_lazy] = ACTIONS(2988),
    [anon_sym_assert] = ACTIONS(2988),
    [anon_sym_upcast] = ACTIONS(2988),
    [anon_sym_downcast] = ACTIONS(2988),
    [anon_sym_COLON_GT] = ACTIONS(2990),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2990),
    [anon_sym_for] = ACTIONS(2988),
    [anon_sym_to] = ACTIONS(2988),
    [anon_sym_downto] = ACTIONS(2988),
    [anon_sym_while] = ACTIONS(2988),
    [anon_sym_if] = ACTIONS(2988),
    [anon_sym_fun] = ACTIONS(2988),
    [anon_sym_try] = ACTIONS(2988),
    [anon_sym_match] = ACTIONS(2988),
    [anon_sym_match_BANG] = ACTIONS(2990),
    [anon_sym_function] = ACTIONS(2988),
    [anon_sym_LT_DASH] = ACTIONS(2988),
    [anon_sym_DOT_LBRACK] = ACTIONS(2990),
    [anon_sym_LT] = ACTIONS(2990),
    [anon_sym_use] = ACTIONS(2988),
    [anon_sym_use_BANG] = ACTIONS(2990),
    [anon_sym_do_BANG] = ACTIONS(2990),
    [anon_sym_begin] = ACTIONS(2988),
    [anon_sym_LPAREN2] = ACTIONS(2988),
    [anon_sym_DOT_DOT2] = ACTIONS(2990),
    [anon_sym_or] = ACTIONS(2988),
    [aux_sym_char_token1] = ACTIONS(2990),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2988),
    [anon_sym_DQUOTE] = ACTIONS(2988),
    [anon_sym_AT_DQUOTE] = ACTIONS(2990),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2990),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2990),
    [sym_bool] = ACTIONS(2988),
    [sym_unit] = ACTIONS(2990),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2988),
    [sym_op_identifier] = ACTIONS(2988),
    [anon_sym_PLUS] = ACTIONS(2988),
    [anon_sym_DASH] = ACTIONS(2988),
    [anon_sym_PLUS_DOT] = ACTIONS(2988),
    [anon_sym_DASH_DOT] = ACTIONS(2988),
    [anon_sym_PERCENT] = ACTIONS(2988),
    [anon_sym_AMP_AMP] = ACTIONS(2988),
    [anon_sym_TILDE] = ACTIONS(2990),
    [aux_sym_prefix_op_token1] = ACTIONS(2988),
    [aux_sym_infix_op_token1] = ACTIONS(2990),
    [aux_sym_infix_op_token2] = ACTIONS(2988),
    [anon_sym_PIPE_PIPE] = ACTIONS(2988),
    [anon_sym_BANG_EQ] = ACTIONS(2988),
    [anon_sym_COLON_EQ] = ACTIONS(2990),
    [anon_sym_DOLLAR] = ACTIONS(2988),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2988),
    [sym_int] = ACTIONS(2988),
    [sym_xint] = ACTIONS(2990),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2990),
    [sym__newline] = ACTIONS(2990),
  },
  [1073] = {
    [sym_block_comment] = STATE(1073),
    [sym_compiler_directive_decl] = STATE(1073),
    [sym_fsi_directive_decl] = STATE(1073),
    [sym_preproc_line] = STATE(1073),
    [sym_identifier] = ACTIONS(3019),
    [anon_sym_EQ] = ACTIONS(3021),
    [anon_sym_GT_RBRACK] = ACTIONS(3021),
    [anon_sym_COLON] = ACTIONS(3019),
    [anon_sym_return] = ACTIONS(3019),
    [anon_sym_do] = ACTIONS(3019),
    [anon_sym_let] = ACTIONS(3019),
    [anon_sym_let_BANG] = ACTIONS(3021),
    [anon_sym_LPAREN] = ACTIONS(3019),
    [anon_sym_COMMA] = ACTIONS(3021),
    [anon_sym_null] = ACTIONS(3019),
    [anon_sym_QMARK] = ACTIONS(3019),
    [anon_sym_COLON_QMARK] = ACTIONS(3019),
    [anon_sym_COLON_COLON] = ACTIONS(3021),
    [anon_sym_AMP] = ACTIONS(3019),
    [anon_sym_LBRACK] = ACTIONS(3019),
    [anon_sym_RBRACK] = ACTIONS(3021),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3021),
    [anon_sym_LBRACE] = ACTIONS(3019),
    [anon_sym_RBRACE] = ACTIONS(3021),
    [anon_sym_LT_AT] = ACTIONS(3019),
    [anon_sym_LT_AT_AT] = ACTIONS(3019),
    [anon_sym_DOT] = ACTIONS(3019),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3021),
    [anon_sym_new] = ACTIONS(3019),
    [anon_sym_with] = ACTIONS(3019),
    [anon_sym_return_BANG] = ACTIONS(3021),
    [anon_sym_yield] = ACTIONS(3019),
    [anon_sym_yield_BANG] = ACTIONS(3021),
    [anon_sym_lazy] = ACTIONS(3019),
    [anon_sym_assert] = ACTIONS(3019),
    [anon_sym_upcast] = ACTIONS(3019),
    [anon_sym_downcast] = ACTIONS(3019),
    [anon_sym_COLON_GT] = ACTIONS(3021),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3021),
    [anon_sym_for] = ACTIONS(3019),
    [anon_sym_to] = ACTIONS(3019),
    [anon_sym_downto] = ACTIONS(3019),
    [anon_sym_while] = ACTIONS(3019),
    [anon_sym_if] = ACTIONS(3019),
    [anon_sym_fun] = ACTIONS(3019),
    [anon_sym_try] = ACTIONS(3019),
    [anon_sym_match] = ACTIONS(3019),
    [anon_sym_match_BANG] = ACTIONS(3021),
    [anon_sym_function] = ACTIONS(3019),
    [anon_sym_LT_DASH] = ACTIONS(3019),
    [anon_sym_DOT_LBRACK] = ACTIONS(3021),
    [anon_sym_LT] = ACTIONS(3021),
    [anon_sym_use] = ACTIONS(3019),
    [anon_sym_use_BANG] = ACTIONS(3021),
    [anon_sym_do_BANG] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3019),
    [anon_sym_LPAREN2] = ACTIONS(3019),
    [anon_sym_DOT_DOT2] = ACTIONS(3021),
    [anon_sym_or] = ACTIONS(3019),
    [aux_sym_char_token1] = ACTIONS(3021),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3019),
    [anon_sym_DQUOTE] = ACTIONS(3019),
    [anon_sym_AT_DQUOTE] = ACTIONS(3021),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3021),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3021),
    [sym_bool] = ACTIONS(3019),
    [sym_unit] = ACTIONS(3021),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3019),
    [sym_op_identifier] = ACTIONS(3019),
    [anon_sym_PLUS] = ACTIONS(3019),
    [anon_sym_DASH] = ACTIONS(3019),
    [anon_sym_PLUS_DOT] = ACTIONS(3019),
    [anon_sym_DASH_DOT] = ACTIONS(3019),
    [anon_sym_PERCENT] = ACTIONS(3019),
    [anon_sym_AMP_AMP] = ACTIONS(3019),
    [anon_sym_TILDE] = ACTIONS(3021),
    [aux_sym_prefix_op_token1] = ACTIONS(3019),
    [aux_sym_infix_op_token1] = ACTIONS(3021),
    [aux_sym_infix_op_token2] = ACTIONS(3019),
    [anon_sym_PIPE_PIPE] = ACTIONS(3019),
    [anon_sym_BANG_EQ] = ACTIONS(3019),
    [anon_sym_COLON_EQ] = ACTIONS(3021),
    [anon_sym_DOLLAR] = ACTIONS(3019),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3019),
    [sym_int] = ACTIONS(3019),
    [sym_xint] = ACTIONS(3021),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3021),
    [sym__newline] = ACTIONS(3021),
  },
  [1074] = {
    [sym_block_comment] = STATE(1074),
    [sym_compiler_directive_decl] = STATE(1074),
    [sym_fsi_directive_decl] = STATE(1074),
    [sym_preproc_line] = STATE(1074),
    [sym_identifier] = ACTIONS(2930),
    [anon_sym_EQ] = ACTIONS(2932),
    [anon_sym_GT_RBRACK] = ACTIONS(2932),
    [anon_sym_COLON] = ACTIONS(2930),
    [anon_sym_return] = ACTIONS(2930),
    [anon_sym_do] = ACTIONS(2930),
    [anon_sym_let] = ACTIONS(2930),
    [anon_sym_let_BANG] = ACTIONS(2932),
    [anon_sym_LPAREN] = ACTIONS(2930),
    [anon_sym_COMMA] = ACTIONS(2932),
    [anon_sym_null] = ACTIONS(2930),
    [anon_sym_QMARK] = ACTIONS(2930),
    [anon_sym_COLON_QMARK] = ACTIONS(2930),
    [anon_sym_COLON_COLON] = ACTIONS(2932),
    [anon_sym_AMP] = ACTIONS(2930),
    [anon_sym_LBRACK] = ACTIONS(2930),
    [anon_sym_RBRACK] = ACTIONS(2932),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2932),
    [anon_sym_LBRACE] = ACTIONS(2930),
    [anon_sym_RBRACE] = ACTIONS(2932),
    [anon_sym_LT_AT] = ACTIONS(2930),
    [anon_sym_LT_AT_AT] = ACTIONS(2930),
    [anon_sym_DOT] = ACTIONS(2930),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2932),
    [anon_sym_new] = ACTIONS(2930),
    [anon_sym_with] = ACTIONS(2930),
    [anon_sym_return_BANG] = ACTIONS(2932),
    [anon_sym_yield] = ACTIONS(2930),
    [anon_sym_yield_BANG] = ACTIONS(2932),
    [anon_sym_lazy] = ACTIONS(2930),
    [anon_sym_assert] = ACTIONS(2930),
    [anon_sym_upcast] = ACTIONS(2930),
    [anon_sym_downcast] = ACTIONS(2930),
    [anon_sym_COLON_GT] = ACTIONS(2932),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2932),
    [anon_sym_for] = ACTIONS(2930),
    [anon_sym_to] = ACTIONS(2930),
    [anon_sym_downto] = ACTIONS(2930),
    [anon_sym_while] = ACTIONS(2930),
    [anon_sym_if] = ACTIONS(2930),
    [anon_sym_fun] = ACTIONS(2930),
    [anon_sym_try] = ACTIONS(2930),
    [anon_sym_match] = ACTIONS(2930),
    [anon_sym_match_BANG] = ACTIONS(2932),
    [anon_sym_function] = ACTIONS(2930),
    [anon_sym_LT_DASH] = ACTIONS(2930),
    [anon_sym_DOT_LBRACK] = ACTIONS(2932),
    [anon_sym_LT] = ACTIONS(2932),
    [anon_sym_use] = ACTIONS(2930),
    [anon_sym_use_BANG] = ACTIONS(2932),
    [anon_sym_do_BANG] = ACTIONS(2932),
    [anon_sym_begin] = ACTIONS(2930),
    [anon_sym_LPAREN2] = ACTIONS(2930),
    [anon_sym_DOT_DOT2] = ACTIONS(2932),
    [anon_sym_or] = ACTIONS(2930),
    [aux_sym_char_token1] = ACTIONS(2932),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2930),
    [anon_sym_DQUOTE] = ACTIONS(2930),
    [anon_sym_AT_DQUOTE] = ACTIONS(2932),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2932),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2932),
    [sym_bool] = ACTIONS(2930),
    [sym_unit] = ACTIONS(2932),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2930),
    [sym_op_identifier] = ACTIONS(2930),
    [anon_sym_PLUS] = ACTIONS(2930),
    [anon_sym_DASH] = ACTIONS(2930),
    [anon_sym_PLUS_DOT] = ACTIONS(2930),
    [anon_sym_DASH_DOT] = ACTIONS(2930),
    [anon_sym_PERCENT] = ACTIONS(2930),
    [anon_sym_AMP_AMP] = ACTIONS(2930),
    [anon_sym_TILDE] = ACTIONS(2932),
    [aux_sym_prefix_op_token1] = ACTIONS(2930),
    [aux_sym_infix_op_token1] = ACTIONS(2932),
    [aux_sym_infix_op_token2] = ACTIONS(2930),
    [anon_sym_PIPE_PIPE] = ACTIONS(2930),
    [anon_sym_BANG_EQ] = ACTIONS(2930),
    [anon_sym_COLON_EQ] = ACTIONS(2932),
    [anon_sym_DOLLAR] = ACTIONS(2930),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2930),
    [sym_int] = ACTIONS(2930),
    [sym_xint] = ACTIONS(2932),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2932),
    [sym__newline] = ACTIONS(2932),
  },
  [1075] = {
    [sym_block_comment] = STATE(1075),
    [sym_compiler_directive_decl] = STATE(1075),
    [sym_fsi_directive_decl] = STATE(1075),
    [sym_preproc_line] = STATE(1075),
    [sym_identifier] = ACTIONS(3003),
    [anon_sym_EQ] = ACTIONS(3005),
    [anon_sym_GT_RBRACK] = ACTIONS(3005),
    [anon_sym_COLON] = ACTIONS(3003),
    [anon_sym_return] = ACTIONS(3003),
    [anon_sym_do] = ACTIONS(3003),
    [anon_sym_let] = ACTIONS(3003),
    [anon_sym_let_BANG] = ACTIONS(3005),
    [anon_sym_LPAREN] = ACTIONS(3003),
    [anon_sym_COMMA] = ACTIONS(3005),
    [anon_sym_null] = ACTIONS(3003),
    [anon_sym_QMARK] = ACTIONS(3003),
    [anon_sym_COLON_QMARK] = ACTIONS(3003),
    [anon_sym_COLON_COLON] = ACTIONS(3005),
    [anon_sym_AMP] = ACTIONS(3003),
    [anon_sym_LBRACK] = ACTIONS(3003),
    [anon_sym_RBRACK] = ACTIONS(3005),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3005),
    [anon_sym_LBRACE] = ACTIONS(3003),
    [anon_sym_RBRACE] = ACTIONS(3005),
    [anon_sym_LT_AT] = ACTIONS(3003),
    [anon_sym_LT_AT_AT] = ACTIONS(3003),
    [anon_sym_DOT] = ACTIONS(3003),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3005),
    [anon_sym_new] = ACTIONS(3003),
    [anon_sym_with] = ACTIONS(3003),
    [anon_sym_return_BANG] = ACTIONS(3005),
    [anon_sym_yield] = ACTIONS(3003),
    [anon_sym_yield_BANG] = ACTIONS(3005),
    [anon_sym_lazy] = ACTIONS(3003),
    [anon_sym_assert] = ACTIONS(3003),
    [anon_sym_upcast] = ACTIONS(3003),
    [anon_sym_downcast] = ACTIONS(3003),
    [anon_sym_COLON_GT] = ACTIONS(3005),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3005),
    [anon_sym_for] = ACTIONS(3003),
    [anon_sym_to] = ACTIONS(3003),
    [anon_sym_downto] = ACTIONS(3003),
    [anon_sym_while] = ACTIONS(3003),
    [anon_sym_if] = ACTIONS(3003),
    [anon_sym_fun] = ACTIONS(3003),
    [anon_sym_try] = ACTIONS(3003),
    [anon_sym_match] = ACTIONS(3003),
    [anon_sym_match_BANG] = ACTIONS(3005),
    [anon_sym_function] = ACTIONS(3003),
    [anon_sym_LT_DASH] = ACTIONS(3003),
    [anon_sym_DOT_LBRACK] = ACTIONS(3005),
    [anon_sym_LT] = ACTIONS(3005),
    [anon_sym_use] = ACTIONS(3003),
    [anon_sym_use_BANG] = ACTIONS(3005),
    [anon_sym_do_BANG] = ACTIONS(3005),
    [anon_sym_begin] = ACTIONS(3003),
    [anon_sym_LPAREN2] = ACTIONS(3003),
    [anon_sym_DOT_DOT2] = ACTIONS(3005),
    [anon_sym_or] = ACTIONS(3003),
    [aux_sym_char_token1] = ACTIONS(3005),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3003),
    [anon_sym_DQUOTE] = ACTIONS(3003),
    [anon_sym_AT_DQUOTE] = ACTIONS(3005),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3005),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3005),
    [sym_bool] = ACTIONS(3003),
    [sym_unit] = ACTIONS(3005),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3003),
    [sym_op_identifier] = ACTIONS(3003),
    [anon_sym_PLUS] = ACTIONS(3003),
    [anon_sym_DASH] = ACTIONS(3003),
    [anon_sym_PLUS_DOT] = ACTIONS(3003),
    [anon_sym_DASH_DOT] = ACTIONS(3003),
    [anon_sym_PERCENT] = ACTIONS(3003),
    [anon_sym_AMP_AMP] = ACTIONS(3003),
    [anon_sym_TILDE] = ACTIONS(3005),
    [aux_sym_prefix_op_token1] = ACTIONS(3003),
    [aux_sym_infix_op_token1] = ACTIONS(3005),
    [aux_sym_infix_op_token2] = ACTIONS(3003),
    [anon_sym_PIPE_PIPE] = ACTIONS(3003),
    [anon_sym_BANG_EQ] = ACTIONS(3003),
    [anon_sym_COLON_EQ] = ACTIONS(3005),
    [anon_sym_DOLLAR] = ACTIONS(3003),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3003),
    [sym_int] = ACTIONS(3003),
    [sym_xint] = ACTIONS(3005),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3005),
    [sym__newline] = ACTIONS(3005),
  },
  [1076] = {
    [sym_block_comment] = STATE(1076),
    [sym_compiler_directive_decl] = STATE(1076),
    [sym_fsi_directive_decl] = STATE(1076),
    [sym_preproc_line] = STATE(1076),
    [sym_identifier] = ACTIONS(2411),
    [anon_sym_EQ] = ACTIONS(2413),
    [anon_sym_GT_RBRACK] = ACTIONS(2413),
    [anon_sym_COLON] = ACTIONS(2411),
    [anon_sym_return] = ACTIONS(2411),
    [anon_sym_do] = ACTIONS(2411),
    [anon_sym_let] = ACTIONS(2411),
    [anon_sym_let_BANG] = ACTIONS(2413),
    [anon_sym_LPAREN] = ACTIONS(2411),
    [anon_sym_COMMA] = ACTIONS(2413),
    [anon_sym_null] = ACTIONS(2411),
    [anon_sym_QMARK] = ACTIONS(2411),
    [anon_sym_COLON_QMARK] = ACTIONS(2411),
    [anon_sym_COLON_COLON] = ACTIONS(2413),
    [anon_sym_AMP] = ACTIONS(2411),
    [anon_sym_LBRACK] = ACTIONS(2411),
    [anon_sym_RBRACK] = ACTIONS(2413),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2413),
    [anon_sym_LBRACE] = ACTIONS(2411),
    [anon_sym_RBRACE] = ACTIONS(2413),
    [anon_sym_LT_AT] = ACTIONS(2411),
    [anon_sym_LT_AT_AT] = ACTIONS(2411),
    [anon_sym_DOT] = ACTIONS(2411),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2413),
    [anon_sym_new] = ACTIONS(2411),
    [anon_sym_with] = ACTIONS(2411),
    [anon_sym_return_BANG] = ACTIONS(2413),
    [anon_sym_yield] = ACTIONS(2411),
    [anon_sym_yield_BANG] = ACTIONS(2413),
    [anon_sym_lazy] = ACTIONS(2411),
    [anon_sym_assert] = ACTIONS(2411),
    [anon_sym_upcast] = ACTIONS(2411),
    [anon_sym_downcast] = ACTIONS(2411),
    [anon_sym_COLON_GT] = ACTIONS(2413),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2413),
    [anon_sym_for] = ACTIONS(2411),
    [anon_sym_to] = ACTIONS(2411),
    [anon_sym_downto] = ACTIONS(2411),
    [anon_sym_while] = ACTIONS(2411),
    [anon_sym_if] = ACTIONS(2411),
    [anon_sym_fun] = ACTIONS(2411),
    [anon_sym_try] = ACTIONS(2411),
    [anon_sym_match] = ACTIONS(2411),
    [anon_sym_match_BANG] = ACTIONS(2413),
    [anon_sym_function] = ACTIONS(2411),
    [anon_sym_LT_DASH] = ACTIONS(2411),
    [anon_sym_DOT_LBRACK] = ACTIONS(2413),
    [anon_sym_LT] = ACTIONS(2413),
    [anon_sym_use] = ACTIONS(2411),
    [anon_sym_use_BANG] = ACTIONS(2413),
    [anon_sym_do_BANG] = ACTIONS(2413),
    [anon_sym_begin] = ACTIONS(2411),
    [anon_sym_LPAREN2] = ACTIONS(2411),
    [anon_sym_DOT_DOT2] = ACTIONS(2413),
    [anon_sym_or] = ACTIONS(2411),
    [aux_sym_char_token1] = ACTIONS(2413),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2411),
    [anon_sym_DQUOTE] = ACTIONS(2411),
    [anon_sym_AT_DQUOTE] = ACTIONS(2413),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2413),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2413),
    [sym_bool] = ACTIONS(2411),
    [sym_unit] = ACTIONS(2413),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2411),
    [sym_op_identifier] = ACTIONS(2411),
    [anon_sym_PLUS] = ACTIONS(2411),
    [anon_sym_DASH] = ACTIONS(2411),
    [anon_sym_PLUS_DOT] = ACTIONS(2411),
    [anon_sym_DASH_DOT] = ACTIONS(2411),
    [anon_sym_PERCENT] = ACTIONS(2411),
    [anon_sym_AMP_AMP] = ACTIONS(2411),
    [anon_sym_TILDE] = ACTIONS(2413),
    [aux_sym_prefix_op_token1] = ACTIONS(2411),
    [aux_sym_infix_op_token1] = ACTIONS(2413),
    [aux_sym_infix_op_token2] = ACTIONS(2411),
    [anon_sym_PIPE_PIPE] = ACTIONS(2411),
    [anon_sym_BANG_EQ] = ACTIONS(2411),
    [anon_sym_COLON_EQ] = ACTIONS(2413),
    [anon_sym_DOLLAR] = ACTIONS(2411),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2411),
    [sym_int] = ACTIONS(2411),
    [sym_xint] = ACTIONS(2413),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2413),
    [sym__newline] = ACTIONS(2413),
  },
  [1077] = {
    [sym_block_comment] = STATE(1077),
    [sym_compiler_directive_decl] = STATE(1077),
    [sym_fsi_directive_decl] = STATE(1077),
    [sym_preproc_line] = STATE(1077),
    [sym_identifier] = ACTIONS(2843),
    [anon_sym_EQ] = ACTIONS(2845),
    [anon_sym_GT_RBRACK] = ACTIONS(2845),
    [anon_sym_COLON] = ACTIONS(2843),
    [anon_sym_return] = ACTIONS(2843),
    [anon_sym_do] = ACTIONS(2843),
    [anon_sym_let] = ACTIONS(2843),
    [anon_sym_let_BANG] = ACTIONS(2845),
    [anon_sym_LPAREN] = ACTIONS(2843),
    [anon_sym_COMMA] = ACTIONS(2845),
    [anon_sym_null] = ACTIONS(2843),
    [anon_sym_QMARK] = ACTIONS(2843),
    [anon_sym_COLON_QMARK] = ACTIONS(2843),
    [anon_sym_COLON_COLON] = ACTIONS(2845),
    [anon_sym_AMP] = ACTIONS(2843),
    [anon_sym_LBRACK] = ACTIONS(2843),
    [anon_sym_RBRACK] = ACTIONS(2845),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2845),
    [anon_sym_LBRACE] = ACTIONS(2843),
    [anon_sym_RBRACE] = ACTIONS(2845),
    [anon_sym_LT_AT] = ACTIONS(2843),
    [anon_sym_LT_AT_AT] = ACTIONS(2843),
    [anon_sym_DOT] = ACTIONS(2843),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2845),
    [anon_sym_new] = ACTIONS(2843),
    [anon_sym_with] = ACTIONS(2843),
    [anon_sym_return_BANG] = ACTIONS(2845),
    [anon_sym_yield] = ACTIONS(2843),
    [anon_sym_yield_BANG] = ACTIONS(2845),
    [anon_sym_lazy] = ACTIONS(2843),
    [anon_sym_assert] = ACTIONS(2843),
    [anon_sym_upcast] = ACTIONS(2843),
    [anon_sym_downcast] = ACTIONS(2843),
    [anon_sym_COLON_GT] = ACTIONS(2845),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2845),
    [anon_sym_for] = ACTIONS(2843),
    [anon_sym_to] = ACTIONS(2843),
    [anon_sym_downto] = ACTIONS(2843),
    [anon_sym_while] = ACTIONS(2843),
    [anon_sym_if] = ACTIONS(2843),
    [anon_sym_fun] = ACTIONS(2843),
    [anon_sym_try] = ACTIONS(2843),
    [anon_sym_match] = ACTIONS(2843),
    [anon_sym_match_BANG] = ACTIONS(2845),
    [anon_sym_function] = ACTIONS(2843),
    [anon_sym_LT_DASH] = ACTIONS(2843),
    [anon_sym_DOT_LBRACK] = ACTIONS(2845),
    [anon_sym_LT] = ACTIONS(2845),
    [anon_sym_use] = ACTIONS(2843),
    [anon_sym_use_BANG] = ACTIONS(2845),
    [anon_sym_do_BANG] = ACTIONS(2845),
    [anon_sym_begin] = ACTIONS(2843),
    [anon_sym_LPAREN2] = ACTIONS(2843),
    [anon_sym_DOT_DOT2] = ACTIONS(2845),
    [anon_sym_or] = ACTIONS(2843),
    [aux_sym_char_token1] = ACTIONS(2845),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2843),
    [anon_sym_DQUOTE] = ACTIONS(2843),
    [anon_sym_AT_DQUOTE] = ACTIONS(2845),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2845),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2845),
    [sym_bool] = ACTIONS(2843),
    [sym_unit] = ACTIONS(2845),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2843),
    [sym_op_identifier] = ACTIONS(2843),
    [anon_sym_PLUS] = ACTIONS(2843),
    [anon_sym_DASH] = ACTIONS(2843),
    [anon_sym_PLUS_DOT] = ACTIONS(2843),
    [anon_sym_DASH_DOT] = ACTIONS(2843),
    [anon_sym_PERCENT] = ACTIONS(2843),
    [anon_sym_AMP_AMP] = ACTIONS(2843),
    [anon_sym_TILDE] = ACTIONS(2845),
    [aux_sym_prefix_op_token1] = ACTIONS(2843),
    [aux_sym_infix_op_token1] = ACTIONS(2845),
    [aux_sym_infix_op_token2] = ACTIONS(2843),
    [anon_sym_PIPE_PIPE] = ACTIONS(2843),
    [anon_sym_BANG_EQ] = ACTIONS(2843),
    [anon_sym_COLON_EQ] = ACTIONS(2845),
    [anon_sym_DOLLAR] = ACTIONS(2843),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2843),
    [sym_int] = ACTIONS(2843),
    [sym_xint] = ACTIONS(2845),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2845),
    [sym__newline] = ACTIONS(2845),
  },
  [1078] = {
    [sym_block_comment] = STATE(1078),
    [sym_compiler_directive_decl] = STATE(1078),
    [sym_fsi_directive_decl] = STATE(1078),
    [sym_preproc_line] = STATE(1078),
    [sym_identifier] = ACTIONS(2942),
    [anon_sym_EQ] = ACTIONS(2944),
    [anon_sym_GT_RBRACK] = ACTIONS(2944),
    [anon_sym_COLON] = ACTIONS(2942),
    [anon_sym_return] = ACTIONS(2942),
    [anon_sym_do] = ACTIONS(2942),
    [anon_sym_let] = ACTIONS(2942),
    [anon_sym_let_BANG] = ACTIONS(2944),
    [anon_sym_LPAREN] = ACTIONS(2942),
    [anon_sym_COMMA] = ACTIONS(2944),
    [anon_sym_null] = ACTIONS(2942),
    [anon_sym_QMARK] = ACTIONS(2942),
    [anon_sym_COLON_QMARK] = ACTIONS(2942),
    [anon_sym_COLON_COLON] = ACTIONS(2944),
    [anon_sym_AMP] = ACTIONS(2942),
    [anon_sym_LBRACK] = ACTIONS(2942),
    [anon_sym_RBRACK] = ACTIONS(2944),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2944),
    [anon_sym_LBRACE] = ACTIONS(2942),
    [anon_sym_RBRACE] = ACTIONS(2944),
    [anon_sym_LT_AT] = ACTIONS(2942),
    [anon_sym_LT_AT_AT] = ACTIONS(2942),
    [anon_sym_DOT] = ACTIONS(2942),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2944),
    [anon_sym_new] = ACTIONS(2942),
    [anon_sym_with] = ACTIONS(2942),
    [anon_sym_return_BANG] = ACTIONS(2944),
    [anon_sym_yield] = ACTIONS(2942),
    [anon_sym_yield_BANG] = ACTIONS(2944),
    [anon_sym_lazy] = ACTIONS(2942),
    [anon_sym_assert] = ACTIONS(2942),
    [anon_sym_upcast] = ACTIONS(2942),
    [anon_sym_downcast] = ACTIONS(2942),
    [anon_sym_COLON_GT] = ACTIONS(2944),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2944),
    [anon_sym_for] = ACTIONS(2942),
    [anon_sym_to] = ACTIONS(2942),
    [anon_sym_downto] = ACTIONS(2942),
    [anon_sym_while] = ACTIONS(2942),
    [anon_sym_if] = ACTIONS(2942),
    [anon_sym_fun] = ACTIONS(2942),
    [anon_sym_try] = ACTIONS(2942),
    [anon_sym_match] = ACTIONS(2942),
    [anon_sym_match_BANG] = ACTIONS(2944),
    [anon_sym_function] = ACTIONS(2942),
    [anon_sym_LT_DASH] = ACTIONS(2942),
    [anon_sym_DOT_LBRACK] = ACTIONS(2944),
    [anon_sym_LT] = ACTIONS(2944),
    [anon_sym_use] = ACTIONS(2942),
    [anon_sym_use_BANG] = ACTIONS(2944),
    [anon_sym_do_BANG] = ACTIONS(2944),
    [anon_sym_begin] = ACTIONS(2942),
    [anon_sym_LPAREN2] = ACTIONS(2942),
    [anon_sym_DOT_DOT2] = ACTIONS(2944),
    [anon_sym_or] = ACTIONS(2942),
    [aux_sym_char_token1] = ACTIONS(2944),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2942),
    [anon_sym_DQUOTE] = ACTIONS(2942),
    [anon_sym_AT_DQUOTE] = ACTIONS(2944),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2944),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2944),
    [sym_bool] = ACTIONS(2942),
    [sym_unit] = ACTIONS(2944),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2942),
    [sym_op_identifier] = ACTIONS(2942),
    [anon_sym_PLUS] = ACTIONS(2942),
    [anon_sym_DASH] = ACTIONS(2942),
    [anon_sym_PLUS_DOT] = ACTIONS(2942),
    [anon_sym_DASH_DOT] = ACTIONS(2942),
    [anon_sym_PERCENT] = ACTIONS(2942),
    [anon_sym_AMP_AMP] = ACTIONS(2942),
    [anon_sym_TILDE] = ACTIONS(2944),
    [aux_sym_prefix_op_token1] = ACTIONS(2942),
    [aux_sym_infix_op_token1] = ACTIONS(2944),
    [aux_sym_infix_op_token2] = ACTIONS(2942),
    [anon_sym_PIPE_PIPE] = ACTIONS(2942),
    [anon_sym_BANG_EQ] = ACTIONS(2942),
    [anon_sym_COLON_EQ] = ACTIONS(2944),
    [anon_sym_DOLLAR] = ACTIONS(2942),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2942),
    [sym_int] = ACTIONS(2942),
    [sym_xint] = ACTIONS(2944),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2944),
    [sym__newline] = ACTIONS(2944),
  },
  [1079] = {
    [sym_block_comment] = STATE(1079),
    [sym_compiler_directive_decl] = STATE(1079),
    [sym_fsi_directive_decl] = STATE(1079),
    [sym_preproc_line] = STATE(1079),
    [sym_identifier] = ACTIONS(3135),
    [anon_sym_EQ] = ACTIONS(3137),
    [anon_sym_GT_RBRACK] = ACTIONS(3137),
    [anon_sym_COLON] = ACTIONS(3135),
    [anon_sym_return] = ACTIONS(3135),
    [anon_sym_do] = ACTIONS(3135),
    [anon_sym_let] = ACTIONS(3135),
    [anon_sym_let_BANG] = ACTIONS(3137),
    [anon_sym_LPAREN] = ACTIONS(3135),
    [anon_sym_COMMA] = ACTIONS(3137),
    [anon_sym_null] = ACTIONS(3135),
    [anon_sym_QMARK] = ACTIONS(3135),
    [anon_sym_COLON_QMARK] = ACTIONS(3135),
    [anon_sym_COLON_COLON] = ACTIONS(3137),
    [anon_sym_AMP] = ACTIONS(3135),
    [anon_sym_LBRACK] = ACTIONS(3135),
    [anon_sym_RBRACK] = ACTIONS(3137),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3137),
    [anon_sym_LBRACE] = ACTIONS(3135),
    [anon_sym_RBRACE] = ACTIONS(3137),
    [anon_sym_LT_AT] = ACTIONS(3135),
    [anon_sym_LT_AT_AT] = ACTIONS(3135),
    [anon_sym_DOT] = ACTIONS(3135),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3137),
    [anon_sym_new] = ACTIONS(3135),
    [anon_sym_with] = ACTIONS(3135),
    [anon_sym_return_BANG] = ACTIONS(3137),
    [anon_sym_yield] = ACTIONS(3135),
    [anon_sym_yield_BANG] = ACTIONS(3137),
    [anon_sym_lazy] = ACTIONS(3135),
    [anon_sym_assert] = ACTIONS(3135),
    [anon_sym_upcast] = ACTIONS(3135),
    [anon_sym_downcast] = ACTIONS(3135),
    [anon_sym_COLON_GT] = ACTIONS(3137),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3137),
    [anon_sym_for] = ACTIONS(3135),
    [anon_sym_to] = ACTIONS(3135),
    [anon_sym_downto] = ACTIONS(3135),
    [anon_sym_while] = ACTIONS(3135),
    [anon_sym_if] = ACTIONS(3135),
    [anon_sym_fun] = ACTIONS(3135),
    [anon_sym_try] = ACTIONS(3135),
    [anon_sym_match] = ACTIONS(3135),
    [anon_sym_match_BANG] = ACTIONS(3137),
    [anon_sym_function] = ACTIONS(3135),
    [anon_sym_LT_DASH] = ACTIONS(3135),
    [anon_sym_DOT_LBRACK] = ACTIONS(3137),
    [anon_sym_LT] = ACTIONS(3137),
    [anon_sym_use] = ACTIONS(3135),
    [anon_sym_use_BANG] = ACTIONS(3137),
    [anon_sym_do_BANG] = ACTIONS(3137),
    [anon_sym_begin] = ACTIONS(3135),
    [anon_sym_LPAREN2] = ACTIONS(3135),
    [anon_sym_DOT_DOT2] = ACTIONS(3137),
    [anon_sym_or] = ACTIONS(3135),
    [aux_sym_char_token1] = ACTIONS(3137),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3135),
    [anon_sym_DQUOTE] = ACTIONS(3135),
    [anon_sym_AT_DQUOTE] = ACTIONS(3137),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3137),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3137),
    [sym_bool] = ACTIONS(3135),
    [sym_unit] = ACTIONS(3137),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3135),
    [sym_op_identifier] = ACTIONS(3135),
    [anon_sym_PLUS] = ACTIONS(3135),
    [anon_sym_DASH] = ACTIONS(3135),
    [anon_sym_PLUS_DOT] = ACTIONS(3135),
    [anon_sym_DASH_DOT] = ACTIONS(3135),
    [anon_sym_PERCENT] = ACTIONS(3135),
    [anon_sym_AMP_AMP] = ACTIONS(3135),
    [anon_sym_TILDE] = ACTIONS(3137),
    [aux_sym_prefix_op_token1] = ACTIONS(3135),
    [aux_sym_infix_op_token1] = ACTIONS(3137),
    [aux_sym_infix_op_token2] = ACTIONS(3135),
    [anon_sym_PIPE_PIPE] = ACTIONS(3135),
    [anon_sym_BANG_EQ] = ACTIONS(3135),
    [anon_sym_COLON_EQ] = ACTIONS(3137),
    [anon_sym_DOLLAR] = ACTIONS(3135),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3135),
    [sym_int] = ACTIONS(3135),
    [sym_xint] = ACTIONS(3137),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3137),
    [sym__newline] = ACTIONS(3137),
  },
  [1080] = {
    [sym_block_comment] = STATE(1080),
    [sym_compiler_directive_decl] = STATE(1080),
    [sym_fsi_directive_decl] = STATE(1080),
    [sym_preproc_line] = STATE(1080),
    [sym_identifier] = ACTIONS(2158),
    [anon_sym_EQ] = ACTIONS(2160),
    [anon_sym_GT_RBRACK] = ACTIONS(2160),
    [anon_sym_COLON] = ACTIONS(2158),
    [anon_sym_return] = ACTIONS(2158),
    [anon_sym_do] = ACTIONS(2158),
    [anon_sym_let] = ACTIONS(2158),
    [anon_sym_let_BANG] = ACTIONS(2160),
    [anon_sym_LPAREN] = ACTIONS(2158),
    [anon_sym_COMMA] = ACTIONS(2160),
    [anon_sym_null] = ACTIONS(2158),
    [anon_sym_QMARK] = ACTIONS(2158),
    [anon_sym_COLON_QMARK] = ACTIONS(2158),
    [anon_sym_COLON_COLON] = ACTIONS(2160),
    [anon_sym_AMP] = ACTIONS(2158),
    [anon_sym_LBRACK] = ACTIONS(2158),
    [anon_sym_RBRACK] = ACTIONS(2160),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2160),
    [anon_sym_LBRACE] = ACTIONS(2158),
    [anon_sym_RBRACE] = ACTIONS(2160),
    [anon_sym_LT_AT] = ACTIONS(2158),
    [anon_sym_LT_AT_AT] = ACTIONS(2158),
    [anon_sym_DOT] = ACTIONS(2158),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2160),
    [anon_sym_new] = ACTIONS(2158),
    [anon_sym_with] = ACTIONS(2158),
    [anon_sym_return_BANG] = ACTIONS(2160),
    [anon_sym_yield] = ACTIONS(2158),
    [anon_sym_yield_BANG] = ACTIONS(2160),
    [anon_sym_lazy] = ACTIONS(2158),
    [anon_sym_assert] = ACTIONS(2158),
    [anon_sym_upcast] = ACTIONS(2158),
    [anon_sym_downcast] = ACTIONS(2158),
    [anon_sym_COLON_GT] = ACTIONS(2160),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2160),
    [anon_sym_for] = ACTIONS(2158),
    [anon_sym_to] = ACTIONS(2158),
    [anon_sym_downto] = ACTIONS(2158),
    [anon_sym_while] = ACTIONS(2158),
    [anon_sym_if] = ACTIONS(2158),
    [anon_sym_fun] = ACTIONS(2158),
    [anon_sym_try] = ACTIONS(2158),
    [anon_sym_match] = ACTIONS(2158),
    [anon_sym_match_BANG] = ACTIONS(2160),
    [anon_sym_function] = ACTIONS(2158),
    [anon_sym_LT_DASH] = ACTIONS(2158),
    [anon_sym_DOT_LBRACK] = ACTIONS(2160),
    [anon_sym_LT] = ACTIONS(2160),
    [anon_sym_use] = ACTIONS(2158),
    [anon_sym_use_BANG] = ACTIONS(2160),
    [anon_sym_do_BANG] = ACTIONS(2160),
    [anon_sym_begin] = ACTIONS(2158),
    [anon_sym_LPAREN2] = ACTIONS(2158),
    [anon_sym_DOT_DOT2] = ACTIONS(2160),
    [anon_sym_or] = ACTIONS(2158),
    [aux_sym_char_token1] = ACTIONS(2160),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2158),
    [anon_sym_DQUOTE] = ACTIONS(2158),
    [anon_sym_AT_DQUOTE] = ACTIONS(2160),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2160),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2160),
    [sym_bool] = ACTIONS(2158),
    [sym_unit] = ACTIONS(2160),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2158),
    [sym_op_identifier] = ACTIONS(2158),
    [anon_sym_PLUS] = ACTIONS(2158),
    [anon_sym_DASH] = ACTIONS(2158),
    [anon_sym_PLUS_DOT] = ACTIONS(2158),
    [anon_sym_DASH_DOT] = ACTIONS(2158),
    [anon_sym_PERCENT] = ACTIONS(2158),
    [anon_sym_AMP_AMP] = ACTIONS(2158),
    [anon_sym_TILDE] = ACTIONS(2160),
    [aux_sym_prefix_op_token1] = ACTIONS(2158),
    [aux_sym_infix_op_token1] = ACTIONS(2160),
    [aux_sym_infix_op_token2] = ACTIONS(2158),
    [anon_sym_PIPE_PIPE] = ACTIONS(2158),
    [anon_sym_BANG_EQ] = ACTIONS(2158),
    [anon_sym_COLON_EQ] = ACTIONS(2160),
    [anon_sym_DOLLAR] = ACTIONS(2158),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2158),
    [sym_int] = ACTIONS(2158),
    [sym_xint] = ACTIONS(2160),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2160),
    [sym__newline] = ACTIONS(2160),
  },
  [1081] = {
    [sym_block_comment] = STATE(1081),
    [sym_compiler_directive_decl] = STATE(1081),
    [sym_fsi_directive_decl] = STATE(1081),
    [sym_preproc_line] = STATE(1081),
    [sym_identifier] = ACTIONS(3035),
    [anon_sym_EQ] = ACTIONS(3037),
    [anon_sym_GT_RBRACK] = ACTIONS(3037),
    [anon_sym_COLON] = ACTIONS(3035),
    [anon_sym_return] = ACTIONS(3035),
    [anon_sym_do] = ACTIONS(3035),
    [anon_sym_let] = ACTIONS(3035),
    [anon_sym_let_BANG] = ACTIONS(3037),
    [anon_sym_LPAREN] = ACTIONS(3035),
    [anon_sym_COMMA] = ACTIONS(3037),
    [anon_sym_null] = ACTIONS(3035),
    [anon_sym_QMARK] = ACTIONS(3035),
    [anon_sym_COLON_QMARK] = ACTIONS(3035),
    [anon_sym_COLON_COLON] = ACTIONS(3037),
    [anon_sym_AMP] = ACTIONS(3035),
    [anon_sym_LBRACK] = ACTIONS(3035),
    [anon_sym_RBRACK] = ACTIONS(3037),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3037),
    [anon_sym_LBRACE] = ACTIONS(3035),
    [anon_sym_RBRACE] = ACTIONS(3037),
    [anon_sym_LT_AT] = ACTIONS(3035),
    [anon_sym_LT_AT_AT] = ACTIONS(3035),
    [anon_sym_DOT] = ACTIONS(3035),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3037),
    [anon_sym_new] = ACTIONS(3035),
    [anon_sym_with] = ACTIONS(3035),
    [anon_sym_return_BANG] = ACTIONS(3037),
    [anon_sym_yield] = ACTIONS(3035),
    [anon_sym_yield_BANG] = ACTIONS(3037),
    [anon_sym_lazy] = ACTIONS(3035),
    [anon_sym_assert] = ACTIONS(3035),
    [anon_sym_upcast] = ACTIONS(3035),
    [anon_sym_downcast] = ACTIONS(3035),
    [anon_sym_COLON_GT] = ACTIONS(3037),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3037),
    [anon_sym_for] = ACTIONS(3035),
    [anon_sym_to] = ACTIONS(3035),
    [anon_sym_downto] = ACTIONS(3035),
    [anon_sym_while] = ACTIONS(3035),
    [anon_sym_if] = ACTIONS(3035),
    [anon_sym_fun] = ACTIONS(3035),
    [anon_sym_try] = ACTIONS(3035),
    [anon_sym_match] = ACTIONS(3035),
    [anon_sym_match_BANG] = ACTIONS(3037),
    [anon_sym_function] = ACTIONS(3035),
    [anon_sym_LT_DASH] = ACTIONS(3035),
    [anon_sym_DOT_LBRACK] = ACTIONS(3037),
    [anon_sym_LT] = ACTIONS(3037),
    [anon_sym_use] = ACTIONS(3035),
    [anon_sym_use_BANG] = ACTIONS(3037),
    [anon_sym_do_BANG] = ACTIONS(3037),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_LPAREN2] = ACTIONS(3035),
    [anon_sym_DOT_DOT2] = ACTIONS(3037),
    [anon_sym_or] = ACTIONS(3035),
    [aux_sym_char_token1] = ACTIONS(3037),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3035),
    [anon_sym_DQUOTE] = ACTIONS(3035),
    [anon_sym_AT_DQUOTE] = ACTIONS(3037),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3037),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3037),
    [sym_bool] = ACTIONS(3035),
    [sym_unit] = ACTIONS(3037),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3035),
    [sym_op_identifier] = ACTIONS(3035),
    [anon_sym_PLUS] = ACTIONS(3035),
    [anon_sym_DASH] = ACTIONS(3035),
    [anon_sym_PLUS_DOT] = ACTIONS(3035),
    [anon_sym_DASH_DOT] = ACTIONS(3035),
    [anon_sym_PERCENT] = ACTIONS(3035),
    [anon_sym_AMP_AMP] = ACTIONS(3035),
    [anon_sym_TILDE] = ACTIONS(3037),
    [aux_sym_prefix_op_token1] = ACTIONS(3035),
    [aux_sym_infix_op_token1] = ACTIONS(3037),
    [aux_sym_infix_op_token2] = ACTIONS(3035),
    [anon_sym_PIPE_PIPE] = ACTIONS(3035),
    [anon_sym_BANG_EQ] = ACTIONS(3035),
    [anon_sym_COLON_EQ] = ACTIONS(3037),
    [anon_sym_DOLLAR] = ACTIONS(3035),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3035),
    [sym_int] = ACTIONS(3035),
    [sym_xint] = ACTIONS(3037),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3037),
    [sym__newline] = ACTIONS(3037),
  },
  [1082] = {
    [sym_elif_expression] = STATE(1391),
    [sym_block_comment] = STATE(1082),
    [sym_compiler_directive_decl] = STATE(1082),
    [sym_fsi_directive_decl] = STATE(1082),
    [sym_preproc_line] = STATE(1082),
    [aux_sym_if_expression_repeat1] = STATE(1082),
    [sym_identifier] = ACTIONS(2518),
    [anon_sym_EQ] = ACTIONS(2520),
    [anon_sym_COLON] = ACTIONS(2518),
    [anon_sym_return] = ACTIONS(2518),
    [anon_sym_do] = ACTIONS(2518),
    [anon_sym_let] = ACTIONS(2518),
    [anon_sym_let_BANG] = ACTIONS(2520),
    [anon_sym_as] = ACTIONS(2518),
    [anon_sym_LPAREN] = ACTIONS(2518),
    [anon_sym_COMMA] = ACTIONS(2520),
    [anon_sym_null] = ACTIONS(2518),
    [anon_sym_QMARK] = ACTIONS(2518),
    [anon_sym_COLON_QMARK] = ACTIONS(2518),
    [anon_sym_COLON_COLON] = ACTIONS(2520),
    [anon_sym_AMP] = ACTIONS(2518),
    [anon_sym_LBRACK] = ACTIONS(2518),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2520),
    [anon_sym_LBRACE] = ACTIONS(2518),
    [anon_sym_LT_AT] = ACTIONS(2518),
    [anon_sym_LT_AT_AT] = ACTIONS(2518),
    [anon_sym_DOT] = ACTIONS(2518),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2520),
    [anon_sym_new] = ACTIONS(2518),
    [anon_sym_with] = ACTIONS(2518),
    [anon_sym_return_BANG] = ACTIONS(2520),
    [anon_sym_yield] = ACTIONS(2518),
    [anon_sym_yield_BANG] = ACTIONS(2520),
    [anon_sym_lazy] = ACTIONS(2518),
    [anon_sym_assert] = ACTIONS(2518),
    [anon_sym_upcast] = ACTIONS(2518),
    [anon_sym_downcast] = ACTIONS(2518),
    [anon_sym_COLON_GT] = ACTIONS(2520),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2520),
    [anon_sym_for] = ACTIONS(2518),
    [anon_sym_while] = ACTIONS(2518),
    [anon_sym_else] = ACTIONS(2518),
    [anon_sym_elif] = ACTIONS(3308),
    [anon_sym_if] = ACTIONS(2518),
    [anon_sym_fun] = ACTIONS(2518),
    [anon_sym_try] = ACTIONS(2518),
    [anon_sym_match] = ACTIONS(2518),
    [anon_sym_match_BANG] = ACTIONS(2520),
    [anon_sym_function] = ACTIONS(2518),
    [anon_sym_LT_DASH] = ACTIONS(2518),
    [anon_sym_DOT_LBRACK] = ACTIONS(2520),
    [anon_sym_LT] = ACTIONS(2520),
    [anon_sym_use] = ACTIONS(2518),
    [anon_sym_use_BANG] = ACTIONS(2520),
    [anon_sym_do_BANG] = ACTIONS(2520),
    [anon_sym_begin] = ACTIONS(2518),
    [anon_sym_LPAREN2] = ACTIONS(2518),
    [anon_sym_or] = ACTIONS(2518),
    [aux_sym_char_token1] = ACTIONS(2520),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2518),
    [anon_sym_DQUOTE] = ACTIONS(2518),
    [anon_sym_AT_DQUOTE] = ACTIONS(2520),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2520),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2520),
    [sym_bool] = ACTIONS(2518),
    [sym_unit] = ACTIONS(2520),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2518),
    [sym_op_identifier] = ACTIONS(2518),
    [anon_sym_PLUS] = ACTIONS(2518),
    [anon_sym_DASH] = ACTIONS(2518),
    [anon_sym_PLUS_DOT] = ACTIONS(2518),
    [anon_sym_DASH_DOT] = ACTIONS(2518),
    [anon_sym_PERCENT] = ACTIONS(2518),
    [anon_sym_AMP_AMP] = ACTIONS(2518),
    [anon_sym_TILDE] = ACTIONS(2520),
    [aux_sym_prefix_op_token1] = ACTIONS(2518),
    [aux_sym_infix_op_token1] = ACTIONS(2520),
    [aux_sym_infix_op_token2] = ACTIONS(2518),
    [anon_sym_PIPE_PIPE] = ACTIONS(2518),
    [anon_sym_BANG_EQ] = ACTIONS(2518),
    [anon_sym_COLON_EQ] = ACTIONS(2520),
    [anon_sym_DOLLAR] = ACTIONS(2518),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2518),
    [sym_int] = ACTIONS(2518),
    [sym_xint] = ACTIONS(2520),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2520),
    [sym__newline] = ACTIONS(2520),
    [sym__dedent] = ACTIONS(2520),
  },
  [1083] = {
    [sym_block_comment] = STATE(1083),
    [sym_compiler_directive_decl] = STATE(1083),
    [sym_fsi_directive_decl] = STATE(1083),
    [sym_preproc_line] = STATE(1083),
    [sym_identifier] = ACTIONS(2340),
    [anon_sym_EQ] = ACTIONS(2342),
    [anon_sym_COLON] = ACTIONS(2340),
    [anon_sym_return] = ACTIONS(2340),
    [anon_sym_do] = ACTIONS(2340),
    [anon_sym_let] = ACTIONS(2340),
    [anon_sym_let_BANG] = ACTIONS(2342),
    [anon_sym_as] = ACTIONS(2340),
    [anon_sym_LPAREN] = ACTIONS(2340),
    [anon_sym_COMMA] = ACTIONS(2342),
    [anon_sym_null] = ACTIONS(2340),
    [anon_sym_QMARK] = ACTIONS(2340),
    [anon_sym_COLON_QMARK] = ACTIONS(2340),
    [anon_sym_COLON_COLON] = ACTIONS(2342),
    [anon_sym_AMP] = ACTIONS(2340),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2342),
    [anon_sym_LBRACE] = ACTIONS(2340),
    [anon_sym_LT_AT] = ACTIONS(2340),
    [anon_sym_LT_AT_AT] = ACTIONS(2340),
    [anon_sym_DOT] = ACTIONS(2340),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2342),
    [anon_sym_new] = ACTIONS(2340),
    [anon_sym_with] = ACTIONS(2340),
    [anon_sym_return_BANG] = ACTIONS(2342),
    [anon_sym_yield] = ACTIONS(2340),
    [anon_sym_yield_BANG] = ACTIONS(2342),
    [anon_sym_lazy] = ACTIONS(2340),
    [anon_sym_assert] = ACTIONS(2340),
    [anon_sym_upcast] = ACTIONS(2340),
    [anon_sym_downcast] = ACTIONS(2340),
    [anon_sym_COLON_GT] = ACTIONS(2342),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2342),
    [anon_sym_for] = ACTIONS(2340),
    [anon_sym_while] = ACTIONS(2340),
    [anon_sym_if] = ACTIONS(2340),
    [anon_sym_fun] = ACTIONS(2340),
    [anon_sym_DASH_GT] = ACTIONS(2340),
    [anon_sym_try] = ACTIONS(2340),
    [anon_sym_match] = ACTIONS(2340),
    [anon_sym_match_BANG] = ACTIONS(2342),
    [anon_sym_function] = ACTIONS(2340),
    [anon_sym_LT_DASH] = ACTIONS(2340),
    [anon_sym_DOT_LBRACK] = ACTIONS(2342),
    [anon_sym_LT] = ACTIONS(2342),
    [anon_sym_use] = ACTIONS(2340),
    [anon_sym_use_BANG] = ACTIONS(2342),
    [anon_sym_do_BANG] = ACTIONS(2342),
    [anon_sym_begin] = ACTIONS(2340),
    [anon_sym_LPAREN2] = ACTIONS(2340),
    [anon_sym_STAR] = ACTIONS(2340),
    [anon_sym_LT2] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2342),
    [anon_sym_or] = ACTIONS(2340),
    [aux_sym_char_token1] = ACTIONS(2342),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2340),
    [anon_sym_DQUOTE] = ACTIONS(2340),
    [anon_sym_AT_DQUOTE] = ACTIONS(2342),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2342),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2342),
    [sym_bool] = ACTIONS(2340),
    [sym_unit] = ACTIONS(2342),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2340),
    [sym_op_identifier] = ACTIONS(2340),
    [anon_sym_PLUS] = ACTIONS(2340),
    [anon_sym_DASH] = ACTIONS(2340),
    [anon_sym_PLUS_DOT] = ACTIONS(2340),
    [anon_sym_DASH_DOT] = ACTIONS(2340),
    [anon_sym_PERCENT] = ACTIONS(2340),
    [anon_sym_AMP_AMP] = ACTIONS(2340),
    [anon_sym_TILDE] = ACTIONS(2342),
    [aux_sym_prefix_op_token1] = ACTIONS(2340),
    [aux_sym_infix_op_token1] = ACTIONS(2342),
    [aux_sym_infix_op_token2] = ACTIONS(2340),
    [anon_sym_PIPE_PIPE] = ACTIONS(2340),
    [anon_sym_BANG_EQ] = ACTIONS(2340),
    [anon_sym_COLON_EQ] = ACTIONS(2342),
    [anon_sym_DOLLAR] = ACTIONS(2340),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2340),
    [sym_int] = ACTIONS(2340),
    [sym_xint] = ACTIONS(2342),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2342),
    [sym__newline] = ACTIONS(2342),
    [sym__dedent] = ACTIONS(2342),
  },
  [1084] = {
    [sym_block_comment] = STATE(1084),
    [sym_compiler_directive_decl] = STATE(1084),
    [sym_fsi_directive_decl] = STATE(1084),
    [sym_preproc_line] = STATE(1084),
    [sym_identifier] = ACTIONS(2906),
    [anon_sym_EQ] = ACTIONS(2908),
    [anon_sym_GT_RBRACK] = ACTIONS(2908),
    [anon_sym_COLON] = ACTIONS(2906),
    [anon_sym_return] = ACTIONS(2906),
    [anon_sym_do] = ACTIONS(2906),
    [anon_sym_let] = ACTIONS(2906),
    [anon_sym_let_BANG] = ACTIONS(2908),
    [anon_sym_LPAREN] = ACTIONS(2906),
    [anon_sym_COMMA] = ACTIONS(2908),
    [anon_sym_null] = ACTIONS(2906),
    [anon_sym_QMARK] = ACTIONS(2906),
    [anon_sym_COLON_QMARK] = ACTIONS(2906),
    [anon_sym_COLON_COLON] = ACTIONS(2908),
    [anon_sym_AMP] = ACTIONS(2906),
    [anon_sym_LBRACK] = ACTIONS(2906),
    [anon_sym_RBRACK] = ACTIONS(2908),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2908),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_RBRACE] = ACTIONS(2908),
    [anon_sym_LT_AT] = ACTIONS(2906),
    [anon_sym_LT_AT_AT] = ACTIONS(2906),
    [anon_sym_DOT] = ACTIONS(2906),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2908),
    [anon_sym_new] = ACTIONS(2906),
    [anon_sym_with] = ACTIONS(2906),
    [anon_sym_return_BANG] = ACTIONS(2908),
    [anon_sym_yield] = ACTIONS(2906),
    [anon_sym_yield_BANG] = ACTIONS(2908),
    [anon_sym_lazy] = ACTIONS(2906),
    [anon_sym_assert] = ACTIONS(2906),
    [anon_sym_upcast] = ACTIONS(2906),
    [anon_sym_downcast] = ACTIONS(2906),
    [anon_sym_COLON_GT] = ACTIONS(2908),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2908),
    [anon_sym_for] = ACTIONS(2906),
    [anon_sym_to] = ACTIONS(2906),
    [anon_sym_downto] = ACTIONS(2906),
    [anon_sym_while] = ACTIONS(2906),
    [anon_sym_if] = ACTIONS(2906),
    [anon_sym_fun] = ACTIONS(2906),
    [anon_sym_try] = ACTIONS(2906),
    [anon_sym_match] = ACTIONS(2906),
    [anon_sym_match_BANG] = ACTIONS(2908),
    [anon_sym_function] = ACTIONS(2906),
    [anon_sym_LT_DASH] = ACTIONS(2906),
    [anon_sym_DOT_LBRACK] = ACTIONS(2908),
    [anon_sym_LT] = ACTIONS(2908),
    [anon_sym_use] = ACTIONS(2906),
    [anon_sym_use_BANG] = ACTIONS(2908),
    [anon_sym_do_BANG] = ACTIONS(2908),
    [anon_sym_begin] = ACTIONS(2906),
    [anon_sym_LPAREN2] = ACTIONS(2906),
    [anon_sym_DOT_DOT2] = ACTIONS(2908),
    [anon_sym_or] = ACTIONS(2906),
    [aux_sym_char_token1] = ACTIONS(2908),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2906),
    [anon_sym_DQUOTE] = ACTIONS(2906),
    [anon_sym_AT_DQUOTE] = ACTIONS(2908),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2908),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2908),
    [sym_bool] = ACTIONS(2906),
    [sym_unit] = ACTIONS(2908),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2906),
    [sym_op_identifier] = ACTIONS(2906),
    [anon_sym_PLUS] = ACTIONS(2906),
    [anon_sym_DASH] = ACTIONS(2906),
    [anon_sym_PLUS_DOT] = ACTIONS(2906),
    [anon_sym_DASH_DOT] = ACTIONS(2906),
    [anon_sym_PERCENT] = ACTIONS(2906),
    [anon_sym_AMP_AMP] = ACTIONS(2906),
    [anon_sym_TILDE] = ACTIONS(2908),
    [aux_sym_prefix_op_token1] = ACTIONS(2906),
    [aux_sym_infix_op_token1] = ACTIONS(2908),
    [aux_sym_infix_op_token2] = ACTIONS(2906),
    [anon_sym_PIPE_PIPE] = ACTIONS(2906),
    [anon_sym_BANG_EQ] = ACTIONS(2906),
    [anon_sym_COLON_EQ] = ACTIONS(2908),
    [anon_sym_DOLLAR] = ACTIONS(2906),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2906),
    [sym_int] = ACTIONS(2906),
    [sym_xint] = ACTIONS(2908),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2908),
    [sym__newline] = ACTIONS(2908),
  },
  [1085] = {
    [sym_block_comment] = STATE(1085),
    [sym_compiler_directive_decl] = STATE(1085),
    [sym_fsi_directive_decl] = STATE(1085),
    [sym_preproc_line] = STATE(1085),
    [sym_identifier] = ACTIONS(2863),
    [anon_sym_EQ] = ACTIONS(2865),
    [anon_sym_GT_RBRACK] = ACTIONS(2865),
    [anon_sym_COLON] = ACTIONS(2863),
    [anon_sym_return] = ACTIONS(2863),
    [anon_sym_do] = ACTIONS(2863),
    [anon_sym_let] = ACTIONS(2863),
    [anon_sym_let_BANG] = ACTIONS(2865),
    [anon_sym_LPAREN] = ACTIONS(2863),
    [anon_sym_COMMA] = ACTIONS(2865),
    [anon_sym_null] = ACTIONS(2863),
    [anon_sym_QMARK] = ACTIONS(2863),
    [anon_sym_COLON_QMARK] = ACTIONS(2863),
    [anon_sym_COLON_COLON] = ACTIONS(2865),
    [anon_sym_AMP] = ACTIONS(2863),
    [anon_sym_LBRACK] = ACTIONS(2863),
    [anon_sym_RBRACK] = ACTIONS(2865),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2865),
    [anon_sym_LBRACE] = ACTIONS(2863),
    [anon_sym_RBRACE] = ACTIONS(2865),
    [anon_sym_LT_AT] = ACTIONS(2863),
    [anon_sym_LT_AT_AT] = ACTIONS(2863),
    [anon_sym_DOT] = ACTIONS(2863),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2865),
    [anon_sym_new] = ACTIONS(2863),
    [anon_sym_with] = ACTIONS(2863),
    [anon_sym_return_BANG] = ACTIONS(2865),
    [anon_sym_yield] = ACTIONS(2863),
    [anon_sym_yield_BANG] = ACTIONS(2865),
    [anon_sym_lazy] = ACTIONS(2863),
    [anon_sym_assert] = ACTIONS(2863),
    [anon_sym_upcast] = ACTIONS(2863),
    [anon_sym_downcast] = ACTIONS(2863),
    [anon_sym_COLON_GT] = ACTIONS(2865),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2865),
    [anon_sym_for] = ACTIONS(2863),
    [anon_sym_to] = ACTIONS(2863),
    [anon_sym_downto] = ACTIONS(2863),
    [anon_sym_while] = ACTIONS(2863),
    [anon_sym_if] = ACTIONS(2863),
    [anon_sym_fun] = ACTIONS(2863),
    [anon_sym_try] = ACTIONS(2863),
    [anon_sym_match] = ACTIONS(2863),
    [anon_sym_match_BANG] = ACTIONS(2865),
    [anon_sym_function] = ACTIONS(2863),
    [anon_sym_LT_DASH] = ACTIONS(2863),
    [anon_sym_DOT_LBRACK] = ACTIONS(2865),
    [anon_sym_LT] = ACTIONS(2865),
    [anon_sym_use] = ACTIONS(2863),
    [anon_sym_use_BANG] = ACTIONS(2865),
    [anon_sym_do_BANG] = ACTIONS(2865),
    [anon_sym_begin] = ACTIONS(2863),
    [anon_sym_LPAREN2] = ACTIONS(2863),
    [anon_sym_DOT_DOT2] = ACTIONS(2865),
    [anon_sym_or] = ACTIONS(2863),
    [aux_sym_char_token1] = ACTIONS(2865),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2863),
    [anon_sym_DQUOTE] = ACTIONS(2863),
    [anon_sym_AT_DQUOTE] = ACTIONS(2865),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2865),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2865),
    [sym_bool] = ACTIONS(2863),
    [sym_unit] = ACTIONS(2865),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2863),
    [sym_op_identifier] = ACTIONS(2863),
    [anon_sym_PLUS] = ACTIONS(2863),
    [anon_sym_DASH] = ACTIONS(2863),
    [anon_sym_PLUS_DOT] = ACTIONS(2863),
    [anon_sym_DASH_DOT] = ACTIONS(2863),
    [anon_sym_PERCENT] = ACTIONS(2863),
    [anon_sym_AMP_AMP] = ACTIONS(2863),
    [anon_sym_TILDE] = ACTIONS(2865),
    [aux_sym_prefix_op_token1] = ACTIONS(2863),
    [aux_sym_infix_op_token1] = ACTIONS(2865),
    [aux_sym_infix_op_token2] = ACTIONS(2863),
    [anon_sym_PIPE_PIPE] = ACTIONS(2863),
    [anon_sym_BANG_EQ] = ACTIONS(2863),
    [anon_sym_COLON_EQ] = ACTIONS(2865),
    [anon_sym_DOLLAR] = ACTIONS(2863),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2863),
    [sym_int] = ACTIONS(2863),
    [sym_xint] = ACTIONS(2865),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2865),
    [sym__newline] = ACTIONS(2865),
  },
  [1086] = {
    [sym__else_expression] = STATE(2023),
    [sym_elif_expression] = STATE(1410),
    [sym_block_comment] = STATE(1086),
    [sym_compiler_directive_decl] = STATE(1086),
    [sym_fsi_directive_decl] = STATE(1086),
    [sym_preproc_line] = STATE(1086),
    [aux_sym_if_expression_repeat1] = STATE(1174),
    [sym_identifier] = ACTIONS(2332),
    [anon_sym_EQ] = ACTIONS(2334),
    [anon_sym_COLON] = ACTIONS(2332),
    [anon_sym_return] = ACTIONS(2332),
    [anon_sym_do] = ACTIONS(2332),
    [anon_sym_let] = ACTIONS(2332),
    [anon_sym_let_BANG] = ACTIONS(2334),
    [anon_sym_LPAREN] = ACTIONS(2332),
    [anon_sym_COMMA] = ACTIONS(2334),
    [anon_sym_null] = ACTIONS(2332),
    [anon_sym_QMARK] = ACTIONS(2332),
    [anon_sym_COLON_QMARK] = ACTIONS(2332),
    [anon_sym_COLON_COLON] = ACTIONS(2334),
    [anon_sym_AMP] = ACTIONS(2332),
    [anon_sym_LBRACK] = ACTIONS(2332),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2334),
    [anon_sym_LBRACE] = ACTIONS(2332),
    [anon_sym_LT_AT] = ACTIONS(2332),
    [anon_sym_LT_AT_AT] = ACTIONS(2332),
    [anon_sym_DOT] = ACTIONS(2332),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2334),
    [anon_sym_new] = ACTIONS(2332),
    [anon_sym_return_BANG] = ACTIONS(2334),
    [anon_sym_yield] = ACTIONS(2332),
    [anon_sym_yield_BANG] = ACTIONS(2334),
    [anon_sym_lazy] = ACTIONS(2332),
    [anon_sym_assert] = ACTIONS(2332),
    [anon_sym_upcast] = ACTIONS(2332),
    [anon_sym_downcast] = ACTIONS(2332),
    [anon_sym_COLON_GT] = ACTIONS(2334),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2334),
    [anon_sym_for] = ACTIONS(2332),
    [anon_sym_while] = ACTIONS(2332),
    [anon_sym_else] = ACTIONS(3296),
    [anon_sym_elif] = ACTIONS(3298),
    [anon_sym_if] = ACTIONS(2332),
    [anon_sym_fun] = ACTIONS(2332),
    [anon_sym_try] = ACTIONS(2332),
    [anon_sym_match] = ACTIONS(2332),
    [anon_sym_match_BANG] = ACTIONS(2334),
    [anon_sym_function] = ACTIONS(2332),
    [anon_sym_LT_DASH] = ACTIONS(2332),
    [anon_sym_DOT_LBRACK] = ACTIONS(2334),
    [anon_sym_LT] = ACTIONS(2334),
    [anon_sym_use] = ACTIONS(2332),
    [anon_sym_use_BANG] = ACTIONS(2334),
    [anon_sym_do_BANG] = ACTIONS(2334),
    [anon_sym_begin] = ACTIONS(2332),
    [anon_sym_LPAREN2] = ACTIONS(2332),
    [anon_sym_or] = ACTIONS(2332),
    [aux_sym_char_token1] = ACTIONS(2334),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2332),
    [anon_sym_DQUOTE] = ACTIONS(2332),
    [anon_sym_AT_DQUOTE] = ACTIONS(2334),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2334),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2334),
    [sym_bool] = ACTIONS(2332),
    [sym_unit] = ACTIONS(2334),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2332),
    [sym_op_identifier] = ACTIONS(2332),
    [anon_sym_PLUS] = ACTIONS(2332),
    [anon_sym_DASH] = ACTIONS(2332),
    [anon_sym_PLUS_DOT] = ACTIONS(2332),
    [anon_sym_DASH_DOT] = ACTIONS(2332),
    [anon_sym_PERCENT] = ACTIONS(2332),
    [anon_sym_AMP_AMP] = ACTIONS(2332),
    [anon_sym_TILDE] = ACTIONS(2334),
    [aux_sym_prefix_op_token1] = ACTIONS(2332),
    [aux_sym_infix_op_token1] = ACTIONS(2334),
    [aux_sym_infix_op_token2] = ACTIONS(2332),
    [anon_sym_PIPE_PIPE] = ACTIONS(2332),
    [anon_sym_BANG_EQ] = ACTIONS(2332),
    [anon_sym_COLON_EQ] = ACTIONS(2334),
    [anon_sym_DOLLAR] = ACTIONS(2332),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2332),
    [sym_int] = ACTIONS(2332),
    [sym_xint] = ACTIONS(2334),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2334),
    [anon_sym_POUNDendif] = ACTIONS(2334),
    [anon_sym_POUNDelse] = ACTIONS(2334),
    [sym__newline] = ACTIONS(2334),
  },
  [1087] = {
    [sym_block_comment] = STATE(1087),
    [sym_compiler_directive_decl] = STATE(1087),
    [sym_fsi_directive_decl] = STATE(1087),
    [sym_preproc_line] = STATE(1087),
    [sym_identifier] = ACTIONS(2902),
    [anon_sym_EQ] = ACTIONS(2904),
    [anon_sym_GT_RBRACK] = ACTIONS(2904),
    [anon_sym_COLON] = ACTIONS(2902),
    [anon_sym_return] = ACTIONS(2902),
    [anon_sym_do] = ACTIONS(2902),
    [anon_sym_let] = ACTIONS(2902),
    [anon_sym_let_BANG] = ACTIONS(2904),
    [anon_sym_LPAREN] = ACTIONS(2902),
    [anon_sym_COMMA] = ACTIONS(2904),
    [anon_sym_null] = ACTIONS(2902),
    [anon_sym_QMARK] = ACTIONS(2902),
    [anon_sym_COLON_QMARK] = ACTIONS(2902),
    [anon_sym_COLON_COLON] = ACTIONS(2904),
    [anon_sym_AMP] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2902),
    [anon_sym_RBRACK] = ACTIONS(2904),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2902),
    [anon_sym_RBRACE] = ACTIONS(2904),
    [anon_sym_LT_AT] = ACTIONS(2902),
    [anon_sym_LT_AT_AT] = ACTIONS(2902),
    [anon_sym_DOT] = ACTIONS(2902),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2904),
    [anon_sym_new] = ACTIONS(2902),
    [anon_sym_with] = ACTIONS(2902),
    [anon_sym_return_BANG] = ACTIONS(2904),
    [anon_sym_yield] = ACTIONS(2902),
    [anon_sym_yield_BANG] = ACTIONS(2904),
    [anon_sym_lazy] = ACTIONS(2902),
    [anon_sym_assert] = ACTIONS(2902),
    [anon_sym_upcast] = ACTIONS(2902),
    [anon_sym_downcast] = ACTIONS(2902),
    [anon_sym_COLON_GT] = ACTIONS(2904),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2904),
    [anon_sym_for] = ACTIONS(2902),
    [anon_sym_to] = ACTIONS(2902),
    [anon_sym_downto] = ACTIONS(2902),
    [anon_sym_while] = ACTIONS(2902),
    [anon_sym_if] = ACTIONS(2902),
    [anon_sym_fun] = ACTIONS(2902),
    [anon_sym_try] = ACTIONS(2902),
    [anon_sym_match] = ACTIONS(2902),
    [anon_sym_match_BANG] = ACTIONS(2904),
    [anon_sym_function] = ACTIONS(2902),
    [anon_sym_LT_DASH] = ACTIONS(2902),
    [anon_sym_DOT_LBRACK] = ACTIONS(2904),
    [anon_sym_LT] = ACTIONS(2904),
    [anon_sym_use] = ACTIONS(2902),
    [anon_sym_use_BANG] = ACTIONS(2904),
    [anon_sym_do_BANG] = ACTIONS(2904),
    [anon_sym_begin] = ACTIONS(2902),
    [anon_sym_LPAREN2] = ACTIONS(2902),
    [anon_sym_DOT_DOT2] = ACTIONS(2904),
    [anon_sym_or] = ACTIONS(2902),
    [aux_sym_char_token1] = ACTIONS(2904),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2902),
    [anon_sym_DQUOTE] = ACTIONS(2902),
    [anon_sym_AT_DQUOTE] = ACTIONS(2904),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2904),
    [sym_bool] = ACTIONS(2902),
    [sym_unit] = ACTIONS(2904),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2902),
    [sym_op_identifier] = ACTIONS(2902),
    [anon_sym_PLUS] = ACTIONS(2902),
    [anon_sym_DASH] = ACTIONS(2902),
    [anon_sym_PLUS_DOT] = ACTIONS(2902),
    [anon_sym_DASH_DOT] = ACTIONS(2902),
    [anon_sym_PERCENT] = ACTIONS(2902),
    [anon_sym_AMP_AMP] = ACTIONS(2902),
    [anon_sym_TILDE] = ACTIONS(2904),
    [aux_sym_prefix_op_token1] = ACTIONS(2902),
    [aux_sym_infix_op_token1] = ACTIONS(2904),
    [aux_sym_infix_op_token2] = ACTIONS(2902),
    [anon_sym_PIPE_PIPE] = ACTIONS(2902),
    [anon_sym_BANG_EQ] = ACTIONS(2902),
    [anon_sym_COLON_EQ] = ACTIONS(2904),
    [anon_sym_DOLLAR] = ACTIONS(2902),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2902),
    [sym_int] = ACTIONS(2902),
    [sym_xint] = ACTIONS(2904),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2904),
    [sym__newline] = ACTIONS(2904),
  },
  [1088] = {
    [sym_block_comment] = STATE(1088),
    [sym_compiler_directive_decl] = STATE(1088),
    [sym_fsi_directive_decl] = STATE(1088),
    [sym_preproc_line] = STATE(1088),
    [sym_identifier] = ACTIONS(3027),
    [anon_sym_EQ] = ACTIONS(3029),
    [anon_sym_GT_RBRACK] = ACTIONS(3029),
    [anon_sym_COLON] = ACTIONS(3027),
    [anon_sym_return] = ACTIONS(3027),
    [anon_sym_do] = ACTIONS(3027),
    [anon_sym_let] = ACTIONS(3027),
    [anon_sym_let_BANG] = ACTIONS(3029),
    [anon_sym_LPAREN] = ACTIONS(3027),
    [anon_sym_COMMA] = ACTIONS(3029),
    [anon_sym_null] = ACTIONS(3027),
    [anon_sym_QMARK] = ACTIONS(3027),
    [anon_sym_COLON_QMARK] = ACTIONS(3027),
    [anon_sym_COLON_COLON] = ACTIONS(3029),
    [anon_sym_AMP] = ACTIONS(3027),
    [anon_sym_LBRACK] = ACTIONS(3027),
    [anon_sym_RBRACK] = ACTIONS(3029),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3027),
    [anon_sym_RBRACE] = ACTIONS(3029),
    [anon_sym_LT_AT] = ACTIONS(3027),
    [anon_sym_LT_AT_AT] = ACTIONS(3027),
    [anon_sym_DOT] = ACTIONS(3027),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3029),
    [anon_sym_new] = ACTIONS(3027),
    [anon_sym_with] = ACTIONS(3027),
    [anon_sym_return_BANG] = ACTIONS(3029),
    [anon_sym_yield] = ACTIONS(3027),
    [anon_sym_yield_BANG] = ACTIONS(3029),
    [anon_sym_lazy] = ACTIONS(3027),
    [anon_sym_assert] = ACTIONS(3027),
    [anon_sym_upcast] = ACTIONS(3027),
    [anon_sym_downcast] = ACTIONS(3027),
    [anon_sym_COLON_GT] = ACTIONS(3029),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3029),
    [anon_sym_for] = ACTIONS(3027),
    [anon_sym_to] = ACTIONS(3027),
    [anon_sym_downto] = ACTIONS(3027),
    [anon_sym_while] = ACTIONS(3027),
    [anon_sym_if] = ACTIONS(3027),
    [anon_sym_fun] = ACTIONS(3027),
    [anon_sym_try] = ACTIONS(3027),
    [anon_sym_match] = ACTIONS(3027),
    [anon_sym_match_BANG] = ACTIONS(3029),
    [anon_sym_function] = ACTIONS(3027),
    [anon_sym_LT_DASH] = ACTIONS(3027),
    [anon_sym_DOT_LBRACK] = ACTIONS(3029),
    [anon_sym_LT] = ACTIONS(3029),
    [anon_sym_use] = ACTIONS(3027),
    [anon_sym_use_BANG] = ACTIONS(3029),
    [anon_sym_do_BANG] = ACTIONS(3029),
    [anon_sym_begin] = ACTIONS(3027),
    [anon_sym_LPAREN2] = ACTIONS(3027),
    [anon_sym_DOT_DOT2] = ACTIONS(3029),
    [anon_sym_or] = ACTIONS(3027),
    [aux_sym_char_token1] = ACTIONS(3029),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3027),
    [anon_sym_DQUOTE] = ACTIONS(3027),
    [anon_sym_AT_DQUOTE] = ACTIONS(3029),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3029),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3029),
    [sym_bool] = ACTIONS(3027),
    [sym_unit] = ACTIONS(3029),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3027),
    [sym_op_identifier] = ACTIONS(3027),
    [anon_sym_PLUS] = ACTIONS(3027),
    [anon_sym_DASH] = ACTIONS(3027),
    [anon_sym_PLUS_DOT] = ACTIONS(3027),
    [anon_sym_DASH_DOT] = ACTIONS(3027),
    [anon_sym_PERCENT] = ACTIONS(3027),
    [anon_sym_AMP_AMP] = ACTIONS(3027),
    [anon_sym_TILDE] = ACTIONS(3029),
    [aux_sym_prefix_op_token1] = ACTIONS(3027),
    [aux_sym_infix_op_token1] = ACTIONS(3029),
    [aux_sym_infix_op_token2] = ACTIONS(3027),
    [anon_sym_PIPE_PIPE] = ACTIONS(3027),
    [anon_sym_BANG_EQ] = ACTIONS(3027),
    [anon_sym_COLON_EQ] = ACTIONS(3029),
    [anon_sym_DOLLAR] = ACTIONS(3027),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3027),
    [sym_int] = ACTIONS(3027),
    [sym_xint] = ACTIONS(3029),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3029),
    [sym__newline] = ACTIONS(3029),
  },
  [1089] = {
    [sym__else_expression] = STATE(1763),
    [sym_elif_expression] = STATE(1432),
    [sym_block_comment] = STATE(1089),
    [sym_compiler_directive_decl] = STATE(1089),
    [sym_fsi_directive_decl] = STATE(1089),
    [sym_preproc_line] = STATE(1089),
    [aux_sym_if_expression_repeat1] = STATE(1267),
    [sym_identifier] = ACTIONS(2332),
    [anon_sym_EQ] = ACTIONS(2334),
    [anon_sym_COLON] = ACTIONS(2332),
    [anon_sym_return] = ACTIONS(2332),
    [anon_sym_do] = ACTIONS(2332),
    [anon_sym_and] = ACTIONS(2332),
    [anon_sym_let] = ACTIONS(2332),
    [anon_sym_let_BANG] = ACTIONS(2334),
    [anon_sym_LPAREN] = ACTIONS(2332),
    [anon_sym_COMMA] = ACTIONS(2334),
    [anon_sym_null] = ACTIONS(2332),
    [anon_sym_QMARK] = ACTIONS(2332),
    [anon_sym_COLON_QMARK] = ACTIONS(2332),
    [anon_sym_COLON_COLON] = ACTIONS(2334),
    [anon_sym_AMP] = ACTIONS(2332),
    [anon_sym_LBRACK] = ACTIONS(2332),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2334),
    [anon_sym_LBRACE] = ACTIONS(2332),
    [anon_sym_LT_AT] = ACTIONS(2332),
    [anon_sym_LT_AT_AT] = ACTIONS(2332),
    [anon_sym_DOT] = ACTIONS(2332),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2334),
    [anon_sym_new] = ACTIONS(2332),
    [anon_sym_return_BANG] = ACTIONS(2334),
    [anon_sym_yield] = ACTIONS(2332),
    [anon_sym_yield_BANG] = ACTIONS(2334),
    [anon_sym_lazy] = ACTIONS(2332),
    [anon_sym_assert] = ACTIONS(2332),
    [anon_sym_upcast] = ACTIONS(2332),
    [anon_sym_downcast] = ACTIONS(2332),
    [anon_sym_COLON_GT] = ACTIONS(2334),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2334),
    [anon_sym_for] = ACTIONS(2332),
    [anon_sym_while] = ACTIONS(2332),
    [anon_sym_else] = ACTIONS(3292),
    [anon_sym_elif] = ACTIONS(3294),
    [anon_sym_if] = ACTIONS(2332),
    [anon_sym_fun] = ACTIONS(2332),
    [anon_sym_try] = ACTIONS(2332),
    [anon_sym_match] = ACTIONS(2332),
    [anon_sym_match_BANG] = ACTIONS(2334),
    [anon_sym_function] = ACTIONS(2332),
    [anon_sym_LT_DASH] = ACTIONS(2332),
    [anon_sym_DOT_LBRACK] = ACTIONS(2334),
    [anon_sym_LT] = ACTIONS(2334),
    [anon_sym_use] = ACTIONS(2332),
    [anon_sym_use_BANG] = ACTIONS(2334),
    [anon_sym_do_BANG] = ACTIONS(2334),
    [anon_sym_begin] = ACTIONS(2332),
    [anon_sym_LPAREN2] = ACTIONS(2332),
    [anon_sym_or] = ACTIONS(2332),
    [aux_sym_char_token1] = ACTIONS(2334),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2332),
    [anon_sym_DQUOTE] = ACTIONS(2332),
    [anon_sym_AT_DQUOTE] = ACTIONS(2334),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2334),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2334),
    [sym_bool] = ACTIONS(2332),
    [sym_unit] = ACTIONS(2334),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2332),
    [sym_op_identifier] = ACTIONS(2332),
    [anon_sym_PLUS] = ACTIONS(2332),
    [anon_sym_DASH] = ACTIONS(2332),
    [anon_sym_PLUS_DOT] = ACTIONS(2332),
    [anon_sym_DASH_DOT] = ACTIONS(2332),
    [anon_sym_PERCENT] = ACTIONS(2332),
    [anon_sym_AMP_AMP] = ACTIONS(2332),
    [anon_sym_TILDE] = ACTIONS(2334),
    [aux_sym_prefix_op_token1] = ACTIONS(2332),
    [aux_sym_infix_op_token1] = ACTIONS(2334),
    [aux_sym_infix_op_token2] = ACTIONS(2332),
    [anon_sym_PIPE_PIPE] = ACTIONS(2332),
    [anon_sym_BANG_EQ] = ACTIONS(2332),
    [anon_sym_COLON_EQ] = ACTIONS(2334),
    [anon_sym_DOLLAR] = ACTIONS(2332),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2332),
    [sym_int] = ACTIONS(2332),
    [sym_xint] = ACTIONS(2334),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2334),
    [sym__newline] = ACTIONS(2334),
    [sym__dedent] = ACTIONS(2334),
  },
  [1090] = {
    [sym_block_comment] = STATE(1090),
    [sym_compiler_directive_decl] = STATE(1090),
    [sym_fsi_directive_decl] = STATE(1090),
    [sym_preproc_line] = STATE(1090),
    [sym_identifier] = ACTIONS(2855),
    [anon_sym_EQ] = ACTIONS(2857),
    [anon_sym_GT_RBRACK] = ACTIONS(2857),
    [anon_sym_COLON] = ACTIONS(2855),
    [anon_sym_return] = ACTIONS(2855),
    [anon_sym_do] = ACTIONS(2855),
    [anon_sym_let] = ACTIONS(2855),
    [anon_sym_let_BANG] = ACTIONS(2857),
    [anon_sym_LPAREN] = ACTIONS(2855),
    [anon_sym_COMMA] = ACTIONS(2857),
    [anon_sym_null] = ACTIONS(2855),
    [anon_sym_QMARK] = ACTIONS(2855),
    [anon_sym_COLON_QMARK] = ACTIONS(2855),
    [anon_sym_COLON_COLON] = ACTIONS(2857),
    [anon_sym_AMP] = ACTIONS(2855),
    [anon_sym_LBRACK] = ACTIONS(2855),
    [anon_sym_RBRACK] = ACTIONS(2857),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2857),
    [anon_sym_LBRACE] = ACTIONS(2855),
    [anon_sym_RBRACE] = ACTIONS(2857),
    [anon_sym_LT_AT] = ACTIONS(2855),
    [anon_sym_LT_AT_AT] = ACTIONS(2855),
    [anon_sym_DOT] = ACTIONS(2855),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2857),
    [anon_sym_new] = ACTIONS(2855),
    [anon_sym_with] = ACTIONS(2855),
    [anon_sym_return_BANG] = ACTIONS(2857),
    [anon_sym_yield] = ACTIONS(2855),
    [anon_sym_yield_BANG] = ACTIONS(2857),
    [anon_sym_lazy] = ACTIONS(2855),
    [anon_sym_assert] = ACTIONS(2855),
    [anon_sym_upcast] = ACTIONS(2855),
    [anon_sym_downcast] = ACTIONS(2855),
    [anon_sym_COLON_GT] = ACTIONS(2857),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2857),
    [anon_sym_for] = ACTIONS(2855),
    [anon_sym_to] = ACTIONS(2855),
    [anon_sym_downto] = ACTIONS(2855),
    [anon_sym_while] = ACTIONS(2855),
    [anon_sym_if] = ACTIONS(2855),
    [anon_sym_fun] = ACTIONS(2855),
    [anon_sym_try] = ACTIONS(2855),
    [anon_sym_match] = ACTIONS(2855),
    [anon_sym_match_BANG] = ACTIONS(2857),
    [anon_sym_function] = ACTIONS(2855),
    [anon_sym_LT_DASH] = ACTIONS(2855),
    [anon_sym_DOT_LBRACK] = ACTIONS(2857),
    [anon_sym_LT] = ACTIONS(2857),
    [anon_sym_use] = ACTIONS(2855),
    [anon_sym_use_BANG] = ACTIONS(2857),
    [anon_sym_do_BANG] = ACTIONS(2857),
    [anon_sym_begin] = ACTIONS(2855),
    [anon_sym_LPAREN2] = ACTIONS(2855),
    [anon_sym_DOT_DOT2] = ACTIONS(2857),
    [anon_sym_or] = ACTIONS(2855),
    [aux_sym_char_token1] = ACTIONS(2857),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2855),
    [anon_sym_DQUOTE] = ACTIONS(2855),
    [anon_sym_AT_DQUOTE] = ACTIONS(2857),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2857),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2857),
    [sym_bool] = ACTIONS(2855),
    [sym_unit] = ACTIONS(2857),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2855),
    [sym_op_identifier] = ACTIONS(2855),
    [anon_sym_PLUS] = ACTIONS(2855),
    [anon_sym_DASH] = ACTIONS(2855),
    [anon_sym_PLUS_DOT] = ACTIONS(2855),
    [anon_sym_DASH_DOT] = ACTIONS(2855),
    [anon_sym_PERCENT] = ACTIONS(2855),
    [anon_sym_AMP_AMP] = ACTIONS(2855),
    [anon_sym_TILDE] = ACTIONS(2857),
    [aux_sym_prefix_op_token1] = ACTIONS(2855),
    [aux_sym_infix_op_token1] = ACTIONS(2857),
    [aux_sym_infix_op_token2] = ACTIONS(2855),
    [anon_sym_PIPE_PIPE] = ACTIONS(2855),
    [anon_sym_BANG_EQ] = ACTIONS(2855),
    [anon_sym_COLON_EQ] = ACTIONS(2857),
    [anon_sym_DOLLAR] = ACTIONS(2855),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2855),
    [sym_int] = ACTIONS(2855),
    [sym_xint] = ACTIONS(2857),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2857),
    [sym__newline] = ACTIONS(2857),
  },
  [1091] = {
    [sym_type_arguments] = STATE(920),
    [sym_long_identifier] = STATE(923),
    [sym_block_comment] = STATE(1091),
    [sym_compiler_directive_decl] = STATE(1091),
    [sym_fsi_directive_decl] = STATE(1091),
    [sym_preproc_line] = STATE(1091),
    [aux_sym_compound_type_repeat1] = STATE(848),
    [sym_identifier] = ACTIONS(2252),
    [anon_sym_EQ] = ACTIONS(2254),
    [anon_sym_COLON] = ACTIONS(2252),
    [anon_sym_return] = ACTIONS(2252),
    [anon_sym_do] = ACTIONS(2252),
    [anon_sym_let] = ACTIONS(2252),
    [anon_sym_let_BANG] = ACTIONS(2254),
    [anon_sym_LPAREN] = ACTIONS(2252),
    [anon_sym_COMMA] = ACTIONS(2254),
    [anon_sym_null] = ACTIONS(2252),
    [anon_sym_QMARK] = ACTIONS(2252),
    [anon_sym_COLON_QMARK] = ACTIONS(2252),
    [anon_sym_COLON_COLON] = ACTIONS(2254),
    [anon_sym_AMP] = ACTIONS(2252),
    [anon_sym_LBRACK] = ACTIONS(2252),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2254),
    [anon_sym_LBRACE] = ACTIONS(2252),
    [anon_sym_LT_AT] = ACTIONS(2252),
    [anon_sym_LT_AT_AT] = ACTIONS(2252),
    [anon_sym_DOT] = ACTIONS(2252),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2254),
    [anon_sym_new] = ACTIONS(2252),
    [anon_sym_return_BANG] = ACTIONS(2254),
    [anon_sym_yield] = ACTIONS(2252),
    [anon_sym_yield_BANG] = ACTIONS(2254),
    [anon_sym_lazy] = ACTIONS(2252),
    [anon_sym_assert] = ACTIONS(2252),
    [anon_sym_upcast] = ACTIONS(2252),
    [anon_sym_downcast] = ACTIONS(2252),
    [anon_sym_COLON_GT] = ACTIONS(2254),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2254),
    [anon_sym_for] = ACTIONS(2252),
    [anon_sym_while] = ACTIONS(2252),
    [anon_sym_if] = ACTIONS(2252),
    [anon_sym_fun] = ACTIONS(2252),
    [anon_sym_DASH_GT] = ACTIONS(2252),
    [anon_sym_try] = ACTIONS(2252),
    [anon_sym_match] = ACTIONS(2252),
    [anon_sym_match_BANG] = ACTIONS(2254),
    [anon_sym_function] = ACTIONS(2252),
    [anon_sym_LT_DASH] = ACTIONS(2252),
    [anon_sym_DOT_LBRACK] = ACTIONS(2254),
    [anon_sym_LT] = ACTIONS(2254),
    [anon_sym_use] = ACTIONS(2252),
    [anon_sym_use_BANG] = ACTIONS(2254),
    [anon_sym_do_BANG] = ACTIONS(2254),
    [anon_sym_begin] = ACTIONS(2252),
    [anon_sym_LPAREN2] = ACTIONS(2252),
    [anon_sym_STAR] = ACTIONS(2663),
    [anon_sym_LT2] = ACTIONS(2665),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2667),
    [anon_sym_or] = ACTIONS(2252),
    [aux_sym_char_token1] = ACTIONS(2254),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2252),
    [anon_sym_DQUOTE] = ACTIONS(2252),
    [anon_sym_AT_DQUOTE] = ACTIONS(2254),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2254),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2254),
    [sym_bool] = ACTIONS(2252),
    [sym_unit] = ACTIONS(2254),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2252),
    [sym_op_identifier] = ACTIONS(2252),
    [anon_sym_PLUS] = ACTIONS(2252),
    [anon_sym_DASH] = ACTIONS(2252),
    [anon_sym_PLUS_DOT] = ACTIONS(2252),
    [anon_sym_DASH_DOT] = ACTIONS(2252),
    [anon_sym_PERCENT] = ACTIONS(2252),
    [anon_sym_AMP_AMP] = ACTIONS(2252),
    [anon_sym_TILDE] = ACTIONS(2254),
    [aux_sym_prefix_op_token1] = ACTIONS(2252),
    [aux_sym_infix_op_token1] = ACTIONS(2254),
    [aux_sym_infix_op_token2] = ACTIONS(2252),
    [anon_sym_PIPE_PIPE] = ACTIONS(2252),
    [anon_sym_BANG_EQ] = ACTIONS(2252),
    [anon_sym_COLON_EQ] = ACTIONS(2254),
    [anon_sym_DOLLAR] = ACTIONS(2252),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2252),
    [sym_int] = ACTIONS(2252),
    [sym_xint] = ACTIONS(2254),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2254),
    [sym__newline] = ACTIONS(2254),
  },
  [1092] = {
    [sym_block_comment] = STATE(1092),
    [sym_compiler_directive_decl] = STATE(1092),
    [sym_fsi_directive_decl] = STATE(1092),
    [sym_preproc_line] = STATE(1092),
    [aux_sym_long_identifier_repeat1] = STATE(1092),
    [sym_identifier] = ACTIONS(2411),
    [anon_sym_EQ] = ACTIONS(2413),
    [anon_sym_COLON] = ACTIONS(2411),
    [anon_sym_return] = ACTIONS(2411),
    [anon_sym_do] = ACTIONS(2411),
    [anon_sym_and] = ACTIONS(2411),
    [anon_sym_let] = ACTIONS(2411),
    [anon_sym_let_BANG] = ACTIONS(2413),
    [anon_sym_LPAREN] = ACTIONS(2411),
    [anon_sym_COMMA] = ACTIONS(2413),
    [anon_sym_null] = ACTIONS(2411),
    [anon_sym_QMARK] = ACTIONS(2411),
    [anon_sym_COLON_QMARK] = ACTIONS(2411),
    [anon_sym_COLON_COLON] = ACTIONS(2413),
    [anon_sym_AMP] = ACTIONS(2411),
    [anon_sym_LBRACK] = ACTIONS(2411),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2413),
    [anon_sym_LBRACE] = ACTIONS(2411),
    [anon_sym_LT_AT] = ACTIONS(2411),
    [anon_sym_LT_AT_AT] = ACTIONS(2411),
    [anon_sym_DOT] = ACTIONS(3311),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2413),
    [anon_sym_new] = ACTIONS(2411),
    [anon_sym_return_BANG] = ACTIONS(2413),
    [anon_sym_yield] = ACTIONS(2411),
    [anon_sym_yield_BANG] = ACTIONS(2413),
    [anon_sym_lazy] = ACTIONS(2411),
    [anon_sym_assert] = ACTIONS(2411),
    [anon_sym_upcast] = ACTIONS(2411),
    [anon_sym_downcast] = ACTIONS(2411),
    [anon_sym_COLON_GT] = ACTIONS(2413),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2413),
    [anon_sym_for] = ACTIONS(2411),
    [anon_sym_while] = ACTIONS(2411),
    [anon_sym_if] = ACTIONS(2411),
    [anon_sym_fun] = ACTIONS(2411),
    [anon_sym_DASH_GT] = ACTIONS(2411),
    [anon_sym_try] = ACTIONS(2411),
    [anon_sym_match] = ACTIONS(2411),
    [anon_sym_match_BANG] = ACTIONS(2413),
    [anon_sym_function] = ACTIONS(2411),
    [anon_sym_LT_DASH] = ACTIONS(2411),
    [anon_sym_DOT_LBRACK] = ACTIONS(2413),
    [anon_sym_LT] = ACTIONS(2413),
    [anon_sym_use] = ACTIONS(2411),
    [anon_sym_use_BANG] = ACTIONS(2413),
    [anon_sym_do_BANG] = ACTIONS(2413),
    [anon_sym_begin] = ACTIONS(2411),
    [anon_sym_LPAREN2] = ACTIONS(2411),
    [anon_sym_STAR] = ACTIONS(2411),
    [anon_sym_LT2] = ACTIONS(2411),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2413),
    [anon_sym_or] = ACTIONS(2411),
    [aux_sym_char_token1] = ACTIONS(2413),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2411),
    [anon_sym_DQUOTE] = ACTIONS(2411),
    [anon_sym_AT_DQUOTE] = ACTIONS(2413),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2413),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2413),
    [sym_bool] = ACTIONS(2411),
    [sym_unit] = ACTIONS(2413),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2411),
    [sym_op_identifier] = ACTIONS(2411),
    [anon_sym_PLUS] = ACTIONS(2411),
    [anon_sym_DASH] = ACTIONS(2411),
    [anon_sym_PLUS_DOT] = ACTIONS(2411),
    [anon_sym_DASH_DOT] = ACTIONS(2411),
    [anon_sym_PERCENT] = ACTIONS(2411),
    [anon_sym_AMP_AMP] = ACTIONS(2411),
    [anon_sym_TILDE] = ACTIONS(2413),
    [aux_sym_prefix_op_token1] = ACTIONS(2411),
    [aux_sym_infix_op_token1] = ACTIONS(2413),
    [aux_sym_infix_op_token2] = ACTIONS(2411),
    [anon_sym_PIPE_PIPE] = ACTIONS(2411),
    [anon_sym_BANG_EQ] = ACTIONS(2411),
    [anon_sym_COLON_EQ] = ACTIONS(2413),
    [anon_sym_DOLLAR] = ACTIONS(2411),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2411),
    [sym_int] = ACTIONS(2411),
    [sym_xint] = ACTIONS(2413),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2413),
    [sym__newline] = ACTIONS(2413),
    [sym__dedent] = ACTIONS(2413),
  },
  [1093] = {
    [sym_block_comment] = STATE(1093),
    [sym_compiler_directive_decl] = STATE(1093),
    [sym_fsi_directive_decl] = STATE(1093),
    [sym_preproc_line] = STATE(1093),
    [sym_identifier] = ACTIONS(2881),
    [anon_sym_EQ] = ACTIONS(2789),
    [anon_sym_GT_RBRACK] = ACTIONS(2789),
    [anon_sym_COLON] = ACTIONS(2881),
    [anon_sym_return] = ACTIONS(2881),
    [anon_sym_do] = ACTIONS(2881),
    [anon_sym_let] = ACTIONS(2881),
    [anon_sym_let_BANG] = ACTIONS(2789),
    [anon_sym_LPAREN] = ACTIONS(2881),
    [anon_sym_COMMA] = ACTIONS(2789),
    [anon_sym_null] = ACTIONS(2881),
    [anon_sym_QMARK] = ACTIONS(2881),
    [anon_sym_COLON_QMARK] = ACTIONS(2881),
    [anon_sym_COLON_COLON] = ACTIONS(2789),
    [anon_sym_AMP] = ACTIONS(2881),
    [anon_sym_LBRACK] = ACTIONS(2881),
    [anon_sym_RBRACK] = ACTIONS(2789),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2789),
    [anon_sym_LBRACE] = ACTIONS(2881),
    [anon_sym_RBRACE] = ACTIONS(2789),
    [anon_sym_LT_AT] = ACTIONS(2881),
    [anon_sym_LT_AT_AT] = ACTIONS(2881),
    [anon_sym_DOT] = ACTIONS(2881),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2789),
    [anon_sym_new] = ACTIONS(2881),
    [anon_sym_with] = ACTIONS(2881),
    [anon_sym_return_BANG] = ACTIONS(2789),
    [anon_sym_yield] = ACTIONS(2881),
    [anon_sym_yield_BANG] = ACTIONS(2789),
    [anon_sym_lazy] = ACTIONS(2881),
    [anon_sym_assert] = ACTIONS(2881),
    [anon_sym_upcast] = ACTIONS(2881),
    [anon_sym_downcast] = ACTIONS(2881),
    [anon_sym_COLON_GT] = ACTIONS(2789),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2789),
    [anon_sym_for] = ACTIONS(2881),
    [anon_sym_to] = ACTIONS(2881),
    [anon_sym_downto] = ACTIONS(2881),
    [anon_sym_while] = ACTIONS(2881),
    [anon_sym_if] = ACTIONS(2881),
    [anon_sym_fun] = ACTIONS(2881),
    [anon_sym_try] = ACTIONS(2881),
    [anon_sym_match] = ACTIONS(2881),
    [anon_sym_match_BANG] = ACTIONS(2789),
    [anon_sym_function] = ACTIONS(2881),
    [anon_sym_LT_DASH] = ACTIONS(2881),
    [anon_sym_DOT_LBRACK] = ACTIONS(2789),
    [anon_sym_LT] = ACTIONS(2789),
    [anon_sym_use] = ACTIONS(2881),
    [anon_sym_use_BANG] = ACTIONS(2789),
    [anon_sym_do_BANG] = ACTIONS(2789),
    [anon_sym_begin] = ACTIONS(2881),
    [anon_sym_LPAREN2] = ACTIONS(2881),
    [anon_sym_DOT_DOT2] = ACTIONS(2789),
    [anon_sym_or] = ACTIONS(2881),
    [aux_sym_char_token1] = ACTIONS(2789),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2881),
    [anon_sym_DQUOTE] = ACTIONS(2881),
    [anon_sym_AT_DQUOTE] = ACTIONS(2789),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2789),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2789),
    [sym_bool] = ACTIONS(2881),
    [sym_unit] = ACTIONS(2789),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2881),
    [sym_op_identifier] = ACTIONS(2881),
    [anon_sym_PLUS] = ACTIONS(2881),
    [anon_sym_DASH] = ACTIONS(2881),
    [anon_sym_PLUS_DOT] = ACTIONS(2881),
    [anon_sym_DASH_DOT] = ACTIONS(2881),
    [anon_sym_PERCENT] = ACTIONS(2881),
    [anon_sym_AMP_AMP] = ACTIONS(2881),
    [anon_sym_TILDE] = ACTIONS(2789),
    [aux_sym_prefix_op_token1] = ACTIONS(2881),
    [aux_sym_infix_op_token1] = ACTIONS(2789),
    [aux_sym_infix_op_token2] = ACTIONS(2881),
    [anon_sym_PIPE_PIPE] = ACTIONS(2881),
    [anon_sym_BANG_EQ] = ACTIONS(2881),
    [anon_sym_COLON_EQ] = ACTIONS(2789),
    [anon_sym_DOLLAR] = ACTIONS(2881),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2881),
    [sym_int] = ACTIONS(2881),
    [sym_xint] = ACTIONS(2789),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2789),
    [sym__newline] = ACTIONS(2789),
  },
  [1094] = {
    [sym_block_comment] = STATE(1094),
    [sym_compiler_directive_decl] = STATE(1094),
    [sym_fsi_directive_decl] = STATE(1094),
    [sym_preproc_line] = STATE(1094),
    [sym_identifier] = ACTIONS(3071),
    [anon_sym_EQ] = ACTIONS(3073),
    [anon_sym_GT_RBRACK] = ACTIONS(3073),
    [anon_sym_COLON] = ACTIONS(3071),
    [anon_sym_return] = ACTIONS(3071),
    [anon_sym_do] = ACTIONS(3071),
    [anon_sym_let] = ACTIONS(3071),
    [anon_sym_let_BANG] = ACTIONS(3073),
    [anon_sym_LPAREN] = ACTIONS(3071),
    [anon_sym_COMMA] = ACTIONS(3073),
    [anon_sym_null] = ACTIONS(3071),
    [anon_sym_QMARK] = ACTIONS(3071),
    [anon_sym_COLON_QMARK] = ACTIONS(3071),
    [anon_sym_COLON_COLON] = ACTIONS(3073),
    [anon_sym_AMP] = ACTIONS(3071),
    [anon_sym_LBRACK] = ACTIONS(3071),
    [anon_sym_RBRACK] = ACTIONS(3073),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3073),
    [anon_sym_LBRACE] = ACTIONS(3071),
    [anon_sym_RBRACE] = ACTIONS(3073),
    [anon_sym_LT_AT] = ACTIONS(3071),
    [anon_sym_LT_AT_AT] = ACTIONS(3071),
    [anon_sym_DOT] = ACTIONS(3071),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3073),
    [anon_sym_new] = ACTIONS(3071),
    [anon_sym_with] = ACTIONS(3071),
    [anon_sym_return_BANG] = ACTIONS(3073),
    [anon_sym_yield] = ACTIONS(3071),
    [anon_sym_yield_BANG] = ACTIONS(3073),
    [anon_sym_lazy] = ACTIONS(3071),
    [anon_sym_assert] = ACTIONS(3071),
    [anon_sym_upcast] = ACTIONS(3071),
    [anon_sym_downcast] = ACTIONS(3071),
    [anon_sym_COLON_GT] = ACTIONS(3073),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3073),
    [anon_sym_for] = ACTIONS(3071),
    [anon_sym_to] = ACTIONS(3071),
    [anon_sym_downto] = ACTIONS(3071),
    [anon_sym_while] = ACTIONS(3071),
    [anon_sym_if] = ACTIONS(3071),
    [anon_sym_fun] = ACTIONS(3071),
    [anon_sym_try] = ACTIONS(3071),
    [anon_sym_match] = ACTIONS(3071),
    [anon_sym_match_BANG] = ACTIONS(3073),
    [anon_sym_function] = ACTIONS(3071),
    [anon_sym_LT_DASH] = ACTIONS(3071),
    [anon_sym_DOT_LBRACK] = ACTIONS(3073),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_use] = ACTIONS(3071),
    [anon_sym_use_BANG] = ACTIONS(3073),
    [anon_sym_do_BANG] = ACTIONS(3073),
    [anon_sym_begin] = ACTIONS(3071),
    [anon_sym_LPAREN2] = ACTIONS(3071),
    [anon_sym_DOT_DOT2] = ACTIONS(3073),
    [anon_sym_or] = ACTIONS(3071),
    [aux_sym_char_token1] = ACTIONS(3073),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3071),
    [anon_sym_DQUOTE] = ACTIONS(3071),
    [anon_sym_AT_DQUOTE] = ACTIONS(3073),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3073),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3073),
    [sym_bool] = ACTIONS(3071),
    [sym_unit] = ACTIONS(3073),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3071),
    [sym_op_identifier] = ACTIONS(3071),
    [anon_sym_PLUS] = ACTIONS(3071),
    [anon_sym_DASH] = ACTIONS(3071),
    [anon_sym_PLUS_DOT] = ACTIONS(3071),
    [anon_sym_DASH_DOT] = ACTIONS(3071),
    [anon_sym_PERCENT] = ACTIONS(3071),
    [anon_sym_AMP_AMP] = ACTIONS(3071),
    [anon_sym_TILDE] = ACTIONS(3073),
    [aux_sym_prefix_op_token1] = ACTIONS(3071),
    [aux_sym_infix_op_token1] = ACTIONS(3073),
    [aux_sym_infix_op_token2] = ACTIONS(3071),
    [anon_sym_PIPE_PIPE] = ACTIONS(3071),
    [anon_sym_BANG_EQ] = ACTIONS(3071),
    [anon_sym_COLON_EQ] = ACTIONS(3073),
    [anon_sym_DOLLAR] = ACTIONS(3071),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3071),
    [sym_int] = ACTIONS(3071),
    [sym_xint] = ACTIONS(3073),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3073),
    [sym__newline] = ACTIONS(3073),
  },
  [1095] = {
    [sym__else_expression] = STATE(1967),
    [sym_elif_expression] = STATE(1449),
    [sym_block_comment] = STATE(1095),
    [sym_compiler_directive_decl] = STATE(1095),
    [sym_fsi_directive_decl] = STATE(1095),
    [sym_preproc_line] = STATE(1095),
    [aux_sym_if_expression_repeat1] = STATE(1105),
    [sym_identifier] = ACTIONS(2422),
    [anon_sym_EQ] = ACTIONS(2424),
    [anon_sym_COLON] = ACTIONS(2422),
    [anon_sym_return] = ACTIONS(2422),
    [anon_sym_do] = ACTIONS(2422),
    [anon_sym_let] = ACTIONS(2422),
    [anon_sym_let_BANG] = ACTIONS(2424),
    [anon_sym_LPAREN] = ACTIONS(2422),
    [anon_sym_COMMA] = ACTIONS(2424),
    [anon_sym_null] = ACTIONS(2422),
    [anon_sym_QMARK] = ACTIONS(2422),
    [anon_sym_COLON_QMARK] = ACTIONS(2422),
    [anon_sym_COLON_COLON] = ACTIONS(2424),
    [anon_sym_AMP] = ACTIONS(2422),
    [anon_sym_LBRACK] = ACTIONS(2422),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2424),
    [anon_sym_LBRACE] = ACTIONS(2422),
    [anon_sym_LT_AT] = ACTIONS(2422),
    [anon_sym_LT_AT_AT] = ACTIONS(2422),
    [anon_sym_DOT] = ACTIONS(2422),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2424),
    [anon_sym_new] = ACTIONS(2422),
    [anon_sym_return_BANG] = ACTIONS(2424),
    [anon_sym_yield] = ACTIONS(2422),
    [anon_sym_yield_BANG] = ACTIONS(2424),
    [anon_sym_lazy] = ACTIONS(2422),
    [anon_sym_assert] = ACTIONS(2422),
    [anon_sym_upcast] = ACTIONS(2422),
    [anon_sym_downcast] = ACTIONS(2422),
    [anon_sym_COLON_GT] = ACTIONS(2424),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2424),
    [anon_sym_for] = ACTIONS(2422),
    [anon_sym_while] = ACTIONS(2422),
    [anon_sym_else] = ACTIONS(3314),
    [anon_sym_elif] = ACTIONS(3316),
    [anon_sym_if] = ACTIONS(2422),
    [anon_sym_fun] = ACTIONS(2422),
    [anon_sym_DASH_GT] = ACTIONS(2422),
    [anon_sym_try] = ACTIONS(2422),
    [anon_sym_match] = ACTIONS(2422),
    [anon_sym_match_BANG] = ACTIONS(2424),
    [anon_sym_function] = ACTIONS(2422),
    [anon_sym_LT_DASH] = ACTIONS(2422),
    [anon_sym_DOT_LBRACK] = ACTIONS(2424),
    [anon_sym_LT] = ACTIONS(2424),
    [anon_sym_use] = ACTIONS(2422),
    [anon_sym_use_BANG] = ACTIONS(2424),
    [anon_sym_do_BANG] = ACTIONS(2424),
    [anon_sym_DOT_DOT] = ACTIONS(2424),
    [anon_sym_begin] = ACTIONS(2422),
    [anon_sym_LPAREN2] = ACTIONS(2422),
    [anon_sym_or] = ACTIONS(2422),
    [aux_sym_char_token1] = ACTIONS(2424),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2422),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_AT_DQUOTE] = ACTIONS(2424),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2424),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2424),
    [sym_bool] = ACTIONS(2422),
    [sym_unit] = ACTIONS(2424),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2422),
    [sym_op_identifier] = ACTIONS(2422),
    [anon_sym_PLUS] = ACTIONS(2422),
    [anon_sym_DASH] = ACTIONS(2422),
    [anon_sym_PLUS_DOT] = ACTIONS(2422),
    [anon_sym_DASH_DOT] = ACTIONS(2422),
    [anon_sym_PERCENT] = ACTIONS(2422),
    [anon_sym_AMP_AMP] = ACTIONS(2422),
    [anon_sym_TILDE] = ACTIONS(2424),
    [aux_sym_prefix_op_token1] = ACTIONS(2422),
    [aux_sym_infix_op_token1] = ACTIONS(2424),
    [aux_sym_infix_op_token2] = ACTIONS(2422),
    [anon_sym_PIPE_PIPE] = ACTIONS(2422),
    [anon_sym_BANG_EQ] = ACTIONS(2422),
    [anon_sym_COLON_EQ] = ACTIONS(2424),
    [anon_sym_DOLLAR] = ACTIONS(2422),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2422),
    [sym_int] = ACTIONS(2422),
    [sym_xint] = ACTIONS(2424),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2424),
    [sym__newline] = ACTIONS(2424),
  },
  [1096] = {
    [sym_block_comment] = STATE(1096),
    [sym_compiler_directive_decl] = STATE(1096),
    [sym_fsi_directive_decl] = STATE(1096),
    [sym_preproc_line] = STATE(1096),
    [sym_identifier] = ACTIONS(2859),
    [anon_sym_EQ] = ACTIONS(2861),
    [anon_sym_GT_RBRACK] = ACTIONS(2861),
    [anon_sym_COLON] = ACTIONS(2859),
    [anon_sym_return] = ACTIONS(2859),
    [anon_sym_do] = ACTIONS(2859),
    [anon_sym_let] = ACTIONS(2859),
    [anon_sym_let_BANG] = ACTIONS(2861),
    [anon_sym_LPAREN] = ACTIONS(2859),
    [anon_sym_COMMA] = ACTIONS(2861),
    [anon_sym_null] = ACTIONS(2859),
    [anon_sym_QMARK] = ACTIONS(2859),
    [anon_sym_COLON_QMARK] = ACTIONS(2859),
    [anon_sym_COLON_COLON] = ACTIONS(2861),
    [anon_sym_AMP] = ACTIONS(2859),
    [anon_sym_LBRACK] = ACTIONS(2859),
    [anon_sym_RBRACK] = ACTIONS(2861),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2861),
    [anon_sym_LBRACE] = ACTIONS(2859),
    [anon_sym_RBRACE] = ACTIONS(2861),
    [anon_sym_LT_AT] = ACTIONS(2859),
    [anon_sym_LT_AT_AT] = ACTIONS(2859),
    [anon_sym_DOT] = ACTIONS(2859),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2861),
    [anon_sym_new] = ACTIONS(2859),
    [anon_sym_with] = ACTIONS(2859),
    [anon_sym_return_BANG] = ACTIONS(2861),
    [anon_sym_yield] = ACTIONS(2859),
    [anon_sym_yield_BANG] = ACTIONS(2861),
    [anon_sym_lazy] = ACTIONS(2859),
    [anon_sym_assert] = ACTIONS(2859),
    [anon_sym_upcast] = ACTIONS(2859),
    [anon_sym_downcast] = ACTIONS(2859),
    [anon_sym_COLON_GT] = ACTIONS(2861),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2861),
    [anon_sym_for] = ACTIONS(2859),
    [anon_sym_to] = ACTIONS(2859),
    [anon_sym_downto] = ACTIONS(2859),
    [anon_sym_while] = ACTIONS(2859),
    [anon_sym_if] = ACTIONS(2859),
    [anon_sym_fun] = ACTIONS(2859),
    [anon_sym_try] = ACTIONS(2859),
    [anon_sym_match] = ACTIONS(2859),
    [anon_sym_match_BANG] = ACTIONS(2861),
    [anon_sym_function] = ACTIONS(2859),
    [anon_sym_LT_DASH] = ACTIONS(2859),
    [anon_sym_DOT_LBRACK] = ACTIONS(2861),
    [anon_sym_LT] = ACTIONS(2861),
    [anon_sym_use] = ACTIONS(2859),
    [anon_sym_use_BANG] = ACTIONS(2861),
    [anon_sym_do_BANG] = ACTIONS(2861),
    [anon_sym_begin] = ACTIONS(2859),
    [anon_sym_LPAREN2] = ACTIONS(2859),
    [anon_sym_DOT_DOT2] = ACTIONS(2861),
    [anon_sym_or] = ACTIONS(2859),
    [aux_sym_char_token1] = ACTIONS(2861),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2859),
    [anon_sym_DQUOTE] = ACTIONS(2859),
    [anon_sym_AT_DQUOTE] = ACTIONS(2861),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2861),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2861),
    [sym_bool] = ACTIONS(2859),
    [sym_unit] = ACTIONS(2861),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2859),
    [sym_op_identifier] = ACTIONS(2859),
    [anon_sym_PLUS] = ACTIONS(2859),
    [anon_sym_DASH] = ACTIONS(2859),
    [anon_sym_PLUS_DOT] = ACTIONS(2859),
    [anon_sym_DASH_DOT] = ACTIONS(2859),
    [anon_sym_PERCENT] = ACTIONS(2859),
    [anon_sym_AMP_AMP] = ACTIONS(2859),
    [anon_sym_TILDE] = ACTIONS(2861),
    [aux_sym_prefix_op_token1] = ACTIONS(2859),
    [aux_sym_infix_op_token1] = ACTIONS(2861),
    [aux_sym_infix_op_token2] = ACTIONS(2859),
    [anon_sym_PIPE_PIPE] = ACTIONS(2859),
    [anon_sym_BANG_EQ] = ACTIONS(2859),
    [anon_sym_COLON_EQ] = ACTIONS(2861),
    [anon_sym_DOLLAR] = ACTIONS(2859),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2859),
    [sym_int] = ACTIONS(2859),
    [sym_xint] = ACTIONS(2861),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2861),
    [sym__newline] = ACTIONS(2861),
  },
  [1097] = {
    [sym_block_comment] = STATE(1097),
    [sym_compiler_directive_decl] = STATE(1097),
    [sym_fsi_directive_decl] = STATE(1097),
    [sym_preproc_line] = STATE(1097),
    [sym_identifier] = ACTIONS(3075),
    [anon_sym_EQ] = ACTIONS(3077),
    [anon_sym_GT_RBRACK] = ACTIONS(3077),
    [anon_sym_COLON] = ACTIONS(3075),
    [anon_sym_return] = ACTIONS(3075),
    [anon_sym_do] = ACTIONS(3075),
    [anon_sym_let] = ACTIONS(3075),
    [anon_sym_let_BANG] = ACTIONS(3077),
    [anon_sym_LPAREN] = ACTIONS(3075),
    [anon_sym_COMMA] = ACTIONS(3077),
    [anon_sym_null] = ACTIONS(3075),
    [anon_sym_QMARK] = ACTIONS(3075),
    [anon_sym_COLON_QMARK] = ACTIONS(3075),
    [anon_sym_COLON_COLON] = ACTIONS(3077),
    [anon_sym_AMP] = ACTIONS(3075),
    [anon_sym_LBRACK] = ACTIONS(3075),
    [anon_sym_RBRACK] = ACTIONS(3077),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3077),
    [anon_sym_LBRACE] = ACTIONS(3075),
    [anon_sym_RBRACE] = ACTIONS(3077),
    [anon_sym_LT_AT] = ACTIONS(3075),
    [anon_sym_LT_AT_AT] = ACTIONS(3075),
    [anon_sym_DOT] = ACTIONS(3075),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3077),
    [anon_sym_new] = ACTIONS(3075),
    [anon_sym_with] = ACTIONS(3075),
    [anon_sym_return_BANG] = ACTIONS(3077),
    [anon_sym_yield] = ACTIONS(3075),
    [anon_sym_yield_BANG] = ACTIONS(3077),
    [anon_sym_lazy] = ACTIONS(3075),
    [anon_sym_assert] = ACTIONS(3075),
    [anon_sym_upcast] = ACTIONS(3075),
    [anon_sym_downcast] = ACTIONS(3075),
    [anon_sym_COLON_GT] = ACTIONS(3077),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3077),
    [anon_sym_for] = ACTIONS(3075),
    [anon_sym_to] = ACTIONS(3075),
    [anon_sym_downto] = ACTIONS(3075),
    [anon_sym_while] = ACTIONS(3075),
    [anon_sym_if] = ACTIONS(3075),
    [anon_sym_fun] = ACTIONS(3075),
    [anon_sym_try] = ACTIONS(3075),
    [anon_sym_match] = ACTIONS(3075),
    [anon_sym_match_BANG] = ACTIONS(3077),
    [anon_sym_function] = ACTIONS(3075),
    [anon_sym_LT_DASH] = ACTIONS(3075),
    [anon_sym_DOT_LBRACK] = ACTIONS(3077),
    [anon_sym_LT] = ACTIONS(3077),
    [anon_sym_use] = ACTIONS(3075),
    [anon_sym_use_BANG] = ACTIONS(3077),
    [anon_sym_do_BANG] = ACTIONS(3077),
    [anon_sym_begin] = ACTIONS(3075),
    [anon_sym_LPAREN2] = ACTIONS(3075),
    [anon_sym_DOT_DOT2] = ACTIONS(3077),
    [anon_sym_or] = ACTIONS(3075),
    [aux_sym_char_token1] = ACTIONS(3077),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3075),
    [anon_sym_DQUOTE] = ACTIONS(3075),
    [anon_sym_AT_DQUOTE] = ACTIONS(3077),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3077),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3077),
    [sym_bool] = ACTIONS(3075),
    [sym_unit] = ACTIONS(3077),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3075),
    [sym_op_identifier] = ACTIONS(3075),
    [anon_sym_PLUS] = ACTIONS(3075),
    [anon_sym_DASH] = ACTIONS(3075),
    [anon_sym_PLUS_DOT] = ACTIONS(3075),
    [anon_sym_DASH_DOT] = ACTIONS(3075),
    [anon_sym_PERCENT] = ACTIONS(3075),
    [anon_sym_AMP_AMP] = ACTIONS(3075),
    [anon_sym_TILDE] = ACTIONS(3077),
    [aux_sym_prefix_op_token1] = ACTIONS(3075),
    [aux_sym_infix_op_token1] = ACTIONS(3077),
    [aux_sym_infix_op_token2] = ACTIONS(3075),
    [anon_sym_PIPE_PIPE] = ACTIONS(3075),
    [anon_sym_BANG_EQ] = ACTIONS(3075),
    [anon_sym_COLON_EQ] = ACTIONS(3077),
    [anon_sym_DOLLAR] = ACTIONS(3075),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3075),
    [sym_int] = ACTIONS(3075),
    [sym_xint] = ACTIONS(3077),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3077),
    [sym__newline] = ACTIONS(3077),
  },
  [1098] = {
    [sym_block_comment] = STATE(1098),
    [sym_compiler_directive_decl] = STATE(1098),
    [sym_fsi_directive_decl] = STATE(1098),
    [sym_preproc_line] = STATE(1098),
    [sym_identifier] = ACTIONS(3023),
    [anon_sym_EQ] = ACTIONS(3025),
    [anon_sym_GT_RBRACK] = ACTIONS(3025),
    [anon_sym_COLON] = ACTIONS(3023),
    [anon_sym_return] = ACTIONS(3023),
    [anon_sym_do] = ACTIONS(3023),
    [anon_sym_let] = ACTIONS(3023),
    [anon_sym_let_BANG] = ACTIONS(3025),
    [anon_sym_LPAREN] = ACTIONS(3023),
    [anon_sym_COMMA] = ACTIONS(3025),
    [anon_sym_null] = ACTIONS(3023),
    [anon_sym_QMARK] = ACTIONS(3023),
    [anon_sym_COLON_QMARK] = ACTIONS(3023),
    [anon_sym_COLON_COLON] = ACTIONS(3025),
    [anon_sym_AMP] = ACTIONS(3023),
    [anon_sym_LBRACK] = ACTIONS(3023),
    [anon_sym_RBRACK] = ACTIONS(3025),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3025),
    [anon_sym_LBRACE] = ACTIONS(3023),
    [anon_sym_RBRACE] = ACTIONS(3025),
    [anon_sym_LT_AT] = ACTIONS(3023),
    [anon_sym_LT_AT_AT] = ACTIONS(3023),
    [anon_sym_DOT] = ACTIONS(3023),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3025),
    [anon_sym_new] = ACTIONS(3023),
    [anon_sym_with] = ACTIONS(3023),
    [anon_sym_return_BANG] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(3023),
    [anon_sym_yield_BANG] = ACTIONS(3025),
    [anon_sym_lazy] = ACTIONS(3023),
    [anon_sym_assert] = ACTIONS(3023),
    [anon_sym_upcast] = ACTIONS(3023),
    [anon_sym_downcast] = ACTIONS(3023),
    [anon_sym_COLON_GT] = ACTIONS(3025),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3025),
    [anon_sym_for] = ACTIONS(3023),
    [anon_sym_to] = ACTIONS(3023),
    [anon_sym_downto] = ACTIONS(3023),
    [anon_sym_while] = ACTIONS(3023),
    [anon_sym_if] = ACTIONS(3023),
    [anon_sym_fun] = ACTIONS(3023),
    [anon_sym_try] = ACTIONS(3023),
    [anon_sym_match] = ACTIONS(3023),
    [anon_sym_match_BANG] = ACTIONS(3025),
    [anon_sym_function] = ACTIONS(3023),
    [anon_sym_LT_DASH] = ACTIONS(3023),
    [anon_sym_DOT_LBRACK] = ACTIONS(3025),
    [anon_sym_LT] = ACTIONS(3025),
    [anon_sym_use] = ACTIONS(3023),
    [anon_sym_use_BANG] = ACTIONS(3025),
    [anon_sym_do_BANG] = ACTIONS(3025),
    [anon_sym_begin] = ACTIONS(3023),
    [anon_sym_LPAREN2] = ACTIONS(3023),
    [anon_sym_DOT_DOT2] = ACTIONS(3025),
    [anon_sym_or] = ACTIONS(3023),
    [aux_sym_char_token1] = ACTIONS(3025),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3023),
    [anon_sym_DQUOTE] = ACTIONS(3023),
    [anon_sym_AT_DQUOTE] = ACTIONS(3025),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3025),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3025),
    [sym_bool] = ACTIONS(3023),
    [sym_unit] = ACTIONS(3025),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3023),
    [sym_op_identifier] = ACTIONS(3023),
    [anon_sym_PLUS] = ACTIONS(3023),
    [anon_sym_DASH] = ACTIONS(3023),
    [anon_sym_PLUS_DOT] = ACTIONS(3023),
    [anon_sym_DASH_DOT] = ACTIONS(3023),
    [anon_sym_PERCENT] = ACTIONS(3023),
    [anon_sym_AMP_AMP] = ACTIONS(3023),
    [anon_sym_TILDE] = ACTIONS(3025),
    [aux_sym_prefix_op_token1] = ACTIONS(3023),
    [aux_sym_infix_op_token1] = ACTIONS(3025),
    [aux_sym_infix_op_token2] = ACTIONS(3023),
    [anon_sym_PIPE_PIPE] = ACTIONS(3023),
    [anon_sym_BANG_EQ] = ACTIONS(3023),
    [anon_sym_COLON_EQ] = ACTIONS(3025),
    [anon_sym_DOLLAR] = ACTIONS(3023),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3023),
    [sym_int] = ACTIONS(3023),
    [sym_xint] = ACTIONS(3025),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3025),
    [sym__newline] = ACTIONS(3025),
  },
  [1099] = {
    [sym_block_comment] = STATE(1099),
    [sym_compiler_directive_decl] = STATE(1099),
    [sym_fsi_directive_decl] = STATE(1099),
    [sym_preproc_line] = STATE(1099),
    [sym_identifier] = ACTIONS(2867),
    [anon_sym_EQ] = ACTIONS(2869),
    [anon_sym_GT_RBRACK] = ACTIONS(2869),
    [anon_sym_COLON] = ACTIONS(2867),
    [anon_sym_return] = ACTIONS(2867),
    [anon_sym_do] = ACTIONS(2867),
    [anon_sym_let] = ACTIONS(2867),
    [anon_sym_let_BANG] = ACTIONS(2869),
    [anon_sym_LPAREN] = ACTIONS(2867),
    [anon_sym_COMMA] = ACTIONS(2869),
    [anon_sym_null] = ACTIONS(2867),
    [anon_sym_QMARK] = ACTIONS(2867),
    [anon_sym_COLON_QMARK] = ACTIONS(2867),
    [anon_sym_COLON_COLON] = ACTIONS(2869),
    [anon_sym_AMP] = ACTIONS(2867),
    [anon_sym_LBRACK] = ACTIONS(2867),
    [anon_sym_RBRACK] = ACTIONS(2869),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2869),
    [anon_sym_LBRACE] = ACTIONS(2867),
    [anon_sym_RBRACE] = ACTIONS(2869),
    [anon_sym_LT_AT] = ACTIONS(2867),
    [anon_sym_LT_AT_AT] = ACTIONS(2867),
    [anon_sym_DOT] = ACTIONS(2867),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2869),
    [anon_sym_new] = ACTIONS(2867),
    [anon_sym_with] = ACTIONS(2867),
    [anon_sym_return_BANG] = ACTIONS(2869),
    [anon_sym_yield] = ACTIONS(2867),
    [anon_sym_yield_BANG] = ACTIONS(2869),
    [anon_sym_lazy] = ACTIONS(2867),
    [anon_sym_assert] = ACTIONS(2867),
    [anon_sym_upcast] = ACTIONS(2867),
    [anon_sym_downcast] = ACTIONS(2867),
    [anon_sym_COLON_GT] = ACTIONS(2869),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2869),
    [anon_sym_for] = ACTIONS(2867),
    [anon_sym_to] = ACTIONS(2867),
    [anon_sym_downto] = ACTIONS(2867),
    [anon_sym_while] = ACTIONS(2867),
    [anon_sym_if] = ACTIONS(2867),
    [anon_sym_fun] = ACTIONS(2867),
    [anon_sym_try] = ACTIONS(2867),
    [anon_sym_match] = ACTIONS(2867),
    [anon_sym_match_BANG] = ACTIONS(2869),
    [anon_sym_function] = ACTIONS(2867),
    [anon_sym_LT_DASH] = ACTIONS(2867),
    [anon_sym_DOT_LBRACK] = ACTIONS(2869),
    [anon_sym_LT] = ACTIONS(2869),
    [anon_sym_use] = ACTIONS(2867),
    [anon_sym_use_BANG] = ACTIONS(2869),
    [anon_sym_do_BANG] = ACTIONS(2869),
    [anon_sym_begin] = ACTIONS(2867),
    [anon_sym_LPAREN2] = ACTIONS(2867),
    [anon_sym_DOT_DOT2] = ACTIONS(2869),
    [anon_sym_or] = ACTIONS(2867),
    [aux_sym_char_token1] = ACTIONS(2869),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2867),
    [anon_sym_DQUOTE] = ACTIONS(2867),
    [anon_sym_AT_DQUOTE] = ACTIONS(2869),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2869),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2869),
    [sym_bool] = ACTIONS(2867),
    [sym_unit] = ACTIONS(2869),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2867),
    [sym_op_identifier] = ACTIONS(2867),
    [anon_sym_PLUS] = ACTIONS(2867),
    [anon_sym_DASH] = ACTIONS(2867),
    [anon_sym_PLUS_DOT] = ACTIONS(2867),
    [anon_sym_DASH_DOT] = ACTIONS(2867),
    [anon_sym_PERCENT] = ACTIONS(2867),
    [anon_sym_AMP_AMP] = ACTIONS(2867),
    [anon_sym_TILDE] = ACTIONS(2869),
    [aux_sym_prefix_op_token1] = ACTIONS(2867),
    [aux_sym_infix_op_token1] = ACTIONS(2869),
    [aux_sym_infix_op_token2] = ACTIONS(2867),
    [anon_sym_PIPE_PIPE] = ACTIONS(2867),
    [anon_sym_BANG_EQ] = ACTIONS(2867),
    [anon_sym_COLON_EQ] = ACTIONS(2869),
    [anon_sym_DOLLAR] = ACTIONS(2867),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2867),
    [sym_int] = ACTIONS(2867),
    [sym_xint] = ACTIONS(2869),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2869),
    [sym__newline] = ACTIONS(2869),
  },
  [1100] = {
    [sym_block_comment] = STATE(1100),
    [sym_compiler_directive_decl] = STATE(1100),
    [sym_fsi_directive_decl] = STATE(1100),
    [sym_preproc_line] = STATE(1100),
    [sym_identifier] = ACTIONS(2553),
    [anon_sym_EQ] = ACTIONS(2555),
    [anon_sym_COLON] = ACTIONS(2553),
    [anon_sym_return] = ACTIONS(2553),
    [anon_sym_do] = ACTIONS(2553),
    [anon_sym_let] = ACTIONS(2553),
    [anon_sym_let_BANG] = ACTIONS(2555),
    [anon_sym_as] = ACTIONS(2553),
    [anon_sym_LPAREN] = ACTIONS(2553),
    [anon_sym_COMMA] = ACTIONS(2555),
    [anon_sym_null] = ACTIONS(2553),
    [anon_sym_QMARK] = ACTIONS(2553),
    [anon_sym_COLON_QMARK] = ACTIONS(2553),
    [anon_sym_COLON_COLON] = ACTIONS(2555),
    [anon_sym_AMP] = ACTIONS(2553),
    [anon_sym_LBRACK] = ACTIONS(2553),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2555),
    [anon_sym_LBRACE] = ACTIONS(2553),
    [anon_sym_LT_AT] = ACTIONS(2553),
    [anon_sym_LT_AT_AT] = ACTIONS(2553),
    [anon_sym_DOT] = ACTIONS(2553),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2555),
    [anon_sym_new] = ACTIONS(2553),
    [anon_sym_with] = ACTIONS(2553),
    [anon_sym_return_BANG] = ACTIONS(2555),
    [anon_sym_yield] = ACTIONS(2553),
    [anon_sym_yield_BANG] = ACTIONS(2555),
    [anon_sym_lazy] = ACTIONS(2553),
    [anon_sym_assert] = ACTIONS(2553),
    [anon_sym_upcast] = ACTIONS(2553),
    [anon_sym_downcast] = ACTIONS(2553),
    [anon_sym_COLON_GT] = ACTIONS(2555),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2555),
    [anon_sym_for] = ACTIONS(2553),
    [anon_sym_while] = ACTIONS(2553),
    [anon_sym_if] = ACTIONS(2553),
    [anon_sym_fun] = ACTIONS(2553),
    [anon_sym_DASH_GT] = ACTIONS(2553),
    [anon_sym_try] = ACTIONS(2553),
    [anon_sym_match] = ACTIONS(2553),
    [anon_sym_match_BANG] = ACTIONS(2555),
    [anon_sym_function] = ACTIONS(2553),
    [anon_sym_LT_DASH] = ACTIONS(2553),
    [anon_sym_DOT_LBRACK] = ACTIONS(2555),
    [anon_sym_LT] = ACTIONS(2555),
    [anon_sym_use] = ACTIONS(2553),
    [anon_sym_use_BANG] = ACTIONS(2555),
    [anon_sym_do_BANG] = ACTIONS(2555),
    [anon_sym_begin] = ACTIONS(2553),
    [anon_sym_LPAREN2] = ACTIONS(2553),
    [anon_sym_STAR] = ACTIONS(2553),
    [anon_sym_LT2] = ACTIONS(2553),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2555),
    [anon_sym_or] = ACTIONS(2553),
    [aux_sym_char_token1] = ACTIONS(2555),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2553),
    [anon_sym_DQUOTE] = ACTIONS(2553),
    [anon_sym_AT_DQUOTE] = ACTIONS(2555),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2555),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2555),
    [sym_bool] = ACTIONS(2553),
    [sym_unit] = ACTIONS(2555),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2553),
    [sym_op_identifier] = ACTIONS(2553),
    [anon_sym_PLUS] = ACTIONS(2553),
    [anon_sym_DASH] = ACTIONS(2553),
    [anon_sym_PLUS_DOT] = ACTIONS(2553),
    [anon_sym_DASH_DOT] = ACTIONS(2553),
    [anon_sym_PERCENT] = ACTIONS(2553),
    [anon_sym_AMP_AMP] = ACTIONS(2553),
    [anon_sym_TILDE] = ACTIONS(2555),
    [aux_sym_prefix_op_token1] = ACTIONS(2553),
    [aux_sym_infix_op_token1] = ACTIONS(2555),
    [aux_sym_infix_op_token2] = ACTIONS(2553),
    [anon_sym_PIPE_PIPE] = ACTIONS(2553),
    [anon_sym_BANG_EQ] = ACTIONS(2553),
    [anon_sym_COLON_EQ] = ACTIONS(2555),
    [anon_sym_DOLLAR] = ACTIONS(2553),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2553),
    [sym_int] = ACTIONS(2553),
    [sym_xint] = ACTIONS(2555),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2555),
    [sym__newline] = ACTIONS(2555),
    [sym__dedent] = ACTIONS(2555),
  },
  [1101] = {
    [sym_block_comment] = STATE(1101),
    [sym_compiler_directive_decl] = STATE(1101),
    [sym_fsi_directive_decl] = STATE(1101),
    [sym_preproc_line] = STATE(1101),
    [sym_identifier] = ACTIONS(3011),
    [anon_sym_EQ] = ACTIONS(3013),
    [anon_sym_GT_RBRACK] = ACTIONS(3013),
    [anon_sym_COLON] = ACTIONS(3011),
    [anon_sym_return] = ACTIONS(3011),
    [anon_sym_do] = ACTIONS(3011),
    [anon_sym_let] = ACTIONS(3011),
    [anon_sym_let_BANG] = ACTIONS(3013),
    [anon_sym_LPAREN] = ACTIONS(3011),
    [anon_sym_COMMA] = ACTIONS(3013),
    [anon_sym_null] = ACTIONS(3011),
    [anon_sym_QMARK] = ACTIONS(3011),
    [anon_sym_COLON_QMARK] = ACTIONS(3011),
    [anon_sym_COLON_COLON] = ACTIONS(3013),
    [anon_sym_AMP] = ACTIONS(3011),
    [anon_sym_LBRACK] = ACTIONS(3011),
    [anon_sym_RBRACK] = ACTIONS(3013),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3013),
    [anon_sym_LBRACE] = ACTIONS(3011),
    [anon_sym_RBRACE] = ACTIONS(3013),
    [anon_sym_LT_AT] = ACTIONS(3011),
    [anon_sym_LT_AT_AT] = ACTIONS(3011),
    [anon_sym_DOT] = ACTIONS(3011),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3013),
    [anon_sym_new] = ACTIONS(3011),
    [anon_sym_with] = ACTIONS(3011),
    [anon_sym_return_BANG] = ACTIONS(3013),
    [anon_sym_yield] = ACTIONS(3011),
    [anon_sym_yield_BANG] = ACTIONS(3013),
    [anon_sym_lazy] = ACTIONS(3011),
    [anon_sym_assert] = ACTIONS(3011),
    [anon_sym_upcast] = ACTIONS(3011),
    [anon_sym_downcast] = ACTIONS(3011),
    [anon_sym_COLON_GT] = ACTIONS(3013),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3013),
    [anon_sym_for] = ACTIONS(3011),
    [anon_sym_to] = ACTIONS(3011),
    [anon_sym_downto] = ACTIONS(3011),
    [anon_sym_while] = ACTIONS(3011),
    [anon_sym_if] = ACTIONS(3011),
    [anon_sym_fun] = ACTIONS(3011),
    [anon_sym_try] = ACTIONS(3011),
    [anon_sym_match] = ACTIONS(3011),
    [anon_sym_match_BANG] = ACTIONS(3013),
    [anon_sym_function] = ACTIONS(3011),
    [anon_sym_LT_DASH] = ACTIONS(3011),
    [anon_sym_DOT_LBRACK] = ACTIONS(3013),
    [anon_sym_LT] = ACTIONS(3013),
    [anon_sym_use] = ACTIONS(3011),
    [anon_sym_use_BANG] = ACTIONS(3013),
    [anon_sym_do_BANG] = ACTIONS(3013),
    [anon_sym_begin] = ACTIONS(3011),
    [anon_sym_LPAREN2] = ACTIONS(3011),
    [anon_sym_DOT_DOT2] = ACTIONS(3013),
    [anon_sym_or] = ACTIONS(3011),
    [aux_sym_char_token1] = ACTIONS(3013),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3011),
    [anon_sym_DQUOTE] = ACTIONS(3011),
    [anon_sym_AT_DQUOTE] = ACTIONS(3013),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3013),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3013),
    [sym_bool] = ACTIONS(3011),
    [sym_unit] = ACTIONS(3013),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3011),
    [sym_op_identifier] = ACTIONS(3011),
    [anon_sym_PLUS] = ACTIONS(3011),
    [anon_sym_DASH] = ACTIONS(3011),
    [anon_sym_PLUS_DOT] = ACTIONS(3011),
    [anon_sym_DASH_DOT] = ACTIONS(3011),
    [anon_sym_PERCENT] = ACTIONS(3011),
    [anon_sym_AMP_AMP] = ACTIONS(3011),
    [anon_sym_TILDE] = ACTIONS(3013),
    [aux_sym_prefix_op_token1] = ACTIONS(3011),
    [aux_sym_infix_op_token1] = ACTIONS(3013),
    [aux_sym_infix_op_token2] = ACTIONS(3011),
    [anon_sym_PIPE_PIPE] = ACTIONS(3011),
    [anon_sym_BANG_EQ] = ACTIONS(3011),
    [anon_sym_COLON_EQ] = ACTIONS(3013),
    [anon_sym_DOLLAR] = ACTIONS(3011),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3011),
    [sym_int] = ACTIONS(3011),
    [sym_xint] = ACTIONS(3013),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3013),
    [sym__newline] = ACTIONS(3013),
  },
  [1102] = {
    [sym_block_comment] = STATE(1102),
    [sym_compiler_directive_decl] = STATE(1102),
    [sym_fsi_directive_decl] = STATE(1102),
    [sym_preproc_line] = STATE(1102),
    [aux_sym_long_identifier_repeat1] = STATE(1092),
    [sym_identifier] = ACTIONS(2418),
    [anon_sym_EQ] = ACTIONS(2420),
    [anon_sym_COLON] = ACTIONS(2418),
    [anon_sym_return] = ACTIONS(2418),
    [anon_sym_do] = ACTIONS(2418),
    [anon_sym_and] = ACTIONS(2418),
    [anon_sym_let] = ACTIONS(2418),
    [anon_sym_let_BANG] = ACTIONS(2420),
    [anon_sym_LPAREN] = ACTIONS(2418),
    [anon_sym_COMMA] = ACTIONS(2420),
    [anon_sym_null] = ACTIONS(2418),
    [anon_sym_QMARK] = ACTIONS(2418),
    [anon_sym_COLON_QMARK] = ACTIONS(2418),
    [anon_sym_COLON_COLON] = ACTIONS(2420),
    [anon_sym_AMP] = ACTIONS(2418),
    [anon_sym_LBRACK] = ACTIONS(2418),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2420),
    [anon_sym_LBRACE] = ACTIONS(2418),
    [anon_sym_LT_AT] = ACTIONS(2418),
    [anon_sym_LT_AT_AT] = ACTIONS(2418),
    [anon_sym_DOT] = ACTIONS(3318),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2420),
    [anon_sym_new] = ACTIONS(2418),
    [anon_sym_return_BANG] = ACTIONS(2420),
    [anon_sym_yield] = ACTIONS(2418),
    [anon_sym_yield_BANG] = ACTIONS(2420),
    [anon_sym_lazy] = ACTIONS(2418),
    [anon_sym_assert] = ACTIONS(2418),
    [anon_sym_upcast] = ACTIONS(2418),
    [anon_sym_downcast] = ACTIONS(2418),
    [anon_sym_COLON_GT] = ACTIONS(2420),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2420),
    [anon_sym_for] = ACTIONS(2418),
    [anon_sym_while] = ACTIONS(2418),
    [anon_sym_if] = ACTIONS(2418),
    [anon_sym_fun] = ACTIONS(2418),
    [anon_sym_DASH_GT] = ACTIONS(2418),
    [anon_sym_try] = ACTIONS(2418),
    [anon_sym_match] = ACTIONS(2418),
    [anon_sym_match_BANG] = ACTIONS(2420),
    [anon_sym_function] = ACTIONS(2418),
    [anon_sym_LT_DASH] = ACTIONS(2418),
    [anon_sym_DOT_LBRACK] = ACTIONS(2420),
    [anon_sym_LT] = ACTIONS(2420),
    [anon_sym_use] = ACTIONS(2418),
    [anon_sym_use_BANG] = ACTIONS(2420),
    [anon_sym_do_BANG] = ACTIONS(2420),
    [anon_sym_begin] = ACTIONS(2418),
    [anon_sym_LPAREN2] = ACTIONS(2418),
    [anon_sym_STAR] = ACTIONS(2418),
    [anon_sym_LT2] = ACTIONS(2418),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2420),
    [anon_sym_or] = ACTIONS(2418),
    [aux_sym_char_token1] = ACTIONS(2420),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2418),
    [anon_sym_DQUOTE] = ACTIONS(2418),
    [anon_sym_AT_DQUOTE] = ACTIONS(2420),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2420),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2420),
    [sym_bool] = ACTIONS(2418),
    [sym_unit] = ACTIONS(2420),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2418),
    [sym_op_identifier] = ACTIONS(2418),
    [anon_sym_PLUS] = ACTIONS(2418),
    [anon_sym_DASH] = ACTIONS(2418),
    [anon_sym_PLUS_DOT] = ACTIONS(2418),
    [anon_sym_DASH_DOT] = ACTIONS(2418),
    [anon_sym_PERCENT] = ACTIONS(2418),
    [anon_sym_AMP_AMP] = ACTIONS(2418),
    [anon_sym_TILDE] = ACTIONS(2420),
    [aux_sym_prefix_op_token1] = ACTIONS(2418),
    [aux_sym_infix_op_token1] = ACTIONS(2420),
    [aux_sym_infix_op_token2] = ACTIONS(2418),
    [anon_sym_PIPE_PIPE] = ACTIONS(2418),
    [anon_sym_BANG_EQ] = ACTIONS(2418),
    [anon_sym_COLON_EQ] = ACTIONS(2420),
    [anon_sym_DOLLAR] = ACTIONS(2418),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2418),
    [sym_int] = ACTIONS(2418),
    [sym_xint] = ACTIONS(2420),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2420),
    [sym__newline] = ACTIONS(2420),
    [sym__dedent] = ACTIONS(2420),
  },
  [1103] = {
    [sym_block_comment] = STATE(1103),
    [sym_compiler_directive_decl] = STATE(1103),
    [sym_fsi_directive_decl] = STATE(1103),
    [sym_preproc_line] = STATE(1103),
    [sym_identifier] = ACTIONS(2563),
    [anon_sym_EQ] = ACTIONS(2565),
    [anon_sym_COLON] = ACTIONS(2563),
    [anon_sym_return] = ACTIONS(2563),
    [anon_sym_do] = ACTIONS(2563),
    [anon_sym_let] = ACTIONS(2563),
    [anon_sym_let_BANG] = ACTIONS(2565),
    [anon_sym_as] = ACTIONS(2563),
    [anon_sym_LPAREN] = ACTIONS(2563),
    [anon_sym_COMMA] = ACTIONS(2565),
    [anon_sym_null] = ACTIONS(2563),
    [anon_sym_QMARK] = ACTIONS(2563),
    [anon_sym_COLON_QMARK] = ACTIONS(2563),
    [anon_sym_COLON_COLON] = ACTIONS(2565),
    [anon_sym_AMP] = ACTIONS(2563),
    [anon_sym_LBRACK] = ACTIONS(2563),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2565),
    [anon_sym_LBRACE] = ACTIONS(2563),
    [anon_sym_LT_AT] = ACTIONS(2563),
    [anon_sym_LT_AT_AT] = ACTIONS(2563),
    [anon_sym_DOT] = ACTIONS(2563),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2565),
    [anon_sym_new] = ACTIONS(2563),
    [anon_sym_with] = ACTIONS(2563),
    [anon_sym_return_BANG] = ACTIONS(2565),
    [anon_sym_yield] = ACTIONS(2563),
    [anon_sym_yield_BANG] = ACTIONS(2565),
    [anon_sym_lazy] = ACTIONS(2563),
    [anon_sym_assert] = ACTIONS(2563),
    [anon_sym_upcast] = ACTIONS(2563),
    [anon_sym_downcast] = ACTIONS(2563),
    [anon_sym_COLON_GT] = ACTIONS(2565),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2565),
    [anon_sym_for] = ACTIONS(2563),
    [anon_sym_while] = ACTIONS(2563),
    [anon_sym_if] = ACTIONS(2563),
    [anon_sym_fun] = ACTIONS(2563),
    [anon_sym_DASH_GT] = ACTIONS(2563),
    [anon_sym_try] = ACTIONS(2563),
    [anon_sym_match] = ACTIONS(2563),
    [anon_sym_match_BANG] = ACTIONS(2565),
    [anon_sym_function] = ACTIONS(2563),
    [anon_sym_LT_DASH] = ACTIONS(2563),
    [anon_sym_DOT_LBRACK] = ACTIONS(2565),
    [anon_sym_LT] = ACTIONS(2565),
    [anon_sym_use] = ACTIONS(2563),
    [anon_sym_use_BANG] = ACTIONS(2565),
    [anon_sym_do_BANG] = ACTIONS(2565),
    [anon_sym_begin] = ACTIONS(2563),
    [anon_sym_LPAREN2] = ACTIONS(2563),
    [anon_sym_STAR] = ACTIONS(2563),
    [anon_sym_LT2] = ACTIONS(2563),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2565),
    [anon_sym_or] = ACTIONS(2563),
    [aux_sym_char_token1] = ACTIONS(2565),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2563),
    [anon_sym_DQUOTE] = ACTIONS(2563),
    [anon_sym_AT_DQUOTE] = ACTIONS(2565),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2565),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2565),
    [sym_bool] = ACTIONS(2563),
    [sym_unit] = ACTIONS(2565),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2563),
    [sym_op_identifier] = ACTIONS(2563),
    [anon_sym_PLUS] = ACTIONS(2563),
    [anon_sym_DASH] = ACTIONS(2563),
    [anon_sym_PLUS_DOT] = ACTIONS(2563),
    [anon_sym_DASH_DOT] = ACTIONS(2563),
    [anon_sym_PERCENT] = ACTIONS(2563),
    [anon_sym_AMP_AMP] = ACTIONS(2563),
    [anon_sym_TILDE] = ACTIONS(2565),
    [aux_sym_prefix_op_token1] = ACTIONS(2563),
    [aux_sym_infix_op_token1] = ACTIONS(2565),
    [aux_sym_infix_op_token2] = ACTIONS(2563),
    [anon_sym_PIPE_PIPE] = ACTIONS(2563),
    [anon_sym_BANG_EQ] = ACTIONS(2563),
    [anon_sym_COLON_EQ] = ACTIONS(2565),
    [anon_sym_DOLLAR] = ACTIONS(2563),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2563),
    [sym_int] = ACTIONS(2563),
    [sym_xint] = ACTIONS(2565),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2565),
    [sym__newline] = ACTIONS(2565),
    [sym__dedent] = ACTIONS(2565),
  },
  [1104] = {
    [sym_block_comment] = STATE(1104),
    [sym_compiler_directive_decl] = STATE(1104),
    [sym_fsi_directive_decl] = STATE(1104),
    [sym_preproc_line] = STATE(1104),
    [sym_identifier] = ACTIONS(2514),
    [anon_sym_EQ] = ACTIONS(2516),
    [anon_sym_COLON] = ACTIONS(2514),
    [anon_sym_return] = ACTIONS(2514),
    [anon_sym_do] = ACTIONS(2514),
    [anon_sym_let] = ACTIONS(2514),
    [anon_sym_let_BANG] = ACTIONS(2516),
    [anon_sym_as] = ACTIONS(2514),
    [anon_sym_LPAREN] = ACTIONS(2514),
    [anon_sym_COMMA] = ACTIONS(2516),
    [anon_sym_null] = ACTIONS(2514),
    [anon_sym_QMARK] = ACTIONS(2514),
    [anon_sym_COLON_QMARK] = ACTIONS(2514),
    [anon_sym_COLON_COLON] = ACTIONS(2516),
    [anon_sym_AMP] = ACTIONS(2514),
    [anon_sym_LBRACK] = ACTIONS(2514),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2516),
    [anon_sym_LBRACE] = ACTIONS(2514),
    [anon_sym_LT_AT] = ACTIONS(2514),
    [anon_sym_LT_AT_AT] = ACTIONS(2514),
    [anon_sym_DOT] = ACTIONS(2514),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2516),
    [anon_sym_new] = ACTIONS(2514),
    [anon_sym_with] = ACTIONS(2514),
    [anon_sym_return_BANG] = ACTIONS(2516),
    [anon_sym_yield] = ACTIONS(2514),
    [anon_sym_yield_BANG] = ACTIONS(2516),
    [anon_sym_lazy] = ACTIONS(2514),
    [anon_sym_assert] = ACTIONS(2514),
    [anon_sym_upcast] = ACTIONS(2514),
    [anon_sym_downcast] = ACTIONS(2514),
    [anon_sym_COLON_GT] = ACTIONS(2516),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2516),
    [anon_sym_for] = ACTIONS(2514),
    [anon_sym_while] = ACTIONS(2514),
    [anon_sym_if] = ACTIONS(2514),
    [anon_sym_fun] = ACTIONS(2514),
    [anon_sym_DASH_GT] = ACTIONS(2514),
    [anon_sym_try] = ACTIONS(2514),
    [anon_sym_match] = ACTIONS(2514),
    [anon_sym_match_BANG] = ACTIONS(2516),
    [anon_sym_function] = ACTIONS(2514),
    [anon_sym_LT_DASH] = ACTIONS(2514),
    [anon_sym_DOT_LBRACK] = ACTIONS(2516),
    [anon_sym_LT] = ACTIONS(2516),
    [anon_sym_use] = ACTIONS(2514),
    [anon_sym_use_BANG] = ACTIONS(2516),
    [anon_sym_do_BANG] = ACTIONS(2516),
    [anon_sym_begin] = ACTIONS(2514),
    [anon_sym_LPAREN2] = ACTIONS(2514),
    [anon_sym_STAR] = ACTIONS(2514),
    [anon_sym_LT2] = ACTIONS(2514),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2516),
    [anon_sym_or] = ACTIONS(2514),
    [aux_sym_char_token1] = ACTIONS(2516),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2514),
    [anon_sym_DQUOTE] = ACTIONS(2514),
    [anon_sym_AT_DQUOTE] = ACTIONS(2516),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2516),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2516),
    [sym_bool] = ACTIONS(2514),
    [sym_unit] = ACTIONS(2516),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2514),
    [sym_op_identifier] = ACTIONS(2514),
    [anon_sym_PLUS] = ACTIONS(2514),
    [anon_sym_DASH] = ACTIONS(2514),
    [anon_sym_PLUS_DOT] = ACTIONS(2514),
    [anon_sym_DASH_DOT] = ACTIONS(2514),
    [anon_sym_PERCENT] = ACTIONS(2514),
    [anon_sym_AMP_AMP] = ACTIONS(2514),
    [anon_sym_TILDE] = ACTIONS(2516),
    [aux_sym_prefix_op_token1] = ACTIONS(2514),
    [aux_sym_infix_op_token1] = ACTIONS(2516),
    [aux_sym_infix_op_token2] = ACTIONS(2514),
    [anon_sym_PIPE_PIPE] = ACTIONS(2514),
    [anon_sym_BANG_EQ] = ACTIONS(2514),
    [anon_sym_COLON_EQ] = ACTIONS(2516),
    [anon_sym_DOLLAR] = ACTIONS(2514),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2514),
    [sym_int] = ACTIONS(2514),
    [sym_xint] = ACTIONS(2516),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2516),
    [sym__newline] = ACTIONS(2516),
    [sym__dedent] = ACTIONS(2516),
  },
  [1105] = {
    [sym__else_expression] = STATE(1944),
    [sym_elif_expression] = STATE(1449),
    [sym_block_comment] = STATE(1105),
    [sym_compiler_directive_decl] = STATE(1105),
    [sym_fsi_directive_decl] = STATE(1105),
    [sym_preproc_line] = STATE(1105),
    [aux_sym_if_expression_repeat1] = STATE(1262),
    [sym_identifier] = ACTIONS(2332),
    [anon_sym_EQ] = ACTIONS(2334),
    [anon_sym_COLON] = ACTIONS(2332),
    [anon_sym_return] = ACTIONS(2332),
    [anon_sym_do] = ACTIONS(2332),
    [anon_sym_let] = ACTIONS(2332),
    [anon_sym_let_BANG] = ACTIONS(2334),
    [anon_sym_LPAREN] = ACTIONS(2332),
    [anon_sym_COMMA] = ACTIONS(2334),
    [anon_sym_null] = ACTIONS(2332),
    [anon_sym_QMARK] = ACTIONS(2332),
    [anon_sym_COLON_QMARK] = ACTIONS(2332),
    [anon_sym_COLON_COLON] = ACTIONS(2334),
    [anon_sym_AMP] = ACTIONS(2332),
    [anon_sym_LBRACK] = ACTIONS(2332),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2334),
    [anon_sym_LBRACE] = ACTIONS(2332),
    [anon_sym_LT_AT] = ACTIONS(2332),
    [anon_sym_LT_AT_AT] = ACTIONS(2332),
    [anon_sym_DOT] = ACTIONS(2332),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2334),
    [anon_sym_new] = ACTIONS(2332),
    [anon_sym_return_BANG] = ACTIONS(2334),
    [anon_sym_yield] = ACTIONS(2332),
    [anon_sym_yield_BANG] = ACTIONS(2334),
    [anon_sym_lazy] = ACTIONS(2332),
    [anon_sym_assert] = ACTIONS(2332),
    [anon_sym_upcast] = ACTIONS(2332),
    [anon_sym_downcast] = ACTIONS(2332),
    [anon_sym_COLON_GT] = ACTIONS(2334),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2334),
    [anon_sym_for] = ACTIONS(2332),
    [anon_sym_while] = ACTIONS(2332),
    [anon_sym_else] = ACTIONS(3314),
    [anon_sym_elif] = ACTIONS(3316),
    [anon_sym_if] = ACTIONS(2332),
    [anon_sym_fun] = ACTIONS(2332),
    [anon_sym_DASH_GT] = ACTIONS(2332),
    [anon_sym_try] = ACTIONS(2332),
    [anon_sym_match] = ACTIONS(2332),
    [anon_sym_match_BANG] = ACTIONS(2334),
    [anon_sym_function] = ACTIONS(2332),
    [anon_sym_LT_DASH] = ACTIONS(2332),
    [anon_sym_DOT_LBRACK] = ACTIONS(2334),
    [anon_sym_LT] = ACTIONS(2334),
    [anon_sym_use] = ACTIONS(2332),
    [anon_sym_use_BANG] = ACTIONS(2334),
    [anon_sym_do_BANG] = ACTIONS(2334),
    [anon_sym_DOT_DOT] = ACTIONS(2334),
    [anon_sym_begin] = ACTIONS(2332),
    [anon_sym_LPAREN2] = ACTIONS(2332),
    [anon_sym_or] = ACTIONS(2332),
    [aux_sym_char_token1] = ACTIONS(2334),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2332),
    [anon_sym_DQUOTE] = ACTIONS(2332),
    [anon_sym_AT_DQUOTE] = ACTIONS(2334),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2334),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2334),
    [sym_bool] = ACTIONS(2332),
    [sym_unit] = ACTIONS(2334),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2332),
    [sym_op_identifier] = ACTIONS(2332),
    [anon_sym_PLUS] = ACTIONS(2332),
    [anon_sym_DASH] = ACTIONS(2332),
    [anon_sym_PLUS_DOT] = ACTIONS(2332),
    [anon_sym_DASH_DOT] = ACTIONS(2332),
    [anon_sym_PERCENT] = ACTIONS(2332),
    [anon_sym_AMP_AMP] = ACTIONS(2332),
    [anon_sym_TILDE] = ACTIONS(2334),
    [aux_sym_prefix_op_token1] = ACTIONS(2332),
    [aux_sym_infix_op_token1] = ACTIONS(2334),
    [aux_sym_infix_op_token2] = ACTIONS(2332),
    [anon_sym_PIPE_PIPE] = ACTIONS(2332),
    [anon_sym_BANG_EQ] = ACTIONS(2332),
    [anon_sym_COLON_EQ] = ACTIONS(2334),
    [anon_sym_DOLLAR] = ACTIONS(2332),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2332),
    [sym_int] = ACTIONS(2332),
    [sym_xint] = ACTIONS(2334),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2334),
    [sym__newline] = ACTIONS(2334),
  },
  [1106] = {
    [sym_block_comment] = STATE(1106),
    [sym_compiler_directive_decl] = STATE(1106),
    [sym_fsi_directive_decl] = STATE(1106),
    [sym_preproc_line] = STATE(1106),
    [sym_identifier] = ACTIONS(3043),
    [anon_sym_EQ] = ACTIONS(3045),
    [anon_sym_GT_RBRACK] = ACTIONS(3045),
    [anon_sym_COLON] = ACTIONS(3043),
    [anon_sym_return] = ACTIONS(3043),
    [anon_sym_do] = ACTIONS(3043),
    [anon_sym_let] = ACTIONS(3043),
    [anon_sym_let_BANG] = ACTIONS(3045),
    [anon_sym_LPAREN] = ACTIONS(3043),
    [anon_sym_COMMA] = ACTIONS(3045),
    [anon_sym_null] = ACTIONS(3043),
    [anon_sym_QMARK] = ACTIONS(3043),
    [anon_sym_COLON_QMARK] = ACTIONS(3043),
    [anon_sym_COLON_COLON] = ACTIONS(3045),
    [anon_sym_AMP] = ACTIONS(3043),
    [anon_sym_LBRACK] = ACTIONS(3043),
    [anon_sym_RBRACK] = ACTIONS(3045),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3045),
    [anon_sym_LBRACE] = ACTIONS(3043),
    [anon_sym_RBRACE] = ACTIONS(3045),
    [anon_sym_LT_AT] = ACTIONS(3043),
    [anon_sym_LT_AT_AT] = ACTIONS(3043),
    [anon_sym_DOT] = ACTIONS(3043),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3045),
    [anon_sym_new] = ACTIONS(3043),
    [anon_sym_with] = ACTIONS(3043),
    [anon_sym_return_BANG] = ACTIONS(3045),
    [anon_sym_yield] = ACTIONS(3043),
    [anon_sym_yield_BANG] = ACTIONS(3045),
    [anon_sym_lazy] = ACTIONS(3043),
    [anon_sym_assert] = ACTIONS(3043),
    [anon_sym_upcast] = ACTIONS(3043),
    [anon_sym_downcast] = ACTIONS(3043),
    [anon_sym_COLON_GT] = ACTIONS(3045),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3045),
    [anon_sym_for] = ACTIONS(3043),
    [anon_sym_to] = ACTIONS(3043),
    [anon_sym_downto] = ACTIONS(3043),
    [anon_sym_while] = ACTIONS(3043),
    [anon_sym_if] = ACTIONS(3043),
    [anon_sym_fun] = ACTIONS(3043),
    [anon_sym_try] = ACTIONS(3043),
    [anon_sym_match] = ACTIONS(3043),
    [anon_sym_match_BANG] = ACTIONS(3045),
    [anon_sym_function] = ACTIONS(3043),
    [anon_sym_LT_DASH] = ACTIONS(3043),
    [anon_sym_DOT_LBRACK] = ACTIONS(3045),
    [anon_sym_LT] = ACTIONS(3045),
    [anon_sym_use] = ACTIONS(3043),
    [anon_sym_use_BANG] = ACTIONS(3045),
    [anon_sym_do_BANG] = ACTIONS(3045),
    [anon_sym_begin] = ACTIONS(3043),
    [anon_sym_LPAREN2] = ACTIONS(3043),
    [anon_sym_DOT_DOT2] = ACTIONS(3045),
    [anon_sym_or] = ACTIONS(3043),
    [aux_sym_char_token1] = ACTIONS(3045),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3043),
    [anon_sym_DQUOTE] = ACTIONS(3043),
    [anon_sym_AT_DQUOTE] = ACTIONS(3045),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3045),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3045),
    [sym_bool] = ACTIONS(3043),
    [sym_unit] = ACTIONS(3045),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3043),
    [sym_op_identifier] = ACTIONS(3043),
    [anon_sym_PLUS] = ACTIONS(3043),
    [anon_sym_DASH] = ACTIONS(3043),
    [anon_sym_PLUS_DOT] = ACTIONS(3043),
    [anon_sym_DASH_DOT] = ACTIONS(3043),
    [anon_sym_PERCENT] = ACTIONS(3043),
    [anon_sym_AMP_AMP] = ACTIONS(3043),
    [anon_sym_TILDE] = ACTIONS(3045),
    [aux_sym_prefix_op_token1] = ACTIONS(3043),
    [aux_sym_infix_op_token1] = ACTIONS(3045),
    [aux_sym_infix_op_token2] = ACTIONS(3043),
    [anon_sym_PIPE_PIPE] = ACTIONS(3043),
    [anon_sym_BANG_EQ] = ACTIONS(3043),
    [anon_sym_COLON_EQ] = ACTIONS(3045),
    [anon_sym_DOLLAR] = ACTIONS(3043),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3043),
    [sym_int] = ACTIONS(3043),
    [sym_xint] = ACTIONS(3045),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3045),
    [sym__newline] = ACTIONS(3045),
  },
  [1107] = {
    [sym_block_comment] = STATE(1107),
    [sym_compiler_directive_decl] = STATE(1107),
    [sym_fsi_directive_decl] = STATE(1107),
    [sym_preproc_line] = STATE(1107),
    [sym_identifier] = ACTIONS(3039),
    [anon_sym_EQ] = ACTIONS(3041),
    [anon_sym_GT_RBRACK] = ACTIONS(3041),
    [anon_sym_COLON] = ACTIONS(3039),
    [anon_sym_return] = ACTIONS(3039),
    [anon_sym_do] = ACTIONS(3039),
    [anon_sym_let] = ACTIONS(3039),
    [anon_sym_let_BANG] = ACTIONS(3041),
    [anon_sym_LPAREN] = ACTIONS(3039),
    [anon_sym_COMMA] = ACTIONS(3041),
    [anon_sym_null] = ACTIONS(3039),
    [anon_sym_QMARK] = ACTIONS(3039),
    [anon_sym_COLON_QMARK] = ACTIONS(3039),
    [anon_sym_COLON_COLON] = ACTIONS(3041),
    [anon_sym_AMP] = ACTIONS(3039),
    [anon_sym_LBRACK] = ACTIONS(3039),
    [anon_sym_RBRACK] = ACTIONS(3041),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3041),
    [anon_sym_LBRACE] = ACTIONS(3039),
    [anon_sym_RBRACE] = ACTIONS(3041),
    [anon_sym_LT_AT] = ACTIONS(3039),
    [anon_sym_LT_AT_AT] = ACTIONS(3039),
    [anon_sym_DOT] = ACTIONS(3039),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3041),
    [anon_sym_new] = ACTIONS(3039),
    [anon_sym_with] = ACTIONS(3039),
    [anon_sym_return_BANG] = ACTIONS(3041),
    [anon_sym_yield] = ACTIONS(3039),
    [anon_sym_yield_BANG] = ACTIONS(3041),
    [anon_sym_lazy] = ACTIONS(3039),
    [anon_sym_assert] = ACTIONS(3039),
    [anon_sym_upcast] = ACTIONS(3039),
    [anon_sym_downcast] = ACTIONS(3039),
    [anon_sym_COLON_GT] = ACTIONS(3041),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3041),
    [anon_sym_for] = ACTIONS(3039),
    [anon_sym_to] = ACTIONS(3039),
    [anon_sym_downto] = ACTIONS(3039),
    [anon_sym_while] = ACTIONS(3039),
    [anon_sym_if] = ACTIONS(3039),
    [anon_sym_fun] = ACTIONS(3039),
    [anon_sym_try] = ACTIONS(3039),
    [anon_sym_match] = ACTIONS(3039),
    [anon_sym_match_BANG] = ACTIONS(3041),
    [anon_sym_function] = ACTIONS(3039),
    [anon_sym_LT_DASH] = ACTIONS(3039),
    [anon_sym_DOT_LBRACK] = ACTIONS(3041),
    [anon_sym_LT] = ACTIONS(3041),
    [anon_sym_use] = ACTIONS(3039),
    [anon_sym_use_BANG] = ACTIONS(3041),
    [anon_sym_do_BANG] = ACTIONS(3041),
    [anon_sym_begin] = ACTIONS(3039),
    [anon_sym_LPAREN2] = ACTIONS(3039),
    [anon_sym_DOT_DOT2] = ACTIONS(3041),
    [anon_sym_or] = ACTIONS(3039),
    [aux_sym_char_token1] = ACTIONS(3041),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3039),
    [anon_sym_DQUOTE] = ACTIONS(3039),
    [anon_sym_AT_DQUOTE] = ACTIONS(3041),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3041),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3041),
    [sym_bool] = ACTIONS(3039),
    [sym_unit] = ACTIONS(3041),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3039),
    [sym_op_identifier] = ACTIONS(3039),
    [anon_sym_PLUS] = ACTIONS(3039),
    [anon_sym_DASH] = ACTIONS(3039),
    [anon_sym_PLUS_DOT] = ACTIONS(3039),
    [anon_sym_DASH_DOT] = ACTIONS(3039),
    [anon_sym_PERCENT] = ACTIONS(3039),
    [anon_sym_AMP_AMP] = ACTIONS(3039),
    [anon_sym_TILDE] = ACTIONS(3041),
    [aux_sym_prefix_op_token1] = ACTIONS(3039),
    [aux_sym_infix_op_token1] = ACTIONS(3041),
    [aux_sym_infix_op_token2] = ACTIONS(3039),
    [anon_sym_PIPE_PIPE] = ACTIONS(3039),
    [anon_sym_BANG_EQ] = ACTIONS(3039),
    [anon_sym_COLON_EQ] = ACTIONS(3041),
    [anon_sym_DOLLAR] = ACTIONS(3039),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3039),
    [sym_int] = ACTIONS(3039),
    [sym_xint] = ACTIONS(3041),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3041),
    [sym__newline] = ACTIONS(3041),
  },
  [1108] = {
    [sym_block_comment] = STATE(1108),
    [sym_compiler_directive_decl] = STATE(1108),
    [sym_fsi_directive_decl] = STATE(1108),
    [sym_preproc_line] = STATE(1108),
    [sym_identifier] = ACTIONS(2454),
    [anon_sym_EQ] = ACTIONS(2456),
    [anon_sym_COLON] = ACTIONS(2454),
    [anon_sym_return] = ACTIONS(2454),
    [anon_sym_do] = ACTIONS(2454),
    [anon_sym_let] = ACTIONS(2454),
    [anon_sym_let_BANG] = ACTIONS(2456),
    [anon_sym_as] = ACTIONS(2454),
    [anon_sym_LPAREN] = ACTIONS(2454),
    [anon_sym_COMMA] = ACTIONS(2456),
    [anon_sym_null] = ACTIONS(2454),
    [anon_sym_QMARK] = ACTIONS(2454),
    [anon_sym_COLON_QMARK] = ACTIONS(2454),
    [anon_sym_COLON_COLON] = ACTIONS(2456),
    [anon_sym_AMP] = ACTIONS(2454),
    [anon_sym_LBRACK] = ACTIONS(2454),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2456),
    [anon_sym_LBRACE] = ACTIONS(2454),
    [anon_sym_LT_AT] = ACTIONS(2454),
    [anon_sym_LT_AT_AT] = ACTIONS(2454),
    [anon_sym_DOT] = ACTIONS(2454),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2456),
    [anon_sym_new] = ACTIONS(2454),
    [anon_sym_with] = ACTIONS(2454),
    [anon_sym_return_BANG] = ACTIONS(2456),
    [anon_sym_yield] = ACTIONS(2454),
    [anon_sym_yield_BANG] = ACTIONS(2456),
    [anon_sym_lazy] = ACTIONS(2454),
    [anon_sym_assert] = ACTIONS(2454),
    [anon_sym_upcast] = ACTIONS(2454),
    [anon_sym_downcast] = ACTIONS(2454),
    [anon_sym_COLON_GT] = ACTIONS(2456),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2456),
    [anon_sym_for] = ACTIONS(2454),
    [anon_sym_while] = ACTIONS(2454),
    [anon_sym_if] = ACTIONS(2454),
    [anon_sym_fun] = ACTIONS(2454),
    [anon_sym_DASH_GT] = ACTIONS(2454),
    [anon_sym_try] = ACTIONS(2454),
    [anon_sym_match] = ACTIONS(2454),
    [anon_sym_match_BANG] = ACTIONS(2456),
    [anon_sym_function] = ACTIONS(2454),
    [anon_sym_LT_DASH] = ACTIONS(2454),
    [anon_sym_DOT_LBRACK] = ACTIONS(2456),
    [anon_sym_LT] = ACTIONS(2456),
    [anon_sym_use] = ACTIONS(2454),
    [anon_sym_use_BANG] = ACTIONS(2456),
    [anon_sym_do_BANG] = ACTIONS(2456),
    [anon_sym_begin] = ACTIONS(2454),
    [anon_sym_LPAREN2] = ACTIONS(2454),
    [anon_sym_STAR] = ACTIONS(2454),
    [anon_sym_LT2] = ACTIONS(2454),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2456),
    [anon_sym_or] = ACTIONS(2454),
    [aux_sym_char_token1] = ACTIONS(2456),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2454),
    [anon_sym_DQUOTE] = ACTIONS(2454),
    [anon_sym_AT_DQUOTE] = ACTIONS(2456),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2456),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2456),
    [sym_bool] = ACTIONS(2454),
    [sym_unit] = ACTIONS(2456),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2454),
    [sym_op_identifier] = ACTIONS(2454),
    [anon_sym_PLUS] = ACTIONS(2454),
    [anon_sym_DASH] = ACTIONS(2454),
    [anon_sym_PLUS_DOT] = ACTIONS(2454),
    [anon_sym_DASH_DOT] = ACTIONS(2454),
    [anon_sym_PERCENT] = ACTIONS(2454),
    [anon_sym_AMP_AMP] = ACTIONS(2454),
    [anon_sym_TILDE] = ACTIONS(2456),
    [aux_sym_prefix_op_token1] = ACTIONS(2454),
    [aux_sym_infix_op_token1] = ACTIONS(2456),
    [aux_sym_infix_op_token2] = ACTIONS(2454),
    [anon_sym_PIPE_PIPE] = ACTIONS(2454),
    [anon_sym_BANG_EQ] = ACTIONS(2454),
    [anon_sym_COLON_EQ] = ACTIONS(2456),
    [anon_sym_DOLLAR] = ACTIONS(2454),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2454),
    [sym_int] = ACTIONS(2454),
    [sym_xint] = ACTIONS(2456),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2456),
    [sym__newline] = ACTIONS(2456),
    [sym__dedent] = ACTIONS(2456),
  },
  [1109] = {
    [sym_block_comment] = STATE(1109),
    [sym_compiler_directive_decl] = STATE(1109),
    [sym_fsi_directive_decl] = STATE(1109),
    [sym_preproc_line] = STATE(1109),
    [sym_identifier] = ACTIONS(3119),
    [anon_sym_EQ] = ACTIONS(3121),
    [anon_sym_GT_RBRACK] = ACTIONS(3121),
    [anon_sym_COLON] = ACTIONS(3119),
    [anon_sym_return] = ACTIONS(3119),
    [anon_sym_do] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_let_BANG] = ACTIONS(3121),
    [anon_sym_LPAREN] = ACTIONS(3119),
    [anon_sym_COMMA] = ACTIONS(3121),
    [anon_sym_null] = ACTIONS(3119),
    [anon_sym_QMARK] = ACTIONS(3119),
    [anon_sym_COLON_QMARK] = ACTIONS(3119),
    [anon_sym_COLON_COLON] = ACTIONS(3121),
    [anon_sym_AMP] = ACTIONS(3119),
    [anon_sym_LBRACK] = ACTIONS(3119),
    [anon_sym_RBRACK] = ACTIONS(3121),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3121),
    [anon_sym_LBRACE] = ACTIONS(3119),
    [anon_sym_RBRACE] = ACTIONS(3121),
    [anon_sym_LT_AT] = ACTIONS(3119),
    [anon_sym_LT_AT_AT] = ACTIONS(3119),
    [anon_sym_DOT] = ACTIONS(3119),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3121),
    [anon_sym_new] = ACTIONS(3119),
    [anon_sym_with] = ACTIONS(3119),
    [anon_sym_return_BANG] = ACTIONS(3121),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_yield_BANG] = ACTIONS(3121),
    [anon_sym_lazy] = ACTIONS(3119),
    [anon_sym_assert] = ACTIONS(3119),
    [anon_sym_upcast] = ACTIONS(3119),
    [anon_sym_downcast] = ACTIONS(3119),
    [anon_sym_COLON_GT] = ACTIONS(3121),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3121),
    [anon_sym_for] = ACTIONS(3119),
    [anon_sym_to] = ACTIONS(3119),
    [anon_sym_downto] = ACTIONS(3119),
    [anon_sym_while] = ACTIONS(3119),
    [anon_sym_if] = ACTIONS(3119),
    [anon_sym_fun] = ACTIONS(3119),
    [anon_sym_try] = ACTIONS(3119),
    [anon_sym_match] = ACTIONS(3119),
    [anon_sym_match_BANG] = ACTIONS(3121),
    [anon_sym_function] = ACTIONS(3119),
    [anon_sym_LT_DASH] = ACTIONS(3119),
    [anon_sym_DOT_LBRACK] = ACTIONS(3121),
    [anon_sym_LT] = ACTIONS(3121),
    [anon_sym_use] = ACTIONS(3119),
    [anon_sym_use_BANG] = ACTIONS(3121),
    [anon_sym_do_BANG] = ACTIONS(3121),
    [anon_sym_begin] = ACTIONS(3119),
    [anon_sym_LPAREN2] = ACTIONS(3119),
    [anon_sym_DOT_DOT2] = ACTIONS(3121),
    [anon_sym_or] = ACTIONS(3119),
    [aux_sym_char_token1] = ACTIONS(3121),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3119),
    [anon_sym_DQUOTE] = ACTIONS(3119),
    [anon_sym_AT_DQUOTE] = ACTIONS(3121),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3121),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3121),
    [sym_bool] = ACTIONS(3119),
    [sym_unit] = ACTIONS(3121),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3119),
    [sym_op_identifier] = ACTIONS(3119),
    [anon_sym_PLUS] = ACTIONS(3119),
    [anon_sym_DASH] = ACTIONS(3119),
    [anon_sym_PLUS_DOT] = ACTIONS(3119),
    [anon_sym_DASH_DOT] = ACTIONS(3119),
    [anon_sym_PERCENT] = ACTIONS(3119),
    [anon_sym_AMP_AMP] = ACTIONS(3119),
    [anon_sym_TILDE] = ACTIONS(3121),
    [aux_sym_prefix_op_token1] = ACTIONS(3119),
    [aux_sym_infix_op_token1] = ACTIONS(3121),
    [aux_sym_infix_op_token2] = ACTIONS(3119),
    [anon_sym_PIPE_PIPE] = ACTIONS(3119),
    [anon_sym_BANG_EQ] = ACTIONS(3119),
    [anon_sym_COLON_EQ] = ACTIONS(3121),
    [anon_sym_DOLLAR] = ACTIONS(3119),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3119),
    [sym_int] = ACTIONS(3119),
    [sym_xint] = ACTIONS(3121),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3121),
    [sym__newline] = ACTIONS(3121),
  },
  [1110] = {
    [sym_block_comment] = STATE(1110),
    [sym_compiler_directive_decl] = STATE(1110),
    [sym_fsi_directive_decl] = STATE(1110),
    [sym_preproc_line] = STATE(1110),
    [aux_sym_type_argument_repeat1] = STATE(1046),
    [sym_identifier] = ACTIONS(2321),
    [anon_sym_EQ] = ACTIONS(2323),
    [anon_sym_COLON] = ACTIONS(2321),
    [anon_sym_return] = ACTIONS(2321),
    [anon_sym_do] = ACTIONS(2321),
    [anon_sym_let] = ACTIONS(2321),
    [anon_sym_let_BANG] = ACTIONS(2323),
    [anon_sym_LPAREN] = ACTIONS(2321),
    [anon_sym_COMMA] = ACTIONS(2323),
    [anon_sym_null] = ACTIONS(2321),
    [anon_sym_QMARK] = ACTIONS(2321),
    [anon_sym_COLON_QMARK] = ACTIONS(2321),
    [anon_sym_COLON_COLON] = ACTIONS(2323),
    [anon_sym_AMP] = ACTIONS(2321),
    [anon_sym_LBRACK] = ACTIONS(2321),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2323),
    [anon_sym_LBRACE] = ACTIONS(2321),
    [anon_sym_LT_AT] = ACTIONS(2321),
    [anon_sym_LT_AT_AT] = ACTIONS(2321),
    [anon_sym_DOT] = ACTIONS(2321),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2323),
    [anon_sym_new] = ACTIONS(2321),
    [anon_sym_return_BANG] = ACTIONS(2323),
    [anon_sym_yield] = ACTIONS(2321),
    [anon_sym_yield_BANG] = ACTIONS(2323),
    [anon_sym_lazy] = ACTIONS(2321),
    [anon_sym_assert] = ACTIONS(2321),
    [anon_sym_upcast] = ACTIONS(2321),
    [anon_sym_downcast] = ACTIONS(2321),
    [anon_sym_COLON_GT] = ACTIONS(2323),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2323),
    [anon_sym_for] = ACTIONS(2321),
    [anon_sym_while] = ACTIONS(2321),
    [anon_sym_if] = ACTIONS(2321),
    [anon_sym_fun] = ACTIONS(2321),
    [anon_sym_DASH_GT] = ACTIONS(2321),
    [anon_sym_try] = ACTIONS(2321),
    [anon_sym_match] = ACTIONS(2321),
    [anon_sym_match_BANG] = ACTIONS(2323),
    [anon_sym_function] = ACTIONS(2321),
    [anon_sym_LT_DASH] = ACTIONS(2321),
    [anon_sym_DOT_LBRACK] = ACTIONS(2323),
    [anon_sym_LT] = ACTIONS(2323),
    [anon_sym_use] = ACTIONS(2321),
    [anon_sym_use_BANG] = ACTIONS(2323),
    [anon_sym_do_BANG] = ACTIONS(2323),
    [anon_sym_begin] = ACTIONS(2321),
    [anon_sym_LPAREN2] = ACTIONS(2321),
    [anon_sym_STAR] = ACTIONS(2321),
    [anon_sym_LT2] = ACTIONS(2321),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2323),
    [anon_sym_or] = ACTIONS(3320),
    [aux_sym_char_token1] = ACTIONS(2323),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2321),
    [anon_sym_DQUOTE] = ACTIONS(2321),
    [anon_sym_AT_DQUOTE] = ACTIONS(2323),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2323),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2323),
    [sym_bool] = ACTIONS(2321),
    [sym_unit] = ACTIONS(2323),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2321),
    [sym_op_identifier] = ACTIONS(2321),
    [anon_sym_PLUS] = ACTIONS(2321),
    [anon_sym_DASH] = ACTIONS(2321),
    [anon_sym_PLUS_DOT] = ACTIONS(2321),
    [anon_sym_DASH_DOT] = ACTIONS(2321),
    [anon_sym_PERCENT] = ACTIONS(2321),
    [anon_sym_AMP_AMP] = ACTIONS(2321),
    [anon_sym_TILDE] = ACTIONS(2323),
    [aux_sym_prefix_op_token1] = ACTIONS(2321),
    [aux_sym_infix_op_token1] = ACTIONS(2323),
    [aux_sym_infix_op_token2] = ACTIONS(2321),
    [anon_sym_PIPE_PIPE] = ACTIONS(2321),
    [anon_sym_BANG_EQ] = ACTIONS(2321),
    [anon_sym_COLON_EQ] = ACTIONS(2323),
    [anon_sym_DOLLAR] = ACTIONS(2321),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2321),
    [sym_int] = ACTIONS(2321),
    [sym_xint] = ACTIONS(2323),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2323),
    [anon_sym_POUNDendif] = ACTIONS(2323),
    [anon_sym_POUNDelse] = ACTIONS(2323),
    [sym__newline] = ACTIONS(2323),
  },
  [1111] = {
    [sym_block_comment] = STATE(1111),
    [sym_compiler_directive_decl] = STATE(1111),
    [sym_fsi_directive_decl] = STATE(1111),
    [sym_preproc_line] = STATE(1111),
    [sym_identifier] = ACTIONS(2835),
    [anon_sym_EQ] = ACTIONS(2837),
    [anon_sym_GT_RBRACK] = ACTIONS(2837),
    [anon_sym_COLON] = ACTIONS(2835),
    [anon_sym_return] = ACTIONS(2835),
    [anon_sym_do] = ACTIONS(2835),
    [anon_sym_let] = ACTIONS(2835),
    [anon_sym_let_BANG] = ACTIONS(2837),
    [anon_sym_LPAREN] = ACTIONS(2835),
    [anon_sym_COMMA] = ACTIONS(2837),
    [anon_sym_null] = ACTIONS(2835),
    [anon_sym_QMARK] = ACTIONS(2835),
    [anon_sym_COLON_QMARK] = ACTIONS(2835),
    [anon_sym_COLON_COLON] = ACTIONS(2837),
    [anon_sym_AMP] = ACTIONS(2835),
    [anon_sym_LBRACK] = ACTIONS(2835),
    [anon_sym_RBRACK] = ACTIONS(2837),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2837),
    [anon_sym_LBRACE] = ACTIONS(2835),
    [anon_sym_RBRACE] = ACTIONS(2837),
    [anon_sym_LT_AT] = ACTIONS(2835),
    [anon_sym_LT_AT_AT] = ACTIONS(2835),
    [anon_sym_DOT] = ACTIONS(2835),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2837),
    [anon_sym_new] = ACTIONS(2835),
    [anon_sym_with] = ACTIONS(2835),
    [anon_sym_return_BANG] = ACTIONS(2837),
    [anon_sym_yield] = ACTIONS(2835),
    [anon_sym_yield_BANG] = ACTIONS(2837),
    [anon_sym_lazy] = ACTIONS(2835),
    [anon_sym_assert] = ACTIONS(2835),
    [anon_sym_upcast] = ACTIONS(2835),
    [anon_sym_downcast] = ACTIONS(2835),
    [anon_sym_COLON_GT] = ACTIONS(2837),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2837),
    [anon_sym_for] = ACTIONS(2835),
    [anon_sym_to] = ACTIONS(2835),
    [anon_sym_downto] = ACTIONS(2835),
    [anon_sym_while] = ACTIONS(2835),
    [anon_sym_if] = ACTIONS(2835),
    [anon_sym_fun] = ACTIONS(2835),
    [anon_sym_try] = ACTIONS(2835),
    [anon_sym_match] = ACTIONS(2835),
    [anon_sym_match_BANG] = ACTIONS(2837),
    [anon_sym_function] = ACTIONS(2835),
    [anon_sym_LT_DASH] = ACTIONS(2835),
    [anon_sym_DOT_LBRACK] = ACTIONS(2837),
    [anon_sym_LT] = ACTIONS(2837),
    [anon_sym_use] = ACTIONS(2835),
    [anon_sym_use_BANG] = ACTIONS(2837),
    [anon_sym_do_BANG] = ACTIONS(2837),
    [anon_sym_begin] = ACTIONS(2835),
    [anon_sym_LPAREN2] = ACTIONS(2835),
    [anon_sym_DOT_DOT2] = ACTIONS(2837),
    [anon_sym_or] = ACTIONS(2835),
    [aux_sym_char_token1] = ACTIONS(2837),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2835),
    [anon_sym_DQUOTE] = ACTIONS(2835),
    [anon_sym_AT_DQUOTE] = ACTIONS(2837),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2837),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2837),
    [sym_bool] = ACTIONS(2835),
    [sym_unit] = ACTIONS(2837),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2835),
    [sym_op_identifier] = ACTIONS(2835),
    [anon_sym_PLUS] = ACTIONS(2835),
    [anon_sym_DASH] = ACTIONS(2835),
    [anon_sym_PLUS_DOT] = ACTIONS(2835),
    [anon_sym_DASH_DOT] = ACTIONS(2835),
    [anon_sym_PERCENT] = ACTIONS(2835),
    [anon_sym_AMP_AMP] = ACTIONS(2835),
    [anon_sym_TILDE] = ACTIONS(2837),
    [aux_sym_prefix_op_token1] = ACTIONS(2835),
    [aux_sym_infix_op_token1] = ACTIONS(2837),
    [aux_sym_infix_op_token2] = ACTIONS(2835),
    [anon_sym_PIPE_PIPE] = ACTIONS(2835),
    [anon_sym_BANG_EQ] = ACTIONS(2835),
    [anon_sym_COLON_EQ] = ACTIONS(2837),
    [anon_sym_DOLLAR] = ACTIONS(2835),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2835),
    [sym_int] = ACTIONS(2835),
    [sym_xint] = ACTIONS(2837),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2837),
    [sym__newline] = ACTIONS(2837),
  },
  [1112] = {
    [sym_block_comment] = STATE(1112),
    [sym_compiler_directive_decl] = STATE(1112),
    [sym_fsi_directive_decl] = STATE(1112),
    [sym_preproc_line] = STATE(1112),
    [aux_sym_type_argument_repeat1] = STATE(1154),
    [sym_identifier] = ACTIONS(2321),
    [anon_sym_EQ] = ACTIONS(2323),
    [anon_sym_COLON] = ACTIONS(2321),
    [anon_sym_return] = ACTIONS(2321),
    [anon_sym_do] = ACTIONS(2321),
    [anon_sym_and] = ACTIONS(2321),
    [anon_sym_let] = ACTIONS(2321),
    [anon_sym_let_BANG] = ACTIONS(2323),
    [anon_sym_LPAREN] = ACTIONS(2321),
    [anon_sym_COMMA] = ACTIONS(2323),
    [anon_sym_null] = ACTIONS(2321),
    [anon_sym_QMARK] = ACTIONS(2321),
    [anon_sym_COLON_QMARK] = ACTIONS(2321),
    [anon_sym_COLON_COLON] = ACTIONS(2323),
    [anon_sym_AMP] = ACTIONS(2321),
    [anon_sym_LBRACK] = ACTIONS(2321),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2323),
    [anon_sym_LBRACE] = ACTIONS(2321),
    [anon_sym_LT_AT] = ACTIONS(2321),
    [anon_sym_LT_AT_AT] = ACTIONS(2321),
    [anon_sym_DOT] = ACTIONS(2321),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2323),
    [anon_sym_new] = ACTIONS(2321),
    [anon_sym_return_BANG] = ACTIONS(2323),
    [anon_sym_yield] = ACTIONS(2321),
    [anon_sym_yield_BANG] = ACTIONS(2323),
    [anon_sym_lazy] = ACTIONS(2321),
    [anon_sym_assert] = ACTIONS(2321),
    [anon_sym_upcast] = ACTIONS(2321),
    [anon_sym_downcast] = ACTIONS(2321),
    [anon_sym_COLON_GT] = ACTIONS(2323),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2323),
    [anon_sym_for] = ACTIONS(2321),
    [anon_sym_while] = ACTIONS(2321),
    [anon_sym_if] = ACTIONS(2321),
    [anon_sym_fun] = ACTIONS(2321),
    [anon_sym_DASH_GT] = ACTIONS(2321),
    [anon_sym_try] = ACTIONS(2321),
    [anon_sym_match] = ACTIONS(2321),
    [anon_sym_match_BANG] = ACTIONS(2323),
    [anon_sym_function] = ACTIONS(2321),
    [anon_sym_LT_DASH] = ACTIONS(2321),
    [anon_sym_DOT_LBRACK] = ACTIONS(2323),
    [anon_sym_LT] = ACTIONS(2323),
    [anon_sym_use] = ACTIONS(2321),
    [anon_sym_use_BANG] = ACTIONS(2323),
    [anon_sym_do_BANG] = ACTIONS(2323),
    [anon_sym_begin] = ACTIONS(2321),
    [anon_sym_LPAREN2] = ACTIONS(2321),
    [anon_sym_STAR] = ACTIONS(2321),
    [anon_sym_LT2] = ACTIONS(2321),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2323),
    [anon_sym_or] = ACTIONS(3323),
    [aux_sym_char_token1] = ACTIONS(2323),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2321),
    [anon_sym_DQUOTE] = ACTIONS(2321),
    [anon_sym_AT_DQUOTE] = ACTIONS(2323),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2323),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2323),
    [sym_bool] = ACTIONS(2321),
    [sym_unit] = ACTIONS(2323),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2321),
    [sym_op_identifier] = ACTIONS(2321),
    [anon_sym_PLUS] = ACTIONS(2321),
    [anon_sym_DASH] = ACTIONS(2321),
    [anon_sym_PLUS_DOT] = ACTIONS(2321),
    [anon_sym_DASH_DOT] = ACTIONS(2321),
    [anon_sym_PERCENT] = ACTIONS(2321),
    [anon_sym_AMP_AMP] = ACTIONS(2321),
    [anon_sym_TILDE] = ACTIONS(2323),
    [aux_sym_prefix_op_token1] = ACTIONS(2321),
    [aux_sym_infix_op_token1] = ACTIONS(2323),
    [aux_sym_infix_op_token2] = ACTIONS(2321),
    [anon_sym_PIPE_PIPE] = ACTIONS(2321),
    [anon_sym_BANG_EQ] = ACTIONS(2321),
    [anon_sym_COLON_EQ] = ACTIONS(2323),
    [anon_sym_DOLLAR] = ACTIONS(2321),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2321),
    [sym_int] = ACTIONS(2321),
    [sym_xint] = ACTIONS(2323),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2323),
    [sym__newline] = ACTIONS(2323),
    [sym__dedent] = ACTIONS(2323),
  },
  [1113] = {
    [sym_block_comment] = STATE(1113),
    [sym_compiler_directive_decl] = STATE(1113),
    [sym_fsi_directive_decl] = STATE(1113),
    [sym_preproc_line] = STATE(1113),
    [sym_identifier] = ACTIONS(3111),
    [anon_sym_EQ] = ACTIONS(3113),
    [anon_sym_GT_RBRACK] = ACTIONS(3113),
    [anon_sym_COLON] = ACTIONS(3111),
    [anon_sym_return] = ACTIONS(3111),
    [anon_sym_do] = ACTIONS(3111),
    [anon_sym_let] = ACTIONS(3111),
    [anon_sym_let_BANG] = ACTIONS(3113),
    [anon_sym_LPAREN] = ACTIONS(3111),
    [anon_sym_COMMA] = ACTIONS(3113),
    [anon_sym_null] = ACTIONS(3111),
    [anon_sym_QMARK] = ACTIONS(3111),
    [anon_sym_COLON_QMARK] = ACTIONS(3111),
    [anon_sym_COLON_COLON] = ACTIONS(3113),
    [anon_sym_AMP] = ACTIONS(3111),
    [anon_sym_LBRACK] = ACTIONS(3111),
    [anon_sym_RBRACK] = ACTIONS(3113),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3113),
    [anon_sym_LBRACE] = ACTIONS(3111),
    [anon_sym_RBRACE] = ACTIONS(3113),
    [anon_sym_LT_AT] = ACTIONS(3111),
    [anon_sym_LT_AT_AT] = ACTIONS(3111),
    [anon_sym_DOT] = ACTIONS(3111),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3113),
    [anon_sym_new] = ACTIONS(3111),
    [anon_sym_with] = ACTIONS(3111),
    [anon_sym_return_BANG] = ACTIONS(3113),
    [anon_sym_yield] = ACTIONS(3111),
    [anon_sym_yield_BANG] = ACTIONS(3113),
    [anon_sym_lazy] = ACTIONS(3111),
    [anon_sym_assert] = ACTIONS(3111),
    [anon_sym_upcast] = ACTIONS(3111),
    [anon_sym_downcast] = ACTIONS(3111),
    [anon_sym_COLON_GT] = ACTIONS(3113),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3113),
    [anon_sym_for] = ACTIONS(3111),
    [anon_sym_to] = ACTIONS(3111),
    [anon_sym_downto] = ACTIONS(3111),
    [anon_sym_while] = ACTIONS(3111),
    [anon_sym_if] = ACTIONS(3111),
    [anon_sym_fun] = ACTIONS(3111),
    [anon_sym_try] = ACTIONS(3111),
    [anon_sym_match] = ACTIONS(3111),
    [anon_sym_match_BANG] = ACTIONS(3113),
    [anon_sym_function] = ACTIONS(3111),
    [anon_sym_LT_DASH] = ACTIONS(3111),
    [anon_sym_DOT_LBRACK] = ACTIONS(3113),
    [anon_sym_LT] = ACTIONS(3113),
    [anon_sym_use] = ACTIONS(3111),
    [anon_sym_use_BANG] = ACTIONS(3113),
    [anon_sym_do_BANG] = ACTIONS(3113),
    [anon_sym_begin] = ACTIONS(3111),
    [anon_sym_LPAREN2] = ACTIONS(3111),
    [anon_sym_DOT_DOT2] = ACTIONS(3113),
    [anon_sym_or] = ACTIONS(3111),
    [aux_sym_char_token1] = ACTIONS(3113),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3111),
    [anon_sym_DQUOTE] = ACTIONS(3111),
    [anon_sym_AT_DQUOTE] = ACTIONS(3113),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3113),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3113),
    [sym_bool] = ACTIONS(3111),
    [sym_unit] = ACTIONS(3113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3111),
    [sym_op_identifier] = ACTIONS(3111),
    [anon_sym_PLUS] = ACTIONS(3111),
    [anon_sym_DASH] = ACTIONS(3111),
    [anon_sym_PLUS_DOT] = ACTIONS(3111),
    [anon_sym_DASH_DOT] = ACTIONS(3111),
    [anon_sym_PERCENT] = ACTIONS(3111),
    [anon_sym_AMP_AMP] = ACTIONS(3111),
    [anon_sym_TILDE] = ACTIONS(3113),
    [aux_sym_prefix_op_token1] = ACTIONS(3111),
    [aux_sym_infix_op_token1] = ACTIONS(3113),
    [aux_sym_infix_op_token2] = ACTIONS(3111),
    [anon_sym_PIPE_PIPE] = ACTIONS(3111),
    [anon_sym_BANG_EQ] = ACTIONS(3111),
    [anon_sym_COLON_EQ] = ACTIONS(3113),
    [anon_sym_DOLLAR] = ACTIONS(3111),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3111),
    [sym_int] = ACTIONS(3111),
    [sym_xint] = ACTIONS(3113),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3113),
    [sym__newline] = ACTIONS(3113),
  },
  [1114] = {
    [sym_block_comment] = STATE(1114),
    [sym_compiler_directive_decl] = STATE(1114),
    [sym_fsi_directive_decl] = STATE(1114),
    [sym_preproc_line] = STATE(1114),
    [aux_sym_compound_type_repeat1] = STATE(1114),
    [sym_identifier] = ACTIONS(2250),
    [anon_sym_EQ] = ACTIONS(2248),
    [anon_sym_COLON] = ACTIONS(2250),
    [anon_sym_return] = ACTIONS(2250),
    [anon_sym_do] = ACTIONS(2250),
    [anon_sym_let] = ACTIONS(2250),
    [anon_sym_let_BANG] = ACTIONS(2248),
    [anon_sym_as] = ACTIONS(2250),
    [anon_sym_LPAREN] = ACTIONS(2250),
    [anon_sym_COMMA] = ACTIONS(2248),
    [anon_sym_null] = ACTIONS(2250),
    [anon_sym_QMARK] = ACTIONS(2250),
    [anon_sym_COLON_QMARK] = ACTIONS(2250),
    [anon_sym_COLON_COLON] = ACTIONS(2248),
    [anon_sym_AMP] = ACTIONS(2250),
    [anon_sym_LBRACK] = ACTIONS(2250),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2248),
    [anon_sym_LBRACE] = ACTIONS(2250),
    [anon_sym_LT_AT] = ACTIONS(2250),
    [anon_sym_LT_AT_AT] = ACTIONS(2250),
    [anon_sym_DOT] = ACTIONS(2250),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2248),
    [anon_sym_new] = ACTIONS(2250),
    [anon_sym_with] = ACTIONS(2250),
    [anon_sym_return_BANG] = ACTIONS(2248),
    [anon_sym_yield] = ACTIONS(2250),
    [anon_sym_yield_BANG] = ACTIONS(2248),
    [anon_sym_lazy] = ACTIONS(2250),
    [anon_sym_assert] = ACTIONS(2250),
    [anon_sym_upcast] = ACTIONS(2250),
    [anon_sym_downcast] = ACTIONS(2250),
    [anon_sym_COLON_GT] = ACTIONS(2248),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2248),
    [anon_sym_for] = ACTIONS(2250),
    [anon_sym_while] = ACTIONS(2250),
    [anon_sym_if] = ACTIONS(2250),
    [anon_sym_fun] = ACTIONS(2250),
    [anon_sym_DASH_GT] = ACTIONS(2250),
    [anon_sym_try] = ACTIONS(2250),
    [anon_sym_match] = ACTIONS(2250),
    [anon_sym_match_BANG] = ACTIONS(2248),
    [anon_sym_function] = ACTIONS(2250),
    [anon_sym_LT_DASH] = ACTIONS(2250),
    [anon_sym_DOT_LBRACK] = ACTIONS(2248),
    [anon_sym_LT] = ACTIONS(2248),
    [anon_sym_use] = ACTIONS(2250),
    [anon_sym_use_BANG] = ACTIONS(2248),
    [anon_sym_do_BANG] = ACTIONS(2248),
    [anon_sym_begin] = ACTIONS(2250),
    [anon_sym_LPAREN2] = ACTIONS(2250),
    [anon_sym_STAR] = ACTIONS(3326),
    [anon_sym_LT2] = ACTIONS(2250),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2248),
    [anon_sym_or] = ACTIONS(2250),
    [aux_sym_char_token1] = ACTIONS(2248),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2250),
    [anon_sym_DQUOTE] = ACTIONS(2250),
    [anon_sym_AT_DQUOTE] = ACTIONS(2248),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2248),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2248),
    [sym_bool] = ACTIONS(2250),
    [sym_unit] = ACTIONS(2248),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2250),
    [sym_op_identifier] = ACTIONS(2250),
    [anon_sym_PLUS] = ACTIONS(2250),
    [anon_sym_DASH] = ACTIONS(2250),
    [anon_sym_PLUS_DOT] = ACTIONS(2250),
    [anon_sym_DASH_DOT] = ACTIONS(2250),
    [anon_sym_PERCENT] = ACTIONS(2250),
    [anon_sym_AMP_AMP] = ACTIONS(2250),
    [anon_sym_TILDE] = ACTIONS(2248),
    [aux_sym_prefix_op_token1] = ACTIONS(2250),
    [aux_sym_infix_op_token1] = ACTIONS(2248),
    [aux_sym_infix_op_token2] = ACTIONS(2250),
    [anon_sym_PIPE_PIPE] = ACTIONS(2250),
    [anon_sym_BANG_EQ] = ACTIONS(2250),
    [anon_sym_COLON_EQ] = ACTIONS(2248),
    [anon_sym_DOLLAR] = ACTIONS(2250),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2250),
    [sym_int] = ACTIONS(2250),
    [sym_xint] = ACTIONS(2248),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2248),
    [sym__newline] = ACTIONS(2248),
  },
  [1115] = {
    [sym_block_comment] = STATE(1115),
    [sym_compiler_directive_decl] = STATE(1115),
    [sym_fsi_directive_decl] = STATE(1115),
    [sym_preproc_line] = STATE(1115),
    [aux_sym_compound_type_repeat1] = STATE(1163),
    [sym_identifier] = ACTIONS(2407),
    [anon_sym_EQ] = ACTIONS(2409),
    [anon_sym_COLON] = ACTIONS(2407),
    [anon_sym_return] = ACTIONS(2407),
    [anon_sym_do] = ACTIONS(2407),
    [anon_sym_let] = ACTIONS(2407),
    [anon_sym_let_BANG] = ACTIONS(2409),
    [anon_sym_LPAREN] = ACTIONS(2407),
    [anon_sym_COMMA] = ACTIONS(2409),
    [anon_sym_null] = ACTIONS(2407),
    [anon_sym_QMARK] = ACTIONS(2407),
    [anon_sym_COLON_QMARK] = ACTIONS(2407),
    [anon_sym_COLON_COLON] = ACTIONS(2409),
    [anon_sym_AMP] = ACTIONS(2407),
    [anon_sym_LBRACK] = ACTIONS(2407),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2409),
    [anon_sym_LBRACE] = ACTIONS(2407),
    [anon_sym_LT_AT] = ACTIONS(2407),
    [anon_sym_LT_AT_AT] = ACTIONS(2407),
    [anon_sym_DOT] = ACTIONS(2407),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2409),
    [anon_sym_new] = ACTIONS(2407),
    [anon_sym_return_BANG] = ACTIONS(2409),
    [anon_sym_yield] = ACTIONS(2407),
    [anon_sym_yield_BANG] = ACTIONS(2409),
    [anon_sym_lazy] = ACTIONS(2407),
    [anon_sym_assert] = ACTIONS(2407),
    [anon_sym_upcast] = ACTIONS(2407),
    [anon_sym_downcast] = ACTIONS(2407),
    [anon_sym_COLON_GT] = ACTIONS(2409),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2409),
    [anon_sym_for] = ACTIONS(2407),
    [anon_sym_while] = ACTIONS(2407),
    [anon_sym_if] = ACTIONS(2407),
    [anon_sym_fun] = ACTIONS(2407),
    [anon_sym_DASH_GT] = ACTIONS(2407),
    [anon_sym_try] = ACTIONS(2407),
    [anon_sym_match] = ACTIONS(2407),
    [anon_sym_match_BANG] = ACTIONS(2409),
    [anon_sym_function] = ACTIONS(2407),
    [anon_sym_LT_DASH] = ACTIONS(2407),
    [anon_sym_DOT_LBRACK] = ACTIONS(2409),
    [anon_sym_LT] = ACTIONS(2409),
    [anon_sym_use] = ACTIONS(2407),
    [anon_sym_use_BANG] = ACTIONS(2409),
    [anon_sym_do_BANG] = ACTIONS(2409),
    [anon_sym_begin] = ACTIONS(2407),
    [anon_sym_LPAREN2] = ACTIONS(2407),
    [anon_sym_STAR] = ACTIONS(3159),
    [anon_sym_LT2] = ACTIONS(2407),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2409),
    [anon_sym_or] = ACTIONS(2407),
    [aux_sym_char_token1] = ACTIONS(2409),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2407),
    [anon_sym_DQUOTE] = ACTIONS(2407),
    [anon_sym_AT_DQUOTE] = ACTIONS(2409),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2409),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2409),
    [sym_bool] = ACTIONS(2407),
    [sym_unit] = ACTIONS(2409),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2407),
    [sym_op_identifier] = ACTIONS(2407),
    [anon_sym_PLUS] = ACTIONS(2407),
    [anon_sym_DASH] = ACTIONS(2407),
    [anon_sym_PLUS_DOT] = ACTIONS(2407),
    [anon_sym_DASH_DOT] = ACTIONS(2407),
    [anon_sym_PERCENT] = ACTIONS(2407),
    [anon_sym_AMP_AMP] = ACTIONS(2407),
    [anon_sym_TILDE] = ACTIONS(2409),
    [aux_sym_prefix_op_token1] = ACTIONS(2407),
    [aux_sym_infix_op_token1] = ACTIONS(2409),
    [aux_sym_infix_op_token2] = ACTIONS(2407),
    [anon_sym_PIPE_PIPE] = ACTIONS(2407),
    [anon_sym_BANG_EQ] = ACTIONS(2407),
    [anon_sym_COLON_EQ] = ACTIONS(2409),
    [anon_sym_DOLLAR] = ACTIONS(2407),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2407),
    [sym_int] = ACTIONS(2407),
    [sym_xint] = ACTIONS(2409),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2409),
    [anon_sym_POUNDendif] = ACTIONS(2409),
    [anon_sym_POUNDelse] = ACTIONS(2409),
    [sym__newline] = ACTIONS(2409),
  },
  [1116] = {
    [sym_block_comment] = STATE(1116),
    [sym_compiler_directive_decl] = STATE(1116),
    [sym_fsi_directive_decl] = STATE(1116),
    [sym_preproc_line] = STATE(1116),
    [sym_identifier] = ACTIONS(2627),
    [anon_sym_EQ] = ACTIONS(2629),
    [anon_sym_COLON] = ACTIONS(2627),
    [anon_sym_return] = ACTIONS(2627),
    [anon_sym_do] = ACTIONS(2627),
    [anon_sym_let] = ACTIONS(2627),
    [anon_sym_let_BANG] = ACTIONS(2629),
    [anon_sym_as] = ACTIONS(2627),
    [anon_sym_LPAREN] = ACTIONS(2627),
    [anon_sym_COMMA] = ACTIONS(2629),
    [anon_sym_null] = ACTIONS(2627),
    [anon_sym_QMARK] = ACTIONS(2627),
    [anon_sym_COLON_QMARK] = ACTIONS(2627),
    [anon_sym_COLON_COLON] = ACTIONS(2629),
    [anon_sym_AMP] = ACTIONS(2627),
    [anon_sym_LBRACK] = ACTIONS(2627),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2629),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_LT_AT] = ACTIONS(2627),
    [anon_sym_LT_AT_AT] = ACTIONS(2627),
    [anon_sym_DOT] = ACTIONS(2627),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2629),
    [anon_sym_new] = ACTIONS(2627),
    [anon_sym_with] = ACTIONS(2627),
    [anon_sym_return_BANG] = ACTIONS(2629),
    [anon_sym_yield] = ACTIONS(2627),
    [anon_sym_yield_BANG] = ACTIONS(2629),
    [anon_sym_lazy] = ACTIONS(2627),
    [anon_sym_assert] = ACTIONS(2627),
    [anon_sym_upcast] = ACTIONS(2627),
    [anon_sym_downcast] = ACTIONS(2627),
    [anon_sym_COLON_GT] = ACTIONS(2629),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2629),
    [anon_sym_for] = ACTIONS(2627),
    [anon_sym_while] = ACTIONS(2627),
    [anon_sym_if] = ACTIONS(2627),
    [anon_sym_fun] = ACTIONS(2627),
    [anon_sym_DASH_GT] = ACTIONS(2627),
    [anon_sym_try] = ACTIONS(2627),
    [anon_sym_match] = ACTIONS(2627),
    [anon_sym_match_BANG] = ACTIONS(2629),
    [anon_sym_function] = ACTIONS(2627),
    [anon_sym_LT_DASH] = ACTIONS(2627),
    [anon_sym_DOT_LBRACK] = ACTIONS(2629),
    [anon_sym_LT] = ACTIONS(2629),
    [anon_sym_use] = ACTIONS(2627),
    [anon_sym_use_BANG] = ACTIONS(2629),
    [anon_sym_do_BANG] = ACTIONS(2629),
    [anon_sym_begin] = ACTIONS(2627),
    [anon_sym_LPAREN2] = ACTIONS(2627),
    [anon_sym_STAR] = ACTIONS(2627),
    [anon_sym_LT2] = ACTIONS(2627),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2629),
    [anon_sym_or] = ACTIONS(2627),
    [aux_sym_char_token1] = ACTIONS(2629),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2627),
    [anon_sym_DQUOTE] = ACTIONS(2627),
    [anon_sym_AT_DQUOTE] = ACTIONS(2629),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2629),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2629),
    [sym_bool] = ACTIONS(2627),
    [sym_unit] = ACTIONS(2629),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2627),
    [sym_op_identifier] = ACTIONS(2627),
    [anon_sym_PLUS] = ACTIONS(2627),
    [anon_sym_DASH] = ACTIONS(2627),
    [anon_sym_PLUS_DOT] = ACTIONS(2627),
    [anon_sym_DASH_DOT] = ACTIONS(2627),
    [anon_sym_PERCENT] = ACTIONS(2627),
    [anon_sym_AMP_AMP] = ACTIONS(2627),
    [anon_sym_TILDE] = ACTIONS(2629),
    [aux_sym_prefix_op_token1] = ACTIONS(2627),
    [aux_sym_infix_op_token1] = ACTIONS(2629),
    [aux_sym_infix_op_token2] = ACTIONS(2627),
    [anon_sym_PIPE_PIPE] = ACTIONS(2627),
    [anon_sym_BANG_EQ] = ACTIONS(2627),
    [anon_sym_COLON_EQ] = ACTIONS(2629),
    [anon_sym_DOLLAR] = ACTIONS(2627),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2627),
    [sym_int] = ACTIONS(2627),
    [sym_xint] = ACTIONS(2629),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2629),
    [sym__newline] = ACTIONS(2629),
    [sym__dedent] = ACTIONS(2629),
  },
  [1117] = {
    [sym_block_comment] = STATE(1117),
    [sym_compiler_directive_decl] = STATE(1117),
    [sym_fsi_directive_decl] = STATE(1117),
    [sym_preproc_line] = STATE(1117),
    [aux_sym_sequential_expression_repeat1] = STATE(1117),
    [sym_identifier] = ACTIONS(2895),
    [anon_sym_EQ] = ACTIONS(2897),
    [anon_sym_GT_RBRACK] = ACTIONS(2897),
    [anon_sym_COLON] = ACTIONS(2895),
    [anon_sym_return] = ACTIONS(2895),
    [anon_sym_do] = ACTIONS(2895),
    [anon_sym_let] = ACTIONS(2895),
    [anon_sym_let_BANG] = ACTIONS(2897),
    [anon_sym_LPAREN] = ACTIONS(2895),
    [anon_sym_COMMA] = ACTIONS(2897),
    [anon_sym_null] = ACTIONS(2895),
    [anon_sym_QMARK] = ACTIONS(2895),
    [anon_sym_COLON_QMARK] = ACTIONS(2895),
    [anon_sym_COLON_COLON] = ACTIONS(2897),
    [anon_sym_AMP] = ACTIONS(2895),
    [anon_sym_LBRACK] = ACTIONS(2895),
    [anon_sym_RBRACK] = ACTIONS(2897),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2897),
    [anon_sym_LBRACE] = ACTIONS(2895),
    [anon_sym_RBRACE] = ACTIONS(2897),
    [anon_sym_LT_AT] = ACTIONS(2895),
    [anon_sym_LT_AT_AT] = ACTIONS(2895),
    [anon_sym_DOT] = ACTIONS(2895),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2897),
    [anon_sym_new] = ACTIONS(2895),
    [anon_sym_with] = ACTIONS(2895),
    [anon_sym_return_BANG] = ACTIONS(2897),
    [anon_sym_yield] = ACTIONS(2895),
    [anon_sym_yield_BANG] = ACTIONS(2897),
    [anon_sym_lazy] = ACTIONS(2895),
    [anon_sym_assert] = ACTIONS(2895),
    [anon_sym_upcast] = ACTIONS(2895),
    [anon_sym_downcast] = ACTIONS(2895),
    [anon_sym_COLON_GT] = ACTIONS(2897),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2897),
    [anon_sym_for] = ACTIONS(2895),
    [anon_sym_to] = ACTIONS(2895),
    [anon_sym_downto] = ACTIONS(2895),
    [anon_sym_while] = ACTIONS(2895),
    [anon_sym_if] = ACTIONS(2895),
    [anon_sym_fun] = ACTIONS(2895),
    [anon_sym_try] = ACTIONS(2895),
    [anon_sym_match] = ACTIONS(2895),
    [anon_sym_match_BANG] = ACTIONS(2897),
    [anon_sym_function] = ACTIONS(2895),
    [anon_sym_LT_DASH] = ACTIONS(2895),
    [anon_sym_DOT_LBRACK] = ACTIONS(2897),
    [anon_sym_LT] = ACTIONS(2897),
    [anon_sym_use] = ACTIONS(2895),
    [anon_sym_use_BANG] = ACTIONS(2897),
    [anon_sym_do_BANG] = ACTIONS(2897),
    [anon_sym_begin] = ACTIONS(2895),
    [anon_sym_LPAREN2] = ACTIONS(2895),
    [anon_sym_or] = ACTIONS(2895),
    [aux_sym_char_token1] = ACTIONS(2897),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2895),
    [anon_sym_DQUOTE] = ACTIONS(2895),
    [anon_sym_AT_DQUOTE] = ACTIONS(2897),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2897),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2897),
    [sym_bool] = ACTIONS(2895),
    [sym_unit] = ACTIONS(2897),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2895),
    [sym_op_identifier] = ACTIONS(2895),
    [anon_sym_PLUS] = ACTIONS(2895),
    [anon_sym_DASH] = ACTIONS(2895),
    [anon_sym_PLUS_DOT] = ACTIONS(2895),
    [anon_sym_DASH_DOT] = ACTIONS(2895),
    [anon_sym_PERCENT] = ACTIONS(2895),
    [anon_sym_AMP_AMP] = ACTIONS(2895),
    [anon_sym_TILDE] = ACTIONS(2897),
    [aux_sym_prefix_op_token1] = ACTIONS(2895),
    [aux_sym_infix_op_token1] = ACTIONS(2897),
    [aux_sym_infix_op_token2] = ACTIONS(2895),
    [anon_sym_PIPE_PIPE] = ACTIONS(2895),
    [anon_sym_BANG_EQ] = ACTIONS(2895),
    [anon_sym_COLON_EQ] = ACTIONS(2897),
    [anon_sym_DOLLAR] = ACTIONS(2895),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2895),
    [sym_int] = ACTIONS(2895),
    [sym_xint] = ACTIONS(2897),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2897),
    [sym__newline] = ACTIONS(3329),
  },
  [1118] = {
    [sym_block_comment] = STATE(1118),
    [sym_compiler_directive_decl] = STATE(1118),
    [sym_fsi_directive_decl] = STATE(1118),
    [sym_preproc_line] = STATE(1118),
    [sym_identifier] = ACTIONS(2851),
    [anon_sym_EQ] = ACTIONS(2853),
    [anon_sym_GT_RBRACK] = ACTIONS(2853),
    [anon_sym_COLON] = ACTIONS(2851),
    [anon_sym_return] = ACTIONS(2851),
    [anon_sym_do] = ACTIONS(2851),
    [anon_sym_let] = ACTIONS(2851),
    [anon_sym_let_BANG] = ACTIONS(2853),
    [anon_sym_LPAREN] = ACTIONS(2851),
    [anon_sym_COMMA] = ACTIONS(2853),
    [anon_sym_null] = ACTIONS(2851),
    [anon_sym_QMARK] = ACTIONS(2851),
    [anon_sym_COLON_QMARK] = ACTIONS(2851),
    [anon_sym_COLON_COLON] = ACTIONS(2853),
    [anon_sym_AMP] = ACTIONS(2851),
    [anon_sym_LBRACK] = ACTIONS(2851),
    [anon_sym_RBRACK] = ACTIONS(2853),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2853),
    [anon_sym_LBRACE] = ACTIONS(2851),
    [anon_sym_RBRACE] = ACTIONS(2853),
    [anon_sym_LT_AT] = ACTIONS(2851),
    [anon_sym_LT_AT_AT] = ACTIONS(2851),
    [anon_sym_DOT] = ACTIONS(2851),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2853),
    [anon_sym_new] = ACTIONS(2851),
    [anon_sym_with] = ACTIONS(2851),
    [anon_sym_return_BANG] = ACTIONS(2853),
    [anon_sym_yield] = ACTIONS(2851),
    [anon_sym_yield_BANG] = ACTIONS(2853),
    [anon_sym_lazy] = ACTIONS(2851),
    [anon_sym_assert] = ACTIONS(2851),
    [anon_sym_upcast] = ACTIONS(2851),
    [anon_sym_downcast] = ACTIONS(2851),
    [anon_sym_COLON_GT] = ACTIONS(2853),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2853),
    [anon_sym_for] = ACTIONS(2851),
    [anon_sym_to] = ACTIONS(2851),
    [anon_sym_downto] = ACTIONS(2851),
    [anon_sym_while] = ACTIONS(2851),
    [anon_sym_if] = ACTIONS(2851),
    [anon_sym_fun] = ACTIONS(2851),
    [anon_sym_try] = ACTIONS(2851),
    [anon_sym_match] = ACTIONS(2851),
    [anon_sym_match_BANG] = ACTIONS(2853),
    [anon_sym_function] = ACTIONS(2851),
    [anon_sym_LT_DASH] = ACTIONS(2851),
    [anon_sym_DOT_LBRACK] = ACTIONS(2853),
    [anon_sym_LT] = ACTIONS(2853),
    [anon_sym_use] = ACTIONS(2851),
    [anon_sym_use_BANG] = ACTIONS(2853),
    [anon_sym_do_BANG] = ACTIONS(2853),
    [anon_sym_begin] = ACTIONS(2851),
    [anon_sym_LPAREN2] = ACTIONS(2851),
    [anon_sym_DOT_DOT2] = ACTIONS(2853),
    [anon_sym_or] = ACTIONS(2851),
    [aux_sym_char_token1] = ACTIONS(2853),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2851),
    [anon_sym_DQUOTE] = ACTIONS(2851),
    [anon_sym_AT_DQUOTE] = ACTIONS(2853),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2853),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2853),
    [sym_bool] = ACTIONS(2851),
    [sym_unit] = ACTIONS(2853),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2851),
    [sym_op_identifier] = ACTIONS(2851),
    [anon_sym_PLUS] = ACTIONS(2851),
    [anon_sym_DASH] = ACTIONS(2851),
    [anon_sym_PLUS_DOT] = ACTIONS(2851),
    [anon_sym_DASH_DOT] = ACTIONS(2851),
    [anon_sym_PERCENT] = ACTIONS(2851),
    [anon_sym_AMP_AMP] = ACTIONS(2851),
    [anon_sym_TILDE] = ACTIONS(2853),
    [aux_sym_prefix_op_token1] = ACTIONS(2851),
    [aux_sym_infix_op_token1] = ACTIONS(2853),
    [aux_sym_infix_op_token2] = ACTIONS(2851),
    [anon_sym_PIPE_PIPE] = ACTIONS(2851),
    [anon_sym_BANG_EQ] = ACTIONS(2851),
    [anon_sym_COLON_EQ] = ACTIONS(2853),
    [anon_sym_DOLLAR] = ACTIONS(2851),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2851),
    [sym_int] = ACTIONS(2851),
    [sym_xint] = ACTIONS(2853),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2853),
    [sym__newline] = ACTIONS(2853),
  },
  [1119] = {
    [sym_block_comment] = STATE(1119),
    [sym_compiler_directive_decl] = STATE(1119),
    [sym_fsi_directive_decl] = STATE(1119),
    [sym_preproc_line] = STATE(1119),
    [sym_identifier] = ACTIONS(2466),
    [anon_sym_EQ] = ACTIONS(2468),
    [anon_sym_COLON] = ACTIONS(2466),
    [anon_sym_return] = ACTIONS(2466),
    [anon_sym_do] = ACTIONS(2466),
    [anon_sym_let] = ACTIONS(2466),
    [anon_sym_let_BANG] = ACTIONS(2468),
    [anon_sym_as] = ACTIONS(2466),
    [anon_sym_LPAREN] = ACTIONS(2466),
    [anon_sym_COMMA] = ACTIONS(2468),
    [anon_sym_null] = ACTIONS(2466),
    [anon_sym_QMARK] = ACTIONS(2466),
    [anon_sym_COLON_QMARK] = ACTIONS(2466),
    [anon_sym_COLON_COLON] = ACTIONS(2468),
    [anon_sym_AMP] = ACTIONS(2466),
    [anon_sym_LBRACK] = ACTIONS(2466),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2468),
    [anon_sym_LBRACE] = ACTIONS(2466),
    [anon_sym_LT_AT] = ACTIONS(2466),
    [anon_sym_LT_AT_AT] = ACTIONS(2466),
    [anon_sym_DOT] = ACTIONS(2466),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2468),
    [anon_sym_new] = ACTIONS(2466),
    [anon_sym_with] = ACTIONS(2466),
    [anon_sym_return_BANG] = ACTIONS(2468),
    [anon_sym_yield] = ACTIONS(2466),
    [anon_sym_yield_BANG] = ACTIONS(2468),
    [anon_sym_lazy] = ACTIONS(2466),
    [anon_sym_assert] = ACTIONS(2466),
    [anon_sym_upcast] = ACTIONS(2466),
    [anon_sym_downcast] = ACTIONS(2466),
    [anon_sym_COLON_GT] = ACTIONS(2468),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2468),
    [anon_sym_for] = ACTIONS(2466),
    [anon_sym_while] = ACTIONS(2466),
    [anon_sym_if] = ACTIONS(2466),
    [anon_sym_fun] = ACTIONS(2466),
    [anon_sym_DASH_GT] = ACTIONS(2466),
    [anon_sym_try] = ACTIONS(2466),
    [anon_sym_match] = ACTIONS(2466),
    [anon_sym_match_BANG] = ACTIONS(2468),
    [anon_sym_function] = ACTIONS(2466),
    [anon_sym_LT_DASH] = ACTIONS(2466),
    [anon_sym_DOT_LBRACK] = ACTIONS(2468),
    [anon_sym_LT] = ACTIONS(2468),
    [anon_sym_use] = ACTIONS(2466),
    [anon_sym_use_BANG] = ACTIONS(2468),
    [anon_sym_do_BANG] = ACTIONS(2468),
    [anon_sym_begin] = ACTIONS(2466),
    [anon_sym_LPAREN2] = ACTIONS(2466),
    [anon_sym_STAR] = ACTIONS(2466),
    [anon_sym_LT2] = ACTIONS(2466),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2468),
    [anon_sym_or] = ACTIONS(2466),
    [aux_sym_char_token1] = ACTIONS(2468),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2466),
    [anon_sym_DQUOTE] = ACTIONS(2466),
    [anon_sym_AT_DQUOTE] = ACTIONS(2468),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2468),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2468),
    [sym_bool] = ACTIONS(2466),
    [sym_unit] = ACTIONS(2468),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2466),
    [sym_op_identifier] = ACTIONS(2466),
    [anon_sym_PLUS] = ACTIONS(2466),
    [anon_sym_DASH] = ACTIONS(2466),
    [anon_sym_PLUS_DOT] = ACTIONS(2466),
    [anon_sym_DASH_DOT] = ACTIONS(2466),
    [anon_sym_PERCENT] = ACTIONS(2466),
    [anon_sym_AMP_AMP] = ACTIONS(2466),
    [anon_sym_TILDE] = ACTIONS(2468),
    [aux_sym_prefix_op_token1] = ACTIONS(2466),
    [aux_sym_infix_op_token1] = ACTIONS(2468),
    [aux_sym_infix_op_token2] = ACTIONS(2466),
    [anon_sym_PIPE_PIPE] = ACTIONS(2466),
    [anon_sym_BANG_EQ] = ACTIONS(2466),
    [anon_sym_COLON_EQ] = ACTIONS(2468),
    [anon_sym_DOLLAR] = ACTIONS(2466),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2466),
    [sym_int] = ACTIONS(2466),
    [sym_xint] = ACTIONS(2468),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2468),
    [sym__newline] = ACTIONS(2468),
    [sym__dedent] = ACTIONS(2468),
  },
  [1120] = {
    [sym_block_comment] = STATE(1120),
    [sym_compiler_directive_decl] = STATE(1120),
    [sym_fsi_directive_decl] = STATE(1120),
    [sym_preproc_line] = STATE(1120),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_EQ] = ACTIONS(3017),
    [anon_sym_GT_RBRACK] = ACTIONS(3017),
    [anon_sym_COLON] = ACTIONS(3015),
    [anon_sym_return] = ACTIONS(3015),
    [anon_sym_do] = ACTIONS(3015),
    [anon_sym_let] = ACTIONS(3015),
    [anon_sym_let_BANG] = ACTIONS(3017),
    [anon_sym_LPAREN] = ACTIONS(3015),
    [anon_sym_COMMA] = ACTIONS(3017),
    [anon_sym_null] = ACTIONS(3015),
    [anon_sym_QMARK] = ACTIONS(3015),
    [anon_sym_COLON_QMARK] = ACTIONS(3015),
    [anon_sym_COLON_COLON] = ACTIONS(3017),
    [anon_sym_AMP] = ACTIONS(3015),
    [anon_sym_LBRACK] = ACTIONS(3015),
    [anon_sym_RBRACK] = ACTIONS(3017),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3017),
    [anon_sym_LBRACE] = ACTIONS(3015),
    [anon_sym_RBRACE] = ACTIONS(3017),
    [anon_sym_LT_AT] = ACTIONS(3015),
    [anon_sym_LT_AT_AT] = ACTIONS(3015),
    [anon_sym_DOT] = ACTIONS(3015),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3017),
    [anon_sym_new] = ACTIONS(3015),
    [anon_sym_with] = ACTIONS(3015),
    [anon_sym_return_BANG] = ACTIONS(3017),
    [anon_sym_yield] = ACTIONS(3015),
    [anon_sym_yield_BANG] = ACTIONS(3017),
    [anon_sym_lazy] = ACTIONS(3015),
    [anon_sym_assert] = ACTIONS(3015),
    [anon_sym_upcast] = ACTIONS(3015),
    [anon_sym_downcast] = ACTIONS(3015),
    [anon_sym_COLON_GT] = ACTIONS(3017),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3017),
    [anon_sym_for] = ACTIONS(3015),
    [anon_sym_to] = ACTIONS(3015),
    [anon_sym_downto] = ACTIONS(3015),
    [anon_sym_while] = ACTIONS(3015),
    [anon_sym_if] = ACTIONS(3015),
    [anon_sym_fun] = ACTIONS(3015),
    [anon_sym_try] = ACTIONS(3015),
    [anon_sym_match] = ACTIONS(3015),
    [anon_sym_match_BANG] = ACTIONS(3017),
    [anon_sym_function] = ACTIONS(3015),
    [anon_sym_LT_DASH] = ACTIONS(3015),
    [anon_sym_DOT_LBRACK] = ACTIONS(3017),
    [anon_sym_LT] = ACTIONS(3017),
    [anon_sym_use] = ACTIONS(3015),
    [anon_sym_use_BANG] = ACTIONS(3017),
    [anon_sym_do_BANG] = ACTIONS(3017),
    [anon_sym_begin] = ACTIONS(3015),
    [anon_sym_LPAREN2] = ACTIONS(3015),
    [anon_sym_DOT_DOT2] = ACTIONS(3017),
    [anon_sym_or] = ACTIONS(3015),
    [aux_sym_char_token1] = ACTIONS(3017),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3015),
    [anon_sym_DQUOTE] = ACTIONS(3015),
    [anon_sym_AT_DQUOTE] = ACTIONS(3017),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3017),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3017),
    [sym_bool] = ACTIONS(3015),
    [sym_unit] = ACTIONS(3017),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3015),
    [sym_op_identifier] = ACTIONS(3015),
    [anon_sym_PLUS] = ACTIONS(3015),
    [anon_sym_DASH] = ACTIONS(3015),
    [anon_sym_PLUS_DOT] = ACTIONS(3015),
    [anon_sym_DASH_DOT] = ACTIONS(3015),
    [anon_sym_PERCENT] = ACTIONS(3015),
    [anon_sym_AMP_AMP] = ACTIONS(3015),
    [anon_sym_TILDE] = ACTIONS(3017),
    [aux_sym_prefix_op_token1] = ACTIONS(3015),
    [aux_sym_infix_op_token1] = ACTIONS(3017),
    [aux_sym_infix_op_token2] = ACTIONS(3015),
    [anon_sym_PIPE_PIPE] = ACTIONS(3015),
    [anon_sym_BANG_EQ] = ACTIONS(3015),
    [anon_sym_COLON_EQ] = ACTIONS(3017),
    [anon_sym_DOLLAR] = ACTIONS(3015),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3015),
    [sym_int] = ACTIONS(3015),
    [sym_xint] = ACTIONS(3017),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3017),
    [sym__newline] = ACTIONS(3017),
  },
  [1121] = {
    [sym_block_comment] = STATE(1121),
    [sym_compiler_directive_decl] = STATE(1121),
    [sym_fsi_directive_decl] = STATE(1121),
    [sym_preproc_line] = STATE(1121),
    [aux_sym_compound_type_repeat1] = STATE(1126),
    [sym_identifier] = ACTIONS(2407),
    [anon_sym_EQ] = ACTIONS(2409),
    [anon_sym_COLON] = ACTIONS(2407),
    [anon_sym_return] = ACTIONS(2407),
    [anon_sym_do] = ACTIONS(2407),
    [anon_sym_and] = ACTIONS(2407),
    [anon_sym_let] = ACTIONS(2407),
    [anon_sym_let_BANG] = ACTIONS(2409),
    [anon_sym_LPAREN] = ACTIONS(2407),
    [anon_sym_COMMA] = ACTIONS(2409),
    [anon_sym_null] = ACTIONS(2407),
    [anon_sym_QMARK] = ACTIONS(2407),
    [anon_sym_COLON_QMARK] = ACTIONS(2407),
    [anon_sym_COLON_COLON] = ACTIONS(2409),
    [anon_sym_AMP] = ACTIONS(2407),
    [anon_sym_LBRACK] = ACTIONS(2407),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2409),
    [anon_sym_LBRACE] = ACTIONS(2407),
    [anon_sym_LT_AT] = ACTIONS(2407),
    [anon_sym_LT_AT_AT] = ACTIONS(2407),
    [anon_sym_DOT] = ACTIONS(2407),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2409),
    [anon_sym_new] = ACTIONS(2407),
    [anon_sym_return_BANG] = ACTIONS(2409),
    [anon_sym_yield] = ACTIONS(2407),
    [anon_sym_yield_BANG] = ACTIONS(2409),
    [anon_sym_lazy] = ACTIONS(2407),
    [anon_sym_assert] = ACTIONS(2407),
    [anon_sym_upcast] = ACTIONS(2407),
    [anon_sym_downcast] = ACTIONS(2407),
    [anon_sym_COLON_GT] = ACTIONS(2409),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2409),
    [anon_sym_for] = ACTIONS(2407),
    [anon_sym_while] = ACTIONS(2407),
    [anon_sym_if] = ACTIONS(2407),
    [anon_sym_fun] = ACTIONS(2407),
    [anon_sym_DASH_GT] = ACTIONS(2407),
    [anon_sym_try] = ACTIONS(2407),
    [anon_sym_match] = ACTIONS(2407),
    [anon_sym_match_BANG] = ACTIONS(2409),
    [anon_sym_function] = ACTIONS(2407),
    [anon_sym_LT_DASH] = ACTIONS(2407),
    [anon_sym_DOT_LBRACK] = ACTIONS(2409),
    [anon_sym_LT] = ACTIONS(2409),
    [anon_sym_use] = ACTIONS(2407),
    [anon_sym_use_BANG] = ACTIONS(2409),
    [anon_sym_do_BANG] = ACTIONS(2409),
    [anon_sym_begin] = ACTIONS(2407),
    [anon_sym_LPAREN2] = ACTIONS(2407),
    [anon_sym_STAR] = ACTIONS(3177),
    [anon_sym_LT2] = ACTIONS(2407),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2409),
    [anon_sym_or] = ACTIONS(2407),
    [aux_sym_char_token1] = ACTIONS(2409),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2407),
    [anon_sym_DQUOTE] = ACTIONS(2407),
    [anon_sym_AT_DQUOTE] = ACTIONS(2409),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2409),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2409),
    [sym_bool] = ACTIONS(2407),
    [sym_unit] = ACTIONS(2409),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2407),
    [sym_op_identifier] = ACTIONS(2407),
    [anon_sym_PLUS] = ACTIONS(2407),
    [anon_sym_DASH] = ACTIONS(2407),
    [anon_sym_PLUS_DOT] = ACTIONS(2407),
    [anon_sym_DASH_DOT] = ACTIONS(2407),
    [anon_sym_PERCENT] = ACTIONS(2407),
    [anon_sym_AMP_AMP] = ACTIONS(2407),
    [anon_sym_TILDE] = ACTIONS(2409),
    [aux_sym_prefix_op_token1] = ACTIONS(2407),
    [aux_sym_infix_op_token1] = ACTIONS(2409),
    [aux_sym_infix_op_token2] = ACTIONS(2407),
    [anon_sym_PIPE_PIPE] = ACTIONS(2407),
    [anon_sym_BANG_EQ] = ACTIONS(2407),
    [anon_sym_COLON_EQ] = ACTIONS(2409),
    [anon_sym_DOLLAR] = ACTIONS(2407),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2407),
    [sym_int] = ACTIONS(2407),
    [sym_xint] = ACTIONS(2409),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2409),
    [sym__newline] = ACTIONS(2409),
    [sym__dedent] = ACTIONS(2409),
  },
  [1122] = {
    [sym_block_comment] = STATE(1122),
    [sym_compiler_directive_decl] = STATE(1122),
    [sym_fsi_directive_decl] = STATE(1122),
    [sym_preproc_line] = STATE(1122),
    [sym_identifier] = ACTIONS(3107),
    [anon_sym_EQ] = ACTIONS(3109),
    [anon_sym_GT_RBRACK] = ACTIONS(3109),
    [anon_sym_COLON] = ACTIONS(3107),
    [anon_sym_return] = ACTIONS(3107),
    [anon_sym_do] = ACTIONS(3107),
    [anon_sym_let] = ACTIONS(3107),
    [anon_sym_let_BANG] = ACTIONS(3109),
    [anon_sym_LPAREN] = ACTIONS(3107),
    [anon_sym_COMMA] = ACTIONS(3109),
    [anon_sym_null] = ACTIONS(3107),
    [anon_sym_QMARK] = ACTIONS(3107),
    [anon_sym_COLON_QMARK] = ACTIONS(3107),
    [anon_sym_COLON_COLON] = ACTIONS(3109),
    [anon_sym_AMP] = ACTIONS(3107),
    [anon_sym_LBRACK] = ACTIONS(3107),
    [anon_sym_RBRACK] = ACTIONS(3109),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3109),
    [anon_sym_LBRACE] = ACTIONS(3107),
    [anon_sym_RBRACE] = ACTIONS(3109),
    [anon_sym_LT_AT] = ACTIONS(3107),
    [anon_sym_LT_AT_AT] = ACTIONS(3107),
    [anon_sym_DOT] = ACTIONS(3107),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3109),
    [anon_sym_new] = ACTIONS(3107),
    [anon_sym_with] = ACTIONS(3107),
    [anon_sym_return_BANG] = ACTIONS(3109),
    [anon_sym_yield] = ACTIONS(3107),
    [anon_sym_yield_BANG] = ACTIONS(3109),
    [anon_sym_lazy] = ACTIONS(3107),
    [anon_sym_assert] = ACTIONS(3107),
    [anon_sym_upcast] = ACTIONS(3107),
    [anon_sym_downcast] = ACTIONS(3107),
    [anon_sym_COLON_GT] = ACTIONS(3109),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3109),
    [anon_sym_for] = ACTIONS(3107),
    [anon_sym_to] = ACTIONS(3107),
    [anon_sym_downto] = ACTIONS(3107),
    [anon_sym_while] = ACTIONS(3107),
    [anon_sym_if] = ACTIONS(3107),
    [anon_sym_fun] = ACTIONS(3107),
    [anon_sym_try] = ACTIONS(3107),
    [anon_sym_match] = ACTIONS(3107),
    [anon_sym_match_BANG] = ACTIONS(3109),
    [anon_sym_function] = ACTIONS(3107),
    [anon_sym_LT_DASH] = ACTIONS(3107),
    [anon_sym_DOT_LBRACK] = ACTIONS(3109),
    [anon_sym_LT] = ACTIONS(3109),
    [anon_sym_use] = ACTIONS(3107),
    [anon_sym_use_BANG] = ACTIONS(3109),
    [anon_sym_do_BANG] = ACTIONS(3109),
    [anon_sym_begin] = ACTIONS(3107),
    [anon_sym_LPAREN2] = ACTIONS(3107),
    [anon_sym_DOT_DOT2] = ACTIONS(3109),
    [anon_sym_or] = ACTIONS(3107),
    [aux_sym_char_token1] = ACTIONS(3109),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3107),
    [anon_sym_DQUOTE] = ACTIONS(3107),
    [anon_sym_AT_DQUOTE] = ACTIONS(3109),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3109),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3109),
    [sym_bool] = ACTIONS(3107),
    [sym_unit] = ACTIONS(3109),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3107),
    [sym_op_identifier] = ACTIONS(3107),
    [anon_sym_PLUS] = ACTIONS(3107),
    [anon_sym_DASH] = ACTIONS(3107),
    [anon_sym_PLUS_DOT] = ACTIONS(3107),
    [anon_sym_DASH_DOT] = ACTIONS(3107),
    [anon_sym_PERCENT] = ACTIONS(3107),
    [anon_sym_AMP_AMP] = ACTIONS(3107),
    [anon_sym_TILDE] = ACTIONS(3109),
    [aux_sym_prefix_op_token1] = ACTIONS(3107),
    [aux_sym_infix_op_token1] = ACTIONS(3109),
    [aux_sym_infix_op_token2] = ACTIONS(3107),
    [anon_sym_PIPE_PIPE] = ACTIONS(3107),
    [anon_sym_BANG_EQ] = ACTIONS(3107),
    [anon_sym_COLON_EQ] = ACTIONS(3109),
    [anon_sym_DOLLAR] = ACTIONS(3107),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3107),
    [sym_int] = ACTIONS(3107),
    [sym_xint] = ACTIONS(3109),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3109),
    [sym__newline] = ACTIONS(3109),
  },
  [1123] = {
    [sym_block_comment] = STATE(1123),
    [sym_compiler_directive_decl] = STATE(1123),
    [sym_fsi_directive_decl] = STATE(1123),
    [sym_preproc_line] = STATE(1123),
    [sym_identifier] = ACTIONS(2877),
    [anon_sym_EQ] = ACTIONS(2879),
    [anon_sym_GT_RBRACK] = ACTIONS(2879),
    [anon_sym_COLON] = ACTIONS(2877),
    [anon_sym_return] = ACTIONS(2877),
    [anon_sym_do] = ACTIONS(2877),
    [anon_sym_let] = ACTIONS(2877),
    [anon_sym_let_BANG] = ACTIONS(2879),
    [anon_sym_LPAREN] = ACTIONS(2877),
    [anon_sym_COMMA] = ACTIONS(2879),
    [anon_sym_null] = ACTIONS(2877),
    [anon_sym_QMARK] = ACTIONS(2877),
    [anon_sym_COLON_QMARK] = ACTIONS(2877),
    [anon_sym_COLON_COLON] = ACTIONS(2879),
    [anon_sym_AMP] = ACTIONS(2877),
    [anon_sym_LBRACK] = ACTIONS(2877),
    [anon_sym_RBRACK] = ACTIONS(2879),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2879),
    [anon_sym_LBRACE] = ACTIONS(2877),
    [anon_sym_RBRACE] = ACTIONS(2879),
    [anon_sym_LT_AT] = ACTIONS(2877),
    [anon_sym_LT_AT_AT] = ACTIONS(2877),
    [anon_sym_DOT] = ACTIONS(2877),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2879),
    [anon_sym_new] = ACTIONS(2877),
    [anon_sym_with] = ACTIONS(2877),
    [anon_sym_return_BANG] = ACTIONS(2879),
    [anon_sym_yield] = ACTIONS(2877),
    [anon_sym_yield_BANG] = ACTIONS(2879),
    [anon_sym_lazy] = ACTIONS(2877),
    [anon_sym_assert] = ACTIONS(2877),
    [anon_sym_upcast] = ACTIONS(2877),
    [anon_sym_downcast] = ACTIONS(2877),
    [anon_sym_COLON_GT] = ACTIONS(2879),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2879),
    [anon_sym_for] = ACTIONS(2877),
    [anon_sym_to] = ACTIONS(2877),
    [anon_sym_downto] = ACTIONS(2877),
    [anon_sym_while] = ACTIONS(2877),
    [anon_sym_if] = ACTIONS(2877),
    [anon_sym_fun] = ACTIONS(2877),
    [anon_sym_try] = ACTIONS(2877),
    [anon_sym_match] = ACTIONS(2877),
    [anon_sym_match_BANG] = ACTIONS(2879),
    [anon_sym_function] = ACTIONS(2877),
    [anon_sym_LT_DASH] = ACTIONS(2877),
    [anon_sym_DOT_LBRACK] = ACTIONS(2879),
    [anon_sym_LT] = ACTIONS(2879),
    [anon_sym_use] = ACTIONS(2877),
    [anon_sym_use_BANG] = ACTIONS(2879),
    [anon_sym_do_BANG] = ACTIONS(2879),
    [anon_sym_begin] = ACTIONS(2877),
    [anon_sym_LPAREN2] = ACTIONS(2877),
    [anon_sym_DOT_DOT2] = ACTIONS(2879),
    [anon_sym_or] = ACTIONS(2877),
    [aux_sym_char_token1] = ACTIONS(2879),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2877),
    [anon_sym_DQUOTE] = ACTIONS(2877),
    [anon_sym_AT_DQUOTE] = ACTIONS(2879),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2879),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2879),
    [sym_bool] = ACTIONS(2877),
    [sym_unit] = ACTIONS(2879),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2877),
    [sym_op_identifier] = ACTIONS(2877),
    [anon_sym_PLUS] = ACTIONS(2877),
    [anon_sym_DASH] = ACTIONS(2877),
    [anon_sym_PLUS_DOT] = ACTIONS(2877),
    [anon_sym_DASH_DOT] = ACTIONS(2877),
    [anon_sym_PERCENT] = ACTIONS(2877),
    [anon_sym_AMP_AMP] = ACTIONS(2877),
    [anon_sym_TILDE] = ACTIONS(2879),
    [aux_sym_prefix_op_token1] = ACTIONS(2877),
    [aux_sym_infix_op_token1] = ACTIONS(2879),
    [aux_sym_infix_op_token2] = ACTIONS(2877),
    [anon_sym_PIPE_PIPE] = ACTIONS(2877),
    [anon_sym_BANG_EQ] = ACTIONS(2877),
    [anon_sym_COLON_EQ] = ACTIONS(2879),
    [anon_sym_DOLLAR] = ACTIONS(2877),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2877),
    [sym_int] = ACTIONS(2877),
    [sym_xint] = ACTIONS(2879),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2879),
    [sym__newline] = ACTIONS(2879),
  },
  [1124] = {
    [sym_block_comment] = STATE(1124),
    [sym_compiler_directive_decl] = STATE(1124),
    [sym_fsi_directive_decl] = STATE(1124),
    [sym_preproc_line] = STATE(1124),
    [sym_identifier] = ACTIONS(2883),
    [anon_sym_EQ] = ACTIONS(2885),
    [anon_sym_GT_RBRACK] = ACTIONS(2885),
    [anon_sym_COLON] = ACTIONS(2883),
    [anon_sym_return] = ACTIONS(2883),
    [anon_sym_do] = ACTIONS(2883),
    [anon_sym_let] = ACTIONS(2883),
    [anon_sym_let_BANG] = ACTIONS(2885),
    [anon_sym_LPAREN] = ACTIONS(2883),
    [anon_sym_COMMA] = ACTIONS(2885),
    [anon_sym_null] = ACTIONS(2883),
    [anon_sym_QMARK] = ACTIONS(2883),
    [anon_sym_COLON_QMARK] = ACTIONS(2883),
    [anon_sym_COLON_COLON] = ACTIONS(2885),
    [anon_sym_AMP] = ACTIONS(2883),
    [anon_sym_LBRACK] = ACTIONS(2883),
    [anon_sym_RBRACK] = ACTIONS(2885),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2885),
    [anon_sym_LBRACE] = ACTIONS(2883),
    [anon_sym_RBRACE] = ACTIONS(2885),
    [anon_sym_LT_AT] = ACTIONS(2883),
    [anon_sym_LT_AT_AT] = ACTIONS(2883),
    [anon_sym_DOT] = ACTIONS(2883),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2885),
    [anon_sym_new] = ACTIONS(2883),
    [anon_sym_with] = ACTIONS(2883),
    [anon_sym_return_BANG] = ACTIONS(2885),
    [anon_sym_yield] = ACTIONS(2883),
    [anon_sym_yield_BANG] = ACTIONS(2885),
    [anon_sym_lazy] = ACTIONS(2883),
    [anon_sym_assert] = ACTIONS(2883),
    [anon_sym_upcast] = ACTIONS(2883),
    [anon_sym_downcast] = ACTIONS(2883),
    [anon_sym_COLON_GT] = ACTIONS(2885),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2885),
    [anon_sym_for] = ACTIONS(2883),
    [anon_sym_to] = ACTIONS(2883),
    [anon_sym_downto] = ACTIONS(2883),
    [anon_sym_while] = ACTIONS(2883),
    [anon_sym_if] = ACTIONS(2883),
    [anon_sym_fun] = ACTIONS(2883),
    [anon_sym_try] = ACTIONS(2883),
    [anon_sym_match] = ACTIONS(2883),
    [anon_sym_match_BANG] = ACTIONS(2885),
    [anon_sym_function] = ACTIONS(2883),
    [anon_sym_LT_DASH] = ACTIONS(2883),
    [anon_sym_DOT_LBRACK] = ACTIONS(2885),
    [anon_sym_LT] = ACTIONS(2885),
    [anon_sym_use] = ACTIONS(2883),
    [anon_sym_use_BANG] = ACTIONS(2885),
    [anon_sym_do_BANG] = ACTIONS(2885),
    [anon_sym_begin] = ACTIONS(2883),
    [anon_sym_LPAREN2] = ACTIONS(2883),
    [anon_sym_DOT_DOT2] = ACTIONS(2885),
    [anon_sym_or] = ACTIONS(2883),
    [aux_sym_char_token1] = ACTIONS(2885),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2883),
    [anon_sym_DQUOTE] = ACTIONS(2883),
    [anon_sym_AT_DQUOTE] = ACTIONS(2885),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2885),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2885),
    [sym_bool] = ACTIONS(2883),
    [sym_unit] = ACTIONS(2885),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2883),
    [sym_op_identifier] = ACTIONS(2883),
    [anon_sym_PLUS] = ACTIONS(2883),
    [anon_sym_DASH] = ACTIONS(2883),
    [anon_sym_PLUS_DOT] = ACTIONS(2883),
    [anon_sym_DASH_DOT] = ACTIONS(2883),
    [anon_sym_PERCENT] = ACTIONS(2883),
    [anon_sym_AMP_AMP] = ACTIONS(2883),
    [anon_sym_TILDE] = ACTIONS(2885),
    [aux_sym_prefix_op_token1] = ACTIONS(2883),
    [aux_sym_infix_op_token1] = ACTIONS(2885),
    [aux_sym_infix_op_token2] = ACTIONS(2883),
    [anon_sym_PIPE_PIPE] = ACTIONS(2883),
    [anon_sym_BANG_EQ] = ACTIONS(2883),
    [anon_sym_COLON_EQ] = ACTIONS(2885),
    [anon_sym_DOLLAR] = ACTIONS(2883),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2883),
    [sym_int] = ACTIONS(2883),
    [sym_xint] = ACTIONS(2885),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2885),
    [sym__newline] = ACTIONS(2885),
  },
  [1125] = {
    [sym_block_comment] = STATE(1125),
    [sym_compiler_directive_decl] = STATE(1125),
    [sym_fsi_directive_decl] = STATE(1125),
    [sym_preproc_line] = STATE(1125),
    [sym_identifier] = ACTIONS(3055),
    [anon_sym_EQ] = ACTIONS(3057),
    [anon_sym_GT_RBRACK] = ACTIONS(3057),
    [anon_sym_COLON] = ACTIONS(3055),
    [anon_sym_return] = ACTIONS(3055),
    [anon_sym_do] = ACTIONS(3055),
    [anon_sym_let] = ACTIONS(3055),
    [anon_sym_let_BANG] = ACTIONS(3057),
    [anon_sym_LPAREN] = ACTIONS(3055),
    [anon_sym_COMMA] = ACTIONS(3057),
    [anon_sym_null] = ACTIONS(3055),
    [anon_sym_QMARK] = ACTIONS(3055),
    [anon_sym_COLON_QMARK] = ACTIONS(3055),
    [anon_sym_COLON_COLON] = ACTIONS(3057),
    [anon_sym_AMP] = ACTIONS(3055),
    [anon_sym_LBRACK] = ACTIONS(3055),
    [anon_sym_RBRACK] = ACTIONS(3057),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3057),
    [anon_sym_LBRACE] = ACTIONS(3055),
    [anon_sym_RBRACE] = ACTIONS(3057),
    [anon_sym_LT_AT] = ACTIONS(3055),
    [anon_sym_LT_AT_AT] = ACTIONS(3055),
    [anon_sym_DOT] = ACTIONS(3055),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3057),
    [anon_sym_new] = ACTIONS(3055),
    [anon_sym_with] = ACTIONS(3055),
    [anon_sym_return_BANG] = ACTIONS(3057),
    [anon_sym_yield] = ACTIONS(3055),
    [anon_sym_yield_BANG] = ACTIONS(3057),
    [anon_sym_lazy] = ACTIONS(3055),
    [anon_sym_assert] = ACTIONS(3055),
    [anon_sym_upcast] = ACTIONS(3055),
    [anon_sym_downcast] = ACTIONS(3055),
    [anon_sym_COLON_GT] = ACTIONS(3057),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3057),
    [anon_sym_for] = ACTIONS(3055),
    [anon_sym_to] = ACTIONS(3055),
    [anon_sym_downto] = ACTIONS(3055),
    [anon_sym_while] = ACTIONS(3055),
    [anon_sym_if] = ACTIONS(3055),
    [anon_sym_fun] = ACTIONS(3055),
    [anon_sym_try] = ACTIONS(3055),
    [anon_sym_match] = ACTIONS(3055),
    [anon_sym_match_BANG] = ACTIONS(3057),
    [anon_sym_function] = ACTIONS(3055),
    [anon_sym_LT_DASH] = ACTIONS(3055),
    [anon_sym_DOT_LBRACK] = ACTIONS(3057),
    [anon_sym_LT] = ACTIONS(3057),
    [anon_sym_use] = ACTIONS(3055),
    [anon_sym_use_BANG] = ACTIONS(3057),
    [anon_sym_do_BANG] = ACTIONS(3057),
    [anon_sym_begin] = ACTIONS(3055),
    [anon_sym_LPAREN2] = ACTIONS(3055),
    [anon_sym_DOT_DOT2] = ACTIONS(3057),
    [anon_sym_or] = ACTIONS(3055),
    [aux_sym_char_token1] = ACTIONS(3057),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3055),
    [anon_sym_DQUOTE] = ACTIONS(3055),
    [anon_sym_AT_DQUOTE] = ACTIONS(3057),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3057),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3057),
    [sym_bool] = ACTIONS(3055),
    [sym_unit] = ACTIONS(3057),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3055),
    [sym_op_identifier] = ACTIONS(3055),
    [anon_sym_PLUS] = ACTIONS(3055),
    [anon_sym_DASH] = ACTIONS(3055),
    [anon_sym_PLUS_DOT] = ACTIONS(3055),
    [anon_sym_DASH_DOT] = ACTIONS(3055),
    [anon_sym_PERCENT] = ACTIONS(3055),
    [anon_sym_AMP_AMP] = ACTIONS(3055),
    [anon_sym_TILDE] = ACTIONS(3057),
    [aux_sym_prefix_op_token1] = ACTIONS(3055),
    [aux_sym_infix_op_token1] = ACTIONS(3057),
    [aux_sym_infix_op_token2] = ACTIONS(3055),
    [anon_sym_PIPE_PIPE] = ACTIONS(3055),
    [anon_sym_BANG_EQ] = ACTIONS(3055),
    [anon_sym_COLON_EQ] = ACTIONS(3057),
    [anon_sym_DOLLAR] = ACTIONS(3055),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3055),
    [sym_int] = ACTIONS(3055),
    [sym_xint] = ACTIONS(3057),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3057),
    [sym__newline] = ACTIONS(3057),
  },
  [1126] = {
    [sym_block_comment] = STATE(1126),
    [sym_compiler_directive_decl] = STATE(1126),
    [sym_fsi_directive_decl] = STATE(1126),
    [sym_preproc_line] = STATE(1126),
    [aux_sym_compound_type_repeat1] = STATE(1126),
    [sym_identifier] = ACTIONS(2250),
    [anon_sym_EQ] = ACTIONS(2248),
    [anon_sym_COLON] = ACTIONS(2250),
    [anon_sym_return] = ACTIONS(2250),
    [anon_sym_do] = ACTIONS(2250),
    [anon_sym_and] = ACTIONS(2250),
    [anon_sym_let] = ACTIONS(2250),
    [anon_sym_let_BANG] = ACTIONS(2248),
    [anon_sym_LPAREN] = ACTIONS(2250),
    [anon_sym_COMMA] = ACTIONS(2248),
    [anon_sym_null] = ACTIONS(2250),
    [anon_sym_QMARK] = ACTIONS(2250),
    [anon_sym_COLON_QMARK] = ACTIONS(2250),
    [anon_sym_COLON_COLON] = ACTIONS(2248),
    [anon_sym_AMP] = ACTIONS(2250),
    [anon_sym_LBRACK] = ACTIONS(2250),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2248),
    [anon_sym_LBRACE] = ACTIONS(2250),
    [anon_sym_LT_AT] = ACTIONS(2250),
    [anon_sym_LT_AT_AT] = ACTIONS(2250),
    [anon_sym_DOT] = ACTIONS(2250),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2248),
    [anon_sym_new] = ACTIONS(2250),
    [anon_sym_return_BANG] = ACTIONS(2248),
    [anon_sym_yield] = ACTIONS(2250),
    [anon_sym_yield_BANG] = ACTIONS(2248),
    [anon_sym_lazy] = ACTIONS(2250),
    [anon_sym_assert] = ACTIONS(2250),
    [anon_sym_upcast] = ACTIONS(2250),
    [anon_sym_downcast] = ACTIONS(2250),
    [anon_sym_COLON_GT] = ACTIONS(2248),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2248),
    [anon_sym_for] = ACTIONS(2250),
    [anon_sym_while] = ACTIONS(2250),
    [anon_sym_if] = ACTIONS(2250),
    [anon_sym_fun] = ACTIONS(2250),
    [anon_sym_DASH_GT] = ACTIONS(2250),
    [anon_sym_try] = ACTIONS(2250),
    [anon_sym_match] = ACTIONS(2250),
    [anon_sym_match_BANG] = ACTIONS(2248),
    [anon_sym_function] = ACTIONS(2250),
    [anon_sym_LT_DASH] = ACTIONS(2250),
    [anon_sym_DOT_LBRACK] = ACTIONS(2248),
    [anon_sym_LT] = ACTIONS(2248),
    [anon_sym_use] = ACTIONS(2250),
    [anon_sym_use_BANG] = ACTIONS(2248),
    [anon_sym_do_BANG] = ACTIONS(2248),
    [anon_sym_begin] = ACTIONS(2250),
    [anon_sym_LPAREN2] = ACTIONS(2250),
    [anon_sym_STAR] = ACTIONS(3332),
    [anon_sym_LT2] = ACTIONS(2250),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2248),
    [anon_sym_or] = ACTIONS(2250),
    [aux_sym_char_token1] = ACTIONS(2248),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2250),
    [anon_sym_DQUOTE] = ACTIONS(2250),
    [anon_sym_AT_DQUOTE] = ACTIONS(2248),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2248),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2248),
    [sym_bool] = ACTIONS(2250),
    [sym_unit] = ACTIONS(2248),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2250),
    [sym_op_identifier] = ACTIONS(2250),
    [anon_sym_PLUS] = ACTIONS(2250),
    [anon_sym_DASH] = ACTIONS(2250),
    [anon_sym_PLUS_DOT] = ACTIONS(2250),
    [anon_sym_DASH_DOT] = ACTIONS(2250),
    [anon_sym_PERCENT] = ACTIONS(2250),
    [anon_sym_AMP_AMP] = ACTIONS(2250),
    [anon_sym_TILDE] = ACTIONS(2248),
    [aux_sym_prefix_op_token1] = ACTIONS(2250),
    [aux_sym_infix_op_token1] = ACTIONS(2248),
    [aux_sym_infix_op_token2] = ACTIONS(2250),
    [anon_sym_PIPE_PIPE] = ACTIONS(2250),
    [anon_sym_BANG_EQ] = ACTIONS(2250),
    [anon_sym_COLON_EQ] = ACTIONS(2248),
    [anon_sym_DOLLAR] = ACTIONS(2250),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2250),
    [sym_int] = ACTIONS(2250),
    [sym_xint] = ACTIONS(2248),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2248),
    [sym__newline] = ACTIONS(2248),
    [sym__dedent] = ACTIONS(2248),
  },
  [1127] = {
    [sym_block_comment] = STATE(1127),
    [sym_compiler_directive_decl] = STATE(1127),
    [sym_fsi_directive_decl] = STATE(1127),
    [sym_preproc_line] = STATE(1127),
    [sym_identifier] = ACTIONS(3115),
    [anon_sym_EQ] = ACTIONS(3117),
    [anon_sym_GT_RBRACK] = ACTIONS(3117),
    [anon_sym_COLON] = ACTIONS(3115),
    [anon_sym_return] = ACTIONS(3115),
    [anon_sym_do] = ACTIONS(3115),
    [anon_sym_let] = ACTIONS(3115),
    [anon_sym_let_BANG] = ACTIONS(3117),
    [anon_sym_LPAREN] = ACTIONS(3115),
    [anon_sym_COMMA] = ACTIONS(3117),
    [anon_sym_null] = ACTIONS(3115),
    [anon_sym_QMARK] = ACTIONS(3115),
    [anon_sym_COLON_QMARK] = ACTIONS(3115),
    [anon_sym_COLON_COLON] = ACTIONS(3117),
    [anon_sym_AMP] = ACTIONS(3115),
    [anon_sym_LBRACK] = ACTIONS(3115),
    [anon_sym_RBRACK] = ACTIONS(3117),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3117),
    [anon_sym_LBRACE] = ACTIONS(3115),
    [anon_sym_RBRACE] = ACTIONS(3117),
    [anon_sym_LT_AT] = ACTIONS(3115),
    [anon_sym_LT_AT_AT] = ACTIONS(3115),
    [anon_sym_DOT] = ACTIONS(3115),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3117),
    [anon_sym_new] = ACTIONS(3115),
    [anon_sym_with] = ACTIONS(3115),
    [anon_sym_return_BANG] = ACTIONS(3117),
    [anon_sym_yield] = ACTIONS(3115),
    [anon_sym_yield_BANG] = ACTIONS(3117),
    [anon_sym_lazy] = ACTIONS(3115),
    [anon_sym_assert] = ACTIONS(3115),
    [anon_sym_upcast] = ACTIONS(3115),
    [anon_sym_downcast] = ACTIONS(3115),
    [anon_sym_COLON_GT] = ACTIONS(3117),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3117),
    [anon_sym_for] = ACTIONS(3115),
    [anon_sym_to] = ACTIONS(3115),
    [anon_sym_downto] = ACTIONS(3115),
    [anon_sym_while] = ACTIONS(3115),
    [anon_sym_if] = ACTIONS(3115),
    [anon_sym_fun] = ACTIONS(3115),
    [anon_sym_try] = ACTIONS(3115),
    [anon_sym_match] = ACTIONS(3115),
    [anon_sym_match_BANG] = ACTIONS(3117),
    [anon_sym_function] = ACTIONS(3115),
    [anon_sym_LT_DASH] = ACTIONS(3115),
    [anon_sym_DOT_LBRACK] = ACTIONS(3117),
    [anon_sym_LT] = ACTIONS(3117),
    [anon_sym_use] = ACTIONS(3115),
    [anon_sym_use_BANG] = ACTIONS(3117),
    [anon_sym_do_BANG] = ACTIONS(3117),
    [anon_sym_begin] = ACTIONS(3115),
    [anon_sym_LPAREN2] = ACTIONS(3115),
    [anon_sym_DOT_DOT2] = ACTIONS(3117),
    [anon_sym_or] = ACTIONS(3115),
    [aux_sym_char_token1] = ACTIONS(3117),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3115),
    [anon_sym_DQUOTE] = ACTIONS(3115),
    [anon_sym_AT_DQUOTE] = ACTIONS(3117),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3117),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3117),
    [sym_bool] = ACTIONS(3115),
    [sym_unit] = ACTIONS(3117),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3115),
    [sym_op_identifier] = ACTIONS(3115),
    [anon_sym_PLUS] = ACTIONS(3115),
    [anon_sym_DASH] = ACTIONS(3115),
    [anon_sym_PLUS_DOT] = ACTIONS(3115),
    [anon_sym_DASH_DOT] = ACTIONS(3115),
    [anon_sym_PERCENT] = ACTIONS(3115),
    [anon_sym_AMP_AMP] = ACTIONS(3115),
    [anon_sym_TILDE] = ACTIONS(3117),
    [aux_sym_prefix_op_token1] = ACTIONS(3115),
    [aux_sym_infix_op_token1] = ACTIONS(3117),
    [aux_sym_infix_op_token2] = ACTIONS(3115),
    [anon_sym_PIPE_PIPE] = ACTIONS(3115),
    [anon_sym_BANG_EQ] = ACTIONS(3115),
    [anon_sym_COLON_EQ] = ACTIONS(3117),
    [anon_sym_DOLLAR] = ACTIONS(3115),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3115),
    [sym_int] = ACTIONS(3115),
    [sym_xint] = ACTIONS(3117),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3117),
    [sym__newline] = ACTIONS(3117),
  },
  [1128] = {
    [sym_block_comment] = STATE(1128),
    [sym_compiler_directive_decl] = STATE(1128),
    [sym_fsi_directive_decl] = STATE(1128),
    [sym_preproc_line] = STATE(1128),
    [sym_identifier] = ACTIONS(2887),
    [anon_sym_EQ] = ACTIONS(2889),
    [anon_sym_GT_RBRACK] = ACTIONS(2889),
    [anon_sym_COLON] = ACTIONS(2887),
    [anon_sym_return] = ACTIONS(2887),
    [anon_sym_do] = ACTIONS(2887),
    [anon_sym_let] = ACTIONS(2887),
    [anon_sym_let_BANG] = ACTIONS(2889),
    [anon_sym_LPAREN] = ACTIONS(2887),
    [anon_sym_COMMA] = ACTIONS(2889),
    [anon_sym_null] = ACTIONS(2887),
    [anon_sym_QMARK] = ACTIONS(2887),
    [anon_sym_COLON_QMARK] = ACTIONS(2887),
    [anon_sym_COLON_COLON] = ACTIONS(2889),
    [anon_sym_AMP] = ACTIONS(2887),
    [anon_sym_LBRACK] = ACTIONS(2887),
    [anon_sym_RBRACK] = ACTIONS(2889),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2889),
    [anon_sym_LBRACE] = ACTIONS(2887),
    [anon_sym_RBRACE] = ACTIONS(2889),
    [anon_sym_LT_AT] = ACTIONS(2887),
    [anon_sym_LT_AT_AT] = ACTIONS(2887),
    [anon_sym_DOT] = ACTIONS(2887),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2889),
    [anon_sym_new] = ACTIONS(2887),
    [anon_sym_with] = ACTIONS(2887),
    [anon_sym_return_BANG] = ACTIONS(2889),
    [anon_sym_yield] = ACTIONS(2887),
    [anon_sym_yield_BANG] = ACTIONS(2889),
    [anon_sym_lazy] = ACTIONS(2887),
    [anon_sym_assert] = ACTIONS(2887),
    [anon_sym_upcast] = ACTIONS(2887),
    [anon_sym_downcast] = ACTIONS(2887),
    [anon_sym_COLON_GT] = ACTIONS(2889),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2889),
    [anon_sym_for] = ACTIONS(2887),
    [anon_sym_to] = ACTIONS(2887),
    [anon_sym_downto] = ACTIONS(2887),
    [anon_sym_while] = ACTIONS(2887),
    [anon_sym_if] = ACTIONS(2887),
    [anon_sym_fun] = ACTIONS(2887),
    [anon_sym_try] = ACTIONS(2887),
    [anon_sym_match] = ACTIONS(2887),
    [anon_sym_match_BANG] = ACTIONS(2889),
    [anon_sym_function] = ACTIONS(2887),
    [anon_sym_LT_DASH] = ACTIONS(2887),
    [anon_sym_DOT_LBRACK] = ACTIONS(2889),
    [anon_sym_LT] = ACTIONS(2889),
    [anon_sym_use] = ACTIONS(2887),
    [anon_sym_use_BANG] = ACTIONS(2889),
    [anon_sym_do_BANG] = ACTIONS(2889),
    [anon_sym_begin] = ACTIONS(2887),
    [anon_sym_LPAREN2] = ACTIONS(2887),
    [anon_sym_DOT_DOT2] = ACTIONS(2889),
    [anon_sym_or] = ACTIONS(2887),
    [aux_sym_char_token1] = ACTIONS(2889),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2887),
    [anon_sym_DQUOTE] = ACTIONS(2887),
    [anon_sym_AT_DQUOTE] = ACTIONS(2889),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2889),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2889),
    [sym_bool] = ACTIONS(2887),
    [sym_unit] = ACTIONS(2889),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2887),
    [sym_op_identifier] = ACTIONS(2887),
    [anon_sym_PLUS] = ACTIONS(2887),
    [anon_sym_DASH] = ACTIONS(2887),
    [anon_sym_PLUS_DOT] = ACTIONS(2887),
    [anon_sym_DASH_DOT] = ACTIONS(2887),
    [anon_sym_PERCENT] = ACTIONS(2887),
    [anon_sym_AMP_AMP] = ACTIONS(2887),
    [anon_sym_TILDE] = ACTIONS(2889),
    [aux_sym_prefix_op_token1] = ACTIONS(2887),
    [aux_sym_infix_op_token1] = ACTIONS(2889),
    [aux_sym_infix_op_token2] = ACTIONS(2887),
    [anon_sym_PIPE_PIPE] = ACTIONS(2887),
    [anon_sym_BANG_EQ] = ACTIONS(2887),
    [anon_sym_COLON_EQ] = ACTIONS(2889),
    [anon_sym_DOLLAR] = ACTIONS(2887),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2887),
    [sym_int] = ACTIONS(2887),
    [sym_xint] = ACTIONS(2889),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2889),
    [sym__newline] = ACTIONS(2889),
  },
  [1129] = {
    [sym_block_comment] = STATE(1129),
    [sym_compiler_directive_decl] = STATE(1129),
    [sym_fsi_directive_decl] = STATE(1129),
    [sym_preproc_line] = STATE(1129),
    [sym_identifier] = ACTIONS(2891),
    [anon_sym_EQ] = ACTIONS(2893),
    [anon_sym_GT_RBRACK] = ACTIONS(2893),
    [anon_sym_COLON] = ACTIONS(2891),
    [anon_sym_return] = ACTIONS(2891),
    [anon_sym_do] = ACTIONS(2891),
    [anon_sym_let] = ACTIONS(2891),
    [anon_sym_let_BANG] = ACTIONS(2893),
    [anon_sym_LPAREN] = ACTIONS(2891),
    [anon_sym_COMMA] = ACTIONS(2893),
    [anon_sym_null] = ACTIONS(2891),
    [anon_sym_QMARK] = ACTIONS(2891),
    [anon_sym_COLON_QMARK] = ACTIONS(2891),
    [anon_sym_COLON_COLON] = ACTIONS(2893),
    [anon_sym_AMP] = ACTIONS(2891),
    [anon_sym_LBRACK] = ACTIONS(2891),
    [anon_sym_RBRACK] = ACTIONS(2893),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2893),
    [anon_sym_LBRACE] = ACTIONS(2891),
    [anon_sym_RBRACE] = ACTIONS(2893),
    [anon_sym_LT_AT] = ACTIONS(2891),
    [anon_sym_LT_AT_AT] = ACTIONS(2891),
    [anon_sym_DOT] = ACTIONS(2891),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2893),
    [anon_sym_new] = ACTIONS(2891),
    [anon_sym_with] = ACTIONS(2891),
    [anon_sym_return_BANG] = ACTIONS(2893),
    [anon_sym_yield] = ACTIONS(2891),
    [anon_sym_yield_BANG] = ACTIONS(2893),
    [anon_sym_lazy] = ACTIONS(2891),
    [anon_sym_assert] = ACTIONS(2891),
    [anon_sym_upcast] = ACTIONS(2891),
    [anon_sym_downcast] = ACTIONS(2891),
    [anon_sym_COLON_GT] = ACTIONS(2893),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2893),
    [anon_sym_for] = ACTIONS(2891),
    [anon_sym_to] = ACTIONS(2891),
    [anon_sym_downto] = ACTIONS(2891),
    [anon_sym_while] = ACTIONS(2891),
    [anon_sym_if] = ACTIONS(2891),
    [anon_sym_fun] = ACTIONS(2891),
    [anon_sym_try] = ACTIONS(2891),
    [anon_sym_match] = ACTIONS(2891),
    [anon_sym_match_BANG] = ACTIONS(2893),
    [anon_sym_function] = ACTIONS(2891),
    [anon_sym_LT_DASH] = ACTIONS(2891),
    [anon_sym_DOT_LBRACK] = ACTIONS(2893),
    [anon_sym_LT] = ACTIONS(2893),
    [anon_sym_use] = ACTIONS(2891),
    [anon_sym_use_BANG] = ACTIONS(2893),
    [anon_sym_do_BANG] = ACTIONS(2893),
    [anon_sym_begin] = ACTIONS(2891),
    [anon_sym_LPAREN2] = ACTIONS(2891),
    [anon_sym_DOT_DOT2] = ACTIONS(2893),
    [anon_sym_or] = ACTIONS(2891),
    [aux_sym_char_token1] = ACTIONS(2893),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2891),
    [anon_sym_DQUOTE] = ACTIONS(2891),
    [anon_sym_AT_DQUOTE] = ACTIONS(2893),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2893),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2893),
    [sym_bool] = ACTIONS(2891),
    [sym_unit] = ACTIONS(2893),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2891),
    [sym_op_identifier] = ACTIONS(2891),
    [anon_sym_PLUS] = ACTIONS(2891),
    [anon_sym_DASH] = ACTIONS(2891),
    [anon_sym_PLUS_DOT] = ACTIONS(2891),
    [anon_sym_DASH_DOT] = ACTIONS(2891),
    [anon_sym_PERCENT] = ACTIONS(2891),
    [anon_sym_AMP_AMP] = ACTIONS(2891),
    [anon_sym_TILDE] = ACTIONS(2893),
    [aux_sym_prefix_op_token1] = ACTIONS(2891),
    [aux_sym_infix_op_token1] = ACTIONS(2893),
    [aux_sym_infix_op_token2] = ACTIONS(2891),
    [anon_sym_PIPE_PIPE] = ACTIONS(2891),
    [anon_sym_BANG_EQ] = ACTIONS(2891),
    [anon_sym_COLON_EQ] = ACTIONS(2893),
    [anon_sym_DOLLAR] = ACTIONS(2891),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2891),
    [sym_int] = ACTIONS(2891),
    [sym_xint] = ACTIONS(2893),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2893),
    [sym__newline] = ACTIONS(2893),
  },
  [1130] = {
    [sym_block_comment] = STATE(1130),
    [sym_compiler_directive_decl] = STATE(1130),
    [sym_fsi_directive_decl] = STATE(1130),
    [sym_preproc_line] = STATE(1130),
    [sym_identifier] = ACTIONS(2910),
    [anon_sym_EQ] = ACTIONS(2912),
    [anon_sym_GT_RBRACK] = ACTIONS(2912),
    [anon_sym_COLON] = ACTIONS(2910),
    [anon_sym_return] = ACTIONS(2910),
    [anon_sym_do] = ACTIONS(2910),
    [anon_sym_let] = ACTIONS(2910),
    [anon_sym_let_BANG] = ACTIONS(2912),
    [anon_sym_LPAREN] = ACTIONS(2910),
    [anon_sym_COMMA] = ACTIONS(2912),
    [anon_sym_null] = ACTIONS(2910),
    [anon_sym_QMARK] = ACTIONS(2910),
    [anon_sym_COLON_QMARK] = ACTIONS(2910),
    [anon_sym_COLON_COLON] = ACTIONS(2912),
    [anon_sym_AMP] = ACTIONS(2910),
    [anon_sym_LBRACK] = ACTIONS(2910),
    [anon_sym_RBRACK] = ACTIONS(2912),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2912),
    [anon_sym_LBRACE] = ACTIONS(2910),
    [anon_sym_RBRACE] = ACTIONS(2912),
    [anon_sym_LT_AT] = ACTIONS(2910),
    [anon_sym_LT_AT_AT] = ACTIONS(2910),
    [anon_sym_DOT] = ACTIONS(2910),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2912),
    [anon_sym_new] = ACTIONS(2910),
    [anon_sym_with] = ACTIONS(2910),
    [anon_sym_return_BANG] = ACTIONS(2912),
    [anon_sym_yield] = ACTIONS(2910),
    [anon_sym_yield_BANG] = ACTIONS(2912),
    [anon_sym_lazy] = ACTIONS(2910),
    [anon_sym_assert] = ACTIONS(2910),
    [anon_sym_upcast] = ACTIONS(2910),
    [anon_sym_downcast] = ACTIONS(2910),
    [anon_sym_COLON_GT] = ACTIONS(2912),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2912),
    [anon_sym_for] = ACTIONS(2910),
    [anon_sym_to] = ACTIONS(2910),
    [anon_sym_downto] = ACTIONS(2910),
    [anon_sym_while] = ACTIONS(2910),
    [anon_sym_if] = ACTIONS(2910),
    [anon_sym_fun] = ACTIONS(2910),
    [anon_sym_try] = ACTIONS(2910),
    [anon_sym_match] = ACTIONS(2910),
    [anon_sym_match_BANG] = ACTIONS(2912),
    [anon_sym_function] = ACTIONS(2910),
    [anon_sym_LT_DASH] = ACTIONS(2910),
    [anon_sym_DOT_LBRACK] = ACTIONS(2912),
    [anon_sym_LT] = ACTIONS(2912),
    [anon_sym_use] = ACTIONS(2910),
    [anon_sym_use_BANG] = ACTIONS(2912),
    [anon_sym_do_BANG] = ACTIONS(2912),
    [anon_sym_begin] = ACTIONS(2910),
    [anon_sym_LPAREN2] = ACTIONS(2910),
    [anon_sym_DOT_DOT2] = ACTIONS(2912),
    [anon_sym_or] = ACTIONS(2910),
    [aux_sym_char_token1] = ACTIONS(2912),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2910),
    [anon_sym_DQUOTE] = ACTIONS(2910),
    [anon_sym_AT_DQUOTE] = ACTIONS(2912),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2912),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2912),
    [sym_bool] = ACTIONS(2910),
    [sym_unit] = ACTIONS(2912),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2910),
    [sym_op_identifier] = ACTIONS(2910),
    [anon_sym_PLUS] = ACTIONS(2910),
    [anon_sym_DASH] = ACTIONS(2910),
    [anon_sym_PLUS_DOT] = ACTIONS(2910),
    [anon_sym_DASH_DOT] = ACTIONS(2910),
    [anon_sym_PERCENT] = ACTIONS(2910),
    [anon_sym_AMP_AMP] = ACTIONS(2910),
    [anon_sym_TILDE] = ACTIONS(2912),
    [aux_sym_prefix_op_token1] = ACTIONS(2910),
    [aux_sym_infix_op_token1] = ACTIONS(2912),
    [aux_sym_infix_op_token2] = ACTIONS(2910),
    [anon_sym_PIPE_PIPE] = ACTIONS(2910),
    [anon_sym_BANG_EQ] = ACTIONS(2910),
    [anon_sym_COLON_EQ] = ACTIONS(2912),
    [anon_sym_DOLLAR] = ACTIONS(2910),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2910),
    [sym_int] = ACTIONS(2910),
    [sym_xint] = ACTIONS(2912),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2912),
    [sym__newline] = ACTIONS(2912),
  },
  [1131] = {
    [sym_block_comment] = STATE(1131),
    [sym_compiler_directive_decl] = STATE(1131),
    [sym_fsi_directive_decl] = STATE(1131),
    [sym_preproc_line] = STATE(1131),
    [sym_identifier] = ACTIONS(3099),
    [anon_sym_EQ] = ACTIONS(3101),
    [anon_sym_GT_RBRACK] = ACTIONS(3101),
    [anon_sym_COLON] = ACTIONS(3099),
    [anon_sym_return] = ACTIONS(3099),
    [anon_sym_do] = ACTIONS(3099),
    [anon_sym_let] = ACTIONS(3099),
    [anon_sym_let_BANG] = ACTIONS(3101),
    [anon_sym_LPAREN] = ACTIONS(3099),
    [anon_sym_COMMA] = ACTIONS(3101),
    [anon_sym_null] = ACTIONS(3099),
    [anon_sym_QMARK] = ACTIONS(3099),
    [anon_sym_COLON_QMARK] = ACTIONS(3099),
    [anon_sym_COLON_COLON] = ACTIONS(3101),
    [anon_sym_AMP] = ACTIONS(3099),
    [anon_sym_LBRACK] = ACTIONS(3099),
    [anon_sym_RBRACK] = ACTIONS(3101),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3101),
    [anon_sym_LBRACE] = ACTIONS(3099),
    [anon_sym_RBRACE] = ACTIONS(3101),
    [anon_sym_LT_AT] = ACTIONS(3099),
    [anon_sym_LT_AT_AT] = ACTIONS(3099),
    [anon_sym_DOT] = ACTIONS(3099),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3101),
    [anon_sym_new] = ACTIONS(3099),
    [anon_sym_with] = ACTIONS(3099),
    [anon_sym_return_BANG] = ACTIONS(3101),
    [anon_sym_yield] = ACTIONS(3099),
    [anon_sym_yield_BANG] = ACTIONS(3101),
    [anon_sym_lazy] = ACTIONS(3099),
    [anon_sym_assert] = ACTIONS(3099),
    [anon_sym_upcast] = ACTIONS(3099),
    [anon_sym_downcast] = ACTIONS(3099),
    [anon_sym_COLON_GT] = ACTIONS(3101),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3101),
    [anon_sym_for] = ACTIONS(3099),
    [anon_sym_to] = ACTIONS(3099),
    [anon_sym_downto] = ACTIONS(3099),
    [anon_sym_while] = ACTIONS(3099),
    [anon_sym_if] = ACTIONS(3099),
    [anon_sym_fun] = ACTIONS(3099),
    [anon_sym_try] = ACTIONS(3099),
    [anon_sym_match] = ACTIONS(3099),
    [anon_sym_match_BANG] = ACTIONS(3101),
    [anon_sym_function] = ACTIONS(3099),
    [anon_sym_LT_DASH] = ACTIONS(3099),
    [anon_sym_DOT_LBRACK] = ACTIONS(3101),
    [anon_sym_LT] = ACTIONS(3101),
    [anon_sym_use] = ACTIONS(3099),
    [anon_sym_use_BANG] = ACTIONS(3101),
    [anon_sym_do_BANG] = ACTIONS(3101),
    [anon_sym_begin] = ACTIONS(3099),
    [anon_sym_LPAREN2] = ACTIONS(3099),
    [anon_sym_DOT_DOT2] = ACTIONS(3101),
    [anon_sym_or] = ACTIONS(3099),
    [aux_sym_char_token1] = ACTIONS(3101),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3099),
    [anon_sym_DQUOTE] = ACTIONS(3099),
    [anon_sym_AT_DQUOTE] = ACTIONS(3101),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3101),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3101),
    [sym_bool] = ACTIONS(3099),
    [sym_unit] = ACTIONS(3101),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3099),
    [sym_op_identifier] = ACTIONS(3099),
    [anon_sym_PLUS] = ACTIONS(3099),
    [anon_sym_DASH] = ACTIONS(3099),
    [anon_sym_PLUS_DOT] = ACTIONS(3099),
    [anon_sym_DASH_DOT] = ACTIONS(3099),
    [anon_sym_PERCENT] = ACTIONS(3099),
    [anon_sym_AMP_AMP] = ACTIONS(3099),
    [anon_sym_TILDE] = ACTIONS(3101),
    [aux_sym_prefix_op_token1] = ACTIONS(3099),
    [aux_sym_infix_op_token1] = ACTIONS(3101),
    [aux_sym_infix_op_token2] = ACTIONS(3099),
    [anon_sym_PIPE_PIPE] = ACTIONS(3099),
    [anon_sym_BANG_EQ] = ACTIONS(3099),
    [anon_sym_COLON_EQ] = ACTIONS(3101),
    [anon_sym_DOLLAR] = ACTIONS(3099),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3099),
    [sym_int] = ACTIONS(3099),
    [sym_xint] = ACTIONS(3101),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3101),
    [sym__newline] = ACTIONS(3101),
  },
  [1132] = {
    [sym_block_comment] = STATE(1132),
    [sym_compiler_directive_decl] = STATE(1132),
    [sym_fsi_directive_decl] = STATE(1132),
    [sym_preproc_line] = STATE(1132),
    [sym_identifier] = ACTIONS(2873),
    [anon_sym_EQ] = ACTIONS(2875),
    [anon_sym_GT_RBRACK] = ACTIONS(2875),
    [anon_sym_COLON] = ACTIONS(2873),
    [anon_sym_return] = ACTIONS(2873),
    [anon_sym_do] = ACTIONS(2873),
    [anon_sym_let] = ACTIONS(2873),
    [anon_sym_let_BANG] = ACTIONS(2875),
    [anon_sym_LPAREN] = ACTIONS(2873),
    [anon_sym_COMMA] = ACTIONS(2875),
    [anon_sym_null] = ACTIONS(2873),
    [anon_sym_QMARK] = ACTIONS(2873),
    [anon_sym_COLON_QMARK] = ACTIONS(2873),
    [anon_sym_COLON_COLON] = ACTIONS(2875),
    [anon_sym_AMP] = ACTIONS(2873),
    [anon_sym_LBRACK] = ACTIONS(2873),
    [anon_sym_RBRACK] = ACTIONS(2875),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2875),
    [anon_sym_LBRACE] = ACTIONS(2873),
    [anon_sym_RBRACE] = ACTIONS(2875),
    [anon_sym_LT_AT] = ACTIONS(2873),
    [anon_sym_LT_AT_AT] = ACTIONS(2873),
    [anon_sym_DOT] = ACTIONS(2873),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2875),
    [anon_sym_new] = ACTIONS(2873),
    [anon_sym_with] = ACTIONS(2873),
    [anon_sym_return_BANG] = ACTIONS(2875),
    [anon_sym_yield] = ACTIONS(2873),
    [anon_sym_yield_BANG] = ACTIONS(2875),
    [anon_sym_lazy] = ACTIONS(2873),
    [anon_sym_assert] = ACTIONS(2873),
    [anon_sym_upcast] = ACTIONS(2873),
    [anon_sym_downcast] = ACTIONS(2873),
    [anon_sym_COLON_GT] = ACTIONS(2875),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2875),
    [anon_sym_for] = ACTIONS(2873),
    [anon_sym_to] = ACTIONS(2873),
    [anon_sym_downto] = ACTIONS(2873),
    [anon_sym_while] = ACTIONS(2873),
    [anon_sym_if] = ACTIONS(2873),
    [anon_sym_fun] = ACTIONS(2873),
    [anon_sym_try] = ACTIONS(2873),
    [anon_sym_match] = ACTIONS(2873),
    [anon_sym_match_BANG] = ACTIONS(2875),
    [anon_sym_function] = ACTIONS(2873),
    [anon_sym_LT_DASH] = ACTIONS(2873),
    [anon_sym_DOT_LBRACK] = ACTIONS(2875),
    [anon_sym_LT] = ACTIONS(2875),
    [anon_sym_use] = ACTIONS(2873),
    [anon_sym_use_BANG] = ACTIONS(2875),
    [anon_sym_do_BANG] = ACTIONS(2875),
    [anon_sym_begin] = ACTIONS(2873),
    [anon_sym_LPAREN2] = ACTIONS(2873),
    [anon_sym_DOT_DOT2] = ACTIONS(2875),
    [anon_sym_or] = ACTIONS(2873),
    [aux_sym_char_token1] = ACTIONS(2875),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2873),
    [anon_sym_DQUOTE] = ACTIONS(2873),
    [anon_sym_AT_DQUOTE] = ACTIONS(2875),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2875),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2875),
    [sym_bool] = ACTIONS(2873),
    [sym_unit] = ACTIONS(2875),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2873),
    [sym_op_identifier] = ACTIONS(2873),
    [anon_sym_PLUS] = ACTIONS(2873),
    [anon_sym_DASH] = ACTIONS(2873),
    [anon_sym_PLUS_DOT] = ACTIONS(2873),
    [anon_sym_DASH_DOT] = ACTIONS(2873),
    [anon_sym_PERCENT] = ACTIONS(2873),
    [anon_sym_AMP_AMP] = ACTIONS(2873),
    [anon_sym_TILDE] = ACTIONS(2875),
    [aux_sym_prefix_op_token1] = ACTIONS(2873),
    [aux_sym_infix_op_token1] = ACTIONS(2875),
    [aux_sym_infix_op_token2] = ACTIONS(2873),
    [anon_sym_PIPE_PIPE] = ACTIONS(2873),
    [anon_sym_BANG_EQ] = ACTIONS(2873),
    [anon_sym_COLON_EQ] = ACTIONS(2875),
    [anon_sym_DOLLAR] = ACTIONS(2873),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2873),
    [sym_int] = ACTIONS(2873),
    [sym_xint] = ACTIONS(2875),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2875),
    [sym__newline] = ACTIONS(2875),
  },
  [1133] = {
    [sym_block_comment] = STATE(1133),
    [sym_compiler_directive_decl] = STATE(1133),
    [sym_fsi_directive_decl] = STATE(1133),
    [sym_preproc_line] = STATE(1133),
    [sym_identifier] = ACTIONS(2839),
    [anon_sym_EQ] = ACTIONS(2841),
    [anon_sym_GT_RBRACK] = ACTIONS(2841),
    [anon_sym_COLON] = ACTIONS(2839),
    [anon_sym_return] = ACTIONS(2839),
    [anon_sym_do] = ACTIONS(2839),
    [anon_sym_let] = ACTIONS(2839),
    [anon_sym_let_BANG] = ACTIONS(2841),
    [anon_sym_LPAREN] = ACTIONS(2839),
    [anon_sym_COMMA] = ACTIONS(2841),
    [anon_sym_null] = ACTIONS(2839),
    [anon_sym_QMARK] = ACTIONS(2839),
    [anon_sym_COLON_QMARK] = ACTIONS(2839),
    [anon_sym_COLON_COLON] = ACTIONS(2841),
    [anon_sym_AMP] = ACTIONS(2839),
    [anon_sym_LBRACK] = ACTIONS(2839),
    [anon_sym_RBRACK] = ACTIONS(2841),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2841),
    [anon_sym_LBRACE] = ACTIONS(2839),
    [anon_sym_RBRACE] = ACTIONS(2841),
    [anon_sym_LT_AT] = ACTIONS(2839),
    [anon_sym_LT_AT_AT] = ACTIONS(2839),
    [anon_sym_DOT] = ACTIONS(2839),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2841),
    [anon_sym_new] = ACTIONS(2839),
    [anon_sym_with] = ACTIONS(2839),
    [anon_sym_return_BANG] = ACTIONS(2841),
    [anon_sym_yield] = ACTIONS(2839),
    [anon_sym_yield_BANG] = ACTIONS(2841),
    [anon_sym_lazy] = ACTIONS(2839),
    [anon_sym_assert] = ACTIONS(2839),
    [anon_sym_upcast] = ACTIONS(2839),
    [anon_sym_downcast] = ACTIONS(2839),
    [anon_sym_COLON_GT] = ACTIONS(2841),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2841),
    [anon_sym_for] = ACTIONS(2839),
    [anon_sym_to] = ACTIONS(2839),
    [anon_sym_downto] = ACTIONS(2839),
    [anon_sym_while] = ACTIONS(2839),
    [anon_sym_if] = ACTIONS(2839),
    [anon_sym_fun] = ACTIONS(2839),
    [anon_sym_try] = ACTIONS(2839),
    [anon_sym_match] = ACTIONS(2839),
    [anon_sym_match_BANG] = ACTIONS(2841),
    [anon_sym_function] = ACTIONS(2839),
    [anon_sym_LT_DASH] = ACTIONS(2839),
    [anon_sym_DOT_LBRACK] = ACTIONS(2841),
    [anon_sym_LT] = ACTIONS(2841),
    [anon_sym_use] = ACTIONS(2839),
    [anon_sym_use_BANG] = ACTIONS(2841),
    [anon_sym_do_BANG] = ACTIONS(2841),
    [anon_sym_begin] = ACTIONS(2839),
    [anon_sym_LPAREN2] = ACTIONS(2839),
    [anon_sym_DOT_DOT2] = ACTIONS(2841),
    [anon_sym_or] = ACTIONS(2839),
    [aux_sym_char_token1] = ACTIONS(2841),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2839),
    [anon_sym_DQUOTE] = ACTIONS(2839),
    [anon_sym_AT_DQUOTE] = ACTIONS(2841),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2841),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2841),
    [sym_bool] = ACTIONS(2839),
    [sym_unit] = ACTIONS(2841),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2839),
    [sym_op_identifier] = ACTIONS(2839),
    [anon_sym_PLUS] = ACTIONS(2839),
    [anon_sym_DASH] = ACTIONS(2839),
    [anon_sym_PLUS_DOT] = ACTIONS(2839),
    [anon_sym_DASH_DOT] = ACTIONS(2839),
    [anon_sym_PERCENT] = ACTIONS(2839),
    [anon_sym_AMP_AMP] = ACTIONS(2839),
    [anon_sym_TILDE] = ACTIONS(2841),
    [aux_sym_prefix_op_token1] = ACTIONS(2839),
    [aux_sym_infix_op_token1] = ACTIONS(2841),
    [aux_sym_infix_op_token2] = ACTIONS(2839),
    [anon_sym_PIPE_PIPE] = ACTIONS(2839),
    [anon_sym_BANG_EQ] = ACTIONS(2839),
    [anon_sym_COLON_EQ] = ACTIONS(2841),
    [anon_sym_DOLLAR] = ACTIONS(2839),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2839),
    [sym_int] = ACTIONS(2839),
    [sym_xint] = ACTIONS(2841),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2841),
    [sym__newline] = ACTIONS(2841),
  },
  [1134] = {
    [sym_block_comment] = STATE(1134),
    [sym_compiler_directive_decl] = STATE(1134),
    [sym_fsi_directive_decl] = STATE(1134),
    [sym_preproc_line] = STATE(1134),
    [sym_identifier] = ACTIONS(2914),
    [anon_sym_EQ] = ACTIONS(2916),
    [anon_sym_GT_RBRACK] = ACTIONS(2916),
    [anon_sym_COLON] = ACTIONS(2914),
    [anon_sym_return] = ACTIONS(2914),
    [anon_sym_do] = ACTIONS(2914),
    [anon_sym_let] = ACTIONS(2914),
    [anon_sym_let_BANG] = ACTIONS(2916),
    [anon_sym_LPAREN] = ACTIONS(2914),
    [anon_sym_COMMA] = ACTIONS(2916),
    [anon_sym_null] = ACTIONS(2914),
    [anon_sym_QMARK] = ACTIONS(2914),
    [anon_sym_COLON_QMARK] = ACTIONS(2914),
    [anon_sym_COLON_COLON] = ACTIONS(2916),
    [anon_sym_AMP] = ACTIONS(2914),
    [anon_sym_LBRACK] = ACTIONS(2914),
    [anon_sym_RBRACK] = ACTIONS(2916),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2916),
    [anon_sym_LBRACE] = ACTIONS(2914),
    [anon_sym_RBRACE] = ACTIONS(2916),
    [anon_sym_LT_AT] = ACTIONS(2914),
    [anon_sym_LT_AT_AT] = ACTIONS(2914),
    [anon_sym_DOT] = ACTIONS(2914),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2916),
    [anon_sym_new] = ACTIONS(2914),
    [anon_sym_with] = ACTIONS(2914),
    [anon_sym_return_BANG] = ACTIONS(2916),
    [anon_sym_yield] = ACTIONS(2914),
    [anon_sym_yield_BANG] = ACTIONS(2916),
    [anon_sym_lazy] = ACTIONS(2914),
    [anon_sym_assert] = ACTIONS(2914),
    [anon_sym_upcast] = ACTIONS(2914),
    [anon_sym_downcast] = ACTIONS(2914),
    [anon_sym_COLON_GT] = ACTIONS(2916),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2916),
    [anon_sym_for] = ACTIONS(2914),
    [anon_sym_to] = ACTIONS(2914),
    [anon_sym_downto] = ACTIONS(2914),
    [anon_sym_while] = ACTIONS(2914),
    [anon_sym_if] = ACTIONS(2914),
    [anon_sym_fun] = ACTIONS(2914),
    [anon_sym_try] = ACTIONS(2914),
    [anon_sym_match] = ACTIONS(2914),
    [anon_sym_match_BANG] = ACTIONS(2916),
    [anon_sym_function] = ACTIONS(2914),
    [anon_sym_LT_DASH] = ACTIONS(2914),
    [anon_sym_DOT_LBRACK] = ACTIONS(2916),
    [anon_sym_LT] = ACTIONS(2916),
    [anon_sym_use] = ACTIONS(2914),
    [anon_sym_use_BANG] = ACTIONS(2916),
    [anon_sym_do_BANG] = ACTIONS(2916),
    [anon_sym_begin] = ACTIONS(2914),
    [anon_sym_LPAREN2] = ACTIONS(2914),
    [anon_sym_DOT_DOT2] = ACTIONS(2916),
    [anon_sym_or] = ACTIONS(2914),
    [aux_sym_char_token1] = ACTIONS(2916),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2914),
    [anon_sym_DQUOTE] = ACTIONS(2914),
    [anon_sym_AT_DQUOTE] = ACTIONS(2916),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2916),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2916),
    [sym_bool] = ACTIONS(2914),
    [sym_unit] = ACTIONS(2916),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2914),
    [sym_op_identifier] = ACTIONS(2914),
    [anon_sym_PLUS] = ACTIONS(2914),
    [anon_sym_DASH] = ACTIONS(2914),
    [anon_sym_PLUS_DOT] = ACTIONS(2914),
    [anon_sym_DASH_DOT] = ACTIONS(2914),
    [anon_sym_PERCENT] = ACTIONS(2914),
    [anon_sym_AMP_AMP] = ACTIONS(2914),
    [anon_sym_TILDE] = ACTIONS(2916),
    [aux_sym_prefix_op_token1] = ACTIONS(2914),
    [aux_sym_infix_op_token1] = ACTIONS(2916),
    [aux_sym_infix_op_token2] = ACTIONS(2914),
    [anon_sym_PIPE_PIPE] = ACTIONS(2914),
    [anon_sym_BANG_EQ] = ACTIONS(2914),
    [anon_sym_COLON_EQ] = ACTIONS(2916),
    [anon_sym_DOLLAR] = ACTIONS(2914),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2914),
    [sym_int] = ACTIONS(2914),
    [sym_xint] = ACTIONS(2916),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2916),
    [sym__newline] = ACTIONS(2916),
  },
  [1135] = {
    [sym_block_comment] = STATE(1135),
    [sym_compiler_directive_decl] = STATE(1135),
    [sym_fsi_directive_decl] = STATE(1135),
    [sym_preproc_line] = STATE(1135),
    [sym_identifier] = ACTIONS(3007),
    [anon_sym_EQ] = ACTIONS(3009),
    [anon_sym_GT_RBRACK] = ACTIONS(3009),
    [anon_sym_COLON] = ACTIONS(3007),
    [anon_sym_return] = ACTIONS(3007),
    [anon_sym_do] = ACTIONS(3007),
    [anon_sym_let] = ACTIONS(3007),
    [anon_sym_let_BANG] = ACTIONS(3009),
    [anon_sym_LPAREN] = ACTIONS(3007),
    [anon_sym_COMMA] = ACTIONS(3009),
    [anon_sym_null] = ACTIONS(3007),
    [anon_sym_QMARK] = ACTIONS(3007),
    [anon_sym_COLON_QMARK] = ACTIONS(3007),
    [anon_sym_COLON_COLON] = ACTIONS(3009),
    [anon_sym_AMP] = ACTIONS(3007),
    [anon_sym_LBRACK] = ACTIONS(3007),
    [anon_sym_RBRACK] = ACTIONS(3009),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3009),
    [anon_sym_LBRACE] = ACTIONS(3007),
    [anon_sym_RBRACE] = ACTIONS(3009),
    [anon_sym_LT_AT] = ACTIONS(3007),
    [anon_sym_LT_AT_AT] = ACTIONS(3007),
    [anon_sym_DOT] = ACTIONS(3007),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3009),
    [anon_sym_new] = ACTIONS(3007),
    [anon_sym_with] = ACTIONS(3007),
    [anon_sym_return_BANG] = ACTIONS(3009),
    [anon_sym_yield] = ACTIONS(3007),
    [anon_sym_yield_BANG] = ACTIONS(3009),
    [anon_sym_lazy] = ACTIONS(3007),
    [anon_sym_assert] = ACTIONS(3007),
    [anon_sym_upcast] = ACTIONS(3007),
    [anon_sym_downcast] = ACTIONS(3007),
    [anon_sym_COLON_GT] = ACTIONS(3009),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3009),
    [anon_sym_for] = ACTIONS(3007),
    [anon_sym_to] = ACTIONS(3007),
    [anon_sym_downto] = ACTIONS(3007),
    [anon_sym_while] = ACTIONS(3007),
    [anon_sym_if] = ACTIONS(3007),
    [anon_sym_fun] = ACTIONS(3007),
    [anon_sym_try] = ACTIONS(3007),
    [anon_sym_match] = ACTIONS(3007),
    [anon_sym_match_BANG] = ACTIONS(3009),
    [anon_sym_function] = ACTIONS(3007),
    [anon_sym_LT_DASH] = ACTIONS(3007),
    [anon_sym_DOT_LBRACK] = ACTIONS(3009),
    [anon_sym_LT] = ACTIONS(3009),
    [anon_sym_use] = ACTIONS(3007),
    [anon_sym_use_BANG] = ACTIONS(3009),
    [anon_sym_do_BANG] = ACTIONS(3009),
    [anon_sym_begin] = ACTIONS(3007),
    [anon_sym_LPAREN2] = ACTIONS(3007),
    [anon_sym_DOT_DOT2] = ACTIONS(3009),
    [anon_sym_or] = ACTIONS(3007),
    [aux_sym_char_token1] = ACTIONS(3009),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3007),
    [anon_sym_DQUOTE] = ACTIONS(3007),
    [anon_sym_AT_DQUOTE] = ACTIONS(3009),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3009),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3009),
    [sym_bool] = ACTIONS(3007),
    [sym_unit] = ACTIONS(3009),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3007),
    [sym_op_identifier] = ACTIONS(3007),
    [anon_sym_PLUS] = ACTIONS(3007),
    [anon_sym_DASH] = ACTIONS(3007),
    [anon_sym_PLUS_DOT] = ACTIONS(3007),
    [anon_sym_DASH_DOT] = ACTIONS(3007),
    [anon_sym_PERCENT] = ACTIONS(3007),
    [anon_sym_AMP_AMP] = ACTIONS(3007),
    [anon_sym_TILDE] = ACTIONS(3009),
    [aux_sym_prefix_op_token1] = ACTIONS(3007),
    [aux_sym_infix_op_token1] = ACTIONS(3009),
    [aux_sym_infix_op_token2] = ACTIONS(3007),
    [anon_sym_PIPE_PIPE] = ACTIONS(3007),
    [anon_sym_BANG_EQ] = ACTIONS(3007),
    [anon_sym_COLON_EQ] = ACTIONS(3009),
    [anon_sym_DOLLAR] = ACTIONS(3007),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3007),
    [sym_int] = ACTIONS(3007),
    [sym_xint] = ACTIONS(3009),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3009),
    [sym__newline] = ACTIONS(3009),
  },
  [1136] = {
    [sym_block_comment] = STATE(1136),
    [sym_compiler_directive_decl] = STATE(1136),
    [sym_fsi_directive_decl] = STATE(1136),
    [sym_preproc_line] = STATE(1136),
    [sym_identifier] = ACTIONS(2918),
    [anon_sym_EQ] = ACTIONS(2920),
    [anon_sym_GT_RBRACK] = ACTIONS(2920),
    [anon_sym_COLON] = ACTIONS(2918),
    [anon_sym_return] = ACTIONS(2918),
    [anon_sym_do] = ACTIONS(2918),
    [anon_sym_let] = ACTIONS(2918),
    [anon_sym_let_BANG] = ACTIONS(2920),
    [anon_sym_LPAREN] = ACTIONS(2918),
    [anon_sym_COMMA] = ACTIONS(2920),
    [anon_sym_null] = ACTIONS(2918),
    [anon_sym_QMARK] = ACTIONS(2918),
    [anon_sym_COLON_QMARK] = ACTIONS(2918),
    [anon_sym_COLON_COLON] = ACTIONS(2920),
    [anon_sym_AMP] = ACTIONS(2918),
    [anon_sym_LBRACK] = ACTIONS(2918),
    [anon_sym_RBRACK] = ACTIONS(2920),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2920),
    [anon_sym_LBRACE] = ACTIONS(2918),
    [anon_sym_RBRACE] = ACTIONS(2920),
    [anon_sym_LT_AT] = ACTIONS(2918),
    [anon_sym_LT_AT_AT] = ACTIONS(2918),
    [anon_sym_DOT] = ACTIONS(2918),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2920),
    [anon_sym_new] = ACTIONS(2918),
    [anon_sym_with] = ACTIONS(2918),
    [anon_sym_return_BANG] = ACTIONS(2920),
    [anon_sym_yield] = ACTIONS(2918),
    [anon_sym_yield_BANG] = ACTIONS(2920),
    [anon_sym_lazy] = ACTIONS(2918),
    [anon_sym_assert] = ACTIONS(2918),
    [anon_sym_upcast] = ACTIONS(2918),
    [anon_sym_downcast] = ACTIONS(2918),
    [anon_sym_COLON_GT] = ACTIONS(2920),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2920),
    [anon_sym_for] = ACTIONS(2918),
    [anon_sym_to] = ACTIONS(2918),
    [anon_sym_downto] = ACTIONS(2918),
    [anon_sym_while] = ACTIONS(2918),
    [anon_sym_if] = ACTIONS(2918),
    [anon_sym_fun] = ACTIONS(2918),
    [anon_sym_try] = ACTIONS(2918),
    [anon_sym_match] = ACTIONS(2918),
    [anon_sym_match_BANG] = ACTIONS(2920),
    [anon_sym_function] = ACTIONS(2918),
    [anon_sym_LT_DASH] = ACTIONS(2918),
    [anon_sym_DOT_LBRACK] = ACTIONS(2920),
    [anon_sym_LT] = ACTIONS(2920),
    [anon_sym_use] = ACTIONS(2918),
    [anon_sym_use_BANG] = ACTIONS(2920),
    [anon_sym_do_BANG] = ACTIONS(2920),
    [anon_sym_begin] = ACTIONS(2918),
    [anon_sym_LPAREN2] = ACTIONS(2918),
    [anon_sym_DOT_DOT2] = ACTIONS(2920),
    [anon_sym_or] = ACTIONS(2918),
    [aux_sym_char_token1] = ACTIONS(2920),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2918),
    [anon_sym_DQUOTE] = ACTIONS(2918),
    [anon_sym_AT_DQUOTE] = ACTIONS(2920),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2920),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2920),
    [sym_bool] = ACTIONS(2918),
    [sym_unit] = ACTIONS(2920),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2918),
    [sym_op_identifier] = ACTIONS(2918),
    [anon_sym_PLUS] = ACTIONS(2918),
    [anon_sym_DASH] = ACTIONS(2918),
    [anon_sym_PLUS_DOT] = ACTIONS(2918),
    [anon_sym_DASH_DOT] = ACTIONS(2918),
    [anon_sym_PERCENT] = ACTIONS(2918),
    [anon_sym_AMP_AMP] = ACTIONS(2918),
    [anon_sym_TILDE] = ACTIONS(2920),
    [aux_sym_prefix_op_token1] = ACTIONS(2918),
    [aux_sym_infix_op_token1] = ACTIONS(2920),
    [aux_sym_infix_op_token2] = ACTIONS(2918),
    [anon_sym_PIPE_PIPE] = ACTIONS(2918),
    [anon_sym_BANG_EQ] = ACTIONS(2918),
    [anon_sym_COLON_EQ] = ACTIONS(2920),
    [anon_sym_DOLLAR] = ACTIONS(2918),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2918),
    [sym_int] = ACTIONS(2918),
    [sym_xint] = ACTIONS(2920),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2920),
    [sym__newline] = ACTIONS(2920),
  },
  [1137] = {
    [sym_block_comment] = STATE(1137),
    [sym_compiler_directive_decl] = STATE(1137),
    [sym_fsi_directive_decl] = STATE(1137),
    [sym_preproc_line] = STATE(1137),
    [sym_identifier] = ACTIONS(2411),
    [anon_sym_EQ] = ACTIONS(2413),
    [anon_sym_COLON] = ACTIONS(2411),
    [anon_sym_return] = ACTIONS(2411),
    [anon_sym_do] = ACTIONS(2411),
    [anon_sym_let] = ACTIONS(2411),
    [anon_sym_let_BANG] = ACTIONS(2413),
    [anon_sym_as] = ACTIONS(2411),
    [anon_sym_LPAREN] = ACTIONS(2411),
    [anon_sym_COMMA] = ACTIONS(2413),
    [anon_sym_null] = ACTIONS(2411),
    [anon_sym_QMARK] = ACTIONS(2411),
    [anon_sym_COLON_QMARK] = ACTIONS(2411),
    [anon_sym_COLON_COLON] = ACTIONS(2413),
    [anon_sym_AMP] = ACTIONS(2411),
    [anon_sym_LBRACK] = ACTIONS(2411),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2413),
    [anon_sym_LBRACE] = ACTIONS(2411),
    [anon_sym_LT_AT] = ACTIONS(2411),
    [anon_sym_LT_AT_AT] = ACTIONS(2411),
    [anon_sym_DOT] = ACTIONS(2411),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2413),
    [anon_sym_new] = ACTIONS(2411),
    [anon_sym_with] = ACTIONS(2411),
    [anon_sym_return_BANG] = ACTIONS(2413),
    [anon_sym_yield] = ACTIONS(2411),
    [anon_sym_yield_BANG] = ACTIONS(2413),
    [anon_sym_lazy] = ACTIONS(2411),
    [anon_sym_assert] = ACTIONS(2411),
    [anon_sym_upcast] = ACTIONS(2411),
    [anon_sym_downcast] = ACTIONS(2411),
    [anon_sym_COLON_GT] = ACTIONS(2413),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2413),
    [anon_sym_for] = ACTIONS(2411),
    [anon_sym_while] = ACTIONS(2411),
    [anon_sym_if] = ACTIONS(2411),
    [anon_sym_fun] = ACTIONS(2411),
    [anon_sym_DASH_GT] = ACTIONS(2411),
    [anon_sym_try] = ACTIONS(2411),
    [anon_sym_match] = ACTIONS(2411),
    [anon_sym_match_BANG] = ACTIONS(2413),
    [anon_sym_function] = ACTIONS(2411),
    [anon_sym_LT_DASH] = ACTIONS(2411),
    [anon_sym_DOT_LBRACK] = ACTIONS(2413),
    [anon_sym_LT] = ACTIONS(2413),
    [anon_sym_use] = ACTIONS(2411),
    [anon_sym_use_BANG] = ACTIONS(2413),
    [anon_sym_do_BANG] = ACTIONS(2413),
    [anon_sym_begin] = ACTIONS(2411),
    [anon_sym_LPAREN2] = ACTIONS(2411),
    [anon_sym_STAR] = ACTIONS(2411),
    [anon_sym_LT2] = ACTIONS(2411),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2413),
    [anon_sym_or] = ACTIONS(2411),
    [aux_sym_char_token1] = ACTIONS(2413),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2411),
    [anon_sym_DQUOTE] = ACTIONS(2411),
    [anon_sym_AT_DQUOTE] = ACTIONS(2413),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2413),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2413),
    [sym_bool] = ACTIONS(2411),
    [sym_unit] = ACTIONS(2413),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2411),
    [sym_op_identifier] = ACTIONS(2411),
    [anon_sym_PLUS] = ACTIONS(2411),
    [anon_sym_DASH] = ACTIONS(2411),
    [anon_sym_PLUS_DOT] = ACTIONS(2411),
    [anon_sym_DASH_DOT] = ACTIONS(2411),
    [anon_sym_PERCENT] = ACTIONS(2411),
    [anon_sym_AMP_AMP] = ACTIONS(2411),
    [anon_sym_TILDE] = ACTIONS(2413),
    [aux_sym_prefix_op_token1] = ACTIONS(2411),
    [aux_sym_infix_op_token1] = ACTIONS(2413),
    [aux_sym_infix_op_token2] = ACTIONS(2411),
    [anon_sym_PIPE_PIPE] = ACTIONS(2411),
    [anon_sym_BANG_EQ] = ACTIONS(2411),
    [anon_sym_COLON_EQ] = ACTIONS(2413),
    [anon_sym_DOLLAR] = ACTIONS(2411),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2411),
    [sym_int] = ACTIONS(2411),
    [sym_xint] = ACTIONS(2413),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2413),
    [sym__newline] = ACTIONS(2413),
    [sym__dedent] = ACTIONS(2413),
  },
  [1138] = {
    [sym_block_comment] = STATE(1138),
    [sym_compiler_directive_decl] = STATE(1138),
    [sym_fsi_directive_decl] = STATE(1138),
    [sym_preproc_line] = STATE(1138),
    [sym_identifier] = ACTIONS(2922),
    [anon_sym_EQ] = ACTIONS(2924),
    [anon_sym_GT_RBRACK] = ACTIONS(2924),
    [anon_sym_COLON] = ACTIONS(2922),
    [anon_sym_return] = ACTIONS(2922),
    [anon_sym_do] = ACTIONS(2922),
    [anon_sym_let] = ACTIONS(2922),
    [anon_sym_let_BANG] = ACTIONS(2924),
    [anon_sym_LPAREN] = ACTIONS(2922),
    [anon_sym_COMMA] = ACTIONS(2924),
    [anon_sym_null] = ACTIONS(2922),
    [anon_sym_QMARK] = ACTIONS(2922),
    [anon_sym_COLON_QMARK] = ACTIONS(2922),
    [anon_sym_COLON_COLON] = ACTIONS(2924),
    [anon_sym_AMP] = ACTIONS(2922),
    [anon_sym_LBRACK] = ACTIONS(2922),
    [anon_sym_RBRACK] = ACTIONS(2924),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2924),
    [anon_sym_LBRACE] = ACTIONS(2922),
    [anon_sym_RBRACE] = ACTIONS(2924),
    [anon_sym_LT_AT] = ACTIONS(2922),
    [anon_sym_LT_AT_AT] = ACTIONS(2922),
    [anon_sym_DOT] = ACTIONS(2922),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2924),
    [anon_sym_new] = ACTIONS(2922),
    [anon_sym_with] = ACTIONS(2922),
    [anon_sym_return_BANG] = ACTIONS(2924),
    [anon_sym_yield] = ACTIONS(2922),
    [anon_sym_yield_BANG] = ACTIONS(2924),
    [anon_sym_lazy] = ACTIONS(2922),
    [anon_sym_assert] = ACTIONS(2922),
    [anon_sym_upcast] = ACTIONS(2922),
    [anon_sym_downcast] = ACTIONS(2922),
    [anon_sym_COLON_GT] = ACTIONS(2924),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2924),
    [anon_sym_for] = ACTIONS(2922),
    [anon_sym_to] = ACTIONS(2922),
    [anon_sym_downto] = ACTIONS(2922),
    [anon_sym_while] = ACTIONS(2922),
    [anon_sym_if] = ACTIONS(2922),
    [anon_sym_fun] = ACTIONS(2922),
    [anon_sym_try] = ACTIONS(2922),
    [anon_sym_match] = ACTIONS(2922),
    [anon_sym_match_BANG] = ACTIONS(2924),
    [anon_sym_function] = ACTIONS(2922),
    [anon_sym_LT_DASH] = ACTIONS(2922),
    [anon_sym_DOT_LBRACK] = ACTIONS(2924),
    [anon_sym_LT] = ACTIONS(2924),
    [anon_sym_use] = ACTIONS(2922),
    [anon_sym_use_BANG] = ACTIONS(2924),
    [anon_sym_do_BANG] = ACTIONS(2924),
    [anon_sym_begin] = ACTIONS(2922),
    [anon_sym_LPAREN2] = ACTIONS(2922),
    [anon_sym_DOT_DOT2] = ACTIONS(2924),
    [anon_sym_or] = ACTIONS(2922),
    [aux_sym_char_token1] = ACTIONS(2924),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2922),
    [anon_sym_DQUOTE] = ACTIONS(2922),
    [anon_sym_AT_DQUOTE] = ACTIONS(2924),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2924),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2924),
    [sym_bool] = ACTIONS(2922),
    [sym_unit] = ACTIONS(2924),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2922),
    [sym_op_identifier] = ACTIONS(2922),
    [anon_sym_PLUS] = ACTIONS(2922),
    [anon_sym_DASH] = ACTIONS(2922),
    [anon_sym_PLUS_DOT] = ACTIONS(2922),
    [anon_sym_DASH_DOT] = ACTIONS(2922),
    [anon_sym_PERCENT] = ACTIONS(2922),
    [anon_sym_AMP_AMP] = ACTIONS(2922),
    [anon_sym_TILDE] = ACTIONS(2924),
    [aux_sym_prefix_op_token1] = ACTIONS(2922),
    [aux_sym_infix_op_token1] = ACTIONS(2924),
    [aux_sym_infix_op_token2] = ACTIONS(2922),
    [anon_sym_PIPE_PIPE] = ACTIONS(2922),
    [anon_sym_BANG_EQ] = ACTIONS(2922),
    [anon_sym_COLON_EQ] = ACTIONS(2924),
    [anon_sym_DOLLAR] = ACTIONS(2922),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2922),
    [sym_int] = ACTIONS(2922),
    [sym_xint] = ACTIONS(2924),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2924),
    [sym__newline] = ACTIONS(2924),
  },
  [1139] = {
    [sym_block_comment] = STATE(1139),
    [sym_compiler_directive_decl] = STATE(1139),
    [sym_fsi_directive_decl] = STATE(1139),
    [sym_preproc_line] = STATE(1139),
    [sym_identifier] = ACTIONS(3091),
    [anon_sym_EQ] = ACTIONS(3093),
    [anon_sym_GT_RBRACK] = ACTIONS(3093),
    [anon_sym_COLON] = ACTIONS(3091),
    [anon_sym_return] = ACTIONS(3091),
    [anon_sym_do] = ACTIONS(3091),
    [anon_sym_let] = ACTIONS(3091),
    [anon_sym_let_BANG] = ACTIONS(3093),
    [anon_sym_LPAREN] = ACTIONS(3091),
    [anon_sym_COMMA] = ACTIONS(3093),
    [anon_sym_null] = ACTIONS(3091),
    [anon_sym_QMARK] = ACTIONS(3091),
    [anon_sym_COLON_QMARK] = ACTIONS(3091),
    [anon_sym_COLON_COLON] = ACTIONS(3093),
    [anon_sym_AMP] = ACTIONS(3091),
    [anon_sym_LBRACK] = ACTIONS(3091),
    [anon_sym_RBRACK] = ACTIONS(3093),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3093),
    [anon_sym_LBRACE] = ACTIONS(3091),
    [anon_sym_RBRACE] = ACTIONS(3093),
    [anon_sym_LT_AT] = ACTIONS(3091),
    [anon_sym_LT_AT_AT] = ACTIONS(3091),
    [anon_sym_DOT] = ACTIONS(3091),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3093),
    [anon_sym_new] = ACTIONS(3091),
    [anon_sym_with] = ACTIONS(3091),
    [anon_sym_return_BANG] = ACTIONS(3093),
    [anon_sym_yield] = ACTIONS(3091),
    [anon_sym_yield_BANG] = ACTIONS(3093),
    [anon_sym_lazy] = ACTIONS(3091),
    [anon_sym_assert] = ACTIONS(3091),
    [anon_sym_upcast] = ACTIONS(3091),
    [anon_sym_downcast] = ACTIONS(3091),
    [anon_sym_COLON_GT] = ACTIONS(3093),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3093),
    [anon_sym_for] = ACTIONS(3091),
    [anon_sym_to] = ACTIONS(3091),
    [anon_sym_downto] = ACTIONS(3091),
    [anon_sym_while] = ACTIONS(3091),
    [anon_sym_if] = ACTIONS(3091),
    [anon_sym_fun] = ACTIONS(3091),
    [anon_sym_try] = ACTIONS(3091),
    [anon_sym_match] = ACTIONS(3091),
    [anon_sym_match_BANG] = ACTIONS(3093),
    [anon_sym_function] = ACTIONS(3091),
    [anon_sym_LT_DASH] = ACTIONS(3091),
    [anon_sym_DOT_LBRACK] = ACTIONS(3093),
    [anon_sym_LT] = ACTIONS(3093),
    [anon_sym_use] = ACTIONS(3091),
    [anon_sym_use_BANG] = ACTIONS(3093),
    [anon_sym_do_BANG] = ACTIONS(3093),
    [anon_sym_begin] = ACTIONS(3091),
    [anon_sym_LPAREN2] = ACTIONS(3091),
    [anon_sym_DOT_DOT2] = ACTIONS(3093),
    [anon_sym_or] = ACTIONS(3091),
    [aux_sym_char_token1] = ACTIONS(3093),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3091),
    [anon_sym_DQUOTE] = ACTIONS(3091),
    [anon_sym_AT_DQUOTE] = ACTIONS(3093),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3093),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3093),
    [sym_bool] = ACTIONS(3091),
    [sym_unit] = ACTIONS(3093),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3091),
    [sym_op_identifier] = ACTIONS(3091),
    [anon_sym_PLUS] = ACTIONS(3091),
    [anon_sym_DASH] = ACTIONS(3091),
    [anon_sym_PLUS_DOT] = ACTIONS(3091),
    [anon_sym_DASH_DOT] = ACTIONS(3091),
    [anon_sym_PERCENT] = ACTIONS(3091),
    [anon_sym_AMP_AMP] = ACTIONS(3091),
    [anon_sym_TILDE] = ACTIONS(3093),
    [aux_sym_prefix_op_token1] = ACTIONS(3091),
    [aux_sym_infix_op_token1] = ACTIONS(3093),
    [aux_sym_infix_op_token2] = ACTIONS(3091),
    [anon_sym_PIPE_PIPE] = ACTIONS(3091),
    [anon_sym_BANG_EQ] = ACTIONS(3091),
    [anon_sym_COLON_EQ] = ACTIONS(3093),
    [anon_sym_DOLLAR] = ACTIONS(3091),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3091),
    [sym_int] = ACTIONS(3091),
    [sym_xint] = ACTIONS(3093),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3093),
    [sym__newline] = ACTIONS(3093),
  },
  [1140] = {
    [sym_block_comment] = STATE(1140),
    [sym_compiler_directive_decl] = STATE(1140),
    [sym_fsi_directive_decl] = STATE(1140),
    [sym_preproc_line] = STATE(1140),
    [sym_identifier] = ACTIONS(3087),
    [anon_sym_EQ] = ACTIONS(3089),
    [anon_sym_GT_RBRACK] = ACTIONS(3089),
    [anon_sym_COLON] = ACTIONS(3087),
    [anon_sym_return] = ACTIONS(3087),
    [anon_sym_do] = ACTIONS(3087),
    [anon_sym_let] = ACTIONS(3087),
    [anon_sym_let_BANG] = ACTIONS(3089),
    [anon_sym_LPAREN] = ACTIONS(3087),
    [anon_sym_COMMA] = ACTIONS(3089),
    [anon_sym_null] = ACTIONS(3087),
    [anon_sym_QMARK] = ACTIONS(3087),
    [anon_sym_COLON_QMARK] = ACTIONS(3087),
    [anon_sym_COLON_COLON] = ACTIONS(3089),
    [anon_sym_AMP] = ACTIONS(3087),
    [anon_sym_LBRACK] = ACTIONS(3087),
    [anon_sym_RBRACK] = ACTIONS(3089),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3089),
    [anon_sym_LBRACE] = ACTIONS(3087),
    [anon_sym_RBRACE] = ACTIONS(3089),
    [anon_sym_LT_AT] = ACTIONS(3087),
    [anon_sym_LT_AT_AT] = ACTIONS(3087),
    [anon_sym_DOT] = ACTIONS(3087),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3089),
    [anon_sym_new] = ACTIONS(3087),
    [anon_sym_with] = ACTIONS(3087),
    [anon_sym_return_BANG] = ACTIONS(3089),
    [anon_sym_yield] = ACTIONS(3087),
    [anon_sym_yield_BANG] = ACTIONS(3089),
    [anon_sym_lazy] = ACTIONS(3087),
    [anon_sym_assert] = ACTIONS(3087),
    [anon_sym_upcast] = ACTIONS(3087),
    [anon_sym_downcast] = ACTIONS(3087),
    [anon_sym_COLON_GT] = ACTIONS(3089),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3089),
    [anon_sym_for] = ACTIONS(3087),
    [anon_sym_to] = ACTIONS(3087),
    [anon_sym_downto] = ACTIONS(3087),
    [anon_sym_while] = ACTIONS(3087),
    [anon_sym_if] = ACTIONS(3087),
    [anon_sym_fun] = ACTIONS(3087),
    [anon_sym_try] = ACTIONS(3087),
    [anon_sym_match] = ACTIONS(3087),
    [anon_sym_match_BANG] = ACTIONS(3089),
    [anon_sym_function] = ACTIONS(3087),
    [anon_sym_LT_DASH] = ACTIONS(3087),
    [anon_sym_DOT_LBRACK] = ACTIONS(3089),
    [anon_sym_LT] = ACTIONS(3089),
    [anon_sym_use] = ACTIONS(3087),
    [anon_sym_use_BANG] = ACTIONS(3089),
    [anon_sym_do_BANG] = ACTIONS(3089),
    [anon_sym_begin] = ACTIONS(3087),
    [anon_sym_LPAREN2] = ACTIONS(3087),
    [anon_sym_DOT_DOT2] = ACTIONS(3089),
    [anon_sym_or] = ACTIONS(3087),
    [aux_sym_char_token1] = ACTIONS(3089),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3087),
    [anon_sym_DQUOTE] = ACTIONS(3087),
    [anon_sym_AT_DQUOTE] = ACTIONS(3089),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3089),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3089),
    [sym_bool] = ACTIONS(3087),
    [sym_unit] = ACTIONS(3089),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3087),
    [sym_op_identifier] = ACTIONS(3087),
    [anon_sym_PLUS] = ACTIONS(3087),
    [anon_sym_DASH] = ACTIONS(3087),
    [anon_sym_PLUS_DOT] = ACTIONS(3087),
    [anon_sym_DASH_DOT] = ACTIONS(3087),
    [anon_sym_PERCENT] = ACTIONS(3087),
    [anon_sym_AMP_AMP] = ACTIONS(3087),
    [anon_sym_TILDE] = ACTIONS(3089),
    [aux_sym_prefix_op_token1] = ACTIONS(3087),
    [aux_sym_infix_op_token1] = ACTIONS(3089),
    [aux_sym_infix_op_token2] = ACTIONS(3087),
    [anon_sym_PIPE_PIPE] = ACTIONS(3087),
    [anon_sym_BANG_EQ] = ACTIONS(3087),
    [anon_sym_COLON_EQ] = ACTIONS(3089),
    [anon_sym_DOLLAR] = ACTIONS(3087),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3087),
    [sym_int] = ACTIONS(3087),
    [sym_xint] = ACTIONS(3089),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3089),
    [sym__newline] = ACTIONS(3089),
  },
  [1141] = {
    [sym_block_comment] = STATE(1141),
    [sym_compiler_directive_decl] = STATE(1141),
    [sym_fsi_directive_decl] = STATE(1141),
    [sym_preproc_line] = STATE(1141),
    [sym_identifier] = ACTIONS(2938),
    [anon_sym_EQ] = ACTIONS(2940),
    [anon_sym_GT_RBRACK] = ACTIONS(2940),
    [anon_sym_COLON] = ACTIONS(2938),
    [anon_sym_return] = ACTIONS(2938),
    [anon_sym_do] = ACTIONS(2938),
    [anon_sym_let] = ACTIONS(2938),
    [anon_sym_let_BANG] = ACTIONS(2940),
    [anon_sym_LPAREN] = ACTIONS(2938),
    [anon_sym_COMMA] = ACTIONS(2940),
    [anon_sym_null] = ACTIONS(2938),
    [anon_sym_QMARK] = ACTIONS(2938),
    [anon_sym_COLON_QMARK] = ACTIONS(2938),
    [anon_sym_COLON_COLON] = ACTIONS(2940),
    [anon_sym_AMP] = ACTIONS(2938),
    [anon_sym_LBRACK] = ACTIONS(2938),
    [anon_sym_RBRACK] = ACTIONS(2940),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2940),
    [anon_sym_LBRACE] = ACTIONS(2938),
    [anon_sym_RBRACE] = ACTIONS(2940),
    [anon_sym_LT_AT] = ACTIONS(2938),
    [anon_sym_LT_AT_AT] = ACTIONS(2938),
    [anon_sym_DOT] = ACTIONS(2938),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2940),
    [anon_sym_new] = ACTIONS(2938),
    [anon_sym_with] = ACTIONS(2938),
    [anon_sym_return_BANG] = ACTIONS(2940),
    [anon_sym_yield] = ACTIONS(2938),
    [anon_sym_yield_BANG] = ACTIONS(2940),
    [anon_sym_lazy] = ACTIONS(2938),
    [anon_sym_assert] = ACTIONS(2938),
    [anon_sym_upcast] = ACTIONS(2938),
    [anon_sym_downcast] = ACTIONS(2938),
    [anon_sym_COLON_GT] = ACTIONS(2940),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2940),
    [anon_sym_for] = ACTIONS(2938),
    [anon_sym_to] = ACTIONS(2938),
    [anon_sym_downto] = ACTIONS(2938),
    [anon_sym_while] = ACTIONS(2938),
    [anon_sym_if] = ACTIONS(2938),
    [anon_sym_fun] = ACTIONS(2938),
    [anon_sym_try] = ACTIONS(2938),
    [anon_sym_match] = ACTIONS(2938),
    [anon_sym_match_BANG] = ACTIONS(2940),
    [anon_sym_function] = ACTIONS(2938),
    [anon_sym_LT_DASH] = ACTIONS(2938),
    [anon_sym_DOT_LBRACK] = ACTIONS(2940),
    [anon_sym_LT] = ACTIONS(2940),
    [anon_sym_use] = ACTIONS(2938),
    [anon_sym_use_BANG] = ACTIONS(2940),
    [anon_sym_do_BANG] = ACTIONS(2940),
    [anon_sym_begin] = ACTIONS(2938),
    [anon_sym_LPAREN2] = ACTIONS(2938),
    [anon_sym_DOT_DOT2] = ACTIONS(2940),
    [anon_sym_or] = ACTIONS(2938),
    [aux_sym_char_token1] = ACTIONS(2940),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2938),
    [anon_sym_DQUOTE] = ACTIONS(2938),
    [anon_sym_AT_DQUOTE] = ACTIONS(2940),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2940),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2940),
    [sym_bool] = ACTIONS(2938),
    [sym_unit] = ACTIONS(2940),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2938),
    [sym_op_identifier] = ACTIONS(2938),
    [anon_sym_PLUS] = ACTIONS(2938),
    [anon_sym_DASH] = ACTIONS(2938),
    [anon_sym_PLUS_DOT] = ACTIONS(2938),
    [anon_sym_DASH_DOT] = ACTIONS(2938),
    [anon_sym_PERCENT] = ACTIONS(2938),
    [anon_sym_AMP_AMP] = ACTIONS(2938),
    [anon_sym_TILDE] = ACTIONS(2940),
    [aux_sym_prefix_op_token1] = ACTIONS(2938),
    [aux_sym_infix_op_token1] = ACTIONS(2940),
    [aux_sym_infix_op_token2] = ACTIONS(2938),
    [anon_sym_PIPE_PIPE] = ACTIONS(2938),
    [anon_sym_BANG_EQ] = ACTIONS(2938),
    [anon_sym_COLON_EQ] = ACTIONS(2940),
    [anon_sym_DOLLAR] = ACTIONS(2938),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2938),
    [sym_int] = ACTIONS(2938),
    [sym_xint] = ACTIONS(2940),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2940),
    [sym__newline] = ACTIONS(2940),
  },
  [1142] = {
    [sym_block_comment] = STATE(1142),
    [sym_compiler_directive_decl] = STATE(1142),
    [sym_fsi_directive_decl] = STATE(1142),
    [sym_preproc_line] = STATE(1142),
    [sym_identifier] = ACTIONS(3123),
    [anon_sym_EQ] = ACTIONS(3125),
    [anon_sym_GT_RBRACK] = ACTIONS(3125),
    [anon_sym_COLON] = ACTIONS(3123),
    [anon_sym_return] = ACTIONS(3123),
    [anon_sym_do] = ACTIONS(3123),
    [anon_sym_let] = ACTIONS(3123),
    [anon_sym_let_BANG] = ACTIONS(3125),
    [anon_sym_LPAREN] = ACTIONS(3123),
    [anon_sym_COMMA] = ACTIONS(3125),
    [anon_sym_null] = ACTIONS(3123),
    [anon_sym_QMARK] = ACTIONS(3123),
    [anon_sym_COLON_QMARK] = ACTIONS(3123),
    [anon_sym_COLON_COLON] = ACTIONS(3125),
    [anon_sym_AMP] = ACTIONS(3123),
    [anon_sym_LBRACK] = ACTIONS(3123),
    [anon_sym_RBRACK] = ACTIONS(3125),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3125),
    [anon_sym_LBRACE] = ACTIONS(3123),
    [anon_sym_RBRACE] = ACTIONS(3125),
    [anon_sym_LT_AT] = ACTIONS(3123),
    [anon_sym_LT_AT_AT] = ACTIONS(3123),
    [anon_sym_DOT] = ACTIONS(3123),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3125),
    [anon_sym_new] = ACTIONS(3123),
    [anon_sym_with] = ACTIONS(3123),
    [anon_sym_return_BANG] = ACTIONS(3125),
    [anon_sym_yield] = ACTIONS(3123),
    [anon_sym_yield_BANG] = ACTIONS(3125),
    [anon_sym_lazy] = ACTIONS(3123),
    [anon_sym_assert] = ACTIONS(3123),
    [anon_sym_upcast] = ACTIONS(3123),
    [anon_sym_downcast] = ACTIONS(3123),
    [anon_sym_COLON_GT] = ACTIONS(3125),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3125),
    [anon_sym_for] = ACTIONS(3123),
    [anon_sym_to] = ACTIONS(3123),
    [anon_sym_downto] = ACTIONS(3123),
    [anon_sym_while] = ACTIONS(3123),
    [anon_sym_if] = ACTIONS(3123),
    [anon_sym_fun] = ACTIONS(3123),
    [anon_sym_try] = ACTIONS(3123),
    [anon_sym_match] = ACTIONS(3123),
    [anon_sym_match_BANG] = ACTIONS(3125),
    [anon_sym_function] = ACTIONS(3123),
    [anon_sym_LT_DASH] = ACTIONS(3123),
    [anon_sym_DOT_LBRACK] = ACTIONS(3125),
    [anon_sym_LT] = ACTIONS(3125),
    [anon_sym_use] = ACTIONS(3123),
    [anon_sym_use_BANG] = ACTIONS(3125),
    [anon_sym_do_BANG] = ACTIONS(3125),
    [anon_sym_begin] = ACTIONS(3123),
    [anon_sym_LPAREN2] = ACTIONS(3123),
    [anon_sym_DOT_DOT2] = ACTIONS(3125),
    [anon_sym_or] = ACTIONS(3123),
    [aux_sym_char_token1] = ACTIONS(3125),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3123),
    [anon_sym_DQUOTE] = ACTIONS(3123),
    [anon_sym_AT_DQUOTE] = ACTIONS(3125),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3125),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3125),
    [sym_bool] = ACTIONS(3123),
    [sym_unit] = ACTIONS(3125),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3123),
    [sym_op_identifier] = ACTIONS(3123),
    [anon_sym_PLUS] = ACTIONS(3123),
    [anon_sym_DASH] = ACTIONS(3123),
    [anon_sym_PLUS_DOT] = ACTIONS(3123),
    [anon_sym_DASH_DOT] = ACTIONS(3123),
    [anon_sym_PERCENT] = ACTIONS(3123),
    [anon_sym_AMP_AMP] = ACTIONS(3123),
    [anon_sym_TILDE] = ACTIONS(3125),
    [aux_sym_prefix_op_token1] = ACTIONS(3123),
    [aux_sym_infix_op_token1] = ACTIONS(3125),
    [aux_sym_infix_op_token2] = ACTIONS(3123),
    [anon_sym_PIPE_PIPE] = ACTIONS(3123),
    [anon_sym_BANG_EQ] = ACTIONS(3123),
    [anon_sym_COLON_EQ] = ACTIONS(3125),
    [anon_sym_DOLLAR] = ACTIONS(3123),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3123),
    [sym_int] = ACTIONS(3123),
    [sym_xint] = ACTIONS(3125),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3125),
    [sym__newline] = ACTIONS(3125),
  },
  [1143] = {
    [sym_block_comment] = STATE(1143),
    [sym_compiler_directive_decl] = STATE(1143),
    [sym_fsi_directive_decl] = STATE(1143),
    [sym_preproc_line] = STATE(1143),
    [sym_identifier] = ACTIONS(2946),
    [anon_sym_EQ] = ACTIONS(2948),
    [anon_sym_GT_RBRACK] = ACTIONS(2948),
    [anon_sym_COLON] = ACTIONS(2946),
    [anon_sym_return] = ACTIONS(2946),
    [anon_sym_do] = ACTIONS(2946),
    [anon_sym_let] = ACTIONS(2946),
    [anon_sym_let_BANG] = ACTIONS(2948),
    [anon_sym_LPAREN] = ACTIONS(2946),
    [anon_sym_COMMA] = ACTIONS(2948),
    [anon_sym_null] = ACTIONS(2946),
    [anon_sym_QMARK] = ACTIONS(2946),
    [anon_sym_COLON_QMARK] = ACTIONS(2946),
    [anon_sym_COLON_COLON] = ACTIONS(2948),
    [anon_sym_AMP] = ACTIONS(2946),
    [anon_sym_LBRACK] = ACTIONS(2946),
    [anon_sym_RBRACK] = ACTIONS(2948),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2948),
    [anon_sym_LBRACE] = ACTIONS(2946),
    [anon_sym_RBRACE] = ACTIONS(2948),
    [anon_sym_LT_AT] = ACTIONS(2946),
    [anon_sym_LT_AT_AT] = ACTIONS(2946),
    [anon_sym_DOT] = ACTIONS(2946),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2948),
    [anon_sym_new] = ACTIONS(2946),
    [anon_sym_with] = ACTIONS(2946),
    [anon_sym_return_BANG] = ACTIONS(2948),
    [anon_sym_yield] = ACTIONS(2946),
    [anon_sym_yield_BANG] = ACTIONS(2948),
    [anon_sym_lazy] = ACTIONS(2946),
    [anon_sym_assert] = ACTIONS(2946),
    [anon_sym_upcast] = ACTIONS(2946),
    [anon_sym_downcast] = ACTIONS(2946),
    [anon_sym_COLON_GT] = ACTIONS(2948),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2948),
    [anon_sym_for] = ACTIONS(2946),
    [anon_sym_to] = ACTIONS(2946),
    [anon_sym_downto] = ACTIONS(2946),
    [anon_sym_while] = ACTIONS(2946),
    [anon_sym_if] = ACTIONS(2946),
    [anon_sym_fun] = ACTIONS(2946),
    [anon_sym_try] = ACTIONS(2946),
    [anon_sym_match] = ACTIONS(2946),
    [anon_sym_match_BANG] = ACTIONS(2948),
    [anon_sym_function] = ACTIONS(2946),
    [anon_sym_LT_DASH] = ACTIONS(2946),
    [anon_sym_DOT_LBRACK] = ACTIONS(2948),
    [anon_sym_LT] = ACTIONS(2948),
    [anon_sym_use] = ACTIONS(2946),
    [anon_sym_use_BANG] = ACTIONS(2948),
    [anon_sym_do_BANG] = ACTIONS(2948),
    [anon_sym_begin] = ACTIONS(2946),
    [anon_sym_LPAREN2] = ACTIONS(2946),
    [anon_sym_DOT_DOT2] = ACTIONS(2948),
    [anon_sym_or] = ACTIONS(2946),
    [aux_sym_char_token1] = ACTIONS(2948),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2946),
    [anon_sym_DQUOTE] = ACTIONS(2946),
    [anon_sym_AT_DQUOTE] = ACTIONS(2948),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2948),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2948),
    [sym_bool] = ACTIONS(2946),
    [sym_unit] = ACTIONS(2948),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2946),
    [sym_op_identifier] = ACTIONS(2946),
    [anon_sym_PLUS] = ACTIONS(2946),
    [anon_sym_DASH] = ACTIONS(2946),
    [anon_sym_PLUS_DOT] = ACTIONS(2946),
    [anon_sym_DASH_DOT] = ACTIONS(2946),
    [anon_sym_PERCENT] = ACTIONS(2946),
    [anon_sym_AMP_AMP] = ACTIONS(2946),
    [anon_sym_TILDE] = ACTIONS(2948),
    [aux_sym_prefix_op_token1] = ACTIONS(2946),
    [aux_sym_infix_op_token1] = ACTIONS(2948),
    [aux_sym_infix_op_token2] = ACTIONS(2946),
    [anon_sym_PIPE_PIPE] = ACTIONS(2946),
    [anon_sym_BANG_EQ] = ACTIONS(2946),
    [anon_sym_COLON_EQ] = ACTIONS(2948),
    [anon_sym_DOLLAR] = ACTIONS(2946),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2946),
    [sym_int] = ACTIONS(2946),
    [sym_xint] = ACTIONS(2948),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2948),
    [sym__newline] = ACTIONS(2948),
  },
  [1144] = {
    [sym_block_comment] = STATE(1144),
    [sym_compiler_directive_decl] = STATE(1144),
    [sym_fsi_directive_decl] = STATE(1144),
    [sym_preproc_line] = STATE(1144),
    [sym_identifier] = ACTIONS(2950),
    [anon_sym_EQ] = ACTIONS(2952),
    [anon_sym_GT_RBRACK] = ACTIONS(2952),
    [anon_sym_COLON] = ACTIONS(2950),
    [anon_sym_return] = ACTIONS(2950),
    [anon_sym_do] = ACTIONS(2950),
    [anon_sym_let] = ACTIONS(2950),
    [anon_sym_let_BANG] = ACTIONS(2952),
    [anon_sym_LPAREN] = ACTIONS(2950),
    [anon_sym_COMMA] = ACTIONS(2952),
    [anon_sym_null] = ACTIONS(2950),
    [anon_sym_QMARK] = ACTIONS(2950),
    [anon_sym_COLON_QMARK] = ACTIONS(2950),
    [anon_sym_COLON_COLON] = ACTIONS(2952),
    [anon_sym_AMP] = ACTIONS(2950),
    [anon_sym_LBRACK] = ACTIONS(2950),
    [anon_sym_RBRACK] = ACTIONS(2952),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2952),
    [anon_sym_LBRACE] = ACTIONS(2950),
    [anon_sym_RBRACE] = ACTIONS(2952),
    [anon_sym_LT_AT] = ACTIONS(2950),
    [anon_sym_LT_AT_AT] = ACTIONS(2950),
    [anon_sym_DOT] = ACTIONS(2950),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2952),
    [anon_sym_new] = ACTIONS(2950),
    [anon_sym_with] = ACTIONS(2950),
    [anon_sym_return_BANG] = ACTIONS(2952),
    [anon_sym_yield] = ACTIONS(2950),
    [anon_sym_yield_BANG] = ACTIONS(2952),
    [anon_sym_lazy] = ACTIONS(2950),
    [anon_sym_assert] = ACTIONS(2950),
    [anon_sym_upcast] = ACTIONS(2950),
    [anon_sym_downcast] = ACTIONS(2950),
    [anon_sym_COLON_GT] = ACTIONS(2952),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2952),
    [anon_sym_for] = ACTIONS(2950),
    [anon_sym_to] = ACTIONS(2950),
    [anon_sym_downto] = ACTIONS(2950),
    [anon_sym_while] = ACTIONS(2950),
    [anon_sym_if] = ACTIONS(2950),
    [anon_sym_fun] = ACTIONS(2950),
    [anon_sym_try] = ACTIONS(2950),
    [anon_sym_match] = ACTIONS(2950),
    [anon_sym_match_BANG] = ACTIONS(2952),
    [anon_sym_function] = ACTIONS(2950),
    [anon_sym_LT_DASH] = ACTIONS(2950),
    [anon_sym_DOT_LBRACK] = ACTIONS(2952),
    [anon_sym_LT] = ACTIONS(2952),
    [anon_sym_use] = ACTIONS(2950),
    [anon_sym_use_BANG] = ACTIONS(2952),
    [anon_sym_do_BANG] = ACTIONS(2952),
    [anon_sym_begin] = ACTIONS(2950),
    [anon_sym_LPAREN2] = ACTIONS(2950),
    [anon_sym_DOT_DOT2] = ACTIONS(2952),
    [anon_sym_or] = ACTIONS(2950),
    [aux_sym_char_token1] = ACTIONS(2952),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2950),
    [anon_sym_DQUOTE] = ACTIONS(2950),
    [anon_sym_AT_DQUOTE] = ACTIONS(2952),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2952),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2952),
    [sym_bool] = ACTIONS(2950),
    [sym_unit] = ACTIONS(2952),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2950),
    [sym_op_identifier] = ACTIONS(2950),
    [anon_sym_PLUS] = ACTIONS(2950),
    [anon_sym_DASH] = ACTIONS(2950),
    [anon_sym_PLUS_DOT] = ACTIONS(2950),
    [anon_sym_DASH_DOT] = ACTIONS(2950),
    [anon_sym_PERCENT] = ACTIONS(2950),
    [anon_sym_AMP_AMP] = ACTIONS(2950),
    [anon_sym_TILDE] = ACTIONS(2952),
    [aux_sym_prefix_op_token1] = ACTIONS(2950),
    [aux_sym_infix_op_token1] = ACTIONS(2952),
    [aux_sym_infix_op_token2] = ACTIONS(2950),
    [anon_sym_PIPE_PIPE] = ACTIONS(2950),
    [anon_sym_BANG_EQ] = ACTIONS(2950),
    [anon_sym_COLON_EQ] = ACTIONS(2952),
    [anon_sym_DOLLAR] = ACTIONS(2950),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2950),
    [sym_int] = ACTIONS(2950),
    [sym_xint] = ACTIONS(2952),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2952),
    [sym__newline] = ACTIONS(2952),
  },
  [1145] = {
    [sym_block_comment] = STATE(1145),
    [sym_compiler_directive_decl] = STATE(1145),
    [sym_fsi_directive_decl] = STATE(1145),
    [sym_preproc_line] = STATE(1145),
    [sym_identifier] = ACTIONS(2567),
    [anon_sym_EQ] = ACTIONS(2569),
    [anon_sym_COLON] = ACTIONS(2567),
    [anon_sym_return] = ACTIONS(2567),
    [anon_sym_do] = ACTIONS(2567),
    [anon_sym_let] = ACTIONS(2567),
    [anon_sym_let_BANG] = ACTIONS(2569),
    [anon_sym_as] = ACTIONS(2567),
    [anon_sym_LPAREN] = ACTIONS(2567),
    [anon_sym_COMMA] = ACTIONS(2569),
    [anon_sym_null] = ACTIONS(2567),
    [anon_sym_QMARK] = ACTIONS(2567),
    [anon_sym_COLON_QMARK] = ACTIONS(2567),
    [anon_sym_COLON_COLON] = ACTIONS(2569),
    [anon_sym_AMP] = ACTIONS(2567),
    [anon_sym_LBRACK] = ACTIONS(2567),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2569),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_LT_AT] = ACTIONS(2567),
    [anon_sym_LT_AT_AT] = ACTIONS(2567),
    [anon_sym_DOT] = ACTIONS(2567),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2569),
    [anon_sym_new] = ACTIONS(2567),
    [anon_sym_with] = ACTIONS(2567),
    [anon_sym_return_BANG] = ACTIONS(2569),
    [anon_sym_yield] = ACTIONS(2567),
    [anon_sym_yield_BANG] = ACTIONS(2569),
    [anon_sym_lazy] = ACTIONS(2567),
    [anon_sym_assert] = ACTIONS(2567),
    [anon_sym_upcast] = ACTIONS(2567),
    [anon_sym_downcast] = ACTIONS(2567),
    [anon_sym_COLON_GT] = ACTIONS(2569),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2569),
    [anon_sym_for] = ACTIONS(2567),
    [anon_sym_while] = ACTIONS(2567),
    [anon_sym_if] = ACTIONS(2567),
    [anon_sym_fun] = ACTIONS(2567),
    [anon_sym_DASH_GT] = ACTIONS(2567),
    [anon_sym_try] = ACTIONS(2567),
    [anon_sym_match] = ACTIONS(2567),
    [anon_sym_match_BANG] = ACTIONS(2569),
    [anon_sym_function] = ACTIONS(2567),
    [anon_sym_LT_DASH] = ACTIONS(2567),
    [anon_sym_DOT_LBRACK] = ACTIONS(2569),
    [anon_sym_LT] = ACTIONS(2569),
    [anon_sym_use] = ACTIONS(2567),
    [anon_sym_use_BANG] = ACTIONS(2569),
    [anon_sym_do_BANG] = ACTIONS(2569),
    [anon_sym_begin] = ACTIONS(2567),
    [anon_sym_LPAREN2] = ACTIONS(2567),
    [anon_sym_STAR] = ACTIONS(2567),
    [anon_sym_LT2] = ACTIONS(2567),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2569),
    [anon_sym_or] = ACTIONS(2567),
    [aux_sym_char_token1] = ACTIONS(2569),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2567),
    [anon_sym_DQUOTE] = ACTIONS(2567),
    [anon_sym_AT_DQUOTE] = ACTIONS(2569),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2569),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2569),
    [sym_bool] = ACTIONS(2567),
    [sym_unit] = ACTIONS(2569),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2567),
    [sym_op_identifier] = ACTIONS(2567),
    [anon_sym_PLUS] = ACTIONS(2567),
    [anon_sym_DASH] = ACTIONS(2567),
    [anon_sym_PLUS_DOT] = ACTIONS(2567),
    [anon_sym_DASH_DOT] = ACTIONS(2567),
    [anon_sym_PERCENT] = ACTIONS(2567),
    [anon_sym_AMP_AMP] = ACTIONS(2567),
    [anon_sym_TILDE] = ACTIONS(2569),
    [aux_sym_prefix_op_token1] = ACTIONS(2567),
    [aux_sym_infix_op_token1] = ACTIONS(2569),
    [aux_sym_infix_op_token2] = ACTIONS(2567),
    [anon_sym_PIPE_PIPE] = ACTIONS(2567),
    [anon_sym_BANG_EQ] = ACTIONS(2567),
    [anon_sym_COLON_EQ] = ACTIONS(2569),
    [anon_sym_DOLLAR] = ACTIONS(2567),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2567),
    [sym_int] = ACTIONS(2567),
    [sym_xint] = ACTIONS(2569),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2569),
    [sym__newline] = ACTIONS(2569),
    [sym__dedent] = ACTIONS(2569),
  },
  [1146] = {
    [sym_block_comment] = STATE(1146),
    [sym_compiler_directive_decl] = STATE(1146),
    [sym_fsi_directive_decl] = STATE(1146),
    [sym_preproc_line] = STATE(1146),
    [sym_identifier] = ACTIONS(2958),
    [anon_sym_EQ] = ACTIONS(2960),
    [anon_sym_GT_RBRACK] = ACTIONS(2960),
    [anon_sym_COLON] = ACTIONS(2958),
    [anon_sym_return] = ACTIONS(2958),
    [anon_sym_do] = ACTIONS(2958),
    [anon_sym_let] = ACTIONS(2958),
    [anon_sym_let_BANG] = ACTIONS(2960),
    [anon_sym_LPAREN] = ACTIONS(2958),
    [anon_sym_COMMA] = ACTIONS(2960),
    [anon_sym_null] = ACTIONS(2958),
    [anon_sym_QMARK] = ACTIONS(2958),
    [anon_sym_COLON_QMARK] = ACTIONS(2958),
    [anon_sym_COLON_COLON] = ACTIONS(2960),
    [anon_sym_AMP] = ACTIONS(2958),
    [anon_sym_LBRACK] = ACTIONS(2958),
    [anon_sym_RBRACK] = ACTIONS(2960),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2960),
    [anon_sym_LBRACE] = ACTIONS(2958),
    [anon_sym_RBRACE] = ACTIONS(2960),
    [anon_sym_LT_AT] = ACTIONS(2958),
    [anon_sym_LT_AT_AT] = ACTIONS(2958),
    [anon_sym_DOT] = ACTIONS(2958),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2960),
    [anon_sym_new] = ACTIONS(2958),
    [anon_sym_with] = ACTIONS(2958),
    [anon_sym_return_BANG] = ACTIONS(2960),
    [anon_sym_yield] = ACTIONS(2958),
    [anon_sym_yield_BANG] = ACTIONS(2960),
    [anon_sym_lazy] = ACTIONS(2958),
    [anon_sym_assert] = ACTIONS(2958),
    [anon_sym_upcast] = ACTIONS(2958),
    [anon_sym_downcast] = ACTIONS(2958),
    [anon_sym_COLON_GT] = ACTIONS(2960),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2960),
    [anon_sym_for] = ACTIONS(2958),
    [anon_sym_to] = ACTIONS(2958),
    [anon_sym_downto] = ACTIONS(2958),
    [anon_sym_while] = ACTIONS(2958),
    [anon_sym_if] = ACTIONS(2958),
    [anon_sym_fun] = ACTIONS(2958),
    [anon_sym_try] = ACTIONS(2958),
    [anon_sym_match] = ACTIONS(2958),
    [anon_sym_match_BANG] = ACTIONS(2960),
    [anon_sym_function] = ACTIONS(2958),
    [anon_sym_LT_DASH] = ACTIONS(2958),
    [anon_sym_DOT_LBRACK] = ACTIONS(2960),
    [anon_sym_LT] = ACTIONS(2960),
    [anon_sym_use] = ACTIONS(2958),
    [anon_sym_use_BANG] = ACTIONS(2960),
    [anon_sym_do_BANG] = ACTIONS(2960),
    [anon_sym_begin] = ACTIONS(2958),
    [anon_sym_LPAREN2] = ACTIONS(2958),
    [anon_sym_DOT_DOT2] = ACTIONS(2960),
    [anon_sym_or] = ACTIONS(2958),
    [aux_sym_char_token1] = ACTIONS(2960),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2958),
    [anon_sym_DQUOTE] = ACTIONS(2958),
    [anon_sym_AT_DQUOTE] = ACTIONS(2960),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2960),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2960),
    [sym_bool] = ACTIONS(2958),
    [sym_unit] = ACTIONS(2960),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2958),
    [sym_op_identifier] = ACTIONS(2958),
    [anon_sym_PLUS] = ACTIONS(2958),
    [anon_sym_DASH] = ACTIONS(2958),
    [anon_sym_PLUS_DOT] = ACTIONS(2958),
    [anon_sym_DASH_DOT] = ACTIONS(2958),
    [anon_sym_PERCENT] = ACTIONS(2958),
    [anon_sym_AMP_AMP] = ACTIONS(2958),
    [anon_sym_TILDE] = ACTIONS(2960),
    [aux_sym_prefix_op_token1] = ACTIONS(2958),
    [aux_sym_infix_op_token1] = ACTIONS(2960),
    [aux_sym_infix_op_token2] = ACTIONS(2958),
    [anon_sym_PIPE_PIPE] = ACTIONS(2958),
    [anon_sym_BANG_EQ] = ACTIONS(2958),
    [anon_sym_COLON_EQ] = ACTIONS(2960),
    [anon_sym_DOLLAR] = ACTIONS(2958),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2958),
    [sym_int] = ACTIONS(2958),
    [sym_xint] = ACTIONS(2960),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2960),
    [sym__newline] = ACTIONS(2960),
  },
  [1147] = {
    [sym_block_comment] = STATE(1147),
    [sym_compiler_directive_decl] = STATE(1147),
    [sym_fsi_directive_decl] = STATE(1147),
    [sym_preproc_line] = STATE(1147),
    [sym_identifier] = ACTIONS(2962),
    [anon_sym_EQ] = ACTIONS(2964),
    [anon_sym_GT_RBRACK] = ACTIONS(2964),
    [anon_sym_COLON] = ACTIONS(2962),
    [anon_sym_return] = ACTIONS(2962),
    [anon_sym_do] = ACTIONS(2962),
    [anon_sym_let] = ACTIONS(2962),
    [anon_sym_let_BANG] = ACTIONS(2964),
    [anon_sym_LPAREN] = ACTIONS(2962),
    [anon_sym_COMMA] = ACTIONS(2964),
    [anon_sym_null] = ACTIONS(2962),
    [anon_sym_QMARK] = ACTIONS(2962),
    [anon_sym_COLON_QMARK] = ACTIONS(2962),
    [anon_sym_COLON_COLON] = ACTIONS(2964),
    [anon_sym_AMP] = ACTIONS(2962),
    [anon_sym_LBRACK] = ACTIONS(2962),
    [anon_sym_RBRACK] = ACTIONS(2964),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2964),
    [anon_sym_LBRACE] = ACTIONS(2962),
    [anon_sym_RBRACE] = ACTIONS(2964),
    [anon_sym_LT_AT] = ACTIONS(2962),
    [anon_sym_LT_AT_AT] = ACTIONS(2962),
    [anon_sym_DOT] = ACTIONS(2962),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2964),
    [anon_sym_new] = ACTIONS(2962),
    [anon_sym_with] = ACTIONS(2962),
    [anon_sym_return_BANG] = ACTIONS(2964),
    [anon_sym_yield] = ACTIONS(2962),
    [anon_sym_yield_BANG] = ACTIONS(2964),
    [anon_sym_lazy] = ACTIONS(2962),
    [anon_sym_assert] = ACTIONS(2962),
    [anon_sym_upcast] = ACTIONS(2962),
    [anon_sym_downcast] = ACTIONS(2962),
    [anon_sym_COLON_GT] = ACTIONS(2964),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2964),
    [anon_sym_for] = ACTIONS(2962),
    [anon_sym_to] = ACTIONS(2962),
    [anon_sym_downto] = ACTIONS(2962),
    [anon_sym_while] = ACTIONS(2962),
    [anon_sym_if] = ACTIONS(2962),
    [anon_sym_fun] = ACTIONS(2962),
    [anon_sym_try] = ACTIONS(2962),
    [anon_sym_match] = ACTIONS(2962),
    [anon_sym_match_BANG] = ACTIONS(2964),
    [anon_sym_function] = ACTIONS(2962),
    [anon_sym_LT_DASH] = ACTIONS(2962),
    [anon_sym_DOT_LBRACK] = ACTIONS(2964),
    [anon_sym_LT] = ACTIONS(2964),
    [anon_sym_use] = ACTIONS(2962),
    [anon_sym_use_BANG] = ACTIONS(2964),
    [anon_sym_do_BANG] = ACTIONS(2964),
    [anon_sym_begin] = ACTIONS(2962),
    [anon_sym_LPAREN2] = ACTIONS(2962),
    [anon_sym_DOT_DOT2] = ACTIONS(2964),
    [anon_sym_or] = ACTIONS(2962),
    [aux_sym_char_token1] = ACTIONS(2964),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2962),
    [anon_sym_DQUOTE] = ACTIONS(2962),
    [anon_sym_AT_DQUOTE] = ACTIONS(2964),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2964),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2964),
    [sym_bool] = ACTIONS(2962),
    [sym_unit] = ACTIONS(2964),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2962),
    [sym_op_identifier] = ACTIONS(2962),
    [anon_sym_PLUS] = ACTIONS(2962),
    [anon_sym_DASH] = ACTIONS(2962),
    [anon_sym_PLUS_DOT] = ACTIONS(2962),
    [anon_sym_DASH_DOT] = ACTIONS(2962),
    [anon_sym_PERCENT] = ACTIONS(2962),
    [anon_sym_AMP_AMP] = ACTIONS(2962),
    [anon_sym_TILDE] = ACTIONS(2964),
    [aux_sym_prefix_op_token1] = ACTIONS(2962),
    [aux_sym_infix_op_token1] = ACTIONS(2964),
    [aux_sym_infix_op_token2] = ACTIONS(2962),
    [anon_sym_PIPE_PIPE] = ACTIONS(2962),
    [anon_sym_BANG_EQ] = ACTIONS(2962),
    [anon_sym_COLON_EQ] = ACTIONS(2964),
    [anon_sym_DOLLAR] = ACTIONS(2962),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2962),
    [sym_int] = ACTIONS(2962),
    [sym_xint] = ACTIONS(2964),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2964),
    [sym__newline] = ACTIONS(2964),
  },
  [1148] = {
    [sym_block_comment] = STATE(1148),
    [sym_compiler_directive_decl] = STATE(1148),
    [sym_fsi_directive_decl] = STATE(1148),
    [sym_preproc_line] = STATE(1148),
    [sym_identifier] = ACTIONS(3103),
    [anon_sym_EQ] = ACTIONS(3105),
    [anon_sym_GT_RBRACK] = ACTIONS(3105),
    [anon_sym_COLON] = ACTIONS(3103),
    [anon_sym_return] = ACTIONS(3103),
    [anon_sym_do] = ACTIONS(3103),
    [anon_sym_let] = ACTIONS(3103),
    [anon_sym_let_BANG] = ACTIONS(3105),
    [anon_sym_LPAREN] = ACTIONS(3103),
    [anon_sym_COMMA] = ACTIONS(3105),
    [anon_sym_null] = ACTIONS(3103),
    [anon_sym_QMARK] = ACTIONS(3103),
    [anon_sym_COLON_QMARK] = ACTIONS(3103),
    [anon_sym_COLON_COLON] = ACTIONS(3105),
    [anon_sym_AMP] = ACTIONS(3103),
    [anon_sym_LBRACK] = ACTIONS(3103),
    [anon_sym_RBRACK] = ACTIONS(3105),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3105),
    [anon_sym_LBRACE] = ACTIONS(3103),
    [anon_sym_RBRACE] = ACTIONS(3105),
    [anon_sym_LT_AT] = ACTIONS(3103),
    [anon_sym_LT_AT_AT] = ACTIONS(3103),
    [anon_sym_DOT] = ACTIONS(3103),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3105),
    [anon_sym_new] = ACTIONS(3103),
    [anon_sym_with] = ACTIONS(3103),
    [anon_sym_return_BANG] = ACTIONS(3105),
    [anon_sym_yield] = ACTIONS(3103),
    [anon_sym_yield_BANG] = ACTIONS(3105),
    [anon_sym_lazy] = ACTIONS(3103),
    [anon_sym_assert] = ACTIONS(3103),
    [anon_sym_upcast] = ACTIONS(3103),
    [anon_sym_downcast] = ACTIONS(3103),
    [anon_sym_COLON_GT] = ACTIONS(3105),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3105),
    [anon_sym_for] = ACTIONS(3103),
    [anon_sym_to] = ACTIONS(3103),
    [anon_sym_downto] = ACTIONS(3103),
    [anon_sym_while] = ACTIONS(3103),
    [anon_sym_if] = ACTIONS(3103),
    [anon_sym_fun] = ACTIONS(3103),
    [anon_sym_try] = ACTIONS(3103),
    [anon_sym_match] = ACTIONS(3103),
    [anon_sym_match_BANG] = ACTIONS(3105),
    [anon_sym_function] = ACTIONS(3103),
    [anon_sym_LT_DASH] = ACTIONS(3103),
    [anon_sym_DOT_LBRACK] = ACTIONS(3105),
    [anon_sym_LT] = ACTIONS(3105),
    [anon_sym_use] = ACTIONS(3103),
    [anon_sym_use_BANG] = ACTIONS(3105),
    [anon_sym_do_BANG] = ACTIONS(3105),
    [anon_sym_begin] = ACTIONS(3103),
    [anon_sym_LPAREN2] = ACTIONS(3103),
    [anon_sym_DOT_DOT2] = ACTIONS(3105),
    [anon_sym_or] = ACTIONS(3103),
    [aux_sym_char_token1] = ACTIONS(3105),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3103),
    [anon_sym_DQUOTE] = ACTIONS(3103),
    [anon_sym_AT_DQUOTE] = ACTIONS(3105),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3105),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3105),
    [sym_bool] = ACTIONS(3103),
    [sym_unit] = ACTIONS(3105),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3103),
    [sym_op_identifier] = ACTIONS(3103),
    [anon_sym_PLUS] = ACTIONS(3103),
    [anon_sym_DASH] = ACTIONS(3103),
    [anon_sym_PLUS_DOT] = ACTIONS(3103),
    [anon_sym_DASH_DOT] = ACTIONS(3103),
    [anon_sym_PERCENT] = ACTIONS(3103),
    [anon_sym_AMP_AMP] = ACTIONS(3103),
    [anon_sym_TILDE] = ACTIONS(3105),
    [aux_sym_prefix_op_token1] = ACTIONS(3103),
    [aux_sym_infix_op_token1] = ACTIONS(3105),
    [aux_sym_infix_op_token2] = ACTIONS(3103),
    [anon_sym_PIPE_PIPE] = ACTIONS(3103),
    [anon_sym_BANG_EQ] = ACTIONS(3103),
    [anon_sym_COLON_EQ] = ACTIONS(3105),
    [anon_sym_DOLLAR] = ACTIONS(3103),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3103),
    [sym_int] = ACTIONS(3103),
    [sym_xint] = ACTIONS(3105),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3105),
    [sym__newline] = ACTIONS(3105),
  },
  [1149] = {
    [sym_block_comment] = STATE(1149),
    [sym_compiler_directive_decl] = STATE(1149),
    [sym_fsi_directive_decl] = STATE(1149),
    [sym_preproc_line] = STATE(1149),
    [aux_sym_type_argument_repeat1] = STATE(1149),
    [sym_identifier] = ACTIONS(2340),
    [anon_sym_EQ] = ACTIONS(2342),
    [anon_sym_COLON] = ACTIONS(2340),
    [anon_sym_return] = ACTIONS(2340),
    [anon_sym_do] = ACTIONS(2340),
    [anon_sym_and] = ACTIONS(2340),
    [anon_sym_let] = ACTIONS(2340),
    [anon_sym_let_BANG] = ACTIONS(2342),
    [anon_sym_LPAREN] = ACTIONS(2340),
    [anon_sym_COMMA] = ACTIONS(2342),
    [anon_sym_null] = ACTIONS(2340),
    [anon_sym_QMARK] = ACTIONS(2340),
    [anon_sym_COLON_QMARK] = ACTIONS(2340),
    [anon_sym_COLON_COLON] = ACTIONS(2342),
    [anon_sym_AMP] = ACTIONS(2340),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2342),
    [anon_sym_LBRACE] = ACTIONS(2340),
    [anon_sym_LT_AT] = ACTIONS(2340),
    [anon_sym_LT_AT_AT] = ACTIONS(2340),
    [anon_sym_DOT] = ACTIONS(2340),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2342),
    [anon_sym_new] = ACTIONS(2340),
    [anon_sym_return_BANG] = ACTIONS(2342),
    [anon_sym_yield] = ACTIONS(2340),
    [anon_sym_yield_BANG] = ACTIONS(2342),
    [anon_sym_lazy] = ACTIONS(2340),
    [anon_sym_assert] = ACTIONS(2340),
    [anon_sym_upcast] = ACTIONS(2340),
    [anon_sym_downcast] = ACTIONS(2340),
    [anon_sym_COLON_GT] = ACTIONS(2342),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2342),
    [anon_sym_for] = ACTIONS(2340),
    [anon_sym_while] = ACTIONS(2340),
    [anon_sym_if] = ACTIONS(2340),
    [anon_sym_fun] = ACTIONS(2340),
    [anon_sym_DASH_GT] = ACTIONS(2340),
    [anon_sym_try] = ACTIONS(2340),
    [anon_sym_match] = ACTIONS(2340),
    [anon_sym_match_BANG] = ACTIONS(2342),
    [anon_sym_function] = ACTIONS(2340),
    [anon_sym_LT_DASH] = ACTIONS(2340),
    [anon_sym_DOT_LBRACK] = ACTIONS(2342),
    [anon_sym_LT] = ACTIONS(2342),
    [anon_sym_use] = ACTIONS(2340),
    [anon_sym_use_BANG] = ACTIONS(2342),
    [anon_sym_do_BANG] = ACTIONS(2342),
    [anon_sym_begin] = ACTIONS(2340),
    [anon_sym_LPAREN2] = ACTIONS(2340),
    [anon_sym_STAR] = ACTIONS(2340),
    [anon_sym_LT2] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2342),
    [anon_sym_or] = ACTIONS(3335),
    [aux_sym_char_token1] = ACTIONS(2342),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2340),
    [anon_sym_DQUOTE] = ACTIONS(2340),
    [anon_sym_AT_DQUOTE] = ACTIONS(2342),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2342),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2342),
    [sym_bool] = ACTIONS(2340),
    [sym_unit] = ACTIONS(2342),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2340),
    [sym_op_identifier] = ACTIONS(2340),
    [anon_sym_PLUS] = ACTIONS(2340),
    [anon_sym_DASH] = ACTIONS(2340),
    [anon_sym_PLUS_DOT] = ACTIONS(2340),
    [anon_sym_DASH_DOT] = ACTIONS(2340),
    [anon_sym_PERCENT] = ACTIONS(2340),
    [anon_sym_AMP_AMP] = ACTIONS(2340),
    [anon_sym_TILDE] = ACTIONS(2342),
    [aux_sym_prefix_op_token1] = ACTIONS(2340),
    [aux_sym_infix_op_token1] = ACTIONS(2342),
    [aux_sym_infix_op_token2] = ACTIONS(2340),
    [anon_sym_PIPE_PIPE] = ACTIONS(2340),
    [anon_sym_BANG_EQ] = ACTIONS(2340),
    [anon_sym_COLON_EQ] = ACTIONS(2342),
    [anon_sym_DOLLAR] = ACTIONS(2340),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2340),
    [sym_int] = ACTIONS(2340),
    [sym_xint] = ACTIONS(2342),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2342),
    [sym__newline] = ACTIONS(2342),
    [sym__dedent] = ACTIONS(2342),
  },
  [1150] = {
    [sym__else_expression] = STATE(1948),
    [sym_elif_expression] = STATE(1451),
    [sym_block_comment] = STATE(1150),
    [sym_compiler_directive_decl] = STATE(1150),
    [sym_fsi_directive_decl] = STATE(1150),
    [sym_preproc_line] = STATE(1150),
    [aux_sym_if_expression_repeat1] = STATE(1264),
    [sym_identifier] = ACTIONS(2332),
    [anon_sym_EQ] = ACTIONS(2334),
    [anon_sym_COLON] = ACTIONS(2332),
    [anon_sym_return] = ACTIONS(2332),
    [anon_sym_do] = ACTIONS(2332),
    [anon_sym_let] = ACTIONS(2332),
    [anon_sym_let_BANG] = ACTIONS(2334),
    [anon_sym_as] = ACTIONS(2332),
    [anon_sym_LPAREN] = ACTIONS(2332),
    [anon_sym_COMMA] = ACTIONS(2334),
    [anon_sym_null] = ACTIONS(2332),
    [anon_sym_QMARK] = ACTIONS(2332),
    [anon_sym_COLON_QMARK] = ACTIONS(2332),
    [anon_sym_COLON_COLON] = ACTIONS(2334),
    [anon_sym_AMP] = ACTIONS(2332),
    [anon_sym_LBRACK] = ACTIONS(2332),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2334),
    [anon_sym_LBRACE] = ACTIONS(2332),
    [anon_sym_LT_AT] = ACTIONS(2332),
    [anon_sym_LT_AT_AT] = ACTIONS(2332),
    [anon_sym_DOT] = ACTIONS(2332),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2334),
    [anon_sym_new] = ACTIONS(2332),
    [anon_sym_with] = ACTIONS(2332),
    [anon_sym_return_BANG] = ACTIONS(2334),
    [anon_sym_yield] = ACTIONS(2332),
    [anon_sym_yield_BANG] = ACTIONS(2334),
    [anon_sym_lazy] = ACTIONS(2332),
    [anon_sym_assert] = ACTIONS(2332),
    [anon_sym_upcast] = ACTIONS(2332),
    [anon_sym_downcast] = ACTIONS(2332),
    [anon_sym_COLON_GT] = ACTIONS(2334),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2334),
    [anon_sym_for] = ACTIONS(2332),
    [anon_sym_while] = ACTIONS(2332),
    [anon_sym_else] = ACTIONS(3338),
    [anon_sym_elif] = ACTIONS(3340),
    [anon_sym_if] = ACTIONS(2332),
    [anon_sym_fun] = ACTIONS(2332),
    [anon_sym_try] = ACTIONS(2332),
    [anon_sym_match] = ACTIONS(2332),
    [anon_sym_match_BANG] = ACTIONS(2334),
    [anon_sym_function] = ACTIONS(2332),
    [anon_sym_LT_DASH] = ACTIONS(2332),
    [anon_sym_DOT_LBRACK] = ACTIONS(2334),
    [anon_sym_LT] = ACTIONS(2334),
    [anon_sym_use] = ACTIONS(2332),
    [anon_sym_use_BANG] = ACTIONS(2334),
    [anon_sym_do_BANG] = ACTIONS(2334),
    [anon_sym_begin] = ACTIONS(2332),
    [anon_sym_LPAREN2] = ACTIONS(2332),
    [anon_sym_or] = ACTIONS(2332),
    [aux_sym_char_token1] = ACTIONS(2334),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2332),
    [anon_sym_DQUOTE] = ACTIONS(2332),
    [anon_sym_AT_DQUOTE] = ACTIONS(2334),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2334),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2334),
    [sym_bool] = ACTIONS(2332),
    [sym_unit] = ACTIONS(2334),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2332),
    [sym_op_identifier] = ACTIONS(2332),
    [anon_sym_PLUS] = ACTIONS(2332),
    [anon_sym_DASH] = ACTIONS(2332),
    [anon_sym_PLUS_DOT] = ACTIONS(2332),
    [anon_sym_DASH_DOT] = ACTIONS(2332),
    [anon_sym_PERCENT] = ACTIONS(2332),
    [anon_sym_AMP_AMP] = ACTIONS(2332),
    [anon_sym_TILDE] = ACTIONS(2334),
    [aux_sym_prefix_op_token1] = ACTIONS(2332),
    [aux_sym_infix_op_token1] = ACTIONS(2334),
    [aux_sym_infix_op_token2] = ACTIONS(2332),
    [anon_sym_PIPE_PIPE] = ACTIONS(2332),
    [anon_sym_BANG_EQ] = ACTIONS(2332),
    [anon_sym_COLON_EQ] = ACTIONS(2334),
    [anon_sym_DOLLAR] = ACTIONS(2332),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2332),
    [sym_int] = ACTIONS(2332),
    [sym_xint] = ACTIONS(2334),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2334),
    [sym__newline] = ACTIONS(2334),
  },
  [1151] = {
    [sym_block_comment] = STATE(1151),
    [sym_compiler_directive_decl] = STATE(1151),
    [sym_fsi_directive_decl] = STATE(1151),
    [sym_preproc_line] = STATE(1151),
    [sym_identifier] = ACTIONS(2474),
    [anon_sym_EQ] = ACTIONS(2476),
    [anon_sym_COLON] = ACTIONS(2474),
    [anon_sym_return] = ACTIONS(2474),
    [anon_sym_do] = ACTIONS(2474),
    [anon_sym_let] = ACTIONS(2474),
    [anon_sym_let_BANG] = ACTIONS(2476),
    [anon_sym_as] = ACTIONS(2474),
    [anon_sym_LPAREN] = ACTIONS(2474),
    [anon_sym_COMMA] = ACTIONS(2476),
    [anon_sym_null] = ACTIONS(2474),
    [anon_sym_QMARK] = ACTIONS(2474),
    [anon_sym_COLON_QMARK] = ACTIONS(2474),
    [anon_sym_COLON_COLON] = ACTIONS(2476),
    [anon_sym_AMP] = ACTIONS(2474),
    [anon_sym_LBRACK] = ACTIONS(2474),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2476),
    [anon_sym_LBRACE] = ACTIONS(2474),
    [anon_sym_LT_AT] = ACTIONS(2474),
    [anon_sym_LT_AT_AT] = ACTIONS(2474),
    [anon_sym_DOT] = ACTIONS(2474),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2476),
    [anon_sym_new] = ACTIONS(2474),
    [anon_sym_with] = ACTIONS(2474),
    [anon_sym_return_BANG] = ACTIONS(2476),
    [anon_sym_yield] = ACTIONS(2474),
    [anon_sym_yield_BANG] = ACTIONS(2476),
    [anon_sym_lazy] = ACTIONS(2474),
    [anon_sym_assert] = ACTIONS(2474),
    [anon_sym_upcast] = ACTIONS(2474),
    [anon_sym_downcast] = ACTIONS(2474),
    [anon_sym_COLON_GT] = ACTIONS(2476),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2476),
    [anon_sym_for] = ACTIONS(2474),
    [anon_sym_while] = ACTIONS(2474),
    [anon_sym_if] = ACTIONS(2474),
    [anon_sym_fun] = ACTIONS(2474),
    [anon_sym_DASH_GT] = ACTIONS(2474),
    [anon_sym_try] = ACTIONS(2474),
    [anon_sym_match] = ACTIONS(2474),
    [anon_sym_match_BANG] = ACTIONS(2476),
    [anon_sym_function] = ACTIONS(2474),
    [anon_sym_LT_DASH] = ACTIONS(2474),
    [anon_sym_DOT_LBRACK] = ACTIONS(2476),
    [anon_sym_LT] = ACTIONS(2476),
    [anon_sym_use] = ACTIONS(2474),
    [anon_sym_use_BANG] = ACTIONS(2476),
    [anon_sym_do_BANG] = ACTIONS(2476),
    [anon_sym_begin] = ACTIONS(2474),
    [anon_sym_LPAREN2] = ACTIONS(2474),
    [anon_sym_STAR] = ACTIONS(2474),
    [anon_sym_LT2] = ACTIONS(2474),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2476),
    [anon_sym_or] = ACTIONS(2474),
    [aux_sym_char_token1] = ACTIONS(2476),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2474),
    [anon_sym_DQUOTE] = ACTIONS(2474),
    [anon_sym_AT_DQUOTE] = ACTIONS(2476),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2476),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2476),
    [sym_bool] = ACTIONS(2474),
    [sym_unit] = ACTIONS(2476),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2474),
    [sym_op_identifier] = ACTIONS(2474),
    [anon_sym_PLUS] = ACTIONS(2474),
    [anon_sym_DASH] = ACTIONS(2474),
    [anon_sym_PLUS_DOT] = ACTIONS(2474),
    [anon_sym_DASH_DOT] = ACTIONS(2474),
    [anon_sym_PERCENT] = ACTIONS(2474),
    [anon_sym_AMP_AMP] = ACTIONS(2474),
    [anon_sym_TILDE] = ACTIONS(2476),
    [aux_sym_prefix_op_token1] = ACTIONS(2474),
    [aux_sym_infix_op_token1] = ACTIONS(2476),
    [aux_sym_infix_op_token2] = ACTIONS(2474),
    [anon_sym_PIPE_PIPE] = ACTIONS(2474),
    [anon_sym_BANG_EQ] = ACTIONS(2474),
    [anon_sym_COLON_EQ] = ACTIONS(2476),
    [anon_sym_DOLLAR] = ACTIONS(2474),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2474),
    [sym_int] = ACTIONS(2474),
    [sym_xint] = ACTIONS(2476),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2476),
    [sym__newline] = ACTIONS(2476),
    [sym__dedent] = ACTIONS(2476),
  },
  [1152] = {
    [sym__else_expression] = STATE(1926),
    [sym_elif_expression] = STATE(1451),
    [sym_block_comment] = STATE(1152),
    [sym_compiler_directive_decl] = STATE(1152),
    [sym_fsi_directive_decl] = STATE(1152),
    [sym_preproc_line] = STATE(1152),
    [aux_sym_if_expression_repeat1] = STATE(1150),
    [sym_identifier] = ACTIONS(2422),
    [anon_sym_EQ] = ACTIONS(2424),
    [anon_sym_COLON] = ACTIONS(2422),
    [anon_sym_return] = ACTIONS(2422),
    [anon_sym_do] = ACTIONS(2422),
    [anon_sym_let] = ACTIONS(2422),
    [anon_sym_let_BANG] = ACTIONS(2424),
    [anon_sym_as] = ACTIONS(2422),
    [anon_sym_LPAREN] = ACTIONS(2422),
    [anon_sym_COMMA] = ACTIONS(2424),
    [anon_sym_null] = ACTIONS(2422),
    [anon_sym_QMARK] = ACTIONS(2422),
    [anon_sym_COLON_QMARK] = ACTIONS(2422),
    [anon_sym_COLON_COLON] = ACTIONS(2424),
    [anon_sym_AMP] = ACTIONS(2422),
    [anon_sym_LBRACK] = ACTIONS(2422),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2424),
    [anon_sym_LBRACE] = ACTIONS(2422),
    [anon_sym_LT_AT] = ACTIONS(2422),
    [anon_sym_LT_AT_AT] = ACTIONS(2422),
    [anon_sym_DOT] = ACTIONS(2422),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2424),
    [anon_sym_new] = ACTIONS(2422),
    [anon_sym_with] = ACTIONS(2422),
    [anon_sym_return_BANG] = ACTIONS(2424),
    [anon_sym_yield] = ACTIONS(2422),
    [anon_sym_yield_BANG] = ACTIONS(2424),
    [anon_sym_lazy] = ACTIONS(2422),
    [anon_sym_assert] = ACTIONS(2422),
    [anon_sym_upcast] = ACTIONS(2422),
    [anon_sym_downcast] = ACTIONS(2422),
    [anon_sym_COLON_GT] = ACTIONS(2424),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2424),
    [anon_sym_for] = ACTIONS(2422),
    [anon_sym_while] = ACTIONS(2422),
    [anon_sym_else] = ACTIONS(3338),
    [anon_sym_elif] = ACTIONS(3340),
    [anon_sym_if] = ACTIONS(2422),
    [anon_sym_fun] = ACTIONS(2422),
    [anon_sym_try] = ACTIONS(2422),
    [anon_sym_match] = ACTIONS(2422),
    [anon_sym_match_BANG] = ACTIONS(2424),
    [anon_sym_function] = ACTIONS(2422),
    [anon_sym_LT_DASH] = ACTIONS(2422),
    [anon_sym_DOT_LBRACK] = ACTIONS(2424),
    [anon_sym_LT] = ACTIONS(2424),
    [anon_sym_use] = ACTIONS(2422),
    [anon_sym_use_BANG] = ACTIONS(2424),
    [anon_sym_do_BANG] = ACTIONS(2424),
    [anon_sym_begin] = ACTIONS(2422),
    [anon_sym_LPAREN2] = ACTIONS(2422),
    [anon_sym_or] = ACTIONS(2422),
    [aux_sym_char_token1] = ACTIONS(2424),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2422),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_AT_DQUOTE] = ACTIONS(2424),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2424),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2424),
    [sym_bool] = ACTIONS(2422),
    [sym_unit] = ACTIONS(2424),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2422),
    [sym_op_identifier] = ACTIONS(2422),
    [anon_sym_PLUS] = ACTIONS(2422),
    [anon_sym_DASH] = ACTIONS(2422),
    [anon_sym_PLUS_DOT] = ACTIONS(2422),
    [anon_sym_DASH_DOT] = ACTIONS(2422),
    [anon_sym_PERCENT] = ACTIONS(2422),
    [anon_sym_AMP_AMP] = ACTIONS(2422),
    [anon_sym_TILDE] = ACTIONS(2424),
    [aux_sym_prefix_op_token1] = ACTIONS(2422),
    [aux_sym_infix_op_token1] = ACTIONS(2424),
    [aux_sym_infix_op_token2] = ACTIONS(2422),
    [anon_sym_PIPE_PIPE] = ACTIONS(2422),
    [anon_sym_BANG_EQ] = ACTIONS(2422),
    [anon_sym_COLON_EQ] = ACTIONS(2424),
    [anon_sym_DOLLAR] = ACTIONS(2422),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2422),
    [sym_int] = ACTIONS(2422),
    [sym_xint] = ACTIONS(2424),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2424),
    [sym__newline] = ACTIONS(2424),
  },
  [1153] = {
    [sym_block_comment] = STATE(1153),
    [sym_compiler_directive_decl] = STATE(1153),
    [sym_fsi_directive_decl] = STATE(1153),
    [sym_preproc_line] = STATE(1153),
    [sym_identifier] = ACTIONS(2510),
    [anon_sym_EQ] = ACTIONS(2512),
    [anon_sym_COLON] = ACTIONS(2510),
    [anon_sym_return] = ACTIONS(2510),
    [anon_sym_do] = ACTIONS(2510),
    [anon_sym_let] = ACTIONS(2510),
    [anon_sym_let_BANG] = ACTIONS(2512),
    [anon_sym_as] = ACTIONS(2510),
    [anon_sym_LPAREN] = ACTIONS(2510),
    [anon_sym_COMMA] = ACTIONS(2512),
    [anon_sym_null] = ACTIONS(2510),
    [anon_sym_QMARK] = ACTIONS(2510),
    [anon_sym_COLON_QMARK] = ACTIONS(2510),
    [anon_sym_COLON_COLON] = ACTIONS(2512),
    [anon_sym_AMP] = ACTIONS(2510),
    [anon_sym_LBRACK] = ACTIONS(2510),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2512),
    [anon_sym_LBRACE] = ACTIONS(2510),
    [anon_sym_LT_AT] = ACTIONS(2510),
    [anon_sym_LT_AT_AT] = ACTIONS(2510),
    [anon_sym_DOT] = ACTIONS(2510),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2512),
    [anon_sym_new] = ACTIONS(2510),
    [anon_sym_with] = ACTIONS(2510),
    [anon_sym_return_BANG] = ACTIONS(2512),
    [anon_sym_yield] = ACTIONS(2510),
    [anon_sym_yield_BANG] = ACTIONS(2512),
    [anon_sym_lazy] = ACTIONS(2510),
    [anon_sym_assert] = ACTIONS(2510),
    [anon_sym_upcast] = ACTIONS(2510),
    [anon_sym_downcast] = ACTIONS(2510),
    [anon_sym_COLON_GT] = ACTIONS(2512),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2512),
    [anon_sym_for] = ACTIONS(2510),
    [anon_sym_while] = ACTIONS(2510),
    [anon_sym_if] = ACTIONS(2510),
    [anon_sym_fun] = ACTIONS(2510),
    [anon_sym_DASH_GT] = ACTIONS(2510),
    [anon_sym_try] = ACTIONS(2510),
    [anon_sym_match] = ACTIONS(2510),
    [anon_sym_match_BANG] = ACTIONS(2512),
    [anon_sym_function] = ACTIONS(2510),
    [anon_sym_LT_DASH] = ACTIONS(2510),
    [anon_sym_DOT_LBRACK] = ACTIONS(2512),
    [anon_sym_LT] = ACTIONS(2512),
    [anon_sym_use] = ACTIONS(2510),
    [anon_sym_use_BANG] = ACTIONS(2512),
    [anon_sym_do_BANG] = ACTIONS(2512),
    [anon_sym_begin] = ACTIONS(2510),
    [anon_sym_LPAREN2] = ACTIONS(2510),
    [anon_sym_STAR] = ACTIONS(2510),
    [anon_sym_LT2] = ACTIONS(2510),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2512),
    [anon_sym_or] = ACTIONS(2510),
    [aux_sym_char_token1] = ACTIONS(2512),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2510),
    [anon_sym_DQUOTE] = ACTIONS(2510),
    [anon_sym_AT_DQUOTE] = ACTIONS(2512),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2512),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2512),
    [sym_bool] = ACTIONS(2510),
    [sym_unit] = ACTIONS(2512),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2510),
    [sym_op_identifier] = ACTIONS(2510),
    [anon_sym_PLUS] = ACTIONS(2510),
    [anon_sym_DASH] = ACTIONS(2510),
    [anon_sym_PLUS_DOT] = ACTIONS(2510),
    [anon_sym_DASH_DOT] = ACTIONS(2510),
    [anon_sym_PERCENT] = ACTIONS(2510),
    [anon_sym_AMP_AMP] = ACTIONS(2510),
    [anon_sym_TILDE] = ACTIONS(2512),
    [aux_sym_prefix_op_token1] = ACTIONS(2510),
    [aux_sym_infix_op_token1] = ACTIONS(2512),
    [aux_sym_infix_op_token2] = ACTIONS(2510),
    [anon_sym_PIPE_PIPE] = ACTIONS(2510),
    [anon_sym_BANG_EQ] = ACTIONS(2510),
    [anon_sym_COLON_EQ] = ACTIONS(2512),
    [anon_sym_DOLLAR] = ACTIONS(2510),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2510),
    [sym_int] = ACTIONS(2510),
    [sym_xint] = ACTIONS(2512),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2512),
    [sym__newline] = ACTIONS(2512),
    [sym__dedent] = ACTIONS(2512),
  },
  [1154] = {
    [sym_block_comment] = STATE(1154),
    [sym_compiler_directive_decl] = STATE(1154),
    [sym_fsi_directive_decl] = STATE(1154),
    [sym_preproc_line] = STATE(1154),
    [aux_sym_type_argument_repeat1] = STATE(1149),
    [sym_identifier] = ACTIONS(2328),
    [anon_sym_EQ] = ACTIONS(2330),
    [anon_sym_COLON] = ACTIONS(2328),
    [anon_sym_return] = ACTIONS(2328),
    [anon_sym_do] = ACTIONS(2328),
    [anon_sym_and] = ACTIONS(2328),
    [anon_sym_let] = ACTIONS(2328),
    [anon_sym_let_BANG] = ACTIONS(2330),
    [anon_sym_LPAREN] = ACTIONS(2328),
    [anon_sym_COMMA] = ACTIONS(2330),
    [anon_sym_null] = ACTIONS(2328),
    [anon_sym_QMARK] = ACTIONS(2328),
    [anon_sym_COLON_QMARK] = ACTIONS(2328),
    [anon_sym_COLON_COLON] = ACTIONS(2330),
    [anon_sym_AMP] = ACTIONS(2328),
    [anon_sym_LBRACK] = ACTIONS(2328),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2330),
    [anon_sym_LBRACE] = ACTIONS(2328),
    [anon_sym_LT_AT] = ACTIONS(2328),
    [anon_sym_LT_AT_AT] = ACTIONS(2328),
    [anon_sym_DOT] = ACTIONS(2328),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2330),
    [anon_sym_new] = ACTIONS(2328),
    [anon_sym_return_BANG] = ACTIONS(2330),
    [anon_sym_yield] = ACTIONS(2328),
    [anon_sym_yield_BANG] = ACTIONS(2330),
    [anon_sym_lazy] = ACTIONS(2328),
    [anon_sym_assert] = ACTIONS(2328),
    [anon_sym_upcast] = ACTIONS(2328),
    [anon_sym_downcast] = ACTIONS(2328),
    [anon_sym_COLON_GT] = ACTIONS(2330),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2330),
    [anon_sym_for] = ACTIONS(2328),
    [anon_sym_while] = ACTIONS(2328),
    [anon_sym_if] = ACTIONS(2328),
    [anon_sym_fun] = ACTIONS(2328),
    [anon_sym_DASH_GT] = ACTIONS(2328),
    [anon_sym_try] = ACTIONS(2328),
    [anon_sym_match] = ACTIONS(2328),
    [anon_sym_match_BANG] = ACTIONS(2330),
    [anon_sym_function] = ACTIONS(2328),
    [anon_sym_LT_DASH] = ACTIONS(2328),
    [anon_sym_DOT_LBRACK] = ACTIONS(2330),
    [anon_sym_LT] = ACTIONS(2330),
    [anon_sym_use] = ACTIONS(2328),
    [anon_sym_use_BANG] = ACTIONS(2330),
    [anon_sym_do_BANG] = ACTIONS(2330),
    [anon_sym_begin] = ACTIONS(2328),
    [anon_sym_LPAREN2] = ACTIONS(2328),
    [anon_sym_STAR] = ACTIONS(2328),
    [anon_sym_LT2] = ACTIONS(2328),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2330),
    [anon_sym_or] = ACTIONS(2328),
    [aux_sym_char_token1] = ACTIONS(2330),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2328),
    [anon_sym_DQUOTE] = ACTIONS(2328),
    [anon_sym_AT_DQUOTE] = ACTIONS(2330),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2330),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2330),
    [sym_bool] = ACTIONS(2328),
    [sym_unit] = ACTIONS(2330),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2328),
    [sym_op_identifier] = ACTIONS(2328),
    [anon_sym_PLUS] = ACTIONS(2328),
    [anon_sym_DASH] = ACTIONS(2328),
    [anon_sym_PLUS_DOT] = ACTIONS(2328),
    [anon_sym_DASH_DOT] = ACTIONS(2328),
    [anon_sym_PERCENT] = ACTIONS(2328),
    [anon_sym_AMP_AMP] = ACTIONS(2328),
    [anon_sym_TILDE] = ACTIONS(2330),
    [aux_sym_prefix_op_token1] = ACTIONS(2328),
    [aux_sym_infix_op_token1] = ACTIONS(2330),
    [aux_sym_infix_op_token2] = ACTIONS(2328),
    [anon_sym_PIPE_PIPE] = ACTIONS(2328),
    [anon_sym_BANG_EQ] = ACTIONS(2328),
    [anon_sym_COLON_EQ] = ACTIONS(2330),
    [anon_sym_DOLLAR] = ACTIONS(2328),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2328),
    [sym_int] = ACTIONS(2328),
    [sym_xint] = ACTIONS(2330),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2330),
    [sym__newline] = ACTIONS(2330),
    [sym__dedent] = ACTIONS(2330),
  },
  [1155] = {
    [sym_block_comment] = STATE(1155),
    [sym_compiler_directive_decl] = STATE(1155),
    [sym_fsi_directive_decl] = STATE(1155),
    [sym_preproc_line] = STATE(1155),
    [sym_identifier] = ACTIONS(2966),
    [anon_sym_EQ] = ACTIONS(2968),
    [anon_sym_GT_RBRACK] = ACTIONS(2968),
    [anon_sym_COLON] = ACTIONS(2966),
    [anon_sym_return] = ACTIONS(2966),
    [anon_sym_do] = ACTIONS(2966),
    [anon_sym_let] = ACTIONS(2966),
    [anon_sym_let_BANG] = ACTIONS(2968),
    [anon_sym_LPAREN] = ACTIONS(2966),
    [anon_sym_COMMA] = ACTIONS(2968),
    [anon_sym_null] = ACTIONS(2966),
    [anon_sym_QMARK] = ACTIONS(2966),
    [anon_sym_COLON_QMARK] = ACTIONS(2966),
    [anon_sym_COLON_COLON] = ACTIONS(2968),
    [anon_sym_AMP] = ACTIONS(2966),
    [anon_sym_LBRACK] = ACTIONS(2966),
    [anon_sym_RBRACK] = ACTIONS(2968),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2968),
    [anon_sym_LBRACE] = ACTIONS(2966),
    [anon_sym_RBRACE] = ACTIONS(2968),
    [anon_sym_LT_AT] = ACTIONS(2966),
    [anon_sym_LT_AT_AT] = ACTIONS(2966),
    [anon_sym_DOT] = ACTIONS(2966),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2968),
    [anon_sym_new] = ACTIONS(2966),
    [anon_sym_with] = ACTIONS(2966),
    [anon_sym_return_BANG] = ACTIONS(2968),
    [anon_sym_yield] = ACTIONS(2966),
    [anon_sym_yield_BANG] = ACTIONS(2968),
    [anon_sym_lazy] = ACTIONS(2966),
    [anon_sym_assert] = ACTIONS(2966),
    [anon_sym_upcast] = ACTIONS(2966),
    [anon_sym_downcast] = ACTIONS(2966),
    [anon_sym_COLON_GT] = ACTIONS(2968),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2968),
    [anon_sym_for] = ACTIONS(2966),
    [anon_sym_to] = ACTIONS(2966),
    [anon_sym_downto] = ACTIONS(2966),
    [anon_sym_while] = ACTIONS(2966),
    [anon_sym_if] = ACTIONS(2966),
    [anon_sym_fun] = ACTIONS(2966),
    [anon_sym_try] = ACTIONS(2966),
    [anon_sym_match] = ACTIONS(2966),
    [anon_sym_match_BANG] = ACTIONS(2968),
    [anon_sym_function] = ACTIONS(2966),
    [anon_sym_LT_DASH] = ACTIONS(2966),
    [anon_sym_DOT_LBRACK] = ACTIONS(2968),
    [anon_sym_LT] = ACTIONS(2968),
    [anon_sym_use] = ACTIONS(2966),
    [anon_sym_use_BANG] = ACTIONS(2968),
    [anon_sym_do_BANG] = ACTIONS(2968),
    [anon_sym_begin] = ACTIONS(2966),
    [anon_sym_LPAREN2] = ACTIONS(2966),
    [anon_sym_DOT_DOT2] = ACTIONS(2968),
    [anon_sym_or] = ACTIONS(2966),
    [aux_sym_char_token1] = ACTIONS(2968),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2966),
    [anon_sym_DQUOTE] = ACTIONS(2966),
    [anon_sym_AT_DQUOTE] = ACTIONS(2968),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2968),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2968),
    [sym_bool] = ACTIONS(2966),
    [sym_unit] = ACTIONS(2968),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2966),
    [sym_op_identifier] = ACTIONS(2966),
    [anon_sym_PLUS] = ACTIONS(2966),
    [anon_sym_DASH] = ACTIONS(2966),
    [anon_sym_PLUS_DOT] = ACTIONS(2966),
    [anon_sym_DASH_DOT] = ACTIONS(2966),
    [anon_sym_PERCENT] = ACTIONS(2966),
    [anon_sym_AMP_AMP] = ACTIONS(2966),
    [anon_sym_TILDE] = ACTIONS(2968),
    [aux_sym_prefix_op_token1] = ACTIONS(2966),
    [aux_sym_infix_op_token1] = ACTIONS(2968),
    [aux_sym_infix_op_token2] = ACTIONS(2966),
    [anon_sym_PIPE_PIPE] = ACTIONS(2966),
    [anon_sym_BANG_EQ] = ACTIONS(2966),
    [anon_sym_COLON_EQ] = ACTIONS(2968),
    [anon_sym_DOLLAR] = ACTIONS(2966),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2966),
    [sym_int] = ACTIONS(2966),
    [sym_xint] = ACTIONS(2968),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2968),
    [sym__newline] = ACTIONS(2968),
  },
  [1156] = {
    [sym_block_comment] = STATE(1156),
    [sym_compiler_directive_decl] = STATE(1156),
    [sym_fsi_directive_decl] = STATE(1156),
    [sym_preproc_line] = STATE(1156),
    [sym_identifier] = ACTIONS(2867),
    [anon_sym_EQ] = ACTIONS(2869),
    [anon_sym_GT_RBRACK] = ACTIONS(2869),
    [anon_sym_COLON] = ACTIONS(2867),
    [anon_sym_return] = ACTIONS(2867),
    [anon_sym_do] = ACTIONS(2867),
    [anon_sym_let] = ACTIONS(2867),
    [anon_sym_let_BANG] = ACTIONS(2869),
    [anon_sym_LPAREN] = ACTIONS(2867),
    [anon_sym_COMMA] = ACTIONS(2869),
    [anon_sym_null] = ACTIONS(2867),
    [anon_sym_QMARK] = ACTIONS(2867),
    [anon_sym_COLON_QMARK] = ACTIONS(2867),
    [anon_sym_COLON_COLON] = ACTIONS(2869),
    [anon_sym_AMP] = ACTIONS(2867),
    [anon_sym_LBRACK] = ACTIONS(2867),
    [anon_sym_RBRACK] = ACTIONS(2869),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2869),
    [anon_sym_LBRACE] = ACTIONS(2867),
    [anon_sym_RBRACE] = ACTIONS(2869),
    [anon_sym_LT_AT] = ACTIONS(2867),
    [anon_sym_LT_AT_AT] = ACTIONS(2867),
    [anon_sym_DOT] = ACTIONS(3342),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2869),
    [anon_sym_new] = ACTIONS(2867),
    [anon_sym_with] = ACTIONS(2867),
    [anon_sym_return_BANG] = ACTIONS(2869),
    [anon_sym_yield] = ACTIONS(2867),
    [anon_sym_yield_BANG] = ACTIONS(2869),
    [anon_sym_lazy] = ACTIONS(2867),
    [anon_sym_assert] = ACTIONS(2867),
    [anon_sym_upcast] = ACTIONS(2867),
    [anon_sym_downcast] = ACTIONS(2867),
    [anon_sym_COLON_GT] = ACTIONS(2869),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2869),
    [anon_sym_for] = ACTIONS(2867),
    [anon_sym_to] = ACTIONS(2867),
    [anon_sym_downto] = ACTIONS(2867),
    [anon_sym_while] = ACTIONS(2867),
    [anon_sym_if] = ACTIONS(2867),
    [anon_sym_fun] = ACTIONS(2867),
    [anon_sym_try] = ACTIONS(2867),
    [anon_sym_match] = ACTIONS(2867),
    [anon_sym_match_BANG] = ACTIONS(2869),
    [anon_sym_function] = ACTIONS(2867),
    [anon_sym_LT_DASH] = ACTIONS(2867),
    [anon_sym_DOT_LBRACK] = ACTIONS(2869),
    [anon_sym_LT] = ACTIONS(2869),
    [anon_sym_use] = ACTIONS(2867),
    [anon_sym_use_BANG] = ACTIONS(2869),
    [anon_sym_do_BANG] = ACTIONS(2869),
    [anon_sym_begin] = ACTIONS(2867),
    [anon_sym_LPAREN2] = ACTIONS(2867),
    [anon_sym_DOT_DOT2] = ACTIONS(2869),
    [anon_sym_or] = ACTIONS(2867),
    [aux_sym_char_token1] = ACTIONS(2869),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2867),
    [anon_sym_DQUOTE] = ACTIONS(2867),
    [anon_sym_AT_DQUOTE] = ACTIONS(2869),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2869),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2869),
    [sym_bool] = ACTIONS(2867),
    [sym_unit] = ACTIONS(2869),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2867),
    [sym_op_identifier] = ACTIONS(2867),
    [anon_sym_PLUS] = ACTIONS(2867),
    [anon_sym_DASH] = ACTIONS(2867),
    [anon_sym_PLUS_DOT] = ACTIONS(2867),
    [anon_sym_DASH_DOT] = ACTIONS(2867),
    [anon_sym_PERCENT] = ACTIONS(2867),
    [anon_sym_AMP_AMP] = ACTIONS(2867),
    [anon_sym_TILDE] = ACTIONS(2869),
    [aux_sym_prefix_op_token1] = ACTIONS(2867),
    [aux_sym_infix_op_token1] = ACTIONS(2869),
    [aux_sym_infix_op_token2] = ACTIONS(2867),
    [anon_sym_PIPE_PIPE] = ACTIONS(2867),
    [anon_sym_BANG_EQ] = ACTIONS(2867),
    [anon_sym_COLON_EQ] = ACTIONS(2869),
    [anon_sym_DOLLAR] = ACTIONS(2867),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2867),
    [sym_int] = ACTIONS(2867),
    [sym_xint] = ACTIONS(2869),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2869),
    [sym__newline] = ACTIONS(2869),
  },
  [1157] = {
    [sym_block_comment] = STATE(1157),
    [sym_compiler_directive_decl] = STATE(1157),
    [sym_fsi_directive_decl] = STATE(1157),
    [sym_preproc_line] = STATE(1157),
    [sym_identifier] = ACTIONS(2974),
    [anon_sym_EQ] = ACTIONS(2976),
    [anon_sym_GT_RBRACK] = ACTIONS(2976),
    [anon_sym_COLON] = ACTIONS(2974),
    [anon_sym_return] = ACTIONS(2974),
    [anon_sym_do] = ACTIONS(2974),
    [anon_sym_let] = ACTIONS(2974),
    [anon_sym_let_BANG] = ACTIONS(2976),
    [anon_sym_LPAREN] = ACTIONS(2974),
    [anon_sym_COMMA] = ACTIONS(2976),
    [anon_sym_null] = ACTIONS(2974),
    [anon_sym_QMARK] = ACTIONS(2974),
    [anon_sym_COLON_QMARK] = ACTIONS(2974),
    [anon_sym_COLON_COLON] = ACTIONS(2976),
    [anon_sym_AMP] = ACTIONS(2974),
    [anon_sym_LBRACK] = ACTIONS(2974),
    [anon_sym_RBRACK] = ACTIONS(2976),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2976),
    [anon_sym_LBRACE] = ACTIONS(2974),
    [anon_sym_RBRACE] = ACTIONS(2976),
    [anon_sym_LT_AT] = ACTIONS(2974),
    [anon_sym_LT_AT_AT] = ACTIONS(2974),
    [anon_sym_DOT] = ACTIONS(2974),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2976),
    [anon_sym_new] = ACTIONS(2974),
    [anon_sym_with] = ACTIONS(2974),
    [anon_sym_return_BANG] = ACTIONS(2976),
    [anon_sym_yield] = ACTIONS(2974),
    [anon_sym_yield_BANG] = ACTIONS(2976),
    [anon_sym_lazy] = ACTIONS(2974),
    [anon_sym_assert] = ACTIONS(2974),
    [anon_sym_upcast] = ACTIONS(2974),
    [anon_sym_downcast] = ACTIONS(2974),
    [anon_sym_COLON_GT] = ACTIONS(2976),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2976),
    [anon_sym_for] = ACTIONS(2974),
    [anon_sym_to] = ACTIONS(2974),
    [anon_sym_downto] = ACTIONS(2974),
    [anon_sym_while] = ACTIONS(2974),
    [anon_sym_if] = ACTIONS(2974),
    [anon_sym_fun] = ACTIONS(2974),
    [anon_sym_try] = ACTIONS(2974),
    [anon_sym_match] = ACTIONS(2974),
    [anon_sym_match_BANG] = ACTIONS(2976),
    [anon_sym_function] = ACTIONS(2974),
    [anon_sym_LT_DASH] = ACTIONS(2974),
    [anon_sym_DOT_LBRACK] = ACTIONS(2976),
    [anon_sym_LT] = ACTIONS(2976),
    [anon_sym_use] = ACTIONS(2974),
    [anon_sym_use_BANG] = ACTIONS(2976),
    [anon_sym_do_BANG] = ACTIONS(2976),
    [anon_sym_begin] = ACTIONS(2974),
    [anon_sym_LPAREN2] = ACTIONS(2974),
    [anon_sym_DOT_DOT2] = ACTIONS(2976),
    [anon_sym_or] = ACTIONS(2974),
    [aux_sym_char_token1] = ACTIONS(2976),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2974),
    [anon_sym_DQUOTE] = ACTIONS(2974),
    [anon_sym_AT_DQUOTE] = ACTIONS(2976),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2976),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2976),
    [sym_bool] = ACTIONS(2974),
    [sym_unit] = ACTIONS(2976),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2974),
    [sym_op_identifier] = ACTIONS(2974),
    [anon_sym_PLUS] = ACTIONS(2974),
    [anon_sym_DASH] = ACTIONS(2974),
    [anon_sym_PLUS_DOT] = ACTIONS(2974),
    [anon_sym_DASH_DOT] = ACTIONS(2974),
    [anon_sym_PERCENT] = ACTIONS(2974),
    [anon_sym_AMP_AMP] = ACTIONS(2974),
    [anon_sym_TILDE] = ACTIONS(2976),
    [aux_sym_prefix_op_token1] = ACTIONS(2974),
    [aux_sym_infix_op_token1] = ACTIONS(2976),
    [aux_sym_infix_op_token2] = ACTIONS(2974),
    [anon_sym_PIPE_PIPE] = ACTIONS(2974),
    [anon_sym_BANG_EQ] = ACTIONS(2974),
    [anon_sym_COLON_EQ] = ACTIONS(2976),
    [anon_sym_DOLLAR] = ACTIONS(2974),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2974),
    [sym_int] = ACTIONS(2974),
    [sym_xint] = ACTIONS(2976),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2976),
    [sym__newline] = ACTIONS(2976),
  },
  [1158] = {
    [sym_block_comment] = STATE(1158),
    [sym_compiler_directive_decl] = STATE(1158),
    [sym_fsi_directive_decl] = STATE(1158),
    [sym_preproc_line] = STATE(1158),
    [aux_sym_long_identifier_repeat1] = STATE(1102),
    [sym_identifier] = ACTIONS(2312),
    [anon_sym_EQ] = ACTIONS(2314),
    [anon_sym_COLON] = ACTIONS(2312),
    [anon_sym_return] = ACTIONS(2312),
    [anon_sym_do] = ACTIONS(2312),
    [anon_sym_and] = ACTIONS(2312),
    [anon_sym_let] = ACTIONS(2312),
    [anon_sym_let_BANG] = ACTIONS(2314),
    [anon_sym_LPAREN] = ACTIONS(2312),
    [anon_sym_COMMA] = ACTIONS(2314),
    [anon_sym_null] = ACTIONS(2312),
    [anon_sym_QMARK] = ACTIONS(2312),
    [anon_sym_COLON_QMARK] = ACTIONS(2312),
    [anon_sym_COLON_COLON] = ACTIONS(2314),
    [anon_sym_AMP] = ACTIONS(2312),
    [anon_sym_LBRACK] = ACTIONS(2312),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2314),
    [anon_sym_LBRACE] = ACTIONS(2312),
    [anon_sym_LT_AT] = ACTIONS(2312),
    [anon_sym_LT_AT_AT] = ACTIONS(2312),
    [anon_sym_DOT] = ACTIONS(3318),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2314),
    [anon_sym_new] = ACTIONS(2312),
    [anon_sym_return_BANG] = ACTIONS(2314),
    [anon_sym_yield] = ACTIONS(2312),
    [anon_sym_yield_BANG] = ACTIONS(2314),
    [anon_sym_lazy] = ACTIONS(2312),
    [anon_sym_assert] = ACTIONS(2312),
    [anon_sym_upcast] = ACTIONS(2312),
    [anon_sym_downcast] = ACTIONS(2312),
    [anon_sym_COLON_GT] = ACTIONS(2314),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2314),
    [anon_sym_for] = ACTIONS(2312),
    [anon_sym_while] = ACTIONS(2312),
    [anon_sym_if] = ACTIONS(2312),
    [anon_sym_fun] = ACTIONS(2312),
    [anon_sym_DASH_GT] = ACTIONS(2312),
    [anon_sym_try] = ACTIONS(2312),
    [anon_sym_match] = ACTIONS(2312),
    [anon_sym_match_BANG] = ACTIONS(2314),
    [anon_sym_function] = ACTIONS(2312),
    [anon_sym_LT_DASH] = ACTIONS(2312),
    [anon_sym_DOT_LBRACK] = ACTIONS(2314),
    [anon_sym_LT] = ACTIONS(2314),
    [anon_sym_use] = ACTIONS(2312),
    [anon_sym_use_BANG] = ACTIONS(2314),
    [anon_sym_do_BANG] = ACTIONS(2314),
    [anon_sym_begin] = ACTIONS(2312),
    [anon_sym_LPAREN2] = ACTIONS(2312),
    [anon_sym_STAR] = ACTIONS(2312),
    [anon_sym_LT2] = ACTIONS(2312),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2314),
    [anon_sym_or] = ACTIONS(2312),
    [aux_sym_char_token1] = ACTIONS(2314),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2312),
    [anon_sym_DQUOTE] = ACTIONS(2312),
    [anon_sym_AT_DQUOTE] = ACTIONS(2314),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2314),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2314),
    [sym_bool] = ACTIONS(2312),
    [sym_unit] = ACTIONS(2314),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2312),
    [sym_op_identifier] = ACTIONS(2312),
    [anon_sym_PLUS] = ACTIONS(2312),
    [anon_sym_DASH] = ACTIONS(2312),
    [anon_sym_PLUS_DOT] = ACTIONS(2312),
    [anon_sym_DASH_DOT] = ACTIONS(2312),
    [anon_sym_PERCENT] = ACTIONS(2312),
    [anon_sym_AMP_AMP] = ACTIONS(2312),
    [anon_sym_TILDE] = ACTIONS(2314),
    [aux_sym_prefix_op_token1] = ACTIONS(2312),
    [aux_sym_infix_op_token1] = ACTIONS(2314),
    [aux_sym_infix_op_token2] = ACTIONS(2312),
    [anon_sym_PIPE_PIPE] = ACTIONS(2312),
    [anon_sym_BANG_EQ] = ACTIONS(2312),
    [anon_sym_COLON_EQ] = ACTIONS(2314),
    [anon_sym_DOLLAR] = ACTIONS(2312),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2312),
    [sym_int] = ACTIONS(2312),
    [sym_xint] = ACTIONS(2314),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2314),
    [sym__newline] = ACTIONS(2314),
    [sym__dedent] = ACTIONS(2314),
  },
  [1159] = {
    [sym_block_comment] = STATE(1159),
    [sym_compiler_directive_decl] = STATE(1159),
    [sym_fsi_directive_decl] = STATE(1159),
    [sym_preproc_line] = STATE(1159),
    [sym_identifier] = ACTIONS(3047),
    [anon_sym_EQ] = ACTIONS(3049),
    [anon_sym_GT_RBRACK] = ACTIONS(3049),
    [anon_sym_COLON] = ACTIONS(3047),
    [anon_sym_return] = ACTIONS(3047),
    [anon_sym_do] = ACTIONS(3047),
    [anon_sym_let] = ACTIONS(3047),
    [anon_sym_let_BANG] = ACTIONS(3049),
    [anon_sym_LPAREN] = ACTIONS(3047),
    [anon_sym_COMMA] = ACTIONS(3049),
    [anon_sym_null] = ACTIONS(3047),
    [anon_sym_QMARK] = ACTIONS(3047),
    [anon_sym_COLON_QMARK] = ACTIONS(3047),
    [anon_sym_COLON_COLON] = ACTIONS(3049),
    [anon_sym_AMP] = ACTIONS(3047),
    [anon_sym_LBRACK] = ACTIONS(3047),
    [anon_sym_RBRACK] = ACTIONS(3049),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3049),
    [anon_sym_LBRACE] = ACTIONS(3047),
    [anon_sym_RBRACE] = ACTIONS(3049),
    [anon_sym_LT_AT] = ACTIONS(3047),
    [anon_sym_LT_AT_AT] = ACTIONS(3047),
    [anon_sym_DOT] = ACTIONS(3047),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3049),
    [anon_sym_new] = ACTIONS(3047),
    [anon_sym_with] = ACTIONS(3047),
    [anon_sym_return_BANG] = ACTIONS(3049),
    [anon_sym_yield] = ACTIONS(3047),
    [anon_sym_yield_BANG] = ACTIONS(3049),
    [anon_sym_lazy] = ACTIONS(3047),
    [anon_sym_assert] = ACTIONS(3047),
    [anon_sym_upcast] = ACTIONS(3047),
    [anon_sym_downcast] = ACTIONS(3047),
    [anon_sym_COLON_GT] = ACTIONS(3049),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3049),
    [anon_sym_for] = ACTIONS(3047),
    [anon_sym_to] = ACTIONS(3047),
    [anon_sym_downto] = ACTIONS(3047),
    [anon_sym_while] = ACTIONS(3047),
    [anon_sym_if] = ACTIONS(3047),
    [anon_sym_fun] = ACTIONS(3047),
    [anon_sym_try] = ACTIONS(3047),
    [anon_sym_match] = ACTIONS(3047),
    [anon_sym_match_BANG] = ACTIONS(3049),
    [anon_sym_function] = ACTIONS(3047),
    [anon_sym_LT_DASH] = ACTIONS(3047),
    [anon_sym_DOT_LBRACK] = ACTIONS(3049),
    [anon_sym_LT] = ACTIONS(3049),
    [anon_sym_use] = ACTIONS(3047),
    [anon_sym_use_BANG] = ACTIONS(3049),
    [anon_sym_do_BANG] = ACTIONS(3049),
    [anon_sym_begin] = ACTIONS(3047),
    [anon_sym_LPAREN2] = ACTIONS(3047),
    [anon_sym_DOT_DOT2] = ACTIONS(3049),
    [anon_sym_or] = ACTIONS(3047),
    [aux_sym_char_token1] = ACTIONS(3049),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3047),
    [anon_sym_DQUOTE] = ACTIONS(3047),
    [anon_sym_AT_DQUOTE] = ACTIONS(3049),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3049),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3049),
    [sym_bool] = ACTIONS(3047),
    [sym_unit] = ACTIONS(3049),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3047),
    [sym_op_identifier] = ACTIONS(3047),
    [anon_sym_PLUS] = ACTIONS(3047),
    [anon_sym_DASH] = ACTIONS(3047),
    [anon_sym_PLUS_DOT] = ACTIONS(3047),
    [anon_sym_DASH_DOT] = ACTIONS(3047),
    [anon_sym_PERCENT] = ACTIONS(3047),
    [anon_sym_AMP_AMP] = ACTIONS(3047),
    [anon_sym_TILDE] = ACTIONS(3049),
    [aux_sym_prefix_op_token1] = ACTIONS(3047),
    [aux_sym_infix_op_token1] = ACTIONS(3049),
    [aux_sym_infix_op_token2] = ACTIONS(3047),
    [anon_sym_PIPE_PIPE] = ACTIONS(3047),
    [anon_sym_BANG_EQ] = ACTIONS(3047),
    [anon_sym_COLON_EQ] = ACTIONS(3049),
    [anon_sym_DOLLAR] = ACTIONS(3047),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3047),
    [sym_int] = ACTIONS(3047),
    [sym_xint] = ACTIONS(3049),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3049),
    [sym__newline] = ACTIONS(3049),
  },
  [1160] = {
    [sym_block_comment] = STATE(1160),
    [sym_compiler_directive_decl] = STATE(1160),
    [sym_fsi_directive_decl] = STATE(1160),
    [sym_preproc_line] = STATE(1160),
    [sym_identifier] = ACTIONS(3059),
    [anon_sym_EQ] = ACTIONS(3061),
    [anon_sym_GT_RBRACK] = ACTIONS(3061),
    [anon_sym_COLON] = ACTIONS(3059),
    [anon_sym_return] = ACTIONS(3059),
    [anon_sym_do] = ACTIONS(3059),
    [anon_sym_let] = ACTIONS(3059),
    [anon_sym_let_BANG] = ACTIONS(3061),
    [anon_sym_LPAREN] = ACTIONS(3059),
    [anon_sym_COMMA] = ACTIONS(3061),
    [anon_sym_null] = ACTIONS(3059),
    [anon_sym_QMARK] = ACTIONS(3059),
    [anon_sym_COLON_QMARK] = ACTIONS(3059),
    [anon_sym_COLON_COLON] = ACTIONS(3061),
    [anon_sym_AMP] = ACTIONS(3059),
    [anon_sym_LBRACK] = ACTIONS(3059),
    [anon_sym_RBRACK] = ACTIONS(3061),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3061),
    [anon_sym_LBRACE] = ACTIONS(3059),
    [anon_sym_RBRACE] = ACTIONS(3061),
    [anon_sym_LT_AT] = ACTIONS(3059),
    [anon_sym_LT_AT_AT] = ACTIONS(3059),
    [anon_sym_DOT] = ACTIONS(3059),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3061),
    [anon_sym_new] = ACTIONS(3059),
    [anon_sym_with] = ACTIONS(3059),
    [anon_sym_return_BANG] = ACTIONS(3061),
    [anon_sym_yield] = ACTIONS(3059),
    [anon_sym_yield_BANG] = ACTIONS(3061),
    [anon_sym_lazy] = ACTIONS(3059),
    [anon_sym_assert] = ACTIONS(3059),
    [anon_sym_upcast] = ACTIONS(3059),
    [anon_sym_downcast] = ACTIONS(3059),
    [anon_sym_COLON_GT] = ACTIONS(3061),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3061),
    [anon_sym_for] = ACTIONS(3059),
    [anon_sym_to] = ACTIONS(3059),
    [anon_sym_downto] = ACTIONS(3059),
    [anon_sym_while] = ACTIONS(3059),
    [anon_sym_if] = ACTIONS(3059),
    [anon_sym_fun] = ACTIONS(3059),
    [anon_sym_try] = ACTIONS(3059),
    [anon_sym_match] = ACTIONS(3059),
    [anon_sym_match_BANG] = ACTIONS(3061),
    [anon_sym_function] = ACTIONS(3059),
    [anon_sym_LT_DASH] = ACTIONS(3059),
    [anon_sym_DOT_LBRACK] = ACTIONS(3061),
    [anon_sym_LT] = ACTIONS(3061),
    [anon_sym_use] = ACTIONS(3059),
    [anon_sym_use_BANG] = ACTIONS(3061),
    [anon_sym_do_BANG] = ACTIONS(3061),
    [anon_sym_begin] = ACTIONS(3059),
    [anon_sym_LPAREN2] = ACTIONS(3059),
    [anon_sym_DOT_DOT2] = ACTIONS(3061),
    [anon_sym_or] = ACTIONS(3059),
    [aux_sym_char_token1] = ACTIONS(3061),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3059),
    [anon_sym_DQUOTE] = ACTIONS(3059),
    [anon_sym_AT_DQUOTE] = ACTIONS(3061),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3061),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3061),
    [sym_bool] = ACTIONS(3059),
    [sym_unit] = ACTIONS(3061),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3059),
    [sym_op_identifier] = ACTIONS(3059),
    [anon_sym_PLUS] = ACTIONS(3059),
    [anon_sym_DASH] = ACTIONS(3059),
    [anon_sym_PLUS_DOT] = ACTIONS(3059),
    [anon_sym_DASH_DOT] = ACTIONS(3059),
    [anon_sym_PERCENT] = ACTIONS(3059),
    [anon_sym_AMP_AMP] = ACTIONS(3059),
    [anon_sym_TILDE] = ACTIONS(3061),
    [aux_sym_prefix_op_token1] = ACTIONS(3059),
    [aux_sym_infix_op_token1] = ACTIONS(3061),
    [aux_sym_infix_op_token2] = ACTIONS(3059),
    [anon_sym_PIPE_PIPE] = ACTIONS(3059),
    [anon_sym_BANG_EQ] = ACTIONS(3059),
    [anon_sym_COLON_EQ] = ACTIONS(3061),
    [anon_sym_DOLLAR] = ACTIONS(3059),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3059),
    [sym_int] = ACTIONS(3059),
    [sym_xint] = ACTIONS(3061),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3061),
    [sym__newline] = ACTIONS(3061),
  },
  [1161] = {
    [sym_block_comment] = STATE(1161),
    [sym_compiler_directive_decl] = STATE(1161),
    [sym_fsi_directive_decl] = STATE(1161),
    [sym_preproc_line] = STATE(1161),
    [aux_sym_long_identifier_repeat1] = STATE(1161),
    [sym_identifier] = ACTIONS(2411),
    [anon_sym_EQ] = ACTIONS(2413),
    [anon_sym_COLON] = ACTIONS(2411),
    [anon_sym_return] = ACTIONS(2411),
    [anon_sym_do] = ACTIONS(2411),
    [anon_sym_let] = ACTIONS(2411),
    [anon_sym_let_BANG] = ACTIONS(2413),
    [anon_sym_LPAREN] = ACTIONS(2411),
    [anon_sym_COMMA] = ACTIONS(2413),
    [anon_sym_null] = ACTIONS(2411),
    [anon_sym_QMARK] = ACTIONS(2411),
    [anon_sym_COLON_QMARK] = ACTIONS(2411),
    [anon_sym_COLON_COLON] = ACTIONS(2413),
    [anon_sym_AMP] = ACTIONS(2411),
    [anon_sym_LBRACK] = ACTIONS(2411),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2413),
    [anon_sym_LBRACE] = ACTIONS(2411),
    [anon_sym_LT_AT] = ACTIONS(2411),
    [anon_sym_LT_AT_AT] = ACTIONS(2411),
    [anon_sym_DOT] = ACTIONS(3344),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2413),
    [anon_sym_new] = ACTIONS(2411),
    [anon_sym_return_BANG] = ACTIONS(2413),
    [anon_sym_yield] = ACTIONS(2411),
    [anon_sym_yield_BANG] = ACTIONS(2413),
    [anon_sym_lazy] = ACTIONS(2411),
    [anon_sym_assert] = ACTIONS(2411),
    [anon_sym_upcast] = ACTIONS(2411),
    [anon_sym_downcast] = ACTIONS(2411),
    [anon_sym_COLON_GT] = ACTIONS(2413),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2413),
    [anon_sym_for] = ACTIONS(2411),
    [anon_sym_while] = ACTIONS(2411),
    [anon_sym_if] = ACTIONS(2411),
    [anon_sym_fun] = ACTIONS(2411),
    [anon_sym_DASH_GT] = ACTIONS(2411),
    [anon_sym_try] = ACTIONS(2411),
    [anon_sym_match] = ACTIONS(2411),
    [anon_sym_match_BANG] = ACTIONS(2413),
    [anon_sym_function] = ACTIONS(2411),
    [anon_sym_LT_DASH] = ACTIONS(2411),
    [anon_sym_DOT_LBRACK] = ACTIONS(2413),
    [anon_sym_LT] = ACTIONS(2413),
    [anon_sym_use] = ACTIONS(2411),
    [anon_sym_use_BANG] = ACTIONS(2413),
    [anon_sym_do_BANG] = ACTIONS(2413),
    [anon_sym_begin] = ACTIONS(2411),
    [anon_sym_LPAREN2] = ACTIONS(2411),
    [anon_sym_STAR] = ACTIONS(2411),
    [anon_sym_LT2] = ACTIONS(2411),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2413),
    [anon_sym_or] = ACTIONS(2411),
    [aux_sym_char_token1] = ACTIONS(2413),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2411),
    [anon_sym_DQUOTE] = ACTIONS(2411),
    [anon_sym_AT_DQUOTE] = ACTIONS(2413),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2413),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2413),
    [sym_bool] = ACTIONS(2411),
    [sym_unit] = ACTIONS(2413),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2411),
    [sym_op_identifier] = ACTIONS(2411),
    [anon_sym_PLUS] = ACTIONS(2411),
    [anon_sym_DASH] = ACTIONS(2411),
    [anon_sym_PLUS_DOT] = ACTIONS(2411),
    [anon_sym_DASH_DOT] = ACTIONS(2411),
    [anon_sym_PERCENT] = ACTIONS(2411),
    [anon_sym_AMP_AMP] = ACTIONS(2411),
    [anon_sym_TILDE] = ACTIONS(2413),
    [aux_sym_prefix_op_token1] = ACTIONS(2411),
    [aux_sym_infix_op_token1] = ACTIONS(2413),
    [aux_sym_infix_op_token2] = ACTIONS(2411),
    [anon_sym_PIPE_PIPE] = ACTIONS(2411),
    [anon_sym_BANG_EQ] = ACTIONS(2411),
    [anon_sym_COLON_EQ] = ACTIONS(2413),
    [anon_sym_DOLLAR] = ACTIONS(2411),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2411),
    [sym_int] = ACTIONS(2411),
    [sym_xint] = ACTIONS(2413),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2413),
    [anon_sym_POUNDendif] = ACTIONS(2413),
    [anon_sym_POUNDelse] = ACTIONS(2413),
    [sym__newline] = ACTIONS(2413),
  },
  [1162] = {
    [sym_block_comment] = STATE(1162),
    [sym_compiler_directive_decl] = STATE(1162),
    [sym_fsi_directive_decl] = STATE(1162),
    [sym_preproc_line] = STATE(1162),
    [sym_identifier] = ACTIONS(3095),
    [anon_sym_EQ] = ACTIONS(3097),
    [anon_sym_GT_RBRACK] = ACTIONS(3097),
    [anon_sym_COLON] = ACTIONS(3095),
    [anon_sym_return] = ACTIONS(3095),
    [anon_sym_do] = ACTIONS(3095),
    [anon_sym_let] = ACTIONS(3095),
    [anon_sym_let_BANG] = ACTIONS(3097),
    [anon_sym_LPAREN] = ACTIONS(3095),
    [anon_sym_COMMA] = ACTIONS(3097),
    [anon_sym_null] = ACTIONS(3095),
    [anon_sym_QMARK] = ACTIONS(3095),
    [anon_sym_COLON_QMARK] = ACTIONS(3095),
    [anon_sym_COLON_COLON] = ACTIONS(3097),
    [anon_sym_AMP] = ACTIONS(3095),
    [anon_sym_LBRACK] = ACTIONS(3095),
    [anon_sym_RBRACK] = ACTIONS(3097),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3097),
    [anon_sym_LBRACE] = ACTIONS(3095),
    [anon_sym_RBRACE] = ACTIONS(3097),
    [anon_sym_LT_AT] = ACTIONS(3095),
    [anon_sym_LT_AT_AT] = ACTIONS(3095),
    [anon_sym_DOT] = ACTIONS(3095),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3097),
    [anon_sym_new] = ACTIONS(3095),
    [anon_sym_with] = ACTIONS(3095),
    [anon_sym_return_BANG] = ACTIONS(3097),
    [anon_sym_yield] = ACTIONS(3095),
    [anon_sym_yield_BANG] = ACTIONS(3097),
    [anon_sym_lazy] = ACTIONS(3095),
    [anon_sym_assert] = ACTIONS(3095),
    [anon_sym_upcast] = ACTIONS(3095),
    [anon_sym_downcast] = ACTIONS(3095),
    [anon_sym_COLON_GT] = ACTIONS(3097),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3097),
    [anon_sym_for] = ACTIONS(3095),
    [anon_sym_to] = ACTIONS(3095),
    [anon_sym_downto] = ACTIONS(3095),
    [anon_sym_while] = ACTIONS(3095),
    [anon_sym_if] = ACTIONS(3095),
    [anon_sym_fun] = ACTIONS(3095),
    [anon_sym_try] = ACTIONS(3095),
    [anon_sym_match] = ACTIONS(3095),
    [anon_sym_match_BANG] = ACTIONS(3097),
    [anon_sym_function] = ACTIONS(3095),
    [anon_sym_LT_DASH] = ACTIONS(3095),
    [anon_sym_DOT_LBRACK] = ACTIONS(3097),
    [anon_sym_LT] = ACTIONS(3097),
    [anon_sym_use] = ACTIONS(3095),
    [anon_sym_use_BANG] = ACTIONS(3097),
    [anon_sym_do_BANG] = ACTIONS(3097),
    [anon_sym_begin] = ACTIONS(3095),
    [anon_sym_LPAREN2] = ACTIONS(3095),
    [anon_sym_DOT_DOT2] = ACTIONS(3097),
    [anon_sym_or] = ACTIONS(3095),
    [aux_sym_char_token1] = ACTIONS(3097),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3095),
    [anon_sym_DQUOTE] = ACTIONS(3095),
    [anon_sym_AT_DQUOTE] = ACTIONS(3097),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3097),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3097),
    [sym_bool] = ACTIONS(3095),
    [sym_unit] = ACTIONS(3097),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3095),
    [sym_op_identifier] = ACTIONS(3095),
    [anon_sym_PLUS] = ACTIONS(3095),
    [anon_sym_DASH] = ACTIONS(3095),
    [anon_sym_PLUS_DOT] = ACTIONS(3095),
    [anon_sym_DASH_DOT] = ACTIONS(3095),
    [anon_sym_PERCENT] = ACTIONS(3095),
    [anon_sym_AMP_AMP] = ACTIONS(3095),
    [anon_sym_TILDE] = ACTIONS(3097),
    [aux_sym_prefix_op_token1] = ACTIONS(3095),
    [aux_sym_infix_op_token1] = ACTIONS(3097),
    [aux_sym_infix_op_token2] = ACTIONS(3095),
    [anon_sym_PIPE_PIPE] = ACTIONS(3095),
    [anon_sym_BANG_EQ] = ACTIONS(3095),
    [anon_sym_COLON_EQ] = ACTIONS(3097),
    [anon_sym_DOLLAR] = ACTIONS(3095),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3095),
    [sym_int] = ACTIONS(3095),
    [sym_xint] = ACTIONS(3097),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3097),
    [sym__newline] = ACTIONS(3097),
  },
  [1163] = {
    [sym_block_comment] = STATE(1163),
    [sym_compiler_directive_decl] = STATE(1163),
    [sym_fsi_directive_decl] = STATE(1163),
    [sym_preproc_line] = STATE(1163),
    [aux_sym_compound_type_repeat1] = STATE(1163),
    [sym_identifier] = ACTIONS(2250),
    [anon_sym_EQ] = ACTIONS(2248),
    [anon_sym_COLON] = ACTIONS(2250),
    [anon_sym_return] = ACTIONS(2250),
    [anon_sym_do] = ACTIONS(2250),
    [anon_sym_let] = ACTIONS(2250),
    [anon_sym_let_BANG] = ACTIONS(2248),
    [anon_sym_LPAREN] = ACTIONS(2250),
    [anon_sym_COMMA] = ACTIONS(2248),
    [anon_sym_null] = ACTIONS(2250),
    [anon_sym_QMARK] = ACTIONS(2250),
    [anon_sym_COLON_QMARK] = ACTIONS(2250),
    [anon_sym_COLON_COLON] = ACTIONS(2248),
    [anon_sym_AMP] = ACTIONS(2250),
    [anon_sym_LBRACK] = ACTIONS(2250),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2248),
    [anon_sym_LBRACE] = ACTIONS(2250),
    [anon_sym_LT_AT] = ACTIONS(2250),
    [anon_sym_LT_AT_AT] = ACTIONS(2250),
    [anon_sym_DOT] = ACTIONS(2250),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2248),
    [anon_sym_new] = ACTIONS(2250),
    [anon_sym_return_BANG] = ACTIONS(2248),
    [anon_sym_yield] = ACTIONS(2250),
    [anon_sym_yield_BANG] = ACTIONS(2248),
    [anon_sym_lazy] = ACTIONS(2250),
    [anon_sym_assert] = ACTIONS(2250),
    [anon_sym_upcast] = ACTIONS(2250),
    [anon_sym_downcast] = ACTIONS(2250),
    [anon_sym_COLON_GT] = ACTIONS(2248),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2248),
    [anon_sym_for] = ACTIONS(2250),
    [anon_sym_while] = ACTIONS(2250),
    [anon_sym_if] = ACTIONS(2250),
    [anon_sym_fun] = ACTIONS(2250),
    [anon_sym_DASH_GT] = ACTIONS(2250),
    [anon_sym_try] = ACTIONS(2250),
    [anon_sym_match] = ACTIONS(2250),
    [anon_sym_match_BANG] = ACTIONS(2248),
    [anon_sym_function] = ACTIONS(2250),
    [anon_sym_LT_DASH] = ACTIONS(2250),
    [anon_sym_DOT_LBRACK] = ACTIONS(2248),
    [anon_sym_LT] = ACTIONS(2248),
    [anon_sym_use] = ACTIONS(2250),
    [anon_sym_use_BANG] = ACTIONS(2248),
    [anon_sym_do_BANG] = ACTIONS(2248),
    [anon_sym_begin] = ACTIONS(2250),
    [anon_sym_LPAREN2] = ACTIONS(2250),
    [anon_sym_STAR] = ACTIONS(3347),
    [anon_sym_LT2] = ACTIONS(2250),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2248),
    [anon_sym_or] = ACTIONS(2250),
    [aux_sym_char_token1] = ACTIONS(2248),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2250),
    [anon_sym_DQUOTE] = ACTIONS(2250),
    [anon_sym_AT_DQUOTE] = ACTIONS(2248),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2248),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2248),
    [sym_bool] = ACTIONS(2250),
    [sym_unit] = ACTIONS(2248),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2250),
    [sym_op_identifier] = ACTIONS(2250),
    [anon_sym_PLUS] = ACTIONS(2250),
    [anon_sym_DASH] = ACTIONS(2250),
    [anon_sym_PLUS_DOT] = ACTIONS(2250),
    [anon_sym_DASH_DOT] = ACTIONS(2250),
    [anon_sym_PERCENT] = ACTIONS(2250),
    [anon_sym_AMP_AMP] = ACTIONS(2250),
    [anon_sym_TILDE] = ACTIONS(2248),
    [aux_sym_prefix_op_token1] = ACTIONS(2250),
    [aux_sym_infix_op_token1] = ACTIONS(2248),
    [aux_sym_infix_op_token2] = ACTIONS(2250),
    [anon_sym_PIPE_PIPE] = ACTIONS(2250),
    [anon_sym_BANG_EQ] = ACTIONS(2250),
    [anon_sym_COLON_EQ] = ACTIONS(2248),
    [anon_sym_DOLLAR] = ACTIONS(2250),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2250),
    [sym_int] = ACTIONS(2250),
    [sym_xint] = ACTIONS(2248),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2248),
    [anon_sym_POUNDendif] = ACTIONS(2248),
    [anon_sym_POUNDelse] = ACTIONS(2248),
    [sym__newline] = ACTIONS(2248),
  },
  [1164] = {
    [sym_block_comment] = STATE(1164),
    [sym_compiler_directive_decl] = STATE(1164),
    [sym_fsi_directive_decl] = STATE(1164),
    [sym_preproc_line] = STATE(1164),
    [sym_identifier] = ACTIONS(3063),
    [anon_sym_EQ] = ACTIONS(3065),
    [anon_sym_GT_RBRACK] = ACTIONS(3065),
    [anon_sym_COLON] = ACTIONS(3063),
    [anon_sym_return] = ACTIONS(3063),
    [anon_sym_do] = ACTIONS(3063),
    [anon_sym_let] = ACTIONS(3063),
    [anon_sym_let_BANG] = ACTIONS(3065),
    [anon_sym_LPAREN] = ACTIONS(3063),
    [anon_sym_COMMA] = ACTIONS(3065),
    [anon_sym_null] = ACTIONS(3063),
    [anon_sym_QMARK] = ACTIONS(3063),
    [anon_sym_COLON_QMARK] = ACTIONS(3063),
    [anon_sym_COLON_COLON] = ACTIONS(3065),
    [anon_sym_AMP] = ACTIONS(3063),
    [anon_sym_LBRACK] = ACTIONS(3063),
    [anon_sym_RBRACK] = ACTIONS(3065),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3065),
    [anon_sym_LBRACE] = ACTIONS(3063),
    [anon_sym_RBRACE] = ACTIONS(3065),
    [anon_sym_LT_AT] = ACTIONS(3063),
    [anon_sym_LT_AT_AT] = ACTIONS(3063),
    [anon_sym_DOT] = ACTIONS(3063),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3065),
    [anon_sym_new] = ACTIONS(3063),
    [anon_sym_with] = ACTIONS(3063),
    [anon_sym_return_BANG] = ACTIONS(3065),
    [anon_sym_yield] = ACTIONS(3063),
    [anon_sym_yield_BANG] = ACTIONS(3065),
    [anon_sym_lazy] = ACTIONS(3063),
    [anon_sym_assert] = ACTIONS(3063),
    [anon_sym_upcast] = ACTIONS(3063),
    [anon_sym_downcast] = ACTIONS(3063),
    [anon_sym_COLON_GT] = ACTIONS(3065),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3065),
    [anon_sym_for] = ACTIONS(3063),
    [anon_sym_to] = ACTIONS(3063),
    [anon_sym_downto] = ACTIONS(3063),
    [anon_sym_while] = ACTIONS(3063),
    [anon_sym_if] = ACTIONS(3063),
    [anon_sym_fun] = ACTIONS(3063),
    [anon_sym_try] = ACTIONS(3063),
    [anon_sym_match] = ACTIONS(3063),
    [anon_sym_match_BANG] = ACTIONS(3065),
    [anon_sym_function] = ACTIONS(3063),
    [anon_sym_LT_DASH] = ACTIONS(3063),
    [anon_sym_DOT_LBRACK] = ACTIONS(3065),
    [anon_sym_LT] = ACTIONS(3065),
    [anon_sym_use] = ACTIONS(3063),
    [anon_sym_use_BANG] = ACTIONS(3065),
    [anon_sym_do_BANG] = ACTIONS(3065),
    [anon_sym_begin] = ACTIONS(3063),
    [anon_sym_LPAREN2] = ACTIONS(3063),
    [anon_sym_DOT_DOT2] = ACTIONS(3065),
    [anon_sym_or] = ACTIONS(3063),
    [aux_sym_char_token1] = ACTIONS(3065),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3063),
    [anon_sym_DQUOTE] = ACTIONS(3063),
    [anon_sym_AT_DQUOTE] = ACTIONS(3065),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3065),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3065),
    [sym_bool] = ACTIONS(3063),
    [sym_unit] = ACTIONS(3065),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3063),
    [sym_op_identifier] = ACTIONS(3063),
    [anon_sym_PLUS] = ACTIONS(3063),
    [anon_sym_DASH] = ACTIONS(3063),
    [anon_sym_PLUS_DOT] = ACTIONS(3063),
    [anon_sym_DASH_DOT] = ACTIONS(3063),
    [anon_sym_PERCENT] = ACTIONS(3063),
    [anon_sym_AMP_AMP] = ACTIONS(3063),
    [anon_sym_TILDE] = ACTIONS(3065),
    [aux_sym_prefix_op_token1] = ACTIONS(3063),
    [aux_sym_infix_op_token1] = ACTIONS(3065),
    [aux_sym_infix_op_token2] = ACTIONS(3063),
    [anon_sym_PIPE_PIPE] = ACTIONS(3063),
    [anon_sym_BANG_EQ] = ACTIONS(3063),
    [anon_sym_COLON_EQ] = ACTIONS(3065),
    [anon_sym_DOLLAR] = ACTIONS(3063),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3063),
    [sym_int] = ACTIONS(3063),
    [sym_xint] = ACTIONS(3065),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3065),
    [sym__newline] = ACTIONS(3065),
  },
  [1165] = {
    [sym_block_comment] = STATE(1165),
    [sym_compiler_directive_decl] = STATE(1165),
    [sym_fsi_directive_decl] = STATE(1165),
    [sym_preproc_line] = STATE(1165),
    [aux_sym_long_identifier_repeat1] = STATE(1161),
    [sym_identifier] = ACTIONS(2418),
    [anon_sym_EQ] = ACTIONS(2420),
    [anon_sym_COLON] = ACTIONS(2418),
    [anon_sym_return] = ACTIONS(2418),
    [anon_sym_do] = ACTIONS(2418),
    [anon_sym_let] = ACTIONS(2418),
    [anon_sym_let_BANG] = ACTIONS(2420),
    [anon_sym_LPAREN] = ACTIONS(2418),
    [anon_sym_COMMA] = ACTIONS(2420),
    [anon_sym_null] = ACTIONS(2418),
    [anon_sym_QMARK] = ACTIONS(2418),
    [anon_sym_COLON_QMARK] = ACTIONS(2418),
    [anon_sym_COLON_COLON] = ACTIONS(2420),
    [anon_sym_AMP] = ACTIONS(2418),
    [anon_sym_LBRACK] = ACTIONS(2418),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2420),
    [anon_sym_LBRACE] = ACTIONS(2418),
    [anon_sym_LT_AT] = ACTIONS(2418),
    [anon_sym_LT_AT_AT] = ACTIONS(2418),
    [anon_sym_DOT] = ACTIONS(3287),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2420),
    [anon_sym_new] = ACTIONS(2418),
    [anon_sym_return_BANG] = ACTIONS(2420),
    [anon_sym_yield] = ACTIONS(2418),
    [anon_sym_yield_BANG] = ACTIONS(2420),
    [anon_sym_lazy] = ACTIONS(2418),
    [anon_sym_assert] = ACTIONS(2418),
    [anon_sym_upcast] = ACTIONS(2418),
    [anon_sym_downcast] = ACTIONS(2418),
    [anon_sym_COLON_GT] = ACTIONS(2420),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2420),
    [anon_sym_for] = ACTIONS(2418),
    [anon_sym_while] = ACTIONS(2418),
    [anon_sym_if] = ACTIONS(2418),
    [anon_sym_fun] = ACTIONS(2418),
    [anon_sym_DASH_GT] = ACTIONS(2418),
    [anon_sym_try] = ACTIONS(2418),
    [anon_sym_match] = ACTIONS(2418),
    [anon_sym_match_BANG] = ACTIONS(2420),
    [anon_sym_function] = ACTIONS(2418),
    [anon_sym_LT_DASH] = ACTIONS(2418),
    [anon_sym_DOT_LBRACK] = ACTIONS(2420),
    [anon_sym_LT] = ACTIONS(2420),
    [anon_sym_use] = ACTIONS(2418),
    [anon_sym_use_BANG] = ACTIONS(2420),
    [anon_sym_do_BANG] = ACTIONS(2420),
    [anon_sym_begin] = ACTIONS(2418),
    [anon_sym_LPAREN2] = ACTIONS(2418),
    [anon_sym_STAR] = ACTIONS(2418),
    [anon_sym_LT2] = ACTIONS(2418),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2420),
    [anon_sym_or] = ACTIONS(2418),
    [aux_sym_char_token1] = ACTIONS(2420),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2418),
    [anon_sym_DQUOTE] = ACTIONS(2418),
    [anon_sym_AT_DQUOTE] = ACTIONS(2420),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2420),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2420),
    [sym_bool] = ACTIONS(2418),
    [sym_unit] = ACTIONS(2420),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2418),
    [sym_op_identifier] = ACTIONS(2418),
    [anon_sym_PLUS] = ACTIONS(2418),
    [anon_sym_DASH] = ACTIONS(2418),
    [anon_sym_PLUS_DOT] = ACTIONS(2418),
    [anon_sym_DASH_DOT] = ACTIONS(2418),
    [anon_sym_PERCENT] = ACTIONS(2418),
    [anon_sym_AMP_AMP] = ACTIONS(2418),
    [anon_sym_TILDE] = ACTIONS(2420),
    [aux_sym_prefix_op_token1] = ACTIONS(2418),
    [aux_sym_infix_op_token1] = ACTIONS(2420),
    [aux_sym_infix_op_token2] = ACTIONS(2418),
    [anon_sym_PIPE_PIPE] = ACTIONS(2418),
    [anon_sym_BANG_EQ] = ACTIONS(2418),
    [anon_sym_COLON_EQ] = ACTIONS(2420),
    [anon_sym_DOLLAR] = ACTIONS(2418),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2418),
    [sym_int] = ACTIONS(2418),
    [sym_xint] = ACTIONS(2420),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2420),
    [anon_sym_POUNDendif] = ACTIONS(2420),
    [anon_sym_POUNDelse] = ACTIONS(2420),
    [sym__newline] = ACTIONS(2420),
  },
  [1166] = {
    [sym_block_comment] = STATE(1166),
    [sym_compiler_directive_decl] = STATE(1166),
    [sym_fsi_directive_decl] = STATE(1166),
    [sym_preproc_line] = STATE(1166),
    [sym_identifier] = ACTIONS(3079),
    [anon_sym_EQ] = ACTIONS(3081),
    [anon_sym_GT_RBRACK] = ACTIONS(3081),
    [anon_sym_COLON] = ACTIONS(3079),
    [anon_sym_return] = ACTIONS(3079),
    [anon_sym_do] = ACTIONS(3079),
    [anon_sym_let] = ACTIONS(3079),
    [anon_sym_let_BANG] = ACTIONS(3081),
    [anon_sym_LPAREN] = ACTIONS(3079),
    [anon_sym_COMMA] = ACTIONS(3081),
    [anon_sym_null] = ACTIONS(3079),
    [anon_sym_QMARK] = ACTIONS(3079),
    [anon_sym_COLON_QMARK] = ACTIONS(3079),
    [anon_sym_COLON_COLON] = ACTIONS(3081),
    [anon_sym_AMP] = ACTIONS(3079),
    [anon_sym_LBRACK] = ACTIONS(3079),
    [anon_sym_RBRACK] = ACTIONS(3081),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3081),
    [anon_sym_LBRACE] = ACTIONS(3079),
    [anon_sym_RBRACE] = ACTIONS(3081),
    [anon_sym_LT_AT] = ACTIONS(3079),
    [anon_sym_LT_AT_AT] = ACTIONS(3079),
    [anon_sym_DOT] = ACTIONS(3079),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3081),
    [anon_sym_new] = ACTIONS(3079),
    [anon_sym_with] = ACTIONS(3079),
    [anon_sym_return_BANG] = ACTIONS(3081),
    [anon_sym_yield] = ACTIONS(3079),
    [anon_sym_yield_BANG] = ACTIONS(3081),
    [anon_sym_lazy] = ACTIONS(3079),
    [anon_sym_assert] = ACTIONS(3079),
    [anon_sym_upcast] = ACTIONS(3079),
    [anon_sym_downcast] = ACTIONS(3079),
    [anon_sym_COLON_GT] = ACTIONS(3081),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3081),
    [anon_sym_for] = ACTIONS(3079),
    [anon_sym_to] = ACTIONS(3079),
    [anon_sym_downto] = ACTIONS(3079),
    [anon_sym_while] = ACTIONS(3079),
    [anon_sym_if] = ACTIONS(3079),
    [anon_sym_fun] = ACTIONS(3079),
    [anon_sym_try] = ACTIONS(3079),
    [anon_sym_match] = ACTIONS(3079),
    [anon_sym_match_BANG] = ACTIONS(3081),
    [anon_sym_function] = ACTIONS(3079),
    [anon_sym_LT_DASH] = ACTIONS(3079),
    [anon_sym_DOT_LBRACK] = ACTIONS(3081),
    [anon_sym_LT] = ACTIONS(3081),
    [anon_sym_use] = ACTIONS(3079),
    [anon_sym_use_BANG] = ACTIONS(3081),
    [anon_sym_do_BANG] = ACTIONS(3081),
    [anon_sym_begin] = ACTIONS(3079),
    [anon_sym_LPAREN2] = ACTIONS(3079),
    [anon_sym_DOT_DOT2] = ACTIONS(3081),
    [anon_sym_or] = ACTIONS(3079),
    [aux_sym_char_token1] = ACTIONS(3081),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3079),
    [anon_sym_DQUOTE] = ACTIONS(3079),
    [anon_sym_AT_DQUOTE] = ACTIONS(3081),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3081),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3081),
    [sym_bool] = ACTIONS(3079),
    [sym_unit] = ACTIONS(3081),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3079),
    [sym_op_identifier] = ACTIONS(3079),
    [anon_sym_PLUS] = ACTIONS(3079),
    [anon_sym_DASH] = ACTIONS(3079),
    [anon_sym_PLUS_DOT] = ACTIONS(3079),
    [anon_sym_DASH_DOT] = ACTIONS(3079),
    [anon_sym_PERCENT] = ACTIONS(3079),
    [anon_sym_AMP_AMP] = ACTIONS(3079),
    [anon_sym_TILDE] = ACTIONS(3081),
    [aux_sym_prefix_op_token1] = ACTIONS(3079),
    [aux_sym_infix_op_token1] = ACTIONS(3081),
    [aux_sym_infix_op_token2] = ACTIONS(3079),
    [anon_sym_PIPE_PIPE] = ACTIONS(3079),
    [anon_sym_BANG_EQ] = ACTIONS(3079),
    [anon_sym_COLON_EQ] = ACTIONS(3081),
    [anon_sym_DOLLAR] = ACTIONS(3079),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3079),
    [sym_int] = ACTIONS(3079),
    [sym_xint] = ACTIONS(3081),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3081),
    [sym__newline] = ACTIONS(3081),
  },
  [1167] = {
    [sym_block_comment] = STATE(1167),
    [sym_compiler_directive_decl] = STATE(1167),
    [sym_fsi_directive_decl] = STATE(1167),
    [sym_preproc_line] = STATE(1167),
    [aux_sym_long_identifier_repeat1] = STATE(1170),
    [sym_identifier] = ACTIONS(2418),
    [anon_sym_EQ] = ACTIONS(2420),
    [anon_sym_COLON] = ACTIONS(2418),
    [anon_sym_return] = ACTIONS(2418),
    [anon_sym_do] = ACTIONS(2418),
    [anon_sym_let] = ACTIONS(2418),
    [anon_sym_let_BANG] = ACTIONS(2420),
    [anon_sym_as] = ACTIONS(2418),
    [anon_sym_LPAREN] = ACTIONS(2418),
    [anon_sym_COMMA] = ACTIONS(2420),
    [anon_sym_null] = ACTIONS(2418),
    [anon_sym_QMARK] = ACTIONS(2418),
    [anon_sym_COLON_QMARK] = ACTIONS(2418),
    [anon_sym_COLON_COLON] = ACTIONS(2420),
    [anon_sym_AMP] = ACTIONS(2418),
    [anon_sym_LBRACK] = ACTIONS(2418),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2420),
    [anon_sym_LBRACE] = ACTIONS(2418),
    [anon_sym_LT_AT] = ACTIONS(2418),
    [anon_sym_LT_AT_AT] = ACTIONS(2418),
    [anon_sym_DOT] = ACTIONS(3306),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2420),
    [anon_sym_new] = ACTIONS(2418),
    [anon_sym_with] = ACTIONS(2418),
    [anon_sym_return_BANG] = ACTIONS(2420),
    [anon_sym_yield] = ACTIONS(2418),
    [anon_sym_yield_BANG] = ACTIONS(2420),
    [anon_sym_lazy] = ACTIONS(2418),
    [anon_sym_assert] = ACTIONS(2418),
    [anon_sym_upcast] = ACTIONS(2418),
    [anon_sym_downcast] = ACTIONS(2418),
    [anon_sym_COLON_GT] = ACTIONS(2420),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2420),
    [anon_sym_for] = ACTIONS(2418),
    [anon_sym_while] = ACTIONS(2418),
    [anon_sym_if] = ACTIONS(2418),
    [anon_sym_fun] = ACTIONS(2418),
    [anon_sym_DASH_GT] = ACTIONS(2418),
    [anon_sym_try] = ACTIONS(2418),
    [anon_sym_match] = ACTIONS(2418),
    [anon_sym_match_BANG] = ACTIONS(2420),
    [anon_sym_function] = ACTIONS(2418),
    [anon_sym_LT_DASH] = ACTIONS(2418),
    [anon_sym_DOT_LBRACK] = ACTIONS(2420),
    [anon_sym_LT] = ACTIONS(2420),
    [anon_sym_use] = ACTIONS(2418),
    [anon_sym_use_BANG] = ACTIONS(2420),
    [anon_sym_do_BANG] = ACTIONS(2420),
    [anon_sym_begin] = ACTIONS(2418),
    [anon_sym_LPAREN2] = ACTIONS(2418),
    [anon_sym_STAR] = ACTIONS(2418),
    [anon_sym_LT2] = ACTIONS(2418),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2420),
    [anon_sym_or] = ACTIONS(2418),
    [aux_sym_char_token1] = ACTIONS(2420),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2418),
    [anon_sym_DQUOTE] = ACTIONS(2418),
    [anon_sym_AT_DQUOTE] = ACTIONS(2420),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2420),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2420),
    [sym_bool] = ACTIONS(2418),
    [sym_unit] = ACTIONS(2420),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2418),
    [sym_op_identifier] = ACTIONS(2418),
    [anon_sym_PLUS] = ACTIONS(2418),
    [anon_sym_DASH] = ACTIONS(2418),
    [anon_sym_PLUS_DOT] = ACTIONS(2418),
    [anon_sym_DASH_DOT] = ACTIONS(2418),
    [anon_sym_PERCENT] = ACTIONS(2418),
    [anon_sym_AMP_AMP] = ACTIONS(2418),
    [anon_sym_TILDE] = ACTIONS(2420),
    [aux_sym_prefix_op_token1] = ACTIONS(2418),
    [aux_sym_infix_op_token1] = ACTIONS(2420),
    [aux_sym_infix_op_token2] = ACTIONS(2418),
    [anon_sym_PIPE_PIPE] = ACTIONS(2418),
    [anon_sym_BANG_EQ] = ACTIONS(2418),
    [anon_sym_COLON_EQ] = ACTIONS(2420),
    [anon_sym_DOLLAR] = ACTIONS(2418),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2418),
    [sym_int] = ACTIONS(2418),
    [sym_xint] = ACTIONS(2420),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2420),
    [sym__newline] = ACTIONS(2420),
  },
  [1168] = {
    [sym_block_comment] = STATE(1168),
    [sym_compiler_directive_decl] = STATE(1168),
    [sym_fsi_directive_decl] = STATE(1168),
    [sym_preproc_line] = STATE(1168),
    [sym_identifier] = ACTIONS(2567),
    [anon_sym_EQ] = ACTIONS(2569),
    [anon_sym_COLON] = ACTIONS(2567),
    [anon_sym_return] = ACTIONS(2567),
    [anon_sym_do] = ACTIONS(2567),
    [anon_sym_let] = ACTIONS(2567),
    [anon_sym_let_BANG] = ACTIONS(2569),
    [anon_sym_as] = ACTIONS(2567),
    [anon_sym_LPAREN] = ACTIONS(2567),
    [anon_sym_COMMA] = ACTIONS(2569),
    [anon_sym_null] = ACTIONS(2567),
    [anon_sym_QMARK] = ACTIONS(2567),
    [anon_sym_COLON_QMARK] = ACTIONS(2567),
    [anon_sym_COLON_COLON] = ACTIONS(2569),
    [anon_sym_AMP] = ACTIONS(2567),
    [anon_sym_LBRACK] = ACTIONS(2567),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2569),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_LT_AT] = ACTIONS(2567),
    [anon_sym_LT_AT_AT] = ACTIONS(2567),
    [anon_sym_DOT] = ACTIONS(2567),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2569),
    [anon_sym_new] = ACTIONS(2567),
    [anon_sym_with] = ACTIONS(2567),
    [anon_sym_return_BANG] = ACTIONS(2569),
    [anon_sym_yield] = ACTIONS(2567),
    [anon_sym_yield_BANG] = ACTIONS(2569),
    [anon_sym_lazy] = ACTIONS(2567),
    [anon_sym_assert] = ACTIONS(2567),
    [anon_sym_upcast] = ACTIONS(2567),
    [anon_sym_downcast] = ACTIONS(2567),
    [anon_sym_COLON_GT] = ACTIONS(2569),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2569),
    [anon_sym_for] = ACTIONS(2567),
    [anon_sym_while] = ACTIONS(2567),
    [anon_sym_if] = ACTIONS(2567),
    [anon_sym_fun] = ACTIONS(2567),
    [anon_sym_DASH_GT] = ACTIONS(2567),
    [anon_sym_try] = ACTIONS(2567),
    [anon_sym_match] = ACTIONS(2567),
    [anon_sym_match_BANG] = ACTIONS(2569),
    [anon_sym_function] = ACTIONS(2567),
    [anon_sym_LT_DASH] = ACTIONS(2567),
    [anon_sym_DOT_LBRACK] = ACTIONS(2569),
    [anon_sym_LT] = ACTIONS(2569),
    [anon_sym_use] = ACTIONS(2567),
    [anon_sym_use_BANG] = ACTIONS(2569),
    [anon_sym_do_BANG] = ACTIONS(2569),
    [anon_sym_begin] = ACTIONS(2567),
    [anon_sym_LPAREN2] = ACTIONS(2567),
    [anon_sym_STAR] = ACTIONS(2567),
    [anon_sym_LT2] = ACTIONS(2567),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2569),
    [anon_sym_or] = ACTIONS(2567),
    [aux_sym_char_token1] = ACTIONS(2569),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2567),
    [anon_sym_DQUOTE] = ACTIONS(2567),
    [anon_sym_AT_DQUOTE] = ACTIONS(2569),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2569),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2569),
    [sym_bool] = ACTIONS(2567),
    [sym_unit] = ACTIONS(2569),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2567),
    [sym_op_identifier] = ACTIONS(2567),
    [anon_sym_PLUS] = ACTIONS(2567),
    [anon_sym_DASH] = ACTIONS(2567),
    [anon_sym_PLUS_DOT] = ACTIONS(2567),
    [anon_sym_DASH_DOT] = ACTIONS(2567),
    [anon_sym_PERCENT] = ACTIONS(2567),
    [anon_sym_AMP_AMP] = ACTIONS(2567),
    [anon_sym_TILDE] = ACTIONS(2569),
    [aux_sym_prefix_op_token1] = ACTIONS(2567),
    [aux_sym_infix_op_token1] = ACTIONS(2569),
    [aux_sym_infix_op_token2] = ACTIONS(2567),
    [anon_sym_PIPE_PIPE] = ACTIONS(2567),
    [anon_sym_BANG_EQ] = ACTIONS(2567),
    [anon_sym_COLON_EQ] = ACTIONS(2569),
    [anon_sym_DOLLAR] = ACTIONS(2567),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2567),
    [sym_int] = ACTIONS(2567),
    [sym_xint] = ACTIONS(2569),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2569),
    [sym__newline] = ACTIONS(2569),
    [sym__dedent] = ACTIONS(2569),
  },
  [1169] = {
    [sym_block_comment] = STATE(1169),
    [sym_compiler_directive_decl] = STATE(1169),
    [sym_fsi_directive_decl] = STATE(1169),
    [sym_preproc_line] = STATE(1169),
    [sym_identifier] = ACTIONS(2557),
    [anon_sym_EQ] = ACTIONS(2559),
    [anon_sym_COLON] = ACTIONS(2557),
    [anon_sym_return] = ACTIONS(2557),
    [anon_sym_do] = ACTIONS(2557),
    [anon_sym_let] = ACTIONS(2557),
    [anon_sym_let_BANG] = ACTIONS(2559),
    [anon_sym_as] = ACTIONS(2557),
    [anon_sym_LPAREN] = ACTIONS(2557),
    [anon_sym_COMMA] = ACTIONS(2559),
    [anon_sym_null] = ACTIONS(2557),
    [anon_sym_QMARK] = ACTIONS(2557),
    [anon_sym_COLON_QMARK] = ACTIONS(2557),
    [anon_sym_COLON_COLON] = ACTIONS(2559),
    [anon_sym_AMP] = ACTIONS(2557),
    [anon_sym_LBRACK] = ACTIONS(2557),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2559),
    [anon_sym_LBRACE] = ACTIONS(2557),
    [anon_sym_LT_AT] = ACTIONS(2557),
    [anon_sym_LT_AT_AT] = ACTIONS(2557),
    [anon_sym_DOT] = ACTIONS(2557),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2559),
    [anon_sym_new] = ACTIONS(2557),
    [anon_sym_with] = ACTIONS(2557),
    [anon_sym_return_BANG] = ACTIONS(2559),
    [anon_sym_yield] = ACTIONS(2557),
    [anon_sym_yield_BANG] = ACTIONS(2559),
    [anon_sym_lazy] = ACTIONS(2557),
    [anon_sym_assert] = ACTIONS(2557),
    [anon_sym_upcast] = ACTIONS(2557),
    [anon_sym_downcast] = ACTIONS(2557),
    [anon_sym_COLON_GT] = ACTIONS(2559),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2559),
    [anon_sym_for] = ACTIONS(2557),
    [anon_sym_while] = ACTIONS(2557),
    [anon_sym_if] = ACTIONS(2557),
    [anon_sym_fun] = ACTIONS(2557),
    [anon_sym_DASH_GT] = ACTIONS(2557),
    [anon_sym_try] = ACTIONS(2557),
    [anon_sym_match] = ACTIONS(2557),
    [anon_sym_match_BANG] = ACTIONS(2559),
    [anon_sym_function] = ACTIONS(2557),
    [anon_sym_LT_DASH] = ACTIONS(2557),
    [anon_sym_DOT_LBRACK] = ACTIONS(2559),
    [anon_sym_LT] = ACTIONS(2559),
    [anon_sym_use] = ACTIONS(2557),
    [anon_sym_use_BANG] = ACTIONS(2559),
    [anon_sym_do_BANG] = ACTIONS(2559),
    [anon_sym_begin] = ACTIONS(2557),
    [anon_sym_LPAREN2] = ACTIONS(2557),
    [anon_sym_STAR] = ACTIONS(2557),
    [anon_sym_LT2] = ACTIONS(3350),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2559),
    [anon_sym_or] = ACTIONS(2557),
    [aux_sym_char_token1] = ACTIONS(2559),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2557),
    [anon_sym_DQUOTE] = ACTIONS(2557),
    [anon_sym_AT_DQUOTE] = ACTIONS(2559),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2559),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2559),
    [sym_bool] = ACTIONS(2557),
    [sym_unit] = ACTIONS(2559),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2557),
    [sym_op_identifier] = ACTIONS(2557),
    [anon_sym_PLUS] = ACTIONS(2557),
    [anon_sym_DASH] = ACTIONS(2557),
    [anon_sym_PLUS_DOT] = ACTIONS(2557),
    [anon_sym_DASH_DOT] = ACTIONS(2557),
    [anon_sym_PERCENT] = ACTIONS(2557),
    [anon_sym_AMP_AMP] = ACTIONS(2557),
    [anon_sym_TILDE] = ACTIONS(2559),
    [aux_sym_prefix_op_token1] = ACTIONS(2557),
    [aux_sym_infix_op_token1] = ACTIONS(2559),
    [aux_sym_infix_op_token2] = ACTIONS(2557),
    [anon_sym_PIPE_PIPE] = ACTIONS(2557),
    [anon_sym_BANG_EQ] = ACTIONS(2557),
    [anon_sym_COLON_EQ] = ACTIONS(2559),
    [anon_sym_DOLLAR] = ACTIONS(2557),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2557),
    [sym_int] = ACTIONS(2557),
    [sym_xint] = ACTIONS(2559),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2559),
    [sym__newline] = ACTIONS(2559),
    [sym__dedent] = ACTIONS(2559),
  },
  [1170] = {
    [sym_block_comment] = STATE(1170),
    [sym_compiler_directive_decl] = STATE(1170),
    [sym_fsi_directive_decl] = STATE(1170),
    [sym_preproc_line] = STATE(1170),
    [aux_sym_long_identifier_repeat1] = STATE(1170),
    [sym_identifier] = ACTIONS(2411),
    [anon_sym_EQ] = ACTIONS(2413),
    [anon_sym_COLON] = ACTIONS(2411),
    [anon_sym_return] = ACTIONS(2411),
    [anon_sym_do] = ACTIONS(2411),
    [anon_sym_let] = ACTIONS(2411),
    [anon_sym_let_BANG] = ACTIONS(2413),
    [anon_sym_as] = ACTIONS(2411),
    [anon_sym_LPAREN] = ACTIONS(2411),
    [anon_sym_COMMA] = ACTIONS(2413),
    [anon_sym_null] = ACTIONS(2411),
    [anon_sym_QMARK] = ACTIONS(2411),
    [anon_sym_COLON_QMARK] = ACTIONS(2411),
    [anon_sym_COLON_COLON] = ACTIONS(2413),
    [anon_sym_AMP] = ACTIONS(2411),
    [anon_sym_LBRACK] = ACTIONS(2411),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2413),
    [anon_sym_LBRACE] = ACTIONS(2411),
    [anon_sym_LT_AT] = ACTIONS(2411),
    [anon_sym_LT_AT_AT] = ACTIONS(2411),
    [anon_sym_DOT] = ACTIONS(3352),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2413),
    [anon_sym_new] = ACTIONS(2411),
    [anon_sym_with] = ACTIONS(2411),
    [anon_sym_return_BANG] = ACTIONS(2413),
    [anon_sym_yield] = ACTIONS(2411),
    [anon_sym_yield_BANG] = ACTIONS(2413),
    [anon_sym_lazy] = ACTIONS(2411),
    [anon_sym_assert] = ACTIONS(2411),
    [anon_sym_upcast] = ACTIONS(2411),
    [anon_sym_downcast] = ACTIONS(2411),
    [anon_sym_COLON_GT] = ACTIONS(2413),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2413),
    [anon_sym_for] = ACTIONS(2411),
    [anon_sym_while] = ACTIONS(2411),
    [anon_sym_if] = ACTIONS(2411),
    [anon_sym_fun] = ACTIONS(2411),
    [anon_sym_DASH_GT] = ACTIONS(2411),
    [anon_sym_try] = ACTIONS(2411),
    [anon_sym_match] = ACTIONS(2411),
    [anon_sym_match_BANG] = ACTIONS(2413),
    [anon_sym_function] = ACTIONS(2411),
    [anon_sym_LT_DASH] = ACTIONS(2411),
    [anon_sym_DOT_LBRACK] = ACTIONS(2413),
    [anon_sym_LT] = ACTIONS(2413),
    [anon_sym_use] = ACTIONS(2411),
    [anon_sym_use_BANG] = ACTIONS(2413),
    [anon_sym_do_BANG] = ACTIONS(2413),
    [anon_sym_begin] = ACTIONS(2411),
    [anon_sym_LPAREN2] = ACTIONS(2411),
    [anon_sym_STAR] = ACTIONS(2411),
    [anon_sym_LT2] = ACTIONS(2411),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2413),
    [anon_sym_or] = ACTIONS(2411),
    [aux_sym_char_token1] = ACTIONS(2413),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2411),
    [anon_sym_DQUOTE] = ACTIONS(2411),
    [anon_sym_AT_DQUOTE] = ACTIONS(2413),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2413),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2413),
    [sym_bool] = ACTIONS(2411),
    [sym_unit] = ACTIONS(2413),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2411),
    [sym_op_identifier] = ACTIONS(2411),
    [anon_sym_PLUS] = ACTIONS(2411),
    [anon_sym_DASH] = ACTIONS(2411),
    [anon_sym_PLUS_DOT] = ACTIONS(2411),
    [anon_sym_DASH_DOT] = ACTIONS(2411),
    [anon_sym_PERCENT] = ACTIONS(2411),
    [anon_sym_AMP_AMP] = ACTIONS(2411),
    [anon_sym_TILDE] = ACTIONS(2413),
    [aux_sym_prefix_op_token1] = ACTIONS(2411),
    [aux_sym_infix_op_token1] = ACTIONS(2413),
    [aux_sym_infix_op_token2] = ACTIONS(2411),
    [anon_sym_PIPE_PIPE] = ACTIONS(2411),
    [anon_sym_BANG_EQ] = ACTIONS(2411),
    [anon_sym_COLON_EQ] = ACTIONS(2413),
    [anon_sym_DOLLAR] = ACTIONS(2411),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2411),
    [sym_int] = ACTIONS(2411),
    [sym_xint] = ACTIONS(2413),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2413),
    [sym__newline] = ACTIONS(2413),
  },
  [1171] = {
    [sym_block_comment] = STATE(1171),
    [sym_compiler_directive_decl] = STATE(1171),
    [sym_fsi_directive_decl] = STATE(1171),
    [sym_preproc_line] = STATE(1171),
    [sym_identifier] = ACTIONS(3083),
    [anon_sym_EQ] = ACTIONS(3085),
    [anon_sym_GT_RBRACK] = ACTIONS(3085),
    [anon_sym_COLON] = ACTIONS(3083),
    [anon_sym_return] = ACTIONS(3083),
    [anon_sym_do] = ACTIONS(3083),
    [anon_sym_let] = ACTIONS(3083),
    [anon_sym_let_BANG] = ACTIONS(3085),
    [anon_sym_LPAREN] = ACTIONS(3083),
    [anon_sym_COMMA] = ACTIONS(3085),
    [anon_sym_null] = ACTIONS(3083),
    [anon_sym_QMARK] = ACTIONS(3083),
    [anon_sym_COLON_QMARK] = ACTIONS(3083),
    [anon_sym_COLON_COLON] = ACTIONS(3085),
    [anon_sym_AMP] = ACTIONS(3083),
    [anon_sym_LBRACK] = ACTIONS(3083),
    [anon_sym_RBRACK] = ACTIONS(3085),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3085),
    [anon_sym_LBRACE] = ACTIONS(3083),
    [anon_sym_RBRACE] = ACTIONS(3085),
    [anon_sym_LT_AT] = ACTIONS(3083),
    [anon_sym_LT_AT_AT] = ACTIONS(3083),
    [anon_sym_DOT] = ACTIONS(3083),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3085),
    [anon_sym_new] = ACTIONS(3083),
    [anon_sym_with] = ACTIONS(3083),
    [anon_sym_return_BANG] = ACTIONS(3085),
    [anon_sym_yield] = ACTIONS(3083),
    [anon_sym_yield_BANG] = ACTIONS(3085),
    [anon_sym_lazy] = ACTIONS(3083),
    [anon_sym_assert] = ACTIONS(3083),
    [anon_sym_upcast] = ACTIONS(3083),
    [anon_sym_downcast] = ACTIONS(3083),
    [anon_sym_COLON_GT] = ACTIONS(3085),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3085),
    [anon_sym_for] = ACTIONS(3083),
    [anon_sym_to] = ACTIONS(3083),
    [anon_sym_downto] = ACTIONS(3083),
    [anon_sym_while] = ACTIONS(3083),
    [anon_sym_if] = ACTIONS(3083),
    [anon_sym_fun] = ACTIONS(3083),
    [anon_sym_try] = ACTIONS(3083),
    [anon_sym_match] = ACTIONS(3083),
    [anon_sym_match_BANG] = ACTIONS(3085),
    [anon_sym_function] = ACTIONS(3083),
    [anon_sym_LT_DASH] = ACTIONS(3083),
    [anon_sym_DOT_LBRACK] = ACTIONS(3085),
    [anon_sym_LT] = ACTIONS(3085),
    [anon_sym_use] = ACTIONS(3083),
    [anon_sym_use_BANG] = ACTIONS(3085),
    [anon_sym_do_BANG] = ACTIONS(3085),
    [anon_sym_begin] = ACTIONS(3083),
    [anon_sym_LPAREN2] = ACTIONS(3083),
    [anon_sym_DOT_DOT2] = ACTIONS(3085),
    [anon_sym_or] = ACTIONS(3083),
    [aux_sym_char_token1] = ACTIONS(3085),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3083),
    [anon_sym_DQUOTE] = ACTIONS(3083),
    [anon_sym_AT_DQUOTE] = ACTIONS(3085),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3085),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3085),
    [sym_bool] = ACTIONS(3083),
    [sym_unit] = ACTIONS(3085),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3083),
    [sym_op_identifier] = ACTIONS(3083),
    [anon_sym_PLUS] = ACTIONS(3083),
    [anon_sym_DASH] = ACTIONS(3083),
    [anon_sym_PLUS_DOT] = ACTIONS(3083),
    [anon_sym_DASH_DOT] = ACTIONS(3083),
    [anon_sym_PERCENT] = ACTIONS(3083),
    [anon_sym_AMP_AMP] = ACTIONS(3083),
    [anon_sym_TILDE] = ACTIONS(3085),
    [aux_sym_prefix_op_token1] = ACTIONS(3083),
    [aux_sym_infix_op_token1] = ACTIONS(3085),
    [aux_sym_infix_op_token2] = ACTIONS(3083),
    [anon_sym_PIPE_PIPE] = ACTIONS(3083),
    [anon_sym_BANG_EQ] = ACTIONS(3083),
    [anon_sym_COLON_EQ] = ACTIONS(3085),
    [anon_sym_DOLLAR] = ACTIONS(3083),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3083),
    [sym_int] = ACTIONS(3083),
    [sym_xint] = ACTIONS(3085),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3085),
    [sym__newline] = ACTIONS(3085),
  },
  [1172] = {
    [sym_block_comment] = STATE(1172),
    [sym_compiler_directive_decl] = STATE(1172),
    [sym_fsi_directive_decl] = STATE(1172),
    [sym_preproc_line] = STATE(1172),
    [sym_identifier] = ACTIONS(2454),
    [anon_sym_EQ] = ACTIONS(2456),
    [anon_sym_COLON] = ACTIONS(2454),
    [anon_sym_return] = ACTIONS(2454),
    [anon_sym_do] = ACTIONS(2454),
    [anon_sym_let] = ACTIONS(2454),
    [anon_sym_let_BANG] = ACTIONS(2456),
    [anon_sym_LPAREN] = ACTIONS(2454),
    [anon_sym_COMMA] = ACTIONS(2456),
    [anon_sym_null] = ACTIONS(2454),
    [anon_sym_QMARK] = ACTIONS(2454),
    [anon_sym_COLON_QMARK] = ACTIONS(2454),
    [anon_sym_COLON_COLON] = ACTIONS(2456),
    [anon_sym_AMP] = ACTIONS(2454),
    [anon_sym_LBRACK] = ACTIONS(2454),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2456),
    [anon_sym_LBRACE] = ACTIONS(2454),
    [anon_sym_LT_AT] = ACTIONS(2454),
    [anon_sym_LT_AT_AT] = ACTIONS(2454),
    [anon_sym_DOT] = ACTIONS(2454),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2456),
    [anon_sym_new] = ACTIONS(2454),
    [anon_sym_return_BANG] = ACTIONS(2456),
    [anon_sym_yield] = ACTIONS(2454),
    [anon_sym_yield_BANG] = ACTIONS(2456),
    [anon_sym_lazy] = ACTIONS(2454),
    [anon_sym_assert] = ACTIONS(2454),
    [anon_sym_upcast] = ACTIONS(2454),
    [anon_sym_downcast] = ACTIONS(2454),
    [anon_sym_COLON_GT] = ACTIONS(2456),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2456),
    [anon_sym_for] = ACTIONS(2454),
    [anon_sym_while] = ACTIONS(2454),
    [anon_sym_if] = ACTIONS(2454),
    [anon_sym_fun] = ACTIONS(2454),
    [anon_sym_DASH_GT] = ACTIONS(2454),
    [anon_sym_try] = ACTIONS(2454),
    [anon_sym_match] = ACTIONS(2454),
    [anon_sym_match_BANG] = ACTIONS(2456),
    [anon_sym_function] = ACTIONS(2454),
    [anon_sym_LT_DASH] = ACTIONS(2454),
    [anon_sym_DOT_LBRACK] = ACTIONS(2456),
    [anon_sym_LT] = ACTIONS(2456),
    [anon_sym_use] = ACTIONS(2454),
    [anon_sym_use_BANG] = ACTIONS(2456),
    [anon_sym_do_BANG] = ACTIONS(2456),
    [anon_sym_begin] = ACTIONS(2454),
    [anon_sym_LPAREN2] = ACTIONS(2454),
    [anon_sym_STAR] = ACTIONS(2454),
    [anon_sym_LT2] = ACTIONS(2454),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2456),
    [anon_sym_or] = ACTIONS(2454),
    [aux_sym_char_token1] = ACTIONS(2456),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2454),
    [anon_sym_DQUOTE] = ACTIONS(2454),
    [anon_sym_AT_DQUOTE] = ACTIONS(2456),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2456),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2456),
    [sym_bool] = ACTIONS(2454),
    [sym_unit] = ACTIONS(2456),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2454),
    [sym_op_identifier] = ACTIONS(2454),
    [anon_sym_PLUS] = ACTIONS(2454),
    [anon_sym_DASH] = ACTIONS(2454),
    [anon_sym_PLUS_DOT] = ACTIONS(2454),
    [anon_sym_DASH_DOT] = ACTIONS(2454),
    [anon_sym_PERCENT] = ACTIONS(2454),
    [anon_sym_AMP_AMP] = ACTIONS(2454),
    [anon_sym_TILDE] = ACTIONS(2456),
    [aux_sym_prefix_op_token1] = ACTIONS(2454),
    [aux_sym_infix_op_token1] = ACTIONS(2456),
    [aux_sym_infix_op_token2] = ACTIONS(2454),
    [anon_sym_PIPE_PIPE] = ACTIONS(2454),
    [anon_sym_BANG_EQ] = ACTIONS(2454),
    [anon_sym_COLON_EQ] = ACTIONS(2456),
    [anon_sym_DOLLAR] = ACTIONS(2454),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2454),
    [sym_int] = ACTIONS(2454),
    [sym_xint] = ACTIONS(2456),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2456),
    [anon_sym_POUNDendif] = ACTIONS(2456),
    [anon_sym_POUNDelse] = ACTIONS(2456),
    [sym__newline] = ACTIONS(2456),
  },
  [1173] = {
    [sym_block_comment] = STATE(1173),
    [sym_compiler_directive_decl] = STATE(1173),
    [sym_fsi_directive_decl] = STATE(1173),
    [sym_preproc_line] = STATE(1173),
    [sym_identifier] = ACTIONS(2567),
    [anon_sym_EQ] = ACTIONS(2569),
    [anon_sym_COLON] = ACTIONS(2567),
    [anon_sym_return] = ACTIONS(2567),
    [anon_sym_do] = ACTIONS(2567),
    [anon_sym_let] = ACTIONS(2567),
    [anon_sym_let_BANG] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2567),
    [anon_sym_COMMA] = ACTIONS(2569),
    [anon_sym_null] = ACTIONS(2567),
    [anon_sym_QMARK] = ACTIONS(2567),
    [anon_sym_COLON_QMARK] = ACTIONS(2567),
    [anon_sym_COLON_COLON] = ACTIONS(2569),
    [anon_sym_AMP] = ACTIONS(2567),
    [anon_sym_LBRACK] = ACTIONS(2567),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2569),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_LT_AT] = ACTIONS(2567),
    [anon_sym_LT_AT_AT] = ACTIONS(2567),
    [anon_sym_DOT] = ACTIONS(2567),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2569),
    [anon_sym_new] = ACTIONS(2567),
    [anon_sym_return_BANG] = ACTIONS(2569),
    [anon_sym_yield] = ACTIONS(2567),
    [anon_sym_yield_BANG] = ACTIONS(2569),
    [anon_sym_lazy] = ACTIONS(2567),
    [anon_sym_assert] = ACTIONS(2567),
    [anon_sym_upcast] = ACTIONS(2567),
    [anon_sym_downcast] = ACTIONS(2567),
    [anon_sym_COLON_GT] = ACTIONS(2569),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2569),
    [anon_sym_for] = ACTIONS(2567),
    [anon_sym_while] = ACTIONS(2567),
    [anon_sym_if] = ACTIONS(2567),
    [anon_sym_fun] = ACTIONS(2567),
    [anon_sym_DASH_GT] = ACTIONS(2567),
    [anon_sym_try] = ACTIONS(2567),
    [anon_sym_match] = ACTIONS(2567),
    [anon_sym_match_BANG] = ACTIONS(2569),
    [anon_sym_function] = ACTIONS(2567),
    [anon_sym_LT_DASH] = ACTIONS(2567),
    [anon_sym_DOT_LBRACK] = ACTIONS(2569),
    [anon_sym_LT] = ACTIONS(2569),
    [anon_sym_use] = ACTIONS(2567),
    [anon_sym_use_BANG] = ACTIONS(2569),
    [anon_sym_do_BANG] = ACTIONS(2569),
    [anon_sym_begin] = ACTIONS(2567),
    [anon_sym_LPAREN2] = ACTIONS(2567),
    [anon_sym_STAR] = ACTIONS(2567),
    [anon_sym_LT2] = ACTIONS(2567),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2569),
    [anon_sym_or] = ACTIONS(2567),
    [aux_sym_char_token1] = ACTIONS(2569),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2567),
    [anon_sym_DQUOTE] = ACTIONS(2567),
    [anon_sym_AT_DQUOTE] = ACTIONS(2569),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2569),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2569),
    [sym_bool] = ACTIONS(2567),
    [sym_unit] = ACTIONS(2569),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2567),
    [sym_op_identifier] = ACTIONS(2567),
    [anon_sym_PLUS] = ACTIONS(2567),
    [anon_sym_DASH] = ACTIONS(2567),
    [anon_sym_PLUS_DOT] = ACTIONS(2567),
    [anon_sym_DASH_DOT] = ACTIONS(2567),
    [anon_sym_PERCENT] = ACTIONS(2567),
    [anon_sym_AMP_AMP] = ACTIONS(2567),
    [anon_sym_TILDE] = ACTIONS(2569),
    [aux_sym_prefix_op_token1] = ACTIONS(2567),
    [aux_sym_infix_op_token1] = ACTIONS(2569),
    [aux_sym_infix_op_token2] = ACTIONS(2567),
    [anon_sym_PIPE_PIPE] = ACTIONS(2567),
    [anon_sym_BANG_EQ] = ACTIONS(2567),
    [anon_sym_COLON_EQ] = ACTIONS(2569),
    [anon_sym_DOLLAR] = ACTIONS(2567),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2567),
    [sym_int] = ACTIONS(2567),
    [sym_xint] = ACTIONS(2569),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2569),
    [anon_sym_POUNDendif] = ACTIONS(2569),
    [anon_sym_POUNDelse] = ACTIONS(2569),
    [sym__newline] = ACTIONS(2569),
  },
  [1174] = {
    [sym_elif_expression] = STATE(1410),
    [sym_block_comment] = STATE(1174),
    [sym_compiler_directive_decl] = STATE(1174),
    [sym_fsi_directive_decl] = STATE(1174),
    [sym_preproc_line] = STATE(1174),
    [aux_sym_if_expression_repeat1] = STATE(1174),
    [sym_identifier] = ACTIONS(2518),
    [anon_sym_EQ] = ACTIONS(2520),
    [anon_sym_COLON] = ACTIONS(2518),
    [anon_sym_return] = ACTIONS(2518),
    [anon_sym_do] = ACTIONS(2518),
    [anon_sym_let] = ACTIONS(2518),
    [anon_sym_let_BANG] = ACTIONS(2520),
    [anon_sym_LPAREN] = ACTIONS(2518),
    [anon_sym_COMMA] = ACTIONS(2520),
    [anon_sym_null] = ACTIONS(2518),
    [anon_sym_QMARK] = ACTIONS(2518),
    [anon_sym_COLON_QMARK] = ACTIONS(2518),
    [anon_sym_COLON_COLON] = ACTIONS(2520),
    [anon_sym_AMP] = ACTIONS(2518),
    [anon_sym_LBRACK] = ACTIONS(2518),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2520),
    [anon_sym_LBRACE] = ACTIONS(2518),
    [anon_sym_LT_AT] = ACTIONS(2518),
    [anon_sym_LT_AT_AT] = ACTIONS(2518),
    [anon_sym_DOT] = ACTIONS(2518),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2520),
    [anon_sym_new] = ACTIONS(2518),
    [anon_sym_return_BANG] = ACTIONS(2520),
    [anon_sym_yield] = ACTIONS(2518),
    [anon_sym_yield_BANG] = ACTIONS(2520),
    [anon_sym_lazy] = ACTIONS(2518),
    [anon_sym_assert] = ACTIONS(2518),
    [anon_sym_upcast] = ACTIONS(2518),
    [anon_sym_downcast] = ACTIONS(2518),
    [anon_sym_COLON_GT] = ACTIONS(2520),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2520),
    [anon_sym_for] = ACTIONS(2518),
    [anon_sym_while] = ACTIONS(2518),
    [anon_sym_else] = ACTIONS(2518),
    [anon_sym_elif] = ACTIONS(3355),
    [anon_sym_if] = ACTIONS(2518),
    [anon_sym_fun] = ACTIONS(2518),
    [anon_sym_try] = ACTIONS(2518),
    [anon_sym_match] = ACTIONS(2518),
    [anon_sym_match_BANG] = ACTIONS(2520),
    [anon_sym_function] = ACTIONS(2518),
    [anon_sym_LT_DASH] = ACTIONS(2518),
    [anon_sym_DOT_LBRACK] = ACTIONS(2520),
    [anon_sym_LT] = ACTIONS(2520),
    [anon_sym_use] = ACTIONS(2518),
    [anon_sym_use_BANG] = ACTIONS(2520),
    [anon_sym_do_BANG] = ACTIONS(2520),
    [anon_sym_begin] = ACTIONS(2518),
    [anon_sym_LPAREN2] = ACTIONS(2518),
    [anon_sym_or] = ACTIONS(2518),
    [aux_sym_char_token1] = ACTIONS(2520),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2518),
    [anon_sym_DQUOTE] = ACTIONS(2518),
    [anon_sym_AT_DQUOTE] = ACTIONS(2520),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2520),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2520),
    [sym_bool] = ACTIONS(2518),
    [sym_unit] = ACTIONS(2520),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2518),
    [sym_op_identifier] = ACTIONS(2518),
    [anon_sym_PLUS] = ACTIONS(2518),
    [anon_sym_DASH] = ACTIONS(2518),
    [anon_sym_PLUS_DOT] = ACTIONS(2518),
    [anon_sym_DASH_DOT] = ACTIONS(2518),
    [anon_sym_PERCENT] = ACTIONS(2518),
    [anon_sym_AMP_AMP] = ACTIONS(2518),
    [anon_sym_TILDE] = ACTIONS(2520),
    [aux_sym_prefix_op_token1] = ACTIONS(2518),
    [aux_sym_infix_op_token1] = ACTIONS(2520),
    [aux_sym_infix_op_token2] = ACTIONS(2518),
    [anon_sym_PIPE_PIPE] = ACTIONS(2518),
    [anon_sym_BANG_EQ] = ACTIONS(2518),
    [anon_sym_COLON_EQ] = ACTIONS(2520),
    [anon_sym_DOLLAR] = ACTIONS(2518),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2518),
    [sym_int] = ACTIONS(2518),
    [sym_xint] = ACTIONS(2520),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2520),
    [anon_sym_POUNDendif] = ACTIONS(2520),
    [anon_sym_POUNDelse] = ACTIONS(2520),
    [sym__newline] = ACTIONS(2520),
  },
  [1175] = {
    [sym_block_comment] = STATE(1175),
    [sym_compiler_directive_decl] = STATE(1175),
    [sym_fsi_directive_decl] = STATE(1175),
    [sym_preproc_line] = STATE(1175),
    [sym_identifier] = ACTIONS(2474),
    [anon_sym_EQ] = ACTIONS(2476),
    [anon_sym_COLON] = ACTIONS(2474),
    [anon_sym_return] = ACTIONS(2474),
    [anon_sym_do] = ACTIONS(2474),
    [anon_sym_let] = ACTIONS(2474),
    [anon_sym_let_BANG] = ACTIONS(2476),
    [anon_sym_as] = ACTIONS(2474),
    [anon_sym_LPAREN] = ACTIONS(2474),
    [anon_sym_COMMA] = ACTIONS(2476),
    [anon_sym_null] = ACTIONS(2474),
    [anon_sym_QMARK] = ACTIONS(2474),
    [anon_sym_COLON_QMARK] = ACTIONS(2474),
    [anon_sym_COLON_COLON] = ACTIONS(2476),
    [anon_sym_AMP] = ACTIONS(2474),
    [anon_sym_LBRACK] = ACTIONS(2474),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2476),
    [anon_sym_LBRACE] = ACTIONS(2474),
    [anon_sym_LT_AT] = ACTIONS(2474),
    [anon_sym_LT_AT_AT] = ACTIONS(2474),
    [anon_sym_DOT] = ACTIONS(2474),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2476),
    [anon_sym_new] = ACTIONS(2474),
    [anon_sym_with] = ACTIONS(2474),
    [anon_sym_return_BANG] = ACTIONS(2476),
    [anon_sym_yield] = ACTIONS(2474),
    [anon_sym_yield_BANG] = ACTIONS(2476),
    [anon_sym_lazy] = ACTIONS(2474),
    [anon_sym_assert] = ACTIONS(2474),
    [anon_sym_upcast] = ACTIONS(2474),
    [anon_sym_downcast] = ACTIONS(2474),
    [anon_sym_COLON_GT] = ACTIONS(2476),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2476),
    [anon_sym_for] = ACTIONS(2474),
    [anon_sym_while] = ACTIONS(2474),
    [anon_sym_if] = ACTIONS(2474),
    [anon_sym_fun] = ACTIONS(2474),
    [anon_sym_DASH_GT] = ACTIONS(2474),
    [anon_sym_try] = ACTIONS(2474),
    [anon_sym_match] = ACTIONS(2474),
    [anon_sym_match_BANG] = ACTIONS(2476),
    [anon_sym_function] = ACTIONS(2474),
    [anon_sym_LT_DASH] = ACTIONS(2474),
    [anon_sym_DOT_LBRACK] = ACTIONS(2476),
    [anon_sym_LT] = ACTIONS(2476),
    [anon_sym_use] = ACTIONS(2474),
    [anon_sym_use_BANG] = ACTIONS(2476),
    [anon_sym_do_BANG] = ACTIONS(2476),
    [anon_sym_begin] = ACTIONS(2474),
    [anon_sym_LPAREN2] = ACTIONS(2474),
    [anon_sym_STAR] = ACTIONS(2474),
    [anon_sym_LT2] = ACTIONS(2474),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2476),
    [anon_sym_or] = ACTIONS(2474),
    [aux_sym_char_token1] = ACTIONS(2476),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2474),
    [anon_sym_DQUOTE] = ACTIONS(2474),
    [anon_sym_AT_DQUOTE] = ACTIONS(2476),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2476),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2476),
    [sym_bool] = ACTIONS(2474),
    [sym_unit] = ACTIONS(2476),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2474),
    [sym_op_identifier] = ACTIONS(2474),
    [anon_sym_PLUS] = ACTIONS(2474),
    [anon_sym_DASH] = ACTIONS(2474),
    [anon_sym_PLUS_DOT] = ACTIONS(2474),
    [anon_sym_DASH_DOT] = ACTIONS(2474),
    [anon_sym_PERCENT] = ACTIONS(2474),
    [anon_sym_AMP_AMP] = ACTIONS(2474),
    [anon_sym_TILDE] = ACTIONS(2476),
    [aux_sym_prefix_op_token1] = ACTIONS(2474),
    [aux_sym_infix_op_token1] = ACTIONS(2476),
    [aux_sym_infix_op_token2] = ACTIONS(2474),
    [anon_sym_PIPE_PIPE] = ACTIONS(2474),
    [anon_sym_BANG_EQ] = ACTIONS(2474),
    [anon_sym_COLON_EQ] = ACTIONS(2476),
    [anon_sym_DOLLAR] = ACTIONS(2474),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2474),
    [sym_int] = ACTIONS(2474),
    [sym_xint] = ACTIONS(2476),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2476),
    [sym__newline] = ACTIONS(2476),
  },
  [1176] = {
    [sym_block_comment] = STATE(1176),
    [sym_compiler_directive_decl] = STATE(1176),
    [sym_fsi_directive_decl] = STATE(1176),
    [sym_preproc_line] = STATE(1176),
    [aux_sym_type_argument_repeat1] = STATE(1176),
    [sym_identifier] = ACTIONS(2340),
    [anon_sym_EQ] = ACTIONS(2342),
    [anon_sym_COLON] = ACTIONS(2340),
    [anon_sym_return] = ACTIONS(2340),
    [anon_sym_do] = ACTIONS(2340),
    [anon_sym_let] = ACTIONS(2340),
    [anon_sym_let_BANG] = ACTIONS(2342),
    [anon_sym_LPAREN] = ACTIONS(2340),
    [anon_sym_COMMA] = ACTIONS(2342),
    [anon_sym_null] = ACTIONS(2340),
    [anon_sym_QMARK] = ACTIONS(2340),
    [anon_sym_COLON_QMARK] = ACTIONS(2340),
    [anon_sym_COLON_COLON] = ACTIONS(2342),
    [anon_sym_AMP] = ACTIONS(2340),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2342),
    [anon_sym_LBRACE] = ACTIONS(2340),
    [anon_sym_LT_AT] = ACTIONS(2340),
    [anon_sym_AT_GT] = ACTIONS(2340),
    [anon_sym_LT_AT_AT] = ACTIONS(2340),
    [anon_sym_DOT] = ACTIONS(2340),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2342),
    [anon_sym_new] = ACTIONS(2340),
    [anon_sym_return_BANG] = ACTIONS(2342),
    [anon_sym_yield] = ACTIONS(2340),
    [anon_sym_yield_BANG] = ACTIONS(2342),
    [anon_sym_lazy] = ACTIONS(2340),
    [anon_sym_assert] = ACTIONS(2340),
    [anon_sym_upcast] = ACTIONS(2340),
    [anon_sym_downcast] = ACTIONS(2340),
    [anon_sym_COLON_GT] = ACTIONS(2342),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2342),
    [anon_sym_for] = ACTIONS(2340),
    [anon_sym_while] = ACTIONS(2340),
    [anon_sym_if] = ACTIONS(2340),
    [anon_sym_fun] = ACTIONS(2340),
    [anon_sym_DASH_GT] = ACTIONS(2340),
    [anon_sym_try] = ACTIONS(2340),
    [anon_sym_match] = ACTIONS(2340),
    [anon_sym_match_BANG] = ACTIONS(2342),
    [anon_sym_function] = ACTIONS(2340),
    [anon_sym_LT_DASH] = ACTIONS(2340),
    [anon_sym_DOT_LBRACK] = ACTIONS(2342),
    [anon_sym_LT] = ACTIONS(2342),
    [anon_sym_use] = ACTIONS(2340),
    [anon_sym_use_BANG] = ACTIONS(2342),
    [anon_sym_do_BANG] = ACTIONS(2342),
    [anon_sym_begin] = ACTIONS(2340),
    [anon_sym_LPAREN2] = ACTIONS(2340),
    [anon_sym_STAR] = ACTIONS(2340),
    [anon_sym_LT2] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2342),
    [anon_sym_or] = ACTIONS(3358),
    [aux_sym_char_token1] = ACTIONS(2342),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2340),
    [anon_sym_DQUOTE] = ACTIONS(2340),
    [anon_sym_AT_DQUOTE] = ACTIONS(2342),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2342),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2342),
    [sym_bool] = ACTIONS(2340),
    [sym_unit] = ACTIONS(2342),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2340),
    [sym_op_identifier] = ACTIONS(2340),
    [anon_sym_PLUS] = ACTIONS(2340),
    [anon_sym_DASH] = ACTIONS(2340),
    [anon_sym_PLUS_DOT] = ACTIONS(2340),
    [anon_sym_DASH_DOT] = ACTIONS(2340),
    [anon_sym_PERCENT] = ACTIONS(2340),
    [anon_sym_AMP_AMP] = ACTIONS(2340),
    [anon_sym_TILDE] = ACTIONS(2342),
    [aux_sym_prefix_op_token1] = ACTIONS(2340),
    [aux_sym_infix_op_token1] = ACTIONS(2342),
    [aux_sym_infix_op_token2] = ACTIONS(2340),
    [anon_sym_PIPE_PIPE] = ACTIONS(2340),
    [anon_sym_BANG_EQ] = ACTIONS(2340),
    [anon_sym_COLON_EQ] = ACTIONS(2342),
    [anon_sym_DOLLAR] = ACTIONS(2340),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2340),
    [sym_int] = ACTIONS(2340),
    [sym_xint] = ACTIONS(2342),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2342),
    [sym__newline] = ACTIONS(2342),
  },
  [1177] = {
    [sym_block_comment] = STATE(1177),
    [sym_compiler_directive_decl] = STATE(1177),
    [sym_fsi_directive_decl] = STATE(1177),
    [sym_preproc_line] = STATE(1177),
    [aux_sym_long_identifier_repeat1] = STATE(1187),
    [sym_identifier] = ACTIONS(2312),
    [anon_sym_EQ] = ACTIONS(2314),
    [anon_sym_COLON] = ACTIONS(2312),
    [anon_sym_return] = ACTIONS(2312),
    [anon_sym_do] = ACTIONS(2312),
    [anon_sym_let] = ACTIONS(2312),
    [anon_sym_let_BANG] = ACTIONS(2314),
    [anon_sym_LPAREN] = ACTIONS(2312),
    [anon_sym_COMMA] = ACTIONS(2314),
    [anon_sym_null] = ACTIONS(2312),
    [anon_sym_QMARK] = ACTIONS(2312),
    [anon_sym_COLON_QMARK] = ACTIONS(2312),
    [anon_sym_COLON_COLON] = ACTIONS(2314),
    [anon_sym_AMP] = ACTIONS(2312),
    [anon_sym_LBRACK] = ACTIONS(2312),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2314),
    [anon_sym_LBRACE] = ACTIONS(2312),
    [anon_sym_LT_AT] = ACTIONS(2312),
    [anon_sym_LT_AT_AT] = ACTIONS(2312),
    [anon_sym_AT_AT_GT] = ACTIONS(2312),
    [anon_sym_DOT] = ACTIONS(3361),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2314),
    [anon_sym_new] = ACTIONS(2312),
    [anon_sym_return_BANG] = ACTIONS(2314),
    [anon_sym_yield] = ACTIONS(2312),
    [anon_sym_yield_BANG] = ACTIONS(2314),
    [anon_sym_lazy] = ACTIONS(2312),
    [anon_sym_assert] = ACTIONS(2312),
    [anon_sym_upcast] = ACTIONS(2312),
    [anon_sym_downcast] = ACTIONS(2312),
    [anon_sym_COLON_GT] = ACTIONS(2314),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2314),
    [anon_sym_for] = ACTIONS(2312),
    [anon_sym_while] = ACTIONS(2312),
    [anon_sym_if] = ACTIONS(2312),
    [anon_sym_fun] = ACTIONS(2312),
    [anon_sym_DASH_GT] = ACTIONS(2312),
    [anon_sym_try] = ACTIONS(2312),
    [anon_sym_match] = ACTIONS(2312),
    [anon_sym_match_BANG] = ACTIONS(2314),
    [anon_sym_function] = ACTIONS(2312),
    [anon_sym_LT_DASH] = ACTIONS(2312),
    [anon_sym_DOT_LBRACK] = ACTIONS(2314),
    [anon_sym_LT] = ACTIONS(2314),
    [anon_sym_use] = ACTIONS(2312),
    [anon_sym_use_BANG] = ACTIONS(2314),
    [anon_sym_do_BANG] = ACTIONS(2314),
    [anon_sym_begin] = ACTIONS(2312),
    [anon_sym_LPAREN2] = ACTIONS(2312),
    [anon_sym_STAR] = ACTIONS(2312),
    [anon_sym_LT2] = ACTIONS(2312),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2314),
    [anon_sym_or] = ACTIONS(2312),
    [aux_sym_char_token1] = ACTIONS(2314),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2312),
    [anon_sym_DQUOTE] = ACTIONS(2312),
    [anon_sym_AT_DQUOTE] = ACTIONS(2314),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2314),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2314),
    [sym_bool] = ACTIONS(2312),
    [sym_unit] = ACTIONS(2314),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2312),
    [sym_op_identifier] = ACTIONS(2312),
    [anon_sym_PLUS] = ACTIONS(2312),
    [anon_sym_DASH] = ACTIONS(2312),
    [anon_sym_PLUS_DOT] = ACTIONS(2312),
    [anon_sym_DASH_DOT] = ACTIONS(2312),
    [anon_sym_PERCENT] = ACTIONS(2312),
    [anon_sym_AMP_AMP] = ACTIONS(2312),
    [anon_sym_TILDE] = ACTIONS(2314),
    [aux_sym_prefix_op_token1] = ACTIONS(2312),
    [aux_sym_infix_op_token1] = ACTIONS(2314),
    [aux_sym_infix_op_token2] = ACTIONS(2312),
    [anon_sym_PIPE_PIPE] = ACTIONS(2312),
    [anon_sym_BANG_EQ] = ACTIONS(2312),
    [anon_sym_COLON_EQ] = ACTIONS(2314),
    [anon_sym_DOLLAR] = ACTIONS(2312),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2312),
    [sym_int] = ACTIONS(2312),
    [sym_xint] = ACTIONS(2314),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2314),
    [sym__newline] = ACTIONS(2314),
  },
  [1178] = {
    [sym_block_comment] = STATE(1178),
    [sym_compiler_directive_decl] = STATE(1178),
    [sym_fsi_directive_decl] = STATE(1178),
    [sym_preproc_line] = STATE(1178),
    [sym_identifier] = ACTIONS(2321),
    [anon_sym_EQ] = ACTIONS(2323),
    [anon_sym_COLON] = ACTIONS(2321),
    [anon_sym_return] = ACTIONS(2321),
    [anon_sym_do] = ACTIONS(2321),
    [anon_sym_let] = ACTIONS(2321),
    [anon_sym_let_BANG] = ACTIONS(2323),
    [anon_sym_LPAREN] = ACTIONS(2321),
    [anon_sym_COMMA] = ACTIONS(2323),
    [anon_sym_null] = ACTIONS(2321),
    [anon_sym_QMARK] = ACTIONS(2321),
    [anon_sym_COLON_QMARK] = ACTIONS(2321),
    [anon_sym_COLON_COLON] = ACTIONS(2323),
    [anon_sym_AMP] = ACTIONS(2321),
    [anon_sym_LBRACK] = ACTIONS(2321),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2323),
    [anon_sym_LBRACE] = ACTIONS(2321),
    [anon_sym_LT_AT] = ACTIONS(2321),
    [anon_sym_LT_AT_AT] = ACTIONS(2321),
    [anon_sym_DOT] = ACTIONS(2321),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2323),
    [anon_sym_new] = ACTIONS(2321),
    [anon_sym_return_BANG] = ACTIONS(2323),
    [anon_sym_yield] = ACTIONS(2321),
    [anon_sym_yield_BANG] = ACTIONS(2323),
    [anon_sym_lazy] = ACTIONS(2321),
    [anon_sym_assert] = ACTIONS(2321),
    [anon_sym_upcast] = ACTIONS(2321),
    [anon_sym_downcast] = ACTIONS(2321),
    [anon_sym_COLON_GT] = ACTIONS(2323),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2323),
    [anon_sym_for] = ACTIONS(2321),
    [anon_sym_while] = ACTIONS(2321),
    [anon_sym_if] = ACTIONS(2321),
    [anon_sym_fun] = ACTIONS(2321),
    [anon_sym_DASH_GT] = ACTIONS(2321),
    [anon_sym_try] = ACTIONS(2321),
    [anon_sym_match] = ACTIONS(2321),
    [anon_sym_match_BANG] = ACTIONS(2323),
    [anon_sym_function] = ACTIONS(2321),
    [anon_sym_LT_DASH] = ACTIONS(2321),
    [anon_sym_DOT_LBRACK] = ACTIONS(2323),
    [anon_sym_LT] = ACTIONS(2323),
    [anon_sym_use] = ACTIONS(2321),
    [anon_sym_use_BANG] = ACTIONS(2323),
    [anon_sym_do_BANG] = ACTIONS(2323),
    [anon_sym_begin] = ACTIONS(2321),
    [anon_sym_LPAREN2] = ACTIONS(2321),
    [anon_sym_STAR] = ACTIONS(2321),
    [anon_sym_LT2] = ACTIONS(2321),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2323),
    [anon_sym_or] = ACTIONS(2321),
    [aux_sym_char_token1] = ACTIONS(2323),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2321),
    [anon_sym_DQUOTE] = ACTIONS(2321),
    [anon_sym_AT_DQUOTE] = ACTIONS(2323),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2323),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2323),
    [sym_bool] = ACTIONS(2321),
    [sym_unit] = ACTIONS(2323),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2321),
    [sym_op_identifier] = ACTIONS(2321),
    [anon_sym_PLUS] = ACTIONS(2321),
    [anon_sym_DASH] = ACTIONS(2321),
    [anon_sym_PLUS_DOT] = ACTIONS(2321),
    [anon_sym_DASH_DOT] = ACTIONS(2321),
    [anon_sym_PERCENT] = ACTIONS(2321),
    [anon_sym_AMP_AMP] = ACTIONS(2321),
    [anon_sym_TILDE] = ACTIONS(2323),
    [aux_sym_prefix_op_token1] = ACTIONS(2321),
    [aux_sym_infix_op_token1] = ACTIONS(2323),
    [aux_sym_infix_op_token2] = ACTIONS(2321),
    [anon_sym_PIPE_PIPE] = ACTIONS(2321),
    [anon_sym_BANG_EQ] = ACTIONS(2321),
    [anon_sym_COLON_EQ] = ACTIONS(2323),
    [anon_sym_DOLLAR] = ACTIONS(2321),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2321),
    [sym_int] = ACTIONS(2321),
    [sym_xint] = ACTIONS(2323),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2323),
    [anon_sym_POUNDendif] = ACTIONS(2323),
    [anon_sym_POUNDelse] = ACTIONS(2323),
    [sym__newline] = ACTIONS(2323),
  },
  [1179] = {
    [sym_block_comment] = STATE(1179),
    [sym_compiler_directive_decl] = STATE(1179),
    [sym_fsi_directive_decl] = STATE(1179),
    [sym_preproc_line] = STATE(1179),
    [sym_identifier] = ACTIONS(2411),
    [anon_sym_EQ] = ACTIONS(2413),
    [anon_sym_COLON] = ACTIONS(2411),
    [anon_sym_return] = ACTIONS(2411),
    [anon_sym_do] = ACTIONS(2411),
    [anon_sym_let] = ACTIONS(2411),
    [anon_sym_let_BANG] = ACTIONS(2413),
    [anon_sym_as] = ACTIONS(2411),
    [anon_sym_LPAREN] = ACTIONS(2411),
    [anon_sym_COMMA] = ACTIONS(2413),
    [anon_sym_null] = ACTIONS(2411),
    [anon_sym_QMARK] = ACTIONS(2411),
    [anon_sym_COLON_QMARK] = ACTIONS(2411),
    [anon_sym_COLON_COLON] = ACTIONS(2413),
    [anon_sym_AMP] = ACTIONS(2411),
    [anon_sym_LBRACK] = ACTIONS(2411),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2413),
    [anon_sym_LBRACE] = ACTIONS(2411),
    [anon_sym_LT_AT] = ACTIONS(2411),
    [anon_sym_LT_AT_AT] = ACTIONS(2411),
    [anon_sym_DOT] = ACTIONS(2411),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2413),
    [anon_sym_new] = ACTIONS(2411),
    [anon_sym_with] = ACTIONS(2411),
    [anon_sym_return_BANG] = ACTIONS(2413),
    [anon_sym_yield] = ACTIONS(2411),
    [anon_sym_yield_BANG] = ACTIONS(2413),
    [anon_sym_lazy] = ACTIONS(2411),
    [anon_sym_assert] = ACTIONS(2411),
    [anon_sym_upcast] = ACTIONS(2411),
    [anon_sym_downcast] = ACTIONS(2411),
    [anon_sym_COLON_GT] = ACTIONS(2413),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2413),
    [anon_sym_for] = ACTIONS(2411),
    [anon_sym_while] = ACTIONS(2411),
    [anon_sym_if] = ACTIONS(2411),
    [anon_sym_fun] = ACTIONS(2411),
    [anon_sym_DASH_GT] = ACTIONS(2411),
    [anon_sym_try] = ACTIONS(2411),
    [anon_sym_match] = ACTIONS(2411),
    [anon_sym_match_BANG] = ACTIONS(2413),
    [anon_sym_function] = ACTIONS(2411),
    [anon_sym_LT_DASH] = ACTIONS(2411),
    [anon_sym_DOT_LBRACK] = ACTIONS(2413),
    [anon_sym_LT] = ACTIONS(2413),
    [anon_sym_use] = ACTIONS(2411),
    [anon_sym_use_BANG] = ACTIONS(2413),
    [anon_sym_do_BANG] = ACTIONS(2413),
    [anon_sym_begin] = ACTIONS(2411),
    [anon_sym_LPAREN2] = ACTIONS(2411),
    [anon_sym_STAR] = ACTIONS(2411),
    [anon_sym_LT2] = ACTIONS(2411),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2413),
    [anon_sym_or] = ACTIONS(2411),
    [aux_sym_char_token1] = ACTIONS(2413),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2411),
    [anon_sym_DQUOTE] = ACTIONS(2411),
    [anon_sym_AT_DQUOTE] = ACTIONS(2413),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2413),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2413),
    [sym_bool] = ACTIONS(2411),
    [sym_unit] = ACTIONS(2413),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2411),
    [sym_op_identifier] = ACTIONS(2411),
    [anon_sym_PLUS] = ACTIONS(2411),
    [anon_sym_DASH] = ACTIONS(2411),
    [anon_sym_PLUS_DOT] = ACTIONS(2411),
    [anon_sym_DASH_DOT] = ACTIONS(2411),
    [anon_sym_PERCENT] = ACTIONS(2411),
    [anon_sym_AMP_AMP] = ACTIONS(2411),
    [anon_sym_TILDE] = ACTIONS(2413),
    [aux_sym_prefix_op_token1] = ACTIONS(2411),
    [aux_sym_infix_op_token1] = ACTIONS(2413),
    [aux_sym_infix_op_token2] = ACTIONS(2411),
    [anon_sym_PIPE_PIPE] = ACTIONS(2411),
    [anon_sym_BANG_EQ] = ACTIONS(2411),
    [anon_sym_COLON_EQ] = ACTIONS(2413),
    [anon_sym_DOLLAR] = ACTIONS(2411),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2411),
    [sym_int] = ACTIONS(2411),
    [sym_xint] = ACTIONS(2413),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2413),
    [sym__newline] = ACTIONS(2413),
  },
  [1180] = {
    [sym_block_comment] = STATE(1180),
    [sym_compiler_directive_decl] = STATE(1180),
    [sym_fsi_directive_decl] = STATE(1180),
    [sym_preproc_line] = STATE(1180),
    [aux_sym_long_identifier_repeat1] = STATE(1208),
    [sym_identifier] = ACTIONS(2312),
    [anon_sym_EQ] = ACTIONS(2314),
    [anon_sym_COLON] = ACTIONS(2312),
    [anon_sym_return] = ACTIONS(2312),
    [anon_sym_do] = ACTIONS(2312),
    [anon_sym_let] = ACTIONS(2312),
    [anon_sym_let_BANG] = ACTIONS(2314),
    [anon_sym_LPAREN] = ACTIONS(2312),
    [anon_sym_COMMA] = ACTIONS(2314),
    [anon_sym_null] = ACTIONS(2312),
    [anon_sym_QMARK] = ACTIONS(2312),
    [anon_sym_COLON_QMARK] = ACTIONS(2312),
    [anon_sym_COLON_COLON] = ACTIONS(2314),
    [anon_sym_AMP] = ACTIONS(2312),
    [anon_sym_LBRACK] = ACTIONS(2312),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2314),
    [anon_sym_LBRACE] = ACTIONS(2312),
    [anon_sym_LT_AT] = ACTIONS(2312),
    [anon_sym_AT_GT] = ACTIONS(2312),
    [anon_sym_LT_AT_AT] = ACTIONS(2312),
    [anon_sym_DOT] = ACTIONS(3363),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2314),
    [anon_sym_new] = ACTIONS(2312),
    [anon_sym_return_BANG] = ACTIONS(2314),
    [anon_sym_yield] = ACTIONS(2312),
    [anon_sym_yield_BANG] = ACTIONS(2314),
    [anon_sym_lazy] = ACTIONS(2312),
    [anon_sym_assert] = ACTIONS(2312),
    [anon_sym_upcast] = ACTIONS(2312),
    [anon_sym_downcast] = ACTIONS(2312),
    [anon_sym_COLON_GT] = ACTIONS(2314),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2314),
    [anon_sym_for] = ACTIONS(2312),
    [anon_sym_while] = ACTIONS(2312),
    [anon_sym_if] = ACTIONS(2312),
    [anon_sym_fun] = ACTIONS(2312),
    [anon_sym_DASH_GT] = ACTIONS(2312),
    [anon_sym_try] = ACTIONS(2312),
    [anon_sym_match] = ACTIONS(2312),
    [anon_sym_match_BANG] = ACTIONS(2314),
    [anon_sym_function] = ACTIONS(2312),
    [anon_sym_LT_DASH] = ACTIONS(2312),
    [anon_sym_DOT_LBRACK] = ACTIONS(2314),
    [anon_sym_LT] = ACTIONS(2314),
    [anon_sym_use] = ACTIONS(2312),
    [anon_sym_use_BANG] = ACTIONS(2314),
    [anon_sym_do_BANG] = ACTIONS(2314),
    [anon_sym_begin] = ACTIONS(2312),
    [anon_sym_LPAREN2] = ACTIONS(2312),
    [anon_sym_STAR] = ACTIONS(2312),
    [anon_sym_LT2] = ACTIONS(2312),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2314),
    [anon_sym_or] = ACTIONS(2312),
    [aux_sym_char_token1] = ACTIONS(2314),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2312),
    [anon_sym_DQUOTE] = ACTIONS(2312),
    [anon_sym_AT_DQUOTE] = ACTIONS(2314),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2314),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2314),
    [sym_bool] = ACTIONS(2312),
    [sym_unit] = ACTIONS(2314),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2312),
    [sym_op_identifier] = ACTIONS(2312),
    [anon_sym_PLUS] = ACTIONS(2312),
    [anon_sym_DASH] = ACTIONS(2312),
    [anon_sym_PLUS_DOT] = ACTIONS(2312),
    [anon_sym_DASH_DOT] = ACTIONS(2312),
    [anon_sym_PERCENT] = ACTIONS(2312),
    [anon_sym_AMP_AMP] = ACTIONS(2312),
    [anon_sym_TILDE] = ACTIONS(2314),
    [aux_sym_prefix_op_token1] = ACTIONS(2312),
    [aux_sym_infix_op_token1] = ACTIONS(2314),
    [aux_sym_infix_op_token2] = ACTIONS(2312),
    [anon_sym_PIPE_PIPE] = ACTIONS(2312),
    [anon_sym_BANG_EQ] = ACTIONS(2312),
    [anon_sym_COLON_EQ] = ACTIONS(2314),
    [anon_sym_DOLLAR] = ACTIONS(2312),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2312),
    [sym_int] = ACTIONS(2312),
    [sym_xint] = ACTIONS(2314),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2314),
    [sym__newline] = ACTIONS(2314),
  },
  [1181] = {
    [sym_block_comment] = STATE(1181),
    [sym_compiler_directive_decl] = STATE(1181),
    [sym_fsi_directive_decl] = STATE(1181),
    [sym_preproc_line] = STATE(1181),
    [sym_identifier] = ACTIONS(2462),
    [anon_sym_EQ] = ACTIONS(2464),
    [anon_sym_COLON] = ACTIONS(2462),
    [anon_sym_return] = ACTIONS(2462),
    [anon_sym_do] = ACTIONS(2462),
    [anon_sym_let] = ACTIONS(2462),
    [anon_sym_let_BANG] = ACTIONS(2464),
    [anon_sym_LPAREN] = ACTIONS(2462),
    [anon_sym_COMMA] = ACTIONS(2464),
    [anon_sym_null] = ACTIONS(2462),
    [anon_sym_QMARK] = ACTIONS(2462),
    [anon_sym_COLON_QMARK] = ACTIONS(2462),
    [anon_sym_COLON_COLON] = ACTIONS(2464),
    [anon_sym_AMP] = ACTIONS(2462),
    [anon_sym_LBRACK] = ACTIONS(2462),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2464),
    [anon_sym_LBRACE] = ACTIONS(2462),
    [anon_sym_LT_AT] = ACTIONS(2462),
    [anon_sym_LT_AT_AT] = ACTIONS(2462),
    [anon_sym_DOT] = ACTIONS(2462),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2464),
    [anon_sym_new] = ACTIONS(2462),
    [anon_sym_return_BANG] = ACTIONS(2464),
    [anon_sym_yield] = ACTIONS(2462),
    [anon_sym_yield_BANG] = ACTIONS(2464),
    [anon_sym_lazy] = ACTIONS(2462),
    [anon_sym_assert] = ACTIONS(2462),
    [anon_sym_upcast] = ACTIONS(2462),
    [anon_sym_downcast] = ACTIONS(2462),
    [anon_sym_COLON_GT] = ACTIONS(2464),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2464),
    [anon_sym_for] = ACTIONS(2462),
    [anon_sym_while] = ACTIONS(2462),
    [anon_sym_if] = ACTIONS(2462),
    [anon_sym_fun] = ACTIONS(2462),
    [anon_sym_DASH_GT] = ACTIONS(2462),
    [anon_sym_try] = ACTIONS(2462),
    [anon_sym_match] = ACTIONS(2462),
    [anon_sym_match_BANG] = ACTIONS(2464),
    [anon_sym_function] = ACTIONS(2462),
    [anon_sym_LT_DASH] = ACTIONS(2462),
    [anon_sym_DOT_LBRACK] = ACTIONS(2464),
    [anon_sym_LT] = ACTIONS(2464),
    [anon_sym_use] = ACTIONS(2462),
    [anon_sym_use_BANG] = ACTIONS(2464),
    [anon_sym_do_BANG] = ACTIONS(2464),
    [anon_sym_begin] = ACTIONS(2462),
    [anon_sym_LPAREN2] = ACTIONS(2462),
    [anon_sym_STAR] = ACTIONS(2462),
    [anon_sym_LT2] = ACTIONS(2462),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2464),
    [anon_sym_or] = ACTIONS(2462),
    [aux_sym_char_token1] = ACTIONS(2464),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2462),
    [anon_sym_DQUOTE] = ACTIONS(2462),
    [anon_sym_AT_DQUOTE] = ACTIONS(2464),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2464),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2464),
    [sym_bool] = ACTIONS(2462),
    [sym_unit] = ACTIONS(2464),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2462),
    [sym_op_identifier] = ACTIONS(2462),
    [anon_sym_PLUS] = ACTIONS(2462),
    [anon_sym_DASH] = ACTIONS(2462),
    [anon_sym_PLUS_DOT] = ACTIONS(2462),
    [anon_sym_DASH_DOT] = ACTIONS(2462),
    [anon_sym_PERCENT] = ACTIONS(2462),
    [anon_sym_AMP_AMP] = ACTIONS(2462),
    [anon_sym_TILDE] = ACTIONS(2464),
    [aux_sym_prefix_op_token1] = ACTIONS(2462),
    [aux_sym_infix_op_token1] = ACTIONS(2464),
    [aux_sym_infix_op_token2] = ACTIONS(2462),
    [anon_sym_PIPE_PIPE] = ACTIONS(2462),
    [anon_sym_BANG_EQ] = ACTIONS(2462),
    [anon_sym_COLON_EQ] = ACTIONS(2464),
    [anon_sym_DOLLAR] = ACTIONS(2462),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2462),
    [sym_int] = ACTIONS(2462),
    [sym_xint] = ACTIONS(2464),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2464),
    [anon_sym_POUNDendif] = ACTIONS(2464),
    [anon_sym_POUNDelse] = ACTIONS(2464),
    [sym__newline] = ACTIONS(2464),
  },
  [1182] = {
    [sym_block_comment] = STATE(1182),
    [sym_compiler_directive_decl] = STATE(1182),
    [sym_fsi_directive_decl] = STATE(1182),
    [sym_preproc_line] = STATE(1182),
    [sym_identifier] = ACTIONS(2557),
    [anon_sym_EQ] = ACTIONS(2559),
    [anon_sym_COLON] = ACTIONS(2557),
    [anon_sym_return] = ACTIONS(2557),
    [anon_sym_do] = ACTIONS(2557),
    [anon_sym_let] = ACTIONS(2557),
    [anon_sym_let_BANG] = ACTIONS(2559),
    [anon_sym_as] = ACTIONS(2557),
    [anon_sym_LPAREN] = ACTIONS(2557),
    [anon_sym_COMMA] = ACTIONS(2559),
    [anon_sym_null] = ACTIONS(2557),
    [anon_sym_QMARK] = ACTIONS(2557),
    [anon_sym_COLON_QMARK] = ACTIONS(2557),
    [anon_sym_COLON_COLON] = ACTIONS(2559),
    [anon_sym_AMP] = ACTIONS(2557),
    [anon_sym_LBRACK] = ACTIONS(2557),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2559),
    [anon_sym_LBRACE] = ACTIONS(2557),
    [anon_sym_LT_AT] = ACTIONS(2557),
    [anon_sym_LT_AT_AT] = ACTIONS(2557),
    [anon_sym_DOT] = ACTIONS(2557),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2559),
    [anon_sym_new] = ACTIONS(2557),
    [anon_sym_with] = ACTIONS(2557),
    [anon_sym_return_BANG] = ACTIONS(2559),
    [anon_sym_yield] = ACTIONS(2557),
    [anon_sym_yield_BANG] = ACTIONS(2559),
    [anon_sym_lazy] = ACTIONS(2557),
    [anon_sym_assert] = ACTIONS(2557),
    [anon_sym_upcast] = ACTIONS(2557),
    [anon_sym_downcast] = ACTIONS(2557),
    [anon_sym_COLON_GT] = ACTIONS(2559),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2559),
    [anon_sym_for] = ACTIONS(2557),
    [anon_sym_while] = ACTIONS(2557),
    [anon_sym_if] = ACTIONS(2557),
    [anon_sym_fun] = ACTIONS(2557),
    [anon_sym_DASH_GT] = ACTIONS(2557),
    [anon_sym_try] = ACTIONS(2557),
    [anon_sym_match] = ACTIONS(2557),
    [anon_sym_match_BANG] = ACTIONS(2559),
    [anon_sym_function] = ACTIONS(2557),
    [anon_sym_LT_DASH] = ACTIONS(2557),
    [anon_sym_DOT_LBRACK] = ACTIONS(2559),
    [anon_sym_LT] = ACTIONS(2559),
    [anon_sym_use] = ACTIONS(2557),
    [anon_sym_use_BANG] = ACTIONS(2559),
    [anon_sym_do_BANG] = ACTIONS(2559),
    [anon_sym_begin] = ACTIONS(2557),
    [anon_sym_LPAREN2] = ACTIONS(2557),
    [anon_sym_STAR] = ACTIONS(2557),
    [anon_sym_LT2] = ACTIONS(3365),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2559),
    [anon_sym_or] = ACTIONS(2557),
    [aux_sym_char_token1] = ACTIONS(2559),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2557),
    [anon_sym_DQUOTE] = ACTIONS(2557),
    [anon_sym_AT_DQUOTE] = ACTIONS(2559),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2559),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2559),
    [sym_bool] = ACTIONS(2557),
    [sym_unit] = ACTIONS(2559),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2557),
    [sym_op_identifier] = ACTIONS(2557),
    [anon_sym_PLUS] = ACTIONS(2557),
    [anon_sym_DASH] = ACTIONS(2557),
    [anon_sym_PLUS_DOT] = ACTIONS(2557),
    [anon_sym_DASH_DOT] = ACTIONS(2557),
    [anon_sym_PERCENT] = ACTIONS(2557),
    [anon_sym_AMP_AMP] = ACTIONS(2557),
    [anon_sym_TILDE] = ACTIONS(2559),
    [aux_sym_prefix_op_token1] = ACTIONS(2557),
    [aux_sym_infix_op_token1] = ACTIONS(2559),
    [aux_sym_infix_op_token2] = ACTIONS(2557),
    [anon_sym_PIPE_PIPE] = ACTIONS(2557),
    [anon_sym_BANG_EQ] = ACTIONS(2557),
    [anon_sym_COLON_EQ] = ACTIONS(2559),
    [anon_sym_DOLLAR] = ACTIONS(2557),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2557),
    [sym_int] = ACTIONS(2557),
    [sym_xint] = ACTIONS(2559),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2559),
    [sym__newline] = ACTIONS(2559),
  },
  [1183] = {
    [sym_block_comment] = STATE(1183),
    [sym_compiler_directive_decl] = STATE(1183),
    [sym_fsi_directive_decl] = STATE(1183),
    [sym_preproc_line] = STATE(1183),
    [sym_identifier] = ACTIONS(2340),
    [anon_sym_EQ] = ACTIONS(2342),
    [anon_sym_COLON] = ACTIONS(2340),
    [anon_sym_return] = ACTIONS(2340),
    [anon_sym_do] = ACTIONS(2340),
    [anon_sym_let] = ACTIONS(2340),
    [anon_sym_let_BANG] = ACTIONS(2342),
    [anon_sym_LPAREN] = ACTIONS(2340),
    [anon_sym_COMMA] = ACTIONS(2342),
    [anon_sym_null] = ACTIONS(2340),
    [anon_sym_QMARK] = ACTIONS(2340),
    [anon_sym_COLON_QMARK] = ACTIONS(2340),
    [anon_sym_COLON_COLON] = ACTIONS(2342),
    [anon_sym_AMP] = ACTIONS(2340),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2342),
    [anon_sym_LBRACE] = ACTIONS(2340),
    [anon_sym_LT_AT] = ACTIONS(2340),
    [anon_sym_LT_AT_AT] = ACTIONS(2340),
    [anon_sym_DOT] = ACTIONS(2340),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2342),
    [anon_sym_new] = ACTIONS(2340),
    [anon_sym_return_BANG] = ACTIONS(2342),
    [anon_sym_yield] = ACTIONS(2340),
    [anon_sym_yield_BANG] = ACTIONS(2342),
    [anon_sym_lazy] = ACTIONS(2340),
    [anon_sym_assert] = ACTIONS(2340),
    [anon_sym_upcast] = ACTIONS(2340),
    [anon_sym_downcast] = ACTIONS(2340),
    [anon_sym_COLON_GT] = ACTIONS(2342),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2342),
    [anon_sym_for] = ACTIONS(2340),
    [anon_sym_while] = ACTIONS(2340),
    [anon_sym_if] = ACTIONS(2340),
    [anon_sym_fun] = ACTIONS(2340),
    [anon_sym_DASH_GT] = ACTIONS(2340),
    [anon_sym_try] = ACTIONS(2340),
    [anon_sym_match] = ACTIONS(2340),
    [anon_sym_match_BANG] = ACTIONS(2342),
    [anon_sym_function] = ACTIONS(2340),
    [anon_sym_LT_DASH] = ACTIONS(2340),
    [anon_sym_DOT_LBRACK] = ACTIONS(2342),
    [anon_sym_LT] = ACTIONS(2342),
    [anon_sym_use] = ACTIONS(2340),
    [anon_sym_use_BANG] = ACTIONS(2342),
    [anon_sym_do_BANG] = ACTIONS(2342),
    [anon_sym_begin] = ACTIONS(2340),
    [anon_sym_LPAREN2] = ACTIONS(2340),
    [anon_sym_STAR] = ACTIONS(2340),
    [anon_sym_LT2] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2342),
    [anon_sym_or] = ACTIONS(2340),
    [aux_sym_char_token1] = ACTIONS(2342),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2340),
    [anon_sym_DQUOTE] = ACTIONS(2340),
    [anon_sym_AT_DQUOTE] = ACTIONS(2342),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2342),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2342),
    [sym_bool] = ACTIONS(2340),
    [sym_unit] = ACTIONS(2342),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2340),
    [sym_op_identifier] = ACTIONS(2340),
    [anon_sym_PLUS] = ACTIONS(2340),
    [anon_sym_DASH] = ACTIONS(2340),
    [anon_sym_PLUS_DOT] = ACTIONS(2340),
    [anon_sym_DASH_DOT] = ACTIONS(2340),
    [anon_sym_PERCENT] = ACTIONS(2340),
    [anon_sym_AMP_AMP] = ACTIONS(2340),
    [anon_sym_TILDE] = ACTIONS(2342),
    [aux_sym_prefix_op_token1] = ACTIONS(2340),
    [aux_sym_infix_op_token1] = ACTIONS(2342),
    [aux_sym_infix_op_token2] = ACTIONS(2340),
    [anon_sym_PIPE_PIPE] = ACTIONS(2340),
    [anon_sym_BANG_EQ] = ACTIONS(2340),
    [anon_sym_COLON_EQ] = ACTIONS(2342),
    [anon_sym_DOLLAR] = ACTIONS(2340),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2340),
    [sym_int] = ACTIONS(2340),
    [sym_xint] = ACTIONS(2342),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2342),
    [anon_sym_POUNDendif] = ACTIONS(2342),
    [anon_sym_POUNDelse] = ACTIONS(2342),
    [sym__newline] = ACTIONS(2342),
  },
  [1184] = {
    [sym_block_comment] = STATE(1184),
    [sym_compiler_directive_decl] = STATE(1184),
    [sym_fsi_directive_decl] = STATE(1184),
    [sym_preproc_line] = STATE(1184),
    [sym_identifier] = ACTIONS(2627),
    [anon_sym_EQ] = ACTIONS(2629),
    [anon_sym_COLON] = ACTIONS(2627),
    [anon_sym_return] = ACTIONS(2627),
    [anon_sym_do] = ACTIONS(2627),
    [anon_sym_let] = ACTIONS(2627),
    [anon_sym_let_BANG] = ACTIONS(2629),
    [anon_sym_LPAREN] = ACTIONS(2627),
    [anon_sym_COMMA] = ACTIONS(2629),
    [anon_sym_null] = ACTIONS(2627),
    [anon_sym_QMARK] = ACTIONS(2627),
    [anon_sym_COLON_QMARK] = ACTIONS(2627),
    [anon_sym_COLON_COLON] = ACTIONS(2629),
    [anon_sym_AMP] = ACTIONS(2627),
    [anon_sym_LBRACK] = ACTIONS(2627),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2629),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_LT_AT] = ACTIONS(2627),
    [anon_sym_LT_AT_AT] = ACTIONS(2627),
    [anon_sym_DOT] = ACTIONS(2627),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2629),
    [anon_sym_new] = ACTIONS(2627),
    [anon_sym_return_BANG] = ACTIONS(2629),
    [anon_sym_yield] = ACTIONS(2627),
    [anon_sym_yield_BANG] = ACTIONS(2629),
    [anon_sym_lazy] = ACTIONS(2627),
    [anon_sym_assert] = ACTIONS(2627),
    [anon_sym_upcast] = ACTIONS(2627),
    [anon_sym_downcast] = ACTIONS(2627),
    [anon_sym_COLON_GT] = ACTIONS(2629),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2629),
    [anon_sym_for] = ACTIONS(2627),
    [anon_sym_while] = ACTIONS(2627),
    [anon_sym_if] = ACTIONS(2627),
    [anon_sym_fun] = ACTIONS(2627),
    [anon_sym_DASH_GT] = ACTIONS(2627),
    [anon_sym_try] = ACTIONS(2627),
    [anon_sym_match] = ACTIONS(2627),
    [anon_sym_match_BANG] = ACTIONS(2629),
    [anon_sym_function] = ACTIONS(2627),
    [anon_sym_LT_DASH] = ACTIONS(2627),
    [anon_sym_DOT_LBRACK] = ACTIONS(2629),
    [anon_sym_LT] = ACTIONS(2629),
    [anon_sym_use] = ACTIONS(2627),
    [anon_sym_use_BANG] = ACTIONS(2629),
    [anon_sym_do_BANG] = ACTIONS(2629),
    [anon_sym_begin] = ACTIONS(2627),
    [anon_sym_LPAREN2] = ACTIONS(2627),
    [anon_sym_STAR] = ACTIONS(2627),
    [anon_sym_LT2] = ACTIONS(2627),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2629),
    [anon_sym_or] = ACTIONS(2627),
    [aux_sym_char_token1] = ACTIONS(2629),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2627),
    [anon_sym_DQUOTE] = ACTIONS(2627),
    [anon_sym_AT_DQUOTE] = ACTIONS(2629),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2629),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2629),
    [sym_bool] = ACTIONS(2627),
    [sym_unit] = ACTIONS(2629),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2627),
    [sym_op_identifier] = ACTIONS(2627),
    [anon_sym_PLUS] = ACTIONS(2627),
    [anon_sym_DASH] = ACTIONS(2627),
    [anon_sym_PLUS_DOT] = ACTIONS(2627),
    [anon_sym_DASH_DOT] = ACTIONS(2627),
    [anon_sym_PERCENT] = ACTIONS(2627),
    [anon_sym_AMP_AMP] = ACTIONS(2627),
    [anon_sym_TILDE] = ACTIONS(2629),
    [aux_sym_prefix_op_token1] = ACTIONS(2627),
    [aux_sym_infix_op_token1] = ACTIONS(2629),
    [aux_sym_infix_op_token2] = ACTIONS(2627),
    [anon_sym_PIPE_PIPE] = ACTIONS(2627),
    [anon_sym_BANG_EQ] = ACTIONS(2627),
    [anon_sym_COLON_EQ] = ACTIONS(2629),
    [anon_sym_DOLLAR] = ACTIONS(2627),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2627),
    [sym_int] = ACTIONS(2627),
    [sym_xint] = ACTIONS(2629),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2629),
    [anon_sym_POUNDendif] = ACTIONS(2629),
    [anon_sym_POUNDelse] = ACTIONS(2629),
    [sym__newline] = ACTIONS(2629),
  },
  [1185] = {
    [sym_block_comment] = STATE(1185),
    [sym_compiler_directive_decl] = STATE(1185),
    [sym_fsi_directive_decl] = STATE(1185),
    [sym_preproc_line] = STATE(1185),
    [sym_identifier] = ACTIONS(2510),
    [anon_sym_EQ] = ACTIONS(2512),
    [anon_sym_COLON] = ACTIONS(2510),
    [anon_sym_return] = ACTIONS(2510),
    [anon_sym_do] = ACTIONS(2510),
    [anon_sym_let] = ACTIONS(2510),
    [anon_sym_let_BANG] = ACTIONS(2512),
    [anon_sym_as] = ACTIONS(2510),
    [anon_sym_LPAREN] = ACTIONS(2510),
    [anon_sym_COMMA] = ACTIONS(2512),
    [anon_sym_null] = ACTIONS(2510),
    [anon_sym_QMARK] = ACTIONS(2510),
    [anon_sym_COLON_QMARK] = ACTIONS(2510),
    [anon_sym_COLON_COLON] = ACTIONS(2512),
    [anon_sym_AMP] = ACTIONS(2510),
    [anon_sym_LBRACK] = ACTIONS(2510),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2512),
    [anon_sym_LBRACE] = ACTIONS(2510),
    [anon_sym_LT_AT] = ACTIONS(2510),
    [anon_sym_LT_AT_AT] = ACTIONS(2510),
    [anon_sym_DOT] = ACTIONS(2510),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2512),
    [anon_sym_new] = ACTIONS(2510),
    [anon_sym_with] = ACTIONS(2510),
    [anon_sym_return_BANG] = ACTIONS(2512),
    [anon_sym_yield] = ACTIONS(2510),
    [anon_sym_yield_BANG] = ACTIONS(2512),
    [anon_sym_lazy] = ACTIONS(2510),
    [anon_sym_assert] = ACTIONS(2510),
    [anon_sym_upcast] = ACTIONS(2510),
    [anon_sym_downcast] = ACTIONS(2510),
    [anon_sym_COLON_GT] = ACTIONS(2512),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2512),
    [anon_sym_for] = ACTIONS(2510),
    [anon_sym_while] = ACTIONS(2510),
    [anon_sym_if] = ACTIONS(2510),
    [anon_sym_fun] = ACTIONS(2510),
    [anon_sym_DASH_GT] = ACTIONS(2510),
    [anon_sym_try] = ACTIONS(2510),
    [anon_sym_match] = ACTIONS(2510),
    [anon_sym_match_BANG] = ACTIONS(2512),
    [anon_sym_function] = ACTIONS(2510),
    [anon_sym_LT_DASH] = ACTIONS(2510),
    [anon_sym_DOT_LBRACK] = ACTIONS(2512),
    [anon_sym_LT] = ACTIONS(2512),
    [anon_sym_use] = ACTIONS(2510),
    [anon_sym_use_BANG] = ACTIONS(2512),
    [anon_sym_do_BANG] = ACTIONS(2512),
    [anon_sym_begin] = ACTIONS(2510),
    [anon_sym_LPAREN2] = ACTIONS(2510),
    [anon_sym_STAR] = ACTIONS(2510),
    [anon_sym_LT2] = ACTIONS(2510),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2512),
    [anon_sym_or] = ACTIONS(2510),
    [aux_sym_char_token1] = ACTIONS(2512),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2510),
    [anon_sym_DQUOTE] = ACTIONS(2510),
    [anon_sym_AT_DQUOTE] = ACTIONS(2512),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2512),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2512),
    [sym_bool] = ACTIONS(2510),
    [sym_unit] = ACTIONS(2512),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2510),
    [sym_op_identifier] = ACTIONS(2510),
    [anon_sym_PLUS] = ACTIONS(2510),
    [anon_sym_DASH] = ACTIONS(2510),
    [anon_sym_PLUS_DOT] = ACTIONS(2510),
    [anon_sym_DASH_DOT] = ACTIONS(2510),
    [anon_sym_PERCENT] = ACTIONS(2510),
    [anon_sym_AMP_AMP] = ACTIONS(2510),
    [anon_sym_TILDE] = ACTIONS(2512),
    [aux_sym_prefix_op_token1] = ACTIONS(2510),
    [aux_sym_infix_op_token1] = ACTIONS(2512),
    [aux_sym_infix_op_token2] = ACTIONS(2510),
    [anon_sym_PIPE_PIPE] = ACTIONS(2510),
    [anon_sym_BANG_EQ] = ACTIONS(2510),
    [anon_sym_COLON_EQ] = ACTIONS(2512),
    [anon_sym_DOLLAR] = ACTIONS(2510),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2510),
    [sym_int] = ACTIONS(2510),
    [sym_xint] = ACTIONS(2512),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2512),
    [sym__newline] = ACTIONS(2512),
  },
  [1186] = {
    [sym_block_comment] = STATE(1186),
    [sym_compiler_directive_decl] = STATE(1186),
    [sym_fsi_directive_decl] = STATE(1186),
    [sym_preproc_line] = STATE(1186),
    [sym_identifier] = ACTIONS(2411),
    [anon_sym_EQ] = ACTIONS(2413),
    [anon_sym_COLON] = ACTIONS(2411),
    [anon_sym_return] = ACTIONS(2411),
    [anon_sym_do] = ACTIONS(2411),
    [anon_sym_let] = ACTIONS(2411),
    [anon_sym_let_BANG] = ACTIONS(2413),
    [anon_sym_LPAREN] = ACTIONS(2411),
    [anon_sym_COMMA] = ACTIONS(2413),
    [anon_sym_null] = ACTIONS(2411),
    [anon_sym_QMARK] = ACTIONS(2411),
    [anon_sym_COLON_QMARK] = ACTIONS(2411),
    [anon_sym_COLON_COLON] = ACTIONS(2413),
    [anon_sym_AMP] = ACTIONS(2411),
    [anon_sym_LBRACK] = ACTIONS(2411),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2413),
    [anon_sym_LBRACE] = ACTIONS(2411),
    [anon_sym_LT_AT] = ACTIONS(2411),
    [anon_sym_LT_AT_AT] = ACTIONS(2411),
    [anon_sym_DOT] = ACTIONS(2411),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2413),
    [anon_sym_new] = ACTIONS(2411),
    [anon_sym_return_BANG] = ACTIONS(2413),
    [anon_sym_yield] = ACTIONS(2411),
    [anon_sym_yield_BANG] = ACTIONS(2413),
    [anon_sym_lazy] = ACTIONS(2411),
    [anon_sym_assert] = ACTIONS(2411),
    [anon_sym_upcast] = ACTIONS(2411),
    [anon_sym_downcast] = ACTIONS(2411),
    [anon_sym_COLON_GT] = ACTIONS(2413),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2413),
    [anon_sym_for] = ACTIONS(2411),
    [anon_sym_while] = ACTIONS(2411),
    [anon_sym_if] = ACTIONS(2411),
    [anon_sym_fun] = ACTIONS(2411),
    [anon_sym_DASH_GT] = ACTIONS(2411),
    [anon_sym_try] = ACTIONS(2411),
    [anon_sym_match] = ACTIONS(2411),
    [anon_sym_match_BANG] = ACTIONS(2413),
    [anon_sym_function] = ACTIONS(2411),
    [anon_sym_LT_DASH] = ACTIONS(2411),
    [anon_sym_DOT_LBRACK] = ACTIONS(2413),
    [anon_sym_LT] = ACTIONS(2413),
    [anon_sym_use] = ACTIONS(2411),
    [anon_sym_use_BANG] = ACTIONS(2413),
    [anon_sym_do_BANG] = ACTIONS(2413),
    [anon_sym_begin] = ACTIONS(2411),
    [anon_sym_LPAREN2] = ACTIONS(2411),
    [anon_sym_STAR] = ACTIONS(2411),
    [anon_sym_LT2] = ACTIONS(2411),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2413),
    [anon_sym_or] = ACTIONS(2411),
    [aux_sym_char_token1] = ACTIONS(2413),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2411),
    [anon_sym_DQUOTE] = ACTIONS(2411),
    [anon_sym_AT_DQUOTE] = ACTIONS(2413),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2413),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2413),
    [sym_bool] = ACTIONS(2411),
    [sym_unit] = ACTIONS(2413),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2411),
    [sym_op_identifier] = ACTIONS(2411),
    [anon_sym_PLUS] = ACTIONS(2411),
    [anon_sym_DASH] = ACTIONS(2411),
    [anon_sym_PLUS_DOT] = ACTIONS(2411),
    [anon_sym_DASH_DOT] = ACTIONS(2411),
    [anon_sym_PERCENT] = ACTIONS(2411),
    [anon_sym_AMP_AMP] = ACTIONS(2411),
    [anon_sym_TILDE] = ACTIONS(2413),
    [aux_sym_prefix_op_token1] = ACTIONS(2411),
    [aux_sym_infix_op_token1] = ACTIONS(2413),
    [aux_sym_infix_op_token2] = ACTIONS(2411),
    [anon_sym_PIPE_PIPE] = ACTIONS(2411),
    [anon_sym_BANG_EQ] = ACTIONS(2411),
    [anon_sym_COLON_EQ] = ACTIONS(2413),
    [anon_sym_DOLLAR] = ACTIONS(2411),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2411),
    [sym_int] = ACTIONS(2411),
    [sym_xint] = ACTIONS(2413),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2413),
    [anon_sym_POUNDendif] = ACTIONS(2413),
    [anon_sym_POUNDelse] = ACTIONS(2413),
    [sym__newline] = ACTIONS(2413),
  },
  [1187] = {
    [sym_block_comment] = STATE(1187),
    [sym_compiler_directive_decl] = STATE(1187),
    [sym_fsi_directive_decl] = STATE(1187),
    [sym_preproc_line] = STATE(1187),
    [aux_sym_long_identifier_repeat1] = STATE(1200),
    [sym_identifier] = ACTIONS(2418),
    [anon_sym_EQ] = ACTIONS(2420),
    [anon_sym_COLON] = ACTIONS(2418),
    [anon_sym_return] = ACTIONS(2418),
    [anon_sym_do] = ACTIONS(2418),
    [anon_sym_let] = ACTIONS(2418),
    [anon_sym_let_BANG] = ACTIONS(2420),
    [anon_sym_LPAREN] = ACTIONS(2418),
    [anon_sym_COMMA] = ACTIONS(2420),
    [anon_sym_null] = ACTIONS(2418),
    [anon_sym_QMARK] = ACTIONS(2418),
    [anon_sym_COLON_QMARK] = ACTIONS(2418),
    [anon_sym_COLON_COLON] = ACTIONS(2420),
    [anon_sym_AMP] = ACTIONS(2418),
    [anon_sym_LBRACK] = ACTIONS(2418),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2420),
    [anon_sym_LBRACE] = ACTIONS(2418),
    [anon_sym_LT_AT] = ACTIONS(2418),
    [anon_sym_LT_AT_AT] = ACTIONS(2418),
    [anon_sym_AT_AT_GT] = ACTIONS(2418),
    [anon_sym_DOT] = ACTIONS(3361),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2420),
    [anon_sym_new] = ACTIONS(2418),
    [anon_sym_return_BANG] = ACTIONS(2420),
    [anon_sym_yield] = ACTIONS(2418),
    [anon_sym_yield_BANG] = ACTIONS(2420),
    [anon_sym_lazy] = ACTIONS(2418),
    [anon_sym_assert] = ACTIONS(2418),
    [anon_sym_upcast] = ACTIONS(2418),
    [anon_sym_downcast] = ACTIONS(2418),
    [anon_sym_COLON_GT] = ACTIONS(2420),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2420),
    [anon_sym_for] = ACTIONS(2418),
    [anon_sym_while] = ACTIONS(2418),
    [anon_sym_if] = ACTIONS(2418),
    [anon_sym_fun] = ACTIONS(2418),
    [anon_sym_DASH_GT] = ACTIONS(2418),
    [anon_sym_try] = ACTIONS(2418),
    [anon_sym_match] = ACTIONS(2418),
    [anon_sym_match_BANG] = ACTIONS(2420),
    [anon_sym_function] = ACTIONS(2418),
    [anon_sym_LT_DASH] = ACTIONS(2418),
    [anon_sym_DOT_LBRACK] = ACTIONS(2420),
    [anon_sym_LT] = ACTIONS(2420),
    [anon_sym_use] = ACTIONS(2418),
    [anon_sym_use_BANG] = ACTIONS(2420),
    [anon_sym_do_BANG] = ACTIONS(2420),
    [anon_sym_begin] = ACTIONS(2418),
    [anon_sym_LPAREN2] = ACTIONS(2418),
    [anon_sym_STAR] = ACTIONS(2418),
    [anon_sym_LT2] = ACTIONS(2418),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2420),
    [anon_sym_or] = ACTIONS(2418),
    [aux_sym_char_token1] = ACTIONS(2420),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2418),
    [anon_sym_DQUOTE] = ACTIONS(2418),
    [anon_sym_AT_DQUOTE] = ACTIONS(2420),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2420),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2420),
    [sym_bool] = ACTIONS(2418),
    [sym_unit] = ACTIONS(2420),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2418),
    [sym_op_identifier] = ACTIONS(2418),
    [anon_sym_PLUS] = ACTIONS(2418),
    [anon_sym_DASH] = ACTIONS(2418),
    [anon_sym_PLUS_DOT] = ACTIONS(2418),
    [anon_sym_DASH_DOT] = ACTIONS(2418),
    [anon_sym_PERCENT] = ACTIONS(2418),
    [anon_sym_AMP_AMP] = ACTIONS(2418),
    [anon_sym_TILDE] = ACTIONS(2420),
    [aux_sym_prefix_op_token1] = ACTIONS(2418),
    [aux_sym_infix_op_token1] = ACTIONS(2420),
    [aux_sym_infix_op_token2] = ACTIONS(2418),
    [anon_sym_PIPE_PIPE] = ACTIONS(2418),
    [anon_sym_BANG_EQ] = ACTIONS(2418),
    [anon_sym_COLON_EQ] = ACTIONS(2420),
    [anon_sym_DOLLAR] = ACTIONS(2418),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2418),
    [sym_int] = ACTIONS(2418),
    [sym_xint] = ACTIONS(2420),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2420),
    [sym__newline] = ACTIONS(2420),
  },
  [1188] = {
    [sym_block_comment] = STATE(1188),
    [sym_compiler_directive_decl] = STATE(1188),
    [sym_fsi_directive_decl] = STATE(1188),
    [sym_preproc_line] = STATE(1188),
    [sym_identifier] = ACTIONS(2506),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_COLON] = ACTIONS(2506),
    [anon_sym_return] = ACTIONS(2506),
    [anon_sym_do] = ACTIONS(2506),
    [anon_sym_and] = ACTIONS(2506),
    [anon_sym_let] = ACTIONS(2506),
    [anon_sym_let_BANG] = ACTIONS(2508),
    [anon_sym_LPAREN] = ACTIONS(2506),
    [anon_sym_COMMA] = ACTIONS(2508),
    [anon_sym_null] = ACTIONS(2506),
    [anon_sym_QMARK] = ACTIONS(2506),
    [anon_sym_COLON_QMARK] = ACTIONS(2506),
    [anon_sym_COLON_COLON] = ACTIONS(2508),
    [anon_sym_AMP] = ACTIONS(2506),
    [anon_sym_LBRACK] = ACTIONS(2506),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2508),
    [anon_sym_LBRACE] = ACTIONS(2506),
    [anon_sym_LT_AT] = ACTIONS(2506),
    [anon_sym_LT_AT_AT] = ACTIONS(2506),
    [anon_sym_DOT] = ACTIONS(2506),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2508),
    [anon_sym_new] = ACTIONS(2506),
    [anon_sym_return_BANG] = ACTIONS(2508),
    [anon_sym_yield] = ACTIONS(2506),
    [anon_sym_yield_BANG] = ACTIONS(2508),
    [anon_sym_lazy] = ACTIONS(2506),
    [anon_sym_assert] = ACTIONS(2506),
    [anon_sym_upcast] = ACTIONS(2506),
    [anon_sym_downcast] = ACTIONS(2506),
    [anon_sym_COLON_GT] = ACTIONS(2508),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2508),
    [anon_sym_for] = ACTIONS(2506),
    [anon_sym_while] = ACTIONS(2506),
    [anon_sym_if] = ACTIONS(2506),
    [anon_sym_fun] = ACTIONS(2506),
    [anon_sym_DASH_GT] = ACTIONS(2506),
    [anon_sym_try] = ACTIONS(2506),
    [anon_sym_match] = ACTIONS(2506),
    [anon_sym_match_BANG] = ACTIONS(2508),
    [anon_sym_function] = ACTIONS(2506),
    [anon_sym_LT_DASH] = ACTIONS(2506),
    [anon_sym_DOT_LBRACK] = ACTIONS(2508),
    [anon_sym_LT] = ACTIONS(2508),
    [anon_sym_use] = ACTIONS(2506),
    [anon_sym_use_BANG] = ACTIONS(2508),
    [anon_sym_do_BANG] = ACTIONS(2508),
    [anon_sym_begin] = ACTIONS(2506),
    [anon_sym_LPAREN2] = ACTIONS(2506),
    [anon_sym_STAR] = ACTIONS(2506),
    [anon_sym_LT2] = ACTIONS(2506),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2508),
    [anon_sym_or] = ACTIONS(2506),
    [aux_sym_char_token1] = ACTIONS(2508),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2506),
    [anon_sym_DQUOTE] = ACTIONS(2506),
    [anon_sym_AT_DQUOTE] = ACTIONS(2508),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2508),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2508),
    [sym_bool] = ACTIONS(2506),
    [sym_unit] = ACTIONS(2508),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2506),
    [sym_op_identifier] = ACTIONS(2506),
    [anon_sym_PLUS] = ACTIONS(2506),
    [anon_sym_DASH] = ACTIONS(2506),
    [anon_sym_PLUS_DOT] = ACTIONS(2506),
    [anon_sym_DASH_DOT] = ACTIONS(2506),
    [anon_sym_PERCENT] = ACTIONS(2506),
    [anon_sym_AMP_AMP] = ACTIONS(2506),
    [anon_sym_TILDE] = ACTIONS(2508),
    [aux_sym_prefix_op_token1] = ACTIONS(2506),
    [aux_sym_infix_op_token1] = ACTIONS(2508),
    [aux_sym_infix_op_token2] = ACTIONS(2506),
    [anon_sym_PIPE_PIPE] = ACTIONS(2506),
    [anon_sym_BANG_EQ] = ACTIONS(2506),
    [anon_sym_COLON_EQ] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(2506),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2506),
    [sym_int] = ACTIONS(2506),
    [sym_xint] = ACTIONS(2508),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2508),
    [sym__newline] = ACTIONS(2508),
    [sym__dedent] = ACTIONS(2508),
  },
  [1189] = {
    [sym_block_comment] = STATE(1189),
    [sym_compiler_directive_decl] = STATE(1189),
    [sym_fsi_directive_decl] = STATE(1189),
    [sym_preproc_line] = STATE(1189),
    [sym_identifier] = ACTIONS(2567),
    [anon_sym_EQ] = ACTIONS(2569),
    [anon_sym_COLON] = ACTIONS(2567),
    [anon_sym_return] = ACTIONS(2567),
    [anon_sym_do] = ACTIONS(2567),
    [anon_sym_and] = ACTIONS(2567),
    [anon_sym_let] = ACTIONS(2567),
    [anon_sym_let_BANG] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2567),
    [anon_sym_COMMA] = ACTIONS(2569),
    [anon_sym_null] = ACTIONS(2567),
    [anon_sym_QMARK] = ACTIONS(2567),
    [anon_sym_COLON_QMARK] = ACTIONS(2567),
    [anon_sym_COLON_COLON] = ACTIONS(2569),
    [anon_sym_AMP] = ACTIONS(2567),
    [anon_sym_LBRACK] = ACTIONS(2567),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2569),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_LT_AT] = ACTIONS(2567),
    [anon_sym_LT_AT_AT] = ACTIONS(2567),
    [anon_sym_DOT] = ACTIONS(2567),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2569),
    [anon_sym_new] = ACTIONS(2567),
    [anon_sym_return_BANG] = ACTIONS(2569),
    [anon_sym_yield] = ACTIONS(2567),
    [anon_sym_yield_BANG] = ACTIONS(2569),
    [anon_sym_lazy] = ACTIONS(2567),
    [anon_sym_assert] = ACTIONS(2567),
    [anon_sym_upcast] = ACTIONS(2567),
    [anon_sym_downcast] = ACTIONS(2567),
    [anon_sym_COLON_GT] = ACTIONS(2569),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2569),
    [anon_sym_for] = ACTIONS(2567),
    [anon_sym_while] = ACTIONS(2567),
    [anon_sym_if] = ACTIONS(2567),
    [anon_sym_fun] = ACTIONS(2567),
    [anon_sym_DASH_GT] = ACTIONS(2567),
    [anon_sym_try] = ACTIONS(2567),
    [anon_sym_match] = ACTIONS(2567),
    [anon_sym_match_BANG] = ACTIONS(2569),
    [anon_sym_function] = ACTIONS(2567),
    [anon_sym_LT_DASH] = ACTIONS(2567),
    [anon_sym_DOT_LBRACK] = ACTIONS(2569),
    [anon_sym_LT] = ACTIONS(2569),
    [anon_sym_use] = ACTIONS(2567),
    [anon_sym_use_BANG] = ACTIONS(2569),
    [anon_sym_do_BANG] = ACTIONS(2569),
    [anon_sym_begin] = ACTIONS(2567),
    [anon_sym_LPAREN2] = ACTIONS(2567),
    [anon_sym_STAR] = ACTIONS(2567),
    [anon_sym_LT2] = ACTIONS(2567),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2569),
    [anon_sym_or] = ACTIONS(2567),
    [aux_sym_char_token1] = ACTIONS(2569),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2567),
    [anon_sym_DQUOTE] = ACTIONS(2567),
    [anon_sym_AT_DQUOTE] = ACTIONS(2569),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2569),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2569),
    [sym_bool] = ACTIONS(2567),
    [sym_unit] = ACTIONS(2569),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2567),
    [sym_op_identifier] = ACTIONS(2567),
    [anon_sym_PLUS] = ACTIONS(2567),
    [anon_sym_DASH] = ACTIONS(2567),
    [anon_sym_PLUS_DOT] = ACTIONS(2567),
    [anon_sym_DASH_DOT] = ACTIONS(2567),
    [anon_sym_PERCENT] = ACTIONS(2567),
    [anon_sym_AMP_AMP] = ACTIONS(2567),
    [anon_sym_TILDE] = ACTIONS(2569),
    [aux_sym_prefix_op_token1] = ACTIONS(2567),
    [aux_sym_infix_op_token1] = ACTIONS(2569),
    [aux_sym_infix_op_token2] = ACTIONS(2567),
    [anon_sym_PIPE_PIPE] = ACTIONS(2567),
    [anon_sym_BANG_EQ] = ACTIONS(2567),
    [anon_sym_COLON_EQ] = ACTIONS(2569),
    [anon_sym_DOLLAR] = ACTIONS(2567),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2567),
    [sym_int] = ACTIONS(2567),
    [sym_xint] = ACTIONS(2569),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2569),
    [sym__newline] = ACTIONS(2569),
    [sym__dedent] = ACTIONS(2569),
  },
  [1190] = {
    [sym__else_expression] = STATE(2325),
    [sym_elif_expression] = STATE(1613),
    [sym_block_comment] = STATE(1190),
    [sym_compiler_directive_decl] = STATE(1190),
    [sym_fsi_directive_decl] = STATE(1190),
    [sym_preproc_line] = STATE(1190),
    [aux_sym_if_expression_repeat1] = STATE(1218),
    [sym_identifier] = ACTIONS(2422),
    [anon_sym_EQ] = ACTIONS(2424),
    [anon_sym_COLON] = ACTIONS(2422),
    [anon_sym_return] = ACTIONS(2422),
    [anon_sym_do] = ACTIONS(2422),
    [anon_sym_let] = ACTIONS(2422),
    [anon_sym_let_BANG] = ACTIONS(2424),
    [anon_sym_LPAREN] = ACTIONS(2422),
    [anon_sym_COMMA] = ACTIONS(2424),
    [anon_sym_null] = ACTIONS(2422),
    [anon_sym_QMARK] = ACTIONS(2422),
    [anon_sym_COLON_QMARK] = ACTIONS(2422),
    [anon_sym_COLON_COLON] = ACTIONS(2424),
    [anon_sym_AMP] = ACTIONS(2422),
    [anon_sym_LBRACK] = ACTIONS(2422),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2424),
    [anon_sym_LBRACE] = ACTIONS(2422),
    [anon_sym_LT_AT] = ACTIONS(2422),
    [anon_sym_AT_GT] = ACTIONS(2422),
    [anon_sym_LT_AT_AT] = ACTIONS(2422),
    [anon_sym_DOT] = ACTIONS(2422),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2424),
    [anon_sym_new] = ACTIONS(2422),
    [anon_sym_return_BANG] = ACTIONS(2424),
    [anon_sym_yield] = ACTIONS(2422),
    [anon_sym_yield_BANG] = ACTIONS(2424),
    [anon_sym_lazy] = ACTIONS(2422),
    [anon_sym_assert] = ACTIONS(2422),
    [anon_sym_upcast] = ACTIONS(2422),
    [anon_sym_downcast] = ACTIONS(2422),
    [anon_sym_COLON_GT] = ACTIONS(2424),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2424),
    [anon_sym_for] = ACTIONS(2422),
    [anon_sym_while] = ACTIONS(2422),
    [anon_sym_else] = ACTIONS(3367),
    [anon_sym_elif] = ACTIONS(3369),
    [anon_sym_if] = ACTIONS(2422),
    [anon_sym_fun] = ACTIONS(2422),
    [anon_sym_try] = ACTIONS(2422),
    [anon_sym_match] = ACTIONS(2422),
    [anon_sym_match_BANG] = ACTIONS(2424),
    [anon_sym_function] = ACTIONS(2422),
    [anon_sym_LT_DASH] = ACTIONS(2422),
    [anon_sym_DOT_LBRACK] = ACTIONS(2424),
    [anon_sym_LT] = ACTIONS(2424),
    [anon_sym_use] = ACTIONS(2422),
    [anon_sym_use_BANG] = ACTIONS(2424),
    [anon_sym_do_BANG] = ACTIONS(2424),
    [anon_sym_begin] = ACTIONS(2422),
    [anon_sym_LPAREN2] = ACTIONS(2422),
    [anon_sym_or] = ACTIONS(2422),
    [aux_sym_char_token1] = ACTIONS(2424),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2422),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_AT_DQUOTE] = ACTIONS(2424),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2424),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2424),
    [sym_bool] = ACTIONS(2422),
    [sym_unit] = ACTIONS(2424),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2422),
    [sym_op_identifier] = ACTIONS(2422),
    [anon_sym_PLUS] = ACTIONS(2422),
    [anon_sym_DASH] = ACTIONS(2422),
    [anon_sym_PLUS_DOT] = ACTIONS(2422),
    [anon_sym_DASH_DOT] = ACTIONS(2422),
    [anon_sym_PERCENT] = ACTIONS(2422),
    [anon_sym_AMP_AMP] = ACTIONS(2422),
    [anon_sym_TILDE] = ACTIONS(2424),
    [aux_sym_prefix_op_token1] = ACTIONS(2422),
    [aux_sym_infix_op_token1] = ACTIONS(2424),
    [aux_sym_infix_op_token2] = ACTIONS(2422),
    [anon_sym_PIPE_PIPE] = ACTIONS(2422),
    [anon_sym_BANG_EQ] = ACTIONS(2422),
    [anon_sym_COLON_EQ] = ACTIONS(2424),
    [anon_sym_DOLLAR] = ACTIONS(2422),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2422),
    [sym_int] = ACTIONS(2422),
    [sym_xint] = ACTIONS(2424),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2424),
    [sym__newline] = ACTIONS(2424),
  },
  [1191] = {
    [sym_block_comment] = STATE(1191),
    [sym_compiler_directive_decl] = STATE(1191),
    [sym_fsi_directive_decl] = STATE(1191),
    [sym_preproc_line] = STATE(1191),
    [sym_identifier] = ACTIONS(2470),
    [anon_sym_EQ] = ACTIONS(2472),
    [anon_sym_COLON] = ACTIONS(2470),
    [anon_sym_return] = ACTIONS(2470),
    [anon_sym_do] = ACTIONS(2470),
    [anon_sym_and] = ACTIONS(2470),
    [anon_sym_let] = ACTIONS(2470),
    [anon_sym_let_BANG] = ACTIONS(2472),
    [anon_sym_LPAREN] = ACTIONS(2470),
    [anon_sym_COMMA] = ACTIONS(2472),
    [anon_sym_null] = ACTIONS(2470),
    [anon_sym_QMARK] = ACTIONS(2470),
    [anon_sym_COLON_QMARK] = ACTIONS(2470),
    [anon_sym_COLON_COLON] = ACTIONS(2472),
    [anon_sym_AMP] = ACTIONS(2470),
    [anon_sym_LBRACK] = ACTIONS(2470),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2472),
    [anon_sym_LBRACE] = ACTIONS(2470),
    [anon_sym_LT_AT] = ACTIONS(2470),
    [anon_sym_LT_AT_AT] = ACTIONS(2470),
    [anon_sym_DOT] = ACTIONS(2470),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2472),
    [anon_sym_new] = ACTIONS(2470),
    [anon_sym_return_BANG] = ACTIONS(2472),
    [anon_sym_yield] = ACTIONS(2470),
    [anon_sym_yield_BANG] = ACTIONS(2472),
    [anon_sym_lazy] = ACTIONS(2470),
    [anon_sym_assert] = ACTIONS(2470),
    [anon_sym_upcast] = ACTIONS(2470),
    [anon_sym_downcast] = ACTIONS(2470),
    [anon_sym_COLON_GT] = ACTIONS(2472),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2472),
    [anon_sym_for] = ACTIONS(2470),
    [anon_sym_while] = ACTIONS(2470),
    [anon_sym_if] = ACTIONS(2470),
    [anon_sym_fun] = ACTIONS(2470),
    [anon_sym_DASH_GT] = ACTIONS(2470),
    [anon_sym_try] = ACTIONS(2470),
    [anon_sym_match] = ACTIONS(2470),
    [anon_sym_match_BANG] = ACTIONS(2472),
    [anon_sym_function] = ACTIONS(2470),
    [anon_sym_LT_DASH] = ACTIONS(2470),
    [anon_sym_DOT_LBRACK] = ACTIONS(2472),
    [anon_sym_LT] = ACTIONS(2472),
    [anon_sym_use] = ACTIONS(2470),
    [anon_sym_use_BANG] = ACTIONS(2472),
    [anon_sym_do_BANG] = ACTIONS(2472),
    [anon_sym_begin] = ACTIONS(2470),
    [anon_sym_LPAREN2] = ACTIONS(2470),
    [anon_sym_STAR] = ACTIONS(2470),
    [anon_sym_LT2] = ACTIONS(2470),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2472),
    [anon_sym_or] = ACTIONS(2470),
    [aux_sym_char_token1] = ACTIONS(2472),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2470),
    [anon_sym_DQUOTE] = ACTIONS(2470),
    [anon_sym_AT_DQUOTE] = ACTIONS(2472),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2472),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2472),
    [sym_bool] = ACTIONS(2470),
    [sym_unit] = ACTIONS(2472),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2470),
    [sym_op_identifier] = ACTIONS(2470),
    [anon_sym_PLUS] = ACTIONS(2470),
    [anon_sym_DASH] = ACTIONS(2470),
    [anon_sym_PLUS_DOT] = ACTIONS(2470),
    [anon_sym_DASH_DOT] = ACTIONS(2470),
    [anon_sym_PERCENT] = ACTIONS(2470),
    [anon_sym_AMP_AMP] = ACTIONS(2470),
    [anon_sym_TILDE] = ACTIONS(2472),
    [aux_sym_prefix_op_token1] = ACTIONS(2470),
    [aux_sym_infix_op_token1] = ACTIONS(2472),
    [aux_sym_infix_op_token2] = ACTIONS(2470),
    [anon_sym_PIPE_PIPE] = ACTIONS(2470),
    [anon_sym_BANG_EQ] = ACTIONS(2470),
    [anon_sym_COLON_EQ] = ACTIONS(2472),
    [anon_sym_DOLLAR] = ACTIONS(2470),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2470),
    [sym_int] = ACTIONS(2470),
    [sym_xint] = ACTIONS(2472),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2472),
    [sym__newline] = ACTIONS(2472),
    [sym__dedent] = ACTIONS(2472),
  },
  [1192] = {
    [sym_block_comment] = STATE(1192),
    [sym_compiler_directive_decl] = STATE(1192),
    [sym_fsi_directive_decl] = STATE(1192),
    [sym_preproc_line] = STATE(1192),
    [sym_identifier] = ACTIONS(2454),
    [anon_sym_EQ] = ACTIONS(2456),
    [anon_sym_COLON] = ACTIONS(2454),
    [anon_sym_return] = ACTIONS(2454),
    [anon_sym_do] = ACTIONS(2454),
    [anon_sym_and] = ACTIONS(2454),
    [anon_sym_let] = ACTIONS(2454),
    [anon_sym_let_BANG] = ACTIONS(2456),
    [anon_sym_LPAREN] = ACTIONS(2454),
    [anon_sym_COMMA] = ACTIONS(2456),
    [anon_sym_null] = ACTIONS(2454),
    [anon_sym_QMARK] = ACTIONS(2454),
    [anon_sym_COLON_QMARK] = ACTIONS(2454),
    [anon_sym_COLON_COLON] = ACTIONS(2456),
    [anon_sym_AMP] = ACTIONS(2454),
    [anon_sym_LBRACK] = ACTIONS(2454),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2456),
    [anon_sym_LBRACE] = ACTIONS(2454),
    [anon_sym_LT_AT] = ACTIONS(2454),
    [anon_sym_LT_AT_AT] = ACTIONS(2454),
    [anon_sym_DOT] = ACTIONS(2454),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2456),
    [anon_sym_new] = ACTIONS(2454),
    [anon_sym_return_BANG] = ACTIONS(2456),
    [anon_sym_yield] = ACTIONS(2454),
    [anon_sym_yield_BANG] = ACTIONS(2456),
    [anon_sym_lazy] = ACTIONS(2454),
    [anon_sym_assert] = ACTIONS(2454),
    [anon_sym_upcast] = ACTIONS(2454),
    [anon_sym_downcast] = ACTIONS(2454),
    [anon_sym_COLON_GT] = ACTIONS(2456),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2456),
    [anon_sym_for] = ACTIONS(2454),
    [anon_sym_while] = ACTIONS(2454),
    [anon_sym_if] = ACTIONS(2454),
    [anon_sym_fun] = ACTIONS(2454),
    [anon_sym_DASH_GT] = ACTIONS(2454),
    [anon_sym_try] = ACTIONS(2454),
    [anon_sym_match] = ACTIONS(2454),
    [anon_sym_match_BANG] = ACTIONS(2456),
    [anon_sym_function] = ACTIONS(2454),
    [anon_sym_LT_DASH] = ACTIONS(2454),
    [anon_sym_DOT_LBRACK] = ACTIONS(2456),
    [anon_sym_LT] = ACTIONS(2456),
    [anon_sym_use] = ACTIONS(2454),
    [anon_sym_use_BANG] = ACTIONS(2456),
    [anon_sym_do_BANG] = ACTIONS(2456),
    [anon_sym_begin] = ACTIONS(2454),
    [anon_sym_LPAREN2] = ACTIONS(2454),
    [anon_sym_STAR] = ACTIONS(2454),
    [anon_sym_LT2] = ACTIONS(2454),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2456),
    [anon_sym_or] = ACTIONS(2454),
    [aux_sym_char_token1] = ACTIONS(2456),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2454),
    [anon_sym_DQUOTE] = ACTIONS(2454),
    [anon_sym_AT_DQUOTE] = ACTIONS(2456),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2456),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2456),
    [sym_bool] = ACTIONS(2454),
    [sym_unit] = ACTIONS(2456),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2454),
    [sym_op_identifier] = ACTIONS(2454),
    [anon_sym_PLUS] = ACTIONS(2454),
    [anon_sym_DASH] = ACTIONS(2454),
    [anon_sym_PLUS_DOT] = ACTIONS(2454),
    [anon_sym_DASH_DOT] = ACTIONS(2454),
    [anon_sym_PERCENT] = ACTIONS(2454),
    [anon_sym_AMP_AMP] = ACTIONS(2454),
    [anon_sym_TILDE] = ACTIONS(2456),
    [aux_sym_prefix_op_token1] = ACTIONS(2454),
    [aux_sym_infix_op_token1] = ACTIONS(2456),
    [aux_sym_infix_op_token2] = ACTIONS(2454),
    [anon_sym_PIPE_PIPE] = ACTIONS(2454),
    [anon_sym_BANG_EQ] = ACTIONS(2454),
    [anon_sym_COLON_EQ] = ACTIONS(2456),
    [anon_sym_DOLLAR] = ACTIONS(2454),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2454),
    [sym_int] = ACTIONS(2454),
    [sym_xint] = ACTIONS(2456),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2456),
    [sym__newline] = ACTIONS(2456),
    [sym__dedent] = ACTIONS(2456),
  },
  [1193] = {
    [sym_block_comment] = STATE(1193),
    [sym_compiler_directive_decl] = STATE(1193),
    [sym_fsi_directive_decl] = STATE(1193),
    [sym_preproc_line] = STATE(1193),
    [aux_sym_type_argument_repeat1] = STATE(1250),
    [sym_identifier] = ACTIONS(2328),
    [anon_sym_EQ] = ACTIONS(2330),
    [anon_sym_COLON] = ACTIONS(2328),
    [anon_sym_return] = ACTIONS(2328),
    [anon_sym_do] = ACTIONS(2328),
    [anon_sym_let] = ACTIONS(2328),
    [anon_sym_let_BANG] = ACTIONS(2330),
    [anon_sym_LPAREN] = ACTIONS(2328),
    [anon_sym_COMMA] = ACTIONS(2330),
    [anon_sym_null] = ACTIONS(2328),
    [anon_sym_QMARK] = ACTIONS(2328),
    [anon_sym_COLON_QMARK] = ACTIONS(2328),
    [anon_sym_COLON_COLON] = ACTIONS(2330),
    [anon_sym_AMP] = ACTIONS(2328),
    [anon_sym_LBRACK] = ACTIONS(2328),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2330),
    [anon_sym_LBRACE] = ACTIONS(2328),
    [anon_sym_LT_AT] = ACTIONS(2328),
    [anon_sym_LT_AT_AT] = ACTIONS(2328),
    [anon_sym_AT_AT_GT] = ACTIONS(2328),
    [anon_sym_DOT] = ACTIONS(2328),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2330),
    [anon_sym_new] = ACTIONS(2328),
    [anon_sym_return_BANG] = ACTIONS(2330),
    [anon_sym_yield] = ACTIONS(2328),
    [anon_sym_yield_BANG] = ACTIONS(2330),
    [anon_sym_lazy] = ACTIONS(2328),
    [anon_sym_assert] = ACTIONS(2328),
    [anon_sym_upcast] = ACTIONS(2328),
    [anon_sym_downcast] = ACTIONS(2328),
    [anon_sym_COLON_GT] = ACTIONS(2330),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2330),
    [anon_sym_for] = ACTIONS(2328),
    [anon_sym_while] = ACTIONS(2328),
    [anon_sym_if] = ACTIONS(2328),
    [anon_sym_fun] = ACTIONS(2328),
    [anon_sym_DASH_GT] = ACTIONS(2328),
    [anon_sym_try] = ACTIONS(2328),
    [anon_sym_match] = ACTIONS(2328),
    [anon_sym_match_BANG] = ACTIONS(2330),
    [anon_sym_function] = ACTIONS(2328),
    [anon_sym_LT_DASH] = ACTIONS(2328),
    [anon_sym_DOT_LBRACK] = ACTIONS(2330),
    [anon_sym_LT] = ACTIONS(2330),
    [anon_sym_use] = ACTIONS(2328),
    [anon_sym_use_BANG] = ACTIONS(2330),
    [anon_sym_do_BANG] = ACTIONS(2330),
    [anon_sym_begin] = ACTIONS(2328),
    [anon_sym_LPAREN2] = ACTIONS(2328),
    [anon_sym_STAR] = ACTIONS(2328),
    [anon_sym_LT2] = ACTIONS(2328),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2330),
    [anon_sym_or] = ACTIONS(2328),
    [aux_sym_char_token1] = ACTIONS(2330),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2328),
    [anon_sym_DQUOTE] = ACTIONS(2328),
    [anon_sym_AT_DQUOTE] = ACTIONS(2330),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2330),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2330),
    [sym_bool] = ACTIONS(2328),
    [sym_unit] = ACTIONS(2330),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2328),
    [sym_op_identifier] = ACTIONS(2328),
    [anon_sym_PLUS] = ACTIONS(2328),
    [anon_sym_DASH] = ACTIONS(2328),
    [anon_sym_PLUS_DOT] = ACTIONS(2328),
    [anon_sym_DASH_DOT] = ACTIONS(2328),
    [anon_sym_PERCENT] = ACTIONS(2328),
    [anon_sym_AMP_AMP] = ACTIONS(2328),
    [anon_sym_TILDE] = ACTIONS(2330),
    [aux_sym_prefix_op_token1] = ACTIONS(2328),
    [aux_sym_infix_op_token1] = ACTIONS(2330),
    [aux_sym_infix_op_token2] = ACTIONS(2328),
    [anon_sym_PIPE_PIPE] = ACTIONS(2328),
    [anon_sym_BANG_EQ] = ACTIONS(2328),
    [anon_sym_COLON_EQ] = ACTIONS(2330),
    [anon_sym_DOLLAR] = ACTIONS(2328),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2328),
    [sym_int] = ACTIONS(2328),
    [sym_xint] = ACTIONS(2330),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2330),
    [sym__newline] = ACTIONS(2330),
  },
  [1194] = {
    [sym_block_comment] = STATE(1194),
    [sym_compiler_directive_decl] = STATE(1194),
    [sym_fsi_directive_decl] = STATE(1194),
    [sym_preproc_line] = STATE(1194),
    [aux_sym_long_identifier_repeat1] = STATE(1209),
    [sym_identifier] = ACTIONS(2312),
    [anon_sym_EQ] = ACTIONS(2314),
    [anon_sym_COLON] = ACTIONS(2312),
    [anon_sym_return] = ACTIONS(2312),
    [anon_sym_do] = ACTIONS(2312),
    [anon_sym_let] = ACTIONS(2312),
    [anon_sym_let_BANG] = ACTIONS(2314),
    [anon_sym_LPAREN] = ACTIONS(2312),
    [anon_sym_COMMA] = ACTIONS(2314),
    [anon_sym_null] = ACTIONS(2312),
    [anon_sym_QMARK] = ACTIONS(2312),
    [anon_sym_COLON_QMARK] = ACTIONS(2312),
    [anon_sym_COLON_COLON] = ACTIONS(2314),
    [anon_sym_AMP] = ACTIONS(2312),
    [anon_sym_LBRACK] = ACTIONS(2312),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2314),
    [anon_sym_LBRACE] = ACTIONS(2312),
    [anon_sym_LT_AT] = ACTIONS(2312),
    [anon_sym_LT_AT_AT] = ACTIONS(2312),
    [anon_sym_DOT] = ACTIONS(3371),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2314),
    [anon_sym_new] = ACTIONS(2312),
    [anon_sym_return_BANG] = ACTIONS(2314),
    [anon_sym_yield] = ACTIONS(2312),
    [anon_sym_yield_BANG] = ACTIONS(2314),
    [anon_sym_lazy] = ACTIONS(2312),
    [anon_sym_assert] = ACTIONS(2312),
    [anon_sym_upcast] = ACTIONS(2312),
    [anon_sym_downcast] = ACTIONS(2312),
    [anon_sym_COLON_GT] = ACTIONS(2314),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2314),
    [anon_sym_for] = ACTIONS(2312),
    [anon_sym_while] = ACTIONS(2312),
    [anon_sym_if] = ACTIONS(2312),
    [anon_sym_fun] = ACTIONS(2312),
    [anon_sym_DASH_GT] = ACTIONS(2312),
    [anon_sym_try] = ACTIONS(2312),
    [anon_sym_match] = ACTIONS(2312),
    [anon_sym_match_BANG] = ACTIONS(2314),
    [anon_sym_function] = ACTIONS(2312),
    [anon_sym_LT_DASH] = ACTIONS(2312),
    [anon_sym_DOT_LBRACK] = ACTIONS(2314),
    [anon_sym_LT] = ACTIONS(2314),
    [anon_sym_use] = ACTIONS(2312),
    [anon_sym_use_BANG] = ACTIONS(2314),
    [anon_sym_do_BANG] = ACTIONS(2314),
    [anon_sym_begin] = ACTIONS(2312),
    [anon_sym_LPAREN2] = ACTIONS(2312),
    [anon_sym_STAR] = ACTIONS(2312),
    [anon_sym_LT2] = ACTIONS(2312),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2314),
    [anon_sym_or] = ACTIONS(2312),
    [aux_sym_char_token1] = ACTIONS(2314),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2312),
    [anon_sym_DQUOTE] = ACTIONS(2312),
    [anon_sym_AT_DQUOTE] = ACTIONS(2314),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2314),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2314),
    [sym_bool] = ACTIONS(2312),
    [sym_unit] = ACTIONS(2314),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2312),
    [sym_op_identifier] = ACTIONS(2312),
    [anon_sym_PLUS] = ACTIONS(2312),
    [anon_sym_DASH] = ACTIONS(2312),
    [anon_sym_PLUS_DOT] = ACTIONS(2312),
    [anon_sym_DASH_DOT] = ACTIONS(2312),
    [anon_sym_PERCENT] = ACTIONS(2312),
    [anon_sym_AMP_AMP] = ACTIONS(2312),
    [anon_sym_TILDE] = ACTIONS(2314),
    [aux_sym_prefix_op_token1] = ACTIONS(2312),
    [aux_sym_infix_op_token1] = ACTIONS(2314),
    [aux_sym_infix_op_token2] = ACTIONS(2312),
    [anon_sym_PIPE_PIPE] = ACTIONS(2312),
    [anon_sym_BANG_EQ] = ACTIONS(2312),
    [anon_sym_COLON_EQ] = ACTIONS(2314),
    [anon_sym_DOLLAR] = ACTIONS(2312),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2312),
    [sym_int] = ACTIONS(2312),
    [sym_xint] = ACTIONS(2314),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2314),
    [anon_sym_POUNDendif] = ACTIONS(2314),
    [sym__newline] = ACTIONS(2314),
  },
  [1195] = {
    [sym_block_comment] = STATE(1195),
    [sym_compiler_directive_decl] = STATE(1195),
    [sym_fsi_directive_decl] = STATE(1195),
    [sym_preproc_line] = STATE(1195),
    [sym_identifier] = ACTIONS(2723),
    [anon_sym_EQ] = ACTIONS(2725),
    [anon_sym_COLON] = ACTIONS(2723),
    [anon_sym_return] = ACTIONS(2723),
    [anon_sym_do] = ACTIONS(2723),
    [anon_sym_let] = ACTIONS(2723),
    [anon_sym_let_BANG] = ACTIONS(2725),
    [anon_sym_as] = ACTIONS(2723),
    [anon_sym_LPAREN] = ACTIONS(2723),
    [anon_sym_COMMA] = ACTIONS(2725),
    [anon_sym_null] = ACTIONS(2723),
    [anon_sym_QMARK] = ACTIONS(2723),
    [anon_sym_COLON_QMARK] = ACTIONS(2723),
    [anon_sym_COLON_COLON] = ACTIONS(2725),
    [anon_sym_AMP] = ACTIONS(2723),
    [anon_sym_LBRACK] = ACTIONS(2723),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2725),
    [anon_sym_LBRACE] = ACTIONS(2723),
    [anon_sym_LT_AT] = ACTIONS(2723),
    [anon_sym_LT_AT_AT] = ACTIONS(2723),
    [anon_sym_DOT] = ACTIONS(2723),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2725),
    [anon_sym_new] = ACTIONS(2723),
    [anon_sym_with] = ACTIONS(2723),
    [anon_sym_return_BANG] = ACTIONS(2725),
    [anon_sym_yield] = ACTIONS(2723),
    [anon_sym_yield_BANG] = ACTIONS(2725),
    [anon_sym_lazy] = ACTIONS(2723),
    [anon_sym_assert] = ACTIONS(2723),
    [anon_sym_upcast] = ACTIONS(2723),
    [anon_sym_downcast] = ACTIONS(2723),
    [anon_sym_COLON_GT] = ACTIONS(2725),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2725),
    [anon_sym_for] = ACTIONS(2723),
    [anon_sym_while] = ACTIONS(2723),
    [anon_sym_if] = ACTIONS(2723),
    [anon_sym_fun] = ACTIONS(2723),
    [anon_sym_try] = ACTIONS(2723),
    [anon_sym_match] = ACTIONS(2723),
    [anon_sym_match_BANG] = ACTIONS(2725),
    [anon_sym_function] = ACTIONS(2723),
    [anon_sym_LT_DASH] = ACTIONS(2723),
    [anon_sym_DOT_LBRACK] = ACTIONS(2725),
    [anon_sym_LT] = ACTIONS(2725),
    [anon_sym_use] = ACTIONS(2723),
    [anon_sym_use_BANG] = ACTIONS(2725),
    [anon_sym_do_BANG] = ACTIONS(2725),
    [anon_sym_begin] = ACTIONS(2723),
    [anon_sym_LPAREN2] = ACTIONS(2723),
    [anon_sym_or] = ACTIONS(2723),
    [aux_sym_char_token1] = ACTIONS(2725),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2723),
    [anon_sym_DQUOTE] = ACTIONS(2723),
    [anon_sym_AT_DQUOTE] = ACTIONS(2725),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2725),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2725),
    [sym_bool] = ACTIONS(2723),
    [sym_unit] = ACTIONS(2725),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2723),
    [sym_op_identifier] = ACTIONS(2723),
    [anon_sym_PLUS] = ACTIONS(2723),
    [anon_sym_DASH] = ACTIONS(2723),
    [anon_sym_PLUS_DOT] = ACTIONS(2723),
    [anon_sym_DASH_DOT] = ACTIONS(2723),
    [anon_sym_PERCENT] = ACTIONS(2723),
    [anon_sym_AMP_AMP] = ACTIONS(2723),
    [anon_sym_TILDE] = ACTIONS(2725),
    [aux_sym_prefix_op_token1] = ACTIONS(2723),
    [aux_sym_infix_op_token1] = ACTIONS(2725),
    [aux_sym_infix_op_token2] = ACTIONS(2723),
    [anon_sym_PIPE_PIPE] = ACTIONS(2723),
    [anon_sym_BANG_EQ] = ACTIONS(2723),
    [anon_sym_COLON_EQ] = ACTIONS(2725),
    [anon_sym_DOLLAR] = ACTIONS(2723),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2723),
    [sym_int] = ACTIONS(2723),
    [sym_xint] = ACTIONS(2725),
    [anon_sym_f] = ACTIONS(2723),
    [aux_sym_decimal_token1] = ACTIONS(2723),
    [aux_sym_float_token1] = ACTIONS(3373),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2725),
    [sym__newline] = ACTIONS(2725),
    [sym__dedent] = ACTIONS(2725),
  },
  [1196] = {
    [sym_block_comment] = STATE(1196),
    [sym_compiler_directive_decl] = STATE(1196),
    [sym_fsi_directive_decl] = STATE(1196),
    [sym_preproc_line] = STATE(1196),
    [aux_sym_compound_type_repeat1] = STATE(1196),
    [sym_identifier] = ACTIONS(2250),
    [anon_sym_EQ] = ACTIONS(2248),
    [anon_sym_COLON] = ACTIONS(2250),
    [anon_sym_return] = ACTIONS(2250),
    [anon_sym_do] = ACTIONS(2250),
    [anon_sym_let] = ACTIONS(2250),
    [anon_sym_let_BANG] = ACTIONS(2248),
    [anon_sym_LPAREN] = ACTIONS(2250),
    [anon_sym_COMMA] = ACTIONS(2248),
    [anon_sym_null] = ACTIONS(2250),
    [anon_sym_QMARK] = ACTIONS(2250),
    [anon_sym_COLON_QMARK] = ACTIONS(2250),
    [anon_sym_COLON_COLON] = ACTIONS(2248),
    [anon_sym_AMP] = ACTIONS(2250),
    [anon_sym_LBRACK] = ACTIONS(2250),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2248),
    [anon_sym_LBRACE] = ACTIONS(2250),
    [anon_sym_LT_AT] = ACTIONS(2250),
    [anon_sym_AT_GT] = ACTIONS(2250),
    [anon_sym_LT_AT_AT] = ACTIONS(2250),
    [anon_sym_DOT] = ACTIONS(2250),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2248),
    [anon_sym_new] = ACTIONS(2250),
    [anon_sym_return_BANG] = ACTIONS(2248),
    [anon_sym_yield] = ACTIONS(2250),
    [anon_sym_yield_BANG] = ACTIONS(2248),
    [anon_sym_lazy] = ACTIONS(2250),
    [anon_sym_assert] = ACTIONS(2250),
    [anon_sym_upcast] = ACTIONS(2250),
    [anon_sym_downcast] = ACTIONS(2250),
    [anon_sym_COLON_GT] = ACTIONS(2248),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2248),
    [anon_sym_for] = ACTIONS(2250),
    [anon_sym_while] = ACTIONS(2250),
    [anon_sym_if] = ACTIONS(2250),
    [anon_sym_fun] = ACTIONS(2250),
    [anon_sym_DASH_GT] = ACTIONS(2250),
    [anon_sym_try] = ACTIONS(2250),
    [anon_sym_match] = ACTIONS(2250),
    [anon_sym_match_BANG] = ACTIONS(2248),
    [anon_sym_function] = ACTIONS(2250),
    [anon_sym_LT_DASH] = ACTIONS(2250),
    [anon_sym_DOT_LBRACK] = ACTIONS(2248),
    [anon_sym_LT] = ACTIONS(2248),
    [anon_sym_use] = ACTIONS(2250),
    [anon_sym_use_BANG] = ACTIONS(2248),
    [anon_sym_do_BANG] = ACTIONS(2248),
    [anon_sym_begin] = ACTIONS(2250),
    [anon_sym_LPAREN2] = ACTIONS(2250),
    [anon_sym_STAR] = ACTIONS(3375),
    [anon_sym_LT2] = ACTIONS(2250),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2248),
    [anon_sym_or] = ACTIONS(2250),
    [aux_sym_char_token1] = ACTIONS(2248),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2250),
    [anon_sym_DQUOTE] = ACTIONS(2250),
    [anon_sym_AT_DQUOTE] = ACTIONS(2248),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2248),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2248),
    [sym_bool] = ACTIONS(2250),
    [sym_unit] = ACTIONS(2248),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2250),
    [sym_op_identifier] = ACTIONS(2250),
    [anon_sym_PLUS] = ACTIONS(2250),
    [anon_sym_DASH] = ACTIONS(2250),
    [anon_sym_PLUS_DOT] = ACTIONS(2250),
    [anon_sym_DASH_DOT] = ACTIONS(2250),
    [anon_sym_PERCENT] = ACTIONS(2250),
    [anon_sym_AMP_AMP] = ACTIONS(2250),
    [anon_sym_TILDE] = ACTIONS(2248),
    [aux_sym_prefix_op_token1] = ACTIONS(2250),
    [aux_sym_infix_op_token1] = ACTIONS(2248),
    [aux_sym_infix_op_token2] = ACTIONS(2250),
    [anon_sym_PIPE_PIPE] = ACTIONS(2250),
    [anon_sym_BANG_EQ] = ACTIONS(2250),
    [anon_sym_COLON_EQ] = ACTIONS(2248),
    [anon_sym_DOLLAR] = ACTIONS(2250),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2250),
    [sym_int] = ACTIONS(2250),
    [sym_xint] = ACTIONS(2248),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2248),
    [sym__newline] = ACTIONS(2248),
  },
  [1197] = {
    [sym_block_comment] = STATE(1197),
    [sym_compiler_directive_decl] = STATE(1197),
    [sym_fsi_directive_decl] = STATE(1197),
    [sym_preproc_line] = STATE(1197),
    [sym_identifier] = ACTIONS(2567),
    [anon_sym_EQ] = ACTIONS(2569),
    [anon_sym_COLON] = ACTIONS(2567),
    [anon_sym_return] = ACTIONS(2567),
    [anon_sym_do] = ACTIONS(2567),
    [anon_sym_let] = ACTIONS(2567),
    [anon_sym_let_BANG] = ACTIONS(2569),
    [anon_sym_as] = ACTIONS(2567),
    [anon_sym_LPAREN] = ACTIONS(2567),
    [anon_sym_COMMA] = ACTIONS(2569),
    [anon_sym_null] = ACTIONS(2567),
    [anon_sym_QMARK] = ACTIONS(2567),
    [anon_sym_COLON_QMARK] = ACTIONS(2567),
    [anon_sym_COLON_COLON] = ACTIONS(2569),
    [anon_sym_AMP] = ACTIONS(2567),
    [anon_sym_LBRACK] = ACTIONS(2567),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2569),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_LT_AT] = ACTIONS(2567),
    [anon_sym_LT_AT_AT] = ACTIONS(2567),
    [anon_sym_DOT] = ACTIONS(2567),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2569),
    [anon_sym_new] = ACTIONS(2567),
    [anon_sym_with] = ACTIONS(2567),
    [anon_sym_return_BANG] = ACTIONS(2569),
    [anon_sym_yield] = ACTIONS(2567),
    [anon_sym_yield_BANG] = ACTIONS(2569),
    [anon_sym_lazy] = ACTIONS(2567),
    [anon_sym_assert] = ACTIONS(2567),
    [anon_sym_upcast] = ACTIONS(2567),
    [anon_sym_downcast] = ACTIONS(2567),
    [anon_sym_COLON_GT] = ACTIONS(2569),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2569),
    [anon_sym_for] = ACTIONS(2567),
    [anon_sym_while] = ACTIONS(2567),
    [anon_sym_if] = ACTIONS(2567),
    [anon_sym_fun] = ACTIONS(2567),
    [anon_sym_DASH_GT] = ACTIONS(2567),
    [anon_sym_try] = ACTIONS(2567),
    [anon_sym_match] = ACTIONS(2567),
    [anon_sym_match_BANG] = ACTIONS(2569),
    [anon_sym_function] = ACTIONS(2567),
    [anon_sym_LT_DASH] = ACTIONS(2567),
    [anon_sym_DOT_LBRACK] = ACTIONS(2569),
    [anon_sym_LT] = ACTIONS(2569),
    [anon_sym_use] = ACTIONS(2567),
    [anon_sym_use_BANG] = ACTIONS(2569),
    [anon_sym_do_BANG] = ACTIONS(2569),
    [anon_sym_begin] = ACTIONS(2567),
    [anon_sym_LPAREN2] = ACTIONS(2567),
    [anon_sym_STAR] = ACTIONS(2567),
    [anon_sym_LT2] = ACTIONS(2567),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2569),
    [anon_sym_or] = ACTIONS(2567),
    [aux_sym_char_token1] = ACTIONS(2569),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2567),
    [anon_sym_DQUOTE] = ACTIONS(2567),
    [anon_sym_AT_DQUOTE] = ACTIONS(2569),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2569),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2569),
    [sym_bool] = ACTIONS(2567),
    [sym_unit] = ACTIONS(2569),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2567),
    [sym_op_identifier] = ACTIONS(2567),
    [anon_sym_PLUS] = ACTIONS(2567),
    [anon_sym_DASH] = ACTIONS(2567),
    [anon_sym_PLUS_DOT] = ACTIONS(2567),
    [anon_sym_DASH_DOT] = ACTIONS(2567),
    [anon_sym_PERCENT] = ACTIONS(2567),
    [anon_sym_AMP_AMP] = ACTIONS(2567),
    [anon_sym_TILDE] = ACTIONS(2569),
    [aux_sym_prefix_op_token1] = ACTIONS(2567),
    [aux_sym_infix_op_token1] = ACTIONS(2569),
    [aux_sym_infix_op_token2] = ACTIONS(2567),
    [anon_sym_PIPE_PIPE] = ACTIONS(2567),
    [anon_sym_BANG_EQ] = ACTIONS(2567),
    [anon_sym_COLON_EQ] = ACTIONS(2569),
    [anon_sym_DOLLAR] = ACTIONS(2567),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2567),
    [sym_int] = ACTIONS(2567),
    [sym_xint] = ACTIONS(2569),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2569),
    [sym__newline] = ACTIONS(2569),
  },
  [1198] = {
    [sym_block_comment] = STATE(1198),
    [sym_compiler_directive_decl] = STATE(1198),
    [sym_fsi_directive_decl] = STATE(1198),
    [sym_preproc_line] = STATE(1198),
    [sym_identifier] = ACTIONS(2553),
    [anon_sym_EQ] = ACTIONS(2555),
    [anon_sym_COLON] = ACTIONS(2553),
    [anon_sym_return] = ACTIONS(2553),
    [anon_sym_do] = ACTIONS(2553),
    [anon_sym_let] = ACTIONS(2553),
    [anon_sym_let_BANG] = ACTIONS(2555),
    [anon_sym_as] = ACTIONS(2553),
    [anon_sym_LPAREN] = ACTIONS(2553),
    [anon_sym_COMMA] = ACTIONS(2555),
    [anon_sym_null] = ACTIONS(2553),
    [anon_sym_QMARK] = ACTIONS(2553),
    [anon_sym_COLON_QMARK] = ACTIONS(2553),
    [anon_sym_COLON_COLON] = ACTIONS(2555),
    [anon_sym_AMP] = ACTIONS(2553),
    [anon_sym_LBRACK] = ACTIONS(2553),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2555),
    [anon_sym_LBRACE] = ACTIONS(2553),
    [anon_sym_LT_AT] = ACTIONS(2553),
    [anon_sym_LT_AT_AT] = ACTIONS(2553),
    [anon_sym_DOT] = ACTIONS(2553),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2555),
    [anon_sym_new] = ACTIONS(2553),
    [anon_sym_with] = ACTIONS(2553),
    [anon_sym_return_BANG] = ACTIONS(2555),
    [anon_sym_yield] = ACTIONS(2553),
    [anon_sym_yield_BANG] = ACTIONS(2555),
    [anon_sym_lazy] = ACTIONS(2553),
    [anon_sym_assert] = ACTIONS(2553),
    [anon_sym_upcast] = ACTIONS(2553),
    [anon_sym_downcast] = ACTIONS(2553),
    [anon_sym_COLON_GT] = ACTIONS(2555),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2555),
    [anon_sym_for] = ACTIONS(2553),
    [anon_sym_while] = ACTIONS(2553),
    [anon_sym_if] = ACTIONS(2553),
    [anon_sym_fun] = ACTIONS(2553),
    [anon_sym_DASH_GT] = ACTIONS(2553),
    [anon_sym_try] = ACTIONS(2553),
    [anon_sym_match] = ACTIONS(2553),
    [anon_sym_match_BANG] = ACTIONS(2555),
    [anon_sym_function] = ACTIONS(2553),
    [anon_sym_LT_DASH] = ACTIONS(2553),
    [anon_sym_DOT_LBRACK] = ACTIONS(2555),
    [anon_sym_LT] = ACTIONS(2555),
    [anon_sym_use] = ACTIONS(2553),
    [anon_sym_use_BANG] = ACTIONS(2555),
    [anon_sym_do_BANG] = ACTIONS(2555),
    [anon_sym_begin] = ACTIONS(2553),
    [anon_sym_LPAREN2] = ACTIONS(2553),
    [anon_sym_STAR] = ACTIONS(2553),
    [anon_sym_LT2] = ACTIONS(2553),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2555),
    [anon_sym_or] = ACTIONS(2553),
    [aux_sym_char_token1] = ACTIONS(2555),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2553),
    [anon_sym_DQUOTE] = ACTIONS(2553),
    [anon_sym_AT_DQUOTE] = ACTIONS(2555),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2555),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2555),
    [sym_bool] = ACTIONS(2553),
    [sym_unit] = ACTIONS(2555),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2553),
    [sym_op_identifier] = ACTIONS(2553),
    [anon_sym_PLUS] = ACTIONS(2553),
    [anon_sym_DASH] = ACTIONS(2553),
    [anon_sym_PLUS_DOT] = ACTIONS(2553),
    [anon_sym_DASH_DOT] = ACTIONS(2553),
    [anon_sym_PERCENT] = ACTIONS(2553),
    [anon_sym_AMP_AMP] = ACTIONS(2553),
    [anon_sym_TILDE] = ACTIONS(2555),
    [aux_sym_prefix_op_token1] = ACTIONS(2553),
    [aux_sym_infix_op_token1] = ACTIONS(2555),
    [aux_sym_infix_op_token2] = ACTIONS(2553),
    [anon_sym_PIPE_PIPE] = ACTIONS(2553),
    [anon_sym_BANG_EQ] = ACTIONS(2553),
    [anon_sym_COLON_EQ] = ACTIONS(2555),
    [anon_sym_DOLLAR] = ACTIONS(2553),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2553),
    [sym_int] = ACTIONS(2553),
    [sym_xint] = ACTIONS(2555),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2555),
    [sym__newline] = ACTIONS(2555),
  },
  [1199] = {
    [sym_block_comment] = STATE(1199),
    [sym_compiler_directive_decl] = STATE(1199),
    [sym_fsi_directive_decl] = STATE(1199),
    [sym_preproc_line] = STATE(1199),
    [sym_identifier] = ACTIONS(2563),
    [anon_sym_EQ] = ACTIONS(2565),
    [anon_sym_COLON] = ACTIONS(2563),
    [anon_sym_return] = ACTIONS(2563),
    [anon_sym_do] = ACTIONS(2563),
    [anon_sym_let] = ACTIONS(2563),
    [anon_sym_let_BANG] = ACTIONS(2565),
    [anon_sym_as] = ACTIONS(2563),
    [anon_sym_LPAREN] = ACTIONS(2563),
    [anon_sym_COMMA] = ACTIONS(2565),
    [anon_sym_null] = ACTIONS(2563),
    [anon_sym_QMARK] = ACTIONS(2563),
    [anon_sym_COLON_QMARK] = ACTIONS(2563),
    [anon_sym_COLON_COLON] = ACTIONS(2565),
    [anon_sym_AMP] = ACTIONS(2563),
    [anon_sym_LBRACK] = ACTIONS(2563),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2565),
    [anon_sym_LBRACE] = ACTIONS(2563),
    [anon_sym_LT_AT] = ACTIONS(2563),
    [anon_sym_LT_AT_AT] = ACTIONS(2563),
    [anon_sym_DOT] = ACTIONS(2563),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2565),
    [anon_sym_new] = ACTIONS(2563),
    [anon_sym_with] = ACTIONS(2563),
    [anon_sym_return_BANG] = ACTIONS(2565),
    [anon_sym_yield] = ACTIONS(2563),
    [anon_sym_yield_BANG] = ACTIONS(2565),
    [anon_sym_lazy] = ACTIONS(2563),
    [anon_sym_assert] = ACTIONS(2563),
    [anon_sym_upcast] = ACTIONS(2563),
    [anon_sym_downcast] = ACTIONS(2563),
    [anon_sym_COLON_GT] = ACTIONS(2565),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2565),
    [anon_sym_for] = ACTIONS(2563),
    [anon_sym_while] = ACTIONS(2563),
    [anon_sym_if] = ACTIONS(2563),
    [anon_sym_fun] = ACTIONS(2563),
    [anon_sym_DASH_GT] = ACTIONS(2563),
    [anon_sym_try] = ACTIONS(2563),
    [anon_sym_match] = ACTIONS(2563),
    [anon_sym_match_BANG] = ACTIONS(2565),
    [anon_sym_function] = ACTIONS(2563),
    [anon_sym_LT_DASH] = ACTIONS(2563),
    [anon_sym_DOT_LBRACK] = ACTIONS(2565),
    [anon_sym_LT] = ACTIONS(2565),
    [anon_sym_use] = ACTIONS(2563),
    [anon_sym_use_BANG] = ACTIONS(2565),
    [anon_sym_do_BANG] = ACTIONS(2565),
    [anon_sym_begin] = ACTIONS(2563),
    [anon_sym_LPAREN2] = ACTIONS(2563),
    [anon_sym_STAR] = ACTIONS(2563),
    [anon_sym_LT2] = ACTIONS(2563),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2565),
    [anon_sym_or] = ACTIONS(2563),
    [aux_sym_char_token1] = ACTIONS(2565),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2563),
    [anon_sym_DQUOTE] = ACTIONS(2563),
    [anon_sym_AT_DQUOTE] = ACTIONS(2565),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2565),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2565),
    [sym_bool] = ACTIONS(2563),
    [sym_unit] = ACTIONS(2565),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2563),
    [sym_op_identifier] = ACTIONS(2563),
    [anon_sym_PLUS] = ACTIONS(2563),
    [anon_sym_DASH] = ACTIONS(2563),
    [anon_sym_PLUS_DOT] = ACTIONS(2563),
    [anon_sym_DASH_DOT] = ACTIONS(2563),
    [anon_sym_PERCENT] = ACTIONS(2563),
    [anon_sym_AMP_AMP] = ACTIONS(2563),
    [anon_sym_TILDE] = ACTIONS(2565),
    [aux_sym_prefix_op_token1] = ACTIONS(2563),
    [aux_sym_infix_op_token1] = ACTIONS(2565),
    [aux_sym_infix_op_token2] = ACTIONS(2563),
    [anon_sym_PIPE_PIPE] = ACTIONS(2563),
    [anon_sym_BANG_EQ] = ACTIONS(2563),
    [anon_sym_COLON_EQ] = ACTIONS(2565),
    [anon_sym_DOLLAR] = ACTIONS(2563),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2563),
    [sym_int] = ACTIONS(2563),
    [sym_xint] = ACTIONS(2565),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2565),
    [sym__newline] = ACTIONS(2565),
  },
  [1200] = {
    [sym_block_comment] = STATE(1200),
    [sym_compiler_directive_decl] = STATE(1200),
    [sym_fsi_directive_decl] = STATE(1200),
    [sym_preproc_line] = STATE(1200),
    [aux_sym_long_identifier_repeat1] = STATE(1200),
    [sym_identifier] = ACTIONS(2411),
    [anon_sym_EQ] = ACTIONS(2413),
    [anon_sym_COLON] = ACTIONS(2411),
    [anon_sym_return] = ACTIONS(2411),
    [anon_sym_do] = ACTIONS(2411),
    [anon_sym_let] = ACTIONS(2411),
    [anon_sym_let_BANG] = ACTIONS(2413),
    [anon_sym_LPAREN] = ACTIONS(2411),
    [anon_sym_COMMA] = ACTIONS(2413),
    [anon_sym_null] = ACTIONS(2411),
    [anon_sym_QMARK] = ACTIONS(2411),
    [anon_sym_COLON_QMARK] = ACTIONS(2411),
    [anon_sym_COLON_COLON] = ACTIONS(2413),
    [anon_sym_AMP] = ACTIONS(2411),
    [anon_sym_LBRACK] = ACTIONS(2411),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2413),
    [anon_sym_LBRACE] = ACTIONS(2411),
    [anon_sym_LT_AT] = ACTIONS(2411),
    [anon_sym_LT_AT_AT] = ACTIONS(2411),
    [anon_sym_AT_AT_GT] = ACTIONS(2411),
    [anon_sym_DOT] = ACTIONS(3378),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2413),
    [anon_sym_new] = ACTIONS(2411),
    [anon_sym_return_BANG] = ACTIONS(2413),
    [anon_sym_yield] = ACTIONS(2411),
    [anon_sym_yield_BANG] = ACTIONS(2413),
    [anon_sym_lazy] = ACTIONS(2411),
    [anon_sym_assert] = ACTIONS(2411),
    [anon_sym_upcast] = ACTIONS(2411),
    [anon_sym_downcast] = ACTIONS(2411),
    [anon_sym_COLON_GT] = ACTIONS(2413),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2413),
    [anon_sym_for] = ACTIONS(2411),
    [anon_sym_while] = ACTIONS(2411),
    [anon_sym_if] = ACTIONS(2411),
    [anon_sym_fun] = ACTIONS(2411),
    [anon_sym_DASH_GT] = ACTIONS(2411),
    [anon_sym_try] = ACTIONS(2411),
    [anon_sym_match] = ACTIONS(2411),
    [anon_sym_match_BANG] = ACTIONS(2413),
    [anon_sym_function] = ACTIONS(2411),
    [anon_sym_LT_DASH] = ACTIONS(2411),
    [anon_sym_DOT_LBRACK] = ACTIONS(2413),
    [anon_sym_LT] = ACTIONS(2413),
    [anon_sym_use] = ACTIONS(2411),
    [anon_sym_use_BANG] = ACTIONS(2413),
    [anon_sym_do_BANG] = ACTIONS(2413),
    [anon_sym_begin] = ACTIONS(2411),
    [anon_sym_LPAREN2] = ACTIONS(2411),
    [anon_sym_STAR] = ACTIONS(2411),
    [anon_sym_LT2] = ACTIONS(2411),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2413),
    [anon_sym_or] = ACTIONS(2411),
    [aux_sym_char_token1] = ACTIONS(2413),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2411),
    [anon_sym_DQUOTE] = ACTIONS(2411),
    [anon_sym_AT_DQUOTE] = ACTIONS(2413),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2413),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2413),
    [sym_bool] = ACTIONS(2411),
    [sym_unit] = ACTIONS(2413),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2411),
    [sym_op_identifier] = ACTIONS(2411),
    [anon_sym_PLUS] = ACTIONS(2411),
    [anon_sym_DASH] = ACTIONS(2411),
    [anon_sym_PLUS_DOT] = ACTIONS(2411),
    [anon_sym_DASH_DOT] = ACTIONS(2411),
    [anon_sym_PERCENT] = ACTIONS(2411),
    [anon_sym_AMP_AMP] = ACTIONS(2411),
    [anon_sym_TILDE] = ACTIONS(2413),
    [aux_sym_prefix_op_token1] = ACTIONS(2411),
    [aux_sym_infix_op_token1] = ACTIONS(2413),
    [aux_sym_infix_op_token2] = ACTIONS(2411),
    [anon_sym_PIPE_PIPE] = ACTIONS(2411),
    [anon_sym_BANG_EQ] = ACTIONS(2411),
    [anon_sym_COLON_EQ] = ACTIONS(2413),
    [anon_sym_DOLLAR] = ACTIONS(2411),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2411),
    [sym_int] = ACTIONS(2411),
    [sym_xint] = ACTIONS(2413),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2413),
    [sym__newline] = ACTIONS(2413),
  },
  [1201] = {
    [sym_block_comment] = STATE(1201),
    [sym_compiler_directive_decl] = STATE(1201),
    [sym_fsi_directive_decl] = STATE(1201),
    [sym_preproc_line] = STATE(1201),
    [aux_sym_type_argument_repeat1] = STATE(1210),
    [sym_identifier] = ACTIONS(2328),
    [anon_sym_EQ] = ACTIONS(2330),
    [anon_sym_COLON] = ACTIONS(2328),
    [anon_sym_return] = ACTIONS(2328),
    [anon_sym_do] = ACTIONS(2328),
    [anon_sym_let] = ACTIONS(2328),
    [anon_sym_let_BANG] = ACTIONS(2330),
    [anon_sym_LPAREN] = ACTIONS(2328),
    [anon_sym_COMMA] = ACTIONS(2330),
    [anon_sym_null] = ACTIONS(2328),
    [anon_sym_QMARK] = ACTIONS(2328),
    [anon_sym_COLON_QMARK] = ACTIONS(2328),
    [anon_sym_COLON_COLON] = ACTIONS(2330),
    [anon_sym_AMP] = ACTIONS(2328),
    [anon_sym_LBRACK] = ACTIONS(2328),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2330),
    [anon_sym_LBRACE] = ACTIONS(2328),
    [anon_sym_LT_AT] = ACTIONS(2328),
    [anon_sym_LT_AT_AT] = ACTIONS(2328),
    [anon_sym_DOT] = ACTIONS(2328),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2330),
    [anon_sym_new] = ACTIONS(2328),
    [anon_sym_return_BANG] = ACTIONS(2330),
    [anon_sym_yield] = ACTIONS(2328),
    [anon_sym_yield_BANG] = ACTIONS(2330),
    [anon_sym_lazy] = ACTIONS(2328),
    [anon_sym_assert] = ACTIONS(2328),
    [anon_sym_upcast] = ACTIONS(2328),
    [anon_sym_downcast] = ACTIONS(2328),
    [anon_sym_COLON_GT] = ACTIONS(2330),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2330),
    [anon_sym_for] = ACTIONS(2328),
    [anon_sym_while] = ACTIONS(2328),
    [anon_sym_if] = ACTIONS(2328),
    [anon_sym_fun] = ACTIONS(2328),
    [anon_sym_DASH_GT] = ACTIONS(2328),
    [anon_sym_try] = ACTIONS(2328),
    [anon_sym_match] = ACTIONS(2328),
    [anon_sym_match_BANG] = ACTIONS(2330),
    [anon_sym_function] = ACTIONS(2328),
    [anon_sym_LT_DASH] = ACTIONS(2328),
    [anon_sym_DOT_LBRACK] = ACTIONS(2330),
    [anon_sym_LT] = ACTIONS(2330),
    [anon_sym_use] = ACTIONS(2328),
    [anon_sym_use_BANG] = ACTIONS(2330),
    [anon_sym_do_BANG] = ACTIONS(2330),
    [anon_sym_begin] = ACTIONS(2328),
    [anon_sym_LPAREN2] = ACTIONS(2328),
    [anon_sym_STAR] = ACTIONS(2328),
    [anon_sym_LT2] = ACTIONS(2328),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2330),
    [anon_sym_or] = ACTIONS(2328),
    [aux_sym_char_token1] = ACTIONS(2330),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2328),
    [anon_sym_DQUOTE] = ACTIONS(2328),
    [anon_sym_AT_DQUOTE] = ACTIONS(2330),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2330),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2330),
    [sym_bool] = ACTIONS(2328),
    [sym_unit] = ACTIONS(2330),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2328),
    [sym_op_identifier] = ACTIONS(2328),
    [anon_sym_PLUS] = ACTIONS(2328),
    [anon_sym_DASH] = ACTIONS(2328),
    [anon_sym_PLUS_DOT] = ACTIONS(2328),
    [anon_sym_DASH_DOT] = ACTIONS(2328),
    [anon_sym_PERCENT] = ACTIONS(2328),
    [anon_sym_AMP_AMP] = ACTIONS(2328),
    [anon_sym_TILDE] = ACTIONS(2330),
    [aux_sym_prefix_op_token1] = ACTIONS(2328),
    [aux_sym_infix_op_token1] = ACTIONS(2330),
    [aux_sym_infix_op_token2] = ACTIONS(2328),
    [anon_sym_PIPE_PIPE] = ACTIONS(2328),
    [anon_sym_BANG_EQ] = ACTIONS(2328),
    [anon_sym_COLON_EQ] = ACTIONS(2330),
    [anon_sym_DOLLAR] = ACTIONS(2328),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2328),
    [sym_int] = ACTIONS(2328),
    [sym_xint] = ACTIONS(2330),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2330),
    [anon_sym_POUNDendif] = ACTIONS(2330),
    [sym__newline] = ACTIONS(2330),
  },
  [1202] = {
    [sym_block_comment] = STATE(1202),
    [sym_compiler_directive_decl] = STATE(1202),
    [sym_fsi_directive_decl] = STATE(1202),
    [sym_preproc_line] = STATE(1202),
    [sym_identifier] = ACTIONS(2321),
    [anon_sym_EQ] = ACTIONS(2323),
    [anon_sym_COLON] = ACTIONS(2321),
    [anon_sym_return] = ACTIONS(2321),
    [anon_sym_do] = ACTIONS(2321),
    [anon_sym_and] = ACTIONS(2321),
    [anon_sym_let] = ACTIONS(2321),
    [anon_sym_let_BANG] = ACTIONS(2323),
    [anon_sym_LPAREN] = ACTIONS(2321),
    [anon_sym_COMMA] = ACTIONS(2323),
    [anon_sym_null] = ACTIONS(2321),
    [anon_sym_QMARK] = ACTIONS(2321),
    [anon_sym_COLON_QMARK] = ACTIONS(2321),
    [anon_sym_COLON_COLON] = ACTIONS(2323),
    [anon_sym_AMP] = ACTIONS(2321),
    [anon_sym_LBRACK] = ACTIONS(2321),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2323),
    [anon_sym_LBRACE] = ACTIONS(2321),
    [anon_sym_LT_AT] = ACTIONS(2321),
    [anon_sym_LT_AT_AT] = ACTIONS(2321),
    [anon_sym_DOT] = ACTIONS(2321),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2323),
    [anon_sym_new] = ACTIONS(2321),
    [anon_sym_return_BANG] = ACTIONS(2323),
    [anon_sym_yield] = ACTIONS(2321),
    [anon_sym_yield_BANG] = ACTIONS(2323),
    [anon_sym_lazy] = ACTIONS(2321),
    [anon_sym_assert] = ACTIONS(2321),
    [anon_sym_upcast] = ACTIONS(2321),
    [anon_sym_downcast] = ACTIONS(2321),
    [anon_sym_COLON_GT] = ACTIONS(2323),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2323),
    [anon_sym_for] = ACTIONS(2321),
    [anon_sym_while] = ACTIONS(2321),
    [anon_sym_if] = ACTIONS(2321),
    [anon_sym_fun] = ACTIONS(2321),
    [anon_sym_DASH_GT] = ACTIONS(2321),
    [anon_sym_try] = ACTIONS(2321),
    [anon_sym_match] = ACTIONS(2321),
    [anon_sym_match_BANG] = ACTIONS(2323),
    [anon_sym_function] = ACTIONS(2321),
    [anon_sym_LT_DASH] = ACTIONS(2321),
    [anon_sym_DOT_LBRACK] = ACTIONS(2323),
    [anon_sym_LT] = ACTIONS(2323),
    [anon_sym_use] = ACTIONS(2321),
    [anon_sym_use_BANG] = ACTIONS(2323),
    [anon_sym_do_BANG] = ACTIONS(2323),
    [anon_sym_begin] = ACTIONS(2321),
    [anon_sym_LPAREN2] = ACTIONS(2321),
    [anon_sym_STAR] = ACTIONS(2321),
    [anon_sym_LT2] = ACTIONS(2321),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2323),
    [anon_sym_or] = ACTIONS(2321),
    [aux_sym_char_token1] = ACTIONS(2323),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2321),
    [anon_sym_DQUOTE] = ACTIONS(2321),
    [anon_sym_AT_DQUOTE] = ACTIONS(2323),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2323),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2323),
    [sym_bool] = ACTIONS(2321),
    [sym_unit] = ACTIONS(2323),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2321),
    [sym_op_identifier] = ACTIONS(2321),
    [anon_sym_PLUS] = ACTIONS(2321),
    [anon_sym_DASH] = ACTIONS(2321),
    [anon_sym_PLUS_DOT] = ACTIONS(2321),
    [anon_sym_DASH_DOT] = ACTIONS(2321),
    [anon_sym_PERCENT] = ACTIONS(2321),
    [anon_sym_AMP_AMP] = ACTIONS(2321),
    [anon_sym_TILDE] = ACTIONS(2323),
    [aux_sym_prefix_op_token1] = ACTIONS(2321),
    [aux_sym_infix_op_token1] = ACTIONS(2323),
    [aux_sym_infix_op_token2] = ACTIONS(2321),
    [anon_sym_PIPE_PIPE] = ACTIONS(2321),
    [anon_sym_BANG_EQ] = ACTIONS(2321),
    [anon_sym_COLON_EQ] = ACTIONS(2323),
    [anon_sym_DOLLAR] = ACTIONS(2321),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2321),
    [sym_int] = ACTIONS(2321),
    [sym_xint] = ACTIONS(2323),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2323),
    [sym__newline] = ACTIONS(2323),
    [sym__dedent] = ACTIONS(2323),
  },
  [1203] = {
    [sym_block_comment] = STATE(1203),
    [sym_compiler_directive_decl] = STATE(1203),
    [sym_fsi_directive_decl] = STATE(1203),
    [sym_preproc_line] = STATE(1203),
    [sym_identifier] = ACTIONS(2462),
    [anon_sym_EQ] = ACTIONS(2464),
    [anon_sym_COLON] = ACTIONS(2462),
    [anon_sym_return] = ACTIONS(2462),
    [anon_sym_do] = ACTIONS(2462),
    [anon_sym_and] = ACTIONS(2462),
    [anon_sym_let] = ACTIONS(2462),
    [anon_sym_let_BANG] = ACTIONS(2464),
    [anon_sym_LPAREN] = ACTIONS(2462),
    [anon_sym_COMMA] = ACTIONS(2464),
    [anon_sym_null] = ACTIONS(2462),
    [anon_sym_QMARK] = ACTIONS(2462),
    [anon_sym_COLON_QMARK] = ACTIONS(2462),
    [anon_sym_COLON_COLON] = ACTIONS(2464),
    [anon_sym_AMP] = ACTIONS(2462),
    [anon_sym_LBRACK] = ACTIONS(2462),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2464),
    [anon_sym_LBRACE] = ACTIONS(2462),
    [anon_sym_LT_AT] = ACTIONS(2462),
    [anon_sym_LT_AT_AT] = ACTIONS(2462),
    [anon_sym_DOT] = ACTIONS(2462),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2464),
    [anon_sym_new] = ACTIONS(2462),
    [anon_sym_return_BANG] = ACTIONS(2464),
    [anon_sym_yield] = ACTIONS(2462),
    [anon_sym_yield_BANG] = ACTIONS(2464),
    [anon_sym_lazy] = ACTIONS(2462),
    [anon_sym_assert] = ACTIONS(2462),
    [anon_sym_upcast] = ACTIONS(2462),
    [anon_sym_downcast] = ACTIONS(2462),
    [anon_sym_COLON_GT] = ACTIONS(2464),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2464),
    [anon_sym_for] = ACTIONS(2462),
    [anon_sym_while] = ACTIONS(2462),
    [anon_sym_if] = ACTIONS(2462),
    [anon_sym_fun] = ACTIONS(2462),
    [anon_sym_DASH_GT] = ACTIONS(2462),
    [anon_sym_try] = ACTIONS(2462),
    [anon_sym_match] = ACTIONS(2462),
    [anon_sym_match_BANG] = ACTIONS(2464),
    [anon_sym_function] = ACTIONS(2462),
    [anon_sym_LT_DASH] = ACTIONS(2462),
    [anon_sym_DOT_LBRACK] = ACTIONS(2464),
    [anon_sym_LT] = ACTIONS(2464),
    [anon_sym_use] = ACTIONS(2462),
    [anon_sym_use_BANG] = ACTIONS(2464),
    [anon_sym_do_BANG] = ACTIONS(2464),
    [anon_sym_begin] = ACTIONS(2462),
    [anon_sym_LPAREN2] = ACTIONS(2462),
    [anon_sym_STAR] = ACTIONS(2462),
    [anon_sym_LT2] = ACTIONS(2462),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2464),
    [anon_sym_or] = ACTIONS(2462),
    [aux_sym_char_token1] = ACTIONS(2464),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2462),
    [anon_sym_DQUOTE] = ACTIONS(2462),
    [anon_sym_AT_DQUOTE] = ACTIONS(2464),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2464),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2464),
    [sym_bool] = ACTIONS(2462),
    [sym_unit] = ACTIONS(2464),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2462),
    [sym_op_identifier] = ACTIONS(2462),
    [anon_sym_PLUS] = ACTIONS(2462),
    [anon_sym_DASH] = ACTIONS(2462),
    [anon_sym_PLUS_DOT] = ACTIONS(2462),
    [anon_sym_DASH_DOT] = ACTIONS(2462),
    [anon_sym_PERCENT] = ACTIONS(2462),
    [anon_sym_AMP_AMP] = ACTIONS(2462),
    [anon_sym_TILDE] = ACTIONS(2464),
    [aux_sym_prefix_op_token1] = ACTIONS(2462),
    [aux_sym_infix_op_token1] = ACTIONS(2464),
    [aux_sym_infix_op_token2] = ACTIONS(2462),
    [anon_sym_PIPE_PIPE] = ACTIONS(2462),
    [anon_sym_BANG_EQ] = ACTIONS(2462),
    [anon_sym_COLON_EQ] = ACTIONS(2464),
    [anon_sym_DOLLAR] = ACTIONS(2462),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2462),
    [sym_int] = ACTIONS(2462),
    [sym_xint] = ACTIONS(2464),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2464),
    [sym__newline] = ACTIONS(2464),
    [sym__dedent] = ACTIONS(2464),
  },
  [1204] = {
    [sym_block_comment] = STATE(1204),
    [sym_compiler_directive_decl] = STATE(1204),
    [sym_fsi_directive_decl] = STATE(1204),
    [sym_preproc_line] = STATE(1204),
    [sym_identifier] = ACTIONS(2340),
    [anon_sym_EQ] = ACTIONS(2342),
    [anon_sym_COLON] = ACTIONS(2340),
    [anon_sym_return] = ACTIONS(2340),
    [anon_sym_do] = ACTIONS(2340),
    [anon_sym_let] = ACTIONS(2340),
    [anon_sym_let_BANG] = ACTIONS(2342),
    [anon_sym_as] = ACTIONS(2340),
    [anon_sym_LPAREN] = ACTIONS(2340),
    [anon_sym_COMMA] = ACTIONS(2342),
    [anon_sym_null] = ACTIONS(2340),
    [anon_sym_QMARK] = ACTIONS(2340),
    [anon_sym_COLON_QMARK] = ACTIONS(2340),
    [anon_sym_COLON_COLON] = ACTIONS(2342),
    [anon_sym_AMP] = ACTIONS(2340),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2342),
    [anon_sym_LBRACE] = ACTIONS(2340),
    [anon_sym_LT_AT] = ACTIONS(2340),
    [anon_sym_LT_AT_AT] = ACTIONS(2340),
    [anon_sym_DOT] = ACTIONS(2340),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2342),
    [anon_sym_new] = ACTIONS(2340),
    [anon_sym_with] = ACTIONS(2340),
    [anon_sym_return_BANG] = ACTIONS(2342),
    [anon_sym_yield] = ACTIONS(2340),
    [anon_sym_yield_BANG] = ACTIONS(2342),
    [anon_sym_lazy] = ACTIONS(2340),
    [anon_sym_assert] = ACTIONS(2340),
    [anon_sym_upcast] = ACTIONS(2340),
    [anon_sym_downcast] = ACTIONS(2340),
    [anon_sym_COLON_GT] = ACTIONS(2342),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2342),
    [anon_sym_for] = ACTIONS(2340),
    [anon_sym_while] = ACTIONS(2340),
    [anon_sym_if] = ACTIONS(2340),
    [anon_sym_fun] = ACTIONS(2340),
    [anon_sym_DASH_GT] = ACTIONS(2340),
    [anon_sym_try] = ACTIONS(2340),
    [anon_sym_match] = ACTIONS(2340),
    [anon_sym_match_BANG] = ACTIONS(2342),
    [anon_sym_function] = ACTIONS(2340),
    [anon_sym_LT_DASH] = ACTIONS(2340),
    [anon_sym_DOT_LBRACK] = ACTIONS(2342),
    [anon_sym_LT] = ACTIONS(2342),
    [anon_sym_use] = ACTIONS(2340),
    [anon_sym_use_BANG] = ACTIONS(2342),
    [anon_sym_do_BANG] = ACTIONS(2342),
    [anon_sym_begin] = ACTIONS(2340),
    [anon_sym_LPAREN2] = ACTIONS(2340),
    [anon_sym_STAR] = ACTIONS(2340),
    [anon_sym_LT2] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2342),
    [anon_sym_or] = ACTIONS(2340),
    [aux_sym_char_token1] = ACTIONS(2342),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2340),
    [anon_sym_DQUOTE] = ACTIONS(2340),
    [anon_sym_AT_DQUOTE] = ACTIONS(2342),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2342),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2342),
    [sym_bool] = ACTIONS(2340),
    [sym_unit] = ACTIONS(2342),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2340),
    [sym_op_identifier] = ACTIONS(2340),
    [anon_sym_PLUS] = ACTIONS(2340),
    [anon_sym_DASH] = ACTIONS(2340),
    [anon_sym_PLUS_DOT] = ACTIONS(2340),
    [anon_sym_DASH_DOT] = ACTIONS(2340),
    [anon_sym_PERCENT] = ACTIONS(2340),
    [anon_sym_AMP_AMP] = ACTIONS(2340),
    [anon_sym_TILDE] = ACTIONS(2342),
    [aux_sym_prefix_op_token1] = ACTIONS(2340),
    [aux_sym_infix_op_token1] = ACTIONS(2342),
    [aux_sym_infix_op_token2] = ACTIONS(2340),
    [anon_sym_PIPE_PIPE] = ACTIONS(2340),
    [anon_sym_BANG_EQ] = ACTIONS(2340),
    [anon_sym_COLON_EQ] = ACTIONS(2342),
    [anon_sym_DOLLAR] = ACTIONS(2340),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2340),
    [sym_int] = ACTIONS(2340),
    [sym_xint] = ACTIONS(2342),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2342),
    [sym__newline] = ACTIONS(2342),
  },
  [1205] = {
    [sym_block_comment] = STATE(1205),
    [sym_compiler_directive_decl] = STATE(1205),
    [sym_fsi_directive_decl] = STATE(1205),
    [sym_preproc_line] = STATE(1205),
    [aux_sym_type_argument_repeat1] = STATE(1211),
    [sym_identifier] = ACTIONS(2321),
    [anon_sym_EQ] = ACTIONS(2323),
    [anon_sym_COLON] = ACTIONS(2321),
    [anon_sym_return] = ACTIONS(2321),
    [anon_sym_do] = ACTIONS(2321),
    [anon_sym_let] = ACTIONS(2321),
    [anon_sym_let_BANG] = ACTIONS(2323),
    [anon_sym_LPAREN] = ACTIONS(2321),
    [anon_sym_COMMA] = ACTIONS(2323),
    [anon_sym_null] = ACTIONS(2321),
    [anon_sym_QMARK] = ACTIONS(2321),
    [anon_sym_COLON_QMARK] = ACTIONS(2321),
    [anon_sym_COLON_COLON] = ACTIONS(2323),
    [anon_sym_AMP] = ACTIONS(2321),
    [anon_sym_LBRACK] = ACTIONS(2321),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2323),
    [anon_sym_LBRACE] = ACTIONS(2321),
    [anon_sym_LT_AT] = ACTIONS(2321),
    [anon_sym_AT_GT] = ACTIONS(2321),
    [anon_sym_LT_AT_AT] = ACTIONS(2321),
    [anon_sym_DOT] = ACTIONS(2321),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2323),
    [anon_sym_new] = ACTIONS(2321),
    [anon_sym_return_BANG] = ACTIONS(2323),
    [anon_sym_yield] = ACTIONS(2321),
    [anon_sym_yield_BANG] = ACTIONS(2323),
    [anon_sym_lazy] = ACTIONS(2321),
    [anon_sym_assert] = ACTIONS(2321),
    [anon_sym_upcast] = ACTIONS(2321),
    [anon_sym_downcast] = ACTIONS(2321),
    [anon_sym_COLON_GT] = ACTIONS(2323),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2323),
    [anon_sym_for] = ACTIONS(2321),
    [anon_sym_while] = ACTIONS(2321),
    [anon_sym_if] = ACTIONS(2321),
    [anon_sym_fun] = ACTIONS(2321),
    [anon_sym_DASH_GT] = ACTIONS(2321),
    [anon_sym_try] = ACTIONS(2321),
    [anon_sym_match] = ACTIONS(2321),
    [anon_sym_match_BANG] = ACTIONS(2323),
    [anon_sym_function] = ACTIONS(2321),
    [anon_sym_LT_DASH] = ACTIONS(2321),
    [anon_sym_DOT_LBRACK] = ACTIONS(2323),
    [anon_sym_LT] = ACTIONS(2323),
    [anon_sym_use] = ACTIONS(2321),
    [anon_sym_use_BANG] = ACTIONS(2323),
    [anon_sym_do_BANG] = ACTIONS(2323),
    [anon_sym_begin] = ACTIONS(2321),
    [anon_sym_LPAREN2] = ACTIONS(2321),
    [anon_sym_STAR] = ACTIONS(2321),
    [anon_sym_LT2] = ACTIONS(2321),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2323),
    [anon_sym_or] = ACTIONS(3381),
    [aux_sym_char_token1] = ACTIONS(2323),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2321),
    [anon_sym_DQUOTE] = ACTIONS(2321),
    [anon_sym_AT_DQUOTE] = ACTIONS(2323),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2323),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2323),
    [sym_bool] = ACTIONS(2321),
    [sym_unit] = ACTIONS(2323),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2321),
    [sym_op_identifier] = ACTIONS(2321),
    [anon_sym_PLUS] = ACTIONS(2321),
    [anon_sym_DASH] = ACTIONS(2321),
    [anon_sym_PLUS_DOT] = ACTIONS(2321),
    [anon_sym_DASH_DOT] = ACTIONS(2321),
    [anon_sym_PERCENT] = ACTIONS(2321),
    [anon_sym_AMP_AMP] = ACTIONS(2321),
    [anon_sym_TILDE] = ACTIONS(2323),
    [aux_sym_prefix_op_token1] = ACTIONS(2321),
    [aux_sym_infix_op_token1] = ACTIONS(2323),
    [aux_sym_infix_op_token2] = ACTIONS(2321),
    [anon_sym_PIPE_PIPE] = ACTIONS(2321),
    [anon_sym_BANG_EQ] = ACTIONS(2321),
    [anon_sym_COLON_EQ] = ACTIONS(2323),
    [anon_sym_DOLLAR] = ACTIONS(2321),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2321),
    [sym_int] = ACTIONS(2321),
    [sym_xint] = ACTIONS(2323),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2323),
    [sym__newline] = ACTIONS(2323),
  },
  [1206] = {
    [sym__else_expression] = STATE(2439),
    [sym_elif_expression] = STATE(1523),
    [sym_block_comment] = STATE(1206),
    [sym_compiler_directive_decl] = STATE(1206),
    [sym_fsi_directive_decl] = STATE(1206),
    [sym_preproc_line] = STATE(1206),
    [aux_sym_if_expression_repeat1] = STATE(1372),
    [sym_identifier] = ACTIONS(2332),
    [anon_sym_EQ] = ACTIONS(2334),
    [anon_sym_COLON] = ACTIONS(2332),
    [anon_sym_return] = ACTIONS(2332),
    [anon_sym_do] = ACTIONS(2332),
    [anon_sym_let] = ACTIONS(2332),
    [anon_sym_let_BANG] = ACTIONS(2334),
    [anon_sym_LPAREN] = ACTIONS(2332),
    [anon_sym_COMMA] = ACTIONS(2334),
    [anon_sym_null] = ACTIONS(2332),
    [anon_sym_QMARK] = ACTIONS(2332),
    [anon_sym_COLON_QMARK] = ACTIONS(2332),
    [anon_sym_COLON_COLON] = ACTIONS(2334),
    [anon_sym_AMP] = ACTIONS(2332),
    [anon_sym_LBRACK] = ACTIONS(2332),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2334),
    [anon_sym_LBRACE] = ACTIONS(2332),
    [anon_sym_LT_AT] = ACTIONS(2332),
    [anon_sym_LT_AT_AT] = ACTIONS(2332),
    [anon_sym_DOT] = ACTIONS(2332),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2334),
    [anon_sym_new] = ACTIONS(2332),
    [anon_sym_return_BANG] = ACTIONS(2334),
    [anon_sym_yield] = ACTIONS(2332),
    [anon_sym_yield_BANG] = ACTIONS(2334),
    [anon_sym_lazy] = ACTIONS(2332),
    [anon_sym_assert] = ACTIONS(2332),
    [anon_sym_upcast] = ACTIONS(2332),
    [anon_sym_downcast] = ACTIONS(2332),
    [anon_sym_COLON_GT] = ACTIONS(2334),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2334),
    [anon_sym_for] = ACTIONS(2332),
    [anon_sym_while] = ACTIONS(2332),
    [anon_sym_else] = ACTIONS(3384),
    [anon_sym_elif] = ACTIONS(3386),
    [anon_sym_if] = ACTIONS(2332),
    [anon_sym_fun] = ACTIONS(2332),
    [anon_sym_try] = ACTIONS(2332),
    [anon_sym_match] = ACTIONS(2332),
    [anon_sym_match_BANG] = ACTIONS(2334),
    [anon_sym_function] = ACTIONS(2332),
    [anon_sym_LT_DASH] = ACTIONS(2332),
    [anon_sym_DOT_LBRACK] = ACTIONS(2334),
    [anon_sym_LT] = ACTIONS(2334),
    [anon_sym_use] = ACTIONS(2332),
    [anon_sym_use_BANG] = ACTIONS(2334),
    [anon_sym_do_BANG] = ACTIONS(2334),
    [anon_sym_begin] = ACTIONS(2332),
    [anon_sym_LPAREN2] = ACTIONS(2332),
    [anon_sym_or] = ACTIONS(2332),
    [aux_sym_char_token1] = ACTIONS(2334),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2332),
    [anon_sym_DQUOTE] = ACTIONS(2332),
    [anon_sym_AT_DQUOTE] = ACTIONS(2334),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2334),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2334),
    [sym_bool] = ACTIONS(2332),
    [sym_unit] = ACTIONS(2334),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2332),
    [sym_op_identifier] = ACTIONS(2332),
    [anon_sym_PLUS] = ACTIONS(2332),
    [anon_sym_DASH] = ACTIONS(2332),
    [anon_sym_PLUS_DOT] = ACTIONS(2332),
    [anon_sym_DASH_DOT] = ACTIONS(2332),
    [anon_sym_PERCENT] = ACTIONS(2332),
    [anon_sym_AMP_AMP] = ACTIONS(2332),
    [anon_sym_TILDE] = ACTIONS(2334),
    [aux_sym_prefix_op_token1] = ACTIONS(2332),
    [aux_sym_infix_op_token1] = ACTIONS(2334),
    [aux_sym_infix_op_token2] = ACTIONS(2332),
    [anon_sym_PIPE_PIPE] = ACTIONS(2332),
    [anon_sym_BANG_EQ] = ACTIONS(2332),
    [anon_sym_COLON_EQ] = ACTIONS(2334),
    [anon_sym_DOLLAR] = ACTIONS(2332),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2332),
    [sym_int] = ACTIONS(2332),
    [sym_xint] = ACTIONS(2334),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2334),
    [anon_sym_POUNDendif] = ACTIONS(2334),
    [sym__newline] = ACTIONS(2334),
  },
  [1207] = {
    [sym_block_comment] = STATE(1207),
    [sym_compiler_directive_decl] = STATE(1207),
    [sym_fsi_directive_decl] = STATE(1207),
    [sym_preproc_line] = STATE(1207),
    [sym_identifier] = ACTIONS(2340),
    [anon_sym_EQ] = ACTIONS(2342),
    [anon_sym_COLON] = ACTIONS(2340),
    [anon_sym_return] = ACTIONS(2340),
    [anon_sym_do] = ACTIONS(2340),
    [anon_sym_and] = ACTIONS(2340),
    [anon_sym_let] = ACTIONS(2340),
    [anon_sym_let_BANG] = ACTIONS(2342),
    [anon_sym_LPAREN] = ACTIONS(2340),
    [anon_sym_COMMA] = ACTIONS(2342),
    [anon_sym_null] = ACTIONS(2340),
    [anon_sym_QMARK] = ACTIONS(2340),
    [anon_sym_COLON_QMARK] = ACTIONS(2340),
    [anon_sym_COLON_COLON] = ACTIONS(2342),
    [anon_sym_AMP] = ACTIONS(2340),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2342),
    [anon_sym_LBRACE] = ACTIONS(2340),
    [anon_sym_LT_AT] = ACTIONS(2340),
    [anon_sym_LT_AT_AT] = ACTIONS(2340),
    [anon_sym_DOT] = ACTIONS(2340),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2342),
    [anon_sym_new] = ACTIONS(2340),
    [anon_sym_return_BANG] = ACTIONS(2342),
    [anon_sym_yield] = ACTIONS(2340),
    [anon_sym_yield_BANG] = ACTIONS(2342),
    [anon_sym_lazy] = ACTIONS(2340),
    [anon_sym_assert] = ACTIONS(2340),
    [anon_sym_upcast] = ACTIONS(2340),
    [anon_sym_downcast] = ACTIONS(2340),
    [anon_sym_COLON_GT] = ACTIONS(2342),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2342),
    [anon_sym_for] = ACTIONS(2340),
    [anon_sym_while] = ACTIONS(2340),
    [anon_sym_if] = ACTIONS(2340),
    [anon_sym_fun] = ACTIONS(2340),
    [anon_sym_DASH_GT] = ACTIONS(2340),
    [anon_sym_try] = ACTIONS(2340),
    [anon_sym_match] = ACTIONS(2340),
    [anon_sym_match_BANG] = ACTIONS(2342),
    [anon_sym_function] = ACTIONS(2340),
    [anon_sym_LT_DASH] = ACTIONS(2340),
    [anon_sym_DOT_LBRACK] = ACTIONS(2342),
    [anon_sym_LT] = ACTIONS(2342),
    [anon_sym_use] = ACTIONS(2340),
    [anon_sym_use_BANG] = ACTIONS(2342),
    [anon_sym_do_BANG] = ACTIONS(2342),
    [anon_sym_begin] = ACTIONS(2340),
    [anon_sym_LPAREN2] = ACTIONS(2340),
    [anon_sym_STAR] = ACTIONS(2340),
    [anon_sym_LT2] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2342),
    [anon_sym_or] = ACTIONS(2340),
    [aux_sym_char_token1] = ACTIONS(2342),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2340),
    [anon_sym_DQUOTE] = ACTIONS(2340),
    [anon_sym_AT_DQUOTE] = ACTIONS(2342),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2342),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2342),
    [sym_bool] = ACTIONS(2340),
    [sym_unit] = ACTIONS(2342),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2340),
    [sym_op_identifier] = ACTIONS(2340),
    [anon_sym_PLUS] = ACTIONS(2340),
    [anon_sym_DASH] = ACTIONS(2340),
    [anon_sym_PLUS_DOT] = ACTIONS(2340),
    [anon_sym_DASH_DOT] = ACTIONS(2340),
    [anon_sym_PERCENT] = ACTIONS(2340),
    [anon_sym_AMP_AMP] = ACTIONS(2340),
    [anon_sym_TILDE] = ACTIONS(2342),
    [aux_sym_prefix_op_token1] = ACTIONS(2340),
    [aux_sym_infix_op_token1] = ACTIONS(2342),
    [aux_sym_infix_op_token2] = ACTIONS(2340),
    [anon_sym_PIPE_PIPE] = ACTIONS(2340),
    [anon_sym_BANG_EQ] = ACTIONS(2340),
    [anon_sym_COLON_EQ] = ACTIONS(2342),
    [anon_sym_DOLLAR] = ACTIONS(2340),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2340),
    [sym_int] = ACTIONS(2340),
    [sym_xint] = ACTIONS(2342),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2342),
    [sym__newline] = ACTIONS(2342),
    [sym__dedent] = ACTIONS(2342),
  },
  [1208] = {
    [sym_block_comment] = STATE(1208),
    [sym_compiler_directive_decl] = STATE(1208),
    [sym_fsi_directive_decl] = STATE(1208),
    [sym_preproc_line] = STATE(1208),
    [aux_sym_long_identifier_repeat1] = STATE(1244),
    [sym_identifier] = ACTIONS(2418),
    [anon_sym_EQ] = ACTIONS(2420),
    [anon_sym_COLON] = ACTIONS(2418),
    [anon_sym_return] = ACTIONS(2418),
    [anon_sym_do] = ACTIONS(2418),
    [anon_sym_let] = ACTIONS(2418),
    [anon_sym_let_BANG] = ACTIONS(2420),
    [anon_sym_LPAREN] = ACTIONS(2418),
    [anon_sym_COMMA] = ACTIONS(2420),
    [anon_sym_null] = ACTIONS(2418),
    [anon_sym_QMARK] = ACTIONS(2418),
    [anon_sym_COLON_QMARK] = ACTIONS(2418),
    [anon_sym_COLON_COLON] = ACTIONS(2420),
    [anon_sym_AMP] = ACTIONS(2418),
    [anon_sym_LBRACK] = ACTIONS(2418),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2420),
    [anon_sym_LBRACE] = ACTIONS(2418),
    [anon_sym_LT_AT] = ACTIONS(2418),
    [anon_sym_AT_GT] = ACTIONS(2418),
    [anon_sym_LT_AT_AT] = ACTIONS(2418),
    [anon_sym_DOT] = ACTIONS(3363),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2420),
    [anon_sym_new] = ACTIONS(2418),
    [anon_sym_return_BANG] = ACTIONS(2420),
    [anon_sym_yield] = ACTIONS(2418),
    [anon_sym_yield_BANG] = ACTIONS(2420),
    [anon_sym_lazy] = ACTIONS(2418),
    [anon_sym_assert] = ACTIONS(2418),
    [anon_sym_upcast] = ACTIONS(2418),
    [anon_sym_downcast] = ACTIONS(2418),
    [anon_sym_COLON_GT] = ACTIONS(2420),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2420),
    [anon_sym_for] = ACTIONS(2418),
    [anon_sym_while] = ACTIONS(2418),
    [anon_sym_if] = ACTIONS(2418),
    [anon_sym_fun] = ACTIONS(2418),
    [anon_sym_DASH_GT] = ACTIONS(2418),
    [anon_sym_try] = ACTIONS(2418),
    [anon_sym_match] = ACTIONS(2418),
    [anon_sym_match_BANG] = ACTIONS(2420),
    [anon_sym_function] = ACTIONS(2418),
    [anon_sym_LT_DASH] = ACTIONS(2418),
    [anon_sym_DOT_LBRACK] = ACTIONS(2420),
    [anon_sym_LT] = ACTIONS(2420),
    [anon_sym_use] = ACTIONS(2418),
    [anon_sym_use_BANG] = ACTIONS(2420),
    [anon_sym_do_BANG] = ACTIONS(2420),
    [anon_sym_begin] = ACTIONS(2418),
    [anon_sym_LPAREN2] = ACTIONS(2418),
    [anon_sym_STAR] = ACTIONS(2418),
    [anon_sym_LT2] = ACTIONS(2418),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2420),
    [anon_sym_or] = ACTIONS(2418),
    [aux_sym_char_token1] = ACTIONS(2420),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2418),
    [anon_sym_DQUOTE] = ACTIONS(2418),
    [anon_sym_AT_DQUOTE] = ACTIONS(2420),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2420),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2420),
    [sym_bool] = ACTIONS(2418),
    [sym_unit] = ACTIONS(2420),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2418),
    [sym_op_identifier] = ACTIONS(2418),
    [anon_sym_PLUS] = ACTIONS(2418),
    [anon_sym_DASH] = ACTIONS(2418),
    [anon_sym_PLUS_DOT] = ACTIONS(2418),
    [anon_sym_DASH_DOT] = ACTIONS(2418),
    [anon_sym_PERCENT] = ACTIONS(2418),
    [anon_sym_AMP_AMP] = ACTIONS(2418),
    [anon_sym_TILDE] = ACTIONS(2420),
    [aux_sym_prefix_op_token1] = ACTIONS(2418),
    [aux_sym_infix_op_token1] = ACTIONS(2420),
    [aux_sym_infix_op_token2] = ACTIONS(2418),
    [anon_sym_PIPE_PIPE] = ACTIONS(2418),
    [anon_sym_BANG_EQ] = ACTIONS(2418),
    [anon_sym_COLON_EQ] = ACTIONS(2420),
    [anon_sym_DOLLAR] = ACTIONS(2418),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2418),
    [sym_int] = ACTIONS(2418),
    [sym_xint] = ACTIONS(2420),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2420),
    [sym__newline] = ACTIONS(2420),
  },
  [1209] = {
    [sym_block_comment] = STATE(1209),
    [sym_compiler_directive_decl] = STATE(1209),
    [sym_fsi_directive_decl] = STATE(1209),
    [sym_preproc_line] = STATE(1209),
    [aux_sym_long_identifier_repeat1] = STATE(1217),
    [sym_identifier] = ACTIONS(2418),
    [anon_sym_EQ] = ACTIONS(2420),
    [anon_sym_COLON] = ACTIONS(2418),
    [anon_sym_return] = ACTIONS(2418),
    [anon_sym_do] = ACTIONS(2418),
    [anon_sym_let] = ACTIONS(2418),
    [anon_sym_let_BANG] = ACTIONS(2420),
    [anon_sym_LPAREN] = ACTIONS(2418),
    [anon_sym_COMMA] = ACTIONS(2420),
    [anon_sym_null] = ACTIONS(2418),
    [anon_sym_QMARK] = ACTIONS(2418),
    [anon_sym_COLON_QMARK] = ACTIONS(2418),
    [anon_sym_COLON_COLON] = ACTIONS(2420),
    [anon_sym_AMP] = ACTIONS(2418),
    [anon_sym_LBRACK] = ACTIONS(2418),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2420),
    [anon_sym_LBRACE] = ACTIONS(2418),
    [anon_sym_LT_AT] = ACTIONS(2418),
    [anon_sym_LT_AT_AT] = ACTIONS(2418),
    [anon_sym_DOT] = ACTIONS(3371),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2420),
    [anon_sym_new] = ACTIONS(2418),
    [anon_sym_return_BANG] = ACTIONS(2420),
    [anon_sym_yield] = ACTIONS(2418),
    [anon_sym_yield_BANG] = ACTIONS(2420),
    [anon_sym_lazy] = ACTIONS(2418),
    [anon_sym_assert] = ACTIONS(2418),
    [anon_sym_upcast] = ACTIONS(2418),
    [anon_sym_downcast] = ACTIONS(2418),
    [anon_sym_COLON_GT] = ACTIONS(2420),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2420),
    [anon_sym_for] = ACTIONS(2418),
    [anon_sym_while] = ACTIONS(2418),
    [anon_sym_if] = ACTIONS(2418),
    [anon_sym_fun] = ACTIONS(2418),
    [anon_sym_DASH_GT] = ACTIONS(2418),
    [anon_sym_try] = ACTIONS(2418),
    [anon_sym_match] = ACTIONS(2418),
    [anon_sym_match_BANG] = ACTIONS(2420),
    [anon_sym_function] = ACTIONS(2418),
    [anon_sym_LT_DASH] = ACTIONS(2418),
    [anon_sym_DOT_LBRACK] = ACTIONS(2420),
    [anon_sym_LT] = ACTIONS(2420),
    [anon_sym_use] = ACTIONS(2418),
    [anon_sym_use_BANG] = ACTIONS(2420),
    [anon_sym_do_BANG] = ACTIONS(2420),
    [anon_sym_begin] = ACTIONS(2418),
    [anon_sym_LPAREN2] = ACTIONS(2418),
    [anon_sym_STAR] = ACTIONS(2418),
    [anon_sym_LT2] = ACTIONS(2418),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2420),
    [anon_sym_or] = ACTIONS(2418),
    [aux_sym_char_token1] = ACTIONS(2420),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2418),
    [anon_sym_DQUOTE] = ACTIONS(2418),
    [anon_sym_AT_DQUOTE] = ACTIONS(2420),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2420),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2420),
    [sym_bool] = ACTIONS(2418),
    [sym_unit] = ACTIONS(2420),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2418),
    [sym_op_identifier] = ACTIONS(2418),
    [anon_sym_PLUS] = ACTIONS(2418),
    [anon_sym_DASH] = ACTIONS(2418),
    [anon_sym_PLUS_DOT] = ACTIONS(2418),
    [anon_sym_DASH_DOT] = ACTIONS(2418),
    [anon_sym_PERCENT] = ACTIONS(2418),
    [anon_sym_AMP_AMP] = ACTIONS(2418),
    [anon_sym_TILDE] = ACTIONS(2420),
    [aux_sym_prefix_op_token1] = ACTIONS(2418),
    [aux_sym_infix_op_token1] = ACTIONS(2420),
    [aux_sym_infix_op_token2] = ACTIONS(2418),
    [anon_sym_PIPE_PIPE] = ACTIONS(2418),
    [anon_sym_BANG_EQ] = ACTIONS(2418),
    [anon_sym_COLON_EQ] = ACTIONS(2420),
    [anon_sym_DOLLAR] = ACTIONS(2418),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2418),
    [sym_int] = ACTIONS(2418),
    [sym_xint] = ACTIONS(2420),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2420),
    [anon_sym_POUNDendif] = ACTIONS(2420),
    [sym__newline] = ACTIONS(2420),
  },
  [1210] = {
    [sym_block_comment] = STATE(1210),
    [sym_compiler_directive_decl] = STATE(1210),
    [sym_fsi_directive_decl] = STATE(1210),
    [sym_preproc_line] = STATE(1210),
    [aux_sym_type_argument_repeat1] = STATE(1210),
    [sym_identifier] = ACTIONS(2340),
    [anon_sym_EQ] = ACTIONS(2342),
    [anon_sym_COLON] = ACTIONS(2340),
    [anon_sym_return] = ACTIONS(2340),
    [anon_sym_do] = ACTIONS(2340),
    [anon_sym_let] = ACTIONS(2340),
    [anon_sym_let_BANG] = ACTIONS(2342),
    [anon_sym_LPAREN] = ACTIONS(2340),
    [anon_sym_COMMA] = ACTIONS(2342),
    [anon_sym_null] = ACTIONS(2340),
    [anon_sym_QMARK] = ACTIONS(2340),
    [anon_sym_COLON_QMARK] = ACTIONS(2340),
    [anon_sym_COLON_COLON] = ACTIONS(2342),
    [anon_sym_AMP] = ACTIONS(2340),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2342),
    [anon_sym_LBRACE] = ACTIONS(2340),
    [anon_sym_LT_AT] = ACTIONS(2340),
    [anon_sym_LT_AT_AT] = ACTIONS(2340),
    [anon_sym_DOT] = ACTIONS(2340),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2342),
    [anon_sym_new] = ACTIONS(2340),
    [anon_sym_return_BANG] = ACTIONS(2342),
    [anon_sym_yield] = ACTIONS(2340),
    [anon_sym_yield_BANG] = ACTIONS(2342),
    [anon_sym_lazy] = ACTIONS(2340),
    [anon_sym_assert] = ACTIONS(2340),
    [anon_sym_upcast] = ACTIONS(2340),
    [anon_sym_downcast] = ACTIONS(2340),
    [anon_sym_COLON_GT] = ACTIONS(2342),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2342),
    [anon_sym_for] = ACTIONS(2340),
    [anon_sym_while] = ACTIONS(2340),
    [anon_sym_if] = ACTIONS(2340),
    [anon_sym_fun] = ACTIONS(2340),
    [anon_sym_DASH_GT] = ACTIONS(2340),
    [anon_sym_try] = ACTIONS(2340),
    [anon_sym_match] = ACTIONS(2340),
    [anon_sym_match_BANG] = ACTIONS(2342),
    [anon_sym_function] = ACTIONS(2340),
    [anon_sym_LT_DASH] = ACTIONS(2340),
    [anon_sym_DOT_LBRACK] = ACTIONS(2342),
    [anon_sym_LT] = ACTIONS(2342),
    [anon_sym_use] = ACTIONS(2340),
    [anon_sym_use_BANG] = ACTIONS(2342),
    [anon_sym_do_BANG] = ACTIONS(2342),
    [anon_sym_begin] = ACTIONS(2340),
    [anon_sym_LPAREN2] = ACTIONS(2340),
    [anon_sym_STAR] = ACTIONS(2340),
    [anon_sym_LT2] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2342),
    [anon_sym_or] = ACTIONS(3388),
    [aux_sym_char_token1] = ACTIONS(2342),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2340),
    [anon_sym_DQUOTE] = ACTIONS(2340),
    [anon_sym_AT_DQUOTE] = ACTIONS(2342),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2342),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2342),
    [sym_bool] = ACTIONS(2340),
    [sym_unit] = ACTIONS(2342),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2340),
    [sym_op_identifier] = ACTIONS(2340),
    [anon_sym_PLUS] = ACTIONS(2340),
    [anon_sym_DASH] = ACTIONS(2340),
    [anon_sym_PLUS_DOT] = ACTIONS(2340),
    [anon_sym_DASH_DOT] = ACTIONS(2340),
    [anon_sym_PERCENT] = ACTIONS(2340),
    [anon_sym_AMP_AMP] = ACTIONS(2340),
    [anon_sym_TILDE] = ACTIONS(2342),
    [aux_sym_prefix_op_token1] = ACTIONS(2340),
    [aux_sym_infix_op_token1] = ACTIONS(2342),
    [aux_sym_infix_op_token2] = ACTIONS(2340),
    [anon_sym_PIPE_PIPE] = ACTIONS(2340),
    [anon_sym_BANG_EQ] = ACTIONS(2340),
    [anon_sym_COLON_EQ] = ACTIONS(2342),
    [anon_sym_DOLLAR] = ACTIONS(2340),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2340),
    [sym_int] = ACTIONS(2340),
    [sym_xint] = ACTIONS(2342),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2342),
    [anon_sym_POUNDendif] = ACTIONS(2342),
    [sym__newline] = ACTIONS(2342),
  },
  [1211] = {
    [sym_block_comment] = STATE(1211),
    [sym_compiler_directive_decl] = STATE(1211),
    [sym_fsi_directive_decl] = STATE(1211),
    [sym_preproc_line] = STATE(1211),
    [aux_sym_type_argument_repeat1] = STATE(1176),
    [sym_identifier] = ACTIONS(2328),
    [anon_sym_EQ] = ACTIONS(2330),
    [anon_sym_COLON] = ACTIONS(2328),
    [anon_sym_return] = ACTIONS(2328),
    [anon_sym_do] = ACTIONS(2328),
    [anon_sym_let] = ACTIONS(2328),
    [anon_sym_let_BANG] = ACTIONS(2330),
    [anon_sym_LPAREN] = ACTIONS(2328),
    [anon_sym_COMMA] = ACTIONS(2330),
    [anon_sym_null] = ACTIONS(2328),
    [anon_sym_QMARK] = ACTIONS(2328),
    [anon_sym_COLON_QMARK] = ACTIONS(2328),
    [anon_sym_COLON_COLON] = ACTIONS(2330),
    [anon_sym_AMP] = ACTIONS(2328),
    [anon_sym_LBRACK] = ACTIONS(2328),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2330),
    [anon_sym_LBRACE] = ACTIONS(2328),
    [anon_sym_LT_AT] = ACTIONS(2328),
    [anon_sym_AT_GT] = ACTIONS(2328),
    [anon_sym_LT_AT_AT] = ACTIONS(2328),
    [anon_sym_DOT] = ACTIONS(2328),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2330),
    [anon_sym_new] = ACTIONS(2328),
    [anon_sym_return_BANG] = ACTIONS(2330),
    [anon_sym_yield] = ACTIONS(2328),
    [anon_sym_yield_BANG] = ACTIONS(2330),
    [anon_sym_lazy] = ACTIONS(2328),
    [anon_sym_assert] = ACTIONS(2328),
    [anon_sym_upcast] = ACTIONS(2328),
    [anon_sym_downcast] = ACTIONS(2328),
    [anon_sym_COLON_GT] = ACTIONS(2330),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2330),
    [anon_sym_for] = ACTIONS(2328),
    [anon_sym_while] = ACTIONS(2328),
    [anon_sym_if] = ACTIONS(2328),
    [anon_sym_fun] = ACTIONS(2328),
    [anon_sym_DASH_GT] = ACTIONS(2328),
    [anon_sym_try] = ACTIONS(2328),
    [anon_sym_match] = ACTIONS(2328),
    [anon_sym_match_BANG] = ACTIONS(2330),
    [anon_sym_function] = ACTIONS(2328),
    [anon_sym_LT_DASH] = ACTIONS(2328),
    [anon_sym_DOT_LBRACK] = ACTIONS(2330),
    [anon_sym_LT] = ACTIONS(2330),
    [anon_sym_use] = ACTIONS(2328),
    [anon_sym_use_BANG] = ACTIONS(2330),
    [anon_sym_do_BANG] = ACTIONS(2330),
    [anon_sym_begin] = ACTIONS(2328),
    [anon_sym_LPAREN2] = ACTIONS(2328),
    [anon_sym_STAR] = ACTIONS(2328),
    [anon_sym_LT2] = ACTIONS(2328),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2330),
    [anon_sym_or] = ACTIONS(2328),
    [aux_sym_char_token1] = ACTIONS(2330),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2328),
    [anon_sym_DQUOTE] = ACTIONS(2328),
    [anon_sym_AT_DQUOTE] = ACTIONS(2330),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2330),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2330),
    [sym_bool] = ACTIONS(2328),
    [sym_unit] = ACTIONS(2330),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2328),
    [sym_op_identifier] = ACTIONS(2328),
    [anon_sym_PLUS] = ACTIONS(2328),
    [anon_sym_DASH] = ACTIONS(2328),
    [anon_sym_PLUS_DOT] = ACTIONS(2328),
    [anon_sym_DASH_DOT] = ACTIONS(2328),
    [anon_sym_PERCENT] = ACTIONS(2328),
    [anon_sym_AMP_AMP] = ACTIONS(2328),
    [anon_sym_TILDE] = ACTIONS(2330),
    [aux_sym_prefix_op_token1] = ACTIONS(2328),
    [aux_sym_infix_op_token1] = ACTIONS(2330),
    [aux_sym_infix_op_token2] = ACTIONS(2328),
    [anon_sym_PIPE_PIPE] = ACTIONS(2328),
    [anon_sym_BANG_EQ] = ACTIONS(2328),
    [anon_sym_COLON_EQ] = ACTIONS(2330),
    [anon_sym_DOLLAR] = ACTIONS(2328),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2328),
    [sym_int] = ACTIONS(2328),
    [sym_xint] = ACTIONS(2330),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2330),
    [sym__newline] = ACTIONS(2330),
  },
  [1212] = {
    [sym_block_comment] = STATE(1212),
    [sym_compiler_directive_decl] = STATE(1212),
    [sym_fsi_directive_decl] = STATE(1212),
    [sym_preproc_line] = STATE(1212),
    [sym_identifier] = ACTIONS(2567),
    [anon_sym_EQ] = ACTIONS(2569),
    [anon_sym_COLON] = ACTIONS(2567),
    [anon_sym_return] = ACTIONS(2567),
    [anon_sym_do] = ACTIONS(2567),
    [anon_sym_let] = ACTIONS(2567),
    [anon_sym_let_BANG] = ACTIONS(2569),
    [anon_sym_as] = ACTIONS(2567),
    [anon_sym_LPAREN] = ACTIONS(2567),
    [anon_sym_COMMA] = ACTIONS(2569),
    [anon_sym_null] = ACTIONS(2567),
    [anon_sym_QMARK] = ACTIONS(2567),
    [anon_sym_COLON_QMARK] = ACTIONS(2567),
    [anon_sym_COLON_COLON] = ACTIONS(2569),
    [anon_sym_AMP] = ACTIONS(2567),
    [anon_sym_LBRACK] = ACTIONS(2567),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2569),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_LT_AT] = ACTIONS(2567),
    [anon_sym_LT_AT_AT] = ACTIONS(2567),
    [anon_sym_DOT] = ACTIONS(2567),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2569),
    [anon_sym_new] = ACTIONS(2567),
    [anon_sym_with] = ACTIONS(2567),
    [anon_sym_return_BANG] = ACTIONS(2569),
    [anon_sym_yield] = ACTIONS(2567),
    [anon_sym_yield_BANG] = ACTIONS(2569),
    [anon_sym_lazy] = ACTIONS(2567),
    [anon_sym_assert] = ACTIONS(2567),
    [anon_sym_upcast] = ACTIONS(2567),
    [anon_sym_downcast] = ACTIONS(2567),
    [anon_sym_COLON_GT] = ACTIONS(2569),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2569),
    [anon_sym_for] = ACTIONS(2567),
    [anon_sym_while] = ACTIONS(2567),
    [anon_sym_if] = ACTIONS(2567),
    [anon_sym_fun] = ACTIONS(2567),
    [anon_sym_DASH_GT] = ACTIONS(2567),
    [anon_sym_try] = ACTIONS(2567),
    [anon_sym_match] = ACTIONS(2567),
    [anon_sym_match_BANG] = ACTIONS(2569),
    [anon_sym_function] = ACTIONS(2567),
    [anon_sym_LT_DASH] = ACTIONS(2567),
    [anon_sym_DOT_LBRACK] = ACTIONS(2569),
    [anon_sym_LT] = ACTIONS(2569),
    [anon_sym_use] = ACTIONS(2567),
    [anon_sym_use_BANG] = ACTIONS(2569),
    [anon_sym_do_BANG] = ACTIONS(2569),
    [anon_sym_begin] = ACTIONS(2567),
    [anon_sym_LPAREN2] = ACTIONS(2567),
    [anon_sym_STAR] = ACTIONS(2567),
    [anon_sym_LT2] = ACTIONS(2567),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2569),
    [anon_sym_or] = ACTIONS(2567),
    [aux_sym_char_token1] = ACTIONS(2569),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2567),
    [anon_sym_DQUOTE] = ACTIONS(2567),
    [anon_sym_AT_DQUOTE] = ACTIONS(2569),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2569),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2569),
    [sym_bool] = ACTIONS(2567),
    [sym_unit] = ACTIONS(2569),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2567),
    [sym_op_identifier] = ACTIONS(2567),
    [anon_sym_PLUS] = ACTIONS(2567),
    [anon_sym_DASH] = ACTIONS(2567),
    [anon_sym_PLUS_DOT] = ACTIONS(2567),
    [anon_sym_DASH_DOT] = ACTIONS(2567),
    [anon_sym_PERCENT] = ACTIONS(2567),
    [anon_sym_AMP_AMP] = ACTIONS(2567),
    [anon_sym_TILDE] = ACTIONS(2569),
    [aux_sym_prefix_op_token1] = ACTIONS(2567),
    [aux_sym_infix_op_token1] = ACTIONS(2569),
    [aux_sym_infix_op_token2] = ACTIONS(2567),
    [anon_sym_PIPE_PIPE] = ACTIONS(2567),
    [anon_sym_BANG_EQ] = ACTIONS(2567),
    [anon_sym_COLON_EQ] = ACTIONS(2569),
    [anon_sym_DOLLAR] = ACTIONS(2567),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2567),
    [sym_int] = ACTIONS(2567),
    [sym_xint] = ACTIONS(2569),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2569),
    [sym__newline] = ACTIONS(2569),
  },
  [1213] = {
    [sym_block_comment] = STATE(1213),
    [sym_compiler_directive_decl] = STATE(1213),
    [sym_fsi_directive_decl] = STATE(1213),
    [sym_preproc_line] = STATE(1213),
    [sym_identifier] = ACTIONS(2462),
    [anon_sym_EQ] = ACTIONS(2464),
    [anon_sym_COLON] = ACTIONS(2462),
    [anon_sym_return] = ACTIONS(2462),
    [anon_sym_do] = ACTIONS(2462),
    [anon_sym_let] = ACTIONS(2462),
    [anon_sym_let_BANG] = ACTIONS(2464),
    [anon_sym_as] = ACTIONS(2462),
    [anon_sym_LPAREN] = ACTIONS(2462),
    [anon_sym_COMMA] = ACTIONS(2464),
    [anon_sym_null] = ACTIONS(2462),
    [anon_sym_QMARK] = ACTIONS(2462),
    [anon_sym_COLON_QMARK] = ACTIONS(2462),
    [anon_sym_COLON_COLON] = ACTIONS(2464),
    [anon_sym_AMP] = ACTIONS(2462),
    [anon_sym_LBRACK] = ACTIONS(2462),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2464),
    [anon_sym_LBRACE] = ACTIONS(2462),
    [anon_sym_LT_AT] = ACTIONS(2462),
    [anon_sym_LT_AT_AT] = ACTIONS(2462),
    [anon_sym_DOT] = ACTIONS(2462),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2464),
    [anon_sym_new] = ACTIONS(2462),
    [anon_sym_with] = ACTIONS(2462),
    [anon_sym_return_BANG] = ACTIONS(2464),
    [anon_sym_yield] = ACTIONS(2462),
    [anon_sym_yield_BANG] = ACTIONS(2464),
    [anon_sym_lazy] = ACTIONS(2462),
    [anon_sym_assert] = ACTIONS(2462),
    [anon_sym_upcast] = ACTIONS(2462),
    [anon_sym_downcast] = ACTIONS(2462),
    [anon_sym_COLON_GT] = ACTIONS(2464),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2464),
    [anon_sym_for] = ACTIONS(2462),
    [anon_sym_while] = ACTIONS(2462),
    [anon_sym_if] = ACTIONS(2462),
    [anon_sym_fun] = ACTIONS(2462),
    [anon_sym_DASH_GT] = ACTIONS(2462),
    [anon_sym_try] = ACTIONS(2462),
    [anon_sym_match] = ACTIONS(2462),
    [anon_sym_match_BANG] = ACTIONS(2464),
    [anon_sym_function] = ACTIONS(2462),
    [anon_sym_LT_DASH] = ACTIONS(2462),
    [anon_sym_DOT_LBRACK] = ACTIONS(2464),
    [anon_sym_LT] = ACTIONS(2464),
    [anon_sym_use] = ACTIONS(2462),
    [anon_sym_use_BANG] = ACTIONS(2464),
    [anon_sym_do_BANG] = ACTIONS(2464),
    [anon_sym_begin] = ACTIONS(2462),
    [anon_sym_LPAREN2] = ACTIONS(2462),
    [anon_sym_STAR] = ACTIONS(2462),
    [anon_sym_LT2] = ACTIONS(2462),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2464),
    [anon_sym_or] = ACTIONS(2462),
    [aux_sym_char_token1] = ACTIONS(2464),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2462),
    [anon_sym_DQUOTE] = ACTIONS(2462),
    [anon_sym_AT_DQUOTE] = ACTIONS(2464),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2464),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2464),
    [sym_bool] = ACTIONS(2462),
    [sym_unit] = ACTIONS(2464),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2462),
    [sym_op_identifier] = ACTIONS(2462),
    [anon_sym_PLUS] = ACTIONS(2462),
    [anon_sym_DASH] = ACTIONS(2462),
    [anon_sym_PLUS_DOT] = ACTIONS(2462),
    [anon_sym_DASH_DOT] = ACTIONS(2462),
    [anon_sym_PERCENT] = ACTIONS(2462),
    [anon_sym_AMP_AMP] = ACTIONS(2462),
    [anon_sym_TILDE] = ACTIONS(2464),
    [aux_sym_prefix_op_token1] = ACTIONS(2462),
    [aux_sym_infix_op_token1] = ACTIONS(2464),
    [aux_sym_infix_op_token2] = ACTIONS(2462),
    [anon_sym_PIPE_PIPE] = ACTIONS(2462),
    [anon_sym_BANG_EQ] = ACTIONS(2462),
    [anon_sym_COLON_EQ] = ACTIONS(2464),
    [anon_sym_DOLLAR] = ACTIONS(2462),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2462),
    [sym_int] = ACTIONS(2462),
    [sym_xint] = ACTIONS(2464),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2464),
    [sym__newline] = ACTIONS(2464),
  },
  [1214] = {
    [sym_block_comment] = STATE(1214),
    [sym_compiler_directive_decl] = STATE(1214),
    [sym_fsi_directive_decl] = STATE(1214),
    [sym_preproc_line] = STATE(1214),
    [aux_sym_compound_type_repeat1] = STATE(1214),
    [sym_identifier] = ACTIONS(2250),
    [anon_sym_EQ] = ACTIONS(2248),
    [anon_sym_COLON] = ACTIONS(2250),
    [anon_sym_return] = ACTIONS(2250),
    [anon_sym_do] = ACTIONS(2250),
    [anon_sym_let] = ACTIONS(2250),
    [anon_sym_let_BANG] = ACTIONS(2248),
    [anon_sym_LPAREN] = ACTIONS(2250),
    [anon_sym_COMMA] = ACTIONS(2248),
    [anon_sym_null] = ACTIONS(2250),
    [anon_sym_QMARK] = ACTIONS(2250),
    [anon_sym_COLON_QMARK] = ACTIONS(2250),
    [anon_sym_COLON_COLON] = ACTIONS(2248),
    [anon_sym_AMP] = ACTIONS(2250),
    [anon_sym_LBRACK] = ACTIONS(2250),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2248),
    [anon_sym_LBRACE] = ACTIONS(2250),
    [anon_sym_LT_AT] = ACTIONS(2250),
    [anon_sym_LT_AT_AT] = ACTIONS(2250),
    [anon_sym_DOT] = ACTIONS(2250),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2248),
    [anon_sym_new] = ACTIONS(2250),
    [anon_sym_return_BANG] = ACTIONS(2248),
    [anon_sym_yield] = ACTIONS(2250),
    [anon_sym_yield_BANG] = ACTIONS(2248),
    [anon_sym_lazy] = ACTIONS(2250),
    [anon_sym_assert] = ACTIONS(2250),
    [anon_sym_upcast] = ACTIONS(2250),
    [anon_sym_downcast] = ACTIONS(2250),
    [anon_sym_COLON_GT] = ACTIONS(2248),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2248),
    [anon_sym_for] = ACTIONS(2250),
    [anon_sym_while] = ACTIONS(2250),
    [anon_sym_if] = ACTIONS(2250),
    [anon_sym_fun] = ACTIONS(2250),
    [anon_sym_DASH_GT] = ACTIONS(2250),
    [anon_sym_try] = ACTIONS(2250),
    [anon_sym_match] = ACTIONS(2250),
    [anon_sym_match_BANG] = ACTIONS(2248),
    [anon_sym_function] = ACTIONS(2250),
    [anon_sym_LT_DASH] = ACTIONS(2250),
    [anon_sym_DOT_LBRACK] = ACTIONS(2248),
    [anon_sym_LT] = ACTIONS(2248),
    [anon_sym_use] = ACTIONS(2250),
    [anon_sym_use_BANG] = ACTIONS(2248),
    [anon_sym_do_BANG] = ACTIONS(2248),
    [anon_sym_DOT_DOT] = ACTIONS(2248),
    [anon_sym_begin] = ACTIONS(2250),
    [anon_sym_LPAREN2] = ACTIONS(2250),
    [anon_sym_STAR] = ACTIONS(3391),
    [anon_sym_LT2] = ACTIONS(2250),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2248),
    [anon_sym_or] = ACTIONS(2250),
    [aux_sym_char_token1] = ACTIONS(2248),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2250),
    [anon_sym_DQUOTE] = ACTIONS(2250),
    [anon_sym_AT_DQUOTE] = ACTIONS(2248),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2248),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2248),
    [sym_bool] = ACTIONS(2250),
    [sym_unit] = ACTIONS(2248),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2250),
    [sym_op_identifier] = ACTIONS(2250),
    [anon_sym_PLUS] = ACTIONS(2250),
    [anon_sym_DASH] = ACTIONS(2250),
    [anon_sym_PLUS_DOT] = ACTIONS(2250),
    [anon_sym_DASH_DOT] = ACTIONS(2250),
    [anon_sym_PERCENT] = ACTIONS(2250),
    [anon_sym_AMP_AMP] = ACTIONS(2250),
    [anon_sym_TILDE] = ACTIONS(2248),
    [aux_sym_prefix_op_token1] = ACTIONS(2250),
    [aux_sym_infix_op_token1] = ACTIONS(2248),
    [aux_sym_infix_op_token2] = ACTIONS(2250),
    [anon_sym_PIPE_PIPE] = ACTIONS(2250),
    [anon_sym_BANG_EQ] = ACTIONS(2250),
    [anon_sym_COLON_EQ] = ACTIONS(2248),
    [anon_sym_DOLLAR] = ACTIONS(2250),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2250),
    [sym_int] = ACTIONS(2250),
    [sym_xint] = ACTIONS(2248),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2248),
    [sym__newline] = ACTIONS(2248),
  },
  [1215] = {
    [sym_block_comment] = STATE(1215),
    [sym_compiler_directive_decl] = STATE(1215),
    [sym_fsi_directive_decl] = STATE(1215),
    [sym_preproc_line] = STATE(1215),
    [aux_sym_type_argument_repeat1] = STATE(1223),
    [sym_identifier] = ACTIONS(2328),
    [anon_sym_EQ] = ACTIONS(2330),
    [anon_sym_COLON] = ACTIONS(2328),
    [anon_sym_return] = ACTIONS(2328),
    [anon_sym_do] = ACTIONS(2328),
    [anon_sym_let] = ACTIONS(2328),
    [anon_sym_let_BANG] = ACTIONS(2330),
    [anon_sym_LPAREN] = ACTIONS(2328),
    [anon_sym_COMMA] = ACTIONS(2330),
    [anon_sym_null] = ACTIONS(2328),
    [anon_sym_QMARK] = ACTIONS(2328),
    [anon_sym_COLON_QMARK] = ACTIONS(2328),
    [anon_sym_COLON_COLON] = ACTIONS(2330),
    [anon_sym_AMP] = ACTIONS(2328),
    [anon_sym_LBRACK] = ACTIONS(2328),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2330),
    [anon_sym_LBRACE] = ACTIONS(2328),
    [anon_sym_LT_AT] = ACTIONS(2328),
    [anon_sym_LT_AT_AT] = ACTIONS(2328),
    [anon_sym_DOT] = ACTIONS(2328),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2330),
    [anon_sym_new] = ACTIONS(2328),
    [anon_sym_return_BANG] = ACTIONS(2330),
    [anon_sym_yield] = ACTIONS(2328),
    [anon_sym_yield_BANG] = ACTIONS(2330),
    [anon_sym_lazy] = ACTIONS(2328),
    [anon_sym_assert] = ACTIONS(2328),
    [anon_sym_upcast] = ACTIONS(2328),
    [anon_sym_downcast] = ACTIONS(2328),
    [anon_sym_COLON_GT] = ACTIONS(2330),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2330),
    [anon_sym_for] = ACTIONS(2328),
    [anon_sym_while] = ACTIONS(2328),
    [anon_sym_if] = ACTIONS(2328),
    [anon_sym_fun] = ACTIONS(2328),
    [anon_sym_DASH_GT] = ACTIONS(2328),
    [anon_sym_try] = ACTIONS(2328),
    [anon_sym_match] = ACTIONS(2328),
    [anon_sym_match_BANG] = ACTIONS(2330),
    [anon_sym_function] = ACTIONS(2328),
    [anon_sym_LT_DASH] = ACTIONS(2328),
    [anon_sym_DOT_LBRACK] = ACTIONS(2330),
    [anon_sym_LT] = ACTIONS(2330),
    [anon_sym_use] = ACTIONS(2328),
    [anon_sym_use_BANG] = ACTIONS(2330),
    [anon_sym_do_BANG] = ACTIONS(2330),
    [anon_sym_DOT_DOT] = ACTIONS(2330),
    [anon_sym_begin] = ACTIONS(2328),
    [anon_sym_LPAREN2] = ACTIONS(2328),
    [anon_sym_STAR] = ACTIONS(2328),
    [anon_sym_LT2] = ACTIONS(2328),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2330),
    [anon_sym_or] = ACTIONS(2328),
    [aux_sym_char_token1] = ACTIONS(2330),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2328),
    [anon_sym_DQUOTE] = ACTIONS(2328),
    [anon_sym_AT_DQUOTE] = ACTIONS(2330),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2330),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2330),
    [sym_bool] = ACTIONS(2328),
    [sym_unit] = ACTIONS(2330),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2328),
    [sym_op_identifier] = ACTIONS(2328),
    [anon_sym_PLUS] = ACTIONS(2328),
    [anon_sym_DASH] = ACTIONS(2328),
    [anon_sym_PLUS_DOT] = ACTIONS(2328),
    [anon_sym_DASH_DOT] = ACTIONS(2328),
    [anon_sym_PERCENT] = ACTIONS(2328),
    [anon_sym_AMP_AMP] = ACTIONS(2328),
    [anon_sym_TILDE] = ACTIONS(2330),
    [aux_sym_prefix_op_token1] = ACTIONS(2328),
    [aux_sym_infix_op_token1] = ACTIONS(2330),
    [aux_sym_infix_op_token2] = ACTIONS(2328),
    [anon_sym_PIPE_PIPE] = ACTIONS(2328),
    [anon_sym_BANG_EQ] = ACTIONS(2328),
    [anon_sym_COLON_EQ] = ACTIONS(2330),
    [anon_sym_DOLLAR] = ACTIONS(2328),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2328),
    [sym_int] = ACTIONS(2328),
    [sym_xint] = ACTIONS(2330),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2330),
    [sym__newline] = ACTIONS(2330),
  },
  [1216] = {
    [sym_block_comment] = STATE(1216),
    [sym_compiler_directive_decl] = STATE(1216),
    [sym_fsi_directive_decl] = STATE(1216),
    [sym_preproc_line] = STATE(1216),
    [sym_identifier] = ACTIONS(2321),
    [anon_sym_EQ] = ACTIONS(2323),
    [anon_sym_COLON] = ACTIONS(2321),
    [anon_sym_return] = ACTIONS(2321),
    [anon_sym_do] = ACTIONS(2321),
    [anon_sym_let] = ACTIONS(2321),
    [anon_sym_let_BANG] = ACTIONS(2323),
    [anon_sym_as] = ACTIONS(2321),
    [anon_sym_LPAREN] = ACTIONS(2321),
    [anon_sym_COMMA] = ACTIONS(2323),
    [anon_sym_null] = ACTIONS(2321),
    [anon_sym_QMARK] = ACTIONS(2321),
    [anon_sym_COLON_QMARK] = ACTIONS(2321),
    [anon_sym_COLON_COLON] = ACTIONS(2323),
    [anon_sym_AMP] = ACTIONS(2321),
    [anon_sym_LBRACK] = ACTIONS(2321),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2323),
    [anon_sym_LBRACE] = ACTIONS(2321),
    [anon_sym_LT_AT] = ACTIONS(2321),
    [anon_sym_LT_AT_AT] = ACTIONS(2321),
    [anon_sym_DOT] = ACTIONS(2321),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2323),
    [anon_sym_new] = ACTIONS(2321),
    [anon_sym_with] = ACTIONS(2321),
    [anon_sym_return_BANG] = ACTIONS(2323),
    [anon_sym_yield] = ACTIONS(2321),
    [anon_sym_yield_BANG] = ACTIONS(2323),
    [anon_sym_lazy] = ACTIONS(2321),
    [anon_sym_assert] = ACTIONS(2321),
    [anon_sym_upcast] = ACTIONS(2321),
    [anon_sym_downcast] = ACTIONS(2321),
    [anon_sym_COLON_GT] = ACTIONS(2323),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2323),
    [anon_sym_for] = ACTIONS(2321),
    [anon_sym_while] = ACTIONS(2321),
    [anon_sym_if] = ACTIONS(2321),
    [anon_sym_fun] = ACTIONS(2321),
    [anon_sym_DASH_GT] = ACTIONS(2321),
    [anon_sym_try] = ACTIONS(2321),
    [anon_sym_match] = ACTIONS(2321),
    [anon_sym_match_BANG] = ACTIONS(2323),
    [anon_sym_function] = ACTIONS(2321),
    [anon_sym_LT_DASH] = ACTIONS(2321),
    [anon_sym_DOT_LBRACK] = ACTIONS(2323),
    [anon_sym_LT] = ACTIONS(2323),
    [anon_sym_use] = ACTIONS(2321),
    [anon_sym_use_BANG] = ACTIONS(2323),
    [anon_sym_do_BANG] = ACTIONS(2323),
    [anon_sym_begin] = ACTIONS(2321),
    [anon_sym_LPAREN2] = ACTIONS(2321),
    [anon_sym_STAR] = ACTIONS(2321),
    [anon_sym_LT2] = ACTIONS(2321),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2323),
    [anon_sym_or] = ACTIONS(2321),
    [aux_sym_char_token1] = ACTIONS(2323),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2321),
    [anon_sym_DQUOTE] = ACTIONS(2321),
    [anon_sym_AT_DQUOTE] = ACTIONS(2323),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2323),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2323),
    [sym_bool] = ACTIONS(2321),
    [sym_unit] = ACTIONS(2323),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2321),
    [sym_op_identifier] = ACTIONS(2321),
    [anon_sym_PLUS] = ACTIONS(2321),
    [anon_sym_DASH] = ACTIONS(2321),
    [anon_sym_PLUS_DOT] = ACTIONS(2321),
    [anon_sym_DASH_DOT] = ACTIONS(2321),
    [anon_sym_PERCENT] = ACTIONS(2321),
    [anon_sym_AMP_AMP] = ACTIONS(2321),
    [anon_sym_TILDE] = ACTIONS(2323),
    [aux_sym_prefix_op_token1] = ACTIONS(2321),
    [aux_sym_infix_op_token1] = ACTIONS(2323),
    [aux_sym_infix_op_token2] = ACTIONS(2321),
    [anon_sym_PIPE_PIPE] = ACTIONS(2321),
    [anon_sym_BANG_EQ] = ACTIONS(2321),
    [anon_sym_COLON_EQ] = ACTIONS(2323),
    [anon_sym_DOLLAR] = ACTIONS(2321),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2321),
    [sym_int] = ACTIONS(2321),
    [sym_xint] = ACTIONS(2323),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2323),
    [sym__newline] = ACTIONS(2323),
  },
  [1217] = {
    [sym_block_comment] = STATE(1217),
    [sym_compiler_directive_decl] = STATE(1217),
    [sym_fsi_directive_decl] = STATE(1217),
    [sym_preproc_line] = STATE(1217),
    [aux_sym_long_identifier_repeat1] = STATE(1217),
    [sym_identifier] = ACTIONS(2411),
    [anon_sym_EQ] = ACTIONS(2413),
    [anon_sym_COLON] = ACTIONS(2411),
    [anon_sym_return] = ACTIONS(2411),
    [anon_sym_do] = ACTIONS(2411),
    [anon_sym_let] = ACTIONS(2411),
    [anon_sym_let_BANG] = ACTIONS(2413),
    [anon_sym_LPAREN] = ACTIONS(2411),
    [anon_sym_COMMA] = ACTIONS(2413),
    [anon_sym_null] = ACTIONS(2411),
    [anon_sym_QMARK] = ACTIONS(2411),
    [anon_sym_COLON_QMARK] = ACTIONS(2411),
    [anon_sym_COLON_COLON] = ACTIONS(2413),
    [anon_sym_AMP] = ACTIONS(2411),
    [anon_sym_LBRACK] = ACTIONS(2411),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2413),
    [anon_sym_LBRACE] = ACTIONS(2411),
    [anon_sym_LT_AT] = ACTIONS(2411),
    [anon_sym_LT_AT_AT] = ACTIONS(2411),
    [anon_sym_DOT] = ACTIONS(3394),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2413),
    [anon_sym_new] = ACTIONS(2411),
    [anon_sym_return_BANG] = ACTIONS(2413),
    [anon_sym_yield] = ACTIONS(2411),
    [anon_sym_yield_BANG] = ACTIONS(2413),
    [anon_sym_lazy] = ACTIONS(2411),
    [anon_sym_assert] = ACTIONS(2411),
    [anon_sym_upcast] = ACTIONS(2411),
    [anon_sym_downcast] = ACTIONS(2411),
    [anon_sym_COLON_GT] = ACTIONS(2413),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2413),
    [anon_sym_for] = ACTIONS(2411),
    [anon_sym_while] = ACTIONS(2411),
    [anon_sym_if] = ACTIONS(2411),
    [anon_sym_fun] = ACTIONS(2411),
    [anon_sym_DASH_GT] = ACTIONS(2411),
    [anon_sym_try] = ACTIONS(2411),
    [anon_sym_match] = ACTIONS(2411),
    [anon_sym_match_BANG] = ACTIONS(2413),
    [anon_sym_function] = ACTIONS(2411),
    [anon_sym_LT_DASH] = ACTIONS(2411),
    [anon_sym_DOT_LBRACK] = ACTIONS(2413),
    [anon_sym_LT] = ACTIONS(2413),
    [anon_sym_use] = ACTIONS(2411),
    [anon_sym_use_BANG] = ACTIONS(2413),
    [anon_sym_do_BANG] = ACTIONS(2413),
    [anon_sym_begin] = ACTIONS(2411),
    [anon_sym_LPAREN2] = ACTIONS(2411),
    [anon_sym_STAR] = ACTIONS(2411),
    [anon_sym_LT2] = ACTIONS(2411),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2413),
    [anon_sym_or] = ACTIONS(2411),
    [aux_sym_char_token1] = ACTIONS(2413),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2411),
    [anon_sym_DQUOTE] = ACTIONS(2411),
    [anon_sym_AT_DQUOTE] = ACTIONS(2413),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2413),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2413),
    [sym_bool] = ACTIONS(2411),
    [sym_unit] = ACTIONS(2413),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2411),
    [sym_op_identifier] = ACTIONS(2411),
    [anon_sym_PLUS] = ACTIONS(2411),
    [anon_sym_DASH] = ACTIONS(2411),
    [anon_sym_PLUS_DOT] = ACTIONS(2411),
    [anon_sym_DASH_DOT] = ACTIONS(2411),
    [anon_sym_PERCENT] = ACTIONS(2411),
    [anon_sym_AMP_AMP] = ACTIONS(2411),
    [anon_sym_TILDE] = ACTIONS(2413),
    [aux_sym_prefix_op_token1] = ACTIONS(2411),
    [aux_sym_infix_op_token1] = ACTIONS(2413),
    [aux_sym_infix_op_token2] = ACTIONS(2411),
    [anon_sym_PIPE_PIPE] = ACTIONS(2411),
    [anon_sym_BANG_EQ] = ACTIONS(2411),
    [anon_sym_COLON_EQ] = ACTIONS(2413),
    [anon_sym_DOLLAR] = ACTIONS(2411),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2411),
    [sym_int] = ACTIONS(2411),
    [sym_xint] = ACTIONS(2413),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2413),
    [anon_sym_POUNDendif] = ACTIONS(2413),
    [sym__newline] = ACTIONS(2413),
  },
  [1218] = {
    [sym__else_expression] = STATE(2358),
    [sym_elif_expression] = STATE(1613),
    [sym_block_comment] = STATE(1218),
    [sym_compiler_directive_decl] = STATE(1218),
    [sym_fsi_directive_decl] = STATE(1218),
    [sym_preproc_line] = STATE(1218),
    [aux_sym_if_expression_repeat1] = STATE(1308),
    [sym_identifier] = ACTIONS(2332),
    [anon_sym_EQ] = ACTIONS(2334),
    [anon_sym_COLON] = ACTIONS(2332),
    [anon_sym_return] = ACTIONS(2332),
    [anon_sym_do] = ACTIONS(2332),
    [anon_sym_let] = ACTIONS(2332),
    [anon_sym_let_BANG] = ACTIONS(2334),
    [anon_sym_LPAREN] = ACTIONS(2332),
    [anon_sym_COMMA] = ACTIONS(2334),
    [anon_sym_null] = ACTIONS(2332),
    [anon_sym_QMARK] = ACTIONS(2332),
    [anon_sym_COLON_QMARK] = ACTIONS(2332),
    [anon_sym_COLON_COLON] = ACTIONS(2334),
    [anon_sym_AMP] = ACTIONS(2332),
    [anon_sym_LBRACK] = ACTIONS(2332),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2334),
    [anon_sym_LBRACE] = ACTIONS(2332),
    [anon_sym_LT_AT] = ACTIONS(2332),
    [anon_sym_AT_GT] = ACTIONS(2332),
    [anon_sym_LT_AT_AT] = ACTIONS(2332),
    [anon_sym_DOT] = ACTIONS(2332),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2334),
    [anon_sym_new] = ACTIONS(2332),
    [anon_sym_return_BANG] = ACTIONS(2334),
    [anon_sym_yield] = ACTIONS(2332),
    [anon_sym_yield_BANG] = ACTIONS(2334),
    [anon_sym_lazy] = ACTIONS(2332),
    [anon_sym_assert] = ACTIONS(2332),
    [anon_sym_upcast] = ACTIONS(2332),
    [anon_sym_downcast] = ACTIONS(2332),
    [anon_sym_COLON_GT] = ACTIONS(2334),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2334),
    [anon_sym_for] = ACTIONS(2332),
    [anon_sym_while] = ACTIONS(2332),
    [anon_sym_else] = ACTIONS(3367),
    [anon_sym_elif] = ACTIONS(3369),
    [anon_sym_if] = ACTIONS(2332),
    [anon_sym_fun] = ACTIONS(2332),
    [anon_sym_try] = ACTIONS(2332),
    [anon_sym_match] = ACTIONS(2332),
    [anon_sym_match_BANG] = ACTIONS(2334),
    [anon_sym_function] = ACTIONS(2332),
    [anon_sym_LT_DASH] = ACTIONS(2332),
    [anon_sym_DOT_LBRACK] = ACTIONS(2334),
    [anon_sym_LT] = ACTIONS(2334),
    [anon_sym_use] = ACTIONS(2332),
    [anon_sym_use_BANG] = ACTIONS(2334),
    [anon_sym_do_BANG] = ACTIONS(2334),
    [anon_sym_begin] = ACTIONS(2332),
    [anon_sym_LPAREN2] = ACTIONS(2332),
    [anon_sym_or] = ACTIONS(2332),
    [aux_sym_char_token1] = ACTIONS(2334),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2332),
    [anon_sym_DQUOTE] = ACTIONS(2332),
    [anon_sym_AT_DQUOTE] = ACTIONS(2334),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2334),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2334),
    [sym_bool] = ACTIONS(2332),
    [sym_unit] = ACTIONS(2334),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2332),
    [sym_op_identifier] = ACTIONS(2332),
    [anon_sym_PLUS] = ACTIONS(2332),
    [anon_sym_DASH] = ACTIONS(2332),
    [anon_sym_PLUS_DOT] = ACTIONS(2332),
    [anon_sym_DASH_DOT] = ACTIONS(2332),
    [anon_sym_PERCENT] = ACTIONS(2332),
    [anon_sym_AMP_AMP] = ACTIONS(2332),
    [anon_sym_TILDE] = ACTIONS(2334),
    [aux_sym_prefix_op_token1] = ACTIONS(2332),
    [aux_sym_infix_op_token1] = ACTIONS(2334),
    [aux_sym_infix_op_token2] = ACTIONS(2332),
    [anon_sym_PIPE_PIPE] = ACTIONS(2332),
    [anon_sym_BANG_EQ] = ACTIONS(2332),
    [anon_sym_COLON_EQ] = ACTIONS(2334),
    [anon_sym_DOLLAR] = ACTIONS(2332),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2332),
    [sym_int] = ACTIONS(2332),
    [sym_xint] = ACTIONS(2334),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2334),
    [sym__newline] = ACTIONS(2334),
  },
  [1219] = {
    [sym_block_comment] = STATE(1219),
    [sym_compiler_directive_decl] = STATE(1219),
    [sym_fsi_directive_decl] = STATE(1219),
    [sym_preproc_line] = STATE(1219),
    [aux_sym_compound_type_repeat1] = STATE(1219),
    [sym_identifier] = ACTIONS(2250),
    [anon_sym_EQ] = ACTIONS(2248),
    [anon_sym_COLON] = ACTIONS(2250),
    [anon_sym_return] = ACTIONS(2250),
    [anon_sym_do] = ACTIONS(2250),
    [anon_sym_let] = ACTIONS(2250),
    [anon_sym_let_BANG] = ACTIONS(2248),
    [anon_sym_LPAREN] = ACTIONS(2250),
    [anon_sym_COMMA] = ACTIONS(2248),
    [anon_sym_null] = ACTIONS(2250),
    [anon_sym_QMARK] = ACTIONS(2250),
    [anon_sym_COLON_QMARK] = ACTIONS(2250),
    [anon_sym_COLON_COLON] = ACTIONS(2248),
    [anon_sym_AMP] = ACTIONS(2250),
    [anon_sym_LBRACK] = ACTIONS(2250),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2248),
    [anon_sym_LBRACE] = ACTIONS(2250),
    [anon_sym_LT_AT] = ACTIONS(2250),
    [anon_sym_LT_AT_AT] = ACTIONS(2250),
    [anon_sym_AT_AT_GT] = ACTIONS(2250),
    [anon_sym_DOT] = ACTIONS(2250),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2248),
    [anon_sym_new] = ACTIONS(2250),
    [anon_sym_return_BANG] = ACTIONS(2248),
    [anon_sym_yield] = ACTIONS(2250),
    [anon_sym_yield_BANG] = ACTIONS(2248),
    [anon_sym_lazy] = ACTIONS(2250),
    [anon_sym_assert] = ACTIONS(2250),
    [anon_sym_upcast] = ACTIONS(2250),
    [anon_sym_downcast] = ACTIONS(2250),
    [anon_sym_COLON_GT] = ACTIONS(2248),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2248),
    [anon_sym_for] = ACTIONS(2250),
    [anon_sym_while] = ACTIONS(2250),
    [anon_sym_if] = ACTIONS(2250),
    [anon_sym_fun] = ACTIONS(2250),
    [anon_sym_DASH_GT] = ACTIONS(2250),
    [anon_sym_try] = ACTIONS(2250),
    [anon_sym_match] = ACTIONS(2250),
    [anon_sym_match_BANG] = ACTIONS(2248),
    [anon_sym_function] = ACTIONS(2250),
    [anon_sym_LT_DASH] = ACTIONS(2250),
    [anon_sym_DOT_LBRACK] = ACTIONS(2248),
    [anon_sym_LT] = ACTIONS(2248),
    [anon_sym_use] = ACTIONS(2250),
    [anon_sym_use_BANG] = ACTIONS(2248),
    [anon_sym_do_BANG] = ACTIONS(2248),
    [anon_sym_begin] = ACTIONS(2250),
    [anon_sym_LPAREN2] = ACTIONS(2250),
    [anon_sym_STAR] = ACTIONS(3397),
    [anon_sym_LT2] = ACTIONS(2250),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2248),
    [anon_sym_or] = ACTIONS(2250),
    [aux_sym_char_token1] = ACTIONS(2248),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2250),
    [anon_sym_DQUOTE] = ACTIONS(2250),
    [anon_sym_AT_DQUOTE] = ACTIONS(2248),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2248),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2248),
    [sym_bool] = ACTIONS(2250),
    [sym_unit] = ACTIONS(2248),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2250),
    [sym_op_identifier] = ACTIONS(2250),
    [anon_sym_PLUS] = ACTIONS(2250),
    [anon_sym_DASH] = ACTIONS(2250),
    [anon_sym_PLUS_DOT] = ACTIONS(2250),
    [anon_sym_DASH_DOT] = ACTIONS(2250),
    [anon_sym_PERCENT] = ACTIONS(2250),
    [anon_sym_AMP_AMP] = ACTIONS(2250),
    [anon_sym_TILDE] = ACTIONS(2248),
    [aux_sym_prefix_op_token1] = ACTIONS(2250),
    [aux_sym_infix_op_token1] = ACTIONS(2248),
    [aux_sym_infix_op_token2] = ACTIONS(2250),
    [anon_sym_PIPE_PIPE] = ACTIONS(2250),
    [anon_sym_BANG_EQ] = ACTIONS(2250),
    [anon_sym_COLON_EQ] = ACTIONS(2248),
    [anon_sym_DOLLAR] = ACTIONS(2250),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2250),
    [sym_int] = ACTIONS(2250),
    [sym_xint] = ACTIONS(2248),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2248),
    [sym__newline] = ACTIONS(2248),
  },
  [1220] = {
    [sym_block_comment] = STATE(1220),
    [sym_compiler_directive_decl] = STATE(1220),
    [sym_fsi_directive_decl] = STATE(1220),
    [sym_preproc_line] = STATE(1220),
    [sym_identifier] = ACTIONS(2723),
    [anon_sym_EQ] = ACTIONS(2725),
    [anon_sym_COLON] = ACTIONS(2723),
    [anon_sym_return] = ACTIONS(2723),
    [anon_sym_do] = ACTIONS(2723),
    [anon_sym_let] = ACTIONS(2723),
    [anon_sym_let_BANG] = ACTIONS(2725),
    [anon_sym_LPAREN] = ACTIONS(2723),
    [anon_sym_COMMA] = ACTIONS(2725),
    [anon_sym_null] = ACTIONS(2723),
    [anon_sym_QMARK] = ACTIONS(2723),
    [anon_sym_COLON_QMARK] = ACTIONS(2723),
    [anon_sym_COLON_COLON] = ACTIONS(2725),
    [anon_sym_AMP] = ACTIONS(2723),
    [anon_sym_LBRACK] = ACTIONS(2723),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2725),
    [anon_sym_LBRACE] = ACTIONS(2723),
    [anon_sym_LT_AT] = ACTIONS(2723),
    [anon_sym_LT_AT_AT] = ACTIONS(2723),
    [anon_sym_DOT] = ACTIONS(2723),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2725),
    [anon_sym_new] = ACTIONS(2723),
    [anon_sym_with] = ACTIONS(2723),
    [anon_sym_return_BANG] = ACTIONS(2725),
    [anon_sym_yield] = ACTIONS(2723),
    [anon_sym_yield_BANG] = ACTIONS(2725),
    [anon_sym_lazy] = ACTIONS(2723),
    [anon_sym_assert] = ACTIONS(2723),
    [anon_sym_upcast] = ACTIONS(2723),
    [anon_sym_downcast] = ACTIONS(2723),
    [anon_sym_COLON_GT] = ACTIONS(2725),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2725),
    [anon_sym_for] = ACTIONS(2723),
    [anon_sym_while] = ACTIONS(2723),
    [anon_sym_if] = ACTIONS(2723),
    [anon_sym_fun] = ACTIONS(2723),
    [anon_sym_try] = ACTIONS(2723),
    [anon_sym_match] = ACTIONS(2723),
    [anon_sym_match_BANG] = ACTIONS(2725),
    [anon_sym_function] = ACTIONS(2723),
    [anon_sym_LT_DASH] = ACTIONS(2723),
    [anon_sym_DOT_LBRACK] = ACTIONS(2725),
    [anon_sym_LT] = ACTIONS(2725),
    [anon_sym_use] = ACTIONS(2723),
    [anon_sym_use_BANG] = ACTIONS(2725),
    [anon_sym_do_BANG] = ACTIONS(2725),
    [anon_sym_begin] = ACTIONS(2723),
    [anon_sym_LPAREN2] = ACTIONS(2723),
    [anon_sym_DOT_DOT2] = ACTIONS(2725),
    [anon_sym_or] = ACTIONS(2723),
    [aux_sym_char_token1] = ACTIONS(2725),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2723),
    [anon_sym_DQUOTE] = ACTIONS(2723),
    [anon_sym_AT_DQUOTE] = ACTIONS(2725),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2725),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2725),
    [sym_bool] = ACTIONS(2723),
    [sym_unit] = ACTIONS(2725),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2723),
    [sym_op_identifier] = ACTIONS(2723),
    [anon_sym_PLUS] = ACTIONS(2723),
    [anon_sym_DASH] = ACTIONS(2723),
    [anon_sym_PLUS_DOT] = ACTIONS(2723),
    [anon_sym_DASH_DOT] = ACTIONS(2723),
    [anon_sym_PERCENT] = ACTIONS(2723),
    [anon_sym_AMP_AMP] = ACTIONS(2723),
    [anon_sym_TILDE] = ACTIONS(2725),
    [aux_sym_prefix_op_token1] = ACTIONS(2723),
    [aux_sym_infix_op_token1] = ACTIONS(2725),
    [aux_sym_infix_op_token2] = ACTIONS(2723),
    [anon_sym_PIPE_PIPE] = ACTIONS(2723),
    [anon_sym_BANG_EQ] = ACTIONS(2723),
    [anon_sym_COLON_EQ] = ACTIONS(2725),
    [anon_sym_DOLLAR] = ACTIONS(2723),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2723),
    [sym_int] = ACTIONS(2723),
    [sym_xint] = ACTIONS(2725),
    [anon_sym_f] = ACTIONS(2723),
    [aux_sym_decimal_token1] = ACTIONS(2723),
    [aux_sym_float_token1] = ACTIONS(3400),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2725),
    [sym__newline] = ACTIONS(2725),
    [sym__dedent] = ACTIONS(2725),
  },
  [1221] = {
    [sym_block_comment] = STATE(1221),
    [sym_compiler_directive_decl] = STATE(1221),
    [sym_fsi_directive_decl] = STATE(1221),
    [sym_preproc_line] = STATE(1221),
    [sym_identifier] = ACTIONS(2553),
    [anon_sym_EQ] = ACTIONS(2555),
    [anon_sym_COLON] = ACTIONS(2553),
    [anon_sym_return] = ACTIONS(2553),
    [anon_sym_do] = ACTIONS(2553),
    [anon_sym_let] = ACTIONS(2553),
    [anon_sym_let_BANG] = ACTIONS(2555),
    [anon_sym_LPAREN] = ACTIONS(2553),
    [anon_sym_COMMA] = ACTIONS(2555),
    [anon_sym_null] = ACTIONS(2553),
    [anon_sym_QMARK] = ACTIONS(2553),
    [anon_sym_COLON_QMARK] = ACTIONS(2553),
    [anon_sym_COLON_COLON] = ACTIONS(2555),
    [anon_sym_AMP] = ACTIONS(2553),
    [anon_sym_LBRACK] = ACTIONS(2553),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2555),
    [anon_sym_LBRACE] = ACTIONS(2553),
    [anon_sym_LT_AT] = ACTIONS(2553),
    [anon_sym_LT_AT_AT] = ACTIONS(2553),
    [anon_sym_DOT] = ACTIONS(2553),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2555),
    [anon_sym_new] = ACTIONS(2553),
    [anon_sym_return_BANG] = ACTIONS(2555),
    [anon_sym_yield] = ACTIONS(2553),
    [anon_sym_yield_BANG] = ACTIONS(2555),
    [anon_sym_lazy] = ACTIONS(2553),
    [anon_sym_assert] = ACTIONS(2553),
    [anon_sym_upcast] = ACTIONS(2553),
    [anon_sym_downcast] = ACTIONS(2553),
    [anon_sym_COLON_GT] = ACTIONS(2555),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2555),
    [anon_sym_for] = ACTIONS(2553),
    [anon_sym_while] = ACTIONS(2553),
    [anon_sym_if] = ACTIONS(2553),
    [anon_sym_fun] = ACTIONS(2553),
    [anon_sym_DASH_GT] = ACTIONS(2553),
    [anon_sym_try] = ACTIONS(2553),
    [anon_sym_match] = ACTIONS(2553),
    [anon_sym_match_BANG] = ACTIONS(2555),
    [anon_sym_function] = ACTIONS(2553),
    [anon_sym_LT_DASH] = ACTIONS(2553),
    [anon_sym_DOT_LBRACK] = ACTIONS(2555),
    [anon_sym_LT] = ACTIONS(2555),
    [anon_sym_use] = ACTIONS(2553),
    [anon_sym_use_BANG] = ACTIONS(2555),
    [anon_sym_do_BANG] = ACTIONS(2555),
    [anon_sym_begin] = ACTIONS(2553),
    [anon_sym_LPAREN2] = ACTIONS(2553),
    [anon_sym_STAR] = ACTIONS(2553),
    [anon_sym_LT2] = ACTIONS(2553),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2555),
    [anon_sym_or] = ACTIONS(2553),
    [aux_sym_char_token1] = ACTIONS(2555),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2553),
    [anon_sym_DQUOTE] = ACTIONS(2553),
    [anon_sym_AT_DQUOTE] = ACTIONS(2555),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2555),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2555),
    [sym_bool] = ACTIONS(2553),
    [sym_unit] = ACTIONS(2555),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2553),
    [sym_op_identifier] = ACTIONS(2553),
    [anon_sym_PLUS] = ACTIONS(2553),
    [anon_sym_DASH] = ACTIONS(2553),
    [anon_sym_PLUS_DOT] = ACTIONS(2553),
    [anon_sym_DASH_DOT] = ACTIONS(2553),
    [anon_sym_PERCENT] = ACTIONS(2553),
    [anon_sym_AMP_AMP] = ACTIONS(2553),
    [anon_sym_TILDE] = ACTIONS(2555),
    [aux_sym_prefix_op_token1] = ACTIONS(2553),
    [aux_sym_infix_op_token1] = ACTIONS(2555),
    [aux_sym_infix_op_token2] = ACTIONS(2553),
    [anon_sym_PIPE_PIPE] = ACTIONS(2553),
    [anon_sym_BANG_EQ] = ACTIONS(2553),
    [anon_sym_COLON_EQ] = ACTIONS(2555),
    [anon_sym_DOLLAR] = ACTIONS(2553),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2553),
    [sym_int] = ACTIONS(2553),
    [sym_xint] = ACTIONS(2555),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2555),
    [anon_sym_POUNDendif] = ACTIONS(2555),
    [anon_sym_POUNDelse] = ACTIONS(2555),
    [sym__newline] = ACTIONS(2555),
  },
  [1222] = {
    [sym_block_comment] = STATE(1222),
    [sym_compiler_directive_decl] = STATE(1222),
    [sym_fsi_directive_decl] = STATE(1222),
    [sym_preproc_line] = STATE(1222),
    [aux_sym_long_identifier_repeat1] = STATE(1222),
    [sym_identifier] = ACTIONS(2411),
    [anon_sym_EQ] = ACTIONS(2413),
    [anon_sym_COLON] = ACTIONS(2411),
    [anon_sym_return] = ACTIONS(2411),
    [anon_sym_do] = ACTIONS(2411),
    [anon_sym_let] = ACTIONS(2411),
    [anon_sym_let_BANG] = ACTIONS(2413),
    [anon_sym_LPAREN] = ACTIONS(2411),
    [anon_sym_COMMA] = ACTIONS(2413),
    [anon_sym_null] = ACTIONS(2411),
    [anon_sym_QMARK] = ACTIONS(2411),
    [anon_sym_COLON_QMARK] = ACTIONS(2411),
    [anon_sym_COLON_COLON] = ACTIONS(2413),
    [anon_sym_AMP] = ACTIONS(2411),
    [anon_sym_LBRACK] = ACTIONS(2411),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2413),
    [anon_sym_LBRACE] = ACTIONS(2411),
    [anon_sym_LT_AT] = ACTIONS(2411),
    [anon_sym_LT_AT_AT] = ACTIONS(2411),
    [anon_sym_DOT] = ACTIONS(3402),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2413),
    [anon_sym_new] = ACTIONS(2411),
    [anon_sym_return_BANG] = ACTIONS(2413),
    [anon_sym_yield] = ACTIONS(2411),
    [anon_sym_yield_BANG] = ACTIONS(2413),
    [anon_sym_lazy] = ACTIONS(2411),
    [anon_sym_assert] = ACTIONS(2411),
    [anon_sym_upcast] = ACTIONS(2411),
    [anon_sym_downcast] = ACTIONS(2411),
    [anon_sym_COLON_GT] = ACTIONS(2413),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2413),
    [anon_sym_for] = ACTIONS(2411),
    [anon_sym_while] = ACTIONS(2411),
    [anon_sym_if] = ACTIONS(2411),
    [anon_sym_fun] = ACTIONS(2411),
    [anon_sym_DASH_GT] = ACTIONS(2411),
    [anon_sym_try] = ACTIONS(2411),
    [anon_sym_match] = ACTIONS(2411),
    [anon_sym_match_BANG] = ACTIONS(2413),
    [anon_sym_function] = ACTIONS(2411),
    [anon_sym_LT_DASH] = ACTIONS(2411),
    [anon_sym_DOT_LBRACK] = ACTIONS(2413),
    [anon_sym_LT] = ACTIONS(2413),
    [anon_sym_use] = ACTIONS(2411),
    [anon_sym_use_BANG] = ACTIONS(2413),
    [anon_sym_do_BANG] = ACTIONS(2413),
    [anon_sym_DOT_DOT] = ACTIONS(2413),
    [anon_sym_begin] = ACTIONS(2411),
    [anon_sym_LPAREN2] = ACTIONS(2411),
    [anon_sym_STAR] = ACTIONS(2411),
    [anon_sym_LT2] = ACTIONS(2411),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2413),
    [anon_sym_or] = ACTIONS(2411),
    [aux_sym_char_token1] = ACTIONS(2413),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2411),
    [anon_sym_DQUOTE] = ACTIONS(2411),
    [anon_sym_AT_DQUOTE] = ACTIONS(2413),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2413),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2413),
    [sym_bool] = ACTIONS(2411),
    [sym_unit] = ACTIONS(2413),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2411),
    [sym_op_identifier] = ACTIONS(2411),
    [anon_sym_PLUS] = ACTIONS(2411),
    [anon_sym_DASH] = ACTIONS(2411),
    [anon_sym_PLUS_DOT] = ACTIONS(2411),
    [anon_sym_DASH_DOT] = ACTIONS(2411),
    [anon_sym_PERCENT] = ACTIONS(2411),
    [anon_sym_AMP_AMP] = ACTIONS(2411),
    [anon_sym_TILDE] = ACTIONS(2413),
    [aux_sym_prefix_op_token1] = ACTIONS(2411),
    [aux_sym_infix_op_token1] = ACTIONS(2413),
    [aux_sym_infix_op_token2] = ACTIONS(2411),
    [anon_sym_PIPE_PIPE] = ACTIONS(2411),
    [anon_sym_BANG_EQ] = ACTIONS(2411),
    [anon_sym_COLON_EQ] = ACTIONS(2413),
    [anon_sym_DOLLAR] = ACTIONS(2411),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2411),
    [sym_int] = ACTIONS(2411),
    [sym_xint] = ACTIONS(2413),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2413),
    [sym__newline] = ACTIONS(2413),
  },
  [1223] = {
    [sym_block_comment] = STATE(1223),
    [sym_compiler_directive_decl] = STATE(1223),
    [sym_fsi_directive_decl] = STATE(1223),
    [sym_preproc_line] = STATE(1223),
    [aux_sym_type_argument_repeat1] = STATE(1223),
    [sym_identifier] = ACTIONS(2340),
    [anon_sym_EQ] = ACTIONS(2342),
    [anon_sym_COLON] = ACTIONS(2340),
    [anon_sym_return] = ACTIONS(2340),
    [anon_sym_do] = ACTIONS(2340),
    [anon_sym_let] = ACTIONS(2340),
    [anon_sym_let_BANG] = ACTIONS(2342),
    [anon_sym_LPAREN] = ACTIONS(2340),
    [anon_sym_COMMA] = ACTIONS(2342),
    [anon_sym_null] = ACTIONS(2340),
    [anon_sym_QMARK] = ACTIONS(2340),
    [anon_sym_COLON_QMARK] = ACTIONS(2340),
    [anon_sym_COLON_COLON] = ACTIONS(2342),
    [anon_sym_AMP] = ACTIONS(2340),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2342),
    [anon_sym_LBRACE] = ACTIONS(2340),
    [anon_sym_LT_AT] = ACTIONS(2340),
    [anon_sym_LT_AT_AT] = ACTIONS(2340),
    [anon_sym_DOT] = ACTIONS(2340),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2342),
    [anon_sym_new] = ACTIONS(2340),
    [anon_sym_return_BANG] = ACTIONS(2342),
    [anon_sym_yield] = ACTIONS(2340),
    [anon_sym_yield_BANG] = ACTIONS(2342),
    [anon_sym_lazy] = ACTIONS(2340),
    [anon_sym_assert] = ACTIONS(2340),
    [anon_sym_upcast] = ACTIONS(2340),
    [anon_sym_downcast] = ACTIONS(2340),
    [anon_sym_COLON_GT] = ACTIONS(2342),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2342),
    [anon_sym_for] = ACTIONS(2340),
    [anon_sym_while] = ACTIONS(2340),
    [anon_sym_if] = ACTIONS(2340),
    [anon_sym_fun] = ACTIONS(2340),
    [anon_sym_DASH_GT] = ACTIONS(2340),
    [anon_sym_try] = ACTIONS(2340),
    [anon_sym_match] = ACTIONS(2340),
    [anon_sym_match_BANG] = ACTIONS(2342),
    [anon_sym_function] = ACTIONS(2340),
    [anon_sym_LT_DASH] = ACTIONS(2340),
    [anon_sym_DOT_LBRACK] = ACTIONS(2342),
    [anon_sym_LT] = ACTIONS(2342),
    [anon_sym_use] = ACTIONS(2340),
    [anon_sym_use_BANG] = ACTIONS(2342),
    [anon_sym_do_BANG] = ACTIONS(2342),
    [anon_sym_DOT_DOT] = ACTIONS(2342),
    [anon_sym_begin] = ACTIONS(2340),
    [anon_sym_LPAREN2] = ACTIONS(2340),
    [anon_sym_STAR] = ACTIONS(2340),
    [anon_sym_LT2] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2342),
    [anon_sym_or] = ACTIONS(3405),
    [aux_sym_char_token1] = ACTIONS(2342),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2340),
    [anon_sym_DQUOTE] = ACTIONS(2340),
    [anon_sym_AT_DQUOTE] = ACTIONS(2342),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2342),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2342),
    [sym_bool] = ACTIONS(2340),
    [sym_unit] = ACTIONS(2342),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2340),
    [sym_op_identifier] = ACTIONS(2340),
    [anon_sym_PLUS] = ACTIONS(2340),
    [anon_sym_DASH] = ACTIONS(2340),
    [anon_sym_PLUS_DOT] = ACTIONS(2340),
    [anon_sym_DASH_DOT] = ACTIONS(2340),
    [anon_sym_PERCENT] = ACTIONS(2340),
    [anon_sym_AMP_AMP] = ACTIONS(2340),
    [anon_sym_TILDE] = ACTIONS(2342),
    [aux_sym_prefix_op_token1] = ACTIONS(2340),
    [aux_sym_infix_op_token1] = ACTIONS(2342),
    [aux_sym_infix_op_token2] = ACTIONS(2340),
    [anon_sym_PIPE_PIPE] = ACTIONS(2340),
    [anon_sym_BANG_EQ] = ACTIONS(2340),
    [anon_sym_COLON_EQ] = ACTIONS(2342),
    [anon_sym_DOLLAR] = ACTIONS(2340),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2340),
    [sym_int] = ACTIONS(2340),
    [sym_xint] = ACTIONS(2342),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2342),
    [sym__newline] = ACTIONS(2342),
  },
  [1224] = {
    [sym_block_comment] = STATE(1224),
    [sym_compiler_directive_decl] = STATE(1224),
    [sym_fsi_directive_decl] = STATE(1224),
    [sym_preproc_line] = STATE(1224),
    [aux_sym_long_identifier_repeat1] = STATE(1225),
    [sym_identifier] = ACTIONS(2312),
    [anon_sym_EQ] = ACTIONS(2314),
    [anon_sym_COLON] = ACTIONS(2312),
    [anon_sym_return] = ACTIONS(2312),
    [anon_sym_do] = ACTIONS(2312),
    [anon_sym_let] = ACTIONS(2312),
    [anon_sym_let_BANG] = ACTIONS(2314),
    [anon_sym_LPAREN] = ACTIONS(2312),
    [anon_sym_COMMA] = ACTIONS(2314),
    [anon_sym_null] = ACTIONS(2312),
    [anon_sym_QMARK] = ACTIONS(2312),
    [anon_sym_COLON_QMARK] = ACTIONS(2312),
    [anon_sym_COLON_COLON] = ACTIONS(2314),
    [anon_sym_AMP] = ACTIONS(2312),
    [anon_sym_LBRACK] = ACTIONS(2312),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2314),
    [anon_sym_LBRACE] = ACTIONS(2312),
    [anon_sym_LT_AT] = ACTIONS(2312),
    [anon_sym_LT_AT_AT] = ACTIONS(2312),
    [anon_sym_DOT] = ACTIONS(3408),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2314),
    [anon_sym_new] = ACTIONS(2312),
    [anon_sym_return_BANG] = ACTIONS(2314),
    [anon_sym_yield] = ACTIONS(2312),
    [anon_sym_yield_BANG] = ACTIONS(2314),
    [anon_sym_lazy] = ACTIONS(2312),
    [anon_sym_assert] = ACTIONS(2312),
    [anon_sym_upcast] = ACTIONS(2312),
    [anon_sym_downcast] = ACTIONS(2312),
    [anon_sym_COLON_GT] = ACTIONS(2314),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2314),
    [anon_sym_for] = ACTIONS(2312),
    [anon_sym_while] = ACTIONS(2312),
    [anon_sym_if] = ACTIONS(2312),
    [anon_sym_fun] = ACTIONS(2312),
    [anon_sym_DASH_GT] = ACTIONS(2312),
    [anon_sym_try] = ACTIONS(2312),
    [anon_sym_match] = ACTIONS(2312),
    [anon_sym_match_BANG] = ACTIONS(2314),
    [anon_sym_function] = ACTIONS(2312),
    [anon_sym_LT_DASH] = ACTIONS(2312),
    [anon_sym_DOT_LBRACK] = ACTIONS(2314),
    [anon_sym_LT] = ACTIONS(2314),
    [anon_sym_use] = ACTIONS(2312),
    [anon_sym_use_BANG] = ACTIONS(2314),
    [anon_sym_do_BANG] = ACTIONS(2314),
    [anon_sym_DOT_DOT] = ACTIONS(2314),
    [anon_sym_begin] = ACTIONS(2312),
    [anon_sym_LPAREN2] = ACTIONS(2312),
    [anon_sym_STAR] = ACTIONS(2312),
    [anon_sym_LT2] = ACTIONS(2312),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2314),
    [anon_sym_or] = ACTIONS(2312),
    [aux_sym_char_token1] = ACTIONS(2314),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2312),
    [anon_sym_DQUOTE] = ACTIONS(2312),
    [anon_sym_AT_DQUOTE] = ACTIONS(2314),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2314),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2314),
    [sym_bool] = ACTIONS(2312),
    [sym_unit] = ACTIONS(2314),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2312),
    [sym_op_identifier] = ACTIONS(2312),
    [anon_sym_PLUS] = ACTIONS(2312),
    [anon_sym_DASH] = ACTIONS(2312),
    [anon_sym_PLUS_DOT] = ACTIONS(2312),
    [anon_sym_DASH_DOT] = ACTIONS(2312),
    [anon_sym_PERCENT] = ACTIONS(2312),
    [anon_sym_AMP_AMP] = ACTIONS(2312),
    [anon_sym_TILDE] = ACTIONS(2314),
    [aux_sym_prefix_op_token1] = ACTIONS(2312),
    [aux_sym_infix_op_token1] = ACTIONS(2314),
    [aux_sym_infix_op_token2] = ACTIONS(2312),
    [anon_sym_PIPE_PIPE] = ACTIONS(2312),
    [anon_sym_BANG_EQ] = ACTIONS(2312),
    [anon_sym_COLON_EQ] = ACTIONS(2314),
    [anon_sym_DOLLAR] = ACTIONS(2312),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2312),
    [sym_int] = ACTIONS(2312),
    [sym_xint] = ACTIONS(2314),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2314),
    [sym__newline] = ACTIONS(2314),
  },
  [1225] = {
    [sym_block_comment] = STATE(1225),
    [sym_compiler_directive_decl] = STATE(1225),
    [sym_fsi_directive_decl] = STATE(1225),
    [sym_preproc_line] = STATE(1225),
    [aux_sym_long_identifier_repeat1] = STATE(1222),
    [sym_identifier] = ACTIONS(2418),
    [anon_sym_EQ] = ACTIONS(2420),
    [anon_sym_COLON] = ACTIONS(2418),
    [anon_sym_return] = ACTIONS(2418),
    [anon_sym_do] = ACTIONS(2418),
    [anon_sym_let] = ACTIONS(2418),
    [anon_sym_let_BANG] = ACTIONS(2420),
    [anon_sym_LPAREN] = ACTIONS(2418),
    [anon_sym_COMMA] = ACTIONS(2420),
    [anon_sym_null] = ACTIONS(2418),
    [anon_sym_QMARK] = ACTIONS(2418),
    [anon_sym_COLON_QMARK] = ACTIONS(2418),
    [anon_sym_COLON_COLON] = ACTIONS(2420),
    [anon_sym_AMP] = ACTIONS(2418),
    [anon_sym_LBRACK] = ACTIONS(2418),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2420),
    [anon_sym_LBRACE] = ACTIONS(2418),
    [anon_sym_LT_AT] = ACTIONS(2418),
    [anon_sym_LT_AT_AT] = ACTIONS(2418),
    [anon_sym_DOT] = ACTIONS(3408),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2420),
    [anon_sym_new] = ACTIONS(2418),
    [anon_sym_return_BANG] = ACTIONS(2420),
    [anon_sym_yield] = ACTIONS(2418),
    [anon_sym_yield_BANG] = ACTIONS(2420),
    [anon_sym_lazy] = ACTIONS(2418),
    [anon_sym_assert] = ACTIONS(2418),
    [anon_sym_upcast] = ACTIONS(2418),
    [anon_sym_downcast] = ACTIONS(2418),
    [anon_sym_COLON_GT] = ACTIONS(2420),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2420),
    [anon_sym_for] = ACTIONS(2418),
    [anon_sym_while] = ACTIONS(2418),
    [anon_sym_if] = ACTIONS(2418),
    [anon_sym_fun] = ACTIONS(2418),
    [anon_sym_DASH_GT] = ACTIONS(2418),
    [anon_sym_try] = ACTIONS(2418),
    [anon_sym_match] = ACTIONS(2418),
    [anon_sym_match_BANG] = ACTIONS(2420),
    [anon_sym_function] = ACTIONS(2418),
    [anon_sym_LT_DASH] = ACTIONS(2418),
    [anon_sym_DOT_LBRACK] = ACTIONS(2420),
    [anon_sym_LT] = ACTIONS(2420),
    [anon_sym_use] = ACTIONS(2418),
    [anon_sym_use_BANG] = ACTIONS(2420),
    [anon_sym_do_BANG] = ACTIONS(2420),
    [anon_sym_DOT_DOT] = ACTIONS(2420),
    [anon_sym_begin] = ACTIONS(2418),
    [anon_sym_LPAREN2] = ACTIONS(2418),
    [anon_sym_STAR] = ACTIONS(2418),
    [anon_sym_LT2] = ACTIONS(2418),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2420),
    [anon_sym_or] = ACTIONS(2418),
    [aux_sym_char_token1] = ACTIONS(2420),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2418),
    [anon_sym_DQUOTE] = ACTIONS(2418),
    [anon_sym_AT_DQUOTE] = ACTIONS(2420),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2420),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2420),
    [sym_bool] = ACTIONS(2418),
    [sym_unit] = ACTIONS(2420),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2418),
    [sym_op_identifier] = ACTIONS(2418),
    [anon_sym_PLUS] = ACTIONS(2418),
    [anon_sym_DASH] = ACTIONS(2418),
    [anon_sym_PLUS_DOT] = ACTIONS(2418),
    [anon_sym_DASH_DOT] = ACTIONS(2418),
    [anon_sym_PERCENT] = ACTIONS(2418),
    [anon_sym_AMP_AMP] = ACTIONS(2418),
    [anon_sym_TILDE] = ACTIONS(2420),
    [aux_sym_prefix_op_token1] = ACTIONS(2418),
    [aux_sym_infix_op_token1] = ACTIONS(2420),
    [aux_sym_infix_op_token2] = ACTIONS(2418),
    [anon_sym_PIPE_PIPE] = ACTIONS(2418),
    [anon_sym_BANG_EQ] = ACTIONS(2418),
    [anon_sym_COLON_EQ] = ACTIONS(2420),
    [anon_sym_DOLLAR] = ACTIONS(2418),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2418),
    [sym_int] = ACTIONS(2418),
    [sym_xint] = ACTIONS(2420),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2420),
    [sym__newline] = ACTIONS(2420),
  },
  [1226] = {
    [sym_block_comment] = STATE(1226),
    [sym_compiler_directive_decl] = STATE(1226),
    [sym_fsi_directive_decl] = STATE(1226),
    [sym_preproc_line] = STATE(1226),
    [sym_identifier] = ACTIONS(2627),
    [anon_sym_EQ] = ACTIONS(2629),
    [anon_sym_COLON] = ACTIONS(2627),
    [anon_sym_return] = ACTIONS(2627),
    [anon_sym_do] = ACTIONS(2627),
    [anon_sym_let] = ACTIONS(2627),
    [anon_sym_let_BANG] = ACTIONS(2629),
    [anon_sym_as] = ACTIONS(2627),
    [anon_sym_LPAREN] = ACTIONS(2627),
    [anon_sym_COMMA] = ACTIONS(2629),
    [anon_sym_null] = ACTIONS(2627),
    [anon_sym_QMARK] = ACTIONS(2627),
    [anon_sym_COLON_QMARK] = ACTIONS(2627),
    [anon_sym_COLON_COLON] = ACTIONS(2629),
    [anon_sym_AMP] = ACTIONS(2627),
    [anon_sym_LBRACK] = ACTIONS(2627),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2629),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_LT_AT] = ACTIONS(2627),
    [anon_sym_LT_AT_AT] = ACTIONS(2627),
    [anon_sym_DOT] = ACTIONS(2627),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2629),
    [anon_sym_new] = ACTIONS(2627),
    [anon_sym_with] = ACTIONS(2627),
    [anon_sym_return_BANG] = ACTIONS(2629),
    [anon_sym_yield] = ACTIONS(2627),
    [anon_sym_yield_BANG] = ACTIONS(2629),
    [anon_sym_lazy] = ACTIONS(2627),
    [anon_sym_assert] = ACTIONS(2627),
    [anon_sym_upcast] = ACTIONS(2627),
    [anon_sym_downcast] = ACTIONS(2627),
    [anon_sym_COLON_GT] = ACTIONS(2629),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2629),
    [anon_sym_for] = ACTIONS(2627),
    [anon_sym_while] = ACTIONS(2627),
    [anon_sym_if] = ACTIONS(2627),
    [anon_sym_fun] = ACTIONS(2627),
    [anon_sym_DASH_GT] = ACTIONS(2627),
    [anon_sym_try] = ACTIONS(2627),
    [anon_sym_match] = ACTIONS(2627),
    [anon_sym_match_BANG] = ACTIONS(2629),
    [anon_sym_function] = ACTIONS(2627),
    [anon_sym_LT_DASH] = ACTIONS(2627),
    [anon_sym_DOT_LBRACK] = ACTIONS(2629),
    [anon_sym_LT] = ACTIONS(2629),
    [anon_sym_use] = ACTIONS(2627),
    [anon_sym_use_BANG] = ACTIONS(2629),
    [anon_sym_do_BANG] = ACTIONS(2629),
    [anon_sym_begin] = ACTIONS(2627),
    [anon_sym_LPAREN2] = ACTIONS(2627),
    [anon_sym_STAR] = ACTIONS(2627),
    [anon_sym_LT2] = ACTIONS(2627),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2629),
    [anon_sym_or] = ACTIONS(2627),
    [aux_sym_char_token1] = ACTIONS(2629),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2627),
    [anon_sym_DQUOTE] = ACTIONS(2627),
    [anon_sym_AT_DQUOTE] = ACTIONS(2629),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2629),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2629),
    [sym_bool] = ACTIONS(2627),
    [sym_unit] = ACTIONS(2629),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2627),
    [sym_op_identifier] = ACTIONS(2627),
    [anon_sym_PLUS] = ACTIONS(2627),
    [anon_sym_DASH] = ACTIONS(2627),
    [anon_sym_PLUS_DOT] = ACTIONS(2627),
    [anon_sym_DASH_DOT] = ACTIONS(2627),
    [anon_sym_PERCENT] = ACTIONS(2627),
    [anon_sym_AMP_AMP] = ACTIONS(2627),
    [anon_sym_TILDE] = ACTIONS(2629),
    [aux_sym_prefix_op_token1] = ACTIONS(2627),
    [aux_sym_infix_op_token1] = ACTIONS(2629),
    [aux_sym_infix_op_token2] = ACTIONS(2627),
    [anon_sym_PIPE_PIPE] = ACTIONS(2627),
    [anon_sym_BANG_EQ] = ACTIONS(2627),
    [anon_sym_COLON_EQ] = ACTIONS(2629),
    [anon_sym_DOLLAR] = ACTIONS(2627),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2627),
    [sym_int] = ACTIONS(2627),
    [sym_xint] = ACTIONS(2629),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2629),
    [sym__newline] = ACTIONS(2629),
  },
  [1227] = {
    [sym__else_expression] = STATE(2455),
    [sym_elif_expression] = STATE(1523),
    [sym_block_comment] = STATE(1227),
    [sym_compiler_directive_decl] = STATE(1227),
    [sym_fsi_directive_decl] = STATE(1227),
    [sym_preproc_line] = STATE(1227),
    [aux_sym_if_expression_repeat1] = STATE(1206),
    [sym_identifier] = ACTIONS(2422),
    [anon_sym_EQ] = ACTIONS(2424),
    [anon_sym_COLON] = ACTIONS(2422),
    [anon_sym_return] = ACTIONS(2422),
    [anon_sym_do] = ACTIONS(2422),
    [anon_sym_let] = ACTIONS(2422),
    [anon_sym_let_BANG] = ACTIONS(2424),
    [anon_sym_LPAREN] = ACTIONS(2422),
    [anon_sym_COMMA] = ACTIONS(2424),
    [anon_sym_null] = ACTIONS(2422),
    [anon_sym_QMARK] = ACTIONS(2422),
    [anon_sym_COLON_QMARK] = ACTIONS(2422),
    [anon_sym_COLON_COLON] = ACTIONS(2424),
    [anon_sym_AMP] = ACTIONS(2422),
    [anon_sym_LBRACK] = ACTIONS(2422),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2424),
    [anon_sym_LBRACE] = ACTIONS(2422),
    [anon_sym_LT_AT] = ACTIONS(2422),
    [anon_sym_LT_AT_AT] = ACTIONS(2422),
    [anon_sym_DOT] = ACTIONS(2422),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2424),
    [anon_sym_new] = ACTIONS(2422),
    [anon_sym_return_BANG] = ACTIONS(2424),
    [anon_sym_yield] = ACTIONS(2422),
    [anon_sym_yield_BANG] = ACTIONS(2424),
    [anon_sym_lazy] = ACTIONS(2422),
    [anon_sym_assert] = ACTIONS(2422),
    [anon_sym_upcast] = ACTIONS(2422),
    [anon_sym_downcast] = ACTIONS(2422),
    [anon_sym_COLON_GT] = ACTIONS(2424),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2424),
    [anon_sym_for] = ACTIONS(2422),
    [anon_sym_while] = ACTIONS(2422),
    [anon_sym_else] = ACTIONS(3384),
    [anon_sym_elif] = ACTIONS(3386),
    [anon_sym_if] = ACTIONS(2422),
    [anon_sym_fun] = ACTIONS(2422),
    [anon_sym_try] = ACTIONS(2422),
    [anon_sym_match] = ACTIONS(2422),
    [anon_sym_match_BANG] = ACTIONS(2424),
    [anon_sym_function] = ACTIONS(2422),
    [anon_sym_LT_DASH] = ACTIONS(2422),
    [anon_sym_DOT_LBRACK] = ACTIONS(2424),
    [anon_sym_LT] = ACTIONS(2424),
    [anon_sym_use] = ACTIONS(2422),
    [anon_sym_use_BANG] = ACTIONS(2424),
    [anon_sym_do_BANG] = ACTIONS(2424),
    [anon_sym_begin] = ACTIONS(2422),
    [anon_sym_LPAREN2] = ACTIONS(2422),
    [anon_sym_or] = ACTIONS(2422),
    [aux_sym_char_token1] = ACTIONS(2424),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2422),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_AT_DQUOTE] = ACTIONS(2424),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2424),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2424),
    [sym_bool] = ACTIONS(2422),
    [sym_unit] = ACTIONS(2424),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2422),
    [sym_op_identifier] = ACTIONS(2422),
    [anon_sym_PLUS] = ACTIONS(2422),
    [anon_sym_DASH] = ACTIONS(2422),
    [anon_sym_PLUS_DOT] = ACTIONS(2422),
    [anon_sym_DASH_DOT] = ACTIONS(2422),
    [anon_sym_PERCENT] = ACTIONS(2422),
    [anon_sym_AMP_AMP] = ACTIONS(2422),
    [anon_sym_TILDE] = ACTIONS(2424),
    [aux_sym_prefix_op_token1] = ACTIONS(2422),
    [aux_sym_infix_op_token1] = ACTIONS(2424),
    [aux_sym_infix_op_token2] = ACTIONS(2422),
    [anon_sym_PIPE_PIPE] = ACTIONS(2422),
    [anon_sym_BANG_EQ] = ACTIONS(2422),
    [anon_sym_COLON_EQ] = ACTIONS(2424),
    [anon_sym_DOLLAR] = ACTIONS(2422),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2422),
    [sym_int] = ACTIONS(2422),
    [sym_xint] = ACTIONS(2424),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2424),
    [anon_sym_POUNDendif] = ACTIONS(2424),
    [sym__newline] = ACTIONS(2424),
  },
  [1228] = {
    [sym_block_comment] = STATE(1228),
    [sym_compiler_directive_decl] = STATE(1228),
    [sym_fsi_directive_decl] = STATE(1228),
    [sym_preproc_line] = STATE(1228),
    [aux_sym_long_identifier_repeat1] = STATE(1237),
    [sym_identifier] = ACTIONS(2312),
    [anon_sym_EQ] = ACTIONS(2314),
    [anon_sym_COLON] = ACTIONS(2312),
    [anon_sym_return] = ACTIONS(2312),
    [anon_sym_do] = ACTIONS(2312),
    [anon_sym_let] = ACTIONS(2312),
    [anon_sym_let_BANG] = ACTIONS(2314),
    [anon_sym_LPAREN] = ACTIONS(2312),
    [anon_sym_COMMA] = ACTIONS(2314),
    [anon_sym_null] = ACTIONS(2312),
    [anon_sym_QMARK] = ACTIONS(2312),
    [anon_sym_COLON_QMARK] = ACTIONS(2312),
    [anon_sym_COLON_COLON] = ACTIONS(2314),
    [anon_sym_AMP] = ACTIONS(2312),
    [anon_sym_LBRACK] = ACTIONS(2312),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2314),
    [anon_sym_LBRACE] = ACTIONS(2312),
    [anon_sym_LT_AT] = ACTIONS(2312),
    [anon_sym_LT_AT_AT] = ACTIONS(2312),
    [anon_sym_DOT] = ACTIONS(3410),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2314),
    [anon_sym_new] = ACTIONS(2312),
    [anon_sym_return_BANG] = ACTIONS(2314),
    [anon_sym_yield] = ACTIONS(2312),
    [anon_sym_yield_BANG] = ACTIONS(2314),
    [anon_sym_lazy] = ACTIONS(2312),
    [anon_sym_assert] = ACTIONS(2312),
    [anon_sym_upcast] = ACTIONS(2312),
    [anon_sym_downcast] = ACTIONS(2312),
    [anon_sym_COLON_GT] = ACTIONS(2314),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2314),
    [anon_sym_for] = ACTIONS(2312),
    [anon_sym_while] = ACTIONS(2312),
    [anon_sym_if] = ACTIONS(2312),
    [anon_sym_fun] = ACTIONS(2312),
    [anon_sym_DASH_GT] = ACTIONS(2312),
    [anon_sym_try] = ACTIONS(2312),
    [anon_sym_match] = ACTIONS(2312),
    [anon_sym_match_BANG] = ACTIONS(2314),
    [anon_sym_function] = ACTIONS(2312),
    [anon_sym_LT_DASH] = ACTIONS(2312),
    [anon_sym_DOT_LBRACK] = ACTIONS(2314),
    [anon_sym_LT] = ACTIONS(2314),
    [anon_sym_GT] = ACTIONS(2312),
    [anon_sym_use] = ACTIONS(2312),
    [anon_sym_use_BANG] = ACTIONS(2314),
    [anon_sym_do_BANG] = ACTIONS(2314),
    [anon_sym_begin] = ACTIONS(2312),
    [anon_sym_LPAREN2] = ACTIONS(2312),
    [anon_sym_STAR] = ACTIONS(2312),
    [anon_sym_LT2] = ACTIONS(2312),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2314),
    [anon_sym_or] = ACTIONS(2312),
    [aux_sym_char_token1] = ACTIONS(2314),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2312),
    [anon_sym_DQUOTE] = ACTIONS(2312),
    [anon_sym_AT_DQUOTE] = ACTIONS(2314),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2314),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2314),
    [sym_bool] = ACTIONS(2312),
    [sym_unit] = ACTIONS(2314),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2312),
    [sym_op_identifier] = ACTIONS(2312),
    [anon_sym_PLUS] = ACTIONS(2312),
    [anon_sym_DASH] = ACTIONS(2312),
    [anon_sym_PLUS_DOT] = ACTIONS(2312),
    [anon_sym_DASH_DOT] = ACTIONS(2312),
    [anon_sym_PERCENT] = ACTIONS(2312),
    [anon_sym_AMP_AMP] = ACTIONS(2312),
    [anon_sym_TILDE] = ACTIONS(2314),
    [aux_sym_prefix_op_token1] = ACTIONS(2312),
    [aux_sym_infix_op_token1] = ACTIONS(2314),
    [aux_sym_infix_op_token2] = ACTIONS(2312),
    [anon_sym_PIPE_PIPE] = ACTIONS(2312),
    [anon_sym_BANG_EQ] = ACTIONS(2312),
    [anon_sym_COLON_EQ] = ACTIONS(2314),
    [anon_sym_DOLLAR] = ACTIONS(2312),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2312),
    [sym_int] = ACTIONS(2312),
    [sym_xint] = ACTIONS(2314),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2314),
    [sym__newline] = ACTIONS(2314),
  },
  [1229] = {
    [sym_block_comment] = STATE(1229),
    [sym_compiler_directive_decl] = STATE(1229),
    [sym_fsi_directive_decl] = STATE(1229),
    [sym_preproc_line] = STATE(1229),
    [sym_identifier] = ACTIONS(2466),
    [anon_sym_EQ] = ACTIONS(2468),
    [anon_sym_COLON] = ACTIONS(2466),
    [anon_sym_return] = ACTIONS(2466),
    [anon_sym_do] = ACTIONS(2466),
    [anon_sym_let] = ACTIONS(2466),
    [anon_sym_let_BANG] = ACTIONS(2468),
    [anon_sym_as] = ACTIONS(2466),
    [anon_sym_LPAREN] = ACTIONS(2466),
    [anon_sym_COMMA] = ACTIONS(2468),
    [anon_sym_null] = ACTIONS(2466),
    [anon_sym_QMARK] = ACTIONS(2466),
    [anon_sym_COLON_QMARK] = ACTIONS(2466),
    [anon_sym_COLON_COLON] = ACTIONS(2468),
    [anon_sym_AMP] = ACTIONS(2466),
    [anon_sym_LBRACK] = ACTIONS(2466),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2468),
    [anon_sym_LBRACE] = ACTIONS(2466),
    [anon_sym_LT_AT] = ACTIONS(2466),
    [anon_sym_LT_AT_AT] = ACTIONS(2466),
    [anon_sym_DOT] = ACTIONS(2466),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2468),
    [anon_sym_new] = ACTIONS(2466),
    [anon_sym_with] = ACTIONS(2466),
    [anon_sym_return_BANG] = ACTIONS(2468),
    [anon_sym_yield] = ACTIONS(2466),
    [anon_sym_yield_BANG] = ACTIONS(2468),
    [anon_sym_lazy] = ACTIONS(2466),
    [anon_sym_assert] = ACTIONS(2466),
    [anon_sym_upcast] = ACTIONS(2466),
    [anon_sym_downcast] = ACTIONS(2466),
    [anon_sym_COLON_GT] = ACTIONS(2468),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2468),
    [anon_sym_for] = ACTIONS(2466),
    [anon_sym_while] = ACTIONS(2466),
    [anon_sym_if] = ACTIONS(2466),
    [anon_sym_fun] = ACTIONS(2466),
    [anon_sym_DASH_GT] = ACTIONS(2466),
    [anon_sym_try] = ACTIONS(2466),
    [anon_sym_match] = ACTIONS(2466),
    [anon_sym_match_BANG] = ACTIONS(2468),
    [anon_sym_function] = ACTIONS(2466),
    [anon_sym_LT_DASH] = ACTIONS(2466),
    [anon_sym_DOT_LBRACK] = ACTIONS(2468),
    [anon_sym_LT] = ACTIONS(2468),
    [anon_sym_use] = ACTIONS(2466),
    [anon_sym_use_BANG] = ACTIONS(2468),
    [anon_sym_do_BANG] = ACTIONS(2468),
    [anon_sym_begin] = ACTIONS(2466),
    [anon_sym_LPAREN2] = ACTIONS(2466),
    [anon_sym_STAR] = ACTIONS(2466),
    [anon_sym_LT2] = ACTIONS(2466),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2468),
    [anon_sym_or] = ACTIONS(2466),
    [aux_sym_char_token1] = ACTIONS(2468),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2466),
    [anon_sym_DQUOTE] = ACTIONS(2466),
    [anon_sym_AT_DQUOTE] = ACTIONS(2468),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2468),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2468),
    [sym_bool] = ACTIONS(2466),
    [sym_unit] = ACTIONS(2468),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2466),
    [sym_op_identifier] = ACTIONS(2466),
    [anon_sym_PLUS] = ACTIONS(2466),
    [anon_sym_DASH] = ACTIONS(2466),
    [anon_sym_PLUS_DOT] = ACTIONS(2466),
    [anon_sym_DASH_DOT] = ACTIONS(2466),
    [anon_sym_PERCENT] = ACTIONS(2466),
    [anon_sym_AMP_AMP] = ACTIONS(2466),
    [anon_sym_TILDE] = ACTIONS(2468),
    [aux_sym_prefix_op_token1] = ACTIONS(2466),
    [aux_sym_infix_op_token1] = ACTIONS(2468),
    [aux_sym_infix_op_token2] = ACTIONS(2466),
    [anon_sym_PIPE_PIPE] = ACTIONS(2466),
    [anon_sym_BANG_EQ] = ACTIONS(2466),
    [anon_sym_COLON_EQ] = ACTIONS(2468),
    [anon_sym_DOLLAR] = ACTIONS(2466),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2466),
    [sym_int] = ACTIONS(2466),
    [sym_xint] = ACTIONS(2468),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2468),
    [sym__newline] = ACTIONS(2468),
  },
  [1230] = {
    [sym_block_comment] = STATE(1230),
    [sym_compiler_directive_decl] = STATE(1230),
    [sym_fsi_directive_decl] = STATE(1230),
    [sym_preproc_line] = STATE(1230),
    [sym_identifier] = ACTIONS(2506),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_COLON] = ACTIONS(2506),
    [anon_sym_return] = ACTIONS(2506),
    [anon_sym_do] = ACTIONS(2506),
    [anon_sym_let] = ACTIONS(2506),
    [anon_sym_let_BANG] = ACTIONS(2508),
    [anon_sym_as] = ACTIONS(2506),
    [anon_sym_LPAREN] = ACTIONS(2506),
    [anon_sym_COMMA] = ACTIONS(2508),
    [anon_sym_null] = ACTIONS(2506),
    [anon_sym_QMARK] = ACTIONS(2506),
    [anon_sym_COLON_QMARK] = ACTIONS(2506),
    [anon_sym_COLON_COLON] = ACTIONS(2508),
    [anon_sym_AMP] = ACTIONS(2506),
    [anon_sym_LBRACK] = ACTIONS(2506),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2508),
    [anon_sym_LBRACE] = ACTIONS(2506),
    [anon_sym_LT_AT] = ACTIONS(2506),
    [anon_sym_LT_AT_AT] = ACTIONS(2506),
    [anon_sym_DOT] = ACTIONS(2506),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2508),
    [anon_sym_new] = ACTIONS(2506),
    [anon_sym_with] = ACTIONS(2506),
    [anon_sym_return_BANG] = ACTIONS(2508),
    [anon_sym_yield] = ACTIONS(2506),
    [anon_sym_yield_BANG] = ACTIONS(2508),
    [anon_sym_lazy] = ACTIONS(2506),
    [anon_sym_assert] = ACTIONS(2506),
    [anon_sym_upcast] = ACTIONS(2506),
    [anon_sym_downcast] = ACTIONS(2506),
    [anon_sym_COLON_GT] = ACTIONS(2508),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2508),
    [anon_sym_for] = ACTIONS(2506),
    [anon_sym_while] = ACTIONS(2506),
    [anon_sym_if] = ACTIONS(2506),
    [anon_sym_fun] = ACTIONS(2506),
    [anon_sym_DASH_GT] = ACTIONS(2506),
    [anon_sym_try] = ACTIONS(2506),
    [anon_sym_match] = ACTIONS(2506),
    [anon_sym_match_BANG] = ACTIONS(2508),
    [anon_sym_function] = ACTIONS(2506),
    [anon_sym_LT_DASH] = ACTIONS(2506),
    [anon_sym_DOT_LBRACK] = ACTIONS(2508),
    [anon_sym_LT] = ACTIONS(2508),
    [anon_sym_use] = ACTIONS(2506),
    [anon_sym_use_BANG] = ACTIONS(2508),
    [anon_sym_do_BANG] = ACTIONS(2508),
    [anon_sym_begin] = ACTIONS(2506),
    [anon_sym_LPAREN2] = ACTIONS(2506),
    [anon_sym_STAR] = ACTIONS(2506),
    [anon_sym_LT2] = ACTIONS(2506),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2508),
    [anon_sym_or] = ACTIONS(2506),
    [aux_sym_char_token1] = ACTIONS(2508),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2506),
    [anon_sym_DQUOTE] = ACTIONS(2506),
    [anon_sym_AT_DQUOTE] = ACTIONS(2508),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2508),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2508),
    [sym_bool] = ACTIONS(2506),
    [sym_unit] = ACTIONS(2508),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2506),
    [sym_op_identifier] = ACTIONS(2506),
    [anon_sym_PLUS] = ACTIONS(2506),
    [anon_sym_DASH] = ACTIONS(2506),
    [anon_sym_PLUS_DOT] = ACTIONS(2506),
    [anon_sym_DASH_DOT] = ACTIONS(2506),
    [anon_sym_PERCENT] = ACTIONS(2506),
    [anon_sym_AMP_AMP] = ACTIONS(2506),
    [anon_sym_TILDE] = ACTIONS(2508),
    [aux_sym_prefix_op_token1] = ACTIONS(2506),
    [aux_sym_infix_op_token1] = ACTIONS(2508),
    [aux_sym_infix_op_token2] = ACTIONS(2506),
    [anon_sym_PIPE_PIPE] = ACTIONS(2506),
    [anon_sym_BANG_EQ] = ACTIONS(2506),
    [anon_sym_COLON_EQ] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(2506),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2506),
    [sym_int] = ACTIONS(2506),
    [sym_xint] = ACTIONS(2508),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2508),
    [sym__newline] = ACTIONS(2508),
  },
  [1231] = {
    [sym_block_comment] = STATE(1231),
    [sym_compiler_directive_decl] = STATE(1231),
    [sym_fsi_directive_decl] = STATE(1231),
    [sym_preproc_line] = STATE(1231),
    [aux_sym_long_identifier_repeat1] = STATE(1231),
    [sym_identifier] = ACTIONS(2411),
    [anon_sym_EQ] = ACTIONS(2413),
    [anon_sym_COLON] = ACTIONS(2411),
    [anon_sym_return] = ACTIONS(2411),
    [anon_sym_do] = ACTIONS(2411),
    [anon_sym_let] = ACTIONS(2411),
    [anon_sym_let_BANG] = ACTIONS(2413),
    [anon_sym_LPAREN] = ACTIONS(2411),
    [anon_sym_COMMA] = ACTIONS(2413),
    [anon_sym_null] = ACTIONS(2411),
    [anon_sym_QMARK] = ACTIONS(2411),
    [anon_sym_COLON_QMARK] = ACTIONS(2411),
    [anon_sym_COLON_COLON] = ACTIONS(2413),
    [anon_sym_AMP] = ACTIONS(2411),
    [anon_sym_LBRACK] = ACTIONS(2411),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2413),
    [anon_sym_LBRACE] = ACTIONS(2411),
    [anon_sym_LT_AT] = ACTIONS(2411),
    [anon_sym_LT_AT_AT] = ACTIONS(2411),
    [anon_sym_DOT] = ACTIONS(3412),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2413),
    [anon_sym_new] = ACTIONS(2411),
    [anon_sym_return_BANG] = ACTIONS(2413),
    [anon_sym_yield] = ACTIONS(2411),
    [anon_sym_yield_BANG] = ACTIONS(2413),
    [anon_sym_lazy] = ACTIONS(2411),
    [anon_sym_assert] = ACTIONS(2411),
    [anon_sym_upcast] = ACTIONS(2411),
    [anon_sym_downcast] = ACTIONS(2411),
    [anon_sym_COLON_GT] = ACTIONS(2413),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2413),
    [anon_sym_for] = ACTIONS(2411),
    [anon_sym_while] = ACTIONS(2411),
    [anon_sym_if] = ACTIONS(2411),
    [anon_sym_fun] = ACTIONS(2411),
    [anon_sym_DASH_GT] = ACTIONS(2411),
    [anon_sym_try] = ACTIONS(2411),
    [anon_sym_match] = ACTIONS(2411),
    [anon_sym_match_BANG] = ACTIONS(2413),
    [anon_sym_function] = ACTIONS(2411),
    [anon_sym_LT_DASH] = ACTIONS(2411),
    [anon_sym_DOT_LBRACK] = ACTIONS(2413),
    [anon_sym_LT] = ACTIONS(2413),
    [anon_sym_GT] = ACTIONS(2411),
    [anon_sym_use] = ACTIONS(2411),
    [anon_sym_use_BANG] = ACTIONS(2413),
    [anon_sym_do_BANG] = ACTIONS(2413),
    [anon_sym_begin] = ACTIONS(2411),
    [anon_sym_LPAREN2] = ACTIONS(2411),
    [anon_sym_STAR] = ACTIONS(2411),
    [anon_sym_LT2] = ACTIONS(2411),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2413),
    [anon_sym_or] = ACTIONS(2411),
    [aux_sym_char_token1] = ACTIONS(2413),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2411),
    [anon_sym_DQUOTE] = ACTIONS(2411),
    [anon_sym_AT_DQUOTE] = ACTIONS(2413),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2413),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2413),
    [sym_bool] = ACTIONS(2411),
    [sym_unit] = ACTIONS(2413),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2411),
    [sym_op_identifier] = ACTIONS(2411),
    [anon_sym_PLUS] = ACTIONS(2411),
    [anon_sym_DASH] = ACTIONS(2411),
    [anon_sym_PLUS_DOT] = ACTIONS(2411),
    [anon_sym_DASH_DOT] = ACTIONS(2411),
    [anon_sym_PERCENT] = ACTIONS(2411),
    [anon_sym_AMP_AMP] = ACTIONS(2411),
    [anon_sym_TILDE] = ACTIONS(2413),
    [aux_sym_prefix_op_token1] = ACTIONS(2411),
    [aux_sym_infix_op_token1] = ACTIONS(2413),
    [aux_sym_infix_op_token2] = ACTIONS(2411),
    [anon_sym_PIPE_PIPE] = ACTIONS(2411),
    [anon_sym_BANG_EQ] = ACTIONS(2411),
    [anon_sym_COLON_EQ] = ACTIONS(2413),
    [anon_sym_DOLLAR] = ACTIONS(2411),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2411),
    [sym_int] = ACTIONS(2411),
    [sym_xint] = ACTIONS(2413),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2413),
    [sym__newline] = ACTIONS(2413),
  },
  [1232] = {
    [sym_block_comment] = STATE(1232),
    [sym_compiler_directive_decl] = STATE(1232),
    [sym_fsi_directive_decl] = STATE(1232),
    [sym_preproc_line] = STATE(1232),
    [sym_identifier] = ACTIONS(2470),
    [anon_sym_EQ] = ACTIONS(2472),
    [anon_sym_COLON] = ACTIONS(2470),
    [anon_sym_return] = ACTIONS(2470),
    [anon_sym_do] = ACTIONS(2470),
    [anon_sym_let] = ACTIONS(2470),
    [anon_sym_let_BANG] = ACTIONS(2472),
    [anon_sym_as] = ACTIONS(2470),
    [anon_sym_LPAREN] = ACTIONS(2470),
    [anon_sym_COMMA] = ACTIONS(2472),
    [anon_sym_null] = ACTIONS(2470),
    [anon_sym_QMARK] = ACTIONS(2470),
    [anon_sym_COLON_QMARK] = ACTIONS(2470),
    [anon_sym_COLON_COLON] = ACTIONS(2472),
    [anon_sym_AMP] = ACTIONS(2470),
    [anon_sym_LBRACK] = ACTIONS(2470),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2472),
    [anon_sym_LBRACE] = ACTIONS(2470),
    [anon_sym_LT_AT] = ACTIONS(2470),
    [anon_sym_LT_AT_AT] = ACTIONS(2470),
    [anon_sym_DOT] = ACTIONS(2470),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2472),
    [anon_sym_new] = ACTIONS(2470),
    [anon_sym_with] = ACTIONS(2470),
    [anon_sym_return_BANG] = ACTIONS(2472),
    [anon_sym_yield] = ACTIONS(2470),
    [anon_sym_yield_BANG] = ACTIONS(2472),
    [anon_sym_lazy] = ACTIONS(2470),
    [anon_sym_assert] = ACTIONS(2470),
    [anon_sym_upcast] = ACTIONS(2470),
    [anon_sym_downcast] = ACTIONS(2470),
    [anon_sym_COLON_GT] = ACTIONS(2472),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2472),
    [anon_sym_for] = ACTIONS(2470),
    [anon_sym_while] = ACTIONS(2470),
    [anon_sym_if] = ACTIONS(2470),
    [anon_sym_fun] = ACTIONS(2470),
    [anon_sym_DASH_GT] = ACTIONS(2470),
    [anon_sym_try] = ACTIONS(2470),
    [anon_sym_match] = ACTIONS(2470),
    [anon_sym_match_BANG] = ACTIONS(2472),
    [anon_sym_function] = ACTIONS(2470),
    [anon_sym_LT_DASH] = ACTIONS(2470),
    [anon_sym_DOT_LBRACK] = ACTIONS(2472),
    [anon_sym_LT] = ACTIONS(2472),
    [anon_sym_use] = ACTIONS(2470),
    [anon_sym_use_BANG] = ACTIONS(2472),
    [anon_sym_do_BANG] = ACTIONS(2472),
    [anon_sym_begin] = ACTIONS(2470),
    [anon_sym_LPAREN2] = ACTIONS(2470),
    [anon_sym_STAR] = ACTIONS(2470),
    [anon_sym_LT2] = ACTIONS(2470),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2472),
    [anon_sym_or] = ACTIONS(2470),
    [aux_sym_char_token1] = ACTIONS(2472),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2470),
    [anon_sym_DQUOTE] = ACTIONS(2470),
    [anon_sym_AT_DQUOTE] = ACTIONS(2472),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2472),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2472),
    [sym_bool] = ACTIONS(2470),
    [sym_unit] = ACTIONS(2472),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2470),
    [sym_op_identifier] = ACTIONS(2470),
    [anon_sym_PLUS] = ACTIONS(2470),
    [anon_sym_DASH] = ACTIONS(2470),
    [anon_sym_PLUS_DOT] = ACTIONS(2470),
    [anon_sym_DASH_DOT] = ACTIONS(2470),
    [anon_sym_PERCENT] = ACTIONS(2470),
    [anon_sym_AMP_AMP] = ACTIONS(2470),
    [anon_sym_TILDE] = ACTIONS(2472),
    [aux_sym_prefix_op_token1] = ACTIONS(2470),
    [aux_sym_infix_op_token1] = ACTIONS(2472),
    [aux_sym_infix_op_token2] = ACTIONS(2470),
    [anon_sym_PIPE_PIPE] = ACTIONS(2470),
    [anon_sym_BANG_EQ] = ACTIONS(2470),
    [anon_sym_COLON_EQ] = ACTIONS(2472),
    [anon_sym_DOLLAR] = ACTIONS(2470),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2470),
    [sym_int] = ACTIONS(2470),
    [sym_xint] = ACTIONS(2472),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2472),
    [sym__newline] = ACTIONS(2472),
  },
  [1233] = {
    [sym_block_comment] = STATE(1233),
    [sym_compiler_directive_decl] = STATE(1233),
    [sym_fsi_directive_decl] = STATE(1233),
    [sym_preproc_line] = STATE(1233),
    [aux_sym_compound_type_repeat1] = STATE(1214),
    [sym_identifier] = ACTIONS(2407),
    [anon_sym_EQ] = ACTIONS(2409),
    [anon_sym_COLON] = ACTIONS(2407),
    [anon_sym_return] = ACTIONS(2407),
    [anon_sym_do] = ACTIONS(2407),
    [anon_sym_let] = ACTIONS(2407),
    [anon_sym_let_BANG] = ACTIONS(2409),
    [anon_sym_LPAREN] = ACTIONS(2407),
    [anon_sym_COMMA] = ACTIONS(2409),
    [anon_sym_null] = ACTIONS(2407),
    [anon_sym_QMARK] = ACTIONS(2407),
    [anon_sym_COLON_QMARK] = ACTIONS(2407),
    [anon_sym_COLON_COLON] = ACTIONS(2409),
    [anon_sym_AMP] = ACTIONS(2407),
    [anon_sym_LBRACK] = ACTIONS(2407),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2409),
    [anon_sym_LBRACE] = ACTIONS(2407),
    [anon_sym_LT_AT] = ACTIONS(2407),
    [anon_sym_LT_AT_AT] = ACTIONS(2407),
    [anon_sym_DOT] = ACTIONS(2407),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2409),
    [anon_sym_new] = ACTIONS(2407),
    [anon_sym_return_BANG] = ACTIONS(2409),
    [anon_sym_yield] = ACTIONS(2407),
    [anon_sym_yield_BANG] = ACTIONS(2409),
    [anon_sym_lazy] = ACTIONS(2407),
    [anon_sym_assert] = ACTIONS(2407),
    [anon_sym_upcast] = ACTIONS(2407),
    [anon_sym_downcast] = ACTIONS(2407),
    [anon_sym_COLON_GT] = ACTIONS(2409),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2409),
    [anon_sym_for] = ACTIONS(2407),
    [anon_sym_while] = ACTIONS(2407),
    [anon_sym_if] = ACTIONS(2407),
    [anon_sym_fun] = ACTIONS(2407),
    [anon_sym_DASH_GT] = ACTIONS(2407),
    [anon_sym_try] = ACTIONS(2407),
    [anon_sym_match] = ACTIONS(2407),
    [anon_sym_match_BANG] = ACTIONS(2409),
    [anon_sym_function] = ACTIONS(2407),
    [anon_sym_LT_DASH] = ACTIONS(2407),
    [anon_sym_DOT_LBRACK] = ACTIONS(2409),
    [anon_sym_LT] = ACTIONS(2409),
    [anon_sym_use] = ACTIONS(2407),
    [anon_sym_use_BANG] = ACTIONS(2409),
    [anon_sym_do_BANG] = ACTIONS(2409),
    [anon_sym_DOT_DOT] = ACTIONS(2409),
    [anon_sym_begin] = ACTIONS(2407),
    [anon_sym_LPAREN2] = ACTIONS(2407),
    [anon_sym_STAR] = ACTIONS(3256),
    [anon_sym_LT2] = ACTIONS(2407),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2409),
    [anon_sym_or] = ACTIONS(2407),
    [aux_sym_char_token1] = ACTIONS(2409),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2407),
    [anon_sym_DQUOTE] = ACTIONS(2407),
    [anon_sym_AT_DQUOTE] = ACTIONS(2409),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2409),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2409),
    [sym_bool] = ACTIONS(2407),
    [sym_unit] = ACTIONS(2409),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2407),
    [sym_op_identifier] = ACTIONS(2407),
    [anon_sym_PLUS] = ACTIONS(2407),
    [anon_sym_DASH] = ACTIONS(2407),
    [anon_sym_PLUS_DOT] = ACTIONS(2407),
    [anon_sym_DASH_DOT] = ACTIONS(2407),
    [anon_sym_PERCENT] = ACTIONS(2407),
    [anon_sym_AMP_AMP] = ACTIONS(2407),
    [anon_sym_TILDE] = ACTIONS(2409),
    [aux_sym_prefix_op_token1] = ACTIONS(2407),
    [aux_sym_infix_op_token1] = ACTIONS(2409),
    [aux_sym_infix_op_token2] = ACTIONS(2407),
    [anon_sym_PIPE_PIPE] = ACTIONS(2407),
    [anon_sym_BANG_EQ] = ACTIONS(2407),
    [anon_sym_COLON_EQ] = ACTIONS(2409),
    [anon_sym_DOLLAR] = ACTIONS(2407),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2407),
    [sym_int] = ACTIONS(2407),
    [sym_xint] = ACTIONS(2409),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2409),
    [sym__newline] = ACTIONS(2409),
  },
  [1234] = {
    [sym_block_comment] = STATE(1234),
    [sym_compiler_directive_decl] = STATE(1234),
    [sym_fsi_directive_decl] = STATE(1234),
    [sym_preproc_line] = STATE(1234),
    [sym_identifier] = ACTIONS(2514),
    [anon_sym_EQ] = ACTIONS(2516),
    [anon_sym_COLON] = ACTIONS(2514),
    [anon_sym_return] = ACTIONS(2514),
    [anon_sym_do] = ACTIONS(2514),
    [anon_sym_let] = ACTIONS(2514),
    [anon_sym_let_BANG] = ACTIONS(2516),
    [anon_sym_as] = ACTIONS(2514),
    [anon_sym_LPAREN] = ACTIONS(2514),
    [anon_sym_COMMA] = ACTIONS(2516),
    [anon_sym_null] = ACTIONS(2514),
    [anon_sym_QMARK] = ACTIONS(2514),
    [anon_sym_COLON_QMARK] = ACTIONS(2514),
    [anon_sym_COLON_COLON] = ACTIONS(2516),
    [anon_sym_AMP] = ACTIONS(2514),
    [anon_sym_LBRACK] = ACTIONS(2514),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2516),
    [anon_sym_LBRACE] = ACTIONS(2514),
    [anon_sym_LT_AT] = ACTIONS(2514),
    [anon_sym_LT_AT_AT] = ACTIONS(2514),
    [anon_sym_DOT] = ACTIONS(2514),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2516),
    [anon_sym_new] = ACTIONS(2514),
    [anon_sym_with] = ACTIONS(2514),
    [anon_sym_return_BANG] = ACTIONS(2516),
    [anon_sym_yield] = ACTIONS(2514),
    [anon_sym_yield_BANG] = ACTIONS(2516),
    [anon_sym_lazy] = ACTIONS(2514),
    [anon_sym_assert] = ACTIONS(2514),
    [anon_sym_upcast] = ACTIONS(2514),
    [anon_sym_downcast] = ACTIONS(2514),
    [anon_sym_COLON_GT] = ACTIONS(2516),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2516),
    [anon_sym_for] = ACTIONS(2514),
    [anon_sym_while] = ACTIONS(2514),
    [anon_sym_if] = ACTIONS(2514),
    [anon_sym_fun] = ACTIONS(2514),
    [anon_sym_DASH_GT] = ACTIONS(2514),
    [anon_sym_try] = ACTIONS(2514),
    [anon_sym_match] = ACTIONS(2514),
    [anon_sym_match_BANG] = ACTIONS(2516),
    [anon_sym_function] = ACTIONS(2514),
    [anon_sym_LT_DASH] = ACTIONS(2514),
    [anon_sym_DOT_LBRACK] = ACTIONS(2516),
    [anon_sym_LT] = ACTIONS(2516),
    [anon_sym_use] = ACTIONS(2514),
    [anon_sym_use_BANG] = ACTIONS(2516),
    [anon_sym_do_BANG] = ACTIONS(2516),
    [anon_sym_begin] = ACTIONS(2514),
    [anon_sym_LPAREN2] = ACTIONS(2514),
    [anon_sym_STAR] = ACTIONS(2514),
    [anon_sym_LT2] = ACTIONS(2514),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2516),
    [anon_sym_or] = ACTIONS(2514),
    [aux_sym_char_token1] = ACTIONS(2516),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2514),
    [anon_sym_DQUOTE] = ACTIONS(2514),
    [anon_sym_AT_DQUOTE] = ACTIONS(2516),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2516),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2516),
    [sym_bool] = ACTIONS(2514),
    [sym_unit] = ACTIONS(2516),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2514),
    [sym_op_identifier] = ACTIONS(2514),
    [anon_sym_PLUS] = ACTIONS(2514),
    [anon_sym_DASH] = ACTIONS(2514),
    [anon_sym_PLUS_DOT] = ACTIONS(2514),
    [anon_sym_DASH_DOT] = ACTIONS(2514),
    [anon_sym_PERCENT] = ACTIONS(2514),
    [anon_sym_AMP_AMP] = ACTIONS(2514),
    [anon_sym_TILDE] = ACTIONS(2516),
    [aux_sym_prefix_op_token1] = ACTIONS(2514),
    [aux_sym_infix_op_token1] = ACTIONS(2516),
    [aux_sym_infix_op_token2] = ACTIONS(2514),
    [anon_sym_PIPE_PIPE] = ACTIONS(2514),
    [anon_sym_BANG_EQ] = ACTIONS(2514),
    [anon_sym_COLON_EQ] = ACTIONS(2516),
    [anon_sym_DOLLAR] = ACTIONS(2514),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2514),
    [sym_int] = ACTIONS(2514),
    [sym_xint] = ACTIONS(2516),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2516),
    [sym__newline] = ACTIONS(2516),
  },
  [1235] = {
    [sym_block_comment] = STATE(1235),
    [sym_compiler_directive_decl] = STATE(1235),
    [sym_fsi_directive_decl] = STATE(1235),
    [sym_preproc_line] = STATE(1235),
    [aux_sym_compound_type_repeat1] = STATE(1219),
    [sym_identifier] = ACTIONS(2407),
    [anon_sym_EQ] = ACTIONS(2409),
    [anon_sym_COLON] = ACTIONS(2407),
    [anon_sym_return] = ACTIONS(2407),
    [anon_sym_do] = ACTIONS(2407),
    [anon_sym_let] = ACTIONS(2407),
    [anon_sym_let_BANG] = ACTIONS(2409),
    [anon_sym_LPAREN] = ACTIONS(2407),
    [anon_sym_COMMA] = ACTIONS(2409),
    [anon_sym_null] = ACTIONS(2407),
    [anon_sym_QMARK] = ACTIONS(2407),
    [anon_sym_COLON_QMARK] = ACTIONS(2407),
    [anon_sym_COLON_COLON] = ACTIONS(2409),
    [anon_sym_AMP] = ACTIONS(2407),
    [anon_sym_LBRACK] = ACTIONS(2407),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2409),
    [anon_sym_LBRACE] = ACTIONS(2407),
    [anon_sym_LT_AT] = ACTIONS(2407),
    [anon_sym_LT_AT_AT] = ACTIONS(2407),
    [anon_sym_AT_AT_GT] = ACTIONS(2407),
    [anon_sym_DOT] = ACTIONS(2407),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2409),
    [anon_sym_new] = ACTIONS(2407),
    [anon_sym_return_BANG] = ACTIONS(2409),
    [anon_sym_yield] = ACTIONS(2407),
    [anon_sym_yield_BANG] = ACTIONS(2409),
    [anon_sym_lazy] = ACTIONS(2407),
    [anon_sym_assert] = ACTIONS(2407),
    [anon_sym_upcast] = ACTIONS(2407),
    [anon_sym_downcast] = ACTIONS(2407),
    [anon_sym_COLON_GT] = ACTIONS(2409),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2409),
    [anon_sym_for] = ACTIONS(2407),
    [anon_sym_while] = ACTIONS(2407),
    [anon_sym_if] = ACTIONS(2407),
    [anon_sym_fun] = ACTIONS(2407),
    [anon_sym_DASH_GT] = ACTIONS(2407),
    [anon_sym_try] = ACTIONS(2407),
    [anon_sym_match] = ACTIONS(2407),
    [anon_sym_match_BANG] = ACTIONS(2409),
    [anon_sym_function] = ACTIONS(2407),
    [anon_sym_LT_DASH] = ACTIONS(2407),
    [anon_sym_DOT_LBRACK] = ACTIONS(2409),
    [anon_sym_LT] = ACTIONS(2409),
    [anon_sym_use] = ACTIONS(2407),
    [anon_sym_use_BANG] = ACTIONS(2409),
    [anon_sym_do_BANG] = ACTIONS(2409),
    [anon_sym_begin] = ACTIONS(2407),
    [anon_sym_LPAREN2] = ACTIONS(2407),
    [anon_sym_STAR] = ACTIONS(3226),
    [anon_sym_LT2] = ACTIONS(2407),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2409),
    [anon_sym_or] = ACTIONS(2407),
    [aux_sym_char_token1] = ACTIONS(2409),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2407),
    [anon_sym_DQUOTE] = ACTIONS(2407),
    [anon_sym_AT_DQUOTE] = ACTIONS(2409),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2409),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2409),
    [sym_bool] = ACTIONS(2407),
    [sym_unit] = ACTIONS(2409),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2407),
    [sym_op_identifier] = ACTIONS(2407),
    [anon_sym_PLUS] = ACTIONS(2407),
    [anon_sym_DASH] = ACTIONS(2407),
    [anon_sym_PLUS_DOT] = ACTIONS(2407),
    [anon_sym_DASH_DOT] = ACTIONS(2407),
    [anon_sym_PERCENT] = ACTIONS(2407),
    [anon_sym_AMP_AMP] = ACTIONS(2407),
    [anon_sym_TILDE] = ACTIONS(2409),
    [aux_sym_prefix_op_token1] = ACTIONS(2407),
    [aux_sym_infix_op_token1] = ACTIONS(2409),
    [aux_sym_infix_op_token2] = ACTIONS(2407),
    [anon_sym_PIPE_PIPE] = ACTIONS(2407),
    [anon_sym_BANG_EQ] = ACTIONS(2407),
    [anon_sym_COLON_EQ] = ACTIONS(2409),
    [anon_sym_DOLLAR] = ACTIONS(2407),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2407),
    [sym_int] = ACTIONS(2407),
    [sym_xint] = ACTIONS(2409),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2409),
    [sym__newline] = ACTIONS(2409),
  },
  [1236] = {
    [sym_block_comment] = STATE(1236),
    [sym_compiler_directive_decl] = STATE(1236),
    [sym_fsi_directive_decl] = STATE(1236),
    [sym_preproc_line] = STATE(1236),
    [sym_identifier] = ACTIONS(2563),
    [anon_sym_EQ] = ACTIONS(2565),
    [anon_sym_COLON] = ACTIONS(2563),
    [anon_sym_return] = ACTIONS(2563),
    [anon_sym_do] = ACTIONS(2563),
    [anon_sym_let] = ACTIONS(2563),
    [anon_sym_let_BANG] = ACTIONS(2565),
    [anon_sym_LPAREN] = ACTIONS(2563),
    [anon_sym_COMMA] = ACTIONS(2565),
    [anon_sym_null] = ACTIONS(2563),
    [anon_sym_QMARK] = ACTIONS(2563),
    [anon_sym_COLON_QMARK] = ACTIONS(2563),
    [anon_sym_COLON_COLON] = ACTIONS(2565),
    [anon_sym_AMP] = ACTIONS(2563),
    [anon_sym_LBRACK] = ACTIONS(2563),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2565),
    [anon_sym_LBRACE] = ACTIONS(2563),
    [anon_sym_LT_AT] = ACTIONS(2563),
    [anon_sym_LT_AT_AT] = ACTIONS(2563),
    [anon_sym_DOT] = ACTIONS(2563),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2565),
    [anon_sym_new] = ACTIONS(2563),
    [anon_sym_return_BANG] = ACTIONS(2565),
    [anon_sym_yield] = ACTIONS(2563),
    [anon_sym_yield_BANG] = ACTIONS(2565),
    [anon_sym_lazy] = ACTIONS(2563),
    [anon_sym_assert] = ACTIONS(2563),
    [anon_sym_upcast] = ACTIONS(2563),
    [anon_sym_downcast] = ACTIONS(2563),
    [anon_sym_COLON_GT] = ACTIONS(2565),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2565),
    [anon_sym_for] = ACTIONS(2563),
    [anon_sym_while] = ACTIONS(2563),
    [anon_sym_if] = ACTIONS(2563),
    [anon_sym_fun] = ACTIONS(2563),
    [anon_sym_DASH_GT] = ACTIONS(2563),
    [anon_sym_try] = ACTIONS(2563),
    [anon_sym_match] = ACTIONS(2563),
    [anon_sym_match_BANG] = ACTIONS(2565),
    [anon_sym_function] = ACTIONS(2563),
    [anon_sym_LT_DASH] = ACTIONS(2563),
    [anon_sym_DOT_LBRACK] = ACTIONS(2565),
    [anon_sym_LT] = ACTIONS(2565),
    [anon_sym_use] = ACTIONS(2563),
    [anon_sym_use_BANG] = ACTIONS(2565),
    [anon_sym_do_BANG] = ACTIONS(2565),
    [anon_sym_begin] = ACTIONS(2563),
    [anon_sym_LPAREN2] = ACTIONS(2563),
    [anon_sym_STAR] = ACTIONS(2563),
    [anon_sym_LT2] = ACTIONS(2563),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2565),
    [anon_sym_or] = ACTIONS(2563),
    [aux_sym_char_token1] = ACTIONS(2565),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2563),
    [anon_sym_DQUOTE] = ACTIONS(2563),
    [anon_sym_AT_DQUOTE] = ACTIONS(2565),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2565),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2565),
    [sym_bool] = ACTIONS(2563),
    [sym_unit] = ACTIONS(2565),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2563),
    [sym_op_identifier] = ACTIONS(2563),
    [anon_sym_PLUS] = ACTIONS(2563),
    [anon_sym_DASH] = ACTIONS(2563),
    [anon_sym_PLUS_DOT] = ACTIONS(2563),
    [anon_sym_DASH_DOT] = ACTIONS(2563),
    [anon_sym_PERCENT] = ACTIONS(2563),
    [anon_sym_AMP_AMP] = ACTIONS(2563),
    [anon_sym_TILDE] = ACTIONS(2565),
    [aux_sym_prefix_op_token1] = ACTIONS(2563),
    [aux_sym_infix_op_token1] = ACTIONS(2565),
    [aux_sym_infix_op_token2] = ACTIONS(2563),
    [anon_sym_PIPE_PIPE] = ACTIONS(2563),
    [anon_sym_BANG_EQ] = ACTIONS(2563),
    [anon_sym_COLON_EQ] = ACTIONS(2565),
    [anon_sym_DOLLAR] = ACTIONS(2563),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2563),
    [sym_int] = ACTIONS(2563),
    [sym_xint] = ACTIONS(2565),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2565),
    [anon_sym_POUNDendif] = ACTIONS(2565),
    [anon_sym_POUNDelse] = ACTIONS(2565),
    [sym__newline] = ACTIONS(2565),
  },
  [1237] = {
    [sym_block_comment] = STATE(1237),
    [sym_compiler_directive_decl] = STATE(1237),
    [sym_fsi_directive_decl] = STATE(1237),
    [sym_preproc_line] = STATE(1237),
    [aux_sym_long_identifier_repeat1] = STATE(1231),
    [sym_identifier] = ACTIONS(2418),
    [anon_sym_EQ] = ACTIONS(2420),
    [anon_sym_COLON] = ACTIONS(2418),
    [anon_sym_return] = ACTIONS(2418),
    [anon_sym_do] = ACTIONS(2418),
    [anon_sym_let] = ACTIONS(2418),
    [anon_sym_let_BANG] = ACTIONS(2420),
    [anon_sym_LPAREN] = ACTIONS(2418),
    [anon_sym_COMMA] = ACTIONS(2420),
    [anon_sym_null] = ACTIONS(2418),
    [anon_sym_QMARK] = ACTIONS(2418),
    [anon_sym_COLON_QMARK] = ACTIONS(2418),
    [anon_sym_COLON_COLON] = ACTIONS(2420),
    [anon_sym_AMP] = ACTIONS(2418),
    [anon_sym_LBRACK] = ACTIONS(2418),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2420),
    [anon_sym_LBRACE] = ACTIONS(2418),
    [anon_sym_LT_AT] = ACTIONS(2418),
    [anon_sym_LT_AT_AT] = ACTIONS(2418),
    [anon_sym_DOT] = ACTIONS(3410),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2420),
    [anon_sym_new] = ACTIONS(2418),
    [anon_sym_return_BANG] = ACTIONS(2420),
    [anon_sym_yield] = ACTIONS(2418),
    [anon_sym_yield_BANG] = ACTIONS(2420),
    [anon_sym_lazy] = ACTIONS(2418),
    [anon_sym_assert] = ACTIONS(2418),
    [anon_sym_upcast] = ACTIONS(2418),
    [anon_sym_downcast] = ACTIONS(2418),
    [anon_sym_COLON_GT] = ACTIONS(2420),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2420),
    [anon_sym_for] = ACTIONS(2418),
    [anon_sym_while] = ACTIONS(2418),
    [anon_sym_if] = ACTIONS(2418),
    [anon_sym_fun] = ACTIONS(2418),
    [anon_sym_DASH_GT] = ACTIONS(2418),
    [anon_sym_try] = ACTIONS(2418),
    [anon_sym_match] = ACTIONS(2418),
    [anon_sym_match_BANG] = ACTIONS(2420),
    [anon_sym_function] = ACTIONS(2418),
    [anon_sym_LT_DASH] = ACTIONS(2418),
    [anon_sym_DOT_LBRACK] = ACTIONS(2420),
    [anon_sym_LT] = ACTIONS(2420),
    [anon_sym_GT] = ACTIONS(2418),
    [anon_sym_use] = ACTIONS(2418),
    [anon_sym_use_BANG] = ACTIONS(2420),
    [anon_sym_do_BANG] = ACTIONS(2420),
    [anon_sym_begin] = ACTIONS(2418),
    [anon_sym_LPAREN2] = ACTIONS(2418),
    [anon_sym_STAR] = ACTIONS(2418),
    [anon_sym_LT2] = ACTIONS(2418),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2420),
    [anon_sym_or] = ACTIONS(2418),
    [aux_sym_char_token1] = ACTIONS(2420),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2418),
    [anon_sym_DQUOTE] = ACTIONS(2418),
    [anon_sym_AT_DQUOTE] = ACTIONS(2420),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2420),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2420),
    [sym_bool] = ACTIONS(2418),
    [sym_unit] = ACTIONS(2420),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2418),
    [sym_op_identifier] = ACTIONS(2418),
    [anon_sym_PLUS] = ACTIONS(2418),
    [anon_sym_DASH] = ACTIONS(2418),
    [anon_sym_PLUS_DOT] = ACTIONS(2418),
    [anon_sym_DASH_DOT] = ACTIONS(2418),
    [anon_sym_PERCENT] = ACTIONS(2418),
    [anon_sym_AMP_AMP] = ACTIONS(2418),
    [anon_sym_TILDE] = ACTIONS(2420),
    [aux_sym_prefix_op_token1] = ACTIONS(2418),
    [aux_sym_infix_op_token1] = ACTIONS(2420),
    [aux_sym_infix_op_token2] = ACTIONS(2418),
    [anon_sym_PIPE_PIPE] = ACTIONS(2418),
    [anon_sym_BANG_EQ] = ACTIONS(2418),
    [anon_sym_COLON_EQ] = ACTIONS(2420),
    [anon_sym_DOLLAR] = ACTIONS(2418),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2418),
    [sym_int] = ACTIONS(2418),
    [sym_xint] = ACTIONS(2420),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2420),
    [sym__newline] = ACTIONS(2420),
  },
  [1238] = {
    [sym_block_comment] = STATE(1238),
    [sym_compiler_directive_decl] = STATE(1238),
    [sym_fsi_directive_decl] = STATE(1238),
    [sym_preproc_line] = STATE(1238),
    [sym_identifier] = ACTIONS(2454),
    [anon_sym_EQ] = ACTIONS(2456),
    [anon_sym_COLON] = ACTIONS(2454),
    [anon_sym_return] = ACTIONS(2454),
    [anon_sym_do] = ACTIONS(2454),
    [anon_sym_let] = ACTIONS(2454),
    [anon_sym_let_BANG] = ACTIONS(2456),
    [anon_sym_as] = ACTIONS(2454),
    [anon_sym_LPAREN] = ACTIONS(2454),
    [anon_sym_COMMA] = ACTIONS(2456),
    [anon_sym_null] = ACTIONS(2454),
    [anon_sym_QMARK] = ACTIONS(2454),
    [anon_sym_COLON_QMARK] = ACTIONS(2454),
    [anon_sym_COLON_COLON] = ACTIONS(2456),
    [anon_sym_AMP] = ACTIONS(2454),
    [anon_sym_LBRACK] = ACTIONS(2454),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2456),
    [anon_sym_LBRACE] = ACTIONS(2454),
    [anon_sym_LT_AT] = ACTIONS(2454),
    [anon_sym_LT_AT_AT] = ACTIONS(2454),
    [anon_sym_DOT] = ACTIONS(2454),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2456),
    [anon_sym_new] = ACTIONS(2454),
    [anon_sym_with] = ACTIONS(2454),
    [anon_sym_return_BANG] = ACTIONS(2456),
    [anon_sym_yield] = ACTIONS(2454),
    [anon_sym_yield_BANG] = ACTIONS(2456),
    [anon_sym_lazy] = ACTIONS(2454),
    [anon_sym_assert] = ACTIONS(2454),
    [anon_sym_upcast] = ACTIONS(2454),
    [anon_sym_downcast] = ACTIONS(2454),
    [anon_sym_COLON_GT] = ACTIONS(2456),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2456),
    [anon_sym_for] = ACTIONS(2454),
    [anon_sym_while] = ACTIONS(2454),
    [anon_sym_if] = ACTIONS(2454),
    [anon_sym_fun] = ACTIONS(2454),
    [anon_sym_DASH_GT] = ACTIONS(2454),
    [anon_sym_try] = ACTIONS(2454),
    [anon_sym_match] = ACTIONS(2454),
    [anon_sym_match_BANG] = ACTIONS(2456),
    [anon_sym_function] = ACTIONS(2454),
    [anon_sym_LT_DASH] = ACTIONS(2454),
    [anon_sym_DOT_LBRACK] = ACTIONS(2456),
    [anon_sym_LT] = ACTIONS(2456),
    [anon_sym_use] = ACTIONS(2454),
    [anon_sym_use_BANG] = ACTIONS(2456),
    [anon_sym_do_BANG] = ACTIONS(2456),
    [anon_sym_begin] = ACTIONS(2454),
    [anon_sym_LPAREN2] = ACTIONS(2454),
    [anon_sym_STAR] = ACTIONS(2454),
    [anon_sym_LT2] = ACTIONS(2454),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2456),
    [anon_sym_or] = ACTIONS(2454),
    [aux_sym_char_token1] = ACTIONS(2456),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2454),
    [anon_sym_DQUOTE] = ACTIONS(2454),
    [anon_sym_AT_DQUOTE] = ACTIONS(2456),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2456),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2456),
    [sym_bool] = ACTIONS(2454),
    [sym_unit] = ACTIONS(2456),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2454),
    [sym_op_identifier] = ACTIONS(2454),
    [anon_sym_PLUS] = ACTIONS(2454),
    [anon_sym_DASH] = ACTIONS(2454),
    [anon_sym_PLUS_DOT] = ACTIONS(2454),
    [anon_sym_DASH_DOT] = ACTIONS(2454),
    [anon_sym_PERCENT] = ACTIONS(2454),
    [anon_sym_AMP_AMP] = ACTIONS(2454),
    [anon_sym_TILDE] = ACTIONS(2456),
    [aux_sym_prefix_op_token1] = ACTIONS(2454),
    [aux_sym_infix_op_token1] = ACTIONS(2456),
    [aux_sym_infix_op_token2] = ACTIONS(2454),
    [anon_sym_PIPE_PIPE] = ACTIONS(2454),
    [anon_sym_BANG_EQ] = ACTIONS(2454),
    [anon_sym_COLON_EQ] = ACTIONS(2456),
    [anon_sym_DOLLAR] = ACTIONS(2454),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2454),
    [sym_int] = ACTIONS(2454),
    [sym_xint] = ACTIONS(2456),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2456),
    [sym__newline] = ACTIONS(2456),
  },
  [1239] = {
    [sym_block_comment] = STATE(1239),
    [sym_compiler_directive_decl] = STATE(1239),
    [sym_fsi_directive_decl] = STATE(1239),
    [sym_preproc_line] = STATE(1239),
    [aux_sym_long_identifier_repeat1] = STATE(850),
    [sym_identifier] = ACTIONS(2791),
    [anon_sym_EQ] = ACTIONS(2794),
    [anon_sym_GT_RBRACK] = ACTIONS(2794),
    [anon_sym_COLON] = ACTIONS(2791),
    [anon_sym_return] = ACTIONS(2791),
    [anon_sym_do] = ACTIONS(2791),
    [anon_sym_let] = ACTIONS(2791),
    [anon_sym_let_BANG] = ACTIONS(2794),
    [anon_sym_LPAREN] = ACTIONS(2791),
    [anon_sym_COMMA] = ACTIONS(2794),
    [anon_sym_null] = ACTIONS(2791),
    [anon_sym_QMARK] = ACTIONS(2791),
    [anon_sym_COLON_QMARK] = ACTIONS(2791),
    [anon_sym_COLON_COLON] = ACTIONS(2794),
    [anon_sym_AMP] = ACTIONS(2791),
    [anon_sym_LBRACK] = ACTIONS(2791),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2794),
    [anon_sym_LBRACE] = ACTIONS(2791),
    [anon_sym_LT_AT] = ACTIONS(2791),
    [anon_sym_LT_AT_AT] = ACTIONS(2791),
    [anon_sym_DOT] = ACTIONS(3415),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2794),
    [anon_sym_new] = ACTIONS(2791),
    [anon_sym_return_BANG] = ACTIONS(2794),
    [anon_sym_yield] = ACTIONS(2791),
    [anon_sym_yield_BANG] = ACTIONS(2794),
    [anon_sym_lazy] = ACTIONS(2791),
    [anon_sym_assert] = ACTIONS(2791),
    [anon_sym_upcast] = ACTIONS(2791),
    [anon_sym_downcast] = ACTIONS(2791),
    [anon_sym_COLON_GT] = ACTIONS(2794),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2794),
    [anon_sym_for] = ACTIONS(2791),
    [anon_sym_while] = ACTIONS(2791),
    [anon_sym_if] = ACTIONS(2791),
    [anon_sym_fun] = ACTIONS(2791),
    [anon_sym_DASH_GT] = ACTIONS(2312),
    [anon_sym_try] = ACTIONS(2791),
    [anon_sym_match] = ACTIONS(2791),
    [anon_sym_match_BANG] = ACTIONS(2794),
    [anon_sym_function] = ACTIONS(2791),
    [anon_sym_LT_DASH] = ACTIONS(2791),
    [anon_sym_DOT_LBRACK] = ACTIONS(2794),
    [anon_sym_LT] = ACTIONS(2794),
    [anon_sym_use] = ACTIONS(2791),
    [anon_sym_use_BANG] = ACTIONS(2794),
    [anon_sym_do_BANG] = ACTIONS(2794),
    [anon_sym_begin] = ACTIONS(2791),
    [anon_sym_LPAREN2] = ACTIONS(2791),
    [anon_sym_STAR] = ACTIONS(2312),
    [anon_sym_LT2] = ACTIONS(2312),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2314),
    [anon_sym_or] = ACTIONS(2791),
    [aux_sym_char_token1] = ACTIONS(2794),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2791),
    [anon_sym_DQUOTE] = ACTIONS(2791),
    [anon_sym_AT_DQUOTE] = ACTIONS(2794),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2794),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2794),
    [sym_bool] = ACTIONS(2791),
    [sym_unit] = ACTIONS(2794),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2791),
    [sym_op_identifier] = ACTIONS(2791),
    [anon_sym_PLUS] = ACTIONS(2791),
    [anon_sym_DASH] = ACTIONS(2791),
    [anon_sym_PLUS_DOT] = ACTIONS(2791),
    [anon_sym_DASH_DOT] = ACTIONS(2791),
    [anon_sym_PERCENT] = ACTIONS(2791),
    [anon_sym_AMP_AMP] = ACTIONS(2791),
    [anon_sym_TILDE] = ACTIONS(2794),
    [aux_sym_prefix_op_token1] = ACTIONS(2791),
    [aux_sym_infix_op_token1] = ACTIONS(2794),
    [aux_sym_infix_op_token2] = ACTIONS(2791),
    [anon_sym_PIPE_PIPE] = ACTIONS(2791),
    [anon_sym_BANG_EQ] = ACTIONS(2791),
    [anon_sym_COLON_EQ] = ACTIONS(2794),
    [anon_sym_DOLLAR] = ACTIONS(2791),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2791),
    [sym_int] = ACTIONS(2791),
    [sym_xint] = ACTIONS(2794),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2794),
    [sym__newline] = ACTIONS(2794),
  },
  [1240] = {
    [sym_block_comment] = STATE(1240),
    [sym_compiler_directive_decl] = STATE(1240),
    [sym_fsi_directive_decl] = STATE(1240),
    [sym_preproc_line] = STATE(1240),
    [aux_sym_type_argument_repeat1] = STATE(1201),
    [sym_identifier] = ACTIONS(2321),
    [anon_sym_EQ] = ACTIONS(2323),
    [anon_sym_COLON] = ACTIONS(2321),
    [anon_sym_return] = ACTIONS(2321),
    [anon_sym_do] = ACTIONS(2321),
    [anon_sym_let] = ACTIONS(2321),
    [anon_sym_let_BANG] = ACTIONS(2323),
    [anon_sym_LPAREN] = ACTIONS(2321),
    [anon_sym_COMMA] = ACTIONS(2323),
    [anon_sym_null] = ACTIONS(2321),
    [anon_sym_QMARK] = ACTIONS(2321),
    [anon_sym_COLON_QMARK] = ACTIONS(2321),
    [anon_sym_COLON_COLON] = ACTIONS(2323),
    [anon_sym_AMP] = ACTIONS(2321),
    [anon_sym_LBRACK] = ACTIONS(2321),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2323),
    [anon_sym_LBRACE] = ACTIONS(2321),
    [anon_sym_LT_AT] = ACTIONS(2321),
    [anon_sym_LT_AT_AT] = ACTIONS(2321),
    [anon_sym_DOT] = ACTIONS(2321),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2323),
    [anon_sym_new] = ACTIONS(2321),
    [anon_sym_return_BANG] = ACTIONS(2323),
    [anon_sym_yield] = ACTIONS(2321),
    [anon_sym_yield_BANG] = ACTIONS(2323),
    [anon_sym_lazy] = ACTIONS(2321),
    [anon_sym_assert] = ACTIONS(2321),
    [anon_sym_upcast] = ACTIONS(2321),
    [anon_sym_downcast] = ACTIONS(2321),
    [anon_sym_COLON_GT] = ACTIONS(2323),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2323),
    [anon_sym_for] = ACTIONS(2321),
    [anon_sym_while] = ACTIONS(2321),
    [anon_sym_if] = ACTIONS(2321),
    [anon_sym_fun] = ACTIONS(2321),
    [anon_sym_DASH_GT] = ACTIONS(2321),
    [anon_sym_try] = ACTIONS(2321),
    [anon_sym_match] = ACTIONS(2321),
    [anon_sym_match_BANG] = ACTIONS(2323),
    [anon_sym_function] = ACTIONS(2321),
    [anon_sym_LT_DASH] = ACTIONS(2321),
    [anon_sym_DOT_LBRACK] = ACTIONS(2323),
    [anon_sym_LT] = ACTIONS(2323),
    [anon_sym_use] = ACTIONS(2321),
    [anon_sym_use_BANG] = ACTIONS(2323),
    [anon_sym_do_BANG] = ACTIONS(2323),
    [anon_sym_begin] = ACTIONS(2321),
    [anon_sym_LPAREN2] = ACTIONS(2321),
    [anon_sym_STAR] = ACTIONS(2321),
    [anon_sym_LT2] = ACTIONS(2321),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2323),
    [anon_sym_or] = ACTIONS(3419),
    [aux_sym_char_token1] = ACTIONS(2323),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2321),
    [anon_sym_DQUOTE] = ACTIONS(2321),
    [anon_sym_AT_DQUOTE] = ACTIONS(2323),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2323),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2323),
    [sym_bool] = ACTIONS(2321),
    [sym_unit] = ACTIONS(2323),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2321),
    [sym_op_identifier] = ACTIONS(2321),
    [anon_sym_PLUS] = ACTIONS(2321),
    [anon_sym_DASH] = ACTIONS(2321),
    [anon_sym_PLUS_DOT] = ACTIONS(2321),
    [anon_sym_DASH_DOT] = ACTIONS(2321),
    [anon_sym_PERCENT] = ACTIONS(2321),
    [anon_sym_AMP_AMP] = ACTIONS(2321),
    [anon_sym_TILDE] = ACTIONS(2323),
    [aux_sym_prefix_op_token1] = ACTIONS(2321),
    [aux_sym_infix_op_token1] = ACTIONS(2323),
    [aux_sym_infix_op_token2] = ACTIONS(2321),
    [anon_sym_PIPE_PIPE] = ACTIONS(2321),
    [anon_sym_BANG_EQ] = ACTIONS(2321),
    [anon_sym_COLON_EQ] = ACTIONS(2323),
    [anon_sym_DOLLAR] = ACTIONS(2321),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2321),
    [sym_int] = ACTIONS(2321),
    [sym_xint] = ACTIONS(2323),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2323),
    [anon_sym_POUNDendif] = ACTIONS(2323),
    [sym__newline] = ACTIONS(2323),
  },
  [1241] = {
    [sym_block_comment] = STATE(1241),
    [sym_compiler_directive_decl] = STATE(1241),
    [sym_fsi_directive_decl] = STATE(1241),
    [sym_preproc_line] = STATE(1241),
    [aux_sym_type_argument_repeat1] = STATE(1215),
    [sym_identifier] = ACTIONS(2321),
    [anon_sym_EQ] = ACTIONS(2323),
    [anon_sym_COLON] = ACTIONS(2321),
    [anon_sym_return] = ACTIONS(2321),
    [anon_sym_do] = ACTIONS(2321),
    [anon_sym_let] = ACTIONS(2321),
    [anon_sym_let_BANG] = ACTIONS(2323),
    [anon_sym_LPAREN] = ACTIONS(2321),
    [anon_sym_COMMA] = ACTIONS(2323),
    [anon_sym_null] = ACTIONS(2321),
    [anon_sym_QMARK] = ACTIONS(2321),
    [anon_sym_COLON_QMARK] = ACTIONS(2321),
    [anon_sym_COLON_COLON] = ACTIONS(2323),
    [anon_sym_AMP] = ACTIONS(2321),
    [anon_sym_LBRACK] = ACTIONS(2321),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2323),
    [anon_sym_LBRACE] = ACTIONS(2321),
    [anon_sym_LT_AT] = ACTIONS(2321),
    [anon_sym_LT_AT_AT] = ACTIONS(2321),
    [anon_sym_DOT] = ACTIONS(2321),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2323),
    [anon_sym_new] = ACTIONS(2321),
    [anon_sym_return_BANG] = ACTIONS(2323),
    [anon_sym_yield] = ACTIONS(2321),
    [anon_sym_yield_BANG] = ACTIONS(2323),
    [anon_sym_lazy] = ACTIONS(2321),
    [anon_sym_assert] = ACTIONS(2321),
    [anon_sym_upcast] = ACTIONS(2321),
    [anon_sym_downcast] = ACTIONS(2321),
    [anon_sym_COLON_GT] = ACTIONS(2323),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2323),
    [anon_sym_for] = ACTIONS(2321),
    [anon_sym_while] = ACTIONS(2321),
    [anon_sym_if] = ACTIONS(2321),
    [anon_sym_fun] = ACTIONS(2321),
    [anon_sym_DASH_GT] = ACTIONS(2321),
    [anon_sym_try] = ACTIONS(2321),
    [anon_sym_match] = ACTIONS(2321),
    [anon_sym_match_BANG] = ACTIONS(2323),
    [anon_sym_function] = ACTIONS(2321),
    [anon_sym_LT_DASH] = ACTIONS(2321),
    [anon_sym_DOT_LBRACK] = ACTIONS(2323),
    [anon_sym_LT] = ACTIONS(2323),
    [anon_sym_use] = ACTIONS(2321),
    [anon_sym_use_BANG] = ACTIONS(2323),
    [anon_sym_do_BANG] = ACTIONS(2323),
    [anon_sym_DOT_DOT] = ACTIONS(2323),
    [anon_sym_begin] = ACTIONS(2321),
    [anon_sym_LPAREN2] = ACTIONS(2321),
    [anon_sym_STAR] = ACTIONS(2321),
    [anon_sym_LT2] = ACTIONS(2321),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2323),
    [anon_sym_or] = ACTIONS(3422),
    [aux_sym_char_token1] = ACTIONS(2323),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2321),
    [anon_sym_DQUOTE] = ACTIONS(2321),
    [anon_sym_AT_DQUOTE] = ACTIONS(2323),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2323),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2323),
    [sym_bool] = ACTIONS(2321),
    [sym_unit] = ACTIONS(2323),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2321),
    [sym_op_identifier] = ACTIONS(2321),
    [anon_sym_PLUS] = ACTIONS(2321),
    [anon_sym_DASH] = ACTIONS(2321),
    [anon_sym_PLUS_DOT] = ACTIONS(2321),
    [anon_sym_DASH_DOT] = ACTIONS(2321),
    [anon_sym_PERCENT] = ACTIONS(2321),
    [anon_sym_AMP_AMP] = ACTIONS(2321),
    [anon_sym_TILDE] = ACTIONS(2323),
    [aux_sym_prefix_op_token1] = ACTIONS(2321),
    [aux_sym_infix_op_token1] = ACTIONS(2323),
    [aux_sym_infix_op_token2] = ACTIONS(2321),
    [anon_sym_PIPE_PIPE] = ACTIONS(2321),
    [anon_sym_BANG_EQ] = ACTIONS(2321),
    [anon_sym_COLON_EQ] = ACTIONS(2323),
    [anon_sym_DOLLAR] = ACTIONS(2321),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2321),
    [sym_int] = ACTIONS(2321),
    [sym_xint] = ACTIONS(2323),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2323),
    [sym__newline] = ACTIONS(2323),
  },
  [1242] = {
    [sym_block_comment] = STATE(1242),
    [sym_compiler_directive_decl] = STATE(1242),
    [sym_fsi_directive_decl] = STATE(1242),
    [sym_preproc_line] = STATE(1242),
    [aux_sym_type_argument_repeat1] = STATE(1266),
    [sym_identifier] = ACTIONS(2321),
    [anon_sym_EQ] = ACTIONS(2323),
    [anon_sym_COLON] = ACTIONS(2321),
    [anon_sym_return] = ACTIONS(2321),
    [anon_sym_do] = ACTIONS(2321),
    [anon_sym_let] = ACTIONS(2321),
    [anon_sym_let_BANG] = ACTIONS(2323),
    [anon_sym_LPAREN] = ACTIONS(2321),
    [anon_sym_COMMA] = ACTIONS(2323),
    [anon_sym_null] = ACTIONS(2321),
    [anon_sym_QMARK] = ACTIONS(2321),
    [anon_sym_COLON_QMARK] = ACTIONS(2321),
    [anon_sym_COLON_COLON] = ACTIONS(2323),
    [anon_sym_AMP] = ACTIONS(2321),
    [anon_sym_LBRACK] = ACTIONS(2321),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2323),
    [anon_sym_LBRACE] = ACTIONS(2321),
    [anon_sym_LT_AT] = ACTIONS(2321),
    [anon_sym_LT_AT_AT] = ACTIONS(2321),
    [anon_sym_DOT] = ACTIONS(2321),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2323),
    [anon_sym_new] = ACTIONS(2321),
    [anon_sym_return_BANG] = ACTIONS(2323),
    [anon_sym_yield] = ACTIONS(2321),
    [anon_sym_yield_BANG] = ACTIONS(2323),
    [anon_sym_lazy] = ACTIONS(2321),
    [anon_sym_assert] = ACTIONS(2321),
    [anon_sym_upcast] = ACTIONS(2321),
    [anon_sym_downcast] = ACTIONS(2321),
    [anon_sym_COLON_GT] = ACTIONS(2323),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2323),
    [anon_sym_for] = ACTIONS(2321),
    [anon_sym_while] = ACTIONS(2321),
    [anon_sym_if] = ACTIONS(2321),
    [anon_sym_fun] = ACTIONS(2321),
    [anon_sym_DASH_GT] = ACTIONS(2321),
    [anon_sym_try] = ACTIONS(2321),
    [anon_sym_match] = ACTIONS(2321),
    [anon_sym_match_BANG] = ACTIONS(2323),
    [anon_sym_function] = ACTIONS(2321),
    [anon_sym_LT_DASH] = ACTIONS(2321),
    [anon_sym_DOT_LBRACK] = ACTIONS(2323),
    [anon_sym_LT] = ACTIONS(2323),
    [anon_sym_GT] = ACTIONS(2321),
    [anon_sym_use] = ACTIONS(2321),
    [anon_sym_use_BANG] = ACTIONS(2323),
    [anon_sym_do_BANG] = ACTIONS(2323),
    [anon_sym_begin] = ACTIONS(2321),
    [anon_sym_LPAREN2] = ACTIONS(2321),
    [anon_sym_STAR] = ACTIONS(2321),
    [anon_sym_LT2] = ACTIONS(2321),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2323),
    [anon_sym_or] = ACTIONS(3425),
    [aux_sym_char_token1] = ACTIONS(2323),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2321),
    [anon_sym_DQUOTE] = ACTIONS(2321),
    [anon_sym_AT_DQUOTE] = ACTIONS(2323),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2323),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2323),
    [sym_bool] = ACTIONS(2321),
    [sym_unit] = ACTIONS(2323),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2321),
    [sym_op_identifier] = ACTIONS(2321),
    [anon_sym_PLUS] = ACTIONS(2321),
    [anon_sym_DASH] = ACTIONS(2321),
    [anon_sym_PLUS_DOT] = ACTIONS(2321),
    [anon_sym_DASH_DOT] = ACTIONS(2321),
    [anon_sym_PERCENT] = ACTIONS(2321),
    [anon_sym_AMP_AMP] = ACTIONS(2321),
    [anon_sym_TILDE] = ACTIONS(2323),
    [aux_sym_prefix_op_token1] = ACTIONS(2321),
    [aux_sym_infix_op_token1] = ACTIONS(2323),
    [aux_sym_infix_op_token2] = ACTIONS(2321),
    [anon_sym_PIPE_PIPE] = ACTIONS(2321),
    [anon_sym_BANG_EQ] = ACTIONS(2321),
    [anon_sym_COLON_EQ] = ACTIONS(2323),
    [anon_sym_DOLLAR] = ACTIONS(2321),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2321),
    [sym_int] = ACTIONS(2321),
    [sym_xint] = ACTIONS(2323),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2323),
    [sym__newline] = ACTIONS(2323),
  },
  [1243] = {
    [sym_block_comment] = STATE(1243),
    [sym_compiler_directive_decl] = STATE(1243),
    [sym_fsi_directive_decl] = STATE(1243),
    [sym_preproc_line] = STATE(1243),
    [sym_identifier] = ACTIONS(2411),
    [anon_sym_EQ] = ACTIONS(2413),
    [anon_sym_COLON] = ACTIONS(2411),
    [anon_sym_return] = ACTIONS(2411),
    [anon_sym_do] = ACTIONS(2411),
    [anon_sym_and] = ACTIONS(2411),
    [anon_sym_let] = ACTIONS(2411),
    [anon_sym_let_BANG] = ACTIONS(2413),
    [anon_sym_LPAREN] = ACTIONS(2411),
    [anon_sym_COMMA] = ACTIONS(2413),
    [anon_sym_null] = ACTIONS(2411),
    [anon_sym_QMARK] = ACTIONS(2411),
    [anon_sym_COLON_QMARK] = ACTIONS(2411),
    [anon_sym_COLON_COLON] = ACTIONS(2413),
    [anon_sym_AMP] = ACTIONS(2411),
    [anon_sym_LBRACK] = ACTIONS(2411),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2413),
    [anon_sym_LBRACE] = ACTIONS(2411),
    [anon_sym_LT_AT] = ACTIONS(2411),
    [anon_sym_LT_AT_AT] = ACTIONS(2411),
    [anon_sym_DOT] = ACTIONS(2411),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2413),
    [anon_sym_new] = ACTIONS(2411),
    [anon_sym_return_BANG] = ACTIONS(2413),
    [anon_sym_yield] = ACTIONS(2411),
    [anon_sym_yield_BANG] = ACTIONS(2413),
    [anon_sym_lazy] = ACTIONS(2411),
    [anon_sym_assert] = ACTIONS(2411),
    [anon_sym_upcast] = ACTIONS(2411),
    [anon_sym_downcast] = ACTIONS(2411),
    [anon_sym_COLON_GT] = ACTIONS(2413),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2413),
    [anon_sym_for] = ACTIONS(2411),
    [anon_sym_while] = ACTIONS(2411),
    [anon_sym_if] = ACTIONS(2411),
    [anon_sym_fun] = ACTIONS(2411),
    [anon_sym_DASH_GT] = ACTIONS(2411),
    [anon_sym_try] = ACTIONS(2411),
    [anon_sym_match] = ACTIONS(2411),
    [anon_sym_match_BANG] = ACTIONS(2413),
    [anon_sym_function] = ACTIONS(2411),
    [anon_sym_LT_DASH] = ACTIONS(2411),
    [anon_sym_DOT_LBRACK] = ACTIONS(2413),
    [anon_sym_LT] = ACTIONS(2413),
    [anon_sym_use] = ACTIONS(2411),
    [anon_sym_use_BANG] = ACTIONS(2413),
    [anon_sym_do_BANG] = ACTIONS(2413),
    [anon_sym_begin] = ACTIONS(2411),
    [anon_sym_LPAREN2] = ACTIONS(2411),
    [anon_sym_STAR] = ACTIONS(2411),
    [anon_sym_LT2] = ACTIONS(2411),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2413),
    [anon_sym_or] = ACTIONS(2411),
    [aux_sym_char_token1] = ACTIONS(2413),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2411),
    [anon_sym_DQUOTE] = ACTIONS(2411),
    [anon_sym_AT_DQUOTE] = ACTIONS(2413),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2413),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2413),
    [sym_bool] = ACTIONS(2411),
    [sym_unit] = ACTIONS(2413),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2411),
    [sym_op_identifier] = ACTIONS(2411),
    [anon_sym_PLUS] = ACTIONS(2411),
    [anon_sym_DASH] = ACTIONS(2411),
    [anon_sym_PLUS_DOT] = ACTIONS(2411),
    [anon_sym_DASH_DOT] = ACTIONS(2411),
    [anon_sym_PERCENT] = ACTIONS(2411),
    [anon_sym_AMP_AMP] = ACTIONS(2411),
    [anon_sym_TILDE] = ACTIONS(2413),
    [aux_sym_prefix_op_token1] = ACTIONS(2411),
    [aux_sym_infix_op_token1] = ACTIONS(2413),
    [aux_sym_infix_op_token2] = ACTIONS(2411),
    [anon_sym_PIPE_PIPE] = ACTIONS(2411),
    [anon_sym_BANG_EQ] = ACTIONS(2411),
    [anon_sym_COLON_EQ] = ACTIONS(2413),
    [anon_sym_DOLLAR] = ACTIONS(2411),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2411),
    [sym_int] = ACTIONS(2411),
    [sym_xint] = ACTIONS(2413),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2413),
    [sym__newline] = ACTIONS(2413),
    [sym__dedent] = ACTIONS(2413),
  },
  [1244] = {
    [sym_block_comment] = STATE(1244),
    [sym_compiler_directive_decl] = STATE(1244),
    [sym_fsi_directive_decl] = STATE(1244),
    [sym_preproc_line] = STATE(1244),
    [aux_sym_long_identifier_repeat1] = STATE(1244),
    [sym_identifier] = ACTIONS(2411),
    [anon_sym_EQ] = ACTIONS(2413),
    [anon_sym_COLON] = ACTIONS(2411),
    [anon_sym_return] = ACTIONS(2411),
    [anon_sym_do] = ACTIONS(2411),
    [anon_sym_let] = ACTIONS(2411),
    [anon_sym_let_BANG] = ACTIONS(2413),
    [anon_sym_LPAREN] = ACTIONS(2411),
    [anon_sym_COMMA] = ACTIONS(2413),
    [anon_sym_null] = ACTIONS(2411),
    [anon_sym_QMARK] = ACTIONS(2411),
    [anon_sym_COLON_QMARK] = ACTIONS(2411),
    [anon_sym_COLON_COLON] = ACTIONS(2413),
    [anon_sym_AMP] = ACTIONS(2411),
    [anon_sym_LBRACK] = ACTIONS(2411),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2413),
    [anon_sym_LBRACE] = ACTIONS(2411),
    [anon_sym_LT_AT] = ACTIONS(2411),
    [anon_sym_AT_GT] = ACTIONS(2411),
    [anon_sym_LT_AT_AT] = ACTIONS(2411),
    [anon_sym_DOT] = ACTIONS(3428),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2413),
    [anon_sym_new] = ACTIONS(2411),
    [anon_sym_return_BANG] = ACTIONS(2413),
    [anon_sym_yield] = ACTIONS(2411),
    [anon_sym_yield_BANG] = ACTIONS(2413),
    [anon_sym_lazy] = ACTIONS(2411),
    [anon_sym_assert] = ACTIONS(2411),
    [anon_sym_upcast] = ACTIONS(2411),
    [anon_sym_downcast] = ACTIONS(2411),
    [anon_sym_COLON_GT] = ACTIONS(2413),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2413),
    [anon_sym_for] = ACTIONS(2411),
    [anon_sym_while] = ACTIONS(2411),
    [anon_sym_if] = ACTIONS(2411),
    [anon_sym_fun] = ACTIONS(2411),
    [anon_sym_DASH_GT] = ACTIONS(2411),
    [anon_sym_try] = ACTIONS(2411),
    [anon_sym_match] = ACTIONS(2411),
    [anon_sym_match_BANG] = ACTIONS(2413),
    [anon_sym_function] = ACTIONS(2411),
    [anon_sym_LT_DASH] = ACTIONS(2411),
    [anon_sym_DOT_LBRACK] = ACTIONS(2413),
    [anon_sym_LT] = ACTIONS(2413),
    [anon_sym_use] = ACTIONS(2411),
    [anon_sym_use_BANG] = ACTIONS(2413),
    [anon_sym_do_BANG] = ACTIONS(2413),
    [anon_sym_begin] = ACTIONS(2411),
    [anon_sym_LPAREN2] = ACTIONS(2411),
    [anon_sym_STAR] = ACTIONS(2411),
    [anon_sym_LT2] = ACTIONS(2411),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2413),
    [anon_sym_or] = ACTIONS(2411),
    [aux_sym_char_token1] = ACTIONS(2413),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2411),
    [anon_sym_DQUOTE] = ACTIONS(2411),
    [anon_sym_AT_DQUOTE] = ACTIONS(2413),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2413),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2413),
    [sym_bool] = ACTIONS(2411),
    [sym_unit] = ACTIONS(2413),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2411),
    [sym_op_identifier] = ACTIONS(2411),
    [anon_sym_PLUS] = ACTIONS(2411),
    [anon_sym_DASH] = ACTIONS(2411),
    [anon_sym_PLUS_DOT] = ACTIONS(2411),
    [anon_sym_DASH_DOT] = ACTIONS(2411),
    [anon_sym_PERCENT] = ACTIONS(2411),
    [anon_sym_AMP_AMP] = ACTIONS(2411),
    [anon_sym_TILDE] = ACTIONS(2413),
    [aux_sym_prefix_op_token1] = ACTIONS(2411),
    [aux_sym_infix_op_token1] = ACTIONS(2413),
    [aux_sym_infix_op_token2] = ACTIONS(2411),
    [anon_sym_PIPE_PIPE] = ACTIONS(2411),
    [anon_sym_BANG_EQ] = ACTIONS(2411),
    [anon_sym_COLON_EQ] = ACTIONS(2413),
    [anon_sym_DOLLAR] = ACTIONS(2411),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2411),
    [sym_int] = ACTIONS(2411),
    [sym_xint] = ACTIONS(2413),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2413),
    [sym__newline] = ACTIONS(2413),
  },
  [1245] = {
    [sym_block_comment] = STATE(1245),
    [sym_compiler_directive_decl] = STATE(1245),
    [sym_fsi_directive_decl] = STATE(1245),
    [sym_preproc_line] = STATE(1245),
    [sym_identifier] = ACTIONS(2553),
    [anon_sym_EQ] = ACTIONS(2555),
    [anon_sym_COLON] = ACTIONS(2553),
    [anon_sym_return] = ACTIONS(2553),
    [anon_sym_do] = ACTIONS(2553),
    [anon_sym_and] = ACTIONS(2553),
    [anon_sym_let] = ACTIONS(2553),
    [anon_sym_let_BANG] = ACTIONS(2555),
    [anon_sym_LPAREN] = ACTIONS(2553),
    [anon_sym_COMMA] = ACTIONS(2555),
    [anon_sym_null] = ACTIONS(2553),
    [anon_sym_QMARK] = ACTIONS(2553),
    [anon_sym_COLON_QMARK] = ACTIONS(2553),
    [anon_sym_COLON_COLON] = ACTIONS(2555),
    [anon_sym_AMP] = ACTIONS(2553),
    [anon_sym_LBRACK] = ACTIONS(2553),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2555),
    [anon_sym_LBRACE] = ACTIONS(2553),
    [anon_sym_LT_AT] = ACTIONS(2553),
    [anon_sym_LT_AT_AT] = ACTIONS(2553),
    [anon_sym_DOT] = ACTIONS(2553),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2555),
    [anon_sym_new] = ACTIONS(2553),
    [anon_sym_return_BANG] = ACTIONS(2555),
    [anon_sym_yield] = ACTIONS(2553),
    [anon_sym_yield_BANG] = ACTIONS(2555),
    [anon_sym_lazy] = ACTIONS(2553),
    [anon_sym_assert] = ACTIONS(2553),
    [anon_sym_upcast] = ACTIONS(2553),
    [anon_sym_downcast] = ACTIONS(2553),
    [anon_sym_COLON_GT] = ACTIONS(2555),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2555),
    [anon_sym_for] = ACTIONS(2553),
    [anon_sym_while] = ACTIONS(2553),
    [anon_sym_if] = ACTIONS(2553),
    [anon_sym_fun] = ACTIONS(2553),
    [anon_sym_DASH_GT] = ACTIONS(2553),
    [anon_sym_try] = ACTIONS(2553),
    [anon_sym_match] = ACTIONS(2553),
    [anon_sym_match_BANG] = ACTIONS(2555),
    [anon_sym_function] = ACTIONS(2553),
    [anon_sym_LT_DASH] = ACTIONS(2553),
    [anon_sym_DOT_LBRACK] = ACTIONS(2555),
    [anon_sym_LT] = ACTIONS(2555),
    [anon_sym_use] = ACTIONS(2553),
    [anon_sym_use_BANG] = ACTIONS(2555),
    [anon_sym_do_BANG] = ACTIONS(2555),
    [anon_sym_begin] = ACTIONS(2553),
    [anon_sym_LPAREN2] = ACTIONS(2553),
    [anon_sym_STAR] = ACTIONS(2553),
    [anon_sym_LT2] = ACTIONS(2553),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2555),
    [anon_sym_or] = ACTIONS(2553),
    [aux_sym_char_token1] = ACTIONS(2555),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2553),
    [anon_sym_DQUOTE] = ACTIONS(2553),
    [anon_sym_AT_DQUOTE] = ACTIONS(2555),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2555),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2555),
    [sym_bool] = ACTIONS(2553),
    [sym_unit] = ACTIONS(2555),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2553),
    [sym_op_identifier] = ACTIONS(2553),
    [anon_sym_PLUS] = ACTIONS(2553),
    [anon_sym_DASH] = ACTIONS(2553),
    [anon_sym_PLUS_DOT] = ACTIONS(2553),
    [anon_sym_DASH_DOT] = ACTIONS(2553),
    [anon_sym_PERCENT] = ACTIONS(2553),
    [anon_sym_AMP_AMP] = ACTIONS(2553),
    [anon_sym_TILDE] = ACTIONS(2555),
    [aux_sym_prefix_op_token1] = ACTIONS(2553),
    [aux_sym_infix_op_token1] = ACTIONS(2555),
    [aux_sym_infix_op_token2] = ACTIONS(2553),
    [anon_sym_PIPE_PIPE] = ACTIONS(2553),
    [anon_sym_BANG_EQ] = ACTIONS(2553),
    [anon_sym_COLON_EQ] = ACTIONS(2555),
    [anon_sym_DOLLAR] = ACTIONS(2553),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2553),
    [sym_int] = ACTIONS(2553),
    [sym_xint] = ACTIONS(2555),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2555),
    [sym__newline] = ACTIONS(2555),
    [sym__dedent] = ACTIONS(2555),
  },
  [1246] = {
    [sym_block_comment] = STATE(1246),
    [sym_compiler_directive_decl] = STATE(1246),
    [sym_fsi_directive_decl] = STATE(1246),
    [sym_preproc_line] = STATE(1246),
    [sym_identifier] = ACTIONS(2563),
    [anon_sym_EQ] = ACTIONS(2565),
    [anon_sym_COLON] = ACTIONS(2563),
    [anon_sym_return] = ACTIONS(2563),
    [anon_sym_do] = ACTIONS(2563),
    [anon_sym_and] = ACTIONS(2563),
    [anon_sym_let] = ACTIONS(2563),
    [anon_sym_let_BANG] = ACTIONS(2565),
    [anon_sym_LPAREN] = ACTIONS(2563),
    [anon_sym_COMMA] = ACTIONS(2565),
    [anon_sym_null] = ACTIONS(2563),
    [anon_sym_QMARK] = ACTIONS(2563),
    [anon_sym_COLON_QMARK] = ACTIONS(2563),
    [anon_sym_COLON_COLON] = ACTIONS(2565),
    [anon_sym_AMP] = ACTIONS(2563),
    [anon_sym_LBRACK] = ACTIONS(2563),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2565),
    [anon_sym_LBRACE] = ACTIONS(2563),
    [anon_sym_LT_AT] = ACTIONS(2563),
    [anon_sym_LT_AT_AT] = ACTIONS(2563),
    [anon_sym_DOT] = ACTIONS(2563),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2565),
    [anon_sym_new] = ACTIONS(2563),
    [anon_sym_return_BANG] = ACTIONS(2565),
    [anon_sym_yield] = ACTIONS(2563),
    [anon_sym_yield_BANG] = ACTIONS(2565),
    [anon_sym_lazy] = ACTIONS(2563),
    [anon_sym_assert] = ACTIONS(2563),
    [anon_sym_upcast] = ACTIONS(2563),
    [anon_sym_downcast] = ACTIONS(2563),
    [anon_sym_COLON_GT] = ACTIONS(2565),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2565),
    [anon_sym_for] = ACTIONS(2563),
    [anon_sym_while] = ACTIONS(2563),
    [anon_sym_if] = ACTIONS(2563),
    [anon_sym_fun] = ACTIONS(2563),
    [anon_sym_DASH_GT] = ACTIONS(2563),
    [anon_sym_try] = ACTIONS(2563),
    [anon_sym_match] = ACTIONS(2563),
    [anon_sym_match_BANG] = ACTIONS(2565),
    [anon_sym_function] = ACTIONS(2563),
    [anon_sym_LT_DASH] = ACTIONS(2563),
    [anon_sym_DOT_LBRACK] = ACTIONS(2565),
    [anon_sym_LT] = ACTIONS(2565),
    [anon_sym_use] = ACTIONS(2563),
    [anon_sym_use_BANG] = ACTIONS(2565),
    [anon_sym_do_BANG] = ACTIONS(2565),
    [anon_sym_begin] = ACTIONS(2563),
    [anon_sym_LPAREN2] = ACTIONS(2563),
    [anon_sym_STAR] = ACTIONS(2563),
    [anon_sym_LT2] = ACTIONS(2563),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2565),
    [anon_sym_or] = ACTIONS(2563),
    [aux_sym_char_token1] = ACTIONS(2565),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2563),
    [anon_sym_DQUOTE] = ACTIONS(2563),
    [anon_sym_AT_DQUOTE] = ACTIONS(2565),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2565),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2565),
    [sym_bool] = ACTIONS(2563),
    [sym_unit] = ACTIONS(2565),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2563),
    [sym_op_identifier] = ACTIONS(2563),
    [anon_sym_PLUS] = ACTIONS(2563),
    [anon_sym_DASH] = ACTIONS(2563),
    [anon_sym_PLUS_DOT] = ACTIONS(2563),
    [anon_sym_DASH_DOT] = ACTIONS(2563),
    [anon_sym_PERCENT] = ACTIONS(2563),
    [anon_sym_AMP_AMP] = ACTIONS(2563),
    [anon_sym_TILDE] = ACTIONS(2565),
    [aux_sym_prefix_op_token1] = ACTIONS(2563),
    [aux_sym_infix_op_token1] = ACTIONS(2565),
    [aux_sym_infix_op_token2] = ACTIONS(2563),
    [anon_sym_PIPE_PIPE] = ACTIONS(2563),
    [anon_sym_BANG_EQ] = ACTIONS(2563),
    [anon_sym_COLON_EQ] = ACTIONS(2565),
    [anon_sym_DOLLAR] = ACTIONS(2563),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2563),
    [sym_int] = ACTIONS(2563),
    [sym_xint] = ACTIONS(2565),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2565),
    [sym__newline] = ACTIONS(2565),
    [sym__dedent] = ACTIONS(2565),
  },
  [1247] = {
    [sym_block_comment] = STATE(1247),
    [sym_compiler_directive_decl] = STATE(1247),
    [sym_fsi_directive_decl] = STATE(1247),
    [sym_preproc_line] = STATE(1247),
    [sym_identifier] = ACTIONS(2514),
    [anon_sym_EQ] = ACTIONS(2516),
    [anon_sym_COLON] = ACTIONS(2514),
    [anon_sym_return] = ACTIONS(2514),
    [anon_sym_do] = ACTIONS(2514),
    [anon_sym_and] = ACTIONS(2514),
    [anon_sym_let] = ACTIONS(2514),
    [anon_sym_let_BANG] = ACTIONS(2516),
    [anon_sym_LPAREN] = ACTIONS(2514),
    [anon_sym_COMMA] = ACTIONS(2516),
    [anon_sym_null] = ACTIONS(2514),
    [anon_sym_QMARK] = ACTIONS(2514),
    [anon_sym_COLON_QMARK] = ACTIONS(2514),
    [anon_sym_COLON_COLON] = ACTIONS(2516),
    [anon_sym_AMP] = ACTIONS(2514),
    [anon_sym_LBRACK] = ACTIONS(2514),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2516),
    [anon_sym_LBRACE] = ACTIONS(2514),
    [anon_sym_LT_AT] = ACTIONS(2514),
    [anon_sym_LT_AT_AT] = ACTIONS(2514),
    [anon_sym_DOT] = ACTIONS(2514),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2516),
    [anon_sym_new] = ACTIONS(2514),
    [anon_sym_return_BANG] = ACTIONS(2516),
    [anon_sym_yield] = ACTIONS(2514),
    [anon_sym_yield_BANG] = ACTIONS(2516),
    [anon_sym_lazy] = ACTIONS(2514),
    [anon_sym_assert] = ACTIONS(2514),
    [anon_sym_upcast] = ACTIONS(2514),
    [anon_sym_downcast] = ACTIONS(2514),
    [anon_sym_COLON_GT] = ACTIONS(2516),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2516),
    [anon_sym_for] = ACTIONS(2514),
    [anon_sym_while] = ACTIONS(2514),
    [anon_sym_if] = ACTIONS(2514),
    [anon_sym_fun] = ACTIONS(2514),
    [anon_sym_DASH_GT] = ACTIONS(2514),
    [anon_sym_try] = ACTIONS(2514),
    [anon_sym_match] = ACTIONS(2514),
    [anon_sym_match_BANG] = ACTIONS(2516),
    [anon_sym_function] = ACTIONS(2514),
    [anon_sym_LT_DASH] = ACTIONS(2514),
    [anon_sym_DOT_LBRACK] = ACTIONS(2516),
    [anon_sym_LT] = ACTIONS(2516),
    [anon_sym_use] = ACTIONS(2514),
    [anon_sym_use_BANG] = ACTIONS(2516),
    [anon_sym_do_BANG] = ACTIONS(2516),
    [anon_sym_begin] = ACTIONS(2514),
    [anon_sym_LPAREN2] = ACTIONS(2514),
    [anon_sym_STAR] = ACTIONS(2514),
    [anon_sym_LT2] = ACTIONS(2514),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2516),
    [anon_sym_or] = ACTIONS(2514),
    [aux_sym_char_token1] = ACTIONS(2516),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2514),
    [anon_sym_DQUOTE] = ACTIONS(2514),
    [anon_sym_AT_DQUOTE] = ACTIONS(2516),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2516),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2516),
    [sym_bool] = ACTIONS(2514),
    [sym_unit] = ACTIONS(2516),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2514),
    [sym_op_identifier] = ACTIONS(2514),
    [anon_sym_PLUS] = ACTIONS(2514),
    [anon_sym_DASH] = ACTIONS(2514),
    [anon_sym_PLUS_DOT] = ACTIONS(2514),
    [anon_sym_DASH_DOT] = ACTIONS(2514),
    [anon_sym_PERCENT] = ACTIONS(2514),
    [anon_sym_AMP_AMP] = ACTIONS(2514),
    [anon_sym_TILDE] = ACTIONS(2516),
    [aux_sym_prefix_op_token1] = ACTIONS(2514),
    [aux_sym_infix_op_token1] = ACTIONS(2516),
    [aux_sym_infix_op_token2] = ACTIONS(2514),
    [anon_sym_PIPE_PIPE] = ACTIONS(2514),
    [anon_sym_BANG_EQ] = ACTIONS(2514),
    [anon_sym_COLON_EQ] = ACTIONS(2516),
    [anon_sym_DOLLAR] = ACTIONS(2514),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2514),
    [sym_int] = ACTIONS(2514),
    [sym_xint] = ACTIONS(2516),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2516),
    [sym__newline] = ACTIONS(2516),
    [sym__dedent] = ACTIONS(2516),
  },
  [1248] = {
    [sym_block_comment] = STATE(1248),
    [sym_compiler_directive_decl] = STATE(1248),
    [sym_fsi_directive_decl] = STATE(1248),
    [sym_preproc_line] = STATE(1248),
    [aux_sym_compound_type_repeat1] = STATE(1248),
    [sym_identifier] = ACTIONS(2250),
    [anon_sym_EQ] = ACTIONS(2248),
    [anon_sym_COLON] = ACTIONS(2250),
    [anon_sym_return] = ACTIONS(2250),
    [anon_sym_do] = ACTIONS(2250),
    [anon_sym_let] = ACTIONS(2250),
    [anon_sym_let_BANG] = ACTIONS(2248),
    [anon_sym_LPAREN] = ACTIONS(2250),
    [anon_sym_COMMA] = ACTIONS(2248),
    [anon_sym_null] = ACTIONS(2250),
    [anon_sym_QMARK] = ACTIONS(2250),
    [anon_sym_COLON_QMARK] = ACTIONS(2250),
    [anon_sym_COLON_COLON] = ACTIONS(2248),
    [anon_sym_AMP] = ACTIONS(2250),
    [anon_sym_LBRACK] = ACTIONS(2250),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2248),
    [anon_sym_LBRACE] = ACTIONS(2250),
    [anon_sym_LT_AT] = ACTIONS(2250),
    [anon_sym_LT_AT_AT] = ACTIONS(2250),
    [anon_sym_DOT] = ACTIONS(2250),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2248),
    [anon_sym_new] = ACTIONS(2250),
    [anon_sym_return_BANG] = ACTIONS(2248),
    [anon_sym_yield] = ACTIONS(2250),
    [anon_sym_yield_BANG] = ACTIONS(2248),
    [anon_sym_lazy] = ACTIONS(2250),
    [anon_sym_assert] = ACTIONS(2250),
    [anon_sym_upcast] = ACTIONS(2250),
    [anon_sym_downcast] = ACTIONS(2250),
    [anon_sym_COLON_GT] = ACTIONS(2248),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2248),
    [anon_sym_for] = ACTIONS(2250),
    [anon_sym_while] = ACTIONS(2250),
    [anon_sym_if] = ACTIONS(2250),
    [anon_sym_fun] = ACTIONS(2250),
    [anon_sym_DASH_GT] = ACTIONS(2250),
    [anon_sym_try] = ACTIONS(2250),
    [anon_sym_match] = ACTIONS(2250),
    [anon_sym_match_BANG] = ACTIONS(2248),
    [anon_sym_function] = ACTIONS(2250),
    [anon_sym_LT_DASH] = ACTIONS(2250),
    [anon_sym_DOT_LBRACK] = ACTIONS(2248),
    [anon_sym_LT] = ACTIONS(2248),
    [anon_sym_GT] = ACTIONS(2250),
    [anon_sym_use] = ACTIONS(2250),
    [anon_sym_use_BANG] = ACTIONS(2248),
    [anon_sym_do_BANG] = ACTIONS(2248),
    [anon_sym_begin] = ACTIONS(2250),
    [anon_sym_LPAREN2] = ACTIONS(2250),
    [anon_sym_STAR] = ACTIONS(3431),
    [anon_sym_LT2] = ACTIONS(2250),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2248),
    [anon_sym_or] = ACTIONS(2250),
    [aux_sym_char_token1] = ACTIONS(2248),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2250),
    [anon_sym_DQUOTE] = ACTIONS(2250),
    [anon_sym_AT_DQUOTE] = ACTIONS(2248),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2248),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2248),
    [sym_bool] = ACTIONS(2250),
    [sym_unit] = ACTIONS(2248),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2250),
    [sym_op_identifier] = ACTIONS(2250),
    [anon_sym_PLUS] = ACTIONS(2250),
    [anon_sym_DASH] = ACTIONS(2250),
    [anon_sym_PLUS_DOT] = ACTIONS(2250),
    [anon_sym_DASH_DOT] = ACTIONS(2250),
    [anon_sym_PERCENT] = ACTIONS(2250),
    [anon_sym_AMP_AMP] = ACTIONS(2250),
    [anon_sym_TILDE] = ACTIONS(2248),
    [aux_sym_prefix_op_token1] = ACTIONS(2250),
    [aux_sym_infix_op_token1] = ACTIONS(2248),
    [aux_sym_infix_op_token2] = ACTIONS(2250),
    [anon_sym_PIPE_PIPE] = ACTIONS(2250),
    [anon_sym_BANG_EQ] = ACTIONS(2250),
    [anon_sym_COLON_EQ] = ACTIONS(2248),
    [anon_sym_DOLLAR] = ACTIONS(2250),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2250),
    [sym_int] = ACTIONS(2250),
    [sym_xint] = ACTIONS(2248),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2248),
    [sym__newline] = ACTIONS(2248),
  },
  [1249] = {
    [sym_block_comment] = STATE(1249),
    [sym_compiler_directive_decl] = STATE(1249),
    [sym_fsi_directive_decl] = STATE(1249),
    [sym_preproc_line] = STATE(1249),
    [aux_sym_compound_type_repeat1] = STATE(1248),
    [sym_identifier] = ACTIONS(2407),
    [anon_sym_EQ] = ACTIONS(2409),
    [anon_sym_COLON] = ACTIONS(2407),
    [anon_sym_return] = ACTIONS(2407),
    [anon_sym_do] = ACTIONS(2407),
    [anon_sym_let] = ACTIONS(2407),
    [anon_sym_let_BANG] = ACTIONS(2409),
    [anon_sym_LPAREN] = ACTIONS(2407),
    [anon_sym_COMMA] = ACTIONS(2409),
    [anon_sym_null] = ACTIONS(2407),
    [anon_sym_QMARK] = ACTIONS(2407),
    [anon_sym_COLON_QMARK] = ACTIONS(2407),
    [anon_sym_COLON_COLON] = ACTIONS(2409),
    [anon_sym_AMP] = ACTIONS(2407),
    [anon_sym_LBRACK] = ACTIONS(2407),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2409),
    [anon_sym_LBRACE] = ACTIONS(2407),
    [anon_sym_LT_AT] = ACTIONS(2407),
    [anon_sym_LT_AT_AT] = ACTIONS(2407),
    [anon_sym_DOT] = ACTIONS(2407),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2409),
    [anon_sym_new] = ACTIONS(2407),
    [anon_sym_return_BANG] = ACTIONS(2409),
    [anon_sym_yield] = ACTIONS(2407),
    [anon_sym_yield_BANG] = ACTIONS(2409),
    [anon_sym_lazy] = ACTIONS(2407),
    [anon_sym_assert] = ACTIONS(2407),
    [anon_sym_upcast] = ACTIONS(2407),
    [anon_sym_downcast] = ACTIONS(2407),
    [anon_sym_COLON_GT] = ACTIONS(2409),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2409),
    [anon_sym_for] = ACTIONS(2407),
    [anon_sym_while] = ACTIONS(2407),
    [anon_sym_if] = ACTIONS(2407),
    [anon_sym_fun] = ACTIONS(2407),
    [anon_sym_DASH_GT] = ACTIONS(2407),
    [anon_sym_try] = ACTIONS(2407),
    [anon_sym_match] = ACTIONS(2407),
    [anon_sym_match_BANG] = ACTIONS(2409),
    [anon_sym_function] = ACTIONS(2407),
    [anon_sym_LT_DASH] = ACTIONS(2407),
    [anon_sym_DOT_LBRACK] = ACTIONS(2409),
    [anon_sym_LT] = ACTIONS(2409),
    [anon_sym_GT] = ACTIONS(2407),
    [anon_sym_use] = ACTIONS(2407),
    [anon_sym_use_BANG] = ACTIONS(2409),
    [anon_sym_do_BANG] = ACTIONS(2409),
    [anon_sym_begin] = ACTIONS(2407),
    [anon_sym_LPAREN2] = ACTIONS(2407),
    [anon_sym_STAR] = ACTIONS(3218),
    [anon_sym_LT2] = ACTIONS(2407),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2409),
    [anon_sym_or] = ACTIONS(2407),
    [aux_sym_char_token1] = ACTIONS(2409),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2407),
    [anon_sym_DQUOTE] = ACTIONS(2407),
    [anon_sym_AT_DQUOTE] = ACTIONS(2409),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2409),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2409),
    [sym_bool] = ACTIONS(2407),
    [sym_unit] = ACTIONS(2409),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2407),
    [sym_op_identifier] = ACTIONS(2407),
    [anon_sym_PLUS] = ACTIONS(2407),
    [anon_sym_DASH] = ACTIONS(2407),
    [anon_sym_PLUS_DOT] = ACTIONS(2407),
    [anon_sym_DASH_DOT] = ACTIONS(2407),
    [anon_sym_PERCENT] = ACTIONS(2407),
    [anon_sym_AMP_AMP] = ACTIONS(2407),
    [anon_sym_TILDE] = ACTIONS(2409),
    [aux_sym_prefix_op_token1] = ACTIONS(2407),
    [aux_sym_infix_op_token1] = ACTIONS(2409),
    [aux_sym_infix_op_token2] = ACTIONS(2407),
    [anon_sym_PIPE_PIPE] = ACTIONS(2407),
    [anon_sym_BANG_EQ] = ACTIONS(2407),
    [anon_sym_COLON_EQ] = ACTIONS(2409),
    [anon_sym_DOLLAR] = ACTIONS(2407),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2407),
    [sym_int] = ACTIONS(2407),
    [sym_xint] = ACTIONS(2409),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2409),
    [sym__newline] = ACTIONS(2409),
  },
  [1250] = {
    [sym_block_comment] = STATE(1250),
    [sym_compiler_directive_decl] = STATE(1250),
    [sym_fsi_directive_decl] = STATE(1250),
    [sym_preproc_line] = STATE(1250),
    [aux_sym_type_argument_repeat1] = STATE(1250),
    [sym_identifier] = ACTIONS(2340),
    [anon_sym_EQ] = ACTIONS(2342),
    [anon_sym_COLON] = ACTIONS(2340),
    [anon_sym_return] = ACTIONS(2340),
    [anon_sym_do] = ACTIONS(2340),
    [anon_sym_let] = ACTIONS(2340),
    [anon_sym_let_BANG] = ACTIONS(2342),
    [anon_sym_LPAREN] = ACTIONS(2340),
    [anon_sym_COMMA] = ACTIONS(2342),
    [anon_sym_null] = ACTIONS(2340),
    [anon_sym_QMARK] = ACTIONS(2340),
    [anon_sym_COLON_QMARK] = ACTIONS(2340),
    [anon_sym_COLON_COLON] = ACTIONS(2342),
    [anon_sym_AMP] = ACTIONS(2340),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2342),
    [anon_sym_LBRACE] = ACTIONS(2340),
    [anon_sym_LT_AT] = ACTIONS(2340),
    [anon_sym_LT_AT_AT] = ACTIONS(2340),
    [anon_sym_AT_AT_GT] = ACTIONS(2340),
    [anon_sym_DOT] = ACTIONS(2340),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2342),
    [anon_sym_new] = ACTIONS(2340),
    [anon_sym_return_BANG] = ACTIONS(2342),
    [anon_sym_yield] = ACTIONS(2340),
    [anon_sym_yield_BANG] = ACTIONS(2342),
    [anon_sym_lazy] = ACTIONS(2340),
    [anon_sym_assert] = ACTIONS(2340),
    [anon_sym_upcast] = ACTIONS(2340),
    [anon_sym_downcast] = ACTIONS(2340),
    [anon_sym_COLON_GT] = ACTIONS(2342),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2342),
    [anon_sym_for] = ACTIONS(2340),
    [anon_sym_while] = ACTIONS(2340),
    [anon_sym_if] = ACTIONS(2340),
    [anon_sym_fun] = ACTIONS(2340),
    [anon_sym_DASH_GT] = ACTIONS(2340),
    [anon_sym_try] = ACTIONS(2340),
    [anon_sym_match] = ACTIONS(2340),
    [anon_sym_match_BANG] = ACTIONS(2342),
    [anon_sym_function] = ACTIONS(2340),
    [anon_sym_LT_DASH] = ACTIONS(2340),
    [anon_sym_DOT_LBRACK] = ACTIONS(2342),
    [anon_sym_LT] = ACTIONS(2342),
    [anon_sym_use] = ACTIONS(2340),
    [anon_sym_use_BANG] = ACTIONS(2342),
    [anon_sym_do_BANG] = ACTIONS(2342),
    [anon_sym_begin] = ACTIONS(2340),
    [anon_sym_LPAREN2] = ACTIONS(2340),
    [anon_sym_STAR] = ACTIONS(2340),
    [anon_sym_LT2] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2342),
    [anon_sym_or] = ACTIONS(3434),
    [aux_sym_char_token1] = ACTIONS(2342),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2340),
    [anon_sym_DQUOTE] = ACTIONS(2340),
    [anon_sym_AT_DQUOTE] = ACTIONS(2342),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2342),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2342),
    [sym_bool] = ACTIONS(2340),
    [sym_unit] = ACTIONS(2342),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2340),
    [sym_op_identifier] = ACTIONS(2340),
    [anon_sym_PLUS] = ACTIONS(2340),
    [anon_sym_DASH] = ACTIONS(2340),
    [anon_sym_PLUS_DOT] = ACTIONS(2340),
    [anon_sym_DASH_DOT] = ACTIONS(2340),
    [anon_sym_PERCENT] = ACTIONS(2340),
    [anon_sym_AMP_AMP] = ACTIONS(2340),
    [anon_sym_TILDE] = ACTIONS(2342),
    [aux_sym_prefix_op_token1] = ACTIONS(2340),
    [aux_sym_infix_op_token1] = ACTIONS(2342),
    [aux_sym_infix_op_token2] = ACTIONS(2340),
    [anon_sym_PIPE_PIPE] = ACTIONS(2340),
    [anon_sym_BANG_EQ] = ACTIONS(2340),
    [anon_sym_COLON_EQ] = ACTIONS(2342),
    [anon_sym_DOLLAR] = ACTIONS(2340),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2340),
    [sym_int] = ACTIONS(2340),
    [sym_xint] = ACTIONS(2342),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2342),
    [sym__newline] = ACTIONS(2342),
  },
  [1251] = {
    [sym__else_expression] = STATE(2286),
    [sym_elif_expression] = STATE(1495),
    [sym_block_comment] = STATE(1251),
    [sym_compiler_directive_decl] = STATE(1251),
    [sym_fsi_directive_decl] = STATE(1251),
    [sym_preproc_line] = STATE(1251),
    [aux_sym_if_expression_repeat1] = STATE(1328),
    [sym_identifier] = ACTIONS(2332),
    [anon_sym_EQ] = ACTIONS(2334),
    [anon_sym_COLON] = ACTIONS(2332),
    [anon_sym_return] = ACTIONS(2332),
    [anon_sym_do] = ACTIONS(2332),
    [anon_sym_let] = ACTIONS(2332),
    [anon_sym_let_BANG] = ACTIONS(2334),
    [anon_sym_LPAREN] = ACTIONS(2332),
    [anon_sym_COMMA] = ACTIONS(2334),
    [anon_sym_null] = ACTIONS(2332),
    [anon_sym_QMARK] = ACTIONS(2332),
    [anon_sym_COLON_QMARK] = ACTIONS(2332),
    [anon_sym_COLON_COLON] = ACTIONS(2334),
    [anon_sym_AMP] = ACTIONS(2332),
    [anon_sym_LBRACK] = ACTIONS(2332),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2334),
    [anon_sym_LBRACE] = ACTIONS(2332),
    [anon_sym_LT_AT] = ACTIONS(2332),
    [anon_sym_LT_AT_AT] = ACTIONS(2332),
    [anon_sym_AT_AT_GT] = ACTIONS(2332),
    [anon_sym_DOT] = ACTIONS(2332),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2334),
    [anon_sym_new] = ACTIONS(2332),
    [anon_sym_return_BANG] = ACTIONS(2334),
    [anon_sym_yield] = ACTIONS(2332),
    [anon_sym_yield_BANG] = ACTIONS(2334),
    [anon_sym_lazy] = ACTIONS(2332),
    [anon_sym_assert] = ACTIONS(2332),
    [anon_sym_upcast] = ACTIONS(2332),
    [anon_sym_downcast] = ACTIONS(2332),
    [anon_sym_COLON_GT] = ACTIONS(2334),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2334),
    [anon_sym_for] = ACTIONS(2332),
    [anon_sym_while] = ACTIONS(2332),
    [anon_sym_else] = ACTIONS(3437),
    [anon_sym_elif] = ACTIONS(3439),
    [anon_sym_if] = ACTIONS(2332),
    [anon_sym_fun] = ACTIONS(2332),
    [anon_sym_try] = ACTIONS(2332),
    [anon_sym_match] = ACTIONS(2332),
    [anon_sym_match_BANG] = ACTIONS(2334),
    [anon_sym_function] = ACTIONS(2332),
    [anon_sym_LT_DASH] = ACTIONS(2332),
    [anon_sym_DOT_LBRACK] = ACTIONS(2334),
    [anon_sym_LT] = ACTIONS(2334),
    [anon_sym_use] = ACTIONS(2332),
    [anon_sym_use_BANG] = ACTIONS(2334),
    [anon_sym_do_BANG] = ACTIONS(2334),
    [anon_sym_begin] = ACTIONS(2332),
    [anon_sym_LPAREN2] = ACTIONS(2332),
    [anon_sym_or] = ACTIONS(2332),
    [aux_sym_char_token1] = ACTIONS(2334),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2332),
    [anon_sym_DQUOTE] = ACTIONS(2332),
    [anon_sym_AT_DQUOTE] = ACTIONS(2334),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2334),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2334),
    [sym_bool] = ACTIONS(2332),
    [sym_unit] = ACTIONS(2334),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2332),
    [sym_op_identifier] = ACTIONS(2332),
    [anon_sym_PLUS] = ACTIONS(2332),
    [anon_sym_DASH] = ACTIONS(2332),
    [anon_sym_PLUS_DOT] = ACTIONS(2332),
    [anon_sym_DASH_DOT] = ACTIONS(2332),
    [anon_sym_PERCENT] = ACTIONS(2332),
    [anon_sym_AMP_AMP] = ACTIONS(2332),
    [anon_sym_TILDE] = ACTIONS(2334),
    [aux_sym_prefix_op_token1] = ACTIONS(2332),
    [aux_sym_infix_op_token1] = ACTIONS(2334),
    [aux_sym_infix_op_token2] = ACTIONS(2332),
    [anon_sym_PIPE_PIPE] = ACTIONS(2332),
    [anon_sym_BANG_EQ] = ACTIONS(2332),
    [anon_sym_COLON_EQ] = ACTIONS(2334),
    [anon_sym_DOLLAR] = ACTIONS(2332),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2332),
    [sym_int] = ACTIONS(2332),
    [sym_xint] = ACTIONS(2334),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2334),
    [sym__newline] = ACTIONS(2334),
  },
  [1252] = {
    [sym_block_comment] = STATE(1252),
    [sym_compiler_directive_decl] = STATE(1252),
    [sym_fsi_directive_decl] = STATE(1252),
    [sym_preproc_line] = STATE(1252),
    [aux_sym_type_argument_repeat1] = STATE(1252),
    [sym_identifier] = ACTIONS(2340),
    [anon_sym_EQ] = ACTIONS(2342),
    [anon_sym_COLON] = ACTIONS(2340),
    [anon_sym_return] = ACTIONS(2340),
    [anon_sym_do] = ACTIONS(2340),
    [anon_sym_let] = ACTIONS(2340),
    [anon_sym_let_BANG] = ACTIONS(2342),
    [anon_sym_LPAREN] = ACTIONS(2340),
    [anon_sym_COMMA] = ACTIONS(2342),
    [anon_sym_null] = ACTIONS(2340),
    [anon_sym_QMARK] = ACTIONS(2340),
    [anon_sym_COLON_QMARK] = ACTIONS(2340),
    [anon_sym_COLON_COLON] = ACTIONS(2342),
    [anon_sym_AMP] = ACTIONS(2340),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2342),
    [anon_sym_LBRACE] = ACTIONS(2340),
    [anon_sym_LT_AT] = ACTIONS(2340),
    [anon_sym_LT_AT_AT] = ACTIONS(2340),
    [anon_sym_DOT] = ACTIONS(2340),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2342),
    [anon_sym_new] = ACTIONS(2340),
    [anon_sym_return_BANG] = ACTIONS(2342),
    [anon_sym_yield] = ACTIONS(2340),
    [anon_sym_yield_BANG] = ACTIONS(2342),
    [anon_sym_lazy] = ACTIONS(2340),
    [anon_sym_assert] = ACTIONS(2340),
    [anon_sym_upcast] = ACTIONS(2340),
    [anon_sym_downcast] = ACTIONS(2340),
    [anon_sym_COLON_GT] = ACTIONS(2342),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2342),
    [anon_sym_for] = ACTIONS(2340),
    [anon_sym_while] = ACTIONS(2340),
    [anon_sym_if] = ACTIONS(2340),
    [anon_sym_fun] = ACTIONS(2340),
    [anon_sym_DASH_GT] = ACTIONS(2340),
    [anon_sym_try] = ACTIONS(2340),
    [anon_sym_match] = ACTIONS(2340),
    [anon_sym_match_BANG] = ACTIONS(2342),
    [anon_sym_function] = ACTIONS(2340),
    [anon_sym_LT_DASH] = ACTIONS(2340),
    [anon_sym_DOT_LBRACK] = ACTIONS(2342),
    [anon_sym_LT] = ACTIONS(2342),
    [anon_sym_GT] = ACTIONS(2340),
    [anon_sym_use] = ACTIONS(2340),
    [anon_sym_use_BANG] = ACTIONS(2342),
    [anon_sym_do_BANG] = ACTIONS(2342),
    [anon_sym_begin] = ACTIONS(2340),
    [anon_sym_LPAREN2] = ACTIONS(2340),
    [anon_sym_STAR] = ACTIONS(2340),
    [anon_sym_LT2] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2342),
    [anon_sym_or] = ACTIONS(3441),
    [aux_sym_char_token1] = ACTIONS(2342),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2340),
    [anon_sym_DQUOTE] = ACTIONS(2340),
    [anon_sym_AT_DQUOTE] = ACTIONS(2342),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2342),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2342),
    [sym_bool] = ACTIONS(2340),
    [sym_unit] = ACTIONS(2342),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2340),
    [sym_op_identifier] = ACTIONS(2340),
    [anon_sym_PLUS] = ACTIONS(2340),
    [anon_sym_DASH] = ACTIONS(2340),
    [anon_sym_PLUS_DOT] = ACTIONS(2340),
    [anon_sym_DASH_DOT] = ACTIONS(2340),
    [anon_sym_PERCENT] = ACTIONS(2340),
    [anon_sym_AMP_AMP] = ACTIONS(2340),
    [anon_sym_TILDE] = ACTIONS(2342),
    [aux_sym_prefix_op_token1] = ACTIONS(2340),
    [aux_sym_infix_op_token1] = ACTIONS(2342),
    [aux_sym_infix_op_token2] = ACTIONS(2340),
    [anon_sym_PIPE_PIPE] = ACTIONS(2340),
    [anon_sym_BANG_EQ] = ACTIONS(2340),
    [anon_sym_COLON_EQ] = ACTIONS(2342),
    [anon_sym_DOLLAR] = ACTIONS(2340),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2340),
    [sym_int] = ACTIONS(2340),
    [sym_xint] = ACTIONS(2342),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2342),
    [sym__newline] = ACTIONS(2342),
  },
  [1253] = {
    [sym__else_expression] = STATE(2214),
    [sym_elif_expression] = STATE(1668),
    [sym_block_comment] = STATE(1253),
    [sym_compiler_directive_decl] = STATE(1253),
    [sym_fsi_directive_decl] = STATE(1253),
    [sym_preproc_line] = STATE(1253),
    [aux_sym_if_expression_repeat1] = STATE(1288),
    [sym_identifier] = ACTIONS(2332),
    [anon_sym_EQ] = ACTIONS(2334),
    [anon_sym_COLON] = ACTIONS(2332),
    [anon_sym_return] = ACTIONS(2332),
    [anon_sym_do] = ACTIONS(2332),
    [anon_sym_let] = ACTIONS(2332),
    [anon_sym_let_BANG] = ACTIONS(2334),
    [anon_sym_LPAREN] = ACTIONS(2332),
    [anon_sym_COMMA] = ACTIONS(2334),
    [anon_sym_null] = ACTIONS(2332),
    [anon_sym_QMARK] = ACTIONS(2332),
    [anon_sym_COLON_QMARK] = ACTIONS(2332),
    [anon_sym_COLON_COLON] = ACTIONS(2334),
    [anon_sym_AMP] = ACTIONS(2332),
    [anon_sym_LBRACK] = ACTIONS(2332),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2334),
    [anon_sym_LBRACE] = ACTIONS(2332),
    [anon_sym_LT_AT] = ACTIONS(2332),
    [anon_sym_LT_AT_AT] = ACTIONS(2332),
    [anon_sym_DOT] = ACTIONS(2332),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2334),
    [anon_sym_new] = ACTIONS(2332),
    [anon_sym_return_BANG] = ACTIONS(2334),
    [anon_sym_yield] = ACTIONS(2332),
    [anon_sym_yield_BANG] = ACTIONS(2334),
    [anon_sym_lazy] = ACTIONS(2332),
    [anon_sym_assert] = ACTIONS(2332),
    [anon_sym_upcast] = ACTIONS(2332),
    [anon_sym_downcast] = ACTIONS(2332),
    [anon_sym_COLON_GT] = ACTIONS(2334),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2334),
    [anon_sym_for] = ACTIONS(2332),
    [anon_sym_while] = ACTIONS(2332),
    [anon_sym_else] = ACTIONS(3444),
    [anon_sym_elif] = ACTIONS(3446),
    [anon_sym_if] = ACTIONS(2332),
    [anon_sym_fun] = ACTIONS(2332),
    [anon_sym_try] = ACTIONS(2332),
    [anon_sym_match] = ACTIONS(2332),
    [anon_sym_match_BANG] = ACTIONS(2334),
    [anon_sym_function] = ACTIONS(2332),
    [anon_sym_LT_DASH] = ACTIONS(2332),
    [anon_sym_DOT_LBRACK] = ACTIONS(2334),
    [anon_sym_LT] = ACTIONS(2334),
    [anon_sym_GT] = ACTIONS(2332),
    [anon_sym_use] = ACTIONS(2332),
    [anon_sym_use_BANG] = ACTIONS(2334),
    [anon_sym_do_BANG] = ACTIONS(2334),
    [anon_sym_begin] = ACTIONS(2332),
    [anon_sym_LPAREN2] = ACTIONS(2332),
    [anon_sym_or] = ACTIONS(2332),
    [aux_sym_char_token1] = ACTIONS(2334),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2332),
    [anon_sym_DQUOTE] = ACTIONS(2332),
    [anon_sym_AT_DQUOTE] = ACTIONS(2334),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2334),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2334),
    [sym_bool] = ACTIONS(2332),
    [sym_unit] = ACTIONS(2334),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2332),
    [sym_op_identifier] = ACTIONS(2332),
    [anon_sym_PLUS] = ACTIONS(2332),
    [anon_sym_DASH] = ACTIONS(2332),
    [anon_sym_PLUS_DOT] = ACTIONS(2332),
    [anon_sym_DASH_DOT] = ACTIONS(2332),
    [anon_sym_PERCENT] = ACTIONS(2332),
    [anon_sym_AMP_AMP] = ACTIONS(2332),
    [anon_sym_TILDE] = ACTIONS(2334),
    [aux_sym_prefix_op_token1] = ACTIONS(2332),
    [aux_sym_infix_op_token1] = ACTIONS(2334),
    [aux_sym_infix_op_token2] = ACTIONS(2332),
    [anon_sym_PIPE_PIPE] = ACTIONS(2332),
    [anon_sym_BANG_EQ] = ACTIONS(2332),
    [anon_sym_COLON_EQ] = ACTIONS(2334),
    [anon_sym_DOLLAR] = ACTIONS(2332),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2332),
    [sym_int] = ACTIONS(2332),
    [sym_xint] = ACTIONS(2334),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2334),
    [sym__newline] = ACTIONS(2334),
  },
  [1254] = {
    [sym_block_comment] = STATE(1254),
    [sym_compiler_directive_decl] = STATE(1254),
    [sym_fsi_directive_decl] = STATE(1254),
    [sym_preproc_line] = STATE(1254),
    [aux_sym_compound_type_repeat1] = STATE(1254),
    [sym_identifier] = ACTIONS(2250),
    [anon_sym_EQ] = ACTIONS(2248),
    [anon_sym_COLON] = ACTIONS(2250),
    [anon_sym_return] = ACTIONS(2250),
    [anon_sym_do] = ACTIONS(2250),
    [anon_sym_let] = ACTIONS(2250),
    [anon_sym_let_BANG] = ACTIONS(2248),
    [anon_sym_LPAREN] = ACTIONS(2250),
    [anon_sym_COMMA] = ACTIONS(2248),
    [anon_sym_null] = ACTIONS(2250),
    [anon_sym_QMARK] = ACTIONS(2250),
    [anon_sym_COLON_QMARK] = ACTIONS(2250),
    [anon_sym_COLON_COLON] = ACTIONS(2248),
    [anon_sym_AMP] = ACTIONS(2250),
    [anon_sym_LBRACK] = ACTIONS(2250),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2248),
    [anon_sym_LBRACE] = ACTIONS(2250),
    [anon_sym_LT_AT] = ACTIONS(2250),
    [anon_sym_LT_AT_AT] = ACTIONS(2250),
    [anon_sym_DOT] = ACTIONS(2250),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2248),
    [anon_sym_new] = ACTIONS(2250),
    [anon_sym_return_BANG] = ACTIONS(2248),
    [anon_sym_yield] = ACTIONS(2250),
    [anon_sym_yield_BANG] = ACTIONS(2248),
    [anon_sym_lazy] = ACTIONS(2250),
    [anon_sym_assert] = ACTIONS(2250),
    [anon_sym_upcast] = ACTIONS(2250),
    [anon_sym_downcast] = ACTIONS(2250),
    [anon_sym_COLON_GT] = ACTIONS(2248),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2248),
    [anon_sym_for] = ACTIONS(2250),
    [anon_sym_while] = ACTIONS(2250),
    [anon_sym_if] = ACTIONS(2250),
    [anon_sym_fun] = ACTIONS(2250),
    [anon_sym_DASH_GT] = ACTIONS(2250),
    [anon_sym_try] = ACTIONS(2250),
    [anon_sym_match] = ACTIONS(2250),
    [anon_sym_match_BANG] = ACTIONS(2248),
    [anon_sym_function] = ACTIONS(2250),
    [anon_sym_LT_DASH] = ACTIONS(2250),
    [anon_sym_DOT_LBRACK] = ACTIONS(2248),
    [anon_sym_LT] = ACTIONS(2248),
    [anon_sym_use] = ACTIONS(2250),
    [anon_sym_use_BANG] = ACTIONS(2248),
    [anon_sym_do_BANG] = ACTIONS(2248),
    [anon_sym_begin] = ACTIONS(2250),
    [anon_sym_LPAREN2] = ACTIONS(2250),
    [anon_sym_STAR] = ACTIONS(3448),
    [anon_sym_LT2] = ACTIONS(2250),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2248),
    [anon_sym_or] = ACTIONS(2250),
    [aux_sym_char_token1] = ACTIONS(2248),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2250),
    [anon_sym_DQUOTE] = ACTIONS(2250),
    [anon_sym_AT_DQUOTE] = ACTIONS(2248),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2248),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2248),
    [sym_bool] = ACTIONS(2250),
    [sym_unit] = ACTIONS(2248),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2250),
    [sym_op_identifier] = ACTIONS(2250),
    [anon_sym_PLUS] = ACTIONS(2250),
    [anon_sym_DASH] = ACTIONS(2250),
    [anon_sym_PLUS_DOT] = ACTIONS(2250),
    [anon_sym_DASH_DOT] = ACTIONS(2250),
    [anon_sym_PERCENT] = ACTIONS(2250),
    [anon_sym_AMP_AMP] = ACTIONS(2250),
    [anon_sym_TILDE] = ACTIONS(2248),
    [aux_sym_prefix_op_token1] = ACTIONS(2250),
    [aux_sym_infix_op_token1] = ACTIONS(2248),
    [aux_sym_infix_op_token2] = ACTIONS(2250),
    [anon_sym_PIPE_PIPE] = ACTIONS(2250),
    [anon_sym_BANG_EQ] = ACTIONS(2250),
    [anon_sym_COLON_EQ] = ACTIONS(2248),
    [anon_sym_DOLLAR] = ACTIONS(2250),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2250),
    [sym_int] = ACTIONS(2250),
    [sym_xint] = ACTIONS(2248),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2248),
    [anon_sym_POUNDendif] = ACTIONS(2248),
    [sym__newline] = ACTIONS(2248),
  },
  [1255] = {
    [sym_block_comment] = STATE(1255),
    [sym_compiler_directive_decl] = STATE(1255),
    [sym_fsi_directive_decl] = STATE(1255),
    [sym_preproc_line] = STATE(1255),
    [sym_identifier] = ACTIONS(2627),
    [anon_sym_EQ] = ACTIONS(2629),
    [anon_sym_COLON] = ACTIONS(2627),
    [anon_sym_return] = ACTIONS(2627),
    [anon_sym_do] = ACTIONS(2627),
    [anon_sym_and] = ACTIONS(2627),
    [anon_sym_let] = ACTIONS(2627),
    [anon_sym_let_BANG] = ACTIONS(2629),
    [anon_sym_LPAREN] = ACTIONS(2627),
    [anon_sym_COMMA] = ACTIONS(2629),
    [anon_sym_null] = ACTIONS(2627),
    [anon_sym_QMARK] = ACTIONS(2627),
    [anon_sym_COLON_QMARK] = ACTIONS(2627),
    [anon_sym_COLON_COLON] = ACTIONS(2629),
    [anon_sym_AMP] = ACTIONS(2627),
    [anon_sym_LBRACK] = ACTIONS(2627),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2629),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_LT_AT] = ACTIONS(2627),
    [anon_sym_LT_AT_AT] = ACTIONS(2627),
    [anon_sym_DOT] = ACTIONS(2627),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2629),
    [anon_sym_new] = ACTIONS(2627),
    [anon_sym_return_BANG] = ACTIONS(2629),
    [anon_sym_yield] = ACTIONS(2627),
    [anon_sym_yield_BANG] = ACTIONS(2629),
    [anon_sym_lazy] = ACTIONS(2627),
    [anon_sym_assert] = ACTIONS(2627),
    [anon_sym_upcast] = ACTIONS(2627),
    [anon_sym_downcast] = ACTIONS(2627),
    [anon_sym_COLON_GT] = ACTIONS(2629),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2629),
    [anon_sym_for] = ACTIONS(2627),
    [anon_sym_while] = ACTIONS(2627),
    [anon_sym_if] = ACTIONS(2627),
    [anon_sym_fun] = ACTIONS(2627),
    [anon_sym_DASH_GT] = ACTIONS(2627),
    [anon_sym_try] = ACTIONS(2627),
    [anon_sym_match] = ACTIONS(2627),
    [anon_sym_match_BANG] = ACTIONS(2629),
    [anon_sym_function] = ACTIONS(2627),
    [anon_sym_LT_DASH] = ACTIONS(2627),
    [anon_sym_DOT_LBRACK] = ACTIONS(2629),
    [anon_sym_LT] = ACTIONS(2629),
    [anon_sym_use] = ACTIONS(2627),
    [anon_sym_use_BANG] = ACTIONS(2629),
    [anon_sym_do_BANG] = ACTIONS(2629),
    [anon_sym_begin] = ACTIONS(2627),
    [anon_sym_LPAREN2] = ACTIONS(2627),
    [anon_sym_STAR] = ACTIONS(2627),
    [anon_sym_LT2] = ACTIONS(2627),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2629),
    [anon_sym_or] = ACTIONS(2627),
    [aux_sym_char_token1] = ACTIONS(2629),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2627),
    [anon_sym_DQUOTE] = ACTIONS(2627),
    [anon_sym_AT_DQUOTE] = ACTIONS(2629),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2629),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2629),
    [sym_bool] = ACTIONS(2627),
    [sym_unit] = ACTIONS(2629),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2627),
    [sym_op_identifier] = ACTIONS(2627),
    [anon_sym_PLUS] = ACTIONS(2627),
    [anon_sym_DASH] = ACTIONS(2627),
    [anon_sym_PLUS_DOT] = ACTIONS(2627),
    [anon_sym_DASH_DOT] = ACTIONS(2627),
    [anon_sym_PERCENT] = ACTIONS(2627),
    [anon_sym_AMP_AMP] = ACTIONS(2627),
    [anon_sym_TILDE] = ACTIONS(2629),
    [aux_sym_prefix_op_token1] = ACTIONS(2627),
    [aux_sym_infix_op_token1] = ACTIONS(2629),
    [aux_sym_infix_op_token2] = ACTIONS(2627),
    [anon_sym_PIPE_PIPE] = ACTIONS(2627),
    [anon_sym_BANG_EQ] = ACTIONS(2627),
    [anon_sym_COLON_EQ] = ACTIONS(2629),
    [anon_sym_DOLLAR] = ACTIONS(2627),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2627),
    [sym_int] = ACTIONS(2627),
    [sym_xint] = ACTIONS(2629),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2629),
    [sym__newline] = ACTIONS(2629),
    [sym__dedent] = ACTIONS(2629),
  },
  [1256] = {
    [sym_block_comment] = STATE(1256),
    [sym_compiler_directive_decl] = STATE(1256),
    [sym_fsi_directive_decl] = STATE(1256),
    [sym_preproc_line] = STATE(1256),
    [sym_identifier] = ACTIONS(2466),
    [anon_sym_EQ] = ACTIONS(2468),
    [anon_sym_COLON] = ACTIONS(2466),
    [anon_sym_return] = ACTIONS(2466),
    [anon_sym_do] = ACTIONS(2466),
    [anon_sym_and] = ACTIONS(2466),
    [anon_sym_let] = ACTIONS(2466),
    [anon_sym_let_BANG] = ACTIONS(2468),
    [anon_sym_LPAREN] = ACTIONS(2466),
    [anon_sym_COMMA] = ACTIONS(2468),
    [anon_sym_null] = ACTIONS(2466),
    [anon_sym_QMARK] = ACTIONS(2466),
    [anon_sym_COLON_QMARK] = ACTIONS(2466),
    [anon_sym_COLON_COLON] = ACTIONS(2468),
    [anon_sym_AMP] = ACTIONS(2466),
    [anon_sym_LBRACK] = ACTIONS(2466),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2468),
    [anon_sym_LBRACE] = ACTIONS(2466),
    [anon_sym_LT_AT] = ACTIONS(2466),
    [anon_sym_LT_AT_AT] = ACTIONS(2466),
    [anon_sym_DOT] = ACTIONS(2466),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2468),
    [anon_sym_new] = ACTIONS(2466),
    [anon_sym_return_BANG] = ACTIONS(2468),
    [anon_sym_yield] = ACTIONS(2466),
    [anon_sym_yield_BANG] = ACTIONS(2468),
    [anon_sym_lazy] = ACTIONS(2466),
    [anon_sym_assert] = ACTIONS(2466),
    [anon_sym_upcast] = ACTIONS(2466),
    [anon_sym_downcast] = ACTIONS(2466),
    [anon_sym_COLON_GT] = ACTIONS(2468),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2468),
    [anon_sym_for] = ACTIONS(2466),
    [anon_sym_while] = ACTIONS(2466),
    [anon_sym_if] = ACTIONS(2466),
    [anon_sym_fun] = ACTIONS(2466),
    [anon_sym_DASH_GT] = ACTIONS(2466),
    [anon_sym_try] = ACTIONS(2466),
    [anon_sym_match] = ACTIONS(2466),
    [anon_sym_match_BANG] = ACTIONS(2468),
    [anon_sym_function] = ACTIONS(2466),
    [anon_sym_LT_DASH] = ACTIONS(2466),
    [anon_sym_DOT_LBRACK] = ACTIONS(2468),
    [anon_sym_LT] = ACTIONS(2468),
    [anon_sym_use] = ACTIONS(2466),
    [anon_sym_use_BANG] = ACTIONS(2468),
    [anon_sym_do_BANG] = ACTIONS(2468),
    [anon_sym_begin] = ACTIONS(2466),
    [anon_sym_LPAREN2] = ACTIONS(2466),
    [anon_sym_STAR] = ACTIONS(2466),
    [anon_sym_LT2] = ACTIONS(2466),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2468),
    [anon_sym_or] = ACTIONS(2466),
    [aux_sym_char_token1] = ACTIONS(2468),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2466),
    [anon_sym_DQUOTE] = ACTIONS(2466),
    [anon_sym_AT_DQUOTE] = ACTIONS(2468),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2468),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2468),
    [sym_bool] = ACTIONS(2466),
    [sym_unit] = ACTIONS(2468),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2466),
    [sym_op_identifier] = ACTIONS(2466),
    [anon_sym_PLUS] = ACTIONS(2466),
    [anon_sym_DASH] = ACTIONS(2466),
    [anon_sym_PLUS_DOT] = ACTIONS(2466),
    [anon_sym_DASH_DOT] = ACTIONS(2466),
    [anon_sym_PERCENT] = ACTIONS(2466),
    [anon_sym_AMP_AMP] = ACTIONS(2466),
    [anon_sym_TILDE] = ACTIONS(2468),
    [aux_sym_prefix_op_token1] = ACTIONS(2466),
    [aux_sym_infix_op_token1] = ACTIONS(2468),
    [aux_sym_infix_op_token2] = ACTIONS(2466),
    [anon_sym_PIPE_PIPE] = ACTIONS(2466),
    [anon_sym_BANG_EQ] = ACTIONS(2466),
    [anon_sym_COLON_EQ] = ACTIONS(2468),
    [anon_sym_DOLLAR] = ACTIONS(2466),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2466),
    [sym_int] = ACTIONS(2466),
    [sym_xint] = ACTIONS(2468),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2468),
    [sym__newline] = ACTIONS(2468),
    [sym__dedent] = ACTIONS(2468),
  },
  [1257] = {
    [sym_block_comment] = STATE(1257),
    [sym_compiler_directive_decl] = STATE(1257),
    [sym_fsi_directive_decl] = STATE(1257),
    [sym_preproc_line] = STATE(1257),
    [aux_sym_type_argument_repeat1] = STATE(1193),
    [sym_identifier] = ACTIONS(2321),
    [anon_sym_EQ] = ACTIONS(2323),
    [anon_sym_COLON] = ACTIONS(2321),
    [anon_sym_return] = ACTIONS(2321),
    [anon_sym_do] = ACTIONS(2321),
    [anon_sym_let] = ACTIONS(2321),
    [anon_sym_let_BANG] = ACTIONS(2323),
    [anon_sym_LPAREN] = ACTIONS(2321),
    [anon_sym_COMMA] = ACTIONS(2323),
    [anon_sym_null] = ACTIONS(2321),
    [anon_sym_QMARK] = ACTIONS(2321),
    [anon_sym_COLON_QMARK] = ACTIONS(2321),
    [anon_sym_COLON_COLON] = ACTIONS(2323),
    [anon_sym_AMP] = ACTIONS(2321),
    [anon_sym_LBRACK] = ACTIONS(2321),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2323),
    [anon_sym_LBRACE] = ACTIONS(2321),
    [anon_sym_LT_AT] = ACTIONS(2321),
    [anon_sym_LT_AT_AT] = ACTIONS(2321),
    [anon_sym_AT_AT_GT] = ACTIONS(2321),
    [anon_sym_DOT] = ACTIONS(2321),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2323),
    [anon_sym_new] = ACTIONS(2321),
    [anon_sym_return_BANG] = ACTIONS(2323),
    [anon_sym_yield] = ACTIONS(2321),
    [anon_sym_yield_BANG] = ACTIONS(2323),
    [anon_sym_lazy] = ACTIONS(2321),
    [anon_sym_assert] = ACTIONS(2321),
    [anon_sym_upcast] = ACTIONS(2321),
    [anon_sym_downcast] = ACTIONS(2321),
    [anon_sym_COLON_GT] = ACTIONS(2323),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2323),
    [anon_sym_for] = ACTIONS(2321),
    [anon_sym_while] = ACTIONS(2321),
    [anon_sym_if] = ACTIONS(2321),
    [anon_sym_fun] = ACTIONS(2321),
    [anon_sym_DASH_GT] = ACTIONS(2321),
    [anon_sym_try] = ACTIONS(2321),
    [anon_sym_match] = ACTIONS(2321),
    [anon_sym_match_BANG] = ACTIONS(2323),
    [anon_sym_function] = ACTIONS(2321),
    [anon_sym_LT_DASH] = ACTIONS(2321),
    [anon_sym_DOT_LBRACK] = ACTIONS(2323),
    [anon_sym_LT] = ACTIONS(2323),
    [anon_sym_use] = ACTIONS(2321),
    [anon_sym_use_BANG] = ACTIONS(2323),
    [anon_sym_do_BANG] = ACTIONS(2323),
    [anon_sym_begin] = ACTIONS(2321),
    [anon_sym_LPAREN2] = ACTIONS(2321),
    [anon_sym_STAR] = ACTIONS(2321),
    [anon_sym_LT2] = ACTIONS(2321),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2323),
    [anon_sym_or] = ACTIONS(3451),
    [aux_sym_char_token1] = ACTIONS(2323),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2321),
    [anon_sym_DQUOTE] = ACTIONS(2321),
    [anon_sym_AT_DQUOTE] = ACTIONS(2323),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2323),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2323),
    [sym_bool] = ACTIONS(2321),
    [sym_unit] = ACTIONS(2323),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2321),
    [sym_op_identifier] = ACTIONS(2321),
    [anon_sym_PLUS] = ACTIONS(2321),
    [anon_sym_DASH] = ACTIONS(2321),
    [anon_sym_PLUS_DOT] = ACTIONS(2321),
    [anon_sym_DASH_DOT] = ACTIONS(2321),
    [anon_sym_PERCENT] = ACTIONS(2321),
    [anon_sym_AMP_AMP] = ACTIONS(2321),
    [anon_sym_TILDE] = ACTIONS(2323),
    [aux_sym_prefix_op_token1] = ACTIONS(2321),
    [aux_sym_infix_op_token1] = ACTIONS(2323),
    [aux_sym_infix_op_token2] = ACTIONS(2321),
    [anon_sym_PIPE_PIPE] = ACTIONS(2321),
    [anon_sym_BANG_EQ] = ACTIONS(2321),
    [anon_sym_COLON_EQ] = ACTIONS(2323),
    [anon_sym_DOLLAR] = ACTIONS(2321),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2321),
    [sym_int] = ACTIONS(2321),
    [sym_xint] = ACTIONS(2323),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2323),
    [sym__newline] = ACTIONS(2323),
  },
  [1258] = {
    [sym_block_comment] = STATE(1258),
    [sym_compiler_directive_decl] = STATE(1258),
    [sym_fsi_directive_decl] = STATE(1258),
    [sym_preproc_line] = STATE(1258),
    [sym_identifier] = ACTIONS(2567),
    [anon_sym_EQ] = ACTIONS(2569),
    [anon_sym_COLON] = ACTIONS(2567),
    [anon_sym_return] = ACTIONS(2567),
    [anon_sym_do] = ACTIONS(2567),
    [anon_sym_let] = ACTIONS(2567),
    [anon_sym_let_BANG] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2567),
    [anon_sym_COMMA] = ACTIONS(2569),
    [anon_sym_null] = ACTIONS(2567),
    [anon_sym_QMARK] = ACTIONS(2567),
    [anon_sym_COLON_QMARK] = ACTIONS(2567),
    [anon_sym_COLON_COLON] = ACTIONS(2569),
    [anon_sym_AMP] = ACTIONS(2567),
    [anon_sym_LBRACK] = ACTIONS(2567),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2569),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_LT_AT] = ACTIONS(2567),
    [anon_sym_LT_AT_AT] = ACTIONS(2567),
    [anon_sym_DOT] = ACTIONS(2567),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2569),
    [anon_sym_new] = ACTIONS(2567),
    [anon_sym_return_BANG] = ACTIONS(2569),
    [anon_sym_yield] = ACTIONS(2567),
    [anon_sym_yield_BANG] = ACTIONS(2569),
    [anon_sym_lazy] = ACTIONS(2567),
    [anon_sym_assert] = ACTIONS(2567),
    [anon_sym_upcast] = ACTIONS(2567),
    [anon_sym_downcast] = ACTIONS(2567),
    [anon_sym_COLON_GT] = ACTIONS(2569),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2569),
    [anon_sym_for] = ACTIONS(2567),
    [anon_sym_while] = ACTIONS(2567),
    [anon_sym_if] = ACTIONS(2567),
    [anon_sym_fun] = ACTIONS(2567),
    [anon_sym_DASH_GT] = ACTIONS(2567),
    [anon_sym_try] = ACTIONS(2567),
    [anon_sym_match] = ACTIONS(2567),
    [anon_sym_match_BANG] = ACTIONS(2569),
    [anon_sym_function] = ACTIONS(2567),
    [anon_sym_LT_DASH] = ACTIONS(2567),
    [anon_sym_DOT_LBRACK] = ACTIONS(2569),
    [anon_sym_LT] = ACTIONS(2569),
    [anon_sym_use] = ACTIONS(2567),
    [anon_sym_use_BANG] = ACTIONS(2569),
    [anon_sym_do_BANG] = ACTIONS(2569),
    [anon_sym_begin] = ACTIONS(2567),
    [anon_sym_LPAREN2] = ACTIONS(2567),
    [anon_sym_STAR] = ACTIONS(2567),
    [anon_sym_LT2] = ACTIONS(2567),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2569),
    [anon_sym_or] = ACTIONS(2567),
    [aux_sym_char_token1] = ACTIONS(2569),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2567),
    [anon_sym_DQUOTE] = ACTIONS(2567),
    [anon_sym_AT_DQUOTE] = ACTIONS(2569),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2569),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2569),
    [sym_bool] = ACTIONS(2567),
    [sym_unit] = ACTIONS(2569),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2567),
    [sym_op_identifier] = ACTIONS(2567),
    [anon_sym_PLUS] = ACTIONS(2567),
    [anon_sym_DASH] = ACTIONS(2567),
    [anon_sym_PLUS_DOT] = ACTIONS(2567),
    [anon_sym_DASH_DOT] = ACTIONS(2567),
    [anon_sym_PERCENT] = ACTIONS(2567),
    [anon_sym_AMP_AMP] = ACTIONS(2567),
    [anon_sym_TILDE] = ACTIONS(2569),
    [aux_sym_prefix_op_token1] = ACTIONS(2567),
    [aux_sym_infix_op_token1] = ACTIONS(2569),
    [aux_sym_infix_op_token2] = ACTIONS(2567),
    [anon_sym_PIPE_PIPE] = ACTIONS(2567),
    [anon_sym_BANG_EQ] = ACTIONS(2567),
    [anon_sym_COLON_EQ] = ACTIONS(2569),
    [anon_sym_DOLLAR] = ACTIONS(2567),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2567),
    [sym_int] = ACTIONS(2567),
    [sym_xint] = ACTIONS(2569),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2569),
    [anon_sym_POUNDendif] = ACTIONS(2569),
    [anon_sym_POUNDelse] = ACTIONS(2569),
    [sym__newline] = ACTIONS(2569),
  },
  [1259] = {
    [sym_block_comment] = STATE(1259),
    [sym_compiler_directive_decl] = STATE(1259),
    [sym_fsi_directive_decl] = STATE(1259),
    [sym_preproc_line] = STATE(1259),
    [aux_sym_compound_type_repeat1] = STATE(1254),
    [sym_identifier] = ACTIONS(2407),
    [anon_sym_EQ] = ACTIONS(2409),
    [anon_sym_COLON] = ACTIONS(2407),
    [anon_sym_return] = ACTIONS(2407),
    [anon_sym_do] = ACTIONS(2407),
    [anon_sym_let] = ACTIONS(2407),
    [anon_sym_let_BANG] = ACTIONS(2409),
    [anon_sym_LPAREN] = ACTIONS(2407),
    [anon_sym_COMMA] = ACTIONS(2409),
    [anon_sym_null] = ACTIONS(2407),
    [anon_sym_QMARK] = ACTIONS(2407),
    [anon_sym_COLON_QMARK] = ACTIONS(2407),
    [anon_sym_COLON_COLON] = ACTIONS(2409),
    [anon_sym_AMP] = ACTIONS(2407),
    [anon_sym_LBRACK] = ACTIONS(2407),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2409),
    [anon_sym_LBRACE] = ACTIONS(2407),
    [anon_sym_LT_AT] = ACTIONS(2407),
    [anon_sym_LT_AT_AT] = ACTIONS(2407),
    [anon_sym_DOT] = ACTIONS(2407),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2409),
    [anon_sym_new] = ACTIONS(2407),
    [anon_sym_return_BANG] = ACTIONS(2409),
    [anon_sym_yield] = ACTIONS(2407),
    [anon_sym_yield_BANG] = ACTIONS(2409),
    [anon_sym_lazy] = ACTIONS(2407),
    [anon_sym_assert] = ACTIONS(2407),
    [anon_sym_upcast] = ACTIONS(2407),
    [anon_sym_downcast] = ACTIONS(2407),
    [anon_sym_COLON_GT] = ACTIONS(2409),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2409),
    [anon_sym_for] = ACTIONS(2407),
    [anon_sym_while] = ACTIONS(2407),
    [anon_sym_if] = ACTIONS(2407),
    [anon_sym_fun] = ACTIONS(2407),
    [anon_sym_DASH_GT] = ACTIONS(2407),
    [anon_sym_try] = ACTIONS(2407),
    [anon_sym_match] = ACTIONS(2407),
    [anon_sym_match_BANG] = ACTIONS(2409),
    [anon_sym_function] = ACTIONS(2407),
    [anon_sym_LT_DASH] = ACTIONS(2407),
    [anon_sym_DOT_LBRACK] = ACTIONS(2409),
    [anon_sym_LT] = ACTIONS(2409),
    [anon_sym_use] = ACTIONS(2407),
    [anon_sym_use_BANG] = ACTIONS(2409),
    [anon_sym_do_BANG] = ACTIONS(2409),
    [anon_sym_begin] = ACTIONS(2407),
    [anon_sym_LPAREN2] = ACTIONS(2407),
    [anon_sym_STAR] = ACTIONS(3240),
    [anon_sym_LT2] = ACTIONS(2407),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2409),
    [anon_sym_or] = ACTIONS(2407),
    [aux_sym_char_token1] = ACTIONS(2409),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2407),
    [anon_sym_DQUOTE] = ACTIONS(2407),
    [anon_sym_AT_DQUOTE] = ACTIONS(2409),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2409),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2409),
    [sym_bool] = ACTIONS(2407),
    [sym_unit] = ACTIONS(2409),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2407),
    [sym_op_identifier] = ACTIONS(2407),
    [anon_sym_PLUS] = ACTIONS(2407),
    [anon_sym_DASH] = ACTIONS(2407),
    [anon_sym_PLUS_DOT] = ACTIONS(2407),
    [anon_sym_DASH_DOT] = ACTIONS(2407),
    [anon_sym_PERCENT] = ACTIONS(2407),
    [anon_sym_AMP_AMP] = ACTIONS(2407),
    [anon_sym_TILDE] = ACTIONS(2409),
    [aux_sym_prefix_op_token1] = ACTIONS(2407),
    [aux_sym_infix_op_token1] = ACTIONS(2409),
    [aux_sym_infix_op_token2] = ACTIONS(2407),
    [anon_sym_PIPE_PIPE] = ACTIONS(2407),
    [anon_sym_BANG_EQ] = ACTIONS(2407),
    [anon_sym_COLON_EQ] = ACTIONS(2409),
    [anon_sym_DOLLAR] = ACTIONS(2407),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2407),
    [sym_int] = ACTIONS(2407),
    [sym_xint] = ACTIONS(2409),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2409),
    [anon_sym_POUNDendif] = ACTIONS(2409),
    [sym__newline] = ACTIONS(2409),
  },
  [1260] = {
    [sym_block_comment] = STATE(1260),
    [sym_compiler_directive_decl] = STATE(1260),
    [sym_fsi_directive_decl] = STATE(1260),
    [sym_preproc_line] = STATE(1260),
    [sym_identifier] = ACTIONS(2514),
    [anon_sym_EQ] = ACTIONS(2516),
    [anon_sym_COLON] = ACTIONS(2514),
    [anon_sym_return] = ACTIONS(2514),
    [anon_sym_do] = ACTIONS(2514),
    [anon_sym_let] = ACTIONS(2514),
    [anon_sym_let_BANG] = ACTIONS(2516),
    [anon_sym_LPAREN] = ACTIONS(2514),
    [anon_sym_COMMA] = ACTIONS(2516),
    [anon_sym_null] = ACTIONS(2514),
    [anon_sym_QMARK] = ACTIONS(2514),
    [anon_sym_COLON_QMARK] = ACTIONS(2514),
    [anon_sym_COLON_COLON] = ACTIONS(2516),
    [anon_sym_AMP] = ACTIONS(2514),
    [anon_sym_LBRACK] = ACTIONS(2514),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2516),
    [anon_sym_LBRACE] = ACTIONS(2514),
    [anon_sym_LT_AT] = ACTIONS(2514),
    [anon_sym_LT_AT_AT] = ACTIONS(2514),
    [anon_sym_DOT] = ACTIONS(2514),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2516),
    [anon_sym_new] = ACTIONS(2514),
    [anon_sym_return_BANG] = ACTIONS(2516),
    [anon_sym_yield] = ACTIONS(2514),
    [anon_sym_yield_BANG] = ACTIONS(2516),
    [anon_sym_lazy] = ACTIONS(2514),
    [anon_sym_assert] = ACTIONS(2514),
    [anon_sym_upcast] = ACTIONS(2514),
    [anon_sym_downcast] = ACTIONS(2514),
    [anon_sym_COLON_GT] = ACTIONS(2516),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2516),
    [anon_sym_for] = ACTIONS(2514),
    [anon_sym_while] = ACTIONS(2514),
    [anon_sym_if] = ACTIONS(2514),
    [anon_sym_fun] = ACTIONS(2514),
    [anon_sym_DASH_GT] = ACTIONS(2514),
    [anon_sym_try] = ACTIONS(2514),
    [anon_sym_match] = ACTIONS(2514),
    [anon_sym_match_BANG] = ACTIONS(2516),
    [anon_sym_function] = ACTIONS(2514),
    [anon_sym_LT_DASH] = ACTIONS(2514),
    [anon_sym_DOT_LBRACK] = ACTIONS(2516),
    [anon_sym_LT] = ACTIONS(2516),
    [anon_sym_use] = ACTIONS(2514),
    [anon_sym_use_BANG] = ACTIONS(2516),
    [anon_sym_do_BANG] = ACTIONS(2516),
    [anon_sym_begin] = ACTIONS(2514),
    [anon_sym_LPAREN2] = ACTIONS(2514),
    [anon_sym_STAR] = ACTIONS(2514),
    [anon_sym_LT2] = ACTIONS(2514),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2516),
    [anon_sym_or] = ACTIONS(2514),
    [aux_sym_char_token1] = ACTIONS(2516),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2514),
    [anon_sym_DQUOTE] = ACTIONS(2514),
    [anon_sym_AT_DQUOTE] = ACTIONS(2516),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2516),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2516),
    [sym_bool] = ACTIONS(2514),
    [sym_unit] = ACTIONS(2516),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2514),
    [sym_op_identifier] = ACTIONS(2514),
    [anon_sym_PLUS] = ACTIONS(2514),
    [anon_sym_DASH] = ACTIONS(2514),
    [anon_sym_PLUS_DOT] = ACTIONS(2514),
    [anon_sym_DASH_DOT] = ACTIONS(2514),
    [anon_sym_PERCENT] = ACTIONS(2514),
    [anon_sym_AMP_AMP] = ACTIONS(2514),
    [anon_sym_TILDE] = ACTIONS(2516),
    [aux_sym_prefix_op_token1] = ACTIONS(2514),
    [aux_sym_infix_op_token1] = ACTIONS(2516),
    [aux_sym_infix_op_token2] = ACTIONS(2514),
    [anon_sym_PIPE_PIPE] = ACTIONS(2514),
    [anon_sym_BANG_EQ] = ACTIONS(2514),
    [anon_sym_COLON_EQ] = ACTIONS(2516),
    [anon_sym_DOLLAR] = ACTIONS(2514),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2514),
    [sym_int] = ACTIONS(2514),
    [sym_xint] = ACTIONS(2516),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2516),
    [anon_sym_POUNDendif] = ACTIONS(2516),
    [anon_sym_POUNDelse] = ACTIONS(2516),
    [sym__newline] = ACTIONS(2516),
  },
  [1261] = {
    [sym__else_expression] = STATE(2134),
    [sym_elif_expression] = STATE(1668),
    [sym_block_comment] = STATE(1261),
    [sym_compiler_directive_decl] = STATE(1261),
    [sym_fsi_directive_decl] = STATE(1261),
    [sym_preproc_line] = STATE(1261),
    [aux_sym_if_expression_repeat1] = STATE(1253),
    [sym_identifier] = ACTIONS(2422),
    [anon_sym_EQ] = ACTIONS(2424),
    [anon_sym_COLON] = ACTIONS(2422),
    [anon_sym_return] = ACTIONS(2422),
    [anon_sym_do] = ACTIONS(2422),
    [anon_sym_let] = ACTIONS(2422),
    [anon_sym_let_BANG] = ACTIONS(2424),
    [anon_sym_LPAREN] = ACTIONS(2422),
    [anon_sym_COMMA] = ACTIONS(2424),
    [anon_sym_null] = ACTIONS(2422),
    [anon_sym_QMARK] = ACTIONS(2422),
    [anon_sym_COLON_QMARK] = ACTIONS(2422),
    [anon_sym_COLON_COLON] = ACTIONS(2424),
    [anon_sym_AMP] = ACTIONS(2422),
    [anon_sym_LBRACK] = ACTIONS(2422),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2424),
    [anon_sym_LBRACE] = ACTIONS(2422),
    [anon_sym_LT_AT] = ACTIONS(2422),
    [anon_sym_LT_AT_AT] = ACTIONS(2422),
    [anon_sym_DOT] = ACTIONS(2422),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2424),
    [anon_sym_new] = ACTIONS(2422),
    [anon_sym_return_BANG] = ACTIONS(2424),
    [anon_sym_yield] = ACTIONS(2422),
    [anon_sym_yield_BANG] = ACTIONS(2424),
    [anon_sym_lazy] = ACTIONS(2422),
    [anon_sym_assert] = ACTIONS(2422),
    [anon_sym_upcast] = ACTIONS(2422),
    [anon_sym_downcast] = ACTIONS(2422),
    [anon_sym_COLON_GT] = ACTIONS(2424),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2424),
    [anon_sym_for] = ACTIONS(2422),
    [anon_sym_while] = ACTIONS(2422),
    [anon_sym_else] = ACTIONS(3444),
    [anon_sym_elif] = ACTIONS(3446),
    [anon_sym_if] = ACTIONS(2422),
    [anon_sym_fun] = ACTIONS(2422),
    [anon_sym_try] = ACTIONS(2422),
    [anon_sym_match] = ACTIONS(2422),
    [anon_sym_match_BANG] = ACTIONS(2424),
    [anon_sym_function] = ACTIONS(2422),
    [anon_sym_LT_DASH] = ACTIONS(2422),
    [anon_sym_DOT_LBRACK] = ACTIONS(2424),
    [anon_sym_LT] = ACTIONS(2424),
    [anon_sym_GT] = ACTIONS(2422),
    [anon_sym_use] = ACTIONS(2422),
    [anon_sym_use_BANG] = ACTIONS(2424),
    [anon_sym_do_BANG] = ACTIONS(2424),
    [anon_sym_begin] = ACTIONS(2422),
    [anon_sym_LPAREN2] = ACTIONS(2422),
    [anon_sym_or] = ACTIONS(2422),
    [aux_sym_char_token1] = ACTIONS(2424),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2422),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_AT_DQUOTE] = ACTIONS(2424),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2424),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2424),
    [sym_bool] = ACTIONS(2422),
    [sym_unit] = ACTIONS(2424),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2422),
    [sym_op_identifier] = ACTIONS(2422),
    [anon_sym_PLUS] = ACTIONS(2422),
    [anon_sym_DASH] = ACTIONS(2422),
    [anon_sym_PLUS_DOT] = ACTIONS(2422),
    [anon_sym_DASH_DOT] = ACTIONS(2422),
    [anon_sym_PERCENT] = ACTIONS(2422),
    [anon_sym_AMP_AMP] = ACTIONS(2422),
    [anon_sym_TILDE] = ACTIONS(2424),
    [aux_sym_prefix_op_token1] = ACTIONS(2422),
    [aux_sym_infix_op_token1] = ACTIONS(2424),
    [aux_sym_infix_op_token2] = ACTIONS(2422),
    [anon_sym_PIPE_PIPE] = ACTIONS(2422),
    [anon_sym_BANG_EQ] = ACTIONS(2422),
    [anon_sym_COLON_EQ] = ACTIONS(2424),
    [anon_sym_DOLLAR] = ACTIONS(2422),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2422),
    [sym_int] = ACTIONS(2422),
    [sym_xint] = ACTIONS(2424),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2424),
    [sym__newline] = ACTIONS(2424),
  },
  [1262] = {
    [sym_elif_expression] = STATE(1449),
    [sym_block_comment] = STATE(1262),
    [sym_compiler_directive_decl] = STATE(1262),
    [sym_fsi_directive_decl] = STATE(1262),
    [sym_preproc_line] = STATE(1262),
    [aux_sym_if_expression_repeat1] = STATE(1262),
    [sym_identifier] = ACTIONS(2518),
    [anon_sym_EQ] = ACTIONS(2520),
    [anon_sym_COLON] = ACTIONS(2518),
    [anon_sym_return] = ACTIONS(2518),
    [anon_sym_do] = ACTIONS(2518),
    [anon_sym_let] = ACTIONS(2518),
    [anon_sym_let_BANG] = ACTIONS(2520),
    [anon_sym_LPAREN] = ACTIONS(2518),
    [anon_sym_COMMA] = ACTIONS(2520),
    [anon_sym_null] = ACTIONS(2518),
    [anon_sym_QMARK] = ACTIONS(2518),
    [anon_sym_COLON_QMARK] = ACTIONS(2518),
    [anon_sym_COLON_COLON] = ACTIONS(2520),
    [anon_sym_AMP] = ACTIONS(2518),
    [anon_sym_LBRACK] = ACTIONS(2518),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2520),
    [anon_sym_LBRACE] = ACTIONS(2518),
    [anon_sym_LT_AT] = ACTIONS(2518),
    [anon_sym_LT_AT_AT] = ACTIONS(2518),
    [anon_sym_DOT] = ACTIONS(2518),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2520),
    [anon_sym_new] = ACTIONS(2518),
    [anon_sym_return_BANG] = ACTIONS(2520),
    [anon_sym_yield] = ACTIONS(2518),
    [anon_sym_yield_BANG] = ACTIONS(2520),
    [anon_sym_lazy] = ACTIONS(2518),
    [anon_sym_assert] = ACTIONS(2518),
    [anon_sym_upcast] = ACTIONS(2518),
    [anon_sym_downcast] = ACTIONS(2518),
    [anon_sym_COLON_GT] = ACTIONS(2520),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2520),
    [anon_sym_for] = ACTIONS(2518),
    [anon_sym_while] = ACTIONS(2518),
    [anon_sym_else] = ACTIONS(2518),
    [anon_sym_elif] = ACTIONS(3454),
    [anon_sym_if] = ACTIONS(2518),
    [anon_sym_fun] = ACTIONS(2518),
    [anon_sym_DASH_GT] = ACTIONS(2518),
    [anon_sym_try] = ACTIONS(2518),
    [anon_sym_match] = ACTIONS(2518),
    [anon_sym_match_BANG] = ACTIONS(2520),
    [anon_sym_function] = ACTIONS(2518),
    [anon_sym_LT_DASH] = ACTIONS(2518),
    [anon_sym_DOT_LBRACK] = ACTIONS(2520),
    [anon_sym_LT] = ACTIONS(2520),
    [anon_sym_use] = ACTIONS(2518),
    [anon_sym_use_BANG] = ACTIONS(2520),
    [anon_sym_do_BANG] = ACTIONS(2520),
    [anon_sym_DOT_DOT] = ACTIONS(2520),
    [anon_sym_begin] = ACTIONS(2518),
    [anon_sym_LPAREN2] = ACTIONS(2518),
    [anon_sym_or] = ACTIONS(2518),
    [aux_sym_char_token1] = ACTIONS(2520),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2518),
    [anon_sym_DQUOTE] = ACTIONS(2518),
    [anon_sym_AT_DQUOTE] = ACTIONS(2520),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2520),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2520),
    [sym_bool] = ACTIONS(2518),
    [sym_unit] = ACTIONS(2520),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2518),
    [sym_op_identifier] = ACTIONS(2518),
    [anon_sym_PLUS] = ACTIONS(2518),
    [anon_sym_DASH] = ACTIONS(2518),
    [anon_sym_PLUS_DOT] = ACTIONS(2518),
    [anon_sym_DASH_DOT] = ACTIONS(2518),
    [anon_sym_PERCENT] = ACTIONS(2518),
    [anon_sym_AMP_AMP] = ACTIONS(2518),
    [anon_sym_TILDE] = ACTIONS(2520),
    [aux_sym_prefix_op_token1] = ACTIONS(2518),
    [aux_sym_infix_op_token1] = ACTIONS(2520),
    [aux_sym_infix_op_token2] = ACTIONS(2518),
    [anon_sym_PIPE_PIPE] = ACTIONS(2518),
    [anon_sym_BANG_EQ] = ACTIONS(2518),
    [anon_sym_COLON_EQ] = ACTIONS(2520),
    [anon_sym_DOLLAR] = ACTIONS(2518),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2518),
    [sym_int] = ACTIONS(2518),
    [sym_xint] = ACTIONS(2520),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2520),
    [sym__newline] = ACTIONS(2520),
  },
  [1263] = {
    [sym_block_comment] = STATE(1263),
    [sym_compiler_directive_decl] = STATE(1263),
    [sym_fsi_directive_decl] = STATE(1263),
    [sym_preproc_line] = STATE(1263),
    [sym_identifier] = ACTIONS(2466),
    [anon_sym_EQ] = ACTIONS(2468),
    [anon_sym_COLON] = ACTIONS(2466),
    [anon_sym_return] = ACTIONS(2466),
    [anon_sym_do] = ACTIONS(2466),
    [anon_sym_let] = ACTIONS(2466),
    [anon_sym_let_BANG] = ACTIONS(2468),
    [anon_sym_LPAREN] = ACTIONS(2466),
    [anon_sym_COMMA] = ACTIONS(2468),
    [anon_sym_null] = ACTIONS(2466),
    [anon_sym_QMARK] = ACTIONS(2466),
    [anon_sym_COLON_QMARK] = ACTIONS(2466),
    [anon_sym_COLON_COLON] = ACTIONS(2468),
    [anon_sym_AMP] = ACTIONS(2466),
    [anon_sym_LBRACK] = ACTIONS(2466),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2468),
    [anon_sym_LBRACE] = ACTIONS(2466),
    [anon_sym_LT_AT] = ACTIONS(2466),
    [anon_sym_LT_AT_AT] = ACTIONS(2466),
    [anon_sym_DOT] = ACTIONS(2466),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2468),
    [anon_sym_new] = ACTIONS(2466),
    [anon_sym_return_BANG] = ACTIONS(2468),
    [anon_sym_yield] = ACTIONS(2466),
    [anon_sym_yield_BANG] = ACTIONS(2468),
    [anon_sym_lazy] = ACTIONS(2466),
    [anon_sym_assert] = ACTIONS(2466),
    [anon_sym_upcast] = ACTIONS(2466),
    [anon_sym_downcast] = ACTIONS(2466),
    [anon_sym_COLON_GT] = ACTIONS(2468),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2468),
    [anon_sym_for] = ACTIONS(2466),
    [anon_sym_while] = ACTIONS(2466),
    [anon_sym_if] = ACTIONS(2466),
    [anon_sym_fun] = ACTIONS(2466),
    [anon_sym_DASH_GT] = ACTIONS(2466),
    [anon_sym_try] = ACTIONS(2466),
    [anon_sym_match] = ACTIONS(2466),
    [anon_sym_match_BANG] = ACTIONS(2468),
    [anon_sym_function] = ACTIONS(2466),
    [anon_sym_LT_DASH] = ACTIONS(2466),
    [anon_sym_DOT_LBRACK] = ACTIONS(2468),
    [anon_sym_LT] = ACTIONS(2468),
    [anon_sym_use] = ACTIONS(2466),
    [anon_sym_use_BANG] = ACTIONS(2468),
    [anon_sym_do_BANG] = ACTIONS(2468),
    [anon_sym_begin] = ACTIONS(2466),
    [anon_sym_LPAREN2] = ACTIONS(2466),
    [anon_sym_STAR] = ACTIONS(2466),
    [anon_sym_LT2] = ACTIONS(2466),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2468),
    [anon_sym_or] = ACTIONS(2466),
    [aux_sym_char_token1] = ACTIONS(2468),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2466),
    [anon_sym_DQUOTE] = ACTIONS(2466),
    [anon_sym_AT_DQUOTE] = ACTIONS(2468),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2468),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2468),
    [sym_bool] = ACTIONS(2466),
    [sym_unit] = ACTIONS(2468),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2466),
    [sym_op_identifier] = ACTIONS(2466),
    [anon_sym_PLUS] = ACTIONS(2466),
    [anon_sym_DASH] = ACTIONS(2466),
    [anon_sym_PLUS_DOT] = ACTIONS(2466),
    [anon_sym_DASH_DOT] = ACTIONS(2466),
    [anon_sym_PERCENT] = ACTIONS(2466),
    [anon_sym_AMP_AMP] = ACTIONS(2466),
    [anon_sym_TILDE] = ACTIONS(2468),
    [aux_sym_prefix_op_token1] = ACTIONS(2466),
    [aux_sym_infix_op_token1] = ACTIONS(2468),
    [aux_sym_infix_op_token2] = ACTIONS(2466),
    [anon_sym_PIPE_PIPE] = ACTIONS(2466),
    [anon_sym_BANG_EQ] = ACTIONS(2466),
    [anon_sym_COLON_EQ] = ACTIONS(2468),
    [anon_sym_DOLLAR] = ACTIONS(2466),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2466),
    [sym_int] = ACTIONS(2466),
    [sym_xint] = ACTIONS(2468),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2468),
    [anon_sym_POUNDendif] = ACTIONS(2468),
    [anon_sym_POUNDelse] = ACTIONS(2468),
    [sym__newline] = ACTIONS(2468),
  },
  [1264] = {
    [sym_elif_expression] = STATE(1451),
    [sym_block_comment] = STATE(1264),
    [sym_compiler_directive_decl] = STATE(1264),
    [sym_fsi_directive_decl] = STATE(1264),
    [sym_preproc_line] = STATE(1264),
    [aux_sym_if_expression_repeat1] = STATE(1264),
    [sym_identifier] = ACTIONS(2518),
    [anon_sym_EQ] = ACTIONS(2520),
    [anon_sym_COLON] = ACTIONS(2518),
    [anon_sym_return] = ACTIONS(2518),
    [anon_sym_do] = ACTIONS(2518),
    [anon_sym_let] = ACTIONS(2518),
    [anon_sym_let_BANG] = ACTIONS(2520),
    [anon_sym_as] = ACTIONS(2518),
    [anon_sym_LPAREN] = ACTIONS(2518),
    [anon_sym_COMMA] = ACTIONS(2520),
    [anon_sym_null] = ACTIONS(2518),
    [anon_sym_QMARK] = ACTIONS(2518),
    [anon_sym_COLON_QMARK] = ACTIONS(2518),
    [anon_sym_COLON_COLON] = ACTIONS(2520),
    [anon_sym_AMP] = ACTIONS(2518),
    [anon_sym_LBRACK] = ACTIONS(2518),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2520),
    [anon_sym_LBRACE] = ACTIONS(2518),
    [anon_sym_LT_AT] = ACTIONS(2518),
    [anon_sym_LT_AT_AT] = ACTIONS(2518),
    [anon_sym_DOT] = ACTIONS(2518),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2520),
    [anon_sym_new] = ACTIONS(2518),
    [anon_sym_with] = ACTIONS(2518),
    [anon_sym_return_BANG] = ACTIONS(2520),
    [anon_sym_yield] = ACTIONS(2518),
    [anon_sym_yield_BANG] = ACTIONS(2520),
    [anon_sym_lazy] = ACTIONS(2518),
    [anon_sym_assert] = ACTIONS(2518),
    [anon_sym_upcast] = ACTIONS(2518),
    [anon_sym_downcast] = ACTIONS(2518),
    [anon_sym_COLON_GT] = ACTIONS(2520),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2520),
    [anon_sym_for] = ACTIONS(2518),
    [anon_sym_while] = ACTIONS(2518),
    [anon_sym_else] = ACTIONS(2518),
    [anon_sym_elif] = ACTIONS(3457),
    [anon_sym_if] = ACTIONS(2518),
    [anon_sym_fun] = ACTIONS(2518),
    [anon_sym_try] = ACTIONS(2518),
    [anon_sym_match] = ACTIONS(2518),
    [anon_sym_match_BANG] = ACTIONS(2520),
    [anon_sym_function] = ACTIONS(2518),
    [anon_sym_LT_DASH] = ACTIONS(2518),
    [anon_sym_DOT_LBRACK] = ACTIONS(2520),
    [anon_sym_LT] = ACTIONS(2520),
    [anon_sym_use] = ACTIONS(2518),
    [anon_sym_use_BANG] = ACTIONS(2520),
    [anon_sym_do_BANG] = ACTIONS(2520),
    [anon_sym_begin] = ACTIONS(2518),
    [anon_sym_LPAREN2] = ACTIONS(2518),
    [anon_sym_or] = ACTIONS(2518),
    [aux_sym_char_token1] = ACTIONS(2520),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2518),
    [anon_sym_DQUOTE] = ACTIONS(2518),
    [anon_sym_AT_DQUOTE] = ACTIONS(2520),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2520),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2520),
    [sym_bool] = ACTIONS(2518),
    [sym_unit] = ACTIONS(2520),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2518),
    [sym_op_identifier] = ACTIONS(2518),
    [anon_sym_PLUS] = ACTIONS(2518),
    [anon_sym_DASH] = ACTIONS(2518),
    [anon_sym_PLUS_DOT] = ACTIONS(2518),
    [anon_sym_DASH_DOT] = ACTIONS(2518),
    [anon_sym_PERCENT] = ACTIONS(2518),
    [anon_sym_AMP_AMP] = ACTIONS(2518),
    [anon_sym_TILDE] = ACTIONS(2520),
    [aux_sym_prefix_op_token1] = ACTIONS(2518),
    [aux_sym_infix_op_token1] = ACTIONS(2520),
    [aux_sym_infix_op_token2] = ACTIONS(2518),
    [anon_sym_PIPE_PIPE] = ACTIONS(2518),
    [anon_sym_BANG_EQ] = ACTIONS(2518),
    [anon_sym_COLON_EQ] = ACTIONS(2520),
    [anon_sym_DOLLAR] = ACTIONS(2518),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2518),
    [sym_int] = ACTIONS(2518),
    [sym_xint] = ACTIONS(2520),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2520),
    [sym__newline] = ACTIONS(2520),
  },
  [1265] = {
    [sym__else_expression] = STATE(2187),
    [sym_elif_expression] = STATE(1659),
    [sym_block_comment] = STATE(1265),
    [sym_compiler_directive_decl] = STATE(1265),
    [sym_fsi_directive_decl] = STATE(1265),
    [sym_preproc_line] = STATE(1265),
    [aux_sym_if_expression_repeat1] = STATE(1275),
    [sym_identifier] = ACTIONS(2422),
    [anon_sym_EQ] = ACTIONS(2424),
    [anon_sym_COLON] = ACTIONS(2422),
    [anon_sym_return] = ACTIONS(2422),
    [anon_sym_do] = ACTIONS(2422),
    [anon_sym_let] = ACTIONS(2422),
    [anon_sym_let_BANG] = ACTIONS(2424),
    [anon_sym_LPAREN] = ACTIONS(2422),
    [anon_sym_COMMA] = ACTIONS(2424),
    [anon_sym_null] = ACTIONS(2422),
    [anon_sym_QMARK] = ACTIONS(2422),
    [anon_sym_COLON_QMARK] = ACTIONS(2422),
    [anon_sym_COLON_COLON] = ACTIONS(2424),
    [anon_sym_AMP] = ACTIONS(2422),
    [anon_sym_LBRACK] = ACTIONS(2422),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2424),
    [anon_sym_LBRACE] = ACTIONS(2422),
    [anon_sym_LT_AT] = ACTIONS(2422),
    [anon_sym_LT_AT_AT] = ACTIONS(2422),
    [anon_sym_DOT] = ACTIONS(2422),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2424),
    [anon_sym_new] = ACTIONS(2422),
    [anon_sym_return_BANG] = ACTIONS(2424),
    [anon_sym_yield] = ACTIONS(2422),
    [anon_sym_yield_BANG] = ACTIONS(2424),
    [anon_sym_lazy] = ACTIONS(2422),
    [anon_sym_assert] = ACTIONS(2422),
    [anon_sym_upcast] = ACTIONS(2422),
    [anon_sym_downcast] = ACTIONS(2422),
    [anon_sym_COLON_GT] = ACTIONS(2424),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2424),
    [anon_sym_for] = ACTIONS(2422),
    [anon_sym_while] = ACTIONS(2422),
    [anon_sym_else] = ACTIONS(3460),
    [anon_sym_elif] = ACTIONS(3462),
    [anon_sym_if] = ACTIONS(2422),
    [anon_sym_fun] = ACTIONS(2422),
    [anon_sym_try] = ACTIONS(2422),
    [anon_sym_match] = ACTIONS(2422),
    [anon_sym_match_BANG] = ACTIONS(2424),
    [anon_sym_function] = ACTIONS(2422),
    [anon_sym_LT_DASH] = ACTIONS(2422),
    [anon_sym_DOT_LBRACK] = ACTIONS(2424),
    [anon_sym_LT] = ACTIONS(2424),
    [anon_sym_use] = ACTIONS(2422),
    [anon_sym_use_BANG] = ACTIONS(2424),
    [anon_sym_do_BANG] = ACTIONS(2424),
    [anon_sym_DOT_DOT] = ACTIONS(2424),
    [anon_sym_begin] = ACTIONS(2422),
    [anon_sym_LPAREN2] = ACTIONS(2422),
    [anon_sym_or] = ACTIONS(2422),
    [aux_sym_char_token1] = ACTIONS(2424),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2422),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_AT_DQUOTE] = ACTIONS(2424),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2424),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2424),
    [sym_bool] = ACTIONS(2422),
    [sym_unit] = ACTIONS(2424),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2422),
    [sym_op_identifier] = ACTIONS(2422),
    [anon_sym_PLUS] = ACTIONS(2422),
    [anon_sym_DASH] = ACTIONS(2422),
    [anon_sym_PLUS_DOT] = ACTIONS(2422),
    [anon_sym_DASH_DOT] = ACTIONS(2422),
    [anon_sym_PERCENT] = ACTIONS(2422),
    [anon_sym_AMP_AMP] = ACTIONS(2422),
    [anon_sym_TILDE] = ACTIONS(2424),
    [aux_sym_prefix_op_token1] = ACTIONS(2422),
    [aux_sym_infix_op_token1] = ACTIONS(2424),
    [aux_sym_infix_op_token2] = ACTIONS(2422),
    [anon_sym_PIPE_PIPE] = ACTIONS(2422),
    [anon_sym_BANG_EQ] = ACTIONS(2422),
    [anon_sym_COLON_EQ] = ACTIONS(2424),
    [anon_sym_DOLLAR] = ACTIONS(2422),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2422),
    [sym_int] = ACTIONS(2422),
    [sym_xint] = ACTIONS(2424),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2424),
    [sym__newline] = ACTIONS(2424),
  },
  [1266] = {
    [sym_block_comment] = STATE(1266),
    [sym_compiler_directive_decl] = STATE(1266),
    [sym_fsi_directive_decl] = STATE(1266),
    [sym_preproc_line] = STATE(1266),
    [aux_sym_type_argument_repeat1] = STATE(1252),
    [sym_identifier] = ACTIONS(2328),
    [anon_sym_EQ] = ACTIONS(2330),
    [anon_sym_COLON] = ACTIONS(2328),
    [anon_sym_return] = ACTIONS(2328),
    [anon_sym_do] = ACTIONS(2328),
    [anon_sym_let] = ACTIONS(2328),
    [anon_sym_let_BANG] = ACTIONS(2330),
    [anon_sym_LPAREN] = ACTIONS(2328),
    [anon_sym_COMMA] = ACTIONS(2330),
    [anon_sym_null] = ACTIONS(2328),
    [anon_sym_QMARK] = ACTIONS(2328),
    [anon_sym_COLON_QMARK] = ACTIONS(2328),
    [anon_sym_COLON_COLON] = ACTIONS(2330),
    [anon_sym_AMP] = ACTIONS(2328),
    [anon_sym_LBRACK] = ACTIONS(2328),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2330),
    [anon_sym_LBRACE] = ACTIONS(2328),
    [anon_sym_LT_AT] = ACTIONS(2328),
    [anon_sym_LT_AT_AT] = ACTIONS(2328),
    [anon_sym_DOT] = ACTIONS(2328),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2330),
    [anon_sym_new] = ACTIONS(2328),
    [anon_sym_return_BANG] = ACTIONS(2330),
    [anon_sym_yield] = ACTIONS(2328),
    [anon_sym_yield_BANG] = ACTIONS(2330),
    [anon_sym_lazy] = ACTIONS(2328),
    [anon_sym_assert] = ACTIONS(2328),
    [anon_sym_upcast] = ACTIONS(2328),
    [anon_sym_downcast] = ACTIONS(2328),
    [anon_sym_COLON_GT] = ACTIONS(2330),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2330),
    [anon_sym_for] = ACTIONS(2328),
    [anon_sym_while] = ACTIONS(2328),
    [anon_sym_if] = ACTIONS(2328),
    [anon_sym_fun] = ACTIONS(2328),
    [anon_sym_DASH_GT] = ACTIONS(2328),
    [anon_sym_try] = ACTIONS(2328),
    [anon_sym_match] = ACTIONS(2328),
    [anon_sym_match_BANG] = ACTIONS(2330),
    [anon_sym_function] = ACTIONS(2328),
    [anon_sym_LT_DASH] = ACTIONS(2328),
    [anon_sym_DOT_LBRACK] = ACTIONS(2330),
    [anon_sym_LT] = ACTIONS(2330),
    [anon_sym_GT] = ACTIONS(2328),
    [anon_sym_use] = ACTIONS(2328),
    [anon_sym_use_BANG] = ACTIONS(2330),
    [anon_sym_do_BANG] = ACTIONS(2330),
    [anon_sym_begin] = ACTIONS(2328),
    [anon_sym_LPAREN2] = ACTIONS(2328),
    [anon_sym_STAR] = ACTIONS(2328),
    [anon_sym_LT2] = ACTIONS(2328),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2330),
    [anon_sym_or] = ACTIONS(2328),
    [aux_sym_char_token1] = ACTIONS(2330),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2328),
    [anon_sym_DQUOTE] = ACTIONS(2328),
    [anon_sym_AT_DQUOTE] = ACTIONS(2330),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2330),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2330),
    [sym_bool] = ACTIONS(2328),
    [sym_unit] = ACTIONS(2330),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2328),
    [sym_op_identifier] = ACTIONS(2328),
    [anon_sym_PLUS] = ACTIONS(2328),
    [anon_sym_DASH] = ACTIONS(2328),
    [anon_sym_PLUS_DOT] = ACTIONS(2328),
    [anon_sym_DASH_DOT] = ACTIONS(2328),
    [anon_sym_PERCENT] = ACTIONS(2328),
    [anon_sym_AMP_AMP] = ACTIONS(2328),
    [anon_sym_TILDE] = ACTIONS(2330),
    [aux_sym_prefix_op_token1] = ACTIONS(2328),
    [aux_sym_infix_op_token1] = ACTIONS(2330),
    [aux_sym_infix_op_token2] = ACTIONS(2328),
    [anon_sym_PIPE_PIPE] = ACTIONS(2328),
    [anon_sym_BANG_EQ] = ACTIONS(2328),
    [anon_sym_COLON_EQ] = ACTIONS(2330),
    [anon_sym_DOLLAR] = ACTIONS(2328),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2328),
    [sym_int] = ACTIONS(2328),
    [sym_xint] = ACTIONS(2330),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2330),
    [sym__newline] = ACTIONS(2330),
  },
  [1267] = {
    [sym_elif_expression] = STATE(1432),
    [sym_block_comment] = STATE(1267),
    [sym_compiler_directive_decl] = STATE(1267),
    [sym_fsi_directive_decl] = STATE(1267),
    [sym_preproc_line] = STATE(1267),
    [aux_sym_if_expression_repeat1] = STATE(1267),
    [sym_identifier] = ACTIONS(2518),
    [anon_sym_EQ] = ACTIONS(2520),
    [anon_sym_COLON] = ACTIONS(2518),
    [anon_sym_return] = ACTIONS(2518),
    [anon_sym_do] = ACTIONS(2518),
    [anon_sym_and] = ACTIONS(2518),
    [anon_sym_let] = ACTIONS(2518),
    [anon_sym_let_BANG] = ACTIONS(2520),
    [anon_sym_LPAREN] = ACTIONS(2518),
    [anon_sym_COMMA] = ACTIONS(2520),
    [anon_sym_null] = ACTIONS(2518),
    [anon_sym_QMARK] = ACTIONS(2518),
    [anon_sym_COLON_QMARK] = ACTIONS(2518),
    [anon_sym_COLON_COLON] = ACTIONS(2520),
    [anon_sym_AMP] = ACTIONS(2518),
    [anon_sym_LBRACK] = ACTIONS(2518),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2520),
    [anon_sym_LBRACE] = ACTIONS(2518),
    [anon_sym_LT_AT] = ACTIONS(2518),
    [anon_sym_LT_AT_AT] = ACTIONS(2518),
    [anon_sym_DOT] = ACTIONS(2518),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2520),
    [anon_sym_new] = ACTIONS(2518),
    [anon_sym_return_BANG] = ACTIONS(2520),
    [anon_sym_yield] = ACTIONS(2518),
    [anon_sym_yield_BANG] = ACTIONS(2520),
    [anon_sym_lazy] = ACTIONS(2518),
    [anon_sym_assert] = ACTIONS(2518),
    [anon_sym_upcast] = ACTIONS(2518),
    [anon_sym_downcast] = ACTIONS(2518),
    [anon_sym_COLON_GT] = ACTIONS(2520),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2520),
    [anon_sym_for] = ACTIONS(2518),
    [anon_sym_while] = ACTIONS(2518),
    [anon_sym_else] = ACTIONS(2518),
    [anon_sym_elif] = ACTIONS(3464),
    [anon_sym_if] = ACTIONS(2518),
    [anon_sym_fun] = ACTIONS(2518),
    [anon_sym_try] = ACTIONS(2518),
    [anon_sym_match] = ACTIONS(2518),
    [anon_sym_match_BANG] = ACTIONS(2520),
    [anon_sym_function] = ACTIONS(2518),
    [anon_sym_LT_DASH] = ACTIONS(2518),
    [anon_sym_DOT_LBRACK] = ACTIONS(2520),
    [anon_sym_LT] = ACTIONS(2520),
    [anon_sym_use] = ACTIONS(2518),
    [anon_sym_use_BANG] = ACTIONS(2520),
    [anon_sym_do_BANG] = ACTIONS(2520),
    [anon_sym_begin] = ACTIONS(2518),
    [anon_sym_LPAREN2] = ACTIONS(2518),
    [anon_sym_or] = ACTIONS(2518),
    [aux_sym_char_token1] = ACTIONS(2520),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2518),
    [anon_sym_DQUOTE] = ACTIONS(2518),
    [anon_sym_AT_DQUOTE] = ACTIONS(2520),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2520),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2520),
    [sym_bool] = ACTIONS(2518),
    [sym_unit] = ACTIONS(2520),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2518),
    [sym_op_identifier] = ACTIONS(2518),
    [anon_sym_PLUS] = ACTIONS(2518),
    [anon_sym_DASH] = ACTIONS(2518),
    [anon_sym_PLUS_DOT] = ACTIONS(2518),
    [anon_sym_DASH_DOT] = ACTIONS(2518),
    [anon_sym_PERCENT] = ACTIONS(2518),
    [anon_sym_AMP_AMP] = ACTIONS(2518),
    [anon_sym_TILDE] = ACTIONS(2520),
    [aux_sym_prefix_op_token1] = ACTIONS(2518),
    [aux_sym_infix_op_token1] = ACTIONS(2520),
    [aux_sym_infix_op_token2] = ACTIONS(2518),
    [anon_sym_PIPE_PIPE] = ACTIONS(2518),
    [anon_sym_BANG_EQ] = ACTIONS(2518),
    [anon_sym_COLON_EQ] = ACTIONS(2520),
    [anon_sym_DOLLAR] = ACTIONS(2518),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2518),
    [sym_int] = ACTIONS(2518),
    [sym_xint] = ACTIONS(2520),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2520),
    [sym__newline] = ACTIONS(2520),
    [sym__dedent] = ACTIONS(2520),
  },
  [1268] = {
    [sym_block_comment] = STATE(1268),
    [sym_compiler_directive_decl] = STATE(1268),
    [sym_fsi_directive_decl] = STATE(1268),
    [sym_preproc_line] = STATE(1268),
    [aux_sym_compound_type_repeat1] = STATE(1196),
    [sym_identifier] = ACTIONS(2407),
    [anon_sym_EQ] = ACTIONS(2409),
    [anon_sym_COLON] = ACTIONS(2407),
    [anon_sym_return] = ACTIONS(2407),
    [anon_sym_do] = ACTIONS(2407),
    [anon_sym_let] = ACTIONS(2407),
    [anon_sym_let_BANG] = ACTIONS(2409),
    [anon_sym_LPAREN] = ACTIONS(2407),
    [anon_sym_COMMA] = ACTIONS(2409),
    [anon_sym_null] = ACTIONS(2407),
    [anon_sym_QMARK] = ACTIONS(2407),
    [anon_sym_COLON_QMARK] = ACTIONS(2407),
    [anon_sym_COLON_COLON] = ACTIONS(2409),
    [anon_sym_AMP] = ACTIONS(2407),
    [anon_sym_LBRACK] = ACTIONS(2407),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2409),
    [anon_sym_LBRACE] = ACTIONS(2407),
    [anon_sym_LT_AT] = ACTIONS(2407),
    [anon_sym_AT_GT] = ACTIONS(2407),
    [anon_sym_LT_AT_AT] = ACTIONS(2407),
    [anon_sym_DOT] = ACTIONS(2407),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2409),
    [anon_sym_new] = ACTIONS(2407),
    [anon_sym_return_BANG] = ACTIONS(2409),
    [anon_sym_yield] = ACTIONS(2407),
    [anon_sym_yield_BANG] = ACTIONS(2409),
    [anon_sym_lazy] = ACTIONS(2407),
    [anon_sym_assert] = ACTIONS(2407),
    [anon_sym_upcast] = ACTIONS(2407),
    [anon_sym_downcast] = ACTIONS(2407),
    [anon_sym_COLON_GT] = ACTIONS(2409),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2409),
    [anon_sym_for] = ACTIONS(2407),
    [anon_sym_while] = ACTIONS(2407),
    [anon_sym_if] = ACTIONS(2407),
    [anon_sym_fun] = ACTIONS(2407),
    [anon_sym_DASH_GT] = ACTIONS(2407),
    [anon_sym_try] = ACTIONS(2407),
    [anon_sym_match] = ACTIONS(2407),
    [anon_sym_match_BANG] = ACTIONS(2409),
    [anon_sym_function] = ACTIONS(2407),
    [anon_sym_LT_DASH] = ACTIONS(2407),
    [anon_sym_DOT_LBRACK] = ACTIONS(2409),
    [anon_sym_LT] = ACTIONS(2409),
    [anon_sym_use] = ACTIONS(2407),
    [anon_sym_use_BANG] = ACTIONS(2409),
    [anon_sym_do_BANG] = ACTIONS(2409),
    [anon_sym_begin] = ACTIONS(2407),
    [anon_sym_LPAREN2] = ACTIONS(2407),
    [anon_sym_STAR] = ACTIONS(3208),
    [anon_sym_LT2] = ACTIONS(2407),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2409),
    [anon_sym_or] = ACTIONS(2407),
    [aux_sym_char_token1] = ACTIONS(2409),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2407),
    [anon_sym_DQUOTE] = ACTIONS(2407),
    [anon_sym_AT_DQUOTE] = ACTIONS(2409),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2409),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2409),
    [sym_bool] = ACTIONS(2407),
    [sym_unit] = ACTIONS(2409),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2407),
    [sym_op_identifier] = ACTIONS(2407),
    [anon_sym_PLUS] = ACTIONS(2407),
    [anon_sym_DASH] = ACTIONS(2407),
    [anon_sym_PLUS_DOT] = ACTIONS(2407),
    [anon_sym_DASH_DOT] = ACTIONS(2407),
    [anon_sym_PERCENT] = ACTIONS(2407),
    [anon_sym_AMP_AMP] = ACTIONS(2407),
    [anon_sym_TILDE] = ACTIONS(2409),
    [aux_sym_prefix_op_token1] = ACTIONS(2407),
    [aux_sym_infix_op_token1] = ACTIONS(2409),
    [aux_sym_infix_op_token2] = ACTIONS(2407),
    [anon_sym_PIPE_PIPE] = ACTIONS(2407),
    [anon_sym_BANG_EQ] = ACTIONS(2407),
    [anon_sym_COLON_EQ] = ACTIONS(2409),
    [anon_sym_DOLLAR] = ACTIONS(2407),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2407),
    [sym_int] = ACTIONS(2407),
    [sym_xint] = ACTIONS(2409),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2409),
    [sym__newline] = ACTIONS(2409),
  },
  [1269] = {
    [sym_block_comment] = STATE(1269),
    [sym_compiler_directive_decl] = STATE(1269),
    [sym_fsi_directive_decl] = STATE(1269),
    [sym_preproc_line] = STATE(1269),
    [sym_identifier] = ACTIONS(2506),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_COLON] = ACTIONS(2506),
    [anon_sym_return] = ACTIONS(2506),
    [anon_sym_do] = ACTIONS(2506),
    [anon_sym_let] = ACTIONS(2506),
    [anon_sym_let_BANG] = ACTIONS(2508),
    [anon_sym_LPAREN] = ACTIONS(2506),
    [anon_sym_COMMA] = ACTIONS(2508),
    [anon_sym_null] = ACTIONS(2506),
    [anon_sym_QMARK] = ACTIONS(2506),
    [anon_sym_COLON_QMARK] = ACTIONS(2506),
    [anon_sym_COLON_COLON] = ACTIONS(2508),
    [anon_sym_AMP] = ACTIONS(2506),
    [anon_sym_LBRACK] = ACTIONS(2506),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2508),
    [anon_sym_LBRACE] = ACTIONS(2506),
    [anon_sym_LT_AT] = ACTIONS(2506),
    [anon_sym_LT_AT_AT] = ACTIONS(2506),
    [anon_sym_DOT] = ACTIONS(2506),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2508),
    [anon_sym_new] = ACTIONS(2506),
    [anon_sym_return_BANG] = ACTIONS(2508),
    [anon_sym_yield] = ACTIONS(2506),
    [anon_sym_yield_BANG] = ACTIONS(2508),
    [anon_sym_lazy] = ACTIONS(2506),
    [anon_sym_assert] = ACTIONS(2506),
    [anon_sym_upcast] = ACTIONS(2506),
    [anon_sym_downcast] = ACTIONS(2506),
    [anon_sym_COLON_GT] = ACTIONS(2508),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2508),
    [anon_sym_for] = ACTIONS(2506),
    [anon_sym_while] = ACTIONS(2506),
    [anon_sym_if] = ACTIONS(2506),
    [anon_sym_fun] = ACTIONS(2506),
    [anon_sym_DASH_GT] = ACTIONS(2506),
    [anon_sym_try] = ACTIONS(2506),
    [anon_sym_match] = ACTIONS(2506),
    [anon_sym_match_BANG] = ACTIONS(2508),
    [anon_sym_function] = ACTIONS(2506),
    [anon_sym_LT_DASH] = ACTIONS(2506),
    [anon_sym_DOT_LBRACK] = ACTIONS(2508),
    [anon_sym_LT] = ACTIONS(2508),
    [anon_sym_use] = ACTIONS(2506),
    [anon_sym_use_BANG] = ACTIONS(2508),
    [anon_sym_do_BANG] = ACTIONS(2508),
    [anon_sym_begin] = ACTIONS(2506),
    [anon_sym_LPAREN2] = ACTIONS(2506),
    [anon_sym_STAR] = ACTIONS(2506),
    [anon_sym_LT2] = ACTIONS(2506),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2508),
    [anon_sym_or] = ACTIONS(2506),
    [aux_sym_char_token1] = ACTIONS(2508),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2506),
    [anon_sym_DQUOTE] = ACTIONS(2506),
    [anon_sym_AT_DQUOTE] = ACTIONS(2508),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2508),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2508),
    [sym_bool] = ACTIONS(2506),
    [sym_unit] = ACTIONS(2508),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2506),
    [sym_op_identifier] = ACTIONS(2506),
    [anon_sym_PLUS] = ACTIONS(2506),
    [anon_sym_DASH] = ACTIONS(2506),
    [anon_sym_PLUS_DOT] = ACTIONS(2506),
    [anon_sym_DASH_DOT] = ACTIONS(2506),
    [anon_sym_PERCENT] = ACTIONS(2506),
    [anon_sym_AMP_AMP] = ACTIONS(2506),
    [anon_sym_TILDE] = ACTIONS(2508),
    [aux_sym_prefix_op_token1] = ACTIONS(2506),
    [aux_sym_infix_op_token1] = ACTIONS(2508),
    [aux_sym_infix_op_token2] = ACTIONS(2506),
    [anon_sym_PIPE_PIPE] = ACTIONS(2506),
    [anon_sym_BANG_EQ] = ACTIONS(2506),
    [anon_sym_COLON_EQ] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(2506),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2506),
    [sym_int] = ACTIONS(2506),
    [sym_xint] = ACTIONS(2508),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2508),
    [anon_sym_POUNDendif] = ACTIONS(2508),
    [anon_sym_POUNDelse] = ACTIONS(2508),
    [sym__newline] = ACTIONS(2508),
  },
  [1270] = {
    [sym_block_comment] = STATE(1270),
    [sym_compiler_directive_decl] = STATE(1270),
    [sym_fsi_directive_decl] = STATE(1270),
    [sym_preproc_line] = STATE(1270),
    [sym_identifier] = ACTIONS(2557),
    [anon_sym_EQ] = ACTIONS(2559),
    [anon_sym_COLON] = ACTIONS(2557),
    [anon_sym_return] = ACTIONS(2557),
    [anon_sym_do] = ACTIONS(2557),
    [anon_sym_and] = ACTIONS(2557),
    [anon_sym_let] = ACTIONS(2557),
    [anon_sym_let_BANG] = ACTIONS(2559),
    [anon_sym_LPAREN] = ACTIONS(2557),
    [anon_sym_COMMA] = ACTIONS(2559),
    [anon_sym_null] = ACTIONS(2557),
    [anon_sym_QMARK] = ACTIONS(2557),
    [anon_sym_COLON_QMARK] = ACTIONS(2557),
    [anon_sym_COLON_COLON] = ACTIONS(2559),
    [anon_sym_AMP] = ACTIONS(2557),
    [anon_sym_LBRACK] = ACTIONS(2557),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2559),
    [anon_sym_LBRACE] = ACTIONS(2557),
    [anon_sym_LT_AT] = ACTIONS(2557),
    [anon_sym_LT_AT_AT] = ACTIONS(2557),
    [anon_sym_DOT] = ACTIONS(2557),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2559),
    [anon_sym_new] = ACTIONS(2557),
    [anon_sym_return_BANG] = ACTIONS(2559),
    [anon_sym_yield] = ACTIONS(2557),
    [anon_sym_yield_BANG] = ACTIONS(2559),
    [anon_sym_lazy] = ACTIONS(2557),
    [anon_sym_assert] = ACTIONS(2557),
    [anon_sym_upcast] = ACTIONS(2557),
    [anon_sym_downcast] = ACTIONS(2557),
    [anon_sym_COLON_GT] = ACTIONS(2559),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2559),
    [anon_sym_for] = ACTIONS(2557),
    [anon_sym_while] = ACTIONS(2557),
    [anon_sym_if] = ACTIONS(2557),
    [anon_sym_fun] = ACTIONS(2557),
    [anon_sym_DASH_GT] = ACTIONS(2557),
    [anon_sym_try] = ACTIONS(2557),
    [anon_sym_match] = ACTIONS(2557),
    [anon_sym_match_BANG] = ACTIONS(2559),
    [anon_sym_function] = ACTIONS(2557),
    [anon_sym_LT_DASH] = ACTIONS(2557),
    [anon_sym_DOT_LBRACK] = ACTIONS(2559),
    [anon_sym_LT] = ACTIONS(2559),
    [anon_sym_use] = ACTIONS(2557),
    [anon_sym_use_BANG] = ACTIONS(2559),
    [anon_sym_do_BANG] = ACTIONS(2559),
    [anon_sym_begin] = ACTIONS(2557),
    [anon_sym_LPAREN2] = ACTIONS(2557),
    [anon_sym_STAR] = ACTIONS(2557),
    [anon_sym_LT2] = ACTIONS(3467),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2559),
    [anon_sym_or] = ACTIONS(2557),
    [aux_sym_char_token1] = ACTIONS(2559),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2557),
    [anon_sym_DQUOTE] = ACTIONS(2557),
    [anon_sym_AT_DQUOTE] = ACTIONS(2559),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2559),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2559),
    [sym_bool] = ACTIONS(2557),
    [sym_unit] = ACTIONS(2559),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2557),
    [sym_op_identifier] = ACTIONS(2557),
    [anon_sym_PLUS] = ACTIONS(2557),
    [anon_sym_DASH] = ACTIONS(2557),
    [anon_sym_PLUS_DOT] = ACTIONS(2557),
    [anon_sym_DASH_DOT] = ACTIONS(2557),
    [anon_sym_PERCENT] = ACTIONS(2557),
    [anon_sym_AMP_AMP] = ACTIONS(2557),
    [anon_sym_TILDE] = ACTIONS(2559),
    [aux_sym_prefix_op_token1] = ACTIONS(2557),
    [aux_sym_infix_op_token1] = ACTIONS(2559),
    [aux_sym_infix_op_token2] = ACTIONS(2557),
    [anon_sym_PIPE_PIPE] = ACTIONS(2557),
    [anon_sym_BANG_EQ] = ACTIONS(2557),
    [anon_sym_COLON_EQ] = ACTIONS(2559),
    [anon_sym_DOLLAR] = ACTIONS(2557),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2557),
    [sym_int] = ACTIONS(2557),
    [sym_xint] = ACTIONS(2559),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2559),
    [sym__newline] = ACTIONS(2559),
    [sym__dedent] = ACTIONS(2559),
  },
  [1271] = {
    [sym_block_comment] = STATE(1271),
    [sym_compiler_directive_decl] = STATE(1271),
    [sym_fsi_directive_decl] = STATE(1271),
    [sym_preproc_line] = STATE(1271),
    [sym_identifier] = ACTIONS(2567),
    [anon_sym_EQ] = ACTIONS(2569),
    [anon_sym_COLON] = ACTIONS(2567),
    [anon_sym_return] = ACTIONS(2567),
    [anon_sym_do] = ACTIONS(2567),
    [anon_sym_and] = ACTIONS(2567),
    [anon_sym_let] = ACTIONS(2567),
    [anon_sym_let_BANG] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2567),
    [anon_sym_COMMA] = ACTIONS(2569),
    [anon_sym_null] = ACTIONS(2567),
    [anon_sym_QMARK] = ACTIONS(2567),
    [anon_sym_COLON_QMARK] = ACTIONS(2567),
    [anon_sym_COLON_COLON] = ACTIONS(2569),
    [anon_sym_AMP] = ACTIONS(2567),
    [anon_sym_LBRACK] = ACTIONS(2567),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2569),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_LT_AT] = ACTIONS(2567),
    [anon_sym_LT_AT_AT] = ACTIONS(2567),
    [anon_sym_DOT] = ACTIONS(2567),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2569),
    [anon_sym_new] = ACTIONS(2567),
    [anon_sym_return_BANG] = ACTIONS(2569),
    [anon_sym_yield] = ACTIONS(2567),
    [anon_sym_yield_BANG] = ACTIONS(2569),
    [anon_sym_lazy] = ACTIONS(2567),
    [anon_sym_assert] = ACTIONS(2567),
    [anon_sym_upcast] = ACTIONS(2567),
    [anon_sym_downcast] = ACTIONS(2567),
    [anon_sym_COLON_GT] = ACTIONS(2569),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2569),
    [anon_sym_for] = ACTIONS(2567),
    [anon_sym_while] = ACTIONS(2567),
    [anon_sym_if] = ACTIONS(2567),
    [anon_sym_fun] = ACTIONS(2567),
    [anon_sym_DASH_GT] = ACTIONS(2567),
    [anon_sym_try] = ACTIONS(2567),
    [anon_sym_match] = ACTIONS(2567),
    [anon_sym_match_BANG] = ACTIONS(2569),
    [anon_sym_function] = ACTIONS(2567),
    [anon_sym_LT_DASH] = ACTIONS(2567),
    [anon_sym_DOT_LBRACK] = ACTIONS(2569),
    [anon_sym_LT] = ACTIONS(2569),
    [anon_sym_use] = ACTIONS(2567),
    [anon_sym_use_BANG] = ACTIONS(2569),
    [anon_sym_do_BANG] = ACTIONS(2569),
    [anon_sym_begin] = ACTIONS(2567),
    [anon_sym_LPAREN2] = ACTIONS(2567),
    [anon_sym_STAR] = ACTIONS(2567),
    [anon_sym_LT2] = ACTIONS(2567),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2569),
    [anon_sym_or] = ACTIONS(2567),
    [aux_sym_char_token1] = ACTIONS(2569),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2567),
    [anon_sym_DQUOTE] = ACTIONS(2567),
    [anon_sym_AT_DQUOTE] = ACTIONS(2569),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2569),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2569),
    [sym_bool] = ACTIONS(2567),
    [sym_unit] = ACTIONS(2569),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2567),
    [sym_op_identifier] = ACTIONS(2567),
    [anon_sym_PLUS] = ACTIONS(2567),
    [anon_sym_DASH] = ACTIONS(2567),
    [anon_sym_PLUS_DOT] = ACTIONS(2567),
    [anon_sym_DASH_DOT] = ACTIONS(2567),
    [anon_sym_PERCENT] = ACTIONS(2567),
    [anon_sym_AMP_AMP] = ACTIONS(2567),
    [anon_sym_TILDE] = ACTIONS(2569),
    [aux_sym_prefix_op_token1] = ACTIONS(2567),
    [aux_sym_infix_op_token1] = ACTIONS(2569),
    [aux_sym_infix_op_token2] = ACTIONS(2567),
    [anon_sym_PIPE_PIPE] = ACTIONS(2567),
    [anon_sym_BANG_EQ] = ACTIONS(2567),
    [anon_sym_COLON_EQ] = ACTIONS(2569),
    [anon_sym_DOLLAR] = ACTIONS(2567),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2567),
    [sym_int] = ACTIONS(2567),
    [sym_xint] = ACTIONS(2569),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2569),
    [sym__newline] = ACTIONS(2569),
    [sym__dedent] = ACTIONS(2569),
  },
  [1272] = {
    [sym_block_comment] = STATE(1272),
    [sym_compiler_directive_decl] = STATE(1272),
    [sym_fsi_directive_decl] = STATE(1272),
    [sym_preproc_line] = STATE(1272),
    [sym_identifier] = ACTIONS(2474),
    [anon_sym_EQ] = ACTIONS(2476),
    [anon_sym_COLON] = ACTIONS(2474),
    [anon_sym_return] = ACTIONS(2474),
    [anon_sym_do] = ACTIONS(2474),
    [anon_sym_let] = ACTIONS(2474),
    [anon_sym_let_BANG] = ACTIONS(2476),
    [anon_sym_LPAREN] = ACTIONS(2474),
    [anon_sym_COMMA] = ACTIONS(2476),
    [anon_sym_null] = ACTIONS(2474),
    [anon_sym_QMARK] = ACTIONS(2474),
    [anon_sym_COLON_QMARK] = ACTIONS(2474),
    [anon_sym_COLON_COLON] = ACTIONS(2476),
    [anon_sym_AMP] = ACTIONS(2474),
    [anon_sym_LBRACK] = ACTIONS(2474),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2476),
    [anon_sym_LBRACE] = ACTIONS(2474),
    [anon_sym_LT_AT] = ACTIONS(2474),
    [anon_sym_LT_AT_AT] = ACTIONS(2474),
    [anon_sym_DOT] = ACTIONS(2474),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2476),
    [anon_sym_new] = ACTIONS(2474),
    [anon_sym_return_BANG] = ACTIONS(2476),
    [anon_sym_yield] = ACTIONS(2474),
    [anon_sym_yield_BANG] = ACTIONS(2476),
    [anon_sym_lazy] = ACTIONS(2474),
    [anon_sym_assert] = ACTIONS(2474),
    [anon_sym_upcast] = ACTIONS(2474),
    [anon_sym_downcast] = ACTIONS(2474),
    [anon_sym_COLON_GT] = ACTIONS(2476),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2476),
    [anon_sym_for] = ACTIONS(2474),
    [anon_sym_while] = ACTIONS(2474),
    [anon_sym_if] = ACTIONS(2474),
    [anon_sym_fun] = ACTIONS(2474),
    [anon_sym_DASH_GT] = ACTIONS(2474),
    [anon_sym_try] = ACTIONS(2474),
    [anon_sym_match] = ACTIONS(2474),
    [anon_sym_match_BANG] = ACTIONS(2476),
    [anon_sym_function] = ACTIONS(2474),
    [anon_sym_LT_DASH] = ACTIONS(2474),
    [anon_sym_DOT_LBRACK] = ACTIONS(2476),
    [anon_sym_LT] = ACTIONS(2476),
    [anon_sym_use] = ACTIONS(2474),
    [anon_sym_use_BANG] = ACTIONS(2476),
    [anon_sym_do_BANG] = ACTIONS(2476),
    [anon_sym_begin] = ACTIONS(2474),
    [anon_sym_LPAREN2] = ACTIONS(2474),
    [anon_sym_STAR] = ACTIONS(2474),
    [anon_sym_LT2] = ACTIONS(2474),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2476),
    [anon_sym_or] = ACTIONS(2474),
    [aux_sym_char_token1] = ACTIONS(2476),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2474),
    [anon_sym_DQUOTE] = ACTIONS(2474),
    [anon_sym_AT_DQUOTE] = ACTIONS(2476),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2476),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2476),
    [sym_bool] = ACTIONS(2474),
    [sym_unit] = ACTIONS(2476),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2474),
    [sym_op_identifier] = ACTIONS(2474),
    [anon_sym_PLUS] = ACTIONS(2474),
    [anon_sym_DASH] = ACTIONS(2474),
    [anon_sym_PLUS_DOT] = ACTIONS(2474),
    [anon_sym_DASH_DOT] = ACTIONS(2474),
    [anon_sym_PERCENT] = ACTIONS(2474),
    [anon_sym_AMP_AMP] = ACTIONS(2474),
    [anon_sym_TILDE] = ACTIONS(2476),
    [aux_sym_prefix_op_token1] = ACTIONS(2474),
    [aux_sym_infix_op_token1] = ACTIONS(2476),
    [aux_sym_infix_op_token2] = ACTIONS(2474),
    [anon_sym_PIPE_PIPE] = ACTIONS(2474),
    [anon_sym_BANG_EQ] = ACTIONS(2474),
    [anon_sym_COLON_EQ] = ACTIONS(2476),
    [anon_sym_DOLLAR] = ACTIONS(2474),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2474),
    [sym_int] = ACTIONS(2474),
    [sym_xint] = ACTIONS(2476),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2476),
    [anon_sym_POUNDendif] = ACTIONS(2476),
    [anon_sym_POUNDelse] = ACTIONS(2476),
    [sym__newline] = ACTIONS(2476),
  },
  [1273] = {
    [sym_block_comment] = STATE(1273),
    [sym_compiler_directive_decl] = STATE(1273),
    [sym_fsi_directive_decl] = STATE(1273),
    [sym_preproc_line] = STATE(1273),
    [sym_identifier] = ACTIONS(2510),
    [anon_sym_EQ] = ACTIONS(2512),
    [anon_sym_COLON] = ACTIONS(2510),
    [anon_sym_return] = ACTIONS(2510),
    [anon_sym_do] = ACTIONS(2510),
    [anon_sym_let] = ACTIONS(2510),
    [anon_sym_let_BANG] = ACTIONS(2512),
    [anon_sym_LPAREN] = ACTIONS(2510),
    [anon_sym_COMMA] = ACTIONS(2512),
    [anon_sym_null] = ACTIONS(2510),
    [anon_sym_QMARK] = ACTIONS(2510),
    [anon_sym_COLON_QMARK] = ACTIONS(2510),
    [anon_sym_COLON_COLON] = ACTIONS(2512),
    [anon_sym_AMP] = ACTIONS(2510),
    [anon_sym_LBRACK] = ACTIONS(2510),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2512),
    [anon_sym_LBRACE] = ACTIONS(2510),
    [anon_sym_LT_AT] = ACTIONS(2510),
    [anon_sym_LT_AT_AT] = ACTIONS(2510),
    [anon_sym_DOT] = ACTIONS(2510),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2512),
    [anon_sym_new] = ACTIONS(2510),
    [anon_sym_return_BANG] = ACTIONS(2512),
    [anon_sym_yield] = ACTIONS(2510),
    [anon_sym_yield_BANG] = ACTIONS(2512),
    [anon_sym_lazy] = ACTIONS(2510),
    [anon_sym_assert] = ACTIONS(2510),
    [anon_sym_upcast] = ACTIONS(2510),
    [anon_sym_downcast] = ACTIONS(2510),
    [anon_sym_COLON_GT] = ACTIONS(2512),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2512),
    [anon_sym_for] = ACTIONS(2510),
    [anon_sym_while] = ACTIONS(2510),
    [anon_sym_if] = ACTIONS(2510),
    [anon_sym_fun] = ACTIONS(2510),
    [anon_sym_DASH_GT] = ACTIONS(2510),
    [anon_sym_try] = ACTIONS(2510),
    [anon_sym_match] = ACTIONS(2510),
    [anon_sym_match_BANG] = ACTIONS(2512),
    [anon_sym_function] = ACTIONS(2510),
    [anon_sym_LT_DASH] = ACTIONS(2510),
    [anon_sym_DOT_LBRACK] = ACTIONS(2512),
    [anon_sym_LT] = ACTIONS(2512),
    [anon_sym_use] = ACTIONS(2510),
    [anon_sym_use_BANG] = ACTIONS(2512),
    [anon_sym_do_BANG] = ACTIONS(2512),
    [anon_sym_begin] = ACTIONS(2510),
    [anon_sym_LPAREN2] = ACTIONS(2510),
    [anon_sym_STAR] = ACTIONS(2510),
    [anon_sym_LT2] = ACTIONS(2510),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2512),
    [anon_sym_or] = ACTIONS(2510),
    [aux_sym_char_token1] = ACTIONS(2512),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2510),
    [anon_sym_DQUOTE] = ACTIONS(2510),
    [anon_sym_AT_DQUOTE] = ACTIONS(2512),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2512),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2512),
    [sym_bool] = ACTIONS(2510),
    [sym_unit] = ACTIONS(2512),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2510),
    [sym_op_identifier] = ACTIONS(2510),
    [anon_sym_PLUS] = ACTIONS(2510),
    [anon_sym_DASH] = ACTIONS(2510),
    [anon_sym_PLUS_DOT] = ACTIONS(2510),
    [anon_sym_DASH_DOT] = ACTIONS(2510),
    [anon_sym_PERCENT] = ACTIONS(2510),
    [anon_sym_AMP_AMP] = ACTIONS(2510),
    [anon_sym_TILDE] = ACTIONS(2512),
    [aux_sym_prefix_op_token1] = ACTIONS(2510),
    [aux_sym_infix_op_token1] = ACTIONS(2512),
    [aux_sym_infix_op_token2] = ACTIONS(2510),
    [anon_sym_PIPE_PIPE] = ACTIONS(2510),
    [anon_sym_BANG_EQ] = ACTIONS(2510),
    [anon_sym_COLON_EQ] = ACTIONS(2512),
    [anon_sym_DOLLAR] = ACTIONS(2510),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2510),
    [sym_int] = ACTIONS(2510),
    [sym_xint] = ACTIONS(2512),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2512),
    [anon_sym_POUNDendif] = ACTIONS(2512),
    [anon_sym_POUNDelse] = ACTIONS(2512),
    [sym__newline] = ACTIONS(2512),
  },
  [1274] = {
    [sym_block_comment] = STATE(1274),
    [sym_compiler_directive_decl] = STATE(1274),
    [sym_fsi_directive_decl] = STATE(1274),
    [sym_preproc_line] = STATE(1274),
    [sym_identifier] = ACTIONS(2470),
    [anon_sym_EQ] = ACTIONS(2472),
    [anon_sym_COLON] = ACTIONS(2470),
    [anon_sym_return] = ACTIONS(2470),
    [anon_sym_do] = ACTIONS(2470),
    [anon_sym_let] = ACTIONS(2470),
    [anon_sym_let_BANG] = ACTIONS(2472),
    [anon_sym_LPAREN] = ACTIONS(2470),
    [anon_sym_COMMA] = ACTIONS(2472),
    [anon_sym_null] = ACTIONS(2470),
    [anon_sym_QMARK] = ACTIONS(2470),
    [anon_sym_COLON_QMARK] = ACTIONS(2470),
    [anon_sym_COLON_COLON] = ACTIONS(2472),
    [anon_sym_AMP] = ACTIONS(2470),
    [anon_sym_LBRACK] = ACTIONS(2470),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2472),
    [anon_sym_LBRACE] = ACTIONS(2470),
    [anon_sym_LT_AT] = ACTIONS(2470),
    [anon_sym_LT_AT_AT] = ACTIONS(2470),
    [anon_sym_DOT] = ACTIONS(2470),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2472),
    [anon_sym_new] = ACTIONS(2470),
    [anon_sym_return_BANG] = ACTIONS(2472),
    [anon_sym_yield] = ACTIONS(2470),
    [anon_sym_yield_BANG] = ACTIONS(2472),
    [anon_sym_lazy] = ACTIONS(2470),
    [anon_sym_assert] = ACTIONS(2470),
    [anon_sym_upcast] = ACTIONS(2470),
    [anon_sym_downcast] = ACTIONS(2470),
    [anon_sym_COLON_GT] = ACTIONS(2472),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2472),
    [anon_sym_for] = ACTIONS(2470),
    [anon_sym_while] = ACTIONS(2470),
    [anon_sym_if] = ACTIONS(2470),
    [anon_sym_fun] = ACTIONS(2470),
    [anon_sym_DASH_GT] = ACTIONS(2470),
    [anon_sym_try] = ACTIONS(2470),
    [anon_sym_match] = ACTIONS(2470),
    [anon_sym_match_BANG] = ACTIONS(2472),
    [anon_sym_function] = ACTIONS(2470),
    [anon_sym_LT_DASH] = ACTIONS(2470),
    [anon_sym_DOT_LBRACK] = ACTIONS(2472),
    [anon_sym_LT] = ACTIONS(2472),
    [anon_sym_use] = ACTIONS(2470),
    [anon_sym_use_BANG] = ACTIONS(2472),
    [anon_sym_do_BANG] = ACTIONS(2472),
    [anon_sym_begin] = ACTIONS(2470),
    [anon_sym_LPAREN2] = ACTIONS(2470),
    [anon_sym_STAR] = ACTIONS(2470),
    [anon_sym_LT2] = ACTIONS(2470),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2472),
    [anon_sym_or] = ACTIONS(2470),
    [aux_sym_char_token1] = ACTIONS(2472),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2470),
    [anon_sym_DQUOTE] = ACTIONS(2470),
    [anon_sym_AT_DQUOTE] = ACTIONS(2472),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2472),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2472),
    [sym_bool] = ACTIONS(2470),
    [sym_unit] = ACTIONS(2472),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2470),
    [sym_op_identifier] = ACTIONS(2470),
    [anon_sym_PLUS] = ACTIONS(2470),
    [anon_sym_DASH] = ACTIONS(2470),
    [anon_sym_PLUS_DOT] = ACTIONS(2470),
    [anon_sym_DASH_DOT] = ACTIONS(2470),
    [anon_sym_PERCENT] = ACTIONS(2470),
    [anon_sym_AMP_AMP] = ACTIONS(2470),
    [anon_sym_TILDE] = ACTIONS(2472),
    [aux_sym_prefix_op_token1] = ACTIONS(2470),
    [aux_sym_infix_op_token1] = ACTIONS(2472),
    [aux_sym_infix_op_token2] = ACTIONS(2470),
    [anon_sym_PIPE_PIPE] = ACTIONS(2470),
    [anon_sym_BANG_EQ] = ACTIONS(2470),
    [anon_sym_COLON_EQ] = ACTIONS(2472),
    [anon_sym_DOLLAR] = ACTIONS(2470),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2470),
    [sym_int] = ACTIONS(2470),
    [sym_xint] = ACTIONS(2472),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2472),
    [anon_sym_POUNDendif] = ACTIONS(2472),
    [anon_sym_POUNDelse] = ACTIONS(2472),
    [sym__newline] = ACTIONS(2472),
  },
  [1275] = {
    [sym__else_expression] = STATE(2174),
    [sym_elif_expression] = STATE(1659),
    [sym_block_comment] = STATE(1275),
    [sym_compiler_directive_decl] = STATE(1275),
    [sym_fsi_directive_decl] = STATE(1275),
    [sym_preproc_line] = STATE(1275),
    [aux_sym_if_expression_repeat1] = STATE(1289),
    [sym_identifier] = ACTIONS(2332),
    [anon_sym_EQ] = ACTIONS(2334),
    [anon_sym_COLON] = ACTIONS(2332),
    [anon_sym_return] = ACTIONS(2332),
    [anon_sym_do] = ACTIONS(2332),
    [anon_sym_let] = ACTIONS(2332),
    [anon_sym_let_BANG] = ACTIONS(2334),
    [anon_sym_LPAREN] = ACTIONS(2332),
    [anon_sym_COMMA] = ACTIONS(2334),
    [anon_sym_null] = ACTIONS(2332),
    [anon_sym_QMARK] = ACTIONS(2332),
    [anon_sym_COLON_QMARK] = ACTIONS(2332),
    [anon_sym_COLON_COLON] = ACTIONS(2334),
    [anon_sym_AMP] = ACTIONS(2332),
    [anon_sym_LBRACK] = ACTIONS(2332),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2334),
    [anon_sym_LBRACE] = ACTIONS(2332),
    [anon_sym_LT_AT] = ACTIONS(2332),
    [anon_sym_LT_AT_AT] = ACTIONS(2332),
    [anon_sym_DOT] = ACTIONS(2332),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2334),
    [anon_sym_new] = ACTIONS(2332),
    [anon_sym_return_BANG] = ACTIONS(2334),
    [anon_sym_yield] = ACTIONS(2332),
    [anon_sym_yield_BANG] = ACTIONS(2334),
    [anon_sym_lazy] = ACTIONS(2332),
    [anon_sym_assert] = ACTIONS(2332),
    [anon_sym_upcast] = ACTIONS(2332),
    [anon_sym_downcast] = ACTIONS(2332),
    [anon_sym_COLON_GT] = ACTIONS(2334),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2334),
    [anon_sym_for] = ACTIONS(2332),
    [anon_sym_while] = ACTIONS(2332),
    [anon_sym_else] = ACTIONS(3460),
    [anon_sym_elif] = ACTIONS(3462),
    [anon_sym_if] = ACTIONS(2332),
    [anon_sym_fun] = ACTIONS(2332),
    [anon_sym_try] = ACTIONS(2332),
    [anon_sym_match] = ACTIONS(2332),
    [anon_sym_match_BANG] = ACTIONS(2334),
    [anon_sym_function] = ACTIONS(2332),
    [anon_sym_LT_DASH] = ACTIONS(2332),
    [anon_sym_DOT_LBRACK] = ACTIONS(2334),
    [anon_sym_LT] = ACTIONS(2334),
    [anon_sym_use] = ACTIONS(2332),
    [anon_sym_use_BANG] = ACTIONS(2334),
    [anon_sym_do_BANG] = ACTIONS(2334),
    [anon_sym_DOT_DOT] = ACTIONS(2334),
    [anon_sym_begin] = ACTIONS(2332),
    [anon_sym_LPAREN2] = ACTIONS(2332),
    [anon_sym_or] = ACTIONS(2332),
    [aux_sym_char_token1] = ACTIONS(2334),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2332),
    [anon_sym_DQUOTE] = ACTIONS(2332),
    [anon_sym_AT_DQUOTE] = ACTIONS(2334),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2334),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2334),
    [sym_bool] = ACTIONS(2332),
    [sym_unit] = ACTIONS(2334),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2332),
    [sym_op_identifier] = ACTIONS(2332),
    [anon_sym_PLUS] = ACTIONS(2332),
    [anon_sym_DASH] = ACTIONS(2332),
    [anon_sym_PLUS_DOT] = ACTIONS(2332),
    [anon_sym_DASH_DOT] = ACTIONS(2332),
    [anon_sym_PERCENT] = ACTIONS(2332),
    [anon_sym_AMP_AMP] = ACTIONS(2332),
    [anon_sym_TILDE] = ACTIONS(2334),
    [aux_sym_prefix_op_token1] = ACTIONS(2332),
    [aux_sym_infix_op_token1] = ACTIONS(2334),
    [aux_sym_infix_op_token2] = ACTIONS(2332),
    [anon_sym_PIPE_PIPE] = ACTIONS(2332),
    [anon_sym_BANG_EQ] = ACTIONS(2332),
    [anon_sym_COLON_EQ] = ACTIONS(2334),
    [anon_sym_DOLLAR] = ACTIONS(2332),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2332),
    [sym_int] = ACTIONS(2332),
    [sym_xint] = ACTIONS(2334),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2334),
    [sym__newline] = ACTIONS(2334),
  },
  [1276] = {
    [sym__else_expression] = STATE(2334),
    [sym_elif_expression] = STATE(1495),
    [sym_block_comment] = STATE(1276),
    [sym_compiler_directive_decl] = STATE(1276),
    [sym_fsi_directive_decl] = STATE(1276),
    [sym_preproc_line] = STATE(1276),
    [aux_sym_if_expression_repeat1] = STATE(1251),
    [sym_identifier] = ACTIONS(2422),
    [anon_sym_EQ] = ACTIONS(2424),
    [anon_sym_COLON] = ACTIONS(2422),
    [anon_sym_return] = ACTIONS(2422),
    [anon_sym_do] = ACTIONS(2422),
    [anon_sym_let] = ACTIONS(2422),
    [anon_sym_let_BANG] = ACTIONS(2424),
    [anon_sym_LPAREN] = ACTIONS(2422),
    [anon_sym_COMMA] = ACTIONS(2424),
    [anon_sym_null] = ACTIONS(2422),
    [anon_sym_QMARK] = ACTIONS(2422),
    [anon_sym_COLON_QMARK] = ACTIONS(2422),
    [anon_sym_COLON_COLON] = ACTIONS(2424),
    [anon_sym_AMP] = ACTIONS(2422),
    [anon_sym_LBRACK] = ACTIONS(2422),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2424),
    [anon_sym_LBRACE] = ACTIONS(2422),
    [anon_sym_LT_AT] = ACTIONS(2422),
    [anon_sym_LT_AT_AT] = ACTIONS(2422),
    [anon_sym_AT_AT_GT] = ACTIONS(2422),
    [anon_sym_DOT] = ACTIONS(2422),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2424),
    [anon_sym_new] = ACTIONS(2422),
    [anon_sym_return_BANG] = ACTIONS(2424),
    [anon_sym_yield] = ACTIONS(2422),
    [anon_sym_yield_BANG] = ACTIONS(2424),
    [anon_sym_lazy] = ACTIONS(2422),
    [anon_sym_assert] = ACTIONS(2422),
    [anon_sym_upcast] = ACTIONS(2422),
    [anon_sym_downcast] = ACTIONS(2422),
    [anon_sym_COLON_GT] = ACTIONS(2424),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2424),
    [anon_sym_for] = ACTIONS(2422),
    [anon_sym_while] = ACTIONS(2422),
    [anon_sym_else] = ACTIONS(3437),
    [anon_sym_elif] = ACTIONS(3439),
    [anon_sym_if] = ACTIONS(2422),
    [anon_sym_fun] = ACTIONS(2422),
    [anon_sym_try] = ACTIONS(2422),
    [anon_sym_match] = ACTIONS(2422),
    [anon_sym_match_BANG] = ACTIONS(2424),
    [anon_sym_function] = ACTIONS(2422),
    [anon_sym_LT_DASH] = ACTIONS(2422),
    [anon_sym_DOT_LBRACK] = ACTIONS(2424),
    [anon_sym_LT] = ACTIONS(2424),
    [anon_sym_use] = ACTIONS(2422),
    [anon_sym_use_BANG] = ACTIONS(2424),
    [anon_sym_do_BANG] = ACTIONS(2424),
    [anon_sym_begin] = ACTIONS(2422),
    [anon_sym_LPAREN2] = ACTIONS(2422),
    [anon_sym_or] = ACTIONS(2422),
    [aux_sym_char_token1] = ACTIONS(2424),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2422),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_AT_DQUOTE] = ACTIONS(2424),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2424),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2424),
    [sym_bool] = ACTIONS(2422),
    [sym_unit] = ACTIONS(2424),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2422),
    [sym_op_identifier] = ACTIONS(2422),
    [anon_sym_PLUS] = ACTIONS(2422),
    [anon_sym_DASH] = ACTIONS(2422),
    [anon_sym_PLUS_DOT] = ACTIONS(2422),
    [anon_sym_DASH_DOT] = ACTIONS(2422),
    [anon_sym_PERCENT] = ACTIONS(2422),
    [anon_sym_AMP_AMP] = ACTIONS(2422),
    [anon_sym_TILDE] = ACTIONS(2424),
    [aux_sym_prefix_op_token1] = ACTIONS(2422),
    [aux_sym_infix_op_token1] = ACTIONS(2424),
    [aux_sym_infix_op_token2] = ACTIONS(2422),
    [anon_sym_PIPE_PIPE] = ACTIONS(2422),
    [anon_sym_BANG_EQ] = ACTIONS(2422),
    [anon_sym_COLON_EQ] = ACTIONS(2424),
    [anon_sym_DOLLAR] = ACTIONS(2422),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2422),
    [sym_int] = ACTIONS(2422),
    [sym_xint] = ACTIONS(2424),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2424),
    [sym__newline] = ACTIONS(2424),
  },
  [1277] = {
    [sym_block_comment] = STATE(1277),
    [sym_compiler_directive_decl] = STATE(1277),
    [sym_fsi_directive_decl] = STATE(1277),
    [sym_preproc_line] = STATE(1277),
    [sym_identifier] = ACTIONS(2474),
    [anon_sym_EQ] = ACTIONS(2476),
    [anon_sym_COLON] = ACTIONS(2474),
    [anon_sym_return] = ACTIONS(2474),
    [anon_sym_do] = ACTIONS(2474),
    [anon_sym_and] = ACTIONS(2474),
    [anon_sym_let] = ACTIONS(2474),
    [anon_sym_let_BANG] = ACTIONS(2476),
    [anon_sym_LPAREN] = ACTIONS(2474),
    [anon_sym_COMMA] = ACTIONS(2476),
    [anon_sym_null] = ACTIONS(2474),
    [anon_sym_QMARK] = ACTIONS(2474),
    [anon_sym_COLON_QMARK] = ACTIONS(2474),
    [anon_sym_COLON_COLON] = ACTIONS(2476),
    [anon_sym_AMP] = ACTIONS(2474),
    [anon_sym_LBRACK] = ACTIONS(2474),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2476),
    [anon_sym_LBRACE] = ACTIONS(2474),
    [anon_sym_LT_AT] = ACTIONS(2474),
    [anon_sym_LT_AT_AT] = ACTIONS(2474),
    [anon_sym_DOT] = ACTIONS(2474),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2476),
    [anon_sym_new] = ACTIONS(2474),
    [anon_sym_return_BANG] = ACTIONS(2476),
    [anon_sym_yield] = ACTIONS(2474),
    [anon_sym_yield_BANG] = ACTIONS(2476),
    [anon_sym_lazy] = ACTIONS(2474),
    [anon_sym_assert] = ACTIONS(2474),
    [anon_sym_upcast] = ACTIONS(2474),
    [anon_sym_downcast] = ACTIONS(2474),
    [anon_sym_COLON_GT] = ACTIONS(2476),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2476),
    [anon_sym_for] = ACTIONS(2474),
    [anon_sym_while] = ACTIONS(2474),
    [anon_sym_if] = ACTIONS(2474),
    [anon_sym_fun] = ACTIONS(2474),
    [anon_sym_DASH_GT] = ACTIONS(2474),
    [anon_sym_try] = ACTIONS(2474),
    [anon_sym_match] = ACTIONS(2474),
    [anon_sym_match_BANG] = ACTIONS(2476),
    [anon_sym_function] = ACTIONS(2474),
    [anon_sym_LT_DASH] = ACTIONS(2474),
    [anon_sym_DOT_LBRACK] = ACTIONS(2476),
    [anon_sym_LT] = ACTIONS(2476),
    [anon_sym_use] = ACTIONS(2474),
    [anon_sym_use_BANG] = ACTIONS(2476),
    [anon_sym_do_BANG] = ACTIONS(2476),
    [anon_sym_begin] = ACTIONS(2474),
    [anon_sym_LPAREN2] = ACTIONS(2474),
    [anon_sym_STAR] = ACTIONS(2474),
    [anon_sym_LT2] = ACTIONS(2474),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2476),
    [anon_sym_or] = ACTIONS(2474),
    [aux_sym_char_token1] = ACTIONS(2476),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2474),
    [anon_sym_DQUOTE] = ACTIONS(2474),
    [anon_sym_AT_DQUOTE] = ACTIONS(2476),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2476),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2476),
    [sym_bool] = ACTIONS(2474),
    [sym_unit] = ACTIONS(2476),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2474),
    [sym_op_identifier] = ACTIONS(2474),
    [anon_sym_PLUS] = ACTIONS(2474),
    [anon_sym_DASH] = ACTIONS(2474),
    [anon_sym_PLUS_DOT] = ACTIONS(2474),
    [anon_sym_DASH_DOT] = ACTIONS(2474),
    [anon_sym_PERCENT] = ACTIONS(2474),
    [anon_sym_AMP_AMP] = ACTIONS(2474),
    [anon_sym_TILDE] = ACTIONS(2476),
    [aux_sym_prefix_op_token1] = ACTIONS(2474),
    [aux_sym_infix_op_token1] = ACTIONS(2476),
    [aux_sym_infix_op_token2] = ACTIONS(2474),
    [anon_sym_PIPE_PIPE] = ACTIONS(2474),
    [anon_sym_BANG_EQ] = ACTIONS(2474),
    [anon_sym_COLON_EQ] = ACTIONS(2476),
    [anon_sym_DOLLAR] = ACTIONS(2474),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2474),
    [sym_int] = ACTIONS(2474),
    [sym_xint] = ACTIONS(2476),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2476),
    [sym__newline] = ACTIONS(2476),
    [sym__dedent] = ACTIONS(2476),
  },
  [1278] = {
    [sym_block_comment] = STATE(1278),
    [sym_compiler_directive_decl] = STATE(1278),
    [sym_fsi_directive_decl] = STATE(1278),
    [sym_preproc_line] = STATE(1278),
    [sym_identifier] = ACTIONS(2510),
    [anon_sym_EQ] = ACTIONS(2512),
    [anon_sym_COLON] = ACTIONS(2510),
    [anon_sym_return] = ACTIONS(2510),
    [anon_sym_do] = ACTIONS(2510),
    [anon_sym_and] = ACTIONS(2510),
    [anon_sym_let] = ACTIONS(2510),
    [anon_sym_let_BANG] = ACTIONS(2512),
    [anon_sym_LPAREN] = ACTIONS(2510),
    [anon_sym_COMMA] = ACTIONS(2512),
    [anon_sym_null] = ACTIONS(2510),
    [anon_sym_QMARK] = ACTIONS(2510),
    [anon_sym_COLON_QMARK] = ACTIONS(2510),
    [anon_sym_COLON_COLON] = ACTIONS(2512),
    [anon_sym_AMP] = ACTIONS(2510),
    [anon_sym_LBRACK] = ACTIONS(2510),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2512),
    [anon_sym_LBRACE] = ACTIONS(2510),
    [anon_sym_LT_AT] = ACTIONS(2510),
    [anon_sym_LT_AT_AT] = ACTIONS(2510),
    [anon_sym_DOT] = ACTIONS(2510),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2512),
    [anon_sym_new] = ACTIONS(2510),
    [anon_sym_return_BANG] = ACTIONS(2512),
    [anon_sym_yield] = ACTIONS(2510),
    [anon_sym_yield_BANG] = ACTIONS(2512),
    [anon_sym_lazy] = ACTIONS(2510),
    [anon_sym_assert] = ACTIONS(2510),
    [anon_sym_upcast] = ACTIONS(2510),
    [anon_sym_downcast] = ACTIONS(2510),
    [anon_sym_COLON_GT] = ACTIONS(2512),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2512),
    [anon_sym_for] = ACTIONS(2510),
    [anon_sym_while] = ACTIONS(2510),
    [anon_sym_if] = ACTIONS(2510),
    [anon_sym_fun] = ACTIONS(2510),
    [anon_sym_DASH_GT] = ACTIONS(2510),
    [anon_sym_try] = ACTIONS(2510),
    [anon_sym_match] = ACTIONS(2510),
    [anon_sym_match_BANG] = ACTIONS(2512),
    [anon_sym_function] = ACTIONS(2510),
    [anon_sym_LT_DASH] = ACTIONS(2510),
    [anon_sym_DOT_LBRACK] = ACTIONS(2512),
    [anon_sym_LT] = ACTIONS(2512),
    [anon_sym_use] = ACTIONS(2510),
    [anon_sym_use_BANG] = ACTIONS(2512),
    [anon_sym_do_BANG] = ACTIONS(2512),
    [anon_sym_begin] = ACTIONS(2510),
    [anon_sym_LPAREN2] = ACTIONS(2510),
    [anon_sym_STAR] = ACTIONS(2510),
    [anon_sym_LT2] = ACTIONS(2510),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2512),
    [anon_sym_or] = ACTIONS(2510),
    [aux_sym_char_token1] = ACTIONS(2512),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2510),
    [anon_sym_DQUOTE] = ACTIONS(2510),
    [anon_sym_AT_DQUOTE] = ACTIONS(2512),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2512),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2512),
    [sym_bool] = ACTIONS(2510),
    [sym_unit] = ACTIONS(2512),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2510),
    [sym_op_identifier] = ACTIONS(2510),
    [anon_sym_PLUS] = ACTIONS(2510),
    [anon_sym_DASH] = ACTIONS(2510),
    [anon_sym_PLUS_DOT] = ACTIONS(2510),
    [anon_sym_DASH_DOT] = ACTIONS(2510),
    [anon_sym_PERCENT] = ACTIONS(2510),
    [anon_sym_AMP_AMP] = ACTIONS(2510),
    [anon_sym_TILDE] = ACTIONS(2512),
    [aux_sym_prefix_op_token1] = ACTIONS(2510),
    [aux_sym_infix_op_token1] = ACTIONS(2512),
    [aux_sym_infix_op_token2] = ACTIONS(2510),
    [anon_sym_PIPE_PIPE] = ACTIONS(2510),
    [anon_sym_BANG_EQ] = ACTIONS(2510),
    [anon_sym_COLON_EQ] = ACTIONS(2512),
    [anon_sym_DOLLAR] = ACTIONS(2510),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2510),
    [sym_int] = ACTIONS(2510),
    [sym_xint] = ACTIONS(2512),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2512),
    [sym__newline] = ACTIONS(2512),
    [sym__dedent] = ACTIONS(2512),
  },
  [1279] = {
    [sym_block_comment] = STATE(1279),
    [sym_compiler_directive_decl] = STATE(1279),
    [sym_fsi_directive_decl] = STATE(1279),
    [sym_preproc_line] = STATE(1279),
    [sym_identifier] = ACTIONS(2557),
    [anon_sym_EQ] = ACTIONS(2559),
    [anon_sym_COLON] = ACTIONS(2557),
    [anon_sym_return] = ACTIONS(2557),
    [anon_sym_do] = ACTIONS(2557),
    [anon_sym_let] = ACTIONS(2557),
    [anon_sym_let_BANG] = ACTIONS(2559),
    [anon_sym_LPAREN] = ACTIONS(2557),
    [anon_sym_COMMA] = ACTIONS(2559),
    [anon_sym_null] = ACTIONS(2557),
    [anon_sym_QMARK] = ACTIONS(2557),
    [anon_sym_COLON_QMARK] = ACTIONS(2557),
    [anon_sym_COLON_COLON] = ACTIONS(2559),
    [anon_sym_AMP] = ACTIONS(2557),
    [anon_sym_LBRACK] = ACTIONS(2557),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2559),
    [anon_sym_LBRACE] = ACTIONS(2557),
    [anon_sym_LT_AT] = ACTIONS(2557),
    [anon_sym_LT_AT_AT] = ACTIONS(2557),
    [anon_sym_DOT] = ACTIONS(2557),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2559),
    [anon_sym_new] = ACTIONS(2557),
    [anon_sym_return_BANG] = ACTIONS(2559),
    [anon_sym_yield] = ACTIONS(2557),
    [anon_sym_yield_BANG] = ACTIONS(2559),
    [anon_sym_lazy] = ACTIONS(2557),
    [anon_sym_assert] = ACTIONS(2557),
    [anon_sym_upcast] = ACTIONS(2557),
    [anon_sym_downcast] = ACTIONS(2557),
    [anon_sym_COLON_GT] = ACTIONS(2559),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2559),
    [anon_sym_for] = ACTIONS(2557),
    [anon_sym_while] = ACTIONS(2557),
    [anon_sym_if] = ACTIONS(2557),
    [anon_sym_fun] = ACTIONS(2557),
    [anon_sym_DASH_GT] = ACTIONS(2557),
    [anon_sym_try] = ACTIONS(2557),
    [anon_sym_match] = ACTIONS(2557),
    [anon_sym_match_BANG] = ACTIONS(2559),
    [anon_sym_function] = ACTIONS(2557),
    [anon_sym_LT_DASH] = ACTIONS(2557),
    [anon_sym_DOT_LBRACK] = ACTIONS(2559),
    [anon_sym_LT] = ACTIONS(2559),
    [anon_sym_use] = ACTIONS(2557),
    [anon_sym_use_BANG] = ACTIONS(2559),
    [anon_sym_do_BANG] = ACTIONS(2559),
    [anon_sym_begin] = ACTIONS(2557),
    [anon_sym_LPAREN2] = ACTIONS(2557),
    [anon_sym_STAR] = ACTIONS(2557),
    [anon_sym_LT2] = ACTIONS(3469),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2559),
    [anon_sym_or] = ACTIONS(2557),
    [aux_sym_char_token1] = ACTIONS(2559),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2557),
    [anon_sym_DQUOTE] = ACTIONS(2557),
    [anon_sym_AT_DQUOTE] = ACTIONS(2559),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2559),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2559),
    [sym_bool] = ACTIONS(2557),
    [sym_unit] = ACTIONS(2559),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2557),
    [sym_op_identifier] = ACTIONS(2557),
    [anon_sym_PLUS] = ACTIONS(2557),
    [anon_sym_DASH] = ACTIONS(2557),
    [anon_sym_PLUS_DOT] = ACTIONS(2557),
    [anon_sym_DASH_DOT] = ACTIONS(2557),
    [anon_sym_PERCENT] = ACTIONS(2557),
    [anon_sym_AMP_AMP] = ACTIONS(2557),
    [anon_sym_TILDE] = ACTIONS(2559),
    [aux_sym_prefix_op_token1] = ACTIONS(2557),
    [aux_sym_infix_op_token1] = ACTIONS(2559),
    [aux_sym_infix_op_token2] = ACTIONS(2557),
    [anon_sym_PIPE_PIPE] = ACTIONS(2557),
    [anon_sym_BANG_EQ] = ACTIONS(2557),
    [anon_sym_COLON_EQ] = ACTIONS(2559),
    [anon_sym_DOLLAR] = ACTIONS(2557),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2557),
    [sym_int] = ACTIONS(2557),
    [sym_xint] = ACTIONS(2559),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2559),
    [anon_sym_POUNDendif] = ACTIONS(2559),
    [anon_sym_POUNDelse] = ACTIONS(2559),
    [sym__newline] = ACTIONS(2559),
  },
  [1280] = {
    [sym_block_comment] = STATE(1280),
    [sym_compiler_directive_decl] = STATE(1280),
    [sym_fsi_directive_decl] = STATE(1280),
    [sym_preproc_line] = STATE(1280),
    [sym_identifier] = ACTIONS(2723),
    [anon_sym_EQ] = ACTIONS(2725),
    [anon_sym_COLON] = ACTIONS(2723),
    [anon_sym_return] = ACTIONS(2723),
    [anon_sym_do] = ACTIONS(2723),
    [anon_sym_let] = ACTIONS(2723),
    [anon_sym_let_BANG] = ACTIONS(2725),
    [anon_sym_as] = ACTIONS(2723),
    [anon_sym_LPAREN] = ACTIONS(2723),
    [anon_sym_COMMA] = ACTIONS(2725),
    [anon_sym_null] = ACTIONS(2723),
    [anon_sym_QMARK] = ACTIONS(2723),
    [anon_sym_COLON_QMARK] = ACTIONS(2723),
    [anon_sym_COLON_COLON] = ACTIONS(2725),
    [anon_sym_AMP] = ACTIONS(2723),
    [anon_sym_LBRACK] = ACTIONS(2723),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2725),
    [anon_sym_LBRACE] = ACTIONS(2723),
    [anon_sym_LT_AT] = ACTIONS(2723),
    [anon_sym_LT_AT_AT] = ACTIONS(2723),
    [anon_sym_DOT] = ACTIONS(2723),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2725),
    [anon_sym_new] = ACTIONS(2723),
    [anon_sym_with] = ACTIONS(2723),
    [anon_sym_return_BANG] = ACTIONS(2725),
    [anon_sym_yield] = ACTIONS(2723),
    [anon_sym_yield_BANG] = ACTIONS(2725),
    [anon_sym_lazy] = ACTIONS(2723),
    [anon_sym_assert] = ACTIONS(2723),
    [anon_sym_upcast] = ACTIONS(2723),
    [anon_sym_downcast] = ACTIONS(2723),
    [anon_sym_COLON_GT] = ACTIONS(2725),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2725),
    [anon_sym_for] = ACTIONS(2723),
    [anon_sym_while] = ACTIONS(2723),
    [anon_sym_if] = ACTIONS(2723),
    [anon_sym_fun] = ACTIONS(2723),
    [anon_sym_try] = ACTIONS(2723),
    [anon_sym_match] = ACTIONS(2723),
    [anon_sym_match_BANG] = ACTIONS(2725),
    [anon_sym_function] = ACTIONS(2723),
    [anon_sym_LT_DASH] = ACTIONS(2723),
    [anon_sym_DOT_LBRACK] = ACTIONS(2725),
    [anon_sym_LT] = ACTIONS(2725),
    [anon_sym_use] = ACTIONS(2723),
    [anon_sym_use_BANG] = ACTIONS(2725),
    [anon_sym_do_BANG] = ACTIONS(2725),
    [anon_sym_begin] = ACTIONS(2723),
    [anon_sym_LPAREN2] = ACTIONS(2723),
    [anon_sym_or] = ACTIONS(2723),
    [aux_sym_char_token1] = ACTIONS(2725),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2723),
    [anon_sym_DQUOTE] = ACTIONS(2723),
    [anon_sym_AT_DQUOTE] = ACTIONS(2725),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2725),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2725),
    [sym_bool] = ACTIONS(2723),
    [sym_unit] = ACTIONS(2725),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2723),
    [sym_op_identifier] = ACTIONS(2723),
    [anon_sym_PLUS] = ACTIONS(2723),
    [anon_sym_DASH] = ACTIONS(2723),
    [anon_sym_PLUS_DOT] = ACTIONS(2723),
    [anon_sym_DASH_DOT] = ACTIONS(2723),
    [anon_sym_PERCENT] = ACTIONS(2723),
    [anon_sym_AMP_AMP] = ACTIONS(2723),
    [anon_sym_TILDE] = ACTIONS(2725),
    [aux_sym_prefix_op_token1] = ACTIONS(2723),
    [aux_sym_infix_op_token1] = ACTIONS(2725),
    [aux_sym_infix_op_token2] = ACTIONS(2723),
    [anon_sym_PIPE_PIPE] = ACTIONS(2723),
    [anon_sym_BANG_EQ] = ACTIONS(2723),
    [anon_sym_COLON_EQ] = ACTIONS(2725),
    [anon_sym_DOLLAR] = ACTIONS(2723),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2723),
    [sym_int] = ACTIONS(2723),
    [sym_xint] = ACTIONS(2725),
    [anon_sym_f] = ACTIONS(2723),
    [aux_sym_decimal_token1] = ACTIONS(2723),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2725),
    [sym__newline] = ACTIONS(2725),
    [sym__dedent] = ACTIONS(2725),
  },
  [1281] = {
    [sym_block_comment] = STATE(1281),
    [sym_compiler_directive_decl] = STATE(1281),
    [sym_fsi_directive_decl] = STATE(1281),
    [sym_preproc_line] = STATE(1281),
    [sym_identifier] = ACTIONS(2411),
    [anon_sym_EQ] = ACTIONS(2413),
    [anon_sym_COLON] = ACTIONS(2411),
    [anon_sym_return] = ACTIONS(2411),
    [anon_sym_do] = ACTIONS(2411),
    [anon_sym_let] = ACTIONS(2411),
    [anon_sym_let_BANG] = ACTIONS(2413),
    [anon_sym_LPAREN] = ACTIONS(2411),
    [anon_sym_COMMA] = ACTIONS(2413),
    [anon_sym_null] = ACTIONS(2411),
    [anon_sym_QMARK] = ACTIONS(2411),
    [anon_sym_COLON_QMARK] = ACTIONS(2411),
    [anon_sym_COLON_COLON] = ACTIONS(2413),
    [anon_sym_AMP] = ACTIONS(2411),
    [anon_sym_LBRACK] = ACTIONS(2411),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2413),
    [anon_sym_LBRACE] = ACTIONS(2411),
    [anon_sym_LT_AT] = ACTIONS(2411),
    [anon_sym_LT_AT_AT] = ACTIONS(2411),
    [anon_sym_DOT] = ACTIONS(2411),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2413),
    [anon_sym_new] = ACTIONS(2411),
    [anon_sym_return_BANG] = ACTIONS(2413),
    [anon_sym_yield] = ACTIONS(2411),
    [anon_sym_yield_BANG] = ACTIONS(2413),
    [anon_sym_lazy] = ACTIONS(2411),
    [anon_sym_assert] = ACTIONS(2411),
    [anon_sym_upcast] = ACTIONS(2411),
    [anon_sym_downcast] = ACTIONS(2411),
    [anon_sym_COLON_GT] = ACTIONS(2413),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2413),
    [anon_sym_for] = ACTIONS(2411),
    [anon_sym_while] = ACTIONS(2411),
    [anon_sym_if] = ACTIONS(2411),
    [anon_sym_fun] = ACTIONS(2411),
    [anon_sym_DASH_GT] = ACTIONS(2411),
    [anon_sym_try] = ACTIONS(2411),
    [anon_sym_match] = ACTIONS(2411),
    [anon_sym_match_BANG] = ACTIONS(2413),
    [anon_sym_function] = ACTIONS(2411),
    [anon_sym_LT_DASH] = ACTIONS(2411),
    [anon_sym_DOT_LBRACK] = ACTIONS(2413),
    [anon_sym_LT] = ACTIONS(2413),
    [anon_sym_use] = ACTIONS(2411),
    [anon_sym_use_BANG] = ACTIONS(2413),
    [anon_sym_do_BANG] = ACTIONS(2413),
    [anon_sym_DOT_DOT] = ACTIONS(2413),
    [anon_sym_begin] = ACTIONS(2411),
    [anon_sym_LPAREN2] = ACTIONS(2411),
    [anon_sym_STAR] = ACTIONS(2411),
    [anon_sym_LT2] = ACTIONS(2411),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2413),
    [anon_sym_or] = ACTIONS(2411),
    [aux_sym_char_token1] = ACTIONS(2413),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2411),
    [anon_sym_DQUOTE] = ACTIONS(2411),
    [anon_sym_AT_DQUOTE] = ACTIONS(2413),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2413),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2413),
    [sym_bool] = ACTIONS(2411),
    [sym_unit] = ACTIONS(2413),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2411),
    [sym_op_identifier] = ACTIONS(2411),
    [anon_sym_PLUS] = ACTIONS(2411),
    [anon_sym_DASH] = ACTIONS(2411),
    [anon_sym_PLUS_DOT] = ACTIONS(2411),
    [anon_sym_DASH_DOT] = ACTIONS(2411),
    [anon_sym_PERCENT] = ACTIONS(2411),
    [anon_sym_AMP_AMP] = ACTIONS(2411),
    [anon_sym_TILDE] = ACTIONS(2413),
    [aux_sym_prefix_op_token1] = ACTIONS(2411),
    [aux_sym_infix_op_token1] = ACTIONS(2413),
    [aux_sym_infix_op_token2] = ACTIONS(2411),
    [anon_sym_PIPE_PIPE] = ACTIONS(2411),
    [anon_sym_BANG_EQ] = ACTIONS(2411),
    [anon_sym_COLON_EQ] = ACTIONS(2413),
    [anon_sym_DOLLAR] = ACTIONS(2411),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2411),
    [sym_int] = ACTIONS(2411),
    [sym_xint] = ACTIONS(2413),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2413),
    [sym__newline] = ACTIONS(2413),
  },
  [1282] = {
    [sym_block_comment] = STATE(1282),
    [sym_compiler_directive_decl] = STATE(1282),
    [sym_fsi_directive_decl] = STATE(1282),
    [sym_preproc_line] = STATE(1282),
    [sym_identifier] = ACTIONS(2553),
    [anon_sym_EQ] = ACTIONS(2555),
    [anon_sym_COLON] = ACTIONS(2553),
    [anon_sym_return] = ACTIONS(2553),
    [anon_sym_do] = ACTIONS(2553),
    [anon_sym_let] = ACTIONS(2553),
    [anon_sym_let_BANG] = ACTIONS(2555),
    [anon_sym_LPAREN] = ACTIONS(2553),
    [anon_sym_COMMA] = ACTIONS(2555),
    [anon_sym_null] = ACTIONS(2553),
    [anon_sym_QMARK] = ACTIONS(2553),
    [anon_sym_COLON_QMARK] = ACTIONS(2553),
    [anon_sym_COLON_COLON] = ACTIONS(2555),
    [anon_sym_AMP] = ACTIONS(2553),
    [anon_sym_LBRACK] = ACTIONS(2553),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2555),
    [anon_sym_LBRACE] = ACTIONS(2553),
    [anon_sym_LT_AT] = ACTIONS(2553),
    [anon_sym_AT_GT] = ACTIONS(2553),
    [anon_sym_LT_AT_AT] = ACTIONS(2553),
    [anon_sym_DOT] = ACTIONS(2553),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2555),
    [anon_sym_new] = ACTIONS(2553),
    [anon_sym_return_BANG] = ACTIONS(2555),
    [anon_sym_yield] = ACTIONS(2553),
    [anon_sym_yield_BANG] = ACTIONS(2555),
    [anon_sym_lazy] = ACTIONS(2553),
    [anon_sym_assert] = ACTIONS(2553),
    [anon_sym_upcast] = ACTIONS(2553),
    [anon_sym_downcast] = ACTIONS(2553),
    [anon_sym_COLON_GT] = ACTIONS(2555),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2555),
    [anon_sym_for] = ACTIONS(2553),
    [anon_sym_while] = ACTIONS(2553),
    [anon_sym_if] = ACTIONS(2553),
    [anon_sym_fun] = ACTIONS(2553),
    [anon_sym_DASH_GT] = ACTIONS(2553),
    [anon_sym_try] = ACTIONS(2553),
    [anon_sym_match] = ACTIONS(2553),
    [anon_sym_match_BANG] = ACTIONS(2555),
    [anon_sym_function] = ACTIONS(2553),
    [anon_sym_LT_DASH] = ACTIONS(2553),
    [anon_sym_DOT_LBRACK] = ACTIONS(2555),
    [anon_sym_LT] = ACTIONS(2555),
    [anon_sym_use] = ACTIONS(2553),
    [anon_sym_use_BANG] = ACTIONS(2555),
    [anon_sym_do_BANG] = ACTIONS(2555),
    [anon_sym_begin] = ACTIONS(2553),
    [anon_sym_LPAREN2] = ACTIONS(2553),
    [anon_sym_STAR] = ACTIONS(2553),
    [anon_sym_LT2] = ACTIONS(2553),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2555),
    [anon_sym_or] = ACTIONS(2553),
    [aux_sym_char_token1] = ACTIONS(2555),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2553),
    [anon_sym_DQUOTE] = ACTIONS(2553),
    [anon_sym_AT_DQUOTE] = ACTIONS(2555),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2555),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2555),
    [sym_bool] = ACTIONS(2553),
    [sym_unit] = ACTIONS(2555),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2553),
    [sym_op_identifier] = ACTIONS(2553),
    [anon_sym_PLUS] = ACTIONS(2553),
    [anon_sym_DASH] = ACTIONS(2553),
    [anon_sym_PLUS_DOT] = ACTIONS(2553),
    [anon_sym_DASH_DOT] = ACTIONS(2553),
    [anon_sym_PERCENT] = ACTIONS(2553),
    [anon_sym_AMP_AMP] = ACTIONS(2553),
    [anon_sym_TILDE] = ACTIONS(2555),
    [aux_sym_prefix_op_token1] = ACTIONS(2553),
    [aux_sym_infix_op_token1] = ACTIONS(2555),
    [aux_sym_infix_op_token2] = ACTIONS(2553),
    [anon_sym_PIPE_PIPE] = ACTIONS(2553),
    [anon_sym_BANG_EQ] = ACTIONS(2553),
    [anon_sym_COLON_EQ] = ACTIONS(2555),
    [anon_sym_DOLLAR] = ACTIONS(2553),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2553),
    [sym_int] = ACTIONS(2553),
    [sym_xint] = ACTIONS(2555),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2555),
    [sym__newline] = ACTIONS(2555),
  },
  [1283] = {
    [sym_block_comment] = STATE(1283),
    [sym_compiler_directive_decl] = STATE(1283),
    [sym_fsi_directive_decl] = STATE(1283),
    [sym_preproc_line] = STATE(1283),
    [sym_identifier] = ACTIONS(2685),
    [anon_sym_EQ] = ACTIONS(2687),
    [anon_sym_COLON] = ACTIONS(2685),
    [anon_sym_return] = ACTIONS(2685),
    [anon_sym_do] = ACTIONS(2685),
    [anon_sym_let] = ACTIONS(2685),
    [anon_sym_let_BANG] = ACTIONS(2687),
    [anon_sym_as] = ACTIONS(2685),
    [anon_sym_LPAREN] = ACTIONS(2685),
    [anon_sym_COMMA] = ACTIONS(2687),
    [anon_sym_null] = ACTIONS(2685),
    [anon_sym_QMARK] = ACTIONS(2685),
    [anon_sym_COLON_QMARK] = ACTIONS(2685),
    [anon_sym_COLON_COLON] = ACTIONS(2687),
    [anon_sym_AMP] = ACTIONS(2685),
    [anon_sym_LBRACK] = ACTIONS(2685),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2687),
    [anon_sym_LBRACE] = ACTIONS(2685),
    [anon_sym_LT_AT] = ACTIONS(2685),
    [anon_sym_LT_AT_AT] = ACTIONS(2685),
    [anon_sym_DOT] = ACTIONS(2685),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2687),
    [anon_sym_new] = ACTIONS(2685),
    [anon_sym_with] = ACTIONS(2685),
    [anon_sym_return_BANG] = ACTIONS(2687),
    [anon_sym_yield] = ACTIONS(2685),
    [anon_sym_yield_BANG] = ACTIONS(2687),
    [anon_sym_lazy] = ACTIONS(2685),
    [anon_sym_assert] = ACTIONS(2685),
    [anon_sym_upcast] = ACTIONS(2685),
    [anon_sym_downcast] = ACTIONS(2685),
    [anon_sym_COLON_GT] = ACTIONS(2687),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2687),
    [anon_sym_for] = ACTIONS(2685),
    [anon_sym_done] = ACTIONS(2685),
    [anon_sym_while] = ACTIONS(2685),
    [anon_sym_if] = ACTIONS(2685),
    [anon_sym_fun] = ACTIONS(2685),
    [anon_sym_try] = ACTIONS(2685),
    [anon_sym_match] = ACTIONS(2685),
    [anon_sym_match_BANG] = ACTIONS(2687),
    [anon_sym_function] = ACTIONS(2685),
    [anon_sym_LT_DASH] = ACTIONS(2685),
    [anon_sym_DOT_LBRACK] = ACTIONS(2687),
    [anon_sym_LT] = ACTIONS(2687),
    [anon_sym_use] = ACTIONS(2685),
    [anon_sym_use_BANG] = ACTIONS(2687),
    [anon_sym_do_BANG] = ACTIONS(2687),
    [anon_sym_DOT_DOT] = ACTIONS(2687),
    [anon_sym_begin] = ACTIONS(2685),
    [anon_sym_LPAREN2] = ACTIONS(2685),
    [anon_sym_or] = ACTIONS(2685),
    [aux_sym_char_token1] = ACTIONS(2687),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2685),
    [anon_sym_DQUOTE] = ACTIONS(2685),
    [anon_sym_AT_DQUOTE] = ACTIONS(2687),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2687),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2687),
    [sym_bool] = ACTIONS(2685),
    [sym_unit] = ACTIONS(2687),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2685),
    [sym_op_identifier] = ACTIONS(2685),
    [anon_sym_PLUS] = ACTIONS(2685),
    [anon_sym_DASH] = ACTIONS(2685),
    [anon_sym_PLUS_DOT] = ACTIONS(2685),
    [anon_sym_DASH_DOT] = ACTIONS(2685),
    [anon_sym_PERCENT] = ACTIONS(2685),
    [anon_sym_AMP_AMP] = ACTIONS(2685),
    [anon_sym_TILDE] = ACTIONS(2687),
    [aux_sym_prefix_op_token1] = ACTIONS(2685),
    [aux_sym_infix_op_token1] = ACTIONS(2687),
    [aux_sym_infix_op_token2] = ACTIONS(2685),
    [anon_sym_PIPE_PIPE] = ACTIONS(2685),
    [anon_sym_BANG_EQ] = ACTIONS(2685),
    [anon_sym_COLON_EQ] = ACTIONS(2687),
    [anon_sym_DOLLAR] = ACTIONS(2685),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2685),
    [sym_int] = ACTIONS(2685),
    [sym_xint] = ACTIONS(2687),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2687),
    [sym__newline] = ACTIONS(2687),
    [sym__dedent] = ACTIONS(2687),
  },
  [1284] = {
    [sym_block_comment] = STATE(1284),
    [sym_compiler_directive_decl] = STATE(1284),
    [sym_fsi_directive_decl] = STATE(1284),
    [sym_preproc_line] = STATE(1284),
    [aux_sym_rules_repeat1] = STATE(1284),
    [sym_identifier] = ACTIONS(2713),
    [anon_sym_EQ] = ACTIONS(2715),
    [anon_sym_COLON] = ACTIONS(2713),
    [anon_sym_return] = ACTIONS(2713),
    [anon_sym_do] = ACTIONS(2713),
    [anon_sym_let] = ACTIONS(2713),
    [anon_sym_let_BANG] = ACTIONS(2715),
    [anon_sym_as] = ACTIONS(2713),
    [anon_sym_LPAREN] = ACTIONS(2713),
    [anon_sym_COMMA] = ACTIONS(2715),
    [anon_sym_null] = ACTIONS(2713),
    [anon_sym_QMARK] = ACTIONS(2713),
    [anon_sym_COLON_QMARK] = ACTIONS(2713),
    [anon_sym_COLON_COLON] = ACTIONS(2715),
    [anon_sym_PIPE] = ACTIONS(3471),
    [anon_sym_AMP] = ACTIONS(2713),
    [anon_sym_LBRACK] = ACTIONS(2713),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2715),
    [anon_sym_LBRACE] = ACTIONS(2713),
    [anon_sym_LT_AT] = ACTIONS(2713),
    [anon_sym_LT_AT_AT] = ACTIONS(2713),
    [anon_sym_DOT] = ACTIONS(2713),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2715),
    [anon_sym_new] = ACTIONS(2713),
    [anon_sym_with] = ACTIONS(2713),
    [anon_sym_return_BANG] = ACTIONS(2715),
    [anon_sym_yield] = ACTIONS(2713),
    [anon_sym_yield_BANG] = ACTIONS(2715),
    [anon_sym_lazy] = ACTIONS(2713),
    [anon_sym_assert] = ACTIONS(2713),
    [anon_sym_upcast] = ACTIONS(2713),
    [anon_sym_downcast] = ACTIONS(2713),
    [anon_sym_COLON_GT] = ACTIONS(2715),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2715),
    [anon_sym_for] = ACTIONS(2713),
    [anon_sym_while] = ACTIONS(2713),
    [anon_sym_if] = ACTIONS(2713),
    [anon_sym_fun] = ACTIONS(2713),
    [anon_sym_try] = ACTIONS(2713),
    [anon_sym_match] = ACTIONS(2713),
    [anon_sym_match_BANG] = ACTIONS(2715),
    [anon_sym_function] = ACTIONS(2713),
    [anon_sym_LT_DASH] = ACTIONS(2713),
    [anon_sym_DOT_LBRACK] = ACTIONS(2715),
    [anon_sym_LT] = ACTIONS(2715),
    [anon_sym_use] = ACTIONS(2713),
    [anon_sym_use_BANG] = ACTIONS(2715),
    [anon_sym_do_BANG] = ACTIONS(2715),
    [anon_sym_begin] = ACTIONS(2713),
    [anon_sym_LPAREN2] = ACTIONS(2713),
    [anon_sym_or] = ACTIONS(2713),
    [aux_sym_char_token1] = ACTIONS(2715),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2713),
    [anon_sym_DQUOTE] = ACTIONS(2713),
    [anon_sym_AT_DQUOTE] = ACTIONS(2715),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2715),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2715),
    [sym_bool] = ACTIONS(2713),
    [sym_unit] = ACTIONS(2715),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2713),
    [sym_op_identifier] = ACTIONS(2713),
    [anon_sym_PLUS] = ACTIONS(2713),
    [anon_sym_DASH] = ACTIONS(2713),
    [anon_sym_PLUS_DOT] = ACTIONS(2713),
    [anon_sym_DASH_DOT] = ACTIONS(2713),
    [anon_sym_PERCENT] = ACTIONS(2713),
    [anon_sym_AMP_AMP] = ACTIONS(2713),
    [anon_sym_TILDE] = ACTIONS(2715),
    [aux_sym_prefix_op_token1] = ACTIONS(2713),
    [aux_sym_infix_op_token1] = ACTIONS(2715),
    [aux_sym_infix_op_token2] = ACTIONS(2713),
    [anon_sym_PIPE_PIPE] = ACTIONS(2713),
    [anon_sym_BANG_EQ] = ACTIONS(2713),
    [anon_sym_COLON_EQ] = ACTIONS(2715),
    [anon_sym_DOLLAR] = ACTIONS(2713),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2713),
    [sym_int] = ACTIONS(2713),
    [sym_xint] = ACTIONS(2715),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2715),
    [sym__newline] = ACTIONS(3474),
    [sym__dedent] = ACTIONS(2715),
  },
  [1285] = {
    [sym_block_comment] = STATE(1285),
    [sym_compiler_directive_decl] = STATE(1285),
    [sym_fsi_directive_decl] = STATE(1285),
    [sym_preproc_line] = STATE(1285),
    [sym_identifier] = ACTIONS(2474),
    [anon_sym_EQ] = ACTIONS(2476),
    [anon_sym_COLON] = ACTIONS(2474),
    [anon_sym_return] = ACTIONS(2474),
    [anon_sym_do] = ACTIONS(2474),
    [anon_sym_let] = ACTIONS(2474),
    [anon_sym_let_BANG] = ACTIONS(2476),
    [anon_sym_LPAREN] = ACTIONS(2474),
    [anon_sym_COMMA] = ACTIONS(2476),
    [anon_sym_null] = ACTIONS(2474),
    [anon_sym_QMARK] = ACTIONS(2474),
    [anon_sym_COLON_QMARK] = ACTIONS(2474),
    [anon_sym_COLON_COLON] = ACTIONS(2476),
    [anon_sym_AMP] = ACTIONS(2474),
    [anon_sym_LBRACK] = ACTIONS(2474),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2476),
    [anon_sym_LBRACE] = ACTIONS(2474),
    [anon_sym_LT_AT] = ACTIONS(2474),
    [anon_sym_AT_GT] = ACTIONS(2474),
    [anon_sym_LT_AT_AT] = ACTIONS(2474),
    [anon_sym_DOT] = ACTIONS(2474),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2476),
    [anon_sym_new] = ACTIONS(2474),
    [anon_sym_return_BANG] = ACTIONS(2476),
    [anon_sym_yield] = ACTIONS(2474),
    [anon_sym_yield_BANG] = ACTIONS(2476),
    [anon_sym_lazy] = ACTIONS(2474),
    [anon_sym_assert] = ACTIONS(2474),
    [anon_sym_upcast] = ACTIONS(2474),
    [anon_sym_downcast] = ACTIONS(2474),
    [anon_sym_COLON_GT] = ACTIONS(2476),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2476),
    [anon_sym_for] = ACTIONS(2474),
    [anon_sym_while] = ACTIONS(2474),
    [anon_sym_if] = ACTIONS(2474),
    [anon_sym_fun] = ACTIONS(2474),
    [anon_sym_DASH_GT] = ACTIONS(2474),
    [anon_sym_try] = ACTIONS(2474),
    [anon_sym_match] = ACTIONS(2474),
    [anon_sym_match_BANG] = ACTIONS(2476),
    [anon_sym_function] = ACTIONS(2474),
    [anon_sym_LT_DASH] = ACTIONS(2474),
    [anon_sym_DOT_LBRACK] = ACTIONS(2476),
    [anon_sym_LT] = ACTIONS(2476),
    [anon_sym_use] = ACTIONS(2474),
    [anon_sym_use_BANG] = ACTIONS(2476),
    [anon_sym_do_BANG] = ACTIONS(2476),
    [anon_sym_begin] = ACTIONS(2474),
    [anon_sym_LPAREN2] = ACTIONS(2474),
    [anon_sym_STAR] = ACTIONS(2474),
    [anon_sym_LT2] = ACTIONS(2474),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2476),
    [anon_sym_or] = ACTIONS(2474),
    [aux_sym_char_token1] = ACTIONS(2476),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2474),
    [anon_sym_DQUOTE] = ACTIONS(2474),
    [anon_sym_AT_DQUOTE] = ACTIONS(2476),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2476),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2476),
    [sym_bool] = ACTIONS(2474),
    [sym_unit] = ACTIONS(2476),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2474),
    [sym_op_identifier] = ACTIONS(2474),
    [anon_sym_PLUS] = ACTIONS(2474),
    [anon_sym_DASH] = ACTIONS(2474),
    [anon_sym_PLUS_DOT] = ACTIONS(2474),
    [anon_sym_DASH_DOT] = ACTIONS(2474),
    [anon_sym_PERCENT] = ACTIONS(2474),
    [anon_sym_AMP_AMP] = ACTIONS(2474),
    [anon_sym_TILDE] = ACTIONS(2476),
    [aux_sym_prefix_op_token1] = ACTIONS(2474),
    [aux_sym_infix_op_token1] = ACTIONS(2476),
    [aux_sym_infix_op_token2] = ACTIONS(2474),
    [anon_sym_PIPE_PIPE] = ACTIONS(2474),
    [anon_sym_BANG_EQ] = ACTIONS(2474),
    [anon_sym_COLON_EQ] = ACTIONS(2476),
    [anon_sym_DOLLAR] = ACTIONS(2474),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2474),
    [sym_int] = ACTIONS(2474),
    [sym_xint] = ACTIONS(2476),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2476),
    [sym__newline] = ACTIONS(2476),
  },
  [1286] = {
    [sym_block_comment] = STATE(1286),
    [sym_compiler_directive_decl] = STATE(1286),
    [sym_fsi_directive_decl] = STATE(1286),
    [sym_preproc_line] = STATE(1286),
    [sym_identifier] = ACTIONS(2321),
    [anon_sym_EQ] = ACTIONS(2323),
    [anon_sym_COLON] = ACTIONS(2321),
    [anon_sym_return] = ACTIONS(2321),
    [anon_sym_do] = ACTIONS(2321),
    [anon_sym_let] = ACTIONS(2321),
    [anon_sym_let_BANG] = ACTIONS(2323),
    [anon_sym_LPAREN] = ACTIONS(2321),
    [anon_sym_COMMA] = ACTIONS(2323),
    [anon_sym_null] = ACTIONS(2321),
    [anon_sym_QMARK] = ACTIONS(2321),
    [anon_sym_COLON_QMARK] = ACTIONS(2321),
    [anon_sym_COLON_COLON] = ACTIONS(2323),
    [anon_sym_AMP] = ACTIONS(2321),
    [anon_sym_LBRACK] = ACTIONS(2321),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2323),
    [anon_sym_LBRACE] = ACTIONS(2321),
    [anon_sym_LT_AT] = ACTIONS(2321),
    [anon_sym_LT_AT_AT] = ACTIONS(2321),
    [anon_sym_AT_AT_GT] = ACTIONS(2321),
    [anon_sym_DOT] = ACTIONS(2321),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2323),
    [anon_sym_new] = ACTIONS(2321),
    [anon_sym_return_BANG] = ACTIONS(2323),
    [anon_sym_yield] = ACTIONS(2321),
    [anon_sym_yield_BANG] = ACTIONS(2323),
    [anon_sym_lazy] = ACTIONS(2321),
    [anon_sym_assert] = ACTIONS(2321),
    [anon_sym_upcast] = ACTIONS(2321),
    [anon_sym_downcast] = ACTIONS(2321),
    [anon_sym_COLON_GT] = ACTIONS(2323),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2323),
    [anon_sym_for] = ACTIONS(2321),
    [anon_sym_while] = ACTIONS(2321),
    [anon_sym_if] = ACTIONS(2321),
    [anon_sym_fun] = ACTIONS(2321),
    [anon_sym_DASH_GT] = ACTIONS(2321),
    [anon_sym_try] = ACTIONS(2321),
    [anon_sym_match] = ACTIONS(2321),
    [anon_sym_match_BANG] = ACTIONS(2323),
    [anon_sym_function] = ACTIONS(2321),
    [anon_sym_LT_DASH] = ACTIONS(2321),
    [anon_sym_DOT_LBRACK] = ACTIONS(2323),
    [anon_sym_LT] = ACTIONS(2323),
    [anon_sym_use] = ACTIONS(2321),
    [anon_sym_use_BANG] = ACTIONS(2323),
    [anon_sym_do_BANG] = ACTIONS(2323),
    [anon_sym_begin] = ACTIONS(2321),
    [anon_sym_LPAREN2] = ACTIONS(2321),
    [anon_sym_STAR] = ACTIONS(2321),
    [anon_sym_LT2] = ACTIONS(2321),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2323),
    [anon_sym_or] = ACTIONS(2321),
    [aux_sym_char_token1] = ACTIONS(2323),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2321),
    [anon_sym_DQUOTE] = ACTIONS(2321),
    [anon_sym_AT_DQUOTE] = ACTIONS(2323),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2323),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2323),
    [sym_bool] = ACTIONS(2321),
    [sym_unit] = ACTIONS(2323),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2321),
    [sym_op_identifier] = ACTIONS(2321),
    [anon_sym_PLUS] = ACTIONS(2321),
    [anon_sym_DASH] = ACTIONS(2321),
    [anon_sym_PLUS_DOT] = ACTIONS(2321),
    [anon_sym_DASH_DOT] = ACTIONS(2321),
    [anon_sym_PERCENT] = ACTIONS(2321),
    [anon_sym_AMP_AMP] = ACTIONS(2321),
    [anon_sym_TILDE] = ACTIONS(2323),
    [aux_sym_prefix_op_token1] = ACTIONS(2321),
    [aux_sym_infix_op_token1] = ACTIONS(2323),
    [aux_sym_infix_op_token2] = ACTIONS(2321),
    [anon_sym_PIPE_PIPE] = ACTIONS(2321),
    [anon_sym_BANG_EQ] = ACTIONS(2321),
    [anon_sym_COLON_EQ] = ACTIONS(2323),
    [anon_sym_DOLLAR] = ACTIONS(2321),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2321),
    [sym_int] = ACTIONS(2321),
    [sym_xint] = ACTIONS(2323),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2323),
    [sym__newline] = ACTIONS(2323),
  },
  [1287] = {
    [sym_block_comment] = STATE(1287),
    [sym_compiler_directive_decl] = STATE(1287),
    [sym_fsi_directive_decl] = STATE(1287),
    [sym_preproc_line] = STATE(1287),
    [sym_identifier] = ACTIONS(2723),
    [anon_sym_EQ] = ACTIONS(2725),
    [anon_sym_COLON] = ACTIONS(2723),
    [anon_sym_return] = ACTIONS(2723),
    [anon_sym_do] = ACTIONS(2723),
    [anon_sym_let] = ACTIONS(2723),
    [anon_sym_let_BANG] = ACTIONS(2725),
    [anon_sym_LPAREN] = ACTIONS(2723),
    [anon_sym_COMMA] = ACTIONS(2725),
    [anon_sym_null] = ACTIONS(2723),
    [anon_sym_QMARK] = ACTIONS(2723),
    [anon_sym_COLON_QMARK] = ACTIONS(2723),
    [anon_sym_COLON_COLON] = ACTIONS(2725),
    [anon_sym_AMP] = ACTIONS(2723),
    [anon_sym_LBRACK] = ACTIONS(2723),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2725),
    [anon_sym_LBRACE] = ACTIONS(2723),
    [anon_sym_LT_AT] = ACTIONS(2723),
    [anon_sym_LT_AT_AT] = ACTIONS(2723),
    [anon_sym_DOT] = ACTIONS(2723),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2725),
    [anon_sym_new] = ACTIONS(2723),
    [anon_sym_return_BANG] = ACTIONS(2725),
    [anon_sym_yield] = ACTIONS(2723),
    [anon_sym_yield_BANG] = ACTIONS(2725),
    [anon_sym_lazy] = ACTIONS(2723),
    [anon_sym_assert] = ACTIONS(2723),
    [anon_sym_upcast] = ACTIONS(2723),
    [anon_sym_downcast] = ACTIONS(2723),
    [anon_sym_COLON_GT] = ACTIONS(2725),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2725),
    [anon_sym_for] = ACTIONS(2723),
    [anon_sym_while] = ACTIONS(2723),
    [anon_sym_if] = ACTIONS(2723),
    [anon_sym_fun] = ACTIONS(2723),
    [anon_sym_try] = ACTIONS(2723),
    [anon_sym_match] = ACTIONS(2723),
    [anon_sym_match_BANG] = ACTIONS(2725),
    [anon_sym_function] = ACTIONS(2723),
    [anon_sym_LT_DASH] = ACTIONS(2723),
    [anon_sym_DOT_LBRACK] = ACTIONS(2725),
    [anon_sym_LT] = ACTIONS(2725),
    [anon_sym_use] = ACTIONS(2723),
    [anon_sym_use_BANG] = ACTIONS(2725),
    [anon_sym_do_BANG] = ACTIONS(2725),
    [anon_sym_begin] = ACTIONS(2723),
    [anon_sym_LPAREN2] = ACTIONS(2723),
    [anon_sym_or] = ACTIONS(2723),
    [aux_sym_char_token1] = ACTIONS(2725),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2723),
    [anon_sym_DQUOTE] = ACTIONS(2723),
    [anon_sym_AT_DQUOTE] = ACTIONS(2725),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2725),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2725),
    [sym_bool] = ACTIONS(2723),
    [sym_unit] = ACTIONS(2725),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2723),
    [sym_op_identifier] = ACTIONS(2723),
    [anon_sym_PLUS] = ACTIONS(2723),
    [anon_sym_DASH] = ACTIONS(2723),
    [anon_sym_PLUS_DOT] = ACTIONS(2723),
    [anon_sym_DASH_DOT] = ACTIONS(2723),
    [anon_sym_PERCENT] = ACTIONS(2723),
    [anon_sym_AMP_AMP] = ACTIONS(2723),
    [anon_sym_TILDE] = ACTIONS(2725),
    [aux_sym_prefix_op_token1] = ACTIONS(2723),
    [aux_sym_infix_op_token1] = ACTIONS(2725),
    [aux_sym_infix_op_token2] = ACTIONS(2723),
    [anon_sym_PIPE_PIPE] = ACTIONS(2723),
    [anon_sym_BANG_EQ] = ACTIONS(2723),
    [anon_sym_COLON_EQ] = ACTIONS(2725),
    [anon_sym_DOLLAR] = ACTIONS(2723),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2723),
    [sym_int] = ACTIONS(2723),
    [sym_xint] = ACTIONS(2725),
    [anon_sym_f] = ACTIONS(2723),
    [aux_sym_decimal_token1] = ACTIONS(2723),
    [aux_sym_float_token1] = ACTIONS(3477),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2725),
    [anon_sym_POUNDendif] = ACTIONS(2725),
    [anon_sym_POUNDelse] = ACTIONS(2725),
    [sym__newline] = ACTIONS(2725),
  },
  [1288] = {
    [sym_elif_expression] = STATE(1668),
    [sym_block_comment] = STATE(1288),
    [sym_compiler_directive_decl] = STATE(1288),
    [sym_fsi_directive_decl] = STATE(1288),
    [sym_preproc_line] = STATE(1288),
    [aux_sym_if_expression_repeat1] = STATE(1288),
    [sym_identifier] = ACTIONS(2518),
    [anon_sym_EQ] = ACTIONS(2520),
    [anon_sym_COLON] = ACTIONS(2518),
    [anon_sym_return] = ACTIONS(2518),
    [anon_sym_do] = ACTIONS(2518),
    [anon_sym_let] = ACTIONS(2518),
    [anon_sym_let_BANG] = ACTIONS(2520),
    [anon_sym_LPAREN] = ACTIONS(2518),
    [anon_sym_COMMA] = ACTIONS(2520),
    [anon_sym_null] = ACTIONS(2518),
    [anon_sym_QMARK] = ACTIONS(2518),
    [anon_sym_COLON_QMARK] = ACTIONS(2518),
    [anon_sym_COLON_COLON] = ACTIONS(2520),
    [anon_sym_AMP] = ACTIONS(2518),
    [anon_sym_LBRACK] = ACTIONS(2518),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2520),
    [anon_sym_LBRACE] = ACTIONS(2518),
    [anon_sym_LT_AT] = ACTIONS(2518),
    [anon_sym_LT_AT_AT] = ACTIONS(2518),
    [anon_sym_DOT] = ACTIONS(2518),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2520),
    [anon_sym_new] = ACTIONS(2518),
    [anon_sym_return_BANG] = ACTIONS(2520),
    [anon_sym_yield] = ACTIONS(2518),
    [anon_sym_yield_BANG] = ACTIONS(2520),
    [anon_sym_lazy] = ACTIONS(2518),
    [anon_sym_assert] = ACTIONS(2518),
    [anon_sym_upcast] = ACTIONS(2518),
    [anon_sym_downcast] = ACTIONS(2518),
    [anon_sym_COLON_GT] = ACTIONS(2520),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2520),
    [anon_sym_for] = ACTIONS(2518),
    [anon_sym_while] = ACTIONS(2518),
    [anon_sym_else] = ACTIONS(2518),
    [anon_sym_elif] = ACTIONS(3479),
    [anon_sym_if] = ACTIONS(2518),
    [anon_sym_fun] = ACTIONS(2518),
    [anon_sym_try] = ACTIONS(2518),
    [anon_sym_match] = ACTIONS(2518),
    [anon_sym_match_BANG] = ACTIONS(2520),
    [anon_sym_function] = ACTIONS(2518),
    [anon_sym_LT_DASH] = ACTIONS(2518),
    [anon_sym_DOT_LBRACK] = ACTIONS(2520),
    [anon_sym_LT] = ACTIONS(2520),
    [anon_sym_GT] = ACTIONS(2518),
    [anon_sym_use] = ACTIONS(2518),
    [anon_sym_use_BANG] = ACTIONS(2520),
    [anon_sym_do_BANG] = ACTIONS(2520),
    [anon_sym_begin] = ACTIONS(2518),
    [anon_sym_LPAREN2] = ACTIONS(2518),
    [anon_sym_or] = ACTIONS(2518),
    [aux_sym_char_token1] = ACTIONS(2520),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2518),
    [anon_sym_DQUOTE] = ACTIONS(2518),
    [anon_sym_AT_DQUOTE] = ACTIONS(2520),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2520),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2520),
    [sym_bool] = ACTIONS(2518),
    [sym_unit] = ACTIONS(2520),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2518),
    [sym_op_identifier] = ACTIONS(2518),
    [anon_sym_PLUS] = ACTIONS(2518),
    [anon_sym_DASH] = ACTIONS(2518),
    [anon_sym_PLUS_DOT] = ACTIONS(2518),
    [anon_sym_DASH_DOT] = ACTIONS(2518),
    [anon_sym_PERCENT] = ACTIONS(2518),
    [anon_sym_AMP_AMP] = ACTIONS(2518),
    [anon_sym_TILDE] = ACTIONS(2520),
    [aux_sym_prefix_op_token1] = ACTIONS(2518),
    [aux_sym_infix_op_token1] = ACTIONS(2520),
    [aux_sym_infix_op_token2] = ACTIONS(2518),
    [anon_sym_PIPE_PIPE] = ACTIONS(2518),
    [anon_sym_BANG_EQ] = ACTIONS(2518),
    [anon_sym_COLON_EQ] = ACTIONS(2520),
    [anon_sym_DOLLAR] = ACTIONS(2518),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2518),
    [sym_int] = ACTIONS(2518),
    [sym_xint] = ACTIONS(2520),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2520),
    [sym__newline] = ACTIONS(2520),
  },
  [1289] = {
    [sym_elif_expression] = STATE(1659),
    [sym_block_comment] = STATE(1289),
    [sym_compiler_directive_decl] = STATE(1289),
    [sym_fsi_directive_decl] = STATE(1289),
    [sym_preproc_line] = STATE(1289),
    [aux_sym_if_expression_repeat1] = STATE(1289),
    [sym_identifier] = ACTIONS(2518),
    [anon_sym_EQ] = ACTIONS(2520),
    [anon_sym_COLON] = ACTIONS(2518),
    [anon_sym_return] = ACTIONS(2518),
    [anon_sym_do] = ACTIONS(2518),
    [anon_sym_let] = ACTIONS(2518),
    [anon_sym_let_BANG] = ACTIONS(2520),
    [anon_sym_LPAREN] = ACTIONS(2518),
    [anon_sym_COMMA] = ACTIONS(2520),
    [anon_sym_null] = ACTIONS(2518),
    [anon_sym_QMARK] = ACTIONS(2518),
    [anon_sym_COLON_QMARK] = ACTIONS(2518),
    [anon_sym_COLON_COLON] = ACTIONS(2520),
    [anon_sym_AMP] = ACTIONS(2518),
    [anon_sym_LBRACK] = ACTIONS(2518),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2520),
    [anon_sym_LBRACE] = ACTIONS(2518),
    [anon_sym_LT_AT] = ACTIONS(2518),
    [anon_sym_LT_AT_AT] = ACTIONS(2518),
    [anon_sym_DOT] = ACTIONS(2518),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2520),
    [anon_sym_new] = ACTIONS(2518),
    [anon_sym_return_BANG] = ACTIONS(2520),
    [anon_sym_yield] = ACTIONS(2518),
    [anon_sym_yield_BANG] = ACTIONS(2520),
    [anon_sym_lazy] = ACTIONS(2518),
    [anon_sym_assert] = ACTIONS(2518),
    [anon_sym_upcast] = ACTIONS(2518),
    [anon_sym_downcast] = ACTIONS(2518),
    [anon_sym_COLON_GT] = ACTIONS(2520),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2520),
    [anon_sym_for] = ACTIONS(2518),
    [anon_sym_while] = ACTIONS(2518),
    [anon_sym_else] = ACTIONS(2518),
    [anon_sym_elif] = ACTIONS(3482),
    [anon_sym_if] = ACTIONS(2518),
    [anon_sym_fun] = ACTIONS(2518),
    [anon_sym_try] = ACTIONS(2518),
    [anon_sym_match] = ACTIONS(2518),
    [anon_sym_match_BANG] = ACTIONS(2520),
    [anon_sym_function] = ACTIONS(2518),
    [anon_sym_LT_DASH] = ACTIONS(2518),
    [anon_sym_DOT_LBRACK] = ACTIONS(2520),
    [anon_sym_LT] = ACTIONS(2520),
    [anon_sym_use] = ACTIONS(2518),
    [anon_sym_use_BANG] = ACTIONS(2520),
    [anon_sym_do_BANG] = ACTIONS(2520),
    [anon_sym_DOT_DOT] = ACTIONS(2520),
    [anon_sym_begin] = ACTIONS(2518),
    [anon_sym_LPAREN2] = ACTIONS(2518),
    [anon_sym_or] = ACTIONS(2518),
    [aux_sym_char_token1] = ACTIONS(2520),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2518),
    [anon_sym_DQUOTE] = ACTIONS(2518),
    [anon_sym_AT_DQUOTE] = ACTIONS(2520),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2520),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2520),
    [sym_bool] = ACTIONS(2518),
    [sym_unit] = ACTIONS(2520),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2518),
    [sym_op_identifier] = ACTIONS(2518),
    [anon_sym_PLUS] = ACTIONS(2518),
    [anon_sym_DASH] = ACTIONS(2518),
    [anon_sym_PLUS_DOT] = ACTIONS(2518),
    [anon_sym_DASH_DOT] = ACTIONS(2518),
    [anon_sym_PERCENT] = ACTIONS(2518),
    [anon_sym_AMP_AMP] = ACTIONS(2518),
    [anon_sym_TILDE] = ACTIONS(2520),
    [aux_sym_prefix_op_token1] = ACTIONS(2518),
    [aux_sym_infix_op_token1] = ACTIONS(2520),
    [aux_sym_infix_op_token2] = ACTIONS(2518),
    [anon_sym_PIPE_PIPE] = ACTIONS(2518),
    [anon_sym_BANG_EQ] = ACTIONS(2518),
    [anon_sym_COLON_EQ] = ACTIONS(2520),
    [anon_sym_DOLLAR] = ACTIONS(2518),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2518),
    [sym_int] = ACTIONS(2518),
    [sym_xint] = ACTIONS(2520),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2520),
    [sym__newline] = ACTIONS(2520),
  },
  [1290] = {
    [sym_block_comment] = STATE(1290),
    [sym_compiler_directive_decl] = STATE(1290),
    [sym_fsi_directive_decl] = STATE(1290),
    [sym_preproc_line] = STATE(1290),
    [sym_identifier] = ACTIONS(2454),
    [anon_sym_EQ] = ACTIONS(2456),
    [anon_sym_COLON] = ACTIONS(2454),
    [anon_sym_return] = ACTIONS(2454),
    [anon_sym_do] = ACTIONS(2454),
    [anon_sym_let] = ACTIONS(2454),
    [anon_sym_let_BANG] = ACTIONS(2456),
    [anon_sym_LPAREN] = ACTIONS(2454),
    [anon_sym_COMMA] = ACTIONS(2456),
    [anon_sym_null] = ACTIONS(2454),
    [anon_sym_QMARK] = ACTIONS(2454),
    [anon_sym_COLON_QMARK] = ACTIONS(2454),
    [anon_sym_COLON_COLON] = ACTIONS(2456),
    [anon_sym_AMP] = ACTIONS(2454),
    [anon_sym_LBRACK] = ACTIONS(2454),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2456),
    [anon_sym_LBRACE] = ACTIONS(2454),
    [anon_sym_LT_AT] = ACTIONS(2454),
    [anon_sym_LT_AT_AT] = ACTIONS(2454),
    [anon_sym_DOT] = ACTIONS(2454),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2456),
    [anon_sym_new] = ACTIONS(2454),
    [anon_sym_return_BANG] = ACTIONS(2456),
    [anon_sym_yield] = ACTIONS(2454),
    [anon_sym_yield_BANG] = ACTIONS(2456),
    [anon_sym_lazy] = ACTIONS(2454),
    [anon_sym_assert] = ACTIONS(2454),
    [anon_sym_upcast] = ACTIONS(2454),
    [anon_sym_downcast] = ACTIONS(2454),
    [anon_sym_COLON_GT] = ACTIONS(2456),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2456),
    [anon_sym_for] = ACTIONS(2454),
    [anon_sym_while] = ACTIONS(2454),
    [anon_sym_if] = ACTIONS(2454),
    [anon_sym_fun] = ACTIONS(2454),
    [anon_sym_DASH_GT] = ACTIONS(2454),
    [anon_sym_try] = ACTIONS(2454),
    [anon_sym_match] = ACTIONS(2454),
    [anon_sym_match_BANG] = ACTIONS(2456),
    [anon_sym_function] = ACTIONS(2454),
    [anon_sym_LT_DASH] = ACTIONS(2454),
    [anon_sym_DOT_LBRACK] = ACTIONS(2456),
    [anon_sym_LT] = ACTIONS(2456),
    [anon_sym_GT] = ACTIONS(2454),
    [anon_sym_use] = ACTIONS(2454),
    [anon_sym_use_BANG] = ACTIONS(2456),
    [anon_sym_do_BANG] = ACTIONS(2456),
    [anon_sym_begin] = ACTIONS(2454),
    [anon_sym_LPAREN2] = ACTIONS(2454),
    [anon_sym_STAR] = ACTIONS(2454),
    [anon_sym_LT2] = ACTIONS(2454),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2456),
    [anon_sym_or] = ACTIONS(2454),
    [aux_sym_char_token1] = ACTIONS(2456),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2454),
    [anon_sym_DQUOTE] = ACTIONS(2454),
    [anon_sym_AT_DQUOTE] = ACTIONS(2456),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2456),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2456),
    [sym_bool] = ACTIONS(2454),
    [sym_unit] = ACTIONS(2456),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2454),
    [sym_op_identifier] = ACTIONS(2454),
    [anon_sym_PLUS] = ACTIONS(2454),
    [anon_sym_DASH] = ACTIONS(2454),
    [anon_sym_PLUS_DOT] = ACTIONS(2454),
    [anon_sym_DASH_DOT] = ACTIONS(2454),
    [anon_sym_PERCENT] = ACTIONS(2454),
    [anon_sym_AMP_AMP] = ACTIONS(2454),
    [anon_sym_TILDE] = ACTIONS(2456),
    [aux_sym_prefix_op_token1] = ACTIONS(2454),
    [aux_sym_infix_op_token1] = ACTIONS(2456),
    [aux_sym_infix_op_token2] = ACTIONS(2454),
    [anon_sym_PIPE_PIPE] = ACTIONS(2454),
    [anon_sym_BANG_EQ] = ACTIONS(2454),
    [anon_sym_COLON_EQ] = ACTIONS(2456),
    [anon_sym_DOLLAR] = ACTIONS(2454),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2454),
    [sym_int] = ACTIONS(2454),
    [sym_xint] = ACTIONS(2456),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2456),
    [sym__newline] = ACTIONS(2456),
  },
  [1291] = {
    [sym_block_comment] = STATE(1291),
    [sym_compiler_directive_decl] = STATE(1291),
    [sym_fsi_directive_decl] = STATE(1291),
    [sym_preproc_line] = STATE(1291),
    [sym_identifier] = ACTIONS(2783),
    [anon_sym_EQ] = ACTIONS(2785),
    [anon_sym_COLON] = ACTIONS(2783),
    [anon_sym_return] = ACTIONS(2783),
    [anon_sym_do] = ACTIONS(2783),
    [anon_sym_let] = ACTIONS(2783),
    [anon_sym_let_BANG] = ACTIONS(2785),
    [anon_sym_LPAREN] = ACTIONS(2783),
    [anon_sym_COMMA] = ACTIONS(2785),
    [anon_sym_null] = ACTIONS(2783),
    [anon_sym_QMARK] = ACTIONS(2783),
    [anon_sym_COLON_QMARK] = ACTIONS(2783),
    [anon_sym_COLON_COLON] = ACTIONS(2785),
    [anon_sym_AMP] = ACTIONS(2783),
    [anon_sym_LBRACK] = ACTIONS(2783),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2785),
    [anon_sym_LBRACE] = ACTIONS(2783),
    [anon_sym_LT_AT] = ACTIONS(2783),
    [anon_sym_LT_AT_AT] = ACTIONS(2783),
    [anon_sym_DOT] = ACTIONS(2783),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2785),
    [anon_sym_new] = ACTIONS(2783),
    [anon_sym_with] = ACTIONS(2783),
    [anon_sym_return_BANG] = ACTIONS(2785),
    [anon_sym_yield] = ACTIONS(2783),
    [anon_sym_yield_BANG] = ACTIONS(2785),
    [anon_sym_lazy] = ACTIONS(2783),
    [anon_sym_assert] = ACTIONS(2783),
    [anon_sym_upcast] = ACTIONS(2783),
    [anon_sym_downcast] = ACTIONS(2783),
    [anon_sym_COLON_GT] = ACTIONS(2785),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2785),
    [anon_sym_for] = ACTIONS(2783),
    [anon_sym_done] = ACTIONS(2787),
    [anon_sym_while] = ACTIONS(2783),
    [anon_sym_if] = ACTIONS(2783),
    [anon_sym_fun] = ACTIONS(2783),
    [anon_sym_DASH_GT] = ACTIONS(2881),
    [anon_sym_try] = ACTIONS(2783),
    [anon_sym_match] = ACTIONS(2783),
    [anon_sym_match_BANG] = ACTIONS(2785),
    [anon_sym_function] = ACTIONS(2783),
    [anon_sym_LT_DASH] = ACTIONS(2783),
    [anon_sym_DOT_LBRACK] = ACTIONS(2785),
    [anon_sym_LT] = ACTIONS(2785),
    [anon_sym_use] = ACTIONS(2783),
    [anon_sym_use_BANG] = ACTIONS(2785),
    [anon_sym_do_BANG] = ACTIONS(2785),
    [anon_sym_DOT_DOT] = ACTIONS(2789),
    [anon_sym_begin] = ACTIONS(2783),
    [anon_sym_LPAREN2] = ACTIONS(2783),
    [anon_sym_or] = ACTIONS(2783),
    [aux_sym_char_token1] = ACTIONS(2785),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2783),
    [anon_sym_DQUOTE] = ACTIONS(2783),
    [anon_sym_AT_DQUOTE] = ACTIONS(2785),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2785),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2785),
    [sym_bool] = ACTIONS(2783),
    [sym_unit] = ACTIONS(2785),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2783),
    [sym_op_identifier] = ACTIONS(2783),
    [anon_sym_PLUS] = ACTIONS(2783),
    [anon_sym_DASH] = ACTIONS(2783),
    [anon_sym_PLUS_DOT] = ACTIONS(2783),
    [anon_sym_DASH_DOT] = ACTIONS(2783),
    [anon_sym_PERCENT] = ACTIONS(2783),
    [anon_sym_AMP_AMP] = ACTIONS(2783),
    [anon_sym_TILDE] = ACTIONS(2785),
    [aux_sym_prefix_op_token1] = ACTIONS(2783),
    [aux_sym_infix_op_token1] = ACTIONS(2785),
    [aux_sym_infix_op_token2] = ACTIONS(2783),
    [anon_sym_PIPE_PIPE] = ACTIONS(2783),
    [anon_sym_BANG_EQ] = ACTIONS(2783),
    [anon_sym_COLON_EQ] = ACTIONS(2785),
    [anon_sym_DOLLAR] = ACTIONS(2783),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2783),
    [sym_int] = ACTIONS(2783),
    [sym_xint] = ACTIONS(2785),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2785),
    [sym__newline] = ACTIONS(2785),
    [sym__dedent] = ACTIONS(2785),
  },
  [1292] = {
    [sym_block_comment] = STATE(1292),
    [sym_compiler_directive_decl] = STATE(1292),
    [sym_fsi_directive_decl] = STATE(1292),
    [sym_preproc_line] = STATE(1292),
    [sym_identifier] = ACTIONS(2627),
    [anon_sym_EQ] = ACTIONS(2629),
    [anon_sym_COLON] = ACTIONS(2627),
    [anon_sym_return] = ACTIONS(2627),
    [anon_sym_do] = ACTIONS(2627),
    [anon_sym_let] = ACTIONS(2627),
    [anon_sym_let_BANG] = ACTIONS(2629),
    [anon_sym_LPAREN] = ACTIONS(2627),
    [anon_sym_COMMA] = ACTIONS(2629),
    [anon_sym_null] = ACTIONS(2627),
    [anon_sym_QMARK] = ACTIONS(2627),
    [anon_sym_COLON_QMARK] = ACTIONS(2627),
    [anon_sym_COLON_COLON] = ACTIONS(2629),
    [anon_sym_AMP] = ACTIONS(2627),
    [anon_sym_LBRACK] = ACTIONS(2627),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2629),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_LT_AT] = ACTIONS(2627),
    [anon_sym_LT_AT_AT] = ACTIONS(2627),
    [anon_sym_DOT] = ACTIONS(2627),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2629),
    [anon_sym_new] = ACTIONS(2627),
    [anon_sym_return_BANG] = ACTIONS(2629),
    [anon_sym_yield] = ACTIONS(2627),
    [anon_sym_yield_BANG] = ACTIONS(2629),
    [anon_sym_lazy] = ACTIONS(2627),
    [anon_sym_assert] = ACTIONS(2627),
    [anon_sym_upcast] = ACTIONS(2627),
    [anon_sym_downcast] = ACTIONS(2627),
    [anon_sym_COLON_GT] = ACTIONS(2629),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2629),
    [anon_sym_for] = ACTIONS(2627),
    [anon_sym_while] = ACTIONS(2627),
    [anon_sym_if] = ACTIONS(2627),
    [anon_sym_fun] = ACTIONS(2627),
    [anon_sym_DASH_GT] = ACTIONS(2627),
    [anon_sym_try] = ACTIONS(2627),
    [anon_sym_match] = ACTIONS(2627),
    [anon_sym_match_BANG] = ACTIONS(2629),
    [anon_sym_function] = ACTIONS(2627),
    [anon_sym_LT_DASH] = ACTIONS(2627),
    [anon_sym_DOT_LBRACK] = ACTIONS(2629),
    [anon_sym_LT] = ACTIONS(2629),
    [anon_sym_GT] = ACTIONS(2627),
    [anon_sym_use] = ACTIONS(2627),
    [anon_sym_use_BANG] = ACTIONS(2629),
    [anon_sym_do_BANG] = ACTIONS(2629),
    [anon_sym_begin] = ACTIONS(2627),
    [anon_sym_LPAREN2] = ACTIONS(2627),
    [anon_sym_STAR] = ACTIONS(2627),
    [anon_sym_LT2] = ACTIONS(2627),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2629),
    [anon_sym_or] = ACTIONS(2627),
    [aux_sym_char_token1] = ACTIONS(2629),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2627),
    [anon_sym_DQUOTE] = ACTIONS(2627),
    [anon_sym_AT_DQUOTE] = ACTIONS(2629),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2629),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2629),
    [sym_bool] = ACTIONS(2627),
    [sym_unit] = ACTIONS(2629),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2627),
    [sym_op_identifier] = ACTIONS(2627),
    [anon_sym_PLUS] = ACTIONS(2627),
    [anon_sym_DASH] = ACTIONS(2627),
    [anon_sym_PLUS_DOT] = ACTIONS(2627),
    [anon_sym_DASH_DOT] = ACTIONS(2627),
    [anon_sym_PERCENT] = ACTIONS(2627),
    [anon_sym_AMP_AMP] = ACTIONS(2627),
    [anon_sym_TILDE] = ACTIONS(2629),
    [aux_sym_prefix_op_token1] = ACTIONS(2627),
    [aux_sym_infix_op_token1] = ACTIONS(2629),
    [aux_sym_infix_op_token2] = ACTIONS(2627),
    [anon_sym_PIPE_PIPE] = ACTIONS(2627),
    [anon_sym_BANG_EQ] = ACTIONS(2627),
    [anon_sym_COLON_EQ] = ACTIONS(2629),
    [anon_sym_DOLLAR] = ACTIONS(2627),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2627),
    [sym_int] = ACTIONS(2627),
    [sym_xint] = ACTIONS(2629),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2629),
    [sym__newline] = ACTIONS(2629),
  },
  [1293] = {
    [sym_block_comment] = STATE(1293),
    [sym_compiler_directive_decl] = STATE(1293),
    [sym_fsi_directive_decl] = STATE(1293),
    [sym_preproc_line] = STATE(1293),
    [sym_identifier] = ACTIONS(2470),
    [anon_sym_EQ] = ACTIONS(2472),
    [anon_sym_COLON] = ACTIONS(2470),
    [anon_sym_return] = ACTIONS(2470),
    [anon_sym_do] = ACTIONS(2470),
    [anon_sym_let] = ACTIONS(2470),
    [anon_sym_let_BANG] = ACTIONS(2472),
    [anon_sym_LPAREN] = ACTIONS(2470),
    [anon_sym_COMMA] = ACTIONS(2472),
    [anon_sym_null] = ACTIONS(2470),
    [anon_sym_QMARK] = ACTIONS(2470),
    [anon_sym_COLON_QMARK] = ACTIONS(2470),
    [anon_sym_COLON_COLON] = ACTIONS(2472),
    [anon_sym_AMP] = ACTIONS(2470),
    [anon_sym_LBRACK] = ACTIONS(2470),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2472),
    [anon_sym_LBRACE] = ACTIONS(2470),
    [anon_sym_LT_AT] = ACTIONS(2470),
    [anon_sym_LT_AT_AT] = ACTIONS(2470),
    [anon_sym_DOT] = ACTIONS(2470),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2472),
    [anon_sym_new] = ACTIONS(2470),
    [anon_sym_return_BANG] = ACTIONS(2472),
    [anon_sym_yield] = ACTIONS(2470),
    [anon_sym_yield_BANG] = ACTIONS(2472),
    [anon_sym_lazy] = ACTIONS(2470),
    [anon_sym_assert] = ACTIONS(2470),
    [anon_sym_upcast] = ACTIONS(2470),
    [anon_sym_downcast] = ACTIONS(2470),
    [anon_sym_COLON_GT] = ACTIONS(2472),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2472),
    [anon_sym_for] = ACTIONS(2470),
    [anon_sym_while] = ACTIONS(2470),
    [anon_sym_if] = ACTIONS(2470),
    [anon_sym_fun] = ACTIONS(2470),
    [anon_sym_DASH_GT] = ACTIONS(2470),
    [anon_sym_try] = ACTIONS(2470),
    [anon_sym_match] = ACTIONS(2470),
    [anon_sym_match_BANG] = ACTIONS(2472),
    [anon_sym_function] = ACTIONS(2470),
    [anon_sym_LT_DASH] = ACTIONS(2470),
    [anon_sym_DOT_LBRACK] = ACTIONS(2472),
    [anon_sym_LT] = ACTIONS(2472),
    [anon_sym_GT] = ACTIONS(2470),
    [anon_sym_use] = ACTIONS(2470),
    [anon_sym_use_BANG] = ACTIONS(2472),
    [anon_sym_do_BANG] = ACTIONS(2472),
    [anon_sym_begin] = ACTIONS(2470),
    [anon_sym_LPAREN2] = ACTIONS(2470),
    [anon_sym_STAR] = ACTIONS(2470),
    [anon_sym_LT2] = ACTIONS(2470),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2472),
    [anon_sym_or] = ACTIONS(2470),
    [aux_sym_char_token1] = ACTIONS(2472),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2470),
    [anon_sym_DQUOTE] = ACTIONS(2470),
    [anon_sym_AT_DQUOTE] = ACTIONS(2472),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2472),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2472),
    [sym_bool] = ACTIONS(2470),
    [sym_unit] = ACTIONS(2472),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2470),
    [sym_op_identifier] = ACTIONS(2470),
    [anon_sym_PLUS] = ACTIONS(2470),
    [anon_sym_DASH] = ACTIONS(2470),
    [anon_sym_PLUS_DOT] = ACTIONS(2470),
    [anon_sym_DASH_DOT] = ACTIONS(2470),
    [anon_sym_PERCENT] = ACTIONS(2470),
    [anon_sym_AMP_AMP] = ACTIONS(2470),
    [anon_sym_TILDE] = ACTIONS(2472),
    [aux_sym_prefix_op_token1] = ACTIONS(2470),
    [aux_sym_infix_op_token1] = ACTIONS(2472),
    [aux_sym_infix_op_token2] = ACTIONS(2470),
    [anon_sym_PIPE_PIPE] = ACTIONS(2470),
    [anon_sym_BANG_EQ] = ACTIONS(2470),
    [anon_sym_COLON_EQ] = ACTIONS(2472),
    [anon_sym_DOLLAR] = ACTIONS(2470),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2470),
    [sym_int] = ACTIONS(2470),
    [sym_xint] = ACTIONS(2472),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2472),
    [sym__newline] = ACTIONS(2472),
  },
  [1294] = {
    [sym_block_comment] = STATE(1294),
    [sym_compiler_directive_decl] = STATE(1294),
    [sym_fsi_directive_decl] = STATE(1294),
    [sym_preproc_line] = STATE(1294),
    [aux_sym_rules_repeat1] = STATE(1284),
    [sym_identifier] = ACTIONS(2737),
    [anon_sym_EQ] = ACTIONS(2739),
    [anon_sym_COLON] = ACTIONS(2737),
    [anon_sym_return] = ACTIONS(2737),
    [anon_sym_do] = ACTIONS(2737),
    [anon_sym_let] = ACTIONS(2737),
    [anon_sym_let_BANG] = ACTIONS(2739),
    [anon_sym_as] = ACTIONS(2737),
    [anon_sym_LPAREN] = ACTIONS(2737),
    [anon_sym_COMMA] = ACTIONS(2739),
    [anon_sym_null] = ACTIONS(2737),
    [anon_sym_QMARK] = ACTIONS(2737),
    [anon_sym_COLON_QMARK] = ACTIONS(2737),
    [anon_sym_COLON_COLON] = ACTIONS(2739),
    [anon_sym_PIPE] = ACTIONS(3485),
    [anon_sym_AMP] = ACTIONS(2737),
    [anon_sym_LBRACK] = ACTIONS(2737),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2739),
    [anon_sym_LBRACE] = ACTIONS(2737),
    [anon_sym_LT_AT] = ACTIONS(2737),
    [anon_sym_LT_AT_AT] = ACTIONS(2737),
    [anon_sym_DOT] = ACTIONS(2737),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2739),
    [anon_sym_new] = ACTIONS(2737),
    [anon_sym_with] = ACTIONS(2737),
    [anon_sym_return_BANG] = ACTIONS(2739),
    [anon_sym_yield] = ACTIONS(2737),
    [anon_sym_yield_BANG] = ACTIONS(2739),
    [anon_sym_lazy] = ACTIONS(2737),
    [anon_sym_assert] = ACTIONS(2737),
    [anon_sym_upcast] = ACTIONS(2737),
    [anon_sym_downcast] = ACTIONS(2737),
    [anon_sym_COLON_GT] = ACTIONS(2739),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2739),
    [anon_sym_for] = ACTIONS(2737),
    [anon_sym_while] = ACTIONS(2737),
    [anon_sym_if] = ACTIONS(2737),
    [anon_sym_fun] = ACTIONS(2737),
    [anon_sym_try] = ACTIONS(2737),
    [anon_sym_match] = ACTIONS(2737),
    [anon_sym_match_BANG] = ACTIONS(2739),
    [anon_sym_function] = ACTIONS(2737),
    [anon_sym_LT_DASH] = ACTIONS(2737),
    [anon_sym_DOT_LBRACK] = ACTIONS(2739),
    [anon_sym_LT] = ACTIONS(2739),
    [anon_sym_use] = ACTIONS(2737),
    [anon_sym_use_BANG] = ACTIONS(2739),
    [anon_sym_do_BANG] = ACTIONS(2739),
    [anon_sym_begin] = ACTIONS(2737),
    [anon_sym_LPAREN2] = ACTIONS(2737),
    [anon_sym_or] = ACTIONS(2737),
    [aux_sym_char_token1] = ACTIONS(2739),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2737),
    [anon_sym_DQUOTE] = ACTIONS(2737),
    [anon_sym_AT_DQUOTE] = ACTIONS(2739),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2739),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2739),
    [sym_bool] = ACTIONS(2737),
    [sym_unit] = ACTIONS(2739),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2737),
    [sym_op_identifier] = ACTIONS(2737),
    [anon_sym_PLUS] = ACTIONS(2737),
    [anon_sym_DASH] = ACTIONS(2737),
    [anon_sym_PLUS_DOT] = ACTIONS(2737),
    [anon_sym_DASH_DOT] = ACTIONS(2737),
    [anon_sym_PERCENT] = ACTIONS(2737),
    [anon_sym_AMP_AMP] = ACTIONS(2737),
    [anon_sym_TILDE] = ACTIONS(2739),
    [aux_sym_prefix_op_token1] = ACTIONS(2737),
    [aux_sym_infix_op_token1] = ACTIONS(2739),
    [aux_sym_infix_op_token2] = ACTIONS(2737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2737),
    [anon_sym_BANG_EQ] = ACTIONS(2737),
    [anon_sym_COLON_EQ] = ACTIONS(2739),
    [anon_sym_DOLLAR] = ACTIONS(2737),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2737),
    [sym_int] = ACTIONS(2737),
    [sym_xint] = ACTIONS(2739),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2739),
    [sym__newline] = ACTIONS(3487),
    [sym__dedent] = ACTIONS(2739),
  },
  [1295] = {
    [sym_block_comment] = STATE(1295),
    [sym_compiler_directive_decl] = STATE(1295),
    [sym_fsi_directive_decl] = STATE(1295),
    [sym_preproc_line] = STATE(1295),
    [sym_identifier] = ACTIONS(2470),
    [anon_sym_EQ] = ACTIONS(2472),
    [anon_sym_COLON] = ACTIONS(2470),
    [anon_sym_return] = ACTIONS(2470),
    [anon_sym_do] = ACTIONS(2470),
    [anon_sym_let] = ACTIONS(2470),
    [anon_sym_let_BANG] = ACTIONS(2472),
    [anon_sym_LPAREN] = ACTIONS(2470),
    [anon_sym_COMMA] = ACTIONS(2472),
    [anon_sym_null] = ACTIONS(2470),
    [anon_sym_QMARK] = ACTIONS(2470),
    [anon_sym_COLON_QMARK] = ACTIONS(2470),
    [anon_sym_COLON_COLON] = ACTIONS(2472),
    [anon_sym_AMP] = ACTIONS(2470),
    [anon_sym_LBRACK] = ACTIONS(2470),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2472),
    [anon_sym_LBRACE] = ACTIONS(2470),
    [anon_sym_LT_AT] = ACTIONS(2470),
    [anon_sym_LT_AT_AT] = ACTIONS(2470),
    [anon_sym_AT_AT_GT] = ACTIONS(2470),
    [anon_sym_DOT] = ACTIONS(2470),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2472),
    [anon_sym_new] = ACTIONS(2470),
    [anon_sym_return_BANG] = ACTIONS(2472),
    [anon_sym_yield] = ACTIONS(2470),
    [anon_sym_yield_BANG] = ACTIONS(2472),
    [anon_sym_lazy] = ACTIONS(2470),
    [anon_sym_assert] = ACTIONS(2470),
    [anon_sym_upcast] = ACTIONS(2470),
    [anon_sym_downcast] = ACTIONS(2470),
    [anon_sym_COLON_GT] = ACTIONS(2472),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2472),
    [anon_sym_for] = ACTIONS(2470),
    [anon_sym_while] = ACTIONS(2470),
    [anon_sym_if] = ACTIONS(2470),
    [anon_sym_fun] = ACTIONS(2470),
    [anon_sym_DASH_GT] = ACTIONS(2470),
    [anon_sym_try] = ACTIONS(2470),
    [anon_sym_match] = ACTIONS(2470),
    [anon_sym_match_BANG] = ACTIONS(2472),
    [anon_sym_function] = ACTIONS(2470),
    [anon_sym_LT_DASH] = ACTIONS(2470),
    [anon_sym_DOT_LBRACK] = ACTIONS(2472),
    [anon_sym_LT] = ACTIONS(2472),
    [anon_sym_use] = ACTIONS(2470),
    [anon_sym_use_BANG] = ACTIONS(2472),
    [anon_sym_do_BANG] = ACTIONS(2472),
    [anon_sym_begin] = ACTIONS(2470),
    [anon_sym_LPAREN2] = ACTIONS(2470),
    [anon_sym_STAR] = ACTIONS(2470),
    [anon_sym_LT2] = ACTIONS(2470),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2472),
    [anon_sym_or] = ACTIONS(2470),
    [aux_sym_char_token1] = ACTIONS(2472),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2470),
    [anon_sym_DQUOTE] = ACTIONS(2470),
    [anon_sym_AT_DQUOTE] = ACTIONS(2472),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2472),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2472),
    [sym_bool] = ACTIONS(2470),
    [sym_unit] = ACTIONS(2472),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2470),
    [sym_op_identifier] = ACTIONS(2470),
    [anon_sym_PLUS] = ACTIONS(2470),
    [anon_sym_DASH] = ACTIONS(2470),
    [anon_sym_PLUS_DOT] = ACTIONS(2470),
    [anon_sym_DASH_DOT] = ACTIONS(2470),
    [anon_sym_PERCENT] = ACTIONS(2470),
    [anon_sym_AMP_AMP] = ACTIONS(2470),
    [anon_sym_TILDE] = ACTIONS(2472),
    [aux_sym_prefix_op_token1] = ACTIONS(2470),
    [aux_sym_infix_op_token1] = ACTIONS(2472),
    [aux_sym_infix_op_token2] = ACTIONS(2470),
    [anon_sym_PIPE_PIPE] = ACTIONS(2470),
    [anon_sym_BANG_EQ] = ACTIONS(2470),
    [anon_sym_COLON_EQ] = ACTIONS(2472),
    [anon_sym_DOLLAR] = ACTIONS(2470),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2470),
    [sym_int] = ACTIONS(2470),
    [sym_xint] = ACTIONS(2472),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2472),
    [sym__newline] = ACTIONS(2472),
  },
  [1296] = {
    [sym_block_comment] = STATE(1296),
    [sym_compiler_directive_decl] = STATE(1296),
    [sym_fsi_directive_decl] = STATE(1296),
    [sym_preproc_line] = STATE(1296),
    [sym_identifier] = ACTIONS(2506),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_COLON] = ACTIONS(2506),
    [anon_sym_return] = ACTIONS(2506),
    [anon_sym_do] = ACTIONS(2506),
    [anon_sym_let] = ACTIONS(2506),
    [anon_sym_let_BANG] = ACTIONS(2508),
    [anon_sym_LPAREN] = ACTIONS(2506),
    [anon_sym_COMMA] = ACTIONS(2508),
    [anon_sym_null] = ACTIONS(2506),
    [anon_sym_QMARK] = ACTIONS(2506),
    [anon_sym_COLON_QMARK] = ACTIONS(2506),
    [anon_sym_COLON_COLON] = ACTIONS(2508),
    [anon_sym_AMP] = ACTIONS(2506),
    [anon_sym_LBRACK] = ACTIONS(2506),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2508),
    [anon_sym_LBRACE] = ACTIONS(2506),
    [anon_sym_LT_AT] = ACTIONS(2506),
    [anon_sym_LT_AT_AT] = ACTIONS(2506),
    [anon_sym_DOT] = ACTIONS(2506),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2508),
    [anon_sym_new] = ACTIONS(2506),
    [anon_sym_return_BANG] = ACTIONS(2508),
    [anon_sym_yield] = ACTIONS(2506),
    [anon_sym_yield_BANG] = ACTIONS(2508),
    [anon_sym_lazy] = ACTIONS(2506),
    [anon_sym_assert] = ACTIONS(2506),
    [anon_sym_upcast] = ACTIONS(2506),
    [anon_sym_downcast] = ACTIONS(2506),
    [anon_sym_COLON_GT] = ACTIONS(2508),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2508),
    [anon_sym_for] = ACTIONS(2506),
    [anon_sym_while] = ACTIONS(2506),
    [anon_sym_if] = ACTIONS(2506),
    [anon_sym_fun] = ACTIONS(2506),
    [anon_sym_DASH_GT] = ACTIONS(2506),
    [anon_sym_try] = ACTIONS(2506),
    [anon_sym_match] = ACTIONS(2506),
    [anon_sym_match_BANG] = ACTIONS(2508),
    [anon_sym_function] = ACTIONS(2506),
    [anon_sym_LT_DASH] = ACTIONS(2506),
    [anon_sym_DOT_LBRACK] = ACTIONS(2508),
    [anon_sym_LT] = ACTIONS(2508),
    [anon_sym_GT] = ACTIONS(2506),
    [anon_sym_use] = ACTIONS(2506),
    [anon_sym_use_BANG] = ACTIONS(2508),
    [anon_sym_do_BANG] = ACTIONS(2508),
    [anon_sym_begin] = ACTIONS(2506),
    [anon_sym_LPAREN2] = ACTIONS(2506),
    [anon_sym_STAR] = ACTIONS(2506),
    [anon_sym_LT2] = ACTIONS(2506),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2508),
    [anon_sym_or] = ACTIONS(2506),
    [aux_sym_char_token1] = ACTIONS(2508),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2506),
    [anon_sym_DQUOTE] = ACTIONS(2506),
    [anon_sym_AT_DQUOTE] = ACTIONS(2508),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2508),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2508),
    [sym_bool] = ACTIONS(2506),
    [sym_unit] = ACTIONS(2508),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2506),
    [sym_op_identifier] = ACTIONS(2506),
    [anon_sym_PLUS] = ACTIONS(2506),
    [anon_sym_DASH] = ACTIONS(2506),
    [anon_sym_PLUS_DOT] = ACTIONS(2506),
    [anon_sym_DASH_DOT] = ACTIONS(2506),
    [anon_sym_PERCENT] = ACTIONS(2506),
    [anon_sym_AMP_AMP] = ACTIONS(2506),
    [anon_sym_TILDE] = ACTIONS(2508),
    [aux_sym_prefix_op_token1] = ACTIONS(2506),
    [aux_sym_infix_op_token1] = ACTIONS(2508),
    [aux_sym_infix_op_token2] = ACTIONS(2506),
    [anon_sym_PIPE_PIPE] = ACTIONS(2506),
    [anon_sym_BANG_EQ] = ACTIONS(2506),
    [anon_sym_COLON_EQ] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(2506),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2506),
    [sym_int] = ACTIONS(2506),
    [sym_xint] = ACTIONS(2508),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2508),
    [sym__newline] = ACTIONS(2508),
  },
  [1297] = {
    [sym_block_comment] = STATE(1297),
    [sym_compiler_directive_decl] = STATE(1297),
    [sym_fsi_directive_decl] = STATE(1297),
    [sym_preproc_line] = STATE(1297),
    [sym_identifier] = ACTIONS(2474),
    [anon_sym_EQ] = ACTIONS(2476),
    [anon_sym_COLON] = ACTIONS(2474),
    [anon_sym_return] = ACTIONS(2474),
    [anon_sym_do] = ACTIONS(2474),
    [anon_sym_let] = ACTIONS(2474),
    [anon_sym_let_BANG] = ACTIONS(2476),
    [anon_sym_LPAREN] = ACTIONS(2474),
    [anon_sym_COMMA] = ACTIONS(2476),
    [anon_sym_null] = ACTIONS(2474),
    [anon_sym_QMARK] = ACTIONS(2474),
    [anon_sym_COLON_QMARK] = ACTIONS(2474),
    [anon_sym_COLON_COLON] = ACTIONS(2476),
    [anon_sym_AMP] = ACTIONS(2474),
    [anon_sym_LBRACK] = ACTIONS(2474),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2476),
    [anon_sym_LBRACE] = ACTIONS(2474),
    [anon_sym_LT_AT] = ACTIONS(2474),
    [anon_sym_LT_AT_AT] = ACTIONS(2474),
    [anon_sym_DOT] = ACTIONS(2474),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2476),
    [anon_sym_new] = ACTIONS(2474),
    [anon_sym_return_BANG] = ACTIONS(2476),
    [anon_sym_yield] = ACTIONS(2474),
    [anon_sym_yield_BANG] = ACTIONS(2476),
    [anon_sym_lazy] = ACTIONS(2474),
    [anon_sym_assert] = ACTIONS(2474),
    [anon_sym_upcast] = ACTIONS(2474),
    [anon_sym_downcast] = ACTIONS(2474),
    [anon_sym_COLON_GT] = ACTIONS(2476),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2476),
    [anon_sym_for] = ACTIONS(2474),
    [anon_sym_while] = ACTIONS(2474),
    [anon_sym_if] = ACTIONS(2474),
    [anon_sym_fun] = ACTIONS(2474),
    [anon_sym_DASH_GT] = ACTIONS(2474),
    [anon_sym_try] = ACTIONS(2474),
    [anon_sym_match] = ACTIONS(2474),
    [anon_sym_match_BANG] = ACTIONS(2476),
    [anon_sym_function] = ACTIONS(2474),
    [anon_sym_LT_DASH] = ACTIONS(2474),
    [anon_sym_DOT_LBRACK] = ACTIONS(2476),
    [anon_sym_LT] = ACTIONS(2476),
    [anon_sym_use] = ACTIONS(2474),
    [anon_sym_use_BANG] = ACTIONS(2476),
    [anon_sym_do_BANG] = ACTIONS(2476),
    [anon_sym_begin] = ACTIONS(2474),
    [anon_sym_LPAREN2] = ACTIONS(2474),
    [anon_sym_STAR] = ACTIONS(2474),
    [anon_sym_LT2] = ACTIONS(2474),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2476),
    [anon_sym_or] = ACTIONS(2474),
    [aux_sym_char_token1] = ACTIONS(2476),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2474),
    [anon_sym_DQUOTE] = ACTIONS(2474),
    [anon_sym_AT_DQUOTE] = ACTIONS(2476),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2476),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2476),
    [sym_bool] = ACTIONS(2474),
    [sym_unit] = ACTIONS(2476),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2474),
    [sym_op_identifier] = ACTIONS(2474),
    [anon_sym_PLUS] = ACTIONS(2474),
    [anon_sym_DASH] = ACTIONS(2474),
    [anon_sym_PLUS_DOT] = ACTIONS(2474),
    [anon_sym_DASH_DOT] = ACTIONS(2474),
    [anon_sym_PERCENT] = ACTIONS(2474),
    [anon_sym_AMP_AMP] = ACTIONS(2474),
    [anon_sym_TILDE] = ACTIONS(2476),
    [aux_sym_prefix_op_token1] = ACTIONS(2474),
    [aux_sym_infix_op_token1] = ACTIONS(2476),
    [aux_sym_infix_op_token2] = ACTIONS(2474),
    [anon_sym_PIPE_PIPE] = ACTIONS(2474),
    [anon_sym_BANG_EQ] = ACTIONS(2474),
    [anon_sym_COLON_EQ] = ACTIONS(2476),
    [anon_sym_DOLLAR] = ACTIONS(2474),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2474),
    [sym_int] = ACTIONS(2474),
    [sym_xint] = ACTIONS(2476),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2476),
    [anon_sym_POUNDendif] = ACTIONS(2476),
    [sym__newline] = ACTIONS(2476),
  },
  [1298] = {
    [sym_block_comment] = STATE(1298),
    [sym_compiler_directive_decl] = STATE(1298),
    [sym_fsi_directive_decl] = STATE(1298),
    [sym_preproc_line] = STATE(1298),
    [sym_identifier] = ACTIONS(2567),
    [anon_sym_EQ] = ACTIONS(2569),
    [anon_sym_COLON] = ACTIONS(2567),
    [anon_sym_return] = ACTIONS(2567),
    [anon_sym_do] = ACTIONS(2567),
    [anon_sym_let] = ACTIONS(2567),
    [anon_sym_let_BANG] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2567),
    [anon_sym_COMMA] = ACTIONS(2569),
    [anon_sym_null] = ACTIONS(2567),
    [anon_sym_QMARK] = ACTIONS(2567),
    [anon_sym_COLON_QMARK] = ACTIONS(2567),
    [anon_sym_COLON_COLON] = ACTIONS(2569),
    [anon_sym_AMP] = ACTIONS(2567),
    [anon_sym_LBRACK] = ACTIONS(2567),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2569),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_LT_AT] = ACTIONS(2567),
    [anon_sym_LT_AT_AT] = ACTIONS(2567),
    [anon_sym_AT_AT_GT] = ACTIONS(2567),
    [anon_sym_DOT] = ACTIONS(2567),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2569),
    [anon_sym_new] = ACTIONS(2567),
    [anon_sym_return_BANG] = ACTIONS(2569),
    [anon_sym_yield] = ACTIONS(2567),
    [anon_sym_yield_BANG] = ACTIONS(2569),
    [anon_sym_lazy] = ACTIONS(2567),
    [anon_sym_assert] = ACTIONS(2567),
    [anon_sym_upcast] = ACTIONS(2567),
    [anon_sym_downcast] = ACTIONS(2567),
    [anon_sym_COLON_GT] = ACTIONS(2569),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2569),
    [anon_sym_for] = ACTIONS(2567),
    [anon_sym_while] = ACTIONS(2567),
    [anon_sym_if] = ACTIONS(2567),
    [anon_sym_fun] = ACTIONS(2567),
    [anon_sym_DASH_GT] = ACTIONS(2567),
    [anon_sym_try] = ACTIONS(2567),
    [anon_sym_match] = ACTIONS(2567),
    [anon_sym_match_BANG] = ACTIONS(2569),
    [anon_sym_function] = ACTIONS(2567),
    [anon_sym_LT_DASH] = ACTIONS(2567),
    [anon_sym_DOT_LBRACK] = ACTIONS(2569),
    [anon_sym_LT] = ACTIONS(2569),
    [anon_sym_use] = ACTIONS(2567),
    [anon_sym_use_BANG] = ACTIONS(2569),
    [anon_sym_do_BANG] = ACTIONS(2569),
    [anon_sym_begin] = ACTIONS(2567),
    [anon_sym_LPAREN2] = ACTIONS(2567),
    [anon_sym_STAR] = ACTIONS(2567),
    [anon_sym_LT2] = ACTIONS(2567),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2569),
    [anon_sym_or] = ACTIONS(2567),
    [aux_sym_char_token1] = ACTIONS(2569),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2567),
    [anon_sym_DQUOTE] = ACTIONS(2567),
    [anon_sym_AT_DQUOTE] = ACTIONS(2569),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2569),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2569),
    [sym_bool] = ACTIONS(2567),
    [sym_unit] = ACTIONS(2569),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2567),
    [sym_op_identifier] = ACTIONS(2567),
    [anon_sym_PLUS] = ACTIONS(2567),
    [anon_sym_DASH] = ACTIONS(2567),
    [anon_sym_PLUS_DOT] = ACTIONS(2567),
    [anon_sym_DASH_DOT] = ACTIONS(2567),
    [anon_sym_PERCENT] = ACTIONS(2567),
    [anon_sym_AMP_AMP] = ACTIONS(2567),
    [anon_sym_TILDE] = ACTIONS(2569),
    [aux_sym_prefix_op_token1] = ACTIONS(2567),
    [aux_sym_infix_op_token1] = ACTIONS(2569),
    [aux_sym_infix_op_token2] = ACTIONS(2567),
    [anon_sym_PIPE_PIPE] = ACTIONS(2567),
    [anon_sym_BANG_EQ] = ACTIONS(2567),
    [anon_sym_COLON_EQ] = ACTIONS(2569),
    [anon_sym_DOLLAR] = ACTIONS(2567),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2567),
    [sym_int] = ACTIONS(2567),
    [sym_xint] = ACTIONS(2569),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2569),
    [sym__newline] = ACTIONS(2569),
  },
  [1299] = {
    [sym_block_comment] = STATE(1299),
    [sym_compiler_directive_decl] = STATE(1299),
    [sym_fsi_directive_decl] = STATE(1299),
    [sym_preproc_line] = STATE(1299),
    [sym_identifier] = ACTIONS(2466),
    [anon_sym_EQ] = ACTIONS(2468),
    [anon_sym_COLON] = ACTIONS(2466),
    [anon_sym_return] = ACTIONS(2466),
    [anon_sym_do] = ACTIONS(2466),
    [anon_sym_let] = ACTIONS(2466),
    [anon_sym_let_BANG] = ACTIONS(2468),
    [anon_sym_LPAREN] = ACTIONS(2466),
    [anon_sym_COMMA] = ACTIONS(2468),
    [anon_sym_null] = ACTIONS(2466),
    [anon_sym_QMARK] = ACTIONS(2466),
    [anon_sym_COLON_QMARK] = ACTIONS(2466),
    [anon_sym_COLON_COLON] = ACTIONS(2468),
    [anon_sym_AMP] = ACTIONS(2466),
    [anon_sym_LBRACK] = ACTIONS(2466),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2468),
    [anon_sym_LBRACE] = ACTIONS(2466),
    [anon_sym_LT_AT] = ACTIONS(2466),
    [anon_sym_LT_AT_AT] = ACTIONS(2466),
    [anon_sym_DOT] = ACTIONS(2466),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2468),
    [anon_sym_new] = ACTIONS(2466),
    [anon_sym_return_BANG] = ACTIONS(2468),
    [anon_sym_yield] = ACTIONS(2466),
    [anon_sym_yield_BANG] = ACTIONS(2468),
    [anon_sym_lazy] = ACTIONS(2466),
    [anon_sym_assert] = ACTIONS(2466),
    [anon_sym_upcast] = ACTIONS(2466),
    [anon_sym_downcast] = ACTIONS(2466),
    [anon_sym_COLON_GT] = ACTIONS(2468),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2468),
    [anon_sym_for] = ACTIONS(2466),
    [anon_sym_while] = ACTIONS(2466),
    [anon_sym_if] = ACTIONS(2466),
    [anon_sym_fun] = ACTIONS(2466),
    [anon_sym_DASH_GT] = ACTIONS(2466),
    [anon_sym_try] = ACTIONS(2466),
    [anon_sym_match] = ACTIONS(2466),
    [anon_sym_match_BANG] = ACTIONS(2468),
    [anon_sym_function] = ACTIONS(2466),
    [anon_sym_LT_DASH] = ACTIONS(2466),
    [anon_sym_DOT_LBRACK] = ACTIONS(2468),
    [anon_sym_LT] = ACTIONS(2468),
    [anon_sym_use] = ACTIONS(2466),
    [anon_sym_use_BANG] = ACTIONS(2468),
    [anon_sym_do_BANG] = ACTIONS(2468),
    [anon_sym_begin] = ACTIONS(2466),
    [anon_sym_LPAREN2] = ACTIONS(2466),
    [anon_sym_STAR] = ACTIONS(2466),
    [anon_sym_LT2] = ACTIONS(2466),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2468),
    [anon_sym_or] = ACTIONS(2466),
    [aux_sym_char_token1] = ACTIONS(2468),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2466),
    [anon_sym_DQUOTE] = ACTIONS(2466),
    [anon_sym_AT_DQUOTE] = ACTIONS(2468),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2468),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2468),
    [sym_bool] = ACTIONS(2466),
    [sym_unit] = ACTIONS(2468),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2466),
    [sym_op_identifier] = ACTIONS(2466),
    [anon_sym_PLUS] = ACTIONS(2466),
    [anon_sym_DASH] = ACTIONS(2466),
    [anon_sym_PLUS_DOT] = ACTIONS(2466),
    [anon_sym_DASH_DOT] = ACTIONS(2466),
    [anon_sym_PERCENT] = ACTIONS(2466),
    [anon_sym_AMP_AMP] = ACTIONS(2466),
    [anon_sym_TILDE] = ACTIONS(2468),
    [aux_sym_prefix_op_token1] = ACTIONS(2466),
    [aux_sym_infix_op_token1] = ACTIONS(2468),
    [aux_sym_infix_op_token2] = ACTIONS(2466),
    [anon_sym_PIPE_PIPE] = ACTIONS(2466),
    [anon_sym_BANG_EQ] = ACTIONS(2466),
    [anon_sym_COLON_EQ] = ACTIONS(2468),
    [anon_sym_DOLLAR] = ACTIONS(2466),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2466),
    [sym_int] = ACTIONS(2466),
    [sym_xint] = ACTIONS(2468),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2468),
    [anon_sym_POUNDendif] = ACTIONS(2468),
    [sym__newline] = ACTIONS(2468),
  },
  [1300] = {
    [sym_block_comment] = STATE(1300),
    [sym_compiler_directive_decl] = STATE(1300),
    [sym_fsi_directive_decl] = STATE(1300),
    [sym_preproc_line] = STATE(1300),
    [sym_identifier] = ACTIONS(2567),
    [anon_sym_EQ] = ACTIONS(2569),
    [anon_sym_COLON] = ACTIONS(2567),
    [anon_sym_return] = ACTIONS(2567),
    [anon_sym_do] = ACTIONS(2567),
    [anon_sym_let] = ACTIONS(2567),
    [anon_sym_let_BANG] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2567),
    [anon_sym_COMMA] = ACTIONS(2569),
    [anon_sym_null] = ACTIONS(2567),
    [anon_sym_QMARK] = ACTIONS(2567),
    [anon_sym_COLON_QMARK] = ACTIONS(2567),
    [anon_sym_COLON_COLON] = ACTIONS(2569),
    [anon_sym_AMP] = ACTIONS(2567),
    [anon_sym_LBRACK] = ACTIONS(2567),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2569),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_LT_AT] = ACTIONS(2567),
    [anon_sym_LT_AT_AT] = ACTIONS(2567),
    [anon_sym_AT_AT_GT] = ACTIONS(2567),
    [anon_sym_DOT] = ACTIONS(2567),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2569),
    [anon_sym_new] = ACTIONS(2567),
    [anon_sym_return_BANG] = ACTIONS(2569),
    [anon_sym_yield] = ACTIONS(2567),
    [anon_sym_yield_BANG] = ACTIONS(2569),
    [anon_sym_lazy] = ACTIONS(2567),
    [anon_sym_assert] = ACTIONS(2567),
    [anon_sym_upcast] = ACTIONS(2567),
    [anon_sym_downcast] = ACTIONS(2567),
    [anon_sym_COLON_GT] = ACTIONS(2569),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2569),
    [anon_sym_for] = ACTIONS(2567),
    [anon_sym_while] = ACTIONS(2567),
    [anon_sym_if] = ACTIONS(2567),
    [anon_sym_fun] = ACTIONS(2567),
    [anon_sym_DASH_GT] = ACTIONS(2567),
    [anon_sym_try] = ACTIONS(2567),
    [anon_sym_match] = ACTIONS(2567),
    [anon_sym_match_BANG] = ACTIONS(2569),
    [anon_sym_function] = ACTIONS(2567),
    [anon_sym_LT_DASH] = ACTIONS(2567),
    [anon_sym_DOT_LBRACK] = ACTIONS(2569),
    [anon_sym_LT] = ACTIONS(2569),
    [anon_sym_use] = ACTIONS(2567),
    [anon_sym_use_BANG] = ACTIONS(2569),
    [anon_sym_do_BANG] = ACTIONS(2569),
    [anon_sym_begin] = ACTIONS(2567),
    [anon_sym_LPAREN2] = ACTIONS(2567),
    [anon_sym_STAR] = ACTIONS(2567),
    [anon_sym_LT2] = ACTIONS(2567),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2569),
    [anon_sym_or] = ACTIONS(2567),
    [aux_sym_char_token1] = ACTIONS(2569),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2567),
    [anon_sym_DQUOTE] = ACTIONS(2567),
    [anon_sym_AT_DQUOTE] = ACTIONS(2569),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2569),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2569),
    [sym_bool] = ACTIONS(2567),
    [sym_unit] = ACTIONS(2569),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2567),
    [sym_op_identifier] = ACTIONS(2567),
    [anon_sym_PLUS] = ACTIONS(2567),
    [anon_sym_DASH] = ACTIONS(2567),
    [anon_sym_PLUS_DOT] = ACTIONS(2567),
    [anon_sym_DASH_DOT] = ACTIONS(2567),
    [anon_sym_PERCENT] = ACTIONS(2567),
    [anon_sym_AMP_AMP] = ACTIONS(2567),
    [anon_sym_TILDE] = ACTIONS(2569),
    [aux_sym_prefix_op_token1] = ACTIONS(2567),
    [aux_sym_infix_op_token1] = ACTIONS(2569),
    [aux_sym_infix_op_token2] = ACTIONS(2567),
    [anon_sym_PIPE_PIPE] = ACTIONS(2567),
    [anon_sym_BANG_EQ] = ACTIONS(2567),
    [anon_sym_COLON_EQ] = ACTIONS(2569),
    [anon_sym_DOLLAR] = ACTIONS(2567),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2567),
    [sym_int] = ACTIONS(2567),
    [sym_xint] = ACTIONS(2569),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2569),
    [sym__newline] = ACTIONS(2569),
  },
  [1301] = {
    [sym_block_comment] = STATE(1301),
    [sym_compiler_directive_decl] = STATE(1301),
    [sym_fsi_directive_decl] = STATE(1301),
    [sym_preproc_line] = STATE(1301),
    [sym_identifier] = ACTIONS(2557),
    [anon_sym_EQ] = ACTIONS(2559),
    [anon_sym_COLON] = ACTIONS(2557),
    [anon_sym_return] = ACTIONS(2557),
    [anon_sym_do] = ACTIONS(2557),
    [anon_sym_let] = ACTIONS(2557),
    [anon_sym_let_BANG] = ACTIONS(2559),
    [anon_sym_LPAREN] = ACTIONS(2557),
    [anon_sym_COMMA] = ACTIONS(2559),
    [anon_sym_null] = ACTIONS(2557),
    [anon_sym_QMARK] = ACTIONS(2557),
    [anon_sym_COLON_QMARK] = ACTIONS(2557),
    [anon_sym_COLON_COLON] = ACTIONS(2559),
    [anon_sym_AMP] = ACTIONS(2557),
    [anon_sym_LBRACK] = ACTIONS(2557),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2559),
    [anon_sym_LBRACE] = ACTIONS(2557),
    [anon_sym_LT_AT] = ACTIONS(2557),
    [anon_sym_LT_AT_AT] = ACTIONS(2557),
    [anon_sym_AT_AT_GT] = ACTIONS(2557),
    [anon_sym_DOT] = ACTIONS(2557),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2559),
    [anon_sym_new] = ACTIONS(2557),
    [anon_sym_return_BANG] = ACTIONS(2559),
    [anon_sym_yield] = ACTIONS(2557),
    [anon_sym_yield_BANG] = ACTIONS(2559),
    [anon_sym_lazy] = ACTIONS(2557),
    [anon_sym_assert] = ACTIONS(2557),
    [anon_sym_upcast] = ACTIONS(2557),
    [anon_sym_downcast] = ACTIONS(2557),
    [anon_sym_COLON_GT] = ACTIONS(2559),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2559),
    [anon_sym_for] = ACTIONS(2557),
    [anon_sym_while] = ACTIONS(2557),
    [anon_sym_if] = ACTIONS(2557),
    [anon_sym_fun] = ACTIONS(2557),
    [anon_sym_DASH_GT] = ACTIONS(2557),
    [anon_sym_try] = ACTIONS(2557),
    [anon_sym_match] = ACTIONS(2557),
    [anon_sym_match_BANG] = ACTIONS(2559),
    [anon_sym_function] = ACTIONS(2557),
    [anon_sym_LT_DASH] = ACTIONS(2557),
    [anon_sym_DOT_LBRACK] = ACTIONS(2559),
    [anon_sym_LT] = ACTIONS(2559),
    [anon_sym_use] = ACTIONS(2557),
    [anon_sym_use_BANG] = ACTIONS(2559),
    [anon_sym_do_BANG] = ACTIONS(2559),
    [anon_sym_begin] = ACTIONS(2557),
    [anon_sym_LPAREN2] = ACTIONS(2557),
    [anon_sym_STAR] = ACTIONS(2557),
    [anon_sym_LT2] = ACTIONS(3490),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2559),
    [anon_sym_or] = ACTIONS(2557),
    [aux_sym_char_token1] = ACTIONS(2559),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2557),
    [anon_sym_DQUOTE] = ACTIONS(2557),
    [anon_sym_AT_DQUOTE] = ACTIONS(2559),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2559),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2559),
    [sym_bool] = ACTIONS(2557),
    [sym_unit] = ACTIONS(2559),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2557),
    [sym_op_identifier] = ACTIONS(2557),
    [anon_sym_PLUS] = ACTIONS(2557),
    [anon_sym_DASH] = ACTIONS(2557),
    [anon_sym_PLUS_DOT] = ACTIONS(2557),
    [anon_sym_DASH_DOT] = ACTIONS(2557),
    [anon_sym_PERCENT] = ACTIONS(2557),
    [anon_sym_AMP_AMP] = ACTIONS(2557),
    [anon_sym_TILDE] = ACTIONS(2559),
    [aux_sym_prefix_op_token1] = ACTIONS(2557),
    [aux_sym_infix_op_token1] = ACTIONS(2559),
    [aux_sym_infix_op_token2] = ACTIONS(2557),
    [anon_sym_PIPE_PIPE] = ACTIONS(2557),
    [anon_sym_BANG_EQ] = ACTIONS(2557),
    [anon_sym_COLON_EQ] = ACTIONS(2559),
    [anon_sym_DOLLAR] = ACTIONS(2557),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2557),
    [sym_int] = ACTIONS(2557),
    [sym_xint] = ACTIONS(2559),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2559),
    [sym__newline] = ACTIONS(2559),
  },
  [1302] = {
    [sym_block_comment] = STATE(1302),
    [sym_compiler_directive_decl] = STATE(1302),
    [sym_fsi_directive_decl] = STATE(1302),
    [sym_preproc_line] = STATE(1302),
    [sym_identifier] = ACTIONS(2510),
    [anon_sym_EQ] = ACTIONS(2512),
    [anon_sym_COLON] = ACTIONS(2510),
    [anon_sym_return] = ACTIONS(2510),
    [anon_sym_do] = ACTIONS(2510),
    [anon_sym_let] = ACTIONS(2510),
    [anon_sym_let_BANG] = ACTIONS(2512),
    [anon_sym_LPAREN] = ACTIONS(2510),
    [anon_sym_COMMA] = ACTIONS(2512),
    [anon_sym_null] = ACTIONS(2510),
    [anon_sym_QMARK] = ACTIONS(2510),
    [anon_sym_COLON_QMARK] = ACTIONS(2510),
    [anon_sym_COLON_COLON] = ACTIONS(2512),
    [anon_sym_AMP] = ACTIONS(2510),
    [anon_sym_LBRACK] = ACTIONS(2510),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2512),
    [anon_sym_LBRACE] = ACTIONS(2510),
    [anon_sym_LT_AT] = ACTIONS(2510),
    [anon_sym_LT_AT_AT] = ACTIONS(2510),
    [anon_sym_DOT] = ACTIONS(2510),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2512),
    [anon_sym_new] = ACTIONS(2510),
    [anon_sym_return_BANG] = ACTIONS(2512),
    [anon_sym_yield] = ACTIONS(2510),
    [anon_sym_yield_BANG] = ACTIONS(2512),
    [anon_sym_lazy] = ACTIONS(2510),
    [anon_sym_assert] = ACTIONS(2510),
    [anon_sym_upcast] = ACTIONS(2510),
    [anon_sym_downcast] = ACTIONS(2510),
    [anon_sym_COLON_GT] = ACTIONS(2512),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2512),
    [anon_sym_for] = ACTIONS(2510),
    [anon_sym_while] = ACTIONS(2510),
    [anon_sym_if] = ACTIONS(2510),
    [anon_sym_fun] = ACTIONS(2510),
    [anon_sym_DASH_GT] = ACTIONS(2510),
    [anon_sym_try] = ACTIONS(2510),
    [anon_sym_match] = ACTIONS(2510),
    [anon_sym_match_BANG] = ACTIONS(2512),
    [anon_sym_function] = ACTIONS(2510),
    [anon_sym_LT_DASH] = ACTIONS(2510),
    [anon_sym_DOT_LBRACK] = ACTIONS(2512),
    [anon_sym_LT] = ACTIONS(2512),
    [anon_sym_use] = ACTIONS(2510),
    [anon_sym_use_BANG] = ACTIONS(2512),
    [anon_sym_do_BANG] = ACTIONS(2512),
    [anon_sym_begin] = ACTIONS(2510),
    [anon_sym_LPAREN2] = ACTIONS(2510),
    [anon_sym_STAR] = ACTIONS(2510),
    [anon_sym_LT2] = ACTIONS(2510),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2512),
    [anon_sym_or] = ACTIONS(2510),
    [aux_sym_char_token1] = ACTIONS(2512),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2510),
    [anon_sym_DQUOTE] = ACTIONS(2510),
    [anon_sym_AT_DQUOTE] = ACTIONS(2512),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2512),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2512),
    [sym_bool] = ACTIONS(2510),
    [sym_unit] = ACTIONS(2512),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2510),
    [sym_op_identifier] = ACTIONS(2510),
    [anon_sym_PLUS] = ACTIONS(2510),
    [anon_sym_DASH] = ACTIONS(2510),
    [anon_sym_PLUS_DOT] = ACTIONS(2510),
    [anon_sym_DASH_DOT] = ACTIONS(2510),
    [anon_sym_PERCENT] = ACTIONS(2510),
    [anon_sym_AMP_AMP] = ACTIONS(2510),
    [anon_sym_TILDE] = ACTIONS(2512),
    [aux_sym_prefix_op_token1] = ACTIONS(2510),
    [aux_sym_infix_op_token1] = ACTIONS(2512),
    [aux_sym_infix_op_token2] = ACTIONS(2510),
    [anon_sym_PIPE_PIPE] = ACTIONS(2510),
    [anon_sym_BANG_EQ] = ACTIONS(2510),
    [anon_sym_COLON_EQ] = ACTIONS(2512),
    [anon_sym_DOLLAR] = ACTIONS(2510),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2510),
    [sym_int] = ACTIONS(2510),
    [sym_xint] = ACTIONS(2512),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2512),
    [anon_sym_POUNDendif] = ACTIONS(2512),
    [sym__newline] = ACTIONS(2512),
  },
  [1303] = {
    [sym_block_comment] = STATE(1303),
    [sym_compiler_directive_decl] = STATE(1303),
    [sym_fsi_directive_decl] = STATE(1303),
    [sym_preproc_line] = STATE(1303),
    [sym_identifier] = ACTIONS(2627),
    [anon_sym_EQ] = ACTIONS(2629),
    [anon_sym_COLON] = ACTIONS(2627),
    [anon_sym_return] = ACTIONS(2627),
    [anon_sym_do] = ACTIONS(2627),
    [anon_sym_let] = ACTIONS(2627),
    [anon_sym_let_BANG] = ACTIONS(2629),
    [anon_sym_LPAREN] = ACTIONS(2627),
    [anon_sym_COMMA] = ACTIONS(2629),
    [anon_sym_null] = ACTIONS(2627),
    [anon_sym_QMARK] = ACTIONS(2627),
    [anon_sym_COLON_QMARK] = ACTIONS(2627),
    [anon_sym_COLON_COLON] = ACTIONS(2629),
    [anon_sym_AMP] = ACTIONS(2627),
    [anon_sym_LBRACK] = ACTIONS(2627),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2629),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_LT_AT] = ACTIONS(2627),
    [anon_sym_LT_AT_AT] = ACTIONS(2627),
    [anon_sym_DOT] = ACTIONS(2627),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2629),
    [anon_sym_new] = ACTIONS(2627),
    [anon_sym_return_BANG] = ACTIONS(2629),
    [anon_sym_yield] = ACTIONS(2627),
    [anon_sym_yield_BANG] = ACTIONS(2629),
    [anon_sym_lazy] = ACTIONS(2627),
    [anon_sym_assert] = ACTIONS(2627),
    [anon_sym_upcast] = ACTIONS(2627),
    [anon_sym_downcast] = ACTIONS(2627),
    [anon_sym_COLON_GT] = ACTIONS(2629),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2629),
    [anon_sym_for] = ACTIONS(2627),
    [anon_sym_while] = ACTIONS(2627),
    [anon_sym_if] = ACTIONS(2627),
    [anon_sym_fun] = ACTIONS(2627),
    [anon_sym_DASH_GT] = ACTIONS(2627),
    [anon_sym_try] = ACTIONS(2627),
    [anon_sym_match] = ACTIONS(2627),
    [anon_sym_match_BANG] = ACTIONS(2629),
    [anon_sym_function] = ACTIONS(2627),
    [anon_sym_LT_DASH] = ACTIONS(2627),
    [anon_sym_DOT_LBRACK] = ACTIONS(2629),
    [anon_sym_LT] = ACTIONS(2629),
    [anon_sym_use] = ACTIONS(2627),
    [anon_sym_use_BANG] = ACTIONS(2629),
    [anon_sym_do_BANG] = ACTIONS(2629),
    [anon_sym_begin] = ACTIONS(2627),
    [anon_sym_LPAREN2] = ACTIONS(2627),
    [anon_sym_STAR] = ACTIONS(2627),
    [anon_sym_LT2] = ACTIONS(2627),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2629),
    [anon_sym_or] = ACTIONS(2627),
    [aux_sym_char_token1] = ACTIONS(2629),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2627),
    [anon_sym_DQUOTE] = ACTIONS(2627),
    [anon_sym_AT_DQUOTE] = ACTIONS(2629),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2629),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2629),
    [sym_bool] = ACTIONS(2627),
    [sym_unit] = ACTIONS(2629),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2627),
    [sym_op_identifier] = ACTIONS(2627),
    [anon_sym_PLUS] = ACTIONS(2627),
    [anon_sym_DASH] = ACTIONS(2627),
    [anon_sym_PLUS_DOT] = ACTIONS(2627),
    [anon_sym_DASH_DOT] = ACTIONS(2627),
    [anon_sym_PERCENT] = ACTIONS(2627),
    [anon_sym_AMP_AMP] = ACTIONS(2627),
    [anon_sym_TILDE] = ACTIONS(2629),
    [aux_sym_prefix_op_token1] = ACTIONS(2627),
    [aux_sym_infix_op_token1] = ACTIONS(2629),
    [aux_sym_infix_op_token2] = ACTIONS(2627),
    [anon_sym_PIPE_PIPE] = ACTIONS(2627),
    [anon_sym_BANG_EQ] = ACTIONS(2627),
    [anon_sym_COLON_EQ] = ACTIONS(2629),
    [anon_sym_DOLLAR] = ACTIONS(2627),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2627),
    [sym_int] = ACTIONS(2627),
    [sym_xint] = ACTIONS(2629),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2629),
    [anon_sym_POUNDendif] = ACTIONS(2629),
    [sym__newline] = ACTIONS(2629),
  },
  [1304] = {
    [sym_block_comment] = STATE(1304),
    [sym_compiler_directive_decl] = STATE(1304),
    [sym_fsi_directive_decl] = STATE(1304),
    [sym_preproc_line] = STATE(1304),
    [sym_identifier] = ACTIONS(2466),
    [anon_sym_EQ] = ACTIONS(2468),
    [anon_sym_COLON] = ACTIONS(2466),
    [anon_sym_return] = ACTIONS(2466),
    [anon_sym_do] = ACTIONS(2466),
    [anon_sym_let] = ACTIONS(2466),
    [anon_sym_let_BANG] = ACTIONS(2468),
    [anon_sym_LPAREN] = ACTIONS(2466),
    [anon_sym_COMMA] = ACTIONS(2468),
    [anon_sym_null] = ACTIONS(2466),
    [anon_sym_QMARK] = ACTIONS(2466),
    [anon_sym_COLON_QMARK] = ACTIONS(2466),
    [anon_sym_COLON_COLON] = ACTIONS(2468),
    [anon_sym_AMP] = ACTIONS(2466),
    [anon_sym_LBRACK] = ACTIONS(2466),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2468),
    [anon_sym_LBRACE] = ACTIONS(2466),
    [anon_sym_LT_AT] = ACTIONS(2466),
    [anon_sym_LT_AT_AT] = ACTIONS(2466),
    [anon_sym_DOT] = ACTIONS(2466),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2468),
    [anon_sym_new] = ACTIONS(2466),
    [anon_sym_return_BANG] = ACTIONS(2468),
    [anon_sym_yield] = ACTIONS(2466),
    [anon_sym_yield_BANG] = ACTIONS(2468),
    [anon_sym_lazy] = ACTIONS(2466),
    [anon_sym_assert] = ACTIONS(2466),
    [anon_sym_upcast] = ACTIONS(2466),
    [anon_sym_downcast] = ACTIONS(2466),
    [anon_sym_COLON_GT] = ACTIONS(2468),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2468),
    [anon_sym_for] = ACTIONS(2466),
    [anon_sym_while] = ACTIONS(2466),
    [anon_sym_if] = ACTIONS(2466),
    [anon_sym_fun] = ACTIONS(2466),
    [anon_sym_DASH_GT] = ACTIONS(2466),
    [anon_sym_try] = ACTIONS(2466),
    [anon_sym_match] = ACTIONS(2466),
    [anon_sym_match_BANG] = ACTIONS(2468),
    [anon_sym_function] = ACTIONS(2466),
    [anon_sym_LT_DASH] = ACTIONS(2466),
    [anon_sym_DOT_LBRACK] = ACTIONS(2468),
    [anon_sym_LT] = ACTIONS(2468),
    [anon_sym_GT] = ACTIONS(2466),
    [anon_sym_use] = ACTIONS(2466),
    [anon_sym_use_BANG] = ACTIONS(2468),
    [anon_sym_do_BANG] = ACTIONS(2468),
    [anon_sym_begin] = ACTIONS(2466),
    [anon_sym_LPAREN2] = ACTIONS(2466),
    [anon_sym_STAR] = ACTIONS(2466),
    [anon_sym_LT2] = ACTIONS(2466),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2468),
    [anon_sym_or] = ACTIONS(2466),
    [aux_sym_char_token1] = ACTIONS(2468),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2466),
    [anon_sym_DQUOTE] = ACTIONS(2466),
    [anon_sym_AT_DQUOTE] = ACTIONS(2468),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2468),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2468),
    [sym_bool] = ACTIONS(2466),
    [sym_unit] = ACTIONS(2468),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2466),
    [sym_op_identifier] = ACTIONS(2466),
    [anon_sym_PLUS] = ACTIONS(2466),
    [anon_sym_DASH] = ACTIONS(2466),
    [anon_sym_PLUS_DOT] = ACTIONS(2466),
    [anon_sym_DASH_DOT] = ACTIONS(2466),
    [anon_sym_PERCENT] = ACTIONS(2466),
    [anon_sym_AMP_AMP] = ACTIONS(2466),
    [anon_sym_TILDE] = ACTIONS(2468),
    [aux_sym_prefix_op_token1] = ACTIONS(2466),
    [aux_sym_infix_op_token1] = ACTIONS(2468),
    [aux_sym_infix_op_token2] = ACTIONS(2466),
    [anon_sym_PIPE_PIPE] = ACTIONS(2466),
    [anon_sym_BANG_EQ] = ACTIONS(2466),
    [anon_sym_COLON_EQ] = ACTIONS(2468),
    [anon_sym_DOLLAR] = ACTIONS(2466),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2466),
    [sym_int] = ACTIONS(2466),
    [sym_xint] = ACTIONS(2468),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2468),
    [sym__newline] = ACTIONS(2468),
  },
  [1305] = {
    [sym_block_comment] = STATE(1305),
    [sym_compiler_directive_decl] = STATE(1305),
    [sym_fsi_directive_decl] = STATE(1305),
    [sym_preproc_line] = STATE(1305),
    [sym_identifier] = ACTIONS(2340),
    [anon_sym_EQ] = ACTIONS(2342),
    [anon_sym_COLON] = ACTIONS(2340),
    [anon_sym_return] = ACTIONS(2340),
    [anon_sym_do] = ACTIONS(2340),
    [anon_sym_let] = ACTIONS(2340),
    [anon_sym_let_BANG] = ACTIONS(2342),
    [anon_sym_LPAREN] = ACTIONS(2340),
    [anon_sym_COMMA] = ACTIONS(2342),
    [anon_sym_null] = ACTIONS(2340),
    [anon_sym_QMARK] = ACTIONS(2340),
    [anon_sym_COLON_QMARK] = ACTIONS(2340),
    [anon_sym_COLON_COLON] = ACTIONS(2342),
    [anon_sym_AMP] = ACTIONS(2340),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2342),
    [anon_sym_LBRACE] = ACTIONS(2340),
    [anon_sym_LT_AT] = ACTIONS(2340),
    [anon_sym_LT_AT_AT] = ACTIONS(2340),
    [anon_sym_DOT] = ACTIONS(2340),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2342),
    [anon_sym_new] = ACTIONS(2340),
    [anon_sym_return_BANG] = ACTIONS(2342),
    [anon_sym_yield] = ACTIONS(2340),
    [anon_sym_yield_BANG] = ACTIONS(2342),
    [anon_sym_lazy] = ACTIONS(2340),
    [anon_sym_assert] = ACTIONS(2340),
    [anon_sym_upcast] = ACTIONS(2340),
    [anon_sym_downcast] = ACTIONS(2340),
    [anon_sym_COLON_GT] = ACTIONS(2342),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2342),
    [anon_sym_for] = ACTIONS(2340),
    [anon_sym_while] = ACTIONS(2340),
    [anon_sym_if] = ACTIONS(2340),
    [anon_sym_fun] = ACTIONS(2340),
    [anon_sym_DASH_GT] = ACTIONS(2340),
    [anon_sym_try] = ACTIONS(2340),
    [anon_sym_match] = ACTIONS(2340),
    [anon_sym_match_BANG] = ACTIONS(2342),
    [anon_sym_function] = ACTIONS(2340),
    [anon_sym_LT_DASH] = ACTIONS(2340),
    [anon_sym_DOT_LBRACK] = ACTIONS(2342),
    [anon_sym_LT] = ACTIONS(2342),
    [anon_sym_GT] = ACTIONS(2340),
    [anon_sym_use] = ACTIONS(2340),
    [anon_sym_use_BANG] = ACTIONS(2342),
    [anon_sym_do_BANG] = ACTIONS(2342),
    [anon_sym_begin] = ACTIONS(2340),
    [anon_sym_LPAREN2] = ACTIONS(2340),
    [anon_sym_STAR] = ACTIONS(2340),
    [anon_sym_LT2] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2342),
    [anon_sym_or] = ACTIONS(2340),
    [aux_sym_char_token1] = ACTIONS(2342),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2340),
    [anon_sym_DQUOTE] = ACTIONS(2340),
    [anon_sym_AT_DQUOTE] = ACTIONS(2342),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2342),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2342),
    [sym_bool] = ACTIONS(2340),
    [sym_unit] = ACTIONS(2342),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2340),
    [sym_op_identifier] = ACTIONS(2340),
    [anon_sym_PLUS] = ACTIONS(2340),
    [anon_sym_DASH] = ACTIONS(2340),
    [anon_sym_PLUS_DOT] = ACTIONS(2340),
    [anon_sym_DASH_DOT] = ACTIONS(2340),
    [anon_sym_PERCENT] = ACTIONS(2340),
    [anon_sym_AMP_AMP] = ACTIONS(2340),
    [anon_sym_TILDE] = ACTIONS(2342),
    [aux_sym_prefix_op_token1] = ACTIONS(2340),
    [aux_sym_infix_op_token1] = ACTIONS(2342),
    [aux_sym_infix_op_token2] = ACTIONS(2340),
    [anon_sym_PIPE_PIPE] = ACTIONS(2340),
    [anon_sym_BANG_EQ] = ACTIONS(2340),
    [anon_sym_COLON_EQ] = ACTIONS(2342),
    [anon_sym_DOLLAR] = ACTIONS(2340),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2340),
    [sym_int] = ACTIONS(2340),
    [sym_xint] = ACTIONS(2342),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2342),
    [sym__newline] = ACTIONS(2342),
  },
  [1306] = {
    [sym_block_comment] = STATE(1306),
    [sym_compiler_directive_decl] = STATE(1306),
    [sym_fsi_directive_decl] = STATE(1306),
    [sym_preproc_line] = STATE(1306),
    [sym_identifier] = ACTIONS(2812),
    [anon_sym_EQ] = ACTIONS(2814),
    [anon_sym_COLON] = ACTIONS(2812),
    [anon_sym_return] = ACTIONS(2812),
    [anon_sym_do] = ACTIONS(2812),
    [anon_sym_let] = ACTIONS(2812),
    [anon_sym_let_BANG] = ACTIONS(2814),
    [anon_sym_LPAREN] = ACTIONS(2812),
    [anon_sym_COMMA] = ACTIONS(2814),
    [anon_sym_null] = ACTIONS(2812),
    [anon_sym_QMARK] = ACTIONS(2812),
    [anon_sym_COLON_QMARK] = ACTIONS(2812),
    [anon_sym_COLON_COLON] = ACTIONS(2814),
    [anon_sym_AMP] = ACTIONS(2812),
    [anon_sym_LBRACK] = ACTIONS(2812),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2814),
    [anon_sym_LBRACE] = ACTIONS(2812),
    [anon_sym_LT_AT] = ACTIONS(2812),
    [anon_sym_LT_AT_AT] = ACTIONS(2812),
    [anon_sym_DOT] = ACTIONS(2812),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2814),
    [anon_sym_new] = ACTIONS(2812),
    [anon_sym_with] = ACTIONS(2812),
    [anon_sym_return_BANG] = ACTIONS(2814),
    [anon_sym_yield] = ACTIONS(2812),
    [anon_sym_yield_BANG] = ACTIONS(2814),
    [anon_sym_lazy] = ACTIONS(2812),
    [anon_sym_assert] = ACTIONS(2812),
    [anon_sym_upcast] = ACTIONS(2812),
    [anon_sym_downcast] = ACTIONS(2812),
    [anon_sym_COLON_GT] = ACTIONS(2814),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2814),
    [anon_sym_for] = ACTIONS(2812),
    [anon_sym_while] = ACTIONS(2812),
    [anon_sym_if] = ACTIONS(2812),
    [anon_sym_fun] = ACTIONS(2812),
    [anon_sym_try] = ACTIONS(2812),
    [anon_sym_match] = ACTIONS(2812),
    [anon_sym_match_BANG] = ACTIONS(2814),
    [anon_sym_function] = ACTIONS(2812),
    [anon_sym_LT_DASH] = ACTIONS(2812),
    [anon_sym_DOT_LBRACK] = ACTIONS(2814),
    [anon_sym_LT] = ACTIONS(2814),
    [anon_sym_use] = ACTIONS(2812),
    [anon_sym_use_BANG] = ACTIONS(2814),
    [anon_sym_do_BANG] = ACTIONS(2814),
    [anon_sym_begin] = ACTIONS(2812),
    [anon_sym_LPAREN2] = ACTIONS(2812),
    [anon_sym_DOT_DOT2] = ACTIONS(2814),
    [anon_sym_or] = ACTIONS(2812),
    [aux_sym_char_token1] = ACTIONS(2814),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2812),
    [anon_sym_DQUOTE] = ACTIONS(2812),
    [anon_sym_AT_DQUOTE] = ACTIONS(2814),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2814),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2814),
    [sym_bool] = ACTIONS(2812),
    [sym_unit] = ACTIONS(2814),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2812),
    [sym_op_identifier] = ACTIONS(2812),
    [anon_sym_PLUS] = ACTIONS(2812),
    [anon_sym_DASH] = ACTIONS(2812),
    [anon_sym_PLUS_DOT] = ACTIONS(2812),
    [anon_sym_DASH_DOT] = ACTIONS(2812),
    [anon_sym_PERCENT] = ACTIONS(2812),
    [anon_sym_AMP_AMP] = ACTIONS(2812),
    [anon_sym_TILDE] = ACTIONS(2814),
    [aux_sym_prefix_op_token1] = ACTIONS(2812),
    [aux_sym_infix_op_token1] = ACTIONS(2814),
    [aux_sym_infix_op_token2] = ACTIONS(2812),
    [anon_sym_PIPE_PIPE] = ACTIONS(2812),
    [anon_sym_BANG_EQ] = ACTIONS(2812),
    [anon_sym_COLON_EQ] = ACTIONS(2814),
    [anon_sym_DOLLAR] = ACTIONS(2812),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2812),
    [sym_int] = ACTIONS(2812),
    [sym_xint] = ACTIONS(2814),
    [anon_sym_f] = ACTIONS(2812),
    [aux_sym_decimal_token1] = ACTIONS(2812),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2814),
    [sym__newline] = ACTIONS(2814),
    [sym__dedent] = ACTIONS(2814),
  },
  [1307] = {
    [sym_block_comment] = STATE(1307),
    [sym_compiler_directive_decl] = STATE(1307),
    [sym_fsi_directive_decl] = STATE(1307),
    [sym_preproc_line] = STATE(1307),
    [sym_identifier] = ACTIONS(2462),
    [anon_sym_EQ] = ACTIONS(2464),
    [anon_sym_COLON] = ACTIONS(2462),
    [anon_sym_return] = ACTIONS(2462),
    [anon_sym_do] = ACTIONS(2462),
    [anon_sym_let] = ACTIONS(2462),
    [anon_sym_let_BANG] = ACTIONS(2464),
    [anon_sym_LPAREN] = ACTIONS(2462),
    [anon_sym_COMMA] = ACTIONS(2464),
    [anon_sym_null] = ACTIONS(2462),
    [anon_sym_QMARK] = ACTIONS(2462),
    [anon_sym_COLON_QMARK] = ACTIONS(2462),
    [anon_sym_COLON_COLON] = ACTIONS(2464),
    [anon_sym_AMP] = ACTIONS(2462),
    [anon_sym_LBRACK] = ACTIONS(2462),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2464),
    [anon_sym_LBRACE] = ACTIONS(2462),
    [anon_sym_LT_AT] = ACTIONS(2462),
    [anon_sym_LT_AT_AT] = ACTIONS(2462),
    [anon_sym_DOT] = ACTIONS(2462),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2464),
    [anon_sym_new] = ACTIONS(2462),
    [anon_sym_return_BANG] = ACTIONS(2464),
    [anon_sym_yield] = ACTIONS(2462),
    [anon_sym_yield_BANG] = ACTIONS(2464),
    [anon_sym_lazy] = ACTIONS(2462),
    [anon_sym_assert] = ACTIONS(2462),
    [anon_sym_upcast] = ACTIONS(2462),
    [anon_sym_downcast] = ACTIONS(2462),
    [anon_sym_COLON_GT] = ACTIONS(2464),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2464),
    [anon_sym_for] = ACTIONS(2462),
    [anon_sym_while] = ACTIONS(2462),
    [anon_sym_if] = ACTIONS(2462),
    [anon_sym_fun] = ACTIONS(2462),
    [anon_sym_DASH_GT] = ACTIONS(2462),
    [anon_sym_try] = ACTIONS(2462),
    [anon_sym_match] = ACTIONS(2462),
    [anon_sym_match_BANG] = ACTIONS(2464),
    [anon_sym_function] = ACTIONS(2462),
    [anon_sym_LT_DASH] = ACTIONS(2462),
    [anon_sym_DOT_LBRACK] = ACTIONS(2464),
    [anon_sym_LT] = ACTIONS(2464),
    [anon_sym_GT] = ACTIONS(2462),
    [anon_sym_use] = ACTIONS(2462),
    [anon_sym_use_BANG] = ACTIONS(2464),
    [anon_sym_do_BANG] = ACTIONS(2464),
    [anon_sym_begin] = ACTIONS(2462),
    [anon_sym_LPAREN2] = ACTIONS(2462),
    [anon_sym_STAR] = ACTIONS(2462),
    [anon_sym_LT2] = ACTIONS(2462),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2464),
    [anon_sym_or] = ACTIONS(2462),
    [aux_sym_char_token1] = ACTIONS(2464),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2462),
    [anon_sym_DQUOTE] = ACTIONS(2462),
    [anon_sym_AT_DQUOTE] = ACTIONS(2464),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2464),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2464),
    [sym_bool] = ACTIONS(2462),
    [sym_unit] = ACTIONS(2464),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2462),
    [sym_op_identifier] = ACTIONS(2462),
    [anon_sym_PLUS] = ACTIONS(2462),
    [anon_sym_DASH] = ACTIONS(2462),
    [anon_sym_PLUS_DOT] = ACTIONS(2462),
    [anon_sym_DASH_DOT] = ACTIONS(2462),
    [anon_sym_PERCENT] = ACTIONS(2462),
    [anon_sym_AMP_AMP] = ACTIONS(2462),
    [anon_sym_TILDE] = ACTIONS(2464),
    [aux_sym_prefix_op_token1] = ACTIONS(2462),
    [aux_sym_infix_op_token1] = ACTIONS(2464),
    [aux_sym_infix_op_token2] = ACTIONS(2462),
    [anon_sym_PIPE_PIPE] = ACTIONS(2462),
    [anon_sym_BANG_EQ] = ACTIONS(2462),
    [anon_sym_COLON_EQ] = ACTIONS(2464),
    [anon_sym_DOLLAR] = ACTIONS(2462),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2462),
    [sym_int] = ACTIONS(2462),
    [sym_xint] = ACTIONS(2464),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2464),
    [sym__newline] = ACTIONS(2464),
  },
  [1308] = {
    [sym_elif_expression] = STATE(1613),
    [sym_block_comment] = STATE(1308),
    [sym_compiler_directive_decl] = STATE(1308),
    [sym_fsi_directive_decl] = STATE(1308),
    [sym_preproc_line] = STATE(1308),
    [aux_sym_if_expression_repeat1] = STATE(1308),
    [sym_identifier] = ACTIONS(2518),
    [anon_sym_EQ] = ACTIONS(2520),
    [anon_sym_COLON] = ACTIONS(2518),
    [anon_sym_return] = ACTIONS(2518),
    [anon_sym_do] = ACTIONS(2518),
    [anon_sym_let] = ACTIONS(2518),
    [anon_sym_let_BANG] = ACTIONS(2520),
    [anon_sym_LPAREN] = ACTIONS(2518),
    [anon_sym_COMMA] = ACTIONS(2520),
    [anon_sym_null] = ACTIONS(2518),
    [anon_sym_QMARK] = ACTIONS(2518),
    [anon_sym_COLON_QMARK] = ACTIONS(2518),
    [anon_sym_COLON_COLON] = ACTIONS(2520),
    [anon_sym_AMP] = ACTIONS(2518),
    [anon_sym_LBRACK] = ACTIONS(2518),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2520),
    [anon_sym_LBRACE] = ACTIONS(2518),
    [anon_sym_LT_AT] = ACTIONS(2518),
    [anon_sym_AT_GT] = ACTIONS(2518),
    [anon_sym_LT_AT_AT] = ACTIONS(2518),
    [anon_sym_DOT] = ACTIONS(2518),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2520),
    [anon_sym_new] = ACTIONS(2518),
    [anon_sym_return_BANG] = ACTIONS(2520),
    [anon_sym_yield] = ACTIONS(2518),
    [anon_sym_yield_BANG] = ACTIONS(2520),
    [anon_sym_lazy] = ACTIONS(2518),
    [anon_sym_assert] = ACTIONS(2518),
    [anon_sym_upcast] = ACTIONS(2518),
    [anon_sym_downcast] = ACTIONS(2518),
    [anon_sym_COLON_GT] = ACTIONS(2520),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2520),
    [anon_sym_for] = ACTIONS(2518),
    [anon_sym_while] = ACTIONS(2518),
    [anon_sym_else] = ACTIONS(2518),
    [anon_sym_elif] = ACTIONS(3492),
    [anon_sym_if] = ACTIONS(2518),
    [anon_sym_fun] = ACTIONS(2518),
    [anon_sym_try] = ACTIONS(2518),
    [anon_sym_match] = ACTIONS(2518),
    [anon_sym_match_BANG] = ACTIONS(2520),
    [anon_sym_function] = ACTIONS(2518),
    [anon_sym_LT_DASH] = ACTIONS(2518),
    [anon_sym_DOT_LBRACK] = ACTIONS(2520),
    [anon_sym_LT] = ACTIONS(2520),
    [anon_sym_use] = ACTIONS(2518),
    [anon_sym_use_BANG] = ACTIONS(2520),
    [anon_sym_do_BANG] = ACTIONS(2520),
    [anon_sym_begin] = ACTIONS(2518),
    [anon_sym_LPAREN2] = ACTIONS(2518),
    [anon_sym_or] = ACTIONS(2518),
    [aux_sym_char_token1] = ACTIONS(2520),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2518),
    [anon_sym_DQUOTE] = ACTIONS(2518),
    [anon_sym_AT_DQUOTE] = ACTIONS(2520),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2520),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2520),
    [sym_bool] = ACTIONS(2518),
    [sym_unit] = ACTIONS(2520),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2518),
    [sym_op_identifier] = ACTIONS(2518),
    [anon_sym_PLUS] = ACTIONS(2518),
    [anon_sym_DASH] = ACTIONS(2518),
    [anon_sym_PLUS_DOT] = ACTIONS(2518),
    [anon_sym_DASH_DOT] = ACTIONS(2518),
    [anon_sym_PERCENT] = ACTIONS(2518),
    [anon_sym_AMP_AMP] = ACTIONS(2518),
    [anon_sym_TILDE] = ACTIONS(2520),
    [aux_sym_prefix_op_token1] = ACTIONS(2518),
    [aux_sym_infix_op_token1] = ACTIONS(2520),
    [aux_sym_infix_op_token2] = ACTIONS(2518),
    [anon_sym_PIPE_PIPE] = ACTIONS(2518),
    [anon_sym_BANG_EQ] = ACTIONS(2518),
    [anon_sym_COLON_EQ] = ACTIONS(2520),
    [anon_sym_DOLLAR] = ACTIONS(2518),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2518),
    [sym_int] = ACTIONS(2518),
    [sym_xint] = ACTIONS(2520),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2520),
    [sym__newline] = ACTIONS(2520),
  },
  [1309] = {
    [sym_block_comment] = STATE(1309),
    [sym_compiler_directive_decl] = STATE(1309),
    [sym_fsi_directive_decl] = STATE(1309),
    [sym_preproc_line] = STATE(1309),
    [sym_identifier] = ACTIONS(2685),
    [anon_sym_EQ] = ACTIONS(2687),
    [anon_sym_COLON] = ACTIONS(2685),
    [anon_sym_return] = ACTIONS(2685),
    [anon_sym_do] = ACTIONS(2685),
    [anon_sym_let] = ACTIONS(2685),
    [anon_sym_let_BANG] = ACTIONS(2687),
    [anon_sym_LPAREN] = ACTIONS(2685),
    [anon_sym_COMMA] = ACTIONS(2687),
    [anon_sym_null] = ACTIONS(2685),
    [anon_sym_QMARK] = ACTIONS(2685),
    [anon_sym_COLON_QMARK] = ACTIONS(2685),
    [anon_sym_COLON_COLON] = ACTIONS(2687),
    [anon_sym_AMP] = ACTIONS(2685),
    [anon_sym_LBRACK] = ACTIONS(2685),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2687),
    [anon_sym_LBRACE] = ACTIONS(2685),
    [anon_sym_LT_AT] = ACTIONS(2685),
    [anon_sym_LT_AT_AT] = ACTIONS(2685),
    [anon_sym_DOT] = ACTIONS(2685),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2687),
    [anon_sym_new] = ACTIONS(2685),
    [anon_sym_return_BANG] = ACTIONS(2687),
    [anon_sym_yield] = ACTIONS(2685),
    [anon_sym_yield_BANG] = ACTIONS(2687),
    [anon_sym_lazy] = ACTIONS(2685),
    [anon_sym_assert] = ACTIONS(2685),
    [anon_sym_upcast] = ACTIONS(2685),
    [anon_sym_downcast] = ACTIONS(2685),
    [anon_sym_COLON_GT] = ACTIONS(2687),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2687),
    [anon_sym_for] = ACTIONS(2685),
    [anon_sym_done] = ACTIONS(2685),
    [anon_sym_while] = ACTIONS(2685),
    [anon_sym_if] = ACTIONS(2685),
    [anon_sym_fun] = ACTIONS(2685),
    [anon_sym_DASH_GT] = ACTIONS(2685),
    [anon_sym_try] = ACTIONS(2685),
    [anon_sym_match] = ACTIONS(2685),
    [anon_sym_match_BANG] = ACTIONS(2687),
    [anon_sym_function] = ACTIONS(2685),
    [anon_sym_LT_DASH] = ACTIONS(2685),
    [anon_sym_DOT_LBRACK] = ACTIONS(2687),
    [anon_sym_LT] = ACTIONS(2687),
    [anon_sym_use] = ACTIONS(2685),
    [anon_sym_use_BANG] = ACTIONS(2687),
    [anon_sym_do_BANG] = ACTIONS(2687),
    [anon_sym_DOT_DOT] = ACTIONS(2685),
    [anon_sym_begin] = ACTIONS(2685),
    [anon_sym_LPAREN2] = ACTIONS(2685),
    [anon_sym_DOT_DOT2] = ACTIONS(2687),
    [anon_sym_or] = ACTIONS(2685),
    [aux_sym_char_token1] = ACTIONS(2687),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2685),
    [anon_sym_DQUOTE] = ACTIONS(2685),
    [anon_sym_AT_DQUOTE] = ACTIONS(2687),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2687),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2687),
    [sym_bool] = ACTIONS(2685),
    [sym_unit] = ACTIONS(2687),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2685),
    [sym_op_identifier] = ACTIONS(2685),
    [anon_sym_PLUS] = ACTIONS(2685),
    [anon_sym_DASH] = ACTIONS(2685),
    [anon_sym_PLUS_DOT] = ACTIONS(2685),
    [anon_sym_DASH_DOT] = ACTIONS(2685),
    [anon_sym_PERCENT] = ACTIONS(2685),
    [anon_sym_AMP_AMP] = ACTIONS(2685),
    [anon_sym_TILDE] = ACTIONS(2687),
    [aux_sym_prefix_op_token1] = ACTIONS(2685),
    [aux_sym_infix_op_token1] = ACTIONS(2687),
    [aux_sym_infix_op_token2] = ACTIONS(2685),
    [anon_sym_PIPE_PIPE] = ACTIONS(2685),
    [anon_sym_BANG_EQ] = ACTIONS(2685),
    [anon_sym_COLON_EQ] = ACTIONS(2687),
    [anon_sym_DOLLAR] = ACTIONS(2685),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2685),
    [sym_int] = ACTIONS(2685),
    [sym_xint] = ACTIONS(2687),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2687),
    [sym__newline] = ACTIONS(2687),
    [sym__dedent] = ACTIONS(2687),
  },
  [1310] = {
    [sym_block_comment] = STATE(1310),
    [sym_compiler_directive_decl] = STATE(1310),
    [sym_fsi_directive_decl] = STATE(1310),
    [sym_preproc_line] = STATE(1310),
    [sym_identifier] = ACTIONS(2723),
    [anon_sym_EQ] = ACTIONS(2725),
    [anon_sym_COLON] = ACTIONS(2723),
    [anon_sym_return] = ACTIONS(2723),
    [anon_sym_do] = ACTIONS(2723),
    [anon_sym_let] = ACTIONS(2723),
    [anon_sym_let_BANG] = ACTIONS(2725),
    [anon_sym_LPAREN] = ACTIONS(2723),
    [anon_sym_COMMA] = ACTIONS(2725),
    [anon_sym_null] = ACTIONS(2723),
    [anon_sym_QMARK] = ACTIONS(2723),
    [anon_sym_COLON_QMARK] = ACTIONS(2723),
    [anon_sym_COLON_COLON] = ACTIONS(2725),
    [anon_sym_AMP] = ACTIONS(2723),
    [anon_sym_LBRACK] = ACTIONS(2723),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2725),
    [anon_sym_LBRACE] = ACTIONS(2723),
    [anon_sym_LT_AT] = ACTIONS(2723),
    [anon_sym_LT_AT_AT] = ACTIONS(2723),
    [anon_sym_DOT] = ACTIONS(2723),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2725),
    [anon_sym_new] = ACTIONS(2723),
    [anon_sym_return_BANG] = ACTIONS(2725),
    [anon_sym_yield] = ACTIONS(2723),
    [anon_sym_yield_BANG] = ACTIONS(2725),
    [anon_sym_lazy] = ACTIONS(2723),
    [anon_sym_assert] = ACTIONS(2723),
    [anon_sym_upcast] = ACTIONS(2723),
    [anon_sym_downcast] = ACTIONS(2723),
    [anon_sym_COLON_GT] = ACTIONS(2725),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2725),
    [anon_sym_for] = ACTIONS(2723),
    [anon_sym_while] = ACTIONS(2723),
    [anon_sym_if] = ACTIONS(2723),
    [anon_sym_fun] = ACTIONS(2723),
    [anon_sym_DASH_GT] = ACTIONS(2723),
    [anon_sym_try] = ACTIONS(2723),
    [anon_sym_match] = ACTIONS(2723),
    [anon_sym_match_BANG] = ACTIONS(2725),
    [anon_sym_function] = ACTIONS(2723),
    [anon_sym_LT_DASH] = ACTIONS(2723),
    [anon_sym_DOT_LBRACK] = ACTIONS(2725),
    [anon_sym_LT] = ACTIONS(2725),
    [anon_sym_use] = ACTIONS(2723),
    [anon_sym_use_BANG] = ACTIONS(2725),
    [anon_sym_do_BANG] = ACTIONS(2725),
    [anon_sym_DOT_DOT] = ACTIONS(2725),
    [anon_sym_begin] = ACTIONS(2723),
    [anon_sym_LPAREN2] = ACTIONS(2723),
    [anon_sym_or] = ACTIONS(2723),
    [aux_sym_char_token1] = ACTIONS(2725),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2723),
    [anon_sym_DQUOTE] = ACTIONS(2723),
    [anon_sym_AT_DQUOTE] = ACTIONS(2725),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2725),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2725),
    [sym_bool] = ACTIONS(2723),
    [sym_unit] = ACTIONS(2725),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2723),
    [sym_op_identifier] = ACTIONS(2723),
    [anon_sym_PLUS] = ACTIONS(2723),
    [anon_sym_DASH] = ACTIONS(2723),
    [anon_sym_PLUS_DOT] = ACTIONS(2723),
    [anon_sym_DASH_DOT] = ACTIONS(2723),
    [anon_sym_PERCENT] = ACTIONS(2723),
    [anon_sym_AMP_AMP] = ACTIONS(2723),
    [anon_sym_TILDE] = ACTIONS(2725),
    [aux_sym_prefix_op_token1] = ACTIONS(2723),
    [aux_sym_infix_op_token1] = ACTIONS(2725),
    [aux_sym_infix_op_token2] = ACTIONS(2723),
    [anon_sym_PIPE_PIPE] = ACTIONS(2723),
    [anon_sym_BANG_EQ] = ACTIONS(2723),
    [anon_sym_COLON_EQ] = ACTIONS(2725),
    [anon_sym_DOLLAR] = ACTIONS(2723),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2723),
    [sym_int] = ACTIONS(2723),
    [sym_xint] = ACTIONS(2725),
    [anon_sym_f] = ACTIONS(2723),
    [aux_sym_decimal_token1] = ACTIONS(2723),
    [aux_sym_float_token1] = ACTIONS(3495),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2725),
    [sym__newline] = ACTIONS(2725),
  },
  [1311] = {
    [sym_block_comment] = STATE(1311),
    [sym_compiler_directive_decl] = STATE(1311),
    [sym_fsi_directive_decl] = STATE(1311),
    [sym_preproc_line] = STATE(1311),
    [sym_identifier] = ACTIONS(2340),
    [anon_sym_EQ] = ACTIONS(2342),
    [anon_sym_COLON] = ACTIONS(2340),
    [anon_sym_return] = ACTIONS(2340),
    [anon_sym_do] = ACTIONS(2340),
    [anon_sym_let] = ACTIONS(2340),
    [anon_sym_let_BANG] = ACTIONS(2342),
    [anon_sym_LPAREN] = ACTIONS(2340),
    [anon_sym_COMMA] = ACTIONS(2342),
    [anon_sym_null] = ACTIONS(2340),
    [anon_sym_QMARK] = ACTIONS(2340),
    [anon_sym_COLON_QMARK] = ACTIONS(2340),
    [anon_sym_COLON_COLON] = ACTIONS(2342),
    [anon_sym_AMP] = ACTIONS(2340),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2342),
    [anon_sym_LBRACE] = ACTIONS(2340),
    [anon_sym_LT_AT] = ACTIONS(2340),
    [anon_sym_LT_AT_AT] = ACTIONS(2340),
    [anon_sym_AT_AT_GT] = ACTIONS(2340),
    [anon_sym_DOT] = ACTIONS(2340),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2342),
    [anon_sym_new] = ACTIONS(2340),
    [anon_sym_return_BANG] = ACTIONS(2342),
    [anon_sym_yield] = ACTIONS(2340),
    [anon_sym_yield_BANG] = ACTIONS(2342),
    [anon_sym_lazy] = ACTIONS(2340),
    [anon_sym_assert] = ACTIONS(2340),
    [anon_sym_upcast] = ACTIONS(2340),
    [anon_sym_downcast] = ACTIONS(2340),
    [anon_sym_COLON_GT] = ACTIONS(2342),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2342),
    [anon_sym_for] = ACTIONS(2340),
    [anon_sym_while] = ACTIONS(2340),
    [anon_sym_if] = ACTIONS(2340),
    [anon_sym_fun] = ACTIONS(2340),
    [anon_sym_DASH_GT] = ACTIONS(2340),
    [anon_sym_try] = ACTIONS(2340),
    [anon_sym_match] = ACTIONS(2340),
    [anon_sym_match_BANG] = ACTIONS(2342),
    [anon_sym_function] = ACTIONS(2340),
    [anon_sym_LT_DASH] = ACTIONS(2340),
    [anon_sym_DOT_LBRACK] = ACTIONS(2342),
    [anon_sym_LT] = ACTIONS(2342),
    [anon_sym_use] = ACTIONS(2340),
    [anon_sym_use_BANG] = ACTIONS(2342),
    [anon_sym_do_BANG] = ACTIONS(2342),
    [anon_sym_begin] = ACTIONS(2340),
    [anon_sym_LPAREN2] = ACTIONS(2340),
    [anon_sym_STAR] = ACTIONS(2340),
    [anon_sym_LT2] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2342),
    [anon_sym_or] = ACTIONS(2340),
    [aux_sym_char_token1] = ACTIONS(2342),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2340),
    [anon_sym_DQUOTE] = ACTIONS(2340),
    [anon_sym_AT_DQUOTE] = ACTIONS(2342),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2342),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2342),
    [sym_bool] = ACTIONS(2340),
    [sym_unit] = ACTIONS(2342),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2340),
    [sym_op_identifier] = ACTIONS(2340),
    [anon_sym_PLUS] = ACTIONS(2340),
    [anon_sym_DASH] = ACTIONS(2340),
    [anon_sym_PLUS_DOT] = ACTIONS(2340),
    [anon_sym_DASH_DOT] = ACTIONS(2340),
    [anon_sym_PERCENT] = ACTIONS(2340),
    [anon_sym_AMP_AMP] = ACTIONS(2340),
    [anon_sym_TILDE] = ACTIONS(2342),
    [aux_sym_prefix_op_token1] = ACTIONS(2340),
    [aux_sym_infix_op_token1] = ACTIONS(2342),
    [aux_sym_infix_op_token2] = ACTIONS(2340),
    [anon_sym_PIPE_PIPE] = ACTIONS(2340),
    [anon_sym_BANG_EQ] = ACTIONS(2340),
    [anon_sym_COLON_EQ] = ACTIONS(2342),
    [anon_sym_DOLLAR] = ACTIONS(2340),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2340),
    [sym_int] = ACTIONS(2340),
    [sym_xint] = ACTIONS(2342),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2342),
    [sym__newline] = ACTIONS(2342),
  },
  [1312] = {
    [sym_block_comment] = STATE(1312),
    [sym_compiler_directive_decl] = STATE(1312),
    [sym_fsi_directive_decl] = STATE(1312),
    [sym_preproc_line] = STATE(1312),
    [sym_identifier] = ACTIONS(2474),
    [anon_sym_EQ] = ACTIONS(2476),
    [anon_sym_COLON] = ACTIONS(2474),
    [anon_sym_return] = ACTIONS(2474),
    [anon_sym_do] = ACTIONS(2474),
    [anon_sym_let] = ACTIONS(2474),
    [anon_sym_let_BANG] = ACTIONS(2476),
    [anon_sym_LPAREN] = ACTIONS(2474),
    [anon_sym_COMMA] = ACTIONS(2476),
    [anon_sym_null] = ACTIONS(2474),
    [anon_sym_QMARK] = ACTIONS(2474),
    [anon_sym_COLON_QMARK] = ACTIONS(2474),
    [anon_sym_COLON_COLON] = ACTIONS(2476),
    [anon_sym_AMP] = ACTIONS(2474),
    [anon_sym_LBRACK] = ACTIONS(2474),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2476),
    [anon_sym_LBRACE] = ACTIONS(2474),
    [anon_sym_LT_AT] = ACTIONS(2474),
    [anon_sym_LT_AT_AT] = ACTIONS(2474),
    [anon_sym_DOT] = ACTIONS(2474),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2476),
    [anon_sym_new] = ACTIONS(2474),
    [anon_sym_return_BANG] = ACTIONS(2476),
    [anon_sym_yield] = ACTIONS(2474),
    [anon_sym_yield_BANG] = ACTIONS(2476),
    [anon_sym_lazy] = ACTIONS(2474),
    [anon_sym_assert] = ACTIONS(2474),
    [anon_sym_upcast] = ACTIONS(2474),
    [anon_sym_downcast] = ACTIONS(2474),
    [anon_sym_COLON_GT] = ACTIONS(2476),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2476),
    [anon_sym_for] = ACTIONS(2474),
    [anon_sym_while] = ACTIONS(2474),
    [anon_sym_if] = ACTIONS(2474),
    [anon_sym_fun] = ACTIONS(2474),
    [anon_sym_DASH_GT] = ACTIONS(2474),
    [anon_sym_try] = ACTIONS(2474),
    [anon_sym_match] = ACTIONS(2474),
    [anon_sym_match_BANG] = ACTIONS(2476),
    [anon_sym_function] = ACTIONS(2474),
    [anon_sym_LT_DASH] = ACTIONS(2474),
    [anon_sym_DOT_LBRACK] = ACTIONS(2476),
    [anon_sym_LT] = ACTIONS(2476),
    [anon_sym_GT] = ACTIONS(2474),
    [anon_sym_use] = ACTIONS(2474),
    [anon_sym_use_BANG] = ACTIONS(2476),
    [anon_sym_do_BANG] = ACTIONS(2476),
    [anon_sym_begin] = ACTIONS(2474),
    [anon_sym_LPAREN2] = ACTIONS(2474),
    [anon_sym_STAR] = ACTIONS(2474),
    [anon_sym_LT2] = ACTIONS(2474),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2476),
    [anon_sym_or] = ACTIONS(2474),
    [aux_sym_char_token1] = ACTIONS(2476),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2474),
    [anon_sym_DQUOTE] = ACTIONS(2474),
    [anon_sym_AT_DQUOTE] = ACTIONS(2476),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2476),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2476),
    [sym_bool] = ACTIONS(2474),
    [sym_unit] = ACTIONS(2476),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2474),
    [sym_op_identifier] = ACTIONS(2474),
    [anon_sym_PLUS] = ACTIONS(2474),
    [anon_sym_DASH] = ACTIONS(2474),
    [anon_sym_PLUS_DOT] = ACTIONS(2474),
    [anon_sym_DASH_DOT] = ACTIONS(2474),
    [anon_sym_PERCENT] = ACTIONS(2474),
    [anon_sym_AMP_AMP] = ACTIONS(2474),
    [anon_sym_TILDE] = ACTIONS(2476),
    [aux_sym_prefix_op_token1] = ACTIONS(2474),
    [aux_sym_infix_op_token1] = ACTIONS(2476),
    [aux_sym_infix_op_token2] = ACTIONS(2474),
    [anon_sym_PIPE_PIPE] = ACTIONS(2474),
    [anon_sym_BANG_EQ] = ACTIONS(2474),
    [anon_sym_COLON_EQ] = ACTIONS(2476),
    [anon_sym_DOLLAR] = ACTIONS(2474),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2474),
    [sym_int] = ACTIONS(2474),
    [sym_xint] = ACTIONS(2476),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2476),
    [sym__newline] = ACTIONS(2476),
  },
  [1313] = {
    [sym_block_comment] = STATE(1313),
    [sym_compiler_directive_decl] = STATE(1313),
    [sym_fsi_directive_decl] = STATE(1313),
    [sym_preproc_line] = STATE(1313),
    [sym_identifier] = ACTIONS(2510),
    [anon_sym_EQ] = ACTIONS(2512),
    [anon_sym_COLON] = ACTIONS(2510),
    [anon_sym_return] = ACTIONS(2510),
    [anon_sym_do] = ACTIONS(2510),
    [anon_sym_let] = ACTIONS(2510),
    [anon_sym_let_BANG] = ACTIONS(2512),
    [anon_sym_LPAREN] = ACTIONS(2510),
    [anon_sym_COMMA] = ACTIONS(2512),
    [anon_sym_null] = ACTIONS(2510),
    [anon_sym_QMARK] = ACTIONS(2510),
    [anon_sym_COLON_QMARK] = ACTIONS(2510),
    [anon_sym_COLON_COLON] = ACTIONS(2512),
    [anon_sym_AMP] = ACTIONS(2510),
    [anon_sym_LBRACK] = ACTIONS(2510),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2512),
    [anon_sym_LBRACE] = ACTIONS(2510),
    [anon_sym_LT_AT] = ACTIONS(2510),
    [anon_sym_LT_AT_AT] = ACTIONS(2510),
    [anon_sym_DOT] = ACTIONS(2510),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2512),
    [anon_sym_new] = ACTIONS(2510),
    [anon_sym_return_BANG] = ACTIONS(2512),
    [anon_sym_yield] = ACTIONS(2510),
    [anon_sym_yield_BANG] = ACTIONS(2512),
    [anon_sym_lazy] = ACTIONS(2510),
    [anon_sym_assert] = ACTIONS(2510),
    [anon_sym_upcast] = ACTIONS(2510),
    [anon_sym_downcast] = ACTIONS(2510),
    [anon_sym_COLON_GT] = ACTIONS(2512),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2512),
    [anon_sym_for] = ACTIONS(2510),
    [anon_sym_while] = ACTIONS(2510),
    [anon_sym_if] = ACTIONS(2510),
    [anon_sym_fun] = ACTIONS(2510),
    [anon_sym_DASH_GT] = ACTIONS(2510),
    [anon_sym_try] = ACTIONS(2510),
    [anon_sym_match] = ACTIONS(2510),
    [anon_sym_match_BANG] = ACTIONS(2512),
    [anon_sym_function] = ACTIONS(2510),
    [anon_sym_LT_DASH] = ACTIONS(2510),
    [anon_sym_DOT_LBRACK] = ACTIONS(2512),
    [anon_sym_LT] = ACTIONS(2512),
    [anon_sym_GT] = ACTIONS(2510),
    [anon_sym_use] = ACTIONS(2510),
    [anon_sym_use_BANG] = ACTIONS(2512),
    [anon_sym_do_BANG] = ACTIONS(2512),
    [anon_sym_begin] = ACTIONS(2510),
    [anon_sym_LPAREN2] = ACTIONS(2510),
    [anon_sym_STAR] = ACTIONS(2510),
    [anon_sym_LT2] = ACTIONS(2510),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2512),
    [anon_sym_or] = ACTIONS(2510),
    [aux_sym_char_token1] = ACTIONS(2512),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2510),
    [anon_sym_DQUOTE] = ACTIONS(2510),
    [anon_sym_AT_DQUOTE] = ACTIONS(2512),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2512),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2512),
    [sym_bool] = ACTIONS(2510),
    [sym_unit] = ACTIONS(2512),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2510),
    [sym_op_identifier] = ACTIONS(2510),
    [anon_sym_PLUS] = ACTIONS(2510),
    [anon_sym_DASH] = ACTIONS(2510),
    [anon_sym_PLUS_DOT] = ACTIONS(2510),
    [anon_sym_DASH_DOT] = ACTIONS(2510),
    [anon_sym_PERCENT] = ACTIONS(2510),
    [anon_sym_AMP_AMP] = ACTIONS(2510),
    [anon_sym_TILDE] = ACTIONS(2512),
    [aux_sym_prefix_op_token1] = ACTIONS(2510),
    [aux_sym_infix_op_token1] = ACTIONS(2512),
    [aux_sym_infix_op_token2] = ACTIONS(2510),
    [anon_sym_PIPE_PIPE] = ACTIONS(2510),
    [anon_sym_BANG_EQ] = ACTIONS(2510),
    [anon_sym_COLON_EQ] = ACTIONS(2512),
    [anon_sym_DOLLAR] = ACTIONS(2510),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2510),
    [sym_int] = ACTIONS(2510),
    [sym_xint] = ACTIONS(2512),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2512),
    [sym__newline] = ACTIONS(2512),
  },
  [1314] = {
    [sym_block_comment] = STATE(1314),
    [sym_compiler_directive_decl] = STATE(1314),
    [sym_fsi_directive_decl] = STATE(1314),
    [sym_preproc_line] = STATE(1314),
    [sym_identifier] = ACTIONS(2557),
    [anon_sym_EQ] = ACTIONS(2559),
    [anon_sym_COLON] = ACTIONS(2557),
    [anon_sym_return] = ACTIONS(2557),
    [anon_sym_do] = ACTIONS(2557),
    [anon_sym_let] = ACTIONS(2557),
    [anon_sym_let_BANG] = ACTIONS(2559),
    [anon_sym_LPAREN] = ACTIONS(2557),
    [anon_sym_COMMA] = ACTIONS(2559),
    [anon_sym_null] = ACTIONS(2557),
    [anon_sym_QMARK] = ACTIONS(2557),
    [anon_sym_COLON_QMARK] = ACTIONS(2557),
    [anon_sym_COLON_COLON] = ACTIONS(2559),
    [anon_sym_AMP] = ACTIONS(2557),
    [anon_sym_LBRACK] = ACTIONS(2557),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2559),
    [anon_sym_LBRACE] = ACTIONS(2557),
    [anon_sym_LT_AT] = ACTIONS(2557),
    [anon_sym_LT_AT_AT] = ACTIONS(2557),
    [anon_sym_DOT] = ACTIONS(2557),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2559),
    [anon_sym_new] = ACTIONS(2557),
    [anon_sym_return_BANG] = ACTIONS(2559),
    [anon_sym_yield] = ACTIONS(2557),
    [anon_sym_yield_BANG] = ACTIONS(2559),
    [anon_sym_lazy] = ACTIONS(2557),
    [anon_sym_assert] = ACTIONS(2557),
    [anon_sym_upcast] = ACTIONS(2557),
    [anon_sym_downcast] = ACTIONS(2557),
    [anon_sym_COLON_GT] = ACTIONS(2559),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2559),
    [anon_sym_for] = ACTIONS(2557),
    [anon_sym_while] = ACTIONS(2557),
    [anon_sym_if] = ACTIONS(2557),
    [anon_sym_fun] = ACTIONS(2557),
    [anon_sym_DASH_GT] = ACTIONS(2557),
    [anon_sym_try] = ACTIONS(2557),
    [anon_sym_match] = ACTIONS(2557),
    [anon_sym_match_BANG] = ACTIONS(2559),
    [anon_sym_function] = ACTIONS(2557),
    [anon_sym_LT_DASH] = ACTIONS(2557),
    [anon_sym_DOT_LBRACK] = ACTIONS(2559),
    [anon_sym_LT] = ACTIONS(2559),
    [anon_sym_use] = ACTIONS(2557),
    [anon_sym_use_BANG] = ACTIONS(2559),
    [anon_sym_do_BANG] = ACTIONS(2559),
    [anon_sym_begin] = ACTIONS(2557),
    [anon_sym_LPAREN2] = ACTIONS(2557),
    [anon_sym_STAR] = ACTIONS(2557),
    [anon_sym_LT2] = ACTIONS(3497),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2559),
    [anon_sym_or] = ACTIONS(2557),
    [aux_sym_char_token1] = ACTIONS(2559),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2557),
    [anon_sym_DQUOTE] = ACTIONS(2557),
    [anon_sym_AT_DQUOTE] = ACTIONS(2559),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2559),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2559),
    [sym_bool] = ACTIONS(2557),
    [sym_unit] = ACTIONS(2559),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2557),
    [sym_op_identifier] = ACTIONS(2557),
    [anon_sym_PLUS] = ACTIONS(2557),
    [anon_sym_DASH] = ACTIONS(2557),
    [anon_sym_PLUS_DOT] = ACTIONS(2557),
    [anon_sym_DASH_DOT] = ACTIONS(2557),
    [anon_sym_PERCENT] = ACTIONS(2557),
    [anon_sym_AMP_AMP] = ACTIONS(2557),
    [anon_sym_TILDE] = ACTIONS(2559),
    [aux_sym_prefix_op_token1] = ACTIONS(2557),
    [aux_sym_infix_op_token1] = ACTIONS(2559),
    [aux_sym_infix_op_token2] = ACTIONS(2557),
    [anon_sym_PIPE_PIPE] = ACTIONS(2557),
    [anon_sym_BANG_EQ] = ACTIONS(2557),
    [anon_sym_COLON_EQ] = ACTIONS(2559),
    [anon_sym_DOLLAR] = ACTIONS(2557),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2557),
    [sym_int] = ACTIONS(2557),
    [sym_xint] = ACTIONS(2559),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2559),
    [anon_sym_POUNDendif] = ACTIONS(2559),
    [sym__newline] = ACTIONS(2559),
  },
  [1315] = {
    [sym_block_comment] = STATE(1315),
    [sym_compiler_directive_decl] = STATE(1315),
    [sym_fsi_directive_decl] = STATE(1315),
    [sym_preproc_line] = STATE(1315),
    [sym_identifier] = ACTIONS(2567),
    [anon_sym_EQ] = ACTIONS(2569),
    [anon_sym_COLON] = ACTIONS(2567),
    [anon_sym_return] = ACTIONS(2567),
    [anon_sym_do] = ACTIONS(2567),
    [anon_sym_let] = ACTIONS(2567),
    [anon_sym_let_BANG] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2567),
    [anon_sym_COMMA] = ACTIONS(2569),
    [anon_sym_null] = ACTIONS(2567),
    [anon_sym_QMARK] = ACTIONS(2567),
    [anon_sym_COLON_QMARK] = ACTIONS(2567),
    [anon_sym_COLON_COLON] = ACTIONS(2569),
    [anon_sym_AMP] = ACTIONS(2567),
    [anon_sym_LBRACK] = ACTIONS(2567),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2569),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_LT_AT] = ACTIONS(2567),
    [anon_sym_LT_AT_AT] = ACTIONS(2567),
    [anon_sym_DOT] = ACTIONS(2567),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2569),
    [anon_sym_new] = ACTIONS(2567),
    [anon_sym_return_BANG] = ACTIONS(2569),
    [anon_sym_yield] = ACTIONS(2567),
    [anon_sym_yield_BANG] = ACTIONS(2569),
    [anon_sym_lazy] = ACTIONS(2567),
    [anon_sym_assert] = ACTIONS(2567),
    [anon_sym_upcast] = ACTIONS(2567),
    [anon_sym_downcast] = ACTIONS(2567),
    [anon_sym_COLON_GT] = ACTIONS(2569),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2569),
    [anon_sym_for] = ACTIONS(2567),
    [anon_sym_while] = ACTIONS(2567),
    [anon_sym_if] = ACTIONS(2567),
    [anon_sym_fun] = ACTIONS(2567),
    [anon_sym_DASH_GT] = ACTIONS(2567),
    [anon_sym_try] = ACTIONS(2567),
    [anon_sym_match] = ACTIONS(2567),
    [anon_sym_match_BANG] = ACTIONS(2569),
    [anon_sym_function] = ACTIONS(2567),
    [anon_sym_LT_DASH] = ACTIONS(2567),
    [anon_sym_DOT_LBRACK] = ACTIONS(2569),
    [anon_sym_LT] = ACTIONS(2569),
    [anon_sym_use] = ACTIONS(2567),
    [anon_sym_use_BANG] = ACTIONS(2569),
    [anon_sym_do_BANG] = ACTIONS(2569),
    [anon_sym_begin] = ACTIONS(2567),
    [anon_sym_LPAREN2] = ACTIONS(2567),
    [anon_sym_STAR] = ACTIONS(2567),
    [anon_sym_LT2] = ACTIONS(2567),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2569),
    [anon_sym_or] = ACTIONS(2567),
    [aux_sym_char_token1] = ACTIONS(2569),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2567),
    [anon_sym_DQUOTE] = ACTIONS(2567),
    [anon_sym_AT_DQUOTE] = ACTIONS(2569),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2569),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2569),
    [sym_bool] = ACTIONS(2567),
    [sym_unit] = ACTIONS(2569),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2567),
    [sym_op_identifier] = ACTIONS(2567),
    [anon_sym_PLUS] = ACTIONS(2567),
    [anon_sym_DASH] = ACTIONS(2567),
    [anon_sym_PLUS_DOT] = ACTIONS(2567),
    [anon_sym_DASH_DOT] = ACTIONS(2567),
    [anon_sym_PERCENT] = ACTIONS(2567),
    [anon_sym_AMP_AMP] = ACTIONS(2567),
    [anon_sym_TILDE] = ACTIONS(2569),
    [aux_sym_prefix_op_token1] = ACTIONS(2567),
    [aux_sym_infix_op_token1] = ACTIONS(2569),
    [aux_sym_infix_op_token2] = ACTIONS(2567),
    [anon_sym_PIPE_PIPE] = ACTIONS(2567),
    [anon_sym_BANG_EQ] = ACTIONS(2567),
    [anon_sym_COLON_EQ] = ACTIONS(2569),
    [anon_sym_DOLLAR] = ACTIONS(2567),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2567),
    [sym_int] = ACTIONS(2567),
    [sym_xint] = ACTIONS(2569),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2569),
    [anon_sym_POUNDendif] = ACTIONS(2569),
    [sym__newline] = ACTIONS(2569),
  },
  [1316] = {
    [sym_block_comment] = STATE(1316),
    [sym_compiler_directive_decl] = STATE(1316),
    [sym_fsi_directive_decl] = STATE(1316),
    [sym_preproc_line] = STATE(1316),
    [sym_identifier] = ACTIONS(2557),
    [anon_sym_EQ] = ACTIONS(2559),
    [anon_sym_COLON] = ACTIONS(2557),
    [anon_sym_return] = ACTIONS(2557),
    [anon_sym_do] = ACTIONS(2557),
    [anon_sym_let] = ACTIONS(2557),
    [anon_sym_let_BANG] = ACTIONS(2559),
    [anon_sym_LPAREN] = ACTIONS(2557),
    [anon_sym_COMMA] = ACTIONS(2559),
    [anon_sym_null] = ACTIONS(2557),
    [anon_sym_QMARK] = ACTIONS(2557),
    [anon_sym_COLON_QMARK] = ACTIONS(2557),
    [anon_sym_COLON_COLON] = ACTIONS(2559),
    [anon_sym_AMP] = ACTIONS(2557),
    [anon_sym_LBRACK] = ACTIONS(2557),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2559),
    [anon_sym_LBRACE] = ACTIONS(2557),
    [anon_sym_LT_AT] = ACTIONS(2557),
    [anon_sym_LT_AT_AT] = ACTIONS(2557),
    [anon_sym_DOT] = ACTIONS(2557),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2559),
    [anon_sym_new] = ACTIONS(2557),
    [anon_sym_return_BANG] = ACTIONS(2559),
    [anon_sym_yield] = ACTIONS(2557),
    [anon_sym_yield_BANG] = ACTIONS(2559),
    [anon_sym_lazy] = ACTIONS(2557),
    [anon_sym_assert] = ACTIONS(2557),
    [anon_sym_upcast] = ACTIONS(2557),
    [anon_sym_downcast] = ACTIONS(2557),
    [anon_sym_COLON_GT] = ACTIONS(2559),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2559),
    [anon_sym_for] = ACTIONS(2557),
    [anon_sym_while] = ACTIONS(2557),
    [anon_sym_if] = ACTIONS(2557),
    [anon_sym_fun] = ACTIONS(2557),
    [anon_sym_DASH_GT] = ACTIONS(2557),
    [anon_sym_try] = ACTIONS(2557),
    [anon_sym_match] = ACTIONS(2557),
    [anon_sym_match_BANG] = ACTIONS(2559),
    [anon_sym_function] = ACTIONS(2557),
    [anon_sym_LT_DASH] = ACTIONS(2557),
    [anon_sym_DOT_LBRACK] = ACTIONS(2559),
    [anon_sym_LT] = ACTIONS(2559),
    [anon_sym_GT] = ACTIONS(2557),
    [anon_sym_use] = ACTIONS(2557),
    [anon_sym_use_BANG] = ACTIONS(2559),
    [anon_sym_do_BANG] = ACTIONS(2559),
    [anon_sym_begin] = ACTIONS(2557),
    [anon_sym_LPAREN2] = ACTIONS(2557),
    [anon_sym_STAR] = ACTIONS(2557),
    [anon_sym_LT2] = ACTIONS(3499),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2559),
    [anon_sym_or] = ACTIONS(2557),
    [aux_sym_char_token1] = ACTIONS(2559),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2557),
    [anon_sym_DQUOTE] = ACTIONS(2557),
    [anon_sym_AT_DQUOTE] = ACTIONS(2559),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2559),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2559),
    [sym_bool] = ACTIONS(2557),
    [sym_unit] = ACTIONS(2559),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2557),
    [sym_op_identifier] = ACTIONS(2557),
    [anon_sym_PLUS] = ACTIONS(2557),
    [anon_sym_DASH] = ACTIONS(2557),
    [anon_sym_PLUS_DOT] = ACTIONS(2557),
    [anon_sym_DASH_DOT] = ACTIONS(2557),
    [anon_sym_PERCENT] = ACTIONS(2557),
    [anon_sym_AMP_AMP] = ACTIONS(2557),
    [anon_sym_TILDE] = ACTIONS(2559),
    [aux_sym_prefix_op_token1] = ACTIONS(2557),
    [aux_sym_infix_op_token1] = ACTIONS(2559),
    [aux_sym_infix_op_token2] = ACTIONS(2557),
    [anon_sym_PIPE_PIPE] = ACTIONS(2557),
    [anon_sym_BANG_EQ] = ACTIONS(2557),
    [anon_sym_COLON_EQ] = ACTIONS(2559),
    [anon_sym_DOLLAR] = ACTIONS(2557),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2557),
    [sym_int] = ACTIONS(2557),
    [sym_xint] = ACTIONS(2559),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2559),
    [sym__newline] = ACTIONS(2559),
  },
  [1317] = {
    [sym_block_comment] = STATE(1317),
    [sym_compiler_directive_decl] = STATE(1317),
    [sym_fsi_directive_decl] = STATE(1317),
    [sym_preproc_line] = STATE(1317),
    [sym_identifier] = ACTIONS(2567),
    [anon_sym_EQ] = ACTIONS(2569),
    [anon_sym_COLON] = ACTIONS(2567),
    [anon_sym_return] = ACTIONS(2567),
    [anon_sym_do] = ACTIONS(2567),
    [anon_sym_let] = ACTIONS(2567),
    [anon_sym_let_BANG] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2567),
    [anon_sym_COMMA] = ACTIONS(2569),
    [anon_sym_null] = ACTIONS(2567),
    [anon_sym_QMARK] = ACTIONS(2567),
    [anon_sym_COLON_QMARK] = ACTIONS(2567),
    [anon_sym_COLON_COLON] = ACTIONS(2569),
    [anon_sym_AMP] = ACTIONS(2567),
    [anon_sym_LBRACK] = ACTIONS(2567),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2569),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_LT_AT] = ACTIONS(2567),
    [anon_sym_LT_AT_AT] = ACTIONS(2567),
    [anon_sym_DOT] = ACTIONS(2567),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2569),
    [anon_sym_new] = ACTIONS(2567),
    [anon_sym_return_BANG] = ACTIONS(2569),
    [anon_sym_yield] = ACTIONS(2567),
    [anon_sym_yield_BANG] = ACTIONS(2569),
    [anon_sym_lazy] = ACTIONS(2567),
    [anon_sym_assert] = ACTIONS(2567),
    [anon_sym_upcast] = ACTIONS(2567),
    [anon_sym_downcast] = ACTIONS(2567),
    [anon_sym_COLON_GT] = ACTIONS(2569),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2569),
    [anon_sym_for] = ACTIONS(2567),
    [anon_sym_while] = ACTIONS(2567),
    [anon_sym_if] = ACTIONS(2567),
    [anon_sym_fun] = ACTIONS(2567),
    [anon_sym_DASH_GT] = ACTIONS(2567),
    [anon_sym_try] = ACTIONS(2567),
    [anon_sym_match] = ACTIONS(2567),
    [anon_sym_match_BANG] = ACTIONS(2569),
    [anon_sym_function] = ACTIONS(2567),
    [anon_sym_LT_DASH] = ACTIONS(2567),
    [anon_sym_DOT_LBRACK] = ACTIONS(2569),
    [anon_sym_LT] = ACTIONS(2569),
    [anon_sym_GT] = ACTIONS(2567),
    [anon_sym_use] = ACTIONS(2567),
    [anon_sym_use_BANG] = ACTIONS(2569),
    [anon_sym_do_BANG] = ACTIONS(2569),
    [anon_sym_begin] = ACTIONS(2567),
    [anon_sym_LPAREN2] = ACTIONS(2567),
    [anon_sym_STAR] = ACTIONS(2567),
    [anon_sym_LT2] = ACTIONS(2567),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2569),
    [anon_sym_or] = ACTIONS(2567),
    [aux_sym_char_token1] = ACTIONS(2569),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2567),
    [anon_sym_DQUOTE] = ACTIONS(2567),
    [anon_sym_AT_DQUOTE] = ACTIONS(2569),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2569),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2569),
    [sym_bool] = ACTIONS(2567),
    [sym_unit] = ACTIONS(2569),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2567),
    [sym_op_identifier] = ACTIONS(2567),
    [anon_sym_PLUS] = ACTIONS(2567),
    [anon_sym_DASH] = ACTIONS(2567),
    [anon_sym_PLUS_DOT] = ACTIONS(2567),
    [anon_sym_DASH_DOT] = ACTIONS(2567),
    [anon_sym_PERCENT] = ACTIONS(2567),
    [anon_sym_AMP_AMP] = ACTIONS(2567),
    [anon_sym_TILDE] = ACTIONS(2569),
    [aux_sym_prefix_op_token1] = ACTIONS(2567),
    [aux_sym_infix_op_token1] = ACTIONS(2569),
    [aux_sym_infix_op_token2] = ACTIONS(2567),
    [anon_sym_PIPE_PIPE] = ACTIONS(2567),
    [anon_sym_BANG_EQ] = ACTIONS(2567),
    [anon_sym_COLON_EQ] = ACTIONS(2569),
    [anon_sym_DOLLAR] = ACTIONS(2567),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2567),
    [sym_int] = ACTIONS(2567),
    [sym_xint] = ACTIONS(2569),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2569),
    [sym__newline] = ACTIONS(2569),
  },
  [1318] = {
    [sym_block_comment] = STATE(1318),
    [sym_compiler_directive_decl] = STATE(1318),
    [sym_fsi_directive_decl] = STATE(1318),
    [sym_preproc_line] = STATE(1318),
    [sym_identifier] = ACTIONS(2514),
    [anon_sym_EQ] = ACTIONS(2516),
    [anon_sym_COLON] = ACTIONS(2514),
    [anon_sym_return] = ACTIONS(2514),
    [anon_sym_do] = ACTIONS(2514),
    [anon_sym_let] = ACTIONS(2514),
    [anon_sym_let_BANG] = ACTIONS(2516),
    [anon_sym_LPAREN] = ACTIONS(2514),
    [anon_sym_COMMA] = ACTIONS(2516),
    [anon_sym_null] = ACTIONS(2514),
    [anon_sym_QMARK] = ACTIONS(2514),
    [anon_sym_COLON_QMARK] = ACTIONS(2514),
    [anon_sym_COLON_COLON] = ACTIONS(2516),
    [anon_sym_AMP] = ACTIONS(2514),
    [anon_sym_LBRACK] = ACTIONS(2514),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2516),
    [anon_sym_LBRACE] = ACTIONS(2514),
    [anon_sym_LT_AT] = ACTIONS(2514),
    [anon_sym_LT_AT_AT] = ACTIONS(2514),
    [anon_sym_DOT] = ACTIONS(2514),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2516),
    [anon_sym_new] = ACTIONS(2514),
    [anon_sym_return_BANG] = ACTIONS(2516),
    [anon_sym_yield] = ACTIONS(2514),
    [anon_sym_yield_BANG] = ACTIONS(2516),
    [anon_sym_lazy] = ACTIONS(2514),
    [anon_sym_assert] = ACTIONS(2514),
    [anon_sym_upcast] = ACTIONS(2514),
    [anon_sym_downcast] = ACTIONS(2514),
    [anon_sym_COLON_GT] = ACTIONS(2516),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2516),
    [anon_sym_for] = ACTIONS(2514),
    [anon_sym_while] = ACTIONS(2514),
    [anon_sym_if] = ACTIONS(2514),
    [anon_sym_fun] = ACTIONS(2514),
    [anon_sym_DASH_GT] = ACTIONS(2514),
    [anon_sym_try] = ACTIONS(2514),
    [anon_sym_match] = ACTIONS(2514),
    [anon_sym_match_BANG] = ACTIONS(2516),
    [anon_sym_function] = ACTIONS(2514),
    [anon_sym_LT_DASH] = ACTIONS(2514),
    [anon_sym_DOT_LBRACK] = ACTIONS(2516),
    [anon_sym_LT] = ACTIONS(2516),
    [anon_sym_use] = ACTIONS(2514),
    [anon_sym_use_BANG] = ACTIONS(2516),
    [anon_sym_do_BANG] = ACTIONS(2516),
    [anon_sym_begin] = ACTIONS(2514),
    [anon_sym_LPAREN2] = ACTIONS(2514),
    [anon_sym_STAR] = ACTIONS(2514),
    [anon_sym_LT2] = ACTIONS(2514),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2516),
    [anon_sym_or] = ACTIONS(2514),
    [aux_sym_char_token1] = ACTIONS(2516),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2514),
    [anon_sym_DQUOTE] = ACTIONS(2514),
    [anon_sym_AT_DQUOTE] = ACTIONS(2516),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2516),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2516),
    [sym_bool] = ACTIONS(2514),
    [sym_unit] = ACTIONS(2516),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2514),
    [sym_op_identifier] = ACTIONS(2514),
    [anon_sym_PLUS] = ACTIONS(2514),
    [anon_sym_DASH] = ACTIONS(2514),
    [anon_sym_PLUS_DOT] = ACTIONS(2514),
    [anon_sym_DASH_DOT] = ACTIONS(2514),
    [anon_sym_PERCENT] = ACTIONS(2514),
    [anon_sym_AMP_AMP] = ACTIONS(2514),
    [anon_sym_TILDE] = ACTIONS(2516),
    [aux_sym_prefix_op_token1] = ACTIONS(2514),
    [aux_sym_infix_op_token1] = ACTIONS(2516),
    [aux_sym_infix_op_token2] = ACTIONS(2514),
    [anon_sym_PIPE_PIPE] = ACTIONS(2514),
    [anon_sym_BANG_EQ] = ACTIONS(2514),
    [anon_sym_COLON_EQ] = ACTIONS(2516),
    [anon_sym_DOLLAR] = ACTIONS(2514),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2514),
    [sym_int] = ACTIONS(2514),
    [sym_xint] = ACTIONS(2516),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2516),
    [anon_sym_POUNDendif] = ACTIONS(2516),
    [sym__newline] = ACTIONS(2516),
  },
  [1319] = {
    [sym_block_comment] = STATE(1319),
    [sym_compiler_directive_decl] = STATE(1319),
    [sym_fsi_directive_decl] = STATE(1319),
    [sym_preproc_line] = STATE(1319),
    [sym_identifier] = ACTIONS(2563),
    [anon_sym_EQ] = ACTIONS(2565),
    [anon_sym_COLON] = ACTIONS(2563),
    [anon_sym_return] = ACTIONS(2563),
    [anon_sym_do] = ACTIONS(2563),
    [anon_sym_let] = ACTIONS(2563),
    [anon_sym_let_BANG] = ACTIONS(2565),
    [anon_sym_LPAREN] = ACTIONS(2563),
    [anon_sym_COMMA] = ACTIONS(2565),
    [anon_sym_null] = ACTIONS(2563),
    [anon_sym_QMARK] = ACTIONS(2563),
    [anon_sym_COLON_QMARK] = ACTIONS(2563),
    [anon_sym_COLON_COLON] = ACTIONS(2565),
    [anon_sym_AMP] = ACTIONS(2563),
    [anon_sym_LBRACK] = ACTIONS(2563),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2565),
    [anon_sym_LBRACE] = ACTIONS(2563),
    [anon_sym_LT_AT] = ACTIONS(2563),
    [anon_sym_LT_AT_AT] = ACTIONS(2563),
    [anon_sym_DOT] = ACTIONS(2563),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2565),
    [anon_sym_new] = ACTIONS(2563),
    [anon_sym_return_BANG] = ACTIONS(2565),
    [anon_sym_yield] = ACTIONS(2563),
    [anon_sym_yield_BANG] = ACTIONS(2565),
    [anon_sym_lazy] = ACTIONS(2563),
    [anon_sym_assert] = ACTIONS(2563),
    [anon_sym_upcast] = ACTIONS(2563),
    [anon_sym_downcast] = ACTIONS(2563),
    [anon_sym_COLON_GT] = ACTIONS(2565),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2565),
    [anon_sym_for] = ACTIONS(2563),
    [anon_sym_while] = ACTIONS(2563),
    [anon_sym_if] = ACTIONS(2563),
    [anon_sym_fun] = ACTIONS(2563),
    [anon_sym_DASH_GT] = ACTIONS(2563),
    [anon_sym_try] = ACTIONS(2563),
    [anon_sym_match] = ACTIONS(2563),
    [anon_sym_match_BANG] = ACTIONS(2565),
    [anon_sym_function] = ACTIONS(2563),
    [anon_sym_LT_DASH] = ACTIONS(2563),
    [anon_sym_DOT_LBRACK] = ACTIONS(2565),
    [anon_sym_LT] = ACTIONS(2565),
    [anon_sym_use] = ACTIONS(2563),
    [anon_sym_use_BANG] = ACTIONS(2565),
    [anon_sym_do_BANG] = ACTIONS(2565),
    [anon_sym_begin] = ACTIONS(2563),
    [anon_sym_LPAREN2] = ACTIONS(2563),
    [anon_sym_STAR] = ACTIONS(2563),
    [anon_sym_LT2] = ACTIONS(2563),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2565),
    [anon_sym_or] = ACTIONS(2563),
    [aux_sym_char_token1] = ACTIONS(2565),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2563),
    [anon_sym_DQUOTE] = ACTIONS(2563),
    [anon_sym_AT_DQUOTE] = ACTIONS(2565),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2565),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2565),
    [sym_bool] = ACTIONS(2563),
    [sym_unit] = ACTIONS(2565),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2563),
    [sym_op_identifier] = ACTIONS(2563),
    [anon_sym_PLUS] = ACTIONS(2563),
    [anon_sym_DASH] = ACTIONS(2563),
    [anon_sym_PLUS_DOT] = ACTIONS(2563),
    [anon_sym_DASH_DOT] = ACTIONS(2563),
    [anon_sym_PERCENT] = ACTIONS(2563),
    [anon_sym_AMP_AMP] = ACTIONS(2563),
    [anon_sym_TILDE] = ACTIONS(2565),
    [aux_sym_prefix_op_token1] = ACTIONS(2563),
    [aux_sym_infix_op_token1] = ACTIONS(2565),
    [aux_sym_infix_op_token2] = ACTIONS(2563),
    [anon_sym_PIPE_PIPE] = ACTIONS(2563),
    [anon_sym_BANG_EQ] = ACTIONS(2563),
    [anon_sym_COLON_EQ] = ACTIONS(2565),
    [anon_sym_DOLLAR] = ACTIONS(2563),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2563),
    [sym_int] = ACTIONS(2563),
    [sym_xint] = ACTIONS(2565),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2565),
    [anon_sym_POUNDendif] = ACTIONS(2565),
    [sym__newline] = ACTIONS(2565),
  },
  [1320] = {
    [sym_block_comment] = STATE(1320),
    [sym_compiler_directive_decl] = STATE(1320),
    [sym_fsi_directive_decl] = STATE(1320),
    [sym_preproc_line] = STATE(1320),
    [sym_identifier] = ACTIONS(2454),
    [anon_sym_EQ] = ACTIONS(2456),
    [anon_sym_COLON] = ACTIONS(2454),
    [anon_sym_return] = ACTIONS(2454),
    [anon_sym_do] = ACTIONS(2454),
    [anon_sym_let] = ACTIONS(2454),
    [anon_sym_let_BANG] = ACTIONS(2456),
    [anon_sym_LPAREN] = ACTIONS(2454),
    [anon_sym_COMMA] = ACTIONS(2456),
    [anon_sym_null] = ACTIONS(2454),
    [anon_sym_QMARK] = ACTIONS(2454),
    [anon_sym_COLON_QMARK] = ACTIONS(2454),
    [anon_sym_COLON_COLON] = ACTIONS(2456),
    [anon_sym_AMP] = ACTIONS(2454),
    [anon_sym_LBRACK] = ACTIONS(2454),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2456),
    [anon_sym_LBRACE] = ACTIONS(2454),
    [anon_sym_LT_AT] = ACTIONS(2454),
    [anon_sym_LT_AT_AT] = ACTIONS(2454),
    [anon_sym_AT_AT_GT] = ACTIONS(2454),
    [anon_sym_DOT] = ACTIONS(2454),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2456),
    [anon_sym_new] = ACTIONS(2454),
    [anon_sym_return_BANG] = ACTIONS(2456),
    [anon_sym_yield] = ACTIONS(2454),
    [anon_sym_yield_BANG] = ACTIONS(2456),
    [anon_sym_lazy] = ACTIONS(2454),
    [anon_sym_assert] = ACTIONS(2454),
    [anon_sym_upcast] = ACTIONS(2454),
    [anon_sym_downcast] = ACTIONS(2454),
    [anon_sym_COLON_GT] = ACTIONS(2456),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2456),
    [anon_sym_for] = ACTIONS(2454),
    [anon_sym_while] = ACTIONS(2454),
    [anon_sym_if] = ACTIONS(2454),
    [anon_sym_fun] = ACTIONS(2454),
    [anon_sym_DASH_GT] = ACTIONS(2454),
    [anon_sym_try] = ACTIONS(2454),
    [anon_sym_match] = ACTIONS(2454),
    [anon_sym_match_BANG] = ACTIONS(2456),
    [anon_sym_function] = ACTIONS(2454),
    [anon_sym_LT_DASH] = ACTIONS(2454),
    [anon_sym_DOT_LBRACK] = ACTIONS(2456),
    [anon_sym_LT] = ACTIONS(2456),
    [anon_sym_use] = ACTIONS(2454),
    [anon_sym_use_BANG] = ACTIONS(2456),
    [anon_sym_do_BANG] = ACTIONS(2456),
    [anon_sym_begin] = ACTIONS(2454),
    [anon_sym_LPAREN2] = ACTIONS(2454),
    [anon_sym_STAR] = ACTIONS(2454),
    [anon_sym_LT2] = ACTIONS(2454),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2456),
    [anon_sym_or] = ACTIONS(2454),
    [aux_sym_char_token1] = ACTIONS(2456),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2454),
    [anon_sym_DQUOTE] = ACTIONS(2454),
    [anon_sym_AT_DQUOTE] = ACTIONS(2456),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2456),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2456),
    [sym_bool] = ACTIONS(2454),
    [sym_unit] = ACTIONS(2456),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2454),
    [sym_op_identifier] = ACTIONS(2454),
    [anon_sym_PLUS] = ACTIONS(2454),
    [anon_sym_DASH] = ACTIONS(2454),
    [anon_sym_PLUS_DOT] = ACTIONS(2454),
    [anon_sym_DASH_DOT] = ACTIONS(2454),
    [anon_sym_PERCENT] = ACTIONS(2454),
    [anon_sym_AMP_AMP] = ACTIONS(2454),
    [anon_sym_TILDE] = ACTIONS(2456),
    [aux_sym_prefix_op_token1] = ACTIONS(2454),
    [aux_sym_infix_op_token1] = ACTIONS(2456),
    [aux_sym_infix_op_token2] = ACTIONS(2454),
    [anon_sym_PIPE_PIPE] = ACTIONS(2454),
    [anon_sym_BANG_EQ] = ACTIONS(2454),
    [anon_sym_COLON_EQ] = ACTIONS(2456),
    [anon_sym_DOLLAR] = ACTIONS(2454),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2454),
    [sym_int] = ACTIONS(2454),
    [sym_xint] = ACTIONS(2456),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2456),
    [sym__newline] = ACTIONS(2456),
  },
  [1321] = {
    [sym_block_comment] = STATE(1321),
    [sym_compiler_directive_decl] = STATE(1321),
    [sym_fsi_directive_decl] = STATE(1321),
    [sym_preproc_line] = STATE(1321),
    [sym_identifier] = ACTIONS(2567),
    [anon_sym_EQ] = ACTIONS(2569),
    [anon_sym_COLON] = ACTIONS(2567),
    [anon_sym_return] = ACTIONS(2567),
    [anon_sym_do] = ACTIONS(2567),
    [anon_sym_let] = ACTIONS(2567),
    [anon_sym_let_BANG] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2567),
    [anon_sym_COMMA] = ACTIONS(2569),
    [anon_sym_null] = ACTIONS(2567),
    [anon_sym_QMARK] = ACTIONS(2567),
    [anon_sym_COLON_QMARK] = ACTIONS(2567),
    [anon_sym_COLON_COLON] = ACTIONS(2569),
    [anon_sym_AMP] = ACTIONS(2567),
    [anon_sym_LBRACK] = ACTIONS(2567),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2569),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_LT_AT] = ACTIONS(2567),
    [anon_sym_LT_AT_AT] = ACTIONS(2567),
    [anon_sym_DOT] = ACTIONS(2567),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2569),
    [anon_sym_new] = ACTIONS(2567),
    [anon_sym_return_BANG] = ACTIONS(2569),
    [anon_sym_yield] = ACTIONS(2567),
    [anon_sym_yield_BANG] = ACTIONS(2569),
    [anon_sym_lazy] = ACTIONS(2567),
    [anon_sym_assert] = ACTIONS(2567),
    [anon_sym_upcast] = ACTIONS(2567),
    [anon_sym_downcast] = ACTIONS(2567),
    [anon_sym_COLON_GT] = ACTIONS(2569),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2569),
    [anon_sym_for] = ACTIONS(2567),
    [anon_sym_while] = ACTIONS(2567),
    [anon_sym_if] = ACTIONS(2567),
    [anon_sym_fun] = ACTIONS(2567),
    [anon_sym_DASH_GT] = ACTIONS(2567),
    [anon_sym_try] = ACTIONS(2567),
    [anon_sym_match] = ACTIONS(2567),
    [anon_sym_match_BANG] = ACTIONS(2569),
    [anon_sym_function] = ACTIONS(2567),
    [anon_sym_LT_DASH] = ACTIONS(2567),
    [anon_sym_DOT_LBRACK] = ACTIONS(2569),
    [anon_sym_LT] = ACTIONS(2569),
    [anon_sym_use] = ACTIONS(2567),
    [anon_sym_use_BANG] = ACTIONS(2569),
    [anon_sym_do_BANG] = ACTIONS(2569),
    [anon_sym_DOT_DOT] = ACTIONS(2569),
    [anon_sym_begin] = ACTIONS(2567),
    [anon_sym_LPAREN2] = ACTIONS(2567),
    [anon_sym_STAR] = ACTIONS(2567),
    [anon_sym_LT2] = ACTIONS(2567),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2569),
    [anon_sym_or] = ACTIONS(2567),
    [aux_sym_char_token1] = ACTIONS(2569),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2567),
    [anon_sym_DQUOTE] = ACTIONS(2567),
    [anon_sym_AT_DQUOTE] = ACTIONS(2569),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2569),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2569),
    [sym_bool] = ACTIONS(2567),
    [sym_unit] = ACTIONS(2569),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2567),
    [sym_op_identifier] = ACTIONS(2567),
    [anon_sym_PLUS] = ACTIONS(2567),
    [anon_sym_DASH] = ACTIONS(2567),
    [anon_sym_PLUS_DOT] = ACTIONS(2567),
    [anon_sym_DASH_DOT] = ACTIONS(2567),
    [anon_sym_PERCENT] = ACTIONS(2567),
    [anon_sym_AMP_AMP] = ACTIONS(2567),
    [anon_sym_TILDE] = ACTIONS(2569),
    [aux_sym_prefix_op_token1] = ACTIONS(2567),
    [aux_sym_infix_op_token1] = ACTIONS(2569),
    [aux_sym_infix_op_token2] = ACTIONS(2567),
    [anon_sym_PIPE_PIPE] = ACTIONS(2567),
    [anon_sym_BANG_EQ] = ACTIONS(2567),
    [anon_sym_COLON_EQ] = ACTIONS(2569),
    [anon_sym_DOLLAR] = ACTIONS(2567),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2567),
    [sym_int] = ACTIONS(2567),
    [sym_xint] = ACTIONS(2569),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2569),
    [sym__newline] = ACTIONS(2569),
  },
  [1322] = {
    [sym_block_comment] = STATE(1322),
    [sym_compiler_directive_decl] = STATE(1322),
    [sym_fsi_directive_decl] = STATE(1322),
    [sym_preproc_line] = STATE(1322),
    [sym_identifier] = ACTIONS(2510),
    [anon_sym_EQ] = ACTIONS(2512),
    [anon_sym_COLON] = ACTIONS(2510),
    [anon_sym_return] = ACTIONS(2510),
    [anon_sym_do] = ACTIONS(2510),
    [anon_sym_let] = ACTIONS(2510),
    [anon_sym_let_BANG] = ACTIONS(2512),
    [anon_sym_LPAREN] = ACTIONS(2510),
    [anon_sym_COMMA] = ACTIONS(2512),
    [anon_sym_null] = ACTIONS(2510),
    [anon_sym_QMARK] = ACTIONS(2510),
    [anon_sym_COLON_QMARK] = ACTIONS(2510),
    [anon_sym_COLON_COLON] = ACTIONS(2512),
    [anon_sym_AMP] = ACTIONS(2510),
    [anon_sym_LBRACK] = ACTIONS(2510),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2512),
    [anon_sym_LBRACE] = ACTIONS(2510),
    [anon_sym_LT_AT] = ACTIONS(2510),
    [anon_sym_LT_AT_AT] = ACTIONS(2510),
    [anon_sym_AT_AT_GT] = ACTIONS(2510),
    [anon_sym_DOT] = ACTIONS(2510),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2512),
    [anon_sym_new] = ACTIONS(2510),
    [anon_sym_return_BANG] = ACTIONS(2512),
    [anon_sym_yield] = ACTIONS(2510),
    [anon_sym_yield_BANG] = ACTIONS(2512),
    [anon_sym_lazy] = ACTIONS(2510),
    [anon_sym_assert] = ACTIONS(2510),
    [anon_sym_upcast] = ACTIONS(2510),
    [anon_sym_downcast] = ACTIONS(2510),
    [anon_sym_COLON_GT] = ACTIONS(2512),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2512),
    [anon_sym_for] = ACTIONS(2510),
    [anon_sym_while] = ACTIONS(2510),
    [anon_sym_if] = ACTIONS(2510),
    [anon_sym_fun] = ACTIONS(2510),
    [anon_sym_DASH_GT] = ACTIONS(2510),
    [anon_sym_try] = ACTIONS(2510),
    [anon_sym_match] = ACTIONS(2510),
    [anon_sym_match_BANG] = ACTIONS(2512),
    [anon_sym_function] = ACTIONS(2510),
    [anon_sym_LT_DASH] = ACTIONS(2510),
    [anon_sym_DOT_LBRACK] = ACTIONS(2512),
    [anon_sym_LT] = ACTIONS(2512),
    [anon_sym_use] = ACTIONS(2510),
    [anon_sym_use_BANG] = ACTIONS(2512),
    [anon_sym_do_BANG] = ACTIONS(2512),
    [anon_sym_begin] = ACTIONS(2510),
    [anon_sym_LPAREN2] = ACTIONS(2510),
    [anon_sym_STAR] = ACTIONS(2510),
    [anon_sym_LT2] = ACTIONS(2510),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2512),
    [anon_sym_or] = ACTIONS(2510),
    [aux_sym_char_token1] = ACTIONS(2512),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2510),
    [anon_sym_DQUOTE] = ACTIONS(2510),
    [anon_sym_AT_DQUOTE] = ACTIONS(2512),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2512),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2512),
    [sym_bool] = ACTIONS(2510),
    [sym_unit] = ACTIONS(2512),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2510),
    [sym_op_identifier] = ACTIONS(2510),
    [anon_sym_PLUS] = ACTIONS(2510),
    [anon_sym_DASH] = ACTIONS(2510),
    [anon_sym_PLUS_DOT] = ACTIONS(2510),
    [anon_sym_DASH_DOT] = ACTIONS(2510),
    [anon_sym_PERCENT] = ACTIONS(2510),
    [anon_sym_AMP_AMP] = ACTIONS(2510),
    [anon_sym_TILDE] = ACTIONS(2512),
    [aux_sym_prefix_op_token1] = ACTIONS(2510),
    [aux_sym_infix_op_token1] = ACTIONS(2512),
    [aux_sym_infix_op_token2] = ACTIONS(2510),
    [anon_sym_PIPE_PIPE] = ACTIONS(2510),
    [anon_sym_BANG_EQ] = ACTIONS(2510),
    [anon_sym_COLON_EQ] = ACTIONS(2512),
    [anon_sym_DOLLAR] = ACTIONS(2510),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2510),
    [sym_int] = ACTIONS(2510),
    [sym_xint] = ACTIONS(2512),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2512),
    [sym__newline] = ACTIONS(2512),
  },
  [1323] = {
    [sym_block_comment] = STATE(1323),
    [sym_compiler_directive_decl] = STATE(1323),
    [sym_fsi_directive_decl] = STATE(1323),
    [sym_preproc_line] = STATE(1323),
    [sym_identifier] = ACTIONS(2474),
    [anon_sym_EQ] = ACTIONS(2476),
    [anon_sym_COLON] = ACTIONS(2474),
    [anon_sym_return] = ACTIONS(2474),
    [anon_sym_do] = ACTIONS(2474),
    [anon_sym_let] = ACTIONS(2474),
    [anon_sym_let_BANG] = ACTIONS(2476),
    [anon_sym_LPAREN] = ACTIONS(2474),
    [anon_sym_COMMA] = ACTIONS(2476),
    [anon_sym_null] = ACTIONS(2474),
    [anon_sym_QMARK] = ACTIONS(2474),
    [anon_sym_COLON_QMARK] = ACTIONS(2474),
    [anon_sym_COLON_COLON] = ACTIONS(2476),
    [anon_sym_AMP] = ACTIONS(2474),
    [anon_sym_LBRACK] = ACTIONS(2474),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2476),
    [anon_sym_LBRACE] = ACTIONS(2474),
    [anon_sym_LT_AT] = ACTIONS(2474),
    [anon_sym_LT_AT_AT] = ACTIONS(2474),
    [anon_sym_AT_AT_GT] = ACTIONS(2474),
    [anon_sym_DOT] = ACTIONS(2474),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2476),
    [anon_sym_new] = ACTIONS(2474),
    [anon_sym_return_BANG] = ACTIONS(2476),
    [anon_sym_yield] = ACTIONS(2474),
    [anon_sym_yield_BANG] = ACTIONS(2476),
    [anon_sym_lazy] = ACTIONS(2474),
    [anon_sym_assert] = ACTIONS(2474),
    [anon_sym_upcast] = ACTIONS(2474),
    [anon_sym_downcast] = ACTIONS(2474),
    [anon_sym_COLON_GT] = ACTIONS(2476),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2476),
    [anon_sym_for] = ACTIONS(2474),
    [anon_sym_while] = ACTIONS(2474),
    [anon_sym_if] = ACTIONS(2474),
    [anon_sym_fun] = ACTIONS(2474),
    [anon_sym_DASH_GT] = ACTIONS(2474),
    [anon_sym_try] = ACTIONS(2474),
    [anon_sym_match] = ACTIONS(2474),
    [anon_sym_match_BANG] = ACTIONS(2476),
    [anon_sym_function] = ACTIONS(2474),
    [anon_sym_LT_DASH] = ACTIONS(2474),
    [anon_sym_DOT_LBRACK] = ACTIONS(2476),
    [anon_sym_LT] = ACTIONS(2476),
    [anon_sym_use] = ACTIONS(2474),
    [anon_sym_use_BANG] = ACTIONS(2476),
    [anon_sym_do_BANG] = ACTIONS(2476),
    [anon_sym_begin] = ACTIONS(2474),
    [anon_sym_LPAREN2] = ACTIONS(2474),
    [anon_sym_STAR] = ACTIONS(2474),
    [anon_sym_LT2] = ACTIONS(2474),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2476),
    [anon_sym_or] = ACTIONS(2474),
    [aux_sym_char_token1] = ACTIONS(2476),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2474),
    [anon_sym_DQUOTE] = ACTIONS(2474),
    [anon_sym_AT_DQUOTE] = ACTIONS(2476),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2476),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2476),
    [sym_bool] = ACTIONS(2474),
    [sym_unit] = ACTIONS(2476),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2474),
    [sym_op_identifier] = ACTIONS(2474),
    [anon_sym_PLUS] = ACTIONS(2474),
    [anon_sym_DASH] = ACTIONS(2474),
    [anon_sym_PLUS_DOT] = ACTIONS(2474),
    [anon_sym_DASH_DOT] = ACTIONS(2474),
    [anon_sym_PERCENT] = ACTIONS(2474),
    [anon_sym_AMP_AMP] = ACTIONS(2474),
    [anon_sym_TILDE] = ACTIONS(2476),
    [aux_sym_prefix_op_token1] = ACTIONS(2474),
    [aux_sym_infix_op_token1] = ACTIONS(2476),
    [aux_sym_infix_op_token2] = ACTIONS(2474),
    [anon_sym_PIPE_PIPE] = ACTIONS(2474),
    [anon_sym_BANG_EQ] = ACTIONS(2474),
    [anon_sym_COLON_EQ] = ACTIONS(2476),
    [anon_sym_DOLLAR] = ACTIONS(2474),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2474),
    [sym_int] = ACTIONS(2474),
    [sym_xint] = ACTIONS(2476),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2476),
    [sym__newline] = ACTIONS(2476),
  },
  [1324] = {
    [sym_block_comment] = STATE(1324),
    [sym_compiler_directive_decl] = STATE(1324),
    [sym_fsi_directive_decl] = STATE(1324),
    [sym_preproc_line] = STATE(1324),
    [sym_identifier] = ACTIONS(2567),
    [anon_sym_EQ] = ACTIONS(2569),
    [anon_sym_COLON] = ACTIONS(2567),
    [anon_sym_return] = ACTIONS(2567),
    [anon_sym_do] = ACTIONS(2567),
    [anon_sym_let] = ACTIONS(2567),
    [anon_sym_let_BANG] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2567),
    [anon_sym_COMMA] = ACTIONS(2569),
    [anon_sym_null] = ACTIONS(2567),
    [anon_sym_QMARK] = ACTIONS(2567),
    [anon_sym_COLON_QMARK] = ACTIONS(2567),
    [anon_sym_COLON_COLON] = ACTIONS(2569),
    [anon_sym_AMP] = ACTIONS(2567),
    [anon_sym_LBRACK] = ACTIONS(2567),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2569),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_LT_AT] = ACTIONS(2567),
    [anon_sym_LT_AT_AT] = ACTIONS(2567),
    [anon_sym_DOT] = ACTIONS(2567),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2569),
    [anon_sym_new] = ACTIONS(2567),
    [anon_sym_return_BANG] = ACTIONS(2569),
    [anon_sym_yield] = ACTIONS(2567),
    [anon_sym_yield_BANG] = ACTIONS(2569),
    [anon_sym_lazy] = ACTIONS(2567),
    [anon_sym_assert] = ACTIONS(2567),
    [anon_sym_upcast] = ACTIONS(2567),
    [anon_sym_downcast] = ACTIONS(2567),
    [anon_sym_COLON_GT] = ACTIONS(2569),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2569),
    [anon_sym_for] = ACTIONS(2567),
    [anon_sym_while] = ACTIONS(2567),
    [anon_sym_if] = ACTIONS(2567),
    [anon_sym_fun] = ACTIONS(2567),
    [anon_sym_DASH_GT] = ACTIONS(2567),
    [anon_sym_try] = ACTIONS(2567),
    [anon_sym_match] = ACTIONS(2567),
    [anon_sym_match_BANG] = ACTIONS(2569),
    [anon_sym_function] = ACTIONS(2567),
    [anon_sym_LT_DASH] = ACTIONS(2567),
    [anon_sym_DOT_LBRACK] = ACTIONS(2569),
    [anon_sym_LT] = ACTIONS(2569),
    [anon_sym_use] = ACTIONS(2567),
    [anon_sym_use_BANG] = ACTIONS(2569),
    [anon_sym_do_BANG] = ACTIONS(2569),
    [anon_sym_DOT_DOT] = ACTIONS(2569),
    [anon_sym_begin] = ACTIONS(2567),
    [anon_sym_LPAREN2] = ACTIONS(2567),
    [anon_sym_STAR] = ACTIONS(2567),
    [anon_sym_LT2] = ACTIONS(2567),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2569),
    [anon_sym_or] = ACTIONS(2567),
    [aux_sym_char_token1] = ACTIONS(2569),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2567),
    [anon_sym_DQUOTE] = ACTIONS(2567),
    [anon_sym_AT_DQUOTE] = ACTIONS(2569),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2569),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2569),
    [sym_bool] = ACTIONS(2567),
    [sym_unit] = ACTIONS(2569),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2567),
    [sym_op_identifier] = ACTIONS(2567),
    [anon_sym_PLUS] = ACTIONS(2567),
    [anon_sym_DASH] = ACTIONS(2567),
    [anon_sym_PLUS_DOT] = ACTIONS(2567),
    [anon_sym_DASH_DOT] = ACTIONS(2567),
    [anon_sym_PERCENT] = ACTIONS(2567),
    [anon_sym_AMP_AMP] = ACTIONS(2567),
    [anon_sym_TILDE] = ACTIONS(2569),
    [aux_sym_prefix_op_token1] = ACTIONS(2567),
    [aux_sym_infix_op_token1] = ACTIONS(2569),
    [aux_sym_infix_op_token2] = ACTIONS(2567),
    [anon_sym_PIPE_PIPE] = ACTIONS(2567),
    [anon_sym_BANG_EQ] = ACTIONS(2567),
    [anon_sym_COLON_EQ] = ACTIONS(2569),
    [anon_sym_DOLLAR] = ACTIONS(2567),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2567),
    [sym_int] = ACTIONS(2567),
    [sym_xint] = ACTIONS(2569),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2569),
    [sym__newline] = ACTIONS(2569),
  },
  [1325] = {
    [sym_block_comment] = STATE(1325),
    [sym_compiler_directive_decl] = STATE(1325),
    [sym_fsi_directive_decl] = STATE(1325),
    [sym_preproc_line] = STATE(1325),
    [sym_identifier] = ACTIONS(2567),
    [anon_sym_EQ] = ACTIONS(2569),
    [anon_sym_COLON] = ACTIONS(2567),
    [anon_sym_return] = ACTIONS(2567),
    [anon_sym_do] = ACTIONS(2567),
    [anon_sym_let] = ACTIONS(2567),
    [anon_sym_let_BANG] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2567),
    [anon_sym_COMMA] = ACTIONS(2569),
    [anon_sym_null] = ACTIONS(2567),
    [anon_sym_QMARK] = ACTIONS(2567),
    [anon_sym_COLON_QMARK] = ACTIONS(2567),
    [anon_sym_COLON_COLON] = ACTIONS(2569),
    [anon_sym_AMP] = ACTIONS(2567),
    [anon_sym_LBRACK] = ACTIONS(2567),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2569),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_LT_AT] = ACTIONS(2567),
    [anon_sym_LT_AT_AT] = ACTIONS(2567),
    [anon_sym_DOT] = ACTIONS(2567),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2569),
    [anon_sym_new] = ACTIONS(2567),
    [anon_sym_return_BANG] = ACTIONS(2569),
    [anon_sym_yield] = ACTIONS(2567),
    [anon_sym_yield_BANG] = ACTIONS(2569),
    [anon_sym_lazy] = ACTIONS(2567),
    [anon_sym_assert] = ACTIONS(2567),
    [anon_sym_upcast] = ACTIONS(2567),
    [anon_sym_downcast] = ACTIONS(2567),
    [anon_sym_COLON_GT] = ACTIONS(2569),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2569),
    [anon_sym_for] = ACTIONS(2567),
    [anon_sym_while] = ACTIONS(2567),
    [anon_sym_if] = ACTIONS(2567),
    [anon_sym_fun] = ACTIONS(2567),
    [anon_sym_DASH_GT] = ACTIONS(2567),
    [anon_sym_try] = ACTIONS(2567),
    [anon_sym_match] = ACTIONS(2567),
    [anon_sym_match_BANG] = ACTIONS(2569),
    [anon_sym_function] = ACTIONS(2567),
    [anon_sym_LT_DASH] = ACTIONS(2567),
    [anon_sym_DOT_LBRACK] = ACTIONS(2569),
    [anon_sym_LT] = ACTIONS(2569),
    [anon_sym_GT] = ACTIONS(2567),
    [anon_sym_use] = ACTIONS(2567),
    [anon_sym_use_BANG] = ACTIONS(2569),
    [anon_sym_do_BANG] = ACTIONS(2569),
    [anon_sym_begin] = ACTIONS(2567),
    [anon_sym_LPAREN2] = ACTIONS(2567),
    [anon_sym_STAR] = ACTIONS(2567),
    [anon_sym_LT2] = ACTIONS(2567),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2569),
    [anon_sym_or] = ACTIONS(2567),
    [aux_sym_char_token1] = ACTIONS(2569),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2567),
    [anon_sym_DQUOTE] = ACTIONS(2567),
    [anon_sym_AT_DQUOTE] = ACTIONS(2569),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2569),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2569),
    [sym_bool] = ACTIONS(2567),
    [sym_unit] = ACTIONS(2569),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2567),
    [sym_op_identifier] = ACTIONS(2567),
    [anon_sym_PLUS] = ACTIONS(2567),
    [anon_sym_DASH] = ACTIONS(2567),
    [anon_sym_PLUS_DOT] = ACTIONS(2567),
    [anon_sym_DASH_DOT] = ACTIONS(2567),
    [anon_sym_PERCENT] = ACTIONS(2567),
    [anon_sym_AMP_AMP] = ACTIONS(2567),
    [anon_sym_TILDE] = ACTIONS(2569),
    [aux_sym_prefix_op_token1] = ACTIONS(2567),
    [aux_sym_infix_op_token1] = ACTIONS(2569),
    [aux_sym_infix_op_token2] = ACTIONS(2567),
    [anon_sym_PIPE_PIPE] = ACTIONS(2567),
    [anon_sym_BANG_EQ] = ACTIONS(2567),
    [anon_sym_COLON_EQ] = ACTIONS(2569),
    [anon_sym_DOLLAR] = ACTIONS(2567),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2567),
    [sym_int] = ACTIONS(2567),
    [sym_xint] = ACTIONS(2569),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2569),
    [sym__newline] = ACTIONS(2569),
  },
  [1326] = {
    [sym_block_comment] = STATE(1326),
    [sym_compiler_directive_decl] = STATE(1326),
    [sym_fsi_directive_decl] = STATE(1326),
    [sym_preproc_line] = STATE(1326),
    [sym_identifier] = ACTIONS(2557),
    [anon_sym_EQ] = ACTIONS(2559),
    [anon_sym_COLON] = ACTIONS(2557),
    [anon_sym_return] = ACTIONS(2557),
    [anon_sym_do] = ACTIONS(2557),
    [anon_sym_let] = ACTIONS(2557),
    [anon_sym_let_BANG] = ACTIONS(2559),
    [anon_sym_LPAREN] = ACTIONS(2557),
    [anon_sym_COMMA] = ACTIONS(2559),
    [anon_sym_null] = ACTIONS(2557),
    [anon_sym_QMARK] = ACTIONS(2557),
    [anon_sym_COLON_QMARK] = ACTIONS(2557),
    [anon_sym_COLON_COLON] = ACTIONS(2559),
    [anon_sym_AMP] = ACTIONS(2557),
    [anon_sym_LBRACK] = ACTIONS(2557),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2559),
    [anon_sym_LBRACE] = ACTIONS(2557),
    [anon_sym_LT_AT] = ACTIONS(2557),
    [anon_sym_LT_AT_AT] = ACTIONS(2557),
    [anon_sym_DOT] = ACTIONS(2557),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2559),
    [anon_sym_new] = ACTIONS(2557),
    [anon_sym_return_BANG] = ACTIONS(2559),
    [anon_sym_yield] = ACTIONS(2557),
    [anon_sym_yield_BANG] = ACTIONS(2559),
    [anon_sym_lazy] = ACTIONS(2557),
    [anon_sym_assert] = ACTIONS(2557),
    [anon_sym_upcast] = ACTIONS(2557),
    [anon_sym_downcast] = ACTIONS(2557),
    [anon_sym_COLON_GT] = ACTIONS(2559),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2559),
    [anon_sym_for] = ACTIONS(2557),
    [anon_sym_while] = ACTIONS(2557),
    [anon_sym_if] = ACTIONS(2557),
    [anon_sym_fun] = ACTIONS(2557),
    [anon_sym_DASH_GT] = ACTIONS(2557),
    [anon_sym_try] = ACTIONS(2557),
    [anon_sym_match] = ACTIONS(2557),
    [anon_sym_match_BANG] = ACTIONS(2559),
    [anon_sym_function] = ACTIONS(2557),
    [anon_sym_LT_DASH] = ACTIONS(2557),
    [anon_sym_DOT_LBRACK] = ACTIONS(2559),
    [anon_sym_LT] = ACTIONS(2559),
    [anon_sym_use] = ACTIONS(2557),
    [anon_sym_use_BANG] = ACTIONS(2559),
    [anon_sym_do_BANG] = ACTIONS(2559),
    [anon_sym_DOT_DOT] = ACTIONS(2559),
    [anon_sym_begin] = ACTIONS(2557),
    [anon_sym_LPAREN2] = ACTIONS(2557),
    [anon_sym_STAR] = ACTIONS(2557),
    [anon_sym_LT2] = ACTIONS(3501),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2559),
    [anon_sym_or] = ACTIONS(2557),
    [aux_sym_char_token1] = ACTIONS(2559),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2557),
    [anon_sym_DQUOTE] = ACTIONS(2557),
    [anon_sym_AT_DQUOTE] = ACTIONS(2559),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2559),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2559),
    [sym_bool] = ACTIONS(2557),
    [sym_unit] = ACTIONS(2559),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2557),
    [sym_op_identifier] = ACTIONS(2557),
    [anon_sym_PLUS] = ACTIONS(2557),
    [anon_sym_DASH] = ACTIONS(2557),
    [anon_sym_PLUS_DOT] = ACTIONS(2557),
    [anon_sym_DASH_DOT] = ACTIONS(2557),
    [anon_sym_PERCENT] = ACTIONS(2557),
    [anon_sym_AMP_AMP] = ACTIONS(2557),
    [anon_sym_TILDE] = ACTIONS(2559),
    [aux_sym_prefix_op_token1] = ACTIONS(2557),
    [aux_sym_infix_op_token1] = ACTIONS(2559),
    [aux_sym_infix_op_token2] = ACTIONS(2557),
    [anon_sym_PIPE_PIPE] = ACTIONS(2557),
    [anon_sym_BANG_EQ] = ACTIONS(2557),
    [anon_sym_COLON_EQ] = ACTIONS(2559),
    [anon_sym_DOLLAR] = ACTIONS(2557),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2557),
    [sym_int] = ACTIONS(2557),
    [sym_xint] = ACTIONS(2559),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2559),
    [sym__newline] = ACTIONS(2559),
  },
  [1327] = {
    [sym_block_comment] = STATE(1327),
    [sym_compiler_directive_decl] = STATE(1327),
    [sym_fsi_directive_decl] = STATE(1327),
    [sym_preproc_line] = STATE(1327),
    [sym_identifier] = ACTIONS(2158),
    [anon_sym_EQ] = ACTIONS(2160),
    [anon_sym_COLON] = ACTIONS(2158),
    [anon_sym_return] = ACTIONS(2158),
    [anon_sym_do] = ACTIONS(2158),
    [anon_sym_let] = ACTIONS(2158),
    [anon_sym_let_BANG] = ACTIONS(2160),
    [anon_sym_as] = ACTIONS(2158),
    [anon_sym_LPAREN] = ACTIONS(2158),
    [anon_sym_COMMA] = ACTIONS(2160),
    [anon_sym_null] = ACTIONS(2158),
    [anon_sym_QMARK] = ACTIONS(2158),
    [anon_sym_COLON_QMARK] = ACTIONS(2158),
    [anon_sym_COLON_COLON] = ACTIONS(2160),
    [anon_sym_AMP] = ACTIONS(2158),
    [anon_sym_LBRACK] = ACTIONS(2158),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2160),
    [anon_sym_LBRACE] = ACTIONS(2158),
    [anon_sym_LT_AT] = ACTIONS(2158),
    [anon_sym_LT_AT_AT] = ACTIONS(2158),
    [anon_sym_DOT] = ACTIONS(2158),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2160),
    [anon_sym_new] = ACTIONS(2158),
    [anon_sym_with] = ACTIONS(2158),
    [anon_sym_return_BANG] = ACTIONS(2160),
    [anon_sym_yield] = ACTIONS(2158),
    [anon_sym_yield_BANG] = ACTIONS(2160),
    [anon_sym_lazy] = ACTIONS(2158),
    [anon_sym_assert] = ACTIONS(2158),
    [anon_sym_upcast] = ACTIONS(2158),
    [anon_sym_downcast] = ACTIONS(2158),
    [anon_sym_COLON_GT] = ACTIONS(2160),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2160),
    [anon_sym_for] = ACTIONS(2158),
    [anon_sym_while] = ACTIONS(2158),
    [anon_sym_if] = ACTIONS(2158),
    [anon_sym_fun] = ACTIONS(2158),
    [anon_sym_try] = ACTIONS(2158),
    [anon_sym_match] = ACTIONS(2158),
    [anon_sym_match_BANG] = ACTIONS(2160),
    [anon_sym_function] = ACTIONS(2158),
    [anon_sym_LT_DASH] = ACTIONS(2158),
    [anon_sym_DOT_LBRACK] = ACTIONS(2160),
    [anon_sym_LT] = ACTIONS(2160),
    [anon_sym_use] = ACTIONS(2158),
    [anon_sym_use_BANG] = ACTIONS(2160),
    [anon_sym_do_BANG] = ACTIONS(2160),
    [anon_sym_begin] = ACTIONS(2158),
    [anon_sym_LPAREN2] = ACTIONS(2158),
    [anon_sym_or] = ACTIONS(2158),
    [aux_sym_char_token1] = ACTIONS(2160),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2158),
    [anon_sym_DQUOTE] = ACTIONS(2158),
    [anon_sym_AT_DQUOTE] = ACTIONS(2160),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2160),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2160),
    [sym_bool] = ACTIONS(2158),
    [sym_unit] = ACTIONS(2160),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2158),
    [sym_op_identifier] = ACTIONS(2158),
    [anon_sym_PLUS] = ACTIONS(2158),
    [anon_sym_DASH] = ACTIONS(2158),
    [anon_sym_PLUS_DOT] = ACTIONS(2158),
    [anon_sym_DASH_DOT] = ACTIONS(2158),
    [anon_sym_PERCENT] = ACTIONS(2158),
    [anon_sym_AMP_AMP] = ACTIONS(2158),
    [anon_sym_TILDE] = ACTIONS(2160),
    [aux_sym_prefix_op_token1] = ACTIONS(2158),
    [aux_sym_infix_op_token1] = ACTIONS(2160),
    [aux_sym_infix_op_token2] = ACTIONS(2158),
    [anon_sym_PIPE_PIPE] = ACTIONS(2158),
    [anon_sym_BANG_EQ] = ACTIONS(2158),
    [anon_sym_COLON_EQ] = ACTIONS(2160),
    [anon_sym_DOLLAR] = ACTIONS(2158),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2158),
    [sym_int] = ACTIONS(2158),
    [sym_xint] = ACTIONS(2160),
    [anon_sym_f] = ACTIONS(2458),
    [aux_sym_decimal_token1] = ACTIONS(2278),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2160),
    [sym__newline] = ACTIONS(2160),
    [sym__dedent] = ACTIONS(2160),
  },
  [1328] = {
    [sym_elif_expression] = STATE(1495),
    [sym_block_comment] = STATE(1328),
    [sym_compiler_directive_decl] = STATE(1328),
    [sym_fsi_directive_decl] = STATE(1328),
    [sym_preproc_line] = STATE(1328),
    [aux_sym_if_expression_repeat1] = STATE(1328),
    [sym_identifier] = ACTIONS(2518),
    [anon_sym_EQ] = ACTIONS(2520),
    [anon_sym_COLON] = ACTIONS(2518),
    [anon_sym_return] = ACTIONS(2518),
    [anon_sym_do] = ACTIONS(2518),
    [anon_sym_let] = ACTIONS(2518),
    [anon_sym_let_BANG] = ACTIONS(2520),
    [anon_sym_LPAREN] = ACTIONS(2518),
    [anon_sym_COMMA] = ACTIONS(2520),
    [anon_sym_null] = ACTIONS(2518),
    [anon_sym_QMARK] = ACTIONS(2518),
    [anon_sym_COLON_QMARK] = ACTIONS(2518),
    [anon_sym_COLON_COLON] = ACTIONS(2520),
    [anon_sym_AMP] = ACTIONS(2518),
    [anon_sym_LBRACK] = ACTIONS(2518),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2520),
    [anon_sym_LBRACE] = ACTIONS(2518),
    [anon_sym_LT_AT] = ACTIONS(2518),
    [anon_sym_LT_AT_AT] = ACTIONS(2518),
    [anon_sym_AT_AT_GT] = ACTIONS(2518),
    [anon_sym_DOT] = ACTIONS(2518),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2520),
    [anon_sym_new] = ACTIONS(2518),
    [anon_sym_return_BANG] = ACTIONS(2520),
    [anon_sym_yield] = ACTIONS(2518),
    [anon_sym_yield_BANG] = ACTIONS(2520),
    [anon_sym_lazy] = ACTIONS(2518),
    [anon_sym_assert] = ACTIONS(2518),
    [anon_sym_upcast] = ACTIONS(2518),
    [anon_sym_downcast] = ACTIONS(2518),
    [anon_sym_COLON_GT] = ACTIONS(2520),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2520),
    [anon_sym_for] = ACTIONS(2518),
    [anon_sym_while] = ACTIONS(2518),
    [anon_sym_else] = ACTIONS(2518),
    [anon_sym_elif] = ACTIONS(3503),
    [anon_sym_if] = ACTIONS(2518),
    [anon_sym_fun] = ACTIONS(2518),
    [anon_sym_try] = ACTIONS(2518),
    [anon_sym_match] = ACTIONS(2518),
    [anon_sym_match_BANG] = ACTIONS(2520),
    [anon_sym_function] = ACTIONS(2518),
    [anon_sym_LT_DASH] = ACTIONS(2518),
    [anon_sym_DOT_LBRACK] = ACTIONS(2520),
    [anon_sym_LT] = ACTIONS(2520),
    [anon_sym_use] = ACTIONS(2518),
    [anon_sym_use_BANG] = ACTIONS(2520),
    [anon_sym_do_BANG] = ACTIONS(2520),
    [anon_sym_begin] = ACTIONS(2518),
    [anon_sym_LPAREN2] = ACTIONS(2518),
    [anon_sym_or] = ACTIONS(2518),
    [aux_sym_char_token1] = ACTIONS(2520),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2518),
    [anon_sym_DQUOTE] = ACTIONS(2518),
    [anon_sym_AT_DQUOTE] = ACTIONS(2520),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2520),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2520),
    [sym_bool] = ACTIONS(2518),
    [sym_unit] = ACTIONS(2520),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2518),
    [sym_op_identifier] = ACTIONS(2518),
    [anon_sym_PLUS] = ACTIONS(2518),
    [anon_sym_DASH] = ACTIONS(2518),
    [anon_sym_PLUS_DOT] = ACTIONS(2518),
    [anon_sym_DASH_DOT] = ACTIONS(2518),
    [anon_sym_PERCENT] = ACTIONS(2518),
    [anon_sym_AMP_AMP] = ACTIONS(2518),
    [anon_sym_TILDE] = ACTIONS(2520),
    [aux_sym_prefix_op_token1] = ACTIONS(2518),
    [aux_sym_infix_op_token1] = ACTIONS(2520),
    [aux_sym_infix_op_token2] = ACTIONS(2518),
    [anon_sym_PIPE_PIPE] = ACTIONS(2518),
    [anon_sym_BANG_EQ] = ACTIONS(2518),
    [anon_sym_COLON_EQ] = ACTIONS(2520),
    [anon_sym_DOLLAR] = ACTIONS(2518),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2518),
    [sym_int] = ACTIONS(2518),
    [sym_xint] = ACTIONS(2520),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2520),
    [sym__newline] = ACTIONS(2520),
  },
  [1329] = {
    [sym_block_comment] = STATE(1329),
    [sym_compiler_directive_decl] = STATE(1329),
    [sym_fsi_directive_decl] = STATE(1329),
    [sym_preproc_line] = STATE(1329),
    [sym_identifier] = ACTIONS(2553),
    [anon_sym_EQ] = ACTIONS(2555),
    [anon_sym_COLON] = ACTIONS(2553),
    [anon_sym_return] = ACTIONS(2553),
    [anon_sym_do] = ACTIONS(2553),
    [anon_sym_let] = ACTIONS(2553),
    [anon_sym_let_BANG] = ACTIONS(2555),
    [anon_sym_LPAREN] = ACTIONS(2553),
    [anon_sym_COMMA] = ACTIONS(2555),
    [anon_sym_null] = ACTIONS(2553),
    [anon_sym_QMARK] = ACTIONS(2553),
    [anon_sym_COLON_QMARK] = ACTIONS(2553),
    [anon_sym_COLON_COLON] = ACTIONS(2555),
    [anon_sym_AMP] = ACTIONS(2553),
    [anon_sym_LBRACK] = ACTIONS(2553),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2555),
    [anon_sym_LBRACE] = ACTIONS(2553),
    [anon_sym_LT_AT] = ACTIONS(2553),
    [anon_sym_LT_AT_AT] = ACTIONS(2553),
    [anon_sym_DOT] = ACTIONS(2553),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2555),
    [anon_sym_new] = ACTIONS(2553),
    [anon_sym_return_BANG] = ACTIONS(2555),
    [anon_sym_yield] = ACTIONS(2553),
    [anon_sym_yield_BANG] = ACTIONS(2555),
    [anon_sym_lazy] = ACTIONS(2553),
    [anon_sym_assert] = ACTIONS(2553),
    [anon_sym_upcast] = ACTIONS(2553),
    [anon_sym_downcast] = ACTIONS(2553),
    [anon_sym_COLON_GT] = ACTIONS(2555),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2555),
    [anon_sym_for] = ACTIONS(2553),
    [anon_sym_while] = ACTIONS(2553),
    [anon_sym_if] = ACTIONS(2553),
    [anon_sym_fun] = ACTIONS(2553),
    [anon_sym_DASH_GT] = ACTIONS(2553),
    [anon_sym_try] = ACTIONS(2553),
    [anon_sym_match] = ACTIONS(2553),
    [anon_sym_match_BANG] = ACTIONS(2555),
    [anon_sym_function] = ACTIONS(2553),
    [anon_sym_LT_DASH] = ACTIONS(2553),
    [anon_sym_DOT_LBRACK] = ACTIONS(2555),
    [anon_sym_LT] = ACTIONS(2555),
    [anon_sym_use] = ACTIONS(2553),
    [anon_sym_use_BANG] = ACTIONS(2555),
    [anon_sym_do_BANG] = ACTIONS(2555),
    [anon_sym_begin] = ACTIONS(2553),
    [anon_sym_LPAREN2] = ACTIONS(2553),
    [anon_sym_STAR] = ACTIONS(2553),
    [anon_sym_LT2] = ACTIONS(2553),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2555),
    [anon_sym_or] = ACTIONS(2553),
    [aux_sym_char_token1] = ACTIONS(2555),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2553),
    [anon_sym_DQUOTE] = ACTIONS(2553),
    [anon_sym_AT_DQUOTE] = ACTIONS(2555),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2555),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2555),
    [sym_bool] = ACTIONS(2553),
    [sym_unit] = ACTIONS(2555),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2553),
    [sym_op_identifier] = ACTIONS(2553),
    [anon_sym_PLUS] = ACTIONS(2553),
    [anon_sym_DASH] = ACTIONS(2553),
    [anon_sym_PLUS_DOT] = ACTIONS(2553),
    [anon_sym_DASH_DOT] = ACTIONS(2553),
    [anon_sym_PERCENT] = ACTIONS(2553),
    [anon_sym_AMP_AMP] = ACTIONS(2553),
    [anon_sym_TILDE] = ACTIONS(2555),
    [aux_sym_prefix_op_token1] = ACTIONS(2553),
    [aux_sym_infix_op_token1] = ACTIONS(2555),
    [aux_sym_infix_op_token2] = ACTIONS(2553),
    [anon_sym_PIPE_PIPE] = ACTIONS(2553),
    [anon_sym_BANG_EQ] = ACTIONS(2553),
    [anon_sym_COLON_EQ] = ACTIONS(2555),
    [anon_sym_DOLLAR] = ACTIONS(2553),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2553),
    [sym_int] = ACTIONS(2553),
    [sym_xint] = ACTIONS(2555),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2555),
    [anon_sym_POUNDendif] = ACTIONS(2555),
    [sym__newline] = ACTIONS(2555),
  },
  [1330] = {
    [sym_block_comment] = STATE(1330),
    [sym_compiler_directive_decl] = STATE(1330),
    [sym_fsi_directive_decl] = STATE(1330),
    [sym_preproc_line] = STATE(1330),
    [sym_identifier] = ACTIONS(2411),
    [anon_sym_EQ] = ACTIONS(2413),
    [anon_sym_COLON] = ACTIONS(2411),
    [anon_sym_return] = ACTIONS(2411),
    [anon_sym_do] = ACTIONS(2411),
    [anon_sym_let] = ACTIONS(2411),
    [anon_sym_let_BANG] = ACTIONS(2413),
    [anon_sym_LPAREN] = ACTIONS(2411),
    [anon_sym_COMMA] = ACTIONS(2413),
    [anon_sym_null] = ACTIONS(2411),
    [anon_sym_QMARK] = ACTIONS(2411),
    [anon_sym_COLON_QMARK] = ACTIONS(2411),
    [anon_sym_COLON_COLON] = ACTIONS(2413),
    [anon_sym_AMP] = ACTIONS(2411),
    [anon_sym_LBRACK] = ACTIONS(2411),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2413),
    [anon_sym_LBRACE] = ACTIONS(2411),
    [anon_sym_LT_AT] = ACTIONS(2411),
    [anon_sym_AT_GT] = ACTIONS(2411),
    [anon_sym_LT_AT_AT] = ACTIONS(2411),
    [anon_sym_DOT] = ACTIONS(2411),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2413),
    [anon_sym_new] = ACTIONS(2411),
    [anon_sym_return_BANG] = ACTIONS(2413),
    [anon_sym_yield] = ACTIONS(2411),
    [anon_sym_yield_BANG] = ACTIONS(2413),
    [anon_sym_lazy] = ACTIONS(2411),
    [anon_sym_assert] = ACTIONS(2411),
    [anon_sym_upcast] = ACTIONS(2411),
    [anon_sym_downcast] = ACTIONS(2411),
    [anon_sym_COLON_GT] = ACTIONS(2413),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2413),
    [anon_sym_for] = ACTIONS(2411),
    [anon_sym_while] = ACTIONS(2411),
    [anon_sym_if] = ACTIONS(2411),
    [anon_sym_fun] = ACTIONS(2411),
    [anon_sym_DASH_GT] = ACTIONS(2411),
    [anon_sym_try] = ACTIONS(2411),
    [anon_sym_match] = ACTIONS(2411),
    [anon_sym_match_BANG] = ACTIONS(2413),
    [anon_sym_function] = ACTIONS(2411),
    [anon_sym_LT_DASH] = ACTIONS(2411),
    [anon_sym_DOT_LBRACK] = ACTIONS(2413),
    [anon_sym_LT] = ACTIONS(2413),
    [anon_sym_use] = ACTIONS(2411),
    [anon_sym_use_BANG] = ACTIONS(2413),
    [anon_sym_do_BANG] = ACTIONS(2413),
    [anon_sym_begin] = ACTIONS(2411),
    [anon_sym_LPAREN2] = ACTIONS(2411),
    [anon_sym_STAR] = ACTIONS(2411),
    [anon_sym_LT2] = ACTIONS(2411),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2413),
    [anon_sym_or] = ACTIONS(2411),
    [aux_sym_char_token1] = ACTIONS(2413),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2411),
    [anon_sym_DQUOTE] = ACTIONS(2411),
    [anon_sym_AT_DQUOTE] = ACTIONS(2413),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2413),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2413),
    [sym_bool] = ACTIONS(2411),
    [sym_unit] = ACTIONS(2413),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2411),
    [sym_op_identifier] = ACTIONS(2411),
    [anon_sym_PLUS] = ACTIONS(2411),
    [anon_sym_DASH] = ACTIONS(2411),
    [anon_sym_PLUS_DOT] = ACTIONS(2411),
    [anon_sym_DASH_DOT] = ACTIONS(2411),
    [anon_sym_PERCENT] = ACTIONS(2411),
    [anon_sym_AMP_AMP] = ACTIONS(2411),
    [anon_sym_TILDE] = ACTIONS(2413),
    [aux_sym_prefix_op_token1] = ACTIONS(2411),
    [aux_sym_infix_op_token1] = ACTIONS(2413),
    [aux_sym_infix_op_token2] = ACTIONS(2411),
    [anon_sym_PIPE_PIPE] = ACTIONS(2411),
    [anon_sym_BANG_EQ] = ACTIONS(2411),
    [anon_sym_COLON_EQ] = ACTIONS(2413),
    [anon_sym_DOLLAR] = ACTIONS(2411),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2411),
    [sym_int] = ACTIONS(2411),
    [sym_xint] = ACTIONS(2413),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2413),
    [sym__newline] = ACTIONS(2413),
  },
  [1331] = {
    [sym_block_comment] = STATE(1331),
    [sym_compiler_directive_decl] = STATE(1331),
    [sym_fsi_directive_decl] = STATE(1331),
    [sym_preproc_line] = STATE(1331),
    [sym_identifier] = ACTIONS(2510),
    [anon_sym_EQ] = ACTIONS(2512),
    [anon_sym_COLON] = ACTIONS(2510),
    [anon_sym_return] = ACTIONS(2510),
    [anon_sym_do] = ACTIONS(2510),
    [anon_sym_let] = ACTIONS(2510),
    [anon_sym_let_BANG] = ACTIONS(2512),
    [anon_sym_LPAREN] = ACTIONS(2510),
    [anon_sym_COMMA] = ACTIONS(2512),
    [anon_sym_null] = ACTIONS(2510),
    [anon_sym_QMARK] = ACTIONS(2510),
    [anon_sym_COLON_QMARK] = ACTIONS(2510),
    [anon_sym_COLON_COLON] = ACTIONS(2512),
    [anon_sym_AMP] = ACTIONS(2510),
    [anon_sym_LBRACK] = ACTIONS(2510),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2512),
    [anon_sym_LBRACE] = ACTIONS(2510),
    [anon_sym_LT_AT] = ACTIONS(2510),
    [anon_sym_LT_AT_AT] = ACTIONS(2510),
    [anon_sym_DOT] = ACTIONS(2510),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2512),
    [anon_sym_new] = ACTIONS(2510),
    [anon_sym_return_BANG] = ACTIONS(2512),
    [anon_sym_yield] = ACTIONS(2510),
    [anon_sym_yield_BANG] = ACTIONS(2512),
    [anon_sym_lazy] = ACTIONS(2510),
    [anon_sym_assert] = ACTIONS(2510),
    [anon_sym_upcast] = ACTIONS(2510),
    [anon_sym_downcast] = ACTIONS(2510),
    [anon_sym_COLON_GT] = ACTIONS(2512),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2512),
    [anon_sym_for] = ACTIONS(2510),
    [anon_sym_while] = ACTIONS(2510),
    [anon_sym_if] = ACTIONS(2510),
    [anon_sym_fun] = ACTIONS(2510),
    [anon_sym_DASH_GT] = ACTIONS(2510),
    [anon_sym_try] = ACTIONS(2510),
    [anon_sym_match] = ACTIONS(2510),
    [anon_sym_match_BANG] = ACTIONS(2512),
    [anon_sym_function] = ACTIONS(2510),
    [anon_sym_LT_DASH] = ACTIONS(2510),
    [anon_sym_DOT_LBRACK] = ACTIONS(2512),
    [anon_sym_LT] = ACTIONS(2512),
    [anon_sym_use] = ACTIONS(2510),
    [anon_sym_use_BANG] = ACTIONS(2512),
    [anon_sym_do_BANG] = ACTIONS(2512),
    [anon_sym_DOT_DOT] = ACTIONS(2512),
    [anon_sym_begin] = ACTIONS(2510),
    [anon_sym_LPAREN2] = ACTIONS(2510),
    [anon_sym_STAR] = ACTIONS(2510),
    [anon_sym_LT2] = ACTIONS(2510),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2512),
    [anon_sym_or] = ACTIONS(2510),
    [aux_sym_char_token1] = ACTIONS(2512),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2510),
    [anon_sym_DQUOTE] = ACTIONS(2510),
    [anon_sym_AT_DQUOTE] = ACTIONS(2512),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2512),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2512),
    [sym_bool] = ACTIONS(2510),
    [sym_unit] = ACTIONS(2512),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2510),
    [sym_op_identifier] = ACTIONS(2510),
    [anon_sym_PLUS] = ACTIONS(2510),
    [anon_sym_DASH] = ACTIONS(2510),
    [anon_sym_PLUS_DOT] = ACTIONS(2510),
    [anon_sym_DASH_DOT] = ACTIONS(2510),
    [anon_sym_PERCENT] = ACTIONS(2510),
    [anon_sym_AMP_AMP] = ACTIONS(2510),
    [anon_sym_TILDE] = ACTIONS(2512),
    [aux_sym_prefix_op_token1] = ACTIONS(2510),
    [aux_sym_infix_op_token1] = ACTIONS(2512),
    [aux_sym_infix_op_token2] = ACTIONS(2510),
    [anon_sym_PIPE_PIPE] = ACTIONS(2510),
    [anon_sym_BANG_EQ] = ACTIONS(2510),
    [anon_sym_COLON_EQ] = ACTIONS(2512),
    [anon_sym_DOLLAR] = ACTIONS(2510),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2510),
    [sym_int] = ACTIONS(2510),
    [sym_xint] = ACTIONS(2512),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2512),
    [sym__newline] = ACTIONS(2512),
  },
  [1332] = {
    [sym_block_comment] = STATE(1332),
    [sym_compiler_directive_decl] = STATE(1332),
    [sym_fsi_directive_decl] = STATE(1332),
    [sym_preproc_line] = STATE(1332),
    [sym_identifier] = ACTIONS(2567),
    [anon_sym_EQ] = ACTIONS(2569),
    [anon_sym_COLON] = ACTIONS(2567),
    [anon_sym_return] = ACTIONS(2567),
    [anon_sym_do] = ACTIONS(2567),
    [anon_sym_let] = ACTIONS(2567),
    [anon_sym_let_BANG] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2567),
    [anon_sym_COMMA] = ACTIONS(2569),
    [anon_sym_null] = ACTIONS(2567),
    [anon_sym_QMARK] = ACTIONS(2567),
    [anon_sym_COLON_QMARK] = ACTIONS(2567),
    [anon_sym_COLON_COLON] = ACTIONS(2569),
    [anon_sym_AMP] = ACTIONS(2567),
    [anon_sym_LBRACK] = ACTIONS(2567),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2569),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_LT_AT] = ACTIONS(2567),
    [anon_sym_LT_AT_AT] = ACTIONS(2567),
    [anon_sym_DOT] = ACTIONS(2567),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2569),
    [anon_sym_new] = ACTIONS(2567),
    [anon_sym_return_BANG] = ACTIONS(2569),
    [anon_sym_yield] = ACTIONS(2567),
    [anon_sym_yield_BANG] = ACTIONS(2569),
    [anon_sym_lazy] = ACTIONS(2567),
    [anon_sym_assert] = ACTIONS(2567),
    [anon_sym_upcast] = ACTIONS(2567),
    [anon_sym_downcast] = ACTIONS(2567),
    [anon_sym_COLON_GT] = ACTIONS(2569),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2569),
    [anon_sym_for] = ACTIONS(2567),
    [anon_sym_while] = ACTIONS(2567),
    [anon_sym_if] = ACTIONS(2567),
    [anon_sym_fun] = ACTIONS(2567),
    [anon_sym_DASH_GT] = ACTIONS(2567),
    [anon_sym_try] = ACTIONS(2567),
    [anon_sym_match] = ACTIONS(2567),
    [anon_sym_match_BANG] = ACTIONS(2569),
    [anon_sym_function] = ACTIONS(2567),
    [anon_sym_LT_DASH] = ACTIONS(2567),
    [anon_sym_DOT_LBRACK] = ACTIONS(2569),
    [anon_sym_LT] = ACTIONS(2569),
    [anon_sym_use] = ACTIONS(2567),
    [anon_sym_use_BANG] = ACTIONS(2569),
    [anon_sym_do_BANG] = ACTIONS(2569),
    [anon_sym_begin] = ACTIONS(2567),
    [anon_sym_LPAREN2] = ACTIONS(2567),
    [anon_sym_STAR] = ACTIONS(2567),
    [anon_sym_LT2] = ACTIONS(2567),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2569),
    [anon_sym_or] = ACTIONS(2567),
    [aux_sym_char_token1] = ACTIONS(2569),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2567),
    [anon_sym_DQUOTE] = ACTIONS(2567),
    [anon_sym_AT_DQUOTE] = ACTIONS(2569),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2569),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2569),
    [sym_bool] = ACTIONS(2567),
    [sym_unit] = ACTIONS(2569),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2567),
    [sym_op_identifier] = ACTIONS(2567),
    [anon_sym_PLUS] = ACTIONS(2567),
    [anon_sym_DASH] = ACTIONS(2567),
    [anon_sym_PLUS_DOT] = ACTIONS(2567),
    [anon_sym_DASH_DOT] = ACTIONS(2567),
    [anon_sym_PERCENT] = ACTIONS(2567),
    [anon_sym_AMP_AMP] = ACTIONS(2567),
    [anon_sym_TILDE] = ACTIONS(2569),
    [aux_sym_prefix_op_token1] = ACTIONS(2567),
    [aux_sym_infix_op_token1] = ACTIONS(2569),
    [aux_sym_infix_op_token2] = ACTIONS(2567),
    [anon_sym_PIPE_PIPE] = ACTIONS(2567),
    [anon_sym_BANG_EQ] = ACTIONS(2567),
    [anon_sym_COLON_EQ] = ACTIONS(2569),
    [anon_sym_DOLLAR] = ACTIONS(2567),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2567),
    [sym_int] = ACTIONS(2567),
    [sym_xint] = ACTIONS(2569),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2569),
    [anon_sym_POUNDendif] = ACTIONS(2569),
    [sym__newline] = ACTIONS(2569),
  },
  [1333] = {
    [sym_block_comment] = STATE(1333),
    [sym_compiler_directive_decl] = STATE(1333),
    [sym_fsi_directive_decl] = STATE(1333),
    [sym_preproc_line] = STATE(1333),
    [sym_identifier] = ACTIONS(2321),
    [anon_sym_EQ] = ACTIONS(2323),
    [anon_sym_COLON] = ACTIONS(2321),
    [anon_sym_return] = ACTIONS(2321),
    [anon_sym_do] = ACTIONS(2321),
    [anon_sym_let] = ACTIONS(2321),
    [anon_sym_let_BANG] = ACTIONS(2323),
    [anon_sym_LPAREN] = ACTIONS(2321),
    [anon_sym_COMMA] = ACTIONS(2323),
    [anon_sym_null] = ACTIONS(2321),
    [anon_sym_QMARK] = ACTIONS(2321),
    [anon_sym_COLON_QMARK] = ACTIONS(2321),
    [anon_sym_COLON_COLON] = ACTIONS(2323),
    [anon_sym_AMP] = ACTIONS(2321),
    [anon_sym_LBRACK] = ACTIONS(2321),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2323),
    [anon_sym_LBRACE] = ACTIONS(2321),
    [anon_sym_LT_AT] = ACTIONS(2321),
    [anon_sym_LT_AT_AT] = ACTIONS(2321),
    [anon_sym_DOT] = ACTIONS(2321),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2323),
    [anon_sym_new] = ACTIONS(2321),
    [anon_sym_return_BANG] = ACTIONS(2323),
    [anon_sym_yield] = ACTIONS(2321),
    [anon_sym_yield_BANG] = ACTIONS(2323),
    [anon_sym_lazy] = ACTIONS(2321),
    [anon_sym_assert] = ACTIONS(2321),
    [anon_sym_upcast] = ACTIONS(2321),
    [anon_sym_downcast] = ACTIONS(2321),
    [anon_sym_COLON_GT] = ACTIONS(2323),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2323),
    [anon_sym_for] = ACTIONS(2321),
    [anon_sym_while] = ACTIONS(2321),
    [anon_sym_if] = ACTIONS(2321),
    [anon_sym_fun] = ACTIONS(2321),
    [anon_sym_DASH_GT] = ACTIONS(2321),
    [anon_sym_try] = ACTIONS(2321),
    [anon_sym_match] = ACTIONS(2321),
    [anon_sym_match_BANG] = ACTIONS(2323),
    [anon_sym_function] = ACTIONS(2321),
    [anon_sym_LT_DASH] = ACTIONS(2321),
    [anon_sym_DOT_LBRACK] = ACTIONS(2323),
    [anon_sym_LT] = ACTIONS(2323),
    [anon_sym_GT] = ACTIONS(2321),
    [anon_sym_use] = ACTIONS(2321),
    [anon_sym_use_BANG] = ACTIONS(2323),
    [anon_sym_do_BANG] = ACTIONS(2323),
    [anon_sym_begin] = ACTIONS(2321),
    [anon_sym_LPAREN2] = ACTIONS(2321),
    [anon_sym_STAR] = ACTIONS(2321),
    [anon_sym_LT2] = ACTIONS(2321),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2323),
    [anon_sym_or] = ACTIONS(2321),
    [aux_sym_char_token1] = ACTIONS(2323),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2321),
    [anon_sym_DQUOTE] = ACTIONS(2321),
    [anon_sym_AT_DQUOTE] = ACTIONS(2323),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2323),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2323),
    [sym_bool] = ACTIONS(2321),
    [sym_unit] = ACTIONS(2323),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2321),
    [sym_op_identifier] = ACTIONS(2321),
    [anon_sym_PLUS] = ACTIONS(2321),
    [anon_sym_DASH] = ACTIONS(2321),
    [anon_sym_PLUS_DOT] = ACTIONS(2321),
    [anon_sym_DASH_DOT] = ACTIONS(2321),
    [anon_sym_PERCENT] = ACTIONS(2321),
    [anon_sym_AMP_AMP] = ACTIONS(2321),
    [anon_sym_TILDE] = ACTIONS(2323),
    [aux_sym_prefix_op_token1] = ACTIONS(2321),
    [aux_sym_infix_op_token1] = ACTIONS(2323),
    [aux_sym_infix_op_token2] = ACTIONS(2321),
    [anon_sym_PIPE_PIPE] = ACTIONS(2321),
    [anon_sym_BANG_EQ] = ACTIONS(2321),
    [anon_sym_COLON_EQ] = ACTIONS(2323),
    [anon_sym_DOLLAR] = ACTIONS(2321),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2321),
    [sym_int] = ACTIONS(2321),
    [sym_xint] = ACTIONS(2323),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2323),
    [sym__newline] = ACTIONS(2323),
  },
  [1334] = {
    [sym_block_comment] = STATE(1334),
    [sym_compiler_directive_decl] = STATE(1334),
    [sym_fsi_directive_decl] = STATE(1334),
    [sym_preproc_line] = STATE(1334),
    [sym_identifier] = ACTIONS(2474),
    [anon_sym_EQ] = ACTIONS(2476),
    [anon_sym_COLON] = ACTIONS(2474),
    [anon_sym_return] = ACTIONS(2474),
    [anon_sym_do] = ACTIONS(2474),
    [anon_sym_let] = ACTIONS(2474),
    [anon_sym_let_BANG] = ACTIONS(2476),
    [anon_sym_LPAREN] = ACTIONS(2474),
    [anon_sym_COMMA] = ACTIONS(2476),
    [anon_sym_null] = ACTIONS(2474),
    [anon_sym_QMARK] = ACTIONS(2474),
    [anon_sym_COLON_QMARK] = ACTIONS(2474),
    [anon_sym_COLON_COLON] = ACTIONS(2476),
    [anon_sym_AMP] = ACTIONS(2474),
    [anon_sym_LBRACK] = ACTIONS(2474),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2476),
    [anon_sym_LBRACE] = ACTIONS(2474),
    [anon_sym_LT_AT] = ACTIONS(2474),
    [anon_sym_LT_AT_AT] = ACTIONS(2474),
    [anon_sym_DOT] = ACTIONS(2474),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2476),
    [anon_sym_new] = ACTIONS(2474),
    [anon_sym_return_BANG] = ACTIONS(2476),
    [anon_sym_yield] = ACTIONS(2474),
    [anon_sym_yield_BANG] = ACTIONS(2476),
    [anon_sym_lazy] = ACTIONS(2474),
    [anon_sym_assert] = ACTIONS(2474),
    [anon_sym_upcast] = ACTIONS(2474),
    [anon_sym_downcast] = ACTIONS(2474),
    [anon_sym_COLON_GT] = ACTIONS(2476),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2476),
    [anon_sym_for] = ACTIONS(2474),
    [anon_sym_while] = ACTIONS(2474),
    [anon_sym_if] = ACTIONS(2474),
    [anon_sym_fun] = ACTIONS(2474),
    [anon_sym_DASH_GT] = ACTIONS(2474),
    [anon_sym_try] = ACTIONS(2474),
    [anon_sym_match] = ACTIONS(2474),
    [anon_sym_match_BANG] = ACTIONS(2476),
    [anon_sym_function] = ACTIONS(2474),
    [anon_sym_LT_DASH] = ACTIONS(2474),
    [anon_sym_DOT_LBRACK] = ACTIONS(2476),
    [anon_sym_LT] = ACTIONS(2476),
    [anon_sym_use] = ACTIONS(2474),
    [anon_sym_use_BANG] = ACTIONS(2476),
    [anon_sym_do_BANG] = ACTIONS(2476),
    [anon_sym_DOT_DOT] = ACTIONS(2476),
    [anon_sym_begin] = ACTIONS(2474),
    [anon_sym_LPAREN2] = ACTIONS(2474),
    [anon_sym_STAR] = ACTIONS(2474),
    [anon_sym_LT2] = ACTIONS(2474),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2476),
    [anon_sym_or] = ACTIONS(2474),
    [aux_sym_char_token1] = ACTIONS(2476),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2474),
    [anon_sym_DQUOTE] = ACTIONS(2474),
    [anon_sym_AT_DQUOTE] = ACTIONS(2476),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2476),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2476),
    [sym_bool] = ACTIONS(2474),
    [sym_unit] = ACTIONS(2476),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2474),
    [sym_op_identifier] = ACTIONS(2474),
    [anon_sym_PLUS] = ACTIONS(2474),
    [anon_sym_DASH] = ACTIONS(2474),
    [anon_sym_PLUS_DOT] = ACTIONS(2474),
    [anon_sym_DASH_DOT] = ACTIONS(2474),
    [anon_sym_PERCENT] = ACTIONS(2474),
    [anon_sym_AMP_AMP] = ACTIONS(2474),
    [anon_sym_TILDE] = ACTIONS(2476),
    [aux_sym_prefix_op_token1] = ACTIONS(2474),
    [aux_sym_infix_op_token1] = ACTIONS(2476),
    [aux_sym_infix_op_token2] = ACTIONS(2474),
    [anon_sym_PIPE_PIPE] = ACTIONS(2474),
    [anon_sym_BANG_EQ] = ACTIONS(2474),
    [anon_sym_COLON_EQ] = ACTIONS(2476),
    [anon_sym_DOLLAR] = ACTIONS(2474),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2474),
    [sym_int] = ACTIONS(2474),
    [sym_xint] = ACTIONS(2476),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2476),
    [sym__newline] = ACTIONS(2476),
  },
  [1335] = {
    [sym_block_comment] = STATE(1335),
    [sym_compiler_directive_decl] = STATE(1335),
    [sym_fsi_directive_decl] = STATE(1335),
    [sym_preproc_line] = STATE(1335),
    [sym_identifier] = ACTIONS(2411),
    [anon_sym_EQ] = ACTIONS(2413),
    [anon_sym_COLON] = ACTIONS(2411),
    [anon_sym_return] = ACTIONS(2411),
    [anon_sym_do] = ACTIONS(2411),
    [anon_sym_let] = ACTIONS(2411),
    [anon_sym_let_BANG] = ACTIONS(2413),
    [anon_sym_LPAREN] = ACTIONS(2411),
    [anon_sym_COMMA] = ACTIONS(2413),
    [anon_sym_null] = ACTIONS(2411),
    [anon_sym_QMARK] = ACTIONS(2411),
    [anon_sym_COLON_QMARK] = ACTIONS(2411),
    [anon_sym_COLON_COLON] = ACTIONS(2413),
    [anon_sym_AMP] = ACTIONS(2411),
    [anon_sym_LBRACK] = ACTIONS(2411),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2413),
    [anon_sym_LBRACE] = ACTIONS(2411),
    [anon_sym_LT_AT] = ACTIONS(2411),
    [anon_sym_LT_AT_AT] = ACTIONS(2411),
    [anon_sym_DOT] = ACTIONS(2411),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2413),
    [anon_sym_new] = ACTIONS(2411),
    [anon_sym_return_BANG] = ACTIONS(2413),
    [anon_sym_yield] = ACTIONS(2411),
    [anon_sym_yield_BANG] = ACTIONS(2413),
    [anon_sym_lazy] = ACTIONS(2411),
    [anon_sym_assert] = ACTIONS(2411),
    [anon_sym_upcast] = ACTIONS(2411),
    [anon_sym_downcast] = ACTIONS(2411),
    [anon_sym_COLON_GT] = ACTIONS(2413),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2413),
    [anon_sym_for] = ACTIONS(2411),
    [anon_sym_while] = ACTIONS(2411),
    [anon_sym_if] = ACTIONS(2411),
    [anon_sym_fun] = ACTIONS(2411),
    [anon_sym_DASH_GT] = ACTIONS(2411),
    [anon_sym_try] = ACTIONS(2411),
    [anon_sym_match] = ACTIONS(2411),
    [anon_sym_match_BANG] = ACTIONS(2413),
    [anon_sym_function] = ACTIONS(2411),
    [anon_sym_LT_DASH] = ACTIONS(2411),
    [anon_sym_DOT_LBRACK] = ACTIONS(2413),
    [anon_sym_LT] = ACTIONS(2413),
    [anon_sym_GT] = ACTIONS(2411),
    [anon_sym_use] = ACTIONS(2411),
    [anon_sym_use_BANG] = ACTIONS(2413),
    [anon_sym_do_BANG] = ACTIONS(2413),
    [anon_sym_begin] = ACTIONS(2411),
    [anon_sym_LPAREN2] = ACTIONS(2411),
    [anon_sym_STAR] = ACTIONS(2411),
    [anon_sym_LT2] = ACTIONS(2411),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2413),
    [anon_sym_or] = ACTIONS(2411),
    [aux_sym_char_token1] = ACTIONS(2413),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2411),
    [anon_sym_DQUOTE] = ACTIONS(2411),
    [anon_sym_AT_DQUOTE] = ACTIONS(2413),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2413),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2413),
    [sym_bool] = ACTIONS(2411),
    [sym_unit] = ACTIONS(2413),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2411),
    [sym_op_identifier] = ACTIONS(2411),
    [anon_sym_PLUS] = ACTIONS(2411),
    [anon_sym_DASH] = ACTIONS(2411),
    [anon_sym_PLUS_DOT] = ACTIONS(2411),
    [anon_sym_DASH_DOT] = ACTIONS(2411),
    [anon_sym_PERCENT] = ACTIONS(2411),
    [anon_sym_AMP_AMP] = ACTIONS(2411),
    [anon_sym_TILDE] = ACTIONS(2413),
    [aux_sym_prefix_op_token1] = ACTIONS(2411),
    [aux_sym_infix_op_token1] = ACTIONS(2413),
    [aux_sym_infix_op_token2] = ACTIONS(2411),
    [anon_sym_PIPE_PIPE] = ACTIONS(2411),
    [anon_sym_BANG_EQ] = ACTIONS(2411),
    [anon_sym_COLON_EQ] = ACTIONS(2413),
    [anon_sym_DOLLAR] = ACTIONS(2411),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2411),
    [sym_int] = ACTIONS(2411),
    [sym_xint] = ACTIONS(2413),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2413),
    [sym__newline] = ACTIONS(2413),
  },
  [1336] = {
    [sym_block_comment] = STATE(1336),
    [sym_compiler_directive_decl] = STATE(1336),
    [sym_fsi_directive_decl] = STATE(1336),
    [sym_preproc_line] = STATE(1336),
    [sym_identifier] = ACTIONS(2506),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_COLON] = ACTIONS(2506),
    [anon_sym_return] = ACTIONS(2506),
    [anon_sym_do] = ACTIONS(2506),
    [anon_sym_let] = ACTIONS(2506),
    [anon_sym_let_BANG] = ACTIONS(2508),
    [anon_sym_LPAREN] = ACTIONS(2506),
    [anon_sym_COMMA] = ACTIONS(2508),
    [anon_sym_null] = ACTIONS(2506),
    [anon_sym_QMARK] = ACTIONS(2506),
    [anon_sym_COLON_QMARK] = ACTIONS(2506),
    [anon_sym_COLON_COLON] = ACTIONS(2508),
    [anon_sym_AMP] = ACTIONS(2506),
    [anon_sym_LBRACK] = ACTIONS(2506),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2508),
    [anon_sym_LBRACE] = ACTIONS(2506),
    [anon_sym_LT_AT] = ACTIONS(2506),
    [anon_sym_AT_GT] = ACTIONS(2506),
    [anon_sym_LT_AT_AT] = ACTIONS(2506),
    [anon_sym_DOT] = ACTIONS(2506),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2508),
    [anon_sym_new] = ACTIONS(2506),
    [anon_sym_return_BANG] = ACTIONS(2508),
    [anon_sym_yield] = ACTIONS(2506),
    [anon_sym_yield_BANG] = ACTIONS(2508),
    [anon_sym_lazy] = ACTIONS(2506),
    [anon_sym_assert] = ACTIONS(2506),
    [anon_sym_upcast] = ACTIONS(2506),
    [anon_sym_downcast] = ACTIONS(2506),
    [anon_sym_COLON_GT] = ACTIONS(2508),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2508),
    [anon_sym_for] = ACTIONS(2506),
    [anon_sym_while] = ACTIONS(2506),
    [anon_sym_if] = ACTIONS(2506),
    [anon_sym_fun] = ACTIONS(2506),
    [anon_sym_DASH_GT] = ACTIONS(2506),
    [anon_sym_try] = ACTIONS(2506),
    [anon_sym_match] = ACTIONS(2506),
    [anon_sym_match_BANG] = ACTIONS(2508),
    [anon_sym_function] = ACTIONS(2506),
    [anon_sym_LT_DASH] = ACTIONS(2506),
    [anon_sym_DOT_LBRACK] = ACTIONS(2508),
    [anon_sym_LT] = ACTIONS(2508),
    [anon_sym_use] = ACTIONS(2506),
    [anon_sym_use_BANG] = ACTIONS(2508),
    [anon_sym_do_BANG] = ACTIONS(2508),
    [anon_sym_begin] = ACTIONS(2506),
    [anon_sym_LPAREN2] = ACTIONS(2506),
    [anon_sym_STAR] = ACTIONS(2506),
    [anon_sym_LT2] = ACTIONS(2506),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2508),
    [anon_sym_or] = ACTIONS(2506),
    [aux_sym_char_token1] = ACTIONS(2508),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2506),
    [anon_sym_DQUOTE] = ACTIONS(2506),
    [anon_sym_AT_DQUOTE] = ACTIONS(2508),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2508),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2508),
    [sym_bool] = ACTIONS(2506),
    [sym_unit] = ACTIONS(2508),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2506),
    [sym_op_identifier] = ACTIONS(2506),
    [anon_sym_PLUS] = ACTIONS(2506),
    [anon_sym_DASH] = ACTIONS(2506),
    [anon_sym_PLUS_DOT] = ACTIONS(2506),
    [anon_sym_DASH_DOT] = ACTIONS(2506),
    [anon_sym_PERCENT] = ACTIONS(2506),
    [anon_sym_AMP_AMP] = ACTIONS(2506),
    [anon_sym_TILDE] = ACTIONS(2508),
    [aux_sym_prefix_op_token1] = ACTIONS(2506),
    [aux_sym_infix_op_token1] = ACTIONS(2508),
    [aux_sym_infix_op_token2] = ACTIONS(2506),
    [anon_sym_PIPE_PIPE] = ACTIONS(2506),
    [anon_sym_BANG_EQ] = ACTIONS(2506),
    [anon_sym_COLON_EQ] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(2506),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2506),
    [sym_int] = ACTIONS(2506),
    [sym_xint] = ACTIONS(2508),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2508),
    [sym__newline] = ACTIONS(2508),
  },
  [1337] = {
    [sym_block_comment] = STATE(1337),
    [sym_compiler_directive_decl] = STATE(1337),
    [sym_fsi_directive_decl] = STATE(1337),
    [sym_preproc_line] = STATE(1337),
    [sym_identifier] = ACTIONS(2506),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_COLON] = ACTIONS(2506),
    [anon_sym_return] = ACTIONS(2506),
    [anon_sym_do] = ACTIONS(2506),
    [anon_sym_let] = ACTIONS(2506),
    [anon_sym_let_BANG] = ACTIONS(2508),
    [anon_sym_LPAREN] = ACTIONS(2506),
    [anon_sym_COMMA] = ACTIONS(2508),
    [anon_sym_null] = ACTIONS(2506),
    [anon_sym_QMARK] = ACTIONS(2506),
    [anon_sym_COLON_QMARK] = ACTIONS(2506),
    [anon_sym_COLON_COLON] = ACTIONS(2508),
    [anon_sym_AMP] = ACTIONS(2506),
    [anon_sym_LBRACK] = ACTIONS(2506),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2508),
    [anon_sym_LBRACE] = ACTIONS(2506),
    [anon_sym_LT_AT] = ACTIONS(2506),
    [anon_sym_LT_AT_AT] = ACTIONS(2506),
    [anon_sym_AT_AT_GT] = ACTIONS(2506),
    [anon_sym_DOT] = ACTIONS(2506),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2508),
    [anon_sym_new] = ACTIONS(2506),
    [anon_sym_return_BANG] = ACTIONS(2508),
    [anon_sym_yield] = ACTIONS(2506),
    [anon_sym_yield_BANG] = ACTIONS(2508),
    [anon_sym_lazy] = ACTIONS(2506),
    [anon_sym_assert] = ACTIONS(2506),
    [anon_sym_upcast] = ACTIONS(2506),
    [anon_sym_downcast] = ACTIONS(2506),
    [anon_sym_COLON_GT] = ACTIONS(2508),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2508),
    [anon_sym_for] = ACTIONS(2506),
    [anon_sym_while] = ACTIONS(2506),
    [anon_sym_if] = ACTIONS(2506),
    [anon_sym_fun] = ACTIONS(2506),
    [anon_sym_DASH_GT] = ACTIONS(2506),
    [anon_sym_try] = ACTIONS(2506),
    [anon_sym_match] = ACTIONS(2506),
    [anon_sym_match_BANG] = ACTIONS(2508),
    [anon_sym_function] = ACTIONS(2506),
    [anon_sym_LT_DASH] = ACTIONS(2506),
    [anon_sym_DOT_LBRACK] = ACTIONS(2508),
    [anon_sym_LT] = ACTIONS(2508),
    [anon_sym_use] = ACTIONS(2506),
    [anon_sym_use_BANG] = ACTIONS(2508),
    [anon_sym_do_BANG] = ACTIONS(2508),
    [anon_sym_begin] = ACTIONS(2506),
    [anon_sym_LPAREN2] = ACTIONS(2506),
    [anon_sym_STAR] = ACTIONS(2506),
    [anon_sym_LT2] = ACTIONS(2506),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2508),
    [anon_sym_or] = ACTIONS(2506),
    [aux_sym_char_token1] = ACTIONS(2508),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2506),
    [anon_sym_DQUOTE] = ACTIONS(2506),
    [anon_sym_AT_DQUOTE] = ACTIONS(2508),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2508),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2508),
    [sym_bool] = ACTIONS(2506),
    [sym_unit] = ACTIONS(2508),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2506),
    [sym_op_identifier] = ACTIONS(2506),
    [anon_sym_PLUS] = ACTIONS(2506),
    [anon_sym_DASH] = ACTIONS(2506),
    [anon_sym_PLUS_DOT] = ACTIONS(2506),
    [anon_sym_DASH_DOT] = ACTIONS(2506),
    [anon_sym_PERCENT] = ACTIONS(2506),
    [anon_sym_AMP_AMP] = ACTIONS(2506),
    [anon_sym_TILDE] = ACTIONS(2508),
    [aux_sym_prefix_op_token1] = ACTIONS(2506),
    [aux_sym_infix_op_token1] = ACTIONS(2508),
    [aux_sym_infix_op_token2] = ACTIONS(2506),
    [anon_sym_PIPE_PIPE] = ACTIONS(2506),
    [anon_sym_BANG_EQ] = ACTIONS(2506),
    [anon_sym_COLON_EQ] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(2506),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2506),
    [sym_int] = ACTIONS(2506),
    [sym_xint] = ACTIONS(2508),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2508),
    [sym__newline] = ACTIONS(2508),
  },
  [1338] = {
    [sym_block_comment] = STATE(1338),
    [sym_compiler_directive_decl] = STATE(1338),
    [sym_fsi_directive_decl] = STATE(1338),
    [sym_preproc_line] = STATE(1338),
    [sym_identifier] = ACTIONS(2723),
    [anon_sym_EQ] = ACTIONS(2725),
    [anon_sym_COLON] = ACTIONS(2723),
    [anon_sym_return] = ACTIONS(2723),
    [anon_sym_do] = ACTIONS(2723),
    [anon_sym_and] = ACTIONS(2723),
    [anon_sym_let] = ACTIONS(2723),
    [anon_sym_let_BANG] = ACTIONS(2725),
    [anon_sym_LPAREN] = ACTIONS(2723),
    [anon_sym_COMMA] = ACTIONS(2725),
    [anon_sym_null] = ACTIONS(2723),
    [anon_sym_QMARK] = ACTIONS(2723),
    [anon_sym_COLON_QMARK] = ACTIONS(2723),
    [anon_sym_COLON_COLON] = ACTIONS(2725),
    [anon_sym_AMP] = ACTIONS(2723),
    [anon_sym_LBRACK] = ACTIONS(2723),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2725),
    [anon_sym_LBRACE] = ACTIONS(2723),
    [anon_sym_LT_AT] = ACTIONS(2723),
    [anon_sym_LT_AT_AT] = ACTIONS(2723),
    [anon_sym_DOT] = ACTIONS(2723),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2725),
    [anon_sym_new] = ACTIONS(2723),
    [anon_sym_return_BANG] = ACTIONS(2725),
    [anon_sym_yield] = ACTIONS(2723),
    [anon_sym_yield_BANG] = ACTIONS(2725),
    [anon_sym_lazy] = ACTIONS(2723),
    [anon_sym_assert] = ACTIONS(2723),
    [anon_sym_upcast] = ACTIONS(2723),
    [anon_sym_downcast] = ACTIONS(2723),
    [anon_sym_COLON_GT] = ACTIONS(2725),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2725),
    [anon_sym_for] = ACTIONS(2723),
    [anon_sym_while] = ACTIONS(2723),
    [anon_sym_if] = ACTIONS(2723),
    [anon_sym_fun] = ACTIONS(2723),
    [anon_sym_try] = ACTIONS(2723),
    [anon_sym_match] = ACTIONS(2723),
    [anon_sym_match_BANG] = ACTIONS(2725),
    [anon_sym_function] = ACTIONS(2723),
    [anon_sym_LT_DASH] = ACTIONS(2723),
    [anon_sym_DOT_LBRACK] = ACTIONS(2725),
    [anon_sym_LT] = ACTIONS(2725),
    [anon_sym_use] = ACTIONS(2723),
    [anon_sym_use_BANG] = ACTIONS(2725),
    [anon_sym_do_BANG] = ACTIONS(2725),
    [anon_sym_begin] = ACTIONS(2723),
    [anon_sym_LPAREN2] = ACTIONS(2723),
    [anon_sym_or] = ACTIONS(2723),
    [aux_sym_char_token1] = ACTIONS(2725),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2723),
    [anon_sym_DQUOTE] = ACTIONS(2723),
    [anon_sym_AT_DQUOTE] = ACTIONS(2725),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2725),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2725),
    [sym_bool] = ACTIONS(2723),
    [sym_unit] = ACTIONS(2725),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2723),
    [sym_op_identifier] = ACTIONS(2723),
    [anon_sym_PLUS] = ACTIONS(2723),
    [anon_sym_DASH] = ACTIONS(2723),
    [anon_sym_PLUS_DOT] = ACTIONS(2723),
    [anon_sym_DASH_DOT] = ACTIONS(2723),
    [anon_sym_PERCENT] = ACTIONS(2723),
    [anon_sym_AMP_AMP] = ACTIONS(2723),
    [anon_sym_TILDE] = ACTIONS(2725),
    [aux_sym_prefix_op_token1] = ACTIONS(2723),
    [aux_sym_infix_op_token1] = ACTIONS(2725),
    [aux_sym_infix_op_token2] = ACTIONS(2723),
    [anon_sym_PIPE_PIPE] = ACTIONS(2723),
    [anon_sym_BANG_EQ] = ACTIONS(2723),
    [anon_sym_COLON_EQ] = ACTIONS(2725),
    [anon_sym_DOLLAR] = ACTIONS(2723),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2723),
    [sym_int] = ACTIONS(2723),
    [sym_xint] = ACTIONS(2725),
    [anon_sym_f] = ACTIONS(2723),
    [aux_sym_decimal_token1] = ACTIONS(2723),
    [aux_sym_float_token1] = ACTIONS(3506),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2725),
    [sym__newline] = ACTIONS(2725),
    [sym__dedent] = ACTIONS(2725),
  },
  [1339] = {
    [sym_block_comment] = STATE(1339),
    [sym_compiler_directive_decl] = STATE(1339),
    [sym_fsi_directive_decl] = STATE(1339),
    [sym_preproc_line] = STATE(1339),
    [sym_identifier] = ACTIONS(2563),
    [anon_sym_EQ] = ACTIONS(2565),
    [anon_sym_COLON] = ACTIONS(2563),
    [anon_sym_return] = ACTIONS(2563),
    [anon_sym_do] = ACTIONS(2563),
    [anon_sym_let] = ACTIONS(2563),
    [anon_sym_let_BANG] = ACTIONS(2565),
    [anon_sym_LPAREN] = ACTIONS(2563),
    [anon_sym_COMMA] = ACTIONS(2565),
    [anon_sym_null] = ACTIONS(2563),
    [anon_sym_QMARK] = ACTIONS(2563),
    [anon_sym_COLON_QMARK] = ACTIONS(2563),
    [anon_sym_COLON_COLON] = ACTIONS(2565),
    [anon_sym_AMP] = ACTIONS(2563),
    [anon_sym_LBRACK] = ACTIONS(2563),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2565),
    [anon_sym_LBRACE] = ACTIONS(2563),
    [anon_sym_LT_AT] = ACTIONS(2563),
    [anon_sym_AT_GT] = ACTIONS(2563),
    [anon_sym_LT_AT_AT] = ACTIONS(2563),
    [anon_sym_DOT] = ACTIONS(2563),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2565),
    [anon_sym_new] = ACTIONS(2563),
    [anon_sym_return_BANG] = ACTIONS(2565),
    [anon_sym_yield] = ACTIONS(2563),
    [anon_sym_yield_BANG] = ACTIONS(2565),
    [anon_sym_lazy] = ACTIONS(2563),
    [anon_sym_assert] = ACTIONS(2563),
    [anon_sym_upcast] = ACTIONS(2563),
    [anon_sym_downcast] = ACTIONS(2563),
    [anon_sym_COLON_GT] = ACTIONS(2565),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2565),
    [anon_sym_for] = ACTIONS(2563),
    [anon_sym_while] = ACTIONS(2563),
    [anon_sym_if] = ACTIONS(2563),
    [anon_sym_fun] = ACTIONS(2563),
    [anon_sym_DASH_GT] = ACTIONS(2563),
    [anon_sym_try] = ACTIONS(2563),
    [anon_sym_match] = ACTIONS(2563),
    [anon_sym_match_BANG] = ACTIONS(2565),
    [anon_sym_function] = ACTIONS(2563),
    [anon_sym_LT_DASH] = ACTIONS(2563),
    [anon_sym_DOT_LBRACK] = ACTIONS(2565),
    [anon_sym_LT] = ACTIONS(2565),
    [anon_sym_use] = ACTIONS(2563),
    [anon_sym_use_BANG] = ACTIONS(2565),
    [anon_sym_do_BANG] = ACTIONS(2565),
    [anon_sym_begin] = ACTIONS(2563),
    [anon_sym_LPAREN2] = ACTIONS(2563),
    [anon_sym_STAR] = ACTIONS(2563),
    [anon_sym_LT2] = ACTIONS(2563),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2565),
    [anon_sym_or] = ACTIONS(2563),
    [aux_sym_char_token1] = ACTIONS(2565),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2563),
    [anon_sym_DQUOTE] = ACTIONS(2563),
    [anon_sym_AT_DQUOTE] = ACTIONS(2565),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2565),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2565),
    [sym_bool] = ACTIONS(2563),
    [sym_unit] = ACTIONS(2565),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2563),
    [sym_op_identifier] = ACTIONS(2563),
    [anon_sym_PLUS] = ACTIONS(2563),
    [anon_sym_DASH] = ACTIONS(2563),
    [anon_sym_PLUS_DOT] = ACTIONS(2563),
    [anon_sym_DASH_DOT] = ACTIONS(2563),
    [anon_sym_PERCENT] = ACTIONS(2563),
    [anon_sym_AMP_AMP] = ACTIONS(2563),
    [anon_sym_TILDE] = ACTIONS(2565),
    [aux_sym_prefix_op_token1] = ACTIONS(2563),
    [aux_sym_infix_op_token1] = ACTIONS(2565),
    [aux_sym_infix_op_token2] = ACTIONS(2563),
    [anon_sym_PIPE_PIPE] = ACTIONS(2563),
    [anon_sym_BANG_EQ] = ACTIONS(2563),
    [anon_sym_COLON_EQ] = ACTIONS(2565),
    [anon_sym_DOLLAR] = ACTIONS(2563),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2563),
    [sym_int] = ACTIONS(2563),
    [sym_xint] = ACTIONS(2565),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2565),
    [sym__newline] = ACTIONS(2565),
  },
  [1340] = {
    [sym_block_comment] = STATE(1340),
    [sym_compiler_directive_decl] = STATE(1340),
    [sym_fsi_directive_decl] = STATE(1340),
    [sym_preproc_line] = STATE(1340),
    [aux_sym_rules_repeat1] = STATE(1284),
    [sym_identifier] = ACTIONS(2698),
    [anon_sym_EQ] = ACTIONS(2700),
    [anon_sym_COLON] = ACTIONS(2698),
    [anon_sym_return] = ACTIONS(2698),
    [anon_sym_do] = ACTIONS(2698),
    [anon_sym_let] = ACTIONS(2698),
    [anon_sym_let_BANG] = ACTIONS(2700),
    [anon_sym_as] = ACTIONS(2698),
    [anon_sym_LPAREN] = ACTIONS(2698),
    [anon_sym_COMMA] = ACTIONS(2700),
    [anon_sym_null] = ACTIONS(2698),
    [anon_sym_QMARK] = ACTIONS(2698),
    [anon_sym_COLON_QMARK] = ACTIONS(2698),
    [anon_sym_COLON_COLON] = ACTIONS(2700),
    [anon_sym_PIPE] = ACTIONS(3485),
    [anon_sym_AMP] = ACTIONS(2698),
    [anon_sym_LBRACK] = ACTIONS(2698),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2700),
    [anon_sym_LBRACE] = ACTIONS(2698),
    [anon_sym_LT_AT] = ACTIONS(2698),
    [anon_sym_LT_AT_AT] = ACTIONS(2698),
    [anon_sym_DOT] = ACTIONS(2698),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2700),
    [anon_sym_new] = ACTIONS(2698),
    [anon_sym_with] = ACTIONS(2698),
    [anon_sym_return_BANG] = ACTIONS(2700),
    [anon_sym_yield] = ACTIONS(2698),
    [anon_sym_yield_BANG] = ACTIONS(2700),
    [anon_sym_lazy] = ACTIONS(2698),
    [anon_sym_assert] = ACTIONS(2698),
    [anon_sym_upcast] = ACTIONS(2698),
    [anon_sym_downcast] = ACTIONS(2698),
    [anon_sym_COLON_GT] = ACTIONS(2700),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2700),
    [anon_sym_for] = ACTIONS(2698),
    [anon_sym_while] = ACTIONS(2698),
    [anon_sym_if] = ACTIONS(2698),
    [anon_sym_fun] = ACTIONS(2698),
    [anon_sym_try] = ACTIONS(2698),
    [anon_sym_match] = ACTIONS(2698),
    [anon_sym_match_BANG] = ACTIONS(2700),
    [anon_sym_function] = ACTIONS(2698),
    [anon_sym_LT_DASH] = ACTIONS(2698),
    [anon_sym_DOT_LBRACK] = ACTIONS(2700),
    [anon_sym_LT] = ACTIONS(2700),
    [anon_sym_use] = ACTIONS(2698),
    [anon_sym_use_BANG] = ACTIONS(2700),
    [anon_sym_do_BANG] = ACTIONS(2700),
    [anon_sym_begin] = ACTIONS(2698),
    [anon_sym_LPAREN2] = ACTIONS(2698),
    [anon_sym_or] = ACTIONS(2698),
    [aux_sym_char_token1] = ACTIONS(2700),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2698),
    [anon_sym_DQUOTE] = ACTIONS(2698),
    [anon_sym_AT_DQUOTE] = ACTIONS(2700),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2700),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2700),
    [sym_bool] = ACTIONS(2698),
    [sym_unit] = ACTIONS(2700),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2698),
    [sym_op_identifier] = ACTIONS(2698),
    [anon_sym_PLUS] = ACTIONS(2698),
    [anon_sym_DASH] = ACTIONS(2698),
    [anon_sym_PLUS_DOT] = ACTIONS(2698),
    [anon_sym_DASH_DOT] = ACTIONS(2698),
    [anon_sym_PERCENT] = ACTIONS(2698),
    [anon_sym_AMP_AMP] = ACTIONS(2698),
    [anon_sym_TILDE] = ACTIONS(2700),
    [aux_sym_prefix_op_token1] = ACTIONS(2698),
    [aux_sym_infix_op_token1] = ACTIONS(2700),
    [aux_sym_infix_op_token2] = ACTIONS(2698),
    [anon_sym_PIPE_PIPE] = ACTIONS(2698),
    [anon_sym_BANG_EQ] = ACTIONS(2698),
    [anon_sym_COLON_EQ] = ACTIONS(2700),
    [anon_sym_DOLLAR] = ACTIONS(2698),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2698),
    [sym_int] = ACTIONS(2698),
    [sym_xint] = ACTIONS(2700),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2700),
    [sym__newline] = ACTIONS(3508),
    [sym__dedent] = ACTIONS(2700),
  },
  [1341] = {
    [sym_block_comment] = STATE(1341),
    [sym_compiler_directive_decl] = STATE(1341),
    [sym_fsi_directive_decl] = STATE(1341),
    [sym_preproc_line] = STATE(1341),
    [sym_identifier] = ACTIONS(2567),
    [anon_sym_EQ] = ACTIONS(2569),
    [anon_sym_COLON] = ACTIONS(2567),
    [anon_sym_return] = ACTIONS(2567),
    [anon_sym_do] = ACTIONS(2567),
    [anon_sym_let] = ACTIONS(2567),
    [anon_sym_let_BANG] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2567),
    [anon_sym_COMMA] = ACTIONS(2569),
    [anon_sym_null] = ACTIONS(2567),
    [anon_sym_QMARK] = ACTIONS(2567),
    [anon_sym_COLON_QMARK] = ACTIONS(2567),
    [anon_sym_COLON_COLON] = ACTIONS(2569),
    [anon_sym_AMP] = ACTIONS(2567),
    [anon_sym_LBRACK] = ACTIONS(2567),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2569),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_LT_AT] = ACTIONS(2567),
    [anon_sym_AT_GT] = ACTIONS(2567),
    [anon_sym_LT_AT_AT] = ACTIONS(2567),
    [anon_sym_DOT] = ACTIONS(2567),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2569),
    [anon_sym_new] = ACTIONS(2567),
    [anon_sym_return_BANG] = ACTIONS(2569),
    [anon_sym_yield] = ACTIONS(2567),
    [anon_sym_yield_BANG] = ACTIONS(2569),
    [anon_sym_lazy] = ACTIONS(2567),
    [anon_sym_assert] = ACTIONS(2567),
    [anon_sym_upcast] = ACTIONS(2567),
    [anon_sym_downcast] = ACTIONS(2567),
    [anon_sym_COLON_GT] = ACTIONS(2569),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2569),
    [anon_sym_for] = ACTIONS(2567),
    [anon_sym_while] = ACTIONS(2567),
    [anon_sym_if] = ACTIONS(2567),
    [anon_sym_fun] = ACTIONS(2567),
    [anon_sym_DASH_GT] = ACTIONS(2567),
    [anon_sym_try] = ACTIONS(2567),
    [anon_sym_match] = ACTIONS(2567),
    [anon_sym_match_BANG] = ACTIONS(2569),
    [anon_sym_function] = ACTIONS(2567),
    [anon_sym_LT_DASH] = ACTIONS(2567),
    [anon_sym_DOT_LBRACK] = ACTIONS(2569),
    [anon_sym_LT] = ACTIONS(2569),
    [anon_sym_use] = ACTIONS(2567),
    [anon_sym_use_BANG] = ACTIONS(2569),
    [anon_sym_do_BANG] = ACTIONS(2569),
    [anon_sym_begin] = ACTIONS(2567),
    [anon_sym_LPAREN2] = ACTIONS(2567),
    [anon_sym_STAR] = ACTIONS(2567),
    [anon_sym_LT2] = ACTIONS(2567),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2569),
    [anon_sym_or] = ACTIONS(2567),
    [aux_sym_char_token1] = ACTIONS(2569),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2567),
    [anon_sym_DQUOTE] = ACTIONS(2567),
    [anon_sym_AT_DQUOTE] = ACTIONS(2569),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2569),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2569),
    [sym_bool] = ACTIONS(2567),
    [sym_unit] = ACTIONS(2569),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2567),
    [sym_op_identifier] = ACTIONS(2567),
    [anon_sym_PLUS] = ACTIONS(2567),
    [anon_sym_DASH] = ACTIONS(2567),
    [anon_sym_PLUS_DOT] = ACTIONS(2567),
    [anon_sym_DASH_DOT] = ACTIONS(2567),
    [anon_sym_PERCENT] = ACTIONS(2567),
    [anon_sym_AMP_AMP] = ACTIONS(2567),
    [anon_sym_TILDE] = ACTIONS(2569),
    [aux_sym_prefix_op_token1] = ACTIONS(2567),
    [aux_sym_infix_op_token1] = ACTIONS(2569),
    [aux_sym_infix_op_token2] = ACTIONS(2567),
    [anon_sym_PIPE_PIPE] = ACTIONS(2567),
    [anon_sym_BANG_EQ] = ACTIONS(2567),
    [anon_sym_COLON_EQ] = ACTIONS(2569),
    [anon_sym_DOLLAR] = ACTIONS(2567),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2567),
    [sym_int] = ACTIONS(2567),
    [sym_xint] = ACTIONS(2569),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2569),
    [sym__newline] = ACTIONS(2569),
  },
  [1342] = {
    [sym_block_comment] = STATE(1342),
    [sym_compiler_directive_decl] = STATE(1342),
    [sym_fsi_directive_decl] = STATE(1342),
    [sym_preproc_line] = STATE(1342),
    [sym_identifier] = ACTIONS(2466),
    [anon_sym_EQ] = ACTIONS(2468),
    [anon_sym_COLON] = ACTIONS(2466),
    [anon_sym_return] = ACTIONS(2466),
    [anon_sym_do] = ACTIONS(2466),
    [anon_sym_let] = ACTIONS(2466),
    [anon_sym_let_BANG] = ACTIONS(2468),
    [anon_sym_LPAREN] = ACTIONS(2466),
    [anon_sym_COMMA] = ACTIONS(2468),
    [anon_sym_null] = ACTIONS(2466),
    [anon_sym_QMARK] = ACTIONS(2466),
    [anon_sym_COLON_QMARK] = ACTIONS(2466),
    [anon_sym_COLON_COLON] = ACTIONS(2468),
    [anon_sym_AMP] = ACTIONS(2466),
    [anon_sym_LBRACK] = ACTIONS(2466),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2468),
    [anon_sym_LBRACE] = ACTIONS(2466),
    [anon_sym_LT_AT] = ACTIONS(2466),
    [anon_sym_LT_AT_AT] = ACTIONS(2466),
    [anon_sym_AT_AT_GT] = ACTIONS(2466),
    [anon_sym_DOT] = ACTIONS(2466),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2468),
    [anon_sym_new] = ACTIONS(2466),
    [anon_sym_return_BANG] = ACTIONS(2468),
    [anon_sym_yield] = ACTIONS(2466),
    [anon_sym_yield_BANG] = ACTIONS(2468),
    [anon_sym_lazy] = ACTIONS(2466),
    [anon_sym_assert] = ACTIONS(2466),
    [anon_sym_upcast] = ACTIONS(2466),
    [anon_sym_downcast] = ACTIONS(2466),
    [anon_sym_COLON_GT] = ACTIONS(2468),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2468),
    [anon_sym_for] = ACTIONS(2466),
    [anon_sym_while] = ACTIONS(2466),
    [anon_sym_if] = ACTIONS(2466),
    [anon_sym_fun] = ACTIONS(2466),
    [anon_sym_DASH_GT] = ACTIONS(2466),
    [anon_sym_try] = ACTIONS(2466),
    [anon_sym_match] = ACTIONS(2466),
    [anon_sym_match_BANG] = ACTIONS(2468),
    [anon_sym_function] = ACTIONS(2466),
    [anon_sym_LT_DASH] = ACTIONS(2466),
    [anon_sym_DOT_LBRACK] = ACTIONS(2468),
    [anon_sym_LT] = ACTIONS(2468),
    [anon_sym_use] = ACTIONS(2466),
    [anon_sym_use_BANG] = ACTIONS(2468),
    [anon_sym_do_BANG] = ACTIONS(2468),
    [anon_sym_begin] = ACTIONS(2466),
    [anon_sym_LPAREN2] = ACTIONS(2466),
    [anon_sym_STAR] = ACTIONS(2466),
    [anon_sym_LT2] = ACTIONS(2466),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2468),
    [anon_sym_or] = ACTIONS(2466),
    [aux_sym_char_token1] = ACTIONS(2468),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2466),
    [anon_sym_DQUOTE] = ACTIONS(2466),
    [anon_sym_AT_DQUOTE] = ACTIONS(2468),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2468),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2468),
    [sym_bool] = ACTIONS(2466),
    [sym_unit] = ACTIONS(2468),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2466),
    [sym_op_identifier] = ACTIONS(2466),
    [anon_sym_PLUS] = ACTIONS(2466),
    [anon_sym_DASH] = ACTIONS(2466),
    [anon_sym_PLUS_DOT] = ACTIONS(2466),
    [anon_sym_DASH_DOT] = ACTIONS(2466),
    [anon_sym_PERCENT] = ACTIONS(2466),
    [anon_sym_AMP_AMP] = ACTIONS(2466),
    [anon_sym_TILDE] = ACTIONS(2468),
    [aux_sym_prefix_op_token1] = ACTIONS(2466),
    [aux_sym_infix_op_token1] = ACTIONS(2468),
    [aux_sym_infix_op_token2] = ACTIONS(2466),
    [anon_sym_PIPE_PIPE] = ACTIONS(2466),
    [anon_sym_BANG_EQ] = ACTIONS(2466),
    [anon_sym_COLON_EQ] = ACTIONS(2468),
    [anon_sym_DOLLAR] = ACTIONS(2466),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2466),
    [sym_int] = ACTIONS(2466),
    [sym_xint] = ACTIONS(2468),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2468),
    [sym__newline] = ACTIONS(2468),
  },
  [1343] = {
    [sym_block_comment] = STATE(1343),
    [sym_compiler_directive_decl] = STATE(1343),
    [sym_fsi_directive_decl] = STATE(1343),
    [sym_preproc_line] = STATE(1343),
    [sym_identifier] = ACTIONS(2506),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_COLON] = ACTIONS(2506),
    [anon_sym_return] = ACTIONS(2506),
    [anon_sym_do] = ACTIONS(2506),
    [anon_sym_let] = ACTIONS(2506),
    [anon_sym_let_BANG] = ACTIONS(2508),
    [anon_sym_LPAREN] = ACTIONS(2506),
    [anon_sym_COMMA] = ACTIONS(2508),
    [anon_sym_null] = ACTIONS(2506),
    [anon_sym_QMARK] = ACTIONS(2506),
    [anon_sym_COLON_QMARK] = ACTIONS(2506),
    [anon_sym_COLON_COLON] = ACTIONS(2508),
    [anon_sym_AMP] = ACTIONS(2506),
    [anon_sym_LBRACK] = ACTIONS(2506),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2508),
    [anon_sym_LBRACE] = ACTIONS(2506),
    [anon_sym_LT_AT] = ACTIONS(2506),
    [anon_sym_LT_AT_AT] = ACTIONS(2506),
    [anon_sym_DOT] = ACTIONS(2506),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2508),
    [anon_sym_new] = ACTIONS(2506),
    [anon_sym_return_BANG] = ACTIONS(2508),
    [anon_sym_yield] = ACTIONS(2506),
    [anon_sym_yield_BANG] = ACTIONS(2508),
    [anon_sym_lazy] = ACTIONS(2506),
    [anon_sym_assert] = ACTIONS(2506),
    [anon_sym_upcast] = ACTIONS(2506),
    [anon_sym_downcast] = ACTIONS(2506),
    [anon_sym_COLON_GT] = ACTIONS(2508),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2508),
    [anon_sym_for] = ACTIONS(2506),
    [anon_sym_while] = ACTIONS(2506),
    [anon_sym_if] = ACTIONS(2506),
    [anon_sym_fun] = ACTIONS(2506),
    [anon_sym_DASH_GT] = ACTIONS(2506),
    [anon_sym_try] = ACTIONS(2506),
    [anon_sym_match] = ACTIONS(2506),
    [anon_sym_match_BANG] = ACTIONS(2508),
    [anon_sym_function] = ACTIONS(2506),
    [anon_sym_LT_DASH] = ACTIONS(2506),
    [anon_sym_DOT_LBRACK] = ACTIONS(2508),
    [anon_sym_LT] = ACTIONS(2508),
    [anon_sym_use] = ACTIONS(2506),
    [anon_sym_use_BANG] = ACTIONS(2508),
    [anon_sym_do_BANG] = ACTIONS(2508),
    [anon_sym_begin] = ACTIONS(2506),
    [anon_sym_LPAREN2] = ACTIONS(2506),
    [anon_sym_STAR] = ACTIONS(2506),
    [anon_sym_LT2] = ACTIONS(2506),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2508),
    [anon_sym_or] = ACTIONS(2506),
    [aux_sym_char_token1] = ACTIONS(2508),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2506),
    [anon_sym_DQUOTE] = ACTIONS(2506),
    [anon_sym_AT_DQUOTE] = ACTIONS(2508),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2508),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2508),
    [sym_bool] = ACTIONS(2506),
    [sym_unit] = ACTIONS(2508),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2506),
    [sym_op_identifier] = ACTIONS(2506),
    [anon_sym_PLUS] = ACTIONS(2506),
    [anon_sym_DASH] = ACTIONS(2506),
    [anon_sym_PLUS_DOT] = ACTIONS(2506),
    [anon_sym_DASH_DOT] = ACTIONS(2506),
    [anon_sym_PERCENT] = ACTIONS(2506),
    [anon_sym_AMP_AMP] = ACTIONS(2506),
    [anon_sym_TILDE] = ACTIONS(2508),
    [aux_sym_prefix_op_token1] = ACTIONS(2506),
    [aux_sym_infix_op_token1] = ACTIONS(2508),
    [aux_sym_infix_op_token2] = ACTIONS(2506),
    [anon_sym_PIPE_PIPE] = ACTIONS(2506),
    [anon_sym_BANG_EQ] = ACTIONS(2506),
    [anon_sym_COLON_EQ] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(2506),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2506),
    [sym_int] = ACTIONS(2506),
    [sym_xint] = ACTIONS(2508),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2508),
    [anon_sym_POUNDendif] = ACTIONS(2508),
    [sym__newline] = ACTIONS(2508),
  },
  [1344] = {
    [sym_block_comment] = STATE(1344),
    [sym_compiler_directive_decl] = STATE(1344),
    [sym_fsi_directive_decl] = STATE(1344),
    [sym_preproc_line] = STATE(1344),
    [sym_identifier] = ACTIONS(2466),
    [anon_sym_EQ] = ACTIONS(2468),
    [anon_sym_COLON] = ACTIONS(2466),
    [anon_sym_return] = ACTIONS(2466),
    [anon_sym_do] = ACTIONS(2466),
    [anon_sym_let] = ACTIONS(2466),
    [anon_sym_let_BANG] = ACTIONS(2468),
    [anon_sym_LPAREN] = ACTIONS(2466),
    [anon_sym_COMMA] = ACTIONS(2468),
    [anon_sym_null] = ACTIONS(2466),
    [anon_sym_QMARK] = ACTIONS(2466),
    [anon_sym_COLON_QMARK] = ACTIONS(2466),
    [anon_sym_COLON_COLON] = ACTIONS(2468),
    [anon_sym_AMP] = ACTIONS(2466),
    [anon_sym_LBRACK] = ACTIONS(2466),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2468),
    [anon_sym_LBRACE] = ACTIONS(2466),
    [anon_sym_LT_AT] = ACTIONS(2466),
    [anon_sym_LT_AT_AT] = ACTIONS(2466),
    [anon_sym_DOT] = ACTIONS(2466),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2468),
    [anon_sym_new] = ACTIONS(2466),
    [anon_sym_return_BANG] = ACTIONS(2468),
    [anon_sym_yield] = ACTIONS(2466),
    [anon_sym_yield_BANG] = ACTIONS(2468),
    [anon_sym_lazy] = ACTIONS(2466),
    [anon_sym_assert] = ACTIONS(2466),
    [anon_sym_upcast] = ACTIONS(2466),
    [anon_sym_downcast] = ACTIONS(2466),
    [anon_sym_COLON_GT] = ACTIONS(2468),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2468),
    [anon_sym_for] = ACTIONS(2466),
    [anon_sym_while] = ACTIONS(2466),
    [anon_sym_if] = ACTIONS(2466),
    [anon_sym_fun] = ACTIONS(2466),
    [anon_sym_DASH_GT] = ACTIONS(2466),
    [anon_sym_try] = ACTIONS(2466),
    [anon_sym_match] = ACTIONS(2466),
    [anon_sym_match_BANG] = ACTIONS(2468),
    [anon_sym_function] = ACTIONS(2466),
    [anon_sym_LT_DASH] = ACTIONS(2466),
    [anon_sym_DOT_LBRACK] = ACTIONS(2468),
    [anon_sym_LT] = ACTIONS(2468),
    [anon_sym_use] = ACTIONS(2466),
    [anon_sym_use_BANG] = ACTIONS(2468),
    [anon_sym_do_BANG] = ACTIONS(2468),
    [anon_sym_DOT_DOT] = ACTIONS(2468),
    [anon_sym_begin] = ACTIONS(2466),
    [anon_sym_LPAREN2] = ACTIONS(2466),
    [anon_sym_STAR] = ACTIONS(2466),
    [anon_sym_LT2] = ACTIONS(2466),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2468),
    [anon_sym_or] = ACTIONS(2466),
    [aux_sym_char_token1] = ACTIONS(2468),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2466),
    [anon_sym_DQUOTE] = ACTIONS(2466),
    [anon_sym_AT_DQUOTE] = ACTIONS(2468),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2468),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2468),
    [sym_bool] = ACTIONS(2466),
    [sym_unit] = ACTIONS(2468),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2466),
    [sym_op_identifier] = ACTIONS(2466),
    [anon_sym_PLUS] = ACTIONS(2466),
    [anon_sym_DASH] = ACTIONS(2466),
    [anon_sym_PLUS_DOT] = ACTIONS(2466),
    [anon_sym_DASH_DOT] = ACTIONS(2466),
    [anon_sym_PERCENT] = ACTIONS(2466),
    [anon_sym_AMP_AMP] = ACTIONS(2466),
    [anon_sym_TILDE] = ACTIONS(2468),
    [aux_sym_prefix_op_token1] = ACTIONS(2466),
    [aux_sym_infix_op_token1] = ACTIONS(2468),
    [aux_sym_infix_op_token2] = ACTIONS(2466),
    [anon_sym_PIPE_PIPE] = ACTIONS(2466),
    [anon_sym_BANG_EQ] = ACTIONS(2466),
    [anon_sym_COLON_EQ] = ACTIONS(2468),
    [anon_sym_DOLLAR] = ACTIONS(2466),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2466),
    [sym_int] = ACTIONS(2466),
    [sym_xint] = ACTIONS(2468),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2468),
    [sym__newline] = ACTIONS(2468),
  },
  [1345] = {
    [sym_block_comment] = STATE(1345),
    [sym_compiler_directive_decl] = STATE(1345),
    [sym_fsi_directive_decl] = STATE(1345),
    [sym_preproc_line] = STATE(1345),
    [sym_identifier] = ACTIONS(2627),
    [anon_sym_EQ] = ACTIONS(2629),
    [anon_sym_COLON] = ACTIONS(2627),
    [anon_sym_return] = ACTIONS(2627),
    [anon_sym_do] = ACTIONS(2627),
    [anon_sym_let] = ACTIONS(2627),
    [anon_sym_let_BANG] = ACTIONS(2629),
    [anon_sym_LPAREN] = ACTIONS(2627),
    [anon_sym_COMMA] = ACTIONS(2629),
    [anon_sym_null] = ACTIONS(2627),
    [anon_sym_QMARK] = ACTIONS(2627),
    [anon_sym_COLON_QMARK] = ACTIONS(2627),
    [anon_sym_COLON_COLON] = ACTIONS(2629),
    [anon_sym_AMP] = ACTIONS(2627),
    [anon_sym_LBRACK] = ACTIONS(2627),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2629),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_LT_AT] = ACTIONS(2627),
    [anon_sym_LT_AT_AT] = ACTIONS(2627),
    [anon_sym_AT_AT_GT] = ACTIONS(2627),
    [anon_sym_DOT] = ACTIONS(2627),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2629),
    [anon_sym_new] = ACTIONS(2627),
    [anon_sym_return_BANG] = ACTIONS(2629),
    [anon_sym_yield] = ACTIONS(2627),
    [anon_sym_yield_BANG] = ACTIONS(2629),
    [anon_sym_lazy] = ACTIONS(2627),
    [anon_sym_assert] = ACTIONS(2627),
    [anon_sym_upcast] = ACTIONS(2627),
    [anon_sym_downcast] = ACTIONS(2627),
    [anon_sym_COLON_GT] = ACTIONS(2629),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2629),
    [anon_sym_for] = ACTIONS(2627),
    [anon_sym_while] = ACTIONS(2627),
    [anon_sym_if] = ACTIONS(2627),
    [anon_sym_fun] = ACTIONS(2627),
    [anon_sym_DASH_GT] = ACTIONS(2627),
    [anon_sym_try] = ACTIONS(2627),
    [anon_sym_match] = ACTIONS(2627),
    [anon_sym_match_BANG] = ACTIONS(2629),
    [anon_sym_function] = ACTIONS(2627),
    [anon_sym_LT_DASH] = ACTIONS(2627),
    [anon_sym_DOT_LBRACK] = ACTIONS(2629),
    [anon_sym_LT] = ACTIONS(2629),
    [anon_sym_use] = ACTIONS(2627),
    [anon_sym_use_BANG] = ACTIONS(2629),
    [anon_sym_do_BANG] = ACTIONS(2629),
    [anon_sym_begin] = ACTIONS(2627),
    [anon_sym_LPAREN2] = ACTIONS(2627),
    [anon_sym_STAR] = ACTIONS(2627),
    [anon_sym_LT2] = ACTIONS(2627),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2629),
    [anon_sym_or] = ACTIONS(2627),
    [aux_sym_char_token1] = ACTIONS(2629),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2627),
    [anon_sym_DQUOTE] = ACTIONS(2627),
    [anon_sym_AT_DQUOTE] = ACTIONS(2629),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2629),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2629),
    [sym_bool] = ACTIONS(2627),
    [sym_unit] = ACTIONS(2629),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2627),
    [sym_op_identifier] = ACTIONS(2627),
    [anon_sym_PLUS] = ACTIONS(2627),
    [anon_sym_DASH] = ACTIONS(2627),
    [anon_sym_PLUS_DOT] = ACTIONS(2627),
    [anon_sym_DASH_DOT] = ACTIONS(2627),
    [anon_sym_PERCENT] = ACTIONS(2627),
    [anon_sym_AMP_AMP] = ACTIONS(2627),
    [anon_sym_TILDE] = ACTIONS(2629),
    [aux_sym_prefix_op_token1] = ACTIONS(2627),
    [aux_sym_infix_op_token1] = ACTIONS(2629),
    [aux_sym_infix_op_token2] = ACTIONS(2627),
    [anon_sym_PIPE_PIPE] = ACTIONS(2627),
    [anon_sym_BANG_EQ] = ACTIONS(2627),
    [anon_sym_COLON_EQ] = ACTIONS(2629),
    [anon_sym_DOLLAR] = ACTIONS(2627),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2627),
    [sym_int] = ACTIONS(2627),
    [sym_xint] = ACTIONS(2629),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2629),
    [sym__newline] = ACTIONS(2629),
  },
  [1346] = {
    [sym_block_comment] = STATE(1346),
    [sym_compiler_directive_decl] = STATE(1346),
    [sym_fsi_directive_decl] = STATE(1346),
    [sym_preproc_line] = STATE(1346),
    [sym_identifier] = ACTIONS(2627),
    [anon_sym_EQ] = ACTIONS(2629),
    [anon_sym_COLON] = ACTIONS(2627),
    [anon_sym_return] = ACTIONS(2627),
    [anon_sym_do] = ACTIONS(2627),
    [anon_sym_let] = ACTIONS(2627),
    [anon_sym_let_BANG] = ACTIONS(2629),
    [anon_sym_LPAREN] = ACTIONS(2627),
    [anon_sym_COMMA] = ACTIONS(2629),
    [anon_sym_null] = ACTIONS(2627),
    [anon_sym_QMARK] = ACTIONS(2627),
    [anon_sym_COLON_QMARK] = ACTIONS(2627),
    [anon_sym_COLON_COLON] = ACTIONS(2629),
    [anon_sym_AMP] = ACTIONS(2627),
    [anon_sym_LBRACK] = ACTIONS(2627),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2629),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_LT_AT] = ACTIONS(2627),
    [anon_sym_LT_AT_AT] = ACTIONS(2627),
    [anon_sym_DOT] = ACTIONS(2627),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2629),
    [anon_sym_new] = ACTIONS(2627),
    [anon_sym_return_BANG] = ACTIONS(2629),
    [anon_sym_yield] = ACTIONS(2627),
    [anon_sym_yield_BANG] = ACTIONS(2629),
    [anon_sym_lazy] = ACTIONS(2627),
    [anon_sym_assert] = ACTIONS(2627),
    [anon_sym_upcast] = ACTIONS(2627),
    [anon_sym_downcast] = ACTIONS(2627),
    [anon_sym_COLON_GT] = ACTIONS(2629),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2629),
    [anon_sym_for] = ACTIONS(2627),
    [anon_sym_while] = ACTIONS(2627),
    [anon_sym_if] = ACTIONS(2627),
    [anon_sym_fun] = ACTIONS(2627),
    [anon_sym_DASH_GT] = ACTIONS(2627),
    [anon_sym_try] = ACTIONS(2627),
    [anon_sym_match] = ACTIONS(2627),
    [anon_sym_match_BANG] = ACTIONS(2629),
    [anon_sym_function] = ACTIONS(2627),
    [anon_sym_LT_DASH] = ACTIONS(2627),
    [anon_sym_DOT_LBRACK] = ACTIONS(2629),
    [anon_sym_LT] = ACTIONS(2629),
    [anon_sym_use] = ACTIONS(2627),
    [anon_sym_use_BANG] = ACTIONS(2629),
    [anon_sym_do_BANG] = ACTIONS(2629),
    [anon_sym_DOT_DOT] = ACTIONS(2629),
    [anon_sym_begin] = ACTIONS(2627),
    [anon_sym_LPAREN2] = ACTIONS(2627),
    [anon_sym_STAR] = ACTIONS(2627),
    [anon_sym_LT2] = ACTIONS(2627),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2629),
    [anon_sym_or] = ACTIONS(2627),
    [aux_sym_char_token1] = ACTIONS(2629),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2627),
    [anon_sym_DQUOTE] = ACTIONS(2627),
    [anon_sym_AT_DQUOTE] = ACTIONS(2629),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2629),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2629),
    [sym_bool] = ACTIONS(2627),
    [sym_unit] = ACTIONS(2629),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2627),
    [sym_op_identifier] = ACTIONS(2627),
    [anon_sym_PLUS] = ACTIONS(2627),
    [anon_sym_DASH] = ACTIONS(2627),
    [anon_sym_PLUS_DOT] = ACTIONS(2627),
    [anon_sym_DASH_DOT] = ACTIONS(2627),
    [anon_sym_PERCENT] = ACTIONS(2627),
    [anon_sym_AMP_AMP] = ACTIONS(2627),
    [anon_sym_TILDE] = ACTIONS(2629),
    [aux_sym_prefix_op_token1] = ACTIONS(2627),
    [aux_sym_infix_op_token1] = ACTIONS(2629),
    [aux_sym_infix_op_token2] = ACTIONS(2627),
    [anon_sym_PIPE_PIPE] = ACTIONS(2627),
    [anon_sym_BANG_EQ] = ACTIONS(2627),
    [anon_sym_COLON_EQ] = ACTIONS(2629),
    [anon_sym_DOLLAR] = ACTIONS(2627),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2627),
    [sym_int] = ACTIONS(2627),
    [sym_xint] = ACTIONS(2629),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2629),
    [sym__newline] = ACTIONS(2629),
  },
  [1347] = {
    [sym_block_comment] = STATE(1347),
    [sym_compiler_directive_decl] = STATE(1347),
    [sym_fsi_directive_decl] = STATE(1347),
    [sym_preproc_line] = STATE(1347),
    [sym_identifier] = ACTIONS(2514),
    [anon_sym_EQ] = ACTIONS(2516),
    [anon_sym_COLON] = ACTIONS(2514),
    [anon_sym_return] = ACTIONS(2514),
    [anon_sym_do] = ACTIONS(2514),
    [anon_sym_let] = ACTIONS(2514),
    [anon_sym_let_BANG] = ACTIONS(2516),
    [anon_sym_LPAREN] = ACTIONS(2514),
    [anon_sym_COMMA] = ACTIONS(2516),
    [anon_sym_null] = ACTIONS(2514),
    [anon_sym_QMARK] = ACTIONS(2514),
    [anon_sym_COLON_QMARK] = ACTIONS(2514),
    [anon_sym_COLON_COLON] = ACTIONS(2516),
    [anon_sym_AMP] = ACTIONS(2514),
    [anon_sym_LBRACK] = ACTIONS(2514),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2516),
    [anon_sym_LBRACE] = ACTIONS(2514),
    [anon_sym_LT_AT] = ACTIONS(2514),
    [anon_sym_LT_AT_AT] = ACTIONS(2514),
    [anon_sym_AT_AT_GT] = ACTIONS(2514),
    [anon_sym_DOT] = ACTIONS(2514),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2516),
    [anon_sym_new] = ACTIONS(2514),
    [anon_sym_return_BANG] = ACTIONS(2516),
    [anon_sym_yield] = ACTIONS(2514),
    [anon_sym_yield_BANG] = ACTIONS(2516),
    [anon_sym_lazy] = ACTIONS(2514),
    [anon_sym_assert] = ACTIONS(2514),
    [anon_sym_upcast] = ACTIONS(2514),
    [anon_sym_downcast] = ACTIONS(2514),
    [anon_sym_COLON_GT] = ACTIONS(2516),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2516),
    [anon_sym_for] = ACTIONS(2514),
    [anon_sym_while] = ACTIONS(2514),
    [anon_sym_if] = ACTIONS(2514),
    [anon_sym_fun] = ACTIONS(2514),
    [anon_sym_DASH_GT] = ACTIONS(2514),
    [anon_sym_try] = ACTIONS(2514),
    [anon_sym_match] = ACTIONS(2514),
    [anon_sym_match_BANG] = ACTIONS(2516),
    [anon_sym_function] = ACTIONS(2514),
    [anon_sym_LT_DASH] = ACTIONS(2514),
    [anon_sym_DOT_LBRACK] = ACTIONS(2516),
    [anon_sym_LT] = ACTIONS(2516),
    [anon_sym_use] = ACTIONS(2514),
    [anon_sym_use_BANG] = ACTIONS(2516),
    [anon_sym_do_BANG] = ACTIONS(2516),
    [anon_sym_begin] = ACTIONS(2514),
    [anon_sym_LPAREN2] = ACTIONS(2514),
    [anon_sym_STAR] = ACTIONS(2514),
    [anon_sym_LT2] = ACTIONS(2514),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2516),
    [anon_sym_or] = ACTIONS(2514),
    [aux_sym_char_token1] = ACTIONS(2516),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2514),
    [anon_sym_DQUOTE] = ACTIONS(2514),
    [anon_sym_AT_DQUOTE] = ACTIONS(2516),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2516),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2516),
    [sym_bool] = ACTIONS(2514),
    [sym_unit] = ACTIONS(2516),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2514),
    [sym_op_identifier] = ACTIONS(2514),
    [anon_sym_PLUS] = ACTIONS(2514),
    [anon_sym_DASH] = ACTIONS(2514),
    [anon_sym_PLUS_DOT] = ACTIONS(2514),
    [anon_sym_DASH_DOT] = ACTIONS(2514),
    [anon_sym_PERCENT] = ACTIONS(2514),
    [anon_sym_AMP_AMP] = ACTIONS(2514),
    [anon_sym_TILDE] = ACTIONS(2516),
    [aux_sym_prefix_op_token1] = ACTIONS(2514),
    [aux_sym_infix_op_token1] = ACTIONS(2516),
    [aux_sym_infix_op_token2] = ACTIONS(2514),
    [anon_sym_PIPE_PIPE] = ACTIONS(2514),
    [anon_sym_BANG_EQ] = ACTIONS(2514),
    [anon_sym_COLON_EQ] = ACTIONS(2516),
    [anon_sym_DOLLAR] = ACTIONS(2514),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2514),
    [sym_int] = ACTIONS(2514),
    [sym_xint] = ACTIONS(2516),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2516),
    [sym__newline] = ACTIONS(2516),
  },
  [1348] = {
    [sym_block_comment] = STATE(1348),
    [sym_compiler_directive_decl] = STATE(1348),
    [sym_fsi_directive_decl] = STATE(1348),
    [sym_preproc_line] = STATE(1348),
    [sym_identifier] = ACTIONS(2723),
    [anon_sym_EQ] = ACTIONS(2725),
    [anon_sym_COLON] = ACTIONS(2723),
    [anon_sym_return] = ACTIONS(2723),
    [anon_sym_do] = ACTIONS(2723),
    [anon_sym_let] = ACTIONS(2723),
    [anon_sym_let_BANG] = ACTIONS(2725),
    [anon_sym_LPAREN] = ACTIONS(2723),
    [anon_sym_COMMA] = ACTIONS(2725),
    [anon_sym_null] = ACTIONS(2723),
    [anon_sym_QMARK] = ACTIONS(2723),
    [anon_sym_COLON_QMARK] = ACTIONS(2723),
    [anon_sym_COLON_COLON] = ACTIONS(2725),
    [anon_sym_AMP] = ACTIONS(2723),
    [anon_sym_LBRACK] = ACTIONS(2723),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2725),
    [anon_sym_LBRACE] = ACTIONS(2723),
    [anon_sym_LT_AT] = ACTIONS(2723),
    [anon_sym_LT_AT_AT] = ACTIONS(2723),
    [anon_sym_DOT] = ACTIONS(2723),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2725),
    [anon_sym_new] = ACTIONS(2723),
    [anon_sym_with] = ACTIONS(2723),
    [anon_sym_return_BANG] = ACTIONS(2725),
    [anon_sym_yield] = ACTIONS(2723),
    [anon_sym_yield_BANG] = ACTIONS(2725),
    [anon_sym_lazy] = ACTIONS(2723),
    [anon_sym_assert] = ACTIONS(2723),
    [anon_sym_upcast] = ACTIONS(2723),
    [anon_sym_downcast] = ACTIONS(2723),
    [anon_sym_COLON_GT] = ACTIONS(2725),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2725),
    [anon_sym_for] = ACTIONS(2723),
    [anon_sym_while] = ACTIONS(2723),
    [anon_sym_if] = ACTIONS(2723),
    [anon_sym_fun] = ACTIONS(2723),
    [anon_sym_try] = ACTIONS(2723),
    [anon_sym_match] = ACTIONS(2723),
    [anon_sym_match_BANG] = ACTIONS(2725),
    [anon_sym_function] = ACTIONS(2723),
    [anon_sym_LT_DASH] = ACTIONS(2723),
    [anon_sym_DOT_LBRACK] = ACTIONS(2725),
    [anon_sym_LT] = ACTIONS(2725),
    [anon_sym_use] = ACTIONS(2723),
    [anon_sym_use_BANG] = ACTIONS(2725),
    [anon_sym_do_BANG] = ACTIONS(2725),
    [anon_sym_begin] = ACTIONS(2723),
    [anon_sym_LPAREN2] = ACTIONS(2723),
    [anon_sym_DOT_DOT2] = ACTIONS(2725),
    [anon_sym_or] = ACTIONS(2723),
    [aux_sym_char_token1] = ACTIONS(2725),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2723),
    [anon_sym_DQUOTE] = ACTIONS(2723),
    [anon_sym_AT_DQUOTE] = ACTIONS(2725),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2725),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2725),
    [sym_bool] = ACTIONS(2723),
    [sym_unit] = ACTIONS(2725),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2723),
    [sym_op_identifier] = ACTIONS(2723),
    [anon_sym_PLUS] = ACTIONS(2723),
    [anon_sym_DASH] = ACTIONS(2723),
    [anon_sym_PLUS_DOT] = ACTIONS(2723),
    [anon_sym_DASH_DOT] = ACTIONS(2723),
    [anon_sym_PERCENT] = ACTIONS(2723),
    [anon_sym_AMP_AMP] = ACTIONS(2723),
    [anon_sym_TILDE] = ACTIONS(2725),
    [aux_sym_prefix_op_token1] = ACTIONS(2723),
    [aux_sym_infix_op_token1] = ACTIONS(2725),
    [aux_sym_infix_op_token2] = ACTIONS(2723),
    [anon_sym_PIPE_PIPE] = ACTIONS(2723),
    [anon_sym_BANG_EQ] = ACTIONS(2723),
    [anon_sym_COLON_EQ] = ACTIONS(2725),
    [anon_sym_DOLLAR] = ACTIONS(2723),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2723),
    [sym_int] = ACTIONS(2723),
    [sym_xint] = ACTIONS(2725),
    [anon_sym_f] = ACTIONS(2723),
    [aux_sym_decimal_token1] = ACTIONS(2723),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2725),
    [sym__newline] = ACTIONS(2725),
    [sym__dedent] = ACTIONS(2725),
  },
  [1349] = {
    [sym_block_comment] = STATE(1349),
    [sym_compiler_directive_decl] = STATE(1349),
    [sym_fsi_directive_decl] = STATE(1349),
    [sym_preproc_line] = STATE(1349),
    [sym_identifier] = ACTIONS(2340),
    [anon_sym_EQ] = ACTIONS(2342),
    [anon_sym_COLON] = ACTIONS(2340),
    [anon_sym_return] = ACTIONS(2340),
    [anon_sym_do] = ACTIONS(2340),
    [anon_sym_let] = ACTIONS(2340),
    [anon_sym_let_BANG] = ACTIONS(2342),
    [anon_sym_LPAREN] = ACTIONS(2340),
    [anon_sym_COMMA] = ACTIONS(2342),
    [anon_sym_null] = ACTIONS(2340),
    [anon_sym_QMARK] = ACTIONS(2340),
    [anon_sym_COLON_QMARK] = ACTIONS(2340),
    [anon_sym_COLON_COLON] = ACTIONS(2342),
    [anon_sym_AMP] = ACTIONS(2340),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2342),
    [anon_sym_LBRACE] = ACTIONS(2340),
    [anon_sym_LT_AT] = ACTIONS(2340),
    [anon_sym_LT_AT_AT] = ACTIONS(2340),
    [anon_sym_DOT] = ACTIONS(2340),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2342),
    [anon_sym_new] = ACTIONS(2340),
    [anon_sym_return_BANG] = ACTIONS(2342),
    [anon_sym_yield] = ACTIONS(2340),
    [anon_sym_yield_BANG] = ACTIONS(2342),
    [anon_sym_lazy] = ACTIONS(2340),
    [anon_sym_assert] = ACTIONS(2340),
    [anon_sym_upcast] = ACTIONS(2340),
    [anon_sym_downcast] = ACTIONS(2340),
    [anon_sym_COLON_GT] = ACTIONS(2342),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2342),
    [anon_sym_for] = ACTIONS(2340),
    [anon_sym_while] = ACTIONS(2340),
    [anon_sym_if] = ACTIONS(2340),
    [anon_sym_fun] = ACTIONS(2340),
    [anon_sym_DASH_GT] = ACTIONS(2340),
    [anon_sym_try] = ACTIONS(2340),
    [anon_sym_match] = ACTIONS(2340),
    [anon_sym_match_BANG] = ACTIONS(2342),
    [anon_sym_function] = ACTIONS(2340),
    [anon_sym_LT_DASH] = ACTIONS(2340),
    [anon_sym_DOT_LBRACK] = ACTIONS(2342),
    [anon_sym_LT] = ACTIONS(2342),
    [anon_sym_use] = ACTIONS(2340),
    [anon_sym_use_BANG] = ACTIONS(2342),
    [anon_sym_do_BANG] = ACTIONS(2342),
    [anon_sym_DOT_DOT] = ACTIONS(2342),
    [anon_sym_begin] = ACTIONS(2340),
    [anon_sym_LPAREN2] = ACTIONS(2340),
    [anon_sym_STAR] = ACTIONS(2340),
    [anon_sym_LT2] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2342),
    [anon_sym_or] = ACTIONS(2340),
    [aux_sym_char_token1] = ACTIONS(2342),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2340),
    [anon_sym_DQUOTE] = ACTIONS(2340),
    [anon_sym_AT_DQUOTE] = ACTIONS(2342),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2342),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2342),
    [sym_bool] = ACTIONS(2340),
    [sym_unit] = ACTIONS(2342),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2340),
    [sym_op_identifier] = ACTIONS(2340),
    [anon_sym_PLUS] = ACTIONS(2340),
    [anon_sym_DASH] = ACTIONS(2340),
    [anon_sym_PLUS_DOT] = ACTIONS(2340),
    [anon_sym_DASH_DOT] = ACTIONS(2340),
    [anon_sym_PERCENT] = ACTIONS(2340),
    [anon_sym_AMP_AMP] = ACTIONS(2340),
    [anon_sym_TILDE] = ACTIONS(2342),
    [aux_sym_prefix_op_token1] = ACTIONS(2340),
    [aux_sym_infix_op_token1] = ACTIONS(2342),
    [aux_sym_infix_op_token2] = ACTIONS(2340),
    [anon_sym_PIPE_PIPE] = ACTIONS(2340),
    [anon_sym_BANG_EQ] = ACTIONS(2340),
    [anon_sym_COLON_EQ] = ACTIONS(2342),
    [anon_sym_DOLLAR] = ACTIONS(2340),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2340),
    [sym_int] = ACTIONS(2340),
    [sym_xint] = ACTIONS(2342),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2342),
    [sym__newline] = ACTIONS(2342),
  },
  [1350] = {
    [sym_block_comment] = STATE(1350),
    [sym_compiler_directive_decl] = STATE(1350),
    [sym_fsi_directive_decl] = STATE(1350),
    [sym_preproc_line] = STATE(1350),
    [sym_identifier] = ACTIONS(2470),
    [anon_sym_EQ] = ACTIONS(2472),
    [anon_sym_COLON] = ACTIONS(2470),
    [anon_sym_return] = ACTIONS(2470),
    [anon_sym_do] = ACTIONS(2470),
    [anon_sym_let] = ACTIONS(2470),
    [anon_sym_let_BANG] = ACTIONS(2472),
    [anon_sym_LPAREN] = ACTIONS(2470),
    [anon_sym_COMMA] = ACTIONS(2472),
    [anon_sym_null] = ACTIONS(2470),
    [anon_sym_QMARK] = ACTIONS(2470),
    [anon_sym_COLON_QMARK] = ACTIONS(2470),
    [anon_sym_COLON_COLON] = ACTIONS(2472),
    [anon_sym_AMP] = ACTIONS(2470),
    [anon_sym_LBRACK] = ACTIONS(2470),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2472),
    [anon_sym_LBRACE] = ACTIONS(2470),
    [anon_sym_LT_AT] = ACTIONS(2470),
    [anon_sym_LT_AT_AT] = ACTIONS(2470),
    [anon_sym_DOT] = ACTIONS(2470),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2472),
    [anon_sym_new] = ACTIONS(2470),
    [anon_sym_return_BANG] = ACTIONS(2472),
    [anon_sym_yield] = ACTIONS(2470),
    [anon_sym_yield_BANG] = ACTIONS(2472),
    [anon_sym_lazy] = ACTIONS(2470),
    [anon_sym_assert] = ACTIONS(2470),
    [anon_sym_upcast] = ACTIONS(2470),
    [anon_sym_downcast] = ACTIONS(2470),
    [anon_sym_COLON_GT] = ACTIONS(2472),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2472),
    [anon_sym_for] = ACTIONS(2470),
    [anon_sym_while] = ACTIONS(2470),
    [anon_sym_if] = ACTIONS(2470),
    [anon_sym_fun] = ACTIONS(2470),
    [anon_sym_DASH_GT] = ACTIONS(2470),
    [anon_sym_try] = ACTIONS(2470),
    [anon_sym_match] = ACTIONS(2470),
    [anon_sym_match_BANG] = ACTIONS(2472),
    [anon_sym_function] = ACTIONS(2470),
    [anon_sym_LT_DASH] = ACTIONS(2470),
    [anon_sym_DOT_LBRACK] = ACTIONS(2472),
    [anon_sym_LT] = ACTIONS(2472),
    [anon_sym_use] = ACTIONS(2470),
    [anon_sym_use_BANG] = ACTIONS(2472),
    [anon_sym_do_BANG] = ACTIONS(2472),
    [anon_sym_begin] = ACTIONS(2470),
    [anon_sym_LPAREN2] = ACTIONS(2470),
    [anon_sym_STAR] = ACTIONS(2470),
    [anon_sym_LT2] = ACTIONS(2470),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2472),
    [anon_sym_or] = ACTIONS(2470),
    [aux_sym_char_token1] = ACTIONS(2472),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2470),
    [anon_sym_DQUOTE] = ACTIONS(2470),
    [anon_sym_AT_DQUOTE] = ACTIONS(2472),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2472),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2472),
    [sym_bool] = ACTIONS(2470),
    [sym_unit] = ACTIONS(2472),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2470),
    [sym_op_identifier] = ACTIONS(2470),
    [anon_sym_PLUS] = ACTIONS(2470),
    [anon_sym_DASH] = ACTIONS(2470),
    [anon_sym_PLUS_DOT] = ACTIONS(2470),
    [anon_sym_DASH_DOT] = ACTIONS(2470),
    [anon_sym_PERCENT] = ACTIONS(2470),
    [anon_sym_AMP_AMP] = ACTIONS(2470),
    [anon_sym_TILDE] = ACTIONS(2472),
    [aux_sym_prefix_op_token1] = ACTIONS(2470),
    [aux_sym_infix_op_token1] = ACTIONS(2472),
    [aux_sym_infix_op_token2] = ACTIONS(2470),
    [anon_sym_PIPE_PIPE] = ACTIONS(2470),
    [anon_sym_BANG_EQ] = ACTIONS(2470),
    [anon_sym_COLON_EQ] = ACTIONS(2472),
    [anon_sym_DOLLAR] = ACTIONS(2470),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2470),
    [sym_int] = ACTIONS(2470),
    [sym_xint] = ACTIONS(2472),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2472),
    [anon_sym_POUNDendif] = ACTIONS(2472),
    [sym__newline] = ACTIONS(2472),
  },
  [1351] = {
    [sym_block_comment] = STATE(1351),
    [sym_compiler_directive_decl] = STATE(1351),
    [sym_fsi_directive_decl] = STATE(1351),
    [sym_preproc_line] = STATE(1351),
    [sym_identifier] = ACTIONS(2454),
    [anon_sym_EQ] = ACTIONS(2456),
    [anon_sym_COLON] = ACTIONS(2454),
    [anon_sym_return] = ACTIONS(2454),
    [anon_sym_do] = ACTIONS(2454),
    [anon_sym_let] = ACTIONS(2454),
    [anon_sym_let_BANG] = ACTIONS(2456),
    [anon_sym_LPAREN] = ACTIONS(2454),
    [anon_sym_COMMA] = ACTIONS(2456),
    [anon_sym_null] = ACTIONS(2454),
    [anon_sym_QMARK] = ACTIONS(2454),
    [anon_sym_COLON_QMARK] = ACTIONS(2454),
    [anon_sym_COLON_COLON] = ACTIONS(2456),
    [anon_sym_AMP] = ACTIONS(2454),
    [anon_sym_LBRACK] = ACTIONS(2454),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2456),
    [anon_sym_LBRACE] = ACTIONS(2454),
    [anon_sym_LT_AT] = ACTIONS(2454),
    [anon_sym_LT_AT_AT] = ACTIONS(2454),
    [anon_sym_DOT] = ACTIONS(2454),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2456),
    [anon_sym_new] = ACTIONS(2454),
    [anon_sym_return_BANG] = ACTIONS(2456),
    [anon_sym_yield] = ACTIONS(2454),
    [anon_sym_yield_BANG] = ACTIONS(2456),
    [anon_sym_lazy] = ACTIONS(2454),
    [anon_sym_assert] = ACTIONS(2454),
    [anon_sym_upcast] = ACTIONS(2454),
    [anon_sym_downcast] = ACTIONS(2454),
    [anon_sym_COLON_GT] = ACTIONS(2456),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2456),
    [anon_sym_for] = ACTIONS(2454),
    [anon_sym_while] = ACTIONS(2454),
    [anon_sym_if] = ACTIONS(2454),
    [anon_sym_fun] = ACTIONS(2454),
    [anon_sym_DASH_GT] = ACTIONS(2454),
    [anon_sym_try] = ACTIONS(2454),
    [anon_sym_match] = ACTIONS(2454),
    [anon_sym_match_BANG] = ACTIONS(2456),
    [anon_sym_function] = ACTIONS(2454),
    [anon_sym_LT_DASH] = ACTIONS(2454),
    [anon_sym_DOT_LBRACK] = ACTIONS(2456),
    [anon_sym_LT] = ACTIONS(2456),
    [anon_sym_use] = ACTIONS(2454),
    [anon_sym_use_BANG] = ACTIONS(2456),
    [anon_sym_do_BANG] = ACTIONS(2456),
    [anon_sym_begin] = ACTIONS(2454),
    [anon_sym_LPAREN2] = ACTIONS(2454),
    [anon_sym_STAR] = ACTIONS(2454),
    [anon_sym_LT2] = ACTIONS(2454),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2456),
    [anon_sym_or] = ACTIONS(2454),
    [aux_sym_char_token1] = ACTIONS(2456),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2454),
    [anon_sym_DQUOTE] = ACTIONS(2454),
    [anon_sym_AT_DQUOTE] = ACTIONS(2456),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2456),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2456),
    [sym_bool] = ACTIONS(2454),
    [sym_unit] = ACTIONS(2456),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2454),
    [sym_op_identifier] = ACTIONS(2454),
    [anon_sym_PLUS] = ACTIONS(2454),
    [anon_sym_DASH] = ACTIONS(2454),
    [anon_sym_PLUS_DOT] = ACTIONS(2454),
    [anon_sym_DASH_DOT] = ACTIONS(2454),
    [anon_sym_PERCENT] = ACTIONS(2454),
    [anon_sym_AMP_AMP] = ACTIONS(2454),
    [anon_sym_TILDE] = ACTIONS(2456),
    [aux_sym_prefix_op_token1] = ACTIONS(2454),
    [aux_sym_infix_op_token1] = ACTIONS(2456),
    [aux_sym_infix_op_token2] = ACTIONS(2454),
    [anon_sym_PIPE_PIPE] = ACTIONS(2454),
    [anon_sym_BANG_EQ] = ACTIONS(2454),
    [anon_sym_COLON_EQ] = ACTIONS(2456),
    [anon_sym_DOLLAR] = ACTIONS(2454),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2454),
    [sym_int] = ACTIONS(2454),
    [sym_xint] = ACTIONS(2456),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2456),
    [anon_sym_POUNDendif] = ACTIONS(2456),
    [sym__newline] = ACTIONS(2456),
  },
  [1352] = {
    [sym_block_comment] = STATE(1352),
    [sym_compiler_directive_decl] = STATE(1352),
    [sym_fsi_directive_decl] = STATE(1352),
    [sym_preproc_line] = STATE(1352),
    [sym_identifier] = ACTIONS(2729),
    [anon_sym_EQ] = ACTIONS(2731),
    [anon_sym_COLON] = ACTIONS(2729),
    [anon_sym_return] = ACTIONS(2729),
    [anon_sym_do] = ACTIONS(2729),
    [anon_sym_let] = ACTIONS(2729),
    [anon_sym_let_BANG] = ACTIONS(2731),
    [anon_sym_as] = ACTIONS(2729),
    [anon_sym_LPAREN] = ACTIONS(2729),
    [anon_sym_COMMA] = ACTIONS(2731),
    [anon_sym_null] = ACTIONS(2729),
    [anon_sym_QMARK] = ACTIONS(2729),
    [anon_sym_COLON_QMARK] = ACTIONS(2729),
    [anon_sym_COLON_COLON] = ACTIONS(2731),
    [anon_sym_AMP] = ACTIONS(2729),
    [anon_sym_LBRACK] = ACTIONS(2729),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2731),
    [anon_sym_LBRACE] = ACTIONS(2729),
    [anon_sym_LT_AT] = ACTIONS(2729),
    [anon_sym_LT_AT_AT] = ACTIONS(2729),
    [anon_sym_DOT] = ACTIONS(2729),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2731),
    [anon_sym_new] = ACTIONS(2729),
    [anon_sym_with] = ACTIONS(2729),
    [anon_sym_return_BANG] = ACTIONS(2731),
    [anon_sym_yield] = ACTIONS(2729),
    [anon_sym_yield_BANG] = ACTIONS(2731),
    [anon_sym_lazy] = ACTIONS(2729),
    [anon_sym_assert] = ACTIONS(2729),
    [anon_sym_upcast] = ACTIONS(2729),
    [anon_sym_downcast] = ACTIONS(2729),
    [anon_sym_COLON_GT] = ACTIONS(2731),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2731),
    [anon_sym_for] = ACTIONS(2729),
    [anon_sym_while] = ACTIONS(2729),
    [anon_sym_else] = ACTIONS(2729),
    [anon_sym_elif] = ACTIONS(2729),
    [anon_sym_if] = ACTIONS(2729),
    [anon_sym_fun] = ACTIONS(2729),
    [anon_sym_try] = ACTIONS(2729),
    [anon_sym_match] = ACTIONS(2729),
    [anon_sym_match_BANG] = ACTIONS(2731),
    [anon_sym_function] = ACTIONS(2729),
    [anon_sym_LT_DASH] = ACTIONS(2729),
    [anon_sym_DOT_LBRACK] = ACTIONS(2731),
    [anon_sym_LT] = ACTIONS(2731),
    [anon_sym_use] = ACTIONS(2729),
    [anon_sym_use_BANG] = ACTIONS(2731),
    [anon_sym_do_BANG] = ACTIONS(2731),
    [anon_sym_begin] = ACTIONS(2729),
    [anon_sym_LPAREN2] = ACTIONS(2729),
    [anon_sym_or] = ACTIONS(2729),
    [aux_sym_char_token1] = ACTIONS(2731),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2729),
    [anon_sym_DQUOTE] = ACTIONS(2729),
    [anon_sym_AT_DQUOTE] = ACTIONS(2731),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2731),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2731),
    [sym_bool] = ACTIONS(2729),
    [sym_unit] = ACTIONS(2731),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2729),
    [sym_op_identifier] = ACTIONS(2729),
    [anon_sym_PLUS] = ACTIONS(2729),
    [anon_sym_DASH] = ACTIONS(2729),
    [anon_sym_PLUS_DOT] = ACTIONS(2729),
    [anon_sym_DASH_DOT] = ACTIONS(2729),
    [anon_sym_PERCENT] = ACTIONS(2729),
    [anon_sym_AMP_AMP] = ACTIONS(2729),
    [anon_sym_TILDE] = ACTIONS(2731),
    [aux_sym_prefix_op_token1] = ACTIONS(2729),
    [aux_sym_infix_op_token1] = ACTIONS(2731),
    [aux_sym_infix_op_token2] = ACTIONS(2729),
    [anon_sym_PIPE_PIPE] = ACTIONS(2729),
    [anon_sym_BANG_EQ] = ACTIONS(2729),
    [anon_sym_COLON_EQ] = ACTIONS(2731),
    [anon_sym_DOLLAR] = ACTIONS(2729),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2729),
    [sym_int] = ACTIONS(2729),
    [sym_xint] = ACTIONS(2731),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2731),
    [sym__newline] = ACTIONS(2731),
    [sym__dedent] = ACTIONS(2731),
  },
  [1353] = {
    [sym_block_comment] = STATE(1353),
    [sym_compiler_directive_decl] = STATE(1353),
    [sym_fsi_directive_decl] = STATE(1353),
    [sym_preproc_line] = STATE(1353),
    [sym_identifier] = ACTIONS(2470),
    [anon_sym_EQ] = ACTIONS(2472),
    [anon_sym_COLON] = ACTIONS(2470),
    [anon_sym_return] = ACTIONS(2470),
    [anon_sym_do] = ACTIONS(2470),
    [anon_sym_let] = ACTIONS(2470),
    [anon_sym_let_BANG] = ACTIONS(2472),
    [anon_sym_LPAREN] = ACTIONS(2470),
    [anon_sym_COMMA] = ACTIONS(2472),
    [anon_sym_null] = ACTIONS(2470),
    [anon_sym_QMARK] = ACTIONS(2470),
    [anon_sym_COLON_QMARK] = ACTIONS(2470),
    [anon_sym_COLON_COLON] = ACTIONS(2472),
    [anon_sym_AMP] = ACTIONS(2470),
    [anon_sym_LBRACK] = ACTIONS(2470),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2472),
    [anon_sym_LBRACE] = ACTIONS(2470),
    [anon_sym_LT_AT] = ACTIONS(2470),
    [anon_sym_AT_GT] = ACTIONS(2470),
    [anon_sym_LT_AT_AT] = ACTIONS(2470),
    [anon_sym_DOT] = ACTIONS(2470),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2472),
    [anon_sym_new] = ACTIONS(2470),
    [anon_sym_return_BANG] = ACTIONS(2472),
    [anon_sym_yield] = ACTIONS(2470),
    [anon_sym_yield_BANG] = ACTIONS(2472),
    [anon_sym_lazy] = ACTIONS(2470),
    [anon_sym_assert] = ACTIONS(2470),
    [anon_sym_upcast] = ACTIONS(2470),
    [anon_sym_downcast] = ACTIONS(2470),
    [anon_sym_COLON_GT] = ACTIONS(2472),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2472),
    [anon_sym_for] = ACTIONS(2470),
    [anon_sym_while] = ACTIONS(2470),
    [anon_sym_if] = ACTIONS(2470),
    [anon_sym_fun] = ACTIONS(2470),
    [anon_sym_DASH_GT] = ACTIONS(2470),
    [anon_sym_try] = ACTIONS(2470),
    [anon_sym_match] = ACTIONS(2470),
    [anon_sym_match_BANG] = ACTIONS(2472),
    [anon_sym_function] = ACTIONS(2470),
    [anon_sym_LT_DASH] = ACTIONS(2470),
    [anon_sym_DOT_LBRACK] = ACTIONS(2472),
    [anon_sym_LT] = ACTIONS(2472),
    [anon_sym_use] = ACTIONS(2470),
    [anon_sym_use_BANG] = ACTIONS(2472),
    [anon_sym_do_BANG] = ACTIONS(2472),
    [anon_sym_begin] = ACTIONS(2470),
    [anon_sym_LPAREN2] = ACTIONS(2470),
    [anon_sym_STAR] = ACTIONS(2470),
    [anon_sym_LT2] = ACTIONS(2470),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2472),
    [anon_sym_or] = ACTIONS(2470),
    [aux_sym_char_token1] = ACTIONS(2472),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2470),
    [anon_sym_DQUOTE] = ACTIONS(2470),
    [anon_sym_AT_DQUOTE] = ACTIONS(2472),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2472),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2472),
    [sym_bool] = ACTIONS(2470),
    [sym_unit] = ACTIONS(2472),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2470),
    [sym_op_identifier] = ACTIONS(2470),
    [anon_sym_PLUS] = ACTIONS(2470),
    [anon_sym_DASH] = ACTIONS(2470),
    [anon_sym_PLUS_DOT] = ACTIONS(2470),
    [anon_sym_DASH_DOT] = ACTIONS(2470),
    [anon_sym_PERCENT] = ACTIONS(2470),
    [anon_sym_AMP_AMP] = ACTIONS(2470),
    [anon_sym_TILDE] = ACTIONS(2472),
    [aux_sym_prefix_op_token1] = ACTIONS(2470),
    [aux_sym_infix_op_token1] = ACTIONS(2472),
    [aux_sym_infix_op_token2] = ACTIONS(2470),
    [anon_sym_PIPE_PIPE] = ACTIONS(2470),
    [anon_sym_BANG_EQ] = ACTIONS(2470),
    [anon_sym_COLON_EQ] = ACTIONS(2472),
    [anon_sym_DOLLAR] = ACTIONS(2470),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2470),
    [sym_int] = ACTIONS(2470),
    [sym_xint] = ACTIONS(2472),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2472),
    [sym__newline] = ACTIONS(2472),
  },
  [1354] = {
    [sym_block_comment] = STATE(1354),
    [sym_compiler_directive_decl] = STATE(1354),
    [sym_fsi_directive_decl] = STATE(1354),
    [sym_preproc_line] = STATE(1354),
    [sym_identifier] = ACTIONS(2411),
    [anon_sym_EQ] = ACTIONS(2413),
    [anon_sym_COLON] = ACTIONS(2411),
    [anon_sym_return] = ACTIONS(2411),
    [anon_sym_do] = ACTIONS(2411),
    [anon_sym_let] = ACTIONS(2411),
    [anon_sym_let_BANG] = ACTIONS(2413),
    [anon_sym_LPAREN] = ACTIONS(2411),
    [anon_sym_COMMA] = ACTIONS(2413),
    [anon_sym_null] = ACTIONS(2411),
    [anon_sym_QMARK] = ACTIONS(2411),
    [anon_sym_COLON_QMARK] = ACTIONS(2411),
    [anon_sym_COLON_COLON] = ACTIONS(2413),
    [anon_sym_AMP] = ACTIONS(2411),
    [anon_sym_LBRACK] = ACTIONS(2411),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2413),
    [anon_sym_LBRACE] = ACTIONS(2411),
    [anon_sym_LT_AT] = ACTIONS(2411),
    [anon_sym_LT_AT_AT] = ACTIONS(2411),
    [anon_sym_DOT] = ACTIONS(2411),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2413),
    [anon_sym_new] = ACTIONS(2411),
    [anon_sym_return_BANG] = ACTIONS(2413),
    [anon_sym_yield] = ACTIONS(2411),
    [anon_sym_yield_BANG] = ACTIONS(2413),
    [anon_sym_lazy] = ACTIONS(2411),
    [anon_sym_assert] = ACTIONS(2411),
    [anon_sym_upcast] = ACTIONS(2411),
    [anon_sym_downcast] = ACTIONS(2411),
    [anon_sym_COLON_GT] = ACTIONS(2413),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2413),
    [anon_sym_for] = ACTIONS(2411),
    [anon_sym_while] = ACTIONS(2411),
    [anon_sym_if] = ACTIONS(2411),
    [anon_sym_fun] = ACTIONS(2411),
    [anon_sym_DASH_GT] = ACTIONS(2411),
    [anon_sym_try] = ACTIONS(2411),
    [anon_sym_match] = ACTIONS(2411),
    [anon_sym_match_BANG] = ACTIONS(2413),
    [anon_sym_function] = ACTIONS(2411),
    [anon_sym_LT_DASH] = ACTIONS(2411),
    [anon_sym_DOT_LBRACK] = ACTIONS(2413),
    [anon_sym_LT] = ACTIONS(2413),
    [anon_sym_use] = ACTIONS(2411),
    [anon_sym_use_BANG] = ACTIONS(2413),
    [anon_sym_do_BANG] = ACTIONS(2413),
    [anon_sym_begin] = ACTIONS(2411),
    [anon_sym_LPAREN2] = ACTIONS(2411),
    [anon_sym_STAR] = ACTIONS(2411),
    [anon_sym_LT2] = ACTIONS(2411),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2413),
    [anon_sym_or] = ACTIONS(2411),
    [aux_sym_char_token1] = ACTIONS(2413),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2411),
    [anon_sym_DQUOTE] = ACTIONS(2411),
    [anon_sym_AT_DQUOTE] = ACTIONS(2413),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2413),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2413),
    [sym_bool] = ACTIONS(2411),
    [sym_unit] = ACTIONS(2413),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2411),
    [sym_op_identifier] = ACTIONS(2411),
    [anon_sym_PLUS] = ACTIONS(2411),
    [anon_sym_DASH] = ACTIONS(2411),
    [anon_sym_PLUS_DOT] = ACTIONS(2411),
    [anon_sym_DASH_DOT] = ACTIONS(2411),
    [anon_sym_PERCENT] = ACTIONS(2411),
    [anon_sym_AMP_AMP] = ACTIONS(2411),
    [anon_sym_TILDE] = ACTIONS(2413),
    [aux_sym_prefix_op_token1] = ACTIONS(2411),
    [aux_sym_infix_op_token1] = ACTIONS(2413),
    [aux_sym_infix_op_token2] = ACTIONS(2411),
    [anon_sym_PIPE_PIPE] = ACTIONS(2411),
    [anon_sym_BANG_EQ] = ACTIONS(2411),
    [anon_sym_COLON_EQ] = ACTIONS(2413),
    [anon_sym_DOLLAR] = ACTIONS(2411),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2411),
    [sym_int] = ACTIONS(2411),
    [sym_xint] = ACTIONS(2413),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2413),
    [anon_sym_POUNDendif] = ACTIONS(2413),
    [sym__newline] = ACTIONS(2413),
  },
  [1355] = {
    [sym_block_comment] = STATE(1355),
    [sym_compiler_directive_decl] = STATE(1355),
    [sym_fsi_directive_decl] = STATE(1355),
    [sym_preproc_line] = STATE(1355),
    [aux_sym_rules_repeat1] = STATE(1340),
    [sym_identifier] = ACTIONS(2689),
    [anon_sym_EQ] = ACTIONS(2691),
    [anon_sym_COLON] = ACTIONS(2689),
    [anon_sym_return] = ACTIONS(2689),
    [anon_sym_do] = ACTIONS(2689),
    [anon_sym_let] = ACTIONS(2689),
    [anon_sym_let_BANG] = ACTIONS(2691),
    [anon_sym_as] = ACTIONS(2689),
    [anon_sym_LPAREN] = ACTIONS(2689),
    [anon_sym_COMMA] = ACTIONS(2691),
    [anon_sym_null] = ACTIONS(2689),
    [anon_sym_QMARK] = ACTIONS(2689),
    [anon_sym_COLON_QMARK] = ACTIONS(2689),
    [anon_sym_COLON_COLON] = ACTIONS(2691),
    [anon_sym_PIPE] = ACTIONS(3485),
    [anon_sym_AMP] = ACTIONS(2689),
    [anon_sym_LBRACK] = ACTIONS(2689),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2691),
    [anon_sym_LBRACE] = ACTIONS(2689),
    [anon_sym_LT_AT] = ACTIONS(2689),
    [anon_sym_LT_AT_AT] = ACTIONS(2689),
    [anon_sym_DOT] = ACTIONS(2689),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2691),
    [anon_sym_new] = ACTIONS(2689),
    [anon_sym_with] = ACTIONS(2689),
    [anon_sym_return_BANG] = ACTIONS(2691),
    [anon_sym_yield] = ACTIONS(2689),
    [anon_sym_yield_BANG] = ACTIONS(2691),
    [anon_sym_lazy] = ACTIONS(2689),
    [anon_sym_assert] = ACTIONS(2689),
    [anon_sym_upcast] = ACTIONS(2689),
    [anon_sym_downcast] = ACTIONS(2689),
    [anon_sym_COLON_GT] = ACTIONS(2691),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2691),
    [anon_sym_for] = ACTIONS(2689),
    [anon_sym_while] = ACTIONS(2689),
    [anon_sym_if] = ACTIONS(2689),
    [anon_sym_fun] = ACTIONS(2689),
    [anon_sym_try] = ACTIONS(2689),
    [anon_sym_match] = ACTIONS(2689),
    [anon_sym_match_BANG] = ACTIONS(2691),
    [anon_sym_function] = ACTIONS(2689),
    [anon_sym_LT_DASH] = ACTIONS(2689),
    [anon_sym_DOT_LBRACK] = ACTIONS(2691),
    [anon_sym_LT] = ACTIONS(2691),
    [anon_sym_use] = ACTIONS(2689),
    [anon_sym_use_BANG] = ACTIONS(2691),
    [anon_sym_do_BANG] = ACTIONS(2691),
    [anon_sym_begin] = ACTIONS(2689),
    [anon_sym_LPAREN2] = ACTIONS(2689),
    [anon_sym_or] = ACTIONS(2689),
    [aux_sym_char_token1] = ACTIONS(2691),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2689),
    [anon_sym_DQUOTE] = ACTIONS(2689),
    [anon_sym_AT_DQUOTE] = ACTIONS(2691),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2691),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2691),
    [sym_bool] = ACTIONS(2689),
    [sym_unit] = ACTIONS(2691),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2689),
    [sym_op_identifier] = ACTIONS(2689),
    [anon_sym_PLUS] = ACTIONS(2689),
    [anon_sym_DASH] = ACTIONS(2689),
    [anon_sym_PLUS_DOT] = ACTIONS(2689),
    [anon_sym_DASH_DOT] = ACTIONS(2689),
    [anon_sym_PERCENT] = ACTIONS(2689),
    [anon_sym_AMP_AMP] = ACTIONS(2689),
    [anon_sym_TILDE] = ACTIONS(2691),
    [aux_sym_prefix_op_token1] = ACTIONS(2689),
    [aux_sym_infix_op_token1] = ACTIONS(2691),
    [aux_sym_infix_op_token2] = ACTIONS(2689),
    [anon_sym_PIPE_PIPE] = ACTIONS(2689),
    [anon_sym_BANG_EQ] = ACTIONS(2689),
    [anon_sym_COLON_EQ] = ACTIONS(2691),
    [anon_sym_DOLLAR] = ACTIONS(2689),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2689),
    [sym_int] = ACTIONS(2689),
    [sym_xint] = ACTIONS(2691),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2691),
    [sym__newline] = ACTIONS(3511),
    [sym__dedent] = ACTIONS(2691),
  },
  [1356] = {
    [sym_block_comment] = STATE(1356),
    [sym_compiler_directive_decl] = STATE(1356),
    [sym_fsi_directive_decl] = STATE(1356),
    [sym_preproc_line] = STATE(1356),
    [sym_identifier] = ACTIONS(2563),
    [anon_sym_EQ] = ACTIONS(2565),
    [anon_sym_COLON] = ACTIONS(2563),
    [anon_sym_return] = ACTIONS(2563),
    [anon_sym_do] = ACTIONS(2563),
    [anon_sym_let] = ACTIONS(2563),
    [anon_sym_let_BANG] = ACTIONS(2565),
    [anon_sym_LPAREN] = ACTIONS(2563),
    [anon_sym_COMMA] = ACTIONS(2565),
    [anon_sym_null] = ACTIONS(2563),
    [anon_sym_QMARK] = ACTIONS(2563),
    [anon_sym_COLON_QMARK] = ACTIONS(2563),
    [anon_sym_COLON_COLON] = ACTIONS(2565),
    [anon_sym_AMP] = ACTIONS(2563),
    [anon_sym_LBRACK] = ACTIONS(2563),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2565),
    [anon_sym_LBRACE] = ACTIONS(2563),
    [anon_sym_LT_AT] = ACTIONS(2563),
    [anon_sym_LT_AT_AT] = ACTIONS(2563),
    [anon_sym_AT_AT_GT] = ACTIONS(2563),
    [anon_sym_DOT] = ACTIONS(2563),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2565),
    [anon_sym_new] = ACTIONS(2563),
    [anon_sym_return_BANG] = ACTIONS(2565),
    [anon_sym_yield] = ACTIONS(2563),
    [anon_sym_yield_BANG] = ACTIONS(2565),
    [anon_sym_lazy] = ACTIONS(2563),
    [anon_sym_assert] = ACTIONS(2563),
    [anon_sym_upcast] = ACTIONS(2563),
    [anon_sym_downcast] = ACTIONS(2563),
    [anon_sym_COLON_GT] = ACTIONS(2565),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2565),
    [anon_sym_for] = ACTIONS(2563),
    [anon_sym_while] = ACTIONS(2563),
    [anon_sym_if] = ACTIONS(2563),
    [anon_sym_fun] = ACTIONS(2563),
    [anon_sym_DASH_GT] = ACTIONS(2563),
    [anon_sym_try] = ACTIONS(2563),
    [anon_sym_match] = ACTIONS(2563),
    [anon_sym_match_BANG] = ACTIONS(2565),
    [anon_sym_function] = ACTIONS(2563),
    [anon_sym_LT_DASH] = ACTIONS(2563),
    [anon_sym_DOT_LBRACK] = ACTIONS(2565),
    [anon_sym_LT] = ACTIONS(2565),
    [anon_sym_use] = ACTIONS(2563),
    [anon_sym_use_BANG] = ACTIONS(2565),
    [anon_sym_do_BANG] = ACTIONS(2565),
    [anon_sym_begin] = ACTIONS(2563),
    [anon_sym_LPAREN2] = ACTIONS(2563),
    [anon_sym_STAR] = ACTIONS(2563),
    [anon_sym_LT2] = ACTIONS(2563),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2565),
    [anon_sym_or] = ACTIONS(2563),
    [aux_sym_char_token1] = ACTIONS(2565),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2563),
    [anon_sym_DQUOTE] = ACTIONS(2563),
    [anon_sym_AT_DQUOTE] = ACTIONS(2565),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2565),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2565),
    [sym_bool] = ACTIONS(2563),
    [sym_unit] = ACTIONS(2565),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2563),
    [sym_op_identifier] = ACTIONS(2563),
    [anon_sym_PLUS] = ACTIONS(2563),
    [anon_sym_DASH] = ACTIONS(2563),
    [anon_sym_PLUS_DOT] = ACTIONS(2563),
    [anon_sym_DASH_DOT] = ACTIONS(2563),
    [anon_sym_PERCENT] = ACTIONS(2563),
    [anon_sym_AMP_AMP] = ACTIONS(2563),
    [anon_sym_TILDE] = ACTIONS(2565),
    [aux_sym_prefix_op_token1] = ACTIONS(2563),
    [aux_sym_infix_op_token1] = ACTIONS(2565),
    [aux_sym_infix_op_token2] = ACTIONS(2563),
    [anon_sym_PIPE_PIPE] = ACTIONS(2563),
    [anon_sym_BANG_EQ] = ACTIONS(2563),
    [anon_sym_COLON_EQ] = ACTIONS(2565),
    [anon_sym_DOLLAR] = ACTIONS(2563),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2563),
    [sym_int] = ACTIONS(2563),
    [sym_xint] = ACTIONS(2565),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2565),
    [sym__newline] = ACTIONS(2565),
  },
  [1357] = {
    [sym_block_comment] = STATE(1357),
    [sym_compiler_directive_decl] = STATE(1357),
    [sym_fsi_directive_decl] = STATE(1357),
    [sym_preproc_line] = STATE(1357),
    [sym_identifier] = ACTIONS(2462),
    [anon_sym_EQ] = ACTIONS(2464),
    [anon_sym_COLON] = ACTIONS(2462),
    [anon_sym_return] = ACTIONS(2462),
    [anon_sym_do] = ACTIONS(2462),
    [anon_sym_let] = ACTIONS(2462),
    [anon_sym_let_BANG] = ACTIONS(2464),
    [anon_sym_LPAREN] = ACTIONS(2462),
    [anon_sym_COMMA] = ACTIONS(2464),
    [anon_sym_null] = ACTIONS(2462),
    [anon_sym_QMARK] = ACTIONS(2462),
    [anon_sym_COLON_QMARK] = ACTIONS(2462),
    [anon_sym_COLON_COLON] = ACTIONS(2464),
    [anon_sym_AMP] = ACTIONS(2462),
    [anon_sym_LBRACK] = ACTIONS(2462),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2464),
    [anon_sym_LBRACE] = ACTIONS(2462),
    [anon_sym_LT_AT] = ACTIONS(2462),
    [anon_sym_LT_AT_AT] = ACTIONS(2462),
    [anon_sym_DOT] = ACTIONS(2462),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2464),
    [anon_sym_new] = ACTIONS(2462),
    [anon_sym_return_BANG] = ACTIONS(2464),
    [anon_sym_yield] = ACTIONS(2462),
    [anon_sym_yield_BANG] = ACTIONS(2464),
    [anon_sym_lazy] = ACTIONS(2462),
    [anon_sym_assert] = ACTIONS(2462),
    [anon_sym_upcast] = ACTIONS(2462),
    [anon_sym_downcast] = ACTIONS(2462),
    [anon_sym_COLON_GT] = ACTIONS(2464),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2464),
    [anon_sym_for] = ACTIONS(2462),
    [anon_sym_while] = ACTIONS(2462),
    [anon_sym_if] = ACTIONS(2462),
    [anon_sym_fun] = ACTIONS(2462),
    [anon_sym_DASH_GT] = ACTIONS(2462),
    [anon_sym_try] = ACTIONS(2462),
    [anon_sym_match] = ACTIONS(2462),
    [anon_sym_match_BANG] = ACTIONS(2464),
    [anon_sym_function] = ACTIONS(2462),
    [anon_sym_LT_DASH] = ACTIONS(2462),
    [anon_sym_DOT_LBRACK] = ACTIONS(2464),
    [anon_sym_LT] = ACTIONS(2464),
    [anon_sym_use] = ACTIONS(2462),
    [anon_sym_use_BANG] = ACTIONS(2464),
    [anon_sym_do_BANG] = ACTIONS(2464),
    [anon_sym_DOT_DOT] = ACTIONS(2464),
    [anon_sym_begin] = ACTIONS(2462),
    [anon_sym_LPAREN2] = ACTIONS(2462),
    [anon_sym_STAR] = ACTIONS(2462),
    [anon_sym_LT2] = ACTIONS(2462),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2464),
    [anon_sym_or] = ACTIONS(2462),
    [aux_sym_char_token1] = ACTIONS(2464),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2462),
    [anon_sym_DQUOTE] = ACTIONS(2462),
    [anon_sym_AT_DQUOTE] = ACTIONS(2464),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2464),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2464),
    [sym_bool] = ACTIONS(2462),
    [sym_unit] = ACTIONS(2464),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2462),
    [sym_op_identifier] = ACTIONS(2462),
    [anon_sym_PLUS] = ACTIONS(2462),
    [anon_sym_DASH] = ACTIONS(2462),
    [anon_sym_PLUS_DOT] = ACTIONS(2462),
    [anon_sym_DASH_DOT] = ACTIONS(2462),
    [anon_sym_PERCENT] = ACTIONS(2462),
    [anon_sym_AMP_AMP] = ACTIONS(2462),
    [anon_sym_TILDE] = ACTIONS(2464),
    [aux_sym_prefix_op_token1] = ACTIONS(2462),
    [aux_sym_infix_op_token1] = ACTIONS(2464),
    [aux_sym_infix_op_token2] = ACTIONS(2462),
    [anon_sym_PIPE_PIPE] = ACTIONS(2462),
    [anon_sym_BANG_EQ] = ACTIONS(2462),
    [anon_sym_COLON_EQ] = ACTIONS(2464),
    [anon_sym_DOLLAR] = ACTIONS(2462),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2462),
    [sym_int] = ACTIONS(2462),
    [sym_xint] = ACTIONS(2464),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2464),
    [sym__newline] = ACTIONS(2464),
  },
  [1358] = {
    [sym_block_comment] = STATE(1358),
    [sym_compiler_directive_decl] = STATE(1358),
    [sym_fsi_directive_decl] = STATE(1358),
    [sym_preproc_line] = STATE(1358),
    [sym_identifier] = ACTIONS(2514),
    [anon_sym_EQ] = ACTIONS(2516),
    [anon_sym_COLON] = ACTIONS(2514),
    [anon_sym_return] = ACTIONS(2514),
    [anon_sym_do] = ACTIONS(2514),
    [anon_sym_let] = ACTIONS(2514),
    [anon_sym_let_BANG] = ACTIONS(2516),
    [anon_sym_LPAREN] = ACTIONS(2514),
    [anon_sym_COMMA] = ACTIONS(2516),
    [anon_sym_null] = ACTIONS(2514),
    [anon_sym_QMARK] = ACTIONS(2514),
    [anon_sym_COLON_QMARK] = ACTIONS(2514),
    [anon_sym_COLON_COLON] = ACTIONS(2516),
    [anon_sym_AMP] = ACTIONS(2514),
    [anon_sym_LBRACK] = ACTIONS(2514),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2516),
    [anon_sym_LBRACE] = ACTIONS(2514),
    [anon_sym_LT_AT] = ACTIONS(2514),
    [anon_sym_LT_AT_AT] = ACTIONS(2514),
    [anon_sym_DOT] = ACTIONS(2514),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2516),
    [anon_sym_new] = ACTIONS(2514),
    [anon_sym_return_BANG] = ACTIONS(2516),
    [anon_sym_yield] = ACTIONS(2514),
    [anon_sym_yield_BANG] = ACTIONS(2516),
    [anon_sym_lazy] = ACTIONS(2514),
    [anon_sym_assert] = ACTIONS(2514),
    [anon_sym_upcast] = ACTIONS(2514),
    [anon_sym_downcast] = ACTIONS(2514),
    [anon_sym_COLON_GT] = ACTIONS(2516),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2516),
    [anon_sym_for] = ACTIONS(2514),
    [anon_sym_while] = ACTIONS(2514),
    [anon_sym_if] = ACTIONS(2514),
    [anon_sym_fun] = ACTIONS(2514),
    [anon_sym_DASH_GT] = ACTIONS(2514),
    [anon_sym_try] = ACTIONS(2514),
    [anon_sym_match] = ACTIONS(2514),
    [anon_sym_match_BANG] = ACTIONS(2516),
    [anon_sym_function] = ACTIONS(2514),
    [anon_sym_LT_DASH] = ACTIONS(2514),
    [anon_sym_DOT_LBRACK] = ACTIONS(2516),
    [anon_sym_LT] = ACTIONS(2516),
    [anon_sym_use] = ACTIONS(2514),
    [anon_sym_use_BANG] = ACTIONS(2516),
    [anon_sym_do_BANG] = ACTIONS(2516),
    [anon_sym_DOT_DOT] = ACTIONS(2516),
    [anon_sym_begin] = ACTIONS(2514),
    [anon_sym_LPAREN2] = ACTIONS(2514),
    [anon_sym_STAR] = ACTIONS(2514),
    [anon_sym_LT2] = ACTIONS(2514),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2516),
    [anon_sym_or] = ACTIONS(2514),
    [aux_sym_char_token1] = ACTIONS(2516),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2514),
    [anon_sym_DQUOTE] = ACTIONS(2514),
    [anon_sym_AT_DQUOTE] = ACTIONS(2516),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2516),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2516),
    [sym_bool] = ACTIONS(2514),
    [sym_unit] = ACTIONS(2516),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2514),
    [sym_op_identifier] = ACTIONS(2514),
    [anon_sym_PLUS] = ACTIONS(2514),
    [anon_sym_DASH] = ACTIONS(2514),
    [anon_sym_PLUS_DOT] = ACTIONS(2514),
    [anon_sym_DASH_DOT] = ACTIONS(2514),
    [anon_sym_PERCENT] = ACTIONS(2514),
    [anon_sym_AMP_AMP] = ACTIONS(2514),
    [anon_sym_TILDE] = ACTIONS(2516),
    [aux_sym_prefix_op_token1] = ACTIONS(2514),
    [aux_sym_infix_op_token1] = ACTIONS(2516),
    [aux_sym_infix_op_token2] = ACTIONS(2514),
    [anon_sym_PIPE_PIPE] = ACTIONS(2514),
    [anon_sym_BANG_EQ] = ACTIONS(2514),
    [anon_sym_COLON_EQ] = ACTIONS(2516),
    [anon_sym_DOLLAR] = ACTIONS(2514),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2514),
    [sym_int] = ACTIONS(2514),
    [sym_xint] = ACTIONS(2516),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2516),
    [sym__newline] = ACTIONS(2516),
  },
  [1359] = {
    [sym_block_comment] = STATE(1359),
    [sym_compiler_directive_decl] = STATE(1359),
    [sym_fsi_directive_decl] = STATE(1359),
    [sym_preproc_line] = STATE(1359),
    [sym_identifier] = ACTIONS(2563),
    [anon_sym_EQ] = ACTIONS(2565),
    [anon_sym_COLON] = ACTIONS(2563),
    [anon_sym_return] = ACTIONS(2563),
    [anon_sym_do] = ACTIONS(2563),
    [anon_sym_let] = ACTIONS(2563),
    [anon_sym_let_BANG] = ACTIONS(2565),
    [anon_sym_LPAREN] = ACTIONS(2563),
    [anon_sym_COMMA] = ACTIONS(2565),
    [anon_sym_null] = ACTIONS(2563),
    [anon_sym_QMARK] = ACTIONS(2563),
    [anon_sym_COLON_QMARK] = ACTIONS(2563),
    [anon_sym_COLON_COLON] = ACTIONS(2565),
    [anon_sym_AMP] = ACTIONS(2563),
    [anon_sym_LBRACK] = ACTIONS(2563),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2565),
    [anon_sym_LBRACE] = ACTIONS(2563),
    [anon_sym_LT_AT] = ACTIONS(2563),
    [anon_sym_LT_AT_AT] = ACTIONS(2563),
    [anon_sym_DOT] = ACTIONS(2563),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2565),
    [anon_sym_new] = ACTIONS(2563),
    [anon_sym_return_BANG] = ACTIONS(2565),
    [anon_sym_yield] = ACTIONS(2563),
    [anon_sym_yield_BANG] = ACTIONS(2565),
    [anon_sym_lazy] = ACTIONS(2563),
    [anon_sym_assert] = ACTIONS(2563),
    [anon_sym_upcast] = ACTIONS(2563),
    [anon_sym_downcast] = ACTIONS(2563),
    [anon_sym_COLON_GT] = ACTIONS(2565),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2565),
    [anon_sym_for] = ACTIONS(2563),
    [anon_sym_while] = ACTIONS(2563),
    [anon_sym_if] = ACTIONS(2563),
    [anon_sym_fun] = ACTIONS(2563),
    [anon_sym_DASH_GT] = ACTIONS(2563),
    [anon_sym_try] = ACTIONS(2563),
    [anon_sym_match] = ACTIONS(2563),
    [anon_sym_match_BANG] = ACTIONS(2565),
    [anon_sym_function] = ACTIONS(2563),
    [anon_sym_LT_DASH] = ACTIONS(2563),
    [anon_sym_DOT_LBRACK] = ACTIONS(2565),
    [anon_sym_LT] = ACTIONS(2565),
    [anon_sym_use] = ACTIONS(2563),
    [anon_sym_use_BANG] = ACTIONS(2565),
    [anon_sym_do_BANG] = ACTIONS(2565),
    [anon_sym_DOT_DOT] = ACTIONS(2565),
    [anon_sym_begin] = ACTIONS(2563),
    [anon_sym_LPAREN2] = ACTIONS(2563),
    [anon_sym_STAR] = ACTIONS(2563),
    [anon_sym_LT2] = ACTIONS(2563),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2565),
    [anon_sym_or] = ACTIONS(2563),
    [aux_sym_char_token1] = ACTIONS(2565),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2563),
    [anon_sym_DQUOTE] = ACTIONS(2563),
    [anon_sym_AT_DQUOTE] = ACTIONS(2565),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2565),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2565),
    [sym_bool] = ACTIONS(2563),
    [sym_unit] = ACTIONS(2565),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2563),
    [sym_op_identifier] = ACTIONS(2563),
    [anon_sym_PLUS] = ACTIONS(2563),
    [anon_sym_DASH] = ACTIONS(2563),
    [anon_sym_PLUS_DOT] = ACTIONS(2563),
    [anon_sym_DASH_DOT] = ACTIONS(2563),
    [anon_sym_PERCENT] = ACTIONS(2563),
    [anon_sym_AMP_AMP] = ACTIONS(2563),
    [anon_sym_TILDE] = ACTIONS(2565),
    [aux_sym_prefix_op_token1] = ACTIONS(2563),
    [aux_sym_infix_op_token1] = ACTIONS(2565),
    [aux_sym_infix_op_token2] = ACTIONS(2563),
    [anon_sym_PIPE_PIPE] = ACTIONS(2563),
    [anon_sym_BANG_EQ] = ACTIONS(2563),
    [anon_sym_COLON_EQ] = ACTIONS(2565),
    [anon_sym_DOLLAR] = ACTIONS(2563),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2563),
    [sym_int] = ACTIONS(2563),
    [sym_xint] = ACTIONS(2565),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2565),
    [sym__newline] = ACTIONS(2565),
  },
  [1360] = {
    [sym_block_comment] = STATE(1360),
    [sym_compiler_directive_decl] = STATE(1360),
    [sym_fsi_directive_decl] = STATE(1360),
    [sym_preproc_line] = STATE(1360),
    [sym_identifier] = ACTIONS(2340),
    [anon_sym_EQ] = ACTIONS(2342),
    [anon_sym_COLON] = ACTIONS(2340),
    [anon_sym_return] = ACTIONS(2340),
    [anon_sym_do] = ACTIONS(2340),
    [anon_sym_let] = ACTIONS(2340),
    [anon_sym_let_BANG] = ACTIONS(2342),
    [anon_sym_LPAREN] = ACTIONS(2340),
    [anon_sym_COMMA] = ACTIONS(2342),
    [anon_sym_null] = ACTIONS(2340),
    [anon_sym_QMARK] = ACTIONS(2340),
    [anon_sym_COLON_QMARK] = ACTIONS(2340),
    [anon_sym_COLON_COLON] = ACTIONS(2342),
    [anon_sym_AMP] = ACTIONS(2340),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2342),
    [anon_sym_LBRACE] = ACTIONS(2340),
    [anon_sym_LT_AT] = ACTIONS(2340),
    [anon_sym_LT_AT_AT] = ACTIONS(2340),
    [anon_sym_DOT] = ACTIONS(2340),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2342),
    [anon_sym_new] = ACTIONS(2340),
    [anon_sym_return_BANG] = ACTIONS(2342),
    [anon_sym_yield] = ACTIONS(2340),
    [anon_sym_yield_BANG] = ACTIONS(2342),
    [anon_sym_lazy] = ACTIONS(2340),
    [anon_sym_assert] = ACTIONS(2340),
    [anon_sym_upcast] = ACTIONS(2340),
    [anon_sym_downcast] = ACTIONS(2340),
    [anon_sym_COLON_GT] = ACTIONS(2342),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2342),
    [anon_sym_for] = ACTIONS(2340),
    [anon_sym_while] = ACTIONS(2340),
    [anon_sym_if] = ACTIONS(2340),
    [anon_sym_fun] = ACTIONS(2340),
    [anon_sym_DASH_GT] = ACTIONS(2340),
    [anon_sym_try] = ACTIONS(2340),
    [anon_sym_match] = ACTIONS(2340),
    [anon_sym_match_BANG] = ACTIONS(2342),
    [anon_sym_function] = ACTIONS(2340),
    [anon_sym_LT_DASH] = ACTIONS(2340),
    [anon_sym_DOT_LBRACK] = ACTIONS(2342),
    [anon_sym_LT] = ACTIONS(2342),
    [anon_sym_use] = ACTIONS(2340),
    [anon_sym_use_BANG] = ACTIONS(2342),
    [anon_sym_do_BANG] = ACTIONS(2342),
    [anon_sym_begin] = ACTIONS(2340),
    [anon_sym_LPAREN2] = ACTIONS(2340),
    [anon_sym_STAR] = ACTIONS(2340),
    [anon_sym_LT2] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2342),
    [anon_sym_or] = ACTIONS(2340),
    [aux_sym_char_token1] = ACTIONS(2342),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2340),
    [anon_sym_DQUOTE] = ACTIONS(2340),
    [anon_sym_AT_DQUOTE] = ACTIONS(2342),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2342),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2342),
    [sym_bool] = ACTIONS(2340),
    [sym_unit] = ACTIONS(2342),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2340),
    [sym_op_identifier] = ACTIONS(2340),
    [anon_sym_PLUS] = ACTIONS(2340),
    [anon_sym_DASH] = ACTIONS(2340),
    [anon_sym_PLUS_DOT] = ACTIONS(2340),
    [anon_sym_DASH_DOT] = ACTIONS(2340),
    [anon_sym_PERCENT] = ACTIONS(2340),
    [anon_sym_AMP_AMP] = ACTIONS(2340),
    [anon_sym_TILDE] = ACTIONS(2342),
    [aux_sym_prefix_op_token1] = ACTIONS(2340),
    [aux_sym_infix_op_token1] = ACTIONS(2342),
    [aux_sym_infix_op_token2] = ACTIONS(2340),
    [anon_sym_PIPE_PIPE] = ACTIONS(2340),
    [anon_sym_BANG_EQ] = ACTIONS(2340),
    [anon_sym_COLON_EQ] = ACTIONS(2342),
    [anon_sym_DOLLAR] = ACTIONS(2340),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2340),
    [sym_int] = ACTIONS(2340),
    [sym_xint] = ACTIONS(2342),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2342),
    [anon_sym_POUNDendif] = ACTIONS(2342),
    [sym__newline] = ACTIONS(2342),
  },
  [1361] = {
    [sym_block_comment] = STATE(1361),
    [sym_compiler_directive_decl] = STATE(1361),
    [sym_fsi_directive_decl] = STATE(1361),
    [sym_preproc_line] = STATE(1361),
    [sym_identifier] = ACTIONS(2462),
    [anon_sym_EQ] = ACTIONS(2464),
    [anon_sym_COLON] = ACTIONS(2462),
    [anon_sym_return] = ACTIONS(2462),
    [anon_sym_do] = ACTIONS(2462),
    [anon_sym_let] = ACTIONS(2462),
    [anon_sym_let_BANG] = ACTIONS(2464),
    [anon_sym_LPAREN] = ACTIONS(2462),
    [anon_sym_COMMA] = ACTIONS(2464),
    [anon_sym_null] = ACTIONS(2462),
    [anon_sym_QMARK] = ACTIONS(2462),
    [anon_sym_COLON_QMARK] = ACTIONS(2462),
    [anon_sym_COLON_COLON] = ACTIONS(2464),
    [anon_sym_AMP] = ACTIONS(2462),
    [anon_sym_LBRACK] = ACTIONS(2462),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2464),
    [anon_sym_LBRACE] = ACTIONS(2462),
    [anon_sym_LT_AT] = ACTIONS(2462),
    [anon_sym_AT_GT] = ACTIONS(2462),
    [anon_sym_LT_AT_AT] = ACTIONS(2462),
    [anon_sym_DOT] = ACTIONS(2462),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2464),
    [anon_sym_new] = ACTIONS(2462),
    [anon_sym_return_BANG] = ACTIONS(2464),
    [anon_sym_yield] = ACTIONS(2462),
    [anon_sym_yield_BANG] = ACTIONS(2464),
    [anon_sym_lazy] = ACTIONS(2462),
    [anon_sym_assert] = ACTIONS(2462),
    [anon_sym_upcast] = ACTIONS(2462),
    [anon_sym_downcast] = ACTIONS(2462),
    [anon_sym_COLON_GT] = ACTIONS(2464),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2464),
    [anon_sym_for] = ACTIONS(2462),
    [anon_sym_while] = ACTIONS(2462),
    [anon_sym_if] = ACTIONS(2462),
    [anon_sym_fun] = ACTIONS(2462),
    [anon_sym_DASH_GT] = ACTIONS(2462),
    [anon_sym_try] = ACTIONS(2462),
    [anon_sym_match] = ACTIONS(2462),
    [anon_sym_match_BANG] = ACTIONS(2464),
    [anon_sym_function] = ACTIONS(2462),
    [anon_sym_LT_DASH] = ACTIONS(2462),
    [anon_sym_DOT_LBRACK] = ACTIONS(2464),
    [anon_sym_LT] = ACTIONS(2464),
    [anon_sym_use] = ACTIONS(2462),
    [anon_sym_use_BANG] = ACTIONS(2464),
    [anon_sym_do_BANG] = ACTIONS(2464),
    [anon_sym_begin] = ACTIONS(2462),
    [anon_sym_LPAREN2] = ACTIONS(2462),
    [anon_sym_STAR] = ACTIONS(2462),
    [anon_sym_LT2] = ACTIONS(2462),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2464),
    [anon_sym_or] = ACTIONS(2462),
    [aux_sym_char_token1] = ACTIONS(2464),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2462),
    [anon_sym_DQUOTE] = ACTIONS(2462),
    [anon_sym_AT_DQUOTE] = ACTIONS(2464),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2464),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2464),
    [sym_bool] = ACTIONS(2462),
    [sym_unit] = ACTIONS(2464),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2462),
    [sym_op_identifier] = ACTIONS(2462),
    [anon_sym_PLUS] = ACTIONS(2462),
    [anon_sym_DASH] = ACTIONS(2462),
    [anon_sym_PLUS_DOT] = ACTIONS(2462),
    [anon_sym_DASH_DOT] = ACTIONS(2462),
    [anon_sym_PERCENT] = ACTIONS(2462),
    [anon_sym_AMP_AMP] = ACTIONS(2462),
    [anon_sym_TILDE] = ACTIONS(2464),
    [aux_sym_prefix_op_token1] = ACTIONS(2462),
    [aux_sym_infix_op_token1] = ACTIONS(2464),
    [aux_sym_infix_op_token2] = ACTIONS(2462),
    [anon_sym_PIPE_PIPE] = ACTIONS(2462),
    [anon_sym_BANG_EQ] = ACTIONS(2462),
    [anon_sym_COLON_EQ] = ACTIONS(2464),
    [anon_sym_DOLLAR] = ACTIONS(2462),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2462),
    [sym_int] = ACTIONS(2462),
    [sym_xint] = ACTIONS(2464),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2464),
    [sym__newline] = ACTIONS(2464),
  },
  [1362] = {
    [sym_block_comment] = STATE(1362),
    [sym_compiler_directive_decl] = STATE(1362),
    [sym_fsi_directive_decl] = STATE(1362),
    [sym_preproc_line] = STATE(1362),
    [sym_identifier] = ACTIONS(2819),
    [anon_sym_EQ] = ACTIONS(2821),
    [anon_sym_COLON] = ACTIONS(2819),
    [anon_sym_return] = ACTIONS(2819),
    [anon_sym_do] = ACTIONS(2819),
    [anon_sym_let] = ACTIONS(2819),
    [anon_sym_let_BANG] = ACTIONS(2821),
    [anon_sym_as] = ACTIONS(2819),
    [anon_sym_LPAREN] = ACTIONS(2819),
    [anon_sym_COMMA] = ACTIONS(2821),
    [anon_sym_null] = ACTIONS(2819),
    [anon_sym_QMARK] = ACTIONS(2819),
    [anon_sym_COLON_QMARK] = ACTIONS(2819),
    [anon_sym_COLON_COLON] = ACTIONS(2821),
    [anon_sym_AMP] = ACTIONS(2819),
    [anon_sym_LBRACK] = ACTIONS(2819),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2821),
    [anon_sym_LBRACE] = ACTIONS(2819),
    [anon_sym_LT_AT] = ACTIONS(2819),
    [anon_sym_LT_AT_AT] = ACTIONS(2819),
    [anon_sym_DOT] = ACTIONS(2819),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2821),
    [anon_sym_new] = ACTIONS(2819),
    [anon_sym_with] = ACTIONS(2819),
    [anon_sym_return_BANG] = ACTIONS(2821),
    [anon_sym_yield] = ACTIONS(2819),
    [anon_sym_yield_BANG] = ACTIONS(2821),
    [anon_sym_lazy] = ACTIONS(2819),
    [anon_sym_assert] = ACTIONS(2819),
    [anon_sym_upcast] = ACTIONS(2819),
    [anon_sym_downcast] = ACTIONS(2819),
    [anon_sym_COLON_GT] = ACTIONS(2821),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2821),
    [anon_sym_for] = ACTIONS(2819),
    [anon_sym_while] = ACTIONS(2819),
    [anon_sym_if] = ACTIONS(2819),
    [anon_sym_fun] = ACTIONS(2819),
    [anon_sym_try] = ACTIONS(2819),
    [anon_sym_match] = ACTIONS(2819),
    [anon_sym_match_BANG] = ACTIONS(2821),
    [anon_sym_function] = ACTIONS(2819),
    [anon_sym_LT_DASH] = ACTIONS(2819),
    [anon_sym_DOT_LBRACK] = ACTIONS(2821),
    [anon_sym_LT] = ACTIONS(2821),
    [anon_sym_use] = ACTIONS(2819),
    [anon_sym_use_BANG] = ACTIONS(2821),
    [anon_sym_do_BANG] = ACTIONS(2821),
    [anon_sym_begin] = ACTIONS(2819),
    [anon_sym_LPAREN2] = ACTIONS(2819),
    [anon_sym_or] = ACTIONS(2819),
    [aux_sym_char_token1] = ACTIONS(2821),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2819),
    [anon_sym_DQUOTE] = ACTIONS(2819),
    [anon_sym_AT_DQUOTE] = ACTIONS(2821),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2821),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2821),
    [sym_bool] = ACTIONS(2819),
    [sym_unit] = ACTIONS(2821),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2819),
    [sym_op_identifier] = ACTIONS(2819),
    [anon_sym_PLUS] = ACTIONS(2819),
    [anon_sym_DASH] = ACTIONS(2819),
    [anon_sym_PLUS_DOT] = ACTIONS(2819),
    [anon_sym_DASH_DOT] = ACTIONS(2819),
    [anon_sym_PERCENT] = ACTIONS(2819),
    [anon_sym_AMP_AMP] = ACTIONS(2819),
    [anon_sym_TILDE] = ACTIONS(2821),
    [aux_sym_prefix_op_token1] = ACTIONS(2819),
    [aux_sym_infix_op_token1] = ACTIONS(2821),
    [aux_sym_infix_op_token2] = ACTIONS(2819),
    [anon_sym_PIPE_PIPE] = ACTIONS(2819),
    [anon_sym_BANG_EQ] = ACTIONS(2819),
    [anon_sym_COLON_EQ] = ACTIONS(2821),
    [anon_sym_DOLLAR] = ACTIONS(2819),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2819),
    [sym_int] = ACTIONS(3514),
    [sym_xint] = ACTIONS(2821),
    [anon_sym_f] = ACTIONS(2819),
    [aux_sym_decimal_token1] = ACTIONS(2819),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2821),
    [sym__newline] = ACTIONS(2821),
    [sym__dedent] = ACTIONS(2821),
  },
  [1363] = {
    [sym_block_comment] = STATE(1363),
    [sym_compiler_directive_decl] = STATE(1363),
    [sym_fsi_directive_decl] = STATE(1363),
    [sym_preproc_line] = STATE(1363),
    [sym_identifier] = ACTIONS(2553),
    [anon_sym_EQ] = ACTIONS(2555),
    [anon_sym_COLON] = ACTIONS(2553),
    [anon_sym_return] = ACTIONS(2553),
    [anon_sym_do] = ACTIONS(2553),
    [anon_sym_let] = ACTIONS(2553),
    [anon_sym_let_BANG] = ACTIONS(2555),
    [anon_sym_LPAREN] = ACTIONS(2553),
    [anon_sym_COMMA] = ACTIONS(2555),
    [anon_sym_null] = ACTIONS(2553),
    [anon_sym_QMARK] = ACTIONS(2553),
    [anon_sym_COLON_QMARK] = ACTIONS(2553),
    [anon_sym_COLON_COLON] = ACTIONS(2555),
    [anon_sym_AMP] = ACTIONS(2553),
    [anon_sym_LBRACK] = ACTIONS(2553),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2555),
    [anon_sym_LBRACE] = ACTIONS(2553),
    [anon_sym_LT_AT] = ACTIONS(2553),
    [anon_sym_LT_AT_AT] = ACTIONS(2553),
    [anon_sym_DOT] = ACTIONS(2553),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2555),
    [anon_sym_new] = ACTIONS(2553),
    [anon_sym_return_BANG] = ACTIONS(2555),
    [anon_sym_yield] = ACTIONS(2553),
    [anon_sym_yield_BANG] = ACTIONS(2555),
    [anon_sym_lazy] = ACTIONS(2553),
    [anon_sym_assert] = ACTIONS(2553),
    [anon_sym_upcast] = ACTIONS(2553),
    [anon_sym_downcast] = ACTIONS(2553),
    [anon_sym_COLON_GT] = ACTIONS(2555),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2555),
    [anon_sym_for] = ACTIONS(2553),
    [anon_sym_while] = ACTIONS(2553),
    [anon_sym_if] = ACTIONS(2553),
    [anon_sym_fun] = ACTIONS(2553),
    [anon_sym_DASH_GT] = ACTIONS(2553),
    [anon_sym_try] = ACTIONS(2553),
    [anon_sym_match] = ACTIONS(2553),
    [anon_sym_match_BANG] = ACTIONS(2555),
    [anon_sym_function] = ACTIONS(2553),
    [anon_sym_LT_DASH] = ACTIONS(2553),
    [anon_sym_DOT_LBRACK] = ACTIONS(2555),
    [anon_sym_LT] = ACTIONS(2555),
    [anon_sym_use] = ACTIONS(2553),
    [anon_sym_use_BANG] = ACTIONS(2555),
    [anon_sym_do_BANG] = ACTIONS(2555),
    [anon_sym_DOT_DOT] = ACTIONS(2555),
    [anon_sym_begin] = ACTIONS(2553),
    [anon_sym_LPAREN2] = ACTIONS(2553),
    [anon_sym_STAR] = ACTIONS(2553),
    [anon_sym_LT2] = ACTIONS(2553),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2555),
    [anon_sym_or] = ACTIONS(2553),
    [aux_sym_char_token1] = ACTIONS(2555),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2553),
    [anon_sym_DQUOTE] = ACTIONS(2553),
    [anon_sym_AT_DQUOTE] = ACTIONS(2555),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2555),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2555),
    [sym_bool] = ACTIONS(2553),
    [sym_unit] = ACTIONS(2555),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2553),
    [sym_op_identifier] = ACTIONS(2553),
    [anon_sym_PLUS] = ACTIONS(2553),
    [anon_sym_DASH] = ACTIONS(2553),
    [anon_sym_PLUS_DOT] = ACTIONS(2553),
    [anon_sym_DASH_DOT] = ACTIONS(2553),
    [anon_sym_PERCENT] = ACTIONS(2553),
    [anon_sym_AMP_AMP] = ACTIONS(2553),
    [anon_sym_TILDE] = ACTIONS(2555),
    [aux_sym_prefix_op_token1] = ACTIONS(2553),
    [aux_sym_infix_op_token1] = ACTIONS(2555),
    [aux_sym_infix_op_token2] = ACTIONS(2553),
    [anon_sym_PIPE_PIPE] = ACTIONS(2553),
    [anon_sym_BANG_EQ] = ACTIONS(2553),
    [anon_sym_COLON_EQ] = ACTIONS(2555),
    [anon_sym_DOLLAR] = ACTIONS(2553),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2553),
    [sym_int] = ACTIONS(2553),
    [sym_xint] = ACTIONS(2555),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2555),
    [sym__newline] = ACTIONS(2555),
  },
  [1364] = {
    [sym_block_comment] = STATE(1364),
    [sym_compiler_directive_decl] = STATE(1364),
    [sym_fsi_directive_decl] = STATE(1364),
    [sym_preproc_line] = STATE(1364),
    [sym_identifier] = ACTIONS(2321),
    [anon_sym_EQ] = ACTIONS(2323),
    [anon_sym_COLON] = ACTIONS(2321),
    [anon_sym_return] = ACTIONS(2321),
    [anon_sym_do] = ACTIONS(2321),
    [anon_sym_let] = ACTIONS(2321),
    [anon_sym_let_BANG] = ACTIONS(2323),
    [anon_sym_LPAREN] = ACTIONS(2321),
    [anon_sym_COMMA] = ACTIONS(2323),
    [anon_sym_null] = ACTIONS(2321),
    [anon_sym_QMARK] = ACTIONS(2321),
    [anon_sym_COLON_QMARK] = ACTIONS(2321),
    [anon_sym_COLON_COLON] = ACTIONS(2323),
    [anon_sym_AMP] = ACTIONS(2321),
    [anon_sym_LBRACK] = ACTIONS(2321),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2323),
    [anon_sym_LBRACE] = ACTIONS(2321),
    [anon_sym_LT_AT] = ACTIONS(2321),
    [anon_sym_LT_AT_AT] = ACTIONS(2321),
    [anon_sym_DOT] = ACTIONS(2321),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2323),
    [anon_sym_new] = ACTIONS(2321),
    [anon_sym_return_BANG] = ACTIONS(2323),
    [anon_sym_yield] = ACTIONS(2321),
    [anon_sym_yield_BANG] = ACTIONS(2323),
    [anon_sym_lazy] = ACTIONS(2321),
    [anon_sym_assert] = ACTIONS(2321),
    [anon_sym_upcast] = ACTIONS(2321),
    [anon_sym_downcast] = ACTIONS(2321),
    [anon_sym_COLON_GT] = ACTIONS(2323),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2323),
    [anon_sym_for] = ACTIONS(2321),
    [anon_sym_while] = ACTIONS(2321),
    [anon_sym_if] = ACTIONS(2321),
    [anon_sym_fun] = ACTIONS(2321),
    [anon_sym_DASH_GT] = ACTIONS(2321),
    [anon_sym_try] = ACTIONS(2321),
    [anon_sym_match] = ACTIONS(2321),
    [anon_sym_match_BANG] = ACTIONS(2323),
    [anon_sym_function] = ACTIONS(2321),
    [anon_sym_LT_DASH] = ACTIONS(2321),
    [anon_sym_DOT_LBRACK] = ACTIONS(2323),
    [anon_sym_LT] = ACTIONS(2323),
    [anon_sym_use] = ACTIONS(2321),
    [anon_sym_use_BANG] = ACTIONS(2323),
    [anon_sym_do_BANG] = ACTIONS(2323),
    [anon_sym_DOT_DOT] = ACTIONS(2323),
    [anon_sym_begin] = ACTIONS(2321),
    [anon_sym_LPAREN2] = ACTIONS(2321),
    [anon_sym_STAR] = ACTIONS(2321),
    [anon_sym_LT2] = ACTIONS(2321),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2323),
    [anon_sym_or] = ACTIONS(2321),
    [aux_sym_char_token1] = ACTIONS(2323),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2321),
    [anon_sym_DQUOTE] = ACTIONS(2321),
    [anon_sym_AT_DQUOTE] = ACTIONS(2323),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2323),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2323),
    [sym_bool] = ACTIONS(2321),
    [sym_unit] = ACTIONS(2323),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2321),
    [sym_op_identifier] = ACTIONS(2321),
    [anon_sym_PLUS] = ACTIONS(2321),
    [anon_sym_DASH] = ACTIONS(2321),
    [anon_sym_PLUS_DOT] = ACTIONS(2321),
    [anon_sym_DASH_DOT] = ACTIONS(2321),
    [anon_sym_PERCENT] = ACTIONS(2321),
    [anon_sym_AMP_AMP] = ACTIONS(2321),
    [anon_sym_TILDE] = ACTIONS(2323),
    [aux_sym_prefix_op_token1] = ACTIONS(2321),
    [aux_sym_infix_op_token1] = ACTIONS(2323),
    [aux_sym_infix_op_token2] = ACTIONS(2321),
    [anon_sym_PIPE_PIPE] = ACTIONS(2321),
    [anon_sym_BANG_EQ] = ACTIONS(2321),
    [anon_sym_COLON_EQ] = ACTIONS(2323),
    [anon_sym_DOLLAR] = ACTIONS(2321),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2321),
    [sym_int] = ACTIONS(2321),
    [sym_xint] = ACTIONS(2323),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2323),
    [sym__newline] = ACTIONS(2323),
  },
  [1365] = {
    [sym_block_comment] = STATE(1365),
    [sym_compiler_directive_decl] = STATE(1365),
    [sym_fsi_directive_decl] = STATE(1365),
    [sym_preproc_line] = STATE(1365),
    [sym_identifier] = ACTIONS(2567),
    [anon_sym_EQ] = ACTIONS(2569),
    [anon_sym_COLON] = ACTIONS(2567),
    [anon_sym_return] = ACTIONS(2567),
    [anon_sym_do] = ACTIONS(2567),
    [anon_sym_let] = ACTIONS(2567),
    [anon_sym_let_BANG] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2567),
    [anon_sym_COMMA] = ACTIONS(2569),
    [anon_sym_null] = ACTIONS(2567),
    [anon_sym_QMARK] = ACTIONS(2567),
    [anon_sym_COLON_QMARK] = ACTIONS(2567),
    [anon_sym_COLON_COLON] = ACTIONS(2569),
    [anon_sym_AMP] = ACTIONS(2567),
    [anon_sym_LBRACK] = ACTIONS(2567),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2569),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_LT_AT] = ACTIONS(2567),
    [anon_sym_AT_GT] = ACTIONS(2567),
    [anon_sym_LT_AT_AT] = ACTIONS(2567),
    [anon_sym_DOT] = ACTIONS(2567),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2569),
    [anon_sym_new] = ACTIONS(2567),
    [anon_sym_return_BANG] = ACTIONS(2569),
    [anon_sym_yield] = ACTIONS(2567),
    [anon_sym_yield_BANG] = ACTIONS(2569),
    [anon_sym_lazy] = ACTIONS(2567),
    [anon_sym_assert] = ACTIONS(2567),
    [anon_sym_upcast] = ACTIONS(2567),
    [anon_sym_downcast] = ACTIONS(2567),
    [anon_sym_COLON_GT] = ACTIONS(2569),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2569),
    [anon_sym_for] = ACTIONS(2567),
    [anon_sym_while] = ACTIONS(2567),
    [anon_sym_if] = ACTIONS(2567),
    [anon_sym_fun] = ACTIONS(2567),
    [anon_sym_DASH_GT] = ACTIONS(2567),
    [anon_sym_try] = ACTIONS(2567),
    [anon_sym_match] = ACTIONS(2567),
    [anon_sym_match_BANG] = ACTIONS(2569),
    [anon_sym_function] = ACTIONS(2567),
    [anon_sym_LT_DASH] = ACTIONS(2567),
    [anon_sym_DOT_LBRACK] = ACTIONS(2569),
    [anon_sym_LT] = ACTIONS(2569),
    [anon_sym_use] = ACTIONS(2567),
    [anon_sym_use_BANG] = ACTIONS(2569),
    [anon_sym_do_BANG] = ACTIONS(2569),
    [anon_sym_begin] = ACTIONS(2567),
    [anon_sym_LPAREN2] = ACTIONS(2567),
    [anon_sym_STAR] = ACTIONS(2567),
    [anon_sym_LT2] = ACTIONS(2567),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2569),
    [anon_sym_or] = ACTIONS(2567),
    [aux_sym_char_token1] = ACTIONS(2569),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2567),
    [anon_sym_DQUOTE] = ACTIONS(2567),
    [anon_sym_AT_DQUOTE] = ACTIONS(2569),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2569),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2569),
    [sym_bool] = ACTIONS(2567),
    [sym_unit] = ACTIONS(2569),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2567),
    [sym_op_identifier] = ACTIONS(2567),
    [anon_sym_PLUS] = ACTIONS(2567),
    [anon_sym_DASH] = ACTIONS(2567),
    [anon_sym_PLUS_DOT] = ACTIONS(2567),
    [anon_sym_DASH_DOT] = ACTIONS(2567),
    [anon_sym_PERCENT] = ACTIONS(2567),
    [anon_sym_AMP_AMP] = ACTIONS(2567),
    [anon_sym_TILDE] = ACTIONS(2569),
    [aux_sym_prefix_op_token1] = ACTIONS(2567),
    [aux_sym_infix_op_token1] = ACTIONS(2569),
    [aux_sym_infix_op_token2] = ACTIONS(2567),
    [anon_sym_PIPE_PIPE] = ACTIONS(2567),
    [anon_sym_BANG_EQ] = ACTIONS(2567),
    [anon_sym_COLON_EQ] = ACTIONS(2569),
    [anon_sym_DOLLAR] = ACTIONS(2567),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2567),
    [sym_int] = ACTIONS(2567),
    [sym_xint] = ACTIONS(2569),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2569),
    [sym__newline] = ACTIONS(2569),
  },
  [1366] = {
    [sym_block_comment] = STATE(1366),
    [sym_compiler_directive_decl] = STATE(1366),
    [sym_fsi_directive_decl] = STATE(1366),
    [sym_preproc_line] = STATE(1366),
    [sym_identifier] = ACTIONS(2462),
    [anon_sym_EQ] = ACTIONS(2464),
    [anon_sym_COLON] = ACTIONS(2462),
    [anon_sym_return] = ACTIONS(2462),
    [anon_sym_do] = ACTIONS(2462),
    [anon_sym_let] = ACTIONS(2462),
    [anon_sym_let_BANG] = ACTIONS(2464),
    [anon_sym_LPAREN] = ACTIONS(2462),
    [anon_sym_COMMA] = ACTIONS(2464),
    [anon_sym_null] = ACTIONS(2462),
    [anon_sym_QMARK] = ACTIONS(2462),
    [anon_sym_COLON_QMARK] = ACTIONS(2462),
    [anon_sym_COLON_COLON] = ACTIONS(2464),
    [anon_sym_AMP] = ACTIONS(2462),
    [anon_sym_LBRACK] = ACTIONS(2462),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2464),
    [anon_sym_LBRACE] = ACTIONS(2462),
    [anon_sym_LT_AT] = ACTIONS(2462),
    [anon_sym_LT_AT_AT] = ACTIONS(2462),
    [anon_sym_DOT] = ACTIONS(2462),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2464),
    [anon_sym_new] = ACTIONS(2462),
    [anon_sym_return_BANG] = ACTIONS(2464),
    [anon_sym_yield] = ACTIONS(2462),
    [anon_sym_yield_BANG] = ACTIONS(2464),
    [anon_sym_lazy] = ACTIONS(2462),
    [anon_sym_assert] = ACTIONS(2462),
    [anon_sym_upcast] = ACTIONS(2462),
    [anon_sym_downcast] = ACTIONS(2462),
    [anon_sym_COLON_GT] = ACTIONS(2464),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2464),
    [anon_sym_for] = ACTIONS(2462),
    [anon_sym_while] = ACTIONS(2462),
    [anon_sym_if] = ACTIONS(2462),
    [anon_sym_fun] = ACTIONS(2462),
    [anon_sym_DASH_GT] = ACTIONS(2462),
    [anon_sym_try] = ACTIONS(2462),
    [anon_sym_match] = ACTIONS(2462),
    [anon_sym_match_BANG] = ACTIONS(2464),
    [anon_sym_function] = ACTIONS(2462),
    [anon_sym_LT_DASH] = ACTIONS(2462),
    [anon_sym_DOT_LBRACK] = ACTIONS(2464),
    [anon_sym_LT] = ACTIONS(2464),
    [anon_sym_use] = ACTIONS(2462),
    [anon_sym_use_BANG] = ACTIONS(2464),
    [anon_sym_do_BANG] = ACTIONS(2464),
    [anon_sym_begin] = ACTIONS(2462),
    [anon_sym_LPAREN2] = ACTIONS(2462),
    [anon_sym_STAR] = ACTIONS(2462),
    [anon_sym_LT2] = ACTIONS(2462),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2464),
    [anon_sym_or] = ACTIONS(2462),
    [aux_sym_char_token1] = ACTIONS(2464),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2462),
    [anon_sym_DQUOTE] = ACTIONS(2462),
    [anon_sym_AT_DQUOTE] = ACTIONS(2464),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2464),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2464),
    [sym_bool] = ACTIONS(2462),
    [sym_unit] = ACTIONS(2464),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2462),
    [sym_op_identifier] = ACTIONS(2462),
    [anon_sym_PLUS] = ACTIONS(2462),
    [anon_sym_DASH] = ACTIONS(2462),
    [anon_sym_PLUS_DOT] = ACTIONS(2462),
    [anon_sym_DASH_DOT] = ACTIONS(2462),
    [anon_sym_PERCENT] = ACTIONS(2462),
    [anon_sym_AMP_AMP] = ACTIONS(2462),
    [anon_sym_TILDE] = ACTIONS(2464),
    [aux_sym_prefix_op_token1] = ACTIONS(2462),
    [aux_sym_infix_op_token1] = ACTIONS(2464),
    [aux_sym_infix_op_token2] = ACTIONS(2462),
    [anon_sym_PIPE_PIPE] = ACTIONS(2462),
    [anon_sym_BANG_EQ] = ACTIONS(2462),
    [anon_sym_COLON_EQ] = ACTIONS(2464),
    [anon_sym_DOLLAR] = ACTIONS(2462),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2462),
    [sym_int] = ACTIONS(2462),
    [sym_xint] = ACTIONS(2464),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2464),
    [anon_sym_POUNDendif] = ACTIONS(2464),
    [sym__newline] = ACTIONS(2464),
  },
  [1367] = {
    [sym_block_comment] = STATE(1367),
    [sym_compiler_directive_decl] = STATE(1367),
    [sym_fsi_directive_decl] = STATE(1367),
    [sym_preproc_line] = STATE(1367),
    [sym_identifier] = ACTIONS(2685),
    [anon_sym_EQ] = ACTIONS(2687),
    [anon_sym_COLON] = ACTIONS(2685),
    [anon_sym_return] = ACTIONS(2685),
    [anon_sym_do] = ACTIONS(2685),
    [anon_sym_let] = ACTIONS(2685),
    [anon_sym_let_BANG] = ACTIONS(2687),
    [anon_sym_as] = ACTIONS(2685),
    [anon_sym_LPAREN] = ACTIONS(2685),
    [anon_sym_COMMA] = ACTIONS(2687),
    [anon_sym_null] = ACTIONS(2685),
    [anon_sym_QMARK] = ACTIONS(2685),
    [anon_sym_COLON_QMARK] = ACTIONS(2685),
    [anon_sym_COLON_COLON] = ACTIONS(2687),
    [anon_sym_AMP] = ACTIONS(2685),
    [anon_sym_LBRACK] = ACTIONS(2685),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2687),
    [anon_sym_LBRACE] = ACTIONS(2685),
    [anon_sym_LT_AT] = ACTIONS(2685),
    [anon_sym_LT_AT_AT] = ACTIONS(2685),
    [anon_sym_DOT] = ACTIONS(2685),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2687),
    [anon_sym_new] = ACTIONS(2685),
    [anon_sym_with] = ACTIONS(2685),
    [anon_sym_return_BANG] = ACTIONS(2687),
    [anon_sym_yield] = ACTIONS(2685),
    [anon_sym_yield_BANG] = ACTIONS(2687),
    [anon_sym_lazy] = ACTIONS(2685),
    [anon_sym_assert] = ACTIONS(2685),
    [anon_sym_upcast] = ACTIONS(2685),
    [anon_sym_downcast] = ACTIONS(2685),
    [anon_sym_COLON_GT] = ACTIONS(2687),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2687),
    [anon_sym_for] = ACTIONS(2685),
    [anon_sym_while] = ACTIONS(2685),
    [anon_sym_else] = ACTIONS(2685),
    [anon_sym_elif] = ACTIONS(2685),
    [anon_sym_if] = ACTIONS(2685),
    [anon_sym_fun] = ACTIONS(2685),
    [anon_sym_try] = ACTIONS(2685),
    [anon_sym_match] = ACTIONS(2685),
    [anon_sym_match_BANG] = ACTIONS(2687),
    [anon_sym_function] = ACTIONS(2685),
    [anon_sym_LT_DASH] = ACTIONS(2685),
    [anon_sym_DOT_LBRACK] = ACTIONS(2687),
    [anon_sym_LT] = ACTIONS(2687),
    [anon_sym_use] = ACTIONS(2685),
    [anon_sym_use_BANG] = ACTIONS(2687),
    [anon_sym_do_BANG] = ACTIONS(2687),
    [anon_sym_begin] = ACTIONS(2685),
    [anon_sym_LPAREN2] = ACTIONS(2685),
    [anon_sym_or] = ACTIONS(2685),
    [aux_sym_char_token1] = ACTIONS(2687),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2685),
    [anon_sym_DQUOTE] = ACTIONS(2685),
    [anon_sym_AT_DQUOTE] = ACTIONS(2687),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2687),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2687),
    [sym_bool] = ACTIONS(2685),
    [sym_unit] = ACTIONS(2687),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2685),
    [sym_op_identifier] = ACTIONS(2685),
    [anon_sym_PLUS] = ACTIONS(2685),
    [anon_sym_DASH] = ACTIONS(2685),
    [anon_sym_PLUS_DOT] = ACTIONS(2685),
    [anon_sym_DASH_DOT] = ACTIONS(2685),
    [anon_sym_PERCENT] = ACTIONS(2685),
    [anon_sym_AMP_AMP] = ACTIONS(2685),
    [anon_sym_TILDE] = ACTIONS(2687),
    [aux_sym_prefix_op_token1] = ACTIONS(2685),
    [aux_sym_infix_op_token1] = ACTIONS(2687),
    [aux_sym_infix_op_token2] = ACTIONS(2685),
    [anon_sym_PIPE_PIPE] = ACTIONS(2685),
    [anon_sym_BANG_EQ] = ACTIONS(2685),
    [anon_sym_COLON_EQ] = ACTIONS(2687),
    [anon_sym_DOLLAR] = ACTIONS(2685),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2685),
    [sym_int] = ACTIONS(2685),
    [sym_xint] = ACTIONS(2687),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2687),
    [sym__newline] = ACTIONS(2687),
    [sym__dedent] = ACTIONS(2687),
  },
  [1368] = {
    [sym_block_comment] = STATE(1368),
    [sym_compiler_directive_decl] = STATE(1368),
    [sym_fsi_directive_decl] = STATE(1368),
    [sym_preproc_line] = STATE(1368),
    [sym_identifier] = ACTIONS(2158),
    [anon_sym_EQ] = ACTIONS(2160),
    [anon_sym_COLON] = ACTIONS(2158),
    [anon_sym_return] = ACTIONS(2158),
    [anon_sym_do] = ACTIONS(2158),
    [anon_sym_let] = ACTIONS(2158),
    [anon_sym_let_BANG] = ACTIONS(2160),
    [anon_sym_LPAREN] = ACTIONS(2158),
    [anon_sym_COMMA] = ACTIONS(2160),
    [anon_sym_null] = ACTIONS(2158),
    [anon_sym_QMARK] = ACTIONS(2158),
    [anon_sym_COLON_QMARK] = ACTIONS(2158),
    [anon_sym_COLON_COLON] = ACTIONS(2160),
    [anon_sym_AMP] = ACTIONS(2158),
    [anon_sym_LBRACK] = ACTIONS(2158),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2160),
    [anon_sym_LBRACE] = ACTIONS(2158),
    [anon_sym_LT_AT] = ACTIONS(2158),
    [anon_sym_LT_AT_AT] = ACTIONS(2158),
    [anon_sym_DOT] = ACTIONS(2158),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2160),
    [anon_sym_new] = ACTIONS(2158),
    [anon_sym_with] = ACTIONS(2158),
    [anon_sym_return_BANG] = ACTIONS(2160),
    [anon_sym_yield] = ACTIONS(2158),
    [anon_sym_yield_BANG] = ACTIONS(2160),
    [anon_sym_lazy] = ACTIONS(2158),
    [anon_sym_assert] = ACTIONS(2158),
    [anon_sym_upcast] = ACTIONS(2158),
    [anon_sym_downcast] = ACTIONS(2158),
    [anon_sym_COLON_GT] = ACTIONS(2160),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2160),
    [anon_sym_for] = ACTIONS(2158),
    [anon_sym_while] = ACTIONS(2158),
    [anon_sym_if] = ACTIONS(2158),
    [anon_sym_fun] = ACTIONS(2158),
    [anon_sym_try] = ACTIONS(2158),
    [anon_sym_match] = ACTIONS(2158),
    [anon_sym_match_BANG] = ACTIONS(2160),
    [anon_sym_function] = ACTIONS(2158),
    [anon_sym_LT_DASH] = ACTIONS(2158),
    [anon_sym_DOT_LBRACK] = ACTIONS(2160),
    [anon_sym_LT] = ACTIONS(2160),
    [anon_sym_use] = ACTIONS(2158),
    [anon_sym_use_BANG] = ACTIONS(2160),
    [anon_sym_do_BANG] = ACTIONS(2160),
    [anon_sym_begin] = ACTIONS(2158),
    [anon_sym_LPAREN2] = ACTIONS(2158),
    [anon_sym_DOT_DOT2] = ACTIONS(2160),
    [anon_sym_or] = ACTIONS(2158),
    [aux_sym_char_token1] = ACTIONS(2160),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2158),
    [anon_sym_DQUOTE] = ACTIONS(2158),
    [anon_sym_AT_DQUOTE] = ACTIONS(2160),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2160),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2160),
    [sym_bool] = ACTIONS(2158),
    [sym_unit] = ACTIONS(2160),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2158),
    [sym_op_identifier] = ACTIONS(2158),
    [anon_sym_PLUS] = ACTIONS(2158),
    [anon_sym_DASH] = ACTIONS(2158),
    [anon_sym_PLUS_DOT] = ACTIONS(2158),
    [anon_sym_DASH_DOT] = ACTIONS(2158),
    [anon_sym_PERCENT] = ACTIONS(2158),
    [anon_sym_AMP_AMP] = ACTIONS(2158),
    [anon_sym_TILDE] = ACTIONS(2160),
    [aux_sym_prefix_op_token1] = ACTIONS(2158),
    [aux_sym_infix_op_token1] = ACTIONS(2160),
    [aux_sym_infix_op_token2] = ACTIONS(2158),
    [anon_sym_PIPE_PIPE] = ACTIONS(2158),
    [anon_sym_BANG_EQ] = ACTIONS(2158),
    [anon_sym_COLON_EQ] = ACTIONS(2160),
    [anon_sym_DOLLAR] = ACTIONS(2158),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2158),
    [sym_int] = ACTIONS(2158),
    [sym_xint] = ACTIONS(2160),
    [anon_sym_f] = ACTIONS(2190),
    [aux_sym_decimal_token1] = ACTIONS(2184),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2160),
    [sym__newline] = ACTIONS(2160),
    [sym__dedent] = ACTIONS(2160),
  },
  [1369] = {
    [sym_block_comment] = STATE(1369),
    [sym_compiler_directive_decl] = STATE(1369),
    [sym_fsi_directive_decl] = STATE(1369),
    [sym_preproc_line] = STATE(1369),
    [sym_identifier] = ACTIONS(2553),
    [anon_sym_EQ] = ACTIONS(2555),
    [anon_sym_COLON] = ACTIONS(2553),
    [anon_sym_return] = ACTIONS(2553),
    [anon_sym_do] = ACTIONS(2553),
    [anon_sym_let] = ACTIONS(2553),
    [anon_sym_let_BANG] = ACTIONS(2555),
    [anon_sym_LPAREN] = ACTIONS(2553),
    [anon_sym_COMMA] = ACTIONS(2555),
    [anon_sym_null] = ACTIONS(2553),
    [anon_sym_QMARK] = ACTIONS(2553),
    [anon_sym_COLON_QMARK] = ACTIONS(2553),
    [anon_sym_COLON_COLON] = ACTIONS(2555),
    [anon_sym_AMP] = ACTIONS(2553),
    [anon_sym_LBRACK] = ACTIONS(2553),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2555),
    [anon_sym_LBRACE] = ACTIONS(2553),
    [anon_sym_LT_AT] = ACTIONS(2553),
    [anon_sym_LT_AT_AT] = ACTIONS(2553),
    [anon_sym_AT_AT_GT] = ACTIONS(2553),
    [anon_sym_DOT] = ACTIONS(2553),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2555),
    [anon_sym_new] = ACTIONS(2553),
    [anon_sym_return_BANG] = ACTIONS(2555),
    [anon_sym_yield] = ACTIONS(2553),
    [anon_sym_yield_BANG] = ACTIONS(2555),
    [anon_sym_lazy] = ACTIONS(2553),
    [anon_sym_assert] = ACTIONS(2553),
    [anon_sym_upcast] = ACTIONS(2553),
    [anon_sym_downcast] = ACTIONS(2553),
    [anon_sym_COLON_GT] = ACTIONS(2555),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2555),
    [anon_sym_for] = ACTIONS(2553),
    [anon_sym_while] = ACTIONS(2553),
    [anon_sym_if] = ACTIONS(2553),
    [anon_sym_fun] = ACTIONS(2553),
    [anon_sym_DASH_GT] = ACTIONS(2553),
    [anon_sym_try] = ACTIONS(2553),
    [anon_sym_match] = ACTIONS(2553),
    [anon_sym_match_BANG] = ACTIONS(2555),
    [anon_sym_function] = ACTIONS(2553),
    [anon_sym_LT_DASH] = ACTIONS(2553),
    [anon_sym_DOT_LBRACK] = ACTIONS(2555),
    [anon_sym_LT] = ACTIONS(2555),
    [anon_sym_use] = ACTIONS(2553),
    [anon_sym_use_BANG] = ACTIONS(2555),
    [anon_sym_do_BANG] = ACTIONS(2555),
    [anon_sym_begin] = ACTIONS(2553),
    [anon_sym_LPAREN2] = ACTIONS(2553),
    [anon_sym_STAR] = ACTIONS(2553),
    [anon_sym_LT2] = ACTIONS(2553),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2555),
    [anon_sym_or] = ACTIONS(2553),
    [aux_sym_char_token1] = ACTIONS(2555),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2553),
    [anon_sym_DQUOTE] = ACTIONS(2553),
    [anon_sym_AT_DQUOTE] = ACTIONS(2555),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2555),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2555),
    [sym_bool] = ACTIONS(2553),
    [sym_unit] = ACTIONS(2555),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2553),
    [sym_op_identifier] = ACTIONS(2553),
    [anon_sym_PLUS] = ACTIONS(2553),
    [anon_sym_DASH] = ACTIONS(2553),
    [anon_sym_PLUS_DOT] = ACTIONS(2553),
    [anon_sym_DASH_DOT] = ACTIONS(2553),
    [anon_sym_PERCENT] = ACTIONS(2553),
    [anon_sym_AMP_AMP] = ACTIONS(2553),
    [anon_sym_TILDE] = ACTIONS(2555),
    [aux_sym_prefix_op_token1] = ACTIONS(2553),
    [aux_sym_infix_op_token1] = ACTIONS(2555),
    [aux_sym_infix_op_token2] = ACTIONS(2553),
    [anon_sym_PIPE_PIPE] = ACTIONS(2553),
    [anon_sym_BANG_EQ] = ACTIONS(2553),
    [anon_sym_COLON_EQ] = ACTIONS(2555),
    [anon_sym_DOLLAR] = ACTIONS(2553),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2553),
    [sym_int] = ACTIONS(2553),
    [sym_xint] = ACTIONS(2555),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2555),
    [sym__newline] = ACTIONS(2555),
  },
  [1370] = {
    [sym_block_comment] = STATE(1370),
    [sym_compiler_directive_decl] = STATE(1370),
    [sym_fsi_directive_decl] = STATE(1370),
    [sym_preproc_line] = STATE(1370),
    [sym_identifier] = ACTIONS(2627),
    [anon_sym_EQ] = ACTIONS(2869),
    [anon_sym_GT_RBRACK] = ACTIONS(2629),
    [anon_sym_COLON] = ACTIONS(2867),
    [anon_sym_return] = ACTIONS(2627),
    [anon_sym_do] = ACTIONS(2627),
    [anon_sym_let] = ACTIONS(2627),
    [anon_sym_let_BANG] = ACTIONS(2629),
    [anon_sym_LPAREN] = ACTIONS(2627),
    [anon_sym_COMMA] = ACTIONS(2869),
    [anon_sym_null] = ACTIONS(2627),
    [anon_sym_QMARK] = ACTIONS(2867),
    [anon_sym_COLON_QMARK] = ACTIONS(2867),
    [anon_sym_COLON_COLON] = ACTIONS(2869),
    [anon_sym_AMP] = ACTIONS(2627),
    [anon_sym_LBRACK] = ACTIONS(2627),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2629),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_LT_AT] = ACTIONS(2627),
    [anon_sym_LT_AT_AT] = ACTIONS(2627),
    [anon_sym_DOT] = ACTIONS(3342),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2629),
    [anon_sym_new] = ACTIONS(2627),
    [anon_sym_return_BANG] = ACTIONS(2629),
    [anon_sym_yield] = ACTIONS(2627),
    [anon_sym_yield_BANG] = ACTIONS(2629),
    [anon_sym_lazy] = ACTIONS(2627),
    [anon_sym_assert] = ACTIONS(2627),
    [anon_sym_upcast] = ACTIONS(2627),
    [anon_sym_downcast] = ACTIONS(2627),
    [anon_sym_COLON_GT] = ACTIONS(2869),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2869),
    [anon_sym_for] = ACTIONS(2627),
    [anon_sym_while] = ACTIONS(2627),
    [anon_sym_if] = ACTIONS(2627),
    [anon_sym_fun] = ACTIONS(2627),
    [anon_sym_DASH_GT] = ACTIONS(2627),
    [anon_sym_try] = ACTIONS(2627),
    [anon_sym_match] = ACTIONS(2627),
    [anon_sym_match_BANG] = ACTIONS(2629),
    [anon_sym_function] = ACTIONS(2627),
    [anon_sym_LT_DASH] = ACTIONS(2867),
    [anon_sym_DOT_LBRACK] = ACTIONS(2869),
    [anon_sym_LT] = ACTIONS(2869),
    [anon_sym_use] = ACTIONS(2627),
    [anon_sym_use_BANG] = ACTIONS(2629),
    [anon_sym_do_BANG] = ACTIONS(2629),
    [anon_sym_begin] = ACTIONS(2627),
    [anon_sym_LPAREN2] = ACTIONS(2867),
    [anon_sym_STAR] = ACTIONS(2627),
    [anon_sym_LT2] = ACTIONS(2627),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2629),
    [anon_sym_or] = ACTIONS(2867),
    [aux_sym_char_token1] = ACTIONS(2629),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2627),
    [anon_sym_DQUOTE] = ACTIONS(2627),
    [anon_sym_AT_DQUOTE] = ACTIONS(2629),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2629),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2629),
    [sym_bool] = ACTIONS(2627),
    [sym_unit] = ACTIONS(2629),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2627),
    [sym_op_identifier] = ACTIONS(2627),
    [anon_sym_PLUS] = ACTIONS(2627),
    [anon_sym_DASH] = ACTIONS(2627),
    [anon_sym_PLUS_DOT] = ACTIONS(2627),
    [anon_sym_DASH_DOT] = ACTIONS(2627),
    [anon_sym_PERCENT] = ACTIONS(2627),
    [anon_sym_AMP_AMP] = ACTIONS(2627),
    [anon_sym_TILDE] = ACTIONS(2629),
    [aux_sym_prefix_op_token1] = ACTIONS(2627),
    [aux_sym_infix_op_token1] = ACTIONS(2869),
    [aux_sym_infix_op_token2] = ACTIONS(2867),
    [anon_sym_PIPE_PIPE] = ACTIONS(2867),
    [anon_sym_BANG_EQ] = ACTIONS(2867),
    [anon_sym_COLON_EQ] = ACTIONS(2869),
    [anon_sym_DOLLAR] = ACTIONS(2867),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2867),
    [sym_int] = ACTIONS(2627),
    [sym_xint] = ACTIONS(2629),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2629),
    [sym__newline] = ACTIONS(2629),
  },
  [1371] = {
    [sym_block_comment] = STATE(1371),
    [sym_compiler_directive_decl] = STATE(1371),
    [sym_fsi_directive_decl] = STATE(1371),
    [sym_preproc_line] = STATE(1371),
    [sym_identifier] = ACTIONS(2454),
    [anon_sym_EQ] = ACTIONS(2456),
    [anon_sym_COLON] = ACTIONS(2454),
    [anon_sym_return] = ACTIONS(2454),
    [anon_sym_do] = ACTIONS(2454),
    [anon_sym_let] = ACTIONS(2454),
    [anon_sym_let_BANG] = ACTIONS(2456),
    [anon_sym_LPAREN] = ACTIONS(2454),
    [anon_sym_COMMA] = ACTIONS(2456),
    [anon_sym_null] = ACTIONS(2454),
    [anon_sym_QMARK] = ACTIONS(2454),
    [anon_sym_COLON_QMARK] = ACTIONS(2454),
    [anon_sym_COLON_COLON] = ACTIONS(2456),
    [anon_sym_AMP] = ACTIONS(2454),
    [anon_sym_LBRACK] = ACTIONS(2454),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2456),
    [anon_sym_LBRACE] = ACTIONS(2454),
    [anon_sym_LT_AT] = ACTIONS(2454),
    [anon_sym_AT_GT] = ACTIONS(2454),
    [anon_sym_LT_AT_AT] = ACTIONS(2454),
    [anon_sym_DOT] = ACTIONS(2454),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2456),
    [anon_sym_new] = ACTIONS(2454),
    [anon_sym_return_BANG] = ACTIONS(2456),
    [anon_sym_yield] = ACTIONS(2454),
    [anon_sym_yield_BANG] = ACTIONS(2456),
    [anon_sym_lazy] = ACTIONS(2454),
    [anon_sym_assert] = ACTIONS(2454),
    [anon_sym_upcast] = ACTIONS(2454),
    [anon_sym_downcast] = ACTIONS(2454),
    [anon_sym_COLON_GT] = ACTIONS(2456),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2456),
    [anon_sym_for] = ACTIONS(2454),
    [anon_sym_while] = ACTIONS(2454),
    [anon_sym_if] = ACTIONS(2454),
    [anon_sym_fun] = ACTIONS(2454),
    [anon_sym_DASH_GT] = ACTIONS(2454),
    [anon_sym_try] = ACTIONS(2454),
    [anon_sym_match] = ACTIONS(2454),
    [anon_sym_match_BANG] = ACTIONS(2456),
    [anon_sym_function] = ACTIONS(2454),
    [anon_sym_LT_DASH] = ACTIONS(2454),
    [anon_sym_DOT_LBRACK] = ACTIONS(2456),
    [anon_sym_LT] = ACTIONS(2456),
    [anon_sym_use] = ACTIONS(2454),
    [anon_sym_use_BANG] = ACTIONS(2456),
    [anon_sym_do_BANG] = ACTIONS(2456),
    [anon_sym_begin] = ACTIONS(2454),
    [anon_sym_LPAREN2] = ACTIONS(2454),
    [anon_sym_STAR] = ACTIONS(2454),
    [anon_sym_LT2] = ACTIONS(2454),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2456),
    [anon_sym_or] = ACTIONS(2454),
    [aux_sym_char_token1] = ACTIONS(2456),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2454),
    [anon_sym_DQUOTE] = ACTIONS(2454),
    [anon_sym_AT_DQUOTE] = ACTIONS(2456),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2456),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2456),
    [sym_bool] = ACTIONS(2454),
    [sym_unit] = ACTIONS(2456),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2454),
    [sym_op_identifier] = ACTIONS(2454),
    [anon_sym_PLUS] = ACTIONS(2454),
    [anon_sym_DASH] = ACTIONS(2454),
    [anon_sym_PLUS_DOT] = ACTIONS(2454),
    [anon_sym_DASH_DOT] = ACTIONS(2454),
    [anon_sym_PERCENT] = ACTIONS(2454),
    [anon_sym_AMP_AMP] = ACTIONS(2454),
    [anon_sym_TILDE] = ACTIONS(2456),
    [aux_sym_prefix_op_token1] = ACTIONS(2454),
    [aux_sym_infix_op_token1] = ACTIONS(2456),
    [aux_sym_infix_op_token2] = ACTIONS(2454),
    [anon_sym_PIPE_PIPE] = ACTIONS(2454),
    [anon_sym_BANG_EQ] = ACTIONS(2454),
    [anon_sym_COLON_EQ] = ACTIONS(2456),
    [anon_sym_DOLLAR] = ACTIONS(2454),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2454),
    [sym_int] = ACTIONS(2454),
    [sym_xint] = ACTIONS(2456),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2456),
    [sym__newline] = ACTIONS(2456),
  },
  [1372] = {
    [sym_elif_expression] = STATE(1523),
    [sym_block_comment] = STATE(1372),
    [sym_compiler_directive_decl] = STATE(1372),
    [sym_fsi_directive_decl] = STATE(1372),
    [sym_preproc_line] = STATE(1372),
    [aux_sym_if_expression_repeat1] = STATE(1372),
    [sym_identifier] = ACTIONS(2518),
    [anon_sym_EQ] = ACTIONS(2520),
    [anon_sym_COLON] = ACTIONS(2518),
    [anon_sym_return] = ACTIONS(2518),
    [anon_sym_do] = ACTIONS(2518),
    [anon_sym_let] = ACTIONS(2518),
    [anon_sym_let_BANG] = ACTIONS(2520),
    [anon_sym_LPAREN] = ACTIONS(2518),
    [anon_sym_COMMA] = ACTIONS(2520),
    [anon_sym_null] = ACTIONS(2518),
    [anon_sym_QMARK] = ACTIONS(2518),
    [anon_sym_COLON_QMARK] = ACTIONS(2518),
    [anon_sym_COLON_COLON] = ACTIONS(2520),
    [anon_sym_AMP] = ACTIONS(2518),
    [anon_sym_LBRACK] = ACTIONS(2518),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2520),
    [anon_sym_LBRACE] = ACTIONS(2518),
    [anon_sym_LT_AT] = ACTIONS(2518),
    [anon_sym_LT_AT_AT] = ACTIONS(2518),
    [anon_sym_DOT] = ACTIONS(2518),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2520),
    [anon_sym_new] = ACTIONS(2518),
    [anon_sym_return_BANG] = ACTIONS(2520),
    [anon_sym_yield] = ACTIONS(2518),
    [anon_sym_yield_BANG] = ACTIONS(2520),
    [anon_sym_lazy] = ACTIONS(2518),
    [anon_sym_assert] = ACTIONS(2518),
    [anon_sym_upcast] = ACTIONS(2518),
    [anon_sym_downcast] = ACTIONS(2518),
    [anon_sym_COLON_GT] = ACTIONS(2520),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2520),
    [anon_sym_for] = ACTIONS(2518),
    [anon_sym_while] = ACTIONS(2518),
    [anon_sym_else] = ACTIONS(2518),
    [anon_sym_elif] = ACTIONS(3516),
    [anon_sym_if] = ACTIONS(2518),
    [anon_sym_fun] = ACTIONS(2518),
    [anon_sym_try] = ACTIONS(2518),
    [anon_sym_match] = ACTIONS(2518),
    [anon_sym_match_BANG] = ACTIONS(2520),
    [anon_sym_function] = ACTIONS(2518),
    [anon_sym_LT_DASH] = ACTIONS(2518),
    [anon_sym_DOT_LBRACK] = ACTIONS(2520),
    [anon_sym_LT] = ACTIONS(2520),
    [anon_sym_use] = ACTIONS(2518),
    [anon_sym_use_BANG] = ACTIONS(2520),
    [anon_sym_do_BANG] = ACTIONS(2520),
    [anon_sym_begin] = ACTIONS(2518),
    [anon_sym_LPAREN2] = ACTIONS(2518),
    [anon_sym_or] = ACTIONS(2518),
    [aux_sym_char_token1] = ACTIONS(2520),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2518),
    [anon_sym_DQUOTE] = ACTIONS(2518),
    [anon_sym_AT_DQUOTE] = ACTIONS(2520),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2520),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2520),
    [sym_bool] = ACTIONS(2518),
    [sym_unit] = ACTIONS(2520),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2518),
    [sym_op_identifier] = ACTIONS(2518),
    [anon_sym_PLUS] = ACTIONS(2518),
    [anon_sym_DASH] = ACTIONS(2518),
    [anon_sym_PLUS_DOT] = ACTIONS(2518),
    [anon_sym_DASH_DOT] = ACTIONS(2518),
    [anon_sym_PERCENT] = ACTIONS(2518),
    [anon_sym_AMP_AMP] = ACTIONS(2518),
    [anon_sym_TILDE] = ACTIONS(2520),
    [aux_sym_prefix_op_token1] = ACTIONS(2518),
    [aux_sym_infix_op_token1] = ACTIONS(2520),
    [aux_sym_infix_op_token2] = ACTIONS(2518),
    [anon_sym_PIPE_PIPE] = ACTIONS(2518),
    [anon_sym_BANG_EQ] = ACTIONS(2518),
    [anon_sym_COLON_EQ] = ACTIONS(2520),
    [anon_sym_DOLLAR] = ACTIONS(2518),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2518),
    [sym_int] = ACTIONS(2518),
    [sym_xint] = ACTIONS(2520),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2520),
    [anon_sym_POUNDendif] = ACTIONS(2520),
    [sym__newline] = ACTIONS(2520),
  },
  [1373] = {
    [sym_block_comment] = STATE(1373),
    [sym_compiler_directive_decl] = STATE(1373),
    [sym_fsi_directive_decl] = STATE(1373),
    [sym_preproc_line] = STATE(1373),
    [aux_sym_rules_repeat1] = STATE(1294),
    [sym_identifier] = ACTIONS(2698),
    [anon_sym_EQ] = ACTIONS(2700),
    [anon_sym_COLON] = ACTIONS(2698),
    [anon_sym_return] = ACTIONS(2698),
    [anon_sym_do] = ACTIONS(2698),
    [anon_sym_let] = ACTIONS(2698),
    [anon_sym_let_BANG] = ACTIONS(2700),
    [anon_sym_as] = ACTIONS(2698),
    [anon_sym_LPAREN] = ACTIONS(2698),
    [anon_sym_COMMA] = ACTIONS(2700),
    [anon_sym_null] = ACTIONS(2698),
    [anon_sym_QMARK] = ACTIONS(2698),
    [anon_sym_COLON_QMARK] = ACTIONS(2698),
    [anon_sym_COLON_COLON] = ACTIONS(2700),
    [anon_sym_PIPE] = ACTIONS(3485),
    [anon_sym_AMP] = ACTIONS(2698),
    [anon_sym_LBRACK] = ACTIONS(2698),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2700),
    [anon_sym_LBRACE] = ACTIONS(2698),
    [anon_sym_LT_AT] = ACTIONS(2698),
    [anon_sym_LT_AT_AT] = ACTIONS(2698),
    [anon_sym_DOT] = ACTIONS(2698),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2700),
    [anon_sym_new] = ACTIONS(2698),
    [anon_sym_with] = ACTIONS(2698),
    [anon_sym_return_BANG] = ACTIONS(2700),
    [anon_sym_yield] = ACTIONS(2698),
    [anon_sym_yield_BANG] = ACTIONS(2700),
    [anon_sym_lazy] = ACTIONS(2698),
    [anon_sym_assert] = ACTIONS(2698),
    [anon_sym_upcast] = ACTIONS(2698),
    [anon_sym_downcast] = ACTIONS(2698),
    [anon_sym_COLON_GT] = ACTIONS(2700),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2700),
    [anon_sym_for] = ACTIONS(2698),
    [anon_sym_while] = ACTIONS(2698),
    [anon_sym_if] = ACTIONS(2698),
    [anon_sym_fun] = ACTIONS(2698),
    [anon_sym_try] = ACTIONS(2698),
    [anon_sym_match] = ACTIONS(2698),
    [anon_sym_match_BANG] = ACTIONS(2700),
    [anon_sym_function] = ACTIONS(2698),
    [anon_sym_LT_DASH] = ACTIONS(2698),
    [anon_sym_DOT_LBRACK] = ACTIONS(2700),
    [anon_sym_LT] = ACTIONS(2700),
    [anon_sym_use] = ACTIONS(2698),
    [anon_sym_use_BANG] = ACTIONS(2700),
    [anon_sym_do_BANG] = ACTIONS(2700),
    [anon_sym_begin] = ACTIONS(2698),
    [anon_sym_LPAREN2] = ACTIONS(2698),
    [anon_sym_or] = ACTIONS(2698),
    [aux_sym_char_token1] = ACTIONS(2700),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2698),
    [anon_sym_DQUOTE] = ACTIONS(2698),
    [anon_sym_AT_DQUOTE] = ACTIONS(2700),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2700),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2700),
    [sym_bool] = ACTIONS(2698),
    [sym_unit] = ACTIONS(2700),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2698),
    [sym_op_identifier] = ACTIONS(2698),
    [anon_sym_PLUS] = ACTIONS(2698),
    [anon_sym_DASH] = ACTIONS(2698),
    [anon_sym_PLUS_DOT] = ACTIONS(2698),
    [anon_sym_DASH_DOT] = ACTIONS(2698),
    [anon_sym_PERCENT] = ACTIONS(2698),
    [anon_sym_AMP_AMP] = ACTIONS(2698),
    [anon_sym_TILDE] = ACTIONS(2700),
    [aux_sym_prefix_op_token1] = ACTIONS(2698),
    [aux_sym_infix_op_token1] = ACTIONS(2700),
    [aux_sym_infix_op_token2] = ACTIONS(2698),
    [anon_sym_PIPE_PIPE] = ACTIONS(2698),
    [anon_sym_BANG_EQ] = ACTIONS(2698),
    [anon_sym_COLON_EQ] = ACTIONS(2700),
    [anon_sym_DOLLAR] = ACTIONS(2698),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2698),
    [sym_int] = ACTIONS(2698),
    [sym_xint] = ACTIONS(2700),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2700),
    [sym__newline] = ACTIONS(3508),
    [sym__dedent] = ACTIONS(2700),
  },
  [1374] = {
    [sym_block_comment] = STATE(1374),
    [sym_compiler_directive_decl] = STATE(1374),
    [sym_fsi_directive_decl] = STATE(1374),
    [sym_preproc_line] = STATE(1374),
    [sym_identifier] = ACTIONS(2321),
    [anon_sym_EQ] = ACTIONS(2323),
    [anon_sym_COLON] = ACTIONS(2321),
    [anon_sym_return] = ACTIONS(2321),
    [anon_sym_do] = ACTIONS(2321),
    [anon_sym_let] = ACTIONS(2321),
    [anon_sym_let_BANG] = ACTIONS(2323),
    [anon_sym_LPAREN] = ACTIONS(2321),
    [anon_sym_COMMA] = ACTIONS(2323),
    [anon_sym_null] = ACTIONS(2321),
    [anon_sym_QMARK] = ACTIONS(2321),
    [anon_sym_COLON_QMARK] = ACTIONS(2321),
    [anon_sym_COLON_COLON] = ACTIONS(2323),
    [anon_sym_AMP] = ACTIONS(2321),
    [anon_sym_LBRACK] = ACTIONS(2321),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2323),
    [anon_sym_LBRACE] = ACTIONS(2321),
    [anon_sym_LT_AT] = ACTIONS(2321),
    [anon_sym_LT_AT_AT] = ACTIONS(2321),
    [anon_sym_DOT] = ACTIONS(2321),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2323),
    [anon_sym_new] = ACTIONS(2321),
    [anon_sym_return_BANG] = ACTIONS(2323),
    [anon_sym_yield] = ACTIONS(2321),
    [anon_sym_yield_BANG] = ACTIONS(2323),
    [anon_sym_lazy] = ACTIONS(2321),
    [anon_sym_assert] = ACTIONS(2321),
    [anon_sym_upcast] = ACTIONS(2321),
    [anon_sym_downcast] = ACTIONS(2321),
    [anon_sym_COLON_GT] = ACTIONS(2323),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2323),
    [anon_sym_for] = ACTIONS(2321),
    [anon_sym_while] = ACTIONS(2321),
    [anon_sym_if] = ACTIONS(2321),
    [anon_sym_fun] = ACTIONS(2321),
    [anon_sym_DASH_GT] = ACTIONS(2321),
    [anon_sym_try] = ACTIONS(2321),
    [anon_sym_match] = ACTIONS(2321),
    [anon_sym_match_BANG] = ACTIONS(2323),
    [anon_sym_function] = ACTIONS(2321),
    [anon_sym_LT_DASH] = ACTIONS(2321),
    [anon_sym_DOT_LBRACK] = ACTIONS(2323),
    [anon_sym_LT] = ACTIONS(2323),
    [anon_sym_use] = ACTIONS(2321),
    [anon_sym_use_BANG] = ACTIONS(2323),
    [anon_sym_do_BANG] = ACTIONS(2323),
    [anon_sym_begin] = ACTIONS(2321),
    [anon_sym_LPAREN2] = ACTIONS(2321),
    [anon_sym_STAR] = ACTIONS(2321),
    [anon_sym_LT2] = ACTIONS(2321),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2323),
    [anon_sym_or] = ACTIONS(2321),
    [aux_sym_char_token1] = ACTIONS(2323),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2321),
    [anon_sym_DQUOTE] = ACTIONS(2321),
    [anon_sym_AT_DQUOTE] = ACTIONS(2323),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2323),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2323),
    [sym_bool] = ACTIONS(2321),
    [sym_unit] = ACTIONS(2323),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2321),
    [sym_op_identifier] = ACTIONS(2321),
    [anon_sym_PLUS] = ACTIONS(2321),
    [anon_sym_DASH] = ACTIONS(2321),
    [anon_sym_PLUS_DOT] = ACTIONS(2321),
    [anon_sym_DASH_DOT] = ACTIONS(2321),
    [anon_sym_PERCENT] = ACTIONS(2321),
    [anon_sym_AMP_AMP] = ACTIONS(2321),
    [anon_sym_TILDE] = ACTIONS(2323),
    [aux_sym_prefix_op_token1] = ACTIONS(2321),
    [aux_sym_infix_op_token1] = ACTIONS(2323),
    [aux_sym_infix_op_token2] = ACTIONS(2321),
    [anon_sym_PIPE_PIPE] = ACTIONS(2321),
    [anon_sym_BANG_EQ] = ACTIONS(2321),
    [anon_sym_COLON_EQ] = ACTIONS(2323),
    [anon_sym_DOLLAR] = ACTIONS(2321),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2321),
    [sym_int] = ACTIONS(2321),
    [sym_xint] = ACTIONS(2323),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2323),
    [anon_sym_POUNDendif] = ACTIONS(2323),
    [sym__newline] = ACTIONS(2323),
  },
  [1375] = {
    [sym_block_comment] = STATE(1375),
    [sym_compiler_directive_decl] = STATE(1375),
    [sym_fsi_directive_decl] = STATE(1375),
    [sym_preproc_line] = STATE(1375),
    [sym_identifier] = ACTIONS(2553),
    [anon_sym_EQ] = ACTIONS(2555),
    [anon_sym_COLON] = ACTIONS(2553),
    [anon_sym_return] = ACTIONS(2553),
    [anon_sym_do] = ACTIONS(2553),
    [anon_sym_let] = ACTIONS(2553),
    [anon_sym_let_BANG] = ACTIONS(2555),
    [anon_sym_LPAREN] = ACTIONS(2553),
    [anon_sym_COMMA] = ACTIONS(2555),
    [anon_sym_null] = ACTIONS(2553),
    [anon_sym_QMARK] = ACTIONS(2553),
    [anon_sym_COLON_QMARK] = ACTIONS(2553),
    [anon_sym_COLON_COLON] = ACTIONS(2555),
    [anon_sym_AMP] = ACTIONS(2553),
    [anon_sym_LBRACK] = ACTIONS(2553),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2555),
    [anon_sym_LBRACE] = ACTIONS(2553),
    [anon_sym_LT_AT] = ACTIONS(2553),
    [anon_sym_LT_AT_AT] = ACTIONS(2553),
    [anon_sym_DOT] = ACTIONS(2553),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2555),
    [anon_sym_new] = ACTIONS(2553),
    [anon_sym_return_BANG] = ACTIONS(2555),
    [anon_sym_yield] = ACTIONS(2553),
    [anon_sym_yield_BANG] = ACTIONS(2555),
    [anon_sym_lazy] = ACTIONS(2553),
    [anon_sym_assert] = ACTIONS(2553),
    [anon_sym_upcast] = ACTIONS(2553),
    [anon_sym_downcast] = ACTIONS(2553),
    [anon_sym_COLON_GT] = ACTIONS(2555),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2555),
    [anon_sym_for] = ACTIONS(2553),
    [anon_sym_while] = ACTIONS(2553),
    [anon_sym_if] = ACTIONS(2553),
    [anon_sym_fun] = ACTIONS(2553),
    [anon_sym_DASH_GT] = ACTIONS(2553),
    [anon_sym_try] = ACTIONS(2553),
    [anon_sym_match] = ACTIONS(2553),
    [anon_sym_match_BANG] = ACTIONS(2555),
    [anon_sym_function] = ACTIONS(2553),
    [anon_sym_LT_DASH] = ACTIONS(2553),
    [anon_sym_DOT_LBRACK] = ACTIONS(2555),
    [anon_sym_LT] = ACTIONS(2555),
    [anon_sym_GT] = ACTIONS(2553),
    [anon_sym_use] = ACTIONS(2553),
    [anon_sym_use_BANG] = ACTIONS(2555),
    [anon_sym_do_BANG] = ACTIONS(2555),
    [anon_sym_begin] = ACTIONS(2553),
    [anon_sym_LPAREN2] = ACTIONS(2553),
    [anon_sym_STAR] = ACTIONS(2553),
    [anon_sym_LT2] = ACTIONS(2553),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2555),
    [anon_sym_or] = ACTIONS(2553),
    [aux_sym_char_token1] = ACTIONS(2555),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2553),
    [anon_sym_DQUOTE] = ACTIONS(2553),
    [anon_sym_AT_DQUOTE] = ACTIONS(2555),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2555),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2555),
    [sym_bool] = ACTIONS(2553),
    [sym_unit] = ACTIONS(2555),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2553),
    [sym_op_identifier] = ACTIONS(2553),
    [anon_sym_PLUS] = ACTIONS(2553),
    [anon_sym_DASH] = ACTIONS(2553),
    [anon_sym_PLUS_DOT] = ACTIONS(2553),
    [anon_sym_DASH_DOT] = ACTIONS(2553),
    [anon_sym_PERCENT] = ACTIONS(2553),
    [anon_sym_AMP_AMP] = ACTIONS(2553),
    [anon_sym_TILDE] = ACTIONS(2555),
    [aux_sym_prefix_op_token1] = ACTIONS(2553),
    [aux_sym_infix_op_token1] = ACTIONS(2555),
    [aux_sym_infix_op_token2] = ACTIONS(2553),
    [anon_sym_PIPE_PIPE] = ACTIONS(2553),
    [anon_sym_BANG_EQ] = ACTIONS(2553),
    [anon_sym_COLON_EQ] = ACTIONS(2555),
    [anon_sym_DOLLAR] = ACTIONS(2553),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2553),
    [sym_int] = ACTIONS(2553),
    [sym_xint] = ACTIONS(2555),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2555),
    [sym__newline] = ACTIONS(2555),
  },
  [1376] = {
    [sym_block_comment] = STATE(1376),
    [sym_compiler_directive_decl] = STATE(1376),
    [sym_fsi_directive_decl] = STATE(1376),
    [sym_preproc_line] = STATE(1376),
    [sym_identifier] = ACTIONS(2514),
    [anon_sym_EQ] = ACTIONS(2516),
    [anon_sym_COLON] = ACTIONS(2514),
    [anon_sym_return] = ACTIONS(2514),
    [anon_sym_do] = ACTIONS(2514),
    [anon_sym_let] = ACTIONS(2514),
    [anon_sym_let_BANG] = ACTIONS(2516),
    [anon_sym_LPAREN] = ACTIONS(2514),
    [anon_sym_COMMA] = ACTIONS(2516),
    [anon_sym_null] = ACTIONS(2514),
    [anon_sym_QMARK] = ACTIONS(2514),
    [anon_sym_COLON_QMARK] = ACTIONS(2514),
    [anon_sym_COLON_COLON] = ACTIONS(2516),
    [anon_sym_AMP] = ACTIONS(2514),
    [anon_sym_LBRACK] = ACTIONS(2514),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2516),
    [anon_sym_LBRACE] = ACTIONS(2514),
    [anon_sym_LT_AT] = ACTIONS(2514),
    [anon_sym_AT_GT] = ACTIONS(2514),
    [anon_sym_LT_AT_AT] = ACTIONS(2514),
    [anon_sym_DOT] = ACTIONS(2514),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2516),
    [anon_sym_new] = ACTIONS(2514),
    [anon_sym_return_BANG] = ACTIONS(2516),
    [anon_sym_yield] = ACTIONS(2514),
    [anon_sym_yield_BANG] = ACTIONS(2516),
    [anon_sym_lazy] = ACTIONS(2514),
    [anon_sym_assert] = ACTIONS(2514),
    [anon_sym_upcast] = ACTIONS(2514),
    [anon_sym_downcast] = ACTIONS(2514),
    [anon_sym_COLON_GT] = ACTIONS(2516),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2516),
    [anon_sym_for] = ACTIONS(2514),
    [anon_sym_while] = ACTIONS(2514),
    [anon_sym_if] = ACTIONS(2514),
    [anon_sym_fun] = ACTIONS(2514),
    [anon_sym_DASH_GT] = ACTIONS(2514),
    [anon_sym_try] = ACTIONS(2514),
    [anon_sym_match] = ACTIONS(2514),
    [anon_sym_match_BANG] = ACTIONS(2516),
    [anon_sym_function] = ACTIONS(2514),
    [anon_sym_LT_DASH] = ACTIONS(2514),
    [anon_sym_DOT_LBRACK] = ACTIONS(2516),
    [anon_sym_LT] = ACTIONS(2516),
    [anon_sym_use] = ACTIONS(2514),
    [anon_sym_use_BANG] = ACTIONS(2516),
    [anon_sym_do_BANG] = ACTIONS(2516),
    [anon_sym_begin] = ACTIONS(2514),
    [anon_sym_LPAREN2] = ACTIONS(2514),
    [anon_sym_STAR] = ACTIONS(2514),
    [anon_sym_LT2] = ACTIONS(2514),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2516),
    [anon_sym_or] = ACTIONS(2514),
    [aux_sym_char_token1] = ACTIONS(2516),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2514),
    [anon_sym_DQUOTE] = ACTIONS(2514),
    [anon_sym_AT_DQUOTE] = ACTIONS(2516),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2516),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2516),
    [sym_bool] = ACTIONS(2514),
    [sym_unit] = ACTIONS(2516),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2514),
    [sym_op_identifier] = ACTIONS(2514),
    [anon_sym_PLUS] = ACTIONS(2514),
    [anon_sym_DASH] = ACTIONS(2514),
    [anon_sym_PLUS_DOT] = ACTIONS(2514),
    [anon_sym_DASH_DOT] = ACTIONS(2514),
    [anon_sym_PERCENT] = ACTIONS(2514),
    [anon_sym_AMP_AMP] = ACTIONS(2514),
    [anon_sym_TILDE] = ACTIONS(2516),
    [aux_sym_prefix_op_token1] = ACTIONS(2514),
    [aux_sym_infix_op_token1] = ACTIONS(2516),
    [aux_sym_infix_op_token2] = ACTIONS(2514),
    [anon_sym_PIPE_PIPE] = ACTIONS(2514),
    [anon_sym_BANG_EQ] = ACTIONS(2514),
    [anon_sym_COLON_EQ] = ACTIONS(2516),
    [anon_sym_DOLLAR] = ACTIONS(2514),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2514),
    [sym_int] = ACTIONS(2514),
    [sym_xint] = ACTIONS(2516),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2516),
    [sym__newline] = ACTIONS(2516),
  },
  [1377] = {
    [sym_block_comment] = STATE(1377),
    [sym_compiler_directive_decl] = STATE(1377),
    [sym_fsi_directive_decl] = STATE(1377),
    [sym_preproc_line] = STATE(1377),
    [sym_identifier] = ACTIONS(2557),
    [anon_sym_EQ] = ACTIONS(2559),
    [anon_sym_COLON] = ACTIONS(2557),
    [anon_sym_return] = ACTIONS(2557),
    [anon_sym_do] = ACTIONS(2557),
    [anon_sym_let] = ACTIONS(2557),
    [anon_sym_let_BANG] = ACTIONS(2559),
    [anon_sym_LPAREN] = ACTIONS(2557),
    [anon_sym_COMMA] = ACTIONS(2559),
    [anon_sym_null] = ACTIONS(2557),
    [anon_sym_QMARK] = ACTIONS(2557),
    [anon_sym_COLON_QMARK] = ACTIONS(2557),
    [anon_sym_COLON_COLON] = ACTIONS(2559),
    [anon_sym_AMP] = ACTIONS(2557),
    [anon_sym_LBRACK] = ACTIONS(2557),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2559),
    [anon_sym_LBRACE] = ACTIONS(2557),
    [anon_sym_LT_AT] = ACTIONS(2557),
    [anon_sym_AT_GT] = ACTIONS(2557),
    [anon_sym_LT_AT_AT] = ACTIONS(2557),
    [anon_sym_DOT] = ACTIONS(2557),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2559),
    [anon_sym_new] = ACTIONS(2557),
    [anon_sym_return_BANG] = ACTIONS(2559),
    [anon_sym_yield] = ACTIONS(2557),
    [anon_sym_yield_BANG] = ACTIONS(2559),
    [anon_sym_lazy] = ACTIONS(2557),
    [anon_sym_assert] = ACTIONS(2557),
    [anon_sym_upcast] = ACTIONS(2557),
    [anon_sym_downcast] = ACTIONS(2557),
    [anon_sym_COLON_GT] = ACTIONS(2559),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2559),
    [anon_sym_for] = ACTIONS(2557),
    [anon_sym_while] = ACTIONS(2557),
    [anon_sym_if] = ACTIONS(2557),
    [anon_sym_fun] = ACTIONS(2557),
    [anon_sym_DASH_GT] = ACTIONS(2557),
    [anon_sym_try] = ACTIONS(2557),
    [anon_sym_match] = ACTIONS(2557),
    [anon_sym_match_BANG] = ACTIONS(2559),
    [anon_sym_function] = ACTIONS(2557),
    [anon_sym_LT_DASH] = ACTIONS(2557),
    [anon_sym_DOT_LBRACK] = ACTIONS(2559),
    [anon_sym_LT] = ACTIONS(2559),
    [anon_sym_use] = ACTIONS(2557),
    [anon_sym_use_BANG] = ACTIONS(2559),
    [anon_sym_do_BANG] = ACTIONS(2559),
    [anon_sym_begin] = ACTIONS(2557),
    [anon_sym_LPAREN2] = ACTIONS(2557),
    [anon_sym_STAR] = ACTIONS(2557),
    [anon_sym_LT2] = ACTIONS(3519),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2559),
    [anon_sym_or] = ACTIONS(2557),
    [aux_sym_char_token1] = ACTIONS(2559),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2557),
    [anon_sym_DQUOTE] = ACTIONS(2557),
    [anon_sym_AT_DQUOTE] = ACTIONS(2559),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2559),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2559),
    [sym_bool] = ACTIONS(2557),
    [sym_unit] = ACTIONS(2559),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2557),
    [sym_op_identifier] = ACTIONS(2557),
    [anon_sym_PLUS] = ACTIONS(2557),
    [anon_sym_DASH] = ACTIONS(2557),
    [anon_sym_PLUS_DOT] = ACTIONS(2557),
    [anon_sym_DASH_DOT] = ACTIONS(2557),
    [anon_sym_PERCENT] = ACTIONS(2557),
    [anon_sym_AMP_AMP] = ACTIONS(2557),
    [anon_sym_TILDE] = ACTIONS(2559),
    [aux_sym_prefix_op_token1] = ACTIONS(2557),
    [aux_sym_infix_op_token1] = ACTIONS(2559),
    [aux_sym_infix_op_token2] = ACTIONS(2557),
    [anon_sym_PIPE_PIPE] = ACTIONS(2557),
    [anon_sym_BANG_EQ] = ACTIONS(2557),
    [anon_sym_COLON_EQ] = ACTIONS(2559),
    [anon_sym_DOLLAR] = ACTIONS(2557),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2557),
    [sym_int] = ACTIONS(2557),
    [sym_xint] = ACTIONS(2559),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2559),
    [sym__newline] = ACTIONS(2559),
  },
  [1378] = {
    [sym_block_comment] = STATE(1378),
    [sym_compiler_directive_decl] = STATE(1378),
    [sym_fsi_directive_decl] = STATE(1378),
    [sym_preproc_line] = STATE(1378),
    [sym_identifier] = ACTIONS(2627),
    [anon_sym_EQ] = ACTIONS(2629),
    [anon_sym_COLON] = ACTIONS(2627),
    [anon_sym_return] = ACTIONS(2627),
    [anon_sym_do] = ACTIONS(2627),
    [anon_sym_let] = ACTIONS(2627),
    [anon_sym_let_BANG] = ACTIONS(2629),
    [anon_sym_LPAREN] = ACTIONS(2627),
    [anon_sym_COMMA] = ACTIONS(2629),
    [anon_sym_null] = ACTIONS(2627),
    [anon_sym_QMARK] = ACTIONS(2627),
    [anon_sym_COLON_QMARK] = ACTIONS(2627),
    [anon_sym_COLON_COLON] = ACTIONS(2629),
    [anon_sym_AMP] = ACTIONS(2627),
    [anon_sym_LBRACK] = ACTIONS(2627),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2629),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_LT_AT] = ACTIONS(2627),
    [anon_sym_AT_GT] = ACTIONS(2627),
    [anon_sym_LT_AT_AT] = ACTIONS(2627),
    [anon_sym_DOT] = ACTIONS(2627),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2629),
    [anon_sym_new] = ACTIONS(2627),
    [anon_sym_return_BANG] = ACTIONS(2629),
    [anon_sym_yield] = ACTIONS(2627),
    [anon_sym_yield_BANG] = ACTIONS(2629),
    [anon_sym_lazy] = ACTIONS(2627),
    [anon_sym_assert] = ACTIONS(2627),
    [anon_sym_upcast] = ACTIONS(2627),
    [anon_sym_downcast] = ACTIONS(2627),
    [anon_sym_COLON_GT] = ACTIONS(2629),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2629),
    [anon_sym_for] = ACTIONS(2627),
    [anon_sym_while] = ACTIONS(2627),
    [anon_sym_if] = ACTIONS(2627),
    [anon_sym_fun] = ACTIONS(2627),
    [anon_sym_DASH_GT] = ACTIONS(2627),
    [anon_sym_try] = ACTIONS(2627),
    [anon_sym_match] = ACTIONS(2627),
    [anon_sym_match_BANG] = ACTIONS(2629),
    [anon_sym_function] = ACTIONS(2627),
    [anon_sym_LT_DASH] = ACTIONS(2627),
    [anon_sym_DOT_LBRACK] = ACTIONS(2629),
    [anon_sym_LT] = ACTIONS(2629),
    [anon_sym_use] = ACTIONS(2627),
    [anon_sym_use_BANG] = ACTIONS(2629),
    [anon_sym_do_BANG] = ACTIONS(2629),
    [anon_sym_begin] = ACTIONS(2627),
    [anon_sym_LPAREN2] = ACTIONS(2627),
    [anon_sym_STAR] = ACTIONS(2627),
    [anon_sym_LT2] = ACTIONS(2627),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2629),
    [anon_sym_or] = ACTIONS(2627),
    [aux_sym_char_token1] = ACTIONS(2629),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2627),
    [anon_sym_DQUOTE] = ACTIONS(2627),
    [anon_sym_AT_DQUOTE] = ACTIONS(2629),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2629),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2629),
    [sym_bool] = ACTIONS(2627),
    [sym_unit] = ACTIONS(2629),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2627),
    [sym_op_identifier] = ACTIONS(2627),
    [anon_sym_PLUS] = ACTIONS(2627),
    [anon_sym_DASH] = ACTIONS(2627),
    [anon_sym_PLUS_DOT] = ACTIONS(2627),
    [anon_sym_DASH_DOT] = ACTIONS(2627),
    [anon_sym_PERCENT] = ACTIONS(2627),
    [anon_sym_AMP_AMP] = ACTIONS(2627),
    [anon_sym_TILDE] = ACTIONS(2629),
    [aux_sym_prefix_op_token1] = ACTIONS(2627),
    [aux_sym_infix_op_token1] = ACTIONS(2629),
    [aux_sym_infix_op_token2] = ACTIONS(2627),
    [anon_sym_PIPE_PIPE] = ACTIONS(2627),
    [anon_sym_BANG_EQ] = ACTIONS(2627),
    [anon_sym_COLON_EQ] = ACTIONS(2629),
    [anon_sym_DOLLAR] = ACTIONS(2627),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2627),
    [sym_int] = ACTIONS(2627),
    [sym_xint] = ACTIONS(2629),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2629),
    [sym__newline] = ACTIONS(2629),
  },
  [1379] = {
    [sym_block_comment] = STATE(1379),
    [sym_compiler_directive_decl] = STATE(1379),
    [sym_fsi_directive_decl] = STATE(1379),
    [sym_preproc_line] = STATE(1379),
    [sym_identifier] = ACTIONS(2462),
    [anon_sym_EQ] = ACTIONS(2464),
    [anon_sym_COLON] = ACTIONS(2462),
    [anon_sym_return] = ACTIONS(2462),
    [anon_sym_do] = ACTIONS(2462),
    [anon_sym_let] = ACTIONS(2462),
    [anon_sym_let_BANG] = ACTIONS(2464),
    [anon_sym_LPAREN] = ACTIONS(2462),
    [anon_sym_COMMA] = ACTIONS(2464),
    [anon_sym_null] = ACTIONS(2462),
    [anon_sym_QMARK] = ACTIONS(2462),
    [anon_sym_COLON_QMARK] = ACTIONS(2462),
    [anon_sym_COLON_COLON] = ACTIONS(2464),
    [anon_sym_AMP] = ACTIONS(2462),
    [anon_sym_LBRACK] = ACTIONS(2462),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2464),
    [anon_sym_LBRACE] = ACTIONS(2462),
    [anon_sym_LT_AT] = ACTIONS(2462),
    [anon_sym_LT_AT_AT] = ACTIONS(2462),
    [anon_sym_AT_AT_GT] = ACTIONS(2462),
    [anon_sym_DOT] = ACTIONS(2462),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2464),
    [anon_sym_new] = ACTIONS(2462),
    [anon_sym_return_BANG] = ACTIONS(2464),
    [anon_sym_yield] = ACTIONS(2462),
    [anon_sym_yield_BANG] = ACTIONS(2464),
    [anon_sym_lazy] = ACTIONS(2462),
    [anon_sym_assert] = ACTIONS(2462),
    [anon_sym_upcast] = ACTIONS(2462),
    [anon_sym_downcast] = ACTIONS(2462),
    [anon_sym_COLON_GT] = ACTIONS(2464),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2464),
    [anon_sym_for] = ACTIONS(2462),
    [anon_sym_while] = ACTIONS(2462),
    [anon_sym_if] = ACTIONS(2462),
    [anon_sym_fun] = ACTIONS(2462),
    [anon_sym_DASH_GT] = ACTIONS(2462),
    [anon_sym_try] = ACTIONS(2462),
    [anon_sym_match] = ACTIONS(2462),
    [anon_sym_match_BANG] = ACTIONS(2464),
    [anon_sym_function] = ACTIONS(2462),
    [anon_sym_LT_DASH] = ACTIONS(2462),
    [anon_sym_DOT_LBRACK] = ACTIONS(2464),
    [anon_sym_LT] = ACTIONS(2464),
    [anon_sym_use] = ACTIONS(2462),
    [anon_sym_use_BANG] = ACTIONS(2464),
    [anon_sym_do_BANG] = ACTIONS(2464),
    [anon_sym_begin] = ACTIONS(2462),
    [anon_sym_LPAREN2] = ACTIONS(2462),
    [anon_sym_STAR] = ACTIONS(2462),
    [anon_sym_LT2] = ACTIONS(2462),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2464),
    [anon_sym_or] = ACTIONS(2462),
    [aux_sym_char_token1] = ACTIONS(2464),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2462),
    [anon_sym_DQUOTE] = ACTIONS(2462),
    [anon_sym_AT_DQUOTE] = ACTIONS(2464),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2464),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2464),
    [sym_bool] = ACTIONS(2462),
    [sym_unit] = ACTIONS(2464),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2462),
    [sym_op_identifier] = ACTIONS(2462),
    [anon_sym_PLUS] = ACTIONS(2462),
    [anon_sym_DASH] = ACTIONS(2462),
    [anon_sym_PLUS_DOT] = ACTIONS(2462),
    [anon_sym_DASH_DOT] = ACTIONS(2462),
    [anon_sym_PERCENT] = ACTIONS(2462),
    [anon_sym_AMP_AMP] = ACTIONS(2462),
    [anon_sym_TILDE] = ACTIONS(2464),
    [aux_sym_prefix_op_token1] = ACTIONS(2462),
    [aux_sym_infix_op_token1] = ACTIONS(2464),
    [aux_sym_infix_op_token2] = ACTIONS(2462),
    [anon_sym_PIPE_PIPE] = ACTIONS(2462),
    [anon_sym_BANG_EQ] = ACTIONS(2462),
    [anon_sym_COLON_EQ] = ACTIONS(2464),
    [anon_sym_DOLLAR] = ACTIONS(2462),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2462),
    [sym_int] = ACTIONS(2462),
    [sym_xint] = ACTIONS(2464),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2464),
    [sym__newline] = ACTIONS(2464),
  },
  [1380] = {
    [sym_block_comment] = STATE(1380),
    [sym_compiler_directive_decl] = STATE(1380),
    [sym_fsi_directive_decl] = STATE(1380),
    [sym_preproc_line] = STATE(1380),
    [sym_identifier] = ACTIONS(2506),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_COLON] = ACTIONS(2506),
    [anon_sym_return] = ACTIONS(2506),
    [anon_sym_do] = ACTIONS(2506),
    [anon_sym_let] = ACTIONS(2506),
    [anon_sym_let_BANG] = ACTIONS(2508),
    [anon_sym_LPAREN] = ACTIONS(2506),
    [anon_sym_COMMA] = ACTIONS(2508),
    [anon_sym_null] = ACTIONS(2506),
    [anon_sym_QMARK] = ACTIONS(2506),
    [anon_sym_COLON_QMARK] = ACTIONS(2506),
    [anon_sym_COLON_COLON] = ACTIONS(2508),
    [anon_sym_AMP] = ACTIONS(2506),
    [anon_sym_LBRACK] = ACTIONS(2506),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2508),
    [anon_sym_LBRACE] = ACTIONS(2506),
    [anon_sym_LT_AT] = ACTIONS(2506),
    [anon_sym_LT_AT_AT] = ACTIONS(2506),
    [anon_sym_DOT] = ACTIONS(2506),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2508),
    [anon_sym_new] = ACTIONS(2506),
    [anon_sym_return_BANG] = ACTIONS(2508),
    [anon_sym_yield] = ACTIONS(2506),
    [anon_sym_yield_BANG] = ACTIONS(2508),
    [anon_sym_lazy] = ACTIONS(2506),
    [anon_sym_assert] = ACTIONS(2506),
    [anon_sym_upcast] = ACTIONS(2506),
    [anon_sym_downcast] = ACTIONS(2506),
    [anon_sym_COLON_GT] = ACTIONS(2508),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2508),
    [anon_sym_for] = ACTIONS(2506),
    [anon_sym_while] = ACTIONS(2506),
    [anon_sym_if] = ACTIONS(2506),
    [anon_sym_fun] = ACTIONS(2506),
    [anon_sym_DASH_GT] = ACTIONS(2506),
    [anon_sym_try] = ACTIONS(2506),
    [anon_sym_match] = ACTIONS(2506),
    [anon_sym_match_BANG] = ACTIONS(2508),
    [anon_sym_function] = ACTIONS(2506),
    [anon_sym_LT_DASH] = ACTIONS(2506),
    [anon_sym_DOT_LBRACK] = ACTIONS(2508),
    [anon_sym_LT] = ACTIONS(2508),
    [anon_sym_use] = ACTIONS(2506),
    [anon_sym_use_BANG] = ACTIONS(2508),
    [anon_sym_do_BANG] = ACTIONS(2508),
    [anon_sym_DOT_DOT] = ACTIONS(2508),
    [anon_sym_begin] = ACTIONS(2506),
    [anon_sym_LPAREN2] = ACTIONS(2506),
    [anon_sym_STAR] = ACTIONS(2506),
    [anon_sym_LT2] = ACTIONS(2506),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2508),
    [anon_sym_or] = ACTIONS(2506),
    [aux_sym_char_token1] = ACTIONS(2508),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2506),
    [anon_sym_DQUOTE] = ACTIONS(2506),
    [anon_sym_AT_DQUOTE] = ACTIONS(2508),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2508),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2508),
    [sym_bool] = ACTIONS(2506),
    [sym_unit] = ACTIONS(2508),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2506),
    [sym_op_identifier] = ACTIONS(2506),
    [anon_sym_PLUS] = ACTIONS(2506),
    [anon_sym_DASH] = ACTIONS(2506),
    [anon_sym_PLUS_DOT] = ACTIONS(2506),
    [anon_sym_DASH_DOT] = ACTIONS(2506),
    [anon_sym_PERCENT] = ACTIONS(2506),
    [anon_sym_AMP_AMP] = ACTIONS(2506),
    [anon_sym_TILDE] = ACTIONS(2508),
    [aux_sym_prefix_op_token1] = ACTIONS(2506),
    [aux_sym_infix_op_token1] = ACTIONS(2508),
    [aux_sym_infix_op_token2] = ACTIONS(2506),
    [anon_sym_PIPE_PIPE] = ACTIONS(2506),
    [anon_sym_BANG_EQ] = ACTIONS(2506),
    [anon_sym_COLON_EQ] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(2506),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2506),
    [sym_int] = ACTIONS(2506),
    [sym_xint] = ACTIONS(2508),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2508),
    [sym__newline] = ACTIONS(2508),
  },
  [1381] = {
    [sym_block_comment] = STATE(1381),
    [sym_compiler_directive_decl] = STATE(1381),
    [sym_fsi_directive_decl] = STATE(1381),
    [sym_preproc_line] = STATE(1381),
    [sym_identifier] = ACTIONS(2466),
    [anon_sym_EQ] = ACTIONS(2468),
    [anon_sym_COLON] = ACTIONS(2466),
    [anon_sym_return] = ACTIONS(2466),
    [anon_sym_do] = ACTIONS(2466),
    [anon_sym_let] = ACTIONS(2466),
    [anon_sym_let_BANG] = ACTIONS(2468),
    [anon_sym_LPAREN] = ACTIONS(2466),
    [anon_sym_COMMA] = ACTIONS(2468),
    [anon_sym_null] = ACTIONS(2466),
    [anon_sym_QMARK] = ACTIONS(2466),
    [anon_sym_COLON_QMARK] = ACTIONS(2466),
    [anon_sym_COLON_COLON] = ACTIONS(2468),
    [anon_sym_AMP] = ACTIONS(2466),
    [anon_sym_LBRACK] = ACTIONS(2466),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2468),
    [anon_sym_LBRACE] = ACTIONS(2466),
    [anon_sym_LT_AT] = ACTIONS(2466),
    [anon_sym_AT_GT] = ACTIONS(2466),
    [anon_sym_LT_AT_AT] = ACTIONS(2466),
    [anon_sym_DOT] = ACTIONS(2466),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2468),
    [anon_sym_new] = ACTIONS(2466),
    [anon_sym_return_BANG] = ACTIONS(2468),
    [anon_sym_yield] = ACTIONS(2466),
    [anon_sym_yield_BANG] = ACTIONS(2468),
    [anon_sym_lazy] = ACTIONS(2466),
    [anon_sym_assert] = ACTIONS(2466),
    [anon_sym_upcast] = ACTIONS(2466),
    [anon_sym_downcast] = ACTIONS(2466),
    [anon_sym_COLON_GT] = ACTIONS(2468),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2468),
    [anon_sym_for] = ACTIONS(2466),
    [anon_sym_while] = ACTIONS(2466),
    [anon_sym_if] = ACTIONS(2466),
    [anon_sym_fun] = ACTIONS(2466),
    [anon_sym_DASH_GT] = ACTIONS(2466),
    [anon_sym_try] = ACTIONS(2466),
    [anon_sym_match] = ACTIONS(2466),
    [anon_sym_match_BANG] = ACTIONS(2468),
    [anon_sym_function] = ACTIONS(2466),
    [anon_sym_LT_DASH] = ACTIONS(2466),
    [anon_sym_DOT_LBRACK] = ACTIONS(2468),
    [anon_sym_LT] = ACTIONS(2468),
    [anon_sym_use] = ACTIONS(2466),
    [anon_sym_use_BANG] = ACTIONS(2468),
    [anon_sym_do_BANG] = ACTIONS(2468),
    [anon_sym_begin] = ACTIONS(2466),
    [anon_sym_LPAREN2] = ACTIONS(2466),
    [anon_sym_STAR] = ACTIONS(2466),
    [anon_sym_LT2] = ACTIONS(2466),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2468),
    [anon_sym_or] = ACTIONS(2466),
    [aux_sym_char_token1] = ACTIONS(2468),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2466),
    [anon_sym_DQUOTE] = ACTIONS(2466),
    [anon_sym_AT_DQUOTE] = ACTIONS(2468),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2468),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2468),
    [sym_bool] = ACTIONS(2466),
    [sym_unit] = ACTIONS(2468),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2466),
    [sym_op_identifier] = ACTIONS(2466),
    [anon_sym_PLUS] = ACTIONS(2466),
    [anon_sym_DASH] = ACTIONS(2466),
    [anon_sym_PLUS_DOT] = ACTIONS(2466),
    [anon_sym_DASH_DOT] = ACTIONS(2466),
    [anon_sym_PERCENT] = ACTIONS(2466),
    [anon_sym_AMP_AMP] = ACTIONS(2466),
    [anon_sym_TILDE] = ACTIONS(2468),
    [aux_sym_prefix_op_token1] = ACTIONS(2466),
    [aux_sym_infix_op_token1] = ACTIONS(2468),
    [aux_sym_infix_op_token2] = ACTIONS(2466),
    [anon_sym_PIPE_PIPE] = ACTIONS(2466),
    [anon_sym_BANG_EQ] = ACTIONS(2466),
    [anon_sym_COLON_EQ] = ACTIONS(2468),
    [anon_sym_DOLLAR] = ACTIONS(2466),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2466),
    [sym_int] = ACTIONS(2466),
    [sym_xint] = ACTIONS(2468),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2468),
    [sym__newline] = ACTIONS(2468),
  },
  [1382] = {
    [sym_block_comment] = STATE(1382),
    [sym_compiler_directive_decl] = STATE(1382),
    [sym_fsi_directive_decl] = STATE(1382),
    [sym_preproc_line] = STATE(1382),
    [sym_identifier] = ACTIONS(2470),
    [anon_sym_EQ] = ACTIONS(2472),
    [anon_sym_COLON] = ACTIONS(2470),
    [anon_sym_return] = ACTIONS(2470),
    [anon_sym_do] = ACTIONS(2470),
    [anon_sym_let] = ACTIONS(2470),
    [anon_sym_let_BANG] = ACTIONS(2472),
    [anon_sym_LPAREN] = ACTIONS(2470),
    [anon_sym_COMMA] = ACTIONS(2472),
    [anon_sym_null] = ACTIONS(2470),
    [anon_sym_QMARK] = ACTIONS(2470),
    [anon_sym_COLON_QMARK] = ACTIONS(2470),
    [anon_sym_COLON_COLON] = ACTIONS(2472),
    [anon_sym_AMP] = ACTIONS(2470),
    [anon_sym_LBRACK] = ACTIONS(2470),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2472),
    [anon_sym_LBRACE] = ACTIONS(2470),
    [anon_sym_LT_AT] = ACTIONS(2470),
    [anon_sym_LT_AT_AT] = ACTIONS(2470),
    [anon_sym_DOT] = ACTIONS(2470),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2472),
    [anon_sym_new] = ACTIONS(2470),
    [anon_sym_return_BANG] = ACTIONS(2472),
    [anon_sym_yield] = ACTIONS(2470),
    [anon_sym_yield_BANG] = ACTIONS(2472),
    [anon_sym_lazy] = ACTIONS(2470),
    [anon_sym_assert] = ACTIONS(2470),
    [anon_sym_upcast] = ACTIONS(2470),
    [anon_sym_downcast] = ACTIONS(2470),
    [anon_sym_COLON_GT] = ACTIONS(2472),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2472),
    [anon_sym_for] = ACTIONS(2470),
    [anon_sym_while] = ACTIONS(2470),
    [anon_sym_if] = ACTIONS(2470),
    [anon_sym_fun] = ACTIONS(2470),
    [anon_sym_DASH_GT] = ACTIONS(2470),
    [anon_sym_try] = ACTIONS(2470),
    [anon_sym_match] = ACTIONS(2470),
    [anon_sym_match_BANG] = ACTIONS(2472),
    [anon_sym_function] = ACTIONS(2470),
    [anon_sym_LT_DASH] = ACTIONS(2470),
    [anon_sym_DOT_LBRACK] = ACTIONS(2472),
    [anon_sym_LT] = ACTIONS(2472),
    [anon_sym_use] = ACTIONS(2470),
    [anon_sym_use_BANG] = ACTIONS(2472),
    [anon_sym_do_BANG] = ACTIONS(2472),
    [anon_sym_DOT_DOT] = ACTIONS(2472),
    [anon_sym_begin] = ACTIONS(2470),
    [anon_sym_LPAREN2] = ACTIONS(2470),
    [anon_sym_STAR] = ACTIONS(2470),
    [anon_sym_LT2] = ACTIONS(2470),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2472),
    [anon_sym_or] = ACTIONS(2470),
    [aux_sym_char_token1] = ACTIONS(2472),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2470),
    [anon_sym_DQUOTE] = ACTIONS(2470),
    [anon_sym_AT_DQUOTE] = ACTIONS(2472),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2472),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2472),
    [sym_bool] = ACTIONS(2470),
    [sym_unit] = ACTIONS(2472),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2470),
    [sym_op_identifier] = ACTIONS(2470),
    [anon_sym_PLUS] = ACTIONS(2470),
    [anon_sym_DASH] = ACTIONS(2470),
    [anon_sym_PLUS_DOT] = ACTIONS(2470),
    [anon_sym_DASH_DOT] = ACTIONS(2470),
    [anon_sym_PERCENT] = ACTIONS(2470),
    [anon_sym_AMP_AMP] = ACTIONS(2470),
    [anon_sym_TILDE] = ACTIONS(2472),
    [aux_sym_prefix_op_token1] = ACTIONS(2470),
    [aux_sym_infix_op_token1] = ACTIONS(2472),
    [aux_sym_infix_op_token2] = ACTIONS(2470),
    [anon_sym_PIPE_PIPE] = ACTIONS(2470),
    [anon_sym_BANG_EQ] = ACTIONS(2470),
    [anon_sym_COLON_EQ] = ACTIONS(2472),
    [anon_sym_DOLLAR] = ACTIONS(2470),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2470),
    [sym_int] = ACTIONS(2470),
    [sym_xint] = ACTIONS(2472),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2472),
    [sym__newline] = ACTIONS(2472),
  },
  [1383] = {
    [sym_block_comment] = STATE(1383),
    [sym_compiler_directive_decl] = STATE(1383),
    [sym_fsi_directive_decl] = STATE(1383),
    [sym_preproc_line] = STATE(1383),
    [sym_identifier] = ACTIONS(2454),
    [anon_sym_EQ] = ACTIONS(2456),
    [anon_sym_COLON] = ACTIONS(2454),
    [anon_sym_return] = ACTIONS(2454),
    [anon_sym_do] = ACTIONS(2454),
    [anon_sym_let] = ACTIONS(2454),
    [anon_sym_let_BANG] = ACTIONS(2456),
    [anon_sym_LPAREN] = ACTIONS(2454),
    [anon_sym_COMMA] = ACTIONS(2456),
    [anon_sym_null] = ACTIONS(2454),
    [anon_sym_QMARK] = ACTIONS(2454),
    [anon_sym_COLON_QMARK] = ACTIONS(2454),
    [anon_sym_COLON_COLON] = ACTIONS(2456),
    [anon_sym_AMP] = ACTIONS(2454),
    [anon_sym_LBRACK] = ACTIONS(2454),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2456),
    [anon_sym_LBRACE] = ACTIONS(2454),
    [anon_sym_LT_AT] = ACTIONS(2454),
    [anon_sym_LT_AT_AT] = ACTIONS(2454),
    [anon_sym_DOT] = ACTIONS(2454),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2456),
    [anon_sym_new] = ACTIONS(2454),
    [anon_sym_return_BANG] = ACTIONS(2456),
    [anon_sym_yield] = ACTIONS(2454),
    [anon_sym_yield_BANG] = ACTIONS(2456),
    [anon_sym_lazy] = ACTIONS(2454),
    [anon_sym_assert] = ACTIONS(2454),
    [anon_sym_upcast] = ACTIONS(2454),
    [anon_sym_downcast] = ACTIONS(2454),
    [anon_sym_COLON_GT] = ACTIONS(2456),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2456),
    [anon_sym_for] = ACTIONS(2454),
    [anon_sym_while] = ACTIONS(2454),
    [anon_sym_if] = ACTIONS(2454),
    [anon_sym_fun] = ACTIONS(2454),
    [anon_sym_DASH_GT] = ACTIONS(2454),
    [anon_sym_try] = ACTIONS(2454),
    [anon_sym_match] = ACTIONS(2454),
    [anon_sym_match_BANG] = ACTIONS(2456),
    [anon_sym_function] = ACTIONS(2454),
    [anon_sym_LT_DASH] = ACTIONS(2454),
    [anon_sym_DOT_LBRACK] = ACTIONS(2456),
    [anon_sym_LT] = ACTIONS(2456),
    [anon_sym_use] = ACTIONS(2454),
    [anon_sym_use_BANG] = ACTIONS(2456),
    [anon_sym_do_BANG] = ACTIONS(2456),
    [anon_sym_DOT_DOT] = ACTIONS(2456),
    [anon_sym_begin] = ACTIONS(2454),
    [anon_sym_LPAREN2] = ACTIONS(2454),
    [anon_sym_STAR] = ACTIONS(2454),
    [anon_sym_LT2] = ACTIONS(2454),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2456),
    [anon_sym_or] = ACTIONS(2454),
    [aux_sym_char_token1] = ACTIONS(2456),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2454),
    [anon_sym_DQUOTE] = ACTIONS(2454),
    [anon_sym_AT_DQUOTE] = ACTIONS(2456),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2456),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2456),
    [sym_bool] = ACTIONS(2454),
    [sym_unit] = ACTIONS(2456),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2454),
    [sym_op_identifier] = ACTIONS(2454),
    [anon_sym_PLUS] = ACTIONS(2454),
    [anon_sym_DASH] = ACTIONS(2454),
    [anon_sym_PLUS_DOT] = ACTIONS(2454),
    [anon_sym_DASH_DOT] = ACTIONS(2454),
    [anon_sym_PERCENT] = ACTIONS(2454),
    [anon_sym_AMP_AMP] = ACTIONS(2454),
    [anon_sym_TILDE] = ACTIONS(2456),
    [aux_sym_prefix_op_token1] = ACTIONS(2454),
    [aux_sym_infix_op_token1] = ACTIONS(2456),
    [aux_sym_infix_op_token2] = ACTIONS(2454),
    [anon_sym_PIPE_PIPE] = ACTIONS(2454),
    [anon_sym_BANG_EQ] = ACTIONS(2454),
    [anon_sym_COLON_EQ] = ACTIONS(2456),
    [anon_sym_DOLLAR] = ACTIONS(2454),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2454),
    [sym_int] = ACTIONS(2454),
    [sym_xint] = ACTIONS(2456),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2456),
    [sym__newline] = ACTIONS(2456),
  },
  [1384] = {
    [sym_block_comment] = STATE(1384),
    [sym_compiler_directive_decl] = STATE(1384),
    [sym_fsi_directive_decl] = STATE(1384),
    [sym_preproc_line] = STATE(1384),
    [sym_identifier] = ACTIONS(2812),
    [anon_sym_EQ] = ACTIONS(2814),
    [anon_sym_COLON] = ACTIONS(2812),
    [anon_sym_return] = ACTIONS(2812),
    [anon_sym_do] = ACTIONS(2812),
    [anon_sym_let] = ACTIONS(2812),
    [anon_sym_let_BANG] = ACTIONS(2814),
    [anon_sym_as] = ACTIONS(2812),
    [anon_sym_LPAREN] = ACTIONS(2812),
    [anon_sym_COMMA] = ACTIONS(2814),
    [anon_sym_null] = ACTIONS(2812),
    [anon_sym_QMARK] = ACTIONS(2812),
    [anon_sym_COLON_QMARK] = ACTIONS(2812),
    [anon_sym_COLON_COLON] = ACTIONS(2814),
    [anon_sym_AMP] = ACTIONS(2812),
    [anon_sym_LBRACK] = ACTIONS(2812),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2814),
    [anon_sym_LBRACE] = ACTIONS(2812),
    [anon_sym_LT_AT] = ACTIONS(2812),
    [anon_sym_LT_AT_AT] = ACTIONS(2812),
    [anon_sym_DOT] = ACTIONS(2812),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2814),
    [anon_sym_new] = ACTIONS(2812),
    [anon_sym_with] = ACTIONS(2812),
    [anon_sym_return_BANG] = ACTIONS(2814),
    [anon_sym_yield] = ACTIONS(2812),
    [anon_sym_yield_BANG] = ACTIONS(2814),
    [anon_sym_lazy] = ACTIONS(2812),
    [anon_sym_assert] = ACTIONS(2812),
    [anon_sym_upcast] = ACTIONS(2812),
    [anon_sym_downcast] = ACTIONS(2812),
    [anon_sym_COLON_GT] = ACTIONS(2814),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2814),
    [anon_sym_for] = ACTIONS(2812),
    [anon_sym_while] = ACTIONS(2812),
    [anon_sym_if] = ACTIONS(2812),
    [anon_sym_fun] = ACTIONS(2812),
    [anon_sym_try] = ACTIONS(2812),
    [anon_sym_match] = ACTIONS(2812),
    [anon_sym_match_BANG] = ACTIONS(2814),
    [anon_sym_function] = ACTIONS(2812),
    [anon_sym_LT_DASH] = ACTIONS(2812),
    [anon_sym_DOT_LBRACK] = ACTIONS(2814),
    [anon_sym_LT] = ACTIONS(2814),
    [anon_sym_use] = ACTIONS(2812),
    [anon_sym_use_BANG] = ACTIONS(2814),
    [anon_sym_do_BANG] = ACTIONS(2814),
    [anon_sym_begin] = ACTIONS(2812),
    [anon_sym_LPAREN2] = ACTIONS(2812),
    [anon_sym_or] = ACTIONS(2812),
    [aux_sym_char_token1] = ACTIONS(2814),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2812),
    [anon_sym_DQUOTE] = ACTIONS(2812),
    [anon_sym_AT_DQUOTE] = ACTIONS(2814),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2814),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2814),
    [sym_bool] = ACTIONS(2812),
    [sym_unit] = ACTIONS(2814),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2812),
    [sym_op_identifier] = ACTIONS(2812),
    [anon_sym_PLUS] = ACTIONS(2812),
    [anon_sym_DASH] = ACTIONS(2812),
    [anon_sym_PLUS_DOT] = ACTIONS(2812),
    [anon_sym_DASH_DOT] = ACTIONS(2812),
    [anon_sym_PERCENT] = ACTIONS(2812),
    [anon_sym_AMP_AMP] = ACTIONS(2812),
    [anon_sym_TILDE] = ACTIONS(2814),
    [aux_sym_prefix_op_token1] = ACTIONS(2812),
    [aux_sym_infix_op_token1] = ACTIONS(2814),
    [aux_sym_infix_op_token2] = ACTIONS(2812),
    [anon_sym_PIPE_PIPE] = ACTIONS(2812),
    [anon_sym_BANG_EQ] = ACTIONS(2812),
    [anon_sym_COLON_EQ] = ACTIONS(2814),
    [anon_sym_DOLLAR] = ACTIONS(2812),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2812),
    [sym_int] = ACTIONS(2812),
    [sym_xint] = ACTIONS(2814),
    [anon_sym_f] = ACTIONS(2812),
    [aux_sym_decimal_token1] = ACTIONS(2812),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2814),
    [sym__newline] = ACTIONS(2814),
    [sym__dedent] = ACTIONS(2814),
  },
  [1385] = {
    [sym_block_comment] = STATE(1385),
    [sym_compiler_directive_decl] = STATE(1385),
    [sym_fsi_directive_decl] = STATE(1385),
    [sym_preproc_line] = STATE(1385),
    [sym_identifier] = ACTIONS(2819),
    [anon_sym_EQ] = ACTIONS(2821),
    [anon_sym_COLON] = ACTIONS(2819),
    [anon_sym_return] = ACTIONS(2819),
    [anon_sym_do] = ACTIONS(2819),
    [anon_sym_let] = ACTIONS(2819),
    [anon_sym_let_BANG] = ACTIONS(2821),
    [anon_sym_LPAREN] = ACTIONS(2819),
    [anon_sym_COMMA] = ACTIONS(2821),
    [anon_sym_null] = ACTIONS(2819),
    [anon_sym_QMARK] = ACTIONS(2819),
    [anon_sym_COLON_QMARK] = ACTIONS(2819),
    [anon_sym_COLON_COLON] = ACTIONS(2821),
    [anon_sym_AMP] = ACTIONS(2819),
    [anon_sym_LBRACK] = ACTIONS(2819),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2821),
    [anon_sym_LBRACE] = ACTIONS(2819),
    [anon_sym_LT_AT] = ACTIONS(2819),
    [anon_sym_LT_AT_AT] = ACTIONS(2819),
    [anon_sym_DOT] = ACTIONS(2819),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2821),
    [anon_sym_new] = ACTIONS(2819),
    [anon_sym_with] = ACTIONS(2819),
    [anon_sym_return_BANG] = ACTIONS(2821),
    [anon_sym_yield] = ACTIONS(2819),
    [anon_sym_yield_BANG] = ACTIONS(2821),
    [anon_sym_lazy] = ACTIONS(2819),
    [anon_sym_assert] = ACTIONS(2819),
    [anon_sym_upcast] = ACTIONS(2819),
    [anon_sym_downcast] = ACTIONS(2819),
    [anon_sym_COLON_GT] = ACTIONS(2821),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2821),
    [anon_sym_for] = ACTIONS(2819),
    [anon_sym_while] = ACTIONS(2819),
    [anon_sym_if] = ACTIONS(2819),
    [anon_sym_fun] = ACTIONS(2819),
    [anon_sym_try] = ACTIONS(2819),
    [anon_sym_match] = ACTIONS(2819),
    [anon_sym_match_BANG] = ACTIONS(2821),
    [anon_sym_function] = ACTIONS(2819),
    [anon_sym_LT_DASH] = ACTIONS(2819),
    [anon_sym_DOT_LBRACK] = ACTIONS(2821),
    [anon_sym_LT] = ACTIONS(2821),
    [anon_sym_use] = ACTIONS(2819),
    [anon_sym_use_BANG] = ACTIONS(2821),
    [anon_sym_do_BANG] = ACTIONS(2821),
    [anon_sym_begin] = ACTIONS(2819),
    [anon_sym_LPAREN2] = ACTIONS(2819),
    [anon_sym_DOT_DOT2] = ACTIONS(2821),
    [anon_sym_or] = ACTIONS(2819),
    [aux_sym_char_token1] = ACTIONS(2821),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2819),
    [anon_sym_DQUOTE] = ACTIONS(2819),
    [anon_sym_AT_DQUOTE] = ACTIONS(2821),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2821),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2821),
    [sym_bool] = ACTIONS(2819),
    [sym_unit] = ACTIONS(2821),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2819),
    [sym_op_identifier] = ACTIONS(2819),
    [anon_sym_PLUS] = ACTIONS(2819),
    [anon_sym_DASH] = ACTIONS(2819),
    [anon_sym_PLUS_DOT] = ACTIONS(2819),
    [anon_sym_DASH_DOT] = ACTIONS(2819),
    [anon_sym_PERCENT] = ACTIONS(2819),
    [anon_sym_AMP_AMP] = ACTIONS(2819),
    [anon_sym_TILDE] = ACTIONS(2821),
    [aux_sym_prefix_op_token1] = ACTIONS(2819),
    [aux_sym_infix_op_token1] = ACTIONS(2821),
    [aux_sym_infix_op_token2] = ACTIONS(2819),
    [anon_sym_PIPE_PIPE] = ACTIONS(2819),
    [anon_sym_BANG_EQ] = ACTIONS(2819),
    [anon_sym_COLON_EQ] = ACTIONS(2821),
    [anon_sym_DOLLAR] = ACTIONS(2819),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2819),
    [sym_int] = ACTIONS(3521),
    [sym_xint] = ACTIONS(2821),
    [anon_sym_f] = ACTIONS(2819),
    [aux_sym_decimal_token1] = ACTIONS(2819),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2821),
    [sym__newline] = ACTIONS(2821),
    [sym__dedent] = ACTIONS(2821),
  },
  [1386] = {
    [sym_block_comment] = STATE(1386),
    [sym_compiler_directive_decl] = STATE(1386),
    [sym_fsi_directive_decl] = STATE(1386),
    [sym_preproc_line] = STATE(1386),
    [sym_identifier] = ACTIONS(2723),
    [anon_sym_EQ] = ACTIONS(2725),
    [anon_sym_COLON] = ACTIONS(2723),
    [anon_sym_return] = ACTIONS(2723),
    [anon_sym_do] = ACTIONS(2723),
    [anon_sym_let] = ACTIONS(2723),
    [anon_sym_let_BANG] = ACTIONS(2725),
    [anon_sym_as] = ACTIONS(2723),
    [anon_sym_LPAREN] = ACTIONS(2723),
    [anon_sym_COMMA] = ACTIONS(2725),
    [anon_sym_null] = ACTIONS(2723),
    [anon_sym_QMARK] = ACTIONS(2723),
    [anon_sym_COLON_QMARK] = ACTIONS(2723),
    [anon_sym_COLON_COLON] = ACTIONS(2725),
    [anon_sym_AMP] = ACTIONS(2723),
    [anon_sym_LBRACK] = ACTIONS(2723),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2725),
    [anon_sym_LBRACE] = ACTIONS(2723),
    [anon_sym_LT_AT] = ACTIONS(2723),
    [anon_sym_LT_AT_AT] = ACTIONS(2723),
    [anon_sym_DOT] = ACTIONS(2723),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2725),
    [anon_sym_new] = ACTIONS(2723),
    [anon_sym_with] = ACTIONS(2723),
    [anon_sym_return_BANG] = ACTIONS(2725),
    [anon_sym_yield] = ACTIONS(2723),
    [anon_sym_yield_BANG] = ACTIONS(2725),
    [anon_sym_lazy] = ACTIONS(2723),
    [anon_sym_assert] = ACTIONS(2723),
    [anon_sym_upcast] = ACTIONS(2723),
    [anon_sym_downcast] = ACTIONS(2723),
    [anon_sym_COLON_GT] = ACTIONS(2725),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2725),
    [anon_sym_for] = ACTIONS(2723),
    [anon_sym_while] = ACTIONS(2723),
    [anon_sym_if] = ACTIONS(2723),
    [anon_sym_fun] = ACTIONS(2723),
    [anon_sym_try] = ACTIONS(2723),
    [anon_sym_match] = ACTIONS(2723),
    [anon_sym_match_BANG] = ACTIONS(2725),
    [anon_sym_function] = ACTIONS(2723),
    [anon_sym_LT_DASH] = ACTIONS(2723),
    [anon_sym_DOT_LBRACK] = ACTIONS(2725),
    [anon_sym_LT] = ACTIONS(2725),
    [anon_sym_use] = ACTIONS(2723),
    [anon_sym_use_BANG] = ACTIONS(2725),
    [anon_sym_do_BANG] = ACTIONS(2725),
    [anon_sym_begin] = ACTIONS(2723),
    [anon_sym_LPAREN2] = ACTIONS(2723),
    [anon_sym_or] = ACTIONS(2723),
    [aux_sym_char_token1] = ACTIONS(2725),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2723),
    [anon_sym_DQUOTE] = ACTIONS(2723),
    [anon_sym_AT_DQUOTE] = ACTIONS(2725),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2725),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2725),
    [sym_bool] = ACTIONS(2723),
    [sym_unit] = ACTIONS(2725),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2723),
    [sym_op_identifier] = ACTIONS(2723),
    [anon_sym_PLUS] = ACTIONS(2723),
    [anon_sym_DASH] = ACTIONS(2723),
    [anon_sym_PLUS_DOT] = ACTIONS(2723),
    [anon_sym_DASH_DOT] = ACTIONS(2723),
    [anon_sym_PERCENT] = ACTIONS(2723),
    [anon_sym_AMP_AMP] = ACTIONS(2723),
    [anon_sym_TILDE] = ACTIONS(2725),
    [aux_sym_prefix_op_token1] = ACTIONS(2723),
    [aux_sym_infix_op_token1] = ACTIONS(2725),
    [aux_sym_infix_op_token2] = ACTIONS(2723),
    [anon_sym_PIPE_PIPE] = ACTIONS(2723),
    [anon_sym_BANG_EQ] = ACTIONS(2723),
    [anon_sym_COLON_EQ] = ACTIONS(2725),
    [anon_sym_DOLLAR] = ACTIONS(2723),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2723),
    [sym_int] = ACTIONS(2723),
    [sym_xint] = ACTIONS(2725),
    [anon_sym_f] = ACTIONS(2723),
    [aux_sym_decimal_token1] = ACTIONS(2723),
    [aux_sym_float_token1] = ACTIONS(3523),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2725),
    [sym__newline] = ACTIONS(2725),
  },
  [1387] = {
    [sym_block_comment] = STATE(1387),
    [sym_compiler_directive_decl] = STATE(1387),
    [sym_fsi_directive_decl] = STATE(1387),
    [sym_preproc_line] = STATE(1387),
    [sym_identifier] = ACTIONS(2411),
    [anon_sym_EQ] = ACTIONS(2413),
    [anon_sym_COLON] = ACTIONS(2411),
    [anon_sym_return] = ACTIONS(2411),
    [anon_sym_do] = ACTIONS(2411),
    [anon_sym_let] = ACTIONS(2411),
    [anon_sym_let_BANG] = ACTIONS(2413),
    [anon_sym_LPAREN] = ACTIONS(2411),
    [anon_sym_COMMA] = ACTIONS(2413),
    [anon_sym_null] = ACTIONS(2411),
    [anon_sym_QMARK] = ACTIONS(2411),
    [anon_sym_COLON_QMARK] = ACTIONS(2411),
    [anon_sym_COLON_COLON] = ACTIONS(2413),
    [anon_sym_AMP] = ACTIONS(2411),
    [anon_sym_LBRACK] = ACTIONS(2411),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2413),
    [anon_sym_LBRACE] = ACTIONS(2411),
    [anon_sym_LT_AT] = ACTIONS(2411),
    [anon_sym_LT_AT_AT] = ACTIONS(2411),
    [anon_sym_AT_AT_GT] = ACTIONS(2411),
    [anon_sym_DOT] = ACTIONS(2411),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2413),
    [anon_sym_new] = ACTIONS(2411),
    [anon_sym_return_BANG] = ACTIONS(2413),
    [anon_sym_yield] = ACTIONS(2411),
    [anon_sym_yield_BANG] = ACTIONS(2413),
    [anon_sym_lazy] = ACTIONS(2411),
    [anon_sym_assert] = ACTIONS(2411),
    [anon_sym_upcast] = ACTIONS(2411),
    [anon_sym_downcast] = ACTIONS(2411),
    [anon_sym_COLON_GT] = ACTIONS(2413),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2413),
    [anon_sym_for] = ACTIONS(2411),
    [anon_sym_while] = ACTIONS(2411),
    [anon_sym_if] = ACTIONS(2411),
    [anon_sym_fun] = ACTIONS(2411),
    [anon_sym_DASH_GT] = ACTIONS(2411),
    [anon_sym_try] = ACTIONS(2411),
    [anon_sym_match] = ACTIONS(2411),
    [anon_sym_match_BANG] = ACTIONS(2413),
    [anon_sym_function] = ACTIONS(2411),
    [anon_sym_LT_DASH] = ACTIONS(2411),
    [anon_sym_DOT_LBRACK] = ACTIONS(2413),
    [anon_sym_LT] = ACTIONS(2413),
    [anon_sym_use] = ACTIONS(2411),
    [anon_sym_use_BANG] = ACTIONS(2413),
    [anon_sym_do_BANG] = ACTIONS(2413),
    [anon_sym_begin] = ACTIONS(2411),
    [anon_sym_LPAREN2] = ACTIONS(2411),
    [anon_sym_STAR] = ACTIONS(2411),
    [anon_sym_LT2] = ACTIONS(2411),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2413),
    [anon_sym_or] = ACTIONS(2411),
    [aux_sym_char_token1] = ACTIONS(2413),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2411),
    [anon_sym_DQUOTE] = ACTIONS(2411),
    [anon_sym_AT_DQUOTE] = ACTIONS(2413),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2413),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2413),
    [sym_bool] = ACTIONS(2411),
    [sym_unit] = ACTIONS(2413),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2411),
    [sym_op_identifier] = ACTIONS(2411),
    [anon_sym_PLUS] = ACTIONS(2411),
    [anon_sym_DASH] = ACTIONS(2411),
    [anon_sym_PLUS_DOT] = ACTIONS(2411),
    [anon_sym_DASH_DOT] = ACTIONS(2411),
    [anon_sym_PERCENT] = ACTIONS(2411),
    [anon_sym_AMP_AMP] = ACTIONS(2411),
    [anon_sym_TILDE] = ACTIONS(2413),
    [aux_sym_prefix_op_token1] = ACTIONS(2411),
    [aux_sym_infix_op_token1] = ACTIONS(2413),
    [aux_sym_infix_op_token2] = ACTIONS(2411),
    [anon_sym_PIPE_PIPE] = ACTIONS(2411),
    [anon_sym_BANG_EQ] = ACTIONS(2411),
    [anon_sym_COLON_EQ] = ACTIONS(2413),
    [anon_sym_DOLLAR] = ACTIONS(2411),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2411),
    [sym_int] = ACTIONS(2411),
    [sym_xint] = ACTIONS(2413),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2413),
    [sym__newline] = ACTIONS(2413),
  },
  [1388] = {
    [sym_block_comment] = STATE(1388),
    [sym_compiler_directive_decl] = STATE(1388),
    [sym_fsi_directive_decl] = STATE(1388),
    [sym_preproc_line] = STATE(1388),
    [sym_identifier] = ACTIONS(2321),
    [anon_sym_EQ] = ACTIONS(2323),
    [anon_sym_COLON] = ACTIONS(2321),
    [anon_sym_return] = ACTIONS(2321),
    [anon_sym_do] = ACTIONS(2321),
    [anon_sym_let] = ACTIONS(2321),
    [anon_sym_let_BANG] = ACTIONS(2323),
    [anon_sym_LPAREN] = ACTIONS(2321),
    [anon_sym_COMMA] = ACTIONS(2323),
    [anon_sym_null] = ACTIONS(2321),
    [anon_sym_QMARK] = ACTIONS(2321),
    [anon_sym_COLON_QMARK] = ACTIONS(2321),
    [anon_sym_COLON_COLON] = ACTIONS(2323),
    [anon_sym_AMP] = ACTIONS(2321),
    [anon_sym_LBRACK] = ACTIONS(2321),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2323),
    [anon_sym_LBRACE] = ACTIONS(2321),
    [anon_sym_LT_AT] = ACTIONS(2321),
    [anon_sym_AT_GT] = ACTIONS(2321),
    [anon_sym_LT_AT_AT] = ACTIONS(2321),
    [anon_sym_DOT] = ACTIONS(2321),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2323),
    [anon_sym_new] = ACTIONS(2321),
    [anon_sym_return_BANG] = ACTIONS(2323),
    [anon_sym_yield] = ACTIONS(2321),
    [anon_sym_yield_BANG] = ACTIONS(2323),
    [anon_sym_lazy] = ACTIONS(2321),
    [anon_sym_assert] = ACTIONS(2321),
    [anon_sym_upcast] = ACTIONS(2321),
    [anon_sym_downcast] = ACTIONS(2321),
    [anon_sym_COLON_GT] = ACTIONS(2323),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2323),
    [anon_sym_for] = ACTIONS(2321),
    [anon_sym_while] = ACTIONS(2321),
    [anon_sym_if] = ACTIONS(2321),
    [anon_sym_fun] = ACTIONS(2321),
    [anon_sym_DASH_GT] = ACTIONS(2321),
    [anon_sym_try] = ACTIONS(2321),
    [anon_sym_match] = ACTIONS(2321),
    [anon_sym_match_BANG] = ACTIONS(2323),
    [anon_sym_function] = ACTIONS(2321),
    [anon_sym_LT_DASH] = ACTIONS(2321),
    [anon_sym_DOT_LBRACK] = ACTIONS(2323),
    [anon_sym_LT] = ACTIONS(2323),
    [anon_sym_use] = ACTIONS(2321),
    [anon_sym_use_BANG] = ACTIONS(2323),
    [anon_sym_do_BANG] = ACTIONS(2323),
    [anon_sym_begin] = ACTIONS(2321),
    [anon_sym_LPAREN2] = ACTIONS(2321),
    [anon_sym_STAR] = ACTIONS(2321),
    [anon_sym_LT2] = ACTIONS(2321),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2323),
    [anon_sym_or] = ACTIONS(2321),
    [aux_sym_char_token1] = ACTIONS(2323),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2321),
    [anon_sym_DQUOTE] = ACTIONS(2321),
    [anon_sym_AT_DQUOTE] = ACTIONS(2323),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2323),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2323),
    [sym_bool] = ACTIONS(2321),
    [sym_unit] = ACTIONS(2323),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2321),
    [sym_op_identifier] = ACTIONS(2321),
    [anon_sym_PLUS] = ACTIONS(2321),
    [anon_sym_DASH] = ACTIONS(2321),
    [anon_sym_PLUS_DOT] = ACTIONS(2321),
    [anon_sym_DASH_DOT] = ACTIONS(2321),
    [anon_sym_PERCENT] = ACTIONS(2321),
    [anon_sym_AMP_AMP] = ACTIONS(2321),
    [anon_sym_TILDE] = ACTIONS(2323),
    [aux_sym_prefix_op_token1] = ACTIONS(2321),
    [aux_sym_infix_op_token1] = ACTIONS(2323),
    [aux_sym_infix_op_token2] = ACTIONS(2321),
    [anon_sym_PIPE_PIPE] = ACTIONS(2321),
    [anon_sym_BANG_EQ] = ACTIONS(2321),
    [anon_sym_COLON_EQ] = ACTIONS(2323),
    [anon_sym_DOLLAR] = ACTIONS(2321),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2321),
    [sym_int] = ACTIONS(2321),
    [sym_xint] = ACTIONS(2323),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2323),
    [sym__newline] = ACTIONS(2323),
  },
  [1389] = {
    [sym_block_comment] = STATE(1389),
    [sym_compiler_directive_decl] = STATE(1389),
    [sym_fsi_directive_decl] = STATE(1389),
    [sym_preproc_line] = STATE(1389),
    [sym_identifier] = ACTIONS(2783),
    [anon_sym_EQ] = ACTIONS(2785),
    [anon_sym_COLON] = ACTIONS(2783),
    [anon_sym_return] = ACTIONS(2783),
    [anon_sym_do] = ACTIONS(2783),
    [anon_sym_let] = ACTIONS(2783),
    [anon_sym_let_BANG] = ACTIONS(2785),
    [anon_sym_LPAREN] = ACTIONS(2783),
    [anon_sym_COMMA] = ACTIONS(2785),
    [anon_sym_null] = ACTIONS(2783),
    [anon_sym_QMARK] = ACTIONS(2783),
    [anon_sym_COLON_QMARK] = ACTIONS(2783),
    [anon_sym_COLON_COLON] = ACTIONS(2785),
    [anon_sym_AMP] = ACTIONS(2783),
    [anon_sym_LBRACK] = ACTIONS(2783),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2785),
    [anon_sym_LBRACE] = ACTIONS(2783),
    [anon_sym_LT_AT] = ACTIONS(2783),
    [anon_sym_LT_AT_AT] = ACTIONS(2783),
    [anon_sym_DOT] = ACTIONS(2783),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2785),
    [anon_sym_new] = ACTIONS(2783),
    [anon_sym_return_BANG] = ACTIONS(2785),
    [anon_sym_yield] = ACTIONS(2783),
    [anon_sym_yield_BANG] = ACTIONS(2785),
    [anon_sym_lazy] = ACTIONS(2783),
    [anon_sym_assert] = ACTIONS(2783),
    [anon_sym_upcast] = ACTIONS(2783),
    [anon_sym_downcast] = ACTIONS(2783),
    [anon_sym_COLON_GT] = ACTIONS(2785),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2785),
    [anon_sym_for] = ACTIONS(2783),
    [anon_sym_done] = ACTIONS(2787),
    [anon_sym_while] = ACTIONS(2783),
    [anon_sym_if] = ACTIONS(2783),
    [anon_sym_fun] = ACTIONS(2783),
    [anon_sym_DASH_GT] = ACTIONS(2881),
    [anon_sym_try] = ACTIONS(2783),
    [anon_sym_match] = ACTIONS(2783),
    [anon_sym_match_BANG] = ACTIONS(2785),
    [anon_sym_function] = ACTIONS(2783),
    [anon_sym_LT_DASH] = ACTIONS(2783),
    [anon_sym_DOT_LBRACK] = ACTIONS(2785),
    [anon_sym_LT] = ACTIONS(2785),
    [anon_sym_use] = ACTIONS(2783),
    [anon_sym_use_BANG] = ACTIONS(2785),
    [anon_sym_do_BANG] = ACTIONS(2785),
    [anon_sym_DOT_DOT] = ACTIONS(2881),
    [anon_sym_begin] = ACTIONS(2783),
    [anon_sym_LPAREN2] = ACTIONS(2783),
    [anon_sym_DOT_DOT2] = ACTIONS(2785),
    [anon_sym_or] = ACTIONS(2783),
    [aux_sym_char_token1] = ACTIONS(2785),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2783),
    [anon_sym_DQUOTE] = ACTIONS(2783),
    [anon_sym_AT_DQUOTE] = ACTIONS(2785),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2785),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2785),
    [sym_bool] = ACTIONS(2783),
    [sym_unit] = ACTIONS(2785),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2783),
    [sym_op_identifier] = ACTIONS(2783),
    [anon_sym_PLUS] = ACTIONS(2783),
    [anon_sym_DASH] = ACTIONS(2783),
    [anon_sym_PLUS_DOT] = ACTIONS(2783),
    [anon_sym_DASH_DOT] = ACTIONS(2783),
    [anon_sym_PERCENT] = ACTIONS(2783),
    [anon_sym_AMP_AMP] = ACTIONS(2783),
    [anon_sym_TILDE] = ACTIONS(2785),
    [aux_sym_prefix_op_token1] = ACTIONS(2783),
    [aux_sym_infix_op_token1] = ACTIONS(2785),
    [aux_sym_infix_op_token2] = ACTIONS(2783),
    [anon_sym_PIPE_PIPE] = ACTIONS(2783),
    [anon_sym_BANG_EQ] = ACTIONS(2783),
    [anon_sym_COLON_EQ] = ACTIONS(2785),
    [anon_sym_DOLLAR] = ACTIONS(2783),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2783),
    [sym_int] = ACTIONS(2783),
    [sym_xint] = ACTIONS(2785),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2785),
    [sym__newline] = ACTIONS(2785),
    [sym__dedent] = ACTIONS(2785),
  },
  [1390] = {
    [sym_block_comment] = STATE(1390),
    [sym_compiler_directive_decl] = STATE(1390),
    [sym_fsi_directive_decl] = STATE(1390),
    [sym_preproc_line] = STATE(1390),
    [sym_identifier] = ACTIONS(2563),
    [anon_sym_EQ] = ACTIONS(2565),
    [anon_sym_COLON] = ACTIONS(2563),
    [anon_sym_return] = ACTIONS(2563),
    [anon_sym_do] = ACTIONS(2563),
    [anon_sym_let] = ACTIONS(2563),
    [anon_sym_let_BANG] = ACTIONS(2565),
    [anon_sym_LPAREN] = ACTIONS(2563),
    [anon_sym_COMMA] = ACTIONS(2565),
    [anon_sym_null] = ACTIONS(2563),
    [anon_sym_QMARK] = ACTIONS(2563),
    [anon_sym_COLON_QMARK] = ACTIONS(2563),
    [anon_sym_COLON_COLON] = ACTIONS(2565),
    [anon_sym_AMP] = ACTIONS(2563),
    [anon_sym_LBRACK] = ACTIONS(2563),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2565),
    [anon_sym_LBRACE] = ACTIONS(2563),
    [anon_sym_LT_AT] = ACTIONS(2563),
    [anon_sym_LT_AT_AT] = ACTIONS(2563),
    [anon_sym_DOT] = ACTIONS(2563),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2565),
    [anon_sym_new] = ACTIONS(2563),
    [anon_sym_return_BANG] = ACTIONS(2565),
    [anon_sym_yield] = ACTIONS(2563),
    [anon_sym_yield_BANG] = ACTIONS(2565),
    [anon_sym_lazy] = ACTIONS(2563),
    [anon_sym_assert] = ACTIONS(2563),
    [anon_sym_upcast] = ACTIONS(2563),
    [anon_sym_downcast] = ACTIONS(2563),
    [anon_sym_COLON_GT] = ACTIONS(2565),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2565),
    [anon_sym_for] = ACTIONS(2563),
    [anon_sym_while] = ACTIONS(2563),
    [anon_sym_if] = ACTIONS(2563),
    [anon_sym_fun] = ACTIONS(2563),
    [anon_sym_DASH_GT] = ACTIONS(2563),
    [anon_sym_try] = ACTIONS(2563),
    [anon_sym_match] = ACTIONS(2563),
    [anon_sym_match_BANG] = ACTIONS(2565),
    [anon_sym_function] = ACTIONS(2563),
    [anon_sym_LT_DASH] = ACTIONS(2563),
    [anon_sym_DOT_LBRACK] = ACTIONS(2565),
    [anon_sym_LT] = ACTIONS(2565),
    [anon_sym_GT] = ACTIONS(2563),
    [anon_sym_use] = ACTIONS(2563),
    [anon_sym_use_BANG] = ACTIONS(2565),
    [anon_sym_do_BANG] = ACTIONS(2565),
    [anon_sym_begin] = ACTIONS(2563),
    [anon_sym_LPAREN2] = ACTIONS(2563),
    [anon_sym_STAR] = ACTIONS(2563),
    [anon_sym_LT2] = ACTIONS(2563),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2565),
    [anon_sym_or] = ACTIONS(2563),
    [aux_sym_char_token1] = ACTIONS(2565),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2563),
    [anon_sym_DQUOTE] = ACTIONS(2563),
    [anon_sym_AT_DQUOTE] = ACTIONS(2565),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2565),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2565),
    [sym_bool] = ACTIONS(2563),
    [sym_unit] = ACTIONS(2565),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2563),
    [sym_op_identifier] = ACTIONS(2563),
    [anon_sym_PLUS] = ACTIONS(2563),
    [anon_sym_DASH] = ACTIONS(2563),
    [anon_sym_PLUS_DOT] = ACTIONS(2563),
    [anon_sym_DASH_DOT] = ACTIONS(2563),
    [anon_sym_PERCENT] = ACTIONS(2563),
    [anon_sym_AMP_AMP] = ACTIONS(2563),
    [anon_sym_TILDE] = ACTIONS(2565),
    [aux_sym_prefix_op_token1] = ACTIONS(2563),
    [aux_sym_infix_op_token1] = ACTIONS(2565),
    [aux_sym_infix_op_token2] = ACTIONS(2563),
    [anon_sym_PIPE_PIPE] = ACTIONS(2563),
    [anon_sym_BANG_EQ] = ACTIONS(2563),
    [anon_sym_COLON_EQ] = ACTIONS(2565),
    [anon_sym_DOLLAR] = ACTIONS(2563),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2563),
    [sym_int] = ACTIONS(2563),
    [sym_xint] = ACTIONS(2565),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2565),
    [sym__newline] = ACTIONS(2565),
  },
  [1391] = {
    [sym_block_comment] = STATE(1391),
    [sym_compiler_directive_decl] = STATE(1391),
    [sym_fsi_directive_decl] = STATE(1391),
    [sym_preproc_line] = STATE(1391),
    [sym_identifier] = ACTIONS(2748),
    [anon_sym_EQ] = ACTIONS(2750),
    [anon_sym_COLON] = ACTIONS(2748),
    [anon_sym_return] = ACTIONS(2748),
    [anon_sym_do] = ACTIONS(2748),
    [anon_sym_let] = ACTIONS(2748),
    [anon_sym_let_BANG] = ACTIONS(2750),
    [anon_sym_as] = ACTIONS(2748),
    [anon_sym_LPAREN] = ACTIONS(2748),
    [anon_sym_COMMA] = ACTIONS(2750),
    [anon_sym_null] = ACTIONS(2748),
    [anon_sym_QMARK] = ACTIONS(2748),
    [anon_sym_COLON_QMARK] = ACTIONS(2748),
    [anon_sym_COLON_COLON] = ACTIONS(2750),
    [anon_sym_AMP] = ACTIONS(2748),
    [anon_sym_LBRACK] = ACTIONS(2748),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2750),
    [anon_sym_LBRACE] = ACTIONS(2748),
    [anon_sym_LT_AT] = ACTIONS(2748),
    [anon_sym_LT_AT_AT] = ACTIONS(2748),
    [anon_sym_DOT] = ACTIONS(2748),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2750),
    [anon_sym_new] = ACTIONS(2748),
    [anon_sym_with] = ACTIONS(2748),
    [anon_sym_return_BANG] = ACTIONS(2750),
    [anon_sym_yield] = ACTIONS(2748),
    [anon_sym_yield_BANG] = ACTIONS(2750),
    [anon_sym_lazy] = ACTIONS(2748),
    [anon_sym_assert] = ACTIONS(2748),
    [anon_sym_upcast] = ACTIONS(2748),
    [anon_sym_downcast] = ACTIONS(2748),
    [anon_sym_COLON_GT] = ACTIONS(2750),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2750),
    [anon_sym_for] = ACTIONS(2748),
    [anon_sym_while] = ACTIONS(2748),
    [anon_sym_else] = ACTIONS(2748),
    [anon_sym_elif] = ACTIONS(2748),
    [anon_sym_if] = ACTIONS(2748),
    [anon_sym_fun] = ACTIONS(2748),
    [anon_sym_try] = ACTIONS(2748),
    [anon_sym_match] = ACTIONS(2748),
    [anon_sym_match_BANG] = ACTIONS(2750),
    [anon_sym_function] = ACTIONS(2748),
    [anon_sym_LT_DASH] = ACTIONS(2748),
    [anon_sym_DOT_LBRACK] = ACTIONS(2750),
    [anon_sym_LT] = ACTIONS(2750),
    [anon_sym_use] = ACTIONS(2748),
    [anon_sym_use_BANG] = ACTIONS(2750),
    [anon_sym_do_BANG] = ACTIONS(2750),
    [anon_sym_begin] = ACTIONS(2748),
    [anon_sym_LPAREN2] = ACTIONS(2748),
    [anon_sym_or] = ACTIONS(2748),
    [aux_sym_char_token1] = ACTIONS(2750),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2748),
    [anon_sym_DQUOTE] = ACTIONS(2748),
    [anon_sym_AT_DQUOTE] = ACTIONS(2750),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2750),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2750),
    [sym_bool] = ACTIONS(2748),
    [sym_unit] = ACTIONS(2750),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2748),
    [sym_op_identifier] = ACTIONS(2748),
    [anon_sym_PLUS] = ACTIONS(2748),
    [anon_sym_DASH] = ACTIONS(2748),
    [anon_sym_PLUS_DOT] = ACTIONS(2748),
    [anon_sym_DASH_DOT] = ACTIONS(2748),
    [anon_sym_PERCENT] = ACTIONS(2748),
    [anon_sym_AMP_AMP] = ACTIONS(2748),
    [anon_sym_TILDE] = ACTIONS(2750),
    [aux_sym_prefix_op_token1] = ACTIONS(2748),
    [aux_sym_infix_op_token1] = ACTIONS(2750),
    [aux_sym_infix_op_token2] = ACTIONS(2748),
    [anon_sym_PIPE_PIPE] = ACTIONS(2748),
    [anon_sym_BANG_EQ] = ACTIONS(2748),
    [anon_sym_COLON_EQ] = ACTIONS(2750),
    [anon_sym_DOLLAR] = ACTIONS(2748),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2748),
    [sym_int] = ACTIONS(2748),
    [sym_xint] = ACTIONS(2750),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2750),
    [sym__newline] = ACTIONS(2750),
    [sym__dedent] = ACTIONS(2750),
  },
  [1392] = {
    [sym_block_comment] = STATE(1392),
    [sym_compiler_directive_decl] = STATE(1392),
    [sym_fsi_directive_decl] = STATE(1392),
    [sym_preproc_line] = STATE(1392),
    [sym_identifier] = ACTIONS(2783),
    [anon_sym_EQ] = ACTIONS(2785),
    [anon_sym_COLON] = ACTIONS(2783),
    [anon_sym_return] = ACTIONS(2783),
    [anon_sym_do] = ACTIONS(2783),
    [anon_sym_let] = ACTIONS(2783),
    [anon_sym_let_BANG] = ACTIONS(2785),
    [anon_sym_as] = ACTIONS(2783),
    [anon_sym_LPAREN] = ACTIONS(2783),
    [anon_sym_COMMA] = ACTIONS(2785),
    [anon_sym_null] = ACTIONS(2783),
    [anon_sym_QMARK] = ACTIONS(2783),
    [anon_sym_COLON_QMARK] = ACTIONS(2783),
    [anon_sym_COLON_COLON] = ACTIONS(2785),
    [anon_sym_AMP] = ACTIONS(2783),
    [anon_sym_LBRACK] = ACTIONS(2783),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2785),
    [anon_sym_LBRACE] = ACTIONS(2783),
    [anon_sym_LT_AT] = ACTIONS(2783),
    [anon_sym_LT_AT_AT] = ACTIONS(2783),
    [anon_sym_DOT] = ACTIONS(2783),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2785),
    [anon_sym_new] = ACTIONS(2783),
    [anon_sym_with] = ACTIONS(2783),
    [anon_sym_return_BANG] = ACTIONS(2785),
    [anon_sym_yield] = ACTIONS(2783),
    [anon_sym_yield_BANG] = ACTIONS(2785),
    [anon_sym_lazy] = ACTIONS(2783),
    [anon_sym_assert] = ACTIONS(2783),
    [anon_sym_upcast] = ACTIONS(2783),
    [anon_sym_downcast] = ACTIONS(2783),
    [anon_sym_COLON_GT] = ACTIONS(2785),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2785),
    [anon_sym_for] = ACTIONS(2783),
    [anon_sym_done] = ACTIONS(3525),
    [anon_sym_while] = ACTIONS(2783),
    [anon_sym_if] = ACTIONS(2783),
    [anon_sym_fun] = ACTIONS(2783),
    [anon_sym_try] = ACTIONS(2783),
    [anon_sym_match] = ACTIONS(2783),
    [anon_sym_match_BANG] = ACTIONS(2785),
    [anon_sym_function] = ACTIONS(2783),
    [anon_sym_LT_DASH] = ACTIONS(2783),
    [anon_sym_DOT_LBRACK] = ACTIONS(2785),
    [anon_sym_LT] = ACTIONS(2785),
    [anon_sym_use] = ACTIONS(2783),
    [anon_sym_use_BANG] = ACTIONS(2785),
    [anon_sym_do_BANG] = ACTIONS(2785),
    [anon_sym_DOT_DOT] = ACTIONS(2789),
    [anon_sym_begin] = ACTIONS(2783),
    [anon_sym_LPAREN2] = ACTIONS(2783),
    [anon_sym_or] = ACTIONS(2783),
    [aux_sym_char_token1] = ACTIONS(2785),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2783),
    [anon_sym_DQUOTE] = ACTIONS(2783),
    [anon_sym_AT_DQUOTE] = ACTIONS(2785),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2785),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2785),
    [sym_bool] = ACTIONS(2783),
    [sym_unit] = ACTIONS(2785),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2783),
    [sym_op_identifier] = ACTIONS(2783),
    [anon_sym_PLUS] = ACTIONS(2783),
    [anon_sym_DASH] = ACTIONS(2783),
    [anon_sym_PLUS_DOT] = ACTIONS(2783),
    [anon_sym_DASH_DOT] = ACTIONS(2783),
    [anon_sym_PERCENT] = ACTIONS(2783),
    [anon_sym_AMP_AMP] = ACTIONS(2783),
    [anon_sym_TILDE] = ACTIONS(2785),
    [aux_sym_prefix_op_token1] = ACTIONS(2783),
    [aux_sym_infix_op_token1] = ACTIONS(2785),
    [aux_sym_infix_op_token2] = ACTIONS(2783),
    [anon_sym_PIPE_PIPE] = ACTIONS(2783),
    [anon_sym_BANG_EQ] = ACTIONS(2783),
    [anon_sym_COLON_EQ] = ACTIONS(2785),
    [anon_sym_DOLLAR] = ACTIONS(2783),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2783),
    [sym_int] = ACTIONS(2783),
    [sym_xint] = ACTIONS(2785),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2785),
    [sym__newline] = ACTIONS(2785),
    [sym__dedent] = ACTIONS(2785),
  },
  [1393] = {
    [sym_block_comment] = STATE(1393),
    [sym_compiler_directive_decl] = STATE(1393),
    [sym_fsi_directive_decl] = STATE(1393),
    [sym_preproc_line] = STATE(1393),
    [sym_identifier] = ACTIONS(2510),
    [anon_sym_EQ] = ACTIONS(2512),
    [anon_sym_COLON] = ACTIONS(2510),
    [anon_sym_return] = ACTIONS(2510),
    [anon_sym_do] = ACTIONS(2510),
    [anon_sym_let] = ACTIONS(2510),
    [anon_sym_let_BANG] = ACTIONS(2512),
    [anon_sym_LPAREN] = ACTIONS(2510),
    [anon_sym_COMMA] = ACTIONS(2512),
    [anon_sym_null] = ACTIONS(2510),
    [anon_sym_QMARK] = ACTIONS(2510),
    [anon_sym_COLON_QMARK] = ACTIONS(2510),
    [anon_sym_COLON_COLON] = ACTIONS(2512),
    [anon_sym_AMP] = ACTIONS(2510),
    [anon_sym_LBRACK] = ACTIONS(2510),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2512),
    [anon_sym_LBRACE] = ACTIONS(2510),
    [anon_sym_LT_AT] = ACTIONS(2510),
    [anon_sym_AT_GT] = ACTIONS(2510),
    [anon_sym_LT_AT_AT] = ACTIONS(2510),
    [anon_sym_DOT] = ACTIONS(2510),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2512),
    [anon_sym_new] = ACTIONS(2510),
    [anon_sym_return_BANG] = ACTIONS(2512),
    [anon_sym_yield] = ACTIONS(2510),
    [anon_sym_yield_BANG] = ACTIONS(2512),
    [anon_sym_lazy] = ACTIONS(2510),
    [anon_sym_assert] = ACTIONS(2510),
    [anon_sym_upcast] = ACTIONS(2510),
    [anon_sym_downcast] = ACTIONS(2510),
    [anon_sym_COLON_GT] = ACTIONS(2512),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2512),
    [anon_sym_for] = ACTIONS(2510),
    [anon_sym_while] = ACTIONS(2510),
    [anon_sym_if] = ACTIONS(2510),
    [anon_sym_fun] = ACTIONS(2510),
    [anon_sym_DASH_GT] = ACTIONS(2510),
    [anon_sym_try] = ACTIONS(2510),
    [anon_sym_match] = ACTIONS(2510),
    [anon_sym_match_BANG] = ACTIONS(2512),
    [anon_sym_function] = ACTIONS(2510),
    [anon_sym_LT_DASH] = ACTIONS(2510),
    [anon_sym_DOT_LBRACK] = ACTIONS(2512),
    [anon_sym_LT] = ACTIONS(2512),
    [anon_sym_use] = ACTIONS(2510),
    [anon_sym_use_BANG] = ACTIONS(2512),
    [anon_sym_do_BANG] = ACTIONS(2512),
    [anon_sym_begin] = ACTIONS(2510),
    [anon_sym_LPAREN2] = ACTIONS(2510),
    [anon_sym_STAR] = ACTIONS(2510),
    [anon_sym_LT2] = ACTIONS(2510),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2512),
    [anon_sym_or] = ACTIONS(2510),
    [aux_sym_char_token1] = ACTIONS(2512),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2510),
    [anon_sym_DQUOTE] = ACTIONS(2510),
    [anon_sym_AT_DQUOTE] = ACTIONS(2512),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2512),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2512),
    [sym_bool] = ACTIONS(2510),
    [sym_unit] = ACTIONS(2512),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2510),
    [sym_op_identifier] = ACTIONS(2510),
    [anon_sym_PLUS] = ACTIONS(2510),
    [anon_sym_DASH] = ACTIONS(2510),
    [anon_sym_PLUS_DOT] = ACTIONS(2510),
    [anon_sym_DASH_DOT] = ACTIONS(2510),
    [anon_sym_PERCENT] = ACTIONS(2510),
    [anon_sym_AMP_AMP] = ACTIONS(2510),
    [anon_sym_TILDE] = ACTIONS(2512),
    [aux_sym_prefix_op_token1] = ACTIONS(2510),
    [aux_sym_infix_op_token1] = ACTIONS(2512),
    [aux_sym_infix_op_token2] = ACTIONS(2510),
    [anon_sym_PIPE_PIPE] = ACTIONS(2510),
    [anon_sym_BANG_EQ] = ACTIONS(2510),
    [anon_sym_COLON_EQ] = ACTIONS(2512),
    [anon_sym_DOLLAR] = ACTIONS(2510),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2510),
    [sym_int] = ACTIONS(2510),
    [sym_xint] = ACTIONS(2512),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2512),
    [sym__newline] = ACTIONS(2512),
  },
  [1394] = {
    [sym_block_comment] = STATE(1394),
    [sym_compiler_directive_decl] = STATE(1394),
    [sym_fsi_directive_decl] = STATE(1394),
    [sym_preproc_line] = STATE(1394),
    [sym_identifier] = ACTIONS(2340),
    [anon_sym_EQ] = ACTIONS(2342),
    [anon_sym_COLON] = ACTIONS(2340),
    [anon_sym_return] = ACTIONS(2340),
    [anon_sym_do] = ACTIONS(2340),
    [anon_sym_let] = ACTIONS(2340),
    [anon_sym_let_BANG] = ACTIONS(2342),
    [anon_sym_LPAREN] = ACTIONS(2340),
    [anon_sym_COMMA] = ACTIONS(2342),
    [anon_sym_null] = ACTIONS(2340),
    [anon_sym_QMARK] = ACTIONS(2340),
    [anon_sym_COLON_QMARK] = ACTIONS(2340),
    [anon_sym_COLON_COLON] = ACTIONS(2342),
    [anon_sym_AMP] = ACTIONS(2340),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2342),
    [anon_sym_LBRACE] = ACTIONS(2340),
    [anon_sym_LT_AT] = ACTIONS(2340),
    [anon_sym_AT_GT] = ACTIONS(2340),
    [anon_sym_LT_AT_AT] = ACTIONS(2340),
    [anon_sym_DOT] = ACTIONS(2340),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2342),
    [anon_sym_new] = ACTIONS(2340),
    [anon_sym_return_BANG] = ACTIONS(2342),
    [anon_sym_yield] = ACTIONS(2340),
    [anon_sym_yield_BANG] = ACTIONS(2342),
    [anon_sym_lazy] = ACTIONS(2340),
    [anon_sym_assert] = ACTIONS(2340),
    [anon_sym_upcast] = ACTIONS(2340),
    [anon_sym_downcast] = ACTIONS(2340),
    [anon_sym_COLON_GT] = ACTIONS(2342),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2342),
    [anon_sym_for] = ACTIONS(2340),
    [anon_sym_while] = ACTIONS(2340),
    [anon_sym_if] = ACTIONS(2340),
    [anon_sym_fun] = ACTIONS(2340),
    [anon_sym_DASH_GT] = ACTIONS(2340),
    [anon_sym_try] = ACTIONS(2340),
    [anon_sym_match] = ACTIONS(2340),
    [anon_sym_match_BANG] = ACTIONS(2342),
    [anon_sym_function] = ACTIONS(2340),
    [anon_sym_LT_DASH] = ACTIONS(2340),
    [anon_sym_DOT_LBRACK] = ACTIONS(2342),
    [anon_sym_LT] = ACTIONS(2342),
    [anon_sym_use] = ACTIONS(2340),
    [anon_sym_use_BANG] = ACTIONS(2342),
    [anon_sym_do_BANG] = ACTIONS(2342),
    [anon_sym_begin] = ACTIONS(2340),
    [anon_sym_LPAREN2] = ACTIONS(2340),
    [anon_sym_STAR] = ACTIONS(2340),
    [anon_sym_LT2] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2342),
    [anon_sym_or] = ACTIONS(2340),
    [aux_sym_char_token1] = ACTIONS(2342),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2340),
    [anon_sym_DQUOTE] = ACTIONS(2340),
    [anon_sym_AT_DQUOTE] = ACTIONS(2342),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2342),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2342),
    [sym_bool] = ACTIONS(2340),
    [sym_unit] = ACTIONS(2342),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2340),
    [sym_op_identifier] = ACTIONS(2340),
    [anon_sym_PLUS] = ACTIONS(2340),
    [anon_sym_DASH] = ACTIONS(2340),
    [anon_sym_PLUS_DOT] = ACTIONS(2340),
    [anon_sym_DASH_DOT] = ACTIONS(2340),
    [anon_sym_PERCENT] = ACTIONS(2340),
    [anon_sym_AMP_AMP] = ACTIONS(2340),
    [anon_sym_TILDE] = ACTIONS(2342),
    [aux_sym_prefix_op_token1] = ACTIONS(2340),
    [aux_sym_infix_op_token1] = ACTIONS(2342),
    [aux_sym_infix_op_token2] = ACTIONS(2340),
    [anon_sym_PIPE_PIPE] = ACTIONS(2340),
    [anon_sym_BANG_EQ] = ACTIONS(2340),
    [anon_sym_COLON_EQ] = ACTIONS(2342),
    [anon_sym_DOLLAR] = ACTIONS(2340),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2340),
    [sym_int] = ACTIONS(2340),
    [sym_xint] = ACTIONS(2342),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2342),
    [sym__newline] = ACTIONS(2342),
  },
  [1395] = {
    [sym_block_comment] = STATE(1395),
    [sym_compiler_directive_decl] = STATE(1395),
    [sym_fsi_directive_decl] = STATE(1395),
    [sym_preproc_line] = STATE(1395),
    [sym_identifier] = ACTIONS(2685),
    [anon_sym_EQ] = ACTIONS(2687),
    [anon_sym_COLON] = ACTIONS(2685),
    [anon_sym_return] = ACTIONS(2685),
    [anon_sym_do] = ACTIONS(2685),
    [anon_sym_let] = ACTIONS(2685),
    [anon_sym_let_BANG] = ACTIONS(2687),
    [anon_sym_LPAREN] = ACTIONS(2685),
    [anon_sym_COMMA] = ACTIONS(2687),
    [anon_sym_null] = ACTIONS(2685),
    [anon_sym_QMARK] = ACTIONS(2685),
    [anon_sym_COLON_QMARK] = ACTIONS(2685),
    [anon_sym_COLON_COLON] = ACTIONS(2687),
    [anon_sym_AMP] = ACTIONS(2685),
    [anon_sym_LBRACK] = ACTIONS(2685),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2687),
    [anon_sym_LBRACE] = ACTIONS(2685),
    [anon_sym_LT_AT] = ACTIONS(2685),
    [anon_sym_LT_AT_AT] = ACTIONS(2685),
    [anon_sym_DOT] = ACTIONS(2685),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2687),
    [anon_sym_new] = ACTIONS(2685),
    [anon_sym_with] = ACTIONS(2685),
    [anon_sym_return_BANG] = ACTIONS(2687),
    [anon_sym_yield] = ACTIONS(2685),
    [anon_sym_yield_BANG] = ACTIONS(2687),
    [anon_sym_lazy] = ACTIONS(2685),
    [anon_sym_assert] = ACTIONS(2685),
    [anon_sym_upcast] = ACTIONS(2685),
    [anon_sym_downcast] = ACTIONS(2685),
    [anon_sym_COLON_GT] = ACTIONS(2687),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2687),
    [anon_sym_for] = ACTIONS(2685),
    [anon_sym_done] = ACTIONS(2685),
    [anon_sym_while] = ACTIONS(2685),
    [anon_sym_if] = ACTIONS(2685),
    [anon_sym_fun] = ACTIONS(2685),
    [anon_sym_DASH_GT] = ACTIONS(2685),
    [anon_sym_try] = ACTIONS(2685),
    [anon_sym_match] = ACTIONS(2685),
    [anon_sym_match_BANG] = ACTIONS(2687),
    [anon_sym_function] = ACTIONS(2685),
    [anon_sym_LT_DASH] = ACTIONS(2685),
    [anon_sym_DOT_LBRACK] = ACTIONS(2687),
    [anon_sym_LT] = ACTIONS(2687),
    [anon_sym_use] = ACTIONS(2685),
    [anon_sym_use_BANG] = ACTIONS(2687),
    [anon_sym_do_BANG] = ACTIONS(2687),
    [anon_sym_DOT_DOT] = ACTIONS(2687),
    [anon_sym_begin] = ACTIONS(2685),
    [anon_sym_LPAREN2] = ACTIONS(2685),
    [anon_sym_or] = ACTIONS(2685),
    [aux_sym_char_token1] = ACTIONS(2687),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2685),
    [anon_sym_DQUOTE] = ACTIONS(2685),
    [anon_sym_AT_DQUOTE] = ACTIONS(2687),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2687),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2687),
    [sym_bool] = ACTIONS(2685),
    [sym_unit] = ACTIONS(2687),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2685),
    [sym_op_identifier] = ACTIONS(2685),
    [anon_sym_PLUS] = ACTIONS(2685),
    [anon_sym_DASH] = ACTIONS(2685),
    [anon_sym_PLUS_DOT] = ACTIONS(2685),
    [anon_sym_DASH_DOT] = ACTIONS(2685),
    [anon_sym_PERCENT] = ACTIONS(2685),
    [anon_sym_AMP_AMP] = ACTIONS(2685),
    [anon_sym_TILDE] = ACTIONS(2687),
    [aux_sym_prefix_op_token1] = ACTIONS(2685),
    [aux_sym_infix_op_token1] = ACTIONS(2687),
    [aux_sym_infix_op_token2] = ACTIONS(2685),
    [anon_sym_PIPE_PIPE] = ACTIONS(2685),
    [anon_sym_BANG_EQ] = ACTIONS(2685),
    [anon_sym_COLON_EQ] = ACTIONS(2687),
    [anon_sym_DOLLAR] = ACTIONS(2685),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2685),
    [sym_int] = ACTIONS(2685),
    [sym_xint] = ACTIONS(2687),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2687),
    [sym__newline] = ACTIONS(2687),
    [sym__dedent] = ACTIONS(2687),
  },
  [1396] = {
    [sym_block_comment] = STATE(1396),
    [sym_compiler_directive_decl] = STATE(1396),
    [sym_fsi_directive_decl] = STATE(1396),
    [sym_preproc_line] = STATE(1396),
    [sym_identifier] = ACTIONS(2514),
    [anon_sym_EQ] = ACTIONS(2516),
    [anon_sym_COLON] = ACTIONS(2514),
    [anon_sym_return] = ACTIONS(2514),
    [anon_sym_do] = ACTIONS(2514),
    [anon_sym_let] = ACTIONS(2514),
    [anon_sym_let_BANG] = ACTIONS(2516),
    [anon_sym_LPAREN] = ACTIONS(2514),
    [anon_sym_COMMA] = ACTIONS(2516),
    [anon_sym_null] = ACTIONS(2514),
    [anon_sym_QMARK] = ACTIONS(2514),
    [anon_sym_COLON_QMARK] = ACTIONS(2514),
    [anon_sym_COLON_COLON] = ACTIONS(2516),
    [anon_sym_AMP] = ACTIONS(2514),
    [anon_sym_LBRACK] = ACTIONS(2514),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2516),
    [anon_sym_LBRACE] = ACTIONS(2514),
    [anon_sym_LT_AT] = ACTIONS(2514),
    [anon_sym_LT_AT_AT] = ACTIONS(2514),
    [anon_sym_DOT] = ACTIONS(2514),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2516),
    [anon_sym_new] = ACTIONS(2514),
    [anon_sym_return_BANG] = ACTIONS(2516),
    [anon_sym_yield] = ACTIONS(2514),
    [anon_sym_yield_BANG] = ACTIONS(2516),
    [anon_sym_lazy] = ACTIONS(2514),
    [anon_sym_assert] = ACTIONS(2514),
    [anon_sym_upcast] = ACTIONS(2514),
    [anon_sym_downcast] = ACTIONS(2514),
    [anon_sym_COLON_GT] = ACTIONS(2516),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2516),
    [anon_sym_for] = ACTIONS(2514),
    [anon_sym_while] = ACTIONS(2514),
    [anon_sym_if] = ACTIONS(2514),
    [anon_sym_fun] = ACTIONS(2514),
    [anon_sym_DASH_GT] = ACTIONS(2514),
    [anon_sym_try] = ACTIONS(2514),
    [anon_sym_match] = ACTIONS(2514),
    [anon_sym_match_BANG] = ACTIONS(2516),
    [anon_sym_function] = ACTIONS(2514),
    [anon_sym_LT_DASH] = ACTIONS(2514),
    [anon_sym_DOT_LBRACK] = ACTIONS(2516),
    [anon_sym_LT] = ACTIONS(2516),
    [anon_sym_GT] = ACTIONS(2514),
    [anon_sym_use] = ACTIONS(2514),
    [anon_sym_use_BANG] = ACTIONS(2516),
    [anon_sym_do_BANG] = ACTIONS(2516),
    [anon_sym_begin] = ACTIONS(2514),
    [anon_sym_LPAREN2] = ACTIONS(2514),
    [anon_sym_STAR] = ACTIONS(2514),
    [anon_sym_LT2] = ACTIONS(2514),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2516),
    [anon_sym_or] = ACTIONS(2514),
    [aux_sym_char_token1] = ACTIONS(2516),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2514),
    [anon_sym_DQUOTE] = ACTIONS(2514),
    [anon_sym_AT_DQUOTE] = ACTIONS(2516),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2516),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2516),
    [sym_bool] = ACTIONS(2514),
    [sym_unit] = ACTIONS(2516),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2514),
    [sym_op_identifier] = ACTIONS(2514),
    [anon_sym_PLUS] = ACTIONS(2514),
    [anon_sym_DASH] = ACTIONS(2514),
    [anon_sym_PLUS_DOT] = ACTIONS(2514),
    [anon_sym_DASH_DOT] = ACTIONS(2514),
    [anon_sym_PERCENT] = ACTIONS(2514),
    [anon_sym_AMP_AMP] = ACTIONS(2514),
    [anon_sym_TILDE] = ACTIONS(2516),
    [aux_sym_prefix_op_token1] = ACTIONS(2514),
    [aux_sym_infix_op_token1] = ACTIONS(2516),
    [aux_sym_infix_op_token2] = ACTIONS(2514),
    [anon_sym_PIPE_PIPE] = ACTIONS(2514),
    [anon_sym_BANG_EQ] = ACTIONS(2514),
    [anon_sym_COLON_EQ] = ACTIONS(2516),
    [anon_sym_DOLLAR] = ACTIONS(2514),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2514),
    [sym_int] = ACTIONS(2514),
    [sym_xint] = ACTIONS(2516),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2516),
    [sym__newline] = ACTIONS(2516),
  },
  [1397] = {
    [sym_block_comment] = STATE(1397),
    [sym_compiler_directive_decl] = STATE(1397),
    [sym_fsi_directive_decl] = STATE(1397),
    [sym_preproc_line] = STATE(1397),
    [sym_identifier] = ACTIONS(2783),
    [anon_sym_EQ] = ACTIONS(2785),
    [anon_sym_COLON] = ACTIONS(2783),
    [anon_sym_return] = ACTIONS(2783),
    [anon_sym_do] = ACTIONS(2783),
    [anon_sym_let] = ACTIONS(2783),
    [anon_sym_let_BANG] = ACTIONS(2785),
    [anon_sym_LPAREN] = ACTIONS(2783),
    [anon_sym_COMMA] = ACTIONS(2785),
    [anon_sym_null] = ACTIONS(2783),
    [anon_sym_QMARK] = ACTIONS(2783),
    [anon_sym_COLON_QMARK] = ACTIONS(2783),
    [anon_sym_COLON_COLON] = ACTIONS(2785),
    [anon_sym_AMP] = ACTIONS(2783),
    [anon_sym_LBRACK] = ACTIONS(2783),
    [anon_sym_RBRACK] = ACTIONS(2785),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2785),
    [anon_sym_LBRACE] = ACTIONS(2783),
    [anon_sym_LT_AT] = ACTIONS(2783),
    [anon_sym_LT_AT_AT] = ACTIONS(2783),
    [anon_sym_DOT] = ACTIONS(2783),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2785),
    [anon_sym_new] = ACTIONS(2783),
    [anon_sym_return_BANG] = ACTIONS(2785),
    [anon_sym_yield] = ACTIONS(2783),
    [anon_sym_yield_BANG] = ACTIONS(2785),
    [anon_sym_lazy] = ACTIONS(2783),
    [anon_sym_assert] = ACTIONS(2783),
    [anon_sym_upcast] = ACTIONS(2783),
    [anon_sym_downcast] = ACTIONS(2783),
    [anon_sym_COLON_GT] = ACTIONS(2785),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2785),
    [anon_sym_for] = ACTIONS(2783),
    [anon_sym_done] = ACTIONS(3285),
    [anon_sym_while] = ACTIONS(2783),
    [anon_sym_if] = ACTIONS(2783),
    [anon_sym_fun] = ACTIONS(2783),
    [anon_sym_try] = ACTIONS(2783),
    [anon_sym_match] = ACTIONS(2783),
    [anon_sym_match_BANG] = ACTIONS(2785),
    [anon_sym_function] = ACTIONS(2783),
    [anon_sym_LT_DASH] = ACTIONS(2783),
    [anon_sym_DOT_LBRACK] = ACTIONS(2785),
    [anon_sym_LT] = ACTIONS(2785),
    [anon_sym_use] = ACTIONS(2783),
    [anon_sym_use_BANG] = ACTIONS(2785),
    [anon_sym_do_BANG] = ACTIONS(2785),
    [anon_sym_DOT_DOT] = ACTIONS(2881),
    [anon_sym_begin] = ACTIONS(2783),
    [anon_sym_LPAREN2] = ACTIONS(2783),
    [anon_sym_DOT_DOT2] = ACTIONS(2785),
    [anon_sym_or] = ACTIONS(2783),
    [aux_sym_char_token1] = ACTIONS(2785),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2783),
    [anon_sym_DQUOTE] = ACTIONS(2783),
    [anon_sym_AT_DQUOTE] = ACTIONS(2785),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2785),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2785),
    [sym_bool] = ACTIONS(2783),
    [sym_unit] = ACTIONS(2785),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2783),
    [sym_op_identifier] = ACTIONS(2783),
    [anon_sym_PLUS] = ACTIONS(2783),
    [anon_sym_DASH] = ACTIONS(2783),
    [anon_sym_PLUS_DOT] = ACTIONS(2783),
    [anon_sym_DASH_DOT] = ACTIONS(2783),
    [anon_sym_PERCENT] = ACTIONS(2783),
    [anon_sym_AMP_AMP] = ACTIONS(2783),
    [anon_sym_TILDE] = ACTIONS(2785),
    [aux_sym_prefix_op_token1] = ACTIONS(2783),
    [aux_sym_infix_op_token1] = ACTIONS(2785),
    [aux_sym_infix_op_token2] = ACTIONS(2783),
    [anon_sym_PIPE_PIPE] = ACTIONS(2783),
    [anon_sym_BANG_EQ] = ACTIONS(2783),
    [anon_sym_COLON_EQ] = ACTIONS(2785),
    [anon_sym_DOLLAR] = ACTIONS(2783),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2783),
    [sym_int] = ACTIONS(2783),
    [sym_xint] = ACTIONS(2785),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2785),
    [sym__newline] = ACTIONS(2785),
  },
  [1398] = {
    [sym_block_comment] = STATE(1398),
    [sym_compiler_directive_decl] = STATE(1398),
    [sym_fsi_directive_decl] = STATE(1398),
    [sym_preproc_line] = STATE(1398),
    [sym_identifier] = ACTIONS(2783),
    [anon_sym_EQ] = ACTIONS(2785),
    [anon_sym_COLON] = ACTIONS(2783),
    [anon_sym_return] = ACTIONS(2783),
    [anon_sym_do] = ACTIONS(2783),
    [anon_sym_let] = ACTIONS(2783),
    [anon_sym_let_BANG] = ACTIONS(2785),
    [anon_sym_as] = ACTIONS(2783),
    [anon_sym_LPAREN] = ACTIONS(2783),
    [anon_sym_COMMA] = ACTIONS(2785),
    [anon_sym_null] = ACTIONS(2783),
    [anon_sym_QMARK] = ACTIONS(2783),
    [anon_sym_COLON_QMARK] = ACTIONS(2783),
    [anon_sym_COLON_COLON] = ACTIONS(2785),
    [anon_sym_AMP] = ACTIONS(2783),
    [anon_sym_LBRACK] = ACTIONS(2783),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2785),
    [anon_sym_LBRACE] = ACTIONS(2783),
    [anon_sym_LT_AT] = ACTIONS(2783),
    [anon_sym_LT_AT_AT] = ACTIONS(2783),
    [anon_sym_DOT] = ACTIONS(2783),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2785),
    [anon_sym_new] = ACTIONS(2783),
    [anon_sym_with] = ACTIONS(2783),
    [anon_sym_return_BANG] = ACTIONS(2785),
    [anon_sym_yield] = ACTIONS(2783),
    [anon_sym_yield_BANG] = ACTIONS(2785),
    [anon_sym_lazy] = ACTIONS(2783),
    [anon_sym_assert] = ACTIONS(2783),
    [anon_sym_upcast] = ACTIONS(2783),
    [anon_sym_downcast] = ACTIONS(2783),
    [anon_sym_COLON_GT] = ACTIONS(2785),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2785),
    [anon_sym_for] = ACTIONS(2783),
    [anon_sym_done] = ACTIONS(3527),
    [anon_sym_while] = ACTIONS(2783),
    [anon_sym_if] = ACTIONS(2783),
    [anon_sym_fun] = ACTIONS(2783),
    [anon_sym_try] = ACTIONS(2783),
    [anon_sym_match] = ACTIONS(2783),
    [anon_sym_match_BANG] = ACTIONS(2785),
    [anon_sym_function] = ACTIONS(2783),
    [anon_sym_LT_DASH] = ACTIONS(2783),
    [anon_sym_DOT_LBRACK] = ACTIONS(2785),
    [anon_sym_LT] = ACTIONS(2785),
    [anon_sym_use] = ACTIONS(2783),
    [anon_sym_use_BANG] = ACTIONS(2785),
    [anon_sym_do_BANG] = ACTIONS(2785),
    [anon_sym_DOT_DOT] = ACTIONS(2789),
    [anon_sym_begin] = ACTIONS(2783),
    [anon_sym_LPAREN2] = ACTIONS(2783),
    [anon_sym_or] = ACTIONS(2783),
    [aux_sym_char_token1] = ACTIONS(2785),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2783),
    [anon_sym_DQUOTE] = ACTIONS(2783),
    [anon_sym_AT_DQUOTE] = ACTIONS(2785),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2785),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2785),
    [sym_bool] = ACTIONS(2783),
    [sym_unit] = ACTIONS(2785),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2783),
    [sym_op_identifier] = ACTIONS(2783),
    [anon_sym_PLUS] = ACTIONS(2783),
    [anon_sym_DASH] = ACTIONS(2783),
    [anon_sym_PLUS_DOT] = ACTIONS(2783),
    [anon_sym_DASH_DOT] = ACTIONS(2783),
    [anon_sym_PERCENT] = ACTIONS(2783),
    [anon_sym_AMP_AMP] = ACTIONS(2783),
    [anon_sym_TILDE] = ACTIONS(2785),
    [aux_sym_prefix_op_token1] = ACTIONS(2783),
    [aux_sym_infix_op_token1] = ACTIONS(2785),
    [aux_sym_infix_op_token2] = ACTIONS(2783),
    [anon_sym_PIPE_PIPE] = ACTIONS(2783),
    [anon_sym_BANG_EQ] = ACTIONS(2783),
    [anon_sym_COLON_EQ] = ACTIONS(2785),
    [anon_sym_DOLLAR] = ACTIONS(2783),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2783),
    [sym_int] = ACTIONS(2783),
    [sym_xint] = ACTIONS(2785),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2785),
    [sym__newline] = ACTIONS(2785),
  },
  [1399] = {
    [sym_block_comment] = STATE(1399),
    [sym_compiler_directive_decl] = STATE(1399),
    [sym_fsi_directive_decl] = STATE(1399),
    [sym_preproc_line] = STATE(1399),
    [aux_sym_long_identifier_repeat1] = STATE(1445),
    [sym_identifier] = ACTIONS(2791),
    [anon_sym_EQ] = ACTIONS(2791),
    [anon_sym_COLON] = ACTIONS(2791),
    [anon_sym_return] = ACTIONS(2791),
    [anon_sym_do] = ACTIONS(2791),
    [anon_sym_let] = ACTIONS(2791),
    [anon_sym_let_BANG] = ACTIONS(2794),
    [anon_sym_LPAREN] = ACTIONS(2791),
    [anon_sym_COMMA] = ACTIONS(2794),
    [anon_sym_null] = ACTIONS(2791),
    [anon_sym_QMARK] = ACTIONS(2791),
    [anon_sym_COLON_QMARK] = ACTIONS(2791),
    [anon_sym_COLON_COLON] = ACTIONS(2794),
    [anon_sym_AMP] = ACTIONS(2791),
    [anon_sym_LBRACK] = ACTIONS(2791),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2794),
    [anon_sym_LBRACE] = ACTIONS(2791),
    [anon_sym_LT_AT] = ACTIONS(2791),
    [anon_sym_LT_AT_AT] = ACTIONS(2791),
    [anon_sym_DOT] = ACTIONS(3529),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2794),
    [anon_sym_new] = ACTIONS(2791),
    [anon_sym_with] = ACTIONS(2791),
    [anon_sym_return_BANG] = ACTIONS(2794),
    [anon_sym_yield] = ACTIONS(2791),
    [anon_sym_yield_BANG] = ACTIONS(2794),
    [anon_sym_lazy] = ACTIONS(2791),
    [anon_sym_assert] = ACTIONS(2791),
    [anon_sym_upcast] = ACTIONS(2791),
    [anon_sym_downcast] = ACTIONS(2791),
    [anon_sym_COLON_GT] = ACTIONS(2794),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2794),
    [anon_sym_for] = ACTIONS(2791),
    [anon_sym_while] = ACTIONS(2791),
    [anon_sym_if] = ACTIONS(2791),
    [anon_sym_fun] = ACTIONS(2791),
    [anon_sym_try] = ACTIONS(2791),
    [anon_sym_match] = ACTIONS(2791),
    [anon_sym_match_BANG] = ACTIONS(2794),
    [anon_sym_function] = ACTIONS(2791),
    [anon_sym_LT_DASH] = ACTIONS(2791),
    [anon_sym_DOT_LBRACK] = ACTIONS(2794),
    [anon_sym_LT] = ACTIONS(2794),
    [anon_sym_use] = ACTIONS(2791),
    [anon_sym_use_BANG] = ACTIONS(2794),
    [anon_sym_do_BANG] = ACTIONS(2794),
    [anon_sym_begin] = ACTIONS(2791),
    [anon_sym_LPAREN2] = ACTIONS(2791),
    [anon_sym_or] = ACTIONS(2791),
    [anon_sym_EQ2] = ACTIONS(2314),
    [aux_sym_char_token1] = ACTIONS(2794),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2791),
    [anon_sym_DQUOTE] = ACTIONS(2791),
    [anon_sym_AT_DQUOTE] = ACTIONS(2794),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2794),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2794),
    [sym_bool] = ACTIONS(2791),
    [sym_unit] = ACTIONS(2794),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2791),
    [sym_op_identifier] = ACTIONS(2791),
    [anon_sym_PLUS] = ACTIONS(2791),
    [anon_sym_DASH] = ACTIONS(2791),
    [anon_sym_PLUS_DOT] = ACTIONS(2791),
    [anon_sym_DASH_DOT] = ACTIONS(2791),
    [anon_sym_PERCENT] = ACTIONS(2791),
    [anon_sym_AMP_AMP] = ACTIONS(2791),
    [anon_sym_TILDE] = ACTIONS(2794),
    [aux_sym_prefix_op_token1] = ACTIONS(2791),
    [aux_sym_infix_op_token1] = ACTIONS(2794),
    [aux_sym_infix_op_token2] = ACTIONS(2791),
    [anon_sym_PIPE_PIPE] = ACTIONS(2791),
    [anon_sym_BANG_EQ] = ACTIONS(2791),
    [anon_sym_COLON_EQ] = ACTIONS(2794),
    [anon_sym_DOLLAR] = ACTIONS(2791),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2791),
    [sym_int] = ACTIONS(2791),
    [sym_xint] = ACTIONS(2794),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2794),
    [sym__newline] = ACTIONS(2794),
    [sym__dedent] = ACTIONS(2794),
  },
  [1400] = {
    [sym_block_comment] = STATE(1400),
    [sym_compiler_directive_decl] = STATE(1400),
    [sym_fsi_directive_decl] = STATE(1400),
    [sym_preproc_line] = STATE(1400),
    [sym_identifier] = ACTIONS(2685),
    [anon_sym_EQ] = ACTIONS(2687),
    [anon_sym_COLON] = ACTIONS(2685),
    [anon_sym_return] = ACTIONS(2685),
    [anon_sym_do] = ACTIONS(2685),
    [anon_sym_let] = ACTIONS(2685),
    [anon_sym_let_BANG] = ACTIONS(2687),
    [anon_sym_LPAREN] = ACTIONS(2685),
    [anon_sym_COMMA] = ACTIONS(2687),
    [anon_sym_null] = ACTIONS(2685),
    [anon_sym_QMARK] = ACTIONS(2685),
    [anon_sym_COLON_QMARK] = ACTIONS(2685),
    [anon_sym_COLON_COLON] = ACTIONS(2687),
    [anon_sym_AMP] = ACTIONS(2685),
    [anon_sym_LBRACK] = ACTIONS(2685),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2687),
    [anon_sym_LBRACE] = ACTIONS(2685),
    [anon_sym_LT_AT] = ACTIONS(2685),
    [anon_sym_LT_AT_AT] = ACTIONS(2685),
    [anon_sym_DOT] = ACTIONS(2685),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2687),
    [anon_sym_new] = ACTIONS(2685),
    [anon_sym_return_BANG] = ACTIONS(2687),
    [anon_sym_yield] = ACTIONS(2685),
    [anon_sym_yield_BANG] = ACTIONS(2687),
    [anon_sym_lazy] = ACTIONS(2685),
    [anon_sym_assert] = ACTIONS(2685),
    [anon_sym_upcast] = ACTIONS(2685),
    [anon_sym_downcast] = ACTIONS(2685),
    [anon_sym_COLON_GT] = ACTIONS(2687),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2687),
    [anon_sym_for] = ACTIONS(2685),
    [anon_sym_while] = ACTIONS(2685),
    [anon_sym_else] = ACTIONS(2685),
    [anon_sym_elif] = ACTIONS(2685),
    [anon_sym_if] = ACTIONS(2685),
    [anon_sym_fun] = ACTIONS(2685),
    [anon_sym_DASH_GT] = ACTIONS(2685),
    [anon_sym_try] = ACTIONS(2685),
    [anon_sym_match] = ACTIONS(2685),
    [anon_sym_match_BANG] = ACTIONS(2687),
    [anon_sym_function] = ACTIONS(2685),
    [anon_sym_LT_DASH] = ACTIONS(2685),
    [anon_sym_DOT_LBRACK] = ACTIONS(2687),
    [anon_sym_LT] = ACTIONS(2687),
    [anon_sym_use] = ACTIONS(2685),
    [anon_sym_use_BANG] = ACTIONS(2687),
    [anon_sym_do_BANG] = ACTIONS(2687),
    [anon_sym_DOT_DOT] = ACTIONS(2687),
    [anon_sym_begin] = ACTIONS(2685),
    [anon_sym_LPAREN2] = ACTIONS(2685),
    [anon_sym_or] = ACTIONS(2685),
    [aux_sym_char_token1] = ACTIONS(2687),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2685),
    [anon_sym_DQUOTE] = ACTIONS(2685),
    [anon_sym_AT_DQUOTE] = ACTIONS(2687),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2687),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2687),
    [sym_bool] = ACTIONS(2685),
    [sym_unit] = ACTIONS(2687),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2685),
    [sym_op_identifier] = ACTIONS(2685),
    [anon_sym_PLUS] = ACTIONS(2685),
    [anon_sym_DASH] = ACTIONS(2685),
    [anon_sym_PLUS_DOT] = ACTIONS(2685),
    [anon_sym_DASH_DOT] = ACTIONS(2685),
    [anon_sym_PERCENT] = ACTIONS(2685),
    [anon_sym_AMP_AMP] = ACTIONS(2685),
    [anon_sym_TILDE] = ACTIONS(2687),
    [aux_sym_prefix_op_token1] = ACTIONS(2685),
    [aux_sym_infix_op_token1] = ACTIONS(2687),
    [aux_sym_infix_op_token2] = ACTIONS(2685),
    [anon_sym_PIPE_PIPE] = ACTIONS(2685),
    [anon_sym_BANG_EQ] = ACTIONS(2685),
    [anon_sym_COLON_EQ] = ACTIONS(2687),
    [anon_sym_DOLLAR] = ACTIONS(2685),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2685),
    [sym_int] = ACTIONS(2685),
    [sym_xint] = ACTIONS(2687),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2687),
    [sym__newline] = ACTIONS(2687),
  },
  [1401] = {
    [sym_block_comment] = STATE(1401),
    [sym_compiler_directive_decl] = STATE(1401),
    [sym_fsi_directive_decl] = STATE(1401),
    [sym_preproc_line] = STATE(1401),
    [sym_identifier] = ACTIONS(2723),
    [anon_sym_EQ] = ACTIONS(2725),
    [anon_sym_COLON] = ACTIONS(2723),
    [anon_sym_return] = ACTIONS(2723),
    [anon_sym_do] = ACTIONS(2723),
    [anon_sym_let] = ACTIONS(2723),
    [anon_sym_let_BANG] = ACTIONS(2725),
    [anon_sym_LPAREN] = ACTIONS(2723),
    [anon_sym_COMMA] = ACTIONS(2725),
    [anon_sym_null] = ACTIONS(2723),
    [anon_sym_QMARK] = ACTIONS(2723),
    [anon_sym_COLON_QMARK] = ACTIONS(2723),
    [anon_sym_COLON_COLON] = ACTIONS(2725),
    [anon_sym_AMP] = ACTIONS(2723),
    [anon_sym_LBRACK] = ACTIONS(2723),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2725),
    [anon_sym_LBRACE] = ACTIONS(2723),
    [anon_sym_LT_AT] = ACTIONS(2723),
    [anon_sym_LT_AT_AT] = ACTIONS(2723),
    [anon_sym_DOT] = ACTIONS(2723),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2725),
    [anon_sym_new] = ACTIONS(2723),
    [anon_sym_return_BANG] = ACTIONS(2725),
    [anon_sym_yield] = ACTIONS(2723),
    [anon_sym_yield_BANG] = ACTIONS(2725),
    [anon_sym_lazy] = ACTIONS(2723),
    [anon_sym_assert] = ACTIONS(2723),
    [anon_sym_upcast] = ACTIONS(2723),
    [anon_sym_downcast] = ACTIONS(2723),
    [anon_sym_COLON_GT] = ACTIONS(2725),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2725),
    [anon_sym_for] = ACTIONS(2723),
    [anon_sym_while] = ACTIONS(2723),
    [anon_sym_if] = ACTIONS(2723),
    [anon_sym_fun] = ACTIONS(2723),
    [anon_sym_try] = ACTIONS(2723),
    [anon_sym_match] = ACTIONS(2723),
    [anon_sym_match_BANG] = ACTIONS(2725),
    [anon_sym_function] = ACTIONS(2723),
    [anon_sym_LT_DASH] = ACTIONS(2723),
    [anon_sym_DOT_LBRACK] = ACTIONS(2725),
    [anon_sym_LT] = ACTIONS(2725),
    [anon_sym_GT] = ACTIONS(2723),
    [anon_sym_use] = ACTIONS(2723),
    [anon_sym_use_BANG] = ACTIONS(2725),
    [anon_sym_do_BANG] = ACTIONS(2725),
    [anon_sym_begin] = ACTIONS(2723),
    [anon_sym_LPAREN2] = ACTIONS(2723),
    [anon_sym_or] = ACTIONS(2723),
    [aux_sym_char_token1] = ACTIONS(2725),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2723),
    [anon_sym_DQUOTE] = ACTIONS(2723),
    [anon_sym_AT_DQUOTE] = ACTIONS(2725),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2725),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2725),
    [sym_bool] = ACTIONS(2723),
    [sym_unit] = ACTIONS(2725),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2723),
    [sym_op_identifier] = ACTIONS(2723),
    [anon_sym_PLUS] = ACTIONS(2723),
    [anon_sym_DASH] = ACTIONS(2723),
    [anon_sym_PLUS_DOT] = ACTIONS(2723),
    [anon_sym_DASH_DOT] = ACTIONS(2723),
    [anon_sym_PERCENT] = ACTIONS(2723),
    [anon_sym_AMP_AMP] = ACTIONS(2723),
    [anon_sym_TILDE] = ACTIONS(2725),
    [aux_sym_prefix_op_token1] = ACTIONS(2723),
    [aux_sym_infix_op_token1] = ACTIONS(2725),
    [aux_sym_infix_op_token2] = ACTIONS(2723),
    [anon_sym_PIPE_PIPE] = ACTIONS(2723),
    [anon_sym_BANG_EQ] = ACTIONS(2723),
    [anon_sym_COLON_EQ] = ACTIONS(2725),
    [anon_sym_DOLLAR] = ACTIONS(2723),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2723),
    [sym_int] = ACTIONS(2723),
    [sym_xint] = ACTIONS(2725),
    [anon_sym_f] = ACTIONS(2723),
    [aux_sym_decimal_token1] = ACTIONS(2723),
    [aux_sym_float_token1] = ACTIONS(3533),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2725),
    [sym__newline] = ACTIONS(2725),
  },
  [1402] = {
    [sym_block_comment] = STATE(1402),
    [sym_compiler_directive_decl] = STATE(1402),
    [sym_fsi_directive_decl] = STATE(1402),
    [sym_preproc_line] = STATE(1402),
    [sym_identifier] = ACTIONS(2723),
    [anon_sym_EQ] = ACTIONS(2725),
    [anon_sym_COLON] = ACTIONS(2723),
    [anon_sym_return] = ACTIONS(2723),
    [anon_sym_do] = ACTIONS(2723),
    [anon_sym_let] = ACTIONS(2723),
    [anon_sym_let_BANG] = ACTIONS(2725),
    [anon_sym_LPAREN] = ACTIONS(2723),
    [anon_sym_COMMA] = ACTIONS(2725),
    [anon_sym_null] = ACTIONS(2723),
    [anon_sym_QMARK] = ACTIONS(2723),
    [anon_sym_COLON_QMARK] = ACTIONS(2723),
    [anon_sym_COLON_COLON] = ACTIONS(2725),
    [anon_sym_AMP] = ACTIONS(2723),
    [anon_sym_LBRACK] = ACTIONS(2723),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2725),
    [anon_sym_LBRACE] = ACTIONS(2723),
    [anon_sym_LT_AT] = ACTIONS(2723),
    [anon_sym_AT_GT] = ACTIONS(2723),
    [anon_sym_LT_AT_AT] = ACTIONS(2723),
    [anon_sym_DOT] = ACTIONS(2723),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2725),
    [anon_sym_new] = ACTIONS(2723),
    [anon_sym_return_BANG] = ACTIONS(2725),
    [anon_sym_yield] = ACTIONS(2723),
    [anon_sym_yield_BANG] = ACTIONS(2725),
    [anon_sym_lazy] = ACTIONS(2723),
    [anon_sym_assert] = ACTIONS(2723),
    [anon_sym_upcast] = ACTIONS(2723),
    [anon_sym_downcast] = ACTIONS(2723),
    [anon_sym_COLON_GT] = ACTIONS(2725),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2725),
    [anon_sym_for] = ACTIONS(2723),
    [anon_sym_while] = ACTIONS(2723),
    [anon_sym_if] = ACTIONS(2723),
    [anon_sym_fun] = ACTIONS(2723),
    [anon_sym_try] = ACTIONS(2723),
    [anon_sym_match] = ACTIONS(2723),
    [anon_sym_match_BANG] = ACTIONS(2725),
    [anon_sym_function] = ACTIONS(2723),
    [anon_sym_LT_DASH] = ACTIONS(2723),
    [anon_sym_DOT_LBRACK] = ACTIONS(2725),
    [anon_sym_LT] = ACTIONS(2725),
    [anon_sym_use] = ACTIONS(2723),
    [anon_sym_use_BANG] = ACTIONS(2725),
    [anon_sym_do_BANG] = ACTIONS(2725),
    [anon_sym_begin] = ACTIONS(2723),
    [anon_sym_LPAREN2] = ACTIONS(2723),
    [anon_sym_or] = ACTIONS(2723),
    [aux_sym_char_token1] = ACTIONS(2725),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2723),
    [anon_sym_DQUOTE] = ACTIONS(2723),
    [anon_sym_AT_DQUOTE] = ACTIONS(2725),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2725),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2725),
    [sym_bool] = ACTIONS(2723),
    [sym_unit] = ACTIONS(2725),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2723),
    [sym_op_identifier] = ACTIONS(2723),
    [anon_sym_PLUS] = ACTIONS(2723),
    [anon_sym_DASH] = ACTIONS(2723),
    [anon_sym_PLUS_DOT] = ACTIONS(2723),
    [anon_sym_DASH_DOT] = ACTIONS(2723),
    [anon_sym_PERCENT] = ACTIONS(2723),
    [anon_sym_AMP_AMP] = ACTIONS(2723),
    [anon_sym_TILDE] = ACTIONS(2725),
    [aux_sym_prefix_op_token1] = ACTIONS(2723),
    [aux_sym_infix_op_token1] = ACTIONS(2725),
    [aux_sym_infix_op_token2] = ACTIONS(2723),
    [anon_sym_PIPE_PIPE] = ACTIONS(2723),
    [anon_sym_BANG_EQ] = ACTIONS(2723),
    [anon_sym_COLON_EQ] = ACTIONS(2725),
    [anon_sym_DOLLAR] = ACTIONS(2723),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2723),
    [sym_int] = ACTIONS(2723),
    [sym_xint] = ACTIONS(2725),
    [anon_sym_f] = ACTIONS(2723),
    [aux_sym_decimal_token1] = ACTIONS(2723),
    [aux_sym_float_token1] = ACTIONS(3535),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2725),
    [sym__newline] = ACTIONS(2725),
  },
  [1403] = {
    [sym_block_comment] = STATE(1403),
    [sym_compiler_directive_decl] = STATE(1403),
    [sym_fsi_directive_decl] = STATE(1403),
    [sym_preproc_line] = STATE(1403),
    [aux_sym_rules_repeat1] = STATE(1403),
    [sym_identifier] = ACTIONS(2713),
    [anon_sym_EQ] = ACTIONS(2715),
    [anon_sym_COLON] = ACTIONS(2713),
    [anon_sym_return] = ACTIONS(2713),
    [anon_sym_do] = ACTIONS(2713),
    [anon_sym_and] = ACTIONS(2713),
    [anon_sym_let] = ACTIONS(2713),
    [anon_sym_let_BANG] = ACTIONS(2715),
    [anon_sym_LPAREN] = ACTIONS(2713),
    [anon_sym_COMMA] = ACTIONS(2715),
    [anon_sym_null] = ACTIONS(2713),
    [anon_sym_QMARK] = ACTIONS(2713),
    [anon_sym_COLON_QMARK] = ACTIONS(2713),
    [anon_sym_COLON_COLON] = ACTIONS(2715),
    [anon_sym_PIPE] = ACTIONS(3537),
    [anon_sym_AMP] = ACTIONS(2713),
    [anon_sym_LBRACK] = ACTIONS(2713),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2715),
    [anon_sym_LBRACE] = ACTIONS(2713),
    [anon_sym_LT_AT] = ACTIONS(2713),
    [anon_sym_LT_AT_AT] = ACTIONS(2713),
    [anon_sym_DOT] = ACTIONS(2713),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2715),
    [anon_sym_new] = ACTIONS(2713),
    [anon_sym_return_BANG] = ACTIONS(2715),
    [anon_sym_yield] = ACTIONS(2713),
    [anon_sym_yield_BANG] = ACTIONS(2715),
    [anon_sym_lazy] = ACTIONS(2713),
    [anon_sym_assert] = ACTIONS(2713),
    [anon_sym_upcast] = ACTIONS(2713),
    [anon_sym_downcast] = ACTIONS(2713),
    [anon_sym_COLON_GT] = ACTIONS(2715),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2715),
    [anon_sym_for] = ACTIONS(2713),
    [anon_sym_while] = ACTIONS(2713),
    [anon_sym_if] = ACTIONS(2713),
    [anon_sym_fun] = ACTIONS(2713),
    [anon_sym_try] = ACTIONS(2713),
    [anon_sym_match] = ACTIONS(2713),
    [anon_sym_match_BANG] = ACTIONS(2715),
    [anon_sym_function] = ACTIONS(2713),
    [anon_sym_LT_DASH] = ACTIONS(2713),
    [anon_sym_DOT_LBRACK] = ACTIONS(2715),
    [anon_sym_LT] = ACTIONS(2715),
    [anon_sym_use] = ACTIONS(2713),
    [anon_sym_use_BANG] = ACTIONS(2715),
    [anon_sym_do_BANG] = ACTIONS(2715),
    [anon_sym_begin] = ACTIONS(2713),
    [anon_sym_LPAREN2] = ACTIONS(2713),
    [anon_sym_or] = ACTIONS(2713),
    [aux_sym_char_token1] = ACTIONS(2715),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2713),
    [anon_sym_DQUOTE] = ACTIONS(2713),
    [anon_sym_AT_DQUOTE] = ACTIONS(2715),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2715),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2715),
    [sym_bool] = ACTIONS(2713),
    [sym_unit] = ACTIONS(2715),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2713),
    [sym_op_identifier] = ACTIONS(2713),
    [anon_sym_PLUS] = ACTIONS(2713),
    [anon_sym_DASH] = ACTIONS(2713),
    [anon_sym_PLUS_DOT] = ACTIONS(2713),
    [anon_sym_DASH_DOT] = ACTIONS(2713),
    [anon_sym_PERCENT] = ACTIONS(2713),
    [anon_sym_AMP_AMP] = ACTIONS(2713),
    [anon_sym_TILDE] = ACTIONS(2715),
    [aux_sym_prefix_op_token1] = ACTIONS(2713),
    [aux_sym_infix_op_token1] = ACTIONS(2715),
    [aux_sym_infix_op_token2] = ACTIONS(2713),
    [anon_sym_PIPE_PIPE] = ACTIONS(2713),
    [anon_sym_BANG_EQ] = ACTIONS(2713),
    [anon_sym_COLON_EQ] = ACTIONS(2715),
    [anon_sym_DOLLAR] = ACTIONS(2713),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2713),
    [sym_int] = ACTIONS(2713),
    [sym_xint] = ACTIONS(2715),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2715),
    [sym__newline] = ACTIONS(3540),
    [sym__dedent] = ACTIONS(2715),
  },
  [1404] = {
    [sym_block_comment] = STATE(1404),
    [sym_compiler_directive_decl] = STATE(1404),
    [sym_fsi_directive_decl] = STATE(1404),
    [sym_preproc_line] = STATE(1404),
    [aux_sym_rules_repeat1] = STATE(1404),
    [sym_identifier] = ACTIONS(2713),
    [anon_sym_EQ] = ACTIONS(2715),
    [anon_sym_COLON] = ACTIONS(2713),
    [anon_sym_return] = ACTIONS(2713),
    [anon_sym_do] = ACTIONS(2713),
    [anon_sym_let] = ACTIONS(2713),
    [anon_sym_let_BANG] = ACTIONS(2715),
    [anon_sym_as] = ACTIONS(2713),
    [anon_sym_LPAREN] = ACTIONS(2713),
    [anon_sym_COMMA] = ACTIONS(2715),
    [anon_sym_null] = ACTIONS(2713),
    [anon_sym_QMARK] = ACTIONS(2713),
    [anon_sym_COLON_QMARK] = ACTIONS(2713),
    [anon_sym_COLON_COLON] = ACTIONS(2715),
    [anon_sym_PIPE] = ACTIONS(3543),
    [anon_sym_AMP] = ACTIONS(2713),
    [anon_sym_LBRACK] = ACTIONS(2713),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2715),
    [anon_sym_LBRACE] = ACTIONS(2713),
    [anon_sym_LT_AT] = ACTIONS(2713),
    [anon_sym_LT_AT_AT] = ACTIONS(2713),
    [anon_sym_DOT] = ACTIONS(2713),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2715),
    [anon_sym_new] = ACTIONS(2713),
    [anon_sym_with] = ACTIONS(2713),
    [anon_sym_return_BANG] = ACTIONS(2715),
    [anon_sym_yield] = ACTIONS(2713),
    [anon_sym_yield_BANG] = ACTIONS(2715),
    [anon_sym_lazy] = ACTIONS(2713),
    [anon_sym_assert] = ACTIONS(2713),
    [anon_sym_upcast] = ACTIONS(2713),
    [anon_sym_downcast] = ACTIONS(2713),
    [anon_sym_COLON_GT] = ACTIONS(2715),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2715),
    [anon_sym_for] = ACTIONS(2713),
    [anon_sym_while] = ACTIONS(2713),
    [anon_sym_if] = ACTIONS(2713),
    [anon_sym_fun] = ACTIONS(2713),
    [anon_sym_try] = ACTIONS(2713),
    [anon_sym_match] = ACTIONS(2713),
    [anon_sym_match_BANG] = ACTIONS(2715),
    [anon_sym_function] = ACTIONS(2713),
    [anon_sym_LT_DASH] = ACTIONS(2713),
    [anon_sym_DOT_LBRACK] = ACTIONS(2715),
    [anon_sym_LT] = ACTIONS(2715),
    [anon_sym_use] = ACTIONS(2713),
    [anon_sym_use_BANG] = ACTIONS(2715),
    [anon_sym_do_BANG] = ACTIONS(2715),
    [anon_sym_begin] = ACTIONS(2713),
    [anon_sym_LPAREN2] = ACTIONS(2713),
    [anon_sym_or] = ACTIONS(2713),
    [aux_sym_char_token1] = ACTIONS(2715),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2713),
    [anon_sym_DQUOTE] = ACTIONS(2713),
    [anon_sym_AT_DQUOTE] = ACTIONS(2715),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2715),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2715),
    [sym_bool] = ACTIONS(2713),
    [sym_unit] = ACTIONS(2715),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2713),
    [sym_op_identifier] = ACTIONS(2713),
    [anon_sym_PLUS] = ACTIONS(2713),
    [anon_sym_DASH] = ACTIONS(2713),
    [anon_sym_PLUS_DOT] = ACTIONS(2713),
    [anon_sym_DASH_DOT] = ACTIONS(2713),
    [anon_sym_PERCENT] = ACTIONS(2713),
    [anon_sym_AMP_AMP] = ACTIONS(2713),
    [anon_sym_TILDE] = ACTIONS(2715),
    [aux_sym_prefix_op_token1] = ACTIONS(2713),
    [aux_sym_infix_op_token1] = ACTIONS(2715),
    [aux_sym_infix_op_token2] = ACTIONS(2713),
    [anon_sym_PIPE_PIPE] = ACTIONS(2713),
    [anon_sym_BANG_EQ] = ACTIONS(2713),
    [anon_sym_COLON_EQ] = ACTIONS(2715),
    [anon_sym_DOLLAR] = ACTIONS(2713),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2713),
    [sym_int] = ACTIONS(2713),
    [sym_xint] = ACTIONS(2715),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2715),
    [sym__newline] = ACTIONS(3546),
  },
  [1405] = {
    [sym_block_comment] = STATE(1405),
    [sym_compiler_directive_decl] = STATE(1405),
    [sym_fsi_directive_decl] = STATE(1405),
    [sym_preproc_line] = STATE(1405),
    [aux_sym_rules_repeat1] = STATE(1403),
    [sym_identifier] = ACTIONS(2737),
    [anon_sym_EQ] = ACTIONS(2739),
    [anon_sym_COLON] = ACTIONS(2737),
    [anon_sym_return] = ACTIONS(2737),
    [anon_sym_do] = ACTIONS(2737),
    [anon_sym_and] = ACTIONS(2737),
    [anon_sym_let] = ACTIONS(2737),
    [anon_sym_let_BANG] = ACTIONS(2739),
    [anon_sym_LPAREN] = ACTIONS(2737),
    [anon_sym_COMMA] = ACTIONS(2739),
    [anon_sym_null] = ACTIONS(2737),
    [anon_sym_QMARK] = ACTIONS(2737),
    [anon_sym_COLON_QMARK] = ACTIONS(2737),
    [anon_sym_COLON_COLON] = ACTIONS(2739),
    [anon_sym_PIPE] = ACTIONS(3549),
    [anon_sym_AMP] = ACTIONS(2737),
    [anon_sym_LBRACK] = ACTIONS(2737),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2739),
    [anon_sym_LBRACE] = ACTIONS(2737),
    [anon_sym_LT_AT] = ACTIONS(2737),
    [anon_sym_LT_AT_AT] = ACTIONS(2737),
    [anon_sym_DOT] = ACTIONS(2737),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2739),
    [anon_sym_new] = ACTIONS(2737),
    [anon_sym_return_BANG] = ACTIONS(2739),
    [anon_sym_yield] = ACTIONS(2737),
    [anon_sym_yield_BANG] = ACTIONS(2739),
    [anon_sym_lazy] = ACTIONS(2737),
    [anon_sym_assert] = ACTIONS(2737),
    [anon_sym_upcast] = ACTIONS(2737),
    [anon_sym_downcast] = ACTIONS(2737),
    [anon_sym_COLON_GT] = ACTIONS(2739),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2739),
    [anon_sym_for] = ACTIONS(2737),
    [anon_sym_while] = ACTIONS(2737),
    [anon_sym_if] = ACTIONS(2737),
    [anon_sym_fun] = ACTIONS(2737),
    [anon_sym_try] = ACTIONS(2737),
    [anon_sym_match] = ACTIONS(2737),
    [anon_sym_match_BANG] = ACTIONS(2739),
    [anon_sym_function] = ACTIONS(2737),
    [anon_sym_LT_DASH] = ACTIONS(2737),
    [anon_sym_DOT_LBRACK] = ACTIONS(2739),
    [anon_sym_LT] = ACTIONS(2739),
    [anon_sym_use] = ACTIONS(2737),
    [anon_sym_use_BANG] = ACTIONS(2739),
    [anon_sym_do_BANG] = ACTIONS(2739),
    [anon_sym_begin] = ACTIONS(2737),
    [anon_sym_LPAREN2] = ACTIONS(2737),
    [anon_sym_or] = ACTIONS(2737),
    [aux_sym_char_token1] = ACTIONS(2739),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2737),
    [anon_sym_DQUOTE] = ACTIONS(2737),
    [anon_sym_AT_DQUOTE] = ACTIONS(2739),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2739),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2739),
    [sym_bool] = ACTIONS(2737),
    [sym_unit] = ACTIONS(2739),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2737),
    [sym_op_identifier] = ACTIONS(2737),
    [anon_sym_PLUS] = ACTIONS(2737),
    [anon_sym_DASH] = ACTIONS(2737),
    [anon_sym_PLUS_DOT] = ACTIONS(2737),
    [anon_sym_DASH_DOT] = ACTIONS(2737),
    [anon_sym_PERCENT] = ACTIONS(2737),
    [anon_sym_AMP_AMP] = ACTIONS(2737),
    [anon_sym_TILDE] = ACTIONS(2739),
    [aux_sym_prefix_op_token1] = ACTIONS(2737),
    [aux_sym_infix_op_token1] = ACTIONS(2739),
    [aux_sym_infix_op_token2] = ACTIONS(2737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2737),
    [anon_sym_BANG_EQ] = ACTIONS(2737),
    [anon_sym_COLON_EQ] = ACTIONS(2739),
    [anon_sym_DOLLAR] = ACTIONS(2737),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2737),
    [sym_int] = ACTIONS(2737),
    [sym_xint] = ACTIONS(2739),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2739),
    [sym__newline] = ACTIONS(3551),
    [sym__dedent] = ACTIONS(2739),
  },
  [1406] = {
    [sym_block_comment] = STATE(1406),
    [sym_compiler_directive_decl] = STATE(1406),
    [sym_fsi_directive_decl] = STATE(1406),
    [sym_preproc_line] = STATE(1406),
    [aux_sym_rules_repeat1] = STATE(1403),
    [sym_identifier] = ACTIONS(2698),
    [anon_sym_EQ] = ACTIONS(2700),
    [anon_sym_COLON] = ACTIONS(2698),
    [anon_sym_return] = ACTIONS(2698),
    [anon_sym_do] = ACTIONS(2698),
    [anon_sym_and] = ACTIONS(2698),
    [anon_sym_let] = ACTIONS(2698),
    [anon_sym_let_BANG] = ACTIONS(2700),
    [anon_sym_LPAREN] = ACTIONS(2698),
    [anon_sym_COMMA] = ACTIONS(2700),
    [anon_sym_null] = ACTIONS(2698),
    [anon_sym_QMARK] = ACTIONS(2698),
    [anon_sym_COLON_QMARK] = ACTIONS(2698),
    [anon_sym_COLON_COLON] = ACTIONS(2700),
    [anon_sym_PIPE] = ACTIONS(3549),
    [anon_sym_AMP] = ACTIONS(2698),
    [anon_sym_LBRACK] = ACTIONS(2698),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2700),
    [anon_sym_LBRACE] = ACTIONS(2698),
    [anon_sym_LT_AT] = ACTIONS(2698),
    [anon_sym_LT_AT_AT] = ACTIONS(2698),
    [anon_sym_DOT] = ACTIONS(2698),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2700),
    [anon_sym_new] = ACTIONS(2698),
    [anon_sym_return_BANG] = ACTIONS(2700),
    [anon_sym_yield] = ACTIONS(2698),
    [anon_sym_yield_BANG] = ACTIONS(2700),
    [anon_sym_lazy] = ACTIONS(2698),
    [anon_sym_assert] = ACTIONS(2698),
    [anon_sym_upcast] = ACTIONS(2698),
    [anon_sym_downcast] = ACTIONS(2698),
    [anon_sym_COLON_GT] = ACTIONS(2700),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2700),
    [anon_sym_for] = ACTIONS(2698),
    [anon_sym_while] = ACTIONS(2698),
    [anon_sym_if] = ACTIONS(2698),
    [anon_sym_fun] = ACTIONS(2698),
    [anon_sym_try] = ACTIONS(2698),
    [anon_sym_match] = ACTIONS(2698),
    [anon_sym_match_BANG] = ACTIONS(2700),
    [anon_sym_function] = ACTIONS(2698),
    [anon_sym_LT_DASH] = ACTIONS(2698),
    [anon_sym_DOT_LBRACK] = ACTIONS(2700),
    [anon_sym_LT] = ACTIONS(2700),
    [anon_sym_use] = ACTIONS(2698),
    [anon_sym_use_BANG] = ACTIONS(2700),
    [anon_sym_do_BANG] = ACTIONS(2700),
    [anon_sym_begin] = ACTIONS(2698),
    [anon_sym_LPAREN2] = ACTIONS(2698),
    [anon_sym_or] = ACTIONS(2698),
    [aux_sym_char_token1] = ACTIONS(2700),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2698),
    [anon_sym_DQUOTE] = ACTIONS(2698),
    [anon_sym_AT_DQUOTE] = ACTIONS(2700),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2700),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2700),
    [sym_bool] = ACTIONS(2698),
    [sym_unit] = ACTIONS(2700),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2698),
    [sym_op_identifier] = ACTIONS(2698),
    [anon_sym_PLUS] = ACTIONS(2698),
    [anon_sym_DASH] = ACTIONS(2698),
    [anon_sym_PLUS_DOT] = ACTIONS(2698),
    [anon_sym_DASH_DOT] = ACTIONS(2698),
    [anon_sym_PERCENT] = ACTIONS(2698),
    [anon_sym_AMP_AMP] = ACTIONS(2698),
    [anon_sym_TILDE] = ACTIONS(2700),
    [aux_sym_prefix_op_token1] = ACTIONS(2698),
    [aux_sym_infix_op_token1] = ACTIONS(2700),
    [aux_sym_infix_op_token2] = ACTIONS(2698),
    [anon_sym_PIPE_PIPE] = ACTIONS(2698),
    [anon_sym_BANG_EQ] = ACTIONS(2698),
    [anon_sym_COLON_EQ] = ACTIONS(2700),
    [anon_sym_DOLLAR] = ACTIONS(2698),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2698),
    [sym_int] = ACTIONS(2698),
    [sym_xint] = ACTIONS(2700),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2700),
    [sym__newline] = ACTIONS(3554),
    [sym__dedent] = ACTIONS(2700),
  },
  [1407] = {
    [sym_block_comment] = STATE(1407),
    [sym_compiler_directive_decl] = STATE(1407),
    [sym_fsi_directive_decl] = STATE(1407),
    [sym_preproc_line] = STATE(1407),
    [aux_sym_rules_repeat1] = STATE(1404),
    [sym_identifier] = ACTIONS(2737),
    [anon_sym_EQ] = ACTIONS(2739),
    [anon_sym_COLON] = ACTIONS(2737),
    [anon_sym_return] = ACTIONS(2737),
    [anon_sym_do] = ACTIONS(2737),
    [anon_sym_let] = ACTIONS(2737),
    [anon_sym_let_BANG] = ACTIONS(2739),
    [anon_sym_as] = ACTIONS(2737),
    [anon_sym_LPAREN] = ACTIONS(2737),
    [anon_sym_COMMA] = ACTIONS(2739),
    [anon_sym_null] = ACTIONS(2737),
    [anon_sym_QMARK] = ACTIONS(2737),
    [anon_sym_COLON_QMARK] = ACTIONS(2737),
    [anon_sym_COLON_COLON] = ACTIONS(2739),
    [anon_sym_PIPE] = ACTIONS(3557),
    [anon_sym_AMP] = ACTIONS(2737),
    [anon_sym_LBRACK] = ACTIONS(2737),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2739),
    [anon_sym_LBRACE] = ACTIONS(2737),
    [anon_sym_LT_AT] = ACTIONS(2737),
    [anon_sym_LT_AT_AT] = ACTIONS(2737),
    [anon_sym_DOT] = ACTIONS(2737),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2739),
    [anon_sym_new] = ACTIONS(2737),
    [anon_sym_with] = ACTIONS(2737),
    [anon_sym_return_BANG] = ACTIONS(2739),
    [anon_sym_yield] = ACTIONS(2737),
    [anon_sym_yield_BANG] = ACTIONS(2739),
    [anon_sym_lazy] = ACTIONS(2737),
    [anon_sym_assert] = ACTIONS(2737),
    [anon_sym_upcast] = ACTIONS(2737),
    [anon_sym_downcast] = ACTIONS(2737),
    [anon_sym_COLON_GT] = ACTIONS(2739),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2739),
    [anon_sym_for] = ACTIONS(2737),
    [anon_sym_while] = ACTIONS(2737),
    [anon_sym_if] = ACTIONS(2737),
    [anon_sym_fun] = ACTIONS(2737),
    [anon_sym_try] = ACTIONS(2737),
    [anon_sym_match] = ACTIONS(2737),
    [anon_sym_match_BANG] = ACTIONS(2739),
    [anon_sym_function] = ACTIONS(2737),
    [anon_sym_LT_DASH] = ACTIONS(2737),
    [anon_sym_DOT_LBRACK] = ACTIONS(2739),
    [anon_sym_LT] = ACTIONS(2739),
    [anon_sym_use] = ACTIONS(2737),
    [anon_sym_use_BANG] = ACTIONS(2739),
    [anon_sym_do_BANG] = ACTIONS(2739),
    [anon_sym_begin] = ACTIONS(2737),
    [anon_sym_LPAREN2] = ACTIONS(2737),
    [anon_sym_or] = ACTIONS(2737),
    [aux_sym_char_token1] = ACTIONS(2739),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2737),
    [anon_sym_DQUOTE] = ACTIONS(2737),
    [anon_sym_AT_DQUOTE] = ACTIONS(2739),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2739),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2739),
    [sym_bool] = ACTIONS(2737),
    [sym_unit] = ACTIONS(2739),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2737),
    [sym_op_identifier] = ACTIONS(2737),
    [anon_sym_PLUS] = ACTIONS(2737),
    [anon_sym_DASH] = ACTIONS(2737),
    [anon_sym_PLUS_DOT] = ACTIONS(2737),
    [anon_sym_DASH_DOT] = ACTIONS(2737),
    [anon_sym_PERCENT] = ACTIONS(2737),
    [anon_sym_AMP_AMP] = ACTIONS(2737),
    [anon_sym_TILDE] = ACTIONS(2739),
    [aux_sym_prefix_op_token1] = ACTIONS(2737),
    [aux_sym_infix_op_token1] = ACTIONS(2739),
    [aux_sym_infix_op_token2] = ACTIONS(2737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2737),
    [anon_sym_BANG_EQ] = ACTIONS(2737),
    [anon_sym_COLON_EQ] = ACTIONS(2739),
    [anon_sym_DOLLAR] = ACTIONS(2737),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2737),
    [sym_int] = ACTIONS(2737),
    [sym_xint] = ACTIONS(2739),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2739),
    [sym__newline] = ACTIONS(3559),
  },
  [1408] = {
    [sym_block_comment] = STATE(1408),
    [sym_compiler_directive_decl] = STATE(1408),
    [sym_fsi_directive_decl] = STATE(1408),
    [sym_preproc_line] = STATE(1408),
    [aux_sym_rules_repeat1] = STATE(1405),
    [sym_identifier] = ACTIONS(2698),
    [anon_sym_EQ] = ACTIONS(2700),
    [anon_sym_COLON] = ACTIONS(2698),
    [anon_sym_return] = ACTIONS(2698),
    [anon_sym_do] = ACTIONS(2698),
    [anon_sym_and] = ACTIONS(2698),
    [anon_sym_let] = ACTIONS(2698),
    [anon_sym_let_BANG] = ACTIONS(2700),
    [anon_sym_LPAREN] = ACTIONS(2698),
    [anon_sym_COMMA] = ACTIONS(2700),
    [anon_sym_null] = ACTIONS(2698),
    [anon_sym_QMARK] = ACTIONS(2698),
    [anon_sym_COLON_QMARK] = ACTIONS(2698),
    [anon_sym_COLON_COLON] = ACTIONS(2700),
    [anon_sym_PIPE] = ACTIONS(3549),
    [anon_sym_AMP] = ACTIONS(2698),
    [anon_sym_LBRACK] = ACTIONS(2698),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2700),
    [anon_sym_LBRACE] = ACTIONS(2698),
    [anon_sym_LT_AT] = ACTIONS(2698),
    [anon_sym_LT_AT_AT] = ACTIONS(2698),
    [anon_sym_DOT] = ACTIONS(2698),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2700),
    [anon_sym_new] = ACTIONS(2698),
    [anon_sym_return_BANG] = ACTIONS(2700),
    [anon_sym_yield] = ACTIONS(2698),
    [anon_sym_yield_BANG] = ACTIONS(2700),
    [anon_sym_lazy] = ACTIONS(2698),
    [anon_sym_assert] = ACTIONS(2698),
    [anon_sym_upcast] = ACTIONS(2698),
    [anon_sym_downcast] = ACTIONS(2698),
    [anon_sym_COLON_GT] = ACTIONS(2700),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2700),
    [anon_sym_for] = ACTIONS(2698),
    [anon_sym_while] = ACTIONS(2698),
    [anon_sym_if] = ACTIONS(2698),
    [anon_sym_fun] = ACTIONS(2698),
    [anon_sym_try] = ACTIONS(2698),
    [anon_sym_match] = ACTIONS(2698),
    [anon_sym_match_BANG] = ACTIONS(2700),
    [anon_sym_function] = ACTIONS(2698),
    [anon_sym_LT_DASH] = ACTIONS(2698),
    [anon_sym_DOT_LBRACK] = ACTIONS(2700),
    [anon_sym_LT] = ACTIONS(2700),
    [anon_sym_use] = ACTIONS(2698),
    [anon_sym_use_BANG] = ACTIONS(2700),
    [anon_sym_do_BANG] = ACTIONS(2700),
    [anon_sym_begin] = ACTIONS(2698),
    [anon_sym_LPAREN2] = ACTIONS(2698),
    [anon_sym_or] = ACTIONS(2698),
    [aux_sym_char_token1] = ACTIONS(2700),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2698),
    [anon_sym_DQUOTE] = ACTIONS(2698),
    [anon_sym_AT_DQUOTE] = ACTIONS(2700),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2700),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2700),
    [sym_bool] = ACTIONS(2698),
    [sym_unit] = ACTIONS(2700),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2698),
    [sym_op_identifier] = ACTIONS(2698),
    [anon_sym_PLUS] = ACTIONS(2698),
    [anon_sym_DASH] = ACTIONS(2698),
    [anon_sym_PLUS_DOT] = ACTIONS(2698),
    [anon_sym_DASH_DOT] = ACTIONS(2698),
    [anon_sym_PERCENT] = ACTIONS(2698),
    [anon_sym_AMP_AMP] = ACTIONS(2698),
    [anon_sym_TILDE] = ACTIONS(2700),
    [aux_sym_prefix_op_token1] = ACTIONS(2698),
    [aux_sym_infix_op_token1] = ACTIONS(2700),
    [aux_sym_infix_op_token2] = ACTIONS(2698),
    [anon_sym_PIPE_PIPE] = ACTIONS(2698),
    [anon_sym_BANG_EQ] = ACTIONS(2698),
    [anon_sym_COLON_EQ] = ACTIONS(2700),
    [anon_sym_DOLLAR] = ACTIONS(2698),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2698),
    [sym_int] = ACTIONS(2698),
    [sym_xint] = ACTIONS(2700),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2700),
    [sym__newline] = ACTIONS(3554),
    [sym__dedent] = ACTIONS(2700),
  },
  [1409] = {
    [sym_attributes] = STATE(2676),
    [sym__attribute_set] = STATE(4045),
    [sym__function_or_value_defns] = STATE(6695),
    [sym__function_or_value_defn_body] = STATE(5748),
    [sym_function_declaration_left] = STATE(6285),
    [sym_value_declaration_left] = STATE(6285),
    [sym_access_modifier] = STATE(2693),
    [sym_repeat_pattern] = STATE(4815),
    [sym__pattern] = STATE(5168),
    [sym_optional_pattern] = STATE(4815),
    [sym_type_check_pattern] = STATE(4815),
    [sym_attribute_pattern] = STATE(4815),
    [sym_paren_pattern] = STATE(4815),
    [sym_as_pattern] = STATE(4815),
    [sym_cons_pattern] = STATE(4815),
    [sym_disjunct_pattern] = STATE(4815),
    [sym_conjunct_pattern] = STATE(4815),
    [sym_typed_pattern] = STATE(4815),
    [sym_list_pattern] = STATE(4815),
    [sym_array_pattern] = STATE(4815),
    [sym_record_pattern] = STATE(4815),
    [sym_named_field_pattern] = STATE(4815),
    [sym_identifier_pattern] = STATE(4815),
    [sym_long_identifier_or_op] = STATE(1792),
    [sym_property_accessor] = STATE(5895),
    [sym_char] = STATE(4765),
    [sym_format_string] = STATE(4746),
    [sym__string_literal] = STATE(4746),
    [sym_string] = STATE(4765),
    [sym_verbatim_string] = STATE(4765),
    [sym_bytearray] = STATE(4765),
    [sym_verbatim_bytearray] = STATE(4765),
    [sym_format_triple_quoted_string] = STATE(4720),
    [sym_triple_quoted_string] = STATE(4765),
    [sym_const] = STATE(4815),
    [sym_long_identifier] = STATE(3320),
    [sym_active_pattern] = STATE(3488),
    [sym__identifier_or_op] = STATE(2746),
    [sym_sbyte] = STATE(4765),
    [sym_byte] = STATE(4765),
    [sym_int16] = STATE(4765),
    [sym_uint16] = STATE(4765),
    [sym_int32] = STATE(4765),
    [sym_uint32] = STATE(4765),
    [sym_nativeint] = STATE(4765),
    [sym_unativeint] = STATE(4765),
    [sym_int64] = STATE(4765),
    [sym_uint64] = STATE(4765),
    [sym_ieee32] = STATE(4765),
    [sym_ieee64] = STATE(4765),
    [sym_bignum] = STATE(4765),
    [sym_decimal] = STATE(4765),
    [sym_float] = STATE(4512),
    [sym_block_comment] = STATE(1409),
    [sym_compiler_directive_decl] = STATE(1409),
    [sym_fsi_directive_decl] = STATE(1409),
    [sym_preproc_line] = STATE(1409),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(3562),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_inline] = ACTIONS(3566),
    [anon_sym_mutable] = ACTIONS(3568),
    [aux_sym_access_modifier_token1] = ACTIONS(3570),
    [anon_sym_LPAREN] = ACTIONS(3572),
    [anon_sym_null] = ACTIONS(3574),
    [anon_sym__] = ACTIONS(3576),
    [anon_sym_QMARK] = ACTIONS(3578),
    [anon_sym_COLON_QMARK] = ACTIONS(3580),
    [anon_sym_LBRACK] = ACTIONS(3582),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3584),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [anon_sym_get] = ACTIONS(3588),
    [anon_sym_set] = ACTIONS(3588),
    [aux_sym_char_token1] = ACTIONS(3590),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3592),
    [anon_sym_DQUOTE] = ACTIONS(3594),
    [anon_sym_AT_DQUOTE] = ACTIONS(3596),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3598),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3600),
    [sym_bool] = ACTIONS(3602),
    [sym_unit] = ACTIONS(3604),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3606),
    [sym_op_identifier] = ACTIONS(3608),
    [sym_int] = ACTIONS(3610),
    [sym_xint] = ACTIONS(3612),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [1410] = {
    [sym_block_comment] = STATE(1410),
    [sym_compiler_directive_decl] = STATE(1410),
    [sym_fsi_directive_decl] = STATE(1410),
    [sym_preproc_line] = STATE(1410),
    [sym_identifier] = ACTIONS(2748),
    [anon_sym_EQ] = ACTIONS(2750),
    [anon_sym_COLON] = ACTIONS(2748),
    [anon_sym_return] = ACTIONS(2748),
    [anon_sym_do] = ACTIONS(2748),
    [anon_sym_let] = ACTIONS(2748),
    [anon_sym_let_BANG] = ACTIONS(2750),
    [anon_sym_LPAREN] = ACTIONS(2748),
    [anon_sym_COMMA] = ACTIONS(2750),
    [anon_sym_null] = ACTIONS(2748),
    [anon_sym_QMARK] = ACTIONS(2748),
    [anon_sym_COLON_QMARK] = ACTIONS(2748),
    [anon_sym_COLON_COLON] = ACTIONS(2750),
    [anon_sym_AMP] = ACTIONS(2748),
    [anon_sym_LBRACK] = ACTIONS(2748),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2750),
    [anon_sym_LBRACE] = ACTIONS(2748),
    [anon_sym_LT_AT] = ACTIONS(2748),
    [anon_sym_LT_AT_AT] = ACTIONS(2748),
    [anon_sym_DOT] = ACTIONS(2748),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2750),
    [anon_sym_new] = ACTIONS(2748),
    [anon_sym_return_BANG] = ACTIONS(2750),
    [anon_sym_yield] = ACTIONS(2748),
    [anon_sym_yield_BANG] = ACTIONS(2750),
    [anon_sym_lazy] = ACTIONS(2748),
    [anon_sym_assert] = ACTIONS(2748),
    [anon_sym_upcast] = ACTIONS(2748),
    [anon_sym_downcast] = ACTIONS(2748),
    [anon_sym_COLON_GT] = ACTIONS(2750),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2750),
    [anon_sym_for] = ACTIONS(2748),
    [anon_sym_while] = ACTIONS(2748),
    [anon_sym_else] = ACTIONS(2748),
    [anon_sym_elif] = ACTIONS(2748),
    [anon_sym_if] = ACTIONS(2748),
    [anon_sym_fun] = ACTIONS(2748),
    [anon_sym_try] = ACTIONS(2748),
    [anon_sym_match] = ACTIONS(2748),
    [anon_sym_match_BANG] = ACTIONS(2750),
    [anon_sym_function] = ACTIONS(2748),
    [anon_sym_LT_DASH] = ACTIONS(2748),
    [anon_sym_DOT_LBRACK] = ACTIONS(2750),
    [anon_sym_LT] = ACTIONS(2750),
    [anon_sym_use] = ACTIONS(2748),
    [anon_sym_use_BANG] = ACTIONS(2750),
    [anon_sym_do_BANG] = ACTIONS(2750),
    [anon_sym_begin] = ACTIONS(2748),
    [anon_sym_LPAREN2] = ACTIONS(2748),
    [anon_sym_or] = ACTIONS(2748),
    [aux_sym_char_token1] = ACTIONS(2750),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2748),
    [anon_sym_DQUOTE] = ACTIONS(2748),
    [anon_sym_AT_DQUOTE] = ACTIONS(2750),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2750),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2750),
    [sym_bool] = ACTIONS(2748),
    [sym_unit] = ACTIONS(2750),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2748),
    [sym_op_identifier] = ACTIONS(2748),
    [anon_sym_PLUS] = ACTIONS(2748),
    [anon_sym_DASH] = ACTIONS(2748),
    [anon_sym_PLUS_DOT] = ACTIONS(2748),
    [anon_sym_DASH_DOT] = ACTIONS(2748),
    [anon_sym_PERCENT] = ACTIONS(2748),
    [anon_sym_AMP_AMP] = ACTIONS(2748),
    [anon_sym_TILDE] = ACTIONS(2750),
    [aux_sym_prefix_op_token1] = ACTIONS(2748),
    [aux_sym_infix_op_token1] = ACTIONS(2750),
    [aux_sym_infix_op_token2] = ACTIONS(2748),
    [anon_sym_PIPE_PIPE] = ACTIONS(2748),
    [anon_sym_BANG_EQ] = ACTIONS(2748),
    [anon_sym_COLON_EQ] = ACTIONS(2750),
    [anon_sym_DOLLAR] = ACTIONS(2748),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2748),
    [sym_int] = ACTIONS(2748),
    [sym_xint] = ACTIONS(2750),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2750),
    [anon_sym_POUNDendif] = ACTIONS(2750),
    [anon_sym_POUNDelse] = ACTIONS(2750),
    [sym__newline] = ACTIONS(2750),
  },
  [1411] = {
    [sym_block_comment] = STATE(1411),
    [sym_compiler_directive_decl] = STATE(1411),
    [sym_fsi_directive_decl] = STATE(1411),
    [sym_preproc_line] = STATE(1411),
    [aux_sym_rules_repeat1] = STATE(1404),
    [sym_identifier] = ACTIONS(2698),
    [anon_sym_EQ] = ACTIONS(2700),
    [anon_sym_COLON] = ACTIONS(2698),
    [anon_sym_return] = ACTIONS(2698),
    [anon_sym_do] = ACTIONS(2698),
    [anon_sym_let] = ACTIONS(2698),
    [anon_sym_let_BANG] = ACTIONS(2700),
    [anon_sym_as] = ACTIONS(2698),
    [anon_sym_LPAREN] = ACTIONS(2698),
    [anon_sym_COMMA] = ACTIONS(2700),
    [anon_sym_null] = ACTIONS(2698),
    [anon_sym_QMARK] = ACTIONS(2698),
    [anon_sym_COLON_QMARK] = ACTIONS(2698),
    [anon_sym_COLON_COLON] = ACTIONS(2700),
    [anon_sym_PIPE] = ACTIONS(3557),
    [anon_sym_AMP] = ACTIONS(2698),
    [anon_sym_LBRACK] = ACTIONS(2698),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2700),
    [anon_sym_LBRACE] = ACTIONS(2698),
    [anon_sym_LT_AT] = ACTIONS(2698),
    [anon_sym_LT_AT_AT] = ACTIONS(2698),
    [anon_sym_DOT] = ACTIONS(2698),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2700),
    [anon_sym_new] = ACTIONS(2698),
    [anon_sym_with] = ACTIONS(2698),
    [anon_sym_return_BANG] = ACTIONS(2700),
    [anon_sym_yield] = ACTIONS(2698),
    [anon_sym_yield_BANG] = ACTIONS(2700),
    [anon_sym_lazy] = ACTIONS(2698),
    [anon_sym_assert] = ACTIONS(2698),
    [anon_sym_upcast] = ACTIONS(2698),
    [anon_sym_downcast] = ACTIONS(2698),
    [anon_sym_COLON_GT] = ACTIONS(2700),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2700),
    [anon_sym_for] = ACTIONS(2698),
    [anon_sym_while] = ACTIONS(2698),
    [anon_sym_if] = ACTIONS(2698),
    [anon_sym_fun] = ACTIONS(2698),
    [anon_sym_try] = ACTIONS(2698),
    [anon_sym_match] = ACTIONS(2698),
    [anon_sym_match_BANG] = ACTIONS(2700),
    [anon_sym_function] = ACTIONS(2698),
    [anon_sym_LT_DASH] = ACTIONS(2698),
    [anon_sym_DOT_LBRACK] = ACTIONS(2700),
    [anon_sym_LT] = ACTIONS(2700),
    [anon_sym_use] = ACTIONS(2698),
    [anon_sym_use_BANG] = ACTIONS(2700),
    [anon_sym_do_BANG] = ACTIONS(2700),
    [anon_sym_begin] = ACTIONS(2698),
    [anon_sym_LPAREN2] = ACTIONS(2698),
    [anon_sym_or] = ACTIONS(2698),
    [aux_sym_char_token1] = ACTIONS(2700),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2698),
    [anon_sym_DQUOTE] = ACTIONS(2698),
    [anon_sym_AT_DQUOTE] = ACTIONS(2700),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2700),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2700),
    [sym_bool] = ACTIONS(2698),
    [sym_unit] = ACTIONS(2700),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2698),
    [sym_op_identifier] = ACTIONS(2698),
    [anon_sym_PLUS] = ACTIONS(2698),
    [anon_sym_DASH] = ACTIONS(2698),
    [anon_sym_PLUS_DOT] = ACTIONS(2698),
    [anon_sym_DASH_DOT] = ACTIONS(2698),
    [anon_sym_PERCENT] = ACTIONS(2698),
    [anon_sym_AMP_AMP] = ACTIONS(2698),
    [anon_sym_TILDE] = ACTIONS(2700),
    [aux_sym_prefix_op_token1] = ACTIONS(2698),
    [aux_sym_infix_op_token1] = ACTIONS(2700),
    [aux_sym_infix_op_token2] = ACTIONS(2698),
    [anon_sym_PIPE_PIPE] = ACTIONS(2698),
    [anon_sym_BANG_EQ] = ACTIONS(2698),
    [anon_sym_COLON_EQ] = ACTIONS(2700),
    [anon_sym_DOLLAR] = ACTIONS(2698),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2698),
    [sym_int] = ACTIONS(2698),
    [sym_xint] = ACTIONS(2700),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2700),
    [sym__newline] = ACTIONS(3614),
  },
  [1412] = {
    [sym_block_comment] = STATE(1412),
    [sym_compiler_directive_decl] = STATE(1412),
    [sym_fsi_directive_decl] = STATE(1412),
    [sym_preproc_line] = STATE(1412),
    [aux_sym_rules_repeat1] = STATE(1407),
    [sym_identifier] = ACTIONS(2698),
    [anon_sym_EQ] = ACTIONS(2700),
    [anon_sym_COLON] = ACTIONS(2698),
    [anon_sym_return] = ACTIONS(2698),
    [anon_sym_do] = ACTIONS(2698),
    [anon_sym_let] = ACTIONS(2698),
    [anon_sym_let_BANG] = ACTIONS(2700),
    [anon_sym_as] = ACTIONS(2698),
    [anon_sym_LPAREN] = ACTIONS(2698),
    [anon_sym_COMMA] = ACTIONS(2700),
    [anon_sym_null] = ACTIONS(2698),
    [anon_sym_QMARK] = ACTIONS(2698),
    [anon_sym_COLON_QMARK] = ACTIONS(2698),
    [anon_sym_COLON_COLON] = ACTIONS(2700),
    [anon_sym_PIPE] = ACTIONS(3557),
    [anon_sym_AMP] = ACTIONS(2698),
    [anon_sym_LBRACK] = ACTIONS(2698),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2700),
    [anon_sym_LBRACE] = ACTIONS(2698),
    [anon_sym_LT_AT] = ACTIONS(2698),
    [anon_sym_LT_AT_AT] = ACTIONS(2698),
    [anon_sym_DOT] = ACTIONS(2698),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2700),
    [anon_sym_new] = ACTIONS(2698),
    [anon_sym_with] = ACTIONS(2698),
    [anon_sym_return_BANG] = ACTIONS(2700),
    [anon_sym_yield] = ACTIONS(2698),
    [anon_sym_yield_BANG] = ACTIONS(2700),
    [anon_sym_lazy] = ACTIONS(2698),
    [anon_sym_assert] = ACTIONS(2698),
    [anon_sym_upcast] = ACTIONS(2698),
    [anon_sym_downcast] = ACTIONS(2698),
    [anon_sym_COLON_GT] = ACTIONS(2700),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2700),
    [anon_sym_for] = ACTIONS(2698),
    [anon_sym_while] = ACTIONS(2698),
    [anon_sym_if] = ACTIONS(2698),
    [anon_sym_fun] = ACTIONS(2698),
    [anon_sym_try] = ACTIONS(2698),
    [anon_sym_match] = ACTIONS(2698),
    [anon_sym_match_BANG] = ACTIONS(2700),
    [anon_sym_function] = ACTIONS(2698),
    [anon_sym_LT_DASH] = ACTIONS(2698),
    [anon_sym_DOT_LBRACK] = ACTIONS(2700),
    [anon_sym_LT] = ACTIONS(2700),
    [anon_sym_use] = ACTIONS(2698),
    [anon_sym_use_BANG] = ACTIONS(2700),
    [anon_sym_do_BANG] = ACTIONS(2700),
    [anon_sym_begin] = ACTIONS(2698),
    [anon_sym_LPAREN2] = ACTIONS(2698),
    [anon_sym_or] = ACTIONS(2698),
    [aux_sym_char_token1] = ACTIONS(2700),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2698),
    [anon_sym_DQUOTE] = ACTIONS(2698),
    [anon_sym_AT_DQUOTE] = ACTIONS(2700),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2700),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2700),
    [sym_bool] = ACTIONS(2698),
    [sym_unit] = ACTIONS(2700),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2698),
    [sym_op_identifier] = ACTIONS(2698),
    [anon_sym_PLUS] = ACTIONS(2698),
    [anon_sym_DASH] = ACTIONS(2698),
    [anon_sym_PLUS_DOT] = ACTIONS(2698),
    [anon_sym_DASH_DOT] = ACTIONS(2698),
    [anon_sym_PERCENT] = ACTIONS(2698),
    [anon_sym_AMP_AMP] = ACTIONS(2698),
    [anon_sym_TILDE] = ACTIONS(2700),
    [aux_sym_prefix_op_token1] = ACTIONS(2698),
    [aux_sym_infix_op_token1] = ACTIONS(2700),
    [aux_sym_infix_op_token2] = ACTIONS(2698),
    [anon_sym_PIPE_PIPE] = ACTIONS(2698),
    [anon_sym_BANG_EQ] = ACTIONS(2698),
    [anon_sym_COLON_EQ] = ACTIONS(2700),
    [anon_sym_DOLLAR] = ACTIONS(2698),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2698),
    [sym_int] = ACTIONS(2698),
    [sym_xint] = ACTIONS(2700),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2700),
    [sym__newline] = ACTIONS(3614),
  },
  [1413] = {
    [sym_block_comment] = STATE(1413),
    [sym_compiler_directive_decl] = STATE(1413),
    [sym_fsi_directive_decl] = STATE(1413),
    [sym_preproc_line] = STATE(1413),
    [aux_sym_rules_repeat1] = STATE(1406),
    [sym_identifier] = ACTIONS(2689),
    [anon_sym_EQ] = ACTIONS(2691),
    [anon_sym_COLON] = ACTIONS(2689),
    [anon_sym_return] = ACTIONS(2689),
    [anon_sym_do] = ACTIONS(2689),
    [anon_sym_and] = ACTIONS(2689),
    [anon_sym_let] = ACTIONS(2689),
    [anon_sym_let_BANG] = ACTIONS(2691),
    [anon_sym_LPAREN] = ACTIONS(2689),
    [anon_sym_COMMA] = ACTIONS(2691),
    [anon_sym_null] = ACTIONS(2689),
    [anon_sym_QMARK] = ACTIONS(2689),
    [anon_sym_COLON_QMARK] = ACTIONS(2689),
    [anon_sym_COLON_COLON] = ACTIONS(2691),
    [anon_sym_PIPE] = ACTIONS(3549),
    [anon_sym_AMP] = ACTIONS(2689),
    [anon_sym_LBRACK] = ACTIONS(2689),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2691),
    [anon_sym_LBRACE] = ACTIONS(2689),
    [anon_sym_LT_AT] = ACTIONS(2689),
    [anon_sym_LT_AT_AT] = ACTIONS(2689),
    [anon_sym_DOT] = ACTIONS(2689),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2691),
    [anon_sym_new] = ACTIONS(2689),
    [anon_sym_return_BANG] = ACTIONS(2691),
    [anon_sym_yield] = ACTIONS(2689),
    [anon_sym_yield_BANG] = ACTIONS(2691),
    [anon_sym_lazy] = ACTIONS(2689),
    [anon_sym_assert] = ACTIONS(2689),
    [anon_sym_upcast] = ACTIONS(2689),
    [anon_sym_downcast] = ACTIONS(2689),
    [anon_sym_COLON_GT] = ACTIONS(2691),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2691),
    [anon_sym_for] = ACTIONS(2689),
    [anon_sym_while] = ACTIONS(2689),
    [anon_sym_if] = ACTIONS(2689),
    [anon_sym_fun] = ACTIONS(2689),
    [anon_sym_try] = ACTIONS(2689),
    [anon_sym_match] = ACTIONS(2689),
    [anon_sym_match_BANG] = ACTIONS(2691),
    [anon_sym_function] = ACTIONS(2689),
    [anon_sym_LT_DASH] = ACTIONS(2689),
    [anon_sym_DOT_LBRACK] = ACTIONS(2691),
    [anon_sym_LT] = ACTIONS(2691),
    [anon_sym_use] = ACTIONS(2689),
    [anon_sym_use_BANG] = ACTIONS(2691),
    [anon_sym_do_BANG] = ACTIONS(2691),
    [anon_sym_begin] = ACTIONS(2689),
    [anon_sym_LPAREN2] = ACTIONS(2689),
    [anon_sym_or] = ACTIONS(2689),
    [aux_sym_char_token1] = ACTIONS(2691),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2689),
    [anon_sym_DQUOTE] = ACTIONS(2689),
    [anon_sym_AT_DQUOTE] = ACTIONS(2691),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2691),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2691),
    [sym_bool] = ACTIONS(2689),
    [sym_unit] = ACTIONS(2691),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2689),
    [sym_op_identifier] = ACTIONS(2689),
    [anon_sym_PLUS] = ACTIONS(2689),
    [anon_sym_DASH] = ACTIONS(2689),
    [anon_sym_PLUS_DOT] = ACTIONS(2689),
    [anon_sym_DASH_DOT] = ACTIONS(2689),
    [anon_sym_PERCENT] = ACTIONS(2689),
    [anon_sym_AMP_AMP] = ACTIONS(2689),
    [anon_sym_TILDE] = ACTIONS(2691),
    [aux_sym_prefix_op_token1] = ACTIONS(2689),
    [aux_sym_infix_op_token1] = ACTIONS(2691),
    [aux_sym_infix_op_token2] = ACTIONS(2689),
    [anon_sym_PIPE_PIPE] = ACTIONS(2689),
    [anon_sym_BANG_EQ] = ACTIONS(2689),
    [anon_sym_COLON_EQ] = ACTIONS(2691),
    [anon_sym_DOLLAR] = ACTIONS(2689),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2689),
    [sym_int] = ACTIONS(2689),
    [sym_xint] = ACTIONS(2691),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2691),
    [sym__newline] = ACTIONS(3617),
    [sym__dedent] = ACTIONS(2691),
  },
  [1414] = {
    [sym_block_comment] = STATE(1414),
    [sym_compiler_directive_decl] = STATE(1414),
    [sym_fsi_directive_decl] = STATE(1414),
    [sym_preproc_line] = STATE(1414),
    [sym_identifier] = ACTIONS(2819),
    [anon_sym_EQ] = ACTIONS(2821),
    [anon_sym_COLON] = ACTIONS(2819),
    [anon_sym_return] = ACTIONS(2819),
    [anon_sym_do] = ACTIONS(2819),
    [anon_sym_let] = ACTIONS(2819),
    [anon_sym_let_BANG] = ACTIONS(2821),
    [anon_sym_as] = ACTIONS(2819),
    [anon_sym_LPAREN] = ACTIONS(2819),
    [anon_sym_COMMA] = ACTIONS(2821),
    [anon_sym_null] = ACTIONS(2819),
    [anon_sym_QMARK] = ACTIONS(2819),
    [anon_sym_COLON_QMARK] = ACTIONS(2819),
    [anon_sym_COLON_COLON] = ACTIONS(2821),
    [anon_sym_AMP] = ACTIONS(2819),
    [anon_sym_LBRACK] = ACTIONS(2819),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2821),
    [anon_sym_LBRACE] = ACTIONS(2819),
    [anon_sym_LT_AT] = ACTIONS(2819),
    [anon_sym_LT_AT_AT] = ACTIONS(2819),
    [anon_sym_DOT] = ACTIONS(2819),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2821),
    [anon_sym_new] = ACTIONS(2819),
    [anon_sym_with] = ACTIONS(2819),
    [anon_sym_return_BANG] = ACTIONS(2821),
    [anon_sym_yield] = ACTIONS(2819),
    [anon_sym_yield_BANG] = ACTIONS(2821),
    [anon_sym_lazy] = ACTIONS(2819),
    [anon_sym_assert] = ACTIONS(2819),
    [anon_sym_upcast] = ACTIONS(2819),
    [anon_sym_downcast] = ACTIONS(2819),
    [anon_sym_COLON_GT] = ACTIONS(2821),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2821),
    [anon_sym_for] = ACTIONS(2819),
    [anon_sym_while] = ACTIONS(2819),
    [anon_sym_if] = ACTIONS(2819),
    [anon_sym_fun] = ACTIONS(2819),
    [anon_sym_try] = ACTIONS(2819),
    [anon_sym_match] = ACTIONS(2819),
    [anon_sym_match_BANG] = ACTIONS(2821),
    [anon_sym_function] = ACTIONS(2819),
    [anon_sym_LT_DASH] = ACTIONS(2819),
    [anon_sym_DOT_LBRACK] = ACTIONS(2821),
    [anon_sym_LT] = ACTIONS(2821),
    [anon_sym_use] = ACTIONS(2819),
    [anon_sym_use_BANG] = ACTIONS(2821),
    [anon_sym_do_BANG] = ACTIONS(2821),
    [anon_sym_begin] = ACTIONS(2819),
    [anon_sym_LPAREN2] = ACTIONS(2819),
    [anon_sym_or] = ACTIONS(2819),
    [aux_sym_char_token1] = ACTIONS(2821),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2819),
    [anon_sym_DQUOTE] = ACTIONS(2819),
    [anon_sym_AT_DQUOTE] = ACTIONS(2821),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2821),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2821),
    [sym_bool] = ACTIONS(2819),
    [sym_unit] = ACTIONS(2821),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2819),
    [sym_op_identifier] = ACTIONS(2819),
    [anon_sym_PLUS] = ACTIONS(2819),
    [anon_sym_DASH] = ACTIONS(2819),
    [anon_sym_PLUS_DOT] = ACTIONS(2819),
    [anon_sym_DASH_DOT] = ACTIONS(2819),
    [anon_sym_PERCENT] = ACTIONS(2819),
    [anon_sym_AMP_AMP] = ACTIONS(2819),
    [anon_sym_TILDE] = ACTIONS(2821),
    [aux_sym_prefix_op_token1] = ACTIONS(2819),
    [aux_sym_infix_op_token1] = ACTIONS(2821),
    [aux_sym_infix_op_token2] = ACTIONS(2819),
    [anon_sym_PIPE_PIPE] = ACTIONS(2819),
    [anon_sym_BANG_EQ] = ACTIONS(2819),
    [anon_sym_COLON_EQ] = ACTIONS(2821),
    [anon_sym_DOLLAR] = ACTIONS(2819),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2819),
    [sym_int] = ACTIONS(3620),
    [sym_xint] = ACTIONS(2821),
    [anon_sym_f] = ACTIONS(2819),
    [aux_sym_decimal_token1] = ACTIONS(2819),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2821),
    [sym__newline] = ACTIONS(2821),
  },
  [1415] = {
    [sym_block_comment] = STATE(1415),
    [sym_compiler_directive_decl] = STATE(1415),
    [sym_fsi_directive_decl] = STATE(1415),
    [sym_preproc_line] = STATE(1415),
    [sym_identifier] = ACTIONS(2723),
    [anon_sym_EQ] = ACTIONS(2725),
    [anon_sym_COLON] = ACTIONS(2723),
    [anon_sym_return] = ACTIONS(2723),
    [anon_sym_do] = ACTIONS(2723),
    [anon_sym_let] = ACTIONS(2723),
    [anon_sym_let_BANG] = ACTIONS(2725),
    [anon_sym_as] = ACTIONS(2723),
    [anon_sym_LPAREN] = ACTIONS(2723),
    [anon_sym_COMMA] = ACTIONS(2725),
    [anon_sym_null] = ACTIONS(2723),
    [anon_sym_QMARK] = ACTIONS(2723),
    [anon_sym_COLON_QMARK] = ACTIONS(2723),
    [anon_sym_COLON_COLON] = ACTIONS(2725),
    [anon_sym_AMP] = ACTIONS(2723),
    [anon_sym_LBRACK] = ACTIONS(2723),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2725),
    [anon_sym_LBRACE] = ACTIONS(2723),
    [anon_sym_LT_AT] = ACTIONS(2723),
    [anon_sym_LT_AT_AT] = ACTIONS(2723),
    [anon_sym_DOT] = ACTIONS(2723),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2725),
    [anon_sym_new] = ACTIONS(2723),
    [anon_sym_with] = ACTIONS(2723),
    [anon_sym_return_BANG] = ACTIONS(2725),
    [anon_sym_yield] = ACTIONS(2723),
    [anon_sym_yield_BANG] = ACTIONS(2725),
    [anon_sym_lazy] = ACTIONS(2723),
    [anon_sym_assert] = ACTIONS(2723),
    [anon_sym_upcast] = ACTIONS(2723),
    [anon_sym_downcast] = ACTIONS(2723),
    [anon_sym_COLON_GT] = ACTIONS(2725),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2725),
    [anon_sym_for] = ACTIONS(2723),
    [anon_sym_while] = ACTIONS(2723),
    [anon_sym_if] = ACTIONS(2723),
    [anon_sym_fun] = ACTIONS(2723),
    [anon_sym_try] = ACTIONS(2723),
    [anon_sym_match] = ACTIONS(2723),
    [anon_sym_match_BANG] = ACTIONS(2725),
    [anon_sym_function] = ACTIONS(2723),
    [anon_sym_LT_DASH] = ACTIONS(2723),
    [anon_sym_DOT_LBRACK] = ACTIONS(2725),
    [anon_sym_LT] = ACTIONS(2725),
    [anon_sym_use] = ACTIONS(2723),
    [anon_sym_use_BANG] = ACTIONS(2725),
    [anon_sym_do_BANG] = ACTIONS(2725),
    [anon_sym_begin] = ACTIONS(2723),
    [anon_sym_LPAREN2] = ACTIONS(2723),
    [anon_sym_or] = ACTIONS(2723),
    [aux_sym_char_token1] = ACTIONS(2725),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2723),
    [anon_sym_DQUOTE] = ACTIONS(2723),
    [anon_sym_AT_DQUOTE] = ACTIONS(2725),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2725),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2725),
    [sym_bool] = ACTIONS(2723),
    [sym_unit] = ACTIONS(2725),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2723),
    [sym_op_identifier] = ACTIONS(2723),
    [anon_sym_PLUS] = ACTIONS(2723),
    [anon_sym_DASH] = ACTIONS(2723),
    [anon_sym_PLUS_DOT] = ACTIONS(2723),
    [anon_sym_DASH_DOT] = ACTIONS(2723),
    [anon_sym_PERCENT] = ACTIONS(2723),
    [anon_sym_AMP_AMP] = ACTIONS(2723),
    [anon_sym_TILDE] = ACTIONS(2725),
    [aux_sym_prefix_op_token1] = ACTIONS(2723),
    [aux_sym_infix_op_token1] = ACTIONS(2725),
    [aux_sym_infix_op_token2] = ACTIONS(2723),
    [anon_sym_PIPE_PIPE] = ACTIONS(2723),
    [anon_sym_BANG_EQ] = ACTIONS(2723),
    [anon_sym_COLON_EQ] = ACTIONS(2725),
    [anon_sym_DOLLAR] = ACTIONS(2723),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2723),
    [sym_int] = ACTIONS(2723),
    [sym_xint] = ACTIONS(2725),
    [anon_sym_f] = ACTIONS(2723),
    [aux_sym_decimal_token1] = ACTIONS(2723),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2725),
    [sym__newline] = ACTIONS(2725),
  },
  [1416] = {
    [sym_block_comment] = STATE(1416),
    [sym_compiler_directive_decl] = STATE(1416),
    [sym_fsi_directive_decl] = STATE(1416),
    [sym_preproc_line] = STATE(1416),
    [sym_identifier] = ACTIONS(2685),
    [anon_sym_EQ] = ACTIONS(2687),
    [anon_sym_COLON] = ACTIONS(2685),
    [anon_sym_return] = ACTIONS(2685),
    [anon_sym_do] = ACTIONS(2685),
    [anon_sym_let] = ACTIONS(2685),
    [anon_sym_let_BANG] = ACTIONS(2687),
    [anon_sym_as] = ACTIONS(2685),
    [anon_sym_LPAREN] = ACTIONS(2685),
    [anon_sym_COMMA] = ACTIONS(2687),
    [anon_sym_null] = ACTIONS(2685),
    [anon_sym_QMARK] = ACTIONS(2685),
    [anon_sym_COLON_QMARK] = ACTIONS(2685),
    [anon_sym_COLON_COLON] = ACTIONS(2687),
    [anon_sym_AMP] = ACTIONS(2685),
    [anon_sym_LBRACK] = ACTIONS(2685),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2687),
    [anon_sym_LBRACE] = ACTIONS(2685),
    [anon_sym_LT_AT] = ACTIONS(2685),
    [anon_sym_LT_AT_AT] = ACTIONS(2685),
    [anon_sym_DOT] = ACTIONS(2685),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2687),
    [anon_sym_new] = ACTIONS(2685),
    [anon_sym_with] = ACTIONS(2685),
    [anon_sym_return_BANG] = ACTIONS(2687),
    [anon_sym_yield] = ACTIONS(2685),
    [anon_sym_yield_BANG] = ACTIONS(2687),
    [anon_sym_lazy] = ACTIONS(2685),
    [anon_sym_assert] = ACTIONS(2685),
    [anon_sym_upcast] = ACTIONS(2685),
    [anon_sym_downcast] = ACTIONS(2685),
    [anon_sym_COLON_GT] = ACTIONS(2687),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2687),
    [anon_sym_for] = ACTIONS(2685),
    [anon_sym_done] = ACTIONS(2685),
    [anon_sym_while] = ACTIONS(2685),
    [anon_sym_if] = ACTIONS(2685),
    [anon_sym_fun] = ACTIONS(2685),
    [anon_sym_try] = ACTIONS(2685),
    [anon_sym_match] = ACTIONS(2685),
    [anon_sym_match_BANG] = ACTIONS(2687),
    [anon_sym_function] = ACTIONS(2685),
    [anon_sym_LT_DASH] = ACTIONS(2685),
    [anon_sym_DOT_LBRACK] = ACTIONS(2687),
    [anon_sym_LT] = ACTIONS(2687),
    [anon_sym_use] = ACTIONS(2685),
    [anon_sym_use_BANG] = ACTIONS(2687),
    [anon_sym_do_BANG] = ACTIONS(2687),
    [anon_sym_DOT_DOT] = ACTIONS(2687),
    [anon_sym_begin] = ACTIONS(2685),
    [anon_sym_LPAREN2] = ACTIONS(2685),
    [anon_sym_or] = ACTIONS(2685),
    [aux_sym_char_token1] = ACTIONS(2687),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2685),
    [anon_sym_DQUOTE] = ACTIONS(2685),
    [anon_sym_AT_DQUOTE] = ACTIONS(2687),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2687),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2687),
    [sym_bool] = ACTIONS(2685),
    [sym_unit] = ACTIONS(2687),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2685),
    [sym_op_identifier] = ACTIONS(2685),
    [anon_sym_PLUS] = ACTIONS(2685),
    [anon_sym_DASH] = ACTIONS(2685),
    [anon_sym_PLUS_DOT] = ACTIONS(2685),
    [anon_sym_DASH_DOT] = ACTIONS(2685),
    [anon_sym_PERCENT] = ACTIONS(2685),
    [anon_sym_AMP_AMP] = ACTIONS(2685),
    [anon_sym_TILDE] = ACTIONS(2687),
    [aux_sym_prefix_op_token1] = ACTIONS(2685),
    [aux_sym_infix_op_token1] = ACTIONS(2687),
    [aux_sym_infix_op_token2] = ACTIONS(2685),
    [anon_sym_PIPE_PIPE] = ACTIONS(2685),
    [anon_sym_BANG_EQ] = ACTIONS(2685),
    [anon_sym_COLON_EQ] = ACTIONS(2687),
    [anon_sym_DOLLAR] = ACTIONS(2685),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2685),
    [sym_int] = ACTIONS(2685),
    [sym_xint] = ACTIONS(2687),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2687),
    [sym__newline] = ACTIONS(2687),
  },
  [1417] = {
    [sym_block_comment] = STATE(1417),
    [sym_compiler_directive_decl] = STATE(1417),
    [sym_fsi_directive_decl] = STATE(1417),
    [sym_preproc_line] = STATE(1417),
    [sym_identifier] = ACTIONS(2812),
    [anon_sym_EQ] = ACTIONS(2814),
    [anon_sym_COLON] = ACTIONS(2812),
    [anon_sym_return] = ACTIONS(2812),
    [anon_sym_do] = ACTIONS(2812),
    [anon_sym_let] = ACTIONS(2812),
    [anon_sym_let_BANG] = ACTIONS(2814),
    [anon_sym_as] = ACTIONS(2812),
    [anon_sym_LPAREN] = ACTIONS(2812),
    [anon_sym_COMMA] = ACTIONS(2814),
    [anon_sym_null] = ACTIONS(2812),
    [anon_sym_QMARK] = ACTIONS(2812),
    [anon_sym_COLON_QMARK] = ACTIONS(2812),
    [anon_sym_COLON_COLON] = ACTIONS(2814),
    [anon_sym_AMP] = ACTIONS(2812),
    [anon_sym_LBRACK] = ACTIONS(2812),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2814),
    [anon_sym_LBRACE] = ACTIONS(2812),
    [anon_sym_LT_AT] = ACTIONS(2812),
    [anon_sym_LT_AT_AT] = ACTIONS(2812),
    [anon_sym_DOT] = ACTIONS(2812),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2814),
    [anon_sym_new] = ACTIONS(2812),
    [anon_sym_with] = ACTIONS(2812),
    [anon_sym_return_BANG] = ACTIONS(2814),
    [anon_sym_yield] = ACTIONS(2812),
    [anon_sym_yield_BANG] = ACTIONS(2814),
    [anon_sym_lazy] = ACTIONS(2812),
    [anon_sym_assert] = ACTIONS(2812),
    [anon_sym_upcast] = ACTIONS(2812),
    [anon_sym_downcast] = ACTIONS(2812),
    [anon_sym_COLON_GT] = ACTIONS(2814),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2814),
    [anon_sym_for] = ACTIONS(2812),
    [anon_sym_while] = ACTIONS(2812),
    [anon_sym_if] = ACTIONS(2812),
    [anon_sym_fun] = ACTIONS(2812),
    [anon_sym_try] = ACTIONS(2812),
    [anon_sym_match] = ACTIONS(2812),
    [anon_sym_match_BANG] = ACTIONS(2814),
    [anon_sym_function] = ACTIONS(2812),
    [anon_sym_LT_DASH] = ACTIONS(2812),
    [anon_sym_DOT_LBRACK] = ACTIONS(2814),
    [anon_sym_LT] = ACTIONS(2814),
    [anon_sym_use] = ACTIONS(2812),
    [anon_sym_use_BANG] = ACTIONS(2814),
    [anon_sym_do_BANG] = ACTIONS(2814),
    [anon_sym_begin] = ACTIONS(2812),
    [anon_sym_LPAREN2] = ACTIONS(2812),
    [anon_sym_or] = ACTIONS(2812),
    [aux_sym_char_token1] = ACTIONS(2814),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2812),
    [anon_sym_DQUOTE] = ACTIONS(2812),
    [anon_sym_AT_DQUOTE] = ACTIONS(2814),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2814),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2814),
    [sym_bool] = ACTIONS(2812),
    [sym_unit] = ACTIONS(2814),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2812),
    [sym_op_identifier] = ACTIONS(2812),
    [anon_sym_PLUS] = ACTIONS(2812),
    [anon_sym_DASH] = ACTIONS(2812),
    [anon_sym_PLUS_DOT] = ACTIONS(2812),
    [anon_sym_DASH_DOT] = ACTIONS(2812),
    [anon_sym_PERCENT] = ACTIONS(2812),
    [anon_sym_AMP_AMP] = ACTIONS(2812),
    [anon_sym_TILDE] = ACTIONS(2814),
    [aux_sym_prefix_op_token1] = ACTIONS(2812),
    [aux_sym_infix_op_token1] = ACTIONS(2814),
    [aux_sym_infix_op_token2] = ACTIONS(2812),
    [anon_sym_PIPE_PIPE] = ACTIONS(2812),
    [anon_sym_BANG_EQ] = ACTIONS(2812),
    [anon_sym_COLON_EQ] = ACTIONS(2814),
    [anon_sym_DOLLAR] = ACTIONS(2812),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2812),
    [sym_int] = ACTIONS(2812),
    [sym_xint] = ACTIONS(2814),
    [anon_sym_f] = ACTIONS(2812),
    [aux_sym_decimal_token1] = ACTIONS(2812),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2814),
    [sym__newline] = ACTIONS(2814),
  },
  [1418] = {
    [sym_block_comment] = STATE(1418),
    [sym_compiler_directive_decl] = STATE(1418),
    [sym_fsi_directive_decl] = STATE(1418),
    [sym_preproc_line] = STATE(1418),
    [sym_identifier] = ACTIONS(2729),
    [anon_sym_EQ] = ACTIONS(2731),
    [anon_sym_COLON] = ACTIONS(2729),
    [anon_sym_return] = ACTIONS(2729),
    [anon_sym_do] = ACTIONS(2729),
    [anon_sym_and] = ACTIONS(2729),
    [anon_sym_let] = ACTIONS(2729),
    [anon_sym_let_BANG] = ACTIONS(2731),
    [anon_sym_LPAREN] = ACTIONS(2729),
    [anon_sym_COMMA] = ACTIONS(2731),
    [anon_sym_null] = ACTIONS(2729),
    [anon_sym_QMARK] = ACTIONS(2729),
    [anon_sym_COLON_QMARK] = ACTIONS(2729),
    [anon_sym_COLON_COLON] = ACTIONS(2731),
    [anon_sym_AMP] = ACTIONS(2729),
    [anon_sym_LBRACK] = ACTIONS(2729),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2731),
    [anon_sym_LBRACE] = ACTIONS(2729),
    [anon_sym_LT_AT] = ACTIONS(2729),
    [anon_sym_LT_AT_AT] = ACTIONS(2729),
    [anon_sym_DOT] = ACTIONS(2729),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2731),
    [anon_sym_new] = ACTIONS(2729),
    [anon_sym_return_BANG] = ACTIONS(2731),
    [anon_sym_yield] = ACTIONS(2729),
    [anon_sym_yield_BANG] = ACTIONS(2731),
    [anon_sym_lazy] = ACTIONS(2729),
    [anon_sym_assert] = ACTIONS(2729),
    [anon_sym_upcast] = ACTIONS(2729),
    [anon_sym_downcast] = ACTIONS(2729),
    [anon_sym_COLON_GT] = ACTIONS(2731),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2731),
    [anon_sym_for] = ACTIONS(2729),
    [anon_sym_while] = ACTIONS(2729),
    [anon_sym_else] = ACTIONS(2729),
    [anon_sym_elif] = ACTIONS(2729),
    [anon_sym_if] = ACTIONS(2729),
    [anon_sym_fun] = ACTIONS(2729),
    [anon_sym_try] = ACTIONS(2729),
    [anon_sym_match] = ACTIONS(2729),
    [anon_sym_match_BANG] = ACTIONS(2731),
    [anon_sym_function] = ACTIONS(2729),
    [anon_sym_LT_DASH] = ACTIONS(2729),
    [anon_sym_DOT_LBRACK] = ACTIONS(2731),
    [anon_sym_LT] = ACTIONS(2731),
    [anon_sym_use] = ACTIONS(2729),
    [anon_sym_use_BANG] = ACTIONS(2731),
    [anon_sym_do_BANG] = ACTIONS(2731),
    [anon_sym_begin] = ACTIONS(2729),
    [anon_sym_LPAREN2] = ACTIONS(2729),
    [anon_sym_or] = ACTIONS(2729),
    [aux_sym_char_token1] = ACTIONS(2731),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2729),
    [anon_sym_DQUOTE] = ACTIONS(2729),
    [anon_sym_AT_DQUOTE] = ACTIONS(2731),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2731),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2731),
    [sym_bool] = ACTIONS(2729),
    [sym_unit] = ACTIONS(2731),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2729),
    [sym_op_identifier] = ACTIONS(2729),
    [anon_sym_PLUS] = ACTIONS(2729),
    [anon_sym_DASH] = ACTIONS(2729),
    [anon_sym_PLUS_DOT] = ACTIONS(2729),
    [anon_sym_DASH_DOT] = ACTIONS(2729),
    [anon_sym_PERCENT] = ACTIONS(2729),
    [anon_sym_AMP_AMP] = ACTIONS(2729),
    [anon_sym_TILDE] = ACTIONS(2731),
    [aux_sym_prefix_op_token1] = ACTIONS(2729),
    [aux_sym_infix_op_token1] = ACTIONS(2731),
    [aux_sym_infix_op_token2] = ACTIONS(2729),
    [anon_sym_PIPE_PIPE] = ACTIONS(2729),
    [anon_sym_BANG_EQ] = ACTIONS(2729),
    [anon_sym_COLON_EQ] = ACTIONS(2731),
    [anon_sym_DOLLAR] = ACTIONS(2729),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2729),
    [sym_int] = ACTIONS(2729),
    [sym_xint] = ACTIONS(2731),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2731),
    [sym__newline] = ACTIONS(2731),
    [sym__dedent] = ACTIONS(2731),
  },
  [1419] = {
    [sym_block_comment] = STATE(1419),
    [sym_compiler_directive_decl] = STATE(1419),
    [sym_fsi_directive_decl] = STATE(1419),
    [sym_preproc_line] = STATE(1419),
    [aux_sym_rules_repeat1] = STATE(1411),
    [sym_identifier] = ACTIONS(2689),
    [anon_sym_EQ] = ACTIONS(2691),
    [anon_sym_COLON] = ACTIONS(2689),
    [anon_sym_return] = ACTIONS(2689),
    [anon_sym_do] = ACTIONS(2689),
    [anon_sym_let] = ACTIONS(2689),
    [anon_sym_let_BANG] = ACTIONS(2691),
    [anon_sym_as] = ACTIONS(2689),
    [anon_sym_LPAREN] = ACTIONS(2689),
    [anon_sym_COMMA] = ACTIONS(2691),
    [anon_sym_null] = ACTIONS(2689),
    [anon_sym_QMARK] = ACTIONS(2689),
    [anon_sym_COLON_QMARK] = ACTIONS(2689),
    [anon_sym_COLON_COLON] = ACTIONS(2691),
    [anon_sym_PIPE] = ACTIONS(3557),
    [anon_sym_AMP] = ACTIONS(2689),
    [anon_sym_LBRACK] = ACTIONS(2689),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2691),
    [anon_sym_LBRACE] = ACTIONS(2689),
    [anon_sym_LT_AT] = ACTIONS(2689),
    [anon_sym_LT_AT_AT] = ACTIONS(2689),
    [anon_sym_DOT] = ACTIONS(2689),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2691),
    [anon_sym_new] = ACTIONS(2689),
    [anon_sym_with] = ACTIONS(2689),
    [anon_sym_return_BANG] = ACTIONS(2691),
    [anon_sym_yield] = ACTIONS(2689),
    [anon_sym_yield_BANG] = ACTIONS(2691),
    [anon_sym_lazy] = ACTIONS(2689),
    [anon_sym_assert] = ACTIONS(2689),
    [anon_sym_upcast] = ACTIONS(2689),
    [anon_sym_downcast] = ACTIONS(2689),
    [anon_sym_COLON_GT] = ACTIONS(2691),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2691),
    [anon_sym_for] = ACTIONS(2689),
    [anon_sym_while] = ACTIONS(2689),
    [anon_sym_if] = ACTIONS(2689),
    [anon_sym_fun] = ACTIONS(2689),
    [anon_sym_try] = ACTIONS(2689),
    [anon_sym_match] = ACTIONS(2689),
    [anon_sym_match_BANG] = ACTIONS(2691),
    [anon_sym_function] = ACTIONS(2689),
    [anon_sym_LT_DASH] = ACTIONS(2689),
    [anon_sym_DOT_LBRACK] = ACTIONS(2691),
    [anon_sym_LT] = ACTIONS(2691),
    [anon_sym_use] = ACTIONS(2689),
    [anon_sym_use_BANG] = ACTIONS(2691),
    [anon_sym_do_BANG] = ACTIONS(2691),
    [anon_sym_begin] = ACTIONS(2689),
    [anon_sym_LPAREN2] = ACTIONS(2689),
    [anon_sym_or] = ACTIONS(2689),
    [aux_sym_char_token1] = ACTIONS(2691),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2689),
    [anon_sym_DQUOTE] = ACTIONS(2689),
    [anon_sym_AT_DQUOTE] = ACTIONS(2691),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2691),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2691),
    [sym_bool] = ACTIONS(2689),
    [sym_unit] = ACTIONS(2691),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2689),
    [sym_op_identifier] = ACTIONS(2689),
    [anon_sym_PLUS] = ACTIONS(2689),
    [anon_sym_DASH] = ACTIONS(2689),
    [anon_sym_PLUS_DOT] = ACTIONS(2689),
    [anon_sym_DASH_DOT] = ACTIONS(2689),
    [anon_sym_PERCENT] = ACTIONS(2689),
    [anon_sym_AMP_AMP] = ACTIONS(2689),
    [anon_sym_TILDE] = ACTIONS(2691),
    [aux_sym_prefix_op_token1] = ACTIONS(2689),
    [aux_sym_infix_op_token1] = ACTIONS(2691),
    [aux_sym_infix_op_token2] = ACTIONS(2689),
    [anon_sym_PIPE_PIPE] = ACTIONS(2689),
    [anon_sym_BANG_EQ] = ACTIONS(2689),
    [anon_sym_COLON_EQ] = ACTIONS(2691),
    [anon_sym_DOLLAR] = ACTIONS(2689),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2689),
    [sym_int] = ACTIONS(2689),
    [sym_xint] = ACTIONS(2691),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2691),
    [sym__newline] = ACTIONS(3622),
  },
  [1420] = {
    [sym_block_comment] = STATE(1420),
    [sym_compiler_directive_decl] = STATE(1420),
    [sym_fsi_directive_decl] = STATE(1420),
    [sym_preproc_line] = STATE(1420),
    [sym_identifier] = ACTIONS(2760),
    [anon_sym_EQ] = ACTIONS(2762),
    [anon_sym_COLON] = ACTIONS(2760),
    [anon_sym_return] = ACTIONS(2760),
    [anon_sym_do] = ACTIONS(2760),
    [anon_sym_let] = ACTIONS(2760),
    [anon_sym_let_BANG] = ACTIONS(2762),
    [anon_sym_as] = ACTIONS(2760),
    [anon_sym_LPAREN] = ACTIONS(2760),
    [anon_sym_COMMA] = ACTIONS(2762),
    [anon_sym_null] = ACTIONS(2760),
    [anon_sym_QMARK] = ACTIONS(2760),
    [anon_sym_COLON_QMARK] = ACTIONS(2760),
    [anon_sym_COLON_COLON] = ACTIONS(2762),
    [anon_sym_PIPE] = ACTIONS(2760),
    [anon_sym_AMP] = ACTIONS(2760),
    [anon_sym_LBRACK] = ACTIONS(2760),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2762),
    [anon_sym_LBRACE] = ACTIONS(2760),
    [anon_sym_LT_AT] = ACTIONS(2760),
    [anon_sym_LT_AT_AT] = ACTIONS(2760),
    [anon_sym_DOT] = ACTIONS(2760),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2762),
    [anon_sym_new] = ACTIONS(2760),
    [anon_sym_with] = ACTIONS(2760),
    [anon_sym_return_BANG] = ACTIONS(2762),
    [anon_sym_yield] = ACTIONS(2760),
    [anon_sym_yield_BANG] = ACTIONS(2762),
    [anon_sym_lazy] = ACTIONS(2760),
    [anon_sym_assert] = ACTIONS(2760),
    [anon_sym_upcast] = ACTIONS(2760),
    [anon_sym_downcast] = ACTIONS(2760),
    [anon_sym_COLON_GT] = ACTIONS(2762),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2762),
    [anon_sym_for] = ACTIONS(2760),
    [anon_sym_while] = ACTIONS(2760),
    [anon_sym_if] = ACTIONS(2760),
    [anon_sym_fun] = ACTIONS(2760),
    [anon_sym_try] = ACTIONS(2760),
    [anon_sym_match] = ACTIONS(2760),
    [anon_sym_match_BANG] = ACTIONS(2762),
    [anon_sym_function] = ACTIONS(2760),
    [anon_sym_LT_DASH] = ACTIONS(2760),
    [anon_sym_DOT_LBRACK] = ACTIONS(2762),
    [anon_sym_LT] = ACTIONS(2762),
    [anon_sym_use] = ACTIONS(2760),
    [anon_sym_use_BANG] = ACTIONS(2762),
    [anon_sym_do_BANG] = ACTIONS(2762),
    [anon_sym_begin] = ACTIONS(2760),
    [anon_sym_LPAREN2] = ACTIONS(2760),
    [anon_sym_or] = ACTIONS(2760),
    [aux_sym_char_token1] = ACTIONS(2762),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2760),
    [anon_sym_DQUOTE] = ACTIONS(2760),
    [anon_sym_AT_DQUOTE] = ACTIONS(2762),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2762),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2762),
    [sym_bool] = ACTIONS(2760),
    [sym_unit] = ACTIONS(2762),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2760),
    [sym_op_identifier] = ACTIONS(2760),
    [anon_sym_PLUS] = ACTIONS(2760),
    [anon_sym_DASH] = ACTIONS(2760),
    [anon_sym_PLUS_DOT] = ACTIONS(2760),
    [anon_sym_DASH_DOT] = ACTIONS(2760),
    [anon_sym_PERCENT] = ACTIONS(2760),
    [anon_sym_AMP_AMP] = ACTIONS(2760),
    [anon_sym_TILDE] = ACTIONS(2762),
    [aux_sym_prefix_op_token1] = ACTIONS(2760),
    [aux_sym_infix_op_token1] = ACTIONS(2762),
    [aux_sym_infix_op_token2] = ACTIONS(2760),
    [anon_sym_PIPE_PIPE] = ACTIONS(2760),
    [anon_sym_BANG_EQ] = ACTIONS(2760),
    [anon_sym_COLON_EQ] = ACTIONS(2762),
    [anon_sym_DOLLAR] = ACTIONS(2760),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2760),
    [sym_int] = ACTIONS(2760),
    [sym_xint] = ACTIONS(2762),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2762),
    [sym__newline] = ACTIONS(2762),
    [sym__dedent] = ACTIONS(2762),
  },
  [1421] = {
    [sym_block_comment] = STATE(1421),
    [sym_compiler_directive_decl] = STATE(1421),
    [sym_fsi_directive_decl] = STATE(1421),
    [sym_preproc_line] = STATE(1421),
    [sym_identifier] = ACTIONS(2756),
    [anon_sym_EQ] = ACTIONS(2758),
    [anon_sym_COLON] = ACTIONS(2756),
    [anon_sym_return] = ACTIONS(2756),
    [anon_sym_do] = ACTIONS(2756),
    [anon_sym_let] = ACTIONS(2756),
    [anon_sym_let_BANG] = ACTIONS(2758),
    [anon_sym_as] = ACTIONS(2756),
    [anon_sym_LPAREN] = ACTIONS(2756),
    [anon_sym_COMMA] = ACTIONS(2758),
    [anon_sym_null] = ACTIONS(2756),
    [anon_sym_QMARK] = ACTIONS(2756),
    [anon_sym_COLON_QMARK] = ACTIONS(2756),
    [anon_sym_COLON_COLON] = ACTIONS(2758),
    [anon_sym_PIPE] = ACTIONS(2756),
    [anon_sym_AMP] = ACTIONS(2756),
    [anon_sym_LBRACK] = ACTIONS(2756),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2758),
    [anon_sym_LBRACE] = ACTIONS(2756),
    [anon_sym_LT_AT] = ACTIONS(2756),
    [anon_sym_LT_AT_AT] = ACTIONS(2756),
    [anon_sym_DOT] = ACTIONS(2756),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2758),
    [anon_sym_new] = ACTIONS(2756),
    [anon_sym_with] = ACTIONS(2756),
    [anon_sym_return_BANG] = ACTIONS(2758),
    [anon_sym_yield] = ACTIONS(2756),
    [anon_sym_yield_BANG] = ACTIONS(2758),
    [anon_sym_lazy] = ACTIONS(2756),
    [anon_sym_assert] = ACTIONS(2756),
    [anon_sym_upcast] = ACTIONS(2756),
    [anon_sym_downcast] = ACTIONS(2756),
    [anon_sym_COLON_GT] = ACTIONS(2758),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2758),
    [anon_sym_for] = ACTIONS(2756),
    [anon_sym_while] = ACTIONS(2756),
    [anon_sym_if] = ACTIONS(2756),
    [anon_sym_fun] = ACTIONS(2756),
    [anon_sym_try] = ACTIONS(2756),
    [anon_sym_match] = ACTIONS(2756),
    [anon_sym_match_BANG] = ACTIONS(2758),
    [anon_sym_function] = ACTIONS(2756),
    [anon_sym_LT_DASH] = ACTIONS(2756),
    [anon_sym_DOT_LBRACK] = ACTIONS(2758),
    [anon_sym_LT] = ACTIONS(2758),
    [anon_sym_use] = ACTIONS(2756),
    [anon_sym_use_BANG] = ACTIONS(2758),
    [anon_sym_do_BANG] = ACTIONS(2758),
    [anon_sym_begin] = ACTIONS(2756),
    [anon_sym_LPAREN2] = ACTIONS(2756),
    [anon_sym_or] = ACTIONS(2756),
    [aux_sym_char_token1] = ACTIONS(2758),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2756),
    [anon_sym_DQUOTE] = ACTIONS(2756),
    [anon_sym_AT_DQUOTE] = ACTIONS(2758),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2758),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2758),
    [sym_bool] = ACTIONS(2756),
    [sym_unit] = ACTIONS(2758),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2756),
    [sym_op_identifier] = ACTIONS(2756),
    [anon_sym_PLUS] = ACTIONS(2756),
    [anon_sym_DASH] = ACTIONS(2756),
    [anon_sym_PLUS_DOT] = ACTIONS(2756),
    [anon_sym_DASH_DOT] = ACTIONS(2756),
    [anon_sym_PERCENT] = ACTIONS(2756),
    [anon_sym_AMP_AMP] = ACTIONS(2756),
    [anon_sym_TILDE] = ACTIONS(2758),
    [aux_sym_prefix_op_token1] = ACTIONS(2756),
    [aux_sym_infix_op_token1] = ACTIONS(2758),
    [aux_sym_infix_op_token2] = ACTIONS(2756),
    [anon_sym_PIPE_PIPE] = ACTIONS(2756),
    [anon_sym_BANG_EQ] = ACTIONS(2756),
    [anon_sym_COLON_EQ] = ACTIONS(2758),
    [anon_sym_DOLLAR] = ACTIONS(2756),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2756),
    [sym_int] = ACTIONS(2756),
    [sym_xint] = ACTIONS(2758),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2758),
    [sym__newline] = ACTIONS(2758),
    [sym__dedent] = ACTIONS(2758),
  },
  [1422] = {
    [sym_block_comment] = STATE(1422),
    [sym_compiler_directive_decl] = STATE(1422),
    [sym_fsi_directive_decl] = STATE(1422),
    [sym_preproc_line] = STATE(1422),
    [sym_identifier] = ACTIONS(2783),
    [anon_sym_EQ] = ACTIONS(2785),
    [anon_sym_COLON] = ACTIONS(2783),
    [anon_sym_return] = ACTIONS(2783),
    [anon_sym_do] = ACTIONS(2783),
    [anon_sym_let] = ACTIONS(2783),
    [anon_sym_let_BANG] = ACTIONS(2785),
    [anon_sym_LPAREN] = ACTIONS(2783),
    [anon_sym_COMMA] = ACTIONS(2785),
    [anon_sym_null] = ACTIONS(2783),
    [anon_sym_QMARK] = ACTIONS(2783),
    [anon_sym_COLON_QMARK] = ACTIONS(2783),
    [anon_sym_COLON_COLON] = ACTIONS(2785),
    [anon_sym_AMP] = ACTIONS(2783),
    [anon_sym_LBRACK] = ACTIONS(2783),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2785),
    [anon_sym_LBRACE] = ACTIONS(2783),
    [anon_sym_LT_AT] = ACTIONS(2783),
    [anon_sym_LT_AT_AT] = ACTIONS(2783),
    [anon_sym_DOT] = ACTIONS(2783),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2785),
    [anon_sym_new] = ACTIONS(2783),
    [anon_sym_return_BANG] = ACTIONS(2785),
    [anon_sym_yield] = ACTIONS(2783),
    [anon_sym_yield_BANG] = ACTIONS(2785),
    [anon_sym_lazy] = ACTIONS(2783),
    [anon_sym_assert] = ACTIONS(2783),
    [anon_sym_upcast] = ACTIONS(2783),
    [anon_sym_downcast] = ACTIONS(2783),
    [anon_sym_COLON_GT] = ACTIONS(2785),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2785),
    [anon_sym_for] = ACTIONS(2783),
    [anon_sym_done] = ACTIONS(3625),
    [anon_sym_while] = ACTIONS(2783),
    [anon_sym_if] = ACTIONS(2783),
    [anon_sym_fun] = ACTIONS(2783),
    [anon_sym_try] = ACTIONS(2783),
    [anon_sym_match] = ACTIONS(2783),
    [anon_sym_match_BANG] = ACTIONS(2785),
    [anon_sym_function] = ACTIONS(2783),
    [anon_sym_LT_DASH] = ACTIONS(2783),
    [anon_sym_DOT_LBRACK] = ACTIONS(2785),
    [anon_sym_LT] = ACTIONS(2785),
    [anon_sym_use] = ACTIONS(2783),
    [anon_sym_use_BANG] = ACTIONS(2785),
    [anon_sym_do_BANG] = ACTIONS(2785),
    [anon_sym_DOT_DOT] = ACTIONS(2789),
    [anon_sym_begin] = ACTIONS(2783),
    [anon_sym_LPAREN2] = ACTIONS(2783),
    [anon_sym_or] = ACTIONS(2783),
    [aux_sym_char_token1] = ACTIONS(2785),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2783),
    [anon_sym_DQUOTE] = ACTIONS(2783),
    [anon_sym_AT_DQUOTE] = ACTIONS(2785),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2785),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2785),
    [sym_bool] = ACTIONS(2783),
    [sym_unit] = ACTIONS(2785),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2783),
    [sym_op_identifier] = ACTIONS(2783),
    [anon_sym_PLUS] = ACTIONS(2783),
    [anon_sym_DASH] = ACTIONS(2783),
    [anon_sym_PLUS_DOT] = ACTIONS(2783),
    [anon_sym_DASH_DOT] = ACTIONS(2783),
    [anon_sym_PERCENT] = ACTIONS(2783),
    [anon_sym_AMP_AMP] = ACTIONS(2783),
    [anon_sym_TILDE] = ACTIONS(2785),
    [aux_sym_prefix_op_token1] = ACTIONS(2783),
    [aux_sym_infix_op_token1] = ACTIONS(2785),
    [aux_sym_infix_op_token2] = ACTIONS(2783),
    [anon_sym_PIPE_PIPE] = ACTIONS(2783),
    [anon_sym_BANG_EQ] = ACTIONS(2783),
    [anon_sym_COLON_EQ] = ACTIONS(2785),
    [anon_sym_DOLLAR] = ACTIONS(2783),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2783),
    [sym_int] = ACTIONS(2783),
    [sym_xint] = ACTIONS(2785),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2785),
    [anon_sym_POUNDendif] = ACTIONS(2785),
    [anon_sym_POUNDelse] = ACTIONS(2785),
    [sym__newline] = ACTIONS(2785),
  },
  [1423] = {
    [sym_block_comment] = STATE(1423),
    [sym_compiler_directive_decl] = STATE(1423),
    [sym_fsi_directive_decl] = STATE(1423),
    [sym_preproc_line] = STATE(1423),
    [sym_identifier] = ACTIONS(2713),
    [anon_sym_EQ] = ACTIONS(2715),
    [anon_sym_COLON] = ACTIONS(2713),
    [anon_sym_return] = ACTIONS(2713),
    [anon_sym_do] = ACTIONS(2713),
    [anon_sym_let] = ACTIONS(2713),
    [anon_sym_let_BANG] = ACTIONS(2715),
    [anon_sym_as] = ACTIONS(2713),
    [anon_sym_LPAREN] = ACTIONS(2713),
    [anon_sym_COMMA] = ACTIONS(2715),
    [anon_sym_null] = ACTIONS(2713),
    [anon_sym_QMARK] = ACTIONS(2713),
    [anon_sym_COLON_QMARK] = ACTIONS(2713),
    [anon_sym_COLON_COLON] = ACTIONS(2715),
    [anon_sym_PIPE] = ACTIONS(2713),
    [anon_sym_AMP] = ACTIONS(2713),
    [anon_sym_LBRACK] = ACTIONS(2713),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2715),
    [anon_sym_LBRACE] = ACTIONS(2713),
    [anon_sym_LT_AT] = ACTIONS(2713),
    [anon_sym_LT_AT_AT] = ACTIONS(2713),
    [anon_sym_DOT] = ACTIONS(2713),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2715),
    [anon_sym_new] = ACTIONS(2713),
    [anon_sym_with] = ACTIONS(2713),
    [anon_sym_return_BANG] = ACTIONS(2715),
    [anon_sym_yield] = ACTIONS(2713),
    [anon_sym_yield_BANG] = ACTIONS(2715),
    [anon_sym_lazy] = ACTIONS(2713),
    [anon_sym_assert] = ACTIONS(2713),
    [anon_sym_upcast] = ACTIONS(2713),
    [anon_sym_downcast] = ACTIONS(2713),
    [anon_sym_COLON_GT] = ACTIONS(2715),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2715),
    [anon_sym_for] = ACTIONS(2713),
    [anon_sym_while] = ACTIONS(2713),
    [anon_sym_if] = ACTIONS(2713),
    [anon_sym_fun] = ACTIONS(2713),
    [anon_sym_try] = ACTIONS(2713),
    [anon_sym_match] = ACTIONS(2713),
    [anon_sym_match_BANG] = ACTIONS(2715),
    [anon_sym_function] = ACTIONS(2713),
    [anon_sym_LT_DASH] = ACTIONS(2713),
    [anon_sym_DOT_LBRACK] = ACTIONS(2715),
    [anon_sym_LT] = ACTIONS(2715),
    [anon_sym_use] = ACTIONS(2713),
    [anon_sym_use_BANG] = ACTIONS(2715),
    [anon_sym_do_BANG] = ACTIONS(2715),
    [anon_sym_begin] = ACTIONS(2713),
    [anon_sym_LPAREN2] = ACTIONS(2713),
    [anon_sym_or] = ACTIONS(2713),
    [aux_sym_char_token1] = ACTIONS(2715),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2713),
    [anon_sym_DQUOTE] = ACTIONS(2713),
    [anon_sym_AT_DQUOTE] = ACTIONS(2715),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2715),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2715),
    [sym_bool] = ACTIONS(2713),
    [sym_unit] = ACTIONS(2715),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2713),
    [sym_op_identifier] = ACTIONS(2713),
    [anon_sym_PLUS] = ACTIONS(2713),
    [anon_sym_DASH] = ACTIONS(2713),
    [anon_sym_PLUS_DOT] = ACTIONS(2713),
    [anon_sym_DASH_DOT] = ACTIONS(2713),
    [anon_sym_PERCENT] = ACTIONS(2713),
    [anon_sym_AMP_AMP] = ACTIONS(2713),
    [anon_sym_TILDE] = ACTIONS(2715),
    [aux_sym_prefix_op_token1] = ACTIONS(2713),
    [aux_sym_infix_op_token1] = ACTIONS(2715),
    [aux_sym_infix_op_token2] = ACTIONS(2713),
    [anon_sym_PIPE_PIPE] = ACTIONS(2713),
    [anon_sym_BANG_EQ] = ACTIONS(2713),
    [anon_sym_COLON_EQ] = ACTIONS(2715),
    [anon_sym_DOLLAR] = ACTIONS(2713),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2713),
    [sym_int] = ACTIONS(2713),
    [sym_xint] = ACTIONS(2715),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2715),
    [sym__newline] = ACTIONS(2715),
    [sym__dedent] = ACTIONS(2715),
  },
  [1424] = {
    [sym_block_comment] = STATE(1424),
    [sym_compiler_directive_decl] = STATE(1424),
    [sym_fsi_directive_decl] = STATE(1424),
    [sym_preproc_line] = STATE(1424),
    [sym_identifier] = ACTIONS(2766),
    [anon_sym_EQ] = ACTIONS(2768),
    [anon_sym_COLON] = ACTIONS(2766),
    [anon_sym_return] = ACTIONS(2766),
    [anon_sym_do] = ACTIONS(2766),
    [anon_sym_let] = ACTIONS(2766),
    [anon_sym_let_BANG] = ACTIONS(2768),
    [anon_sym_as] = ACTIONS(2766),
    [anon_sym_LPAREN] = ACTIONS(2766),
    [anon_sym_COMMA] = ACTIONS(2768),
    [anon_sym_null] = ACTIONS(2766),
    [anon_sym_QMARK] = ACTIONS(2766),
    [anon_sym_COLON_QMARK] = ACTIONS(2766),
    [anon_sym_COLON_COLON] = ACTIONS(2768),
    [anon_sym_PIPE] = ACTIONS(2766),
    [anon_sym_AMP] = ACTIONS(2766),
    [anon_sym_LBRACK] = ACTIONS(2766),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2768),
    [anon_sym_LBRACE] = ACTIONS(2766),
    [anon_sym_LT_AT] = ACTIONS(2766),
    [anon_sym_LT_AT_AT] = ACTIONS(2766),
    [anon_sym_DOT] = ACTIONS(2766),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2768),
    [anon_sym_new] = ACTIONS(2766),
    [anon_sym_with] = ACTIONS(2766),
    [anon_sym_return_BANG] = ACTIONS(2768),
    [anon_sym_yield] = ACTIONS(2766),
    [anon_sym_yield_BANG] = ACTIONS(2768),
    [anon_sym_lazy] = ACTIONS(2766),
    [anon_sym_assert] = ACTIONS(2766),
    [anon_sym_upcast] = ACTIONS(2766),
    [anon_sym_downcast] = ACTIONS(2766),
    [anon_sym_COLON_GT] = ACTIONS(2768),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2768),
    [anon_sym_for] = ACTIONS(2766),
    [anon_sym_while] = ACTIONS(2766),
    [anon_sym_if] = ACTIONS(2766),
    [anon_sym_fun] = ACTIONS(2766),
    [anon_sym_try] = ACTIONS(2766),
    [anon_sym_match] = ACTIONS(2766),
    [anon_sym_match_BANG] = ACTIONS(2768),
    [anon_sym_function] = ACTIONS(2766),
    [anon_sym_LT_DASH] = ACTIONS(2766),
    [anon_sym_DOT_LBRACK] = ACTIONS(2768),
    [anon_sym_LT] = ACTIONS(2768),
    [anon_sym_use] = ACTIONS(2766),
    [anon_sym_use_BANG] = ACTIONS(2768),
    [anon_sym_do_BANG] = ACTIONS(2768),
    [anon_sym_begin] = ACTIONS(2766),
    [anon_sym_LPAREN2] = ACTIONS(2766),
    [anon_sym_or] = ACTIONS(2766),
    [aux_sym_char_token1] = ACTIONS(2768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2766),
    [anon_sym_DQUOTE] = ACTIONS(2766),
    [anon_sym_AT_DQUOTE] = ACTIONS(2768),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2768),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2768),
    [sym_bool] = ACTIONS(2766),
    [sym_unit] = ACTIONS(2768),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2766),
    [sym_op_identifier] = ACTIONS(2766),
    [anon_sym_PLUS] = ACTIONS(2766),
    [anon_sym_DASH] = ACTIONS(2766),
    [anon_sym_PLUS_DOT] = ACTIONS(2766),
    [anon_sym_DASH_DOT] = ACTIONS(2766),
    [anon_sym_PERCENT] = ACTIONS(2766),
    [anon_sym_AMP_AMP] = ACTIONS(2766),
    [anon_sym_TILDE] = ACTIONS(2768),
    [aux_sym_prefix_op_token1] = ACTIONS(2766),
    [aux_sym_infix_op_token1] = ACTIONS(2768),
    [aux_sym_infix_op_token2] = ACTIONS(2766),
    [anon_sym_PIPE_PIPE] = ACTIONS(2766),
    [anon_sym_BANG_EQ] = ACTIONS(2766),
    [anon_sym_COLON_EQ] = ACTIONS(2768),
    [anon_sym_DOLLAR] = ACTIONS(2766),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2766),
    [sym_int] = ACTIONS(2766),
    [sym_xint] = ACTIONS(2768),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2768),
    [sym__newline] = ACTIONS(2768),
    [sym__dedent] = ACTIONS(2768),
  },
  [1425] = {
    [sym_block_comment] = STATE(1425),
    [sym_compiler_directive_decl] = STATE(1425),
    [sym_fsi_directive_decl] = STATE(1425),
    [sym_preproc_line] = STATE(1425),
    [sym_identifier] = ACTIONS(2158),
    [anon_sym_EQ] = ACTIONS(2160),
    [anon_sym_COLON] = ACTIONS(2158),
    [anon_sym_return] = ACTIONS(2158),
    [anon_sym_do] = ACTIONS(2158),
    [anon_sym_let] = ACTIONS(2158),
    [anon_sym_let_BANG] = ACTIONS(2160),
    [anon_sym_as] = ACTIONS(2158),
    [anon_sym_LPAREN] = ACTIONS(2158),
    [anon_sym_COMMA] = ACTIONS(2160),
    [anon_sym_null] = ACTIONS(2158),
    [anon_sym_QMARK] = ACTIONS(2158),
    [anon_sym_COLON_QMARK] = ACTIONS(2158),
    [anon_sym_COLON_COLON] = ACTIONS(2160),
    [anon_sym_AMP] = ACTIONS(2158),
    [anon_sym_LBRACK] = ACTIONS(2158),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2160),
    [anon_sym_LBRACE] = ACTIONS(2158),
    [anon_sym_LT_AT] = ACTIONS(2158),
    [anon_sym_LT_AT_AT] = ACTIONS(2158),
    [anon_sym_DOT] = ACTIONS(2158),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2160),
    [anon_sym_new] = ACTIONS(2158),
    [anon_sym_with] = ACTIONS(2158),
    [anon_sym_return_BANG] = ACTIONS(2160),
    [anon_sym_yield] = ACTIONS(2158),
    [anon_sym_yield_BANG] = ACTIONS(2160),
    [anon_sym_lazy] = ACTIONS(2158),
    [anon_sym_assert] = ACTIONS(2158),
    [anon_sym_upcast] = ACTIONS(2158),
    [anon_sym_downcast] = ACTIONS(2158),
    [anon_sym_COLON_GT] = ACTIONS(2160),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2160),
    [anon_sym_for] = ACTIONS(2158),
    [anon_sym_while] = ACTIONS(2158),
    [anon_sym_if] = ACTIONS(2158),
    [anon_sym_fun] = ACTIONS(2158),
    [anon_sym_try] = ACTIONS(2158),
    [anon_sym_match] = ACTIONS(2158),
    [anon_sym_match_BANG] = ACTIONS(2160),
    [anon_sym_function] = ACTIONS(2158),
    [anon_sym_LT_DASH] = ACTIONS(2158),
    [anon_sym_DOT_LBRACK] = ACTIONS(2160),
    [anon_sym_LT] = ACTIONS(2160),
    [anon_sym_use] = ACTIONS(2158),
    [anon_sym_use_BANG] = ACTIONS(2160),
    [anon_sym_do_BANG] = ACTIONS(2160),
    [anon_sym_begin] = ACTIONS(2158),
    [anon_sym_LPAREN2] = ACTIONS(2158),
    [anon_sym_or] = ACTIONS(2158),
    [aux_sym_char_token1] = ACTIONS(2160),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2158),
    [anon_sym_DQUOTE] = ACTIONS(2158),
    [anon_sym_AT_DQUOTE] = ACTIONS(2160),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2160),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2160),
    [sym_bool] = ACTIONS(2158),
    [sym_unit] = ACTIONS(2160),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2158),
    [sym_op_identifier] = ACTIONS(2158),
    [anon_sym_PLUS] = ACTIONS(2158),
    [anon_sym_DASH] = ACTIONS(2158),
    [anon_sym_PLUS_DOT] = ACTIONS(2158),
    [anon_sym_DASH_DOT] = ACTIONS(2158),
    [anon_sym_PERCENT] = ACTIONS(2158),
    [anon_sym_AMP_AMP] = ACTIONS(2158),
    [anon_sym_TILDE] = ACTIONS(2160),
    [aux_sym_prefix_op_token1] = ACTIONS(2158),
    [aux_sym_infix_op_token1] = ACTIONS(2160),
    [aux_sym_infix_op_token2] = ACTIONS(2158),
    [anon_sym_PIPE_PIPE] = ACTIONS(2158),
    [anon_sym_BANG_EQ] = ACTIONS(2158),
    [anon_sym_COLON_EQ] = ACTIONS(2160),
    [anon_sym_DOLLAR] = ACTIONS(2158),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2158),
    [sym_int] = ACTIONS(2158),
    [sym_xint] = ACTIONS(2160),
    [anon_sym_f] = ACTIONS(2669),
    [aux_sym_decimal_token1] = ACTIONS(2448),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2160),
    [sym__newline] = ACTIONS(2160),
  },
  [1426] = {
    [sym_block_comment] = STATE(1426),
    [sym_compiler_directive_decl] = STATE(1426),
    [sym_fsi_directive_decl] = STATE(1426),
    [sym_preproc_line] = STATE(1426),
    [aux_sym_sequential_expression_repeat1] = STATE(1426),
    [sym_identifier] = ACTIONS(2895),
    [anon_sym_EQ] = ACTIONS(2897),
    [anon_sym_COLON] = ACTIONS(2895),
    [anon_sym_return] = ACTIONS(2895),
    [anon_sym_do] = ACTIONS(2895),
    [anon_sym_let] = ACTIONS(2895),
    [anon_sym_let_BANG] = ACTIONS(2897),
    [anon_sym_as] = ACTIONS(2895),
    [anon_sym_LPAREN] = ACTIONS(2895),
    [anon_sym_COMMA] = ACTIONS(2897),
    [anon_sym_null] = ACTIONS(2895),
    [anon_sym_QMARK] = ACTIONS(2895),
    [anon_sym_COLON_QMARK] = ACTIONS(2895),
    [anon_sym_COLON_COLON] = ACTIONS(2897),
    [anon_sym_AMP] = ACTIONS(2895),
    [anon_sym_LBRACK] = ACTIONS(2895),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2897),
    [anon_sym_LBRACE] = ACTIONS(2895),
    [anon_sym_LT_AT] = ACTIONS(2895),
    [anon_sym_LT_AT_AT] = ACTIONS(2895),
    [anon_sym_DOT] = ACTIONS(2895),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2897),
    [anon_sym_new] = ACTIONS(2895),
    [anon_sym_with] = ACTIONS(2895),
    [anon_sym_return_BANG] = ACTIONS(2897),
    [anon_sym_yield] = ACTIONS(2895),
    [anon_sym_yield_BANG] = ACTIONS(2897),
    [anon_sym_lazy] = ACTIONS(2895),
    [anon_sym_assert] = ACTIONS(2895),
    [anon_sym_upcast] = ACTIONS(2895),
    [anon_sym_downcast] = ACTIONS(2895),
    [anon_sym_COLON_GT] = ACTIONS(2897),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2897),
    [anon_sym_for] = ACTIONS(2895),
    [anon_sym_while] = ACTIONS(2895),
    [anon_sym_if] = ACTIONS(2895),
    [anon_sym_fun] = ACTIONS(2895),
    [anon_sym_try] = ACTIONS(2895),
    [anon_sym_match] = ACTIONS(2895),
    [anon_sym_match_BANG] = ACTIONS(2897),
    [anon_sym_function] = ACTIONS(2895),
    [anon_sym_LT_DASH] = ACTIONS(2895),
    [anon_sym_DOT_LBRACK] = ACTIONS(2897),
    [anon_sym_LT] = ACTIONS(2897),
    [anon_sym_use] = ACTIONS(2895),
    [anon_sym_use_BANG] = ACTIONS(2897),
    [anon_sym_do_BANG] = ACTIONS(2897),
    [anon_sym_begin] = ACTIONS(2895),
    [anon_sym_LPAREN2] = ACTIONS(2895),
    [anon_sym_or] = ACTIONS(2895),
    [aux_sym_char_token1] = ACTIONS(2897),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2895),
    [anon_sym_DQUOTE] = ACTIONS(2895),
    [anon_sym_AT_DQUOTE] = ACTIONS(2897),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2897),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2897),
    [sym_bool] = ACTIONS(2895),
    [sym_unit] = ACTIONS(2897),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2895),
    [sym_op_identifier] = ACTIONS(2895),
    [anon_sym_PLUS] = ACTIONS(2895),
    [anon_sym_DASH] = ACTIONS(2895),
    [anon_sym_PLUS_DOT] = ACTIONS(2895),
    [anon_sym_DASH_DOT] = ACTIONS(2895),
    [anon_sym_PERCENT] = ACTIONS(2895),
    [anon_sym_AMP_AMP] = ACTIONS(2895),
    [anon_sym_TILDE] = ACTIONS(2897),
    [aux_sym_prefix_op_token1] = ACTIONS(2895),
    [aux_sym_infix_op_token1] = ACTIONS(2897),
    [aux_sym_infix_op_token2] = ACTIONS(2895),
    [anon_sym_PIPE_PIPE] = ACTIONS(2895),
    [anon_sym_BANG_EQ] = ACTIONS(2895),
    [anon_sym_COLON_EQ] = ACTIONS(2897),
    [anon_sym_DOLLAR] = ACTIONS(2895),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2895),
    [sym_int] = ACTIONS(2895),
    [sym_xint] = ACTIONS(2897),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2897),
    [sym__newline] = ACTIONS(3627),
    [sym__dedent] = ACTIONS(2897),
  },
  [1427] = {
    [sym_block_comment] = STATE(1427),
    [sym_compiler_directive_decl] = STATE(1427),
    [sym_fsi_directive_decl] = STATE(1427),
    [sym_preproc_line] = STATE(1427),
    [sym_identifier] = ACTIONS(2158),
    [anon_sym_EQ] = ACTIONS(2160),
    [anon_sym_COLON] = ACTIONS(2158),
    [anon_sym_return] = ACTIONS(2158),
    [anon_sym_do] = ACTIONS(2158),
    [anon_sym_let] = ACTIONS(2158),
    [anon_sym_let_BANG] = ACTIONS(2160),
    [anon_sym_LPAREN] = ACTIONS(2158),
    [anon_sym_COMMA] = ACTIONS(2160),
    [anon_sym_null] = ACTIONS(2158),
    [anon_sym_QMARK] = ACTIONS(2158),
    [anon_sym_COLON_QMARK] = ACTIONS(2158),
    [anon_sym_COLON_COLON] = ACTIONS(2160),
    [anon_sym_AMP] = ACTIONS(2158),
    [anon_sym_LBRACK] = ACTIONS(2158),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2160),
    [anon_sym_LBRACE] = ACTIONS(2158),
    [anon_sym_LT_AT] = ACTIONS(2158),
    [anon_sym_LT_AT_AT] = ACTIONS(2158),
    [anon_sym_DOT] = ACTIONS(2158),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2160),
    [anon_sym_new] = ACTIONS(2158),
    [anon_sym_return_BANG] = ACTIONS(2160),
    [anon_sym_yield] = ACTIONS(2158),
    [anon_sym_yield_BANG] = ACTIONS(2160),
    [anon_sym_lazy] = ACTIONS(2158),
    [anon_sym_assert] = ACTIONS(2158),
    [anon_sym_upcast] = ACTIONS(2158),
    [anon_sym_downcast] = ACTIONS(2158),
    [anon_sym_COLON_GT] = ACTIONS(2160),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2160),
    [anon_sym_for] = ACTIONS(2158),
    [anon_sym_while] = ACTIONS(2158),
    [anon_sym_if] = ACTIONS(2158),
    [anon_sym_fun] = ACTIONS(2158),
    [anon_sym_try] = ACTIONS(2158),
    [anon_sym_match] = ACTIONS(2158),
    [anon_sym_match_BANG] = ACTIONS(2160),
    [anon_sym_function] = ACTIONS(2158),
    [anon_sym_LT_DASH] = ACTIONS(2158),
    [anon_sym_DOT_LBRACK] = ACTIONS(2160),
    [anon_sym_LT] = ACTIONS(2160),
    [anon_sym_use] = ACTIONS(2158),
    [anon_sym_use_BANG] = ACTIONS(2160),
    [anon_sym_do_BANG] = ACTIONS(2160),
    [anon_sym_begin] = ACTIONS(2158),
    [anon_sym_LPAREN2] = ACTIONS(2158),
    [anon_sym_or] = ACTIONS(2158),
    [aux_sym_char_token1] = ACTIONS(2160),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2158),
    [anon_sym_DQUOTE] = ACTIONS(2158),
    [anon_sym_AT_DQUOTE] = ACTIONS(2160),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2160),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2160),
    [sym_bool] = ACTIONS(2158),
    [sym_unit] = ACTIONS(2160),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2158),
    [sym_op_identifier] = ACTIONS(2158),
    [anon_sym_PLUS] = ACTIONS(2158),
    [anon_sym_DASH] = ACTIONS(2158),
    [anon_sym_PLUS_DOT] = ACTIONS(2158),
    [anon_sym_DASH_DOT] = ACTIONS(2158),
    [anon_sym_PERCENT] = ACTIONS(2158),
    [anon_sym_AMP_AMP] = ACTIONS(2158),
    [anon_sym_TILDE] = ACTIONS(2160),
    [aux_sym_prefix_op_token1] = ACTIONS(2158),
    [aux_sym_infix_op_token1] = ACTIONS(2160),
    [aux_sym_infix_op_token2] = ACTIONS(2158),
    [anon_sym_PIPE_PIPE] = ACTIONS(2158),
    [anon_sym_BANG_EQ] = ACTIONS(2158),
    [anon_sym_COLON_EQ] = ACTIONS(2160),
    [anon_sym_DOLLAR] = ACTIONS(2158),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2158),
    [sym_int] = ACTIONS(2158),
    [sym_xint] = ACTIONS(2160),
    [anon_sym_f] = ACTIONS(2673),
    [aux_sym_decimal_token1] = ACTIONS(2397),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2160),
    [anon_sym_POUNDendif] = ACTIONS(2160),
    [anon_sym_POUNDelse] = ACTIONS(2160),
    [sym__newline] = ACTIONS(2160),
  },
  [1428] = {
    [sym_block_comment] = STATE(1428),
    [sym_compiler_directive_decl] = STATE(1428),
    [sym_fsi_directive_decl] = STATE(1428),
    [sym_preproc_line] = STATE(1428),
    [sym_identifier] = ACTIONS(2804),
    [anon_sym_EQ] = ACTIONS(2806),
    [anon_sym_COLON] = ACTIONS(2804),
    [anon_sym_return] = ACTIONS(2804),
    [anon_sym_do] = ACTIONS(2804),
    [anon_sym_let] = ACTIONS(2804),
    [anon_sym_let_BANG] = ACTIONS(2806),
    [anon_sym_as] = ACTIONS(2804),
    [anon_sym_LPAREN] = ACTIONS(2804),
    [anon_sym_COMMA] = ACTIONS(2806),
    [anon_sym_null] = ACTIONS(2804),
    [anon_sym_QMARK] = ACTIONS(2804),
    [anon_sym_COLON_QMARK] = ACTIONS(2804),
    [anon_sym_COLON_COLON] = ACTIONS(2806),
    [anon_sym_AMP] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2804),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(2804),
    [anon_sym_LT_AT] = ACTIONS(2804),
    [anon_sym_LT_AT_AT] = ACTIONS(2804),
    [anon_sym_DOT] = ACTIONS(2804),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2806),
    [anon_sym_new] = ACTIONS(2804),
    [anon_sym_with] = ACTIONS(2804),
    [anon_sym_return_BANG] = ACTIONS(2806),
    [anon_sym_yield] = ACTIONS(2804),
    [anon_sym_yield_BANG] = ACTIONS(2806),
    [anon_sym_lazy] = ACTIONS(2804),
    [anon_sym_assert] = ACTIONS(2804),
    [anon_sym_upcast] = ACTIONS(2804),
    [anon_sym_downcast] = ACTIONS(2804),
    [anon_sym_COLON_GT] = ACTIONS(2806),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2806),
    [anon_sym_for] = ACTIONS(2804),
    [anon_sym_done] = ACTIONS(3630),
    [anon_sym_while] = ACTIONS(2804),
    [anon_sym_if] = ACTIONS(2804),
    [anon_sym_fun] = ACTIONS(2804),
    [anon_sym_try] = ACTIONS(2804),
    [anon_sym_match] = ACTIONS(2804),
    [anon_sym_match_BANG] = ACTIONS(2806),
    [anon_sym_function] = ACTIONS(2804),
    [anon_sym_LT_DASH] = ACTIONS(2804),
    [anon_sym_DOT_LBRACK] = ACTIONS(2806),
    [anon_sym_LT] = ACTIONS(2806),
    [anon_sym_use] = ACTIONS(2804),
    [anon_sym_use_BANG] = ACTIONS(2806),
    [anon_sym_do_BANG] = ACTIONS(2806),
    [anon_sym_begin] = ACTIONS(2804),
    [anon_sym_LPAREN2] = ACTIONS(2804),
    [anon_sym_or] = ACTIONS(2804),
    [aux_sym_char_token1] = ACTIONS(2806),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2804),
    [anon_sym_DQUOTE] = ACTIONS(2804),
    [anon_sym_AT_DQUOTE] = ACTIONS(2806),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2806),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2806),
    [sym_bool] = ACTIONS(2804),
    [sym_unit] = ACTIONS(2806),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2804),
    [sym_op_identifier] = ACTIONS(2804),
    [anon_sym_PLUS] = ACTIONS(2804),
    [anon_sym_DASH] = ACTIONS(2804),
    [anon_sym_PLUS_DOT] = ACTIONS(2804),
    [anon_sym_DASH_DOT] = ACTIONS(2804),
    [anon_sym_PERCENT] = ACTIONS(2804),
    [anon_sym_AMP_AMP] = ACTIONS(2804),
    [anon_sym_TILDE] = ACTIONS(2806),
    [aux_sym_prefix_op_token1] = ACTIONS(2804),
    [aux_sym_infix_op_token1] = ACTIONS(2806),
    [aux_sym_infix_op_token2] = ACTIONS(2804),
    [anon_sym_PIPE_PIPE] = ACTIONS(2804),
    [anon_sym_BANG_EQ] = ACTIONS(2804),
    [anon_sym_COLON_EQ] = ACTIONS(2806),
    [anon_sym_DOLLAR] = ACTIONS(2804),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2804),
    [sym_int] = ACTIONS(2804),
    [sym_xint] = ACTIONS(2806),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2806),
    [sym__newline] = ACTIONS(2806),
    [sym__dedent] = ACTIONS(2806),
  },
  [1429] = {
    [sym_block_comment] = STATE(1429),
    [sym_compiler_directive_decl] = STATE(1429),
    [sym_fsi_directive_decl] = STATE(1429),
    [sym_preproc_line] = STATE(1429),
    [sym_identifier] = ACTIONS(2685),
    [anon_sym_EQ] = ACTIONS(2687),
    [anon_sym_COLON] = ACTIONS(2685),
    [anon_sym_return] = ACTIONS(2685),
    [anon_sym_do] = ACTIONS(2685),
    [anon_sym_let] = ACTIONS(2685),
    [anon_sym_let_BANG] = ACTIONS(2687),
    [anon_sym_as] = ACTIONS(2685),
    [anon_sym_LPAREN] = ACTIONS(2685),
    [anon_sym_COMMA] = ACTIONS(2687),
    [anon_sym_null] = ACTIONS(2685),
    [anon_sym_QMARK] = ACTIONS(2685),
    [anon_sym_COLON_QMARK] = ACTIONS(2685),
    [anon_sym_COLON_COLON] = ACTIONS(2687),
    [anon_sym_PIPE] = ACTIONS(2685),
    [anon_sym_AMP] = ACTIONS(2685),
    [anon_sym_LBRACK] = ACTIONS(2685),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2687),
    [anon_sym_LBRACE] = ACTIONS(2685),
    [anon_sym_LT_AT] = ACTIONS(2685),
    [anon_sym_LT_AT_AT] = ACTIONS(2685),
    [anon_sym_DOT] = ACTIONS(2685),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2687),
    [anon_sym_new] = ACTIONS(2685),
    [anon_sym_with] = ACTIONS(2685),
    [anon_sym_return_BANG] = ACTIONS(2687),
    [anon_sym_yield] = ACTIONS(2685),
    [anon_sym_yield_BANG] = ACTIONS(2687),
    [anon_sym_lazy] = ACTIONS(2685),
    [anon_sym_assert] = ACTIONS(2685),
    [anon_sym_upcast] = ACTIONS(2685),
    [anon_sym_downcast] = ACTIONS(2685),
    [anon_sym_COLON_GT] = ACTIONS(2687),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2687),
    [anon_sym_for] = ACTIONS(2685),
    [anon_sym_while] = ACTIONS(2685),
    [anon_sym_if] = ACTIONS(2685),
    [anon_sym_fun] = ACTIONS(2685),
    [anon_sym_try] = ACTIONS(2685),
    [anon_sym_match] = ACTIONS(2685),
    [anon_sym_match_BANG] = ACTIONS(2687),
    [anon_sym_function] = ACTIONS(2685),
    [anon_sym_LT_DASH] = ACTIONS(2685),
    [anon_sym_DOT_LBRACK] = ACTIONS(2687),
    [anon_sym_LT] = ACTIONS(2687),
    [anon_sym_use] = ACTIONS(2685),
    [anon_sym_use_BANG] = ACTIONS(2687),
    [anon_sym_do_BANG] = ACTIONS(2687),
    [anon_sym_begin] = ACTIONS(2685),
    [anon_sym_LPAREN2] = ACTIONS(2685),
    [anon_sym_or] = ACTIONS(2685),
    [aux_sym_char_token1] = ACTIONS(2687),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2685),
    [anon_sym_DQUOTE] = ACTIONS(2685),
    [anon_sym_AT_DQUOTE] = ACTIONS(2687),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2687),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2687),
    [sym_bool] = ACTIONS(2685),
    [sym_unit] = ACTIONS(2687),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2685),
    [sym_op_identifier] = ACTIONS(2685),
    [anon_sym_PLUS] = ACTIONS(2685),
    [anon_sym_DASH] = ACTIONS(2685),
    [anon_sym_PLUS_DOT] = ACTIONS(2685),
    [anon_sym_DASH_DOT] = ACTIONS(2685),
    [anon_sym_PERCENT] = ACTIONS(2685),
    [anon_sym_AMP_AMP] = ACTIONS(2685),
    [anon_sym_TILDE] = ACTIONS(2687),
    [aux_sym_prefix_op_token1] = ACTIONS(2685),
    [aux_sym_infix_op_token1] = ACTIONS(2687),
    [aux_sym_infix_op_token2] = ACTIONS(2685),
    [anon_sym_PIPE_PIPE] = ACTIONS(2685),
    [anon_sym_BANG_EQ] = ACTIONS(2685),
    [anon_sym_COLON_EQ] = ACTIONS(2687),
    [anon_sym_DOLLAR] = ACTIONS(2685),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2685),
    [sym_int] = ACTIONS(2685),
    [sym_xint] = ACTIONS(2687),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2687),
    [sym__newline] = ACTIONS(2687),
    [sym__dedent] = ACTIONS(2687),
  },
  [1430] = {
    [sym_block_comment] = STATE(1430),
    [sym_compiler_directive_decl] = STATE(1430),
    [sym_fsi_directive_decl] = STATE(1430),
    [sym_preproc_line] = STATE(1430),
    [sym_identifier] = ACTIONS(2783),
    [anon_sym_EQ] = ACTIONS(2785),
    [anon_sym_COLON] = ACTIONS(2783),
    [anon_sym_return] = ACTIONS(2783),
    [anon_sym_do] = ACTIONS(2783),
    [anon_sym_let] = ACTIONS(2783),
    [anon_sym_let_BANG] = ACTIONS(2785),
    [anon_sym_as] = ACTIONS(2783),
    [anon_sym_LPAREN] = ACTIONS(2783),
    [anon_sym_COMMA] = ACTIONS(2785),
    [anon_sym_null] = ACTIONS(2783),
    [anon_sym_QMARK] = ACTIONS(2783),
    [anon_sym_COLON_QMARK] = ACTIONS(2783),
    [anon_sym_COLON_COLON] = ACTIONS(2785),
    [anon_sym_AMP] = ACTIONS(2783),
    [anon_sym_LBRACK] = ACTIONS(2783),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2785),
    [anon_sym_LBRACE] = ACTIONS(2783),
    [anon_sym_LT_AT] = ACTIONS(2783),
    [anon_sym_LT_AT_AT] = ACTIONS(2783),
    [anon_sym_DOT] = ACTIONS(2783),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2785),
    [anon_sym_new] = ACTIONS(2783),
    [anon_sym_with] = ACTIONS(2783),
    [anon_sym_return_BANG] = ACTIONS(2785),
    [anon_sym_yield] = ACTIONS(2783),
    [anon_sym_yield_BANG] = ACTIONS(2785),
    [anon_sym_lazy] = ACTIONS(2783),
    [anon_sym_assert] = ACTIONS(2783),
    [anon_sym_upcast] = ACTIONS(2783),
    [anon_sym_downcast] = ACTIONS(2783),
    [anon_sym_COLON_GT] = ACTIONS(2785),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2785),
    [anon_sym_for] = ACTIONS(2783),
    [anon_sym_done] = ACTIONS(3525),
    [anon_sym_while] = ACTIONS(2783),
    [anon_sym_if] = ACTIONS(2783),
    [anon_sym_fun] = ACTIONS(2783),
    [anon_sym_try] = ACTIONS(2783),
    [anon_sym_match] = ACTIONS(2783),
    [anon_sym_match_BANG] = ACTIONS(2785),
    [anon_sym_function] = ACTIONS(2783),
    [anon_sym_LT_DASH] = ACTIONS(2783),
    [anon_sym_DOT_LBRACK] = ACTIONS(2785),
    [anon_sym_LT] = ACTIONS(2785),
    [anon_sym_use] = ACTIONS(2783),
    [anon_sym_use_BANG] = ACTIONS(2785),
    [anon_sym_do_BANG] = ACTIONS(2785),
    [anon_sym_begin] = ACTIONS(2783),
    [anon_sym_LPAREN2] = ACTIONS(2783),
    [anon_sym_or] = ACTIONS(2783),
    [aux_sym_char_token1] = ACTIONS(2785),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2783),
    [anon_sym_DQUOTE] = ACTIONS(2783),
    [anon_sym_AT_DQUOTE] = ACTIONS(2785),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2785),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2785),
    [sym_bool] = ACTIONS(2783),
    [sym_unit] = ACTIONS(2785),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2783),
    [sym_op_identifier] = ACTIONS(2783),
    [anon_sym_PLUS] = ACTIONS(2783),
    [anon_sym_DASH] = ACTIONS(2783),
    [anon_sym_PLUS_DOT] = ACTIONS(2783),
    [anon_sym_DASH_DOT] = ACTIONS(2783),
    [anon_sym_PERCENT] = ACTIONS(2783),
    [anon_sym_AMP_AMP] = ACTIONS(2783),
    [anon_sym_TILDE] = ACTIONS(2785),
    [aux_sym_prefix_op_token1] = ACTIONS(2783),
    [aux_sym_infix_op_token1] = ACTIONS(2785),
    [aux_sym_infix_op_token2] = ACTIONS(2783),
    [anon_sym_PIPE_PIPE] = ACTIONS(2783),
    [anon_sym_BANG_EQ] = ACTIONS(2783),
    [anon_sym_COLON_EQ] = ACTIONS(2785),
    [anon_sym_DOLLAR] = ACTIONS(2783),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2783),
    [sym_int] = ACTIONS(2783),
    [sym_xint] = ACTIONS(2785),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2785),
    [sym__newline] = ACTIONS(2785),
    [sym__dedent] = ACTIONS(2785),
  },
  [1431] = {
    [sym_block_comment] = STATE(1431),
    [sym_compiler_directive_decl] = STATE(1431),
    [sym_fsi_directive_decl] = STATE(1431),
    [sym_preproc_line] = STATE(1431),
    [sym_identifier] = ACTIONS(2723),
    [anon_sym_EQ] = ACTIONS(2725),
    [anon_sym_COLON] = ACTIONS(2723),
    [anon_sym_return] = ACTIONS(2723),
    [anon_sym_do] = ACTIONS(2723),
    [anon_sym_let] = ACTIONS(2723),
    [anon_sym_let_BANG] = ACTIONS(2725),
    [anon_sym_LPAREN] = ACTIONS(2723),
    [anon_sym_COMMA] = ACTIONS(2725),
    [anon_sym_null] = ACTIONS(2723),
    [anon_sym_QMARK] = ACTIONS(2723),
    [anon_sym_COLON_QMARK] = ACTIONS(2723),
    [anon_sym_COLON_COLON] = ACTIONS(2725),
    [anon_sym_AMP] = ACTIONS(2723),
    [anon_sym_LBRACK] = ACTIONS(2723),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2725),
    [anon_sym_LBRACE] = ACTIONS(2723),
    [anon_sym_LT_AT] = ACTIONS(2723),
    [anon_sym_LT_AT_AT] = ACTIONS(2723),
    [anon_sym_AT_AT_GT] = ACTIONS(2723),
    [anon_sym_DOT] = ACTIONS(2723),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2725),
    [anon_sym_new] = ACTIONS(2723),
    [anon_sym_return_BANG] = ACTIONS(2725),
    [anon_sym_yield] = ACTIONS(2723),
    [anon_sym_yield_BANG] = ACTIONS(2725),
    [anon_sym_lazy] = ACTIONS(2723),
    [anon_sym_assert] = ACTIONS(2723),
    [anon_sym_upcast] = ACTIONS(2723),
    [anon_sym_downcast] = ACTIONS(2723),
    [anon_sym_COLON_GT] = ACTIONS(2725),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2725),
    [anon_sym_for] = ACTIONS(2723),
    [anon_sym_while] = ACTIONS(2723),
    [anon_sym_if] = ACTIONS(2723),
    [anon_sym_fun] = ACTIONS(2723),
    [anon_sym_try] = ACTIONS(2723),
    [anon_sym_match] = ACTIONS(2723),
    [anon_sym_match_BANG] = ACTIONS(2725),
    [anon_sym_function] = ACTIONS(2723),
    [anon_sym_LT_DASH] = ACTIONS(2723),
    [anon_sym_DOT_LBRACK] = ACTIONS(2725),
    [anon_sym_LT] = ACTIONS(2725),
    [anon_sym_use] = ACTIONS(2723),
    [anon_sym_use_BANG] = ACTIONS(2725),
    [anon_sym_do_BANG] = ACTIONS(2725),
    [anon_sym_begin] = ACTIONS(2723),
    [anon_sym_LPAREN2] = ACTIONS(2723),
    [anon_sym_or] = ACTIONS(2723),
    [aux_sym_char_token1] = ACTIONS(2725),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2723),
    [anon_sym_DQUOTE] = ACTIONS(2723),
    [anon_sym_AT_DQUOTE] = ACTIONS(2725),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2725),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2725),
    [sym_bool] = ACTIONS(2723),
    [sym_unit] = ACTIONS(2725),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2723),
    [sym_op_identifier] = ACTIONS(2723),
    [anon_sym_PLUS] = ACTIONS(2723),
    [anon_sym_DASH] = ACTIONS(2723),
    [anon_sym_PLUS_DOT] = ACTIONS(2723),
    [anon_sym_DASH_DOT] = ACTIONS(2723),
    [anon_sym_PERCENT] = ACTIONS(2723),
    [anon_sym_AMP_AMP] = ACTIONS(2723),
    [anon_sym_TILDE] = ACTIONS(2725),
    [aux_sym_prefix_op_token1] = ACTIONS(2723),
    [aux_sym_infix_op_token1] = ACTIONS(2725),
    [aux_sym_infix_op_token2] = ACTIONS(2723),
    [anon_sym_PIPE_PIPE] = ACTIONS(2723),
    [anon_sym_BANG_EQ] = ACTIONS(2723),
    [anon_sym_COLON_EQ] = ACTIONS(2725),
    [anon_sym_DOLLAR] = ACTIONS(2723),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2723),
    [sym_int] = ACTIONS(2723),
    [sym_xint] = ACTIONS(2725),
    [anon_sym_f] = ACTIONS(2723),
    [aux_sym_decimal_token1] = ACTIONS(2723),
    [aux_sym_float_token1] = ACTIONS(3632),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2725),
    [sym__newline] = ACTIONS(2725),
  },
  [1432] = {
    [sym_block_comment] = STATE(1432),
    [sym_compiler_directive_decl] = STATE(1432),
    [sym_fsi_directive_decl] = STATE(1432),
    [sym_preproc_line] = STATE(1432),
    [sym_identifier] = ACTIONS(2748),
    [anon_sym_EQ] = ACTIONS(2750),
    [anon_sym_COLON] = ACTIONS(2748),
    [anon_sym_return] = ACTIONS(2748),
    [anon_sym_do] = ACTIONS(2748),
    [anon_sym_and] = ACTIONS(2748),
    [anon_sym_let] = ACTIONS(2748),
    [anon_sym_let_BANG] = ACTIONS(2750),
    [anon_sym_LPAREN] = ACTIONS(2748),
    [anon_sym_COMMA] = ACTIONS(2750),
    [anon_sym_null] = ACTIONS(2748),
    [anon_sym_QMARK] = ACTIONS(2748),
    [anon_sym_COLON_QMARK] = ACTIONS(2748),
    [anon_sym_COLON_COLON] = ACTIONS(2750),
    [anon_sym_AMP] = ACTIONS(2748),
    [anon_sym_LBRACK] = ACTIONS(2748),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2750),
    [anon_sym_LBRACE] = ACTIONS(2748),
    [anon_sym_LT_AT] = ACTIONS(2748),
    [anon_sym_LT_AT_AT] = ACTIONS(2748),
    [anon_sym_DOT] = ACTIONS(2748),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2750),
    [anon_sym_new] = ACTIONS(2748),
    [anon_sym_return_BANG] = ACTIONS(2750),
    [anon_sym_yield] = ACTIONS(2748),
    [anon_sym_yield_BANG] = ACTIONS(2750),
    [anon_sym_lazy] = ACTIONS(2748),
    [anon_sym_assert] = ACTIONS(2748),
    [anon_sym_upcast] = ACTIONS(2748),
    [anon_sym_downcast] = ACTIONS(2748),
    [anon_sym_COLON_GT] = ACTIONS(2750),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2750),
    [anon_sym_for] = ACTIONS(2748),
    [anon_sym_while] = ACTIONS(2748),
    [anon_sym_else] = ACTIONS(2748),
    [anon_sym_elif] = ACTIONS(2748),
    [anon_sym_if] = ACTIONS(2748),
    [anon_sym_fun] = ACTIONS(2748),
    [anon_sym_try] = ACTIONS(2748),
    [anon_sym_match] = ACTIONS(2748),
    [anon_sym_match_BANG] = ACTIONS(2750),
    [anon_sym_function] = ACTIONS(2748),
    [anon_sym_LT_DASH] = ACTIONS(2748),
    [anon_sym_DOT_LBRACK] = ACTIONS(2750),
    [anon_sym_LT] = ACTIONS(2750),
    [anon_sym_use] = ACTIONS(2748),
    [anon_sym_use_BANG] = ACTIONS(2750),
    [anon_sym_do_BANG] = ACTIONS(2750),
    [anon_sym_begin] = ACTIONS(2748),
    [anon_sym_LPAREN2] = ACTIONS(2748),
    [anon_sym_or] = ACTIONS(2748),
    [aux_sym_char_token1] = ACTIONS(2750),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2748),
    [anon_sym_DQUOTE] = ACTIONS(2748),
    [anon_sym_AT_DQUOTE] = ACTIONS(2750),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2750),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2750),
    [sym_bool] = ACTIONS(2748),
    [sym_unit] = ACTIONS(2750),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2748),
    [sym_op_identifier] = ACTIONS(2748),
    [anon_sym_PLUS] = ACTIONS(2748),
    [anon_sym_DASH] = ACTIONS(2748),
    [anon_sym_PLUS_DOT] = ACTIONS(2748),
    [anon_sym_DASH_DOT] = ACTIONS(2748),
    [anon_sym_PERCENT] = ACTIONS(2748),
    [anon_sym_AMP_AMP] = ACTIONS(2748),
    [anon_sym_TILDE] = ACTIONS(2750),
    [aux_sym_prefix_op_token1] = ACTIONS(2748),
    [aux_sym_infix_op_token1] = ACTIONS(2750),
    [aux_sym_infix_op_token2] = ACTIONS(2748),
    [anon_sym_PIPE_PIPE] = ACTIONS(2748),
    [anon_sym_BANG_EQ] = ACTIONS(2748),
    [anon_sym_COLON_EQ] = ACTIONS(2750),
    [anon_sym_DOLLAR] = ACTIONS(2748),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2748),
    [sym_int] = ACTIONS(2748),
    [sym_xint] = ACTIONS(2750),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2750),
    [sym__newline] = ACTIONS(2750),
    [sym__dedent] = ACTIONS(2750),
  },
  [1433] = {
    [sym_block_comment] = STATE(1433),
    [sym_compiler_directive_decl] = STATE(1433),
    [sym_fsi_directive_decl] = STATE(1433),
    [sym_preproc_line] = STATE(1433),
    [sym_identifier] = ACTIONS(2685),
    [anon_sym_EQ] = ACTIONS(2687),
    [anon_sym_COLON] = ACTIONS(2685),
    [anon_sym_return] = ACTIONS(2685),
    [anon_sym_do] = ACTIONS(2685),
    [anon_sym_let] = ACTIONS(2685),
    [anon_sym_let_BANG] = ACTIONS(2687),
    [anon_sym_LPAREN] = ACTIONS(2685),
    [anon_sym_COMMA] = ACTIONS(2687),
    [anon_sym_null] = ACTIONS(2685),
    [anon_sym_QMARK] = ACTIONS(2685),
    [anon_sym_COLON_QMARK] = ACTIONS(2685),
    [anon_sym_COLON_COLON] = ACTIONS(2687),
    [anon_sym_AMP] = ACTIONS(2685),
    [anon_sym_LBRACK] = ACTIONS(2685),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2687),
    [anon_sym_LBRACE] = ACTIONS(2685),
    [anon_sym_LT_AT] = ACTIONS(2685),
    [anon_sym_LT_AT_AT] = ACTIONS(2685),
    [anon_sym_DOT] = ACTIONS(2685),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2687),
    [anon_sym_new] = ACTIONS(2685),
    [anon_sym_return_BANG] = ACTIONS(2687),
    [anon_sym_yield] = ACTIONS(2685),
    [anon_sym_yield_BANG] = ACTIONS(2687),
    [anon_sym_lazy] = ACTIONS(2685),
    [anon_sym_assert] = ACTIONS(2685),
    [anon_sym_upcast] = ACTIONS(2685),
    [anon_sym_downcast] = ACTIONS(2685),
    [anon_sym_COLON_GT] = ACTIONS(2687),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2687),
    [anon_sym_for] = ACTIONS(2685),
    [anon_sym_while] = ACTIONS(2685),
    [anon_sym_else] = ACTIONS(2685),
    [anon_sym_elif] = ACTIONS(2685),
    [anon_sym_if] = ACTIONS(2685),
    [anon_sym_fun] = ACTIONS(2685),
    [anon_sym_try] = ACTIONS(2685),
    [anon_sym_match] = ACTIONS(2685),
    [anon_sym_match_BANG] = ACTIONS(2687),
    [anon_sym_function] = ACTIONS(2685),
    [anon_sym_LT_DASH] = ACTIONS(2685),
    [anon_sym_DOT_LBRACK] = ACTIONS(2687),
    [anon_sym_LT] = ACTIONS(2687),
    [anon_sym_use] = ACTIONS(2685),
    [anon_sym_use_BANG] = ACTIONS(2687),
    [anon_sym_do_BANG] = ACTIONS(2687),
    [anon_sym_begin] = ACTIONS(2685),
    [anon_sym_LPAREN2] = ACTIONS(2685),
    [anon_sym_or] = ACTIONS(2685),
    [aux_sym_char_token1] = ACTIONS(2687),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2685),
    [anon_sym_DQUOTE] = ACTIONS(2685),
    [anon_sym_AT_DQUOTE] = ACTIONS(2687),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2687),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2687),
    [sym_bool] = ACTIONS(2685),
    [sym_unit] = ACTIONS(2687),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2685),
    [sym_op_identifier] = ACTIONS(2685),
    [anon_sym_PLUS] = ACTIONS(2685),
    [anon_sym_DASH] = ACTIONS(2685),
    [anon_sym_PLUS_DOT] = ACTIONS(2685),
    [anon_sym_DASH_DOT] = ACTIONS(2685),
    [anon_sym_PERCENT] = ACTIONS(2685),
    [anon_sym_AMP_AMP] = ACTIONS(2685),
    [anon_sym_TILDE] = ACTIONS(2687),
    [aux_sym_prefix_op_token1] = ACTIONS(2685),
    [aux_sym_infix_op_token1] = ACTIONS(2687),
    [aux_sym_infix_op_token2] = ACTIONS(2685),
    [anon_sym_PIPE_PIPE] = ACTIONS(2685),
    [anon_sym_BANG_EQ] = ACTIONS(2685),
    [anon_sym_COLON_EQ] = ACTIONS(2687),
    [anon_sym_DOLLAR] = ACTIONS(2685),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2685),
    [sym_int] = ACTIONS(2685),
    [sym_xint] = ACTIONS(2687),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2687),
    [anon_sym_POUNDendif] = ACTIONS(2687),
    [anon_sym_POUNDelse] = ACTIONS(2687),
    [sym__newline] = ACTIONS(2687),
  },
  [1434] = {
    [sym_block_comment] = STATE(1434),
    [sym_compiler_directive_decl] = STATE(1434),
    [sym_fsi_directive_decl] = STATE(1434),
    [sym_preproc_line] = STATE(1434),
    [sym_identifier] = ACTIONS(2819),
    [anon_sym_EQ] = ACTIONS(2821),
    [anon_sym_COLON] = ACTIONS(2819),
    [anon_sym_return] = ACTIONS(2819),
    [anon_sym_do] = ACTIONS(2819),
    [anon_sym_let] = ACTIONS(2819),
    [anon_sym_let_BANG] = ACTIONS(2821),
    [anon_sym_LPAREN] = ACTIONS(2819),
    [anon_sym_COMMA] = ACTIONS(2821),
    [anon_sym_null] = ACTIONS(2819),
    [anon_sym_QMARK] = ACTIONS(2819),
    [anon_sym_COLON_QMARK] = ACTIONS(2819),
    [anon_sym_COLON_COLON] = ACTIONS(2821),
    [anon_sym_AMP] = ACTIONS(2819),
    [anon_sym_LBRACK] = ACTIONS(2819),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2821),
    [anon_sym_LBRACE] = ACTIONS(2819),
    [anon_sym_LT_AT] = ACTIONS(2819),
    [anon_sym_LT_AT_AT] = ACTIONS(2819),
    [anon_sym_DOT] = ACTIONS(2819),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2821),
    [anon_sym_new] = ACTIONS(2819),
    [anon_sym_return_BANG] = ACTIONS(2821),
    [anon_sym_yield] = ACTIONS(2819),
    [anon_sym_yield_BANG] = ACTIONS(2821),
    [anon_sym_lazy] = ACTIONS(2819),
    [anon_sym_assert] = ACTIONS(2819),
    [anon_sym_upcast] = ACTIONS(2819),
    [anon_sym_downcast] = ACTIONS(2819),
    [anon_sym_COLON_GT] = ACTIONS(2821),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2821),
    [anon_sym_for] = ACTIONS(2819),
    [anon_sym_while] = ACTIONS(2819),
    [anon_sym_if] = ACTIONS(2819),
    [anon_sym_fun] = ACTIONS(2819),
    [anon_sym_DASH_GT] = ACTIONS(2819),
    [anon_sym_try] = ACTIONS(2819),
    [anon_sym_match] = ACTIONS(2819),
    [anon_sym_match_BANG] = ACTIONS(2821),
    [anon_sym_function] = ACTIONS(2819),
    [anon_sym_LT_DASH] = ACTIONS(2819),
    [anon_sym_DOT_LBRACK] = ACTIONS(2821),
    [anon_sym_LT] = ACTIONS(2821),
    [anon_sym_use] = ACTIONS(2819),
    [anon_sym_use_BANG] = ACTIONS(2821),
    [anon_sym_do_BANG] = ACTIONS(2821),
    [anon_sym_DOT_DOT] = ACTIONS(2821),
    [anon_sym_begin] = ACTIONS(2819),
    [anon_sym_LPAREN2] = ACTIONS(2819),
    [anon_sym_or] = ACTIONS(2819),
    [aux_sym_char_token1] = ACTIONS(2821),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2819),
    [anon_sym_DQUOTE] = ACTIONS(2819),
    [anon_sym_AT_DQUOTE] = ACTIONS(2821),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2821),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2821),
    [sym_bool] = ACTIONS(2819),
    [sym_unit] = ACTIONS(2821),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2819),
    [sym_op_identifier] = ACTIONS(2819),
    [anon_sym_PLUS] = ACTIONS(2819),
    [anon_sym_DASH] = ACTIONS(2819),
    [anon_sym_PLUS_DOT] = ACTIONS(2819),
    [anon_sym_DASH_DOT] = ACTIONS(2819),
    [anon_sym_PERCENT] = ACTIONS(2819),
    [anon_sym_AMP_AMP] = ACTIONS(2819),
    [anon_sym_TILDE] = ACTIONS(2821),
    [aux_sym_prefix_op_token1] = ACTIONS(2819),
    [aux_sym_infix_op_token1] = ACTIONS(2821),
    [aux_sym_infix_op_token2] = ACTIONS(2819),
    [anon_sym_PIPE_PIPE] = ACTIONS(2819),
    [anon_sym_BANG_EQ] = ACTIONS(2819),
    [anon_sym_COLON_EQ] = ACTIONS(2821),
    [anon_sym_DOLLAR] = ACTIONS(2819),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2819),
    [sym_int] = ACTIONS(3634),
    [sym_xint] = ACTIONS(2821),
    [anon_sym_f] = ACTIONS(2819),
    [aux_sym_decimal_token1] = ACTIONS(2819),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2821),
    [sym__newline] = ACTIONS(2821),
  },
  [1435] = {
    [sym_block_comment] = STATE(1435),
    [sym_compiler_directive_decl] = STATE(1435),
    [sym_fsi_directive_decl] = STATE(1435),
    [sym_preproc_line] = STATE(1435),
    [sym_identifier] = ACTIONS(2770),
    [anon_sym_EQ] = ACTIONS(2772),
    [anon_sym_COLON] = ACTIONS(2770),
    [anon_sym_return] = ACTIONS(2770),
    [anon_sym_do] = ACTIONS(2770),
    [anon_sym_let] = ACTIONS(2770),
    [anon_sym_let_BANG] = ACTIONS(2772),
    [anon_sym_as] = ACTIONS(2770),
    [anon_sym_LPAREN] = ACTIONS(2770),
    [anon_sym_COMMA] = ACTIONS(2772),
    [anon_sym_null] = ACTIONS(2770),
    [anon_sym_QMARK] = ACTIONS(2770),
    [anon_sym_COLON_QMARK] = ACTIONS(2770),
    [anon_sym_COLON_COLON] = ACTIONS(2772),
    [anon_sym_AMP] = ACTIONS(2770),
    [anon_sym_LBRACK] = ACTIONS(2770),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2772),
    [anon_sym_LBRACE] = ACTIONS(2770),
    [anon_sym_LT_AT] = ACTIONS(2770),
    [anon_sym_LT_AT_AT] = ACTIONS(2770),
    [anon_sym_DOT] = ACTIONS(2770),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2772),
    [anon_sym_new] = ACTIONS(2770),
    [anon_sym_with] = ACTIONS(2770),
    [anon_sym_return_BANG] = ACTIONS(2772),
    [anon_sym_yield] = ACTIONS(2770),
    [anon_sym_yield_BANG] = ACTIONS(2772),
    [anon_sym_lazy] = ACTIONS(2770),
    [anon_sym_assert] = ACTIONS(2770),
    [anon_sym_upcast] = ACTIONS(2770),
    [anon_sym_downcast] = ACTIONS(2770),
    [anon_sym_COLON_GT] = ACTIONS(2772),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2772),
    [anon_sym_for] = ACTIONS(2770),
    [anon_sym_done] = ACTIONS(3636),
    [anon_sym_while] = ACTIONS(2770),
    [anon_sym_if] = ACTIONS(2770),
    [anon_sym_fun] = ACTIONS(2770),
    [anon_sym_try] = ACTIONS(2770),
    [anon_sym_match] = ACTIONS(2770),
    [anon_sym_match_BANG] = ACTIONS(2772),
    [anon_sym_function] = ACTIONS(2770),
    [anon_sym_LT_DASH] = ACTIONS(2770),
    [anon_sym_DOT_LBRACK] = ACTIONS(2772),
    [anon_sym_LT] = ACTIONS(2772),
    [anon_sym_use] = ACTIONS(2770),
    [anon_sym_use_BANG] = ACTIONS(2772),
    [anon_sym_do_BANG] = ACTIONS(2772),
    [anon_sym_begin] = ACTIONS(2770),
    [anon_sym_LPAREN2] = ACTIONS(2770),
    [anon_sym_or] = ACTIONS(2770),
    [aux_sym_char_token1] = ACTIONS(2772),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2770),
    [anon_sym_DQUOTE] = ACTIONS(2770),
    [anon_sym_AT_DQUOTE] = ACTIONS(2772),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2772),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2772),
    [sym_bool] = ACTIONS(2770),
    [sym_unit] = ACTIONS(2772),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2770),
    [sym_op_identifier] = ACTIONS(2770),
    [anon_sym_PLUS] = ACTIONS(2770),
    [anon_sym_DASH] = ACTIONS(2770),
    [anon_sym_PLUS_DOT] = ACTIONS(2770),
    [anon_sym_DASH_DOT] = ACTIONS(2770),
    [anon_sym_PERCENT] = ACTIONS(2770),
    [anon_sym_AMP_AMP] = ACTIONS(2770),
    [anon_sym_TILDE] = ACTIONS(2772),
    [aux_sym_prefix_op_token1] = ACTIONS(2770),
    [aux_sym_infix_op_token1] = ACTIONS(2772),
    [aux_sym_infix_op_token2] = ACTIONS(2770),
    [anon_sym_PIPE_PIPE] = ACTIONS(2770),
    [anon_sym_BANG_EQ] = ACTIONS(2770),
    [anon_sym_COLON_EQ] = ACTIONS(2772),
    [anon_sym_DOLLAR] = ACTIONS(2770),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2770),
    [sym_int] = ACTIONS(2770),
    [sym_xint] = ACTIONS(2772),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2772),
    [sym__newline] = ACTIONS(2772),
    [sym__dedent] = ACTIONS(2772),
  },
  [1436] = {
    [sym_block_comment] = STATE(1436),
    [sym_compiler_directive_decl] = STATE(1436),
    [sym_fsi_directive_decl] = STATE(1436),
    [sym_preproc_line] = STATE(1436),
    [sym_identifier] = ACTIONS(2819),
    [anon_sym_EQ] = ACTIONS(2821),
    [anon_sym_COLON] = ACTIONS(2819),
    [anon_sym_return] = ACTIONS(2819),
    [anon_sym_do] = ACTIONS(2819),
    [anon_sym_let] = ACTIONS(2819),
    [anon_sym_let_BANG] = ACTIONS(2821),
    [anon_sym_LPAREN] = ACTIONS(2819),
    [anon_sym_COMMA] = ACTIONS(2821),
    [anon_sym_null] = ACTIONS(2819),
    [anon_sym_QMARK] = ACTIONS(2819),
    [anon_sym_COLON_QMARK] = ACTIONS(2819),
    [anon_sym_COLON_COLON] = ACTIONS(2821),
    [anon_sym_AMP] = ACTIONS(2819),
    [anon_sym_LBRACK] = ACTIONS(2819),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2821),
    [anon_sym_LBRACE] = ACTIONS(2819),
    [anon_sym_LT_AT] = ACTIONS(2819),
    [anon_sym_LT_AT_AT] = ACTIONS(2819),
    [anon_sym_DOT] = ACTIONS(2819),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2821),
    [anon_sym_new] = ACTIONS(2819),
    [anon_sym_return_BANG] = ACTIONS(2821),
    [anon_sym_yield] = ACTIONS(2819),
    [anon_sym_yield_BANG] = ACTIONS(2821),
    [anon_sym_lazy] = ACTIONS(2819),
    [anon_sym_assert] = ACTIONS(2819),
    [anon_sym_upcast] = ACTIONS(2819),
    [anon_sym_downcast] = ACTIONS(2819),
    [anon_sym_COLON_GT] = ACTIONS(2821),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2821),
    [anon_sym_for] = ACTIONS(2819),
    [anon_sym_while] = ACTIONS(2819),
    [anon_sym_if] = ACTIONS(2819),
    [anon_sym_fun] = ACTIONS(2819),
    [anon_sym_try] = ACTIONS(2819),
    [anon_sym_match] = ACTIONS(2819),
    [anon_sym_match_BANG] = ACTIONS(2821),
    [anon_sym_function] = ACTIONS(2819),
    [anon_sym_LT_DASH] = ACTIONS(2819),
    [anon_sym_DOT_LBRACK] = ACTIONS(2821),
    [anon_sym_LT] = ACTIONS(2821),
    [anon_sym_use] = ACTIONS(2819),
    [anon_sym_use_BANG] = ACTIONS(2821),
    [anon_sym_do_BANG] = ACTIONS(2821),
    [anon_sym_begin] = ACTIONS(2819),
    [anon_sym_LPAREN2] = ACTIONS(2819),
    [anon_sym_or] = ACTIONS(2819),
    [aux_sym_char_token1] = ACTIONS(2821),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2819),
    [anon_sym_DQUOTE] = ACTIONS(2819),
    [anon_sym_AT_DQUOTE] = ACTIONS(2821),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2821),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2821),
    [sym_bool] = ACTIONS(2819),
    [sym_unit] = ACTIONS(2821),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2819),
    [sym_op_identifier] = ACTIONS(2819),
    [anon_sym_PLUS] = ACTIONS(2819),
    [anon_sym_DASH] = ACTIONS(2819),
    [anon_sym_PLUS_DOT] = ACTIONS(2819),
    [anon_sym_DASH_DOT] = ACTIONS(2819),
    [anon_sym_PERCENT] = ACTIONS(2819),
    [anon_sym_AMP_AMP] = ACTIONS(2819),
    [anon_sym_TILDE] = ACTIONS(2821),
    [aux_sym_prefix_op_token1] = ACTIONS(2819),
    [aux_sym_infix_op_token1] = ACTIONS(2821),
    [aux_sym_infix_op_token2] = ACTIONS(2819),
    [anon_sym_PIPE_PIPE] = ACTIONS(2819),
    [anon_sym_BANG_EQ] = ACTIONS(2819),
    [anon_sym_COLON_EQ] = ACTIONS(2821),
    [anon_sym_DOLLAR] = ACTIONS(2819),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2819),
    [sym_int] = ACTIONS(3638),
    [sym_xint] = ACTIONS(2821),
    [anon_sym_f] = ACTIONS(2819),
    [aux_sym_decimal_token1] = ACTIONS(2819),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2821),
    [anon_sym_POUNDendif] = ACTIONS(2821),
    [anon_sym_POUNDelse] = ACTIONS(2821),
    [sym__newline] = ACTIONS(2821),
  },
  [1437] = {
    [sym_block_comment] = STATE(1437),
    [sym_compiler_directive_decl] = STATE(1437),
    [sym_fsi_directive_decl] = STATE(1437),
    [sym_preproc_line] = STATE(1437),
    [aux_sym_sequential_expression_repeat1] = STATE(1426),
    [sym_identifier] = ACTIONS(2847),
    [anon_sym_EQ] = ACTIONS(2849),
    [anon_sym_COLON] = ACTIONS(2847),
    [anon_sym_return] = ACTIONS(2847),
    [anon_sym_do] = ACTIONS(2847),
    [anon_sym_let] = ACTIONS(2847),
    [anon_sym_let_BANG] = ACTIONS(2849),
    [anon_sym_as] = ACTIONS(2847),
    [anon_sym_LPAREN] = ACTIONS(2847),
    [anon_sym_COMMA] = ACTIONS(2849),
    [anon_sym_null] = ACTIONS(2847),
    [anon_sym_QMARK] = ACTIONS(2847),
    [anon_sym_COLON_QMARK] = ACTIONS(2847),
    [anon_sym_COLON_COLON] = ACTIONS(2849),
    [anon_sym_AMP] = ACTIONS(2847),
    [anon_sym_LBRACK] = ACTIONS(2847),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2849),
    [anon_sym_LBRACE] = ACTIONS(2847),
    [anon_sym_LT_AT] = ACTIONS(2847),
    [anon_sym_LT_AT_AT] = ACTIONS(2847),
    [anon_sym_DOT] = ACTIONS(2847),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2849),
    [anon_sym_new] = ACTIONS(2847),
    [anon_sym_with] = ACTIONS(2847),
    [anon_sym_return_BANG] = ACTIONS(2849),
    [anon_sym_yield] = ACTIONS(2847),
    [anon_sym_yield_BANG] = ACTIONS(2849),
    [anon_sym_lazy] = ACTIONS(2847),
    [anon_sym_assert] = ACTIONS(2847),
    [anon_sym_upcast] = ACTIONS(2847),
    [anon_sym_downcast] = ACTIONS(2847),
    [anon_sym_COLON_GT] = ACTIONS(2849),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2849),
    [anon_sym_for] = ACTIONS(2847),
    [anon_sym_while] = ACTIONS(2847),
    [anon_sym_if] = ACTIONS(2847),
    [anon_sym_fun] = ACTIONS(2847),
    [anon_sym_try] = ACTIONS(2847),
    [anon_sym_match] = ACTIONS(2847),
    [anon_sym_match_BANG] = ACTIONS(2849),
    [anon_sym_function] = ACTIONS(2847),
    [anon_sym_LT_DASH] = ACTIONS(2847),
    [anon_sym_DOT_LBRACK] = ACTIONS(2849),
    [anon_sym_LT] = ACTIONS(2849),
    [anon_sym_use] = ACTIONS(2847),
    [anon_sym_use_BANG] = ACTIONS(2849),
    [anon_sym_do_BANG] = ACTIONS(2849),
    [anon_sym_begin] = ACTIONS(2847),
    [anon_sym_LPAREN2] = ACTIONS(2847),
    [anon_sym_or] = ACTIONS(2847),
    [aux_sym_char_token1] = ACTIONS(2849),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2847),
    [anon_sym_DQUOTE] = ACTIONS(2847),
    [anon_sym_AT_DQUOTE] = ACTIONS(2849),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2849),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2849),
    [sym_bool] = ACTIONS(2847),
    [sym_unit] = ACTIONS(2849),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2847),
    [sym_op_identifier] = ACTIONS(2847),
    [anon_sym_PLUS] = ACTIONS(2847),
    [anon_sym_DASH] = ACTIONS(2847),
    [anon_sym_PLUS_DOT] = ACTIONS(2847),
    [anon_sym_DASH_DOT] = ACTIONS(2847),
    [anon_sym_PERCENT] = ACTIONS(2847),
    [anon_sym_AMP_AMP] = ACTIONS(2847),
    [anon_sym_TILDE] = ACTIONS(2849),
    [aux_sym_prefix_op_token1] = ACTIONS(2847),
    [aux_sym_infix_op_token1] = ACTIONS(2849),
    [aux_sym_infix_op_token2] = ACTIONS(2847),
    [anon_sym_PIPE_PIPE] = ACTIONS(2847),
    [anon_sym_BANG_EQ] = ACTIONS(2847),
    [anon_sym_COLON_EQ] = ACTIONS(2849),
    [anon_sym_DOLLAR] = ACTIONS(2847),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2847),
    [sym_int] = ACTIONS(2847),
    [sym_xint] = ACTIONS(2849),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2849),
    [sym__newline] = ACTIONS(2849),
    [sym__dedent] = ACTIONS(2849),
  },
  [1438] = {
    [sym_block_comment] = STATE(1438),
    [sym_compiler_directive_decl] = STATE(1438),
    [sym_fsi_directive_decl] = STATE(1438),
    [sym_preproc_line] = STATE(1438),
    [sym_identifier] = ACTIONS(2158),
    [anon_sym_EQ] = ACTIONS(2160),
    [anon_sym_COLON] = ACTIONS(2158),
    [anon_sym_return] = ACTIONS(2158),
    [anon_sym_do] = ACTIONS(2158),
    [anon_sym_and] = ACTIONS(2158),
    [anon_sym_let] = ACTIONS(2158),
    [anon_sym_let_BANG] = ACTIONS(2160),
    [anon_sym_LPAREN] = ACTIONS(2158),
    [anon_sym_COMMA] = ACTIONS(2160),
    [anon_sym_null] = ACTIONS(2158),
    [anon_sym_QMARK] = ACTIONS(2158),
    [anon_sym_COLON_QMARK] = ACTIONS(2158),
    [anon_sym_COLON_COLON] = ACTIONS(2160),
    [anon_sym_AMP] = ACTIONS(2158),
    [anon_sym_LBRACK] = ACTIONS(2158),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2160),
    [anon_sym_LBRACE] = ACTIONS(2158),
    [anon_sym_LT_AT] = ACTIONS(2158),
    [anon_sym_LT_AT_AT] = ACTIONS(2158),
    [anon_sym_DOT] = ACTIONS(2158),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2160),
    [anon_sym_new] = ACTIONS(2158),
    [anon_sym_return_BANG] = ACTIONS(2160),
    [anon_sym_yield] = ACTIONS(2158),
    [anon_sym_yield_BANG] = ACTIONS(2160),
    [anon_sym_lazy] = ACTIONS(2158),
    [anon_sym_assert] = ACTIONS(2158),
    [anon_sym_upcast] = ACTIONS(2158),
    [anon_sym_downcast] = ACTIONS(2158),
    [anon_sym_COLON_GT] = ACTIONS(2160),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2160),
    [anon_sym_for] = ACTIONS(2158),
    [anon_sym_while] = ACTIONS(2158),
    [anon_sym_if] = ACTIONS(2158),
    [anon_sym_fun] = ACTIONS(2158),
    [anon_sym_try] = ACTIONS(2158),
    [anon_sym_match] = ACTIONS(2158),
    [anon_sym_match_BANG] = ACTIONS(2160),
    [anon_sym_function] = ACTIONS(2158),
    [anon_sym_LT_DASH] = ACTIONS(2158),
    [anon_sym_DOT_LBRACK] = ACTIONS(2160),
    [anon_sym_LT] = ACTIONS(2160),
    [anon_sym_use] = ACTIONS(2158),
    [anon_sym_use_BANG] = ACTIONS(2160),
    [anon_sym_do_BANG] = ACTIONS(2160),
    [anon_sym_begin] = ACTIONS(2158),
    [anon_sym_LPAREN2] = ACTIONS(2158),
    [anon_sym_or] = ACTIONS(2158),
    [aux_sym_char_token1] = ACTIONS(2160),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2158),
    [anon_sym_DQUOTE] = ACTIONS(2158),
    [anon_sym_AT_DQUOTE] = ACTIONS(2160),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2160),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2160),
    [sym_bool] = ACTIONS(2158),
    [sym_unit] = ACTIONS(2160),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2158),
    [sym_op_identifier] = ACTIONS(2158),
    [anon_sym_PLUS] = ACTIONS(2158),
    [anon_sym_DASH] = ACTIONS(2158),
    [anon_sym_PLUS_DOT] = ACTIONS(2158),
    [anon_sym_DASH_DOT] = ACTIONS(2158),
    [anon_sym_PERCENT] = ACTIONS(2158),
    [anon_sym_AMP_AMP] = ACTIONS(2158),
    [anon_sym_TILDE] = ACTIONS(2160),
    [aux_sym_prefix_op_token1] = ACTIONS(2158),
    [aux_sym_infix_op_token1] = ACTIONS(2160),
    [aux_sym_infix_op_token2] = ACTIONS(2158),
    [anon_sym_PIPE_PIPE] = ACTIONS(2158),
    [anon_sym_BANG_EQ] = ACTIONS(2158),
    [anon_sym_COLON_EQ] = ACTIONS(2160),
    [anon_sym_DOLLAR] = ACTIONS(2158),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2158),
    [sym_int] = ACTIONS(2158),
    [sym_xint] = ACTIONS(2160),
    [anon_sym_f] = ACTIONS(2681),
    [aux_sym_decimal_token1] = ACTIONS(2369),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2160),
    [sym__newline] = ACTIONS(2160),
    [sym__dedent] = ACTIONS(2160),
  },
  [1439] = {
    [sym_block_comment] = STATE(1439),
    [sym_compiler_directive_decl] = STATE(1439),
    [sym_fsi_directive_decl] = STATE(1439),
    [sym_preproc_line] = STATE(1439),
    [sym_identifier] = ACTIONS(2723),
    [anon_sym_EQ] = ACTIONS(2725),
    [anon_sym_COLON] = ACTIONS(2723),
    [anon_sym_return] = ACTIONS(2723),
    [anon_sym_do] = ACTIONS(2723),
    [anon_sym_let] = ACTIONS(2723),
    [anon_sym_let_BANG] = ACTIONS(2725),
    [anon_sym_LPAREN] = ACTIONS(2723),
    [anon_sym_COMMA] = ACTIONS(2725),
    [anon_sym_null] = ACTIONS(2723),
    [anon_sym_QMARK] = ACTIONS(2723),
    [anon_sym_COLON_QMARK] = ACTIONS(2723),
    [anon_sym_COLON_COLON] = ACTIONS(2725),
    [anon_sym_AMP] = ACTIONS(2723),
    [anon_sym_LBRACK] = ACTIONS(2723),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2725),
    [anon_sym_LBRACE] = ACTIONS(2723),
    [anon_sym_LT_AT] = ACTIONS(2723),
    [anon_sym_LT_AT_AT] = ACTIONS(2723),
    [anon_sym_DOT] = ACTIONS(2723),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2725),
    [anon_sym_new] = ACTIONS(2723),
    [anon_sym_return_BANG] = ACTIONS(2725),
    [anon_sym_yield] = ACTIONS(2723),
    [anon_sym_yield_BANG] = ACTIONS(2725),
    [anon_sym_lazy] = ACTIONS(2723),
    [anon_sym_assert] = ACTIONS(2723),
    [anon_sym_upcast] = ACTIONS(2723),
    [anon_sym_downcast] = ACTIONS(2723),
    [anon_sym_COLON_GT] = ACTIONS(2725),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2725),
    [anon_sym_for] = ACTIONS(2723),
    [anon_sym_while] = ACTIONS(2723),
    [anon_sym_if] = ACTIONS(2723),
    [anon_sym_fun] = ACTIONS(2723),
    [anon_sym_try] = ACTIONS(2723),
    [anon_sym_match] = ACTIONS(2723),
    [anon_sym_match_BANG] = ACTIONS(2725),
    [anon_sym_function] = ACTIONS(2723),
    [anon_sym_LT_DASH] = ACTIONS(2723),
    [anon_sym_DOT_LBRACK] = ACTIONS(2725),
    [anon_sym_LT] = ACTIONS(2725),
    [anon_sym_use] = ACTIONS(2723),
    [anon_sym_use_BANG] = ACTIONS(2725),
    [anon_sym_do_BANG] = ACTIONS(2725),
    [anon_sym_begin] = ACTIONS(2723),
    [anon_sym_LPAREN2] = ACTIONS(2723),
    [anon_sym_or] = ACTIONS(2723),
    [aux_sym_char_token1] = ACTIONS(2725),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2723),
    [anon_sym_DQUOTE] = ACTIONS(2723),
    [anon_sym_AT_DQUOTE] = ACTIONS(2725),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2725),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2725),
    [sym_bool] = ACTIONS(2723),
    [sym_unit] = ACTIONS(2725),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2723),
    [sym_op_identifier] = ACTIONS(2723),
    [anon_sym_PLUS] = ACTIONS(2723),
    [anon_sym_DASH] = ACTIONS(2723),
    [anon_sym_PLUS_DOT] = ACTIONS(2723),
    [anon_sym_DASH_DOT] = ACTIONS(2723),
    [anon_sym_PERCENT] = ACTIONS(2723),
    [anon_sym_AMP_AMP] = ACTIONS(2723),
    [anon_sym_TILDE] = ACTIONS(2725),
    [aux_sym_prefix_op_token1] = ACTIONS(2723),
    [aux_sym_infix_op_token1] = ACTIONS(2725),
    [aux_sym_infix_op_token2] = ACTIONS(2723),
    [anon_sym_PIPE_PIPE] = ACTIONS(2723),
    [anon_sym_BANG_EQ] = ACTIONS(2723),
    [anon_sym_COLON_EQ] = ACTIONS(2725),
    [anon_sym_DOLLAR] = ACTIONS(2723),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2723),
    [sym_int] = ACTIONS(2723),
    [sym_xint] = ACTIONS(2725),
    [anon_sym_f] = ACTIONS(2723),
    [aux_sym_decimal_token1] = ACTIONS(2723),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2725),
    [anon_sym_POUNDendif] = ACTIONS(2725),
    [anon_sym_POUNDelse] = ACTIONS(2725),
    [sym__newline] = ACTIONS(2725),
  },
  [1440] = {
    [sym_block_comment] = STATE(1440),
    [sym_compiler_directive_decl] = STATE(1440),
    [sym_fsi_directive_decl] = STATE(1440),
    [sym_preproc_line] = STATE(1440),
    [sym_identifier] = ACTIONS(2685),
    [anon_sym_EQ] = ACTIONS(2687),
    [anon_sym_COLON] = ACTIONS(2685),
    [anon_sym_return] = ACTIONS(2685),
    [anon_sym_do] = ACTIONS(2685),
    [anon_sym_let] = ACTIONS(2685),
    [anon_sym_let_BANG] = ACTIONS(2687),
    [anon_sym_LPAREN] = ACTIONS(2685),
    [anon_sym_COMMA] = ACTIONS(2687),
    [anon_sym_null] = ACTIONS(2685),
    [anon_sym_QMARK] = ACTIONS(2685),
    [anon_sym_COLON_QMARK] = ACTIONS(2685),
    [anon_sym_COLON_COLON] = ACTIONS(2687),
    [anon_sym_AMP] = ACTIONS(2685),
    [anon_sym_LBRACK] = ACTIONS(2685),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2687),
    [anon_sym_LBRACE] = ACTIONS(2685),
    [anon_sym_LT_AT] = ACTIONS(2685),
    [anon_sym_LT_AT_AT] = ACTIONS(2685),
    [anon_sym_DOT] = ACTIONS(2685),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2687),
    [anon_sym_new] = ACTIONS(2685),
    [anon_sym_return_BANG] = ACTIONS(2687),
    [anon_sym_yield] = ACTIONS(2685),
    [anon_sym_yield_BANG] = ACTIONS(2687),
    [anon_sym_lazy] = ACTIONS(2685),
    [anon_sym_assert] = ACTIONS(2685),
    [anon_sym_upcast] = ACTIONS(2685),
    [anon_sym_downcast] = ACTIONS(2685),
    [anon_sym_COLON_GT] = ACTIONS(2687),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2687),
    [anon_sym_for] = ACTIONS(2685),
    [anon_sym_done] = ACTIONS(2685),
    [anon_sym_while] = ACTIONS(2685),
    [anon_sym_if] = ACTIONS(2685),
    [anon_sym_fun] = ACTIONS(2685),
    [anon_sym_try] = ACTIONS(2685),
    [anon_sym_match] = ACTIONS(2685),
    [anon_sym_match_BANG] = ACTIONS(2687),
    [anon_sym_function] = ACTIONS(2685),
    [anon_sym_LT_DASH] = ACTIONS(2685),
    [anon_sym_DOT_LBRACK] = ACTIONS(2687),
    [anon_sym_LT] = ACTIONS(2687),
    [anon_sym_use] = ACTIONS(2685),
    [anon_sym_use_BANG] = ACTIONS(2687),
    [anon_sym_do_BANG] = ACTIONS(2687),
    [anon_sym_DOT_DOT] = ACTIONS(2687),
    [anon_sym_begin] = ACTIONS(2685),
    [anon_sym_LPAREN2] = ACTIONS(2685),
    [anon_sym_or] = ACTIONS(2685),
    [aux_sym_char_token1] = ACTIONS(2687),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2685),
    [anon_sym_DQUOTE] = ACTIONS(2685),
    [anon_sym_AT_DQUOTE] = ACTIONS(2687),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2687),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2687),
    [sym_bool] = ACTIONS(2685),
    [sym_unit] = ACTIONS(2687),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2685),
    [sym_op_identifier] = ACTIONS(2685),
    [anon_sym_PLUS] = ACTIONS(2685),
    [anon_sym_DASH] = ACTIONS(2685),
    [anon_sym_PLUS_DOT] = ACTIONS(2685),
    [anon_sym_DASH_DOT] = ACTIONS(2685),
    [anon_sym_PERCENT] = ACTIONS(2685),
    [anon_sym_AMP_AMP] = ACTIONS(2685),
    [anon_sym_TILDE] = ACTIONS(2687),
    [aux_sym_prefix_op_token1] = ACTIONS(2685),
    [aux_sym_infix_op_token1] = ACTIONS(2687),
    [aux_sym_infix_op_token2] = ACTIONS(2685),
    [anon_sym_PIPE_PIPE] = ACTIONS(2685),
    [anon_sym_BANG_EQ] = ACTIONS(2685),
    [anon_sym_COLON_EQ] = ACTIONS(2687),
    [anon_sym_DOLLAR] = ACTIONS(2685),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2685),
    [sym_int] = ACTIONS(2685),
    [sym_xint] = ACTIONS(2687),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2687),
    [anon_sym_POUNDendif] = ACTIONS(2687),
    [anon_sym_POUNDelse] = ACTIONS(2687),
    [sym__newline] = ACTIONS(2687),
  },
  [1441] = {
    [sym_block_comment] = STATE(1441),
    [sym_compiler_directive_decl] = STATE(1441),
    [sym_fsi_directive_decl] = STATE(1441),
    [sym_preproc_line] = STATE(1441),
    [sym_identifier] = ACTIONS(2812),
    [anon_sym_EQ] = ACTIONS(2814),
    [anon_sym_COLON] = ACTIONS(2812),
    [anon_sym_return] = ACTIONS(2812),
    [anon_sym_do] = ACTIONS(2812),
    [anon_sym_let] = ACTIONS(2812),
    [anon_sym_let_BANG] = ACTIONS(2814),
    [anon_sym_LPAREN] = ACTIONS(2812),
    [anon_sym_COMMA] = ACTIONS(2814),
    [anon_sym_null] = ACTIONS(2812),
    [anon_sym_QMARK] = ACTIONS(2812),
    [anon_sym_COLON_QMARK] = ACTIONS(2812),
    [anon_sym_COLON_COLON] = ACTIONS(2814),
    [anon_sym_AMP] = ACTIONS(2812),
    [anon_sym_LBRACK] = ACTIONS(2812),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2814),
    [anon_sym_LBRACE] = ACTIONS(2812),
    [anon_sym_LT_AT] = ACTIONS(2812),
    [anon_sym_LT_AT_AT] = ACTIONS(2812),
    [anon_sym_DOT] = ACTIONS(2812),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2814),
    [anon_sym_new] = ACTIONS(2812),
    [anon_sym_return_BANG] = ACTIONS(2814),
    [anon_sym_yield] = ACTIONS(2812),
    [anon_sym_yield_BANG] = ACTIONS(2814),
    [anon_sym_lazy] = ACTIONS(2812),
    [anon_sym_assert] = ACTIONS(2812),
    [anon_sym_upcast] = ACTIONS(2812),
    [anon_sym_downcast] = ACTIONS(2812),
    [anon_sym_COLON_GT] = ACTIONS(2814),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2814),
    [anon_sym_for] = ACTIONS(2812),
    [anon_sym_while] = ACTIONS(2812),
    [anon_sym_if] = ACTIONS(2812),
    [anon_sym_fun] = ACTIONS(2812),
    [anon_sym_try] = ACTIONS(2812),
    [anon_sym_match] = ACTIONS(2812),
    [anon_sym_match_BANG] = ACTIONS(2814),
    [anon_sym_function] = ACTIONS(2812),
    [anon_sym_LT_DASH] = ACTIONS(2812),
    [anon_sym_DOT_LBRACK] = ACTIONS(2814),
    [anon_sym_LT] = ACTIONS(2814),
    [anon_sym_use] = ACTIONS(2812),
    [anon_sym_use_BANG] = ACTIONS(2814),
    [anon_sym_do_BANG] = ACTIONS(2814),
    [anon_sym_begin] = ACTIONS(2812),
    [anon_sym_LPAREN2] = ACTIONS(2812),
    [anon_sym_or] = ACTIONS(2812),
    [aux_sym_char_token1] = ACTIONS(2814),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2812),
    [anon_sym_DQUOTE] = ACTIONS(2812),
    [anon_sym_AT_DQUOTE] = ACTIONS(2814),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2814),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2814),
    [sym_bool] = ACTIONS(2812),
    [sym_unit] = ACTIONS(2814),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2812),
    [sym_op_identifier] = ACTIONS(2812),
    [anon_sym_PLUS] = ACTIONS(2812),
    [anon_sym_DASH] = ACTIONS(2812),
    [anon_sym_PLUS_DOT] = ACTIONS(2812),
    [anon_sym_DASH_DOT] = ACTIONS(2812),
    [anon_sym_PERCENT] = ACTIONS(2812),
    [anon_sym_AMP_AMP] = ACTIONS(2812),
    [anon_sym_TILDE] = ACTIONS(2814),
    [aux_sym_prefix_op_token1] = ACTIONS(2812),
    [aux_sym_infix_op_token1] = ACTIONS(2814),
    [aux_sym_infix_op_token2] = ACTIONS(2812),
    [anon_sym_PIPE_PIPE] = ACTIONS(2812),
    [anon_sym_BANG_EQ] = ACTIONS(2812),
    [anon_sym_COLON_EQ] = ACTIONS(2814),
    [anon_sym_DOLLAR] = ACTIONS(2812),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2812),
    [sym_int] = ACTIONS(2812),
    [sym_xint] = ACTIONS(2814),
    [anon_sym_f] = ACTIONS(2812),
    [aux_sym_decimal_token1] = ACTIONS(2812),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2814),
    [anon_sym_POUNDendif] = ACTIONS(2814),
    [anon_sym_POUNDelse] = ACTIONS(2814),
    [sym__newline] = ACTIONS(2814),
  },
  [1442] = {
    [sym_block_comment] = STATE(1442),
    [sym_compiler_directive_decl] = STATE(1442),
    [sym_fsi_directive_decl] = STATE(1442),
    [sym_preproc_line] = STATE(1442),
    [sym_identifier] = ACTIONS(2723),
    [anon_sym_EQ] = ACTIONS(2725),
    [anon_sym_COLON] = ACTIONS(2723),
    [anon_sym_return] = ACTIONS(2723),
    [anon_sym_do] = ACTIONS(2723),
    [anon_sym_let] = ACTIONS(2723),
    [anon_sym_let_BANG] = ACTIONS(2725),
    [anon_sym_LPAREN] = ACTIONS(2723),
    [anon_sym_COMMA] = ACTIONS(2725),
    [anon_sym_null] = ACTIONS(2723),
    [anon_sym_QMARK] = ACTIONS(2723),
    [anon_sym_COLON_QMARK] = ACTIONS(2723),
    [anon_sym_COLON_COLON] = ACTIONS(2725),
    [anon_sym_AMP] = ACTIONS(2723),
    [anon_sym_LBRACK] = ACTIONS(2723),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2725),
    [anon_sym_LBRACE] = ACTIONS(2723),
    [anon_sym_LT_AT] = ACTIONS(2723),
    [anon_sym_LT_AT_AT] = ACTIONS(2723),
    [anon_sym_DOT] = ACTIONS(2723),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2725),
    [anon_sym_new] = ACTIONS(2723),
    [anon_sym_return_BANG] = ACTIONS(2725),
    [anon_sym_yield] = ACTIONS(2723),
    [anon_sym_yield_BANG] = ACTIONS(2725),
    [anon_sym_lazy] = ACTIONS(2723),
    [anon_sym_assert] = ACTIONS(2723),
    [anon_sym_upcast] = ACTIONS(2723),
    [anon_sym_downcast] = ACTIONS(2723),
    [anon_sym_COLON_GT] = ACTIONS(2725),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2725),
    [anon_sym_for] = ACTIONS(2723),
    [anon_sym_while] = ACTIONS(2723),
    [anon_sym_if] = ACTIONS(2723),
    [anon_sym_fun] = ACTIONS(2723),
    [anon_sym_try] = ACTIONS(2723),
    [anon_sym_match] = ACTIONS(2723),
    [anon_sym_match_BANG] = ACTIONS(2725),
    [anon_sym_function] = ACTIONS(2723),
    [anon_sym_LT_DASH] = ACTIONS(2723),
    [anon_sym_DOT_LBRACK] = ACTIONS(2725),
    [anon_sym_LT] = ACTIONS(2725),
    [anon_sym_use] = ACTIONS(2723),
    [anon_sym_use_BANG] = ACTIONS(2725),
    [anon_sym_do_BANG] = ACTIONS(2725),
    [anon_sym_DOT_DOT] = ACTIONS(2725),
    [anon_sym_begin] = ACTIONS(2723),
    [anon_sym_LPAREN2] = ACTIONS(2723),
    [anon_sym_or] = ACTIONS(2723),
    [aux_sym_char_token1] = ACTIONS(2725),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2723),
    [anon_sym_DQUOTE] = ACTIONS(2723),
    [anon_sym_AT_DQUOTE] = ACTIONS(2725),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2725),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2725),
    [sym_bool] = ACTIONS(2723),
    [sym_unit] = ACTIONS(2725),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2723),
    [sym_op_identifier] = ACTIONS(2723),
    [anon_sym_PLUS] = ACTIONS(2723),
    [anon_sym_DASH] = ACTIONS(2723),
    [anon_sym_PLUS_DOT] = ACTIONS(2723),
    [anon_sym_DASH_DOT] = ACTIONS(2723),
    [anon_sym_PERCENT] = ACTIONS(2723),
    [anon_sym_AMP_AMP] = ACTIONS(2723),
    [anon_sym_TILDE] = ACTIONS(2725),
    [aux_sym_prefix_op_token1] = ACTIONS(2723),
    [aux_sym_infix_op_token1] = ACTIONS(2725),
    [aux_sym_infix_op_token2] = ACTIONS(2723),
    [anon_sym_PIPE_PIPE] = ACTIONS(2723),
    [anon_sym_BANG_EQ] = ACTIONS(2723),
    [anon_sym_COLON_EQ] = ACTIONS(2725),
    [anon_sym_DOLLAR] = ACTIONS(2723),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2723),
    [sym_int] = ACTIONS(2723),
    [sym_xint] = ACTIONS(2725),
    [anon_sym_f] = ACTIONS(2723),
    [aux_sym_decimal_token1] = ACTIONS(2723),
    [aux_sym_float_token1] = ACTIONS(3640),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2725),
    [sym__newline] = ACTIONS(2725),
  },
  [1443] = {
    [sym_block_comment] = STATE(1443),
    [sym_compiler_directive_decl] = STATE(1443),
    [sym_fsi_directive_decl] = STATE(1443),
    [sym_preproc_line] = STATE(1443),
    [sym_identifier] = ACTIONS(2783),
    [anon_sym_EQ] = ACTIONS(2785),
    [anon_sym_COLON] = ACTIONS(2783),
    [anon_sym_return] = ACTIONS(2783),
    [anon_sym_do] = ACTIONS(2783),
    [anon_sym_and] = ACTIONS(2783),
    [anon_sym_let] = ACTIONS(2783),
    [anon_sym_let_BANG] = ACTIONS(2785),
    [anon_sym_LPAREN] = ACTIONS(2783),
    [anon_sym_COMMA] = ACTIONS(2785),
    [anon_sym_null] = ACTIONS(2783),
    [anon_sym_QMARK] = ACTIONS(2783),
    [anon_sym_COLON_QMARK] = ACTIONS(2783),
    [anon_sym_COLON_COLON] = ACTIONS(2785),
    [anon_sym_AMP] = ACTIONS(2783),
    [anon_sym_LBRACK] = ACTIONS(2783),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2785),
    [anon_sym_LBRACE] = ACTIONS(2783),
    [anon_sym_LT_AT] = ACTIONS(2783),
    [anon_sym_LT_AT_AT] = ACTIONS(2783),
    [anon_sym_DOT] = ACTIONS(2783),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2785),
    [anon_sym_new] = ACTIONS(2783),
    [anon_sym_return_BANG] = ACTIONS(2785),
    [anon_sym_yield] = ACTIONS(2783),
    [anon_sym_yield_BANG] = ACTIONS(2785),
    [anon_sym_lazy] = ACTIONS(2783),
    [anon_sym_assert] = ACTIONS(2783),
    [anon_sym_upcast] = ACTIONS(2783),
    [anon_sym_downcast] = ACTIONS(2783),
    [anon_sym_COLON_GT] = ACTIONS(2785),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2785),
    [anon_sym_for] = ACTIONS(2783),
    [anon_sym_done] = ACTIONS(3642),
    [anon_sym_while] = ACTIONS(2783),
    [anon_sym_if] = ACTIONS(2783),
    [anon_sym_fun] = ACTIONS(2783),
    [anon_sym_try] = ACTIONS(2783),
    [anon_sym_match] = ACTIONS(2783),
    [anon_sym_match_BANG] = ACTIONS(2785),
    [anon_sym_function] = ACTIONS(2783),
    [anon_sym_LT_DASH] = ACTIONS(2783),
    [anon_sym_DOT_LBRACK] = ACTIONS(2785),
    [anon_sym_LT] = ACTIONS(2785),
    [anon_sym_use] = ACTIONS(2783),
    [anon_sym_use_BANG] = ACTIONS(2785),
    [anon_sym_do_BANG] = ACTIONS(2785),
    [anon_sym_DOT_DOT] = ACTIONS(2789),
    [anon_sym_begin] = ACTIONS(2783),
    [anon_sym_LPAREN2] = ACTIONS(2783),
    [anon_sym_or] = ACTIONS(2783),
    [aux_sym_char_token1] = ACTIONS(2785),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2783),
    [anon_sym_DQUOTE] = ACTIONS(2783),
    [anon_sym_AT_DQUOTE] = ACTIONS(2785),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2785),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2785),
    [sym_bool] = ACTIONS(2783),
    [sym_unit] = ACTIONS(2785),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2783),
    [sym_op_identifier] = ACTIONS(2783),
    [anon_sym_PLUS] = ACTIONS(2783),
    [anon_sym_DASH] = ACTIONS(2783),
    [anon_sym_PLUS_DOT] = ACTIONS(2783),
    [anon_sym_DASH_DOT] = ACTIONS(2783),
    [anon_sym_PERCENT] = ACTIONS(2783),
    [anon_sym_AMP_AMP] = ACTIONS(2783),
    [anon_sym_TILDE] = ACTIONS(2785),
    [aux_sym_prefix_op_token1] = ACTIONS(2783),
    [aux_sym_infix_op_token1] = ACTIONS(2785),
    [aux_sym_infix_op_token2] = ACTIONS(2783),
    [anon_sym_PIPE_PIPE] = ACTIONS(2783),
    [anon_sym_BANG_EQ] = ACTIONS(2783),
    [anon_sym_COLON_EQ] = ACTIONS(2785),
    [anon_sym_DOLLAR] = ACTIONS(2783),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2783),
    [sym_int] = ACTIONS(2783),
    [sym_xint] = ACTIONS(2785),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2785),
    [sym__newline] = ACTIONS(2785),
    [sym__dedent] = ACTIONS(2785),
  },
  [1444] = {
    [sym_block_comment] = STATE(1444),
    [sym_compiler_directive_decl] = STATE(1444),
    [sym_fsi_directive_decl] = STATE(1444),
    [sym_preproc_line] = STATE(1444),
    [sym_identifier] = ACTIONS(2819),
    [anon_sym_EQ] = ACTIONS(2821),
    [anon_sym_COLON] = ACTIONS(2819),
    [anon_sym_return] = ACTIONS(2819),
    [anon_sym_do] = ACTIONS(2819),
    [anon_sym_and] = ACTIONS(2819),
    [anon_sym_let] = ACTIONS(2819),
    [anon_sym_let_BANG] = ACTIONS(2821),
    [anon_sym_LPAREN] = ACTIONS(2819),
    [anon_sym_COMMA] = ACTIONS(2821),
    [anon_sym_null] = ACTIONS(2819),
    [anon_sym_QMARK] = ACTIONS(2819),
    [anon_sym_COLON_QMARK] = ACTIONS(2819),
    [anon_sym_COLON_COLON] = ACTIONS(2821),
    [anon_sym_AMP] = ACTIONS(2819),
    [anon_sym_LBRACK] = ACTIONS(2819),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2821),
    [anon_sym_LBRACE] = ACTIONS(2819),
    [anon_sym_LT_AT] = ACTIONS(2819),
    [anon_sym_LT_AT_AT] = ACTIONS(2819),
    [anon_sym_DOT] = ACTIONS(2819),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2821),
    [anon_sym_new] = ACTIONS(2819),
    [anon_sym_return_BANG] = ACTIONS(2821),
    [anon_sym_yield] = ACTIONS(2819),
    [anon_sym_yield_BANG] = ACTIONS(2821),
    [anon_sym_lazy] = ACTIONS(2819),
    [anon_sym_assert] = ACTIONS(2819),
    [anon_sym_upcast] = ACTIONS(2819),
    [anon_sym_downcast] = ACTIONS(2819),
    [anon_sym_COLON_GT] = ACTIONS(2821),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2821),
    [anon_sym_for] = ACTIONS(2819),
    [anon_sym_while] = ACTIONS(2819),
    [anon_sym_if] = ACTIONS(2819),
    [anon_sym_fun] = ACTIONS(2819),
    [anon_sym_try] = ACTIONS(2819),
    [anon_sym_match] = ACTIONS(2819),
    [anon_sym_match_BANG] = ACTIONS(2821),
    [anon_sym_function] = ACTIONS(2819),
    [anon_sym_LT_DASH] = ACTIONS(2819),
    [anon_sym_DOT_LBRACK] = ACTIONS(2821),
    [anon_sym_LT] = ACTIONS(2821),
    [anon_sym_use] = ACTIONS(2819),
    [anon_sym_use_BANG] = ACTIONS(2821),
    [anon_sym_do_BANG] = ACTIONS(2821),
    [anon_sym_begin] = ACTIONS(2819),
    [anon_sym_LPAREN2] = ACTIONS(2819),
    [anon_sym_or] = ACTIONS(2819),
    [aux_sym_char_token1] = ACTIONS(2821),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2819),
    [anon_sym_DQUOTE] = ACTIONS(2819),
    [anon_sym_AT_DQUOTE] = ACTIONS(2821),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2821),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2821),
    [sym_bool] = ACTIONS(2819),
    [sym_unit] = ACTIONS(2821),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2819),
    [sym_op_identifier] = ACTIONS(2819),
    [anon_sym_PLUS] = ACTIONS(2819),
    [anon_sym_DASH] = ACTIONS(2819),
    [anon_sym_PLUS_DOT] = ACTIONS(2819),
    [anon_sym_DASH_DOT] = ACTIONS(2819),
    [anon_sym_PERCENT] = ACTIONS(2819),
    [anon_sym_AMP_AMP] = ACTIONS(2819),
    [anon_sym_TILDE] = ACTIONS(2821),
    [aux_sym_prefix_op_token1] = ACTIONS(2819),
    [aux_sym_infix_op_token1] = ACTIONS(2821),
    [aux_sym_infix_op_token2] = ACTIONS(2819),
    [anon_sym_PIPE_PIPE] = ACTIONS(2819),
    [anon_sym_BANG_EQ] = ACTIONS(2819),
    [anon_sym_COLON_EQ] = ACTIONS(2821),
    [anon_sym_DOLLAR] = ACTIONS(2819),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2819),
    [sym_int] = ACTIONS(3644),
    [sym_xint] = ACTIONS(2821),
    [anon_sym_f] = ACTIONS(2819),
    [aux_sym_decimal_token1] = ACTIONS(2819),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2821),
    [sym__newline] = ACTIONS(2821),
    [sym__dedent] = ACTIONS(2821),
  },
  [1445] = {
    [sym_block_comment] = STATE(1445),
    [sym_compiler_directive_decl] = STATE(1445),
    [sym_fsi_directive_decl] = STATE(1445),
    [sym_preproc_line] = STATE(1445),
    [aux_sym_long_identifier_repeat1] = STATE(1455),
    [sym_identifier] = ACTIONS(2418),
    [anon_sym_EQ] = ACTIONS(2418),
    [anon_sym_COLON] = ACTIONS(2418),
    [anon_sym_return] = ACTIONS(2418),
    [anon_sym_do] = ACTIONS(2418),
    [anon_sym_let] = ACTIONS(2418),
    [anon_sym_let_BANG] = ACTIONS(2420),
    [anon_sym_LPAREN] = ACTIONS(2418),
    [anon_sym_COMMA] = ACTIONS(2420),
    [anon_sym_null] = ACTIONS(2418),
    [anon_sym_QMARK] = ACTIONS(2418),
    [anon_sym_COLON_QMARK] = ACTIONS(2418),
    [anon_sym_COLON_COLON] = ACTIONS(2420),
    [anon_sym_AMP] = ACTIONS(2418),
    [anon_sym_LBRACK] = ACTIONS(2418),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2420),
    [anon_sym_LBRACE] = ACTIONS(2418),
    [anon_sym_LT_AT] = ACTIONS(2418),
    [anon_sym_LT_AT_AT] = ACTIONS(2418),
    [anon_sym_DOT] = ACTIONS(3646),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2420),
    [anon_sym_new] = ACTIONS(2418),
    [anon_sym_with] = ACTIONS(2418),
    [anon_sym_return_BANG] = ACTIONS(2420),
    [anon_sym_yield] = ACTIONS(2418),
    [anon_sym_yield_BANG] = ACTIONS(2420),
    [anon_sym_lazy] = ACTIONS(2418),
    [anon_sym_assert] = ACTIONS(2418),
    [anon_sym_upcast] = ACTIONS(2418),
    [anon_sym_downcast] = ACTIONS(2418),
    [anon_sym_COLON_GT] = ACTIONS(2420),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2420),
    [anon_sym_for] = ACTIONS(2418),
    [anon_sym_while] = ACTIONS(2418),
    [anon_sym_if] = ACTIONS(2418),
    [anon_sym_fun] = ACTIONS(2418),
    [anon_sym_try] = ACTIONS(2418),
    [anon_sym_match] = ACTIONS(2418),
    [anon_sym_match_BANG] = ACTIONS(2420),
    [anon_sym_function] = ACTIONS(2418),
    [anon_sym_LT_DASH] = ACTIONS(2418),
    [anon_sym_DOT_LBRACK] = ACTIONS(2420),
    [anon_sym_LT] = ACTIONS(2420),
    [anon_sym_use] = ACTIONS(2418),
    [anon_sym_use_BANG] = ACTIONS(2420),
    [anon_sym_do_BANG] = ACTIONS(2420),
    [anon_sym_begin] = ACTIONS(2418),
    [anon_sym_LPAREN2] = ACTIONS(2418),
    [anon_sym_or] = ACTIONS(2418),
    [anon_sym_EQ2] = ACTIONS(2420),
    [aux_sym_char_token1] = ACTIONS(2420),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2418),
    [anon_sym_DQUOTE] = ACTIONS(2418),
    [anon_sym_AT_DQUOTE] = ACTIONS(2420),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2420),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2420),
    [sym_bool] = ACTIONS(2418),
    [sym_unit] = ACTIONS(2420),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2418),
    [sym_op_identifier] = ACTIONS(2418),
    [anon_sym_PLUS] = ACTIONS(2418),
    [anon_sym_DASH] = ACTIONS(2418),
    [anon_sym_PLUS_DOT] = ACTIONS(2418),
    [anon_sym_DASH_DOT] = ACTIONS(2418),
    [anon_sym_PERCENT] = ACTIONS(2418),
    [anon_sym_AMP_AMP] = ACTIONS(2418),
    [anon_sym_TILDE] = ACTIONS(2420),
    [aux_sym_prefix_op_token1] = ACTIONS(2418),
    [aux_sym_infix_op_token1] = ACTIONS(2420),
    [aux_sym_infix_op_token2] = ACTIONS(2418),
    [anon_sym_PIPE_PIPE] = ACTIONS(2418),
    [anon_sym_BANG_EQ] = ACTIONS(2418),
    [anon_sym_COLON_EQ] = ACTIONS(2420),
    [anon_sym_DOLLAR] = ACTIONS(2418),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2418),
    [sym_int] = ACTIONS(2418),
    [sym_xint] = ACTIONS(2420),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2420),
    [sym__newline] = ACTIONS(2420),
    [sym__dedent] = ACTIONS(2420),
  },
  [1446] = {
    [sym_block_comment] = STATE(1446),
    [sym_compiler_directive_decl] = STATE(1446),
    [sym_fsi_directive_decl] = STATE(1446),
    [sym_preproc_line] = STATE(1446),
    [aux_sym_long_identifier_repeat1] = STATE(1466),
    [sym_identifier] = ACTIONS(2791),
    [anon_sym_EQ] = ACTIONS(2794),
    [anon_sym_COLON] = ACTIONS(2791),
    [anon_sym_return] = ACTIONS(2791),
    [anon_sym_do] = ACTIONS(2791),
    [anon_sym_let] = ACTIONS(2791),
    [anon_sym_let_BANG] = ACTIONS(2794),
    [anon_sym_as] = ACTIONS(2791),
    [anon_sym_LPAREN] = ACTIONS(2791),
    [anon_sym_COMMA] = ACTIONS(2794),
    [anon_sym_null] = ACTIONS(2791),
    [anon_sym_QMARK] = ACTIONS(2791),
    [anon_sym_COLON_QMARK] = ACTIONS(2791),
    [anon_sym_COLON_COLON] = ACTIONS(2794),
    [anon_sym_AMP] = ACTIONS(2791),
    [anon_sym_LBRACK] = ACTIONS(2791),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2794),
    [anon_sym_LBRACE] = ACTIONS(2791),
    [anon_sym_LT_AT] = ACTIONS(2791),
    [anon_sym_LT_AT_AT] = ACTIONS(2791),
    [anon_sym_DOT] = ACTIONS(3648),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2794),
    [anon_sym_new] = ACTIONS(2791),
    [anon_sym_with] = ACTIONS(2791),
    [anon_sym_return_BANG] = ACTIONS(2794),
    [anon_sym_yield] = ACTIONS(2791),
    [anon_sym_yield_BANG] = ACTIONS(2794),
    [anon_sym_lazy] = ACTIONS(2791),
    [anon_sym_assert] = ACTIONS(2791),
    [anon_sym_upcast] = ACTIONS(2791),
    [anon_sym_downcast] = ACTIONS(2791),
    [anon_sym_COLON_GT] = ACTIONS(2794),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2794),
    [anon_sym_for] = ACTIONS(2791),
    [anon_sym_while] = ACTIONS(2791),
    [anon_sym_if] = ACTIONS(2791),
    [anon_sym_fun] = ACTIONS(2791),
    [anon_sym_try] = ACTIONS(2791),
    [anon_sym_match] = ACTIONS(2791),
    [anon_sym_match_BANG] = ACTIONS(2794),
    [anon_sym_function] = ACTIONS(2791),
    [anon_sym_LT_DASH] = ACTIONS(2791),
    [anon_sym_DOT_LBRACK] = ACTIONS(2794),
    [anon_sym_LT] = ACTIONS(2794),
    [anon_sym_use] = ACTIONS(2791),
    [anon_sym_use_BANG] = ACTIONS(2794),
    [anon_sym_do_BANG] = ACTIONS(2794),
    [anon_sym_begin] = ACTIONS(2791),
    [anon_sym_LPAREN2] = ACTIONS(2791),
    [anon_sym_or] = ACTIONS(2791),
    [aux_sym_char_token1] = ACTIONS(2794),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2791),
    [anon_sym_DQUOTE] = ACTIONS(2791),
    [anon_sym_AT_DQUOTE] = ACTIONS(2794),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2794),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2794),
    [sym_bool] = ACTIONS(2791),
    [sym_unit] = ACTIONS(2794),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2791),
    [sym_op_identifier] = ACTIONS(2791),
    [anon_sym_PLUS] = ACTIONS(2791),
    [anon_sym_DASH] = ACTIONS(2791),
    [anon_sym_PLUS_DOT] = ACTIONS(2791),
    [anon_sym_DASH_DOT] = ACTIONS(2791),
    [anon_sym_PERCENT] = ACTIONS(2791),
    [anon_sym_AMP_AMP] = ACTIONS(2791),
    [anon_sym_TILDE] = ACTIONS(2794),
    [aux_sym_prefix_op_token1] = ACTIONS(2791),
    [aux_sym_infix_op_token1] = ACTIONS(2794),
    [aux_sym_infix_op_token2] = ACTIONS(2791),
    [anon_sym_PIPE_PIPE] = ACTIONS(2791),
    [anon_sym_BANG_EQ] = ACTIONS(2791),
    [anon_sym_COLON_EQ] = ACTIONS(2794),
    [anon_sym_DOLLAR] = ACTIONS(2791),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2791),
    [sym_int] = ACTIONS(2791),
    [sym_xint] = ACTIONS(2794),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2794),
    [sym__newline] = ACTIONS(2794),
    [sym__dedent] = ACTIONS(2794),
  },
  [1447] = {
    [sym_block_comment] = STATE(1447),
    [sym_compiler_directive_decl] = STATE(1447),
    [sym_fsi_directive_decl] = STATE(1447),
    [sym_preproc_line] = STATE(1447),
    [sym_identifier] = ACTIONS(2158),
    [anon_sym_EQ] = ACTIONS(2160),
    [anon_sym_COLON] = ACTIONS(2158),
    [anon_sym_return] = ACTIONS(2158),
    [anon_sym_do] = ACTIONS(2158),
    [anon_sym_let] = ACTIONS(2158),
    [anon_sym_let_BANG] = ACTIONS(2160),
    [anon_sym_LPAREN] = ACTIONS(2158),
    [anon_sym_COMMA] = ACTIONS(2160),
    [anon_sym_null] = ACTIONS(2158),
    [anon_sym_QMARK] = ACTIONS(2158),
    [anon_sym_COLON_QMARK] = ACTIONS(2158),
    [anon_sym_COLON_COLON] = ACTIONS(2160),
    [anon_sym_AMP] = ACTIONS(2158),
    [anon_sym_LBRACK] = ACTIONS(2158),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2160),
    [anon_sym_LBRACE] = ACTIONS(2158),
    [anon_sym_LT_AT] = ACTIONS(2158),
    [anon_sym_LT_AT_AT] = ACTIONS(2158),
    [anon_sym_DOT] = ACTIONS(2158),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2160),
    [anon_sym_new] = ACTIONS(2158),
    [anon_sym_return_BANG] = ACTIONS(2160),
    [anon_sym_yield] = ACTIONS(2158),
    [anon_sym_yield_BANG] = ACTIONS(2160),
    [anon_sym_lazy] = ACTIONS(2158),
    [anon_sym_assert] = ACTIONS(2158),
    [anon_sym_upcast] = ACTIONS(2158),
    [anon_sym_downcast] = ACTIONS(2158),
    [anon_sym_COLON_GT] = ACTIONS(2160),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2160),
    [anon_sym_for] = ACTIONS(2158),
    [anon_sym_while] = ACTIONS(2158),
    [anon_sym_if] = ACTIONS(2158),
    [anon_sym_fun] = ACTIONS(2158),
    [anon_sym_DASH_GT] = ACTIONS(2158),
    [anon_sym_try] = ACTIONS(2158),
    [anon_sym_match] = ACTIONS(2158),
    [anon_sym_match_BANG] = ACTIONS(2160),
    [anon_sym_function] = ACTIONS(2158),
    [anon_sym_LT_DASH] = ACTIONS(2158),
    [anon_sym_DOT_LBRACK] = ACTIONS(2160),
    [anon_sym_LT] = ACTIONS(2160),
    [anon_sym_use] = ACTIONS(2158),
    [anon_sym_use_BANG] = ACTIONS(2160),
    [anon_sym_do_BANG] = ACTIONS(2160),
    [anon_sym_DOT_DOT] = ACTIONS(2160),
    [anon_sym_begin] = ACTIONS(2158),
    [anon_sym_LPAREN2] = ACTIONS(2158),
    [anon_sym_or] = ACTIONS(2158),
    [aux_sym_char_token1] = ACTIONS(2160),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2158),
    [anon_sym_DQUOTE] = ACTIONS(2158),
    [anon_sym_AT_DQUOTE] = ACTIONS(2160),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2160),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2160),
    [sym_bool] = ACTIONS(2158),
    [sym_unit] = ACTIONS(2160),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2158),
    [sym_op_identifier] = ACTIONS(2158),
    [anon_sym_PLUS] = ACTIONS(2158),
    [anon_sym_DASH] = ACTIONS(2158),
    [anon_sym_PLUS_DOT] = ACTIONS(2158),
    [anon_sym_DASH_DOT] = ACTIONS(2158),
    [anon_sym_PERCENT] = ACTIONS(2158),
    [anon_sym_AMP_AMP] = ACTIONS(2158),
    [anon_sym_TILDE] = ACTIONS(2160),
    [aux_sym_prefix_op_token1] = ACTIONS(2158),
    [aux_sym_infix_op_token1] = ACTIONS(2160),
    [aux_sym_infix_op_token2] = ACTIONS(2158),
    [anon_sym_PIPE_PIPE] = ACTIONS(2158),
    [anon_sym_BANG_EQ] = ACTIONS(2158),
    [anon_sym_COLON_EQ] = ACTIONS(2160),
    [anon_sym_DOLLAR] = ACTIONS(2158),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2158),
    [sym_int] = ACTIONS(2158),
    [sym_xint] = ACTIONS(2160),
    [anon_sym_f] = ACTIONS(2677),
    [aux_sym_decimal_token1] = ACTIONS(2306),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2160),
    [sym__newline] = ACTIONS(2160),
  },
  [1448] = {
    [sym_block_comment] = STATE(1448),
    [sym_compiler_directive_decl] = STATE(1448),
    [sym_fsi_directive_decl] = STATE(1448),
    [sym_preproc_line] = STATE(1448),
    [sym_identifier] = ACTIONS(2723),
    [anon_sym_EQ] = ACTIONS(2725),
    [anon_sym_COLON] = ACTIONS(2723),
    [anon_sym_return] = ACTIONS(2723),
    [anon_sym_do] = ACTIONS(2723),
    [anon_sym_and] = ACTIONS(2723),
    [anon_sym_let] = ACTIONS(2723),
    [anon_sym_let_BANG] = ACTIONS(2725),
    [anon_sym_LPAREN] = ACTIONS(2723),
    [anon_sym_COMMA] = ACTIONS(2725),
    [anon_sym_null] = ACTIONS(2723),
    [anon_sym_QMARK] = ACTIONS(2723),
    [anon_sym_COLON_QMARK] = ACTIONS(2723),
    [anon_sym_COLON_COLON] = ACTIONS(2725),
    [anon_sym_AMP] = ACTIONS(2723),
    [anon_sym_LBRACK] = ACTIONS(2723),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2725),
    [anon_sym_LBRACE] = ACTIONS(2723),
    [anon_sym_LT_AT] = ACTIONS(2723),
    [anon_sym_LT_AT_AT] = ACTIONS(2723),
    [anon_sym_DOT] = ACTIONS(2723),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2725),
    [anon_sym_new] = ACTIONS(2723),
    [anon_sym_return_BANG] = ACTIONS(2725),
    [anon_sym_yield] = ACTIONS(2723),
    [anon_sym_yield_BANG] = ACTIONS(2725),
    [anon_sym_lazy] = ACTIONS(2723),
    [anon_sym_assert] = ACTIONS(2723),
    [anon_sym_upcast] = ACTIONS(2723),
    [anon_sym_downcast] = ACTIONS(2723),
    [anon_sym_COLON_GT] = ACTIONS(2725),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2725),
    [anon_sym_for] = ACTIONS(2723),
    [anon_sym_while] = ACTIONS(2723),
    [anon_sym_if] = ACTIONS(2723),
    [anon_sym_fun] = ACTIONS(2723),
    [anon_sym_try] = ACTIONS(2723),
    [anon_sym_match] = ACTIONS(2723),
    [anon_sym_match_BANG] = ACTIONS(2725),
    [anon_sym_function] = ACTIONS(2723),
    [anon_sym_LT_DASH] = ACTIONS(2723),
    [anon_sym_DOT_LBRACK] = ACTIONS(2725),
    [anon_sym_LT] = ACTIONS(2725),
    [anon_sym_use] = ACTIONS(2723),
    [anon_sym_use_BANG] = ACTIONS(2725),
    [anon_sym_do_BANG] = ACTIONS(2725),
    [anon_sym_begin] = ACTIONS(2723),
    [anon_sym_LPAREN2] = ACTIONS(2723),
    [anon_sym_or] = ACTIONS(2723),
    [aux_sym_char_token1] = ACTIONS(2725),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2723),
    [anon_sym_DQUOTE] = ACTIONS(2723),
    [anon_sym_AT_DQUOTE] = ACTIONS(2725),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2725),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2725),
    [sym_bool] = ACTIONS(2723),
    [sym_unit] = ACTIONS(2725),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2723),
    [sym_op_identifier] = ACTIONS(2723),
    [anon_sym_PLUS] = ACTIONS(2723),
    [anon_sym_DASH] = ACTIONS(2723),
    [anon_sym_PLUS_DOT] = ACTIONS(2723),
    [anon_sym_DASH_DOT] = ACTIONS(2723),
    [anon_sym_PERCENT] = ACTIONS(2723),
    [anon_sym_AMP_AMP] = ACTIONS(2723),
    [anon_sym_TILDE] = ACTIONS(2725),
    [aux_sym_prefix_op_token1] = ACTIONS(2723),
    [aux_sym_infix_op_token1] = ACTIONS(2725),
    [aux_sym_infix_op_token2] = ACTIONS(2723),
    [anon_sym_PIPE_PIPE] = ACTIONS(2723),
    [anon_sym_BANG_EQ] = ACTIONS(2723),
    [anon_sym_COLON_EQ] = ACTIONS(2725),
    [anon_sym_DOLLAR] = ACTIONS(2723),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2723),
    [sym_int] = ACTIONS(2723),
    [sym_xint] = ACTIONS(2725),
    [anon_sym_f] = ACTIONS(2723),
    [aux_sym_decimal_token1] = ACTIONS(2723),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2725),
    [sym__newline] = ACTIONS(2725),
    [sym__dedent] = ACTIONS(2725),
  },
  [1449] = {
    [sym_block_comment] = STATE(1449),
    [sym_compiler_directive_decl] = STATE(1449),
    [sym_fsi_directive_decl] = STATE(1449),
    [sym_preproc_line] = STATE(1449),
    [sym_identifier] = ACTIONS(2748),
    [anon_sym_EQ] = ACTIONS(2750),
    [anon_sym_COLON] = ACTIONS(2748),
    [anon_sym_return] = ACTIONS(2748),
    [anon_sym_do] = ACTIONS(2748),
    [anon_sym_let] = ACTIONS(2748),
    [anon_sym_let_BANG] = ACTIONS(2750),
    [anon_sym_LPAREN] = ACTIONS(2748),
    [anon_sym_COMMA] = ACTIONS(2750),
    [anon_sym_null] = ACTIONS(2748),
    [anon_sym_QMARK] = ACTIONS(2748),
    [anon_sym_COLON_QMARK] = ACTIONS(2748),
    [anon_sym_COLON_COLON] = ACTIONS(2750),
    [anon_sym_AMP] = ACTIONS(2748),
    [anon_sym_LBRACK] = ACTIONS(2748),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2750),
    [anon_sym_LBRACE] = ACTIONS(2748),
    [anon_sym_LT_AT] = ACTIONS(2748),
    [anon_sym_LT_AT_AT] = ACTIONS(2748),
    [anon_sym_DOT] = ACTIONS(2748),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2750),
    [anon_sym_new] = ACTIONS(2748),
    [anon_sym_return_BANG] = ACTIONS(2750),
    [anon_sym_yield] = ACTIONS(2748),
    [anon_sym_yield_BANG] = ACTIONS(2750),
    [anon_sym_lazy] = ACTIONS(2748),
    [anon_sym_assert] = ACTIONS(2748),
    [anon_sym_upcast] = ACTIONS(2748),
    [anon_sym_downcast] = ACTIONS(2748),
    [anon_sym_COLON_GT] = ACTIONS(2750),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2750),
    [anon_sym_for] = ACTIONS(2748),
    [anon_sym_while] = ACTIONS(2748),
    [anon_sym_else] = ACTIONS(2748),
    [anon_sym_elif] = ACTIONS(2748),
    [anon_sym_if] = ACTIONS(2748),
    [anon_sym_fun] = ACTIONS(2748),
    [anon_sym_DASH_GT] = ACTIONS(2748),
    [anon_sym_try] = ACTIONS(2748),
    [anon_sym_match] = ACTIONS(2748),
    [anon_sym_match_BANG] = ACTIONS(2750),
    [anon_sym_function] = ACTIONS(2748),
    [anon_sym_LT_DASH] = ACTIONS(2748),
    [anon_sym_DOT_LBRACK] = ACTIONS(2750),
    [anon_sym_LT] = ACTIONS(2750),
    [anon_sym_use] = ACTIONS(2748),
    [anon_sym_use_BANG] = ACTIONS(2750),
    [anon_sym_do_BANG] = ACTIONS(2750),
    [anon_sym_DOT_DOT] = ACTIONS(2750),
    [anon_sym_begin] = ACTIONS(2748),
    [anon_sym_LPAREN2] = ACTIONS(2748),
    [anon_sym_or] = ACTIONS(2748),
    [aux_sym_char_token1] = ACTIONS(2750),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2748),
    [anon_sym_DQUOTE] = ACTIONS(2748),
    [anon_sym_AT_DQUOTE] = ACTIONS(2750),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2750),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2750),
    [sym_bool] = ACTIONS(2748),
    [sym_unit] = ACTIONS(2750),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2748),
    [sym_op_identifier] = ACTIONS(2748),
    [anon_sym_PLUS] = ACTIONS(2748),
    [anon_sym_DASH] = ACTIONS(2748),
    [anon_sym_PLUS_DOT] = ACTIONS(2748),
    [anon_sym_DASH_DOT] = ACTIONS(2748),
    [anon_sym_PERCENT] = ACTIONS(2748),
    [anon_sym_AMP_AMP] = ACTIONS(2748),
    [anon_sym_TILDE] = ACTIONS(2750),
    [aux_sym_prefix_op_token1] = ACTIONS(2748),
    [aux_sym_infix_op_token1] = ACTIONS(2750),
    [aux_sym_infix_op_token2] = ACTIONS(2748),
    [anon_sym_PIPE_PIPE] = ACTIONS(2748),
    [anon_sym_BANG_EQ] = ACTIONS(2748),
    [anon_sym_COLON_EQ] = ACTIONS(2750),
    [anon_sym_DOLLAR] = ACTIONS(2748),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2748),
    [sym_int] = ACTIONS(2748),
    [sym_xint] = ACTIONS(2750),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2750),
    [sym__newline] = ACTIONS(2750),
  },
  [1450] = {
    [sym_block_comment] = STATE(1450),
    [sym_compiler_directive_decl] = STATE(1450),
    [sym_fsi_directive_decl] = STATE(1450),
    [sym_preproc_line] = STATE(1450),
    [aux_sym_rules_repeat1] = STATE(1456),
    [sym_identifier] = ACTIONS(2737),
    [anon_sym_EQ] = ACTIONS(2739),
    [anon_sym_COLON] = ACTIONS(2737),
    [anon_sym_return] = ACTIONS(2737),
    [anon_sym_do] = ACTIONS(2737),
    [anon_sym_let] = ACTIONS(2737),
    [anon_sym_let_BANG] = ACTIONS(2739),
    [anon_sym_LPAREN] = ACTIONS(2737),
    [anon_sym_COMMA] = ACTIONS(2739),
    [anon_sym_null] = ACTIONS(2737),
    [anon_sym_QMARK] = ACTIONS(2737),
    [anon_sym_COLON_QMARK] = ACTIONS(2737),
    [anon_sym_COLON_COLON] = ACTIONS(2739),
    [anon_sym_PIPE] = ACTIONS(3652),
    [anon_sym_AMP] = ACTIONS(2737),
    [anon_sym_LBRACK] = ACTIONS(2737),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2739),
    [anon_sym_LBRACE] = ACTIONS(2737),
    [anon_sym_LT_AT] = ACTIONS(2737),
    [anon_sym_LT_AT_AT] = ACTIONS(2737),
    [anon_sym_DOT] = ACTIONS(2737),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2739),
    [anon_sym_new] = ACTIONS(2737),
    [anon_sym_return_BANG] = ACTIONS(2739),
    [anon_sym_yield] = ACTIONS(2737),
    [anon_sym_yield_BANG] = ACTIONS(2739),
    [anon_sym_lazy] = ACTIONS(2737),
    [anon_sym_assert] = ACTIONS(2737),
    [anon_sym_upcast] = ACTIONS(2737),
    [anon_sym_downcast] = ACTIONS(2737),
    [anon_sym_COLON_GT] = ACTIONS(2739),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2739),
    [anon_sym_for] = ACTIONS(2737),
    [anon_sym_while] = ACTIONS(2737),
    [anon_sym_if] = ACTIONS(2737),
    [anon_sym_fun] = ACTIONS(2737),
    [anon_sym_try] = ACTIONS(2737),
    [anon_sym_match] = ACTIONS(2737),
    [anon_sym_match_BANG] = ACTIONS(2739),
    [anon_sym_function] = ACTIONS(2737),
    [anon_sym_LT_DASH] = ACTIONS(2737),
    [anon_sym_DOT_LBRACK] = ACTIONS(2739),
    [anon_sym_LT] = ACTIONS(2739),
    [anon_sym_use] = ACTIONS(2737),
    [anon_sym_use_BANG] = ACTIONS(2739),
    [anon_sym_do_BANG] = ACTIONS(2739),
    [anon_sym_begin] = ACTIONS(2737),
    [anon_sym_LPAREN2] = ACTIONS(2737),
    [anon_sym_or] = ACTIONS(2737),
    [aux_sym_char_token1] = ACTIONS(2739),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2737),
    [anon_sym_DQUOTE] = ACTIONS(2737),
    [anon_sym_AT_DQUOTE] = ACTIONS(2739),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2739),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2739),
    [sym_bool] = ACTIONS(2737),
    [sym_unit] = ACTIONS(2739),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2737),
    [sym_op_identifier] = ACTIONS(2737),
    [anon_sym_PLUS] = ACTIONS(2737),
    [anon_sym_DASH] = ACTIONS(2737),
    [anon_sym_PLUS_DOT] = ACTIONS(2737),
    [anon_sym_DASH_DOT] = ACTIONS(2737),
    [anon_sym_PERCENT] = ACTIONS(2737),
    [anon_sym_AMP_AMP] = ACTIONS(2737),
    [anon_sym_TILDE] = ACTIONS(2739),
    [aux_sym_prefix_op_token1] = ACTIONS(2737),
    [aux_sym_infix_op_token1] = ACTIONS(2739),
    [aux_sym_infix_op_token2] = ACTIONS(2737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2737),
    [anon_sym_BANG_EQ] = ACTIONS(2737),
    [anon_sym_COLON_EQ] = ACTIONS(2739),
    [anon_sym_DOLLAR] = ACTIONS(2737),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2737),
    [sym_int] = ACTIONS(2737),
    [sym_xint] = ACTIONS(2739),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2739),
    [anon_sym_POUNDendif] = ACTIONS(2739),
    [anon_sym_POUNDelse] = ACTIONS(2739),
    [sym__newline] = ACTIONS(3654),
  },
  [1451] = {
    [sym_block_comment] = STATE(1451),
    [sym_compiler_directive_decl] = STATE(1451),
    [sym_fsi_directive_decl] = STATE(1451),
    [sym_preproc_line] = STATE(1451),
    [sym_identifier] = ACTIONS(2748),
    [anon_sym_EQ] = ACTIONS(2750),
    [anon_sym_COLON] = ACTIONS(2748),
    [anon_sym_return] = ACTIONS(2748),
    [anon_sym_do] = ACTIONS(2748),
    [anon_sym_let] = ACTIONS(2748),
    [anon_sym_let_BANG] = ACTIONS(2750),
    [anon_sym_as] = ACTIONS(2748),
    [anon_sym_LPAREN] = ACTIONS(2748),
    [anon_sym_COMMA] = ACTIONS(2750),
    [anon_sym_null] = ACTIONS(2748),
    [anon_sym_QMARK] = ACTIONS(2748),
    [anon_sym_COLON_QMARK] = ACTIONS(2748),
    [anon_sym_COLON_COLON] = ACTIONS(2750),
    [anon_sym_AMP] = ACTIONS(2748),
    [anon_sym_LBRACK] = ACTIONS(2748),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2750),
    [anon_sym_LBRACE] = ACTIONS(2748),
    [anon_sym_LT_AT] = ACTIONS(2748),
    [anon_sym_LT_AT_AT] = ACTIONS(2748),
    [anon_sym_DOT] = ACTIONS(2748),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2750),
    [anon_sym_new] = ACTIONS(2748),
    [anon_sym_with] = ACTIONS(2748),
    [anon_sym_return_BANG] = ACTIONS(2750),
    [anon_sym_yield] = ACTIONS(2748),
    [anon_sym_yield_BANG] = ACTIONS(2750),
    [anon_sym_lazy] = ACTIONS(2748),
    [anon_sym_assert] = ACTIONS(2748),
    [anon_sym_upcast] = ACTIONS(2748),
    [anon_sym_downcast] = ACTIONS(2748),
    [anon_sym_COLON_GT] = ACTIONS(2750),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2750),
    [anon_sym_for] = ACTIONS(2748),
    [anon_sym_while] = ACTIONS(2748),
    [anon_sym_else] = ACTIONS(2748),
    [anon_sym_elif] = ACTIONS(2748),
    [anon_sym_if] = ACTIONS(2748),
    [anon_sym_fun] = ACTIONS(2748),
    [anon_sym_try] = ACTIONS(2748),
    [anon_sym_match] = ACTIONS(2748),
    [anon_sym_match_BANG] = ACTIONS(2750),
    [anon_sym_function] = ACTIONS(2748),
    [anon_sym_LT_DASH] = ACTIONS(2748),
    [anon_sym_DOT_LBRACK] = ACTIONS(2750),
    [anon_sym_LT] = ACTIONS(2750),
    [anon_sym_use] = ACTIONS(2748),
    [anon_sym_use_BANG] = ACTIONS(2750),
    [anon_sym_do_BANG] = ACTIONS(2750),
    [anon_sym_begin] = ACTIONS(2748),
    [anon_sym_LPAREN2] = ACTIONS(2748),
    [anon_sym_or] = ACTIONS(2748),
    [aux_sym_char_token1] = ACTIONS(2750),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2748),
    [anon_sym_DQUOTE] = ACTIONS(2748),
    [anon_sym_AT_DQUOTE] = ACTIONS(2750),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2750),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2750),
    [sym_bool] = ACTIONS(2748),
    [sym_unit] = ACTIONS(2750),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2748),
    [sym_op_identifier] = ACTIONS(2748),
    [anon_sym_PLUS] = ACTIONS(2748),
    [anon_sym_DASH] = ACTIONS(2748),
    [anon_sym_PLUS_DOT] = ACTIONS(2748),
    [anon_sym_DASH_DOT] = ACTIONS(2748),
    [anon_sym_PERCENT] = ACTIONS(2748),
    [anon_sym_AMP_AMP] = ACTIONS(2748),
    [anon_sym_TILDE] = ACTIONS(2750),
    [aux_sym_prefix_op_token1] = ACTIONS(2748),
    [aux_sym_infix_op_token1] = ACTIONS(2750),
    [aux_sym_infix_op_token2] = ACTIONS(2748),
    [anon_sym_PIPE_PIPE] = ACTIONS(2748),
    [anon_sym_BANG_EQ] = ACTIONS(2748),
    [anon_sym_COLON_EQ] = ACTIONS(2750),
    [anon_sym_DOLLAR] = ACTIONS(2748),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2748),
    [sym_int] = ACTIONS(2748),
    [sym_xint] = ACTIONS(2750),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2750),
    [sym__newline] = ACTIONS(2750),
  },
  [1452] = {
    [sym_block_comment] = STATE(1452),
    [sym_compiler_directive_decl] = STATE(1452),
    [sym_fsi_directive_decl] = STATE(1452),
    [sym_preproc_line] = STATE(1452),
    [aux_sym_long_identifier_repeat1] = STATE(1452),
    [sym_identifier] = ACTIONS(2411),
    [anon_sym_EQ] = ACTIONS(2413),
    [anon_sym_COLON] = ACTIONS(2411),
    [anon_sym_return] = ACTIONS(2411),
    [anon_sym_do] = ACTIONS(2411),
    [anon_sym_let] = ACTIONS(2411),
    [anon_sym_let_BANG] = ACTIONS(2413),
    [anon_sym_as] = ACTIONS(2411),
    [anon_sym_LPAREN] = ACTIONS(2411),
    [anon_sym_COMMA] = ACTIONS(2413),
    [anon_sym_null] = ACTIONS(2411),
    [anon_sym_QMARK] = ACTIONS(2411),
    [anon_sym_COLON_QMARK] = ACTIONS(2411),
    [anon_sym_COLON_COLON] = ACTIONS(2413),
    [anon_sym_AMP] = ACTIONS(2411),
    [anon_sym_LBRACK] = ACTIONS(2411),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2413),
    [anon_sym_LBRACE] = ACTIONS(2411),
    [anon_sym_LT_AT] = ACTIONS(2411),
    [anon_sym_LT_AT_AT] = ACTIONS(2411),
    [anon_sym_DOT] = ACTIONS(3657),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2413),
    [anon_sym_new] = ACTIONS(2411),
    [anon_sym_with] = ACTIONS(2411),
    [anon_sym_return_BANG] = ACTIONS(2413),
    [anon_sym_yield] = ACTIONS(2411),
    [anon_sym_yield_BANG] = ACTIONS(2413),
    [anon_sym_lazy] = ACTIONS(2411),
    [anon_sym_assert] = ACTIONS(2411),
    [anon_sym_upcast] = ACTIONS(2411),
    [anon_sym_downcast] = ACTIONS(2411),
    [anon_sym_COLON_GT] = ACTIONS(2413),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2413),
    [anon_sym_for] = ACTIONS(2411),
    [anon_sym_while] = ACTIONS(2411),
    [anon_sym_if] = ACTIONS(2411),
    [anon_sym_fun] = ACTIONS(2411),
    [anon_sym_try] = ACTIONS(2411),
    [anon_sym_match] = ACTIONS(2411),
    [anon_sym_match_BANG] = ACTIONS(2413),
    [anon_sym_function] = ACTIONS(2411),
    [anon_sym_LT_DASH] = ACTIONS(2411),
    [anon_sym_DOT_LBRACK] = ACTIONS(2413),
    [anon_sym_LT] = ACTIONS(2413),
    [anon_sym_use] = ACTIONS(2411),
    [anon_sym_use_BANG] = ACTIONS(2413),
    [anon_sym_do_BANG] = ACTIONS(2413),
    [anon_sym_begin] = ACTIONS(2411),
    [anon_sym_LPAREN2] = ACTIONS(2411),
    [anon_sym_or] = ACTIONS(2411),
    [aux_sym_char_token1] = ACTIONS(2413),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2411),
    [anon_sym_DQUOTE] = ACTIONS(2411),
    [anon_sym_AT_DQUOTE] = ACTIONS(2413),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2413),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2413),
    [sym_bool] = ACTIONS(2411),
    [sym_unit] = ACTIONS(2413),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2411),
    [sym_op_identifier] = ACTIONS(2411),
    [anon_sym_PLUS] = ACTIONS(2411),
    [anon_sym_DASH] = ACTIONS(2411),
    [anon_sym_PLUS_DOT] = ACTIONS(2411),
    [anon_sym_DASH_DOT] = ACTIONS(2411),
    [anon_sym_PERCENT] = ACTIONS(2411),
    [anon_sym_AMP_AMP] = ACTIONS(2411),
    [anon_sym_TILDE] = ACTIONS(2413),
    [aux_sym_prefix_op_token1] = ACTIONS(2411),
    [aux_sym_infix_op_token1] = ACTIONS(2413),
    [aux_sym_infix_op_token2] = ACTIONS(2411),
    [anon_sym_PIPE_PIPE] = ACTIONS(2411),
    [anon_sym_BANG_EQ] = ACTIONS(2411),
    [anon_sym_COLON_EQ] = ACTIONS(2413),
    [anon_sym_DOLLAR] = ACTIONS(2411),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2411),
    [sym_int] = ACTIONS(2411),
    [sym_xint] = ACTIONS(2413),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2413),
    [sym__newline] = ACTIONS(2413),
    [sym__dedent] = ACTIONS(2413),
  },
  [1453] = {
    [sym_block_comment] = STATE(1453),
    [sym_compiler_directive_decl] = STATE(1453),
    [sym_fsi_directive_decl] = STATE(1453),
    [sym_preproc_line] = STATE(1453),
    [sym_identifier] = ACTIONS(2812),
    [anon_sym_EQ] = ACTIONS(2814),
    [anon_sym_COLON] = ACTIONS(2812),
    [anon_sym_return] = ACTIONS(2812),
    [anon_sym_do] = ACTIONS(2812),
    [anon_sym_and] = ACTIONS(2812),
    [anon_sym_let] = ACTIONS(2812),
    [anon_sym_let_BANG] = ACTIONS(2814),
    [anon_sym_LPAREN] = ACTIONS(2812),
    [anon_sym_COMMA] = ACTIONS(2814),
    [anon_sym_null] = ACTIONS(2812),
    [anon_sym_QMARK] = ACTIONS(2812),
    [anon_sym_COLON_QMARK] = ACTIONS(2812),
    [anon_sym_COLON_COLON] = ACTIONS(2814),
    [anon_sym_AMP] = ACTIONS(2812),
    [anon_sym_LBRACK] = ACTIONS(2812),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2814),
    [anon_sym_LBRACE] = ACTIONS(2812),
    [anon_sym_LT_AT] = ACTIONS(2812),
    [anon_sym_LT_AT_AT] = ACTIONS(2812),
    [anon_sym_DOT] = ACTIONS(2812),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2814),
    [anon_sym_new] = ACTIONS(2812),
    [anon_sym_return_BANG] = ACTIONS(2814),
    [anon_sym_yield] = ACTIONS(2812),
    [anon_sym_yield_BANG] = ACTIONS(2814),
    [anon_sym_lazy] = ACTIONS(2812),
    [anon_sym_assert] = ACTIONS(2812),
    [anon_sym_upcast] = ACTIONS(2812),
    [anon_sym_downcast] = ACTIONS(2812),
    [anon_sym_COLON_GT] = ACTIONS(2814),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2814),
    [anon_sym_for] = ACTIONS(2812),
    [anon_sym_while] = ACTIONS(2812),
    [anon_sym_if] = ACTIONS(2812),
    [anon_sym_fun] = ACTIONS(2812),
    [anon_sym_try] = ACTIONS(2812),
    [anon_sym_match] = ACTIONS(2812),
    [anon_sym_match_BANG] = ACTIONS(2814),
    [anon_sym_function] = ACTIONS(2812),
    [anon_sym_LT_DASH] = ACTIONS(2812),
    [anon_sym_DOT_LBRACK] = ACTIONS(2814),
    [anon_sym_LT] = ACTIONS(2814),
    [anon_sym_use] = ACTIONS(2812),
    [anon_sym_use_BANG] = ACTIONS(2814),
    [anon_sym_do_BANG] = ACTIONS(2814),
    [anon_sym_begin] = ACTIONS(2812),
    [anon_sym_LPAREN2] = ACTIONS(2812),
    [anon_sym_or] = ACTIONS(2812),
    [aux_sym_char_token1] = ACTIONS(2814),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2812),
    [anon_sym_DQUOTE] = ACTIONS(2812),
    [anon_sym_AT_DQUOTE] = ACTIONS(2814),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2814),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2814),
    [sym_bool] = ACTIONS(2812),
    [sym_unit] = ACTIONS(2814),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2812),
    [sym_op_identifier] = ACTIONS(2812),
    [anon_sym_PLUS] = ACTIONS(2812),
    [anon_sym_DASH] = ACTIONS(2812),
    [anon_sym_PLUS_DOT] = ACTIONS(2812),
    [anon_sym_DASH_DOT] = ACTIONS(2812),
    [anon_sym_PERCENT] = ACTIONS(2812),
    [anon_sym_AMP_AMP] = ACTIONS(2812),
    [anon_sym_TILDE] = ACTIONS(2814),
    [aux_sym_prefix_op_token1] = ACTIONS(2812),
    [aux_sym_infix_op_token1] = ACTIONS(2814),
    [aux_sym_infix_op_token2] = ACTIONS(2812),
    [anon_sym_PIPE_PIPE] = ACTIONS(2812),
    [anon_sym_BANG_EQ] = ACTIONS(2812),
    [anon_sym_COLON_EQ] = ACTIONS(2814),
    [anon_sym_DOLLAR] = ACTIONS(2812),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2812),
    [sym_int] = ACTIONS(2812),
    [sym_xint] = ACTIONS(2814),
    [anon_sym_f] = ACTIONS(2812),
    [aux_sym_decimal_token1] = ACTIONS(2812),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2814),
    [sym__newline] = ACTIONS(2814),
    [sym__dedent] = ACTIONS(2814),
  },
  [1454] = {
    [sym_block_comment] = STATE(1454),
    [sym_compiler_directive_decl] = STATE(1454),
    [sym_fsi_directive_decl] = STATE(1454),
    [sym_preproc_line] = STATE(1454),
    [sym_identifier] = ACTIONS(2723),
    [anon_sym_EQ] = ACTIONS(2725),
    [anon_sym_COLON] = ACTIONS(2723),
    [anon_sym_return] = ACTIONS(2723),
    [anon_sym_do] = ACTIONS(2723),
    [anon_sym_let] = ACTIONS(2723),
    [anon_sym_let_BANG] = ACTIONS(2725),
    [anon_sym_LPAREN] = ACTIONS(2723),
    [anon_sym_COMMA] = ACTIONS(2725),
    [anon_sym_null] = ACTIONS(2723),
    [anon_sym_QMARK] = ACTIONS(2723),
    [anon_sym_COLON_QMARK] = ACTIONS(2723),
    [anon_sym_COLON_COLON] = ACTIONS(2725),
    [anon_sym_AMP] = ACTIONS(2723),
    [anon_sym_LBRACK] = ACTIONS(2723),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2725),
    [anon_sym_LBRACE] = ACTIONS(2723),
    [anon_sym_LT_AT] = ACTIONS(2723),
    [anon_sym_LT_AT_AT] = ACTIONS(2723),
    [anon_sym_DOT] = ACTIONS(2723),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2725),
    [anon_sym_new] = ACTIONS(2723),
    [anon_sym_return_BANG] = ACTIONS(2725),
    [anon_sym_yield] = ACTIONS(2723),
    [anon_sym_yield_BANG] = ACTIONS(2725),
    [anon_sym_lazy] = ACTIONS(2723),
    [anon_sym_assert] = ACTIONS(2723),
    [anon_sym_upcast] = ACTIONS(2723),
    [anon_sym_downcast] = ACTIONS(2723),
    [anon_sym_COLON_GT] = ACTIONS(2725),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2725),
    [anon_sym_for] = ACTIONS(2723),
    [anon_sym_while] = ACTIONS(2723),
    [anon_sym_if] = ACTIONS(2723),
    [anon_sym_fun] = ACTIONS(2723),
    [anon_sym_DASH_GT] = ACTIONS(2723),
    [anon_sym_try] = ACTIONS(2723),
    [anon_sym_match] = ACTIONS(2723),
    [anon_sym_match_BANG] = ACTIONS(2725),
    [anon_sym_function] = ACTIONS(2723),
    [anon_sym_LT_DASH] = ACTIONS(2723),
    [anon_sym_DOT_LBRACK] = ACTIONS(2725),
    [anon_sym_LT] = ACTIONS(2725),
    [anon_sym_use] = ACTIONS(2723),
    [anon_sym_use_BANG] = ACTIONS(2725),
    [anon_sym_do_BANG] = ACTIONS(2725),
    [anon_sym_DOT_DOT] = ACTIONS(2725),
    [anon_sym_begin] = ACTIONS(2723),
    [anon_sym_LPAREN2] = ACTIONS(2723),
    [anon_sym_or] = ACTIONS(2723),
    [aux_sym_char_token1] = ACTIONS(2725),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2723),
    [anon_sym_DQUOTE] = ACTIONS(2723),
    [anon_sym_AT_DQUOTE] = ACTIONS(2725),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2725),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2725),
    [sym_bool] = ACTIONS(2723),
    [sym_unit] = ACTIONS(2725),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2723),
    [sym_op_identifier] = ACTIONS(2723),
    [anon_sym_PLUS] = ACTIONS(2723),
    [anon_sym_DASH] = ACTIONS(2723),
    [anon_sym_PLUS_DOT] = ACTIONS(2723),
    [anon_sym_DASH_DOT] = ACTIONS(2723),
    [anon_sym_PERCENT] = ACTIONS(2723),
    [anon_sym_AMP_AMP] = ACTIONS(2723),
    [anon_sym_TILDE] = ACTIONS(2725),
    [aux_sym_prefix_op_token1] = ACTIONS(2723),
    [aux_sym_infix_op_token1] = ACTIONS(2725),
    [aux_sym_infix_op_token2] = ACTIONS(2723),
    [anon_sym_PIPE_PIPE] = ACTIONS(2723),
    [anon_sym_BANG_EQ] = ACTIONS(2723),
    [anon_sym_COLON_EQ] = ACTIONS(2725),
    [anon_sym_DOLLAR] = ACTIONS(2723),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2723),
    [sym_int] = ACTIONS(2723),
    [sym_xint] = ACTIONS(2725),
    [anon_sym_f] = ACTIONS(2723),
    [aux_sym_decimal_token1] = ACTIONS(2723),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2725),
    [sym__newline] = ACTIONS(2725),
  },
  [1455] = {
    [sym_block_comment] = STATE(1455),
    [sym_compiler_directive_decl] = STATE(1455),
    [sym_fsi_directive_decl] = STATE(1455),
    [sym_preproc_line] = STATE(1455),
    [aux_sym_long_identifier_repeat1] = STATE(1455),
    [sym_identifier] = ACTIONS(2411),
    [anon_sym_EQ] = ACTIONS(2411),
    [anon_sym_COLON] = ACTIONS(2411),
    [anon_sym_return] = ACTIONS(2411),
    [anon_sym_do] = ACTIONS(2411),
    [anon_sym_let] = ACTIONS(2411),
    [anon_sym_let_BANG] = ACTIONS(2413),
    [anon_sym_LPAREN] = ACTIONS(2411),
    [anon_sym_COMMA] = ACTIONS(2413),
    [anon_sym_null] = ACTIONS(2411),
    [anon_sym_QMARK] = ACTIONS(2411),
    [anon_sym_COLON_QMARK] = ACTIONS(2411),
    [anon_sym_COLON_COLON] = ACTIONS(2413),
    [anon_sym_AMP] = ACTIONS(2411),
    [anon_sym_LBRACK] = ACTIONS(2411),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2413),
    [anon_sym_LBRACE] = ACTIONS(2411),
    [anon_sym_LT_AT] = ACTIONS(2411),
    [anon_sym_LT_AT_AT] = ACTIONS(2411),
    [anon_sym_DOT] = ACTIONS(3660),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2413),
    [anon_sym_new] = ACTIONS(2411),
    [anon_sym_with] = ACTIONS(2411),
    [anon_sym_return_BANG] = ACTIONS(2413),
    [anon_sym_yield] = ACTIONS(2411),
    [anon_sym_yield_BANG] = ACTIONS(2413),
    [anon_sym_lazy] = ACTIONS(2411),
    [anon_sym_assert] = ACTIONS(2411),
    [anon_sym_upcast] = ACTIONS(2411),
    [anon_sym_downcast] = ACTIONS(2411),
    [anon_sym_COLON_GT] = ACTIONS(2413),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2413),
    [anon_sym_for] = ACTIONS(2411),
    [anon_sym_while] = ACTIONS(2411),
    [anon_sym_if] = ACTIONS(2411),
    [anon_sym_fun] = ACTIONS(2411),
    [anon_sym_try] = ACTIONS(2411),
    [anon_sym_match] = ACTIONS(2411),
    [anon_sym_match_BANG] = ACTIONS(2413),
    [anon_sym_function] = ACTIONS(2411),
    [anon_sym_LT_DASH] = ACTIONS(2411),
    [anon_sym_DOT_LBRACK] = ACTIONS(2413),
    [anon_sym_LT] = ACTIONS(2413),
    [anon_sym_use] = ACTIONS(2411),
    [anon_sym_use_BANG] = ACTIONS(2413),
    [anon_sym_do_BANG] = ACTIONS(2413),
    [anon_sym_begin] = ACTIONS(2411),
    [anon_sym_LPAREN2] = ACTIONS(2411),
    [anon_sym_or] = ACTIONS(2411),
    [anon_sym_EQ2] = ACTIONS(2413),
    [aux_sym_char_token1] = ACTIONS(2413),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2411),
    [anon_sym_DQUOTE] = ACTIONS(2411),
    [anon_sym_AT_DQUOTE] = ACTIONS(2413),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2413),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2413),
    [sym_bool] = ACTIONS(2411),
    [sym_unit] = ACTIONS(2413),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2411),
    [sym_op_identifier] = ACTIONS(2411),
    [anon_sym_PLUS] = ACTIONS(2411),
    [anon_sym_DASH] = ACTIONS(2411),
    [anon_sym_PLUS_DOT] = ACTIONS(2411),
    [anon_sym_DASH_DOT] = ACTIONS(2411),
    [anon_sym_PERCENT] = ACTIONS(2411),
    [anon_sym_AMP_AMP] = ACTIONS(2411),
    [anon_sym_TILDE] = ACTIONS(2413),
    [aux_sym_prefix_op_token1] = ACTIONS(2411),
    [aux_sym_infix_op_token1] = ACTIONS(2413),
    [aux_sym_infix_op_token2] = ACTIONS(2411),
    [anon_sym_PIPE_PIPE] = ACTIONS(2411),
    [anon_sym_BANG_EQ] = ACTIONS(2411),
    [anon_sym_COLON_EQ] = ACTIONS(2413),
    [anon_sym_DOLLAR] = ACTIONS(2411),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2411),
    [sym_int] = ACTIONS(2411),
    [sym_xint] = ACTIONS(2413),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2413),
    [sym__newline] = ACTIONS(2413),
    [sym__dedent] = ACTIONS(2413),
  },
  [1456] = {
    [sym_block_comment] = STATE(1456),
    [sym_compiler_directive_decl] = STATE(1456),
    [sym_fsi_directive_decl] = STATE(1456),
    [sym_preproc_line] = STATE(1456),
    [aux_sym_rules_repeat1] = STATE(1456),
    [sym_identifier] = ACTIONS(2713),
    [anon_sym_EQ] = ACTIONS(2715),
    [anon_sym_COLON] = ACTIONS(2713),
    [anon_sym_return] = ACTIONS(2713),
    [anon_sym_do] = ACTIONS(2713),
    [anon_sym_let] = ACTIONS(2713),
    [anon_sym_let_BANG] = ACTIONS(2715),
    [anon_sym_LPAREN] = ACTIONS(2713),
    [anon_sym_COMMA] = ACTIONS(2715),
    [anon_sym_null] = ACTIONS(2713),
    [anon_sym_QMARK] = ACTIONS(2713),
    [anon_sym_COLON_QMARK] = ACTIONS(2713),
    [anon_sym_COLON_COLON] = ACTIONS(2715),
    [anon_sym_PIPE] = ACTIONS(3663),
    [anon_sym_AMP] = ACTIONS(2713),
    [anon_sym_LBRACK] = ACTIONS(2713),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2715),
    [anon_sym_LBRACE] = ACTIONS(2713),
    [anon_sym_LT_AT] = ACTIONS(2713),
    [anon_sym_LT_AT_AT] = ACTIONS(2713),
    [anon_sym_DOT] = ACTIONS(2713),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2715),
    [anon_sym_new] = ACTIONS(2713),
    [anon_sym_return_BANG] = ACTIONS(2715),
    [anon_sym_yield] = ACTIONS(2713),
    [anon_sym_yield_BANG] = ACTIONS(2715),
    [anon_sym_lazy] = ACTIONS(2713),
    [anon_sym_assert] = ACTIONS(2713),
    [anon_sym_upcast] = ACTIONS(2713),
    [anon_sym_downcast] = ACTIONS(2713),
    [anon_sym_COLON_GT] = ACTIONS(2715),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2715),
    [anon_sym_for] = ACTIONS(2713),
    [anon_sym_while] = ACTIONS(2713),
    [anon_sym_if] = ACTIONS(2713),
    [anon_sym_fun] = ACTIONS(2713),
    [anon_sym_try] = ACTIONS(2713),
    [anon_sym_match] = ACTIONS(2713),
    [anon_sym_match_BANG] = ACTIONS(2715),
    [anon_sym_function] = ACTIONS(2713),
    [anon_sym_LT_DASH] = ACTIONS(2713),
    [anon_sym_DOT_LBRACK] = ACTIONS(2715),
    [anon_sym_LT] = ACTIONS(2715),
    [anon_sym_use] = ACTIONS(2713),
    [anon_sym_use_BANG] = ACTIONS(2715),
    [anon_sym_do_BANG] = ACTIONS(2715),
    [anon_sym_begin] = ACTIONS(2713),
    [anon_sym_LPAREN2] = ACTIONS(2713),
    [anon_sym_or] = ACTIONS(2713),
    [aux_sym_char_token1] = ACTIONS(2715),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2713),
    [anon_sym_DQUOTE] = ACTIONS(2713),
    [anon_sym_AT_DQUOTE] = ACTIONS(2715),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2715),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2715),
    [sym_bool] = ACTIONS(2713),
    [sym_unit] = ACTIONS(2715),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2713),
    [sym_op_identifier] = ACTIONS(2713),
    [anon_sym_PLUS] = ACTIONS(2713),
    [anon_sym_DASH] = ACTIONS(2713),
    [anon_sym_PLUS_DOT] = ACTIONS(2713),
    [anon_sym_DASH_DOT] = ACTIONS(2713),
    [anon_sym_PERCENT] = ACTIONS(2713),
    [anon_sym_AMP_AMP] = ACTIONS(2713),
    [anon_sym_TILDE] = ACTIONS(2715),
    [aux_sym_prefix_op_token1] = ACTIONS(2713),
    [aux_sym_infix_op_token1] = ACTIONS(2715),
    [aux_sym_infix_op_token2] = ACTIONS(2713),
    [anon_sym_PIPE_PIPE] = ACTIONS(2713),
    [anon_sym_BANG_EQ] = ACTIONS(2713),
    [anon_sym_COLON_EQ] = ACTIONS(2715),
    [anon_sym_DOLLAR] = ACTIONS(2713),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2713),
    [sym_int] = ACTIONS(2713),
    [sym_xint] = ACTIONS(2715),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2715),
    [anon_sym_POUNDendif] = ACTIONS(2715),
    [anon_sym_POUNDelse] = ACTIONS(2715),
    [sym__newline] = ACTIONS(3666),
  },
  [1457] = {
    [sym_block_comment] = STATE(1457),
    [sym_compiler_directive_decl] = STATE(1457),
    [sym_fsi_directive_decl] = STATE(1457),
    [sym_preproc_line] = STATE(1457),
    [aux_sym_rules_repeat1] = STATE(1465),
    [sym_identifier] = ACTIONS(2737),
    [anon_sym_EQ] = ACTIONS(2739),
    [anon_sym_COLON] = ACTIONS(2737),
    [anon_sym_return] = ACTIONS(2737),
    [anon_sym_do] = ACTIONS(2737),
    [anon_sym_let] = ACTIONS(2737),
    [anon_sym_let_BANG] = ACTIONS(2739),
    [anon_sym_LPAREN] = ACTIONS(2737),
    [anon_sym_COMMA] = ACTIONS(2739),
    [anon_sym_null] = ACTIONS(2737),
    [anon_sym_QMARK] = ACTIONS(2737),
    [anon_sym_COLON_QMARK] = ACTIONS(2737),
    [anon_sym_COLON_COLON] = ACTIONS(2739),
    [anon_sym_PIPE] = ACTIONS(3669),
    [anon_sym_AMP] = ACTIONS(2737),
    [anon_sym_LBRACK] = ACTIONS(2737),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2739),
    [anon_sym_LBRACE] = ACTIONS(2737),
    [anon_sym_LT_AT] = ACTIONS(2737),
    [anon_sym_LT_AT_AT] = ACTIONS(2737),
    [anon_sym_DOT] = ACTIONS(2737),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2739),
    [anon_sym_new] = ACTIONS(2737),
    [anon_sym_return_BANG] = ACTIONS(2739),
    [anon_sym_yield] = ACTIONS(2737),
    [anon_sym_yield_BANG] = ACTIONS(2739),
    [anon_sym_lazy] = ACTIONS(2737),
    [anon_sym_assert] = ACTIONS(2737),
    [anon_sym_upcast] = ACTIONS(2737),
    [anon_sym_downcast] = ACTIONS(2737),
    [anon_sym_COLON_GT] = ACTIONS(2739),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2739),
    [anon_sym_for] = ACTIONS(2737),
    [anon_sym_while] = ACTIONS(2737),
    [anon_sym_if] = ACTIONS(2737),
    [anon_sym_fun] = ACTIONS(2737),
    [anon_sym_DASH_GT] = ACTIONS(2737),
    [anon_sym_try] = ACTIONS(2737),
    [anon_sym_match] = ACTIONS(2737),
    [anon_sym_match_BANG] = ACTIONS(2739),
    [anon_sym_function] = ACTIONS(2737),
    [anon_sym_LT_DASH] = ACTIONS(2737),
    [anon_sym_DOT_LBRACK] = ACTIONS(2739),
    [anon_sym_LT] = ACTIONS(2739),
    [anon_sym_use] = ACTIONS(2737),
    [anon_sym_use_BANG] = ACTIONS(2739),
    [anon_sym_do_BANG] = ACTIONS(2739),
    [anon_sym_DOT_DOT] = ACTIONS(2739),
    [anon_sym_begin] = ACTIONS(2737),
    [anon_sym_LPAREN2] = ACTIONS(2737),
    [anon_sym_or] = ACTIONS(2737),
    [aux_sym_char_token1] = ACTIONS(2739),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2737),
    [anon_sym_DQUOTE] = ACTIONS(2737),
    [anon_sym_AT_DQUOTE] = ACTIONS(2739),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2739),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2739),
    [sym_bool] = ACTIONS(2737),
    [sym_unit] = ACTIONS(2739),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2737),
    [sym_op_identifier] = ACTIONS(2737),
    [anon_sym_PLUS] = ACTIONS(2737),
    [anon_sym_DASH] = ACTIONS(2737),
    [anon_sym_PLUS_DOT] = ACTIONS(2737),
    [anon_sym_DASH_DOT] = ACTIONS(2737),
    [anon_sym_PERCENT] = ACTIONS(2737),
    [anon_sym_AMP_AMP] = ACTIONS(2737),
    [anon_sym_TILDE] = ACTIONS(2739),
    [aux_sym_prefix_op_token1] = ACTIONS(2737),
    [aux_sym_infix_op_token1] = ACTIONS(2739),
    [aux_sym_infix_op_token2] = ACTIONS(2737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2737),
    [anon_sym_BANG_EQ] = ACTIONS(2737),
    [anon_sym_COLON_EQ] = ACTIONS(2739),
    [anon_sym_DOLLAR] = ACTIONS(2737),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2737),
    [sym_int] = ACTIONS(2737),
    [sym_xint] = ACTIONS(2739),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2739),
    [sym__newline] = ACTIONS(3671),
  },
  [1458] = {
    [sym_block_comment] = STATE(1458),
    [sym_compiler_directive_decl] = STATE(1458),
    [sym_fsi_directive_decl] = STATE(1458),
    [sym_preproc_line] = STATE(1458),
    [aux_sym_rules_repeat1] = STATE(1473),
    [sym_identifier] = ACTIONS(2689),
    [anon_sym_EQ] = ACTIONS(2691),
    [anon_sym_COLON] = ACTIONS(2689),
    [anon_sym_return] = ACTIONS(2689),
    [anon_sym_do] = ACTIONS(2689),
    [anon_sym_let] = ACTIONS(2689),
    [anon_sym_let_BANG] = ACTIONS(2691),
    [anon_sym_LPAREN] = ACTIONS(2689),
    [anon_sym_COMMA] = ACTIONS(2691),
    [anon_sym_null] = ACTIONS(2689),
    [anon_sym_QMARK] = ACTIONS(2689),
    [anon_sym_COLON_QMARK] = ACTIONS(2689),
    [anon_sym_COLON_COLON] = ACTIONS(2691),
    [anon_sym_PIPE] = ACTIONS(3652),
    [anon_sym_AMP] = ACTIONS(2689),
    [anon_sym_LBRACK] = ACTIONS(2689),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2691),
    [anon_sym_LBRACE] = ACTIONS(2689),
    [anon_sym_LT_AT] = ACTIONS(2689),
    [anon_sym_LT_AT_AT] = ACTIONS(2689),
    [anon_sym_DOT] = ACTIONS(2689),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2691),
    [anon_sym_new] = ACTIONS(2689),
    [anon_sym_return_BANG] = ACTIONS(2691),
    [anon_sym_yield] = ACTIONS(2689),
    [anon_sym_yield_BANG] = ACTIONS(2691),
    [anon_sym_lazy] = ACTIONS(2689),
    [anon_sym_assert] = ACTIONS(2689),
    [anon_sym_upcast] = ACTIONS(2689),
    [anon_sym_downcast] = ACTIONS(2689),
    [anon_sym_COLON_GT] = ACTIONS(2691),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2691),
    [anon_sym_for] = ACTIONS(2689),
    [anon_sym_while] = ACTIONS(2689),
    [anon_sym_if] = ACTIONS(2689),
    [anon_sym_fun] = ACTIONS(2689),
    [anon_sym_try] = ACTIONS(2689),
    [anon_sym_match] = ACTIONS(2689),
    [anon_sym_match_BANG] = ACTIONS(2691),
    [anon_sym_function] = ACTIONS(2689),
    [anon_sym_LT_DASH] = ACTIONS(2689),
    [anon_sym_DOT_LBRACK] = ACTIONS(2691),
    [anon_sym_LT] = ACTIONS(2691),
    [anon_sym_use] = ACTIONS(2689),
    [anon_sym_use_BANG] = ACTIONS(2691),
    [anon_sym_do_BANG] = ACTIONS(2691),
    [anon_sym_begin] = ACTIONS(2689),
    [anon_sym_LPAREN2] = ACTIONS(2689),
    [anon_sym_or] = ACTIONS(2689),
    [aux_sym_char_token1] = ACTIONS(2691),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2689),
    [anon_sym_DQUOTE] = ACTIONS(2689),
    [anon_sym_AT_DQUOTE] = ACTIONS(2691),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2691),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2691),
    [sym_bool] = ACTIONS(2689),
    [sym_unit] = ACTIONS(2691),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2689),
    [sym_op_identifier] = ACTIONS(2689),
    [anon_sym_PLUS] = ACTIONS(2689),
    [anon_sym_DASH] = ACTIONS(2689),
    [anon_sym_PLUS_DOT] = ACTIONS(2689),
    [anon_sym_DASH_DOT] = ACTIONS(2689),
    [anon_sym_PERCENT] = ACTIONS(2689),
    [anon_sym_AMP_AMP] = ACTIONS(2689),
    [anon_sym_TILDE] = ACTIONS(2691),
    [aux_sym_prefix_op_token1] = ACTIONS(2689),
    [aux_sym_infix_op_token1] = ACTIONS(2691),
    [aux_sym_infix_op_token2] = ACTIONS(2689),
    [anon_sym_PIPE_PIPE] = ACTIONS(2689),
    [anon_sym_BANG_EQ] = ACTIONS(2689),
    [anon_sym_COLON_EQ] = ACTIONS(2691),
    [anon_sym_DOLLAR] = ACTIONS(2689),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2689),
    [sym_int] = ACTIONS(2689),
    [sym_xint] = ACTIONS(2691),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2691),
    [anon_sym_POUNDendif] = ACTIONS(2691),
    [anon_sym_POUNDelse] = ACTIONS(2691),
    [sym__newline] = ACTIONS(3674),
  },
  [1459] = {
    [sym_block_comment] = STATE(1459),
    [sym_compiler_directive_decl] = STATE(1459),
    [sym_fsi_directive_decl] = STATE(1459),
    [sym_preproc_line] = STATE(1459),
    [sym_identifier] = ACTIONS(2723),
    [anon_sym_EQ] = ACTIONS(2725),
    [anon_sym_COLON] = ACTIONS(2723),
    [anon_sym_return] = ACTIONS(2723),
    [anon_sym_do] = ACTIONS(2723),
    [anon_sym_let] = ACTIONS(2723),
    [anon_sym_let_BANG] = ACTIONS(2725),
    [anon_sym_LPAREN] = ACTIONS(2723),
    [anon_sym_COMMA] = ACTIONS(2725),
    [anon_sym_null] = ACTIONS(2723),
    [anon_sym_QMARK] = ACTIONS(2723),
    [anon_sym_COLON_QMARK] = ACTIONS(2723),
    [anon_sym_COLON_COLON] = ACTIONS(2725),
    [anon_sym_AMP] = ACTIONS(2723),
    [anon_sym_LBRACK] = ACTIONS(2723),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2725),
    [anon_sym_LBRACE] = ACTIONS(2723),
    [anon_sym_LT_AT] = ACTIONS(2723),
    [anon_sym_LT_AT_AT] = ACTIONS(2723),
    [anon_sym_DOT] = ACTIONS(2723),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2725),
    [anon_sym_new] = ACTIONS(2723),
    [anon_sym_return_BANG] = ACTIONS(2725),
    [anon_sym_yield] = ACTIONS(2723),
    [anon_sym_yield_BANG] = ACTIONS(2725),
    [anon_sym_lazy] = ACTIONS(2723),
    [anon_sym_assert] = ACTIONS(2723),
    [anon_sym_upcast] = ACTIONS(2723),
    [anon_sym_downcast] = ACTIONS(2723),
    [anon_sym_COLON_GT] = ACTIONS(2725),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2725),
    [anon_sym_for] = ACTIONS(2723),
    [anon_sym_while] = ACTIONS(2723),
    [anon_sym_if] = ACTIONS(2723),
    [anon_sym_fun] = ACTIONS(2723),
    [anon_sym_try] = ACTIONS(2723),
    [anon_sym_match] = ACTIONS(2723),
    [anon_sym_match_BANG] = ACTIONS(2725),
    [anon_sym_function] = ACTIONS(2723),
    [anon_sym_LT_DASH] = ACTIONS(2723),
    [anon_sym_DOT_LBRACK] = ACTIONS(2725),
    [anon_sym_LT] = ACTIONS(2725),
    [anon_sym_use] = ACTIONS(2723),
    [anon_sym_use_BANG] = ACTIONS(2725),
    [anon_sym_do_BANG] = ACTIONS(2725),
    [anon_sym_begin] = ACTIONS(2723),
    [anon_sym_LPAREN2] = ACTIONS(2723),
    [anon_sym_or] = ACTIONS(2723),
    [aux_sym_char_token1] = ACTIONS(2725),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2723),
    [anon_sym_DQUOTE] = ACTIONS(2723),
    [anon_sym_AT_DQUOTE] = ACTIONS(2725),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2725),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2725),
    [sym_bool] = ACTIONS(2723),
    [sym_unit] = ACTIONS(2725),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2723),
    [sym_op_identifier] = ACTIONS(2723),
    [anon_sym_PLUS] = ACTIONS(2723),
    [anon_sym_DASH] = ACTIONS(2723),
    [anon_sym_PLUS_DOT] = ACTIONS(2723),
    [anon_sym_DASH_DOT] = ACTIONS(2723),
    [anon_sym_PERCENT] = ACTIONS(2723),
    [anon_sym_AMP_AMP] = ACTIONS(2723),
    [anon_sym_TILDE] = ACTIONS(2725),
    [aux_sym_prefix_op_token1] = ACTIONS(2723),
    [aux_sym_infix_op_token1] = ACTIONS(2725),
    [aux_sym_infix_op_token2] = ACTIONS(2723),
    [anon_sym_PIPE_PIPE] = ACTIONS(2723),
    [anon_sym_BANG_EQ] = ACTIONS(2723),
    [anon_sym_COLON_EQ] = ACTIONS(2725),
    [anon_sym_DOLLAR] = ACTIONS(2723),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2723),
    [sym_int] = ACTIONS(2723),
    [sym_xint] = ACTIONS(2725),
    [anon_sym_f] = ACTIONS(2723),
    [aux_sym_decimal_token1] = ACTIONS(2723),
    [aux_sym_float_token1] = ACTIONS(3677),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2725),
    [anon_sym_POUNDendif] = ACTIONS(2725),
    [sym__newline] = ACTIONS(2725),
  },
  [1460] = {
    [sym_block_comment] = STATE(1460),
    [sym_compiler_directive_decl] = STATE(1460),
    [sym_fsi_directive_decl] = STATE(1460),
    [sym_preproc_line] = STATE(1460),
    [sym_identifier] = ACTIONS(2685),
    [anon_sym_EQ] = ACTIONS(2687),
    [anon_sym_COLON] = ACTIONS(2685),
    [anon_sym_return] = ACTIONS(2685),
    [anon_sym_do] = ACTIONS(2685),
    [anon_sym_and] = ACTIONS(2685),
    [anon_sym_let] = ACTIONS(2685),
    [anon_sym_let_BANG] = ACTIONS(2687),
    [anon_sym_LPAREN] = ACTIONS(2685),
    [anon_sym_COMMA] = ACTIONS(2687),
    [anon_sym_null] = ACTIONS(2685),
    [anon_sym_QMARK] = ACTIONS(2685),
    [anon_sym_COLON_QMARK] = ACTIONS(2685),
    [anon_sym_COLON_COLON] = ACTIONS(2687),
    [anon_sym_AMP] = ACTIONS(2685),
    [anon_sym_LBRACK] = ACTIONS(2685),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2687),
    [anon_sym_LBRACE] = ACTIONS(2685),
    [anon_sym_LT_AT] = ACTIONS(2685),
    [anon_sym_LT_AT_AT] = ACTIONS(2685),
    [anon_sym_DOT] = ACTIONS(2685),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2687),
    [anon_sym_new] = ACTIONS(2685),
    [anon_sym_return_BANG] = ACTIONS(2687),
    [anon_sym_yield] = ACTIONS(2685),
    [anon_sym_yield_BANG] = ACTIONS(2687),
    [anon_sym_lazy] = ACTIONS(2685),
    [anon_sym_assert] = ACTIONS(2685),
    [anon_sym_upcast] = ACTIONS(2685),
    [anon_sym_downcast] = ACTIONS(2685),
    [anon_sym_COLON_GT] = ACTIONS(2687),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2687),
    [anon_sym_for] = ACTIONS(2685),
    [anon_sym_done] = ACTIONS(2685),
    [anon_sym_while] = ACTIONS(2685),
    [anon_sym_if] = ACTIONS(2685),
    [anon_sym_fun] = ACTIONS(2685),
    [anon_sym_try] = ACTIONS(2685),
    [anon_sym_match] = ACTIONS(2685),
    [anon_sym_match_BANG] = ACTIONS(2687),
    [anon_sym_function] = ACTIONS(2685),
    [anon_sym_LT_DASH] = ACTIONS(2685),
    [anon_sym_DOT_LBRACK] = ACTIONS(2687),
    [anon_sym_LT] = ACTIONS(2687),
    [anon_sym_use] = ACTIONS(2685),
    [anon_sym_use_BANG] = ACTIONS(2687),
    [anon_sym_do_BANG] = ACTIONS(2687),
    [anon_sym_DOT_DOT] = ACTIONS(2687),
    [anon_sym_begin] = ACTIONS(2685),
    [anon_sym_LPAREN2] = ACTIONS(2685),
    [anon_sym_or] = ACTIONS(2685),
    [aux_sym_char_token1] = ACTIONS(2687),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2685),
    [anon_sym_DQUOTE] = ACTIONS(2685),
    [anon_sym_AT_DQUOTE] = ACTIONS(2687),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2687),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2687),
    [sym_bool] = ACTIONS(2685),
    [sym_unit] = ACTIONS(2687),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2685),
    [sym_op_identifier] = ACTIONS(2685),
    [anon_sym_PLUS] = ACTIONS(2685),
    [anon_sym_DASH] = ACTIONS(2685),
    [anon_sym_PLUS_DOT] = ACTIONS(2685),
    [anon_sym_DASH_DOT] = ACTIONS(2685),
    [anon_sym_PERCENT] = ACTIONS(2685),
    [anon_sym_AMP_AMP] = ACTIONS(2685),
    [anon_sym_TILDE] = ACTIONS(2687),
    [aux_sym_prefix_op_token1] = ACTIONS(2685),
    [aux_sym_infix_op_token1] = ACTIONS(2687),
    [aux_sym_infix_op_token2] = ACTIONS(2685),
    [anon_sym_PIPE_PIPE] = ACTIONS(2685),
    [anon_sym_BANG_EQ] = ACTIONS(2685),
    [anon_sym_COLON_EQ] = ACTIONS(2687),
    [anon_sym_DOLLAR] = ACTIONS(2685),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2685),
    [sym_int] = ACTIONS(2685),
    [sym_xint] = ACTIONS(2687),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2687),
    [sym__newline] = ACTIONS(2687),
    [sym__dedent] = ACTIONS(2687),
  },
  [1461] = {
    [sym_block_comment] = STATE(1461),
    [sym_compiler_directive_decl] = STATE(1461),
    [sym_fsi_directive_decl] = STATE(1461),
    [sym_preproc_line] = STATE(1461),
    [aux_sym_rules_repeat1] = STATE(1464),
    [sym_identifier] = ACTIONS(2689),
    [anon_sym_EQ] = ACTIONS(2691),
    [anon_sym_COLON] = ACTIONS(2689),
    [anon_sym_return] = ACTIONS(2689),
    [anon_sym_do] = ACTIONS(2689),
    [anon_sym_let] = ACTIONS(2689),
    [anon_sym_let_BANG] = ACTIONS(2691),
    [anon_sym_LPAREN] = ACTIONS(2689),
    [anon_sym_COMMA] = ACTIONS(2691),
    [anon_sym_null] = ACTIONS(2689),
    [anon_sym_QMARK] = ACTIONS(2689),
    [anon_sym_COLON_QMARK] = ACTIONS(2689),
    [anon_sym_COLON_COLON] = ACTIONS(2691),
    [anon_sym_PIPE] = ACTIONS(3669),
    [anon_sym_AMP] = ACTIONS(2689),
    [anon_sym_LBRACK] = ACTIONS(2689),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2691),
    [anon_sym_LBRACE] = ACTIONS(2689),
    [anon_sym_LT_AT] = ACTIONS(2689),
    [anon_sym_LT_AT_AT] = ACTIONS(2689),
    [anon_sym_DOT] = ACTIONS(2689),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2691),
    [anon_sym_new] = ACTIONS(2689),
    [anon_sym_return_BANG] = ACTIONS(2691),
    [anon_sym_yield] = ACTIONS(2689),
    [anon_sym_yield_BANG] = ACTIONS(2691),
    [anon_sym_lazy] = ACTIONS(2689),
    [anon_sym_assert] = ACTIONS(2689),
    [anon_sym_upcast] = ACTIONS(2689),
    [anon_sym_downcast] = ACTIONS(2689),
    [anon_sym_COLON_GT] = ACTIONS(2691),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2691),
    [anon_sym_for] = ACTIONS(2689),
    [anon_sym_while] = ACTIONS(2689),
    [anon_sym_if] = ACTIONS(2689),
    [anon_sym_fun] = ACTIONS(2689),
    [anon_sym_DASH_GT] = ACTIONS(2689),
    [anon_sym_try] = ACTIONS(2689),
    [anon_sym_match] = ACTIONS(2689),
    [anon_sym_match_BANG] = ACTIONS(2691),
    [anon_sym_function] = ACTIONS(2689),
    [anon_sym_LT_DASH] = ACTIONS(2689),
    [anon_sym_DOT_LBRACK] = ACTIONS(2691),
    [anon_sym_LT] = ACTIONS(2691),
    [anon_sym_use] = ACTIONS(2689),
    [anon_sym_use_BANG] = ACTIONS(2691),
    [anon_sym_do_BANG] = ACTIONS(2691),
    [anon_sym_DOT_DOT] = ACTIONS(2691),
    [anon_sym_begin] = ACTIONS(2689),
    [anon_sym_LPAREN2] = ACTIONS(2689),
    [anon_sym_or] = ACTIONS(2689),
    [aux_sym_char_token1] = ACTIONS(2691),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2689),
    [anon_sym_DQUOTE] = ACTIONS(2689),
    [anon_sym_AT_DQUOTE] = ACTIONS(2691),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2691),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2691),
    [sym_bool] = ACTIONS(2689),
    [sym_unit] = ACTIONS(2691),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2689),
    [sym_op_identifier] = ACTIONS(2689),
    [anon_sym_PLUS] = ACTIONS(2689),
    [anon_sym_DASH] = ACTIONS(2689),
    [anon_sym_PLUS_DOT] = ACTIONS(2689),
    [anon_sym_DASH_DOT] = ACTIONS(2689),
    [anon_sym_PERCENT] = ACTIONS(2689),
    [anon_sym_AMP_AMP] = ACTIONS(2689),
    [anon_sym_TILDE] = ACTIONS(2691),
    [aux_sym_prefix_op_token1] = ACTIONS(2689),
    [aux_sym_infix_op_token1] = ACTIONS(2691),
    [aux_sym_infix_op_token2] = ACTIONS(2689),
    [anon_sym_PIPE_PIPE] = ACTIONS(2689),
    [anon_sym_BANG_EQ] = ACTIONS(2689),
    [anon_sym_COLON_EQ] = ACTIONS(2691),
    [anon_sym_DOLLAR] = ACTIONS(2689),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2689),
    [sym_int] = ACTIONS(2689),
    [sym_xint] = ACTIONS(2691),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2691),
    [sym__newline] = ACTIONS(3679),
  },
  [1462] = {
    [sym_block_comment] = STATE(1462),
    [sym_compiler_directive_decl] = STATE(1462),
    [sym_fsi_directive_decl] = STATE(1462),
    [sym_preproc_line] = STATE(1462),
    [sym_identifier] = ACTIONS(2783),
    [anon_sym_EQ] = ACTIONS(2785),
    [anon_sym_COLON] = ACTIONS(2783),
    [anon_sym_return] = ACTIONS(2783),
    [anon_sym_do] = ACTIONS(2783),
    [anon_sym_let] = ACTIONS(2783),
    [anon_sym_let_BANG] = ACTIONS(2785),
    [anon_sym_LPAREN] = ACTIONS(2783),
    [anon_sym_COMMA] = ACTIONS(2785),
    [anon_sym_null] = ACTIONS(2783),
    [anon_sym_QMARK] = ACTIONS(2783),
    [anon_sym_COLON_QMARK] = ACTIONS(2783),
    [anon_sym_COLON_COLON] = ACTIONS(2785),
    [anon_sym_AMP] = ACTIONS(2783),
    [anon_sym_LBRACK] = ACTIONS(2783),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2785),
    [anon_sym_LBRACE] = ACTIONS(2783),
    [anon_sym_LT_AT] = ACTIONS(2783),
    [anon_sym_LT_AT_AT] = ACTIONS(2783),
    [anon_sym_DOT] = ACTIONS(2783),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2785),
    [anon_sym_new] = ACTIONS(2783),
    [anon_sym_return_BANG] = ACTIONS(2785),
    [anon_sym_yield] = ACTIONS(2783),
    [anon_sym_yield_BANG] = ACTIONS(2785),
    [anon_sym_lazy] = ACTIONS(2783),
    [anon_sym_assert] = ACTIONS(2783),
    [anon_sym_upcast] = ACTIONS(2783),
    [anon_sym_downcast] = ACTIONS(2783),
    [anon_sym_COLON_GT] = ACTIONS(2785),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2785),
    [anon_sym_for] = ACTIONS(2783),
    [anon_sym_done] = ACTIONS(2787),
    [anon_sym_while] = ACTIONS(2783),
    [anon_sym_if] = ACTIONS(2783),
    [anon_sym_fun] = ACTIONS(2783),
    [anon_sym_try] = ACTIONS(2783),
    [anon_sym_match] = ACTIONS(2783),
    [anon_sym_match_BANG] = ACTIONS(2785),
    [anon_sym_function] = ACTIONS(2783),
    [anon_sym_LT_DASH] = ACTIONS(2783),
    [anon_sym_DOT_LBRACK] = ACTIONS(2785),
    [anon_sym_LT] = ACTIONS(2785),
    [anon_sym_use] = ACTIONS(2783),
    [anon_sym_use_BANG] = ACTIONS(2785),
    [anon_sym_do_BANG] = ACTIONS(2785),
    [anon_sym_DOT_DOT] = ACTIONS(2881),
    [anon_sym_begin] = ACTIONS(2783),
    [anon_sym_LPAREN2] = ACTIONS(2783),
    [anon_sym_DOT_DOT2] = ACTIONS(2785),
    [anon_sym_or] = ACTIONS(2783),
    [aux_sym_char_token1] = ACTIONS(2785),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2783),
    [anon_sym_DQUOTE] = ACTIONS(2783),
    [anon_sym_AT_DQUOTE] = ACTIONS(2785),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2785),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2785),
    [sym_bool] = ACTIONS(2783),
    [sym_unit] = ACTIONS(2785),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2783),
    [sym_op_identifier] = ACTIONS(2783),
    [anon_sym_PLUS] = ACTIONS(2783),
    [anon_sym_DASH] = ACTIONS(2783),
    [anon_sym_PLUS_DOT] = ACTIONS(2783),
    [anon_sym_DASH_DOT] = ACTIONS(2783),
    [anon_sym_PERCENT] = ACTIONS(2783),
    [anon_sym_AMP_AMP] = ACTIONS(2783),
    [anon_sym_TILDE] = ACTIONS(2785),
    [aux_sym_prefix_op_token1] = ACTIONS(2783),
    [aux_sym_infix_op_token1] = ACTIONS(2785),
    [aux_sym_infix_op_token2] = ACTIONS(2783),
    [anon_sym_PIPE_PIPE] = ACTIONS(2783),
    [anon_sym_BANG_EQ] = ACTIONS(2783),
    [anon_sym_COLON_EQ] = ACTIONS(2785),
    [anon_sym_DOLLAR] = ACTIONS(2783),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2783),
    [sym_int] = ACTIONS(2783),
    [sym_xint] = ACTIONS(2785),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2785),
    [sym__newline] = ACTIONS(2785),
    [sym__dedent] = ACTIONS(2785),
  },
  [1463] = {
    [sym_block_comment] = STATE(1463),
    [sym_compiler_directive_decl] = STATE(1463),
    [sym_fsi_directive_decl] = STATE(1463),
    [sym_preproc_line] = STATE(1463),
    [aux_sym_rules_repeat1] = STATE(1457),
    [sym_identifier] = ACTIONS(2698),
    [anon_sym_EQ] = ACTIONS(2700),
    [anon_sym_COLON] = ACTIONS(2698),
    [anon_sym_return] = ACTIONS(2698),
    [anon_sym_do] = ACTIONS(2698),
    [anon_sym_let] = ACTIONS(2698),
    [anon_sym_let_BANG] = ACTIONS(2700),
    [anon_sym_LPAREN] = ACTIONS(2698),
    [anon_sym_COMMA] = ACTIONS(2700),
    [anon_sym_null] = ACTIONS(2698),
    [anon_sym_QMARK] = ACTIONS(2698),
    [anon_sym_COLON_QMARK] = ACTIONS(2698),
    [anon_sym_COLON_COLON] = ACTIONS(2700),
    [anon_sym_PIPE] = ACTIONS(3669),
    [anon_sym_AMP] = ACTIONS(2698),
    [anon_sym_LBRACK] = ACTIONS(2698),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2700),
    [anon_sym_LBRACE] = ACTIONS(2698),
    [anon_sym_LT_AT] = ACTIONS(2698),
    [anon_sym_LT_AT_AT] = ACTIONS(2698),
    [anon_sym_DOT] = ACTIONS(2698),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2700),
    [anon_sym_new] = ACTIONS(2698),
    [anon_sym_return_BANG] = ACTIONS(2700),
    [anon_sym_yield] = ACTIONS(2698),
    [anon_sym_yield_BANG] = ACTIONS(2700),
    [anon_sym_lazy] = ACTIONS(2698),
    [anon_sym_assert] = ACTIONS(2698),
    [anon_sym_upcast] = ACTIONS(2698),
    [anon_sym_downcast] = ACTIONS(2698),
    [anon_sym_COLON_GT] = ACTIONS(2700),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2700),
    [anon_sym_for] = ACTIONS(2698),
    [anon_sym_while] = ACTIONS(2698),
    [anon_sym_if] = ACTIONS(2698),
    [anon_sym_fun] = ACTIONS(2698),
    [anon_sym_DASH_GT] = ACTIONS(2698),
    [anon_sym_try] = ACTIONS(2698),
    [anon_sym_match] = ACTIONS(2698),
    [anon_sym_match_BANG] = ACTIONS(2700),
    [anon_sym_function] = ACTIONS(2698),
    [anon_sym_LT_DASH] = ACTIONS(2698),
    [anon_sym_DOT_LBRACK] = ACTIONS(2700),
    [anon_sym_LT] = ACTIONS(2700),
    [anon_sym_use] = ACTIONS(2698),
    [anon_sym_use_BANG] = ACTIONS(2700),
    [anon_sym_do_BANG] = ACTIONS(2700),
    [anon_sym_DOT_DOT] = ACTIONS(2700),
    [anon_sym_begin] = ACTIONS(2698),
    [anon_sym_LPAREN2] = ACTIONS(2698),
    [anon_sym_or] = ACTIONS(2698),
    [aux_sym_char_token1] = ACTIONS(2700),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2698),
    [anon_sym_DQUOTE] = ACTIONS(2698),
    [anon_sym_AT_DQUOTE] = ACTIONS(2700),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2700),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2700),
    [sym_bool] = ACTIONS(2698),
    [sym_unit] = ACTIONS(2700),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2698),
    [sym_op_identifier] = ACTIONS(2698),
    [anon_sym_PLUS] = ACTIONS(2698),
    [anon_sym_DASH] = ACTIONS(2698),
    [anon_sym_PLUS_DOT] = ACTIONS(2698),
    [anon_sym_DASH_DOT] = ACTIONS(2698),
    [anon_sym_PERCENT] = ACTIONS(2698),
    [anon_sym_AMP_AMP] = ACTIONS(2698),
    [anon_sym_TILDE] = ACTIONS(2700),
    [aux_sym_prefix_op_token1] = ACTIONS(2698),
    [aux_sym_infix_op_token1] = ACTIONS(2700),
    [aux_sym_infix_op_token2] = ACTIONS(2698),
    [anon_sym_PIPE_PIPE] = ACTIONS(2698),
    [anon_sym_BANG_EQ] = ACTIONS(2698),
    [anon_sym_COLON_EQ] = ACTIONS(2700),
    [anon_sym_DOLLAR] = ACTIONS(2698),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2698),
    [sym_int] = ACTIONS(2698),
    [sym_xint] = ACTIONS(2700),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2700),
    [sym__newline] = ACTIONS(3682),
  },
  [1464] = {
    [sym_block_comment] = STATE(1464),
    [sym_compiler_directive_decl] = STATE(1464),
    [sym_fsi_directive_decl] = STATE(1464),
    [sym_preproc_line] = STATE(1464),
    [aux_sym_rules_repeat1] = STATE(1465),
    [sym_identifier] = ACTIONS(2698),
    [anon_sym_EQ] = ACTIONS(2700),
    [anon_sym_COLON] = ACTIONS(2698),
    [anon_sym_return] = ACTIONS(2698),
    [anon_sym_do] = ACTIONS(2698),
    [anon_sym_let] = ACTIONS(2698),
    [anon_sym_let_BANG] = ACTIONS(2700),
    [anon_sym_LPAREN] = ACTIONS(2698),
    [anon_sym_COMMA] = ACTIONS(2700),
    [anon_sym_null] = ACTIONS(2698),
    [anon_sym_QMARK] = ACTIONS(2698),
    [anon_sym_COLON_QMARK] = ACTIONS(2698),
    [anon_sym_COLON_COLON] = ACTIONS(2700),
    [anon_sym_PIPE] = ACTIONS(3669),
    [anon_sym_AMP] = ACTIONS(2698),
    [anon_sym_LBRACK] = ACTIONS(2698),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2700),
    [anon_sym_LBRACE] = ACTIONS(2698),
    [anon_sym_LT_AT] = ACTIONS(2698),
    [anon_sym_LT_AT_AT] = ACTIONS(2698),
    [anon_sym_DOT] = ACTIONS(2698),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2700),
    [anon_sym_new] = ACTIONS(2698),
    [anon_sym_return_BANG] = ACTIONS(2700),
    [anon_sym_yield] = ACTIONS(2698),
    [anon_sym_yield_BANG] = ACTIONS(2700),
    [anon_sym_lazy] = ACTIONS(2698),
    [anon_sym_assert] = ACTIONS(2698),
    [anon_sym_upcast] = ACTIONS(2698),
    [anon_sym_downcast] = ACTIONS(2698),
    [anon_sym_COLON_GT] = ACTIONS(2700),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2700),
    [anon_sym_for] = ACTIONS(2698),
    [anon_sym_while] = ACTIONS(2698),
    [anon_sym_if] = ACTIONS(2698),
    [anon_sym_fun] = ACTIONS(2698),
    [anon_sym_DASH_GT] = ACTIONS(2698),
    [anon_sym_try] = ACTIONS(2698),
    [anon_sym_match] = ACTIONS(2698),
    [anon_sym_match_BANG] = ACTIONS(2700),
    [anon_sym_function] = ACTIONS(2698),
    [anon_sym_LT_DASH] = ACTIONS(2698),
    [anon_sym_DOT_LBRACK] = ACTIONS(2700),
    [anon_sym_LT] = ACTIONS(2700),
    [anon_sym_use] = ACTIONS(2698),
    [anon_sym_use_BANG] = ACTIONS(2700),
    [anon_sym_do_BANG] = ACTIONS(2700),
    [anon_sym_DOT_DOT] = ACTIONS(2700),
    [anon_sym_begin] = ACTIONS(2698),
    [anon_sym_LPAREN2] = ACTIONS(2698),
    [anon_sym_or] = ACTIONS(2698),
    [aux_sym_char_token1] = ACTIONS(2700),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2698),
    [anon_sym_DQUOTE] = ACTIONS(2698),
    [anon_sym_AT_DQUOTE] = ACTIONS(2700),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2700),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2700),
    [sym_bool] = ACTIONS(2698),
    [sym_unit] = ACTIONS(2700),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2698),
    [sym_op_identifier] = ACTIONS(2698),
    [anon_sym_PLUS] = ACTIONS(2698),
    [anon_sym_DASH] = ACTIONS(2698),
    [anon_sym_PLUS_DOT] = ACTIONS(2698),
    [anon_sym_DASH_DOT] = ACTIONS(2698),
    [anon_sym_PERCENT] = ACTIONS(2698),
    [anon_sym_AMP_AMP] = ACTIONS(2698),
    [anon_sym_TILDE] = ACTIONS(2700),
    [aux_sym_prefix_op_token1] = ACTIONS(2698),
    [aux_sym_infix_op_token1] = ACTIONS(2700),
    [aux_sym_infix_op_token2] = ACTIONS(2698),
    [anon_sym_PIPE_PIPE] = ACTIONS(2698),
    [anon_sym_BANG_EQ] = ACTIONS(2698),
    [anon_sym_COLON_EQ] = ACTIONS(2700),
    [anon_sym_DOLLAR] = ACTIONS(2698),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2698),
    [sym_int] = ACTIONS(2698),
    [sym_xint] = ACTIONS(2700),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2700),
    [sym__newline] = ACTIONS(3682),
  },
  [1465] = {
    [sym_block_comment] = STATE(1465),
    [sym_compiler_directive_decl] = STATE(1465),
    [sym_fsi_directive_decl] = STATE(1465),
    [sym_preproc_line] = STATE(1465),
    [aux_sym_rules_repeat1] = STATE(1465),
    [sym_identifier] = ACTIONS(2713),
    [anon_sym_EQ] = ACTIONS(2715),
    [anon_sym_COLON] = ACTIONS(2713),
    [anon_sym_return] = ACTIONS(2713),
    [anon_sym_do] = ACTIONS(2713),
    [anon_sym_let] = ACTIONS(2713),
    [anon_sym_let_BANG] = ACTIONS(2715),
    [anon_sym_LPAREN] = ACTIONS(2713),
    [anon_sym_COMMA] = ACTIONS(2715),
    [anon_sym_null] = ACTIONS(2713),
    [anon_sym_QMARK] = ACTIONS(2713),
    [anon_sym_COLON_QMARK] = ACTIONS(2713),
    [anon_sym_COLON_COLON] = ACTIONS(2715),
    [anon_sym_PIPE] = ACTIONS(3685),
    [anon_sym_AMP] = ACTIONS(2713),
    [anon_sym_LBRACK] = ACTIONS(2713),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2715),
    [anon_sym_LBRACE] = ACTIONS(2713),
    [anon_sym_LT_AT] = ACTIONS(2713),
    [anon_sym_LT_AT_AT] = ACTIONS(2713),
    [anon_sym_DOT] = ACTIONS(2713),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2715),
    [anon_sym_new] = ACTIONS(2713),
    [anon_sym_return_BANG] = ACTIONS(2715),
    [anon_sym_yield] = ACTIONS(2713),
    [anon_sym_yield_BANG] = ACTIONS(2715),
    [anon_sym_lazy] = ACTIONS(2713),
    [anon_sym_assert] = ACTIONS(2713),
    [anon_sym_upcast] = ACTIONS(2713),
    [anon_sym_downcast] = ACTIONS(2713),
    [anon_sym_COLON_GT] = ACTIONS(2715),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2715),
    [anon_sym_for] = ACTIONS(2713),
    [anon_sym_while] = ACTIONS(2713),
    [anon_sym_if] = ACTIONS(2713),
    [anon_sym_fun] = ACTIONS(2713),
    [anon_sym_DASH_GT] = ACTIONS(2713),
    [anon_sym_try] = ACTIONS(2713),
    [anon_sym_match] = ACTIONS(2713),
    [anon_sym_match_BANG] = ACTIONS(2715),
    [anon_sym_function] = ACTIONS(2713),
    [anon_sym_LT_DASH] = ACTIONS(2713),
    [anon_sym_DOT_LBRACK] = ACTIONS(2715),
    [anon_sym_LT] = ACTIONS(2715),
    [anon_sym_use] = ACTIONS(2713),
    [anon_sym_use_BANG] = ACTIONS(2715),
    [anon_sym_do_BANG] = ACTIONS(2715),
    [anon_sym_DOT_DOT] = ACTIONS(2715),
    [anon_sym_begin] = ACTIONS(2713),
    [anon_sym_LPAREN2] = ACTIONS(2713),
    [anon_sym_or] = ACTIONS(2713),
    [aux_sym_char_token1] = ACTIONS(2715),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2713),
    [anon_sym_DQUOTE] = ACTIONS(2713),
    [anon_sym_AT_DQUOTE] = ACTIONS(2715),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2715),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2715),
    [sym_bool] = ACTIONS(2713),
    [sym_unit] = ACTIONS(2715),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2713),
    [sym_op_identifier] = ACTIONS(2713),
    [anon_sym_PLUS] = ACTIONS(2713),
    [anon_sym_DASH] = ACTIONS(2713),
    [anon_sym_PLUS_DOT] = ACTIONS(2713),
    [anon_sym_DASH_DOT] = ACTIONS(2713),
    [anon_sym_PERCENT] = ACTIONS(2713),
    [anon_sym_AMP_AMP] = ACTIONS(2713),
    [anon_sym_TILDE] = ACTIONS(2715),
    [aux_sym_prefix_op_token1] = ACTIONS(2713),
    [aux_sym_infix_op_token1] = ACTIONS(2715),
    [aux_sym_infix_op_token2] = ACTIONS(2713),
    [anon_sym_PIPE_PIPE] = ACTIONS(2713),
    [anon_sym_BANG_EQ] = ACTIONS(2713),
    [anon_sym_COLON_EQ] = ACTIONS(2715),
    [anon_sym_DOLLAR] = ACTIONS(2713),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2713),
    [sym_int] = ACTIONS(2713),
    [sym_xint] = ACTIONS(2715),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2715),
    [sym__newline] = ACTIONS(3688),
  },
  [1466] = {
    [sym_block_comment] = STATE(1466),
    [sym_compiler_directive_decl] = STATE(1466),
    [sym_fsi_directive_decl] = STATE(1466),
    [sym_preproc_line] = STATE(1466),
    [aux_sym_long_identifier_repeat1] = STATE(1452),
    [sym_identifier] = ACTIONS(2418),
    [anon_sym_EQ] = ACTIONS(2420),
    [anon_sym_COLON] = ACTIONS(2418),
    [anon_sym_return] = ACTIONS(2418),
    [anon_sym_do] = ACTIONS(2418),
    [anon_sym_let] = ACTIONS(2418),
    [anon_sym_let_BANG] = ACTIONS(2420),
    [anon_sym_as] = ACTIONS(2418),
    [anon_sym_LPAREN] = ACTIONS(2418),
    [anon_sym_COMMA] = ACTIONS(2420),
    [anon_sym_null] = ACTIONS(2418),
    [anon_sym_QMARK] = ACTIONS(2418),
    [anon_sym_COLON_QMARK] = ACTIONS(2418),
    [anon_sym_COLON_COLON] = ACTIONS(2420),
    [anon_sym_AMP] = ACTIONS(2418),
    [anon_sym_LBRACK] = ACTIONS(2418),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2420),
    [anon_sym_LBRACE] = ACTIONS(2418),
    [anon_sym_LT_AT] = ACTIONS(2418),
    [anon_sym_LT_AT_AT] = ACTIONS(2418),
    [anon_sym_DOT] = ACTIONS(3691),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2420),
    [anon_sym_new] = ACTIONS(2418),
    [anon_sym_with] = ACTIONS(2418),
    [anon_sym_return_BANG] = ACTIONS(2420),
    [anon_sym_yield] = ACTIONS(2418),
    [anon_sym_yield_BANG] = ACTIONS(2420),
    [anon_sym_lazy] = ACTIONS(2418),
    [anon_sym_assert] = ACTIONS(2418),
    [anon_sym_upcast] = ACTIONS(2418),
    [anon_sym_downcast] = ACTIONS(2418),
    [anon_sym_COLON_GT] = ACTIONS(2420),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2420),
    [anon_sym_for] = ACTIONS(2418),
    [anon_sym_while] = ACTIONS(2418),
    [anon_sym_if] = ACTIONS(2418),
    [anon_sym_fun] = ACTIONS(2418),
    [anon_sym_try] = ACTIONS(2418),
    [anon_sym_match] = ACTIONS(2418),
    [anon_sym_match_BANG] = ACTIONS(2420),
    [anon_sym_function] = ACTIONS(2418),
    [anon_sym_LT_DASH] = ACTIONS(2418),
    [anon_sym_DOT_LBRACK] = ACTIONS(2420),
    [anon_sym_LT] = ACTIONS(2420),
    [anon_sym_use] = ACTIONS(2418),
    [anon_sym_use_BANG] = ACTIONS(2420),
    [anon_sym_do_BANG] = ACTIONS(2420),
    [anon_sym_begin] = ACTIONS(2418),
    [anon_sym_LPAREN2] = ACTIONS(2418),
    [anon_sym_or] = ACTIONS(2418),
    [aux_sym_char_token1] = ACTIONS(2420),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2418),
    [anon_sym_DQUOTE] = ACTIONS(2418),
    [anon_sym_AT_DQUOTE] = ACTIONS(2420),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2420),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2420),
    [sym_bool] = ACTIONS(2418),
    [sym_unit] = ACTIONS(2420),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2418),
    [sym_op_identifier] = ACTIONS(2418),
    [anon_sym_PLUS] = ACTIONS(2418),
    [anon_sym_DASH] = ACTIONS(2418),
    [anon_sym_PLUS_DOT] = ACTIONS(2418),
    [anon_sym_DASH_DOT] = ACTIONS(2418),
    [anon_sym_PERCENT] = ACTIONS(2418),
    [anon_sym_AMP_AMP] = ACTIONS(2418),
    [anon_sym_TILDE] = ACTIONS(2420),
    [aux_sym_prefix_op_token1] = ACTIONS(2418),
    [aux_sym_infix_op_token1] = ACTIONS(2420),
    [aux_sym_infix_op_token2] = ACTIONS(2418),
    [anon_sym_PIPE_PIPE] = ACTIONS(2418),
    [anon_sym_BANG_EQ] = ACTIONS(2418),
    [anon_sym_COLON_EQ] = ACTIONS(2420),
    [anon_sym_DOLLAR] = ACTIONS(2418),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2418),
    [sym_int] = ACTIONS(2418),
    [sym_xint] = ACTIONS(2420),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2420),
    [sym__newline] = ACTIONS(2420),
    [sym__dedent] = ACTIONS(2420),
  },
  [1467] = {
    [sym_block_comment] = STATE(1467),
    [sym_compiler_directive_decl] = STATE(1467),
    [sym_fsi_directive_decl] = STATE(1467),
    [sym_preproc_line] = STATE(1467),
    [sym_identifier] = ACTIONS(2812),
    [anon_sym_EQ] = ACTIONS(2814),
    [anon_sym_COLON] = ACTIONS(2812),
    [anon_sym_return] = ACTIONS(2812),
    [anon_sym_do] = ACTIONS(2812),
    [anon_sym_let] = ACTIONS(2812),
    [anon_sym_let_BANG] = ACTIONS(2814),
    [anon_sym_LPAREN] = ACTIONS(2812),
    [anon_sym_COMMA] = ACTIONS(2814),
    [anon_sym_null] = ACTIONS(2812),
    [anon_sym_QMARK] = ACTIONS(2812),
    [anon_sym_COLON_QMARK] = ACTIONS(2812),
    [anon_sym_COLON_COLON] = ACTIONS(2814),
    [anon_sym_AMP] = ACTIONS(2812),
    [anon_sym_LBRACK] = ACTIONS(2812),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2814),
    [anon_sym_LBRACE] = ACTIONS(2812),
    [anon_sym_LT_AT] = ACTIONS(2812),
    [anon_sym_LT_AT_AT] = ACTIONS(2812),
    [anon_sym_DOT] = ACTIONS(2812),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2814),
    [anon_sym_new] = ACTIONS(2812),
    [anon_sym_return_BANG] = ACTIONS(2814),
    [anon_sym_yield] = ACTIONS(2812),
    [anon_sym_yield_BANG] = ACTIONS(2814),
    [anon_sym_lazy] = ACTIONS(2812),
    [anon_sym_assert] = ACTIONS(2812),
    [anon_sym_upcast] = ACTIONS(2812),
    [anon_sym_downcast] = ACTIONS(2812),
    [anon_sym_COLON_GT] = ACTIONS(2814),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2814),
    [anon_sym_for] = ACTIONS(2812),
    [anon_sym_while] = ACTIONS(2812),
    [anon_sym_if] = ACTIONS(2812),
    [anon_sym_fun] = ACTIONS(2812),
    [anon_sym_DASH_GT] = ACTIONS(2812),
    [anon_sym_try] = ACTIONS(2812),
    [anon_sym_match] = ACTIONS(2812),
    [anon_sym_match_BANG] = ACTIONS(2814),
    [anon_sym_function] = ACTIONS(2812),
    [anon_sym_LT_DASH] = ACTIONS(2812),
    [anon_sym_DOT_LBRACK] = ACTIONS(2814),
    [anon_sym_LT] = ACTIONS(2814),
    [anon_sym_use] = ACTIONS(2812),
    [anon_sym_use_BANG] = ACTIONS(2814),
    [anon_sym_do_BANG] = ACTIONS(2814),
    [anon_sym_DOT_DOT] = ACTIONS(2814),
    [anon_sym_begin] = ACTIONS(2812),
    [anon_sym_LPAREN2] = ACTIONS(2812),
    [anon_sym_or] = ACTIONS(2812),
    [aux_sym_char_token1] = ACTIONS(2814),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2812),
    [anon_sym_DQUOTE] = ACTIONS(2812),
    [anon_sym_AT_DQUOTE] = ACTIONS(2814),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2814),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2814),
    [sym_bool] = ACTIONS(2812),
    [sym_unit] = ACTIONS(2814),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2812),
    [sym_op_identifier] = ACTIONS(2812),
    [anon_sym_PLUS] = ACTIONS(2812),
    [anon_sym_DASH] = ACTIONS(2812),
    [anon_sym_PLUS_DOT] = ACTIONS(2812),
    [anon_sym_DASH_DOT] = ACTIONS(2812),
    [anon_sym_PERCENT] = ACTIONS(2812),
    [anon_sym_AMP_AMP] = ACTIONS(2812),
    [anon_sym_TILDE] = ACTIONS(2814),
    [aux_sym_prefix_op_token1] = ACTIONS(2812),
    [aux_sym_infix_op_token1] = ACTIONS(2814),
    [aux_sym_infix_op_token2] = ACTIONS(2812),
    [anon_sym_PIPE_PIPE] = ACTIONS(2812),
    [anon_sym_BANG_EQ] = ACTIONS(2812),
    [anon_sym_COLON_EQ] = ACTIONS(2814),
    [anon_sym_DOLLAR] = ACTIONS(2812),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2812),
    [sym_int] = ACTIONS(2812),
    [sym_xint] = ACTIONS(2814),
    [anon_sym_f] = ACTIONS(2812),
    [aux_sym_decimal_token1] = ACTIONS(2812),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2814),
    [sym__newline] = ACTIONS(2814),
  },
  [1468] = {
    [sym_block_comment] = STATE(1468),
    [sym_compiler_directive_decl] = STATE(1468),
    [sym_fsi_directive_decl] = STATE(1468),
    [sym_preproc_line] = STATE(1468),
    [sym_identifier] = ACTIONS(2729),
    [anon_sym_EQ] = ACTIONS(2731),
    [anon_sym_COLON] = ACTIONS(2729),
    [anon_sym_return] = ACTIONS(2729),
    [anon_sym_do] = ACTIONS(2729),
    [anon_sym_let] = ACTIONS(2729),
    [anon_sym_let_BANG] = ACTIONS(2731),
    [anon_sym_as] = ACTIONS(2729),
    [anon_sym_LPAREN] = ACTIONS(2729),
    [anon_sym_COMMA] = ACTIONS(2731),
    [anon_sym_null] = ACTIONS(2729),
    [anon_sym_QMARK] = ACTIONS(2729),
    [anon_sym_COLON_QMARK] = ACTIONS(2729),
    [anon_sym_COLON_COLON] = ACTIONS(2731),
    [anon_sym_AMP] = ACTIONS(2729),
    [anon_sym_LBRACK] = ACTIONS(2729),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2731),
    [anon_sym_LBRACE] = ACTIONS(2729),
    [anon_sym_LT_AT] = ACTIONS(2729),
    [anon_sym_LT_AT_AT] = ACTIONS(2729),
    [anon_sym_DOT] = ACTIONS(2729),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2731),
    [anon_sym_new] = ACTIONS(2729),
    [anon_sym_with] = ACTIONS(2729),
    [anon_sym_return_BANG] = ACTIONS(2731),
    [anon_sym_yield] = ACTIONS(2729),
    [anon_sym_yield_BANG] = ACTIONS(2731),
    [anon_sym_lazy] = ACTIONS(2729),
    [anon_sym_assert] = ACTIONS(2729),
    [anon_sym_upcast] = ACTIONS(2729),
    [anon_sym_downcast] = ACTIONS(2729),
    [anon_sym_COLON_GT] = ACTIONS(2731),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2731),
    [anon_sym_for] = ACTIONS(2729),
    [anon_sym_while] = ACTIONS(2729),
    [anon_sym_else] = ACTIONS(2729),
    [anon_sym_elif] = ACTIONS(2729),
    [anon_sym_if] = ACTIONS(2729),
    [anon_sym_fun] = ACTIONS(2729),
    [anon_sym_try] = ACTIONS(2729),
    [anon_sym_match] = ACTIONS(2729),
    [anon_sym_match_BANG] = ACTIONS(2731),
    [anon_sym_function] = ACTIONS(2729),
    [anon_sym_LT_DASH] = ACTIONS(2729),
    [anon_sym_DOT_LBRACK] = ACTIONS(2731),
    [anon_sym_LT] = ACTIONS(2731),
    [anon_sym_use] = ACTIONS(2729),
    [anon_sym_use_BANG] = ACTIONS(2731),
    [anon_sym_do_BANG] = ACTIONS(2731),
    [anon_sym_begin] = ACTIONS(2729),
    [anon_sym_LPAREN2] = ACTIONS(2729),
    [anon_sym_or] = ACTIONS(2729),
    [aux_sym_char_token1] = ACTIONS(2731),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2729),
    [anon_sym_DQUOTE] = ACTIONS(2729),
    [anon_sym_AT_DQUOTE] = ACTIONS(2731),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2731),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2731),
    [sym_bool] = ACTIONS(2729),
    [sym_unit] = ACTIONS(2731),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2729),
    [sym_op_identifier] = ACTIONS(2729),
    [anon_sym_PLUS] = ACTIONS(2729),
    [anon_sym_DASH] = ACTIONS(2729),
    [anon_sym_PLUS_DOT] = ACTIONS(2729),
    [anon_sym_DASH_DOT] = ACTIONS(2729),
    [anon_sym_PERCENT] = ACTIONS(2729),
    [anon_sym_AMP_AMP] = ACTIONS(2729),
    [anon_sym_TILDE] = ACTIONS(2731),
    [aux_sym_prefix_op_token1] = ACTIONS(2729),
    [aux_sym_infix_op_token1] = ACTIONS(2731),
    [aux_sym_infix_op_token2] = ACTIONS(2729),
    [anon_sym_PIPE_PIPE] = ACTIONS(2729),
    [anon_sym_BANG_EQ] = ACTIONS(2729),
    [anon_sym_COLON_EQ] = ACTIONS(2731),
    [anon_sym_DOLLAR] = ACTIONS(2729),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2729),
    [sym_int] = ACTIONS(2729),
    [sym_xint] = ACTIONS(2731),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2731),
    [sym__newline] = ACTIONS(2731),
  },
  [1469] = {
    [sym_block_comment] = STATE(1469),
    [sym_compiler_directive_decl] = STATE(1469),
    [sym_fsi_directive_decl] = STATE(1469),
    [sym_preproc_line] = STATE(1469),
    [sym_identifier] = ACTIONS(2729),
    [anon_sym_EQ] = ACTIONS(2731),
    [anon_sym_COLON] = ACTIONS(2729),
    [anon_sym_return] = ACTIONS(2729),
    [anon_sym_do] = ACTIONS(2729),
    [anon_sym_let] = ACTIONS(2729),
    [anon_sym_let_BANG] = ACTIONS(2731),
    [anon_sym_LPAREN] = ACTIONS(2729),
    [anon_sym_COMMA] = ACTIONS(2731),
    [anon_sym_null] = ACTIONS(2729),
    [anon_sym_QMARK] = ACTIONS(2729),
    [anon_sym_COLON_QMARK] = ACTIONS(2729),
    [anon_sym_COLON_COLON] = ACTIONS(2731),
    [anon_sym_AMP] = ACTIONS(2729),
    [anon_sym_LBRACK] = ACTIONS(2729),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2731),
    [anon_sym_LBRACE] = ACTIONS(2729),
    [anon_sym_LT_AT] = ACTIONS(2729),
    [anon_sym_LT_AT_AT] = ACTIONS(2729),
    [anon_sym_DOT] = ACTIONS(2729),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2731),
    [anon_sym_new] = ACTIONS(2729),
    [anon_sym_return_BANG] = ACTIONS(2731),
    [anon_sym_yield] = ACTIONS(2729),
    [anon_sym_yield_BANG] = ACTIONS(2731),
    [anon_sym_lazy] = ACTIONS(2729),
    [anon_sym_assert] = ACTIONS(2729),
    [anon_sym_upcast] = ACTIONS(2729),
    [anon_sym_downcast] = ACTIONS(2729),
    [anon_sym_COLON_GT] = ACTIONS(2731),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2731),
    [anon_sym_for] = ACTIONS(2729),
    [anon_sym_while] = ACTIONS(2729),
    [anon_sym_else] = ACTIONS(2729),
    [anon_sym_elif] = ACTIONS(2729),
    [anon_sym_if] = ACTIONS(2729),
    [anon_sym_fun] = ACTIONS(2729),
    [anon_sym_DASH_GT] = ACTIONS(2729),
    [anon_sym_try] = ACTIONS(2729),
    [anon_sym_match] = ACTIONS(2729),
    [anon_sym_match_BANG] = ACTIONS(2731),
    [anon_sym_function] = ACTIONS(2729),
    [anon_sym_LT_DASH] = ACTIONS(2729),
    [anon_sym_DOT_LBRACK] = ACTIONS(2731),
    [anon_sym_LT] = ACTIONS(2731),
    [anon_sym_use] = ACTIONS(2729),
    [anon_sym_use_BANG] = ACTIONS(2731),
    [anon_sym_do_BANG] = ACTIONS(2731),
    [anon_sym_DOT_DOT] = ACTIONS(2731),
    [anon_sym_begin] = ACTIONS(2729),
    [anon_sym_LPAREN2] = ACTIONS(2729),
    [anon_sym_or] = ACTIONS(2729),
    [aux_sym_char_token1] = ACTIONS(2731),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2729),
    [anon_sym_DQUOTE] = ACTIONS(2729),
    [anon_sym_AT_DQUOTE] = ACTIONS(2731),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2731),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2731),
    [sym_bool] = ACTIONS(2729),
    [sym_unit] = ACTIONS(2731),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2729),
    [sym_op_identifier] = ACTIONS(2729),
    [anon_sym_PLUS] = ACTIONS(2729),
    [anon_sym_DASH] = ACTIONS(2729),
    [anon_sym_PLUS_DOT] = ACTIONS(2729),
    [anon_sym_DASH_DOT] = ACTIONS(2729),
    [anon_sym_PERCENT] = ACTIONS(2729),
    [anon_sym_AMP_AMP] = ACTIONS(2729),
    [anon_sym_TILDE] = ACTIONS(2731),
    [aux_sym_prefix_op_token1] = ACTIONS(2729),
    [aux_sym_infix_op_token1] = ACTIONS(2731),
    [aux_sym_infix_op_token2] = ACTIONS(2729),
    [anon_sym_PIPE_PIPE] = ACTIONS(2729),
    [anon_sym_BANG_EQ] = ACTIONS(2729),
    [anon_sym_COLON_EQ] = ACTIONS(2731),
    [anon_sym_DOLLAR] = ACTIONS(2729),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2729),
    [sym_int] = ACTIONS(2729),
    [sym_xint] = ACTIONS(2731),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2731),
    [sym__newline] = ACTIONS(2731),
  },
  [1470] = {
    [sym_block_comment] = STATE(1470),
    [sym_compiler_directive_decl] = STATE(1470),
    [sym_fsi_directive_decl] = STATE(1470),
    [sym_preproc_line] = STATE(1470),
    [sym_identifier] = ACTIONS(2729),
    [anon_sym_EQ] = ACTIONS(2731),
    [anon_sym_COLON] = ACTIONS(2729),
    [anon_sym_return] = ACTIONS(2729),
    [anon_sym_do] = ACTIONS(2729),
    [anon_sym_let] = ACTIONS(2729),
    [anon_sym_let_BANG] = ACTIONS(2731),
    [anon_sym_LPAREN] = ACTIONS(2729),
    [anon_sym_COMMA] = ACTIONS(2731),
    [anon_sym_null] = ACTIONS(2729),
    [anon_sym_QMARK] = ACTIONS(2729),
    [anon_sym_COLON_QMARK] = ACTIONS(2729),
    [anon_sym_COLON_COLON] = ACTIONS(2731),
    [anon_sym_AMP] = ACTIONS(2729),
    [anon_sym_LBRACK] = ACTIONS(2729),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2731),
    [anon_sym_LBRACE] = ACTIONS(2729),
    [anon_sym_LT_AT] = ACTIONS(2729),
    [anon_sym_LT_AT_AT] = ACTIONS(2729),
    [anon_sym_DOT] = ACTIONS(2729),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2731),
    [anon_sym_new] = ACTIONS(2729),
    [anon_sym_return_BANG] = ACTIONS(2731),
    [anon_sym_yield] = ACTIONS(2729),
    [anon_sym_yield_BANG] = ACTIONS(2731),
    [anon_sym_lazy] = ACTIONS(2729),
    [anon_sym_assert] = ACTIONS(2729),
    [anon_sym_upcast] = ACTIONS(2729),
    [anon_sym_downcast] = ACTIONS(2729),
    [anon_sym_COLON_GT] = ACTIONS(2731),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2731),
    [anon_sym_for] = ACTIONS(2729),
    [anon_sym_while] = ACTIONS(2729),
    [anon_sym_else] = ACTIONS(2729),
    [anon_sym_elif] = ACTIONS(2729),
    [anon_sym_if] = ACTIONS(2729),
    [anon_sym_fun] = ACTIONS(2729),
    [anon_sym_try] = ACTIONS(2729),
    [anon_sym_match] = ACTIONS(2729),
    [anon_sym_match_BANG] = ACTIONS(2731),
    [anon_sym_function] = ACTIONS(2729),
    [anon_sym_LT_DASH] = ACTIONS(2729),
    [anon_sym_DOT_LBRACK] = ACTIONS(2731),
    [anon_sym_LT] = ACTIONS(2731),
    [anon_sym_use] = ACTIONS(2729),
    [anon_sym_use_BANG] = ACTIONS(2731),
    [anon_sym_do_BANG] = ACTIONS(2731),
    [anon_sym_begin] = ACTIONS(2729),
    [anon_sym_LPAREN2] = ACTIONS(2729),
    [anon_sym_or] = ACTIONS(2729),
    [aux_sym_char_token1] = ACTIONS(2731),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2729),
    [anon_sym_DQUOTE] = ACTIONS(2729),
    [anon_sym_AT_DQUOTE] = ACTIONS(2731),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2731),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2731),
    [sym_bool] = ACTIONS(2729),
    [sym_unit] = ACTIONS(2731),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2729),
    [sym_op_identifier] = ACTIONS(2729),
    [anon_sym_PLUS] = ACTIONS(2729),
    [anon_sym_DASH] = ACTIONS(2729),
    [anon_sym_PLUS_DOT] = ACTIONS(2729),
    [anon_sym_DASH_DOT] = ACTIONS(2729),
    [anon_sym_PERCENT] = ACTIONS(2729),
    [anon_sym_AMP_AMP] = ACTIONS(2729),
    [anon_sym_TILDE] = ACTIONS(2731),
    [aux_sym_prefix_op_token1] = ACTIONS(2729),
    [aux_sym_infix_op_token1] = ACTIONS(2731),
    [aux_sym_infix_op_token2] = ACTIONS(2729),
    [anon_sym_PIPE_PIPE] = ACTIONS(2729),
    [anon_sym_BANG_EQ] = ACTIONS(2729),
    [anon_sym_COLON_EQ] = ACTIONS(2731),
    [anon_sym_DOLLAR] = ACTIONS(2729),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2729),
    [sym_int] = ACTIONS(2729),
    [sym_xint] = ACTIONS(2731),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2731),
    [anon_sym_POUNDendif] = ACTIONS(2731),
    [anon_sym_POUNDelse] = ACTIONS(2731),
    [sym__newline] = ACTIONS(2731),
  },
  [1471] = {
    [sym_block_comment] = STATE(1471),
    [sym_compiler_directive_decl] = STATE(1471),
    [sym_fsi_directive_decl] = STATE(1471),
    [sym_preproc_line] = STATE(1471),
    [aux_sym_rules_repeat1] = STATE(1450),
    [sym_identifier] = ACTIONS(2698),
    [anon_sym_EQ] = ACTIONS(2700),
    [anon_sym_COLON] = ACTIONS(2698),
    [anon_sym_return] = ACTIONS(2698),
    [anon_sym_do] = ACTIONS(2698),
    [anon_sym_let] = ACTIONS(2698),
    [anon_sym_let_BANG] = ACTIONS(2700),
    [anon_sym_LPAREN] = ACTIONS(2698),
    [anon_sym_COMMA] = ACTIONS(2700),
    [anon_sym_null] = ACTIONS(2698),
    [anon_sym_QMARK] = ACTIONS(2698),
    [anon_sym_COLON_QMARK] = ACTIONS(2698),
    [anon_sym_COLON_COLON] = ACTIONS(2700),
    [anon_sym_PIPE] = ACTIONS(3652),
    [anon_sym_AMP] = ACTIONS(2698),
    [anon_sym_LBRACK] = ACTIONS(2698),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2700),
    [anon_sym_LBRACE] = ACTIONS(2698),
    [anon_sym_LT_AT] = ACTIONS(2698),
    [anon_sym_LT_AT_AT] = ACTIONS(2698),
    [anon_sym_DOT] = ACTIONS(2698),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2700),
    [anon_sym_new] = ACTIONS(2698),
    [anon_sym_return_BANG] = ACTIONS(2700),
    [anon_sym_yield] = ACTIONS(2698),
    [anon_sym_yield_BANG] = ACTIONS(2700),
    [anon_sym_lazy] = ACTIONS(2698),
    [anon_sym_assert] = ACTIONS(2698),
    [anon_sym_upcast] = ACTIONS(2698),
    [anon_sym_downcast] = ACTIONS(2698),
    [anon_sym_COLON_GT] = ACTIONS(2700),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2700),
    [anon_sym_for] = ACTIONS(2698),
    [anon_sym_while] = ACTIONS(2698),
    [anon_sym_if] = ACTIONS(2698),
    [anon_sym_fun] = ACTIONS(2698),
    [anon_sym_try] = ACTIONS(2698),
    [anon_sym_match] = ACTIONS(2698),
    [anon_sym_match_BANG] = ACTIONS(2700),
    [anon_sym_function] = ACTIONS(2698),
    [anon_sym_LT_DASH] = ACTIONS(2698),
    [anon_sym_DOT_LBRACK] = ACTIONS(2700),
    [anon_sym_LT] = ACTIONS(2700),
    [anon_sym_use] = ACTIONS(2698),
    [anon_sym_use_BANG] = ACTIONS(2700),
    [anon_sym_do_BANG] = ACTIONS(2700),
    [anon_sym_begin] = ACTIONS(2698),
    [anon_sym_LPAREN2] = ACTIONS(2698),
    [anon_sym_or] = ACTIONS(2698),
    [aux_sym_char_token1] = ACTIONS(2700),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2698),
    [anon_sym_DQUOTE] = ACTIONS(2698),
    [anon_sym_AT_DQUOTE] = ACTIONS(2700),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2700),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2700),
    [sym_bool] = ACTIONS(2698),
    [sym_unit] = ACTIONS(2700),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2698),
    [sym_op_identifier] = ACTIONS(2698),
    [anon_sym_PLUS] = ACTIONS(2698),
    [anon_sym_DASH] = ACTIONS(2698),
    [anon_sym_PLUS_DOT] = ACTIONS(2698),
    [anon_sym_DASH_DOT] = ACTIONS(2698),
    [anon_sym_PERCENT] = ACTIONS(2698),
    [anon_sym_AMP_AMP] = ACTIONS(2698),
    [anon_sym_TILDE] = ACTIONS(2700),
    [aux_sym_prefix_op_token1] = ACTIONS(2698),
    [aux_sym_infix_op_token1] = ACTIONS(2700),
    [aux_sym_infix_op_token2] = ACTIONS(2698),
    [anon_sym_PIPE_PIPE] = ACTIONS(2698),
    [anon_sym_BANG_EQ] = ACTIONS(2698),
    [anon_sym_COLON_EQ] = ACTIONS(2700),
    [anon_sym_DOLLAR] = ACTIONS(2698),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2698),
    [sym_int] = ACTIONS(2698),
    [sym_xint] = ACTIONS(2700),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2700),
    [anon_sym_POUNDendif] = ACTIONS(2700),
    [anon_sym_POUNDelse] = ACTIONS(2700),
    [sym__newline] = ACTIONS(3693),
  },
  [1472] = {
    [sym_block_comment] = STATE(1472),
    [sym_compiler_directive_decl] = STATE(1472),
    [sym_fsi_directive_decl] = STATE(1472),
    [sym_preproc_line] = STATE(1472),
    [sym_identifier] = ACTIONS(2685),
    [anon_sym_EQ] = ACTIONS(2687),
    [anon_sym_COLON] = ACTIONS(2685),
    [anon_sym_return] = ACTIONS(2685),
    [anon_sym_do] = ACTIONS(2685),
    [anon_sym_and] = ACTIONS(2685),
    [anon_sym_let] = ACTIONS(2685),
    [anon_sym_let_BANG] = ACTIONS(2687),
    [anon_sym_LPAREN] = ACTIONS(2685),
    [anon_sym_COMMA] = ACTIONS(2687),
    [anon_sym_null] = ACTIONS(2685),
    [anon_sym_QMARK] = ACTIONS(2685),
    [anon_sym_COLON_QMARK] = ACTIONS(2685),
    [anon_sym_COLON_COLON] = ACTIONS(2687),
    [anon_sym_AMP] = ACTIONS(2685),
    [anon_sym_LBRACK] = ACTIONS(2685),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2687),
    [anon_sym_LBRACE] = ACTIONS(2685),
    [anon_sym_LT_AT] = ACTIONS(2685),
    [anon_sym_LT_AT_AT] = ACTIONS(2685),
    [anon_sym_DOT] = ACTIONS(2685),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2687),
    [anon_sym_new] = ACTIONS(2685),
    [anon_sym_return_BANG] = ACTIONS(2687),
    [anon_sym_yield] = ACTIONS(2685),
    [anon_sym_yield_BANG] = ACTIONS(2687),
    [anon_sym_lazy] = ACTIONS(2685),
    [anon_sym_assert] = ACTIONS(2685),
    [anon_sym_upcast] = ACTIONS(2685),
    [anon_sym_downcast] = ACTIONS(2685),
    [anon_sym_COLON_GT] = ACTIONS(2687),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2687),
    [anon_sym_for] = ACTIONS(2685),
    [anon_sym_while] = ACTIONS(2685),
    [anon_sym_else] = ACTIONS(2685),
    [anon_sym_elif] = ACTIONS(2685),
    [anon_sym_if] = ACTIONS(2685),
    [anon_sym_fun] = ACTIONS(2685),
    [anon_sym_try] = ACTIONS(2685),
    [anon_sym_match] = ACTIONS(2685),
    [anon_sym_match_BANG] = ACTIONS(2687),
    [anon_sym_function] = ACTIONS(2685),
    [anon_sym_LT_DASH] = ACTIONS(2685),
    [anon_sym_DOT_LBRACK] = ACTIONS(2687),
    [anon_sym_LT] = ACTIONS(2687),
    [anon_sym_use] = ACTIONS(2685),
    [anon_sym_use_BANG] = ACTIONS(2687),
    [anon_sym_do_BANG] = ACTIONS(2687),
    [anon_sym_begin] = ACTIONS(2685),
    [anon_sym_LPAREN2] = ACTIONS(2685),
    [anon_sym_or] = ACTIONS(2685),
    [aux_sym_char_token1] = ACTIONS(2687),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2685),
    [anon_sym_DQUOTE] = ACTIONS(2685),
    [anon_sym_AT_DQUOTE] = ACTIONS(2687),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2687),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2687),
    [sym_bool] = ACTIONS(2685),
    [sym_unit] = ACTIONS(2687),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2685),
    [sym_op_identifier] = ACTIONS(2685),
    [anon_sym_PLUS] = ACTIONS(2685),
    [anon_sym_DASH] = ACTIONS(2685),
    [anon_sym_PLUS_DOT] = ACTIONS(2685),
    [anon_sym_DASH_DOT] = ACTIONS(2685),
    [anon_sym_PERCENT] = ACTIONS(2685),
    [anon_sym_AMP_AMP] = ACTIONS(2685),
    [anon_sym_TILDE] = ACTIONS(2687),
    [aux_sym_prefix_op_token1] = ACTIONS(2685),
    [aux_sym_infix_op_token1] = ACTIONS(2687),
    [aux_sym_infix_op_token2] = ACTIONS(2685),
    [anon_sym_PIPE_PIPE] = ACTIONS(2685),
    [anon_sym_BANG_EQ] = ACTIONS(2685),
    [anon_sym_COLON_EQ] = ACTIONS(2687),
    [anon_sym_DOLLAR] = ACTIONS(2685),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2685),
    [sym_int] = ACTIONS(2685),
    [sym_xint] = ACTIONS(2687),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2687),
    [sym__newline] = ACTIONS(2687),
    [sym__dedent] = ACTIONS(2687),
  },
  [1473] = {
    [sym_block_comment] = STATE(1473),
    [sym_compiler_directive_decl] = STATE(1473),
    [sym_fsi_directive_decl] = STATE(1473),
    [sym_preproc_line] = STATE(1473),
    [aux_sym_rules_repeat1] = STATE(1456),
    [sym_identifier] = ACTIONS(2698),
    [anon_sym_EQ] = ACTIONS(2700),
    [anon_sym_COLON] = ACTIONS(2698),
    [anon_sym_return] = ACTIONS(2698),
    [anon_sym_do] = ACTIONS(2698),
    [anon_sym_let] = ACTIONS(2698),
    [anon_sym_let_BANG] = ACTIONS(2700),
    [anon_sym_LPAREN] = ACTIONS(2698),
    [anon_sym_COMMA] = ACTIONS(2700),
    [anon_sym_null] = ACTIONS(2698),
    [anon_sym_QMARK] = ACTIONS(2698),
    [anon_sym_COLON_QMARK] = ACTIONS(2698),
    [anon_sym_COLON_COLON] = ACTIONS(2700),
    [anon_sym_PIPE] = ACTIONS(3652),
    [anon_sym_AMP] = ACTIONS(2698),
    [anon_sym_LBRACK] = ACTIONS(2698),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2700),
    [anon_sym_LBRACE] = ACTIONS(2698),
    [anon_sym_LT_AT] = ACTIONS(2698),
    [anon_sym_LT_AT_AT] = ACTIONS(2698),
    [anon_sym_DOT] = ACTIONS(2698),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2700),
    [anon_sym_new] = ACTIONS(2698),
    [anon_sym_return_BANG] = ACTIONS(2700),
    [anon_sym_yield] = ACTIONS(2698),
    [anon_sym_yield_BANG] = ACTIONS(2700),
    [anon_sym_lazy] = ACTIONS(2698),
    [anon_sym_assert] = ACTIONS(2698),
    [anon_sym_upcast] = ACTIONS(2698),
    [anon_sym_downcast] = ACTIONS(2698),
    [anon_sym_COLON_GT] = ACTIONS(2700),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2700),
    [anon_sym_for] = ACTIONS(2698),
    [anon_sym_while] = ACTIONS(2698),
    [anon_sym_if] = ACTIONS(2698),
    [anon_sym_fun] = ACTIONS(2698),
    [anon_sym_try] = ACTIONS(2698),
    [anon_sym_match] = ACTIONS(2698),
    [anon_sym_match_BANG] = ACTIONS(2700),
    [anon_sym_function] = ACTIONS(2698),
    [anon_sym_LT_DASH] = ACTIONS(2698),
    [anon_sym_DOT_LBRACK] = ACTIONS(2700),
    [anon_sym_LT] = ACTIONS(2700),
    [anon_sym_use] = ACTIONS(2698),
    [anon_sym_use_BANG] = ACTIONS(2700),
    [anon_sym_do_BANG] = ACTIONS(2700),
    [anon_sym_begin] = ACTIONS(2698),
    [anon_sym_LPAREN2] = ACTIONS(2698),
    [anon_sym_or] = ACTIONS(2698),
    [aux_sym_char_token1] = ACTIONS(2700),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2698),
    [anon_sym_DQUOTE] = ACTIONS(2698),
    [anon_sym_AT_DQUOTE] = ACTIONS(2700),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2700),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2700),
    [sym_bool] = ACTIONS(2698),
    [sym_unit] = ACTIONS(2700),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2698),
    [sym_op_identifier] = ACTIONS(2698),
    [anon_sym_PLUS] = ACTIONS(2698),
    [anon_sym_DASH] = ACTIONS(2698),
    [anon_sym_PLUS_DOT] = ACTIONS(2698),
    [anon_sym_DASH_DOT] = ACTIONS(2698),
    [anon_sym_PERCENT] = ACTIONS(2698),
    [anon_sym_AMP_AMP] = ACTIONS(2698),
    [anon_sym_TILDE] = ACTIONS(2700),
    [aux_sym_prefix_op_token1] = ACTIONS(2698),
    [aux_sym_infix_op_token1] = ACTIONS(2700),
    [aux_sym_infix_op_token2] = ACTIONS(2698),
    [anon_sym_PIPE_PIPE] = ACTIONS(2698),
    [anon_sym_BANG_EQ] = ACTIONS(2698),
    [anon_sym_COLON_EQ] = ACTIONS(2700),
    [anon_sym_DOLLAR] = ACTIONS(2698),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2698),
    [sym_int] = ACTIONS(2698),
    [sym_xint] = ACTIONS(2700),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2700),
    [anon_sym_POUNDendif] = ACTIONS(2700),
    [anon_sym_POUNDelse] = ACTIONS(2700),
    [sym__newline] = ACTIONS(3693),
  },
  [1474] = {
    [sym_block_comment] = STATE(1474),
    [sym_compiler_directive_decl] = STATE(1474),
    [sym_fsi_directive_decl] = STATE(1474),
    [sym_preproc_line] = STATE(1474),
    [sym_identifier] = ACTIONS(2685),
    [anon_sym_EQ] = ACTIONS(2687),
    [anon_sym_COLON] = ACTIONS(2685),
    [anon_sym_return] = ACTIONS(2685),
    [anon_sym_do] = ACTIONS(2685),
    [anon_sym_let] = ACTIONS(2685),
    [anon_sym_let_BANG] = ACTIONS(2687),
    [anon_sym_as] = ACTIONS(2685),
    [anon_sym_LPAREN] = ACTIONS(2685),
    [anon_sym_COMMA] = ACTIONS(2687),
    [anon_sym_null] = ACTIONS(2685),
    [anon_sym_QMARK] = ACTIONS(2685),
    [anon_sym_COLON_QMARK] = ACTIONS(2685),
    [anon_sym_COLON_COLON] = ACTIONS(2687),
    [anon_sym_AMP] = ACTIONS(2685),
    [anon_sym_LBRACK] = ACTIONS(2685),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2687),
    [anon_sym_LBRACE] = ACTIONS(2685),
    [anon_sym_LT_AT] = ACTIONS(2685),
    [anon_sym_LT_AT_AT] = ACTIONS(2685),
    [anon_sym_DOT] = ACTIONS(2685),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2687),
    [anon_sym_new] = ACTIONS(2685),
    [anon_sym_with] = ACTIONS(2685),
    [anon_sym_return_BANG] = ACTIONS(2687),
    [anon_sym_yield] = ACTIONS(2685),
    [anon_sym_yield_BANG] = ACTIONS(2687),
    [anon_sym_lazy] = ACTIONS(2685),
    [anon_sym_assert] = ACTIONS(2685),
    [anon_sym_upcast] = ACTIONS(2685),
    [anon_sym_downcast] = ACTIONS(2685),
    [anon_sym_COLON_GT] = ACTIONS(2687),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2687),
    [anon_sym_for] = ACTIONS(2685),
    [anon_sym_while] = ACTIONS(2685),
    [anon_sym_else] = ACTIONS(2685),
    [anon_sym_elif] = ACTIONS(2685),
    [anon_sym_if] = ACTIONS(2685),
    [anon_sym_fun] = ACTIONS(2685),
    [anon_sym_try] = ACTIONS(2685),
    [anon_sym_match] = ACTIONS(2685),
    [anon_sym_match_BANG] = ACTIONS(2687),
    [anon_sym_function] = ACTIONS(2685),
    [anon_sym_LT_DASH] = ACTIONS(2685),
    [anon_sym_DOT_LBRACK] = ACTIONS(2687),
    [anon_sym_LT] = ACTIONS(2687),
    [anon_sym_use] = ACTIONS(2685),
    [anon_sym_use_BANG] = ACTIONS(2687),
    [anon_sym_do_BANG] = ACTIONS(2687),
    [anon_sym_begin] = ACTIONS(2685),
    [anon_sym_LPAREN2] = ACTIONS(2685),
    [anon_sym_or] = ACTIONS(2685),
    [aux_sym_char_token1] = ACTIONS(2687),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2685),
    [anon_sym_DQUOTE] = ACTIONS(2685),
    [anon_sym_AT_DQUOTE] = ACTIONS(2687),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2687),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2687),
    [sym_bool] = ACTIONS(2685),
    [sym_unit] = ACTIONS(2687),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2685),
    [sym_op_identifier] = ACTIONS(2685),
    [anon_sym_PLUS] = ACTIONS(2685),
    [anon_sym_DASH] = ACTIONS(2685),
    [anon_sym_PLUS_DOT] = ACTIONS(2685),
    [anon_sym_DASH_DOT] = ACTIONS(2685),
    [anon_sym_PERCENT] = ACTIONS(2685),
    [anon_sym_AMP_AMP] = ACTIONS(2685),
    [anon_sym_TILDE] = ACTIONS(2687),
    [aux_sym_prefix_op_token1] = ACTIONS(2685),
    [aux_sym_infix_op_token1] = ACTIONS(2687),
    [aux_sym_infix_op_token2] = ACTIONS(2685),
    [anon_sym_PIPE_PIPE] = ACTIONS(2685),
    [anon_sym_BANG_EQ] = ACTIONS(2685),
    [anon_sym_COLON_EQ] = ACTIONS(2687),
    [anon_sym_DOLLAR] = ACTIONS(2685),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2685),
    [sym_int] = ACTIONS(2685),
    [sym_xint] = ACTIONS(2687),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2687),
    [sym__newline] = ACTIONS(2687),
  },
  [1475] = {
    [sym_block_comment] = STATE(1475),
    [sym_compiler_directive_decl] = STATE(1475),
    [sym_fsi_directive_decl] = STATE(1475),
    [sym_preproc_line] = STATE(1475),
    [sym_identifier] = ACTIONS(2770),
    [anon_sym_EQ] = ACTIONS(2772),
    [anon_sym_COLON] = ACTIONS(2770),
    [anon_sym_return] = ACTIONS(2770),
    [anon_sym_do] = ACTIONS(2770),
    [anon_sym_let] = ACTIONS(2770),
    [anon_sym_let_BANG] = ACTIONS(2772),
    [anon_sym_LPAREN] = ACTIONS(2770),
    [anon_sym_COMMA] = ACTIONS(2772),
    [anon_sym_null] = ACTIONS(2770),
    [anon_sym_QMARK] = ACTIONS(2770),
    [anon_sym_COLON_QMARK] = ACTIONS(2770),
    [anon_sym_COLON_COLON] = ACTIONS(2772),
    [anon_sym_AMP] = ACTIONS(2770),
    [anon_sym_LBRACK] = ACTIONS(2770),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2772),
    [anon_sym_LBRACE] = ACTIONS(2770),
    [anon_sym_LT_AT] = ACTIONS(2770),
    [anon_sym_LT_AT_AT] = ACTIONS(2770),
    [anon_sym_DOT] = ACTIONS(2770),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2772),
    [anon_sym_new] = ACTIONS(2770),
    [anon_sym_return_BANG] = ACTIONS(2772),
    [anon_sym_yield] = ACTIONS(2770),
    [anon_sym_yield_BANG] = ACTIONS(2772),
    [anon_sym_lazy] = ACTIONS(2770),
    [anon_sym_assert] = ACTIONS(2770),
    [anon_sym_upcast] = ACTIONS(2770),
    [anon_sym_downcast] = ACTIONS(2770),
    [anon_sym_COLON_GT] = ACTIONS(2772),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2772),
    [anon_sym_for] = ACTIONS(2770),
    [anon_sym_done] = ACTIONS(3696),
    [anon_sym_while] = ACTIONS(2770),
    [anon_sym_if] = ACTIONS(2770),
    [anon_sym_fun] = ACTIONS(2770),
    [anon_sym_DASH_GT] = ACTIONS(2770),
    [anon_sym_try] = ACTIONS(2770),
    [anon_sym_match] = ACTIONS(2770),
    [anon_sym_match_BANG] = ACTIONS(2772),
    [anon_sym_function] = ACTIONS(2770),
    [anon_sym_LT_DASH] = ACTIONS(2770),
    [anon_sym_DOT_LBRACK] = ACTIONS(2772),
    [anon_sym_LT] = ACTIONS(2772),
    [anon_sym_use] = ACTIONS(2770),
    [anon_sym_use_BANG] = ACTIONS(2772),
    [anon_sym_do_BANG] = ACTIONS(2772),
    [anon_sym_DOT_DOT] = ACTIONS(2772),
    [anon_sym_begin] = ACTIONS(2770),
    [anon_sym_LPAREN2] = ACTIONS(2770),
    [anon_sym_or] = ACTIONS(2770),
    [aux_sym_char_token1] = ACTIONS(2772),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2770),
    [anon_sym_DQUOTE] = ACTIONS(2770),
    [anon_sym_AT_DQUOTE] = ACTIONS(2772),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2772),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2772),
    [sym_bool] = ACTIONS(2770),
    [sym_unit] = ACTIONS(2772),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2770),
    [sym_op_identifier] = ACTIONS(2770),
    [anon_sym_PLUS] = ACTIONS(2770),
    [anon_sym_DASH] = ACTIONS(2770),
    [anon_sym_PLUS_DOT] = ACTIONS(2770),
    [anon_sym_DASH_DOT] = ACTIONS(2770),
    [anon_sym_PERCENT] = ACTIONS(2770),
    [anon_sym_AMP_AMP] = ACTIONS(2770),
    [anon_sym_TILDE] = ACTIONS(2772),
    [aux_sym_prefix_op_token1] = ACTIONS(2770),
    [aux_sym_infix_op_token1] = ACTIONS(2772),
    [aux_sym_infix_op_token2] = ACTIONS(2770),
    [anon_sym_PIPE_PIPE] = ACTIONS(2770),
    [anon_sym_BANG_EQ] = ACTIONS(2770),
    [anon_sym_COLON_EQ] = ACTIONS(2772),
    [anon_sym_DOLLAR] = ACTIONS(2770),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2770),
    [sym_int] = ACTIONS(2770),
    [sym_xint] = ACTIONS(2772),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2772),
    [sym__newline] = ACTIONS(2772),
  },
  [1476] = {
    [sym_block_comment] = STATE(1476),
    [sym_compiler_directive_decl] = STATE(1476),
    [sym_fsi_directive_decl] = STATE(1476),
    [sym_preproc_line] = STATE(1476),
    [sym_identifier] = ACTIONS(3079),
    [anon_sym_EQ] = ACTIONS(3081),
    [anon_sym_COLON] = ACTIONS(3079),
    [anon_sym_return] = ACTIONS(3079),
    [anon_sym_do] = ACTIONS(3079),
    [anon_sym_let] = ACTIONS(3079),
    [anon_sym_let_BANG] = ACTIONS(3081),
    [anon_sym_as] = ACTIONS(3079),
    [anon_sym_LPAREN] = ACTIONS(3079),
    [anon_sym_COMMA] = ACTIONS(3081),
    [anon_sym_null] = ACTIONS(3079),
    [anon_sym_QMARK] = ACTIONS(3079),
    [anon_sym_COLON_QMARK] = ACTIONS(3079),
    [anon_sym_COLON_COLON] = ACTIONS(3081),
    [anon_sym_AMP] = ACTIONS(3079),
    [anon_sym_LBRACK] = ACTIONS(3079),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3081),
    [anon_sym_LBRACE] = ACTIONS(3079),
    [anon_sym_LT_AT] = ACTIONS(3079),
    [anon_sym_LT_AT_AT] = ACTIONS(3079),
    [anon_sym_DOT] = ACTIONS(3079),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3081),
    [anon_sym_new] = ACTIONS(3079),
    [anon_sym_with] = ACTIONS(3079),
    [anon_sym_return_BANG] = ACTIONS(3081),
    [anon_sym_yield] = ACTIONS(3079),
    [anon_sym_yield_BANG] = ACTIONS(3081),
    [anon_sym_lazy] = ACTIONS(3079),
    [anon_sym_assert] = ACTIONS(3079),
    [anon_sym_upcast] = ACTIONS(3079),
    [anon_sym_downcast] = ACTIONS(3079),
    [anon_sym_COLON_GT] = ACTIONS(3081),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3081),
    [anon_sym_for] = ACTIONS(3079),
    [anon_sym_while] = ACTIONS(3079),
    [anon_sym_if] = ACTIONS(3079),
    [anon_sym_fun] = ACTIONS(3079),
    [anon_sym_try] = ACTIONS(3079),
    [anon_sym_match] = ACTIONS(3079),
    [anon_sym_match_BANG] = ACTIONS(3081),
    [anon_sym_function] = ACTIONS(3079),
    [anon_sym_LT_DASH] = ACTIONS(3079),
    [anon_sym_DOT_LBRACK] = ACTIONS(3081),
    [anon_sym_LT] = ACTIONS(3081),
    [anon_sym_use] = ACTIONS(3079),
    [anon_sym_use_BANG] = ACTIONS(3081),
    [anon_sym_do_BANG] = ACTIONS(3081),
    [anon_sym_begin] = ACTIONS(3079),
    [anon_sym_LPAREN2] = ACTIONS(3079),
    [anon_sym_or] = ACTIONS(3079),
    [aux_sym_char_token1] = ACTIONS(3081),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3079),
    [anon_sym_DQUOTE] = ACTIONS(3079),
    [anon_sym_AT_DQUOTE] = ACTIONS(3081),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3081),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3081),
    [sym_bool] = ACTIONS(3079),
    [sym_unit] = ACTIONS(3081),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3079),
    [sym_op_identifier] = ACTIONS(3079),
    [anon_sym_PLUS] = ACTIONS(3079),
    [anon_sym_DASH] = ACTIONS(3079),
    [anon_sym_PLUS_DOT] = ACTIONS(3079),
    [anon_sym_DASH_DOT] = ACTIONS(3079),
    [anon_sym_PERCENT] = ACTIONS(3079),
    [anon_sym_AMP_AMP] = ACTIONS(3079),
    [anon_sym_TILDE] = ACTIONS(3081),
    [aux_sym_prefix_op_token1] = ACTIONS(3079),
    [aux_sym_infix_op_token1] = ACTIONS(3081),
    [aux_sym_infix_op_token2] = ACTIONS(3079),
    [anon_sym_PIPE_PIPE] = ACTIONS(3079),
    [anon_sym_BANG_EQ] = ACTIONS(3079),
    [anon_sym_COLON_EQ] = ACTIONS(3081),
    [anon_sym_DOLLAR] = ACTIONS(3079),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3079),
    [sym_int] = ACTIONS(3079),
    [sym_xint] = ACTIONS(3081),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3081),
    [sym__newline] = ACTIONS(3081),
    [sym__dedent] = ACTIONS(3081),
  },
  [1477] = {
    [sym_block_comment] = STATE(1477),
    [sym_compiler_directive_decl] = STATE(1477),
    [sym_fsi_directive_decl] = STATE(1477),
    [sym_preproc_line] = STATE(1477),
    [sym_identifier] = ACTIONS(2883),
    [anon_sym_EQ] = ACTIONS(2885),
    [anon_sym_COLON] = ACTIONS(2883),
    [anon_sym_return] = ACTIONS(2883),
    [anon_sym_do] = ACTIONS(2883),
    [anon_sym_let] = ACTIONS(2883),
    [anon_sym_let_BANG] = ACTIONS(2885),
    [anon_sym_as] = ACTIONS(2883),
    [anon_sym_LPAREN] = ACTIONS(2883),
    [anon_sym_COMMA] = ACTIONS(2885),
    [anon_sym_null] = ACTIONS(2883),
    [anon_sym_QMARK] = ACTIONS(2883),
    [anon_sym_COLON_QMARK] = ACTIONS(2883),
    [anon_sym_COLON_COLON] = ACTIONS(2885),
    [anon_sym_AMP] = ACTIONS(2883),
    [anon_sym_LBRACK] = ACTIONS(2883),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2885),
    [anon_sym_LBRACE] = ACTIONS(2883),
    [anon_sym_LT_AT] = ACTIONS(2883),
    [anon_sym_LT_AT_AT] = ACTIONS(2883),
    [anon_sym_DOT] = ACTIONS(2883),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2885),
    [anon_sym_new] = ACTIONS(2883),
    [anon_sym_with] = ACTIONS(2883),
    [anon_sym_return_BANG] = ACTIONS(2885),
    [anon_sym_yield] = ACTIONS(2883),
    [anon_sym_yield_BANG] = ACTIONS(2885),
    [anon_sym_lazy] = ACTIONS(2883),
    [anon_sym_assert] = ACTIONS(2883),
    [anon_sym_upcast] = ACTIONS(2883),
    [anon_sym_downcast] = ACTIONS(2883),
    [anon_sym_COLON_GT] = ACTIONS(2885),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2885),
    [anon_sym_for] = ACTIONS(2883),
    [anon_sym_while] = ACTIONS(2883),
    [anon_sym_if] = ACTIONS(2883),
    [anon_sym_fun] = ACTIONS(2883),
    [anon_sym_try] = ACTIONS(2883),
    [anon_sym_match] = ACTIONS(2883),
    [anon_sym_match_BANG] = ACTIONS(2885),
    [anon_sym_function] = ACTIONS(2883),
    [anon_sym_LT_DASH] = ACTIONS(2883),
    [anon_sym_DOT_LBRACK] = ACTIONS(2885),
    [anon_sym_LT] = ACTIONS(2885),
    [anon_sym_use] = ACTIONS(2883),
    [anon_sym_use_BANG] = ACTIONS(2885),
    [anon_sym_do_BANG] = ACTIONS(2885),
    [anon_sym_begin] = ACTIONS(2883),
    [anon_sym_LPAREN2] = ACTIONS(2883),
    [anon_sym_or] = ACTIONS(2883),
    [aux_sym_char_token1] = ACTIONS(2885),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2883),
    [anon_sym_DQUOTE] = ACTIONS(2883),
    [anon_sym_AT_DQUOTE] = ACTIONS(2885),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2885),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2885),
    [sym_bool] = ACTIONS(2883),
    [sym_unit] = ACTIONS(2885),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2883),
    [sym_op_identifier] = ACTIONS(2883),
    [anon_sym_PLUS] = ACTIONS(2883),
    [anon_sym_DASH] = ACTIONS(2883),
    [anon_sym_PLUS_DOT] = ACTIONS(2883),
    [anon_sym_DASH_DOT] = ACTIONS(2883),
    [anon_sym_PERCENT] = ACTIONS(2883),
    [anon_sym_AMP_AMP] = ACTIONS(2883),
    [anon_sym_TILDE] = ACTIONS(2885),
    [aux_sym_prefix_op_token1] = ACTIONS(2883),
    [aux_sym_infix_op_token1] = ACTIONS(2885),
    [aux_sym_infix_op_token2] = ACTIONS(2883),
    [anon_sym_PIPE_PIPE] = ACTIONS(2883),
    [anon_sym_BANG_EQ] = ACTIONS(2883),
    [anon_sym_COLON_EQ] = ACTIONS(2885),
    [anon_sym_DOLLAR] = ACTIONS(2883),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2883),
    [sym_int] = ACTIONS(2883),
    [sym_xint] = ACTIONS(2885),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2885),
    [sym__newline] = ACTIONS(2885),
    [sym__dedent] = ACTIONS(2885),
  },
  [1478] = {
    [sym_block_comment] = STATE(1478),
    [sym_compiler_directive_decl] = STATE(1478),
    [sym_fsi_directive_decl] = STATE(1478),
    [sym_preproc_line] = STATE(1478),
    [sym_identifier] = ACTIONS(2685),
    [anon_sym_EQ] = ACTIONS(2687),
    [anon_sym_COLON] = ACTIONS(2685),
    [anon_sym_return] = ACTIONS(2685),
    [anon_sym_do] = ACTIONS(2685),
    [anon_sym_let] = ACTIONS(2685),
    [anon_sym_let_BANG] = ACTIONS(2687),
    [anon_sym_LPAREN] = ACTIONS(2685),
    [anon_sym_COMMA] = ACTIONS(2687),
    [anon_sym_null] = ACTIONS(2685),
    [anon_sym_QMARK] = ACTIONS(2685),
    [anon_sym_COLON_QMARK] = ACTIONS(2685),
    [anon_sym_COLON_COLON] = ACTIONS(2687),
    [anon_sym_AMP] = ACTIONS(2685),
    [anon_sym_LBRACK] = ACTIONS(2685),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2687),
    [anon_sym_LBRACE] = ACTIONS(2685),
    [anon_sym_LT_AT] = ACTIONS(2685),
    [anon_sym_LT_AT_AT] = ACTIONS(2685),
    [anon_sym_DOT] = ACTIONS(2685),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2687),
    [anon_sym_new] = ACTIONS(2685),
    [anon_sym_return_BANG] = ACTIONS(2687),
    [anon_sym_yield] = ACTIONS(2685),
    [anon_sym_yield_BANG] = ACTIONS(2687),
    [anon_sym_lazy] = ACTIONS(2685),
    [anon_sym_assert] = ACTIONS(2685),
    [anon_sym_upcast] = ACTIONS(2685),
    [anon_sym_downcast] = ACTIONS(2685),
    [anon_sym_COLON_GT] = ACTIONS(2687),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2687),
    [anon_sym_for] = ACTIONS(2685),
    [anon_sym_done] = ACTIONS(2685),
    [anon_sym_while] = ACTIONS(2685),
    [anon_sym_if] = ACTIONS(2685),
    [anon_sym_fun] = ACTIONS(2685),
    [anon_sym_try] = ACTIONS(2685),
    [anon_sym_match] = ACTIONS(2685),
    [anon_sym_match_BANG] = ACTIONS(2687),
    [anon_sym_function] = ACTIONS(2685),
    [anon_sym_LT_DASH] = ACTIONS(2685),
    [anon_sym_DOT_LBRACK] = ACTIONS(2687),
    [anon_sym_LT] = ACTIONS(2687),
    [anon_sym_use] = ACTIONS(2685),
    [anon_sym_use_BANG] = ACTIONS(2687),
    [anon_sym_do_BANG] = ACTIONS(2687),
    [anon_sym_DOT_DOT] = ACTIONS(2687),
    [anon_sym_begin] = ACTIONS(2685),
    [anon_sym_LPAREN2] = ACTIONS(2685),
    [anon_sym_or] = ACTIONS(2685),
    [aux_sym_char_token1] = ACTIONS(2687),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2685),
    [anon_sym_DQUOTE] = ACTIONS(2685),
    [anon_sym_AT_DQUOTE] = ACTIONS(2687),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2687),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2687),
    [sym_bool] = ACTIONS(2685),
    [sym_unit] = ACTIONS(2687),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2685),
    [sym_op_identifier] = ACTIONS(2685),
    [anon_sym_PLUS] = ACTIONS(2685),
    [anon_sym_DASH] = ACTIONS(2685),
    [anon_sym_PLUS_DOT] = ACTIONS(2685),
    [anon_sym_DASH_DOT] = ACTIONS(2685),
    [anon_sym_PERCENT] = ACTIONS(2685),
    [anon_sym_AMP_AMP] = ACTIONS(2685),
    [anon_sym_TILDE] = ACTIONS(2687),
    [aux_sym_prefix_op_token1] = ACTIONS(2685),
    [aux_sym_infix_op_token1] = ACTIONS(2687),
    [aux_sym_infix_op_token2] = ACTIONS(2685),
    [anon_sym_PIPE_PIPE] = ACTIONS(2685),
    [anon_sym_BANG_EQ] = ACTIONS(2685),
    [anon_sym_COLON_EQ] = ACTIONS(2687),
    [anon_sym_DOLLAR] = ACTIONS(2685),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2685),
    [sym_int] = ACTIONS(2685),
    [sym_xint] = ACTIONS(2687),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2687),
    [anon_sym_POUNDendif] = ACTIONS(2687),
    [sym__newline] = ACTIONS(2687),
  },
  [1479] = {
    [sym_block_comment] = STATE(1479),
    [sym_compiler_directive_decl] = STATE(1479),
    [sym_fsi_directive_decl] = STATE(1479),
    [sym_preproc_line] = STATE(1479),
    [sym_identifier] = ACTIONS(2877),
    [anon_sym_EQ] = ACTIONS(2879),
    [anon_sym_COLON] = ACTIONS(2877),
    [anon_sym_return] = ACTIONS(2877),
    [anon_sym_do] = ACTIONS(2877),
    [anon_sym_let] = ACTIONS(2877),
    [anon_sym_let_BANG] = ACTIONS(2879),
    [anon_sym_as] = ACTIONS(2877),
    [anon_sym_LPAREN] = ACTIONS(2877),
    [anon_sym_COMMA] = ACTIONS(2879),
    [anon_sym_null] = ACTIONS(2877),
    [anon_sym_QMARK] = ACTIONS(2877),
    [anon_sym_COLON_QMARK] = ACTIONS(2877),
    [anon_sym_COLON_COLON] = ACTIONS(2879),
    [anon_sym_AMP] = ACTIONS(2877),
    [anon_sym_LBRACK] = ACTIONS(2877),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2879),
    [anon_sym_LBRACE] = ACTIONS(2877),
    [anon_sym_LT_AT] = ACTIONS(2877),
    [anon_sym_LT_AT_AT] = ACTIONS(2877),
    [anon_sym_DOT] = ACTIONS(2877),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2879),
    [anon_sym_new] = ACTIONS(2877),
    [anon_sym_with] = ACTIONS(2877),
    [anon_sym_return_BANG] = ACTIONS(2879),
    [anon_sym_yield] = ACTIONS(2877),
    [anon_sym_yield_BANG] = ACTIONS(2879),
    [anon_sym_lazy] = ACTIONS(2877),
    [anon_sym_assert] = ACTIONS(2877),
    [anon_sym_upcast] = ACTIONS(2877),
    [anon_sym_downcast] = ACTIONS(2877),
    [anon_sym_COLON_GT] = ACTIONS(2879),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2879),
    [anon_sym_for] = ACTIONS(2877),
    [anon_sym_while] = ACTIONS(2877),
    [anon_sym_if] = ACTIONS(2877),
    [anon_sym_fun] = ACTIONS(2877),
    [anon_sym_try] = ACTIONS(2877),
    [anon_sym_match] = ACTIONS(2877),
    [anon_sym_match_BANG] = ACTIONS(2879),
    [anon_sym_function] = ACTIONS(2877),
    [anon_sym_LT_DASH] = ACTIONS(2877),
    [anon_sym_DOT_LBRACK] = ACTIONS(2879),
    [anon_sym_LT] = ACTIONS(2879),
    [anon_sym_use] = ACTIONS(2877),
    [anon_sym_use_BANG] = ACTIONS(2879),
    [anon_sym_do_BANG] = ACTIONS(2879),
    [anon_sym_begin] = ACTIONS(2877),
    [anon_sym_LPAREN2] = ACTIONS(2877),
    [anon_sym_or] = ACTIONS(2877),
    [aux_sym_char_token1] = ACTIONS(2879),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2877),
    [anon_sym_DQUOTE] = ACTIONS(2877),
    [anon_sym_AT_DQUOTE] = ACTIONS(2879),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2879),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2879),
    [sym_bool] = ACTIONS(2877),
    [sym_unit] = ACTIONS(2879),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2877),
    [sym_op_identifier] = ACTIONS(2877),
    [anon_sym_PLUS] = ACTIONS(2877),
    [anon_sym_DASH] = ACTIONS(2877),
    [anon_sym_PLUS_DOT] = ACTIONS(2877),
    [anon_sym_DASH_DOT] = ACTIONS(2877),
    [anon_sym_PERCENT] = ACTIONS(2877),
    [anon_sym_AMP_AMP] = ACTIONS(2877),
    [anon_sym_TILDE] = ACTIONS(2879),
    [aux_sym_prefix_op_token1] = ACTIONS(2877),
    [aux_sym_infix_op_token1] = ACTIONS(2879),
    [aux_sym_infix_op_token2] = ACTIONS(2877),
    [anon_sym_PIPE_PIPE] = ACTIONS(2877),
    [anon_sym_BANG_EQ] = ACTIONS(2877),
    [anon_sym_COLON_EQ] = ACTIONS(2879),
    [anon_sym_DOLLAR] = ACTIONS(2877),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2877),
    [sym_int] = ACTIONS(2877),
    [sym_xint] = ACTIONS(2879),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2879),
    [sym__newline] = ACTIONS(2879),
    [sym__dedent] = ACTIONS(2879),
  },
  [1480] = {
    [sym_block_comment] = STATE(1480),
    [sym_compiler_directive_decl] = STATE(1480),
    [sym_fsi_directive_decl] = STATE(1480),
    [sym_preproc_line] = STATE(1480),
    [sym_identifier] = ACTIONS(2873),
    [anon_sym_EQ] = ACTIONS(2875),
    [anon_sym_COLON] = ACTIONS(2873),
    [anon_sym_return] = ACTIONS(2873),
    [anon_sym_do] = ACTIONS(2873),
    [anon_sym_let] = ACTIONS(2873),
    [anon_sym_let_BANG] = ACTIONS(2875),
    [anon_sym_as] = ACTIONS(2873),
    [anon_sym_LPAREN] = ACTIONS(2873),
    [anon_sym_COMMA] = ACTIONS(2875),
    [anon_sym_null] = ACTIONS(2873),
    [anon_sym_QMARK] = ACTIONS(2873),
    [anon_sym_COLON_QMARK] = ACTIONS(2873),
    [anon_sym_COLON_COLON] = ACTIONS(2875),
    [anon_sym_AMP] = ACTIONS(2873),
    [anon_sym_LBRACK] = ACTIONS(2873),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2875),
    [anon_sym_LBRACE] = ACTIONS(2873),
    [anon_sym_LT_AT] = ACTIONS(2873),
    [anon_sym_LT_AT_AT] = ACTIONS(2873),
    [anon_sym_DOT] = ACTIONS(2873),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2875),
    [anon_sym_new] = ACTIONS(2873),
    [anon_sym_with] = ACTIONS(2873),
    [anon_sym_return_BANG] = ACTIONS(2875),
    [anon_sym_yield] = ACTIONS(2873),
    [anon_sym_yield_BANG] = ACTIONS(2875),
    [anon_sym_lazy] = ACTIONS(2873),
    [anon_sym_assert] = ACTIONS(2873),
    [anon_sym_upcast] = ACTIONS(2873),
    [anon_sym_downcast] = ACTIONS(2873),
    [anon_sym_COLON_GT] = ACTIONS(2875),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2875),
    [anon_sym_for] = ACTIONS(2873),
    [anon_sym_while] = ACTIONS(2873),
    [anon_sym_if] = ACTIONS(2873),
    [anon_sym_fun] = ACTIONS(2873),
    [anon_sym_try] = ACTIONS(2873),
    [anon_sym_match] = ACTIONS(2873),
    [anon_sym_match_BANG] = ACTIONS(2875),
    [anon_sym_function] = ACTIONS(2873),
    [anon_sym_LT_DASH] = ACTIONS(2873),
    [anon_sym_DOT_LBRACK] = ACTIONS(2875),
    [anon_sym_LT] = ACTIONS(2875),
    [anon_sym_use] = ACTIONS(2873),
    [anon_sym_use_BANG] = ACTIONS(2875),
    [anon_sym_do_BANG] = ACTIONS(2875),
    [anon_sym_begin] = ACTIONS(2873),
    [anon_sym_LPAREN2] = ACTIONS(2873),
    [anon_sym_or] = ACTIONS(2873),
    [aux_sym_char_token1] = ACTIONS(2875),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2873),
    [anon_sym_DQUOTE] = ACTIONS(2873),
    [anon_sym_AT_DQUOTE] = ACTIONS(2875),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2875),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2875),
    [sym_bool] = ACTIONS(2873),
    [sym_unit] = ACTIONS(2875),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2873),
    [sym_op_identifier] = ACTIONS(2873),
    [anon_sym_PLUS] = ACTIONS(2873),
    [anon_sym_DASH] = ACTIONS(2873),
    [anon_sym_PLUS_DOT] = ACTIONS(2873),
    [anon_sym_DASH_DOT] = ACTIONS(2873),
    [anon_sym_PERCENT] = ACTIONS(2873),
    [anon_sym_AMP_AMP] = ACTIONS(2873),
    [anon_sym_TILDE] = ACTIONS(2875),
    [aux_sym_prefix_op_token1] = ACTIONS(2873),
    [aux_sym_infix_op_token1] = ACTIONS(2875),
    [aux_sym_infix_op_token2] = ACTIONS(2873),
    [anon_sym_PIPE_PIPE] = ACTIONS(2873),
    [anon_sym_BANG_EQ] = ACTIONS(2873),
    [anon_sym_COLON_EQ] = ACTIONS(2875),
    [anon_sym_DOLLAR] = ACTIONS(2873),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2873),
    [sym_int] = ACTIONS(2873),
    [sym_xint] = ACTIONS(2875),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2875),
    [sym__newline] = ACTIONS(2875),
    [sym__dedent] = ACTIONS(2875),
  },
  [1481] = {
    [sym_block_comment] = STATE(1481),
    [sym_compiler_directive_decl] = STATE(1481),
    [sym_fsi_directive_decl] = STATE(1481),
    [sym_preproc_line] = STATE(1481),
    [sym_identifier] = ACTIONS(2783),
    [anon_sym_EQ] = ACTIONS(2785),
    [anon_sym_COLON] = ACTIONS(2783),
    [anon_sym_return] = ACTIONS(2783),
    [anon_sym_do] = ACTIONS(2783),
    [anon_sym_let] = ACTIONS(2783),
    [anon_sym_let_BANG] = ACTIONS(2785),
    [anon_sym_LPAREN] = ACTIONS(2783),
    [anon_sym_COMMA] = ACTIONS(2785),
    [anon_sym_null] = ACTIONS(2783),
    [anon_sym_QMARK] = ACTIONS(2783),
    [anon_sym_COLON_QMARK] = ACTIONS(2783),
    [anon_sym_COLON_COLON] = ACTIONS(2785),
    [anon_sym_AMP] = ACTIONS(2783),
    [anon_sym_LBRACK] = ACTIONS(2783),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2785),
    [anon_sym_LBRACE] = ACTIONS(2783),
    [anon_sym_LT_AT] = ACTIONS(2783),
    [anon_sym_LT_AT_AT] = ACTIONS(2783),
    [anon_sym_AT_AT_GT] = ACTIONS(2783),
    [anon_sym_DOT] = ACTIONS(2783),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2785),
    [anon_sym_new] = ACTIONS(2783),
    [anon_sym_return_BANG] = ACTIONS(2785),
    [anon_sym_yield] = ACTIONS(2783),
    [anon_sym_yield_BANG] = ACTIONS(2785),
    [anon_sym_lazy] = ACTIONS(2783),
    [anon_sym_assert] = ACTIONS(2783),
    [anon_sym_upcast] = ACTIONS(2783),
    [anon_sym_downcast] = ACTIONS(2783),
    [anon_sym_COLON_GT] = ACTIONS(2785),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2785),
    [anon_sym_for] = ACTIONS(2783),
    [anon_sym_done] = ACTIONS(3698),
    [anon_sym_while] = ACTIONS(2783),
    [anon_sym_if] = ACTIONS(2783),
    [anon_sym_fun] = ACTIONS(2783),
    [anon_sym_try] = ACTIONS(2783),
    [anon_sym_match] = ACTIONS(2783),
    [anon_sym_match_BANG] = ACTIONS(2785),
    [anon_sym_function] = ACTIONS(2783),
    [anon_sym_LT_DASH] = ACTIONS(2783),
    [anon_sym_DOT_LBRACK] = ACTIONS(2785),
    [anon_sym_LT] = ACTIONS(2785),
    [anon_sym_use] = ACTIONS(2783),
    [anon_sym_use_BANG] = ACTIONS(2785),
    [anon_sym_do_BANG] = ACTIONS(2785),
    [anon_sym_DOT_DOT] = ACTIONS(2789),
    [anon_sym_begin] = ACTIONS(2783),
    [anon_sym_LPAREN2] = ACTIONS(2783),
    [anon_sym_or] = ACTIONS(2783),
    [aux_sym_char_token1] = ACTIONS(2785),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2783),
    [anon_sym_DQUOTE] = ACTIONS(2783),
    [anon_sym_AT_DQUOTE] = ACTIONS(2785),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2785),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2785),
    [sym_bool] = ACTIONS(2783),
    [sym_unit] = ACTIONS(2785),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2783),
    [sym_op_identifier] = ACTIONS(2783),
    [anon_sym_PLUS] = ACTIONS(2783),
    [anon_sym_DASH] = ACTIONS(2783),
    [anon_sym_PLUS_DOT] = ACTIONS(2783),
    [anon_sym_DASH_DOT] = ACTIONS(2783),
    [anon_sym_PERCENT] = ACTIONS(2783),
    [anon_sym_AMP_AMP] = ACTIONS(2783),
    [anon_sym_TILDE] = ACTIONS(2785),
    [aux_sym_prefix_op_token1] = ACTIONS(2783),
    [aux_sym_infix_op_token1] = ACTIONS(2785),
    [aux_sym_infix_op_token2] = ACTIONS(2783),
    [anon_sym_PIPE_PIPE] = ACTIONS(2783),
    [anon_sym_BANG_EQ] = ACTIONS(2783),
    [anon_sym_COLON_EQ] = ACTIONS(2785),
    [anon_sym_DOLLAR] = ACTIONS(2783),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2783),
    [sym_int] = ACTIONS(2783),
    [sym_xint] = ACTIONS(2785),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2785),
    [sym__newline] = ACTIONS(2785),
  },
  [1482] = {
    [sym_block_comment] = STATE(1482),
    [sym_compiler_directive_decl] = STATE(1482),
    [sym_fsi_directive_decl] = STATE(1482),
    [sym_preproc_line] = STATE(1482),
    [sym_identifier] = ACTIONS(2859),
    [anon_sym_EQ] = ACTIONS(2861),
    [anon_sym_COLON] = ACTIONS(2859),
    [anon_sym_return] = ACTIONS(2859),
    [anon_sym_do] = ACTIONS(2859),
    [anon_sym_let] = ACTIONS(2859),
    [anon_sym_let_BANG] = ACTIONS(2861),
    [anon_sym_as] = ACTIONS(2859),
    [anon_sym_LPAREN] = ACTIONS(2859),
    [anon_sym_COMMA] = ACTIONS(2861),
    [anon_sym_null] = ACTIONS(2859),
    [anon_sym_QMARK] = ACTIONS(2859),
    [anon_sym_COLON_QMARK] = ACTIONS(2859),
    [anon_sym_COLON_COLON] = ACTIONS(2861),
    [anon_sym_AMP] = ACTIONS(2859),
    [anon_sym_LBRACK] = ACTIONS(2859),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2861),
    [anon_sym_LBRACE] = ACTIONS(2859),
    [anon_sym_LT_AT] = ACTIONS(2859),
    [anon_sym_LT_AT_AT] = ACTIONS(2859),
    [anon_sym_DOT] = ACTIONS(2859),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2861),
    [anon_sym_new] = ACTIONS(2859),
    [anon_sym_with] = ACTIONS(2859),
    [anon_sym_return_BANG] = ACTIONS(2861),
    [anon_sym_yield] = ACTIONS(2859),
    [anon_sym_yield_BANG] = ACTIONS(2861),
    [anon_sym_lazy] = ACTIONS(2859),
    [anon_sym_assert] = ACTIONS(2859),
    [anon_sym_upcast] = ACTIONS(2859),
    [anon_sym_downcast] = ACTIONS(2859),
    [anon_sym_COLON_GT] = ACTIONS(2861),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2861),
    [anon_sym_for] = ACTIONS(2859),
    [anon_sym_while] = ACTIONS(2859),
    [anon_sym_if] = ACTIONS(2859),
    [anon_sym_fun] = ACTIONS(2859),
    [anon_sym_try] = ACTIONS(2859),
    [anon_sym_match] = ACTIONS(2859),
    [anon_sym_match_BANG] = ACTIONS(2861),
    [anon_sym_function] = ACTIONS(2859),
    [anon_sym_LT_DASH] = ACTIONS(2859),
    [anon_sym_DOT_LBRACK] = ACTIONS(2861),
    [anon_sym_LT] = ACTIONS(2861),
    [anon_sym_use] = ACTIONS(2859),
    [anon_sym_use_BANG] = ACTIONS(2861),
    [anon_sym_do_BANG] = ACTIONS(2861),
    [anon_sym_begin] = ACTIONS(2859),
    [anon_sym_LPAREN2] = ACTIONS(2859),
    [anon_sym_or] = ACTIONS(2859),
    [aux_sym_char_token1] = ACTIONS(2861),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2859),
    [anon_sym_DQUOTE] = ACTIONS(2859),
    [anon_sym_AT_DQUOTE] = ACTIONS(2861),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2861),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2861),
    [sym_bool] = ACTIONS(2859),
    [sym_unit] = ACTIONS(2861),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2859),
    [sym_op_identifier] = ACTIONS(2859),
    [anon_sym_PLUS] = ACTIONS(2859),
    [anon_sym_DASH] = ACTIONS(2859),
    [anon_sym_PLUS_DOT] = ACTIONS(2859),
    [anon_sym_DASH_DOT] = ACTIONS(2859),
    [anon_sym_PERCENT] = ACTIONS(2859),
    [anon_sym_AMP_AMP] = ACTIONS(2859),
    [anon_sym_TILDE] = ACTIONS(2861),
    [aux_sym_prefix_op_token1] = ACTIONS(2859),
    [aux_sym_infix_op_token1] = ACTIONS(2861),
    [aux_sym_infix_op_token2] = ACTIONS(2859),
    [anon_sym_PIPE_PIPE] = ACTIONS(2859),
    [anon_sym_BANG_EQ] = ACTIONS(2859),
    [anon_sym_COLON_EQ] = ACTIONS(2861),
    [anon_sym_DOLLAR] = ACTIONS(2859),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2859),
    [sym_int] = ACTIONS(2859),
    [sym_xint] = ACTIONS(2861),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2861),
    [sym__newline] = ACTIONS(2861),
    [sym__dedent] = ACTIONS(2861),
  },
  [1483] = {
    [sym_block_comment] = STATE(1483),
    [sym_compiler_directive_decl] = STATE(1483),
    [sym_fsi_directive_decl] = STATE(1483),
    [sym_preproc_line] = STATE(1483),
    [sym_identifier] = ACTIONS(2855),
    [anon_sym_EQ] = ACTIONS(2857),
    [anon_sym_COLON] = ACTIONS(2855),
    [anon_sym_return] = ACTIONS(2855),
    [anon_sym_do] = ACTIONS(2855),
    [anon_sym_let] = ACTIONS(2855),
    [anon_sym_let_BANG] = ACTIONS(2857),
    [anon_sym_as] = ACTIONS(2855),
    [anon_sym_LPAREN] = ACTIONS(2855),
    [anon_sym_COMMA] = ACTIONS(2857),
    [anon_sym_null] = ACTIONS(2855),
    [anon_sym_QMARK] = ACTIONS(2855),
    [anon_sym_COLON_QMARK] = ACTIONS(2855),
    [anon_sym_COLON_COLON] = ACTIONS(2857),
    [anon_sym_AMP] = ACTIONS(2855),
    [anon_sym_LBRACK] = ACTIONS(2855),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2857),
    [anon_sym_LBRACE] = ACTIONS(2855),
    [anon_sym_LT_AT] = ACTIONS(2855),
    [anon_sym_LT_AT_AT] = ACTIONS(2855),
    [anon_sym_DOT] = ACTIONS(2855),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2857),
    [anon_sym_new] = ACTIONS(2855),
    [anon_sym_with] = ACTIONS(2855),
    [anon_sym_return_BANG] = ACTIONS(2857),
    [anon_sym_yield] = ACTIONS(2855),
    [anon_sym_yield_BANG] = ACTIONS(2857),
    [anon_sym_lazy] = ACTIONS(2855),
    [anon_sym_assert] = ACTIONS(2855),
    [anon_sym_upcast] = ACTIONS(2855),
    [anon_sym_downcast] = ACTIONS(2855),
    [anon_sym_COLON_GT] = ACTIONS(2857),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2857),
    [anon_sym_for] = ACTIONS(2855),
    [anon_sym_while] = ACTIONS(2855),
    [anon_sym_if] = ACTIONS(2855),
    [anon_sym_fun] = ACTIONS(2855),
    [anon_sym_try] = ACTIONS(2855),
    [anon_sym_match] = ACTIONS(2855),
    [anon_sym_match_BANG] = ACTIONS(2857),
    [anon_sym_function] = ACTIONS(2855),
    [anon_sym_LT_DASH] = ACTIONS(2855),
    [anon_sym_DOT_LBRACK] = ACTIONS(2857),
    [anon_sym_LT] = ACTIONS(2857),
    [anon_sym_use] = ACTIONS(2855),
    [anon_sym_use_BANG] = ACTIONS(2857),
    [anon_sym_do_BANG] = ACTIONS(2857),
    [anon_sym_begin] = ACTIONS(2855),
    [anon_sym_LPAREN2] = ACTIONS(2855),
    [anon_sym_or] = ACTIONS(2855),
    [aux_sym_char_token1] = ACTIONS(2857),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2855),
    [anon_sym_DQUOTE] = ACTIONS(2855),
    [anon_sym_AT_DQUOTE] = ACTIONS(2857),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2857),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2857),
    [sym_bool] = ACTIONS(2855),
    [sym_unit] = ACTIONS(2857),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2855),
    [sym_op_identifier] = ACTIONS(2855),
    [anon_sym_PLUS] = ACTIONS(2855),
    [anon_sym_DASH] = ACTIONS(2855),
    [anon_sym_PLUS_DOT] = ACTIONS(2855),
    [anon_sym_DASH_DOT] = ACTIONS(2855),
    [anon_sym_PERCENT] = ACTIONS(2855),
    [anon_sym_AMP_AMP] = ACTIONS(2855),
    [anon_sym_TILDE] = ACTIONS(2857),
    [aux_sym_prefix_op_token1] = ACTIONS(2855),
    [aux_sym_infix_op_token1] = ACTIONS(2857),
    [aux_sym_infix_op_token2] = ACTIONS(2855),
    [anon_sym_PIPE_PIPE] = ACTIONS(2855),
    [anon_sym_BANG_EQ] = ACTIONS(2855),
    [anon_sym_COLON_EQ] = ACTIONS(2857),
    [anon_sym_DOLLAR] = ACTIONS(2855),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2855),
    [sym_int] = ACTIONS(2855),
    [sym_xint] = ACTIONS(2857),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2857),
    [sym__newline] = ACTIONS(2857),
    [sym__dedent] = ACTIONS(2857),
  },
  [1484] = {
    [sym_block_comment] = STATE(1484),
    [sym_compiler_directive_decl] = STATE(1484),
    [sym_fsi_directive_decl] = STATE(1484),
    [sym_preproc_line] = STATE(1484),
    [sym_identifier] = ACTIONS(2158),
    [anon_sym_EQ] = ACTIONS(2160),
    [anon_sym_COLON] = ACTIONS(2158),
    [anon_sym_return] = ACTIONS(2158),
    [anon_sym_do] = ACTIONS(2158),
    [anon_sym_let] = ACTIONS(2158),
    [anon_sym_let_BANG] = ACTIONS(2160),
    [anon_sym_as] = ACTIONS(2158),
    [anon_sym_LPAREN] = ACTIONS(2158),
    [anon_sym_COMMA] = ACTIONS(2160),
    [anon_sym_null] = ACTIONS(2158),
    [anon_sym_QMARK] = ACTIONS(2158),
    [anon_sym_COLON_QMARK] = ACTIONS(2158),
    [anon_sym_COLON_COLON] = ACTIONS(2160),
    [anon_sym_AMP] = ACTIONS(2158),
    [anon_sym_LBRACK] = ACTIONS(2158),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2160),
    [anon_sym_LBRACE] = ACTIONS(2158),
    [anon_sym_LT_AT] = ACTIONS(2158),
    [anon_sym_LT_AT_AT] = ACTIONS(2158),
    [anon_sym_DOT] = ACTIONS(2158),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2160),
    [anon_sym_new] = ACTIONS(2158),
    [anon_sym_with] = ACTIONS(2158),
    [anon_sym_return_BANG] = ACTIONS(2160),
    [anon_sym_yield] = ACTIONS(2158),
    [anon_sym_yield_BANG] = ACTIONS(2160),
    [anon_sym_lazy] = ACTIONS(2158),
    [anon_sym_assert] = ACTIONS(2158),
    [anon_sym_upcast] = ACTIONS(2158),
    [anon_sym_downcast] = ACTIONS(2158),
    [anon_sym_COLON_GT] = ACTIONS(2160),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2160),
    [anon_sym_for] = ACTIONS(2158),
    [anon_sym_while] = ACTIONS(2158),
    [anon_sym_if] = ACTIONS(2158),
    [anon_sym_fun] = ACTIONS(2158),
    [anon_sym_try] = ACTIONS(2158),
    [anon_sym_match] = ACTIONS(2158),
    [anon_sym_match_BANG] = ACTIONS(2160),
    [anon_sym_function] = ACTIONS(2158),
    [anon_sym_LT_DASH] = ACTIONS(2158),
    [anon_sym_DOT_LBRACK] = ACTIONS(2160),
    [anon_sym_LT] = ACTIONS(2160),
    [anon_sym_use] = ACTIONS(2158),
    [anon_sym_use_BANG] = ACTIONS(2160),
    [anon_sym_do_BANG] = ACTIONS(2160),
    [anon_sym_begin] = ACTIONS(2158),
    [anon_sym_LPAREN2] = ACTIONS(2158),
    [anon_sym_or] = ACTIONS(2158),
    [aux_sym_char_token1] = ACTIONS(2160),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2158),
    [anon_sym_DQUOTE] = ACTIONS(2158),
    [anon_sym_AT_DQUOTE] = ACTIONS(2160),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2160),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2160),
    [sym_bool] = ACTIONS(2158),
    [sym_unit] = ACTIONS(2160),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2158),
    [sym_op_identifier] = ACTIONS(2158),
    [anon_sym_PLUS] = ACTIONS(2158),
    [anon_sym_DASH] = ACTIONS(2158),
    [anon_sym_PLUS_DOT] = ACTIONS(2158),
    [anon_sym_DASH_DOT] = ACTIONS(2158),
    [anon_sym_PERCENT] = ACTIONS(2158),
    [anon_sym_AMP_AMP] = ACTIONS(2158),
    [anon_sym_TILDE] = ACTIONS(2160),
    [aux_sym_prefix_op_token1] = ACTIONS(2158),
    [aux_sym_infix_op_token1] = ACTIONS(2160),
    [aux_sym_infix_op_token2] = ACTIONS(2158),
    [anon_sym_PIPE_PIPE] = ACTIONS(2158),
    [anon_sym_BANG_EQ] = ACTIONS(2158),
    [anon_sym_COLON_EQ] = ACTIONS(2160),
    [anon_sym_DOLLAR] = ACTIONS(2158),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2158),
    [sym_int] = ACTIONS(2158),
    [sym_xint] = ACTIONS(2160),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2160),
    [sym__newline] = ACTIONS(2160),
    [sym__dedent] = ACTIONS(2160),
  },
  [1485] = {
    [sym_block_comment] = STATE(1485),
    [sym_compiler_directive_decl] = STATE(1485),
    [sym_fsi_directive_decl] = STATE(1485),
    [sym_preproc_line] = STATE(1485),
    [aux_sym_rules_repeat1] = STATE(1485),
    [sym_identifier] = ACTIONS(2713),
    [anon_sym_EQ] = ACTIONS(2715),
    [anon_sym_COLON] = ACTIONS(2713),
    [anon_sym_return] = ACTIONS(2713),
    [anon_sym_do] = ACTIONS(2713),
    [anon_sym_let] = ACTIONS(2713),
    [anon_sym_let_BANG] = ACTIONS(2715),
    [anon_sym_LPAREN] = ACTIONS(2713),
    [anon_sym_COMMA] = ACTIONS(2715),
    [anon_sym_null] = ACTIONS(2713),
    [anon_sym_QMARK] = ACTIONS(2713),
    [anon_sym_COLON_QMARK] = ACTIONS(2713),
    [anon_sym_COLON_COLON] = ACTIONS(2715),
    [anon_sym_PIPE] = ACTIONS(3700),
    [anon_sym_AMP] = ACTIONS(2713),
    [anon_sym_LBRACK] = ACTIONS(2713),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2715),
    [anon_sym_LBRACE] = ACTIONS(2713),
    [anon_sym_LT_AT] = ACTIONS(2713),
    [anon_sym_AT_GT] = ACTIONS(2713),
    [anon_sym_LT_AT_AT] = ACTIONS(2713),
    [anon_sym_DOT] = ACTIONS(2713),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2715),
    [anon_sym_new] = ACTIONS(2713),
    [anon_sym_return_BANG] = ACTIONS(2715),
    [anon_sym_yield] = ACTIONS(2713),
    [anon_sym_yield_BANG] = ACTIONS(2715),
    [anon_sym_lazy] = ACTIONS(2713),
    [anon_sym_assert] = ACTIONS(2713),
    [anon_sym_upcast] = ACTIONS(2713),
    [anon_sym_downcast] = ACTIONS(2713),
    [anon_sym_COLON_GT] = ACTIONS(2715),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2715),
    [anon_sym_for] = ACTIONS(2713),
    [anon_sym_while] = ACTIONS(2713),
    [anon_sym_if] = ACTIONS(2713),
    [anon_sym_fun] = ACTIONS(2713),
    [anon_sym_try] = ACTIONS(2713),
    [anon_sym_match] = ACTIONS(2713),
    [anon_sym_match_BANG] = ACTIONS(2715),
    [anon_sym_function] = ACTIONS(2713),
    [anon_sym_LT_DASH] = ACTIONS(2713),
    [anon_sym_DOT_LBRACK] = ACTIONS(2715),
    [anon_sym_LT] = ACTIONS(2715),
    [anon_sym_use] = ACTIONS(2713),
    [anon_sym_use_BANG] = ACTIONS(2715),
    [anon_sym_do_BANG] = ACTIONS(2715),
    [anon_sym_begin] = ACTIONS(2713),
    [anon_sym_LPAREN2] = ACTIONS(2713),
    [anon_sym_or] = ACTIONS(2713),
    [aux_sym_char_token1] = ACTIONS(2715),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2713),
    [anon_sym_DQUOTE] = ACTIONS(2713),
    [anon_sym_AT_DQUOTE] = ACTIONS(2715),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2715),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2715),
    [sym_bool] = ACTIONS(2713),
    [sym_unit] = ACTIONS(2715),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2713),
    [sym_op_identifier] = ACTIONS(2713),
    [anon_sym_PLUS] = ACTIONS(2713),
    [anon_sym_DASH] = ACTIONS(2713),
    [anon_sym_PLUS_DOT] = ACTIONS(2713),
    [anon_sym_DASH_DOT] = ACTIONS(2713),
    [anon_sym_PERCENT] = ACTIONS(2713),
    [anon_sym_AMP_AMP] = ACTIONS(2713),
    [anon_sym_TILDE] = ACTIONS(2715),
    [aux_sym_prefix_op_token1] = ACTIONS(2713),
    [aux_sym_infix_op_token1] = ACTIONS(2715),
    [aux_sym_infix_op_token2] = ACTIONS(2713),
    [anon_sym_PIPE_PIPE] = ACTIONS(2713),
    [anon_sym_BANG_EQ] = ACTIONS(2713),
    [anon_sym_COLON_EQ] = ACTIONS(2715),
    [anon_sym_DOLLAR] = ACTIONS(2713),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2713),
    [sym_int] = ACTIONS(2713),
    [sym_xint] = ACTIONS(2715),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2715),
    [sym__newline] = ACTIONS(3703),
  },
  [1486] = {
    [sym_block_comment] = STATE(1486),
    [sym_compiler_directive_decl] = STATE(1486),
    [sym_fsi_directive_decl] = STATE(1486),
    [sym_preproc_line] = STATE(1486),
    [aux_sym_sequential_expression_repeat1] = STATE(1486),
    [sym_identifier] = ACTIONS(2895),
    [anon_sym_EQ] = ACTIONS(2897),
    [anon_sym_COLON] = ACTIONS(2895),
    [anon_sym_return] = ACTIONS(2895),
    [anon_sym_do] = ACTIONS(2895),
    [anon_sym_let] = ACTIONS(2895),
    [anon_sym_let_BANG] = ACTIONS(2897),
    [anon_sym_LPAREN] = ACTIONS(2895),
    [anon_sym_COMMA] = ACTIONS(2897),
    [anon_sym_null] = ACTIONS(2895),
    [anon_sym_QMARK] = ACTIONS(2895),
    [anon_sym_COLON_QMARK] = ACTIONS(2895),
    [anon_sym_COLON_COLON] = ACTIONS(2897),
    [anon_sym_AMP] = ACTIONS(2895),
    [anon_sym_LBRACK] = ACTIONS(2895),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2897),
    [anon_sym_LBRACE] = ACTIONS(2895),
    [anon_sym_LT_AT] = ACTIONS(2895),
    [anon_sym_LT_AT_AT] = ACTIONS(2895),
    [anon_sym_DOT] = ACTIONS(2895),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2897),
    [anon_sym_new] = ACTIONS(2895),
    [anon_sym_return_BANG] = ACTIONS(2897),
    [anon_sym_yield] = ACTIONS(2895),
    [anon_sym_yield_BANG] = ACTIONS(2897),
    [anon_sym_lazy] = ACTIONS(2895),
    [anon_sym_assert] = ACTIONS(2895),
    [anon_sym_upcast] = ACTIONS(2895),
    [anon_sym_downcast] = ACTIONS(2895),
    [anon_sym_COLON_GT] = ACTIONS(2897),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2897),
    [anon_sym_for] = ACTIONS(2895),
    [anon_sym_while] = ACTIONS(2895),
    [anon_sym_if] = ACTIONS(2895),
    [anon_sym_fun] = ACTIONS(2895),
    [anon_sym_try] = ACTIONS(2895),
    [anon_sym_match] = ACTIONS(2895),
    [anon_sym_match_BANG] = ACTIONS(2897),
    [anon_sym_function] = ACTIONS(2895),
    [anon_sym_LT_DASH] = ACTIONS(2895),
    [anon_sym_DOT_LBRACK] = ACTIONS(2897),
    [anon_sym_LT] = ACTIONS(2897),
    [anon_sym_use] = ACTIONS(2895),
    [anon_sym_use_BANG] = ACTIONS(2897),
    [anon_sym_do_BANG] = ACTIONS(2897),
    [anon_sym_begin] = ACTIONS(2895),
    [anon_sym_LPAREN2] = ACTIONS(2895),
    [anon_sym_or] = ACTIONS(2895),
    [aux_sym_char_token1] = ACTIONS(2897),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2895),
    [anon_sym_DQUOTE] = ACTIONS(2895),
    [anon_sym_AT_DQUOTE] = ACTIONS(2897),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2897),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2897),
    [sym_bool] = ACTIONS(2895),
    [sym_unit] = ACTIONS(2897),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2895),
    [sym_op_identifier] = ACTIONS(2895),
    [anon_sym_PLUS] = ACTIONS(2895),
    [anon_sym_DASH] = ACTIONS(2895),
    [anon_sym_PLUS_DOT] = ACTIONS(2895),
    [anon_sym_DASH_DOT] = ACTIONS(2895),
    [anon_sym_PERCENT] = ACTIONS(2895),
    [anon_sym_AMP_AMP] = ACTIONS(2895),
    [anon_sym_TILDE] = ACTIONS(2897),
    [aux_sym_prefix_op_token1] = ACTIONS(2895),
    [aux_sym_infix_op_token1] = ACTIONS(2897),
    [aux_sym_infix_op_token2] = ACTIONS(2895),
    [anon_sym_PIPE_PIPE] = ACTIONS(2895),
    [anon_sym_BANG_EQ] = ACTIONS(2895),
    [anon_sym_COLON_EQ] = ACTIONS(2897),
    [anon_sym_DOLLAR] = ACTIONS(2895),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2895),
    [sym_int] = ACTIONS(2895),
    [sym_xint] = ACTIONS(2897),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2897),
    [anon_sym_POUNDendif] = ACTIONS(2897),
    [anon_sym_POUNDelse] = ACTIONS(2897),
    [sym__newline] = ACTIONS(3706),
  },
  [1487] = {
    [sym_block_comment] = STATE(1487),
    [sym_compiler_directive_decl] = STATE(1487),
    [sym_fsi_directive_decl] = STATE(1487),
    [sym_preproc_line] = STATE(1487),
    [sym_identifier] = ACTIONS(2158),
    [anon_sym_EQ] = ACTIONS(2160),
    [anon_sym_COLON] = ACTIONS(2158),
    [anon_sym_return] = ACTIONS(2158),
    [anon_sym_do] = ACTIONS(2158),
    [anon_sym_let] = ACTIONS(2158),
    [anon_sym_let_BANG] = ACTIONS(2160),
    [anon_sym_LPAREN] = ACTIONS(2158),
    [anon_sym_COMMA] = ACTIONS(2160),
    [anon_sym_null] = ACTIONS(2158),
    [anon_sym_QMARK] = ACTIONS(2158),
    [anon_sym_COLON_QMARK] = ACTIONS(2158),
    [anon_sym_COLON_COLON] = ACTIONS(2160),
    [anon_sym_AMP] = ACTIONS(2158),
    [anon_sym_LBRACK] = ACTIONS(2158),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2160),
    [anon_sym_LBRACE] = ACTIONS(2158),
    [anon_sym_LT_AT] = ACTIONS(2158),
    [anon_sym_LT_AT_AT] = ACTIONS(2158),
    [anon_sym_DOT] = ACTIONS(2158),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2160),
    [anon_sym_new] = ACTIONS(2158),
    [anon_sym_return_BANG] = ACTIONS(2160),
    [anon_sym_yield] = ACTIONS(2158),
    [anon_sym_yield_BANG] = ACTIONS(2160),
    [anon_sym_lazy] = ACTIONS(2158),
    [anon_sym_assert] = ACTIONS(2158),
    [anon_sym_upcast] = ACTIONS(2158),
    [anon_sym_downcast] = ACTIONS(2158),
    [anon_sym_COLON_GT] = ACTIONS(2160),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2160),
    [anon_sym_for] = ACTIONS(2158),
    [anon_sym_while] = ACTIONS(2158),
    [anon_sym_if] = ACTIONS(2158),
    [anon_sym_fun] = ACTIONS(2158),
    [anon_sym_try] = ACTIONS(2158),
    [anon_sym_match] = ACTIONS(2158),
    [anon_sym_match_BANG] = ACTIONS(2160),
    [anon_sym_function] = ACTIONS(2158),
    [anon_sym_LT_DASH] = ACTIONS(2158),
    [anon_sym_DOT_LBRACK] = ACTIONS(2160),
    [anon_sym_LT] = ACTIONS(2160),
    [anon_sym_use] = ACTIONS(2158),
    [anon_sym_use_BANG] = ACTIONS(2160),
    [anon_sym_do_BANG] = ACTIONS(2160),
    [anon_sym_DOT_DOT] = ACTIONS(2160),
    [anon_sym_begin] = ACTIONS(2158),
    [anon_sym_LPAREN2] = ACTIONS(2158),
    [anon_sym_or] = ACTIONS(2158),
    [aux_sym_char_token1] = ACTIONS(2160),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2158),
    [anon_sym_DQUOTE] = ACTIONS(2158),
    [anon_sym_AT_DQUOTE] = ACTIONS(2160),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2160),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2160),
    [sym_bool] = ACTIONS(2158),
    [sym_unit] = ACTIONS(2160),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2158),
    [sym_op_identifier] = ACTIONS(2158),
    [anon_sym_PLUS] = ACTIONS(2158),
    [anon_sym_DASH] = ACTIONS(2158),
    [anon_sym_PLUS_DOT] = ACTIONS(2158),
    [anon_sym_DASH_DOT] = ACTIONS(2158),
    [anon_sym_PERCENT] = ACTIONS(2158),
    [anon_sym_AMP_AMP] = ACTIONS(2158),
    [anon_sym_TILDE] = ACTIONS(2160),
    [aux_sym_prefix_op_token1] = ACTIONS(2158),
    [aux_sym_infix_op_token1] = ACTIONS(2160),
    [aux_sym_infix_op_token2] = ACTIONS(2158),
    [anon_sym_PIPE_PIPE] = ACTIONS(2158),
    [anon_sym_BANG_EQ] = ACTIONS(2158),
    [anon_sym_COLON_EQ] = ACTIONS(2160),
    [anon_sym_DOLLAR] = ACTIONS(2158),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2158),
    [sym_int] = ACTIONS(2158),
    [sym_xint] = ACTIONS(2160),
    [anon_sym_f] = ACTIONS(2709),
    [aux_sym_decimal_token1] = ACTIONS(2500),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2160),
    [sym__newline] = ACTIONS(2160),
  },
  [1488] = {
    [sym_block_comment] = STATE(1488),
    [sym_compiler_directive_decl] = STATE(1488),
    [sym_fsi_directive_decl] = STATE(1488),
    [sym_preproc_line] = STATE(1488),
    [aux_sym_rules_repeat1] = STATE(1485),
    [sym_identifier] = ACTIONS(2737),
    [anon_sym_EQ] = ACTIONS(2739),
    [anon_sym_COLON] = ACTIONS(2737),
    [anon_sym_return] = ACTIONS(2737),
    [anon_sym_do] = ACTIONS(2737),
    [anon_sym_let] = ACTIONS(2737),
    [anon_sym_let_BANG] = ACTIONS(2739),
    [anon_sym_LPAREN] = ACTIONS(2737),
    [anon_sym_COMMA] = ACTIONS(2739),
    [anon_sym_null] = ACTIONS(2737),
    [anon_sym_QMARK] = ACTIONS(2737),
    [anon_sym_COLON_QMARK] = ACTIONS(2737),
    [anon_sym_COLON_COLON] = ACTIONS(2739),
    [anon_sym_PIPE] = ACTIONS(3709),
    [anon_sym_AMP] = ACTIONS(2737),
    [anon_sym_LBRACK] = ACTIONS(2737),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2739),
    [anon_sym_LBRACE] = ACTIONS(2737),
    [anon_sym_LT_AT] = ACTIONS(2737),
    [anon_sym_AT_GT] = ACTIONS(2737),
    [anon_sym_LT_AT_AT] = ACTIONS(2737),
    [anon_sym_DOT] = ACTIONS(2737),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2739),
    [anon_sym_new] = ACTIONS(2737),
    [anon_sym_return_BANG] = ACTIONS(2739),
    [anon_sym_yield] = ACTIONS(2737),
    [anon_sym_yield_BANG] = ACTIONS(2739),
    [anon_sym_lazy] = ACTIONS(2737),
    [anon_sym_assert] = ACTIONS(2737),
    [anon_sym_upcast] = ACTIONS(2737),
    [anon_sym_downcast] = ACTIONS(2737),
    [anon_sym_COLON_GT] = ACTIONS(2739),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2739),
    [anon_sym_for] = ACTIONS(2737),
    [anon_sym_while] = ACTIONS(2737),
    [anon_sym_if] = ACTIONS(2737),
    [anon_sym_fun] = ACTIONS(2737),
    [anon_sym_try] = ACTIONS(2737),
    [anon_sym_match] = ACTIONS(2737),
    [anon_sym_match_BANG] = ACTIONS(2739),
    [anon_sym_function] = ACTIONS(2737),
    [anon_sym_LT_DASH] = ACTIONS(2737),
    [anon_sym_DOT_LBRACK] = ACTIONS(2739),
    [anon_sym_LT] = ACTIONS(2739),
    [anon_sym_use] = ACTIONS(2737),
    [anon_sym_use_BANG] = ACTIONS(2739),
    [anon_sym_do_BANG] = ACTIONS(2739),
    [anon_sym_begin] = ACTIONS(2737),
    [anon_sym_LPAREN2] = ACTIONS(2737),
    [anon_sym_or] = ACTIONS(2737),
    [aux_sym_char_token1] = ACTIONS(2739),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2737),
    [anon_sym_DQUOTE] = ACTIONS(2737),
    [anon_sym_AT_DQUOTE] = ACTIONS(2739),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2739),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2739),
    [sym_bool] = ACTIONS(2737),
    [sym_unit] = ACTIONS(2739),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2737),
    [sym_op_identifier] = ACTIONS(2737),
    [anon_sym_PLUS] = ACTIONS(2737),
    [anon_sym_DASH] = ACTIONS(2737),
    [anon_sym_PLUS_DOT] = ACTIONS(2737),
    [anon_sym_DASH_DOT] = ACTIONS(2737),
    [anon_sym_PERCENT] = ACTIONS(2737),
    [anon_sym_AMP_AMP] = ACTIONS(2737),
    [anon_sym_TILDE] = ACTIONS(2739),
    [aux_sym_prefix_op_token1] = ACTIONS(2737),
    [aux_sym_infix_op_token1] = ACTIONS(2739),
    [aux_sym_infix_op_token2] = ACTIONS(2737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2737),
    [anon_sym_BANG_EQ] = ACTIONS(2737),
    [anon_sym_COLON_EQ] = ACTIONS(2739),
    [anon_sym_DOLLAR] = ACTIONS(2737),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2737),
    [sym_int] = ACTIONS(2737),
    [sym_xint] = ACTIONS(2739),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2739),
    [sym__newline] = ACTIONS(3711),
  },
  [1489] = {
    [sym_block_comment] = STATE(1489),
    [sym_compiler_directive_decl] = STATE(1489),
    [sym_fsi_directive_decl] = STATE(1489),
    [sym_preproc_line] = STATE(1489),
    [sym_identifier] = ACTIONS(2843),
    [anon_sym_EQ] = ACTIONS(2845),
    [anon_sym_COLON] = ACTIONS(2843),
    [anon_sym_return] = ACTIONS(2843),
    [anon_sym_do] = ACTIONS(2843),
    [anon_sym_let] = ACTIONS(2843),
    [anon_sym_let_BANG] = ACTIONS(2845),
    [anon_sym_as] = ACTIONS(2843),
    [anon_sym_LPAREN] = ACTIONS(2843),
    [anon_sym_COMMA] = ACTIONS(2845),
    [anon_sym_null] = ACTIONS(2843),
    [anon_sym_QMARK] = ACTIONS(2843),
    [anon_sym_COLON_QMARK] = ACTIONS(2843),
    [anon_sym_COLON_COLON] = ACTIONS(2845),
    [anon_sym_AMP] = ACTIONS(2843),
    [anon_sym_LBRACK] = ACTIONS(2843),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2845),
    [anon_sym_LBRACE] = ACTIONS(2843),
    [anon_sym_LT_AT] = ACTIONS(2843),
    [anon_sym_LT_AT_AT] = ACTIONS(2843),
    [anon_sym_DOT] = ACTIONS(2843),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2845),
    [anon_sym_new] = ACTIONS(2843),
    [anon_sym_with] = ACTIONS(2843),
    [anon_sym_return_BANG] = ACTIONS(2845),
    [anon_sym_yield] = ACTIONS(2843),
    [anon_sym_yield_BANG] = ACTIONS(2845),
    [anon_sym_lazy] = ACTIONS(2843),
    [anon_sym_assert] = ACTIONS(2843),
    [anon_sym_upcast] = ACTIONS(2843),
    [anon_sym_downcast] = ACTIONS(2843),
    [anon_sym_COLON_GT] = ACTIONS(2845),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2845),
    [anon_sym_for] = ACTIONS(2843),
    [anon_sym_while] = ACTIONS(2843),
    [anon_sym_if] = ACTIONS(2843),
    [anon_sym_fun] = ACTIONS(2843),
    [anon_sym_try] = ACTIONS(2843),
    [anon_sym_match] = ACTIONS(2843),
    [anon_sym_match_BANG] = ACTIONS(2845),
    [anon_sym_function] = ACTIONS(2843),
    [anon_sym_LT_DASH] = ACTIONS(2843),
    [anon_sym_DOT_LBRACK] = ACTIONS(2845),
    [anon_sym_LT] = ACTIONS(2845),
    [anon_sym_use] = ACTIONS(2843),
    [anon_sym_use_BANG] = ACTIONS(2845),
    [anon_sym_do_BANG] = ACTIONS(2845),
    [anon_sym_begin] = ACTIONS(2843),
    [anon_sym_LPAREN2] = ACTIONS(2843),
    [anon_sym_or] = ACTIONS(2843),
    [aux_sym_char_token1] = ACTIONS(2845),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2843),
    [anon_sym_DQUOTE] = ACTIONS(2843),
    [anon_sym_AT_DQUOTE] = ACTIONS(2845),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2845),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2845),
    [sym_bool] = ACTIONS(2843),
    [sym_unit] = ACTIONS(2845),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2843),
    [sym_op_identifier] = ACTIONS(2843),
    [anon_sym_PLUS] = ACTIONS(2843),
    [anon_sym_DASH] = ACTIONS(2843),
    [anon_sym_PLUS_DOT] = ACTIONS(2843),
    [anon_sym_DASH_DOT] = ACTIONS(2843),
    [anon_sym_PERCENT] = ACTIONS(2843),
    [anon_sym_AMP_AMP] = ACTIONS(2843),
    [anon_sym_TILDE] = ACTIONS(2845),
    [aux_sym_prefix_op_token1] = ACTIONS(2843),
    [aux_sym_infix_op_token1] = ACTIONS(2845),
    [aux_sym_infix_op_token2] = ACTIONS(2843),
    [anon_sym_PIPE_PIPE] = ACTIONS(2843),
    [anon_sym_BANG_EQ] = ACTIONS(2843),
    [anon_sym_COLON_EQ] = ACTIONS(2845),
    [anon_sym_DOLLAR] = ACTIONS(2843),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2843),
    [sym_int] = ACTIONS(2843),
    [sym_xint] = ACTIONS(2845),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2845),
    [sym__newline] = ACTIONS(2845),
    [sym__dedent] = ACTIONS(2845),
  },
  [1490] = {
    [sym_block_comment] = STATE(1490),
    [sym_compiler_directive_decl] = STATE(1490),
    [sym_fsi_directive_decl] = STATE(1490),
    [sym_preproc_line] = STATE(1490),
    [aux_sym_sequential_expression_repeat1] = STATE(1589),
    [sym_identifier] = ACTIONS(2847),
    [anon_sym_EQ] = ACTIONS(2849),
    [anon_sym_COLON] = ACTIONS(2847),
    [anon_sym_return] = ACTIONS(2847),
    [anon_sym_do] = ACTIONS(2847),
    [anon_sym_let] = ACTIONS(2847),
    [anon_sym_let_BANG] = ACTIONS(2849),
    [anon_sym_LPAREN] = ACTIONS(2847),
    [anon_sym_COMMA] = ACTIONS(2849),
    [anon_sym_null] = ACTIONS(2847),
    [anon_sym_QMARK] = ACTIONS(2847),
    [anon_sym_COLON_QMARK] = ACTIONS(2847),
    [anon_sym_COLON_COLON] = ACTIONS(2849),
    [anon_sym_AMP] = ACTIONS(2847),
    [anon_sym_LBRACK] = ACTIONS(2847),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2849),
    [anon_sym_LBRACE] = ACTIONS(2847),
    [anon_sym_LT_AT] = ACTIONS(2847),
    [anon_sym_LT_AT_AT] = ACTIONS(2847),
    [anon_sym_DOT] = ACTIONS(2847),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2849),
    [anon_sym_new] = ACTIONS(2847),
    [anon_sym_return_BANG] = ACTIONS(2849),
    [anon_sym_yield] = ACTIONS(2847),
    [anon_sym_yield_BANG] = ACTIONS(2849),
    [anon_sym_lazy] = ACTIONS(2847),
    [anon_sym_assert] = ACTIONS(2847),
    [anon_sym_upcast] = ACTIONS(2847),
    [anon_sym_downcast] = ACTIONS(2847),
    [anon_sym_COLON_GT] = ACTIONS(2849),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2849),
    [anon_sym_for] = ACTIONS(2847),
    [anon_sym_while] = ACTIONS(2847),
    [anon_sym_if] = ACTIONS(2847),
    [anon_sym_fun] = ACTIONS(2847),
    [anon_sym_DASH_GT] = ACTIONS(2847),
    [anon_sym_try] = ACTIONS(2847),
    [anon_sym_match] = ACTIONS(2847),
    [anon_sym_match_BANG] = ACTIONS(2849),
    [anon_sym_function] = ACTIONS(2847),
    [anon_sym_LT_DASH] = ACTIONS(2847),
    [anon_sym_DOT_LBRACK] = ACTIONS(2849),
    [anon_sym_LT] = ACTIONS(2849),
    [anon_sym_use] = ACTIONS(2847),
    [anon_sym_use_BANG] = ACTIONS(2849),
    [anon_sym_do_BANG] = ACTIONS(2849),
    [anon_sym_DOT_DOT] = ACTIONS(2849),
    [anon_sym_begin] = ACTIONS(2847),
    [anon_sym_LPAREN2] = ACTIONS(2847),
    [anon_sym_or] = ACTIONS(2847),
    [aux_sym_char_token1] = ACTIONS(2849),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2847),
    [anon_sym_DQUOTE] = ACTIONS(2847),
    [anon_sym_AT_DQUOTE] = ACTIONS(2849),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2849),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2849),
    [sym_bool] = ACTIONS(2847),
    [sym_unit] = ACTIONS(2849),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2847),
    [sym_op_identifier] = ACTIONS(2847),
    [anon_sym_PLUS] = ACTIONS(2847),
    [anon_sym_DASH] = ACTIONS(2847),
    [anon_sym_PLUS_DOT] = ACTIONS(2847),
    [anon_sym_DASH_DOT] = ACTIONS(2847),
    [anon_sym_PERCENT] = ACTIONS(2847),
    [anon_sym_AMP_AMP] = ACTIONS(2847),
    [anon_sym_TILDE] = ACTIONS(2849),
    [aux_sym_prefix_op_token1] = ACTIONS(2847),
    [aux_sym_infix_op_token1] = ACTIONS(2849),
    [aux_sym_infix_op_token2] = ACTIONS(2847),
    [anon_sym_PIPE_PIPE] = ACTIONS(2847),
    [anon_sym_BANG_EQ] = ACTIONS(2847),
    [anon_sym_COLON_EQ] = ACTIONS(2849),
    [anon_sym_DOLLAR] = ACTIONS(2847),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2847),
    [sym_int] = ACTIONS(2847),
    [sym_xint] = ACTIONS(2849),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2849),
    [sym__newline] = ACTIONS(2849),
  },
  [1491] = {
    [sym_attributes] = STATE(2676),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(4815),
    [sym__pattern] = STATE(5088),
    [sym_optional_pattern] = STATE(4815),
    [sym_type_check_pattern] = STATE(4815),
    [sym_attribute_pattern] = STATE(4815),
    [sym_paren_pattern] = STATE(4815),
    [sym_as_pattern] = STATE(4815),
    [sym_cons_pattern] = STATE(4815),
    [sym_disjunct_pattern] = STATE(4815),
    [sym_conjunct_pattern] = STATE(4815),
    [sym_typed_pattern] = STATE(4815),
    [sym_list_pattern] = STATE(4815),
    [sym_array_pattern] = STATE(4815),
    [sym_record_pattern] = STATE(4815),
    [sym_named_field_pattern] = STATE(4815),
    [sym_identifier_pattern] = STATE(4815),
    [sym_long_identifier_or_op] = STATE(1792),
    [sym_char] = STATE(4765),
    [sym_format_string] = STATE(4746),
    [sym__string_literal] = STATE(4746),
    [sym_string] = STATE(4765),
    [sym_verbatim_string] = STATE(4765),
    [sym_bytearray] = STATE(4765),
    [sym_verbatim_bytearray] = STATE(4765),
    [sym_format_triple_quoted_string] = STATE(4720),
    [sym_triple_quoted_string] = STATE(4765),
    [sym_const] = STATE(4815),
    [sym_long_identifier] = STATE(3320),
    [sym_active_pattern] = STATE(3488),
    [sym__identifier_or_op] = STATE(3410),
    [sym_sbyte] = STATE(4765),
    [sym_byte] = STATE(4765),
    [sym_int16] = STATE(4765),
    [sym_uint16] = STATE(4765),
    [sym_int32] = STATE(4765),
    [sym_uint32] = STATE(4765),
    [sym_nativeint] = STATE(4765),
    [sym_unativeint] = STATE(4765),
    [sym_int64] = STATE(4765),
    [sym_uint64] = STATE(4765),
    [sym_ieee32] = STATE(4765),
    [sym_ieee64] = STATE(4765),
    [sym_bignum] = STATE(4765),
    [sym_decimal] = STATE(4765),
    [sym_float] = STATE(4512),
    [sym_block_comment] = STATE(1491),
    [sym_compiler_directive_decl] = STATE(1491),
    [sym_fsi_directive_decl] = STATE(1491),
    [sym_preproc_line] = STATE(1491),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [aux_sym_repeat_pattern_repeat1] = STATE(3397),
    [sym_identifier] = ACTIONS(3562),
    [anon_sym_EQ] = ACTIONS(3714),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_COLON] = ACTIONS(3716),
    [anon_sym_as] = ACTIONS(3718),
    [anon_sym_LPAREN] = ACTIONS(3572),
    [anon_sym_RPAREN] = ACTIONS(3714),
    [anon_sym_COMMA] = ACTIONS(3720),
    [anon_sym_null] = ACTIONS(3574),
    [anon_sym__] = ACTIONS(3576),
    [anon_sym_QMARK] = ACTIONS(3578),
    [anon_sym_COLON_QMARK] = ACTIONS(3580),
    [anon_sym_COLON_COLON] = ACTIONS(3722),
    [anon_sym_PIPE] = ACTIONS(3724),
    [anon_sym_AMP] = ACTIONS(3726),
    [anon_sym_LBRACK] = ACTIONS(3582),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3584),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [anon_sym_LT2] = ACTIONS(3714),
    [aux_sym_char_token1] = ACTIONS(3590),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3592),
    [anon_sym_DQUOTE] = ACTIONS(3594),
    [anon_sym_AT_DQUOTE] = ACTIONS(3596),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3598),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3600),
    [sym_bool] = ACTIONS(3602),
    [sym_unit] = ACTIONS(3604),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3606),
    [sym_op_identifier] = ACTIONS(3608),
    [sym_int] = ACTIONS(3610),
    [sym_xint] = ACTIONS(3612),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [1492] = {
    [sym_block_comment] = STATE(1492),
    [sym_compiler_directive_decl] = STATE(1492),
    [sym_fsi_directive_decl] = STATE(1492),
    [sym_preproc_line] = STATE(1492),
    [sym_identifier] = ACTIONS(2804),
    [anon_sym_EQ] = ACTIONS(2806),
    [anon_sym_COLON] = ACTIONS(2804),
    [anon_sym_return] = ACTIONS(2804),
    [anon_sym_do] = ACTIONS(2804),
    [anon_sym_let] = ACTIONS(2804),
    [anon_sym_let_BANG] = ACTIONS(2806),
    [anon_sym_as] = ACTIONS(2804),
    [anon_sym_LPAREN] = ACTIONS(2804),
    [anon_sym_COMMA] = ACTIONS(2806),
    [anon_sym_null] = ACTIONS(2804),
    [anon_sym_QMARK] = ACTIONS(2804),
    [anon_sym_COLON_QMARK] = ACTIONS(2804),
    [anon_sym_COLON_COLON] = ACTIONS(2806),
    [anon_sym_AMP] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2804),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(2804),
    [anon_sym_LT_AT] = ACTIONS(2804),
    [anon_sym_LT_AT_AT] = ACTIONS(2804),
    [anon_sym_DOT] = ACTIONS(2804),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2806),
    [anon_sym_new] = ACTIONS(2804),
    [anon_sym_with] = ACTIONS(2804),
    [anon_sym_return_BANG] = ACTIONS(2806),
    [anon_sym_yield] = ACTIONS(2804),
    [anon_sym_yield_BANG] = ACTIONS(2806),
    [anon_sym_lazy] = ACTIONS(2804),
    [anon_sym_assert] = ACTIONS(2804),
    [anon_sym_upcast] = ACTIONS(2804),
    [anon_sym_downcast] = ACTIONS(2804),
    [anon_sym_COLON_GT] = ACTIONS(2806),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2806),
    [anon_sym_for] = ACTIONS(2804),
    [anon_sym_done] = ACTIONS(3728),
    [anon_sym_while] = ACTIONS(2804),
    [anon_sym_if] = ACTIONS(2804),
    [anon_sym_fun] = ACTIONS(2804),
    [anon_sym_try] = ACTIONS(2804),
    [anon_sym_match] = ACTIONS(2804),
    [anon_sym_match_BANG] = ACTIONS(2806),
    [anon_sym_function] = ACTIONS(2804),
    [anon_sym_LT_DASH] = ACTIONS(2804),
    [anon_sym_DOT_LBRACK] = ACTIONS(2806),
    [anon_sym_LT] = ACTIONS(2806),
    [anon_sym_use] = ACTIONS(2804),
    [anon_sym_use_BANG] = ACTIONS(2806),
    [anon_sym_do_BANG] = ACTIONS(2806),
    [anon_sym_begin] = ACTIONS(2804),
    [anon_sym_LPAREN2] = ACTIONS(2804),
    [anon_sym_or] = ACTIONS(2804),
    [aux_sym_char_token1] = ACTIONS(2806),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2804),
    [anon_sym_DQUOTE] = ACTIONS(2804),
    [anon_sym_AT_DQUOTE] = ACTIONS(2806),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2806),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2806),
    [sym_bool] = ACTIONS(2804),
    [sym_unit] = ACTIONS(2806),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2804),
    [sym_op_identifier] = ACTIONS(2804),
    [anon_sym_PLUS] = ACTIONS(2804),
    [anon_sym_DASH] = ACTIONS(2804),
    [anon_sym_PLUS_DOT] = ACTIONS(2804),
    [anon_sym_DASH_DOT] = ACTIONS(2804),
    [anon_sym_PERCENT] = ACTIONS(2804),
    [anon_sym_AMP_AMP] = ACTIONS(2804),
    [anon_sym_TILDE] = ACTIONS(2806),
    [aux_sym_prefix_op_token1] = ACTIONS(2804),
    [aux_sym_infix_op_token1] = ACTIONS(2806),
    [aux_sym_infix_op_token2] = ACTIONS(2804),
    [anon_sym_PIPE_PIPE] = ACTIONS(2804),
    [anon_sym_BANG_EQ] = ACTIONS(2804),
    [anon_sym_COLON_EQ] = ACTIONS(2806),
    [anon_sym_DOLLAR] = ACTIONS(2804),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2804),
    [sym_int] = ACTIONS(2804),
    [sym_xint] = ACTIONS(2806),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2806),
    [sym__newline] = ACTIONS(2806),
  },
  [1493] = {
    [sym_block_comment] = STATE(1493),
    [sym_compiler_directive_decl] = STATE(1493),
    [sym_fsi_directive_decl] = STATE(1493),
    [sym_preproc_line] = STATE(1493),
    [sym_identifier] = ACTIONS(2812),
    [anon_sym_EQ] = ACTIONS(2814),
    [anon_sym_COLON] = ACTIONS(2812),
    [anon_sym_return] = ACTIONS(2812),
    [anon_sym_do] = ACTIONS(2812),
    [anon_sym_let] = ACTIONS(2812),
    [anon_sym_let_BANG] = ACTIONS(2814),
    [anon_sym_LPAREN] = ACTIONS(2812),
    [anon_sym_COMMA] = ACTIONS(2814),
    [anon_sym_null] = ACTIONS(2812),
    [anon_sym_QMARK] = ACTIONS(2812),
    [anon_sym_COLON_QMARK] = ACTIONS(2812),
    [anon_sym_COLON_COLON] = ACTIONS(2814),
    [anon_sym_AMP] = ACTIONS(2812),
    [anon_sym_LBRACK] = ACTIONS(2812),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2814),
    [anon_sym_LBRACE] = ACTIONS(2812),
    [anon_sym_LT_AT] = ACTIONS(2812),
    [anon_sym_LT_AT_AT] = ACTIONS(2812),
    [anon_sym_DOT] = ACTIONS(2812),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2814),
    [anon_sym_new] = ACTIONS(2812),
    [anon_sym_return_BANG] = ACTIONS(2814),
    [anon_sym_yield] = ACTIONS(2812),
    [anon_sym_yield_BANG] = ACTIONS(2814),
    [anon_sym_lazy] = ACTIONS(2812),
    [anon_sym_assert] = ACTIONS(2812),
    [anon_sym_upcast] = ACTIONS(2812),
    [anon_sym_downcast] = ACTIONS(2812),
    [anon_sym_COLON_GT] = ACTIONS(2814),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2814),
    [anon_sym_for] = ACTIONS(2812),
    [anon_sym_while] = ACTIONS(2812),
    [anon_sym_if] = ACTIONS(2812),
    [anon_sym_fun] = ACTIONS(2812),
    [anon_sym_try] = ACTIONS(2812),
    [anon_sym_match] = ACTIONS(2812),
    [anon_sym_match_BANG] = ACTIONS(2814),
    [anon_sym_function] = ACTIONS(2812),
    [anon_sym_LT_DASH] = ACTIONS(2812),
    [anon_sym_DOT_LBRACK] = ACTIONS(2814),
    [anon_sym_LT] = ACTIONS(2814),
    [anon_sym_use] = ACTIONS(2812),
    [anon_sym_use_BANG] = ACTIONS(2814),
    [anon_sym_do_BANG] = ACTIONS(2814),
    [anon_sym_begin] = ACTIONS(2812),
    [anon_sym_LPAREN2] = ACTIONS(2812),
    [anon_sym_or] = ACTIONS(2812),
    [aux_sym_char_token1] = ACTIONS(2814),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2812),
    [anon_sym_DQUOTE] = ACTIONS(2812),
    [anon_sym_AT_DQUOTE] = ACTIONS(2814),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2814),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2814),
    [sym_bool] = ACTIONS(2812),
    [sym_unit] = ACTIONS(2814),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2812),
    [sym_op_identifier] = ACTIONS(2812),
    [anon_sym_PLUS] = ACTIONS(2812),
    [anon_sym_DASH] = ACTIONS(2812),
    [anon_sym_PLUS_DOT] = ACTIONS(2812),
    [anon_sym_DASH_DOT] = ACTIONS(2812),
    [anon_sym_PERCENT] = ACTIONS(2812),
    [anon_sym_AMP_AMP] = ACTIONS(2812),
    [anon_sym_TILDE] = ACTIONS(2814),
    [aux_sym_prefix_op_token1] = ACTIONS(2812),
    [aux_sym_infix_op_token1] = ACTIONS(2814),
    [aux_sym_infix_op_token2] = ACTIONS(2812),
    [anon_sym_PIPE_PIPE] = ACTIONS(2812),
    [anon_sym_BANG_EQ] = ACTIONS(2812),
    [anon_sym_COLON_EQ] = ACTIONS(2814),
    [anon_sym_DOLLAR] = ACTIONS(2812),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2812),
    [sym_int] = ACTIONS(2812),
    [sym_xint] = ACTIONS(2814),
    [anon_sym_f] = ACTIONS(2812),
    [aux_sym_decimal_token1] = ACTIONS(2812),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2814),
    [anon_sym_POUNDendif] = ACTIONS(2814),
    [sym__newline] = ACTIONS(2814),
  },
  [1494] = {
    [sym_block_comment] = STATE(1494),
    [sym_compiler_directive_decl] = STATE(1494),
    [sym_fsi_directive_decl] = STATE(1494),
    [sym_preproc_line] = STATE(1494),
    [sym_identifier] = ACTIONS(2819),
    [anon_sym_EQ] = ACTIONS(2821),
    [anon_sym_COLON] = ACTIONS(2819),
    [anon_sym_return] = ACTIONS(2819),
    [anon_sym_do] = ACTIONS(2819),
    [anon_sym_let] = ACTIONS(2819),
    [anon_sym_let_BANG] = ACTIONS(2821),
    [anon_sym_LPAREN] = ACTIONS(2819),
    [anon_sym_COMMA] = ACTIONS(2821),
    [anon_sym_null] = ACTIONS(2819),
    [anon_sym_QMARK] = ACTIONS(2819),
    [anon_sym_COLON_QMARK] = ACTIONS(2819),
    [anon_sym_COLON_COLON] = ACTIONS(2821),
    [anon_sym_AMP] = ACTIONS(2819),
    [anon_sym_LBRACK] = ACTIONS(2819),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2821),
    [anon_sym_LBRACE] = ACTIONS(2819),
    [anon_sym_LT_AT] = ACTIONS(2819),
    [anon_sym_LT_AT_AT] = ACTIONS(2819),
    [anon_sym_DOT] = ACTIONS(2819),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2821),
    [anon_sym_new] = ACTIONS(2819),
    [anon_sym_return_BANG] = ACTIONS(2821),
    [anon_sym_yield] = ACTIONS(2819),
    [anon_sym_yield_BANG] = ACTIONS(2821),
    [anon_sym_lazy] = ACTIONS(2819),
    [anon_sym_assert] = ACTIONS(2819),
    [anon_sym_upcast] = ACTIONS(2819),
    [anon_sym_downcast] = ACTIONS(2819),
    [anon_sym_COLON_GT] = ACTIONS(2821),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2821),
    [anon_sym_for] = ACTIONS(2819),
    [anon_sym_while] = ACTIONS(2819),
    [anon_sym_if] = ACTIONS(2819),
    [anon_sym_fun] = ACTIONS(2819),
    [anon_sym_try] = ACTIONS(2819),
    [anon_sym_match] = ACTIONS(2819),
    [anon_sym_match_BANG] = ACTIONS(2821),
    [anon_sym_function] = ACTIONS(2819),
    [anon_sym_LT_DASH] = ACTIONS(2819),
    [anon_sym_DOT_LBRACK] = ACTIONS(2821),
    [anon_sym_LT] = ACTIONS(2821),
    [anon_sym_use] = ACTIONS(2819),
    [anon_sym_use_BANG] = ACTIONS(2821),
    [anon_sym_do_BANG] = ACTIONS(2821),
    [anon_sym_DOT_DOT] = ACTIONS(2821),
    [anon_sym_begin] = ACTIONS(2819),
    [anon_sym_LPAREN2] = ACTIONS(2819),
    [anon_sym_or] = ACTIONS(2819),
    [aux_sym_char_token1] = ACTIONS(2821),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2819),
    [anon_sym_DQUOTE] = ACTIONS(2819),
    [anon_sym_AT_DQUOTE] = ACTIONS(2821),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2821),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2821),
    [sym_bool] = ACTIONS(2819),
    [sym_unit] = ACTIONS(2821),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2819),
    [sym_op_identifier] = ACTIONS(2819),
    [anon_sym_PLUS] = ACTIONS(2819),
    [anon_sym_DASH] = ACTIONS(2819),
    [anon_sym_PLUS_DOT] = ACTIONS(2819),
    [anon_sym_DASH_DOT] = ACTIONS(2819),
    [anon_sym_PERCENT] = ACTIONS(2819),
    [anon_sym_AMP_AMP] = ACTIONS(2819),
    [anon_sym_TILDE] = ACTIONS(2821),
    [aux_sym_prefix_op_token1] = ACTIONS(2819),
    [aux_sym_infix_op_token1] = ACTIONS(2821),
    [aux_sym_infix_op_token2] = ACTIONS(2819),
    [anon_sym_PIPE_PIPE] = ACTIONS(2819),
    [anon_sym_BANG_EQ] = ACTIONS(2819),
    [anon_sym_COLON_EQ] = ACTIONS(2821),
    [anon_sym_DOLLAR] = ACTIONS(2819),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2819),
    [sym_int] = ACTIONS(3730),
    [sym_xint] = ACTIONS(2821),
    [anon_sym_f] = ACTIONS(2819),
    [aux_sym_decimal_token1] = ACTIONS(2819),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2821),
    [sym__newline] = ACTIONS(2821),
  },
  [1495] = {
    [sym_block_comment] = STATE(1495),
    [sym_compiler_directive_decl] = STATE(1495),
    [sym_fsi_directive_decl] = STATE(1495),
    [sym_preproc_line] = STATE(1495),
    [sym_identifier] = ACTIONS(2748),
    [anon_sym_EQ] = ACTIONS(2750),
    [anon_sym_COLON] = ACTIONS(2748),
    [anon_sym_return] = ACTIONS(2748),
    [anon_sym_do] = ACTIONS(2748),
    [anon_sym_let] = ACTIONS(2748),
    [anon_sym_let_BANG] = ACTIONS(2750),
    [anon_sym_LPAREN] = ACTIONS(2748),
    [anon_sym_COMMA] = ACTIONS(2750),
    [anon_sym_null] = ACTIONS(2748),
    [anon_sym_QMARK] = ACTIONS(2748),
    [anon_sym_COLON_QMARK] = ACTIONS(2748),
    [anon_sym_COLON_COLON] = ACTIONS(2750),
    [anon_sym_AMP] = ACTIONS(2748),
    [anon_sym_LBRACK] = ACTIONS(2748),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2750),
    [anon_sym_LBRACE] = ACTIONS(2748),
    [anon_sym_LT_AT] = ACTIONS(2748),
    [anon_sym_LT_AT_AT] = ACTIONS(2748),
    [anon_sym_AT_AT_GT] = ACTIONS(2748),
    [anon_sym_DOT] = ACTIONS(2748),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2750),
    [anon_sym_new] = ACTIONS(2748),
    [anon_sym_return_BANG] = ACTIONS(2750),
    [anon_sym_yield] = ACTIONS(2748),
    [anon_sym_yield_BANG] = ACTIONS(2750),
    [anon_sym_lazy] = ACTIONS(2748),
    [anon_sym_assert] = ACTIONS(2748),
    [anon_sym_upcast] = ACTIONS(2748),
    [anon_sym_downcast] = ACTIONS(2748),
    [anon_sym_COLON_GT] = ACTIONS(2750),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2750),
    [anon_sym_for] = ACTIONS(2748),
    [anon_sym_while] = ACTIONS(2748),
    [anon_sym_else] = ACTIONS(2748),
    [anon_sym_elif] = ACTIONS(2748),
    [anon_sym_if] = ACTIONS(2748),
    [anon_sym_fun] = ACTIONS(2748),
    [anon_sym_try] = ACTIONS(2748),
    [anon_sym_match] = ACTIONS(2748),
    [anon_sym_match_BANG] = ACTIONS(2750),
    [anon_sym_function] = ACTIONS(2748),
    [anon_sym_LT_DASH] = ACTIONS(2748),
    [anon_sym_DOT_LBRACK] = ACTIONS(2750),
    [anon_sym_LT] = ACTIONS(2750),
    [anon_sym_use] = ACTIONS(2748),
    [anon_sym_use_BANG] = ACTIONS(2750),
    [anon_sym_do_BANG] = ACTIONS(2750),
    [anon_sym_begin] = ACTIONS(2748),
    [anon_sym_LPAREN2] = ACTIONS(2748),
    [anon_sym_or] = ACTIONS(2748),
    [aux_sym_char_token1] = ACTIONS(2750),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2748),
    [anon_sym_DQUOTE] = ACTIONS(2748),
    [anon_sym_AT_DQUOTE] = ACTIONS(2750),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2750),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2750),
    [sym_bool] = ACTIONS(2748),
    [sym_unit] = ACTIONS(2750),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2748),
    [sym_op_identifier] = ACTIONS(2748),
    [anon_sym_PLUS] = ACTIONS(2748),
    [anon_sym_DASH] = ACTIONS(2748),
    [anon_sym_PLUS_DOT] = ACTIONS(2748),
    [anon_sym_DASH_DOT] = ACTIONS(2748),
    [anon_sym_PERCENT] = ACTIONS(2748),
    [anon_sym_AMP_AMP] = ACTIONS(2748),
    [anon_sym_TILDE] = ACTIONS(2750),
    [aux_sym_prefix_op_token1] = ACTIONS(2748),
    [aux_sym_infix_op_token1] = ACTIONS(2750),
    [aux_sym_infix_op_token2] = ACTIONS(2748),
    [anon_sym_PIPE_PIPE] = ACTIONS(2748),
    [anon_sym_BANG_EQ] = ACTIONS(2748),
    [anon_sym_COLON_EQ] = ACTIONS(2750),
    [anon_sym_DOLLAR] = ACTIONS(2748),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2748),
    [sym_int] = ACTIONS(2748),
    [sym_xint] = ACTIONS(2750),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2750),
    [sym__newline] = ACTIONS(2750),
  },
  [1496] = {
    [sym_block_comment] = STATE(1496),
    [sym_compiler_directive_decl] = STATE(1496),
    [sym_fsi_directive_decl] = STATE(1496),
    [sym_preproc_line] = STATE(1496),
    [sym_identifier] = ACTIONS(2766),
    [anon_sym_EQ] = ACTIONS(2768),
    [anon_sym_COLON] = ACTIONS(2766),
    [anon_sym_return] = ACTIONS(2766),
    [anon_sym_do] = ACTIONS(2766),
    [anon_sym_let] = ACTIONS(2766),
    [anon_sym_let_BANG] = ACTIONS(2768),
    [anon_sym_LPAREN] = ACTIONS(2766),
    [anon_sym_COMMA] = ACTIONS(2768),
    [anon_sym_null] = ACTIONS(2766),
    [anon_sym_QMARK] = ACTIONS(2766),
    [anon_sym_COLON_QMARK] = ACTIONS(2766),
    [anon_sym_COLON_COLON] = ACTIONS(2768),
    [anon_sym_PIPE] = ACTIONS(2766),
    [anon_sym_AMP] = ACTIONS(2766),
    [anon_sym_LBRACK] = ACTIONS(2766),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2768),
    [anon_sym_LBRACE] = ACTIONS(2766),
    [anon_sym_LT_AT] = ACTIONS(2766),
    [anon_sym_LT_AT_AT] = ACTIONS(2766),
    [anon_sym_DOT] = ACTIONS(2766),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2768),
    [anon_sym_new] = ACTIONS(2766),
    [anon_sym_return_BANG] = ACTIONS(2768),
    [anon_sym_yield] = ACTIONS(2766),
    [anon_sym_yield_BANG] = ACTIONS(2768),
    [anon_sym_lazy] = ACTIONS(2766),
    [anon_sym_assert] = ACTIONS(2766),
    [anon_sym_upcast] = ACTIONS(2766),
    [anon_sym_downcast] = ACTIONS(2766),
    [anon_sym_COLON_GT] = ACTIONS(2768),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2768),
    [anon_sym_for] = ACTIONS(2766),
    [anon_sym_while] = ACTIONS(2766),
    [anon_sym_if] = ACTIONS(2766),
    [anon_sym_fun] = ACTIONS(2766),
    [anon_sym_try] = ACTIONS(2766),
    [anon_sym_match] = ACTIONS(2766),
    [anon_sym_match_BANG] = ACTIONS(2768),
    [anon_sym_function] = ACTIONS(2766),
    [anon_sym_LT_DASH] = ACTIONS(2766),
    [anon_sym_DOT_LBRACK] = ACTIONS(2768),
    [anon_sym_LT] = ACTIONS(2768),
    [anon_sym_use] = ACTIONS(2766),
    [anon_sym_use_BANG] = ACTIONS(2768),
    [anon_sym_do_BANG] = ACTIONS(2768),
    [anon_sym_begin] = ACTIONS(2766),
    [anon_sym_LPAREN2] = ACTIONS(2766),
    [anon_sym_or] = ACTIONS(2766),
    [aux_sym_char_token1] = ACTIONS(2768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2766),
    [anon_sym_DQUOTE] = ACTIONS(2766),
    [anon_sym_AT_DQUOTE] = ACTIONS(2768),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2768),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2768),
    [sym_bool] = ACTIONS(2766),
    [sym_unit] = ACTIONS(2768),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2766),
    [sym_op_identifier] = ACTIONS(2766),
    [anon_sym_PLUS] = ACTIONS(2766),
    [anon_sym_DASH] = ACTIONS(2766),
    [anon_sym_PLUS_DOT] = ACTIONS(2766),
    [anon_sym_DASH_DOT] = ACTIONS(2766),
    [anon_sym_PERCENT] = ACTIONS(2766),
    [anon_sym_AMP_AMP] = ACTIONS(2766),
    [anon_sym_TILDE] = ACTIONS(2768),
    [aux_sym_prefix_op_token1] = ACTIONS(2766),
    [aux_sym_infix_op_token1] = ACTIONS(2768),
    [aux_sym_infix_op_token2] = ACTIONS(2766),
    [anon_sym_PIPE_PIPE] = ACTIONS(2766),
    [anon_sym_BANG_EQ] = ACTIONS(2766),
    [anon_sym_COLON_EQ] = ACTIONS(2768),
    [anon_sym_DOLLAR] = ACTIONS(2766),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2766),
    [sym_int] = ACTIONS(2766),
    [sym_xint] = ACTIONS(2768),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2768),
    [anon_sym_POUNDendif] = ACTIONS(2768),
    [anon_sym_POUNDelse] = ACTIONS(2768),
    [sym__newline] = ACTIONS(2768),
  },
  [1497] = {
    [sym_block_comment] = STATE(1497),
    [sym_compiler_directive_decl] = STATE(1497),
    [sym_fsi_directive_decl] = STATE(1497),
    [sym_preproc_line] = STATE(1497),
    [aux_sym_rules_repeat1] = STATE(1517),
    [sym_identifier] = ACTIONS(2689),
    [anon_sym_EQ] = ACTIONS(2691),
    [anon_sym_COLON] = ACTIONS(2689),
    [anon_sym_return] = ACTIONS(2689),
    [anon_sym_do] = ACTIONS(2689),
    [anon_sym_let] = ACTIONS(2689),
    [anon_sym_let_BANG] = ACTIONS(2691),
    [anon_sym_LPAREN] = ACTIONS(2689),
    [anon_sym_COMMA] = ACTIONS(2691),
    [anon_sym_null] = ACTIONS(2689),
    [anon_sym_QMARK] = ACTIONS(2689),
    [anon_sym_COLON_QMARK] = ACTIONS(2689),
    [anon_sym_COLON_COLON] = ACTIONS(2691),
    [anon_sym_PIPE] = ACTIONS(3732),
    [anon_sym_AMP] = ACTIONS(2689),
    [anon_sym_LBRACK] = ACTIONS(2689),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2691),
    [anon_sym_LBRACE] = ACTIONS(2689),
    [anon_sym_LT_AT] = ACTIONS(2689),
    [anon_sym_LT_AT_AT] = ACTIONS(2689),
    [anon_sym_AT_AT_GT] = ACTIONS(2689),
    [anon_sym_DOT] = ACTIONS(2689),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2691),
    [anon_sym_new] = ACTIONS(2689),
    [anon_sym_return_BANG] = ACTIONS(2691),
    [anon_sym_yield] = ACTIONS(2689),
    [anon_sym_yield_BANG] = ACTIONS(2691),
    [anon_sym_lazy] = ACTIONS(2689),
    [anon_sym_assert] = ACTIONS(2689),
    [anon_sym_upcast] = ACTIONS(2689),
    [anon_sym_downcast] = ACTIONS(2689),
    [anon_sym_COLON_GT] = ACTIONS(2691),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2691),
    [anon_sym_for] = ACTIONS(2689),
    [anon_sym_while] = ACTIONS(2689),
    [anon_sym_if] = ACTIONS(2689),
    [anon_sym_fun] = ACTIONS(2689),
    [anon_sym_try] = ACTIONS(2689),
    [anon_sym_match] = ACTIONS(2689),
    [anon_sym_match_BANG] = ACTIONS(2691),
    [anon_sym_function] = ACTIONS(2689),
    [anon_sym_LT_DASH] = ACTIONS(2689),
    [anon_sym_DOT_LBRACK] = ACTIONS(2691),
    [anon_sym_LT] = ACTIONS(2691),
    [anon_sym_use] = ACTIONS(2689),
    [anon_sym_use_BANG] = ACTIONS(2691),
    [anon_sym_do_BANG] = ACTIONS(2691),
    [anon_sym_begin] = ACTIONS(2689),
    [anon_sym_LPAREN2] = ACTIONS(2689),
    [anon_sym_or] = ACTIONS(2689),
    [aux_sym_char_token1] = ACTIONS(2691),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2689),
    [anon_sym_DQUOTE] = ACTIONS(2689),
    [anon_sym_AT_DQUOTE] = ACTIONS(2691),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2691),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2691),
    [sym_bool] = ACTIONS(2689),
    [sym_unit] = ACTIONS(2691),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2689),
    [sym_op_identifier] = ACTIONS(2689),
    [anon_sym_PLUS] = ACTIONS(2689),
    [anon_sym_DASH] = ACTIONS(2689),
    [anon_sym_PLUS_DOT] = ACTIONS(2689),
    [anon_sym_DASH_DOT] = ACTIONS(2689),
    [anon_sym_PERCENT] = ACTIONS(2689),
    [anon_sym_AMP_AMP] = ACTIONS(2689),
    [anon_sym_TILDE] = ACTIONS(2691),
    [aux_sym_prefix_op_token1] = ACTIONS(2689),
    [aux_sym_infix_op_token1] = ACTIONS(2691),
    [aux_sym_infix_op_token2] = ACTIONS(2689),
    [anon_sym_PIPE_PIPE] = ACTIONS(2689),
    [anon_sym_BANG_EQ] = ACTIONS(2689),
    [anon_sym_COLON_EQ] = ACTIONS(2691),
    [anon_sym_DOLLAR] = ACTIONS(2689),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2689),
    [sym_int] = ACTIONS(2689),
    [sym_xint] = ACTIONS(2691),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2691),
    [sym__newline] = ACTIONS(3734),
  },
  [1498] = {
    [sym_block_comment] = STATE(1498),
    [sym_compiler_directive_decl] = STATE(1498),
    [sym_fsi_directive_decl] = STATE(1498),
    [sym_preproc_line] = STATE(1498),
    [sym_identifier] = ACTIONS(2713),
    [anon_sym_EQ] = ACTIONS(2715),
    [anon_sym_COLON] = ACTIONS(2713),
    [anon_sym_return] = ACTIONS(2713),
    [anon_sym_do] = ACTIONS(2713),
    [anon_sym_let] = ACTIONS(2713),
    [anon_sym_let_BANG] = ACTIONS(2715),
    [anon_sym_LPAREN] = ACTIONS(2713),
    [anon_sym_COMMA] = ACTIONS(2715),
    [anon_sym_null] = ACTIONS(2713),
    [anon_sym_QMARK] = ACTIONS(2713),
    [anon_sym_COLON_QMARK] = ACTIONS(2713),
    [anon_sym_COLON_COLON] = ACTIONS(2715),
    [anon_sym_PIPE] = ACTIONS(2713),
    [anon_sym_AMP] = ACTIONS(2713),
    [anon_sym_LBRACK] = ACTIONS(2713),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2715),
    [anon_sym_LBRACE] = ACTIONS(2713),
    [anon_sym_LT_AT] = ACTIONS(2713),
    [anon_sym_LT_AT_AT] = ACTIONS(2713),
    [anon_sym_DOT] = ACTIONS(2713),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2715),
    [anon_sym_new] = ACTIONS(2713),
    [anon_sym_return_BANG] = ACTIONS(2715),
    [anon_sym_yield] = ACTIONS(2713),
    [anon_sym_yield_BANG] = ACTIONS(2715),
    [anon_sym_lazy] = ACTIONS(2713),
    [anon_sym_assert] = ACTIONS(2713),
    [anon_sym_upcast] = ACTIONS(2713),
    [anon_sym_downcast] = ACTIONS(2713),
    [anon_sym_COLON_GT] = ACTIONS(2715),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2715),
    [anon_sym_for] = ACTIONS(2713),
    [anon_sym_while] = ACTIONS(2713),
    [anon_sym_if] = ACTIONS(2713),
    [anon_sym_fun] = ACTIONS(2713),
    [anon_sym_try] = ACTIONS(2713),
    [anon_sym_match] = ACTIONS(2713),
    [anon_sym_match_BANG] = ACTIONS(2715),
    [anon_sym_function] = ACTIONS(2713),
    [anon_sym_LT_DASH] = ACTIONS(2713),
    [anon_sym_DOT_LBRACK] = ACTIONS(2715),
    [anon_sym_LT] = ACTIONS(2715),
    [anon_sym_use] = ACTIONS(2713),
    [anon_sym_use_BANG] = ACTIONS(2715),
    [anon_sym_do_BANG] = ACTIONS(2715),
    [anon_sym_begin] = ACTIONS(2713),
    [anon_sym_LPAREN2] = ACTIONS(2713),
    [anon_sym_or] = ACTIONS(2713),
    [aux_sym_char_token1] = ACTIONS(2715),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2713),
    [anon_sym_DQUOTE] = ACTIONS(2713),
    [anon_sym_AT_DQUOTE] = ACTIONS(2715),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2715),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2715),
    [sym_bool] = ACTIONS(2713),
    [sym_unit] = ACTIONS(2715),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2713),
    [sym_op_identifier] = ACTIONS(2713),
    [anon_sym_PLUS] = ACTIONS(2713),
    [anon_sym_DASH] = ACTIONS(2713),
    [anon_sym_PLUS_DOT] = ACTIONS(2713),
    [anon_sym_DASH_DOT] = ACTIONS(2713),
    [anon_sym_PERCENT] = ACTIONS(2713),
    [anon_sym_AMP_AMP] = ACTIONS(2713),
    [anon_sym_TILDE] = ACTIONS(2715),
    [aux_sym_prefix_op_token1] = ACTIONS(2713),
    [aux_sym_infix_op_token1] = ACTIONS(2715),
    [aux_sym_infix_op_token2] = ACTIONS(2713),
    [anon_sym_PIPE_PIPE] = ACTIONS(2713),
    [anon_sym_BANG_EQ] = ACTIONS(2713),
    [anon_sym_COLON_EQ] = ACTIONS(2715),
    [anon_sym_DOLLAR] = ACTIONS(2713),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2713),
    [sym_int] = ACTIONS(2713),
    [sym_xint] = ACTIONS(2715),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2715),
    [anon_sym_POUNDendif] = ACTIONS(2715),
    [anon_sym_POUNDelse] = ACTIONS(2715),
    [sym__newline] = ACTIONS(2715),
  },
  [1499] = {
    [sym_block_comment] = STATE(1499),
    [sym_compiler_directive_decl] = STATE(1499),
    [sym_fsi_directive_decl] = STATE(1499),
    [sym_preproc_line] = STATE(1499),
    [sym_identifier] = ACTIONS(2783),
    [anon_sym_EQ] = ACTIONS(2785),
    [anon_sym_COLON] = ACTIONS(2783),
    [anon_sym_return] = ACTIONS(2783),
    [anon_sym_do] = ACTIONS(2783),
    [anon_sym_let] = ACTIONS(2783),
    [anon_sym_let_BANG] = ACTIONS(2785),
    [anon_sym_as] = ACTIONS(2783),
    [anon_sym_LPAREN] = ACTIONS(2783),
    [anon_sym_COMMA] = ACTIONS(2785),
    [anon_sym_null] = ACTIONS(2783),
    [anon_sym_QMARK] = ACTIONS(2783),
    [anon_sym_COLON_QMARK] = ACTIONS(2783),
    [anon_sym_COLON_COLON] = ACTIONS(2785),
    [anon_sym_AMP] = ACTIONS(2783),
    [anon_sym_LBRACK] = ACTIONS(2783),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2785),
    [anon_sym_LBRACE] = ACTIONS(2783),
    [anon_sym_LT_AT] = ACTIONS(2783),
    [anon_sym_LT_AT_AT] = ACTIONS(2783),
    [anon_sym_DOT] = ACTIONS(2783),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2785),
    [anon_sym_new] = ACTIONS(2783),
    [anon_sym_with] = ACTIONS(2783),
    [anon_sym_return_BANG] = ACTIONS(2785),
    [anon_sym_yield] = ACTIONS(2783),
    [anon_sym_yield_BANG] = ACTIONS(2785),
    [anon_sym_lazy] = ACTIONS(2783),
    [anon_sym_assert] = ACTIONS(2783),
    [anon_sym_upcast] = ACTIONS(2783),
    [anon_sym_downcast] = ACTIONS(2783),
    [anon_sym_COLON_GT] = ACTIONS(2785),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2785),
    [anon_sym_for] = ACTIONS(2783),
    [anon_sym_done] = ACTIONS(3527),
    [anon_sym_while] = ACTIONS(2783),
    [anon_sym_if] = ACTIONS(2783),
    [anon_sym_fun] = ACTIONS(2783),
    [anon_sym_try] = ACTIONS(2783),
    [anon_sym_match] = ACTIONS(2783),
    [anon_sym_match_BANG] = ACTIONS(2785),
    [anon_sym_function] = ACTIONS(2783),
    [anon_sym_LT_DASH] = ACTIONS(2783),
    [anon_sym_DOT_LBRACK] = ACTIONS(2785),
    [anon_sym_LT] = ACTIONS(2785),
    [anon_sym_use] = ACTIONS(2783),
    [anon_sym_use_BANG] = ACTIONS(2785),
    [anon_sym_do_BANG] = ACTIONS(2785),
    [anon_sym_begin] = ACTIONS(2783),
    [anon_sym_LPAREN2] = ACTIONS(2783),
    [anon_sym_or] = ACTIONS(2783),
    [aux_sym_char_token1] = ACTIONS(2785),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2783),
    [anon_sym_DQUOTE] = ACTIONS(2783),
    [anon_sym_AT_DQUOTE] = ACTIONS(2785),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2785),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2785),
    [sym_bool] = ACTIONS(2783),
    [sym_unit] = ACTIONS(2785),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2783),
    [sym_op_identifier] = ACTIONS(2783),
    [anon_sym_PLUS] = ACTIONS(2783),
    [anon_sym_DASH] = ACTIONS(2783),
    [anon_sym_PLUS_DOT] = ACTIONS(2783),
    [anon_sym_DASH_DOT] = ACTIONS(2783),
    [anon_sym_PERCENT] = ACTIONS(2783),
    [anon_sym_AMP_AMP] = ACTIONS(2783),
    [anon_sym_TILDE] = ACTIONS(2785),
    [aux_sym_prefix_op_token1] = ACTIONS(2783),
    [aux_sym_infix_op_token1] = ACTIONS(2785),
    [aux_sym_infix_op_token2] = ACTIONS(2783),
    [anon_sym_PIPE_PIPE] = ACTIONS(2783),
    [anon_sym_BANG_EQ] = ACTIONS(2783),
    [anon_sym_COLON_EQ] = ACTIONS(2785),
    [anon_sym_DOLLAR] = ACTIONS(2783),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2783),
    [sym_int] = ACTIONS(2783),
    [sym_xint] = ACTIONS(2785),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2785),
    [sym__newline] = ACTIONS(2785),
  },
  [1500] = {
    [sym_block_comment] = STATE(1500),
    [sym_compiler_directive_decl] = STATE(1500),
    [sym_fsi_directive_decl] = STATE(1500),
    [sym_preproc_line] = STATE(1500),
    [sym_identifier] = ACTIONS(2723),
    [anon_sym_EQ] = ACTIONS(2725),
    [anon_sym_COLON] = ACTIONS(2723),
    [anon_sym_return] = ACTIONS(2723),
    [anon_sym_do] = ACTIONS(2723),
    [anon_sym_let] = ACTIONS(2723),
    [anon_sym_let_BANG] = ACTIONS(2725),
    [anon_sym_LPAREN] = ACTIONS(2723),
    [anon_sym_COMMA] = ACTIONS(2725),
    [anon_sym_null] = ACTIONS(2723),
    [anon_sym_QMARK] = ACTIONS(2723),
    [anon_sym_COLON_QMARK] = ACTIONS(2723),
    [anon_sym_COLON_COLON] = ACTIONS(2725),
    [anon_sym_AMP] = ACTIONS(2723),
    [anon_sym_LBRACK] = ACTIONS(2723),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2725),
    [anon_sym_LBRACE] = ACTIONS(2723),
    [anon_sym_LT_AT] = ACTIONS(2723),
    [anon_sym_LT_AT_AT] = ACTIONS(2723),
    [anon_sym_DOT] = ACTIONS(2723),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2725),
    [anon_sym_new] = ACTIONS(2723),
    [anon_sym_return_BANG] = ACTIONS(2725),
    [anon_sym_yield] = ACTIONS(2723),
    [anon_sym_yield_BANG] = ACTIONS(2725),
    [anon_sym_lazy] = ACTIONS(2723),
    [anon_sym_assert] = ACTIONS(2723),
    [anon_sym_upcast] = ACTIONS(2723),
    [anon_sym_downcast] = ACTIONS(2723),
    [anon_sym_COLON_GT] = ACTIONS(2725),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2725),
    [anon_sym_for] = ACTIONS(2723),
    [anon_sym_while] = ACTIONS(2723),
    [anon_sym_if] = ACTIONS(2723),
    [anon_sym_fun] = ACTIONS(2723),
    [anon_sym_try] = ACTIONS(2723),
    [anon_sym_match] = ACTIONS(2723),
    [anon_sym_match_BANG] = ACTIONS(2725),
    [anon_sym_function] = ACTIONS(2723),
    [anon_sym_LT_DASH] = ACTIONS(2723),
    [anon_sym_DOT_LBRACK] = ACTIONS(2725),
    [anon_sym_LT] = ACTIONS(2725),
    [anon_sym_use] = ACTIONS(2723),
    [anon_sym_use_BANG] = ACTIONS(2725),
    [anon_sym_do_BANG] = ACTIONS(2725),
    [anon_sym_begin] = ACTIONS(2723),
    [anon_sym_LPAREN2] = ACTIONS(2723),
    [anon_sym_or] = ACTIONS(2723),
    [aux_sym_char_token1] = ACTIONS(2725),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2723),
    [anon_sym_DQUOTE] = ACTIONS(2723),
    [anon_sym_AT_DQUOTE] = ACTIONS(2725),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2725),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2725),
    [sym_bool] = ACTIONS(2723),
    [sym_unit] = ACTIONS(2725),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2723),
    [sym_op_identifier] = ACTIONS(2723),
    [anon_sym_PLUS] = ACTIONS(2723),
    [anon_sym_DASH] = ACTIONS(2723),
    [anon_sym_PLUS_DOT] = ACTIONS(2723),
    [anon_sym_DASH_DOT] = ACTIONS(2723),
    [anon_sym_PERCENT] = ACTIONS(2723),
    [anon_sym_AMP_AMP] = ACTIONS(2723),
    [anon_sym_TILDE] = ACTIONS(2725),
    [aux_sym_prefix_op_token1] = ACTIONS(2723),
    [aux_sym_infix_op_token1] = ACTIONS(2725),
    [aux_sym_infix_op_token2] = ACTIONS(2723),
    [anon_sym_PIPE_PIPE] = ACTIONS(2723),
    [anon_sym_BANG_EQ] = ACTIONS(2723),
    [anon_sym_COLON_EQ] = ACTIONS(2725),
    [anon_sym_DOLLAR] = ACTIONS(2723),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2723),
    [sym_int] = ACTIONS(2723),
    [sym_xint] = ACTIONS(2725),
    [anon_sym_f] = ACTIONS(2723),
    [aux_sym_decimal_token1] = ACTIONS(2723),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2725),
    [anon_sym_POUNDendif] = ACTIONS(2725),
    [sym__newline] = ACTIONS(2725),
  },
  [1501] = {
    [sym_block_comment] = STATE(1501),
    [sym_compiler_directive_decl] = STATE(1501),
    [sym_fsi_directive_decl] = STATE(1501),
    [sym_preproc_line] = STATE(1501),
    [aux_sym_rules_repeat1] = STATE(1485),
    [sym_identifier] = ACTIONS(2698),
    [anon_sym_EQ] = ACTIONS(2700),
    [anon_sym_COLON] = ACTIONS(2698),
    [anon_sym_return] = ACTIONS(2698),
    [anon_sym_do] = ACTIONS(2698),
    [anon_sym_let] = ACTIONS(2698),
    [anon_sym_let_BANG] = ACTIONS(2700),
    [anon_sym_LPAREN] = ACTIONS(2698),
    [anon_sym_COMMA] = ACTIONS(2700),
    [anon_sym_null] = ACTIONS(2698),
    [anon_sym_QMARK] = ACTIONS(2698),
    [anon_sym_COLON_QMARK] = ACTIONS(2698),
    [anon_sym_COLON_COLON] = ACTIONS(2700),
    [anon_sym_PIPE] = ACTIONS(3709),
    [anon_sym_AMP] = ACTIONS(2698),
    [anon_sym_LBRACK] = ACTIONS(2698),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2700),
    [anon_sym_LBRACE] = ACTIONS(2698),
    [anon_sym_LT_AT] = ACTIONS(2698),
    [anon_sym_AT_GT] = ACTIONS(2698),
    [anon_sym_LT_AT_AT] = ACTIONS(2698),
    [anon_sym_DOT] = ACTIONS(2698),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2700),
    [anon_sym_new] = ACTIONS(2698),
    [anon_sym_return_BANG] = ACTIONS(2700),
    [anon_sym_yield] = ACTIONS(2698),
    [anon_sym_yield_BANG] = ACTIONS(2700),
    [anon_sym_lazy] = ACTIONS(2698),
    [anon_sym_assert] = ACTIONS(2698),
    [anon_sym_upcast] = ACTIONS(2698),
    [anon_sym_downcast] = ACTIONS(2698),
    [anon_sym_COLON_GT] = ACTIONS(2700),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2700),
    [anon_sym_for] = ACTIONS(2698),
    [anon_sym_while] = ACTIONS(2698),
    [anon_sym_if] = ACTIONS(2698),
    [anon_sym_fun] = ACTIONS(2698),
    [anon_sym_try] = ACTIONS(2698),
    [anon_sym_match] = ACTIONS(2698),
    [anon_sym_match_BANG] = ACTIONS(2700),
    [anon_sym_function] = ACTIONS(2698),
    [anon_sym_LT_DASH] = ACTIONS(2698),
    [anon_sym_DOT_LBRACK] = ACTIONS(2700),
    [anon_sym_LT] = ACTIONS(2700),
    [anon_sym_use] = ACTIONS(2698),
    [anon_sym_use_BANG] = ACTIONS(2700),
    [anon_sym_do_BANG] = ACTIONS(2700),
    [anon_sym_begin] = ACTIONS(2698),
    [anon_sym_LPAREN2] = ACTIONS(2698),
    [anon_sym_or] = ACTIONS(2698),
    [aux_sym_char_token1] = ACTIONS(2700),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2698),
    [anon_sym_DQUOTE] = ACTIONS(2698),
    [anon_sym_AT_DQUOTE] = ACTIONS(2700),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2700),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2700),
    [sym_bool] = ACTIONS(2698),
    [sym_unit] = ACTIONS(2700),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2698),
    [sym_op_identifier] = ACTIONS(2698),
    [anon_sym_PLUS] = ACTIONS(2698),
    [anon_sym_DASH] = ACTIONS(2698),
    [anon_sym_PLUS_DOT] = ACTIONS(2698),
    [anon_sym_DASH_DOT] = ACTIONS(2698),
    [anon_sym_PERCENT] = ACTIONS(2698),
    [anon_sym_AMP_AMP] = ACTIONS(2698),
    [anon_sym_TILDE] = ACTIONS(2700),
    [aux_sym_prefix_op_token1] = ACTIONS(2698),
    [aux_sym_infix_op_token1] = ACTIONS(2700),
    [aux_sym_infix_op_token2] = ACTIONS(2698),
    [anon_sym_PIPE_PIPE] = ACTIONS(2698),
    [anon_sym_BANG_EQ] = ACTIONS(2698),
    [anon_sym_COLON_EQ] = ACTIONS(2700),
    [anon_sym_DOLLAR] = ACTIONS(2698),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2698),
    [sym_int] = ACTIONS(2698),
    [sym_xint] = ACTIONS(2700),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2700),
    [sym__newline] = ACTIONS(3737),
  },
  [1502] = {
    [sym_block_comment] = STATE(1502),
    [sym_compiler_directive_decl] = STATE(1502),
    [sym_fsi_directive_decl] = STATE(1502),
    [sym_preproc_line] = STATE(1502),
    [aux_sym_rules_repeat1] = STATE(1488),
    [sym_identifier] = ACTIONS(2698),
    [anon_sym_EQ] = ACTIONS(2700),
    [anon_sym_COLON] = ACTIONS(2698),
    [anon_sym_return] = ACTIONS(2698),
    [anon_sym_do] = ACTIONS(2698),
    [anon_sym_let] = ACTIONS(2698),
    [anon_sym_let_BANG] = ACTIONS(2700),
    [anon_sym_LPAREN] = ACTIONS(2698),
    [anon_sym_COMMA] = ACTIONS(2700),
    [anon_sym_null] = ACTIONS(2698),
    [anon_sym_QMARK] = ACTIONS(2698),
    [anon_sym_COLON_QMARK] = ACTIONS(2698),
    [anon_sym_COLON_COLON] = ACTIONS(2700),
    [anon_sym_PIPE] = ACTIONS(3709),
    [anon_sym_AMP] = ACTIONS(2698),
    [anon_sym_LBRACK] = ACTIONS(2698),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2700),
    [anon_sym_LBRACE] = ACTIONS(2698),
    [anon_sym_LT_AT] = ACTIONS(2698),
    [anon_sym_AT_GT] = ACTIONS(2698),
    [anon_sym_LT_AT_AT] = ACTIONS(2698),
    [anon_sym_DOT] = ACTIONS(2698),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2700),
    [anon_sym_new] = ACTIONS(2698),
    [anon_sym_return_BANG] = ACTIONS(2700),
    [anon_sym_yield] = ACTIONS(2698),
    [anon_sym_yield_BANG] = ACTIONS(2700),
    [anon_sym_lazy] = ACTIONS(2698),
    [anon_sym_assert] = ACTIONS(2698),
    [anon_sym_upcast] = ACTIONS(2698),
    [anon_sym_downcast] = ACTIONS(2698),
    [anon_sym_COLON_GT] = ACTIONS(2700),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2700),
    [anon_sym_for] = ACTIONS(2698),
    [anon_sym_while] = ACTIONS(2698),
    [anon_sym_if] = ACTIONS(2698),
    [anon_sym_fun] = ACTIONS(2698),
    [anon_sym_try] = ACTIONS(2698),
    [anon_sym_match] = ACTIONS(2698),
    [anon_sym_match_BANG] = ACTIONS(2700),
    [anon_sym_function] = ACTIONS(2698),
    [anon_sym_LT_DASH] = ACTIONS(2698),
    [anon_sym_DOT_LBRACK] = ACTIONS(2700),
    [anon_sym_LT] = ACTIONS(2700),
    [anon_sym_use] = ACTIONS(2698),
    [anon_sym_use_BANG] = ACTIONS(2700),
    [anon_sym_do_BANG] = ACTIONS(2700),
    [anon_sym_begin] = ACTIONS(2698),
    [anon_sym_LPAREN2] = ACTIONS(2698),
    [anon_sym_or] = ACTIONS(2698),
    [aux_sym_char_token1] = ACTIONS(2700),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2698),
    [anon_sym_DQUOTE] = ACTIONS(2698),
    [anon_sym_AT_DQUOTE] = ACTIONS(2700),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2700),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2700),
    [sym_bool] = ACTIONS(2698),
    [sym_unit] = ACTIONS(2700),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2698),
    [sym_op_identifier] = ACTIONS(2698),
    [anon_sym_PLUS] = ACTIONS(2698),
    [anon_sym_DASH] = ACTIONS(2698),
    [anon_sym_PLUS_DOT] = ACTIONS(2698),
    [anon_sym_DASH_DOT] = ACTIONS(2698),
    [anon_sym_PERCENT] = ACTIONS(2698),
    [anon_sym_AMP_AMP] = ACTIONS(2698),
    [anon_sym_TILDE] = ACTIONS(2700),
    [aux_sym_prefix_op_token1] = ACTIONS(2698),
    [aux_sym_infix_op_token1] = ACTIONS(2700),
    [aux_sym_infix_op_token2] = ACTIONS(2698),
    [anon_sym_PIPE_PIPE] = ACTIONS(2698),
    [anon_sym_BANG_EQ] = ACTIONS(2698),
    [anon_sym_COLON_EQ] = ACTIONS(2700),
    [anon_sym_DOLLAR] = ACTIONS(2698),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2698),
    [sym_int] = ACTIONS(2698),
    [sym_xint] = ACTIONS(2700),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2700),
    [sym__newline] = ACTIONS(3737),
  },
  [1503] = {
    [sym_block_comment] = STATE(1503),
    [sym_compiler_directive_decl] = STATE(1503),
    [sym_fsi_directive_decl] = STATE(1503),
    [sym_preproc_line] = STATE(1503),
    [sym_identifier] = ACTIONS(2783),
    [anon_sym_EQ] = ACTIONS(2785),
    [anon_sym_COLON] = ACTIONS(2783),
    [anon_sym_return] = ACTIONS(2783),
    [anon_sym_do] = ACTIONS(2783),
    [anon_sym_let] = ACTIONS(2783),
    [anon_sym_let_BANG] = ACTIONS(2785),
    [anon_sym_LPAREN] = ACTIONS(2783),
    [anon_sym_COMMA] = ACTIONS(2785),
    [anon_sym_null] = ACTIONS(2783),
    [anon_sym_QMARK] = ACTIONS(2783),
    [anon_sym_COLON_QMARK] = ACTIONS(2783),
    [anon_sym_COLON_COLON] = ACTIONS(2785),
    [anon_sym_AMP] = ACTIONS(2783),
    [anon_sym_LBRACK] = ACTIONS(2783),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2785),
    [anon_sym_LBRACE] = ACTIONS(2783),
    [anon_sym_LT_AT] = ACTIONS(2783),
    [anon_sym_LT_AT_AT] = ACTIONS(2783),
    [anon_sym_DOT] = ACTIONS(2783),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2785),
    [anon_sym_new] = ACTIONS(2783),
    [anon_sym_return_BANG] = ACTIONS(2785),
    [anon_sym_yield] = ACTIONS(2783),
    [anon_sym_yield_BANG] = ACTIONS(2785),
    [anon_sym_lazy] = ACTIONS(2783),
    [anon_sym_assert] = ACTIONS(2783),
    [anon_sym_upcast] = ACTIONS(2783),
    [anon_sym_downcast] = ACTIONS(2783),
    [anon_sym_COLON_GT] = ACTIONS(2785),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2785),
    [anon_sym_for] = ACTIONS(2783),
    [anon_sym_done] = ACTIONS(3740),
    [anon_sym_while] = ACTIONS(2783),
    [anon_sym_if] = ACTIONS(2783),
    [anon_sym_fun] = ACTIONS(2783),
    [anon_sym_DASH_GT] = ACTIONS(2783),
    [anon_sym_try] = ACTIONS(2783),
    [anon_sym_match] = ACTIONS(2783),
    [anon_sym_match_BANG] = ACTIONS(2785),
    [anon_sym_function] = ACTIONS(2783),
    [anon_sym_LT_DASH] = ACTIONS(2783),
    [anon_sym_DOT_LBRACK] = ACTIONS(2785),
    [anon_sym_LT] = ACTIONS(2785),
    [anon_sym_use] = ACTIONS(2783),
    [anon_sym_use_BANG] = ACTIONS(2785),
    [anon_sym_do_BANG] = ACTIONS(2785),
    [anon_sym_DOT_DOT] = ACTIONS(2785),
    [anon_sym_begin] = ACTIONS(2783),
    [anon_sym_LPAREN2] = ACTIONS(2783),
    [anon_sym_or] = ACTIONS(2783),
    [aux_sym_char_token1] = ACTIONS(2785),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2783),
    [anon_sym_DQUOTE] = ACTIONS(2783),
    [anon_sym_AT_DQUOTE] = ACTIONS(2785),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2785),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2785),
    [sym_bool] = ACTIONS(2783),
    [sym_unit] = ACTIONS(2785),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2783),
    [sym_op_identifier] = ACTIONS(2783),
    [anon_sym_PLUS] = ACTIONS(2783),
    [anon_sym_DASH] = ACTIONS(2783),
    [anon_sym_PLUS_DOT] = ACTIONS(2783),
    [anon_sym_DASH_DOT] = ACTIONS(2783),
    [anon_sym_PERCENT] = ACTIONS(2783),
    [anon_sym_AMP_AMP] = ACTIONS(2783),
    [anon_sym_TILDE] = ACTIONS(2785),
    [aux_sym_prefix_op_token1] = ACTIONS(2783),
    [aux_sym_infix_op_token1] = ACTIONS(2785),
    [aux_sym_infix_op_token2] = ACTIONS(2783),
    [anon_sym_PIPE_PIPE] = ACTIONS(2783),
    [anon_sym_BANG_EQ] = ACTIONS(2783),
    [anon_sym_COLON_EQ] = ACTIONS(2785),
    [anon_sym_DOLLAR] = ACTIONS(2783),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2783),
    [sym_int] = ACTIONS(2783),
    [sym_xint] = ACTIONS(2785),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2785),
    [sym__newline] = ACTIONS(2785),
  },
  [1504] = {
    [sym_block_comment] = STATE(1504),
    [sym_compiler_directive_decl] = STATE(1504),
    [sym_fsi_directive_decl] = STATE(1504),
    [sym_preproc_line] = STATE(1504),
    [aux_sym_sequential_expression_repeat1] = STATE(1504),
    [sym_identifier] = ACTIONS(2895),
    [anon_sym_EQ] = ACTIONS(2897),
    [anon_sym_COLON] = ACTIONS(2895),
    [anon_sym_return] = ACTIONS(2895),
    [anon_sym_do] = ACTIONS(2895),
    [anon_sym_let] = ACTIONS(2895),
    [anon_sym_let_BANG] = ACTIONS(2897),
    [anon_sym_LPAREN] = ACTIONS(2895),
    [anon_sym_COMMA] = ACTIONS(2897),
    [anon_sym_null] = ACTIONS(2895),
    [anon_sym_QMARK] = ACTIONS(2895),
    [anon_sym_COLON_QMARK] = ACTIONS(2895),
    [anon_sym_COLON_COLON] = ACTIONS(2897),
    [anon_sym_AMP] = ACTIONS(2895),
    [anon_sym_LBRACK] = ACTIONS(2895),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2897),
    [anon_sym_LBRACE] = ACTIONS(2895),
    [anon_sym_LT_AT] = ACTIONS(2895),
    [anon_sym_LT_AT_AT] = ACTIONS(2895),
    [anon_sym_DOT] = ACTIONS(2895),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2897),
    [anon_sym_new] = ACTIONS(2895),
    [anon_sym_with] = ACTIONS(2895),
    [anon_sym_return_BANG] = ACTIONS(2897),
    [anon_sym_yield] = ACTIONS(2895),
    [anon_sym_yield_BANG] = ACTIONS(2897),
    [anon_sym_lazy] = ACTIONS(2895),
    [anon_sym_assert] = ACTIONS(2895),
    [anon_sym_upcast] = ACTIONS(2895),
    [anon_sym_downcast] = ACTIONS(2895),
    [anon_sym_COLON_GT] = ACTIONS(2897),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2897),
    [anon_sym_for] = ACTIONS(2895),
    [anon_sym_while] = ACTIONS(2895),
    [anon_sym_if] = ACTIONS(2895),
    [anon_sym_fun] = ACTIONS(2895),
    [anon_sym_try] = ACTIONS(2895),
    [anon_sym_match] = ACTIONS(2895),
    [anon_sym_match_BANG] = ACTIONS(2897),
    [anon_sym_function] = ACTIONS(2895),
    [anon_sym_LT_DASH] = ACTIONS(2895),
    [anon_sym_DOT_LBRACK] = ACTIONS(2897),
    [anon_sym_LT] = ACTIONS(2897),
    [anon_sym_use] = ACTIONS(2895),
    [anon_sym_use_BANG] = ACTIONS(2897),
    [anon_sym_do_BANG] = ACTIONS(2897),
    [anon_sym_begin] = ACTIONS(2895),
    [anon_sym_LPAREN2] = ACTIONS(2895),
    [anon_sym_or] = ACTIONS(2895),
    [aux_sym_char_token1] = ACTIONS(2897),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2895),
    [anon_sym_DQUOTE] = ACTIONS(2895),
    [anon_sym_AT_DQUOTE] = ACTIONS(2897),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2897),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2897),
    [sym_bool] = ACTIONS(2895),
    [sym_unit] = ACTIONS(2897),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2895),
    [sym_op_identifier] = ACTIONS(2895),
    [anon_sym_PLUS] = ACTIONS(2895),
    [anon_sym_DASH] = ACTIONS(2895),
    [anon_sym_PLUS_DOT] = ACTIONS(2895),
    [anon_sym_DASH_DOT] = ACTIONS(2895),
    [anon_sym_PERCENT] = ACTIONS(2895),
    [anon_sym_AMP_AMP] = ACTIONS(2895),
    [anon_sym_TILDE] = ACTIONS(2897),
    [aux_sym_prefix_op_token1] = ACTIONS(2895),
    [aux_sym_infix_op_token1] = ACTIONS(2897),
    [aux_sym_infix_op_token2] = ACTIONS(2895),
    [anon_sym_PIPE_PIPE] = ACTIONS(2895),
    [anon_sym_BANG_EQ] = ACTIONS(2895),
    [anon_sym_COLON_EQ] = ACTIONS(2897),
    [anon_sym_DOLLAR] = ACTIONS(2895),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2895),
    [sym_int] = ACTIONS(2895),
    [sym_xint] = ACTIONS(2897),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2897),
    [sym__newline] = ACTIONS(3742),
    [sym__dedent] = ACTIONS(2897),
  },
  [1505] = {
    [sym_block_comment] = STATE(1505),
    [sym_compiler_directive_decl] = STATE(1505),
    [sym_fsi_directive_decl] = STATE(1505),
    [sym_preproc_line] = STATE(1505),
    [sym_identifier] = ACTIONS(2756),
    [anon_sym_EQ] = ACTIONS(2758),
    [anon_sym_COLON] = ACTIONS(2756),
    [anon_sym_return] = ACTIONS(2756),
    [anon_sym_do] = ACTIONS(2756),
    [anon_sym_let] = ACTIONS(2756),
    [anon_sym_let_BANG] = ACTIONS(2758),
    [anon_sym_LPAREN] = ACTIONS(2756),
    [anon_sym_COMMA] = ACTIONS(2758),
    [anon_sym_null] = ACTIONS(2756),
    [anon_sym_QMARK] = ACTIONS(2756),
    [anon_sym_COLON_QMARK] = ACTIONS(2756),
    [anon_sym_COLON_COLON] = ACTIONS(2758),
    [anon_sym_PIPE] = ACTIONS(2756),
    [anon_sym_AMP] = ACTIONS(2756),
    [anon_sym_LBRACK] = ACTIONS(2756),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2758),
    [anon_sym_LBRACE] = ACTIONS(2756),
    [anon_sym_LT_AT] = ACTIONS(2756),
    [anon_sym_LT_AT_AT] = ACTIONS(2756),
    [anon_sym_DOT] = ACTIONS(2756),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2758),
    [anon_sym_new] = ACTIONS(2756),
    [anon_sym_return_BANG] = ACTIONS(2758),
    [anon_sym_yield] = ACTIONS(2756),
    [anon_sym_yield_BANG] = ACTIONS(2758),
    [anon_sym_lazy] = ACTIONS(2756),
    [anon_sym_assert] = ACTIONS(2756),
    [anon_sym_upcast] = ACTIONS(2756),
    [anon_sym_downcast] = ACTIONS(2756),
    [anon_sym_COLON_GT] = ACTIONS(2758),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2758),
    [anon_sym_for] = ACTIONS(2756),
    [anon_sym_while] = ACTIONS(2756),
    [anon_sym_if] = ACTIONS(2756),
    [anon_sym_fun] = ACTIONS(2756),
    [anon_sym_try] = ACTIONS(2756),
    [anon_sym_match] = ACTIONS(2756),
    [anon_sym_match_BANG] = ACTIONS(2758),
    [anon_sym_function] = ACTIONS(2756),
    [anon_sym_LT_DASH] = ACTIONS(2756),
    [anon_sym_DOT_LBRACK] = ACTIONS(2758),
    [anon_sym_LT] = ACTIONS(2758),
    [anon_sym_use] = ACTIONS(2756),
    [anon_sym_use_BANG] = ACTIONS(2758),
    [anon_sym_do_BANG] = ACTIONS(2758),
    [anon_sym_begin] = ACTIONS(2756),
    [anon_sym_LPAREN2] = ACTIONS(2756),
    [anon_sym_or] = ACTIONS(2756),
    [aux_sym_char_token1] = ACTIONS(2758),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2756),
    [anon_sym_DQUOTE] = ACTIONS(2756),
    [anon_sym_AT_DQUOTE] = ACTIONS(2758),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2758),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2758),
    [sym_bool] = ACTIONS(2756),
    [sym_unit] = ACTIONS(2758),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2756),
    [sym_op_identifier] = ACTIONS(2756),
    [anon_sym_PLUS] = ACTIONS(2756),
    [anon_sym_DASH] = ACTIONS(2756),
    [anon_sym_PLUS_DOT] = ACTIONS(2756),
    [anon_sym_DASH_DOT] = ACTIONS(2756),
    [anon_sym_PERCENT] = ACTIONS(2756),
    [anon_sym_AMP_AMP] = ACTIONS(2756),
    [anon_sym_TILDE] = ACTIONS(2758),
    [aux_sym_prefix_op_token1] = ACTIONS(2756),
    [aux_sym_infix_op_token1] = ACTIONS(2758),
    [aux_sym_infix_op_token2] = ACTIONS(2756),
    [anon_sym_PIPE_PIPE] = ACTIONS(2756),
    [anon_sym_BANG_EQ] = ACTIONS(2756),
    [anon_sym_COLON_EQ] = ACTIONS(2758),
    [anon_sym_DOLLAR] = ACTIONS(2756),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2756),
    [sym_int] = ACTIONS(2756),
    [sym_xint] = ACTIONS(2758),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2758),
    [anon_sym_POUNDendif] = ACTIONS(2758),
    [anon_sym_POUNDelse] = ACTIONS(2758),
    [sym__newline] = ACTIONS(2758),
  },
  [1506] = {
    [sym_block_comment] = STATE(1506),
    [sym_compiler_directive_decl] = STATE(1506),
    [sym_fsi_directive_decl] = STATE(1506),
    [sym_preproc_line] = STATE(1506),
    [sym_identifier] = ACTIONS(2760),
    [anon_sym_EQ] = ACTIONS(2762),
    [anon_sym_COLON] = ACTIONS(2760),
    [anon_sym_return] = ACTIONS(2760),
    [anon_sym_do] = ACTIONS(2760),
    [anon_sym_let] = ACTIONS(2760),
    [anon_sym_let_BANG] = ACTIONS(2762),
    [anon_sym_LPAREN] = ACTIONS(2760),
    [anon_sym_COMMA] = ACTIONS(2762),
    [anon_sym_null] = ACTIONS(2760),
    [anon_sym_QMARK] = ACTIONS(2760),
    [anon_sym_COLON_QMARK] = ACTIONS(2760),
    [anon_sym_COLON_COLON] = ACTIONS(2762),
    [anon_sym_PIPE] = ACTIONS(2760),
    [anon_sym_AMP] = ACTIONS(2760),
    [anon_sym_LBRACK] = ACTIONS(2760),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2762),
    [anon_sym_LBRACE] = ACTIONS(2760),
    [anon_sym_LT_AT] = ACTIONS(2760),
    [anon_sym_LT_AT_AT] = ACTIONS(2760),
    [anon_sym_DOT] = ACTIONS(2760),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2762),
    [anon_sym_new] = ACTIONS(2760),
    [anon_sym_return_BANG] = ACTIONS(2762),
    [anon_sym_yield] = ACTIONS(2760),
    [anon_sym_yield_BANG] = ACTIONS(2762),
    [anon_sym_lazy] = ACTIONS(2760),
    [anon_sym_assert] = ACTIONS(2760),
    [anon_sym_upcast] = ACTIONS(2760),
    [anon_sym_downcast] = ACTIONS(2760),
    [anon_sym_COLON_GT] = ACTIONS(2762),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2762),
    [anon_sym_for] = ACTIONS(2760),
    [anon_sym_while] = ACTIONS(2760),
    [anon_sym_if] = ACTIONS(2760),
    [anon_sym_fun] = ACTIONS(2760),
    [anon_sym_try] = ACTIONS(2760),
    [anon_sym_match] = ACTIONS(2760),
    [anon_sym_match_BANG] = ACTIONS(2762),
    [anon_sym_function] = ACTIONS(2760),
    [anon_sym_LT_DASH] = ACTIONS(2760),
    [anon_sym_DOT_LBRACK] = ACTIONS(2762),
    [anon_sym_LT] = ACTIONS(2762),
    [anon_sym_use] = ACTIONS(2760),
    [anon_sym_use_BANG] = ACTIONS(2762),
    [anon_sym_do_BANG] = ACTIONS(2762),
    [anon_sym_begin] = ACTIONS(2760),
    [anon_sym_LPAREN2] = ACTIONS(2760),
    [anon_sym_or] = ACTIONS(2760),
    [aux_sym_char_token1] = ACTIONS(2762),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2760),
    [anon_sym_DQUOTE] = ACTIONS(2760),
    [anon_sym_AT_DQUOTE] = ACTIONS(2762),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2762),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2762),
    [sym_bool] = ACTIONS(2760),
    [sym_unit] = ACTIONS(2762),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2760),
    [sym_op_identifier] = ACTIONS(2760),
    [anon_sym_PLUS] = ACTIONS(2760),
    [anon_sym_DASH] = ACTIONS(2760),
    [anon_sym_PLUS_DOT] = ACTIONS(2760),
    [anon_sym_DASH_DOT] = ACTIONS(2760),
    [anon_sym_PERCENT] = ACTIONS(2760),
    [anon_sym_AMP_AMP] = ACTIONS(2760),
    [anon_sym_TILDE] = ACTIONS(2762),
    [aux_sym_prefix_op_token1] = ACTIONS(2760),
    [aux_sym_infix_op_token1] = ACTIONS(2762),
    [aux_sym_infix_op_token2] = ACTIONS(2760),
    [anon_sym_PIPE_PIPE] = ACTIONS(2760),
    [anon_sym_BANG_EQ] = ACTIONS(2760),
    [anon_sym_COLON_EQ] = ACTIONS(2762),
    [anon_sym_DOLLAR] = ACTIONS(2760),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2760),
    [sym_int] = ACTIONS(2760),
    [sym_xint] = ACTIONS(2762),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2762),
    [anon_sym_POUNDendif] = ACTIONS(2762),
    [anon_sym_POUNDelse] = ACTIONS(2762),
    [sym__newline] = ACTIONS(2762),
  },
  [1507] = {
    [sym_block_comment] = STATE(1507),
    [sym_compiler_directive_decl] = STATE(1507),
    [sym_fsi_directive_decl] = STATE(1507),
    [sym_preproc_line] = STATE(1507),
    [sym_identifier] = ACTIONS(2804),
    [anon_sym_EQ] = ACTIONS(2806),
    [anon_sym_COLON] = ACTIONS(2804),
    [anon_sym_return] = ACTIONS(2804),
    [anon_sym_do] = ACTIONS(2804),
    [anon_sym_let] = ACTIONS(2804),
    [anon_sym_let_BANG] = ACTIONS(2806),
    [anon_sym_LPAREN] = ACTIONS(2804),
    [anon_sym_COMMA] = ACTIONS(2806),
    [anon_sym_null] = ACTIONS(2804),
    [anon_sym_QMARK] = ACTIONS(2804),
    [anon_sym_COLON_QMARK] = ACTIONS(2804),
    [anon_sym_COLON_COLON] = ACTIONS(2806),
    [anon_sym_AMP] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2804),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(2804),
    [anon_sym_LT_AT] = ACTIONS(2804),
    [anon_sym_LT_AT_AT] = ACTIONS(2804),
    [anon_sym_DOT] = ACTIONS(2804),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2806),
    [anon_sym_new] = ACTIONS(2804),
    [anon_sym_return_BANG] = ACTIONS(2806),
    [anon_sym_yield] = ACTIONS(2804),
    [anon_sym_yield_BANG] = ACTIONS(2806),
    [anon_sym_lazy] = ACTIONS(2804),
    [anon_sym_assert] = ACTIONS(2804),
    [anon_sym_upcast] = ACTIONS(2804),
    [anon_sym_downcast] = ACTIONS(2804),
    [anon_sym_COLON_GT] = ACTIONS(2806),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2806),
    [anon_sym_for] = ACTIONS(2804),
    [anon_sym_done] = ACTIONS(3745),
    [anon_sym_while] = ACTIONS(2804),
    [anon_sym_if] = ACTIONS(2804),
    [anon_sym_fun] = ACTIONS(2804),
    [anon_sym_DASH_GT] = ACTIONS(2804),
    [anon_sym_try] = ACTIONS(2804),
    [anon_sym_match] = ACTIONS(2804),
    [anon_sym_match_BANG] = ACTIONS(2806),
    [anon_sym_function] = ACTIONS(2804),
    [anon_sym_LT_DASH] = ACTIONS(2804),
    [anon_sym_DOT_LBRACK] = ACTIONS(2806),
    [anon_sym_LT] = ACTIONS(2806),
    [anon_sym_use] = ACTIONS(2804),
    [anon_sym_use_BANG] = ACTIONS(2806),
    [anon_sym_do_BANG] = ACTIONS(2806),
    [anon_sym_DOT_DOT] = ACTIONS(2806),
    [anon_sym_begin] = ACTIONS(2804),
    [anon_sym_LPAREN2] = ACTIONS(2804),
    [anon_sym_or] = ACTIONS(2804),
    [aux_sym_char_token1] = ACTIONS(2806),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2804),
    [anon_sym_DQUOTE] = ACTIONS(2804),
    [anon_sym_AT_DQUOTE] = ACTIONS(2806),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2806),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2806),
    [sym_bool] = ACTIONS(2804),
    [sym_unit] = ACTIONS(2806),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2804),
    [sym_op_identifier] = ACTIONS(2804),
    [anon_sym_PLUS] = ACTIONS(2804),
    [anon_sym_DASH] = ACTIONS(2804),
    [anon_sym_PLUS_DOT] = ACTIONS(2804),
    [anon_sym_DASH_DOT] = ACTIONS(2804),
    [anon_sym_PERCENT] = ACTIONS(2804),
    [anon_sym_AMP_AMP] = ACTIONS(2804),
    [anon_sym_TILDE] = ACTIONS(2806),
    [aux_sym_prefix_op_token1] = ACTIONS(2804),
    [aux_sym_infix_op_token1] = ACTIONS(2806),
    [aux_sym_infix_op_token2] = ACTIONS(2804),
    [anon_sym_PIPE_PIPE] = ACTIONS(2804),
    [anon_sym_BANG_EQ] = ACTIONS(2804),
    [anon_sym_COLON_EQ] = ACTIONS(2806),
    [anon_sym_DOLLAR] = ACTIONS(2804),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2804),
    [sym_int] = ACTIONS(2804),
    [sym_xint] = ACTIONS(2806),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2806),
    [sym__newline] = ACTIONS(2806),
  },
  [1508] = {
    [sym_block_comment] = STATE(1508),
    [sym_compiler_directive_decl] = STATE(1508),
    [sym_fsi_directive_decl] = STATE(1508),
    [sym_preproc_line] = STATE(1508),
    [sym_identifier] = ACTIONS(2819),
    [anon_sym_EQ] = ACTIONS(2821),
    [anon_sym_COLON] = ACTIONS(2819),
    [anon_sym_return] = ACTIONS(2819),
    [anon_sym_do] = ACTIONS(2819),
    [anon_sym_let] = ACTIONS(2819),
    [anon_sym_let_BANG] = ACTIONS(2821),
    [anon_sym_LPAREN] = ACTIONS(2819),
    [anon_sym_COMMA] = ACTIONS(2821),
    [anon_sym_null] = ACTIONS(2819),
    [anon_sym_QMARK] = ACTIONS(2819),
    [anon_sym_COLON_QMARK] = ACTIONS(2819),
    [anon_sym_COLON_COLON] = ACTIONS(2821),
    [anon_sym_AMP] = ACTIONS(2819),
    [anon_sym_LBRACK] = ACTIONS(2819),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2821),
    [anon_sym_LBRACE] = ACTIONS(2819),
    [anon_sym_LT_AT] = ACTIONS(2819),
    [anon_sym_LT_AT_AT] = ACTIONS(2819),
    [anon_sym_DOT] = ACTIONS(2819),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2821),
    [anon_sym_new] = ACTIONS(2819),
    [anon_sym_return_BANG] = ACTIONS(2821),
    [anon_sym_yield] = ACTIONS(2819),
    [anon_sym_yield_BANG] = ACTIONS(2821),
    [anon_sym_lazy] = ACTIONS(2819),
    [anon_sym_assert] = ACTIONS(2819),
    [anon_sym_upcast] = ACTIONS(2819),
    [anon_sym_downcast] = ACTIONS(2819),
    [anon_sym_COLON_GT] = ACTIONS(2821),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2821),
    [anon_sym_for] = ACTIONS(2819),
    [anon_sym_while] = ACTIONS(2819),
    [anon_sym_if] = ACTIONS(2819),
    [anon_sym_fun] = ACTIONS(2819),
    [anon_sym_try] = ACTIONS(2819),
    [anon_sym_match] = ACTIONS(2819),
    [anon_sym_match_BANG] = ACTIONS(2821),
    [anon_sym_function] = ACTIONS(2819),
    [anon_sym_LT_DASH] = ACTIONS(2819),
    [anon_sym_DOT_LBRACK] = ACTIONS(2821),
    [anon_sym_LT] = ACTIONS(2821),
    [anon_sym_use] = ACTIONS(2819),
    [anon_sym_use_BANG] = ACTIONS(2821),
    [anon_sym_do_BANG] = ACTIONS(2821),
    [anon_sym_begin] = ACTIONS(2819),
    [anon_sym_LPAREN2] = ACTIONS(2819),
    [anon_sym_or] = ACTIONS(2819),
    [aux_sym_char_token1] = ACTIONS(2821),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2819),
    [anon_sym_DQUOTE] = ACTIONS(2819),
    [anon_sym_AT_DQUOTE] = ACTIONS(2821),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2821),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2821),
    [sym_bool] = ACTIONS(2819),
    [sym_unit] = ACTIONS(2821),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2819),
    [sym_op_identifier] = ACTIONS(2819),
    [anon_sym_PLUS] = ACTIONS(2819),
    [anon_sym_DASH] = ACTIONS(2819),
    [anon_sym_PLUS_DOT] = ACTIONS(2819),
    [anon_sym_DASH_DOT] = ACTIONS(2819),
    [anon_sym_PERCENT] = ACTIONS(2819),
    [anon_sym_AMP_AMP] = ACTIONS(2819),
    [anon_sym_TILDE] = ACTIONS(2821),
    [aux_sym_prefix_op_token1] = ACTIONS(2819),
    [aux_sym_infix_op_token1] = ACTIONS(2821),
    [aux_sym_infix_op_token2] = ACTIONS(2819),
    [anon_sym_PIPE_PIPE] = ACTIONS(2819),
    [anon_sym_BANG_EQ] = ACTIONS(2819),
    [anon_sym_COLON_EQ] = ACTIONS(2821),
    [anon_sym_DOLLAR] = ACTIONS(2819),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2819),
    [sym_int] = ACTIONS(3747),
    [sym_xint] = ACTIONS(2821),
    [anon_sym_f] = ACTIONS(2819),
    [aux_sym_decimal_token1] = ACTIONS(2819),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2821),
    [anon_sym_POUNDendif] = ACTIONS(2821),
    [sym__newline] = ACTIONS(2821),
  },
  [1509] = {
    [sym_block_comment] = STATE(1509),
    [sym_compiler_directive_decl] = STATE(1509),
    [sym_fsi_directive_decl] = STATE(1509),
    [sym_preproc_line] = STATE(1509),
    [aux_sym_rules_repeat1] = STATE(1509),
    [sym_identifier] = ACTIONS(2713),
    [anon_sym_EQ] = ACTIONS(2715),
    [anon_sym_COLON] = ACTIONS(2713),
    [anon_sym_return] = ACTIONS(2713),
    [anon_sym_do] = ACTIONS(2713),
    [anon_sym_let] = ACTIONS(2713),
    [anon_sym_let_BANG] = ACTIONS(2715),
    [anon_sym_LPAREN] = ACTIONS(2713),
    [anon_sym_COMMA] = ACTIONS(2715),
    [anon_sym_null] = ACTIONS(2713),
    [anon_sym_QMARK] = ACTIONS(2713),
    [anon_sym_COLON_QMARK] = ACTIONS(2713),
    [anon_sym_COLON_COLON] = ACTIONS(2715),
    [anon_sym_PIPE] = ACTIONS(3749),
    [anon_sym_AMP] = ACTIONS(2713),
    [anon_sym_LBRACK] = ACTIONS(2713),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2715),
    [anon_sym_LBRACE] = ACTIONS(2713),
    [anon_sym_LT_AT] = ACTIONS(2713),
    [anon_sym_LT_AT_AT] = ACTIONS(2713),
    [anon_sym_DOT] = ACTIONS(2713),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2715),
    [anon_sym_new] = ACTIONS(2713),
    [anon_sym_return_BANG] = ACTIONS(2715),
    [anon_sym_yield] = ACTIONS(2713),
    [anon_sym_yield_BANG] = ACTIONS(2715),
    [anon_sym_lazy] = ACTIONS(2713),
    [anon_sym_assert] = ACTIONS(2713),
    [anon_sym_upcast] = ACTIONS(2713),
    [anon_sym_downcast] = ACTIONS(2713),
    [anon_sym_COLON_GT] = ACTIONS(2715),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2715),
    [anon_sym_for] = ACTIONS(2713),
    [anon_sym_while] = ACTIONS(2713),
    [anon_sym_if] = ACTIONS(2713),
    [anon_sym_fun] = ACTIONS(2713),
    [anon_sym_try] = ACTIONS(2713),
    [anon_sym_match] = ACTIONS(2713),
    [anon_sym_match_BANG] = ACTIONS(2715),
    [anon_sym_function] = ACTIONS(2713),
    [anon_sym_LT_DASH] = ACTIONS(2713),
    [anon_sym_DOT_LBRACK] = ACTIONS(2715),
    [anon_sym_LT] = ACTIONS(2715),
    [anon_sym_GT] = ACTIONS(2713),
    [anon_sym_use] = ACTIONS(2713),
    [anon_sym_use_BANG] = ACTIONS(2715),
    [anon_sym_do_BANG] = ACTIONS(2715),
    [anon_sym_begin] = ACTIONS(2713),
    [anon_sym_LPAREN2] = ACTIONS(2713),
    [anon_sym_or] = ACTIONS(2713),
    [aux_sym_char_token1] = ACTIONS(2715),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2713),
    [anon_sym_DQUOTE] = ACTIONS(2713),
    [anon_sym_AT_DQUOTE] = ACTIONS(2715),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2715),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2715),
    [sym_bool] = ACTIONS(2713),
    [sym_unit] = ACTIONS(2715),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2713),
    [sym_op_identifier] = ACTIONS(2713),
    [anon_sym_PLUS] = ACTIONS(2713),
    [anon_sym_DASH] = ACTIONS(2713),
    [anon_sym_PLUS_DOT] = ACTIONS(2713),
    [anon_sym_DASH_DOT] = ACTIONS(2713),
    [anon_sym_PERCENT] = ACTIONS(2713),
    [anon_sym_AMP_AMP] = ACTIONS(2713),
    [anon_sym_TILDE] = ACTIONS(2715),
    [aux_sym_prefix_op_token1] = ACTIONS(2713),
    [aux_sym_infix_op_token1] = ACTIONS(2715),
    [aux_sym_infix_op_token2] = ACTIONS(2713),
    [anon_sym_PIPE_PIPE] = ACTIONS(2713),
    [anon_sym_BANG_EQ] = ACTIONS(2713),
    [anon_sym_COLON_EQ] = ACTIONS(2715),
    [anon_sym_DOLLAR] = ACTIONS(2713),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2713),
    [sym_int] = ACTIONS(2713),
    [sym_xint] = ACTIONS(2715),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2715),
    [sym__newline] = ACTIONS(3752),
  },
  [1510] = {
    [sym_block_comment] = STATE(1510),
    [sym_compiler_directive_decl] = STATE(1510),
    [sym_fsi_directive_decl] = STATE(1510),
    [sym_preproc_line] = STATE(1510),
    [aux_sym_long_identifier_repeat1] = STATE(1618),
    [sym_identifier] = ACTIONS(2791),
    [anon_sym_EQ] = ACTIONS(2791),
    [anon_sym_COLON] = ACTIONS(2791),
    [anon_sym_return] = ACTIONS(2791),
    [anon_sym_do] = ACTIONS(2791),
    [anon_sym_let] = ACTIONS(2791),
    [anon_sym_let_BANG] = ACTIONS(2794),
    [anon_sym_LPAREN] = ACTIONS(2791),
    [anon_sym_COMMA] = ACTIONS(2794),
    [anon_sym_null] = ACTIONS(2791),
    [anon_sym_QMARK] = ACTIONS(2791),
    [anon_sym_COLON_QMARK] = ACTIONS(2791),
    [anon_sym_COLON_COLON] = ACTIONS(2794),
    [anon_sym_AMP] = ACTIONS(2791),
    [anon_sym_LBRACK] = ACTIONS(2791),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2794),
    [anon_sym_LBRACE] = ACTIONS(2791),
    [anon_sym_LT_AT] = ACTIONS(2791),
    [anon_sym_LT_AT_AT] = ACTIONS(2791),
    [anon_sym_DOT] = ACTIONS(3755),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2794),
    [anon_sym_new] = ACTIONS(2791),
    [anon_sym_with] = ACTIONS(2791),
    [anon_sym_return_BANG] = ACTIONS(2794),
    [anon_sym_yield] = ACTIONS(2791),
    [anon_sym_yield_BANG] = ACTIONS(2794),
    [anon_sym_lazy] = ACTIONS(2791),
    [anon_sym_assert] = ACTIONS(2791),
    [anon_sym_upcast] = ACTIONS(2791),
    [anon_sym_downcast] = ACTIONS(2791),
    [anon_sym_COLON_GT] = ACTIONS(2794),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2794),
    [anon_sym_for] = ACTIONS(2791),
    [anon_sym_while] = ACTIONS(2791),
    [anon_sym_if] = ACTIONS(2791),
    [anon_sym_fun] = ACTIONS(2791),
    [anon_sym_try] = ACTIONS(2791),
    [anon_sym_match] = ACTIONS(2791),
    [anon_sym_match_BANG] = ACTIONS(2794),
    [anon_sym_function] = ACTIONS(2791),
    [anon_sym_LT_DASH] = ACTIONS(2791),
    [anon_sym_DOT_LBRACK] = ACTIONS(2794),
    [anon_sym_LT] = ACTIONS(2794),
    [anon_sym_use] = ACTIONS(2791),
    [anon_sym_use_BANG] = ACTIONS(2794),
    [anon_sym_do_BANG] = ACTIONS(2794),
    [anon_sym_begin] = ACTIONS(2791),
    [anon_sym_LPAREN2] = ACTIONS(2791),
    [anon_sym_or] = ACTIONS(2791),
    [anon_sym_EQ2] = ACTIONS(2314),
    [aux_sym_char_token1] = ACTIONS(2794),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2791),
    [anon_sym_DQUOTE] = ACTIONS(2791),
    [anon_sym_AT_DQUOTE] = ACTIONS(2794),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2794),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2794),
    [sym_bool] = ACTIONS(2791),
    [sym_unit] = ACTIONS(2794),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2791),
    [sym_op_identifier] = ACTIONS(2791),
    [anon_sym_PLUS] = ACTIONS(2791),
    [anon_sym_DASH] = ACTIONS(2791),
    [anon_sym_PLUS_DOT] = ACTIONS(2791),
    [anon_sym_DASH_DOT] = ACTIONS(2791),
    [anon_sym_PERCENT] = ACTIONS(2791),
    [anon_sym_AMP_AMP] = ACTIONS(2791),
    [anon_sym_TILDE] = ACTIONS(2794),
    [aux_sym_prefix_op_token1] = ACTIONS(2791),
    [aux_sym_infix_op_token1] = ACTIONS(2794),
    [aux_sym_infix_op_token2] = ACTIONS(2791),
    [anon_sym_PIPE_PIPE] = ACTIONS(2791),
    [anon_sym_BANG_EQ] = ACTIONS(2791),
    [anon_sym_COLON_EQ] = ACTIONS(2794),
    [anon_sym_DOLLAR] = ACTIONS(2791),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2791),
    [sym_int] = ACTIONS(2791),
    [sym_xint] = ACTIONS(2794),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2794),
    [sym__newline] = ACTIONS(2794),
  },
  [1511] = {
    [sym_block_comment] = STATE(1511),
    [sym_compiler_directive_decl] = STATE(1511),
    [sym_fsi_directive_decl] = STATE(1511),
    [sym_preproc_line] = STATE(1511),
    [sym_identifier] = ACTIONS(2158),
    [anon_sym_EQ] = ACTIONS(2160),
    [anon_sym_COLON] = ACTIONS(2158),
    [anon_sym_return] = ACTIONS(2158),
    [anon_sym_do] = ACTIONS(2158),
    [anon_sym_let] = ACTIONS(2158),
    [anon_sym_let_BANG] = ACTIONS(2160),
    [anon_sym_LPAREN] = ACTIONS(2158),
    [anon_sym_COMMA] = ACTIONS(2160),
    [anon_sym_null] = ACTIONS(2158),
    [anon_sym_QMARK] = ACTIONS(2158),
    [anon_sym_COLON_QMARK] = ACTIONS(2158),
    [anon_sym_COLON_COLON] = ACTIONS(2160),
    [anon_sym_AMP] = ACTIONS(2158),
    [anon_sym_LBRACK] = ACTIONS(2158),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2160),
    [anon_sym_LBRACE] = ACTIONS(2158),
    [anon_sym_LT_AT] = ACTIONS(2158),
    [anon_sym_LT_AT_AT] = ACTIONS(2158),
    [anon_sym_DOT] = ACTIONS(2158),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2160),
    [anon_sym_new] = ACTIONS(2158),
    [anon_sym_return_BANG] = ACTIONS(2160),
    [anon_sym_yield] = ACTIONS(2158),
    [anon_sym_yield_BANG] = ACTIONS(2160),
    [anon_sym_lazy] = ACTIONS(2158),
    [anon_sym_assert] = ACTIONS(2158),
    [anon_sym_upcast] = ACTIONS(2158),
    [anon_sym_downcast] = ACTIONS(2158),
    [anon_sym_COLON_GT] = ACTIONS(2160),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2160),
    [anon_sym_for] = ACTIONS(2158),
    [anon_sym_while] = ACTIONS(2158),
    [anon_sym_if] = ACTIONS(2158),
    [anon_sym_fun] = ACTIONS(2158),
    [anon_sym_try] = ACTIONS(2158),
    [anon_sym_match] = ACTIONS(2158),
    [anon_sym_match_BANG] = ACTIONS(2160),
    [anon_sym_function] = ACTIONS(2158),
    [anon_sym_LT_DASH] = ACTIONS(2158),
    [anon_sym_DOT_LBRACK] = ACTIONS(2160),
    [anon_sym_LT] = ACTIONS(2160),
    [anon_sym_use] = ACTIONS(2158),
    [anon_sym_use_BANG] = ACTIONS(2160),
    [anon_sym_do_BANG] = ACTIONS(2160),
    [anon_sym_begin] = ACTIONS(2158),
    [anon_sym_LPAREN2] = ACTIONS(2158),
    [anon_sym_or] = ACTIONS(2158),
    [aux_sym_char_token1] = ACTIONS(2160),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2158),
    [anon_sym_DQUOTE] = ACTIONS(2158),
    [anon_sym_AT_DQUOTE] = ACTIONS(2160),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2160),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2160),
    [sym_bool] = ACTIONS(2158),
    [sym_unit] = ACTIONS(2160),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2158),
    [sym_op_identifier] = ACTIONS(2158),
    [anon_sym_PLUS] = ACTIONS(2158),
    [anon_sym_DASH] = ACTIONS(2158),
    [anon_sym_PLUS_DOT] = ACTIONS(2158),
    [anon_sym_DASH_DOT] = ACTIONS(2158),
    [anon_sym_PERCENT] = ACTIONS(2158),
    [anon_sym_AMP_AMP] = ACTIONS(2158),
    [anon_sym_TILDE] = ACTIONS(2160),
    [aux_sym_prefix_op_token1] = ACTIONS(2158),
    [aux_sym_infix_op_token1] = ACTIONS(2160),
    [aux_sym_infix_op_token2] = ACTIONS(2158),
    [anon_sym_PIPE_PIPE] = ACTIONS(2158),
    [anon_sym_BANG_EQ] = ACTIONS(2158),
    [anon_sym_COLON_EQ] = ACTIONS(2160),
    [anon_sym_DOLLAR] = ACTIONS(2158),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2158),
    [sym_int] = ACTIONS(2158),
    [sym_xint] = ACTIONS(2160),
    [anon_sym_f] = ACTIONS(2752),
    [aux_sym_decimal_token1] = ACTIONS(2621),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2160),
    [anon_sym_POUNDendif] = ACTIONS(2160),
    [sym__newline] = ACTIONS(2160),
  },
  [1512] = {
    [sym_block_comment] = STATE(1512),
    [sym_compiler_directive_decl] = STATE(1512),
    [sym_fsi_directive_decl] = STATE(1512),
    [sym_preproc_line] = STATE(1512),
    [sym_identifier] = ACTIONS(2411),
    [anon_sym_EQ] = ACTIONS(2411),
    [anon_sym_COLON] = ACTIONS(2411),
    [anon_sym_return] = ACTIONS(2411),
    [anon_sym_do] = ACTIONS(2411),
    [anon_sym_let] = ACTIONS(2411),
    [anon_sym_let_BANG] = ACTIONS(2413),
    [anon_sym_LPAREN] = ACTIONS(2411),
    [anon_sym_COMMA] = ACTIONS(2413),
    [anon_sym_null] = ACTIONS(2411),
    [anon_sym_QMARK] = ACTIONS(2411),
    [anon_sym_COLON_QMARK] = ACTIONS(2411),
    [anon_sym_COLON_COLON] = ACTIONS(2413),
    [anon_sym_AMP] = ACTIONS(2411),
    [anon_sym_LBRACK] = ACTIONS(2411),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2413),
    [anon_sym_LBRACE] = ACTIONS(2411),
    [anon_sym_LT_AT] = ACTIONS(2411),
    [anon_sym_LT_AT_AT] = ACTIONS(2411),
    [anon_sym_DOT] = ACTIONS(2411),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2413),
    [anon_sym_new] = ACTIONS(2411),
    [anon_sym_with] = ACTIONS(2411),
    [anon_sym_return_BANG] = ACTIONS(2413),
    [anon_sym_yield] = ACTIONS(2411),
    [anon_sym_yield_BANG] = ACTIONS(2413),
    [anon_sym_lazy] = ACTIONS(2411),
    [anon_sym_assert] = ACTIONS(2411),
    [anon_sym_upcast] = ACTIONS(2411),
    [anon_sym_downcast] = ACTIONS(2411),
    [anon_sym_COLON_GT] = ACTIONS(2413),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2413),
    [anon_sym_for] = ACTIONS(2411),
    [anon_sym_while] = ACTIONS(2411),
    [anon_sym_if] = ACTIONS(2411),
    [anon_sym_fun] = ACTIONS(2411),
    [anon_sym_try] = ACTIONS(2411),
    [anon_sym_match] = ACTIONS(2411),
    [anon_sym_match_BANG] = ACTIONS(2413),
    [anon_sym_function] = ACTIONS(2411),
    [anon_sym_LT_DASH] = ACTIONS(2411),
    [anon_sym_DOT_LBRACK] = ACTIONS(2413),
    [anon_sym_LT] = ACTIONS(2413),
    [anon_sym_use] = ACTIONS(2411),
    [anon_sym_use_BANG] = ACTIONS(2413),
    [anon_sym_do_BANG] = ACTIONS(2413),
    [anon_sym_begin] = ACTIONS(2411),
    [anon_sym_LPAREN2] = ACTIONS(2411),
    [anon_sym_or] = ACTIONS(2411),
    [anon_sym_EQ2] = ACTIONS(2413),
    [aux_sym_char_token1] = ACTIONS(2413),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2411),
    [anon_sym_DQUOTE] = ACTIONS(2411),
    [anon_sym_AT_DQUOTE] = ACTIONS(2413),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2413),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2413),
    [sym_bool] = ACTIONS(2411),
    [sym_unit] = ACTIONS(2413),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2411),
    [sym_op_identifier] = ACTIONS(2411),
    [anon_sym_PLUS] = ACTIONS(2411),
    [anon_sym_DASH] = ACTIONS(2411),
    [anon_sym_PLUS_DOT] = ACTIONS(2411),
    [anon_sym_DASH_DOT] = ACTIONS(2411),
    [anon_sym_PERCENT] = ACTIONS(2411),
    [anon_sym_AMP_AMP] = ACTIONS(2411),
    [anon_sym_TILDE] = ACTIONS(2413),
    [aux_sym_prefix_op_token1] = ACTIONS(2411),
    [aux_sym_infix_op_token1] = ACTIONS(2413),
    [aux_sym_infix_op_token2] = ACTIONS(2411),
    [anon_sym_PIPE_PIPE] = ACTIONS(2411),
    [anon_sym_BANG_EQ] = ACTIONS(2411),
    [anon_sym_COLON_EQ] = ACTIONS(2413),
    [anon_sym_DOLLAR] = ACTIONS(2411),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2411),
    [sym_int] = ACTIONS(2411),
    [sym_xint] = ACTIONS(2413),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2413),
    [sym__newline] = ACTIONS(2413),
    [sym__dedent] = ACTIONS(2413),
  },
  [1513] = {
    [sym_block_comment] = STATE(1513),
    [sym_compiler_directive_decl] = STATE(1513),
    [sym_fsi_directive_decl] = STATE(1513),
    [sym_preproc_line] = STATE(1513),
    [aux_sym_rules_repeat1] = STATE(1509),
    [sym_identifier] = ACTIONS(2737),
    [anon_sym_EQ] = ACTIONS(2739),
    [anon_sym_COLON] = ACTIONS(2737),
    [anon_sym_return] = ACTIONS(2737),
    [anon_sym_do] = ACTIONS(2737),
    [anon_sym_let] = ACTIONS(2737),
    [anon_sym_let_BANG] = ACTIONS(2739),
    [anon_sym_LPAREN] = ACTIONS(2737),
    [anon_sym_COMMA] = ACTIONS(2739),
    [anon_sym_null] = ACTIONS(2737),
    [anon_sym_QMARK] = ACTIONS(2737),
    [anon_sym_COLON_QMARK] = ACTIONS(2737),
    [anon_sym_COLON_COLON] = ACTIONS(2739),
    [anon_sym_PIPE] = ACTIONS(3759),
    [anon_sym_AMP] = ACTIONS(2737),
    [anon_sym_LBRACK] = ACTIONS(2737),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2739),
    [anon_sym_LBRACE] = ACTIONS(2737),
    [anon_sym_LT_AT] = ACTIONS(2737),
    [anon_sym_LT_AT_AT] = ACTIONS(2737),
    [anon_sym_DOT] = ACTIONS(2737),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2739),
    [anon_sym_new] = ACTIONS(2737),
    [anon_sym_return_BANG] = ACTIONS(2739),
    [anon_sym_yield] = ACTIONS(2737),
    [anon_sym_yield_BANG] = ACTIONS(2739),
    [anon_sym_lazy] = ACTIONS(2737),
    [anon_sym_assert] = ACTIONS(2737),
    [anon_sym_upcast] = ACTIONS(2737),
    [anon_sym_downcast] = ACTIONS(2737),
    [anon_sym_COLON_GT] = ACTIONS(2739),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2739),
    [anon_sym_for] = ACTIONS(2737),
    [anon_sym_while] = ACTIONS(2737),
    [anon_sym_if] = ACTIONS(2737),
    [anon_sym_fun] = ACTIONS(2737),
    [anon_sym_try] = ACTIONS(2737),
    [anon_sym_match] = ACTIONS(2737),
    [anon_sym_match_BANG] = ACTIONS(2739),
    [anon_sym_function] = ACTIONS(2737),
    [anon_sym_LT_DASH] = ACTIONS(2737),
    [anon_sym_DOT_LBRACK] = ACTIONS(2739),
    [anon_sym_LT] = ACTIONS(2739),
    [anon_sym_GT] = ACTIONS(2737),
    [anon_sym_use] = ACTIONS(2737),
    [anon_sym_use_BANG] = ACTIONS(2739),
    [anon_sym_do_BANG] = ACTIONS(2739),
    [anon_sym_begin] = ACTIONS(2737),
    [anon_sym_LPAREN2] = ACTIONS(2737),
    [anon_sym_or] = ACTIONS(2737),
    [aux_sym_char_token1] = ACTIONS(2739),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2737),
    [anon_sym_DQUOTE] = ACTIONS(2737),
    [anon_sym_AT_DQUOTE] = ACTIONS(2739),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2739),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2739),
    [sym_bool] = ACTIONS(2737),
    [sym_unit] = ACTIONS(2739),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2737),
    [sym_op_identifier] = ACTIONS(2737),
    [anon_sym_PLUS] = ACTIONS(2737),
    [anon_sym_DASH] = ACTIONS(2737),
    [anon_sym_PLUS_DOT] = ACTIONS(2737),
    [anon_sym_DASH_DOT] = ACTIONS(2737),
    [anon_sym_PERCENT] = ACTIONS(2737),
    [anon_sym_AMP_AMP] = ACTIONS(2737),
    [anon_sym_TILDE] = ACTIONS(2739),
    [aux_sym_prefix_op_token1] = ACTIONS(2737),
    [aux_sym_infix_op_token1] = ACTIONS(2739),
    [aux_sym_infix_op_token2] = ACTIONS(2737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2737),
    [anon_sym_BANG_EQ] = ACTIONS(2737),
    [anon_sym_COLON_EQ] = ACTIONS(2739),
    [anon_sym_DOLLAR] = ACTIONS(2737),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2737),
    [sym_int] = ACTIONS(2737),
    [sym_xint] = ACTIONS(2739),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2739),
    [sym__newline] = ACTIONS(3761),
  },
  [1514] = {
    [sym_block_comment] = STATE(1514),
    [sym_compiler_directive_decl] = STATE(1514),
    [sym_fsi_directive_decl] = STATE(1514),
    [sym_preproc_line] = STATE(1514),
    [aux_sym_long_identifier_repeat1] = STATE(1587),
    [sym_identifier] = ACTIONS(2791),
    [anon_sym_EQ] = ACTIONS(2794),
    [anon_sym_COLON] = ACTIONS(2791),
    [anon_sym_return] = ACTIONS(2791),
    [anon_sym_do] = ACTIONS(2791),
    [anon_sym_and] = ACTIONS(2791),
    [anon_sym_let] = ACTIONS(2791),
    [anon_sym_let_BANG] = ACTIONS(2794),
    [anon_sym_LPAREN] = ACTIONS(2791),
    [anon_sym_COMMA] = ACTIONS(2794),
    [anon_sym_null] = ACTIONS(2791),
    [anon_sym_QMARK] = ACTIONS(2791),
    [anon_sym_COLON_QMARK] = ACTIONS(2791),
    [anon_sym_COLON_COLON] = ACTIONS(2794),
    [anon_sym_AMP] = ACTIONS(2791),
    [anon_sym_LBRACK] = ACTIONS(2791),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2794),
    [anon_sym_LBRACE] = ACTIONS(2791),
    [anon_sym_LT_AT] = ACTIONS(2791),
    [anon_sym_LT_AT_AT] = ACTIONS(2791),
    [anon_sym_DOT] = ACTIONS(3764),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2794),
    [anon_sym_new] = ACTIONS(2791),
    [anon_sym_return_BANG] = ACTIONS(2794),
    [anon_sym_yield] = ACTIONS(2791),
    [anon_sym_yield_BANG] = ACTIONS(2794),
    [anon_sym_lazy] = ACTIONS(2791),
    [anon_sym_assert] = ACTIONS(2791),
    [anon_sym_upcast] = ACTIONS(2791),
    [anon_sym_downcast] = ACTIONS(2791),
    [anon_sym_COLON_GT] = ACTIONS(2794),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2794),
    [anon_sym_for] = ACTIONS(2791),
    [anon_sym_while] = ACTIONS(2791),
    [anon_sym_if] = ACTIONS(2791),
    [anon_sym_fun] = ACTIONS(2791),
    [anon_sym_try] = ACTIONS(2791),
    [anon_sym_match] = ACTIONS(2791),
    [anon_sym_match_BANG] = ACTIONS(2794),
    [anon_sym_function] = ACTIONS(2791),
    [anon_sym_LT_DASH] = ACTIONS(2791),
    [anon_sym_DOT_LBRACK] = ACTIONS(2794),
    [anon_sym_LT] = ACTIONS(2794),
    [anon_sym_use] = ACTIONS(2791),
    [anon_sym_use_BANG] = ACTIONS(2794),
    [anon_sym_do_BANG] = ACTIONS(2794),
    [anon_sym_begin] = ACTIONS(2791),
    [anon_sym_LPAREN2] = ACTIONS(2791),
    [anon_sym_or] = ACTIONS(2791),
    [aux_sym_char_token1] = ACTIONS(2794),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2791),
    [anon_sym_DQUOTE] = ACTIONS(2791),
    [anon_sym_AT_DQUOTE] = ACTIONS(2794),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2794),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2794),
    [sym_bool] = ACTIONS(2791),
    [sym_unit] = ACTIONS(2794),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2791),
    [sym_op_identifier] = ACTIONS(2791),
    [anon_sym_PLUS] = ACTIONS(2791),
    [anon_sym_DASH] = ACTIONS(2791),
    [anon_sym_PLUS_DOT] = ACTIONS(2791),
    [anon_sym_DASH_DOT] = ACTIONS(2791),
    [anon_sym_PERCENT] = ACTIONS(2791),
    [anon_sym_AMP_AMP] = ACTIONS(2791),
    [anon_sym_TILDE] = ACTIONS(2794),
    [aux_sym_prefix_op_token1] = ACTIONS(2791),
    [aux_sym_infix_op_token1] = ACTIONS(2794),
    [aux_sym_infix_op_token2] = ACTIONS(2791),
    [anon_sym_PIPE_PIPE] = ACTIONS(2791),
    [anon_sym_BANG_EQ] = ACTIONS(2791),
    [anon_sym_COLON_EQ] = ACTIONS(2794),
    [anon_sym_DOLLAR] = ACTIONS(2791),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2791),
    [sym_int] = ACTIONS(2791),
    [sym_xint] = ACTIONS(2794),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2794),
    [sym__newline] = ACTIONS(2794),
    [sym__dedent] = ACTIONS(2794),
  },
  [1515] = {
    [sym_block_comment] = STATE(1515),
    [sym_compiler_directive_decl] = STATE(1515),
    [sym_fsi_directive_decl] = STATE(1515),
    [sym_preproc_line] = STATE(1515),
    [aux_sym_rules_repeat1] = STATE(1501),
    [sym_identifier] = ACTIONS(2689),
    [anon_sym_EQ] = ACTIONS(2691),
    [anon_sym_COLON] = ACTIONS(2689),
    [anon_sym_return] = ACTIONS(2689),
    [anon_sym_do] = ACTIONS(2689),
    [anon_sym_let] = ACTIONS(2689),
    [anon_sym_let_BANG] = ACTIONS(2691),
    [anon_sym_LPAREN] = ACTIONS(2689),
    [anon_sym_COMMA] = ACTIONS(2691),
    [anon_sym_null] = ACTIONS(2689),
    [anon_sym_QMARK] = ACTIONS(2689),
    [anon_sym_COLON_QMARK] = ACTIONS(2689),
    [anon_sym_COLON_COLON] = ACTIONS(2691),
    [anon_sym_PIPE] = ACTIONS(3709),
    [anon_sym_AMP] = ACTIONS(2689),
    [anon_sym_LBRACK] = ACTIONS(2689),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2691),
    [anon_sym_LBRACE] = ACTIONS(2689),
    [anon_sym_LT_AT] = ACTIONS(2689),
    [anon_sym_AT_GT] = ACTIONS(2689),
    [anon_sym_LT_AT_AT] = ACTIONS(2689),
    [anon_sym_DOT] = ACTIONS(2689),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2691),
    [anon_sym_new] = ACTIONS(2689),
    [anon_sym_return_BANG] = ACTIONS(2691),
    [anon_sym_yield] = ACTIONS(2689),
    [anon_sym_yield_BANG] = ACTIONS(2691),
    [anon_sym_lazy] = ACTIONS(2689),
    [anon_sym_assert] = ACTIONS(2689),
    [anon_sym_upcast] = ACTIONS(2689),
    [anon_sym_downcast] = ACTIONS(2689),
    [anon_sym_COLON_GT] = ACTIONS(2691),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2691),
    [anon_sym_for] = ACTIONS(2689),
    [anon_sym_while] = ACTIONS(2689),
    [anon_sym_if] = ACTIONS(2689),
    [anon_sym_fun] = ACTIONS(2689),
    [anon_sym_try] = ACTIONS(2689),
    [anon_sym_match] = ACTIONS(2689),
    [anon_sym_match_BANG] = ACTIONS(2691),
    [anon_sym_function] = ACTIONS(2689),
    [anon_sym_LT_DASH] = ACTIONS(2689),
    [anon_sym_DOT_LBRACK] = ACTIONS(2691),
    [anon_sym_LT] = ACTIONS(2691),
    [anon_sym_use] = ACTIONS(2689),
    [anon_sym_use_BANG] = ACTIONS(2691),
    [anon_sym_do_BANG] = ACTIONS(2691),
    [anon_sym_begin] = ACTIONS(2689),
    [anon_sym_LPAREN2] = ACTIONS(2689),
    [anon_sym_or] = ACTIONS(2689),
    [aux_sym_char_token1] = ACTIONS(2691),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2689),
    [anon_sym_DQUOTE] = ACTIONS(2689),
    [anon_sym_AT_DQUOTE] = ACTIONS(2691),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2691),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2691),
    [sym_bool] = ACTIONS(2689),
    [sym_unit] = ACTIONS(2691),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2689),
    [sym_op_identifier] = ACTIONS(2689),
    [anon_sym_PLUS] = ACTIONS(2689),
    [anon_sym_DASH] = ACTIONS(2689),
    [anon_sym_PLUS_DOT] = ACTIONS(2689),
    [anon_sym_DASH_DOT] = ACTIONS(2689),
    [anon_sym_PERCENT] = ACTIONS(2689),
    [anon_sym_AMP_AMP] = ACTIONS(2689),
    [anon_sym_TILDE] = ACTIONS(2691),
    [aux_sym_prefix_op_token1] = ACTIONS(2689),
    [aux_sym_infix_op_token1] = ACTIONS(2691),
    [aux_sym_infix_op_token2] = ACTIONS(2689),
    [anon_sym_PIPE_PIPE] = ACTIONS(2689),
    [anon_sym_BANG_EQ] = ACTIONS(2689),
    [anon_sym_COLON_EQ] = ACTIONS(2691),
    [anon_sym_DOLLAR] = ACTIONS(2689),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2689),
    [sym_int] = ACTIONS(2689),
    [sym_xint] = ACTIONS(2691),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2691),
    [sym__newline] = ACTIONS(3768),
  },
  [1516] = {
    [sym_block_comment] = STATE(1516),
    [sym_compiler_directive_decl] = STATE(1516),
    [sym_fsi_directive_decl] = STATE(1516),
    [sym_preproc_line] = STATE(1516),
    [aux_sym_rules_repeat1] = STATE(1527),
    [sym_identifier] = ACTIONS(2698),
    [anon_sym_EQ] = ACTIONS(2700),
    [anon_sym_COLON] = ACTIONS(2698),
    [anon_sym_return] = ACTIONS(2698),
    [anon_sym_do] = ACTIONS(2698),
    [anon_sym_let] = ACTIONS(2698),
    [anon_sym_let_BANG] = ACTIONS(2700),
    [anon_sym_LPAREN] = ACTIONS(2698),
    [anon_sym_COMMA] = ACTIONS(2700),
    [anon_sym_null] = ACTIONS(2698),
    [anon_sym_QMARK] = ACTIONS(2698),
    [anon_sym_COLON_QMARK] = ACTIONS(2698),
    [anon_sym_COLON_COLON] = ACTIONS(2700),
    [anon_sym_PIPE] = ACTIONS(3732),
    [anon_sym_AMP] = ACTIONS(2698),
    [anon_sym_LBRACK] = ACTIONS(2698),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2700),
    [anon_sym_LBRACE] = ACTIONS(2698),
    [anon_sym_LT_AT] = ACTIONS(2698),
    [anon_sym_LT_AT_AT] = ACTIONS(2698),
    [anon_sym_AT_AT_GT] = ACTIONS(2698),
    [anon_sym_DOT] = ACTIONS(2698),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2700),
    [anon_sym_new] = ACTIONS(2698),
    [anon_sym_return_BANG] = ACTIONS(2700),
    [anon_sym_yield] = ACTIONS(2698),
    [anon_sym_yield_BANG] = ACTIONS(2700),
    [anon_sym_lazy] = ACTIONS(2698),
    [anon_sym_assert] = ACTIONS(2698),
    [anon_sym_upcast] = ACTIONS(2698),
    [anon_sym_downcast] = ACTIONS(2698),
    [anon_sym_COLON_GT] = ACTIONS(2700),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2700),
    [anon_sym_for] = ACTIONS(2698),
    [anon_sym_while] = ACTIONS(2698),
    [anon_sym_if] = ACTIONS(2698),
    [anon_sym_fun] = ACTIONS(2698),
    [anon_sym_try] = ACTIONS(2698),
    [anon_sym_match] = ACTIONS(2698),
    [anon_sym_match_BANG] = ACTIONS(2700),
    [anon_sym_function] = ACTIONS(2698),
    [anon_sym_LT_DASH] = ACTIONS(2698),
    [anon_sym_DOT_LBRACK] = ACTIONS(2700),
    [anon_sym_LT] = ACTIONS(2700),
    [anon_sym_use] = ACTIONS(2698),
    [anon_sym_use_BANG] = ACTIONS(2700),
    [anon_sym_do_BANG] = ACTIONS(2700),
    [anon_sym_begin] = ACTIONS(2698),
    [anon_sym_LPAREN2] = ACTIONS(2698),
    [anon_sym_or] = ACTIONS(2698),
    [aux_sym_char_token1] = ACTIONS(2700),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2698),
    [anon_sym_DQUOTE] = ACTIONS(2698),
    [anon_sym_AT_DQUOTE] = ACTIONS(2700),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2700),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2700),
    [sym_bool] = ACTIONS(2698),
    [sym_unit] = ACTIONS(2700),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2698),
    [sym_op_identifier] = ACTIONS(2698),
    [anon_sym_PLUS] = ACTIONS(2698),
    [anon_sym_DASH] = ACTIONS(2698),
    [anon_sym_PLUS_DOT] = ACTIONS(2698),
    [anon_sym_DASH_DOT] = ACTIONS(2698),
    [anon_sym_PERCENT] = ACTIONS(2698),
    [anon_sym_AMP_AMP] = ACTIONS(2698),
    [anon_sym_TILDE] = ACTIONS(2700),
    [aux_sym_prefix_op_token1] = ACTIONS(2698),
    [aux_sym_infix_op_token1] = ACTIONS(2700),
    [aux_sym_infix_op_token2] = ACTIONS(2698),
    [anon_sym_PIPE_PIPE] = ACTIONS(2698),
    [anon_sym_BANG_EQ] = ACTIONS(2698),
    [anon_sym_COLON_EQ] = ACTIONS(2700),
    [anon_sym_DOLLAR] = ACTIONS(2698),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2698),
    [sym_int] = ACTIONS(2698),
    [sym_xint] = ACTIONS(2700),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2700),
    [sym__newline] = ACTIONS(3771),
  },
  [1517] = {
    [sym_block_comment] = STATE(1517),
    [sym_compiler_directive_decl] = STATE(1517),
    [sym_fsi_directive_decl] = STATE(1517),
    [sym_preproc_line] = STATE(1517),
    [aux_sym_rules_repeat1] = STATE(1530),
    [sym_identifier] = ACTIONS(2698),
    [anon_sym_EQ] = ACTIONS(2700),
    [anon_sym_COLON] = ACTIONS(2698),
    [anon_sym_return] = ACTIONS(2698),
    [anon_sym_do] = ACTIONS(2698),
    [anon_sym_let] = ACTIONS(2698),
    [anon_sym_let_BANG] = ACTIONS(2700),
    [anon_sym_LPAREN] = ACTIONS(2698),
    [anon_sym_COMMA] = ACTIONS(2700),
    [anon_sym_null] = ACTIONS(2698),
    [anon_sym_QMARK] = ACTIONS(2698),
    [anon_sym_COLON_QMARK] = ACTIONS(2698),
    [anon_sym_COLON_COLON] = ACTIONS(2700),
    [anon_sym_PIPE] = ACTIONS(3732),
    [anon_sym_AMP] = ACTIONS(2698),
    [anon_sym_LBRACK] = ACTIONS(2698),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2700),
    [anon_sym_LBRACE] = ACTIONS(2698),
    [anon_sym_LT_AT] = ACTIONS(2698),
    [anon_sym_LT_AT_AT] = ACTIONS(2698),
    [anon_sym_AT_AT_GT] = ACTIONS(2698),
    [anon_sym_DOT] = ACTIONS(2698),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2700),
    [anon_sym_new] = ACTIONS(2698),
    [anon_sym_return_BANG] = ACTIONS(2700),
    [anon_sym_yield] = ACTIONS(2698),
    [anon_sym_yield_BANG] = ACTIONS(2700),
    [anon_sym_lazy] = ACTIONS(2698),
    [anon_sym_assert] = ACTIONS(2698),
    [anon_sym_upcast] = ACTIONS(2698),
    [anon_sym_downcast] = ACTIONS(2698),
    [anon_sym_COLON_GT] = ACTIONS(2700),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2700),
    [anon_sym_for] = ACTIONS(2698),
    [anon_sym_while] = ACTIONS(2698),
    [anon_sym_if] = ACTIONS(2698),
    [anon_sym_fun] = ACTIONS(2698),
    [anon_sym_try] = ACTIONS(2698),
    [anon_sym_match] = ACTIONS(2698),
    [anon_sym_match_BANG] = ACTIONS(2700),
    [anon_sym_function] = ACTIONS(2698),
    [anon_sym_LT_DASH] = ACTIONS(2698),
    [anon_sym_DOT_LBRACK] = ACTIONS(2700),
    [anon_sym_LT] = ACTIONS(2700),
    [anon_sym_use] = ACTIONS(2698),
    [anon_sym_use_BANG] = ACTIONS(2700),
    [anon_sym_do_BANG] = ACTIONS(2700),
    [anon_sym_begin] = ACTIONS(2698),
    [anon_sym_LPAREN2] = ACTIONS(2698),
    [anon_sym_or] = ACTIONS(2698),
    [aux_sym_char_token1] = ACTIONS(2700),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2698),
    [anon_sym_DQUOTE] = ACTIONS(2698),
    [anon_sym_AT_DQUOTE] = ACTIONS(2700),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2700),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2700),
    [sym_bool] = ACTIONS(2698),
    [sym_unit] = ACTIONS(2700),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2698),
    [sym_op_identifier] = ACTIONS(2698),
    [anon_sym_PLUS] = ACTIONS(2698),
    [anon_sym_DASH] = ACTIONS(2698),
    [anon_sym_PLUS_DOT] = ACTIONS(2698),
    [anon_sym_DASH_DOT] = ACTIONS(2698),
    [anon_sym_PERCENT] = ACTIONS(2698),
    [anon_sym_AMP_AMP] = ACTIONS(2698),
    [anon_sym_TILDE] = ACTIONS(2700),
    [aux_sym_prefix_op_token1] = ACTIONS(2698),
    [aux_sym_infix_op_token1] = ACTIONS(2700),
    [aux_sym_infix_op_token2] = ACTIONS(2698),
    [anon_sym_PIPE_PIPE] = ACTIONS(2698),
    [anon_sym_BANG_EQ] = ACTIONS(2698),
    [anon_sym_COLON_EQ] = ACTIONS(2700),
    [anon_sym_DOLLAR] = ACTIONS(2698),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2698),
    [sym_int] = ACTIONS(2698),
    [sym_xint] = ACTIONS(2700),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2700),
    [sym__newline] = ACTIONS(3771),
  },
  [1518] = {
    [sym_block_comment] = STATE(1518),
    [sym_compiler_directive_decl] = STATE(1518),
    [sym_fsi_directive_decl] = STATE(1518),
    [sym_preproc_line] = STATE(1518),
    [sym_identifier] = ACTIONS(2685),
    [anon_sym_EQ] = ACTIONS(2687),
    [anon_sym_COLON] = ACTIONS(2685),
    [anon_sym_return] = ACTIONS(2685),
    [anon_sym_do] = ACTIONS(2685),
    [anon_sym_let] = ACTIONS(2685),
    [anon_sym_let_BANG] = ACTIONS(2687),
    [anon_sym_LPAREN] = ACTIONS(2685),
    [anon_sym_COMMA] = ACTIONS(2687),
    [anon_sym_null] = ACTIONS(2685),
    [anon_sym_QMARK] = ACTIONS(2685),
    [anon_sym_COLON_QMARK] = ACTIONS(2685),
    [anon_sym_COLON_COLON] = ACTIONS(2687),
    [anon_sym_AMP] = ACTIONS(2685),
    [anon_sym_LBRACK] = ACTIONS(2685),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2687),
    [anon_sym_LBRACE] = ACTIONS(2685),
    [anon_sym_LT_AT] = ACTIONS(2685),
    [anon_sym_LT_AT_AT] = ACTIONS(2685),
    [anon_sym_DOT] = ACTIONS(2685),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2687),
    [anon_sym_new] = ACTIONS(2685),
    [anon_sym_return_BANG] = ACTIONS(2687),
    [anon_sym_yield] = ACTIONS(2685),
    [anon_sym_yield_BANG] = ACTIONS(2687),
    [anon_sym_lazy] = ACTIONS(2685),
    [anon_sym_assert] = ACTIONS(2685),
    [anon_sym_upcast] = ACTIONS(2685),
    [anon_sym_downcast] = ACTIONS(2685),
    [anon_sym_COLON_GT] = ACTIONS(2687),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2687),
    [anon_sym_for] = ACTIONS(2685),
    [anon_sym_while] = ACTIONS(2685),
    [anon_sym_else] = ACTIONS(2685),
    [anon_sym_elif] = ACTIONS(2685),
    [anon_sym_if] = ACTIONS(2685),
    [anon_sym_fun] = ACTIONS(2685),
    [anon_sym_try] = ACTIONS(2685),
    [anon_sym_match] = ACTIONS(2685),
    [anon_sym_match_BANG] = ACTIONS(2687),
    [anon_sym_function] = ACTIONS(2685),
    [anon_sym_LT_DASH] = ACTIONS(2685),
    [anon_sym_DOT_LBRACK] = ACTIONS(2687),
    [anon_sym_LT] = ACTIONS(2687),
    [anon_sym_GT] = ACTIONS(2685),
    [anon_sym_use] = ACTIONS(2685),
    [anon_sym_use_BANG] = ACTIONS(2687),
    [anon_sym_do_BANG] = ACTIONS(2687),
    [anon_sym_begin] = ACTIONS(2685),
    [anon_sym_LPAREN2] = ACTIONS(2685),
    [anon_sym_or] = ACTIONS(2685),
    [aux_sym_char_token1] = ACTIONS(2687),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2685),
    [anon_sym_DQUOTE] = ACTIONS(2685),
    [anon_sym_AT_DQUOTE] = ACTIONS(2687),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2687),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2687),
    [sym_bool] = ACTIONS(2685),
    [sym_unit] = ACTIONS(2687),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2685),
    [sym_op_identifier] = ACTIONS(2685),
    [anon_sym_PLUS] = ACTIONS(2685),
    [anon_sym_DASH] = ACTIONS(2685),
    [anon_sym_PLUS_DOT] = ACTIONS(2685),
    [anon_sym_DASH_DOT] = ACTIONS(2685),
    [anon_sym_PERCENT] = ACTIONS(2685),
    [anon_sym_AMP_AMP] = ACTIONS(2685),
    [anon_sym_TILDE] = ACTIONS(2687),
    [aux_sym_prefix_op_token1] = ACTIONS(2685),
    [aux_sym_infix_op_token1] = ACTIONS(2687),
    [aux_sym_infix_op_token2] = ACTIONS(2685),
    [anon_sym_PIPE_PIPE] = ACTIONS(2685),
    [anon_sym_BANG_EQ] = ACTIONS(2685),
    [anon_sym_COLON_EQ] = ACTIONS(2687),
    [anon_sym_DOLLAR] = ACTIONS(2685),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2685),
    [sym_int] = ACTIONS(2685),
    [sym_xint] = ACTIONS(2687),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2687),
    [sym__newline] = ACTIONS(2687),
  },
  [1519] = {
    [sym_block_comment] = STATE(1519),
    [sym_compiler_directive_decl] = STATE(1519),
    [sym_fsi_directive_decl] = STATE(1519),
    [sym_preproc_line] = STATE(1519),
    [sym_identifier] = ACTIONS(2812),
    [anon_sym_EQ] = ACTIONS(2814),
    [anon_sym_COLON] = ACTIONS(2812),
    [anon_sym_return] = ACTIONS(2812),
    [anon_sym_do] = ACTIONS(2812),
    [anon_sym_let] = ACTIONS(2812),
    [anon_sym_let_BANG] = ACTIONS(2814),
    [anon_sym_LPAREN] = ACTIONS(2812),
    [anon_sym_COMMA] = ACTIONS(2814),
    [anon_sym_null] = ACTIONS(2812),
    [anon_sym_QMARK] = ACTIONS(2812),
    [anon_sym_COLON_QMARK] = ACTIONS(2812),
    [anon_sym_COLON_COLON] = ACTIONS(2814),
    [anon_sym_AMP] = ACTIONS(2812),
    [anon_sym_LBRACK] = ACTIONS(2812),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2814),
    [anon_sym_LBRACE] = ACTIONS(2812),
    [anon_sym_LT_AT] = ACTIONS(2812),
    [anon_sym_LT_AT_AT] = ACTIONS(2812),
    [anon_sym_AT_AT_GT] = ACTIONS(2812),
    [anon_sym_DOT] = ACTIONS(2812),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2814),
    [anon_sym_new] = ACTIONS(2812),
    [anon_sym_return_BANG] = ACTIONS(2814),
    [anon_sym_yield] = ACTIONS(2812),
    [anon_sym_yield_BANG] = ACTIONS(2814),
    [anon_sym_lazy] = ACTIONS(2812),
    [anon_sym_assert] = ACTIONS(2812),
    [anon_sym_upcast] = ACTIONS(2812),
    [anon_sym_downcast] = ACTIONS(2812),
    [anon_sym_COLON_GT] = ACTIONS(2814),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2814),
    [anon_sym_for] = ACTIONS(2812),
    [anon_sym_while] = ACTIONS(2812),
    [anon_sym_if] = ACTIONS(2812),
    [anon_sym_fun] = ACTIONS(2812),
    [anon_sym_try] = ACTIONS(2812),
    [anon_sym_match] = ACTIONS(2812),
    [anon_sym_match_BANG] = ACTIONS(2814),
    [anon_sym_function] = ACTIONS(2812),
    [anon_sym_LT_DASH] = ACTIONS(2812),
    [anon_sym_DOT_LBRACK] = ACTIONS(2814),
    [anon_sym_LT] = ACTIONS(2814),
    [anon_sym_use] = ACTIONS(2812),
    [anon_sym_use_BANG] = ACTIONS(2814),
    [anon_sym_do_BANG] = ACTIONS(2814),
    [anon_sym_begin] = ACTIONS(2812),
    [anon_sym_LPAREN2] = ACTIONS(2812),
    [anon_sym_or] = ACTIONS(2812),
    [aux_sym_char_token1] = ACTIONS(2814),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2812),
    [anon_sym_DQUOTE] = ACTIONS(2812),
    [anon_sym_AT_DQUOTE] = ACTIONS(2814),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2814),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2814),
    [sym_bool] = ACTIONS(2812),
    [sym_unit] = ACTIONS(2814),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2812),
    [sym_op_identifier] = ACTIONS(2812),
    [anon_sym_PLUS] = ACTIONS(2812),
    [anon_sym_DASH] = ACTIONS(2812),
    [anon_sym_PLUS_DOT] = ACTIONS(2812),
    [anon_sym_DASH_DOT] = ACTIONS(2812),
    [anon_sym_PERCENT] = ACTIONS(2812),
    [anon_sym_AMP_AMP] = ACTIONS(2812),
    [anon_sym_TILDE] = ACTIONS(2814),
    [aux_sym_prefix_op_token1] = ACTIONS(2812),
    [aux_sym_infix_op_token1] = ACTIONS(2814),
    [aux_sym_infix_op_token2] = ACTIONS(2812),
    [anon_sym_PIPE_PIPE] = ACTIONS(2812),
    [anon_sym_BANG_EQ] = ACTIONS(2812),
    [anon_sym_COLON_EQ] = ACTIONS(2814),
    [anon_sym_DOLLAR] = ACTIONS(2812),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2812),
    [sym_int] = ACTIONS(2812),
    [sym_xint] = ACTIONS(2814),
    [anon_sym_f] = ACTIONS(2812),
    [aux_sym_decimal_token1] = ACTIONS(2812),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2814),
    [sym__newline] = ACTIONS(2814),
  },
  [1520] = {
    [sym_block_comment] = STATE(1520),
    [sym_compiler_directive_decl] = STATE(1520),
    [sym_fsi_directive_decl] = STATE(1520),
    [sym_preproc_line] = STATE(1520),
    [sym_identifier] = ACTIONS(2411),
    [anon_sym_EQ] = ACTIONS(2413),
    [anon_sym_COLON] = ACTIONS(2411),
    [anon_sym_return] = ACTIONS(2411),
    [anon_sym_do] = ACTIONS(2411),
    [anon_sym_let] = ACTIONS(2411),
    [anon_sym_let_BANG] = ACTIONS(2413),
    [anon_sym_as] = ACTIONS(2411),
    [anon_sym_LPAREN] = ACTIONS(2411),
    [anon_sym_COMMA] = ACTIONS(2413),
    [anon_sym_null] = ACTIONS(2411),
    [anon_sym_QMARK] = ACTIONS(2411),
    [anon_sym_COLON_QMARK] = ACTIONS(2411),
    [anon_sym_COLON_COLON] = ACTIONS(2413),
    [anon_sym_AMP] = ACTIONS(2411),
    [anon_sym_LBRACK] = ACTIONS(2411),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2413),
    [anon_sym_LBRACE] = ACTIONS(2411),
    [anon_sym_LT_AT] = ACTIONS(2411),
    [anon_sym_LT_AT_AT] = ACTIONS(2411),
    [anon_sym_DOT] = ACTIONS(2411),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2413),
    [anon_sym_new] = ACTIONS(2411),
    [anon_sym_with] = ACTIONS(2411),
    [anon_sym_return_BANG] = ACTIONS(2413),
    [anon_sym_yield] = ACTIONS(2411),
    [anon_sym_yield_BANG] = ACTIONS(2413),
    [anon_sym_lazy] = ACTIONS(2411),
    [anon_sym_assert] = ACTIONS(2411),
    [anon_sym_upcast] = ACTIONS(2411),
    [anon_sym_downcast] = ACTIONS(2411),
    [anon_sym_COLON_GT] = ACTIONS(2413),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2413),
    [anon_sym_for] = ACTIONS(2411),
    [anon_sym_while] = ACTIONS(2411),
    [anon_sym_if] = ACTIONS(2411),
    [anon_sym_fun] = ACTIONS(2411),
    [anon_sym_try] = ACTIONS(2411),
    [anon_sym_match] = ACTIONS(2411),
    [anon_sym_match_BANG] = ACTIONS(2413),
    [anon_sym_function] = ACTIONS(2411),
    [anon_sym_LT_DASH] = ACTIONS(2411),
    [anon_sym_DOT_LBRACK] = ACTIONS(2413),
    [anon_sym_LT] = ACTIONS(2413),
    [anon_sym_use] = ACTIONS(2411),
    [anon_sym_use_BANG] = ACTIONS(2413),
    [anon_sym_do_BANG] = ACTIONS(2413),
    [anon_sym_begin] = ACTIONS(2411),
    [anon_sym_LPAREN2] = ACTIONS(2411),
    [anon_sym_or] = ACTIONS(2411),
    [aux_sym_char_token1] = ACTIONS(2413),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2411),
    [anon_sym_DQUOTE] = ACTIONS(2411),
    [anon_sym_AT_DQUOTE] = ACTIONS(2413),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2413),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2413),
    [sym_bool] = ACTIONS(2411),
    [sym_unit] = ACTIONS(2413),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2411),
    [sym_op_identifier] = ACTIONS(2411),
    [anon_sym_PLUS] = ACTIONS(2411),
    [anon_sym_DASH] = ACTIONS(2411),
    [anon_sym_PLUS_DOT] = ACTIONS(2411),
    [anon_sym_DASH_DOT] = ACTIONS(2411),
    [anon_sym_PERCENT] = ACTIONS(2411),
    [anon_sym_AMP_AMP] = ACTIONS(2411),
    [anon_sym_TILDE] = ACTIONS(2413),
    [aux_sym_prefix_op_token1] = ACTIONS(2411),
    [aux_sym_infix_op_token1] = ACTIONS(2413),
    [aux_sym_infix_op_token2] = ACTIONS(2411),
    [anon_sym_PIPE_PIPE] = ACTIONS(2411),
    [anon_sym_BANG_EQ] = ACTIONS(2411),
    [anon_sym_COLON_EQ] = ACTIONS(2413),
    [anon_sym_DOLLAR] = ACTIONS(2411),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2411),
    [sym_int] = ACTIONS(2411),
    [sym_xint] = ACTIONS(2413),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2413),
    [sym__newline] = ACTIONS(2413),
    [sym__dedent] = ACTIONS(2413),
  },
  [1521] = {
    [sym_block_comment] = STATE(1521),
    [sym_compiler_directive_decl] = STATE(1521),
    [sym_fsi_directive_decl] = STATE(1521),
    [sym_preproc_line] = STATE(1521),
    [sym_identifier] = ACTIONS(3007),
    [anon_sym_EQ] = ACTIONS(3009),
    [anon_sym_COLON] = ACTIONS(3007),
    [anon_sym_return] = ACTIONS(3007),
    [anon_sym_do] = ACTIONS(3007),
    [anon_sym_let] = ACTIONS(3007),
    [anon_sym_let_BANG] = ACTIONS(3009),
    [anon_sym_as] = ACTIONS(3007),
    [anon_sym_LPAREN] = ACTIONS(3007),
    [anon_sym_COMMA] = ACTIONS(3009),
    [anon_sym_null] = ACTIONS(3007),
    [anon_sym_QMARK] = ACTIONS(3007),
    [anon_sym_COLON_QMARK] = ACTIONS(3007),
    [anon_sym_COLON_COLON] = ACTIONS(3009),
    [anon_sym_AMP] = ACTIONS(3007),
    [anon_sym_LBRACK] = ACTIONS(3007),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3009),
    [anon_sym_LBRACE] = ACTIONS(3007),
    [anon_sym_LT_AT] = ACTIONS(3007),
    [anon_sym_LT_AT_AT] = ACTIONS(3007),
    [anon_sym_DOT] = ACTIONS(3007),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3009),
    [anon_sym_new] = ACTIONS(3007),
    [anon_sym_with] = ACTIONS(3007),
    [anon_sym_return_BANG] = ACTIONS(3009),
    [anon_sym_yield] = ACTIONS(3007),
    [anon_sym_yield_BANG] = ACTIONS(3009),
    [anon_sym_lazy] = ACTIONS(3007),
    [anon_sym_assert] = ACTIONS(3007),
    [anon_sym_upcast] = ACTIONS(3007),
    [anon_sym_downcast] = ACTIONS(3007),
    [anon_sym_COLON_GT] = ACTIONS(3009),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3009),
    [anon_sym_for] = ACTIONS(3007),
    [anon_sym_while] = ACTIONS(3007),
    [anon_sym_if] = ACTIONS(3007),
    [anon_sym_fun] = ACTIONS(3007),
    [anon_sym_try] = ACTIONS(3007),
    [anon_sym_match] = ACTIONS(3007),
    [anon_sym_match_BANG] = ACTIONS(3009),
    [anon_sym_function] = ACTIONS(3007),
    [anon_sym_LT_DASH] = ACTIONS(3007),
    [anon_sym_DOT_LBRACK] = ACTIONS(3009),
    [anon_sym_LT] = ACTIONS(3009),
    [anon_sym_use] = ACTIONS(3007),
    [anon_sym_use_BANG] = ACTIONS(3009),
    [anon_sym_do_BANG] = ACTIONS(3009),
    [anon_sym_begin] = ACTIONS(3007),
    [anon_sym_LPAREN2] = ACTIONS(3007),
    [anon_sym_or] = ACTIONS(3007),
    [aux_sym_char_token1] = ACTIONS(3009),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3007),
    [anon_sym_DQUOTE] = ACTIONS(3007),
    [anon_sym_AT_DQUOTE] = ACTIONS(3009),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3009),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3009),
    [sym_bool] = ACTIONS(3007),
    [sym_unit] = ACTIONS(3009),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3007),
    [sym_op_identifier] = ACTIONS(3007),
    [anon_sym_PLUS] = ACTIONS(3007),
    [anon_sym_DASH] = ACTIONS(3007),
    [anon_sym_PLUS_DOT] = ACTIONS(3007),
    [anon_sym_DASH_DOT] = ACTIONS(3007),
    [anon_sym_PERCENT] = ACTIONS(3007),
    [anon_sym_AMP_AMP] = ACTIONS(3007),
    [anon_sym_TILDE] = ACTIONS(3009),
    [aux_sym_prefix_op_token1] = ACTIONS(3007),
    [aux_sym_infix_op_token1] = ACTIONS(3009),
    [aux_sym_infix_op_token2] = ACTIONS(3007),
    [anon_sym_PIPE_PIPE] = ACTIONS(3007),
    [anon_sym_BANG_EQ] = ACTIONS(3007),
    [anon_sym_COLON_EQ] = ACTIONS(3009),
    [anon_sym_DOLLAR] = ACTIONS(3007),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3007),
    [sym_int] = ACTIONS(3007),
    [sym_xint] = ACTIONS(3009),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3009),
    [sym__newline] = ACTIONS(3009),
    [sym__dedent] = ACTIONS(3009),
  },
  [1522] = {
    [sym_attributes] = STATE(2636),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(3546),
    [sym__pattern] = STATE(3354),
    [sym_optional_pattern] = STATE(3546),
    [sym_type_check_pattern] = STATE(3546),
    [sym_attribute_pattern] = STATE(3546),
    [sym_paren_pattern] = STATE(3546),
    [sym_as_pattern] = STATE(3546),
    [sym_cons_pattern] = STATE(3546),
    [sym_disjunct_pattern] = STATE(3546),
    [sym_conjunct_pattern] = STATE(3546),
    [sym_typed_pattern] = STATE(3546),
    [sym_list_pattern] = STATE(3546),
    [sym_array_pattern] = STATE(3546),
    [sym_record_pattern] = STATE(3546),
    [sym_named_field_pattern] = STATE(3546),
    [sym_identifier_pattern] = STATE(3546),
    [sym_long_identifier_or_op] = STATE(1834),
    [sym_char] = STATE(3509),
    [sym_format_string] = STATE(3517),
    [sym__string_literal] = STATE(3517),
    [sym_string] = STATE(3509),
    [sym_verbatim_string] = STATE(3509),
    [sym_bytearray] = STATE(3509),
    [sym_verbatim_bytearray] = STATE(3509),
    [sym_format_triple_quoted_string] = STATE(3519),
    [sym_triple_quoted_string] = STATE(3509),
    [sym_const] = STATE(3546),
    [sym_long_identifier] = STATE(3320),
    [sym_active_pattern] = STATE(3488),
    [sym__identifier_or_op] = STATE(3410),
    [sym_sbyte] = STATE(3509),
    [sym_byte] = STATE(3509),
    [sym_int16] = STATE(3509),
    [sym_uint16] = STATE(3509),
    [sym_int32] = STATE(3509),
    [sym_uint32] = STATE(3509),
    [sym_nativeint] = STATE(3509),
    [sym_unativeint] = STATE(3509),
    [sym_int64] = STATE(3509),
    [sym_uint64] = STATE(3509),
    [sym_ieee32] = STATE(3509),
    [sym_ieee64] = STATE(3509),
    [sym_bignum] = STATE(3509),
    [sym_decimal] = STATE(3509),
    [sym_float] = STATE(3291),
    [sym_block_comment] = STATE(1522),
    [sym_compiler_directive_decl] = STATE(1522),
    [sym_fsi_directive_decl] = STATE(1522),
    [sym_preproc_line] = STATE(1522),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [aux_sym_repeat_pattern_repeat1] = STATE(3397),
    [sym_identifier] = ACTIONS(3716),
    [anon_sym_EQ] = ACTIONS(3714),
    [anon_sym_LBRACK_LT] = ACTIONS(3714),
    [anon_sym_COLON] = ACTIONS(3716),
    [anon_sym_as] = ACTIONS(3718),
    [anon_sym_LPAREN] = ACTIONS(3716),
    [anon_sym_RPAREN] = ACTIONS(3714),
    [anon_sym_COMMA] = ACTIONS(3720),
    [anon_sym_null] = ACTIONS(3716),
    [anon_sym__] = ACTIONS(3716),
    [anon_sym_QMARK] = ACTIONS(3714),
    [anon_sym_COLON_QMARK] = ACTIONS(3714),
    [anon_sym_COLON_COLON] = ACTIONS(3722),
    [anon_sym_PIPE] = ACTIONS(3724),
    [anon_sym_AMP] = ACTIONS(3726),
    [anon_sym_LBRACK] = ACTIONS(3716),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3714),
    [anon_sym_LBRACE] = ACTIONS(3714),
    [anon_sym_LT2] = ACTIONS(3714),
    [aux_sym_char_token1] = ACTIONS(3714),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3716),
    [anon_sym_DQUOTE] = ACTIONS(3716),
    [anon_sym_AT_DQUOTE] = ACTIONS(3714),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3714),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3714),
    [sym_bool] = ACTIONS(3716),
    [sym_unit] = ACTIONS(3714),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3716),
    [sym_op_identifier] = ACTIONS(3714),
    [sym_int] = ACTIONS(3716),
    [sym_xint] = ACTIONS(3714),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [1523] = {
    [sym_block_comment] = STATE(1523),
    [sym_compiler_directive_decl] = STATE(1523),
    [sym_fsi_directive_decl] = STATE(1523),
    [sym_preproc_line] = STATE(1523),
    [sym_identifier] = ACTIONS(2748),
    [anon_sym_EQ] = ACTIONS(2750),
    [anon_sym_COLON] = ACTIONS(2748),
    [anon_sym_return] = ACTIONS(2748),
    [anon_sym_do] = ACTIONS(2748),
    [anon_sym_let] = ACTIONS(2748),
    [anon_sym_let_BANG] = ACTIONS(2750),
    [anon_sym_LPAREN] = ACTIONS(2748),
    [anon_sym_COMMA] = ACTIONS(2750),
    [anon_sym_null] = ACTIONS(2748),
    [anon_sym_QMARK] = ACTIONS(2748),
    [anon_sym_COLON_QMARK] = ACTIONS(2748),
    [anon_sym_COLON_COLON] = ACTIONS(2750),
    [anon_sym_AMP] = ACTIONS(2748),
    [anon_sym_LBRACK] = ACTIONS(2748),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2750),
    [anon_sym_LBRACE] = ACTIONS(2748),
    [anon_sym_LT_AT] = ACTIONS(2748),
    [anon_sym_LT_AT_AT] = ACTIONS(2748),
    [anon_sym_DOT] = ACTIONS(2748),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2750),
    [anon_sym_new] = ACTIONS(2748),
    [anon_sym_return_BANG] = ACTIONS(2750),
    [anon_sym_yield] = ACTIONS(2748),
    [anon_sym_yield_BANG] = ACTIONS(2750),
    [anon_sym_lazy] = ACTIONS(2748),
    [anon_sym_assert] = ACTIONS(2748),
    [anon_sym_upcast] = ACTIONS(2748),
    [anon_sym_downcast] = ACTIONS(2748),
    [anon_sym_COLON_GT] = ACTIONS(2750),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2750),
    [anon_sym_for] = ACTIONS(2748),
    [anon_sym_while] = ACTIONS(2748),
    [anon_sym_else] = ACTIONS(2748),
    [anon_sym_elif] = ACTIONS(2748),
    [anon_sym_if] = ACTIONS(2748),
    [anon_sym_fun] = ACTIONS(2748),
    [anon_sym_try] = ACTIONS(2748),
    [anon_sym_match] = ACTIONS(2748),
    [anon_sym_match_BANG] = ACTIONS(2750),
    [anon_sym_function] = ACTIONS(2748),
    [anon_sym_LT_DASH] = ACTIONS(2748),
    [anon_sym_DOT_LBRACK] = ACTIONS(2750),
    [anon_sym_LT] = ACTIONS(2750),
    [anon_sym_use] = ACTIONS(2748),
    [anon_sym_use_BANG] = ACTIONS(2750),
    [anon_sym_do_BANG] = ACTIONS(2750),
    [anon_sym_begin] = ACTIONS(2748),
    [anon_sym_LPAREN2] = ACTIONS(2748),
    [anon_sym_or] = ACTIONS(2748),
    [aux_sym_char_token1] = ACTIONS(2750),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2748),
    [anon_sym_DQUOTE] = ACTIONS(2748),
    [anon_sym_AT_DQUOTE] = ACTIONS(2750),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2750),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2750),
    [sym_bool] = ACTIONS(2748),
    [sym_unit] = ACTIONS(2750),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2748),
    [sym_op_identifier] = ACTIONS(2748),
    [anon_sym_PLUS] = ACTIONS(2748),
    [anon_sym_DASH] = ACTIONS(2748),
    [anon_sym_PLUS_DOT] = ACTIONS(2748),
    [anon_sym_DASH_DOT] = ACTIONS(2748),
    [anon_sym_PERCENT] = ACTIONS(2748),
    [anon_sym_AMP_AMP] = ACTIONS(2748),
    [anon_sym_TILDE] = ACTIONS(2750),
    [aux_sym_prefix_op_token1] = ACTIONS(2748),
    [aux_sym_infix_op_token1] = ACTIONS(2750),
    [aux_sym_infix_op_token2] = ACTIONS(2748),
    [anon_sym_PIPE_PIPE] = ACTIONS(2748),
    [anon_sym_BANG_EQ] = ACTIONS(2748),
    [anon_sym_COLON_EQ] = ACTIONS(2750),
    [anon_sym_DOLLAR] = ACTIONS(2748),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2748),
    [sym_int] = ACTIONS(2748),
    [sym_xint] = ACTIONS(2750),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2750),
    [anon_sym_POUNDendif] = ACTIONS(2750),
    [sym__newline] = ACTIONS(2750),
  },
  [1524] = {
    [sym_block_comment] = STATE(1524),
    [sym_compiler_directive_decl] = STATE(1524),
    [sym_fsi_directive_decl] = STATE(1524),
    [sym_preproc_line] = STATE(1524),
    [sym_identifier] = ACTIONS(2766),
    [anon_sym_EQ] = ACTIONS(2768),
    [anon_sym_COLON] = ACTIONS(2766),
    [anon_sym_return] = ACTIONS(2766),
    [anon_sym_do] = ACTIONS(2766),
    [anon_sym_let] = ACTIONS(2766),
    [anon_sym_let_BANG] = ACTIONS(2768),
    [anon_sym_LPAREN] = ACTIONS(2766),
    [anon_sym_COMMA] = ACTIONS(2768),
    [anon_sym_null] = ACTIONS(2766),
    [anon_sym_QMARK] = ACTIONS(2766),
    [anon_sym_COLON_QMARK] = ACTIONS(2766),
    [anon_sym_COLON_COLON] = ACTIONS(2768),
    [anon_sym_PIPE] = ACTIONS(2766),
    [anon_sym_AMP] = ACTIONS(2766),
    [anon_sym_LBRACK] = ACTIONS(2766),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2768),
    [anon_sym_LBRACE] = ACTIONS(2766),
    [anon_sym_LT_AT] = ACTIONS(2766),
    [anon_sym_LT_AT_AT] = ACTIONS(2766),
    [anon_sym_DOT] = ACTIONS(2766),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2768),
    [anon_sym_new] = ACTIONS(2766),
    [anon_sym_return_BANG] = ACTIONS(2768),
    [anon_sym_yield] = ACTIONS(2766),
    [anon_sym_yield_BANG] = ACTIONS(2768),
    [anon_sym_lazy] = ACTIONS(2766),
    [anon_sym_assert] = ACTIONS(2766),
    [anon_sym_upcast] = ACTIONS(2766),
    [anon_sym_downcast] = ACTIONS(2766),
    [anon_sym_COLON_GT] = ACTIONS(2768),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2768),
    [anon_sym_for] = ACTIONS(2766),
    [anon_sym_while] = ACTIONS(2766),
    [anon_sym_if] = ACTIONS(2766),
    [anon_sym_fun] = ACTIONS(2766),
    [anon_sym_DASH_GT] = ACTIONS(2766),
    [anon_sym_try] = ACTIONS(2766),
    [anon_sym_match] = ACTIONS(2766),
    [anon_sym_match_BANG] = ACTIONS(2768),
    [anon_sym_function] = ACTIONS(2766),
    [anon_sym_LT_DASH] = ACTIONS(2766),
    [anon_sym_DOT_LBRACK] = ACTIONS(2768),
    [anon_sym_LT] = ACTIONS(2768),
    [anon_sym_use] = ACTIONS(2766),
    [anon_sym_use_BANG] = ACTIONS(2768),
    [anon_sym_do_BANG] = ACTIONS(2768),
    [anon_sym_DOT_DOT] = ACTIONS(2768),
    [anon_sym_begin] = ACTIONS(2766),
    [anon_sym_LPAREN2] = ACTIONS(2766),
    [anon_sym_or] = ACTIONS(2766),
    [aux_sym_char_token1] = ACTIONS(2768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2766),
    [anon_sym_DQUOTE] = ACTIONS(2766),
    [anon_sym_AT_DQUOTE] = ACTIONS(2768),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2768),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2768),
    [sym_bool] = ACTIONS(2766),
    [sym_unit] = ACTIONS(2768),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2766),
    [sym_op_identifier] = ACTIONS(2766),
    [anon_sym_PLUS] = ACTIONS(2766),
    [anon_sym_DASH] = ACTIONS(2766),
    [anon_sym_PLUS_DOT] = ACTIONS(2766),
    [anon_sym_DASH_DOT] = ACTIONS(2766),
    [anon_sym_PERCENT] = ACTIONS(2766),
    [anon_sym_AMP_AMP] = ACTIONS(2766),
    [anon_sym_TILDE] = ACTIONS(2768),
    [aux_sym_prefix_op_token1] = ACTIONS(2766),
    [aux_sym_infix_op_token1] = ACTIONS(2768),
    [aux_sym_infix_op_token2] = ACTIONS(2766),
    [anon_sym_PIPE_PIPE] = ACTIONS(2766),
    [anon_sym_BANG_EQ] = ACTIONS(2766),
    [anon_sym_COLON_EQ] = ACTIONS(2768),
    [anon_sym_DOLLAR] = ACTIONS(2766),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2766),
    [sym_int] = ACTIONS(2766),
    [sym_xint] = ACTIONS(2768),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2768),
    [sym__newline] = ACTIONS(2768),
  },
  [1525] = {
    [sym_block_comment] = STATE(1525),
    [sym_compiler_directive_decl] = STATE(1525),
    [sym_fsi_directive_decl] = STATE(1525),
    [sym_preproc_line] = STATE(1525),
    [sym_identifier] = ACTIONS(2713),
    [anon_sym_EQ] = ACTIONS(2715),
    [anon_sym_COLON] = ACTIONS(2713),
    [anon_sym_return] = ACTIONS(2713),
    [anon_sym_do] = ACTIONS(2713),
    [anon_sym_let] = ACTIONS(2713),
    [anon_sym_let_BANG] = ACTIONS(2715),
    [anon_sym_LPAREN] = ACTIONS(2713),
    [anon_sym_COMMA] = ACTIONS(2715),
    [anon_sym_null] = ACTIONS(2713),
    [anon_sym_QMARK] = ACTIONS(2713),
    [anon_sym_COLON_QMARK] = ACTIONS(2713),
    [anon_sym_COLON_COLON] = ACTIONS(2715),
    [anon_sym_PIPE] = ACTIONS(2713),
    [anon_sym_AMP] = ACTIONS(2713),
    [anon_sym_LBRACK] = ACTIONS(2713),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2715),
    [anon_sym_LBRACE] = ACTIONS(2713),
    [anon_sym_LT_AT] = ACTIONS(2713),
    [anon_sym_LT_AT_AT] = ACTIONS(2713),
    [anon_sym_DOT] = ACTIONS(2713),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2715),
    [anon_sym_new] = ACTIONS(2713),
    [anon_sym_return_BANG] = ACTIONS(2715),
    [anon_sym_yield] = ACTIONS(2713),
    [anon_sym_yield_BANG] = ACTIONS(2715),
    [anon_sym_lazy] = ACTIONS(2713),
    [anon_sym_assert] = ACTIONS(2713),
    [anon_sym_upcast] = ACTIONS(2713),
    [anon_sym_downcast] = ACTIONS(2713),
    [anon_sym_COLON_GT] = ACTIONS(2715),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2715),
    [anon_sym_for] = ACTIONS(2713),
    [anon_sym_while] = ACTIONS(2713),
    [anon_sym_if] = ACTIONS(2713),
    [anon_sym_fun] = ACTIONS(2713),
    [anon_sym_DASH_GT] = ACTIONS(2713),
    [anon_sym_try] = ACTIONS(2713),
    [anon_sym_match] = ACTIONS(2713),
    [anon_sym_match_BANG] = ACTIONS(2715),
    [anon_sym_function] = ACTIONS(2713),
    [anon_sym_LT_DASH] = ACTIONS(2713),
    [anon_sym_DOT_LBRACK] = ACTIONS(2715),
    [anon_sym_LT] = ACTIONS(2715),
    [anon_sym_use] = ACTIONS(2713),
    [anon_sym_use_BANG] = ACTIONS(2715),
    [anon_sym_do_BANG] = ACTIONS(2715),
    [anon_sym_DOT_DOT] = ACTIONS(2715),
    [anon_sym_begin] = ACTIONS(2713),
    [anon_sym_LPAREN2] = ACTIONS(2713),
    [anon_sym_or] = ACTIONS(2713),
    [aux_sym_char_token1] = ACTIONS(2715),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2713),
    [anon_sym_DQUOTE] = ACTIONS(2713),
    [anon_sym_AT_DQUOTE] = ACTIONS(2715),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2715),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2715),
    [sym_bool] = ACTIONS(2713),
    [sym_unit] = ACTIONS(2715),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2713),
    [sym_op_identifier] = ACTIONS(2713),
    [anon_sym_PLUS] = ACTIONS(2713),
    [anon_sym_DASH] = ACTIONS(2713),
    [anon_sym_PLUS_DOT] = ACTIONS(2713),
    [anon_sym_DASH_DOT] = ACTIONS(2713),
    [anon_sym_PERCENT] = ACTIONS(2713),
    [anon_sym_AMP_AMP] = ACTIONS(2713),
    [anon_sym_TILDE] = ACTIONS(2715),
    [aux_sym_prefix_op_token1] = ACTIONS(2713),
    [aux_sym_infix_op_token1] = ACTIONS(2715),
    [aux_sym_infix_op_token2] = ACTIONS(2713),
    [anon_sym_PIPE_PIPE] = ACTIONS(2713),
    [anon_sym_BANG_EQ] = ACTIONS(2713),
    [anon_sym_COLON_EQ] = ACTIONS(2715),
    [anon_sym_DOLLAR] = ACTIONS(2713),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2713),
    [sym_int] = ACTIONS(2713),
    [sym_xint] = ACTIONS(2715),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2715),
    [sym__newline] = ACTIONS(2715),
  },
  [1526] = {
    [sym_block_comment] = STATE(1526),
    [sym_compiler_directive_decl] = STATE(1526),
    [sym_fsi_directive_decl] = STATE(1526),
    [sym_preproc_line] = STATE(1526),
    [sym_identifier] = ACTIONS(2756),
    [anon_sym_EQ] = ACTIONS(2758),
    [anon_sym_COLON] = ACTIONS(2756),
    [anon_sym_return] = ACTIONS(2756),
    [anon_sym_do] = ACTIONS(2756),
    [anon_sym_let] = ACTIONS(2756),
    [anon_sym_let_BANG] = ACTIONS(2758),
    [anon_sym_LPAREN] = ACTIONS(2756),
    [anon_sym_COMMA] = ACTIONS(2758),
    [anon_sym_null] = ACTIONS(2756),
    [anon_sym_QMARK] = ACTIONS(2756),
    [anon_sym_COLON_QMARK] = ACTIONS(2756),
    [anon_sym_COLON_COLON] = ACTIONS(2758),
    [anon_sym_PIPE] = ACTIONS(2756),
    [anon_sym_AMP] = ACTIONS(2756),
    [anon_sym_LBRACK] = ACTIONS(2756),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2758),
    [anon_sym_LBRACE] = ACTIONS(2756),
    [anon_sym_LT_AT] = ACTIONS(2756),
    [anon_sym_LT_AT_AT] = ACTIONS(2756),
    [anon_sym_DOT] = ACTIONS(2756),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2758),
    [anon_sym_new] = ACTIONS(2756),
    [anon_sym_return_BANG] = ACTIONS(2758),
    [anon_sym_yield] = ACTIONS(2756),
    [anon_sym_yield_BANG] = ACTIONS(2758),
    [anon_sym_lazy] = ACTIONS(2756),
    [anon_sym_assert] = ACTIONS(2756),
    [anon_sym_upcast] = ACTIONS(2756),
    [anon_sym_downcast] = ACTIONS(2756),
    [anon_sym_COLON_GT] = ACTIONS(2758),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2758),
    [anon_sym_for] = ACTIONS(2756),
    [anon_sym_while] = ACTIONS(2756),
    [anon_sym_if] = ACTIONS(2756),
    [anon_sym_fun] = ACTIONS(2756),
    [anon_sym_DASH_GT] = ACTIONS(2756),
    [anon_sym_try] = ACTIONS(2756),
    [anon_sym_match] = ACTIONS(2756),
    [anon_sym_match_BANG] = ACTIONS(2758),
    [anon_sym_function] = ACTIONS(2756),
    [anon_sym_LT_DASH] = ACTIONS(2756),
    [anon_sym_DOT_LBRACK] = ACTIONS(2758),
    [anon_sym_LT] = ACTIONS(2758),
    [anon_sym_use] = ACTIONS(2756),
    [anon_sym_use_BANG] = ACTIONS(2758),
    [anon_sym_do_BANG] = ACTIONS(2758),
    [anon_sym_DOT_DOT] = ACTIONS(2758),
    [anon_sym_begin] = ACTIONS(2756),
    [anon_sym_LPAREN2] = ACTIONS(2756),
    [anon_sym_or] = ACTIONS(2756),
    [aux_sym_char_token1] = ACTIONS(2758),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2756),
    [anon_sym_DQUOTE] = ACTIONS(2756),
    [anon_sym_AT_DQUOTE] = ACTIONS(2758),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2758),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2758),
    [sym_bool] = ACTIONS(2756),
    [sym_unit] = ACTIONS(2758),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2756),
    [sym_op_identifier] = ACTIONS(2756),
    [anon_sym_PLUS] = ACTIONS(2756),
    [anon_sym_DASH] = ACTIONS(2756),
    [anon_sym_PLUS_DOT] = ACTIONS(2756),
    [anon_sym_DASH_DOT] = ACTIONS(2756),
    [anon_sym_PERCENT] = ACTIONS(2756),
    [anon_sym_AMP_AMP] = ACTIONS(2756),
    [anon_sym_TILDE] = ACTIONS(2758),
    [aux_sym_prefix_op_token1] = ACTIONS(2756),
    [aux_sym_infix_op_token1] = ACTIONS(2758),
    [aux_sym_infix_op_token2] = ACTIONS(2756),
    [anon_sym_PIPE_PIPE] = ACTIONS(2756),
    [anon_sym_BANG_EQ] = ACTIONS(2756),
    [anon_sym_COLON_EQ] = ACTIONS(2758),
    [anon_sym_DOLLAR] = ACTIONS(2756),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2756),
    [sym_int] = ACTIONS(2756),
    [sym_xint] = ACTIONS(2758),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2758),
    [sym__newline] = ACTIONS(2758),
  },
  [1527] = {
    [sym_block_comment] = STATE(1527),
    [sym_compiler_directive_decl] = STATE(1527),
    [sym_fsi_directive_decl] = STATE(1527),
    [sym_preproc_line] = STATE(1527),
    [aux_sym_rules_repeat1] = STATE(1530),
    [sym_identifier] = ACTIONS(2737),
    [anon_sym_EQ] = ACTIONS(2739),
    [anon_sym_COLON] = ACTIONS(2737),
    [anon_sym_return] = ACTIONS(2737),
    [anon_sym_do] = ACTIONS(2737),
    [anon_sym_let] = ACTIONS(2737),
    [anon_sym_let_BANG] = ACTIONS(2739),
    [anon_sym_LPAREN] = ACTIONS(2737),
    [anon_sym_COMMA] = ACTIONS(2739),
    [anon_sym_null] = ACTIONS(2737),
    [anon_sym_QMARK] = ACTIONS(2737),
    [anon_sym_COLON_QMARK] = ACTIONS(2737),
    [anon_sym_COLON_COLON] = ACTIONS(2739),
    [anon_sym_PIPE] = ACTIONS(3732),
    [anon_sym_AMP] = ACTIONS(2737),
    [anon_sym_LBRACK] = ACTIONS(2737),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2739),
    [anon_sym_LBRACE] = ACTIONS(2737),
    [anon_sym_LT_AT] = ACTIONS(2737),
    [anon_sym_LT_AT_AT] = ACTIONS(2737),
    [anon_sym_AT_AT_GT] = ACTIONS(2737),
    [anon_sym_DOT] = ACTIONS(2737),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2739),
    [anon_sym_new] = ACTIONS(2737),
    [anon_sym_return_BANG] = ACTIONS(2739),
    [anon_sym_yield] = ACTIONS(2737),
    [anon_sym_yield_BANG] = ACTIONS(2739),
    [anon_sym_lazy] = ACTIONS(2737),
    [anon_sym_assert] = ACTIONS(2737),
    [anon_sym_upcast] = ACTIONS(2737),
    [anon_sym_downcast] = ACTIONS(2737),
    [anon_sym_COLON_GT] = ACTIONS(2739),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2739),
    [anon_sym_for] = ACTIONS(2737),
    [anon_sym_while] = ACTIONS(2737),
    [anon_sym_if] = ACTIONS(2737),
    [anon_sym_fun] = ACTIONS(2737),
    [anon_sym_try] = ACTIONS(2737),
    [anon_sym_match] = ACTIONS(2737),
    [anon_sym_match_BANG] = ACTIONS(2739),
    [anon_sym_function] = ACTIONS(2737),
    [anon_sym_LT_DASH] = ACTIONS(2737),
    [anon_sym_DOT_LBRACK] = ACTIONS(2739),
    [anon_sym_LT] = ACTIONS(2739),
    [anon_sym_use] = ACTIONS(2737),
    [anon_sym_use_BANG] = ACTIONS(2739),
    [anon_sym_do_BANG] = ACTIONS(2739),
    [anon_sym_begin] = ACTIONS(2737),
    [anon_sym_LPAREN2] = ACTIONS(2737),
    [anon_sym_or] = ACTIONS(2737),
    [aux_sym_char_token1] = ACTIONS(2739),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2737),
    [anon_sym_DQUOTE] = ACTIONS(2737),
    [anon_sym_AT_DQUOTE] = ACTIONS(2739),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2739),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2739),
    [sym_bool] = ACTIONS(2737),
    [sym_unit] = ACTIONS(2739),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2737),
    [sym_op_identifier] = ACTIONS(2737),
    [anon_sym_PLUS] = ACTIONS(2737),
    [anon_sym_DASH] = ACTIONS(2737),
    [anon_sym_PLUS_DOT] = ACTIONS(2737),
    [anon_sym_DASH_DOT] = ACTIONS(2737),
    [anon_sym_PERCENT] = ACTIONS(2737),
    [anon_sym_AMP_AMP] = ACTIONS(2737),
    [anon_sym_TILDE] = ACTIONS(2739),
    [aux_sym_prefix_op_token1] = ACTIONS(2737),
    [aux_sym_infix_op_token1] = ACTIONS(2739),
    [aux_sym_infix_op_token2] = ACTIONS(2737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2737),
    [anon_sym_BANG_EQ] = ACTIONS(2737),
    [anon_sym_COLON_EQ] = ACTIONS(2739),
    [anon_sym_DOLLAR] = ACTIONS(2737),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2737),
    [sym_int] = ACTIONS(2737),
    [sym_xint] = ACTIONS(2739),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2739),
    [sym__newline] = ACTIONS(3774),
  },
  [1528] = {
    [sym_block_comment] = STATE(1528),
    [sym_compiler_directive_decl] = STATE(1528),
    [sym_fsi_directive_decl] = STATE(1528),
    [sym_preproc_line] = STATE(1528),
    [sym_identifier] = ACTIONS(2760),
    [anon_sym_EQ] = ACTIONS(2762),
    [anon_sym_COLON] = ACTIONS(2760),
    [anon_sym_return] = ACTIONS(2760),
    [anon_sym_do] = ACTIONS(2760),
    [anon_sym_let] = ACTIONS(2760),
    [anon_sym_let_BANG] = ACTIONS(2762),
    [anon_sym_LPAREN] = ACTIONS(2760),
    [anon_sym_COMMA] = ACTIONS(2762),
    [anon_sym_null] = ACTIONS(2760),
    [anon_sym_QMARK] = ACTIONS(2760),
    [anon_sym_COLON_QMARK] = ACTIONS(2760),
    [anon_sym_COLON_COLON] = ACTIONS(2762),
    [anon_sym_PIPE] = ACTIONS(2760),
    [anon_sym_AMP] = ACTIONS(2760),
    [anon_sym_LBRACK] = ACTIONS(2760),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2762),
    [anon_sym_LBRACE] = ACTIONS(2760),
    [anon_sym_LT_AT] = ACTIONS(2760),
    [anon_sym_LT_AT_AT] = ACTIONS(2760),
    [anon_sym_DOT] = ACTIONS(2760),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2762),
    [anon_sym_new] = ACTIONS(2760),
    [anon_sym_return_BANG] = ACTIONS(2762),
    [anon_sym_yield] = ACTIONS(2760),
    [anon_sym_yield_BANG] = ACTIONS(2762),
    [anon_sym_lazy] = ACTIONS(2760),
    [anon_sym_assert] = ACTIONS(2760),
    [anon_sym_upcast] = ACTIONS(2760),
    [anon_sym_downcast] = ACTIONS(2760),
    [anon_sym_COLON_GT] = ACTIONS(2762),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2762),
    [anon_sym_for] = ACTIONS(2760),
    [anon_sym_while] = ACTIONS(2760),
    [anon_sym_if] = ACTIONS(2760),
    [anon_sym_fun] = ACTIONS(2760),
    [anon_sym_DASH_GT] = ACTIONS(2760),
    [anon_sym_try] = ACTIONS(2760),
    [anon_sym_match] = ACTIONS(2760),
    [anon_sym_match_BANG] = ACTIONS(2762),
    [anon_sym_function] = ACTIONS(2760),
    [anon_sym_LT_DASH] = ACTIONS(2760),
    [anon_sym_DOT_LBRACK] = ACTIONS(2762),
    [anon_sym_LT] = ACTIONS(2762),
    [anon_sym_use] = ACTIONS(2760),
    [anon_sym_use_BANG] = ACTIONS(2762),
    [anon_sym_do_BANG] = ACTIONS(2762),
    [anon_sym_DOT_DOT] = ACTIONS(2762),
    [anon_sym_begin] = ACTIONS(2760),
    [anon_sym_LPAREN2] = ACTIONS(2760),
    [anon_sym_or] = ACTIONS(2760),
    [aux_sym_char_token1] = ACTIONS(2762),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2760),
    [anon_sym_DQUOTE] = ACTIONS(2760),
    [anon_sym_AT_DQUOTE] = ACTIONS(2762),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2762),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2762),
    [sym_bool] = ACTIONS(2760),
    [sym_unit] = ACTIONS(2762),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2760),
    [sym_op_identifier] = ACTIONS(2760),
    [anon_sym_PLUS] = ACTIONS(2760),
    [anon_sym_DASH] = ACTIONS(2760),
    [anon_sym_PLUS_DOT] = ACTIONS(2760),
    [anon_sym_DASH_DOT] = ACTIONS(2760),
    [anon_sym_PERCENT] = ACTIONS(2760),
    [anon_sym_AMP_AMP] = ACTIONS(2760),
    [anon_sym_TILDE] = ACTIONS(2762),
    [aux_sym_prefix_op_token1] = ACTIONS(2760),
    [aux_sym_infix_op_token1] = ACTIONS(2762),
    [aux_sym_infix_op_token2] = ACTIONS(2760),
    [anon_sym_PIPE_PIPE] = ACTIONS(2760),
    [anon_sym_BANG_EQ] = ACTIONS(2760),
    [anon_sym_COLON_EQ] = ACTIONS(2762),
    [anon_sym_DOLLAR] = ACTIONS(2760),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2760),
    [sym_int] = ACTIONS(2760),
    [sym_xint] = ACTIONS(2762),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2762),
    [sym__newline] = ACTIONS(2762),
  },
  [1529] = {
    [sym_block_comment] = STATE(1529),
    [sym_compiler_directive_decl] = STATE(1529),
    [sym_fsi_directive_decl] = STATE(1529),
    [sym_preproc_line] = STATE(1529),
    [aux_sym_rules_repeat1] = STATE(1509),
    [sym_identifier] = ACTIONS(2698),
    [anon_sym_EQ] = ACTIONS(2700),
    [anon_sym_COLON] = ACTIONS(2698),
    [anon_sym_return] = ACTIONS(2698),
    [anon_sym_do] = ACTIONS(2698),
    [anon_sym_let] = ACTIONS(2698),
    [anon_sym_let_BANG] = ACTIONS(2700),
    [anon_sym_LPAREN] = ACTIONS(2698),
    [anon_sym_COMMA] = ACTIONS(2700),
    [anon_sym_null] = ACTIONS(2698),
    [anon_sym_QMARK] = ACTIONS(2698),
    [anon_sym_COLON_QMARK] = ACTIONS(2698),
    [anon_sym_COLON_COLON] = ACTIONS(2700),
    [anon_sym_PIPE] = ACTIONS(3759),
    [anon_sym_AMP] = ACTIONS(2698),
    [anon_sym_LBRACK] = ACTIONS(2698),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2700),
    [anon_sym_LBRACE] = ACTIONS(2698),
    [anon_sym_LT_AT] = ACTIONS(2698),
    [anon_sym_LT_AT_AT] = ACTIONS(2698),
    [anon_sym_DOT] = ACTIONS(2698),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2700),
    [anon_sym_new] = ACTIONS(2698),
    [anon_sym_return_BANG] = ACTIONS(2700),
    [anon_sym_yield] = ACTIONS(2698),
    [anon_sym_yield_BANG] = ACTIONS(2700),
    [anon_sym_lazy] = ACTIONS(2698),
    [anon_sym_assert] = ACTIONS(2698),
    [anon_sym_upcast] = ACTIONS(2698),
    [anon_sym_downcast] = ACTIONS(2698),
    [anon_sym_COLON_GT] = ACTIONS(2700),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2700),
    [anon_sym_for] = ACTIONS(2698),
    [anon_sym_while] = ACTIONS(2698),
    [anon_sym_if] = ACTIONS(2698),
    [anon_sym_fun] = ACTIONS(2698),
    [anon_sym_try] = ACTIONS(2698),
    [anon_sym_match] = ACTIONS(2698),
    [anon_sym_match_BANG] = ACTIONS(2700),
    [anon_sym_function] = ACTIONS(2698),
    [anon_sym_LT_DASH] = ACTIONS(2698),
    [anon_sym_DOT_LBRACK] = ACTIONS(2700),
    [anon_sym_LT] = ACTIONS(2700),
    [anon_sym_GT] = ACTIONS(2698),
    [anon_sym_use] = ACTIONS(2698),
    [anon_sym_use_BANG] = ACTIONS(2700),
    [anon_sym_do_BANG] = ACTIONS(2700),
    [anon_sym_begin] = ACTIONS(2698),
    [anon_sym_LPAREN2] = ACTIONS(2698),
    [anon_sym_or] = ACTIONS(2698),
    [aux_sym_char_token1] = ACTIONS(2700),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2698),
    [anon_sym_DQUOTE] = ACTIONS(2698),
    [anon_sym_AT_DQUOTE] = ACTIONS(2700),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2700),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2700),
    [sym_bool] = ACTIONS(2698),
    [sym_unit] = ACTIONS(2700),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2698),
    [sym_op_identifier] = ACTIONS(2698),
    [anon_sym_PLUS] = ACTIONS(2698),
    [anon_sym_DASH] = ACTIONS(2698),
    [anon_sym_PLUS_DOT] = ACTIONS(2698),
    [anon_sym_DASH_DOT] = ACTIONS(2698),
    [anon_sym_PERCENT] = ACTIONS(2698),
    [anon_sym_AMP_AMP] = ACTIONS(2698),
    [anon_sym_TILDE] = ACTIONS(2700),
    [aux_sym_prefix_op_token1] = ACTIONS(2698),
    [aux_sym_infix_op_token1] = ACTIONS(2700),
    [aux_sym_infix_op_token2] = ACTIONS(2698),
    [anon_sym_PIPE_PIPE] = ACTIONS(2698),
    [anon_sym_BANG_EQ] = ACTIONS(2698),
    [anon_sym_COLON_EQ] = ACTIONS(2700),
    [anon_sym_DOLLAR] = ACTIONS(2698),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2698),
    [sym_int] = ACTIONS(2698),
    [sym_xint] = ACTIONS(2700),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2700),
    [sym__newline] = ACTIONS(3777),
  },
  [1530] = {
    [sym_block_comment] = STATE(1530),
    [sym_compiler_directive_decl] = STATE(1530),
    [sym_fsi_directive_decl] = STATE(1530),
    [sym_preproc_line] = STATE(1530),
    [aux_sym_rules_repeat1] = STATE(1530),
    [sym_identifier] = ACTIONS(2713),
    [anon_sym_EQ] = ACTIONS(2715),
    [anon_sym_COLON] = ACTIONS(2713),
    [anon_sym_return] = ACTIONS(2713),
    [anon_sym_do] = ACTIONS(2713),
    [anon_sym_let] = ACTIONS(2713),
    [anon_sym_let_BANG] = ACTIONS(2715),
    [anon_sym_LPAREN] = ACTIONS(2713),
    [anon_sym_COMMA] = ACTIONS(2715),
    [anon_sym_null] = ACTIONS(2713),
    [anon_sym_QMARK] = ACTIONS(2713),
    [anon_sym_COLON_QMARK] = ACTIONS(2713),
    [anon_sym_COLON_COLON] = ACTIONS(2715),
    [anon_sym_PIPE] = ACTIONS(3780),
    [anon_sym_AMP] = ACTIONS(2713),
    [anon_sym_LBRACK] = ACTIONS(2713),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2715),
    [anon_sym_LBRACE] = ACTIONS(2713),
    [anon_sym_LT_AT] = ACTIONS(2713),
    [anon_sym_LT_AT_AT] = ACTIONS(2713),
    [anon_sym_AT_AT_GT] = ACTIONS(2713),
    [anon_sym_DOT] = ACTIONS(2713),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2715),
    [anon_sym_new] = ACTIONS(2713),
    [anon_sym_return_BANG] = ACTIONS(2715),
    [anon_sym_yield] = ACTIONS(2713),
    [anon_sym_yield_BANG] = ACTIONS(2715),
    [anon_sym_lazy] = ACTIONS(2713),
    [anon_sym_assert] = ACTIONS(2713),
    [anon_sym_upcast] = ACTIONS(2713),
    [anon_sym_downcast] = ACTIONS(2713),
    [anon_sym_COLON_GT] = ACTIONS(2715),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2715),
    [anon_sym_for] = ACTIONS(2713),
    [anon_sym_while] = ACTIONS(2713),
    [anon_sym_if] = ACTIONS(2713),
    [anon_sym_fun] = ACTIONS(2713),
    [anon_sym_try] = ACTIONS(2713),
    [anon_sym_match] = ACTIONS(2713),
    [anon_sym_match_BANG] = ACTIONS(2715),
    [anon_sym_function] = ACTIONS(2713),
    [anon_sym_LT_DASH] = ACTIONS(2713),
    [anon_sym_DOT_LBRACK] = ACTIONS(2715),
    [anon_sym_LT] = ACTIONS(2715),
    [anon_sym_use] = ACTIONS(2713),
    [anon_sym_use_BANG] = ACTIONS(2715),
    [anon_sym_do_BANG] = ACTIONS(2715),
    [anon_sym_begin] = ACTIONS(2713),
    [anon_sym_LPAREN2] = ACTIONS(2713),
    [anon_sym_or] = ACTIONS(2713),
    [aux_sym_char_token1] = ACTIONS(2715),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2713),
    [anon_sym_DQUOTE] = ACTIONS(2713),
    [anon_sym_AT_DQUOTE] = ACTIONS(2715),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2715),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2715),
    [sym_bool] = ACTIONS(2713),
    [sym_unit] = ACTIONS(2715),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2713),
    [sym_op_identifier] = ACTIONS(2713),
    [anon_sym_PLUS] = ACTIONS(2713),
    [anon_sym_DASH] = ACTIONS(2713),
    [anon_sym_PLUS_DOT] = ACTIONS(2713),
    [anon_sym_DASH_DOT] = ACTIONS(2713),
    [anon_sym_PERCENT] = ACTIONS(2713),
    [anon_sym_AMP_AMP] = ACTIONS(2713),
    [anon_sym_TILDE] = ACTIONS(2715),
    [aux_sym_prefix_op_token1] = ACTIONS(2713),
    [aux_sym_infix_op_token1] = ACTIONS(2715),
    [aux_sym_infix_op_token2] = ACTIONS(2713),
    [anon_sym_PIPE_PIPE] = ACTIONS(2713),
    [anon_sym_BANG_EQ] = ACTIONS(2713),
    [anon_sym_COLON_EQ] = ACTIONS(2715),
    [anon_sym_DOLLAR] = ACTIONS(2713),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2713),
    [sym_int] = ACTIONS(2713),
    [sym_xint] = ACTIONS(2715),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2715),
    [sym__newline] = ACTIONS(3783),
  },
  [1531] = {
    [sym_block_comment] = STATE(1531),
    [sym_compiler_directive_decl] = STATE(1531),
    [sym_fsi_directive_decl] = STATE(1531),
    [sym_preproc_line] = STATE(1531),
    [aux_sym_rules_repeat1] = STATE(1513),
    [sym_identifier] = ACTIONS(2698),
    [anon_sym_EQ] = ACTIONS(2700),
    [anon_sym_COLON] = ACTIONS(2698),
    [anon_sym_return] = ACTIONS(2698),
    [anon_sym_do] = ACTIONS(2698),
    [anon_sym_let] = ACTIONS(2698),
    [anon_sym_let_BANG] = ACTIONS(2700),
    [anon_sym_LPAREN] = ACTIONS(2698),
    [anon_sym_COMMA] = ACTIONS(2700),
    [anon_sym_null] = ACTIONS(2698),
    [anon_sym_QMARK] = ACTIONS(2698),
    [anon_sym_COLON_QMARK] = ACTIONS(2698),
    [anon_sym_COLON_COLON] = ACTIONS(2700),
    [anon_sym_PIPE] = ACTIONS(3759),
    [anon_sym_AMP] = ACTIONS(2698),
    [anon_sym_LBRACK] = ACTIONS(2698),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2700),
    [anon_sym_LBRACE] = ACTIONS(2698),
    [anon_sym_LT_AT] = ACTIONS(2698),
    [anon_sym_LT_AT_AT] = ACTIONS(2698),
    [anon_sym_DOT] = ACTIONS(2698),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2700),
    [anon_sym_new] = ACTIONS(2698),
    [anon_sym_return_BANG] = ACTIONS(2700),
    [anon_sym_yield] = ACTIONS(2698),
    [anon_sym_yield_BANG] = ACTIONS(2700),
    [anon_sym_lazy] = ACTIONS(2698),
    [anon_sym_assert] = ACTIONS(2698),
    [anon_sym_upcast] = ACTIONS(2698),
    [anon_sym_downcast] = ACTIONS(2698),
    [anon_sym_COLON_GT] = ACTIONS(2700),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2700),
    [anon_sym_for] = ACTIONS(2698),
    [anon_sym_while] = ACTIONS(2698),
    [anon_sym_if] = ACTIONS(2698),
    [anon_sym_fun] = ACTIONS(2698),
    [anon_sym_try] = ACTIONS(2698),
    [anon_sym_match] = ACTIONS(2698),
    [anon_sym_match_BANG] = ACTIONS(2700),
    [anon_sym_function] = ACTIONS(2698),
    [anon_sym_LT_DASH] = ACTIONS(2698),
    [anon_sym_DOT_LBRACK] = ACTIONS(2700),
    [anon_sym_LT] = ACTIONS(2700),
    [anon_sym_GT] = ACTIONS(2698),
    [anon_sym_use] = ACTIONS(2698),
    [anon_sym_use_BANG] = ACTIONS(2700),
    [anon_sym_do_BANG] = ACTIONS(2700),
    [anon_sym_begin] = ACTIONS(2698),
    [anon_sym_LPAREN2] = ACTIONS(2698),
    [anon_sym_or] = ACTIONS(2698),
    [aux_sym_char_token1] = ACTIONS(2700),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2698),
    [anon_sym_DQUOTE] = ACTIONS(2698),
    [anon_sym_AT_DQUOTE] = ACTIONS(2700),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2700),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2700),
    [sym_bool] = ACTIONS(2698),
    [sym_unit] = ACTIONS(2700),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2698),
    [sym_op_identifier] = ACTIONS(2698),
    [anon_sym_PLUS] = ACTIONS(2698),
    [anon_sym_DASH] = ACTIONS(2698),
    [anon_sym_PLUS_DOT] = ACTIONS(2698),
    [anon_sym_DASH_DOT] = ACTIONS(2698),
    [anon_sym_PERCENT] = ACTIONS(2698),
    [anon_sym_AMP_AMP] = ACTIONS(2698),
    [anon_sym_TILDE] = ACTIONS(2700),
    [aux_sym_prefix_op_token1] = ACTIONS(2698),
    [aux_sym_infix_op_token1] = ACTIONS(2700),
    [aux_sym_infix_op_token2] = ACTIONS(2698),
    [anon_sym_PIPE_PIPE] = ACTIONS(2698),
    [anon_sym_BANG_EQ] = ACTIONS(2698),
    [anon_sym_COLON_EQ] = ACTIONS(2700),
    [anon_sym_DOLLAR] = ACTIONS(2698),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2698),
    [sym_int] = ACTIONS(2698),
    [sym_xint] = ACTIONS(2700),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2700),
    [sym__newline] = ACTIONS(3777),
  },
  [1532] = {
    [sym_block_comment] = STATE(1532),
    [sym_compiler_directive_decl] = STATE(1532),
    [sym_fsi_directive_decl] = STATE(1532),
    [sym_preproc_line] = STATE(1532),
    [sym_identifier] = ACTIONS(2685),
    [anon_sym_EQ] = ACTIONS(2687),
    [anon_sym_COLON] = ACTIONS(2685),
    [anon_sym_return] = ACTIONS(2685),
    [anon_sym_do] = ACTIONS(2685),
    [anon_sym_and] = ACTIONS(2685),
    [anon_sym_let] = ACTIONS(2685),
    [anon_sym_let_BANG] = ACTIONS(2687),
    [anon_sym_LPAREN] = ACTIONS(2685),
    [anon_sym_COMMA] = ACTIONS(2687),
    [anon_sym_null] = ACTIONS(2685),
    [anon_sym_QMARK] = ACTIONS(2685),
    [anon_sym_COLON_QMARK] = ACTIONS(2685),
    [anon_sym_COLON_COLON] = ACTIONS(2687),
    [anon_sym_PIPE] = ACTIONS(2685),
    [anon_sym_AMP] = ACTIONS(2685),
    [anon_sym_LBRACK] = ACTIONS(2685),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2687),
    [anon_sym_LBRACE] = ACTIONS(2685),
    [anon_sym_LT_AT] = ACTIONS(2685),
    [anon_sym_LT_AT_AT] = ACTIONS(2685),
    [anon_sym_DOT] = ACTIONS(2685),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2687),
    [anon_sym_new] = ACTIONS(2685),
    [anon_sym_return_BANG] = ACTIONS(2687),
    [anon_sym_yield] = ACTIONS(2685),
    [anon_sym_yield_BANG] = ACTIONS(2687),
    [anon_sym_lazy] = ACTIONS(2685),
    [anon_sym_assert] = ACTIONS(2685),
    [anon_sym_upcast] = ACTIONS(2685),
    [anon_sym_downcast] = ACTIONS(2685),
    [anon_sym_COLON_GT] = ACTIONS(2687),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2687),
    [anon_sym_for] = ACTIONS(2685),
    [anon_sym_while] = ACTIONS(2685),
    [anon_sym_if] = ACTIONS(2685),
    [anon_sym_fun] = ACTIONS(2685),
    [anon_sym_try] = ACTIONS(2685),
    [anon_sym_match] = ACTIONS(2685),
    [anon_sym_match_BANG] = ACTIONS(2687),
    [anon_sym_function] = ACTIONS(2685),
    [anon_sym_LT_DASH] = ACTIONS(2685),
    [anon_sym_DOT_LBRACK] = ACTIONS(2687),
    [anon_sym_LT] = ACTIONS(2687),
    [anon_sym_use] = ACTIONS(2685),
    [anon_sym_use_BANG] = ACTIONS(2687),
    [anon_sym_do_BANG] = ACTIONS(2687),
    [anon_sym_begin] = ACTIONS(2685),
    [anon_sym_LPAREN2] = ACTIONS(2685),
    [anon_sym_or] = ACTIONS(2685),
    [aux_sym_char_token1] = ACTIONS(2687),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2685),
    [anon_sym_DQUOTE] = ACTIONS(2685),
    [anon_sym_AT_DQUOTE] = ACTIONS(2687),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2687),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2687),
    [sym_bool] = ACTIONS(2685),
    [sym_unit] = ACTIONS(2687),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2685),
    [sym_op_identifier] = ACTIONS(2685),
    [anon_sym_PLUS] = ACTIONS(2685),
    [anon_sym_DASH] = ACTIONS(2685),
    [anon_sym_PLUS_DOT] = ACTIONS(2685),
    [anon_sym_DASH_DOT] = ACTIONS(2685),
    [anon_sym_PERCENT] = ACTIONS(2685),
    [anon_sym_AMP_AMP] = ACTIONS(2685),
    [anon_sym_TILDE] = ACTIONS(2687),
    [aux_sym_prefix_op_token1] = ACTIONS(2685),
    [aux_sym_infix_op_token1] = ACTIONS(2687),
    [aux_sym_infix_op_token2] = ACTIONS(2685),
    [anon_sym_PIPE_PIPE] = ACTIONS(2685),
    [anon_sym_BANG_EQ] = ACTIONS(2685),
    [anon_sym_COLON_EQ] = ACTIONS(2687),
    [anon_sym_DOLLAR] = ACTIONS(2685),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2685),
    [sym_int] = ACTIONS(2685),
    [sym_xint] = ACTIONS(2687),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2687),
    [sym__newline] = ACTIONS(2687),
    [sym__dedent] = ACTIONS(2687),
  },
  [1533] = {
    [sym_block_comment] = STATE(1533),
    [sym_compiler_directive_decl] = STATE(1533),
    [sym_fsi_directive_decl] = STATE(1533),
    [sym_preproc_line] = STATE(1533),
    [sym_identifier] = ACTIONS(2770),
    [anon_sym_EQ] = ACTIONS(2772),
    [anon_sym_COLON] = ACTIONS(2770),
    [anon_sym_return] = ACTIONS(2770),
    [anon_sym_do] = ACTIONS(2770),
    [anon_sym_let] = ACTIONS(2770),
    [anon_sym_let_BANG] = ACTIONS(2772),
    [anon_sym_as] = ACTIONS(2770),
    [anon_sym_LPAREN] = ACTIONS(2770),
    [anon_sym_COMMA] = ACTIONS(2772),
    [anon_sym_null] = ACTIONS(2770),
    [anon_sym_QMARK] = ACTIONS(2770),
    [anon_sym_COLON_QMARK] = ACTIONS(2770),
    [anon_sym_COLON_COLON] = ACTIONS(2772),
    [anon_sym_AMP] = ACTIONS(2770),
    [anon_sym_LBRACK] = ACTIONS(2770),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2772),
    [anon_sym_LBRACE] = ACTIONS(2770),
    [anon_sym_LT_AT] = ACTIONS(2770),
    [anon_sym_LT_AT_AT] = ACTIONS(2770),
    [anon_sym_DOT] = ACTIONS(2770),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2772),
    [anon_sym_new] = ACTIONS(2770),
    [anon_sym_with] = ACTIONS(2770),
    [anon_sym_return_BANG] = ACTIONS(2772),
    [anon_sym_yield] = ACTIONS(2770),
    [anon_sym_yield_BANG] = ACTIONS(2772),
    [anon_sym_lazy] = ACTIONS(2770),
    [anon_sym_assert] = ACTIONS(2770),
    [anon_sym_upcast] = ACTIONS(2770),
    [anon_sym_downcast] = ACTIONS(2770),
    [anon_sym_COLON_GT] = ACTIONS(2772),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2772),
    [anon_sym_for] = ACTIONS(2770),
    [anon_sym_done] = ACTIONS(3786),
    [anon_sym_while] = ACTIONS(2770),
    [anon_sym_if] = ACTIONS(2770),
    [anon_sym_fun] = ACTIONS(2770),
    [anon_sym_try] = ACTIONS(2770),
    [anon_sym_match] = ACTIONS(2770),
    [anon_sym_match_BANG] = ACTIONS(2772),
    [anon_sym_function] = ACTIONS(2770),
    [anon_sym_LT_DASH] = ACTIONS(2770),
    [anon_sym_DOT_LBRACK] = ACTIONS(2772),
    [anon_sym_LT] = ACTIONS(2772),
    [anon_sym_use] = ACTIONS(2770),
    [anon_sym_use_BANG] = ACTIONS(2772),
    [anon_sym_do_BANG] = ACTIONS(2772),
    [anon_sym_begin] = ACTIONS(2770),
    [anon_sym_LPAREN2] = ACTIONS(2770),
    [anon_sym_or] = ACTIONS(2770),
    [aux_sym_char_token1] = ACTIONS(2772),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2770),
    [anon_sym_DQUOTE] = ACTIONS(2770),
    [anon_sym_AT_DQUOTE] = ACTIONS(2772),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2772),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2772),
    [sym_bool] = ACTIONS(2770),
    [sym_unit] = ACTIONS(2772),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2770),
    [sym_op_identifier] = ACTIONS(2770),
    [anon_sym_PLUS] = ACTIONS(2770),
    [anon_sym_DASH] = ACTIONS(2770),
    [anon_sym_PLUS_DOT] = ACTIONS(2770),
    [anon_sym_DASH_DOT] = ACTIONS(2770),
    [anon_sym_PERCENT] = ACTIONS(2770),
    [anon_sym_AMP_AMP] = ACTIONS(2770),
    [anon_sym_TILDE] = ACTIONS(2772),
    [aux_sym_prefix_op_token1] = ACTIONS(2770),
    [aux_sym_infix_op_token1] = ACTIONS(2772),
    [aux_sym_infix_op_token2] = ACTIONS(2770),
    [anon_sym_PIPE_PIPE] = ACTIONS(2770),
    [anon_sym_BANG_EQ] = ACTIONS(2770),
    [anon_sym_COLON_EQ] = ACTIONS(2772),
    [anon_sym_DOLLAR] = ACTIONS(2770),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2770),
    [sym_int] = ACTIONS(2770),
    [sym_xint] = ACTIONS(2772),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2772),
    [sym__newline] = ACTIONS(2772),
  },
  [1534] = {
    [sym_block_comment] = STATE(1534),
    [sym_compiler_directive_decl] = STATE(1534),
    [sym_fsi_directive_decl] = STATE(1534),
    [sym_preproc_line] = STATE(1534),
    [sym_identifier] = ACTIONS(2729),
    [anon_sym_EQ] = ACTIONS(2731),
    [anon_sym_COLON] = ACTIONS(2729),
    [anon_sym_return] = ACTIONS(2729),
    [anon_sym_do] = ACTIONS(2729),
    [anon_sym_let] = ACTIONS(2729),
    [anon_sym_let_BANG] = ACTIONS(2731),
    [anon_sym_LPAREN] = ACTIONS(2729),
    [anon_sym_COMMA] = ACTIONS(2731),
    [anon_sym_null] = ACTIONS(2729),
    [anon_sym_QMARK] = ACTIONS(2729),
    [anon_sym_COLON_QMARK] = ACTIONS(2729),
    [anon_sym_COLON_COLON] = ACTIONS(2731),
    [anon_sym_AMP] = ACTIONS(2729),
    [anon_sym_LBRACK] = ACTIONS(2729),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2731),
    [anon_sym_LBRACE] = ACTIONS(2729),
    [anon_sym_LT_AT] = ACTIONS(2729),
    [anon_sym_LT_AT_AT] = ACTIONS(2729),
    [anon_sym_DOT] = ACTIONS(2729),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2731),
    [anon_sym_new] = ACTIONS(2729),
    [anon_sym_return_BANG] = ACTIONS(2731),
    [anon_sym_yield] = ACTIONS(2729),
    [anon_sym_yield_BANG] = ACTIONS(2731),
    [anon_sym_lazy] = ACTIONS(2729),
    [anon_sym_assert] = ACTIONS(2729),
    [anon_sym_upcast] = ACTIONS(2729),
    [anon_sym_downcast] = ACTIONS(2729),
    [anon_sym_COLON_GT] = ACTIONS(2731),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2731),
    [anon_sym_for] = ACTIONS(2729),
    [anon_sym_while] = ACTIONS(2729),
    [anon_sym_else] = ACTIONS(2729),
    [anon_sym_elif] = ACTIONS(2729),
    [anon_sym_if] = ACTIONS(2729),
    [anon_sym_fun] = ACTIONS(2729),
    [anon_sym_try] = ACTIONS(2729),
    [anon_sym_match] = ACTIONS(2729),
    [anon_sym_match_BANG] = ACTIONS(2731),
    [anon_sym_function] = ACTIONS(2729),
    [anon_sym_LT_DASH] = ACTIONS(2729),
    [anon_sym_DOT_LBRACK] = ACTIONS(2731),
    [anon_sym_LT] = ACTIONS(2731),
    [anon_sym_use] = ACTIONS(2729),
    [anon_sym_use_BANG] = ACTIONS(2731),
    [anon_sym_do_BANG] = ACTIONS(2731),
    [anon_sym_begin] = ACTIONS(2729),
    [anon_sym_LPAREN2] = ACTIONS(2729),
    [anon_sym_or] = ACTIONS(2729),
    [aux_sym_char_token1] = ACTIONS(2731),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2729),
    [anon_sym_DQUOTE] = ACTIONS(2729),
    [anon_sym_AT_DQUOTE] = ACTIONS(2731),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2731),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2731),
    [sym_bool] = ACTIONS(2729),
    [sym_unit] = ACTIONS(2731),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2729),
    [sym_op_identifier] = ACTIONS(2729),
    [anon_sym_PLUS] = ACTIONS(2729),
    [anon_sym_DASH] = ACTIONS(2729),
    [anon_sym_PLUS_DOT] = ACTIONS(2729),
    [anon_sym_DASH_DOT] = ACTIONS(2729),
    [anon_sym_PERCENT] = ACTIONS(2729),
    [anon_sym_AMP_AMP] = ACTIONS(2729),
    [anon_sym_TILDE] = ACTIONS(2731),
    [aux_sym_prefix_op_token1] = ACTIONS(2729),
    [aux_sym_infix_op_token1] = ACTIONS(2731),
    [aux_sym_infix_op_token2] = ACTIONS(2729),
    [anon_sym_PIPE_PIPE] = ACTIONS(2729),
    [anon_sym_BANG_EQ] = ACTIONS(2729),
    [anon_sym_COLON_EQ] = ACTIONS(2731),
    [anon_sym_DOLLAR] = ACTIONS(2729),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2729),
    [sym_int] = ACTIONS(2729),
    [sym_xint] = ACTIONS(2731),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2731),
    [anon_sym_POUNDendif] = ACTIONS(2731),
    [sym__newline] = ACTIONS(2731),
  },
  [1535] = {
    [sym_block_comment] = STATE(1535),
    [sym_compiler_directive_decl] = STATE(1535),
    [sym_fsi_directive_decl] = STATE(1535),
    [sym_preproc_line] = STATE(1535),
    [sym_identifier] = ACTIONS(2685),
    [anon_sym_EQ] = ACTIONS(2687),
    [anon_sym_COLON] = ACTIONS(2685),
    [anon_sym_return] = ACTIONS(2685),
    [anon_sym_do] = ACTIONS(2685),
    [anon_sym_let] = ACTIONS(2685),
    [anon_sym_let_BANG] = ACTIONS(2687),
    [anon_sym_as] = ACTIONS(2685),
    [anon_sym_LPAREN] = ACTIONS(2685),
    [anon_sym_COMMA] = ACTIONS(2687),
    [anon_sym_null] = ACTIONS(2685),
    [anon_sym_QMARK] = ACTIONS(2685),
    [anon_sym_COLON_QMARK] = ACTIONS(2685),
    [anon_sym_COLON_COLON] = ACTIONS(2687),
    [anon_sym_PIPE] = ACTIONS(2685),
    [anon_sym_AMP] = ACTIONS(2685),
    [anon_sym_LBRACK] = ACTIONS(2685),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2687),
    [anon_sym_LBRACE] = ACTIONS(2685),
    [anon_sym_LT_AT] = ACTIONS(2685),
    [anon_sym_LT_AT_AT] = ACTIONS(2685),
    [anon_sym_DOT] = ACTIONS(2685),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2687),
    [anon_sym_new] = ACTIONS(2685),
    [anon_sym_with] = ACTIONS(2685),
    [anon_sym_return_BANG] = ACTIONS(2687),
    [anon_sym_yield] = ACTIONS(2685),
    [anon_sym_yield_BANG] = ACTIONS(2687),
    [anon_sym_lazy] = ACTIONS(2685),
    [anon_sym_assert] = ACTIONS(2685),
    [anon_sym_upcast] = ACTIONS(2685),
    [anon_sym_downcast] = ACTIONS(2685),
    [anon_sym_COLON_GT] = ACTIONS(2687),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2687),
    [anon_sym_for] = ACTIONS(2685),
    [anon_sym_while] = ACTIONS(2685),
    [anon_sym_if] = ACTIONS(2685),
    [anon_sym_fun] = ACTIONS(2685),
    [anon_sym_try] = ACTIONS(2685),
    [anon_sym_match] = ACTIONS(2685),
    [anon_sym_match_BANG] = ACTIONS(2687),
    [anon_sym_function] = ACTIONS(2685),
    [anon_sym_LT_DASH] = ACTIONS(2685),
    [anon_sym_DOT_LBRACK] = ACTIONS(2687),
    [anon_sym_LT] = ACTIONS(2687),
    [anon_sym_use] = ACTIONS(2685),
    [anon_sym_use_BANG] = ACTIONS(2687),
    [anon_sym_do_BANG] = ACTIONS(2687),
    [anon_sym_begin] = ACTIONS(2685),
    [anon_sym_LPAREN2] = ACTIONS(2685),
    [anon_sym_or] = ACTIONS(2685),
    [aux_sym_char_token1] = ACTIONS(2687),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2685),
    [anon_sym_DQUOTE] = ACTIONS(2685),
    [anon_sym_AT_DQUOTE] = ACTIONS(2687),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2687),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2687),
    [sym_bool] = ACTIONS(2685),
    [sym_unit] = ACTIONS(2687),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2685),
    [sym_op_identifier] = ACTIONS(2685),
    [anon_sym_PLUS] = ACTIONS(2685),
    [anon_sym_DASH] = ACTIONS(2685),
    [anon_sym_PLUS_DOT] = ACTIONS(2685),
    [anon_sym_DASH_DOT] = ACTIONS(2685),
    [anon_sym_PERCENT] = ACTIONS(2685),
    [anon_sym_AMP_AMP] = ACTIONS(2685),
    [anon_sym_TILDE] = ACTIONS(2687),
    [aux_sym_prefix_op_token1] = ACTIONS(2685),
    [aux_sym_infix_op_token1] = ACTIONS(2687),
    [aux_sym_infix_op_token2] = ACTIONS(2685),
    [anon_sym_PIPE_PIPE] = ACTIONS(2685),
    [anon_sym_BANG_EQ] = ACTIONS(2685),
    [anon_sym_COLON_EQ] = ACTIONS(2687),
    [anon_sym_DOLLAR] = ACTIONS(2685),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2685),
    [sym_int] = ACTIONS(2685),
    [sym_xint] = ACTIONS(2687),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2687),
    [sym__newline] = ACTIONS(2687),
  },
  [1536] = {
    [sym_block_comment] = STATE(1536),
    [sym_compiler_directive_decl] = STATE(1536),
    [sym_fsi_directive_decl] = STATE(1536),
    [sym_preproc_line] = STATE(1536),
    [sym_identifier] = ACTIONS(2887),
    [anon_sym_EQ] = ACTIONS(2889),
    [anon_sym_COLON] = ACTIONS(2887),
    [anon_sym_return] = ACTIONS(2887),
    [anon_sym_do] = ACTIONS(2887),
    [anon_sym_let] = ACTIONS(2887),
    [anon_sym_let_BANG] = ACTIONS(2889),
    [anon_sym_as] = ACTIONS(2887),
    [anon_sym_LPAREN] = ACTIONS(2887),
    [anon_sym_COMMA] = ACTIONS(2889),
    [anon_sym_null] = ACTIONS(2887),
    [anon_sym_QMARK] = ACTIONS(2887),
    [anon_sym_COLON_QMARK] = ACTIONS(2887),
    [anon_sym_COLON_COLON] = ACTIONS(2889),
    [anon_sym_AMP] = ACTIONS(2887),
    [anon_sym_LBRACK] = ACTIONS(2887),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2889),
    [anon_sym_LBRACE] = ACTIONS(2887),
    [anon_sym_LT_AT] = ACTIONS(2887),
    [anon_sym_LT_AT_AT] = ACTIONS(2887),
    [anon_sym_DOT] = ACTIONS(2887),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2889),
    [anon_sym_new] = ACTIONS(2887),
    [anon_sym_with] = ACTIONS(2887),
    [anon_sym_return_BANG] = ACTIONS(2889),
    [anon_sym_yield] = ACTIONS(2887),
    [anon_sym_yield_BANG] = ACTIONS(2889),
    [anon_sym_lazy] = ACTIONS(2887),
    [anon_sym_assert] = ACTIONS(2887),
    [anon_sym_upcast] = ACTIONS(2887),
    [anon_sym_downcast] = ACTIONS(2887),
    [anon_sym_COLON_GT] = ACTIONS(2889),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2889),
    [anon_sym_for] = ACTIONS(2887),
    [anon_sym_while] = ACTIONS(2887),
    [anon_sym_if] = ACTIONS(2887),
    [anon_sym_fun] = ACTIONS(2887),
    [anon_sym_try] = ACTIONS(2887),
    [anon_sym_match] = ACTIONS(2887),
    [anon_sym_match_BANG] = ACTIONS(2889),
    [anon_sym_function] = ACTIONS(2887),
    [anon_sym_LT_DASH] = ACTIONS(2887),
    [anon_sym_DOT_LBRACK] = ACTIONS(2889),
    [anon_sym_LT] = ACTIONS(2889),
    [anon_sym_use] = ACTIONS(2887),
    [anon_sym_use_BANG] = ACTIONS(2889),
    [anon_sym_do_BANG] = ACTIONS(2889),
    [anon_sym_begin] = ACTIONS(2887),
    [anon_sym_LPAREN2] = ACTIONS(2887),
    [anon_sym_or] = ACTIONS(2887),
    [aux_sym_char_token1] = ACTIONS(2889),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2887),
    [anon_sym_DQUOTE] = ACTIONS(2887),
    [anon_sym_AT_DQUOTE] = ACTIONS(2889),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2889),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2889),
    [sym_bool] = ACTIONS(2887),
    [sym_unit] = ACTIONS(2889),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2887),
    [sym_op_identifier] = ACTIONS(2887),
    [anon_sym_PLUS] = ACTIONS(2887),
    [anon_sym_DASH] = ACTIONS(2887),
    [anon_sym_PLUS_DOT] = ACTIONS(2887),
    [anon_sym_DASH_DOT] = ACTIONS(2887),
    [anon_sym_PERCENT] = ACTIONS(2887),
    [anon_sym_AMP_AMP] = ACTIONS(2887),
    [anon_sym_TILDE] = ACTIONS(2889),
    [aux_sym_prefix_op_token1] = ACTIONS(2887),
    [aux_sym_infix_op_token1] = ACTIONS(2889),
    [aux_sym_infix_op_token2] = ACTIONS(2887),
    [anon_sym_PIPE_PIPE] = ACTIONS(2887),
    [anon_sym_BANG_EQ] = ACTIONS(2887),
    [anon_sym_COLON_EQ] = ACTIONS(2889),
    [anon_sym_DOLLAR] = ACTIONS(2887),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2887),
    [sym_int] = ACTIONS(2887),
    [sym_xint] = ACTIONS(2889),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2889),
    [sym__newline] = ACTIONS(2889),
    [sym__dedent] = ACTIONS(2889),
  },
  [1537] = {
    [sym_block_comment] = STATE(1537),
    [sym_compiler_directive_decl] = STATE(1537),
    [sym_fsi_directive_decl] = STATE(1537),
    [sym_preproc_line] = STATE(1537),
    [sym_identifier] = ACTIONS(2851),
    [anon_sym_EQ] = ACTIONS(2853),
    [anon_sym_COLON] = ACTIONS(2851),
    [anon_sym_return] = ACTIONS(2851),
    [anon_sym_do] = ACTIONS(2851),
    [anon_sym_let] = ACTIONS(2851),
    [anon_sym_let_BANG] = ACTIONS(2853),
    [anon_sym_as] = ACTIONS(2851),
    [anon_sym_LPAREN] = ACTIONS(2851),
    [anon_sym_COMMA] = ACTIONS(2853),
    [anon_sym_null] = ACTIONS(2851),
    [anon_sym_QMARK] = ACTIONS(2851),
    [anon_sym_COLON_QMARK] = ACTIONS(2851),
    [anon_sym_COLON_COLON] = ACTIONS(2853),
    [anon_sym_AMP] = ACTIONS(2851),
    [anon_sym_LBRACK] = ACTIONS(2851),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2853),
    [anon_sym_LBRACE] = ACTIONS(2851),
    [anon_sym_LT_AT] = ACTIONS(2851),
    [anon_sym_LT_AT_AT] = ACTIONS(2851),
    [anon_sym_DOT] = ACTIONS(2851),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2853),
    [anon_sym_new] = ACTIONS(2851),
    [anon_sym_with] = ACTIONS(2851),
    [anon_sym_return_BANG] = ACTIONS(2853),
    [anon_sym_yield] = ACTIONS(2851),
    [anon_sym_yield_BANG] = ACTIONS(2853),
    [anon_sym_lazy] = ACTIONS(2851),
    [anon_sym_assert] = ACTIONS(2851),
    [anon_sym_upcast] = ACTIONS(2851),
    [anon_sym_downcast] = ACTIONS(2851),
    [anon_sym_COLON_GT] = ACTIONS(2853),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2853),
    [anon_sym_for] = ACTIONS(2851),
    [anon_sym_while] = ACTIONS(2851),
    [anon_sym_if] = ACTIONS(2851),
    [anon_sym_fun] = ACTIONS(2851),
    [anon_sym_try] = ACTIONS(2851),
    [anon_sym_match] = ACTIONS(2851),
    [anon_sym_match_BANG] = ACTIONS(2853),
    [anon_sym_function] = ACTIONS(2851),
    [anon_sym_LT_DASH] = ACTIONS(2851),
    [anon_sym_DOT_LBRACK] = ACTIONS(2853),
    [anon_sym_LT] = ACTIONS(2853),
    [anon_sym_use] = ACTIONS(2851),
    [anon_sym_use_BANG] = ACTIONS(2853),
    [anon_sym_do_BANG] = ACTIONS(2853),
    [anon_sym_begin] = ACTIONS(2851),
    [anon_sym_LPAREN2] = ACTIONS(2851),
    [anon_sym_or] = ACTIONS(2851),
    [aux_sym_char_token1] = ACTIONS(2853),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2851),
    [anon_sym_DQUOTE] = ACTIONS(2851),
    [anon_sym_AT_DQUOTE] = ACTIONS(2853),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2853),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2853),
    [sym_bool] = ACTIONS(2851),
    [sym_unit] = ACTIONS(2853),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2851),
    [sym_op_identifier] = ACTIONS(2851),
    [anon_sym_PLUS] = ACTIONS(2851),
    [anon_sym_DASH] = ACTIONS(2851),
    [anon_sym_PLUS_DOT] = ACTIONS(2851),
    [anon_sym_DASH_DOT] = ACTIONS(2851),
    [anon_sym_PERCENT] = ACTIONS(2851),
    [anon_sym_AMP_AMP] = ACTIONS(2851),
    [anon_sym_TILDE] = ACTIONS(2853),
    [aux_sym_prefix_op_token1] = ACTIONS(2851),
    [aux_sym_infix_op_token1] = ACTIONS(2853),
    [aux_sym_infix_op_token2] = ACTIONS(2851),
    [anon_sym_PIPE_PIPE] = ACTIONS(2851),
    [anon_sym_BANG_EQ] = ACTIONS(2851),
    [anon_sym_COLON_EQ] = ACTIONS(2853),
    [anon_sym_DOLLAR] = ACTIONS(2851),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2851),
    [sym_int] = ACTIONS(2851),
    [sym_xint] = ACTIONS(2853),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2853),
    [sym__newline] = ACTIONS(2853),
    [sym__dedent] = ACTIONS(2853),
  },
  [1538] = {
    [sym_block_comment] = STATE(1538),
    [sym_compiler_directive_decl] = STATE(1538),
    [sym_fsi_directive_decl] = STATE(1538),
    [sym_preproc_line] = STATE(1538),
    [sym_identifier] = ACTIONS(2839),
    [anon_sym_EQ] = ACTIONS(2841),
    [anon_sym_COLON] = ACTIONS(2839),
    [anon_sym_return] = ACTIONS(2839),
    [anon_sym_do] = ACTIONS(2839),
    [anon_sym_let] = ACTIONS(2839),
    [anon_sym_let_BANG] = ACTIONS(2841),
    [anon_sym_as] = ACTIONS(2839),
    [anon_sym_LPAREN] = ACTIONS(2839),
    [anon_sym_COMMA] = ACTIONS(2841),
    [anon_sym_null] = ACTIONS(2839),
    [anon_sym_QMARK] = ACTIONS(2839),
    [anon_sym_COLON_QMARK] = ACTIONS(2839),
    [anon_sym_COLON_COLON] = ACTIONS(2841),
    [anon_sym_AMP] = ACTIONS(2839),
    [anon_sym_LBRACK] = ACTIONS(2839),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2841),
    [anon_sym_LBRACE] = ACTIONS(2839),
    [anon_sym_LT_AT] = ACTIONS(2839),
    [anon_sym_LT_AT_AT] = ACTIONS(2839),
    [anon_sym_DOT] = ACTIONS(2839),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2841),
    [anon_sym_new] = ACTIONS(2839),
    [anon_sym_with] = ACTIONS(2839),
    [anon_sym_return_BANG] = ACTIONS(2841),
    [anon_sym_yield] = ACTIONS(2839),
    [anon_sym_yield_BANG] = ACTIONS(2841),
    [anon_sym_lazy] = ACTIONS(2839),
    [anon_sym_assert] = ACTIONS(2839),
    [anon_sym_upcast] = ACTIONS(2839),
    [anon_sym_downcast] = ACTIONS(2839),
    [anon_sym_COLON_GT] = ACTIONS(2841),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2841),
    [anon_sym_for] = ACTIONS(2839),
    [anon_sym_while] = ACTIONS(2839),
    [anon_sym_if] = ACTIONS(2839),
    [anon_sym_fun] = ACTIONS(2839),
    [anon_sym_try] = ACTIONS(2839),
    [anon_sym_match] = ACTIONS(2839),
    [anon_sym_match_BANG] = ACTIONS(2841),
    [anon_sym_function] = ACTIONS(2839),
    [anon_sym_LT_DASH] = ACTIONS(2839),
    [anon_sym_DOT_LBRACK] = ACTIONS(2841),
    [anon_sym_LT] = ACTIONS(2841),
    [anon_sym_use] = ACTIONS(2839),
    [anon_sym_use_BANG] = ACTIONS(2841),
    [anon_sym_do_BANG] = ACTIONS(2841),
    [anon_sym_begin] = ACTIONS(2839),
    [anon_sym_LPAREN2] = ACTIONS(2839),
    [anon_sym_or] = ACTIONS(2839),
    [aux_sym_char_token1] = ACTIONS(2841),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2839),
    [anon_sym_DQUOTE] = ACTIONS(2839),
    [anon_sym_AT_DQUOTE] = ACTIONS(2841),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2841),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2841),
    [sym_bool] = ACTIONS(2839),
    [sym_unit] = ACTIONS(2841),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2839),
    [sym_op_identifier] = ACTIONS(2839),
    [anon_sym_PLUS] = ACTIONS(2839),
    [anon_sym_DASH] = ACTIONS(2839),
    [anon_sym_PLUS_DOT] = ACTIONS(2839),
    [anon_sym_DASH_DOT] = ACTIONS(2839),
    [anon_sym_PERCENT] = ACTIONS(2839),
    [anon_sym_AMP_AMP] = ACTIONS(2839),
    [anon_sym_TILDE] = ACTIONS(2841),
    [aux_sym_prefix_op_token1] = ACTIONS(2839),
    [aux_sym_infix_op_token1] = ACTIONS(2841),
    [aux_sym_infix_op_token2] = ACTIONS(2839),
    [anon_sym_PIPE_PIPE] = ACTIONS(2839),
    [anon_sym_BANG_EQ] = ACTIONS(2839),
    [anon_sym_COLON_EQ] = ACTIONS(2841),
    [anon_sym_DOLLAR] = ACTIONS(2839),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2839),
    [sym_int] = ACTIONS(2839),
    [sym_xint] = ACTIONS(2841),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2841),
    [sym__newline] = ACTIONS(2841),
    [sym__dedent] = ACTIONS(2841),
  },
  [1539] = {
    [sym_block_comment] = STATE(1539),
    [sym_compiler_directive_decl] = STATE(1539),
    [sym_fsi_directive_decl] = STATE(1539),
    [sym_preproc_line] = STATE(1539),
    [sym_identifier] = ACTIONS(2685),
    [anon_sym_EQ] = ACTIONS(2687),
    [anon_sym_COLON] = ACTIONS(2685),
    [anon_sym_return] = ACTIONS(2685),
    [anon_sym_do] = ACTIONS(2685),
    [anon_sym_let] = ACTIONS(2685),
    [anon_sym_let_BANG] = ACTIONS(2687),
    [anon_sym_LPAREN] = ACTIONS(2685),
    [anon_sym_COMMA] = ACTIONS(2687),
    [anon_sym_null] = ACTIONS(2685),
    [anon_sym_QMARK] = ACTIONS(2685),
    [anon_sym_COLON_QMARK] = ACTIONS(2685),
    [anon_sym_COLON_COLON] = ACTIONS(2687),
    [anon_sym_AMP] = ACTIONS(2685),
    [anon_sym_LBRACK] = ACTIONS(2685),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2687),
    [anon_sym_LBRACE] = ACTIONS(2685),
    [anon_sym_LT_AT] = ACTIONS(2685),
    [anon_sym_LT_AT_AT] = ACTIONS(2685),
    [anon_sym_AT_AT_GT] = ACTIONS(2685),
    [anon_sym_DOT] = ACTIONS(2685),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2687),
    [anon_sym_new] = ACTIONS(2685),
    [anon_sym_return_BANG] = ACTIONS(2687),
    [anon_sym_yield] = ACTIONS(2685),
    [anon_sym_yield_BANG] = ACTIONS(2687),
    [anon_sym_lazy] = ACTIONS(2685),
    [anon_sym_assert] = ACTIONS(2685),
    [anon_sym_upcast] = ACTIONS(2685),
    [anon_sym_downcast] = ACTIONS(2685),
    [anon_sym_COLON_GT] = ACTIONS(2687),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2687),
    [anon_sym_for] = ACTIONS(2685),
    [anon_sym_done] = ACTIONS(2685),
    [anon_sym_while] = ACTIONS(2685),
    [anon_sym_if] = ACTIONS(2685),
    [anon_sym_fun] = ACTIONS(2685),
    [anon_sym_try] = ACTIONS(2685),
    [anon_sym_match] = ACTIONS(2685),
    [anon_sym_match_BANG] = ACTIONS(2687),
    [anon_sym_function] = ACTIONS(2685),
    [anon_sym_LT_DASH] = ACTIONS(2685),
    [anon_sym_DOT_LBRACK] = ACTIONS(2687),
    [anon_sym_LT] = ACTIONS(2687),
    [anon_sym_use] = ACTIONS(2685),
    [anon_sym_use_BANG] = ACTIONS(2687),
    [anon_sym_do_BANG] = ACTIONS(2687),
    [anon_sym_DOT_DOT] = ACTIONS(2687),
    [anon_sym_begin] = ACTIONS(2685),
    [anon_sym_LPAREN2] = ACTIONS(2685),
    [anon_sym_or] = ACTIONS(2685),
    [aux_sym_char_token1] = ACTIONS(2687),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2685),
    [anon_sym_DQUOTE] = ACTIONS(2685),
    [anon_sym_AT_DQUOTE] = ACTIONS(2687),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2687),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2687),
    [sym_bool] = ACTIONS(2685),
    [sym_unit] = ACTIONS(2687),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2685),
    [sym_op_identifier] = ACTIONS(2685),
    [anon_sym_PLUS] = ACTIONS(2685),
    [anon_sym_DASH] = ACTIONS(2685),
    [anon_sym_PLUS_DOT] = ACTIONS(2685),
    [anon_sym_DASH_DOT] = ACTIONS(2685),
    [anon_sym_PERCENT] = ACTIONS(2685),
    [anon_sym_AMP_AMP] = ACTIONS(2685),
    [anon_sym_TILDE] = ACTIONS(2687),
    [aux_sym_prefix_op_token1] = ACTIONS(2685),
    [aux_sym_infix_op_token1] = ACTIONS(2687),
    [aux_sym_infix_op_token2] = ACTIONS(2685),
    [anon_sym_PIPE_PIPE] = ACTIONS(2685),
    [anon_sym_BANG_EQ] = ACTIONS(2685),
    [anon_sym_COLON_EQ] = ACTIONS(2687),
    [anon_sym_DOLLAR] = ACTIONS(2685),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2685),
    [sym_int] = ACTIONS(2685),
    [sym_xint] = ACTIONS(2687),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2687),
    [sym__newline] = ACTIONS(2687),
  },
  [1540] = {
    [sym_block_comment] = STATE(1540),
    [sym_compiler_directive_decl] = STATE(1540),
    [sym_fsi_directive_decl] = STATE(1540),
    [sym_preproc_line] = STATE(1540),
    [sym_identifier] = ACTIONS(2685),
    [anon_sym_EQ] = ACTIONS(2687),
    [anon_sym_COLON] = ACTIONS(2685),
    [anon_sym_return] = ACTIONS(2685),
    [anon_sym_do] = ACTIONS(2685),
    [anon_sym_let] = ACTIONS(2685),
    [anon_sym_let_BANG] = ACTIONS(2687),
    [anon_sym_LPAREN] = ACTIONS(2685),
    [anon_sym_COMMA] = ACTIONS(2687),
    [anon_sym_null] = ACTIONS(2685),
    [anon_sym_QMARK] = ACTIONS(2685),
    [anon_sym_COLON_QMARK] = ACTIONS(2685),
    [anon_sym_COLON_COLON] = ACTIONS(2687),
    [anon_sym_AMP] = ACTIONS(2685),
    [anon_sym_LBRACK] = ACTIONS(2685),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2687),
    [anon_sym_LBRACE] = ACTIONS(2685),
    [anon_sym_LT_AT] = ACTIONS(2685),
    [anon_sym_LT_AT_AT] = ACTIONS(2685),
    [anon_sym_DOT] = ACTIONS(2685),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2687),
    [anon_sym_new] = ACTIONS(2685),
    [anon_sym_return_BANG] = ACTIONS(2687),
    [anon_sym_yield] = ACTIONS(2685),
    [anon_sym_yield_BANG] = ACTIONS(2687),
    [anon_sym_lazy] = ACTIONS(2685),
    [anon_sym_assert] = ACTIONS(2685),
    [anon_sym_upcast] = ACTIONS(2685),
    [anon_sym_downcast] = ACTIONS(2685),
    [anon_sym_COLON_GT] = ACTIONS(2687),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2687),
    [anon_sym_for] = ACTIONS(2685),
    [anon_sym_while] = ACTIONS(2685),
    [anon_sym_else] = ACTIONS(2685),
    [anon_sym_elif] = ACTIONS(2685),
    [anon_sym_if] = ACTIONS(2685),
    [anon_sym_fun] = ACTIONS(2685),
    [anon_sym_try] = ACTIONS(2685),
    [anon_sym_match] = ACTIONS(2685),
    [anon_sym_match_BANG] = ACTIONS(2687),
    [anon_sym_function] = ACTIONS(2685),
    [anon_sym_LT_DASH] = ACTIONS(2685),
    [anon_sym_DOT_LBRACK] = ACTIONS(2687),
    [anon_sym_LT] = ACTIONS(2687),
    [anon_sym_use] = ACTIONS(2685),
    [anon_sym_use_BANG] = ACTIONS(2687),
    [anon_sym_do_BANG] = ACTIONS(2687),
    [anon_sym_DOT_DOT] = ACTIONS(2687),
    [anon_sym_begin] = ACTIONS(2685),
    [anon_sym_LPAREN2] = ACTIONS(2685),
    [anon_sym_or] = ACTIONS(2685),
    [aux_sym_char_token1] = ACTIONS(2687),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2685),
    [anon_sym_DQUOTE] = ACTIONS(2685),
    [anon_sym_AT_DQUOTE] = ACTIONS(2687),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2687),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2687),
    [sym_bool] = ACTIONS(2685),
    [sym_unit] = ACTIONS(2687),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2685),
    [sym_op_identifier] = ACTIONS(2685),
    [anon_sym_PLUS] = ACTIONS(2685),
    [anon_sym_DASH] = ACTIONS(2685),
    [anon_sym_PLUS_DOT] = ACTIONS(2685),
    [anon_sym_DASH_DOT] = ACTIONS(2685),
    [anon_sym_PERCENT] = ACTIONS(2685),
    [anon_sym_AMP_AMP] = ACTIONS(2685),
    [anon_sym_TILDE] = ACTIONS(2687),
    [aux_sym_prefix_op_token1] = ACTIONS(2685),
    [aux_sym_infix_op_token1] = ACTIONS(2687),
    [aux_sym_infix_op_token2] = ACTIONS(2685),
    [anon_sym_PIPE_PIPE] = ACTIONS(2685),
    [anon_sym_BANG_EQ] = ACTIONS(2685),
    [anon_sym_COLON_EQ] = ACTIONS(2687),
    [anon_sym_DOLLAR] = ACTIONS(2685),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2685),
    [sym_int] = ACTIONS(2685),
    [sym_xint] = ACTIONS(2687),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2687),
    [sym__newline] = ACTIONS(2687),
  },
  [1541] = {
    [sym_block_comment] = STATE(1541),
    [sym_compiler_directive_decl] = STATE(1541),
    [sym_fsi_directive_decl] = STATE(1541),
    [sym_preproc_line] = STATE(1541),
    [sym_identifier] = ACTIONS(2934),
    [anon_sym_EQ] = ACTIONS(2936),
    [anon_sym_COLON] = ACTIONS(2934),
    [anon_sym_return] = ACTIONS(2934),
    [anon_sym_do] = ACTIONS(2934),
    [anon_sym_let] = ACTIONS(2934),
    [anon_sym_let_BANG] = ACTIONS(2936),
    [anon_sym_as] = ACTIONS(2934),
    [anon_sym_LPAREN] = ACTIONS(2934),
    [anon_sym_COMMA] = ACTIONS(2936),
    [anon_sym_null] = ACTIONS(2934),
    [anon_sym_QMARK] = ACTIONS(2934),
    [anon_sym_COLON_QMARK] = ACTIONS(2934),
    [anon_sym_COLON_COLON] = ACTIONS(2936),
    [anon_sym_AMP] = ACTIONS(2934),
    [anon_sym_LBRACK] = ACTIONS(2934),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2936),
    [anon_sym_LBRACE] = ACTIONS(2934),
    [anon_sym_LT_AT] = ACTIONS(2934),
    [anon_sym_LT_AT_AT] = ACTIONS(2934),
    [anon_sym_DOT] = ACTIONS(2934),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2936),
    [anon_sym_new] = ACTIONS(2934),
    [anon_sym_with] = ACTIONS(2934),
    [anon_sym_return_BANG] = ACTIONS(2936),
    [anon_sym_yield] = ACTIONS(2934),
    [anon_sym_yield_BANG] = ACTIONS(2936),
    [anon_sym_lazy] = ACTIONS(2934),
    [anon_sym_assert] = ACTIONS(2934),
    [anon_sym_upcast] = ACTIONS(2934),
    [anon_sym_downcast] = ACTIONS(2934),
    [anon_sym_COLON_GT] = ACTIONS(2936),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2936),
    [anon_sym_for] = ACTIONS(2934),
    [anon_sym_while] = ACTIONS(2934),
    [anon_sym_if] = ACTIONS(2934),
    [anon_sym_fun] = ACTIONS(2934),
    [anon_sym_try] = ACTIONS(2934),
    [anon_sym_match] = ACTIONS(2934),
    [anon_sym_match_BANG] = ACTIONS(2936),
    [anon_sym_function] = ACTIONS(2934),
    [anon_sym_LT_DASH] = ACTIONS(2934),
    [anon_sym_DOT_LBRACK] = ACTIONS(2936),
    [anon_sym_LT] = ACTIONS(2936),
    [anon_sym_use] = ACTIONS(2934),
    [anon_sym_use_BANG] = ACTIONS(2936),
    [anon_sym_do_BANG] = ACTIONS(2936),
    [anon_sym_begin] = ACTIONS(2934),
    [anon_sym_LPAREN2] = ACTIONS(2934),
    [anon_sym_or] = ACTIONS(2934),
    [aux_sym_char_token1] = ACTIONS(2936),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2934),
    [anon_sym_DQUOTE] = ACTIONS(2934),
    [anon_sym_AT_DQUOTE] = ACTIONS(2936),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2936),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2936),
    [sym_bool] = ACTIONS(2934),
    [sym_unit] = ACTIONS(2936),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2934),
    [sym_op_identifier] = ACTIONS(2934),
    [anon_sym_PLUS] = ACTIONS(2934),
    [anon_sym_DASH] = ACTIONS(2934),
    [anon_sym_PLUS_DOT] = ACTIONS(2934),
    [anon_sym_DASH_DOT] = ACTIONS(2934),
    [anon_sym_PERCENT] = ACTIONS(2934),
    [anon_sym_AMP_AMP] = ACTIONS(2934),
    [anon_sym_TILDE] = ACTIONS(2936),
    [aux_sym_prefix_op_token1] = ACTIONS(2934),
    [aux_sym_infix_op_token1] = ACTIONS(2936),
    [aux_sym_infix_op_token2] = ACTIONS(2934),
    [anon_sym_PIPE_PIPE] = ACTIONS(2934),
    [anon_sym_BANG_EQ] = ACTIONS(2934),
    [anon_sym_COLON_EQ] = ACTIONS(2936),
    [anon_sym_DOLLAR] = ACTIONS(2934),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2934),
    [sym_int] = ACTIONS(2934),
    [sym_xint] = ACTIONS(2936),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2936),
    [sym__newline] = ACTIONS(2936),
    [sym__dedent] = ACTIONS(2936),
  },
  [1542] = {
    [sym_block_comment] = STATE(1542),
    [sym_compiler_directive_decl] = STATE(1542),
    [sym_fsi_directive_decl] = STATE(1542),
    [sym_preproc_line] = STATE(1542),
    [aux_sym_sequential_expression_repeat1] = STATE(1504),
    [sym_identifier] = ACTIONS(2847),
    [anon_sym_EQ] = ACTIONS(2849),
    [anon_sym_COLON] = ACTIONS(2847),
    [anon_sym_return] = ACTIONS(2847),
    [anon_sym_do] = ACTIONS(2847),
    [anon_sym_let] = ACTIONS(2847),
    [anon_sym_let_BANG] = ACTIONS(2849),
    [anon_sym_LPAREN] = ACTIONS(2847),
    [anon_sym_COMMA] = ACTIONS(2849),
    [anon_sym_null] = ACTIONS(2847),
    [anon_sym_QMARK] = ACTIONS(2847),
    [anon_sym_COLON_QMARK] = ACTIONS(2847),
    [anon_sym_COLON_COLON] = ACTIONS(2849),
    [anon_sym_AMP] = ACTIONS(2847),
    [anon_sym_LBRACK] = ACTIONS(2847),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2849),
    [anon_sym_LBRACE] = ACTIONS(2847),
    [anon_sym_LT_AT] = ACTIONS(2847),
    [anon_sym_LT_AT_AT] = ACTIONS(2847),
    [anon_sym_DOT] = ACTIONS(2847),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2849),
    [anon_sym_new] = ACTIONS(2847),
    [anon_sym_with] = ACTIONS(2847),
    [anon_sym_return_BANG] = ACTIONS(2849),
    [anon_sym_yield] = ACTIONS(2847),
    [anon_sym_yield_BANG] = ACTIONS(2849),
    [anon_sym_lazy] = ACTIONS(2847),
    [anon_sym_assert] = ACTIONS(2847),
    [anon_sym_upcast] = ACTIONS(2847),
    [anon_sym_downcast] = ACTIONS(2847),
    [anon_sym_COLON_GT] = ACTIONS(2849),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2849),
    [anon_sym_for] = ACTIONS(2847),
    [anon_sym_while] = ACTIONS(2847),
    [anon_sym_if] = ACTIONS(2847),
    [anon_sym_fun] = ACTIONS(2847),
    [anon_sym_try] = ACTIONS(2847),
    [anon_sym_match] = ACTIONS(2847),
    [anon_sym_match_BANG] = ACTIONS(2849),
    [anon_sym_function] = ACTIONS(2847),
    [anon_sym_LT_DASH] = ACTIONS(2847),
    [anon_sym_DOT_LBRACK] = ACTIONS(2849),
    [anon_sym_LT] = ACTIONS(2849),
    [anon_sym_use] = ACTIONS(2847),
    [anon_sym_use_BANG] = ACTIONS(2849),
    [anon_sym_do_BANG] = ACTIONS(2849),
    [anon_sym_begin] = ACTIONS(2847),
    [anon_sym_LPAREN2] = ACTIONS(2847),
    [anon_sym_or] = ACTIONS(2847),
    [aux_sym_char_token1] = ACTIONS(2849),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2847),
    [anon_sym_DQUOTE] = ACTIONS(2847),
    [anon_sym_AT_DQUOTE] = ACTIONS(2849),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2849),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2849),
    [sym_bool] = ACTIONS(2847),
    [sym_unit] = ACTIONS(2849),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2847),
    [sym_op_identifier] = ACTIONS(2847),
    [anon_sym_PLUS] = ACTIONS(2847),
    [anon_sym_DASH] = ACTIONS(2847),
    [anon_sym_PLUS_DOT] = ACTIONS(2847),
    [anon_sym_DASH_DOT] = ACTIONS(2847),
    [anon_sym_PERCENT] = ACTIONS(2847),
    [anon_sym_AMP_AMP] = ACTIONS(2847),
    [anon_sym_TILDE] = ACTIONS(2849),
    [aux_sym_prefix_op_token1] = ACTIONS(2847),
    [aux_sym_infix_op_token1] = ACTIONS(2849),
    [aux_sym_infix_op_token2] = ACTIONS(2847),
    [anon_sym_PIPE_PIPE] = ACTIONS(2847),
    [anon_sym_BANG_EQ] = ACTIONS(2847),
    [anon_sym_COLON_EQ] = ACTIONS(2849),
    [anon_sym_DOLLAR] = ACTIONS(2847),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2847),
    [sym_int] = ACTIONS(2847),
    [sym_xint] = ACTIONS(2849),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2849),
    [sym__newline] = ACTIONS(2849),
    [sym__dedent] = ACTIONS(2849),
  },
  [1543] = {
    [sym_block_comment] = STATE(1543),
    [sym_compiler_directive_decl] = STATE(1543),
    [sym_fsi_directive_decl] = STATE(1543),
    [sym_preproc_line] = STATE(1543),
    [sym_identifier] = ACTIONS(2891),
    [anon_sym_EQ] = ACTIONS(2893),
    [anon_sym_COLON] = ACTIONS(2891),
    [anon_sym_return] = ACTIONS(2891),
    [anon_sym_do] = ACTIONS(2891),
    [anon_sym_let] = ACTIONS(2891),
    [anon_sym_let_BANG] = ACTIONS(2893),
    [anon_sym_as] = ACTIONS(2891),
    [anon_sym_LPAREN] = ACTIONS(2891),
    [anon_sym_COMMA] = ACTIONS(2893),
    [anon_sym_null] = ACTIONS(2891),
    [anon_sym_QMARK] = ACTIONS(2891),
    [anon_sym_COLON_QMARK] = ACTIONS(2891),
    [anon_sym_COLON_COLON] = ACTIONS(2893),
    [anon_sym_AMP] = ACTIONS(2891),
    [anon_sym_LBRACK] = ACTIONS(2891),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2893),
    [anon_sym_LBRACE] = ACTIONS(2891),
    [anon_sym_LT_AT] = ACTIONS(2891),
    [anon_sym_LT_AT_AT] = ACTIONS(2891),
    [anon_sym_DOT] = ACTIONS(2891),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2893),
    [anon_sym_new] = ACTIONS(2891),
    [anon_sym_with] = ACTIONS(2891),
    [anon_sym_return_BANG] = ACTIONS(2893),
    [anon_sym_yield] = ACTIONS(2891),
    [anon_sym_yield_BANG] = ACTIONS(2893),
    [anon_sym_lazy] = ACTIONS(2891),
    [anon_sym_assert] = ACTIONS(2891),
    [anon_sym_upcast] = ACTIONS(2891),
    [anon_sym_downcast] = ACTIONS(2891),
    [anon_sym_COLON_GT] = ACTIONS(2893),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2893),
    [anon_sym_for] = ACTIONS(2891),
    [anon_sym_while] = ACTIONS(2891),
    [anon_sym_if] = ACTIONS(2891),
    [anon_sym_fun] = ACTIONS(2891),
    [anon_sym_try] = ACTIONS(2891),
    [anon_sym_match] = ACTIONS(2891),
    [anon_sym_match_BANG] = ACTIONS(2893),
    [anon_sym_function] = ACTIONS(2891),
    [anon_sym_LT_DASH] = ACTIONS(2891),
    [anon_sym_DOT_LBRACK] = ACTIONS(2893),
    [anon_sym_LT] = ACTIONS(2893),
    [anon_sym_use] = ACTIONS(2891),
    [anon_sym_use_BANG] = ACTIONS(2893),
    [anon_sym_do_BANG] = ACTIONS(2893),
    [anon_sym_begin] = ACTIONS(2891),
    [anon_sym_LPAREN2] = ACTIONS(2891),
    [anon_sym_or] = ACTIONS(2891),
    [aux_sym_char_token1] = ACTIONS(2893),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2891),
    [anon_sym_DQUOTE] = ACTIONS(2891),
    [anon_sym_AT_DQUOTE] = ACTIONS(2893),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2893),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2893),
    [sym_bool] = ACTIONS(2891),
    [sym_unit] = ACTIONS(2893),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2891),
    [sym_op_identifier] = ACTIONS(2891),
    [anon_sym_PLUS] = ACTIONS(2891),
    [anon_sym_DASH] = ACTIONS(2891),
    [anon_sym_PLUS_DOT] = ACTIONS(2891),
    [anon_sym_DASH_DOT] = ACTIONS(2891),
    [anon_sym_PERCENT] = ACTIONS(2891),
    [anon_sym_AMP_AMP] = ACTIONS(2891),
    [anon_sym_TILDE] = ACTIONS(2893),
    [aux_sym_prefix_op_token1] = ACTIONS(2891),
    [aux_sym_infix_op_token1] = ACTIONS(2893),
    [aux_sym_infix_op_token2] = ACTIONS(2891),
    [anon_sym_PIPE_PIPE] = ACTIONS(2891),
    [anon_sym_BANG_EQ] = ACTIONS(2891),
    [anon_sym_COLON_EQ] = ACTIONS(2893),
    [anon_sym_DOLLAR] = ACTIONS(2891),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2891),
    [sym_int] = ACTIONS(2891),
    [sym_xint] = ACTIONS(2893),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2893),
    [sym__newline] = ACTIONS(2893),
    [sym__dedent] = ACTIONS(2893),
  },
  [1544] = {
    [sym_block_comment] = STATE(1544),
    [sym_compiler_directive_decl] = STATE(1544),
    [sym_fsi_directive_decl] = STATE(1544),
    [sym_preproc_line] = STATE(1544),
    [sym_identifier] = ACTIONS(2910),
    [anon_sym_EQ] = ACTIONS(2912),
    [anon_sym_COLON] = ACTIONS(2910),
    [anon_sym_return] = ACTIONS(2910),
    [anon_sym_do] = ACTIONS(2910),
    [anon_sym_let] = ACTIONS(2910),
    [anon_sym_let_BANG] = ACTIONS(2912),
    [anon_sym_as] = ACTIONS(2910),
    [anon_sym_LPAREN] = ACTIONS(2910),
    [anon_sym_COMMA] = ACTIONS(2912),
    [anon_sym_null] = ACTIONS(2910),
    [anon_sym_QMARK] = ACTIONS(2910),
    [anon_sym_COLON_QMARK] = ACTIONS(2910),
    [anon_sym_COLON_COLON] = ACTIONS(2912),
    [anon_sym_AMP] = ACTIONS(2910),
    [anon_sym_LBRACK] = ACTIONS(2910),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2912),
    [anon_sym_LBRACE] = ACTIONS(2910),
    [anon_sym_LT_AT] = ACTIONS(2910),
    [anon_sym_LT_AT_AT] = ACTIONS(2910),
    [anon_sym_DOT] = ACTIONS(2910),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2912),
    [anon_sym_new] = ACTIONS(2910),
    [anon_sym_with] = ACTIONS(2910),
    [anon_sym_return_BANG] = ACTIONS(2912),
    [anon_sym_yield] = ACTIONS(2910),
    [anon_sym_yield_BANG] = ACTIONS(2912),
    [anon_sym_lazy] = ACTIONS(2910),
    [anon_sym_assert] = ACTIONS(2910),
    [anon_sym_upcast] = ACTIONS(2910),
    [anon_sym_downcast] = ACTIONS(2910),
    [anon_sym_COLON_GT] = ACTIONS(2912),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2912),
    [anon_sym_for] = ACTIONS(2910),
    [anon_sym_while] = ACTIONS(2910),
    [anon_sym_if] = ACTIONS(2910),
    [anon_sym_fun] = ACTIONS(2910),
    [anon_sym_try] = ACTIONS(2910),
    [anon_sym_match] = ACTIONS(2910),
    [anon_sym_match_BANG] = ACTIONS(2912),
    [anon_sym_function] = ACTIONS(2910),
    [anon_sym_LT_DASH] = ACTIONS(2910),
    [anon_sym_DOT_LBRACK] = ACTIONS(2912),
    [anon_sym_LT] = ACTIONS(2912),
    [anon_sym_use] = ACTIONS(2910),
    [anon_sym_use_BANG] = ACTIONS(2912),
    [anon_sym_do_BANG] = ACTIONS(2912),
    [anon_sym_begin] = ACTIONS(2910),
    [anon_sym_LPAREN2] = ACTIONS(2910),
    [anon_sym_or] = ACTIONS(2910),
    [aux_sym_char_token1] = ACTIONS(2912),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2910),
    [anon_sym_DQUOTE] = ACTIONS(2910),
    [anon_sym_AT_DQUOTE] = ACTIONS(2912),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2912),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2912),
    [sym_bool] = ACTIONS(2910),
    [sym_unit] = ACTIONS(2912),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2910),
    [sym_op_identifier] = ACTIONS(2910),
    [anon_sym_PLUS] = ACTIONS(2910),
    [anon_sym_DASH] = ACTIONS(2910),
    [anon_sym_PLUS_DOT] = ACTIONS(2910),
    [anon_sym_DASH_DOT] = ACTIONS(2910),
    [anon_sym_PERCENT] = ACTIONS(2910),
    [anon_sym_AMP_AMP] = ACTIONS(2910),
    [anon_sym_TILDE] = ACTIONS(2912),
    [aux_sym_prefix_op_token1] = ACTIONS(2910),
    [aux_sym_infix_op_token1] = ACTIONS(2912),
    [aux_sym_infix_op_token2] = ACTIONS(2910),
    [anon_sym_PIPE_PIPE] = ACTIONS(2910),
    [anon_sym_BANG_EQ] = ACTIONS(2910),
    [anon_sym_COLON_EQ] = ACTIONS(2912),
    [anon_sym_DOLLAR] = ACTIONS(2910),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2910),
    [sym_int] = ACTIONS(2910),
    [sym_xint] = ACTIONS(2912),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2912),
    [sym__newline] = ACTIONS(2912),
    [sym__dedent] = ACTIONS(2912),
  },
  [1545] = {
    [sym_block_comment] = STATE(1545),
    [sym_compiler_directive_decl] = STATE(1545),
    [sym_fsi_directive_decl] = STATE(1545),
    [sym_preproc_line] = STATE(1545),
    [sym_identifier] = ACTIONS(2914),
    [anon_sym_EQ] = ACTIONS(2916),
    [anon_sym_COLON] = ACTIONS(2914),
    [anon_sym_return] = ACTIONS(2914),
    [anon_sym_do] = ACTIONS(2914),
    [anon_sym_let] = ACTIONS(2914),
    [anon_sym_let_BANG] = ACTIONS(2916),
    [anon_sym_as] = ACTIONS(2914),
    [anon_sym_LPAREN] = ACTIONS(2914),
    [anon_sym_COMMA] = ACTIONS(2916),
    [anon_sym_null] = ACTIONS(2914),
    [anon_sym_QMARK] = ACTIONS(2914),
    [anon_sym_COLON_QMARK] = ACTIONS(2914),
    [anon_sym_COLON_COLON] = ACTIONS(2916),
    [anon_sym_AMP] = ACTIONS(2914),
    [anon_sym_LBRACK] = ACTIONS(2914),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2916),
    [anon_sym_LBRACE] = ACTIONS(2914),
    [anon_sym_LT_AT] = ACTIONS(2914),
    [anon_sym_LT_AT_AT] = ACTIONS(2914),
    [anon_sym_DOT] = ACTIONS(2914),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2916),
    [anon_sym_new] = ACTIONS(2914),
    [anon_sym_with] = ACTIONS(2914),
    [anon_sym_return_BANG] = ACTIONS(2916),
    [anon_sym_yield] = ACTIONS(2914),
    [anon_sym_yield_BANG] = ACTIONS(2916),
    [anon_sym_lazy] = ACTIONS(2914),
    [anon_sym_assert] = ACTIONS(2914),
    [anon_sym_upcast] = ACTIONS(2914),
    [anon_sym_downcast] = ACTIONS(2914),
    [anon_sym_COLON_GT] = ACTIONS(2916),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2916),
    [anon_sym_for] = ACTIONS(2914),
    [anon_sym_while] = ACTIONS(2914),
    [anon_sym_if] = ACTIONS(2914),
    [anon_sym_fun] = ACTIONS(2914),
    [anon_sym_try] = ACTIONS(2914),
    [anon_sym_match] = ACTIONS(2914),
    [anon_sym_match_BANG] = ACTIONS(2916),
    [anon_sym_function] = ACTIONS(2914),
    [anon_sym_LT_DASH] = ACTIONS(2914),
    [anon_sym_DOT_LBRACK] = ACTIONS(2916),
    [anon_sym_LT] = ACTIONS(2916),
    [anon_sym_use] = ACTIONS(2914),
    [anon_sym_use_BANG] = ACTIONS(2916),
    [anon_sym_do_BANG] = ACTIONS(2916),
    [anon_sym_begin] = ACTIONS(2914),
    [anon_sym_LPAREN2] = ACTIONS(2914),
    [anon_sym_or] = ACTIONS(2914),
    [aux_sym_char_token1] = ACTIONS(2916),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2914),
    [anon_sym_DQUOTE] = ACTIONS(2914),
    [anon_sym_AT_DQUOTE] = ACTIONS(2916),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2916),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2916),
    [sym_bool] = ACTIONS(2914),
    [sym_unit] = ACTIONS(2916),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2914),
    [sym_op_identifier] = ACTIONS(2914),
    [anon_sym_PLUS] = ACTIONS(2914),
    [anon_sym_DASH] = ACTIONS(2914),
    [anon_sym_PLUS_DOT] = ACTIONS(2914),
    [anon_sym_DASH_DOT] = ACTIONS(2914),
    [anon_sym_PERCENT] = ACTIONS(2914),
    [anon_sym_AMP_AMP] = ACTIONS(2914),
    [anon_sym_TILDE] = ACTIONS(2916),
    [aux_sym_prefix_op_token1] = ACTIONS(2914),
    [aux_sym_infix_op_token1] = ACTIONS(2916),
    [aux_sym_infix_op_token2] = ACTIONS(2914),
    [anon_sym_PIPE_PIPE] = ACTIONS(2914),
    [anon_sym_BANG_EQ] = ACTIONS(2914),
    [anon_sym_COLON_EQ] = ACTIONS(2916),
    [anon_sym_DOLLAR] = ACTIONS(2914),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2914),
    [sym_int] = ACTIONS(2914),
    [sym_xint] = ACTIONS(2916),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2916),
    [sym__newline] = ACTIONS(2916),
    [sym__dedent] = ACTIONS(2916),
  },
  [1546] = {
    [sym_block_comment] = STATE(1546),
    [sym_compiler_directive_decl] = STATE(1546),
    [sym_fsi_directive_decl] = STATE(1546),
    [sym_preproc_line] = STATE(1546),
    [sym_identifier] = ACTIONS(2723),
    [anon_sym_EQ] = ACTIONS(2725),
    [anon_sym_COLON] = ACTIONS(2723),
    [anon_sym_return] = ACTIONS(2723),
    [anon_sym_do] = ACTIONS(2723),
    [anon_sym_let] = ACTIONS(2723),
    [anon_sym_let_BANG] = ACTIONS(2725),
    [anon_sym_LPAREN] = ACTIONS(2723),
    [anon_sym_COMMA] = ACTIONS(2725),
    [anon_sym_null] = ACTIONS(2723),
    [anon_sym_QMARK] = ACTIONS(2723),
    [anon_sym_COLON_QMARK] = ACTIONS(2723),
    [anon_sym_COLON_COLON] = ACTIONS(2725),
    [anon_sym_AMP] = ACTIONS(2723),
    [anon_sym_LBRACK] = ACTIONS(2723),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2725),
    [anon_sym_LBRACE] = ACTIONS(2723),
    [anon_sym_LT_AT] = ACTIONS(2723),
    [anon_sym_LT_AT_AT] = ACTIONS(2723),
    [anon_sym_DOT] = ACTIONS(2723),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2725),
    [anon_sym_new] = ACTIONS(2723),
    [anon_sym_return_BANG] = ACTIONS(2725),
    [anon_sym_yield] = ACTIONS(2723),
    [anon_sym_yield_BANG] = ACTIONS(2725),
    [anon_sym_lazy] = ACTIONS(2723),
    [anon_sym_assert] = ACTIONS(2723),
    [anon_sym_upcast] = ACTIONS(2723),
    [anon_sym_downcast] = ACTIONS(2723),
    [anon_sym_COLON_GT] = ACTIONS(2725),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2725),
    [anon_sym_for] = ACTIONS(2723),
    [anon_sym_while] = ACTIONS(2723),
    [anon_sym_if] = ACTIONS(2723),
    [anon_sym_fun] = ACTIONS(2723),
    [anon_sym_try] = ACTIONS(2723),
    [anon_sym_match] = ACTIONS(2723),
    [anon_sym_match_BANG] = ACTIONS(2725),
    [anon_sym_function] = ACTIONS(2723),
    [anon_sym_LT_DASH] = ACTIONS(2723),
    [anon_sym_DOT_LBRACK] = ACTIONS(2725),
    [anon_sym_LT] = ACTIONS(2725),
    [anon_sym_use] = ACTIONS(2723),
    [anon_sym_use_BANG] = ACTIONS(2725),
    [anon_sym_do_BANG] = ACTIONS(2725),
    [anon_sym_DOT_DOT] = ACTIONS(2725),
    [anon_sym_begin] = ACTIONS(2723),
    [anon_sym_LPAREN2] = ACTIONS(2723),
    [anon_sym_or] = ACTIONS(2723),
    [aux_sym_char_token1] = ACTIONS(2725),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2723),
    [anon_sym_DQUOTE] = ACTIONS(2723),
    [anon_sym_AT_DQUOTE] = ACTIONS(2725),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2725),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2725),
    [sym_bool] = ACTIONS(2723),
    [sym_unit] = ACTIONS(2725),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2723),
    [sym_op_identifier] = ACTIONS(2723),
    [anon_sym_PLUS] = ACTIONS(2723),
    [anon_sym_DASH] = ACTIONS(2723),
    [anon_sym_PLUS_DOT] = ACTIONS(2723),
    [anon_sym_DASH_DOT] = ACTIONS(2723),
    [anon_sym_PERCENT] = ACTIONS(2723),
    [anon_sym_AMP_AMP] = ACTIONS(2723),
    [anon_sym_TILDE] = ACTIONS(2725),
    [aux_sym_prefix_op_token1] = ACTIONS(2723),
    [aux_sym_infix_op_token1] = ACTIONS(2725),
    [aux_sym_infix_op_token2] = ACTIONS(2723),
    [anon_sym_PIPE_PIPE] = ACTIONS(2723),
    [anon_sym_BANG_EQ] = ACTIONS(2723),
    [anon_sym_COLON_EQ] = ACTIONS(2725),
    [anon_sym_DOLLAR] = ACTIONS(2723),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2723),
    [sym_int] = ACTIONS(2723),
    [sym_xint] = ACTIONS(2725),
    [anon_sym_f] = ACTIONS(2723),
    [aux_sym_decimal_token1] = ACTIONS(2723),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2725),
    [sym__newline] = ACTIONS(2725),
  },
  [1547] = {
    [sym_block_comment] = STATE(1547),
    [sym_compiler_directive_decl] = STATE(1547),
    [sym_fsi_directive_decl] = STATE(1547),
    [sym_preproc_line] = STATE(1547),
    [sym_identifier] = ACTIONS(2918),
    [anon_sym_EQ] = ACTIONS(2920),
    [anon_sym_COLON] = ACTIONS(2918),
    [anon_sym_return] = ACTIONS(2918),
    [anon_sym_do] = ACTIONS(2918),
    [anon_sym_let] = ACTIONS(2918),
    [anon_sym_let_BANG] = ACTIONS(2920),
    [anon_sym_as] = ACTIONS(2918),
    [anon_sym_LPAREN] = ACTIONS(2918),
    [anon_sym_COMMA] = ACTIONS(2920),
    [anon_sym_null] = ACTIONS(2918),
    [anon_sym_QMARK] = ACTIONS(2918),
    [anon_sym_COLON_QMARK] = ACTIONS(2918),
    [anon_sym_COLON_COLON] = ACTIONS(2920),
    [anon_sym_AMP] = ACTIONS(2918),
    [anon_sym_LBRACK] = ACTIONS(2918),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2920),
    [anon_sym_LBRACE] = ACTIONS(2918),
    [anon_sym_LT_AT] = ACTIONS(2918),
    [anon_sym_LT_AT_AT] = ACTIONS(2918),
    [anon_sym_DOT] = ACTIONS(2918),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2920),
    [anon_sym_new] = ACTIONS(2918),
    [anon_sym_with] = ACTIONS(2918),
    [anon_sym_return_BANG] = ACTIONS(2920),
    [anon_sym_yield] = ACTIONS(2918),
    [anon_sym_yield_BANG] = ACTIONS(2920),
    [anon_sym_lazy] = ACTIONS(2918),
    [anon_sym_assert] = ACTIONS(2918),
    [anon_sym_upcast] = ACTIONS(2918),
    [anon_sym_downcast] = ACTIONS(2918),
    [anon_sym_COLON_GT] = ACTIONS(2920),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2920),
    [anon_sym_for] = ACTIONS(2918),
    [anon_sym_while] = ACTIONS(2918),
    [anon_sym_if] = ACTIONS(2918),
    [anon_sym_fun] = ACTIONS(2918),
    [anon_sym_try] = ACTIONS(2918),
    [anon_sym_match] = ACTIONS(2918),
    [anon_sym_match_BANG] = ACTIONS(2920),
    [anon_sym_function] = ACTIONS(2918),
    [anon_sym_LT_DASH] = ACTIONS(2918),
    [anon_sym_DOT_LBRACK] = ACTIONS(2920),
    [anon_sym_LT] = ACTIONS(2920),
    [anon_sym_use] = ACTIONS(2918),
    [anon_sym_use_BANG] = ACTIONS(2920),
    [anon_sym_do_BANG] = ACTIONS(2920),
    [anon_sym_begin] = ACTIONS(2918),
    [anon_sym_LPAREN2] = ACTIONS(2918),
    [anon_sym_or] = ACTIONS(2918),
    [aux_sym_char_token1] = ACTIONS(2920),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2918),
    [anon_sym_DQUOTE] = ACTIONS(2918),
    [anon_sym_AT_DQUOTE] = ACTIONS(2920),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2920),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2920),
    [sym_bool] = ACTIONS(2918),
    [sym_unit] = ACTIONS(2920),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2918),
    [sym_op_identifier] = ACTIONS(2918),
    [anon_sym_PLUS] = ACTIONS(2918),
    [anon_sym_DASH] = ACTIONS(2918),
    [anon_sym_PLUS_DOT] = ACTIONS(2918),
    [anon_sym_DASH_DOT] = ACTIONS(2918),
    [anon_sym_PERCENT] = ACTIONS(2918),
    [anon_sym_AMP_AMP] = ACTIONS(2918),
    [anon_sym_TILDE] = ACTIONS(2920),
    [aux_sym_prefix_op_token1] = ACTIONS(2918),
    [aux_sym_infix_op_token1] = ACTIONS(2920),
    [aux_sym_infix_op_token2] = ACTIONS(2918),
    [anon_sym_PIPE_PIPE] = ACTIONS(2918),
    [anon_sym_BANG_EQ] = ACTIONS(2918),
    [anon_sym_COLON_EQ] = ACTIONS(2920),
    [anon_sym_DOLLAR] = ACTIONS(2918),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2918),
    [sym_int] = ACTIONS(2918),
    [sym_xint] = ACTIONS(2920),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2920),
    [sym__newline] = ACTIONS(2920),
    [sym__dedent] = ACTIONS(2920),
  },
  [1548] = {
    [sym_block_comment] = STATE(1548),
    [sym_compiler_directive_decl] = STATE(1548),
    [sym_fsi_directive_decl] = STATE(1548),
    [sym_preproc_line] = STATE(1548),
    [aux_sym_long_identifier_repeat1] = STATE(1548),
    [sym_identifier] = ACTIONS(2411),
    [anon_sym_EQ] = ACTIONS(2411),
    [anon_sym_COLON] = ACTIONS(2411),
    [anon_sym_return] = ACTIONS(2411),
    [anon_sym_do] = ACTIONS(2411),
    [anon_sym_let] = ACTIONS(2411),
    [anon_sym_let_BANG] = ACTIONS(2413),
    [anon_sym_LPAREN] = ACTIONS(2411),
    [anon_sym_COMMA] = ACTIONS(2413),
    [anon_sym_null] = ACTIONS(2411),
    [anon_sym_QMARK] = ACTIONS(2411),
    [anon_sym_COLON_QMARK] = ACTIONS(2411),
    [anon_sym_COLON_COLON] = ACTIONS(2413),
    [anon_sym_AMP] = ACTIONS(2411),
    [anon_sym_LBRACK] = ACTIONS(2411),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2413),
    [anon_sym_LBRACE] = ACTIONS(2411),
    [anon_sym_LT_AT] = ACTIONS(2411),
    [anon_sym_LT_AT_AT] = ACTIONS(2411),
    [anon_sym_DOT] = ACTIONS(3788),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2413),
    [anon_sym_new] = ACTIONS(2411),
    [anon_sym_with] = ACTIONS(2411),
    [anon_sym_return_BANG] = ACTIONS(2413),
    [anon_sym_yield] = ACTIONS(2411),
    [anon_sym_yield_BANG] = ACTIONS(2413),
    [anon_sym_lazy] = ACTIONS(2411),
    [anon_sym_assert] = ACTIONS(2411),
    [anon_sym_upcast] = ACTIONS(2411),
    [anon_sym_downcast] = ACTIONS(2411),
    [anon_sym_COLON_GT] = ACTIONS(2413),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2413),
    [anon_sym_for] = ACTIONS(2411),
    [anon_sym_while] = ACTIONS(2411),
    [anon_sym_if] = ACTIONS(2411),
    [anon_sym_fun] = ACTIONS(2411),
    [anon_sym_try] = ACTIONS(2411),
    [anon_sym_match] = ACTIONS(2411),
    [anon_sym_match_BANG] = ACTIONS(2413),
    [anon_sym_function] = ACTIONS(2411),
    [anon_sym_LT_DASH] = ACTIONS(2411),
    [anon_sym_DOT_LBRACK] = ACTIONS(2413),
    [anon_sym_LT] = ACTIONS(2413),
    [anon_sym_use] = ACTIONS(2411),
    [anon_sym_use_BANG] = ACTIONS(2413),
    [anon_sym_do_BANG] = ACTIONS(2413),
    [anon_sym_begin] = ACTIONS(2411),
    [anon_sym_LPAREN2] = ACTIONS(2411),
    [anon_sym_or] = ACTIONS(2411),
    [anon_sym_EQ2] = ACTIONS(2413),
    [aux_sym_char_token1] = ACTIONS(2413),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2411),
    [anon_sym_DQUOTE] = ACTIONS(2411),
    [anon_sym_AT_DQUOTE] = ACTIONS(2413),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2413),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2413),
    [sym_bool] = ACTIONS(2411),
    [sym_unit] = ACTIONS(2413),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2411),
    [sym_op_identifier] = ACTIONS(2411),
    [anon_sym_PLUS] = ACTIONS(2411),
    [anon_sym_DASH] = ACTIONS(2411),
    [anon_sym_PLUS_DOT] = ACTIONS(2411),
    [anon_sym_DASH_DOT] = ACTIONS(2411),
    [anon_sym_PERCENT] = ACTIONS(2411),
    [anon_sym_AMP_AMP] = ACTIONS(2411),
    [anon_sym_TILDE] = ACTIONS(2413),
    [aux_sym_prefix_op_token1] = ACTIONS(2411),
    [aux_sym_infix_op_token1] = ACTIONS(2413),
    [aux_sym_infix_op_token2] = ACTIONS(2411),
    [anon_sym_PIPE_PIPE] = ACTIONS(2411),
    [anon_sym_BANG_EQ] = ACTIONS(2411),
    [anon_sym_COLON_EQ] = ACTIONS(2413),
    [anon_sym_DOLLAR] = ACTIONS(2411),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2411),
    [sym_int] = ACTIONS(2411),
    [sym_xint] = ACTIONS(2413),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2413),
    [sym__newline] = ACTIONS(2413),
  },
  [1549] = {
    [sym_block_comment] = STATE(1549),
    [sym_compiler_directive_decl] = STATE(1549),
    [sym_fsi_directive_decl] = STATE(1549),
    [sym_preproc_line] = STATE(1549),
    [sym_identifier] = ACTIONS(2881),
    [anon_sym_EQ] = ACTIONS(2789),
    [anon_sym_COLON] = ACTIONS(2881),
    [anon_sym_return] = ACTIONS(2881),
    [anon_sym_do] = ACTIONS(2881),
    [anon_sym_let] = ACTIONS(2881),
    [anon_sym_let_BANG] = ACTIONS(2789),
    [anon_sym_as] = ACTIONS(2881),
    [anon_sym_LPAREN] = ACTIONS(2881),
    [anon_sym_COMMA] = ACTIONS(2789),
    [anon_sym_null] = ACTIONS(2881),
    [anon_sym_QMARK] = ACTIONS(2881),
    [anon_sym_COLON_QMARK] = ACTIONS(2881),
    [anon_sym_COLON_COLON] = ACTIONS(2789),
    [anon_sym_AMP] = ACTIONS(2881),
    [anon_sym_LBRACK] = ACTIONS(2881),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2789),
    [anon_sym_LBRACE] = ACTIONS(2881),
    [anon_sym_LT_AT] = ACTIONS(2881),
    [anon_sym_LT_AT_AT] = ACTIONS(2881),
    [anon_sym_DOT] = ACTIONS(2881),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2789),
    [anon_sym_new] = ACTIONS(2881),
    [anon_sym_with] = ACTIONS(2881),
    [anon_sym_return_BANG] = ACTIONS(2789),
    [anon_sym_yield] = ACTIONS(2881),
    [anon_sym_yield_BANG] = ACTIONS(2789),
    [anon_sym_lazy] = ACTIONS(2881),
    [anon_sym_assert] = ACTIONS(2881),
    [anon_sym_upcast] = ACTIONS(2881),
    [anon_sym_downcast] = ACTIONS(2881),
    [anon_sym_COLON_GT] = ACTIONS(2789),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2789),
    [anon_sym_for] = ACTIONS(2881),
    [anon_sym_while] = ACTIONS(2881),
    [anon_sym_if] = ACTIONS(2881),
    [anon_sym_fun] = ACTIONS(2881),
    [anon_sym_try] = ACTIONS(2881),
    [anon_sym_match] = ACTIONS(2881),
    [anon_sym_match_BANG] = ACTIONS(2789),
    [anon_sym_function] = ACTIONS(2881),
    [anon_sym_LT_DASH] = ACTIONS(2881),
    [anon_sym_DOT_LBRACK] = ACTIONS(2789),
    [anon_sym_LT] = ACTIONS(2789),
    [anon_sym_use] = ACTIONS(2881),
    [anon_sym_use_BANG] = ACTIONS(2789),
    [anon_sym_do_BANG] = ACTIONS(2789),
    [anon_sym_begin] = ACTIONS(2881),
    [anon_sym_LPAREN2] = ACTIONS(2881),
    [anon_sym_or] = ACTIONS(2881),
    [aux_sym_char_token1] = ACTIONS(2789),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2881),
    [anon_sym_DQUOTE] = ACTIONS(2881),
    [anon_sym_AT_DQUOTE] = ACTIONS(2789),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2789),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2789),
    [sym_bool] = ACTIONS(2881),
    [sym_unit] = ACTIONS(2789),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2881),
    [sym_op_identifier] = ACTIONS(2881),
    [anon_sym_PLUS] = ACTIONS(2881),
    [anon_sym_DASH] = ACTIONS(2881),
    [anon_sym_PLUS_DOT] = ACTIONS(2881),
    [anon_sym_DASH_DOT] = ACTIONS(2881),
    [anon_sym_PERCENT] = ACTIONS(2881),
    [anon_sym_AMP_AMP] = ACTIONS(2881),
    [anon_sym_TILDE] = ACTIONS(2789),
    [aux_sym_prefix_op_token1] = ACTIONS(2881),
    [aux_sym_infix_op_token1] = ACTIONS(2789),
    [aux_sym_infix_op_token2] = ACTIONS(2881),
    [anon_sym_PIPE_PIPE] = ACTIONS(2881),
    [anon_sym_BANG_EQ] = ACTIONS(2881),
    [anon_sym_COLON_EQ] = ACTIONS(2789),
    [anon_sym_DOLLAR] = ACTIONS(2881),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2881),
    [sym_int] = ACTIONS(2881),
    [sym_xint] = ACTIONS(2789),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2789),
    [sym__newline] = ACTIONS(2789),
    [sym__dedent] = ACTIONS(2789),
  },
  [1550] = {
    [sym_block_comment] = STATE(1550),
    [sym_compiler_directive_decl] = STATE(1550),
    [sym_fsi_directive_decl] = STATE(1550),
    [sym_preproc_line] = STATE(1550),
    [sym_identifier] = ACTIONS(2902),
    [anon_sym_EQ] = ACTIONS(2904),
    [anon_sym_COLON] = ACTIONS(2902),
    [anon_sym_return] = ACTIONS(2902),
    [anon_sym_do] = ACTIONS(2902),
    [anon_sym_let] = ACTIONS(2902),
    [anon_sym_let_BANG] = ACTIONS(2904),
    [anon_sym_as] = ACTIONS(2902),
    [anon_sym_LPAREN] = ACTIONS(2902),
    [anon_sym_COMMA] = ACTIONS(2904),
    [anon_sym_null] = ACTIONS(2902),
    [anon_sym_QMARK] = ACTIONS(2902),
    [anon_sym_COLON_QMARK] = ACTIONS(2902),
    [anon_sym_COLON_COLON] = ACTIONS(2904),
    [anon_sym_AMP] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2902),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2902),
    [anon_sym_LT_AT] = ACTIONS(2902),
    [anon_sym_LT_AT_AT] = ACTIONS(2902),
    [anon_sym_DOT] = ACTIONS(2902),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2904),
    [anon_sym_new] = ACTIONS(2902),
    [anon_sym_with] = ACTIONS(2902),
    [anon_sym_return_BANG] = ACTIONS(2904),
    [anon_sym_yield] = ACTIONS(2902),
    [anon_sym_yield_BANG] = ACTIONS(2904),
    [anon_sym_lazy] = ACTIONS(2902),
    [anon_sym_assert] = ACTIONS(2902),
    [anon_sym_upcast] = ACTIONS(2902),
    [anon_sym_downcast] = ACTIONS(2902),
    [anon_sym_COLON_GT] = ACTIONS(2904),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2904),
    [anon_sym_for] = ACTIONS(2902),
    [anon_sym_while] = ACTIONS(2902),
    [anon_sym_if] = ACTIONS(2902),
    [anon_sym_fun] = ACTIONS(2902),
    [anon_sym_try] = ACTIONS(2902),
    [anon_sym_match] = ACTIONS(2902),
    [anon_sym_match_BANG] = ACTIONS(2904),
    [anon_sym_function] = ACTIONS(2902),
    [anon_sym_LT_DASH] = ACTIONS(2902),
    [anon_sym_DOT_LBRACK] = ACTIONS(2904),
    [anon_sym_LT] = ACTIONS(2904),
    [anon_sym_use] = ACTIONS(2902),
    [anon_sym_use_BANG] = ACTIONS(2904),
    [anon_sym_do_BANG] = ACTIONS(2904),
    [anon_sym_begin] = ACTIONS(2902),
    [anon_sym_LPAREN2] = ACTIONS(2902),
    [anon_sym_or] = ACTIONS(2902),
    [aux_sym_char_token1] = ACTIONS(2904),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2902),
    [anon_sym_DQUOTE] = ACTIONS(2902),
    [anon_sym_AT_DQUOTE] = ACTIONS(2904),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2904),
    [sym_bool] = ACTIONS(2902),
    [sym_unit] = ACTIONS(2904),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2902),
    [sym_op_identifier] = ACTIONS(2902),
    [anon_sym_PLUS] = ACTIONS(2902),
    [anon_sym_DASH] = ACTIONS(2902),
    [anon_sym_PLUS_DOT] = ACTIONS(2902),
    [anon_sym_DASH_DOT] = ACTIONS(2902),
    [anon_sym_PERCENT] = ACTIONS(2902),
    [anon_sym_AMP_AMP] = ACTIONS(2902),
    [anon_sym_TILDE] = ACTIONS(2904),
    [aux_sym_prefix_op_token1] = ACTIONS(2902),
    [aux_sym_infix_op_token1] = ACTIONS(2904),
    [aux_sym_infix_op_token2] = ACTIONS(2902),
    [anon_sym_PIPE_PIPE] = ACTIONS(2902),
    [anon_sym_BANG_EQ] = ACTIONS(2902),
    [anon_sym_COLON_EQ] = ACTIONS(2904),
    [anon_sym_DOLLAR] = ACTIONS(2902),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2902),
    [sym_int] = ACTIONS(2902),
    [sym_xint] = ACTIONS(2904),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2904),
    [sym__newline] = ACTIONS(2904),
    [sym__dedent] = ACTIONS(2904),
  },
  [1551] = {
    [sym_block_comment] = STATE(1551),
    [sym_compiler_directive_decl] = STATE(1551),
    [sym_fsi_directive_decl] = STATE(1551),
    [sym_preproc_line] = STATE(1551),
    [sym_identifier] = ACTIONS(2906),
    [anon_sym_EQ] = ACTIONS(2908),
    [anon_sym_COLON] = ACTIONS(2906),
    [anon_sym_return] = ACTIONS(2906),
    [anon_sym_do] = ACTIONS(2906),
    [anon_sym_let] = ACTIONS(2906),
    [anon_sym_let_BANG] = ACTIONS(2908),
    [anon_sym_as] = ACTIONS(2906),
    [anon_sym_LPAREN] = ACTIONS(2906),
    [anon_sym_COMMA] = ACTIONS(2908),
    [anon_sym_null] = ACTIONS(2906),
    [anon_sym_QMARK] = ACTIONS(2906),
    [anon_sym_COLON_QMARK] = ACTIONS(2906),
    [anon_sym_COLON_COLON] = ACTIONS(2908),
    [anon_sym_AMP] = ACTIONS(2906),
    [anon_sym_LBRACK] = ACTIONS(2906),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2908),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_LT_AT] = ACTIONS(2906),
    [anon_sym_LT_AT_AT] = ACTIONS(2906),
    [anon_sym_DOT] = ACTIONS(2906),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2908),
    [anon_sym_new] = ACTIONS(2906),
    [anon_sym_with] = ACTIONS(2906),
    [anon_sym_return_BANG] = ACTIONS(2908),
    [anon_sym_yield] = ACTIONS(2906),
    [anon_sym_yield_BANG] = ACTIONS(2908),
    [anon_sym_lazy] = ACTIONS(2906),
    [anon_sym_assert] = ACTIONS(2906),
    [anon_sym_upcast] = ACTIONS(2906),
    [anon_sym_downcast] = ACTIONS(2906),
    [anon_sym_COLON_GT] = ACTIONS(2908),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2908),
    [anon_sym_for] = ACTIONS(2906),
    [anon_sym_while] = ACTIONS(2906),
    [anon_sym_if] = ACTIONS(2906),
    [anon_sym_fun] = ACTIONS(2906),
    [anon_sym_try] = ACTIONS(2906),
    [anon_sym_match] = ACTIONS(2906),
    [anon_sym_match_BANG] = ACTIONS(2908),
    [anon_sym_function] = ACTIONS(2906),
    [anon_sym_LT_DASH] = ACTIONS(2906),
    [anon_sym_DOT_LBRACK] = ACTIONS(2908),
    [anon_sym_LT] = ACTIONS(2908),
    [anon_sym_use] = ACTIONS(2906),
    [anon_sym_use_BANG] = ACTIONS(2908),
    [anon_sym_do_BANG] = ACTIONS(2908),
    [anon_sym_begin] = ACTIONS(2906),
    [anon_sym_LPAREN2] = ACTIONS(2906),
    [anon_sym_or] = ACTIONS(2906),
    [aux_sym_char_token1] = ACTIONS(2908),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2906),
    [anon_sym_DQUOTE] = ACTIONS(2906),
    [anon_sym_AT_DQUOTE] = ACTIONS(2908),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2908),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2908),
    [sym_bool] = ACTIONS(2906),
    [sym_unit] = ACTIONS(2908),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2906),
    [sym_op_identifier] = ACTIONS(2906),
    [anon_sym_PLUS] = ACTIONS(2906),
    [anon_sym_DASH] = ACTIONS(2906),
    [anon_sym_PLUS_DOT] = ACTIONS(2906),
    [anon_sym_DASH_DOT] = ACTIONS(2906),
    [anon_sym_PERCENT] = ACTIONS(2906),
    [anon_sym_AMP_AMP] = ACTIONS(2906),
    [anon_sym_TILDE] = ACTIONS(2908),
    [aux_sym_prefix_op_token1] = ACTIONS(2906),
    [aux_sym_infix_op_token1] = ACTIONS(2908),
    [aux_sym_infix_op_token2] = ACTIONS(2906),
    [anon_sym_PIPE_PIPE] = ACTIONS(2906),
    [anon_sym_BANG_EQ] = ACTIONS(2906),
    [anon_sym_COLON_EQ] = ACTIONS(2908),
    [anon_sym_DOLLAR] = ACTIONS(2906),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2906),
    [sym_int] = ACTIONS(2906),
    [sym_xint] = ACTIONS(2908),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2908),
    [sym__newline] = ACTIONS(2908),
    [sym__dedent] = ACTIONS(2908),
  },
  [1552] = {
    [sym_block_comment] = STATE(1552),
    [sym_compiler_directive_decl] = STATE(1552),
    [sym_fsi_directive_decl] = STATE(1552),
    [sym_preproc_line] = STATE(1552),
    [sym_identifier] = ACTIONS(2930),
    [anon_sym_EQ] = ACTIONS(2932),
    [anon_sym_COLON] = ACTIONS(2930),
    [anon_sym_return] = ACTIONS(2930),
    [anon_sym_do] = ACTIONS(2930),
    [anon_sym_let] = ACTIONS(2930),
    [anon_sym_let_BANG] = ACTIONS(2932),
    [anon_sym_as] = ACTIONS(2930),
    [anon_sym_LPAREN] = ACTIONS(2930),
    [anon_sym_COMMA] = ACTIONS(2932),
    [anon_sym_null] = ACTIONS(2930),
    [anon_sym_QMARK] = ACTIONS(2930),
    [anon_sym_COLON_QMARK] = ACTIONS(2930),
    [anon_sym_COLON_COLON] = ACTIONS(2932),
    [anon_sym_AMP] = ACTIONS(2930),
    [anon_sym_LBRACK] = ACTIONS(2930),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2932),
    [anon_sym_LBRACE] = ACTIONS(2930),
    [anon_sym_LT_AT] = ACTIONS(2930),
    [anon_sym_LT_AT_AT] = ACTIONS(2930),
    [anon_sym_DOT] = ACTIONS(2930),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2932),
    [anon_sym_new] = ACTIONS(2930),
    [anon_sym_with] = ACTIONS(2930),
    [anon_sym_return_BANG] = ACTIONS(2932),
    [anon_sym_yield] = ACTIONS(2930),
    [anon_sym_yield_BANG] = ACTIONS(2932),
    [anon_sym_lazy] = ACTIONS(2930),
    [anon_sym_assert] = ACTIONS(2930),
    [anon_sym_upcast] = ACTIONS(2930),
    [anon_sym_downcast] = ACTIONS(2930),
    [anon_sym_COLON_GT] = ACTIONS(2932),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2932),
    [anon_sym_for] = ACTIONS(2930),
    [anon_sym_while] = ACTIONS(2930),
    [anon_sym_if] = ACTIONS(2930),
    [anon_sym_fun] = ACTIONS(2930),
    [anon_sym_try] = ACTIONS(2930),
    [anon_sym_match] = ACTIONS(2930),
    [anon_sym_match_BANG] = ACTIONS(2932),
    [anon_sym_function] = ACTIONS(2930),
    [anon_sym_LT_DASH] = ACTIONS(2930),
    [anon_sym_DOT_LBRACK] = ACTIONS(2932),
    [anon_sym_LT] = ACTIONS(2932),
    [anon_sym_use] = ACTIONS(2930),
    [anon_sym_use_BANG] = ACTIONS(2932),
    [anon_sym_do_BANG] = ACTIONS(2932),
    [anon_sym_begin] = ACTIONS(2930),
    [anon_sym_LPAREN2] = ACTIONS(2930),
    [anon_sym_or] = ACTIONS(2930),
    [aux_sym_char_token1] = ACTIONS(2932),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2930),
    [anon_sym_DQUOTE] = ACTIONS(2930),
    [anon_sym_AT_DQUOTE] = ACTIONS(2932),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2932),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2932),
    [sym_bool] = ACTIONS(2930),
    [sym_unit] = ACTIONS(2932),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2930),
    [sym_op_identifier] = ACTIONS(2930),
    [anon_sym_PLUS] = ACTIONS(2930),
    [anon_sym_DASH] = ACTIONS(2930),
    [anon_sym_PLUS_DOT] = ACTIONS(2930),
    [anon_sym_DASH_DOT] = ACTIONS(2930),
    [anon_sym_PERCENT] = ACTIONS(2930),
    [anon_sym_AMP_AMP] = ACTIONS(2930),
    [anon_sym_TILDE] = ACTIONS(2932),
    [aux_sym_prefix_op_token1] = ACTIONS(2930),
    [aux_sym_infix_op_token1] = ACTIONS(2932),
    [aux_sym_infix_op_token2] = ACTIONS(2930),
    [anon_sym_PIPE_PIPE] = ACTIONS(2930),
    [anon_sym_BANG_EQ] = ACTIONS(2930),
    [anon_sym_COLON_EQ] = ACTIONS(2932),
    [anon_sym_DOLLAR] = ACTIONS(2930),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2930),
    [sym_int] = ACTIONS(2930),
    [sym_xint] = ACTIONS(2932),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2932),
    [sym__newline] = ACTIONS(2932),
    [sym__dedent] = ACTIONS(2932),
  },
  [1553] = {
    [sym_block_comment] = STATE(1553),
    [sym_compiler_directive_decl] = STATE(1553),
    [sym_fsi_directive_decl] = STATE(1553),
    [sym_preproc_line] = STATE(1553),
    [sym_identifier] = ACTIONS(2984),
    [anon_sym_EQ] = ACTIONS(2986),
    [anon_sym_COLON] = ACTIONS(2984),
    [anon_sym_return] = ACTIONS(2984),
    [anon_sym_do] = ACTIONS(2984),
    [anon_sym_let] = ACTIONS(2984),
    [anon_sym_let_BANG] = ACTIONS(2986),
    [anon_sym_as] = ACTIONS(2984),
    [anon_sym_LPAREN] = ACTIONS(2984),
    [anon_sym_COMMA] = ACTIONS(2986),
    [anon_sym_null] = ACTIONS(2984),
    [anon_sym_QMARK] = ACTIONS(2984),
    [anon_sym_COLON_QMARK] = ACTIONS(2984),
    [anon_sym_COLON_COLON] = ACTIONS(2986),
    [anon_sym_AMP] = ACTIONS(2984),
    [anon_sym_LBRACK] = ACTIONS(2984),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2986),
    [anon_sym_LBRACE] = ACTIONS(2984),
    [anon_sym_LT_AT] = ACTIONS(2984),
    [anon_sym_LT_AT_AT] = ACTIONS(2984),
    [anon_sym_DOT] = ACTIONS(2984),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2986),
    [anon_sym_new] = ACTIONS(2984),
    [anon_sym_with] = ACTIONS(2984),
    [anon_sym_return_BANG] = ACTIONS(2986),
    [anon_sym_yield] = ACTIONS(2984),
    [anon_sym_yield_BANG] = ACTIONS(2986),
    [anon_sym_lazy] = ACTIONS(2984),
    [anon_sym_assert] = ACTIONS(2984),
    [anon_sym_upcast] = ACTIONS(2984),
    [anon_sym_downcast] = ACTIONS(2984),
    [anon_sym_COLON_GT] = ACTIONS(2986),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2986),
    [anon_sym_for] = ACTIONS(2984),
    [anon_sym_while] = ACTIONS(2984),
    [anon_sym_if] = ACTIONS(2984),
    [anon_sym_fun] = ACTIONS(2984),
    [anon_sym_try] = ACTIONS(2984),
    [anon_sym_match] = ACTIONS(2984),
    [anon_sym_match_BANG] = ACTIONS(2986),
    [anon_sym_function] = ACTIONS(2984),
    [anon_sym_LT_DASH] = ACTIONS(2984),
    [anon_sym_DOT_LBRACK] = ACTIONS(2986),
    [anon_sym_LT] = ACTIONS(2986),
    [anon_sym_use] = ACTIONS(2984),
    [anon_sym_use_BANG] = ACTIONS(2986),
    [anon_sym_do_BANG] = ACTIONS(2986),
    [anon_sym_begin] = ACTIONS(2984),
    [anon_sym_LPAREN2] = ACTIONS(2984),
    [anon_sym_or] = ACTIONS(2984),
    [aux_sym_char_token1] = ACTIONS(2986),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2984),
    [anon_sym_DQUOTE] = ACTIONS(2984),
    [anon_sym_AT_DQUOTE] = ACTIONS(2986),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2986),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2986),
    [sym_bool] = ACTIONS(2984),
    [sym_unit] = ACTIONS(2986),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2984),
    [sym_op_identifier] = ACTIONS(2984),
    [anon_sym_PLUS] = ACTIONS(2984),
    [anon_sym_DASH] = ACTIONS(2984),
    [anon_sym_PLUS_DOT] = ACTIONS(2984),
    [anon_sym_DASH_DOT] = ACTIONS(2984),
    [anon_sym_PERCENT] = ACTIONS(2984),
    [anon_sym_AMP_AMP] = ACTIONS(2984),
    [anon_sym_TILDE] = ACTIONS(2986),
    [aux_sym_prefix_op_token1] = ACTIONS(2984),
    [aux_sym_infix_op_token1] = ACTIONS(2986),
    [aux_sym_infix_op_token2] = ACTIONS(2984),
    [anon_sym_PIPE_PIPE] = ACTIONS(2984),
    [anon_sym_BANG_EQ] = ACTIONS(2984),
    [anon_sym_COLON_EQ] = ACTIONS(2986),
    [anon_sym_DOLLAR] = ACTIONS(2984),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2984),
    [sym_int] = ACTIONS(2984),
    [sym_xint] = ACTIONS(2986),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2986),
    [sym__newline] = ACTIONS(2986),
    [sym__dedent] = ACTIONS(2986),
  },
  [1554] = {
    [sym_block_comment] = STATE(1554),
    [sym_compiler_directive_decl] = STATE(1554),
    [sym_fsi_directive_decl] = STATE(1554),
    [sym_preproc_line] = STATE(1554),
    [sym_identifier] = ACTIONS(2922),
    [anon_sym_EQ] = ACTIONS(2924),
    [anon_sym_COLON] = ACTIONS(2922),
    [anon_sym_return] = ACTIONS(2922),
    [anon_sym_do] = ACTIONS(2922),
    [anon_sym_let] = ACTIONS(2922),
    [anon_sym_let_BANG] = ACTIONS(2924),
    [anon_sym_as] = ACTIONS(2922),
    [anon_sym_LPAREN] = ACTIONS(2922),
    [anon_sym_COMMA] = ACTIONS(2924),
    [anon_sym_null] = ACTIONS(2922),
    [anon_sym_QMARK] = ACTIONS(2922),
    [anon_sym_COLON_QMARK] = ACTIONS(2922),
    [anon_sym_COLON_COLON] = ACTIONS(2924),
    [anon_sym_AMP] = ACTIONS(2922),
    [anon_sym_LBRACK] = ACTIONS(2922),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2924),
    [anon_sym_LBRACE] = ACTIONS(2922),
    [anon_sym_LT_AT] = ACTIONS(2922),
    [anon_sym_LT_AT_AT] = ACTIONS(2922),
    [anon_sym_DOT] = ACTIONS(2922),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2924),
    [anon_sym_new] = ACTIONS(2922),
    [anon_sym_with] = ACTIONS(2922),
    [anon_sym_return_BANG] = ACTIONS(2924),
    [anon_sym_yield] = ACTIONS(2922),
    [anon_sym_yield_BANG] = ACTIONS(2924),
    [anon_sym_lazy] = ACTIONS(2922),
    [anon_sym_assert] = ACTIONS(2922),
    [anon_sym_upcast] = ACTIONS(2922),
    [anon_sym_downcast] = ACTIONS(2922),
    [anon_sym_COLON_GT] = ACTIONS(2924),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2924),
    [anon_sym_for] = ACTIONS(2922),
    [anon_sym_while] = ACTIONS(2922),
    [anon_sym_if] = ACTIONS(2922),
    [anon_sym_fun] = ACTIONS(2922),
    [anon_sym_try] = ACTIONS(2922),
    [anon_sym_match] = ACTIONS(2922),
    [anon_sym_match_BANG] = ACTIONS(2924),
    [anon_sym_function] = ACTIONS(2922),
    [anon_sym_LT_DASH] = ACTIONS(2922),
    [anon_sym_DOT_LBRACK] = ACTIONS(2924),
    [anon_sym_LT] = ACTIONS(2924),
    [anon_sym_use] = ACTIONS(2922),
    [anon_sym_use_BANG] = ACTIONS(2924),
    [anon_sym_do_BANG] = ACTIONS(2924),
    [anon_sym_begin] = ACTIONS(2922),
    [anon_sym_LPAREN2] = ACTIONS(2922),
    [anon_sym_or] = ACTIONS(2922),
    [aux_sym_char_token1] = ACTIONS(2924),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2922),
    [anon_sym_DQUOTE] = ACTIONS(2922),
    [anon_sym_AT_DQUOTE] = ACTIONS(2924),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2924),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2924),
    [sym_bool] = ACTIONS(2922),
    [sym_unit] = ACTIONS(2924),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2922),
    [sym_op_identifier] = ACTIONS(2922),
    [anon_sym_PLUS] = ACTIONS(2922),
    [anon_sym_DASH] = ACTIONS(2922),
    [anon_sym_PLUS_DOT] = ACTIONS(2922),
    [anon_sym_DASH_DOT] = ACTIONS(2922),
    [anon_sym_PERCENT] = ACTIONS(2922),
    [anon_sym_AMP_AMP] = ACTIONS(2922),
    [anon_sym_TILDE] = ACTIONS(2924),
    [aux_sym_prefix_op_token1] = ACTIONS(2922),
    [aux_sym_infix_op_token1] = ACTIONS(2924),
    [aux_sym_infix_op_token2] = ACTIONS(2922),
    [anon_sym_PIPE_PIPE] = ACTIONS(2922),
    [anon_sym_BANG_EQ] = ACTIONS(2922),
    [anon_sym_COLON_EQ] = ACTIONS(2924),
    [anon_sym_DOLLAR] = ACTIONS(2922),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2922),
    [sym_int] = ACTIONS(2922),
    [sym_xint] = ACTIONS(2924),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2924),
    [sym__newline] = ACTIONS(2924),
    [sym__dedent] = ACTIONS(2924),
  },
  [1555] = {
    [sym_block_comment] = STATE(1555),
    [sym_compiler_directive_decl] = STATE(1555),
    [sym_fsi_directive_decl] = STATE(1555),
    [sym_preproc_line] = STATE(1555),
    [sym_identifier] = ACTIONS(2978),
    [anon_sym_EQ] = ACTIONS(2980),
    [anon_sym_COLON] = ACTIONS(2978),
    [anon_sym_return] = ACTIONS(2978),
    [anon_sym_do] = ACTIONS(2978),
    [anon_sym_let] = ACTIONS(2978),
    [anon_sym_let_BANG] = ACTIONS(2980),
    [anon_sym_as] = ACTIONS(2978),
    [anon_sym_LPAREN] = ACTIONS(2978),
    [anon_sym_COMMA] = ACTIONS(2980),
    [anon_sym_null] = ACTIONS(2978),
    [anon_sym_QMARK] = ACTIONS(2978),
    [anon_sym_COLON_QMARK] = ACTIONS(2978),
    [anon_sym_COLON_COLON] = ACTIONS(2980),
    [anon_sym_AMP] = ACTIONS(2978),
    [anon_sym_LBRACK] = ACTIONS(2978),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2980),
    [anon_sym_LBRACE] = ACTIONS(2978),
    [anon_sym_LT_AT] = ACTIONS(2978),
    [anon_sym_LT_AT_AT] = ACTIONS(2978),
    [anon_sym_DOT] = ACTIONS(2978),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2980),
    [anon_sym_new] = ACTIONS(2978),
    [anon_sym_with] = ACTIONS(2978),
    [anon_sym_return_BANG] = ACTIONS(2980),
    [anon_sym_yield] = ACTIONS(2978),
    [anon_sym_yield_BANG] = ACTIONS(2980),
    [anon_sym_lazy] = ACTIONS(2978),
    [anon_sym_assert] = ACTIONS(2978),
    [anon_sym_upcast] = ACTIONS(2978),
    [anon_sym_downcast] = ACTIONS(2978),
    [anon_sym_COLON_GT] = ACTIONS(2980),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2980),
    [anon_sym_for] = ACTIONS(2978),
    [anon_sym_while] = ACTIONS(2978),
    [anon_sym_if] = ACTIONS(2978),
    [anon_sym_fun] = ACTIONS(2978),
    [anon_sym_try] = ACTIONS(2978),
    [anon_sym_match] = ACTIONS(2978),
    [anon_sym_match_BANG] = ACTIONS(2980),
    [anon_sym_function] = ACTIONS(2978),
    [anon_sym_LT_DASH] = ACTIONS(2978),
    [anon_sym_DOT_LBRACK] = ACTIONS(2980),
    [anon_sym_LT] = ACTIONS(2980),
    [anon_sym_use] = ACTIONS(2978),
    [anon_sym_use_BANG] = ACTIONS(2980),
    [anon_sym_do_BANG] = ACTIONS(2980),
    [anon_sym_begin] = ACTIONS(2978),
    [anon_sym_LPAREN2] = ACTIONS(2978),
    [anon_sym_or] = ACTIONS(2978),
    [aux_sym_char_token1] = ACTIONS(2980),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2978),
    [anon_sym_DQUOTE] = ACTIONS(2978),
    [anon_sym_AT_DQUOTE] = ACTIONS(2980),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2980),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2980),
    [sym_bool] = ACTIONS(2978),
    [sym_unit] = ACTIONS(2980),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2978),
    [sym_op_identifier] = ACTIONS(2978),
    [anon_sym_PLUS] = ACTIONS(2978),
    [anon_sym_DASH] = ACTIONS(2978),
    [anon_sym_PLUS_DOT] = ACTIONS(2978),
    [anon_sym_DASH_DOT] = ACTIONS(2978),
    [anon_sym_PERCENT] = ACTIONS(2978),
    [anon_sym_AMP_AMP] = ACTIONS(2978),
    [anon_sym_TILDE] = ACTIONS(2980),
    [aux_sym_prefix_op_token1] = ACTIONS(2978),
    [aux_sym_infix_op_token1] = ACTIONS(2980),
    [aux_sym_infix_op_token2] = ACTIONS(2978),
    [anon_sym_PIPE_PIPE] = ACTIONS(2978),
    [anon_sym_BANG_EQ] = ACTIONS(2978),
    [anon_sym_COLON_EQ] = ACTIONS(2980),
    [anon_sym_DOLLAR] = ACTIONS(2978),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2978),
    [sym_int] = ACTIONS(2978),
    [sym_xint] = ACTIONS(2980),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2980),
    [sym__newline] = ACTIONS(2980),
    [sym__dedent] = ACTIONS(2980),
  },
  [1556] = {
    [sym_block_comment] = STATE(1556),
    [sym_compiler_directive_decl] = STATE(1556),
    [sym_fsi_directive_decl] = STATE(1556),
    [sym_preproc_line] = STATE(1556),
    [sym_identifier] = ACTIONS(2992),
    [anon_sym_EQ] = ACTIONS(2994),
    [anon_sym_COLON] = ACTIONS(2992),
    [anon_sym_return] = ACTIONS(2992),
    [anon_sym_do] = ACTIONS(2992),
    [anon_sym_let] = ACTIONS(2992),
    [anon_sym_let_BANG] = ACTIONS(2994),
    [anon_sym_as] = ACTIONS(2992),
    [anon_sym_LPAREN] = ACTIONS(2992),
    [anon_sym_COMMA] = ACTIONS(2994),
    [anon_sym_null] = ACTIONS(2992),
    [anon_sym_QMARK] = ACTIONS(2992),
    [anon_sym_COLON_QMARK] = ACTIONS(2992),
    [anon_sym_COLON_COLON] = ACTIONS(2994),
    [anon_sym_AMP] = ACTIONS(2992),
    [anon_sym_LBRACK] = ACTIONS(2992),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2994),
    [anon_sym_LBRACE] = ACTIONS(2992),
    [anon_sym_LT_AT] = ACTIONS(2992),
    [anon_sym_LT_AT_AT] = ACTIONS(2992),
    [anon_sym_DOT] = ACTIONS(2992),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2994),
    [anon_sym_new] = ACTIONS(2992),
    [anon_sym_with] = ACTIONS(2992),
    [anon_sym_return_BANG] = ACTIONS(2994),
    [anon_sym_yield] = ACTIONS(2992),
    [anon_sym_yield_BANG] = ACTIONS(2994),
    [anon_sym_lazy] = ACTIONS(2992),
    [anon_sym_assert] = ACTIONS(2992),
    [anon_sym_upcast] = ACTIONS(2992),
    [anon_sym_downcast] = ACTIONS(2992),
    [anon_sym_COLON_GT] = ACTIONS(2994),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2994),
    [anon_sym_for] = ACTIONS(2992),
    [anon_sym_while] = ACTIONS(2992),
    [anon_sym_if] = ACTIONS(2992),
    [anon_sym_fun] = ACTIONS(2992),
    [anon_sym_try] = ACTIONS(2992),
    [anon_sym_match] = ACTIONS(2992),
    [anon_sym_match_BANG] = ACTIONS(2994),
    [anon_sym_function] = ACTIONS(2992),
    [anon_sym_LT_DASH] = ACTIONS(2992),
    [anon_sym_DOT_LBRACK] = ACTIONS(2994),
    [anon_sym_LT] = ACTIONS(2994),
    [anon_sym_use] = ACTIONS(2992),
    [anon_sym_use_BANG] = ACTIONS(2994),
    [anon_sym_do_BANG] = ACTIONS(2994),
    [anon_sym_begin] = ACTIONS(2992),
    [anon_sym_LPAREN2] = ACTIONS(2992),
    [anon_sym_or] = ACTIONS(2992),
    [aux_sym_char_token1] = ACTIONS(2994),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2992),
    [anon_sym_DQUOTE] = ACTIONS(2992),
    [anon_sym_AT_DQUOTE] = ACTIONS(2994),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2994),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2994),
    [sym_bool] = ACTIONS(2992),
    [sym_unit] = ACTIONS(2994),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2992),
    [sym_op_identifier] = ACTIONS(2992),
    [anon_sym_PLUS] = ACTIONS(2992),
    [anon_sym_DASH] = ACTIONS(2992),
    [anon_sym_PLUS_DOT] = ACTIONS(2992),
    [anon_sym_DASH_DOT] = ACTIONS(2992),
    [anon_sym_PERCENT] = ACTIONS(2992),
    [anon_sym_AMP_AMP] = ACTIONS(2992),
    [anon_sym_TILDE] = ACTIONS(2994),
    [aux_sym_prefix_op_token1] = ACTIONS(2992),
    [aux_sym_infix_op_token1] = ACTIONS(2994),
    [aux_sym_infix_op_token2] = ACTIONS(2992),
    [anon_sym_PIPE_PIPE] = ACTIONS(2992),
    [anon_sym_BANG_EQ] = ACTIONS(2992),
    [anon_sym_COLON_EQ] = ACTIONS(2994),
    [anon_sym_DOLLAR] = ACTIONS(2992),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2992),
    [sym_int] = ACTIONS(2992),
    [sym_xint] = ACTIONS(2994),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2994),
    [sym__newline] = ACTIONS(2994),
    [sym__dedent] = ACTIONS(2994),
  },
  [1557] = {
    [sym_block_comment] = STATE(1557),
    [sym_compiler_directive_decl] = STATE(1557),
    [sym_fsi_directive_decl] = STATE(1557),
    [sym_preproc_line] = STATE(1557),
    [sym_identifier] = ACTIONS(2996),
    [anon_sym_EQ] = ACTIONS(2998),
    [anon_sym_COLON] = ACTIONS(2996),
    [anon_sym_return] = ACTIONS(2996),
    [anon_sym_do] = ACTIONS(2996),
    [anon_sym_let] = ACTIONS(2996),
    [anon_sym_let_BANG] = ACTIONS(2998),
    [anon_sym_as] = ACTIONS(2996),
    [anon_sym_LPAREN] = ACTIONS(2996),
    [anon_sym_COMMA] = ACTIONS(2998),
    [anon_sym_null] = ACTIONS(2996),
    [anon_sym_QMARK] = ACTIONS(2996),
    [anon_sym_COLON_QMARK] = ACTIONS(2996),
    [anon_sym_COLON_COLON] = ACTIONS(2998),
    [anon_sym_AMP] = ACTIONS(2996),
    [anon_sym_LBRACK] = ACTIONS(2996),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2998),
    [anon_sym_LBRACE] = ACTIONS(2996),
    [anon_sym_LT_AT] = ACTIONS(2996),
    [anon_sym_LT_AT_AT] = ACTIONS(2996),
    [anon_sym_DOT] = ACTIONS(2996),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2998),
    [anon_sym_new] = ACTIONS(2996),
    [anon_sym_with] = ACTIONS(2996),
    [anon_sym_return_BANG] = ACTIONS(2998),
    [anon_sym_yield] = ACTIONS(2996),
    [anon_sym_yield_BANG] = ACTIONS(2998),
    [anon_sym_lazy] = ACTIONS(2996),
    [anon_sym_assert] = ACTIONS(2996),
    [anon_sym_upcast] = ACTIONS(2996),
    [anon_sym_downcast] = ACTIONS(2996),
    [anon_sym_COLON_GT] = ACTIONS(2998),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2998),
    [anon_sym_for] = ACTIONS(2996),
    [anon_sym_while] = ACTIONS(2996),
    [anon_sym_if] = ACTIONS(2996),
    [anon_sym_fun] = ACTIONS(2996),
    [anon_sym_try] = ACTIONS(2996),
    [anon_sym_match] = ACTIONS(2996),
    [anon_sym_match_BANG] = ACTIONS(2998),
    [anon_sym_function] = ACTIONS(2996),
    [anon_sym_LT_DASH] = ACTIONS(2996),
    [anon_sym_DOT_LBRACK] = ACTIONS(2998),
    [anon_sym_LT] = ACTIONS(2998),
    [anon_sym_use] = ACTIONS(2996),
    [anon_sym_use_BANG] = ACTIONS(2998),
    [anon_sym_do_BANG] = ACTIONS(2998),
    [anon_sym_begin] = ACTIONS(2996),
    [anon_sym_LPAREN2] = ACTIONS(2996),
    [anon_sym_or] = ACTIONS(2996),
    [aux_sym_char_token1] = ACTIONS(2998),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2996),
    [anon_sym_DQUOTE] = ACTIONS(2996),
    [anon_sym_AT_DQUOTE] = ACTIONS(2998),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2998),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2998),
    [sym_bool] = ACTIONS(2996),
    [sym_unit] = ACTIONS(2998),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2996),
    [sym_op_identifier] = ACTIONS(2996),
    [anon_sym_PLUS] = ACTIONS(2996),
    [anon_sym_DASH] = ACTIONS(2996),
    [anon_sym_PLUS_DOT] = ACTIONS(2996),
    [anon_sym_DASH_DOT] = ACTIONS(2996),
    [anon_sym_PERCENT] = ACTIONS(2996),
    [anon_sym_AMP_AMP] = ACTIONS(2996),
    [anon_sym_TILDE] = ACTIONS(2998),
    [aux_sym_prefix_op_token1] = ACTIONS(2996),
    [aux_sym_infix_op_token1] = ACTIONS(2998),
    [aux_sym_infix_op_token2] = ACTIONS(2996),
    [anon_sym_PIPE_PIPE] = ACTIONS(2996),
    [anon_sym_BANG_EQ] = ACTIONS(2996),
    [anon_sym_COLON_EQ] = ACTIONS(2998),
    [anon_sym_DOLLAR] = ACTIONS(2996),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2996),
    [sym_int] = ACTIONS(2996),
    [sym_xint] = ACTIONS(2998),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2998),
    [sym__newline] = ACTIONS(2998),
    [sym__dedent] = ACTIONS(2998),
  },
  [1558] = {
    [sym_block_comment] = STATE(1558),
    [sym_compiler_directive_decl] = STATE(1558),
    [sym_fsi_directive_decl] = STATE(1558),
    [sym_preproc_line] = STATE(1558),
    [aux_sym_sequential_expression_repeat1] = STATE(1632),
    [sym_identifier] = ACTIONS(2847),
    [anon_sym_EQ] = ACTIONS(2849),
    [anon_sym_COLON] = ACTIONS(2847),
    [anon_sym_return] = ACTIONS(2847),
    [anon_sym_do] = ACTIONS(2847),
    [anon_sym_let] = ACTIONS(2847),
    [anon_sym_let_BANG] = ACTIONS(2849),
    [anon_sym_LPAREN] = ACTIONS(2847),
    [anon_sym_COMMA] = ACTIONS(2849),
    [anon_sym_null] = ACTIONS(2847),
    [anon_sym_QMARK] = ACTIONS(2847),
    [anon_sym_COLON_QMARK] = ACTIONS(2847),
    [anon_sym_COLON_COLON] = ACTIONS(2849),
    [anon_sym_AMP] = ACTIONS(2847),
    [anon_sym_LBRACK] = ACTIONS(2847),
    [anon_sym_RBRACK] = ACTIONS(2849),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2849),
    [anon_sym_LBRACE] = ACTIONS(2847),
    [anon_sym_LT_AT] = ACTIONS(2847),
    [anon_sym_LT_AT_AT] = ACTIONS(2847),
    [anon_sym_DOT] = ACTIONS(2847),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2849),
    [anon_sym_new] = ACTIONS(2847),
    [anon_sym_return_BANG] = ACTIONS(2849),
    [anon_sym_yield] = ACTIONS(2847),
    [anon_sym_yield_BANG] = ACTIONS(2849),
    [anon_sym_lazy] = ACTIONS(2847),
    [anon_sym_assert] = ACTIONS(2847),
    [anon_sym_upcast] = ACTIONS(2847),
    [anon_sym_downcast] = ACTIONS(2847),
    [anon_sym_COLON_GT] = ACTIONS(2849),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2849),
    [anon_sym_for] = ACTIONS(2847),
    [anon_sym_while] = ACTIONS(2847),
    [anon_sym_if] = ACTIONS(2847),
    [anon_sym_fun] = ACTIONS(2847),
    [anon_sym_try] = ACTIONS(2847),
    [anon_sym_match] = ACTIONS(2847),
    [anon_sym_match_BANG] = ACTIONS(2849),
    [anon_sym_function] = ACTIONS(2847),
    [anon_sym_LT_DASH] = ACTIONS(2847),
    [anon_sym_DOT_LBRACK] = ACTIONS(2849),
    [anon_sym_LT] = ACTIONS(2849),
    [anon_sym_use] = ACTIONS(2847),
    [anon_sym_use_BANG] = ACTIONS(2849),
    [anon_sym_do_BANG] = ACTIONS(2849),
    [anon_sym_begin] = ACTIONS(2847),
    [anon_sym_LPAREN2] = ACTIONS(2847),
    [anon_sym_DOT_DOT2] = ACTIONS(2849),
    [anon_sym_or] = ACTIONS(2847),
    [aux_sym_char_token1] = ACTIONS(2849),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2847),
    [anon_sym_DQUOTE] = ACTIONS(2847),
    [anon_sym_AT_DQUOTE] = ACTIONS(2849),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2849),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2849),
    [sym_bool] = ACTIONS(2847),
    [sym_unit] = ACTIONS(2849),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2847),
    [sym_op_identifier] = ACTIONS(2847),
    [anon_sym_PLUS] = ACTIONS(2847),
    [anon_sym_DASH] = ACTIONS(2847),
    [anon_sym_PLUS_DOT] = ACTIONS(2847),
    [anon_sym_DASH_DOT] = ACTIONS(2847),
    [anon_sym_PERCENT] = ACTIONS(2847),
    [anon_sym_AMP_AMP] = ACTIONS(2847),
    [anon_sym_TILDE] = ACTIONS(2849),
    [aux_sym_prefix_op_token1] = ACTIONS(2847),
    [aux_sym_infix_op_token1] = ACTIONS(2849),
    [aux_sym_infix_op_token2] = ACTIONS(2847),
    [anon_sym_PIPE_PIPE] = ACTIONS(2847),
    [anon_sym_BANG_EQ] = ACTIONS(2847),
    [anon_sym_COLON_EQ] = ACTIONS(2849),
    [anon_sym_DOLLAR] = ACTIONS(2847),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2847),
    [sym_int] = ACTIONS(2847),
    [sym_xint] = ACTIONS(2849),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2849),
    [sym__newline] = ACTIONS(2849),
  },
  [1559] = {
    [sym_block_comment] = STATE(1559),
    [sym_compiler_directive_decl] = STATE(1559),
    [sym_fsi_directive_decl] = STATE(1559),
    [sym_preproc_line] = STATE(1559),
    [aux_sym_sequential_expression_repeat1] = STATE(1559),
    [sym_identifier] = ACTIONS(2895),
    [anon_sym_EQ] = ACTIONS(2897),
    [anon_sym_COLON] = ACTIONS(2895),
    [anon_sym_return] = ACTIONS(2895),
    [anon_sym_do] = ACTIONS(2895),
    [anon_sym_let] = ACTIONS(2895),
    [anon_sym_let_BANG] = ACTIONS(2897),
    [anon_sym_as] = ACTIONS(2895),
    [anon_sym_LPAREN] = ACTIONS(2895),
    [anon_sym_COMMA] = ACTIONS(2897),
    [anon_sym_null] = ACTIONS(2895),
    [anon_sym_QMARK] = ACTIONS(2895),
    [anon_sym_COLON_QMARK] = ACTIONS(2895),
    [anon_sym_COLON_COLON] = ACTIONS(2897),
    [anon_sym_AMP] = ACTIONS(2895),
    [anon_sym_LBRACK] = ACTIONS(2895),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2897),
    [anon_sym_LBRACE] = ACTIONS(2895),
    [anon_sym_LT_AT] = ACTIONS(2895),
    [anon_sym_LT_AT_AT] = ACTIONS(2895),
    [anon_sym_DOT] = ACTIONS(2895),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2897),
    [anon_sym_new] = ACTIONS(2895),
    [anon_sym_with] = ACTIONS(2895),
    [anon_sym_return_BANG] = ACTIONS(2897),
    [anon_sym_yield] = ACTIONS(2895),
    [anon_sym_yield_BANG] = ACTIONS(2897),
    [anon_sym_lazy] = ACTIONS(2895),
    [anon_sym_assert] = ACTIONS(2895),
    [anon_sym_upcast] = ACTIONS(2895),
    [anon_sym_downcast] = ACTIONS(2895),
    [anon_sym_COLON_GT] = ACTIONS(2897),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2897),
    [anon_sym_for] = ACTIONS(2895),
    [anon_sym_while] = ACTIONS(2895),
    [anon_sym_if] = ACTIONS(2895),
    [anon_sym_fun] = ACTIONS(2895),
    [anon_sym_try] = ACTIONS(2895),
    [anon_sym_match] = ACTIONS(2895),
    [anon_sym_match_BANG] = ACTIONS(2897),
    [anon_sym_function] = ACTIONS(2895),
    [anon_sym_LT_DASH] = ACTIONS(2895),
    [anon_sym_DOT_LBRACK] = ACTIONS(2897),
    [anon_sym_LT] = ACTIONS(2897),
    [anon_sym_use] = ACTIONS(2895),
    [anon_sym_use_BANG] = ACTIONS(2897),
    [anon_sym_do_BANG] = ACTIONS(2897),
    [anon_sym_begin] = ACTIONS(2895),
    [anon_sym_LPAREN2] = ACTIONS(2895),
    [anon_sym_or] = ACTIONS(2895),
    [aux_sym_char_token1] = ACTIONS(2897),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2895),
    [anon_sym_DQUOTE] = ACTIONS(2895),
    [anon_sym_AT_DQUOTE] = ACTIONS(2897),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2897),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2897),
    [sym_bool] = ACTIONS(2895),
    [sym_unit] = ACTIONS(2897),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2895),
    [sym_op_identifier] = ACTIONS(2895),
    [anon_sym_PLUS] = ACTIONS(2895),
    [anon_sym_DASH] = ACTIONS(2895),
    [anon_sym_PLUS_DOT] = ACTIONS(2895),
    [anon_sym_DASH_DOT] = ACTIONS(2895),
    [anon_sym_PERCENT] = ACTIONS(2895),
    [anon_sym_AMP_AMP] = ACTIONS(2895),
    [anon_sym_TILDE] = ACTIONS(2897),
    [aux_sym_prefix_op_token1] = ACTIONS(2895),
    [aux_sym_infix_op_token1] = ACTIONS(2897),
    [aux_sym_infix_op_token2] = ACTIONS(2895),
    [anon_sym_PIPE_PIPE] = ACTIONS(2895),
    [anon_sym_BANG_EQ] = ACTIONS(2895),
    [anon_sym_COLON_EQ] = ACTIONS(2897),
    [anon_sym_DOLLAR] = ACTIONS(2895),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2895),
    [sym_int] = ACTIONS(2895),
    [sym_xint] = ACTIONS(2897),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2897),
    [sym__newline] = ACTIONS(3791),
  },
  [1560] = {
    [sym_block_comment] = STATE(1560),
    [sym_compiler_directive_decl] = STATE(1560),
    [sym_fsi_directive_decl] = STATE(1560),
    [sym_preproc_line] = STATE(1560),
    [sym_identifier] = ACTIONS(3003),
    [anon_sym_EQ] = ACTIONS(3005),
    [anon_sym_COLON] = ACTIONS(3003),
    [anon_sym_return] = ACTIONS(3003),
    [anon_sym_do] = ACTIONS(3003),
    [anon_sym_let] = ACTIONS(3003),
    [anon_sym_let_BANG] = ACTIONS(3005),
    [anon_sym_as] = ACTIONS(3003),
    [anon_sym_LPAREN] = ACTIONS(3003),
    [anon_sym_COMMA] = ACTIONS(3005),
    [anon_sym_null] = ACTIONS(3003),
    [anon_sym_QMARK] = ACTIONS(3003),
    [anon_sym_COLON_QMARK] = ACTIONS(3003),
    [anon_sym_COLON_COLON] = ACTIONS(3005),
    [anon_sym_AMP] = ACTIONS(3003),
    [anon_sym_LBRACK] = ACTIONS(3003),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3005),
    [anon_sym_LBRACE] = ACTIONS(3003),
    [anon_sym_LT_AT] = ACTIONS(3003),
    [anon_sym_LT_AT_AT] = ACTIONS(3003),
    [anon_sym_DOT] = ACTIONS(3003),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3005),
    [anon_sym_new] = ACTIONS(3003),
    [anon_sym_with] = ACTIONS(3003),
    [anon_sym_return_BANG] = ACTIONS(3005),
    [anon_sym_yield] = ACTIONS(3003),
    [anon_sym_yield_BANG] = ACTIONS(3005),
    [anon_sym_lazy] = ACTIONS(3003),
    [anon_sym_assert] = ACTIONS(3003),
    [anon_sym_upcast] = ACTIONS(3003),
    [anon_sym_downcast] = ACTIONS(3003),
    [anon_sym_COLON_GT] = ACTIONS(3005),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3005),
    [anon_sym_for] = ACTIONS(3003),
    [anon_sym_while] = ACTIONS(3003),
    [anon_sym_if] = ACTIONS(3003),
    [anon_sym_fun] = ACTIONS(3003),
    [anon_sym_try] = ACTIONS(3003),
    [anon_sym_match] = ACTIONS(3003),
    [anon_sym_match_BANG] = ACTIONS(3005),
    [anon_sym_function] = ACTIONS(3003),
    [anon_sym_LT_DASH] = ACTIONS(3003),
    [anon_sym_DOT_LBRACK] = ACTIONS(3005),
    [anon_sym_LT] = ACTIONS(3005),
    [anon_sym_use] = ACTIONS(3003),
    [anon_sym_use_BANG] = ACTIONS(3005),
    [anon_sym_do_BANG] = ACTIONS(3005),
    [anon_sym_begin] = ACTIONS(3003),
    [anon_sym_LPAREN2] = ACTIONS(3003),
    [anon_sym_or] = ACTIONS(3003),
    [aux_sym_char_token1] = ACTIONS(3005),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3003),
    [anon_sym_DQUOTE] = ACTIONS(3003),
    [anon_sym_AT_DQUOTE] = ACTIONS(3005),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3005),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3005),
    [sym_bool] = ACTIONS(3003),
    [sym_unit] = ACTIONS(3005),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3003),
    [sym_op_identifier] = ACTIONS(3003),
    [anon_sym_PLUS] = ACTIONS(3003),
    [anon_sym_DASH] = ACTIONS(3003),
    [anon_sym_PLUS_DOT] = ACTIONS(3003),
    [anon_sym_DASH_DOT] = ACTIONS(3003),
    [anon_sym_PERCENT] = ACTIONS(3003),
    [anon_sym_AMP_AMP] = ACTIONS(3003),
    [anon_sym_TILDE] = ACTIONS(3005),
    [aux_sym_prefix_op_token1] = ACTIONS(3003),
    [aux_sym_infix_op_token1] = ACTIONS(3005),
    [aux_sym_infix_op_token2] = ACTIONS(3003),
    [anon_sym_PIPE_PIPE] = ACTIONS(3003),
    [anon_sym_BANG_EQ] = ACTIONS(3003),
    [anon_sym_COLON_EQ] = ACTIONS(3005),
    [anon_sym_DOLLAR] = ACTIONS(3003),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3003),
    [sym_int] = ACTIONS(3003),
    [sym_xint] = ACTIONS(3005),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3005),
    [sym__newline] = ACTIONS(3005),
    [sym__dedent] = ACTIONS(3005),
  },
  [1561] = {
    [sym_block_comment] = STATE(1561),
    [sym_compiler_directive_decl] = STATE(1561),
    [sym_fsi_directive_decl] = STATE(1561),
    [sym_preproc_line] = STATE(1561),
    [aux_sym_rules_repeat1] = STATE(1569),
    [sym_identifier] = ACTIONS(2689),
    [anon_sym_EQ] = ACTIONS(2691),
    [anon_sym_COLON] = ACTIONS(2689),
    [anon_sym_return] = ACTIONS(2689),
    [anon_sym_do] = ACTIONS(2689),
    [anon_sym_let] = ACTIONS(2689),
    [anon_sym_let_BANG] = ACTIONS(2691),
    [anon_sym_LPAREN] = ACTIONS(2689),
    [anon_sym_COMMA] = ACTIONS(2691),
    [anon_sym_null] = ACTIONS(2689),
    [anon_sym_QMARK] = ACTIONS(2689),
    [anon_sym_COLON_QMARK] = ACTIONS(2689),
    [anon_sym_COLON_COLON] = ACTIONS(2691),
    [anon_sym_PIPE] = ACTIONS(3794),
    [anon_sym_AMP] = ACTIONS(2689),
    [anon_sym_LBRACK] = ACTIONS(2689),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2691),
    [anon_sym_LBRACE] = ACTIONS(2689),
    [anon_sym_LT_AT] = ACTIONS(2689),
    [anon_sym_LT_AT_AT] = ACTIONS(2689),
    [anon_sym_DOT] = ACTIONS(2689),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2691),
    [anon_sym_new] = ACTIONS(2689),
    [anon_sym_return_BANG] = ACTIONS(2691),
    [anon_sym_yield] = ACTIONS(2689),
    [anon_sym_yield_BANG] = ACTIONS(2691),
    [anon_sym_lazy] = ACTIONS(2689),
    [anon_sym_assert] = ACTIONS(2689),
    [anon_sym_upcast] = ACTIONS(2689),
    [anon_sym_downcast] = ACTIONS(2689),
    [anon_sym_COLON_GT] = ACTIONS(2691),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2691),
    [anon_sym_for] = ACTIONS(2689),
    [anon_sym_while] = ACTIONS(2689),
    [anon_sym_if] = ACTIONS(2689),
    [anon_sym_fun] = ACTIONS(2689),
    [anon_sym_try] = ACTIONS(2689),
    [anon_sym_match] = ACTIONS(2689),
    [anon_sym_match_BANG] = ACTIONS(2691),
    [anon_sym_function] = ACTIONS(2689),
    [anon_sym_LT_DASH] = ACTIONS(2689),
    [anon_sym_DOT_LBRACK] = ACTIONS(2691),
    [anon_sym_LT] = ACTIONS(2691),
    [anon_sym_use] = ACTIONS(2689),
    [anon_sym_use_BANG] = ACTIONS(2691),
    [anon_sym_do_BANG] = ACTIONS(2691),
    [anon_sym_begin] = ACTIONS(2689),
    [anon_sym_LPAREN2] = ACTIONS(2689),
    [anon_sym_or] = ACTIONS(2689),
    [aux_sym_char_token1] = ACTIONS(2691),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2689),
    [anon_sym_DQUOTE] = ACTIONS(2689),
    [anon_sym_AT_DQUOTE] = ACTIONS(2691),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2691),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2691),
    [sym_bool] = ACTIONS(2689),
    [sym_unit] = ACTIONS(2691),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2689),
    [sym_op_identifier] = ACTIONS(2689),
    [anon_sym_PLUS] = ACTIONS(2689),
    [anon_sym_DASH] = ACTIONS(2689),
    [anon_sym_PLUS_DOT] = ACTIONS(2689),
    [anon_sym_DASH_DOT] = ACTIONS(2689),
    [anon_sym_PERCENT] = ACTIONS(2689),
    [anon_sym_AMP_AMP] = ACTIONS(2689),
    [anon_sym_TILDE] = ACTIONS(2691),
    [aux_sym_prefix_op_token1] = ACTIONS(2689),
    [aux_sym_infix_op_token1] = ACTIONS(2691),
    [aux_sym_infix_op_token2] = ACTIONS(2689),
    [anon_sym_PIPE_PIPE] = ACTIONS(2689),
    [anon_sym_BANG_EQ] = ACTIONS(2689),
    [anon_sym_COLON_EQ] = ACTIONS(2691),
    [anon_sym_DOLLAR] = ACTIONS(2689),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2689),
    [sym_int] = ACTIONS(2689),
    [sym_xint] = ACTIONS(2691),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2691),
    [anon_sym_POUNDendif] = ACTIONS(2691),
    [sym__newline] = ACTIONS(3796),
  },
  [1562] = {
    [sym_block_comment] = STATE(1562),
    [sym_compiler_directive_decl] = STATE(1562),
    [sym_fsi_directive_decl] = STATE(1562),
    [sym_preproc_line] = STATE(1562),
    [sym_identifier] = ACTIONS(3051),
    [anon_sym_EQ] = ACTIONS(3053),
    [anon_sym_COLON] = ACTIONS(3051),
    [anon_sym_return] = ACTIONS(3051),
    [anon_sym_do] = ACTIONS(3051),
    [anon_sym_let] = ACTIONS(3051),
    [anon_sym_let_BANG] = ACTIONS(3053),
    [anon_sym_as] = ACTIONS(3051),
    [anon_sym_LPAREN] = ACTIONS(3051),
    [anon_sym_COMMA] = ACTIONS(3053),
    [anon_sym_null] = ACTIONS(3051),
    [anon_sym_QMARK] = ACTIONS(3051),
    [anon_sym_COLON_QMARK] = ACTIONS(3051),
    [anon_sym_COLON_COLON] = ACTIONS(3053),
    [anon_sym_AMP] = ACTIONS(3051),
    [anon_sym_LBRACK] = ACTIONS(3051),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3053),
    [anon_sym_LBRACE] = ACTIONS(3051),
    [anon_sym_LT_AT] = ACTIONS(3051),
    [anon_sym_LT_AT_AT] = ACTIONS(3051),
    [anon_sym_DOT] = ACTIONS(3051),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3053),
    [anon_sym_new] = ACTIONS(3051),
    [anon_sym_with] = ACTIONS(3051),
    [anon_sym_return_BANG] = ACTIONS(3053),
    [anon_sym_yield] = ACTIONS(3051),
    [anon_sym_yield_BANG] = ACTIONS(3053),
    [anon_sym_lazy] = ACTIONS(3051),
    [anon_sym_assert] = ACTIONS(3051),
    [anon_sym_upcast] = ACTIONS(3051),
    [anon_sym_downcast] = ACTIONS(3051),
    [anon_sym_COLON_GT] = ACTIONS(3053),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3053),
    [anon_sym_for] = ACTIONS(3051),
    [anon_sym_while] = ACTIONS(3051),
    [anon_sym_if] = ACTIONS(3051),
    [anon_sym_fun] = ACTIONS(3051),
    [anon_sym_try] = ACTIONS(3051),
    [anon_sym_match] = ACTIONS(3051),
    [anon_sym_match_BANG] = ACTIONS(3053),
    [anon_sym_function] = ACTIONS(3051),
    [anon_sym_LT_DASH] = ACTIONS(3051),
    [anon_sym_DOT_LBRACK] = ACTIONS(3053),
    [anon_sym_LT] = ACTIONS(3053),
    [anon_sym_use] = ACTIONS(3051),
    [anon_sym_use_BANG] = ACTIONS(3053),
    [anon_sym_do_BANG] = ACTIONS(3053),
    [anon_sym_begin] = ACTIONS(3051),
    [anon_sym_LPAREN2] = ACTIONS(3051),
    [anon_sym_or] = ACTIONS(3051),
    [aux_sym_char_token1] = ACTIONS(3053),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3051),
    [anon_sym_DQUOTE] = ACTIONS(3051),
    [anon_sym_AT_DQUOTE] = ACTIONS(3053),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3053),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3053),
    [sym_bool] = ACTIONS(3051),
    [sym_unit] = ACTIONS(3053),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3051),
    [sym_op_identifier] = ACTIONS(3051),
    [anon_sym_PLUS] = ACTIONS(3051),
    [anon_sym_DASH] = ACTIONS(3051),
    [anon_sym_PLUS_DOT] = ACTIONS(3051),
    [anon_sym_DASH_DOT] = ACTIONS(3051),
    [anon_sym_PERCENT] = ACTIONS(3051),
    [anon_sym_AMP_AMP] = ACTIONS(3051),
    [anon_sym_TILDE] = ACTIONS(3053),
    [aux_sym_prefix_op_token1] = ACTIONS(3051),
    [aux_sym_infix_op_token1] = ACTIONS(3053),
    [aux_sym_infix_op_token2] = ACTIONS(3051),
    [anon_sym_PIPE_PIPE] = ACTIONS(3051),
    [anon_sym_BANG_EQ] = ACTIONS(3051),
    [anon_sym_COLON_EQ] = ACTIONS(3053),
    [anon_sym_DOLLAR] = ACTIONS(3051),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3051),
    [sym_int] = ACTIONS(3051),
    [sym_xint] = ACTIONS(3053),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3053),
    [sym__newline] = ACTIONS(3053),
    [sym__dedent] = ACTIONS(3053),
  },
  [1563] = {
    [sym_block_comment] = STATE(1563),
    [sym_compiler_directive_decl] = STATE(1563),
    [sym_fsi_directive_decl] = STATE(1563),
    [sym_preproc_line] = STATE(1563),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_EQ] = ACTIONS(3017),
    [anon_sym_COLON] = ACTIONS(3015),
    [anon_sym_return] = ACTIONS(3015),
    [anon_sym_do] = ACTIONS(3015),
    [anon_sym_let] = ACTIONS(3015),
    [anon_sym_let_BANG] = ACTIONS(3017),
    [anon_sym_as] = ACTIONS(3015),
    [anon_sym_LPAREN] = ACTIONS(3015),
    [anon_sym_COMMA] = ACTIONS(3017),
    [anon_sym_null] = ACTIONS(3015),
    [anon_sym_QMARK] = ACTIONS(3015),
    [anon_sym_COLON_QMARK] = ACTIONS(3015),
    [anon_sym_COLON_COLON] = ACTIONS(3017),
    [anon_sym_AMP] = ACTIONS(3015),
    [anon_sym_LBRACK] = ACTIONS(3015),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3017),
    [anon_sym_LBRACE] = ACTIONS(3015),
    [anon_sym_LT_AT] = ACTIONS(3015),
    [anon_sym_LT_AT_AT] = ACTIONS(3015),
    [anon_sym_DOT] = ACTIONS(3015),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3017),
    [anon_sym_new] = ACTIONS(3015),
    [anon_sym_with] = ACTIONS(3015),
    [anon_sym_return_BANG] = ACTIONS(3017),
    [anon_sym_yield] = ACTIONS(3015),
    [anon_sym_yield_BANG] = ACTIONS(3017),
    [anon_sym_lazy] = ACTIONS(3015),
    [anon_sym_assert] = ACTIONS(3015),
    [anon_sym_upcast] = ACTIONS(3015),
    [anon_sym_downcast] = ACTIONS(3015),
    [anon_sym_COLON_GT] = ACTIONS(3017),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3017),
    [anon_sym_for] = ACTIONS(3015),
    [anon_sym_while] = ACTIONS(3015),
    [anon_sym_if] = ACTIONS(3015),
    [anon_sym_fun] = ACTIONS(3015),
    [anon_sym_try] = ACTIONS(3015),
    [anon_sym_match] = ACTIONS(3015),
    [anon_sym_match_BANG] = ACTIONS(3017),
    [anon_sym_function] = ACTIONS(3015),
    [anon_sym_LT_DASH] = ACTIONS(3015),
    [anon_sym_DOT_LBRACK] = ACTIONS(3017),
    [anon_sym_LT] = ACTIONS(3017),
    [anon_sym_use] = ACTIONS(3015),
    [anon_sym_use_BANG] = ACTIONS(3017),
    [anon_sym_do_BANG] = ACTIONS(3017),
    [anon_sym_begin] = ACTIONS(3015),
    [anon_sym_LPAREN2] = ACTIONS(3015),
    [anon_sym_or] = ACTIONS(3015),
    [aux_sym_char_token1] = ACTIONS(3017),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3015),
    [anon_sym_DQUOTE] = ACTIONS(3015),
    [anon_sym_AT_DQUOTE] = ACTIONS(3017),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3017),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3017),
    [sym_bool] = ACTIONS(3015),
    [sym_unit] = ACTIONS(3017),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3015),
    [sym_op_identifier] = ACTIONS(3015),
    [anon_sym_PLUS] = ACTIONS(3015),
    [anon_sym_DASH] = ACTIONS(3015),
    [anon_sym_PLUS_DOT] = ACTIONS(3015),
    [anon_sym_DASH_DOT] = ACTIONS(3015),
    [anon_sym_PERCENT] = ACTIONS(3015),
    [anon_sym_AMP_AMP] = ACTIONS(3015),
    [anon_sym_TILDE] = ACTIONS(3017),
    [aux_sym_prefix_op_token1] = ACTIONS(3015),
    [aux_sym_infix_op_token1] = ACTIONS(3017),
    [aux_sym_infix_op_token2] = ACTIONS(3015),
    [anon_sym_PIPE_PIPE] = ACTIONS(3015),
    [anon_sym_BANG_EQ] = ACTIONS(3015),
    [anon_sym_COLON_EQ] = ACTIONS(3017),
    [anon_sym_DOLLAR] = ACTIONS(3015),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3015),
    [sym_int] = ACTIONS(3015),
    [sym_xint] = ACTIONS(3017),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3017),
    [sym__newline] = ACTIONS(3017),
    [sym__dedent] = ACTIONS(3017),
  },
  [1564] = {
    [sym_block_comment] = STATE(1564),
    [sym_compiler_directive_decl] = STATE(1564),
    [sym_fsi_directive_decl] = STATE(1564),
    [sym_preproc_line] = STATE(1564),
    [sym_identifier] = ACTIONS(2685),
    [anon_sym_EQ] = ACTIONS(2687),
    [anon_sym_COLON] = ACTIONS(2685),
    [anon_sym_return] = ACTIONS(2685),
    [anon_sym_do] = ACTIONS(2685),
    [anon_sym_let] = ACTIONS(2685),
    [anon_sym_let_BANG] = ACTIONS(2687),
    [anon_sym_LPAREN] = ACTIONS(2685),
    [anon_sym_COMMA] = ACTIONS(2687),
    [anon_sym_null] = ACTIONS(2685),
    [anon_sym_QMARK] = ACTIONS(2685),
    [anon_sym_COLON_QMARK] = ACTIONS(2685),
    [anon_sym_COLON_COLON] = ACTIONS(2687),
    [anon_sym_AMP] = ACTIONS(2685),
    [anon_sym_LBRACK] = ACTIONS(2685),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2687),
    [anon_sym_LBRACE] = ACTIONS(2685),
    [anon_sym_LT_AT] = ACTIONS(2685),
    [anon_sym_AT_GT] = ACTIONS(2685),
    [anon_sym_LT_AT_AT] = ACTIONS(2685),
    [anon_sym_DOT] = ACTIONS(2685),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2687),
    [anon_sym_new] = ACTIONS(2685),
    [anon_sym_return_BANG] = ACTIONS(2687),
    [anon_sym_yield] = ACTIONS(2685),
    [anon_sym_yield_BANG] = ACTIONS(2687),
    [anon_sym_lazy] = ACTIONS(2685),
    [anon_sym_assert] = ACTIONS(2685),
    [anon_sym_upcast] = ACTIONS(2685),
    [anon_sym_downcast] = ACTIONS(2685),
    [anon_sym_COLON_GT] = ACTIONS(2687),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2687),
    [anon_sym_for] = ACTIONS(2685),
    [anon_sym_while] = ACTIONS(2685),
    [anon_sym_else] = ACTIONS(2685),
    [anon_sym_elif] = ACTIONS(2685),
    [anon_sym_if] = ACTIONS(2685),
    [anon_sym_fun] = ACTIONS(2685),
    [anon_sym_try] = ACTIONS(2685),
    [anon_sym_match] = ACTIONS(2685),
    [anon_sym_match_BANG] = ACTIONS(2687),
    [anon_sym_function] = ACTIONS(2685),
    [anon_sym_LT_DASH] = ACTIONS(2685),
    [anon_sym_DOT_LBRACK] = ACTIONS(2687),
    [anon_sym_LT] = ACTIONS(2687),
    [anon_sym_use] = ACTIONS(2685),
    [anon_sym_use_BANG] = ACTIONS(2687),
    [anon_sym_do_BANG] = ACTIONS(2687),
    [anon_sym_begin] = ACTIONS(2685),
    [anon_sym_LPAREN2] = ACTIONS(2685),
    [anon_sym_or] = ACTIONS(2685),
    [aux_sym_char_token1] = ACTIONS(2687),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2685),
    [anon_sym_DQUOTE] = ACTIONS(2685),
    [anon_sym_AT_DQUOTE] = ACTIONS(2687),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2687),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2687),
    [sym_bool] = ACTIONS(2685),
    [sym_unit] = ACTIONS(2687),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2685),
    [sym_op_identifier] = ACTIONS(2685),
    [anon_sym_PLUS] = ACTIONS(2685),
    [anon_sym_DASH] = ACTIONS(2685),
    [anon_sym_PLUS_DOT] = ACTIONS(2685),
    [anon_sym_DASH_DOT] = ACTIONS(2685),
    [anon_sym_PERCENT] = ACTIONS(2685),
    [anon_sym_AMP_AMP] = ACTIONS(2685),
    [anon_sym_TILDE] = ACTIONS(2687),
    [aux_sym_prefix_op_token1] = ACTIONS(2685),
    [aux_sym_infix_op_token1] = ACTIONS(2687),
    [aux_sym_infix_op_token2] = ACTIONS(2685),
    [anon_sym_PIPE_PIPE] = ACTIONS(2685),
    [anon_sym_BANG_EQ] = ACTIONS(2685),
    [anon_sym_COLON_EQ] = ACTIONS(2687),
    [anon_sym_DOLLAR] = ACTIONS(2685),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2685),
    [sym_int] = ACTIONS(2685),
    [sym_xint] = ACTIONS(2687),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2687),
    [sym__newline] = ACTIONS(2687),
  },
  [1565] = {
    [sym_block_comment] = STATE(1565),
    [sym_compiler_directive_decl] = STATE(1565),
    [sym_fsi_directive_decl] = STATE(1565),
    [sym_preproc_line] = STATE(1565),
    [sym_identifier] = ACTIONS(2760),
    [anon_sym_EQ] = ACTIONS(2762),
    [anon_sym_COLON] = ACTIONS(2760),
    [anon_sym_return] = ACTIONS(2760),
    [anon_sym_do] = ACTIONS(2760),
    [anon_sym_let] = ACTIONS(2760),
    [anon_sym_let_BANG] = ACTIONS(2762),
    [anon_sym_as] = ACTIONS(2760),
    [anon_sym_LPAREN] = ACTIONS(2760),
    [anon_sym_COMMA] = ACTIONS(2762),
    [anon_sym_null] = ACTIONS(2760),
    [anon_sym_QMARK] = ACTIONS(2760),
    [anon_sym_COLON_QMARK] = ACTIONS(2760),
    [anon_sym_COLON_COLON] = ACTIONS(2762),
    [anon_sym_PIPE] = ACTIONS(2760),
    [anon_sym_AMP] = ACTIONS(2760),
    [anon_sym_LBRACK] = ACTIONS(2760),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2762),
    [anon_sym_LBRACE] = ACTIONS(2760),
    [anon_sym_LT_AT] = ACTIONS(2760),
    [anon_sym_LT_AT_AT] = ACTIONS(2760),
    [anon_sym_DOT] = ACTIONS(2760),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2762),
    [anon_sym_new] = ACTIONS(2760),
    [anon_sym_with] = ACTIONS(2760),
    [anon_sym_return_BANG] = ACTIONS(2762),
    [anon_sym_yield] = ACTIONS(2760),
    [anon_sym_yield_BANG] = ACTIONS(2762),
    [anon_sym_lazy] = ACTIONS(2760),
    [anon_sym_assert] = ACTIONS(2760),
    [anon_sym_upcast] = ACTIONS(2760),
    [anon_sym_downcast] = ACTIONS(2760),
    [anon_sym_COLON_GT] = ACTIONS(2762),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2762),
    [anon_sym_for] = ACTIONS(2760),
    [anon_sym_while] = ACTIONS(2760),
    [anon_sym_if] = ACTIONS(2760),
    [anon_sym_fun] = ACTIONS(2760),
    [anon_sym_try] = ACTIONS(2760),
    [anon_sym_match] = ACTIONS(2760),
    [anon_sym_match_BANG] = ACTIONS(2762),
    [anon_sym_function] = ACTIONS(2760),
    [anon_sym_LT_DASH] = ACTIONS(2760),
    [anon_sym_DOT_LBRACK] = ACTIONS(2762),
    [anon_sym_LT] = ACTIONS(2762),
    [anon_sym_use] = ACTIONS(2760),
    [anon_sym_use_BANG] = ACTIONS(2762),
    [anon_sym_do_BANG] = ACTIONS(2762),
    [anon_sym_begin] = ACTIONS(2760),
    [anon_sym_LPAREN2] = ACTIONS(2760),
    [anon_sym_or] = ACTIONS(2760),
    [aux_sym_char_token1] = ACTIONS(2762),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2760),
    [anon_sym_DQUOTE] = ACTIONS(2760),
    [anon_sym_AT_DQUOTE] = ACTIONS(2762),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2762),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2762),
    [sym_bool] = ACTIONS(2760),
    [sym_unit] = ACTIONS(2762),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2760),
    [sym_op_identifier] = ACTIONS(2760),
    [anon_sym_PLUS] = ACTIONS(2760),
    [anon_sym_DASH] = ACTIONS(2760),
    [anon_sym_PLUS_DOT] = ACTIONS(2760),
    [anon_sym_DASH_DOT] = ACTIONS(2760),
    [anon_sym_PERCENT] = ACTIONS(2760),
    [anon_sym_AMP_AMP] = ACTIONS(2760),
    [anon_sym_TILDE] = ACTIONS(2762),
    [aux_sym_prefix_op_token1] = ACTIONS(2760),
    [aux_sym_infix_op_token1] = ACTIONS(2762),
    [aux_sym_infix_op_token2] = ACTIONS(2760),
    [anon_sym_PIPE_PIPE] = ACTIONS(2760),
    [anon_sym_BANG_EQ] = ACTIONS(2760),
    [anon_sym_COLON_EQ] = ACTIONS(2762),
    [anon_sym_DOLLAR] = ACTIONS(2760),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2760),
    [sym_int] = ACTIONS(2760),
    [sym_xint] = ACTIONS(2762),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2762),
    [sym__newline] = ACTIONS(2762),
  },
  [1566] = {
    [sym_block_comment] = STATE(1566),
    [sym_compiler_directive_decl] = STATE(1566),
    [sym_fsi_directive_decl] = STATE(1566),
    [sym_preproc_line] = STATE(1566),
    [sym_identifier] = ACTIONS(3039),
    [anon_sym_EQ] = ACTIONS(3041),
    [anon_sym_COLON] = ACTIONS(3039),
    [anon_sym_return] = ACTIONS(3039),
    [anon_sym_do] = ACTIONS(3039),
    [anon_sym_let] = ACTIONS(3039),
    [anon_sym_let_BANG] = ACTIONS(3041),
    [anon_sym_as] = ACTIONS(3039),
    [anon_sym_LPAREN] = ACTIONS(3039),
    [anon_sym_COMMA] = ACTIONS(3041),
    [anon_sym_null] = ACTIONS(3039),
    [anon_sym_QMARK] = ACTIONS(3039),
    [anon_sym_COLON_QMARK] = ACTIONS(3039),
    [anon_sym_COLON_COLON] = ACTIONS(3041),
    [anon_sym_AMP] = ACTIONS(3039),
    [anon_sym_LBRACK] = ACTIONS(3039),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3041),
    [anon_sym_LBRACE] = ACTIONS(3039),
    [anon_sym_LT_AT] = ACTIONS(3039),
    [anon_sym_LT_AT_AT] = ACTIONS(3039),
    [anon_sym_DOT] = ACTIONS(3039),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3041),
    [anon_sym_new] = ACTIONS(3039),
    [anon_sym_with] = ACTIONS(3039),
    [anon_sym_return_BANG] = ACTIONS(3041),
    [anon_sym_yield] = ACTIONS(3039),
    [anon_sym_yield_BANG] = ACTIONS(3041),
    [anon_sym_lazy] = ACTIONS(3039),
    [anon_sym_assert] = ACTIONS(3039),
    [anon_sym_upcast] = ACTIONS(3039),
    [anon_sym_downcast] = ACTIONS(3039),
    [anon_sym_COLON_GT] = ACTIONS(3041),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3041),
    [anon_sym_for] = ACTIONS(3039),
    [anon_sym_while] = ACTIONS(3039),
    [anon_sym_if] = ACTIONS(3039),
    [anon_sym_fun] = ACTIONS(3039),
    [anon_sym_try] = ACTIONS(3039),
    [anon_sym_match] = ACTIONS(3039),
    [anon_sym_match_BANG] = ACTIONS(3041),
    [anon_sym_function] = ACTIONS(3039),
    [anon_sym_LT_DASH] = ACTIONS(3039),
    [anon_sym_DOT_LBRACK] = ACTIONS(3041),
    [anon_sym_LT] = ACTIONS(3041),
    [anon_sym_use] = ACTIONS(3039),
    [anon_sym_use_BANG] = ACTIONS(3041),
    [anon_sym_do_BANG] = ACTIONS(3041),
    [anon_sym_begin] = ACTIONS(3039),
    [anon_sym_LPAREN2] = ACTIONS(3039),
    [anon_sym_or] = ACTIONS(3039),
    [aux_sym_char_token1] = ACTIONS(3041),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3039),
    [anon_sym_DQUOTE] = ACTIONS(3039),
    [anon_sym_AT_DQUOTE] = ACTIONS(3041),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3041),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3041),
    [sym_bool] = ACTIONS(3039),
    [sym_unit] = ACTIONS(3041),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3039),
    [sym_op_identifier] = ACTIONS(3039),
    [anon_sym_PLUS] = ACTIONS(3039),
    [anon_sym_DASH] = ACTIONS(3039),
    [anon_sym_PLUS_DOT] = ACTIONS(3039),
    [anon_sym_DASH_DOT] = ACTIONS(3039),
    [anon_sym_PERCENT] = ACTIONS(3039),
    [anon_sym_AMP_AMP] = ACTIONS(3039),
    [anon_sym_TILDE] = ACTIONS(3041),
    [aux_sym_prefix_op_token1] = ACTIONS(3039),
    [aux_sym_infix_op_token1] = ACTIONS(3041),
    [aux_sym_infix_op_token2] = ACTIONS(3039),
    [anon_sym_PIPE_PIPE] = ACTIONS(3039),
    [anon_sym_BANG_EQ] = ACTIONS(3039),
    [anon_sym_COLON_EQ] = ACTIONS(3041),
    [anon_sym_DOLLAR] = ACTIONS(3039),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3039),
    [sym_int] = ACTIONS(3039),
    [sym_xint] = ACTIONS(3041),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3041),
    [sym__newline] = ACTIONS(3041),
    [sym__dedent] = ACTIONS(3041),
  },
  [1567] = {
    [sym_block_comment] = STATE(1567),
    [sym_compiler_directive_decl] = STATE(1567),
    [sym_fsi_directive_decl] = STATE(1567),
    [sym_preproc_line] = STATE(1567),
    [sym_identifier] = ACTIONS(3043),
    [anon_sym_EQ] = ACTIONS(3045),
    [anon_sym_COLON] = ACTIONS(3043),
    [anon_sym_return] = ACTIONS(3043),
    [anon_sym_do] = ACTIONS(3043),
    [anon_sym_let] = ACTIONS(3043),
    [anon_sym_let_BANG] = ACTIONS(3045),
    [anon_sym_as] = ACTIONS(3043),
    [anon_sym_LPAREN] = ACTIONS(3043),
    [anon_sym_COMMA] = ACTIONS(3045),
    [anon_sym_null] = ACTIONS(3043),
    [anon_sym_QMARK] = ACTIONS(3043),
    [anon_sym_COLON_QMARK] = ACTIONS(3043),
    [anon_sym_COLON_COLON] = ACTIONS(3045),
    [anon_sym_AMP] = ACTIONS(3043),
    [anon_sym_LBRACK] = ACTIONS(3043),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3045),
    [anon_sym_LBRACE] = ACTIONS(3043),
    [anon_sym_LT_AT] = ACTIONS(3043),
    [anon_sym_LT_AT_AT] = ACTIONS(3043),
    [anon_sym_DOT] = ACTIONS(3043),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3045),
    [anon_sym_new] = ACTIONS(3043),
    [anon_sym_with] = ACTIONS(3043),
    [anon_sym_return_BANG] = ACTIONS(3045),
    [anon_sym_yield] = ACTIONS(3043),
    [anon_sym_yield_BANG] = ACTIONS(3045),
    [anon_sym_lazy] = ACTIONS(3043),
    [anon_sym_assert] = ACTIONS(3043),
    [anon_sym_upcast] = ACTIONS(3043),
    [anon_sym_downcast] = ACTIONS(3043),
    [anon_sym_COLON_GT] = ACTIONS(3045),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3045),
    [anon_sym_for] = ACTIONS(3043),
    [anon_sym_while] = ACTIONS(3043),
    [anon_sym_if] = ACTIONS(3043),
    [anon_sym_fun] = ACTIONS(3043),
    [anon_sym_try] = ACTIONS(3043),
    [anon_sym_match] = ACTIONS(3043),
    [anon_sym_match_BANG] = ACTIONS(3045),
    [anon_sym_function] = ACTIONS(3043),
    [anon_sym_LT_DASH] = ACTIONS(3043),
    [anon_sym_DOT_LBRACK] = ACTIONS(3045),
    [anon_sym_LT] = ACTIONS(3045),
    [anon_sym_use] = ACTIONS(3043),
    [anon_sym_use_BANG] = ACTIONS(3045),
    [anon_sym_do_BANG] = ACTIONS(3045),
    [anon_sym_begin] = ACTIONS(3043),
    [anon_sym_LPAREN2] = ACTIONS(3043),
    [anon_sym_or] = ACTIONS(3043),
    [aux_sym_char_token1] = ACTIONS(3045),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3043),
    [anon_sym_DQUOTE] = ACTIONS(3043),
    [anon_sym_AT_DQUOTE] = ACTIONS(3045),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3045),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3045),
    [sym_bool] = ACTIONS(3043),
    [sym_unit] = ACTIONS(3045),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3043),
    [sym_op_identifier] = ACTIONS(3043),
    [anon_sym_PLUS] = ACTIONS(3043),
    [anon_sym_DASH] = ACTIONS(3043),
    [anon_sym_PLUS_DOT] = ACTIONS(3043),
    [anon_sym_DASH_DOT] = ACTIONS(3043),
    [anon_sym_PERCENT] = ACTIONS(3043),
    [anon_sym_AMP_AMP] = ACTIONS(3043),
    [anon_sym_TILDE] = ACTIONS(3045),
    [aux_sym_prefix_op_token1] = ACTIONS(3043),
    [aux_sym_infix_op_token1] = ACTIONS(3045),
    [aux_sym_infix_op_token2] = ACTIONS(3043),
    [anon_sym_PIPE_PIPE] = ACTIONS(3043),
    [anon_sym_BANG_EQ] = ACTIONS(3043),
    [anon_sym_COLON_EQ] = ACTIONS(3045),
    [anon_sym_DOLLAR] = ACTIONS(3043),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3043),
    [sym_int] = ACTIONS(3043),
    [sym_xint] = ACTIONS(3045),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3045),
    [sym__newline] = ACTIONS(3045),
    [sym__dedent] = ACTIONS(3045),
  },
  [1568] = {
    [sym_block_comment] = STATE(1568),
    [sym_compiler_directive_decl] = STATE(1568),
    [sym_fsi_directive_decl] = STATE(1568),
    [sym_preproc_line] = STATE(1568),
    [aux_sym_rules_repeat1] = STATE(1598),
    [sym_identifier] = ACTIONS(2698),
    [anon_sym_EQ] = ACTIONS(2700),
    [anon_sym_COLON] = ACTIONS(2698),
    [anon_sym_return] = ACTIONS(2698),
    [anon_sym_do] = ACTIONS(2698),
    [anon_sym_let] = ACTIONS(2698),
    [anon_sym_let_BANG] = ACTIONS(2700),
    [anon_sym_LPAREN] = ACTIONS(2698),
    [anon_sym_COMMA] = ACTIONS(2700),
    [anon_sym_null] = ACTIONS(2698),
    [anon_sym_QMARK] = ACTIONS(2698),
    [anon_sym_COLON_QMARK] = ACTIONS(2698),
    [anon_sym_COLON_COLON] = ACTIONS(2700),
    [anon_sym_PIPE] = ACTIONS(3794),
    [anon_sym_AMP] = ACTIONS(2698),
    [anon_sym_LBRACK] = ACTIONS(2698),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2700),
    [anon_sym_LBRACE] = ACTIONS(2698),
    [anon_sym_LT_AT] = ACTIONS(2698),
    [anon_sym_LT_AT_AT] = ACTIONS(2698),
    [anon_sym_DOT] = ACTIONS(2698),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2700),
    [anon_sym_new] = ACTIONS(2698),
    [anon_sym_return_BANG] = ACTIONS(2700),
    [anon_sym_yield] = ACTIONS(2698),
    [anon_sym_yield_BANG] = ACTIONS(2700),
    [anon_sym_lazy] = ACTIONS(2698),
    [anon_sym_assert] = ACTIONS(2698),
    [anon_sym_upcast] = ACTIONS(2698),
    [anon_sym_downcast] = ACTIONS(2698),
    [anon_sym_COLON_GT] = ACTIONS(2700),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2700),
    [anon_sym_for] = ACTIONS(2698),
    [anon_sym_while] = ACTIONS(2698),
    [anon_sym_if] = ACTIONS(2698),
    [anon_sym_fun] = ACTIONS(2698),
    [anon_sym_try] = ACTIONS(2698),
    [anon_sym_match] = ACTIONS(2698),
    [anon_sym_match_BANG] = ACTIONS(2700),
    [anon_sym_function] = ACTIONS(2698),
    [anon_sym_LT_DASH] = ACTIONS(2698),
    [anon_sym_DOT_LBRACK] = ACTIONS(2700),
    [anon_sym_LT] = ACTIONS(2700),
    [anon_sym_use] = ACTIONS(2698),
    [anon_sym_use_BANG] = ACTIONS(2700),
    [anon_sym_do_BANG] = ACTIONS(2700),
    [anon_sym_begin] = ACTIONS(2698),
    [anon_sym_LPAREN2] = ACTIONS(2698),
    [anon_sym_or] = ACTIONS(2698),
    [aux_sym_char_token1] = ACTIONS(2700),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2698),
    [anon_sym_DQUOTE] = ACTIONS(2698),
    [anon_sym_AT_DQUOTE] = ACTIONS(2700),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2700),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2700),
    [sym_bool] = ACTIONS(2698),
    [sym_unit] = ACTIONS(2700),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2698),
    [sym_op_identifier] = ACTIONS(2698),
    [anon_sym_PLUS] = ACTIONS(2698),
    [anon_sym_DASH] = ACTIONS(2698),
    [anon_sym_PLUS_DOT] = ACTIONS(2698),
    [anon_sym_DASH_DOT] = ACTIONS(2698),
    [anon_sym_PERCENT] = ACTIONS(2698),
    [anon_sym_AMP_AMP] = ACTIONS(2698),
    [anon_sym_TILDE] = ACTIONS(2700),
    [aux_sym_prefix_op_token1] = ACTIONS(2698),
    [aux_sym_infix_op_token1] = ACTIONS(2700),
    [aux_sym_infix_op_token2] = ACTIONS(2698),
    [anon_sym_PIPE_PIPE] = ACTIONS(2698),
    [anon_sym_BANG_EQ] = ACTIONS(2698),
    [anon_sym_COLON_EQ] = ACTIONS(2700),
    [anon_sym_DOLLAR] = ACTIONS(2698),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2698),
    [sym_int] = ACTIONS(2698),
    [sym_xint] = ACTIONS(2700),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2700),
    [anon_sym_POUNDendif] = ACTIONS(2700),
    [sym__newline] = ACTIONS(3799),
  },
  [1569] = {
    [sym_block_comment] = STATE(1569),
    [sym_compiler_directive_decl] = STATE(1569),
    [sym_fsi_directive_decl] = STATE(1569),
    [sym_preproc_line] = STATE(1569),
    [aux_sym_rules_repeat1] = STATE(1599),
    [sym_identifier] = ACTIONS(2698),
    [anon_sym_EQ] = ACTIONS(2700),
    [anon_sym_COLON] = ACTIONS(2698),
    [anon_sym_return] = ACTIONS(2698),
    [anon_sym_do] = ACTIONS(2698),
    [anon_sym_let] = ACTIONS(2698),
    [anon_sym_let_BANG] = ACTIONS(2700),
    [anon_sym_LPAREN] = ACTIONS(2698),
    [anon_sym_COMMA] = ACTIONS(2700),
    [anon_sym_null] = ACTIONS(2698),
    [anon_sym_QMARK] = ACTIONS(2698),
    [anon_sym_COLON_QMARK] = ACTIONS(2698),
    [anon_sym_COLON_COLON] = ACTIONS(2700),
    [anon_sym_PIPE] = ACTIONS(3794),
    [anon_sym_AMP] = ACTIONS(2698),
    [anon_sym_LBRACK] = ACTIONS(2698),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2700),
    [anon_sym_LBRACE] = ACTIONS(2698),
    [anon_sym_LT_AT] = ACTIONS(2698),
    [anon_sym_LT_AT_AT] = ACTIONS(2698),
    [anon_sym_DOT] = ACTIONS(2698),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2700),
    [anon_sym_new] = ACTIONS(2698),
    [anon_sym_return_BANG] = ACTIONS(2700),
    [anon_sym_yield] = ACTIONS(2698),
    [anon_sym_yield_BANG] = ACTIONS(2700),
    [anon_sym_lazy] = ACTIONS(2698),
    [anon_sym_assert] = ACTIONS(2698),
    [anon_sym_upcast] = ACTIONS(2698),
    [anon_sym_downcast] = ACTIONS(2698),
    [anon_sym_COLON_GT] = ACTIONS(2700),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2700),
    [anon_sym_for] = ACTIONS(2698),
    [anon_sym_while] = ACTIONS(2698),
    [anon_sym_if] = ACTIONS(2698),
    [anon_sym_fun] = ACTIONS(2698),
    [anon_sym_try] = ACTIONS(2698),
    [anon_sym_match] = ACTIONS(2698),
    [anon_sym_match_BANG] = ACTIONS(2700),
    [anon_sym_function] = ACTIONS(2698),
    [anon_sym_LT_DASH] = ACTIONS(2698),
    [anon_sym_DOT_LBRACK] = ACTIONS(2700),
    [anon_sym_LT] = ACTIONS(2700),
    [anon_sym_use] = ACTIONS(2698),
    [anon_sym_use_BANG] = ACTIONS(2700),
    [anon_sym_do_BANG] = ACTIONS(2700),
    [anon_sym_begin] = ACTIONS(2698),
    [anon_sym_LPAREN2] = ACTIONS(2698),
    [anon_sym_or] = ACTIONS(2698),
    [aux_sym_char_token1] = ACTIONS(2700),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2698),
    [anon_sym_DQUOTE] = ACTIONS(2698),
    [anon_sym_AT_DQUOTE] = ACTIONS(2700),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2700),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2700),
    [sym_bool] = ACTIONS(2698),
    [sym_unit] = ACTIONS(2700),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2698),
    [sym_op_identifier] = ACTIONS(2698),
    [anon_sym_PLUS] = ACTIONS(2698),
    [anon_sym_DASH] = ACTIONS(2698),
    [anon_sym_PLUS_DOT] = ACTIONS(2698),
    [anon_sym_DASH_DOT] = ACTIONS(2698),
    [anon_sym_PERCENT] = ACTIONS(2698),
    [anon_sym_AMP_AMP] = ACTIONS(2698),
    [anon_sym_TILDE] = ACTIONS(2700),
    [aux_sym_prefix_op_token1] = ACTIONS(2698),
    [aux_sym_infix_op_token1] = ACTIONS(2700),
    [aux_sym_infix_op_token2] = ACTIONS(2698),
    [anon_sym_PIPE_PIPE] = ACTIONS(2698),
    [anon_sym_BANG_EQ] = ACTIONS(2698),
    [anon_sym_COLON_EQ] = ACTIONS(2700),
    [anon_sym_DOLLAR] = ACTIONS(2698),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2698),
    [sym_int] = ACTIONS(2698),
    [sym_xint] = ACTIONS(2700),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2700),
    [anon_sym_POUNDendif] = ACTIONS(2700),
    [sym__newline] = ACTIONS(3799),
  },
  [1570] = {
    [sym_block_comment] = STATE(1570),
    [sym_compiler_directive_decl] = STATE(1570),
    [sym_fsi_directive_decl] = STATE(1570),
    [sym_preproc_line] = STATE(1570),
    [sym_identifier] = ACTIONS(3047),
    [anon_sym_EQ] = ACTIONS(3049),
    [anon_sym_COLON] = ACTIONS(3047),
    [anon_sym_return] = ACTIONS(3047),
    [anon_sym_do] = ACTIONS(3047),
    [anon_sym_let] = ACTIONS(3047),
    [anon_sym_let_BANG] = ACTIONS(3049),
    [anon_sym_as] = ACTIONS(3047),
    [anon_sym_LPAREN] = ACTIONS(3047),
    [anon_sym_COMMA] = ACTIONS(3049),
    [anon_sym_null] = ACTIONS(3047),
    [anon_sym_QMARK] = ACTIONS(3047),
    [anon_sym_COLON_QMARK] = ACTIONS(3047),
    [anon_sym_COLON_COLON] = ACTIONS(3049),
    [anon_sym_AMP] = ACTIONS(3047),
    [anon_sym_LBRACK] = ACTIONS(3047),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3049),
    [anon_sym_LBRACE] = ACTIONS(3047),
    [anon_sym_LT_AT] = ACTIONS(3047),
    [anon_sym_LT_AT_AT] = ACTIONS(3047),
    [anon_sym_DOT] = ACTIONS(3047),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3049),
    [anon_sym_new] = ACTIONS(3047),
    [anon_sym_with] = ACTIONS(3047),
    [anon_sym_return_BANG] = ACTIONS(3049),
    [anon_sym_yield] = ACTIONS(3047),
    [anon_sym_yield_BANG] = ACTIONS(3049),
    [anon_sym_lazy] = ACTIONS(3047),
    [anon_sym_assert] = ACTIONS(3047),
    [anon_sym_upcast] = ACTIONS(3047),
    [anon_sym_downcast] = ACTIONS(3047),
    [anon_sym_COLON_GT] = ACTIONS(3049),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3049),
    [anon_sym_for] = ACTIONS(3047),
    [anon_sym_while] = ACTIONS(3047),
    [anon_sym_if] = ACTIONS(3047),
    [anon_sym_fun] = ACTIONS(3047),
    [anon_sym_try] = ACTIONS(3047),
    [anon_sym_match] = ACTIONS(3047),
    [anon_sym_match_BANG] = ACTIONS(3049),
    [anon_sym_function] = ACTIONS(3047),
    [anon_sym_LT_DASH] = ACTIONS(3047),
    [anon_sym_DOT_LBRACK] = ACTIONS(3049),
    [anon_sym_LT] = ACTIONS(3049),
    [anon_sym_use] = ACTIONS(3047),
    [anon_sym_use_BANG] = ACTIONS(3049),
    [anon_sym_do_BANG] = ACTIONS(3049),
    [anon_sym_begin] = ACTIONS(3047),
    [anon_sym_LPAREN2] = ACTIONS(3047),
    [anon_sym_or] = ACTIONS(3047),
    [aux_sym_char_token1] = ACTIONS(3049),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3047),
    [anon_sym_DQUOTE] = ACTIONS(3047),
    [anon_sym_AT_DQUOTE] = ACTIONS(3049),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3049),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3049),
    [sym_bool] = ACTIONS(3047),
    [sym_unit] = ACTIONS(3049),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3047),
    [sym_op_identifier] = ACTIONS(3047),
    [anon_sym_PLUS] = ACTIONS(3047),
    [anon_sym_DASH] = ACTIONS(3047),
    [anon_sym_PLUS_DOT] = ACTIONS(3047),
    [anon_sym_DASH_DOT] = ACTIONS(3047),
    [anon_sym_PERCENT] = ACTIONS(3047),
    [anon_sym_AMP_AMP] = ACTIONS(3047),
    [anon_sym_TILDE] = ACTIONS(3049),
    [aux_sym_prefix_op_token1] = ACTIONS(3047),
    [aux_sym_infix_op_token1] = ACTIONS(3049),
    [aux_sym_infix_op_token2] = ACTIONS(3047),
    [anon_sym_PIPE_PIPE] = ACTIONS(3047),
    [anon_sym_BANG_EQ] = ACTIONS(3047),
    [anon_sym_COLON_EQ] = ACTIONS(3049),
    [anon_sym_DOLLAR] = ACTIONS(3047),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3047),
    [sym_int] = ACTIONS(3047),
    [sym_xint] = ACTIONS(3049),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3049),
    [sym__newline] = ACTIONS(3049),
    [sym__dedent] = ACTIONS(3049),
  },
  [1571] = {
    [sym_block_comment] = STATE(1571),
    [sym_compiler_directive_decl] = STATE(1571),
    [sym_fsi_directive_decl] = STATE(1571),
    [sym_preproc_line] = STATE(1571),
    [aux_sym_long_identifier_repeat1] = STATE(1571),
    [sym_identifier] = ACTIONS(2411),
    [anon_sym_EQ] = ACTIONS(2413),
    [anon_sym_COLON] = ACTIONS(2411),
    [anon_sym_return] = ACTIONS(2411),
    [anon_sym_do] = ACTIONS(2411),
    [anon_sym_let] = ACTIONS(2411),
    [anon_sym_let_BANG] = ACTIONS(2413),
    [anon_sym_LPAREN] = ACTIONS(2411),
    [anon_sym_COMMA] = ACTIONS(2413),
    [anon_sym_null] = ACTIONS(2411),
    [anon_sym_QMARK] = ACTIONS(2411),
    [anon_sym_COLON_QMARK] = ACTIONS(2411),
    [anon_sym_COLON_COLON] = ACTIONS(2413),
    [anon_sym_AMP] = ACTIONS(2411),
    [anon_sym_LBRACK] = ACTIONS(2411),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2413),
    [anon_sym_LBRACE] = ACTIONS(2411),
    [anon_sym_LT_AT] = ACTIONS(2411),
    [anon_sym_LT_AT_AT] = ACTIONS(2411),
    [anon_sym_DOT] = ACTIONS(3802),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2413),
    [anon_sym_new] = ACTIONS(2411),
    [anon_sym_return_BANG] = ACTIONS(2413),
    [anon_sym_yield] = ACTIONS(2411),
    [anon_sym_yield_BANG] = ACTIONS(2413),
    [anon_sym_lazy] = ACTIONS(2411),
    [anon_sym_assert] = ACTIONS(2411),
    [anon_sym_upcast] = ACTIONS(2411),
    [anon_sym_downcast] = ACTIONS(2411),
    [anon_sym_COLON_GT] = ACTIONS(2413),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2413),
    [anon_sym_for] = ACTIONS(2411),
    [anon_sym_while] = ACTIONS(2411),
    [anon_sym_if] = ACTIONS(2411),
    [anon_sym_fun] = ACTIONS(2411),
    [anon_sym_try] = ACTIONS(2411),
    [anon_sym_match] = ACTIONS(2411),
    [anon_sym_match_BANG] = ACTIONS(2413),
    [anon_sym_function] = ACTIONS(2411),
    [anon_sym_LT_DASH] = ACTIONS(2411),
    [anon_sym_DOT_LBRACK] = ACTIONS(2413),
    [anon_sym_LT] = ACTIONS(2413),
    [anon_sym_use] = ACTIONS(2411),
    [anon_sym_use_BANG] = ACTIONS(2413),
    [anon_sym_do_BANG] = ACTIONS(2413),
    [anon_sym_begin] = ACTIONS(2411),
    [anon_sym_LPAREN2] = ACTIONS(2411),
    [anon_sym_or] = ACTIONS(2411),
    [aux_sym_char_token1] = ACTIONS(2413),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2411),
    [anon_sym_DQUOTE] = ACTIONS(2411),
    [anon_sym_AT_DQUOTE] = ACTIONS(2413),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2413),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2413),
    [sym_bool] = ACTIONS(2411),
    [sym_unit] = ACTIONS(2413),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2411),
    [sym_op_identifier] = ACTIONS(2411),
    [anon_sym_PLUS] = ACTIONS(2411),
    [anon_sym_DASH] = ACTIONS(2411),
    [anon_sym_PLUS_DOT] = ACTIONS(2411),
    [anon_sym_DASH_DOT] = ACTIONS(2411),
    [anon_sym_PERCENT] = ACTIONS(2411),
    [anon_sym_AMP_AMP] = ACTIONS(2411),
    [anon_sym_TILDE] = ACTIONS(2413),
    [aux_sym_prefix_op_token1] = ACTIONS(2411),
    [aux_sym_infix_op_token1] = ACTIONS(2413),
    [aux_sym_infix_op_token2] = ACTIONS(2411),
    [anon_sym_PIPE_PIPE] = ACTIONS(2411),
    [anon_sym_BANG_EQ] = ACTIONS(2411),
    [anon_sym_COLON_EQ] = ACTIONS(2413),
    [anon_sym_DOLLAR] = ACTIONS(2411),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2411),
    [sym_int] = ACTIONS(2411),
    [sym_xint] = ACTIONS(2413),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2413),
    [anon_sym_POUNDendif] = ACTIONS(2413),
    [anon_sym_POUNDelse] = ACTIONS(2413),
    [sym__newline] = ACTIONS(2413),
  },
  [1572] = {
    [sym_block_comment] = STATE(1572),
    [sym_compiler_directive_decl] = STATE(1572),
    [sym_fsi_directive_decl] = STATE(1572),
    [sym_preproc_line] = STATE(1572),
    [sym_identifier] = ACTIONS(2729),
    [anon_sym_EQ] = ACTIONS(2731),
    [anon_sym_COLON] = ACTIONS(2729),
    [anon_sym_return] = ACTIONS(2729),
    [anon_sym_do] = ACTIONS(2729),
    [anon_sym_let] = ACTIONS(2729),
    [anon_sym_let_BANG] = ACTIONS(2731),
    [anon_sym_LPAREN] = ACTIONS(2729),
    [anon_sym_COMMA] = ACTIONS(2731),
    [anon_sym_null] = ACTIONS(2729),
    [anon_sym_QMARK] = ACTIONS(2729),
    [anon_sym_COLON_QMARK] = ACTIONS(2729),
    [anon_sym_COLON_COLON] = ACTIONS(2731),
    [anon_sym_AMP] = ACTIONS(2729),
    [anon_sym_LBRACK] = ACTIONS(2729),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2731),
    [anon_sym_LBRACE] = ACTIONS(2729),
    [anon_sym_LT_AT] = ACTIONS(2729),
    [anon_sym_AT_GT] = ACTIONS(2729),
    [anon_sym_LT_AT_AT] = ACTIONS(2729),
    [anon_sym_DOT] = ACTIONS(2729),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2731),
    [anon_sym_new] = ACTIONS(2729),
    [anon_sym_return_BANG] = ACTIONS(2731),
    [anon_sym_yield] = ACTIONS(2729),
    [anon_sym_yield_BANG] = ACTIONS(2731),
    [anon_sym_lazy] = ACTIONS(2729),
    [anon_sym_assert] = ACTIONS(2729),
    [anon_sym_upcast] = ACTIONS(2729),
    [anon_sym_downcast] = ACTIONS(2729),
    [anon_sym_COLON_GT] = ACTIONS(2731),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2731),
    [anon_sym_for] = ACTIONS(2729),
    [anon_sym_while] = ACTIONS(2729),
    [anon_sym_else] = ACTIONS(2729),
    [anon_sym_elif] = ACTIONS(2729),
    [anon_sym_if] = ACTIONS(2729),
    [anon_sym_fun] = ACTIONS(2729),
    [anon_sym_try] = ACTIONS(2729),
    [anon_sym_match] = ACTIONS(2729),
    [anon_sym_match_BANG] = ACTIONS(2731),
    [anon_sym_function] = ACTIONS(2729),
    [anon_sym_LT_DASH] = ACTIONS(2729),
    [anon_sym_DOT_LBRACK] = ACTIONS(2731),
    [anon_sym_LT] = ACTIONS(2731),
    [anon_sym_use] = ACTIONS(2729),
    [anon_sym_use_BANG] = ACTIONS(2731),
    [anon_sym_do_BANG] = ACTIONS(2731),
    [anon_sym_begin] = ACTIONS(2729),
    [anon_sym_LPAREN2] = ACTIONS(2729),
    [anon_sym_or] = ACTIONS(2729),
    [aux_sym_char_token1] = ACTIONS(2731),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2729),
    [anon_sym_DQUOTE] = ACTIONS(2729),
    [anon_sym_AT_DQUOTE] = ACTIONS(2731),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2731),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2731),
    [sym_bool] = ACTIONS(2729),
    [sym_unit] = ACTIONS(2731),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2729),
    [sym_op_identifier] = ACTIONS(2729),
    [anon_sym_PLUS] = ACTIONS(2729),
    [anon_sym_DASH] = ACTIONS(2729),
    [anon_sym_PLUS_DOT] = ACTIONS(2729),
    [anon_sym_DASH_DOT] = ACTIONS(2729),
    [anon_sym_PERCENT] = ACTIONS(2729),
    [anon_sym_AMP_AMP] = ACTIONS(2729),
    [anon_sym_TILDE] = ACTIONS(2731),
    [aux_sym_prefix_op_token1] = ACTIONS(2729),
    [aux_sym_infix_op_token1] = ACTIONS(2731),
    [aux_sym_infix_op_token2] = ACTIONS(2729),
    [anon_sym_PIPE_PIPE] = ACTIONS(2729),
    [anon_sym_BANG_EQ] = ACTIONS(2729),
    [anon_sym_COLON_EQ] = ACTIONS(2731),
    [anon_sym_DOLLAR] = ACTIONS(2729),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2729),
    [sym_int] = ACTIONS(2729),
    [sym_xint] = ACTIONS(2731),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2731),
    [sym__newline] = ACTIONS(2731),
  },
  [1573] = {
    [sym_block_comment] = STATE(1573),
    [sym_compiler_directive_decl] = STATE(1573),
    [sym_fsi_directive_decl] = STATE(1573),
    [sym_preproc_line] = STATE(1573),
    [sym_identifier] = ACTIONS(2729),
    [anon_sym_EQ] = ACTIONS(2731),
    [anon_sym_COLON] = ACTIONS(2729),
    [anon_sym_return] = ACTIONS(2729),
    [anon_sym_do] = ACTIONS(2729),
    [anon_sym_let] = ACTIONS(2729),
    [anon_sym_let_BANG] = ACTIONS(2731),
    [anon_sym_LPAREN] = ACTIONS(2729),
    [anon_sym_COMMA] = ACTIONS(2731),
    [anon_sym_null] = ACTIONS(2729),
    [anon_sym_QMARK] = ACTIONS(2729),
    [anon_sym_COLON_QMARK] = ACTIONS(2729),
    [anon_sym_COLON_COLON] = ACTIONS(2731),
    [anon_sym_AMP] = ACTIONS(2729),
    [anon_sym_LBRACK] = ACTIONS(2729),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2731),
    [anon_sym_LBRACE] = ACTIONS(2729),
    [anon_sym_LT_AT] = ACTIONS(2729),
    [anon_sym_LT_AT_AT] = ACTIONS(2729),
    [anon_sym_AT_AT_GT] = ACTIONS(2729),
    [anon_sym_DOT] = ACTIONS(2729),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2731),
    [anon_sym_new] = ACTIONS(2729),
    [anon_sym_return_BANG] = ACTIONS(2731),
    [anon_sym_yield] = ACTIONS(2729),
    [anon_sym_yield_BANG] = ACTIONS(2731),
    [anon_sym_lazy] = ACTIONS(2729),
    [anon_sym_assert] = ACTIONS(2729),
    [anon_sym_upcast] = ACTIONS(2729),
    [anon_sym_downcast] = ACTIONS(2729),
    [anon_sym_COLON_GT] = ACTIONS(2731),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2731),
    [anon_sym_for] = ACTIONS(2729),
    [anon_sym_while] = ACTIONS(2729),
    [anon_sym_else] = ACTIONS(2729),
    [anon_sym_elif] = ACTIONS(2729),
    [anon_sym_if] = ACTIONS(2729),
    [anon_sym_fun] = ACTIONS(2729),
    [anon_sym_try] = ACTIONS(2729),
    [anon_sym_match] = ACTIONS(2729),
    [anon_sym_match_BANG] = ACTIONS(2731),
    [anon_sym_function] = ACTIONS(2729),
    [anon_sym_LT_DASH] = ACTIONS(2729),
    [anon_sym_DOT_LBRACK] = ACTIONS(2731),
    [anon_sym_LT] = ACTIONS(2731),
    [anon_sym_use] = ACTIONS(2729),
    [anon_sym_use_BANG] = ACTIONS(2731),
    [anon_sym_do_BANG] = ACTIONS(2731),
    [anon_sym_begin] = ACTIONS(2729),
    [anon_sym_LPAREN2] = ACTIONS(2729),
    [anon_sym_or] = ACTIONS(2729),
    [aux_sym_char_token1] = ACTIONS(2731),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2729),
    [anon_sym_DQUOTE] = ACTIONS(2729),
    [anon_sym_AT_DQUOTE] = ACTIONS(2731),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2731),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2731),
    [sym_bool] = ACTIONS(2729),
    [sym_unit] = ACTIONS(2731),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2729),
    [sym_op_identifier] = ACTIONS(2729),
    [anon_sym_PLUS] = ACTIONS(2729),
    [anon_sym_DASH] = ACTIONS(2729),
    [anon_sym_PLUS_DOT] = ACTIONS(2729),
    [anon_sym_DASH_DOT] = ACTIONS(2729),
    [anon_sym_PERCENT] = ACTIONS(2729),
    [anon_sym_AMP_AMP] = ACTIONS(2729),
    [anon_sym_TILDE] = ACTIONS(2731),
    [aux_sym_prefix_op_token1] = ACTIONS(2729),
    [aux_sym_infix_op_token1] = ACTIONS(2731),
    [aux_sym_infix_op_token2] = ACTIONS(2729),
    [anon_sym_PIPE_PIPE] = ACTIONS(2729),
    [anon_sym_BANG_EQ] = ACTIONS(2729),
    [anon_sym_COLON_EQ] = ACTIONS(2731),
    [anon_sym_DOLLAR] = ACTIONS(2729),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2729),
    [sym_int] = ACTIONS(2729),
    [sym_xint] = ACTIONS(2731),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2731),
    [sym__newline] = ACTIONS(2731),
  },
  [1574] = {
    [sym_block_comment] = STATE(1574),
    [sym_compiler_directive_decl] = STATE(1574),
    [sym_fsi_directive_decl] = STATE(1574),
    [sym_preproc_line] = STATE(1574),
    [aux_sym_rules_repeat1] = STATE(1529),
    [sym_identifier] = ACTIONS(2689),
    [anon_sym_EQ] = ACTIONS(2691),
    [anon_sym_COLON] = ACTIONS(2689),
    [anon_sym_return] = ACTIONS(2689),
    [anon_sym_do] = ACTIONS(2689),
    [anon_sym_let] = ACTIONS(2689),
    [anon_sym_let_BANG] = ACTIONS(2691),
    [anon_sym_LPAREN] = ACTIONS(2689),
    [anon_sym_COMMA] = ACTIONS(2691),
    [anon_sym_null] = ACTIONS(2689),
    [anon_sym_QMARK] = ACTIONS(2689),
    [anon_sym_COLON_QMARK] = ACTIONS(2689),
    [anon_sym_COLON_COLON] = ACTIONS(2691),
    [anon_sym_PIPE] = ACTIONS(3759),
    [anon_sym_AMP] = ACTIONS(2689),
    [anon_sym_LBRACK] = ACTIONS(2689),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2691),
    [anon_sym_LBRACE] = ACTIONS(2689),
    [anon_sym_LT_AT] = ACTIONS(2689),
    [anon_sym_LT_AT_AT] = ACTIONS(2689),
    [anon_sym_DOT] = ACTIONS(2689),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2691),
    [anon_sym_new] = ACTIONS(2689),
    [anon_sym_return_BANG] = ACTIONS(2691),
    [anon_sym_yield] = ACTIONS(2689),
    [anon_sym_yield_BANG] = ACTIONS(2691),
    [anon_sym_lazy] = ACTIONS(2689),
    [anon_sym_assert] = ACTIONS(2689),
    [anon_sym_upcast] = ACTIONS(2689),
    [anon_sym_downcast] = ACTIONS(2689),
    [anon_sym_COLON_GT] = ACTIONS(2691),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2691),
    [anon_sym_for] = ACTIONS(2689),
    [anon_sym_while] = ACTIONS(2689),
    [anon_sym_if] = ACTIONS(2689),
    [anon_sym_fun] = ACTIONS(2689),
    [anon_sym_try] = ACTIONS(2689),
    [anon_sym_match] = ACTIONS(2689),
    [anon_sym_match_BANG] = ACTIONS(2691),
    [anon_sym_function] = ACTIONS(2689),
    [anon_sym_LT_DASH] = ACTIONS(2689),
    [anon_sym_DOT_LBRACK] = ACTIONS(2691),
    [anon_sym_LT] = ACTIONS(2691),
    [anon_sym_GT] = ACTIONS(2689),
    [anon_sym_use] = ACTIONS(2689),
    [anon_sym_use_BANG] = ACTIONS(2691),
    [anon_sym_do_BANG] = ACTIONS(2691),
    [anon_sym_begin] = ACTIONS(2689),
    [anon_sym_LPAREN2] = ACTIONS(2689),
    [anon_sym_or] = ACTIONS(2689),
    [aux_sym_char_token1] = ACTIONS(2691),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2689),
    [anon_sym_DQUOTE] = ACTIONS(2689),
    [anon_sym_AT_DQUOTE] = ACTIONS(2691),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2691),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2691),
    [sym_bool] = ACTIONS(2689),
    [sym_unit] = ACTIONS(2691),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2689),
    [sym_op_identifier] = ACTIONS(2689),
    [anon_sym_PLUS] = ACTIONS(2689),
    [anon_sym_DASH] = ACTIONS(2689),
    [anon_sym_PLUS_DOT] = ACTIONS(2689),
    [anon_sym_DASH_DOT] = ACTIONS(2689),
    [anon_sym_PERCENT] = ACTIONS(2689),
    [anon_sym_AMP_AMP] = ACTIONS(2689),
    [anon_sym_TILDE] = ACTIONS(2691),
    [aux_sym_prefix_op_token1] = ACTIONS(2689),
    [aux_sym_infix_op_token1] = ACTIONS(2691),
    [aux_sym_infix_op_token2] = ACTIONS(2689),
    [anon_sym_PIPE_PIPE] = ACTIONS(2689),
    [anon_sym_BANG_EQ] = ACTIONS(2689),
    [anon_sym_COLON_EQ] = ACTIONS(2691),
    [anon_sym_DOLLAR] = ACTIONS(2689),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2689),
    [sym_int] = ACTIONS(2689),
    [sym_xint] = ACTIONS(2691),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2691),
    [sym__newline] = ACTIONS(3805),
  },
  [1575] = {
    [sym_block_comment] = STATE(1575),
    [sym_compiler_directive_decl] = STATE(1575),
    [sym_fsi_directive_decl] = STATE(1575),
    [sym_preproc_line] = STATE(1575),
    [sym_identifier] = ACTIONS(2812),
    [anon_sym_EQ] = ACTIONS(2814),
    [anon_sym_COLON] = ACTIONS(2812),
    [anon_sym_return] = ACTIONS(2812),
    [anon_sym_do] = ACTIONS(2812),
    [anon_sym_let] = ACTIONS(2812),
    [anon_sym_let_BANG] = ACTIONS(2814),
    [anon_sym_LPAREN] = ACTIONS(2812),
    [anon_sym_COMMA] = ACTIONS(2814),
    [anon_sym_null] = ACTIONS(2812),
    [anon_sym_QMARK] = ACTIONS(2812),
    [anon_sym_COLON_QMARK] = ACTIONS(2812),
    [anon_sym_COLON_COLON] = ACTIONS(2814),
    [anon_sym_AMP] = ACTIONS(2812),
    [anon_sym_LBRACK] = ACTIONS(2812),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2814),
    [anon_sym_LBRACE] = ACTIONS(2812),
    [anon_sym_LT_AT] = ACTIONS(2812),
    [anon_sym_LT_AT_AT] = ACTIONS(2812),
    [anon_sym_DOT] = ACTIONS(2812),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2814),
    [anon_sym_new] = ACTIONS(2812),
    [anon_sym_return_BANG] = ACTIONS(2814),
    [anon_sym_yield] = ACTIONS(2812),
    [anon_sym_yield_BANG] = ACTIONS(2814),
    [anon_sym_lazy] = ACTIONS(2812),
    [anon_sym_assert] = ACTIONS(2812),
    [anon_sym_upcast] = ACTIONS(2812),
    [anon_sym_downcast] = ACTIONS(2812),
    [anon_sym_COLON_GT] = ACTIONS(2814),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2814),
    [anon_sym_for] = ACTIONS(2812),
    [anon_sym_while] = ACTIONS(2812),
    [anon_sym_if] = ACTIONS(2812),
    [anon_sym_fun] = ACTIONS(2812),
    [anon_sym_try] = ACTIONS(2812),
    [anon_sym_match] = ACTIONS(2812),
    [anon_sym_match_BANG] = ACTIONS(2814),
    [anon_sym_function] = ACTIONS(2812),
    [anon_sym_LT_DASH] = ACTIONS(2812),
    [anon_sym_DOT_LBRACK] = ACTIONS(2814),
    [anon_sym_LT] = ACTIONS(2814),
    [anon_sym_use] = ACTIONS(2812),
    [anon_sym_use_BANG] = ACTIONS(2814),
    [anon_sym_do_BANG] = ACTIONS(2814),
    [anon_sym_DOT_DOT] = ACTIONS(2814),
    [anon_sym_begin] = ACTIONS(2812),
    [anon_sym_LPAREN2] = ACTIONS(2812),
    [anon_sym_or] = ACTIONS(2812),
    [aux_sym_char_token1] = ACTIONS(2814),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2812),
    [anon_sym_DQUOTE] = ACTIONS(2812),
    [anon_sym_AT_DQUOTE] = ACTIONS(2814),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2814),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2814),
    [sym_bool] = ACTIONS(2812),
    [sym_unit] = ACTIONS(2814),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2812),
    [sym_op_identifier] = ACTIONS(2812),
    [anon_sym_PLUS] = ACTIONS(2812),
    [anon_sym_DASH] = ACTIONS(2812),
    [anon_sym_PLUS_DOT] = ACTIONS(2812),
    [anon_sym_DASH_DOT] = ACTIONS(2812),
    [anon_sym_PERCENT] = ACTIONS(2812),
    [anon_sym_AMP_AMP] = ACTIONS(2812),
    [anon_sym_TILDE] = ACTIONS(2814),
    [aux_sym_prefix_op_token1] = ACTIONS(2812),
    [aux_sym_infix_op_token1] = ACTIONS(2814),
    [aux_sym_infix_op_token2] = ACTIONS(2812),
    [anon_sym_PIPE_PIPE] = ACTIONS(2812),
    [anon_sym_BANG_EQ] = ACTIONS(2812),
    [anon_sym_COLON_EQ] = ACTIONS(2814),
    [anon_sym_DOLLAR] = ACTIONS(2812),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2812),
    [sym_int] = ACTIONS(2812),
    [sym_xint] = ACTIONS(2814),
    [anon_sym_f] = ACTIONS(2812),
    [aux_sym_decimal_token1] = ACTIONS(2812),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2814),
    [sym__newline] = ACTIONS(2814),
  },
  [1576] = {
    [sym_block_comment] = STATE(1576),
    [sym_compiler_directive_decl] = STATE(1576),
    [sym_fsi_directive_decl] = STATE(1576),
    [sym_preproc_line] = STATE(1576),
    [sym_identifier] = ACTIONS(2938),
    [anon_sym_EQ] = ACTIONS(2940),
    [anon_sym_COLON] = ACTIONS(2938),
    [anon_sym_return] = ACTIONS(2938),
    [anon_sym_do] = ACTIONS(2938),
    [anon_sym_let] = ACTIONS(2938),
    [anon_sym_let_BANG] = ACTIONS(2940),
    [anon_sym_as] = ACTIONS(2938),
    [anon_sym_LPAREN] = ACTIONS(2938),
    [anon_sym_COMMA] = ACTIONS(2940),
    [anon_sym_null] = ACTIONS(2938),
    [anon_sym_QMARK] = ACTIONS(2938),
    [anon_sym_COLON_QMARK] = ACTIONS(2938),
    [anon_sym_COLON_COLON] = ACTIONS(2940),
    [anon_sym_AMP] = ACTIONS(2938),
    [anon_sym_LBRACK] = ACTIONS(2938),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2940),
    [anon_sym_LBRACE] = ACTIONS(2938),
    [anon_sym_LT_AT] = ACTIONS(2938),
    [anon_sym_LT_AT_AT] = ACTIONS(2938),
    [anon_sym_DOT] = ACTIONS(2938),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2940),
    [anon_sym_new] = ACTIONS(2938),
    [anon_sym_with] = ACTIONS(2938),
    [anon_sym_return_BANG] = ACTIONS(2940),
    [anon_sym_yield] = ACTIONS(2938),
    [anon_sym_yield_BANG] = ACTIONS(2940),
    [anon_sym_lazy] = ACTIONS(2938),
    [anon_sym_assert] = ACTIONS(2938),
    [anon_sym_upcast] = ACTIONS(2938),
    [anon_sym_downcast] = ACTIONS(2938),
    [anon_sym_COLON_GT] = ACTIONS(2940),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2940),
    [anon_sym_for] = ACTIONS(2938),
    [anon_sym_while] = ACTIONS(2938),
    [anon_sym_if] = ACTIONS(2938),
    [anon_sym_fun] = ACTIONS(2938),
    [anon_sym_try] = ACTIONS(2938),
    [anon_sym_match] = ACTIONS(2938),
    [anon_sym_match_BANG] = ACTIONS(2940),
    [anon_sym_function] = ACTIONS(2938),
    [anon_sym_LT_DASH] = ACTIONS(2938),
    [anon_sym_DOT_LBRACK] = ACTIONS(2940),
    [anon_sym_LT] = ACTIONS(2940),
    [anon_sym_use] = ACTIONS(2938),
    [anon_sym_use_BANG] = ACTIONS(2940),
    [anon_sym_do_BANG] = ACTIONS(2940),
    [anon_sym_begin] = ACTIONS(2938),
    [anon_sym_LPAREN2] = ACTIONS(2938),
    [anon_sym_or] = ACTIONS(2938),
    [aux_sym_char_token1] = ACTIONS(2940),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2938),
    [anon_sym_DQUOTE] = ACTIONS(2938),
    [anon_sym_AT_DQUOTE] = ACTIONS(2940),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2940),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2940),
    [sym_bool] = ACTIONS(2938),
    [sym_unit] = ACTIONS(2940),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2938),
    [sym_op_identifier] = ACTIONS(2938),
    [anon_sym_PLUS] = ACTIONS(2938),
    [anon_sym_DASH] = ACTIONS(2938),
    [anon_sym_PLUS_DOT] = ACTIONS(2938),
    [anon_sym_DASH_DOT] = ACTIONS(2938),
    [anon_sym_PERCENT] = ACTIONS(2938),
    [anon_sym_AMP_AMP] = ACTIONS(2938),
    [anon_sym_TILDE] = ACTIONS(2940),
    [aux_sym_prefix_op_token1] = ACTIONS(2938),
    [aux_sym_infix_op_token1] = ACTIONS(2940),
    [aux_sym_infix_op_token2] = ACTIONS(2938),
    [anon_sym_PIPE_PIPE] = ACTIONS(2938),
    [anon_sym_BANG_EQ] = ACTIONS(2938),
    [anon_sym_COLON_EQ] = ACTIONS(2940),
    [anon_sym_DOLLAR] = ACTIONS(2938),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2938),
    [sym_int] = ACTIONS(2938),
    [sym_xint] = ACTIONS(2940),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2940),
    [sym__newline] = ACTIONS(2940),
    [sym__dedent] = ACTIONS(2940),
  },
  [1577] = {
    [sym_block_comment] = STATE(1577),
    [sym_compiler_directive_decl] = STATE(1577),
    [sym_fsi_directive_decl] = STATE(1577),
    [sym_preproc_line] = STATE(1577),
    [sym_identifier] = ACTIONS(2723),
    [anon_sym_EQ] = ACTIONS(2725),
    [anon_sym_COLON] = ACTIONS(2723),
    [anon_sym_return] = ACTIONS(2723),
    [anon_sym_do] = ACTIONS(2723),
    [anon_sym_let] = ACTIONS(2723),
    [anon_sym_let_BANG] = ACTIONS(2725),
    [anon_sym_LPAREN] = ACTIONS(2723),
    [anon_sym_COMMA] = ACTIONS(2725),
    [anon_sym_null] = ACTIONS(2723),
    [anon_sym_QMARK] = ACTIONS(2723),
    [anon_sym_COLON_QMARK] = ACTIONS(2723),
    [anon_sym_COLON_COLON] = ACTIONS(2725),
    [anon_sym_AMP] = ACTIONS(2723),
    [anon_sym_LBRACK] = ACTIONS(2723),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2725),
    [anon_sym_LBRACE] = ACTIONS(2723),
    [anon_sym_LT_AT] = ACTIONS(2723),
    [anon_sym_LT_AT_AT] = ACTIONS(2723),
    [anon_sym_AT_AT_GT] = ACTIONS(2723),
    [anon_sym_DOT] = ACTIONS(2723),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2725),
    [anon_sym_new] = ACTIONS(2723),
    [anon_sym_return_BANG] = ACTIONS(2725),
    [anon_sym_yield] = ACTIONS(2723),
    [anon_sym_yield_BANG] = ACTIONS(2725),
    [anon_sym_lazy] = ACTIONS(2723),
    [anon_sym_assert] = ACTIONS(2723),
    [anon_sym_upcast] = ACTIONS(2723),
    [anon_sym_downcast] = ACTIONS(2723),
    [anon_sym_COLON_GT] = ACTIONS(2725),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2725),
    [anon_sym_for] = ACTIONS(2723),
    [anon_sym_while] = ACTIONS(2723),
    [anon_sym_if] = ACTIONS(2723),
    [anon_sym_fun] = ACTIONS(2723),
    [anon_sym_try] = ACTIONS(2723),
    [anon_sym_match] = ACTIONS(2723),
    [anon_sym_match_BANG] = ACTIONS(2725),
    [anon_sym_function] = ACTIONS(2723),
    [anon_sym_LT_DASH] = ACTIONS(2723),
    [anon_sym_DOT_LBRACK] = ACTIONS(2725),
    [anon_sym_LT] = ACTIONS(2725),
    [anon_sym_use] = ACTIONS(2723),
    [anon_sym_use_BANG] = ACTIONS(2725),
    [anon_sym_do_BANG] = ACTIONS(2725),
    [anon_sym_begin] = ACTIONS(2723),
    [anon_sym_LPAREN2] = ACTIONS(2723),
    [anon_sym_or] = ACTIONS(2723),
    [aux_sym_char_token1] = ACTIONS(2725),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2723),
    [anon_sym_DQUOTE] = ACTIONS(2723),
    [anon_sym_AT_DQUOTE] = ACTIONS(2725),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2725),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2725),
    [sym_bool] = ACTIONS(2723),
    [sym_unit] = ACTIONS(2725),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2723),
    [sym_op_identifier] = ACTIONS(2723),
    [anon_sym_PLUS] = ACTIONS(2723),
    [anon_sym_DASH] = ACTIONS(2723),
    [anon_sym_PLUS_DOT] = ACTIONS(2723),
    [anon_sym_DASH_DOT] = ACTIONS(2723),
    [anon_sym_PERCENT] = ACTIONS(2723),
    [anon_sym_AMP_AMP] = ACTIONS(2723),
    [anon_sym_TILDE] = ACTIONS(2725),
    [aux_sym_prefix_op_token1] = ACTIONS(2723),
    [aux_sym_infix_op_token1] = ACTIONS(2725),
    [aux_sym_infix_op_token2] = ACTIONS(2723),
    [anon_sym_PIPE_PIPE] = ACTIONS(2723),
    [anon_sym_BANG_EQ] = ACTIONS(2723),
    [anon_sym_COLON_EQ] = ACTIONS(2725),
    [anon_sym_DOLLAR] = ACTIONS(2723),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2723),
    [sym_int] = ACTIONS(2723),
    [sym_xint] = ACTIONS(2725),
    [anon_sym_f] = ACTIONS(2723),
    [aux_sym_decimal_token1] = ACTIONS(2723),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2725),
    [sym__newline] = ACTIONS(2725),
  },
  [1578] = {
    [sym_block_comment] = STATE(1578),
    [sym_compiler_directive_decl] = STATE(1578),
    [sym_fsi_directive_decl] = STATE(1578),
    [sym_preproc_line] = STATE(1578),
    [aux_sym_sequential_expression_repeat1] = STATE(1655),
    [sym_identifier] = ACTIONS(2847),
    [anon_sym_EQ] = ACTIONS(2849),
    [anon_sym_COLON] = ACTIONS(2847),
    [anon_sym_return] = ACTIONS(2847),
    [anon_sym_do] = ACTIONS(2847),
    [anon_sym_let] = ACTIONS(2847),
    [anon_sym_let_BANG] = ACTIONS(2849),
    [anon_sym_LPAREN] = ACTIONS(2847),
    [anon_sym_COMMA] = ACTIONS(2849),
    [anon_sym_null] = ACTIONS(2847),
    [anon_sym_QMARK] = ACTIONS(2847),
    [anon_sym_COLON_QMARK] = ACTIONS(2847),
    [anon_sym_COLON_COLON] = ACTIONS(2849),
    [anon_sym_AMP] = ACTIONS(2847),
    [anon_sym_LBRACK] = ACTIONS(2847),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2849),
    [anon_sym_LBRACE] = ACTIONS(2847),
    [anon_sym_LT_AT] = ACTIONS(2847),
    [anon_sym_LT_AT_AT] = ACTIONS(2847),
    [anon_sym_DOT] = ACTIONS(2847),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2849),
    [anon_sym_new] = ACTIONS(2847),
    [anon_sym_return_BANG] = ACTIONS(2849),
    [anon_sym_yield] = ACTIONS(2847),
    [anon_sym_yield_BANG] = ACTIONS(2849),
    [anon_sym_lazy] = ACTIONS(2847),
    [anon_sym_assert] = ACTIONS(2847),
    [anon_sym_upcast] = ACTIONS(2847),
    [anon_sym_downcast] = ACTIONS(2847),
    [anon_sym_COLON_GT] = ACTIONS(2849),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2849),
    [anon_sym_for] = ACTIONS(2847),
    [anon_sym_while] = ACTIONS(2847),
    [anon_sym_if] = ACTIONS(2847),
    [anon_sym_fun] = ACTIONS(2847),
    [anon_sym_try] = ACTIONS(2847),
    [anon_sym_match] = ACTIONS(2847),
    [anon_sym_match_BANG] = ACTIONS(2849),
    [anon_sym_function] = ACTIONS(2847),
    [anon_sym_LT_DASH] = ACTIONS(2847),
    [anon_sym_DOT_LBRACK] = ACTIONS(2849),
    [anon_sym_LT] = ACTIONS(2849),
    [anon_sym_use] = ACTIONS(2847),
    [anon_sym_use_BANG] = ACTIONS(2849),
    [anon_sym_do_BANG] = ACTIONS(2849),
    [anon_sym_begin] = ACTIONS(2847),
    [anon_sym_LPAREN2] = ACTIONS(2847),
    [anon_sym_DOT_DOT2] = ACTIONS(2849),
    [anon_sym_or] = ACTIONS(2847),
    [aux_sym_char_token1] = ACTIONS(2849),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2847),
    [anon_sym_DQUOTE] = ACTIONS(2847),
    [anon_sym_AT_DQUOTE] = ACTIONS(2849),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2849),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2849),
    [sym_bool] = ACTIONS(2847),
    [sym_unit] = ACTIONS(2849),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2847),
    [sym_op_identifier] = ACTIONS(2847),
    [anon_sym_PLUS] = ACTIONS(2847),
    [anon_sym_DASH] = ACTIONS(2847),
    [anon_sym_PLUS_DOT] = ACTIONS(2847),
    [anon_sym_DASH_DOT] = ACTIONS(2847),
    [anon_sym_PERCENT] = ACTIONS(2847),
    [anon_sym_AMP_AMP] = ACTIONS(2847),
    [anon_sym_TILDE] = ACTIONS(2849),
    [aux_sym_prefix_op_token1] = ACTIONS(2847),
    [aux_sym_infix_op_token1] = ACTIONS(2849),
    [aux_sym_infix_op_token2] = ACTIONS(2847),
    [anon_sym_PIPE_PIPE] = ACTIONS(2847),
    [anon_sym_BANG_EQ] = ACTIONS(2847),
    [anon_sym_COLON_EQ] = ACTIONS(2849),
    [anon_sym_DOLLAR] = ACTIONS(2847),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2847),
    [sym_int] = ACTIONS(2847),
    [sym_xint] = ACTIONS(2849),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2849),
    [sym__newline] = ACTIONS(2849),
    [sym__dedent] = ACTIONS(2849),
  },
  [1579] = {
    [sym_block_comment] = STATE(1579),
    [sym_compiler_directive_decl] = STATE(1579),
    [sym_fsi_directive_decl] = STATE(1579),
    [sym_preproc_line] = STATE(1579),
    [aux_sym_long_identifier_repeat1] = STATE(1582),
    [sym_identifier] = ACTIONS(2418),
    [anon_sym_EQ] = ACTIONS(2420),
    [anon_sym_COLON] = ACTIONS(2418),
    [anon_sym_return] = ACTIONS(2418),
    [anon_sym_do] = ACTIONS(2418),
    [anon_sym_let] = ACTIONS(2418),
    [anon_sym_let_BANG] = ACTIONS(2420),
    [anon_sym_LPAREN] = ACTIONS(2418),
    [anon_sym_COMMA] = ACTIONS(2420),
    [anon_sym_null] = ACTIONS(2418),
    [anon_sym_QMARK] = ACTIONS(2418),
    [anon_sym_COLON_QMARK] = ACTIONS(2418),
    [anon_sym_COLON_COLON] = ACTIONS(2420),
    [anon_sym_AMP] = ACTIONS(2418),
    [anon_sym_LBRACK] = ACTIONS(2418),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2420),
    [anon_sym_LBRACE] = ACTIONS(2418),
    [anon_sym_LT_AT] = ACTIONS(2418),
    [anon_sym_LT_AT_AT] = ACTIONS(2418),
    [anon_sym_DOT] = ACTIONS(3808),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2420),
    [anon_sym_new] = ACTIONS(2418),
    [anon_sym_return_BANG] = ACTIONS(2420),
    [anon_sym_yield] = ACTIONS(2418),
    [anon_sym_yield_BANG] = ACTIONS(2420),
    [anon_sym_lazy] = ACTIONS(2418),
    [anon_sym_assert] = ACTIONS(2418),
    [anon_sym_upcast] = ACTIONS(2418),
    [anon_sym_downcast] = ACTIONS(2418),
    [anon_sym_COLON_GT] = ACTIONS(2420),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2420),
    [anon_sym_for] = ACTIONS(2418),
    [anon_sym_while] = ACTIONS(2418),
    [anon_sym_if] = ACTIONS(2418),
    [anon_sym_fun] = ACTIONS(2418),
    [anon_sym_DASH_GT] = ACTIONS(2418),
    [anon_sym_try] = ACTIONS(2418),
    [anon_sym_match] = ACTIONS(2418),
    [anon_sym_match_BANG] = ACTIONS(2420),
    [anon_sym_function] = ACTIONS(2418),
    [anon_sym_LT_DASH] = ACTIONS(2418),
    [anon_sym_DOT_LBRACK] = ACTIONS(2420),
    [anon_sym_LT] = ACTIONS(2420),
    [anon_sym_use] = ACTIONS(2418),
    [anon_sym_use_BANG] = ACTIONS(2420),
    [anon_sym_do_BANG] = ACTIONS(2420),
    [anon_sym_DOT_DOT] = ACTIONS(2420),
    [anon_sym_begin] = ACTIONS(2418),
    [anon_sym_LPAREN2] = ACTIONS(2418),
    [anon_sym_or] = ACTIONS(2418),
    [aux_sym_char_token1] = ACTIONS(2420),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2418),
    [anon_sym_DQUOTE] = ACTIONS(2418),
    [anon_sym_AT_DQUOTE] = ACTIONS(2420),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2420),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2420),
    [sym_bool] = ACTIONS(2418),
    [sym_unit] = ACTIONS(2420),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2418),
    [sym_op_identifier] = ACTIONS(2418),
    [anon_sym_PLUS] = ACTIONS(2418),
    [anon_sym_DASH] = ACTIONS(2418),
    [anon_sym_PLUS_DOT] = ACTIONS(2418),
    [anon_sym_DASH_DOT] = ACTIONS(2418),
    [anon_sym_PERCENT] = ACTIONS(2418),
    [anon_sym_AMP_AMP] = ACTIONS(2418),
    [anon_sym_TILDE] = ACTIONS(2420),
    [aux_sym_prefix_op_token1] = ACTIONS(2418),
    [aux_sym_infix_op_token1] = ACTIONS(2420),
    [aux_sym_infix_op_token2] = ACTIONS(2418),
    [anon_sym_PIPE_PIPE] = ACTIONS(2418),
    [anon_sym_BANG_EQ] = ACTIONS(2418),
    [anon_sym_COLON_EQ] = ACTIONS(2420),
    [anon_sym_DOLLAR] = ACTIONS(2418),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2418),
    [sym_int] = ACTIONS(2418),
    [sym_xint] = ACTIONS(2420),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2420),
    [sym__newline] = ACTIONS(2420),
  },
  [1580] = {
    [sym_block_comment] = STATE(1580),
    [sym_compiler_directive_decl] = STATE(1580),
    [sym_fsi_directive_decl] = STATE(1580),
    [sym_preproc_line] = STATE(1580),
    [sym_identifier] = ACTIONS(3059),
    [anon_sym_EQ] = ACTIONS(3061),
    [anon_sym_COLON] = ACTIONS(3059),
    [anon_sym_return] = ACTIONS(3059),
    [anon_sym_do] = ACTIONS(3059),
    [anon_sym_let] = ACTIONS(3059),
    [anon_sym_let_BANG] = ACTIONS(3061),
    [anon_sym_as] = ACTIONS(3059),
    [anon_sym_LPAREN] = ACTIONS(3059),
    [anon_sym_COMMA] = ACTIONS(3061),
    [anon_sym_null] = ACTIONS(3059),
    [anon_sym_QMARK] = ACTIONS(3059),
    [anon_sym_COLON_QMARK] = ACTIONS(3059),
    [anon_sym_COLON_COLON] = ACTIONS(3061),
    [anon_sym_AMP] = ACTIONS(3059),
    [anon_sym_LBRACK] = ACTIONS(3059),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3061),
    [anon_sym_LBRACE] = ACTIONS(3059),
    [anon_sym_LT_AT] = ACTIONS(3059),
    [anon_sym_LT_AT_AT] = ACTIONS(3059),
    [anon_sym_DOT] = ACTIONS(3059),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3061),
    [anon_sym_new] = ACTIONS(3059),
    [anon_sym_with] = ACTIONS(3059),
    [anon_sym_return_BANG] = ACTIONS(3061),
    [anon_sym_yield] = ACTIONS(3059),
    [anon_sym_yield_BANG] = ACTIONS(3061),
    [anon_sym_lazy] = ACTIONS(3059),
    [anon_sym_assert] = ACTIONS(3059),
    [anon_sym_upcast] = ACTIONS(3059),
    [anon_sym_downcast] = ACTIONS(3059),
    [anon_sym_COLON_GT] = ACTIONS(3061),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3061),
    [anon_sym_for] = ACTIONS(3059),
    [anon_sym_while] = ACTIONS(3059),
    [anon_sym_if] = ACTIONS(3059),
    [anon_sym_fun] = ACTIONS(3059),
    [anon_sym_try] = ACTIONS(3059),
    [anon_sym_match] = ACTIONS(3059),
    [anon_sym_match_BANG] = ACTIONS(3061),
    [anon_sym_function] = ACTIONS(3059),
    [anon_sym_LT_DASH] = ACTIONS(3059),
    [anon_sym_DOT_LBRACK] = ACTIONS(3061),
    [anon_sym_LT] = ACTIONS(3061),
    [anon_sym_use] = ACTIONS(3059),
    [anon_sym_use_BANG] = ACTIONS(3061),
    [anon_sym_do_BANG] = ACTIONS(3061),
    [anon_sym_begin] = ACTIONS(3059),
    [anon_sym_LPAREN2] = ACTIONS(3059),
    [anon_sym_or] = ACTIONS(3059),
    [aux_sym_char_token1] = ACTIONS(3061),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3059),
    [anon_sym_DQUOTE] = ACTIONS(3059),
    [anon_sym_AT_DQUOTE] = ACTIONS(3061),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3061),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3061),
    [sym_bool] = ACTIONS(3059),
    [sym_unit] = ACTIONS(3061),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3059),
    [sym_op_identifier] = ACTIONS(3059),
    [anon_sym_PLUS] = ACTIONS(3059),
    [anon_sym_DASH] = ACTIONS(3059),
    [anon_sym_PLUS_DOT] = ACTIONS(3059),
    [anon_sym_DASH_DOT] = ACTIONS(3059),
    [anon_sym_PERCENT] = ACTIONS(3059),
    [anon_sym_AMP_AMP] = ACTIONS(3059),
    [anon_sym_TILDE] = ACTIONS(3061),
    [aux_sym_prefix_op_token1] = ACTIONS(3059),
    [aux_sym_infix_op_token1] = ACTIONS(3061),
    [aux_sym_infix_op_token2] = ACTIONS(3059),
    [anon_sym_PIPE_PIPE] = ACTIONS(3059),
    [anon_sym_BANG_EQ] = ACTIONS(3059),
    [anon_sym_COLON_EQ] = ACTIONS(3061),
    [anon_sym_DOLLAR] = ACTIONS(3059),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3059),
    [sym_int] = ACTIONS(3059),
    [sym_xint] = ACTIONS(3061),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3061),
    [sym__newline] = ACTIONS(3061),
    [sym__dedent] = ACTIONS(3061),
  },
  [1581] = {
    [sym_block_comment] = STATE(1581),
    [sym_compiler_directive_decl] = STATE(1581),
    [sym_fsi_directive_decl] = STATE(1581),
    [sym_preproc_line] = STATE(1581),
    [sym_identifier] = ACTIONS(3063),
    [anon_sym_EQ] = ACTIONS(3065),
    [anon_sym_COLON] = ACTIONS(3063),
    [anon_sym_return] = ACTIONS(3063),
    [anon_sym_do] = ACTIONS(3063),
    [anon_sym_let] = ACTIONS(3063),
    [anon_sym_let_BANG] = ACTIONS(3065),
    [anon_sym_as] = ACTIONS(3063),
    [anon_sym_LPAREN] = ACTIONS(3063),
    [anon_sym_COMMA] = ACTIONS(3065),
    [anon_sym_null] = ACTIONS(3063),
    [anon_sym_QMARK] = ACTIONS(3063),
    [anon_sym_COLON_QMARK] = ACTIONS(3063),
    [anon_sym_COLON_COLON] = ACTIONS(3065),
    [anon_sym_AMP] = ACTIONS(3063),
    [anon_sym_LBRACK] = ACTIONS(3063),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3065),
    [anon_sym_LBRACE] = ACTIONS(3063),
    [anon_sym_LT_AT] = ACTIONS(3063),
    [anon_sym_LT_AT_AT] = ACTIONS(3063),
    [anon_sym_DOT] = ACTIONS(3063),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3065),
    [anon_sym_new] = ACTIONS(3063),
    [anon_sym_with] = ACTIONS(3063),
    [anon_sym_return_BANG] = ACTIONS(3065),
    [anon_sym_yield] = ACTIONS(3063),
    [anon_sym_yield_BANG] = ACTIONS(3065),
    [anon_sym_lazy] = ACTIONS(3063),
    [anon_sym_assert] = ACTIONS(3063),
    [anon_sym_upcast] = ACTIONS(3063),
    [anon_sym_downcast] = ACTIONS(3063),
    [anon_sym_COLON_GT] = ACTIONS(3065),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3065),
    [anon_sym_for] = ACTIONS(3063),
    [anon_sym_while] = ACTIONS(3063),
    [anon_sym_if] = ACTIONS(3063),
    [anon_sym_fun] = ACTIONS(3063),
    [anon_sym_try] = ACTIONS(3063),
    [anon_sym_match] = ACTIONS(3063),
    [anon_sym_match_BANG] = ACTIONS(3065),
    [anon_sym_function] = ACTIONS(3063),
    [anon_sym_LT_DASH] = ACTIONS(3063),
    [anon_sym_DOT_LBRACK] = ACTIONS(3065),
    [anon_sym_LT] = ACTIONS(3065),
    [anon_sym_use] = ACTIONS(3063),
    [anon_sym_use_BANG] = ACTIONS(3065),
    [anon_sym_do_BANG] = ACTIONS(3065),
    [anon_sym_begin] = ACTIONS(3063),
    [anon_sym_LPAREN2] = ACTIONS(3063),
    [anon_sym_or] = ACTIONS(3063),
    [aux_sym_char_token1] = ACTIONS(3065),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3063),
    [anon_sym_DQUOTE] = ACTIONS(3063),
    [anon_sym_AT_DQUOTE] = ACTIONS(3065),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3065),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3065),
    [sym_bool] = ACTIONS(3063),
    [sym_unit] = ACTIONS(3065),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3063),
    [sym_op_identifier] = ACTIONS(3063),
    [anon_sym_PLUS] = ACTIONS(3063),
    [anon_sym_DASH] = ACTIONS(3063),
    [anon_sym_PLUS_DOT] = ACTIONS(3063),
    [anon_sym_DASH_DOT] = ACTIONS(3063),
    [anon_sym_PERCENT] = ACTIONS(3063),
    [anon_sym_AMP_AMP] = ACTIONS(3063),
    [anon_sym_TILDE] = ACTIONS(3065),
    [aux_sym_prefix_op_token1] = ACTIONS(3063),
    [aux_sym_infix_op_token1] = ACTIONS(3065),
    [aux_sym_infix_op_token2] = ACTIONS(3063),
    [anon_sym_PIPE_PIPE] = ACTIONS(3063),
    [anon_sym_BANG_EQ] = ACTIONS(3063),
    [anon_sym_COLON_EQ] = ACTIONS(3065),
    [anon_sym_DOLLAR] = ACTIONS(3063),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3063),
    [sym_int] = ACTIONS(3063),
    [sym_xint] = ACTIONS(3065),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3065),
    [sym__newline] = ACTIONS(3065),
    [sym__dedent] = ACTIONS(3065),
  },
  [1582] = {
    [sym_block_comment] = STATE(1582),
    [sym_compiler_directive_decl] = STATE(1582),
    [sym_fsi_directive_decl] = STATE(1582),
    [sym_preproc_line] = STATE(1582),
    [aux_sym_long_identifier_repeat1] = STATE(1582),
    [sym_identifier] = ACTIONS(2411),
    [anon_sym_EQ] = ACTIONS(2413),
    [anon_sym_COLON] = ACTIONS(2411),
    [anon_sym_return] = ACTIONS(2411),
    [anon_sym_do] = ACTIONS(2411),
    [anon_sym_let] = ACTIONS(2411),
    [anon_sym_let_BANG] = ACTIONS(2413),
    [anon_sym_LPAREN] = ACTIONS(2411),
    [anon_sym_COMMA] = ACTIONS(2413),
    [anon_sym_null] = ACTIONS(2411),
    [anon_sym_QMARK] = ACTIONS(2411),
    [anon_sym_COLON_QMARK] = ACTIONS(2411),
    [anon_sym_COLON_COLON] = ACTIONS(2413),
    [anon_sym_AMP] = ACTIONS(2411),
    [anon_sym_LBRACK] = ACTIONS(2411),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2413),
    [anon_sym_LBRACE] = ACTIONS(2411),
    [anon_sym_LT_AT] = ACTIONS(2411),
    [anon_sym_LT_AT_AT] = ACTIONS(2411),
    [anon_sym_DOT] = ACTIONS(3810),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2413),
    [anon_sym_new] = ACTIONS(2411),
    [anon_sym_return_BANG] = ACTIONS(2413),
    [anon_sym_yield] = ACTIONS(2411),
    [anon_sym_yield_BANG] = ACTIONS(2413),
    [anon_sym_lazy] = ACTIONS(2411),
    [anon_sym_assert] = ACTIONS(2411),
    [anon_sym_upcast] = ACTIONS(2411),
    [anon_sym_downcast] = ACTIONS(2411),
    [anon_sym_COLON_GT] = ACTIONS(2413),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2413),
    [anon_sym_for] = ACTIONS(2411),
    [anon_sym_while] = ACTIONS(2411),
    [anon_sym_if] = ACTIONS(2411),
    [anon_sym_fun] = ACTIONS(2411),
    [anon_sym_DASH_GT] = ACTIONS(2411),
    [anon_sym_try] = ACTIONS(2411),
    [anon_sym_match] = ACTIONS(2411),
    [anon_sym_match_BANG] = ACTIONS(2413),
    [anon_sym_function] = ACTIONS(2411),
    [anon_sym_LT_DASH] = ACTIONS(2411),
    [anon_sym_DOT_LBRACK] = ACTIONS(2413),
    [anon_sym_LT] = ACTIONS(2413),
    [anon_sym_use] = ACTIONS(2411),
    [anon_sym_use_BANG] = ACTIONS(2413),
    [anon_sym_do_BANG] = ACTIONS(2413),
    [anon_sym_DOT_DOT] = ACTIONS(2413),
    [anon_sym_begin] = ACTIONS(2411),
    [anon_sym_LPAREN2] = ACTIONS(2411),
    [anon_sym_or] = ACTIONS(2411),
    [aux_sym_char_token1] = ACTIONS(2413),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2411),
    [anon_sym_DQUOTE] = ACTIONS(2411),
    [anon_sym_AT_DQUOTE] = ACTIONS(2413),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2413),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2413),
    [sym_bool] = ACTIONS(2411),
    [sym_unit] = ACTIONS(2413),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2411),
    [sym_op_identifier] = ACTIONS(2411),
    [anon_sym_PLUS] = ACTIONS(2411),
    [anon_sym_DASH] = ACTIONS(2411),
    [anon_sym_PLUS_DOT] = ACTIONS(2411),
    [anon_sym_DASH_DOT] = ACTIONS(2411),
    [anon_sym_PERCENT] = ACTIONS(2411),
    [anon_sym_AMP_AMP] = ACTIONS(2411),
    [anon_sym_TILDE] = ACTIONS(2413),
    [aux_sym_prefix_op_token1] = ACTIONS(2411),
    [aux_sym_infix_op_token1] = ACTIONS(2413),
    [aux_sym_infix_op_token2] = ACTIONS(2411),
    [anon_sym_PIPE_PIPE] = ACTIONS(2411),
    [anon_sym_BANG_EQ] = ACTIONS(2411),
    [anon_sym_COLON_EQ] = ACTIONS(2413),
    [anon_sym_DOLLAR] = ACTIONS(2411),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2411),
    [sym_int] = ACTIONS(2411),
    [sym_xint] = ACTIONS(2413),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2413),
    [sym__newline] = ACTIONS(2413),
  },
  [1583] = {
    [sym_block_comment] = STATE(1583),
    [sym_compiler_directive_decl] = STATE(1583),
    [sym_fsi_directive_decl] = STATE(1583),
    [sym_preproc_line] = STATE(1583),
    [sym_identifier] = ACTIONS(3083),
    [anon_sym_EQ] = ACTIONS(3085),
    [anon_sym_COLON] = ACTIONS(3083),
    [anon_sym_return] = ACTIONS(3083),
    [anon_sym_do] = ACTIONS(3083),
    [anon_sym_let] = ACTIONS(3083),
    [anon_sym_let_BANG] = ACTIONS(3085),
    [anon_sym_as] = ACTIONS(3083),
    [anon_sym_LPAREN] = ACTIONS(3083),
    [anon_sym_COMMA] = ACTIONS(3085),
    [anon_sym_null] = ACTIONS(3083),
    [anon_sym_QMARK] = ACTIONS(3083),
    [anon_sym_COLON_QMARK] = ACTIONS(3083),
    [anon_sym_COLON_COLON] = ACTIONS(3085),
    [anon_sym_AMP] = ACTIONS(3083),
    [anon_sym_LBRACK] = ACTIONS(3083),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3085),
    [anon_sym_LBRACE] = ACTIONS(3083),
    [anon_sym_LT_AT] = ACTIONS(3083),
    [anon_sym_LT_AT_AT] = ACTIONS(3083),
    [anon_sym_DOT] = ACTIONS(3083),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3085),
    [anon_sym_new] = ACTIONS(3083),
    [anon_sym_with] = ACTIONS(3083),
    [anon_sym_return_BANG] = ACTIONS(3085),
    [anon_sym_yield] = ACTIONS(3083),
    [anon_sym_yield_BANG] = ACTIONS(3085),
    [anon_sym_lazy] = ACTIONS(3083),
    [anon_sym_assert] = ACTIONS(3083),
    [anon_sym_upcast] = ACTIONS(3083),
    [anon_sym_downcast] = ACTIONS(3083),
    [anon_sym_COLON_GT] = ACTIONS(3085),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3085),
    [anon_sym_for] = ACTIONS(3083),
    [anon_sym_while] = ACTIONS(3083),
    [anon_sym_if] = ACTIONS(3083),
    [anon_sym_fun] = ACTIONS(3083),
    [anon_sym_try] = ACTIONS(3083),
    [anon_sym_match] = ACTIONS(3083),
    [anon_sym_match_BANG] = ACTIONS(3085),
    [anon_sym_function] = ACTIONS(3083),
    [anon_sym_LT_DASH] = ACTIONS(3083),
    [anon_sym_DOT_LBRACK] = ACTIONS(3085),
    [anon_sym_LT] = ACTIONS(3085),
    [anon_sym_use] = ACTIONS(3083),
    [anon_sym_use_BANG] = ACTIONS(3085),
    [anon_sym_do_BANG] = ACTIONS(3085),
    [anon_sym_begin] = ACTIONS(3083),
    [anon_sym_LPAREN2] = ACTIONS(3083),
    [anon_sym_or] = ACTIONS(3083),
    [aux_sym_char_token1] = ACTIONS(3085),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3083),
    [anon_sym_DQUOTE] = ACTIONS(3083),
    [anon_sym_AT_DQUOTE] = ACTIONS(3085),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3085),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3085),
    [sym_bool] = ACTIONS(3083),
    [sym_unit] = ACTIONS(3085),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3083),
    [sym_op_identifier] = ACTIONS(3083),
    [anon_sym_PLUS] = ACTIONS(3083),
    [anon_sym_DASH] = ACTIONS(3083),
    [anon_sym_PLUS_DOT] = ACTIONS(3083),
    [anon_sym_DASH_DOT] = ACTIONS(3083),
    [anon_sym_PERCENT] = ACTIONS(3083),
    [anon_sym_AMP_AMP] = ACTIONS(3083),
    [anon_sym_TILDE] = ACTIONS(3085),
    [aux_sym_prefix_op_token1] = ACTIONS(3083),
    [aux_sym_infix_op_token1] = ACTIONS(3085),
    [aux_sym_infix_op_token2] = ACTIONS(3083),
    [anon_sym_PIPE_PIPE] = ACTIONS(3083),
    [anon_sym_BANG_EQ] = ACTIONS(3083),
    [anon_sym_COLON_EQ] = ACTIONS(3085),
    [anon_sym_DOLLAR] = ACTIONS(3083),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3083),
    [sym_int] = ACTIONS(3083),
    [sym_xint] = ACTIONS(3085),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3085),
    [sym__newline] = ACTIONS(3085),
    [sym__dedent] = ACTIONS(3085),
  },
  [1584] = {
    [sym_block_comment] = STATE(1584),
    [sym_compiler_directive_decl] = STATE(1584),
    [sym_fsi_directive_decl] = STATE(1584),
    [sym_preproc_line] = STATE(1584),
    [sym_identifier] = ACTIONS(3099),
    [anon_sym_EQ] = ACTIONS(3101),
    [anon_sym_COLON] = ACTIONS(3099),
    [anon_sym_return] = ACTIONS(3099),
    [anon_sym_do] = ACTIONS(3099),
    [anon_sym_let] = ACTIONS(3099),
    [anon_sym_let_BANG] = ACTIONS(3101),
    [anon_sym_as] = ACTIONS(3099),
    [anon_sym_LPAREN] = ACTIONS(3099),
    [anon_sym_COMMA] = ACTIONS(3101),
    [anon_sym_null] = ACTIONS(3099),
    [anon_sym_QMARK] = ACTIONS(3099),
    [anon_sym_COLON_QMARK] = ACTIONS(3099),
    [anon_sym_COLON_COLON] = ACTIONS(3101),
    [anon_sym_AMP] = ACTIONS(3099),
    [anon_sym_LBRACK] = ACTIONS(3099),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3101),
    [anon_sym_LBRACE] = ACTIONS(3099),
    [anon_sym_LT_AT] = ACTIONS(3099),
    [anon_sym_LT_AT_AT] = ACTIONS(3099),
    [anon_sym_DOT] = ACTIONS(3099),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3101),
    [anon_sym_new] = ACTIONS(3099),
    [anon_sym_with] = ACTIONS(3099),
    [anon_sym_return_BANG] = ACTIONS(3101),
    [anon_sym_yield] = ACTIONS(3099),
    [anon_sym_yield_BANG] = ACTIONS(3101),
    [anon_sym_lazy] = ACTIONS(3099),
    [anon_sym_assert] = ACTIONS(3099),
    [anon_sym_upcast] = ACTIONS(3099),
    [anon_sym_downcast] = ACTIONS(3099),
    [anon_sym_COLON_GT] = ACTIONS(3101),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3101),
    [anon_sym_for] = ACTIONS(3099),
    [anon_sym_while] = ACTIONS(3099),
    [anon_sym_if] = ACTIONS(3099),
    [anon_sym_fun] = ACTIONS(3099),
    [anon_sym_try] = ACTIONS(3099),
    [anon_sym_match] = ACTIONS(3099),
    [anon_sym_match_BANG] = ACTIONS(3101),
    [anon_sym_function] = ACTIONS(3099),
    [anon_sym_LT_DASH] = ACTIONS(3099),
    [anon_sym_DOT_LBRACK] = ACTIONS(3101),
    [anon_sym_LT] = ACTIONS(3101),
    [anon_sym_use] = ACTIONS(3099),
    [anon_sym_use_BANG] = ACTIONS(3101),
    [anon_sym_do_BANG] = ACTIONS(3101),
    [anon_sym_begin] = ACTIONS(3099),
    [anon_sym_LPAREN2] = ACTIONS(3099),
    [anon_sym_or] = ACTIONS(3099),
    [aux_sym_char_token1] = ACTIONS(3101),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3099),
    [anon_sym_DQUOTE] = ACTIONS(3099),
    [anon_sym_AT_DQUOTE] = ACTIONS(3101),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3101),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3101),
    [sym_bool] = ACTIONS(3099),
    [sym_unit] = ACTIONS(3101),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3099),
    [sym_op_identifier] = ACTIONS(3099),
    [anon_sym_PLUS] = ACTIONS(3099),
    [anon_sym_DASH] = ACTIONS(3099),
    [anon_sym_PLUS_DOT] = ACTIONS(3099),
    [anon_sym_DASH_DOT] = ACTIONS(3099),
    [anon_sym_PERCENT] = ACTIONS(3099),
    [anon_sym_AMP_AMP] = ACTIONS(3099),
    [anon_sym_TILDE] = ACTIONS(3101),
    [aux_sym_prefix_op_token1] = ACTIONS(3099),
    [aux_sym_infix_op_token1] = ACTIONS(3101),
    [aux_sym_infix_op_token2] = ACTIONS(3099),
    [anon_sym_PIPE_PIPE] = ACTIONS(3099),
    [anon_sym_BANG_EQ] = ACTIONS(3099),
    [anon_sym_COLON_EQ] = ACTIONS(3101),
    [anon_sym_DOLLAR] = ACTIONS(3099),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3099),
    [sym_int] = ACTIONS(3099),
    [sym_xint] = ACTIONS(3101),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3101),
    [sym__newline] = ACTIONS(3101),
    [sym__dedent] = ACTIONS(3101),
  },
  [1585] = {
    [sym_block_comment] = STATE(1585),
    [sym_compiler_directive_decl] = STATE(1585),
    [sym_fsi_directive_decl] = STATE(1585),
    [sym_preproc_line] = STATE(1585),
    [aux_sym_sequential_expression_repeat1] = STATE(1559),
    [sym_identifier] = ACTIONS(2847),
    [anon_sym_EQ] = ACTIONS(2849),
    [anon_sym_COLON] = ACTIONS(2847),
    [anon_sym_return] = ACTIONS(2847),
    [anon_sym_do] = ACTIONS(2847),
    [anon_sym_let] = ACTIONS(2847),
    [anon_sym_let_BANG] = ACTIONS(2849),
    [anon_sym_as] = ACTIONS(2847),
    [anon_sym_LPAREN] = ACTIONS(2847),
    [anon_sym_COMMA] = ACTIONS(2849),
    [anon_sym_null] = ACTIONS(2847),
    [anon_sym_QMARK] = ACTIONS(2847),
    [anon_sym_COLON_QMARK] = ACTIONS(2847),
    [anon_sym_COLON_COLON] = ACTIONS(2849),
    [anon_sym_AMP] = ACTIONS(2847),
    [anon_sym_LBRACK] = ACTIONS(2847),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2849),
    [anon_sym_LBRACE] = ACTIONS(2847),
    [anon_sym_LT_AT] = ACTIONS(2847),
    [anon_sym_LT_AT_AT] = ACTIONS(2847),
    [anon_sym_DOT] = ACTIONS(2847),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2849),
    [anon_sym_new] = ACTIONS(2847),
    [anon_sym_with] = ACTIONS(2847),
    [anon_sym_return_BANG] = ACTIONS(2849),
    [anon_sym_yield] = ACTIONS(2847),
    [anon_sym_yield_BANG] = ACTIONS(2849),
    [anon_sym_lazy] = ACTIONS(2847),
    [anon_sym_assert] = ACTIONS(2847),
    [anon_sym_upcast] = ACTIONS(2847),
    [anon_sym_downcast] = ACTIONS(2847),
    [anon_sym_COLON_GT] = ACTIONS(2849),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2849),
    [anon_sym_for] = ACTIONS(2847),
    [anon_sym_while] = ACTIONS(2847),
    [anon_sym_if] = ACTIONS(2847),
    [anon_sym_fun] = ACTIONS(2847),
    [anon_sym_try] = ACTIONS(2847),
    [anon_sym_match] = ACTIONS(2847),
    [anon_sym_match_BANG] = ACTIONS(2849),
    [anon_sym_function] = ACTIONS(2847),
    [anon_sym_LT_DASH] = ACTIONS(2847),
    [anon_sym_DOT_LBRACK] = ACTIONS(2849),
    [anon_sym_LT] = ACTIONS(2849),
    [anon_sym_use] = ACTIONS(2847),
    [anon_sym_use_BANG] = ACTIONS(2849),
    [anon_sym_do_BANG] = ACTIONS(2849),
    [anon_sym_begin] = ACTIONS(2847),
    [anon_sym_LPAREN2] = ACTIONS(2847),
    [anon_sym_or] = ACTIONS(2847),
    [aux_sym_char_token1] = ACTIONS(2849),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2847),
    [anon_sym_DQUOTE] = ACTIONS(2847),
    [anon_sym_AT_DQUOTE] = ACTIONS(2849),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2849),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2849),
    [sym_bool] = ACTIONS(2847),
    [sym_unit] = ACTIONS(2849),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2847),
    [sym_op_identifier] = ACTIONS(2847),
    [anon_sym_PLUS] = ACTIONS(2847),
    [anon_sym_DASH] = ACTIONS(2847),
    [anon_sym_PLUS_DOT] = ACTIONS(2847),
    [anon_sym_DASH_DOT] = ACTIONS(2847),
    [anon_sym_PERCENT] = ACTIONS(2847),
    [anon_sym_AMP_AMP] = ACTIONS(2847),
    [anon_sym_TILDE] = ACTIONS(2849),
    [aux_sym_prefix_op_token1] = ACTIONS(2847),
    [aux_sym_infix_op_token1] = ACTIONS(2849),
    [aux_sym_infix_op_token2] = ACTIONS(2847),
    [anon_sym_PIPE_PIPE] = ACTIONS(2847),
    [anon_sym_BANG_EQ] = ACTIONS(2847),
    [anon_sym_COLON_EQ] = ACTIONS(2849),
    [anon_sym_DOLLAR] = ACTIONS(2847),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2847),
    [sym_int] = ACTIONS(2847),
    [sym_xint] = ACTIONS(2849),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2849),
    [sym__newline] = ACTIONS(2849),
  },
  [1586] = {
    [sym_block_comment] = STATE(1586),
    [sym_compiler_directive_decl] = STATE(1586),
    [sym_fsi_directive_decl] = STATE(1586),
    [sym_preproc_line] = STATE(1586),
    [sym_identifier] = ACTIONS(2158),
    [anon_sym_EQ] = ACTIONS(2160),
    [anon_sym_COLON] = ACTIONS(2158),
    [anon_sym_return] = ACTIONS(2158),
    [anon_sym_do] = ACTIONS(2158),
    [anon_sym_let] = ACTIONS(2158),
    [anon_sym_let_BANG] = ACTIONS(2160),
    [anon_sym_LPAREN] = ACTIONS(2158),
    [anon_sym_COMMA] = ACTIONS(2160),
    [anon_sym_null] = ACTIONS(2158),
    [anon_sym_QMARK] = ACTIONS(2158),
    [anon_sym_COLON_QMARK] = ACTIONS(2158),
    [anon_sym_COLON_COLON] = ACTIONS(2160),
    [anon_sym_AMP] = ACTIONS(2158),
    [anon_sym_LBRACK] = ACTIONS(2158),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2160),
    [anon_sym_LBRACE] = ACTIONS(2158),
    [anon_sym_LT_AT] = ACTIONS(2158),
    [anon_sym_AT_GT] = ACTIONS(2158),
    [anon_sym_LT_AT_AT] = ACTIONS(2158),
    [anon_sym_DOT] = ACTIONS(2158),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2160),
    [anon_sym_new] = ACTIONS(2158),
    [anon_sym_return_BANG] = ACTIONS(2160),
    [anon_sym_yield] = ACTIONS(2158),
    [anon_sym_yield_BANG] = ACTIONS(2160),
    [anon_sym_lazy] = ACTIONS(2158),
    [anon_sym_assert] = ACTIONS(2158),
    [anon_sym_upcast] = ACTIONS(2158),
    [anon_sym_downcast] = ACTIONS(2158),
    [anon_sym_COLON_GT] = ACTIONS(2160),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2160),
    [anon_sym_for] = ACTIONS(2158),
    [anon_sym_while] = ACTIONS(2158),
    [anon_sym_if] = ACTIONS(2158),
    [anon_sym_fun] = ACTIONS(2158),
    [anon_sym_try] = ACTIONS(2158),
    [anon_sym_match] = ACTIONS(2158),
    [anon_sym_match_BANG] = ACTIONS(2160),
    [anon_sym_function] = ACTIONS(2158),
    [anon_sym_LT_DASH] = ACTIONS(2158),
    [anon_sym_DOT_LBRACK] = ACTIONS(2160),
    [anon_sym_LT] = ACTIONS(2160),
    [anon_sym_use] = ACTIONS(2158),
    [anon_sym_use_BANG] = ACTIONS(2160),
    [anon_sym_do_BANG] = ACTIONS(2160),
    [anon_sym_begin] = ACTIONS(2158),
    [anon_sym_LPAREN2] = ACTIONS(2158),
    [anon_sym_or] = ACTIONS(2158),
    [aux_sym_char_token1] = ACTIONS(2160),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2158),
    [anon_sym_DQUOTE] = ACTIONS(2158),
    [anon_sym_AT_DQUOTE] = ACTIONS(2160),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2160),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2160),
    [sym_bool] = ACTIONS(2158),
    [sym_unit] = ACTIONS(2160),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2158),
    [sym_op_identifier] = ACTIONS(2158),
    [anon_sym_PLUS] = ACTIONS(2158),
    [anon_sym_DASH] = ACTIONS(2158),
    [anon_sym_PLUS_DOT] = ACTIONS(2158),
    [anon_sym_DASH_DOT] = ACTIONS(2158),
    [anon_sym_PERCENT] = ACTIONS(2158),
    [anon_sym_AMP_AMP] = ACTIONS(2158),
    [anon_sym_TILDE] = ACTIONS(2160),
    [aux_sym_prefix_op_token1] = ACTIONS(2158),
    [aux_sym_infix_op_token1] = ACTIONS(2160),
    [aux_sym_infix_op_token2] = ACTIONS(2158),
    [anon_sym_PIPE_PIPE] = ACTIONS(2158),
    [anon_sym_BANG_EQ] = ACTIONS(2158),
    [anon_sym_COLON_EQ] = ACTIONS(2160),
    [anon_sym_DOLLAR] = ACTIONS(2158),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2158),
    [sym_int] = ACTIONS(2158),
    [sym_xint] = ACTIONS(2160),
    [anon_sym_f] = ACTIONS(2705),
    [aux_sym_decimal_token1] = ACTIONS(2593),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2160),
    [sym__newline] = ACTIONS(2160),
  },
  [1587] = {
    [sym_block_comment] = STATE(1587),
    [sym_compiler_directive_decl] = STATE(1587),
    [sym_fsi_directive_decl] = STATE(1587),
    [sym_preproc_line] = STATE(1587),
    [aux_sym_long_identifier_repeat1] = STATE(1588),
    [sym_identifier] = ACTIONS(2418),
    [anon_sym_EQ] = ACTIONS(2420),
    [anon_sym_COLON] = ACTIONS(2418),
    [anon_sym_return] = ACTIONS(2418),
    [anon_sym_do] = ACTIONS(2418),
    [anon_sym_and] = ACTIONS(2418),
    [anon_sym_let] = ACTIONS(2418),
    [anon_sym_let_BANG] = ACTIONS(2420),
    [anon_sym_LPAREN] = ACTIONS(2418),
    [anon_sym_COMMA] = ACTIONS(2420),
    [anon_sym_null] = ACTIONS(2418),
    [anon_sym_QMARK] = ACTIONS(2418),
    [anon_sym_COLON_QMARK] = ACTIONS(2418),
    [anon_sym_COLON_COLON] = ACTIONS(2420),
    [anon_sym_AMP] = ACTIONS(2418),
    [anon_sym_LBRACK] = ACTIONS(2418),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2420),
    [anon_sym_LBRACE] = ACTIONS(2418),
    [anon_sym_LT_AT] = ACTIONS(2418),
    [anon_sym_LT_AT_AT] = ACTIONS(2418),
    [anon_sym_DOT] = ACTIONS(3813),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2420),
    [anon_sym_new] = ACTIONS(2418),
    [anon_sym_return_BANG] = ACTIONS(2420),
    [anon_sym_yield] = ACTIONS(2418),
    [anon_sym_yield_BANG] = ACTIONS(2420),
    [anon_sym_lazy] = ACTIONS(2418),
    [anon_sym_assert] = ACTIONS(2418),
    [anon_sym_upcast] = ACTIONS(2418),
    [anon_sym_downcast] = ACTIONS(2418),
    [anon_sym_COLON_GT] = ACTIONS(2420),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2420),
    [anon_sym_for] = ACTIONS(2418),
    [anon_sym_while] = ACTIONS(2418),
    [anon_sym_if] = ACTIONS(2418),
    [anon_sym_fun] = ACTIONS(2418),
    [anon_sym_try] = ACTIONS(2418),
    [anon_sym_match] = ACTIONS(2418),
    [anon_sym_match_BANG] = ACTIONS(2420),
    [anon_sym_function] = ACTIONS(2418),
    [anon_sym_LT_DASH] = ACTIONS(2418),
    [anon_sym_DOT_LBRACK] = ACTIONS(2420),
    [anon_sym_LT] = ACTIONS(2420),
    [anon_sym_use] = ACTIONS(2418),
    [anon_sym_use_BANG] = ACTIONS(2420),
    [anon_sym_do_BANG] = ACTIONS(2420),
    [anon_sym_begin] = ACTIONS(2418),
    [anon_sym_LPAREN2] = ACTIONS(2418),
    [anon_sym_or] = ACTIONS(2418),
    [aux_sym_char_token1] = ACTIONS(2420),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2418),
    [anon_sym_DQUOTE] = ACTIONS(2418),
    [anon_sym_AT_DQUOTE] = ACTIONS(2420),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2420),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2420),
    [sym_bool] = ACTIONS(2418),
    [sym_unit] = ACTIONS(2420),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2418),
    [sym_op_identifier] = ACTIONS(2418),
    [anon_sym_PLUS] = ACTIONS(2418),
    [anon_sym_DASH] = ACTIONS(2418),
    [anon_sym_PLUS_DOT] = ACTIONS(2418),
    [anon_sym_DASH_DOT] = ACTIONS(2418),
    [anon_sym_PERCENT] = ACTIONS(2418),
    [anon_sym_AMP_AMP] = ACTIONS(2418),
    [anon_sym_TILDE] = ACTIONS(2420),
    [aux_sym_prefix_op_token1] = ACTIONS(2418),
    [aux_sym_infix_op_token1] = ACTIONS(2420),
    [aux_sym_infix_op_token2] = ACTIONS(2418),
    [anon_sym_PIPE_PIPE] = ACTIONS(2418),
    [anon_sym_BANG_EQ] = ACTIONS(2418),
    [anon_sym_COLON_EQ] = ACTIONS(2420),
    [anon_sym_DOLLAR] = ACTIONS(2418),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2418),
    [sym_int] = ACTIONS(2418),
    [sym_xint] = ACTIONS(2420),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2420),
    [sym__newline] = ACTIONS(2420),
    [sym__dedent] = ACTIONS(2420),
  },
  [1588] = {
    [sym_block_comment] = STATE(1588),
    [sym_compiler_directive_decl] = STATE(1588),
    [sym_fsi_directive_decl] = STATE(1588),
    [sym_preproc_line] = STATE(1588),
    [aux_sym_long_identifier_repeat1] = STATE(1588),
    [sym_identifier] = ACTIONS(2411),
    [anon_sym_EQ] = ACTIONS(2413),
    [anon_sym_COLON] = ACTIONS(2411),
    [anon_sym_return] = ACTIONS(2411),
    [anon_sym_do] = ACTIONS(2411),
    [anon_sym_and] = ACTIONS(2411),
    [anon_sym_let] = ACTIONS(2411),
    [anon_sym_let_BANG] = ACTIONS(2413),
    [anon_sym_LPAREN] = ACTIONS(2411),
    [anon_sym_COMMA] = ACTIONS(2413),
    [anon_sym_null] = ACTIONS(2411),
    [anon_sym_QMARK] = ACTIONS(2411),
    [anon_sym_COLON_QMARK] = ACTIONS(2411),
    [anon_sym_COLON_COLON] = ACTIONS(2413),
    [anon_sym_AMP] = ACTIONS(2411),
    [anon_sym_LBRACK] = ACTIONS(2411),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2413),
    [anon_sym_LBRACE] = ACTIONS(2411),
    [anon_sym_LT_AT] = ACTIONS(2411),
    [anon_sym_LT_AT_AT] = ACTIONS(2411),
    [anon_sym_DOT] = ACTIONS(3815),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2413),
    [anon_sym_new] = ACTIONS(2411),
    [anon_sym_return_BANG] = ACTIONS(2413),
    [anon_sym_yield] = ACTIONS(2411),
    [anon_sym_yield_BANG] = ACTIONS(2413),
    [anon_sym_lazy] = ACTIONS(2411),
    [anon_sym_assert] = ACTIONS(2411),
    [anon_sym_upcast] = ACTIONS(2411),
    [anon_sym_downcast] = ACTIONS(2411),
    [anon_sym_COLON_GT] = ACTIONS(2413),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2413),
    [anon_sym_for] = ACTIONS(2411),
    [anon_sym_while] = ACTIONS(2411),
    [anon_sym_if] = ACTIONS(2411),
    [anon_sym_fun] = ACTIONS(2411),
    [anon_sym_try] = ACTIONS(2411),
    [anon_sym_match] = ACTIONS(2411),
    [anon_sym_match_BANG] = ACTIONS(2413),
    [anon_sym_function] = ACTIONS(2411),
    [anon_sym_LT_DASH] = ACTIONS(2411),
    [anon_sym_DOT_LBRACK] = ACTIONS(2413),
    [anon_sym_LT] = ACTIONS(2413),
    [anon_sym_use] = ACTIONS(2411),
    [anon_sym_use_BANG] = ACTIONS(2413),
    [anon_sym_do_BANG] = ACTIONS(2413),
    [anon_sym_begin] = ACTIONS(2411),
    [anon_sym_LPAREN2] = ACTIONS(2411),
    [anon_sym_or] = ACTIONS(2411),
    [aux_sym_char_token1] = ACTIONS(2413),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2411),
    [anon_sym_DQUOTE] = ACTIONS(2411),
    [anon_sym_AT_DQUOTE] = ACTIONS(2413),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2413),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2413),
    [sym_bool] = ACTIONS(2411),
    [sym_unit] = ACTIONS(2413),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2411),
    [sym_op_identifier] = ACTIONS(2411),
    [anon_sym_PLUS] = ACTIONS(2411),
    [anon_sym_DASH] = ACTIONS(2411),
    [anon_sym_PLUS_DOT] = ACTIONS(2411),
    [anon_sym_DASH_DOT] = ACTIONS(2411),
    [anon_sym_PERCENT] = ACTIONS(2411),
    [anon_sym_AMP_AMP] = ACTIONS(2411),
    [anon_sym_TILDE] = ACTIONS(2413),
    [aux_sym_prefix_op_token1] = ACTIONS(2411),
    [aux_sym_infix_op_token1] = ACTIONS(2413),
    [aux_sym_infix_op_token2] = ACTIONS(2411),
    [anon_sym_PIPE_PIPE] = ACTIONS(2411),
    [anon_sym_BANG_EQ] = ACTIONS(2411),
    [anon_sym_COLON_EQ] = ACTIONS(2413),
    [anon_sym_DOLLAR] = ACTIONS(2411),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2411),
    [sym_int] = ACTIONS(2411),
    [sym_xint] = ACTIONS(2413),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2413),
    [sym__newline] = ACTIONS(2413),
    [sym__dedent] = ACTIONS(2413),
  },
  [1589] = {
    [sym_block_comment] = STATE(1589),
    [sym_compiler_directive_decl] = STATE(1589),
    [sym_fsi_directive_decl] = STATE(1589),
    [sym_preproc_line] = STATE(1589),
    [aux_sym_sequential_expression_repeat1] = STATE(1589),
    [sym_identifier] = ACTIONS(2895),
    [anon_sym_EQ] = ACTIONS(2897),
    [anon_sym_COLON] = ACTIONS(2895),
    [anon_sym_return] = ACTIONS(2895),
    [anon_sym_do] = ACTIONS(2895),
    [anon_sym_let] = ACTIONS(2895),
    [anon_sym_let_BANG] = ACTIONS(2897),
    [anon_sym_LPAREN] = ACTIONS(2895),
    [anon_sym_COMMA] = ACTIONS(2897),
    [anon_sym_null] = ACTIONS(2895),
    [anon_sym_QMARK] = ACTIONS(2895),
    [anon_sym_COLON_QMARK] = ACTIONS(2895),
    [anon_sym_COLON_COLON] = ACTIONS(2897),
    [anon_sym_AMP] = ACTIONS(2895),
    [anon_sym_LBRACK] = ACTIONS(2895),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2897),
    [anon_sym_LBRACE] = ACTIONS(2895),
    [anon_sym_LT_AT] = ACTIONS(2895),
    [anon_sym_LT_AT_AT] = ACTIONS(2895),
    [anon_sym_DOT] = ACTIONS(2895),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2897),
    [anon_sym_new] = ACTIONS(2895),
    [anon_sym_return_BANG] = ACTIONS(2897),
    [anon_sym_yield] = ACTIONS(2895),
    [anon_sym_yield_BANG] = ACTIONS(2897),
    [anon_sym_lazy] = ACTIONS(2895),
    [anon_sym_assert] = ACTIONS(2895),
    [anon_sym_upcast] = ACTIONS(2895),
    [anon_sym_downcast] = ACTIONS(2895),
    [anon_sym_COLON_GT] = ACTIONS(2897),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2897),
    [anon_sym_for] = ACTIONS(2895),
    [anon_sym_while] = ACTIONS(2895),
    [anon_sym_if] = ACTIONS(2895),
    [anon_sym_fun] = ACTIONS(2895),
    [anon_sym_DASH_GT] = ACTIONS(2895),
    [anon_sym_try] = ACTIONS(2895),
    [anon_sym_match] = ACTIONS(2895),
    [anon_sym_match_BANG] = ACTIONS(2897),
    [anon_sym_function] = ACTIONS(2895),
    [anon_sym_LT_DASH] = ACTIONS(2895),
    [anon_sym_DOT_LBRACK] = ACTIONS(2897),
    [anon_sym_LT] = ACTIONS(2897),
    [anon_sym_use] = ACTIONS(2895),
    [anon_sym_use_BANG] = ACTIONS(2897),
    [anon_sym_do_BANG] = ACTIONS(2897),
    [anon_sym_DOT_DOT] = ACTIONS(2897),
    [anon_sym_begin] = ACTIONS(2895),
    [anon_sym_LPAREN2] = ACTIONS(2895),
    [anon_sym_or] = ACTIONS(2895),
    [aux_sym_char_token1] = ACTIONS(2897),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2895),
    [anon_sym_DQUOTE] = ACTIONS(2895),
    [anon_sym_AT_DQUOTE] = ACTIONS(2897),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2897),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2897),
    [sym_bool] = ACTIONS(2895),
    [sym_unit] = ACTIONS(2897),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2895),
    [sym_op_identifier] = ACTIONS(2895),
    [anon_sym_PLUS] = ACTIONS(2895),
    [anon_sym_DASH] = ACTIONS(2895),
    [anon_sym_PLUS_DOT] = ACTIONS(2895),
    [anon_sym_DASH_DOT] = ACTIONS(2895),
    [anon_sym_PERCENT] = ACTIONS(2895),
    [anon_sym_AMP_AMP] = ACTIONS(2895),
    [anon_sym_TILDE] = ACTIONS(2897),
    [aux_sym_prefix_op_token1] = ACTIONS(2895),
    [aux_sym_infix_op_token1] = ACTIONS(2897),
    [aux_sym_infix_op_token2] = ACTIONS(2895),
    [anon_sym_PIPE_PIPE] = ACTIONS(2895),
    [anon_sym_BANG_EQ] = ACTIONS(2895),
    [anon_sym_COLON_EQ] = ACTIONS(2897),
    [anon_sym_DOLLAR] = ACTIONS(2895),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2895),
    [sym_int] = ACTIONS(2895),
    [sym_xint] = ACTIONS(2897),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2897),
    [sym__newline] = ACTIONS(3818),
  },
  [1590] = {
    [sym_block_comment] = STATE(1590),
    [sym_compiler_directive_decl] = STATE(1590),
    [sym_fsi_directive_decl] = STATE(1590),
    [sym_preproc_line] = STATE(1590),
    [sym_identifier] = ACTIONS(3103),
    [anon_sym_EQ] = ACTIONS(3105),
    [anon_sym_COLON] = ACTIONS(3103),
    [anon_sym_return] = ACTIONS(3103),
    [anon_sym_do] = ACTIONS(3103),
    [anon_sym_let] = ACTIONS(3103),
    [anon_sym_let_BANG] = ACTIONS(3105),
    [anon_sym_as] = ACTIONS(3103),
    [anon_sym_LPAREN] = ACTIONS(3103),
    [anon_sym_COMMA] = ACTIONS(3105),
    [anon_sym_null] = ACTIONS(3103),
    [anon_sym_QMARK] = ACTIONS(3103),
    [anon_sym_COLON_QMARK] = ACTIONS(3103),
    [anon_sym_COLON_COLON] = ACTIONS(3105),
    [anon_sym_AMP] = ACTIONS(3103),
    [anon_sym_LBRACK] = ACTIONS(3103),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3105),
    [anon_sym_LBRACE] = ACTIONS(3103),
    [anon_sym_LT_AT] = ACTIONS(3103),
    [anon_sym_LT_AT_AT] = ACTIONS(3103),
    [anon_sym_DOT] = ACTIONS(3103),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3105),
    [anon_sym_new] = ACTIONS(3103),
    [anon_sym_with] = ACTIONS(3103),
    [anon_sym_return_BANG] = ACTIONS(3105),
    [anon_sym_yield] = ACTIONS(3103),
    [anon_sym_yield_BANG] = ACTIONS(3105),
    [anon_sym_lazy] = ACTIONS(3103),
    [anon_sym_assert] = ACTIONS(3103),
    [anon_sym_upcast] = ACTIONS(3103),
    [anon_sym_downcast] = ACTIONS(3103),
    [anon_sym_COLON_GT] = ACTIONS(3105),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3105),
    [anon_sym_for] = ACTIONS(3103),
    [anon_sym_while] = ACTIONS(3103),
    [anon_sym_if] = ACTIONS(3103),
    [anon_sym_fun] = ACTIONS(3103),
    [anon_sym_try] = ACTIONS(3103),
    [anon_sym_match] = ACTIONS(3103),
    [anon_sym_match_BANG] = ACTIONS(3105),
    [anon_sym_function] = ACTIONS(3103),
    [anon_sym_LT_DASH] = ACTIONS(3103),
    [anon_sym_DOT_LBRACK] = ACTIONS(3105),
    [anon_sym_LT] = ACTIONS(3105),
    [anon_sym_use] = ACTIONS(3103),
    [anon_sym_use_BANG] = ACTIONS(3105),
    [anon_sym_do_BANG] = ACTIONS(3105),
    [anon_sym_begin] = ACTIONS(3103),
    [anon_sym_LPAREN2] = ACTIONS(3103),
    [anon_sym_or] = ACTIONS(3103),
    [aux_sym_char_token1] = ACTIONS(3105),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3103),
    [anon_sym_DQUOTE] = ACTIONS(3103),
    [anon_sym_AT_DQUOTE] = ACTIONS(3105),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3105),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3105),
    [sym_bool] = ACTIONS(3103),
    [sym_unit] = ACTIONS(3105),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3103),
    [sym_op_identifier] = ACTIONS(3103),
    [anon_sym_PLUS] = ACTIONS(3103),
    [anon_sym_DASH] = ACTIONS(3103),
    [anon_sym_PLUS_DOT] = ACTIONS(3103),
    [anon_sym_DASH_DOT] = ACTIONS(3103),
    [anon_sym_PERCENT] = ACTIONS(3103),
    [anon_sym_AMP_AMP] = ACTIONS(3103),
    [anon_sym_TILDE] = ACTIONS(3105),
    [aux_sym_prefix_op_token1] = ACTIONS(3103),
    [aux_sym_infix_op_token1] = ACTIONS(3105),
    [aux_sym_infix_op_token2] = ACTIONS(3103),
    [anon_sym_PIPE_PIPE] = ACTIONS(3103),
    [anon_sym_BANG_EQ] = ACTIONS(3103),
    [anon_sym_COLON_EQ] = ACTIONS(3105),
    [anon_sym_DOLLAR] = ACTIONS(3103),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3103),
    [sym_int] = ACTIONS(3103),
    [sym_xint] = ACTIONS(3105),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3105),
    [sym__newline] = ACTIONS(3105),
    [sym__dedent] = ACTIONS(3105),
  },
  [1591] = {
    [sym_block_comment] = STATE(1591),
    [sym_compiler_directive_decl] = STATE(1591),
    [sym_fsi_directive_decl] = STATE(1591),
    [sym_preproc_line] = STATE(1591),
    [sym_identifier] = ACTIONS(3107),
    [anon_sym_EQ] = ACTIONS(3109),
    [anon_sym_COLON] = ACTIONS(3107),
    [anon_sym_return] = ACTIONS(3107),
    [anon_sym_do] = ACTIONS(3107),
    [anon_sym_let] = ACTIONS(3107),
    [anon_sym_let_BANG] = ACTIONS(3109),
    [anon_sym_as] = ACTIONS(3107),
    [anon_sym_LPAREN] = ACTIONS(3107),
    [anon_sym_COMMA] = ACTIONS(3109),
    [anon_sym_null] = ACTIONS(3107),
    [anon_sym_QMARK] = ACTIONS(3107),
    [anon_sym_COLON_QMARK] = ACTIONS(3107),
    [anon_sym_COLON_COLON] = ACTIONS(3109),
    [anon_sym_AMP] = ACTIONS(3107),
    [anon_sym_LBRACK] = ACTIONS(3107),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3109),
    [anon_sym_LBRACE] = ACTIONS(3107),
    [anon_sym_LT_AT] = ACTIONS(3107),
    [anon_sym_LT_AT_AT] = ACTIONS(3107),
    [anon_sym_DOT] = ACTIONS(3107),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3109),
    [anon_sym_new] = ACTIONS(3107),
    [anon_sym_with] = ACTIONS(3107),
    [anon_sym_return_BANG] = ACTIONS(3109),
    [anon_sym_yield] = ACTIONS(3107),
    [anon_sym_yield_BANG] = ACTIONS(3109),
    [anon_sym_lazy] = ACTIONS(3107),
    [anon_sym_assert] = ACTIONS(3107),
    [anon_sym_upcast] = ACTIONS(3107),
    [anon_sym_downcast] = ACTIONS(3107),
    [anon_sym_COLON_GT] = ACTIONS(3109),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3109),
    [anon_sym_for] = ACTIONS(3107),
    [anon_sym_while] = ACTIONS(3107),
    [anon_sym_if] = ACTIONS(3107),
    [anon_sym_fun] = ACTIONS(3107),
    [anon_sym_try] = ACTIONS(3107),
    [anon_sym_match] = ACTIONS(3107),
    [anon_sym_match_BANG] = ACTIONS(3109),
    [anon_sym_function] = ACTIONS(3107),
    [anon_sym_LT_DASH] = ACTIONS(3107),
    [anon_sym_DOT_LBRACK] = ACTIONS(3109),
    [anon_sym_LT] = ACTIONS(3109),
    [anon_sym_use] = ACTIONS(3107),
    [anon_sym_use_BANG] = ACTIONS(3109),
    [anon_sym_do_BANG] = ACTIONS(3109),
    [anon_sym_begin] = ACTIONS(3107),
    [anon_sym_LPAREN2] = ACTIONS(3107),
    [anon_sym_or] = ACTIONS(3107),
    [aux_sym_char_token1] = ACTIONS(3109),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3107),
    [anon_sym_DQUOTE] = ACTIONS(3107),
    [anon_sym_AT_DQUOTE] = ACTIONS(3109),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3109),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3109),
    [sym_bool] = ACTIONS(3107),
    [sym_unit] = ACTIONS(3109),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3107),
    [sym_op_identifier] = ACTIONS(3107),
    [anon_sym_PLUS] = ACTIONS(3107),
    [anon_sym_DASH] = ACTIONS(3107),
    [anon_sym_PLUS_DOT] = ACTIONS(3107),
    [anon_sym_DASH_DOT] = ACTIONS(3107),
    [anon_sym_PERCENT] = ACTIONS(3107),
    [anon_sym_AMP_AMP] = ACTIONS(3107),
    [anon_sym_TILDE] = ACTIONS(3109),
    [aux_sym_prefix_op_token1] = ACTIONS(3107),
    [aux_sym_infix_op_token1] = ACTIONS(3109),
    [aux_sym_infix_op_token2] = ACTIONS(3107),
    [anon_sym_PIPE_PIPE] = ACTIONS(3107),
    [anon_sym_BANG_EQ] = ACTIONS(3107),
    [anon_sym_COLON_EQ] = ACTIONS(3109),
    [anon_sym_DOLLAR] = ACTIONS(3107),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3107),
    [sym_int] = ACTIONS(3107),
    [sym_xint] = ACTIONS(3109),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3109),
    [sym__newline] = ACTIONS(3109),
    [sym__dedent] = ACTIONS(3109),
  },
  [1592] = {
    [sym_block_comment] = STATE(1592),
    [sym_compiler_directive_decl] = STATE(1592),
    [sym_fsi_directive_decl] = STATE(1592),
    [sym_preproc_line] = STATE(1592),
    [sym_identifier] = ACTIONS(3111),
    [anon_sym_EQ] = ACTIONS(3113),
    [anon_sym_COLON] = ACTIONS(3111),
    [anon_sym_return] = ACTIONS(3111),
    [anon_sym_do] = ACTIONS(3111),
    [anon_sym_let] = ACTIONS(3111),
    [anon_sym_let_BANG] = ACTIONS(3113),
    [anon_sym_as] = ACTIONS(3111),
    [anon_sym_LPAREN] = ACTIONS(3111),
    [anon_sym_COMMA] = ACTIONS(3113),
    [anon_sym_null] = ACTIONS(3111),
    [anon_sym_QMARK] = ACTIONS(3111),
    [anon_sym_COLON_QMARK] = ACTIONS(3111),
    [anon_sym_COLON_COLON] = ACTIONS(3113),
    [anon_sym_AMP] = ACTIONS(3111),
    [anon_sym_LBRACK] = ACTIONS(3111),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3113),
    [anon_sym_LBRACE] = ACTIONS(3111),
    [anon_sym_LT_AT] = ACTIONS(3111),
    [anon_sym_LT_AT_AT] = ACTIONS(3111),
    [anon_sym_DOT] = ACTIONS(3111),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3113),
    [anon_sym_new] = ACTIONS(3111),
    [anon_sym_with] = ACTIONS(3111),
    [anon_sym_return_BANG] = ACTIONS(3113),
    [anon_sym_yield] = ACTIONS(3111),
    [anon_sym_yield_BANG] = ACTIONS(3113),
    [anon_sym_lazy] = ACTIONS(3111),
    [anon_sym_assert] = ACTIONS(3111),
    [anon_sym_upcast] = ACTIONS(3111),
    [anon_sym_downcast] = ACTIONS(3111),
    [anon_sym_COLON_GT] = ACTIONS(3113),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3113),
    [anon_sym_for] = ACTIONS(3111),
    [anon_sym_while] = ACTIONS(3111),
    [anon_sym_if] = ACTIONS(3111),
    [anon_sym_fun] = ACTIONS(3111),
    [anon_sym_try] = ACTIONS(3111),
    [anon_sym_match] = ACTIONS(3111),
    [anon_sym_match_BANG] = ACTIONS(3113),
    [anon_sym_function] = ACTIONS(3111),
    [anon_sym_LT_DASH] = ACTIONS(3111),
    [anon_sym_DOT_LBRACK] = ACTIONS(3113),
    [anon_sym_LT] = ACTIONS(3113),
    [anon_sym_use] = ACTIONS(3111),
    [anon_sym_use_BANG] = ACTIONS(3113),
    [anon_sym_do_BANG] = ACTIONS(3113),
    [anon_sym_begin] = ACTIONS(3111),
    [anon_sym_LPAREN2] = ACTIONS(3111),
    [anon_sym_or] = ACTIONS(3111),
    [aux_sym_char_token1] = ACTIONS(3113),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3111),
    [anon_sym_DQUOTE] = ACTIONS(3111),
    [anon_sym_AT_DQUOTE] = ACTIONS(3113),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3113),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3113),
    [sym_bool] = ACTIONS(3111),
    [sym_unit] = ACTIONS(3113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3111),
    [sym_op_identifier] = ACTIONS(3111),
    [anon_sym_PLUS] = ACTIONS(3111),
    [anon_sym_DASH] = ACTIONS(3111),
    [anon_sym_PLUS_DOT] = ACTIONS(3111),
    [anon_sym_DASH_DOT] = ACTIONS(3111),
    [anon_sym_PERCENT] = ACTIONS(3111),
    [anon_sym_AMP_AMP] = ACTIONS(3111),
    [anon_sym_TILDE] = ACTIONS(3113),
    [aux_sym_prefix_op_token1] = ACTIONS(3111),
    [aux_sym_infix_op_token1] = ACTIONS(3113),
    [aux_sym_infix_op_token2] = ACTIONS(3111),
    [anon_sym_PIPE_PIPE] = ACTIONS(3111),
    [anon_sym_BANG_EQ] = ACTIONS(3111),
    [anon_sym_COLON_EQ] = ACTIONS(3113),
    [anon_sym_DOLLAR] = ACTIONS(3111),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3111),
    [sym_int] = ACTIONS(3111),
    [sym_xint] = ACTIONS(3113),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3113),
    [sym__newline] = ACTIONS(3113),
    [sym__dedent] = ACTIONS(3113),
  },
  [1593] = {
    [sym_block_comment] = STATE(1593),
    [sym_compiler_directive_decl] = STATE(1593),
    [sym_fsi_directive_decl] = STATE(1593),
    [sym_preproc_line] = STATE(1593),
    [sym_identifier] = ACTIONS(2783),
    [anon_sym_EQ] = ACTIONS(2785),
    [anon_sym_COLON] = ACTIONS(2783),
    [anon_sym_return] = ACTIONS(2783),
    [anon_sym_do] = ACTIONS(2783),
    [anon_sym_let] = ACTIONS(2783),
    [anon_sym_let_BANG] = ACTIONS(2785),
    [anon_sym_LPAREN] = ACTIONS(2783),
    [anon_sym_COMMA] = ACTIONS(2785),
    [anon_sym_null] = ACTIONS(2783),
    [anon_sym_QMARK] = ACTIONS(2783),
    [anon_sym_COLON_QMARK] = ACTIONS(2783),
    [anon_sym_COLON_COLON] = ACTIONS(2785),
    [anon_sym_AMP] = ACTIONS(2783),
    [anon_sym_LBRACK] = ACTIONS(2783),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2785),
    [anon_sym_LBRACE] = ACTIONS(2783),
    [anon_sym_LT_AT] = ACTIONS(2783),
    [anon_sym_AT_GT] = ACTIONS(2783),
    [anon_sym_LT_AT_AT] = ACTIONS(2783),
    [anon_sym_DOT] = ACTIONS(2783),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2785),
    [anon_sym_new] = ACTIONS(2783),
    [anon_sym_return_BANG] = ACTIONS(2785),
    [anon_sym_yield] = ACTIONS(2783),
    [anon_sym_yield_BANG] = ACTIONS(2785),
    [anon_sym_lazy] = ACTIONS(2783),
    [anon_sym_assert] = ACTIONS(2783),
    [anon_sym_upcast] = ACTIONS(2783),
    [anon_sym_downcast] = ACTIONS(2783),
    [anon_sym_COLON_GT] = ACTIONS(2785),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2785),
    [anon_sym_for] = ACTIONS(2783),
    [anon_sym_done] = ACTIONS(3821),
    [anon_sym_while] = ACTIONS(2783),
    [anon_sym_if] = ACTIONS(2783),
    [anon_sym_fun] = ACTIONS(2783),
    [anon_sym_try] = ACTIONS(2783),
    [anon_sym_match] = ACTIONS(2783),
    [anon_sym_match_BANG] = ACTIONS(2785),
    [anon_sym_function] = ACTIONS(2783),
    [anon_sym_LT_DASH] = ACTIONS(2783),
    [anon_sym_DOT_LBRACK] = ACTIONS(2785),
    [anon_sym_LT] = ACTIONS(2785),
    [anon_sym_use] = ACTIONS(2783),
    [anon_sym_use_BANG] = ACTIONS(2785),
    [anon_sym_do_BANG] = ACTIONS(2785),
    [anon_sym_DOT_DOT] = ACTIONS(2789),
    [anon_sym_begin] = ACTIONS(2783),
    [anon_sym_LPAREN2] = ACTIONS(2783),
    [anon_sym_or] = ACTIONS(2783),
    [aux_sym_char_token1] = ACTIONS(2785),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2783),
    [anon_sym_DQUOTE] = ACTIONS(2783),
    [anon_sym_AT_DQUOTE] = ACTIONS(2785),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2785),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2785),
    [sym_bool] = ACTIONS(2783),
    [sym_unit] = ACTIONS(2785),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2783),
    [sym_op_identifier] = ACTIONS(2783),
    [anon_sym_PLUS] = ACTIONS(2783),
    [anon_sym_DASH] = ACTIONS(2783),
    [anon_sym_PLUS_DOT] = ACTIONS(2783),
    [anon_sym_DASH_DOT] = ACTIONS(2783),
    [anon_sym_PERCENT] = ACTIONS(2783),
    [anon_sym_AMP_AMP] = ACTIONS(2783),
    [anon_sym_TILDE] = ACTIONS(2785),
    [aux_sym_prefix_op_token1] = ACTIONS(2783),
    [aux_sym_infix_op_token1] = ACTIONS(2785),
    [aux_sym_infix_op_token2] = ACTIONS(2783),
    [anon_sym_PIPE_PIPE] = ACTIONS(2783),
    [anon_sym_BANG_EQ] = ACTIONS(2783),
    [anon_sym_COLON_EQ] = ACTIONS(2785),
    [anon_sym_DOLLAR] = ACTIONS(2783),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2783),
    [sym_int] = ACTIONS(2783),
    [sym_xint] = ACTIONS(2785),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2785),
    [sym__newline] = ACTIONS(2785),
  },
  [1594] = {
    [sym_block_comment] = STATE(1594),
    [sym_compiler_directive_decl] = STATE(1594),
    [sym_fsi_directive_decl] = STATE(1594),
    [sym_preproc_line] = STATE(1594),
    [sym_identifier] = ACTIONS(2835),
    [anon_sym_EQ] = ACTIONS(2837),
    [anon_sym_COLON] = ACTIONS(2835),
    [anon_sym_return] = ACTIONS(2835),
    [anon_sym_do] = ACTIONS(2835),
    [anon_sym_let] = ACTIONS(2835),
    [anon_sym_let_BANG] = ACTIONS(2837),
    [anon_sym_as] = ACTIONS(2835),
    [anon_sym_LPAREN] = ACTIONS(2835),
    [anon_sym_COMMA] = ACTIONS(2837),
    [anon_sym_null] = ACTIONS(2835),
    [anon_sym_QMARK] = ACTIONS(2835),
    [anon_sym_COLON_QMARK] = ACTIONS(2835),
    [anon_sym_COLON_COLON] = ACTIONS(2837),
    [anon_sym_AMP] = ACTIONS(2835),
    [anon_sym_LBRACK] = ACTIONS(2835),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2837),
    [anon_sym_LBRACE] = ACTIONS(2835),
    [anon_sym_LT_AT] = ACTIONS(2835),
    [anon_sym_LT_AT_AT] = ACTIONS(2835),
    [anon_sym_DOT] = ACTIONS(2835),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2837),
    [anon_sym_new] = ACTIONS(2835),
    [anon_sym_with] = ACTIONS(2835),
    [anon_sym_return_BANG] = ACTIONS(2837),
    [anon_sym_yield] = ACTIONS(2835),
    [anon_sym_yield_BANG] = ACTIONS(2837),
    [anon_sym_lazy] = ACTIONS(2835),
    [anon_sym_assert] = ACTIONS(2835),
    [anon_sym_upcast] = ACTIONS(2835),
    [anon_sym_downcast] = ACTIONS(2835),
    [anon_sym_COLON_GT] = ACTIONS(2837),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2837),
    [anon_sym_for] = ACTIONS(2835),
    [anon_sym_while] = ACTIONS(2835),
    [anon_sym_if] = ACTIONS(2835),
    [anon_sym_fun] = ACTIONS(2835),
    [anon_sym_try] = ACTIONS(2835),
    [anon_sym_match] = ACTIONS(2835),
    [anon_sym_match_BANG] = ACTIONS(2837),
    [anon_sym_function] = ACTIONS(2835),
    [anon_sym_LT_DASH] = ACTIONS(2835),
    [anon_sym_DOT_LBRACK] = ACTIONS(2837),
    [anon_sym_LT] = ACTIONS(2837),
    [anon_sym_use] = ACTIONS(2835),
    [anon_sym_use_BANG] = ACTIONS(2837),
    [anon_sym_do_BANG] = ACTIONS(2837),
    [anon_sym_begin] = ACTIONS(2835),
    [anon_sym_LPAREN2] = ACTIONS(2835),
    [anon_sym_or] = ACTIONS(2835),
    [aux_sym_char_token1] = ACTIONS(2837),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2835),
    [anon_sym_DQUOTE] = ACTIONS(2835),
    [anon_sym_AT_DQUOTE] = ACTIONS(2837),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2837),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2837),
    [sym_bool] = ACTIONS(2835),
    [sym_unit] = ACTIONS(2837),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2835),
    [sym_op_identifier] = ACTIONS(2835),
    [anon_sym_PLUS] = ACTIONS(2835),
    [anon_sym_DASH] = ACTIONS(2835),
    [anon_sym_PLUS_DOT] = ACTIONS(2835),
    [anon_sym_DASH_DOT] = ACTIONS(2835),
    [anon_sym_PERCENT] = ACTIONS(2835),
    [anon_sym_AMP_AMP] = ACTIONS(2835),
    [anon_sym_TILDE] = ACTIONS(2837),
    [aux_sym_prefix_op_token1] = ACTIONS(2835),
    [aux_sym_infix_op_token1] = ACTIONS(2837),
    [aux_sym_infix_op_token2] = ACTIONS(2835),
    [anon_sym_PIPE_PIPE] = ACTIONS(2835),
    [anon_sym_BANG_EQ] = ACTIONS(2835),
    [anon_sym_COLON_EQ] = ACTIONS(2837),
    [anon_sym_DOLLAR] = ACTIONS(2835),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2835),
    [sym_int] = ACTIONS(2835),
    [sym_xint] = ACTIONS(2837),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2837),
    [sym__newline] = ACTIONS(2837),
    [sym__dedent] = ACTIONS(2837),
  },
  [1595] = {
    [sym_block_comment] = STATE(1595),
    [sym_compiler_directive_decl] = STATE(1595),
    [sym_fsi_directive_decl] = STATE(1595),
    [sym_preproc_line] = STATE(1595),
    [sym_identifier] = ACTIONS(2819),
    [anon_sym_EQ] = ACTIONS(2821),
    [anon_sym_COLON] = ACTIONS(2819),
    [anon_sym_return] = ACTIONS(2819),
    [anon_sym_do] = ACTIONS(2819),
    [anon_sym_let] = ACTIONS(2819),
    [anon_sym_let_BANG] = ACTIONS(2821),
    [anon_sym_LPAREN] = ACTIONS(2819),
    [anon_sym_COMMA] = ACTIONS(2821),
    [anon_sym_null] = ACTIONS(2819),
    [anon_sym_QMARK] = ACTIONS(2819),
    [anon_sym_COLON_QMARK] = ACTIONS(2819),
    [anon_sym_COLON_COLON] = ACTIONS(2821),
    [anon_sym_AMP] = ACTIONS(2819),
    [anon_sym_LBRACK] = ACTIONS(2819),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2821),
    [anon_sym_LBRACE] = ACTIONS(2819),
    [anon_sym_LT_AT] = ACTIONS(2819),
    [anon_sym_LT_AT_AT] = ACTIONS(2819),
    [anon_sym_AT_AT_GT] = ACTIONS(2819),
    [anon_sym_DOT] = ACTIONS(2819),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2821),
    [anon_sym_new] = ACTIONS(2819),
    [anon_sym_return_BANG] = ACTIONS(2821),
    [anon_sym_yield] = ACTIONS(2819),
    [anon_sym_yield_BANG] = ACTIONS(2821),
    [anon_sym_lazy] = ACTIONS(2819),
    [anon_sym_assert] = ACTIONS(2819),
    [anon_sym_upcast] = ACTIONS(2819),
    [anon_sym_downcast] = ACTIONS(2819),
    [anon_sym_COLON_GT] = ACTIONS(2821),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2821),
    [anon_sym_for] = ACTIONS(2819),
    [anon_sym_while] = ACTIONS(2819),
    [anon_sym_if] = ACTIONS(2819),
    [anon_sym_fun] = ACTIONS(2819),
    [anon_sym_try] = ACTIONS(2819),
    [anon_sym_match] = ACTIONS(2819),
    [anon_sym_match_BANG] = ACTIONS(2821),
    [anon_sym_function] = ACTIONS(2819),
    [anon_sym_LT_DASH] = ACTIONS(2819),
    [anon_sym_DOT_LBRACK] = ACTIONS(2821),
    [anon_sym_LT] = ACTIONS(2821),
    [anon_sym_use] = ACTIONS(2819),
    [anon_sym_use_BANG] = ACTIONS(2821),
    [anon_sym_do_BANG] = ACTIONS(2821),
    [anon_sym_begin] = ACTIONS(2819),
    [anon_sym_LPAREN2] = ACTIONS(2819),
    [anon_sym_or] = ACTIONS(2819),
    [aux_sym_char_token1] = ACTIONS(2821),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2819),
    [anon_sym_DQUOTE] = ACTIONS(2819),
    [anon_sym_AT_DQUOTE] = ACTIONS(2821),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2821),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2821),
    [sym_bool] = ACTIONS(2819),
    [sym_unit] = ACTIONS(2821),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2819),
    [sym_op_identifier] = ACTIONS(2819),
    [anon_sym_PLUS] = ACTIONS(2819),
    [anon_sym_DASH] = ACTIONS(2819),
    [anon_sym_PLUS_DOT] = ACTIONS(2819),
    [anon_sym_DASH_DOT] = ACTIONS(2819),
    [anon_sym_PERCENT] = ACTIONS(2819),
    [anon_sym_AMP_AMP] = ACTIONS(2819),
    [anon_sym_TILDE] = ACTIONS(2821),
    [aux_sym_prefix_op_token1] = ACTIONS(2819),
    [aux_sym_infix_op_token1] = ACTIONS(2821),
    [aux_sym_infix_op_token2] = ACTIONS(2819),
    [anon_sym_PIPE_PIPE] = ACTIONS(2819),
    [anon_sym_BANG_EQ] = ACTIONS(2819),
    [anon_sym_COLON_EQ] = ACTIONS(2821),
    [anon_sym_DOLLAR] = ACTIONS(2819),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2819),
    [sym_int] = ACTIONS(3823),
    [sym_xint] = ACTIONS(2821),
    [anon_sym_f] = ACTIONS(2819),
    [aux_sym_decimal_token1] = ACTIONS(2819),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2821),
    [sym__newline] = ACTIONS(2821),
  },
  [1596] = {
    [sym_block_comment] = STATE(1596),
    [sym_compiler_directive_decl] = STATE(1596),
    [sym_fsi_directive_decl] = STATE(1596),
    [sym_preproc_line] = STATE(1596),
    [sym_identifier] = ACTIONS(3119),
    [anon_sym_EQ] = ACTIONS(3121),
    [anon_sym_COLON] = ACTIONS(3119),
    [anon_sym_return] = ACTIONS(3119),
    [anon_sym_do] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_let_BANG] = ACTIONS(3121),
    [anon_sym_as] = ACTIONS(3119),
    [anon_sym_LPAREN] = ACTIONS(3119),
    [anon_sym_COMMA] = ACTIONS(3121),
    [anon_sym_null] = ACTIONS(3119),
    [anon_sym_QMARK] = ACTIONS(3119),
    [anon_sym_COLON_QMARK] = ACTIONS(3119),
    [anon_sym_COLON_COLON] = ACTIONS(3121),
    [anon_sym_AMP] = ACTIONS(3119),
    [anon_sym_LBRACK] = ACTIONS(3119),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3121),
    [anon_sym_LBRACE] = ACTIONS(3119),
    [anon_sym_LT_AT] = ACTIONS(3119),
    [anon_sym_LT_AT_AT] = ACTIONS(3119),
    [anon_sym_DOT] = ACTIONS(3119),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3121),
    [anon_sym_new] = ACTIONS(3119),
    [anon_sym_with] = ACTIONS(3119),
    [anon_sym_return_BANG] = ACTIONS(3121),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_yield_BANG] = ACTIONS(3121),
    [anon_sym_lazy] = ACTIONS(3119),
    [anon_sym_assert] = ACTIONS(3119),
    [anon_sym_upcast] = ACTIONS(3119),
    [anon_sym_downcast] = ACTIONS(3119),
    [anon_sym_COLON_GT] = ACTIONS(3121),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3121),
    [anon_sym_for] = ACTIONS(3119),
    [anon_sym_while] = ACTIONS(3119),
    [anon_sym_if] = ACTIONS(3119),
    [anon_sym_fun] = ACTIONS(3119),
    [anon_sym_try] = ACTIONS(3119),
    [anon_sym_match] = ACTIONS(3119),
    [anon_sym_match_BANG] = ACTIONS(3121),
    [anon_sym_function] = ACTIONS(3119),
    [anon_sym_LT_DASH] = ACTIONS(3119),
    [anon_sym_DOT_LBRACK] = ACTIONS(3121),
    [anon_sym_LT] = ACTIONS(3121),
    [anon_sym_use] = ACTIONS(3119),
    [anon_sym_use_BANG] = ACTIONS(3121),
    [anon_sym_do_BANG] = ACTIONS(3121),
    [anon_sym_begin] = ACTIONS(3119),
    [anon_sym_LPAREN2] = ACTIONS(3119),
    [anon_sym_or] = ACTIONS(3119),
    [aux_sym_char_token1] = ACTIONS(3121),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3119),
    [anon_sym_DQUOTE] = ACTIONS(3119),
    [anon_sym_AT_DQUOTE] = ACTIONS(3121),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3121),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3121),
    [sym_bool] = ACTIONS(3119),
    [sym_unit] = ACTIONS(3121),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3119),
    [sym_op_identifier] = ACTIONS(3119),
    [anon_sym_PLUS] = ACTIONS(3119),
    [anon_sym_DASH] = ACTIONS(3119),
    [anon_sym_PLUS_DOT] = ACTIONS(3119),
    [anon_sym_DASH_DOT] = ACTIONS(3119),
    [anon_sym_PERCENT] = ACTIONS(3119),
    [anon_sym_AMP_AMP] = ACTIONS(3119),
    [anon_sym_TILDE] = ACTIONS(3121),
    [aux_sym_prefix_op_token1] = ACTIONS(3119),
    [aux_sym_infix_op_token1] = ACTIONS(3121),
    [aux_sym_infix_op_token2] = ACTIONS(3119),
    [anon_sym_PIPE_PIPE] = ACTIONS(3119),
    [anon_sym_BANG_EQ] = ACTIONS(3119),
    [anon_sym_COLON_EQ] = ACTIONS(3121),
    [anon_sym_DOLLAR] = ACTIONS(3119),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3119),
    [sym_int] = ACTIONS(3119),
    [sym_xint] = ACTIONS(3121),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3121),
    [sym__newline] = ACTIONS(3121),
    [sym__dedent] = ACTIONS(3121),
  },
  [1597] = {
    [sym_block_comment] = STATE(1597),
    [sym_compiler_directive_decl] = STATE(1597),
    [sym_fsi_directive_decl] = STATE(1597),
    [sym_preproc_line] = STATE(1597),
    [aux_sym_long_identifier_repeat1] = STATE(1571),
    [sym_identifier] = ACTIONS(2418),
    [anon_sym_EQ] = ACTIONS(2420),
    [anon_sym_COLON] = ACTIONS(2418),
    [anon_sym_return] = ACTIONS(2418),
    [anon_sym_do] = ACTIONS(2418),
    [anon_sym_let] = ACTIONS(2418),
    [anon_sym_let_BANG] = ACTIONS(2420),
    [anon_sym_LPAREN] = ACTIONS(2418),
    [anon_sym_COMMA] = ACTIONS(2420),
    [anon_sym_null] = ACTIONS(2418),
    [anon_sym_QMARK] = ACTIONS(2418),
    [anon_sym_COLON_QMARK] = ACTIONS(2418),
    [anon_sym_COLON_COLON] = ACTIONS(2420),
    [anon_sym_AMP] = ACTIONS(2418),
    [anon_sym_LBRACK] = ACTIONS(2418),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2420),
    [anon_sym_LBRACE] = ACTIONS(2418),
    [anon_sym_LT_AT] = ACTIONS(2418),
    [anon_sym_LT_AT_AT] = ACTIONS(2418),
    [anon_sym_DOT] = ACTIONS(3825),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2420),
    [anon_sym_new] = ACTIONS(2418),
    [anon_sym_return_BANG] = ACTIONS(2420),
    [anon_sym_yield] = ACTIONS(2418),
    [anon_sym_yield_BANG] = ACTIONS(2420),
    [anon_sym_lazy] = ACTIONS(2418),
    [anon_sym_assert] = ACTIONS(2418),
    [anon_sym_upcast] = ACTIONS(2418),
    [anon_sym_downcast] = ACTIONS(2418),
    [anon_sym_COLON_GT] = ACTIONS(2420),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2420),
    [anon_sym_for] = ACTIONS(2418),
    [anon_sym_while] = ACTIONS(2418),
    [anon_sym_if] = ACTIONS(2418),
    [anon_sym_fun] = ACTIONS(2418),
    [anon_sym_try] = ACTIONS(2418),
    [anon_sym_match] = ACTIONS(2418),
    [anon_sym_match_BANG] = ACTIONS(2420),
    [anon_sym_function] = ACTIONS(2418),
    [anon_sym_LT_DASH] = ACTIONS(2418),
    [anon_sym_DOT_LBRACK] = ACTIONS(2420),
    [anon_sym_LT] = ACTIONS(2420),
    [anon_sym_use] = ACTIONS(2418),
    [anon_sym_use_BANG] = ACTIONS(2420),
    [anon_sym_do_BANG] = ACTIONS(2420),
    [anon_sym_begin] = ACTIONS(2418),
    [anon_sym_LPAREN2] = ACTIONS(2418),
    [anon_sym_or] = ACTIONS(2418),
    [aux_sym_char_token1] = ACTIONS(2420),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2418),
    [anon_sym_DQUOTE] = ACTIONS(2418),
    [anon_sym_AT_DQUOTE] = ACTIONS(2420),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2420),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2420),
    [sym_bool] = ACTIONS(2418),
    [sym_unit] = ACTIONS(2420),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2418),
    [sym_op_identifier] = ACTIONS(2418),
    [anon_sym_PLUS] = ACTIONS(2418),
    [anon_sym_DASH] = ACTIONS(2418),
    [anon_sym_PLUS_DOT] = ACTIONS(2418),
    [anon_sym_DASH_DOT] = ACTIONS(2418),
    [anon_sym_PERCENT] = ACTIONS(2418),
    [anon_sym_AMP_AMP] = ACTIONS(2418),
    [anon_sym_TILDE] = ACTIONS(2420),
    [aux_sym_prefix_op_token1] = ACTIONS(2418),
    [aux_sym_infix_op_token1] = ACTIONS(2420),
    [aux_sym_infix_op_token2] = ACTIONS(2418),
    [anon_sym_PIPE_PIPE] = ACTIONS(2418),
    [anon_sym_BANG_EQ] = ACTIONS(2418),
    [anon_sym_COLON_EQ] = ACTIONS(2420),
    [anon_sym_DOLLAR] = ACTIONS(2418),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2418),
    [sym_int] = ACTIONS(2418),
    [sym_xint] = ACTIONS(2420),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2420),
    [anon_sym_POUNDendif] = ACTIONS(2420),
    [anon_sym_POUNDelse] = ACTIONS(2420),
    [sym__newline] = ACTIONS(2420),
  },
  [1598] = {
    [sym_block_comment] = STATE(1598),
    [sym_compiler_directive_decl] = STATE(1598),
    [sym_fsi_directive_decl] = STATE(1598),
    [sym_preproc_line] = STATE(1598),
    [aux_sym_rules_repeat1] = STATE(1599),
    [sym_identifier] = ACTIONS(2737),
    [anon_sym_EQ] = ACTIONS(2739),
    [anon_sym_COLON] = ACTIONS(2737),
    [anon_sym_return] = ACTIONS(2737),
    [anon_sym_do] = ACTIONS(2737),
    [anon_sym_let] = ACTIONS(2737),
    [anon_sym_let_BANG] = ACTIONS(2739),
    [anon_sym_LPAREN] = ACTIONS(2737),
    [anon_sym_COMMA] = ACTIONS(2739),
    [anon_sym_null] = ACTIONS(2737),
    [anon_sym_QMARK] = ACTIONS(2737),
    [anon_sym_COLON_QMARK] = ACTIONS(2737),
    [anon_sym_COLON_COLON] = ACTIONS(2739),
    [anon_sym_PIPE] = ACTIONS(3794),
    [anon_sym_AMP] = ACTIONS(2737),
    [anon_sym_LBRACK] = ACTIONS(2737),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2739),
    [anon_sym_LBRACE] = ACTIONS(2737),
    [anon_sym_LT_AT] = ACTIONS(2737),
    [anon_sym_LT_AT_AT] = ACTIONS(2737),
    [anon_sym_DOT] = ACTIONS(2737),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2739),
    [anon_sym_new] = ACTIONS(2737),
    [anon_sym_return_BANG] = ACTIONS(2739),
    [anon_sym_yield] = ACTIONS(2737),
    [anon_sym_yield_BANG] = ACTIONS(2739),
    [anon_sym_lazy] = ACTIONS(2737),
    [anon_sym_assert] = ACTIONS(2737),
    [anon_sym_upcast] = ACTIONS(2737),
    [anon_sym_downcast] = ACTIONS(2737),
    [anon_sym_COLON_GT] = ACTIONS(2739),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2739),
    [anon_sym_for] = ACTIONS(2737),
    [anon_sym_while] = ACTIONS(2737),
    [anon_sym_if] = ACTIONS(2737),
    [anon_sym_fun] = ACTIONS(2737),
    [anon_sym_try] = ACTIONS(2737),
    [anon_sym_match] = ACTIONS(2737),
    [anon_sym_match_BANG] = ACTIONS(2739),
    [anon_sym_function] = ACTIONS(2737),
    [anon_sym_LT_DASH] = ACTIONS(2737),
    [anon_sym_DOT_LBRACK] = ACTIONS(2739),
    [anon_sym_LT] = ACTIONS(2739),
    [anon_sym_use] = ACTIONS(2737),
    [anon_sym_use_BANG] = ACTIONS(2739),
    [anon_sym_do_BANG] = ACTIONS(2739),
    [anon_sym_begin] = ACTIONS(2737),
    [anon_sym_LPAREN2] = ACTIONS(2737),
    [anon_sym_or] = ACTIONS(2737),
    [aux_sym_char_token1] = ACTIONS(2739),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2737),
    [anon_sym_DQUOTE] = ACTIONS(2737),
    [anon_sym_AT_DQUOTE] = ACTIONS(2739),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2739),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2739),
    [sym_bool] = ACTIONS(2737),
    [sym_unit] = ACTIONS(2739),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2737),
    [sym_op_identifier] = ACTIONS(2737),
    [anon_sym_PLUS] = ACTIONS(2737),
    [anon_sym_DASH] = ACTIONS(2737),
    [anon_sym_PLUS_DOT] = ACTIONS(2737),
    [anon_sym_DASH_DOT] = ACTIONS(2737),
    [anon_sym_PERCENT] = ACTIONS(2737),
    [anon_sym_AMP_AMP] = ACTIONS(2737),
    [anon_sym_TILDE] = ACTIONS(2739),
    [aux_sym_prefix_op_token1] = ACTIONS(2737),
    [aux_sym_infix_op_token1] = ACTIONS(2739),
    [aux_sym_infix_op_token2] = ACTIONS(2737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2737),
    [anon_sym_BANG_EQ] = ACTIONS(2737),
    [anon_sym_COLON_EQ] = ACTIONS(2739),
    [anon_sym_DOLLAR] = ACTIONS(2737),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2737),
    [sym_int] = ACTIONS(2737),
    [sym_xint] = ACTIONS(2739),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2739),
    [anon_sym_POUNDendif] = ACTIONS(2739),
    [sym__newline] = ACTIONS(3827),
  },
  [1599] = {
    [sym_block_comment] = STATE(1599),
    [sym_compiler_directive_decl] = STATE(1599),
    [sym_fsi_directive_decl] = STATE(1599),
    [sym_preproc_line] = STATE(1599),
    [aux_sym_rules_repeat1] = STATE(1599),
    [sym_identifier] = ACTIONS(2713),
    [anon_sym_EQ] = ACTIONS(2715),
    [anon_sym_COLON] = ACTIONS(2713),
    [anon_sym_return] = ACTIONS(2713),
    [anon_sym_do] = ACTIONS(2713),
    [anon_sym_let] = ACTIONS(2713),
    [anon_sym_let_BANG] = ACTIONS(2715),
    [anon_sym_LPAREN] = ACTIONS(2713),
    [anon_sym_COMMA] = ACTIONS(2715),
    [anon_sym_null] = ACTIONS(2713),
    [anon_sym_QMARK] = ACTIONS(2713),
    [anon_sym_COLON_QMARK] = ACTIONS(2713),
    [anon_sym_COLON_COLON] = ACTIONS(2715),
    [anon_sym_PIPE] = ACTIONS(3830),
    [anon_sym_AMP] = ACTIONS(2713),
    [anon_sym_LBRACK] = ACTIONS(2713),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2715),
    [anon_sym_LBRACE] = ACTIONS(2713),
    [anon_sym_LT_AT] = ACTIONS(2713),
    [anon_sym_LT_AT_AT] = ACTIONS(2713),
    [anon_sym_DOT] = ACTIONS(2713),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2715),
    [anon_sym_new] = ACTIONS(2713),
    [anon_sym_return_BANG] = ACTIONS(2715),
    [anon_sym_yield] = ACTIONS(2713),
    [anon_sym_yield_BANG] = ACTIONS(2715),
    [anon_sym_lazy] = ACTIONS(2713),
    [anon_sym_assert] = ACTIONS(2713),
    [anon_sym_upcast] = ACTIONS(2713),
    [anon_sym_downcast] = ACTIONS(2713),
    [anon_sym_COLON_GT] = ACTIONS(2715),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2715),
    [anon_sym_for] = ACTIONS(2713),
    [anon_sym_while] = ACTIONS(2713),
    [anon_sym_if] = ACTIONS(2713),
    [anon_sym_fun] = ACTIONS(2713),
    [anon_sym_try] = ACTIONS(2713),
    [anon_sym_match] = ACTIONS(2713),
    [anon_sym_match_BANG] = ACTIONS(2715),
    [anon_sym_function] = ACTIONS(2713),
    [anon_sym_LT_DASH] = ACTIONS(2713),
    [anon_sym_DOT_LBRACK] = ACTIONS(2715),
    [anon_sym_LT] = ACTIONS(2715),
    [anon_sym_use] = ACTIONS(2713),
    [anon_sym_use_BANG] = ACTIONS(2715),
    [anon_sym_do_BANG] = ACTIONS(2715),
    [anon_sym_begin] = ACTIONS(2713),
    [anon_sym_LPAREN2] = ACTIONS(2713),
    [anon_sym_or] = ACTIONS(2713),
    [aux_sym_char_token1] = ACTIONS(2715),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2713),
    [anon_sym_DQUOTE] = ACTIONS(2713),
    [anon_sym_AT_DQUOTE] = ACTIONS(2715),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2715),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2715),
    [sym_bool] = ACTIONS(2713),
    [sym_unit] = ACTIONS(2715),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2713),
    [sym_op_identifier] = ACTIONS(2713),
    [anon_sym_PLUS] = ACTIONS(2713),
    [anon_sym_DASH] = ACTIONS(2713),
    [anon_sym_PLUS_DOT] = ACTIONS(2713),
    [anon_sym_DASH_DOT] = ACTIONS(2713),
    [anon_sym_PERCENT] = ACTIONS(2713),
    [anon_sym_AMP_AMP] = ACTIONS(2713),
    [anon_sym_TILDE] = ACTIONS(2715),
    [aux_sym_prefix_op_token1] = ACTIONS(2713),
    [aux_sym_infix_op_token1] = ACTIONS(2715),
    [aux_sym_infix_op_token2] = ACTIONS(2713),
    [anon_sym_PIPE_PIPE] = ACTIONS(2713),
    [anon_sym_BANG_EQ] = ACTIONS(2713),
    [anon_sym_COLON_EQ] = ACTIONS(2715),
    [anon_sym_DOLLAR] = ACTIONS(2713),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2713),
    [sym_int] = ACTIONS(2713),
    [sym_xint] = ACTIONS(2715),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2715),
    [anon_sym_POUNDendif] = ACTIONS(2715),
    [sym__newline] = ACTIONS(3833),
  },
  [1600] = {
    [sym_block_comment] = STATE(1600),
    [sym_compiler_directive_decl] = STATE(1600),
    [sym_fsi_directive_decl] = STATE(1600),
    [sym_preproc_line] = STATE(1600),
    [sym_identifier] = ACTIONS(3135),
    [anon_sym_EQ] = ACTIONS(3137),
    [anon_sym_COLON] = ACTIONS(3135),
    [anon_sym_return] = ACTIONS(3135),
    [anon_sym_do] = ACTIONS(3135),
    [anon_sym_let] = ACTIONS(3135),
    [anon_sym_let_BANG] = ACTIONS(3137),
    [anon_sym_as] = ACTIONS(3135),
    [anon_sym_LPAREN] = ACTIONS(3135),
    [anon_sym_COMMA] = ACTIONS(3137),
    [anon_sym_null] = ACTIONS(3135),
    [anon_sym_QMARK] = ACTIONS(3135),
    [anon_sym_COLON_QMARK] = ACTIONS(3135),
    [anon_sym_COLON_COLON] = ACTIONS(3137),
    [anon_sym_AMP] = ACTIONS(3135),
    [anon_sym_LBRACK] = ACTIONS(3135),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3137),
    [anon_sym_LBRACE] = ACTIONS(3135),
    [anon_sym_LT_AT] = ACTIONS(3135),
    [anon_sym_LT_AT_AT] = ACTIONS(3135),
    [anon_sym_DOT] = ACTIONS(3135),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3137),
    [anon_sym_new] = ACTIONS(3135),
    [anon_sym_with] = ACTIONS(3135),
    [anon_sym_return_BANG] = ACTIONS(3137),
    [anon_sym_yield] = ACTIONS(3135),
    [anon_sym_yield_BANG] = ACTIONS(3137),
    [anon_sym_lazy] = ACTIONS(3135),
    [anon_sym_assert] = ACTIONS(3135),
    [anon_sym_upcast] = ACTIONS(3135),
    [anon_sym_downcast] = ACTIONS(3135),
    [anon_sym_COLON_GT] = ACTIONS(3137),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3137),
    [anon_sym_for] = ACTIONS(3135),
    [anon_sym_while] = ACTIONS(3135),
    [anon_sym_if] = ACTIONS(3135),
    [anon_sym_fun] = ACTIONS(3135),
    [anon_sym_try] = ACTIONS(3135),
    [anon_sym_match] = ACTIONS(3135),
    [anon_sym_match_BANG] = ACTIONS(3137),
    [anon_sym_function] = ACTIONS(3135),
    [anon_sym_LT_DASH] = ACTIONS(3135),
    [anon_sym_DOT_LBRACK] = ACTIONS(3137),
    [anon_sym_LT] = ACTIONS(3137),
    [anon_sym_use] = ACTIONS(3135),
    [anon_sym_use_BANG] = ACTIONS(3137),
    [anon_sym_do_BANG] = ACTIONS(3137),
    [anon_sym_begin] = ACTIONS(3135),
    [anon_sym_LPAREN2] = ACTIONS(3135),
    [anon_sym_or] = ACTIONS(3135),
    [aux_sym_char_token1] = ACTIONS(3137),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3135),
    [anon_sym_DQUOTE] = ACTIONS(3135),
    [anon_sym_AT_DQUOTE] = ACTIONS(3137),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3137),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3137),
    [sym_bool] = ACTIONS(3135),
    [sym_unit] = ACTIONS(3137),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3135),
    [sym_op_identifier] = ACTIONS(3135),
    [anon_sym_PLUS] = ACTIONS(3135),
    [anon_sym_DASH] = ACTIONS(3135),
    [anon_sym_PLUS_DOT] = ACTIONS(3135),
    [anon_sym_DASH_DOT] = ACTIONS(3135),
    [anon_sym_PERCENT] = ACTIONS(3135),
    [anon_sym_AMP_AMP] = ACTIONS(3135),
    [anon_sym_TILDE] = ACTIONS(3137),
    [aux_sym_prefix_op_token1] = ACTIONS(3135),
    [aux_sym_infix_op_token1] = ACTIONS(3137),
    [aux_sym_infix_op_token2] = ACTIONS(3135),
    [anon_sym_PIPE_PIPE] = ACTIONS(3135),
    [anon_sym_BANG_EQ] = ACTIONS(3135),
    [anon_sym_COLON_EQ] = ACTIONS(3137),
    [anon_sym_DOLLAR] = ACTIONS(3135),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3135),
    [sym_int] = ACTIONS(3135),
    [sym_xint] = ACTIONS(3137),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3137),
    [sym__newline] = ACTIONS(3137),
    [sym__dedent] = ACTIONS(3137),
  },
  [1601] = {
    [sym_block_comment] = STATE(1601),
    [sym_compiler_directive_decl] = STATE(1601),
    [sym_fsi_directive_decl] = STATE(1601),
    [sym_preproc_line] = STATE(1601),
    [sym_identifier] = ACTIONS(3139),
    [anon_sym_EQ] = ACTIONS(3141),
    [anon_sym_COLON] = ACTIONS(3139),
    [anon_sym_return] = ACTIONS(3139),
    [anon_sym_do] = ACTIONS(3139),
    [anon_sym_let] = ACTIONS(3139),
    [anon_sym_let_BANG] = ACTIONS(3141),
    [anon_sym_as] = ACTIONS(3139),
    [anon_sym_LPAREN] = ACTIONS(3139),
    [anon_sym_COMMA] = ACTIONS(3141),
    [anon_sym_null] = ACTIONS(3139),
    [anon_sym_QMARK] = ACTIONS(3139),
    [anon_sym_COLON_QMARK] = ACTIONS(3139),
    [anon_sym_COLON_COLON] = ACTIONS(3141),
    [anon_sym_AMP] = ACTIONS(3139),
    [anon_sym_LBRACK] = ACTIONS(3139),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3141),
    [anon_sym_LBRACE] = ACTIONS(3139),
    [anon_sym_LT_AT] = ACTIONS(3139),
    [anon_sym_LT_AT_AT] = ACTIONS(3139),
    [anon_sym_DOT] = ACTIONS(3139),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3141),
    [anon_sym_new] = ACTIONS(3139),
    [anon_sym_with] = ACTIONS(3139),
    [anon_sym_return_BANG] = ACTIONS(3141),
    [anon_sym_yield] = ACTIONS(3139),
    [anon_sym_yield_BANG] = ACTIONS(3141),
    [anon_sym_lazy] = ACTIONS(3139),
    [anon_sym_assert] = ACTIONS(3139),
    [anon_sym_upcast] = ACTIONS(3139),
    [anon_sym_downcast] = ACTIONS(3139),
    [anon_sym_COLON_GT] = ACTIONS(3141),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3141),
    [anon_sym_for] = ACTIONS(3139),
    [anon_sym_while] = ACTIONS(3139),
    [anon_sym_if] = ACTIONS(3139),
    [anon_sym_fun] = ACTIONS(3139),
    [anon_sym_try] = ACTIONS(3139),
    [anon_sym_match] = ACTIONS(3139),
    [anon_sym_match_BANG] = ACTIONS(3141),
    [anon_sym_function] = ACTIONS(3139),
    [anon_sym_LT_DASH] = ACTIONS(3139),
    [anon_sym_DOT_LBRACK] = ACTIONS(3141),
    [anon_sym_LT] = ACTIONS(3141),
    [anon_sym_use] = ACTIONS(3139),
    [anon_sym_use_BANG] = ACTIONS(3141),
    [anon_sym_do_BANG] = ACTIONS(3141),
    [anon_sym_begin] = ACTIONS(3139),
    [anon_sym_LPAREN2] = ACTIONS(3139),
    [anon_sym_or] = ACTIONS(3139),
    [aux_sym_char_token1] = ACTIONS(3141),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3139),
    [anon_sym_DQUOTE] = ACTIONS(3139),
    [anon_sym_AT_DQUOTE] = ACTIONS(3141),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3141),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3141),
    [sym_bool] = ACTIONS(3139),
    [sym_unit] = ACTIONS(3141),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3139),
    [sym_op_identifier] = ACTIONS(3139),
    [anon_sym_PLUS] = ACTIONS(3139),
    [anon_sym_DASH] = ACTIONS(3139),
    [anon_sym_PLUS_DOT] = ACTIONS(3139),
    [anon_sym_DASH_DOT] = ACTIONS(3139),
    [anon_sym_PERCENT] = ACTIONS(3139),
    [anon_sym_AMP_AMP] = ACTIONS(3139),
    [anon_sym_TILDE] = ACTIONS(3141),
    [aux_sym_prefix_op_token1] = ACTIONS(3139),
    [aux_sym_infix_op_token1] = ACTIONS(3141),
    [aux_sym_infix_op_token2] = ACTIONS(3139),
    [anon_sym_PIPE_PIPE] = ACTIONS(3139),
    [anon_sym_BANG_EQ] = ACTIONS(3139),
    [anon_sym_COLON_EQ] = ACTIONS(3141),
    [anon_sym_DOLLAR] = ACTIONS(3139),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3139),
    [sym_int] = ACTIONS(3139),
    [sym_xint] = ACTIONS(3141),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3141),
    [sym__newline] = ACTIONS(3141),
    [sym__dedent] = ACTIONS(3141),
  },
  [1602] = {
    [sym_block_comment] = STATE(1602),
    [sym_compiler_directive_decl] = STATE(1602),
    [sym_fsi_directive_decl] = STATE(1602),
    [sym_preproc_line] = STATE(1602),
    [sym_identifier] = ACTIONS(3131),
    [anon_sym_EQ] = ACTIONS(3133),
    [anon_sym_COLON] = ACTIONS(3131),
    [anon_sym_return] = ACTIONS(3131),
    [anon_sym_do] = ACTIONS(3131),
    [anon_sym_let] = ACTIONS(3131),
    [anon_sym_let_BANG] = ACTIONS(3133),
    [anon_sym_as] = ACTIONS(3131),
    [anon_sym_LPAREN] = ACTIONS(3131),
    [anon_sym_COMMA] = ACTIONS(3133),
    [anon_sym_null] = ACTIONS(3131),
    [anon_sym_QMARK] = ACTIONS(3131),
    [anon_sym_COLON_QMARK] = ACTIONS(3131),
    [anon_sym_COLON_COLON] = ACTIONS(3133),
    [anon_sym_AMP] = ACTIONS(3131),
    [anon_sym_LBRACK] = ACTIONS(3131),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3133),
    [anon_sym_LBRACE] = ACTIONS(3131),
    [anon_sym_LT_AT] = ACTIONS(3131),
    [anon_sym_LT_AT_AT] = ACTIONS(3131),
    [anon_sym_DOT] = ACTIONS(3131),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3133),
    [anon_sym_new] = ACTIONS(3131),
    [anon_sym_with] = ACTIONS(3131),
    [anon_sym_return_BANG] = ACTIONS(3133),
    [anon_sym_yield] = ACTIONS(3131),
    [anon_sym_yield_BANG] = ACTIONS(3133),
    [anon_sym_lazy] = ACTIONS(3131),
    [anon_sym_assert] = ACTIONS(3131),
    [anon_sym_upcast] = ACTIONS(3131),
    [anon_sym_downcast] = ACTIONS(3131),
    [anon_sym_COLON_GT] = ACTIONS(3133),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3133),
    [anon_sym_for] = ACTIONS(3131),
    [anon_sym_while] = ACTIONS(3131),
    [anon_sym_if] = ACTIONS(3131),
    [anon_sym_fun] = ACTIONS(3131),
    [anon_sym_try] = ACTIONS(3131),
    [anon_sym_match] = ACTIONS(3131),
    [anon_sym_match_BANG] = ACTIONS(3133),
    [anon_sym_function] = ACTIONS(3131),
    [anon_sym_LT_DASH] = ACTIONS(3131),
    [anon_sym_DOT_LBRACK] = ACTIONS(3133),
    [anon_sym_LT] = ACTIONS(3133),
    [anon_sym_use] = ACTIONS(3131),
    [anon_sym_use_BANG] = ACTIONS(3133),
    [anon_sym_do_BANG] = ACTIONS(3133),
    [anon_sym_begin] = ACTIONS(3131),
    [anon_sym_LPAREN2] = ACTIONS(3131),
    [anon_sym_or] = ACTIONS(3131),
    [aux_sym_char_token1] = ACTIONS(3133),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3131),
    [anon_sym_DQUOTE] = ACTIONS(3131),
    [anon_sym_AT_DQUOTE] = ACTIONS(3133),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3133),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3133),
    [sym_bool] = ACTIONS(3131),
    [sym_unit] = ACTIONS(3133),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3131),
    [sym_op_identifier] = ACTIONS(3131),
    [anon_sym_PLUS] = ACTIONS(3131),
    [anon_sym_DASH] = ACTIONS(3131),
    [anon_sym_PLUS_DOT] = ACTIONS(3131),
    [anon_sym_DASH_DOT] = ACTIONS(3131),
    [anon_sym_PERCENT] = ACTIONS(3131),
    [anon_sym_AMP_AMP] = ACTIONS(3131),
    [anon_sym_TILDE] = ACTIONS(3133),
    [aux_sym_prefix_op_token1] = ACTIONS(3131),
    [aux_sym_infix_op_token1] = ACTIONS(3133),
    [aux_sym_infix_op_token2] = ACTIONS(3131),
    [anon_sym_PIPE_PIPE] = ACTIONS(3131),
    [anon_sym_BANG_EQ] = ACTIONS(3131),
    [anon_sym_COLON_EQ] = ACTIONS(3133),
    [anon_sym_DOLLAR] = ACTIONS(3131),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3131),
    [sym_int] = ACTIONS(3131),
    [sym_xint] = ACTIONS(3133),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3133),
    [sym__newline] = ACTIONS(3133),
    [sym__dedent] = ACTIONS(3133),
  },
  [1603] = {
    [sym_block_comment] = STATE(1603),
    [sym_compiler_directive_decl] = STATE(1603),
    [sym_fsi_directive_decl] = STATE(1603),
    [sym_preproc_line] = STATE(1603),
    [sym_identifier] = ACTIONS(3127),
    [anon_sym_EQ] = ACTIONS(3129),
    [anon_sym_COLON] = ACTIONS(3127),
    [anon_sym_return] = ACTIONS(3127),
    [anon_sym_do] = ACTIONS(3127),
    [anon_sym_let] = ACTIONS(3127),
    [anon_sym_let_BANG] = ACTIONS(3129),
    [anon_sym_as] = ACTIONS(3127),
    [anon_sym_LPAREN] = ACTIONS(3127),
    [anon_sym_COMMA] = ACTIONS(3129),
    [anon_sym_null] = ACTIONS(3127),
    [anon_sym_QMARK] = ACTIONS(3127),
    [anon_sym_COLON_QMARK] = ACTIONS(3127),
    [anon_sym_COLON_COLON] = ACTIONS(3129),
    [anon_sym_AMP] = ACTIONS(3127),
    [anon_sym_LBRACK] = ACTIONS(3127),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3129),
    [anon_sym_LBRACE] = ACTIONS(3127),
    [anon_sym_LT_AT] = ACTIONS(3127),
    [anon_sym_LT_AT_AT] = ACTIONS(3127),
    [anon_sym_DOT] = ACTIONS(3127),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3129),
    [anon_sym_new] = ACTIONS(3127),
    [anon_sym_with] = ACTIONS(3127),
    [anon_sym_return_BANG] = ACTIONS(3129),
    [anon_sym_yield] = ACTIONS(3127),
    [anon_sym_yield_BANG] = ACTIONS(3129),
    [anon_sym_lazy] = ACTIONS(3127),
    [anon_sym_assert] = ACTIONS(3127),
    [anon_sym_upcast] = ACTIONS(3127),
    [anon_sym_downcast] = ACTIONS(3127),
    [anon_sym_COLON_GT] = ACTIONS(3129),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3129),
    [anon_sym_for] = ACTIONS(3127),
    [anon_sym_while] = ACTIONS(3127),
    [anon_sym_if] = ACTIONS(3127),
    [anon_sym_fun] = ACTIONS(3127),
    [anon_sym_try] = ACTIONS(3127),
    [anon_sym_match] = ACTIONS(3127),
    [anon_sym_match_BANG] = ACTIONS(3129),
    [anon_sym_function] = ACTIONS(3127),
    [anon_sym_LT_DASH] = ACTIONS(3127),
    [anon_sym_DOT_LBRACK] = ACTIONS(3129),
    [anon_sym_LT] = ACTIONS(3129),
    [anon_sym_use] = ACTIONS(3127),
    [anon_sym_use_BANG] = ACTIONS(3129),
    [anon_sym_do_BANG] = ACTIONS(3129),
    [anon_sym_begin] = ACTIONS(3127),
    [anon_sym_LPAREN2] = ACTIONS(3127),
    [anon_sym_or] = ACTIONS(3127),
    [aux_sym_char_token1] = ACTIONS(3129),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3127),
    [anon_sym_DQUOTE] = ACTIONS(3127),
    [anon_sym_AT_DQUOTE] = ACTIONS(3129),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3129),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3129),
    [sym_bool] = ACTIONS(3127),
    [sym_unit] = ACTIONS(3129),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3127),
    [sym_op_identifier] = ACTIONS(3127),
    [anon_sym_PLUS] = ACTIONS(3127),
    [anon_sym_DASH] = ACTIONS(3127),
    [anon_sym_PLUS_DOT] = ACTIONS(3127),
    [anon_sym_DASH_DOT] = ACTIONS(3127),
    [anon_sym_PERCENT] = ACTIONS(3127),
    [anon_sym_AMP_AMP] = ACTIONS(3127),
    [anon_sym_TILDE] = ACTIONS(3129),
    [aux_sym_prefix_op_token1] = ACTIONS(3127),
    [aux_sym_infix_op_token1] = ACTIONS(3129),
    [aux_sym_infix_op_token2] = ACTIONS(3127),
    [anon_sym_PIPE_PIPE] = ACTIONS(3127),
    [anon_sym_BANG_EQ] = ACTIONS(3127),
    [anon_sym_COLON_EQ] = ACTIONS(3129),
    [anon_sym_DOLLAR] = ACTIONS(3127),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3127),
    [sym_int] = ACTIONS(3127),
    [sym_xint] = ACTIONS(3129),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3129),
    [sym__newline] = ACTIONS(3129),
    [sym__dedent] = ACTIONS(3129),
  },
  [1604] = {
    [sym_block_comment] = STATE(1604),
    [sym_compiler_directive_decl] = STATE(1604),
    [sym_fsi_directive_decl] = STATE(1604),
    [sym_preproc_line] = STATE(1604),
    [sym_identifier] = ACTIONS(3123),
    [anon_sym_EQ] = ACTIONS(3125),
    [anon_sym_COLON] = ACTIONS(3123),
    [anon_sym_return] = ACTIONS(3123),
    [anon_sym_do] = ACTIONS(3123),
    [anon_sym_let] = ACTIONS(3123),
    [anon_sym_let_BANG] = ACTIONS(3125),
    [anon_sym_as] = ACTIONS(3123),
    [anon_sym_LPAREN] = ACTIONS(3123),
    [anon_sym_COMMA] = ACTIONS(3125),
    [anon_sym_null] = ACTIONS(3123),
    [anon_sym_QMARK] = ACTIONS(3123),
    [anon_sym_COLON_QMARK] = ACTIONS(3123),
    [anon_sym_COLON_COLON] = ACTIONS(3125),
    [anon_sym_AMP] = ACTIONS(3123),
    [anon_sym_LBRACK] = ACTIONS(3123),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3125),
    [anon_sym_LBRACE] = ACTIONS(3123),
    [anon_sym_LT_AT] = ACTIONS(3123),
    [anon_sym_LT_AT_AT] = ACTIONS(3123),
    [anon_sym_DOT] = ACTIONS(3123),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3125),
    [anon_sym_new] = ACTIONS(3123),
    [anon_sym_with] = ACTIONS(3123),
    [anon_sym_return_BANG] = ACTIONS(3125),
    [anon_sym_yield] = ACTIONS(3123),
    [anon_sym_yield_BANG] = ACTIONS(3125),
    [anon_sym_lazy] = ACTIONS(3123),
    [anon_sym_assert] = ACTIONS(3123),
    [anon_sym_upcast] = ACTIONS(3123),
    [anon_sym_downcast] = ACTIONS(3123),
    [anon_sym_COLON_GT] = ACTIONS(3125),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3125),
    [anon_sym_for] = ACTIONS(3123),
    [anon_sym_while] = ACTIONS(3123),
    [anon_sym_if] = ACTIONS(3123),
    [anon_sym_fun] = ACTIONS(3123),
    [anon_sym_try] = ACTIONS(3123),
    [anon_sym_match] = ACTIONS(3123),
    [anon_sym_match_BANG] = ACTIONS(3125),
    [anon_sym_function] = ACTIONS(3123),
    [anon_sym_LT_DASH] = ACTIONS(3123),
    [anon_sym_DOT_LBRACK] = ACTIONS(3125),
    [anon_sym_LT] = ACTIONS(3125),
    [anon_sym_use] = ACTIONS(3123),
    [anon_sym_use_BANG] = ACTIONS(3125),
    [anon_sym_do_BANG] = ACTIONS(3125),
    [anon_sym_begin] = ACTIONS(3123),
    [anon_sym_LPAREN2] = ACTIONS(3123),
    [anon_sym_or] = ACTIONS(3123),
    [aux_sym_char_token1] = ACTIONS(3125),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3123),
    [anon_sym_DQUOTE] = ACTIONS(3123),
    [anon_sym_AT_DQUOTE] = ACTIONS(3125),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3125),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3125),
    [sym_bool] = ACTIONS(3123),
    [sym_unit] = ACTIONS(3125),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3123),
    [sym_op_identifier] = ACTIONS(3123),
    [anon_sym_PLUS] = ACTIONS(3123),
    [anon_sym_DASH] = ACTIONS(3123),
    [anon_sym_PLUS_DOT] = ACTIONS(3123),
    [anon_sym_DASH_DOT] = ACTIONS(3123),
    [anon_sym_PERCENT] = ACTIONS(3123),
    [anon_sym_AMP_AMP] = ACTIONS(3123),
    [anon_sym_TILDE] = ACTIONS(3125),
    [aux_sym_prefix_op_token1] = ACTIONS(3123),
    [aux_sym_infix_op_token1] = ACTIONS(3125),
    [aux_sym_infix_op_token2] = ACTIONS(3123),
    [anon_sym_PIPE_PIPE] = ACTIONS(3123),
    [anon_sym_BANG_EQ] = ACTIONS(3123),
    [anon_sym_COLON_EQ] = ACTIONS(3125),
    [anon_sym_DOLLAR] = ACTIONS(3123),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3123),
    [sym_int] = ACTIONS(3123),
    [sym_xint] = ACTIONS(3125),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3125),
    [sym__newline] = ACTIONS(3125),
    [sym__dedent] = ACTIONS(3125),
  },
  [1605] = {
    [sym_block_comment] = STATE(1605),
    [sym_compiler_directive_decl] = STATE(1605),
    [sym_fsi_directive_decl] = STATE(1605),
    [sym_preproc_line] = STATE(1605),
    [sym_identifier] = ACTIONS(2946),
    [anon_sym_EQ] = ACTIONS(2948),
    [anon_sym_COLON] = ACTIONS(2946),
    [anon_sym_return] = ACTIONS(2946),
    [anon_sym_do] = ACTIONS(2946),
    [anon_sym_let] = ACTIONS(2946),
    [anon_sym_let_BANG] = ACTIONS(2948),
    [anon_sym_as] = ACTIONS(2946),
    [anon_sym_LPAREN] = ACTIONS(2946),
    [anon_sym_COMMA] = ACTIONS(2948),
    [anon_sym_null] = ACTIONS(2946),
    [anon_sym_QMARK] = ACTIONS(2946),
    [anon_sym_COLON_QMARK] = ACTIONS(2946),
    [anon_sym_COLON_COLON] = ACTIONS(2948),
    [anon_sym_AMP] = ACTIONS(2946),
    [anon_sym_LBRACK] = ACTIONS(2946),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2948),
    [anon_sym_LBRACE] = ACTIONS(2946),
    [anon_sym_LT_AT] = ACTIONS(2946),
    [anon_sym_LT_AT_AT] = ACTIONS(2946),
    [anon_sym_DOT] = ACTIONS(2946),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2948),
    [anon_sym_new] = ACTIONS(2946),
    [anon_sym_with] = ACTIONS(2946),
    [anon_sym_return_BANG] = ACTIONS(2948),
    [anon_sym_yield] = ACTIONS(2946),
    [anon_sym_yield_BANG] = ACTIONS(2948),
    [anon_sym_lazy] = ACTIONS(2946),
    [anon_sym_assert] = ACTIONS(2946),
    [anon_sym_upcast] = ACTIONS(2946),
    [anon_sym_downcast] = ACTIONS(2946),
    [anon_sym_COLON_GT] = ACTIONS(2948),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2948),
    [anon_sym_for] = ACTIONS(2946),
    [anon_sym_while] = ACTIONS(2946),
    [anon_sym_if] = ACTIONS(2946),
    [anon_sym_fun] = ACTIONS(2946),
    [anon_sym_try] = ACTIONS(2946),
    [anon_sym_match] = ACTIONS(2946),
    [anon_sym_match_BANG] = ACTIONS(2948),
    [anon_sym_function] = ACTIONS(2946),
    [anon_sym_LT_DASH] = ACTIONS(2946),
    [anon_sym_DOT_LBRACK] = ACTIONS(2948),
    [anon_sym_LT] = ACTIONS(2948),
    [anon_sym_use] = ACTIONS(2946),
    [anon_sym_use_BANG] = ACTIONS(2948),
    [anon_sym_do_BANG] = ACTIONS(2948),
    [anon_sym_begin] = ACTIONS(2946),
    [anon_sym_LPAREN2] = ACTIONS(2946),
    [anon_sym_or] = ACTIONS(2946),
    [aux_sym_char_token1] = ACTIONS(2948),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2946),
    [anon_sym_DQUOTE] = ACTIONS(2946),
    [anon_sym_AT_DQUOTE] = ACTIONS(2948),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2948),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2948),
    [sym_bool] = ACTIONS(2946),
    [sym_unit] = ACTIONS(2948),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2946),
    [sym_op_identifier] = ACTIONS(2946),
    [anon_sym_PLUS] = ACTIONS(2946),
    [anon_sym_DASH] = ACTIONS(2946),
    [anon_sym_PLUS_DOT] = ACTIONS(2946),
    [anon_sym_DASH_DOT] = ACTIONS(2946),
    [anon_sym_PERCENT] = ACTIONS(2946),
    [anon_sym_AMP_AMP] = ACTIONS(2946),
    [anon_sym_TILDE] = ACTIONS(2948),
    [aux_sym_prefix_op_token1] = ACTIONS(2946),
    [aux_sym_infix_op_token1] = ACTIONS(2948),
    [aux_sym_infix_op_token2] = ACTIONS(2946),
    [anon_sym_PIPE_PIPE] = ACTIONS(2946),
    [anon_sym_BANG_EQ] = ACTIONS(2946),
    [anon_sym_COLON_EQ] = ACTIONS(2948),
    [anon_sym_DOLLAR] = ACTIONS(2946),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2946),
    [sym_int] = ACTIONS(2946),
    [sym_xint] = ACTIONS(2948),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2948),
    [sym__newline] = ACTIONS(2948),
    [sym__dedent] = ACTIONS(2948),
  },
  [1606] = {
    [sym_block_comment] = STATE(1606),
    [sym_compiler_directive_decl] = STATE(1606),
    [sym_fsi_directive_decl] = STATE(1606),
    [sym_preproc_line] = STATE(1606),
    [aux_sym_long_identifier_repeat1] = STATE(1607),
    [sym_identifier] = ACTIONS(2418),
    [anon_sym_EQ] = ACTIONS(2420),
    [anon_sym_COLON] = ACTIONS(2418),
    [anon_sym_return] = ACTIONS(2418),
    [anon_sym_do] = ACTIONS(2418),
    [anon_sym_let] = ACTIONS(2418),
    [anon_sym_let_BANG] = ACTIONS(2420),
    [anon_sym_as] = ACTIONS(2418),
    [anon_sym_LPAREN] = ACTIONS(2418),
    [anon_sym_COMMA] = ACTIONS(2420),
    [anon_sym_null] = ACTIONS(2418),
    [anon_sym_QMARK] = ACTIONS(2418),
    [anon_sym_COLON_QMARK] = ACTIONS(2418),
    [anon_sym_COLON_COLON] = ACTIONS(2420),
    [anon_sym_AMP] = ACTIONS(2418),
    [anon_sym_LBRACK] = ACTIONS(2418),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2420),
    [anon_sym_LBRACE] = ACTIONS(2418),
    [anon_sym_LT_AT] = ACTIONS(2418),
    [anon_sym_LT_AT_AT] = ACTIONS(2418),
    [anon_sym_DOT] = ACTIONS(3836),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2420),
    [anon_sym_new] = ACTIONS(2418),
    [anon_sym_with] = ACTIONS(2418),
    [anon_sym_return_BANG] = ACTIONS(2420),
    [anon_sym_yield] = ACTIONS(2418),
    [anon_sym_yield_BANG] = ACTIONS(2420),
    [anon_sym_lazy] = ACTIONS(2418),
    [anon_sym_assert] = ACTIONS(2418),
    [anon_sym_upcast] = ACTIONS(2418),
    [anon_sym_downcast] = ACTIONS(2418),
    [anon_sym_COLON_GT] = ACTIONS(2420),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2420),
    [anon_sym_for] = ACTIONS(2418),
    [anon_sym_while] = ACTIONS(2418),
    [anon_sym_if] = ACTIONS(2418),
    [anon_sym_fun] = ACTIONS(2418),
    [anon_sym_try] = ACTIONS(2418),
    [anon_sym_match] = ACTIONS(2418),
    [anon_sym_match_BANG] = ACTIONS(2420),
    [anon_sym_function] = ACTIONS(2418),
    [anon_sym_LT_DASH] = ACTIONS(2418),
    [anon_sym_DOT_LBRACK] = ACTIONS(2420),
    [anon_sym_LT] = ACTIONS(2420),
    [anon_sym_use] = ACTIONS(2418),
    [anon_sym_use_BANG] = ACTIONS(2420),
    [anon_sym_do_BANG] = ACTIONS(2420),
    [anon_sym_begin] = ACTIONS(2418),
    [anon_sym_LPAREN2] = ACTIONS(2418),
    [anon_sym_or] = ACTIONS(2418),
    [aux_sym_char_token1] = ACTIONS(2420),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2418),
    [anon_sym_DQUOTE] = ACTIONS(2418),
    [anon_sym_AT_DQUOTE] = ACTIONS(2420),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2420),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2420),
    [sym_bool] = ACTIONS(2418),
    [sym_unit] = ACTIONS(2420),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2418),
    [sym_op_identifier] = ACTIONS(2418),
    [anon_sym_PLUS] = ACTIONS(2418),
    [anon_sym_DASH] = ACTIONS(2418),
    [anon_sym_PLUS_DOT] = ACTIONS(2418),
    [anon_sym_DASH_DOT] = ACTIONS(2418),
    [anon_sym_PERCENT] = ACTIONS(2418),
    [anon_sym_AMP_AMP] = ACTIONS(2418),
    [anon_sym_TILDE] = ACTIONS(2420),
    [aux_sym_prefix_op_token1] = ACTIONS(2418),
    [aux_sym_infix_op_token1] = ACTIONS(2420),
    [aux_sym_infix_op_token2] = ACTIONS(2418),
    [anon_sym_PIPE_PIPE] = ACTIONS(2418),
    [anon_sym_BANG_EQ] = ACTIONS(2418),
    [anon_sym_COLON_EQ] = ACTIONS(2420),
    [anon_sym_DOLLAR] = ACTIONS(2418),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2418),
    [sym_int] = ACTIONS(2418),
    [sym_xint] = ACTIONS(2420),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2420),
    [sym__newline] = ACTIONS(2420),
  },
  [1607] = {
    [sym_block_comment] = STATE(1607),
    [sym_compiler_directive_decl] = STATE(1607),
    [sym_fsi_directive_decl] = STATE(1607),
    [sym_preproc_line] = STATE(1607),
    [aux_sym_long_identifier_repeat1] = STATE(1607),
    [sym_identifier] = ACTIONS(2411),
    [anon_sym_EQ] = ACTIONS(2413),
    [anon_sym_COLON] = ACTIONS(2411),
    [anon_sym_return] = ACTIONS(2411),
    [anon_sym_do] = ACTIONS(2411),
    [anon_sym_let] = ACTIONS(2411),
    [anon_sym_let_BANG] = ACTIONS(2413),
    [anon_sym_as] = ACTIONS(2411),
    [anon_sym_LPAREN] = ACTIONS(2411),
    [anon_sym_COMMA] = ACTIONS(2413),
    [anon_sym_null] = ACTIONS(2411),
    [anon_sym_QMARK] = ACTIONS(2411),
    [anon_sym_COLON_QMARK] = ACTIONS(2411),
    [anon_sym_COLON_COLON] = ACTIONS(2413),
    [anon_sym_AMP] = ACTIONS(2411),
    [anon_sym_LBRACK] = ACTIONS(2411),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2413),
    [anon_sym_LBRACE] = ACTIONS(2411),
    [anon_sym_LT_AT] = ACTIONS(2411),
    [anon_sym_LT_AT_AT] = ACTIONS(2411),
    [anon_sym_DOT] = ACTIONS(3838),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2413),
    [anon_sym_new] = ACTIONS(2411),
    [anon_sym_with] = ACTIONS(2411),
    [anon_sym_return_BANG] = ACTIONS(2413),
    [anon_sym_yield] = ACTIONS(2411),
    [anon_sym_yield_BANG] = ACTIONS(2413),
    [anon_sym_lazy] = ACTIONS(2411),
    [anon_sym_assert] = ACTIONS(2411),
    [anon_sym_upcast] = ACTIONS(2411),
    [anon_sym_downcast] = ACTIONS(2411),
    [anon_sym_COLON_GT] = ACTIONS(2413),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2413),
    [anon_sym_for] = ACTIONS(2411),
    [anon_sym_while] = ACTIONS(2411),
    [anon_sym_if] = ACTIONS(2411),
    [anon_sym_fun] = ACTIONS(2411),
    [anon_sym_try] = ACTIONS(2411),
    [anon_sym_match] = ACTIONS(2411),
    [anon_sym_match_BANG] = ACTIONS(2413),
    [anon_sym_function] = ACTIONS(2411),
    [anon_sym_LT_DASH] = ACTIONS(2411),
    [anon_sym_DOT_LBRACK] = ACTIONS(2413),
    [anon_sym_LT] = ACTIONS(2413),
    [anon_sym_use] = ACTIONS(2411),
    [anon_sym_use_BANG] = ACTIONS(2413),
    [anon_sym_do_BANG] = ACTIONS(2413),
    [anon_sym_begin] = ACTIONS(2411),
    [anon_sym_LPAREN2] = ACTIONS(2411),
    [anon_sym_or] = ACTIONS(2411),
    [aux_sym_char_token1] = ACTIONS(2413),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2411),
    [anon_sym_DQUOTE] = ACTIONS(2411),
    [anon_sym_AT_DQUOTE] = ACTIONS(2413),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2413),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2413),
    [sym_bool] = ACTIONS(2411),
    [sym_unit] = ACTIONS(2413),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2411),
    [sym_op_identifier] = ACTIONS(2411),
    [anon_sym_PLUS] = ACTIONS(2411),
    [anon_sym_DASH] = ACTIONS(2411),
    [anon_sym_PLUS_DOT] = ACTIONS(2411),
    [anon_sym_DASH_DOT] = ACTIONS(2411),
    [anon_sym_PERCENT] = ACTIONS(2411),
    [anon_sym_AMP_AMP] = ACTIONS(2411),
    [anon_sym_TILDE] = ACTIONS(2413),
    [aux_sym_prefix_op_token1] = ACTIONS(2411),
    [aux_sym_infix_op_token1] = ACTIONS(2413),
    [aux_sym_infix_op_token2] = ACTIONS(2411),
    [anon_sym_PIPE_PIPE] = ACTIONS(2411),
    [anon_sym_BANG_EQ] = ACTIONS(2411),
    [anon_sym_COLON_EQ] = ACTIONS(2413),
    [anon_sym_DOLLAR] = ACTIONS(2411),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2411),
    [sym_int] = ACTIONS(2411),
    [sym_xint] = ACTIONS(2413),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2413),
    [sym__newline] = ACTIONS(2413),
  },
  [1608] = {
    [sym_block_comment] = STATE(1608),
    [sym_compiler_directive_decl] = STATE(1608),
    [sym_fsi_directive_decl] = STATE(1608),
    [sym_preproc_line] = STATE(1608),
    [sym_identifier] = ACTIONS(3091),
    [anon_sym_EQ] = ACTIONS(3093),
    [anon_sym_COLON] = ACTIONS(3091),
    [anon_sym_return] = ACTIONS(3091),
    [anon_sym_do] = ACTIONS(3091),
    [anon_sym_let] = ACTIONS(3091),
    [anon_sym_let_BANG] = ACTIONS(3093),
    [anon_sym_as] = ACTIONS(3091),
    [anon_sym_LPAREN] = ACTIONS(3091),
    [anon_sym_COMMA] = ACTIONS(3093),
    [anon_sym_null] = ACTIONS(3091),
    [anon_sym_QMARK] = ACTIONS(3091),
    [anon_sym_COLON_QMARK] = ACTIONS(3091),
    [anon_sym_COLON_COLON] = ACTIONS(3093),
    [anon_sym_AMP] = ACTIONS(3091),
    [anon_sym_LBRACK] = ACTIONS(3091),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3093),
    [anon_sym_LBRACE] = ACTIONS(3091),
    [anon_sym_LT_AT] = ACTIONS(3091),
    [anon_sym_LT_AT_AT] = ACTIONS(3091),
    [anon_sym_DOT] = ACTIONS(3091),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3093),
    [anon_sym_new] = ACTIONS(3091),
    [anon_sym_with] = ACTIONS(3091),
    [anon_sym_return_BANG] = ACTIONS(3093),
    [anon_sym_yield] = ACTIONS(3091),
    [anon_sym_yield_BANG] = ACTIONS(3093),
    [anon_sym_lazy] = ACTIONS(3091),
    [anon_sym_assert] = ACTIONS(3091),
    [anon_sym_upcast] = ACTIONS(3091),
    [anon_sym_downcast] = ACTIONS(3091),
    [anon_sym_COLON_GT] = ACTIONS(3093),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3093),
    [anon_sym_for] = ACTIONS(3091),
    [anon_sym_while] = ACTIONS(3091),
    [anon_sym_if] = ACTIONS(3091),
    [anon_sym_fun] = ACTIONS(3091),
    [anon_sym_try] = ACTIONS(3091),
    [anon_sym_match] = ACTIONS(3091),
    [anon_sym_match_BANG] = ACTIONS(3093),
    [anon_sym_function] = ACTIONS(3091),
    [anon_sym_LT_DASH] = ACTIONS(3091),
    [anon_sym_DOT_LBRACK] = ACTIONS(3093),
    [anon_sym_LT] = ACTIONS(3093),
    [anon_sym_use] = ACTIONS(3091),
    [anon_sym_use_BANG] = ACTIONS(3093),
    [anon_sym_do_BANG] = ACTIONS(3093),
    [anon_sym_begin] = ACTIONS(3091),
    [anon_sym_LPAREN2] = ACTIONS(3091),
    [anon_sym_or] = ACTIONS(3091),
    [aux_sym_char_token1] = ACTIONS(3093),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3091),
    [anon_sym_DQUOTE] = ACTIONS(3091),
    [anon_sym_AT_DQUOTE] = ACTIONS(3093),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3093),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3093),
    [sym_bool] = ACTIONS(3091),
    [sym_unit] = ACTIONS(3093),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3091),
    [sym_op_identifier] = ACTIONS(3091),
    [anon_sym_PLUS] = ACTIONS(3091),
    [anon_sym_DASH] = ACTIONS(3091),
    [anon_sym_PLUS_DOT] = ACTIONS(3091),
    [anon_sym_DASH_DOT] = ACTIONS(3091),
    [anon_sym_PERCENT] = ACTIONS(3091),
    [anon_sym_AMP_AMP] = ACTIONS(3091),
    [anon_sym_TILDE] = ACTIONS(3093),
    [aux_sym_prefix_op_token1] = ACTIONS(3091),
    [aux_sym_infix_op_token1] = ACTIONS(3093),
    [aux_sym_infix_op_token2] = ACTIONS(3091),
    [anon_sym_PIPE_PIPE] = ACTIONS(3091),
    [anon_sym_BANG_EQ] = ACTIONS(3091),
    [anon_sym_COLON_EQ] = ACTIONS(3093),
    [anon_sym_DOLLAR] = ACTIONS(3091),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3091),
    [sym_int] = ACTIONS(3091),
    [sym_xint] = ACTIONS(3093),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3093),
    [sym__newline] = ACTIONS(3093),
    [sym__dedent] = ACTIONS(3093),
  },
  [1609] = {
    [sym_block_comment] = STATE(1609),
    [sym_compiler_directive_decl] = STATE(1609),
    [sym_fsi_directive_decl] = STATE(1609),
    [sym_preproc_line] = STATE(1609),
    [sym_identifier] = ACTIONS(3087),
    [anon_sym_EQ] = ACTIONS(3089),
    [anon_sym_COLON] = ACTIONS(3087),
    [anon_sym_return] = ACTIONS(3087),
    [anon_sym_do] = ACTIONS(3087),
    [anon_sym_let] = ACTIONS(3087),
    [anon_sym_let_BANG] = ACTIONS(3089),
    [anon_sym_as] = ACTIONS(3087),
    [anon_sym_LPAREN] = ACTIONS(3087),
    [anon_sym_COMMA] = ACTIONS(3089),
    [anon_sym_null] = ACTIONS(3087),
    [anon_sym_QMARK] = ACTIONS(3087),
    [anon_sym_COLON_QMARK] = ACTIONS(3087),
    [anon_sym_COLON_COLON] = ACTIONS(3089),
    [anon_sym_AMP] = ACTIONS(3087),
    [anon_sym_LBRACK] = ACTIONS(3087),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3089),
    [anon_sym_LBRACE] = ACTIONS(3087),
    [anon_sym_LT_AT] = ACTIONS(3087),
    [anon_sym_LT_AT_AT] = ACTIONS(3087),
    [anon_sym_DOT] = ACTIONS(3087),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3089),
    [anon_sym_new] = ACTIONS(3087),
    [anon_sym_with] = ACTIONS(3087),
    [anon_sym_return_BANG] = ACTIONS(3089),
    [anon_sym_yield] = ACTIONS(3087),
    [anon_sym_yield_BANG] = ACTIONS(3089),
    [anon_sym_lazy] = ACTIONS(3087),
    [anon_sym_assert] = ACTIONS(3087),
    [anon_sym_upcast] = ACTIONS(3087),
    [anon_sym_downcast] = ACTIONS(3087),
    [anon_sym_COLON_GT] = ACTIONS(3089),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3089),
    [anon_sym_for] = ACTIONS(3087),
    [anon_sym_while] = ACTIONS(3087),
    [anon_sym_if] = ACTIONS(3087),
    [anon_sym_fun] = ACTIONS(3087),
    [anon_sym_try] = ACTIONS(3087),
    [anon_sym_match] = ACTIONS(3087),
    [anon_sym_match_BANG] = ACTIONS(3089),
    [anon_sym_function] = ACTIONS(3087),
    [anon_sym_LT_DASH] = ACTIONS(3087),
    [anon_sym_DOT_LBRACK] = ACTIONS(3089),
    [anon_sym_LT] = ACTIONS(3089),
    [anon_sym_use] = ACTIONS(3087),
    [anon_sym_use_BANG] = ACTIONS(3089),
    [anon_sym_do_BANG] = ACTIONS(3089),
    [anon_sym_begin] = ACTIONS(3087),
    [anon_sym_LPAREN2] = ACTIONS(3087),
    [anon_sym_or] = ACTIONS(3087),
    [aux_sym_char_token1] = ACTIONS(3089),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3087),
    [anon_sym_DQUOTE] = ACTIONS(3087),
    [anon_sym_AT_DQUOTE] = ACTIONS(3089),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3089),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3089),
    [sym_bool] = ACTIONS(3087),
    [sym_unit] = ACTIONS(3089),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3087),
    [sym_op_identifier] = ACTIONS(3087),
    [anon_sym_PLUS] = ACTIONS(3087),
    [anon_sym_DASH] = ACTIONS(3087),
    [anon_sym_PLUS_DOT] = ACTIONS(3087),
    [anon_sym_DASH_DOT] = ACTIONS(3087),
    [anon_sym_PERCENT] = ACTIONS(3087),
    [anon_sym_AMP_AMP] = ACTIONS(3087),
    [anon_sym_TILDE] = ACTIONS(3089),
    [aux_sym_prefix_op_token1] = ACTIONS(3087),
    [aux_sym_infix_op_token1] = ACTIONS(3089),
    [aux_sym_infix_op_token2] = ACTIONS(3087),
    [anon_sym_PIPE_PIPE] = ACTIONS(3087),
    [anon_sym_BANG_EQ] = ACTIONS(3087),
    [anon_sym_COLON_EQ] = ACTIONS(3089),
    [anon_sym_DOLLAR] = ACTIONS(3087),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3087),
    [sym_int] = ACTIONS(3087),
    [sym_xint] = ACTIONS(3089),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3089),
    [sym__newline] = ACTIONS(3089),
    [sym__dedent] = ACTIONS(3089),
  },
  [1610] = {
    [sym_block_comment] = STATE(1610),
    [sym_compiler_directive_decl] = STATE(1610),
    [sym_fsi_directive_decl] = STATE(1610),
    [sym_preproc_line] = STATE(1610),
    [sym_identifier] = ACTIONS(3075),
    [anon_sym_EQ] = ACTIONS(3077),
    [anon_sym_COLON] = ACTIONS(3075),
    [anon_sym_return] = ACTIONS(3075),
    [anon_sym_do] = ACTIONS(3075),
    [anon_sym_let] = ACTIONS(3075),
    [anon_sym_let_BANG] = ACTIONS(3077),
    [anon_sym_as] = ACTIONS(3075),
    [anon_sym_LPAREN] = ACTIONS(3075),
    [anon_sym_COMMA] = ACTIONS(3077),
    [anon_sym_null] = ACTIONS(3075),
    [anon_sym_QMARK] = ACTIONS(3075),
    [anon_sym_COLON_QMARK] = ACTIONS(3075),
    [anon_sym_COLON_COLON] = ACTIONS(3077),
    [anon_sym_AMP] = ACTIONS(3075),
    [anon_sym_LBRACK] = ACTIONS(3075),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3077),
    [anon_sym_LBRACE] = ACTIONS(3075),
    [anon_sym_LT_AT] = ACTIONS(3075),
    [anon_sym_LT_AT_AT] = ACTIONS(3075),
    [anon_sym_DOT] = ACTIONS(3075),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3077),
    [anon_sym_new] = ACTIONS(3075),
    [anon_sym_with] = ACTIONS(3075),
    [anon_sym_return_BANG] = ACTIONS(3077),
    [anon_sym_yield] = ACTIONS(3075),
    [anon_sym_yield_BANG] = ACTIONS(3077),
    [anon_sym_lazy] = ACTIONS(3075),
    [anon_sym_assert] = ACTIONS(3075),
    [anon_sym_upcast] = ACTIONS(3075),
    [anon_sym_downcast] = ACTIONS(3075),
    [anon_sym_COLON_GT] = ACTIONS(3077),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3077),
    [anon_sym_for] = ACTIONS(3075),
    [anon_sym_while] = ACTIONS(3075),
    [anon_sym_if] = ACTIONS(3075),
    [anon_sym_fun] = ACTIONS(3075),
    [anon_sym_try] = ACTIONS(3075),
    [anon_sym_match] = ACTIONS(3075),
    [anon_sym_match_BANG] = ACTIONS(3077),
    [anon_sym_function] = ACTIONS(3075),
    [anon_sym_LT_DASH] = ACTIONS(3075),
    [anon_sym_DOT_LBRACK] = ACTIONS(3077),
    [anon_sym_LT] = ACTIONS(3077),
    [anon_sym_use] = ACTIONS(3075),
    [anon_sym_use_BANG] = ACTIONS(3077),
    [anon_sym_do_BANG] = ACTIONS(3077),
    [anon_sym_begin] = ACTIONS(3075),
    [anon_sym_LPAREN2] = ACTIONS(3075),
    [anon_sym_or] = ACTIONS(3075),
    [aux_sym_char_token1] = ACTIONS(3077),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3075),
    [anon_sym_DQUOTE] = ACTIONS(3075),
    [anon_sym_AT_DQUOTE] = ACTIONS(3077),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3077),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3077),
    [sym_bool] = ACTIONS(3075),
    [sym_unit] = ACTIONS(3077),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3075),
    [sym_op_identifier] = ACTIONS(3075),
    [anon_sym_PLUS] = ACTIONS(3075),
    [anon_sym_DASH] = ACTIONS(3075),
    [anon_sym_PLUS_DOT] = ACTIONS(3075),
    [anon_sym_DASH_DOT] = ACTIONS(3075),
    [anon_sym_PERCENT] = ACTIONS(3075),
    [anon_sym_AMP_AMP] = ACTIONS(3075),
    [anon_sym_TILDE] = ACTIONS(3077),
    [aux_sym_prefix_op_token1] = ACTIONS(3075),
    [aux_sym_infix_op_token1] = ACTIONS(3077),
    [aux_sym_infix_op_token2] = ACTIONS(3075),
    [anon_sym_PIPE_PIPE] = ACTIONS(3075),
    [anon_sym_BANG_EQ] = ACTIONS(3075),
    [anon_sym_COLON_EQ] = ACTIONS(3077),
    [anon_sym_DOLLAR] = ACTIONS(3075),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3075),
    [sym_int] = ACTIONS(3075),
    [sym_xint] = ACTIONS(3077),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3077),
    [sym__newline] = ACTIONS(3077),
    [sym__dedent] = ACTIONS(3077),
  },
  [1611] = {
    [sym_block_comment] = STATE(1611),
    [sym_compiler_directive_decl] = STATE(1611),
    [sym_fsi_directive_decl] = STATE(1611),
    [sym_preproc_line] = STATE(1611),
    [sym_identifier] = ACTIONS(3071),
    [anon_sym_EQ] = ACTIONS(3073),
    [anon_sym_COLON] = ACTIONS(3071),
    [anon_sym_return] = ACTIONS(3071),
    [anon_sym_do] = ACTIONS(3071),
    [anon_sym_let] = ACTIONS(3071),
    [anon_sym_let_BANG] = ACTIONS(3073),
    [anon_sym_as] = ACTIONS(3071),
    [anon_sym_LPAREN] = ACTIONS(3071),
    [anon_sym_COMMA] = ACTIONS(3073),
    [anon_sym_null] = ACTIONS(3071),
    [anon_sym_QMARK] = ACTIONS(3071),
    [anon_sym_COLON_QMARK] = ACTIONS(3071),
    [anon_sym_COLON_COLON] = ACTIONS(3073),
    [anon_sym_AMP] = ACTIONS(3071),
    [anon_sym_LBRACK] = ACTIONS(3071),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3073),
    [anon_sym_LBRACE] = ACTIONS(3071),
    [anon_sym_LT_AT] = ACTIONS(3071),
    [anon_sym_LT_AT_AT] = ACTIONS(3071),
    [anon_sym_DOT] = ACTIONS(3071),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3073),
    [anon_sym_new] = ACTIONS(3071),
    [anon_sym_with] = ACTIONS(3071),
    [anon_sym_return_BANG] = ACTIONS(3073),
    [anon_sym_yield] = ACTIONS(3071),
    [anon_sym_yield_BANG] = ACTIONS(3073),
    [anon_sym_lazy] = ACTIONS(3071),
    [anon_sym_assert] = ACTIONS(3071),
    [anon_sym_upcast] = ACTIONS(3071),
    [anon_sym_downcast] = ACTIONS(3071),
    [anon_sym_COLON_GT] = ACTIONS(3073),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3073),
    [anon_sym_for] = ACTIONS(3071),
    [anon_sym_while] = ACTIONS(3071),
    [anon_sym_if] = ACTIONS(3071),
    [anon_sym_fun] = ACTIONS(3071),
    [anon_sym_try] = ACTIONS(3071),
    [anon_sym_match] = ACTIONS(3071),
    [anon_sym_match_BANG] = ACTIONS(3073),
    [anon_sym_function] = ACTIONS(3071),
    [anon_sym_LT_DASH] = ACTIONS(3071),
    [anon_sym_DOT_LBRACK] = ACTIONS(3073),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_use] = ACTIONS(3071),
    [anon_sym_use_BANG] = ACTIONS(3073),
    [anon_sym_do_BANG] = ACTIONS(3073),
    [anon_sym_begin] = ACTIONS(3071),
    [anon_sym_LPAREN2] = ACTIONS(3071),
    [anon_sym_or] = ACTIONS(3071),
    [aux_sym_char_token1] = ACTIONS(3073),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3071),
    [anon_sym_DQUOTE] = ACTIONS(3071),
    [anon_sym_AT_DQUOTE] = ACTIONS(3073),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3073),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3073),
    [sym_bool] = ACTIONS(3071),
    [sym_unit] = ACTIONS(3073),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3071),
    [sym_op_identifier] = ACTIONS(3071),
    [anon_sym_PLUS] = ACTIONS(3071),
    [anon_sym_DASH] = ACTIONS(3071),
    [anon_sym_PLUS_DOT] = ACTIONS(3071),
    [anon_sym_DASH_DOT] = ACTIONS(3071),
    [anon_sym_PERCENT] = ACTIONS(3071),
    [anon_sym_AMP_AMP] = ACTIONS(3071),
    [anon_sym_TILDE] = ACTIONS(3073),
    [aux_sym_prefix_op_token1] = ACTIONS(3071),
    [aux_sym_infix_op_token1] = ACTIONS(3073),
    [aux_sym_infix_op_token2] = ACTIONS(3071),
    [anon_sym_PIPE_PIPE] = ACTIONS(3071),
    [anon_sym_BANG_EQ] = ACTIONS(3071),
    [anon_sym_COLON_EQ] = ACTIONS(3073),
    [anon_sym_DOLLAR] = ACTIONS(3071),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3071),
    [sym_int] = ACTIONS(3071),
    [sym_xint] = ACTIONS(3073),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3073),
    [sym__newline] = ACTIONS(3073),
    [sym__dedent] = ACTIONS(3073),
  },
  [1612] = {
    [sym_block_comment] = STATE(1612),
    [sym_compiler_directive_decl] = STATE(1612),
    [sym_fsi_directive_decl] = STATE(1612),
    [sym_preproc_line] = STATE(1612),
    [sym_identifier] = ACTIONS(3067),
    [anon_sym_EQ] = ACTIONS(3069),
    [anon_sym_COLON] = ACTIONS(3067),
    [anon_sym_return] = ACTIONS(3067),
    [anon_sym_do] = ACTIONS(3067),
    [anon_sym_let] = ACTIONS(3067),
    [anon_sym_let_BANG] = ACTIONS(3069),
    [anon_sym_as] = ACTIONS(3067),
    [anon_sym_LPAREN] = ACTIONS(3067),
    [anon_sym_COMMA] = ACTIONS(3069),
    [anon_sym_null] = ACTIONS(3067),
    [anon_sym_QMARK] = ACTIONS(3067),
    [anon_sym_COLON_QMARK] = ACTIONS(3067),
    [anon_sym_COLON_COLON] = ACTIONS(3069),
    [anon_sym_AMP] = ACTIONS(3067),
    [anon_sym_LBRACK] = ACTIONS(3067),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3069),
    [anon_sym_LBRACE] = ACTIONS(3067),
    [anon_sym_LT_AT] = ACTIONS(3067),
    [anon_sym_LT_AT_AT] = ACTIONS(3067),
    [anon_sym_DOT] = ACTIONS(3067),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3069),
    [anon_sym_new] = ACTIONS(3067),
    [anon_sym_with] = ACTIONS(3067),
    [anon_sym_return_BANG] = ACTIONS(3069),
    [anon_sym_yield] = ACTIONS(3067),
    [anon_sym_yield_BANG] = ACTIONS(3069),
    [anon_sym_lazy] = ACTIONS(3067),
    [anon_sym_assert] = ACTIONS(3067),
    [anon_sym_upcast] = ACTIONS(3067),
    [anon_sym_downcast] = ACTIONS(3067),
    [anon_sym_COLON_GT] = ACTIONS(3069),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3069),
    [anon_sym_for] = ACTIONS(3067),
    [anon_sym_while] = ACTIONS(3067),
    [anon_sym_if] = ACTIONS(3067),
    [anon_sym_fun] = ACTIONS(3067),
    [anon_sym_try] = ACTIONS(3067),
    [anon_sym_match] = ACTIONS(3067),
    [anon_sym_match_BANG] = ACTIONS(3069),
    [anon_sym_function] = ACTIONS(3067),
    [anon_sym_LT_DASH] = ACTIONS(3067),
    [anon_sym_DOT_LBRACK] = ACTIONS(3069),
    [anon_sym_LT] = ACTIONS(3069),
    [anon_sym_use] = ACTIONS(3067),
    [anon_sym_use_BANG] = ACTIONS(3069),
    [anon_sym_do_BANG] = ACTIONS(3069),
    [anon_sym_begin] = ACTIONS(3067),
    [anon_sym_LPAREN2] = ACTIONS(3067),
    [anon_sym_or] = ACTIONS(3067),
    [aux_sym_char_token1] = ACTIONS(3069),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3067),
    [anon_sym_DQUOTE] = ACTIONS(3067),
    [anon_sym_AT_DQUOTE] = ACTIONS(3069),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3069),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3069),
    [sym_bool] = ACTIONS(3067),
    [sym_unit] = ACTIONS(3069),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3067),
    [sym_op_identifier] = ACTIONS(3067),
    [anon_sym_PLUS] = ACTIONS(3067),
    [anon_sym_DASH] = ACTIONS(3067),
    [anon_sym_PLUS_DOT] = ACTIONS(3067),
    [anon_sym_DASH_DOT] = ACTIONS(3067),
    [anon_sym_PERCENT] = ACTIONS(3067),
    [anon_sym_AMP_AMP] = ACTIONS(3067),
    [anon_sym_TILDE] = ACTIONS(3069),
    [aux_sym_prefix_op_token1] = ACTIONS(3067),
    [aux_sym_infix_op_token1] = ACTIONS(3069),
    [aux_sym_infix_op_token2] = ACTIONS(3067),
    [anon_sym_PIPE_PIPE] = ACTIONS(3067),
    [anon_sym_BANG_EQ] = ACTIONS(3067),
    [anon_sym_COLON_EQ] = ACTIONS(3069),
    [anon_sym_DOLLAR] = ACTIONS(3067),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3067),
    [sym_int] = ACTIONS(3067),
    [sym_xint] = ACTIONS(3069),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3069),
    [sym__newline] = ACTIONS(3069),
    [sym__dedent] = ACTIONS(3069),
  },
  [1613] = {
    [sym_block_comment] = STATE(1613),
    [sym_compiler_directive_decl] = STATE(1613),
    [sym_fsi_directive_decl] = STATE(1613),
    [sym_preproc_line] = STATE(1613),
    [sym_identifier] = ACTIONS(2748),
    [anon_sym_EQ] = ACTIONS(2750),
    [anon_sym_COLON] = ACTIONS(2748),
    [anon_sym_return] = ACTIONS(2748),
    [anon_sym_do] = ACTIONS(2748),
    [anon_sym_let] = ACTIONS(2748),
    [anon_sym_let_BANG] = ACTIONS(2750),
    [anon_sym_LPAREN] = ACTIONS(2748),
    [anon_sym_COMMA] = ACTIONS(2750),
    [anon_sym_null] = ACTIONS(2748),
    [anon_sym_QMARK] = ACTIONS(2748),
    [anon_sym_COLON_QMARK] = ACTIONS(2748),
    [anon_sym_COLON_COLON] = ACTIONS(2750),
    [anon_sym_AMP] = ACTIONS(2748),
    [anon_sym_LBRACK] = ACTIONS(2748),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2750),
    [anon_sym_LBRACE] = ACTIONS(2748),
    [anon_sym_LT_AT] = ACTIONS(2748),
    [anon_sym_AT_GT] = ACTIONS(2748),
    [anon_sym_LT_AT_AT] = ACTIONS(2748),
    [anon_sym_DOT] = ACTIONS(2748),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2750),
    [anon_sym_new] = ACTIONS(2748),
    [anon_sym_return_BANG] = ACTIONS(2750),
    [anon_sym_yield] = ACTIONS(2748),
    [anon_sym_yield_BANG] = ACTIONS(2750),
    [anon_sym_lazy] = ACTIONS(2748),
    [anon_sym_assert] = ACTIONS(2748),
    [anon_sym_upcast] = ACTIONS(2748),
    [anon_sym_downcast] = ACTIONS(2748),
    [anon_sym_COLON_GT] = ACTIONS(2750),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2750),
    [anon_sym_for] = ACTIONS(2748),
    [anon_sym_while] = ACTIONS(2748),
    [anon_sym_else] = ACTIONS(2748),
    [anon_sym_elif] = ACTIONS(2748),
    [anon_sym_if] = ACTIONS(2748),
    [anon_sym_fun] = ACTIONS(2748),
    [anon_sym_try] = ACTIONS(2748),
    [anon_sym_match] = ACTIONS(2748),
    [anon_sym_match_BANG] = ACTIONS(2750),
    [anon_sym_function] = ACTIONS(2748),
    [anon_sym_LT_DASH] = ACTIONS(2748),
    [anon_sym_DOT_LBRACK] = ACTIONS(2750),
    [anon_sym_LT] = ACTIONS(2750),
    [anon_sym_use] = ACTIONS(2748),
    [anon_sym_use_BANG] = ACTIONS(2750),
    [anon_sym_do_BANG] = ACTIONS(2750),
    [anon_sym_begin] = ACTIONS(2748),
    [anon_sym_LPAREN2] = ACTIONS(2748),
    [anon_sym_or] = ACTIONS(2748),
    [aux_sym_char_token1] = ACTIONS(2750),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2748),
    [anon_sym_DQUOTE] = ACTIONS(2748),
    [anon_sym_AT_DQUOTE] = ACTIONS(2750),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2750),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2750),
    [sym_bool] = ACTIONS(2748),
    [sym_unit] = ACTIONS(2750),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2748),
    [sym_op_identifier] = ACTIONS(2748),
    [anon_sym_PLUS] = ACTIONS(2748),
    [anon_sym_DASH] = ACTIONS(2748),
    [anon_sym_PLUS_DOT] = ACTIONS(2748),
    [anon_sym_DASH_DOT] = ACTIONS(2748),
    [anon_sym_PERCENT] = ACTIONS(2748),
    [anon_sym_AMP_AMP] = ACTIONS(2748),
    [anon_sym_TILDE] = ACTIONS(2750),
    [aux_sym_prefix_op_token1] = ACTIONS(2748),
    [aux_sym_infix_op_token1] = ACTIONS(2750),
    [aux_sym_infix_op_token2] = ACTIONS(2748),
    [anon_sym_PIPE_PIPE] = ACTIONS(2748),
    [anon_sym_BANG_EQ] = ACTIONS(2748),
    [anon_sym_COLON_EQ] = ACTIONS(2750),
    [anon_sym_DOLLAR] = ACTIONS(2748),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2748),
    [sym_int] = ACTIONS(2748),
    [sym_xint] = ACTIONS(2750),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2750),
    [sym__newline] = ACTIONS(2750),
  },
  [1614] = {
    [sym_block_comment] = STATE(1614),
    [sym_compiler_directive_decl] = STATE(1614),
    [sym_fsi_directive_decl] = STATE(1614),
    [sym_preproc_line] = STATE(1614),
    [sym_identifier] = ACTIONS(2158),
    [anon_sym_EQ] = ACTIONS(2160),
    [anon_sym_COLON] = ACTIONS(2158),
    [anon_sym_return] = ACTIONS(2158),
    [anon_sym_do] = ACTIONS(2158),
    [anon_sym_let] = ACTIONS(2158),
    [anon_sym_let_BANG] = ACTIONS(2160),
    [anon_sym_LPAREN] = ACTIONS(2158),
    [anon_sym_COMMA] = ACTIONS(2160),
    [anon_sym_null] = ACTIONS(2158),
    [anon_sym_QMARK] = ACTIONS(2158),
    [anon_sym_COLON_QMARK] = ACTIONS(2158),
    [anon_sym_COLON_COLON] = ACTIONS(2160),
    [anon_sym_AMP] = ACTIONS(2158),
    [anon_sym_LBRACK] = ACTIONS(2158),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2160),
    [anon_sym_LBRACE] = ACTIONS(2158),
    [anon_sym_LT_AT] = ACTIONS(2158),
    [anon_sym_LT_AT_AT] = ACTIONS(2158),
    [anon_sym_AT_AT_GT] = ACTIONS(2158),
    [anon_sym_DOT] = ACTIONS(2158),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2160),
    [anon_sym_new] = ACTIONS(2158),
    [anon_sym_return_BANG] = ACTIONS(2160),
    [anon_sym_yield] = ACTIONS(2158),
    [anon_sym_yield_BANG] = ACTIONS(2160),
    [anon_sym_lazy] = ACTIONS(2158),
    [anon_sym_assert] = ACTIONS(2158),
    [anon_sym_upcast] = ACTIONS(2158),
    [anon_sym_downcast] = ACTIONS(2158),
    [anon_sym_COLON_GT] = ACTIONS(2160),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2160),
    [anon_sym_for] = ACTIONS(2158),
    [anon_sym_while] = ACTIONS(2158),
    [anon_sym_if] = ACTIONS(2158),
    [anon_sym_fun] = ACTIONS(2158),
    [anon_sym_try] = ACTIONS(2158),
    [anon_sym_match] = ACTIONS(2158),
    [anon_sym_match_BANG] = ACTIONS(2160),
    [anon_sym_function] = ACTIONS(2158),
    [anon_sym_LT_DASH] = ACTIONS(2158),
    [anon_sym_DOT_LBRACK] = ACTIONS(2160),
    [anon_sym_LT] = ACTIONS(2160),
    [anon_sym_use] = ACTIONS(2158),
    [anon_sym_use_BANG] = ACTIONS(2160),
    [anon_sym_do_BANG] = ACTIONS(2160),
    [anon_sym_begin] = ACTIONS(2158),
    [anon_sym_LPAREN2] = ACTIONS(2158),
    [anon_sym_or] = ACTIONS(2158),
    [aux_sym_char_token1] = ACTIONS(2160),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2158),
    [anon_sym_DQUOTE] = ACTIONS(2158),
    [anon_sym_AT_DQUOTE] = ACTIONS(2160),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2160),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2160),
    [sym_bool] = ACTIONS(2158),
    [sym_unit] = ACTIONS(2160),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2158),
    [sym_op_identifier] = ACTIONS(2158),
    [anon_sym_PLUS] = ACTIONS(2158),
    [anon_sym_DASH] = ACTIONS(2158),
    [anon_sym_PLUS_DOT] = ACTIONS(2158),
    [anon_sym_DASH_DOT] = ACTIONS(2158),
    [anon_sym_PERCENT] = ACTIONS(2158),
    [anon_sym_AMP_AMP] = ACTIONS(2158),
    [anon_sym_TILDE] = ACTIONS(2160),
    [aux_sym_prefix_op_token1] = ACTIONS(2158),
    [aux_sym_infix_op_token1] = ACTIONS(2160),
    [aux_sym_infix_op_token2] = ACTIONS(2158),
    [anon_sym_PIPE_PIPE] = ACTIONS(2158),
    [anon_sym_BANG_EQ] = ACTIONS(2158),
    [anon_sym_COLON_EQ] = ACTIONS(2160),
    [anon_sym_DOLLAR] = ACTIONS(2158),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2158),
    [sym_int] = ACTIONS(2158),
    [sym_xint] = ACTIONS(2160),
    [anon_sym_f] = ACTIONS(2744),
    [aux_sym_decimal_token1] = ACTIONS(2547),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2160),
    [sym__newline] = ACTIONS(2160),
  },
  [1615] = {
    [sym_block_comment] = STATE(1615),
    [sym_compiler_directive_decl] = STATE(1615),
    [sym_fsi_directive_decl] = STATE(1615),
    [sym_preproc_line] = STATE(1615),
    [sym_identifier] = ACTIONS(2831),
    [anon_sym_EQ] = ACTIONS(2833),
    [anon_sym_COLON] = ACTIONS(2831),
    [anon_sym_return] = ACTIONS(2831),
    [anon_sym_do] = ACTIONS(2831),
    [anon_sym_let] = ACTIONS(2831),
    [anon_sym_let_BANG] = ACTIONS(2833),
    [anon_sym_as] = ACTIONS(2831),
    [anon_sym_LPAREN] = ACTIONS(2831),
    [anon_sym_COMMA] = ACTIONS(2833),
    [anon_sym_null] = ACTIONS(2831),
    [anon_sym_QMARK] = ACTIONS(2831),
    [anon_sym_COLON_QMARK] = ACTIONS(2831),
    [anon_sym_COLON_COLON] = ACTIONS(2833),
    [anon_sym_AMP] = ACTIONS(2831),
    [anon_sym_LBRACK] = ACTIONS(2831),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2833),
    [anon_sym_LBRACE] = ACTIONS(2831),
    [anon_sym_LT_AT] = ACTIONS(2831),
    [anon_sym_LT_AT_AT] = ACTIONS(2831),
    [anon_sym_DOT] = ACTIONS(2831),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2833),
    [anon_sym_new] = ACTIONS(2831),
    [anon_sym_with] = ACTIONS(2831),
    [anon_sym_return_BANG] = ACTIONS(2833),
    [anon_sym_yield] = ACTIONS(2831),
    [anon_sym_yield_BANG] = ACTIONS(2833),
    [anon_sym_lazy] = ACTIONS(2831),
    [anon_sym_assert] = ACTIONS(2831),
    [anon_sym_upcast] = ACTIONS(2831),
    [anon_sym_downcast] = ACTIONS(2831),
    [anon_sym_COLON_GT] = ACTIONS(2833),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2833),
    [anon_sym_for] = ACTIONS(2831),
    [anon_sym_while] = ACTIONS(2831),
    [anon_sym_if] = ACTIONS(2831),
    [anon_sym_fun] = ACTIONS(2831),
    [anon_sym_try] = ACTIONS(2831),
    [anon_sym_match] = ACTIONS(2831),
    [anon_sym_match_BANG] = ACTIONS(2833),
    [anon_sym_function] = ACTIONS(2831),
    [anon_sym_LT_DASH] = ACTIONS(2831),
    [anon_sym_DOT_LBRACK] = ACTIONS(2833),
    [anon_sym_LT] = ACTIONS(2833),
    [anon_sym_use] = ACTIONS(2831),
    [anon_sym_use_BANG] = ACTIONS(2833),
    [anon_sym_do_BANG] = ACTIONS(2833),
    [anon_sym_begin] = ACTIONS(2831),
    [anon_sym_LPAREN2] = ACTIONS(2831),
    [anon_sym_or] = ACTIONS(2831),
    [aux_sym_char_token1] = ACTIONS(2833),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2831),
    [anon_sym_DQUOTE] = ACTIONS(2831),
    [anon_sym_AT_DQUOTE] = ACTIONS(2833),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2833),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2833),
    [sym_bool] = ACTIONS(2831),
    [sym_unit] = ACTIONS(2833),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2831),
    [sym_op_identifier] = ACTIONS(2831),
    [anon_sym_PLUS] = ACTIONS(2831),
    [anon_sym_DASH] = ACTIONS(2831),
    [anon_sym_PLUS_DOT] = ACTIONS(2831),
    [anon_sym_DASH_DOT] = ACTIONS(2831),
    [anon_sym_PERCENT] = ACTIONS(2831),
    [anon_sym_AMP_AMP] = ACTIONS(2831),
    [anon_sym_TILDE] = ACTIONS(2833),
    [aux_sym_prefix_op_token1] = ACTIONS(2831),
    [aux_sym_infix_op_token1] = ACTIONS(2833),
    [aux_sym_infix_op_token2] = ACTIONS(2831),
    [anon_sym_PIPE_PIPE] = ACTIONS(2831),
    [anon_sym_BANG_EQ] = ACTIONS(2831),
    [anon_sym_COLON_EQ] = ACTIONS(2833),
    [anon_sym_DOLLAR] = ACTIONS(2831),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2831),
    [sym_int] = ACTIONS(2831),
    [sym_xint] = ACTIONS(2833),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2833),
    [sym__newline] = ACTIONS(2833),
    [sym__dedent] = ACTIONS(2833),
  },
  [1616] = {
    [sym_block_comment] = STATE(1616),
    [sym_compiler_directive_decl] = STATE(1616),
    [sym_fsi_directive_decl] = STATE(1616),
    [sym_preproc_line] = STATE(1616),
    [sym_identifier] = ACTIONS(2950),
    [anon_sym_EQ] = ACTIONS(2952),
    [anon_sym_COLON] = ACTIONS(2950),
    [anon_sym_return] = ACTIONS(2950),
    [anon_sym_do] = ACTIONS(2950),
    [anon_sym_let] = ACTIONS(2950),
    [anon_sym_let_BANG] = ACTIONS(2952),
    [anon_sym_as] = ACTIONS(2950),
    [anon_sym_LPAREN] = ACTIONS(2950),
    [anon_sym_COMMA] = ACTIONS(2952),
    [anon_sym_null] = ACTIONS(2950),
    [anon_sym_QMARK] = ACTIONS(2950),
    [anon_sym_COLON_QMARK] = ACTIONS(2950),
    [anon_sym_COLON_COLON] = ACTIONS(2952),
    [anon_sym_AMP] = ACTIONS(2950),
    [anon_sym_LBRACK] = ACTIONS(2950),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2952),
    [anon_sym_LBRACE] = ACTIONS(2950),
    [anon_sym_LT_AT] = ACTIONS(2950),
    [anon_sym_LT_AT_AT] = ACTIONS(2950),
    [anon_sym_DOT] = ACTIONS(2950),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2952),
    [anon_sym_new] = ACTIONS(2950),
    [anon_sym_with] = ACTIONS(2950),
    [anon_sym_return_BANG] = ACTIONS(2952),
    [anon_sym_yield] = ACTIONS(2950),
    [anon_sym_yield_BANG] = ACTIONS(2952),
    [anon_sym_lazy] = ACTIONS(2950),
    [anon_sym_assert] = ACTIONS(2950),
    [anon_sym_upcast] = ACTIONS(2950),
    [anon_sym_downcast] = ACTIONS(2950),
    [anon_sym_COLON_GT] = ACTIONS(2952),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2952),
    [anon_sym_for] = ACTIONS(2950),
    [anon_sym_while] = ACTIONS(2950),
    [anon_sym_if] = ACTIONS(2950),
    [anon_sym_fun] = ACTIONS(2950),
    [anon_sym_try] = ACTIONS(2950),
    [anon_sym_match] = ACTIONS(2950),
    [anon_sym_match_BANG] = ACTIONS(2952),
    [anon_sym_function] = ACTIONS(2950),
    [anon_sym_LT_DASH] = ACTIONS(2950),
    [anon_sym_DOT_LBRACK] = ACTIONS(2952),
    [anon_sym_LT] = ACTIONS(2952),
    [anon_sym_use] = ACTIONS(2950),
    [anon_sym_use_BANG] = ACTIONS(2952),
    [anon_sym_do_BANG] = ACTIONS(2952),
    [anon_sym_begin] = ACTIONS(2950),
    [anon_sym_LPAREN2] = ACTIONS(2950),
    [anon_sym_or] = ACTIONS(2950),
    [aux_sym_char_token1] = ACTIONS(2952),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2950),
    [anon_sym_DQUOTE] = ACTIONS(2950),
    [anon_sym_AT_DQUOTE] = ACTIONS(2952),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2952),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2952),
    [sym_bool] = ACTIONS(2950),
    [sym_unit] = ACTIONS(2952),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2950),
    [sym_op_identifier] = ACTIONS(2950),
    [anon_sym_PLUS] = ACTIONS(2950),
    [anon_sym_DASH] = ACTIONS(2950),
    [anon_sym_PLUS_DOT] = ACTIONS(2950),
    [anon_sym_DASH_DOT] = ACTIONS(2950),
    [anon_sym_PERCENT] = ACTIONS(2950),
    [anon_sym_AMP_AMP] = ACTIONS(2950),
    [anon_sym_TILDE] = ACTIONS(2952),
    [aux_sym_prefix_op_token1] = ACTIONS(2950),
    [aux_sym_infix_op_token1] = ACTIONS(2952),
    [aux_sym_infix_op_token2] = ACTIONS(2950),
    [anon_sym_PIPE_PIPE] = ACTIONS(2950),
    [anon_sym_BANG_EQ] = ACTIONS(2950),
    [anon_sym_COLON_EQ] = ACTIONS(2952),
    [anon_sym_DOLLAR] = ACTIONS(2950),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2950),
    [sym_int] = ACTIONS(2950),
    [sym_xint] = ACTIONS(2952),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2952),
    [sym__newline] = ACTIONS(2952),
    [sym__dedent] = ACTIONS(2952),
  },
  [1617] = {
    [sym_block_comment] = STATE(1617),
    [sym_compiler_directive_decl] = STATE(1617),
    [sym_fsi_directive_decl] = STATE(1617),
    [sym_preproc_line] = STATE(1617),
    [sym_identifier] = ACTIONS(3055),
    [anon_sym_EQ] = ACTIONS(3057),
    [anon_sym_COLON] = ACTIONS(3055),
    [anon_sym_return] = ACTIONS(3055),
    [anon_sym_do] = ACTIONS(3055),
    [anon_sym_let] = ACTIONS(3055),
    [anon_sym_let_BANG] = ACTIONS(3057),
    [anon_sym_as] = ACTIONS(3055),
    [anon_sym_LPAREN] = ACTIONS(3055),
    [anon_sym_COMMA] = ACTIONS(3057),
    [anon_sym_null] = ACTIONS(3055),
    [anon_sym_QMARK] = ACTIONS(3055),
    [anon_sym_COLON_QMARK] = ACTIONS(3055),
    [anon_sym_COLON_COLON] = ACTIONS(3057),
    [anon_sym_AMP] = ACTIONS(3055),
    [anon_sym_LBRACK] = ACTIONS(3055),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3057),
    [anon_sym_LBRACE] = ACTIONS(3055),
    [anon_sym_LT_AT] = ACTIONS(3055),
    [anon_sym_LT_AT_AT] = ACTIONS(3055),
    [anon_sym_DOT] = ACTIONS(3055),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3057),
    [anon_sym_new] = ACTIONS(3055),
    [anon_sym_with] = ACTIONS(3055),
    [anon_sym_return_BANG] = ACTIONS(3057),
    [anon_sym_yield] = ACTIONS(3055),
    [anon_sym_yield_BANG] = ACTIONS(3057),
    [anon_sym_lazy] = ACTIONS(3055),
    [anon_sym_assert] = ACTIONS(3055),
    [anon_sym_upcast] = ACTIONS(3055),
    [anon_sym_downcast] = ACTIONS(3055),
    [anon_sym_COLON_GT] = ACTIONS(3057),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3057),
    [anon_sym_for] = ACTIONS(3055),
    [anon_sym_while] = ACTIONS(3055),
    [anon_sym_if] = ACTIONS(3055),
    [anon_sym_fun] = ACTIONS(3055),
    [anon_sym_try] = ACTIONS(3055),
    [anon_sym_match] = ACTIONS(3055),
    [anon_sym_match_BANG] = ACTIONS(3057),
    [anon_sym_function] = ACTIONS(3055),
    [anon_sym_LT_DASH] = ACTIONS(3055),
    [anon_sym_DOT_LBRACK] = ACTIONS(3057),
    [anon_sym_LT] = ACTIONS(3057),
    [anon_sym_use] = ACTIONS(3055),
    [anon_sym_use_BANG] = ACTIONS(3057),
    [anon_sym_do_BANG] = ACTIONS(3057),
    [anon_sym_begin] = ACTIONS(3055),
    [anon_sym_LPAREN2] = ACTIONS(3055),
    [anon_sym_or] = ACTIONS(3055),
    [aux_sym_char_token1] = ACTIONS(3057),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3055),
    [anon_sym_DQUOTE] = ACTIONS(3055),
    [anon_sym_AT_DQUOTE] = ACTIONS(3057),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3057),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3057),
    [sym_bool] = ACTIONS(3055),
    [sym_unit] = ACTIONS(3057),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3055),
    [sym_op_identifier] = ACTIONS(3055),
    [anon_sym_PLUS] = ACTIONS(3055),
    [anon_sym_DASH] = ACTIONS(3055),
    [anon_sym_PLUS_DOT] = ACTIONS(3055),
    [anon_sym_DASH_DOT] = ACTIONS(3055),
    [anon_sym_PERCENT] = ACTIONS(3055),
    [anon_sym_AMP_AMP] = ACTIONS(3055),
    [anon_sym_TILDE] = ACTIONS(3057),
    [aux_sym_prefix_op_token1] = ACTIONS(3055),
    [aux_sym_infix_op_token1] = ACTIONS(3057),
    [aux_sym_infix_op_token2] = ACTIONS(3055),
    [anon_sym_PIPE_PIPE] = ACTIONS(3055),
    [anon_sym_BANG_EQ] = ACTIONS(3055),
    [anon_sym_COLON_EQ] = ACTIONS(3057),
    [anon_sym_DOLLAR] = ACTIONS(3055),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3055),
    [sym_int] = ACTIONS(3055),
    [sym_xint] = ACTIONS(3057),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3057),
    [sym__newline] = ACTIONS(3057),
    [sym__dedent] = ACTIONS(3057),
  },
  [1618] = {
    [sym_block_comment] = STATE(1618),
    [sym_compiler_directive_decl] = STATE(1618),
    [sym_fsi_directive_decl] = STATE(1618),
    [sym_preproc_line] = STATE(1618),
    [aux_sym_long_identifier_repeat1] = STATE(1548),
    [sym_identifier] = ACTIONS(2418),
    [anon_sym_EQ] = ACTIONS(2418),
    [anon_sym_COLON] = ACTIONS(2418),
    [anon_sym_return] = ACTIONS(2418),
    [anon_sym_do] = ACTIONS(2418),
    [anon_sym_let] = ACTIONS(2418),
    [anon_sym_let_BANG] = ACTIONS(2420),
    [anon_sym_LPAREN] = ACTIONS(2418),
    [anon_sym_COMMA] = ACTIONS(2420),
    [anon_sym_null] = ACTIONS(2418),
    [anon_sym_QMARK] = ACTIONS(2418),
    [anon_sym_COLON_QMARK] = ACTIONS(2418),
    [anon_sym_COLON_COLON] = ACTIONS(2420),
    [anon_sym_AMP] = ACTIONS(2418),
    [anon_sym_LBRACK] = ACTIONS(2418),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2420),
    [anon_sym_LBRACE] = ACTIONS(2418),
    [anon_sym_LT_AT] = ACTIONS(2418),
    [anon_sym_LT_AT_AT] = ACTIONS(2418),
    [anon_sym_DOT] = ACTIONS(3841),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2420),
    [anon_sym_new] = ACTIONS(2418),
    [anon_sym_with] = ACTIONS(2418),
    [anon_sym_return_BANG] = ACTIONS(2420),
    [anon_sym_yield] = ACTIONS(2418),
    [anon_sym_yield_BANG] = ACTIONS(2420),
    [anon_sym_lazy] = ACTIONS(2418),
    [anon_sym_assert] = ACTIONS(2418),
    [anon_sym_upcast] = ACTIONS(2418),
    [anon_sym_downcast] = ACTIONS(2418),
    [anon_sym_COLON_GT] = ACTIONS(2420),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2420),
    [anon_sym_for] = ACTIONS(2418),
    [anon_sym_while] = ACTIONS(2418),
    [anon_sym_if] = ACTIONS(2418),
    [anon_sym_fun] = ACTIONS(2418),
    [anon_sym_try] = ACTIONS(2418),
    [anon_sym_match] = ACTIONS(2418),
    [anon_sym_match_BANG] = ACTIONS(2420),
    [anon_sym_function] = ACTIONS(2418),
    [anon_sym_LT_DASH] = ACTIONS(2418),
    [anon_sym_DOT_LBRACK] = ACTIONS(2420),
    [anon_sym_LT] = ACTIONS(2420),
    [anon_sym_use] = ACTIONS(2418),
    [anon_sym_use_BANG] = ACTIONS(2420),
    [anon_sym_do_BANG] = ACTIONS(2420),
    [anon_sym_begin] = ACTIONS(2418),
    [anon_sym_LPAREN2] = ACTIONS(2418),
    [anon_sym_or] = ACTIONS(2418),
    [anon_sym_EQ2] = ACTIONS(2420),
    [aux_sym_char_token1] = ACTIONS(2420),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2418),
    [anon_sym_DQUOTE] = ACTIONS(2418),
    [anon_sym_AT_DQUOTE] = ACTIONS(2420),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2420),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2420),
    [sym_bool] = ACTIONS(2418),
    [sym_unit] = ACTIONS(2420),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2418),
    [sym_op_identifier] = ACTIONS(2418),
    [anon_sym_PLUS] = ACTIONS(2418),
    [anon_sym_DASH] = ACTIONS(2418),
    [anon_sym_PLUS_DOT] = ACTIONS(2418),
    [anon_sym_DASH_DOT] = ACTIONS(2418),
    [anon_sym_PERCENT] = ACTIONS(2418),
    [anon_sym_AMP_AMP] = ACTIONS(2418),
    [anon_sym_TILDE] = ACTIONS(2420),
    [aux_sym_prefix_op_token1] = ACTIONS(2418),
    [aux_sym_infix_op_token1] = ACTIONS(2420),
    [aux_sym_infix_op_token2] = ACTIONS(2418),
    [anon_sym_PIPE_PIPE] = ACTIONS(2418),
    [anon_sym_BANG_EQ] = ACTIONS(2418),
    [anon_sym_COLON_EQ] = ACTIONS(2420),
    [anon_sym_DOLLAR] = ACTIONS(2418),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2418),
    [sym_int] = ACTIONS(2418),
    [sym_xint] = ACTIONS(2420),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2420),
    [sym__newline] = ACTIONS(2420),
  },
  [1619] = {
    [sym_block_comment] = STATE(1619),
    [sym_compiler_directive_decl] = STATE(1619),
    [sym_fsi_directive_decl] = STATE(1619),
    [sym_preproc_line] = STATE(1619),
    [sym_identifier] = ACTIONS(2958),
    [anon_sym_EQ] = ACTIONS(2960),
    [anon_sym_COLON] = ACTIONS(2958),
    [anon_sym_return] = ACTIONS(2958),
    [anon_sym_do] = ACTIONS(2958),
    [anon_sym_let] = ACTIONS(2958),
    [anon_sym_let_BANG] = ACTIONS(2960),
    [anon_sym_as] = ACTIONS(2958),
    [anon_sym_LPAREN] = ACTIONS(2958),
    [anon_sym_COMMA] = ACTIONS(2960),
    [anon_sym_null] = ACTIONS(2958),
    [anon_sym_QMARK] = ACTIONS(2958),
    [anon_sym_COLON_QMARK] = ACTIONS(2958),
    [anon_sym_COLON_COLON] = ACTIONS(2960),
    [anon_sym_AMP] = ACTIONS(2958),
    [anon_sym_LBRACK] = ACTIONS(2958),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2960),
    [anon_sym_LBRACE] = ACTIONS(2958),
    [anon_sym_LT_AT] = ACTIONS(2958),
    [anon_sym_LT_AT_AT] = ACTIONS(2958),
    [anon_sym_DOT] = ACTIONS(2958),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2960),
    [anon_sym_new] = ACTIONS(2958),
    [anon_sym_with] = ACTIONS(2958),
    [anon_sym_return_BANG] = ACTIONS(2960),
    [anon_sym_yield] = ACTIONS(2958),
    [anon_sym_yield_BANG] = ACTIONS(2960),
    [anon_sym_lazy] = ACTIONS(2958),
    [anon_sym_assert] = ACTIONS(2958),
    [anon_sym_upcast] = ACTIONS(2958),
    [anon_sym_downcast] = ACTIONS(2958),
    [anon_sym_COLON_GT] = ACTIONS(2960),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2960),
    [anon_sym_for] = ACTIONS(2958),
    [anon_sym_while] = ACTIONS(2958),
    [anon_sym_if] = ACTIONS(2958),
    [anon_sym_fun] = ACTIONS(2958),
    [anon_sym_try] = ACTIONS(2958),
    [anon_sym_match] = ACTIONS(2958),
    [anon_sym_match_BANG] = ACTIONS(2960),
    [anon_sym_function] = ACTIONS(2958),
    [anon_sym_LT_DASH] = ACTIONS(2958),
    [anon_sym_DOT_LBRACK] = ACTIONS(2960),
    [anon_sym_LT] = ACTIONS(2960),
    [anon_sym_use] = ACTIONS(2958),
    [anon_sym_use_BANG] = ACTIONS(2960),
    [anon_sym_do_BANG] = ACTIONS(2960),
    [anon_sym_begin] = ACTIONS(2958),
    [anon_sym_LPAREN2] = ACTIONS(2958),
    [anon_sym_or] = ACTIONS(2958),
    [aux_sym_char_token1] = ACTIONS(2960),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2958),
    [anon_sym_DQUOTE] = ACTIONS(2958),
    [anon_sym_AT_DQUOTE] = ACTIONS(2960),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2960),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2960),
    [sym_bool] = ACTIONS(2958),
    [sym_unit] = ACTIONS(2960),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2958),
    [sym_op_identifier] = ACTIONS(2958),
    [anon_sym_PLUS] = ACTIONS(2958),
    [anon_sym_DASH] = ACTIONS(2958),
    [anon_sym_PLUS_DOT] = ACTIONS(2958),
    [anon_sym_DASH_DOT] = ACTIONS(2958),
    [anon_sym_PERCENT] = ACTIONS(2958),
    [anon_sym_AMP_AMP] = ACTIONS(2958),
    [anon_sym_TILDE] = ACTIONS(2960),
    [aux_sym_prefix_op_token1] = ACTIONS(2958),
    [aux_sym_infix_op_token1] = ACTIONS(2960),
    [aux_sym_infix_op_token2] = ACTIONS(2958),
    [anon_sym_PIPE_PIPE] = ACTIONS(2958),
    [anon_sym_BANG_EQ] = ACTIONS(2958),
    [anon_sym_COLON_EQ] = ACTIONS(2960),
    [anon_sym_DOLLAR] = ACTIONS(2958),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2958),
    [sym_int] = ACTIONS(2958),
    [sym_xint] = ACTIONS(2960),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2960),
    [sym__newline] = ACTIONS(2960),
    [sym__dedent] = ACTIONS(2960),
  },
  [1620] = {
    [sym_block_comment] = STATE(1620),
    [sym_compiler_directive_decl] = STATE(1620),
    [sym_fsi_directive_decl] = STATE(1620),
    [sym_preproc_line] = STATE(1620),
    [aux_sym_sequential_expression_repeat1] = STATE(1653),
    [sym_identifier] = ACTIONS(2847),
    [anon_sym_EQ] = ACTIONS(2849),
    [anon_sym_COLON] = ACTIONS(2847),
    [anon_sym_return] = ACTIONS(2847),
    [anon_sym_do] = ACTIONS(2847),
    [anon_sym_and] = ACTIONS(2847),
    [anon_sym_let] = ACTIONS(2847),
    [anon_sym_let_BANG] = ACTIONS(2849),
    [anon_sym_LPAREN] = ACTIONS(2847),
    [anon_sym_COMMA] = ACTIONS(2849),
    [anon_sym_null] = ACTIONS(2847),
    [anon_sym_QMARK] = ACTIONS(2847),
    [anon_sym_COLON_QMARK] = ACTIONS(2847),
    [anon_sym_COLON_COLON] = ACTIONS(2849),
    [anon_sym_AMP] = ACTIONS(2847),
    [anon_sym_LBRACK] = ACTIONS(2847),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2849),
    [anon_sym_LBRACE] = ACTIONS(2847),
    [anon_sym_LT_AT] = ACTIONS(2847),
    [anon_sym_LT_AT_AT] = ACTIONS(2847),
    [anon_sym_DOT] = ACTIONS(2847),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2849),
    [anon_sym_new] = ACTIONS(2847),
    [anon_sym_return_BANG] = ACTIONS(2849),
    [anon_sym_yield] = ACTIONS(2847),
    [anon_sym_yield_BANG] = ACTIONS(2849),
    [anon_sym_lazy] = ACTIONS(2847),
    [anon_sym_assert] = ACTIONS(2847),
    [anon_sym_upcast] = ACTIONS(2847),
    [anon_sym_downcast] = ACTIONS(2847),
    [anon_sym_COLON_GT] = ACTIONS(2849),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2849),
    [anon_sym_for] = ACTIONS(2847),
    [anon_sym_while] = ACTIONS(2847),
    [anon_sym_if] = ACTIONS(2847),
    [anon_sym_fun] = ACTIONS(2847),
    [anon_sym_try] = ACTIONS(2847),
    [anon_sym_match] = ACTIONS(2847),
    [anon_sym_match_BANG] = ACTIONS(2849),
    [anon_sym_function] = ACTIONS(2847),
    [anon_sym_LT_DASH] = ACTIONS(2847),
    [anon_sym_DOT_LBRACK] = ACTIONS(2849),
    [anon_sym_LT] = ACTIONS(2849),
    [anon_sym_use] = ACTIONS(2847),
    [anon_sym_use_BANG] = ACTIONS(2849),
    [anon_sym_do_BANG] = ACTIONS(2849),
    [anon_sym_begin] = ACTIONS(2847),
    [anon_sym_LPAREN2] = ACTIONS(2847),
    [anon_sym_or] = ACTIONS(2847),
    [aux_sym_char_token1] = ACTIONS(2849),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2847),
    [anon_sym_DQUOTE] = ACTIONS(2847),
    [anon_sym_AT_DQUOTE] = ACTIONS(2849),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2849),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2849),
    [sym_bool] = ACTIONS(2847),
    [sym_unit] = ACTIONS(2849),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2847),
    [sym_op_identifier] = ACTIONS(2847),
    [anon_sym_PLUS] = ACTIONS(2847),
    [anon_sym_DASH] = ACTIONS(2847),
    [anon_sym_PLUS_DOT] = ACTIONS(2847),
    [anon_sym_DASH_DOT] = ACTIONS(2847),
    [anon_sym_PERCENT] = ACTIONS(2847),
    [anon_sym_AMP_AMP] = ACTIONS(2847),
    [anon_sym_TILDE] = ACTIONS(2849),
    [aux_sym_prefix_op_token1] = ACTIONS(2847),
    [aux_sym_infix_op_token1] = ACTIONS(2849),
    [aux_sym_infix_op_token2] = ACTIONS(2847),
    [anon_sym_PIPE_PIPE] = ACTIONS(2847),
    [anon_sym_BANG_EQ] = ACTIONS(2847),
    [anon_sym_COLON_EQ] = ACTIONS(2849),
    [anon_sym_DOLLAR] = ACTIONS(2847),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2847),
    [sym_int] = ACTIONS(2847),
    [sym_xint] = ACTIONS(2849),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2849),
    [sym__newline] = ACTIONS(2849),
    [sym__dedent] = ACTIONS(2849),
  },
  [1621] = {
    [sym_block_comment] = STATE(1621),
    [sym_compiler_directive_decl] = STATE(1621),
    [sym_fsi_directive_decl] = STATE(1621),
    [sym_preproc_line] = STATE(1621),
    [sym_identifier] = ACTIONS(2783),
    [anon_sym_EQ] = ACTIONS(2785),
    [anon_sym_COLON] = ACTIONS(2783),
    [anon_sym_return] = ACTIONS(2783),
    [anon_sym_do] = ACTIONS(2783),
    [anon_sym_let] = ACTIONS(2783),
    [anon_sym_let_BANG] = ACTIONS(2785),
    [anon_sym_LPAREN] = ACTIONS(2783),
    [anon_sym_COMMA] = ACTIONS(2785),
    [anon_sym_null] = ACTIONS(2783),
    [anon_sym_QMARK] = ACTIONS(2783),
    [anon_sym_COLON_QMARK] = ACTIONS(2783),
    [anon_sym_COLON_COLON] = ACTIONS(2785),
    [anon_sym_AMP] = ACTIONS(2783),
    [anon_sym_LBRACK] = ACTIONS(2783),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2785),
    [anon_sym_LBRACE] = ACTIONS(2783),
    [anon_sym_LT_AT] = ACTIONS(2783),
    [anon_sym_LT_AT_AT] = ACTIONS(2783),
    [anon_sym_DOT] = ACTIONS(2783),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2785),
    [anon_sym_new] = ACTIONS(2783),
    [anon_sym_return_BANG] = ACTIONS(2785),
    [anon_sym_yield] = ACTIONS(2783),
    [anon_sym_yield_BANG] = ACTIONS(2785),
    [anon_sym_lazy] = ACTIONS(2783),
    [anon_sym_assert] = ACTIONS(2783),
    [anon_sym_upcast] = ACTIONS(2783),
    [anon_sym_downcast] = ACTIONS(2783),
    [anon_sym_COLON_GT] = ACTIONS(2785),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2785),
    [anon_sym_for] = ACTIONS(2783),
    [anon_sym_done] = ACTIONS(3740),
    [anon_sym_while] = ACTIONS(2783),
    [anon_sym_if] = ACTIONS(2783),
    [anon_sym_fun] = ACTIONS(2783),
    [anon_sym_DASH_GT] = ACTIONS(2783),
    [anon_sym_try] = ACTIONS(2783),
    [anon_sym_match] = ACTIONS(2783),
    [anon_sym_match_BANG] = ACTIONS(2785),
    [anon_sym_function] = ACTIONS(2783),
    [anon_sym_LT_DASH] = ACTIONS(2783),
    [anon_sym_DOT_LBRACK] = ACTIONS(2785),
    [anon_sym_LT] = ACTIONS(2785),
    [anon_sym_use] = ACTIONS(2783),
    [anon_sym_use_BANG] = ACTIONS(2785),
    [anon_sym_do_BANG] = ACTIONS(2785),
    [anon_sym_DOT_DOT] = ACTIONS(2785),
    [anon_sym_begin] = ACTIONS(2783),
    [anon_sym_LPAREN2] = ACTIONS(2783),
    [anon_sym_or] = ACTIONS(2783),
    [aux_sym_char_token1] = ACTIONS(2785),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2783),
    [anon_sym_DQUOTE] = ACTIONS(2783),
    [anon_sym_AT_DQUOTE] = ACTIONS(2785),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2785),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2785),
    [sym_bool] = ACTIONS(2783),
    [sym_unit] = ACTIONS(2785),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2783),
    [sym_op_identifier] = ACTIONS(2783),
    [anon_sym_PLUS] = ACTIONS(2783),
    [anon_sym_DASH] = ACTIONS(2783),
    [anon_sym_PLUS_DOT] = ACTIONS(2783),
    [anon_sym_DASH_DOT] = ACTIONS(2783),
    [anon_sym_PERCENT] = ACTIONS(2783),
    [anon_sym_AMP_AMP] = ACTIONS(2783),
    [anon_sym_TILDE] = ACTIONS(2785),
    [aux_sym_prefix_op_token1] = ACTIONS(2783),
    [aux_sym_infix_op_token1] = ACTIONS(2785),
    [aux_sym_infix_op_token2] = ACTIONS(2783),
    [anon_sym_PIPE_PIPE] = ACTIONS(2783),
    [anon_sym_BANG_EQ] = ACTIONS(2783),
    [anon_sym_COLON_EQ] = ACTIONS(2785),
    [anon_sym_DOLLAR] = ACTIONS(2783),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2783),
    [sym_int] = ACTIONS(2783),
    [sym_xint] = ACTIONS(2785),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2785),
    [sym__newline] = ACTIONS(2785),
  },
  [1622] = {
    [sym_block_comment] = STATE(1622),
    [sym_compiler_directive_decl] = STATE(1622),
    [sym_fsi_directive_decl] = STATE(1622),
    [sym_preproc_line] = STATE(1622),
    [sym_identifier] = ACTIONS(2819),
    [anon_sym_EQ] = ACTIONS(2821),
    [anon_sym_COLON] = ACTIONS(2819),
    [anon_sym_return] = ACTIONS(2819),
    [anon_sym_do] = ACTIONS(2819),
    [anon_sym_let] = ACTIONS(2819),
    [anon_sym_let_BANG] = ACTIONS(2821),
    [anon_sym_LPAREN] = ACTIONS(2819),
    [anon_sym_COMMA] = ACTIONS(2821),
    [anon_sym_null] = ACTIONS(2819),
    [anon_sym_QMARK] = ACTIONS(2819),
    [anon_sym_COLON_QMARK] = ACTIONS(2819),
    [anon_sym_COLON_COLON] = ACTIONS(2821),
    [anon_sym_AMP] = ACTIONS(2819),
    [anon_sym_LBRACK] = ACTIONS(2819),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2821),
    [anon_sym_LBRACE] = ACTIONS(2819),
    [anon_sym_LT_AT] = ACTIONS(2819),
    [anon_sym_AT_GT] = ACTIONS(2819),
    [anon_sym_LT_AT_AT] = ACTIONS(2819),
    [anon_sym_DOT] = ACTIONS(2819),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2821),
    [anon_sym_new] = ACTIONS(2819),
    [anon_sym_return_BANG] = ACTIONS(2821),
    [anon_sym_yield] = ACTIONS(2819),
    [anon_sym_yield_BANG] = ACTIONS(2821),
    [anon_sym_lazy] = ACTIONS(2819),
    [anon_sym_assert] = ACTIONS(2819),
    [anon_sym_upcast] = ACTIONS(2819),
    [anon_sym_downcast] = ACTIONS(2819),
    [anon_sym_COLON_GT] = ACTIONS(2821),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2821),
    [anon_sym_for] = ACTIONS(2819),
    [anon_sym_while] = ACTIONS(2819),
    [anon_sym_if] = ACTIONS(2819),
    [anon_sym_fun] = ACTIONS(2819),
    [anon_sym_try] = ACTIONS(2819),
    [anon_sym_match] = ACTIONS(2819),
    [anon_sym_match_BANG] = ACTIONS(2821),
    [anon_sym_function] = ACTIONS(2819),
    [anon_sym_LT_DASH] = ACTIONS(2819),
    [anon_sym_DOT_LBRACK] = ACTIONS(2821),
    [anon_sym_LT] = ACTIONS(2821),
    [anon_sym_use] = ACTIONS(2819),
    [anon_sym_use_BANG] = ACTIONS(2821),
    [anon_sym_do_BANG] = ACTIONS(2821),
    [anon_sym_begin] = ACTIONS(2819),
    [anon_sym_LPAREN2] = ACTIONS(2819),
    [anon_sym_or] = ACTIONS(2819),
    [aux_sym_char_token1] = ACTIONS(2821),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2819),
    [anon_sym_DQUOTE] = ACTIONS(2819),
    [anon_sym_AT_DQUOTE] = ACTIONS(2821),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2821),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2821),
    [sym_bool] = ACTIONS(2819),
    [sym_unit] = ACTIONS(2821),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2819),
    [sym_op_identifier] = ACTIONS(2819),
    [anon_sym_PLUS] = ACTIONS(2819),
    [anon_sym_DASH] = ACTIONS(2819),
    [anon_sym_PLUS_DOT] = ACTIONS(2819),
    [anon_sym_DASH_DOT] = ACTIONS(2819),
    [anon_sym_PERCENT] = ACTIONS(2819),
    [anon_sym_AMP_AMP] = ACTIONS(2819),
    [anon_sym_TILDE] = ACTIONS(2821),
    [aux_sym_prefix_op_token1] = ACTIONS(2819),
    [aux_sym_infix_op_token1] = ACTIONS(2821),
    [aux_sym_infix_op_token2] = ACTIONS(2819),
    [anon_sym_PIPE_PIPE] = ACTIONS(2819),
    [anon_sym_BANG_EQ] = ACTIONS(2819),
    [anon_sym_COLON_EQ] = ACTIONS(2821),
    [anon_sym_DOLLAR] = ACTIONS(2819),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2819),
    [sym_int] = ACTIONS(3843),
    [sym_xint] = ACTIONS(2821),
    [anon_sym_f] = ACTIONS(2819),
    [aux_sym_decimal_token1] = ACTIONS(2819),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2821),
    [sym__newline] = ACTIONS(2821),
  },
  [1623] = {
    [sym_block_comment] = STATE(1623),
    [sym_compiler_directive_decl] = STATE(1623),
    [sym_fsi_directive_decl] = STATE(1623),
    [sym_preproc_line] = STATE(1623),
    [sym_identifier] = ACTIONS(3011),
    [anon_sym_EQ] = ACTIONS(3013),
    [anon_sym_COLON] = ACTIONS(3011),
    [anon_sym_return] = ACTIONS(3011),
    [anon_sym_do] = ACTIONS(3011),
    [anon_sym_let] = ACTIONS(3011),
    [anon_sym_let_BANG] = ACTIONS(3013),
    [anon_sym_as] = ACTIONS(3011),
    [anon_sym_LPAREN] = ACTIONS(3011),
    [anon_sym_COMMA] = ACTIONS(3013),
    [anon_sym_null] = ACTIONS(3011),
    [anon_sym_QMARK] = ACTIONS(3011),
    [anon_sym_COLON_QMARK] = ACTIONS(3011),
    [anon_sym_COLON_COLON] = ACTIONS(3013),
    [anon_sym_AMP] = ACTIONS(3011),
    [anon_sym_LBRACK] = ACTIONS(3011),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3013),
    [anon_sym_LBRACE] = ACTIONS(3011),
    [anon_sym_LT_AT] = ACTIONS(3011),
    [anon_sym_LT_AT_AT] = ACTIONS(3011),
    [anon_sym_DOT] = ACTIONS(3011),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3013),
    [anon_sym_new] = ACTIONS(3011),
    [anon_sym_with] = ACTIONS(3011),
    [anon_sym_return_BANG] = ACTIONS(3013),
    [anon_sym_yield] = ACTIONS(3011),
    [anon_sym_yield_BANG] = ACTIONS(3013),
    [anon_sym_lazy] = ACTIONS(3011),
    [anon_sym_assert] = ACTIONS(3011),
    [anon_sym_upcast] = ACTIONS(3011),
    [anon_sym_downcast] = ACTIONS(3011),
    [anon_sym_COLON_GT] = ACTIONS(3013),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3013),
    [anon_sym_for] = ACTIONS(3011),
    [anon_sym_while] = ACTIONS(3011),
    [anon_sym_if] = ACTIONS(3011),
    [anon_sym_fun] = ACTIONS(3011),
    [anon_sym_try] = ACTIONS(3011),
    [anon_sym_match] = ACTIONS(3011),
    [anon_sym_match_BANG] = ACTIONS(3013),
    [anon_sym_function] = ACTIONS(3011),
    [anon_sym_LT_DASH] = ACTIONS(3011),
    [anon_sym_DOT_LBRACK] = ACTIONS(3013),
    [anon_sym_LT] = ACTIONS(3013),
    [anon_sym_use] = ACTIONS(3011),
    [anon_sym_use_BANG] = ACTIONS(3013),
    [anon_sym_do_BANG] = ACTIONS(3013),
    [anon_sym_begin] = ACTIONS(3011),
    [anon_sym_LPAREN2] = ACTIONS(3011),
    [anon_sym_or] = ACTIONS(3011),
    [aux_sym_char_token1] = ACTIONS(3013),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3011),
    [anon_sym_DQUOTE] = ACTIONS(3011),
    [anon_sym_AT_DQUOTE] = ACTIONS(3013),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3013),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3013),
    [sym_bool] = ACTIONS(3011),
    [sym_unit] = ACTIONS(3013),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3011),
    [sym_op_identifier] = ACTIONS(3011),
    [anon_sym_PLUS] = ACTIONS(3011),
    [anon_sym_DASH] = ACTIONS(3011),
    [anon_sym_PLUS_DOT] = ACTIONS(3011),
    [anon_sym_DASH_DOT] = ACTIONS(3011),
    [anon_sym_PERCENT] = ACTIONS(3011),
    [anon_sym_AMP_AMP] = ACTIONS(3011),
    [anon_sym_TILDE] = ACTIONS(3013),
    [aux_sym_prefix_op_token1] = ACTIONS(3011),
    [aux_sym_infix_op_token1] = ACTIONS(3013),
    [aux_sym_infix_op_token2] = ACTIONS(3011),
    [anon_sym_PIPE_PIPE] = ACTIONS(3011),
    [anon_sym_BANG_EQ] = ACTIONS(3011),
    [anon_sym_COLON_EQ] = ACTIONS(3013),
    [anon_sym_DOLLAR] = ACTIONS(3011),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3011),
    [sym_int] = ACTIONS(3011),
    [sym_xint] = ACTIONS(3013),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3013),
    [sym__newline] = ACTIONS(3013),
    [sym__dedent] = ACTIONS(3013),
  },
  [1624] = {
    [sym_block_comment] = STATE(1624),
    [sym_compiler_directive_decl] = STATE(1624),
    [sym_fsi_directive_decl] = STATE(1624),
    [sym_preproc_line] = STATE(1624),
    [sym_identifier] = ACTIONS(2988),
    [anon_sym_EQ] = ACTIONS(2990),
    [anon_sym_COLON] = ACTIONS(2988),
    [anon_sym_return] = ACTIONS(2988),
    [anon_sym_do] = ACTIONS(2988),
    [anon_sym_let] = ACTIONS(2988),
    [anon_sym_let_BANG] = ACTIONS(2990),
    [anon_sym_as] = ACTIONS(2988),
    [anon_sym_LPAREN] = ACTIONS(2988),
    [anon_sym_COMMA] = ACTIONS(2990),
    [anon_sym_null] = ACTIONS(2988),
    [anon_sym_QMARK] = ACTIONS(2988),
    [anon_sym_COLON_QMARK] = ACTIONS(2988),
    [anon_sym_COLON_COLON] = ACTIONS(2990),
    [anon_sym_AMP] = ACTIONS(2988),
    [anon_sym_LBRACK] = ACTIONS(2988),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2990),
    [anon_sym_LBRACE] = ACTIONS(2988),
    [anon_sym_LT_AT] = ACTIONS(2988),
    [anon_sym_LT_AT_AT] = ACTIONS(2988),
    [anon_sym_DOT] = ACTIONS(2988),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2990),
    [anon_sym_new] = ACTIONS(2988),
    [anon_sym_with] = ACTIONS(2988),
    [anon_sym_return_BANG] = ACTIONS(2990),
    [anon_sym_yield] = ACTIONS(2988),
    [anon_sym_yield_BANG] = ACTIONS(2990),
    [anon_sym_lazy] = ACTIONS(2988),
    [anon_sym_assert] = ACTIONS(2988),
    [anon_sym_upcast] = ACTIONS(2988),
    [anon_sym_downcast] = ACTIONS(2988),
    [anon_sym_COLON_GT] = ACTIONS(2990),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2990),
    [anon_sym_for] = ACTIONS(2988),
    [anon_sym_while] = ACTIONS(2988),
    [anon_sym_if] = ACTIONS(2988),
    [anon_sym_fun] = ACTIONS(2988),
    [anon_sym_try] = ACTIONS(2988),
    [anon_sym_match] = ACTIONS(2988),
    [anon_sym_match_BANG] = ACTIONS(2990),
    [anon_sym_function] = ACTIONS(2988),
    [anon_sym_LT_DASH] = ACTIONS(2988),
    [anon_sym_DOT_LBRACK] = ACTIONS(2990),
    [anon_sym_LT] = ACTIONS(2990),
    [anon_sym_use] = ACTIONS(2988),
    [anon_sym_use_BANG] = ACTIONS(2990),
    [anon_sym_do_BANG] = ACTIONS(2990),
    [anon_sym_begin] = ACTIONS(2988),
    [anon_sym_LPAREN2] = ACTIONS(2988),
    [anon_sym_or] = ACTIONS(2988),
    [aux_sym_char_token1] = ACTIONS(2990),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2988),
    [anon_sym_DQUOTE] = ACTIONS(2988),
    [anon_sym_AT_DQUOTE] = ACTIONS(2990),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2990),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2990),
    [sym_bool] = ACTIONS(2988),
    [sym_unit] = ACTIONS(2990),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2988),
    [sym_op_identifier] = ACTIONS(2988),
    [anon_sym_PLUS] = ACTIONS(2988),
    [anon_sym_DASH] = ACTIONS(2988),
    [anon_sym_PLUS_DOT] = ACTIONS(2988),
    [anon_sym_DASH_DOT] = ACTIONS(2988),
    [anon_sym_PERCENT] = ACTIONS(2988),
    [anon_sym_AMP_AMP] = ACTIONS(2988),
    [anon_sym_TILDE] = ACTIONS(2990),
    [aux_sym_prefix_op_token1] = ACTIONS(2988),
    [aux_sym_infix_op_token1] = ACTIONS(2990),
    [aux_sym_infix_op_token2] = ACTIONS(2988),
    [anon_sym_PIPE_PIPE] = ACTIONS(2988),
    [anon_sym_BANG_EQ] = ACTIONS(2988),
    [anon_sym_COLON_EQ] = ACTIONS(2990),
    [anon_sym_DOLLAR] = ACTIONS(2988),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2988),
    [sym_int] = ACTIONS(2988),
    [sym_xint] = ACTIONS(2990),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2990),
    [sym__newline] = ACTIONS(2990),
    [sym__dedent] = ACTIONS(2990),
  },
  [1625] = {
    [sym_block_comment] = STATE(1625),
    [sym_compiler_directive_decl] = STATE(1625),
    [sym_fsi_directive_decl] = STATE(1625),
    [sym_preproc_line] = STATE(1625),
    [sym_identifier] = ACTIONS(2970),
    [anon_sym_EQ] = ACTIONS(2972),
    [anon_sym_COLON] = ACTIONS(2970),
    [anon_sym_return] = ACTIONS(2970),
    [anon_sym_do] = ACTIONS(2970),
    [anon_sym_let] = ACTIONS(2970),
    [anon_sym_let_BANG] = ACTIONS(2972),
    [anon_sym_as] = ACTIONS(2970),
    [anon_sym_LPAREN] = ACTIONS(2970),
    [anon_sym_COMMA] = ACTIONS(2972),
    [anon_sym_null] = ACTIONS(2970),
    [anon_sym_QMARK] = ACTIONS(2970),
    [anon_sym_COLON_QMARK] = ACTIONS(2970),
    [anon_sym_COLON_COLON] = ACTIONS(2972),
    [anon_sym_AMP] = ACTIONS(2970),
    [anon_sym_LBRACK] = ACTIONS(2970),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2972),
    [anon_sym_LBRACE] = ACTIONS(2970),
    [anon_sym_LT_AT] = ACTIONS(2970),
    [anon_sym_LT_AT_AT] = ACTIONS(2970),
    [anon_sym_DOT] = ACTIONS(2970),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2972),
    [anon_sym_new] = ACTIONS(2970),
    [anon_sym_with] = ACTIONS(2970),
    [anon_sym_return_BANG] = ACTIONS(2972),
    [anon_sym_yield] = ACTIONS(2970),
    [anon_sym_yield_BANG] = ACTIONS(2972),
    [anon_sym_lazy] = ACTIONS(2970),
    [anon_sym_assert] = ACTIONS(2970),
    [anon_sym_upcast] = ACTIONS(2970),
    [anon_sym_downcast] = ACTIONS(2970),
    [anon_sym_COLON_GT] = ACTIONS(2972),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2972),
    [anon_sym_for] = ACTIONS(2970),
    [anon_sym_while] = ACTIONS(2970),
    [anon_sym_if] = ACTIONS(2970),
    [anon_sym_fun] = ACTIONS(2970),
    [anon_sym_try] = ACTIONS(2970),
    [anon_sym_match] = ACTIONS(2970),
    [anon_sym_match_BANG] = ACTIONS(2972),
    [anon_sym_function] = ACTIONS(2970),
    [anon_sym_LT_DASH] = ACTIONS(2970),
    [anon_sym_DOT_LBRACK] = ACTIONS(2972),
    [anon_sym_LT] = ACTIONS(2972),
    [anon_sym_use] = ACTIONS(2970),
    [anon_sym_use_BANG] = ACTIONS(2972),
    [anon_sym_do_BANG] = ACTIONS(2972),
    [anon_sym_begin] = ACTIONS(2970),
    [anon_sym_LPAREN2] = ACTIONS(2970),
    [anon_sym_or] = ACTIONS(2970),
    [aux_sym_char_token1] = ACTIONS(2972),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2970),
    [anon_sym_DQUOTE] = ACTIONS(2970),
    [anon_sym_AT_DQUOTE] = ACTIONS(2972),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2972),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2972),
    [sym_bool] = ACTIONS(2970),
    [sym_unit] = ACTIONS(2972),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2970),
    [sym_op_identifier] = ACTIONS(2970),
    [anon_sym_PLUS] = ACTIONS(2970),
    [anon_sym_DASH] = ACTIONS(2970),
    [anon_sym_PLUS_DOT] = ACTIONS(2970),
    [anon_sym_DASH_DOT] = ACTIONS(2970),
    [anon_sym_PERCENT] = ACTIONS(2970),
    [anon_sym_AMP_AMP] = ACTIONS(2970),
    [anon_sym_TILDE] = ACTIONS(2972),
    [aux_sym_prefix_op_token1] = ACTIONS(2970),
    [aux_sym_infix_op_token1] = ACTIONS(2972),
    [aux_sym_infix_op_token2] = ACTIONS(2970),
    [anon_sym_PIPE_PIPE] = ACTIONS(2970),
    [anon_sym_BANG_EQ] = ACTIONS(2970),
    [anon_sym_COLON_EQ] = ACTIONS(2972),
    [anon_sym_DOLLAR] = ACTIONS(2970),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2970),
    [sym_int] = ACTIONS(2970),
    [sym_xint] = ACTIONS(2972),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2972),
    [sym__newline] = ACTIONS(2972),
    [sym__dedent] = ACTIONS(2972),
  },
  [1626] = {
    [sym_block_comment] = STATE(1626),
    [sym_compiler_directive_decl] = STATE(1626),
    [sym_fsi_directive_decl] = STATE(1626),
    [sym_preproc_line] = STATE(1626),
    [sym_identifier] = ACTIONS(2867),
    [anon_sym_EQ] = ACTIONS(2867),
    [anon_sym_COLON] = ACTIONS(2867),
    [anon_sym_return] = ACTIONS(2867),
    [anon_sym_do] = ACTIONS(2867),
    [anon_sym_let] = ACTIONS(2867),
    [anon_sym_let_BANG] = ACTIONS(2869),
    [anon_sym_LPAREN] = ACTIONS(2867),
    [anon_sym_COMMA] = ACTIONS(2869),
    [anon_sym_null] = ACTIONS(2867),
    [anon_sym_QMARK] = ACTIONS(2867),
    [anon_sym_COLON_QMARK] = ACTIONS(2867),
    [anon_sym_COLON_COLON] = ACTIONS(2869),
    [anon_sym_AMP] = ACTIONS(2867),
    [anon_sym_LBRACK] = ACTIONS(2867),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2869),
    [anon_sym_LBRACE] = ACTIONS(2867),
    [anon_sym_LT_AT] = ACTIONS(2867),
    [anon_sym_LT_AT_AT] = ACTIONS(2867),
    [anon_sym_DOT] = ACTIONS(2871),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2869),
    [anon_sym_new] = ACTIONS(2867),
    [anon_sym_with] = ACTIONS(2867),
    [anon_sym_return_BANG] = ACTIONS(2869),
    [anon_sym_yield] = ACTIONS(2867),
    [anon_sym_yield_BANG] = ACTIONS(2869),
    [anon_sym_lazy] = ACTIONS(2867),
    [anon_sym_assert] = ACTIONS(2867),
    [anon_sym_upcast] = ACTIONS(2867),
    [anon_sym_downcast] = ACTIONS(2867),
    [anon_sym_COLON_GT] = ACTIONS(2869),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2869),
    [anon_sym_for] = ACTIONS(2867),
    [anon_sym_while] = ACTIONS(2867),
    [anon_sym_if] = ACTIONS(2867),
    [anon_sym_fun] = ACTIONS(2867),
    [anon_sym_try] = ACTIONS(2867),
    [anon_sym_match] = ACTIONS(2867),
    [anon_sym_match_BANG] = ACTIONS(2869),
    [anon_sym_function] = ACTIONS(2867),
    [anon_sym_LT_DASH] = ACTIONS(2867),
    [anon_sym_DOT_LBRACK] = ACTIONS(2869),
    [anon_sym_LT] = ACTIONS(2869),
    [anon_sym_use] = ACTIONS(2867),
    [anon_sym_use_BANG] = ACTIONS(2869),
    [anon_sym_do_BANG] = ACTIONS(2869),
    [anon_sym_begin] = ACTIONS(2867),
    [anon_sym_LPAREN2] = ACTIONS(2867),
    [anon_sym_or] = ACTIONS(2867),
    [anon_sym_EQ2] = ACTIONS(3845),
    [aux_sym_char_token1] = ACTIONS(2869),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2867),
    [anon_sym_DQUOTE] = ACTIONS(2867),
    [anon_sym_AT_DQUOTE] = ACTIONS(2869),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2869),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2869),
    [sym_bool] = ACTIONS(2867),
    [sym_unit] = ACTIONS(2869),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2867),
    [sym_op_identifier] = ACTIONS(2867),
    [anon_sym_PLUS] = ACTIONS(2867),
    [anon_sym_DASH] = ACTIONS(2867),
    [anon_sym_PLUS_DOT] = ACTIONS(2867),
    [anon_sym_DASH_DOT] = ACTIONS(2867),
    [anon_sym_PERCENT] = ACTIONS(2867),
    [anon_sym_AMP_AMP] = ACTIONS(2867),
    [anon_sym_TILDE] = ACTIONS(2869),
    [aux_sym_prefix_op_token1] = ACTIONS(2867),
    [aux_sym_infix_op_token1] = ACTIONS(2869),
    [aux_sym_infix_op_token2] = ACTIONS(2867),
    [anon_sym_PIPE_PIPE] = ACTIONS(2867),
    [anon_sym_BANG_EQ] = ACTIONS(2867),
    [anon_sym_COLON_EQ] = ACTIONS(2869),
    [anon_sym_DOLLAR] = ACTIONS(2867),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2867),
    [sym_int] = ACTIONS(2867),
    [sym_xint] = ACTIONS(2869),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2869),
    [sym__newline] = ACTIONS(2869),
    [sym__dedent] = ACTIONS(2869),
  },
  [1627] = {
    [sym_block_comment] = STATE(1627),
    [sym_compiler_directive_decl] = STATE(1627),
    [sym_fsi_directive_decl] = STATE(1627),
    [sym_preproc_line] = STATE(1627),
    [sym_identifier] = ACTIONS(2942),
    [anon_sym_EQ] = ACTIONS(2944),
    [anon_sym_COLON] = ACTIONS(2942),
    [anon_sym_return] = ACTIONS(2942),
    [anon_sym_do] = ACTIONS(2942),
    [anon_sym_let] = ACTIONS(2942),
    [anon_sym_let_BANG] = ACTIONS(2944),
    [anon_sym_as] = ACTIONS(2942),
    [anon_sym_LPAREN] = ACTIONS(2942),
    [anon_sym_COMMA] = ACTIONS(2944),
    [anon_sym_null] = ACTIONS(2942),
    [anon_sym_QMARK] = ACTIONS(2942),
    [anon_sym_COLON_QMARK] = ACTIONS(2942),
    [anon_sym_COLON_COLON] = ACTIONS(2944),
    [anon_sym_AMP] = ACTIONS(2942),
    [anon_sym_LBRACK] = ACTIONS(2942),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2944),
    [anon_sym_LBRACE] = ACTIONS(2942),
    [anon_sym_LT_AT] = ACTIONS(2942),
    [anon_sym_LT_AT_AT] = ACTIONS(2942),
    [anon_sym_DOT] = ACTIONS(2942),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2944),
    [anon_sym_new] = ACTIONS(2942),
    [anon_sym_with] = ACTIONS(2942),
    [anon_sym_return_BANG] = ACTIONS(2944),
    [anon_sym_yield] = ACTIONS(2942),
    [anon_sym_yield_BANG] = ACTIONS(2944),
    [anon_sym_lazy] = ACTIONS(2942),
    [anon_sym_assert] = ACTIONS(2942),
    [anon_sym_upcast] = ACTIONS(2942),
    [anon_sym_downcast] = ACTIONS(2942),
    [anon_sym_COLON_GT] = ACTIONS(2944),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2944),
    [anon_sym_for] = ACTIONS(2942),
    [anon_sym_while] = ACTIONS(2942),
    [anon_sym_if] = ACTIONS(2942),
    [anon_sym_fun] = ACTIONS(2942),
    [anon_sym_try] = ACTIONS(2942),
    [anon_sym_match] = ACTIONS(2942),
    [anon_sym_match_BANG] = ACTIONS(2944),
    [anon_sym_function] = ACTIONS(2942),
    [anon_sym_LT_DASH] = ACTIONS(2942),
    [anon_sym_DOT_LBRACK] = ACTIONS(2944),
    [anon_sym_LT] = ACTIONS(2944),
    [anon_sym_use] = ACTIONS(2942),
    [anon_sym_use_BANG] = ACTIONS(2944),
    [anon_sym_do_BANG] = ACTIONS(2944),
    [anon_sym_begin] = ACTIONS(2942),
    [anon_sym_LPAREN2] = ACTIONS(2942),
    [anon_sym_or] = ACTIONS(2942),
    [aux_sym_char_token1] = ACTIONS(2944),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2942),
    [anon_sym_DQUOTE] = ACTIONS(2942),
    [anon_sym_AT_DQUOTE] = ACTIONS(2944),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2944),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2944),
    [sym_bool] = ACTIONS(2942),
    [sym_unit] = ACTIONS(2944),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2942),
    [sym_op_identifier] = ACTIONS(2942),
    [anon_sym_PLUS] = ACTIONS(2942),
    [anon_sym_DASH] = ACTIONS(2942),
    [anon_sym_PLUS_DOT] = ACTIONS(2942),
    [anon_sym_DASH_DOT] = ACTIONS(2942),
    [anon_sym_PERCENT] = ACTIONS(2942),
    [anon_sym_AMP_AMP] = ACTIONS(2942),
    [anon_sym_TILDE] = ACTIONS(2944),
    [aux_sym_prefix_op_token1] = ACTIONS(2942),
    [aux_sym_infix_op_token1] = ACTIONS(2944),
    [aux_sym_infix_op_token2] = ACTIONS(2942),
    [anon_sym_PIPE_PIPE] = ACTIONS(2942),
    [anon_sym_BANG_EQ] = ACTIONS(2942),
    [anon_sym_COLON_EQ] = ACTIONS(2944),
    [anon_sym_DOLLAR] = ACTIONS(2942),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2942),
    [sym_int] = ACTIONS(2942),
    [sym_xint] = ACTIONS(2944),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2944),
    [sym__newline] = ACTIONS(2944),
    [sym__dedent] = ACTIONS(2944),
  },
  [1628] = {
    [sym_block_comment] = STATE(1628),
    [sym_compiler_directive_decl] = STATE(1628),
    [sym_fsi_directive_decl] = STATE(1628),
    [sym_preproc_line] = STATE(1628),
    [sym_identifier] = ACTIONS(2962),
    [anon_sym_EQ] = ACTIONS(2964),
    [anon_sym_COLON] = ACTIONS(2962),
    [anon_sym_return] = ACTIONS(2962),
    [anon_sym_do] = ACTIONS(2962),
    [anon_sym_let] = ACTIONS(2962),
    [anon_sym_let_BANG] = ACTIONS(2964),
    [anon_sym_as] = ACTIONS(2962),
    [anon_sym_LPAREN] = ACTIONS(2962),
    [anon_sym_COMMA] = ACTIONS(2964),
    [anon_sym_null] = ACTIONS(2962),
    [anon_sym_QMARK] = ACTIONS(2962),
    [anon_sym_COLON_QMARK] = ACTIONS(2962),
    [anon_sym_COLON_COLON] = ACTIONS(2964),
    [anon_sym_AMP] = ACTIONS(2962),
    [anon_sym_LBRACK] = ACTIONS(2962),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2964),
    [anon_sym_LBRACE] = ACTIONS(2962),
    [anon_sym_LT_AT] = ACTIONS(2962),
    [anon_sym_LT_AT_AT] = ACTIONS(2962),
    [anon_sym_DOT] = ACTIONS(2962),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2964),
    [anon_sym_new] = ACTIONS(2962),
    [anon_sym_with] = ACTIONS(2962),
    [anon_sym_return_BANG] = ACTIONS(2964),
    [anon_sym_yield] = ACTIONS(2962),
    [anon_sym_yield_BANG] = ACTIONS(2964),
    [anon_sym_lazy] = ACTIONS(2962),
    [anon_sym_assert] = ACTIONS(2962),
    [anon_sym_upcast] = ACTIONS(2962),
    [anon_sym_downcast] = ACTIONS(2962),
    [anon_sym_COLON_GT] = ACTIONS(2964),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2964),
    [anon_sym_for] = ACTIONS(2962),
    [anon_sym_while] = ACTIONS(2962),
    [anon_sym_if] = ACTIONS(2962),
    [anon_sym_fun] = ACTIONS(2962),
    [anon_sym_try] = ACTIONS(2962),
    [anon_sym_match] = ACTIONS(2962),
    [anon_sym_match_BANG] = ACTIONS(2964),
    [anon_sym_function] = ACTIONS(2962),
    [anon_sym_LT_DASH] = ACTIONS(2962),
    [anon_sym_DOT_LBRACK] = ACTIONS(2964),
    [anon_sym_LT] = ACTIONS(2964),
    [anon_sym_use] = ACTIONS(2962),
    [anon_sym_use_BANG] = ACTIONS(2964),
    [anon_sym_do_BANG] = ACTIONS(2964),
    [anon_sym_begin] = ACTIONS(2962),
    [anon_sym_LPAREN2] = ACTIONS(2962),
    [anon_sym_or] = ACTIONS(2962),
    [aux_sym_char_token1] = ACTIONS(2964),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2962),
    [anon_sym_DQUOTE] = ACTIONS(2962),
    [anon_sym_AT_DQUOTE] = ACTIONS(2964),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2964),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2964),
    [sym_bool] = ACTIONS(2962),
    [sym_unit] = ACTIONS(2964),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2962),
    [sym_op_identifier] = ACTIONS(2962),
    [anon_sym_PLUS] = ACTIONS(2962),
    [anon_sym_DASH] = ACTIONS(2962),
    [anon_sym_PLUS_DOT] = ACTIONS(2962),
    [anon_sym_DASH_DOT] = ACTIONS(2962),
    [anon_sym_PERCENT] = ACTIONS(2962),
    [anon_sym_AMP_AMP] = ACTIONS(2962),
    [anon_sym_TILDE] = ACTIONS(2964),
    [aux_sym_prefix_op_token1] = ACTIONS(2962),
    [aux_sym_infix_op_token1] = ACTIONS(2964),
    [aux_sym_infix_op_token2] = ACTIONS(2962),
    [anon_sym_PIPE_PIPE] = ACTIONS(2962),
    [anon_sym_BANG_EQ] = ACTIONS(2962),
    [anon_sym_COLON_EQ] = ACTIONS(2964),
    [anon_sym_DOLLAR] = ACTIONS(2962),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2962),
    [sym_int] = ACTIONS(2962),
    [sym_xint] = ACTIONS(2964),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2964),
    [sym__newline] = ACTIONS(2964),
    [sym__dedent] = ACTIONS(2964),
  },
  [1629] = {
    [sym_block_comment] = STATE(1629),
    [sym_compiler_directive_decl] = STATE(1629),
    [sym_fsi_directive_decl] = STATE(1629),
    [sym_preproc_line] = STATE(1629),
    [sym_identifier] = ACTIONS(2685),
    [anon_sym_EQ] = ACTIONS(2687),
    [anon_sym_COLON] = ACTIONS(2685),
    [anon_sym_return] = ACTIONS(2685),
    [anon_sym_do] = ACTIONS(2685),
    [anon_sym_let] = ACTIONS(2685),
    [anon_sym_let_BANG] = ACTIONS(2687),
    [anon_sym_LPAREN] = ACTIONS(2685),
    [anon_sym_COMMA] = ACTIONS(2687),
    [anon_sym_null] = ACTIONS(2685),
    [anon_sym_QMARK] = ACTIONS(2685),
    [anon_sym_COLON_QMARK] = ACTIONS(2685),
    [anon_sym_COLON_COLON] = ACTIONS(2687),
    [anon_sym_AMP] = ACTIONS(2685),
    [anon_sym_LBRACK] = ACTIONS(2685),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2687),
    [anon_sym_LBRACE] = ACTIONS(2685),
    [anon_sym_LT_AT] = ACTIONS(2685),
    [anon_sym_LT_AT_AT] = ACTIONS(2685),
    [anon_sym_AT_AT_GT] = ACTIONS(2685),
    [anon_sym_DOT] = ACTIONS(2685),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2687),
    [anon_sym_new] = ACTIONS(2685),
    [anon_sym_return_BANG] = ACTIONS(2687),
    [anon_sym_yield] = ACTIONS(2685),
    [anon_sym_yield_BANG] = ACTIONS(2687),
    [anon_sym_lazy] = ACTIONS(2685),
    [anon_sym_assert] = ACTIONS(2685),
    [anon_sym_upcast] = ACTIONS(2685),
    [anon_sym_downcast] = ACTIONS(2685),
    [anon_sym_COLON_GT] = ACTIONS(2687),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2687),
    [anon_sym_for] = ACTIONS(2685),
    [anon_sym_while] = ACTIONS(2685),
    [anon_sym_else] = ACTIONS(2685),
    [anon_sym_elif] = ACTIONS(2685),
    [anon_sym_if] = ACTIONS(2685),
    [anon_sym_fun] = ACTIONS(2685),
    [anon_sym_try] = ACTIONS(2685),
    [anon_sym_match] = ACTIONS(2685),
    [anon_sym_match_BANG] = ACTIONS(2687),
    [anon_sym_function] = ACTIONS(2685),
    [anon_sym_LT_DASH] = ACTIONS(2685),
    [anon_sym_DOT_LBRACK] = ACTIONS(2687),
    [anon_sym_LT] = ACTIONS(2687),
    [anon_sym_use] = ACTIONS(2685),
    [anon_sym_use_BANG] = ACTIONS(2687),
    [anon_sym_do_BANG] = ACTIONS(2687),
    [anon_sym_begin] = ACTIONS(2685),
    [anon_sym_LPAREN2] = ACTIONS(2685),
    [anon_sym_or] = ACTIONS(2685),
    [aux_sym_char_token1] = ACTIONS(2687),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2685),
    [anon_sym_DQUOTE] = ACTIONS(2685),
    [anon_sym_AT_DQUOTE] = ACTIONS(2687),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2687),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2687),
    [sym_bool] = ACTIONS(2685),
    [sym_unit] = ACTIONS(2687),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2685),
    [sym_op_identifier] = ACTIONS(2685),
    [anon_sym_PLUS] = ACTIONS(2685),
    [anon_sym_DASH] = ACTIONS(2685),
    [anon_sym_PLUS_DOT] = ACTIONS(2685),
    [anon_sym_DASH_DOT] = ACTIONS(2685),
    [anon_sym_PERCENT] = ACTIONS(2685),
    [anon_sym_AMP_AMP] = ACTIONS(2685),
    [anon_sym_TILDE] = ACTIONS(2687),
    [aux_sym_prefix_op_token1] = ACTIONS(2685),
    [aux_sym_infix_op_token1] = ACTIONS(2687),
    [aux_sym_infix_op_token2] = ACTIONS(2685),
    [anon_sym_PIPE_PIPE] = ACTIONS(2685),
    [anon_sym_BANG_EQ] = ACTIONS(2685),
    [anon_sym_COLON_EQ] = ACTIONS(2687),
    [anon_sym_DOLLAR] = ACTIONS(2685),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2685),
    [sym_int] = ACTIONS(2685),
    [sym_xint] = ACTIONS(2687),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2687),
    [sym__newline] = ACTIONS(2687),
  },
  [1630] = {
    [sym_block_comment] = STATE(1630),
    [sym_compiler_directive_decl] = STATE(1630),
    [sym_fsi_directive_decl] = STATE(1630),
    [sym_preproc_line] = STATE(1630),
    [sym_identifier] = ACTIONS(2770),
    [anon_sym_EQ] = ACTIONS(2772),
    [anon_sym_COLON] = ACTIONS(2770),
    [anon_sym_return] = ACTIONS(2770),
    [anon_sym_do] = ACTIONS(2770),
    [anon_sym_and] = ACTIONS(2770),
    [anon_sym_let] = ACTIONS(2770),
    [anon_sym_let_BANG] = ACTIONS(2772),
    [anon_sym_LPAREN] = ACTIONS(2770),
    [anon_sym_COMMA] = ACTIONS(2772),
    [anon_sym_null] = ACTIONS(2770),
    [anon_sym_QMARK] = ACTIONS(2770),
    [anon_sym_COLON_QMARK] = ACTIONS(2770),
    [anon_sym_COLON_COLON] = ACTIONS(2772),
    [anon_sym_AMP] = ACTIONS(2770),
    [anon_sym_LBRACK] = ACTIONS(2770),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2772),
    [anon_sym_LBRACE] = ACTIONS(2770),
    [anon_sym_LT_AT] = ACTIONS(2770),
    [anon_sym_LT_AT_AT] = ACTIONS(2770),
    [anon_sym_DOT] = ACTIONS(2770),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2772),
    [anon_sym_new] = ACTIONS(2770),
    [anon_sym_return_BANG] = ACTIONS(2772),
    [anon_sym_yield] = ACTIONS(2770),
    [anon_sym_yield_BANG] = ACTIONS(2772),
    [anon_sym_lazy] = ACTIONS(2770),
    [anon_sym_assert] = ACTIONS(2770),
    [anon_sym_upcast] = ACTIONS(2770),
    [anon_sym_downcast] = ACTIONS(2770),
    [anon_sym_COLON_GT] = ACTIONS(2772),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2772),
    [anon_sym_for] = ACTIONS(2770),
    [anon_sym_done] = ACTIONS(3847),
    [anon_sym_while] = ACTIONS(2770),
    [anon_sym_if] = ACTIONS(2770),
    [anon_sym_fun] = ACTIONS(2770),
    [anon_sym_try] = ACTIONS(2770),
    [anon_sym_match] = ACTIONS(2770),
    [anon_sym_match_BANG] = ACTIONS(2772),
    [anon_sym_function] = ACTIONS(2770),
    [anon_sym_LT_DASH] = ACTIONS(2770),
    [anon_sym_DOT_LBRACK] = ACTIONS(2772),
    [anon_sym_LT] = ACTIONS(2772),
    [anon_sym_use] = ACTIONS(2770),
    [anon_sym_use_BANG] = ACTIONS(2772),
    [anon_sym_do_BANG] = ACTIONS(2772),
    [anon_sym_begin] = ACTIONS(2770),
    [anon_sym_LPAREN2] = ACTIONS(2770),
    [anon_sym_or] = ACTIONS(2770),
    [aux_sym_char_token1] = ACTIONS(2772),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2770),
    [anon_sym_DQUOTE] = ACTIONS(2770),
    [anon_sym_AT_DQUOTE] = ACTIONS(2772),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2772),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2772),
    [sym_bool] = ACTIONS(2770),
    [sym_unit] = ACTIONS(2772),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2770),
    [sym_op_identifier] = ACTIONS(2770),
    [anon_sym_PLUS] = ACTIONS(2770),
    [anon_sym_DASH] = ACTIONS(2770),
    [anon_sym_PLUS_DOT] = ACTIONS(2770),
    [anon_sym_DASH_DOT] = ACTIONS(2770),
    [anon_sym_PERCENT] = ACTIONS(2770),
    [anon_sym_AMP_AMP] = ACTIONS(2770),
    [anon_sym_TILDE] = ACTIONS(2772),
    [aux_sym_prefix_op_token1] = ACTIONS(2770),
    [aux_sym_infix_op_token1] = ACTIONS(2772),
    [aux_sym_infix_op_token2] = ACTIONS(2770),
    [anon_sym_PIPE_PIPE] = ACTIONS(2770),
    [anon_sym_BANG_EQ] = ACTIONS(2770),
    [anon_sym_COLON_EQ] = ACTIONS(2772),
    [anon_sym_DOLLAR] = ACTIONS(2770),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2770),
    [sym_int] = ACTIONS(2770),
    [sym_xint] = ACTIONS(2772),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2772),
    [sym__newline] = ACTIONS(2772),
    [sym__dedent] = ACTIONS(2772),
  },
  [1631] = {
    [sym_attributes] = STATE(2698),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(3506),
    [sym__pattern] = STATE(3347),
    [sym_optional_pattern] = STATE(3506),
    [sym_type_check_pattern] = STATE(3506),
    [sym_attribute_pattern] = STATE(3506),
    [sym_paren_pattern] = STATE(3506),
    [sym_as_pattern] = STATE(3506),
    [sym_cons_pattern] = STATE(3506),
    [sym_disjunct_pattern] = STATE(3506),
    [sym_conjunct_pattern] = STATE(3506),
    [sym_typed_pattern] = STATE(3506),
    [sym_list_pattern] = STATE(3506),
    [sym_array_pattern] = STATE(3506),
    [sym_record_pattern] = STATE(3506),
    [sym_named_field_pattern] = STATE(3506),
    [sym_identifier_pattern] = STATE(3506),
    [sym_long_identifier_or_op] = STATE(1864),
    [sym_char] = STATE(3497),
    [sym_format_string] = STATE(3495),
    [sym__string_literal] = STATE(3495),
    [sym_string] = STATE(3497),
    [sym_verbatim_string] = STATE(3497),
    [sym_bytearray] = STATE(3497),
    [sym_verbatim_bytearray] = STATE(3497),
    [sym_format_triple_quoted_string] = STATE(3494),
    [sym_triple_quoted_string] = STATE(3497),
    [sym_const] = STATE(3506),
    [sym_long_identifier] = STATE(3363),
    [sym_active_pattern] = STATE(3521),
    [sym__identifier_or_op] = STATE(3510),
    [sym_sbyte] = STATE(3497),
    [sym_byte] = STATE(3497),
    [sym_int16] = STATE(3497),
    [sym_uint16] = STATE(3497),
    [sym_int32] = STATE(3497),
    [sym_uint32] = STATE(3497),
    [sym_nativeint] = STATE(3497),
    [sym_unativeint] = STATE(3497),
    [sym_int64] = STATE(3497),
    [sym_uint64] = STATE(3497),
    [sym_ieee32] = STATE(3497),
    [sym_ieee64] = STATE(3497),
    [sym_bignum] = STATE(3497),
    [sym_decimal] = STATE(3497),
    [sym_float] = STATE(3305),
    [sym_block_comment] = STATE(1631),
    [sym_compiler_directive_decl] = STATE(1631),
    [sym_fsi_directive_decl] = STATE(1631),
    [sym_preproc_line] = STATE(1631),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [aux_sym_repeat_pattern_repeat1] = STATE(3362),
    [sym_identifier] = ACTIONS(3716),
    [anon_sym_LBRACK_LT] = ACTIONS(3714),
    [anon_sym_COLON] = ACTIONS(3716),
    [anon_sym_as] = ACTIONS(3849),
    [anon_sym_LPAREN] = ACTIONS(3716),
    [anon_sym_RPAREN] = ACTIONS(3714),
    [anon_sym_COMMA] = ACTIONS(3851),
    [anon_sym_null] = ACTIONS(3716),
    [anon_sym__] = ACTIONS(3716),
    [anon_sym_QMARK] = ACTIONS(3714),
    [anon_sym_COLON_QMARK] = ACTIONS(3714),
    [anon_sym_COLON_COLON] = ACTIONS(3853),
    [anon_sym_PIPE] = ACTIONS(3855),
    [anon_sym_AMP] = ACTIONS(3857),
    [anon_sym_LBRACK] = ACTIONS(3716),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3714),
    [anon_sym_LBRACE] = ACTIONS(3714),
    [anon_sym_RBRACE] = ACTIONS(3714),
    [aux_sym_char_token1] = ACTIONS(3714),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3716),
    [anon_sym_DQUOTE] = ACTIONS(3716),
    [anon_sym_AT_DQUOTE] = ACTIONS(3714),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3714),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3714),
    [sym_bool] = ACTIONS(3716),
    [sym_unit] = ACTIONS(3714),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3716),
    [sym_op_identifier] = ACTIONS(3714),
    [sym_int] = ACTIONS(3716),
    [sym_xint] = ACTIONS(3714),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [sym__newline] = ACTIONS(3714),
  },
  [1632] = {
    [sym_block_comment] = STATE(1632),
    [sym_compiler_directive_decl] = STATE(1632),
    [sym_fsi_directive_decl] = STATE(1632),
    [sym_preproc_line] = STATE(1632),
    [aux_sym_sequential_expression_repeat1] = STATE(1632),
    [sym_identifier] = ACTIONS(2895),
    [anon_sym_EQ] = ACTIONS(2897),
    [anon_sym_COLON] = ACTIONS(2895),
    [anon_sym_return] = ACTIONS(2895),
    [anon_sym_do] = ACTIONS(2895),
    [anon_sym_let] = ACTIONS(2895),
    [anon_sym_let_BANG] = ACTIONS(2897),
    [anon_sym_LPAREN] = ACTIONS(2895),
    [anon_sym_COMMA] = ACTIONS(2897),
    [anon_sym_null] = ACTIONS(2895),
    [anon_sym_QMARK] = ACTIONS(2895),
    [anon_sym_COLON_QMARK] = ACTIONS(2895),
    [anon_sym_COLON_COLON] = ACTIONS(2897),
    [anon_sym_AMP] = ACTIONS(2895),
    [anon_sym_LBRACK] = ACTIONS(2895),
    [anon_sym_RBRACK] = ACTIONS(2897),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2897),
    [anon_sym_LBRACE] = ACTIONS(2895),
    [anon_sym_LT_AT] = ACTIONS(2895),
    [anon_sym_LT_AT_AT] = ACTIONS(2895),
    [anon_sym_DOT] = ACTIONS(2895),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2897),
    [anon_sym_new] = ACTIONS(2895),
    [anon_sym_return_BANG] = ACTIONS(2897),
    [anon_sym_yield] = ACTIONS(2895),
    [anon_sym_yield_BANG] = ACTIONS(2897),
    [anon_sym_lazy] = ACTIONS(2895),
    [anon_sym_assert] = ACTIONS(2895),
    [anon_sym_upcast] = ACTIONS(2895),
    [anon_sym_downcast] = ACTIONS(2895),
    [anon_sym_COLON_GT] = ACTIONS(2897),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2897),
    [anon_sym_for] = ACTIONS(2895),
    [anon_sym_while] = ACTIONS(2895),
    [anon_sym_if] = ACTIONS(2895),
    [anon_sym_fun] = ACTIONS(2895),
    [anon_sym_try] = ACTIONS(2895),
    [anon_sym_match] = ACTIONS(2895),
    [anon_sym_match_BANG] = ACTIONS(2897),
    [anon_sym_function] = ACTIONS(2895),
    [anon_sym_LT_DASH] = ACTIONS(2895),
    [anon_sym_DOT_LBRACK] = ACTIONS(2897),
    [anon_sym_LT] = ACTIONS(2897),
    [anon_sym_use] = ACTIONS(2895),
    [anon_sym_use_BANG] = ACTIONS(2897),
    [anon_sym_do_BANG] = ACTIONS(2897),
    [anon_sym_begin] = ACTIONS(2895),
    [anon_sym_LPAREN2] = ACTIONS(2895),
    [anon_sym_DOT_DOT2] = ACTIONS(2897),
    [anon_sym_or] = ACTIONS(2895),
    [aux_sym_char_token1] = ACTIONS(2897),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2895),
    [anon_sym_DQUOTE] = ACTIONS(2895),
    [anon_sym_AT_DQUOTE] = ACTIONS(2897),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2897),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2897),
    [sym_bool] = ACTIONS(2895),
    [sym_unit] = ACTIONS(2897),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2895),
    [sym_op_identifier] = ACTIONS(2895),
    [anon_sym_PLUS] = ACTIONS(2895),
    [anon_sym_DASH] = ACTIONS(2895),
    [anon_sym_PLUS_DOT] = ACTIONS(2895),
    [anon_sym_DASH_DOT] = ACTIONS(2895),
    [anon_sym_PERCENT] = ACTIONS(2895),
    [anon_sym_AMP_AMP] = ACTIONS(2895),
    [anon_sym_TILDE] = ACTIONS(2897),
    [aux_sym_prefix_op_token1] = ACTIONS(2895),
    [aux_sym_infix_op_token1] = ACTIONS(2897),
    [aux_sym_infix_op_token2] = ACTIONS(2895),
    [anon_sym_PIPE_PIPE] = ACTIONS(2895),
    [anon_sym_BANG_EQ] = ACTIONS(2895),
    [anon_sym_COLON_EQ] = ACTIONS(2897),
    [anon_sym_DOLLAR] = ACTIONS(2895),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2895),
    [sym_int] = ACTIONS(2895),
    [sym_xint] = ACTIONS(2897),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2897),
    [sym__newline] = ACTIONS(3859),
  },
  [1633] = {
    [sym_block_comment] = STATE(1633),
    [sym_compiler_directive_decl] = STATE(1633),
    [sym_fsi_directive_decl] = STATE(1633),
    [sym_preproc_line] = STATE(1633),
    [sym_identifier] = ACTIONS(2966),
    [anon_sym_EQ] = ACTIONS(2968),
    [anon_sym_COLON] = ACTIONS(2966),
    [anon_sym_return] = ACTIONS(2966),
    [anon_sym_do] = ACTIONS(2966),
    [anon_sym_let] = ACTIONS(2966),
    [anon_sym_let_BANG] = ACTIONS(2968),
    [anon_sym_as] = ACTIONS(2966),
    [anon_sym_LPAREN] = ACTIONS(2966),
    [anon_sym_COMMA] = ACTIONS(2968),
    [anon_sym_null] = ACTIONS(2966),
    [anon_sym_QMARK] = ACTIONS(2966),
    [anon_sym_COLON_QMARK] = ACTIONS(2966),
    [anon_sym_COLON_COLON] = ACTIONS(2968),
    [anon_sym_AMP] = ACTIONS(2966),
    [anon_sym_LBRACK] = ACTIONS(2966),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2968),
    [anon_sym_LBRACE] = ACTIONS(2966),
    [anon_sym_LT_AT] = ACTIONS(2966),
    [anon_sym_LT_AT_AT] = ACTIONS(2966),
    [anon_sym_DOT] = ACTIONS(2966),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2968),
    [anon_sym_new] = ACTIONS(2966),
    [anon_sym_with] = ACTIONS(2966),
    [anon_sym_return_BANG] = ACTIONS(2968),
    [anon_sym_yield] = ACTIONS(2966),
    [anon_sym_yield_BANG] = ACTIONS(2968),
    [anon_sym_lazy] = ACTIONS(2966),
    [anon_sym_assert] = ACTIONS(2966),
    [anon_sym_upcast] = ACTIONS(2966),
    [anon_sym_downcast] = ACTIONS(2966),
    [anon_sym_COLON_GT] = ACTIONS(2968),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2968),
    [anon_sym_for] = ACTIONS(2966),
    [anon_sym_while] = ACTIONS(2966),
    [anon_sym_if] = ACTIONS(2966),
    [anon_sym_fun] = ACTIONS(2966),
    [anon_sym_try] = ACTIONS(2966),
    [anon_sym_match] = ACTIONS(2966),
    [anon_sym_match_BANG] = ACTIONS(2968),
    [anon_sym_function] = ACTIONS(2966),
    [anon_sym_LT_DASH] = ACTIONS(2966),
    [anon_sym_DOT_LBRACK] = ACTIONS(2968),
    [anon_sym_LT] = ACTIONS(2968),
    [anon_sym_use] = ACTIONS(2966),
    [anon_sym_use_BANG] = ACTIONS(2968),
    [anon_sym_do_BANG] = ACTIONS(2968),
    [anon_sym_begin] = ACTIONS(2966),
    [anon_sym_LPAREN2] = ACTIONS(2966),
    [anon_sym_or] = ACTIONS(2966),
    [aux_sym_char_token1] = ACTIONS(2968),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2966),
    [anon_sym_DQUOTE] = ACTIONS(2966),
    [anon_sym_AT_DQUOTE] = ACTIONS(2968),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2968),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2968),
    [sym_bool] = ACTIONS(2966),
    [sym_unit] = ACTIONS(2968),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2966),
    [sym_op_identifier] = ACTIONS(2966),
    [anon_sym_PLUS] = ACTIONS(2966),
    [anon_sym_DASH] = ACTIONS(2966),
    [anon_sym_PLUS_DOT] = ACTIONS(2966),
    [anon_sym_DASH_DOT] = ACTIONS(2966),
    [anon_sym_PERCENT] = ACTIONS(2966),
    [anon_sym_AMP_AMP] = ACTIONS(2966),
    [anon_sym_TILDE] = ACTIONS(2968),
    [aux_sym_prefix_op_token1] = ACTIONS(2966),
    [aux_sym_infix_op_token1] = ACTIONS(2968),
    [aux_sym_infix_op_token2] = ACTIONS(2966),
    [anon_sym_PIPE_PIPE] = ACTIONS(2966),
    [anon_sym_BANG_EQ] = ACTIONS(2966),
    [anon_sym_COLON_EQ] = ACTIONS(2968),
    [anon_sym_DOLLAR] = ACTIONS(2966),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2966),
    [sym_int] = ACTIONS(2966),
    [sym_xint] = ACTIONS(2968),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2968),
    [sym__newline] = ACTIONS(2968),
    [sym__dedent] = ACTIONS(2968),
  },
  [1634] = {
    [sym_block_comment] = STATE(1634),
    [sym_compiler_directive_decl] = STATE(1634),
    [sym_fsi_directive_decl] = STATE(1634),
    [sym_preproc_line] = STATE(1634),
    [sym_identifier] = ACTIONS(2974),
    [anon_sym_EQ] = ACTIONS(2976),
    [anon_sym_COLON] = ACTIONS(2974),
    [anon_sym_return] = ACTIONS(2974),
    [anon_sym_do] = ACTIONS(2974),
    [anon_sym_let] = ACTIONS(2974),
    [anon_sym_let_BANG] = ACTIONS(2976),
    [anon_sym_as] = ACTIONS(2974),
    [anon_sym_LPAREN] = ACTIONS(2974),
    [anon_sym_COMMA] = ACTIONS(2976),
    [anon_sym_null] = ACTIONS(2974),
    [anon_sym_QMARK] = ACTIONS(2974),
    [anon_sym_COLON_QMARK] = ACTIONS(2974),
    [anon_sym_COLON_COLON] = ACTIONS(2976),
    [anon_sym_AMP] = ACTIONS(2974),
    [anon_sym_LBRACK] = ACTIONS(2974),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2976),
    [anon_sym_LBRACE] = ACTIONS(2974),
    [anon_sym_LT_AT] = ACTIONS(2974),
    [anon_sym_LT_AT_AT] = ACTIONS(2974),
    [anon_sym_DOT] = ACTIONS(2974),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2976),
    [anon_sym_new] = ACTIONS(2974),
    [anon_sym_with] = ACTIONS(2974),
    [anon_sym_return_BANG] = ACTIONS(2976),
    [anon_sym_yield] = ACTIONS(2974),
    [anon_sym_yield_BANG] = ACTIONS(2976),
    [anon_sym_lazy] = ACTIONS(2974),
    [anon_sym_assert] = ACTIONS(2974),
    [anon_sym_upcast] = ACTIONS(2974),
    [anon_sym_downcast] = ACTIONS(2974),
    [anon_sym_COLON_GT] = ACTIONS(2976),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2976),
    [anon_sym_for] = ACTIONS(2974),
    [anon_sym_while] = ACTIONS(2974),
    [anon_sym_if] = ACTIONS(2974),
    [anon_sym_fun] = ACTIONS(2974),
    [anon_sym_try] = ACTIONS(2974),
    [anon_sym_match] = ACTIONS(2974),
    [anon_sym_match_BANG] = ACTIONS(2976),
    [anon_sym_function] = ACTIONS(2974),
    [anon_sym_LT_DASH] = ACTIONS(2974),
    [anon_sym_DOT_LBRACK] = ACTIONS(2976),
    [anon_sym_LT] = ACTIONS(2976),
    [anon_sym_use] = ACTIONS(2974),
    [anon_sym_use_BANG] = ACTIONS(2976),
    [anon_sym_do_BANG] = ACTIONS(2976),
    [anon_sym_begin] = ACTIONS(2974),
    [anon_sym_LPAREN2] = ACTIONS(2974),
    [anon_sym_or] = ACTIONS(2974),
    [aux_sym_char_token1] = ACTIONS(2976),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2974),
    [anon_sym_DQUOTE] = ACTIONS(2974),
    [anon_sym_AT_DQUOTE] = ACTIONS(2976),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2976),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2976),
    [sym_bool] = ACTIONS(2974),
    [sym_unit] = ACTIONS(2976),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2974),
    [sym_op_identifier] = ACTIONS(2974),
    [anon_sym_PLUS] = ACTIONS(2974),
    [anon_sym_DASH] = ACTIONS(2974),
    [anon_sym_PLUS_DOT] = ACTIONS(2974),
    [anon_sym_DASH_DOT] = ACTIONS(2974),
    [anon_sym_PERCENT] = ACTIONS(2974),
    [anon_sym_AMP_AMP] = ACTIONS(2974),
    [anon_sym_TILDE] = ACTIONS(2976),
    [aux_sym_prefix_op_token1] = ACTIONS(2974),
    [aux_sym_infix_op_token1] = ACTIONS(2976),
    [aux_sym_infix_op_token2] = ACTIONS(2974),
    [anon_sym_PIPE_PIPE] = ACTIONS(2974),
    [anon_sym_BANG_EQ] = ACTIONS(2974),
    [anon_sym_COLON_EQ] = ACTIONS(2976),
    [anon_sym_DOLLAR] = ACTIONS(2974),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2974),
    [sym_int] = ACTIONS(2974),
    [sym_xint] = ACTIONS(2976),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2976),
    [sym__newline] = ACTIONS(2976),
    [sym__dedent] = ACTIONS(2976),
  },
  [1635] = {
    [sym_block_comment] = STATE(1635),
    [sym_compiler_directive_decl] = STATE(1635),
    [sym_fsi_directive_decl] = STATE(1635),
    [sym_preproc_line] = STATE(1635),
    [aux_sym_sequential_expression_repeat1] = STATE(1486),
    [sym_identifier] = ACTIONS(2847),
    [anon_sym_EQ] = ACTIONS(2849),
    [anon_sym_COLON] = ACTIONS(2847),
    [anon_sym_return] = ACTIONS(2847),
    [anon_sym_do] = ACTIONS(2847),
    [anon_sym_let] = ACTIONS(2847),
    [anon_sym_let_BANG] = ACTIONS(2849),
    [anon_sym_LPAREN] = ACTIONS(2847),
    [anon_sym_COMMA] = ACTIONS(2849),
    [anon_sym_null] = ACTIONS(2847),
    [anon_sym_QMARK] = ACTIONS(2847),
    [anon_sym_COLON_QMARK] = ACTIONS(2847),
    [anon_sym_COLON_COLON] = ACTIONS(2849),
    [anon_sym_AMP] = ACTIONS(2847),
    [anon_sym_LBRACK] = ACTIONS(2847),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2849),
    [anon_sym_LBRACE] = ACTIONS(2847),
    [anon_sym_LT_AT] = ACTIONS(2847),
    [anon_sym_LT_AT_AT] = ACTIONS(2847),
    [anon_sym_DOT] = ACTIONS(2847),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2849),
    [anon_sym_new] = ACTIONS(2847),
    [anon_sym_return_BANG] = ACTIONS(2849),
    [anon_sym_yield] = ACTIONS(2847),
    [anon_sym_yield_BANG] = ACTIONS(2849),
    [anon_sym_lazy] = ACTIONS(2847),
    [anon_sym_assert] = ACTIONS(2847),
    [anon_sym_upcast] = ACTIONS(2847),
    [anon_sym_downcast] = ACTIONS(2847),
    [anon_sym_COLON_GT] = ACTIONS(2849),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2849),
    [anon_sym_for] = ACTIONS(2847),
    [anon_sym_while] = ACTIONS(2847),
    [anon_sym_if] = ACTIONS(2847),
    [anon_sym_fun] = ACTIONS(2847),
    [anon_sym_try] = ACTIONS(2847),
    [anon_sym_match] = ACTIONS(2847),
    [anon_sym_match_BANG] = ACTIONS(2849),
    [anon_sym_function] = ACTIONS(2847),
    [anon_sym_LT_DASH] = ACTIONS(2847),
    [anon_sym_DOT_LBRACK] = ACTIONS(2849),
    [anon_sym_LT] = ACTIONS(2849),
    [anon_sym_use] = ACTIONS(2847),
    [anon_sym_use_BANG] = ACTIONS(2849),
    [anon_sym_do_BANG] = ACTIONS(2849),
    [anon_sym_begin] = ACTIONS(2847),
    [anon_sym_LPAREN2] = ACTIONS(2847),
    [anon_sym_or] = ACTIONS(2847),
    [aux_sym_char_token1] = ACTIONS(2849),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2847),
    [anon_sym_DQUOTE] = ACTIONS(2847),
    [anon_sym_AT_DQUOTE] = ACTIONS(2849),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2849),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2849),
    [sym_bool] = ACTIONS(2847),
    [sym_unit] = ACTIONS(2849),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2847),
    [sym_op_identifier] = ACTIONS(2847),
    [anon_sym_PLUS] = ACTIONS(2847),
    [anon_sym_DASH] = ACTIONS(2847),
    [anon_sym_PLUS_DOT] = ACTIONS(2847),
    [anon_sym_DASH_DOT] = ACTIONS(2847),
    [anon_sym_PERCENT] = ACTIONS(2847),
    [anon_sym_AMP_AMP] = ACTIONS(2847),
    [anon_sym_TILDE] = ACTIONS(2849),
    [aux_sym_prefix_op_token1] = ACTIONS(2847),
    [aux_sym_infix_op_token1] = ACTIONS(2849),
    [aux_sym_infix_op_token2] = ACTIONS(2847),
    [anon_sym_PIPE_PIPE] = ACTIONS(2847),
    [anon_sym_BANG_EQ] = ACTIONS(2847),
    [anon_sym_COLON_EQ] = ACTIONS(2849),
    [anon_sym_DOLLAR] = ACTIONS(2847),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2847),
    [sym_int] = ACTIONS(2847),
    [sym_xint] = ACTIONS(2849),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2849),
    [anon_sym_POUNDendif] = ACTIONS(2849),
    [anon_sym_POUNDelse] = ACTIONS(2849),
    [sym__newline] = ACTIONS(2849),
  },
  [1636] = {
    [sym_block_comment] = STATE(1636),
    [sym_compiler_directive_decl] = STATE(1636),
    [sym_fsi_directive_decl] = STATE(1636),
    [sym_preproc_line] = STATE(1636),
    [sym_identifier] = ACTIONS(2729),
    [anon_sym_EQ] = ACTIONS(2731),
    [anon_sym_COLON] = ACTIONS(2729),
    [anon_sym_return] = ACTIONS(2729),
    [anon_sym_do] = ACTIONS(2729),
    [anon_sym_let] = ACTIONS(2729),
    [anon_sym_let_BANG] = ACTIONS(2731),
    [anon_sym_LPAREN] = ACTIONS(2729),
    [anon_sym_COMMA] = ACTIONS(2731),
    [anon_sym_null] = ACTIONS(2729),
    [anon_sym_QMARK] = ACTIONS(2729),
    [anon_sym_COLON_QMARK] = ACTIONS(2729),
    [anon_sym_COLON_COLON] = ACTIONS(2731),
    [anon_sym_AMP] = ACTIONS(2729),
    [anon_sym_LBRACK] = ACTIONS(2729),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2731),
    [anon_sym_LBRACE] = ACTIONS(2729),
    [anon_sym_LT_AT] = ACTIONS(2729),
    [anon_sym_LT_AT_AT] = ACTIONS(2729),
    [anon_sym_DOT] = ACTIONS(2729),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2731),
    [anon_sym_new] = ACTIONS(2729),
    [anon_sym_return_BANG] = ACTIONS(2731),
    [anon_sym_yield] = ACTIONS(2729),
    [anon_sym_yield_BANG] = ACTIONS(2731),
    [anon_sym_lazy] = ACTIONS(2729),
    [anon_sym_assert] = ACTIONS(2729),
    [anon_sym_upcast] = ACTIONS(2729),
    [anon_sym_downcast] = ACTIONS(2729),
    [anon_sym_COLON_GT] = ACTIONS(2731),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2731),
    [anon_sym_for] = ACTIONS(2729),
    [anon_sym_while] = ACTIONS(2729),
    [anon_sym_else] = ACTIONS(2729),
    [anon_sym_elif] = ACTIONS(2729),
    [anon_sym_if] = ACTIONS(2729),
    [anon_sym_fun] = ACTIONS(2729),
    [anon_sym_try] = ACTIONS(2729),
    [anon_sym_match] = ACTIONS(2729),
    [anon_sym_match_BANG] = ACTIONS(2731),
    [anon_sym_function] = ACTIONS(2729),
    [anon_sym_LT_DASH] = ACTIONS(2729),
    [anon_sym_DOT_LBRACK] = ACTIONS(2731),
    [anon_sym_LT] = ACTIONS(2731),
    [anon_sym_GT] = ACTIONS(2729),
    [anon_sym_use] = ACTIONS(2729),
    [anon_sym_use_BANG] = ACTIONS(2731),
    [anon_sym_do_BANG] = ACTIONS(2731),
    [anon_sym_begin] = ACTIONS(2729),
    [anon_sym_LPAREN2] = ACTIONS(2729),
    [anon_sym_or] = ACTIONS(2729),
    [aux_sym_char_token1] = ACTIONS(2731),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2729),
    [anon_sym_DQUOTE] = ACTIONS(2729),
    [anon_sym_AT_DQUOTE] = ACTIONS(2731),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2731),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2731),
    [sym_bool] = ACTIONS(2729),
    [sym_unit] = ACTIONS(2731),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2729),
    [sym_op_identifier] = ACTIONS(2729),
    [anon_sym_PLUS] = ACTIONS(2729),
    [anon_sym_DASH] = ACTIONS(2729),
    [anon_sym_PLUS_DOT] = ACTIONS(2729),
    [anon_sym_DASH_DOT] = ACTIONS(2729),
    [anon_sym_PERCENT] = ACTIONS(2729),
    [anon_sym_AMP_AMP] = ACTIONS(2729),
    [anon_sym_TILDE] = ACTIONS(2731),
    [aux_sym_prefix_op_token1] = ACTIONS(2729),
    [aux_sym_infix_op_token1] = ACTIONS(2731),
    [aux_sym_infix_op_token2] = ACTIONS(2729),
    [anon_sym_PIPE_PIPE] = ACTIONS(2729),
    [anon_sym_BANG_EQ] = ACTIONS(2729),
    [anon_sym_COLON_EQ] = ACTIONS(2731),
    [anon_sym_DOLLAR] = ACTIONS(2729),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2729),
    [sym_int] = ACTIONS(2729),
    [sym_xint] = ACTIONS(2731),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2731),
    [sym__newline] = ACTIONS(2731),
  },
  [1637] = {
    [sym_block_comment] = STATE(1637),
    [sym_compiler_directive_decl] = STATE(1637),
    [sym_fsi_directive_decl] = STATE(1637),
    [sym_preproc_line] = STATE(1637),
    [sym_identifier] = ACTIONS(3019),
    [anon_sym_EQ] = ACTIONS(3021),
    [anon_sym_COLON] = ACTIONS(3019),
    [anon_sym_return] = ACTIONS(3019),
    [anon_sym_do] = ACTIONS(3019),
    [anon_sym_let] = ACTIONS(3019),
    [anon_sym_let_BANG] = ACTIONS(3021),
    [anon_sym_as] = ACTIONS(3019),
    [anon_sym_LPAREN] = ACTIONS(3019),
    [anon_sym_COMMA] = ACTIONS(3021),
    [anon_sym_null] = ACTIONS(3019),
    [anon_sym_QMARK] = ACTIONS(3019),
    [anon_sym_COLON_QMARK] = ACTIONS(3019),
    [anon_sym_COLON_COLON] = ACTIONS(3021),
    [anon_sym_AMP] = ACTIONS(3019),
    [anon_sym_LBRACK] = ACTIONS(3019),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3021),
    [anon_sym_LBRACE] = ACTIONS(3019),
    [anon_sym_LT_AT] = ACTIONS(3019),
    [anon_sym_LT_AT_AT] = ACTIONS(3019),
    [anon_sym_DOT] = ACTIONS(3019),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3021),
    [anon_sym_new] = ACTIONS(3019),
    [anon_sym_with] = ACTIONS(3019),
    [anon_sym_return_BANG] = ACTIONS(3021),
    [anon_sym_yield] = ACTIONS(3019),
    [anon_sym_yield_BANG] = ACTIONS(3021),
    [anon_sym_lazy] = ACTIONS(3019),
    [anon_sym_assert] = ACTIONS(3019),
    [anon_sym_upcast] = ACTIONS(3019),
    [anon_sym_downcast] = ACTIONS(3019),
    [anon_sym_COLON_GT] = ACTIONS(3021),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3021),
    [anon_sym_for] = ACTIONS(3019),
    [anon_sym_while] = ACTIONS(3019),
    [anon_sym_if] = ACTIONS(3019),
    [anon_sym_fun] = ACTIONS(3019),
    [anon_sym_try] = ACTIONS(3019),
    [anon_sym_match] = ACTIONS(3019),
    [anon_sym_match_BANG] = ACTIONS(3021),
    [anon_sym_function] = ACTIONS(3019),
    [anon_sym_LT_DASH] = ACTIONS(3019),
    [anon_sym_DOT_LBRACK] = ACTIONS(3021),
    [anon_sym_LT] = ACTIONS(3021),
    [anon_sym_use] = ACTIONS(3019),
    [anon_sym_use_BANG] = ACTIONS(3021),
    [anon_sym_do_BANG] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3019),
    [anon_sym_LPAREN2] = ACTIONS(3019),
    [anon_sym_or] = ACTIONS(3019),
    [aux_sym_char_token1] = ACTIONS(3021),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3019),
    [anon_sym_DQUOTE] = ACTIONS(3019),
    [anon_sym_AT_DQUOTE] = ACTIONS(3021),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3021),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3021),
    [sym_bool] = ACTIONS(3019),
    [sym_unit] = ACTIONS(3021),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3019),
    [sym_op_identifier] = ACTIONS(3019),
    [anon_sym_PLUS] = ACTIONS(3019),
    [anon_sym_DASH] = ACTIONS(3019),
    [anon_sym_PLUS_DOT] = ACTIONS(3019),
    [anon_sym_DASH_DOT] = ACTIONS(3019),
    [anon_sym_PERCENT] = ACTIONS(3019),
    [anon_sym_AMP_AMP] = ACTIONS(3019),
    [anon_sym_TILDE] = ACTIONS(3021),
    [aux_sym_prefix_op_token1] = ACTIONS(3019),
    [aux_sym_infix_op_token1] = ACTIONS(3021),
    [aux_sym_infix_op_token2] = ACTIONS(3019),
    [anon_sym_PIPE_PIPE] = ACTIONS(3019),
    [anon_sym_BANG_EQ] = ACTIONS(3019),
    [anon_sym_COLON_EQ] = ACTIONS(3021),
    [anon_sym_DOLLAR] = ACTIONS(3019),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3019),
    [sym_int] = ACTIONS(3019),
    [sym_xint] = ACTIONS(3021),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3021),
    [sym__newline] = ACTIONS(3021),
    [sym__dedent] = ACTIONS(3021),
  },
  [1638] = {
    [sym_block_comment] = STATE(1638),
    [sym_compiler_directive_decl] = STATE(1638),
    [sym_fsi_directive_decl] = STATE(1638),
    [sym_preproc_line] = STATE(1638),
    [sym_identifier] = ACTIONS(2783),
    [anon_sym_EQ] = ACTIONS(2785),
    [anon_sym_COLON] = ACTIONS(2783),
    [anon_sym_return] = ACTIONS(2783),
    [anon_sym_do] = ACTIONS(2783),
    [anon_sym_and] = ACTIONS(2783),
    [anon_sym_let] = ACTIONS(2783),
    [anon_sym_let_BANG] = ACTIONS(2785),
    [anon_sym_LPAREN] = ACTIONS(2783),
    [anon_sym_COMMA] = ACTIONS(2785),
    [anon_sym_null] = ACTIONS(2783),
    [anon_sym_QMARK] = ACTIONS(2783),
    [anon_sym_COLON_QMARK] = ACTIONS(2783),
    [anon_sym_COLON_COLON] = ACTIONS(2785),
    [anon_sym_AMP] = ACTIONS(2783),
    [anon_sym_LBRACK] = ACTIONS(2783),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2785),
    [anon_sym_LBRACE] = ACTIONS(2783),
    [anon_sym_LT_AT] = ACTIONS(2783),
    [anon_sym_LT_AT_AT] = ACTIONS(2783),
    [anon_sym_DOT] = ACTIONS(2783),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2785),
    [anon_sym_new] = ACTIONS(2783),
    [anon_sym_return_BANG] = ACTIONS(2785),
    [anon_sym_yield] = ACTIONS(2783),
    [anon_sym_yield_BANG] = ACTIONS(2785),
    [anon_sym_lazy] = ACTIONS(2783),
    [anon_sym_assert] = ACTIONS(2783),
    [anon_sym_upcast] = ACTIONS(2783),
    [anon_sym_downcast] = ACTIONS(2783),
    [anon_sym_COLON_GT] = ACTIONS(2785),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2785),
    [anon_sym_for] = ACTIONS(2783),
    [anon_sym_done] = ACTIONS(3642),
    [anon_sym_while] = ACTIONS(2783),
    [anon_sym_if] = ACTIONS(2783),
    [anon_sym_fun] = ACTIONS(2783),
    [anon_sym_try] = ACTIONS(2783),
    [anon_sym_match] = ACTIONS(2783),
    [anon_sym_match_BANG] = ACTIONS(2785),
    [anon_sym_function] = ACTIONS(2783),
    [anon_sym_LT_DASH] = ACTIONS(2783),
    [anon_sym_DOT_LBRACK] = ACTIONS(2785),
    [anon_sym_LT] = ACTIONS(2785),
    [anon_sym_use] = ACTIONS(2783),
    [anon_sym_use_BANG] = ACTIONS(2785),
    [anon_sym_do_BANG] = ACTIONS(2785),
    [anon_sym_begin] = ACTIONS(2783),
    [anon_sym_LPAREN2] = ACTIONS(2783),
    [anon_sym_or] = ACTIONS(2783),
    [aux_sym_char_token1] = ACTIONS(2785),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2783),
    [anon_sym_DQUOTE] = ACTIONS(2783),
    [anon_sym_AT_DQUOTE] = ACTIONS(2785),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2785),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2785),
    [sym_bool] = ACTIONS(2783),
    [sym_unit] = ACTIONS(2785),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2783),
    [sym_op_identifier] = ACTIONS(2783),
    [anon_sym_PLUS] = ACTIONS(2783),
    [anon_sym_DASH] = ACTIONS(2783),
    [anon_sym_PLUS_DOT] = ACTIONS(2783),
    [anon_sym_DASH_DOT] = ACTIONS(2783),
    [anon_sym_PERCENT] = ACTIONS(2783),
    [anon_sym_AMP_AMP] = ACTIONS(2783),
    [anon_sym_TILDE] = ACTIONS(2785),
    [aux_sym_prefix_op_token1] = ACTIONS(2783),
    [aux_sym_infix_op_token1] = ACTIONS(2785),
    [aux_sym_infix_op_token2] = ACTIONS(2783),
    [anon_sym_PIPE_PIPE] = ACTIONS(2783),
    [anon_sym_BANG_EQ] = ACTIONS(2783),
    [anon_sym_COLON_EQ] = ACTIONS(2785),
    [anon_sym_DOLLAR] = ACTIONS(2783),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2783),
    [sym_int] = ACTIONS(2783),
    [sym_xint] = ACTIONS(2785),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2785),
    [sym__newline] = ACTIONS(2785),
    [sym__dedent] = ACTIONS(2785),
  },
  [1639] = {
    [sym_block_comment] = STATE(1639),
    [sym_compiler_directive_decl] = STATE(1639),
    [sym_fsi_directive_decl] = STATE(1639),
    [sym_preproc_line] = STATE(1639),
    [sym_identifier] = ACTIONS(3023),
    [anon_sym_EQ] = ACTIONS(3025),
    [anon_sym_COLON] = ACTIONS(3023),
    [anon_sym_return] = ACTIONS(3023),
    [anon_sym_do] = ACTIONS(3023),
    [anon_sym_let] = ACTIONS(3023),
    [anon_sym_let_BANG] = ACTIONS(3025),
    [anon_sym_as] = ACTIONS(3023),
    [anon_sym_LPAREN] = ACTIONS(3023),
    [anon_sym_COMMA] = ACTIONS(3025),
    [anon_sym_null] = ACTIONS(3023),
    [anon_sym_QMARK] = ACTIONS(3023),
    [anon_sym_COLON_QMARK] = ACTIONS(3023),
    [anon_sym_COLON_COLON] = ACTIONS(3025),
    [anon_sym_AMP] = ACTIONS(3023),
    [anon_sym_LBRACK] = ACTIONS(3023),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3025),
    [anon_sym_LBRACE] = ACTIONS(3023),
    [anon_sym_LT_AT] = ACTIONS(3023),
    [anon_sym_LT_AT_AT] = ACTIONS(3023),
    [anon_sym_DOT] = ACTIONS(3023),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3025),
    [anon_sym_new] = ACTIONS(3023),
    [anon_sym_with] = ACTIONS(3023),
    [anon_sym_return_BANG] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(3023),
    [anon_sym_yield_BANG] = ACTIONS(3025),
    [anon_sym_lazy] = ACTIONS(3023),
    [anon_sym_assert] = ACTIONS(3023),
    [anon_sym_upcast] = ACTIONS(3023),
    [anon_sym_downcast] = ACTIONS(3023),
    [anon_sym_COLON_GT] = ACTIONS(3025),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3025),
    [anon_sym_for] = ACTIONS(3023),
    [anon_sym_while] = ACTIONS(3023),
    [anon_sym_if] = ACTIONS(3023),
    [anon_sym_fun] = ACTIONS(3023),
    [anon_sym_try] = ACTIONS(3023),
    [anon_sym_match] = ACTIONS(3023),
    [anon_sym_match_BANG] = ACTIONS(3025),
    [anon_sym_function] = ACTIONS(3023),
    [anon_sym_LT_DASH] = ACTIONS(3023),
    [anon_sym_DOT_LBRACK] = ACTIONS(3025),
    [anon_sym_LT] = ACTIONS(3025),
    [anon_sym_use] = ACTIONS(3023),
    [anon_sym_use_BANG] = ACTIONS(3025),
    [anon_sym_do_BANG] = ACTIONS(3025),
    [anon_sym_begin] = ACTIONS(3023),
    [anon_sym_LPAREN2] = ACTIONS(3023),
    [anon_sym_or] = ACTIONS(3023),
    [aux_sym_char_token1] = ACTIONS(3025),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3023),
    [anon_sym_DQUOTE] = ACTIONS(3023),
    [anon_sym_AT_DQUOTE] = ACTIONS(3025),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3025),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3025),
    [sym_bool] = ACTIONS(3023),
    [sym_unit] = ACTIONS(3025),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3023),
    [sym_op_identifier] = ACTIONS(3023),
    [anon_sym_PLUS] = ACTIONS(3023),
    [anon_sym_DASH] = ACTIONS(3023),
    [anon_sym_PLUS_DOT] = ACTIONS(3023),
    [anon_sym_DASH_DOT] = ACTIONS(3023),
    [anon_sym_PERCENT] = ACTIONS(3023),
    [anon_sym_AMP_AMP] = ACTIONS(3023),
    [anon_sym_TILDE] = ACTIONS(3025),
    [aux_sym_prefix_op_token1] = ACTIONS(3023),
    [aux_sym_infix_op_token1] = ACTIONS(3025),
    [aux_sym_infix_op_token2] = ACTIONS(3023),
    [anon_sym_PIPE_PIPE] = ACTIONS(3023),
    [anon_sym_BANG_EQ] = ACTIONS(3023),
    [anon_sym_COLON_EQ] = ACTIONS(3025),
    [anon_sym_DOLLAR] = ACTIONS(3023),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3023),
    [sym_int] = ACTIONS(3023),
    [sym_xint] = ACTIONS(3025),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3025),
    [sym__newline] = ACTIONS(3025),
    [sym__dedent] = ACTIONS(3025),
  },
  [1640] = {
    [sym_block_comment] = STATE(1640),
    [sym_compiler_directive_decl] = STATE(1640),
    [sym_fsi_directive_decl] = STATE(1640),
    [sym_preproc_line] = STATE(1640),
    [sym_identifier] = ACTIONS(2685),
    [anon_sym_EQ] = ACTIONS(2687),
    [anon_sym_COLON] = ACTIONS(2685),
    [anon_sym_return] = ACTIONS(2685),
    [anon_sym_do] = ACTIONS(2685),
    [anon_sym_let] = ACTIONS(2685),
    [anon_sym_let_BANG] = ACTIONS(2687),
    [anon_sym_LPAREN] = ACTIONS(2685),
    [anon_sym_COMMA] = ACTIONS(2687),
    [anon_sym_null] = ACTIONS(2685),
    [anon_sym_QMARK] = ACTIONS(2685),
    [anon_sym_COLON_QMARK] = ACTIONS(2685),
    [anon_sym_COLON_COLON] = ACTIONS(2687),
    [anon_sym_AMP] = ACTIONS(2685),
    [anon_sym_LBRACK] = ACTIONS(2685),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2687),
    [anon_sym_LBRACE] = ACTIONS(2685),
    [anon_sym_LT_AT] = ACTIONS(2685),
    [anon_sym_LT_AT_AT] = ACTIONS(2685),
    [anon_sym_DOT] = ACTIONS(2685),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2687),
    [anon_sym_new] = ACTIONS(2685),
    [anon_sym_return_BANG] = ACTIONS(2687),
    [anon_sym_yield] = ACTIONS(2685),
    [anon_sym_yield_BANG] = ACTIONS(2687),
    [anon_sym_lazy] = ACTIONS(2685),
    [anon_sym_assert] = ACTIONS(2685),
    [anon_sym_upcast] = ACTIONS(2685),
    [anon_sym_downcast] = ACTIONS(2685),
    [anon_sym_COLON_GT] = ACTIONS(2687),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2687),
    [anon_sym_for] = ACTIONS(2685),
    [anon_sym_done] = ACTIONS(2685),
    [anon_sym_while] = ACTIONS(2685),
    [anon_sym_if] = ACTIONS(2685),
    [anon_sym_fun] = ACTIONS(2685),
    [anon_sym_DASH_GT] = ACTIONS(2685),
    [anon_sym_try] = ACTIONS(2685),
    [anon_sym_match] = ACTIONS(2685),
    [anon_sym_match_BANG] = ACTIONS(2687),
    [anon_sym_function] = ACTIONS(2685),
    [anon_sym_LT_DASH] = ACTIONS(2685),
    [anon_sym_DOT_LBRACK] = ACTIONS(2687),
    [anon_sym_LT] = ACTIONS(2687),
    [anon_sym_use] = ACTIONS(2685),
    [anon_sym_use_BANG] = ACTIONS(2687),
    [anon_sym_do_BANG] = ACTIONS(2687),
    [anon_sym_DOT_DOT] = ACTIONS(2687),
    [anon_sym_begin] = ACTIONS(2685),
    [anon_sym_LPAREN2] = ACTIONS(2685),
    [anon_sym_or] = ACTIONS(2685),
    [aux_sym_char_token1] = ACTIONS(2687),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2685),
    [anon_sym_DQUOTE] = ACTIONS(2685),
    [anon_sym_AT_DQUOTE] = ACTIONS(2687),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2687),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2687),
    [sym_bool] = ACTIONS(2685),
    [sym_unit] = ACTIONS(2687),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2685),
    [sym_op_identifier] = ACTIONS(2685),
    [anon_sym_PLUS] = ACTIONS(2685),
    [anon_sym_DASH] = ACTIONS(2685),
    [anon_sym_PLUS_DOT] = ACTIONS(2685),
    [anon_sym_DASH_DOT] = ACTIONS(2685),
    [anon_sym_PERCENT] = ACTIONS(2685),
    [anon_sym_AMP_AMP] = ACTIONS(2685),
    [anon_sym_TILDE] = ACTIONS(2687),
    [aux_sym_prefix_op_token1] = ACTIONS(2685),
    [aux_sym_infix_op_token1] = ACTIONS(2687),
    [aux_sym_infix_op_token2] = ACTIONS(2685),
    [anon_sym_PIPE_PIPE] = ACTIONS(2685),
    [anon_sym_BANG_EQ] = ACTIONS(2685),
    [anon_sym_COLON_EQ] = ACTIONS(2687),
    [anon_sym_DOLLAR] = ACTIONS(2685),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2685),
    [sym_int] = ACTIONS(2685),
    [sym_xint] = ACTIONS(2687),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2687),
    [sym__newline] = ACTIONS(2687),
  },
  [1641] = {
    [sym_block_comment] = STATE(1641),
    [sym_compiler_directive_decl] = STATE(1641),
    [sym_fsi_directive_decl] = STATE(1641),
    [sym_preproc_line] = STATE(1641),
    [sym_identifier] = ACTIONS(3115),
    [anon_sym_EQ] = ACTIONS(3117),
    [anon_sym_COLON] = ACTIONS(3115),
    [anon_sym_return] = ACTIONS(3115),
    [anon_sym_do] = ACTIONS(3115),
    [anon_sym_let] = ACTIONS(3115),
    [anon_sym_let_BANG] = ACTIONS(3117),
    [anon_sym_as] = ACTIONS(3115),
    [anon_sym_LPAREN] = ACTIONS(3115),
    [anon_sym_COMMA] = ACTIONS(3117),
    [anon_sym_null] = ACTIONS(3115),
    [anon_sym_QMARK] = ACTIONS(3115),
    [anon_sym_COLON_QMARK] = ACTIONS(3115),
    [anon_sym_COLON_COLON] = ACTIONS(3117),
    [anon_sym_AMP] = ACTIONS(3115),
    [anon_sym_LBRACK] = ACTIONS(3115),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3117),
    [anon_sym_LBRACE] = ACTIONS(3115),
    [anon_sym_LT_AT] = ACTIONS(3115),
    [anon_sym_LT_AT_AT] = ACTIONS(3115),
    [anon_sym_DOT] = ACTIONS(3115),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3117),
    [anon_sym_new] = ACTIONS(3115),
    [anon_sym_with] = ACTIONS(3115),
    [anon_sym_return_BANG] = ACTIONS(3117),
    [anon_sym_yield] = ACTIONS(3115),
    [anon_sym_yield_BANG] = ACTIONS(3117),
    [anon_sym_lazy] = ACTIONS(3115),
    [anon_sym_assert] = ACTIONS(3115),
    [anon_sym_upcast] = ACTIONS(3115),
    [anon_sym_downcast] = ACTIONS(3115),
    [anon_sym_COLON_GT] = ACTIONS(3117),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3117),
    [anon_sym_for] = ACTIONS(3115),
    [anon_sym_while] = ACTIONS(3115),
    [anon_sym_if] = ACTIONS(3115),
    [anon_sym_fun] = ACTIONS(3115),
    [anon_sym_try] = ACTIONS(3115),
    [anon_sym_match] = ACTIONS(3115),
    [anon_sym_match_BANG] = ACTIONS(3117),
    [anon_sym_function] = ACTIONS(3115),
    [anon_sym_LT_DASH] = ACTIONS(3115),
    [anon_sym_DOT_LBRACK] = ACTIONS(3117),
    [anon_sym_LT] = ACTIONS(3117),
    [anon_sym_use] = ACTIONS(3115),
    [anon_sym_use_BANG] = ACTIONS(3117),
    [anon_sym_do_BANG] = ACTIONS(3117),
    [anon_sym_begin] = ACTIONS(3115),
    [anon_sym_LPAREN2] = ACTIONS(3115),
    [anon_sym_or] = ACTIONS(3115),
    [aux_sym_char_token1] = ACTIONS(3117),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3115),
    [anon_sym_DQUOTE] = ACTIONS(3115),
    [anon_sym_AT_DQUOTE] = ACTIONS(3117),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3117),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3117),
    [sym_bool] = ACTIONS(3115),
    [sym_unit] = ACTIONS(3117),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3115),
    [sym_op_identifier] = ACTIONS(3115),
    [anon_sym_PLUS] = ACTIONS(3115),
    [anon_sym_DASH] = ACTIONS(3115),
    [anon_sym_PLUS_DOT] = ACTIONS(3115),
    [anon_sym_DASH_DOT] = ACTIONS(3115),
    [anon_sym_PERCENT] = ACTIONS(3115),
    [anon_sym_AMP_AMP] = ACTIONS(3115),
    [anon_sym_TILDE] = ACTIONS(3117),
    [aux_sym_prefix_op_token1] = ACTIONS(3115),
    [aux_sym_infix_op_token1] = ACTIONS(3117),
    [aux_sym_infix_op_token2] = ACTIONS(3115),
    [anon_sym_PIPE_PIPE] = ACTIONS(3115),
    [anon_sym_BANG_EQ] = ACTIONS(3115),
    [anon_sym_COLON_EQ] = ACTIONS(3117),
    [anon_sym_DOLLAR] = ACTIONS(3115),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3115),
    [sym_int] = ACTIONS(3115),
    [sym_xint] = ACTIONS(3117),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3117),
    [sym__newline] = ACTIONS(3117),
    [sym__dedent] = ACTIONS(3117),
  },
  [1642] = {
    [sym_block_comment] = STATE(1642),
    [sym_compiler_directive_decl] = STATE(1642),
    [sym_fsi_directive_decl] = STATE(1642),
    [sym_preproc_line] = STATE(1642),
    [sym_identifier] = ACTIONS(2804),
    [anon_sym_EQ] = ACTIONS(2806),
    [anon_sym_COLON] = ACTIONS(2804),
    [anon_sym_return] = ACTIONS(2804),
    [anon_sym_do] = ACTIONS(2804),
    [anon_sym_and] = ACTIONS(2804),
    [anon_sym_let] = ACTIONS(2804),
    [anon_sym_let_BANG] = ACTIONS(2806),
    [anon_sym_LPAREN] = ACTIONS(2804),
    [anon_sym_COMMA] = ACTIONS(2806),
    [anon_sym_null] = ACTIONS(2804),
    [anon_sym_QMARK] = ACTIONS(2804),
    [anon_sym_COLON_QMARK] = ACTIONS(2804),
    [anon_sym_COLON_COLON] = ACTIONS(2806),
    [anon_sym_AMP] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2804),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(2804),
    [anon_sym_LT_AT] = ACTIONS(2804),
    [anon_sym_LT_AT_AT] = ACTIONS(2804),
    [anon_sym_DOT] = ACTIONS(2804),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2806),
    [anon_sym_new] = ACTIONS(2804),
    [anon_sym_return_BANG] = ACTIONS(2806),
    [anon_sym_yield] = ACTIONS(2804),
    [anon_sym_yield_BANG] = ACTIONS(2806),
    [anon_sym_lazy] = ACTIONS(2804),
    [anon_sym_assert] = ACTIONS(2804),
    [anon_sym_upcast] = ACTIONS(2804),
    [anon_sym_downcast] = ACTIONS(2804),
    [anon_sym_COLON_GT] = ACTIONS(2806),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2806),
    [anon_sym_for] = ACTIONS(2804),
    [anon_sym_done] = ACTIONS(3862),
    [anon_sym_while] = ACTIONS(2804),
    [anon_sym_if] = ACTIONS(2804),
    [anon_sym_fun] = ACTIONS(2804),
    [anon_sym_try] = ACTIONS(2804),
    [anon_sym_match] = ACTIONS(2804),
    [anon_sym_match_BANG] = ACTIONS(2806),
    [anon_sym_function] = ACTIONS(2804),
    [anon_sym_LT_DASH] = ACTIONS(2804),
    [anon_sym_DOT_LBRACK] = ACTIONS(2806),
    [anon_sym_LT] = ACTIONS(2806),
    [anon_sym_use] = ACTIONS(2804),
    [anon_sym_use_BANG] = ACTIONS(2806),
    [anon_sym_do_BANG] = ACTIONS(2806),
    [anon_sym_begin] = ACTIONS(2804),
    [anon_sym_LPAREN2] = ACTIONS(2804),
    [anon_sym_or] = ACTIONS(2804),
    [aux_sym_char_token1] = ACTIONS(2806),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2804),
    [anon_sym_DQUOTE] = ACTIONS(2804),
    [anon_sym_AT_DQUOTE] = ACTIONS(2806),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2806),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2806),
    [sym_bool] = ACTIONS(2804),
    [sym_unit] = ACTIONS(2806),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2804),
    [sym_op_identifier] = ACTIONS(2804),
    [anon_sym_PLUS] = ACTIONS(2804),
    [anon_sym_DASH] = ACTIONS(2804),
    [anon_sym_PLUS_DOT] = ACTIONS(2804),
    [anon_sym_DASH_DOT] = ACTIONS(2804),
    [anon_sym_PERCENT] = ACTIONS(2804),
    [anon_sym_AMP_AMP] = ACTIONS(2804),
    [anon_sym_TILDE] = ACTIONS(2806),
    [aux_sym_prefix_op_token1] = ACTIONS(2804),
    [aux_sym_infix_op_token1] = ACTIONS(2806),
    [aux_sym_infix_op_token2] = ACTIONS(2804),
    [anon_sym_PIPE_PIPE] = ACTIONS(2804),
    [anon_sym_BANG_EQ] = ACTIONS(2804),
    [anon_sym_COLON_EQ] = ACTIONS(2806),
    [anon_sym_DOLLAR] = ACTIONS(2804),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2804),
    [sym_int] = ACTIONS(2804),
    [sym_xint] = ACTIONS(2806),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2806),
    [sym__newline] = ACTIONS(2806),
    [sym__dedent] = ACTIONS(2806),
  },
  [1643] = {
    [sym_block_comment] = STATE(1643),
    [sym_compiler_directive_decl] = STATE(1643),
    [sym_fsi_directive_decl] = STATE(1643),
    [sym_preproc_line] = STATE(1643),
    [sym_identifier] = ACTIONS(2867),
    [anon_sym_EQ] = ACTIONS(2869),
    [anon_sym_COLON] = ACTIONS(2867),
    [anon_sym_return] = ACTIONS(2867),
    [anon_sym_do] = ACTIONS(2867),
    [anon_sym_let] = ACTIONS(2867),
    [anon_sym_let_BANG] = ACTIONS(2869),
    [anon_sym_as] = ACTIONS(2867),
    [anon_sym_LPAREN] = ACTIONS(2867),
    [anon_sym_COMMA] = ACTIONS(2869),
    [anon_sym_null] = ACTIONS(2867),
    [anon_sym_QMARK] = ACTIONS(2867),
    [anon_sym_COLON_QMARK] = ACTIONS(2867),
    [anon_sym_COLON_COLON] = ACTIONS(2869),
    [anon_sym_AMP] = ACTIONS(2867),
    [anon_sym_LBRACK] = ACTIONS(2867),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2869),
    [anon_sym_LBRACE] = ACTIONS(2867),
    [anon_sym_LT_AT] = ACTIONS(2867),
    [anon_sym_LT_AT_AT] = ACTIONS(2867),
    [anon_sym_DOT] = ACTIONS(3864),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2869),
    [anon_sym_new] = ACTIONS(2867),
    [anon_sym_with] = ACTIONS(2867),
    [anon_sym_return_BANG] = ACTIONS(2869),
    [anon_sym_yield] = ACTIONS(2867),
    [anon_sym_yield_BANG] = ACTIONS(2869),
    [anon_sym_lazy] = ACTIONS(2867),
    [anon_sym_assert] = ACTIONS(2867),
    [anon_sym_upcast] = ACTIONS(2867),
    [anon_sym_downcast] = ACTIONS(2867),
    [anon_sym_COLON_GT] = ACTIONS(2869),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2869),
    [anon_sym_for] = ACTIONS(2867),
    [anon_sym_while] = ACTIONS(2867),
    [anon_sym_if] = ACTIONS(2867),
    [anon_sym_fun] = ACTIONS(2867),
    [anon_sym_try] = ACTIONS(2867),
    [anon_sym_match] = ACTIONS(2867),
    [anon_sym_match_BANG] = ACTIONS(2869),
    [anon_sym_function] = ACTIONS(2867),
    [anon_sym_LT_DASH] = ACTIONS(2867),
    [anon_sym_DOT_LBRACK] = ACTIONS(2869),
    [anon_sym_LT] = ACTIONS(2869),
    [anon_sym_use] = ACTIONS(2867),
    [anon_sym_use_BANG] = ACTIONS(2869),
    [anon_sym_do_BANG] = ACTIONS(2869),
    [anon_sym_begin] = ACTIONS(2867),
    [anon_sym_LPAREN2] = ACTIONS(2867),
    [anon_sym_or] = ACTIONS(2867),
    [aux_sym_char_token1] = ACTIONS(2869),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2867),
    [anon_sym_DQUOTE] = ACTIONS(2867),
    [anon_sym_AT_DQUOTE] = ACTIONS(2869),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2869),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2869),
    [sym_bool] = ACTIONS(2867),
    [sym_unit] = ACTIONS(2869),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2867),
    [sym_op_identifier] = ACTIONS(2867),
    [anon_sym_PLUS] = ACTIONS(2867),
    [anon_sym_DASH] = ACTIONS(2867),
    [anon_sym_PLUS_DOT] = ACTIONS(2867),
    [anon_sym_DASH_DOT] = ACTIONS(2867),
    [anon_sym_PERCENT] = ACTIONS(2867),
    [anon_sym_AMP_AMP] = ACTIONS(2867),
    [anon_sym_TILDE] = ACTIONS(2869),
    [aux_sym_prefix_op_token1] = ACTIONS(2867),
    [aux_sym_infix_op_token1] = ACTIONS(2869),
    [aux_sym_infix_op_token2] = ACTIONS(2867),
    [anon_sym_PIPE_PIPE] = ACTIONS(2867),
    [anon_sym_BANG_EQ] = ACTIONS(2867),
    [anon_sym_COLON_EQ] = ACTIONS(2869),
    [anon_sym_DOLLAR] = ACTIONS(2867),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2867),
    [sym_int] = ACTIONS(2867),
    [sym_xint] = ACTIONS(2869),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2869),
    [sym__newline] = ACTIONS(2869),
    [sym__dedent] = ACTIONS(2869),
  },
  [1644] = {
    [sym_block_comment] = STATE(1644),
    [sym_compiler_directive_decl] = STATE(1644),
    [sym_fsi_directive_decl] = STATE(1644),
    [sym_preproc_line] = STATE(1644),
    [aux_sym_long_identifier_repeat1] = STATE(1579),
    [sym_identifier] = ACTIONS(2791),
    [anon_sym_EQ] = ACTIONS(2794),
    [anon_sym_COLON] = ACTIONS(2791),
    [anon_sym_return] = ACTIONS(2791),
    [anon_sym_do] = ACTIONS(2791),
    [anon_sym_let] = ACTIONS(2791),
    [anon_sym_let_BANG] = ACTIONS(2794),
    [anon_sym_LPAREN] = ACTIONS(2791),
    [anon_sym_COMMA] = ACTIONS(2794),
    [anon_sym_null] = ACTIONS(2791),
    [anon_sym_QMARK] = ACTIONS(2791),
    [anon_sym_COLON_QMARK] = ACTIONS(2791),
    [anon_sym_COLON_COLON] = ACTIONS(2794),
    [anon_sym_AMP] = ACTIONS(2791),
    [anon_sym_LBRACK] = ACTIONS(2791),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2794),
    [anon_sym_LBRACE] = ACTIONS(2791),
    [anon_sym_LT_AT] = ACTIONS(2791),
    [anon_sym_LT_AT_AT] = ACTIONS(2791),
    [anon_sym_DOT] = ACTIONS(3866),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2794),
    [anon_sym_new] = ACTIONS(2791),
    [anon_sym_return_BANG] = ACTIONS(2794),
    [anon_sym_yield] = ACTIONS(2791),
    [anon_sym_yield_BANG] = ACTIONS(2794),
    [anon_sym_lazy] = ACTIONS(2791),
    [anon_sym_assert] = ACTIONS(2791),
    [anon_sym_upcast] = ACTIONS(2791),
    [anon_sym_downcast] = ACTIONS(2791),
    [anon_sym_COLON_GT] = ACTIONS(2794),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2794),
    [anon_sym_for] = ACTIONS(2791),
    [anon_sym_while] = ACTIONS(2791),
    [anon_sym_if] = ACTIONS(2791),
    [anon_sym_fun] = ACTIONS(2791),
    [anon_sym_DASH_GT] = ACTIONS(2791),
    [anon_sym_try] = ACTIONS(2791),
    [anon_sym_match] = ACTIONS(2791),
    [anon_sym_match_BANG] = ACTIONS(2794),
    [anon_sym_function] = ACTIONS(2791),
    [anon_sym_LT_DASH] = ACTIONS(2791),
    [anon_sym_DOT_LBRACK] = ACTIONS(2794),
    [anon_sym_LT] = ACTIONS(2794),
    [anon_sym_use] = ACTIONS(2791),
    [anon_sym_use_BANG] = ACTIONS(2794),
    [anon_sym_do_BANG] = ACTIONS(2794),
    [anon_sym_DOT_DOT] = ACTIONS(2794),
    [anon_sym_begin] = ACTIONS(2791),
    [anon_sym_LPAREN2] = ACTIONS(2791),
    [anon_sym_or] = ACTIONS(2791),
    [aux_sym_char_token1] = ACTIONS(2794),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2791),
    [anon_sym_DQUOTE] = ACTIONS(2791),
    [anon_sym_AT_DQUOTE] = ACTIONS(2794),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2794),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2794),
    [sym_bool] = ACTIONS(2791),
    [sym_unit] = ACTIONS(2794),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2791),
    [sym_op_identifier] = ACTIONS(2791),
    [anon_sym_PLUS] = ACTIONS(2791),
    [anon_sym_DASH] = ACTIONS(2791),
    [anon_sym_PLUS_DOT] = ACTIONS(2791),
    [anon_sym_DASH_DOT] = ACTIONS(2791),
    [anon_sym_PERCENT] = ACTIONS(2791),
    [anon_sym_AMP_AMP] = ACTIONS(2791),
    [anon_sym_TILDE] = ACTIONS(2794),
    [aux_sym_prefix_op_token1] = ACTIONS(2791),
    [aux_sym_infix_op_token1] = ACTIONS(2794),
    [aux_sym_infix_op_token2] = ACTIONS(2791),
    [anon_sym_PIPE_PIPE] = ACTIONS(2791),
    [anon_sym_BANG_EQ] = ACTIONS(2791),
    [anon_sym_COLON_EQ] = ACTIONS(2794),
    [anon_sym_DOLLAR] = ACTIONS(2791),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2791),
    [sym_int] = ACTIONS(2791),
    [sym_xint] = ACTIONS(2794),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2794),
    [sym__newline] = ACTIONS(2794),
  },
  [1645] = {
    [sym_block_comment] = STATE(1645),
    [sym_compiler_directive_decl] = STATE(1645),
    [sym_fsi_directive_decl] = STATE(1645),
    [sym_preproc_line] = STATE(1645),
    [sym_identifier] = ACTIONS(2863),
    [anon_sym_EQ] = ACTIONS(2865),
    [anon_sym_COLON] = ACTIONS(2863),
    [anon_sym_return] = ACTIONS(2863),
    [anon_sym_do] = ACTIONS(2863),
    [anon_sym_let] = ACTIONS(2863),
    [anon_sym_let_BANG] = ACTIONS(2865),
    [anon_sym_as] = ACTIONS(2863),
    [anon_sym_LPAREN] = ACTIONS(2863),
    [anon_sym_COMMA] = ACTIONS(2865),
    [anon_sym_null] = ACTIONS(2863),
    [anon_sym_QMARK] = ACTIONS(2863),
    [anon_sym_COLON_QMARK] = ACTIONS(2863),
    [anon_sym_COLON_COLON] = ACTIONS(2865),
    [anon_sym_AMP] = ACTIONS(2863),
    [anon_sym_LBRACK] = ACTIONS(2863),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2865),
    [anon_sym_LBRACE] = ACTIONS(2863),
    [anon_sym_LT_AT] = ACTIONS(2863),
    [anon_sym_LT_AT_AT] = ACTIONS(2863),
    [anon_sym_DOT] = ACTIONS(2863),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2865),
    [anon_sym_new] = ACTIONS(2863),
    [anon_sym_with] = ACTIONS(2863),
    [anon_sym_return_BANG] = ACTIONS(2865),
    [anon_sym_yield] = ACTIONS(2863),
    [anon_sym_yield_BANG] = ACTIONS(2865),
    [anon_sym_lazy] = ACTIONS(2863),
    [anon_sym_assert] = ACTIONS(2863),
    [anon_sym_upcast] = ACTIONS(2863),
    [anon_sym_downcast] = ACTIONS(2863),
    [anon_sym_COLON_GT] = ACTIONS(2865),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2865),
    [anon_sym_for] = ACTIONS(2863),
    [anon_sym_while] = ACTIONS(2863),
    [anon_sym_if] = ACTIONS(2863),
    [anon_sym_fun] = ACTIONS(2863),
    [anon_sym_try] = ACTIONS(2863),
    [anon_sym_match] = ACTIONS(2863),
    [anon_sym_match_BANG] = ACTIONS(2865),
    [anon_sym_function] = ACTIONS(2863),
    [anon_sym_LT_DASH] = ACTIONS(2863),
    [anon_sym_DOT_LBRACK] = ACTIONS(2865),
    [anon_sym_LT] = ACTIONS(2865),
    [anon_sym_use] = ACTIONS(2863),
    [anon_sym_use_BANG] = ACTIONS(2865),
    [anon_sym_do_BANG] = ACTIONS(2865),
    [anon_sym_begin] = ACTIONS(2863),
    [anon_sym_LPAREN2] = ACTIONS(2863),
    [anon_sym_or] = ACTIONS(2863),
    [aux_sym_char_token1] = ACTIONS(2865),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2863),
    [anon_sym_DQUOTE] = ACTIONS(2863),
    [anon_sym_AT_DQUOTE] = ACTIONS(2865),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2865),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2865),
    [sym_bool] = ACTIONS(2863),
    [sym_unit] = ACTIONS(2865),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2863),
    [sym_op_identifier] = ACTIONS(2863),
    [anon_sym_PLUS] = ACTIONS(2863),
    [anon_sym_DASH] = ACTIONS(2863),
    [anon_sym_PLUS_DOT] = ACTIONS(2863),
    [anon_sym_DASH_DOT] = ACTIONS(2863),
    [anon_sym_PERCENT] = ACTIONS(2863),
    [anon_sym_AMP_AMP] = ACTIONS(2863),
    [anon_sym_TILDE] = ACTIONS(2865),
    [aux_sym_prefix_op_token1] = ACTIONS(2863),
    [aux_sym_infix_op_token1] = ACTIONS(2865),
    [aux_sym_infix_op_token2] = ACTIONS(2863),
    [anon_sym_PIPE_PIPE] = ACTIONS(2863),
    [anon_sym_BANG_EQ] = ACTIONS(2863),
    [anon_sym_COLON_EQ] = ACTIONS(2865),
    [anon_sym_DOLLAR] = ACTIONS(2863),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2863),
    [sym_int] = ACTIONS(2863),
    [sym_xint] = ACTIONS(2865),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2865),
    [sym__newline] = ACTIONS(2865),
    [sym__dedent] = ACTIONS(2865),
  },
  [1646] = {
    [sym_block_comment] = STATE(1646),
    [sym_compiler_directive_decl] = STATE(1646),
    [sym_fsi_directive_decl] = STATE(1646),
    [sym_preproc_line] = STATE(1646),
    [sym_identifier] = ACTIONS(3027),
    [anon_sym_EQ] = ACTIONS(3029),
    [anon_sym_COLON] = ACTIONS(3027),
    [anon_sym_return] = ACTIONS(3027),
    [anon_sym_do] = ACTIONS(3027),
    [anon_sym_let] = ACTIONS(3027),
    [anon_sym_let_BANG] = ACTIONS(3029),
    [anon_sym_as] = ACTIONS(3027),
    [anon_sym_LPAREN] = ACTIONS(3027),
    [anon_sym_COMMA] = ACTIONS(3029),
    [anon_sym_null] = ACTIONS(3027),
    [anon_sym_QMARK] = ACTIONS(3027),
    [anon_sym_COLON_QMARK] = ACTIONS(3027),
    [anon_sym_COLON_COLON] = ACTIONS(3029),
    [anon_sym_AMP] = ACTIONS(3027),
    [anon_sym_LBRACK] = ACTIONS(3027),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3027),
    [anon_sym_LT_AT] = ACTIONS(3027),
    [anon_sym_LT_AT_AT] = ACTIONS(3027),
    [anon_sym_DOT] = ACTIONS(3027),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3029),
    [anon_sym_new] = ACTIONS(3027),
    [anon_sym_with] = ACTIONS(3027),
    [anon_sym_return_BANG] = ACTIONS(3029),
    [anon_sym_yield] = ACTIONS(3027),
    [anon_sym_yield_BANG] = ACTIONS(3029),
    [anon_sym_lazy] = ACTIONS(3027),
    [anon_sym_assert] = ACTIONS(3027),
    [anon_sym_upcast] = ACTIONS(3027),
    [anon_sym_downcast] = ACTIONS(3027),
    [anon_sym_COLON_GT] = ACTIONS(3029),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3029),
    [anon_sym_for] = ACTIONS(3027),
    [anon_sym_while] = ACTIONS(3027),
    [anon_sym_if] = ACTIONS(3027),
    [anon_sym_fun] = ACTIONS(3027),
    [anon_sym_try] = ACTIONS(3027),
    [anon_sym_match] = ACTIONS(3027),
    [anon_sym_match_BANG] = ACTIONS(3029),
    [anon_sym_function] = ACTIONS(3027),
    [anon_sym_LT_DASH] = ACTIONS(3027),
    [anon_sym_DOT_LBRACK] = ACTIONS(3029),
    [anon_sym_LT] = ACTIONS(3029),
    [anon_sym_use] = ACTIONS(3027),
    [anon_sym_use_BANG] = ACTIONS(3029),
    [anon_sym_do_BANG] = ACTIONS(3029),
    [anon_sym_begin] = ACTIONS(3027),
    [anon_sym_LPAREN2] = ACTIONS(3027),
    [anon_sym_or] = ACTIONS(3027),
    [aux_sym_char_token1] = ACTIONS(3029),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3027),
    [anon_sym_DQUOTE] = ACTIONS(3027),
    [anon_sym_AT_DQUOTE] = ACTIONS(3029),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3029),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3029),
    [sym_bool] = ACTIONS(3027),
    [sym_unit] = ACTIONS(3029),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3027),
    [sym_op_identifier] = ACTIONS(3027),
    [anon_sym_PLUS] = ACTIONS(3027),
    [anon_sym_DASH] = ACTIONS(3027),
    [anon_sym_PLUS_DOT] = ACTIONS(3027),
    [anon_sym_DASH_DOT] = ACTIONS(3027),
    [anon_sym_PERCENT] = ACTIONS(3027),
    [anon_sym_AMP_AMP] = ACTIONS(3027),
    [anon_sym_TILDE] = ACTIONS(3029),
    [aux_sym_prefix_op_token1] = ACTIONS(3027),
    [aux_sym_infix_op_token1] = ACTIONS(3029),
    [aux_sym_infix_op_token2] = ACTIONS(3027),
    [anon_sym_PIPE_PIPE] = ACTIONS(3027),
    [anon_sym_BANG_EQ] = ACTIONS(3027),
    [anon_sym_COLON_EQ] = ACTIONS(3029),
    [anon_sym_DOLLAR] = ACTIONS(3027),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3027),
    [sym_int] = ACTIONS(3027),
    [sym_xint] = ACTIONS(3029),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3029),
    [sym__newline] = ACTIONS(3029),
    [sym__dedent] = ACTIONS(3029),
  },
  [1647] = {
    [sym_block_comment] = STATE(1647),
    [sym_compiler_directive_decl] = STATE(1647),
    [sym_fsi_directive_decl] = STATE(1647),
    [sym_preproc_line] = STATE(1647),
    [sym_identifier] = ACTIONS(3031),
    [anon_sym_EQ] = ACTIONS(3033),
    [anon_sym_COLON] = ACTIONS(3031),
    [anon_sym_return] = ACTIONS(3031),
    [anon_sym_do] = ACTIONS(3031),
    [anon_sym_let] = ACTIONS(3031),
    [anon_sym_let_BANG] = ACTIONS(3033),
    [anon_sym_as] = ACTIONS(3031),
    [anon_sym_LPAREN] = ACTIONS(3031),
    [anon_sym_COMMA] = ACTIONS(3033),
    [anon_sym_null] = ACTIONS(3031),
    [anon_sym_QMARK] = ACTIONS(3031),
    [anon_sym_COLON_QMARK] = ACTIONS(3031),
    [anon_sym_COLON_COLON] = ACTIONS(3033),
    [anon_sym_AMP] = ACTIONS(3031),
    [anon_sym_LBRACK] = ACTIONS(3031),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3033),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [anon_sym_LT_AT] = ACTIONS(3031),
    [anon_sym_LT_AT_AT] = ACTIONS(3031),
    [anon_sym_DOT] = ACTIONS(3031),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3033),
    [anon_sym_new] = ACTIONS(3031),
    [anon_sym_with] = ACTIONS(3031),
    [anon_sym_return_BANG] = ACTIONS(3033),
    [anon_sym_yield] = ACTIONS(3031),
    [anon_sym_yield_BANG] = ACTIONS(3033),
    [anon_sym_lazy] = ACTIONS(3031),
    [anon_sym_assert] = ACTIONS(3031),
    [anon_sym_upcast] = ACTIONS(3031),
    [anon_sym_downcast] = ACTIONS(3031),
    [anon_sym_COLON_GT] = ACTIONS(3033),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3033),
    [anon_sym_for] = ACTIONS(3031),
    [anon_sym_while] = ACTIONS(3031),
    [anon_sym_if] = ACTIONS(3031),
    [anon_sym_fun] = ACTIONS(3031),
    [anon_sym_try] = ACTIONS(3031),
    [anon_sym_match] = ACTIONS(3031),
    [anon_sym_match_BANG] = ACTIONS(3033),
    [anon_sym_function] = ACTIONS(3031),
    [anon_sym_LT_DASH] = ACTIONS(3031),
    [anon_sym_DOT_LBRACK] = ACTIONS(3033),
    [anon_sym_LT] = ACTIONS(3033),
    [anon_sym_use] = ACTIONS(3031),
    [anon_sym_use_BANG] = ACTIONS(3033),
    [anon_sym_do_BANG] = ACTIONS(3033),
    [anon_sym_begin] = ACTIONS(3031),
    [anon_sym_LPAREN2] = ACTIONS(3031),
    [anon_sym_or] = ACTIONS(3031),
    [aux_sym_char_token1] = ACTIONS(3033),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3031),
    [anon_sym_DQUOTE] = ACTIONS(3031),
    [anon_sym_AT_DQUOTE] = ACTIONS(3033),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3033),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3033),
    [sym_bool] = ACTIONS(3031),
    [sym_unit] = ACTIONS(3033),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3031),
    [sym_op_identifier] = ACTIONS(3031),
    [anon_sym_PLUS] = ACTIONS(3031),
    [anon_sym_DASH] = ACTIONS(3031),
    [anon_sym_PLUS_DOT] = ACTIONS(3031),
    [anon_sym_DASH_DOT] = ACTIONS(3031),
    [anon_sym_PERCENT] = ACTIONS(3031),
    [anon_sym_AMP_AMP] = ACTIONS(3031),
    [anon_sym_TILDE] = ACTIONS(3033),
    [aux_sym_prefix_op_token1] = ACTIONS(3031),
    [aux_sym_infix_op_token1] = ACTIONS(3033),
    [aux_sym_infix_op_token2] = ACTIONS(3031),
    [anon_sym_PIPE_PIPE] = ACTIONS(3031),
    [anon_sym_BANG_EQ] = ACTIONS(3031),
    [anon_sym_COLON_EQ] = ACTIONS(3033),
    [anon_sym_DOLLAR] = ACTIONS(3031),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3031),
    [sym_int] = ACTIONS(3031),
    [sym_xint] = ACTIONS(3033),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3033),
    [sym__newline] = ACTIONS(3033),
    [sym__dedent] = ACTIONS(3033),
  },
  [1648] = {
    [sym_block_comment] = STATE(1648),
    [sym_compiler_directive_decl] = STATE(1648),
    [sym_fsi_directive_decl] = STATE(1648),
    [sym_preproc_line] = STATE(1648),
    [sym_identifier] = ACTIONS(2954),
    [anon_sym_EQ] = ACTIONS(2956),
    [anon_sym_COLON] = ACTIONS(2954),
    [anon_sym_return] = ACTIONS(2954),
    [anon_sym_do] = ACTIONS(2954),
    [anon_sym_let] = ACTIONS(2954),
    [anon_sym_let_BANG] = ACTIONS(2956),
    [anon_sym_as] = ACTIONS(2954),
    [anon_sym_LPAREN] = ACTIONS(2954),
    [anon_sym_COMMA] = ACTIONS(2956),
    [anon_sym_null] = ACTIONS(2954),
    [anon_sym_QMARK] = ACTIONS(2954),
    [anon_sym_COLON_QMARK] = ACTIONS(2954),
    [anon_sym_COLON_COLON] = ACTIONS(2956),
    [anon_sym_AMP] = ACTIONS(2954),
    [anon_sym_LBRACK] = ACTIONS(2954),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2956),
    [anon_sym_LBRACE] = ACTIONS(2954),
    [anon_sym_LT_AT] = ACTIONS(2954),
    [anon_sym_LT_AT_AT] = ACTIONS(2954),
    [anon_sym_DOT] = ACTIONS(2954),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2956),
    [anon_sym_new] = ACTIONS(2954),
    [anon_sym_with] = ACTIONS(2954),
    [anon_sym_return_BANG] = ACTIONS(2956),
    [anon_sym_yield] = ACTIONS(2954),
    [anon_sym_yield_BANG] = ACTIONS(2956),
    [anon_sym_lazy] = ACTIONS(2954),
    [anon_sym_assert] = ACTIONS(2954),
    [anon_sym_upcast] = ACTIONS(2954),
    [anon_sym_downcast] = ACTIONS(2954),
    [anon_sym_COLON_GT] = ACTIONS(2956),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2956),
    [anon_sym_for] = ACTIONS(2954),
    [anon_sym_while] = ACTIONS(2954),
    [anon_sym_if] = ACTIONS(2954),
    [anon_sym_fun] = ACTIONS(2954),
    [anon_sym_try] = ACTIONS(2954),
    [anon_sym_match] = ACTIONS(2954),
    [anon_sym_match_BANG] = ACTIONS(2956),
    [anon_sym_function] = ACTIONS(2954),
    [anon_sym_LT_DASH] = ACTIONS(2954),
    [anon_sym_DOT_LBRACK] = ACTIONS(2956),
    [anon_sym_LT] = ACTIONS(2956),
    [anon_sym_use] = ACTIONS(2954),
    [anon_sym_use_BANG] = ACTIONS(2956),
    [anon_sym_do_BANG] = ACTIONS(2956),
    [anon_sym_begin] = ACTIONS(2954),
    [anon_sym_LPAREN2] = ACTIONS(2954),
    [anon_sym_or] = ACTIONS(2954),
    [aux_sym_char_token1] = ACTIONS(2956),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2954),
    [anon_sym_DQUOTE] = ACTIONS(2954),
    [anon_sym_AT_DQUOTE] = ACTIONS(2956),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2956),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2956),
    [sym_bool] = ACTIONS(2954),
    [sym_unit] = ACTIONS(2956),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2954),
    [sym_op_identifier] = ACTIONS(2954),
    [anon_sym_PLUS] = ACTIONS(2954),
    [anon_sym_DASH] = ACTIONS(2954),
    [anon_sym_PLUS_DOT] = ACTIONS(2954),
    [anon_sym_DASH_DOT] = ACTIONS(2954),
    [anon_sym_PERCENT] = ACTIONS(2954),
    [anon_sym_AMP_AMP] = ACTIONS(2954),
    [anon_sym_TILDE] = ACTIONS(2956),
    [aux_sym_prefix_op_token1] = ACTIONS(2954),
    [aux_sym_infix_op_token1] = ACTIONS(2956),
    [aux_sym_infix_op_token2] = ACTIONS(2954),
    [anon_sym_PIPE_PIPE] = ACTIONS(2954),
    [anon_sym_BANG_EQ] = ACTIONS(2954),
    [anon_sym_COLON_EQ] = ACTIONS(2956),
    [anon_sym_DOLLAR] = ACTIONS(2954),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2954),
    [sym_int] = ACTIONS(2954),
    [sym_xint] = ACTIONS(2956),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2956),
    [sym__newline] = ACTIONS(2956),
    [sym__dedent] = ACTIONS(2956),
  },
  [1649] = {
    [sym_block_comment] = STATE(1649),
    [sym_compiler_directive_decl] = STATE(1649),
    [sym_fsi_directive_decl] = STATE(1649),
    [sym_preproc_line] = STATE(1649),
    [sym_identifier] = ACTIONS(2685),
    [anon_sym_EQ] = ACTIONS(2687),
    [anon_sym_COLON] = ACTIONS(2685),
    [anon_sym_return] = ACTIONS(2685),
    [anon_sym_do] = ACTIONS(2685),
    [anon_sym_let] = ACTIONS(2685),
    [anon_sym_let_BANG] = ACTIONS(2687),
    [anon_sym_LPAREN] = ACTIONS(2685),
    [anon_sym_COMMA] = ACTIONS(2687),
    [anon_sym_null] = ACTIONS(2685),
    [anon_sym_QMARK] = ACTIONS(2685),
    [anon_sym_COLON_QMARK] = ACTIONS(2685),
    [anon_sym_COLON_COLON] = ACTIONS(2687),
    [anon_sym_PIPE] = ACTIONS(2685),
    [anon_sym_AMP] = ACTIONS(2685),
    [anon_sym_LBRACK] = ACTIONS(2685),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2687),
    [anon_sym_LBRACE] = ACTIONS(2685),
    [anon_sym_LT_AT] = ACTIONS(2685),
    [anon_sym_LT_AT_AT] = ACTIONS(2685),
    [anon_sym_DOT] = ACTIONS(2685),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2687),
    [anon_sym_new] = ACTIONS(2685),
    [anon_sym_return_BANG] = ACTIONS(2687),
    [anon_sym_yield] = ACTIONS(2685),
    [anon_sym_yield_BANG] = ACTIONS(2687),
    [anon_sym_lazy] = ACTIONS(2685),
    [anon_sym_assert] = ACTIONS(2685),
    [anon_sym_upcast] = ACTIONS(2685),
    [anon_sym_downcast] = ACTIONS(2685),
    [anon_sym_COLON_GT] = ACTIONS(2687),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2687),
    [anon_sym_for] = ACTIONS(2685),
    [anon_sym_while] = ACTIONS(2685),
    [anon_sym_if] = ACTIONS(2685),
    [anon_sym_fun] = ACTIONS(2685),
    [anon_sym_try] = ACTIONS(2685),
    [anon_sym_match] = ACTIONS(2685),
    [anon_sym_match_BANG] = ACTIONS(2687),
    [anon_sym_function] = ACTIONS(2685),
    [anon_sym_LT_DASH] = ACTIONS(2685),
    [anon_sym_DOT_LBRACK] = ACTIONS(2687),
    [anon_sym_LT] = ACTIONS(2687),
    [anon_sym_use] = ACTIONS(2685),
    [anon_sym_use_BANG] = ACTIONS(2687),
    [anon_sym_do_BANG] = ACTIONS(2687),
    [anon_sym_begin] = ACTIONS(2685),
    [anon_sym_LPAREN2] = ACTIONS(2685),
    [anon_sym_or] = ACTIONS(2685),
    [aux_sym_char_token1] = ACTIONS(2687),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2685),
    [anon_sym_DQUOTE] = ACTIONS(2685),
    [anon_sym_AT_DQUOTE] = ACTIONS(2687),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2687),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2687),
    [sym_bool] = ACTIONS(2685),
    [sym_unit] = ACTIONS(2687),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2685),
    [sym_op_identifier] = ACTIONS(2685),
    [anon_sym_PLUS] = ACTIONS(2685),
    [anon_sym_DASH] = ACTIONS(2685),
    [anon_sym_PLUS_DOT] = ACTIONS(2685),
    [anon_sym_DASH_DOT] = ACTIONS(2685),
    [anon_sym_PERCENT] = ACTIONS(2685),
    [anon_sym_AMP_AMP] = ACTIONS(2685),
    [anon_sym_TILDE] = ACTIONS(2687),
    [aux_sym_prefix_op_token1] = ACTIONS(2685),
    [aux_sym_infix_op_token1] = ACTIONS(2687),
    [aux_sym_infix_op_token2] = ACTIONS(2685),
    [anon_sym_PIPE_PIPE] = ACTIONS(2685),
    [anon_sym_BANG_EQ] = ACTIONS(2685),
    [anon_sym_COLON_EQ] = ACTIONS(2687),
    [anon_sym_DOLLAR] = ACTIONS(2685),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2685),
    [sym_int] = ACTIONS(2685),
    [sym_xint] = ACTIONS(2687),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2687),
    [anon_sym_POUNDendif] = ACTIONS(2687),
    [anon_sym_POUNDelse] = ACTIONS(2687),
    [sym__newline] = ACTIONS(2687),
  },
  [1650] = {
    [sym_attributes] = STATE(2641),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(5241),
    [sym__pattern] = STATE(5154),
    [sym_optional_pattern] = STATE(5241),
    [sym_type_check_pattern] = STATE(5241),
    [sym_attribute_pattern] = STATE(5241),
    [sym_paren_pattern] = STATE(5241),
    [sym_as_pattern] = STATE(5241),
    [sym_cons_pattern] = STATE(5241),
    [sym_disjunct_pattern] = STATE(5241),
    [sym_conjunct_pattern] = STATE(5241),
    [sym_typed_pattern] = STATE(5241),
    [sym_list_pattern] = STATE(5241),
    [sym_array_pattern] = STATE(5241),
    [sym_record_pattern] = STATE(5241),
    [sym_named_field_pattern] = STATE(5241),
    [sym_identifier_pattern] = STATE(5241),
    [sym_long_identifier_or_op] = STATE(1721),
    [sym_char] = STATE(5389),
    [sym_format_string] = STATE(5273),
    [sym__string_literal] = STATE(5273),
    [sym_string] = STATE(5389),
    [sym_verbatim_string] = STATE(5389),
    [sym_bytearray] = STATE(5389),
    [sym_verbatim_bytearray] = STATE(5389),
    [sym_format_triple_quoted_string] = STATE(5377),
    [sym_triple_quoted_string] = STATE(5389),
    [sym_const] = STATE(5241),
    [sym_long_identifier] = STATE(3363),
    [sym_active_pattern] = STATE(3521),
    [sym__identifier_or_op] = STATE(3510),
    [sym_sbyte] = STATE(5389),
    [sym_byte] = STATE(5389),
    [sym_int16] = STATE(5389),
    [sym_uint16] = STATE(5389),
    [sym_int32] = STATE(5389),
    [sym_uint32] = STATE(5389),
    [sym_nativeint] = STATE(5389),
    [sym_unativeint] = STATE(5389),
    [sym_int64] = STATE(5389),
    [sym_uint64] = STATE(5389),
    [sym_ieee32] = STATE(5389),
    [sym_ieee64] = STATE(5389),
    [sym_bignum] = STATE(5389),
    [sym_decimal] = STATE(5389),
    [sym_float] = STATE(4893),
    [sym_block_comment] = STATE(1650),
    [sym_compiler_directive_decl] = STATE(1650),
    [sym_fsi_directive_decl] = STATE(1650),
    [sym_preproc_line] = STATE(1650),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [aux_sym_repeat_pattern_repeat1] = STATE(3362),
    [sym_identifier] = ACTIONS(3870),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_COLON] = ACTIONS(3716),
    [anon_sym_as] = ACTIONS(3849),
    [anon_sym_LPAREN] = ACTIONS(3872),
    [anon_sym_RPAREN] = ACTIONS(3714),
    [anon_sym_COMMA] = ACTIONS(3851),
    [anon_sym_null] = ACTIONS(3874),
    [anon_sym__] = ACTIONS(3876),
    [anon_sym_QMARK] = ACTIONS(3878),
    [anon_sym_COLON_QMARK] = ACTIONS(3880),
    [anon_sym_COLON_COLON] = ACTIONS(3853),
    [anon_sym_PIPE] = ACTIONS(3855),
    [anon_sym_AMP] = ACTIONS(3857),
    [anon_sym_LBRACK] = ACTIONS(3882),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3884),
    [anon_sym_LBRACE] = ACTIONS(3886),
    [anon_sym_RBRACE] = ACTIONS(3714),
    [aux_sym_char_token1] = ACTIONS(3888),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3890),
    [anon_sym_DQUOTE] = ACTIONS(3892),
    [anon_sym_AT_DQUOTE] = ACTIONS(3894),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3896),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3898),
    [sym_bool] = ACTIONS(3900),
    [sym_unit] = ACTIONS(3902),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3904),
    [sym_op_identifier] = ACTIONS(3906),
    [sym_int] = ACTIONS(3908),
    [sym_xint] = ACTIONS(3910),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [sym__newline] = ACTIONS(3714),
  },
  [1651] = {
    [sym_block_comment] = STATE(1651),
    [sym_compiler_directive_decl] = STATE(1651),
    [sym_fsi_directive_decl] = STATE(1651),
    [sym_preproc_line] = STATE(1651),
    [sym_identifier] = ACTIONS(3035),
    [anon_sym_EQ] = ACTIONS(3037),
    [anon_sym_COLON] = ACTIONS(3035),
    [anon_sym_return] = ACTIONS(3035),
    [anon_sym_do] = ACTIONS(3035),
    [anon_sym_let] = ACTIONS(3035),
    [anon_sym_let_BANG] = ACTIONS(3037),
    [anon_sym_as] = ACTIONS(3035),
    [anon_sym_LPAREN] = ACTIONS(3035),
    [anon_sym_COMMA] = ACTIONS(3037),
    [anon_sym_null] = ACTIONS(3035),
    [anon_sym_QMARK] = ACTIONS(3035),
    [anon_sym_COLON_QMARK] = ACTIONS(3035),
    [anon_sym_COLON_COLON] = ACTIONS(3037),
    [anon_sym_AMP] = ACTIONS(3035),
    [anon_sym_LBRACK] = ACTIONS(3035),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3037),
    [anon_sym_LBRACE] = ACTIONS(3035),
    [anon_sym_LT_AT] = ACTIONS(3035),
    [anon_sym_LT_AT_AT] = ACTIONS(3035),
    [anon_sym_DOT] = ACTIONS(3035),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3037),
    [anon_sym_new] = ACTIONS(3035),
    [anon_sym_with] = ACTIONS(3035),
    [anon_sym_return_BANG] = ACTIONS(3037),
    [anon_sym_yield] = ACTIONS(3035),
    [anon_sym_yield_BANG] = ACTIONS(3037),
    [anon_sym_lazy] = ACTIONS(3035),
    [anon_sym_assert] = ACTIONS(3035),
    [anon_sym_upcast] = ACTIONS(3035),
    [anon_sym_downcast] = ACTIONS(3035),
    [anon_sym_COLON_GT] = ACTIONS(3037),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3037),
    [anon_sym_for] = ACTIONS(3035),
    [anon_sym_while] = ACTIONS(3035),
    [anon_sym_if] = ACTIONS(3035),
    [anon_sym_fun] = ACTIONS(3035),
    [anon_sym_try] = ACTIONS(3035),
    [anon_sym_match] = ACTIONS(3035),
    [anon_sym_match_BANG] = ACTIONS(3037),
    [anon_sym_function] = ACTIONS(3035),
    [anon_sym_LT_DASH] = ACTIONS(3035),
    [anon_sym_DOT_LBRACK] = ACTIONS(3037),
    [anon_sym_LT] = ACTIONS(3037),
    [anon_sym_use] = ACTIONS(3035),
    [anon_sym_use_BANG] = ACTIONS(3037),
    [anon_sym_do_BANG] = ACTIONS(3037),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_LPAREN2] = ACTIONS(3035),
    [anon_sym_or] = ACTIONS(3035),
    [aux_sym_char_token1] = ACTIONS(3037),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3035),
    [anon_sym_DQUOTE] = ACTIONS(3035),
    [anon_sym_AT_DQUOTE] = ACTIONS(3037),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3037),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3037),
    [sym_bool] = ACTIONS(3035),
    [sym_unit] = ACTIONS(3037),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3035),
    [sym_op_identifier] = ACTIONS(3035),
    [anon_sym_PLUS] = ACTIONS(3035),
    [anon_sym_DASH] = ACTIONS(3035),
    [anon_sym_PLUS_DOT] = ACTIONS(3035),
    [anon_sym_DASH_DOT] = ACTIONS(3035),
    [anon_sym_PERCENT] = ACTIONS(3035),
    [anon_sym_AMP_AMP] = ACTIONS(3035),
    [anon_sym_TILDE] = ACTIONS(3037),
    [aux_sym_prefix_op_token1] = ACTIONS(3035),
    [aux_sym_infix_op_token1] = ACTIONS(3037),
    [aux_sym_infix_op_token2] = ACTIONS(3035),
    [anon_sym_PIPE_PIPE] = ACTIONS(3035),
    [anon_sym_BANG_EQ] = ACTIONS(3035),
    [anon_sym_COLON_EQ] = ACTIONS(3037),
    [anon_sym_DOLLAR] = ACTIONS(3035),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3035),
    [sym_int] = ACTIONS(3035),
    [sym_xint] = ACTIONS(3037),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3037),
    [sym__newline] = ACTIONS(3037),
    [sym__dedent] = ACTIONS(3037),
  },
  [1652] = {
    [sym_block_comment] = STATE(1652),
    [sym_compiler_directive_decl] = STATE(1652),
    [sym_fsi_directive_decl] = STATE(1652),
    [sym_preproc_line] = STATE(1652),
    [sym_identifier] = ACTIONS(2926),
    [anon_sym_EQ] = ACTIONS(2928),
    [anon_sym_COLON] = ACTIONS(2926),
    [anon_sym_return] = ACTIONS(2926),
    [anon_sym_do] = ACTIONS(2926),
    [anon_sym_let] = ACTIONS(2926),
    [anon_sym_let_BANG] = ACTIONS(2928),
    [anon_sym_as] = ACTIONS(2926),
    [anon_sym_LPAREN] = ACTIONS(2926),
    [anon_sym_COMMA] = ACTIONS(2928),
    [anon_sym_null] = ACTIONS(2926),
    [anon_sym_QMARK] = ACTIONS(2926),
    [anon_sym_COLON_QMARK] = ACTIONS(2926),
    [anon_sym_COLON_COLON] = ACTIONS(2928),
    [anon_sym_AMP] = ACTIONS(2926),
    [anon_sym_LBRACK] = ACTIONS(2926),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2928),
    [anon_sym_LBRACE] = ACTIONS(2926),
    [anon_sym_LT_AT] = ACTIONS(2926),
    [anon_sym_LT_AT_AT] = ACTIONS(2926),
    [anon_sym_DOT] = ACTIONS(2926),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2928),
    [anon_sym_new] = ACTIONS(2926),
    [anon_sym_with] = ACTIONS(2926),
    [anon_sym_return_BANG] = ACTIONS(2928),
    [anon_sym_yield] = ACTIONS(2926),
    [anon_sym_yield_BANG] = ACTIONS(2928),
    [anon_sym_lazy] = ACTIONS(2926),
    [anon_sym_assert] = ACTIONS(2926),
    [anon_sym_upcast] = ACTIONS(2926),
    [anon_sym_downcast] = ACTIONS(2926),
    [anon_sym_COLON_GT] = ACTIONS(2928),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2928),
    [anon_sym_for] = ACTIONS(2926),
    [anon_sym_while] = ACTIONS(2926),
    [anon_sym_if] = ACTIONS(2926),
    [anon_sym_fun] = ACTIONS(2926),
    [anon_sym_try] = ACTIONS(2926),
    [anon_sym_match] = ACTIONS(2926),
    [anon_sym_match_BANG] = ACTIONS(2928),
    [anon_sym_function] = ACTIONS(2926),
    [anon_sym_LT_DASH] = ACTIONS(2926),
    [anon_sym_DOT_LBRACK] = ACTIONS(2928),
    [anon_sym_LT] = ACTIONS(2928),
    [anon_sym_use] = ACTIONS(2926),
    [anon_sym_use_BANG] = ACTIONS(2928),
    [anon_sym_do_BANG] = ACTIONS(2928),
    [anon_sym_begin] = ACTIONS(2926),
    [anon_sym_LPAREN2] = ACTIONS(2926),
    [anon_sym_or] = ACTIONS(2926),
    [aux_sym_char_token1] = ACTIONS(2928),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2926),
    [anon_sym_DQUOTE] = ACTIONS(2926),
    [anon_sym_AT_DQUOTE] = ACTIONS(2928),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2928),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2928),
    [sym_bool] = ACTIONS(2926),
    [sym_unit] = ACTIONS(2928),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2926),
    [sym_op_identifier] = ACTIONS(2926),
    [anon_sym_PLUS] = ACTIONS(2926),
    [anon_sym_DASH] = ACTIONS(2926),
    [anon_sym_PLUS_DOT] = ACTIONS(2926),
    [anon_sym_DASH_DOT] = ACTIONS(2926),
    [anon_sym_PERCENT] = ACTIONS(2926),
    [anon_sym_AMP_AMP] = ACTIONS(2926),
    [anon_sym_TILDE] = ACTIONS(2928),
    [aux_sym_prefix_op_token1] = ACTIONS(2926),
    [aux_sym_infix_op_token1] = ACTIONS(2928),
    [aux_sym_infix_op_token2] = ACTIONS(2926),
    [anon_sym_PIPE_PIPE] = ACTIONS(2926),
    [anon_sym_BANG_EQ] = ACTIONS(2926),
    [anon_sym_COLON_EQ] = ACTIONS(2928),
    [anon_sym_DOLLAR] = ACTIONS(2926),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2926),
    [sym_int] = ACTIONS(2926),
    [sym_xint] = ACTIONS(2928),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2928),
    [sym__newline] = ACTIONS(2928),
    [sym__dedent] = ACTIONS(2928),
  },
  [1653] = {
    [sym_block_comment] = STATE(1653),
    [sym_compiler_directive_decl] = STATE(1653),
    [sym_fsi_directive_decl] = STATE(1653),
    [sym_preproc_line] = STATE(1653),
    [aux_sym_sequential_expression_repeat1] = STATE(1653),
    [sym_identifier] = ACTIONS(2895),
    [anon_sym_EQ] = ACTIONS(2897),
    [anon_sym_COLON] = ACTIONS(2895),
    [anon_sym_return] = ACTIONS(2895),
    [anon_sym_do] = ACTIONS(2895),
    [anon_sym_and] = ACTIONS(2895),
    [anon_sym_let] = ACTIONS(2895),
    [anon_sym_let_BANG] = ACTIONS(2897),
    [anon_sym_LPAREN] = ACTIONS(2895),
    [anon_sym_COMMA] = ACTIONS(2897),
    [anon_sym_null] = ACTIONS(2895),
    [anon_sym_QMARK] = ACTIONS(2895),
    [anon_sym_COLON_QMARK] = ACTIONS(2895),
    [anon_sym_COLON_COLON] = ACTIONS(2897),
    [anon_sym_AMP] = ACTIONS(2895),
    [anon_sym_LBRACK] = ACTIONS(2895),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2897),
    [anon_sym_LBRACE] = ACTIONS(2895),
    [anon_sym_LT_AT] = ACTIONS(2895),
    [anon_sym_LT_AT_AT] = ACTIONS(2895),
    [anon_sym_DOT] = ACTIONS(2895),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2897),
    [anon_sym_new] = ACTIONS(2895),
    [anon_sym_return_BANG] = ACTIONS(2897),
    [anon_sym_yield] = ACTIONS(2895),
    [anon_sym_yield_BANG] = ACTIONS(2897),
    [anon_sym_lazy] = ACTIONS(2895),
    [anon_sym_assert] = ACTIONS(2895),
    [anon_sym_upcast] = ACTIONS(2895),
    [anon_sym_downcast] = ACTIONS(2895),
    [anon_sym_COLON_GT] = ACTIONS(2897),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2897),
    [anon_sym_for] = ACTIONS(2895),
    [anon_sym_while] = ACTIONS(2895),
    [anon_sym_if] = ACTIONS(2895),
    [anon_sym_fun] = ACTIONS(2895),
    [anon_sym_try] = ACTIONS(2895),
    [anon_sym_match] = ACTIONS(2895),
    [anon_sym_match_BANG] = ACTIONS(2897),
    [anon_sym_function] = ACTIONS(2895),
    [anon_sym_LT_DASH] = ACTIONS(2895),
    [anon_sym_DOT_LBRACK] = ACTIONS(2897),
    [anon_sym_LT] = ACTIONS(2897),
    [anon_sym_use] = ACTIONS(2895),
    [anon_sym_use_BANG] = ACTIONS(2897),
    [anon_sym_do_BANG] = ACTIONS(2897),
    [anon_sym_begin] = ACTIONS(2895),
    [anon_sym_LPAREN2] = ACTIONS(2895),
    [anon_sym_or] = ACTIONS(2895),
    [aux_sym_char_token1] = ACTIONS(2897),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2895),
    [anon_sym_DQUOTE] = ACTIONS(2895),
    [anon_sym_AT_DQUOTE] = ACTIONS(2897),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2897),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2897),
    [sym_bool] = ACTIONS(2895),
    [sym_unit] = ACTIONS(2897),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2895),
    [sym_op_identifier] = ACTIONS(2895),
    [anon_sym_PLUS] = ACTIONS(2895),
    [anon_sym_DASH] = ACTIONS(2895),
    [anon_sym_PLUS_DOT] = ACTIONS(2895),
    [anon_sym_DASH_DOT] = ACTIONS(2895),
    [anon_sym_PERCENT] = ACTIONS(2895),
    [anon_sym_AMP_AMP] = ACTIONS(2895),
    [anon_sym_TILDE] = ACTIONS(2897),
    [aux_sym_prefix_op_token1] = ACTIONS(2895),
    [aux_sym_infix_op_token1] = ACTIONS(2897),
    [aux_sym_infix_op_token2] = ACTIONS(2895),
    [anon_sym_PIPE_PIPE] = ACTIONS(2895),
    [anon_sym_BANG_EQ] = ACTIONS(2895),
    [anon_sym_COLON_EQ] = ACTIONS(2897),
    [anon_sym_DOLLAR] = ACTIONS(2895),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2895),
    [sym_int] = ACTIONS(2895),
    [sym_xint] = ACTIONS(2897),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2897),
    [sym__newline] = ACTIONS(3912),
    [sym__dedent] = ACTIONS(2897),
  },
  [1654] = {
    [sym_block_comment] = STATE(1654),
    [sym_compiler_directive_decl] = STATE(1654),
    [sym_fsi_directive_decl] = STATE(1654),
    [sym_preproc_line] = STATE(1654),
    [sym_identifier] = ACTIONS(2770),
    [anon_sym_EQ] = ACTIONS(2772),
    [anon_sym_COLON] = ACTIONS(2770),
    [anon_sym_return] = ACTIONS(2770),
    [anon_sym_do] = ACTIONS(2770),
    [anon_sym_let] = ACTIONS(2770),
    [anon_sym_let_BANG] = ACTIONS(2772),
    [anon_sym_LPAREN] = ACTIONS(2770),
    [anon_sym_COMMA] = ACTIONS(2772),
    [anon_sym_null] = ACTIONS(2770),
    [anon_sym_QMARK] = ACTIONS(2770),
    [anon_sym_COLON_QMARK] = ACTIONS(2770),
    [anon_sym_COLON_COLON] = ACTIONS(2772),
    [anon_sym_AMP] = ACTIONS(2770),
    [anon_sym_LBRACK] = ACTIONS(2770),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2772),
    [anon_sym_LBRACE] = ACTIONS(2770),
    [anon_sym_LT_AT] = ACTIONS(2770),
    [anon_sym_LT_AT_AT] = ACTIONS(2770),
    [anon_sym_DOT] = ACTIONS(2770),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2772),
    [anon_sym_new] = ACTIONS(2770),
    [anon_sym_return_BANG] = ACTIONS(2772),
    [anon_sym_yield] = ACTIONS(2770),
    [anon_sym_yield_BANG] = ACTIONS(2772),
    [anon_sym_lazy] = ACTIONS(2770),
    [anon_sym_assert] = ACTIONS(2770),
    [anon_sym_upcast] = ACTIONS(2770),
    [anon_sym_downcast] = ACTIONS(2770),
    [anon_sym_COLON_GT] = ACTIONS(2772),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2772),
    [anon_sym_for] = ACTIONS(2770),
    [anon_sym_done] = ACTIONS(3915),
    [anon_sym_while] = ACTIONS(2770),
    [anon_sym_if] = ACTIONS(2770),
    [anon_sym_fun] = ACTIONS(2770),
    [anon_sym_try] = ACTIONS(2770),
    [anon_sym_match] = ACTIONS(2770),
    [anon_sym_match_BANG] = ACTIONS(2772),
    [anon_sym_function] = ACTIONS(2770),
    [anon_sym_LT_DASH] = ACTIONS(2770),
    [anon_sym_DOT_LBRACK] = ACTIONS(2772),
    [anon_sym_LT] = ACTIONS(2772),
    [anon_sym_use] = ACTIONS(2770),
    [anon_sym_use_BANG] = ACTIONS(2772),
    [anon_sym_do_BANG] = ACTIONS(2772),
    [anon_sym_begin] = ACTIONS(2770),
    [anon_sym_LPAREN2] = ACTIONS(2770),
    [anon_sym_or] = ACTIONS(2770),
    [aux_sym_char_token1] = ACTIONS(2772),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2770),
    [anon_sym_DQUOTE] = ACTIONS(2770),
    [anon_sym_AT_DQUOTE] = ACTIONS(2772),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2772),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2772),
    [sym_bool] = ACTIONS(2770),
    [sym_unit] = ACTIONS(2772),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2770),
    [sym_op_identifier] = ACTIONS(2770),
    [anon_sym_PLUS] = ACTIONS(2770),
    [anon_sym_DASH] = ACTIONS(2770),
    [anon_sym_PLUS_DOT] = ACTIONS(2770),
    [anon_sym_DASH_DOT] = ACTIONS(2770),
    [anon_sym_PERCENT] = ACTIONS(2770),
    [anon_sym_AMP_AMP] = ACTIONS(2770),
    [anon_sym_TILDE] = ACTIONS(2772),
    [aux_sym_prefix_op_token1] = ACTIONS(2770),
    [aux_sym_infix_op_token1] = ACTIONS(2772),
    [aux_sym_infix_op_token2] = ACTIONS(2770),
    [anon_sym_PIPE_PIPE] = ACTIONS(2770),
    [anon_sym_BANG_EQ] = ACTIONS(2770),
    [anon_sym_COLON_EQ] = ACTIONS(2772),
    [anon_sym_DOLLAR] = ACTIONS(2770),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2770),
    [sym_int] = ACTIONS(2770),
    [sym_xint] = ACTIONS(2772),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2772),
    [anon_sym_POUNDendif] = ACTIONS(2772),
    [anon_sym_POUNDelse] = ACTIONS(2772),
    [sym__newline] = ACTIONS(2772),
  },
  [1655] = {
    [sym_block_comment] = STATE(1655),
    [sym_compiler_directive_decl] = STATE(1655),
    [sym_fsi_directive_decl] = STATE(1655),
    [sym_preproc_line] = STATE(1655),
    [aux_sym_sequential_expression_repeat1] = STATE(1655),
    [sym_identifier] = ACTIONS(2895),
    [anon_sym_EQ] = ACTIONS(2897),
    [anon_sym_COLON] = ACTIONS(2895),
    [anon_sym_return] = ACTIONS(2895),
    [anon_sym_do] = ACTIONS(2895),
    [anon_sym_let] = ACTIONS(2895),
    [anon_sym_let_BANG] = ACTIONS(2897),
    [anon_sym_LPAREN] = ACTIONS(2895),
    [anon_sym_COMMA] = ACTIONS(2897),
    [anon_sym_null] = ACTIONS(2895),
    [anon_sym_QMARK] = ACTIONS(2895),
    [anon_sym_COLON_QMARK] = ACTIONS(2895),
    [anon_sym_COLON_COLON] = ACTIONS(2897),
    [anon_sym_AMP] = ACTIONS(2895),
    [anon_sym_LBRACK] = ACTIONS(2895),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2897),
    [anon_sym_LBRACE] = ACTIONS(2895),
    [anon_sym_LT_AT] = ACTIONS(2895),
    [anon_sym_LT_AT_AT] = ACTIONS(2895),
    [anon_sym_DOT] = ACTIONS(2895),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2897),
    [anon_sym_new] = ACTIONS(2895),
    [anon_sym_return_BANG] = ACTIONS(2897),
    [anon_sym_yield] = ACTIONS(2895),
    [anon_sym_yield_BANG] = ACTIONS(2897),
    [anon_sym_lazy] = ACTIONS(2895),
    [anon_sym_assert] = ACTIONS(2895),
    [anon_sym_upcast] = ACTIONS(2895),
    [anon_sym_downcast] = ACTIONS(2895),
    [anon_sym_COLON_GT] = ACTIONS(2897),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2897),
    [anon_sym_for] = ACTIONS(2895),
    [anon_sym_while] = ACTIONS(2895),
    [anon_sym_if] = ACTIONS(2895),
    [anon_sym_fun] = ACTIONS(2895),
    [anon_sym_try] = ACTIONS(2895),
    [anon_sym_match] = ACTIONS(2895),
    [anon_sym_match_BANG] = ACTIONS(2897),
    [anon_sym_function] = ACTIONS(2895),
    [anon_sym_LT_DASH] = ACTIONS(2895),
    [anon_sym_DOT_LBRACK] = ACTIONS(2897),
    [anon_sym_LT] = ACTIONS(2897),
    [anon_sym_use] = ACTIONS(2895),
    [anon_sym_use_BANG] = ACTIONS(2897),
    [anon_sym_do_BANG] = ACTIONS(2897),
    [anon_sym_begin] = ACTIONS(2895),
    [anon_sym_LPAREN2] = ACTIONS(2895),
    [anon_sym_DOT_DOT2] = ACTIONS(2897),
    [anon_sym_or] = ACTIONS(2895),
    [aux_sym_char_token1] = ACTIONS(2897),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2895),
    [anon_sym_DQUOTE] = ACTIONS(2895),
    [anon_sym_AT_DQUOTE] = ACTIONS(2897),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2897),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2897),
    [sym_bool] = ACTIONS(2895),
    [sym_unit] = ACTIONS(2897),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2895),
    [sym_op_identifier] = ACTIONS(2895),
    [anon_sym_PLUS] = ACTIONS(2895),
    [anon_sym_DASH] = ACTIONS(2895),
    [anon_sym_PLUS_DOT] = ACTIONS(2895),
    [anon_sym_DASH_DOT] = ACTIONS(2895),
    [anon_sym_PERCENT] = ACTIONS(2895),
    [anon_sym_AMP_AMP] = ACTIONS(2895),
    [anon_sym_TILDE] = ACTIONS(2897),
    [aux_sym_prefix_op_token1] = ACTIONS(2895),
    [aux_sym_infix_op_token1] = ACTIONS(2897),
    [aux_sym_infix_op_token2] = ACTIONS(2895),
    [anon_sym_PIPE_PIPE] = ACTIONS(2895),
    [anon_sym_BANG_EQ] = ACTIONS(2895),
    [anon_sym_COLON_EQ] = ACTIONS(2897),
    [anon_sym_DOLLAR] = ACTIONS(2895),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2895),
    [sym_int] = ACTIONS(2895),
    [sym_xint] = ACTIONS(2897),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2897),
    [sym__newline] = ACTIONS(3917),
    [sym__dedent] = ACTIONS(2897),
  },
  [1656] = {
    [sym_block_comment] = STATE(1656),
    [sym_compiler_directive_decl] = STATE(1656),
    [sym_fsi_directive_decl] = STATE(1656),
    [sym_preproc_line] = STATE(1656),
    [sym_identifier] = ACTIONS(2685),
    [anon_sym_EQ] = ACTIONS(2687),
    [anon_sym_COLON] = ACTIONS(2685),
    [anon_sym_return] = ACTIONS(2685),
    [anon_sym_do] = ACTIONS(2685),
    [anon_sym_let] = ACTIONS(2685),
    [anon_sym_let_BANG] = ACTIONS(2687),
    [anon_sym_LPAREN] = ACTIONS(2685),
    [anon_sym_COMMA] = ACTIONS(2687),
    [anon_sym_null] = ACTIONS(2685),
    [anon_sym_QMARK] = ACTIONS(2685),
    [anon_sym_COLON_QMARK] = ACTIONS(2685),
    [anon_sym_COLON_COLON] = ACTIONS(2687),
    [anon_sym_AMP] = ACTIONS(2685),
    [anon_sym_LBRACK] = ACTIONS(2685),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2687),
    [anon_sym_LBRACE] = ACTIONS(2685),
    [anon_sym_LT_AT] = ACTIONS(2685),
    [anon_sym_LT_AT_AT] = ACTIONS(2685),
    [anon_sym_DOT] = ACTIONS(2685),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2687),
    [anon_sym_new] = ACTIONS(2685),
    [anon_sym_return_BANG] = ACTIONS(2687),
    [anon_sym_yield] = ACTIONS(2685),
    [anon_sym_yield_BANG] = ACTIONS(2687),
    [anon_sym_lazy] = ACTIONS(2685),
    [anon_sym_assert] = ACTIONS(2685),
    [anon_sym_upcast] = ACTIONS(2685),
    [anon_sym_downcast] = ACTIONS(2685),
    [anon_sym_COLON_GT] = ACTIONS(2687),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2687),
    [anon_sym_for] = ACTIONS(2685),
    [anon_sym_done] = ACTIONS(2685),
    [anon_sym_while] = ACTIONS(2685),
    [anon_sym_if] = ACTIONS(2685),
    [anon_sym_fun] = ACTIONS(2685),
    [anon_sym_try] = ACTIONS(2685),
    [anon_sym_match] = ACTIONS(2685),
    [anon_sym_match_BANG] = ACTIONS(2687),
    [anon_sym_function] = ACTIONS(2685),
    [anon_sym_LT_DASH] = ACTIONS(2685),
    [anon_sym_DOT_LBRACK] = ACTIONS(2687),
    [anon_sym_LT] = ACTIONS(2687),
    [anon_sym_GT] = ACTIONS(2685),
    [anon_sym_use] = ACTIONS(2685),
    [anon_sym_use_BANG] = ACTIONS(2687),
    [anon_sym_do_BANG] = ACTIONS(2687),
    [anon_sym_DOT_DOT] = ACTIONS(2687),
    [anon_sym_begin] = ACTIONS(2685),
    [anon_sym_LPAREN2] = ACTIONS(2685),
    [anon_sym_or] = ACTIONS(2685),
    [aux_sym_char_token1] = ACTIONS(2687),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2685),
    [anon_sym_DQUOTE] = ACTIONS(2685),
    [anon_sym_AT_DQUOTE] = ACTIONS(2687),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2687),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2687),
    [sym_bool] = ACTIONS(2685),
    [sym_unit] = ACTIONS(2687),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2685),
    [sym_op_identifier] = ACTIONS(2685),
    [anon_sym_PLUS] = ACTIONS(2685),
    [anon_sym_DASH] = ACTIONS(2685),
    [anon_sym_PLUS_DOT] = ACTIONS(2685),
    [anon_sym_DASH_DOT] = ACTIONS(2685),
    [anon_sym_PERCENT] = ACTIONS(2685),
    [anon_sym_AMP_AMP] = ACTIONS(2685),
    [anon_sym_TILDE] = ACTIONS(2687),
    [aux_sym_prefix_op_token1] = ACTIONS(2685),
    [aux_sym_infix_op_token1] = ACTIONS(2687),
    [aux_sym_infix_op_token2] = ACTIONS(2685),
    [anon_sym_PIPE_PIPE] = ACTIONS(2685),
    [anon_sym_BANG_EQ] = ACTIONS(2685),
    [anon_sym_COLON_EQ] = ACTIONS(2687),
    [anon_sym_DOLLAR] = ACTIONS(2685),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2685),
    [sym_int] = ACTIONS(2685),
    [sym_xint] = ACTIONS(2687),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2687),
    [sym__newline] = ACTIONS(2687),
  },
  [1657] = {
    [sym_block_comment] = STATE(1657),
    [sym_compiler_directive_decl] = STATE(1657),
    [sym_fsi_directive_decl] = STATE(1657),
    [sym_preproc_line] = STATE(1657),
    [sym_identifier] = ACTIONS(2804),
    [anon_sym_EQ] = ACTIONS(2806),
    [anon_sym_COLON] = ACTIONS(2804),
    [anon_sym_return] = ACTIONS(2804),
    [anon_sym_do] = ACTIONS(2804),
    [anon_sym_let] = ACTIONS(2804),
    [anon_sym_let_BANG] = ACTIONS(2806),
    [anon_sym_LPAREN] = ACTIONS(2804),
    [anon_sym_COMMA] = ACTIONS(2806),
    [anon_sym_null] = ACTIONS(2804),
    [anon_sym_QMARK] = ACTIONS(2804),
    [anon_sym_COLON_QMARK] = ACTIONS(2804),
    [anon_sym_COLON_COLON] = ACTIONS(2806),
    [anon_sym_AMP] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2804),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(2804),
    [anon_sym_LT_AT] = ACTIONS(2804),
    [anon_sym_LT_AT_AT] = ACTIONS(2804),
    [anon_sym_DOT] = ACTIONS(2804),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2806),
    [anon_sym_new] = ACTIONS(2804),
    [anon_sym_return_BANG] = ACTIONS(2806),
    [anon_sym_yield] = ACTIONS(2804),
    [anon_sym_yield_BANG] = ACTIONS(2806),
    [anon_sym_lazy] = ACTIONS(2804),
    [anon_sym_assert] = ACTIONS(2804),
    [anon_sym_upcast] = ACTIONS(2804),
    [anon_sym_downcast] = ACTIONS(2804),
    [anon_sym_COLON_GT] = ACTIONS(2806),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2806),
    [anon_sym_for] = ACTIONS(2804),
    [anon_sym_done] = ACTIONS(3920),
    [anon_sym_while] = ACTIONS(2804),
    [anon_sym_if] = ACTIONS(2804),
    [anon_sym_fun] = ACTIONS(2804),
    [anon_sym_try] = ACTIONS(2804),
    [anon_sym_match] = ACTIONS(2804),
    [anon_sym_match_BANG] = ACTIONS(2806),
    [anon_sym_function] = ACTIONS(2804),
    [anon_sym_LT_DASH] = ACTIONS(2804),
    [anon_sym_DOT_LBRACK] = ACTIONS(2806),
    [anon_sym_LT] = ACTIONS(2806),
    [anon_sym_use] = ACTIONS(2804),
    [anon_sym_use_BANG] = ACTIONS(2806),
    [anon_sym_do_BANG] = ACTIONS(2806),
    [anon_sym_begin] = ACTIONS(2804),
    [anon_sym_LPAREN2] = ACTIONS(2804),
    [anon_sym_or] = ACTIONS(2804),
    [aux_sym_char_token1] = ACTIONS(2806),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2804),
    [anon_sym_DQUOTE] = ACTIONS(2804),
    [anon_sym_AT_DQUOTE] = ACTIONS(2806),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2806),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2806),
    [sym_bool] = ACTIONS(2804),
    [sym_unit] = ACTIONS(2806),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2804),
    [sym_op_identifier] = ACTIONS(2804),
    [anon_sym_PLUS] = ACTIONS(2804),
    [anon_sym_DASH] = ACTIONS(2804),
    [anon_sym_PLUS_DOT] = ACTIONS(2804),
    [anon_sym_DASH_DOT] = ACTIONS(2804),
    [anon_sym_PERCENT] = ACTIONS(2804),
    [anon_sym_AMP_AMP] = ACTIONS(2804),
    [anon_sym_TILDE] = ACTIONS(2806),
    [aux_sym_prefix_op_token1] = ACTIONS(2804),
    [aux_sym_infix_op_token1] = ACTIONS(2806),
    [aux_sym_infix_op_token2] = ACTIONS(2804),
    [anon_sym_PIPE_PIPE] = ACTIONS(2804),
    [anon_sym_BANG_EQ] = ACTIONS(2804),
    [anon_sym_COLON_EQ] = ACTIONS(2806),
    [anon_sym_DOLLAR] = ACTIONS(2804),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2804),
    [sym_int] = ACTIONS(2804),
    [sym_xint] = ACTIONS(2806),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2806),
    [anon_sym_POUNDendif] = ACTIONS(2806),
    [anon_sym_POUNDelse] = ACTIONS(2806),
    [sym__newline] = ACTIONS(2806),
  },
  [1658] = {
    [sym_block_comment] = STATE(1658),
    [sym_compiler_directive_decl] = STATE(1658),
    [sym_fsi_directive_decl] = STATE(1658),
    [sym_preproc_line] = STATE(1658),
    [sym_identifier] = ACTIONS(3095),
    [anon_sym_EQ] = ACTIONS(3097),
    [anon_sym_COLON] = ACTIONS(3095),
    [anon_sym_return] = ACTIONS(3095),
    [anon_sym_do] = ACTIONS(3095),
    [anon_sym_let] = ACTIONS(3095),
    [anon_sym_let_BANG] = ACTIONS(3097),
    [anon_sym_as] = ACTIONS(3095),
    [anon_sym_LPAREN] = ACTIONS(3095),
    [anon_sym_COMMA] = ACTIONS(3097),
    [anon_sym_null] = ACTIONS(3095),
    [anon_sym_QMARK] = ACTIONS(3095),
    [anon_sym_COLON_QMARK] = ACTIONS(3095),
    [anon_sym_COLON_COLON] = ACTIONS(3097),
    [anon_sym_AMP] = ACTIONS(3095),
    [anon_sym_LBRACK] = ACTIONS(3095),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3097),
    [anon_sym_LBRACE] = ACTIONS(3095),
    [anon_sym_LT_AT] = ACTIONS(3095),
    [anon_sym_LT_AT_AT] = ACTIONS(3095),
    [anon_sym_DOT] = ACTIONS(3095),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3097),
    [anon_sym_new] = ACTIONS(3095),
    [anon_sym_with] = ACTIONS(3095),
    [anon_sym_return_BANG] = ACTIONS(3097),
    [anon_sym_yield] = ACTIONS(3095),
    [anon_sym_yield_BANG] = ACTIONS(3097),
    [anon_sym_lazy] = ACTIONS(3095),
    [anon_sym_assert] = ACTIONS(3095),
    [anon_sym_upcast] = ACTIONS(3095),
    [anon_sym_downcast] = ACTIONS(3095),
    [anon_sym_COLON_GT] = ACTIONS(3097),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3097),
    [anon_sym_for] = ACTIONS(3095),
    [anon_sym_while] = ACTIONS(3095),
    [anon_sym_if] = ACTIONS(3095),
    [anon_sym_fun] = ACTIONS(3095),
    [anon_sym_try] = ACTIONS(3095),
    [anon_sym_match] = ACTIONS(3095),
    [anon_sym_match_BANG] = ACTIONS(3097),
    [anon_sym_function] = ACTIONS(3095),
    [anon_sym_LT_DASH] = ACTIONS(3095),
    [anon_sym_DOT_LBRACK] = ACTIONS(3097),
    [anon_sym_LT] = ACTIONS(3097),
    [anon_sym_use] = ACTIONS(3095),
    [anon_sym_use_BANG] = ACTIONS(3097),
    [anon_sym_do_BANG] = ACTIONS(3097),
    [anon_sym_begin] = ACTIONS(3095),
    [anon_sym_LPAREN2] = ACTIONS(3095),
    [anon_sym_or] = ACTIONS(3095),
    [aux_sym_char_token1] = ACTIONS(3097),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3095),
    [anon_sym_DQUOTE] = ACTIONS(3095),
    [anon_sym_AT_DQUOTE] = ACTIONS(3097),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3097),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3097),
    [sym_bool] = ACTIONS(3095),
    [sym_unit] = ACTIONS(3097),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3095),
    [sym_op_identifier] = ACTIONS(3095),
    [anon_sym_PLUS] = ACTIONS(3095),
    [anon_sym_DASH] = ACTIONS(3095),
    [anon_sym_PLUS_DOT] = ACTIONS(3095),
    [anon_sym_DASH_DOT] = ACTIONS(3095),
    [anon_sym_PERCENT] = ACTIONS(3095),
    [anon_sym_AMP_AMP] = ACTIONS(3095),
    [anon_sym_TILDE] = ACTIONS(3097),
    [aux_sym_prefix_op_token1] = ACTIONS(3095),
    [aux_sym_infix_op_token1] = ACTIONS(3097),
    [aux_sym_infix_op_token2] = ACTIONS(3095),
    [anon_sym_PIPE_PIPE] = ACTIONS(3095),
    [anon_sym_BANG_EQ] = ACTIONS(3095),
    [anon_sym_COLON_EQ] = ACTIONS(3097),
    [anon_sym_DOLLAR] = ACTIONS(3095),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3095),
    [sym_int] = ACTIONS(3095),
    [sym_xint] = ACTIONS(3097),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3097),
    [sym__newline] = ACTIONS(3097),
    [sym__dedent] = ACTIONS(3097),
  },
  [1659] = {
    [sym_block_comment] = STATE(1659),
    [sym_compiler_directive_decl] = STATE(1659),
    [sym_fsi_directive_decl] = STATE(1659),
    [sym_preproc_line] = STATE(1659),
    [sym_identifier] = ACTIONS(2748),
    [anon_sym_EQ] = ACTIONS(2750),
    [anon_sym_COLON] = ACTIONS(2748),
    [anon_sym_return] = ACTIONS(2748),
    [anon_sym_do] = ACTIONS(2748),
    [anon_sym_let] = ACTIONS(2748),
    [anon_sym_let_BANG] = ACTIONS(2750),
    [anon_sym_LPAREN] = ACTIONS(2748),
    [anon_sym_COMMA] = ACTIONS(2750),
    [anon_sym_null] = ACTIONS(2748),
    [anon_sym_QMARK] = ACTIONS(2748),
    [anon_sym_COLON_QMARK] = ACTIONS(2748),
    [anon_sym_COLON_COLON] = ACTIONS(2750),
    [anon_sym_AMP] = ACTIONS(2748),
    [anon_sym_LBRACK] = ACTIONS(2748),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2750),
    [anon_sym_LBRACE] = ACTIONS(2748),
    [anon_sym_LT_AT] = ACTIONS(2748),
    [anon_sym_LT_AT_AT] = ACTIONS(2748),
    [anon_sym_DOT] = ACTIONS(2748),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2750),
    [anon_sym_new] = ACTIONS(2748),
    [anon_sym_return_BANG] = ACTIONS(2750),
    [anon_sym_yield] = ACTIONS(2748),
    [anon_sym_yield_BANG] = ACTIONS(2750),
    [anon_sym_lazy] = ACTIONS(2748),
    [anon_sym_assert] = ACTIONS(2748),
    [anon_sym_upcast] = ACTIONS(2748),
    [anon_sym_downcast] = ACTIONS(2748),
    [anon_sym_COLON_GT] = ACTIONS(2750),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2750),
    [anon_sym_for] = ACTIONS(2748),
    [anon_sym_while] = ACTIONS(2748),
    [anon_sym_else] = ACTIONS(2748),
    [anon_sym_elif] = ACTIONS(2748),
    [anon_sym_if] = ACTIONS(2748),
    [anon_sym_fun] = ACTIONS(2748),
    [anon_sym_try] = ACTIONS(2748),
    [anon_sym_match] = ACTIONS(2748),
    [anon_sym_match_BANG] = ACTIONS(2750),
    [anon_sym_function] = ACTIONS(2748),
    [anon_sym_LT_DASH] = ACTIONS(2748),
    [anon_sym_DOT_LBRACK] = ACTIONS(2750),
    [anon_sym_LT] = ACTIONS(2750),
    [anon_sym_use] = ACTIONS(2748),
    [anon_sym_use_BANG] = ACTIONS(2750),
    [anon_sym_do_BANG] = ACTIONS(2750),
    [anon_sym_DOT_DOT] = ACTIONS(2750),
    [anon_sym_begin] = ACTIONS(2748),
    [anon_sym_LPAREN2] = ACTIONS(2748),
    [anon_sym_or] = ACTIONS(2748),
    [aux_sym_char_token1] = ACTIONS(2750),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2748),
    [anon_sym_DQUOTE] = ACTIONS(2748),
    [anon_sym_AT_DQUOTE] = ACTIONS(2750),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2750),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2750),
    [sym_bool] = ACTIONS(2748),
    [sym_unit] = ACTIONS(2750),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2748),
    [sym_op_identifier] = ACTIONS(2748),
    [anon_sym_PLUS] = ACTIONS(2748),
    [anon_sym_DASH] = ACTIONS(2748),
    [anon_sym_PLUS_DOT] = ACTIONS(2748),
    [anon_sym_DASH_DOT] = ACTIONS(2748),
    [anon_sym_PERCENT] = ACTIONS(2748),
    [anon_sym_AMP_AMP] = ACTIONS(2748),
    [anon_sym_TILDE] = ACTIONS(2750),
    [aux_sym_prefix_op_token1] = ACTIONS(2748),
    [aux_sym_infix_op_token1] = ACTIONS(2750),
    [aux_sym_infix_op_token2] = ACTIONS(2748),
    [anon_sym_PIPE_PIPE] = ACTIONS(2748),
    [anon_sym_BANG_EQ] = ACTIONS(2748),
    [anon_sym_COLON_EQ] = ACTIONS(2750),
    [anon_sym_DOLLAR] = ACTIONS(2748),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2748),
    [sym_int] = ACTIONS(2748),
    [sym_xint] = ACTIONS(2750),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2750),
    [sym__newline] = ACTIONS(2750),
  },
  [1660] = {
    [sym_block_comment] = STATE(1660),
    [sym_compiler_directive_decl] = STATE(1660),
    [sym_fsi_directive_decl] = STATE(1660),
    [sym_preproc_line] = STATE(1660),
    [sym_identifier] = ACTIONS(2766),
    [anon_sym_EQ] = ACTIONS(2768),
    [anon_sym_COLON] = ACTIONS(2766),
    [anon_sym_return] = ACTIONS(2766),
    [anon_sym_do] = ACTIONS(2766),
    [anon_sym_let] = ACTIONS(2766),
    [anon_sym_let_BANG] = ACTIONS(2768),
    [anon_sym_as] = ACTIONS(2766),
    [anon_sym_LPAREN] = ACTIONS(2766),
    [anon_sym_COMMA] = ACTIONS(2768),
    [anon_sym_null] = ACTIONS(2766),
    [anon_sym_QMARK] = ACTIONS(2766),
    [anon_sym_COLON_QMARK] = ACTIONS(2766),
    [anon_sym_COLON_COLON] = ACTIONS(2768),
    [anon_sym_PIPE] = ACTIONS(2766),
    [anon_sym_AMP] = ACTIONS(2766),
    [anon_sym_LBRACK] = ACTIONS(2766),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2768),
    [anon_sym_LBRACE] = ACTIONS(2766),
    [anon_sym_LT_AT] = ACTIONS(2766),
    [anon_sym_LT_AT_AT] = ACTIONS(2766),
    [anon_sym_DOT] = ACTIONS(2766),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2768),
    [anon_sym_new] = ACTIONS(2766),
    [anon_sym_with] = ACTIONS(2766),
    [anon_sym_return_BANG] = ACTIONS(2768),
    [anon_sym_yield] = ACTIONS(2766),
    [anon_sym_yield_BANG] = ACTIONS(2768),
    [anon_sym_lazy] = ACTIONS(2766),
    [anon_sym_assert] = ACTIONS(2766),
    [anon_sym_upcast] = ACTIONS(2766),
    [anon_sym_downcast] = ACTIONS(2766),
    [anon_sym_COLON_GT] = ACTIONS(2768),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2768),
    [anon_sym_for] = ACTIONS(2766),
    [anon_sym_while] = ACTIONS(2766),
    [anon_sym_if] = ACTIONS(2766),
    [anon_sym_fun] = ACTIONS(2766),
    [anon_sym_try] = ACTIONS(2766),
    [anon_sym_match] = ACTIONS(2766),
    [anon_sym_match_BANG] = ACTIONS(2768),
    [anon_sym_function] = ACTIONS(2766),
    [anon_sym_LT_DASH] = ACTIONS(2766),
    [anon_sym_DOT_LBRACK] = ACTIONS(2768),
    [anon_sym_LT] = ACTIONS(2768),
    [anon_sym_use] = ACTIONS(2766),
    [anon_sym_use_BANG] = ACTIONS(2768),
    [anon_sym_do_BANG] = ACTIONS(2768),
    [anon_sym_begin] = ACTIONS(2766),
    [anon_sym_LPAREN2] = ACTIONS(2766),
    [anon_sym_or] = ACTIONS(2766),
    [aux_sym_char_token1] = ACTIONS(2768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2766),
    [anon_sym_DQUOTE] = ACTIONS(2766),
    [anon_sym_AT_DQUOTE] = ACTIONS(2768),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2768),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2768),
    [sym_bool] = ACTIONS(2766),
    [sym_unit] = ACTIONS(2768),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2766),
    [sym_op_identifier] = ACTIONS(2766),
    [anon_sym_PLUS] = ACTIONS(2766),
    [anon_sym_DASH] = ACTIONS(2766),
    [anon_sym_PLUS_DOT] = ACTIONS(2766),
    [anon_sym_DASH_DOT] = ACTIONS(2766),
    [anon_sym_PERCENT] = ACTIONS(2766),
    [anon_sym_AMP_AMP] = ACTIONS(2766),
    [anon_sym_TILDE] = ACTIONS(2768),
    [aux_sym_prefix_op_token1] = ACTIONS(2766),
    [aux_sym_infix_op_token1] = ACTIONS(2768),
    [aux_sym_infix_op_token2] = ACTIONS(2766),
    [anon_sym_PIPE_PIPE] = ACTIONS(2766),
    [anon_sym_BANG_EQ] = ACTIONS(2766),
    [anon_sym_COLON_EQ] = ACTIONS(2768),
    [anon_sym_DOLLAR] = ACTIONS(2766),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2766),
    [sym_int] = ACTIONS(2766),
    [sym_xint] = ACTIONS(2768),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2768),
    [sym__newline] = ACTIONS(2768),
  },
  [1661] = {
    [sym_block_comment] = STATE(1661),
    [sym_compiler_directive_decl] = STATE(1661),
    [sym_fsi_directive_decl] = STATE(1661),
    [sym_preproc_line] = STATE(1661),
    [sym_identifier] = ACTIONS(2766),
    [anon_sym_EQ] = ACTIONS(2768),
    [anon_sym_COLON] = ACTIONS(2766),
    [anon_sym_return] = ACTIONS(2766),
    [anon_sym_do] = ACTIONS(2766),
    [anon_sym_and] = ACTIONS(2766),
    [anon_sym_let] = ACTIONS(2766),
    [anon_sym_let_BANG] = ACTIONS(2768),
    [anon_sym_LPAREN] = ACTIONS(2766),
    [anon_sym_COMMA] = ACTIONS(2768),
    [anon_sym_null] = ACTIONS(2766),
    [anon_sym_QMARK] = ACTIONS(2766),
    [anon_sym_COLON_QMARK] = ACTIONS(2766),
    [anon_sym_COLON_COLON] = ACTIONS(2768),
    [anon_sym_PIPE] = ACTIONS(2766),
    [anon_sym_AMP] = ACTIONS(2766),
    [anon_sym_LBRACK] = ACTIONS(2766),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2768),
    [anon_sym_LBRACE] = ACTIONS(2766),
    [anon_sym_LT_AT] = ACTIONS(2766),
    [anon_sym_LT_AT_AT] = ACTIONS(2766),
    [anon_sym_DOT] = ACTIONS(2766),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2768),
    [anon_sym_new] = ACTIONS(2766),
    [anon_sym_return_BANG] = ACTIONS(2768),
    [anon_sym_yield] = ACTIONS(2766),
    [anon_sym_yield_BANG] = ACTIONS(2768),
    [anon_sym_lazy] = ACTIONS(2766),
    [anon_sym_assert] = ACTIONS(2766),
    [anon_sym_upcast] = ACTIONS(2766),
    [anon_sym_downcast] = ACTIONS(2766),
    [anon_sym_COLON_GT] = ACTIONS(2768),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2768),
    [anon_sym_for] = ACTIONS(2766),
    [anon_sym_while] = ACTIONS(2766),
    [anon_sym_if] = ACTIONS(2766),
    [anon_sym_fun] = ACTIONS(2766),
    [anon_sym_try] = ACTIONS(2766),
    [anon_sym_match] = ACTIONS(2766),
    [anon_sym_match_BANG] = ACTIONS(2768),
    [anon_sym_function] = ACTIONS(2766),
    [anon_sym_LT_DASH] = ACTIONS(2766),
    [anon_sym_DOT_LBRACK] = ACTIONS(2768),
    [anon_sym_LT] = ACTIONS(2768),
    [anon_sym_use] = ACTIONS(2766),
    [anon_sym_use_BANG] = ACTIONS(2768),
    [anon_sym_do_BANG] = ACTIONS(2768),
    [anon_sym_begin] = ACTIONS(2766),
    [anon_sym_LPAREN2] = ACTIONS(2766),
    [anon_sym_or] = ACTIONS(2766),
    [aux_sym_char_token1] = ACTIONS(2768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2766),
    [anon_sym_DQUOTE] = ACTIONS(2766),
    [anon_sym_AT_DQUOTE] = ACTIONS(2768),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2768),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2768),
    [sym_bool] = ACTIONS(2766),
    [sym_unit] = ACTIONS(2768),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2766),
    [sym_op_identifier] = ACTIONS(2766),
    [anon_sym_PLUS] = ACTIONS(2766),
    [anon_sym_DASH] = ACTIONS(2766),
    [anon_sym_PLUS_DOT] = ACTIONS(2766),
    [anon_sym_DASH_DOT] = ACTIONS(2766),
    [anon_sym_PERCENT] = ACTIONS(2766),
    [anon_sym_AMP_AMP] = ACTIONS(2766),
    [anon_sym_TILDE] = ACTIONS(2768),
    [aux_sym_prefix_op_token1] = ACTIONS(2766),
    [aux_sym_infix_op_token1] = ACTIONS(2768),
    [aux_sym_infix_op_token2] = ACTIONS(2766),
    [anon_sym_PIPE_PIPE] = ACTIONS(2766),
    [anon_sym_BANG_EQ] = ACTIONS(2766),
    [anon_sym_COLON_EQ] = ACTIONS(2768),
    [anon_sym_DOLLAR] = ACTIONS(2766),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2766),
    [sym_int] = ACTIONS(2766),
    [sym_xint] = ACTIONS(2768),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2768),
    [sym__newline] = ACTIONS(2768),
    [sym__dedent] = ACTIONS(2768),
  },
  [1662] = {
    [sym_block_comment] = STATE(1662),
    [sym_compiler_directive_decl] = STATE(1662),
    [sym_fsi_directive_decl] = STATE(1662),
    [sym_preproc_line] = STATE(1662),
    [sym_identifier] = ACTIONS(2713),
    [anon_sym_EQ] = ACTIONS(2715),
    [anon_sym_COLON] = ACTIONS(2713),
    [anon_sym_return] = ACTIONS(2713),
    [anon_sym_do] = ACTIONS(2713),
    [anon_sym_and] = ACTIONS(2713),
    [anon_sym_let] = ACTIONS(2713),
    [anon_sym_let_BANG] = ACTIONS(2715),
    [anon_sym_LPAREN] = ACTIONS(2713),
    [anon_sym_COMMA] = ACTIONS(2715),
    [anon_sym_null] = ACTIONS(2713),
    [anon_sym_QMARK] = ACTIONS(2713),
    [anon_sym_COLON_QMARK] = ACTIONS(2713),
    [anon_sym_COLON_COLON] = ACTIONS(2715),
    [anon_sym_PIPE] = ACTIONS(2713),
    [anon_sym_AMP] = ACTIONS(2713),
    [anon_sym_LBRACK] = ACTIONS(2713),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2715),
    [anon_sym_LBRACE] = ACTIONS(2713),
    [anon_sym_LT_AT] = ACTIONS(2713),
    [anon_sym_LT_AT_AT] = ACTIONS(2713),
    [anon_sym_DOT] = ACTIONS(2713),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2715),
    [anon_sym_new] = ACTIONS(2713),
    [anon_sym_return_BANG] = ACTIONS(2715),
    [anon_sym_yield] = ACTIONS(2713),
    [anon_sym_yield_BANG] = ACTIONS(2715),
    [anon_sym_lazy] = ACTIONS(2713),
    [anon_sym_assert] = ACTIONS(2713),
    [anon_sym_upcast] = ACTIONS(2713),
    [anon_sym_downcast] = ACTIONS(2713),
    [anon_sym_COLON_GT] = ACTIONS(2715),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2715),
    [anon_sym_for] = ACTIONS(2713),
    [anon_sym_while] = ACTIONS(2713),
    [anon_sym_if] = ACTIONS(2713),
    [anon_sym_fun] = ACTIONS(2713),
    [anon_sym_try] = ACTIONS(2713),
    [anon_sym_match] = ACTIONS(2713),
    [anon_sym_match_BANG] = ACTIONS(2715),
    [anon_sym_function] = ACTIONS(2713),
    [anon_sym_LT_DASH] = ACTIONS(2713),
    [anon_sym_DOT_LBRACK] = ACTIONS(2715),
    [anon_sym_LT] = ACTIONS(2715),
    [anon_sym_use] = ACTIONS(2713),
    [anon_sym_use_BANG] = ACTIONS(2715),
    [anon_sym_do_BANG] = ACTIONS(2715),
    [anon_sym_begin] = ACTIONS(2713),
    [anon_sym_LPAREN2] = ACTIONS(2713),
    [anon_sym_or] = ACTIONS(2713),
    [aux_sym_char_token1] = ACTIONS(2715),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2713),
    [anon_sym_DQUOTE] = ACTIONS(2713),
    [anon_sym_AT_DQUOTE] = ACTIONS(2715),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2715),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2715),
    [sym_bool] = ACTIONS(2713),
    [sym_unit] = ACTIONS(2715),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2713),
    [sym_op_identifier] = ACTIONS(2713),
    [anon_sym_PLUS] = ACTIONS(2713),
    [anon_sym_DASH] = ACTIONS(2713),
    [anon_sym_PLUS_DOT] = ACTIONS(2713),
    [anon_sym_DASH_DOT] = ACTIONS(2713),
    [anon_sym_PERCENT] = ACTIONS(2713),
    [anon_sym_AMP_AMP] = ACTIONS(2713),
    [anon_sym_TILDE] = ACTIONS(2715),
    [aux_sym_prefix_op_token1] = ACTIONS(2713),
    [aux_sym_infix_op_token1] = ACTIONS(2715),
    [aux_sym_infix_op_token2] = ACTIONS(2713),
    [anon_sym_PIPE_PIPE] = ACTIONS(2713),
    [anon_sym_BANG_EQ] = ACTIONS(2713),
    [anon_sym_COLON_EQ] = ACTIONS(2715),
    [anon_sym_DOLLAR] = ACTIONS(2713),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2713),
    [sym_int] = ACTIONS(2713),
    [sym_xint] = ACTIONS(2715),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2715),
    [sym__newline] = ACTIONS(2715),
    [sym__dedent] = ACTIONS(2715),
  },
  [1663] = {
    [sym_block_comment] = STATE(1663),
    [sym_compiler_directive_decl] = STATE(1663),
    [sym_fsi_directive_decl] = STATE(1663),
    [sym_preproc_line] = STATE(1663),
    [sym_identifier] = ACTIONS(2713),
    [anon_sym_EQ] = ACTIONS(2715),
    [anon_sym_COLON] = ACTIONS(2713),
    [anon_sym_return] = ACTIONS(2713),
    [anon_sym_do] = ACTIONS(2713),
    [anon_sym_let] = ACTIONS(2713),
    [anon_sym_let_BANG] = ACTIONS(2715),
    [anon_sym_as] = ACTIONS(2713),
    [anon_sym_LPAREN] = ACTIONS(2713),
    [anon_sym_COMMA] = ACTIONS(2715),
    [anon_sym_null] = ACTIONS(2713),
    [anon_sym_QMARK] = ACTIONS(2713),
    [anon_sym_COLON_QMARK] = ACTIONS(2713),
    [anon_sym_COLON_COLON] = ACTIONS(2715),
    [anon_sym_PIPE] = ACTIONS(2713),
    [anon_sym_AMP] = ACTIONS(2713),
    [anon_sym_LBRACK] = ACTIONS(2713),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2715),
    [anon_sym_LBRACE] = ACTIONS(2713),
    [anon_sym_LT_AT] = ACTIONS(2713),
    [anon_sym_LT_AT_AT] = ACTIONS(2713),
    [anon_sym_DOT] = ACTIONS(2713),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2715),
    [anon_sym_new] = ACTIONS(2713),
    [anon_sym_with] = ACTIONS(2713),
    [anon_sym_return_BANG] = ACTIONS(2715),
    [anon_sym_yield] = ACTIONS(2713),
    [anon_sym_yield_BANG] = ACTIONS(2715),
    [anon_sym_lazy] = ACTIONS(2713),
    [anon_sym_assert] = ACTIONS(2713),
    [anon_sym_upcast] = ACTIONS(2713),
    [anon_sym_downcast] = ACTIONS(2713),
    [anon_sym_COLON_GT] = ACTIONS(2715),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2715),
    [anon_sym_for] = ACTIONS(2713),
    [anon_sym_while] = ACTIONS(2713),
    [anon_sym_if] = ACTIONS(2713),
    [anon_sym_fun] = ACTIONS(2713),
    [anon_sym_try] = ACTIONS(2713),
    [anon_sym_match] = ACTIONS(2713),
    [anon_sym_match_BANG] = ACTIONS(2715),
    [anon_sym_function] = ACTIONS(2713),
    [anon_sym_LT_DASH] = ACTIONS(2713),
    [anon_sym_DOT_LBRACK] = ACTIONS(2715),
    [anon_sym_LT] = ACTIONS(2715),
    [anon_sym_use] = ACTIONS(2713),
    [anon_sym_use_BANG] = ACTIONS(2715),
    [anon_sym_do_BANG] = ACTIONS(2715),
    [anon_sym_begin] = ACTIONS(2713),
    [anon_sym_LPAREN2] = ACTIONS(2713),
    [anon_sym_or] = ACTIONS(2713),
    [aux_sym_char_token1] = ACTIONS(2715),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2713),
    [anon_sym_DQUOTE] = ACTIONS(2713),
    [anon_sym_AT_DQUOTE] = ACTIONS(2715),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2715),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2715),
    [sym_bool] = ACTIONS(2713),
    [sym_unit] = ACTIONS(2715),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2713),
    [sym_op_identifier] = ACTIONS(2713),
    [anon_sym_PLUS] = ACTIONS(2713),
    [anon_sym_DASH] = ACTIONS(2713),
    [anon_sym_PLUS_DOT] = ACTIONS(2713),
    [anon_sym_DASH_DOT] = ACTIONS(2713),
    [anon_sym_PERCENT] = ACTIONS(2713),
    [anon_sym_AMP_AMP] = ACTIONS(2713),
    [anon_sym_TILDE] = ACTIONS(2715),
    [aux_sym_prefix_op_token1] = ACTIONS(2713),
    [aux_sym_infix_op_token1] = ACTIONS(2715),
    [aux_sym_infix_op_token2] = ACTIONS(2713),
    [anon_sym_PIPE_PIPE] = ACTIONS(2713),
    [anon_sym_BANG_EQ] = ACTIONS(2713),
    [anon_sym_COLON_EQ] = ACTIONS(2715),
    [anon_sym_DOLLAR] = ACTIONS(2713),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2713),
    [sym_int] = ACTIONS(2713),
    [sym_xint] = ACTIONS(2715),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2715),
    [sym__newline] = ACTIONS(2715),
  },
  [1664] = {
    [sym_block_comment] = STATE(1664),
    [sym_compiler_directive_decl] = STATE(1664),
    [sym_fsi_directive_decl] = STATE(1664),
    [sym_preproc_line] = STATE(1664),
    [sym_identifier] = ACTIONS(2812),
    [anon_sym_EQ] = ACTIONS(2814),
    [anon_sym_COLON] = ACTIONS(2812),
    [anon_sym_return] = ACTIONS(2812),
    [anon_sym_do] = ACTIONS(2812),
    [anon_sym_let] = ACTIONS(2812),
    [anon_sym_let_BANG] = ACTIONS(2814),
    [anon_sym_LPAREN] = ACTIONS(2812),
    [anon_sym_COMMA] = ACTIONS(2814),
    [anon_sym_null] = ACTIONS(2812),
    [anon_sym_QMARK] = ACTIONS(2812),
    [anon_sym_COLON_QMARK] = ACTIONS(2812),
    [anon_sym_COLON_COLON] = ACTIONS(2814),
    [anon_sym_AMP] = ACTIONS(2812),
    [anon_sym_LBRACK] = ACTIONS(2812),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2814),
    [anon_sym_LBRACE] = ACTIONS(2812),
    [anon_sym_LT_AT] = ACTIONS(2812),
    [anon_sym_AT_GT] = ACTIONS(2812),
    [anon_sym_LT_AT_AT] = ACTIONS(2812),
    [anon_sym_DOT] = ACTIONS(2812),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2814),
    [anon_sym_new] = ACTIONS(2812),
    [anon_sym_return_BANG] = ACTIONS(2814),
    [anon_sym_yield] = ACTIONS(2812),
    [anon_sym_yield_BANG] = ACTIONS(2814),
    [anon_sym_lazy] = ACTIONS(2812),
    [anon_sym_assert] = ACTIONS(2812),
    [anon_sym_upcast] = ACTIONS(2812),
    [anon_sym_downcast] = ACTIONS(2812),
    [anon_sym_COLON_GT] = ACTIONS(2814),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2814),
    [anon_sym_for] = ACTIONS(2812),
    [anon_sym_while] = ACTIONS(2812),
    [anon_sym_if] = ACTIONS(2812),
    [anon_sym_fun] = ACTIONS(2812),
    [anon_sym_try] = ACTIONS(2812),
    [anon_sym_match] = ACTIONS(2812),
    [anon_sym_match_BANG] = ACTIONS(2814),
    [anon_sym_function] = ACTIONS(2812),
    [anon_sym_LT_DASH] = ACTIONS(2812),
    [anon_sym_DOT_LBRACK] = ACTIONS(2814),
    [anon_sym_LT] = ACTIONS(2814),
    [anon_sym_use] = ACTIONS(2812),
    [anon_sym_use_BANG] = ACTIONS(2814),
    [anon_sym_do_BANG] = ACTIONS(2814),
    [anon_sym_begin] = ACTIONS(2812),
    [anon_sym_LPAREN2] = ACTIONS(2812),
    [anon_sym_or] = ACTIONS(2812),
    [aux_sym_char_token1] = ACTIONS(2814),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2812),
    [anon_sym_DQUOTE] = ACTIONS(2812),
    [anon_sym_AT_DQUOTE] = ACTIONS(2814),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2814),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2814),
    [sym_bool] = ACTIONS(2812),
    [sym_unit] = ACTIONS(2814),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2812),
    [sym_op_identifier] = ACTIONS(2812),
    [anon_sym_PLUS] = ACTIONS(2812),
    [anon_sym_DASH] = ACTIONS(2812),
    [anon_sym_PLUS_DOT] = ACTIONS(2812),
    [anon_sym_DASH_DOT] = ACTIONS(2812),
    [anon_sym_PERCENT] = ACTIONS(2812),
    [anon_sym_AMP_AMP] = ACTIONS(2812),
    [anon_sym_TILDE] = ACTIONS(2814),
    [aux_sym_prefix_op_token1] = ACTIONS(2812),
    [aux_sym_infix_op_token1] = ACTIONS(2814),
    [aux_sym_infix_op_token2] = ACTIONS(2812),
    [anon_sym_PIPE_PIPE] = ACTIONS(2812),
    [anon_sym_BANG_EQ] = ACTIONS(2812),
    [anon_sym_COLON_EQ] = ACTIONS(2814),
    [anon_sym_DOLLAR] = ACTIONS(2812),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2812),
    [sym_int] = ACTIONS(2812),
    [sym_xint] = ACTIONS(2814),
    [anon_sym_f] = ACTIONS(2812),
    [aux_sym_decimal_token1] = ACTIONS(2812),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2814),
    [sym__newline] = ACTIONS(2814),
  },
  [1665] = {
    [sym_block_comment] = STATE(1665),
    [sym_compiler_directive_decl] = STATE(1665),
    [sym_fsi_directive_decl] = STATE(1665),
    [sym_preproc_line] = STATE(1665),
    [sym_identifier] = ACTIONS(2756),
    [anon_sym_EQ] = ACTIONS(2758),
    [anon_sym_COLON] = ACTIONS(2756),
    [anon_sym_return] = ACTIONS(2756),
    [anon_sym_do] = ACTIONS(2756),
    [anon_sym_and] = ACTIONS(2756),
    [anon_sym_let] = ACTIONS(2756),
    [anon_sym_let_BANG] = ACTIONS(2758),
    [anon_sym_LPAREN] = ACTIONS(2756),
    [anon_sym_COMMA] = ACTIONS(2758),
    [anon_sym_null] = ACTIONS(2756),
    [anon_sym_QMARK] = ACTIONS(2756),
    [anon_sym_COLON_QMARK] = ACTIONS(2756),
    [anon_sym_COLON_COLON] = ACTIONS(2758),
    [anon_sym_PIPE] = ACTIONS(2756),
    [anon_sym_AMP] = ACTIONS(2756),
    [anon_sym_LBRACK] = ACTIONS(2756),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2758),
    [anon_sym_LBRACE] = ACTIONS(2756),
    [anon_sym_LT_AT] = ACTIONS(2756),
    [anon_sym_LT_AT_AT] = ACTIONS(2756),
    [anon_sym_DOT] = ACTIONS(2756),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2758),
    [anon_sym_new] = ACTIONS(2756),
    [anon_sym_return_BANG] = ACTIONS(2758),
    [anon_sym_yield] = ACTIONS(2756),
    [anon_sym_yield_BANG] = ACTIONS(2758),
    [anon_sym_lazy] = ACTIONS(2756),
    [anon_sym_assert] = ACTIONS(2756),
    [anon_sym_upcast] = ACTIONS(2756),
    [anon_sym_downcast] = ACTIONS(2756),
    [anon_sym_COLON_GT] = ACTIONS(2758),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2758),
    [anon_sym_for] = ACTIONS(2756),
    [anon_sym_while] = ACTIONS(2756),
    [anon_sym_if] = ACTIONS(2756),
    [anon_sym_fun] = ACTIONS(2756),
    [anon_sym_try] = ACTIONS(2756),
    [anon_sym_match] = ACTIONS(2756),
    [anon_sym_match_BANG] = ACTIONS(2758),
    [anon_sym_function] = ACTIONS(2756),
    [anon_sym_LT_DASH] = ACTIONS(2756),
    [anon_sym_DOT_LBRACK] = ACTIONS(2758),
    [anon_sym_LT] = ACTIONS(2758),
    [anon_sym_use] = ACTIONS(2756),
    [anon_sym_use_BANG] = ACTIONS(2758),
    [anon_sym_do_BANG] = ACTIONS(2758),
    [anon_sym_begin] = ACTIONS(2756),
    [anon_sym_LPAREN2] = ACTIONS(2756),
    [anon_sym_or] = ACTIONS(2756),
    [aux_sym_char_token1] = ACTIONS(2758),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2756),
    [anon_sym_DQUOTE] = ACTIONS(2756),
    [anon_sym_AT_DQUOTE] = ACTIONS(2758),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2758),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2758),
    [sym_bool] = ACTIONS(2756),
    [sym_unit] = ACTIONS(2758),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2756),
    [sym_op_identifier] = ACTIONS(2756),
    [anon_sym_PLUS] = ACTIONS(2756),
    [anon_sym_DASH] = ACTIONS(2756),
    [anon_sym_PLUS_DOT] = ACTIONS(2756),
    [anon_sym_DASH_DOT] = ACTIONS(2756),
    [anon_sym_PERCENT] = ACTIONS(2756),
    [anon_sym_AMP_AMP] = ACTIONS(2756),
    [anon_sym_TILDE] = ACTIONS(2758),
    [aux_sym_prefix_op_token1] = ACTIONS(2756),
    [aux_sym_infix_op_token1] = ACTIONS(2758),
    [aux_sym_infix_op_token2] = ACTIONS(2756),
    [anon_sym_PIPE_PIPE] = ACTIONS(2756),
    [anon_sym_BANG_EQ] = ACTIONS(2756),
    [anon_sym_COLON_EQ] = ACTIONS(2758),
    [anon_sym_DOLLAR] = ACTIONS(2756),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2756),
    [sym_int] = ACTIONS(2756),
    [sym_xint] = ACTIONS(2758),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2758),
    [sym__newline] = ACTIONS(2758),
    [sym__dedent] = ACTIONS(2758),
  },
  [1666] = {
    [sym_block_comment] = STATE(1666),
    [sym_compiler_directive_decl] = STATE(1666),
    [sym_fsi_directive_decl] = STATE(1666),
    [sym_preproc_line] = STATE(1666),
    [sym_identifier] = ACTIONS(2760),
    [anon_sym_EQ] = ACTIONS(2762),
    [anon_sym_COLON] = ACTIONS(2760),
    [anon_sym_return] = ACTIONS(2760),
    [anon_sym_do] = ACTIONS(2760),
    [anon_sym_and] = ACTIONS(2760),
    [anon_sym_let] = ACTIONS(2760),
    [anon_sym_let_BANG] = ACTIONS(2762),
    [anon_sym_LPAREN] = ACTIONS(2760),
    [anon_sym_COMMA] = ACTIONS(2762),
    [anon_sym_null] = ACTIONS(2760),
    [anon_sym_QMARK] = ACTIONS(2760),
    [anon_sym_COLON_QMARK] = ACTIONS(2760),
    [anon_sym_COLON_COLON] = ACTIONS(2762),
    [anon_sym_PIPE] = ACTIONS(2760),
    [anon_sym_AMP] = ACTIONS(2760),
    [anon_sym_LBRACK] = ACTIONS(2760),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2762),
    [anon_sym_LBRACE] = ACTIONS(2760),
    [anon_sym_LT_AT] = ACTIONS(2760),
    [anon_sym_LT_AT_AT] = ACTIONS(2760),
    [anon_sym_DOT] = ACTIONS(2760),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2762),
    [anon_sym_new] = ACTIONS(2760),
    [anon_sym_return_BANG] = ACTIONS(2762),
    [anon_sym_yield] = ACTIONS(2760),
    [anon_sym_yield_BANG] = ACTIONS(2762),
    [anon_sym_lazy] = ACTIONS(2760),
    [anon_sym_assert] = ACTIONS(2760),
    [anon_sym_upcast] = ACTIONS(2760),
    [anon_sym_downcast] = ACTIONS(2760),
    [anon_sym_COLON_GT] = ACTIONS(2762),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2762),
    [anon_sym_for] = ACTIONS(2760),
    [anon_sym_while] = ACTIONS(2760),
    [anon_sym_if] = ACTIONS(2760),
    [anon_sym_fun] = ACTIONS(2760),
    [anon_sym_try] = ACTIONS(2760),
    [anon_sym_match] = ACTIONS(2760),
    [anon_sym_match_BANG] = ACTIONS(2762),
    [anon_sym_function] = ACTIONS(2760),
    [anon_sym_LT_DASH] = ACTIONS(2760),
    [anon_sym_DOT_LBRACK] = ACTIONS(2762),
    [anon_sym_LT] = ACTIONS(2762),
    [anon_sym_use] = ACTIONS(2760),
    [anon_sym_use_BANG] = ACTIONS(2762),
    [anon_sym_do_BANG] = ACTIONS(2762),
    [anon_sym_begin] = ACTIONS(2760),
    [anon_sym_LPAREN2] = ACTIONS(2760),
    [anon_sym_or] = ACTIONS(2760),
    [aux_sym_char_token1] = ACTIONS(2762),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2760),
    [anon_sym_DQUOTE] = ACTIONS(2760),
    [anon_sym_AT_DQUOTE] = ACTIONS(2762),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2762),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2762),
    [sym_bool] = ACTIONS(2760),
    [sym_unit] = ACTIONS(2762),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2760),
    [sym_op_identifier] = ACTIONS(2760),
    [anon_sym_PLUS] = ACTIONS(2760),
    [anon_sym_DASH] = ACTIONS(2760),
    [anon_sym_PLUS_DOT] = ACTIONS(2760),
    [anon_sym_DASH_DOT] = ACTIONS(2760),
    [anon_sym_PERCENT] = ACTIONS(2760),
    [anon_sym_AMP_AMP] = ACTIONS(2760),
    [anon_sym_TILDE] = ACTIONS(2762),
    [aux_sym_prefix_op_token1] = ACTIONS(2760),
    [aux_sym_infix_op_token1] = ACTIONS(2762),
    [aux_sym_infix_op_token2] = ACTIONS(2760),
    [anon_sym_PIPE_PIPE] = ACTIONS(2760),
    [anon_sym_BANG_EQ] = ACTIONS(2760),
    [anon_sym_COLON_EQ] = ACTIONS(2762),
    [anon_sym_DOLLAR] = ACTIONS(2760),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2760),
    [sym_int] = ACTIONS(2760),
    [sym_xint] = ACTIONS(2762),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2762),
    [sym__newline] = ACTIONS(2762),
    [sym__dedent] = ACTIONS(2762),
  },
  [1667] = {
    [sym_block_comment] = STATE(1667),
    [sym_compiler_directive_decl] = STATE(1667),
    [sym_fsi_directive_decl] = STATE(1667),
    [sym_preproc_line] = STATE(1667),
    [sym_identifier] = ACTIONS(2729),
    [anon_sym_EQ] = ACTIONS(2731),
    [anon_sym_COLON] = ACTIONS(2729),
    [anon_sym_return] = ACTIONS(2729),
    [anon_sym_do] = ACTIONS(2729),
    [anon_sym_let] = ACTIONS(2729),
    [anon_sym_let_BANG] = ACTIONS(2731),
    [anon_sym_LPAREN] = ACTIONS(2729),
    [anon_sym_COMMA] = ACTIONS(2731),
    [anon_sym_null] = ACTIONS(2729),
    [anon_sym_QMARK] = ACTIONS(2729),
    [anon_sym_COLON_QMARK] = ACTIONS(2729),
    [anon_sym_COLON_COLON] = ACTIONS(2731),
    [anon_sym_AMP] = ACTIONS(2729),
    [anon_sym_LBRACK] = ACTIONS(2729),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2731),
    [anon_sym_LBRACE] = ACTIONS(2729),
    [anon_sym_LT_AT] = ACTIONS(2729),
    [anon_sym_LT_AT_AT] = ACTIONS(2729),
    [anon_sym_DOT] = ACTIONS(2729),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2731),
    [anon_sym_new] = ACTIONS(2729),
    [anon_sym_return_BANG] = ACTIONS(2731),
    [anon_sym_yield] = ACTIONS(2729),
    [anon_sym_yield_BANG] = ACTIONS(2731),
    [anon_sym_lazy] = ACTIONS(2729),
    [anon_sym_assert] = ACTIONS(2729),
    [anon_sym_upcast] = ACTIONS(2729),
    [anon_sym_downcast] = ACTIONS(2729),
    [anon_sym_COLON_GT] = ACTIONS(2731),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2731),
    [anon_sym_for] = ACTIONS(2729),
    [anon_sym_while] = ACTIONS(2729),
    [anon_sym_else] = ACTIONS(2729),
    [anon_sym_elif] = ACTIONS(2729),
    [anon_sym_if] = ACTIONS(2729),
    [anon_sym_fun] = ACTIONS(2729),
    [anon_sym_try] = ACTIONS(2729),
    [anon_sym_match] = ACTIONS(2729),
    [anon_sym_match_BANG] = ACTIONS(2731),
    [anon_sym_function] = ACTIONS(2729),
    [anon_sym_LT_DASH] = ACTIONS(2729),
    [anon_sym_DOT_LBRACK] = ACTIONS(2731),
    [anon_sym_LT] = ACTIONS(2731),
    [anon_sym_use] = ACTIONS(2729),
    [anon_sym_use_BANG] = ACTIONS(2731),
    [anon_sym_do_BANG] = ACTIONS(2731),
    [anon_sym_DOT_DOT] = ACTIONS(2731),
    [anon_sym_begin] = ACTIONS(2729),
    [anon_sym_LPAREN2] = ACTIONS(2729),
    [anon_sym_or] = ACTIONS(2729),
    [aux_sym_char_token1] = ACTIONS(2731),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2729),
    [anon_sym_DQUOTE] = ACTIONS(2729),
    [anon_sym_AT_DQUOTE] = ACTIONS(2731),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2731),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2731),
    [sym_bool] = ACTIONS(2729),
    [sym_unit] = ACTIONS(2731),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2729),
    [sym_op_identifier] = ACTIONS(2729),
    [anon_sym_PLUS] = ACTIONS(2729),
    [anon_sym_DASH] = ACTIONS(2729),
    [anon_sym_PLUS_DOT] = ACTIONS(2729),
    [anon_sym_DASH_DOT] = ACTIONS(2729),
    [anon_sym_PERCENT] = ACTIONS(2729),
    [anon_sym_AMP_AMP] = ACTIONS(2729),
    [anon_sym_TILDE] = ACTIONS(2731),
    [aux_sym_prefix_op_token1] = ACTIONS(2729),
    [aux_sym_infix_op_token1] = ACTIONS(2731),
    [aux_sym_infix_op_token2] = ACTIONS(2729),
    [anon_sym_PIPE_PIPE] = ACTIONS(2729),
    [anon_sym_BANG_EQ] = ACTIONS(2729),
    [anon_sym_COLON_EQ] = ACTIONS(2731),
    [anon_sym_DOLLAR] = ACTIONS(2729),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2729),
    [sym_int] = ACTIONS(2729),
    [sym_xint] = ACTIONS(2731),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2731),
    [sym__newline] = ACTIONS(2731),
  },
  [1668] = {
    [sym_block_comment] = STATE(1668),
    [sym_compiler_directive_decl] = STATE(1668),
    [sym_fsi_directive_decl] = STATE(1668),
    [sym_preproc_line] = STATE(1668),
    [sym_identifier] = ACTIONS(2748),
    [anon_sym_EQ] = ACTIONS(2750),
    [anon_sym_COLON] = ACTIONS(2748),
    [anon_sym_return] = ACTIONS(2748),
    [anon_sym_do] = ACTIONS(2748),
    [anon_sym_let] = ACTIONS(2748),
    [anon_sym_let_BANG] = ACTIONS(2750),
    [anon_sym_LPAREN] = ACTIONS(2748),
    [anon_sym_COMMA] = ACTIONS(2750),
    [anon_sym_null] = ACTIONS(2748),
    [anon_sym_QMARK] = ACTIONS(2748),
    [anon_sym_COLON_QMARK] = ACTIONS(2748),
    [anon_sym_COLON_COLON] = ACTIONS(2750),
    [anon_sym_AMP] = ACTIONS(2748),
    [anon_sym_LBRACK] = ACTIONS(2748),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2750),
    [anon_sym_LBRACE] = ACTIONS(2748),
    [anon_sym_LT_AT] = ACTIONS(2748),
    [anon_sym_LT_AT_AT] = ACTIONS(2748),
    [anon_sym_DOT] = ACTIONS(2748),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2750),
    [anon_sym_new] = ACTIONS(2748),
    [anon_sym_return_BANG] = ACTIONS(2750),
    [anon_sym_yield] = ACTIONS(2748),
    [anon_sym_yield_BANG] = ACTIONS(2750),
    [anon_sym_lazy] = ACTIONS(2748),
    [anon_sym_assert] = ACTIONS(2748),
    [anon_sym_upcast] = ACTIONS(2748),
    [anon_sym_downcast] = ACTIONS(2748),
    [anon_sym_COLON_GT] = ACTIONS(2750),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2750),
    [anon_sym_for] = ACTIONS(2748),
    [anon_sym_while] = ACTIONS(2748),
    [anon_sym_else] = ACTIONS(2748),
    [anon_sym_elif] = ACTIONS(2748),
    [anon_sym_if] = ACTIONS(2748),
    [anon_sym_fun] = ACTIONS(2748),
    [anon_sym_try] = ACTIONS(2748),
    [anon_sym_match] = ACTIONS(2748),
    [anon_sym_match_BANG] = ACTIONS(2750),
    [anon_sym_function] = ACTIONS(2748),
    [anon_sym_LT_DASH] = ACTIONS(2748),
    [anon_sym_DOT_LBRACK] = ACTIONS(2750),
    [anon_sym_LT] = ACTIONS(2750),
    [anon_sym_GT] = ACTIONS(2748),
    [anon_sym_use] = ACTIONS(2748),
    [anon_sym_use_BANG] = ACTIONS(2750),
    [anon_sym_do_BANG] = ACTIONS(2750),
    [anon_sym_begin] = ACTIONS(2748),
    [anon_sym_LPAREN2] = ACTIONS(2748),
    [anon_sym_or] = ACTIONS(2748),
    [aux_sym_char_token1] = ACTIONS(2750),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2748),
    [anon_sym_DQUOTE] = ACTIONS(2748),
    [anon_sym_AT_DQUOTE] = ACTIONS(2750),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2750),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2750),
    [sym_bool] = ACTIONS(2748),
    [sym_unit] = ACTIONS(2750),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2748),
    [sym_op_identifier] = ACTIONS(2748),
    [anon_sym_PLUS] = ACTIONS(2748),
    [anon_sym_DASH] = ACTIONS(2748),
    [anon_sym_PLUS_DOT] = ACTIONS(2748),
    [anon_sym_DASH_DOT] = ACTIONS(2748),
    [anon_sym_PERCENT] = ACTIONS(2748),
    [anon_sym_AMP_AMP] = ACTIONS(2748),
    [anon_sym_TILDE] = ACTIONS(2750),
    [aux_sym_prefix_op_token1] = ACTIONS(2748),
    [aux_sym_infix_op_token1] = ACTIONS(2750),
    [aux_sym_infix_op_token2] = ACTIONS(2748),
    [anon_sym_PIPE_PIPE] = ACTIONS(2748),
    [anon_sym_BANG_EQ] = ACTIONS(2748),
    [anon_sym_COLON_EQ] = ACTIONS(2750),
    [anon_sym_DOLLAR] = ACTIONS(2748),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2748),
    [sym_int] = ACTIONS(2748),
    [sym_xint] = ACTIONS(2750),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2750),
    [sym__newline] = ACTIONS(2750),
  },
  [1669] = {
    [sym_block_comment] = STATE(1669),
    [sym_compiler_directive_decl] = STATE(1669),
    [sym_fsi_directive_decl] = STATE(1669),
    [sym_preproc_line] = STATE(1669),
    [aux_sym_long_identifier_repeat1] = STATE(1606),
    [sym_identifier] = ACTIONS(2791),
    [anon_sym_EQ] = ACTIONS(2794),
    [anon_sym_COLON] = ACTIONS(2791),
    [anon_sym_return] = ACTIONS(2791),
    [anon_sym_do] = ACTIONS(2791),
    [anon_sym_let] = ACTIONS(2791),
    [anon_sym_let_BANG] = ACTIONS(2794),
    [anon_sym_as] = ACTIONS(2791),
    [anon_sym_LPAREN] = ACTIONS(2791),
    [anon_sym_COMMA] = ACTIONS(2794),
    [anon_sym_null] = ACTIONS(2791),
    [anon_sym_QMARK] = ACTIONS(2791),
    [anon_sym_COLON_QMARK] = ACTIONS(2791),
    [anon_sym_COLON_COLON] = ACTIONS(2794),
    [anon_sym_AMP] = ACTIONS(2791),
    [anon_sym_LBRACK] = ACTIONS(2791),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2794),
    [anon_sym_LBRACE] = ACTIONS(2791),
    [anon_sym_LT_AT] = ACTIONS(2791),
    [anon_sym_LT_AT_AT] = ACTIONS(2791),
    [anon_sym_DOT] = ACTIONS(3922),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2794),
    [anon_sym_new] = ACTIONS(2791),
    [anon_sym_with] = ACTIONS(2791),
    [anon_sym_return_BANG] = ACTIONS(2794),
    [anon_sym_yield] = ACTIONS(2791),
    [anon_sym_yield_BANG] = ACTIONS(2794),
    [anon_sym_lazy] = ACTIONS(2791),
    [anon_sym_assert] = ACTIONS(2791),
    [anon_sym_upcast] = ACTIONS(2791),
    [anon_sym_downcast] = ACTIONS(2791),
    [anon_sym_COLON_GT] = ACTIONS(2794),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2794),
    [anon_sym_for] = ACTIONS(2791),
    [anon_sym_while] = ACTIONS(2791),
    [anon_sym_if] = ACTIONS(2791),
    [anon_sym_fun] = ACTIONS(2791),
    [anon_sym_try] = ACTIONS(2791),
    [anon_sym_match] = ACTIONS(2791),
    [anon_sym_match_BANG] = ACTIONS(2794),
    [anon_sym_function] = ACTIONS(2791),
    [anon_sym_LT_DASH] = ACTIONS(2791),
    [anon_sym_DOT_LBRACK] = ACTIONS(2794),
    [anon_sym_LT] = ACTIONS(2794),
    [anon_sym_use] = ACTIONS(2791),
    [anon_sym_use_BANG] = ACTIONS(2794),
    [anon_sym_do_BANG] = ACTIONS(2794),
    [anon_sym_begin] = ACTIONS(2791),
    [anon_sym_LPAREN2] = ACTIONS(2791),
    [anon_sym_or] = ACTIONS(2791),
    [aux_sym_char_token1] = ACTIONS(2794),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2791),
    [anon_sym_DQUOTE] = ACTIONS(2791),
    [anon_sym_AT_DQUOTE] = ACTIONS(2794),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2794),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2794),
    [sym_bool] = ACTIONS(2791),
    [sym_unit] = ACTIONS(2794),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2791),
    [sym_op_identifier] = ACTIONS(2791),
    [anon_sym_PLUS] = ACTIONS(2791),
    [anon_sym_DASH] = ACTIONS(2791),
    [anon_sym_PLUS_DOT] = ACTIONS(2791),
    [anon_sym_DASH_DOT] = ACTIONS(2791),
    [anon_sym_PERCENT] = ACTIONS(2791),
    [anon_sym_AMP_AMP] = ACTIONS(2791),
    [anon_sym_TILDE] = ACTIONS(2794),
    [aux_sym_prefix_op_token1] = ACTIONS(2791),
    [aux_sym_infix_op_token1] = ACTIONS(2794),
    [aux_sym_infix_op_token2] = ACTIONS(2791),
    [anon_sym_PIPE_PIPE] = ACTIONS(2791),
    [anon_sym_BANG_EQ] = ACTIONS(2791),
    [anon_sym_COLON_EQ] = ACTIONS(2794),
    [anon_sym_DOLLAR] = ACTIONS(2791),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2791),
    [sym_int] = ACTIONS(2791),
    [sym_xint] = ACTIONS(2794),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2794),
    [sym__newline] = ACTIONS(2794),
  },
  [1670] = {
    [sym_block_comment] = STATE(1670),
    [sym_compiler_directive_decl] = STATE(1670),
    [sym_fsi_directive_decl] = STATE(1670),
    [sym_preproc_line] = STATE(1670),
    [sym_identifier] = ACTIONS(2685),
    [anon_sym_EQ] = ACTIONS(2687),
    [anon_sym_COLON] = ACTIONS(2685),
    [anon_sym_return] = ACTIONS(2685),
    [anon_sym_do] = ACTIONS(2685),
    [anon_sym_let] = ACTIONS(2685),
    [anon_sym_let_BANG] = ACTIONS(2687),
    [anon_sym_LPAREN] = ACTIONS(2685),
    [anon_sym_COMMA] = ACTIONS(2687),
    [anon_sym_null] = ACTIONS(2685),
    [anon_sym_QMARK] = ACTIONS(2685),
    [anon_sym_COLON_QMARK] = ACTIONS(2685),
    [anon_sym_COLON_COLON] = ACTIONS(2687),
    [anon_sym_PIPE] = ACTIONS(2685),
    [anon_sym_AMP] = ACTIONS(2685),
    [anon_sym_LBRACK] = ACTIONS(2685),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2687),
    [anon_sym_LBRACE] = ACTIONS(2685),
    [anon_sym_LT_AT] = ACTIONS(2685),
    [anon_sym_LT_AT_AT] = ACTIONS(2685),
    [anon_sym_DOT] = ACTIONS(2685),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2687),
    [anon_sym_new] = ACTIONS(2685),
    [anon_sym_return_BANG] = ACTIONS(2687),
    [anon_sym_yield] = ACTIONS(2685),
    [anon_sym_yield_BANG] = ACTIONS(2687),
    [anon_sym_lazy] = ACTIONS(2685),
    [anon_sym_assert] = ACTIONS(2685),
    [anon_sym_upcast] = ACTIONS(2685),
    [anon_sym_downcast] = ACTIONS(2685),
    [anon_sym_COLON_GT] = ACTIONS(2687),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2687),
    [anon_sym_for] = ACTIONS(2685),
    [anon_sym_while] = ACTIONS(2685),
    [anon_sym_if] = ACTIONS(2685),
    [anon_sym_fun] = ACTIONS(2685),
    [anon_sym_DASH_GT] = ACTIONS(2685),
    [anon_sym_try] = ACTIONS(2685),
    [anon_sym_match] = ACTIONS(2685),
    [anon_sym_match_BANG] = ACTIONS(2687),
    [anon_sym_function] = ACTIONS(2685),
    [anon_sym_LT_DASH] = ACTIONS(2685),
    [anon_sym_DOT_LBRACK] = ACTIONS(2687),
    [anon_sym_LT] = ACTIONS(2687),
    [anon_sym_use] = ACTIONS(2685),
    [anon_sym_use_BANG] = ACTIONS(2687),
    [anon_sym_do_BANG] = ACTIONS(2687),
    [anon_sym_DOT_DOT] = ACTIONS(2687),
    [anon_sym_begin] = ACTIONS(2685),
    [anon_sym_LPAREN2] = ACTIONS(2685),
    [anon_sym_or] = ACTIONS(2685),
    [aux_sym_char_token1] = ACTIONS(2687),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2685),
    [anon_sym_DQUOTE] = ACTIONS(2685),
    [anon_sym_AT_DQUOTE] = ACTIONS(2687),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2687),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2687),
    [sym_bool] = ACTIONS(2685),
    [sym_unit] = ACTIONS(2687),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2685),
    [sym_op_identifier] = ACTIONS(2685),
    [anon_sym_PLUS] = ACTIONS(2685),
    [anon_sym_DASH] = ACTIONS(2685),
    [anon_sym_PLUS_DOT] = ACTIONS(2685),
    [anon_sym_DASH_DOT] = ACTIONS(2685),
    [anon_sym_PERCENT] = ACTIONS(2685),
    [anon_sym_AMP_AMP] = ACTIONS(2685),
    [anon_sym_TILDE] = ACTIONS(2687),
    [aux_sym_prefix_op_token1] = ACTIONS(2685),
    [aux_sym_infix_op_token1] = ACTIONS(2687),
    [aux_sym_infix_op_token2] = ACTIONS(2685),
    [anon_sym_PIPE_PIPE] = ACTIONS(2685),
    [anon_sym_BANG_EQ] = ACTIONS(2685),
    [anon_sym_COLON_EQ] = ACTIONS(2687),
    [anon_sym_DOLLAR] = ACTIONS(2685),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2685),
    [sym_int] = ACTIONS(2685),
    [sym_xint] = ACTIONS(2687),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2687),
    [sym__newline] = ACTIONS(2687),
  },
  [1671] = {
    [sym_block_comment] = STATE(1671),
    [sym_compiler_directive_decl] = STATE(1671),
    [sym_fsi_directive_decl] = STATE(1671),
    [sym_preproc_line] = STATE(1671),
    [sym_identifier] = ACTIONS(2723),
    [anon_sym_EQ] = ACTIONS(2725),
    [anon_sym_COLON] = ACTIONS(2723),
    [anon_sym_return] = ACTIONS(2723),
    [anon_sym_do] = ACTIONS(2723),
    [anon_sym_let] = ACTIONS(2723),
    [anon_sym_let_BANG] = ACTIONS(2725),
    [anon_sym_LPAREN] = ACTIONS(2723),
    [anon_sym_COMMA] = ACTIONS(2725),
    [anon_sym_null] = ACTIONS(2723),
    [anon_sym_QMARK] = ACTIONS(2723),
    [anon_sym_COLON_QMARK] = ACTIONS(2723),
    [anon_sym_COLON_COLON] = ACTIONS(2725),
    [anon_sym_AMP] = ACTIONS(2723),
    [anon_sym_LBRACK] = ACTIONS(2723),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2725),
    [anon_sym_LBRACE] = ACTIONS(2723),
    [anon_sym_LT_AT] = ACTIONS(2723),
    [anon_sym_AT_GT] = ACTIONS(2723),
    [anon_sym_LT_AT_AT] = ACTIONS(2723),
    [anon_sym_DOT] = ACTIONS(2723),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2725),
    [anon_sym_new] = ACTIONS(2723),
    [anon_sym_return_BANG] = ACTIONS(2725),
    [anon_sym_yield] = ACTIONS(2723),
    [anon_sym_yield_BANG] = ACTIONS(2725),
    [anon_sym_lazy] = ACTIONS(2723),
    [anon_sym_assert] = ACTIONS(2723),
    [anon_sym_upcast] = ACTIONS(2723),
    [anon_sym_downcast] = ACTIONS(2723),
    [anon_sym_COLON_GT] = ACTIONS(2725),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2725),
    [anon_sym_for] = ACTIONS(2723),
    [anon_sym_while] = ACTIONS(2723),
    [anon_sym_if] = ACTIONS(2723),
    [anon_sym_fun] = ACTIONS(2723),
    [anon_sym_try] = ACTIONS(2723),
    [anon_sym_match] = ACTIONS(2723),
    [anon_sym_match_BANG] = ACTIONS(2725),
    [anon_sym_function] = ACTIONS(2723),
    [anon_sym_LT_DASH] = ACTIONS(2723),
    [anon_sym_DOT_LBRACK] = ACTIONS(2725),
    [anon_sym_LT] = ACTIONS(2725),
    [anon_sym_use] = ACTIONS(2723),
    [anon_sym_use_BANG] = ACTIONS(2725),
    [anon_sym_do_BANG] = ACTIONS(2725),
    [anon_sym_begin] = ACTIONS(2723),
    [anon_sym_LPAREN2] = ACTIONS(2723),
    [anon_sym_or] = ACTIONS(2723),
    [aux_sym_char_token1] = ACTIONS(2725),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2723),
    [anon_sym_DQUOTE] = ACTIONS(2723),
    [anon_sym_AT_DQUOTE] = ACTIONS(2725),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2725),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2725),
    [sym_bool] = ACTIONS(2723),
    [sym_unit] = ACTIONS(2725),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2723),
    [sym_op_identifier] = ACTIONS(2723),
    [anon_sym_PLUS] = ACTIONS(2723),
    [anon_sym_DASH] = ACTIONS(2723),
    [anon_sym_PLUS_DOT] = ACTIONS(2723),
    [anon_sym_DASH_DOT] = ACTIONS(2723),
    [anon_sym_PERCENT] = ACTIONS(2723),
    [anon_sym_AMP_AMP] = ACTIONS(2723),
    [anon_sym_TILDE] = ACTIONS(2725),
    [aux_sym_prefix_op_token1] = ACTIONS(2723),
    [aux_sym_infix_op_token1] = ACTIONS(2725),
    [aux_sym_infix_op_token2] = ACTIONS(2723),
    [anon_sym_PIPE_PIPE] = ACTIONS(2723),
    [anon_sym_BANG_EQ] = ACTIONS(2723),
    [anon_sym_COLON_EQ] = ACTIONS(2725),
    [anon_sym_DOLLAR] = ACTIONS(2723),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2723),
    [sym_int] = ACTIONS(2723),
    [sym_xint] = ACTIONS(2725),
    [anon_sym_f] = ACTIONS(2723),
    [aux_sym_decimal_token1] = ACTIONS(2723),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2725),
    [sym__newline] = ACTIONS(2725),
  },
  [1672] = {
    [sym_block_comment] = STATE(1672),
    [sym_compiler_directive_decl] = STATE(1672),
    [sym_fsi_directive_decl] = STATE(1672),
    [sym_preproc_line] = STATE(1672),
    [sym_identifier] = ACTIONS(2158),
    [anon_sym_EQ] = ACTIONS(2160),
    [anon_sym_COLON] = ACTIONS(2158),
    [anon_sym_return] = ACTIONS(2158),
    [anon_sym_do] = ACTIONS(2158),
    [anon_sym_let] = ACTIONS(2158),
    [anon_sym_let_BANG] = ACTIONS(2160),
    [anon_sym_LPAREN] = ACTIONS(2158),
    [anon_sym_COMMA] = ACTIONS(2160),
    [anon_sym_null] = ACTIONS(2158),
    [anon_sym_QMARK] = ACTIONS(2158),
    [anon_sym_COLON_QMARK] = ACTIONS(2158),
    [anon_sym_COLON_COLON] = ACTIONS(2160),
    [anon_sym_AMP] = ACTIONS(2158),
    [anon_sym_LBRACK] = ACTIONS(2158),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2160),
    [anon_sym_LBRACE] = ACTIONS(2158),
    [anon_sym_LT_AT] = ACTIONS(2158),
    [anon_sym_LT_AT_AT] = ACTIONS(2158),
    [anon_sym_DOT] = ACTIONS(2158),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2160),
    [anon_sym_new] = ACTIONS(2158),
    [anon_sym_return_BANG] = ACTIONS(2160),
    [anon_sym_yield] = ACTIONS(2158),
    [anon_sym_yield_BANG] = ACTIONS(2160),
    [anon_sym_lazy] = ACTIONS(2158),
    [anon_sym_assert] = ACTIONS(2158),
    [anon_sym_upcast] = ACTIONS(2158),
    [anon_sym_downcast] = ACTIONS(2158),
    [anon_sym_COLON_GT] = ACTIONS(2160),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2160),
    [anon_sym_for] = ACTIONS(2158),
    [anon_sym_while] = ACTIONS(2158),
    [anon_sym_if] = ACTIONS(2158),
    [anon_sym_fun] = ACTIONS(2158),
    [anon_sym_try] = ACTIONS(2158),
    [anon_sym_match] = ACTIONS(2158),
    [anon_sym_match_BANG] = ACTIONS(2160),
    [anon_sym_function] = ACTIONS(2158),
    [anon_sym_LT_DASH] = ACTIONS(2158),
    [anon_sym_DOT_LBRACK] = ACTIONS(2160),
    [anon_sym_LT] = ACTIONS(2160),
    [anon_sym_GT] = ACTIONS(2158),
    [anon_sym_use] = ACTIONS(2158),
    [anon_sym_use_BANG] = ACTIONS(2160),
    [anon_sym_do_BANG] = ACTIONS(2160),
    [anon_sym_begin] = ACTIONS(2158),
    [anon_sym_LPAREN2] = ACTIONS(2158),
    [anon_sym_or] = ACTIONS(2158),
    [aux_sym_char_token1] = ACTIONS(2160),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2158),
    [anon_sym_DQUOTE] = ACTIONS(2158),
    [anon_sym_AT_DQUOTE] = ACTIONS(2160),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2160),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2160),
    [sym_bool] = ACTIONS(2158),
    [sym_unit] = ACTIONS(2160),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2158),
    [sym_op_identifier] = ACTIONS(2158),
    [anon_sym_PLUS] = ACTIONS(2158),
    [anon_sym_DASH] = ACTIONS(2158),
    [anon_sym_PLUS_DOT] = ACTIONS(2158),
    [anon_sym_DASH_DOT] = ACTIONS(2158),
    [anon_sym_PERCENT] = ACTIONS(2158),
    [anon_sym_AMP_AMP] = ACTIONS(2158),
    [anon_sym_TILDE] = ACTIONS(2160),
    [aux_sym_prefix_op_token1] = ACTIONS(2158),
    [aux_sym_infix_op_token1] = ACTIONS(2160),
    [aux_sym_infix_op_token2] = ACTIONS(2158),
    [anon_sym_PIPE_PIPE] = ACTIONS(2158),
    [anon_sym_BANG_EQ] = ACTIONS(2158),
    [anon_sym_COLON_EQ] = ACTIONS(2160),
    [anon_sym_DOLLAR] = ACTIONS(2158),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2158),
    [sym_int] = ACTIONS(2158),
    [sym_xint] = ACTIONS(2160),
    [anon_sym_f] = ACTIONS(2733),
    [aux_sym_decimal_token1] = ACTIONS(2653),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2160),
    [sym__newline] = ACTIONS(2160),
  },
  [1673] = {
    [sym_block_comment] = STATE(1673),
    [sym_compiler_directive_decl] = STATE(1673),
    [sym_fsi_directive_decl] = STATE(1673),
    [sym_preproc_line] = STATE(1673),
    [sym_identifier] = ACTIONS(2819),
    [anon_sym_EQ] = ACTIONS(2821),
    [anon_sym_COLON] = ACTIONS(2819),
    [anon_sym_return] = ACTIONS(2819),
    [anon_sym_do] = ACTIONS(2819),
    [anon_sym_let] = ACTIONS(2819),
    [anon_sym_let_BANG] = ACTIONS(2821),
    [anon_sym_LPAREN] = ACTIONS(2819),
    [anon_sym_COMMA] = ACTIONS(2821),
    [anon_sym_null] = ACTIONS(2819),
    [anon_sym_QMARK] = ACTIONS(2819),
    [anon_sym_COLON_QMARK] = ACTIONS(2819),
    [anon_sym_COLON_COLON] = ACTIONS(2821),
    [anon_sym_AMP] = ACTIONS(2819),
    [anon_sym_LBRACK] = ACTIONS(2819),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2821),
    [anon_sym_LBRACE] = ACTIONS(2819),
    [anon_sym_LT_AT] = ACTIONS(2819),
    [anon_sym_LT_AT_AT] = ACTIONS(2819),
    [anon_sym_DOT] = ACTIONS(2819),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2821),
    [anon_sym_new] = ACTIONS(2819),
    [anon_sym_return_BANG] = ACTIONS(2821),
    [anon_sym_yield] = ACTIONS(2819),
    [anon_sym_yield_BANG] = ACTIONS(2821),
    [anon_sym_lazy] = ACTIONS(2819),
    [anon_sym_assert] = ACTIONS(2819),
    [anon_sym_upcast] = ACTIONS(2819),
    [anon_sym_downcast] = ACTIONS(2819),
    [anon_sym_COLON_GT] = ACTIONS(2821),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2821),
    [anon_sym_for] = ACTIONS(2819),
    [anon_sym_while] = ACTIONS(2819),
    [anon_sym_if] = ACTIONS(2819),
    [anon_sym_fun] = ACTIONS(2819),
    [anon_sym_try] = ACTIONS(2819),
    [anon_sym_match] = ACTIONS(2819),
    [anon_sym_match_BANG] = ACTIONS(2821),
    [anon_sym_function] = ACTIONS(2819),
    [anon_sym_LT_DASH] = ACTIONS(2819),
    [anon_sym_DOT_LBRACK] = ACTIONS(2821),
    [anon_sym_LT] = ACTIONS(2821),
    [anon_sym_GT] = ACTIONS(2819),
    [anon_sym_use] = ACTIONS(2819),
    [anon_sym_use_BANG] = ACTIONS(2821),
    [anon_sym_do_BANG] = ACTIONS(2821),
    [anon_sym_begin] = ACTIONS(2819),
    [anon_sym_LPAREN2] = ACTIONS(2819),
    [anon_sym_or] = ACTIONS(2819),
    [aux_sym_char_token1] = ACTIONS(2821),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2819),
    [anon_sym_DQUOTE] = ACTIONS(2819),
    [anon_sym_AT_DQUOTE] = ACTIONS(2821),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2821),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2821),
    [sym_bool] = ACTIONS(2819),
    [sym_unit] = ACTIONS(2821),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2819),
    [sym_op_identifier] = ACTIONS(2819),
    [anon_sym_PLUS] = ACTIONS(2819),
    [anon_sym_DASH] = ACTIONS(2819),
    [anon_sym_PLUS_DOT] = ACTIONS(2819),
    [anon_sym_DASH_DOT] = ACTIONS(2819),
    [anon_sym_PERCENT] = ACTIONS(2819),
    [anon_sym_AMP_AMP] = ACTIONS(2819),
    [anon_sym_TILDE] = ACTIONS(2821),
    [aux_sym_prefix_op_token1] = ACTIONS(2819),
    [aux_sym_infix_op_token1] = ACTIONS(2821),
    [aux_sym_infix_op_token2] = ACTIONS(2819),
    [anon_sym_PIPE_PIPE] = ACTIONS(2819),
    [anon_sym_BANG_EQ] = ACTIONS(2819),
    [anon_sym_COLON_EQ] = ACTIONS(2821),
    [anon_sym_DOLLAR] = ACTIONS(2819),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2819),
    [sym_int] = ACTIONS(3926),
    [sym_xint] = ACTIONS(2821),
    [anon_sym_f] = ACTIONS(2819),
    [aux_sym_decimal_token1] = ACTIONS(2819),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2821),
    [sym__newline] = ACTIONS(2821),
  },
  [1674] = {
    [sym_block_comment] = STATE(1674),
    [sym_compiler_directive_decl] = STATE(1674),
    [sym_fsi_directive_decl] = STATE(1674),
    [sym_preproc_line] = STATE(1674),
    [sym_identifier] = ACTIONS(2685),
    [anon_sym_EQ] = ACTIONS(2687),
    [anon_sym_COLON] = ACTIONS(2685),
    [anon_sym_return] = ACTIONS(2685),
    [anon_sym_do] = ACTIONS(2685),
    [anon_sym_let] = ACTIONS(2685),
    [anon_sym_let_BANG] = ACTIONS(2687),
    [anon_sym_LPAREN] = ACTIONS(2685),
    [anon_sym_COMMA] = ACTIONS(2687),
    [anon_sym_null] = ACTIONS(2685),
    [anon_sym_QMARK] = ACTIONS(2685),
    [anon_sym_COLON_QMARK] = ACTIONS(2685),
    [anon_sym_COLON_COLON] = ACTIONS(2687),
    [anon_sym_AMP] = ACTIONS(2685),
    [anon_sym_LBRACK] = ACTIONS(2685),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2687),
    [anon_sym_LBRACE] = ACTIONS(2685),
    [anon_sym_LT_AT] = ACTIONS(2685),
    [anon_sym_LT_AT_AT] = ACTIONS(2685),
    [anon_sym_DOT] = ACTIONS(2685),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2687),
    [anon_sym_new] = ACTIONS(2685),
    [anon_sym_return_BANG] = ACTIONS(2687),
    [anon_sym_yield] = ACTIONS(2685),
    [anon_sym_yield_BANG] = ACTIONS(2687),
    [anon_sym_lazy] = ACTIONS(2685),
    [anon_sym_assert] = ACTIONS(2685),
    [anon_sym_upcast] = ACTIONS(2685),
    [anon_sym_downcast] = ACTIONS(2685),
    [anon_sym_COLON_GT] = ACTIONS(2687),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2687),
    [anon_sym_for] = ACTIONS(2685),
    [anon_sym_while] = ACTIONS(2685),
    [anon_sym_else] = ACTIONS(2685),
    [anon_sym_elif] = ACTIONS(2685),
    [anon_sym_if] = ACTIONS(2685),
    [anon_sym_fun] = ACTIONS(2685),
    [anon_sym_try] = ACTIONS(2685),
    [anon_sym_match] = ACTIONS(2685),
    [anon_sym_match_BANG] = ACTIONS(2687),
    [anon_sym_function] = ACTIONS(2685),
    [anon_sym_LT_DASH] = ACTIONS(2685),
    [anon_sym_DOT_LBRACK] = ACTIONS(2687),
    [anon_sym_LT] = ACTIONS(2687),
    [anon_sym_use] = ACTIONS(2685),
    [anon_sym_use_BANG] = ACTIONS(2687),
    [anon_sym_do_BANG] = ACTIONS(2687),
    [anon_sym_begin] = ACTIONS(2685),
    [anon_sym_LPAREN2] = ACTIONS(2685),
    [anon_sym_or] = ACTIONS(2685),
    [aux_sym_char_token1] = ACTIONS(2687),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2685),
    [anon_sym_DQUOTE] = ACTIONS(2685),
    [anon_sym_AT_DQUOTE] = ACTIONS(2687),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2687),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2687),
    [sym_bool] = ACTIONS(2685),
    [sym_unit] = ACTIONS(2687),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2685),
    [sym_op_identifier] = ACTIONS(2685),
    [anon_sym_PLUS] = ACTIONS(2685),
    [anon_sym_DASH] = ACTIONS(2685),
    [anon_sym_PLUS_DOT] = ACTIONS(2685),
    [anon_sym_DASH_DOT] = ACTIONS(2685),
    [anon_sym_PERCENT] = ACTIONS(2685),
    [anon_sym_AMP_AMP] = ACTIONS(2685),
    [anon_sym_TILDE] = ACTIONS(2687),
    [aux_sym_prefix_op_token1] = ACTIONS(2685),
    [aux_sym_infix_op_token1] = ACTIONS(2687),
    [aux_sym_infix_op_token2] = ACTIONS(2685),
    [anon_sym_PIPE_PIPE] = ACTIONS(2685),
    [anon_sym_BANG_EQ] = ACTIONS(2685),
    [anon_sym_COLON_EQ] = ACTIONS(2687),
    [anon_sym_DOLLAR] = ACTIONS(2685),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2685),
    [sym_int] = ACTIONS(2685),
    [sym_xint] = ACTIONS(2687),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2687),
    [anon_sym_POUNDendif] = ACTIONS(2687),
    [sym__newline] = ACTIONS(2687),
  },
  [1675] = {
    [sym_block_comment] = STATE(1675),
    [sym_compiler_directive_decl] = STATE(1675),
    [sym_fsi_directive_decl] = STATE(1675),
    [sym_preproc_line] = STATE(1675),
    [sym_identifier] = ACTIONS(2783),
    [anon_sym_EQ] = ACTIONS(2785),
    [anon_sym_COLON] = ACTIONS(2783),
    [anon_sym_return] = ACTIONS(2783),
    [anon_sym_do] = ACTIONS(2783),
    [anon_sym_let] = ACTIONS(2783),
    [anon_sym_let_BANG] = ACTIONS(2785),
    [anon_sym_LPAREN] = ACTIONS(2783),
    [anon_sym_COMMA] = ACTIONS(2785),
    [anon_sym_null] = ACTIONS(2783),
    [anon_sym_QMARK] = ACTIONS(2783),
    [anon_sym_COLON_QMARK] = ACTIONS(2783),
    [anon_sym_COLON_COLON] = ACTIONS(2785),
    [anon_sym_AMP] = ACTIONS(2783),
    [anon_sym_LBRACK] = ACTIONS(2783),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2785),
    [anon_sym_LBRACE] = ACTIONS(2783),
    [anon_sym_LT_AT] = ACTIONS(2783),
    [anon_sym_LT_AT_AT] = ACTIONS(2783),
    [anon_sym_DOT] = ACTIONS(2783),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2785),
    [anon_sym_new] = ACTIONS(2783),
    [anon_sym_return_BANG] = ACTIONS(2785),
    [anon_sym_yield] = ACTIONS(2783),
    [anon_sym_yield_BANG] = ACTIONS(2785),
    [anon_sym_lazy] = ACTIONS(2783),
    [anon_sym_assert] = ACTIONS(2783),
    [anon_sym_upcast] = ACTIONS(2783),
    [anon_sym_downcast] = ACTIONS(2783),
    [anon_sym_COLON_GT] = ACTIONS(2785),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2785),
    [anon_sym_for] = ACTIONS(2783),
    [anon_sym_done] = ACTIONS(3928),
    [anon_sym_while] = ACTIONS(2783),
    [anon_sym_if] = ACTIONS(2783),
    [anon_sym_fun] = ACTIONS(2783),
    [anon_sym_try] = ACTIONS(2783),
    [anon_sym_match] = ACTIONS(2783),
    [anon_sym_match_BANG] = ACTIONS(2785),
    [anon_sym_function] = ACTIONS(2783),
    [anon_sym_LT_DASH] = ACTIONS(2783),
    [anon_sym_DOT_LBRACK] = ACTIONS(2785),
    [anon_sym_LT] = ACTIONS(2785),
    [anon_sym_GT] = ACTIONS(2783),
    [anon_sym_use] = ACTIONS(2783),
    [anon_sym_use_BANG] = ACTIONS(2785),
    [anon_sym_do_BANG] = ACTIONS(2785),
    [anon_sym_DOT_DOT] = ACTIONS(2789),
    [anon_sym_begin] = ACTIONS(2783),
    [anon_sym_LPAREN2] = ACTIONS(2783),
    [anon_sym_or] = ACTIONS(2783),
    [aux_sym_char_token1] = ACTIONS(2785),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2783),
    [anon_sym_DQUOTE] = ACTIONS(2783),
    [anon_sym_AT_DQUOTE] = ACTIONS(2785),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2785),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2785),
    [sym_bool] = ACTIONS(2783),
    [sym_unit] = ACTIONS(2785),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2783),
    [sym_op_identifier] = ACTIONS(2783),
    [anon_sym_PLUS] = ACTIONS(2783),
    [anon_sym_DASH] = ACTIONS(2783),
    [anon_sym_PLUS_DOT] = ACTIONS(2783),
    [anon_sym_DASH_DOT] = ACTIONS(2783),
    [anon_sym_PERCENT] = ACTIONS(2783),
    [anon_sym_AMP_AMP] = ACTIONS(2783),
    [anon_sym_TILDE] = ACTIONS(2785),
    [aux_sym_prefix_op_token1] = ACTIONS(2783),
    [aux_sym_infix_op_token1] = ACTIONS(2785),
    [aux_sym_infix_op_token2] = ACTIONS(2783),
    [anon_sym_PIPE_PIPE] = ACTIONS(2783),
    [anon_sym_BANG_EQ] = ACTIONS(2783),
    [anon_sym_COLON_EQ] = ACTIONS(2785),
    [anon_sym_DOLLAR] = ACTIONS(2783),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2783),
    [sym_int] = ACTIONS(2783),
    [sym_xint] = ACTIONS(2785),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2785),
    [sym__newline] = ACTIONS(2785),
  },
  [1676] = {
    [sym_block_comment] = STATE(1676),
    [sym_compiler_directive_decl] = STATE(1676),
    [sym_fsi_directive_decl] = STATE(1676),
    [sym_preproc_line] = STATE(1676),
    [sym_identifier] = ACTIONS(2685),
    [anon_sym_EQ] = ACTIONS(2687),
    [anon_sym_COLON] = ACTIONS(2685),
    [anon_sym_return] = ACTIONS(2685),
    [anon_sym_do] = ACTIONS(2685),
    [anon_sym_let] = ACTIONS(2685),
    [anon_sym_let_BANG] = ACTIONS(2687),
    [anon_sym_LPAREN] = ACTIONS(2685),
    [anon_sym_COMMA] = ACTIONS(2687),
    [anon_sym_null] = ACTIONS(2685),
    [anon_sym_QMARK] = ACTIONS(2685),
    [anon_sym_COLON_QMARK] = ACTIONS(2685),
    [anon_sym_COLON_COLON] = ACTIONS(2687),
    [anon_sym_AMP] = ACTIONS(2685),
    [anon_sym_LBRACK] = ACTIONS(2685),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2687),
    [anon_sym_LBRACE] = ACTIONS(2685),
    [anon_sym_LT_AT] = ACTIONS(2685),
    [anon_sym_AT_GT] = ACTIONS(2685),
    [anon_sym_LT_AT_AT] = ACTIONS(2685),
    [anon_sym_DOT] = ACTIONS(2685),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2687),
    [anon_sym_new] = ACTIONS(2685),
    [anon_sym_return_BANG] = ACTIONS(2687),
    [anon_sym_yield] = ACTIONS(2685),
    [anon_sym_yield_BANG] = ACTIONS(2687),
    [anon_sym_lazy] = ACTIONS(2685),
    [anon_sym_assert] = ACTIONS(2685),
    [anon_sym_upcast] = ACTIONS(2685),
    [anon_sym_downcast] = ACTIONS(2685),
    [anon_sym_COLON_GT] = ACTIONS(2687),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2687),
    [anon_sym_for] = ACTIONS(2685),
    [anon_sym_done] = ACTIONS(2685),
    [anon_sym_while] = ACTIONS(2685),
    [anon_sym_if] = ACTIONS(2685),
    [anon_sym_fun] = ACTIONS(2685),
    [anon_sym_try] = ACTIONS(2685),
    [anon_sym_match] = ACTIONS(2685),
    [anon_sym_match_BANG] = ACTIONS(2687),
    [anon_sym_function] = ACTIONS(2685),
    [anon_sym_LT_DASH] = ACTIONS(2685),
    [anon_sym_DOT_LBRACK] = ACTIONS(2687),
    [anon_sym_LT] = ACTIONS(2687),
    [anon_sym_use] = ACTIONS(2685),
    [anon_sym_use_BANG] = ACTIONS(2687),
    [anon_sym_do_BANG] = ACTIONS(2687),
    [anon_sym_DOT_DOT] = ACTIONS(2687),
    [anon_sym_begin] = ACTIONS(2685),
    [anon_sym_LPAREN2] = ACTIONS(2685),
    [anon_sym_or] = ACTIONS(2685),
    [aux_sym_char_token1] = ACTIONS(2687),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2685),
    [anon_sym_DQUOTE] = ACTIONS(2685),
    [anon_sym_AT_DQUOTE] = ACTIONS(2687),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2687),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2687),
    [sym_bool] = ACTIONS(2685),
    [sym_unit] = ACTIONS(2687),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2685),
    [sym_op_identifier] = ACTIONS(2685),
    [anon_sym_PLUS] = ACTIONS(2685),
    [anon_sym_DASH] = ACTIONS(2685),
    [anon_sym_PLUS_DOT] = ACTIONS(2685),
    [anon_sym_DASH_DOT] = ACTIONS(2685),
    [anon_sym_PERCENT] = ACTIONS(2685),
    [anon_sym_AMP_AMP] = ACTIONS(2685),
    [anon_sym_TILDE] = ACTIONS(2687),
    [aux_sym_prefix_op_token1] = ACTIONS(2685),
    [aux_sym_infix_op_token1] = ACTIONS(2687),
    [aux_sym_infix_op_token2] = ACTIONS(2685),
    [anon_sym_PIPE_PIPE] = ACTIONS(2685),
    [anon_sym_BANG_EQ] = ACTIONS(2685),
    [anon_sym_COLON_EQ] = ACTIONS(2687),
    [anon_sym_DOLLAR] = ACTIONS(2685),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2685),
    [sym_int] = ACTIONS(2685),
    [sym_xint] = ACTIONS(2687),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2687),
    [sym__newline] = ACTIONS(2687),
  },
  [1677] = {
    [sym_block_comment] = STATE(1677),
    [sym_compiler_directive_decl] = STATE(1677),
    [sym_fsi_directive_decl] = STATE(1677),
    [sym_preproc_line] = STATE(1677),
    [sym_identifier] = ACTIONS(2723),
    [anon_sym_EQ] = ACTIONS(2725),
    [anon_sym_COLON] = ACTIONS(2723),
    [anon_sym_return] = ACTIONS(2723),
    [anon_sym_do] = ACTIONS(2723),
    [anon_sym_let] = ACTIONS(2723),
    [anon_sym_let_BANG] = ACTIONS(2725),
    [anon_sym_LPAREN] = ACTIONS(2723),
    [anon_sym_COMMA] = ACTIONS(2725),
    [anon_sym_null] = ACTIONS(2723),
    [anon_sym_QMARK] = ACTIONS(2723),
    [anon_sym_COLON_QMARK] = ACTIONS(2723),
    [anon_sym_COLON_COLON] = ACTIONS(2725),
    [anon_sym_AMP] = ACTIONS(2723),
    [anon_sym_LBRACK] = ACTIONS(2723),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2725),
    [anon_sym_LBRACE] = ACTIONS(2723),
    [anon_sym_LT_AT] = ACTIONS(2723),
    [anon_sym_LT_AT_AT] = ACTIONS(2723),
    [anon_sym_DOT] = ACTIONS(2723),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2725),
    [anon_sym_new] = ACTIONS(2723),
    [anon_sym_return_BANG] = ACTIONS(2725),
    [anon_sym_yield] = ACTIONS(2723),
    [anon_sym_yield_BANG] = ACTIONS(2725),
    [anon_sym_lazy] = ACTIONS(2723),
    [anon_sym_assert] = ACTIONS(2723),
    [anon_sym_upcast] = ACTIONS(2723),
    [anon_sym_downcast] = ACTIONS(2723),
    [anon_sym_COLON_GT] = ACTIONS(2725),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2725),
    [anon_sym_for] = ACTIONS(2723),
    [anon_sym_while] = ACTIONS(2723),
    [anon_sym_if] = ACTIONS(2723),
    [anon_sym_fun] = ACTIONS(2723),
    [anon_sym_try] = ACTIONS(2723),
    [anon_sym_match] = ACTIONS(2723),
    [anon_sym_match_BANG] = ACTIONS(2725),
    [anon_sym_function] = ACTIONS(2723),
    [anon_sym_LT_DASH] = ACTIONS(2723),
    [anon_sym_DOT_LBRACK] = ACTIONS(2725),
    [anon_sym_LT] = ACTIONS(2725),
    [anon_sym_GT] = ACTIONS(2723),
    [anon_sym_use] = ACTIONS(2723),
    [anon_sym_use_BANG] = ACTIONS(2725),
    [anon_sym_do_BANG] = ACTIONS(2725),
    [anon_sym_begin] = ACTIONS(2723),
    [anon_sym_LPAREN2] = ACTIONS(2723),
    [anon_sym_or] = ACTIONS(2723),
    [aux_sym_char_token1] = ACTIONS(2725),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2723),
    [anon_sym_DQUOTE] = ACTIONS(2723),
    [anon_sym_AT_DQUOTE] = ACTIONS(2725),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2725),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2725),
    [sym_bool] = ACTIONS(2723),
    [sym_unit] = ACTIONS(2725),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2723),
    [sym_op_identifier] = ACTIONS(2723),
    [anon_sym_PLUS] = ACTIONS(2723),
    [anon_sym_DASH] = ACTIONS(2723),
    [anon_sym_PLUS_DOT] = ACTIONS(2723),
    [anon_sym_DASH_DOT] = ACTIONS(2723),
    [anon_sym_PERCENT] = ACTIONS(2723),
    [anon_sym_AMP_AMP] = ACTIONS(2723),
    [anon_sym_TILDE] = ACTIONS(2725),
    [aux_sym_prefix_op_token1] = ACTIONS(2723),
    [aux_sym_infix_op_token1] = ACTIONS(2725),
    [aux_sym_infix_op_token2] = ACTIONS(2723),
    [anon_sym_PIPE_PIPE] = ACTIONS(2723),
    [anon_sym_BANG_EQ] = ACTIONS(2723),
    [anon_sym_COLON_EQ] = ACTIONS(2725),
    [anon_sym_DOLLAR] = ACTIONS(2723),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2723),
    [sym_int] = ACTIONS(2723),
    [sym_xint] = ACTIONS(2725),
    [anon_sym_f] = ACTIONS(2723),
    [aux_sym_decimal_token1] = ACTIONS(2723),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2725),
    [sym__newline] = ACTIONS(2725),
  },
  [1678] = {
    [sym_block_comment] = STATE(1678),
    [sym_compiler_directive_decl] = STATE(1678),
    [sym_fsi_directive_decl] = STATE(1678),
    [sym_preproc_line] = STATE(1678),
    [aux_sym_rules_repeat1] = STATE(1680),
    [sym_identifier] = ACTIONS(2689),
    [anon_sym_EQ] = ACTIONS(2691),
    [anon_sym_COLON] = ACTIONS(2689),
    [anon_sym_return] = ACTIONS(2689),
    [anon_sym_do] = ACTIONS(2689),
    [anon_sym_let] = ACTIONS(2689),
    [anon_sym_let_BANG] = ACTIONS(2691),
    [anon_sym_LPAREN] = ACTIONS(2689),
    [anon_sym_COMMA] = ACTIONS(2691),
    [anon_sym_null] = ACTIONS(2689),
    [anon_sym_QMARK] = ACTIONS(2689),
    [anon_sym_COLON_QMARK] = ACTIONS(2689),
    [anon_sym_COLON_COLON] = ACTIONS(2691),
    [anon_sym_PIPE] = ACTIONS(3930),
    [anon_sym_AMP] = ACTIONS(2689),
    [anon_sym_LBRACK] = ACTIONS(2689),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2691),
    [anon_sym_LBRACE] = ACTIONS(2689),
    [anon_sym_LT_AT] = ACTIONS(2689),
    [anon_sym_LT_AT_AT] = ACTIONS(2689),
    [anon_sym_DOT] = ACTIONS(2689),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2691),
    [anon_sym_new] = ACTIONS(2689),
    [anon_sym_return_BANG] = ACTIONS(2691),
    [anon_sym_yield] = ACTIONS(2689),
    [anon_sym_yield_BANG] = ACTIONS(2691),
    [anon_sym_lazy] = ACTIONS(2689),
    [anon_sym_assert] = ACTIONS(2689),
    [anon_sym_upcast] = ACTIONS(2689),
    [anon_sym_downcast] = ACTIONS(2689),
    [anon_sym_COLON_GT] = ACTIONS(2691),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2691),
    [anon_sym_for] = ACTIONS(2689),
    [anon_sym_while] = ACTIONS(2689),
    [anon_sym_if] = ACTIONS(2689),
    [anon_sym_fun] = ACTIONS(2689),
    [anon_sym_try] = ACTIONS(2689),
    [anon_sym_match] = ACTIONS(2689),
    [anon_sym_match_BANG] = ACTIONS(2691),
    [anon_sym_function] = ACTIONS(2689),
    [anon_sym_LT_DASH] = ACTIONS(2689),
    [anon_sym_DOT_LBRACK] = ACTIONS(2691),
    [anon_sym_LT] = ACTIONS(2691),
    [anon_sym_use] = ACTIONS(2689),
    [anon_sym_use_BANG] = ACTIONS(2691),
    [anon_sym_do_BANG] = ACTIONS(2691),
    [anon_sym_DOT_DOT] = ACTIONS(2691),
    [anon_sym_begin] = ACTIONS(2689),
    [anon_sym_LPAREN2] = ACTIONS(2689),
    [anon_sym_or] = ACTIONS(2689),
    [aux_sym_char_token1] = ACTIONS(2691),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2689),
    [anon_sym_DQUOTE] = ACTIONS(2689),
    [anon_sym_AT_DQUOTE] = ACTIONS(2691),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2691),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2691),
    [sym_bool] = ACTIONS(2689),
    [sym_unit] = ACTIONS(2691),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2689),
    [sym_op_identifier] = ACTIONS(2689),
    [anon_sym_PLUS] = ACTIONS(2689),
    [anon_sym_DASH] = ACTIONS(2689),
    [anon_sym_PLUS_DOT] = ACTIONS(2689),
    [anon_sym_DASH_DOT] = ACTIONS(2689),
    [anon_sym_PERCENT] = ACTIONS(2689),
    [anon_sym_AMP_AMP] = ACTIONS(2689),
    [anon_sym_TILDE] = ACTIONS(2691),
    [aux_sym_prefix_op_token1] = ACTIONS(2689),
    [aux_sym_infix_op_token1] = ACTIONS(2691),
    [aux_sym_infix_op_token2] = ACTIONS(2689),
    [anon_sym_PIPE_PIPE] = ACTIONS(2689),
    [anon_sym_BANG_EQ] = ACTIONS(2689),
    [anon_sym_COLON_EQ] = ACTIONS(2691),
    [anon_sym_DOLLAR] = ACTIONS(2689),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2689),
    [sym_int] = ACTIONS(2689),
    [sym_xint] = ACTIONS(2691),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2691),
    [sym__newline] = ACTIONS(3932),
  },
  [1679] = {
    [sym_block_comment] = STATE(1679),
    [sym_compiler_directive_decl] = STATE(1679),
    [sym_fsi_directive_decl] = STATE(1679),
    [sym_preproc_line] = STATE(1679),
    [aux_sym_rules_repeat1] = STATE(1683),
    [sym_identifier] = ACTIONS(2698),
    [anon_sym_EQ] = ACTIONS(2700),
    [anon_sym_COLON] = ACTIONS(2698),
    [anon_sym_return] = ACTIONS(2698),
    [anon_sym_do] = ACTIONS(2698),
    [anon_sym_let] = ACTIONS(2698),
    [anon_sym_let_BANG] = ACTIONS(2700),
    [anon_sym_LPAREN] = ACTIONS(2698),
    [anon_sym_COMMA] = ACTIONS(2700),
    [anon_sym_null] = ACTIONS(2698),
    [anon_sym_QMARK] = ACTIONS(2698),
    [anon_sym_COLON_QMARK] = ACTIONS(2698),
    [anon_sym_COLON_COLON] = ACTIONS(2700),
    [anon_sym_PIPE] = ACTIONS(3930),
    [anon_sym_AMP] = ACTIONS(2698),
    [anon_sym_LBRACK] = ACTIONS(2698),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2700),
    [anon_sym_LBRACE] = ACTIONS(2698),
    [anon_sym_LT_AT] = ACTIONS(2698),
    [anon_sym_LT_AT_AT] = ACTIONS(2698),
    [anon_sym_DOT] = ACTIONS(2698),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2700),
    [anon_sym_new] = ACTIONS(2698),
    [anon_sym_return_BANG] = ACTIONS(2700),
    [anon_sym_yield] = ACTIONS(2698),
    [anon_sym_yield_BANG] = ACTIONS(2700),
    [anon_sym_lazy] = ACTIONS(2698),
    [anon_sym_assert] = ACTIONS(2698),
    [anon_sym_upcast] = ACTIONS(2698),
    [anon_sym_downcast] = ACTIONS(2698),
    [anon_sym_COLON_GT] = ACTIONS(2700),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2700),
    [anon_sym_for] = ACTIONS(2698),
    [anon_sym_while] = ACTIONS(2698),
    [anon_sym_if] = ACTIONS(2698),
    [anon_sym_fun] = ACTIONS(2698),
    [anon_sym_try] = ACTIONS(2698),
    [anon_sym_match] = ACTIONS(2698),
    [anon_sym_match_BANG] = ACTIONS(2700),
    [anon_sym_function] = ACTIONS(2698),
    [anon_sym_LT_DASH] = ACTIONS(2698),
    [anon_sym_DOT_LBRACK] = ACTIONS(2700),
    [anon_sym_LT] = ACTIONS(2700),
    [anon_sym_use] = ACTIONS(2698),
    [anon_sym_use_BANG] = ACTIONS(2700),
    [anon_sym_do_BANG] = ACTIONS(2700),
    [anon_sym_DOT_DOT] = ACTIONS(2700),
    [anon_sym_begin] = ACTIONS(2698),
    [anon_sym_LPAREN2] = ACTIONS(2698),
    [anon_sym_or] = ACTIONS(2698),
    [aux_sym_char_token1] = ACTIONS(2700),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2698),
    [anon_sym_DQUOTE] = ACTIONS(2698),
    [anon_sym_AT_DQUOTE] = ACTIONS(2700),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2700),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2700),
    [sym_bool] = ACTIONS(2698),
    [sym_unit] = ACTIONS(2700),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2698),
    [sym_op_identifier] = ACTIONS(2698),
    [anon_sym_PLUS] = ACTIONS(2698),
    [anon_sym_DASH] = ACTIONS(2698),
    [anon_sym_PLUS_DOT] = ACTIONS(2698),
    [anon_sym_DASH_DOT] = ACTIONS(2698),
    [anon_sym_PERCENT] = ACTIONS(2698),
    [anon_sym_AMP_AMP] = ACTIONS(2698),
    [anon_sym_TILDE] = ACTIONS(2700),
    [aux_sym_prefix_op_token1] = ACTIONS(2698),
    [aux_sym_infix_op_token1] = ACTIONS(2700),
    [aux_sym_infix_op_token2] = ACTIONS(2698),
    [anon_sym_PIPE_PIPE] = ACTIONS(2698),
    [anon_sym_BANG_EQ] = ACTIONS(2698),
    [anon_sym_COLON_EQ] = ACTIONS(2700),
    [anon_sym_DOLLAR] = ACTIONS(2698),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2698),
    [sym_int] = ACTIONS(2698),
    [sym_xint] = ACTIONS(2700),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2700),
    [sym__newline] = ACTIONS(3935),
  },
  [1680] = {
    [sym_block_comment] = STATE(1680),
    [sym_compiler_directive_decl] = STATE(1680),
    [sym_fsi_directive_decl] = STATE(1680),
    [sym_preproc_line] = STATE(1680),
    [aux_sym_rules_repeat1] = STATE(1684),
    [sym_identifier] = ACTIONS(2698),
    [anon_sym_EQ] = ACTIONS(2700),
    [anon_sym_COLON] = ACTIONS(2698),
    [anon_sym_return] = ACTIONS(2698),
    [anon_sym_do] = ACTIONS(2698),
    [anon_sym_let] = ACTIONS(2698),
    [anon_sym_let_BANG] = ACTIONS(2700),
    [anon_sym_LPAREN] = ACTIONS(2698),
    [anon_sym_COMMA] = ACTIONS(2700),
    [anon_sym_null] = ACTIONS(2698),
    [anon_sym_QMARK] = ACTIONS(2698),
    [anon_sym_COLON_QMARK] = ACTIONS(2698),
    [anon_sym_COLON_COLON] = ACTIONS(2700),
    [anon_sym_PIPE] = ACTIONS(3930),
    [anon_sym_AMP] = ACTIONS(2698),
    [anon_sym_LBRACK] = ACTIONS(2698),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2700),
    [anon_sym_LBRACE] = ACTIONS(2698),
    [anon_sym_LT_AT] = ACTIONS(2698),
    [anon_sym_LT_AT_AT] = ACTIONS(2698),
    [anon_sym_DOT] = ACTIONS(2698),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2700),
    [anon_sym_new] = ACTIONS(2698),
    [anon_sym_return_BANG] = ACTIONS(2700),
    [anon_sym_yield] = ACTIONS(2698),
    [anon_sym_yield_BANG] = ACTIONS(2700),
    [anon_sym_lazy] = ACTIONS(2698),
    [anon_sym_assert] = ACTIONS(2698),
    [anon_sym_upcast] = ACTIONS(2698),
    [anon_sym_downcast] = ACTIONS(2698),
    [anon_sym_COLON_GT] = ACTIONS(2700),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2700),
    [anon_sym_for] = ACTIONS(2698),
    [anon_sym_while] = ACTIONS(2698),
    [anon_sym_if] = ACTIONS(2698),
    [anon_sym_fun] = ACTIONS(2698),
    [anon_sym_try] = ACTIONS(2698),
    [anon_sym_match] = ACTIONS(2698),
    [anon_sym_match_BANG] = ACTIONS(2700),
    [anon_sym_function] = ACTIONS(2698),
    [anon_sym_LT_DASH] = ACTIONS(2698),
    [anon_sym_DOT_LBRACK] = ACTIONS(2700),
    [anon_sym_LT] = ACTIONS(2700),
    [anon_sym_use] = ACTIONS(2698),
    [anon_sym_use_BANG] = ACTIONS(2700),
    [anon_sym_do_BANG] = ACTIONS(2700),
    [anon_sym_DOT_DOT] = ACTIONS(2700),
    [anon_sym_begin] = ACTIONS(2698),
    [anon_sym_LPAREN2] = ACTIONS(2698),
    [anon_sym_or] = ACTIONS(2698),
    [aux_sym_char_token1] = ACTIONS(2700),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2698),
    [anon_sym_DQUOTE] = ACTIONS(2698),
    [anon_sym_AT_DQUOTE] = ACTIONS(2700),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2700),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2700),
    [sym_bool] = ACTIONS(2698),
    [sym_unit] = ACTIONS(2700),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2698),
    [sym_op_identifier] = ACTIONS(2698),
    [anon_sym_PLUS] = ACTIONS(2698),
    [anon_sym_DASH] = ACTIONS(2698),
    [anon_sym_PLUS_DOT] = ACTIONS(2698),
    [anon_sym_DASH_DOT] = ACTIONS(2698),
    [anon_sym_PERCENT] = ACTIONS(2698),
    [anon_sym_AMP_AMP] = ACTIONS(2698),
    [anon_sym_TILDE] = ACTIONS(2700),
    [aux_sym_prefix_op_token1] = ACTIONS(2698),
    [aux_sym_infix_op_token1] = ACTIONS(2700),
    [aux_sym_infix_op_token2] = ACTIONS(2698),
    [anon_sym_PIPE_PIPE] = ACTIONS(2698),
    [anon_sym_BANG_EQ] = ACTIONS(2698),
    [anon_sym_COLON_EQ] = ACTIONS(2700),
    [anon_sym_DOLLAR] = ACTIONS(2698),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2698),
    [sym_int] = ACTIONS(2698),
    [sym_xint] = ACTIONS(2700),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2700),
    [sym__newline] = ACTIONS(3935),
  },
  [1681] = {
    [sym_block_comment] = STATE(1681),
    [sym_compiler_directive_decl] = STATE(1681),
    [sym_fsi_directive_decl] = STATE(1681),
    [sym_preproc_line] = STATE(1681),
    [sym_identifier] = ACTIONS(2812),
    [anon_sym_EQ] = ACTIONS(2814),
    [anon_sym_COLON] = ACTIONS(2812),
    [anon_sym_return] = ACTIONS(2812),
    [anon_sym_do] = ACTIONS(2812),
    [anon_sym_let] = ACTIONS(2812),
    [anon_sym_let_BANG] = ACTIONS(2814),
    [anon_sym_LPAREN] = ACTIONS(2812),
    [anon_sym_COMMA] = ACTIONS(2814),
    [anon_sym_null] = ACTIONS(2812),
    [anon_sym_QMARK] = ACTIONS(2812),
    [anon_sym_COLON_QMARK] = ACTIONS(2812),
    [anon_sym_COLON_COLON] = ACTIONS(2814),
    [anon_sym_AMP] = ACTIONS(2812),
    [anon_sym_LBRACK] = ACTIONS(2812),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2814),
    [anon_sym_LBRACE] = ACTIONS(2812),
    [anon_sym_LT_AT] = ACTIONS(2812),
    [anon_sym_LT_AT_AT] = ACTIONS(2812),
    [anon_sym_DOT] = ACTIONS(2812),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2814),
    [anon_sym_new] = ACTIONS(2812),
    [anon_sym_return_BANG] = ACTIONS(2814),
    [anon_sym_yield] = ACTIONS(2812),
    [anon_sym_yield_BANG] = ACTIONS(2814),
    [anon_sym_lazy] = ACTIONS(2812),
    [anon_sym_assert] = ACTIONS(2812),
    [anon_sym_upcast] = ACTIONS(2812),
    [anon_sym_downcast] = ACTIONS(2812),
    [anon_sym_COLON_GT] = ACTIONS(2814),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2814),
    [anon_sym_for] = ACTIONS(2812),
    [anon_sym_while] = ACTIONS(2812),
    [anon_sym_if] = ACTIONS(2812),
    [anon_sym_fun] = ACTIONS(2812),
    [anon_sym_try] = ACTIONS(2812),
    [anon_sym_match] = ACTIONS(2812),
    [anon_sym_match_BANG] = ACTIONS(2814),
    [anon_sym_function] = ACTIONS(2812),
    [anon_sym_LT_DASH] = ACTIONS(2812),
    [anon_sym_DOT_LBRACK] = ACTIONS(2814),
    [anon_sym_LT] = ACTIONS(2814),
    [anon_sym_GT] = ACTIONS(2812),
    [anon_sym_use] = ACTIONS(2812),
    [anon_sym_use_BANG] = ACTIONS(2814),
    [anon_sym_do_BANG] = ACTIONS(2814),
    [anon_sym_begin] = ACTIONS(2812),
    [anon_sym_LPAREN2] = ACTIONS(2812),
    [anon_sym_or] = ACTIONS(2812),
    [aux_sym_char_token1] = ACTIONS(2814),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2812),
    [anon_sym_DQUOTE] = ACTIONS(2812),
    [anon_sym_AT_DQUOTE] = ACTIONS(2814),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2814),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2814),
    [sym_bool] = ACTIONS(2812),
    [sym_unit] = ACTIONS(2814),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2812),
    [sym_op_identifier] = ACTIONS(2812),
    [anon_sym_PLUS] = ACTIONS(2812),
    [anon_sym_DASH] = ACTIONS(2812),
    [anon_sym_PLUS_DOT] = ACTIONS(2812),
    [anon_sym_DASH_DOT] = ACTIONS(2812),
    [anon_sym_PERCENT] = ACTIONS(2812),
    [anon_sym_AMP_AMP] = ACTIONS(2812),
    [anon_sym_TILDE] = ACTIONS(2814),
    [aux_sym_prefix_op_token1] = ACTIONS(2812),
    [aux_sym_infix_op_token1] = ACTIONS(2814),
    [aux_sym_infix_op_token2] = ACTIONS(2812),
    [anon_sym_PIPE_PIPE] = ACTIONS(2812),
    [anon_sym_BANG_EQ] = ACTIONS(2812),
    [anon_sym_COLON_EQ] = ACTIONS(2814),
    [anon_sym_DOLLAR] = ACTIONS(2812),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2812),
    [sym_int] = ACTIONS(2812),
    [sym_xint] = ACTIONS(2814),
    [anon_sym_f] = ACTIONS(2812),
    [aux_sym_decimal_token1] = ACTIONS(2812),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2814),
    [sym__newline] = ACTIONS(2814),
  },
  [1682] = {
    [sym_block_comment] = STATE(1682),
    [sym_compiler_directive_decl] = STATE(1682),
    [sym_fsi_directive_decl] = STATE(1682),
    [sym_preproc_line] = STATE(1682),
    [sym_identifier] = ACTIONS(2783),
    [anon_sym_EQ] = ACTIONS(2785),
    [anon_sym_COLON] = ACTIONS(2783),
    [anon_sym_return] = ACTIONS(2783),
    [anon_sym_do] = ACTIONS(2783),
    [anon_sym_let] = ACTIONS(2783),
    [anon_sym_let_BANG] = ACTIONS(2785),
    [anon_sym_LPAREN] = ACTIONS(2783),
    [anon_sym_COMMA] = ACTIONS(2785),
    [anon_sym_null] = ACTIONS(2783),
    [anon_sym_QMARK] = ACTIONS(2783),
    [anon_sym_COLON_QMARK] = ACTIONS(2783),
    [anon_sym_COLON_COLON] = ACTIONS(2785),
    [anon_sym_AMP] = ACTIONS(2783),
    [anon_sym_LBRACK] = ACTIONS(2783),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2785),
    [anon_sym_LBRACE] = ACTIONS(2783),
    [anon_sym_LT_AT] = ACTIONS(2783),
    [anon_sym_LT_AT_AT] = ACTIONS(2783),
    [anon_sym_DOT] = ACTIONS(2783),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2785),
    [anon_sym_new] = ACTIONS(2783),
    [anon_sym_return_BANG] = ACTIONS(2785),
    [anon_sym_yield] = ACTIONS(2783),
    [anon_sym_yield_BANG] = ACTIONS(2785),
    [anon_sym_lazy] = ACTIONS(2783),
    [anon_sym_assert] = ACTIONS(2783),
    [anon_sym_upcast] = ACTIONS(2783),
    [anon_sym_downcast] = ACTIONS(2783),
    [anon_sym_COLON_GT] = ACTIONS(2785),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2785),
    [anon_sym_for] = ACTIONS(2783),
    [anon_sym_done] = ACTIONS(3625),
    [anon_sym_while] = ACTIONS(2783),
    [anon_sym_if] = ACTIONS(2783),
    [anon_sym_fun] = ACTIONS(2783),
    [anon_sym_try] = ACTIONS(2783),
    [anon_sym_match] = ACTIONS(2783),
    [anon_sym_match_BANG] = ACTIONS(2785),
    [anon_sym_function] = ACTIONS(2783),
    [anon_sym_LT_DASH] = ACTIONS(2783),
    [anon_sym_DOT_LBRACK] = ACTIONS(2785),
    [anon_sym_LT] = ACTIONS(2785),
    [anon_sym_use] = ACTIONS(2783),
    [anon_sym_use_BANG] = ACTIONS(2785),
    [anon_sym_do_BANG] = ACTIONS(2785),
    [anon_sym_begin] = ACTIONS(2783),
    [anon_sym_LPAREN2] = ACTIONS(2783),
    [anon_sym_or] = ACTIONS(2783),
    [aux_sym_char_token1] = ACTIONS(2785),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2783),
    [anon_sym_DQUOTE] = ACTIONS(2783),
    [anon_sym_AT_DQUOTE] = ACTIONS(2785),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2785),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2785),
    [sym_bool] = ACTIONS(2783),
    [sym_unit] = ACTIONS(2785),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2783),
    [sym_op_identifier] = ACTIONS(2783),
    [anon_sym_PLUS] = ACTIONS(2783),
    [anon_sym_DASH] = ACTIONS(2783),
    [anon_sym_PLUS_DOT] = ACTIONS(2783),
    [anon_sym_DASH_DOT] = ACTIONS(2783),
    [anon_sym_PERCENT] = ACTIONS(2783),
    [anon_sym_AMP_AMP] = ACTIONS(2783),
    [anon_sym_TILDE] = ACTIONS(2785),
    [aux_sym_prefix_op_token1] = ACTIONS(2783),
    [aux_sym_infix_op_token1] = ACTIONS(2785),
    [aux_sym_infix_op_token2] = ACTIONS(2783),
    [anon_sym_PIPE_PIPE] = ACTIONS(2783),
    [anon_sym_BANG_EQ] = ACTIONS(2783),
    [anon_sym_COLON_EQ] = ACTIONS(2785),
    [anon_sym_DOLLAR] = ACTIONS(2783),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2783),
    [sym_int] = ACTIONS(2783),
    [sym_xint] = ACTIONS(2785),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2785),
    [anon_sym_POUNDendif] = ACTIONS(2785),
    [anon_sym_POUNDelse] = ACTIONS(2785),
    [sym__newline] = ACTIONS(2785),
  },
  [1683] = {
    [sym_block_comment] = STATE(1683),
    [sym_compiler_directive_decl] = STATE(1683),
    [sym_fsi_directive_decl] = STATE(1683),
    [sym_preproc_line] = STATE(1683),
    [aux_sym_rules_repeat1] = STATE(1684),
    [sym_identifier] = ACTIONS(2737),
    [anon_sym_EQ] = ACTIONS(2739),
    [anon_sym_COLON] = ACTIONS(2737),
    [anon_sym_return] = ACTIONS(2737),
    [anon_sym_do] = ACTIONS(2737),
    [anon_sym_let] = ACTIONS(2737),
    [anon_sym_let_BANG] = ACTIONS(2739),
    [anon_sym_LPAREN] = ACTIONS(2737),
    [anon_sym_COMMA] = ACTIONS(2739),
    [anon_sym_null] = ACTIONS(2737),
    [anon_sym_QMARK] = ACTIONS(2737),
    [anon_sym_COLON_QMARK] = ACTIONS(2737),
    [anon_sym_COLON_COLON] = ACTIONS(2739),
    [anon_sym_PIPE] = ACTIONS(3930),
    [anon_sym_AMP] = ACTIONS(2737),
    [anon_sym_LBRACK] = ACTIONS(2737),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2739),
    [anon_sym_LBRACE] = ACTIONS(2737),
    [anon_sym_LT_AT] = ACTIONS(2737),
    [anon_sym_LT_AT_AT] = ACTIONS(2737),
    [anon_sym_DOT] = ACTIONS(2737),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2739),
    [anon_sym_new] = ACTIONS(2737),
    [anon_sym_return_BANG] = ACTIONS(2739),
    [anon_sym_yield] = ACTIONS(2737),
    [anon_sym_yield_BANG] = ACTIONS(2739),
    [anon_sym_lazy] = ACTIONS(2737),
    [anon_sym_assert] = ACTIONS(2737),
    [anon_sym_upcast] = ACTIONS(2737),
    [anon_sym_downcast] = ACTIONS(2737),
    [anon_sym_COLON_GT] = ACTIONS(2739),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2739),
    [anon_sym_for] = ACTIONS(2737),
    [anon_sym_while] = ACTIONS(2737),
    [anon_sym_if] = ACTIONS(2737),
    [anon_sym_fun] = ACTIONS(2737),
    [anon_sym_try] = ACTIONS(2737),
    [anon_sym_match] = ACTIONS(2737),
    [anon_sym_match_BANG] = ACTIONS(2739),
    [anon_sym_function] = ACTIONS(2737),
    [anon_sym_LT_DASH] = ACTIONS(2737),
    [anon_sym_DOT_LBRACK] = ACTIONS(2739),
    [anon_sym_LT] = ACTIONS(2739),
    [anon_sym_use] = ACTIONS(2737),
    [anon_sym_use_BANG] = ACTIONS(2739),
    [anon_sym_do_BANG] = ACTIONS(2739),
    [anon_sym_DOT_DOT] = ACTIONS(2739),
    [anon_sym_begin] = ACTIONS(2737),
    [anon_sym_LPAREN2] = ACTIONS(2737),
    [anon_sym_or] = ACTIONS(2737),
    [aux_sym_char_token1] = ACTIONS(2739),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2737),
    [anon_sym_DQUOTE] = ACTIONS(2737),
    [anon_sym_AT_DQUOTE] = ACTIONS(2739),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2739),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2739),
    [sym_bool] = ACTIONS(2737),
    [sym_unit] = ACTIONS(2739),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2737),
    [sym_op_identifier] = ACTIONS(2737),
    [anon_sym_PLUS] = ACTIONS(2737),
    [anon_sym_DASH] = ACTIONS(2737),
    [anon_sym_PLUS_DOT] = ACTIONS(2737),
    [anon_sym_DASH_DOT] = ACTIONS(2737),
    [anon_sym_PERCENT] = ACTIONS(2737),
    [anon_sym_AMP_AMP] = ACTIONS(2737),
    [anon_sym_TILDE] = ACTIONS(2739),
    [aux_sym_prefix_op_token1] = ACTIONS(2737),
    [aux_sym_infix_op_token1] = ACTIONS(2739),
    [aux_sym_infix_op_token2] = ACTIONS(2737),
    [anon_sym_PIPE_PIPE] = ACTIONS(2737),
    [anon_sym_BANG_EQ] = ACTIONS(2737),
    [anon_sym_COLON_EQ] = ACTIONS(2739),
    [anon_sym_DOLLAR] = ACTIONS(2737),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2737),
    [sym_int] = ACTIONS(2737),
    [sym_xint] = ACTIONS(2739),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2739),
    [sym__newline] = ACTIONS(3938),
  },
  [1684] = {
    [sym_block_comment] = STATE(1684),
    [sym_compiler_directive_decl] = STATE(1684),
    [sym_fsi_directive_decl] = STATE(1684),
    [sym_preproc_line] = STATE(1684),
    [aux_sym_rules_repeat1] = STATE(1684),
    [sym_identifier] = ACTIONS(2713),
    [anon_sym_EQ] = ACTIONS(2715),
    [anon_sym_COLON] = ACTIONS(2713),
    [anon_sym_return] = ACTIONS(2713),
    [anon_sym_do] = ACTIONS(2713),
    [anon_sym_let] = ACTIONS(2713),
    [anon_sym_let_BANG] = ACTIONS(2715),
    [anon_sym_LPAREN] = ACTIONS(2713),
    [anon_sym_COMMA] = ACTIONS(2715),
    [anon_sym_null] = ACTIONS(2713),
    [anon_sym_QMARK] = ACTIONS(2713),
    [anon_sym_COLON_QMARK] = ACTIONS(2713),
    [anon_sym_COLON_COLON] = ACTIONS(2715),
    [anon_sym_PIPE] = ACTIONS(3941),
    [anon_sym_AMP] = ACTIONS(2713),
    [anon_sym_LBRACK] = ACTIONS(2713),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2715),
    [anon_sym_LBRACE] = ACTIONS(2713),
    [anon_sym_LT_AT] = ACTIONS(2713),
    [anon_sym_LT_AT_AT] = ACTIONS(2713),
    [anon_sym_DOT] = ACTIONS(2713),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2715),
    [anon_sym_new] = ACTIONS(2713),
    [anon_sym_return_BANG] = ACTIONS(2715),
    [anon_sym_yield] = ACTIONS(2713),
    [anon_sym_yield_BANG] = ACTIONS(2715),
    [anon_sym_lazy] = ACTIONS(2713),
    [anon_sym_assert] = ACTIONS(2713),
    [anon_sym_upcast] = ACTIONS(2713),
    [anon_sym_downcast] = ACTIONS(2713),
    [anon_sym_COLON_GT] = ACTIONS(2715),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2715),
    [anon_sym_for] = ACTIONS(2713),
    [anon_sym_while] = ACTIONS(2713),
    [anon_sym_if] = ACTIONS(2713),
    [anon_sym_fun] = ACTIONS(2713),
    [anon_sym_try] = ACTIONS(2713),
    [anon_sym_match] = ACTIONS(2713),
    [anon_sym_match_BANG] = ACTIONS(2715),
    [anon_sym_function] = ACTIONS(2713),
    [anon_sym_LT_DASH] = ACTIONS(2713),
    [anon_sym_DOT_LBRACK] = ACTIONS(2715),
    [anon_sym_LT] = ACTIONS(2715),
    [anon_sym_use] = ACTIONS(2713),
    [anon_sym_use_BANG] = ACTIONS(2715),
    [anon_sym_do_BANG] = ACTIONS(2715),
    [anon_sym_DOT_DOT] = ACTIONS(2715),
    [anon_sym_begin] = ACTIONS(2713),
    [anon_sym_LPAREN2] = ACTIONS(2713),
    [anon_sym_or] = ACTIONS(2713),
    [aux_sym_char_token1] = ACTIONS(2715),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2713),
    [anon_sym_DQUOTE] = ACTIONS(2713),
    [anon_sym_AT_DQUOTE] = ACTIONS(2715),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2715),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2715),
    [sym_bool] = ACTIONS(2713),
    [sym_unit] = ACTIONS(2715),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2713),
    [sym_op_identifier] = ACTIONS(2713),
    [anon_sym_PLUS] = ACTIONS(2713),
    [anon_sym_DASH] = ACTIONS(2713),
    [anon_sym_PLUS_DOT] = ACTIONS(2713),
    [anon_sym_DASH_DOT] = ACTIONS(2713),
    [anon_sym_PERCENT] = ACTIONS(2713),
    [anon_sym_AMP_AMP] = ACTIONS(2713),
    [anon_sym_TILDE] = ACTIONS(2715),
    [aux_sym_prefix_op_token1] = ACTIONS(2713),
    [aux_sym_infix_op_token1] = ACTIONS(2715),
    [aux_sym_infix_op_token2] = ACTIONS(2713),
    [anon_sym_PIPE_PIPE] = ACTIONS(2713),
    [anon_sym_BANG_EQ] = ACTIONS(2713),
    [anon_sym_COLON_EQ] = ACTIONS(2715),
    [anon_sym_DOLLAR] = ACTIONS(2713),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2713),
    [sym_int] = ACTIONS(2713),
    [sym_xint] = ACTIONS(2715),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2715),
    [sym__newline] = ACTIONS(3944),
  },
  [1685] = {
    [sym_block_comment] = STATE(1685),
    [sym_compiler_directive_decl] = STATE(1685),
    [sym_fsi_directive_decl] = STATE(1685),
    [sym_preproc_line] = STATE(1685),
    [sym_identifier] = ACTIONS(2783),
    [anon_sym_EQ] = ACTIONS(2785),
    [anon_sym_COLON] = ACTIONS(2783),
    [anon_sym_return] = ACTIONS(2783),
    [anon_sym_do] = ACTIONS(2783),
    [anon_sym_let] = ACTIONS(2783),
    [anon_sym_let_BANG] = ACTIONS(2785),
    [anon_sym_LPAREN] = ACTIONS(2783),
    [anon_sym_COMMA] = ACTIONS(2785),
    [anon_sym_null] = ACTIONS(2783),
    [anon_sym_QMARK] = ACTIONS(2783),
    [anon_sym_COLON_QMARK] = ACTIONS(2783),
    [anon_sym_COLON_COLON] = ACTIONS(2785),
    [anon_sym_AMP] = ACTIONS(2783),
    [anon_sym_LBRACK] = ACTIONS(2783),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2785),
    [anon_sym_LBRACE] = ACTIONS(2783),
    [anon_sym_LT_AT] = ACTIONS(2783),
    [anon_sym_LT_AT_AT] = ACTIONS(2783),
    [anon_sym_DOT] = ACTIONS(2783),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2785),
    [anon_sym_new] = ACTIONS(2783),
    [anon_sym_return_BANG] = ACTIONS(2785),
    [anon_sym_yield] = ACTIONS(2783),
    [anon_sym_yield_BANG] = ACTIONS(2785),
    [anon_sym_lazy] = ACTIONS(2783),
    [anon_sym_assert] = ACTIONS(2783),
    [anon_sym_upcast] = ACTIONS(2783),
    [anon_sym_downcast] = ACTIONS(2783),
    [anon_sym_COLON_GT] = ACTIONS(2785),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2785),
    [anon_sym_for] = ACTIONS(2783),
    [anon_sym_done] = ACTIONS(3740),
    [anon_sym_while] = ACTIONS(2783),
    [anon_sym_if] = ACTIONS(2783),
    [anon_sym_fun] = ACTIONS(2783),
    [anon_sym_DASH_GT] = ACTIONS(2783),
    [anon_sym_try] = ACTIONS(2783),
    [anon_sym_match] = ACTIONS(2783),
    [anon_sym_match_BANG] = ACTIONS(2785),
    [anon_sym_function] = ACTIONS(2783),
    [anon_sym_LT_DASH] = ACTIONS(2783),
    [anon_sym_DOT_LBRACK] = ACTIONS(2785),
    [anon_sym_LT] = ACTIONS(2785),
    [anon_sym_use] = ACTIONS(2783),
    [anon_sym_use_BANG] = ACTIONS(2785),
    [anon_sym_do_BANG] = ACTIONS(2785),
    [anon_sym_DOT_DOT] = ACTIONS(2789),
    [anon_sym_begin] = ACTIONS(2783),
    [anon_sym_LPAREN2] = ACTIONS(2783),
    [anon_sym_or] = ACTIONS(2783),
    [aux_sym_char_token1] = ACTIONS(2785),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2783),
    [anon_sym_DQUOTE] = ACTIONS(2783),
    [anon_sym_AT_DQUOTE] = ACTIONS(2785),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2785),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2785),
    [sym_bool] = ACTIONS(2783),
    [sym_unit] = ACTIONS(2785),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2783),
    [sym_op_identifier] = ACTIONS(2783),
    [anon_sym_PLUS] = ACTIONS(2783),
    [anon_sym_DASH] = ACTIONS(2783),
    [anon_sym_PLUS_DOT] = ACTIONS(2783),
    [anon_sym_DASH_DOT] = ACTIONS(2783),
    [anon_sym_PERCENT] = ACTIONS(2783),
    [anon_sym_AMP_AMP] = ACTIONS(2783),
    [anon_sym_TILDE] = ACTIONS(2785),
    [aux_sym_prefix_op_token1] = ACTIONS(2783),
    [aux_sym_infix_op_token1] = ACTIONS(2785),
    [aux_sym_infix_op_token2] = ACTIONS(2783),
    [anon_sym_PIPE_PIPE] = ACTIONS(2783),
    [anon_sym_BANG_EQ] = ACTIONS(2783),
    [anon_sym_COLON_EQ] = ACTIONS(2785),
    [anon_sym_DOLLAR] = ACTIONS(2783),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2783),
    [sym_int] = ACTIONS(2783),
    [sym_xint] = ACTIONS(2785),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2785),
    [sym__newline] = ACTIONS(2785),
  },
  [1686] = {
    [sym_block_comment] = STATE(1686),
    [sym_compiler_directive_decl] = STATE(1686),
    [sym_fsi_directive_decl] = STATE(1686),
    [sym_preproc_line] = STATE(1686),
    [aux_sym_long_identifier_repeat1] = STATE(1597),
    [sym_identifier] = ACTIONS(2791),
    [anon_sym_EQ] = ACTIONS(2794),
    [anon_sym_COLON] = ACTIONS(2791),
    [anon_sym_return] = ACTIONS(2791),
    [anon_sym_do] = ACTIONS(2791),
    [anon_sym_let] = ACTIONS(2791),
    [anon_sym_let_BANG] = ACTIONS(2794),
    [anon_sym_LPAREN] = ACTIONS(2791),
    [anon_sym_COMMA] = ACTIONS(2794),
    [anon_sym_null] = ACTIONS(2791),
    [anon_sym_QMARK] = ACTIONS(2791),
    [anon_sym_COLON_QMARK] = ACTIONS(2791),
    [anon_sym_COLON_COLON] = ACTIONS(2794),
    [anon_sym_AMP] = ACTIONS(2791),
    [anon_sym_LBRACK] = ACTIONS(2791),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2794),
    [anon_sym_LBRACE] = ACTIONS(2791),
    [anon_sym_LT_AT] = ACTIONS(2791),
    [anon_sym_LT_AT_AT] = ACTIONS(2791),
    [anon_sym_DOT] = ACTIONS(3947),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2794),
    [anon_sym_new] = ACTIONS(2791),
    [anon_sym_return_BANG] = ACTIONS(2794),
    [anon_sym_yield] = ACTIONS(2791),
    [anon_sym_yield_BANG] = ACTIONS(2794),
    [anon_sym_lazy] = ACTIONS(2791),
    [anon_sym_assert] = ACTIONS(2791),
    [anon_sym_upcast] = ACTIONS(2791),
    [anon_sym_downcast] = ACTIONS(2791),
    [anon_sym_COLON_GT] = ACTIONS(2794),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2794),
    [anon_sym_for] = ACTIONS(2791),
    [anon_sym_while] = ACTIONS(2791),
    [anon_sym_if] = ACTIONS(2791),
    [anon_sym_fun] = ACTIONS(2791),
    [anon_sym_try] = ACTIONS(2791),
    [anon_sym_match] = ACTIONS(2791),
    [anon_sym_match_BANG] = ACTIONS(2794),
    [anon_sym_function] = ACTIONS(2791),
    [anon_sym_LT_DASH] = ACTIONS(2791),
    [anon_sym_DOT_LBRACK] = ACTIONS(2794),
    [anon_sym_LT] = ACTIONS(2794),
    [anon_sym_use] = ACTIONS(2791),
    [anon_sym_use_BANG] = ACTIONS(2794),
    [anon_sym_do_BANG] = ACTIONS(2794),
    [anon_sym_begin] = ACTIONS(2791),
    [anon_sym_LPAREN2] = ACTIONS(2791),
    [anon_sym_or] = ACTIONS(2791),
    [aux_sym_char_token1] = ACTIONS(2794),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2791),
    [anon_sym_DQUOTE] = ACTIONS(2791),
    [anon_sym_AT_DQUOTE] = ACTIONS(2794),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2794),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2794),
    [sym_bool] = ACTIONS(2791),
    [sym_unit] = ACTIONS(2794),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2791),
    [sym_op_identifier] = ACTIONS(2791),
    [anon_sym_PLUS] = ACTIONS(2791),
    [anon_sym_DASH] = ACTIONS(2791),
    [anon_sym_PLUS_DOT] = ACTIONS(2791),
    [anon_sym_DASH_DOT] = ACTIONS(2791),
    [anon_sym_PERCENT] = ACTIONS(2791),
    [anon_sym_AMP_AMP] = ACTIONS(2791),
    [anon_sym_TILDE] = ACTIONS(2794),
    [aux_sym_prefix_op_token1] = ACTIONS(2791),
    [aux_sym_infix_op_token1] = ACTIONS(2794),
    [aux_sym_infix_op_token2] = ACTIONS(2791),
    [anon_sym_PIPE_PIPE] = ACTIONS(2791),
    [anon_sym_BANG_EQ] = ACTIONS(2791),
    [anon_sym_COLON_EQ] = ACTIONS(2794),
    [anon_sym_DOLLAR] = ACTIONS(2791),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2791),
    [sym_int] = ACTIONS(2791),
    [sym_xint] = ACTIONS(2794),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2794),
    [anon_sym_POUNDendif] = ACTIONS(2794),
    [anon_sym_POUNDelse] = ACTIONS(2794),
    [sym__newline] = ACTIONS(2794),
  },
  [1687] = {
    [sym_block_comment] = STATE(1687),
    [sym_compiler_directive_decl] = STATE(1687),
    [sym_fsi_directive_decl] = STATE(1687),
    [sym_preproc_line] = STATE(1687),
    [sym_identifier] = ACTIONS(2783),
    [anon_sym_EQ] = ACTIONS(2785),
    [anon_sym_COLON] = ACTIONS(2783),
    [anon_sym_return] = ACTIONS(2783),
    [anon_sym_do] = ACTIONS(2783),
    [anon_sym_let] = ACTIONS(2783),
    [anon_sym_let_BANG] = ACTIONS(2785),
    [anon_sym_LPAREN] = ACTIONS(2783),
    [anon_sym_COMMA] = ACTIONS(2785),
    [anon_sym_null] = ACTIONS(2783),
    [anon_sym_QMARK] = ACTIONS(2783),
    [anon_sym_COLON_QMARK] = ACTIONS(2783),
    [anon_sym_COLON_COLON] = ACTIONS(2785),
    [anon_sym_AMP] = ACTIONS(2783),
    [anon_sym_LBRACK] = ACTIONS(2783),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2785),
    [anon_sym_LBRACE] = ACTIONS(2783),
    [anon_sym_LT_AT] = ACTIONS(2783),
    [anon_sym_LT_AT_AT] = ACTIONS(2783),
    [anon_sym_DOT] = ACTIONS(2783),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2785),
    [anon_sym_new] = ACTIONS(2783),
    [anon_sym_return_BANG] = ACTIONS(2785),
    [anon_sym_yield] = ACTIONS(2783),
    [anon_sym_yield_BANG] = ACTIONS(2785),
    [anon_sym_lazy] = ACTIONS(2783),
    [anon_sym_assert] = ACTIONS(2783),
    [anon_sym_upcast] = ACTIONS(2783),
    [anon_sym_downcast] = ACTIONS(2783),
    [anon_sym_COLON_GT] = ACTIONS(2785),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2785),
    [anon_sym_for] = ACTIONS(2783),
    [anon_sym_done] = ACTIONS(3951),
    [anon_sym_while] = ACTIONS(2783),
    [anon_sym_if] = ACTIONS(2783),
    [anon_sym_fun] = ACTIONS(2783),
    [anon_sym_try] = ACTIONS(2783),
    [anon_sym_match] = ACTIONS(2783),
    [anon_sym_match_BANG] = ACTIONS(2785),
    [anon_sym_function] = ACTIONS(2783),
    [anon_sym_LT_DASH] = ACTIONS(2783),
    [anon_sym_DOT_LBRACK] = ACTIONS(2785),
    [anon_sym_LT] = ACTIONS(2785),
    [anon_sym_use] = ACTIONS(2783),
    [anon_sym_use_BANG] = ACTIONS(2785),
    [anon_sym_do_BANG] = ACTIONS(2785),
    [anon_sym_DOT_DOT] = ACTIONS(2789),
    [anon_sym_begin] = ACTIONS(2783),
    [anon_sym_LPAREN2] = ACTIONS(2783),
    [anon_sym_or] = ACTIONS(2783),
    [aux_sym_char_token1] = ACTIONS(2785),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2783),
    [anon_sym_DQUOTE] = ACTIONS(2783),
    [anon_sym_AT_DQUOTE] = ACTIONS(2785),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2785),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2785),
    [sym_bool] = ACTIONS(2783),
    [sym_unit] = ACTIONS(2785),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2783),
    [sym_op_identifier] = ACTIONS(2783),
    [anon_sym_PLUS] = ACTIONS(2783),
    [anon_sym_DASH] = ACTIONS(2783),
    [anon_sym_PLUS_DOT] = ACTIONS(2783),
    [anon_sym_DASH_DOT] = ACTIONS(2783),
    [anon_sym_PERCENT] = ACTIONS(2783),
    [anon_sym_AMP_AMP] = ACTIONS(2783),
    [anon_sym_TILDE] = ACTIONS(2785),
    [aux_sym_prefix_op_token1] = ACTIONS(2783),
    [aux_sym_infix_op_token1] = ACTIONS(2785),
    [aux_sym_infix_op_token2] = ACTIONS(2783),
    [anon_sym_PIPE_PIPE] = ACTIONS(2783),
    [anon_sym_BANG_EQ] = ACTIONS(2783),
    [anon_sym_COLON_EQ] = ACTIONS(2785),
    [anon_sym_DOLLAR] = ACTIONS(2783),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2783),
    [sym_int] = ACTIONS(2783),
    [sym_xint] = ACTIONS(2785),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2785),
    [anon_sym_POUNDendif] = ACTIONS(2785),
    [sym__newline] = ACTIONS(2785),
  },
  [1688] = {
    [sym_block_comment] = STATE(1688),
    [sym_compiler_directive_decl] = STATE(1688),
    [sym_fsi_directive_decl] = STATE(1688),
    [sym_preproc_line] = STATE(1688),
    [sym_identifier] = ACTIONS(2756),
    [anon_sym_EQ] = ACTIONS(2758),
    [anon_sym_COLON] = ACTIONS(2756),
    [anon_sym_return] = ACTIONS(2756),
    [anon_sym_do] = ACTIONS(2756),
    [anon_sym_let] = ACTIONS(2756),
    [anon_sym_let_BANG] = ACTIONS(2758),
    [anon_sym_as] = ACTIONS(2756),
    [anon_sym_LPAREN] = ACTIONS(2756),
    [anon_sym_COMMA] = ACTIONS(2758),
    [anon_sym_null] = ACTIONS(2756),
    [anon_sym_QMARK] = ACTIONS(2756),
    [anon_sym_COLON_QMARK] = ACTIONS(2756),
    [anon_sym_COLON_COLON] = ACTIONS(2758),
    [anon_sym_PIPE] = ACTIONS(2756),
    [anon_sym_AMP] = ACTIONS(2756),
    [anon_sym_LBRACK] = ACTIONS(2756),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2758),
    [anon_sym_LBRACE] = ACTIONS(2756),
    [anon_sym_LT_AT] = ACTIONS(2756),
    [anon_sym_LT_AT_AT] = ACTIONS(2756),
    [anon_sym_DOT] = ACTIONS(2756),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2758),
    [anon_sym_new] = ACTIONS(2756),
    [anon_sym_with] = ACTIONS(2756),
    [anon_sym_return_BANG] = ACTIONS(2758),
    [anon_sym_yield] = ACTIONS(2756),
    [anon_sym_yield_BANG] = ACTIONS(2758),
    [anon_sym_lazy] = ACTIONS(2756),
    [anon_sym_assert] = ACTIONS(2756),
    [anon_sym_upcast] = ACTIONS(2756),
    [anon_sym_downcast] = ACTIONS(2756),
    [anon_sym_COLON_GT] = ACTIONS(2758),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2758),
    [anon_sym_for] = ACTIONS(2756),
    [anon_sym_while] = ACTIONS(2756),
    [anon_sym_if] = ACTIONS(2756),
    [anon_sym_fun] = ACTIONS(2756),
    [anon_sym_try] = ACTIONS(2756),
    [anon_sym_match] = ACTIONS(2756),
    [anon_sym_match_BANG] = ACTIONS(2758),
    [anon_sym_function] = ACTIONS(2756),
    [anon_sym_LT_DASH] = ACTIONS(2756),
    [anon_sym_DOT_LBRACK] = ACTIONS(2758),
    [anon_sym_LT] = ACTIONS(2758),
    [anon_sym_use] = ACTIONS(2756),
    [anon_sym_use_BANG] = ACTIONS(2758),
    [anon_sym_do_BANG] = ACTIONS(2758),
    [anon_sym_begin] = ACTIONS(2756),
    [anon_sym_LPAREN2] = ACTIONS(2756),
    [anon_sym_or] = ACTIONS(2756),
    [aux_sym_char_token1] = ACTIONS(2758),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2756),
    [anon_sym_DQUOTE] = ACTIONS(2756),
    [anon_sym_AT_DQUOTE] = ACTIONS(2758),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2758),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2758),
    [sym_bool] = ACTIONS(2756),
    [sym_unit] = ACTIONS(2758),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2756),
    [sym_op_identifier] = ACTIONS(2756),
    [anon_sym_PLUS] = ACTIONS(2756),
    [anon_sym_DASH] = ACTIONS(2756),
    [anon_sym_PLUS_DOT] = ACTIONS(2756),
    [anon_sym_DASH_DOT] = ACTIONS(2756),
    [anon_sym_PERCENT] = ACTIONS(2756),
    [anon_sym_AMP_AMP] = ACTIONS(2756),
    [anon_sym_TILDE] = ACTIONS(2758),
    [aux_sym_prefix_op_token1] = ACTIONS(2756),
    [aux_sym_infix_op_token1] = ACTIONS(2758),
    [aux_sym_infix_op_token2] = ACTIONS(2756),
    [anon_sym_PIPE_PIPE] = ACTIONS(2756),
    [anon_sym_BANG_EQ] = ACTIONS(2756),
    [anon_sym_COLON_EQ] = ACTIONS(2758),
    [anon_sym_DOLLAR] = ACTIONS(2756),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2756),
    [sym_int] = ACTIONS(2756),
    [sym_xint] = ACTIONS(2758),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2758),
    [sym__newline] = ACTIONS(2758),
  },
  [1689] = {
    [sym_block_comment] = STATE(1689),
    [sym_compiler_directive_decl] = STATE(1689),
    [sym_fsi_directive_decl] = STATE(1689),
    [sym_preproc_line] = STATE(1689),
    [sym_identifier] = ACTIONS(2867),
    [anon_sym_EQ] = ACTIONS(2869),
    [anon_sym_COLON] = ACTIONS(2867),
    [anon_sym_return] = ACTIONS(2867),
    [anon_sym_do] = ACTIONS(2867),
    [anon_sym_let] = ACTIONS(2867),
    [anon_sym_let_BANG] = ACTIONS(2869),
    [anon_sym_as] = ACTIONS(2867),
    [anon_sym_LPAREN] = ACTIONS(2867),
    [anon_sym_COMMA] = ACTIONS(2869),
    [anon_sym_null] = ACTIONS(2867),
    [anon_sym_QMARK] = ACTIONS(2867),
    [anon_sym_COLON_QMARK] = ACTIONS(2867),
    [anon_sym_COLON_COLON] = ACTIONS(2869),
    [anon_sym_AMP] = ACTIONS(2867),
    [anon_sym_LBRACK] = ACTIONS(2867),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2869),
    [anon_sym_LBRACE] = ACTIONS(2867),
    [anon_sym_LT_AT] = ACTIONS(2867),
    [anon_sym_LT_AT_AT] = ACTIONS(2867),
    [anon_sym_DOT] = ACTIONS(2867),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2869),
    [anon_sym_new] = ACTIONS(2867),
    [anon_sym_with] = ACTIONS(2867),
    [anon_sym_return_BANG] = ACTIONS(2869),
    [anon_sym_yield] = ACTIONS(2867),
    [anon_sym_yield_BANG] = ACTIONS(2869),
    [anon_sym_lazy] = ACTIONS(2867),
    [anon_sym_assert] = ACTIONS(2867),
    [anon_sym_upcast] = ACTIONS(2867),
    [anon_sym_downcast] = ACTIONS(2867),
    [anon_sym_COLON_GT] = ACTIONS(2869),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2869),
    [anon_sym_for] = ACTIONS(2867),
    [anon_sym_while] = ACTIONS(2867),
    [anon_sym_if] = ACTIONS(2867),
    [anon_sym_fun] = ACTIONS(2867),
    [anon_sym_try] = ACTIONS(2867),
    [anon_sym_match] = ACTIONS(2867),
    [anon_sym_match_BANG] = ACTIONS(2869),
    [anon_sym_function] = ACTIONS(2867),
    [anon_sym_LT_DASH] = ACTIONS(2867),
    [anon_sym_DOT_LBRACK] = ACTIONS(2869),
    [anon_sym_LT] = ACTIONS(2869),
    [anon_sym_use] = ACTIONS(2867),
    [anon_sym_use_BANG] = ACTIONS(2869),
    [anon_sym_do_BANG] = ACTIONS(2869),
    [anon_sym_begin] = ACTIONS(2867),
    [anon_sym_LPAREN2] = ACTIONS(2867),
    [anon_sym_or] = ACTIONS(2867),
    [aux_sym_char_token1] = ACTIONS(2869),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2867),
    [anon_sym_DQUOTE] = ACTIONS(2867),
    [anon_sym_AT_DQUOTE] = ACTIONS(2869),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2869),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2869),
    [sym_bool] = ACTIONS(2867),
    [sym_unit] = ACTIONS(2869),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2867),
    [sym_op_identifier] = ACTIONS(2867),
    [anon_sym_PLUS] = ACTIONS(2867),
    [anon_sym_DASH] = ACTIONS(2867),
    [anon_sym_PLUS_DOT] = ACTIONS(2867),
    [anon_sym_DASH_DOT] = ACTIONS(2867),
    [anon_sym_PERCENT] = ACTIONS(2867),
    [anon_sym_AMP_AMP] = ACTIONS(2867),
    [anon_sym_TILDE] = ACTIONS(2869),
    [aux_sym_prefix_op_token1] = ACTIONS(2867),
    [aux_sym_infix_op_token1] = ACTIONS(2869),
    [aux_sym_infix_op_token2] = ACTIONS(2867),
    [anon_sym_PIPE_PIPE] = ACTIONS(2867),
    [anon_sym_BANG_EQ] = ACTIONS(2867),
    [anon_sym_COLON_EQ] = ACTIONS(2869),
    [anon_sym_DOLLAR] = ACTIONS(2867),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2867),
    [sym_int] = ACTIONS(2867),
    [sym_xint] = ACTIONS(2869),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2869),
    [sym__newline] = ACTIONS(2869),
    [sym__dedent] = ACTIONS(2869),
  },
  [1690] = {
    [sym_block_comment] = STATE(1690),
    [sym_compiler_directive_decl] = STATE(1690),
    [sym_fsi_directive_decl] = STATE(1690),
    [sym_preproc_line] = STATE(1690),
    [sym_identifier] = ACTIONS(2883),
    [anon_sym_EQ] = ACTIONS(2885),
    [anon_sym_COLON] = ACTIONS(2883),
    [anon_sym_return] = ACTIONS(2883),
    [anon_sym_do] = ACTIONS(2883),
    [anon_sym_let] = ACTIONS(2883),
    [anon_sym_let_BANG] = ACTIONS(2885),
    [anon_sym_LPAREN] = ACTIONS(2883),
    [anon_sym_COMMA] = ACTIONS(2885),
    [anon_sym_null] = ACTIONS(2883),
    [anon_sym_QMARK] = ACTIONS(2883),
    [anon_sym_COLON_QMARK] = ACTIONS(2883),
    [anon_sym_COLON_COLON] = ACTIONS(2885),
    [anon_sym_AMP] = ACTIONS(2883),
    [anon_sym_LBRACK] = ACTIONS(2883),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2885),
    [anon_sym_LBRACE] = ACTIONS(2883),
    [anon_sym_LT_AT] = ACTIONS(2883),
    [anon_sym_LT_AT_AT] = ACTIONS(2883),
    [anon_sym_DOT] = ACTIONS(2883),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2885),
    [anon_sym_new] = ACTIONS(2883),
    [anon_sym_return_BANG] = ACTIONS(2885),
    [anon_sym_yield] = ACTIONS(2883),
    [anon_sym_yield_BANG] = ACTIONS(2885),
    [anon_sym_lazy] = ACTIONS(2883),
    [anon_sym_assert] = ACTIONS(2883),
    [anon_sym_upcast] = ACTIONS(2883),
    [anon_sym_downcast] = ACTIONS(2883),
    [anon_sym_COLON_GT] = ACTIONS(2885),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2885),
    [anon_sym_for] = ACTIONS(2883),
    [anon_sym_while] = ACTIONS(2883),
    [anon_sym_if] = ACTIONS(2883),
    [anon_sym_fun] = ACTIONS(2883),
    [anon_sym_DASH_GT] = ACTIONS(2883),
    [anon_sym_try] = ACTIONS(2883),
    [anon_sym_match] = ACTIONS(2883),
    [anon_sym_match_BANG] = ACTIONS(2885),
    [anon_sym_function] = ACTIONS(2883),
    [anon_sym_LT_DASH] = ACTIONS(2883),
    [anon_sym_DOT_LBRACK] = ACTIONS(2885),
    [anon_sym_LT] = ACTIONS(2885),
    [anon_sym_use] = ACTIONS(2883),
    [anon_sym_use_BANG] = ACTIONS(2885),
    [anon_sym_do_BANG] = ACTIONS(2885),
    [anon_sym_DOT_DOT] = ACTIONS(2885),
    [anon_sym_begin] = ACTIONS(2883),
    [anon_sym_LPAREN2] = ACTIONS(2883),
    [anon_sym_or] = ACTIONS(2883),
    [aux_sym_char_token1] = ACTIONS(2885),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2883),
    [anon_sym_DQUOTE] = ACTIONS(2883),
    [anon_sym_AT_DQUOTE] = ACTIONS(2885),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2885),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2885),
    [sym_bool] = ACTIONS(2883),
    [sym_unit] = ACTIONS(2885),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2883),
    [sym_op_identifier] = ACTIONS(2883),
    [anon_sym_PLUS] = ACTIONS(2883),
    [anon_sym_DASH] = ACTIONS(2883),
    [anon_sym_PLUS_DOT] = ACTIONS(2883),
    [anon_sym_DASH_DOT] = ACTIONS(2883),
    [anon_sym_PERCENT] = ACTIONS(2883),
    [anon_sym_AMP_AMP] = ACTIONS(2883),
    [anon_sym_TILDE] = ACTIONS(2885),
    [aux_sym_prefix_op_token1] = ACTIONS(2883),
    [aux_sym_infix_op_token1] = ACTIONS(2885),
    [aux_sym_infix_op_token2] = ACTIONS(2883),
    [anon_sym_PIPE_PIPE] = ACTIONS(2883),
    [anon_sym_BANG_EQ] = ACTIONS(2883),
    [anon_sym_COLON_EQ] = ACTIONS(2885),
    [anon_sym_DOLLAR] = ACTIONS(2883),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2883),
    [sym_int] = ACTIONS(2883),
    [sym_xint] = ACTIONS(2885),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2885),
    [sym__newline] = ACTIONS(2885),
  },
  [1691] = {
    [sym_block_comment] = STATE(1691),
    [sym_compiler_directive_decl] = STATE(1691),
    [sym_fsi_directive_decl] = STATE(1691),
    [sym_preproc_line] = STATE(1691),
    [sym_identifier] = ACTIONS(3031),
    [anon_sym_EQ] = ACTIONS(3033),
    [anon_sym_COLON] = ACTIONS(3031),
    [anon_sym_return] = ACTIONS(3031),
    [anon_sym_do] = ACTIONS(3031),
    [anon_sym_and] = ACTIONS(3031),
    [anon_sym_let] = ACTIONS(3031),
    [anon_sym_let_BANG] = ACTIONS(3033),
    [anon_sym_LPAREN] = ACTIONS(3031),
    [anon_sym_COMMA] = ACTIONS(3033),
    [anon_sym_null] = ACTIONS(3031),
    [anon_sym_QMARK] = ACTIONS(3031),
    [anon_sym_COLON_QMARK] = ACTIONS(3031),
    [anon_sym_COLON_COLON] = ACTIONS(3033),
    [anon_sym_AMP] = ACTIONS(3031),
    [anon_sym_LBRACK] = ACTIONS(3031),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3033),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [anon_sym_LT_AT] = ACTIONS(3031),
    [anon_sym_LT_AT_AT] = ACTIONS(3031),
    [anon_sym_DOT] = ACTIONS(3031),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3033),
    [anon_sym_new] = ACTIONS(3031),
    [anon_sym_return_BANG] = ACTIONS(3033),
    [anon_sym_yield] = ACTIONS(3031),
    [anon_sym_yield_BANG] = ACTIONS(3033),
    [anon_sym_lazy] = ACTIONS(3031),
    [anon_sym_assert] = ACTIONS(3031),
    [anon_sym_upcast] = ACTIONS(3031),
    [anon_sym_downcast] = ACTIONS(3031),
    [anon_sym_COLON_GT] = ACTIONS(3033),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3033),
    [anon_sym_for] = ACTIONS(3031),
    [anon_sym_while] = ACTIONS(3031),
    [anon_sym_if] = ACTIONS(3031),
    [anon_sym_fun] = ACTIONS(3031),
    [anon_sym_try] = ACTIONS(3031),
    [anon_sym_match] = ACTIONS(3031),
    [anon_sym_match_BANG] = ACTIONS(3033),
    [anon_sym_function] = ACTIONS(3031),
    [anon_sym_LT_DASH] = ACTIONS(3031),
    [anon_sym_DOT_LBRACK] = ACTIONS(3033),
    [anon_sym_LT] = ACTIONS(3033),
    [anon_sym_use] = ACTIONS(3031),
    [anon_sym_use_BANG] = ACTIONS(3033),
    [anon_sym_do_BANG] = ACTIONS(3033),
    [anon_sym_begin] = ACTIONS(3031),
    [anon_sym_LPAREN2] = ACTIONS(3031),
    [anon_sym_or] = ACTIONS(3031),
    [aux_sym_char_token1] = ACTIONS(3033),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3031),
    [anon_sym_DQUOTE] = ACTIONS(3031),
    [anon_sym_AT_DQUOTE] = ACTIONS(3033),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3033),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3033),
    [sym_bool] = ACTIONS(3031),
    [sym_unit] = ACTIONS(3033),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3031),
    [sym_op_identifier] = ACTIONS(3031),
    [anon_sym_PLUS] = ACTIONS(3031),
    [anon_sym_DASH] = ACTIONS(3031),
    [anon_sym_PLUS_DOT] = ACTIONS(3031),
    [anon_sym_DASH_DOT] = ACTIONS(3031),
    [anon_sym_PERCENT] = ACTIONS(3031),
    [anon_sym_AMP_AMP] = ACTIONS(3031),
    [anon_sym_TILDE] = ACTIONS(3033),
    [aux_sym_prefix_op_token1] = ACTIONS(3031),
    [aux_sym_infix_op_token1] = ACTIONS(3033),
    [aux_sym_infix_op_token2] = ACTIONS(3031),
    [anon_sym_PIPE_PIPE] = ACTIONS(3031),
    [anon_sym_BANG_EQ] = ACTIONS(3031),
    [anon_sym_COLON_EQ] = ACTIONS(3033),
    [anon_sym_DOLLAR] = ACTIONS(3031),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3031),
    [sym_int] = ACTIONS(3031),
    [sym_xint] = ACTIONS(3033),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3033),
    [sym__newline] = ACTIONS(3033),
    [sym__dedent] = ACTIONS(3033),
  },
  [1692] = {
    [sym_block_comment] = STATE(1692),
    [sym_compiler_directive_decl] = STATE(1692),
    [sym_fsi_directive_decl] = STATE(1692),
    [sym_preproc_line] = STATE(1692),
    [sym_identifier] = ACTIONS(2859),
    [anon_sym_EQ] = ACTIONS(2861),
    [anon_sym_COLON] = ACTIONS(2859),
    [anon_sym_return] = ACTIONS(2859),
    [anon_sym_do] = ACTIONS(2859),
    [anon_sym_let] = ACTIONS(2859),
    [anon_sym_let_BANG] = ACTIONS(2861),
    [anon_sym_as] = ACTIONS(2859),
    [anon_sym_LPAREN] = ACTIONS(2859),
    [anon_sym_COMMA] = ACTIONS(2861),
    [anon_sym_null] = ACTIONS(2859),
    [anon_sym_QMARK] = ACTIONS(2859),
    [anon_sym_COLON_QMARK] = ACTIONS(2859),
    [anon_sym_COLON_COLON] = ACTIONS(2861),
    [anon_sym_AMP] = ACTIONS(2859),
    [anon_sym_LBRACK] = ACTIONS(2859),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2861),
    [anon_sym_LBRACE] = ACTIONS(2859),
    [anon_sym_LT_AT] = ACTIONS(2859),
    [anon_sym_LT_AT_AT] = ACTIONS(2859),
    [anon_sym_DOT] = ACTIONS(2859),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2861),
    [anon_sym_new] = ACTIONS(2859),
    [anon_sym_with] = ACTIONS(2859),
    [anon_sym_return_BANG] = ACTIONS(2861),
    [anon_sym_yield] = ACTIONS(2859),
    [anon_sym_yield_BANG] = ACTIONS(2861),
    [anon_sym_lazy] = ACTIONS(2859),
    [anon_sym_assert] = ACTIONS(2859),
    [anon_sym_upcast] = ACTIONS(2859),
    [anon_sym_downcast] = ACTIONS(2859),
    [anon_sym_COLON_GT] = ACTIONS(2861),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2861),
    [anon_sym_for] = ACTIONS(2859),
    [anon_sym_while] = ACTIONS(2859),
    [anon_sym_if] = ACTIONS(2859),
    [anon_sym_fun] = ACTIONS(2859),
    [anon_sym_try] = ACTIONS(2859),
    [anon_sym_match] = ACTIONS(2859),
    [anon_sym_match_BANG] = ACTIONS(2861),
    [anon_sym_function] = ACTIONS(2859),
    [anon_sym_LT_DASH] = ACTIONS(2859),
    [anon_sym_DOT_LBRACK] = ACTIONS(2861),
    [anon_sym_LT] = ACTIONS(2861),
    [anon_sym_use] = ACTIONS(2859),
    [anon_sym_use_BANG] = ACTIONS(2861),
    [anon_sym_do_BANG] = ACTIONS(2861),
    [anon_sym_begin] = ACTIONS(2859),
    [anon_sym_LPAREN2] = ACTIONS(2859),
    [anon_sym_or] = ACTIONS(2859),
    [aux_sym_char_token1] = ACTIONS(2861),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2859),
    [anon_sym_DQUOTE] = ACTIONS(2859),
    [anon_sym_AT_DQUOTE] = ACTIONS(2861),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2861),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2861),
    [sym_bool] = ACTIONS(2859),
    [sym_unit] = ACTIONS(2861),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2859),
    [sym_op_identifier] = ACTIONS(2859),
    [anon_sym_PLUS] = ACTIONS(2859),
    [anon_sym_DASH] = ACTIONS(2859),
    [anon_sym_PLUS_DOT] = ACTIONS(2859),
    [anon_sym_DASH_DOT] = ACTIONS(2859),
    [anon_sym_PERCENT] = ACTIONS(2859),
    [anon_sym_AMP_AMP] = ACTIONS(2859),
    [anon_sym_TILDE] = ACTIONS(2861),
    [aux_sym_prefix_op_token1] = ACTIONS(2859),
    [aux_sym_infix_op_token1] = ACTIONS(2861),
    [aux_sym_infix_op_token2] = ACTIONS(2859),
    [anon_sym_PIPE_PIPE] = ACTIONS(2859),
    [anon_sym_BANG_EQ] = ACTIONS(2859),
    [anon_sym_COLON_EQ] = ACTIONS(2861),
    [anon_sym_DOLLAR] = ACTIONS(2859),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2859),
    [sym_int] = ACTIONS(2859),
    [sym_xint] = ACTIONS(2861),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2861),
    [sym__newline] = ACTIONS(2861),
  },
  [1693] = {
    [sym_block_comment] = STATE(1693),
    [sym_compiler_directive_decl] = STATE(1693),
    [sym_fsi_directive_decl] = STATE(1693),
    [sym_preproc_line] = STATE(1693),
    [sym_identifier] = ACTIONS(2855),
    [anon_sym_EQ] = ACTIONS(2857),
    [anon_sym_COLON] = ACTIONS(2855),
    [anon_sym_return] = ACTIONS(2855),
    [anon_sym_do] = ACTIONS(2855),
    [anon_sym_let] = ACTIONS(2855),
    [anon_sym_let_BANG] = ACTIONS(2857),
    [anon_sym_as] = ACTIONS(2855),
    [anon_sym_LPAREN] = ACTIONS(2855),
    [anon_sym_COMMA] = ACTIONS(2857),
    [anon_sym_null] = ACTIONS(2855),
    [anon_sym_QMARK] = ACTIONS(2855),
    [anon_sym_COLON_QMARK] = ACTIONS(2855),
    [anon_sym_COLON_COLON] = ACTIONS(2857),
    [anon_sym_AMP] = ACTIONS(2855),
    [anon_sym_LBRACK] = ACTIONS(2855),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2857),
    [anon_sym_LBRACE] = ACTIONS(2855),
    [anon_sym_LT_AT] = ACTIONS(2855),
    [anon_sym_LT_AT_AT] = ACTIONS(2855),
    [anon_sym_DOT] = ACTIONS(2855),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2857),
    [anon_sym_new] = ACTIONS(2855),
    [anon_sym_with] = ACTIONS(2855),
    [anon_sym_return_BANG] = ACTIONS(2857),
    [anon_sym_yield] = ACTIONS(2855),
    [anon_sym_yield_BANG] = ACTIONS(2857),
    [anon_sym_lazy] = ACTIONS(2855),
    [anon_sym_assert] = ACTIONS(2855),
    [anon_sym_upcast] = ACTIONS(2855),
    [anon_sym_downcast] = ACTIONS(2855),
    [anon_sym_COLON_GT] = ACTIONS(2857),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2857),
    [anon_sym_for] = ACTIONS(2855),
    [anon_sym_while] = ACTIONS(2855),
    [anon_sym_if] = ACTIONS(2855),
    [anon_sym_fun] = ACTIONS(2855),
    [anon_sym_try] = ACTIONS(2855),
    [anon_sym_match] = ACTIONS(2855),
    [anon_sym_match_BANG] = ACTIONS(2857),
    [anon_sym_function] = ACTIONS(2855),
    [anon_sym_LT_DASH] = ACTIONS(2855),
    [anon_sym_DOT_LBRACK] = ACTIONS(2857),
    [anon_sym_LT] = ACTIONS(2857),
    [anon_sym_use] = ACTIONS(2855),
    [anon_sym_use_BANG] = ACTIONS(2857),
    [anon_sym_do_BANG] = ACTIONS(2857),
    [anon_sym_begin] = ACTIONS(2855),
    [anon_sym_LPAREN2] = ACTIONS(2855),
    [anon_sym_or] = ACTIONS(2855),
    [aux_sym_char_token1] = ACTIONS(2857),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2855),
    [anon_sym_DQUOTE] = ACTIONS(2855),
    [anon_sym_AT_DQUOTE] = ACTIONS(2857),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2857),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2857),
    [sym_bool] = ACTIONS(2855),
    [sym_unit] = ACTIONS(2857),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2855),
    [sym_op_identifier] = ACTIONS(2855),
    [anon_sym_PLUS] = ACTIONS(2855),
    [anon_sym_DASH] = ACTIONS(2855),
    [anon_sym_PLUS_DOT] = ACTIONS(2855),
    [anon_sym_DASH_DOT] = ACTIONS(2855),
    [anon_sym_PERCENT] = ACTIONS(2855),
    [anon_sym_AMP_AMP] = ACTIONS(2855),
    [anon_sym_TILDE] = ACTIONS(2857),
    [aux_sym_prefix_op_token1] = ACTIONS(2855),
    [aux_sym_infix_op_token1] = ACTIONS(2857),
    [aux_sym_infix_op_token2] = ACTIONS(2855),
    [anon_sym_PIPE_PIPE] = ACTIONS(2855),
    [anon_sym_BANG_EQ] = ACTIONS(2855),
    [anon_sym_COLON_EQ] = ACTIONS(2857),
    [anon_sym_DOLLAR] = ACTIONS(2855),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2855),
    [sym_int] = ACTIONS(2855),
    [sym_xint] = ACTIONS(2857),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2857),
    [sym__newline] = ACTIONS(2857),
  },
  [1694] = {
    [sym_block_comment] = STATE(1694),
    [sym_compiler_directive_decl] = STATE(1694),
    [sym_fsi_directive_decl] = STATE(1694),
    [sym_preproc_line] = STATE(1694),
    [sym_identifier] = ACTIONS(2158),
    [anon_sym_EQ] = ACTIONS(2160),
    [anon_sym_COLON] = ACTIONS(2158),
    [anon_sym_return] = ACTIONS(2158),
    [anon_sym_do] = ACTIONS(2158),
    [anon_sym_let] = ACTIONS(2158),
    [anon_sym_let_BANG] = ACTIONS(2160),
    [anon_sym_as] = ACTIONS(2158),
    [anon_sym_LPAREN] = ACTIONS(2158),
    [anon_sym_COMMA] = ACTIONS(2160),
    [anon_sym_null] = ACTIONS(2158),
    [anon_sym_QMARK] = ACTIONS(2158),
    [anon_sym_COLON_QMARK] = ACTIONS(2158),
    [anon_sym_COLON_COLON] = ACTIONS(2160),
    [anon_sym_AMP] = ACTIONS(2158),
    [anon_sym_LBRACK] = ACTIONS(2158),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2160),
    [anon_sym_LBRACE] = ACTIONS(2158),
    [anon_sym_LT_AT] = ACTIONS(2158),
    [anon_sym_LT_AT_AT] = ACTIONS(2158),
    [anon_sym_DOT] = ACTIONS(2158),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2160),
    [anon_sym_new] = ACTIONS(2158),
    [anon_sym_with] = ACTIONS(2158),
    [anon_sym_return_BANG] = ACTIONS(2160),
    [anon_sym_yield] = ACTIONS(2158),
    [anon_sym_yield_BANG] = ACTIONS(2160),
    [anon_sym_lazy] = ACTIONS(2158),
    [anon_sym_assert] = ACTIONS(2158),
    [anon_sym_upcast] = ACTIONS(2158),
    [anon_sym_downcast] = ACTIONS(2158),
    [anon_sym_COLON_GT] = ACTIONS(2160),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2160),
    [anon_sym_for] = ACTIONS(2158),
    [anon_sym_while] = ACTIONS(2158),
    [anon_sym_if] = ACTIONS(2158),
    [anon_sym_fun] = ACTIONS(2158),
    [anon_sym_try] = ACTIONS(2158),
    [anon_sym_match] = ACTIONS(2158),
    [anon_sym_match_BANG] = ACTIONS(2160),
    [anon_sym_function] = ACTIONS(2158),
    [anon_sym_LT_DASH] = ACTIONS(2158),
    [anon_sym_DOT_LBRACK] = ACTIONS(2160),
    [anon_sym_LT] = ACTIONS(2160),
    [anon_sym_use] = ACTIONS(2158),
    [anon_sym_use_BANG] = ACTIONS(2160),
    [anon_sym_do_BANG] = ACTIONS(2160),
    [anon_sym_begin] = ACTIONS(2158),
    [anon_sym_LPAREN2] = ACTIONS(2158),
    [anon_sym_or] = ACTIONS(2158),
    [aux_sym_char_token1] = ACTIONS(2160),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2158),
    [anon_sym_DQUOTE] = ACTIONS(2158),
    [anon_sym_AT_DQUOTE] = ACTIONS(2160),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2160),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2160),
    [sym_bool] = ACTIONS(2158),
    [sym_unit] = ACTIONS(2160),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2158),
    [sym_op_identifier] = ACTIONS(2158),
    [anon_sym_PLUS] = ACTIONS(2158),
    [anon_sym_DASH] = ACTIONS(2158),
    [anon_sym_PLUS_DOT] = ACTIONS(2158),
    [anon_sym_DASH_DOT] = ACTIONS(2158),
    [anon_sym_PERCENT] = ACTIONS(2158),
    [anon_sym_AMP_AMP] = ACTIONS(2158),
    [anon_sym_TILDE] = ACTIONS(2160),
    [aux_sym_prefix_op_token1] = ACTIONS(2158),
    [aux_sym_infix_op_token1] = ACTIONS(2160),
    [aux_sym_infix_op_token2] = ACTIONS(2158),
    [anon_sym_PIPE_PIPE] = ACTIONS(2158),
    [anon_sym_BANG_EQ] = ACTIONS(2158),
    [anon_sym_COLON_EQ] = ACTIONS(2160),
    [anon_sym_DOLLAR] = ACTIONS(2158),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2158),
    [sym_int] = ACTIONS(2158),
    [sym_xint] = ACTIONS(2160),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2160),
    [sym__newline] = ACTIONS(2160),
  },
  [1695] = {
    [sym_block_comment] = STATE(1695),
    [sym_compiler_directive_decl] = STATE(1695),
    [sym_fsi_directive_decl] = STATE(1695),
    [sym_preproc_line] = STATE(1695),
    [sym_identifier] = ACTIONS(2843),
    [anon_sym_EQ] = ACTIONS(2845),
    [anon_sym_COLON] = ACTIONS(2843),
    [anon_sym_return] = ACTIONS(2843),
    [anon_sym_do] = ACTIONS(2843),
    [anon_sym_let] = ACTIONS(2843),
    [anon_sym_let_BANG] = ACTIONS(2845),
    [anon_sym_as] = ACTIONS(2843),
    [anon_sym_LPAREN] = ACTIONS(2843),
    [anon_sym_COMMA] = ACTIONS(2845),
    [anon_sym_null] = ACTIONS(2843),
    [anon_sym_QMARK] = ACTIONS(2843),
    [anon_sym_COLON_QMARK] = ACTIONS(2843),
    [anon_sym_COLON_COLON] = ACTIONS(2845),
    [anon_sym_AMP] = ACTIONS(2843),
    [anon_sym_LBRACK] = ACTIONS(2843),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2845),
    [anon_sym_LBRACE] = ACTIONS(2843),
    [anon_sym_LT_AT] = ACTIONS(2843),
    [anon_sym_LT_AT_AT] = ACTIONS(2843),
    [anon_sym_DOT] = ACTIONS(2843),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2845),
    [anon_sym_new] = ACTIONS(2843),
    [anon_sym_with] = ACTIONS(2843),
    [anon_sym_return_BANG] = ACTIONS(2845),
    [anon_sym_yield] = ACTIONS(2843),
    [anon_sym_yield_BANG] = ACTIONS(2845),
    [anon_sym_lazy] = ACTIONS(2843),
    [anon_sym_assert] = ACTIONS(2843),
    [anon_sym_upcast] = ACTIONS(2843),
    [anon_sym_downcast] = ACTIONS(2843),
    [anon_sym_COLON_GT] = ACTIONS(2845),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2845),
    [anon_sym_for] = ACTIONS(2843),
    [anon_sym_while] = ACTIONS(2843),
    [anon_sym_if] = ACTIONS(2843),
    [anon_sym_fun] = ACTIONS(2843),
    [anon_sym_try] = ACTIONS(2843),
    [anon_sym_match] = ACTIONS(2843),
    [anon_sym_match_BANG] = ACTIONS(2845),
    [anon_sym_function] = ACTIONS(2843),
    [anon_sym_LT_DASH] = ACTIONS(2843),
    [anon_sym_DOT_LBRACK] = ACTIONS(2845),
    [anon_sym_LT] = ACTIONS(2845),
    [anon_sym_use] = ACTIONS(2843),
    [anon_sym_use_BANG] = ACTIONS(2845),
    [anon_sym_do_BANG] = ACTIONS(2845),
    [anon_sym_begin] = ACTIONS(2843),
    [anon_sym_LPAREN2] = ACTIONS(2843),
    [anon_sym_or] = ACTIONS(2843),
    [aux_sym_char_token1] = ACTIONS(2845),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2843),
    [anon_sym_DQUOTE] = ACTIONS(2843),
    [anon_sym_AT_DQUOTE] = ACTIONS(2845),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2845),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2845),
    [sym_bool] = ACTIONS(2843),
    [sym_unit] = ACTIONS(2845),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2843),
    [sym_op_identifier] = ACTIONS(2843),
    [anon_sym_PLUS] = ACTIONS(2843),
    [anon_sym_DASH] = ACTIONS(2843),
    [anon_sym_PLUS_DOT] = ACTIONS(2843),
    [anon_sym_DASH_DOT] = ACTIONS(2843),
    [anon_sym_PERCENT] = ACTIONS(2843),
    [anon_sym_AMP_AMP] = ACTIONS(2843),
    [anon_sym_TILDE] = ACTIONS(2845),
    [aux_sym_prefix_op_token1] = ACTIONS(2843),
    [aux_sym_infix_op_token1] = ACTIONS(2845),
    [aux_sym_infix_op_token2] = ACTIONS(2843),
    [anon_sym_PIPE_PIPE] = ACTIONS(2843),
    [anon_sym_BANG_EQ] = ACTIONS(2843),
    [anon_sym_COLON_EQ] = ACTIONS(2845),
    [anon_sym_DOLLAR] = ACTIONS(2843),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2843),
    [sym_int] = ACTIONS(2843),
    [sym_xint] = ACTIONS(2845),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2845),
    [sym__newline] = ACTIONS(2845),
  },
  [1696] = {
    [sym_block_comment] = STATE(1696),
    [sym_compiler_directive_decl] = STATE(1696),
    [sym_fsi_directive_decl] = STATE(1696),
    [sym_preproc_line] = STATE(1696),
    [sym_identifier] = ACTIONS(3011),
    [anon_sym_EQ] = ACTIONS(3013),
    [anon_sym_COLON] = ACTIONS(3011),
    [anon_sym_return] = ACTIONS(3011),
    [anon_sym_do] = ACTIONS(3011),
    [anon_sym_let] = ACTIONS(3011),
    [anon_sym_let_BANG] = ACTIONS(3013),
    [anon_sym_LPAREN] = ACTIONS(3011),
    [anon_sym_COMMA] = ACTIONS(3013),
    [anon_sym_null] = ACTIONS(3011),
    [anon_sym_QMARK] = ACTIONS(3011),
    [anon_sym_COLON_QMARK] = ACTIONS(3011),
    [anon_sym_COLON_COLON] = ACTIONS(3013),
    [anon_sym_AMP] = ACTIONS(3011),
    [anon_sym_LBRACK] = ACTIONS(3011),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3013),
    [anon_sym_LBRACE] = ACTIONS(3011),
    [anon_sym_LT_AT] = ACTIONS(3011),
    [anon_sym_LT_AT_AT] = ACTIONS(3011),
    [anon_sym_DOT] = ACTIONS(3011),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3013),
    [anon_sym_new] = ACTIONS(3011),
    [anon_sym_return_BANG] = ACTIONS(3013),
    [anon_sym_yield] = ACTIONS(3011),
    [anon_sym_yield_BANG] = ACTIONS(3013),
    [anon_sym_lazy] = ACTIONS(3011),
    [anon_sym_assert] = ACTIONS(3011),
    [anon_sym_upcast] = ACTIONS(3011),
    [anon_sym_downcast] = ACTIONS(3011),
    [anon_sym_COLON_GT] = ACTIONS(3013),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3013),
    [anon_sym_for] = ACTIONS(3011),
    [anon_sym_while] = ACTIONS(3011),
    [anon_sym_if] = ACTIONS(3011),
    [anon_sym_fun] = ACTIONS(3011),
    [anon_sym_DASH_GT] = ACTIONS(3011),
    [anon_sym_try] = ACTIONS(3011),
    [anon_sym_match] = ACTIONS(3011),
    [anon_sym_match_BANG] = ACTIONS(3013),
    [anon_sym_function] = ACTIONS(3011),
    [anon_sym_LT_DASH] = ACTIONS(3011),
    [anon_sym_DOT_LBRACK] = ACTIONS(3013),
    [anon_sym_LT] = ACTIONS(3013),
    [anon_sym_use] = ACTIONS(3011),
    [anon_sym_use_BANG] = ACTIONS(3013),
    [anon_sym_do_BANG] = ACTIONS(3013),
    [anon_sym_DOT_DOT] = ACTIONS(3013),
    [anon_sym_begin] = ACTIONS(3011),
    [anon_sym_LPAREN2] = ACTIONS(3011),
    [anon_sym_or] = ACTIONS(3011),
    [aux_sym_char_token1] = ACTIONS(3013),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3011),
    [anon_sym_DQUOTE] = ACTIONS(3011),
    [anon_sym_AT_DQUOTE] = ACTIONS(3013),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3013),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3013),
    [sym_bool] = ACTIONS(3011),
    [sym_unit] = ACTIONS(3013),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3011),
    [sym_op_identifier] = ACTIONS(3011),
    [anon_sym_PLUS] = ACTIONS(3011),
    [anon_sym_DASH] = ACTIONS(3011),
    [anon_sym_PLUS_DOT] = ACTIONS(3011),
    [anon_sym_DASH_DOT] = ACTIONS(3011),
    [anon_sym_PERCENT] = ACTIONS(3011),
    [anon_sym_AMP_AMP] = ACTIONS(3011),
    [anon_sym_TILDE] = ACTIONS(3013),
    [aux_sym_prefix_op_token1] = ACTIONS(3011),
    [aux_sym_infix_op_token1] = ACTIONS(3013),
    [aux_sym_infix_op_token2] = ACTIONS(3011),
    [anon_sym_PIPE_PIPE] = ACTIONS(3011),
    [anon_sym_BANG_EQ] = ACTIONS(3011),
    [anon_sym_COLON_EQ] = ACTIONS(3013),
    [anon_sym_DOLLAR] = ACTIONS(3011),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3011),
    [sym_int] = ACTIONS(3011),
    [sym_xint] = ACTIONS(3013),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3013),
    [sym__newline] = ACTIONS(3013),
  },
  [1697] = {
    [sym_block_comment] = STATE(1697),
    [sym_compiler_directive_decl] = STATE(1697),
    [sym_fsi_directive_decl] = STATE(1697),
    [sym_preproc_line] = STATE(1697),
    [sym_identifier] = ACTIONS(2988),
    [anon_sym_EQ] = ACTIONS(2990),
    [anon_sym_COLON] = ACTIONS(2988),
    [anon_sym_return] = ACTIONS(2988),
    [anon_sym_do] = ACTIONS(2988),
    [anon_sym_let] = ACTIONS(2988),
    [anon_sym_let_BANG] = ACTIONS(2990),
    [anon_sym_LPAREN] = ACTIONS(2988),
    [anon_sym_COMMA] = ACTIONS(2990),
    [anon_sym_null] = ACTIONS(2988),
    [anon_sym_QMARK] = ACTIONS(2988),
    [anon_sym_COLON_QMARK] = ACTIONS(2988),
    [anon_sym_COLON_COLON] = ACTIONS(2990),
    [anon_sym_AMP] = ACTIONS(2988),
    [anon_sym_LBRACK] = ACTIONS(2988),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2990),
    [anon_sym_LBRACE] = ACTIONS(2988),
    [anon_sym_LT_AT] = ACTIONS(2988),
    [anon_sym_LT_AT_AT] = ACTIONS(2988),
    [anon_sym_DOT] = ACTIONS(2988),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2990),
    [anon_sym_new] = ACTIONS(2988),
    [anon_sym_return_BANG] = ACTIONS(2990),
    [anon_sym_yield] = ACTIONS(2988),
    [anon_sym_yield_BANG] = ACTIONS(2990),
    [anon_sym_lazy] = ACTIONS(2988),
    [anon_sym_assert] = ACTIONS(2988),
    [anon_sym_upcast] = ACTIONS(2988),
    [anon_sym_downcast] = ACTIONS(2988),
    [anon_sym_COLON_GT] = ACTIONS(2990),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2990),
    [anon_sym_for] = ACTIONS(2988),
    [anon_sym_while] = ACTIONS(2988),
    [anon_sym_if] = ACTIONS(2988),
    [anon_sym_fun] = ACTIONS(2988),
    [anon_sym_DASH_GT] = ACTIONS(2988),
    [anon_sym_try] = ACTIONS(2988),
    [anon_sym_match] = ACTIONS(2988),
    [anon_sym_match_BANG] = ACTIONS(2990),
    [anon_sym_function] = ACTIONS(2988),
    [anon_sym_LT_DASH] = ACTIONS(2988),
    [anon_sym_DOT_LBRACK] = ACTIONS(2990),
    [anon_sym_LT] = ACTIONS(2990),
    [anon_sym_use] = ACTIONS(2988),
    [anon_sym_use_BANG] = ACTIONS(2990),
    [anon_sym_do_BANG] = ACTIONS(2990),
    [anon_sym_DOT_DOT] = ACTIONS(2990),
    [anon_sym_begin] = ACTIONS(2988),
    [anon_sym_LPAREN2] = ACTIONS(2988),
    [anon_sym_or] = ACTIONS(2988),
    [aux_sym_char_token1] = ACTIONS(2990),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2988),
    [anon_sym_DQUOTE] = ACTIONS(2988),
    [anon_sym_AT_DQUOTE] = ACTIONS(2990),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2990),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2990),
    [sym_bool] = ACTIONS(2988),
    [sym_unit] = ACTIONS(2990),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2988),
    [sym_op_identifier] = ACTIONS(2988),
    [anon_sym_PLUS] = ACTIONS(2988),
    [anon_sym_DASH] = ACTIONS(2988),
    [anon_sym_PLUS_DOT] = ACTIONS(2988),
    [anon_sym_DASH_DOT] = ACTIONS(2988),
    [anon_sym_PERCENT] = ACTIONS(2988),
    [anon_sym_AMP_AMP] = ACTIONS(2988),
    [anon_sym_TILDE] = ACTIONS(2990),
    [aux_sym_prefix_op_token1] = ACTIONS(2988),
    [aux_sym_infix_op_token1] = ACTIONS(2990),
    [aux_sym_infix_op_token2] = ACTIONS(2988),
    [anon_sym_PIPE_PIPE] = ACTIONS(2988),
    [anon_sym_BANG_EQ] = ACTIONS(2988),
    [anon_sym_COLON_EQ] = ACTIONS(2990),
    [anon_sym_DOLLAR] = ACTIONS(2988),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2988),
    [sym_int] = ACTIONS(2988),
    [sym_xint] = ACTIONS(2990),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2990),
    [sym__newline] = ACTIONS(2990),
  },
  [1698] = {
    [sym_block_comment] = STATE(1698),
    [sym_compiler_directive_decl] = STATE(1698),
    [sym_fsi_directive_decl] = STATE(1698),
    [sym_preproc_line] = STATE(1698),
    [aux_sym_sequential_expression_repeat1] = STATE(1698),
    [sym_identifier] = ACTIONS(2895),
    [anon_sym_EQ] = ACTIONS(2897),
    [anon_sym_COLON] = ACTIONS(2895),
    [anon_sym_return] = ACTIONS(2895),
    [anon_sym_do] = ACTIONS(2895),
    [anon_sym_let] = ACTIONS(2895),
    [anon_sym_let_BANG] = ACTIONS(2897),
    [anon_sym_LPAREN] = ACTIONS(2895),
    [anon_sym_COMMA] = ACTIONS(2897),
    [anon_sym_null] = ACTIONS(2895),
    [anon_sym_QMARK] = ACTIONS(2895),
    [anon_sym_COLON_QMARK] = ACTIONS(2895),
    [anon_sym_COLON_COLON] = ACTIONS(2897),
    [anon_sym_AMP] = ACTIONS(2895),
    [anon_sym_LBRACK] = ACTIONS(2895),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2897),
    [anon_sym_LBRACE] = ACTIONS(2895),
    [anon_sym_LT_AT] = ACTIONS(2895),
    [anon_sym_LT_AT_AT] = ACTIONS(2895),
    [anon_sym_DOT] = ACTIONS(2895),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2897),
    [anon_sym_new] = ACTIONS(2895),
    [anon_sym_return_BANG] = ACTIONS(2897),
    [anon_sym_yield] = ACTIONS(2895),
    [anon_sym_yield_BANG] = ACTIONS(2897),
    [anon_sym_lazy] = ACTIONS(2895),
    [anon_sym_assert] = ACTIONS(2895),
    [anon_sym_upcast] = ACTIONS(2895),
    [anon_sym_downcast] = ACTIONS(2895),
    [anon_sym_COLON_GT] = ACTIONS(2897),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2897),
    [anon_sym_for] = ACTIONS(2895),
    [anon_sym_while] = ACTIONS(2895),
    [anon_sym_if] = ACTIONS(2895),
    [anon_sym_fun] = ACTIONS(2895),
    [anon_sym_try] = ACTIONS(2895),
    [anon_sym_match] = ACTIONS(2895),
    [anon_sym_match_BANG] = ACTIONS(2897),
    [anon_sym_function] = ACTIONS(2895),
    [anon_sym_LT_DASH] = ACTIONS(2895),
    [anon_sym_DOT_LBRACK] = ACTIONS(2897),
    [anon_sym_LT] = ACTIONS(2897),
    [anon_sym_GT] = ACTIONS(2895),
    [anon_sym_use] = ACTIONS(2895),
    [anon_sym_use_BANG] = ACTIONS(2897),
    [anon_sym_do_BANG] = ACTIONS(2897),
    [anon_sym_begin] = ACTIONS(2895),
    [anon_sym_LPAREN2] = ACTIONS(2895),
    [anon_sym_or] = ACTIONS(2895),
    [aux_sym_char_token1] = ACTIONS(2897),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2895),
    [anon_sym_DQUOTE] = ACTIONS(2895),
    [anon_sym_AT_DQUOTE] = ACTIONS(2897),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2897),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2897),
    [sym_bool] = ACTIONS(2895),
    [sym_unit] = ACTIONS(2897),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2895),
    [sym_op_identifier] = ACTIONS(2895),
    [anon_sym_PLUS] = ACTIONS(2895),
    [anon_sym_DASH] = ACTIONS(2895),
    [anon_sym_PLUS_DOT] = ACTIONS(2895),
    [anon_sym_DASH_DOT] = ACTIONS(2895),
    [anon_sym_PERCENT] = ACTIONS(2895),
    [anon_sym_AMP_AMP] = ACTIONS(2895),
    [anon_sym_TILDE] = ACTIONS(2897),
    [aux_sym_prefix_op_token1] = ACTIONS(2895),
    [aux_sym_infix_op_token1] = ACTIONS(2897),
    [aux_sym_infix_op_token2] = ACTIONS(2895),
    [anon_sym_PIPE_PIPE] = ACTIONS(2895),
    [anon_sym_BANG_EQ] = ACTIONS(2895),
    [anon_sym_COLON_EQ] = ACTIONS(2897),
    [anon_sym_DOLLAR] = ACTIONS(2895),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2895),
    [sym_int] = ACTIONS(2895),
    [sym_xint] = ACTIONS(2897),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2897),
    [sym__newline] = ACTIONS(3953),
  },
  [1699] = {
    [sym_block_comment] = STATE(1699),
    [sym_compiler_directive_decl] = STATE(1699),
    [sym_fsi_directive_decl] = STATE(1699),
    [sym_preproc_line] = STATE(1699),
    [sym_identifier] = ACTIONS(2970),
    [anon_sym_EQ] = ACTIONS(2972),
    [anon_sym_COLON] = ACTIONS(2970),
    [anon_sym_return] = ACTIONS(2970),
    [anon_sym_do] = ACTIONS(2970),
    [anon_sym_let] = ACTIONS(2970),
    [anon_sym_let_BANG] = ACTIONS(2972),
    [anon_sym_LPAREN] = ACTIONS(2970),
    [anon_sym_COMMA] = ACTIONS(2972),
    [anon_sym_null] = ACTIONS(2970),
    [anon_sym_QMARK] = ACTIONS(2970),
    [anon_sym_COLON_QMARK] = ACTIONS(2970),
    [anon_sym_COLON_COLON] = ACTIONS(2972),
    [anon_sym_AMP] = ACTIONS(2970),
    [anon_sym_LBRACK] = ACTIONS(2970),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2972),
    [anon_sym_LBRACE] = ACTIONS(2970),
    [anon_sym_LT_AT] = ACTIONS(2970),
    [anon_sym_LT_AT_AT] = ACTIONS(2970),
    [anon_sym_DOT] = ACTIONS(2970),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2972),
    [anon_sym_new] = ACTIONS(2970),
    [anon_sym_return_BANG] = ACTIONS(2972),
    [anon_sym_yield] = ACTIONS(2970),
    [anon_sym_yield_BANG] = ACTIONS(2972),
    [anon_sym_lazy] = ACTIONS(2970),
    [anon_sym_assert] = ACTIONS(2970),
    [anon_sym_upcast] = ACTIONS(2970),
    [anon_sym_downcast] = ACTIONS(2970),
    [anon_sym_COLON_GT] = ACTIONS(2972),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2972),
    [anon_sym_for] = ACTIONS(2970),
    [anon_sym_while] = ACTIONS(2970),
    [anon_sym_if] = ACTIONS(2970),
    [anon_sym_fun] = ACTIONS(2970),
    [anon_sym_DASH_GT] = ACTIONS(2970),
    [anon_sym_try] = ACTIONS(2970),
    [anon_sym_match] = ACTIONS(2970),
    [anon_sym_match_BANG] = ACTIONS(2972),
    [anon_sym_function] = ACTIONS(2970),
    [anon_sym_LT_DASH] = ACTIONS(2970),
    [anon_sym_DOT_LBRACK] = ACTIONS(2972),
    [anon_sym_LT] = ACTIONS(2972),
    [anon_sym_use] = ACTIONS(2970),
    [anon_sym_use_BANG] = ACTIONS(2972),
    [anon_sym_do_BANG] = ACTIONS(2972),
    [anon_sym_DOT_DOT] = ACTIONS(2972),
    [anon_sym_begin] = ACTIONS(2970),
    [anon_sym_LPAREN2] = ACTIONS(2970),
    [anon_sym_or] = ACTIONS(2970),
    [aux_sym_char_token1] = ACTIONS(2972),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2970),
    [anon_sym_DQUOTE] = ACTIONS(2970),
    [anon_sym_AT_DQUOTE] = ACTIONS(2972),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2972),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2972),
    [sym_bool] = ACTIONS(2970),
    [sym_unit] = ACTIONS(2972),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2970),
    [sym_op_identifier] = ACTIONS(2970),
    [anon_sym_PLUS] = ACTIONS(2970),
    [anon_sym_DASH] = ACTIONS(2970),
    [anon_sym_PLUS_DOT] = ACTIONS(2970),
    [anon_sym_DASH_DOT] = ACTIONS(2970),
    [anon_sym_PERCENT] = ACTIONS(2970),
    [anon_sym_AMP_AMP] = ACTIONS(2970),
    [anon_sym_TILDE] = ACTIONS(2972),
    [aux_sym_prefix_op_token1] = ACTIONS(2970),
    [aux_sym_infix_op_token1] = ACTIONS(2972),
    [aux_sym_infix_op_token2] = ACTIONS(2970),
    [anon_sym_PIPE_PIPE] = ACTIONS(2970),
    [anon_sym_BANG_EQ] = ACTIONS(2970),
    [anon_sym_COLON_EQ] = ACTIONS(2972),
    [anon_sym_DOLLAR] = ACTIONS(2970),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2970),
    [sym_int] = ACTIONS(2970),
    [sym_xint] = ACTIONS(2972),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2972),
    [sym__newline] = ACTIONS(2972),
  },
  [1700] = {
    [sym_block_comment] = STATE(1700),
    [sym_compiler_directive_decl] = STATE(1700),
    [sym_fsi_directive_decl] = STATE(1700),
    [sym_preproc_line] = STATE(1700),
    [sym_identifier] = ACTIONS(2942),
    [anon_sym_EQ] = ACTIONS(2944),
    [anon_sym_COLON] = ACTIONS(2942),
    [anon_sym_return] = ACTIONS(2942),
    [anon_sym_do] = ACTIONS(2942),
    [anon_sym_let] = ACTIONS(2942),
    [anon_sym_let_BANG] = ACTIONS(2944),
    [anon_sym_LPAREN] = ACTIONS(2942),
    [anon_sym_COMMA] = ACTIONS(2944),
    [anon_sym_null] = ACTIONS(2942),
    [anon_sym_QMARK] = ACTIONS(2942),
    [anon_sym_COLON_QMARK] = ACTIONS(2942),
    [anon_sym_COLON_COLON] = ACTIONS(2944),
    [anon_sym_AMP] = ACTIONS(2942),
    [anon_sym_LBRACK] = ACTIONS(2942),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2944),
    [anon_sym_LBRACE] = ACTIONS(2942),
    [anon_sym_LT_AT] = ACTIONS(2942),
    [anon_sym_LT_AT_AT] = ACTIONS(2942),
    [anon_sym_DOT] = ACTIONS(2942),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2944),
    [anon_sym_new] = ACTIONS(2942),
    [anon_sym_return_BANG] = ACTIONS(2944),
    [anon_sym_yield] = ACTIONS(2942),
    [anon_sym_yield_BANG] = ACTIONS(2944),
    [anon_sym_lazy] = ACTIONS(2942),
    [anon_sym_assert] = ACTIONS(2942),
    [anon_sym_upcast] = ACTIONS(2942),
    [anon_sym_downcast] = ACTIONS(2942),
    [anon_sym_COLON_GT] = ACTIONS(2944),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2944),
    [anon_sym_for] = ACTIONS(2942),
    [anon_sym_while] = ACTIONS(2942),
    [anon_sym_if] = ACTIONS(2942),
    [anon_sym_fun] = ACTIONS(2942),
    [anon_sym_DASH_GT] = ACTIONS(2942),
    [anon_sym_try] = ACTIONS(2942),
    [anon_sym_match] = ACTIONS(2942),
    [anon_sym_match_BANG] = ACTIONS(2944),
    [anon_sym_function] = ACTIONS(2942),
    [anon_sym_LT_DASH] = ACTIONS(2942),
    [anon_sym_DOT_LBRACK] = ACTIONS(2944),
    [anon_sym_LT] = ACTIONS(2944),
    [anon_sym_use] = ACTIONS(2942),
    [anon_sym_use_BANG] = ACTIONS(2944),
    [anon_sym_do_BANG] = ACTIONS(2944),
    [anon_sym_DOT_DOT] = ACTIONS(2944),
    [anon_sym_begin] = ACTIONS(2942),
    [anon_sym_LPAREN2] = ACTIONS(2942),
    [anon_sym_or] = ACTIONS(2942),
    [aux_sym_char_token1] = ACTIONS(2944),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2942),
    [anon_sym_DQUOTE] = ACTIONS(2942),
    [anon_sym_AT_DQUOTE] = ACTIONS(2944),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2944),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2944),
    [sym_bool] = ACTIONS(2942),
    [sym_unit] = ACTIONS(2944),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2942),
    [sym_op_identifier] = ACTIONS(2942),
    [anon_sym_PLUS] = ACTIONS(2942),
    [anon_sym_DASH] = ACTIONS(2942),
    [anon_sym_PLUS_DOT] = ACTIONS(2942),
    [anon_sym_DASH_DOT] = ACTIONS(2942),
    [anon_sym_PERCENT] = ACTIONS(2942),
    [anon_sym_AMP_AMP] = ACTIONS(2942),
    [anon_sym_TILDE] = ACTIONS(2944),
    [aux_sym_prefix_op_token1] = ACTIONS(2942),
    [aux_sym_infix_op_token1] = ACTIONS(2944),
    [aux_sym_infix_op_token2] = ACTIONS(2942),
    [anon_sym_PIPE_PIPE] = ACTIONS(2942),
    [anon_sym_BANG_EQ] = ACTIONS(2942),
    [anon_sym_COLON_EQ] = ACTIONS(2944),
    [anon_sym_DOLLAR] = ACTIONS(2942),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2942),
    [sym_int] = ACTIONS(2942),
    [sym_xint] = ACTIONS(2944),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2944),
    [sym__newline] = ACTIONS(2944),
  },
  [1701] = {
    [sym_block_comment] = STATE(1701),
    [sym_compiler_directive_decl] = STATE(1701),
    [sym_fsi_directive_decl] = STATE(1701),
    [sym_preproc_line] = STATE(1701),
    [sym_identifier] = ACTIONS(2867),
    [anon_sym_EQ] = ACTIONS(2869),
    [anon_sym_COLON] = ACTIONS(2867),
    [anon_sym_return] = ACTIONS(2867),
    [anon_sym_do] = ACTIONS(2867),
    [anon_sym_let] = ACTIONS(2867),
    [anon_sym_let_BANG] = ACTIONS(2869),
    [anon_sym_LPAREN] = ACTIONS(2867),
    [anon_sym_COMMA] = ACTIONS(2869),
    [anon_sym_null] = ACTIONS(2867),
    [anon_sym_QMARK] = ACTIONS(2867),
    [anon_sym_COLON_QMARK] = ACTIONS(2867),
    [anon_sym_COLON_COLON] = ACTIONS(2869),
    [anon_sym_AMP] = ACTIONS(2867),
    [anon_sym_LBRACK] = ACTIONS(2867),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2869),
    [anon_sym_LBRACE] = ACTIONS(2867),
    [anon_sym_LT_AT] = ACTIONS(2867),
    [anon_sym_LT_AT_AT] = ACTIONS(2867),
    [anon_sym_DOT] = ACTIONS(3956),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2869),
    [anon_sym_new] = ACTIONS(2867),
    [anon_sym_return_BANG] = ACTIONS(2869),
    [anon_sym_yield] = ACTIONS(2867),
    [anon_sym_yield_BANG] = ACTIONS(2869),
    [anon_sym_lazy] = ACTIONS(2867),
    [anon_sym_assert] = ACTIONS(2867),
    [anon_sym_upcast] = ACTIONS(2867),
    [anon_sym_downcast] = ACTIONS(2867),
    [anon_sym_COLON_GT] = ACTIONS(2869),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2869),
    [anon_sym_for] = ACTIONS(2867),
    [anon_sym_while] = ACTIONS(2867),
    [anon_sym_if] = ACTIONS(2867),
    [anon_sym_fun] = ACTIONS(2867),
    [anon_sym_DASH_GT] = ACTIONS(2867),
    [anon_sym_try] = ACTIONS(2867),
    [anon_sym_match] = ACTIONS(2867),
    [anon_sym_match_BANG] = ACTIONS(2869),
    [anon_sym_function] = ACTIONS(2867),
    [anon_sym_LT_DASH] = ACTIONS(2867),
    [anon_sym_DOT_LBRACK] = ACTIONS(2869),
    [anon_sym_LT] = ACTIONS(2869),
    [anon_sym_use] = ACTIONS(2867),
    [anon_sym_use_BANG] = ACTIONS(2869),
    [anon_sym_do_BANG] = ACTIONS(2869),
    [anon_sym_DOT_DOT] = ACTIONS(2869),
    [anon_sym_begin] = ACTIONS(2867),
    [anon_sym_LPAREN2] = ACTIONS(2867),
    [anon_sym_or] = ACTIONS(2867),
    [aux_sym_char_token1] = ACTIONS(2869),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2867),
    [anon_sym_DQUOTE] = ACTIONS(2867),
    [anon_sym_AT_DQUOTE] = ACTIONS(2869),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2869),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2869),
    [sym_bool] = ACTIONS(2867),
    [sym_unit] = ACTIONS(2869),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2867),
    [sym_op_identifier] = ACTIONS(2867),
    [anon_sym_PLUS] = ACTIONS(2867),
    [anon_sym_DASH] = ACTIONS(2867),
    [anon_sym_PLUS_DOT] = ACTIONS(2867),
    [anon_sym_DASH_DOT] = ACTIONS(2867),
    [anon_sym_PERCENT] = ACTIONS(2867),
    [anon_sym_AMP_AMP] = ACTIONS(2867),
    [anon_sym_TILDE] = ACTIONS(2869),
    [aux_sym_prefix_op_token1] = ACTIONS(2867),
    [aux_sym_infix_op_token1] = ACTIONS(2869),
    [aux_sym_infix_op_token2] = ACTIONS(2867),
    [anon_sym_PIPE_PIPE] = ACTIONS(2867),
    [anon_sym_BANG_EQ] = ACTIONS(2867),
    [anon_sym_COLON_EQ] = ACTIONS(2869),
    [anon_sym_DOLLAR] = ACTIONS(2867),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2867),
    [sym_int] = ACTIONS(2867),
    [sym_xint] = ACTIONS(2869),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2869),
    [sym__newline] = ACTIONS(2869),
  },
  [1702] = {
    [sym_block_comment] = STATE(1702),
    [sym_compiler_directive_decl] = STATE(1702),
    [sym_fsi_directive_decl] = STATE(1702),
    [sym_preproc_line] = STATE(1702),
    [sym_identifier] = ACTIONS(2863),
    [anon_sym_EQ] = ACTIONS(2865),
    [anon_sym_COLON] = ACTIONS(2863),
    [anon_sym_return] = ACTIONS(2863),
    [anon_sym_do] = ACTIONS(2863),
    [anon_sym_let] = ACTIONS(2863),
    [anon_sym_let_BANG] = ACTIONS(2865),
    [anon_sym_LPAREN] = ACTIONS(2863),
    [anon_sym_COMMA] = ACTIONS(2865),
    [anon_sym_null] = ACTIONS(2863),
    [anon_sym_QMARK] = ACTIONS(2863),
    [anon_sym_COLON_QMARK] = ACTIONS(2863),
    [anon_sym_COLON_COLON] = ACTIONS(2865),
    [anon_sym_AMP] = ACTIONS(2863),
    [anon_sym_LBRACK] = ACTIONS(2863),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2865),
    [anon_sym_LBRACE] = ACTIONS(2863),
    [anon_sym_LT_AT] = ACTIONS(2863),
    [anon_sym_LT_AT_AT] = ACTIONS(2863),
    [anon_sym_DOT] = ACTIONS(2863),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2865),
    [anon_sym_new] = ACTIONS(2863),
    [anon_sym_return_BANG] = ACTIONS(2865),
    [anon_sym_yield] = ACTIONS(2863),
    [anon_sym_yield_BANG] = ACTIONS(2865),
    [anon_sym_lazy] = ACTIONS(2863),
    [anon_sym_assert] = ACTIONS(2863),
    [anon_sym_upcast] = ACTIONS(2863),
    [anon_sym_downcast] = ACTIONS(2863),
    [anon_sym_COLON_GT] = ACTIONS(2865),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2865),
    [anon_sym_for] = ACTIONS(2863),
    [anon_sym_while] = ACTIONS(2863),
    [anon_sym_if] = ACTIONS(2863),
    [anon_sym_fun] = ACTIONS(2863),
    [anon_sym_DASH_GT] = ACTIONS(2863),
    [anon_sym_try] = ACTIONS(2863),
    [anon_sym_match] = ACTIONS(2863),
    [anon_sym_match_BANG] = ACTIONS(2865),
    [anon_sym_function] = ACTIONS(2863),
    [anon_sym_LT_DASH] = ACTIONS(2863),
    [anon_sym_DOT_LBRACK] = ACTIONS(2865),
    [anon_sym_LT] = ACTIONS(2865),
    [anon_sym_use] = ACTIONS(2863),
    [anon_sym_use_BANG] = ACTIONS(2865),
    [anon_sym_do_BANG] = ACTIONS(2865),
    [anon_sym_DOT_DOT] = ACTIONS(2865),
    [anon_sym_begin] = ACTIONS(2863),
    [anon_sym_LPAREN2] = ACTIONS(2863),
    [anon_sym_or] = ACTIONS(2863),
    [aux_sym_char_token1] = ACTIONS(2865),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2863),
    [anon_sym_DQUOTE] = ACTIONS(2863),
    [anon_sym_AT_DQUOTE] = ACTIONS(2865),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2865),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2865),
    [sym_bool] = ACTIONS(2863),
    [sym_unit] = ACTIONS(2865),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2863),
    [sym_op_identifier] = ACTIONS(2863),
    [anon_sym_PLUS] = ACTIONS(2863),
    [anon_sym_DASH] = ACTIONS(2863),
    [anon_sym_PLUS_DOT] = ACTIONS(2863),
    [anon_sym_DASH_DOT] = ACTIONS(2863),
    [anon_sym_PERCENT] = ACTIONS(2863),
    [anon_sym_AMP_AMP] = ACTIONS(2863),
    [anon_sym_TILDE] = ACTIONS(2865),
    [aux_sym_prefix_op_token1] = ACTIONS(2863),
    [aux_sym_infix_op_token1] = ACTIONS(2865),
    [aux_sym_infix_op_token2] = ACTIONS(2863),
    [anon_sym_PIPE_PIPE] = ACTIONS(2863),
    [anon_sym_BANG_EQ] = ACTIONS(2863),
    [anon_sym_COLON_EQ] = ACTIONS(2865),
    [anon_sym_DOLLAR] = ACTIONS(2863),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2863),
    [sym_int] = ACTIONS(2863),
    [sym_xint] = ACTIONS(2865),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2865),
    [sym__newline] = ACTIONS(2865),
  },
  [1703] = {
    [sym_block_comment] = STATE(1703),
    [sym_compiler_directive_decl] = STATE(1703),
    [sym_fsi_directive_decl] = STATE(1703),
    [sym_preproc_line] = STATE(1703),
    [sym_identifier] = ACTIONS(2760),
    [anon_sym_EQ] = ACTIONS(2762),
    [anon_sym_COLON] = ACTIONS(2760),
    [anon_sym_return] = ACTIONS(2760),
    [anon_sym_do] = ACTIONS(2760),
    [anon_sym_let] = ACTIONS(2760),
    [anon_sym_let_BANG] = ACTIONS(2762),
    [anon_sym_LPAREN] = ACTIONS(2760),
    [anon_sym_COMMA] = ACTIONS(2762),
    [anon_sym_null] = ACTIONS(2760),
    [anon_sym_QMARK] = ACTIONS(2760),
    [anon_sym_COLON_QMARK] = ACTIONS(2760),
    [anon_sym_COLON_COLON] = ACTIONS(2762),
    [anon_sym_PIPE] = ACTIONS(2760),
    [anon_sym_AMP] = ACTIONS(2760),
    [anon_sym_LBRACK] = ACTIONS(2760),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2762),
    [anon_sym_LBRACE] = ACTIONS(2760),
    [anon_sym_LT_AT] = ACTIONS(2760),
    [anon_sym_LT_AT_AT] = ACTIONS(2760),
    [anon_sym_DOT] = ACTIONS(2760),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2762),
    [anon_sym_new] = ACTIONS(2760),
    [anon_sym_return_BANG] = ACTIONS(2762),
    [anon_sym_yield] = ACTIONS(2760),
    [anon_sym_yield_BANG] = ACTIONS(2762),
    [anon_sym_lazy] = ACTIONS(2760),
    [anon_sym_assert] = ACTIONS(2760),
    [anon_sym_upcast] = ACTIONS(2760),
    [anon_sym_downcast] = ACTIONS(2760),
    [anon_sym_COLON_GT] = ACTIONS(2762),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2762),
    [anon_sym_for] = ACTIONS(2760),
    [anon_sym_while] = ACTIONS(2760),
    [anon_sym_if] = ACTIONS(2760),
    [anon_sym_fun] = ACTIONS(2760),
    [anon_sym_try] = ACTIONS(2760),
    [anon_sym_match] = ACTIONS(2760),
    [anon_sym_match_BANG] = ACTIONS(2762),
    [anon_sym_function] = ACTIONS(2760),
    [anon_sym_LT_DASH] = ACTIONS(2760),
    [anon_sym_DOT_LBRACK] = ACTIONS(2762),
    [anon_sym_LT] = ACTIONS(2762),
    [anon_sym_use] = ACTIONS(2760),
    [anon_sym_use_BANG] = ACTIONS(2762),
    [anon_sym_do_BANG] = ACTIONS(2762),
    [anon_sym_DOT_DOT] = ACTIONS(2762),
    [anon_sym_begin] = ACTIONS(2760),
    [anon_sym_LPAREN2] = ACTIONS(2760),
    [anon_sym_or] = ACTIONS(2760),
    [aux_sym_char_token1] = ACTIONS(2762),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2760),
    [anon_sym_DQUOTE] = ACTIONS(2760),
    [anon_sym_AT_DQUOTE] = ACTIONS(2762),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2762),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2762),
    [sym_bool] = ACTIONS(2760),
    [sym_unit] = ACTIONS(2762),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2760),
    [sym_op_identifier] = ACTIONS(2760),
    [anon_sym_PLUS] = ACTIONS(2760),
    [anon_sym_DASH] = ACTIONS(2760),
    [anon_sym_PLUS_DOT] = ACTIONS(2760),
    [anon_sym_DASH_DOT] = ACTIONS(2760),
    [anon_sym_PERCENT] = ACTIONS(2760),
    [anon_sym_AMP_AMP] = ACTIONS(2760),
    [anon_sym_TILDE] = ACTIONS(2762),
    [aux_sym_prefix_op_token1] = ACTIONS(2760),
    [aux_sym_infix_op_token1] = ACTIONS(2762),
    [aux_sym_infix_op_token2] = ACTIONS(2760),
    [anon_sym_PIPE_PIPE] = ACTIONS(2760),
    [anon_sym_BANG_EQ] = ACTIONS(2760),
    [anon_sym_COLON_EQ] = ACTIONS(2762),
    [anon_sym_DOLLAR] = ACTIONS(2760),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2760),
    [sym_int] = ACTIONS(2760),
    [sym_xint] = ACTIONS(2762),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2762),
    [sym__newline] = ACTIONS(2762),
  },
  [1704] = {
    [sym_block_comment] = STATE(1704),
    [sym_compiler_directive_decl] = STATE(1704),
    [sym_fsi_directive_decl] = STATE(1704),
    [sym_preproc_line] = STATE(1704),
    [sym_identifier] = ACTIONS(2756),
    [anon_sym_EQ] = ACTIONS(2758),
    [anon_sym_COLON] = ACTIONS(2756),
    [anon_sym_return] = ACTIONS(2756),
    [anon_sym_do] = ACTIONS(2756),
    [anon_sym_let] = ACTIONS(2756),
    [anon_sym_let_BANG] = ACTIONS(2758),
    [anon_sym_LPAREN] = ACTIONS(2756),
    [anon_sym_COMMA] = ACTIONS(2758),
    [anon_sym_null] = ACTIONS(2756),
    [anon_sym_QMARK] = ACTIONS(2756),
    [anon_sym_COLON_QMARK] = ACTIONS(2756),
    [anon_sym_COLON_COLON] = ACTIONS(2758),
    [anon_sym_PIPE] = ACTIONS(2756),
    [anon_sym_AMP] = ACTIONS(2756),
    [anon_sym_LBRACK] = ACTIONS(2756),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2758),
    [anon_sym_LBRACE] = ACTIONS(2756),
    [anon_sym_LT_AT] = ACTIONS(2756),
    [anon_sym_LT_AT_AT] = ACTIONS(2756),
    [anon_sym_DOT] = ACTIONS(2756),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2758),
    [anon_sym_new] = ACTIONS(2756),
    [anon_sym_return_BANG] = ACTIONS(2758),
    [anon_sym_yield] = ACTIONS(2756),
    [anon_sym_yield_BANG] = ACTIONS(2758),
    [anon_sym_lazy] = ACTIONS(2756),
    [anon_sym_assert] = ACTIONS(2756),
    [anon_sym_upcast] = ACTIONS(2756),
    [anon_sym_downcast] = ACTIONS(2756),
    [anon_sym_COLON_GT] = ACTIONS(2758),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2758),
    [anon_sym_for] = ACTIONS(2756),
    [anon_sym_while] = ACTIONS(2756),
    [anon_sym_if] = ACTIONS(2756),
    [anon_sym_fun] = ACTIONS(2756),
    [anon_sym_try] = ACTIONS(2756),
    [anon_sym_match] = ACTIONS(2756),
    [anon_sym_match_BANG] = ACTIONS(2758),
    [anon_sym_function] = ACTIONS(2756),
    [anon_sym_LT_DASH] = ACTIONS(2756),
    [anon_sym_DOT_LBRACK] = ACTIONS(2758),
    [anon_sym_LT] = ACTIONS(2758),
    [anon_sym_use] = ACTIONS(2756),
    [anon_sym_use_BANG] = ACTIONS(2758),
    [anon_sym_do_BANG] = ACTIONS(2758),
    [anon_sym_DOT_DOT] = ACTIONS(2758),
    [anon_sym_begin] = ACTIONS(2756),
    [anon_sym_LPAREN2] = ACTIONS(2756),
    [anon_sym_or] = ACTIONS(2756),
    [aux_sym_char_token1] = ACTIONS(2758),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2756),
    [anon_sym_DQUOTE] = ACTIONS(2756),
    [anon_sym_AT_DQUOTE] = ACTIONS(2758),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2758),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2758),
    [sym_bool] = ACTIONS(2756),
    [sym_unit] = ACTIONS(2758),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2756),
    [sym_op_identifier] = ACTIONS(2756),
    [anon_sym_PLUS] = ACTIONS(2756),
    [anon_sym_DASH] = ACTIONS(2756),
    [anon_sym_PLUS_DOT] = ACTIONS(2756),
    [anon_sym_DASH_DOT] = ACTIONS(2756),
    [anon_sym_PERCENT] = ACTIONS(2756),
    [anon_sym_AMP_AMP] = ACTIONS(2756),
    [anon_sym_TILDE] = ACTIONS(2758),
    [aux_sym_prefix_op_token1] = ACTIONS(2756),
    [aux_sym_infix_op_token1] = ACTIONS(2758),
    [aux_sym_infix_op_token2] = ACTIONS(2756),
    [anon_sym_PIPE_PIPE] = ACTIONS(2756),
    [anon_sym_BANG_EQ] = ACTIONS(2756),
    [anon_sym_COLON_EQ] = ACTIONS(2758),
    [anon_sym_DOLLAR] = ACTIONS(2756),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2756),
    [sym_int] = ACTIONS(2756),
    [sym_xint] = ACTIONS(2758),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2758),
    [sym__newline] = ACTIONS(2758),
  },
  [1705] = {
    [sym_block_comment] = STATE(1705),
    [sym_compiler_directive_decl] = STATE(1705),
    [sym_fsi_directive_decl] = STATE(1705),
    [sym_preproc_line] = STATE(1705),
    [sym_identifier] = ACTIONS(3011),
    [anon_sym_EQ] = ACTIONS(3013),
    [anon_sym_COLON] = ACTIONS(3011),
    [anon_sym_return] = ACTIONS(3011),
    [anon_sym_do] = ACTIONS(3011),
    [anon_sym_let] = ACTIONS(3011),
    [anon_sym_let_BANG] = ACTIONS(3013),
    [anon_sym_LPAREN] = ACTIONS(3011),
    [anon_sym_COMMA] = ACTIONS(3013),
    [anon_sym_null] = ACTIONS(3011),
    [anon_sym_QMARK] = ACTIONS(3011),
    [anon_sym_COLON_QMARK] = ACTIONS(3011),
    [anon_sym_COLON_COLON] = ACTIONS(3013),
    [anon_sym_AMP] = ACTIONS(3011),
    [anon_sym_LBRACK] = ACTIONS(3011),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3013),
    [anon_sym_LBRACE] = ACTIONS(3011),
    [anon_sym_LT_AT] = ACTIONS(3011),
    [anon_sym_LT_AT_AT] = ACTIONS(3011),
    [anon_sym_DOT] = ACTIONS(3011),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3013),
    [anon_sym_new] = ACTIONS(3011),
    [anon_sym_return_BANG] = ACTIONS(3013),
    [anon_sym_yield] = ACTIONS(3011),
    [anon_sym_yield_BANG] = ACTIONS(3013),
    [anon_sym_lazy] = ACTIONS(3011),
    [anon_sym_assert] = ACTIONS(3011),
    [anon_sym_upcast] = ACTIONS(3011),
    [anon_sym_downcast] = ACTIONS(3011),
    [anon_sym_COLON_GT] = ACTIONS(3013),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3013),
    [anon_sym_for] = ACTIONS(3011),
    [anon_sym_while] = ACTIONS(3011),
    [anon_sym_if] = ACTIONS(3011),
    [anon_sym_fun] = ACTIONS(3011),
    [anon_sym_try] = ACTIONS(3011),
    [anon_sym_match] = ACTIONS(3011),
    [anon_sym_match_BANG] = ACTIONS(3013),
    [anon_sym_function] = ACTIONS(3011),
    [anon_sym_LT_DASH] = ACTIONS(3011),
    [anon_sym_DOT_LBRACK] = ACTIONS(3013),
    [anon_sym_LT] = ACTIONS(3013),
    [anon_sym_use] = ACTIONS(3011),
    [anon_sym_use_BANG] = ACTIONS(3013),
    [anon_sym_do_BANG] = ACTIONS(3013),
    [anon_sym_begin] = ACTIONS(3011),
    [anon_sym_LPAREN2] = ACTIONS(3011),
    [anon_sym_or] = ACTIONS(3011),
    [aux_sym_char_token1] = ACTIONS(3013),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3011),
    [anon_sym_DQUOTE] = ACTIONS(3011),
    [anon_sym_AT_DQUOTE] = ACTIONS(3013),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3013),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3013),
    [sym_bool] = ACTIONS(3011),
    [sym_unit] = ACTIONS(3013),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3011),
    [sym_op_identifier] = ACTIONS(3011),
    [anon_sym_PLUS] = ACTIONS(3011),
    [anon_sym_DASH] = ACTIONS(3011),
    [anon_sym_PLUS_DOT] = ACTIONS(3011),
    [anon_sym_DASH_DOT] = ACTIONS(3011),
    [anon_sym_PERCENT] = ACTIONS(3011),
    [anon_sym_AMP_AMP] = ACTIONS(3011),
    [anon_sym_TILDE] = ACTIONS(3013),
    [aux_sym_prefix_op_token1] = ACTIONS(3011),
    [aux_sym_infix_op_token1] = ACTIONS(3013),
    [aux_sym_infix_op_token2] = ACTIONS(3011),
    [anon_sym_PIPE_PIPE] = ACTIONS(3011),
    [anon_sym_BANG_EQ] = ACTIONS(3011),
    [anon_sym_COLON_EQ] = ACTIONS(3013),
    [anon_sym_DOLLAR] = ACTIONS(3011),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3011),
    [sym_int] = ACTIONS(3011),
    [sym_xint] = ACTIONS(3013),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3013),
    [anon_sym_POUNDendif] = ACTIONS(3013),
    [anon_sym_POUNDelse] = ACTIONS(3013),
    [sym__newline] = ACTIONS(3013),
  },
  [1706] = {
    [sym_block_comment] = STATE(1706),
    [sym_compiler_directive_decl] = STATE(1706),
    [sym_fsi_directive_decl] = STATE(1706),
    [sym_preproc_line] = STATE(1706),
    [sym_identifier] = ACTIONS(2713),
    [anon_sym_EQ] = ACTIONS(2715),
    [anon_sym_COLON] = ACTIONS(2713),
    [anon_sym_return] = ACTIONS(2713),
    [anon_sym_do] = ACTIONS(2713),
    [anon_sym_let] = ACTIONS(2713),
    [anon_sym_let_BANG] = ACTIONS(2715),
    [anon_sym_LPAREN] = ACTIONS(2713),
    [anon_sym_COMMA] = ACTIONS(2715),
    [anon_sym_null] = ACTIONS(2713),
    [anon_sym_QMARK] = ACTIONS(2713),
    [anon_sym_COLON_QMARK] = ACTIONS(2713),
    [anon_sym_COLON_COLON] = ACTIONS(2715),
    [anon_sym_PIPE] = ACTIONS(2713),
    [anon_sym_AMP] = ACTIONS(2713),
    [anon_sym_LBRACK] = ACTIONS(2713),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2715),
    [anon_sym_LBRACE] = ACTIONS(2713),
    [anon_sym_LT_AT] = ACTIONS(2713),
    [anon_sym_LT_AT_AT] = ACTIONS(2713),
    [anon_sym_DOT] = ACTIONS(2713),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2715),
    [anon_sym_new] = ACTIONS(2713),
    [anon_sym_return_BANG] = ACTIONS(2715),
    [anon_sym_yield] = ACTIONS(2713),
    [anon_sym_yield_BANG] = ACTIONS(2715),
    [anon_sym_lazy] = ACTIONS(2713),
    [anon_sym_assert] = ACTIONS(2713),
    [anon_sym_upcast] = ACTIONS(2713),
    [anon_sym_downcast] = ACTIONS(2713),
    [anon_sym_COLON_GT] = ACTIONS(2715),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2715),
    [anon_sym_for] = ACTIONS(2713),
    [anon_sym_while] = ACTIONS(2713),
    [anon_sym_if] = ACTIONS(2713),
    [anon_sym_fun] = ACTIONS(2713),
    [anon_sym_try] = ACTIONS(2713),
    [anon_sym_match] = ACTIONS(2713),
    [anon_sym_match_BANG] = ACTIONS(2715),
    [anon_sym_function] = ACTIONS(2713),
    [anon_sym_LT_DASH] = ACTIONS(2713),
    [anon_sym_DOT_LBRACK] = ACTIONS(2715),
    [anon_sym_LT] = ACTIONS(2715),
    [anon_sym_use] = ACTIONS(2713),
    [anon_sym_use_BANG] = ACTIONS(2715),
    [anon_sym_do_BANG] = ACTIONS(2715),
    [anon_sym_DOT_DOT] = ACTIONS(2715),
    [anon_sym_begin] = ACTIONS(2713),
    [anon_sym_LPAREN2] = ACTIONS(2713),
    [anon_sym_or] = ACTIONS(2713),
    [aux_sym_char_token1] = ACTIONS(2715),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2713),
    [anon_sym_DQUOTE] = ACTIONS(2713),
    [anon_sym_AT_DQUOTE] = ACTIONS(2715),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2715),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2715),
    [sym_bool] = ACTIONS(2713),
    [sym_unit] = ACTIONS(2715),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2713),
    [sym_op_identifier] = ACTIONS(2713),
    [anon_sym_PLUS] = ACTIONS(2713),
    [anon_sym_DASH] = ACTIONS(2713),
    [anon_sym_PLUS_DOT] = ACTIONS(2713),
    [anon_sym_DASH_DOT] = ACTIONS(2713),
    [anon_sym_PERCENT] = ACTIONS(2713),
    [anon_sym_AMP_AMP] = ACTIONS(2713),
    [anon_sym_TILDE] = ACTIONS(2715),
    [aux_sym_prefix_op_token1] = ACTIONS(2713),
    [aux_sym_infix_op_token1] = ACTIONS(2715),
    [aux_sym_infix_op_token2] = ACTIONS(2713),
    [anon_sym_PIPE_PIPE] = ACTIONS(2713),
    [anon_sym_BANG_EQ] = ACTIONS(2713),
    [anon_sym_COLON_EQ] = ACTIONS(2715),
    [anon_sym_DOLLAR] = ACTIONS(2713),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2713),
    [sym_int] = ACTIONS(2713),
    [sym_xint] = ACTIONS(2715),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2715),
    [sym__newline] = ACTIONS(2715),
  },
  [1707] = {
    [sym_block_comment] = STATE(1707),
    [sym_compiler_directive_decl] = STATE(1707),
    [sym_fsi_directive_decl] = STATE(1707),
    [sym_preproc_line] = STATE(1707),
    [sym_identifier] = ACTIONS(2770),
    [anon_sym_EQ] = ACTIONS(2772),
    [anon_sym_COLON] = ACTIONS(2770),
    [anon_sym_return] = ACTIONS(2770),
    [anon_sym_do] = ACTIONS(2770),
    [anon_sym_let] = ACTIONS(2770),
    [anon_sym_let_BANG] = ACTIONS(2772),
    [anon_sym_LPAREN] = ACTIONS(2770),
    [anon_sym_COMMA] = ACTIONS(2772),
    [anon_sym_null] = ACTIONS(2770),
    [anon_sym_QMARK] = ACTIONS(2770),
    [anon_sym_COLON_QMARK] = ACTIONS(2770),
    [anon_sym_COLON_COLON] = ACTIONS(2772),
    [anon_sym_AMP] = ACTIONS(2770),
    [anon_sym_LBRACK] = ACTIONS(2770),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2772),
    [anon_sym_LBRACE] = ACTIONS(2770),
    [anon_sym_LT_AT] = ACTIONS(2770),
    [anon_sym_LT_AT_AT] = ACTIONS(2770),
    [anon_sym_DOT] = ACTIONS(2770),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2772),
    [anon_sym_new] = ACTIONS(2770),
    [anon_sym_return_BANG] = ACTIONS(2772),
    [anon_sym_yield] = ACTIONS(2770),
    [anon_sym_yield_BANG] = ACTIONS(2772),
    [anon_sym_lazy] = ACTIONS(2770),
    [anon_sym_assert] = ACTIONS(2770),
    [anon_sym_upcast] = ACTIONS(2770),
    [anon_sym_downcast] = ACTIONS(2770),
    [anon_sym_COLON_GT] = ACTIONS(2772),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2772),
    [anon_sym_for] = ACTIONS(2770),
    [anon_sym_done] = ACTIONS(3958),
    [anon_sym_while] = ACTIONS(2770),
    [anon_sym_if] = ACTIONS(2770),
    [anon_sym_fun] = ACTIONS(2770),
    [anon_sym_try] = ACTIONS(2770),
    [anon_sym_match] = ACTIONS(2770),
    [anon_sym_match_BANG] = ACTIONS(2772),
    [anon_sym_function] = ACTIONS(2770),
    [anon_sym_LT_DASH] = ACTIONS(2770),
    [anon_sym_DOT_LBRACK] = ACTIONS(2772),
    [anon_sym_LT] = ACTIONS(2772),
    [anon_sym_GT] = ACTIONS(2770),
    [anon_sym_use] = ACTIONS(2770),
    [anon_sym_use_BANG] = ACTIONS(2772),
    [anon_sym_do_BANG] = ACTIONS(2772),
    [anon_sym_begin] = ACTIONS(2770),
    [anon_sym_LPAREN2] = ACTIONS(2770),
    [anon_sym_or] = ACTIONS(2770),
    [aux_sym_char_token1] = ACTIONS(2772),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2770),
    [anon_sym_DQUOTE] = ACTIONS(2770),
    [anon_sym_AT_DQUOTE] = ACTIONS(2772),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2772),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2772),
    [sym_bool] = ACTIONS(2770),
    [sym_unit] = ACTIONS(2772),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2770),
    [sym_op_identifier] = ACTIONS(2770),
    [anon_sym_PLUS] = ACTIONS(2770),
    [anon_sym_DASH] = ACTIONS(2770),
    [anon_sym_PLUS_DOT] = ACTIONS(2770),
    [anon_sym_DASH_DOT] = ACTIONS(2770),
    [anon_sym_PERCENT] = ACTIONS(2770),
    [anon_sym_AMP_AMP] = ACTIONS(2770),
    [anon_sym_TILDE] = ACTIONS(2772),
    [aux_sym_prefix_op_token1] = ACTIONS(2770),
    [aux_sym_infix_op_token1] = ACTIONS(2772),
    [aux_sym_infix_op_token2] = ACTIONS(2770),
    [anon_sym_PIPE_PIPE] = ACTIONS(2770),
    [anon_sym_BANG_EQ] = ACTIONS(2770),
    [anon_sym_COLON_EQ] = ACTIONS(2772),
    [anon_sym_DOLLAR] = ACTIONS(2770),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2770),
    [sym_int] = ACTIONS(2770),
    [sym_xint] = ACTIONS(2772),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2772),
    [sym__newline] = ACTIONS(2772),
  },
  [1708] = {
    [sym_block_comment] = STATE(1708),
    [sym_compiler_directive_decl] = STATE(1708),
    [sym_fsi_directive_decl] = STATE(1708),
    [sym_preproc_line] = STATE(1708),
    [sym_identifier] = ACTIONS(2766),
    [anon_sym_EQ] = ACTIONS(2768),
    [anon_sym_COLON] = ACTIONS(2766),
    [anon_sym_return] = ACTIONS(2766),
    [anon_sym_do] = ACTIONS(2766),
    [anon_sym_let] = ACTIONS(2766),
    [anon_sym_let_BANG] = ACTIONS(2768),
    [anon_sym_LPAREN] = ACTIONS(2766),
    [anon_sym_COMMA] = ACTIONS(2768),
    [anon_sym_null] = ACTIONS(2766),
    [anon_sym_QMARK] = ACTIONS(2766),
    [anon_sym_COLON_QMARK] = ACTIONS(2766),
    [anon_sym_COLON_COLON] = ACTIONS(2768),
    [anon_sym_PIPE] = ACTIONS(2766),
    [anon_sym_AMP] = ACTIONS(2766),
    [anon_sym_LBRACK] = ACTIONS(2766),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2768),
    [anon_sym_LBRACE] = ACTIONS(2766),
    [anon_sym_LT_AT] = ACTIONS(2766),
    [anon_sym_LT_AT_AT] = ACTIONS(2766),
    [anon_sym_DOT] = ACTIONS(2766),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2768),
    [anon_sym_new] = ACTIONS(2766),
    [anon_sym_return_BANG] = ACTIONS(2768),
    [anon_sym_yield] = ACTIONS(2766),
    [anon_sym_yield_BANG] = ACTIONS(2768),
    [anon_sym_lazy] = ACTIONS(2766),
    [anon_sym_assert] = ACTIONS(2766),
    [anon_sym_upcast] = ACTIONS(2766),
    [anon_sym_downcast] = ACTIONS(2766),
    [anon_sym_COLON_GT] = ACTIONS(2768),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2768),
    [anon_sym_for] = ACTIONS(2766),
    [anon_sym_while] = ACTIONS(2766),
    [anon_sym_if] = ACTIONS(2766),
    [anon_sym_fun] = ACTIONS(2766),
    [anon_sym_try] = ACTIONS(2766),
    [anon_sym_match] = ACTIONS(2766),
    [anon_sym_match_BANG] = ACTIONS(2768),
    [anon_sym_function] = ACTIONS(2766),
    [anon_sym_LT_DASH] = ACTIONS(2766),
    [anon_sym_DOT_LBRACK] = ACTIONS(2768),
    [anon_sym_LT] = ACTIONS(2768),
    [anon_sym_use] = ACTIONS(2766),
    [anon_sym_use_BANG] = ACTIONS(2768),
    [anon_sym_do_BANG] = ACTIONS(2768),
    [anon_sym_DOT_DOT] = ACTIONS(2768),
    [anon_sym_begin] = ACTIONS(2766),
    [anon_sym_LPAREN2] = ACTIONS(2766),
    [anon_sym_or] = ACTIONS(2766),
    [aux_sym_char_token1] = ACTIONS(2768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2766),
    [anon_sym_DQUOTE] = ACTIONS(2766),
    [anon_sym_AT_DQUOTE] = ACTIONS(2768),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2768),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2768),
    [sym_bool] = ACTIONS(2766),
    [sym_unit] = ACTIONS(2768),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2766),
    [sym_op_identifier] = ACTIONS(2766),
    [anon_sym_PLUS] = ACTIONS(2766),
    [anon_sym_DASH] = ACTIONS(2766),
    [anon_sym_PLUS_DOT] = ACTIONS(2766),
    [anon_sym_DASH_DOT] = ACTIONS(2766),
    [anon_sym_PERCENT] = ACTIONS(2766),
    [anon_sym_AMP_AMP] = ACTIONS(2766),
    [anon_sym_TILDE] = ACTIONS(2768),
    [aux_sym_prefix_op_token1] = ACTIONS(2766),
    [aux_sym_infix_op_token1] = ACTIONS(2768),
    [aux_sym_infix_op_token2] = ACTIONS(2766),
    [anon_sym_PIPE_PIPE] = ACTIONS(2766),
    [anon_sym_BANG_EQ] = ACTIONS(2766),
    [anon_sym_COLON_EQ] = ACTIONS(2768),
    [anon_sym_DOLLAR] = ACTIONS(2766),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2766),
    [sym_int] = ACTIONS(2766),
    [sym_xint] = ACTIONS(2768),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2768),
    [sym__newline] = ACTIONS(2768),
  },
  [1709] = {
    [sym_block_comment] = STATE(1709),
    [sym_compiler_directive_decl] = STATE(1709),
    [sym_fsi_directive_decl] = STATE(1709),
    [sym_preproc_line] = STATE(1709),
    [sym_identifier] = ACTIONS(2988),
    [anon_sym_EQ] = ACTIONS(2990),
    [anon_sym_COLON] = ACTIONS(2988),
    [anon_sym_return] = ACTIONS(2988),
    [anon_sym_do] = ACTIONS(2988),
    [anon_sym_let] = ACTIONS(2988),
    [anon_sym_let_BANG] = ACTIONS(2990),
    [anon_sym_LPAREN] = ACTIONS(2988),
    [anon_sym_COMMA] = ACTIONS(2990),
    [anon_sym_null] = ACTIONS(2988),
    [anon_sym_QMARK] = ACTIONS(2988),
    [anon_sym_COLON_QMARK] = ACTIONS(2988),
    [anon_sym_COLON_COLON] = ACTIONS(2990),
    [anon_sym_AMP] = ACTIONS(2988),
    [anon_sym_LBRACK] = ACTIONS(2988),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2990),
    [anon_sym_LBRACE] = ACTIONS(2988),
    [anon_sym_LT_AT] = ACTIONS(2988),
    [anon_sym_LT_AT_AT] = ACTIONS(2988),
    [anon_sym_DOT] = ACTIONS(2988),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2990),
    [anon_sym_new] = ACTIONS(2988),
    [anon_sym_return_BANG] = ACTIONS(2990),
    [anon_sym_yield] = ACTIONS(2988),
    [anon_sym_yield_BANG] = ACTIONS(2990),
    [anon_sym_lazy] = ACTIONS(2988),
    [anon_sym_assert] = ACTIONS(2988),
    [anon_sym_upcast] = ACTIONS(2988),
    [anon_sym_downcast] = ACTIONS(2988),
    [anon_sym_COLON_GT] = ACTIONS(2990),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2990),
    [anon_sym_for] = ACTIONS(2988),
    [anon_sym_while] = ACTIONS(2988),
    [anon_sym_if] = ACTIONS(2988),
    [anon_sym_fun] = ACTIONS(2988),
    [anon_sym_try] = ACTIONS(2988),
    [anon_sym_match] = ACTIONS(2988),
    [anon_sym_match_BANG] = ACTIONS(2990),
    [anon_sym_function] = ACTIONS(2988),
    [anon_sym_LT_DASH] = ACTIONS(2988),
    [anon_sym_DOT_LBRACK] = ACTIONS(2990),
    [anon_sym_LT] = ACTIONS(2990),
    [anon_sym_use] = ACTIONS(2988),
    [anon_sym_use_BANG] = ACTIONS(2990),
    [anon_sym_do_BANG] = ACTIONS(2990),
    [anon_sym_begin] = ACTIONS(2988),
    [anon_sym_LPAREN2] = ACTIONS(2988),
    [anon_sym_or] = ACTIONS(2988),
    [aux_sym_char_token1] = ACTIONS(2990),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2988),
    [anon_sym_DQUOTE] = ACTIONS(2988),
    [anon_sym_AT_DQUOTE] = ACTIONS(2990),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2990),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2990),
    [sym_bool] = ACTIONS(2988),
    [sym_unit] = ACTIONS(2990),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2988),
    [sym_op_identifier] = ACTIONS(2988),
    [anon_sym_PLUS] = ACTIONS(2988),
    [anon_sym_DASH] = ACTIONS(2988),
    [anon_sym_PLUS_DOT] = ACTIONS(2988),
    [anon_sym_DASH_DOT] = ACTIONS(2988),
    [anon_sym_PERCENT] = ACTIONS(2988),
    [anon_sym_AMP_AMP] = ACTIONS(2988),
    [anon_sym_TILDE] = ACTIONS(2990),
    [aux_sym_prefix_op_token1] = ACTIONS(2988),
    [aux_sym_infix_op_token1] = ACTIONS(2990),
    [aux_sym_infix_op_token2] = ACTIONS(2988),
    [anon_sym_PIPE_PIPE] = ACTIONS(2988),
    [anon_sym_BANG_EQ] = ACTIONS(2988),
    [anon_sym_COLON_EQ] = ACTIONS(2990),
    [anon_sym_DOLLAR] = ACTIONS(2988),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2988),
    [sym_int] = ACTIONS(2988),
    [sym_xint] = ACTIONS(2990),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2990),
    [anon_sym_POUNDendif] = ACTIONS(2990),
    [anon_sym_POUNDelse] = ACTIONS(2990),
    [sym__newline] = ACTIONS(2990),
  },
  [1710] = {
    [sym_block_comment] = STATE(1710),
    [sym_compiler_directive_decl] = STATE(1710),
    [sym_fsi_directive_decl] = STATE(1710),
    [sym_preproc_line] = STATE(1710),
    [sym_identifier] = ACTIONS(2970),
    [anon_sym_EQ] = ACTIONS(2972),
    [anon_sym_COLON] = ACTIONS(2970),
    [anon_sym_return] = ACTIONS(2970),
    [anon_sym_do] = ACTIONS(2970),
    [anon_sym_let] = ACTIONS(2970),
    [anon_sym_let_BANG] = ACTIONS(2972),
    [anon_sym_LPAREN] = ACTIONS(2970),
    [anon_sym_COMMA] = ACTIONS(2972),
    [anon_sym_null] = ACTIONS(2970),
    [anon_sym_QMARK] = ACTIONS(2970),
    [anon_sym_COLON_QMARK] = ACTIONS(2970),
    [anon_sym_COLON_COLON] = ACTIONS(2972),
    [anon_sym_AMP] = ACTIONS(2970),
    [anon_sym_LBRACK] = ACTIONS(2970),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2972),
    [anon_sym_LBRACE] = ACTIONS(2970),
    [anon_sym_LT_AT] = ACTIONS(2970),
    [anon_sym_LT_AT_AT] = ACTIONS(2970),
    [anon_sym_DOT] = ACTIONS(2970),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2972),
    [anon_sym_new] = ACTIONS(2970),
    [anon_sym_return_BANG] = ACTIONS(2972),
    [anon_sym_yield] = ACTIONS(2970),
    [anon_sym_yield_BANG] = ACTIONS(2972),
    [anon_sym_lazy] = ACTIONS(2970),
    [anon_sym_assert] = ACTIONS(2970),
    [anon_sym_upcast] = ACTIONS(2970),
    [anon_sym_downcast] = ACTIONS(2970),
    [anon_sym_COLON_GT] = ACTIONS(2972),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2972),
    [anon_sym_for] = ACTIONS(2970),
    [anon_sym_while] = ACTIONS(2970),
    [anon_sym_if] = ACTIONS(2970),
    [anon_sym_fun] = ACTIONS(2970),
    [anon_sym_try] = ACTIONS(2970),
    [anon_sym_match] = ACTIONS(2970),
    [anon_sym_match_BANG] = ACTIONS(2972),
    [anon_sym_function] = ACTIONS(2970),
    [anon_sym_LT_DASH] = ACTIONS(2970),
    [anon_sym_DOT_LBRACK] = ACTIONS(2972),
    [anon_sym_LT] = ACTIONS(2972),
    [anon_sym_use] = ACTIONS(2970),
    [anon_sym_use_BANG] = ACTIONS(2972),
    [anon_sym_do_BANG] = ACTIONS(2972),
    [anon_sym_begin] = ACTIONS(2970),
    [anon_sym_LPAREN2] = ACTIONS(2970),
    [anon_sym_or] = ACTIONS(2970),
    [aux_sym_char_token1] = ACTIONS(2972),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2970),
    [anon_sym_DQUOTE] = ACTIONS(2970),
    [anon_sym_AT_DQUOTE] = ACTIONS(2972),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2972),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2972),
    [sym_bool] = ACTIONS(2970),
    [sym_unit] = ACTIONS(2972),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2970),
    [sym_op_identifier] = ACTIONS(2970),
    [anon_sym_PLUS] = ACTIONS(2970),
    [anon_sym_DASH] = ACTIONS(2970),
    [anon_sym_PLUS_DOT] = ACTIONS(2970),
    [anon_sym_DASH_DOT] = ACTIONS(2970),
    [anon_sym_PERCENT] = ACTIONS(2970),
    [anon_sym_AMP_AMP] = ACTIONS(2970),
    [anon_sym_TILDE] = ACTIONS(2972),
    [aux_sym_prefix_op_token1] = ACTIONS(2970),
    [aux_sym_infix_op_token1] = ACTIONS(2972),
    [aux_sym_infix_op_token2] = ACTIONS(2970),
    [anon_sym_PIPE_PIPE] = ACTIONS(2970),
    [anon_sym_BANG_EQ] = ACTIONS(2970),
    [anon_sym_COLON_EQ] = ACTIONS(2972),
    [anon_sym_DOLLAR] = ACTIONS(2970),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2970),
    [sym_int] = ACTIONS(2970),
    [sym_xint] = ACTIONS(2972),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2972),
    [anon_sym_POUNDendif] = ACTIONS(2972),
    [anon_sym_POUNDelse] = ACTIONS(2972),
    [sym__newline] = ACTIONS(2972),
  },
  [1711] = {
    [sym_block_comment] = STATE(1711),
    [sym_compiler_directive_decl] = STATE(1711),
    [sym_fsi_directive_decl] = STATE(1711),
    [sym_preproc_line] = STATE(1711),
    [sym_identifier] = ACTIONS(2873),
    [anon_sym_EQ] = ACTIONS(2875),
    [anon_sym_COLON] = ACTIONS(2873),
    [anon_sym_return] = ACTIONS(2873),
    [anon_sym_do] = ACTIONS(2873),
    [anon_sym_let] = ACTIONS(2873),
    [anon_sym_let_BANG] = ACTIONS(2875),
    [anon_sym_as] = ACTIONS(2873),
    [anon_sym_LPAREN] = ACTIONS(2873),
    [anon_sym_COMMA] = ACTIONS(2875),
    [anon_sym_null] = ACTIONS(2873),
    [anon_sym_QMARK] = ACTIONS(2873),
    [anon_sym_COLON_QMARK] = ACTIONS(2873),
    [anon_sym_COLON_COLON] = ACTIONS(2875),
    [anon_sym_AMP] = ACTIONS(2873),
    [anon_sym_LBRACK] = ACTIONS(2873),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2875),
    [anon_sym_LBRACE] = ACTIONS(2873),
    [anon_sym_LT_AT] = ACTIONS(2873),
    [anon_sym_LT_AT_AT] = ACTIONS(2873),
    [anon_sym_DOT] = ACTIONS(2873),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2875),
    [anon_sym_new] = ACTIONS(2873),
    [anon_sym_with] = ACTIONS(2873),
    [anon_sym_return_BANG] = ACTIONS(2875),
    [anon_sym_yield] = ACTIONS(2873),
    [anon_sym_yield_BANG] = ACTIONS(2875),
    [anon_sym_lazy] = ACTIONS(2873),
    [anon_sym_assert] = ACTIONS(2873),
    [anon_sym_upcast] = ACTIONS(2873),
    [anon_sym_downcast] = ACTIONS(2873),
    [anon_sym_COLON_GT] = ACTIONS(2875),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2875),
    [anon_sym_for] = ACTIONS(2873),
    [anon_sym_while] = ACTIONS(2873),
    [anon_sym_if] = ACTIONS(2873),
    [anon_sym_fun] = ACTIONS(2873),
    [anon_sym_try] = ACTIONS(2873),
    [anon_sym_match] = ACTIONS(2873),
    [anon_sym_match_BANG] = ACTIONS(2875),
    [anon_sym_function] = ACTIONS(2873),
    [anon_sym_LT_DASH] = ACTIONS(2873),
    [anon_sym_DOT_LBRACK] = ACTIONS(2875),
    [anon_sym_LT] = ACTIONS(2875),
    [anon_sym_use] = ACTIONS(2873),
    [anon_sym_use_BANG] = ACTIONS(2875),
    [anon_sym_do_BANG] = ACTIONS(2875),
    [anon_sym_begin] = ACTIONS(2873),
    [anon_sym_LPAREN2] = ACTIONS(2873),
    [anon_sym_or] = ACTIONS(2873),
    [aux_sym_char_token1] = ACTIONS(2875),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2873),
    [anon_sym_DQUOTE] = ACTIONS(2873),
    [anon_sym_AT_DQUOTE] = ACTIONS(2875),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2875),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2875),
    [sym_bool] = ACTIONS(2873),
    [sym_unit] = ACTIONS(2875),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2873),
    [sym_op_identifier] = ACTIONS(2873),
    [anon_sym_PLUS] = ACTIONS(2873),
    [anon_sym_DASH] = ACTIONS(2873),
    [anon_sym_PLUS_DOT] = ACTIONS(2873),
    [anon_sym_DASH_DOT] = ACTIONS(2873),
    [anon_sym_PERCENT] = ACTIONS(2873),
    [anon_sym_AMP_AMP] = ACTIONS(2873),
    [anon_sym_TILDE] = ACTIONS(2875),
    [aux_sym_prefix_op_token1] = ACTIONS(2873),
    [aux_sym_infix_op_token1] = ACTIONS(2875),
    [aux_sym_infix_op_token2] = ACTIONS(2873),
    [anon_sym_PIPE_PIPE] = ACTIONS(2873),
    [anon_sym_BANG_EQ] = ACTIONS(2873),
    [anon_sym_COLON_EQ] = ACTIONS(2875),
    [anon_sym_DOLLAR] = ACTIONS(2873),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2873),
    [sym_int] = ACTIONS(2873),
    [sym_xint] = ACTIONS(2875),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2875),
    [sym__newline] = ACTIONS(2875),
  },
  [1712] = {
    [sym_block_comment] = STATE(1712),
    [sym_compiler_directive_decl] = STATE(1712),
    [sym_fsi_directive_decl] = STATE(1712),
    [sym_preproc_line] = STATE(1712),
    [sym_identifier] = ACTIONS(2954),
    [anon_sym_EQ] = ACTIONS(2956),
    [anon_sym_COLON] = ACTIONS(2954),
    [anon_sym_return] = ACTIONS(2954),
    [anon_sym_do] = ACTIONS(2954),
    [anon_sym_let] = ACTIONS(2954),
    [anon_sym_let_BANG] = ACTIONS(2956),
    [anon_sym_LPAREN] = ACTIONS(2954),
    [anon_sym_COMMA] = ACTIONS(2956),
    [anon_sym_null] = ACTIONS(2954),
    [anon_sym_QMARK] = ACTIONS(2954),
    [anon_sym_COLON_QMARK] = ACTIONS(2954),
    [anon_sym_COLON_COLON] = ACTIONS(2956),
    [anon_sym_AMP] = ACTIONS(2954),
    [anon_sym_LBRACK] = ACTIONS(2954),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2956),
    [anon_sym_LBRACE] = ACTIONS(2954),
    [anon_sym_LT_AT] = ACTIONS(2954),
    [anon_sym_LT_AT_AT] = ACTIONS(2954),
    [anon_sym_DOT] = ACTIONS(2954),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2956),
    [anon_sym_new] = ACTIONS(2954),
    [anon_sym_return_BANG] = ACTIONS(2956),
    [anon_sym_yield] = ACTIONS(2954),
    [anon_sym_yield_BANG] = ACTIONS(2956),
    [anon_sym_lazy] = ACTIONS(2954),
    [anon_sym_assert] = ACTIONS(2954),
    [anon_sym_upcast] = ACTIONS(2954),
    [anon_sym_downcast] = ACTIONS(2954),
    [anon_sym_COLON_GT] = ACTIONS(2956),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2956),
    [anon_sym_for] = ACTIONS(2954),
    [anon_sym_while] = ACTIONS(2954),
    [anon_sym_if] = ACTIONS(2954),
    [anon_sym_fun] = ACTIONS(2954),
    [anon_sym_DASH_GT] = ACTIONS(2954),
    [anon_sym_try] = ACTIONS(2954),
    [anon_sym_match] = ACTIONS(2954),
    [anon_sym_match_BANG] = ACTIONS(2956),
    [anon_sym_function] = ACTIONS(2954),
    [anon_sym_LT_DASH] = ACTIONS(2954),
    [anon_sym_DOT_LBRACK] = ACTIONS(2956),
    [anon_sym_LT] = ACTIONS(2956),
    [anon_sym_use] = ACTIONS(2954),
    [anon_sym_use_BANG] = ACTIONS(2956),
    [anon_sym_do_BANG] = ACTIONS(2956),
    [anon_sym_DOT_DOT] = ACTIONS(2956),
    [anon_sym_begin] = ACTIONS(2954),
    [anon_sym_LPAREN2] = ACTIONS(2954),
    [anon_sym_or] = ACTIONS(2954),
    [aux_sym_char_token1] = ACTIONS(2956),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2954),
    [anon_sym_DQUOTE] = ACTIONS(2954),
    [anon_sym_AT_DQUOTE] = ACTIONS(2956),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2956),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2956),
    [sym_bool] = ACTIONS(2954),
    [sym_unit] = ACTIONS(2956),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2954),
    [sym_op_identifier] = ACTIONS(2954),
    [anon_sym_PLUS] = ACTIONS(2954),
    [anon_sym_DASH] = ACTIONS(2954),
    [anon_sym_PLUS_DOT] = ACTIONS(2954),
    [anon_sym_DASH_DOT] = ACTIONS(2954),
    [anon_sym_PERCENT] = ACTIONS(2954),
    [anon_sym_AMP_AMP] = ACTIONS(2954),
    [anon_sym_TILDE] = ACTIONS(2956),
    [aux_sym_prefix_op_token1] = ACTIONS(2954),
    [aux_sym_infix_op_token1] = ACTIONS(2956),
    [aux_sym_infix_op_token2] = ACTIONS(2954),
    [anon_sym_PIPE_PIPE] = ACTIONS(2954),
    [anon_sym_BANG_EQ] = ACTIONS(2954),
    [anon_sym_COLON_EQ] = ACTIONS(2956),
    [anon_sym_DOLLAR] = ACTIONS(2954),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2954),
    [sym_int] = ACTIONS(2954),
    [sym_xint] = ACTIONS(2956),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2956),
    [sym__newline] = ACTIONS(2956),
  },
  [1713] = {
    [sym_block_comment] = STATE(1713),
    [sym_compiler_directive_decl] = STATE(1713),
    [sym_fsi_directive_decl] = STATE(1713),
    [sym_preproc_line] = STATE(1713),
    [sym_identifier] = ACTIONS(2942),
    [anon_sym_EQ] = ACTIONS(2944),
    [anon_sym_COLON] = ACTIONS(2942),
    [anon_sym_return] = ACTIONS(2942),
    [anon_sym_do] = ACTIONS(2942),
    [anon_sym_let] = ACTIONS(2942),
    [anon_sym_let_BANG] = ACTIONS(2944),
    [anon_sym_LPAREN] = ACTIONS(2942),
    [anon_sym_COMMA] = ACTIONS(2944),
    [anon_sym_null] = ACTIONS(2942),
    [anon_sym_QMARK] = ACTIONS(2942),
    [anon_sym_COLON_QMARK] = ACTIONS(2942),
    [anon_sym_COLON_COLON] = ACTIONS(2944),
    [anon_sym_AMP] = ACTIONS(2942),
    [anon_sym_LBRACK] = ACTIONS(2942),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2944),
    [anon_sym_LBRACE] = ACTIONS(2942),
    [anon_sym_LT_AT] = ACTIONS(2942),
    [anon_sym_LT_AT_AT] = ACTIONS(2942),
    [anon_sym_DOT] = ACTIONS(2942),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2944),
    [anon_sym_new] = ACTIONS(2942),
    [anon_sym_return_BANG] = ACTIONS(2944),
    [anon_sym_yield] = ACTIONS(2942),
    [anon_sym_yield_BANG] = ACTIONS(2944),
    [anon_sym_lazy] = ACTIONS(2942),
    [anon_sym_assert] = ACTIONS(2942),
    [anon_sym_upcast] = ACTIONS(2942),
    [anon_sym_downcast] = ACTIONS(2942),
    [anon_sym_COLON_GT] = ACTIONS(2944),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2944),
    [anon_sym_for] = ACTIONS(2942),
    [anon_sym_while] = ACTIONS(2942),
    [anon_sym_if] = ACTIONS(2942),
    [anon_sym_fun] = ACTIONS(2942),
    [anon_sym_try] = ACTIONS(2942),
    [anon_sym_match] = ACTIONS(2942),
    [anon_sym_match_BANG] = ACTIONS(2944),
    [anon_sym_function] = ACTIONS(2942),
    [anon_sym_LT_DASH] = ACTIONS(2942),
    [anon_sym_DOT_LBRACK] = ACTIONS(2944),
    [anon_sym_LT] = ACTIONS(2944),
    [anon_sym_use] = ACTIONS(2942),
    [anon_sym_use_BANG] = ACTIONS(2944),
    [anon_sym_do_BANG] = ACTIONS(2944),
    [anon_sym_begin] = ACTIONS(2942),
    [anon_sym_LPAREN2] = ACTIONS(2942),
    [anon_sym_or] = ACTIONS(2942),
    [aux_sym_char_token1] = ACTIONS(2944),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2942),
    [anon_sym_DQUOTE] = ACTIONS(2942),
    [anon_sym_AT_DQUOTE] = ACTIONS(2944),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2944),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2944),
    [sym_bool] = ACTIONS(2942),
    [sym_unit] = ACTIONS(2944),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2942),
    [sym_op_identifier] = ACTIONS(2942),
    [anon_sym_PLUS] = ACTIONS(2942),
    [anon_sym_DASH] = ACTIONS(2942),
    [anon_sym_PLUS_DOT] = ACTIONS(2942),
    [anon_sym_DASH_DOT] = ACTIONS(2942),
    [anon_sym_PERCENT] = ACTIONS(2942),
    [anon_sym_AMP_AMP] = ACTIONS(2942),
    [anon_sym_TILDE] = ACTIONS(2944),
    [aux_sym_prefix_op_token1] = ACTIONS(2942),
    [aux_sym_infix_op_token1] = ACTIONS(2944),
    [aux_sym_infix_op_token2] = ACTIONS(2942),
    [anon_sym_PIPE_PIPE] = ACTIONS(2942),
    [anon_sym_BANG_EQ] = ACTIONS(2942),
    [anon_sym_COLON_EQ] = ACTIONS(2944),
    [anon_sym_DOLLAR] = ACTIONS(2942),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2942),
    [sym_int] = ACTIONS(2942),
    [sym_xint] = ACTIONS(2944),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2944),
    [anon_sym_POUNDendif] = ACTIONS(2944),
    [anon_sym_POUNDelse] = ACTIONS(2944),
    [sym__newline] = ACTIONS(2944),
  },
  [1714] = {
    [sym_block_comment] = STATE(1714),
    [sym_compiler_directive_decl] = STATE(1714),
    [sym_fsi_directive_decl] = STATE(1714),
    [sym_preproc_line] = STATE(1714),
    [sym_identifier] = ACTIONS(2877),
    [anon_sym_EQ] = ACTIONS(2879),
    [anon_sym_COLON] = ACTIONS(2877),
    [anon_sym_return] = ACTIONS(2877),
    [anon_sym_do] = ACTIONS(2877),
    [anon_sym_let] = ACTIONS(2877),
    [anon_sym_let_BANG] = ACTIONS(2879),
    [anon_sym_as] = ACTIONS(2877),
    [anon_sym_LPAREN] = ACTIONS(2877),
    [anon_sym_COMMA] = ACTIONS(2879),
    [anon_sym_null] = ACTIONS(2877),
    [anon_sym_QMARK] = ACTIONS(2877),
    [anon_sym_COLON_QMARK] = ACTIONS(2877),
    [anon_sym_COLON_COLON] = ACTIONS(2879),
    [anon_sym_AMP] = ACTIONS(2877),
    [anon_sym_LBRACK] = ACTIONS(2877),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2879),
    [anon_sym_LBRACE] = ACTIONS(2877),
    [anon_sym_LT_AT] = ACTIONS(2877),
    [anon_sym_LT_AT_AT] = ACTIONS(2877),
    [anon_sym_DOT] = ACTIONS(2877),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2879),
    [anon_sym_new] = ACTIONS(2877),
    [anon_sym_with] = ACTIONS(2877),
    [anon_sym_return_BANG] = ACTIONS(2879),
    [anon_sym_yield] = ACTIONS(2877),
    [anon_sym_yield_BANG] = ACTIONS(2879),
    [anon_sym_lazy] = ACTIONS(2877),
    [anon_sym_assert] = ACTIONS(2877),
    [anon_sym_upcast] = ACTIONS(2877),
    [anon_sym_downcast] = ACTIONS(2877),
    [anon_sym_COLON_GT] = ACTIONS(2879),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2879),
    [anon_sym_for] = ACTIONS(2877),
    [anon_sym_while] = ACTIONS(2877),
    [anon_sym_if] = ACTIONS(2877),
    [anon_sym_fun] = ACTIONS(2877),
    [anon_sym_try] = ACTIONS(2877),
    [anon_sym_match] = ACTIONS(2877),
    [anon_sym_match_BANG] = ACTIONS(2879),
    [anon_sym_function] = ACTIONS(2877),
    [anon_sym_LT_DASH] = ACTIONS(2877),
    [anon_sym_DOT_LBRACK] = ACTIONS(2879),
    [anon_sym_LT] = ACTIONS(2879),
    [anon_sym_use] = ACTIONS(2877),
    [anon_sym_use_BANG] = ACTIONS(2879),
    [anon_sym_do_BANG] = ACTIONS(2879),
    [anon_sym_begin] = ACTIONS(2877),
    [anon_sym_LPAREN2] = ACTIONS(2877),
    [anon_sym_or] = ACTIONS(2877),
    [aux_sym_char_token1] = ACTIONS(2879),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2877),
    [anon_sym_DQUOTE] = ACTIONS(2877),
    [anon_sym_AT_DQUOTE] = ACTIONS(2879),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2879),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2879),
    [sym_bool] = ACTIONS(2877),
    [sym_unit] = ACTIONS(2879),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2877),
    [sym_op_identifier] = ACTIONS(2877),
    [anon_sym_PLUS] = ACTIONS(2877),
    [anon_sym_DASH] = ACTIONS(2877),
    [anon_sym_PLUS_DOT] = ACTIONS(2877),
    [anon_sym_DASH_DOT] = ACTIONS(2877),
    [anon_sym_PERCENT] = ACTIONS(2877),
    [anon_sym_AMP_AMP] = ACTIONS(2877),
    [anon_sym_TILDE] = ACTIONS(2879),
    [aux_sym_prefix_op_token1] = ACTIONS(2877),
    [aux_sym_infix_op_token1] = ACTIONS(2879),
    [aux_sym_infix_op_token2] = ACTIONS(2877),
    [anon_sym_PIPE_PIPE] = ACTIONS(2877),
    [anon_sym_BANG_EQ] = ACTIONS(2877),
    [anon_sym_COLON_EQ] = ACTIONS(2879),
    [anon_sym_DOLLAR] = ACTIONS(2877),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2877),
    [sym_int] = ACTIONS(2877),
    [sym_xint] = ACTIONS(2879),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2879),
    [sym__newline] = ACTIONS(2879),
  },
  [1715] = {
    [sym_block_comment] = STATE(1715),
    [sym_compiler_directive_decl] = STATE(1715),
    [sym_fsi_directive_decl] = STATE(1715),
    [sym_preproc_line] = STATE(1715),
    [sym_identifier] = ACTIONS(2883),
    [anon_sym_EQ] = ACTIONS(2885),
    [anon_sym_COLON] = ACTIONS(2883),
    [anon_sym_return] = ACTIONS(2883),
    [anon_sym_do] = ACTIONS(2883),
    [anon_sym_let] = ACTIONS(2883),
    [anon_sym_let_BANG] = ACTIONS(2885),
    [anon_sym_as] = ACTIONS(2883),
    [anon_sym_LPAREN] = ACTIONS(2883),
    [anon_sym_COMMA] = ACTIONS(2885),
    [anon_sym_null] = ACTIONS(2883),
    [anon_sym_QMARK] = ACTIONS(2883),
    [anon_sym_COLON_QMARK] = ACTIONS(2883),
    [anon_sym_COLON_COLON] = ACTIONS(2885),
    [anon_sym_AMP] = ACTIONS(2883),
    [anon_sym_LBRACK] = ACTIONS(2883),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2885),
    [anon_sym_LBRACE] = ACTIONS(2883),
    [anon_sym_LT_AT] = ACTIONS(2883),
    [anon_sym_LT_AT_AT] = ACTIONS(2883),
    [anon_sym_DOT] = ACTIONS(2883),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2885),
    [anon_sym_new] = ACTIONS(2883),
    [anon_sym_with] = ACTIONS(2883),
    [anon_sym_return_BANG] = ACTIONS(2885),
    [anon_sym_yield] = ACTIONS(2883),
    [anon_sym_yield_BANG] = ACTIONS(2885),
    [anon_sym_lazy] = ACTIONS(2883),
    [anon_sym_assert] = ACTIONS(2883),
    [anon_sym_upcast] = ACTIONS(2883),
    [anon_sym_downcast] = ACTIONS(2883),
    [anon_sym_COLON_GT] = ACTIONS(2885),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2885),
    [anon_sym_for] = ACTIONS(2883),
    [anon_sym_while] = ACTIONS(2883),
    [anon_sym_if] = ACTIONS(2883),
    [anon_sym_fun] = ACTIONS(2883),
    [anon_sym_try] = ACTIONS(2883),
    [anon_sym_match] = ACTIONS(2883),
    [anon_sym_match_BANG] = ACTIONS(2885),
    [anon_sym_function] = ACTIONS(2883),
    [anon_sym_LT_DASH] = ACTIONS(2883),
    [anon_sym_DOT_LBRACK] = ACTIONS(2885),
    [anon_sym_LT] = ACTIONS(2885),
    [anon_sym_use] = ACTIONS(2883),
    [anon_sym_use_BANG] = ACTIONS(2885),
    [anon_sym_do_BANG] = ACTIONS(2885),
    [anon_sym_begin] = ACTIONS(2883),
    [anon_sym_LPAREN2] = ACTIONS(2883),
    [anon_sym_or] = ACTIONS(2883),
    [aux_sym_char_token1] = ACTIONS(2885),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2883),
    [anon_sym_DQUOTE] = ACTIONS(2883),
    [anon_sym_AT_DQUOTE] = ACTIONS(2885),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2885),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2885),
    [sym_bool] = ACTIONS(2883),
    [sym_unit] = ACTIONS(2885),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2883),
    [sym_op_identifier] = ACTIONS(2883),
    [anon_sym_PLUS] = ACTIONS(2883),
    [anon_sym_DASH] = ACTIONS(2883),
    [anon_sym_PLUS_DOT] = ACTIONS(2883),
    [anon_sym_DASH_DOT] = ACTIONS(2883),
    [anon_sym_PERCENT] = ACTIONS(2883),
    [anon_sym_AMP_AMP] = ACTIONS(2883),
    [anon_sym_TILDE] = ACTIONS(2885),
    [aux_sym_prefix_op_token1] = ACTIONS(2883),
    [aux_sym_infix_op_token1] = ACTIONS(2885),
    [aux_sym_infix_op_token2] = ACTIONS(2883),
    [anon_sym_PIPE_PIPE] = ACTIONS(2883),
    [anon_sym_BANG_EQ] = ACTIONS(2883),
    [anon_sym_COLON_EQ] = ACTIONS(2885),
    [anon_sym_DOLLAR] = ACTIONS(2883),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2883),
    [sym_int] = ACTIONS(2883),
    [sym_xint] = ACTIONS(2885),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2885),
    [sym__newline] = ACTIONS(2885),
  },
  [1716] = {
    [sym_block_comment] = STATE(1716),
    [sym_compiler_directive_decl] = STATE(1716),
    [sym_fsi_directive_decl] = STATE(1716),
    [sym_preproc_line] = STATE(1716),
    [sym_identifier] = ACTIONS(2887),
    [anon_sym_EQ] = ACTIONS(2889),
    [anon_sym_COLON] = ACTIONS(2887),
    [anon_sym_return] = ACTIONS(2887),
    [anon_sym_do] = ACTIONS(2887),
    [anon_sym_let] = ACTIONS(2887),
    [anon_sym_let_BANG] = ACTIONS(2889),
    [anon_sym_as] = ACTIONS(2887),
    [anon_sym_LPAREN] = ACTIONS(2887),
    [anon_sym_COMMA] = ACTIONS(2889),
    [anon_sym_null] = ACTIONS(2887),
    [anon_sym_QMARK] = ACTIONS(2887),
    [anon_sym_COLON_QMARK] = ACTIONS(2887),
    [anon_sym_COLON_COLON] = ACTIONS(2889),
    [anon_sym_AMP] = ACTIONS(2887),
    [anon_sym_LBRACK] = ACTIONS(2887),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2889),
    [anon_sym_LBRACE] = ACTIONS(2887),
    [anon_sym_LT_AT] = ACTIONS(2887),
    [anon_sym_LT_AT_AT] = ACTIONS(2887),
    [anon_sym_DOT] = ACTIONS(2887),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2889),
    [anon_sym_new] = ACTIONS(2887),
    [anon_sym_with] = ACTIONS(2887),
    [anon_sym_return_BANG] = ACTIONS(2889),
    [anon_sym_yield] = ACTIONS(2887),
    [anon_sym_yield_BANG] = ACTIONS(2889),
    [anon_sym_lazy] = ACTIONS(2887),
    [anon_sym_assert] = ACTIONS(2887),
    [anon_sym_upcast] = ACTIONS(2887),
    [anon_sym_downcast] = ACTIONS(2887),
    [anon_sym_COLON_GT] = ACTIONS(2889),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2889),
    [anon_sym_for] = ACTIONS(2887),
    [anon_sym_while] = ACTIONS(2887),
    [anon_sym_if] = ACTIONS(2887),
    [anon_sym_fun] = ACTIONS(2887),
    [anon_sym_try] = ACTIONS(2887),
    [anon_sym_match] = ACTIONS(2887),
    [anon_sym_match_BANG] = ACTIONS(2889),
    [anon_sym_function] = ACTIONS(2887),
    [anon_sym_LT_DASH] = ACTIONS(2887),
    [anon_sym_DOT_LBRACK] = ACTIONS(2889),
    [anon_sym_LT] = ACTIONS(2889),
    [anon_sym_use] = ACTIONS(2887),
    [anon_sym_use_BANG] = ACTIONS(2889),
    [anon_sym_do_BANG] = ACTIONS(2889),
    [anon_sym_begin] = ACTIONS(2887),
    [anon_sym_LPAREN2] = ACTIONS(2887),
    [anon_sym_or] = ACTIONS(2887),
    [aux_sym_char_token1] = ACTIONS(2889),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2887),
    [anon_sym_DQUOTE] = ACTIONS(2887),
    [anon_sym_AT_DQUOTE] = ACTIONS(2889),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2889),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2889),
    [sym_bool] = ACTIONS(2887),
    [sym_unit] = ACTIONS(2889),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2887),
    [sym_op_identifier] = ACTIONS(2887),
    [anon_sym_PLUS] = ACTIONS(2887),
    [anon_sym_DASH] = ACTIONS(2887),
    [anon_sym_PLUS_DOT] = ACTIONS(2887),
    [anon_sym_DASH_DOT] = ACTIONS(2887),
    [anon_sym_PERCENT] = ACTIONS(2887),
    [anon_sym_AMP_AMP] = ACTIONS(2887),
    [anon_sym_TILDE] = ACTIONS(2889),
    [aux_sym_prefix_op_token1] = ACTIONS(2887),
    [aux_sym_infix_op_token1] = ACTIONS(2889),
    [aux_sym_infix_op_token2] = ACTIONS(2887),
    [anon_sym_PIPE_PIPE] = ACTIONS(2887),
    [anon_sym_BANG_EQ] = ACTIONS(2887),
    [anon_sym_COLON_EQ] = ACTIONS(2889),
    [anon_sym_DOLLAR] = ACTIONS(2887),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2887),
    [sym_int] = ACTIONS(2887),
    [sym_xint] = ACTIONS(2889),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2889),
    [sym__newline] = ACTIONS(2889),
  },
  [1717] = {
    [sym_block_comment] = STATE(1717),
    [sym_compiler_directive_decl] = STATE(1717),
    [sym_fsi_directive_decl] = STATE(1717),
    [sym_preproc_line] = STATE(1717),
    [sym_identifier] = ACTIONS(2891),
    [anon_sym_EQ] = ACTIONS(2893),
    [anon_sym_COLON] = ACTIONS(2891),
    [anon_sym_return] = ACTIONS(2891),
    [anon_sym_do] = ACTIONS(2891),
    [anon_sym_let] = ACTIONS(2891),
    [anon_sym_let_BANG] = ACTIONS(2893),
    [anon_sym_as] = ACTIONS(2891),
    [anon_sym_LPAREN] = ACTIONS(2891),
    [anon_sym_COMMA] = ACTIONS(2893),
    [anon_sym_null] = ACTIONS(2891),
    [anon_sym_QMARK] = ACTIONS(2891),
    [anon_sym_COLON_QMARK] = ACTIONS(2891),
    [anon_sym_COLON_COLON] = ACTIONS(2893),
    [anon_sym_AMP] = ACTIONS(2891),
    [anon_sym_LBRACK] = ACTIONS(2891),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2893),
    [anon_sym_LBRACE] = ACTIONS(2891),
    [anon_sym_LT_AT] = ACTIONS(2891),
    [anon_sym_LT_AT_AT] = ACTIONS(2891),
    [anon_sym_DOT] = ACTIONS(2891),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2893),
    [anon_sym_new] = ACTIONS(2891),
    [anon_sym_with] = ACTIONS(2891),
    [anon_sym_return_BANG] = ACTIONS(2893),
    [anon_sym_yield] = ACTIONS(2891),
    [anon_sym_yield_BANG] = ACTIONS(2893),
    [anon_sym_lazy] = ACTIONS(2891),
    [anon_sym_assert] = ACTIONS(2891),
    [anon_sym_upcast] = ACTIONS(2891),
    [anon_sym_downcast] = ACTIONS(2891),
    [anon_sym_COLON_GT] = ACTIONS(2893),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2893),
    [anon_sym_for] = ACTIONS(2891),
    [anon_sym_while] = ACTIONS(2891),
    [anon_sym_if] = ACTIONS(2891),
    [anon_sym_fun] = ACTIONS(2891),
    [anon_sym_try] = ACTIONS(2891),
    [anon_sym_match] = ACTIONS(2891),
    [anon_sym_match_BANG] = ACTIONS(2893),
    [anon_sym_function] = ACTIONS(2891),
    [anon_sym_LT_DASH] = ACTIONS(2891),
    [anon_sym_DOT_LBRACK] = ACTIONS(2893),
    [anon_sym_LT] = ACTIONS(2893),
    [anon_sym_use] = ACTIONS(2891),
    [anon_sym_use_BANG] = ACTIONS(2893),
    [anon_sym_do_BANG] = ACTIONS(2893),
    [anon_sym_begin] = ACTIONS(2891),
    [anon_sym_LPAREN2] = ACTIONS(2891),
    [anon_sym_or] = ACTIONS(2891),
    [aux_sym_char_token1] = ACTIONS(2893),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2891),
    [anon_sym_DQUOTE] = ACTIONS(2891),
    [anon_sym_AT_DQUOTE] = ACTIONS(2893),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2893),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2893),
    [sym_bool] = ACTIONS(2891),
    [sym_unit] = ACTIONS(2893),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2891),
    [sym_op_identifier] = ACTIONS(2891),
    [anon_sym_PLUS] = ACTIONS(2891),
    [anon_sym_DASH] = ACTIONS(2891),
    [anon_sym_PLUS_DOT] = ACTIONS(2891),
    [anon_sym_DASH_DOT] = ACTIONS(2891),
    [anon_sym_PERCENT] = ACTIONS(2891),
    [anon_sym_AMP_AMP] = ACTIONS(2891),
    [anon_sym_TILDE] = ACTIONS(2893),
    [aux_sym_prefix_op_token1] = ACTIONS(2891),
    [aux_sym_infix_op_token1] = ACTIONS(2893),
    [aux_sym_infix_op_token2] = ACTIONS(2891),
    [anon_sym_PIPE_PIPE] = ACTIONS(2891),
    [anon_sym_BANG_EQ] = ACTIONS(2891),
    [anon_sym_COLON_EQ] = ACTIONS(2893),
    [anon_sym_DOLLAR] = ACTIONS(2891),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2891),
    [sym_int] = ACTIONS(2891),
    [sym_xint] = ACTIONS(2893),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2893),
    [sym__newline] = ACTIONS(2893),
  },
  [1718] = {
    [sym_block_comment] = STATE(1718),
    [sym_compiler_directive_decl] = STATE(1718),
    [sym_fsi_directive_decl] = STATE(1718),
    [sym_preproc_line] = STATE(1718),
    [sym_identifier] = ACTIONS(2910),
    [anon_sym_EQ] = ACTIONS(2912),
    [anon_sym_COLON] = ACTIONS(2910),
    [anon_sym_return] = ACTIONS(2910),
    [anon_sym_do] = ACTIONS(2910),
    [anon_sym_let] = ACTIONS(2910),
    [anon_sym_let_BANG] = ACTIONS(2912),
    [anon_sym_as] = ACTIONS(2910),
    [anon_sym_LPAREN] = ACTIONS(2910),
    [anon_sym_COMMA] = ACTIONS(2912),
    [anon_sym_null] = ACTIONS(2910),
    [anon_sym_QMARK] = ACTIONS(2910),
    [anon_sym_COLON_QMARK] = ACTIONS(2910),
    [anon_sym_COLON_COLON] = ACTIONS(2912),
    [anon_sym_AMP] = ACTIONS(2910),
    [anon_sym_LBRACK] = ACTIONS(2910),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2912),
    [anon_sym_LBRACE] = ACTIONS(2910),
    [anon_sym_LT_AT] = ACTIONS(2910),
    [anon_sym_LT_AT_AT] = ACTIONS(2910),
    [anon_sym_DOT] = ACTIONS(2910),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2912),
    [anon_sym_new] = ACTIONS(2910),
    [anon_sym_with] = ACTIONS(2910),
    [anon_sym_return_BANG] = ACTIONS(2912),
    [anon_sym_yield] = ACTIONS(2910),
    [anon_sym_yield_BANG] = ACTIONS(2912),
    [anon_sym_lazy] = ACTIONS(2910),
    [anon_sym_assert] = ACTIONS(2910),
    [anon_sym_upcast] = ACTIONS(2910),
    [anon_sym_downcast] = ACTIONS(2910),
    [anon_sym_COLON_GT] = ACTIONS(2912),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2912),
    [anon_sym_for] = ACTIONS(2910),
    [anon_sym_while] = ACTIONS(2910),
    [anon_sym_if] = ACTIONS(2910),
    [anon_sym_fun] = ACTIONS(2910),
    [anon_sym_try] = ACTIONS(2910),
    [anon_sym_match] = ACTIONS(2910),
    [anon_sym_match_BANG] = ACTIONS(2912),
    [anon_sym_function] = ACTIONS(2910),
    [anon_sym_LT_DASH] = ACTIONS(2910),
    [anon_sym_DOT_LBRACK] = ACTIONS(2912),
    [anon_sym_LT] = ACTIONS(2912),
    [anon_sym_use] = ACTIONS(2910),
    [anon_sym_use_BANG] = ACTIONS(2912),
    [anon_sym_do_BANG] = ACTIONS(2912),
    [anon_sym_begin] = ACTIONS(2910),
    [anon_sym_LPAREN2] = ACTIONS(2910),
    [anon_sym_or] = ACTIONS(2910),
    [aux_sym_char_token1] = ACTIONS(2912),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2910),
    [anon_sym_DQUOTE] = ACTIONS(2910),
    [anon_sym_AT_DQUOTE] = ACTIONS(2912),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2912),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2912),
    [sym_bool] = ACTIONS(2910),
    [sym_unit] = ACTIONS(2912),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2910),
    [sym_op_identifier] = ACTIONS(2910),
    [anon_sym_PLUS] = ACTIONS(2910),
    [anon_sym_DASH] = ACTIONS(2910),
    [anon_sym_PLUS_DOT] = ACTIONS(2910),
    [anon_sym_DASH_DOT] = ACTIONS(2910),
    [anon_sym_PERCENT] = ACTIONS(2910),
    [anon_sym_AMP_AMP] = ACTIONS(2910),
    [anon_sym_TILDE] = ACTIONS(2912),
    [aux_sym_prefix_op_token1] = ACTIONS(2910),
    [aux_sym_infix_op_token1] = ACTIONS(2912),
    [aux_sym_infix_op_token2] = ACTIONS(2910),
    [anon_sym_PIPE_PIPE] = ACTIONS(2910),
    [anon_sym_BANG_EQ] = ACTIONS(2910),
    [anon_sym_COLON_EQ] = ACTIONS(2912),
    [anon_sym_DOLLAR] = ACTIONS(2910),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2910),
    [sym_int] = ACTIONS(2910),
    [sym_xint] = ACTIONS(2912),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2912),
    [sym__newline] = ACTIONS(2912),
  },
  [1719] = {
    [sym_block_comment] = STATE(1719),
    [sym_compiler_directive_decl] = STATE(1719),
    [sym_fsi_directive_decl] = STATE(1719),
    [sym_preproc_line] = STATE(1719),
    [sym_identifier] = ACTIONS(2914),
    [anon_sym_EQ] = ACTIONS(2916),
    [anon_sym_COLON] = ACTIONS(2914),
    [anon_sym_return] = ACTIONS(2914),
    [anon_sym_do] = ACTIONS(2914),
    [anon_sym_let] = ACTIONS(2914),
    [anon_sym_let_BANG] = ACTIONS(2916),
    [anon_sym_as] = ACTIONS(2914),
    [anon_sym_LPAREN] = ACTIONS(2914),
    [anon_sym_COMMA] = ACTIONS(2916),
    [anon_sym_null] = ACTIONS(2914),
    [anon_sym_QMARK] = ACTIONS(2914),
    [anon_sym_COLON_QMARK] = ACTIONS(2914),
    [anon_sym_COLON_COLON] = ACTIONS(2916),
    [anon_sym_AMP] = ACTIONS(2914),
    [anon_sym_LBRACK] = ACTIONS(2914),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2916),
    [anon_sym_LBRACE] = ACTIONS(2914),
    [anon_sym_LT_AT] = ACTIONS(2914),
    [anon_sym_LT_AT_AT] = ACTIONS(2914),
    [anon_sym_DOT] = ACTIONS(2914),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2916),
    [anon_sym_new] = ACTIONS(2914),
    [anon_sym_with] = ACTIONS(2914),
    [anon_sym_return_BANG] = ACTIONS(2916),
    [anon_sym_yield] = ACTIONS(2914),
    [anon_sym_yield_BANG] = ACTIONS(2916),
    [anon_sym_lazy] = ACTIONS(2914),
    [anon_sym_assert] = ACTIONS(2914),
    [anon_sym_upcast] = ACTIONS(2914),
    [anon_sym_downcast] = ACTIONS(2914),
    [anon_sym_COLON_GT] = ACTIONS(2916),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2916),
    [anon_sym_for] = ACTIONS(2914),
    [anon_sym_while] = ACTIONS(2914),
    [anon_sym_if] = ACTIONS(2914),
    [anon_sym_fun] = ACTIONS(2914),
    [anon_sym_try] = ACTIONS(2914),
    [anon_sym_match] = ACTIONS(2914),
    [anon_sym_match_BANG] = ACTIONS(2916),
    [anon_sym_function] = ACTIONS(2914),
    [anon_sym_LT_DASH] = ACTIONS(2914),
    [anon_sym_DOT_LBRACK] = ACTIONS(2916),
    [anon_sym_LT] = ACTIONS(2916),
    [anon_sym_use] = ACTIONS(2914),
    [anon_sym_use_BANG] = ACTIONS(2916),
    [anon_sym_do_BANG] = ACTIONS(2916),
    [anon_sym_begin] = ACTIONS(2914),
    [anon_sym_LPAREN2] = ACTIONS(2914),
    [anon_sym_or] = ACTIONS(2914),
    [aux_sym_char_token1] = ACTIONS(2916),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2914),
    [anon_sym_DQUOTE] = ACTIONS(2914),
    [anon_sym_AT_DQUOTE] = ACTIONS(2916),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2916),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2916),
    [sym_bool] = ACTIONS(2914),
    [sym_unit] = ACTIONS(2916),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2914),
    [sym_op_identifier] = ACTIONS(2914),
    [anon_sym_PLUS] = ACTIONS(2914),
    [anon_sym_DASH] = ACTIONS(2914),
    [anon_sym_PLUS_DOT] = ACTIONS(2914),
    [anon_sym_DASH_DOT] = ACTIONS(2914),
    [anon_sym_PERCENT] = ACTIONS(2914),
    [anon_sym_AMP_AMP] = ACTIONS(2914),
    [anon_sym_TILDE] = ACTIONS(2916),
    [aux_sym_prefix_op_token1] = ACTIONS(2914),
    [aux_sym_infix_op_token1] = ACTIONS(2916),
    [aux_sym_infix_op_token2] = ACTIONS(2914),
    [anon_sym_PIPE_PIPE] = ACTIONS(2914),
    [anon_sym_BANG_EQ] = ACTIONS(2914),
    [anon_sym_COLON_EQ] = ACTIONS(2916),
    [anon_sym_DOLLAR] = ACTIONS(2914),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2914),
    [sym_int] = ACTIONS(2914),
    [sym_xint] = ACTIONS(2916),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2916),
    [sym__newline] = ACTIONS(2916),
  },
  [1720] = {
    [sym_block_comment] = STATE(1720),
    [sym_compiler_directive_decl] = STATE(1720),
    [sym_fsi_directive_decl] = STATE(1720),
    [sym_preproc_line] = STATE(1720),
    [sym_identifier] = ACTIONS(2918),
    [anon_sym_EQ] = ACTIONS(2920),
    [anon_sym_COLON] = ACTIONS(2918),
    [anon_sym_return] = ACTIONS(2918),
    [anon_sym_do] = ACTIONS(2918),
    [anon_sym_let] = ACTIONS(2918),
    [anon_sym_let_BANG] = ACTIONS(2920),
    [anon_sym_as] = ACTIONS(2918),
    [anon_sym_LPAREN] = ACTIONS(2918),
    [anon_sym_COMMA] = ACTIONS(2920),
    [anon_sym_null] = ACTIONS(2918),
    [anon_sym_QMARK] = ACTIONS(2918),
    [anon_sym_COLON_QMARK] = ACTIONS(2918),
    [anon_sym_COLON_COLON] = ACTIONS(2920),
    [anon_sym_AMP] = ACTIONS(2918),
    [anon_sym_LBRACK] = ACTIONS(2918),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2920),
    [anon_sym_LBRACE] = ACTIONS(2918),
    [anon_sym_LT_AT] = ACTIONS(2918),
    [anon_sym_LT_AT_AT] = ACTIONS(2918),
    [anon_sym_DOT] = ACTIONS(2918),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2920),
    [anon_sym_new] = ACTIONS(2918),
    [anon_sym_with] = ACTIONS(2918),
    [anon_sym_return_BANG] = ACTIONS(2920),
    [anon_sym_yield] = ACTIONS(2918),
    [anon_sym_yield_BANG] = ACTIONS(2920),
    [anon_sym_lazy] = ACTIONS(2918),
    [anon_sym_assert] = ACTIONS(2918),
    [anon_sym_upcast] = ACTIONS(2918),
    [anon_sym_downcast] = ACTIONS(2918),
    [anon_sym_COLON_GT] = ACTIONS(2920),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2920),
    [anon_sym_for] = ACTIONS(2918),
    [anon_sym_while] = ACTIONS(2918),
    [anon_sym_if] = ACTIONS(2918),
    [anon_sym_fun] = ACTIONS(2918),
    [anon_sym_try] = ACTIONS(2918),
    [anon_sym_match] = ACTIONS(2918),
    [anon_sym_match_BANG] = ACTIONS(2920),
    [anon_sym_function] = ACTIONS(2918),
    [anon_sym_LT_DASH] = ACTIONS(2918),
    [anon_sym_DOT_LBRACK] = ACTIONS(2920),
    [anon_sym_LT] = ACTIONS(2920),
    [anon_sym_use] = ACTIONS(2918),
    [anon_sym_use_BANG] = ACTIONS(2920),
    [anon_sym_do_BANG] = ACTIONS(2920),
    [anon_sym_begin] = ACTIONS(2918),
    [anon_sym_LPAREN2] = ACTIONS(2918),
    [anon_sym_or] = ACTIONS(2918),
    [aux_sym_char_token1] = ACTIONS(2920),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2918),
    [anon_sym_DQUOTE] = ACTIONS(2918),
    [anon_sym_AT_DQUOTE] = ACTIONS(2920),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2920),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2920),
    [sym_bool] = ACTIONS(2918),
    [sym_unit] = ACTIONS(2920),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2918),
    [sym_op_identifier] = ACTIONS(2918),
    [anon_sym_PLUS] = ACTIONS(2918),
    [anon_sym_DASH] = ACTIONS(2918),
    [anon_sym_PLUS_DOT] = ACTIONS(2918),
    [anon_sym_DASH_DOT] = ACTIONS(2918),
    [anon_sym_PERCENT] = ACTIONS(2918),
    [anon_sym_AMP_AMP] = ACTIONS(2918),
    [anon_sym_TILDE] = ACTIONS(2920),
    [aux_sym_prefix_op_token1] = ACTIONS(2918),
    [aux_sym_infix_op_token1] = ACTIONS(2920),
    [aux_sym_infix_op_token2] = ACTIONS(2918),
    [anon_sym_PIPE_PIPE] = ACTIONS(2918),
    [anon_sym_BANG_EQ] = ACTIONS(2918),
    [anon_sym_COLON_EQ] = ACTIONS(2920),
    [anon_sym_DOLLAR] = ACTIONS(2918),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2918),
    [sym_int] = ACTIONS(2918),
    [sym_xint] = ACTIONS(2920),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2920),
    [sym__newline] = ACTIONS(2920),
  },
  [1721] = {
    [sym_attributes] = STATE(2698),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(3506),
    [sym__pattern] = STATE(1650),
    [sym_optional_pattern] = STATE(3506),
    [sym_type_check_pattern] = STATE(3506),
    [sym_attribute_pattern] = STATE(3506),
    [sym_paren_pattern] = STATE(3506),
    [sym_as_pattern] = STATE(3506),
    [sym_cons_pattern] = STATE(3506),
    [sym_disjunct_pattern] = STATE(3506),
    [sym_conjunct_pattern] = STATE(3506),
    [sym_typed_pattern] = STATE(3506),
    [sym_list_pattern] = STATE(3506),
    [sym_array_pattern] = STATE(3506),
    [sym_record_pattern] = STATE(3506),
    [sym_named_field_pattern] = STATE(3506),
    [sym_identifier_pattern] = STATE(3506),
    [sym_long_identifier_or_op] = STATE(1864),
    [sym_char] = STATE(3497),
    [sym_format_string] = STATE(3495),
    [sym__string_literal] = STATE(3495),
    [sym_string] = STATE(3497),
    [sym_verbatim_string] = STATE(3497),
    [sym_bytearray] = STATE(3497),
    [sym_verbatim_bytearray] = STATE(3497),
    [sym_format_triple_quoted_string] = STATE(3494),
    [sym_triple_quoted_string] = STATE(3497),
    [sym_const] = STATE(3506),
    [sym_long_identifier] = STATE(3363),
    [sym_active_pattern] = STATE(3521),
    [sym__identifier_or_op] = STATE(3510),
    [sym_sbyte] = STATE(3497),
    [sym_byte] = STATE(3497),
    [sym_int16] = STATE(3497),
    [sym_uint16] = STATE(3497),
    [sym_int32] = STATE(3497),
    [sym_uint32] = STATE(3497),
    [sym_nativeint] = STATE(3497),
    [sym_unativeint] = STATE(3497),
    [sym_int64] = STATE(3497),
    [sym_uint64] = STATE(3497),
    [sym_ieee32] = STATE(3497),
    [sym_ieee64] = STATE(3497),
    [sym_bignum] = STATE(3497),
    [sym_decimal] = STATE(3497),
    [sym_float] = STATE(3305),
    [sym_block_comment] = STATE(1721),
    [sym_compiler_directive_decl] = STATE(1721),
    [sym_fsi_directive_decl] = STATE(1721),
    [sym_preproc_line] = STATE(1721),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(3870),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_COLON] = ACTIONS(3960),
    [anon_sym_as] = ACTIONS(3960),
    [anon_sym_LPAREN] = ACTIONS(3962),
    [anon_sym_RPAREN] = ACTIONS(3964),
    [anon_sym_COMMA] = ACTIONS(3964),
    [anon_sym_null] = ACTIONS(3966),
    [anon_sym__] = ACTIONS(3968),
    [anon_sym_QMARK] = ACTIONS(3970),
    [anon_sym_COLON_QMARK] = ACTIONS(3972),
    [anon_sym_COLON_COLON] = ACTIONS(3964),
    [anon_sym_PIPE] = ACTIONS(3964),
    [anon_sym_AMP] = ACTIONS(3964),
    [anon_sym_LBRACK] = ACTIONS(3974),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3976),
    [anon_sym_LBRACE] = ACTIONS(3978),
    [anon_sym_RBRACE] = ACTIONS(3964),
    [aux_sym_char_token1] = ACTIONS(3980),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3982),
    [anon_sym_DQUOTE] = ACTIONS(3984),
    [anon_sym_AT_DQUOTE] = ACTIONS(3986),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3988),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3990),
    [sym_bool] = ACTIONS(3992),
    [sym_unit] = ACTIONS(3994),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3904),
    [sym_op_identifier] = ACTIONS(3906),
    [sym_int] = ACTIONS(3996),
    [sym_xint] = ACTIONS(3998),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [sym__newline] = ACTIONS(3964),
  },
  [1722] = {
    [sym_block_comment] = STATE(1722),
    [sym_compiler_directive_decl] = STATE(1722),
    [sym_fsi_directive_decl] = STATE(1722),
    [sym_preproc_line] = STATE(1722),
    [sym_identifier] = ACTIONS(2922),
    [anon_sym_EQ] = ACTIONS(2924),
    [anon_sym_COLON] = ACTIONS(2922),
    [anon_sym_return] = ACTIONS(2922),
    [anon_sym_do] = ACTIONS(2922),
    [anon_sym_let] = ACTIONS(2922),
    [anon_sym_let_BANG] = ACTIONS(2924),
    [anon_sym_as] = ACTIONS(2922),
    [anon_sym_LPAREN] = ACTIONS(2922),
    [anon_sym_COMMA] = ACTIONS(2924),
    [anon_sym_null] = ACTIONS(2922),
    [anon_sym_QMARK] = ACTIONS(2922),
    [anon_sym_COLON_QMARK] = ACTIONS(2922),
    [anon_sym_COLON_COLON] = ACTIONS(2924),
    [anon_sym_AMP] = ACTIONS(2922),
    [anon_sym_LBRACK] = ACTIONS(2922),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2924),
    [anon_sym_LBRACE] = ACTIONS(2922),
    [anon_sym_LT_AT] = ACTIONS(2922),
    [anon_sym_LT_AT_AT] = ACTIONS(2922),
    [anon_sym_DOT] = ACTIONS(2922),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2924),
    [anon_sym_new] = ACTIONS(2922),
    [anon_sym_with] = ACTIONS(2922),
    [anon_sym_return_BANG] = ACTIONS(2924),
    [anon_sym_yield] = ACTIONS(2922),
    [anon_sym_yield_BANG] = ACTIONS(2924),
    [anon_sym_lazy] = ACTIONS(2922),
    [anon_sym_assert] = ACTIONS(2922),
    [anon_sym_upcast] = ACTIONS(2922),
    [anon_sym_downcast] = ACTIONS(2922),
    [anon_sym_COLON_GT] = ACTIONS(2924),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2924),
    [anon_sym_for] = ACTIONS(2922),
    [anon_sym_while] = ACTIONS(2922),
    [anon_sym_if] = ACTIONS(2922),
    [anon_sym_fun] = ACTIONS(2922),
    [anon_sym_try] = ACTIONS(2922),
    [anon_sym_match] = ACTIONS(2922),
    [anon_sym_match_BANG] = ACTIONS(2924),
    [anon_sym_function] = ACTIONS(2922),
    [anon_sym_LT_DASH] = ACTIONS(2922),
    [anon_sym_DOT_LBRACK] = ACTIONS(2924),
    [anon_sym_LT] = ACTIONS(2924),
    [anon_sym_use] = ACTIONS(2922),
    [anon_sym_use_BANG] = ACTIONS(2924),
    [anon_sym_do_BANG] = ACTIONS(2924),
    [anon_sym_begin] = ACTIONS(2922),
    [anon_sym_LPAREN2] = ACTIONS(2922),
    [anon_sym_or] = ACTIONS(2922),
    [aux_sym_char_token1] = ACTIONS(2924),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2922),
    [anon_sym_DQUOTE] = ACTIONS(2922),
    [anon_sym_AT_DQUOTE] = ACTIONS(2924),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2924),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2924),
    [sym_bool] = ACTIONS(2922),
    [sym_unit] = ACTIONS(2924),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2922),
    [sym_op_identifier] = ACTIONS(2922),
    [anon_sym_PLUS] = ACTIONS(2922),
    [anon_sym_DASH] = ACTIONS(2922),
    [anon_sym_PLUS_DOT] = ACTIONS(2922),
    [anon_sym_DASH_DOT] = ACTIONS(2922),
    [anon_sym_PERCENT] = ACTIONS(2922),
    [anon_sym_AMP_AMP] = ACTIONS(2922),
    [anon_sym_TILDE] = ACTIONS(2924),
    [aux_sym_prefix_op_token1] = ACTIONS(2922),
    [aux_sym_infix_op_token1] = ACTIONS(2924),
    [aux_sym_infix_op_token2] = ACTIONS(2922),
    [anon_sym_PIPE_PIPE] = ACTIONS(2922),
    [anon_sym_BANG_EQ] = ACTIONS(2922),
    [anon_sym_COLON_EQ] = ACTIONS(2924),
    [anon_sym_DOLLAR] = ACTIONS(2922),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2922),
    [sym_int] = ACTIONS(2922),
    [sym_xint] = ACTIONS(2924),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2924),
    [sym__newline] = ACTIONS(2924),
  },
  [1723] = {
    [sym_block_comment] = STATE(1723),
    [sym_compiler_directive_decl] = STATE(1723),
    [sym_fsi_directive_decl] = STATE(1723),
    [sym_preproc_line] = STATE(1723),
    [sym_identifier] = ACTIONS(2926),
    [anon_sym_EQ] = ACTIONS(2928),
    [anon_sym_COLON] = ACTIONS(2926),
    [anon_sym_return] = ACTIONS(2926),
    [anon_sym_do] = ACTIONS(2926),
    [anon_sym_let] = ACTIONS(2926),
    [anon_sym_let_BANG] = ACTIONS(2928),
    [anon_sym_as] = ACTIONS(2926),
    [anon_sym_LPAREN] = ACTIONS(2926),
    [anon_sym_COMMA] = ACTIONS(2928),
    [anon_sym_null] = ACTIONS(2926),
    [anon_sym_QMARK] = ACTIONS(2926),
    [anon_sym_COLON_QMARK] = ACTIONS(2926),
    [anon_sym_COLON_COLON] = ACTIONS(2928),
    [anon_sym_AMP] = ACTIONS(2926),
    [anon_sym_LBRACK] = ACTIONS(2926),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2928),
    [anon_sym_LBRACE] = ACTIONS(2926),
    [anon_sym_LT_AT] = ACTIONS(2926),
    [anon_sym_LT_AT_AT] = ACTIONS(2926),
    [anon_sym_DOT] = ACTIONS(2926),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2928),
    [anon_sym_new] = ACTIONS(2926),
    [anon_sym_with] = ACTIONS(2926),
    [anon_sym_return_BANG] = ACTIONS(2928),
    [anon_sym_yield] = ACTIONS(2926),
    [anon_sym_yield_BANG] = ACTIONS(2928),
    [anon_sym_lazy] = ACTIONS(2926),
    [anon_sym_assert] = ACTIONS(2926),
    [anon_sym_upcast] = ACTIONS(2926),
    [anon_sym_downcast] = ACTIONS(2926),
    [anon_sym_COLON_GT] = ACTIONS(2928),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2928),
    [anon_sym_for] = ACTIONS(2926),
    [anon_sym_while] = ACTIONS(2926),
    [anon_sym_if] = ACTIONS(2926),
    [anon_sym_fun] = ACTIONS(2926),
    [anon_sym_try] = ACTIONS(2926),
    [anon_sym_match] = ACTIONS(2926),
    [anon_sym_match_BANG] = ACTIONS(2928),
    [anon_sym_function] = ACTIONS(2926),
    [anon_sym_LT_DASH] = ACTIONS(2926),
    [anon_sym_DOT_LBRACK] = ACTIONS(2928),
    [anon_sym_LT] = ACTIONS(2928),
    [anon_sym_use] = ACTIONS(2926),
    [anon_sym_use_BANG] = ACTIONS(2928),
    [anon_sym_do_BANG] = ACTIONS(2928),
    [anon_sym_begin] = ACTIONS(2926),
    [anon_sym_LPAREN2] = ACTIONS(2926),
    [anon_sym_or] = ACTIONS(2926),
    [aux_sym_char_token1] = ACTIONS(2928),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2926),
    [anon_sym_DQUOTE] = ACTIONS(2926),
    [anon_sym_AT_DQUOTE] = ACTIONS(2928),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2928),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2928),
    [sym_bool] = ACTIONS(2926),
    [sym_unit] = ACTIONS(2928),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2926),
    [sym_op_identifier] = ACTIONS(2926),
    [anon_sym_PLUS] = ACTIONS(2926),
    [anon_sym_DASH] = ACTIONS(2926),
    [anon_sym_PLUS_DOT] = ACTIONS(2926),
    [anon_sym_DASH_DOT] = ACTIONS(2926),
    [anon_sym_PERCENT] = ACTIONS(2926),
    [anon_sym_AMP_AMP] = ACTIONS(2926),
    [anon_sym_TILDE] = ACTIONS(2928),
    [aux_sym_prefix_op_token1] = ACTIONS(2926),
    [aux_sym_infix_op_token1] = ACTIONS(2928),
    [aux_sym_infix_op_token2] = ACTIONS(2926),
    [anon_sym_PIPE_PIPE] = ACTIONS(2926),
    [anon_sym_BANG_EQ] = ACTIONS(2926),
    [anon_sym_COLON_EQ] = ACTIONS(2928),
    [anon_sym_DOLLAR] = ACTIONS(2926),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2926),
    [sym_int] = ACTIONS(2926),
    [sym_xint] = ACTIONS(2928),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2928),
    [sym__newline] = ACTIONS(2928),
  },
  [1724] = {
    [sym_block_comment] = STATE(1724),
    [sym_compiler_directive_decl] = STATE(1724),
    [sym_fsi_directive_decl] = STATE(1724),
    [sym_preproc_line] = STATE(1724),
    [sym_identifier] = ACTIONS(2867),
    [anon_sym_EQ] = ACTIONS(2869),
    [anon_sym_COLON] = ACTIONS(2867),
    [anon_sym_return] = ACTIONS(2867),
    [anon_sym_do] = ACTIONS(2867),
    [anon_sym_let] = ACTIONS(2867),
    [anon_sym_let_BANG] = ACTIONS(2869),
    [anon_sym_LPAREN] = ACTIONS(2867),
    [anon_sym_COMMA] = ACTIONS(2869),
    [anon_sym_null] = ACTIONS(2867),
    [anon_sym_QMARK] = ACTIONS(2867),
    [anon_sym_COLON_QMARK] = ACTIONS(2867),
    [anon_sym_COLON_COLON] = ACTIONS(2869),
    [anon_sym_AMP] = ACTIONS(2867),
    [anon_sym_LBRACK] = ACTIONS(2867),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2869),
    [anon_sym_LBRACE] = ACTIONS(2867),
    [anon_sym_LT_AT] = ACTIONS(2867),
    [anon_sym_LT_AT_AT] = ACTIONS(2867),
    [anon_sym_DOT] = ACTIONS(2867),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2869),
    [anon_sym_new] = ACTIONS(2867),
    [anon_sym_return_BANG] = ACTIONS(2869),
    [anon_sym_yield] = ACTIONS(2867),
    [anon_sym_yield_BANG] = ACTIONS(2869),
    [anon_sym_lazy] = ACTIONS(2867),
    [anon_sym_assert] = ACTIONS(2867),
    [anon_sym_upcast] = ACTIONS(2867),
    [anon_sym_downcast] = ACTIONS(2867),
    [anon_sym_COLON_GT] = ACTIONS(2869),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2869),
    [anon_sym_for] = ACTIONS(2867),
    [anon_sym_while] = ACTIONS(2867),
    [anon_sym_if] = ACTIONS(2867),
    [anon_sym_fun] = ACTIONS(2867),
    [anon_sym_DASH_GT] = ACTIONS(2867),
    [anon_sym_try] = ACTIONS(2867),
    [anon_sym_match] = ACTIONS(2867),
    [anon_sym_match_BANG] = ACTIONS(2869),
    [anon_sym_function] = ACTIONS(2867),
    [anon_sym_LT_DASH] = ACTIONS(2867),
    [anon_sym_DOT_LBRACK] = ACTIONS(2869),
    [anon_sym_LT] = ACTIONS(2869),
    [anon_sym_use] = ACTIONS(2867),
    [anon_sym_use_BANG] = ACTIONS(2869),
    [anon_sym_do_BANG] = ACTIONS(2869),
    [anon_sym_DOT_DOT] = ACTIONS(2869),
    [anon_sym_begin] = ACTIONS(2867),
    [anon_sym_LPAREN2] = ACTIONS(2867),
    [anon_sym_or] = ACTIONS(2867),
    [aux_sym_char_token1] = ACTIONS(2869),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2867),
    [anon_sym_DQUOTE] = ACTIONS(2867),
    [anon_sym_AT_DQUOTE] = ACTIONS(2869),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2869),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2869),
    [sym_bool] = ACTIONS(2867),
    [sym_unit] = ACTIONS(2869),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2867),
    [sym_op_identifier] = ACTIONS(2867),
    [anon_sym_PLUS] = ACTIONS(2867),
    [anon_sym_DASH] = ACTIONS(2867),
    [anon_sym_PLUS_DOT] = ACTIONS(2867),
    [anon_sym_DASH_DOT] = ACTIONS(2867),
    [anon_sym_PERCENT] = ACTIONS(2867),
    [anon_sym_AMP_AMP] = ACTIONS(2867),
    [anon_sym_TILDE] = ACTIONS(2869),
    [aux_sym_prefix_op_token1] = ACTIONS(2867),
    [aux_sym_infix_op_token1] = ACTIONS(2869),
    [aux_sym_infix_op_token2] = ACTIONS(2867),
    [anon_sym_PIPE_PIPE] = ACTIONS(2867),
    [anon_sym_BANG_EQ] = ACTIONS(2867),
    [anon_sym_COLON_EQ] = ACTIONS(2869),
    [anon_sym_DOLLAR] = ACTIONS(2867),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2867),
    [sym_int] = ACTIONS(2867),
    [sym_xint] = ACTIONS(2869),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2869),
    [sym__newline] = ACTIONS(2869),
  },
  [1725] = {
    [sym_block_comment] = STATE(1725),
    [sym_compiler_directive_decl] = STATE(1725),
    [sym_fsi_directive_decl] = STATE(1725),
    [sym_preproc_line] = STATE(1725),
    [sym_identifier] = ACTIONS(2867),
    [anon_sym_EQ] = ACTIONS(2869),
    [anon_sym_COLON] = ACTIONS(2867),
    [anon_sym_return] = ACTIONS(2867),
    [anon_sym_do] = ACTIONS(2867),
    [anon_sym_let] = ACTIONS(2867),
    [anon_sym_let_BANG] = ACTIONS(2869),
    [anon_sym_LPAREN] = ACTIONS(2867),
    [anon_sym_COMMA] = ACTIONS(2869),
    [anon_sym_null] = ACTIONS(2867),
    [anon_sym_QMARK] = ACTIONS(2867),
    [anon_sym_COLON_QMARK] = ACTIONS(2867),
    [anon_sym_COLON_COLON] = ACTIONS(2869),
    [anon_sym_AMP] = ACTIONS(2867),
    [anon_sym_LBRACK] = ACTIONS(2867),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2869),
    [anon_sym_LBRACE] = ACTIONS(2867),
    [anon_sym_LT_AT] = ACTIONS(2867),
    [anon_sym_LT_AT_AT] = ACTIONS(2867),
    [anon_sym_DOT] = ACTIONS(4000),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2869),
    [anon_sym_new] = ACTIONS(2867),
    [anon_sym_return_BANG] = ACTIONS(2869),
    [anon_sym_yield] = ACTIONS(2867),
    [anon_sym_yield_BANG] = ACTIONS(2869),
    [anon_sym_lazy] = ACTIONS(2867),
    [anon_sym_assert] = ACTIONS(2867),
    [anon_sym_upcast] = ACTIONS(2867),
    [anon_sym_downcast] = ACTIONS(2867),
    [anon_sym_COLON_GT] = ACTIONS(2869),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2869),
    [anon_sym_for] = ACTIONS(2867),
    [anon_sym_while] = ACTIONS(2867),
    [anon_sym_if] = ACTIONS(2867),
    [anon_sym_fun] = ACTIONS(2867),
    [anon_sym_try] = ACTIONS(2867),
    [anon_sym_match] = ACTIONS(2867),
    [anon_sym_match_BANG] = ACTIONS(2869),
    [anon_sym_function] = ACTIONS(2867),
    [anon_sym_LT_DASH] = ACTIONS(2867),
    [anon_sym_DOT_LBRACK] = ACTIONS(2869),
    [anon_sym_LT] = ACTIONS(2869),
    [anon_sym_use] = ACTIONS(2867),
    [anon_sym_use_BANG] = ACTIONS(2869),
    [anon_sym_do_BANG] = ACTIONS(2869),
    [anon_sym_begin] = ACTIONS(2867),
    [anon_sym_LPAREN2] = ACTIONS(2867),
    [anon_sym_or] = ACTIONS(2867),
    [aux_sym_char_token1] = ACTIONS(2869),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2867),
    [anon_sym_DQUOTE] = ACTIONS(2867),
    [anon_sym_AT_DQUOTE] = ACTIONS(2869),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2869),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2869),
    [sym_bool] = ACTIONS(2867),
    [sym_unit] = ACTIONS(2869),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2867),
    [sym_op_identifier] = ACTIONS(2867),
    [anon_sym_PLUS] = ACTIONS(2867),
    [anon_sym_DASH] = ACTIONS(2867),
    [anon_sym_PLUS_DOT] = ACTIONS(2867),
    [anon_sym_DASH_DOT] = ACTIONS(2867),
    [anon_sym_PERCENT] = ACTIONS(2867),
    [anon_sym_AMP_AMP] = ACTIONS(2867),
    [anon_sym_TILDE] = ACTIONS(2869),
    [aux_sym_prefix_op_token1] = ACTIONS(2867),
    [aux_sym_infix_op_token1] = ACTIONS(2869),
    [aux_sym_infix_op_token2] = ACTIONS(2867),
    [anon_sym_PIPE_PIPE] = ACTIONS(2867),
    [anon_sym_BANG_EQ] = ACTIONS(2867),
    [anon_sym_COLON_EQ] = ACTIONS(2869),
    [anon_sym_DOLLAR] = ACTIONS(2867),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2867),
    [sym_int] = ACTIONS(2867),
    [sym_xint] = ACTIONS(2869),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2869),
    [anon_sym_POUNDendif] = ACTIONS(2869),
    [anon_sym_POUNDelse] = ACTIONS(2869),
    [sym__newline] = ACTIONS(2869),
  },
  [1726] = {
    [sym_block_comment] = STATE(1726),
    [sym_compiler_directive_decl] = STATE(1726),
    [sym_fsi_directive_decl] = STATE(1726),
    [sym_preproc_line] = STATE(1726),
    [sym_identifier] = ACTIONS(2863),
    [anon_sym_EQ] = ACTIONS(2865),
    [anon_sym_COLON] = ACTIONS(2863),
    [anon_sym_return] = ACTIONS(2863),
    [anon_sym_do] = ACTIONS(2863),
    [anon_sym_let] = ACTIONS(2863),
    [anon_sym_let_BANG] = ACTIONS(2865),
    [anon_sym_LPAREN] = ACTIONS(2863),
    [anon_sym_COMMA] = ACTIONS(2865),
    [anon_sym_null] = ACTIONS(2863),
    [anon_sym_QMARK] = ACTIONS(2863),
    [anon_sym_COLON_QMARK] = ACTIONS(2863),
    [anon_sym_COLON_COLON] = ACTIONS(2865),
    [anon_sym_AMP] = ACTIONS(2863),
    [anon_sym_LBRACK] = ACTIONS(2863),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2865),
    [anon_sym_LBRACE] = ACTIONS(2863),
    [anon_sym_LT_AT] = ACTIONS(2863),
    [anon_sym_LT_AT_AT] = ACTIONS(2863),
    [anon_sym_DOT] = ACTIONS(2863),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2865),
    [anon_sym_new] = ACTIONS(2863),
    [anon_sym_return_BANG] = ACTIONS(2865),
    [anon_sym_yield] = ACTIONS(2863),
    [anon_sym_yield_BANG] = ACTIONS(2865),
    [anon_sym_lazy] = ACTIONS(2863),
    [anon_sym_assert] = ACTIONS(2863),
    [anon_sym_upcast] = ACTIONS(2863),
    [anon_sym_downcast] = ACTIONS(2863),
    [anon_sym_COLON_GT] = ACTIONS(2865),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2865),
    [anon_sym_for] = ACTIONS(2863),
    [anon_sym_while] = ACTIONS(2863),
    [anon_sym_if] = ACTIONS(2863),
    [anon_sym_fun] = ACTIONS(2863),
    [anon_sym_try] = ACTIONS(2863),
    [anon_sym_match] = ACTIONS(2863),
    [anon_sym_match_BANG] = ACTIONS(2865),
    [anon_sym_function] = ACTIONS(2863),
    [anon_sym_LT_DASH] = ACTIONS(2863),
    [anon_sym_DOT_LBRACK] = ACTIONS(2865),
    [anon_sym_LT] = ACTIONS(2865),
    [anon_sym_use] = ACTIONS(2863),
    [anon_sym_use_BANG] = ACTIONS(2865),
    [anon_sym_do_BANG] = ACTIONS(2865),
    [anon_sym_begin] = ACTIONS(2863),
    [anon_sym_LPAREN2] = ACTIONS(2863),
    [anon_sym_or] = ACTIONS(2863),
    [aux_sym_char_token1] = ACTIONS(2865),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2863),
    [anon_sym_DQUOTE] = ACTIONS(2863),
    [anon_sym_AT_DQUOTE] = ACTIONS(2865),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2865),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2865),
    [sym_bool] = ACTIONS(2863),
    [sym_unit] = ACTIONS(2865),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2863),
    [sym_op_identifier] = ACTIONS(2863),
    [anon_sym_PLUS] = ACTIONS(2863),
    [anon_sym_DASH] = ACTIONS(2863),
    [anon_sym_PLUS_DOT] = ACTIONS(2863),
    [anon_sym_DASH_DOT] = ACTIONS(2863),
    [anon_sym_PERCENT] = ACTIONS(2863),
    [anon_sym_AMP_AMP] = ACTIONS(2863),
    [anon_sym_TILDE] = ACTIONS(2865),
    [aux_sym_prefix_op_token1] = ACTIONS(2863),
    [aux_sym_infix_op_token1] = ACTIONS(2865),
    [aux_sym_infix_op_token2] = ACTIONS(2863),
    [anon_sym_PIPE_PIPE] = ACTIONS(2863),
    [anon_sym_BANG_EQ] = ACTIONS(2863),
    [anon_sym_COLON_EQ] = ACTIONS(2865),
    [anon_sym_DOLLAR] = ACTIONS(2863),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2863),
    [sym_int] = ACTIONS(2863),
    [sym_xint] = ACTIONS(2865),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2865),
    [anon_sym_POUNDendif] = ACTIONS(2865),
    [anon_sym_POUNDelse] = ACTIONS(2865),
    [sym__newline] = ACTIONS(2865),
  },
  [1727] = {
    [sym_block_comment] = STATE(1727),
    [sym_compiler_directive_decl] = STATE(1727),
    [sym_fsi_directive_decl] = STATE(1727),
    [sym_preproc_line] = STATE(1727),
    [sym_identifier] = ACTIONS(2938),
    [anon_sym_EQ] = ACTIONS(2940),
    [anon_sym_COLON] = ACTIONS(2938),
    [anon_sym_return] = ACTIONS(2938),
    [anon_sym_do] = ACTIONS(2938),
    [anon_sym_let] = ACTIONS(2938),
    [anon_sym_let_BANG] = ACTIONS(2940),
    [anon_sym_as] = ACTIONS(2938),
    [anon_sym_LPAREN] = ACTIONS(2938),
    [anon_sym_COMMA] = ACTIONS(2940),
    [anon_sym_null] = ACTIONS(2938),
    [anon_sym_QMARK] = ACTIONS(2938),
    [anon_sym_COLON_QMARK] = ACTIONS(2938),
    [anon_sym_COLON_COLON] = ACTIONS(2940),
    [anon_sym_AMP] = ACTIONS(2938),
    [anon_sym_LBRACK] = ACTIONS(2938),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2940),
    [anon_sym_LBRACE] = ACTIONS(2938),
    [anon_sym_LT_AT] = ACTIONS(2938),
    [anon_sym_LT_AT_AT] = ACTIONS(2938),
    [anon_sym_DOT] = ACTIONS(2938),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2940),
    [anon_sym_new] = ACTIONS(2938),
    [anon_sym_with] = ACTIONS(2938),
    [anon_sym_return_BANG] = ACTIONS(2940),
    [anon_sym_yield] = ACTIONS(2938),
    [anon_sym_yield_BANG] = ACTIONS(2940),
    [anon_sym_lazy] = ACTIONS(2938),
    [anon_sym_assert] = ACTIONS(2938),
    [anon_sym_upcast] = ACTIONS(2938),
    [anon_sym_downcast] = ACTIONS(2938),
    [anon_sym_COLON_GT] = ACTIONS(2940),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2940),
    [anon_sym_for] = ACTIONS(2938),
    [anon_sym_while] = ACTIONS(2938),
    [anon_sym_if] = ACTIONS(2938),
    [anon_sym_fun] = ACTIONS(2938),
    [anon_sym_try] = ACTIONS(2938),
    [anon_sym_match] = ACTIONS(2938),
    [anon_sym_match_BANG] = ACTIONS(2940),
    [anon_sym_function] = ACTIONS(2938),
    [anon_sym_LT_DASH] = ACTIONS(2938),
    [anon_sym_DOT_LBRACK] = ACTIONS(2940),
    [anon_sym_LT] = ACTIONS(2940),
    [anon_sym_use] = ACTIONS(2938),
    [anon_sym_use_BANG] = ACTIONS(2940),
    [anon_sym_do_BANG] = ACTIONS(2940),
    [anon_sym_begin] = ACTIONS(2938),
    [anon_sym_LPAREN2] = ACTIONS(2938),
    [anon_sym_or] = ACTIONS(2938),
    [aux_sym_char_token1] = ACTIONS(2940),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2938),
    [anon_sym_DQUOTE] = ACTIONS(2938),
    [anon_sym_AT_DQUOTE] = ACTIONS(2940),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2940),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2940),
    [sym_bool] = ACTIONS(2938),
    [sym_unit] = ACTIONS(2940),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2938),
    [sym_op_identifier] = ACTIONS(2938),
    [anon_sym_PLUS] = ACTIONS(2938),
    [anon_sym_DASH] = ACTIONS(2938),
    [anon_sym_PLUS_DOT] = ACTIONS(2938),
    [anon_sym_DASH_DOT] = ACTIONS(2938),
    [anon_sym_PERCENT] = ACTIONS(2938),
    [anon_sym_AMP_AMP] = ACTIONS(2938),
    [anon_sym_TILDE] = ACTIONS(2940),
    [aux_sym_prefix_op_token1] = ACTIONS(2938),
    [aux_sym_infix_op_token1] = ACTIONS(2940),
    [aux_sym_infix_op_token2] = ACTIONS(2938),
    [anon_sym_PIPE_PIPE] = ACTIONS(2938),
    [anon_sym_BANG_EQ] = ACTIONS(2938),
    [anon_sym_COLON_EQ] = ACTIONS(2940),
    [anon_sym_DOLLAR] = ACTIONS(2938),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2938),
    [sym_int] = ACTIONS(2938),
    [sym_xint] = ACTIONS(2940),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2940),
    [sym__newline] = ACTIONS(2940),
  },
  [1728] = {
    [sym_block_comment] = STATE(1728),
    [sym_compiler_directive_decl] = STATE(1728),
    [sym_fsi_directive_decl] = STATE(1728),
    [sym_preproc_line] = STATE(1728),
    [sym_identifier] = ACTIONS(2946),
    [anon_sym_EQ] = ACTIONS(2948),
    [anon_sym_COLON] = ACTIONS(2946),
    [anon_sym_return] = ACTIONS(2946),
    [anon_sym_do] = ACTIONS(2946),
    [anon_sym_let] = ACTIONS(2946),
    [anon_sym_let_BANG] = ACTIONS(2948),
    [anon_sym_as] = ACTIONS(2946),
    [anon_sym_LPAREN] = ACTIONS(2946),
    [anon_sym_COMMA] = ACTIONS(2948),
    [anon_sym_null] = ACTIONS(2946),
    [anon_sym_QMARK] = ACTIONS(2946),
    [anon_sym_COLON_QMARK] = ACTIONS(2946),
    [anon_sym_COLON_COLON] = ACTIONS(2948),
    [anon_sym_AMP] = ACTIONS(2946),
    [anon_sym_LBRACK] = ACTIONS(2946),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2948),
    [anon_sym_LBRACE] = ACTIONS(2946),
    [anon_sym_LT_AT] = ACTIONS(2946),
    [anon_sym_LT_AT_AT] = ACTIONS(2946),
    [anon_sym_DOT] = ACTIONS(2946),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2948),
    [anon_sym_new] = ACTIONS(2946),
    [anon_sym_with] = ACTIONS(2946),
    [anon_sym_return_BANG] = ACTIONS(2948),
    [anon_sym_yield] = ACTIONS(2946),
    [anon_sym_yield_BANG] = ACTIONS(2948),
    [anon_sym_lazy] = ACTIONS(2946),
    [anon_sym_assert] = ACTIONS(2946),
    [anon_sym_upcast] = ACTIONS(2946),
    [anon_sym_downcast] = ACTIONS(2946),
    [anon_sym_COLON_GT] = ACTIONS(2948),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2948),
    [anon_sym_for] = ACTIONS(2946),
    [anon_sym_while] = ACTIONS(2946),
    [anon_sym_if] = ACTIONS(2946),
    [anon_sym_fun] = ACTIONS(2946),
    [anon_sym_try] = ACTIONS(2946),
    [anon_sym_match] = ACTIONS(2946),
    [anon_sym_match_BANG] = ACTIONS(2948),
    [anon_sym_function] = ACTIONS(2946),
    [anon_sym_LT_DASH] = ACTIONS(2946),
    [anon_sym_DOT_LBRACK] = ACTIONS(2948),
    [anon_sym_LT] = ACTIONS(2948),
    [anon_sym_use] = ACTIONS(2946),
    [anon_sym_use_BANG] = ACTIONS(2948),
    [anon_sym_do_BANG] = ACTIONS(2948),
    [anon_sym_begin] = ACTIONS(2946),
    [anon_sym_LPAREN2] = ACTIONS(2946),
    [anon_sym_or] = ACTIONS(2946),
    [aux_sym_char_token1] = ACTIONS(2948),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2946),
    [anon_sym_DQUOTE] = ACTIONS(2946),
    [anon_sym_AT_DQUOTE] = ACTIONS(2948),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2948),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2948),
    [sym_bool] = ACTIONS(2946),
    [sym_unit] = ACTIONS(2948),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2946),
    [sym_op_identifier] = ACTIONS(2946),
    [anon_sym_PLUS] = ACTIONS(2946),
    [anon_sym_DASH] = ACTIONS(2946),
    [anon_sym_PLUS_DOT] = ACTIONS(2946),
    [anon_sym_DASH_DOT] = ACTIONS(2946),
    [anon_sym_PERCENT] = ACTIONS(2946),
    [anon_sym_AMP_AMP] = ACTIONS(2946),
    [anon_sym_TILDE] = ACTIONS(2948),
    [aux_sym_prefix_op_token1] = ACTIONS(2946),
    [aux_sym_infix_op_token1] = ACTIONS(2948),
    [aux_sym_infix_op_token2] = ACTIONS(2946),
    [anon_sym_PIPE_PIPE] = ACTIONS(2946),
    [anon_sym_BANG_EQ] = ACTIONS(2946),
    [anon_sym_COLON_EQ] = ACTIONS(2948),
    [anon_sym_DOLLAR] = ACTIONS(2946),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2946),
    [sym_int] = ACTIONS(2946),
    [sym_xint] = ACTIONS(2948),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2948),
    [sym__newline] = ACTIONS(2948),
  },
  [1729] = {
    [sym_block_comment] = STATE(1729),
    [sym_compiler_directive_decl] = STATE(1729),
    [sym_fsi_directive_decl] = STATE(1729),
    [sym_preproc_line] = STATE(1729),
    [sym_identifier] = ACTIONS(2804),
    [anon_sym_EQ] = ACTIONS(2806),
    [anon_sym_COLON] = ACTIONS(2804),
    [anon_sym_return] = ACTIONS(2804),
    [anon_sym_do] = ACTIONS(2804),
    [anon_sym_let] = ACTIONS(2804),
    [anon_sym_let_BANG] = ACTIONS(2806),
    [anon_sym_LPAREN] = ACTIONS(2804),
    [anon_sym_COMMA] = ACTIONS(2806),
    [anon_sym_null] = ACTIONS(2804),
    [anon_sym_QMARK] = ACTIONS(2804),
    [anon_sym_COLON_QMARK] = ACTIONS(2804),
    [anon_sym_COLON_COLON] = ACTIONS(2806),
    [anon_sym_AMP] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2804),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(2804),
    [anon_sym_LT_AT] = ACTIONS(2804),
    [anon_sym_LT_AT_AT] = ACTIONS(2804),
    [anon_sym_DOT] = ACTIONS(2804),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2806),
    [anon_sym_new] = ACTIONS(2804),
    [anon_sym_return_BANG] = ACTIONS(2806),
    [anon_sym_yield] = ACTIONS(2804),
    [anon_sym_yield_BANG] = ACTIONS(2806),
    [anon_sym_lazy] = ACTIONS(2804),
    [anon_sym_assert] = ACTIONS(2804),
    [anon_sym_upcast] = ACTIONS(2804),
    [anon_sym_downcast] = ACTIONS(2804),
    [anon_sym_COLON_GT] = ACTIONS(2806),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2806),
    [anon_sym_for] = ACTIONS(2804),
    [anon_sym_done] = ACTIONS(4002),
    [anon_sym_while] = ACTIONS(2804),
    [anon_sym_if] = ACTIONS(2804),
    [anon_sym_fun] = ACTIONS(2804),
    [anon_sym_try] = ACTIONS(2804),
    [anon_sym_match] = ACTIONS(2804),
    [anon_sym_match_BANG] = ACTIONS(2806),
    [anon_sym_function] = ACTIONS(2804),
    [anon_sym_LT_DASH] = ACTIONS(2804),
    [anon_sym_DOT_LBRACK] = ACTIONS(2806),
    [anon_sym_LT] = ACTIONS(2806),
    [anon_sym_use] = ACTIONS(2804),
    [anon_sym_use_BANG] = ACTIONS(2806),
    [anon_sym_do_BANG] = ACTIONS(2806),
    [anon_sym_DOT_DOT] = ACTIONS(2806),
    [anon_sym_begin] = ACTIONS(2804),
    [anon_sym_LPAREN2] = ACTIONS(2804),
    [anon_sym_or] = ACTIONS(2804),
    [aux_sym_char_token1] = ACTIONS(2806),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2804),
    [anon_sym_DQUOTE] = ACTIONS(2804),
    [anon_sym_AT_DQUOTE] = ACTIONS(2806),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2806),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2806),
    [sym_bool] = ACTIONS(2804),
    [sym_unit] = ACTIONS(2806),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2804),
    [sym_op_identifier] = ACTIONS(2804),
    [anon_sym_PLUS] = ACTIONS(2804),
    [anon_sym_DASH] = ACTIONS(2804),
    [anon_sym_PLUS_DOT] = ACTIONS(2804),
    [anon_sym_DASH_DOT] = ACTIONS(2804),
    [anon_sym_PERCENT] = ACTIONS(2804),
    [anon_sym_AMP_AMP] = ACTIONS(2804),
    [anon_sym_TILDE] = ACTIONS(2806),
    [aux_sym_prefix_op_token1] = ACTIONS(2804),
    [aux_sym_infix_op_token1] = ACTIONS(2806),
    [aux_sym_infix_op_token2] = ACTIONS(2804),
    [anon_sym_PIPE_PIPE] = ACTIONS(2804),
    [anon_sym_BANG_EQ] = ACTIONS(2804),
    [anon_sym_COLON_EQ] = ACTIONS(2806),
    [anon_sym_DOLLAR] = ACTIONS(2804),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2804),
    [sym_int] = ACTIONS(2804),
    [sym_xint] = ACTIONS(2806),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2806),
    [sym__newline] = ACTIONS(2806),
  },
  [1730] = {
    [sym_block_comment] = STATE(1730),
    [sym_compiler_directive_decl] = STATE(1730),
    [sym_fsi_directive_decl] = STATE(1730),
    [sym_preproc_line] = STATE(1730),
    [sym_identifier] = ACTIONS(2783),
    [anon_sym_EQ] = ACTIONS(2785),
    [anon_sym_COLON] = ACTIONS(2783),
    [anon_sym_return] = ACTIONS(2783),
    [anon_sym_do] = ACTIONS(2783),
    [anon_sym_let] = ACTIONS(2783),
    [anon_sym_let_BANG] = ACTIONS(2785),
    [anon_sym_LPAREN] = ACTIONS(2783),
    [anon_sym_COMMA] = ACTIONS(2785),
    [anon_sym_null] = ACTIONS(2783),
    [anon_sym_QMARK] = ACTIONS(2783),
    [anon_sym_COLON_QMARK] = ACTIONS(2783),
    [anon_sym_COLON_COLON] = ACTIONS(2785),
    [anon_sym_AMP] = ACTIONS(2783),
    [anon_sym_LBRACK] = ACTIONS(2783),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2785),
    [anon_sym_LBRACE] = ACTIONS(2783),
    [anon_sym_LT_AT] = ACTIONS(2783),
    [anon_sym_LT_AT_AT] = ACTIONS(2783),
    [anon_sym_DOT] = ACTIONS(2783),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2785),
    [anon_sym_new] = ACTIONS(2783),
    [anon_sym_return_BANG] = ACTIONS(2785),
    [anon_sym_yield] = ACTIONS(2783),
    [anon_sym_yield_BANG] = ACTIONS(2785),
    [anon_sym_lazy] = ACTIONS(2783),
    [anon_sym_assert] = ACTIONS(2783),
    [anon_sym_upcast] = ACTIONS(2783),
    [anon_sym_downcast] = ACTIONS(2783),
    [anon_sym_COLON_GT] = ACTIONS(2785),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2785),
    [anon_sym_for] = ACTIONS(2783),
    [anon_sym_done] = ACTIONS(4004),
    [anon_sym_while] = ACTIONS(2783),
    [anon_sym_if] = ACTIONS(2783),
    [anon_sym_fun] = ACTIONS(2783),
    [anon_sym_try] = ACTIONS(2783),
    [anon_sym_match] = ACTIONS(2783),
    [anon_sym_match_BANG] = ACTIONS(2785),
    [anon_sym_function] = ACTIONS(2783),
    [anon_sym_LT_DASH] = ACTIONS(2783),
    [anon_sym_DOT_LBRACK] = ACTIONS(2785),
    [anon_sym_LT] = ACTIONS(2785),
    [anon_sym_use] = ACTIONS(2783),
    [anon_sym_use_BANG] = ACTIONS(2785),
    [anon_sym_do_BANG] = ACTIONS(2785),
    [anon_sym_DOT_DOT] = ACTIONS(2785),
    [anon_sym_begin] = ACTIONS(2783),
    [anon_sym_LPAREN2] = ACTIONS(2783),
    [anon_sym_or] = ACTIONS(2783),
    [aux_sym_char_token1] = ACTIONS(2785),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2783),
    [anon_sym_DQUOTE] = ACTIONS(2783),
    [anon_sym_AT_DQUOTE] = ACTIONS(2785),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2785),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2785),
    [sym_bool] = ACTIONS(2783),
    [sym_unit] = ACTIONS(2785),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2783),
    [sym_op_identifier] = ACTIONS(2783),
    [anon_sym_PLUS] = ACTIONS(2783),
    [anon_sym_DASH] = ACTIONS(2783),
    [anon_sym_PLUS_DOT] = ACTIONS(2783),
    [anon_sym_DASH_DOT] = ACTIONS(2783),
    [anon_sym_PERCENT] = ACTIONS(2783),
    [anon_sym_AMP_AMP] = ACTIONS(2783),
    [anon_sym_TILDE] = ACTIONS(2785),
    [aux_sym_prefix_op_token1] = ACTIONS(2783),
    [aux_sym_infix_op_token1] = ACTIONS(2785),
    [aux_sym_infix_op_token2] = ACTIONS(2783),
    [anon_sym_PIPE_PIPE] = ACTIONS(2783),
    [anon_sym_BANG_EQ] = ACTIONS(2783),
    [anon_sym_COLON_EQ] = ACTIONS(2785),
    [anon_sym_DOLLAR] = ACTIONS(2783),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2783),
    [sym_int] = ACTIONS(2783),
    [sym_xint] = ACTIONS(2785),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2785),
    [sym__newline] = ACTIONS(2785),
  },
  [1731] = {
    [sym_block_comment] = STATE(1731),
    [sym_compiler_directive_decl] = STATE(1731),
    [sym_fsi_directive_decl] = STATE(1731),
    [sym_preproc_line] = STATE(1731),
    [sym_identifier] = ACTIONS(3011),
    [anon_sym_EQ] = ACTIONS(3013),
    [anon_sym_COLON] = ACTIONS(3011),
    [anon_sym_return] = ACTIONS(3011),
    [anon_sym_do] = ACTIONS(3011),
    [anon_sym_let] = ACTIONS(3011),
    [anon_sym_let_BANG] = ACTIONS(3013),
    [anon_sym_as] = ACTIONS(3011),
    [anon_sym_LPAREN] = ACTIONS(3011),
    [anon_sym_COMMA] = ACTIONS(3013),
    [anon_sym_null] = ACTIONS(3011),
    [anon_sym_QMARK] = ACTIONS(3011),
    [anon_sym_COLON_QMARK] = ACTIONS(3011),
    [anon_sym_COLON_COLON] = ACTIONS(3013),
    [anon_sym_AMP] = ACTIONS(3011),
    [anon_sym_LBRACK] = ACTIONS(3011),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3013),
    [anon_sym_LBRACE] = ACTIONS(3011),
    [anon_sym_LT_AT] = ACTIONS(3011),
    [anon_sym_LT_AT_AT] = ACTIONS(3011),
    [anon_sym_DOT] = ACTIONS(3011),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3013),
    [anon_sym_new] = ACTIONS(3011),
    [anon_sym_with] = ACTIONS(3011),
    [anon_sym_return_BANG] = ACTIONS(3013),
    [anon_sym_yield] = ACTIONS(3011),
    [anon_sym_yield_BANG] = ACTIONS(3013),
    [anon_sym_lazy] = ACTIONS(3011),
    [anon_sym_assert] = ACTIONS(3011),
    [anon_sym_upcast] = ACTIONS(3011),
    [anon_sym_downcast] = ACTIONS(3011),
    [anon_sym_COLON_GT] = ACTIONS(3013),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3013),
    [anon_sym_for] = ACTIONS(3011),
    [anon_sym_while] = ACTIONS(3011),
    [anon_sym_if] = ACTIONS(3011),
    [anon_sym_fun] = ACTIONS(3011),
    [anon_sym_try] = ACTIONS(3011),
    [anon_sym_match] = ACTIONS(3011),
    [anon_sym_match_BANG] = ACTIONS(3013),
    [anon_sym_function] = ACTIONS(3011),
    [anon_sym_LT_DASH] = ACTIONS(3011),
    [anon_sym_DOT_LBRACK] = ACTIONS(3013),
    [anon_sym_LT] = ACTIONS(3013),
    [anon_sym_use] = ACTIONS(3011),
    [anon_sym_use_BANG] = ACTIONS(3013),
    [anon_sym_do_BANG] = ACTIONS(3013),
    [anon_sym_begin] = ACTIONS(3011),
    [anon_sym_LPAREN2] = ACTIONS(3011),
    [anon_sym_or] = ACTIONS(3011),
    [aux_sym_char_token1] = ACTIONS(3013),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3011),
    [anon_sym_DQUOTE] = ACTIONS(3011),
    [anon_sym_AT_DQUOTE] = ACTIONS(3013),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3013),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3013),
    [sym_bool] = ACTIONS(3011),
    [sym_unit] = ACTIONS(3013),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3011),
    [sym_op_identifier] = ACTIONS(3011),
    [anon_sym_PLUS] = ACTIONS(3011),
    [anon_sym_DASH] = ACTIONS(3011),
    [anon_sym_PLUS_DOT] = ACTIONS(3011),
    [anon_sym_DASH_DOT] = ACTIONS(3011),
    [anon_sym_PERCENT] = ACTIONS(3011),
    [anon_sym_AMP_AMP] = ACTIONS(3011),
    [anon_sym_TILDE] = ACTIONS(3013),
    [aux_sym_prefix_op_token1] = ACTIONS(3011),
    [aux_sym_infix_op_token1] = ACTIONS(3013),
    [aux_sym_infix_op_token2] = ACTIONS(3011),
    [anon_sym_PIPE_PIPE] = ACTIONS(3011),
    [anon_sym_BANG_EQ] = ACTIONS(3011),
    [anon_sym_COLON_EQ] = ACTIONS(3013),
    [anon_sym_DOLLAR] = ACTIONS(3011),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3011),
    [sym_int] = ACTIONS(3011),
    [sym_xint] = ACTIONS(3013),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3013),
    [sym__newline] = ACTIONS(3013),
  },
  [1732] = {
    [sym_block_comment] = STATE(1732),
    [sym_compiler_directive_decl] = STATE(1732),
    [sym_fsi_directive_decl] = STATE(1732),
    [sym_preproc_line] = STATE(1732),
    [sym_identifier] = ACTIONS(2950),
    [anon_sym_EQ] = ACTIONS(2952),
    [anon_sym_COLON] = ACTIONS(2950),
    [anon_sym_return] = ACTIONS(2950),
    [anon_sym_do] = ACTIONS(2950),
    [anon_sym_let] = ACTIONS(2950),
    [anon_sym_let_BANG] = ACTIONS(2952),
    [anon_sym_as] = ACTIONS(2950),
    [anon_sym_LPAREN] = ACTIONS(2950),
    [anon_sym_COMMA] = ACTIONS(2952),
    [anon_sym_null] = ACTIONS(2950),
    [anon_sym_QMARK] = ACTIONS(2950),
    [anon_sym_COLON_QMARK] = ACTIONS(2950),
    [anon_sym_COLON_COLON] = ACTIONS(2952),
    [anon_sym_AMP] = ACTIONS(2950),
    [anon_sym_LBRACK] = ACTIONS(2950),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2952),
    [anon_sym_LBRACE] = ACTIONS(2950),
    [anon_sym_LT_AT] = ACTIONS(2950),
    [anon_sym_LT_AT_AT] = ACTIONS(2950),
    [anon_sym_DOT] = ACTIONS(2950),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2952),
    [anon_sym_new] = ACTIONS(2950),
    [anon_sym_with] = ACTIONS(2950),
    [anon_sym_return_BANG] = ACTIONS(2952),
    [anon_sym_yield] = ACTIONS(2950),
    [anon_sym_yield_BANG] = ACTIONS(2952),
    [anon_sym_lazy] = ACTIONS(2950),
    [anon_sym_assert] = ACTIONS(2950),
    [anon_sym_upcast] = ACTIONS(2950),
    [anon_sym_downcast] = ACTIONS(2950),
    [anon_sym_COLON_GT] = ACTIONS(2952),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2952),
    [anon_sym_for] = ACTIONS(2950),
    [anon_sym_while] = ACTIONS(2950),
    [anon_sym_if] = ACTIONS(2950),
    [anon_sym_fun] = ACTIONS(2950),
    [anon_sym_try] = ACTIONS(2950),
    [anon_sym_match] = ACTIONS(2950),
    [anon_sym_match_BANG] = ACTIONS(2952),
    [anon_sym_function] = ACTIONS(2950),
    [anon_sym_LT_DASH] = ACTIONS(2950),
    [anon_sym_DOT_LBRACK] = ACTIONS(2952),
    [anon_sym_LT] = ACTIONS(2952),
    [anon_sym_use] = ACTIONS(2950),
    [anon_sym_use_BANG] = ACTIONS(2952),
    [anon_sym_do_BANG] = ACTIONS(2952),
    [anon_sym_begin] = ACTIONS(2950),
    [anon_sym_LPAREN2] = ACTIONS(2950),
    [anon_sym_or] = ACTIONS(2950),
    [aux_sym_char_token1] = ACTIONS(2952),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2950),
    [anon_sym_DQUOTE] = ACTIONS(2950),
    [anon_sym_AT_DQUOTE] = ACTIONS(2952),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2952),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2952),
    [sym_bool] = ACTIONS(2950),
    [sym_unit] = ACTIONS(2952),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2950),
    [sym_op_identifier] = ACTIONS(2950),
    [anon_sym_PLUS] = ACTIONS(2950),
    [anon_sym_DASH] = ACTIONS(2950),
    [anon_sym_PLUS_DOT] = ACTIONS(2950),
    [anon_sym_DASH_DOT] = ACTIONS(2950),
    [anon_sym_PERCENT] = ACTIONS(2950),
    [anon_sym_AMP_AMP] = ACTIONS(2950),
    [anon_sym_TILDE] = ACTIONS(2952),
    [aux_sym_prefix_op_token1] = ACTIONS(2950),
    [aux_sym_infix_op_token1] = ACTIONS(2952),
    [aux_sym_infix_op_token2] = ACTIONS(2950),
    [anon_sym_PIPE_PIPE] = ACTIONS(2950),
    [anon_sym_BANG_EQ] = ACTIONS(2950),
    [anon_sym_COLON_EQ] = ACTIONS(2952),
    [anon_sym_DOLLAR] = ACTIONS(2950),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2950),
    [sym_int] = ACTIONS(2950),
    [sym_xint] = ACTIONS(2952),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2952),
    [sym__newline] = ACTIONS(2952),
  },
  [1733] = {
    [sym_block_comment] = STATE(1733),
    [sym_compiler_directive_decl] = STATE(1733),
    [sym_fsi_directive_decl] = STATE(1733),
    [sym_preproc_line] = STATE(1733),
    [sym_identifier] = ACTIONS(2988),
    [anon_sym_EQ] = ACTIONS(2990),
    [anon_sym_COLON] = ACTIONS(2988),
    [anon_sym_return] = ACTIONS(2988),
    [anon_sym_do] = ACTIONS(2988),
    [anon_sym_let] = ACTIONS(2988),
    [anon_sym_let_BANG] = ACTIONS(2990),
    [anon_sym_as] = ACTIONS(2988),
    [anon_sym_LPAREN] = ACTIONS(2988),
    [anon_sym_COMMA] = ACTIONS(2990),
    [anon_sym_null] = ACTIONS(2988),
    [anon_sym_QMARK] = ACTIONS(2988),
    [anon_sym_COLON_QMARK] = ACTIONS(2988),
    [anon_sym_COLON_COLON] = ACTIONS(2990),
    [anon_sym_AMP] = ACTIONS(2988),
    [anon_sym_LBRACK] = ACTIONS(2988),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2990),
    [anon_sym_LBRACE] = ACTIONS(2988),
    [anon_sym_LT_AT] = ACTIONS(2988),
    [anon_sym_LT_AT_AT] = ACTIONS(2988),
    [anon_sym_DOT] = ACTIONS(2988),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2990),
    [anon_sym_new] = ACTIONS(2988),
    [anon_sym_with] = ACTIONS(2988),
    [anon_sym_return_BANG] = ACTIONS(2990),
    [anon_sym_yield] = ACTIONS(2988),
    [anon_sym_yield_BANG] = ACTIONS(2990),
    [anon_sym_lazy] = ACTIONS(2988),
    [anon_sym_assert] = ACTIONS(2988),
    [anon_sym_upcast] = ACTIONS(2988),
    [anon_sym_downcast] = ACTIONS(2988),
    [anon_sym_COLON_GT] = ACTIONS(2990),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2990),
    [anon_sym_for] = ACTIONS(2988),
    [anon_sym_while] = ACTIONS(2988),
    [anon_sym_if] = ACTIONS(2988),
    [anon_sym_fun] = ACTIONS(2988),
    [anon_sym_try] = ACTIONS(2988),
    [anon_sym_match] = ACTIONS(2988),
    [anon_sym_match_BANG] = ACTIONS(2990),
    [anon_sym_function] = ACTIONS(2988),
    [anon_sym_LT_DASH] = ACTIONS(2988),
    [anon_sym_DOT_LBRACK] = ACTIONS(2990),
    [anon_sym_LT] = ACTIONS(2990),
    [anon_sym_use] = ACTIONS(2988),
    [anon_sym_use_BANG] = ACTIONS(2990),
    [anon_sym_do_BANG] = ACTIONS(2990),
    [anon_sym_begin] = ACTIONS(2988),
    [anon_sym_LPAREN2] = ACTIONS(2988),
    [anon_sym_or] = ACTIONS(2988),
    [aux_sym_char_token1] = ACTIONS(2990),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2988),
    [anon_sym_DQUOTE] = ACTIONS(2988),
    [anon_sym_AT_DQUOTE] = ACTIONS(2990),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2990),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2990),
    [sym_bool] = ACTIONS(2988),
    [sym_unit] = ACTIONS(2990),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2988),
    [sym_op_identifier] = ACTIONS(2988),
    [anon_sym_PLUS] = ACTIONS(2988),
    [anon_sym_DASH] = ACTIONS(2988),
    [anon_sym_PLUS_DOT] = ACTIONS(2988),
    [anon_sym_DASH_DOT] = ACTIONS(2988),
    [anon_sym_PERCENT] = ACTIONS(2988),
    [anon_sym_AMP_AMP] = ACTIONS(2988),
    [anon_sym_TILDE] = ACTIONS(2990),
    [aux_sym_prefix_op_token1] = ACTIONS(2988),
    [aux_sym_infix_op_token1] = ACTIONS(2990),
    [aux_sym_infix_op_token2] = ACTIONS(2988),
    [anon_sym_PIPE_PIPE] = ACTIONS(2988),
    [anon_sym_BANG_EQ] = ACTIONS(2988),
    [anon_sym_COLON_EQ] = ACTIONS(2990),
    [anon_sym_DOLLAR] = ACTIONS(2988),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2988),
    [sym_int] = ACTIONS(2988),
    [sym_xint] = ACTIONS(2990),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2990),
    [sym__newline] = ACTIONS(2990),
  },
  [1734] = {
    [sym_block_comment] = STATE(1734),
    [sym_compiler_directive_decl] = STATE(1734),
    [sym_fsi_directive_decl] = STATE(1734),
    [sym_preproc_line] = STATE(1734),
    [sym_identifier] = ACTIONS(2770),
    [anon_sym_EQ] = ACTIONS(2772),
    [anon_sym_COLON] = ACTIONS(2770),
    [anon_sym_return] = ACTIONS(2770),
    [anon_sym_do] = ACTIONS(2770),
    [anon_sym_let] = ACTIONS(2770),
    [anon_sym_let_BANG] = ACTIONS(2772),
    [anon_sym_LPAREN] = ACTIONS(2770),
    [anon_sym_COMMA] = ACTIONS(2772),
    [anon_sym_null] = ACTIONS(2770),
    [anon_sym_QMARK] = ACTIONS(2770),
    [anon_sym_COLON_QMARK] = ACTIONS(2770),
    [anon_sym_COLON_COLON] = ACTIONS(2772),
    [anon_sym_AMP] = ACTIONS(2770),
    [anon_sym_LBRACK] = ACTIONS(2770),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2772),
    [anon_sym_LBRACE] = ACTIONS(2770),
    [anon_sym_LT_AT] = ACTIONS(2770),
    [anon_sym_LT_AT_AT] = ACTIONS(2770),
    [anon_sym_DOT] = ACTIONS(2770),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2772),
    [anon_sym_new] = ACTIONS(2770),
    [anon_sym_return_BANG] = ACTIONS(2772),
    [anon_sym_yield] = ACTIONS(2770),
    [anon_sym_yield_BANG] = ACTIONS(2772),
    [anon_sym_lazy] = ACTIONS(2770),
    [anon_sym_assert] = ACTIONS(2770),
    [anon_sym_upcast] = ACTIONS(2770),
    [anon_sym_downcast] = ACTIONS(2770),
    [anon_sym_COLON_GT] = ACTIONS(2772),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2772),
    [anon_sym_for] = ACTIONS(2770),
    [anon_sym_done] = ACTIONS(4006),
    [anon_sym_while] = ACTIONS(2770),
    [anon_sym_if] = ACTIONS(2770),
    [anon_sym_fun] = ACTIONS(2770),
    [anon_sym_try] = ACTIONS(2770),
    [anon_sym_match] = ACTIONS(2770),
    [anon_sym_match_BANG] = ACTIONS(2772),
    [anon_sym_function] = ACTIONS(2770),
    [anon_sym_LT_DASH] = ACTIONS(2770),
    [anon_sym_DOT_LBRACK] = ACTIONS(2772),
    [anon_sym_LT] = ACTIONS(2772),
    [anon_sym_use] = ACTIONS(2770),
    [anon_sym_use_BANG] = ACTIONS(2772),
    [anon_sym_do_BANG] = ACTIONS(2772),
    [anon_sym_DOT_DOT] = ACTIONS(2772),
    [anon_sym_begin] = ACTIONS(2770),
    [anon_sym_LPAREN2] = ACTIONS(2770),
    [anon_sym_or] = ACTIONS(2770),
    [aux_sym_char_token1] = ACTIONS(2772),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2770),
    [anon_sym_DQUOTE] = ACTIONS(2770),
    [anon_sym_AT_DQUOTE] = ACTIONS(2772),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2772),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2772),
    [sym_bool] = ACTIONS(2770),
    [sym_unit] = ACTIONS(2772),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2770),
    [sym_op_identifier] = ACTIONS(2770),
    [anon_sym_PLUS] = ACTIONS(2770),
    [anon_sym_DASH] = ACTIONS(2770),
    [anon_sym_PLUS_DOT] = ACTIONS(2770),
    [anon_sym_DASH_DOT] = ACTIONS(2770),
    [anon_sym_PERCENT] = ACTIONS(2770),
    [anon_sym_AMP_AMP] = ACTIONS(2770),
    [anon_sym_TILDE] = ACTIONS(2772),
    [aux_sym_prefix_op_token1] = ACTIONS(2770),
    [aux_sym_infix_op_token1] = ACTIONS(2772),
    [aux_sym_infix_op_token2] = ACTIONS(2770),
    [anon_sym_PIPE_PIPE] = ACTIONS(2770),
    [anon_sym_BANG_EQ] = ACTIONS(2770),
    [anon_sym_COLON_EQ] = ACTIONS(2772),
    [anon_sym_DOLLAR] = ACTIONS(2770),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2770),
    [sym_int] = ACTIONS(2770),
    [sym_xint] = ACTIONS(2772),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2772),
    [sym__newline] = ACTIONS(2772),
  },
  [1735] = {
    [sym_block_comment] = STATE(1735),
    [sym_compiler_directive_decl] = STATE(1735),
    [sym_fsi_directive_decl] = STATE(1735),
    [sym_preproc_line] = STATE(1735),
    [sym_identifier] = ACTIONS(2970),
    [anon_sym_EQ] = ACTIONS(2972),
    [anon_sym_COLON] = ACTIONS(2970),
    [anon_sym_return] = ACTIONS(2970),
    [anon_sym_do] = ACTIONS(2970),
    [anon_sym_let] = ACTIONS(2970),
    [anon_sym_let_BANG] = ACTIONS(2972),
    [anon_sym_as] = ACTIONS(2970),
    [anon_sym_LPAREN] = ACTIONS(2970),
    [anon_sym_COMMA] = ACTIONS(2972),
    [anon_sym_null] = ACTIONS(2970),
    [anon_sym_QMARK] = ACTIONS(2970),
    [anon_sym_COLON_QMARK] = ACTIONS(2970),
    [anon_sym_COLON_COLON] = ACTIONS(2972),
    [anon_sym_AMP] = ACTIONS(2970),
    [anon_sym_LBRACK] = ACTIONS(2970),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2972),
    [anon_sym_LBRACE] = ACTIONS(2970),
    [anon_sym_LT_AT] = ACTIONS(2970),
    [anon_sym_LT_AT_AT] = ACTIONS(2970),
    [anon_sym_DOT] = ACTIONS(2970),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2972),
    [anon_sym_new] = ACTIONS(2970),
    [anon_sym_with] = ACTIONS(2970),
    [anon_sym_return_BANG] = ACTIONS(2972),
    [anon_sym_yield] = ACTIONS(2970),
    [anon_sym_yield_BANG] = ACTIONS(2972),
    [anon_sym_lazy] = ACTIONS(2970),
    [anon_sym_assert] = ACTIONS(2970),
    [anon_sym_upcast] = ACTIONS(2970),
    [anon_sym_downcast] = ACTIONS(2970),
    [anon_sym_COLON_GT] = ACTIONS(2972),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2972),
    [anon_sym_for] = ACTIONS(2970),
    [anon_sym_while] = ACTIONS(2970),
    [anon_sym_if] = ACTIONS(2970),
    [anon_sym_fun] = ACTIONS(2970),
    [anon_sym_try] = ACTIONS(2970),
    [anon_sym_match] = ACTIONS(2970),
    [anon_sym_match_BANG] = ACTIONS(2972),
    [anon_sym_function] = ACTIONS(2970),
    [anon_sym_LT_DASH] = ACTIONS(2970),
    [anon_sym_DOT_LBRACK] = ACTIONS(2972),
    [anon_sym_LT] = ACTIONS(2972),
    [anon_sym_use] = ACTIONS(2970),
    [anon_sym_use_BANG] = ACTIONS(2972),
    [anon_sym_do_BANG] = ACTIONS(2972),
    [anon_sym_begin] = ACTIONS(2970),
    [anon_sym_LPAREN2] = ACTIONS(2970),
    [anon_sym_or] = ACTIONS(2970),
    [aux_sym_char_token1] = ACTIONS(2972),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2970),
    [anon_sym_DQUOTE] = ACTIONS(2970),
    [anon_sym_AT_DQUOTE] = ACTIONS(2972),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2972),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2972),
    [sym_bool] = ACTIONS(2970),
    [sym_unit] = ACTIONS(2972),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2970),
    [sym_op_identifier] = ACTIONS(2970),
    [anon_sym_PLUS] = ACTIONS(2970),
    [anon_sym_DASH] = ACTIONS(2970),
    [anon_sym_PLUS_DOT] = ACTIONS(2970),
    [anon_sym_DASH_DOT] = ACTIONS(2970),
    [anon_sym_PERCENT] = ACTIONS(2970),
    [anon_sym_AMP_AMP] = ACTIONS(2970),
    [anon_sym_TILDE] = ACTIONS(2972),
    [aux_sym_prefix_op_token1] = ACTIONS(2970),
    [aux_sym_infix_op_token1] = ACTIONS(2972),
    [aux_sym_infix_op_token2] = ACTIONS(2970),
    [anon_sym_PIPE_PIPE] = ACTIONS(2970),
    [anon_sym_BANG_EQ] = ACTIONS(2970),
    [anon_sym_COLON_EQ] = ACTIONS(2972),
    [anon_sym_DOLLAR] = ACTIONS(2970),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2970),
    [sym_int] = ACTIONS(2970),
    [sym_xint] = ACTIONS(2972),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2972),
    [sym__newline] = ACTIONS(2972),
  },
  [1736] = {
    [sym_block_comment] = STATE(1736),
    [sym_compiler_directive_decl] = STATE(1736),
    [sym_fsi_directive_decl] = STATE(1736),
    [sym_preproc_line] = STATE(1736),
    [sym_identifier] = ACTIONS(2954),
    [anon_sym_EQ] = ACTIONS(2956),
    [anon_sym_COLON] = ACTIONS(2954),
    [anon_sym_return] = ACTIONS(2954),
    [anon_sym_do] = ACTIONS(2954),
    [anon_sym_let] = ACTIONS(2954),
    [anon_sym_let_BANG] = ACTIONS(2956),
    [anon_sym_LPAREN] = ACTIONS(2954),
    [anon_sym_COMMA] = ACTIONS(2956),
    [anon_sym_null] = ACTIONS(2954),
    [anon_sym_QMARK] = ACTIONS(2954),
    [anon_sym_COLON_QMARK] = ACTIONS(2954),
    [anon_sym_COLON_COLON] = ACTIONS(2956),
    [anon_sym_AMP] = ACTIONS(2954),
    [anon_sym_LBRACK] = ACTIONS(2954),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2956),
    [anon_sym_LBRACE] = ACTIONS(2954),
    [anon_sym_LT_AT] = ACTIONS(2954),
    [anon_sym_LT_AT_AT] = ACTIONS(2954),
    [anon_sym_DOT] = ACTIONS(2954),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2956),
    [anon_sym_new] = ACTIONS(2954),
    [anon_sym_return_BANG] = ACTIONS(2956),
    [anon_sym_yield] = ACTIONS(2954),
    [anon_sym_yield_BANG] = ACTIONS(2956),
    [anon_sym_lazy] = ACTIONS(2954),
    [anon_sym_assert] = ACTIONS(2954),
    [anon_sym_upcast] = ACTIONS(2954),
    [anon_sym_downcast] = ACTIONS(2954),
    [anon_sym_COLON_GT] = ACTIONS(2956),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2956),
    [anon_sym_for] = ACTIONS(2954),
    [anon_sym_while] = ACTIONS(2954),
    [anon_sym_if] = ACTIONS(2954),
    [anon_sym_fun] = ACTIONS(2954),
    [anon_sym_try] = ACTIONS(2954),
    [anon_sym_match] = ACTIONS(2954),
    [anon_sym_match_BANG] = ACTIONS(2956),
    [anon_sym_function] = ACTIONS(2954),
    [anon_sym_LT_DASH] = ACTIONS(2954),
    [anon_sym_DOT_LBRACK] = ACTIONS(2956),
    [anon_sym_LT] = ACTIONS(2956),
    [anon_sym_use] = ACTIONS(2954),
    [anon_sym_use_BANG] = ACTIONS(2956),
    [anon_sym_do_BANG] = ACTIONS(2956),
    [anon_sym_begin] = ACTIONS(2954),
    [anon_sym_LPAREN2] = ACTIONS(2954),
    [anon_sym_or] = ACTIONS(2954),
    [aux_sym_char_token1] = ACTIONS(2956),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2954),
    [anon_sym_DQUOTE] = ACTIONS(2954),
    [anon_sym_AT_DQUOTE] = ACTIONS(2956),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2956),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2956),
    [sym_bool] = ACTIONS(2954),
    [sym_unit] = ACTIONS(2956),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2954),
    [sym_op_identifier] = ACTIONS(2954),
    [anon_sym_PLUS] = ACTIONS(2954),
    [anon_sym_DASH] = ACTIONS(2954),
    [anon_sym_PLUS_DOT] = ACTIONS(2954),
    [anon_sym_DASH_DOT] = ACTIONS(2954),
    [anon_sym_PERCENT] = ACTIONS(2954),
    [anon_sym_AMP_AMP] = ACTIONS(2954),
    [anon_sym_TILDE] = ACTIONS(2956),
    [aux_sym_prefix_op_token1] = ACTIONS(2954),
    [aux_sym_infix_op_token1] = ACTIONS(2956),
    [aux_sym_infix_op_token2] = ACTIONS(2954),
    [anon_sym_PIPE_PIPE] = ACTIONS(2954),
    [anon_sym_BANG_EQ] = ACTIONS(2954),
    [anon_sym_COLON_EQ] = ACTIONS(2956),
    [anon_sym_DOLLAR] = ACTIONS(2954),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2954),
    [sym_int] = ACTIONS(2954),
    [sym_xint] = ACTIONS(2956),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2956),
    [anon_sym_POUNDendif] = ACTIONS(2956),
    [anon_sym_POUNDelse] = ACTIONS(2956),
    [sym__newline] = ACTIONS(2956),
  },
  [1737] = {
    [sym_block_comment] = STATE(1737),
    [sym_compiler_directive_decl] = STATE(1737),
    [sym_fsi_directive_decl] = STATE(1737),
    [sym_preproc_line] = STATE(1737),
    [sym_identifier] = ACTIONS(2958),
    [anon_sym_EQ] = ACTIONS(2960),
    [anon_sym_COLON] = ACTIONS(2958),
    [anon_sym_return] = ACTIONS(2958),
    [anon_sym_do] = ACTIONS(2958),
    [anon_sym_let] = ACTIONS(2958),
    [anon_sym_let_BANG] = ACTIONS(2960),
    [anon_sym_as] = ACTIONS(2958),
    [anon_sym_LPAREN] = ACTIONS(2958),
    [anon_sym_COMMA] = ACTIONS(2960),
    [anon_sym_null] = ACTIONS(2958),
    [anon_sym_QMARK] = ACTIONS(2958),
    [anon_sym_COLON_QMARK] = ACTIONS(2958),
    [anon_sym_COLON_COLON] = ACTIONS(2960),
    [anon_sym_AMP] = ACTIONS(2958),
    [anon_sym_LBRACK] = ACTIONS(2958),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2960),
    [anon_sym_LBRACE] = ACTIONS(2958),
    [anon_sym_LT_AT] = ACTIONS(2958),
    [anon_sym_LT_AT_AT] = ACTIONS(2958),
    [anon_sym_DOT] = ACTIONS(2958),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2960),
    [anon_sym_new] = ACTIONS(2958),
    [anon_sym_with] = ACTIONS(2958),
    [anon_sym_return_BANG] = ACTIONS(2960),
    [anon_sym_yield] = ACTIONS(2958),
    [anon_sym_yield_BANG] = ACTIONS(2960),
    [anon_sym_lazy] = ACTIONS(2958),
    [anon_sym_assert] = ACTIONS(2958),
    [anon_sym_upcast] = ACTIONS(2958),
    [anon_sym_downcast] = ACTIONS(2958),
    [anon_sym_COLON_GT] = ACTIONS(2960),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2960),
    [anon_sym_for] = ACTIONS(2958),
    [anon_sym_while] = ACTIONS(2958),
    [anon_sym_if] = ACTIONS(2958),
    [anon_sym_fun] = ACTIONS(2958),
    [anon_sym_try] = ACTIONS(2958),
    [anon_sym_match] = ACTIONS(2958),
    [anon_sym_match_BANG] = ACTIONS(2960),
    [anon_sym_function] = ACTIONS(2958),
    [anon_sym_LT_DASH] = ACTIONS(2958),
    [anon_sym_DOT_LBRACK] = ACTIONS(2960),
    [anon_sym_LT] = ACTIONS(2960),
    [anon_sym_use] = ACTIONS(2958),
    [anon_sym_use_BANG] = ACTIONS(2960),
    [anon_sym_do_BANG] = ACTIONS(2960),
    [anon_sym_begin] = ACTIONS(2958),
    [anon_sym_LPAREN2] = ACTIONS(2958),
    [anon_sym_or] = ACTIONS(2958),
    [aux_sym_char_token1] = ACTIONS(2960),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2958),
    [anon_sym_DQUOTE] = ACTIONS(2958),
    [anon_sym_AT_DQUOTE] = ACTIONS(2960),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2960),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2960),
    [sym_bool] = ACTIONS(2958),
    [sym_unit] = ACTIONS(2960),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2958),
    [sym_op_identifier] = ACTIONS(2958),
    [anon_sym_PLUS] = ACTIONS(2958),
    [anon_sym_DASH] = ACTIONS(2958),
    [anon_sym_PLUS_DOT] = ACTIONS(2958),
    [anon_sym_DASH_DOT] = ACTIONS(2958),
    [anon_sym_PERCENT] = ACTIONS(2958),
    [anon_sym_AMP_AMP] = ACTIONS(2958),
    [anon_sym_TILDE] = ACTIONS(2960),
    [aux_sym_prefix_op_token1] = ACTIONS(2958),
    [aux_sym_infix_op_token1] = ACTIONS(2960),
    [aux_sym_infix_op_token2] = ACTIONS(2958),
    [anon_sym_PIPE_PIPE] = ACTIONS(2958),
    [anon_sym_BANG_EQ] = ACTIONS(2958),
    [anon_sym_COLON_EQ] = ACTIONS(2960),
    [anon_sym_DOLLAR] = ACTIONS(2958),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2958),
    [sym_int] = ACTIONS(2958),
    [sym_xint] = ACTIONS(2960),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2960),
    [sym__newline] = ACTIONS(2960),
  },
  [1738] = {
    [sym_block_comment] = STATE(1738),
    [sym_compiler_directive_decl] = STATE(1738),
    [sym_fsi_directive_decl] = STATE(1738),
    [sym_preproc_line] = STATE(1738),
    [sym_identifier] = ACTIONS(2962),
    [anon_sym_EQ] = ACTIONS(2964),
    [anon_sym_COLON] = ACTIONS(2962),
    [anon_sym_return] = ACTIONS(2962),
    [anon_sym_do] = ACTIONS(2962),
    [anon_sym_let] = ACTIONS(2962),
    [anon_sym_let_BANG] = ACTIONS(2964),
    [anon_sym_as] = ACTIONS(2962),
    [anon_sym_LPAREN] = ACTIONS(2962),
    [anon_sym_COMMA] = ACTIONS(2964),
    [anon_sym_null] = ACTIONS(2962),
    [anon_sym_QMARK] = ACTIONS(2962),
    [anon_sym_COLON_QMARK] = ACTIONS(2962),
    [anon_sym_COLON_COLON] = ACTIONS(2964),
    [anon_sym_AMP] = ACTIONS(2962),
    [anon_sym_LBRACK] = ACTIONS(2962),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2964),
    [anon_sym_LBRACE] = ACTIONS(2962),
    [anon_sym_LT_AT] = ACTIONS(2962),
    [anon_sym_LT_AT_AT] = ACTIONS(2962),
    [anon_sym_DOT] = ACTIONS(2962),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2964),
    [anon_sym_new] = ACTIONS(2962),
    [anon_sym_with] = ACTIONS(2962),
    [anon_sym_return_BANG] = ACTIONS(2964),
    [anon_sym_yield] = ACTIONS(2962),
    [anon_sym_yield_BANG] = ACTIONS(2964),
    [anon_sym_lazy] = ACTIONS(2962),
    [anon_sym_assert] = ACTIONS(2962),
    [anon_sym_upcast] = ACTIONS(2962),
    [anon_sym_downcast] = ACTIONS(2962),
    [anon_sym_COLON_GT] = ACTIONS(2964),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2964),
    [anon_sym_for] = ACTIONS(2962),
    [anon_sym_while] = ACTIONS(2962),
    [anon_sym_if] = ACTIONS(2962),
    [anon_sym_fun] = ACTIONS(2962),
    [anon_sym_try] = ACTIONS(2962),
    [anon_sym_match] = ACTIONS(2962),
    [anon_sym_match_BANG] = ACTIONS(2964),
    [anon_sym_function] = ACTIONS(2962),
    [anon_sym_LT_DASH] = ACTIONS(2962),
    [anon_sym_DOT_LBRACK] = ACTIONS(2964),
    [anon_sym_LT] = ACTIONS(2964),
    [anon_sym_use] = ACTIONS(2962),
    [anon_sym_use_BANG] = ACTIONS(2964),
    [anon_sym_do_BANG] = ACTIONS(2964),
    [anon_sym_begin] = ACTIONS(2962),
    [anon_sym_LPAREN2] = ACTIONS(2962),
    [anon_sym_or] = ACTIONS(2962),
    [aux_sym_char_token1] = ACTIONS(2964),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2962),
    [anon_sym_DQUOTE] = ACTIONS(2962),
    [anon_sym_AT_DQUOTE] = ACTIONS(2964),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2964),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2964),
    [sym_bool] = ACTIONS(2962),
    [sym_unit] = ACTIONS(2964),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2962),
    [sym_op_identifier] = ACTIONS(2962),
    [anon_sym_PLUS] = ACTIONS(2962),
    [anon_sym_DASH] = ACTIONS(2962),
    [anon_sym_PLUS_DOT] = ACTIONS(2962),
    [anon_sym_DASH_DOT] = ACTIONS(2962),
    [anon_sym_PERCENT] = ACTIONS(2962),
    [anon_sym_AMP_AMP] = ACTIONS(2962),
    [anon_sym_TILDE] = ACTIONS(2964),
    [aux_sym_prefix_op_token1] = ACTIONS(2962),
    [aux_sym_infix_op_token1] = ACTIONS(2964),
    [aux_sym_infix_op_token2] = ACTIONS(2962),
    [anon_sym_PIPE_PIPE] = ACTIONS(2962),
    [anon_sym_BANG_EQ] = ACTIONS(2962),
    [anon_sym_COLON_EQ] = ACTIONS(2964),
    [anon_sym_DOLLAR] = ACTIONS(2962),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2962),
    [sym_int] = ACTIONS(2962),
    [sym_xint] = ACTIONS(2964),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2964),
    [sym__newline] = ACTIONS(2964),
  },
  [1739] = {
    [sym_block_comment] = STATE(1739),
    [sym_compiler_directive_decl] = STATE(1739),
    [sym_fsi_directive_decl] = STATE(1739),
    [sym_preproc_line] = STATE(1739),
    [sym_identifier] = ACTIONS(2942),
    [anon_sym_EQ] = ACTIONS(2944),
    [anon_sym_COLON] = ACTIONS(2942),
    [anon_sym_return] = ACTIONS(2942),
    [anon_sym_do] = ACTIONS(2942),
    [anon_sym_let] = ACTIONS(2942),
    [anon_sym_let_BANG] = ACTIONS(2944),
    [anon_sym_as] = ACTIONS(2942),
    [anon_sym_LPAREN] = ACTIONS(2942),
    [anon_sym_COMMA] = ACTIONS(2944),
    [anon_sym_null] = ACTIONS(2942),
    [anon_sym_QMARK] = ACTIONS(2942),
    [anon_sym_COLON_QMARK] = ACTIONS(2942),
    [anon_sym_COLON_COLON] = ACTIONS(2944),
    [anon_sym_AMP] = ACTIONS(2942),
    [anon_sym_LBRACK] = ACTIONS(2942),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2944),
    [anon_sym_LBRACE] = ACTIONS(2942),
    [anon_sym_LT_AT] = ACTIONS(2942),
    [anon_sym_LT_AT_AT] = ACTIONS(2942),
    [anon_sym_DOT] = ACTIONS(2942),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2944),
    [anon_sym_new] = ACTIONS(2942),
    [anon_sym_with] = ACTIONS(2942),
    [anon_sym_return_BANG] = ACTIONS(2944),
    [anon_sym_yield] = ACTIONS(2942),
    [anon_sym_yield_BANG] = ACTIONS(2944),
    [anon_sym_lazy] = ACTIONS(2942),
    [anon_sym_assert] = ACTIONS(2942),
    [anon_sym_upcast] = ACTIONS(2942),
    [anon_sym_downcast] = ACTIONS(2942),
    [anon_sym_COLON_GT] = ACTIONS(2944),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2944),
    [anon_sym_for] = ACTIONS(2942),
    [anon_sym_while] = ACTIONS(2942),
    [anon_sym_if] = ACTIONS(2942),
    [anon_sym_fun] = ACTIONS(2942),
    [anon_sym_try] = ACTIONS(2942),
    [anon_sym_match] = ACTIONS(2942),
    [anon_sym_match_BANG] = ACTIONS(2944),
    [anon_sym_function] = ACTIONS(2942),
    [anon_sym_LT_DASH] = ACTIONS(2942),
    [anon_sym_DOT_LBRACK] = ACTIONS(2944),
    [anon_sym_LT] = ACTIONS(2944),
    [anon_sym_use] = ACTIONS(2942),
    [anon_sym_use_BANG] = ACTIONS(2944),
    [anon_sym_do_BANG] = ACTIONS(2944),
    [anon_sym_begin] = ACTIONS(2942),
    [anon_sym_LPAREN2] = ACTIONS(2942),
    [anon_sym_or] = ACTIONS(2942),
    [aux_sym_char_token1] = ACTIONS(2944),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2942),
    [anon_sym_DQUOTE] = ACTIONS(2942),
    [anon_sym_AT_DQUOTE] = ACTIONS(2944),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2944),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2944),
    [sym_bool] = ACTIONS(2942),
    [sym_unit] = ACTIONS(2944),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2942),
    [sym_op_identifier] = ACTIONS(2942),
    [anon_sym_PLUS] = ACTIONS(2942),
    [anon_sym_DASH] = ACTIONS(2942),
    [anon_sym_PLUS_DOT] = ACTIONS(2942),
    [anon_sym_DASH_DOT] = ACTIONS(2942),
    [anon_sym_PERCENT] = ACTIONS(2942),
    [anon_sym_AMP_AMP] = ACTIONS(2942),
    [anon_sym_TILDE] = ACTIONS(2944),
    [aux_sym_prefix_op_token1] = ACTIONS(2942),
    [aux_sym_infix_op_token1] = ACTIONS(2944),
    [aux_sym_infix_op_token2] = ACTIONS(2942),
    [anon_sym_PIPE_PIPE] = ACTIONS(2942),
    [anon_sym_BANG_EQ] = ACTIONS(2942),
    [anon_sym_COLON_EQ] = ACTIONS(2944),
    [anon_sym_DOLLAR] = ACTIONS(2942),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2942),
    [sym_int] = ACTIONS(2942),
    [sym_xint] = ACTIONS(2944),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2944),
    [sym__newline] = ACTIONS(2944),
  },
  [1740] = {
    [sym_block_comment] = STATE(1740),
    [sym_compiler_directive_decl] = STATE(1740),
    [sym_fsi_directive_decl] = STATE(1740),
    [sym_preproc_line] = STATE(1740),
    [sym_identifier] = ACTIONS(2966),
    [anon_sym_EQ] = ACTIONS(2968),
    [anon_sym_COLON] = ACTIONS(2966),
    [anon_sym_return] = ACTIONS(2966),
    [anon_sym_do] = ACTIONS(2966),
    [anon_sym_let] = ACTIONS(2966),
    [anon_sym_let_BANG] = ACTIONS(2968),
    [anon_sym_as] = ACTIONS(2966),
    [anon_sym_LPAREN] = ACTIONS(2966),
    [anon_sym_COMMA] = ACTIONS(2968),
    [anon_sym_null] = ACTIONS(2966),
    [anon_sym_QMARK] = ACTIONS(2966),
    [anon_sym_COLON_QMARK] = ACTIONS(2966),
    [anon_sym_COLON_COLON] = ACTIONS(2968),
    [anon_sym_AMP] = ACTIONS(2966),
    [anon_sym_LBRACK] = ACTIONS(2966),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2968),
    [anon_sym_LBRACE] = ACTIONS(2966),
    [anon_sym_LT_AT] = ACTIONS(2966),
    [anon_sym_LT_AT_AT] = ACTIONS(2966),
    [anon_sym_DOT] = ACTIONS(2966),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2968),
    [anon_sym_new] = ACTIONS(2966),
    [anon_sym_with] = ACTIONS(2966),
    [anon_sym_return_BANG] = ACTIONS(2968),
    [anon_sym_yield] = ACTIONS(2966),
    [anon_sym_yield_BANG] = ACTIONS(2968),
    [anon_sym_lazy] = ACTIONS(2966),
    [anon_sym_assert] = ACTIONS(2966),
    [anon_sym_upcast] = ACTIONS(2966),
    [anon_sym_downcast] = ACTIONS(2966),
    [anon_sym_COLON_GT] = ACTIONS(2968),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2968),
    [anon_sym_for] = ACTIONS(2966),
    [anon_sym_while] = ACTIONS(2966),
    [anon_sym_if] = ACTIONS(2966),
    [anon_sym_fun] = ACTIONS(2966),
    [anon_sym_try] = ACTIONS(2966),
    [anon_sym_match] = ACTIONS(2966),
    [anon_sym_match_BANG] = ACTIONS(2968),
    [anon_sym_function] = ACTIONS(2966),
    [anon_sym_LT_DASH] = ACTIONS(2966),
    [anon_sym_DOT_LBRACK] = ACTIONS(2968),
    [anon_sym_LT] = ACTIONS(2968),
    [anon_sym_use] = ACTIONS(2966),
    [anon_sym_use_BANG] = ACTIONS(2968),
    [anon_sym_do_BANG] = ACTIONS(2968),
    [anon_sym_begin] = ACTIONS(2966),
    [anon_sym_LPAREN2] = ACTIONS(2966),
    [anon_sym_or] = ACTIONS(2966),
    [aux_sym_char_token1] = ACTIONS(2968),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2966),
    [anon_sym_DQUOTE] = ACTIONS(2966),
    [anon_sym_AT_DQUOTE] = ACTIONS(2968),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2968),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2968),
    [sym_bool] = ACTIONS(2966),
    [sym_unit] = ACTIONS(2968),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2966),
    [sym_op_identifier] = ACTIONS(2966),
    [anon_sym_PLUS] = ACTIONS(2966),
    [anon_sym_DASH] = ACTIONS(2966),
    [anon_sym_PLUS_DOT] = ACTIONS(2966),
    [anon_sym_DASH_DOT] = ACTIONS(2966),
    [anon_sym_PERCENT] = ACTIONS(2966),
    [anon_sym_AMP_AMP] = ACTIONS(2966),
    [anon_sym_TILDE] = ACTIONS(2968),
    [aux_sym_prefix_op_token1] = ACTIONS(2966),
    [aux_sym_infix_op_token1] = ACTIONS(2968),
    [aux_sym_infix_op_token2] = ACTIONS(2966),
    [anon_sym_PIPE_PIPE] = ACTIONS(2966),
    [anon_sym_BANG_EQ] = ACTIONS(2966),
    [anon_sym_COLON_EQ] = ACTIONS(2968),
    [anon_sym_DOLLAR] = ACTIONS(2966),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2966),
    [sym_int] = ACTIONS(2966),
    [sym_xint] = ACTIONS(2968),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2968),
    [sym__newline] = ACTIONS(2968),
  },
  [1741] = {
    [sym_block_comment] = STATE(1741),
    [sym_compiler_directive_decl] = STATE(1741),
    [sym_fsi_directive_decl] = STATE(1741),
    [sym_preproc_line] = STATE(1741),
    [sym_identifier] = ACTIONS(2974),
    [anon_sym_EQ] = ACTIONS(2976),
    [anon_sym_COLON] = ACTIONS(2974),
    [anon_sym_return] = ACTIONS(2974),
    [anon_sym_do] = ACTIONS(2974),
    [anon_sym_let] = ACTIONS(2974),
    [anon_sym_let_BANG] = ACTIONS(2976),
    [anon_sym_as] = ACTIONS(2974),
    [anon_sym_LPAREN] = ACTIONS(2974),
    [anon_sym_COMMA] = ACTIONS(2976),
    [anon_sym_null] = ACTIONS(2974),
    [anon_sym_QMARK] = ACTIONS(2974),
    [anon_sym_COLON_QMARK] = ACTIONS(2974),
    [anon_sym_COLON_COLON] = ACTIONS(2976),
    [anon_sym_AMP] = ACTIONS(2974),
    [anon_sym_LBRACK] = ACTIONS(2974),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2976),
    [anon_sym_LBRACE] = ACTIONS(2974),
    [anon_sym_LT_AT] = ACTIONS(2974),
    [anon_sym_LT_AT_AT] = ACTIONS(2974),
    [anon_sym_DOT] = ACTIONS(2974),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2976),
    [anon_sym_new] = ACTIONS(2974),
    [anon_sym_with] = ACTIONS(2974),
    [anon_sym_return_BANG] = ACTIONS(2976),
    [anon_sym_yield] = ACTIONS(2974),
    [anon_sym_yield_BANG] = ACTIONS(2976),
    [anon_sym_lazy] = ACTIONS(2974),
    [anon_sym_assert] = ACTIONS(2974),
    [anon_sym_upcast] = ACTIONS(2974),
    [anon_sym_downcast] = ACTIONS(2974),
    [anon_sym_COLON_GT] = ACTIONS(2976),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2976),
    [anon_sym_for] = ACTIONS(2974),
    [anon_sym_while] = ACTIONS(2974),
    [anon_sym_if] = ACTIONS(2974),
    [anon_sym_fun] = ACTIONS(2974),
    [anon_sym_try] = ACTIONS(2974),
    [anon_sym_match] = ACTIONS(2974),
    [anon_sym_match_BANG] = ACTIONS(2976),
    [anon_sym_function] = ACTIONS(2974),
    [anon_sym_LT_DASH] = ACTIONS(2974),
    [anon_sym_DOT_LBRACK] = ACTIONS(2976),
    [anon_sym_LT] = ACTIONS(2976),
    [anon_sym_use] = ACTIONS(2974),
    [anon_sym_use_BANG] = ACTIONS(2976),
    [anon_sym_do_BANG] = ACTIONS(2976),
    [anon_sym_begin] = ACTIONS(2974),
    [anon_sym_LPAREN2] = ACTIONS(2974),
    [anon_sym_or] = ACTIONS(2974),
    [aux_sym_char_token1] = ACTIONS(2976),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2974),
    [anon_sym_DQUOTE] = ACTIONS(2974),
    [anon_sym_AT_DQUOTE] = ACTIONS(2976),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2976),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2976),
    [sym_bool] = ACTIONS(2974),
    [sym_unit] = ACTIONS(2976),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2974),
    [sym_op_identifier] = ACTIONS(2974),
    [anon_sym_PLUS] = ACTIONS(2974),
    [anon_sym_DASH] = ACTIONS(2974),
    [anon_sym_PLUS_DOT] = ACTIONS(2974),
    [anon_sym_DASH_DOT] = ACTIONS(2974),
    [anon_sym_PERCENT] = ACTIONS(2974),
    [anon_sym_AMP_AMP] = ACTIONS(2974),
    [anon_sym_TILDE] = ACTIONS(2976),
    [aux_sym_prefix_op_token1] = ACTIONS(2974),
    [aux_sym_infix_op_token1] = ACTIONS(2976),
    [aux_sym_infix_op_token2] = ACTIONS(2974),
    [anon_sym_PIPE_PIPE] = ACTIONS(2974),
    [anon_sym_BANG_EQ] = ACTIONS(2974),
    [anon_sym_COLON_EQ] = ACTIONS(2976),
    [anon_sym_DOLLAR] = ACTIONS(2974),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2974),
    [sym_int] = ACTIONS(2974),
    [sym_xint] = ACTIONS(2976),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2976),
    [sym__newline] = ACTIONS(2976),
  },
  [1742] = {
    [sym_block_comment] = STATE(1742),
    [sym_compiler_directive_decl] = STATE(1742),
    [sym_fsi_directive_decl] = STATE(1742),
    [sym_preproc_line] = STATE(1742),
    [sym_identifier] = ACTIONS(3019),
    [anon_sym_EQ] = ACTIONS(3021),
    [anon_sym_COLON] = ACTIONS(3019),
    [anon_sym_return] = ACTIONS(3019),
    [anon_sym_do] = ACTIONS(3019),
    [anon_sym_let] = ACTIONS(3019),
    [anon_sym_let_BANG] = ACTIONS(3021),
    [anon_sym_as] = ACTIONS(3019),
    [anon_sym_LPAREN] = ACTIONS(3019),
    [anon_sym_COMMA] = ACTIONS(3021),
    [anon_sym_null] = ACTIONS(3019),
    [anon_sym_QMARK] = ACTIONS(3019),
    [anon_sym_COLON_QMARK] = ACTIONS(3019),
    [anon_sym_COLON_COLON] = ACTIONS(3021),
    [anon_sym_AMP] = ACTIONS(3019),
    [anon_sym_LBRACK] = ACTIONS(3019),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3021),
    [anon_sym_LBRACE] = ACTIONS(3019),
    [anon_sym_LT_AT] = ACTIONS(3019),
    [anon_sym_LT_AT_AT] = ACTIONS(3019),
    [anon_sym_DOT] = ACTIONS(3019),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3021),
    [anon_sym_new] = ACTIONS(3019),
    [anon_sym_with] = ACTIONS(3019),
    [anon_sym_return_BANG] = ACTIONS(3021),
    [anon_sym_yield] = ACTIONS(3019),
    [anon_sym_yield_BANG] = ACTIONS(3021),
    [anon_sym_lazy] = ACTIONS(3019),
    [anon_sym_assert] = ACTIONS(3019),
    [anon_sym_upcast] = ACTIONS(3019),
    [anon_sym_downcast] = ACTIONS(3019),
    [anon_sym_COLON_GT] = ACTIONS(3021),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3021),
    [anon_sym_for] = ACTIONS(3019),
    [anon_sym_while] = ACTIONS(3019),
    [anon_sym_if] = ACTIONS(3019),
    [anon_sym_fun] = ACTIONS(3019),
    [anon_sym_try] = ACTIONS(3019),
    [anon_sym_match] = ACTIONS(3019),
    [anon_sym_match_BANG] = ACTIONS(3021),
    [anon_sym_function] = ACTIONS(3019),
    [anon_sym_LT_DASH] = ACTIONS(3019),
    [anon_sym_DOT_LBRACK] = ACTIONS(3021),
    [anon_sym_LT] = ACTIONS(3021),
    [anon_sym_use] = ACTIONS(3019),
    [anon_sym_use_BANG] = ACTIONS(3021),
    [anon_sym_do_BANG] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3019),
    [anon_sym_LPAREN2] = ACTIONS(3019),
    [anon_sym_or] = ACTIONS(3019),
    [aux_sym_char_token1] = ACTIONS(3021),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3019),
    [anon_sym_DQUOTE] = ACTIONS(3019),
    [anon_sym_AT_DQUOTE] = ACTIONS(3021),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3021),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3021),
    [sym_bool] = ACTIONS(3019),
    [sym_unit] = ACTIONS(3021),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3019),
    [sym_op_identifier] = ACTIONS(3019),
    [anon_sym_PLUS] = ACTIONS(3019),
    [anon_sym_DASH] = ACTIONS(3019),
    [anon_sym_PLUS_DOT] = ACTIONS(3019),
    [anon_sym_DASH_DOT] = ACTIONS(3019),
    [anon_sym_PERCENT] = ACTIONS(3019),
    [anon_sym_AMP_AMP] = ACTIONS(3019),
    [anon_sym_TILDE] = ACTIONS(3021),
    [aux_sym_prefix_op_token1] = ACTIONS(3019),
    [aux_sym_infix_op_token1] = ACTIONS(3021),
    [aux_sym_infix_op_token2] = ACTIONS(3019),
    [anon_sym_PIPE_PIPE] = ACTIONS(3019),
    [anon_sym_BANG_EQ] = ACTIONS(3019),
    [anon_sym_COLON_EQ] = ACTIONS(3021),
    [anon_sym_DOLLAR] = ACTIONS(3019),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3019),
    [sym_int] = ACTIONS(3019),
    [sym_xint] = ACTIONS(3021),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3021),
    [sym__newline] = ACTIONS(3021),
  },
  [1743] = {
    [sym_block_comment] = STATE(1743),
    [sym_compiler_directive_decl] = STATE(1743),
    [sym_fsi_directive_decl] = STATE(1743),
    [sym_preproc_line] = STATE(1743),
    [aux_sym_sequential_expression_repeat1] = STATE(2062),
    [sym_identifier] = ACTIONS(2847),
    [anon_sym_EQ] = ACTIONS(2849),
    [anon_sym_COLON] = ACTIONS(2847),
    [anon_sym_return] = ACTIONS(2847),
    [anon_sym_do] = ACTIONS(2847),
    [anon_sym_let] = ACTIONS(2847),
    [anon_sym_let_BANG] = ACTIONS(2849),
    [anon_sym_LPAREN] = ACTIONS(2847),
    [anon_sym_COMMA] = ACTIONS(2849),
    [anon_sym_null] = ACTIONS(2847),
    [anon_sym_QMARK] = ACTIONS(2847),
    [anon_sym_COLON_QMARK] = ACTIONS(2847),
    [anon_sym_COLON_COLON] = ACTIONS(2849),
    [anon_sym_AMP] = ACTIONS(2847),
    [anon_sym_LBRACK] = ACTIONS(2847),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2849),
    [anon_sym_LBRACE] = ACTIONS(2847),
    [anon_sym_LT_AT] = ACTIONS(2847),
    [anon_sym_LT_AT_AT] = ACTIONS(2847),
    [anon_sym_DOT] = ACTIONS(2847),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2849),
    [anon_sym_new] = ACTIONS(2847),
    [anon_sym_return_BANG] = ACTIONS(2849),
    [anon_sym_yield] = ACTIONS(2847),
    [anon_sym_yield_BANG] = ACTIONS(2849),
    [anon_sym_lazy] = ACTIONS(2847),
    [anon_sym_assert] = ACTIONS(2847),
    [anon_sym_upcast] = ACTIONS(2847),
    [anon_sym_downcast] = ACTIONS(2847),
    [anon_sym_COLON_GT] = ACTIONS(2849),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2849),
    [anon_sym_for] = ACTIONS(2847),
    [anon_sym_while] = ACTIONS(2847),
    [anon_sym_if] = ACTIONS(2847),
    [anon_sym_fun] = ACTIONS(2847),
    [anon_sym_try] = ACTIONS(2847),
    [anon_sym_match] = ACTIONS(2847),
    [anon_sym_match_BANG] = ACTIONS(2849),
    [anon_sym_function] = ACTIONS(2847),
    [anon_sym_LT_DASH] = ACTIONS(2847),
    [anon_sym_DOT_LBRACK] = ACTIONS(2849),
    [anon_sym_LT] = ACTIONS(2849),
    [anon_sym_use] = ACTIONS(2847),
    [anon_sym_use_BANG] = ACTIONS(2849),
    [anon_sym_do_BANG] = ACTIONS(2849),
    [anon_sym_DOT_DOT] = ACTIONS(2849),
    [anon_sym_begin] = ACTIONS(2847),
    [anon_sym_LPAREN2] = ACTIONS(2847),
    [anon_sym_or] = ACTIONS(2847),
    [aux_sym_char_token1] = ACTIONS(2849),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2847),
    [anon_sym_DQUOTE] = ACTIONS(2847),
    [anon_sym_AT_DQUOTE] = ACTIONS(2849),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2849),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2849),
    [sym_bool] = ACTIONS(2847),
    [sym_unit] = ACTIONS(2849),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2847),
    [sym_op_identifier] = ACTIONS(2847),
    [anon_sym_PLUS] = ACTIONS(2847),
    [anon_sym_DASH] = ACTIONS(2847),
    [anon_sym_PLUS_DOT] = ACTIONS(2847),
    [anon_sym_DASH_DOT] = ACTIONS(2847),
    [anon_sym_PERCENT] = ACTIONS(2847),
    [anon_sym_AMP_AMP] = ACTIONS(2847),
    [anon_sym_TILDE] = ACTIONS(2849),
    [aux_sym_prefix_op_token1] = ACTIONS(2847),
    [aux_sym_infix_op_token1] = ACTIONS(2849),
    [aux_sym_infix_op_token2] = ACTIONS(2847),
    [anon_sym_PIPE_PIPE] = ACTIONS(2847),
    [anon_sym_BANG_EQ] = ACTIONS(2847),
    [anon_sym_COLON_EQ] = ACTIONS(2849),
    [anon_sym_DOLLAR] = ACTIONS(2847),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2847),
    [sym_int] = ACTIONS(2847),
    [sym_xint] = ACTIONS(2849),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2849),
    [sym__newline] = ACTIONS(2849),
  },
  [1744] = {
    [sym_block_comment] = STATE(1744),
    [sym_compiler_directive_decl] = STATE(1744),
    [sym_fsi_directive_decl] = STATE(1744),
    [sym_preproc_line] = STATE(1744),
    [sym_identifier] = ACTIONS(3023),
    [anon_sym_EQ] = ACTIONS(3025),
    [anon_sym_COLON] = ACTIONS(3023),
    [anon_sym_return] = ACTIONS(3023),
    [anon_sym_do] = ACTIONS(3023),
    [anon_sym_let] = ACTIONS(3023),
    [anon_sym_let_BANG] = ACTIONS(3025),
    [anon_sym_as] = ACTIONS(3023),
    [anon_sym_LPAREN] = ACTIONS(3023),
    [anon_sym_COMMA] = ACTIONS(3025),
    [anon_sym_null] = ACTIONS(3023),
    [anon_sym_QMARK] = ACTIONS(3023),
    [anon_sym_COLON_QMARK] = ACTIONS(3023),
    [anon_sym_COLON_COLON] = ACTIONS(3025),
    [anon_sym_AMP] = ACTIONS(3023),
    [anon_sym_LBRACK] = ACTIONS(3023),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3025),
    [anon_sym_LBRACE] = ACTIONS(3023),
    [anon_sym_LT_AT] = ACTIONS(3023),
    [anon_sym_LT_AT_AT] = ACTIONS(3023),
    [anon_sym_DOT] = ACTIONS(3023),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3025),
    [anon_sym_new] = ACTIONS(3023),
    [anon_sym_with] = ACTIONS(3023),
    [anon_sym_return_BANG] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(3023),
    [anon_sym_yield_BANG] = ACTIONS(3025),
    [anon_sym_lazy] = ACTIONS(3023),
    [anon_sym_assert] = ACTIONS(3023),
    [anon_sym_upcast] = ACTIONS(3023),
    [anon_sym_downcast] = ACTIONS(3023),
    [anon_sym_COLON_GT] = ACTIONS(3025),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3025),
    [anon_sym_for] = ACTIONS(3023),
    [anon_sym_while] = ACTIONS(3023),
    [anon_sym_if] = ACTIONS(3023),
    [anon_sym_fun] = ACTIONS(3023),
    [anon_sym_try] = ACTIONS(3023),
    [anon_sym_match] = ACTIONS(3023),
    [anon_sym_match_BANG] = ACTIONS(3025),
    [anon_sym_function] = ACTIONS(3023),
    [anon_sym_LT_DASH] = ACTIONS(3023),
    [anon_sym_DOT_LBRACK] = ACTIONS(3025),
    [anon_sym_LT] = ACTIONS(3025),
    [anon_sym_use] = ACTIONS(3023),
    [anon_sym_use_BANG] = ACTIONS(3025),
    [anon_sym_do_BANG] = ACTIONS(3025),
    [anon_sym_begin] = ACTIONS(3023),
    [anon_sym_LPAREN2] = ACTIONS(3023),
    [anon_sym_or] = ACTIONS(3023),
    [aux_sym_char_token1] = ACTIONS(3025),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3023),
    [anon_sym_DQUOTE] = ACTIONS(3023),
    [anon_sym_AT_DQUOTE] = ACTIONS(3025),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3025),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3025),
    [sym_bool] = ACTIONS(3023),
    [sym_unit] = ACTIONS(3025),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3023),
    [sym_op_identifier] = ACTIONS(3023),
    [anon_sym_PLUS] = ACTIONS(3023),
    [anon_sym_DASH] = ACTIONS(3023),
    [anon_sym_PLUS_DOT] = ACTIONS(3023),
    [anon_sym_DASH_DOT] = ACTIONS(3023),
    [anon_sym_PERCENT] = ACTIONS(3023),
    [anon_sym_AMP_AMP] = ACTIONS(3023),
    [anon_sym_TILDE] = ACTIONS(3025),
    [aux_sym_prefix_op_token1] = ACTIONS(3023),
    [aux_sym_infix_op_token1] = ACTIONS(3025),
    [aux_sym_infix_op_token2] = ACTIONS(3023),
    [anon_sym_PIPE_PIPE] = ACTIONS(3023),
    [anon_sym_BANG_EQ] = ACTIONS(3023),
    [anon_sym_COLON_EQ] = ACTIONS(3025),
    [anon_sym_DOLLAR] = ACTIONS(3023),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3023),
    [sym_int] = ACTIONS(3023),
    [sym_xint] = ACTIONS(3025),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3025),
    [sym__newline] = ACTIONS(3025),
  },
  [1745] = {
    [sym_block_comment] = STATE(1745),
    [sym_compiler_directive_decl] = STATE(1745),
    [sym_fsi_directive_decl] = STATE(1745),
    [sym_preproc_line] = STATE(1745),
    [sym_identifier] = ACTIONS(3027),
    [anon_sym_EQ] = ACTIONS(3029),
    [anon_sym_COLON] = ACTIONS(3027),
    [anon_sym_return] = ACTIONS(3027),
    [anon_sym_do] = ACTIONS(3027),
    [anon_sym_let] = ACTIONS(3027),
    [anon_sym_let_BANG] = ACTIONS(3029),
    [anon_sym_as] = ACTIONS(3027),
    [anon_sym_LPAREN] = ACTIONS(3027),
    [anon_sym_COMMA] = ACTIONS(3029),
    [anon_sym_null] = ACTIONS(3027),
    [anon_sym_QMARK] = ACTIONS(3027),
    [anon_sym_COLON_QMARK] = ACTIONS(3027),
    [anon_sym_COLON_COLON] = ACTIONS(3029),
    [anon_sym_AMP] = ACTIONS(3027),
    [anon_sym_LBRACK] = ACTIONS(3027),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3027),
    [anon_sym_LT_AT] = ACTIONS(3027),
    [anon_sym_LT_AT_AT] = ACTIONS(3027),
    [anon_sym_DOT] = ACTIONS(3027),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3029),
    [anon_sym_new] = ACTIONS(3027),
    [anon_sym_with] = ACTIONS(3027),
    [anon_sym_return_BANG] = ACTIONS(3029),
    [anon_sym_yield] = ACTIONS(3027),
    [anon_sym_yield_BANG] = ACTIONS(3029),
    [anon_sym_lazy] = ACTIONS(3027),
    [anon_sym_assert] = ACTIONS(3027),
    [anon_sym_upcast] = ACTIONS(3027),
    [anon_sym_downcast] = ACTIONS(3027),
    [anon_sym_COLON_GT] = ACTIONS(3029),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3029),
    [anon_sym_for] = ACTIONS(3027),
    [anon_sym_while] = ACTIONS(3027),
    [anon_sym_if] = ACTIONS(3027),
    [anon_sym_fun] = ACTIONS(3027),
    [anon_sym_try] = ACTIONS(3027),
    [anon_sym_match] = ACTIONS(3027),
    [anon_sym_match_BANG] = ACTIONS(3029),
    [anon_sym_function] = ACTIONS(3027),
    [anon_sym_LT_DASH] = ACTIONS(3027),
    [anon_sym_DOT_LBRACK] = ACTIONS(3029),
    [anon_sym_LT] = ACTIONS(3029),
    [anon_sym_use] = ACTIONS(3027),
    [anon_sym_use_BANG] = ACTIONS(3029),
    [anon_sym_do_BANG] = ACTIONS(3029),
    [anon_sym_begin] = ACTIONS(3027),
    [anon_sym_LPAREN2] = ACTIONS(3027),
    [anon_sym_or] = ACTIONS(3027),
    [aux_sym_char_token1] = ACTIONS(3029),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3027),
    [anon_sym_DQUOTE] = ACTIONS(3027),
    [anon_sym_AT_DQUOTE] = ACTIONS(3029),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3029),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3029),
    [sym_bool] = ACTIONS(3027),
    [sym_unit] = ACTIONS(3029),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3027),
    [sym_op_identifier] = ACTIONS(3027),
    [anon_sym_PLUS] = ACTIONS(3027),
    [anon_sym_DASH] = ACTIONS(3027),
    [anon_sym_PLUS_DOT] = ACTIONS(3027),
    [anon_sym_DASH_DOT] = ACTIONS(3027),
    [anon_sym_PERCENT] = ACTIONS(3027),
    [anon_sym_AMP_AMP] = ACTIONS(3027),
    [anon_sym_TILDE] = ACTIONS(3029),
    [aux_sym_prefix_op_token1] = ACTIONS(3027),
    [aux_sym_infix_op_token1] = ACTIONS(3029),
    [aux_sym_infix_op_token2] = ACTIONS(3027),
    [anon_sym_PIPE_PIPE] = ACTIONS(3027),
    [anon_sym_BANG_EQ] = ACTIONS(3027),
    [anon_sym_COLON_EQ] = ACTIONS(3029),
    [anon_sym_DOLLAR] = ACTIONS(3027),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3027),
    [sym_int] = ACTIONS(3027),
    [sym_xint] = ACTIONS(3029),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3029),
    [sym__newline] = ACTIONS(3029),
  },
  [1746] = {
    [sym_block_comment] = STATE(1746),
    [sym_compiler_directive_decl] = STATE(1746),
    [sym_fsi_directive_decl] = STATE(1746),
    [sym_preproc_line] = STATE(1746),
    [sym_identifier] = ACTIONS(3031),
    [anon_sym_EQ] = ACTIONS(3033),
    [anon_sym_COLON] = ACTIONS(3031),
    [anon_sym_return] = ACTIONS(3031),
    [anon_sym_do] = ACTIONS(3031),
    [anon_sym_let] = ACTIONS(3031),
    [anon_sym_let_BANG] = ACTIONS(3033),
    [anon_sym_as] = ACTIONS(3031),
    [anon_sym_LPAREN] = ACTIONS(3031),
    [anon_sym_COMMA] = ACTIONS(3033),
    [anon_sym_null] = ACTIONS(3031),
    [anon_sym_QMARK] = ACTIONS(3031),
    [anon_sym_COLON_QMARK] = ACTIONS(3031),
    [anon_sym_COLON_COLON] = ACTIONS(3033),
    [anon_sym_AMP] = ACTIONS(3031),
    [anon_sym_LBRACK] = ACTIONS(3031),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3033),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [anon_sym_LT_AT] = ACTIONS(3031),
    [anon_sym_LT_AT_AT] = ACTIONS(3031),
    [anon_sym_DOT] = ACTIONS(3031),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3033),
    [anon_sym_new] = ACTIONS(3031),
    [anon_sym_with] = ACTIONS(3031),
    [anon_sym_return_BANG] = ACTIONS(3033),
    [anon_sym_yield] = ACTIONS(3031),
    [anon_sym_yield_BANG] = ACTIONS(3033),
    [anon_sym_lazy] = ACTIONS(3031),
    [anon_sym_assert] = ACTIONS(3031),
    [anon_sym_upcast] = ACTIONS(3031),
    [anon_sym_downcast] = ACTIONS(3031),
    [anon_sym_COLON_GT] = ACTIONS(3033),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3033),
    [anon_sym_for] = ACTIONS(3031),
    [anon_sym_while] = ACTIONS(3031),
    [anon_sym_if] = ACTIONS(3031),
    [anon_sym_fun] = ACTIONS(3031),
    [anon_sym_try] = ACTIONS(3031),
    [anon_sym_match] = ACTIONS(3031),
    [anon_sym_match_BANG] = ACTIONS(3033),
    [anon_sym_function] = ACTIONS(3031),
    [anon_sym_LT_DASH] = ACTIONS(3031),
    [anon_sym_DOT_LBRACK] = ACTIONS(3033),
    [anon_sym_LT] = ACTIONS(3033),
    [anon_sym_use] = ACTIONS(3031),
    [anon_sym_use_BANG] = ACTIONS(3033),
    [anon_sym_do_BANG] = ACTIONS(3033),
    [anon_sym_begin] = ACTIONS(3031),
    [anon_sym_LPAREN2] = ACTIONS(3031),
    [anon_sym_or] = ACTIONS(3031),
    [aux_sym_char_token1] = ACTIONS(3033),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3031),
    [anon_sym_DQUOTE] = ACTIONS(3031),
    [anon_sym_AT_DQUOTE] = ACTIONS(3033),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3033),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3033),
    [sym_bool] = ACTIONS(3031),
    [sym_unit] = ACTIONS(3033),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3031),
    [sym_op_identifier] = ACTIONS(3031),
    [anon_sym_PLUS] = ACTIONS(3031),
    [anon_sym_DASH] = ACTIONS(3031),
    [anon_sym_PLUS_DOT] = ACTIONS(3031),
    [anon_sym_DASH_DOT] = ACTIONS(3031),
    [anon_sym_PERCENT] = ACTIONS(3031),
    [anon_sym_AMP_AMP] = ACTIONS(3031),
    [anon_sym_TILDE] = ACTIONS(3033),
    [aux_sym_prefix_op_token1] = ACTIONS(3031),
    [aux_sym_infix_op_token1] = ACTIONS(3033),
    [aux_sym_infix_op_token2] = ACTIONS(3031),
    [anon_sym_PIPE_PIPE] = ACTIONS(3031),
    [anon_sym_BANG_EQ] = ACTIONS(3031),
    [anon_sym_COLON_EQ] = ACTIONS(3033),
    [anon_sym_DOLLAR] = ACTIONS(3031),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3031),
    [sym_int] = ACTIONS(3031),
    [sym_xint] = ACTIONS(3033),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3033),
    [sym__newline] = ACTIONS(3033),
  },
  [1747] = {
    [sym_block_comment] = STATE(1747),
    [sym_compiler_directive_decl] = STATE(1747),
    [sym_fsi_directive_decl] = STATE(1747),
    [sym_preproc_line] = STATE(1747),
    [sym_identifier] = ACTIONS(3035),
    [anon_sym_EQ] = ACTIONS(3037),
    [anon_sym_COLON] = ACTIONS(3035),
    [anon_sym_return] = ACTIONS(3035),
    [anon_sym_do] = ACTIONS(3035),
    [anon_sym_let] = ACTIONS(3035),
    [anon_sym_let_BANG] = ACTIONS(3037),
    [anon_sym_as] = ACTIONS(3035),
    [anon_sym_LPAREN] = ACTIONS(3035),
    [anon_sym_COMMA] = ACTIONS(3037),
    [anon_sym_null] = ACTIONS(3035),
    [anon_sym_QMARK] = ACTIONS(3035),
    [anon_sym_COLON_QMARK] = ACTIONS(3035),
    [anon_sym_COLON_COLON] = ACTIONS(3037),
    [anon_sym_AMP] = ACTIONS(3035),
    [anon_sym_LBRACK] = ACTIONS(3035),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3037),
    [anon_sym_LBRACE] = ACTIONS(3035),
    [anon_sym_LT_AT] = ACTIONS(3035),
    [anon_sym_LT_AT_AT] = ACTIONS(3035),
    [anon_sym_DOT] = ACTIONS(3035),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3037),
    [anon_sym_new] = ACTIONS(3035),
    [anon_sym_with] = ACTIONS(3035),
    [anon_sym_return_BANG] = ACTIONS(3037),
    [anon_sym_yield] = ACTIONS(3035),
    [anon_sym_yield_BANG] = ACTIONS(3037),
    [anon_sym_lazy] = ACTIONS(3035),
    [anon_sym_assert] = ACTIONS(3035),
    [anon_sym_upcast] = ACTIONS(3035),
    [anon_sym_downcast] = ACTIONS(3035),
    [anon_sym_COLON_GT] = ACTIONS(3037),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3037),
    [anon_sym_for] = ACTIONS(3035),
    [anon_sym_while] = ACTIONS(3035),
    [anon_sym_if] = ACTIONS(3035),
    [anon_sym_fun] = ACTIONS(3035),
    [anon_sym_try] = ACTIONS(3035),
    [anon_sym_match] = ACTIONS(3035),
    [anon_sym_match_BANG] = ACTIONS(3037),
    [anon_sym_function] = ACTIONS(3035),
    [anon_sym_LT_DASH] = ACTIONS(3035),
    [anon_sym_DOT_LBRACK] = ACTIONS(3037),
    [anon_sym_LT] = ACTIONS(3037),
    [anon_sym_use] = ACTIONS(3035),
    [anon_sym_use_BANG] = ACTIONS(3037),
    [anon_sym_do_BANG] = ACTIONS(3037),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_LPAREN2] = ACTIONS(3035),
    [anon_sym_or] = ACTIONS(3035),
    [aux_sym_char_token1] = ACTIONS(3037),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3035),
    [anon_sym_DQUOTE] = ACTIONS(3035),
    [anon_sym_AT_DQUOTE] = ACTIONS(3037),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3037),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3037),
    [sym_bool] = ACTIONS(3035),
    [sym_unit] = ACTIONS(3037),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3035),
    [sym_op_identifier] = ACTIONS(3035),
    [anon_sym_PLUS] = ACTIONS(3035),
    [anon_sym_DASH] = ACTIONS(3035),
    [anon_sym_PLUS_DOT] = ACTIONS(3035),
    [anon_sym_DASH_DOT] = ACTIONS(3035),
    [anon_sym_PERCENT] = ACTIONS(3035),
    [anon_sym_AMP_AMP] = ACTIONS(3035),
    [anon_sym_TILDE] = ACTIONS(3037),
    [aux_sym_prefix_op_token1] = ACTIONS(3035),
    [aux_sym_infix_op_token1] = ACTIONS(3037),
    [aux_sym_infix_op_token2] = ACTIONS(3035),
    [anon_sym_PIPE_PIPE] = ACTIONS(3035),
    [anon_sym_BANG_EQ] = ACTIONS(3035),
    [anon_sym_COLON_EQ] = ACTIONS(3037),
    [anon_sym_DOLLAR] = ACTIONS(3035),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3035),
    [sym_int] = ACTIONS(3035),
    [sym_xint] = ACTIONS(3037),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3037),
    [sym__newline] = ACTIONS(3037),
  },
  [1748] = {
    [sym_block_comment] = STATE(1748),
    [sym_compiler_directive_decl] = STATE(1748),
    [sym_fsi_directive_decl] = STATE(1748),
    [sym_preproc_line] = STATE(1748),
    [aux_sym_sequential_expression_repeat1] = STATE(1698),
    [sym_identifier] = ACTIONS(2847),
    [anon_sym_EQ] = ACTIONS(2849),
    [anon_sym_COLON] = ACTIONS(2847),
    [anon_sym_return] = ACTIONS(2847),
    [anon_sym_do] = ACTIONS(2847),
    [anon_sym_let] = ACTIONS(2847),
    [anon_sym_let_BANG] = ACTIONS(2849),
    [anon_sym_LPAREN] = ACTIONS(2847),
    [anon_sym_COMMA] = ACTIONS(2849),
    [anon_sym_null] = ACTIONS(2847),
    [anon_sym_QMARK] = ACTIONS(2847),
    [anon_sym_COLON_QMARK] = ACTIONS(2847),
    [anon_sym_COLON_COLON] = ACTIONS(2849),
    [anon_sym_AMP] = ACTIONS(2847),
    [anon_sym_LBRACK] = ACTIONS(2847),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2849),
    [anon_sym_LBRACE] = ACTIONS(2847),
    [anon_sym_LT_AT] = ACTIONS(2847),
    [anon_sym_LT_AT_AT] = ACTIONS(2847),
    [anon_sym_DOT] = ACTIONS(2847),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2849),
    [anon_sym_new] = ACTIONS(2847),
    [anon_sym_return_BANG] = ACTIONS(2849),
    [anon_sym_yield] = ACTIONS(2847),
    [anon_sym_yield_BANG] = ACTIONS(2849),
    [anon_sym_lazy] = ACTIONS(2847),
    [anon_sym_assert] = ACTIONS(2847),
    [anon_sym_upcast] = ACTIONS(2847),
    [anon_sym_downcast] = ACTIONS(2847),
    [anon_sym_COLON_GT] = ACTIONS(2849),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2849),
    [anon_sym_for] = ACTIONS(2847),
    [anon_sym_while] = ACTIONS(2847),
    [anon_sym_if] = ACTIONS(2847),
    [anon_sym_fun] = ACTIONS(2847),
    [anon_sym_try] = ACTIONS(2847),
    [anon_sym_match] = ACTIONS(2847),
    [anon_sym_match_BANG] = ACTIONS(2849),
    [anon_sym_function] = ACTIONS(2847),
    [anon_sym_LT_DASH] = ACTIONS(2847),
    [anon_sym_DOT_LBRACK] = ACTIONS(2849),
    [anon_sym_LT] = ACTIONS(2849),
    [anon_sym_GT] = ACTIONS(2847),
    [anon_sym_use] = ACTIONS(2847),
    [anon_sym_use_BANG] = ACTIONS(2849),
    [anon_sym_do_BANG] = ACTIONS(2849),
    [anon_sym_begin] = ACTIONS(2847),
    [anon_sym_LPAREN2] = ACTIONS(2847),
    [anon_sym_or] = ACTIONS(2847),
    [aux_sym_char_token1] = ACTIONS(2849),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2847),
    [anon_sym_DQUOTE] = ACTIONS(2847),
    [anon_sym_AT_DQUOTE] = ACTIONS(2849),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2849),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2849),
    [sym_bool] = ACTIONS(2847),
    [sym_unit] = ACTIONS(2849),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2847),
    [sym_op_identifier] = ACTIONS(2847),
    [anon_sym_PLUS] = ACTIONS(2847),
    [anon_sym_DASH] = ACTIONS(2847),
    [anon_sym_PLUS_DOT] = ACTIONS(2847),
    [anon_sym_DASH_DOT] = ACTIONS(2847),
    [anon_sym_PERCENT] = ACTIONS(2847),
    [anon_sym_AMP_AMP] = ACTIONS(2847),
    [anon_sym_TILDE] = ACTIONS(2849),
    [aux_sym_prefix_op_token1] = ACTIONS(2847),
    [aux_sym_infix_op_token1] = ACTIONS(2849),
    [aux_sym_infix_op_token2] = ACTIONS(2847),
    [anon_sym_PIPE_PIPE] = ACTIONS(2847),
    [anon_sym_BANG_EQ] = ACTIONS(2847),
    [anon_sym_COLON_EQ] = ACTIONS(2849),
    [anon_sym_DOLLAR] = ACTIONS(2847),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2847),
    [sym_int] = ACTIONS(2847),
    [sym_xint] = ACTIONS(2849),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2849),
    [sym__newline] = ACTIONS(2849),
  },
  [1749] = {
    [sym_block_comment] = STATE(1749),
    [sym_compiler_directive_decl] = STATE(1749),
    [sym_fsi_directive_decl] = STATE(1749),
    [sym_preproc_line] = STATE(1749),
    [sym_identifier] = ACTIONS(2783),
    [anon_sym_EQ] = ACTIONS(2785),
    [anon_sym_COLON] = ACTIONS(2783),
    [anon_sym_return] = ACTIONS(2783),
    [anon_sym_do] = ACTIONS(2783),
    [anon_sym_let] = ACTIONS(2783),
    [anon_sym_let_BANG] = ACTIONS(2785),
    [anon_sym_LPAREN] = ACTIONS(2783),
    [anon_sym_COMMA] = ACTIONS(2785),
    [anon_sym_null] = ACTIONS(2783),
    [anon_sym_QMARK] = ACTIONS(2783),
    [anon_sym_COLON_QMARK] = ACTIONS(2783),
    [anon_sym_COLON_COLON] = ACTIONS(2785),
    [anon_sym_AMP] = ACTIONS(2783),
    [anon_sym_LBRACK] = ACTIONS(2783),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2785),
    [anon_sym_LBRACE] = ACTIONS(2783),
    [anon_sym_LT_AT] = ACTIONS(2783),
    [anon_sym_LT_AT_AT] = ACTIONS(2783),
    [anon_sym_DOT] = ACTIONS(2783),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2785),
    [anon_sym_new] = ACTIONS(2783),
    [anon_sym_return_BANG] = ACTIONS(2785),
    [anon_sym_yield] = ACTIONS(2783),
    [anon_sym_yield_BANG] = ACTIONS(2785),
    [anon_sym_lazy] = ACTIONS(2783),
    [anon_sym_assert] = ACTIONS(2783),
    [anon_sym_upcast] = ACTIONS(2783),
    [anon_sym_downcast] = ACTIONS(2783),
    [anon_sym_COLON_GT] = ACTIONS(2785),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2785),
    [anon_sym_for] = ACTIONS(2783),
    [anon_sym_done] = ACTIONS(3928),
    [anon_sym_while] = ACTIONS(2783),
    [anon_sym_if] = ACTIONS(2783),
    [anon_sym_fun] = ACTIONS(2783),
    [anon_sym_try] = ACTIONS(2783),
    [anon_sym_match] = ACTIONS(2783),
    [anon_sym_match_BANG] = ACTIONS(2785),
    [anon_sym_function] = ACTIONS(2783),
    [anon_sym_LT_DASH] = ACTIONS(2783),
    [anon_sym_DOT_LBRACK] = ACTIONS(2785),
    [anon_sym_LT] = ACTIONS(2785),
    [anon_sym_GT] = ACTIONS(2783),
    [anon_sym_use] = ACTIONS(2783),
    [anon_sym_use_BANG] = ACTIONS(2785),
    [anon_sym_do_BANG] = ACTIONS(2785),
    [anon_sym_begin] = ACTIONS(2783),
    [anon_sym_LPAREN2] = ACTIONS(2783),
    [anon_sym_or] = ACTIONS(2783),
    [aux_sym_char_token1] = ACTIONS(2785),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2783),
    [anon_sym_DQUOTE] = ACTIONS(2783),
    [anon_sym_AT_DQUOTE] = ACTIONS(2785),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2785),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2785),
    [sym_bool] = ACTIONS(2783),
    [sym_unit] = ACTIONS(2785),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2783),
    [sym_op_identifier] = ACTIONS(2783),
    [anon_sym_PLUS] = ACTIONS(2783),
    [anon_sym_DASH] = ACTIONS(2783),
    [anon_sym_PLUS_DOT] = ACTIONS(2783),
    [anon_sym_DASH_DOT] = ACTIONS(2783),
    [anon_sym_PERCENT] = ACTIONS(2783),
    [anon_sym_AMP_AMP] = ACTIONS(2783),
    [anon_sym_TILDE] = ACTIONS(2785),
    [aux_sym_prefix_op_token1] = ACTIONS(2783),
    [aux_sym_infix_op_token1] = ACTIONS(2785),
    [aux_sym_infix_op_token2] = ACTIONS(2783),
    [anon_sym_PIPE_PIPE] = ACTIONS(2783),
    [anon_sym_BANG_EQ] = ACTIONS(2783),
    [anon_sym_COLON_EQ] = ACTIONS(2785),
    [anon_sym_DOLLAR] = ACTIONS(2783),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2783),
    [sym_int] = ACTIONS(2783),
    [sym_xint] = ACTIONS(2785),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2785),
    [sym__newline] = ACTIONS(2785),
  },
  [1750] = {
    [sym_block_comment] = STATE(1750),
    [sym_compiler_directive_decl] = STATE(1750),
    [sym_fsi_directive_decl] = STATE(1750),
    [sym_preproc_line] = STATE(1750),
    [sym_identifier] = ACTIONS(2867),
    [anon_sym_EQ] = ACTIONS(2869),
    [anon_sym_COLON] = ACTIONS(2867),
    [anon_sym_return] = ACTIONS(2867),
    [anon_sym_do] = ACTIONS(2867),
    [anon_sym_and] = ACTIONS(2867),
    [anon_sym_let] = ACTIONS(2867),
    [anon_sym_let_BANG] = ACTIONS(2869),
    [anon_sym_LPAREN] = ACTIONS(2867),
    [anon_sym_COMMA] = ACTIONS(2869),
    [anon_sym_null] = ACTIONS(2867),
    [anon_sym_QMARK] = ACTIONS(2867),
    [anon_sym_COLON_QMARK] = ACTIONS(2867),
    [anon_sym_COLON_COLON] = ACTIONS(2869),
    [anon_sym_AMP] = ACTIONS(2867),
    [anon_sym_LBRACK] = ACTIONS(2867),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2869),
    [anon_sym_LBRACE] = ACTIONS(2867),
    [anon_sym_LT_AT] = ACTIONS(2867),
    [anon_sym_LT_AT_AT] = ACTIONS(2867),
    [anon_sym_DOT] = ACTIONS(2867),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2869),
    [anon_sym_new] = ACTIONS(2867),
    [anon_sym_return_BANG] = ACTIONS(2869),
    [anon_sym_yield] = ACTIONS(2867),
    [anon_sym_yield_BANG] = ACTIONS(2869),
    [anon_sym_lazy] = ACTIONS(2867),
    [anon_sym_assert] = ACTIONS(2867),
    [anon_sym_upcast] = ACTIONS(2867),
    [anon_sym_downcast] = ACTIONS(2867),
    [anon_sym_COLON_GT] = ACTIONS(2869),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2869),
    [anon_sym_for] = ACTIONS(2867),
    [anon_sym_while] = ACTIONS(2867),
    [anon_sym_if] = ACTIONS(2867),
    [anon_sym_fun] = ACTIONS(2867),
    [anon_sym_try] = ACTIONS(2867),
    [anon_sym_match] = ACTIONS(2867),
    [anon_sym_match_BANG] = ACTIONS(2869),
    [anon_sym_function] = ACTIONS(2867),
    [anon_sym_LT_DASH] = ACTIONS(2867),
    [anon_sym_DOT_LBRACK] = ACTIONS(2869),
    [anon_sym_LT] = ACTIONS(2869),
    [anon_sym_use] = ACTIONS(2867),
    [anon_sym_use_BANG] = ACTIONS(2869),
    [anon_sym_do_BANG] = ACTIONS(2869),
    [anon_sym_begin] = ACTIONS(2867),
    [anon_sym_LPAREN2] = ACTIONS(2867),
    [anon_sym_or] = ACTIONS(2867),
    [aux_sym_char_token1] = ACTIONS(2869),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2867),
    [anon_sym_DQUOTE] = ACTIONS(2867),
    [anon_sym_AT_DQUOTE] = ACTIONS(2869),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2869),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2869),
    [sym_bool] = ACTIONS(2867),
    [sym_unit] = ACTIONS(2869),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2867),
    [sym_op_identifier] = ACTIONS(2867),
    [anon_sym_PLUS] = ACTIONS(2867),
    [anon_sym_DASH] = ACTIONS(2867),
    [anon_sym_PLUS_DOT] = ACTIONS(2867),
    [anon_sym_DASH_DOT] = ACTIONS(2867),
    [anon_sym_PERCENT] = ACTIONS(2867),
    [anon_sym_AMP_AMP] = ACTIONS(2867),
    [anon_sym_TILDE] = ACTIONS(2869),
    [aux_sym_prefix_op_token1] = ACTIONS(2867),
    [aux_sym_infix_op_token1] = ACTIONS(2869),
    [aux_sym_infix_op_token2] = ACTIONS(2867),
    [anon_sym_PIPE_PIPE] = ACTIONS(2867),
    [anon_sym_BANG_EQ] = ACTIONS(2867),
    [anon_sym_COLON_EQ] = ACTIONS(2869),
    [anon_sym_DOLLAR] = ACTIONS(2867),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2867),
    [sym_int] = ACTIONS(2867),
    [sym_xint] = ACTIONS(2869),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2869),
    [sym__newline] = ACTIONS(2869),
    [sym__dedent] = ACTIONS(2869),
  },
  [1751] = {
    [sym_block_comment] = STATE(1751),
    [sym_compiler_directive_decl] = STATE(1751),
    [sym_fsi_directive_decl] = STATE(1751),
    [sym_preproc_line] = STATE(1751),
    [sym_identifier] = ACTIONS(2867),
    [anon_sym_EQ] = ACTIONS(2869),
    [anon_sym_COLON] = ACTIONS(2867),
    [anon_sym_return] = ACTIONS(2867),
    [anon_sym_do] = ACTIONS(2867),
    [anon_sym_let] = ACTIONS(2867),
    [anon_sym_let_BANG] = ACTIONS(2869),
    [anon_sym_LPAREN] = ACTIONS(2867),
    [anon_sym_COMMA] = ACTIONS(2869),
    [anon_sym_null] = ACTIONS(2867),
    [anon_sym_QMARK] = ACTIONS(2867),
    [anon_sym_COLON_QMARK] = ACTIONS(2867),
    [anon_sym_COLON_COLON] = ACTIONS(2869),
    [anon_sym_AMP] = ACTIONS(2867),
    [anon_sym_LBRACK] = ACTIONS(2867),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2869),
    [anon_sym_LBRACE] = ACTIONS(2867),
    [anon_sym_LT_AT] = ACTIONS(2867),
    [anon_sym_LT_AT_AT] = ACTIONS(2867),
    [anon_sym_DOT] = ACTIONS(2867),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2869),
    [anon_sym_new] = ACTIONS(2867),
    [anon_sym_return_BANG] = ACTIONS(2869),
    [anon_sym_yield] = ACTIONS(2867),
    [anon_sym_yield_BANG] = ACTIONS(2869),
    [anon_sym_lazy] = ACTIONS(2867),
    [anon_sym_assert] = ACTIONS(2867),
    [anon_sym_upcast] = ACTIONS(2867),
    [anon_sym_downcast] = ACTIONS(2867),
    [anon_sym_COLON_GT] = ACTIONS(2869),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2869),
    [anon_sym_for] = ACTIONS(2867),
    [anon_sym_while] = ACTIONS(2867),
    [anon_sym_if] = ACTIONS(2867),
    [anon_sym_fun] = ACTIONS(2867),
    [anon_sym_try] = ACTIONS(2867),
    [anon_sym_match] = ACTIONS(2867),
    [anon_sym_match_BANG] = ACTIONS(2869),
    [anon_sym_function] = ACTIONS(2867),
    [anon_sym_LT_DASH] = ACTIONS(2867),
    [anon_sym_DOT_LBRACK] = ACTIONS(2869),
    [anon_sym_LT] = ACTIONS(2869),
    [anon_sym_use] = ACTIONS(2867),
    [anon_sym_use_BANG] = ACTIONS(2869),
    [anon_sym_do_BANG] = ACTIONS(2869),
    [anon_sym_begin] = ACTIONS(2867),
    [anon_sym_LPAREN2] = ACTIONS(2867),
    [anon_sym_or] = ACTIONS(2867),
    [aux_sym_char_token1] = ACTIONS(2869),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2867),
    [anon_sym_DQUOTE] = ACTIONS(2867),
    [anon_sym_AT_DQUOTE] = ACTIONS(2869),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2869),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2869),
    [sym_bool] = ACTIONS(2867),
    [sym_unit] = ACTIONS(2869),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2867),
    [sym_op_identifier] = ACTIONS(2867),
    [anon_sym_PLUS] = ACTIONS(2867),
    [anon_sym_DASH] = ACTIONS(2867),
    [anon_sym_PLUS_DOT] = ACTIONS(2867),
    [anon_sym_DASH_DOT] = ACTIONS(2867),
    [anon_sym_PERCENT] = ACTIONS(2867),
    [anon_sym_AMP_AMP] = ACTIONS(2867),
    [anon_sym_TILDE] = ACTIONS(2869),
    [aux_sym_prefix_op_token1] = ACTIONS(2867),
    [aux_sym_infix_op_token1] = ACTIONS(2869),
    [aux_sym_infix_op_token2] = ACTIONS(2867),
    [anon_sym_PIPE_PIPE] = ACTIONS(2867),
    [anon_sym_BANG_EQ] = ACTIONS(2867),
    [anon_sym_COLON_EQ] = ACTIONS(2869),
    [anon_sym_DOLLAR] = ACTIONS(2867),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2867),
    [sym_int] = ACTIONS(2867),
    [sym_xint] = ACTIONS(2869),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2869),
    [anon_sym_POUNDendif] = ACTIONS(2869),
    [anon_sym_POUNDelse] = ACTIONS(2869),
    [sym__newline] = ACTIONS(2869),
  },
  [1752] = {
    [sym_block_comment] = STATE(1752),
    [sym_compiler_directive_decl] = STATE(1752),
    [sym_fsi_directive_decl] = STATE(1752),
    [sym_preproc_line] = STATE(1752),
    [aux_sym_long_identifier_repeat1] = STATE(1910),
    [sym_identifier] = ACTIONS(2791),
    [anon_sym_EQ] = ACTIONS(2794),
    [anon_sym_COLON] = ACTIONS(2791),
    [anon_sym_return] = ACTIONS(2791),
    [anon_sym_do] = ACTIONS(2791),
    [anon_sym_let] = ACTIONS(2791),
    [anon_sym_let_BANG] = ACTIONS(2794),
    [anon_sym_LPAREN] = ACTIONS(2791),
    [anon_sym_COMMA] = ACTIONS(2794),
    [anon_sym_null] = ACTIONS(2791),
    [anon_sym_QMARK] = ACTIONS(2791),
    [anon_sym_COLON_QMARK] = ACTIONS(2791),
    [anon_sym_COLON_COLON] = ACTIONS(2794),
    [anon_sym_AMP] = ACTIONS(2791),
    [anon_sym_LBRACK] = ACTIONS(2791),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2794),
    [anon_sym_LBRACE] = ACTIONS(2791),
    [anon_sym_LT_AT] = ACTIONS(2791),
    [anon_sym_LT_AT_AT] = ACTIONS(2791),
    [anon_sym_DOT] = ACTIONS(4008),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2794),
    [anon_sym_new] = ACTIONS(2791),
    [anon_sym_return_BANG] = ACTIONS(2794),
    [anon_sym_yield] = ACTIONS(2791),
    [anon_sym_yield_BANG] = ACTIONS(2794),
    [anon_sym_lazy] = ACTIONS(2791),
    [anon_sym_assert] = ACTIONS(2791),
    [anon_sym_upcast] = ACTIONS(2791),
    [anon_sym_downcast] = ACTIONS(2791),
    [anon_sym_COLON_GT] = ACTIONS(2794),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2794),
    [anon_sym_for] = ACTIONS(2791),
    [anon_sym_while] = ACTIONS(2791),
    [anon_sym_if] = ACTIONS(2791),
    [anon_sym_fun] = ACTIONS(2791),
    [anon_sym_try] = ACTIONS(2791),
    [anon_sym_match] = ACTIONS(2791),
    [anon_sym_match_BANG] = ACTIONS(2794),
    [anon_sym_function] = ACTIONS(2791),
    [anon_sym_LT_DASH] = ACTIONS(2791),
    [anon_sym_DOT_LBRACK] = ACTIONS(2794),
    [anon_sym_LT] = ACTIONS(2794),
    [anon_sym_GT] = ACTIONS(2791),
    [anon_sym_use] = ACTIONS(2791),
    [anon_sym_use_BANG] = ACTIONS(2794),
    [anon_sym_do_BANG] = ACTIONS(2794),
    [anon_sym_begin] = ACTIONS(2791),
    [anon_sym_LPAREN2] = ACTIONS(2791),
    [anon_sym_or] = ACTIONS(2791),
    [aux_sym_char_token1] = ACTIONS(2794),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2791),
    [anon_sym_DQUOTE] = ACTIONS(2791),
    [anon_sym_AT_DQUOTE] = ACTIONS(2794),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2794),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2794),
    [sym_bool] = ACTIONS(2791),
    [sym_unit] = ACTIONS(2794),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2791),
    [sym_op_identifier] = ACTIONS(2791),
    [anon_sym_PLUS] = ACTIONS(2791),
    [anon_sym_DASH] = ACTIONS(2791),
    [anon_sym_PLUS_DOT] = ACTIONS(2791),
    [anon_sym_DASH_DOT] = ACTIONS(2791),
    [anon_sym_PERCENT] = ACTIONS(2791),
    [anon_sym_AMP_AMP] = ACTIONS(2791),
    [anon_sym_TILDE] = ACTIONS(2794),
    [aux_sym_prefix_op_token1] = ACTIONS(2791),
    [aux_sym_infix_op_token1] = ACTIONS(2794),
    [aux_sym_infix_op_token2] = ACTIONS(2791),
    [anon_sym_PIPE_PIPE] = ACTIONS(2791),
    [anon_sym_BANG_EQ] = ACTIONS(2791),
    [anon_sym_COLON_EQ] = ACTIONS(2794),
    [anon_sym_DOLLAR] = ACTIONS(2791),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2791),
    [sym_int] = ACTIONS(2791),
    [sym_xint] = ACTIONS(2794),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2794),
    [sym__newline] = ACTIONS(2794),
  },
  [1753] = {
    [sym_block_comment] = STATE(1753),
    [sym_compiler_directive_decl] = STATE(1753),
    [sym_fsi_directive_decl] = STATE(1753),
    [sym_preproc_line] = STATE(1753),
    [sym_identifier] = ACTIONS(2863),
    [anon_sym_EQ] = ACTIONS(2865),
    [anon_sym_COLON] = ACTIONS(2863),
    [anon_sym_return] = ACTIONS(2863),
    [anon_sym_do] = ACTIONS(2863),
    [anon_sym_let] = ACTIONS(2863),
    [anon_sym_let_BANG] = ACTIONS(2865),
    [anon_sym_as] = ACTIONS(2863),
    [anon_sym_LPAREN] = ACTIONS(2863),
    [anon_sym_COMMA] = ACTIONS(2865),
    [anon_sym_null] = ACTIONS(2863),
    [anon_sym_QMARK] = ACTIONS(2863),
    [anon_sym_COLON_QMARK] = ACTIONS(2863),
    [anon_sym_COLON_COLON] = ACTIONS(2865),
    [anon_sym_AMP] = ACTIONS(2863),
    [anon_sym_LBRACK] = ACTIONS(2863),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2865),
    [anon_sym_LBRACE] = ACTIONS(2863),
    [anon_sym_LT_AT] = ACTIONS(2863),
    [anon_sym_LT_AT_AT] = ACTIONS(2863),
    [anon_sym_DOT] = ACTIONS(2863),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2865),
    [anon_sym_new] = ACTIONS(2863),
    [anon_sym_with] = ACTIONS(2863),
    [anon_sym_return_BANG] = ACTIONS(2865),
    [anon_sym_yield] = ACTIONS(2863),
    [anon_sym_yield_BANG] = ACTIONS(2865),
    [anon_sym_lazy] = ACTIONS(2863),
    [anon_sym_assert] = ACTIONS(2863),
    [anon_sym_upcast] = ACTIONS(2863),
    [anon_sym_downcast] = ACTIONS(2863),
    [anon_sym_COLON_GT] = ACTIONS(2865),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2865),
    [anon_sym_for] = ACTIONS(2863),
    [anon_sym_while] = ACTIONS(2863),
    [anon_sym_if] = ACTIONS(2863),
    [anon_sym_fun] = ACTIONS(2863),
    [anon_sym_try] = ACTIONS(2863),
    [anon_sym_match] = ACTIONS(2863),
    [anon_sym_match_BANG] = ACTIONS(2865),
    [anon_sym_function] = ACTIONS(2863),
    [anon_sym_LT_DASH] = ACTIONS(2863),
    [anon_sym_DOT_LBRACK] = ACTIONS(2865),
    [anon_sym_LT] = ACTIONS(2865),
    [anon_sym_use] = ACTIONS(2863),
    [anon_sym_use_BANG] = ACTIONS(2865),
    [anon_sym_do_BANG] = ACTIONS(2865),
    [anon_sym_begin] = ACTIONS(2863),
    [anon_sym_LPAREN2] = ACTIONS(2863),
    [anon_sym_or] = ACTIONS(2863),
    [aux_sym_char_token1] = ACTIONS(2865),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2863),
    [anon_sym_DQUOTE] = ACTIONS(2863),
    [anon_sym_AT_DQUOTE] = ACTIONS(2865),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2865),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2865),
    [sym_bool] = ACTIONS(2863),
    [sym_unit] = ACTIONS(2865),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2863),
    [sym_op_identifier] = ACTIONS(2863),
    [anon_sym_PLUS] = ACTIONS(2863),
    [anon_sym_DASH] = ACTIONS(2863),
    [anon_sym_PLUS_DOT] = ACTIONS(2863),
    [anon_sym_DASH_DOT] = ACTIONS(2863),
    [anon_sym_PERCENT] = ACTIONS(2863),
    [anon_sym_AMP_AMP] = ACTIONS(2863),
    [anon_sym_TILDE] = ACTIONS(2865),
    [aux_sym_prefix_op_token1] = ACTIONS(2863),
    [aux_sym_infix_op_token1] = ACTIONS(2865),
    [aux_sym_infix_op_token2] = ACTIONS(2863),
    [anon_sym_PIPE_PIPE] = ACTIONS(2863),
    [anon_sym_BANG_EQ] = ACTIONS(2863),
    [anon_sym_COLON_EQ] = ACTIONS(2865),
    [anon_sym_DOLLAR] = ACTIONS(2863),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2863),
    [sym_int] = ACTIONS(2863),
    [sym_xint] = ACTIONS(2865),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2865),
    [sym__newline] = ACTIONS(2865),
  },
  [1754] = {
    [sym_block_comment] = STATE(1754),
    [sym_compiler_directive_decl] = STATE(1754),
    [sym_fsi_directive_decl] = STATE(1754),
    [sym_preproc_line] = STATE(1754),
    [sym_identifier] = ACTIONS(3095),
    [anon_sym_EQ] = ACTIONS(3097),
    [anon_sym_COLON] = ACTIONS(3095),
    [anon_sym_return] = ACTIONS(3095),
    [anon_sym_do] = ACTIONS(3095),
    [anon_sym_let] = ACTIONS(3095),
    [anon_sym_let_BANG] = ACTIONS(3097),
    [anon_sym_as] = ACTIONS(3095),
    [anon_sym_LPAREN] = ACTIONS(3095),
    [anon_sym_COMMA] = ACTIONS(3097),
    [anon_sym_null] = ACTIONS(3095),
    [anon_sym_QMARK] = ACTIONS(3095),
    [anon_sym_COLON_QMARK] = ACTIONS(3095),
    [anon_sym_COLON_COLON] = ACTIONS(3097),
    [anon_sym_AMP] = ACTIONS(3095),
    [anon_sym_LBRACK] = ACTIONS(3095),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3097),
    [anon_sym_LBRACE] = ACTIONS(3095),
    [anon_sym_LT_AT] = ACTIONS(3095),
    [anon_sym_LT_AT_AT] = ACTIONS(3095),
    [anon_sym_DOT] = ACTIONS(3095),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3097),
    [anon_sym_new] = ACTIONS(3095),
    [anon_sym_with] = ACTIONS(3095),
    [anon_sym_return_BANG] = ACTIONS(3097),
    [anon_sym_yield] = ACTIONS(3095),
    [anon_sym_yield_BANG] = ACTIONS(3097),
    [anon_sym_lazy] = ACTIONS(3095),
    [anon_sym_assert] = ACTIONS(3095),
    [anon_sym_upcast] = ACTIONS(3095),
    [anon_sym_downcast] = ACTIONS(3095),
    [anon_sym_COLON_GT] = ACTIONS(3097),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3097),
    [anon_sym_for] = ACTIONS(3095),
    [anon_sym_while] = ACTIONS(3095),
    [anon_sym_if] = ACTIONS(3095),
    [anon_sym_fun] = ACTIONS(3095),
    [anon_sym_try] = ACTIONS(3095),
    [anon_sym_match] = ACTIONS(3095),
    [anon_sym_match_BANG] = ACTIONS(3097),
    [anon_sym_function] = ACTIONS(3095),
    [anon_sym_LT_DASH] = ACTIONS(3095),
    [anon_sym_DOT_LBRACK] = ACTIONS(3097),
    [anon_sym_LT] = ACTIONS(3097),
    [anon_sym_use] = ACTIONS(3095),
    [anon_sym_use_BANG] = ACTIONS(3097),
    [anon_sym_do_BANG] = ACTIONS(3097),
    [anon_sym_begin] = ACTIONS(3095),
    [anon_sym_LPAREN2] = ACTIONS(3095),
    [anon_sym_or] = ACTIONS(3095),
    [aux_sym_char_token1] = ACTIONS(3097),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3095),
    [anon_sym_DQUOTE] = ACTIONS(3095),
    [anon_sym_AT_DQUOTE] = ACTIONS(3097),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3097),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3097),
    [sym_bool] = ACTIONS(3095),
    [sym_unit] = ACTIONS(3097),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3095),
    [sym_op_identifier] = ACTIONS(3095),
    [anon_sym_PLUS] = ACTIONS(3095),
    [anon_sym_DASH] = ACTIONS(3095),
    [anon_sym_PLUS_DOT] = ACTIONS(3095),
    [anon_sym_DASH_DOT] = ACTIONS(3095),
    [anon_sym_PERCENT] = ACTIONS(3095),
    [anon_sym_AMP_AMP] = ACTIONS(3095),
    [anon_sym_TILDE] = ACTIONS(3097),
    [aux_sym_prefix_op_token1] = ACTIONS(3095),
    [aux_sym_infix_op_token1] = ACTIONS(3097),
    [aux_sym_infix_op_token2] = ACTIONS(3095),
    [anon_sym_PIPE_PIPE] = ACTIONS(3095),
    [anon_sym_BANG_EQ] = ACTIONS(3095),
    [anon_sym_COLON_EQ] = ACTIONS(3097),
    [anon_sym_DOLLAR] = ACTIONS(3095),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3095),
    [sym_int] = ACTIONS(3095),
    [sym_xint] = ACTIONS(3097),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3097),
    [sym__newline] = ACTIONS(3097),
  },
  [1755] = {
    [sym_block_comment] = STATE(1755),
    [sym_compiler_directive_decl] = STATE(1755),
    [sym_fsi_directive_decl] = STATE(1755),
    [sym_preproc_line] = STATE(1755),
    [aux_sym_sequential_expression_repeat1] = STATE(1802),
    [sym_identifier] = ACTIONS(2847),
    [anon_sym_EQ] = ACTIONS(2849),
    [anon_sym_COLON] = ACTIONS(2847),
    [anon_sym_return] = ACTIONS(2847),
    [anon_sym_do] = ACTIONS(2847),
    [anon_sym_let] = ACTIONS(2847),
    [anon_sym_let_BANG] = ACTIONS(2849),
    [anon_sym_LPAREN] = ACTIONS(2847),
    [anon_sym_COMMA] = ACTIONS(2849),
    [anon_sym_null] = ACTIONS(2847),
    [anon_sym_QMARK] = ACTIONS(2847),
    [anon_sym_COLON_QMARK] = ACTIONS(2847),
    [anon_sym_COLON_COLON] = ACTIONS(2849),
    [anon_sym_AMP] = ACTIONS(2847),
    [anon_sym_LBRACK] = ACTIONS(2847),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2849),
    [anon_sym_LBRACE] = ACTIONS(2847),
    [anon_sym_LT_AT] = ACTIONS(2847),
    [anon_sym_AT_GT] = ACTIONS(2847),
    [anon_sym_LT_AT_AT] = ACTIONS(2847),
    [anon_sym_DOT] = ACTIONS(2847),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2849),
    [anon_sym_new] = ACTIONS(2847),
    [anon_sym_return_BANG] = ACTIONS(2849),
    [anon_sym_yield] = ACTIONS(2847),
    [anon_sym_yield_BANG] = ACTIONS(2849),
    [anon_sym_lazy] = ACTIONS(2847),
    [anon_sym_assert] = ACTIONS(2847),
    [anon_sym_upcast] = ACTIONS(2847),
    [anon_sym_downcast] = ACTIONS(2847),
    [anon_sym_COLON_GT] = ACTIONS(2849),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2849),
    [anon_sym_for] = ACTIONS(2847),
    [anon_sym_while] = ACTIONS(2847),
    [anon_sym_if] = ACTIONS(2847),
    [anon_sym_fun] = ACTIONS(2847),
    [anon_sym_try] = ACTIONS(2847),
    [anon_sym_match] = ACTIONS(2847),
    [anon_sym_match_BANG] = ACTIONS(2849),
    [anon_sym_function] = ACTIONS(2847),
    [anon_sym_LT_DASH] = ACTIONS(2847),
    [anon_sym_DOT_LBRACK] = ACTIONS(2849),
    [anon_sym_LT] = ACTIONS(2849),
    [anon_sym_use] = ACTIONS(2847),
    [anon_sym_use_BANG] = ACTIONS(2849),
    [anon_sym_do_BANG] = ACTIONS(2849),
    [anon_sym_begin] = ACTIONS(2847),
    [anon_sym_LPAREN2] = ACTIONS(2847),
    [anon_sym_or] = ACTIONS(2847),
    [aux_sym_char_token1] = ACTIONS(2849),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2847),
    [anon_sym_DQUOTE] = ACTIONS(2847),
    [anon_sym_AT_DQUOTE] = ACTIONS(2849),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2849),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2849),
    [sym_bool] = ACTIONS(2847),
    [sym_unit] = ACTIONS(2849),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2847),
    [sym_op_identifier] = ACTIONS(2847),
    [anon_sym_PLUS] = ACTIONS(2847),
    [anon_sym_DASH] = ACTIONS(2847),
    [anon_sym_PLUS_DOT] = ACTIONS(2847),
    [anon_sym_DASH_DOT] = ACTIONS(2847),
    [anon_sym_PERCENT] = ACTIONS(2847),
    [anon_sym_AMP_AMP] = ACTIONS(2847),
    [anon_sym_TILDE] = ACTIONS(2849),
    [aux_sym_prefix_op_token1] = ACTIONS(2847),
    [aux_sym_infix_op_token1] = ACTIONS(2849),
    [aux_sym_infix_op_token2] = ACTIONS(2847),
    [anon_sym_PIPE_PIPE] = ACTIONS(2847),
    [anon_sym_BANG_EQ] = ACTIONS(2847),
    [anon_sym_COLON_EQ] = ACTIONS(2849),
    [anon_sym_DOLLAR] = ACTIONS(2847),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2847),
    [sym_int] = ACTIONS(2847),
    [sym_xint] = ACTIONS(2849),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2849),
    [sym__newline] = ACTIONS(2849),
  },
  [1756] = {
    [sym_block_comment] = STATE(1756),
    [sym_compiler_directive_decl] = STATE(1756),
    [sym_fsi_directive_decl] = STATE(1756),
    [sym_preproc_line] = STATE(1756),
    [sym_identifier] = ACTIONS(3055),
    [anon_sym_EQ] = ACTIONS(3057),
    [anon_sym_COLON] = ACTIONS(3055),
    [anon_sym_return] = ACTIONS(3055),
    [anon_sym_do] = ACTIONS(3055),
    [anon_sym_and] = ACTIONS(3055),
    [anon_sym_let] = ACTIONS(3055),
    [anon_sym_let_BANG] = ACTIONS(3057),
    [anon_sym_LPAREN] = ACTIONS(3055),
    [anon_sym_COMMA] = ACTIONS(3057),
    [anon_sym_null] = ACTIONS(3055),
    [anon_sym_QMARK] = ACTIONS(3055),
    [anon_sym_COLON_QMARK] = ACTIONS(3055),
    [anon_sym_COLON_COLON] = ACTIONS(3057),
    [anon_sym_AMP] = ACTIONS(3055),
    [anon_sym_LBRACK] = ACTIONS(3055),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3057),
    [anon_sym_LBRACE] = ACTIONS(3055),
    [anon_sym_LT_AT] = ACTIONS(3055),
    [anon_sym_LT_AT_AT] = ACTIONS(3055),
    [anon_sym_DOT] = ACTIONS(3055),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3057),
    [anon_sym_new] = ACTIONS(3055),
    [anon_sym_return_BANG] = ACTIONS(3057),
    [anon_sym_yield] = ACTIONS(3055),
    [anon_sym_yield_BANG] = ACTIONS(3057),
    [anon_sym_lazy] = ACTIONS(3055),
    [anon_sym_assert] = ACTIONS(3055),
    [anon_sym_upcast] = ACTIONS(3055),
    [anon_sym_downcast] = ACTIONS(3055),
    [anon_sym_COLON_GT] = ACTIONS(3057),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3057),
    [anon_sym_for] = ACTIONS(3055),
    [anon_sym_while] = ACTIONS(3055),
    [anon_sym_if] = ACTIONS(3055),
    [anon_sym_fun] = ACTIONS(3055),
    [anon_sym_try] = ACTIONS(3055),
    [anon_sym_match] = ACTIONS(3055),
    [anon_sym_match_BANG] = ACTIONS(3057),
    [anon_sym_function] = ACTIONS(3055),
    [anon_sym_LT_DASH] = ACTIONS(3055),
    [anon_sym_DOT_LBRACK] = ACTIONS(3057),
    [anon_sym_LT] = ACTIONS(3057),
    [anon_sym_use] = ACTIONS(3055),
    [anon_sym_use_BANG] = ACTIONS(3057),
    [anon_sym_do_BANG] = ACTIONS(3057),
    [anon_sym_begin] = ACTIONS(3055),
    [anon_sym_LPAREN2] = ACTIONS(3055),
    [anon_sym_or] = ACTIONS(3055),
    [aux_sym_char_token1] = ACTIONS(3057),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3055),
    [anon_sym_DQUOTE] = ACTIONS(3055),
    [anon_sym_AT_DQUOTE] = ACTIONS(3057),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3057),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3057),
    [sym_bool] = ACTIONS(3055),
    [sym_unit] = ACTIONS(3057),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3055),
    [sym_op_identifier] = ACTIONS(3055),
    [anon_sym_PLUS] = ACTIONS(3055),
    [anon_sym_DASH] = ACTIONS(3055),
    [anon_sym_PLUS_DOT] = ACTIONS(3055),
    [anon_sym_DASH_DOT] = ACTIONS(3055),
    [anon_sym_PERCENT] = ACTIONS(3055),
    [anon_sym_AMP_AMP] = ACTIONS(3055),
    [anon_sym_TILDE] = ACTIONS(3057),
    [aux_sym_prefix_op_token1] = ACTIONS(3055),
    [aux_sym_infix_op_token1] = ACTIONS(3057),
    [aux_sym_infix_op_token2] = ACTIONS(3055),
    [anon_sym_PIPE_PIPE] = ACTIONS(3055),
    [anon_sym_BANG_EQ] = ACTIONS(3055),
    [anon_sym_COLON_EQ] = ACTIONS(3057),
    [anon_sym_DOLLAR] = ACTIONS(3055),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3055),
    [sym_int] = ACTIONS(3055),
    [sym_xint] = ACTIONS(3057),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3057),
    [sym__newline] = ACTIONS(3057),
    [sym__dedent] = ACTIONS(3057),
  },
  [1757] = {
    [sym_block_comment] = STATE(1757),
    [sym_compiler_directive_decl] = STATE(1757),
    [sym_fsi_directive_decl] = STATE(1757),
    [sym_preproc_line] = STATE(1757),
    [sym_identifier] = ACTIONS(2831),
    [anon_sym_EQ] = ACTIONS(2833),
    [anon_sym_COLON] = ACTIONS(2831),
    [anon_sym_return] = ACTIONS(2831),
    [anon_sym_do] = ACTIONS(2831),
    [anon_sym_and] = ACTIONS(2831),
    [anon_sym_let] = ACTIONS(2831),
    [anon_sym_let_BANG] = ACTIONS(2833),
    [anon_sym_LPAREN] = ACTIONS(2831),
    [anon_sym_COMMA] = ACTIONS(2833),
    [anon_sym_null] = ACTIONS(2831),
    [anon_sym_QMARK] = ACTIONS(2831),
    [anon_sym_COLON_QMARK] = ACTIONS(2831),
    [anon_sym_COLON_COLON] = ACTIONS(2833),
    [anon_sym_AMP] = ACTIONS(2831),
    [anon_sym_LBRACK] = ACTIONS(2831),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2833),
    [anon_sym_LBRACE] = ACTIONS(2831),
    [anon_sym_LT_AT] = ACTIONS(2831),
    [anon_sym_LT_AT_AT] = ACTIONS(2831),
    [anon_sym_DOT] = ACTIONS(2831),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2833),
    [anon_sym_new] = ACTIONS(2831),
    [anon_sym_return_BANG] = ACTIONS(2833),
    [anon_sym_yield] = ACTIONS(2831),
    [anon_sym_yield_BANG] = ACTIONS(2833),
    [anon_sym_lazy] = ACTIONS(2831),
    [anon_sym_assert] = ACTIONS(2831),
    [anon_sym_upcast] = ACTIONS(2831),
    [anon_sym_downcast] = ACTIONS(2831),
    [anon_sym_COLON_GT] = ACTIONS(2833),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2833),
    [anon_sym_for] = ACTIONS(2831),
    [anon_sym_while] = ACTIONS(2831),
    [anon_sym_if] = ACTIONS(2831),
    [anon_sym_fun] = ACTIONS(2831),
    [anon_sym_try] = ACTIONS(2831),
    [anon_sym_match] = ACTIONS(2831),
    [anon_sym_match_BANG] = ACTIONS(2833),
    [anon_sym_function] = ACTIONS(2831),
    [anon_sym_LT_DASH] = ACTIONS(2831),
    [anon_sym_DOT_LBRACK] = ACTIONS(2833),
    [anon_sym_LT] = ACTIONS(2833),
    [anon_sym_use] = ACTIONS(2831),
    [anon_sym_use_BANG] = ACTIONS(2833),
    [anon_sym_do_BANG] = ACTIONS(2833),
    [anon_sym_begin] = ACTIONS(2831),
    [anon_sym_LPAREN2] = ACTIONS(2831),
    [anon_sym_or] = ACTIONS(2831),
    [aux_sym_char_token1] = ACTIONS(2833),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2831),
    [anon_sym_DQUOTE] = ACTIONS(2831),
    [anon_sym_AT_DQUOTE] = ACTIONS(2833),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2833),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2833),
    [sym_bool] = ACTIONS(2831),
    [sym_unit] = ACTIONS(2833),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2831),
    [sym_op_identifier] = ACTIONS(2831),
    [anon_sym_PLUS] = ACTIONS(2831),
    [anon_sym_DASH] = ACTIONS(2831),
    [anon_sym_PLUS_DOT] = ACTIONS(2831),
    [anon_sym_DASH_DOT] = ACTIONS(2831),
    [anon_sym_PERCENT] = ACTIONS(2831),
    [anon_sym_AMP_AMP] = ACTIONS(2831),
    [anon_sym_TILDE] = ACTIONS(2833),
    [aux_sym_prefix_op_token1] = ACTIONS(2831),
    [aux_sym_infix_op_token1] = ACTIONS(2833),
    [aux_sym_infix_op_token2] = ACTIONS(2831),
    [anon_sym_PIPE_PIPE] = ACTIONS(2831),
    [anon_sym_BANG_EQ] = ACTIONS(2831),
    [anon_sym_COLON_EQ] = ACTIONS(2833),
    [anon_sym_DOLLAR] = ACTIONS(2831),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2831),
    [sym_int] = ACTIONS(2831),
    [sym_xint] = ACTIONS(2833),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2833),
    [sym__newline] = ACTIONS(2833),
    [sym__dedent] = ACTIONS(2833),
  },
  [1758] = {
    [sym_block_comment] = STATE(1758),
    [sym_compiler_directive_decl] = STATE(1758),
    [sym_fsi_directive_decl] = STATE(1758),
    [sym_preproc_line] = STATE(1758),
    [sym_identifier] = ACTIONS(3067),
    [anon_sym_EQ] = ACTIONS(3069),
    [anon_sym_COLON] = ACTIONS(3067),
    [anon_sym_return] = ACTIONS(3067),
    [anon_sym_do] = ACTIONS(3067),
    [anon_sym_and] = ACTIONS(3067),
    [anon_sym_let] = ACTIONS(3067),
    [anon_sym_let_BANG] = ACTIONS(3069),
    [anon_sym_LPAREN] = ACTIONS(3067),
    [anon_sym_COMMA] = ACTIONS(3069),
    [anon_sym_null] = ACTIONS(3067),
    [anon_sym_QMARK] = ACTIONS(3067),
    [anon_sym_COLON_QMARK] = ACTIONS(3067),
    [anon_sym_COLON_COLON] = ACTIONS(3069),
    [anon_sym_AMP] = ACTIONS(3067),
    [anon_sym_LBRACK] = ACTIONS(3067),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3069),
    [anon_sym_LBRACE] = ACTIONS(3067),
    [anon_sym_LT_AT] = ACTIONS(3067),
    [anon_sym_LT_AT_AT] = ACTIONS(3067),
    [anon_sym_DOT] = ACTIONS(3067),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3069),
    [anon_sym_new] = ACTIONS(3067),
    [anon_sym_return_BANG] = ACTIONS(3069),
    [anon_sym_yield] = ACTIONS(3067),
    [anon_sym_yield_BANG] = ACTIONS(3069),
    [anon_sym_lazy] = ACTIONS(3067),
    [anon_sym_assert] = ACTIONS(3067),
    [anon_sym_upcast] = ACTIONS(3067),
    [anon_sym_downcast] = ACTIONS(3067),
    [anon_sym_COLON_GT] = ACTIONS(3069),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3069),
    [anon_sym_for] = ACTIONS(3067),
    [anon_sym_while] = ACTIONS(3067),
    [anon_sym_if] = ACTIONS(3067),
    [anon_sym_fun] = ACTIONS(3067),
    [anon_sym_try] = ACTIONS(3067),
    [anon_sym_match] = ACTIONS(3067),
    [anon_sym_match_BANG] = ACTIONS(3069),
    [anon_sym_function] = ACTIONS(3067),
    [anon_sym_LT_DASH] = ACTIONS(3067),
    [anon_sym_DOT_LBRACK] = ACTIONS(3069),
    [anon_sym_LT] = ACTIONS(3069),
    [anon_sym_use] = ACTIONS(3067),
    [anon_sym_use_BANG] = ACTIONS(3069),
    [anon_sym_do_BANG] = ACTIONS(3069),
    [anon_sym_begin] = ACTIONS(3067),
    [anon_sym_LPAREN2] = ACTIONS(3067),
    [anon_sym_or] = ACTIONS(3067),
    [aux_sym_char_token1] = ACTIONS(3069),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3067),
    [anon_sym_DQUOTE] = ACTIONS(3067),
    [anon_sym_AT_DQUOTE] = ACTIONS(3069),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3069),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3069),
    [sym_bool] = ACTIONS(3067),
    [sym_unit] = ACTIONS(3069),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3067),
    [sym_op_identifier] = ACTIONS(3067),
    [anon_sym_PLUS] = ACTIONS(3067),
    [anon_sym_DASH] = ACTIONS(3067),
    [anon_sym_PLUS_DOT] = ACTIONS(3067),
    [anon_sym_DASH_DOT] = ACTIONS(3067),
    [anon_sym_PERCENT] = ACTIONS(3067),
    [anon_sym_AMP_AMP] = ACTIONS(3067),
    [anon_sym_TILDE] = ACTIONS(3069),
    [aux_sym_prefix_op_token1] = ACTIONS(3067),
    [aux_sym_infix_op_token1] = ACTIONS(3069),
    [aux_sym_infix_op_token2] = ACTIONS(3067),
    [anon_sym_PIPE_PIPE] = ACTIONS(3067),
    [anon_sym_BANG_EQ] = ACTIONS(3067),
    [anon_sym_COLON_EQ] = ACTIONS(3069),
    [anon_sym_DOLLAR] = ACTIONS(3067),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3067),
    [sym_int] = ACTIONS(3067),
    [sym_xint] = ACTIONS(3069),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3069),
    [sym__newline] = ACTIONS(3069),
    [sym__dedent] = ACTIONS(3069),
  },
  [1759] = {
    [sym_block_comment] = STATE(1759),
    [sym_compiler_directive_decl] = STATE(1759),
    [sym_fsi_directive_decl] = STATE(1759),
    [sym_preproc_line] = STATE(1759),
    [sym_identifier] = ACTIONS(3071),
    [anon_sym_EQ] = ACTIONS(3073),
    [anon_sym_COLON] = ACTIONS(3071),
    [anon_sym_return] = ACTIONS(3071),
    [anon_sym_do] = ACTIONS(3071),
    [anon_sym_and] = ACTIONS(3071),
    [anon_sym_let] = ACTIONS(3071),
    [anon_sym_let_BANG] = ACTIONS(3073),
    [anon_sym_LPAREN] = ACTIONS(3071),
    [anon_sym_COMMA] = ACTIONS(3073),
    [anon_sym_null] = ACTIONS(3071),
    [anon_sym_QMARK] = ACTIONS(3071),
    [anon_sym_COLON_QMARK] = ACTIONS(3071),
    [anon_sym_COLON_COLON] = ACTIONS(3073),
    [anon_sym_AMP] = ACTIONS(3071),
    [anon_sym_LBRACK] = ACTIONS(3071),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3073),
    [anon_sym_LBRACE] = ACTIONS(3071),
    [anon_sym_LT_AT] = ACTIONS(3071),
    [anon_sym_LT_AT_AT] = ACTIONS(3071),
    [anon_sym_DOT] = ACTIONS(3071),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3073),
    [anon_sym_new] = ACTIONS(3071),
    [anon_sym_return_BANG] = ACTIONS(3073),
    [anon_sym_yield] = ACTIONS(3071),
    [anon_sym_yield_BANG] = ACTIONS(3073),
    [anon_sym_lazy] = ACTIONS(3071),
    [anon_sym_assert] = ACTIONS(3071),
    [anon_sym_upcast] = ACTIONS(3071),
    [anon_sym_downcast] = ACTIONS(3071),
    [anon_sym_COLON_GT] = ACTIONS(3073),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3073),
    [anon_sym_for] = ACTIONS(3071),
    [anon_sym_while] = ACTIONS(3071),
    [anon_sym_if] = ACTIONS(3071),
    [anon_sym_fun] = ACTIONS(3071),
    [anon_sym_try] = ACTIONS(3071),
    [anon_sym_match] = ACTIONS(3071),
    [anon_sym_match_BANG] = ACTIONS(3073),
    [anon_sym_function] = ACTIONS(3071),
    [anon_sym_LT_DASH] = ACTIONS(3071),
    [anon_sym_DOT_LBRACK] = ACTIONS(3073),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_use] = ACTIONS(3071),
    [anon_sym_use_BANG] = ACTIONS(3073),
    [anon_sym_do_BANG] = ACTIONS(3073),
    [anon_sym_begin] = ACTIONS(3071),
    [anon_sym_LPAREN2] = ACTIONS(3071),
    [anon_sym_or] = ACTIONS(3071),
    [aux_sym_char_token1] = ACTIONS(3073),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3071),
    [anon_sym_DQUOTE] = ACTIONS(3071),
    [anon_sym_AT_DQUOTE] = ACTIONS(3073),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3073),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3073),
    [sym_bool] = ACTIONS(3071),
    [sym_unit] = ACTIONS(3073),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3071),
    [sym_op_identifier] = ACTIONS(3071),
    [anon_sym_PLUS] = ACTIONS(3071),
    [anon_sym_DASH] = ACTIONS(3071),
    [anon_sym_PLUS_DOT] = ACTIONS(3071),
    [anon_sym_DASH_DOT] = ACTIONS(3071),
    [anon_sym_PERCENT] = ACTIONS(3071),
    [anon_sym_AMP_AMP] = ACTIONS(3071),
    [anon_sym_TILDE] = ACTIONS(3073),
    [aux_sym_prefix_op_token1] = ACTIONS(3071),
    [aux_sym_infix_op_token1] = ACTIONS(3073),
    [aux_sym_infix_op_token2] = ACTIONS(3071),
    [anon_sym_PIPE_PIPE] = ACTIONS(3071),
    [anon_sym_BANG_EQ] = ACTIONS(3071),
    [anon_sym_COLON_EQ] = ACTIONS(3073),
    [anon_sym_DOLLAR] = ACTIONS(3071),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3071),
    [sym_int] = ACTIONS(3071),
    [sym_xint] = ACTIONS(3073),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3073),
    [sym__newline] = ACTIONS(3073),
    [sym__dedent] = ACTIONS(3073),
  },
  [1760] = {
    [sym_block_comment] = STATE(1760),
    [sym_compiler_directive_decl] = STATE(1760),
    [sym_fsi_directive_decl] = STATE(1760),
    [sym_preproc_line] = STATE(1760),
    [sym_identifier] = ACTIONS(3075),
    [anon_sym_EQ] = ACTIONS(3077),
    [anon_sym_COLON] = ACTIONS(3075),
    [anon_sym_return] = ACTIONS(3075),
    [anon_sym_do] = ACTIONS(3075),
    [anon_sym_and] = ACTIONS(3075),
    [anon_sym_let] = ACTIONS(3075),
    [anon_sym_let_BANG] = ACTIONS(3077),
    [anon_sym_LPAREN] = ACTIONS(3075),
    [anon_sym_COMMA] = ACTIONS(3077),
    [anon_sym_null] = ACTIONS(3075),
    [anon_sym_QMARK] = ACTIONS(3075),
    [anon_sym_COLON_QMARK] = ACTIONS(3075),
    [anon_sym_COLON_COLON] = ACTIONS(3077),
    [anon_sym_AMP] = ACTIONS(3075),
    [anon_sym_LBRACK] = ACTIONS(3075),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3077),
    [anon_sym_LBRACE] = ACTIONS(3075),
    [anon_sym_LT_AT] = ACTIONS(3075),
    [anon_sym_LT_AT_AT] = ACTIONS(3075),
    [anon_sym_DOT] = ACTIONS(3075),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3077),
    [anon_sym_new] = ACTIONS(3075),
    [anon_sym_return_BANG] = ACTIONS(3077),
    [anon_sym_yield] = ACTIONS(3075),
    [anon_sym_yield_BANG] = ACTIONS(3077),
    [anon_sym_lazy] = ACTIONS(3075),
    [anon_sym_assert] = ACTIONS(3075),
    [anon_sym_upcast] = ACTIONS(3075),
    [anon_sym_downcast] = ACTIONS(3075),
    [anon_sym_COLON_GT] = ACTIONS(3077),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3077),
    [anon_sym_for] = ACTIONS(3075),
    [anon_sym_while] = ACTIONS(3075),
    [anon_sym_if] = ACTIONS(3075),
    [anon_sym_fun] = ACTIONS(3075),
    [anon_sym_try] = ACTIONS(3075),
    [anon_sym_match] = ACTIONS(3075),
    [anon_sym_match_BANG] = ACTIONS(3077),
    [anon_sym_function] = ACTIONS(3075),
    [anon_sym_LT_DASH] = ACTIONS(3075),
    [anon_sym_DOT_LBRACK] = ACTIONS(3077),
    [anon_sym_LT] = ACTIONS(3077),
    [anon_sym_use] = ACTIONS(3075),
    [anon_sym_use_BANG] = ACTIONS(3077),
    [anon_sym_do_BANG] = ACTIONS(3077),
    [anon_sym_begin] = ACTIONS(3075),
    [anon_sym_LPAREN2] = ACTIONS(3075),
    [anon_sym_or] = ACTIONS(3075),
    [aux_sym_char_token1] = ACTIONS(3077),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3075),
    [anon_sym_DQUOTE] = ACTIONS(3075),
    [anon_sym_AT_DQUOTE] = ACTIONS(3077),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3077),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3077),
    [sym_bool] = ACTIONS(3075),
    [sym_unit] = ACTIONS(3077),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3075),
    [sym_op_identifier] = ACTIONS(3075),
    [anon_sym_PLUS] = ACTIONS(3075),
    [anon_sym_DASH] = ACTIONS(3075),
    [anon_sym_PLUS_DOT] = ACTIONS(3075),
    [anon_sym_DASH_DOT] = ACTIONS(3075),
    [anon_sym_PERCENT] = ACTIONS(3075),
    [anon_sym_AMP_AMP] = ACTIONS(3075),
    [anon_sym_TILDE] = ACTIONS(3077),
    [aux_sym_prefix_op_token1] = ACTIONS(3075),
    [aux_sym_infix_op_token1] = ACTIONS(3077),
    [aux_sym_infix_op_token2] = ACTIONS(3075),
    [anon_sym_PIPE_PIPE] = ACTIONS(3075),
    [anon_sym_BANG_EQ] = ACTIONS(3075),
    [anon_sym_COLON_EQ] = ACTIONS(3077),
    [anon_sym_DOLLAR] = ACTIONS(3075),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3075),
    [sym_int] = ACTIONS(3075),
    [sym_xint] = ACTIONS(3077),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3077),
    [sym__newline] = ACTIONS(3077),
    [sym__dedent] = ACTIONS(3077),
  },
  [1761] = {
    [sym_block_comment] = STATE(1761),
    [sym_compiler_directive_decl] = STATE(1761),
    [sym_fsi_directive_decl] = STATE(1761),
    [sym_preproc_line] = STATE(1761),
    [sym_identifier] = ACTIONS(3087),
    [anon_sym_EQ] = ACTIONS(3089),
    [anon_sym_COLON] = ACTIONS(3087),
    [anon_sym_return] = ACTIONS(3087),
    [anon_sym_do] = ACTIONS(3087),
    [anon_sym_and] = ACTIONS(3087),
    [anon_sym_let] = ACTIONS(3087),
    [anon_sym_let_BANG] = ACTIONS(3089),
    [anon_sym_LPAREN] = ACTIONS(3087),
    [anon_sym_COMMA] = ACTIONS(3089),
    [anon_sym_null] = ACTIONS(3087),
    [anon_sym_QMARK] = ACTIONS(3087),
    [anon_sym_COLON_QMARK] = ACTIONS(3087),
    [anon_sym_COLON_COLON] = ACTIONS(3089),
    [anon_sym_AMP] = ACTIONS(3087),
    [anon_sym_LBRACK] = ACTIONS(3087),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3089),
    [anon_sym_LBRACE] = ACTIONS(3087),
    [anon_sym_LT_AT] = ACTIONS(3087),
    [anon_sym_LT_AT_AT] = ACTIONS(3087),
    [anon_sym_DOT] = ACTIONS(3087),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3089),
    [anon_sym_new] = ACTIONS(3087),
    [anon_sym_return_BANG] = ACTIONS(3089),
    [anon_sym_yield] = ACTIONS(3087),
    [anon_sym_yield_BANG] = ACTIONS(3089),
    [anon_sym_lazy] = ACTIONS(3087),
    [anon_sym_assert] = ACTIONS(3087),
    [anon_sym_upcast] = ACTIONS(3087),
    [anon_sym_downcast] = ACTIONS(3087),
    [anon_sym_COLON_GT] = ACTIONS(3089),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3089),
    [anon_sym_for] = ACTIONS(3087),
    [anon_sym_while] = ACTIONS(3087),
    [anon_sym_if] = ACTIONS(3087),
    [anon_sym_fun] = ACTIONS(3087),
    [anon_sym_try] = ACTIONS(3087),
    [anon_sym_match] = ACTIONS(3087),
    [anon_sym_match_BANG] = ACTIONS(3089),
    [anon_sym_function] = ACTIONS(3087),
    [anon_sym_LT_DASH] = ACTIONS(3087),
    [anon_sym_DOT_LBRACK] = ACTIONS(3089),
    [anon_sym_LT] = ACTIONS(3089),
    [anon_sym_use] = ACTIONS(3087),
    [anon_sym_use_BANG] = ACTIONS(3089),
    [anon_sym_do_BANG] = ACTIONS(3089),
    [anon_sym_begin] = ACTIONS(3087),
    [anon_sym_LPAREN2] = ACTIONS(3087),
    [anon_sym_or] = ACTIONS(3087),
    [aux_sym_char_token1] = ACTIONS(3089),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3087),
    [anon_sym_DQUOTE] = ACTIONS(3087),
    [anon_sym_AT_DQUOTE] = ACTIONS(3089),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3089),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3089),
    [sym_bool] = ACTIONS(3087),
    [sym_unit] = ACTIONS(3089),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3087),
    [sym_op_identifier] = ACTIONS(3087),
    [anon_sym_PLUS] = ACTIONS(3087),
    [anon_sym_DASH] = ACTIONS(3087),
    [anon_sym_PLUS_DOT] = ACTIONS(3087),
    [anon_sym_DASH_DOT] = ACTIONS(3087),
    [anon_sym_PERCENT] = ACTIONS(3087),
    [anon_sym_AMP_AMP] = ACTIONS(3087),
    [anon_sym_TILDE] = ACTIONS(3089),
    [aux_sym_prefix_op_token1] = ACTIONS(3087),
    [aux_sym_infix_op_token1] = ACTIONS(3089),
    [aux_sym_infix_op_token2] = ACTIONS(3087),
    [anon_sym_PIPE_PIPE] = ACTIONS(3087),
    [anon_sym_BANG_EQ] = ACTIONS(3087),
    [anon_sym_COLON_EQ] = ACTIONS(3089),
    [anon_sym_DOLLAR] = ACTIONS(3087),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3087),
    [sym_int] = ACTIONS(3087),
    [sym_xint] = ACTIONS(3089),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3089),
    [sym__newline] = ACTIONS(3089),
    [sym__dedent] = ACTIONS(3089),
  },
  [1762] = {
    [sym_block_comment] = STATE(1762),
    [sym_compiler_directive_decl] = STATE(1762),
    [sym_fsi_directive_decl] = STATE(1762),
    [sym_preproc_line] = STATE(1762),
    [sym_identifier] = ACTIONS(3091),
    [anon_sym_EQ] = ACTIONS(3093),
    [anon_sym_COLON] = ACTIONS(3091),
    [anon_sym_return] = ACTIONS(3091),
    [anon_sym_do] = ACTIONS(3091),
    [anon_sym_and] = ACTIONS(3091),
    [anon_sym_let] = ACTIONS(3091),
    [anon_sym_let_BANG] = ACTIONS(3093),
    [anon_sym_LPAREN] = ACTIONS(3091),
    [anon_sym_COMMA] = ACTIONS(3093),
    [anon_sym_null] = ACTIONS(3091),
    [anon_sym_QMARK] = ACTIONS(3091),
    [anon_sym_COLON_QMARK] = ACTIONS(3091),
    [anon_sym_COLON_COLON] = ACTIONS(3093),
    [anon_sym_AMP] = ACTIONS(3091),
    [anon_sym_LBRACK] = ACTIONS(3091),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3093),
    [anon_sym_LBRACE] = ACTIONS(3091),
    [anon_sym_LT_AT] = ACTIONS(3091),
    [anon_sym_LT_AT_AT] = ACTIONS(3091),
    [anon_sym_DOT] = ACTIONS(3091),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3093),
    [anon_sym_new] = ACTIONS(3091),
    [anon_sym_return_BANG] = ACTIONS(3093),
    [anon_sym_yield] = ACTIONS(3091),
    [anon_sym_yield_BANG] = ACTIONS(3093),
    [anon_sym_lazy] = ACTIONS(3091),
    [anon_sym_assert] = ACTIONS(3091),
    [anon_sym_upcast] = ACTIONS(3091),
    [anon_sym_downcast] = ACTIONS(3091),
    [anon_sym_COLON_GT] = ACTIONS(3093),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3093),
    [anon_sym_for] = ACTIONS(3091),
    [anon_sym_while] = ACTIONS(3091),
    [anon_sym_if] = ACTIONS(3091),
    [anon_sym_fun] = ACTIONS(3091),
    [anon_sym_try] = ACTIONS(3091),
    [anon_sym_match] = ACTIONS(3091),
    [anon_sym_match_BANG] = ACTIONS(3093),
    [anon_sym_function] = ACTIONS(3091),
    [anon_sym_LT_DASH] = ACTIONS(3091),
    [anon_sym_DOT_LBRACK] = ACTIONS(3093),
    [anon_sym_LT] = ACTIONS(3093),
    [anon_sym_use] = ACTIONS(3091),
    [anon_sym_use_BANG] = ACTIONS(3093),
    [anon_sym_do_BANG] = ACTIONS(3093),
    [anon_sym_begin] = ACTIONS(3091),
    [anon_sym_LPAREN2] = ACTIONS(3091),
    [anon_sym_or] = ACTIONS(3091),
    [aux_sym_char_token1] = ACTIONS(3093),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3091),
    [anon_sym_DQUOTE] = ACTIONS(3091),
    [anon_sym_AT_DQUOTE] = ACTIONS(3093),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3093),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3093),
    [sym_bool] = ACTIONS(3091),
    [sym_unit] = ACTIONS(3093),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3091),
    [sym_op_identifier] = ACTIONS(3091),
    [anon_sym_PLUS] = ACTIONS(3091),
    [anon_sym_DASH] = ACTIONS(3091),
    [anon_sym_PLUS_DOT] = ACTIONS(3091),
    [anon_sym_DASH_DOT] = ACTIONS(3091),
    [anon_sym_PERCENT] = ACTIONS(3091),
    [anon_sym_AMP_AMP] = ACTIONS(3091),
    [anon_sym_TILDE] = ACTIONS(3093),
    [aux_sym_prefix_op_token1] = ACTIONS(3091),
    [aux_sym_infix_op_token1] = ACTIONS(3093),
    [aux_sym_infix_op_token2] = ACTIONS(3091),
    [anon_sym_PIPE_PIPE] = ACTIONS(3091),
    [anon_sym_BANG_EQ] = ACTIONS(3091),
    [anon_sym_COLON_EQ] = ACTIONS(3093),
    [anon_sym_DOLLAR] = ACTIONS(3091),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3091),
    [sym_int] = ACTIONS(3091),
    [sym_xint] = ACTIONS(3093),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3093),
    [sym__newline] = ACTIONS(3093),
    [sym__dedent] = ACTIONS(3093),
  },
  [1763] = {
    [sym_block_comment] = STATE(1763),
    [sym_compiler_directive_decl] = STATE(1763),
    [sym_fsi_directive_decl] = STATE(1763),
    [sym_preproc_line] = STATE(1763),
    [sym_identifier] = ACTIONS(3123),
    [anon_sym_EQ] = ACTIONS(3125),
    [anon_sym_COLON] = ACTIONS(3123),
    [anon_sym_return] = ACTIONS(3123),
    [anon_sym_do] = ACTIONS(3123),
    [anon_sym_and] = ACTIONS(3123),
    [anon_sym_let] = ACTIONS(3123),
    [anon_sym_let_BANG] = ACTIONS(3125),
    [anon_sym_LPAREN] = ACTIONS(3123),
    [anon_sym_COMMA] = ACTIONS(3125),
    [anon_sym_null] = ACTIONS(3123),
    [anon_sym_QMARK] = ACTIONS(3123),
    [anon_sym_COLON_QMARK] = ACTIONS(3123),
    [anon_sym_COLON_COLON] = ACTIONS(3125),
    [anon_sym_AMP] = ACTIONS(3123),
    [anon_sym_LBRACK] = ACTIONS(3123),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3125),
    [anon_sym_LBRACE] = ACTIONS(3123),
    [anon_sym_LT_AT] = ACTIONS(3123),
    [anon_sym_LT_AT_AT] = ACTIONS(3123),
    [anon_sym_DOT] = ACTIONS(3123),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3125),
    [anon_sym_new] = ACTIONS(3123),
    [anon_sym_return_BANG] = ACTIONS(3125),
    [anon_sym_yield] = ACTIONS(3123),
    [anon_sym_yield_BANG] = ACTIONS(3125),
    [anon_sym_lazy] = ACTIONS(3123),
    [anon_sym_assert] = ACTIONS(3123),
    [anon_sym_upcast] = ACTIONS(3123),
    [anon_sym_downcast] = ACTIONS(3123),
    [anon_sym_COLON_GT] = ACTIONS(3125),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3125),
    [anon_sym_for] = ACTIONS(3123),
    [anon_sym_while] = ACTIONS(3123),
    [anon_sym_if] = ACTIONS(3123),
    [anon_sym_fun] = ACTIONS(3123),
    [anon_sym_try] = ACTIONS(3123),
    [anon_sym_match] = ACTIONS(3123),
    [anon_sym_match_BANG] = ACTIONS(3125),
    [anon_sym_function] = ACTIONS(3123),
    [anon_sym_LT_DASH] = ACTIONS(3123),
    [anon_sym_DOT_LBRACK] = ACTIONS(3125),
    [anon_sym_LT] = ACTIONS(3125),
    [anon_sym_use] = ACTIONS(3123),
    [anon_sym_use_BANG] = ACTIONS(3125),
    [anon_sym_do_BANG] = ACTIONS(3125),
    [anon_sym_begin] = ACTIONS(3123),
    [anon_sym_LPAREN2] = ACTIONS(3123),
    [anon_sym_or] = ACTIONS(3123),
    [aux_sym_char_token1] = ACTIONS(3125),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3123),
    [anon_sym_DQUOTE] = ACTIONS(3123),
    [anon_sym_AT_DQUOTE] = ACTIONS(3125),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3125),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3125),
    [sym_bool] = ACTIONS(3123),
    [sym_unit] = ACTIONS(3125),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3123),
    [sym_op_identifier] = ACTIONS(3123),
    [anon_sym_PLUS] = ACTIONS(3123),
    [anon_sym_DASH] = ACTIONS(3123),
    [anon_sym_PLUS_DOT] = ACTIONS(3123),
    [anon_sym_DASH_DOT] = ACTIONS(3123),
    [anon_sym_PERCENT] = ACTIONS(3123),
    [anon_sym_AMP_AMP] = ACTIONS(3123),
    [anon_sym_TILDE] = ACTIONS(3125),
    [aux_sym_prefix_op_token1] = ACTIONS(3123),
    [aux_sym_infix_op_token1] = ACTIONS(3125),
    [aux_sym_infix_op_token2] = ACTIONS(3123),
    [anon_sym_PIPE_PIPE] = ACTIONS(3123),
    [anon_sym_BANG_EQ] = ACTIONS(3123),
    [anon_sym_COLON_EQ] = ACTIONS(3125),
    [anon_sym_DOLLAR] = ACTIONS(3123),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3123),
    [sym_int] = ACTIONS(3123),
    [sym_xint] = ACTIONS(3125),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3125),
    [sym__newline] = ACTIONS(3125),
    [sym__dedent] = ACTIONS(3125),
  },
  [1764] = {
    [sym_block_comment] = STATE(1764),
    [sym_compiler_directive_decl] = STATE(1764),
    [sym_fsi_directive_decl] = STATE(1764),
    [sym_preproc_line] = STATE(1764),
    [sym_identifier] = ACTIONS(3127),
    [anon_sym_EQ] = ACTIONS(3129),
    [anon_sym_COLON] = ACTIONS(3127),
    [anon_sym_return] = ACTIONS(3127),
    [anon_sym_do] = ACTIONS(3127),
    [anon_sym_and] = ACTIONS(3127),
    [anon_sym_let] = ACTIONS(3127),
    [anon_sym_let_BANG] = ACTIONS(3129),
    [anon_sym_LPAREN] = ACTIONS(3127),
    [anon_sym_COMMA] = ACTIONS(3129),
    [anon_sym_null] = ACTIONS(3127),
    [anon_sym_QMARK] = ACTIONS(3127),
    [anon_sym_COLON_QMARK] = ACTIONS(3127),
    [anon_sym_COLON_COLON] = ACTIONS(3129),
    [anon_sym_AMP] = ACTIONS(3127),
    [anon_sym_LBRACK] = ACTIONS(3127),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3129),
    [anon_sym_LBRACE] = ACTIONS(3127),
    [anon_sym_LT_AT] = ACTIONS(3127),
    [anon_sym_LT_AT_AT] = ACTIONS(3127),
    [anon_sym_DOT] = ACTIONS(3127),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3129),
    [anon_sym_new] = ACTIONS(3127),
    [anon_sym_return_BANG] = ACTIONS(3129),
    [anon_sym_yield] = ACTIONS(3127),
    [anon_sym_yield_BANG] = ACTIONS(3129),
    [anon_sym_lazy] = ACTIONS(3127),
    [anon_sym_assert] = ACTIONS(3127),
    [anon_sym_upcast] = ACTIONS(3127),
    [anon_sym_downcast] = ACTIONS(3127),
    [anon_sym_COLON_GT] = ACTIONS(3129),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3129),
    [anon_sym_for] = ACTIONS(3127),
    [anon_sym_while] = ACTIONS(3127),
    [anon_sym_if] = ACTIONS(3127),
    [anon_sym_fun] = ACTIONS(3127),
    [anon_sym_try] = ACTIONS(3127),
    [anon_sym_match] = ACTIONS(3127),
    [anon_sym_match_BANG] = ACTIONS(3129),
    [anon_sym_function] = ACTIONS(3127),
    [anon_sym_LT_DASH] = ACTIONS(3127),
    [anon_sym_DOT_LBRACK] = ACTIONS(3129),
    [anon_sym_LT] = ACTIONS(3129),
    [anon_sym_use] = ACTIONS(3127),
    [anon_sym_use_BANG] = ACTIONS(3129),
    [anon_sym_do_BANG] = ACTIONS(3129),
    [anon_sym_begin] = ACTIONS(3127),
    [anon_sym_LPAREN2] = ACTIONS(3127),
    [anon_sym_or] = ACTIONS(3127),
    [aux_sym_char_token1] = ACTIONS(3129),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3127),
    [anon_sym_DQUOTE] = ACTIONS(3127),
    [anon_sym_AT_DQUOTE] = ACTIONS(3129),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3129),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3129),
    [sym_bool] = ACTIONS(3127),
    [sym_unit] = ACTIONS(3129),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3127),
    [sym_op_identifier] = ACTIONS(3127),
    [anon_sym_PLUS] = ACTIONS(3127),
    [anon_sym_DASH] = ACTIONS(3127),
    [anon_sym_PLUS_DOT] = ACTIONS(3127),
    [anon_sym_DASH_DOT] = ACTIONS(3127),
    [anon_sym_PERCENT] = ACTIONS(3127),
    [anon_sym_AMP_AMP] = ACTIONS(3127),
    [anon_sym_TILDE] = ACTIONS(3129),
    [aux_sym_prefix_op_token1] = ACTIONS(3127),
    [aux_sym_infix_op_token1] = ACTIONS(3129),
    [aux_sym_infix_op_token2] = ACTIONS(3127),
    [anon_sym_PIPE_PIPE] = ACTIONS(3127),
    [anon_sym_BANG_EQ] = ACTIONS(3127),
    [anon_sym_COLON_EQ] = ACTIONS(3129),
    [anon_sym_DOLLAR] = ACTIONS(3127),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3127),
    [sym_int] = ACTIONS(3127),
    [sym_xint] = ACTIONS(3129),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3129),
    [sym__newline] = ACTIONS(3129),
    [sym__dedent] = ACTIONS(3129),
  },
  [1765] = {
    [sym_block_comment] = STATE(1765),
    [sym_compiler_directive_decl] = STATE(1765),
    [sym_fsi_directive_decl] = STATE(1765),
    [sym_preproc_line] = STATE(1765),
    [sym_identifier] = ACTIONS(2804),
    [anon_sym_EQ] = ACTIONS(2806),
    [anon_sym_COLON] = ACTIONS(2804),
    [anon_sym_return] = ACTIONS(2804),
    [anon_sym_do] = ACTIONS(2804),
    [anon_sym_let] = ACTIONS(2804),
    [anon_sym_let_BANG] = ACTIONS(2806),
    [anon_sym_LPAREN] = ACTIONS(2804),
    [anon_sym_COMMA] = ACTIONS(2806),
    [anon_sym_null] = ACTIONS(2804),
    [anon_sym_QMARK] = ACTIONS(2804),
    [anon_sym_COLON_QMARK] = ACTIONS(2804),
    [anon_sym_COLON_COLON] = ACTIONS(2806),
    [anon_sym_AMP] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2804),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(2804),
    [anon_sym_LT_AT] = ACTIONS(2804),
    [anon_sym_LT_AT_AT] = ACTIONS(2804),
    [anon_sym_DOT] = ACTIONS(2804),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2806),
    [anon_sym_new] = ACTIONS(2804),
    [anon_sym_return_BANG] = ACTIONS(2806),
    [anon_sym_yield] = ACTIONS(2804),
    [anon_sym_yield_BANG] = ACTIONS(2806),
    [anon_sym_lazy] = ACTIONS(2804),
    [anon_sym_assert] = ACTIONS(2804),
    [anon_sym_upcast] = ACTIONS(2804),
    [anon_sym_downcast] = ACTIONS(2804),
    [anon_sym_COLON_GT] = ACTIONS(2806),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2806),
    [anon_sym_for] = ACTIONS(2804),
    [anon_sym_done] = ACTIONS(4012),
    [anon_sym_while] = ACTIONS(2804),
    [anon_sym_if] = ACTIONS(2804),
    [anon_sym_fun] = ACTIONS(2804),
    [anon_sym_try] = ACTIONS(2804),
    [anon_sym_match] = ACTIONS(2804),
    [anon_sym_match_BANG] = ACTIONS(2806),
    [anon_sym_function] = ACTIONS(2804),
    [anon_sym_LT_DASH] = ACTIONS(2804),
    [anon_sym_DOT_LBRACK] = ACTIONS(2806),
    [anon_sym_LT] = ACTIONS(2806),
    [anon_sym_GT] = ACTIONS(2804),
    [anon_sym_use] = ACTIONS(2804),
    [anon_sym_use_BANG] = ACTIONS(2806),
    [anon_sym_do_BANG] = ACTIONS(2806),
    [anon_sym_begin] = ACTIONS(2804),
    [anon_sym_LPAREN2] = ACTIONS(2804),
    [anon_sym_or] = ACTIONS(2804),
    [aux_sym_char_token1] = ACTIONS(2806),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2804),
    [anon_sym_DQUOTE] = ACTIONS(2804),
    [anon_sym_AT_DQUOTE] = ACTIONS(2806),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2806),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2806),
    [sym_bool] = ACTIONS(2804),
    [sym_unit] = ACTIONS(2806),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2804),
    [sym_op_identifier] = ACTIONS(2804),
    [anon_sym_PLUS] = ACTIONS(2804),
    [anon_sym_DASH] = ACTIONS(2804),
    [anon_sym_PLUS_DOT] = ACTIONS(2804),
    [anon_sym_DASH_DOT] = ACTIONS(2804),
    [anon_sym_PERCENT] = ACTIONS(2804),
    [anon_sym_AMP_AMP] = ACTIONS(2804),
    [anon_sym_TILDE] = ACTIONS(2806),
    [aux_sym_prefix_op_token1] = ACTIONS(2804),
    [aux_sym_infix_op_token1] = ACTIONS(2806),
    [aux_sym_infix_op_token2] = ACTIONS(2804),
    [anon_sym_PIPE_PIPE] = ACTIONS(2804),
    [anon_sym_BANG_EQ] = ACTIONS(2804),
    [anon_sym_COLON_EQ] = ACTIONS(2806),
    [anon_sym_DOLLAR] = ACTIONS(2804),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2804),
    [sym_int] = ACTIONS(2804),
    [sym_xint] = ACTIONS(2806),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2806),
    [sym__newline] = ACTIONS(2806),
  },
  [1766] = {
    [sym_block_comment] = STATE(1766),
    [sym_compiler_directive_decl] = STATE(1766),
    [sym_fsi_directive_decl] = STATE(1766),
    [sym_preproc_line] = STATE(1766),
    [sym_identifier] = ACTIONS(3131),
    [anon_sym_EQ] = ACTIONS(3133),
    [anon_sym_COLON] = ACTIONS(3131),
    [anon_sym_return] = ACTIONS(3131),
    [anon_sym_do] = ACTIONS(3131),
    [anon_sym_and] = ACTIONS(3131),
    [anon_sym_let] = ACTIONS(3131),
    [anon_sym_let_BANG] = ACTIONS(3133),
    [anon_sym_LPAREN] = ACTIONS(3131),
    [anon_sym_COMMA] = ACTIONS(3133),
    [anon_sym_null] = ACTIONS(3131),
    [anon_sym_QMARK] = ACTIONS(3131),
    [anon_sym_COLON_QMARK] = ACTIONS(3131),
    [anon_sym_COLON_COLON] = ACTIONS(3133),
    [anon_sym_AMP] = ACTIONS(3131),
    [anon_sym_LBRACK] = ACTIONS(3131),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3133),
    [anon_sym_LBRACE] = ACTIONS(3131),
    [anon_sym_LT_AT] = ACTIONS(3131),
    [anon_sym_LT_AT_AT] = ACTIONS(3131),
    [anon_sym_DOT] = ACTIONS(3131),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3133),
    [anon_sym_new] = ACTIONS(3131),
    [anon_sym_return_BANG] = ACTIONS(3133),
    [anon_sym_yield] = ACTIONS(3131),
    [anon_sym_yield_BANG] = ACTIONS(3133),
    [anon_sym_lazy] = ACTIONS(3131),
    [anon_sym_assert] = ACTIONS(3131),
    [anon_sym_upcast] = ACTIONS(3131),
    [anon_sym_downcast] = ACTIONS(3131),
    [anon_sym_COLON_GT] = ACTIONS(3133),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3133),
    [anon_sym_for] = ACTIONS(3131),
    [anon_sym_while] = ACTIONS(3131),
    [anon_sym_if] = ACTIONS(3131),
    [anon_sym_fun] = ACTIONS(3131),
    [anon_sym_try] = ACTIONS(3131),
    [anon_sym_match] = ACTIONS(3131),
    [anon_sym_match_BANG] = ACTIONS(3133),
    [anon_sym_function] = ACTIONS(3131),
    [anon_sym_LT_DASH] = ACTIONS(3131),
    [anon_sym_DOT_LBRACK] = ACTIONS(3133),
    [anon_sym_LT] = ACTIONS(3133),
    [anon_sym_use] = ACTIONS(3131),
    [anon_sym_use_BANG] = ACTIONS(3133),
    [anon_sym_do_BANG] = ACTIONS(3133),
    [anon_sym_begin] = ACTIONS(3131),
    [anon_sym_LPAREN2] = ACTIONS(3131),
    [anon_sym_or] = ACTIONS(3131),
    [aux_sym_char_token1] = ACTIONS(3133),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3131),
    [anon_sym_DQUOTE] = ACTIONS(3131),
    [anon_sym_AT_DQUOTE] = ACTIONS(3133),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3133),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3133),
    [sym_bool] = ACTIONS(3131),
    [sym_unit] = ACTIONS(3133),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3131),
    [sym_op_identifier] = ACTIONS(3131),
    [anon_sym_PLUS] = ACTIONS(3131),
    [anon_sym_DASH] = ACTIONS(3131),
    [anon_sym_PLUS_DOT] = ACTIONS(3131),
    [anon_sym_DASH_DOT] = ACTIONS(3131),
    [anon_sym_PERCENT] = ACTIONS(3131),
    [anon_sym_AMP_AMP] = ACTIONS(3131),
    [anon_sym_TILDE] = ACTIONS(3133),
    [aux_sym_prefix_op_token1] = ACTIONS(3131),
    [aux_sym_infix_op_token1] = ACTIONS(3133),
    [aux_sym_infix_op_token2] = ACTIONS(3131),
    [anon_sym_PIPE_PIPE] = ACTIONS(3131),
    [anon_sym_BANG_EQ] = ACTIONS(3131),
    [anon_sym_COLON_EQ] = ACTIONS(3133),
    [anon_sym_DOLLAR] = ACTIONS(3131),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3131),
    [sym_int] = ACTIONS(3131),
    [sym_xint] = ACTIONS(3133),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3133),
    [sym__newline] = ACTIONS(3133),
    [sym__dedent] = ACTIONS(3133),
  },
  [1767] = {
    [sym_block_comment] = STATE(1767),
    [sym_compiler_directive_decl] = STATE(1767),
    [sym_fsi_directive_decl] = STATE(1767),
    [sym_preproc_line] = STATE(1767),
    [sym_identifier] = ACTIONS(3139),
    [anon_sym_EQ] = ACTIONS(3141),
    [anon_sym_COLON] = ACTIONS(3139),
    [anon_sym_return] = ACTIONS(3139),
    [anon_sym_do] = ACTIONS(3139),
    [anon_sym_and] = ACTIONS(3139),
    [anon_sym_let] = ACTIONS(3139),
    [anon_sym_let_BANG] = ACTIONS(3141),
    [anon_sym_LPAREN] = ACTIONS(3139),
    [anon_sym_COMMA] = ACTIONS(3141),
    [anon_sym_null] = ACTIONS(3139),
    [anon_sym_QMARK] = ACTIONS(3139),
    [anon_sym_COLON_QMARK] = ACTIONS(3139),
    [anon_sym_COLON_COLON] = ACTIONS(3141),
    [anon_sym_AMP] = ACTIONS(3139),
    [anon_sym_LBRACK] = ACTIONS(3139),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3141),
    [anon_sym_LBRACE] = ACTIONS(3139),
    [anon_sym_LT_AT] = ACTIONS(3139),
    [anon_sym_LT_AT_AT] = ACTIONS(3139),
    [anon_sym_DOT] = ACTIONS(3139),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3141),
    [anon_sym_new] = ACTIONS(3139),
    [anon_sym_return_BANG] = ACTIONS(3141),
    [anon_sym_yield] = ACTIONS(3139),
    [anon_sym_yield_BANG] = ACTIONS(3141),
    [anon_sym_lazy] = ACTIONS(3139),
    [anon_sym_assert] = ACTIONS(3139),
    [anon_sym_upcast] = ACTIONS(3139),
    [anon_sym_downcast] = ACTIONS(3139),
    [anon_sym_COLON_GT] = ACTIONS(3141),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3141),
    [anon_sym_for] = ACTIONS(3139),
    [anon_sym_while] = ACTIONS(3139),
    [anon_sym_if] = ACTIONS(3139),
    [anon_sym_fun] = ACTIONS(3139),
    [anon_sym_try] = ACTIONS(3139),
    [anon_sym_match] = ACTIONS(3139),
    [anon_sym_match_BANG] = ACTIONS(3141),
    [anon_sym_function] = ACTIONS(3139),
    [anon_sym_LT_DASH] = ACTIONS(3139),
    [anon_sym_DOT_LBRACK] = ACTIONS(3141),
    [anon_sym_LT] = ACTIONS(3141),
    [anon_sym_use] = ACTIONS(3139),
    [anon_sym_use_BANG] = ACTIONS(3141),
    [anon_sym_do_BANG] = ACTIONS(3141),
    [anon_sym_begin] = ACTIONS(3139),
    [anon_sym_LPAREN2] = ACTIONS(3139),
    [anon_sym_or] = ACTIONS(3139),
    [aux_sym_char_token1] = ACTIONS(3141),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3139),
    [anon_sym_DQUOTE] = ACTIONS(3139),
    [anon_sym_AT_DQUOTE] = ACTIONS(3141),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3141),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3141),
    [sym_bool] = ACTIONS(3139),
    [sym_unit] = ACTIONS(3141),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3139),
    [sym_op_identifier] = ACTIONS(3139),
    [anon_sym_PLUS] = ACTIONS(3139),
    [anon_sym_DASH] = ACTIONS(3139),
    [anon_sym_PLUS_DOT] = ACTIONS(3139),
    [anon_sym_DASH_DOT] = ACTIONS(3139),
    [anon_sym_PERCENT] = ACTIONS(3139),
    [anon_sym_AMP_AMP] = ACTIONS(3139),
    [anon_sym_TILDE] = ACTIONS(3141),
    [aux_sym_prefix_op_token1] = ACTIONS(3139),
    [aux_sym_infix_op_token1] = ACTIONS(3141),
    [aux_sym_infix_op_token2] = ACTIONS(3139),
    [anon_sym_PIPE_PIPE] = ACTIONS(3139),
    [anon_sym_BANG_EQ] = ACTIONS(3139),
    [anon_sym_COLON_EQ] = ACTIONS(3141),
    [anon_sym_DOLLAR] = ACTIONS(3139),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3139),
    [sym_int] = ACTIONS(3139),
    [sym_xint] = ACTIONS(3141),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3141),
    [sym__newline] = ACTIONS(3141),
    [sym__dedent] = ACTIONS(3141),
  },
  [1768] = {
    [sym_block_comment] = STATE(1768),
    [sym_compiler_directive_decl] = STATE(1768),
    [sym_fsi_directive_decl] = STATE(1768),
    [sym_preproc_line] = STATE(1768),
    [sym_identifier] = ACTIONS(3135),
    [anon_sym_EQ] = ACTIONS(3137),
    [anon_sym_COLON] = ACTIONS(3135),
    [anon_sym_return] = ACTIONS(3135),
    [anon_sym_do] = ACTIONS(3135),
    [anon_sym_and] = ACTIONS(3135),
    [anon_sym_let] = ACTIONS(3135),
    [anon_sym_let_BANG] = ACTIONS(3137),
    [anon_sym_LPAREN] = ACTIONS(3135),
    [anon_sym_COMMA] = ACTIONS(3137),
    [anon_sym_null] = ACTIONS(3135),
    [anon_sym_QMARK] = ACTIONS(3135),
    [anon_sym_COLON_QMARK] = ACTIONS(3135),
    [anon_sym_COLON_COLON] = ACTIONS(3137),
    [anon_sym_AMP] = ACTIONS(3135),
    [anon_sym_LBRACK] = ACTIONS(3135),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3137),
    [anon_sym_LBRACE] = ACTIONS(3135),
    [anon_sym_LT_AT] = ACTIONS(3135),
    [anon_sym_LT_AT_AT] = ACTIONS(3135),
    [anon_sym_DOT] = ACTIONS(3135),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3137),
    [anon_sym_new] = ACTIONS(3135),
    [anon_sym_return_BANG] = ACTIONS(3137),
    [anon_sym_yield] = ACTIONS(3135),
    [anon_sym_yield_BANG] = ACTIONS(3137),
    [anon_sym_lazy] = ACTIONS(3135),
    [anon_sym_assert] = ACTIONS(3135),
    [anon_sym_upcast] = ACTIONS(3135),
    [anon_sym_downcast] = ACTIONS(3135),
    [anon_sym_COLON_GT] = ACTIONS(3137),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3137),
    [anon_sym_for] = ACTIONS(3135),
    [anon_sym_while] = ACTIONS(3135),
    [anon_sym_if] = ACTIONS(3135),
    [anon_sym_fun] = ACTIONS(3135),
    [anon_sym_try] = ACTIONS(3135),
    [anon_sym_match] = ACTIONS(3135),
    [anon_sym_match_BANG] = ACTIONS(3137),
    [anon_sym_function] = ACTIONS(3135),
    [anon_sym_LT_DASH] = ACTIONS(3135),
    [anon_sym_DOT_LBRACK] = ACTIONS(3137),
    [anon_sym_LT] = ACTIONS(3137),
    [anon_sym_use] = ACTIONS(3135),
    [anon_sym_use_BANG] = ACTIONS(3137),
    [anon_sym_do_BANG] = ACTIONS(3137),
    [anon_sym_begin] = ACTIONS(3135),
    [anon_sym_LPAREN2] = ACTIONS(3135),
    [anon_sym_or] = ACTIONS(3135),
    [aux_sym_char_token1] = ACTIONS(3137),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3135),
    [anon_sym_DQUOTE] = ACTIONS(3135),
    [anon_sym_AT_DQUOTE] = ACTIONS(3137),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3137),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3137),
    [sym_bool] = ACTIONS(3135),
    [sym_unit] = ACTIONS(3137),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3135),
    [sym_op_identifier] = ACTIONS(3135),
    [anon_sym_PLUS] = ACTIONS(3135),
    [anon_sym_DASH] = ACTIONS(3135),
    [anon_sym_PLUS_DOT] = ACTIONS(3135),
    [anon_sym_DASH_DOT] = ACTIONS(3135),
    [anon_sym_PERCENT] = ACTIONS(3135),
    [anon_sym_AMP_AMP] = ACTIONS(3135),
    [anon_sym_TILDE] = ACTIONS(3137),
    [aux_sym_prefix_op_token1] = ACTIONS(3135),
    [aux_sym_infix_op_token1] = ACTIONS(3137),
    [aux_sym_infix_op_token2] = ACTIONS(3135),
    [anon_sym_PIPE_PIPE] = ACTIONS(3135),
    [anon_sym_BANG_EQ] = ACTIONS(3135),
    [anon_sym_COLON_EQ] = ACTIONS(3137),
    [anon_sym_DOLLAR] = ACTIONS(3135),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3135),
    [sym_int] = ACTIONS(3135),
    [sym_xint] = ACTIONS(3137),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3137),
    [sym__newline] = ACTIONS(3137),
    [sym__dedent] = ACTIONS(3137),
  },
  [1769] = {
    [sym_block_comment] = STATE(1769),
    [sym_compiler_directive_decl] = STATE(1769),
    [sym_fsi_directive_decl] = STATE(1769),
    [sym_preproc_line] = STATE(1769),
    [sym_identifier] = ACTIONS(3119),
    [anon_sym_EQ] = ACTIONS(3121),
    [anon_sym_COLON] = ACTIONS(3119),
    [anon_sym_return] = ACTIONS(3119),
    [anon_sym_do] = ACTIONS(3119),
    [anon_sym_and] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_let_BANG] = ACTIONS(3121),
    [anon_sym_LPAREN] = ACTIONS(3119),
    [anon_sym_COMMA] = ACTIONS(3121),
    [anon_sym_null] = ACTIONS(3119),
    [anon_sym_QMARK] = ACTIONS(3119),
    [anon_sym_COLON_QMARK] = ACTIONS(3119),
    [anon_sym_COLON_COLON] = ACTIONS(3121),
    [anon_sym_AMP] = ACTIONS(3119),
    [anon_sym_LBRACK] = ACTIONS(3119),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3121),
    [anon_sym_LBRACE] = ACTIONS(3119),
    [anon_sym_LT_AT] = ACTIONS(3119),
    [anon_sym_LT_AT_AT] = ACTIONS(3119),
    [anon_sym_DOT] = ACTIONS(3119),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3121),
    [anon_sym_new] = ACTIONS(3119),
    [anon_sym_return_BANG] = ACTIONS(3121),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_yield_BANG] = ACTIONS(3121),
    [anon_sym_lazy] = ACTIONS(3119),
    [anon_sym_assert] = ACTIONS(3119),
    [anon_sym_upcast] = ACTIONS(3119),
    [anon_sym_downcast] = ACTIONS(3119),
    [anon_sym_COLON_GT] = ACTIONS(3121),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3121),
    [anon_sym_for] = ACTIONS(3119),
    [anon_sym_while] = ACTIONS(3119),
    [anon_sym_if] = ACTIONS(3119),
    [anon_sym_fun] = ACTIONS(3119),
    [anon_sym_try] = ACTIONS(3119),
    [anon_sym_match] = ACTIONS(3119),
    [anon_sym_match_BANG] = ACTIONS(3121),
    [anon_sym_function] = ACTIONS(3119),
    [anon_sym_LT_DASH] = ACTIONS(3119),
    [anon_sym_DOT_LBRACK] = ACTIONS(3121),
    [anon_sym_LT] = ACTIONS(3121),
    [anon_sym_use] = ACTIONS(3119),
    [anon_sym_use_BANG] = ACTIONS(3121),
    [anon_sym_do_BANG] = ACTIONS(3121),
    [anon_sym_begin] = ACTIONS(3119),
    [anon_sym_LPAREN2] = ACTIONS(3119),
    [anon_sym_or] = ACTIONS(3119),
    [aux_sym_char_token1] = ACTIONS(3121),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3119),
    [anon_sym_DQUOTE] = ACTIONS(3119),
    [anon_sym_AT_DQUOTE] = ACTIONS(3121),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3121),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3121),
    [sym_bool] = ACTIONS(3119),
    [sym_unit] = ACTIONS(3121),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3119),
    [sym_op_identifier] = ACTIONS(3119),
    [anon_sym_PLUS] = ACTIONS(3119),
    [anon_sym_DASH] = ACTIONS(3119),
    [anon_sym_PLUS_DOT] = ACTIONS(3119),
    [anon_sym_DASH_DOT] = ACTIONS(3119),
    [anon_sym_PERCENT] = ACTIONS(3119),
    [anon_sym_AMP_AMP] = ACTIONS(3119),
    [anon_sym_TILDE] = ACTIONS(3121),
    [aux_sym_prefix_op_token1] = ACTIONS(3119),
    [aux_sym_infix_op_token1] = ACTIONS(3121),
    [aux_sym_infix_op_token2] = ACTIONS(3119),
    [anon_sym_PIPE_PIPE] = ACTIONS(3119),
    [anon_sym_BANG_EQ] = ACTIONS(3119),
    [anon_sym_COLON_EQ] = ACTIONS(3121),
    [anon_sym_DOLLAR] = ACTIONS(3119),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3119),
    [sym_int] = ACTIONS(3119),
    [sym_xint] = ACTIONS(3121),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3121),
    [sym__newline] = ACTIONS(3121),
    [sym__dedent] = ACTIONS(3121),
  },
  [1770] = {
    [sym_block_comment] = STATE(1770),
    [sym_compiler_directive_decl] = STATE(1770),
    [sym_fsi_directive_decl] = STATE(1770),
    [sym_preproc_line] = STATE(1770),
    [sym_identifier] = ACTIONS(2835),
    [anon_sym_EQ] = ACTIONS(2837),
    [anon_sym_COLON] = ACTIONS(2835),
    [anon_sym_return] = ACTIONS(2835),
    [anon_sym_do] = ACTIONS(2835),
    [anon_sym_and] = ACTIONS(2835),
    [anon_sym_let] = ACTIONS(2835),
    [anon_sym_let_BANG] = ACTIONS(2837),
    [anon_sym_LPAREN] = ACTIONS(2835),
    [anon_sym_COMMA] = ACTIONS(2837),
    [anon_sym_null] = ACTIONS(2835),
    [anon_sym_QMARK] = ACTIONS(2835),
    [anon_sym_COLON_QMARK] = ACTIONS(2835),
    [anon_sym_COLON_COLON] = ACTIONS(2837),
    [anon_sym_AMP] = ACTIONS(2835),
    [anon_sym_LBRACK] = ACTIONS(2835),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2837),
    [anon_sym_LBRACE] = ACTIONS(2835),
    [anon_sym_LT_AT] = ACTIONS(2835),
    [anon_sym_LT_AT_AT] = ACTIONS(2835),
    [anon_sym_DOT] = ACTIONS(2835),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2837),
    [anon_sym_new] = ACTIONS(2835),
    [anon_sym_return_BANG] = ACTIONS(2837),
    [anon_sym_yield] = ACTIONS(2835),
    [anon_sym_yield_BANG] = ACTIONS(2837),
    [anon_sym_lazy] = ACTIONS(2835),
    [anon_sym_assert] = ACTIONS(2835),
    [anon_sym_upcast] = ACTIONS(2835),
    [anon_sym_downcast] = ACTIONS(2835),
    [anon_sym_COLON_GT] = ACTIONS(2837),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2837),
    [anon_sym_for] = ACTIONS(2835),
    [anon_sym_while] = ACTIONS(2835),
    [anon_sym_if] = ACTIONS(2835),
    [anon_sym_fun] = ACTIONS(2835),
    [anon_sym_try] = ACTIONS(2835),
    [anon_sym_match] = ACTIONS(2835),
    [anon_sym_match_BANG] = ACTIONS(2837),
    [anon_sym_function] = ACTIONS(2835),
    [anon_sym_LT_DASH] = ACTIONS(2835),
    [anon_sym_DOT_LBRACK] = ACTIONS(2837),
    [anon_sym_LT] = ACTIONS(2837),
    [anon_sym_use] = ACTIONS(2835),
    [anon_sym_use_BANG] = ACTIONS(2837),
    [anon_sym_do_BANG] = ACTIONS(2837),
    [anon_sym_begin] = ACTIONS(2835),
    [anon_sym_LPAREN2] = ACTIONS(2835),
    [anon_sym_or] = ACTIONS(2835),
    [aux_sym_char_token1] = ACTIONS(2837),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2835),
    [anon_sym_DQUOTE] = ACTIONS(2835),
    [anon_sym_AT_DQUOTE] = ACTIONS(2837),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2837),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2837),
    [sym_bool] = ACTIONS(2835),
    [sym_unit] = ACTIONS(2837),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2835),
    [sym_op_identifier] = ACTIONS(2835),
    [anon_sym_PLUS] = ACTIONS(2835),
    [anon_sym_DASH] = ACTIONS(2835),
    [anon_sym_PLUS_DOT] = ACTIONS(2835),
    [anon_sym_DASH_DOT] = ACTIONS(2835),
    [anon_sym_PERCENT] = ACTIONS(2835),
    [anon_sym_AMP_AMP] = ACTIONS(2835),
    [anon_sym_TILDE] = ACTIONS(2837),
    [aux_sym_prefix_op_token1] = ACTIONS(2835),
    [aux_sym_infix_op_token1] = ACTIONS(2837),
    [aux_sym_infix_op_token2] = ACTIONS(2835),
    [anon_sym_PIPE_PIPE] = ACTIONS(2835),
    [anon_sym_BANG_EQ] = ACTIONS(2835),
    [anon_sym_COLON_EQ] = ACTIONS(2837),
    [anon_sym_DOLLAR] = ACTIONS(2835),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2835),
    [sym_int] = ACTIONS(2835),
    [sym_xint] = ACTIONS(2837),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2837),
    [sym__newline] = ACTIONS(2837),
    [sym__dedent] = ACTIONS(2837),
  },
  [1771] = {
    [sym_block_comment] = STATE(1771),
    [sym_compiler_directive_decl] = STATE(1771),
    [sym_fsi_directive_decl] = STATE(1771),
    [sym_preproc_line] = STATE(1771),
    [sym_identifier] = ACTIONS(3111),
    [anon_sym_EQ] = ACTIONS(3113),
    [anon_sym_COLON] = ACTIONS(3111),
    [anon_sym_return] = ACTIONS(3111),
    [anon_sym_do] = ACTIONS(3111),
    [anon_sym_and] = ACTIONS(3111),
    [anon_sym_let] = ACTIONS(3111),
    [anon_sym_let_BANG] = ACTIONS(3113),
    [anon_sym_LPAREN] = ACTIONS(3111),
    [anon_sym_COMMA] = ACTIONS(3113),
    [anon_sym_null] = ACTIONS(3111),
    [anon_sym_QMARK] = ACTIONS(3111),
    [anon_sym_COLON_QMARK] = ACTIONS(3111),
    [anon_sym_COLON_COLON] = ACTIONS(3113),
    [anon_sym_AMP] = ACTIONS(3111),
    [anon_sym_LBRACK] = ACTIONS(3111),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3113),
    [anon_sym_LBRACE] = ACTIONS(3111),
    [anon_sym_LT_AT] = ACTIONS(3111),
    [anon_sym_LT_AT_AT] = ACTIONS(3111),
    [anon_sym_DOT] = ACTIONS(3111),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3113),
    [anon_sym_new] = ACTIONS(3111),
    [anon_sym_return_BANG] = ACTIONS(3113),
    [anon_sym_yield] = ACTIONS(3111),
    [anon_sym_yield_BANG] = ACTIONS(3113),
    [anon_sym_lazy] = ACTIONS(3111),
    [anon_sym_assert] = ACTIONS(3111),
    [anon_sym_upcast] = ACTIONS(3111),
    [anon_sym_downcast] = ACTIONS(3111),
    [anon_sym_COLON_GT] = ACTIONS(3113),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3113),
    [anon_sym_for] = ACTIONS(3111),
    [anon_sym_while] = ACTIONS(3111),
    [anon_sym_if] = ACTIONS(3111),
    [anon_sym_fun] = ACTIONS(3111),
    [anon_sym_try] = ACTIONS(3111),
    [anon_sym_match] = ACTIONS(3111),
    [anon_sym_match_BANG] = ACTIONS(3113),
    [anon_sym_function] = ACTIONS(3111),
    [anon_sym_LT_DASH] = ACTIONS(3111),
    [anon_sym_DOT_LBRACK] = ACTIONS(3113),
    [anon_sym_LT] = ACTIONS(3113),
    [anon_sym_use] = ACTIONS(3111),
    [anon_sym_use_BANG] = ACTIONS(3113),
    [anon_sym_do_BANG] = ACTIONS(3113),
    [anon_sym_begin] = ACTIONS(3111),
    [anon_sym_LPAREN2] = ACTIONS(3111),
    [anon_sym_or] = ACTIONS(3111),
    [aux_sym_char_token1] = ACTIONS(3113),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3111),
    [anon_sym_DQUOTE] = ACTIONS(3111),
    [anon_sym_AT_DQUOTE] = ACTIONS(3113),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3113),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3113),
    [sym_bool] = ACTIONS(3111),
    [sym_unit] = ACTIONS(3113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3111),
    [sym_op_identifier] = ACTIONS(3111),
    [anon_sym_PLUS] = ACTIONS(3111),
    [anon_sym_DASH] = ACTIONS(3111),
    [anon_sym_PLUS_DOT] = ACTIONS(3111),
    [anon_sym_DASH_DOT] = ACTIONS(3111),
    [anon_sym_PERCENT] = ACTIONS(3111),
    [anon_sym_AMP_AMP] = ACTIONS(3111),
    [anon_sym_TILDE] = ACTIONS(3113),
    [aux_sym_prefix_op_token1] = ACTIONS(3111),
    [aux_sym_infix_op_token1] = ACTIONS(3113),
    [aux_sym_infix_op_token2] = ACTIONS(3111),
    [anon_sym_PIPE_PIPE] = ACTIONS(3111),
    [anon_sym_BANG_EQ] = ACTIONS(3111),
    [anon_sym_COLON_EQ] = ACTIONS(3113),
    [anon_sym_DOLLAR] = ACTIONS(3111),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3111),
    [sym_int] = ACTIONS(3111),
    [sym_xint] = ACTIONS(3113),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3113),
    [sym__newline] = ACTIONS(3113),
    [sym__dedent] = ACTIONS(3113),
  },
  [1772] = {
    [sym_block_comment] = STATE(1772),
    [sym_compiler_directive_decl] = STATE(1772),
    [sym_fsi_directive_decl] = STATE(1772),
    [sym_preproc_line] = STATE(1772),
    [sym_identifier] = ACTIONS(3107),
    [anon_sym_EQ] = ACTIONS(3109),
    [anon_sym_COLON] = ACTIONS(3107),
    [anon_sym_return] = ACTIONS(3107),
    [anon_sym_do] = ACTIONS(3107),
    [anon_sym_and] = ACTIONS(3107),
    [anon_sym_let] = ACTIONS(3107),
    [anon_sym_let_BANG] = ACTIONS(3109),
    [anon_sym_LPAREN] = ACTIONS(3107),
    [anon_sym_COMMA] = ACTIONS(3109),
    [anon_sym_null] = ACTIONS(3107),
    [anon_sym_QMARK] = ACTIONS(3107),
    [anon_sym_COLON_QMARK] = ACTIONS(3107),
    [anon_sym_COLON_COLON] = ACTIONS(3109),
    [anon_sym_AMP] = ACTIONS(3107),
    [anon_sym_LBRACK] = ACTIONS(3107),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3109),
    [anon_sym_LBRACE] = ACTIONS(3107),
    [anon_sym_LT_AT] = ACTIONS(3107),
    [anon_sym_LT_AT_AT] = ACTIONS(3107),
    [anon_sym_DOT] = ACTIONS(3107),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3109),
    [anon_sym_new] = ACTIONS(3107),
    [anon_sym_return_BANG] = ACTIONS(3109),
    [anon_sym_yield] = ACTIONS(3107),
    [anon_sym_yield_BANG] = ACTIONS(3109),
    [anon_sym_lazy] = ACTIONS(3107),
    [anon_sym_assert] = ACTIONS(3107),
    [anon_sym_upcast] = ACTIONS(3107),
    [anon_sym_downcast] = ACTIONS(3107),
    [anon_sym_COLON_GT] = ACTIONS(3109),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3109),
    [anon_sym_for] = ACTIONS(3107),
    [anon_sym_while] = ACTIONS(3107),
    [anon_sym_if] = ACTIONS(3107),
    [anon_sym_fun] = ACTIONS(3107),
    [anon_sym_try] = ACTIONS(3107),
    [anon_sym_match] = ACTIONS(3107),
    [anon_sym_match_BANG] = ACTIONS(3109),
    [anon_sym_function] = ACTIONS(3107),
    [anon_sym_LT_DASH] = ACTIONS(3107),
    [anon_sym_DOT_LBRACK] = ACTIONS(3109),
    [anon_sym_LT] = ACTIONS(3109),
    [anon_sym_use] = ACTIONS(3107),
    [anon_sym_use_BANG] = ACTIONS(3109),
    [anon_sym_do_BANG] = ACTIONS(3109),
    [anon_sym_begin] = ACTIONS(3107),
    [anon_sym_LPAREN2] = ACTIONS(3107),
    [anon_sym_or] = ACTIONS(3107),
    [aux_sym_char_token1] = ACTIONS(3109),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3107),
    [anon_sym_DQUOTE] = ACTIONS(3107),
    [anon_sym_AT_DQUOTE] = ACTIONS(3109),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3109),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3109),
    [sym_bool] = ACTIONS(3107),
    [sym_unit] = ACTIONS(3109),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3107),
    [sym_op_identifier] = ACTIONS(3107),
    [anon_sym_PLUS] = ACTIONS(3107),
    [anon_sym_DASH] = ACTIONS(3107),
    [anon_sym_PLUS_DOT] = ACTIONS(3107),
    [anon_sym_DASH_DOT] = ACTIONS(3107),
    [anon_sym_PERCENT] = ACTIONS(3107),
    [anon_sym_AMP_AMP] = ACTIONS(3107),
    [anon_sym_TILDE] = ACTIONS(3109),
    [aux_sym_prefix_op_token1] = ACTIONS(3107),
    [aux_sym_infix_op_token1] = ACTIONS(3109),
    [aux_sym_infix_op_token2] = ACTIONS(3107),
    [anon_sym_PIPE_PIPE] = ACTIONS(3107),
    [anon_sym_BANG_EQ] = ACTIONS(3107),
    [anon_sym_COLON_EQ] = ACTIONS(3109),
    [anon_sym_DOLLAR] = ACTIONS(3107),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3107),
    [sym_int] = ACTIONS(3107),
    [sym_xint] = ACTIONS(3109),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3109),
    [sym__newline] = ACTIONS(3109),
    [sym__dedent] = ACTIONS(3109),
  },
  [1773] = {
    [sym_block_comment] = STATE(1773),
    [sym_compiler_directive_decl] = STATE(1773),
    [sym_fsi_directive_decl] = STATE(1773),
    [sym_preproc_line] = STATE(1773),
    [sym_identifier] = ACTIONS(3103),
    [anon_sym_EQ] = ACTIONS(3105),
    [anon_sym_COLON] = ACTIONS(3103),
    [anon_sym_return] = ACTIONS(3103),
    [anon_sym_do] = ACTIONS(3103),
    [anon_sym_and] = ACTIONS(3103),
    [anon_sym_let] = ACTIONS(3103),
    [anon_sym_let_BANG] = ACTIONS(3105),
    [anon_sym_LPAREN] = ACTIONS(3103),
    [anon_sym_COMMA] = ACTIONS(3105),
    [anon_sym_null] = ACTIONS(3103),
    [anon_sym_QMARK] = ACTIONS(3103),
    [anon_sym_COLON_QMARK] = ACTIONS(3103),
    [anon_sym_COLON_COLON] = ACTIONS(3105),
    [anon_sym_AMP] = ACTIONS(3103),
    [anon_sym_LBRACK] = ACTIONS(3103),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3105),
    [anon_sym_LBRACE] = ACTIONS(3103),
    [anon_sym_LT_AT] = ACTIONS(3103),
    [anon_sym_LT_AT_AT] = ACTIONS(3103),
    [anon_sym_DOT] = ACTIONS(3103),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3105),
    [anon_sym_new] = ACTIONS(3103),
    [anon_sym_return_BANG] = ACTIONS(3105),
    [anon_sym_yield] = ACTIONS(3103),
    [anon_sym_yield_BANG] = ACTIONS(3105),
    [anon_sym_lazy] = ACTIONS(3103),
    [anon_sym_assert] = ACTIONS(3103),
    [anon_sym_upcast] = ACTIONS(3103),
    [anon_sym_downcast] = ACTIONS(3103),
    [anon_sym_COLON_GT] = ACTIONS(3105),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3105),
    [anon_sym_for] = ACTIONS(3103),
    [anon_sym_while] = ACTIONS(3103),
    [anon_sym_if] = ACTIONS(3103),
    [anon_sym_fun] = ACTIONS(3103),
    [anon_sym_try] = ACTIONS(3103),
    [anon_sym_match] = ACTIONS(3103),
    [anon_sym_match_BANG] = ACTIONS(3105),
    [anon_sym_function] = ACTIONS(3103),
    [anon_sym_LT_DASH] = ACTIONS(3103),
    [anon_sym_DOT_LBRACK] = ACTIONS(3105),
    [anon_sym_LT] = ACTIONS(3105),
    [anon_sym_use] = ACTIONS(3103),
    [anon_sym_use_BANG] = ACTIONS(3105),
    [anon_sym_do_BANG] = ACTIONS(3105),
    [anon_sym_begin] = ACTIONS(3103),
    [anon_sym_LPAREN2] = ACTIONS(3103),
    [anon_sym_or] = ACTIONS(3103),
    [aux_sym_char_token1] = ACTIONS(3105),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3103),
    [anon_sym_DQUOTE] = ACTIONS(3103),
    [anon_sym_AT_DQUOTE] = ACTIONS(3105),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3105),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3105),
    [sym_bool] = ACTIONS(3103),
    [sym_unit] = ACTIONS(3105),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3103),
    [sym_op_identifier] = ACTIONS(3103),
    [anon_sym_PLUS] = ACTIONS(3103),
    [anon_sym_DASH] = ACTIONS(3103),
    [anon_sym_PLUS_DOT] = ACTIONS(3103),
    [anon_sym_DASH_DOT] = ACTIONS(3103),
    [anon_sym_PERCENT] = ACTIONS(3103),
    [anon_sym_AMP_AMP] = ACTIONS(3103),
    [anon_sym_TILDE] = ACTIONS(3105),
    [aux_sym_prefix_op_token1] = ACTIONS(3103),
    [aux_sym_infix_op_token1] = ACTIONS(3105),
    [aux_sym_infix_op_token2] = ACTIONS(3103),
    [anon_sym_PIPE_PIPE] = ACTIONS(3103),
    [anon_sym_BANG_EQ] = ACTIONS(3103),
    [anon_sym_COLON_EQ] = ACTIONS(3105),
    [anon_sym_DOLLAR] = ACTIONS(3103),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3103),
    [sym_int] = ACTIONS(3103),
    [sym_xint] = ACTIONS(3105),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3105),
    [sym__newline] = ACTIONS(3105),
    [sym__dedent] = ACTIONS(3105),
  },
  [1774] = {
    [sym_block_comment] = STATE(1774),
    [sym_compiler_directive_decl] = STATE(1774),
    [sym_fsi_directive_decl] = STATE(1774),
    [sym_preproc_line] = STATE(1774),
    [sym_identifier] = ACTIONS(3099),
    [anon_sym_EQ] = ACTIONS(3101),
    [anon_sym_COLON] = ACTIONS(3099),
    [anon_sym_return] = ACTIONS(3099),
    [anon_sym_do] = ACTIONS(3099),
    [anon_sym_and] = ACTIONS(3099),
    [anon_sym_let] = ACTIONS(3099),
    [anon_sym_let_BANG] = ACTIONS(3101),
    [anon_sym_LPAREN] = ACTIONS(3099),
    [anon_sym_COMMA] = ACTIONS(3101),
    [anon_sym_null] = ACTIONS(3099),
    [anon_sym_QMARK] = ACTIONS(3099),
    [anon_sym_COLON_QMARK] = ACTIONS(3099),
    [anon_sym_COLON_COLON] = ACTIONS(3101),
    [anon_sym_AMP] = ACTIONS(3099),
    [anon_sym_LBRACK] = ACTIONS(3099),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3101),
    [anon_sym_LBRACE] = ACTIONS(3099),
    [anon_sym_LT_AT] = ACTIONS(3099),
    [anon_sym_LT_AT_AT] = ACTIONS(3099),
    [anon_sym_DOT] = ACTIONS(3099),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3101),
    [anon_sym_new] = ACTIONS(3099),
    [anon_sym_return_BANG] = ACTIONS(3101),
    [anon_sym_yield] = ACTIONS(3099),
    [anon_sym_yield_BANG] = ACTIONS(3101),
    [anon_sym_lazy] = ACTIONS(3099),
    [anon_sym_assert] = ACTIONS(3099),
    [anon_sym_upcast] = ACTIONS(3099),
    [anon_sym_downcast] = ACTIONS(3099),
    [anon_sym_COLON_GT] = ACTIONS(3101),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3101),
    [anon_sym_for] = ACTIONS(3099),
    [anon_sym_while] = ACTIONS(3099),
    [anon_sym_if] = ACTIONS(3099),
    [anon_sym_fun] = ACTIONS(3099),
    [anon_sym_try] = ACTIONS(3099),
    [anon_sym_match] = ACTIONS(3099),
    [anon_sym_match_BANG] = ACTIONS(3101),
    [anon_sym_function] = ACTIONS(3099),
    [anon_sym_LT_DASH] = ACTIONS(3099),
    [anon_sym_DOT_LBRACK] = ACTIONS(3101),
    [anon_sym_LT] = ACTIONS(3101),
    [anon_sym_use] = ACTIONS(3099),
    [anon_sym_use_BANG] = ACTIONS(3101),
    [anon_sym_do_BANG] = ACTIONS(3101),
    [anon_sym_begin] = ACTIONS(3099),
    [anon_sym_LPAREN2] = ACTIONS(3099),
    [anon_sym_or] = ACTIONS(3099),
    [aux_sym_char_token1] = ACTIONS(3101),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3099),
    [anon_sym_DQUOTE] = ACTIONS(3099),
    [anon_sym_AT_DQUOTE] = ACTIONS(3101),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3101),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3101),
    [sym_bool] = ACTIONS(3099),
    [sym_unit] = ACTIONS(3101),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3099),
    [sym_op_identifier] = ACTIONS(3099),
    [anon_sym_PLUS] = ACTIONS(3099),
    [anon_sym_DASH] = ACTIONS(3099),
    [anon_sym_PLUS_DOT] = ACTIONS(3099),
    [anon_sym_DASH_DOT] = ACTIONS(3099),
    [anon_sym_PERCENT] = ACTIONS(3099),
    [anon_sym_AMP_AMP] = ACTIONS(3099),
    [anon_sym_TILDE] = ACTIONS(3101),
    [aux_sym_prefix_op_token1] = ACTIONS(3099),
    [aux_sym_infix_op_token1] = ACTIONS(3101),
    [aux_sym_infix_op_token2] = ACTIONS(3099),
    [anon_sym_PIPE_PIPE] = ACTIONS(3099),
    [anon_sym_BANG_EQ] = ACTIONS(3099),
    [anon_sym_COLON_EQ] = ACTIONS(3101),
    [anon_sym_DOLLAR] = ACTIONS(3099),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3099),
    [sym_int] = ACTIONS(3099),
    [sym_xint] = ACTIONS(3101),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3101),
    [sym__newline] = ACTIONS(3101),
    [sym__dedent] = ACTIONS(3101),
  },
  [1775] = {
    [sym_block_comment] = STATE(1775),
    [sym_compiler_directive_decl] = STATE(1775),
    [sym_fsi_directive_decl] = STATE(1775),
    [sym_preproc_line] = STATE(1775),
    [sym_identifier] = ACTIONS(3083),
    [anon_sym_EQ] = ACTIONS(3085),
    [anon_sym_COLON] = ACTIONS(3083),
    [anon_sym_return] = ACTIONS(3083),
    [anon_sym_do] = ACTIONS(3083),
    [anon_sym_and] = ACTIONS(3083),
    [anon_sym_let] = ACTIONS(3083),
    [anon_sym_let_BANG] = ACTIONS(3085),
    [anon_sym_LPAREN] = ACTIONS(3083),
    [anon_sym_COMMA] = ACTIONS(3085),
    [anon_sym_null] = ACTIONS(3083),
    [anon_sym_QMARK] = ACTIONS(3083),
    [anon_sym_COLON_QMARK] = ACTIONS(3083),
    [anon_sym_COLON_COLON] = ACTIONS(3085),
    [anon_sym_AMP] = ACTIONS(3083),
    [anon_sym_LBRACK] = ACTIONS(3083),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3085),
    [anon_sym_LBRACE] = ACTIONS(3083),
    [anon_sym_LT_AT] = ACTIONS(3083),
    [anon_sym_LT_AT_AT] = ACTIONS(3083),
    [anon_sym_DOT] = ACTIONS(3083),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3085),
    [anon_sym_new] = ACTIONS(3083),
    [anon_sym_return_BANG] = ACTIONS(3085),
    [anon_sym_yield] = ACTIONS(3083),
    [anon_sym_yield_BANG] = ACTIONS(3085),
    [anon_sym_lazy] = ACTIONS(3083),
    [anon_sym_assert] = ACTIONS(3083),
    [anon_sym_upcast] = ACTIONS(3083),
    [anon_sym_downcast] = ACTIONS(3083),
    [anon_sym_COLON_GT] = ACTIONS(3085),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3085),
    [anon_sym_for] = ACTIONS(3083),
    [anon_sym_while] = ACTIONS(3083),
    [anon_sym_if] = ACTIONS(3083),
    [anon_sym_fun] = ACTIONS(3083),
    [anon_sym_try] = ACTIONS(3083),
    [anon_sym_match] = ACTIONS(3083),
    [anon_sym_match_BANG] = ACTIONS(3085),
    [anon_sym_function] = ACTIONS(3083),
    [anon_sym_LT_DASH] = ACTIONS(3083),
    [anon_sym_DOT_LBRACK] = ACTIONS(3085),
    [anon_sym_LT] = ACTIONS(3085),
    [anon_sym_use] = ACTIONS(3083),
    [anon_sym_use_BANG] = ACTIONS(3085),
    [anon_sym_do_BANG] = ACTIONS(3085),
    [anon_sym_begin] = ACTIONS(3083),
    [anon_sym_LPAREN2] = ACTIONS(3083),
    [anon_sym_or] = ACTIONS(3083),
    [aux_sym_char_token1] = ACTIONS(3085),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3083),
    [anon_sym_DQUOTE] = ACTIONS(3083),
    [anon_sym_AT_DQUOTE] = ACTIONS(3085),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3085),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3085),
    [sym_bool] = ACTIONS(3083),
    [sym_unit] = ACTIONS(3085),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3083),
    [sym_op_identifier] = ACTIONS(3083),
    [anon_sym_PLUS] = ACTIONS(3083),
    [anon_sym_DASH] = ACTIONS(3083),
    [anon_sym_PLUS_DOT] = ACTIONS(3083),
    [anon_sym_DASH_DOT] = ACTIONS(3083),
    [anon_sym_PERCENT] = ACTIONS(3083),
    [anon_sym_AMP_AMP] = ACTIONS(3083),
    [anon_sym_TILDE] = ACTIONS(3085),
    [aux_sym_prefix_op_token1] = ACTIONS(3083),
    [aux_sym_infix_op_token1] = ACTIONS(3085),
    [aux_sym_infix_op_token2] = ACTIONS(3083),
    [anon_sym_PIPE_PIPE] = ACTIONS(3083),
    [anon_sym_BANG_EQ] = ACTIONS(3083),
    [anon_sym_COLON_EQ] = ACTIONS(3085),
    [anon_sym_DOLLAR] = ACTIONS(3083),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3083),
    [sym_int] = ACTIONS(3083),
    [sym_xint] = ACTIONS(3085),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3085),
    [sym__newline] = ACTIONS(3085),
    [sym__dedent] = ACTIONS(3085),
  },
  [1776] = {
    [sym_block_comment] = STATE(1776),
    [sym_compiler_directive_decl] = STATE(1776),
    [sym_fsi_directive_decl] = STATE(1776),
    [sym_preproc_line] = STATE(1776),
    [sym_identifier] = ACTIONS(3079),
    [anon_sym_EQ] = ACTIONS(3081),
    [anon_sym_COLON] = ACTIONS(3079),
    [anon_sym_return] = ACTIONS(3079),
    [anon_sym_do] = ACTIONS(3079),
    [anon_sym_and] = ACTIONS(3079),
    [anon_sym_let] = ACTIONS(3079),
    [anon_sym_let_BANG] = ACTIONS(3081),
    [anon_sym_LPAREN] = ACTIONS(3079),
    [anon_sym_COMMA] = ACTIONS(3081),
    [anon_sym_null] = ACTIONS(3079),
    [anon_sym_QMARK] = ACTIONS(3079),
    [anon_sym_COLON_QMARK] = ACTIONS(3079),
    [anon_sym_COLON_COLON] = ACTIONS(3081),
    [anon_sym_AMP] = ACTIONS(3079),
    [anon_sym_LBRACK] = ACTIONS(3079),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3081),
    [anon_sym_LBRACE] = ACTIONS(3079),
    [anon_sym_LT_AT] = ACTIONS(3079),
    [anon_sym_LT_AT_AT] = ACTIONS(3079),
    [anon_sym_DOT] = ACTIONS(3079),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3081),
    [anon_sym_new] = ACTIONS(3079),
    [anon_sym_return_BANG] = ACTIONS(3081),
    [anon_sym_yield] = ACTIONS(3079),
    [anon_sym_yield_BANG] = ACTIONS(3081),
    [anon_sym_lazy] = ACTIONS(3079),
    [anon_sym_assert] = ACTIONS(3079),
    [anon_sym_upcast] = ACTIONS(3079),
    [anon_sym_downcast] = ACTIONS(3079),
    [anon_sym_COLON_GT] = ACTIONS(3081),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3081),
    [anon_sym_for] = ACTIONS(3079),
    [anon_sym_while] = ACTIONS(3079),
    [anon_sym_if] = ACTIONS(3079),
    [anon_sym_fun] = ACTIONS(3079),
    [anon_sym_try] = ACTIONS(3079),
    [anon_sym_match] = ACTIONS(3079),
    [anon_sym_match_BANG] = ACTIONS(3081),
    [anon_sym_function] = ACTIONS(3079),
    [anon_sym_LT_DASH] = ACTIONS(3079),
    [anon_sym_DOT_LBRACK] = ACTIONS(3081),
    [anon_sym_LT] = ACTIONS(3081),
    [anon_sym_use] = ACTIONS(3079),
    [anon_sym_use_BANG] = ACTIONS(3081),
    [anon_sym_do_BANG] = ACTIONS(3081),
    [anon_sym_begin] = ACTIONS(3079),
    [anon_sym_LPAREN2] = ACTIONS(3079),
    [anon_sym_or] = ACTIONS(3079),
    [aux_sym_char_token1] = ACTIONS(3081),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3079),
    [anon_sym_DQUOTE] = ACTIONS(3079),
    [anon_sym_AT_DQUOTE] = ACTIONS(3081),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3081),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3081),
    [sym_bool] = ACTIONS(3079),
    [sym_unit] = ACTIONS(3081),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3079),
    [sym_op_identifier] = ACTIONS(3079),
    [anon_sym_PLUS] = ACTIONS(3079),
    [anon_sym_DASH] = ACTIONS(3079),
    [anon_sym_PLUS_DOT] = ACTIONS(3079),
    [anon_sym_DASH_DOT] = ACTIONS(3079),
    [anon_sym_PERCENT] = ACTIONS(3079),
    [anon_sym_AMP_AMP] = ACTIONS(3079),
    [anon_sym_TILDE] = ACTIONS(3081),
    [aux_sym_prefix_op_token1] = ACTIONS(3079),
    [aux_sym_infix_op_token1] = ACTIONS(3081),
    [aux_sym_infix_op_token2] = ACTIONS(3079),
    [anon_sym_PIPE_PIPE] = ACTIONS(3079),
    [anon_sym_BANG_EQ] = ACTIONS(3079),
    [anon_sym_COLON_EQ] = ACTIONS(3081),
    [anon_sym_DOLLAR] = ACTIONS(3079),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3079),
    [sym_int] = ACTIONS(3079),
    [sym_xint] = ACTIONS(3081),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3081),
    [sym__newline] = ACTIONS(3081),
    [sym__dedent] = ACTIONS(3081),
  },
  [1777] = {
    [sym_block_comment] = STATE(1777),
    [sym_compiler_directive_decl] = STATE(1777),
    [sym_fsi_directive_decl] = STATE(1777),
    [sym_preproc_line] = STATE(1777),
    [sym_identifier] = ACTIONS(3063),
    [anon_sym_EQ] = ACTIONS(3065),
    [anon_sym_COLON] = ACTIONS(3063),
    [anon_sym_return] = ACTIONS(3063),
    [anon_sym_do] = ACTIONS(3063),
    [anon_sym_and] = ACTIONS(3063),
    [anon_sym_let] = ACTIONS(3063),
    [anon_sym_let_BANG] = ACTIONS(3065),
    [anon_sym_LPAREN] = ACTIONS(3063),
    [anon_sym_COMMA] = ACTIONS(3065),
    [anon_sym_null] = ACTIONS(3063),
    [anon_sym_QMARK] = ACTIONS(3063),
    [anon_sym_COLON_QMARK] = ACTIONS(3063),
    [anon_sym_COLON_COLON] = ACTIONS(3065),
    [anon_sym_AMP] = ACTIONS(3063),
    [anon_sym_LBRACK] = ACTIONS(3063),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3065),
    [anon_sym_LBRACE] = ACTIONS(3063),
    [anon_sym_LT_AT] = ACTIONS(3063),
    [anon_sym_LT_AT_AT] = ACTIONS(3063),
    [anon_sym_DOT] = ACTIONS(3063),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3065),
    [anon_sym_new] = ACTIONS(3063),
    [anon_sym_return_BANG] = ACTIONS(3065),
    [anon_sym_yield] = ACTIONS(3063),
    [anon_sym_yield_BANG] = ACTIONS(3065),
    [anon_sym_lazy] = ACTIONS(3063),
    [anon_sym_assert] = ACTIONS(3063),
    [anon_sym_upcast] = ACTIONS(3063),
    [anon_sym_downcast] = ACTIONS(3063),
    [anon_sym_COLON_GT] = ACTIONS(3065),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3065),
    [anon_sym_for] = ACTIONS(3063),
    [anon_sym_while] = ACTIONS(3063),
    [anon_sym_if] = ACTIONS(3063),
    [anon_sym_fun] = ACTIONS(3063),
    [anon_sym_try] = ACTIONS(3063),
    [anon_sym_match] = ACTIONS(3063),
    [anon_sym_match_BANG] = ACTIONS(3065),
    [anon_sym_function] = ACTIONS(3063),
    [anon_sym_LT_DASH] = ACTIONS(3063),
    [anon_sym_DOT_LBRACK] = ACTIONS(3065),
    [anon_sym_LT] = ACTIONS(3065),
    [anon_sym_use] = ACTIONS(3063),
    [anon_sym_use_BANG] = ACTIONS(3065),
    [anon_sym_do_BANG] = ACTIONS(3065),
    [anon_sym_begin] = ACTIONS(3063),
    [anon_sym_LPAREN2] = ACTIONS(3063),
    [anon_sym_or] = ACTIONS(3063),
    [aux_sym_char_token1] = ACTIONS(3065),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3063),
    [anon_sym_DQUOTE] = ACTIONS(3063),
    [anon_sym_AT_DQUOTE] = ACTIONS(3065),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3065),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3065),
    [sym_bool] = ACTIONS(3063),
    [sym_unit] = ACTIONS(3065),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3063),
    [sym_op_identifier] = ACTIONS(3063),
    [anon_sym_PLUS] = ACTIONS(3063),
    [anon_sym_DASH] = ACTIONS(3063),
    [anon_sym_PLUS_DOT] = ACTIONS(3063),
    [anon_sym_DASH_DOT] = ACTIONS(3063),
    [anon_sym_PERCENT] = ACTIONS(3063),
    [anon_sym_AMP_AMP] = ACTIONS(3063),
    [anon_sym_TILDE] = ACTIONS(3065),
    [aux_sym_prefix_op_token1] = ACTIONS(3063),
    [aux_sym_infix_op_token1] = ACTIONS(3065),
    [aux_sym_infix_op_token2] = ACTIONS(3063),
    [anon_sym_PIPE_PIPE] = ACTIONS(3063),
    [anon_sym_BANG_EQ] = ACTIONS(3063),
    [anon_sym_COLON_EQ] = ACTIONS(3065),
    [anon_sym_DOLLAR] = ACTIONS(3063),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3063),
    [sym_int] = ACTIONS(3063),
    [sym_xint] = ACTIONS(3065),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3065),
    [sym__newline] = ACTIONS(3065),
    [sym__dedent] = ACTIONS(3065),
  },
  [1778] = {
    [sym_block_comment] = STATE(1778),
    [sym_compiler_directive_decl] = STATE(1778),
    [sym_fsi_directive_decl] = STATE(1778),
    [sym_preproc_line] = STATE(1778),
    [sym_identifier] = ACTIONS(3059),
    [anon_sym_EQ] = ACTIONS(3061),
    [anon_sym_COLON] = ACTIONS(3059),
    [anon_sym_return] = ACTIONS(3059),
    [anon_sym_do] = ACTIONS(3059),
    [anon_sym_and] = ACTIONS(3059),
    [anon_sym_let] = ACTIONS(3059),
    [anon_sym_let_BANG] = ACTIONS(3061),
    [anon_sym_LPAREN] = ACTIONS(3059),
    [anon_sym_COMMA] = ACTIONS(3061),
    [anon_sym_null] = ACTIONS(3059),
    [anon_sym_QMARK] = ACTIONS(3059),
    [anon_sym_COLON_QMARK] = ACTIONS(3059),
    [anon_sym_COLON_COLON] = ACTIONS(3061),
    [anon_sym_AMP] = ACTIONS(3059),
    [anon_sym_LBRACK] = ACTIONS(3059),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3061),
    [anon_sym_LBRACE] = ACTIONS(3059),
    [anon_sym_LT_AT] = ACTIONS(3059),
    [anon_sym_LT_AT_AT] = ACTIONS(3059),
    [anon_sym_DOT] = ACTIONS(3059),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3061),
    [anon_sym_new] = ACTIONS(3059),
    [anon_sym_return_BANG] = ACTIONS(3061),
    [anon_sym_yield] = ACTIONS(3059),
    [anon_sym_yield_BANG] = ACTIONS(3061),
    [anon_sym_lazy] = ACTIONS(3059),
    [anon_sym_assert] = ACTIONS(3059),
    [anon_sym_upcast] = ACTIONS(3059),
    [anon_sym_downcast] = ACTIONS(3059),
    [anon_sym_COLON_GT] = ACTIONS(3061),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3061),
    [anon_sym_for] = ACTIONS(3059),
    [anon_sym_while] = ACTIONS(3059),
    [anon_sym_if] = ACTIONS(3059),
    [anon_sym_fun] = ACTIONS(3059),
    [anon_sym_try] = ACTIONS(3059),
    [anon_sym_match] = ACTIONS(3059),
    [anon_sym_match_BANG] = ACTIONS(3061),
    [anon_sym_function] = ACTIONS(3059),
    [anon_sym_LT_DASH] = ACTIONS(3059),
    [anon_sym_DOT_LBRACK] = ACTIONS(3061),
    [anon_sym_LT] = ACTIONS(3061),
    [anon_sym_use] = ACTIONS(3059),
    [anon_sym_use_BANG] = ACTIONS(3061),
    [anon_sym_do_BANG] = ACTIONS(3061),
    [anon_sym_begin] = ACTIONS(3059),
    [anon_sym_LPAREN2] = ACTIONS(3059),
    [anon_sym_or] = ACTIONS(3059),
    [aux_sym_char_token1] = ACTIONS(3061),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3059),
    [anon_sym_DQUOTE] = ACTIONS(3059),
    [anon_sym_AT_DQUOTE] = ACTIONS(3061),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3061),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3061),
    [sym_bool] = ACTIONS(3059),
    [sym_unit] = ACTIONS(3061),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3059),
    [sym_op_identifier] = ACTIONS(3059),
    [anon_sym_PLUS] = ACTIONS(3059),
    [anon_sym_DASH] = ACTIONS(3059),
    [anon_sym_PLUS_DOT] = ACTIONS(3059),
    [anon_sym_DASH_DOT] = ACTIONS(3059),
    [anon_sym_PERCENT] = ACTIONS(3059),
    [anon_sym_AMP_AMP] = ACTIONS(3059),
    [anon_sym_TILDE] = ACTIONS(3061),
    [aux_sym_prefix_op_token1] = ACTIONS(3059),
    [aux_sym_infix_op_token1] = ACTIONS(3061),
    [aux_sym_infix_op_token2] = ACTIONS(3059),
    [anon_sym_PIPE_PIPE] = ACTIONS(3059),
    [anon_sym_BANG_EQ] = ACTIONS(3059),
    [anon_sym_COLON_EQ] = ACTIONS(3061),
    [anon_sym_DOLLAR] = ACTIONS(3059),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3059),
    [sym_int] = ACTIONS(3059),
    [sym_xint] = ACTIONS(3061),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3061),
    [sym__newline] = ACTIONS(3061),
    [sym__dedent] = ACTIONS(3061),
  },
  [1779] = {
    [sym_block_comment] = STATE(1779),
    [sym_compiler_directive_decl] = STATE(1779),
    [sym_fsi_directive_decl] = STATE(1779),
    [sym_preproc_line] = STATE(1779),
    [sym_identifier] = ACTIONS(3051),
    [anon_sym_EQ] = ACTIONS(3053),
    [anon_sym_COLON] = ACTIONS(3051),
    [anon_sym_return] = ACTIONS(3051),
    [anon_sym_do] = ACTIONS(3051),
    [anon_sym_and] = ACTIONS(3051),
    [anon_sym_let] = ACTIONS(3051),
    [anon_sym_let_BANG] = ACTIONS(3053),
    [anon_sym_LPAREN] = ACTIONS(3051),
    [anon_sym_COMMA] = ACTIONS(3053),
    [anon_sym_null] = ACTIONS(3051),
    [anon_sym_QMARK] = ACTIONS(3051),
    [anon_sym_COLON_QMARK] = ACTIONS(3051),
    [anon_sym_COLON_COLON] = ACTIONS(3053),
    [anon_sym_AMP] = ACTIONS(3051),
    [anon_sym_LBRACK] = ACTIONS(3051),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3053),
    [anon_sym_LBRACE] = ACTIONS(3051),
    [anon_sym_LT_AT] = ACTIONS(3051),
    [anon_sym_LT_AT_AT] = ACTIONS(3051),
    [anon_sym_DOT] = ACTIONS(3051),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3053),
    [anon_sym_new] = ACTIONS(3051),
    [anon_sym_return_BANG] = ACTIONS(3053),
    [anon_sym_yield] = ACTIONS(3051),
    [anon_sym_yield_BANG] = ACTIONS(3053),
    [anon_sym_lazy] = ACTIONS(3051),
    [anon_sym_assert] = ACTIONS(3051),
    [anon_sym_upcast] = ACTIONS(3051),
    [anon_sym_downcast] = ACTIONS(3051),
    [anon_sym_COLON_GT] = ACTIONS(3053),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3053),
    [anon_sym_for] = ACTIONS(3051),
    [anon_sym_while] = ACTIONS(3051),
    [anon_sym_if] = ACTIONS(3051),
    [anon_sym_fun] = ACTIONS(3051),
    [anon_sym_try] = ACTIONS(3051),
    [anon_sym_match] = ACTIONS(3051),
    [anon_sym_match_BANG] = ACTIONS(3053),
    [anon_sym_function] = ACTIONS(3051),
    [anon_sym_LT_DASH] = ACTIONS(3051),
    [anon_sym_DOT_LBRACK] = ACTIONS(3053),
    [anon_sym_LT] = ACTIONS(3053),
    [anon_sym_use] = ACTIONS(3051),
    [anon_sym_use_BANG] = ACTIONS(3053),
    [anon_sym_do_BANG] = ACTIONS(3053),
    [anon_sym_begin] = ACTIONS(3051),
    [anon_sym_LPAREN2] = ACTIONS(3051),
    [anon_sym_or] = ACTIONS(3051),
    [aux_sym_char_token1] = ACTIONS(3053),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3051),
    [anon_sym_DQUOTE] = ACTIONS(3051),
    [anon_sym_AT_DQUOTE] = ACTIONS(3053),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3053),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3053),
    [sym_bool] = ACTIONS(3051),
    [sym_unit] = ACTIONS(3053),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3051),
    [sym_op_identifier] = ACTIONS(3051),
    [anon_sym_PLUS] = ACTIONS(3051),
    [anon_sym_DASH] = ACTIONS(3051),
    [anon_sym_PLUS_DOT] = ACTIONS(3051),
    [anon_sym_DASH_DOT] = ACTIONS(3051),
    [anon_sym_PERCENT] = ACTIONS(3051),
    [anon_sym_AMP_AMP] = ACTIONS(3051),
    [anon_sym_TILDE] = ACTIONS(3053),
    [aux_sym_prefix_op_token1] = ACTIONS(3051),
    [aux_sym_infix_op_token1] = ACTIONS(3053),
    [aux_sym_infix_op_token2] = ACTIONS(3051),
    [anon_sym_PIPE_PIPE] = ACTIONS(3051),
    [anon_sym_BANG_EQ] = ACTIONS(3051),
    [anon_sym_COLON_EQ] = ACTIONS(3053),
    [anon_sym_DOLLAR] = ACTIONS(3051),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3051),
    [sym_int] = ACTIONS(3051),
    [sym_xint] = ACTIONS(3053),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3053),
    [sym__newline] = ACTIONS(3053),
    [sym__dedent] = ACTIONS(3053),
  },
  [1780] = {
    [sym_block_comment] = STATE(1780),
    [sym_compiler_directive_decl] = STATE(1780),
    [sym_fsi_directive_decl] = STATE(1780),
    [sym_preproc_line] = STATE(1780),
    [sym_identifier] = ACTIONS(3047),
    [anon_sym_EQ] = ACTIONS(3049),
    [anon_sym_COLON] = ACTIONS(3047),
    [anon_sym_return] = ACTIONS(3047),
    [anon_sym_do] = ACTIONS(3047),
    [anon_sym_and] = ACTIONS(3047),
    [anon_sym_let] = ACTIONS(3047),
    [anon_sym_let_BANG] = ACTIONS(3049),
    [anon_sym_LPAREN] = ACTIONS(3047),
    [anon_sym_COMMA] = ACTIONS(3049),
    [anon_sym_null] = ACTIONS(3047),
    [anon_sym_QMARK] = ACTIONS(3047),
    [anon_sym_COLON_QMARK] = ACTIONS(3047),
    [anon_sym_COLON_COLON] = ACTIONS(3049),
    [anon_sym_AMP] = ACTIONS(3047),
    [anon_sym_LBRACK] = ACTIONS(3047),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3049),
    [anon_sym_LBRACE] = ACTIONS(3047),
    [anon_sym_LT_AT] = ACTIONS(3047),
    [anon_sym_LT_AT_AT] = ACTIONS(3047),
    [anon_sym_DOT] = ACTIONS(3047),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3049),
    [anon_sym_new] = ACTIONS(3047),
    [anon_sym_return_BANG] = ACTIONS(3049),
    [anon_sym_yield] = ACTIONS(3047),
    [anon_sym_yield_BANG] = ACTIONS(3049),
    [anon_sym_lazy] = ACTIONS(3047),
    [anon_sym_assert] = ACTIONS(3047),
    [anon_sym_upcast] = ACTIONS(3047),
    [anon_sym_downcast] = ACTIONS(3047),
    [anon_sym_COLON_GT] = ACTIONS(3049),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3049),
    [anon_sym_for] = ACTIONS(3047),
    [anon_sym_while] = ACTIONS(3047),
    [anon_sym_if] = ACTIONS(3047),
    [anon_sym_fun] = ACTIONS(3047),
    [anon_sym_try] = ACTIONS(3047),
    [anon_sym_match] = ACTIONS(3047),
    [anon_sym_match_BANG] = ACTIONS(3049),
    [anon_sym_function] = ACTIONS(3047),
    [anon_sym_LT_DASH] = ACTIONS(3047),
    [anon_sym_DOT_LBRACK] = ACTIONS(3049),
    [anon_sym_LT] = ACTIONS(3049),
    [anon_sym_use] = ACTIONS(3047),
    [anon_sym_use_BANG] = ACTIONS(3049),
    [anon_sym_do_BANG] = ACTIONS(3049),
    [anon_sym_begin] = ACTIONS(3047),
    [anon_sym_LPAREN2] = ACTIONS(3047),
    [anon_sym_or] = ACTIONS(3047),
    [aux_sym_char_token1] = ACTIONS(3049),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3047),
    [anon_sym_DQUOTE] = ACTIONS(3047),
    [anon_sym_AT_DQUOTE] = ACTIONS(3049),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3049),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3049),
    [sym_bool] = ACTIONS(3047),
    [sym_unit] = ACTIONS(3049),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3047),
    [sym_op_identifier] = ACTIONS(3047),
    [anon_sym_PLUS] = ACTIONS(3047),
    [anon_sym_DASH] = ACTIONS(3047),
    [anon_sym_PLUS_DOT] = ACTIONS(3047),
    [anon_sym_DASH_DOT] = ACTIONS(3047),
    [anon_sym_PERCENT] = ACTIONS(3047),
    [anon_sym_AMP_AMP] = ACTIONS(3047),
    [anon_sym_TILDE] = ACTIONS(3049),
    [aux_sym_prefix_op_token1] = ACTIONS(3047),
    [aux_sym_infix_op_token1] = ACTIONS(3049),
    [aux_sym_infix_op_token2] = ACTIONS(3047),
    [anon_sym_PIPE_PIPE] = ACTIONS(3047),
    [anon_sym_BANG_EQ] = ACTIONS(3047),
    [anon_sym_COLON_EQ] = ACTIONS(3049),
    [anon_sym_DOLLAR] = ACTIONS(3047),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3047),
    [sym_int] = ACTIONS(3047),
    [sym_xint] = ACTIONS(3049),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3049),
    [sym__newline] = ACTIONS(3049),
    [sym__dedent] = ACTIONS(3049),
  },
  [1781] = {
    [sym_block_comment] = STATE(1781),
    [sym_compiler_directive_decl] = STATE(1781),
    [sym_fsi_directive_decl] = STATE(1781),
    [sym_preproc_line] = STATE(1781),
    [sym_identifier] = ACTIONS(3043),
    [anon_sym_EQ] = ACTIONS(3045),
    [anon_sym_COLON] = ACTIONS(3043),
    [anon_sym_return] = ACTIONS(3043),
    [anon_sym_do] = ACTIONS(3043),
    [anon_sym_and] = ACTIONS(3043),
    [anon_sym_let] = ACTIONS(3043),
    [anon_sym_let_BANG] = ACTIONS(3045),
    [anon_sym_LPAREN] = ACTIONS(3043),
    [anon_sym_COMMA] = ACTIONS(3045),
    [anon_sym_null] = ACTIONS(3043),
    [anon_sym_QMARK] = ACTIONS(3043),
    [anon_sym_COLON_QMARK] = ACTIONS(3043),
    [anon_sym_COLON_COLON] = ACTIONS(3045),
    [anon_sym_AMP] = ACTIONS(3043),
    [anon_sym_LBRACK] = ACTIONS(3043),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3045),
    [anon_sym_LBRACE] = ACTIONS(3043),
    [anon_sym_LT_AT] = ACTIONS(3043),
    [anon_sym_LT_AT_AT] = ACTIONS(3043),
    [anon_sym_DOT] = ACTIONS(3043),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3045),
    [anon_sym_new] = ACTIONS(3043),
    [anon_sym_return_BANG] = ACTIONS(3045),
    [anon_sym_yield] = ACTIONS(3043),
    [anon_sym_yield_BANG] = ACTIONS(3045),
    [anon_sym_lazy] = ACTIONS(3043),
    [anon_sym_assert] = ACTIONS(3043),
    [anon_sym_upcast] = ACTIONS(3043),
    [anon_sym_downcast] = ACTIONS(3043),
    [anon_sym_COLON_GT] = ACTIONS(3045),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3045),
    [anon_sym_for] = ACTIONS(3043),
    [anon_sym_while] = ACTIONS(3043),
    [anon_sym_if] = ACTIONS(3043),
    [anon_sym_fun] = ACTIONS(3043),
    [anon_sym_try] = ACTIONS(3043),
    [anon_sym_match] = ACTIONS(3043),
    [anon_sym_match_BANG] = ACTIONS(3045),
    [anon_sym_function] = ACTIONS(3043),
    [anon_sym_LT_DASH] = ACTIONS(3043),
    [anon_sym_DOT_LBRACK] = ACTIONS(3045),
    [anon_sym_LT] = ACTIONS(3045),
    [anon_sym_use] = ACTIONS(3043),
    [anon_sym_use_BANG] = ACTIONS(3045),
    [anon_sym_do_BANG] = ACTIONS(3045),
    [anon_sym_begin] = ACTIONS(3043),
    [anon_sym_LPAREN2] = ACTIONS(3043),
    [anon_sym_or] = ACTIONS(3043),
    [aux_sym_char_token1] = ACTIONS(3045),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3043),
    [anon_sym_DQUOTE] = ACTIONS(3043),
    [anon_sym_AT_DQUOTE] = ACTIONS(3045),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3045),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3045),
    [sym_bool] = ACTIONS(3043),
    [sym_unit] = ACTIONS(3045),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3043),
    [sym_op_identifier] = ACTIONS(3043),
    [anon_sym_PLUS] = ACTIONS(3043),
    [anon_sym_DASH] = ACTIONS(3043),
    [anon_sym_PLUS_DOT] = ACTIONS(3043),
    [anon_sym_DASH_DOT] = ACTIONS(3043),
    [anon_sym_PERCENT] = ACTIONS(3043),
    [anon_sym_AMP_AMP] = ACTIONS(3043),
    [anon_sym_TILDE] = ACTIONS(3045),
    [aux_sym_prefix_op_token1] = ACTIONS(3043),
    [aux_sym_infix_op_token1] = ACTIONS(3045),
    [aux_sym_infix_op_token2] = ACTIONS(3043),
    [anon_sym_PIPE_PIPE] = ACTIONS(3043),
    [anon_sym_BANG_EQ] = ACTIONS(3043),
    [anon_sym_COLON_EQ] = ACTIONS(3045),
    [anon_sym_DOLLAR] = ACTIONS(3043),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3043),
    [sym_int] = ACTIONS(3043),
    [sym_xint] = ACTIONS(3045),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3045),
    [sym__newline] = ACTIONS(3045),
    [sym__dedent] = ACTIONS(3045),
  },
  [1782] = {
    [sym_block_comment] = STATE(1782),
    [sym_compiler_directive_decl] = STATE(1782),
    [sym_fsi_directive_decl] = STATE(1782),
    [sym_preproc_line] = STATE(1782),
    [sym_identifier] = ACTIONS(3039),
    [anon_sym_EQ] = ACTIONS(3041),
    [anon_sym_COLON] = ACTIONS(3039),
    [anon_sym_return] = ACTIONS(3039),
    [anon_sym_do] = ACTIONS(3039),
    [anon_sym_and] = ACTIONS(3039),
    [anon_sym_let] = ACTIONS(3039),
    [anon_sym_let_BANG] = ACTIONS(3041),
    [anon_sym_LPAREN] = ACTIONS(3039),
    [anon_sym_COMMA] = ACTIONS(3041),
    [anon_sym_null] = ACTIONS(3039),
    [anon_sym_QMARK] = ACTIONS(3039),
    [anon_sym_COLON_QMARK] = ACTIONS(3039),
    [anon_sym_COLON_COLON] = ACTIONS(3041),
    [anon_sym_AMP] = ACTIONS(3039),
    [anon_sym_LBRACK] = ACTIONS(3039),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3041),
    [anon_sym_LBRACE] = ACTIONS(3039),
    [anon_sym_LT_AT] = ACTIONS(3039),
    [anon_sym_LT_AT_AT] = ACTIONS(3039),
    [anon_sym_DOT] = ACTIONS(3039),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3041),
    [anon_sym_new] = ACTIONS(3039),
    [anon_sym_return_BANG] = ACTIONS(3041),
    [anon_sym_yield] = ACTIONS(3039),
    [anon_sym_yield_BANG] = ACTIONS(3041),
    [anon_sym_lazy] = ACTIONS(3039),
    [anon_sym_assert] = ACTIONS(3039),
    [anon_sym_upcast] = ACTIONS(3039),
    [anon_sym_downcast] = ACTIONS(3039),
    [anon_sym_COLON_GT] = ACTIONS(3041),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3041),
    [anon_sym_for] = ACTIONS(3039),
    [anon_sym_while] = ACTIONS(3039),
    [anon_sym_if] = ACTIONS(3039),
    [anon_sym_fun] = ACTIONS(3039),
    [anon_sym_try] = ACTIONS(3039),
    [anon_sym_match] = ACTIONS(3039),
    [anon_sym_match_BANG] = ACTIONS(3041),
    [anon_sym_function] = ACTIONS(3039),
    [anon_sym_LT_DASH] = ACTIONS(3039),
    [anon_sym_DOT_LBRACK] = ACTIONS(3041),
    [anon_sym_LT] = ACTIONS(3041),
    [anon_sym_use] = ACTIONS(3039),
    [anon_sym_use_BANG] = ACTIONS(3041),
    [anon_sym_do_BANG] = ACTIONS(3041),
    [anon_sym_begin] = ACTIONS(3039),
    [anon_sym_LPAREN2] = ACTIONS(3039),
    [anon_sym_or] = ACTIONS(3039),
    [aux_sym_char_token1] = ACTIONS(3041),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3039),
    [anon_sym_DQUOTE] = ACTIONS(3039),
    [anon_sym_AT_DQUOTE] = ACTIONS(3041),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3041),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3041),
    [sym_bool] = ACTIONS(3039),
    [sym_unit] = ACTIONS(3041),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3039),
    [sym_op_identifier] = ACTIONS(3039),
    [anon_sym_PLUS] = ACTIONS(3039),
    [anon_sym_DASH] = ACTIONS(3039),
    [anon_sym_PLUS_DOT] = ACTIONS(3039),
    [anon_sym_DASH_DOT] = ACTIONS(3039),
    [anon_sym_PERCENT] = ACTIONS(3039),
    [anon_sym_AMP_AMP] = ACTIONS(3039),
    [anon_sym_TILDE] = ACTIONS(3041),
    [aux_sym_prefix_op_token1] = ACTIONS(3039),
    [aux_sym_infix_op_token1] = ACTIONS(3041),
    [aux_sym_infix_op_token2] = ACTIONS(3039),
    [anon_sym_PIPE_PIPE] = ACTIONS(3039),
    [anon_sym_BANG_EQ] = ACTIONS(3039),
    [anon_sym_COLON_EQ] = ACTIONS(3041),
    [anon_sym_DOLLAR] = ACTIONS(3039),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3039),
    [sym_int] = ACTIONS(3039),
    [sym_xint] = ACTIONS(3041),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3041),
    [sym__newline] = ACTIONS(3041),
    [sym__dedent] = ACTIONS(3041),
  },
  [1783] = {
    [sym_block_comment] = STATE(1783),
    [sym_compiler_directive_decl] = STATE(1783),
    [sym_fsi_directive_decl] = STATE(1783),
    [sym_preproc_line] = STATE(1783),
    [sym_identifier] = ACTIONS(3115),
    [anon_sym_EQ] = ACTIONS(3117),
    [anon_sym_COLON] = ACTIONS(3115),
    [anon_sym_return] = ACTIONS(3115),
    [anon_sym_do] = ACTIONS(3115),
    [anon_sym_let] = ACTIONS(3115),
    [anon_sym_let_BANG] = ACTIONS(3117),
    [anon_sym_as] = ACTIONS(3115),
    [anon_sym_LPAREN] = ACTIONS(3115),
    [anon_sym_COMMA] = ACTIONS(3117),
    [anon_sym_null] = ACTIONS(3115),
    [anon_sym_QMARK] = ACTIONS(3115),
    [anon_sym_COLON_QMARK] = ACTIONS(3115),
    [anon_sym_COLON_COLON] = ACTIONS(3117),
    [anon_sym_AMP] = ACTIONS(3115),
    [anon_sym_LBRACK] = ACTIONS(3115),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3117),
    [anon_sym_LBRACE] = ACTIONS(3115),
    [anon_sym_LT_AT] = ACTIONS(3115),
    [anon_sym_LT_AT_AT] = ACTIONS(3115),
    [anon_sym_DOT] = ACTIONS(3115),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3117),
    [anon_sym_new] = ACTIONS(3115),
    [anon_sym_with] = ACTIONS(3115),
    [anon_sym_return_BANG] = ACTIONS(3117),
    [anon_sym_yield] = ACTIONS(3115),
    [anon_sym_yield_BANG] = ACTIONS(3117),
    [anon_sym_lazy] = ACTIONS(3115),
    [anon_sym_assert] = ACTIONS(3115),
    [anon_sym_upcast] = ACTIONS(3115),
    [anon_sym_downcast] = ACTIONS(3115),
    [anon_sym_COLON_GT] = ACTIONS(3117),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3117),
    [anon_sym_for] = ACTIONS(3115),
    [anon_sym_while] = ACTIONS(3115),
    [anon_sym_if] = ACTIONS(3115),
    [anon_sym_fun] = ACTIONS(3115),
    [anon_sym_try] = ACTIONS(3115),
    [anon_sym_match] = ACTIONS(3115),
    [anon_sym_match_BANG] = ACTIONS(3117),
    [anon_sym_function] = ACTIONS(3115),
    [anon_sym_LT_DASH] = ACTIONS(3115),
    [anon_sym_DOT_LBRACK] = ACTIONS(3117),
    [anon_sym_LT] = ACTIONS(3117),
    [anon_sym_use] = ACTIONS(3115),
    [anon_sym_use_BANG] = ACTIONS(3117),
    [anon_sym_do_BANG] = ACTIONS(3117),
    [anon_sym_begin] = ACTIONS(3115),
    [anon_sym_LPAREN2] = ACTIONS(3115),
    [anon_sym_or] = ACTIONS(3115),
    [aux_sym_char_token1] = ACTIONS(3117),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3115),
    [anon_sym_DQUOTE] = ACTIONS(3115),
    [anon_sym_AT_DQUOTE] = ACTIONS(3117),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3117),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3117),
    [sym_bool] = ACTIONS(3115),
    [sym_unit] = ACTIONS(3117),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3115),
    [sym_op_identifier] = ACTIONS(3115),
    [anon_sym_PLUS] = ACTIONS(3115),
    [anon_sym_DASH] = ACTIONS(3115),
    [anon_sym_PLUS_DOT] = ACTIONS(3115),
    [anon_sym_DASH_DOT] = ACTIONS(3115),
    [anon_sym_PERCENT] = ACTIONS(3115),
    [anon_sym_AMP_AMP] = ACTIONS(3115),
    [anon_sym_TILDE] = ACTIONS(3117),
    [aux_sym_prefix_op_token1] = ACTIONS(3115),
    [aux_sym_infix_op_token1] = ACTIONS(3117),
    [aux_sym_infix_op_token2] = ACTIONS(3115),
    [anon_sym_PIPE_PIPE] = ACTIONS(3115),
    [anon_sym_BANG_EQ] = ACTIONS(3115),
    [anon_sym_COLON_EQ] = ACTIONS(3117),
    [anon_sym_DOLLAR] = ACTIONS(3115),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3115),
    [sym_int] = ACTIONS(3115),
    [sym_xint] = ACTIONS(3117),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3117),
    [sym__newline] = ACTIONS(3117),
  },
  [1784] = {
    [sym_block_comment] = STATE(1784),
    [sym_compiler_directive_decl] = STATE(1784),
    [sym_fsi_directive_decl] = STATE(1784),
    [sym_preproc_line] = STATE(1784),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_EQ] = ACTIONS(3017),
    [anon_sym_COLON] = ACTIONS(3015),
    [anon_sym_return] = ACTIONS(3015),
    [anon_sym_do] = ACTIONS(3015),
    [anon_sym_and] = ACTIONS(3015),
    [anon_sym_let] = ACTIONS(3015),
    [anon_sym_let_BANG] = ACTIONS(3017),
    [anon_sym_LPAREN] = ACTIONS(3015),
    [anon_sym_COMMA] = ACTIONS(3017),
    [anon_sym_null] = ACTIONS(3015),
    [anon_sym_QMARK] = ACTIONS(3015),
    [anon_sym_COLON_QMARK] = ACTIONS(3015),
    [anon_sym_COLON_COLON] = ACTIONS(3017),
    [anon_sym_AMP] = ACTIONS(3015),
    [anon_sym_LBRACK] = ACTIONS(3015),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3017),
    [anon_sym_LBRACE] = ACTIONS(3015),
    [anon_sym_LT_AT] = ACTIONS(3015),
    [anon_sym_LT_AT_AT] = ACTIONS(3015),
    [anon_sym_DOT] = ACTIONS(3015),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3017),
    [anon_sym_new] = ACTIONS(3015),
    [anon_sym_return_BANG] = ACTIONS(3017),
    [anon_sym_yield] = ACTIONS(3015),
    [anon_sym_yield_BANG] = ACTIONS(3017),
    [anon_sym_lazy] = ACTIONS(3015),
    [anon_sym_assert] = ACTIONS(3015),
    [anon_sym_upcast] = ACTIONS(3015),
    [anon_sym_downcast] = ACTIONS(3015),
    [anon_sym_COLON_GT] = ACTIONS(3017),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3017),
    [anon_sym_for] = ACTIONS(3015),
    [anon_sym_while] = ACTIONS(3015),
    [anon_sym_if] = ACTIONS(3015),
    [anon_sym_fun] = ACTIONS(3015),
    [anon_sym_try] = ACTIONS(3015),
    [anon_sym_match] = ACTIONS(3015),
    [anon_sym_match_BANG] = ACTIONS(3017),
    [anon_sym_function] = ACTIONS(3015),
    [anon_sym_LT_DASH] = ACTIONS(3015),
    [anon_sym_DOT_LBRACK] = ACTIONS(3017),
    [anon_sym_LT] = ACTIONS(3017),
    [anon_sym_use] = ACTIONS(3015),
    [anon_sym_use_BANG] = ACTIONS(3017),
    [anon_sym_do_BANG] = ACTIONS(3017),
    [anon_sym_begin] = ACTIONS(3015),
    [anon_sym_LPAREN2] = ACTIONS(3015),
    [anon_sym_or] = ACTIONS(3015),
    [aux_sym_char_token1] = ACTIONS(3017),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3015),
    [anon_sym_DQUOTE] = ACTIONS(3015),
    [anon_sym_AT_DQUOTE] = ACTIONS(3017),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3017),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3017),
    [sym_bool] = ACTIONS(3015),
    [sym_unit] = ACTIONS(3017),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3015),
    [sym_op_identifier] = ACTIONS(3015),
    [anon_sym_PLUS] = ACTIONS(3015),
    [anon_sym_DASH] = ACTIONS(3015),
    [anon_sym_PLUS_DOT] = ACTIONS(3015),
    [anon_sym_DASH_DOT] = ACTIONS(3015),
    [anon_sym_PERCENT] = ACTIONS(3015),
    [anon_sym_AMP_AMP] = ACTIONS(3015),
    [anon_sym_TILDE] = ACTIONS(3017),
    [aux_sym_prefix_op_token1] = ACTIONS(3015),
    [aux_sym_infix_op_token1] = ACTIONS(3017),
    [aux_sym_infix_op_token2] = ACTIONS(3015),
    [anon_sym_PIPE_PIPE] = ACTIONS(3015),
    [anon_sym_BANG_EQ] = ACTIONS(3015),
    [anon_sym_COLON_EQ] = ACTIONS(3017),
    [anon_sym_DOLLAR] = ACTIONS(3015),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3015),
    [sym_int] = ACTIONS(3015),
    [sym_xint] = ACTIONS(3017),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3017),
    [sym__newline] = ACTIONS(3017),
    [sym__dedent] = ACTIONS(3017),
  },
  [1785] = {
    [sym_block_comment] = STATE(1785),
    [sym_compiler_directive_decl] = STATE(1785),
    [sym_fsi_directive_decl] = STATE(1785),
    [sym_preproc_line] = STATE(1785),
    [sym_identifier] = ACTIONS(3007),
    [anon_sym_EQ] = ACTIONS(3009),
    [anon_sym_COLON] = ACTIONS(3007),
    [anon_sym_return] = ACTIONS(3007),
    [anon_sym_do] = ACTIONS(3007),
    [anon_sym_and] = ACTIONS(3007),
    [anon_sym_let] = ACTIONS(3007),
    [anon_sym_let_BANG] = ACTIONS(3009),
    [anon_sym_LPAREN] = ACTIONS(3007),
    [anon_sym_COMMA] = ACTIONS(3009),
    [anon_sym_null] = ACTIONS(3007),
    [anon_sym_QMARK] = ACTIONS(3007),
    [anon_sym_COLON_QMARK] = ACTIONS(3007),
    [anon_sym_COLON_COLON] = ACTIONS(3009),
    [anon_sym_AMP] = ACTIONS(3007),
    [anon_sym_LBRACK] = ACTIONS(3007),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3009),
    [anon_sym_LBRACE] = ACTIONS(3007),
    [anon_sym_LT_AT] = ACTIONS(3007),
    [anon_sym_LT_AT_AT] = ACTIONS(3007),
    [anon_sym_DOT] = ACTIONS(3007),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3009),
    [anon_sym_new] = ACTIONS(3007),
    [anon_sym_return_BANG] = ACTIONS(3009),
    [anon_sym_yield] = ACTIONS(3007),
    [anon_sym_yield_BANG] = ACTIONS(3009),
    [anon_sym_lazy] = ACTIONS(3007),
    [anon_sym_assert] = ACTIONS(3007),
    [anon_sym_upcast] = ACTIONS(3007),
    [anon_sym_downcast] = ACTIONS(3007),
    [anon_sym_COLON_GT] = ACTIONS(3009),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3009),
    [anon_sym_for] = ACTIONS(3007),
    [anon_sym_while] = ACTIONS(3007),
    [anon_sym_if] = ACTIONS(3007),
    [anon_sym_fun] = ACTIONS(3007),
    [anon_sym_try] = ACTIONS(3007),
    [anon_sym_match] = ACTIONS(3007),
    [anon_sym_match_BANG] = ACTIONS(3009),
    [anon_sym_function] = ACTIONS(3007),
    [anon_sym_LT_DASH] = ACTIONS(3007),
    [anon_sym_DOT_LBRACK] = ACTIONS(3009),
    [anon_sym_LT] = ACTIONS(3009),
    [anon_sym_use] = ACTIONS(3007),
    [anon_sym_use_BANG] = ACTIONS(3009),
    [anon_sym_do_BANG] = ACTIONS(3009),
    [anon_sym_begin] = ACTIONS(3007),
    [anon_sym_LPAREN2] = ACTIONS(3007),
    [anon_sym_or] = ACTIONS(3007),
    [aux_sym_char_token1] = ACTIONS(3009),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3007),
    [anon_sym_DQUOTE] = ACTIONS(3007),
    [anon_sym_AT_DQUOTE] = ACTIONS(3009),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3009),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3009),
    [sym_bool] = ACTIONS(3007),
    [sym_unit] = ACTIONS(3009),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3007),
    [sym_op_identifier] = ACTIONS(3007),
    [anon_sym_PLUS] = ACTIONS(3007),
    [anon_sym_DASH] = ACTIONS(3007),
    [anon_sym_PLUS_DOT] = ACTIONS(3007),
    [anon_sym_DASH_DOT] = ACTIONS(3007),
    [anon_sym_PERCENT] = ACTIONS(3007),
    [anon_sym_AMP_AMP] = ACTIONS(3007),
    [anon_sym_TILDE] = ACTIONS(3009),
    [aux_sym_prefix_op_token1] = ACTIONS(3007),
    [aux_sym_infix_op_token1] = ACTIONS(3009),
    [aux_sym_infix_op_token2] = ACTIONS(3007),
    [anon_sym_PIPE_PIPE] = ACTIONS(3007),
    [anon_sym_BANG_EQ] = ACTIONS(3007),
    [anon_sym_COLON_EQ] = ACTIONS(3009),
    [anon_sym_DOLLAR] = ACTIONS(3007),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3007),
    [sym_int] = ACTIONS(3007),
    [sym_xint] = ACTIONS(3009),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3009),
    [sym__newline] = ACTIONS(3009),
    [sym__dedent] = ACTIONS(3009),
  },
  [1786] = {
    [sym_block_comment] = STATE(1786),
    [sym_compiler_directive_decl] = STATE(1786),
    [sym_fsi_directive_decl] = STATE(1786),
    [sym_preproc_line] = STATE(1786),
    [sym_identifier] = ACTIONS(3003),
    [anon_sym_EQ] = ACTIONS(3005),
    [anon_sym_COLON] = ACTIONS(3003),
    [anon_sym_return] = ACTIONS(3003),
    [anon_sym_do] = ACTIONS(3003),
    [anon_sym_and] = ACTIONS(3003),
    [anon_sym_let] = ACTIONS(3003),
    [anon_sym_let_BANG] = ACTIONS(3005),
    [anon_sym_LPAREN] = ACTIONS(3003),
    [anon_sym_COMMA] = ACTIONS(3005),
    [anon_sym_null] = ACTIONS(3003),
    [anon_sym_QMARK] = ACTIONS(3003),
    [anon_sym_COLON_QMARK] = ACTIONS(3003),
    [anon_sym_COLON_COLON] = ACTIONS(3005),
    [anon_sym_AMP] = ACTIONS(3003),
    [anon_sym_LBRACK] = ACTIONS(3003),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3005),
    [anon_sym_LBRACE] = ACTIONS(3003),
    [anon_sym_LT_AT] = ACTIONS(3003),
    [anon_sym_LT_AT_AT] = ACTIONS(3003),
    [anon_sym_DOT] = ACTIONS(3003),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3005),
    [anon_sym_new] = ACTIONS(3003),
    [anon_sym_return_BANG] = ACTIONS(3005),
    [anon_sym_yield] = ACTIONS(3003),
    [anon_sym_yield_BANG] = ACTIONS(3005),
    [anon_sym_lazy] = ACTIONS(3003),
    [anon_sym_assert] = ACTIONS(3003),
    [anon_sym_upcast] = ACTIONS(3003),
    [anon_sym_downcast] = ACTIONS(3003),
    [anon_sym_COLON_GT] = ACTIONS(3005),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3005),
    [anon_sym_for] = ACTIONS(3003),
    [anon_sym_while] = ACTIONS(3003),
    [anon_sym_if] = ACTIONS(3003),
    [anon_sym_fun] = ACTIONS(3003),
    [anon_sym_try] = ACTIONS(3003),
    [anon_sym_match] = ACTIONS(3003),
    [anon_sym_match_BANG] = ACTIONS(3005),
    [anon_sym_function] = ACTIONS(3003),
    [anon_sym_LT_DASH] = ACTIONS(3003),
    [anon_sym_DOT_LBRACK] = ACTIONS(3005),
    [anon_sym_LT] = ACTIONS(3005),
    [anon_sym_use] = ACTIONS(3003),
    [anon_sym_use_BANG] = ACTIONS(3005),
    [anon_sym_do_BANG] = ACTIONS(3005),
    [anon_sym_begin] = ACTIONS(3003),
    [anon_sym_LPAREN2] = ACTIONS(3003),
    [anon_sym_or] = ACTIONS(3003),
    [aux_sym_char_token1] = ACTIONS(3005),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3003),
    [anon_sym_DQUOTE] = ACTIONS(3003),
    [anon_sym_AT_DQUOTE] = ACTIONS(3005),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3005),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3005),
    [sym_bool] = ACTIONS(3003),
    [sym_unit] = ACTIONS(3005),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3003),
    [sym_op_identifier] = ACTIONS(3003),
    [anon_sym_PLUS] = ACTIONS(3003),
    [anon_sym_DASH] = ACTIONS(3003),
    [anon_sym_PLUS_DOT] = ACTIONS(3003),
    [anon_sym_DASH_DOT] = ACTIONS(3003),
    [anon_sym_PERCENT] = ACTIONS(3003),
    [anon_sym_AMP_AMP] = ACTIONS(3003),
    [anon_sym_TILDE] = ACTIONS(3005),
    [aux_sym_prefix_op_token1] = ACTIONS(3003),
    [aux_sym_infix_op_token1] = ACTIONS(3005),
    [aux_sym_infix_op_token2] = ACTIONS(3003),
    [anon_sym_PIPE_PIPE] = ACTIONS(3003),
    [anon_sym_BANG_EQ] = ACTIONS(3003),
    [anon_sym_COLON_EQ] = ACTIONS(3005),
    [anon_sym_DOLLAR] = ACTIONS(3003),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3003),
    [sym_int] = ACTIONS(3003),
    [sym_xint] = ACTIONS(3005),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3005),
    [sym__newline] = ACTIONS(3005),
    [sym__dedent] = ACTIONS(3005),
  },
  [1787] = {
    [sym_block_comment] = STATE(1787),
    [sym_compiler_directive_decl] = STATE(1787),
    [sym_fsi_directive_decl] = STATE(1787),
    [sym_preproc_line] = STATE(1787),
    [sym_identifier] = ACTIONS(2996),
    [anon_sym_EQ] = ACTIONS(2998),
    [anon_sym_COLON] = ACTIONS(2996),
    [anon_sym_return] = ACTIONS(2996),
    [anon_sym_do] = ACTIONS(2996),
    [anon_sym_and] = ACTIONS(2996),
    [anon_sym_let] = ACTIONS(2996),
    [anon_sym_let_BANG] = ACTIONS(2998),
    [anon_sym_LPAREN] = ACTIONS(2996),
    [anon_sym_COMMA] = ACTIONS(2998),
    [anon_sym_null] = ACTIONS(2996),
    [anon_sym_QMARK] = ACTIONS(2996),
    [anon_sym_COLON_QMARK] = ACTIONS(2996),
    [anon_sym_COLON_COLON] = ACTIONS(2998),
    [anon_sym_AMP] = ACTIONS(2996),
    [anon_sym_LBRACK] = ACTIONS(2996),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2998),
    [anon_sym_LBRACE] = ACTIONS(2996),
    [anon_sym_LT_AT] = ACTIONS(2996),
    [anon_sym_LT_AT_AT] = ACTIONS(2996),
    [anon_sym_DOT] = ACTIONS(2996),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2998),
    [anon_sym_new] = ACTIONS(2996),
    [anon_sym_return_BANG] = ACTIONS(2998),
    [anon_sym_yield] = ACTIONS(2996),
    [anon_sym_yield_BANG] = ACTIONS(2998),
    [anon_sym_lazy] = ACTIONS(2996),
    [anon_sym_assert] = ACTIONS(2996),
    [anon_sym_upcast] = ACTIONS(2996),
    [anon_sym_downcast] = ACTIONS(2996),
    [anon_sym_COLON_GT] = ACTIONS(2998),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2998),
    [anon_sym_for] = ACTIONS(2996),
    [anon_sym_while] = ACTIONS(2996),
    [anon_sym_if] = ACTIONS(2996),
    [anon_sym_fun] = ACTIONS(2996),
    [anon_sym_try] = ACTIONS(2996),
    [anon_sym_match] = ACTIONS(2996),
    [anon_sym_match_BANG] = ACTIONS(2998),
    [anon_sym_function] = ACTIONS(2996),
    [anon_sym_LT_DASH] = ACTIONS(2996),
    [anon_sym_DOT_LBRACK] = ACTIONS(2998),
    [anon_sym_LT] = ACTIONS(2998),
    [anon_sym_use] = ACTIONS(2996),
    [anon_sym_use_BANG] = ACTIONS(2998),
    [anon_sym_do_BANG] = ACTIONS(2998),
    [anon_sym_begin] = ACTIONS(2996),
    [anon_sym_LPAREN2] = ACTIONS(2996),
    [anon_sym_or] = ACTIONS(2996),
    [aux_sym_char_token1] = ACTIONS(2998),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2996),
    [anon_sym_DQUOTE] = ACTIONS(2996),
    [anon_sym_AT_DQUOTE] = ACTIONS(2998),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2998),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2998),
    [sym_bool] = ACTIONS(2996),
    [sym_unit] = ACTIONS(2998),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2996),
    [sym_op_identifier] = ACTIONS(2996),
    [anon_sym_PLUS] = ACTIONS(2996),
    [anon_sym_DASH] = ACTIONS(2996),
    [anon_sym_PLUS_DOT] = ACTIONS(2996),
    [anon_sym_DASH_DOT] = ACTIONS(2996),
    [anon_sym_PERCENT] = ACTIONS(2996),
    [anon_sym_AMP_AMP] = ACTIONS(2996),
    [anon_sym_TILDE] = ACTIONS(2998),
    [aux_sym_prefix_op_token1] = ACTIONS(2996),
    [aux_sym_infix_op_token1] = ACTIONS(2998),
    [aux_sym_infix_op_token2] = ACTIONS(2996),
    [anon_sym_PIPE_PIPE] = ACTIONS(2996),
    [anon_sym_BANG_EQ] = ACTIONS(2996),
    [anon_sym_COLON_EQ] = ACTIONS(2998),
    [anon_sym_DOLLAR] = ACTIONS(2996),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2996),
    [sym_int] = ACTIONS(2996),
    [sym_xint] = ACTIONS(2998),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2998),
    [sym__newline] = ACTIONS(2998),
    [sym__dedent] = ACTIONS(2998),
  },
  [1788] = {
    [sym_block_comment] = STATE(1788),
    [sym_compiler_directive_decl] = STATE(1788),
    [sym_fsi_directive_decl] = STATE(1788),
    [sym_preproc_line] = STATE(1788),
    [sym_identifier] = ACTIONS(2992),
    [anon_sym_EQ] = ACTIONS(2994),
    [anon_sym_COLON] = ACTIONS(2992),
    [anon_sym_return] = ACTIONS(2992),
    [anon_sym_do] = ACTIONS(2992),
    [anon_sym_and] = ACTIONS(2992),
    [anon_sym_let] = ACTIONS(2992),
    [anon_sym_let_BANG] = ACTIONS(2994),
    [anon_sym_LPAREN] = ACTIONS(2992),
    [anon_sym_COMMA] = ACTIONS(2994),
    [anon_sym_null] = ACTIONS(2992),
    [anon_sym_QMARK] = ACTIONS(2992),
    [anon_sym_COLON_QMARK] = ACTIONS(2992),
    [anon_sym_COLON_COLON] = ACTIONS(2994),
    [anon_sym_AMP] = ACTIONS(2992),
    [anon_sym_LBRACK] = ACTIONS(2992),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2994),
    [anon_sym_LBRACE] = ACTIONS(2992),
    [anon_sym_LT_AT] = ACTIONS(2992),
    [anon_sym_LT_AT_AT] = ACTIONS(2992),
    [anon_sym_DOT] = ACTIONS(2992),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2994),
    [anon_sym_new] = ACTIONS(2992),
    [anon_sym_return_BANG] = ACTIONS(2994),
    [anon_sym_yield] = ACTIONS(2992),
    [anon_sym_yield_BANG] = ACTIONS(2994),
    [anon_sym_lazy] = ACTIONS(2992),
    [anon_sym_assert] = ACTIONS(2992),
    [anon_sym_upcast] = ACTIONS(2992),
    [anon_sym_downcast] = ACTIONS(2992),
    [anon_sym_COLON_GT] = ACTIONS(2994),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2994),
    [anon_sym_for] = ACTIONS(2992),
    [anon_sym_while] = ACTIONS(2992),
    [anon_sym_if] = ACTIONS(2992),
    [anon_sym_fun] = ACTIONS(2992),
    [anon_sym_try] = ACTIONS(2992),
    [anon_sym_match] = ACTIONS(2992),
    [anon_sym_match_BANG] = ACTIONS(2994),
    [anon_sym_function] = ACTIONS(2992),
    [anon_sym_LT_DASH] = ACTIONS(2992),
    [anon_sym_DOT_LBRACK] = ACTIONS(2994),
    [anon_sym_LT] = ACTIONS(2994),
    [anon_sym_use] = ACTIONS(2992),
    [anon_sym_use_BANG] = ACTIONS(2994),
    [anon_sym_do_BANG] = ACTIONS(2994),
    [anon_sym_begin] = ACTIONS(2992),
    [anon_sym_LPAREN2] = ACTIONS(2992),
    [anon_sym_or] = ACTIONS(2992),
    [aux_sym_char_token1] = ACTIONS(2994),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2992),
    [anon_sym_DQUOTE] = ACTIONS(2992),
    [anon_sym_AT_DQUOTE] = ACTIONS(2994),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2994),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2994),
    [sym_bool] = ACTIONS(2992),
    [sym_unit] = ACTIONS(2994),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2992),
    [sym_op_identifier] = ACTIONS(2992),
    [anon_sym_PLUS] = ACTIONS(2992),
    [anon_sym_DASH] = ACTIONS(2992),
    [anon_sym_PLUS_DOT] = ACTIONS(2992),
    [anon_sym_DASH_DOT] = ACTIONS(2992),
    [anon_sym_PERCENT] = ACTIONS(2992),
    [anon_sym_AMP_AMP] = ACTIONS(2992),
    [anon_sym_TILDE] = ACTIONS(2994),
    [aux_sym_prefix_op_token1] = ACTIONS(2992),
    [aux_sym_infix_op_token1] = ACTIONS(2994),
    [aux_sym_infix_op_token2] = ACTIONS(2992),
    [anon_sym_PIPE_PIPE] = ACTIONS(2992),
    [anon_sym_BANG_EQ] = ACTIONS(2992),
    [anon_sym_COLON_EQ] = ACTIONS(2994),
    [anon_sym_DOLLAR] = ACTIONS(2992),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2992),
    [sym_int] = ACTIONS(2992),
    [sym_xint] = ACTIONS(2994),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2994),
    [sym__newline] = ACTIONS(2994),
    [sym__dedent] = ACTIONS(2994),
  },
  [1789] = {
    [sym_block_comment] = STATE(1789),
    [sym_compiler_directive_decl] = STATE(1789),
    [sym_fsi_directive_decl] = STATE(1789),
    [sym_preproc_line] = STATE(1789),
    [sym_identifier] = ACTIONS(2978),
    [anon_sym_EQ] = ACTIONS(2980),
    [anon_sym_COLON] = ACTIONS(2978),
    [anon_sym_return] = ACTIONS(2978),
    [anon_sym_do] = ACTIONS(2978),
    [anon_sym_and] = ACTIONS(2978),
    [anon_sym_let] = ACTIONS(2978),
    [anon_sym_let_BANG] = ACTIONS(2980),
    [anon_sym_LPAREN] = ACTIONS(2978),
    [anon_sym_COMMA] = ACTIONS(2980),
    [anon_sym_null] = ACTIONS(2978),
    [anon_sym_QMARK] = ACTIONS(2978),
    [anon_sym_COLON_QMARK] = ACTIONS(2978),
    [anon_sym_COLON_COLON] = ACTIONS(2980),
    [anon_sym_AMP] = ACTIONS(2978),
    [anon_sym_LBRACK] = ACTIONS(2978),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2980),
    [anon_sym_LBRACE] = ACTIONS(2978),
    [anon_sym_LT_AT] = ACTIONS(2978),
    [anon_sym_LT_AT_AT] = ACTIONS(2978),
    [anon_sym_DOT] = ACTIONS(2978),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2980),
    [anon_sym_new] = ACTIONS(2978),
    [anon_sym_return_BANG] = ACTIONS(2980),
    [anon_sym_yield] = ACTIONS(2978),
    [anon_sym_yield_BANG] = ACTIONS(2980),
    [anon_sym_lazy] = ACTIONS(2978),
    [anon_sym_assert] = ACTIONS(2978),
    [anon_sym_upcast] = ACTIONS(2978),
    [anon_sym_downcast] = ACTIONS(2978),
    [anon_sym_COLON_GT] = ACTIONS(2980),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2980),
    [anon_sym_for] = ACTIONS(2978),
    [anon_sym_while] = ACTIONS(2978),
    [anon_sym_if] = ACTIONS(2978),
    [anon_sym_fun] = ACTIONS(2978),
    [anon_sym_try] = ACTIONS(2978),
    [anon_sym_match] = ACTIONS(2978),
    [anon_sym_match_BANG] = ACTIONS(2980),
    [anon_sym_function] = ACTIONS(2978),
    [anon_sym_LT_DASH] = ACTIONS(2978),
    [anon_sym_DOT_LBRACK] = ACTIONS(2980),
    [anon_sym_LT] = ACTIONS(2980),
    [anon_sym_use] = ACTIONS(2978),
    [anon_sym_use_BANG] = ACTIONS(2980),
    [anon_sym_do_BANG] = ACTIONS(2980),
    [anon_sym_begin] = ACTIONS(2978),
    [anon_sym_LPAREN2] = ACTIONS(2978),
    [anon_sym_or] = ACTIONS(2978),
    [aux_sym_char_token1] = ACTIONS(2980),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2978),
    [anon_sym_DQUOTE] = ACTIONS(2978),
    [anon_sym_AT_DQUOTE] = ACTIONS(2980),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2980),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2980),
    [sym_bool] = ACTIONS(2978),
    [sym_unit] = ACTIONS(2980),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2978),
    [sym_op_identifier] = ACTIONS(2978),
    [anon_sym_PLUS] = ACTIONS(2978),
    [anon_sym_DASH] = ACTIONS(2978),
    [anon_sym_PLUS_DOT] = ACTIONS(2978),
    [anon_sym_DASH_DOT] = ACTIONS(2978),
    [anon_sym_PERCENT] = ACTIONS(2978),
    [anon_sym_AMP_AMP] = ACTIONS(2978),
    [anon_sym_TILDE] = ACTIONS(2980),
    [aux_sym_prefix_op_token1] = ACTIONS(2978),
    [aux_sym_infix_op_token1] = ACTIONS(2980),
    [aux_sym_infix_op_token2] = ACTIONS(2978),
    [anon_sym_PIPE_PIPE] = ACTIONS(2978),
    [anon_sym_BANG_EQ] = ACTIONS(2978),
    [anon_sym_COLON_EQ] = ACTIONS(2980),
    [anon_sym_DOLLAR] = ACTIONS(2978),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2978),
    [sym_int] = ACTIONS(2978),
    [sym_xint] = ACTIONS(2980),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2980),
    [sym__newline] = ACTIONS(2980),
    [sym__dedent] = ACTIONS(2980),
  },
  [1790] = {
    [sym_block_comment] = STATE(1790),
    [sym_compiler_directive_decl] = STATE(1790),
    [sym_fsi_directive_decl] = STATE(1790),
    [sym_preproc_line] = STATE(1790),
    [sym_identifier] = ACTIONS(2954),
    [anon_sym_EQ] = ACTIONS(2956),
    [anon_sym_COLON] = ACTIONS(2954),
    [anon_sym_return] = ACTIONS(2954),
    [anon_sym_do] = ACTIONS(2954),
    [anon_sym_let] = ACTIONS(2954),
    [anon_sym_let_BANG] = ACTIONS(2956),
    [anon_sym_as] = ACTIONS(2954),
    [anon_sym_LPAREN] = ACTIONS(2954),
    [anon_sym_COMMA] = ACTIONS(2956),
    [anon_sym_null] = ACTIONS(2954),
    [anon_sym_QMARK] = ACTIONS(2954),
    [anon_sym_COLON_QMARK] = ACTIONS(2954),
    [anon_sym_COLON_COLON] = ACTIONS(2956),
    [anon_sym_AMP] = ACTIONS(2954),
    [anon_sym_LBRACK] = ACTIONS(2954),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2956),
    [anon_sym_LBRACE] = ACTIONS(2954),
    [anon_sym_LT_AT] = ACTIONS(2954),
    [anon_sym_LT_AT_AT] = ACTIONS(2954),
    [anon_sym_DOT] = ACTIONS(2954),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2956),
    [anon_sym_new] = ACTIONS(2954),
    [anon_sym_with] = ACTIONS(2954),
    [anon_sym_return_BANG] = ACTIONS(2956),
    [anon_sym_yield] = ACTIONS(2954),
    [anon_sym_yield_BANG] = ACTIONS(2956),
    [anon_sym_lazy] = ACTIONS(2954),
    [anon_sym_assert] = ACTIONS(2954),
    [anon_sym_upcast] = ACTIONS(2954),
    [anon_sym_downcast] = ACTIONS(2954),
    [anon_sym_COLON_GT] = ACTIONS(2956),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2956),
    [anon_sym_for] = ACTIONS(2954),
    [anon_sym_while] = ACTIONS(2954),
    [anon_sym_if] = ACTIONS(2954),
    [anon_sym_fun] = ACTIONS(2954),
    [anon_sym_try] = ACTIONS(2954),
    [anon_sym_match] = ACTIONS(2954),
    [anon_sym_match_BANG] = ACTIONS(2956),
    [anon_sym_function] = ACTIONS(2954),
    [anon_sym_LT_DASH] = ACTIONS(2954),
    [anon_sym_DOT_LBRACK] = ACTIONS(2956),
    [anon_sym_LT] = ACTIONS(2956),
    [anon_sym_use] = ACTIONS(2954),
    [anon_sym_use_BANG] = ACTIONS(2956),
    [anon_sym_do_BANG] = ACTIONS(2956),
    [anon_sym_begin] = ACTIONS(2954),
    [anon_sym_LPAREN2] = ACTIONS(2954),
    [anon_sym_or] = ACTIONS(2954),
    [aux_sym_char_token1] = ACTIONS(2956),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2954),
    [anon_sym_DQUOTE] = ACTIONS(2954),
    [anon_sym_AT_DQUOTE] = ACTIONS(2956),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2956),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2956),
    [sym_bool] = ACTIONS(2954),
    [sym_unit] = ACTIONS(2956),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2954),
    [sym_op_identifier] = ACTIONS(2954),
    [anon_sym_PLUS] = ACTIONS(2954),
    [anon_sym_DASH] = ACTIONS(2954),
    [anon_sym_PLUS_DOT] = ACTIONS(2954),
    [anon_sym_DASH_DOT] = ACTIONS(2954),
    [anon_sym_PERCENT] = ACTIONS(2954),
    [anon_sym_AMP_AMP] = ACTIONS(2954),
    [anon_sym_TILDE] = ACTIONS(2956),
    [aux_sym_prefix_op_token1] = ACTIONS(2954),
    [aux_sym_infix_op_token1] = ACTIONS(2956),
    [aux_sym_infix_op_token2] = ACTIONS(2954),
    [anon_sym_PIPE_PIPE] = ACTIONS(2954),
    [anon_sym_BANG_EQ] = ACTIONS(2954),
    [anon_sym_COLON_EQ] = ACTIONS(2956),
    [anon_sym_DOLLAR] = ACTIONS(2954),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2954),
    [sym_int] = ACTIONS(2954),
    [sym_xint] = ACTIONS(2956),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2956),
    [sym__newline] = ACTIONS(2956),
  },
  [1791] = {
    [sym_block_comment] = STATE(1791),
    [sym_compiler_directive_decl] = STATE(1791),
    [sym_fsi_directive_decl] = STATE(1791),
    [sym_preproc_line] = STATE(1791),
    [sym_identifier] = ACTIONS(2954),
    [anon_sym_EQ] = ACTIONS(2956),
    [anon_sym_COLON] = ACTIONS(2954),
    [anon_sym_return] = ACTIONS(2954),
    [anon_sym_do] = ACTIONS(2954),
    [anon_sym_and] = ACTIONS(2954),
    [anon_sym_let] = ACTIONS(2954),
    [anon_sym_let_BANG] = ACTIONS(2956),
    [anon_sym_LPAREN] = ACTIONS(2954),
    [anon_sym_COMMA] = ACTIONS(2956),
    [anon_sym_null] = ACTIONS(2954),
    [anon_sym_QMARK] = ACTIONS(2954),
    [anon_sym_COLON_QMARK] = ACTIONS(2954),
    [anon_sym_COLON_COLON] = ACTIONS(2956),
    [anon_sym_AMP] = ACTIONS(2954),
    [anon_sym_LBRACK] = ACTIONS(2954),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2956),
    [anon_sym_LBRACE] = ACTIONS(2954),
    [anon_sym_LT_AT] = ACTIONS(2954),
    [anon_sym_LT_AT_AT] = ACTIONS(2954),
    [anon_sym_DOT] = ACTIONS(2954),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2956),
    [anon_sym_new] = ACTIONS(2954),
    [anon_sym_return_BANG] = ACTIONS(2956),
    [anon_sym_yield] = ACTIONS(2954),
    [anon_sym_yield_BANG] = ACTIONS(2956),
    [anon_sym_lazy] = ACTIONS(2954),
    [anon_sym_assert] = ACTIONS(2954),
    [anon_sym_upcast] = ACTIONS(2954),
    [anon_sym_downcast] = ACTIONS(2954),
    [anon_sym_COLON_GT] = ACTIONS(2956),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2956),
    [anon_sym_for] = ACTIONS(2954),
    [anon_sym_while] = ACTIONS(2954),
    [anon_sym_if] = ACTIONS(2954),
    [anon_sym_fun] = ACTIONS(2954),
    [anon_sym_try] = ACTIONS(2954),
    [anon_sym_match] = ACTIONS(2954),
    [anon_sym_match_BANG] = ACTIONS(2956),
    [anon_sym_function] = ACTIONS(2954),
    [anon_sym_LT_DASH] = ACTIONS(2954),
    [anon_sym_DOT_LBRACK] = ACTIONS(2956),
    [anon_sym_LT] = ACTIONS(2956),
    [anon_sym_use] = ACTIONS(2954),
    [anon_sym_use_BANG] = ACTIONS(2956),
    [anon_sym_do_BANG] = ACTIONS(2956),
    [anon_sym_begin] = ACTIONS(2954),
    [anon_sym_LPAREN2] = ACTIONS(2954),
    [anon_sym_or] = ACTIONS(2954),
    [aux_sym_char_token1] = ACTIONS(2956),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2954),
    [anon_sym_DQUOTE] = ACTIONS(2954),
    [anon_sym_AT_DQUOTE] = ACTIONS(2956),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2956),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2956),
    [sym_bool] = ACTIONS(2954),
    [sym_unit] = ACTIONS(2956),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2954),
    [sym_op_identifier] = ACTIONS(2954),
    [anon_sym_PLUS] = ACTIONS(2954),
    [anon_sym_DASH] = ACTIONS(2954),
    [anon_sym_PLUS_DOT] = ACTIONS(2954),
    [anon_sym_DASH_DOT] = ACTIONS(2954),
    [anon_sym_PERCENT] = ACTIONS(2954),
    [anon_sym_AMP_AMP] = ACTIONS(2954),
    [anon_sym_TILDE] = ACTIONS(2956),
    [aux_sym_prefix_op_token1] = ACTIONS(2954),
    [aux_sym_infix_op_token1] = ACTIONS(2956),
    [aux_sym_infix_op_token2] = ACTIONS(2954),
    [anon_sym_PIPE_PIPE] = ACTIONS(2954),
    [anon_sym_BANG_EQ] = ACTIONS(2954),
    [anon_sym_COLON_EQ] = ACTIONS(2956),
    [anon_sym_DOLLAR] = ACTIONS(2954),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2954),
    [sym_int] = ACTIONS(2954),
    [sym_xint] = ACTIONS(2956),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2956),
    [sym__newline] = ACTIONS(2956),
    [sym__dedent] = ACTIONS(2956),
  },
  [1792] = {
    [sym_attributes] = STATE(2636),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(3546),
    [sym__pattern] = STATE(1491),
    [sym_optional_pattern] = STATE(3546),
    [sym_type_check_pattern] = STATE(3546),
    [sym_attribute_pattern] = STATE(3546),
    [sym_paren_pattern] = STATE(3546),
    [sym_as_pattern] = STATE(3546),
    [sym_cons_pattern] = STATE(3546),
    [sym_disjunct_pattern] = STATE(3546),
    [sym_conjunct_pattern] = STATE(3546),
    [sym_typed_pattern] = STATE(3546),
    [sym_list_pattern] = STATE(3546),
    [sym_array_pattern] = STATE(3546),
    [sym_record_pattern] = STATE(3546),
    [sym_named_field_pattern] = STATE(3546),
    [sym_identifier_pattern] = STATE(3546),
    [sym_long_identifier_or_op] = STATE(1834),
    [sym_char] = STATE(3509),
    [sym_format_string] = STATE(3517),
    [sym__string_literal] = STATE(3517),
    [sym_string] = STATE(3509),
    [sym_verbatim_string] = STATE(3509),
    [sym_bytearray] = STATE(3509),
    [sym_verbatim_bytearray] = STATE(3509),
    [sym_format_triple_quoted_string] = STATE(3519),
    [sym_triple_quoted_string] = STATE(3509),
    [sym_const] = STATE(3546),
    [sym_long_identifier] = STATE(3320),
    [sym_active_pattern] = STATE(3488),
    [sym__identifier_or_op] = STATE(3410),
    [sym_sbyte] = STATE(3509),
    [sym_byte] = STATE(3509),
    [sym_int16] = STATE(3509),
    [sym_uint16] = STATE(3509),
    [sym_int32] = STATE(3509),
    [sym_uint32] = STATE(3509),
    [sym_nativeint] = STATE(3509),
    [sym_unativeint] = STATE(3509),
    [sym_int64] = STATE(3509),
    [sym_uint64] = STATE(3509),
    [sym_ieee32] = STATE(3509),
    [sym_ieee64] = STATE(3509),
    [sym_bignum] = STATE(3509),
    [sym_decimal] = STATE(3509),
    [sym_float] = STATE(3291),
    [sym_block_comment] = STATE(1792),
    [sym_compiler_directive_decl] = STATE(1792),
    [sym_fsi_directive_decl] = STATE(1792),
    [sym_preproc_line] = STATE(1792),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(3562),
    [anon_sym_EQ] = ACTIONS(3964),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_COLON] = ACTIONS(3960),
    [anon_sym_as] = ACTIONS(3960),
    [anon_sym_LPAREN] = ACTIONS(4014),
    [anon_sym_RPAREN] = ACTIONS(3964),
    [anon_sym_COMMA] = ACTIONS(3964),
    [anon_sym_null] = ACTIONS(4016),
    [anon_sym__] = ACTIONS(4018),
    [anon_sym_QMARK] = ACTIONS(4020),
    [anon_sym_COLON_QMARK] = ACTIONS(4022),
    [anon_sym_COLON_COLON] = ACTIONS(3964),
    [anon_sym_PIPE] = ACTIONS(3964),
    [anon_sym_AMP] = ACTIONS(3964),
    [anon_sym_LBRACK] = ACTIONS(4024),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4026),
    [anon_sym_LBRACE] = ACTIONS(4028),
    [anon_sym_LT2] = ACTIONS(3964),
    [aux_sym_char_token1] = ACTIONS(4030),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4032),
    [anon_sym_DQUOTE] = ACTIONS(4034),
    [anon_sym_AT_DQUOTE] = ACTIONS(4036),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4038),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4040),
    [sym_bool] = ACTIONS(4042),
    [sym_unit] = ACTIONS(4044),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3606),
    [sym_op_identifier] = ACTIONS(3608),
    [sym_int] = ACTIONS(4046),
    [sym_xint] = ACTIONS(4048),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [1793] = {
    [sym_block_comment] = STATE(1793),
    [sym_compiler_directive_decl] = STATE(1793),
    [sym_fsi_directive_decl] = STATE(1793),
    [sym_preproc_line] = STATE(1793),
    [sym_identifier] = ACTIONS(2930),
    [anon_sym_EQ] = ACTIONS(2932),
    [anon_sym_COLON] = ACTIONS(2930),
    [anon_sym_return] = ACTIONS(2930),
    [anon_sym_do] = ACTIONS(2930),
    [anon_sym_and] = ACTIONS(2930),
    [anon_sym_let] = ACTIONS(2930),
    [anon_sym_let_BANG] = ACTIONS(2932),
    [anon_sym_LPAREN] = ACTIONS(2930),
    [anon_sym_COMMA] = ACTIONS(2932),
    [anon_sym_null] = ACTIONS(2930),
    [anon_sym_QMARK] = ACTIONS(2930),
    [anon_sym_COLON_QMARK] = ACTIONS(2930),
    [anon_sym_COLON_COLON] = ACTIONS(2932),
    [anon_sym_AMP] = ACTIONS(2930),
    [anon_sym_LBRACK] = ACTIONS(2930),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2932),
    [anon_sym_LBRACE] = ACTIONS(2930),
    [anon_sym_LT_AT] = ACTIONS(2930),
    [anon_sym_LT_AT_AT] = ACTIONS(2930),
    [anon_sym_DOT] = ACTIONS(2930),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2932),
    [anon_sym_new] = ACTIONS(2930),
    [anon_sym_return_BANG] = ACTIONS(2932),
    [anon_sym_yield] = ACTIONS(2930),
    [anon_sym_yield_BANG] = ACTIONS(2932),
    [anon_sym_lazy] = ACTIONS(2930),
    [anon_sym_assert] = ACTIONS(2930),
    [anon_sym_upcast] = ACTIONS(2930),
    [anon_sym_downcast] = ACTIONS(2930),
    [anon_sym_COLON_GT] = ACTIONS(2932),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2932),
    [anon_sym_for] = ACTIONS(2930),
    [anon_sym_while] = ACTIONS(2930),
    [anon_sym_if] = ACTIONS(2930),
    [anon_sym_fun] = ACTIONS(2930),
    [anon_sym_try] = ACTIONS(2930),
    [anon_sym_match] = ACTIONS(2930),
    [anon_sym_match_BANG] = ACTIONS(2932),
    [anon_sym_function] = ACTIONS(2930),
    [anon_sym_LT_DASH] = ACTIONS(2930),
    [anon_sym_DOT_LBRACK] = ACTIONS(2932),
    [anon_sym_LT] = ACTIONS(2932),
    [anon_sym_use] = ACTIONS(2930),
    [anon_sym_use_BANG] = ACTIONS(2932),
    [anon_sym_do_BANG] = ACTIONS(2932),
    [anon_sym_begin] = ACTIONS(2930),
    [anon_sym_LPAREN2] = ACTIONS(2930),
    [anon_sym_or] = ACTIONS(2930),
    [aux_sym_char_token1] = ACTIONS(2932),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2930),
    [anon_sym_DQUOTE] = ACTIONS(2930),
    [anon_sym_AT_DQUOTE] = ACTIONS(2932),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2932),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2932),
    [sym_bool] = ACTIONS(2930),
    [sym_unit] = ACTIONS(2932),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2930),
    [sym_op_identifier] = ACTIONS(2930),
    [anon_sym_PLUS] = ACTIONS(2930),
    [anon_sym_DASH] = ACTIONS(2930),
    [anon_sym_PLUS_DOT] = ACTIONS(2930),
    [anon_sym_DASH_DOT] = ACTIONS(2930),
    [anon_sym_PERCENT] = ACTIONS(2930),
    [anon_sym_AMP_AMP] = ACTIONS(2930),
    [anon_sym_TILDE] = ACTIONS(2932),
    [aux_sym_prefix_op_token1] = ACTIONS(2930),
    [aux_sym_infix_op_token1] = ACTIONS(2932),
    [aux_sym_infix_op_token2] = ACTIONS(2930),
    [anon_sym_PIPE_PIPE] = ACTIONS(2930),
    [anon_sym_BANG_EQ] = ACTIONS(2930),
    [anon_sym_COLON_EQ] = ACTIONS(2932),
    [anon_sym_DOLLAR] = ACTIONS(2930),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2930),
    [sym_int] = ACTIONS(2930),
    [sym_xint] = ACTIONS(2932),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2932),
    [sym__newline] = ACTIONS(2932),
    [sym__dedent] = ACTIONS(2932),
  },
  [1794] = {
    [sym_block_comment] = STATE(1794),
    [sym_compiler_directive_decl] = STATE(1794),
    [sym_fsi_directive_decl] = STATE(1794),
    [sym_preproc_line] = STATE(1794),
    [sym_identifier] = ACTIONS(2906),
    [anon_sym_EQ] = ACTIONS(2908),
    [anon_sym_COLON] = ACTIONS(2906),
    [anon_sym_return] = ACTIONS(2906),
    [anon_sym_do] = ACTIONS(2906),
    [anon_sym_and] = ACTIONS(2906),
    [anon_sym_let] = ACTIONS(2906),
    [anon_sym_let_BANG] = ACTIONS(2908),
    [anon_sym_LPAREN] = ACTIONS(2906),
    [anon_sym_COMMA] = ACTIONS(2908),
    [anon_sym_null] = ACTIONS(2906),
    [anon_sym_QMARK] = ACTIONS(2906),
    [anon_sym_COLON_QMARK] = ACTIONS(2906),
    [anon_sym_COLON_COLON] = ACTIONS(2908),
    [anon_sym_AMP] = ACTIONS(2906),
    [anon_sym_LBRACK] = ACTIONS(2906),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2908),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_LT_AT] = ACTIONS(2906),
    [anon_sym_LT_AT_AT] = ACTIONS(2906),
    [anon_sym_DOT] = ACTIONS(2906),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2908),
    [anon_sym_new] = ACTIONS(2906),
    [anon_sym_return_BANG] = ACTIONS(2908),
    [anon_sym_yield] = ACTIONS(2906),
    [anon_sym_yield_BANG] = ACTIONS(2908),
    [anon_sym_lazy] = ACTIONS(2906),
    [anon_sym_assert] = ACTIONS(2906),
    [anon_sym_upcast] = ACTIONS(2906),
    [anon_sym_downcast] = ACTIONS(2906),
    [anon_sym_COLON_GT] = ACTIONS(2908),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2908),
    [anon_sym_for] = ACTIONS(2906),
    [anon_sym_while] = ACTIONS(2906),
    [anon_sym_if] = ACTIONS(2906),
    [anon_sym_fun] = ACTIONS(2906),
    [anon_sym_try] = ACTIONS(2906),
    [anon_sym_match] = ACTIONS(2906),
    [anon_sym_match_BANG] = ACTIONS(2908),
    [anon_sym_function] = ACTIONS(2906),
    [anon_sym_LT_DASH] = ACTIONS(2906),
    [anon_sym_DOT_LBRACK] = ACTIONS(2908),
    [anon_sym_LT] = ACTIONS(2908),
    [anon_sym_use] = ACTIONS(2906),
    [anon_sym_use_BANG] = ACTIONS(2908),
    [anon_sym_do_BANG] = ACTIONS(2908),
    [anon_sym_begin] = ACTIONS(2906),
    [anon_sym_LPAREN2] = ACTIONS(2906),
    [anon_sym_or] = ACTIONS(2906),
    [aux_sym_char_token1] = ACTIONS(2908),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2906),
    [anon_sym_DQUOTE] = ACTIONS(2906),
    [anon_sym_AT_DQUOTE] = ACTIONS(2908),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2908),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2908),
    [sym_bool] = ACTIONS(2906),
    [sym_unit] = ACTIONS(2908),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2906),
    [sym_op_identifier] = ACTIONS(2906),
    [anon_sym_PLUS] = ACTIONS(2906),
    [anon_sym_DASH] = ACTIONS(2906),
    [anon_sym_PLUS_DOT] = ACTIONS(2906),
    [anon_sym_DASH_DOT] = ACTIONS(2906),
    [anon_sym_PERCENT] = ACTIONS(2906),
    [anon_sym_AMP_AMP] = ACTIONS(2906),
    [anon_sym_TILDE] = ACTIONS(2908),
    [aux_sym_prefix_op_token1] = ACTIONS(2906),
    [aux_sym_infix_op_token1] = ACTIONS(2908),
    [aux_sym_infix_op_token2] = ACTIONS(2906),
    [anon_sym_PIPE_PIPE] = ACTIONS(2906),
    [anon_sym_BANG_EQ] = ACTIONS(2906),
    [anon_sym_COLON_EQ] = ACTIONS(2908),
    [anon_sym_DOLLAR] = ACTIONS(2906),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2906),
    [sym_int] = ACTIONS(2906),
    [sym_xint] = ACTIONS(2908),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2908),
    [sym__newline] = ACTIONS(2908),
    [sym__dedent] = ACTIONS(2908),
  },
  [1795] = {
    [sym_block_comment] = STATE(1795),
    [sym_compiler_directive_decl] = STATE(1795),
    [sym_fsi_directive_decl] = STATE(1795),
    [sym_preproc_line] = STATE(1795),
    [sym_identifier] = ACTIONS(2902),
    [anon_sym_EQ] = ACTIONS(2904),
    [anon_sym_COLON] = ACTIONS(2902),
    [anon_sym_return] = ACTIONS(2902),
    [anon_sym_do] = ACTIONS(2902),
    [anon_sym_and] = ACTIONS(2902),
    [anon_sym_let] = ACTIONS(2902),
    [anon_sym_let_BANG] = ACTIONS(2904),
    [anon_sym_LPAREN] = ACTIONS(2902),
    [anon_sym_COMMA] = ACTIONS(2904),
    [anon_sym_null] = ACTIONS(2902),
    [anon_sym_QMARK] = ACTIONS(2902),
    [anon_sym_COLON_QMARK] = ACTIONS(2902),
    [anon_sym_COLON_COLON] = ACTIONS(2904),
    [anon_sym_AMP] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2902),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2902),
    [anon_sym_LT_AT] = ACTIONS(2902),
    [anon_sym_LT_AT_AT] = ACTIONS(2902),
    [anon_sym_DOT] = ACTIONS(2902),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2904),
    [anon_sym_new] = ACTIONS(2902),
    [anon_sym_return_BANG] = ACTIONS(2904),
    [anon_sym_yield] = ACTIONS(2902),
    [anon_sym_yield_BANG] = ACTIONS(2904),
    [anon_sym_lazy] = ACTIONS(2902),
    [anon_sym_assert] = ACTIONS(2902),
    [anon_sym_upcast] = ACTIONS(2902),
    [anon_sym_downcast] = ACTIONS(2902),
    [anon_sym_COLON_GT] = ACTIONS(2904),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2904),
    [anon_sym_for] = ACTIONS(2902),
    [anon_sym_while] = ACTIONS(2902),
    [anon_sym_if] = ACTIONS(2902),
    [anon_sym_fun] = ACTIONS(2902),
    [anon_sym_try] = ACTIONS(2902),
    [anon_sym_match] = ACTIONS(2902),
    [anon_sym_match_BANG] = ACTIONS(2904),
    [anon_sym_function] = ACTIONS(2902),
    [anon_sym_LT_DASH] = ACTIONS(2902),
    [anon_sym_DOT_LBRACK] = ACTIONS(2904),
    [anon_sym_LT] = ACTIONS(2904),
    [anon_sym_use] = ACTIONS(2902),
    [anon_sym_use_BANG] = ACTIONS(2904),
    [anon_sym_do_BANG] = ACTIONS(2904),
    [anon_sym_begin] = ACTIONS(2902),
    [anon_sym_LPAREN2] = ACTIONS(2902),
    [anon_sym_or] = ACTIONS(2902),
    [aux_sym_char_token1] = ACTIONS(2904),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2902),
    [anon_sym_DQUOTE] = ACTIONS(2902),
    [anon_sym_AT_DQUOTE] = ACTIONS(2904),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2904),
    [sym_bool] = ACTIONS(2902),
    [sym_unit] = ACTIONS(2904),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2902),
    [sym_op_identifier] = ACTIONS(2902),
    [anon_sym_PLUS] = ACTIONS(2902),
    [anon_sym_DASH] = ACTIONS(2902),
    [anon_sym_PLUS_DOT] = ACTIONS(2902),
    [anon_sym_DASH_DOT] = ACTIONS(2902),
    [anon_sym_PERCENT] = ACTIONS(2902),
    [anon_sym_AMP_AMP] = ACTIONS(2902),
    [anon_sym_TILDE] = ACTIONS(2904),
    [aux_sym_prefix_op_token1] = ACTIONS(2902),
    [aux_sym_infix_op_token1] = ACTIONS(2904),
    [aux_sym_infix_op_token2] = ACTIONS(2902),
    [anon_sym_PIPE_PIPE] = ACTIONS(2902),
    [anon_sym_BANG_EQ] = ACTIONS(2902),
    [anon_sym_COLON_EQ] = ACTIONS(2904),
    [anon_sym_DOLLAR] = ACTIONS(2902),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2902),
    [sym_int] = ACTIONS(2902),
    [sym_xint] = ACTIONS(2904),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2904),
    [sym__newline] = ACTIONS(2904),
    [sym__dedent] = ACTIONS(2904),
  },
  [1796] = {
    [sym_block_comment] = STATE(1796),
    [sym_compiler_directive_decl] = STATE(1796),
    [sym_fsi_directive_decl] = STATE(1796),
    [sym_preproc_line] = STATE(1796),
    [sym_identifier] = ACTIONS(2685),
    [anon_sym_EQ] = ACTIONS(2687),
    [anon_sym_COLON] = ACTIONS(2685),
    [anon_sym_return] = ACTIONS(2685),
    [anon_sym_do] = ACTIONS(2685),
    [anon_sym_let] = ACTIONS(2685),
    [anon_sym_let_BANG] = ACTIONS(2687),
    [anon_sym_LPAREN] = ACTIONS(2685),
    [anon_sym_COMMA] = ACTIONS(2687),
    [anon_sym_null] = ACTIONS(2685),
    [anon_sym_QMARK] = ACTIONS(2685),
    [anon_sym_COLON_QMARK] = ACTIONS(2685),
    [anon_sym_COLON_COLON] = ACTIONS(2687),
    [anon_sym_PIPE] = ACTIONS(2685),
    [anon_sym_AMP] = ACTIONS(2685),
    [anon_sym_LBRACK] = ACTIONS(2685),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2687),
    [anon_sym_LBRACE] = ACTIONS(2685),
    [anon_sym_LT_AT] = ACTIONS(2685),
    [anon_sym_LT_AT_AT] = ACTIONS(2685),
    [anon_sym_AT_AT_GT] = ACTIONS(2685),
    [anon_sym_DOT] = ACTIONS(2685),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2687),
    [anon_sym_new] = ACTIONS(2685),
    [anon_sym_return_BANG] = ACTIONS(2687),
    [anon_sym_yield] = ACTIONS(2685),
    [anon_sym_yield_BANG] = ACTIONS(2687),
    [anon_sym_lazy] = ACTIONS(2685),
    [anon_sym_assert] = ACTIONS(2685),
    [anon_sym_upcast] = ACTIONS(2685),
    [anon_sym_downcast] = ACTIONS(2685),
    [anon_sym_COLON_GT] = ACTIONS(2687),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2687),
    [anon_sym_for] = ACTIONS(2685),
    [anon_sym_while] = ACTIONS(2685),
    [anon_sym_if] = ACTIONS(2685),
    [anon_sym_fun] = ACTIONS(2685),
    [anon_sym_try] = ACTIONS(2685),
    [anon_sym_match] = ACTIONS(2685),
    [anon_sym_match_BANG] = ACTIONS(2687),
    [anon_sym_function] = ACTIONS(2685),
    [anon_sym_LT_DASH] = ACTIONS(2685),
    [anon_sym_DOT_LBRACK] = ACTIONS(2687),
    [anon_sym_LT] = ACTIONS(2687),
    [anon_sym_use] = ACTIONS(2685),
    [anon_sym_use_BANG] = ACTIONS(2687),
    [anon_sym_do_BANG] = ACTIONS(2687),
    [anon_sym_begin] = ACTIONS(2685),
    [anon_sym_LPAREN2] = ACTIONS(2685),
    [anon_sym_or] = ACTIONS(2685),
    [aux_sym_char_token1] = ACTIONS(2687),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2685),
    [anon_sym_DQUOTE] = ACTIONS(2685),
    [anon_sym_AT_DQUOTE] = ACTIONS(2687),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2687),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2687),
    [sym_bool] = ACTIONS(2685),
    [sym_unit] = ACTIONS(2687),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2685),
    [sym_op_identifier] = ACTIONS(2685),
    [anon_sym_PLUS] = ACTIONS(2685),
    [anon_sym_DASH] = ACTIONS(2685),
    [anon_sym_PLUS_DOT] = ACTIONS(2685),
    [anon_sym_DASH_DOT] = ACTIONS(2685),
    [anon_sym_PERCENT] = ACTIONS(2685),
    [anon_sym_AMP_AMP] = ACTIONS(2685),
    [anon_sym_TILDE] = ACTIONS(2687),
    [aux_sym_prefix_op_token1] = ACTIONS(2685),
    [aux_sym_infix_op_token1] = ACTIONS(2687),
    [aux_sym_infix_op_token2] = ACTIONS(2685),
    [anon_sym_PIPE_PIPE] = ACTIONS(2685),
    [anon_sym_BANG_EQ] = ACTIONS(2685),
    [anon_sym_COLON_EQ] = ACTIONS(2687),
    [anon_sym_DOLLAR] = ACTIONS(2685),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2685),
    [sym_int] = ACTIONS(2685),
    [sym_xint] = ACTIONS(2687),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2687),
    [sym__newline] = ACTIONS(2687),
  },
  [1797] = {
    [sym_block_comment] = STATE(1797),
    [sym_compiler_directive_decl] = STATE(1797),
    [sym_fsi_directive_decl] = STATE(1797),
    [sym_preproc_line] = STATE(1797),
    [sym_identifier] = ACTIONS(2851),
    [anon_sym_EQ] = ACTIONS(2853),
    [anon_sym_COLON] = ACTIONS(2851),
    [anon_sym_return] = ACTIONS(2851),
    [anon_sym_do] = ACTIONS(2851),
    [anon_sym_let] = ACTIONS(2851),
    [anon_sym_let_BANG] = ACTIONS(2853),
    [anon_sym_as] = ACTIONS(2851),
    [anon_sym_LPAREN] = ACTIONS(2851),
    [anon_sym_COMMA] = ACTIONS(2853),
    [anon_sym_null] = ACTIONS(2851),
    [anon_sym_QMARK] = ACTIONS(2851),
    [anon_sym_COLON_QMARK] = ACTIONS(2851),
    [anon_sym_COLON_COLON] = ACTIONS(2853),
    [anon_sym_AMP] = ACTIONS(2851),
    [anon_sym_LBRACK] = ACTIONS(2851),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2853),
    [anon_sym_LBRACE] = ACTIONS(2851),
    [anon_sym_LT_AT] = ACTIONS(2851),
    [anon_sym_LT_AT_AT] = ACTIONS(2851),
    [anon_sym_DOT] = ACTIONS(2851),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2853),
    [anon_sym_new] = ACTIONS(2851),
    [anon_sym_with] = ACTIONS(2851),
    [anon_sym_return_BANG] = ACTIONS(2853),
    [anon_sym_yield] = ACTIONS(2851),
    [anon_sym_yield_BANG] = ACTIONS(2853),
    [anon_sym_lazy] = ACTIONS(2851),
    [anon_sym_assert] = ACTIONS(2851),
    [anon_sym_upcast] = ACTIONS(2851),
    [anon_sym_downcast] = ACTIONS(2851),
    [anon_sym_COLON_GT] = ACTIONS(2853),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2853),
    [anon_sym_for] = ACTIONS(2851),
    [anon_sym_while] = ACTIONS(2851),
    [anon_sym_if] = ACTIONS(2851),
    [anon_sym_fun] = ACTIONS(2851),
    [anon_sym_try] = ACTIONS(2851),
    [anon_sym_match] = ACTIONS(2851),
    [anon_sym_match_BANG] = ACTIONS(2853),
    [anon_sym_function] = ACTIONS(2851),
    [anon_sym_LT_DASH] = ACTIONS(2851),
    [anon_sym_DOT_LBRACK] = ACTIONS(2853),
    [anon_sym_LT] = ACTIONS(2853),
    [anon_sym_use] = ACTIONS(2851),
    [anon_sym_use_BANG] = ACTIONS(2853),
    [anon_sym_do_BANG] = ACTIONS(2853),
    [anon_sym_begin] = ACTIONS(2851),
    [anon_sym_LPAREN2] = ACTIONS(2851),
    [anon_sym_or] = ACTIONS(2851),
    [aux_sym_char_token1] = ACTIONS(2853),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2851),
    [anon_sym_DQUOTE] = ACTIONS(2851),
    [anon_sym_AT_DQUOTE] = ACTIONS(2853),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2853),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2853),
    [sym_bool] = ACTIONS(2851),
    [sym_unit] = ACTIONS(2853),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2851),
    [sym_op_identifier] = ACTIONS(2851),
    [anon_sym_PLUS] = ACTIONS(2851),
    [anon_sym_DASH] = ACTIONS(2851),
    [anon_sym_PLUS_DOT] = ACTIONS(2851),
    [anon_sym_DASH_DOT] = ACTIONS(2851),
    [anon_sym_PERCENT] = ACTIONS(2851),
    [anon_sym_AMP_AMP] = ACTIONS(2851),
    [anon_sym_TILDE] = ACTIONS(2853),
    [aux_sym_prefix_op_token1] = ACTIONS(2851),
    [aux_sym_infix_op_token1] = ACTIONS(2853),
    [aux_sym_infix_op_token2] = ACTIONS(2851),
    [anon_sym_PIPE_PIPE] = ACTIONS(2851),
    [anon_sym_BANG_EQ] = ACTIONS(2851),
    [anon_sym_COLON_EQ] = ACTIONS(2853),
    [anon_sym_DOLLAR] = ACTIONS(2851),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2851),
    [sym_int] = ACTIONS(2851),
    [sym_xint] = ACTIONS(2853),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2853),
    [sym__newline] = ACTIONS(2853),
  },
  [1798] = {
    [sym_block_comment] = STATE(1798),
    [sym_compiler_directive_decl] = STATE(1798),
    [sym_fsi_directive_decl] = STATE(1798),
    [sym_preproc_line] = STATE(1798),
    [sym_identifier] = ACTIONS(2881),
    [anon_sym_EQ] = ACTIONS(2789),
    [anon_sym_COLON] = ACTIONS(2881),
    [anon_sym_return] = ACTIONS(2881),
    [anon_sym_do] = ACTIONS(2881),
    [anon_sym_and] = ACTIONS(2881),
    [anon_sym_let] = ACTIONS(2881),
    [anon_sym_let_BANG] = ACTIONS(2789),
    [anon_sym_LPAREN] = ACTIONS(2881),
    [anon_sym_COMMA] = ACTIONS(2789),
    [anon_sym_null] = ACTIONS(2881),
    [anon_sym_QMARK] = ACTIONS(2881),
    [anon_sym_COLON_QMARK] = ACTIONS(2881),
    [anon_sym_COLON_COLON] = ACTIONS(2789),
    [anon_sym_AMP] = ACTIONS(2881),
    [anon_sym_LBRACK] = ACTIONS(2881),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2789),
    [anon_sym_LBRACE] = ACTIONS(2881),
    [anon_sym_LT_AT] = ACTIONS(2881),
    [anon_sym_LT_AT_AT] = ACTIONS(2881),
    [anon_sym_DOT] = ACTIONS(2881),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2789),
    [anon_sym_new] = ACTIONS(2881),
    [anon_sym_return_BANG] = ACTIONS(2789),
    [anon_sym_yield] = ACTIONS(2881),
    [anon_sym_yield_BANG] = ACTIONS(2789),
    [anon_sym_lazy] = ACTIONS(2881),
    [anon_sym_assert] = ACTIONS(2881),
    [anon_sym_upcast] = ACTIONS(2881),
    [anon_sym_downcast] = ACTIONS(2881),
    [anon_sym_COLON_GT] = ACTIONS(2789),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2789),
    [anon_sym_for] = ACTIONS(2881),
    [anon_sym_while] = ACTIONS(2881),
    [anon_sym_if] = ACTIONS(2881),
    [anon_sym_fun] = ACTIONS(2881),
    [anon_sym_try] = ACTIONS(2881),
    [anon_sym_match] = ACTIONS(2881),
    [anon_sym_match_BANG] = ACTIONS(2789),
    [anon_sym_function] = ACTIONS(2881),
    [anon_sym_LT_DASH] = ACTIONS(2881),
    [anon_sym_DOT_LBRACK] = ACTIONS(2789),
    [anon_sym_LT] = ACTIONS(2789),
    [anon_sym_use] = ACTIONS(2881),
    [anon_sym_use_BANG] = ACTIONS(2789),
    [anon_sym_do_BANG] = ACTIONS(2789),
    [anon_sym_begin] = ACTIONS(2881),
    [anon_sym_LPAREN2] = ACTIONS(2881),
    [anon_sym_or] = ACTIONS(2881),
    [aux_sym_char_token1] = ACTIONS(2789),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2881),
    [anon_sym_DQUOTE] = ACTIONS(2881),
    [anon_sym_AT_DQUOTE] = ACTIONS(2789),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2789),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2789),
    [sym_bool] = ACTIONS(2881),
    [sym_unit] = ACTIONS(2789),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2881),
    [sym_op_identifier] = ACTIONS(2881),
    [anon_sym_PLUS] = ACTIONS(2881),
    [anon_sym_DASH] = ACTIONS(2881),
    [anon_sym_PLUS_DOT] = ACTIONS(2881),
    [anon_sym_DASH_DOT] = ACTIONS(2881),
    [anon_sym_PERCENT] = ACTIONS(2881),
    [anon_sym_AMP_AMP] = ACTIONS(2881),
    [anon_sym_TILDE] = ACTIONS(2789),
    [aux_sym_prefix_op_token1] = ACTIONS(2881),
    [aux_sym_infix_op_token1] = ACTIONS(2789),
    [aux_sym_infix_op_token2] = ACTIONS(2881),
    [anon_sym_PIPE_PIPE] = ACTIONS(2881),
    [anon_sym_BANG_EQ] = ACTIONS(2881),
    [anon_sym_COLON_EQ] = ACTIONS(2789),
    [anon_sym_DOLLAR] = ACTIONS(2881),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2881),
    [sym_int] = ACTIONS(2881),
    [sym_xint] = ACTIONS(2789),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2789),
    [sym__newline] = ACTIONS(2789),
    [sym__dedent] = ACTIONS(2789),
  },
  [1799] = {
    [sym_block_comment] = STATE(1799),
    [sym_compiler_directive_decl] = STATE(1799),
    [sym_fsi_directive_decl] = STATE(1799),
    [sym_preproc_line] = STATE(1799),
    [sym_identifier] = ACTIONS(2843),
    [anon_sym_EQ] = ACTIONS(2845),
    [anon_sym_COLON] = ACTIONS(2843),
    [anon_sym_return] = ACTIONS(2843),
    [anon_sym_do] = ACTIONS(2843),
    [anon_sym_let] = ACTIONS(2843),
    [anon_sym_let_BANG] = ACTIONS(2845),
    [anon_sym_LPAREN] = ACTIONS(2843),
    [anon_sym_COMMA] = ACTIONS(2845),
    [anon_sym_null] = ACTIONS(2843),
    [anon_sym_QMARK] = ACTIONS(2843),
    [anon_sym_COLON_QMARK] = ACTIONS(2843),
    [anon_sym_COLON_COLON] = ACTIONS(2845),
    [anon_sym_AMP] = ACTIONS(2843),
    [anon_sym_LBRACK] = ACTIONS(2843),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2845),
    [anon_sym_LBRACE] = ACTIONS(2843),
    [anon_sym_LT_AT] = ACTIONS(2843),
    [anon_sym_LT_AT_AT] = ACTIONS(2843),
    [anon_sym_DOT] = ACTIONS(2843),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2845),
    [anon_sym_new] = ACTIONS(2843),
    [anon_sym_return_BANG] = ACTIONS(2845),
    [anon_sym_yield] = ACTIONS(2843),
    [anon_sym_yield_BANG] = ACTIONS(2845),
    [anon_sym_lazy] = ACTIONS(2843),
    [anon_sym_assert] = ACTIONS(2843),
    [anon_sym_upcast] = ACTIONS(2843),
    [anon_sym_downcast] = ACTIONS(2843),
    [anon_sym_COLON_GT] = ACTIONS(2845),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2845),
    [anon_sym_for] = ACTIONS(2843),
    [anon_sym_while] = ACTIONS(2843),
    [anon_sym_if] = ACTIONS(2843),
    [anon_sym_fun] = ACTIONS(2843),
    [anon_sym_try] = ACTIONS(2843),
    [anon_sym_match] = ACTIONS(2843),
    [anon_sym_match_BANG] = ACTIONS(2845),
    [anon_sym_function] = ACTIONS(2843),
    [anon_sym_LT_DASH] = ACTIONS(2843),
    [anon_sym_DOT_LBRACK] = ACTIONS(2845),
    [anon_sym_LT] = ACTIONS(2845),
    [anon_sym_use] = ACTIONS(2843),
    [anon_sym_use_BANG] = ACTIONS(2845),
    [anon_sym_do_BANG] = ACTIONS(2845),
    [anon_sym_begin] = ACTIONS(2843),
    [anon_sym_LPAREN2] = ACTIONS(2843),
    [anon_sym_or] = ACTIONS(2843),
    [aux_sym_char_token1] = ACTIONS(2845),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2843),
    [anon_sym_DQUOTE] = ACTIONS(2843),
    [anon_sym_AT_DQUOTE] = ACTIONS(2845),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2845),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2845),
    [sym_bool] = ACTIONS(2843),
    [sym_unit] = ACTIONS(2845),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2843),
    [sym_op_identifier] = ACTIONS(2843),
    [anon_sym_PLUS] = ACTIONS(2843),
    [anon_sym_DASH] = ACTIONS(2843),
    [anon_sym_PLUS_DOT] = ACTIONS(2843),
    [anon_sym_DASH_DOT] = ACTIONS(2843),
    [anon_sym_PERCENT] = ACTIONS(2843),
    [anon_sym_AMP_AMP] = ACTIONS(2843),
    [anon_sym_TILDE] = ACTIONS(2845),
    [aux_sym_prefix_op_token1] = ACTIONS(2843),
    [aux_sym_infix_op_token1] = ACTIONS(2845),
    [aux_sym_infix_op_token2] = ACTIONS(2843),
    [anon_sym_PIPE_PIPE] = ACTIONS(2843),
    [anon_sym_BANG_EQ] = ACTIONS(2843),
    [anon_sym_COLON_EQ] = ACTIONS(2845),
    [anon_sym_DOLLAR] = ACTIONS(2843),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2843),
    [sym_int] = ACTIONS(2843),
    [sym_xint] = ACTIONS(2845),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2845),
    [anon_sym_POUNDendif] = ACTIONS(2845),
    [anon_sym_POUNDelse] = ACTIONS(2845),
    [sym__newline] = ACTIONS(2845),
  },
  [1800] = {
    [sym_block_comment] = STATE(1800),
    [sym_compiler_directive_decl] = STATE(1800),
    [sym_fsi_directive_decl] = STATE(1800),
    [sym_preproc_line] = STATE(1800),
    [sym_identifier] = ACTIONS(2839),
    [anon_sym_EQ] = ACTIONS(2841),
    [anon_sym_COLON] = ACTIONS(2839),
    [anon_sym_return] = ACTIONS(2839),
    [anon_sym_do] = ACTIONS(2839),
    [anon_sym_let] = ACTIONS(2839),
    [anon_sym_let_BANG] = ACTIONS(2841),
    [anon_sym_as] = ACTIONS(2839),
    [anon_sym_LPAREN] = ACTIONS(2839),
    [anon_sym_COMMA] = ACTIONS(2841),
    [anon_sym_null] = ACTIONS(2839),
    [anon_sym_QMARK] = ACTIONS(2839),
    [anon_sym_COLON_QMARK] = ACTIONS(2839),
    [anon_sym_COLON_COLON] = ACTIONS(2841),
    [anon_sym_AMP] = ACTIONS(2839),
    [anon_sym_LBRACK] = ACTIONS(2839),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2841),
    [anon_sym_LBRACE] = ACTIONS(2839),
    [anon_sym_LT_AT] = ACTIONS(2839),
    [anon_sym_LT_AT_AT] = ACTIONS(2839),
    [anon_sym_DOT] = ACTIONS(2839),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2841),
    [anon_sym_new] = ACTIONS(2839),
    [anon_sym_with] = ACTIONS(2839),
    [anon_sym_return_BANG] = ACTIONS(2841),
    [anon_sym_yield] = ACTIONS(2839),
    [anon_sym_yield_BANG] = ACTIONS(2841),
    [anon_sym_lazy] = ACTIONS(2839),
    [anon_sym_assert] = ACTIONS(2839),
    [anon_sym_upcast] = ACTIONS(2839),
    [anon_sym_downcast] = ACTIONS(2839),
    [anon_sym_COLON_GT] = ACTIONS(2841),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2841),
    [anon_sym_for] = ACTIONS(2839),
    [anon_sym_while] = ACTIONS(2839),
    [anon_sym_if] = ACTIONS(2839),
    [anon_sym_fun] = ACTIONS(2839),
    [anon_sym_try] = ACTIONS(2839),
    [anon_sym_match] = ACTIONS(2839),
    [anon_sym_match_BANG] = ACTIONS(2841),
    [anon_sym_function] = ACTIONS(2839),
    [anon_sym_LT_DASH] = ACTIONS(2839),
    [anon_sym_DOT_LBRACK] = ACTIONS(2841),
    [anon_sym_LT] = ACTIONS(2841),
    [anon_sym_use] = ACTIONS(2839),
    [anon_sym_use_BANG] = ACTIONS(2841),
    [anon_sym_do_BANG] = ACTIONS(2841),
    [anon_sym_begin] = ACTIONS(2839),
    [anon_sym_LPAREN2] = ACTIONS(2839),
    [anon_sym_or] = ACTIONS(2839),
    [aux_sym_char_token1] = ACTIONS(2841),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2839),
    [anon_sym_DQUOTE] = ACTIONS(2839),
    [anon_sym_AT_DQUOTE] = ACTIONS(2841),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2841),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2841),
    [sym_bool] = ACTIONS(2839),
    [sym_unit] = ACTIONS(2841),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2839),
    [sym_op_identifier] = ACTIONS(2839),
    [anon_sym_PLUS] = ACTIONS(2839),
    [anon_sym_DASH] = ACTIONS(2839),
    [anon_sym_PLUS_DOT] = ACTIONS(2839),
    [anon_sym_DASH_DOT] = ACTIONS(2839),
    [anon_sym_PERCENT] = ACTIONS(2839),
    [anon_sym_AMP_AMP] = ACTIONS(2839),
    [anon_sym_TILDE] = ACTIONS(2841),
    [aux_sym_prefix_op_token1] = ACTIONS(2839),
    [aux_sym_infix_op_token1] = ACTIONS(2841),
    [aux_sym_infix_op_token2] = ACTIONS(2839),
    [anon_sym_PIPE_PIPE] = ACTIONS(2839),
    [anon_sym_BANG_EQ] = ACTIONS(2839),
    [anon_sym_COLON_EQ] = ACTIONS(2841),
    [anon_sym_DOLLAR] = ACTIONS(2839),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2839),
    [sym_int] = ACTIONS(2839),
    [sym_xint] = ACTIONS(2841),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2841),
    [sym__newline] = ACTIONS(2841),
  },
  [1801] = {
    [sym_block_comment] = STATE(1801),
    [sym_compiler_directive_decl] = STATE(1801),
    [sym_fsi_directive_decl] = STATE(1801),
    [sym_preproc_line] = STATE(1801),
    [sym_identifier] = ACTIONS(2158),
    [anon_sym_EQ] = ACTIONS(2160),
    [anon_sym_COLON] = ACTIONS(2158),
    [anon_sym_return] = ACTIONS(2158),
    [anon_sym_do] = ACTIONS(2158),
    [anon_sym_let] = ACTIONS(2158),
    [anon_sym_let_BANG] = ACTIONS(2160),
    [anon_sym_LPAREN] = ACTIONS(2158),
    [anon_sym_COMMA] = ACTIONS(2160),
    [anon_sym_null] = ACTIONS(2158),
    [anon_sym_QMARK] = ACTIONS(2158),
    [anon_sym_COLON_QMARK] = ACTIONS(2158),
    [anon_sym_COLON_COLON] = ACTIONS(2160),
    [anon_sym_AMP] = ACTIONS(2158),
    [anon_sym_LBRACK] = ACTIONS(2158),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2160),
    [anon_sym_LBRACE] = ACTIONS(2158),
    [anon_sym_LT_AT] = ACTIONS(2158),
    [anon_sym_LT_AT_AT] = ACTIONS(2158),
    [anon_sym_DOT] = ACTIONS(2158),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2160),
    [anon_sym_new] = ACTIONS(2158),
    [anon_sym_return_BANG] = ACTIONS(2160),
    [anon_sym_yield] = ACTIONS(2158),
    [anon_sym_yield_BANG] = ACTIONS(2160),
    [anon_sym_lazy] = ACTIONS(2158),
    [anon_sym_assert] = ACTIONS(2158),
    [anon_sym_upcast] = ACTIONS(2158),
    [anon_sym_downcast] = ACTIONS(2158),
    [anon_sym_COLON_GT] = ACTIONS(2160),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2160),
    [anon_sym_for] = ACTIONS(2158),
    [anon_sym_while] = ACTIONS(2158),
    [anon_sym_if] = ACTIONS(2158),
    [anon_sym_fun] = ACTIONS(2158),
    [anon_sym_try] = ACTIONS(2158),
    [anon_sym_match] = ACTIONS(2158),
    [anon_sym_match_BANG] = ACTIONS(2160),
    [anon_sym_function] = ACTIONS(2158),
    [anon_sym_LT_DASH] = ACTIONS(2158),
    [anon_sym_DOT_LBRACK] = ACTIONS(2160),
    [anon_sym_LT] = ACTIONS(2160),
    [anon_sym_use] = ACTIONS(2158),
    [anon_sym_use_BANG] = ACTIONS(2160),
    [anon_sym_do_BANG] = ACTIONS(2160),
    [anon_sym_begin] = ACTIONS(2158),
    [anon_sym_LPAREN2] = ACTIONS(2158),
    [anon_sym_or] = ACTIONS(2158),
    [aux_sym_char_token1] = ACTIONS(2160),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2158),
    [anon_sym_DQUOTE] = ACTIONS(2158),
    [anon_sym_AT_DQUOTE] = ACTIONS(2160),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2160),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2160),
    [sym_bool] = ACTIONS(2158),
    [sym_unit] = ACTIONS(2160),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2158),
    [sym_op_identifier] = ACTIONS(2158),
    [anon_sym_PLUS] = ACTIONS(2158),
    [anon_sym_DASH] = ACTIONS(2158),
    [anon_sym_PLUS_DOT] = ACTIONS(2158),
    [anon_sym_DASH_DOT] = ACTIONS(2158),
    [anon_sym_PERCENT] = ACTIONS(2158),
    [anon_sym_AMP_AMP] = ACTIONS(2158),
    [anon_sym_TILDE] = ACTIONS(2160),
    [aux_sym_prefix_op_token1] = ACTIONS(2158),
    [aux_sym_infix_op_token1] = ACTIONS(2160),
    [aux_sym_infix_op_token2] = ACTIONS(2158),
    [anon_sym_PIPE_PIPE] = ACTIONS(2158),
    [anon_sym_BANG_EQ] = ACTIONS(2158),
    [anon_sym_COLON_EQ] = ACTIONS(2160),
    [anon_sym_DOLLAR] = ACTIONS(2158),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2158),
    [sym_int] = ACTIONS(2158),
    [sym_xint] = ACTIONS(2160),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2160),
    [anon_sym_POUNDendif] = ACTIONS(2160),
    [anon_sym_POUNDelse] = ACTIONS(2160),
    [sym__newline] = ACTIONS(2160),
  },
  [1802] = {
    [sym_block_comment] = STATE(1802),
    [sym_compiler_directive_decl] = STATE(1802),
    [sym_fsi_directive_decl] = STATE(1802),
    [sym_preproc_line] = STATE(1802),
    [aux_sym_sequential_expression_repeat1] = STATE(1802),
    [sym_identifier] = ACTIONS(2895),
    [anon_sym_EQ] = ACTIONS(2897),
    [anon_sym_COLON] = ACTIONS(2895),
    [anon_sym_return] = ACTIONS(2895),
    [anon_sym_do] = ACTIONS(2895),
    [anon_sym_let] = ACTIONS(2895),
    [anon_sym_let_BANG] = ACTIONS(2897),
    [anon_sym_LPAREN] = ACTIONS(2895),
    [anon_sym_COMMA] = ACTIONS(2897),
    [anon_sym_null] = ACTIONS(2895),
    [anon_sym_QMARK] = ACTIONS(2895),
    [anon_sym_COLON_QMARK] = ACTIONS(2895),
    [anon_sym_COLON_COLON] = ACTIONS(2897),
    [anon_sym_AMP] = ACTIONS(2895),
    [anon_sym_LBRACK] = ACTIONS(2895),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2897),
    [anon_sym_LBRACE] = ACTIONS(2895),
    [anon_sym_LT_AT] = ACTIONS(2895),
    [anon_sym_AT_GT] = ACTIONS(2895),
    [anon_sym_LT_AT_AT] = ACTIONS(2895),
    [anon_sym_DOT] = ACTIONS(2895),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2897),
    [anon_sym_new] = ACTIONS(2895),
    [anon_sym_return_BANG] = ACTIONS(2897),
    [anon_sym_yield] = ACTIONS(2895),
    [anon_sym_yield_BANG] = ACTIONS(2897),
    [anon_sym_lazy] = ACTIONS(2895),
    [anon_sym_assert] = ACTIONS(2895),
    [anon_sym_upcast] = ACTIONS(2895),
    [anon_sym_downcast] = ACTIONS(2895),
    [anon_sym_COLON_GT] = ACTIONS(2897),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2897),
    [anon_sym_for] = ACTIONS(2895),
    [anon_sym_while] = ACTIONS(2895),
    [anon_sym_if] = ACTIONS(2895),
    [anon_sym_fun] = ACTIONS(2895),
    [anon_sym_try] = ACTIONS(2895),
    [anon_sym_match] = ACTIONS(2895),
    [anon_sym_match_BANG] = ACTIONS(2897),
    [anon_sym_function] = ACTIONS(2895),
    [anon_sym_LT_DASH] = ACTIONS(2895),
    [anon_sym_DOT_LBRACK] = ACTIONS(2897),
    [anon_sym_LT] = ACTIONS(2897),
    [anon_sym_use] = ACTIONS(2895),
    [anon_sym_use_BANG] = ACTIONS(2897),
    [anon_sym_do_BANG] = ACTIONS(2897),
    [anon_sym_begin] = ACTIONS(2895),
    [anon_sym_LPAREN2] = ACTIONS(2895),
    [anon_sym_or] = ACTIONS(2895),
    [aux_sym_char_token1] = ACTIONS(2897),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2895),
    [anon_sym_DQUOTE] = ACTIONS(2895),
    [anon_sym_AT_DQUOTE] = ACTIONS(2897),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2897),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2897),
    [sym_bool] = ACTIONS(2895),
    [sym_unit] = ACTIONS(2897),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2895),
    [sym_op_identifier] = ACTIONS(2895),
    [anon_sym_PLUS] = ACTIONS(2895),
    [anon_sym_DASH] = ACTIONS(2895),
    [anon_sym_PLUS_DOT] = ACTIONS(2895),
    [anon_sym_DASH_DOT] = ACTIONS(2895),
    [anon_sym_PERCENT] = ACTIONS(2895),
    [anon_sym_AMP_AMP] = ACTIONS(2895),
    [anon_sym_TILDE] = ACTIONS(2897),
    [aux_sym_prefix_op_token1] = ACTIONS(2895),
    [aux_sym_infix_op_token1] = ACTIONS(2897),
    [aux_sym_infix_op_token2] = ACTIONS(2895),
    [anon_sym_PIPE_PIPE] = ACTIONS(2895),
    [anon_sym_BANG_EQ] = ACTIONS(2895),
    [anon_sym_COLON_EQ] = ACTIONS(2897),
    [anon_sym_DOLLAR] = ACTIONS(2895),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2895),
    [sym_int] = ACTIONS(2895),
    [sym_xint] = ACTIONS(2897),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2897),
    [sym__newline] = ACTIONS(4050),
  },
  [1803] = {
    [sym_block_comment] = STATE(1803),
    [sym_compiler_directive_decl] = STATE(1803),
    [sym_fsi_directive_decl] = STATE(1803),
    [sym_preproc_line] = STATE(1803),
    [aux_sym_long_identifier_repeat1] = STATE(1983),
    [sym_identifier] = ACTIONS(2791),
    [anon_sym_EQ] = ACTIONS(2794),
    [anon_sym_COLON] = ACTIONS(2791),
    [anon_sym_return] = ACTIONS(2791),
    [anon_sym_do] = ACTIONS(2791),
    [anon_sym_let] = ACTIONS(2791),
    [anon_sym_let_BANG] = ACTIONS(2794),
    [anon_sym_LPAREN] = ACTIONS(2791),
    [anon_sym_COMMA] = ACTIONS(2794),
    [anon_sym_null] = ACTIONS(2791),
    [anon_sym_QMARK] = ACTIONS(2791),
    [anon_sym_COLON_QMARK] = ACTIONS(2791),
    [anon_sym_COLON_COLON] = ACTIONS(2794),
    [anon_sym_AMP] = ACTIONS(2791),
    [anon_sym_LBRACK] = ACTIONS(2791),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2794),
    [anon_sym_LBRACE] = ACTIONS(2791),
    [anon_sym_LT_AT] = ACTIONS(2791),
    [anon_sym_LT_AT_AT] = ACTIONS(2791),
    [anon_sym_DOT] = ACTIONS(4053),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2794),
    [anon_sym_new] = ACTIONS(2791),
    [anon_sym_return_BANG] = ACTIONS(2794),
    [anon_sym_yield] = ACTIONS(2791),
    [anon_sym_yield_BANG] = ACTIONS(2794),
    [anon_sym_lazy] = ACTIONS(2791),
    [anon_sym_assert] = ACTIONS(2791),
    [anon_sym_upcast] = ACTIONS(2791),
    [anon_sym_downcast] = ACTIONS(2791),
    [anon_sym_COLON_GT] = ACTIONS(2794),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2794),
    [anon_sym_for] = ACTIONS(2791),
    [anon_sym_while] = ACTIONS(2791),
    [anon_sym_if] = ACTIONS(2791),
    [anon_sym_fun] = ACTIONS(2791),
    [anon_sym_try] = ACTIONS(2791),
    [anon_sym_match] = ACTIONS(2791),
    [anon_sym_match_BANG] = ACTIONS(2794),
    [anon_sym_function] = ACTIONS(2791),
    [anon_sym_LT_DASH] = ACTIONS(2791),
    [anon_sym_DOT_LBRACK] = ACTIONS(2794),
    [anon_sym_LT] = ACTIONS(2794),
    [anon_sym_use] = ACTIONS(2791),
    [anon_sym_use_BANG] = ACTIONS(2794),
    [anon_sym_do_BANG] = ACTIONS(2794),
    [anon_sym_begin] = ACTIONS(2791),
    [anon_sym_LPAREN2] = ACTIONS(2791),
    [anon_sym_or] = ACTIONS(2791),
    [aux_sym_char_token1] = ACTIONS(2794),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2791),
    [anon_sym_DQUOTE] = ACTIONS(2791),
    [anon_sym_AT_DQUOTE] = ACTIONS(2794),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2794),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2794),
    [sym_bool] = ACTIONS(2791),
    [sym_unit] = ACTIONS(2794),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2791),
    [sym_op_identifier] = ACTIONS(2791),
    [anon_sym_PLUS] = ACTIONS(2791),
    [anon_sym_DASH] = ACTIONS(2791),
    [anon_sym_PLUS_DOT] = ACTIONS(2791),
    [anon_sym_DASH_DOT] = ACTIONS(2791),
    [anon_sym_PERCENT] = ACTIONS(2791),
    [anon_sym_AMP_AMP] = ACTIONS(2791),
    [anon_sym_TILDE] = ACTIONS(2794),
    [aux_sym_prefix_op_token1] = ACTIONS(2791),
    [aux_sym_infix_op_token1] = ACTIONS(2794),
    [aux_sym_infix_op_token2] = ACTIONS(2791),
    [anon_sym_PIPE_PIPE] = ACTIONS(2791),
    [anon_sym_BANG_EQ] = ACTIONS(2791),
    [anon_sym_COLON_EQ] = ACTIONS(2794),
    [anon_sym_DOLLAR] = ACTIONS(2791),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2791),
    [sym_int] = ACTIONS(2791),
    [sym_xint] = ACTIONS(2794),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2794),
    [anon_sym_POUNDendif] = ACTIONS(2794),
    [sym__newline] = ACTIONS(2794),
  },
  [1804] = {
    [sym_block_comment] = STATE(1804),
    [sym_compiler_directive_decl] = STATE(1804),
    [sym_fsi_directive_decl] = STATE(1804),
    [sym_preproc_line] = STATE(1804),
    [sym_identifier] = ACTIONS(2855),
    [anon_sym_EQ] = ACTIONS(2857),
    [anon_sym_COLON] = ACTIONS(2855),
    [anon_sym_return] = ACTIONS(2855),
    [anon_sym_do] = ACTIONS(2855),
    [anon_sym_let] = ACTIONS(2855),
    [anon_sym_let_BANG] = ACTIONS(2857),
    [anon_sym_LPAREN] = ACTIONS(2855),
    [anon_sym_COMMA] = ACTIONS(2857),
    [anon_sym_null] = ACTIONS(2855),
    [anon_sym_QMARK] = ACTIONS(2855),
    [anon_sym_COLON_QMARK] = ACTIONS(2855),
    [anon_sym_COLON_COLON] = ACTIONS(2857),
    [anon_sym_AMP] = ACTIONS(2855),
    [anon_sym_LBRACK] = ACTIONS(2855),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2857),
    [anon_sym_LBRACE] = ACTIONS(2855),
    [anon_sym_LT_AT] = ACTIONS(2855),
    [anon_sym_LT_AT_AT] = ACTIONS(2855),
    [anon_sym_DOT] = ACTIONS(2855),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2857),
    [anon_sym_new] = ACTIONS(2855),
    [anon_sym_return_BANG] = ACTIONS(2857),
    [anon_sym_yield] = ACTIONS(2855),
    [anon_sym_yield_BANG] = ACTIONS(2857),
    [anon_sym_lazy] = ACTIONS(2855),
    [anon_sym_assert] = ACTIONS(2855),
    [anon_sym_upcast] = ACTIONS(2855),
    [anon_sym_downcast] = ACTIONS(2855),
    [anon_sym_COLON_GT] = ACTIONS(2857),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2857),
    [anon_sym_for] = ACTIONS(2855),
    [anon_sym_while] = ACTIONS(2855),
    [anon_sym_if] = ACTIONS(2855),
    [anon_sym_fun] = ACTIONS(2855),
    [anon_sym_try] = ACTIONS(2855),
    [anon_sym_match] = ACTIONS(2855),
    [anon_sym_match_BANG] = ACTIONS(2857),
    [anon_sym_function] = ACTIONS(2855),
    [anon_sym_LT_DASH] = ACTIONS(2855),
    [anon_sym_DOT_LBRACK] = ACTIONS(2857),
    [anon_sym_LT] = ACTIONS(2857),
    [anon_sym_use] = ACTIONS(2855),
    [anon_sym_use_BANG] = ACTIONS(2857),
    [anon_sym_do_BANG] = ACTIONS(2857),
    [anon_sym_begin] = ACTIONS(2855),
    [anon_sym_LPAREN2] = ACTIONS(2855),
    [anon_sym_or] = ACTIONS(2855),
    [aux_sym_char_token1] = ACTIONS(2857),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2855),
    [anon_sym_DQUOTE] = ACTIONS(2855),
    [anon_sym_AT_DQUOTE] = ACTIONS(2857),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2857),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2857),
    [sym_bool] = ACTIONS(2855),
    [sym_unit] = ACTIONS(2857),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2855),
    [sym_op_identifier] = ACTIONS(2855),
    [anon_sym_PLUS] = ACTIONS(2855),
    [anon_sym_DASH] = ACTIONS(2855),
    [anon_sym_PLUS_DOT] = ACTIONS(2855),
    [anon_sym_DASH_DOT] = ACTIONS(2855),
    [anon_sym_PERCENT] = ACTIONS(2855),
    [anon_sym_AMP_AMP] = ACTIONS(2855),
    [anon_sym_TILDE] = ACTIONS(2857),
    [aux_sym_prefix_op_token1] = ACTIONS(2855),
    [aux_sym_infix_op_token1] = ACTIONS(2857),
    [aux_sym_infix_op_token2] = ACTIONS(2855),
    [anon_sym_PIPE_PIPE] = ACTIONS(2855),
    [anon_sym_BANG_EQ] = ACTIONS(2855),
    [anon_sym_COLON_EQ] = ACTIONS(2857),
    [anon_sym_DOLLAR] = ACTIONS(2855),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2855),
    [sym_int] = ACTIONS(2855),
    [sym_xint] = ACTIONS(2857),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2857),
    [anon_sym_POUNDendif] = ACTIONS(2857),
    [anon_sym_POUNDelse] = ACTIONS(2857),
    [sym__newline] = ACTIONS(2857),
  },
  [1805] = {
    [sym_block_comment] = STATE(1805),
    [sym_compiler_directive_decl] = STATE(1805),
    [sym_fsi_directive_decl] = STATE(1805),
    [sym_preproc_line] = STATE(1805),
    [sym_identifier] = ACTIONS(2411),
    [anon_sym_EQ] = ACTIONS(2413),
    [anon_sym_COLON] = ACTIONS(2411),
    [anon_sym_return] = ACTIONS(2411),
    [anon_sym_do] = ACTIONS(2411),
    [anon_sym_let] = ACTIONS(2411),
    [anon_sym_let_BANG] = ACTIONS(2413),
    [anon_sym_as] = ACTIONS(2411),
    [anon_sym_LPAREN] = ACTIONS(2411),
    [anon_sym_COMMA] = ACTIONS(2413),
    [anon_sym_null] = ACTIONS(2411),
    [anon_sym_QMARK] = ACTIONS(2411),
    [anon_sym_COLON_QMARK] = ACTIONS(2411),
    [anon_sym_COLON_COLON] = ACTIONS(2413),
    [anon_sym_AMP] = ACTIONS(2411),
    [anon_sym_LBRACK] = ACTIONS(2411),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2413),
    [anon_sym_LBRACE] = ACTIONS(2411),
    [anon_sym_LT_AT] = ACTIONS(2411),
    [anon_sym_LT_AT_AT] = ACTIONS(2411),
    [anon_sym_DOT] = ACTIONS(2411),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2413),
    [anon_sym_new] = ACTIONS(2411),
    [anon_sym_with] = ACTIONS(2411),
    [anon_sym_return_BANG] = ACTIONS(2413),
    [anon_sym_yield] = ACTIONS(2411),
    [anon_sym_yield_BANG] = ACTIONS(2413),
    [anon_sym_lazy] = ACTIONS(2411),
    [anon_sym_assert] = ACTIONS(2411),
    [anon_sym_upcast] = ACTIONS(2411),
    [anon_sym_downcast] = ACTIONS(2411),
    [anon_sym_COLON_GT] = ACTIONS(2413),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2413),
    [anon_sym_for] = ACTIONS(2411),
    [anon_sym_while] = ACTIONS(2411),
    [anon_sym_if] = ACTIONS(2411),
    [anon_sym_fun] = ACTIONS(2411),
    [anon_sym_try] = ACTIONS(2411),
    [anon_sym_match] = ACTIONS(2411),
    [anon_sym_match_BANG] = ACTIONS(2413),
    [anon_sym_function] = ACTIONS(2411),
    [anon_sym_LT_DASH] = ACTIONS(2411),
    [anon_sym_DOT_LBRACK] = ACTIONS(2413),
    [anon_sym_LT] = ACTIONS(2413),
    [anon_sym_use] = ACTIONS(2411),
    [anon_sym_use_BANG] = ACTIONS(2413),
    [anon_sym_do_BANG] = ACTIONS(2413),
    [anon_sym_begin] = ACTIONS(2411),
    [anon_sym_LPAREN2] = ACTIONS(2411),
    [anon_sym_or] = ACTIONS(2411),
    [aux_sym_char_token1] = ACTIONS(2413),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2411),
    [anon_sym_DQUOTE] = ACTIONS(2411),
    [anon_sym_AT_DQUOTE] = ACTIONS(2413),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2413),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2413),
    [sym_bool] = ACTIONS(2411),
    [sym_unit] = ACTIONS(2413),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2411),
    [sym_op_identifier] = ACTIONS(2411),
    [anon_sym_PLUS] = ACTIONS(2411),
    [anon_sym_DASH] = ACTIONS(2411),
    [anon_sym_PLUS_DOT] = ACTIONS(2411),
    [anon_sym_DASH_DOT] = ACTIONS(2411),
    [anon_sym_PERCENT] = ACTIONS(2411),
    [anon_sym_AMP_AMP] = ACTIONS(2411),
    [anon_sym_TILDE] = ACTIONS(2413),
    [aux_sym_prefix_op_token1] = ACTIONS(2411),
    [aux_sym_infix_op_token1] = ACTIONS(2413),
    [aux_sym_infix_op_token2] = ACTIONS(2411),
    [anon_sym_PIPE_PIPE] = ACTIONS(2411),
    [anon_sym_BANG_EQ] = ACTIONS(2411),
    [anon_sym_COLON_EQ] = ACTIONS(2413),
    [anon_sym_DOLLAR] = ACTIONS(2411),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2411),
    [sym_int] = ACTIONS(2411),
    [sym_xint] = ACTIONS(2413),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2413),
    [sym__newline] = ACTIONS(2413),
  },
  [1806] = {
    [sym_block_comment] = STATE(1806),
    [sym_compiler_directive_decl] = STATE(1806),
    [sym_fsi_directive_decl] = STATE(1806),
    [sym_preproc_line] = STATE(1806),
    [sym_identifier] = ACTIONS(2839),
    [anon_sym_EQ] = ACTIONS(2841),
    [anon_sym_COLON] = ACTIONS(2839),
    [anon_sym_return] = ACTIONS(2839),
    [anon_sym_do] = ACTIONS(2839),
    [anon_sym_and] = ACTIONS(2839),
    [anon_sym_let] = ACTIONS(2839),
    [anon_sym_let_BANG] = ACTIONS(2841),
    [anon_sym_LPAREN] = ACTIONS(2839),
    [anon_sym_COMMA] = ACTIONS(2841),
    [anon_sym_null] = ACTIONS(2839),
    [anon_sym_QMARK] = ACTIONS(2839),
    [anon_sym_COLON_QMARK] = ACTIONS(2839),
    [anon_sym_COLON_COLON] = ACTIONS(2841),
    [anon_sym_AMP] = ACTIONS(2839),
    [anon_sym_LBRACK] = ACTIONS(2839),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2841),
    [anon_sym_LBRACE] = ACTIONS(2839),
    [anon_sym_LT_AT] = ACTIONS(2839),
    [anon_sym_LT_AT_AT] = ACTIONS(2839),
    [anon_sym_DOT] = ACTIONS(2839),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2841),
    [anon_sym_new] = ACTIONS(2839),
    [anon_sym_return_BANG] = ACTIONS(2841),
    [anon_sym_yield] = ACTIONS(2839),
    [anon_sym_yield_BANG] = ACTIONS(2841),
    [anon_sym_lazy] = ACTIONS(2839),
    [anon_sym_assert] = ACTIONS(2839),
    [anon_sym_upcast] = ACTIONS(2839),
    [anon_sym_downcast] = ACTIONS(2839),
    [anon_sym_COLON_GT] = ACTIONS(2841),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2841),
    [anon_sym_for] = ACTIONS(2839),
    [anon_sym_while] = ACTIONS(2839),
    [anon_sym_if] = ACTIONS(2839),
    [anon_sym_fun] = ACTIONS(2839),
    [anon_sym_try] = ACTIONS(2839),
    [anon_sym_match] = ACTIONS(2839),
    [anon_sym_match_BANG] = ACTIONS(2841),
    [anon_sym_function] = ACTIONS(2839),
    [anon_sym_LT_DASH] = ACTIONS(2839),
    [anon_sym_DOT_LBRACK] = ACTIONS(2841),
    [anon_sym_LT] = ACTIONS(2841),
    [anon_sym_use] = ACTIONS(2839),
    [anon_sym_use_BANG] = ACTIONS(2841),
    [anon_sym_do_BANG] = ACTIONS(2841),
    [anon_sym_begin] = ACTIONS(2839),
    [anon_sym_LPAREN2] = ACTIONS(2839),
    [anon_sym_or] = ACTIONS(2839),
    [aux_sym_char_token1] = ACTIONS(2841),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2839),
    [anon_sym_DQUOTE] = ACTIONS(2839),
    [anon_sym_AT_DQUOTE] = ACTIONS(2841),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2841),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2841),
    [sym_bool] = ACTIONS(2839),
    [sym_unit] = ACTIONS(2841),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2839),
    [sym_op_identifier] = ACTIONS(2839),
    [anon_sym_PLUS] = ACTIONS(2839),
    [anon_sym_DASH] = ACTIONS(2839),
    [anon_sym_PLUS_DOT] = ACTIONS(2839),
    [anon_sym_DASH_DOT] = ACTIONS(2839),
    [anon_sym_PERCENT] = ACTIONS(2839),
    [anon_sym_AMP_AMP] = ACTIONS(2839),
    [anon_sym_TILDE] = ACTIONS(2841),
    [aux_sym_prefix_op_token1] = ACTIONS(2839),
    [aux_sym_infix_op_token1] = ACTIONS(2841),
    [aux_sym_infix_op_token2] = ACTIONS(2839),
    [anon_sym_PIPE_PIPE] = ACTIONS(2839),
    [anon_sym_BANG_EQ] = ACTIONS(2839),
    [anon_sym_COLON_EQ] = ACTIONS(2841),
    [anon_sym_DOLLAR] = ACTIONS(2839),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2839),
    [sym_int] = ACTIONS(2839),
    [sym_xint] = ACTIONS(2841),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2841),
    [sym__newline] = ACTIONS(2841),
    [sym__dedent] = ACTIONS(2841),
  },
  [1807] = {
    [sym_block_comment] = STATE(1807),
    [sym_compiler_directive_decl] = STATE(1807),
    [sym_fsi_directive_decl] = STATE(1807),
    [sym_preproc_line] = STATE(1807),
    [sym_identifier] = ACTIONS(2859),
    [anon_sym_EQ] = ACTIONS(2861),
    [anon_sym_COLON] = ACTIONS(2859),
    [anon_sym_return] = ACTIONS(2859),
    [anon_sym_do] = ACTIONS(2859),
    [anon_sym_let] = ACTIONS(2859),
    [anon_sym_let_BANG] = ACTIONS(2861),
    [anon_sym_LPAREN] = ACTIONS(2859),
    [anon_sym_COMMA] = ACTIONS(2861),
    [anon_sym_null] = ACTIONS(2859),
    [anon_sym_QMARK] = ACTIONS(2859),
    [anon_sym_COLON_QMARK] = ACTIONS(2859),
    [anon_sym_COLON_COLON] = ACTIONS(2861),
    [anon_sym_AMP] = ACTIONS(2859),
    [anon_sym_LBRACK] = ACTIONS(2859),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2861),
    [anon_sym_LBRACE] = ACTIONS(2859),
    [anon_sym_LT_AT] = ACTIONS(2859),
    [anon_sym_LT_AT_AT] = ACTIONS(2859),
    [anon_sym_DOT] = ACTIONS(2859),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2861),
    [anon_sym_new] = ACTIONS(2859),
    [anon_sym_return_BANG] = ACTIONS(2861),
    [anon_sym_yield] = ACTIONS(2859),
    [anon_sym_yield_BANG] = ACTIONS(2861),
    [anon_sym_lazy] = ACTIONS(2859),
    [anon_sym_assert] = ACTIONS(2859),
    [anon_sym_upcast] = ACTIONS(2859),
    [anon_sym_downcast] = ACTIONS(2859),
    [anon_sym_COLON_GT] = ACTIONS(2861),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2861),
    [anon_sym_for] = ACTIONS(2859),
    [anon_sym_while] = ACTIONS(2859),
    [anon_sym_if] = ACTIONS(2859),
    [anon_sym_fun] = ACTIONS(2859),
    [anon_sym_try] = ACTIONS(2859),
    [anon_sym_match] = ACTIONS(2859),
    [anon_sym_match_BANG] = ACTIONS(2861),
    [anon_sym_function] = ACTIONS(2859),
    [anon_sym_LT_DASH] = ACTIONS(2859),
    [anon_sym_DOT_LBRACK] = ACTIONS(2861),
    [anon_sym_LT] = ACTIONS(2861),
    [anon_sym_use] = ACTIONS(2859),
    [anon_sym_use_BANG] = ACTIONS(2861),
    [anon_sym_do_BANG] = ACTIONS(2861),
    [anon_sym_begin] = ACTIONS(2859),
    [anon_sym_LPAREN2] = ACTIONS(2859),
    [anon_sym_or] = ACTIONS(2859),
    [aux_sym_char_token1] = ACTIONS(2861),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2859),
    [anon_sym_DQUOTE] = ACTIONS(2859),
    [anon_sym_AT_DQUOTE] = ACTIONS(2861),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2861),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2861),
    [sym_bool] = ACTIONS(2859),
    [sym_unit] = ACTIONS(2861),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2859),
    [sym_op_identifier] = ACTIONS(2859),
    [anon_sym_PLUS] = ACTIONS(2859),
    [anon_sym_DASH] = ACTIONS(2859),
    [anon_sym_PLUS_DOT] = ACTIONS(2859),
    [anon_sym_DASH_DOT] = ACTIONS(2859),
    [anon_sym_PERCENT] = ACTIONS(2859),
    [anon_sym_AMP_AMP] = ACTIONS(2859),
    [anon_sym_TILDE] = ACTIONS(2861),
    [aux_sym_prefix_op_token1] = ACTIONS(2859),
    [aux_sym_infix_op_token1] = ACTIONS(2861),
    [aux_sym_infix_op_token2] = ACTIONS(2859),
    [anon_sym_PIPE_PIPE] = ACTIONS(2859),
    [anon_sym_BANG_EQ] = ACTIONS(2859),
    [anon_sym_COLON_EQ] = ACTIONS(2861),
    [anon_sym_DOLLAR] = ACTIONS(2859),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2859),
    [sym_int] = ACTIONS(2859),
    [sym_xint] = ACTIONS(2861),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2861),
    [anon_sym_POUNDendif] = ACTIONS(2861),
    [anon_sym_POUNDelse] = ACTIONS(2861),
    [sym__newline] = ACTIONS(2861),
  },
  [1808] = {
    [sym_block_comment] = STATE(1808),
    [sym_compiler_directive_decl] = STATE(1808),
    [sym_fsi_directive_decl] = STATE(1808),
    [sym_preproc_line] = STATE(1808),
    [sym_identifier] = ACTIONS(2685),
    [anon_sym_EQ] = ACTIONS(2687),
    [anon_sym_COLON] = ACTIONS(2685),
    [anon_sym_return] = ACTIONS(2685),
    [anon_sym_do] = ACTIONS(2685),
    [anon_sym_let] = ACTIONS(2685),
    [anon_sym_let_BANG] = ACTIONS(2687),
    [anon_sym_LPAREN] = ACTIONS(2685),
    [anon_sym_COMMA] = ACTIONS(2687),
    [anon_sym_null] = ACTIONS(2685),
    [anon_sym_QMARK] = ACTIONS(2685),
    [anon_sym_COLON_QMARK] = ACTIONS(2685),
    [anon_sym_COLON_COLON] = ACTIONS(2687),
    [anon_sym_PIPE] = ACTIONS(2685),
    [anon_sym_AMP] = ACTIONS(2685),
    [anon_sym_LBRACK] = ACTIONS(2685),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2687),
    [anon_sym_LBRACE] = ACTIONS(2685),
    [anon_sym_LT_AT] = ACTIONS(2685),
    [anon_sym_AT_GT] = ACTIONS(2685),
    [anon_sym_LT_AT_AT] = ACTIONS(2685),
    [anon_sym_DOT] = ACTIONS(2685),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2687),
    [anon_sym_new] = ACTIONS(2685),
    [anon_sym_return_BANG] = ACTIONS(2687),
    [anon_sym_yield] = ACTIONS(2685),
    [anon_sym_yield_BANG] = ACTIONS(2687),
    [anon_sym_lazy] = ACTIONS(2685),
    [anon_sym_assert] = ACTIONS(2685),
    [anon_sym_upcast] = ACTIONS(2685),
    [anon_sym_downcast] = ACTIONS(2685),
    [anon_sym_COLON_GT] = ACTIONS(2687),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2687),
    [anon_sym_for] = ACTIONS(2685),
    [anon_sym_while] = ACTIONS(2685),
    [anon_sym_if] = ACTIONS(2685),
    [anon_sym_fun] = ACTIONS(2685),
    [anon_sym_try] = ACTIONS(2685),
    [anon_sym_match] = ACTIONS(2685),
    [anon_sym_match_BANG] = ACTIONS(2687),
    [anon_sym_function] = ACTIONS(2685),
    [anon_sym_LT_DASH] = ACTIONS(2685),
    [anon_sym_DOT_LBRACK] = ACTIONS(2687),
    [anon_sym_LT] = ACTIONS(2687),
    [anon_sym_use] = ACTIONS(2685),
    [anon_sym_use_BANG] = ACTIONS(2687),
    [anon_sym_do_BANG] = ACTIONS(2687),
    [anon_sym_begin] = ACTIONS(2685),
    [anon_sym_LPAREN2] = ACTIONS(2685),
    [anon_sym_or] = ACTIONS(2685),
    [aux_sym_char_token1] = ACTIONS(2687),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2685),
    [anon_sym_DQUOTE] = ACTIONS(2685),
    [anon_sym_AT_DQUOTE] = ACTIONS(2687),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2687),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2687),
    [sym_bool] = ACTIONS(2685),
    [sym_unit] = ACTIONS(2687),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2685),
    [sym_op_identifier] = ACTIONS(2685),
    [anon_sym_PLUS] = ACTIONS(2685),
    [anon_sym_DASH] = ACTIONS(2685),
    [anon_sym_PLUS_DOT] = ACTIONS(2685),
    [anon_sym_DASH_DOT] = ACTIONS(2685),
    [anon_sym_PERCENT] = ACTIONS(2685),
    [anon_sym_AMP_AMP] = ACTIONS(2685),
    [anon_sym_TILDE] = ACTIONS(2687),
    [aux_sym_prefix_op_token1] = ACTIONS(2685),
    [aux_sym_infix_op_token1] = ACTIONS(2687),
    [aux_sym_infix_op_token2] = ACTIONS(2685),
    [anon_sym_PIPE_PIPE] = ACTIONS(2685),
    [anon_sym_BANG_EQ] = ACTIONS(2685),
    [anon_sym_COLON_EQ] = ACTIONS(2687),
    [anon_sym_DOLLAR] = ACTIONS(2685),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2685),
    [sym_int] = ACTIONS(2685),
    [sym_xint] = ACTIONS(2687),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2687),
    [sym__newline] = ACTIONS(2687),
  },
  [1809] = {
    [sym_block_comment] = STATE(1809),
    [sym_compiler_directive_decl] = STATE(1809),
    [sym_fsi_directive_decl] = STATE(1809),
    [sym_preproc_line] = STATE(1809),
    [sym_identifier] = ACTIONS(2851),
    [anon_sym_EQ] = ACTIONS(2853),
    [anon_sym_COLON] = ACTIONS(2851),
    [anon_sym_return] = ACTIONS(2851),
    [anon_sym_do] = ACTIONS(2851),
    [anon_sym_and] = ACTIONS(2851),
    [anon_sym_let] = ACTIONS(2851),
    [anon_sym_let_BANG] = ACTIONS(2853),
    [anon_sym_LPAREN] = ACTIONS(2851),
    [anon_sym_COMMA] = ACTIONS(2853),
    [anon_sym_null] = ACTIONS(2851),
    [anon_sym_QMARK] = ACTIONS(2851),
    [anon_sym_COLON_QMARK] = ACTIONS(2851),
    [anon_sym_COLON_COLON] = ACTIONS(2853),
    [anon_sym_AMP] = ACTIONS(2851),
    [anon_sym_LBRACK] = ACTIONS(2851),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2853),
    [anon_sym_LBRACE] = ACTIONS(2851),
    [anon_sym_LT_AT] = ACTIONS(2851),
    [anon_sym_LT_AT_AT] = ACTIONS(2851),
    [anon_sym_DOT] = ACTIONS(2851),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2853),
    [anon_sym_new] = ACTIONS(2851),
    [anon_sym_return_BANG] = ACTIONS(2853),
    [anon_sym_yield] = ACTIONS(2851),
    [anon_sym_yield_BANG] = ACTIONS(2853),
    [anon_sym_lazy] = ACTIONS(2851),
    [anon_sym_assert] = ACTIONS(2851),
    [anon_sym_upcast] = ACTIONS(2851),
    [anon_sym_downcast] = ACTIONS(2851),
    [anon_sym_COLON_GT] = ACTIONS(2853),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2853),
    [anon_sym_for] = ACTIONS(2851),
    [anon_sym_while] = ACTIONS(2851),
    [anon_sym_if] = ACTIONS(2851),
    [anon_sym_fun] = ACTIONS(2851),
    [anon_sym_try] = ACTIONS(2851),
    [anon_sym_match] = ACTIONS(2851),
    [anon_sym_match_BANG] = ACTIONS(2853),
    [anon_sym_function] = ACTIONS(2851),
    [anon_sym_LT_DASH] = ACTIONS(2851),
    [anon_sym_DOT_LBRACK] = ACTIONS(2853),
    [anon_sym_LT] = ACTIONS(2853),
    [anon_sym_use] = ACTIONS(2851),
    [anon_sym_use_BANG] = ACTIONS(2853),
    [anon_sym_do_BANG] = ACTIONS(2853),
    [anon_sym_begin] = ACTIONS(2851),
    [anon_sym_LPAREN2] = ACTIONS(2851),
    [anon_sym_or] = ACTIONS(2851),
    [aux_sym_char_token1] = ACTIONS(2853),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2851),
    [anon_sym_DQUOTE] = ACTIONS(2851),
    [anon_sym_AT_DQUOTE] = ACTIONS(2853),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2853),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2853),
    [sym_bool] = ACTIONS(2851),
    [sym_unit] = ACTIONS(2853),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2851),
    [sym_op_identifier] = ACTIONS(2851),
    [anon_sym_PLUS] = ACTIONS(2851),
    [anon_sym_DASH] = ACTIONS(2851),
    [anon_sym_PLUS_DOT] = ACTIONS(2851),
    [anon_sym_DASH_DOT] = ACTIONS(2851),
    [anon_sym_PERCENT] = ACTIONS(2851),
    [anon_sym_AMP_AMP] = ACTIONS(2851),
    [anon_sym_TILDE] = ACTIONS(2853),
    [aux_sym_prefix_op_token1] = ACTIONS(2851),
    [aux_sym_infix_op_token1] = ACTIONS(2853),
    [aux_sym_infix_op_token2] = ACTIONS(2851),
    [anon_sym_PIPE_PIPE] = ACTIONS(2851),
    [anon_sym_BANG_EQ] = ACTIONS(2851),
    [anon_sym_COLON_EQ] = ACTIONS(2853),
    [anon_sym_DOLLAR] = ACTIONS(2851),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2851),
    [sym_int] = ACTIONS(2851),
    [sym_xint] = ACTIONS(2853),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2853),
    [sym__newline] = ACTIONS(2853),
    [sym__dedent] = ACTIONS(2853),
  },
  [1810] = {
    [sym_block_comment] = STATE(1810),
    [sym_compiler_directive_decl] = STATE(1810),
    [sym_fsi_directive_decl] = STATE(1810),
    [sym_preproc_line] = STATE(1810),
    [sym_identifier] = ACTIONS(2867),
    [anon_sym_EQ] = ACTIONS(2869),
    [anon_sym_COLON] = ACTIONS(2867),
    [anon_sym_return] = ACTIONS(2867),
    [anon_sym_do] = ACTIONS(2867),
    [anon_sym_and] = ACTIONS(2867),
    [anon_sym_let] = ACTIONS(2867),
    [anon_sym_let_BANG] = ACTIONS(2869),
    [anon_sym_LPAREN] = ACTIONS(2867),
    [anon_sym_COMMA] = ACTIONS(2869),
    [anon_sym_null] = ACTIONS(2867),
    [anon_sym_QMARK] = ACTIONS(2867),
    [anon_sym_COLON_QMARK] = ACTIONS(2867),
    [anon_sym_COLON_COLON] = ACTIONS(2869),
    [anon_sym_AMP] = ACTIONS(2867),
    [anon_sym_LBRACK] = ACTIONS(2867),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2869),
    [anon_sym_LBRACE] = ACTIONS(2867),
    [anon_sym_LT_AT] = ACTIONS(2867),
    [anon_sym_LT_AT_AT] = ACTIONS(2867),
    [anon_sym_DOT] = ACTIONS(4057),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2869),
    [anon_sym_new] = ACTIONS(2867),
    [anon_sym_return_BANG] = ACTIONS(2869),
    [anon_sym_yield] = ACTIONS(2867),
    [anon_sym_yield_BANG] = ACTIONS(2869),
    [anon_sym_lazy] = ACTIONS(2867),
    [anon_sym_assert] = ACTIONS(2867),
    [anon_sym_upcast] = ACTIONS(2867),
    [anon_sym_downcast] = ACTIONS(2867),
    [anon_sym_COLON_GT] = ACTIONS(2869),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2869),
    [anon_sym_for] = ACTIONS(2867),
    [anon_sym_while] = ACTIONS(2867),
    [anon_sym_if] = ACTIONS(2867),
    [anon_sym_fun] = ACTIONS(2867),
    [anon_sym_try] = ACTIONS(2867),
    [anon_sym_match] = ACTIONS(2867),
    [anon_sym_match_BANG] = ACTIONS(2869),
    [anon_sym_function] = ACTIONS(2867),
    [anon_sym_LT_DASH] = ACTIONS(2867),
    [anon_sym_DOT_LBRACK] = ACTIONS(2869),
    [anon_sym_LT] = ACTIONS(2869),
    [anon_sym_use] = ACTIONS(2867),
    [anon_sym_use_BANG] = ACTIONS(2869),
    [anon_sym_do_BANG] = ACTIONS(2869),
    [anon_sym_begin] = ACTIONS(2867),
    [anon_sym_LPAREN2] = ACTIONS(2867),
    [anon_sym_or] = ACTIONS(2867),
    [aux_sym_char_token1] = ACTIONS(2869),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2867),
    [anon_sym_DQUOTE] = ACTIONS(2867),
    [anon_sym_AT_DQUOTE] = ACTIONS(2869),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2869),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2869),
    [sym_bool] = ACTIONS(2867),
    [sym_unit] = ACTIONS(2869),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2867),
    [sym_op_identifier] = ACTIONS(2867),
    [anon_sym_PLUS] = ACTIONS(2867),
    [anon_sym_DASH] = ACTIONS(2867),
    [anon_sym_PLUS_DOT] = ACTIONS(2867),
    [anon_sym_DASH_DOT] = ACTIONS(2867),
    [anon_sym_PERCENT] = ACTIONS(2867),
    [anon_sym_AMP_AMP] = ACTIONS(2867),
    [anon_sym_TILDE] = ACTIONS(2869),
    [aux_sym_prefix_op_token1] = ACTIONS(2867),
    [aux_sym_infix_op_token1] = ACTIONS(2869),
    [aux_sym_infix_op_token2] = ACTIONS(2867),
    [anon_sym_PIPE_PIPE] = ACTIONS(2867),
    [anon_sym_BANG_EQ] = ACTIONS(2867),
    [anon_sym_COLON_EQ] = ACTIONS(2869),
    [anon_sym_DOLLAR] = ACTIONS(2867),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2867),
    [sym_int] = ACTIONS(2867),
    [sym_xint] = ACTIONS(2869),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2869),
    [sym__newline] = ACTIONS(2869),
    [sym__dedent] = ACTIONS(2869),
  },
  [1811] = {
    [sym_block_comment] = STATE(1811),
    [sym_compiler_directive_decl] = STATE(1811),
    [sym_fsi_directive_decl] = STATE(1811),
    [sym_preproc_line] = STATE(1811),
    [sym_identifier] = ACTIONS(2984),
    [anon_sym_EQ] = ACTIONS(2986),
    [anon_sym_COLON] = ACTIONS(2984),
    [anon_sym_return] = ACTIONS(2984),
    [anon_sym_do] = ACTIONS(2984),
    [anon_sym_let] = ACTIONS(2984),
    [anon_sym_let_BANG] = ACTIONS(2986),
    [anon_sym_as] = ACTIONS(2984),
    [anon_sym_LPAREN] = ACTIONS(2984),
    [anon_sym_COMMA] = ACTIONS(2986),
    [anon_sym_null] = ACTIONS(2984),
    [anon_sym_QMARK] = ACTIONS(2984),
    [anon_sym_COLON_QMARK] = ACTIONS(2984),
    [anon_sym_COLON_COLON] = ACTIONS(2986),
    [anon_sym_AMP] = ACTIONS(2984),
    [anon_sym_LBRACK] = ACTIONS(2984),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2986),
    [anon_sym_LBRACE] = ACTIONS(2984),
    [anon_sym_LT_AT] = ACTIONS(2984),
    [anon_sym_LT_AT_AT] = ACTIONS(2984),
    [anon_sym_DOT] = ACTIONS(2984),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2986),
    [anon_sym_new] = ACTIONS(2984),
    [anon_sym_with] = ACTIONS(2984),
    [anon_sym_return_BANG] = ACTIONS(2986),
    [anon_sym_yield] = ACTIONS(2984),
    [anon_sym_yield_BANG] = ACTIONS(2986),
    [anon_sym_lazy] = ACTIONS(2984),
    [anon_sym_assert] = ACTIONS(2984),
    [anon_sym_upcast] = ACTIONS(2984),
    [anon_sym_downcast] = ACTIONS(2984),
    [anon_sym_COLON_GT] = ACTIONS(2986),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2986),
    [anon_sym_for] = ACTIONS(2984),
    [anon_sym_while] = ACTIONS(2984),
    [anon_sym_if] = ACTIONS(2984),
    [anon_sym_fun] = ACTIONS(2984),
    [anon_sym_try] = ACTIONS(2984),
    [anon_sym_match] = ACTIONS(2984),
    [anon_sym_match_BANG] = ACTIONS(2986),
    [anon_sym_function] = ACTIONS(2984),
    [anon_sym_LT_DASH] = ACTIONS(2984),
    [anon_sym_DOT_LBRACK] = ACTIONS(2986),
    [anon_sym_LT] = ACTIONS(2986),
    [anon_sym_use] = ACTIONS(2984),
    [anon_sym_use_BANG] = ACTIONS(2986),
    [anon_sym_do_BANG] = ACTIONS(2986),
    [anon_sym_begin] = ACTIONS(2984),
    [anon_sym_LPAREN2] = ACTIONS(2984),
    [anon_sym_or] = ACTIONS(2984),
    [aux_sym_char_token1] = ACTIONS(2986),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2984),
    [anon_sym_DQUOTE] = ACTIONS(2984),
    [anon_sym_AT_DQUOTE] = ACTIONS(2986),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2986),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2986),
    [sym_bool] = ACTIONS(2984),
    [sym_unit] = ACTIONS(2986),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2984),
    [sym_op_identifier] = ACTIONS(2984),
    [anon_sym_PLUS] = ACTIONS(2984),
    [anon_sym_DASH] = ACTIONS(2984),
    [anon_sym_PLUS_DOT] = ACTIONS(2984),
    [anon_sym_DASH_DOT] = ACTIONS(2984),
    [anon_sym_PERCENT] = ACTIONS(2984),
    [anon_sym_AMP_AMP] = ACTIONS(2984),
    [anon_sym_TILDE] = ACTIONS(2986),
    [aux_sym_prefix_op_token1] = ACTIONS(2984),
    [aux_sym_infix_op_token1] = ACTIONS(2986),
    [aux_sym_infix_op_token2] = ACTIONS(2984),
    [anon_sym_PIPE_PIPE] = ACTIONS(2984),
    [anon_sym_BANG_EQ] = ACTIONS(2984),
    [anon_sym_COLON_EQ] = ACTIONS(2986),
    [anon_sym_DOLLAR] = ACTIONS(2984),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2984),
    [sym_int] = ACTIONS(2984),
    [sym_xint] = ACTIONS(2986),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2986),
    [sym__newline] = ACTIONS(2986),
  },
  [1812] = {
    [sym_block_comment] = STATE(1812),
    [sym_compiler_directive_decl] = STATE(1812),
    [sym_fsi_directive_decl] = STATE(1812),
    [sym_preproc_line] = STATE(1812),
    [sym_identifier] = ACTIONS(2867),
    [anon_sym_EQ] = ACTIONS(2869),
    [anon_sym_COLON] = ACTIONS(2867),
    [anon_sym_return] = ACTIONS(2867),
    [anon_sym_do] = ACTIONS(2867),
    [anon_sym_let] = ACTIONS(2867),
    [anon_sym_let_BANG] = ACTIONS(2869),
    [anon_sym_as] = ACTIONS(2867),
    [anon_sym_LPAREN] = ACTIONS(2867),
    [anon_sym_COMMA] = ACTIONS(2869),
    [anon_sym_null] = ACTIONS(2867),
    [anon_sym_QMARK] = ACTIONS(2867),
    [anon_sym_COLON_QMARK] = ACTIONS(2867),
    [anon_sym_COLON_COLON] = ACTIONS(2869),
    [anon_sym_AMP] = ACTIONS(2867),
    [anon_sym_LBRACK] = ACTIONS(2867),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2869),
    [anon_sym_LBRACE] = ACTIONS(2867),
    [anon_sym_LT_AT] = ACTIONS(2867),
    [anon_sym_LT_AT_AT] = ACTIONS(2867),
    [anon_sym_DOT] = ACTIONS(2867),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2869),
    [anon_sym_new] = ACTIONS(2867),
    [anon_sym_with] = ACTIONS(2867),
    [anon_sym_return_BANG] = ACTIONS(2869),
    [anon_sym_yield] = ACTIONS(2867),
    [anon_sym_yield_BANG] = ACTIONS(2869),
    [anon_sym_lazy] = ACTIONS(2867),
    [anon_sym_assert] = ACTIONS(2867),
    [anon_sym_upcast] = ACTIONS(2867),
    [anon_sym_downcast] = ACTIONS(2867),
    [anon_sym_COLON_GT] = ACTIONS(2869),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2869),
    [anon_sym_for] = ACTIONS(2867),
    [anon_sym_while] = ACTIONS(2867),
    [anon_sym_if] = ACTIONS(2867),
    [anon_sym_fun] = ACTIONS(2867),
    [anon_sym_try] = ACTIONS(2867),
    [anon_sym_match] = ACTIONS(2867),
    [anon_sym_match_BANG] = ACTIONS(2869),
    [anon_sym_function] = ACTIONS(2867),
    [anon_sym_LT_DASH] = ACTIONS(2867),
    [anon_sym_DOT_LBRACK] = ACTIONS(2869),
    [anon_sym_LT] = ACTIONS(2869),
    [anon_sym_use] = ACTIONS(2867),
    [anon_sym_use_BANG] = ACTIONS(2869),
    [anon_sym_do_BANG] = ACTIONS(2869),
    [anon_sym_begin] = ACTIONS(2867),
    [anon_sym_LPAREN2] = ACTIONS(2867),
    [anon_sym_or] = ACTIONS(2867),
    [aux_sym_char_token1] = ACTIONS(2869),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2867),
    [anon_sym_DQUOTE] = ACTIONS(2867),
    [anon_sym_AT_DQUOTE] = ACTIONS(2869),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2869),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2869),
    [sym_bool] = ACTIONS(2867),
    [sym_unit] = ACTIONS(2869),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2867),
    [sym_op_identifier] = ACTIONS(2867),
    [anon_sym_PLUS] = ACTIONS(2867),
    [anon_sym_DASH] = ACTIONS(2867),
    [anon_sym_PLUS_DOT] = ACTIONS(2867),
    [anon_sym_DASH_DOT] = ACTIONS(2867),
    [anon_sym_PERCENT] = ACTIONS(2867),
    [anon_sym_AMP_AMP] = ACTIONS(2867),
    [anon_sym_TILDE] = ACTIONS(2869),
    [aux_sym_prefix_op_token1] = ACTIONS(2867),
    [aux_sym_infix_op_token1] = ACTIONS(2869),
    [aux_sym_infix_op_token2] = ACTIONS(2867),
    [anon_sym_PIPE_PIPE] = ACTIONS(2867),
    [anon_sym_BANG_EQ] = ACTIONS(2867),
    [anon_sym_COLON_EQ] = ACTIONS(2869),
    [anon_sym_DOLLAR] = ACTIONS(2867),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2867),
    [sym_int] = ACTIONS(2867),
    [sym_xint] = ACTIONS(2869),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2869),
    [sym__newline] = ACTIONS(2869),
  },
  [1813] = {
    [sym_block_comment] = STATE(1813),
    [sym_compiler_directive_decl] = STATE(1813),
    [sym_fsi_directive_decl] = STATE(1813),
    [sym_preproc_line] = STATE(1813),
    [sym_identifier] = ACTIONS(2867),
    [anon_sym_EQ] = ACTIONS(2869),
    [anon_sym_COLON] = ACTIONS(2867),
    [anon_sym_return] = ACTIONS(2867),
    [anon_sym_do] = ACTIONS(2867),
    [anon_sym_let] = ACTIONS(2867),
    [anon_sym_let_BANG] = ACTIONS(2869),
    [anon_sym_as] = ACTIONS(2867),
    [anon_sym_LPAREN] = ACTIONS(2867),
    [anon_sym_COMMA] = ACTIONS(2869),
    [anon_sym_null] = ACTIONS(2867),
    [anon_sym_QMARK] = ACTIONS(2867),
    [anon_sym_COLON_QMARK] = ACTIONS(2867),
    [anon_sym_COLON_COLON] = ACTIONS(2869),
    [anon_sym_AMP] = ACTIONS(2867),
    [anon_sym_LBRACK] = ACTIONS(2867),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2869),
    [anon_sym_LBRACE] = ACTIONS(2867),
    [anon_sym_LT_AT] = ACTIONS(2867),
    [anon_sym_LT_AT_AT] = ACTIONS(2867),
    [anon_sym_DOT] = ACTIONS(4059),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2869),
    [anon_sym_new] = ACTIONS(2867),
    [anon_sym_with] = ACTIONS(2867),
    [anon_sym_return_BANG] = ACTIONS(2869),
    [anon_sym_yield] = ACTIONS(2867),
    [anon_sym_yield_BANG] = ACTIONS(2869),
    [anon_sym_lazy] = ACTIONS(2867),
    [anon_sym_assert] = ACTIONS(2867),
    [anon_sym_upcast] = ACTIONS(2867),
    [anon_sym_downcast] = ACTIONS(2867),
    [anon_sym_COLON_GT] = ACTIONS(2869),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2869),
    [anon_sym_for] = ACTIONS(2867),
    [anon_sym_while] = ACTIONS(2867),
    [anon_sym_if] = ACTIONS(2867),
    [anon_sym_fun] = ACTIONS(2867),
    [anon_sym_try] = ACTIONS(2867),
    [anon_sym_match] = ACTIONS(2867),
    [anon_sym_match_BANG] = ACTIONS(2869),
    [anon_sym_function] = ACTIONS(2867),
    [anon_sym_LT_DASH] = ACTIONS(2867),
    [anon_sym_DOT_LBRACK] = ACTIONS(2869),
    [anon_sym_LT] = ACTIONS(2869),
    [anon_sym_use] = ACTIONS(2867),
    [anon_sym_use_BANG] = ACTIONS(2869),
    [anon_sym_do_BANG] = ACTIONS(2869),
    [anon_sym_begin] = ACTIONS(2867),
    [anon_sym_LPAREN2] = ACTIONS(2867),
    [anon_sym_or] = ACTIONS(2867),
    [aux_sym_char_token1] = ACTIONS(2869),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2867),
    [anon_sym_DQUOTE] = ACTIONS(2867),
    [anon_sym_AT_DQUOTE] = ACTIONS(2869),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2869),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2869),
    [sym_bool] = ACTIONS(2867),
    [sym_unit] = ACTIONS(2869),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2867),
    [sym_op_identifier] = ACTIONS(2867),
    [anon_sym_PLUS] = ACTIONS(2867),
    [anon_sym_DASH] = ACTIONS(2867),
    [anon_sym_PLUS_DOT] = ACTIONS(2867),
    [anon_sym_DASH_DOT] = ACTIONS(2867),
    [anon_sym_PERCENT] = ACTIONS(2867),
    [anon_sym_AMP_AMP] = ACTIONS(2867),
    [anon_sym_TILDE] = ACTIONS(2869),
    [aux_sym_prefix_op_token1] = ACTIONS(2867),
    [aux_sym_infix_op_token1] = ACTIONS(2869),
    [aux_sym_infix_op_token2] = ACTIONS(2867),
    [anon_sym_PIPE_PIPE] = ACTIONS(2867),
    [anon_sym_BANG_EQ] = ACTIONS(2867),
    [anon_sym_COLON_EQ] = ACTIONS(2869),
    [anon_sym_DOLLAR] = ACTIONS(2867),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2867),
    [sym_int] = ACTIONS(2867),
    [sym_xint] = ACTIONS(2869),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2869),
    [sym__newline] = ACTIONS(2869),
  },
  [1814] = {
    [sym_block_comment] = STATE(1814),
    [sym_compiler_directive_decl] = STATE(1814),
    [sym_fsi_directive_decl] = STATE(1814),
    [sym_preproc_line] = STATE(1814),
    [sym_identifier] = ACTIONS(2873),
    [anon_sym_EQ] = ACTIONS(2875),
    [anon_sym_COLON] = ACTIONS(2873),
    [anon_sym_return] = ACTIONS(2873),
    [anon_sym_do] = ACTIONS(2873),
    [anon_sym_let] = ACTIONS(2873),
    [anon_sym_let_BANG] = ACTIONS(2875),
    [anon_sym_LPAREN] = ACTIONS(2873),
    [anon_sym_COMMA] = ACTIONS(2875),
    [anon_sym_null] = ACTIONS(2873),
    [anon_sym_QMARK] = ACTIONS(2873),
    [anon_sym_COLON_QMARK] = ACTIONS(2873),
    [anon_sym_COLON_COLON] = ACTIONS(2875),
    [anon_sym_AMP] = ACTIONS(2873),
    [anon_sym_LBRACK] = ACTIONS(2873),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2875),
    [anon_sym_LBRACE] = ACTIONS(2873),
    [anon_sym_LT_AT] = ACTIONS(2873),
    [anon_sym_LT_AT_AT] = ACTIONS(2873),
    [anon_sym_DOT] = ACTIONS(2873),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2875),
    [anon_sym_new] = ACTIONS(2873),
    [anon_sym_return_BANG] = ACTIONS(2875),
    [anon_sym_yield] = ACTIONS(2873),
    [anon_sym_yield_BANG] = ACTIONS(2875),
    [anon_sym_lazy] = ACTIONS(2873),
    [anon_sym_assert] = ACTIONS(2873),
    [anon_sym_upcast] = ACTIONS(2873),
    [anon_sym_downcast] = ACTIONS(2873),
    [anon_sym_COLON_GT] = ACTIONS(2875),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2875),
    [anon_sym_for] = ACTIONS(2873),
    [anon_sym_while] = ACTIONS(2873),
    [anon_sym_if] = ACTIONS(2873),
    [anon_sym_fun] = ACTIONS(2873),
    [anon_sym_try] = ACTIONS(2873),
    [anon_sym_match] = ACTIONS(2873),
    [anon_sym_match_BANG] = ACTIONS(2875),
    [anon_sym_function] = ACTIONS(2873),
    [anon_sym_LT_DASH] = ACTIONS(2873),
    [anon_sym_DOT_LBRACK] = ACTIONS(2875),
    [anon_sym_LT] = ACTIONS(2875),
    [anon_sym_use] = ACTIONS(2873),
    [anon_sym_use_BANG] = ACTIONS(2875),
    [anon_sym_do_BANG] = ACTIONS(2875),
    [anon_sym_begin] = ACTIONS(2873),
    [anon_sym_LPAREN2] = ACTIONS(2873),
    [anon_sym_or] = ACTIONS(2873),
    [aux_sym_char_token1] = ACTIONS(2875),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2873),
    [anon_sym_DQUOTE] = ACTIONS(2873),
    [anon_sym_AT_DQUOTE] = ACTIONS(2875),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2875),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2875),
    [sym_bool] = ACTIONS(2873),
    [sym_unit] = ACTIONS(2875),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2873),
    [sym_op_identifier] = ACTIONS(2873),
    [anon_sym_PLUS] = ACTIONS(2873),
    [anon_sym_DASH] = ACTIONS(2873),
    [anon_sym_PLUS_DOT] = ACTIONS(2873),
    [anon_sym_DASH_DOT] = ACTIONS(2873),
    [anon_sym_PERCENT] = ACTIONS(2873),
    [anon_sym_AMP_AMP] = ACTIONS(2873),
    [anon_sym_TILDE] = ACTIONS(2875),
    [aux_sym_prefix_op_token1] = ACTIONS(2873),
    [aux_sym_infix_op_token1] = ACTIONS(2875),
    [aux_sym_infix_op_token2] = ACTIONS(2873),
    [anon_sym_PIPE_PIPE] = ACTIONS(2873),
    [anon_sym_BANG_EQ] = ACTIONS(2873),
    [anon_sym_COLON_EQ] = ACTIONS(2875),
    [anon_sym_DOLLAR] = ACTIONS(2873),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2873),
    [sym_int] = ACTIONS(2873),
    [sym_xint] = ACTIONS(2875),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2875),
    [anon_sym_POUNDendif] = ACTIONS(2875),
    [anon_sym_POUNDelse] = ACTIONS(2875),
    [sym__newline] = ACTIONS(2875),
  },
  [1815] = {
    [sym_block_comment] = STATE(1815),
    [sym_compiler_directive_decl] = STATE(1815),
    [sym_fsi_directive_decl] = STATE(1815),
    [sym_preproc_line] = STATE(1815),
    [sym_identifier] = ACTIONS(2760),
    [anon_sym_EQ] = ACTIONS(2762),
    [anon_sym_COLON] = ACTIONS(2760),
    [anon_sym_return] = ACTIONS(2760),
    [anon_sym_do] = ACTIONS(2760),
    [anon_sym_let] = ACTIONS(2760),
    [anon_sym_let_BANG] = ACTIONS(2762),
    [anon_sym_LPAREN] = ACTIONS(2760),
    [anon_sym_COMMA] = ACTIONS(2762),
    [anon_sym_null] = ACTIONS(2760),
    [anon_sym_QMARK] = ACTIONS(2760),
    [anon_sym_COLON_QMARK] = ACTIONS(2760),
    [anon_sym_COLON_COLON] = ACTIONS(2762),
    [anon_sym_PIPE] = ACTIONS(2760),
    [anon_sym_AMP] = ACTIONS(2760),
    [anon_sym_LBRACK] = ACTIONS(2760),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2762),
    [anon_sym_LBRACE] = ACTIONS(2760),
    [anon_sym_LT_AT] = ACTIONS(2760),
    [anon_sym_LT_AT_AT] = ACTIONS(2760),
    [anon_sym_DOT] = ACTIONS(2760),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2762),
    [anon_sym_new] = ACTIONS(2760),
    [anon_sym_return_BANG] = ACTIONS(2762),
    [anon_sym_yield] = ACTIONS(2760),
    [anon_sym_yield_BANG] = ACTIONS(2762),
    [anon_sym_lazy] = ACTIONS(2760),
    [anon_sym_assert] = ACTIONS(2760),
    [anon_sym_upcast] = ACTIONS(2760),
    [anon_sym_downcast] = ACTIONS(2760),
    [anon_sym_COLON_GT] = ACTIONS(2762),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2762),
    [anon_sym_for] = ACTIONS(2760),
    [anon_sym_while] = ACTIONS(2760),
    [anon_sym_if] = ACTIONS(2760),
    [anon_sym_fun] = ACTIONS(2760),
    [anon_sym_try] = ACTIONS(2760),
    [anon_sym_match] = ACTIONS(2760),
    [anon_sym_match_BANG] = ACTIONS(2762),
    [anon_sym_function] = ACTIONS(2760),
    [anon_sym_LT_DASH] = ACTIONS(2760),
    [anon_sym_DOT_LBRACK] = ACTIONS(2762),
    [anon_sym_LT] = ACTIONS(2762),
    [anon_sym_use] = ACTIONS(2760),
    [anon_sym_use_BANG] = ACTIONS(2762),
    [anon_sym_do_BANG] = ACTIONS(2762),
    [anon_sym_begin] = ACTIONS(2760),
    [anon_sym_LPAREN2] = ACTIONS(2760),
    [anon_sym_or] = ACTIONS(2760),
    [aux_sym_char_token1] = ACTIONS(2762),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2760),
    [anon_sym_DQUOTE] = ACTIONS(2760),
    [anon_sym_AT_DQUOTE] = ACTIONS(2762),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2762),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2762),
    [sym_bool] = ACTIONS(2760),
    [sym_unit] = ACTIONS(2762),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2760),
    [sym_op_identifier] = ACTIONS(2760),
    [anon_sym_PLUS] = ACTIONS(2760),
    [anon_sym_DASH] = ACTIONS(2760),
    [anon_sym_PLUS_DOT] = ACTIONS(2760),
    [anon_sym_DASH_DOT] = ACTIONS(2760),
    [anon_sym_PERCENT] = ACTIONS(2760),
    [anon_sym_AMP_AMP] = ACTIONS(2760),
    [anon_sym_TILDE] = ACTIONS(2762),
    [aux_sym_prefix_op_token1] = ACTIONS(2760),
    [aux_sym_infix_op_token1] = ACTIONS(2762),
    [aux_sym_infix_op_token2] = ACTIONS(2760),
    [anon_sym_PIPE_PIPE] = ACTIONS(2760),
    [anon_sym_BANG_EQ] = ACTIONS(2760),
    [anon_sym_COLON_EQ] = ACTIONS(2762),
    [anon_sym_DOLLAR] = ACTIONS(2760),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2760),
    [sym_int] = ACTIONS(2760),
    [sym_xint] = ACTIONS(2762),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2762),
    [anon_sym_POUNDendif] = ACTIONS(2762),
    [sym__newline] = ACTIONS(2762),
  },
  [1816] = {
    [sym_block_comment] = STATE(1816),
    [sym_compiler_directive_decl] = STATE(1816),
    [sym_fsi_directive_decl] = STATE(1816),
    [sym_preproc_line] = STATE(1816),
    [aux_sym_long_identifier_repeat1] = STATE(1816),
    [sym_identifier] = ACTIONS(2411),
    [anon_sym_EQ] = ACTIONS(2413),
    [anon_sym_COLON] = ACTIONS(2411),
    [anon_sym_return] = ACTIONS(2411),
    [anon_sym_do] = ACTIONS(2411),
    [anon_sym_let] = ACTIONS(2411),
    [anon_sym_let_BANG] = ACTIONS(2413),
    [anon_sym_LPAREN] = ACTIONS(2411),
    [anon_sym_COMMA] = ACTIONS(2413),
    [anon_sym_null] = ACTIONS(2411),
    [anon_sym_QMARK] = ACTIONS(2411),
    [anon_sym_COLON_QMARK] = ACTIONS(2411),
    [anon_sym_COLON_COLON] = ACTIONS(2413),
    [anon_sym_AMP] = ACTIONS(2411),
    [anon_sym_LBRACK] = ACTIONS(2411),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2413),
    [anon_sym_LBRACE] = ACTIONS(2411),
    [anon_sym_LT_AT] = ACTIONS(2411),
    [anon_sym_LT_AT_AT] = ACTIONS(2411),
    [anon_sym_DOT] = ACTIONS(4061),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2413),
    [anon_sym_new] = ACTIONS(2411),
    [anon_sym_return_BANG] = ACTIONS(2413),
    [anon_sym_yield] = ACTIONS(2411),
    [anon_sym_yield_BANG] = ACTIONS(2413),
    [anon_sym_lazy] = ACTIONS(2411),
    [anon_sym_assert] = ACTIONS(2411),
    [anon_sym_upcast] = ACTIONS(2411),
    [anon_sym_downcast] = ACTIONS(2411),
    [anon_sym_COLON_GT] = ACTIONS(2413),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2413),
    [anon_sym_for] = ACTIONS(2411),
    [anon_sym_while] = ACTIONS(2411),
    [anon_sym_if] = ACTIONS(2411),
    [anon_sym_fun] = ACTIONS(2411),
    [anon_sym_try] = ACTIONS(2411),
    [anon_sym_match] = ACTIONS(2411),
    [anon_sym_match_BANG] = ACTIONS(2413),
    [anon_sym_function] = ACTIONS(2411),
    [anon_sym_LT_DASH] = ACTIONS(2411),
    [anon_sym_DOT_LBRACK] = ACTIONS(2413),
    [anon_sym_LT] = ACTIONS(2413),
    [anon_sym_use] = ACTIONS(2411),
    [anon_sym_use_BANG] = ACTIONS(2413),
    [anon_sym_do_BANG] = ACTIONS(2413),
    [anon_sym_DOT_DOT] = ACTIONS(2413),
    [anon_sym_begin] = ACTIONS(2411),
    [anon_sym_LPAREN2] = ACTIONS(2411),
    [anon_sym_or] = ACTIONS(2411),
    [aux_sym_char_token1] = ACTIONS(2413),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2411),
    [anon_sym_DQUOTE] = ACTIONS(2411),
    [anon_sym_AT_DQUOTE] = ACTIONS(2413),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2413),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2413),
    [sym_bool] = ACTIONS(2411),
    [sym_unit] = ACTIONS(2413),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2411),
    [sym_op_identifier] = ACTIONS(2411),
    [anon_sym_PLUS] = ACTIONS(2411),
    [anon_sym_DASH] = ACTIONS(2411),
    [anon_sym_PLUS_DOT] = ACTIONS(2411),
    [anon_sym_DASH_DOT] = ACTIONS(2411),
    [anon_sym_PERCENT] = ACTIONS(2411),
    [anon_sym_AMP_AMP] = ACTIONS(2411),
    [anon_sym_TILDE] = ACTIONS(2413),
    [aux_sym_prefix_op_token1] = ACTIONS(2411),
    [aux_sym_infix_op_token1] = ACTIONS(2413),
    [aux_sym_infix_op_token2] = ACTIONS(2411),
    [anon_sym_PIPE_PIPE] = ACTIONS(2411),
    [anon_sym_BANG_EQ] = ACTIONS(2411),
    [anon_sym_COLON_EQ] = ACTIONS(2413),
    [anon_sym_DOLLAR] = ACTIONS(2411),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2411),
    [sym_int] = ACTIONS(2411),
    [sym_xint] = ACTIONS(2413),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2413),
    [sym__newline] = ACTIONS(2413),
  },
  [1817] = {
    [sym_block_comment] = STATE(1817),
    [sym_compiler_directive_decl] = STATE(1817),
    [sym_fsi_directive_decl] = STATE(1817),
    [sym_preproc_line] = STATE(1817),
    [aux_sym_long_identifier_repeat1] = STATE(1816),
    [sym_identifier] = ACTIONS(2418),
    [anon_sym_EQ] = ACTIONS(2420),
    [anon_sym_COLON] = ACTIONS(2418),
    [anon_sym_return] = ACTIONS(2418),
    [anon_sym_do] = ACTIONS(2418),
    [anon_sym_let] = ACTIONS(2418),
    [anon_sym_let_BANG] = ACTIONS(2420),
    [anon_sym_LPAREN] = ACTIONS(2418),
    [anon_sym_COMMA] = ACTIONS(2420),
    [anon_sym_null] = ACTIONS(2418),
    [anon_sym_QMARK] = ACTIONS(2418),
    [anon_sym_COLON_QMARK] = ACTIONS(2418),
    [anon_sym_COLON_COLON] = ACTIONS(2420),
    [anon_sym_AMP] = ACTIONS(2418),
    [anon_sym_LBRACK] = ACTIONS(2418),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2420),
    [anon_sym_LBRACE] = ACTIONS(2418),
    [anon_sym_LT_AT] = ACTIONS(2418),
    [anon_sym_LT_AT_AT] = ACTIONS(2418),
    [anon_sym_DOT] = ACTIONS(4064),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2420),
    [anon_sym_new] = ACTIONS(2418),
    [anon_sym_return_BANG] = ACTIONS(2420),
    [anon_sym_yield] = ACTIONS(2418),
    [anon_sym_yield_BANG] = ACTIONS(2420),
    [anon_sym_lazy] = ACTIONS(2418),
    [anon_sym_assert] = ACTIONS(2418),
    [anon_sym_upcast] = ACTIONS(2418),
    [anon_sym_downcast] = ACTIONS(2418),
    [anon_sym_COLON_GT] = ACTIONS(2420),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2420),
    [anon_sym_for] = ACTIONS(2418),
    [anon_sym_while] = ACTIONS(2418),
    [anon_sym_if] = ACTIONS(2418),
    [anon_sym_fun] = ACTIONS(2418),
    [anon_sym_try] = ACTIONS(2418),
    [anon_sym_match] = ACTIONS(2418),
    [anon_sym_match_BANG] = ACTIONS(2420),
    [anon_sym_function] = ACTIONS(2418),
    [anon_sym_LT_DASH] = ACTIONS(2418),
    [anon_sym_DOT_LBRACK] = ACTIONS(2420),
    [anon_sym_LT] = ACTIONS(2420),
    [anon_sym_use] = ACTIONS(2418),
    [anon_sym_use_BANG] = ACTIONS(2420),
    [anon_sym_do_BANG] = ACTIONS(2420),
    [anon_sym_DOT_DOT] = ACTIONS(2420),
    [anon_sym_begin] = ACTIONS(2418),
    [anon_sym_LPAREN2] = ACTIONS(2418),
    [anon_sym_or] = ACTIONS(2418),
    [aux_sym_char_token1] = ACTIONS(2420),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2418),
    [anon_sym_DQUOTE] = ACTIONS(2418),
    [anon_sym_AT_DQUOTE] = ACTIONS(2420),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2420),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2420),
    [sym_bool] = ACTIONS(2418),
    [sym_unit] = ACTIONS(2420),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2418),
    [sym_op_identifier] = ACTIONS(2418),
    [anon_sym_PLUS] = ACTIONS(2418),
    [anon_sym_DASH] = ACTIONS(2418),
    [anon_sym_PLUS_DOT] = ACTIONS(2418),
    [anon_sym_DASH_DOT] = ACTIONS(2418),
    [anon_sym_PERCENT] = ACTIONS(2418),
    [anon_sym_AMP_AMP] = ACTIONS(2418),
    [anon_sym_TILDE] = ACTIONS(2420),
    [aux_sym_prefix_op_token1] = ACTIONS(2418),
    [aux_sym_infix_op_token1] = ACTIONS(2420),
    [aux_sym_infix_op_token2] = ACTIONS(2418),
    [anon_sym_PIPE_PIPE] = ACTIONS(2418),
    [anon_sym_BANG_EQ] = ACTIONS(2418),
    [anon_sym_COLON_EQ] = ACTIONS(2420),
    [anon_sym_DOLLAR] = ACTIONS(2418),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2418),
    [sym_int] = ACTIONS(2418),
    [sym_xint] = ACTIONS(2420),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2420),
    [sym__newline] = ACTIONS(2420),
  },
  [1818] = {
    [sym_block_comment] = STATE(1818),
    [sym_compiler_directive_decl] = STATE(1818),
    [sym_fsi_directive_decl] = STATE(1818),
    [sym_preproc_line] = STATE(1818),
    [sym_identifier] = ACTIONS(2877),
    [anon_sym_EQ] = ACTIONS(2879),
    [anon_sym_COLON] = ACTIONS(2877),
    [anon_sym_return] = ACTIONS(2877),
    [anon_sym_do] = ACTIONS(2877),
    [anon_sym_let] = ACTIONS(2877),
    [anon_sym_let_BANG] = ACTIONS(2879),
    [anon_sym_LPAREN] = ACTIONS(2877),
    [anon_sym_COMMA] = ACTIONS(2879),
    [anon_sym_null] = ACTIONS(2877),
    [anon_sym_QMARK] = ACTIONS(2877),
    [anon_sym_COLON_QMARK] = ACTIONS(2877),
    [anon_sym_COLON_COLON] = ACTIONS(2879),
    [anon_sym_AMP] = ACTIONS(2877),
    [anon_sym_LBRACK] = ACTIONS(2877),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2879),
    [anon_sym_LBRACE] = ACTIONS(2877),
    [anon_sym_LT_AT] = ACTIONS(2877),
    [anon_sym_LT_AT_AT] = ACTIONS(2877),
    [anon_sym_DOT] = ACTIONS(2877),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2879),
    [anon_sym_new] = ACTIONS(2877),
    [anon_sym_return_BANG] = ACTIONS(2879),
    [anon_sym_yield] = ACTIONS(2877),
    [anon_sym_yield_BANG] = ACTIONS(2879),
    [anon_sym_lazy] = ACTIONS(2877),
    [anon_sym_assert] = ACTIONS(2877),
    [anon_sym_upcast] = ACTIONS(2877),
    [anon_sym_downcast] = ACTIONS(2877),
    [anon_sym_COLON_GT] = ACTIONS(2879),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2879),
    [anon_sym_for] = ACTIONS(2877),
    [anon_sym_while] = ACTIONS(2877),
    [anon_sym_if] = ACTIONS(2877),
    [anon_sym_fun] = ACTIONS(2877),
    [anon_sym_try] = ACTIONS(2877),
    [anon_sym_match] = ACTIONS(2877),
    [anon_sym_match_BANG] = ACTIONS(2879),
    [anon_sym_function] = ACTIONS(2877),
    [anon_sym_LT_DASH] = ACTIONS(2877),
    [anon_sym_DOT_LBRACK] = ACTIONS(2879),
    [anon_sym_LT] = ACTIONS(2879),
    [anon_sym_use] = ACTIONS(2877),
    [anon_sym_use_BANG] = ACTIONS(2879),
    [anon_sym_do_BANG] = ACTIONS(2879),
    [anon_sym_begin] = ACTIONS(2877),
    [anon_sym_LPAREN2] = ACTIONS(2877),
    [anon_sym_or] = ACTIONS(2877),
    [aux_sym_char_token1] = ACTIONS(2879),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2877),
    [anon_sym_DQUOTE] = ACTIONS(2877),
    [anon_sym_AT_DQUOTE] = ACTIONS(2879),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2879),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2879),
    [sym_bool] = ACTIONS(2877),
    [sym_unit] = ACTIONS(2879),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2877),
    [sym_op_identifier] = ACTIONS(2877),
    [anon_sym_PLUS] = ACTIONS(2877),
    [anon_sym_DASH] = ACTIONS(2877),
    [anon_sym_PLUS_DOT] = ACTIONS(2877),
    [anon_sym_DASH_DOT] = ACTIONS(2877),
    [anon_sym_PERCENT] = ACTIONS(2877),
    [anon_sym_AMP_AMP] = ACTIONS(2877),
    [anon_sym_TILDE] = ACTIONS(2879),
    [aux_sym_prefix_op_token1] = ACTIONS(2877),
    [aux_sym_infix_op_token1] = ACTIONS(2879),
    [aux_sym_infix_op_token2] = ACTIONS(2877),
    [anon_sym_PIPE_PIPE] = ACTIONS(2877),
    [anon_sym_BANG_EQ] = ACTIONS(2877),
    [anon_sym_COLON_EQ] = ACTIONS(2879),
    [anon_sym_DOLLAR] = ACTIONS(2877),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2877),
    [sym_int] = ACTIONS(2877),
    [sym_xint] = ACTIONS(2879),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2879),
    [anon_sym_POUNDendif] = ACTIONS(2879),
    [anon_sym_POUNDelse] = ACTIONS(2879),
    [sym__newline] = ACTIONS(2879),
  },
  [1819] = {
    [sym_block_comment] = STATE(1819),
    [sym_compiler_directive_decl] = STATE(1819),
    [sym_fsi_directive_decl] = STATE(1819),
    [sym_preproc_line] = STATE(1819),
    [sym_identifier] = ACTIONS(2756),
    [anon_sym_EQ] = ACTIONS(2758),
    [anon_sym_COLON] = ACTIONS(2756),
    [anon_sym_return] = ACTIONS(2756),
    [anon_sym_do] = ACTIONS(2756),
    [anon_sym_let] = ACTIONS(2756),
    [anon_sym_let_BANG] = ACTIONS(2758),
    [anon_sym_LPAREN] = ACTIONS(2756),
    [anon_sym_COMMA] = ACTIONS(2758),
    [anon_sym_null] = ACTIONS(2756),
    [anon_sym_QMARK] = ACTIONS(2756),
    [anon_sym_COLON_QMARK] = ACTIONS(2756),
    [anon_sym_COLON_COLON] = ACTIONS(2758),
    [anon_sym_PIPE] = ACTIONS(2756),
    [anon_sym_AMP] = ACTIONS(2756),
    [anon_sym_LBRACK] = ACTIONS(2756),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2758),
    [anon_sym_LBRACE] = ACTIONS(2756),
    [anon_sym_LT_AT] = ACTIONS(2756),
    [anon_sym_LT_AT_AT] = ACTIONS(2756),
    [anon_sym_DOT] = ACTIONS(2756),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2758),
    [anon_sym_new] = ACTIONS(2756),
    [anon_sym_return_BANG] = ACTIONS(2758),
    [anon_sym_yield] = ACTIONS(2756),
    [anon_sym_yield_BANG] = ACTIONS(2758),
    [anon_sym_lazy] = ACTIONS(2756),
    [anon_sym_assert] = ACTIONS(2756),
    [anon_sym_upcast] = ACTIONS(2756),
    [anon_sym_downcast] = ACTIONS(2756),
    [anon_sym_COLON_GT] = ACTIONS(2758),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2758),
    [anon_sym_for] = ACTIONS(2756),
    [anon_sym_while] = ACTIONS(2756),
    [anon_sym_if] = ACTIONS(2756),
    [anon_sym_fun] = ACTIONS(2756),
    [anon_sym_try] = ACTIONS(2756),
    [anon_sym_match] = ACTIONS(2756),
    [anon_sym_match_BANG] = ACTIONS(2758),
    [anon_sym_function] = ACTIONS(2756),
    [anon_sym_LT_DASH] = ACTIONS(2756),
    [anon_sym_DOT_LBRACK] = ACTIONS(2758),
    [anon_sym_LT] = ACTIONS(2758),
    [anon_sym_use] = ACTIONS(2756),
    [anon_sym_use_BANG] = ACTIONS(2758),
    [anon_sym_do_BANG] = ACTIONS(2758),
    [anon_sym_begin] = ACTIONS(2756),
    [anon_sym_LPAREN2] = ACTIONS(2756),
    [anon_sym_or] = ACTIONS(2756),
    [aux_sym_char_token1] = ACTIONS(2758),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2756),
    [anon_sym_DQUOTE] = ACTIONS(2756),
    [anon_sym_AT_DQUOTE] = ACTIONS(2758),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2758),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2758),
    [sym_bool] = ACTIONS(2756),
    [sym_unit] = ACTIONS(2758),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2756),
    [sym_op_identifier] = ACTIONS(2756),
    [anon_sym_PLUS] = ACTIONS(2756),
    [anon_sym_DASH] = ACTIONS(2756),
    [anon_sym_PLUS_DOT] = ACTIONS(2756),
    [anon_sym_DASH_DOT] = ACTIONS(2756),
    [anon_sym_PERCENT] = ACTIONS(2756),
    [anon_sym_AMP_AMP] = ACTIONS(2756),
    [anon_sym_TILDE] = ACTIONS(2758),
    [aux_sym_prefix_op_token1] = ACTIONS(2756),
    [aux_sym_infix_op_token1] = ACTIONS(2758),
    [aux_sym_infix_op_token2] = ACTIONS(2756),
    [anon_sym_PIPE_PIPE] = ACTIONS(2756),
    [anon_sym_BANG_EQ] = ACTIONS(2756),
    [anon_sym_COLON_EQ] = ACTIONS(2758),
    [anon_sym_DOLLAR] = ACTIONS(2756),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2756),
    [sym_int] = ACTIONS(2756),
    [sym_xint] = ACTIONS(2758),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2758),
    [anon_sym_POUNDendif] = ACTIONS(2758),
    [sym__newline] = ACTIONS(2758),
  },
  [1820] = {
    [sym_block_comment] = STATE(1820),
    [sym_compiler_directive_decl] = STATE(1820),
    [sym_fsi_directive_decl] = STATE(1820),
    [sym_preproc_line] = STATE(1820),
    [sym_identifier] = ACTIONS(2783),
    [anon_sym_EQ] = ACTIONS(2785),
    [anon_sym_COLON] = ACTIONS(2783),
    [anon_sym_return] = ACTIONS(2783),
    [anon_sym_do] = ACTIONS(2783),
    [anon_sym_let] = ACTIONS(2783),
    [anon_sym_let_BANG] = ACTIONS(2785),
    [anon_sym_LPAREN] = ACTIONS(2783),
    [anon_sym_COMMA] = ACTIONS(2785),
    [anon_sym_null] = ACTIONS(2783),
    [anon_sym_QMARK] = ACTIONS(2783),
    [anon_sym_COLON_QMARK] = ACTIONS(2783),
    [anon_sym_COLON_COLON] = ACTIONS(2785),
    [anon_sym_AMP] = ACTIONS(2783),
    [anon_sym_LBRACK] = ACTIONS(2783),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2785),
    [anon_sym_LBRACE] = ACTIONS(2783),
    [anon_sym_LT_AT] = ACTIONS(2783),
    [anon_sym_LT_AT_AT] = ACTIONS(2783),
    [anon_sym_DOT] = ACTIONS(2783),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2785),
    [anon_sym_new] = ACTIONS(2783),
    [anon_sym_return_BANG] = ACTIONS(2785),
    [anon_sym_yield] = ACTIONS(2783),
    [anon_sym_yield_BANG] = ACTIONS(2785),
    [anon_sym_lazy] = ACTIONS(2783),
    [anon_sym_assert] = ACTIONS(2783),
    [anon_sym_upcast] = ACTIONS(2783),
    [anon_sym_downcast] = ACTIONS(2783),
    [anon_sym_COLON_GT] = ACTIONS(2785),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2785),
    [anon_sym_for] = ACTIONS(2783),
    [anon_sym_done] = ACTIONS(4004),
    [anon_sym_while] = ACTIONS(2783),
    [anon_sym_if] = ACTIONS(2783),
    [anon_sym_fun] = ACTIONS(2783),
    [anon_sym_try] = ACTIONS(2783),
    [anon_sym_match] = ACTIONS(2783),
    [anon_sym_match_BANG] = ACTIONS(2785),
    [anon_sym_function] = ACTIONS(2783),
    [anon_sym_LT_DASH] = ACTIONS(2783),
    [anon_sym_DOT_LBRACK] = ACTIONS(2785),
    [anon_sym_LT] = ACTIONS(2785),
    [anon_sym_use] = ACTIONS(2783),
    [anon_sym_use_BANG] = ACTIONS(2785),
    [anon_sym_do_BANG] = ACTIONS(2785),
    [anon_sym_DOT_DOT] = ACTIONS(2785),
    [anon_sym_begin] = ACTIONS(2783),
    [anon_sym_LPAREN2] = ACTIONS(2783),
    [anon_sym_or] = ACTIONS(2783),
    [aux_sym_char_token1] = ACTIONS(2785),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2783),
    [anon_sym_DQUOTE] = ACTIONS(2783),
    [anon_sym_AT_DQUOTE] = ACTIONS(2785),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2785),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2785),
    [sym_bool] = ACTIONS(2783),
    [sym_unit] = ACTIONS(2785),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2783),
    [sym_op_identifier] = ACTIONS(2783),
    [anon_sym_PLUS] = ACTIONS(2783),
    [anon_sym_DASH] = ACTIONS(2783),
    [anon_sym_PLUS_DOT] = ACTIONS(2783),
    [anon_sym_DASH_DOT] = ACTIONS(2783),
    [anon_sym_PERCENT] = ACTIONS(2783),
    [anon_sym_AMP_AMP] = ACTIONS(2783),
    [anon_sym_TILDE] = ACTIONS(2785),
    [aux_sym_prefix_op_token1] = ACTIONS(2783),
    [aux_sym_infix_op_token1] = ACTIONS(2785),
    [aux_sym_infix_op_token2] = ACTIONS(2783),
    [anon_sym_PIPE_PIPE] = ACTIONS(2783),
    [anon_sym_BANG_EQ] = ACTIONS(2783),
    [anon_sym_COLON_EQ] = ACTIONS(2785),
    [anon_sym_DOLLAR] = ACTIONS(2783),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2783),
    [sym_int] = ACTIONS(2783),
    [sym_xint] = ACTIONS(2785),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2785),
    [sym__newline] = ACTIONS(2785),
  },
  [1821] = {
    [sym_block_comment] = STATE(1821),
    [sym_compiler_directive_decl] = STATE(1821),
    [sym_fsi_directive_decl] = STATE(1821),
    [sym_preproc_line] = STATE(1821),
    [sym_identifier] = ACTIONS(2883),
    [anon_sym_EQ] = ACTIONS(2885),
    [anon_sym_COLON] = ACTIONS(2883),
    [anon_sym_return] = ACTIONS(2883),
    [anon_sym_do] = ACTIONS(2883),
    [anon_sym_let] = ACTIONS(2883),
    [anon_sym_let_BANG] = ACTIONS(2885),
    [anon_sym_LPAREN] = ACTIONS(2883),
    [anon_sym_COMMA] = ACTIONS(2885),
    [anon_sym_null] = ACTIONS(2883),
    [anon_sym_QMARK] = ACTIONS(2883),
    [anon_sym_COLON_QMARK] = ACTIONS(2883),
    [anon_sym_COLON_COLON] = ACTIONS(2885),
    [anon_sym_AMP] = ACTIONS(2883),
    [anon_sym_LBRACK] = ACTIONS(2883),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2885),
    [anon_sym_LBRACE] = ACTIONS(2883),
    [anon_sym_LT_AT] = ACTIONS(2883),
    [anon_sym_LT_AT_AT] = ACTIONS(2883),
    [anon_sym_DOT] = ACTIONS(2883),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2885),
    [anon_sym_new] = ACTIONS(2883),
    [anon_sym_return_BANG] = ACTIONS(2885),
    [anon_sym_yield] = ACTIONS(2883),
    [anon_sym_yield_BANG] = ACTIONS(2885),
    [anon_sym_lazy] = ACTIONS(2883),
    [anon_sym_assert] = ACTIONS(2883),
    [anon_sym_upcast] = ACTIONS(2883),
    [anon_sym_downcast] = ACTIONS(2883),
    [anon_sym_COLON_GT] = ACTIONS(2885),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2885),
    [anon_sym_for] = ACTIONS(2883),
    [anon_sym_while] = ACTIONS(2883),
    [anon_sym_if] = ACTIONS(2883),
    [anon_sym_fun] = ACTIONS(2883),
    [anon_sym_try] = ACTIONS(2883),
    [anon_sym_match] = ACTIONS(2883),
    [anon_sym_match_BANG] = ACTIONS(2885),
    [anon_sym_function] = ACTIONS(2883),
    [anon_sym_LT_DASH] = ACTIONS(2883),
    [anon_sym_DOT_LBRACK] = ACTIONS(2885),
    [anon_sym_LT] = ACTIONS(2885),
    [anon_sym_use] = ACTIONS(2883),
    [anon_sym_use_BANG] = ACTIONS(2885),
    [anon_sym_do_BANG] = ACTIONS(2885),
    [anon_sym_begin] = ACTIONS(2883),
    [anon_sym_LPAREN2] = ACTIONS(2883),
    [anon_sym_or] = ACTIONS(2883),
    [aux_sym_char_token1] = ACTIONS(2885),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2883),
    [anon_sym_DQUOTE] = ACTIONS(2883),
    [anon_sym_AT_DQUOTE] = ACTIONS(2885),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2885),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2885),
    [sym_bool] = ACTIONS(2883),
    [sym_unit] = ACTIONS(2885),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2883),
    [sym_op_identifier] = ACTIONS(2883),
    [anon_sym_PLUS] = ACTIONS(2883),
    [anon_sym_DASH] = ACTIONS(2883),
    [anon_sym_PLUS_DOT] = ACTIONS(2883),
    [anon_sym_DASH_DOT] = ACTIONS(2883),
    [anon_sym_PERCENT] = ACTIONS(2883),
    [anon_sym_AMP_AMP] = ACTIONS(2883),
    [anon_sym_TILDE] = ACTIONS(2885),
    [aux_sym_prefix_op_token1] = ACTIONS(2883),
    [aux_sym_infix_op_token1] = ACTIONS(2885),
    [aux_sym_infix_op_token2] = ACTIONS(2883),
    [anon_sym_PIPE_PIPE] = ACTIONS(2883),
    [anon_sym_BANG_EQ] = ACTIONS(2883),
    [anon_sym_COLON_EQ] = ACTIONS(2885),
    [anon_sym_DOLLAR] = ACTIONS(2883),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2883),
    [sym_int] = ACTIONS(2883),
    [sym_xint] = ACTIONS(2885),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2885),
    [anon_sym_POUNDendif] = ACTIONS(2885),
    [anon_sym_POUNDelse] = ACTIONS(2885),
    [sym__newline] = ACTIONS(2885),
  },
  [1822] = {
    [sym_block_comment] = STATE(1822),
    [sym_compiler_directive_decl] = STATE(1822),
    [sym_fsi_directive_decl] = STATE(1822),
    [sym_preproc_line] = STATE(1822),
    [sym_identifier] = ACTIONS(2713),
    [anon_sym_EQ] = ACTIONS(2715),
    [anon_sym_COLON] = ACTIONS(2713),
    [anon_sym_return] = ACTIONS(2713),
    [anon_sym_do] = ACTIONS(2713),
    [anon_sym_let] = ACTIONS(2713),
    [anon_sym_let_BANG] = ACTIONS(2715),
    [anon_sym_LPAREN] = ACTIONS(2713),
    [anon_sym_COMMA] = ACTIONS(2715),
    [anon_sym_null] = ACTIONS(2713),
    [anon_sym_QMARK] = ACTIONS(2713),
    [anon_sym_COLON_QMARK] = ACTIONS(2713),
    [anon_sym_COLON_COLON] = ACTIONS(2715),
    [anon_sym_PIPE] = ACTIONS(2713),
    [anon_sym_AMP] = ACTIONS(2713),
    [anon_sym_LBRACK] = ACTIONS(2713),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2715),
    [anon_sym_LBRACE] = ACTIONS(2713),
    [anon_sym_LT_AT] = ACTIONS(2713),
    [anon_sym_LT_AT_AT] = ACTIONS(2713),
    [anon_sym_DOT] = ACTIONS(2713),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2715),
    [anon_sym_new] = ACTIONS(2713),
    [anon_sym_return_BANG] = ACTIONS(2715),
    [anon_sym_yield] = ACTIONS(2713),
    [anon_sym_yield_BANG] = ACTIONS(2715),
    [anon_sym_lazy] = ACTIONS(2713),
    [anon_sym_assert] = ACTIONS(2713),
    [anon_sym_upcast] = ACTIONS(2713),
    [anon_sym_downcast] = ACTIONS(2713),
    [anon_sym_COLON_GT] = ACTIONS(2715),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2715),
    [anon_sym_for] = ACTIONS(2713),
    [anon_sym_while] = ACTIONS(2713),
    [anon_sym_if] = ACTIONS(2713),
    [anon_sym_fun] = ACTIONS(2713),
    [anon_sym_try] = ACTIONS(2713),
    [anon_sym_match] = ACTIONS(2713),
    [anon_sym_match_BANG] = ACTIONS(2715),
    [anon_sym_function] = ACTIONS(2713),
    [anon_sym_LT_DASH] = ACTIONS(2713),
    [anon_sym_DOT_LBRACK] = ACTIONS(2715),
    [anon_sym_LT] = ACTIONS(2715),
    [anon_sym_use] = ACTIONS(2713),
    [anon_sym_use_BANG] = ACTIONS(2715),
    [anon_sym_do_BANG] = ACTIONS(2715),
    [anon_sym_begin] = ACTIONS(2713),
    [anon_sym_LPAREN2] = ACTIONS(2713),
    [anon_sym_or] = ACTIONS(2713),
    [aux_sym_char_token1] = ACTIONS(2715),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2713),
    [anon_sym_DQUOTE] = ACTIONS(2713),
    [anon_sym_AT_DQUOTE] = ACTIONS(2715),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2715),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2715),
    [sym_bool] = ACTIONS(2713),
    [sym_unit] = ACTIONS(2715),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2713),
    [sym_op_identifier] = ACTIONS(2713),
    [anon_sym_PLUS] = ACTIONS(2713),
    [anon_sym_DASH] = ACTIONS(2713),
    [anon_sym_PLUS_DOT] = ACTIONS(2713),
    [anon_sym_DASH_DOT] = ACTIONS(2713),
    [anon_sym_PERCENT] = ACTIONS(2713),
    [anon_sym_AMP_AMP] = ACTIONS(2713),
    [anon_sym_TILDE] = ACTIONS(2715),
    [aux_sym_prefix_op_token1] = ACTIONS(2713),
    [aux_sym_infix_op_token1] = ACTIONS(2715),
    [aux_sym_infix_op_token2] = ACTIONS(2713),
    [anon_sym_PIPE_PIPE] = ACTIONS(2713),
    [anon_sym_BANG_EQ] = ACTIONS(2713),
    [anon_sym_COLON_EQ] = ACTIONS(2715),
    [anon_sym_DOLLAR] = ACTIONS(2713),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2713),
    [sym_int] = ACTIONS(2713),
    [sym_xint] = ACTIONS(2715),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2715),
    [anon_sym_POUNDendif] = ACTIONS(2715),
    [sym__newline] = ACTIONS(2715),
  },
  [1823] = {
    [sym_block_comment] = STATE(1823),
    [sym_compiler_directive_decl] = STATE(1823),
    [sym_fsi_directive_decl] = STATE(1823),
    [sym_preproc_line] = STATE(1823),
    [sym_identifier] = ACTIONS(2766),
    [anon_sym_EQ] = ACTIONS(2768),
    [anon_sym_COLON] = ACTIONS(2766),
    [anon_sym_return] = ACTIONS(2766),
    [anon_sym_do] = ACTIONS(2766),
    [anon_sym_let] = ACTIONS(2766),
    [anon_sym_let_BANG] = ACTIONS(2768),
    [anon_sym_LPAREN] = ACTIONS(2766),
    [anon_sym_COMMA] = ACTIONS(2768),
    [anon_sym_null] = ACTIONS(2766),
    [anon_sym_QMARK] = ACTIONS(2766),
    [anon_sym_COLON_QMARK] = ACTIONS(2766),
    [anon_sym_COLON_COLON] = ACTIONS(2768),
    [anon_sym_PIPE] = ACTIONS(2766),
    [anon_sym_AMP] = ACTIONS(2766),
    [anon_sym_LBRACK] = ACTIONS(2766),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2768),
    [anon_sym_LBRACE] = ACTIONS(2766),
    [anon_sym_LT_AT] = ACTIONS(2766),
    [anon_sym_LT_AT_AT] = ACTIONS(2766),
    [anon_sym_DOT] = ACTIONS(2766),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2768),
    [anon_sym_new] = ACTIONS(2766),
    [anon_sym_return_BANG] = ACTIONS(2768),
    [anon_sym_yield] = ACTIONS(2766),
    [anon_sym_yield_BANG] = ACTIONS(2768),
    [anon_sym_lazy] = ACTIONS(2766),
    [anon_sym_assert] = ACTIONS(2766),
    [anon_sym_upcast] = ACTIONS(2766),
    [anon_sym_downcast] = ACTIONS(2766),
    [anon_sym_COLON_GT] = ACTIONS(2768),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2768),
    [anon_sym_for] = ACTIONS(2766),
    [anon_sym_while] = ACTIONS(2766),
    [anon_sym_if] = ACTIONS(2766),
    [anon_sym_fun] = ACTIONS(2766),
    [anon_sym_try] = ACTIONS(2766),
    [anon_sym_match] = ACTIONS(2766),
    [anon_sym_match_BANG] = ACTIONS(2768),
    [anon_sym_function] = ACTIONS(2766),
    [anon_sym_LT_DASH] = ACTIONS(2766),
    [anon_sym_DOT_LBRACK] = ACTIONS(2768),
    [anon_sym_LT] = ACTIONS(2768),
    [anon_sym_use] = ACTIONS(2766),
    [anon_sym_use_BANG] = ACTIONS(2768),
    [anon_sym_do_BANG] = ACTIONS(2768),
    [anon_sym_begin] = ACTIONS(2766),
    [anon_sym_LPAREN2] = ACTIONS(2766),
    [anon_sym_or] = ACTIONS(2766),
    [aux_sym_char_token1] = ACTIONS(2768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2766),
    [anon_sym_DQUOTE] = ACTIONS(2766),
    [anon_sym_AT_DQUOTE] = ACTIONS(2768),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2768),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2768),
    [sym_bool] = ACTIONS(2766),
    [sym_unit] = ACTIONS(2768),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2766),
    [sym_op_identifier] = ACTIONS(2766),
    [anon_sym_PLUS] = ACTIONS(2766),
    [anon_sym_DASH] = ACTIONS(2766),
    [anon_sym_PLUS_DOT] = ACTIONS(2766),
    [anon_sym_DASH_DOT] = ACTIONS(2766),
    [anon_sym_PERCENT] = ACTIONS(2766),
    [anon_sym_AMP_AMP] = ACTIONS(2766),
    [anon_sym_TILDE] = ACTIONS(2768),
    [aux_sym_prefix_op_token1] = ACTIONS(2766),
    [aux_sym_infix_op_token1] = ACTIONS(2768),
    [aux_sym_infix_op_token2] = ACTIONS(2766),
    [anon_sym_PIPE_PIPE] = ACTIONS(2766),
    [anon_sym_BANG_EQ] = ACTIONS(2766),
    [anon_sym_COLON_EQ] = ACTIONS(2768),
    [anon_sym_DOLLAR] = ACTIONS(2766),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2766),
    [sym_int] = ACTIONS(2766),
    [sym_xint] = ACTIONS(2768),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2768),
    [anon_sym_POUNDendif] = ACTIONS(2768),
    [sym__newline] = ACTIONS(2768),
  },
  [1824] = {
    [sym_block_comment] = STATE(1824),
    [sym_compiler_directive_decl] = STATE(1824),
    [sym_fsi_directive_decl] = STATE(1824),
    [sym_preproc_line] = STATE(1824),
    [sym_identifier] = ACTIONS(2783),
    [anon_sym_EQ] = ACTIONS(2785),
    [anon_sym_COLON] = ACTIONS(2783),
    [anon_sym_return] = ACTIONS(2783),
    [anon_sym_do] = ACTIONS(2783),
    [anon_sym_let] = ACTIONS(2783),
    [anon_sym_let_BANG] = ACTIONS(2785),
    [anon_sym_LPAREN] = ACTIONS(2783),
    [anon_sym_COMMA] = ACTIONS(2785),
    [anon_sym_null] = ACTIONS(2783),
    [anon_sym_QMARK] = ACTIONS(2783),
    [anon_sym_COLON_QMARK] = ACTIONS(2783),
    [anon_sym_COLON_COLON] = ACTIONS(2785),
    [anon_sym_AMP] = ACTIONS(2783),
    [anon_sym_LBRACK] = ACTIONS(2783),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2785),
    [anon_sym_LBRACE] = ACTIONS(2783),
    [anon_sym_LT_AT] = ACTIONS(2783),
    [anon_sym_AT_GT] = ACTIONS(2783),
    [anon_sym_LT_AT_AT] = ACTIONS(2783),
    [anon_sym_DOT] = ACTIONS(2783),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2785),
    [anon_sym_new] = ACTIONS(2783),
    [anon_sym_return_BANG] = ACTIONS(2785),
    [anon_sym_yield] = ACTIONS(2783),
    [anon_sym_yield_BANG] = ACTIONS(2785),
    [anon_sym_lazy] = ACTIONS(2783),
    [anon_sym_assert] = ACTIONS(2783),
    [anon_sym_upcast] = ACTIONS(2783),
    [anon_sym_downcast] = ACTIONS(2783),
    [anon_sym_COLON_GT] = ACTIONS(2785),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2785),
    [anon_sym_for] = ACTIONS(2783),
    [anon_sym_done] = ACTIONS(3821),
    [anon_sym_while] = ACTIONS(2783),
    [anon_sym_if] = ACTIONS(2783),
    [anon_sym_fun] = ACTIONS(2783),
    [anon_sym_try] = ACTIONS(2783),
    [anon_sym_match] = ACTIONS(2783),
    [anon_sym_match_BANG] = ACTIONS(2785),
    [anon_sym_function] = ACTIONS(2783),
    [anon_sym_LT_DASH] = ACTIONS(2783),
    [anon_sym_DOT_LBRACK] = ACTIONS(2785),
    [anon_sym_LT] = ACTIONS(2785),
    [anon_sym_use] = ACTIONS(2783),
    [anon_sym_use_BANG] = ACTIONS(2785),
    [anon_sym_do_BANG] = ACTIONS(2785),
    [anon_sym_begin] = ACTIONS(2783),
    [anon_sym_LPAREN2] = ACTIONS(2783),
    [anon_sym_or] = ACTIONS(2783),
    [aux_sym_char_token1] = ACTIONS(2785),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2783),
    [anon_sym_DQUOTE] = ACTIONS(2783),
    [anon_sym_AT_DQUOTE] = ACTIONS(2785),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2785),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2785),
    [sym_bool] = ACTIONS(2783),
    [sym_unit] = ACTIONS(2785),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2783),
    [sym_op_identifier] = ACTIONS(2783),
    [anon_sym_PLUS] = ACTIONS(2783),
    [anon_sym_DASH] = ACTIONS(2783),
    [anon_sym_PLUS_DOT] = ACTIONS(2783),
    [anon_sym_DASH_DOT] = ACTIONS(2783),
    [anon_sym_PERCENT] = ACTIONS(2783),
    [anon_sym_AMP_AMP] = ACTIONS(2783),
    [anon_sym_TILDE] = ACTIONS(2785),
    [aux_sym_prefix_op_token1] = ACTIONS(2783),
    [aux_sym_infix_op_token1] = ACTIONS(2785),
    [aux_sym_infix_op_token2] = ACTIONS(2783),
    [anon_sym_PIPE_PIPE] = ACTIONS(2783),
    [anon_sym_BANG_EQ] = ACTIONS(2783),
    [anon_sym_COLON_EQ] = ACTIONS(2785),
    [anon_sym_DOLLAR] = ACTIONS(2783),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2783),
    [sym_int] = ACTIONS(2783),
    [sym_xint] = ACTIONS(2785),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2785),
    [sym__newline] = ACTIONS(2785),
  },
  [1825] = {
    [sym_block_comment] = STATE(1825),
    [sym_compiler_directive_decl] = STATE(1825),
    [sym_fsi_directive_decl] = STATE(1825),
    [sym_preproc_line] = STATE(1825),
    [sym_identifier] = ACTIONS(2887),
    [anon_sym_EQ] = ACTIONS(2889),
    [anon_sym_COLON] = ACTIONS(2887),
    [anon_sym_return] = ACTIONS(2887),
    [anon_sym_do] = ACTIONS(2887),
    [anon_sym_let] = ACTIONS(2887),
    [anon_sym_let_BANG] = ACTIONS(2889),
    [anon_sym_LPAREN] = ACTIONS(2887),
    [anon_sym_COMMA] = ACTIONS(2889),
    [anon_sym_null] = ACTIONS(2887),
    [anon_sym_QMARK] = ACTIONS(2887),
    [anon_sym_COLON_QMARK] = ACTIONS(2887),
    [anon_sym_COLON_COLON] = ACTIONS(2889),
    [anon_sym_AMP] = ACTIONS(2887),
    [anon_sym_LBRACK] = ACTIONS(2887),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2889),
    [anon_sym_LBRACE] = ACTIONS(2887),
    [anon_sym_LT_AT] = ACTIONS(2887),
    [anon_sym_LT_AT_AT] = ACTIONS(2887),
    [anon_sym_DOT] = ACTIONS(2887),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2889),
    [anon_sym_new] = ACTIONS(2887),
    [anon_sym_return_BANG] = ACTIONS(2889),
    [anon_sym_yield] = ACTIONS(2887),
    [anon_sym_yield_BANG] = ACTIONS(2889),
    [anon_sym_lazy] = ACTIONS(2887),
    [anon_sym_assert] = ACTIONS(2887),
    [anon_sym_upcast] = ACTIONS(2887),
    [anon_sym_downcast] = ACTIONS(2887),
    [anon_sym_COLON_GT] = ACTIONS(2889),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2889),
    [anon_sym_for] = ACTIONS(2887),
    [anon_sym_while] = ACTIONS(2887),
    [anon_sym_if] = ACTIONS(2887),
    [anon_sym_fun] = ACTIONS(2887),
    [anon_sym_try] = ACTIONS(2887),
    [anon_sym_match] = ACTIONS(2887),
    [anon_sym_match_BANG] = ACTIONS(2889),
    [anon_sym_function] = ACTIONS(2887),
    [anon_sym_LT_DASH] = ACTIONS(2887),
    [anon_sym_DOT_LBRACK] = ACTIONS(2889),
    [anon_sym_LT] = ACTIONS(2889),
    [anon_sym_use] = ACTIONS(2887),
    [anon_sym_use_BANG] = ACTIONS(2889),
    [anon_sym_do_BANG] = ACTIONS(2889),
    [anon_sym_begin] = ACTIONS(2887),
    [anon_sym_LPAREN2] = ACTIONS(2887),
    [anon_sym_or] = ACTIONS(2887),
    [aux_sym_char_token1] = ACTIONS(2889),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2887),
    [anon_sym_DQUOTE] = ACTIONS(2887),
    [anon_sym_AT_DQUOTE] = ACTIONS(2889),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2889),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2889),
    [sym_bool] = ACTIONS(2887),
    [sym_unit] = ACTIONS(2889),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2887),
    [sym_op_identifier] = ACTIONS(2887),
    [anon_sym_PLUS] = ACTIONS(2887),
    [anon_sym_DASH] = ACTIONS(2887),
    [anon_sym_PLUS_DOT] = ACTIONS(2887),
    [anon_sym_DASH_DOT] = ACTIONS(2887),
    [anon_sym_PERCENT] = ACTIONS(2887),
    [anon_sym_AMP_AMP] = ACTIONS(2887),
    [anon_sym_TILDE] = ACTIONS(2889),
    [aux_sym_prefix_op_token1] = ACTIONS(2887),
    [aux_sym_infix_op_token1] = ACTIONS(2889),
    [aux_sym_infix_op_token2] = ACTIONS(2887),
    [anon_sym_PIPE_PIPE] = ACTIONS(2887),
    [anon_sym_BANG_EQ] = ACTIONS(2887),
    [anon_sym_COLON_EQ] = ACTIONS(2889),
    [anon_sym_DOLLAR] = ACTIONS(2887),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2887),
    [sym_int] = ACTIONS(2887),
    [sym_xint] = ACTIONS(2889),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2889),
    [anon_sym_POUNDendif] = ACTIONS(2889),
    [anon_sym_POUNDelse] = ACTIONS(2889),
    [sym__newline] = ACTIONS(2889),
  },
  [1826] = {
    [sym_block_comment] = STATE(1826),
    [sym_compiler_directive_decl] = STATE(1826),
    [sym_fsi_directive_decl] = STATE(1826),
    [sym_preproc_line] = STATE(1826),
    [sym_identifier] = ACTIONS(2891),
    [anon_sym_EQ] = ACTIONS(2893),
    [anon_sym_COLON] = ACTIONS(2891),
    [anon_sym_return] = ACTIONS(2891),
    [anon_sym_do] = ACTIONS(2891),
    [anon_sym_let] = ACTIONS(2891),
    [anon_sym_let_BANG] = ACTIONS(2893),
    [anon_sym_LPAREN] = ACTIONS(2891),
    [anon_sym_COMMA] = ACTIONS(2893),
    [anon_sym_null] = ACTIONS(2891),
    [anon_sym_QMARK] = ACTIONS(2891),
    [anon_sym_COLON_QMARK] = ACTIONS(2891),
    [anon_sym_COLON_COLON] = ACTIONS(2893),
    [anon_sym_AMP] = ACTIONS(2891),
    [anon_sym_LBRACK] = ACTIONS(2891),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2893),
    [anon_sym_LBRACE] = ACTIONS(2891),
    [anon_sym_LT_AT] = ACTIONS(2891),
    [anon_sym_LT_AT_AT] = ACTIONS(2891),
    [anon_sym_DOT] = ACTIONS(2891),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2893),
    [anon_sym_new] = ACTIONS(2891),
    [anon_sym_return_BANG] = ACTIONS(2893),
    [anon_sym_yield] = ACTIONS(2891),
    [anon_sym_yield_BANG] = ACTIONS(2893),
    [anon_sym_lazy] = ACTIONS(2891),
    [anon_sym_assert] = ACTIONS(2891),
    [anon_sym_upcast] = ACTIONS(2891),
    [anon_sym_downcast] = ACTIONS(2891),
    [anon_sym_COLON_GT] = ACTIONS(2893),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2893),
    [anon_sym_for] = ACTIONS(2891),
    [anon_sym_while] = ACTIONS(2891),
    [anon_sym_if] = ACTIONS(2891),
    [anon_sym_fun] = ACTIONS(2891),
    [anon_sym_try] = ACTIONS(2891),
    [anon_sym_match] = ACTIONS(2891),
    [anon_sym_match_BANG] = ACTIONS(2893),
    [anon_sym_function] = ACTIONS(2891),
    [anon_sym_LT_DASH] = ACTIONS(2891),
    [anon_sym_DOT_LBRACK] = ACTIONS(2893),
    [anon_sym_LT] = ACTIONS(2893),
    [anon_sym_use] = ACTIONS(2891),
    [anon_sym_use_BANG] = ACTIONS(2893),
    [anon_sym_do_BANG] = ACTIONS(2893),
    [anon_sym_begin] = ACTIONS(2891),
    [anon_sym_LPAREN2] = ACTIONS(2891),
    [anon_sym_or] = ACTIONS(2891),
    [aux_sym_char_token1] = ACTIONS(2893),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2891),
    [anon_sym_DQUOTE] = ACTIONS(2891),
    [anon_sym_AT_DQUOTE] = ACTIONS(2893),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2893),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2893),
    [sym_bool] = ACTIONS(2891),
    [sym_unit] = ACTIONS(2893),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2891),
    [sym_op_identifier] = ACTIONS(2891),
    [anon_sym_PLUS] = ACTIONS(2891),
    [anon_sym_DASH] = ACTIONS(2891),
    [anon_sym_PLUS_DOT] = ACTIONS(2891),
    [anon_sym_DASH_DOT] = ACTIONS(2891),
    [anon_sym_PERCENT] = ACTIONS(2891),
    [anon_sym_AMP_AMP] = ACTIONS(2891),
    [anon_sym_TILDE] = ACTIONS(2893),
    [aux_sym_prefix_op_token1] = ACTIONS(2891),
    [aux_sym_infix_op_token1] = ACTIONS(2893),
    [aux_sym_infix_op_token2] = ACTIONS(2891),
    [anon_sym_PIPE_PIPE] = ACTIONS(2891),
    [anon_sym_BANG_EQ] = ACTIONS(2891),
    [anon_sym_COLON_EQ] = ACTIONS(2893),
    [anon_sym_DOLLAR] = ACTIONS(2891),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2891),
    [sym_int] = ACTIONS(2891),
    [sym_xint] = ACTIONS(2893),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2893),
    [anon_sym_POUNDendif] = ACTIONS(2893),
    [anon_sym_POUNDelse] = ACTIONS(2893),
    [sym__newline] = ACTIONS(2893),
  },
  [1827] = {
    [sym_block_comment] = STATE(1827),
    [sym_compiler_directive_decl] = STATE(1827),
    [sym_fsi_directive_decl] = STATE(1827),
    [sym_preproc_line] = STATE(1827),
    [sym_identifier] = ACTIONS(2411),
    [anon_sym_EQ] = ACTIONS(2413),
    [anon_sym_COLON] = ACTIONS(2411),
    [anon_sym_return] = ACTIONS(2411),
    [anon_sym_do] = ACTIONS(2411),
    [anon_sym_and] = ACTIONS(2411),
    [anon_sym_let] = ACTIONS(2411),
    [anon_sym_let_BANG] = ACTIONS(2413),
    [anon_sym_LPAREN] = ACTIONS(2411),
    [anon_sym_COMMA] = ACTIONS(2413),
    [anon_sym_null] = ACTIONS(2411),
    [anon_sym_QMARK] = ACTIONS(2411),
    [anon_sym_COLON_QMARK] = ACTIONS(2411),
    [anon_sym_COLON_COLON] = ACTIONS(2413),
    [anon_sym_AMP] = ACTIONS(2411),
    [anon_sym_LBRACK] = ACTIONS(2411),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2413),
    [anon_sym_LBRACE] = ACTIONS(2411),
    [anon_sym_LT_AT] = ACTIONS(2411),
    [anon_sym_LT_AT_AT] = ACTIONS(2411),
    [anon_sym_DOT] = ACTIONS(2411),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2413),
    [anon_sym_new] = ACTIONS(2411),
    [anon_sym_return_BANG] = ACTIONS(2413),
    [anon_sym_yield] = ACTIONS(2411),
    [anon_sym_yield_BANG] = ACTIONS(2413),
    [anon_sym_lazy] = ACTIONS(2411),
    [anon_sym_assert] = ACTIONS(2411),
    [anon_sym_upcast] = ACTIONS(2411),
    [anon_sym_downcast] = ACTIONS(2411),
    [anon_sym_COLON_GT] = ACTIONS(2413),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2413),
    [anon_sym_for] = ACTIONS(2411),
    [anon_sym_while] = ACTIONS(2411),
    [anon_sym_if] = ACTIONS(2411),
    [anon_sym_fun] = ACTIONS(2411),
    [anon_sym_try] = ACTIONS(2411),
    [anon_sym_match] = ACTIONS(2411),
    [anon_sym_match_BANG] = ACTIONS(2413),
    [anon_sym_function] = ACTIONS(2411),
    [anon_sym_LT_DASH] = ACTIONS(2411),
    [anon_sym_DOT_LBRACK] = ACTIONS(2413),
    [anon_sym_LT] = ACTIONS(2413),
    [anon_sym_use] = ACTIONS(2411),
    [anon_sym_use_BANG] = ACTIONS(2413),
    [anon_sym_do_BANG] = ACTIONS(2413),
    [anon_sym_begin] = ACTIONS(2411),
    [anon_sym_LPAREN2] = ACTIONS(2411),
    [anon_sym_or] = ACTIONS(2411),
    [aux_sym_char_token1] = ACTIONS(2413),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2411),
    [anon_sym_DQUOTE] = ACTIONS(2411),
    [anon_sym_AT_DQUOTE] = ACTIONS(2413),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2413),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2413),
    [sym_bool] = ACTIONS(2411),
    [sym_unit] = ACTIONS(2413),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2411),
    [sym_op_identifier] = ACTIONS(2411),
    [anon_sym_PLUS] = ACTIONS(2411),
    [anon_sym_DASH] = ACTIONS(2411),
    [anon_sym_PLUS_DOT] = ACTIONS(2411),
    [anon_sym_DASH_DOT] = ACTIONS(2411),
    [anon_sym_PERCENT] = ACTIONS(2411),
    [anon_sym_AMP_AMP] = ACTIONS(2411),
    [anon_sym_TILDE] = ACTIONS(2413),
    [aux_sym_prefix_op_token1] = ACTIONS(2411),
    [aux_sym_infix_op_token1] = ACTIONS(2413),
    [aux_sym_infix_op_token2] = ACTIONS(2411),
    [anon_sym_PIPE_PIPE] = ACTIONS(2411),
    [anon_sym_BANG_EQ] = ACTIONS(2411),
    [anon_sym_COLON_EQ] = ACTIONS(2413),
    [anon_sym_DOLLAR] = ACTIONS(2411),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2411),
    [sym_int] = ACTIONS(2411),
    [sym_xint] = ACTIONS(2413),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2413),
    [sym__newline] = ACTIONS(2413),
    [sym__dedent] = ACTIONS(2413),
  },
  [1828] = {
    [sym_block_comment] = STATE(1828),
    [sym_compiler_directive_decl] = STATE(1828),
    [sym_fsi_directive_decl] = STATE(1828),
    [sym_preproc_line] = STATE(1828),
    [sym_identifier] = ACTIONS(2770),
    [anon_sym_EQ] = ACTIONS(2772),
    [anon_sym_COLON] = ACTIONS(2770),
    [anon_sym_return] = ACTIONS(2770),
    [anon_sym_do] = ACTIONS(2770),
    [anon_sym_let] = ACTIONS(2770),
    [anon_sym_let_BANG] = ACTIONS(2772),
    [anon_sym_LPAREN] = ACTIONS(2770),
    [anon_sym_COMMA] = ACTIONS(2772),
    [anon_sym_null] = ACTIONS(2770),
    [anon_sym_QMARK] = ACTIONS(2770),
    [anon_sym_COLON_QMARK] = ACTIONS(2770),
    [anon_sym_COLON_COLON] = ACTIONS(2772),
    [anon_sym_AMP] = ACTIONS(2770),
    [anon_sym_LBRACK] = ACTIONS(2770),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2772),
    [anon_sym_LBRACE] = ACTIONS(2770),
    [anon_sym_LT_AT] = ACTIONS(2770),
    [anon_sym_AT_GT] = ACTIONS(2770),
    [anon_sym_LT_AT_AT] = ACTIONS(2770),
    [anon_sym_DOT] = ACTIONS(2770),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2772),
    [anon_sym_new] = ACTIONS(2770),
    [anon_sym_return_BANG] = ACTIONS(2772),
    [anon_sym_yield] = ACTIONS(2770),
    [anon_sym_yield_BANG] = ACTIONS(2772),
    [anon_sym_lazy] = ACTIONS(2770),
    [anon_sym_assert] = ACTIONS(2770),
    [anon_sym_upcast] = ACTIONS(2770),
    [anon_sym_downcast] = ACTIONS(2770),
    [anon_sym_COLON_GT] = ACTIONS(2772),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2772),
    [anon_sym_for] = ACTIONS(2770),
    [anon_sym_done] = ACTIONS(4066),
    [anon_sym_while] = ACTIONS(2770),
    [anon_sym_if] = ACTIONS(2770),
    [anon_sym_fun] = ACTIONS(2770),
    [anon_sym_try] = ACTIONS(2770),
    [anon_sym_match] = ACTIONS(2770),
    [anon_sym_match_BANG] = ACTIONS(2772),
    [anon_sym_function] = ACTIONS(2770),
    [anon_sym_LT_DASH] = ACTIONS(2770),
    [anon_sym_DOT_LBRACK] = ACTIONS(2772),
    [anon_sym_LT] = ACTIONS(2772),
    [anon_sym_use] = ACTIONS(2770),
    [anon_sym_use_BANG] = ACTIONS(2772),
    [anon_sym_do_BANG] = ACTIONS(2772),
    [anon_sym_begin] = ACTIONS(2770),
    [anon_sym_LPAREN2] = ACTIONS(2770),
    [anon_sym_or] = ACTIONS(2770),
    [aux_sym_char_token1] = ACTIONS(2772),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2770),
    [anon_sym_DQUOTE] = ACTIONS(2770),
    [anon_sym_AT_DQUOTE] = ACTIONS(2772),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2772),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2772),
    [sym_bool] = ACTIONS(2770),
    [sym_unit] = ACTIONS(2772),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2770),
    [sym_op_identifier] = ACTIONS(2770),
    [anon_sym_PLUS] = ACTIONS(2770),
    [anon_sym_DASH] = ACTIONS(2770),
    [anon_sym_PLUS_DOT] = ACTIONS(2770),
    [anon_sym_DASH_DOT] = ACTIONS(2770),
    [anon_sym_PERCENT] = ACTIONS(2770),
    [anon_sym_AMP_AMP] = ACTIONS(2770),
    [anon_sym_TILDE] = ACTIONS(2772),
    [aux_sym_prefix_op_token1] = ACTIONS(2770),
    [aux_sym_infix_op_token1] = ACTIONS(2772),
    [aux_sym_infix_op_token2] = ACTIONS(2770),
    [anon_sym_PIPE_PIPE] = ACTIONS(2770),
    [anon_sym_BANG_EQ] = ACTIONS(2770),
    [anon_sym_COLON_EQ] = ACTIONS(2772),
    [anon_sym_DOLLAR] = ACTIONS(2770),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2770),
    [sym_int] = ACTIONS(2770),
    [sym_xint] = ACTIONS(2772),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2772),
    [sym__newline] = ACTIONS(2772),
  },
  [1829] = {
    [sym_block_comment] = STATE(1829),
    [sym_compiler_directive_decl] = STATE(1829),
    [sym_fsi_directive_decl] = STATE(1829),
    [sym_preproc_line] = STATE(1829),
    [sym_identifier] = ACTIONS(2804),
    [anon_sym_EQ] = ACTIONS(2806),
    [anon_sym_COLON] = ACTIONS(2804),
    [anon_sym_return] = ACTIONS(2804),
    [anon_sym_do] = ACTIONS(2804),
    [anon_sym_let] = ACTIONS(2804),
    [anon_sym_let_BANG] = ACTIONS(2806),
    [anon_sym_LPAREN] = ACTIONS(2804),
    [anon_sym_COMMA] = ACTIONS(2806),
    [anon_sym_null] = ACTIONS(2804),
    [anon_sym_QMARK] = ACTIONS(2804),
    [anon_sym_COLON_QMARK] = ACTIONS(2804),
    [anon_sym_COLON_COLON] = ACTIONS(2806),
    [anon_sym_AMP] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2804),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(2804),
    [anon_sym_LT_AT] = ACTIONS(2804),
    [anon_sym_AT_GT] = ACTIONS(2804),
    [anon_sym_LT_AT_AT] = ACTIONS(2804),
    [anon_sym_DOT] = ACTIONS(2804),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2806),
    [anon_sym_new] = ACTIONS(2804),
    [anon_sym_return_BANG] = ACTIONS(2806),
    [anon_sym_yield] = ACTIONS(2804),
    [anon_sym_yield_BANG] = ACTIONS(2806),
    [anon_sym_lazy] = ACTIONS(2804),
    [anon_sym_assert] = ACTIONS(2804),
    [anon_sym_upcast] = ACTIONS(2804),
    [anon_sym_downcast] = ACTIONS(2804),
    [anon_sym_COLON_GT] = ACTIONS(2806),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2806),
    [anon_sym_for] = ACTIONS(2804),
    [anon_sym_done] = ACTIONS(4068),
    [anon_sym_while] = ACTIONS(2804),
    [anon_sym_if] = ACTIONS(2804),
    [anon_sym_fun] = ACTIONS(2804),
    [anon_sym_try] = ACTIONS(2804),
    [anon_sym_match] = ACTIONS(2804),
    [anon_sym_match_BANG] = ACTIONS(2806),
    [anon_sym_function] = ACTIONS(2804),
    [anon_sym_LT_DASH] = ACTIONS(2804),
    [anon_sym_DOT_LBRACK] = ACTIONS(2806),
    [anon_sym_LT] = ACTIONS(2806),
    [anon_sym_use] = ACTIONS(2804),
    [anon_sym_use_BANG] = ACTIONS(2806),
    [anon_sym_do_BANG] = ACTIONS(2806),
    [anon_sym_begin] = ACTIONS(2804),
    [anon_sym_LPAREN2] = ACTIONS(2804),
    [anon_sym_or] = ACTIONS(2804),
    [aux_sym_char_token1] = ACTIONS(2806),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2804),
    [anon_sym_DQUOTE] = ACTIONS(2804),
    [anon_sym_AT_DQUOTE] = ACTIONS(2806),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2806),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2806),
    [sym_bool] = ACTIONS(2804),
    [sym_unit] = ACTIONS(2806),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2804),
    [sym_op_identifier] = ACTIONS(2804),
    [anon_sym_PLUS] = ACTIONS(2804),
    [anon_sym_DASH] = ACTIONS(2804),
    [anon_sym_PLUS_DOT] = ACTIONS(2804),
    [anon_sym_DASH_DOT] = ACTIONS(2804),
    [anon_sym_PERCENT] = ACTIONS(2804),
    [anon_sym_AMP_AMP] = ACTIONS(2804),
    [anon_sym_TILDE] = ACTIONS(2806),
    [aux_sym_prefix_op_token1] = ACTIONS(2804),
    [aux_sym_infix_op_token1] = ACTIONS(2806),
    [aux_sym_infix_op_token2] = ACTIONS(2804),
    [anon_sym_PIPE_PIPE] = ACTIONS(2804),
    [anon_sym_BANG_EQ] = ACTIONS(2804),
    [anon_sym_COLON_EQ] = ACTIONS(2806),
    [anon_sym_DOLLAR] = ACTIONS(2804),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2804),
    [sym_int] = ACTIONS(2804),
    [sym_xint] = ACTIONS(2806),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2806),
    [sym__newline] = ACTIONS(2806),
  },
  [1830] = {
    [sym_block_comment] = STATE(1830),
    [sym_compiler_directive_decl] = STATE(1830),
    [sym_fsi_directive_decl] = STATE(1830),
    [sym_preproc_line] = STATE(1830),
    [sym_identifier] = ACTIONS(2910),
    [anon_sym_EQ] = ACTIONS(2912),
    [anon_sym_COLON] = ACTIONS(2910),
    [anon_sym_return] = ACTIONS(2910),
    [anon_sym_do] = ACTIONS(2910),
    [anon_sym_let] = ACTIONS(2910),
    [anon_sym_let_BANG] = ACTIONS(2912),
    [anon_sym_LPAREN] = ACTIONS(2910),
    [anon_sym_COMMA] = ACTIONS(2912),
    [anon_sym_null] = ACTIONS(2910),
    [anon_sym_QMARK] = ACTIONS(2910),
    [anon_sym_COLON_QMARK] = ACTIONS(2910),
    [anon_sym_COLON_COLON] = ACTIONS(2912),
    [anon_sym_AMP] = ACTIONS(2910),
    [anon_sym_LBRACK] = ACTIONS(2910),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2912),
    [anon_sym_LBRACE] = ACTIONS(2910),
    [anon_sym_LT_AT] = ACTIONS(2910),
    [anon_sym_LT_AT_AT] = ACTIONS(2910),
    [anon_sym_DOT] = ACTIONS(2910),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2912),
    [anon_sym_new] = ACTIONS(2910),
    [anon_sym_return_BANG] = ACTIONS(2912),
    [anon_sym_yield] = ACTIONS(2910),
    [anon_sym_yield_BANG] = ACTIONS(2912),
    [anon_sym_lazy] = ACTIONS(2910),
    [anon_sym_assert] = ACTIONS(2910),
    [anon_sym_upcast] = ACTIONS(2910),
    [anon_sym_downcast] = ACTIONS(2910),
    [anon_sym_COLON_GT] = ACTIONS(2912),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2912),
    [anon_sym_for] = ACTIONS(2910),
    [anon_sym_while] = ACTIONS(2910),
    [anon_sym_if] = ACTIONS(2910),
    [anon_sym_fun] = ACTIONS(2910),
    [anon_sym_try] = ACTIONS(2910),
    [anon_sym_match] = ACTIONS(2910),
    [anon_sym_match_BANG] = ACTIONS(2912),
    [anon_sym_function] = ACTIONS(2910),
    [anon_sym_LT_DASH] = ACTIONS(2910),
    [anon_sym_DOT_LBRACK] = ACTIONS(2912),
    [anon_sym_LT] = ACTIONS(2912),
    [anon_sym_use] = ACTIONS(2910),
    [anon_sym_use_BANG] = ACTIONS(2912),
    [anon_sym_do_BANG] = ACTIONS(2912),
    [anon_sym_begin] = ACTIONS(2910),
    [anon_sym_LPAREN2] = ACTIONS(2910),
    [anon_sym_or] = ACTIONS(2910),
    [aux_sym_char_token1] = ACTIONS(2912),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2910),
    [anon_sym_DQUOTE] = ACTIONS(2910),
    [anon_sym_AT_DQUOTE] = ACTIONS(2912),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2912),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2912),
    [sym_bool] = ACTIONS(2910),
    [sym_unit] = ACTIONS(2912),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2910),
    [sym_op_identifier] = ACTIONS(2910),
    [anon_sym_PLUS] = ACTIONS(2910),
    [anon_sym_DASH] = ACTIONS(2910),
    [anon_sym_PLUS_DOT] = ACTIONS(2910),
    [anon_sym_DASH_DOT] = ACTIONS(2910),
    [anon_sym_PERCENT] = ACTIONS(2910),
    [anon_sym_AMP_AMP] = ACTIONS(2910),
    [anon_sym_TILDE] = ACTIONS(2912),
    [aux_sym_prefix_op_token1] = ACTIONS(2910),
    [aux_sym_infix_op_token1] = ACTIONS(2912),
    [aux_sym_infix_op_token2] = ACTIONS(2910),
    [anon_sym_PIPE_PIPE] = ACTIONS(2910),
    [anon_sym_BANG_EQ] = ACTIONS(2910),
    [anon_sym_COLON_EQ] = ACTIONS(2912),
    [anon_sym_DOLLAR] = ACTIONS(2910),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2910),
    [sym_int] = ACTIONS(2910),
    [sym_xint] = ACTIONS(2912),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2912),
    [anon_sym_POUNDendif] = ACTIONS(2912),
    [anon_sym_POUNDelse] = ACTIONS(2912),
    [sym__newline] = ACTIONS(2912),
  },
  [1831] = {
    [sym_block_comment] = STATE(1831),
    [sym_compiler_directive_decl] = STATE(1831),
    [sym_fsi_directive_decl] = STATE(1831),
    [sym_preproc_line] = STATE(1831),
    [sym_identifier] = ACTIONS(2914),
    [anon_sym_EQ] = ACTIONS(2916),
    [anon_sym_COLON] = ACTIONS(2914),
    [anon_sym_return] = ACTIONS(2914),
    [anon_sym_do] = ACTIONS(2914),
    [anon_sym_let] = ACTIONS(2914),
    [anon_sym_let_BANG] = ACTIONS(2916),
    [anon_sym_LPAREN] = ACTIONS(2914),
    [anon_sym_COMMA] = ACTIONS(2916),
    [anon_sym_null] = ACTIONS(2914),
    [anon_sym_QMARK] = ACTIONS(2914),
    [anon_sym_COLON_QMARK] = ACTIONS(2914),
    [anon_sym_COLON_COLON] = ACTIONS(2916),
    [anon_sym_AMP] = ACTIONS(2914),
    [anon_sym_LBRACK] = ACTIONS(2914),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2916),
    [anon_sym_LBRACE] = ACTIONS(2914),
    [anon_sym_LT_AT] = ACTIONS(2914),
    [anon_sym_LT_AT_AT] = ACTIONS(2914),
    [anon_sym_DOT] = ACTIONS(2914),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2916),
    [anon_sym_new] = ACTIONS(2914),
    [anon_sym_return_BANG] = ACTIONS(2916),
    [anon_sym_yield] = ACTIONS(2914),
    [anon_sym_yield_BANG] = ACTIONS(2916),
    [anon_sym_lazy] = ACTIONS(2914),
    [anon_sym_assert] = ACTIONS(2914),
    [anon_sym_upcast] = ACTIONS(2914),
    [anon_sym_downcast] = ACTIONS(2914),
    [anon_sym_COLON_GT] = ACTIONS(2916),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2916),
    [anon_sym_for] = ACTIONS(2914),
    [anon_sym_while] = ACTIONS(2914),
    [anon_sym_if] = ACTIONS(2914),
    [anon_sym_fun] = ACTIONS(2914),
    [anon_sym_try] = ACTIONS(2914),
    [anon_sym_match] = ACTIONS(2914),
    [anon_sym_match_BANG] = ACTIONS(2916),
    [anon_sym_function] = ACTIONS(2914),
    [anon_sym_LT_DASH] = ACTIONS(2914),
    [anon_sym_DOT_LBRACK] = ACTIONS(2916),
    [anon_sym_LT] = ACTIONS(2916),
    [anon_sym_use] = ACTIONS(2914),
    [anon_sym_use_BANG] = ACTIONS(2916),
    [anon_sym_do_BANG] = ACTIONS(2916),
    [anon_sym_begin] = ACTIONS(2914),
    [anon_sym_LPAREN2] = ACTIONS(2914),
    [anon_sym_or] = ACTIONS(2914),
    [aux_sym_char_token1] = ACTIONS(2916),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2914),
    [anon_sym_DQUOTE] = ACTIONS(2914),
    [anon_sym_AT_DQUOTE] = ACTIONS(2916),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2916),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2916),
    [sym_bool] = ACTIONS(2914),
    [sym_unit] = ACTIONS(2916),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2914),
    [sym_op_identifier] = ACTIONS(2914),
    [anon_sym_PLUS] = ACTIONS(2914),
    [anon_sym_DASH] = ACTIONS(2914),
    [anon_sym_PLUS_DOT] = ACTIONS(2914),
    [anon_sym_DASH_DOT] = ACTIONS(2914),
    [anon_sym_PERCENT] = ACTIONS(2914),
    [anon_sym_AMP_AMP] = ACTIONS(2914),
    [anon_sym_TILDE] = ACTIONS(2916),
    [aux_sym_prefix_op_token1] = ACTIONS(2914),
    [aux_sym_infix_op_token1] = ACTIONS(2916),
    [aux_sym_infix_op_token2] = ACTIONS(2914),
    [anon_sym_PIPE_PIPE] = ACTIONS(2914),
    [anon_sym_BANG_EQ] = ACTIONS(2914),
    [anon_sym_COLON_EQ] = ACTIONS(2916),
    [anon_sym_DOLLAR] = ACTIONS(2914),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2914),
    [sym_int] = ACTIONS(2914),
    [sym_xint] = ACTIONS(2916),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2916),
    [anon_sym_POUNDendif] = ACTIONS(2916),
    [anon_sym_POUNDelse] = ACTIONS(2916),
    [sym__newline] = ACTIONS(2916),
  },
  [1832] = {
    [sym_block_comment] = STATE(1832),
    [sym_compiler_directive_decl] = STATE(1832),
    [sym_fsi_directive_decl] = STATE(1832),
    [sym_preproc_line] = STATE(1832),
    [sym_identifier] = ACTIONS(2918),
    [anon_sym_EQ] = ACTIONS(2920),
    [anon_sym_COLON] = ACTIONS(2918),
    [anon_sym_return] = ACTIONS(2918),
    [anon_sym_do] = ACTIONS(2918),
    [anon_sym_let] = ACTIONS(2918),
    [anon_sym_let_BANG] = ACTIONS(2920),
    [anon_sym_LPAREN] = ACTIONS(2918),
    [anon_sym_COMMA] = ACTIONS(2920),
    [anon_sym_null] = ACTIONS(2918),
    [anon_sym_QMARK] = ACTIONS(2918),
    [anon_sym_COLON_QMARK] = ACTIONS(2918),
    [anon_sym_COLON_COLON] = ACTIONS(2920),
    [anon_sym_AMP] = ACTIONS(2918),
    [anon_sym_LBRACK] = ACTIONS(2918),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2920),
    [anon_sym_LBRACE] = ACTIONS(2918),
    [anon_sym_LT_AT] = ACTIONS(2918),
    [anon_sym_LT_AT_AT] = ACTIONS(2918),
    [anon_sym_DOT] = ACTIONS(2918),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2920),
    [anon_sym_new] = ACTIONS(2918),
    [anon_sym_return_BANG] = ACTIONS(2920),
    [anon_sym_yield] = ACTIONS(2918),
    [anon_sym_yield_BANG] = ACTIONS(2920),
    [anon_sym_lazy] = ACTIONS(2918),
    [anon_sym_assert] = ACTIONS(2918),
    [anon_sym_upcast] = ACTIONS(2918),
    [anon_sym_downcast] = ACTIONS(2918),
    [anon_sym_COLON_GT] = ACTIONS(2920),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2920),
    [anon_sym_for] = ACTIONS(2918),
    [anon_sym_while] = ACTIONS(2918),
    [anon_sym_if] = ACTIONS(2918),
    [anon_sym_fun] = ACTIONS(2918),
    [anon_sym_try] = ACTIONS(2918),
    [anon_sym_match] = ACTIONS(2918),
    [anon_sym_match_BANG] = ACTIONS(2920),
    [anon_sym_function] = ACTIONS(2918),
    [anon_sym_LT_DASH] = ACTIONS(2918),
    [anon_sym_DOT_LBRACK] = ACTIONS(2920),
    [anon_sym_LT] = ACTIONS(2920),
    [anon_sym_use] = ACTIONS(2918),
    [anon_sym_use_BANG] = ACTIONS(2920),
    [anon_sym_do_BANG] = ACTIONS(2920),
    [anon_sym_begin] = ACTIONS(2918),
    [anon_sym_LPAREN2] = ACTIONS(2918),
    [anon_sym_or] = ACTIONS(2918),
    [aux_sym_char_token1] = ACTIONS(2920),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2918),
    [anon_sym_DQUOTE] = ACTIONS(2918),
    [anon_sym_AT_DQUOTE] = ACTIONS(2920),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2920),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2920),
    [sym_bool] = ACTIONS(2918),
    [sym_unit] = ACTIONS(2920),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2918),
    [sym_op_identifier] = ACTIONS(2918),
    [anon_sym_PLUS] = ACTIONS(2918),
    [anon_sym_DASH] = ACTIONS(2918),
    [anon_sym_PLUS_DOT] = ACTIONS(2918),
    [anon_sym_DASH_DOT] = ACTIONS(2918),
    [anon_sym_PERCENT] = ACTIONS(2918),
    [anon_sym_AMP_AMP] = ACTIONS(2918),
    [anon_sym_TILDE] = ACTIONS(2920),
    [aux_sym_prefix_op_token1] = ACTIONS(2918),
    [aux_sym_infix_op_token1] = ACTIONS(2920),
    [aux_sym_infix_op_token2] = ACTIONS(2918),
    [anon_sym_PIPE_PIPE] = ACTIONS(2918),
    [anon_sym_BANG_EQ] = ACTIONS(2918),
    [anon_sym_COLON_EQ] = ACTIONS(2920),
    [anon_sym_DOLLAR] = ACTIONS(2918),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2918),
    [sym_int] = ACTIONS(2918),
    [sym_xint] = ACTIONS(2920),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2920),
    [anon_sym_POUNDendif] = ACTIONS(2920),
    [anon_sym_POUNDelse] = ACTIONS(2920),
    [sym__newline] = ACTIONS(2920),
  },
  [1833] = {
    [sym_block_comment] = STATE(1833),
    [sym_compiler_directive_decl] = STATE(1833),
    [sym_fsi_directive_decl] = STATE(1833),
    [sym_preproc_line] = STATE(1833),
    [aux_sym_sequential_expression_repeat1] = STATE(1833),
    [sym_identifier] = ACTIONS(2895),
    [anon_sym_EQ] = ACTIONS(2897),
    [anon_sym_COLON] = ACTIONS(2895),
    [anon_sym_return] = ACTIONS(2895),
    [anon_sym_do] = ACTIONS(2895),
    [anon_sym_let] = ACTIONS(2895),
    [anon_sym_let_BANG] = ACTIONS(2897),
    [anon_sym_LPAREN] = ACTIONS(2895),
    [anon_sym_COMMA] = ACTIONS(2897),
    [anon_sym_null] = ACTIONS(2895),
    [anon_sym_QMARK] = ACTIONS(2895),
    [anon_sym_COLON_QMARK] = ACTIONS(2895),
    [anon_sym_COLON_COLON] = ACTIONS(2897),
    [anon_sym_AMP] = ACTIONS(2895),
    [anon_sym_LBRACK] = ACTIONS(2895),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2897),
    [anon_sym_LBRACE] = ACTIONS(2895),
    [anon_sym_LT_AT] = ACTIONS(2895),
    [anon_sym_LT_AT_AT] = ACTIONS(2895),
    [anon_sym_DOT] = ACTIONS(2895),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2897),
    [anon_sym_new] = ACTIONS(2895),
    [anon_sym_return_BANG] = ACTIONS(2897),
    [anon_sym_yield] = ACTIONS(2895),
    [anon_sym_yield_BANG] = ACTIONS(2897),
    [anon_sym_lazy] = ACTIONS(2895),
    [anon_sym_assert] = ACTIONS(2895),
    [anon_sym_upcast] = ACTIONS(2895),
    [anon_sym_downcast] = ACTIONS(2895),
    [anon_sym_COLON_GT] = ACTIONS(2897),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2897),
    [anon_sym_for] = ACTIONS(2895),
    [anon_sym_while] = ACTIONS(2895),
    [anon_sym_if] = ACTIONS(2895),
    [anon_sym_fun] = ACTIONS(2895),
    [anon_sym_try] = ACTIONS(2895),
    [anon_sym_match] = ACTIONS(2895),
    [anon_sym_match_BANG] = ACTIONS(2897),
    [anon_sym_function] = ACTIONS(2895),
    [anon_sym_LT_DASH] = ACTIONS(2895),
    [anon_sym_DOT_LBRACK] = ACTIONS(2897),
    [anon_sym_LT] = ACTIONS(2897),
    [anon_sym_use] = ACTIONS(2895),
    [anon_sym_use_BANG] = ACTIONS(2897),
    [anon_sym_do_BANG] = ACTIONS(2897),
    [anon_sym_begin] = ACTIONS(2895),
    [anon_sym_LPAREN2] = ACTIONS(2895),
    [anon_sym_or] = ACTIONS(2895),
    [aux_sym_char_token1] = ACTIONS(2897),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2895),
    [anon_sym_DQUOTE] = ACTIONS(2895),
    [anon_sym_AT_DQUOTE] = ACTIONS(2897),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2897),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2897),
    [sym_bool] = ACTIONS(2895),
    [sym_unit] = ACTIONS(2897),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2895),
    [sym_op_identifier] = ACTIONS(2895),
    [anon_sym_PLUS] = ACTIONS(2895),
    [anon_sym_DASH] = ACTIONS(2895),
    [anon_sym_PLUS_DOT] = ACTIONS(2895),
    [anon_sym_DASH_DOT] = ACTIONS(2895),
    [anon_sym_PERCENT] = ACTIONS(2895),
    [anon_sym_AMP_AMP] = ACTIONS(2895),
    [anon_sym_TILDE] = ACTIONS(2897),
    [aux_sym_prefix_op_token1] = ACTIONS(2895),
    [aux_sym_infix_op_token1] = ACTIONS(2897),
    [aux_sym_infix_op_token2] = ACTIONS(2895),
    [anon_sym_PIPE_PIPE] = ACTIONS(2895),
    [anon_sym_BANG_EQ] = ACTIONS(2895),
    [anon_sym_COLON_EQ] = ACTIONS(2897),
    [anon_sym_DOLLAR] = ACTIONS(2895),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2895),
    [sym_int] = ACTIONS(2895),
    [sym_xint] = ACTIONS(2897),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2897),
    [anon_sym_POUNDendif] = ACTIONS(2897),
    [sym__newline] = ACTIONS(4070),
  },
  [1834] = {
    [sym_attributes] = STATE(2636),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(3546),
    [sym__pattern] = STATE(1522),
    [sym_optional_pattern] = STATE(3546),
    [sym_type_check_pattern] = STATE(3546),
    [sym_attribute_pattern] = STATE(3546),
    [sym_paren_pattern] = STATE(3546),
    [sym_as_pattern] = STATE(3546),
    [sym_cons_pattern] = STATE(3546),
    [sym_disjunct_pattern] = STATE(3546),
    [sym_conjunct_pattern] = STATE(3546),
    [sym_typed_pattern] = STATE(3546),
    [sym_list_pattern] = STATE(3546),
    [sym_array_pattern] = STATE(3546),
    [sym_record_pattern] = STATE(3546),
    [sym_named_field_pattern] = STATE(3546),
    [sym_identifier_pattern] = STATE(3546),
    [sym_long_identifier_or_op] = STATE(1834),
    [sym_char] = STATE(3509),
    [sym_format_string] = STATE(3517),
    [sym__string_literal] = STATE(3517),
    [sym_string] = STATE(3509),
    [sym_verbatim_string] = STATE(3509),
    [sym_bytearray] = STATE(3509),
    [sym_verbatim_bytearray] = STATE(3509),
    [sym_format_triple_quoted_string] = STATE(3519),
    [sym_triple_quoted_string] = STATE(3509),
    [sym_const] = STATE(3546),
    [sym_long_identifier] = STATE(3320),
    [sym_active_pattern] = STATE(3488),
    [sym__identifier_or_op] = STATE(3410),
    [sym_sbyte] = STATE(3509),
    [sym_byte] = STATE(3509),
    [sym_int16] = STATE(3509),
    [sym_uint16] = STATE(3509),
    [sym_int32] = STATE(3509),
    [sym_uint32] = STATE(3509),
    [sym_nativeint] = STATE(3509),
    [sym_unativeint] = STATE(3509),
    [sym_int64] = STATE(3509),
    [sym_uint64] = STATE(3509),
    [sym_ieee32] = STATE(3509),
    [sym_ieee64] = STATE(3509),
    [sym_bignum] = STATE(3509),
    [sym_decimal] = STATE(3509),
    [sym_float] = STATE(3291),
    [sym_block_comment] = STATE(1834),
    [sym_compiler_directive_decl] = STATE(1834),
    [sym_fsi_directive_decl] = STATE(1834),
    [sym_preproc_line] = STATE(1834),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(3960),
    [anon_sym_EQ] = ACTIONS(3964),
    [anon_sym_LBRACK_LT] = ACTIONS(3964),
    [anon_sym_COLON] = ACTIONS(3960),
    [anon_sym_as] = ACTIONS(3960),
    [anon_sym_LPAREN] = ACTIONS(3960),
    [anon_sym_RPAREN] = ACTIONS(3964),
    [anon_sym_COMMA] = ACTIONS(3964),
    [anon_sym_null] = ACTIONS(3960),
    [anon_sym__] = ACTIONS(3960),
    [anon_sym_QMARK] = ACTIONS(3964),
    [anon_sym_COLON_QMARK] = ACTIONS(3964),
    [anon_sym_COLON_COLON] = ACTIONS(3964),
    [anon_sym_PIPE] = ACTIONS(3964),
    [anon_sym_AMP] = ACTIONS(3964),
    [anon_sym_LBRACK] = ACTIONS(3960),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3964),
    [anon_sym_LBRACE] = ACTIONS(3964),
    [anon_sym_LT2] = ACTIONS(3964),
    [aux_sym_char_token1] = ACTIONS(3964),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3960),
    [anon_sym_DQUOTE] = ACTIONS(3960),
    [anon_sym_AT_DQUOTE] = ACTIONS(3964),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3964),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3964),
    [sym_bool] = ACTIONS(3960),
    [sym_unit] = ACTIONS(3964),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3960),
    [sym_op_identifier] = ACTIONS(3964),
    [sym_int] = ACTIONS(3960),
    [sym_xint] = ACTIONS(3964),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [1835] = {
    [sym_block_comment] = STATE(1835),
    [sym_compiler_directive_decl] = STATE(1835),
    [sym_fsi_directive_decl] = STATE(1835),
    [sym_preproc_line] = STATE(1835),
    [sym_identifier] = ACTIONS(2922),
    [anon_sym_EQ] = ACTIONS(2924),
    [anon_sym_COLON] = ACTIONS(2922),
    [anon_sym_return] = ACTIONS(2922),
    [anon_sym_do] = ACTIONS(2922),
    [anon_sym_let] = ACTIONS(2922),
    [anon_sym_let_BANG] = ACTIONS(2924),
    [anon_sym_LPAREN] = ACTIONS(2922),
    [anon_sym_COMMA] = ACTIONS(2924),
    [anon_sym_null] = ACTIONS(2922),
    [anon_sym_QMARK] = ACTIONS(2922),
    [anon_sym_COLON_QMARK] = ACTIONS(2922),
    [anon_sym_COLON_COLON] = ACTIONS(2924),
    [anon_sym_AMP] = ACTIONS(2922),
    [anon_sym_LBRACK] = ACTIONS(2922),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2924),
    [anon_sym_LBRACE] = ACTIONS(2922),
    [anon_sym_LT_AT] = ACTIONS(2922),
    [anon_sym_LT_AT_AT] = ACTIONS(2922),
    [anon_sym_DOT] = ACTIONS(2922),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2924),
    [anon_sym_new] = ACTIONS(2922),
    [anon_sym_return_BANG] = ACTIONS(2924),
    [anon_sym_yield] = ACTIONS(2922),
    [anon_sym_yield_BANG] = ACTIONS(2924),
    [anon_sym_lazy] = ACTIONS(2922),
    [anon_sym_assert] = ACTIONS(2922),
    [anon_sym_upcast] = ACTIONS(2922),
    [anon_sym_downcast] = ACTIONS(2922),
    [anon_sym_COLON_GT] = ACTIONS(2924),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2924),
    [anon_sym_for] = ACTIONS(2922),
    [anon_sym_while] = ACTIONS(2922),
    [anon_sym_if] = ACTIONS(2922),
    [anon_sym_fun] = ACTIONS(2922),
    [anon_sym_try] = ACTIONS(2922),
    [anon_sym_match] = ACTIONS(2922),
    [anon_sym_match_BANG] = ACTIONS(2924),
    [anon_sym_function] = ACTIONS(2922),
    [anon_sym_LT_DASH] = ACTIONS(2922),
    [anon_sym_DOT_LBRACK] = ACTIONS(2924),
    [anon_sym_LT] = ACTIONS(2924),
    [anon_sym_use] = ACTIONS(2922),
    [anon_sym_use_BANG] = ACTIONS(2924),
    [anon_sym_do_BANG] = ACTIONS(2924),
    [anon_sym_begin] = ACTIONS(2922),
    [anon_sym_LPAREN2] = ACTIONS(2922),
    [anon_sym_or] = ACTIONS(2922),
    [aux_sym_char_token1] = ACTIONS(2924),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2922),
    [anon_sym_DQUOTE] = ACTIONS(2922),
    [anon_sym_AT_DQUOTE] = ACTIONS(2924),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2924),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2924),
    [sym_bool] = ACTIONS(2922),
    [sym_unit] = ACTIONS(2924),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2922),
    [sym_op_identifier] = ACTIONS(2922),
    [anon_sym_PLUS] = ACTIONS(2922),
    [anon_sym_DASH] = ACTIONS(2922),
    [anon_sym_PLUS_DOT] = ACTIONS(2922),
    [anon_sym_DASH_DOT] = ACTIONS(2922),
    [anon_sym_PERCENT] = ACTIONS(2922),
    [anon_sym_AMP_AMP] = ACTIONS(2922),
    [anon_sym_TILDE] = ACTIONS(2924),
    [aux_sym_prefix_op_token1] = ACTIONS(2922),
    [aux_sym_infix_op_token1] = ACTIONS(2924),
    [aux_sym_infix_op_token2] = ACTIONS(2922),
    [anon_sym_PIPE_PIPE] = ACTIONS(2922),
    [anon_sym_BANG_EQ] = ACTIONS(2922),
    [anon_sym_COLON_EQ] = ACTIONS(2924),
    [anon_sym_DOLLAR] = ACTIONS(2922),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2922),
    [sym_int] = ACTIONS(2922),
    [sym_xint] = ACTIONS(2924),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2924),
    [anon_sym_POUNDendif] = ACTIONS(2924),
    [anon_sym_POUNDelse] = ACTIONS(2924),
    [sym__newline] = ACTIONS(2924),
  },
  [1836] = {
    [sym_attributes] = STATE(2674),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(5431),
    [sym__pattern] = STATE(5303),
    [sym_optional_pattern] = STATE(5431),
    [sym_type_check_pattern] = STATE(5431),
    [sym_attribute_pattern] = STATE(5431),
    [sym_paren_pattern] = STATE(5431),
    [sym_as_pattern] = STATE(5431),
    [sym_cons_pattern] = STATE(5431),
    [sym_disjunct_pattern] = STATE(5431),
    [sym_conjunct_pattern] = STATE(5431),
    [sym_typed_pattern] = STATE(5431),
    [sym_list_pattern] = STATE(5431),
    [sym_array_pattern] = STATE(5431),
    [sym_record_pattern] = STATE(5431),
    [sym_named_field_pattern] = STATE(5431),
    [sym_identifier_pattern] = STATE(5431),
    [sym_long_identifier_or_op] = STATE(2273),
    [sym_char] = STATE(5475),
    [sym_format_string] = STATE(5423),
    [sym__string_literal] = STATE(5423),
    [sym_string] = STATE(5475),
    [sym_verbatim_string] = STATE(5475),
    [sym_bytearray] = STATE(5475),
    [sym_verbatim_bytearray] = STATE(5475),
    [sym_format_triple_quoted_string] = STATE(5477),
    [sym_triple_quoted_string] = STATE(5475),
    [sym_const] = STATE(5431),
    [sym_long_identifier] = STATE(3437),
    [sym_active_pattern] = STATE(3653),
    [sym__identifier_or_op] = STATE(3660),
    [sym_sbyte] = STATE(5475),
    [sym_byte] = STATE(5475),
    [sym_int16] = STATE(5475),
    [sym_uint16] = STATE(5475),
    [sym_int32] = STATE(5475),
    [sym_uint32] = STATE(5475),
    [sym_nativeint] = STATE(5475),
    [sym_unativeint] = STATE(5475),
    [sym_int64] = STATE(5475),
    [sym_uint64] = STATE(5475),
    [sym_ieee32] = STATE(5475),
    [sym_ieee64] = STATE(5475),
    [sym_bignum] = STATE(5475),
    [sym_decimal] = STATE(5475),
    [sym_float] = STATE(4953),
    [sym_block_comment] = STATE(1836),
    [sym_compiler_directive_decl] = STATE(1836),
    [sym_fsi_directive_decl] = STATE(1836),
    [sym_preproc_line] = STATE(1836),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [aux_sym_repeat_pattern_repeat1] = STATE(3555),
    [sym_identifier] = ACTIONS(4073),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_COLON] = ACTIONS(3716),
    [anon_sym_as] = ACTIONS(4075),
    [anon_sym_LPAREN] = ACTIONS(4077),
    [anon_sym_COMMA] = ACTIONS(4079),
    [anon_sym_null] = ACTIONS(4081),
    [anon_sym__] = ACTIONS(4083),
    [anon_sym_QMARK] = ACTIONS(4085),
    [anon_sym_COLON_QMARK] = ACTIONS(4087),
    [anon_sym_COLON_COLON] = ACTIONS(4089),
    [anon_sym_PIPE] = ACTIONS(4091),
    [anon_sym_AMP] = ACTIONS(4093),
    [anon_sym_LBRACK] = ACTIONS(4095),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4097),
    [anon_sym_LBRACE] = ACTIONS(4099),
    [aux_sym_char_token1] = ACTIONS(4101),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4103),
    [anon_sym_DQUOTE] = ACTIONS(4105),
    [anon_sym_AT_DQUOTE] = ACTIONS(4107),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4109),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4111),
    [sym_bool] = ACTIONS(4113),
    [sym_unit] = ACTIONS(4115),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4117),
    [sym_op_identifier] = ACTIONS(4119),
    [sym_int] = ACTIONS(4121),
    [sym_xint] = ACTIONS(4123),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [sym__newline] = ACTIONS(3714),
    [sym__dedent] = ACTIONS(3714),
  },
  [1837] = {
    [sym_block_comment] = STATE(1837),
    [sym_compiler_directive_decl] = STATE(1837),
    [sym_fsi_directive_decl] = STATE(1837),
    [sym_preproc_line] = STATE(1837),
    [sym_identifier] = ACTIONS(2926),
    [anon_sym_EQ] = ACTIONS(2928),
    [anon_sym_COLON] = ACTIONS(2926),
    [anon_sym_return] = ACTIONS(2926),
    [anon_sym_do] = ACTIONS(2926),
    [anon_sym_let] = ACTIONS(2926),
    [anon_sym_let_BANG] = ACTIONS(2928),
    [anon_sym_LPAREN] = ACTIONS(2926),
    [anon_sym_COMMA] = ACTIONS(2928),
    [anon_sym_null] = ACTIONS(2926),
    [anon_sym_QMARK] = ACTIONS(2926),
    [anon_sym_COLON_QMARK] = ACTIONS(2926),
    [anon_sym_COLON_COLON] = ACTIONS(2928),
    [anon_sym_AMP] = ACTIONS(2926),
    [anon_sym_LBRACK] = ACTIONS(2926),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2928),
    [anon_sym_LBRACE] = ACTIONS(2926),
    [anon_sym_LT_AT] = ACTIONS(2926),
    [anon_sym_LT_AT_AT] = ACTIONS(2926),
    [anon_sym_DOT] = ACTIONS(2926),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2928),
    [anon_sym_new] = ACTIONS(2926),
    [anon_sym_return_BANG] = ACTIONS(2928),
    [anon_sym_yield] = ACTIONS(2926),
    [anon_sym_yield_BANG] = ACTIONS(2928),
    [anon_sym_lazy] = ACTIONS(2926),
    [anon_sym_assert] = ACTIONS(2926),
    [anon_sym_upcast] = ACTIONS(2926),
    [anon_sym_downcast] = ACTIONS(2926),
    [anon_sym_COLON_GT] = ACTIONS(2928),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2928),
    [anon_sym_for] = ACTIONS(2926),
    [anon_sym_while] = ACTIONS(2926),
    [anon_sym_if] = ACTIONS(2926),
    [anon_sym_fun] = ACTIONS(2926),
    [anon_sym_try] = ACTIONS(2926),
    [anon_sym_match] = ACTIONS(2926),
    [anon_sym_match_BANG] = ACTIONS(2928),
    [anon_sym_function] = ACTIONS(2926),
    [anon_sym_LT_DASH] = ACTIONS(2926),
    [anon_sym_DOT_LBRACK] = ACTIONS(2928),
    [anon_sym_LT] = ACTIONS(2928),
    [anon_sym_use] = ACTIONS(2926),
    [anon_sym_use_BANG] = ACTIONS(2928),
    [anon_sym_do_BANG] = ACTIONS(2928),
    [anon_sym_begin] = ACTIONS(2926),
    [anon_sym_LPAREN2] = ACTIONS(2926),
    [anon_sym_or] = ACTIONS(2926),
    [aux_sym_char_token1] = ACTIONS(2928),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2926),
    [anon_sym_DQUOTE] = ACTIONS(2926),
    [anon_sym_AT_DQUOTE] = ACTIONS(2928),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2928),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2928),
    [sym_bool] = ACTIONS(2926),
    [sym_unit] = ACTIONS(2928),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2926),
    [sym_op_identifier] = ACTIONS(2926),
    [anon_sym_PLUS] = ACTIONS(2926),
    [anon_sym_DASH] = ACTIONS(2926),
    [anon_sym_PLUS_DOT] = ACTIONS(2926),
    [anon_sym_DASH_DOT] = ACTIONS(2926),
    [anon_sym_PERCENT] = ACTIONS(2926),
    [anon_sym_AMP_AMP] = ACTIONS(2926),
    [anon_sym_TILDE] = ACTIONS(2928),
    [aux_sym_prefix_op_token1] = ACTIONS(2926),
    [aux_sym_infix_op_token1] = ACTIONS(2928),
    [aux_sym_infix_op_token2] = ACTIONS(2926),
    [anon_sym_PIPE_PIPE] = ACTIONS(2926),
    [anon_sym_BANG_EQ] = ACTIONS(2926),
    [anon_sym_COLON_EQ] = ACTIONS(2928),
    [anon_sym_DOLLAR] = ACTIONS(2926),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2926),
    [sym_int] = ACTIONS(2926),
    [sym_xint] = ACTIONS(2928),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2928),
    [anon_sym_POUNDendif] = ACTIONS(2928),
    [anon_sym_POUNDelse] = ACTIONS(2928),
    [sym__newline] = ACTIONS(2928),
  },
  [1838] = {
    [sym_block_comment] = STATE(1838),
    [sym_compiler_directive_decl] = STATE(1838),
    [sym_fsi_directive_decl] = STATE(1838),
    [sym_preproc_line] = STATE(1838),
    [sym_identifier] = ACTIONS(2938),
    [anon_sym_EQ] = ACTIONS(2940),
    [anon_sym_COLON] = ACTIONS(2938),
    [anon_sym_return] = ACTIONS(2938),
    [anon_sym_do] = ACTIONS(2938),
    [anon_sym_let] = ACTIONS(2938),
    [anon_sym_let_BANG] = ACTIONS(2940),
    [anon_sym_LPAREN] = ACTIONS(2938),
    [anon_sym_COMMA] = ACTIONS(2940),
    [anon_sym_null] = ACTIONS(2938),
    [anon_sym_QMARK] = ACTIONS(2938),
    [anon_sym_COLON_QMARK] = ACTIONS(2938),
    [anon_sym_COLON_COLON] = ACTIONS(2940),
    [anon_sym_AMP] = ACTIONS(2938),
    [anon_sym_LBRACK] = ACTIONS(2938),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2940),
    [anon_sym_LBRACE] = ACTIONS(2938),
    [anon_sym_LT_AT] = ACTIONS(2938),
    [anon_sym_LT_AT_AT] = ACTIONS(2938),
    [anon_sym_DOT] = ACTIONS(2938),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2940),
    [anon_sym_new] = ACTIONS(2938),
    [anon_sym_return_BANG] = ACTIONS(2940),
    [anon_sym_yield] = ACTIONS(2938),
    [anon_sym_yield_BANG] = ACTIONS(2940),
    [anon_sym_lazy] = ACTIONS(2938),
    [anon_sym_assert] = ACTIONS(2938),
    [anon_sym_upcast] = ACTIONS(2938),
    [anon_sym_downcast] = ACTIONS(2938),
    [anon_sym_COLON_GT] = ACTIONS(2940),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2940),
    [anon_sym_for] = ACTIONS(2938),
    [anon_sym_while] = ACTIONS(2938),
    [anon_sym_if] = ACTIONS(2938),
    [anon_sym_fun] = ACTIONS(2938),
    [anon_sym_try] = ACTIONS(2938),
    [anon_sym_match] = ACTIONS(2938),
    [anon_sym_match_BANG] = ACTIONS(2940),
    [anon_sym_function] = ACTIONS(2938),
    [anon_sym_LT_DASH] = ACTIONS(2938),
    [anon_sym_DOT_LBRACK] = ACTIONS(2940),
    [anon_sym_LT] = ACTIONS(2940),
    [anon_sym_use] = ACTIONS(2938),
    [anon_sym_use_BANG] = ACTIONS(2940),
    [anon_sym_do_BANG] = ACTIONS(2940),
    [anon_sym_begin] = ACTIONS(2938),
    [anon_sym_LPAREN2] = ACTIONS(2938),
    [anon_sym_or] = ACTIONS(2938),
    [aux_sym_char_token1] = ACTIONS(2940),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2938),
    [anon_sym_DQUOTE] = ACTIONS(2938),
    [anon_sym_AT_DQUOTE] = ACTIONS(2940),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2940),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2940),
    [sym_bool] = ACTIONS(2938),
    [sym_unit] = ACTIONS(2940),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2938),
    [sym_op_identifier] = ACTIONS(2938),
    [anon_sym_PLUS] = ACTIONS(2938),
    [anon_sym_DASH] = ACTIONS(2938),
    [anon_sym_PLUS_DOT] = ACTIONS(2938),
    [anon_sym_DASH_DOT] = ACTIONS(2938),
    [anon_sym_PERCENT] = ACTIONS(2938),
    [anon_sym_AMP_AMP] = ACTIONS(2938),
    [anon_sym_TILDE] = ACTIONS(2940),
    [aux_sym_prefix_op_token1] = ACTIONS(2938),
    [aux_sym_infix_op_token1] = ACTIONS(2940),
    [aux_sym_infix_op_token2] = ACTIONS(2938),
    [anon_sym_PIPE_PIPE] = ACTIONS(2938),
    [anon_sym_BANG_EQ] = ACTIONS(2938),
    [anon_sym_COLON_EQ] = ACTIONS(2940),
    [anon_sym_DOLLAR] = ACTIONS(2938),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2938),
    [sym_int] = ACTIONS(2938),
    [sym_xint] = ACTIONS(2940),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2940),
    [anon_sym_POUNDendif] = ACTIONS(2940),
    [anon_sym_POUNDelse] = ACTIONS(2940),
    [sym__newline] = ACTIONS(2940),
  },
  [1839] = {
    [sym_block_comment] = STATE(1839),
    [sym_compiler_directive_decl] = STATE(1839),
    [sym_fsi_directive_decl] = STATE(1839),
    [sym_preproc_line] = STATE(1839),
    [sym_identifier] = ACTIONS(2946),
    [anon_sym_EQ] = ACTIONS(2948),
    [anon_sym_COLON] = ACTIONS(2946),
    [anon_sym_return] = ACTIONS(2946),
    [anon_sym_do] = ACTIONS(2946),
    [anon_sym_let] = ACTIONS(2946),
    [anon_sym_let_BANG] = ACTIONS(2948),
    [anon_sym_LPAREN] = ACTIONS(2946),
    [anon_sym_COMMA] = ACTIONS(2948),
    [anon_sym_null] = ACTIONS(2946),
    [anon_sym_QMARK] = ACTIONS(2946),
    [anon_sym_COLON_QMARK] = ACTIONS(2946),
    [anon_sym_COLON_COLON] = ACTIONS(2948),
    [anon_sym_AMP] = ACTIONS(2946),
    [anon_sym_LBRACK] = ACTIONS(2946),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2948),
    [anon_sym_LBRACE] = ACTIONS(2946),
    [anon_sym_LT_AT] = ACTIONS(2946),
    [anon_sym_LT_AT_AT] = ACTIONS(2946),
    [anon_sym_DOT] = ACTIONS(2946),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2948),
    [anon_sym_new] = ACTIONS(2946),
    [anon_sym_return_BANG] = ACTIONS(2948),
    [anon_sym_yield] = ACTIONS(2946),
    [anon_sym_yield_BANG] = ACTIONS(2948),
    [anon_sym_lazy] = ACTIONS(2946),
    [anon_sym_assert] = ACTIONS(2946),
    [anon_sym_upcast] = ACTIONS(2946),
    [anon_sym_downcast] = ACTIONS(2946),
    [anon_sym_COLON_GT] = ACTIONS(2948),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2948),
    [anon_sym_for] = ACTIONS(2946),
    [anon_sym_while] = ACTIONS(2946),
    [anon_sym_if] = ACTIONS(2946),
    [anon_sym_fun] = ACTIONS(2946),
    [anon_sym_try] = ACTIONS(2946),
    [anon_sym_match] = ACTIONS(2946),
    [anon_sym_match_BANG] = ACTIONS(2948),
    [anon_sym_function] = ACTIONS(2946),
    [anon_sym_LT_DASH] = ACTIONS(2946),
    [anon_sym_DOT_LBRACK] = ACTIONS(2948),
    [anon_sym_LT] = ACTIONS(2948),
    [anon_sym_use] = ACTIONS(2946),
    [anon_sym_use_BANG] = ACTIONS(2948),
    [anon_sym_do_BANG] = ACTIONS(2948),
    [anon_sym_begin] = ACTIONS(2946),
    [anon_sym_LPAREN2] = ACTIONS(2946),
    [anon_sym_or] = ACTIONS(2946),
    [aux_sym_char_token1] = ACTIONS(2948),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2946),
    [anon_sym_DQUOTE] = ACTIONS(2946),
    [anon_sym_AT_DQUOTE] = ACTIONS(2948),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2948),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2948),
    [sym_bool] = ACTIONS(2946),
    [sym_unit] = ACTIONS(2948),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2946),
    [sym_op_identifier] = ACTIONS(2946),
    [anon_sym_PLUS] = ACTIONS(2946),
    [anon_sym_DASH] = ACTIONS(2946),
    [anon_sym_PLUS_DOT] = ACTIONS(2946),
    [anon_sym_DASH_DOT] = ACTIONS(2946),
    [anon_sym_PERCENT] = ACTIONS(2946),
    [anon_sym_AMP_AMP] = ACTIONS(2946),
    [anon_sym_TILDE] = ACTIONS(2948),
    [aux_sym_prefix_op_token1] = ACTIONS(2946),
    [aux_sym_infix_op_token1] = ACTIONS(2948),
    [aux_sym_infix_op_token2] = ACTIONS(2946),
    [anon_sym_PIPE_PIPE] = ACTIONS(2946),
    [anon_sym_BANG_EQ] = ACTIONS(2946),
    [anon_sym_COLON_EQ] = ACTIONS(2948),
    [anon_sym_DOLLAR] = ACTIONS(2946),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2946),
    [sym_int] = ACTIONS(2946),
    [sym_xint] = ACTIONS(2948),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2948),
    [anon_sym_POUNDendif] = ACTIONS(2948),
    [anon_sym_POUNDelse] = ACTIONS(2948),
    [sym__newline] = ACTIONS(2948),
  },
  [1840] = {
    [sym_block_comment] = STATE(1840),
    [sym_compiler_directive_decl] = STATE(1840),
    [sym_fsi_directive_decl] = STATE(1840),
    [sym_preproc_line] = STATE(1840),
    [sym_identifier] = ACTIONS(2950),
    [anon_sym_EQ] = ACTIONS(2952),
    [anon_sym_COLON] = ACTIONS(2950),
    [anon_sym_return] = ACTIONS(2950),
    [anon_sym_do] = ACTIONS(2950),
    [anon_sym_let] = ACTIONS(2950),
    [anon_sym_let_BANG] = ACTIONS(2952),
    [anon_sym_LPAREN] = ACTIONS(2950),
    [anon_sym_COMMA] = ACTIONS(2952),
    [anon_sym_null] = ACTIONS(2950),
    [anon_sym_QMARK] = ACTIONS(2950),
    [anon_sym_COLON_QMARK] = ACTIONS(2950),
    [anon_sym_COLON_COLON] = ACTIONS(2952),
    [anon_sym_AMP] = ACTIONS(2950),
    [anon_sym_LBRACK] = ACTIONS(2950),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2952),
    [anon_sym_LBRACE] = ACTIONS(2950),
    [anon_sym_LT_AT] = ACTIONS(2950),
    [anon_sym_LT_AT_AT] = ACTIONS(2950),
    [anon_sym_DOT] = ACTIONS(2950),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2952),
    [anon_sym_new] = ACTIONS(2950),
    [anon_sym_return_BANG] = ACTIONS(2952),
    [anon_sym_yield] = ACTIONS(2950),
    [anon_sym_yield_BANG] = ACTIONS(2952),
    [anon_sym_lazy] = ACTIONS(2950),
    [anon_sym_assert] = ACTIONS(2950),
    [anon_sym_upcast] = ACTIONS(2950),
    [anon_sym_downcast] = ACTIONS(2950),
    [anon_sym_COLON_GT] = ACTIONS(2952),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2952),
    [anon_sym_for] = ACTIONS(2950),
    [anon_sym_while] = ACTIONS(2950),
    [anon_sym_if] = ACTIONS(2950),
    [anon_sym_fun] = ACTIONS(2950),
    [anon_sym_try] = ACTIONS(2950),
    [anon_sym_match] = ACTIONS(2950),
    [anon_sym_match_BANG] = ACTIONS(2952),
    [anon_sym_function] = ACTIONS(2950),
    [anon_sym_LT_DASH] = ACTIONS(2950),
    [anon_sym_DOT_LBRACK] = ACTIONS(2952),
    [anon_sym_LT] = ACTIONS(2952),
    [anon_sym_use] = ACTIONS(2950),
    [anon_sym_use_BANG] = ACTIONS(2952),
    [anon_sym_do_BANG] = ACTIONS(2952),
    [anon_sym_begin] = ACTIONS(2950),
    [anon_sym_LPAREN2] = ACTIONS(2950),
    [anon_sym_or] = ACTIONS(2950),
    [aux_sym_char_token1] = ACTIONS(2952),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2950),
    [anon_sym_DQUOTE] = ACTIONS(2950),
    [anon_sym_AT_DQUOTE] = ACTIONS(2952),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2952),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2952),
    [sym_bool] = ACTIONS(2950),
    [sym_unit] = ACTIONS(2952),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2950),
    [sym_op_identifier] = ACTIONS(2950),
    [anon_sym_PLUS] = ACTIONS(2950),
    [anon_sym_DASH] = ACTIONS(2950),
    [anon_sym_PLUS_DOT] = ACTIONS(2950),
    [anon_sym_DASH_DOT] = ACTIONS(2950),
    [anon_sym_PERCENT] = ACTIONS(2950),
    [anon_sym_AMP_AMP] = ACTIONS(2950),
    [anon_sym_TILDE] = ACTIONS(2952),
    [aux_sym_prefix_op_token1] = ACTIONS(2950),
    [aux_sym_infix_op_token1] = ACTIONS(2952),
    [aux_sym_infix_op_token2] = ACTIONS(2950),
    [anon_sym_PIPE_PIPE] = ACTIONS(2950),
    [anon_sym_BANG_EQ] = ACTIONS(2950),
    [anon_sym_COLON_EQ] = ACTIONS(2952),
    [anon_sym_DOLLAR] = ACTIONS(2950),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2950),
    [sym_int] = ACTIONS(2950),
    [sym_xint] = ACTIONS(2952),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2952),
    [anon_sym_POUNDendif] = ACTIONS(2952),
    [anon_sym_POUNDelse] = ACTIONS(2952),
    [sym__newline] = ACTIONS(2952),
  },
  [1841] = {
    [sym_block_comment] = STATE(1841),
    [sym_compiler_directive_decl] = STATE(1841),
    [sym_fsi_directive_decl] = STATE(1841),
    [sym_preproc_line] = STATE(1841),
    [sym_identifier] = ACTIONS(2958),
    [anon_sym_EQ] = ACTIONS(2960),
    [anon_sym_COLON] = ACTIONS(2958),
    [anon_sym_return] = ACTIONS(2958),
    [anon_sym_do] = ACTIONS(2958),
    [anon_sym_let] = ACTIONS(2958),
    [anon_sym_let_BANG] = ACTIONS(2960),
    [anon_sym_LPAREN] = ACTIONS(2958),
    [anon_sym_COMMA] = ACTIONS(2960),
    [anon_sym_null] = ACTIONS(2958),
    [anon_sym_QMARK] = ACTIONS(2958),
    [anon_sym_COLON_QMARK] = ACTIONS(2958),
    [anon_sym_COLON_COLON] = ACTIONS(2960),
    [anon_sym_AMP] = ACTIONS(2958),
    [anon_sym_LBRACK] = ACTIONS(2958),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2960),
    [anon_sym_LBRACE] = ACTIONS(2958),
    [anon_sym_LT_AT] = ACTIONS(2958),
    [anon_sym_LT_AT_AT] = ACTIONS(2958),
    [anon_sym_DOT] = ACTIONS(2958),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2960),
    [anon_sym_new] = ACTIONS(2958),
    [anon_sym_return_BANG] = ACTIONS(2960),
    [anon_sym_yield] = ACTIONS(2958),
    [anon_sym_yield_BANG] = ACTIONS(2960),
    [anon_sym_lazy] = ACTIONS(2958),
    [anon_sym_assert] = ACTIONS(2958),
    [anon_sym_upcast] = ACTIONS(2958),
    [anon_sym_downcast] = ACTIONS(2958),
    [anon_sym_COLON_GT] = ACTIONS(2960),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2960),
    [anon_sym_for] = ACTIONS(2958),
    [anon_sym_while] = ACTIONS(2958),
    [anon_sym_if] = ACTIONS(2958),
    [anon_sym_fun] = ACTIONS(2958),
    [anon_sym_try] = ACTIONS(2958),
    [anon_sym_match] = ACTIONS(2958),
    [anon_sym_match_BANG] = ACTIONS(2960),
    [anon_sym_function] = ACTIONS(2958),
    [anon_sym_LT_DASH] = ACTIONS(2958),
    [anon_sym_DOT_LBRACK] = ACTIONS(2960),
    [anon_sym_LT] = ACTIONS(2960),
    [anon_sym_use] = ACTIONS(2958),
    [anon_sym_use_BANG] = ACTIONS(2960),
    [anon_sym_do_BANG] = ACTIONS(2960),
    [anon_sym_begin] = ACTIONS(2958),
    [anon_sym_LPAREN2] = ACTIONS(2958),
    [anon_sym_or] = ACTIONS(2958),
    [aux_sym_char_token1] = ACTIONS(2960),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2958),
    [anon_sym_DQUOTE] = ACTIONS(2958),
    [anon_sym_AT_DQUOTE] = ACTIONS(2960),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2960),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2960),
    [sym_bool] = ACTIONS(2958),
    [sym_unit] = ACTIONS(2960),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2958),
    [sym_op_identifier] = ACTIONS(2958),
    [anon_sym_PLUS] = ACTIONS(2958),
    [anon_sym_DASH] = ACTIONS(2958),
    [anon_sym_PLUS_DOT] = ACTIONS(2958),
    [anon_sym_DASH_DOT] = ACTIONS(2958),
    [anon_sym_PERCENT] = ACTIONS(2958),
    [anon_sym_AMP_AMP] = ACTIONS(2958),
    [anon_sym_TILDE] = ACTIONS(2960),
    [aux_sym_prefix_op_token1] = ACTIONS(2958),
    [aux_sym_infix_op_token1] = ACTIONS(2960),
    [aux_sym_infix_op_token2] = ACTIONS(2958),
    [anon_sym_PIPE_PIPE] = ACTIONS(2958),
    [anon_sym_BANG_EQ] = ACTIONS(2958),
    [anon_sym_COLON_EQ] = ACTIONS(2960),
    [anon_sym_DOLLAR] = ACTIONS(2958),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2958),
    [sym_int] = ACTIONS(2958),
    [sym_xint] = ACTIONS(2960),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2960),
    [anon_sym_POUNDendif] = ACTIONS(2960),
    [anon_sym_POUNDelse] = ACTIONS(2960),
    [sym__newline] = ACTIONS(2960),
  },
  [1842] = {
    [sym_block_comment] = STATE(1842),
    [sym_compiler_directive_decl] = STATE(1842),
    [sym_fsi_directive_decl] = STATE(1842),
    [sym_preproc_line] = STATE(1842),
    [sym_identifier] = ACTIONS(2962),
    [anon_sym_EQ] = ACTIONS(2964),
    [anon_sym_COLON] = ACTIONS(2962),
    [anon_sym_return] = ACTIONS(2962),
    [anon_sym_do] = ACTIONS(2962),
    [anon_sym_let] = ACTIONS(2962),
    [anon_sym_let_BANG] = ACTIONS(2964),
    [anon_sym_LPAREN] = ACTIONS(2962),
    [anon_sym_COMMA] = ACTIONS(2964),
    [anon_sym_null] = ACTIONS(2962),
    [anon_sym_QMARK] = ACTIONS(2962),
    [anon_sym_COLON_QMARK] = ACTIONS(2962),
    [anon_sym_COLON_COLON] = ACTIONS(2964),
    [anon_sym_AMP] = ACTIONS(2962),
    [anon_sym_LBRACK] = ACTIONS(2962),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2964),
    [anon_sym_LBRACE] = ACTIONS(2962),
    [anon_sym_LT_AT] = ACTIONS(2962),
    [anon_sym_LT_AT_AT] = ACTIONS(2962),
    [anon_sym_DOT] = ACTIONS(2962),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2964),
    [anon_sym_new] = ACTIONS(2962),
    [anon_sym_return_BANG] = ACTIONS(2964),
    [anon_sym_yield] = ACTIONS(2962),
    [anon_sym_yield_BANG] = ACTIONS(2964),
    [anon_sym_lazy] = ACTIONS(2962),
    [anon_sym_assert] = ACTIONS(2962),
    [anon_sym_upcast] = ACTIONS(2962),
    [anon_sym_downcast] = ACTIONS(2962),
    [anon_sym_COLON_GT] = ACTIONS(2964),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2964),
    [anon_sym_for] = ACTIONS(2962),
    [anon_sym_while] = ACTIONS(2962),
    [anon_sym_if] = ACTIONS(2962),
    [anon_sym_fun] = ACTIONS(2962),
    [anon_sym_try] = ACTIONS(2962),
    [anon_sym_match] = ACTIONS(2962),
    [anon_sym_match_BANG] = ACTIONS(2964),
    [anon_sym_function] = ACTIONS(2962),
    [anon_sym_LT_DASH] = ACTIONS(2962),
    [anon_sym_DOT_LBRACK] = ACTIONS(2964),
    [anon_sym_LT] = ACTIONS(2964),
    [anon_sym_use] = ACTIONS(2962),
    [anon_sym_use_BANG] = ACTIONS(2964),
    [anon_sym_do_BANG] = ACTIONS(2964),
    [anon_sym_begin] = ACTIONS(2962),
    [anon_sym_LPAREN2] = ACTIONS(2962),
    [anon_sym_or] = ACTIONS(2962),
    [aux_sym_char_token1] = ACTIONS(2964),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2962),
    [anon_sym_DQUOTE] = ACTIONS(2962),
    [anon_sym_AT_DQUOTE] = ACTIONS(2964),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2964),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2964),
    [sym_bool] = ACTIONS(2962),
    [sym_unit] = ACTIONS(2964),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2962),
    [sym_op_identifier] = ACTIONS(2962),
    [anon_sym_PLUS] = ACTIONS(2962),
    [anon_sym_DASH] = ACTIONS(2962),
    [anon_sym_PLUS_DOT] = ACTIONS(2962),
    [anon_sym_DASH_DOT] = ACTIONS(2962),
    [anon_sym_PERCENT] = ACTIONS(2962),
    [anon_sym_AMP_AMP] = ACTIONS(2962),
    [anon_sym_TILDE] = ACTIONS(2964),
    [aux_sym_prefix_op_token1] = ACTIONS(2962),
    [aux_sym_infix_op_token1] = ACTIONS(2964),
    [aux_sym_infix_op_token2] = ACTIONS(2962),
    [anon_sym_PIPE_PIPE] = ACTIONS(2962),
    [anon_sym_BANG_EQ] = ACTIONS(2962),
    [anon_sym_COLON_EQ] = ACTIONS(2964),
    [anon_sym_DOLLAR] = ACTIONS(2962),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2962),
    [sym_int] = ACTIONS(2962),
    [sym_xint] = ACTIONS(2964),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2964),
    [anon_sym_POUNDendif] = ACTIONS(2964),
    [anon_sym_POUNDelse] = ACTIONS(2964),
    [sym__newline] = ACTIONS(2964),
  },
  [1843] = {
    [sym_block_comment] = STATE(1843),
    [sym_compiler_directive_decl] = STATE(1843),
    [sym_fsi_directive_decl] = STATE(1843),
    [sym_preproc_line] = STATE(1843),
    [sym_identifier] = ACTIONS(2966),
    [anon_sym_EQ] = ACTIONS(2968),
    [anon_sym_COLON] = ACTIONS(2966),
    [anon_sym_return] = ACTIONS(2966),
    [anon_sym_do] = ACTIONS(2966),
    [anon_sym_let] = ACTIONS(2966),
    [anon_sym_let_BANG] = ACTIONS(2968),
    [anon_sym_LPAREN] = ACTIONS(2966),
    [anon_sym_COMMA] = ACTIONS(2968),
    [anon_sym_null] = ACTIONS(2966),
    [anon_sym_QMARK] = ACTIONS(2966),
    [anon_sym_COLON_QMARK] = ACTIONS(2966),
    [anon_sym_COLON_COLON] = ACTIONS(2968),
    [anon_sym_AMP] = ACTIONS(2966),
    [anon_sym_LBRACK] = ACTIONS(2966),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2968),
    [anon_sym_LBRACE] = ACTIONS(2966),
    [anon_sym_LT_AT] = ACTIONS(2966),
    [anon_sym_LT_AT_AT] = ACTIONS(2966),
    [anon_sym_DOT] = ACTIONS(2966),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2968),
    [anon_sym_new] = ACTIONS(2966),
    [anon_sym_return_BANG] = ACTIONS(2968),
    [anon_sym_yield] = ACTIONS(2966),
    [anon_sym_yield_BANG] = ACTIONS(2968),
    [anon_sym_lazy] = ACTIONS(2966),
    [anon_sym_assert] = ACTIONS(2966),
    [anon_sym_upcast] = ACTIONS(2966),
    [anon_sym_downcast] = ACTIONS(2966),
    [anon_sym_COLON_GT] = ACTIONS(2968),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2968),
    [anon_sym_for] = ACTIONS(2966),
    [anon_sym_while] = ACTIONS(2966),
    [anon_sym_if] = ACTIONS(2966),
    [anon_sym_fun] = ACTIONS(2966),
    [anon_sym_try] = ACTIONS(2966),
    [anon_sym_match] = ACTIONS(2966),
    [anon_sym_match_BANG] = ACTIONS(2968),
    [anon_sym_function] = ACTIONS(2966),
    [anon_sym_LT_DASH] = ACTIONS(2966),
    [anon_sym_DOT_LBRACK] = ACTIONS(2968),
    [anon_sym_LT] = ACTIONS(2968),
    [anon_sym_use] = ACTIONS(2966),
    [anon_sym_use_BANG] = ACTIONS(2968),
    [anon_sym_do_BANG] = ACTIONS(2968),
    [anon_sym_begin] = ACTIONS(2966),
    [anon_sym_LPAREN2] = ACTIONS(2966),
    [anon_sym_or] = ACTIONS(2966),
    [aux_sym_char_token1] = ACTIONS(2968),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2966),
    [anon_sym_DQUOTE] = ACTIONS(2966),
    [anon_sym_AT_DQUOTE] = ACTIONS(2968),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2968),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2968),
    [sym_bool] = ACTIONS(2966),
    [sym_unit] = ACTIONS(2968),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2966),
    [sym_op_identifier] = ACTIONS(2966),
    [anon_sym_PLUS] = ACTIONS(2966),
    [anon_sym_DASH] = ACTIONS(2966),
    [anon_sym_PLUS_DOT] = ACTIONS(2966),
    [anon_sym_DASH_DOT] = ACTIONS(2966),
    [anon_sym_PERCENT] = ACTIONS(2966),
    [anon_sym_AMP_AMP] = ACTIONS(2966),
    [anon_sym_TILDE] = ACTIONS(2968),
    [aux_sym_prefix_op_token1] = ACTIONS(2966),
    [aux_sym_infix_op_token1] = ACTIONS(2968),
    [aux_sym_infix_op_token2] = ACTIONS(2966),
    [anon_sym_PIPE_PIPE] = ACTIONS(2966),
    [anon_sym_BANG_EQ] = ACTIONS(2966),
    [anon_sym_COLON_EQ] = ACTIONS(2968),
    [anon_sym_DOLLAR] = ACTIONS(2966),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2966),
    [sym_int] = ACTIONS(2966),
    [sym_xint] = ACTIONS(2968),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2968),
    [anon_sym_POUNDendif] = ACTIONS(2968),
    [anon_sym_POUNDelse] = ACTIONS(2968),
    [sym__newline] = ACTIONS(2968),
  },
  [1844] = {
    [sym_block_comment] = STATE(1844),
    [sym_compiler_directive_decl] = STATE(1844),
    [sym_fsi_directive_decl] = STATE(1844),
    [sym_preproc_line] = STATE(1844),
    [sym_identifier] = ACTIONS(2881),
    [anon_sym_EQ] = ACTIONS(2789),
    [anon_sym_COLON] = ACTIONS(2881),
    [anon_sym_return] = ACTIONS(2881),
    [anon_sym_do] = ACTIONS(2881),
    [anon_sym_let] = ACTIONS(2881),
    [anon_sym_let_BANG] = ACTIONS(2789),
    [anon_sym_as] = ACTIONS(2881),
    [anon_sym_LPAREN] = ACTIONS(2881),
    [anon_sym_COMMA] = ACTIONS(2789),
    [anon_sym_null] = ACTIONS(2881),
    [anon_sym_QMARK] = ACTIONS(2881),
    [anon_sym_COLON_QMARK] = ACTIONS(2881),
    [anon_sym_COLON_COLON] = ACTIONS(2789),
    [anon_sym_AMP] = ACTIONS(2881),
    [anon_sym_LBRACK] = ACTIONS(2881),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2789),
    [anon_sym_LBRACE] = ACTIONS(2881),
    [anon_sym_LT_AT] = ACTIONS(2881),
    [anon_sym_LT_AT_AT] = ACTIONS(2881),
    [anon_sym_DOT] = ACTIONS(2881),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2789),
    [anon_sym_new] = ACTIONS(2881),
    [anon_sym_with] = ACTIONS(2881),
    [anon_sym_return_BANG] = ACTIONS(2789),
    [anon_sym_yield] = ACTIONS(2881),
    [anon_sym_yield_BANG] = ACTIONS(2789),
    [anon_sym_lazy] = ACTIONS(2881),
    [anon_sym_assert] = ACTIONS(2881),
    [anon_sym_upcast] = ACTIONS(2881),
    [anon_sym_downcast] = ACTIONS(2881),
    [anon_sym_COLON_GT] = ACTIONS(2789),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2789),
    [anon_sym_for] = ACTIONS(2881),
    [anon_sym_while] = ACTIONS(2881),
    [anon_sym_if] = ACTIONS(2881),
    [anon_sym_fun] = ACTIONS(2881),
    [anon_sym_try] = ACTIONS(2881),
    [anon_sym_match] = ACTIONS(2881),
    [anon_sym_match_BANG] = ACTIONS(2789),
    [anon_sym_function] = ACTIONS(2881),
    [anon_sym_LT_DASH] = ACTIONS(2881),
    [anon_sym_DOT_LBRACK] = ACTIONS(2789),
    [anon_sym_LT] = ACTIONS(2789),
    [anon_sym_use] = ACTIONS(2881),
    [anon_sym_use_BANG] = ACTIONS(2789),
    [anon_sym_do_BANG] = ACTIONS(2789),
    [anon_sym_begin] = ACTIONS(2881),
    [anon_sym_LPAREN2] = ACTIONS(2881),
    [anon_sym_or] = ACTIONS(2881),
    [aux_sym_char_token1] = ACTIONS(2789),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2881),
    [anon_sym_DQUOTE] = ACTIONS(2881),
    [anon_sym_AT_DQUOTE] = ACTIONS(2789),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2789),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2789),
    [sym_bool] = ACTIONS(2881),
    [sym_unit] = ACTIONS(2789),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2881),
    [sym_op_identifier] = ACTIONS(2881),
    [anon_sym_PLUS] = ACTIONS(2881),
    [anon_sym_DASH] = ACTIONS(2881),
    [anon_sym_PLUS_DOT] = ACTIONS(2881),
    [anon_sym_DASH_DOT] = ACTIONS(2881),
    [anon_sym_PERCENT] = ACTIONS(2881),
    [anon_sym_AMP_AMP] = ACTIONS(2881),
    [anon_sym_TILDE] = ACTIONS(2789),
    [aux_sym_prefix_op_token1] = ACTIONS(2881),
    [aux_sym_infix_op_token1] = ACTIONS(2789),
    [aux_sym_infix_op_token2] = ACTIONS(2881),
    [anon_sym_PIPE_PIPE] = ACTIONS(2881),
    [anon_sym_BANG_EQ] = ACTIONS(2881),
    [anon_sym_COLON_EQ] = ACTIONS(2789),
    [anon_sym_DOLLAR] = ACTIONS(2881),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2881),
    [sym_int] = ACTIONS(2881),
    [sym_xint] = ACTIONS(2789),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2789),
    [sym__newline] = ACTIONS(2789),
  },
  [1845] = {
    [sym_block_comment] = STATE(1845),
    [sym_compiler_directive_decl] = STATE(1845),
    [sym_fsi_directive_decl] = STATE(1845),
    [sym_preproc_line] = STATE(1845),
    [sym_identifier] = ACTIONS(2902),
    [anon_sym_EQ] = ACTIONS(2904),
    [anon_sym_COLON] = ACTIONS(2902),
    [anon_sym_return] = ACTIONS(2902),
    [anon_sym_do] = ACTIONS(2902),
    [anon_sym_let] = ACTIONS(2902),
    [anon_sym_let_BANG] = ACTIONS(2904),
    [anon_sym_as] = ACTIONS(2902),
    [anon_sym_LPAREN] = ACTIONS(2902),
    [anon_sym_COMMA] = ACTIONS(2904),
    [anon_sym_null] = ACTIONS(2902),
    [anon_sym_QMARK] = ACTIONS(2902),
    [anon_sym_COLON_QMARK] = ACTIONS(2902),
    [anon_sym_COLON_COLON] = ACTIONS(2904),
    [anon_sym_AMP] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2902),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2902),
    [anon_sym_LT_AT] = ACTIONS(2902),
    [anon_sym_LT_AT_AT] = ACTIONS(2902),
    [anon_sym_DOT] = ACTIONS(2902),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2904),
    [anon_sym_new] = ACTIONS(2902),
    [anon_sym_with] = ACTIONS(2902),
    [anon_sym_return_BANG] = ACTIONS(2904),
    [anon_sym_yield] = ACTIONS(2902),
    [anon_sym_yield_BANG] = ACTIONS(2904),
    [anon_sym_lazy] = ACTIONS(2902),
    [anon_sym_assert] = ACTIONS(2902),
    [anon_sym_upcast] = ACTIONS(2902),
    [anon_sym_downcast] = ACTIONS(2902),
    [anon_sym_COLON_GT] = ACTIONS(2904),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2904),
    [anon_sym_for] = ACTIONS(2902),
    [anon_sym_while] = ACTIONS(2902),
    [anon_sym_if] = ACTIONS(2902),
    [anon_sym_fun] = ACTIONS(2902),
    [anon_sym_try] = ACTIONS(2902),
    [anon_sym_match] = ACTIONS(2902),
    [anon_sym_match_BANG] = ACTIONS(2904),
    [anon_sym_function] = ACTIONS(2902),
    [anon_sym_LT_DASH] = ACTIONS(2902),
    [anon_sym_DOT_LBRACK] = ACTIONS(2904),
    [anon_sym_LT] = ACTIONS(2904),
    [anon_sym_use] = ACTIONS(2902),
    [anon_sym_use_BANG] = ACTIONS(2904),
    [anon_sym_do_BANG] = ACTIONS(2904),
    [anon_sym_begin] = ACTIONS(2902),
    [anon_sym_LPAREN2] = ACTIONS(2902),
    [anon_sym_or] = ACTIONS(2902),
    [aux_sym_char_token1] = ACTIONS(2904),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2902),
    [anon_sym_DQUOTE] = ACTIONS(2902),
    [anon_sym_AT_DQUOTE] = ACTIONS(2904),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2904),
    [sym_bool] = ACTIONS(2902),
    [sym_unit] = ACTIONS(2904),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2902),
    [sym_op_identifier] = ACTIONS(2902),
    [anon_sym_PLUS] = ACTIONS(2902),
    [anon_sym_DASH] = ACTIONS(2902),
    [anon_sym_PLUS_DOT] = ACTIONS(2902),
    [anon_sym_DASH_DOT] = ACTIONS(2902),
    [anon_sym_PERCENT] = ACTIONS(2902),
    [anon_sym_AMP_AMP] = ACTIONS(2902),
    [anon_sym_TILDE] = ACTIONS(2904),
    [aux_sym_prefix_op_token1] = ACTIONS(2902),
    [aux_sym_infix_op_token1] = ACTIONS(2904),
    [aux_sym_infix_op_token2] = ACTIONS(2902),
    [anon_sym_PIPE_PIPE] = ACTIONS(2902),
    [anon_sym_BANG_EQ] = ACTIONS(2902),
    [anon_sym_COLON_EQ] = ACTIONS(2904),
    [anon_sym_DOLLAR] = ACTIONS(2902),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2902),
    [sym_int] = ACTIONS(2902),
    [sym_xint] = ACTIONS(2904),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2904),
    [sym__newline] = ACTIONS(2904),
  },
  [1846] = {
    [sym_block_comment] = STATE(1846),
    [sym_compiler_directive_decl] = STATE(1846),
    [sym_fsi_directive_decl] = STATE(1846),
    [sym_preproc_line] = STATE(1846),
    [sym_identifier] = ACTIONS(2906),
    [anon_sym_EQ] = ACTIONS(2908),
    [anon_sym_COLON] = ACTIONS(2906),
    [anon_sym_return] = ACTIONS(2906),
    [anon_sym_do] = ACTIONS(2906),
    [anon_sym_let] = ACTIONS(2906),
    [anon_sym_let_BANG] = ACTIONS(2908),
    [anon_sym_as] = ACTIONS(2906),
    [anon_sym_LPAREN] = ACTIONS(2906),
    [anon_sym_COMMA] = ACTIONS(2908),
    [anon_sym_null] = ACTIONS(2906),
    [anon_sym_QMARK] = ACTIONS(2906),
    [anon_sym_COLON_QMARK] = ACTIONS(2906),
    [anon_sym_COLON_COLON] = ACTIONS(2908),
    [anon_sym_AMP] = ACTIONS(2906),
    [anon_sym_LBRACK] = ACTIONS(2906),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2908),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_LT_AT] = ACTIONS(2906),
    [anon_sym_LT_AT_AT] = ACTIONS(2906),
    [anon_sym_DOT] = ACTIONS(2906),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2908),
    [anon_sym_new] = ACTIONS(2906),
    [anon_sym_with] = ACTIONS(2906),
    [anon_sym_return_BANG] = ACTIONS(2908),
    [anon_sym_yield] = ACTIONS(2906),
    [anon_sym_yield_BANG] = ACTIONS(2908),
    [anon_sym_lazy] = ACTIONS(2906),
    [anon_sym_assert] = ACTIONS(2906),
    [anon_sym_upcast] = ACTIONS(2906),
    [anon_sym_downcast] = ACTIONS(2906),
    [anon_sym_COLON_GT] = ACTIONS(2908),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2908),
    [anon_sym_for] = ACTIONS(2906),
    [anon_sym_while] = ACTIONS(2906),
    [anon_sym_if] = ACTIONS(2906),
    [anon_sym_fun] = ACTIONS(2906),
    [anon_sym_try] = ACTIONS(2906),
    [anon_sym_match] = ACTIONS(2906),
    [anon_sym_match_BANG] = ACTIONS(2908),
    [anon_sym_function] = ACTIONS(2906),
    [anon_sym_LT_DASH] = ACTIONS(2906),
    [anon_sym_DOT_LBRACK] = ACTIONS(2908),
    [anon_sym_LT] = ACTIONS(2908),
    [anon_sym_use] = ACTIONS(2906),
    [anon_sym_use_BANG] = ACTIONS(2908),
    [anon_sym_do_BANG] = ACTIONS(2908),
    [anon_sym_begin] = ACTIONS(2906),
    [anon_sym_LPAREN2] = ACTIONS(2906),
    [anon_sym_or] = ACTIONS(2906),
    [aux_sym_char_token1] = ACTIONS(2908),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2906),
    [anon_sym_DQUOTE] = ACTIONS(2906),
    [anon_sym_AT_DQUOTE] = ACTIONS(2908),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2908),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2908),
    [sym_bool] = ACTIONS(2906),
    [sym_unit] = ACTIONS(2908),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2906),
    [sym_op_identifier] = ACTIONS(2906),
    [anon_sym_PLUS] = ACTIONS(2906),
    [anon_sym_DASH] = ACTIONS(2906),
    [anon_sym_PLUS_DOT] = ACTIONS(2906),
    [anon_sym_DASH_DOT] = ACTIONS(2906),
    [anon_sym_PERCENT] = ACTIONS(2906),
    [anon_sym_AMP_AMP] = ACTIONS(2906),
    [anon_sym_TILDE] = ACTIONS(2908),
    [aux_sym_prefix_op_token1] = ACTIONS(2906),
    [aux_sym_infix_op_token1] = ACTIONS(2908),
    [aux_sym_infix_op_token2] = ACTIONS(2906),
    [anon_sym_PIPE_PIPE] = ACTIONS(2906),
    [anon_sym_BANG_EQ] = ACTIONS(2906),
    [anon_sym_COLON_EQ] = ACTIONS(2908),
    [anon_sym_DOLLAR] = ACTIONS(2906),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2906),
    [sym_int] = ACTIONS(2906),
    [sym_xint] = ACTIONS(2908),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2908),
    [sym__newline] = ACTIONS(2908),
  },
  [1847] = {
    [sym_block_comment] = STATE(1847),
    [sym_compiler_directive_decl] = STATE(1847),
    [sym_fsi_directive_decl] = STATE(1847),
    [sym_preproc_line] = STATE(1847),
    [sym_identifier] = ACTIONS(2974),
    [anon_sym_EQ] = ACTIONS(2976),
    [anon_sym_COLON] = ACTIONS(2974),
    [anon_sym_return] = ACTIONS(2974),
    [anon_sym_do] = ACTIONS(2974),
    [anon_sym_let] = ACTIONS(2974),
    [anon_sym_let_BANG] = ACTIONS(2976),
    [anon_sym_LPAREN] = ACTIONS(2974),
    [anon_sym_COMMA] = ACTIONS(2976),
    [anon_sym_null] = ACTIONS(2974),
    [anon_sym_QMARK] = ACTIONS(2974),
    [anon_sym_COLON_QMARK] = ACTIONS(2974),
    [anon_sym_COLON_COLON] = ACTIONS(2976),
    [anon_sym_AMP] = ACTIONS(2974),
    [anon_sym_LBRACK] = ACTIONS(2974),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2976),
    [anon_sym_LBRACE] = ACTIONS(2974),
    [anon_sym_LT_AT] = ACTIONS(2974),
    [anon_sym_LT_AT_AT] = ACTIONS(2974),
    [anon_sym_DOT] = ACTIONS(2974),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2976),
    [anon_sym_new] = ACTIONS(2974),
    [anon_sym_return_BANG] = ACTIONS(2976),
    [anon_sym_yield] = ACTIONS(2974),
    [anon_sym_yield_BANG] = ACTIONS(2976),
    [anon_sym_lazy] = ACTIONS(2974),
    [anon_sym_assert] = ACTIONS(2974),
    [anon_sym_upcast] = ACTIONS(2974),
    [anon_sym_downcast] = ACTIONS(2974),
    [anon_sym_COLON_GT] = ACTIONS(2976),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2976),
    [anon_sym_for] = ACTIONS(2974),
    [anon_sym_while] = ACTIONS(2974),
    [anon_sym_if] = ACTIONS(2974),
    [anon_sym_fun] = ACTIONS(2974),
    [anon_sym_try] = ACTIONS(2974),
    [anon_sym_match] = ACTIONS(2974),
    [anon_sym_match_BANG] = ACTIONS(2976),
    [anon_sym_function] = ACTIONS(2974),
    [anon_sym_LT_DASH] = ACTIONS(2974),
    [anon_sym_DOT_LBRACK] = ACTIONS(2976),
    [anon_sym_LT] = ACTIONS(2976),
    [anon_sym_use] = ACTIONS(2974),
    [anon_sym_use_BANG] = ACTIONS(2976),
    [anon_sym_do_BANG] = ACTIONS(2976),
    [anon_sym_begin] = ACTIONS(2974),
    [anon_sym_LPAREN2] = ACTIONS(2974),
    [anon_sym_or] = ACTIONS(2974),
    [aux_sym_char_token1] = ACTIONS(2976),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2974),
    [anon_sym_DQUOTE] = ACTIONS(2974),
    [anon_sym_AT_DQUOTE] = ACTIONS(2976),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2976),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2976),
    [sym_bool] = ACTIONS(2974),
    [sym_unit] = ACTIONS(2976),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2974),
    [sym_op_identifier] = ACTIONS(2974),
    [anon_sym_PLUS] = ACTIONS(2974),
    [anon_sym_DASH] = ACTIONS(2974),
    [anon_sym_PLUS_DOT] = ACTIONS(2974),
    [anon_sym_DASH_DOT] = ACTIONS(2974),
    [anon_sym_PERCENT] = ACTIONS(2974),
    [anon_sym_AMP_AMP] = ACTIONS(2974),
    [anon_sym_TILDE] = ACTIONS(2976),
    [aux_sym_prefix_op_token1] = ACTIONS(2974),
    [aux_sym_infix_op_token1] = ACTIONS(2976),
    [aux_sym_infix_op_token2] = ACTIONS(2974),
    [anon_sym_PIPE_PIPE] = ACTIONS(2974),
    [anon_sym_BANG_EQ] = ACTIONS(2974),
    [anon_sym_COLON_EQ] = ACTIONS(2976),
    [anon_sym_DOLLAR] = ACTIONS(2974),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2974),
    [sym_int] = ACTIONS(2974),
    [sym_xint] = ACTIONS(2976),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2976),
    [anon_sym_POUNDendif] = ACTIONS(2976),
    [anon_sym_POUNDelse] = ACTIONS(2976),
    [sym__newline] = ACTIONS(2976),
  },
  [1848] = {
    [sym_block_comment] = STATE(1848),
    [sym_compiler_directive_decl] = STATE(1848),
    [sym_fsi_directive_decl] = STATE(1848),
    [sym_preproc_line] = STATE(1848),
    [sym_identifier] = ACTIONS(2934),
    [anon_sym_EQ] = ACTIONS(2936),
    [anon_sym_COLON] = ACTIONS(2934),
    [anon_sym_return] = ACTIONS(2934),
    [anon_sym_do] = ACTIONS(2934),
    [anon_sym_let] = ACTIONS(2934),
    [anon_sym_let_BANG] = ACTIONS(2936),
    [anon_sym_as] = ACTIONS(2934),
    [anon_sym_LPAREN] = ACTIONS(2934),
    [anon_sym_COMMA] = ACTIONS(2936),
    [anon_sym_null] = ACTIONS(2934),
    [anon_sym_QMARK] = ACTIONS(2934),
    [anon_sym_COLON_QMARK] = ACTIONS(2934),
    [anon_sym_COLON_COLON] = ACTIONS(2936),
    [anon_sym_AMP] = ACTIONS(2934),
    [anon_sym_LBRACK] = ACTIONS(2934),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2936),
    [anon_sym_LBRACE] = ACTIONS(2934),
    [anon_sym_LT_AT] = ACTIONS(2934),
    [anon_sym_LT_AT_AT] = ACTIONS(2934),
    [anon_sym_DOT] = ACTIONS(2934),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2936),
    [anon_sym_new] = ACTIONS(2934),
    [anon_sym_with] = ACTIONS(2934),
    [anon_sym_return_BANG] = ACTIONS(2936),
    [anon_sym_yield] = ACTIONS(2934),
    [anon_sym_yield_BANG] = ACTIONS(2936),
    [anon_sym_lazy] = ACTIONS(2934),
    [anon_sym_assert] = ACTIONS(2934),
    [anon_sym_upcast] = ACTIONS(2934),
    [anon_sym_downcast] = ACTIONS(2934),
    [anon_sym_COLON_GT] = ACTIONS(2936),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2936),
    [anon_sym_for] = ACTIONS(2934),
    [anon_sym_while] = ACTIONS(2934),
    [anon_sym_if] = ACTIONS(2934),
    [anon_sym_fun] = ACTIONS(2934),
    [anon_sym_try] = ACTIONS(2934),
    [anon_sym_match] = ACTIONS(2934),
    [anon_sym_match_BANG] = ACTIONS(2936),
    [anon_sym_function] = ACTIONS(2934),
    [anon_sym_LT_DASH] = ACTIONS(2934),
    [anon_sym_DOT_LBRACK] = ACTIONS(2936),
    [anon_sym_LT] = ACTIONS(2936),
    [anon_sym_use] = ACTIONS(2934),
    [anon_sym_use_BANG] = ACTIONS(2936),
    [anon_sym_do_BANG] = ACTIONS(2936),
    [anon_sym_begin] = ACTIONS(2934),
    [anon_sym_LPAREN2] = ACTIONS(2934),
    [anon_sym_or] = ACTIONS(2934),
    [aux_sym_char_token1] = ACTIONS(2936),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2934),
    [anon_sym_DQUOTE] = ACTIONS(2934),
    [anon_sym_AT_DQUOTE] = ACTIONS(2936),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2936),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2936),
    [sym_bool] = ACTIONS(2934),
    [sym_unit] = ACTIONS(2936),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2934),
    [sym_op_identifier] = ACTIONS(2934),
    [anon_sym_PLUS] = ACTIONS(2934),
    [anon_sym_DASH] = ACTIONS(2934),
    [anon_sym_PLUS_DOT] = ACTIONS(2934),
    [anon_sym_DASH_DOT] = ACTIONS(2934),
    [anon_sym_PERCENT] = ACTIONS(2934),
    [anon_sym_AMP_AMP] = ACTIONS(2934),
    [anon_sym_TILDE] = ACTIONS(2936),
    [aux_sym_prefix_op_token1] = ACTIONS(2934),
    [aux_sym_infix_op_token1] = ACTIONS(2936),
    [aux_sym_infix_op_token2] = ACTIONS(2934),
    [anon_sym_PIPE_PIPE] = ACTIONS(2934),
    [anon_sym_BANG_EQ] = ACTIONS(2934),
    [anon_sym_COLON_EQ] = ACTIONS(2936),
    [anon_sym_DOLLAR] = ACTIONS(2934),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2934),
    [sym_int] = ACTIONS(2934),
    [sym_xint] = ACTIONS(2936),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2936),
    [sym__newline] = ACTIONS(2936),
  },
  [1849] = {
    [sym_block_comment] = STATE(1849),
    [sym_compiler_directive_decl] = STATE(1849),
    [sym_fsi_directive_decl] = STATE(1849),
    [sym_preproc_line] = STATE(1849),
    [sym_identifier] = ACTIONS(2411),
    [anon_sym_EQ] = ACTIONS(2411),
    [anon_sym_COLON] = ACTIONS(2411),
    [anon_sym_return] = ACTIONS(2411),
    [anon_sym_do] = ACTIONS(2411),
    [anon_sym_let] = ACTIONS(2411),
    [anon_sym_let_BANG] = ACTIONS(2413),
    [anon_sym_LPAREN] = ACTIONS(2411),
    [anon_sym_COMMA] = ACTIONS(2413),
    [anon_sym_null] = ACTIONS(2411),
    [anon_sym_QMARK] = ACTIONS(2411),
    [anon_sym_COLON_QMARK] = ACTIONS(2411),
    [anon_sym_COLON_COLON] = ACTIONS(2413),
    [anon_sym_AMP] = ACTIONS(2411),
    [anon_sym_LBRACK] = ACTIONS(2411),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2413),
    [anon_sym_LBRACE] = ACTIONS(2411),
    [anon_sym_LT_AT] = ACTIONS(2411),
    [anon_sym_LT_AT_AT] = ACTIONS(2411),
    [anon_sym_DOT] = ACTIONS(2411),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2413),
    [anon_sym_new] = ACTIONS(2411),
    [anon_sym_with] = ACTIONS(2411),
    [anon_sym_return_BANG] = ACTIONS(2413),
    [anon_sym_yield] = ACTIONS(2411),
    [anon_sym_yield_BANG] = ACTIONS(2413),
    [anon_sym_lazy] = ACTIONS(2411),
    [anon_sym_assert] = ACTIONS(2411),
    [anon_sym_upcast] = ACTIONS(2411),
    [anon_sym_downcast] = ACTIONS(2411),
    [anon_sym_COLON_GT] = ACTIONS(2413),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2413),
    [anon_sym_for] = ACTIONS(2411),
    [anon_sym_while] = ACTIONS(2411),
    [anon_sym_if] = ACTIONS(2411),
    [anon_sym_fun] = ACTIONS(2411),
    [anon_sym_try] = ACTIONS(2411),
    [anon_sym_match] = ACTIONS(2411),
    [anon_sym_match_BANG] = ACTIONS(2413),
    [anon_sym_function] = ACTIONS(2411),
    [anon_sym_LT_DASH] = ACTIONS(2411),
    [anon_sym_DOT_LBRACK] = ACTIONS(2413),
    [anon_sym_LT] = ACTIONS(2413),
    [anon_sym_use] = ACTIONS(2411),
    [anon_sym_use_BANG] = ACTIONS(2413),
    [anon_sym_do_BANG] = ACTIONS(2413),
    [anon_sym_begin] = ACTIONS(2411),
    [anon_sym_LPAREN2] = ACTIONS(2411),
    [anon_sym_or] = ACTIONS(2411),
    [anon_sym_EQ2] = ACTIONS(2413),
    [aux_sym_char_token1] = ACTIONS(2413),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2411),
    [anon_sym_DQUOTE] = ACTIONS(2411),
    [anon_sym_AT_DQUOTE] = ACTIONS(2413),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2413),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2413),
    [sym_bool] = ACTIONS(2411),
    [sym_unit] = ACTIONS(2413),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2411),
    [sym_op_identifier] = ACTIONS(2411),
    [anon_sym_PLUS] = ACTIONS(2411),
    [anon_sym_DASH] = ACTIONS(2411),
    [anon_sym_PLUS_DOT] = ACTIONS(2411),
    [anon_sym_DASH_DOT] = ACTIONS(2411),
    [anon_sym_PERCENT] = ACTIONS(2411),
    [anon_sym_AMP_AMP] = ACTIONS(2411),
    [anon_sym_TILDE] = ACTIONS(2413),
    [aux_sym_prefix_op_token1] = ACTIONS(2411),
    [aux_sym_infix_op_token1] = ACTIONS(2413),
    [aux_sym_infix_op_token2] = ACTIONS(2411),
    [anon_sym_PIPE_PIPE] = ACTIONS(2411),
    [anon_sym_BANG_EQ] = ACTIONS(2411),
    [anon_sym_COLON_EQ] = ACTIONS(2413),
    [anon_sym_DOLLAR] = ACTIONS(2411),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2411),
    [sym_int] = ACTIONS(2411),
    [sym_xint] = ACTIONS(2413),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2413),
    [sym__newline] = ACTIONS(2413),
  },
  [1850] = {
    [sym_block_comment] = STATE(1850),
    [sym_compiler_directive_decl] = STATE(1850),
    [sym_fsi_directive_decl] = STATE(1850),
    [sym_preproc_line] = STATE(1850),
    [sym_identifier] = ACTIONS(2685),
    [anon_sym_EQ] = ACTIONS(2687),
    [anon_sym_COLON] = ACTIONS(2685),
    [anon_sym_return] = ACTIONS(2685),
    [anon_sym_do] = ACTIONS(2685),
    [anon_sym_let] = ACTIONS(2685),
    [anon_sym_let_BANG] = ACTIONS(2687),
    [anon_sym_LPAREN] = ACTIONS(2685),
    [anon_sym_COMMA] = ACTIONS(2687),
    [anon_sym_null] = ACTIONS(2685),
    [anon_sym_QMARK] = ACTIONS(2685),
    [anon_sym_COLON_QMARK] = ACTIONS(2685),
    [anon_sym_COLON_COLON] = ACTIONS(2687),
    [anon_sym_PIPE] = ACTIONS(2685),
    [anon_sym_AMP] = ACTIONS(2685),
    [anon_sym_LBRACK] = ACTIONS(2685),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2687),
    [anon_sym_LBRACE] = ACTIONS(2685),
    [anon_sym_LT_AT] = ACTIONS(2685),
    [anon_sym_LT_AT_AT] = ACTIONS(2685),
    [anon_sym_DOT] = ACTIONS(2685),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2687),
    [anon_sym_new] = ACTIONS(2685),
    [anon_sym_return_BANG] = ACTIONS(2687),
    [anon_sym_yield] = ACTIONS(2685),
    [anon_sym_yield_BANG] = ACTIONS(2687),
    [anon_sym_lazy] = ACTIONS(2685),
    [anon_sym_assert] = ACTIONS(2685),
    [anon_sym_upcast] = ACTIONS(2685),
    [anon_sym_downcast] = ACTIONS(2685),
    [anon_sym_COLON_GT] = ACTIONS(2687),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2687),
    [anon_sym_for] = ACTIONS(2685),
    [anon_sym_while] = ACTIONS(2685),
    [anon_sym_if] = ACTIONS(2685),
    [anon_sym_fun] = ACTIONS(2685),
    [anon_sym_try] = ACTIONS(2685),
    [anon_sym_match] = ACTIONS(2685),
    [anon_sym_match_BANG] = ACTIONS(2687),
    [anon_sym_function] = ACTIONS(2685),
    [anon_sym_LT_DASH] = ACTIONS(2685),
    [anon_sym_DOT_LBRACK] = ACTIONS(2687),
    [anon_sym_LT] = ACTIONS(2687),
    [anon_sym_use] = ACTIONS(2685),
    [anon_sym_use_BANG] = ACTIONS(2687),
    [anon_sym_do_BANG] = ACTIONS(2687),
    [anon_sym_DOT_DOT] = ACTIONS(2687),
    [anon_sym_begin] = ACTIONS(2685),
    [anon_sym_LPAREN2] = ACTIONS(2685),
    [anon_sym_or] = ACTIONS(2685),
    [aux_sym_char_token1] = ACTIONS(2687),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2685),
    [anon_sym_DQUOTE] = ACTIONS(2685),
    [anon_sym_AT_DQUOTE] = ACTIONS(2687),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2687),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2687),
    [sym_bool] = ACTIONS(2685),
    [sym_unit] = ACTIONS(2687),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2685),
    [sym_op_identifier] = ACTIONS(2685),
    [anon_sym_PLUS] = ACTIONS(2685),
    [anon_sym_DASH] = ACTIONS(2685),
    [anon_sym_PLUS_DOT] = ACTIONS(2685),
    [anon_sym_DASH_DOT] = ACTIONS(2685),
    [anon_sym_PERCENT] = ACTIONS(2685),
    [anon_sym_AMP_AMP] = ACTIONS(2685),
    [anon_sym_TILDE] = ACTIONS(2687),
    [aux_sym_prefix_op_token1] = ACTIONS(2685),
    [aux_sym_infix_op_token1] = ACTIONS(2687),
    [aux_sym_infix_op_token2] = ACTIONS(2685),
    [anon_sym_PIPE_PIPE] = ACTIONS(2685),
    [anon_sym_BANG_EQ] = ACTIONS(2685),
    [anon_sym_COLON_EQ] = ACTIONS(2687),
    [anon_sym_DOLLAR] = ACTIONS(2685),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2685),
    [sym_int] = ACTIONS(2685),
    [sym_xint] = ACTIONS(2687),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2687),
    [sym__newline] = ACTIONS(2687),
  },
  [1851] = {
    [sym_attributes] = STATE(2652),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(3588),
    [sym__pattern] = STATE(3431),
    [sym_optional_pattern] = STATE(3588),
    [sym_type_check_pattern] = STATE(3588),
    [sym_attribute_pattern] = STATE(3588),
    [sym_paren_pattern] = STATE(3588),
    [sym_as_pattern] = STATE(3588),
    [sym_cons_pattern] = STATE(3588),
    [sym_disjunct_pattern] = STATE(3588),
    [sym_conjunct_pattern] = STATE(3588),
    [sym_typed_pattern] = STATE(3588),
    [sym_list_pattern] = STATE(3588),
    [sym_array_pattern] = STATE(3588),
    [sym_record_pattern] = STATE(3588),
    [sym_named_field_pattern] = STATE(3588),
    [sym_identifier_pattern] = STATE(3588),
    [sym_long_identifier_or_op] = STATE(2401),
    [sym_char] = STATE(3658),
    [sym_format_string] = STATE(3670),
    [sym__string_literal] = STATE(3670),
    [sym_string] = STATE(3658),
    [sym_verbatim_string] = STATE(3658),
    [sym_bytearray] = STATE(3658),
    [sym_verbatim_bytearray] = STATE(3658),
    [sym_format_triple_quoted_string] = STATE(3673),
    [sym_triple_quoted_string] = STATE(3658),
    [sym_const] = STATE(3588),
    [sym_long_identifier] = STATE(3493),
    [sym_active_pattern] = STATE(3613),
    [sym__identifier_or_op] = STATE(3650),
    [sym_sbyte] = STATE(3658),
    [sym_byte] = STATE(3658),
    [sym_int16] = STATE(3658),
    [sym_uint16] = STATE(3658),
    [sym_int32] = STATE(3658),
    [sym_uint32] = STATE(3658),
    [sym_nativeint] = STATE(3658),
    [sym_unativeint] = STATE(3658),
    [sym_int64] = STATE(3658),
    [sym_uint64] = STATE(3658),
    [sym_ieee32] = STATE(3658),
    [sym_ieee64] = STATE(3658),
    [sym_bignum] = STATE(3658),
    [sym_decimal] = STATE(3658),
    [sym_float] = STATE(3376),
    [sym_block_comment] = STATE(1851),
    [sym_compiler_directive_decl] = STATE(1851),
    [sym_fsi_directive_decl] = STATE(1851),
    [sym_preproc_line] = STATE(1851),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [aux_sym_repeat_pattern_repeat1] = STATE(3452),
    [sym_identifier] = ACTIONS(3716),
    [anon_sym_LBRACK_LT] = ACTIONS(3714),
    [anon_sym_COLON] = ACTIONS(3716),
    [anon_sym_as] = ACTIONS(4125),
    [anon_sym_LPAREN] = ACTIONS(3716),
    [anon_sym_COMMA] = ACTIONS(4127),
    [anon_sym_null] = ACTIONS(3716),
    [anon_sym__] = ACTIONS(3716),
    [anon_sym_QMARK] = ACTIONS(3714),
    [anon_sym_COLON_QMARK] = ACTIONS(3714),
    [anon_sym_COLON_COLON] = ACTIONS(4129),
    [anon_sym_PIPE] = ACTIONS(4131),
    [anon_sym_AMP] = ACTIONS(4133),
    [anon_sym_LBRACK] = ACTIONS(3716),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3714),
    [anon_sym_LBRACE] = ACTIONS(3714),
    [anon_sym_DASH_GT] = ACTIONS(3714),
    [anon_sym_when] = ACTIONS(3716),
    [aux_sym_char_token1] = ACTIONS(3714),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3716),
    [anon_sym_DQUOTE] = ACTIONS(3716),
    [anon_sym_AT_DQUOTE] = ACTIONS(3714),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3714),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3714),
    [sym_bool] = ACTIONS(3716),
    [sym_unit] = ACTIONS(3714),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3716),
    [sym_op_identifier] = ACTIONS(3714),
    [sym_int] = ACTIONS(3716),
    [sym_xint] = ACTIONS(3714),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [1852] = {
    [sym_block_comment] = STATE(1852),
    [sym_compiler_directive_decl] = STATE(1852),
    [sym_fsi_directive_decl] = STATE(1852),
    [sym_preproc_line] = STATE(1852),
    [sym_identifier] = ACTIONS(3019),
    [anon_sym_EQ] = ACTIONS(3021),
    [anon_sym_COLON] = ACTIONS(3019),
    [anon_sym_return] = ACTIONS(3019),
    [anon_sym_do] = ACTIONS(3019),
    [anon_sym_let] = ACTIONS(3019),
    [anon_sym_let_BANG] = ACTIONS(3021),
    [anon_sym_LPAREN] = ACTIONS(3019),
    [anon_sym_COMMA] = ACTIONS(3021),
    [anon_sym_null] = ACTIONS(3019),
    [anon_sym_QMARK] = ACTIONS(3019),
    [anon_sym_COLON_QMARK] = ACTIONS(3019),
    [anon_sym_COLON_COLON] = ACTIONS(3021),
    [anon_sym_AMP] = ACTIONS(3019),
    [anon_sym_LBRACK] = ACTIONS(3019),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3021),
    [anon_sym_LBRACE] = ACTIONS(3019),
    [anon_sym_LT_AT] = ACTIONS(3019),
    [anon_sym_LT_AT_AT] = ACTIONS(3019),
    [anon_sym_DOT] = ACTIONS(3019),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3021),
    [anon_sym_new] = ACTIONS(3019),
    [anon_sym_return_BANG] = ACTIONS(3021),
    [anon_sym_yield] = ACTIONS(3019),
    [anon_sym_yield_BANG] = ACTIONS(3021),
    [anon_sym_lazy] = ACTIONS(3019),
    [anon_sym_assert] = ACTIONS(3019),
    [anon_sym_upcast] = ACTIONS(3019),
    [anon_sym_downcast] = ACTIONS(3019),
    [anon_sym_COLON_GT] = ACTIONS(3021),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3021),
    [anon_sym_for] = ACTIONS(3019),
    [anon_sym_while] = ACTIONS(3019),
    [anon_sym_if] = ACTIONS(3019),
    [anon_sym_fun] = ACTIONS(3019),
    [anon_sym_try] = ACTIONS(3019),
    [anon_sym_match] = ACTIONS(3019),
    [anon_sym_match_BANG] = ACTIONS(3021),
    [anon_sym_function] = ACTIONS(3019),
    [anon_sym_LT_DASH] = ACTIONS(3019),
    [anon_sym_DOT_LBRACK] = ACTIONS(3021),
    [anon_sym_LT] = ACTIONS(3021),
    [anon_sym_use] = ACTIONS(3019),
    [anon_sym_use_BANG] = ACTIONS(3021),
    [anon_sym_do_BANG] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3019),
    [anon_sym_LPAREN2] = ACTIONS(3019),
    [anon_sym_or] = ACTIONS(3019),
    [aux_sym_char_token1] = ACTIONS(3021),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3019),
    [anon_sym_DQUOTE] = ACTIONS(3019),
    [anon_sym_AT_DQUOTE] = ACTIONS(3021),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3021),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3021),
    [sym_bool] = ACTIONS(3019),
    [sym_unit] = ACTIONS(3021),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3019),
    [sym_op_identifier] = ACTIONS(3019),
    [anon_sym_PLUS] = ACTIONS(3019),
    [anon_sym_DASH] = ACTIONS(3019),
    [anon_sym_PLUS_DOT] = ACTIONS(3019),
    [anon_sym_DASH_DOT] = ACTIONS(3019),
    [anon_sym_PERCENT] = ACTIONS(3019),
    [anon_sym_AMP_AMP] = ACTIONS(3019),
    [anon_sym_TILDE] = ACTIONS(3021),
    [aux_sym_prefix_op_token1] = ACTIONS(3019),
    [aux_sym_infix_op_token1] = ACTIONS(3021),
    [aux_sym_infix_op_token2] = ACTIONS(3019),
    [anon_sym_PIPE_PIPE] = ACTIONS(3019),
    [anon_sym_BANG_EQ] = ACTIONS(3019),
    [anon_sym_COLON_EQ] = ACTIONS(3021),
    [anon_sym_DOLLAR] = ACTIONS(3019),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3019),
    [sym_int] = ACTIONS(3019),
    [sym_xint] = ACTIONS(3021),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3021),
    [anon_sym_POUNDendif] = ACTIONS(3021),
    [anon_sym_POUNDelse] = ACTIONS(3021),
    [sym__newline] = ACTIONS(3021),
  },
  [1853] = {
    [sym_block_comment] = STATE(1853),
    [sym_compiler_directive_decl] = STATE(1853),
    [sym_fsi_directive_decl] = STATE(1853),
    [sym_preproc_line] = STATE(1853),
    [sym_identifier] = ACTIONS(2930),
    [anon_sym_EQ] = ACTIONS(2932),
    [anon_sym_COLON] = ACTIONS(2930),
    [anon_sym_return] = ACTIONS(2930),
    [anon_sym_do] = ACTIONS(2930),
    [anon_sym_let] = ACTIONS(2930),
    [anon_sym_let_BANG] = ACTIONS(2932),
    [anon_sym_as] = ACTIONS(2930),
    [anon_sym_LPAREN] = ACTIONS(2930),
    [anon_sym_COMMA] = ACTIONS(2932),
    [anon_sym_null] = ACTIONS(2930),
    [anon_sym_QMARK] = ACTIONS(2930),
    [anon_sym_COLON_QMARK] = ACTIONS(2930),
    [anon_sym_COLON_COLON] = ACTIONS(2932),
    [anon_sym_AMP] = ACTIONS(2930),
    [anon_sym_LBRACK] = ACTIONS(2930),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2932),
    [anon_sym_LBRACE] = ACTIONS(2930),
    [anon_sym_LT_AT] = ACTIONS(2930),
    [anon_sym_LT_AT_AT] = ACTIONS(2930),
    [anon_sym_DOT] = ACTIONS(2930),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2932),
    [anon_sym_new] = ACTIONS(2930),
    [anon_sym_with] = ACTIONS(2930),
    [anon_sym_return_BANG] = ACTIONS(2932),
    [anon_sym_yield] = ACTIONS(2930),
    [anon_sym_yield_BANG] = ACTIONS(2932),
    [anon_sym_lazy] = ACTIONS(2930),
    [anon_sym_assert] = ACTIONS(2930),
    [anon_sym_upcast] = ACTIONS(2930),
    [anon_sym_downcast] = ACTIONS(2930),
    [anon_sym_COLON_GT] = ACTIONS(2932),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2932),
    [anon_sym_for] = ACTIONS(2930),
    [anon_sym_while] = ACTIONS(2930),
    [anon_sym_if] = ACTIONS(2930),
    [anon_sym_fun] = ACTIONS(2930),
    [anon_sym_try] = ACTIONS(2930),
    [anon_sym_match] = ACTIONS(2930),
    [anon_sym_match_BANG] = ACTIONS(2932),
    [anon_sym_function] = ACTIONS(2930),
    [anon_sym_LT_DASH] = ACTIONS(2930),
    [anon_sym_DOT_LBRACK] = ACTIONS(2932),
    [anon_sym_LT] = ACTIONS(2932),
    [anon_sym_use] = ACTIONS(2930),
    [anon_sym_use_BANG] = ACTIONS(2932),
    [anon_sym_do_BANG] = ACTIONS(2932),
    [anon_sym_begin] = ACTIONS(2930),
    [anon_sym_LPAREN2] = ACTIONS(2930),
    [anon_sym_or] = ACTIONS(2930),
    [aux_sym_char_token1] = ACTIONS(2932),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2930),
    [anon_sym_DQUOTE] = ACTIONS(2930),
    [anon_sym_AT_DQUOTE] = ACTIONS(2932),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2932),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2932),
    [sym_bool] = ACTIONS(2930),
    [sym_unit] = ACTIONS(2932),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2930),
    [sym_op_identifier] = ACTIONS(2930),
    [anon_sym_PLUS] = ACTIONS(2930),
    [anon_sym_DASH] = ACTIONS(2930),
    [anon_sym_PLUS_DOT] = ACTIONS(2930),
    [anon_sym_DASH_DOT] = ACTIONS(2930),
    [anon_sym_PERCENT] = ACTIONS(2930),
    [anon_sym_AMP_AMP] = ACTIONS(2930),
    [anon_sym_TILDE] = ACTIONS(2932),
    [aux_sym_prefix_op_token1] = ACTIONS(2930),
    [aux_sym_infix_op_token1] = ACTIONS(2932),
    [aux_sym_infix_op_token2] = ACTIONS(2930),
    [anon_sym_PIPE_PIPE] = ACTIONS(2930),
    [anon_sym_BANG_EQ] = ACTIONS(2930),
    [anon_sym_COLON_EQ] = ACTIONS(2932),
    [anon_sym_DOLLAR] = ACTIONS(2930),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2930),
    [sym_int] = ACTIONS(2930),
    [sym_xint] = ACTIONS(2932),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2932),
    [sym__newline] = ACTIONS(2932),
  },
  [1854] = {
    [sym_block_comment] = STATE(1854),
    [sym_compiler_directive_decl] = STATE(1854),
    [sym_fsi_directive_decl] = STATE(1854),
    [sym_preproc_line] = STATE(1854),
    [sym_identifier] = ACTIONS(3023),
    [anon_sym_EQ] = ACTIONS(3025),
    [anon_sym_COLON] = ACTIONS(3023),
    [anon_sym_return] = ACTIONS(3023),
    [anon_sym_do] = ACTIONS(3023),
    [anon_sym_let] = ACTIONS(3023),
    [anon_sym_let_BANG] = ACTIONS(3025),
    [anon_sym_LPAREN] = ACTIONS(3023),
    [anon_sym_COMMA] = ACTIONS(3025),
    [anon_sym_null] = ACTIONS(3023),
    [anon_sym_QMARK] = ACTIONS(3023),
    [anon_sym_COLON_QMARK] = ACTIONS(3023),
    [anon_sym_COLON_COLON] = ACTIONS(3025),
    [anon_sym_AMP] = ACTIONS(3023),
    [anon_sym_LBRACK] = ACTIONS(3023),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3025),
    [anon_sym_LBRACE] = ACTIONS(3023),
    [anon_sym_LT_AT] = ACTIONS(3023),
    [anon_sym_LT_AT_AT] = ACTIONS(3023),
    [anon_sym_DOT] = ACTIONS(3023),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3025),
    [anon_sym_new] = ACTIONS(3023),
    [anon_sym_return_BANG] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(3023),
    [anon_sym_yield_BANG] = ACTIONS(3025),
    [anon_sym_lazy] = ACTIONS(3023),
    [anon_sym_assert] = ACTIONS(3023),
    [anon_sym_upcast] = ACTIONS(3023),
    [anon_sym_downcast] = ACTIONS(3023),
    [anon_sym_COLON_GT] = ACTIONS(3025),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3025),
    [anon_sym_for] = ACTIONS(3023),
    [anon_sym_while] = ACTIONS(3023),
    [anon_sym_if] = ACTIONS(3023),
    [anon_sym_fun] = ACTIONS(3023),
    [anon_sym_try] = ACTIONS(3023),
    [anon_sym_match] = ACTIONS(3023),
    [anon_sym_match_BANG] = ACTIONS(3025),
    [anon_sym_function] = ACTIONS(3023),
    [anon_sym_LT_DASH] = ACTIONS(3023),
    [anon_sym_DOT_LBRACK] = ACTIONS(3025),
    [anon_sym_LT] = ACTIONS(3025),
    [anon_sym_use] = ACTIONS(3023),
    [anon_sym_use_BANG] = ACTIONS(3025),
    [anon_sym_do_BANG] = ACTIONS(3025),
    [anon_sym_begin] = ACTIONS(3023),
    [anon_sym_LPAREN2] = ACTIONS(3023),
    [anon_sym_or] = ACTIONS(3023),
    [aux_sym_char_token1] = ACTIONS(3025),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3023),
    [anon_sym_DQUOTE] = ACTIONS(3023),
    [anon_sym_AT_DQUOTE] = ACTIONS(3025),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3025),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3025),
    [sym_bool] = ACTIONS(3023),
    [sym_unit] = ACTIONS(3025),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3023),
    [sym_op_identifier] = ACTIONS(3023),
    [anon_sym_PLUS] = ACTIONS(3023),
    [anon_sym_DASH] = ACTIONS(3023),
    [anon_sym_PLUS_DOT] = ACTIONS(3023),
    [anon_sym_DASH_DOT] = ACTIONS(3023),
    [anon_sym_PERCENT] = ACTIONS(3023),
    [anon_sym_AMP_AMP] = ACTIONS(3023),
    [anon_sym_TILDE] = ACTIONS(3025),
    [aux_sym_prefix_op_token1] = ACTIONS(3023),
    [aux_sym_infix_op_token1] = ACTIONS(3025),
    [aux_sym_infix_op_token2] = ACTIONS(3023),
    [anon_sym_PIPE_PIPE] = ACTIONS(3023),
    [anon_sym_BANG_EQ] = ACTIONS(3023),
    [anon_sym_COLON_EQ] = ACTIONS(3025),
    [anon_sym_DOLLAR] = ACTIONS(3023),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3023),
    [sym_int] = ACTIONS(3023),
    [sym_xint] = ACTIONS(3025),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3025),
    [anon_sym_POUNDendif] = ACTIONS(3025),
    [anon_sym_POUNDelse] = ACTIONS(3025),
    [sym__newline] = ACTIONS(3025),
  },
  [1855] = {
    [sym_block_comment] = STATE(1855),
    [sym_compiler_directive_decl] = STATE(1855),
    [sym_fsi_directive_decl] = STATE(1855),
    [sym_preproc_line] = STATE(1855),
    [sym_identifier] = ACTIONS(3027),
    [anon_sym_EQ] = ACTIONS(3029),
    [anon_sym_COLON] = ACTIONS(3027),
    [anon_sym_return] = ACTIONS(3027),
    [anon_sym_do] = ACTIONS(3027),
    [anon_sym_let] = ACTIONS(3027),
    [anon_sym_let_BANG] = ACTIONS(3029),
    [anon_sym_LPAREN] = ACTIONS(3027),
    [anon_sym_COMMA] = ACTIONS(3029),
    [anon_sym_null] = ACTIONS(3027),
    [anon_sym_QMARK] = ACTIONS(3027),
    [anon_sym_COLON_QMARK] = ACTIONS(3027),
    [anon_sym_COLON_COLON] = ACTIONS(3029),
    [anon_sym_AMP] = ACTIONS(3027),
    [anon_sym_LBRACK] = ACTIONS(3027),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3027),
    [anon_sym_LT_AT] = ACTIONS(3027),
    [anon_sym_LT_AT_AT] = ACTIONS(3027),
    [anon_sym_DOT] = ACTIONS(3027),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3029),
    [anon_sym_new] = ACTIONS(3027),
    [anon_sym_return_BANG] = ACTIONS(3029),
    [anon_sym_yield] = ACTIONS(3027),
    [anon_sym_yield_BANG] = ACTIONS(3029),
    [anon_sym_lazy] = ACTIONS(3027),
    [anon_sym_assert] = ACTIONS(3027),
    [anon_sym_upcast] = ACTIONS(3027),
    [anon_sym_downcast] = ACTIONS(3027),
    [anon_sym_COLON_GT] = ACTIONS(3029),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3029),
    [anon_sym_for] = ACTIONS(3027),
    [anon_sym_while] = ACTIONS(3027),
    [anon_sym_if] = ACTIONS(3027),
    [anon_sym_fun] = ACTIONS(3027),
    [anon_sym_try] = ACTIONS(3027),
    [anon_sym_match] = ACTIONS(3027),
    [anon_sym_match_BANG] = ACTIONS(3029),
    [anon_sym_function] = ACTIONS(3027),
    [anon_sym_LT_DASH] = ACTIONS(3027),
    [anon_sym_DOT_LBRACK] = ACTIONS(3029),
    [anon_sym_LT] = ACTIONS(3029),
    [anon_sym_use] = ACTIONS(3027),
    [anon_sym_use_BANG] = ACTIONS(3029),
    [anon_sym_do_BANG] = ACTIONS(3029),
    [anon_sym_begin] = ACTIONS(3027),
    [anon_sym_LPAREN2] = ACTIONS(3027),
    [anon_sym_or] = ACTIONS(3027),
    [aux_sym_char_token1] = ACTIONS(3029),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3027),
    [anon_sym_DQUOTE] = ACTIONS(3027),
    [anon_sym_AT_DQUOTE] = ACTIONS(3029),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3029),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3029),
    [sym_bool] = ACTIONS(3027),
    [sym_unit] = ACTIONS(3029),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3027),
    [sym_op_identifier] = ACTIONS(3027),
    [anon_sym_PLUS] = ACTIONS(3027),
    [anon_sym_DASH] = ACTIONS(3027),
    [anon_sym_PLUS_DOT] = ACTIONS(3027),
    [anon_sym_DASH_DOT] = ACTIONS(3027),
    [anon_sym_PERCENT] = ACTIONS(3027),
    [anon_sym_AMP_AMP] = ACTIONS(3027),
    [anon_sym_TILDE] = ACTIONS(3029),
    [aux_sym_prefix_op_token1] = ACTIONS(3027),
    [aux_sym_infix_op_token1] = ACTIONS(3029),
    [aux_sym_infix_op_token2] = ACTIONS(3027),
    [anon_sym_PIPE_PIPE] = ACTIONS(3027),
    [anon_sym_BANG_EQ] = ACTIONS(3027),
    [anon_sym_COLON_EQ] = ACTIONS(3029),
    [anon_sym_DOLLAR] = ACTIONS(3027),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3027),
    [sym_int] = ACTIONS(3027),
    [sym_xint] = ACTIONS(3029),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3029),
    [anon_sym_POUNDendif] = ACTIONS(3029),
    [anon_sym_POUNDelse] = ACTIONS(3029),
    [sym__newline] = ACTIONS(3029),
  },
  [1856] = {
    [sym_block_comment] = STATE(1856),
    [sym_compiler_directive_decl] = STATE(1856),
    [sym_fsi_directive_decl] = STATE(1856),
    [sym_preproc_line] = STATE(1856),
    [sym_identifier] = ACTIONS(3031),
    [anon_sym_EQ] = ACTIONS(3033),
    [anon_sym_COLON] = ACTIONS(3031),
    [anon_sym_return] = ACTIONS(3031),
    [anon_sym_do] = ACTIONS(3031),
    [anon_sym_let] = ACTIONS(3031),
    [anon_sym_let_BANG] = ACTIONS(3033),
    [anon_sym_LPAREN] = ACTIONS(3031),
    [anon_sym_COMMA] = ACTIONS(3033),
    [anon_sym_null] = ACTIONS(3031),
    [anon_sym_QMARK] = ACTIONS(3031),
    [anon_sym_COLON_QMARK] = ACTIONS(3031),
    [anon_sym_COLON_COLON] = ACTIONS(3033),
    [anon_sym_AMP] = ACTIONS(3031),
    [anon_sym_LBRACK] = ACTIONS(3031),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3033),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [anon_sym_LT_AT] = ACTIONS(3031),
    [anon_sym_LT_AT_AT] = ACTIONS(3031),
    [anon_sym_DOT] = ACTIONS(3031),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3033),
    [anon_sym_new] = ACTIONS(3031),
    [anon_sym_return_BANG] = ACTIONS(3033),
    [anon_sym_yield] = ACTIONS(3031),
    [anon_sym_yield_BANG] = ACTIONS(3033),
    [anon_sym_lazy] = ACTIONS(3031),
    [anon_sym_assert] = ACTIONS(3031),
    [anon_sym_upcast] = ACTIONS(3031),
    [anon_sym_downcast] = ACTIONS(3031),
    [anon_sym_COLON_GT] = ACTIONS(3033),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3033),
    [anon_sym_for] = ACTIONS(3031),
    [anon_sym_while] = ACTIONS(3031),
    [anon_sym_if] = ACTIONS(3031),
    [anon_sym_fun] = ACTIONS(3031),
    [anon_sym_try] = ACTIONS(3031),
    [anon_sym_match] = ACTIONS(3031),
    [anon_sym_match_BANG] = ACTIONS(3033),
    [anon_sym_function] = ACTIONS(3031),
    [anon_sym_LT_DASH] = ACTIONS(3031),
    [anon_sym_DOT_LBRACK] = ACTIONS(3033),
    [anon_sym_LT] = ACTIONS(3033),
    [anon_sym_use] = ACTIONS(3031),
    [anon_sym_use_BANG] = ACTIONS(3033),
    [anon_sym_do_BANG] = ACTIONS(3033),
    [anon_sym_begin] = ACTIONS(3031),
    [anon_sym_LPAREN2] = ACTIONS(3031),
    [anon_sym_or] = ACTIONS(3031),
    [aux_sym_char_token1] = ACTIONS(3033),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3031),
    [anon_sym_DQUOTE] = ACTIONS(3031),
    [anon_sym_AT_DQUOTE] = ACTIONS(3033),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3033),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3033),
    [sym_bool] = ACTIONS(3031),
    [sym_unit] = ACTIONS(3033),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3031),
    [sym_op_identifier] = ACTIONS(3031),
    [anon_sym_PLUS] = ACTIONS(3031),
    [anon_sym_DASH] = ACTIONS(3031),
    [anon_sym_PLUS_DOT] = ACTIONS(3031),
    [anon_sym_DASH_DOT] = ACTIONS(3031),
    [anon_sym_PERCENT] = ACTIONS(3031),
    [anon_sym_AMP_AMP] = ACTIONS(3031),
    [anon_sym_TILDE] = ACTIONS(3033),
    [aux_sym_prefix_op_token1] = ACTIONS(3031),
    [aux_sym_infix_op_token1] = ACTIONS(3033),
    [aux_sym_infix_op_token2] = ACTIONS(3031),
    [anon_sym_PIPE_PIPE] = ACTIONS(3031),
    [anon_sym_BANG_EQ] = ACTIONS(3031),
    [anon_sym_COLON_EQ] = ACTIONS(3033),
    [anon_sym_DOLLAR] = ACTIONS(3031),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3031),
    [sym_int] = ACTIONS(3031),
    [sym_xint] = ACTIONS(3033),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3033),
    [anon_sym_POUNDendif] = ACTIONS(3033),
    [anon_sym_POUNDelse] = ACTIONS(3033),
    [sym__newline] = ACTIONS(3033),
  },
  [1857] = {
    [sym_block_comment] = STATE(1857),
    [sym_compiler_directive_decl] = STATE(1857),
    [sym_fsi_directive_decl] = STATE(1857),
    [sym_preproc_line] = STATE(1857),
    [sym_identifier] = ACTIONS(3035),
    [anon_sym_EQ] = ACTIONS(3037),
    [anon_sym_COLON] = ACTIONS(3035),
    [anon_sym_return] = ACTIONS(3035),
    [anon_sym_do] = ACTIONS(3035),
    [anon_sym_let] = ACTIONS(3035),
    [anon_sym_let_BANG] = ACTIONS(3037),
    [anon_sym_LPAREN] = ACTIONS(3035),
    [anon_sym_COMMA] = ACTIONS(3037),
    [anon_sym_null] = ACTIONS(3035),
    [anon_sym_QMARK] = ACTIONS(3035),
    [anon_sym_COLON_QMARK] = ACTIONS(3035),
    [anon_sym_COLON_COLON] = ACTIONS(3037),
    [anon_sym_AMP] = ACTIONS(3035),
    [anon_sym_LBRACK] = ACTIONS(3035),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3037),
    [anon_sym_LBRACE] = ACTIONS(3035),
    [anon_sym_LT_AT] = ACTIONS(3035),
    [anon_sym_LT_AT_AT] = ACTIONS(3035),
    [anon_sym_DOT] = ACTIONS(3035),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3037),
    [anon_sym_new] = ACTIONS(3035),
    [anon_sym_return_BANG] = ACTIONS(3037),
    [anon_sym_yield] = ACTIONS(3035),
    [anon_sym_yield_BANG] = ACTIONS(3037),
    [anon_sym_lazy] = ACTIONS(3035),
    [anon_sym_assert] = ACTIONS(3035),
    [anon_sym_upcast] = ACTIONS(3035),
    [anon_sym_downcast] = ACTIONS(3035),
    [anon_sym_COLON_GT] = ACTIONS(3037),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3037),
    [anon_sym_for] = ACTIONS(3035),
    [anon_sym_while] = ACTIONS(3035),
    [anon_sym_if] = ACTIONS(3035),
    [anon_sym_fun] = ACTIONS(3035),
    [anon_sym_try] = ACTIONS(3035),
    [anon_sym_match] = ACTIONS(3035),
    [anon_sym_match_BANG] = ACTIONS(3037),
    [anon_sym_function] = ACTIONS(3035),
    [anon_sym_LT_DASH] = ACTIONS(3035),
    [anon_sym_DOT_LBRACK] = ACTIONS(3037),
    [anon_sym_LT] = ACTIONS(3037),
    [anon_sym_use] = ACTIONS(3035),
    [anon_sym_use_BANG] = ACTIONS(3037),
    [anon_sym_do_BANG] = ACTIONS(3037),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_LPAREN2] = ACTIONS(3035),
    [anon_sym_or] = ACTIONS(3035),
    [aux_sym_char_token1] = ACTIONS(3037),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3035),
    [anon_sym_DQUOTE] = ACTIONS(3035),
    [anon_sym_AT_DQUOTE] = ACTIONS(3037),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3037),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3037),
    [sym_bool] = ACTIONS(3035),
    [sym_unit] = ACTIONS(3037),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3035),
    [sym_op_identifier] = ACTIONS(3035),
    [anon_sym_PLUS] = ACTIONS(3035),
    [anon_sym_DASH] = ACTIONS(3035),
    [anon_sym_PLUS_DOT] = ACTIONS(3035),
    [anon_sym_DASH_DOT] = ACTIONS(3035),
    [anon_sym_PERCENT] = ACTIONS(3035),
    [anon_sym_AMP_AMP] = ACTIONS(3035),
    [anon_sym_TILDE] = ACTIONS(3037),
    [aux_sym_prefix_op_token1] = ACTIONS(3035),
    [aux_sym_infix_op_token1] = ACTIONS(3037),
    [aux_sym_infix_op_token2] = ACTIONS(3035),
    [anon_sym_PIPE_PIPE] = ACTIONS(3035),
    [anon_sym_BANG_EQ] = ACTIONS(3035),
    [anon_sym_COLON_EQ] = ACTIONS(3037),
    [anon_sym_DOLLAR] = ACTIONS(3035),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3035),
    [sym_int] = ACTIONS(3035),
    [sym_xint] = ACTIONS(3037),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3037),
    [anon_sym_POUNDendif] = ACTIONS(3037),
    [anon_sym_POUNDelse] = ACTIONS(3037),
    [sym__newline] = ACTIONS(3037),
  },
  [1858] = {
    [sym_block_comment] = STATE(1858),
    [sym_compiler_directive_decl] = STATE(1858),
    [sym_fsi_directive_decl] = STATE(1858),
    [sym_preproc_line] = STATE(1858),
    [sym_identifier] = ACTIONS(2843),
    [anon_sym_EQ] = ACTIONS(2845),
    [anon_sym_COLON] = ACTIONS(2843),
    [anon_sym_return] = ACTIONS(2843),
    [anon_sym_do] = ACTIONS(2843),
    [anon_sym_let] = ACTIONS(2843),
    [anon_sym_let_BANG] = ACTIONS(2845),
    [anon_sym_LPAREN] = ACTIONS(2843),
    [anon_sym_COMMA] = ACTIONS(2845),
    [anon_sym_null] = ACTIONS(2843),
    [anon_sym_QMARK] = ACTIONS(2843),
    [anon_sym_COLON_QMARK] = ACTIONS(2843),
    [anon_sym_COLON_COLON] = ACTIONS(2845),
    [anon_sym_AMP] = ACTIONS(2843),
    [anon_sym_LBRACK] = ACTIONS(2843),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2845),
    [anon_sym_LBRACE] = ACTIONS(2843),
    [anon_sym_LT_AT] = ACTIONS(2843),
    [anon_sym_LT_AT_AT] = ACTIONS(2843),
    [anon_sym_DOT] = ACTIONS(2843),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2845),
    [anon_sym_new] = ACTIONS(2843),
    [anon_sym_return_BANG] = ACTIONS(2845),
    [anon_sym_yield] = ACTIONS(2843),
    [anon_sym_yield_BANG] = ACTIONS(2845),
    [anon_sym_lazy] = ACTIONS(2843),
    [anon_sym_assert] = ACTIONS(2843),
    [anon_sym_upcast] = ACTIONS(2843),
    [anon_sym_downcast] = ACTIONS(2843),
    [anon_sym_COLON_GT] = ACTIONS(2845),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2845),
    [anon_sym_for] = ACTIONS(2843),
    [anon_sym_while] = ACTIONS(2843),
    [anon_sym_if] = ACTIONS(2843),
    [anon_sym_fun] = ACTIONS(2843),
    [anon_sym_DASH_GT] = ACTIONS(2843),
    [anon_sym_try] = ACTIONS(2843),
    [anon_sym_match] = ACTIONS(2843),
    [anon_sym_match_BANG] = ACTIONS(2845),
    [anon_sym_function] = ACTIONS(2843),
    [anon_sym_LT_DASH] = ACTIONS(2843),
    [anon_sym_DOT_LBRACK] = ACTIONS(2845),
    [anon_sym_LT] = ACTIONS(2845),
    [anon_sym_use] = ACTIONS(2843),
    [anon_sym_use_BANG] = ACTIONS(2845),
    [anon_sym_do_BANG] = ACTIONS(2845),
    [anon_sym_DOT_DOT] = ACTIONS(2845),
    [anon_sym_begin] = ACTIONS(2843),
    [anon_sym_LPAREN2] = ACTIONS(2843),
    [anon_sym_or] = ACTIONS(2843),
    [aux_sym_char_token1] = ACTIONS(2845),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2843),
    [anon_sym_DQUOTE] = ACTIONS(2843),
    [anon_sym_AT_DQUOTE] = ACTIONS(2845),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2845),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2845),
    [sym_bool] = ACTIONS(2843),
    [sym_unit] = ACTIONS(2845),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2843),
    [sym_op_identifier] = ACTIONS(2843),
    [anon_sym_PLUS] = ACTIONS(2843),
    [anon_sym_DASH] = ACTIONS(2843),
    [anon_sym_PLUS_DOT] = ACTIONS(2843),
    [anon_sym_DASH_DOT] = ACTIONS(2843),
    [anon_sym_PERCENT] = ACTIONS(2843),
    [anon_sym_AMP_AMP] = ACTIONS(2843),
    [anon_sym_TILDE] = ACTIONS(2845),
    [aux_sym_prefix_op_token1] = ACTIONS(2843),
    [aux_sym_infix_op_token1] = ACTIONS(2845),
    [aux_sym_infix_op_token2] = ACTIONS(2843),
    [anon_sym_PIPE_PIPE] = ACTIONS(2843),
    [anon_sym_BANG_EQ] = ACTIONS(2843),
    [anon_sym_COLON_EQ] = ACTIONS(2845),
    [anon_sym_DOLLAR] = ACTIONS(2843),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2843),
    [sym_int] = ACTIONS(2843),
    [sym_xint] = ACTIONS(2845),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2845),
    [sym__newline] = ACTIONS(2845),
  },
  [1859] = {
    [sym_block_comment] = STATE(1859),
    [sym_compiler_directive_decl] = STATE(1859),
    [sym_fsi_directive_decl] = STATE(1859),
    [sym_preproc_line] = STATE(1859),
    [sym_identifier] = ACTIONS(2158),
    [anon_sym_EQ] = ACTIONS(2160),
    [anon_sym_COLON] = ACTIONS(2158),
    [anon_sym_return] = ACTIONS(2158),
    [anon_sym_do] = ACTIONS(2158),
    [anon_sym_let] = ACTIONS(2158),
    [anon_sym_let_BANG] = ACTIONS(2160),
    [anon_sym_LPAREN] = ACTIONS(2158),
    [anon_sym_COMMA] = ACTIONS(2160),
    [anon_sym_null] = ACTIONS(2158),
    [anon_sym_QMARK] = ACTIONS(2158),
    [anon_sym_COLON_QMARK] = ACTIONS(2158),
    [anon_sym_COLON_COLON] = ACTIONS(2160),
    [anon_sym_AMP] = ACTIONS(2158),
    [anon_sym_LBRACK] = ACTIONS(2158),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2160),
    [anon_sym_LBRACE] = ACTIONS(2158),
    [anon_sym_LT_AT] = ACTIONS(2158),
    [anon_sym_LT_AT_AT] = ACTIONS(2158),
    [anon_sym_DOT] = ACTIONS(2158),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2160),
    [anon_sym_new] = ACTIONS(2158),
    [anon_sym_return_BANG] = ACTIONS(2160),
    [anon_sym_yield] = ACTIONS(2158),
    [anon_sym_yield_BANG] = ACTIONS(2160),
    [anon_sym_lazy] = ACTIONS(2158),
    [anon_sym_assert] = ACTIONS(2158),
    [anon_sym_upcast] = ACTIONS(2158),
    [anon_sym_downcast] = ACTIONS(2158),
    [anon_sym_COLON_GT] = ACTIONS(2160),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2160),
    [anon_sym_for] = ACTIONS(2158),
    [anon_sym_while] = ACTIONS(2158),
    [anon_sym_if] = ACTIONS(2158),
    [anon_sym_fun] = ACTIONS(2158),
    [anon_sym_DASH_GT] = ACTIONS(2158),
    [anon_sym_try] = ACTIONS(2158),
    [anon_sym_match] = ACTIONS(2158),
    [anon_sym_match_BANG] = ACTIONS(2160),
    [anon_sym_function] = ACTIONS(2158),
    [anon_sym_LT_DASH] = ACTIONS(2158),
    [anon_sym_DOT_LBRACK] = ACTIONS(2160),
    [anon_sym_LT] = ACTIONS(2160),
    [anon_sym_use] = ACTIONS(2158),
    [anon_sym_use_BANG] = ACTIONS(2160),
    [anon_sym_do_BANG] = ACTIONS(2160),
    [anon_sym_DOT_DOT] = ACTIONS(2160),
    [anon_sym_begin] = ACTIONS(2158),
    [anon_sym_LPAREN2] = ACTIONS(2158),
    [anon_sym_or] = ACTIONS(2158),
    [aux_sym_char_token1] = ACTIONS(2160),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2158),
    [anon_sym_DQUOTE] = ACTIONS(2158),
    [anon_sym_AT_DQUOTE] = ACTIONS(2160),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2160),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2160),
    [sym_bool] = ACTIONS(2158),
    [sym_unit] = ACTIONS(2160),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2158),
    [sym_op_identifier] = ACTIONS(2158),
    [anon_sym_PLUS] = ACTIONS(2158),
    [anon_sym_DASH] = ACTIONS(2158),
    [anon_sym_PLUS_DOT] = ACTIONS(2158),
    [anon_sym_DASH_DOT] = ACTIONS(2158),
    [anon_sym_PERCENT] = ACTIONS(2158),
    [anon_sym_AMP_AMP] = ACTIONS(2158),
    [anon_sym_TILDE] = ACTIONS(2160),
    [aux_sym_prefix_op_token1] = ACTIONS(2158),
    [aux_sym_infix_op_token1] = ACTIONS(2160),
    [aux_sym_infix_op_token2] = ACTIONS(2158),
    [anon_sym_PIPE_PIPE] = ACTIONS(2158),
    [anon_sym_BANG_EQ] = ACTIONS(2158),
    [anon_sym_COLON_EQ] = ACTIONS(2160),
    [anon_sym_DOLLAR] = ACTIONS(2158),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2158),
    [sym_int] = ACTIONS(2158),
    [sym_xint] = ACTIONS(2160),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2160),
    [sym__newline] = ACTIONS(2160),
  },
  [1860] = {
    [sym_block_comment] = STATE(1860),
    [sym_compiler_directive_decl] = STATE(1860),
    [sym_fsi_directive_decl] = STATE(1860),
    [sym_preproc_line] = STATE(1860),
    [sym_identifier] = ACTIONS(2863),
    [anon_sym_EQ] = ACTIONS(2865),
    [anon_sym_COLON] = ACTIONS(2863),
    [anon_sym_return] = ACTIONS(2863),
    [anon_sym_do] = ACTIONS(2863),
    [anon_sym_and] = ACTIONS(2863),
    [anon_sym_let] = ACTIONS(2863),
    [anon_sym_let_BANG] = ACTIONS(2865),
    [anon_sym_LPAREN] = ACTIONS(2863),
    [anon_sym_COMMA] = ACTIONS(2865),
    [anon_sym_null] = ACTIONS(2863),
    [anon_sym_QMARK] = ACTIONS(2863),
    [anon_sym_COLON_QMARK] = ACTIONS(2863),
    [anon_sym_COLON_COLON] = ACTIONS(2865),
    [anon_sym_AMP] = ACTIONS(2863),
    [anon_sym_LBRACK] = ACTIONS(2863),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2865),
    [anon_sym_LBRACE] = ACTIONS(2863),
    [anon_sym_LT_AT] = ACTIONS(2863),
    [anon_sym_LT_AT_AT] = ACTIONS(2863),
    [anon_sym_DOT] = ACTIONS(2863),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2865),
    [anon_sym_new] = ACTIONS(2863),
    [anon_sym_return_BANG] = ACTIONS(2865),
    [anon_sym_yield] = ACTIONS(2863),
    [anon_sym_yield_BANG] = ACTIONS(2865),
    [anon_sym_lazy] = ACTIONS(2863),
    [anon_sym_assert] = ACTIONS(2863),
    [anon_sym_upcast] = ACTIONS(2863),
    [anon_sym_downcast] = ACTIONS(2863),
    [anon_sym_COLON_GT] = ACTIONS(2865),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2865),
    [anon_sym_for] = ACTIONS(2863),
    [anon_sym_while] = ACTIONS(2863),
    [anon_sym_if] = ACTIONS(2863),
    [anon_sym_fun] = ACTIONS(2863),
    [anon_sym_try] = ACTIONS(2863),
    [anon_sym_match] = ACTIONS(2863),
    [anon_sym_match_BANG] = ACTIONS(2865),
    [anon_sym_function] = ACTIONS(2863),
    [anon_sym_LT_DASH] = ACTIONS(2863),
    [anon_sym_DOT_LBRACK] = ACTIONS(2865),
    [anon_sym_LT] = ACTIONS(2865),
    [anon_sym_use] = ACTIONS(2863),
    [anon_sym_use_BANG] = ACTIONS(2865),
    [anon_sym_do_BANG] = ACTIONS(2865),
    [anon_sym_begin] = ACTIONS(2863),
    [anon_sym_LPAREN2] = ACTIONS(2863),
    [anon_sym_or] = ACTIONS(2863),
    [aux_sym_char_token1] = ACTIONS(2865),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2863),
    [anon_sym_DQUOTE] = ACTIONS(2863),
    [anon_sym_AT_DQUOTE] = ACTIONS(2865),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2865),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2865),
    [sym_bool] = ACTIONS(2863),
    [sym_unit] = ACTIONS(2865),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2863),
    [sym_op_identifier] = ACTIONS(2863),
    [anon_sym_PLUS] = ACTIONS(2863),
    [anon_sym_DASH] = ACTIONS(2863),
    [anon_sym_PLUS_DOT] = ACTIONS(2863),
    [anon_sym_DASH_DOT] = ACTIONS(2863),
    [anon_sym_PERCENT] = ACTIONS(2863),
    [anon_sym_AMP_AMP] = ACTIONS(2863),
    [anon_sym_TILDE] = ACTIONS(2865),
    [aux_sym_prefix_op_token1] = ACTIONS(2863),
    [aux_sym_infix_op_token1] = ACTIONS(2865),
    [aux_sym_infix_op_token2] = ACTIONS(2863),
    [anon_sym_PIPE_PIPE] = ACTIONS(2863),
    [anon_sym_BANG_EQ] = ACTIONS(2863),
    [anon_sym_COLON_EQ] = ACTIONS(2865),
    [anon_sym_DOLLAR] = ACTIONS(2863),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2863),
    [sym_int] = ACTIONS(2863),
    [sym_xint] = ACTIONS(2865),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2865),
    [sym__newline] = ACTIONS(2865),
    [sym__dedent] = ACTIONS(2865),
  },
  [1861] = {
    [sym_block_comment] = STATE(1861),
    [sym_compiler_directive_decl] = STATE(1861),
    [sym_fsi_directive_decl] = STATE(1861),
    [sym_preproc_line] = STATE(1861),
    [sym_identifier] = ACTIONS(2855),
    [anon_sym_EQ] = ACTIONS(2857),
    [anon_sym_COLON] = ACTIONS(2855),
    [anon_sym_return] = ACTIONS(2855),
    [anon_sym_do] = ACTIONS(2855),
    [anon_sym_let] = ACTIONS(2855),
    [anon_sym_let_BANG] = ACTIONS(2857),
    [anon_sym_LPAREN] = ACTIONS(2855),
    [anon_sym_COMMA] = ACTIONS(2857),
    [anon_sym_null] = ACTIONS(2855),
    [anon_sym_QMARK] = ACTIONS(2855),
    [anon_sym_COLON_QMARK] = ACTIONS(2855),
    [anon_sym_COLON_COLON] = ACTIONS(2857),
    [anon_sym_AMP] = ACTIONS(2855),
    [anon_sym_LBRACK] = ACTIONS(2855),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2857),
    [anon_sym_LBRACE] = ACTIONS(2855),
    [anon_sym_LT_AT] = ACTIONS(2855),
    [anon_sym_LT_AT_AT] = ACTIONS(2855),
    [anon_sym_DOT] = ACTIONS(2855),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2857),
    [anon_sym_new] = ACTIONS(2855),
    [anon_sym_return_BANG] = ACTIONS(2857),
    [anon_sym_yield] = ACTIONS(2855),
    [anon_sym_yield_BANG] = ACTIONS(2857),
    [anon_sym_lazy] = ACTIONS(2855),
    [anon_sym_assert] = ACTIONS(2855),
    [anon_sym_upcast] = ACTIONS(2855),
    [anon_sym_downcast] = ACTIONS(2855),
    [anon_sym_COLON_GT] = ACTIONS(2857),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2857),
    [anon_sym_for] = ACTIONS(2855),
    [anon_sym_while] = ACTIONS(2855),
    [anon_sym_if] = ACTIONS(2855),
    [anon_sym_fun] = ACTIONS(2855),
    [anon_sym_DASH_GT] = ACTIONS(2855),
    [anon_sym_try] = ACTIONS(2855),
    [anon_sym_match] = ACTIONS(2855),
    [anon_sym_match_BANG] = ACTIONS(2857),
    [anon_sym_function] = ACTIONS(2855),
    [anon_sym_LT_DASH] = ACTIONS(2855),
    [anon_sym_DOT_LBRACK] = ACTIONS(2857),
    [anon_sym_LT] = ACTIONS(2857),
    [anon_sym_use] = ACTIONS(2855),
    [anon_sym_use_BANG] = ACTIONS(2857),
    [anon_sym_do_BANG] = ACTIONS(2857),
    [anon_sym_DOT_DOT] = ACTIONS(2857),
    [anon_sym_begin] = ACTIONS(2855),
    [anon_sym_LPAREN2] = ACTIONS(2855),
    [anon_sym_or] = ACTIONS(2855),
    [aux_sym_char_token1] = ACTIONS(2857),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2855),
    [anon_sym_DQUOTE] = ACTIONS(2855),
    [anon_sym_AT_DQUOTE] = ACTIONS(2857),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2857),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2857),
    [sym_bool] = ACTIONS(2855),
    [sym_unit] = ACTIONS(2857),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2855),
    [sym_op_identifier] = ACTIONS(2855),
    [anon_sym_PLUS] = ACTIONS(2855),
    [anon_sym_DASH] = ACTIONS(2855),
    [anon_sym_PLUS_DOT] = ACTIONS(2855),
    [anon_sym_DASH_DOT] = ACTIONS(2855),
    [anon_sym_PERCENT] = ACTIONS(2855),
    [anon_sym_AMP_AMP] = ACTIONS(2855),
    [anon_sym_TILDE] = ACTIONS(2857),
    [aux_sym_prefix_op_token1] = ACTIONS(2855),
    [aux_sym_infix_op_token1] = ACTIONS(2857),
    [aux_sym_infix_op_token2] = ACTIONS(2855),
    [anon_sym_PIPE_PIPE] = ACTIONS(2855),
    [anon_sym_BANG_EQ] = ACTIONS(2855),
    [anon_sym_COLON_EQ] = ACTIONS(2857),
    [anon_sym_DOLLAR] = ACTIONS(2855),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2855),
    [sym_int] = ACTIONS(2855),
    [sym_xint] = ACTIONS(2857),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2857),
    [sym__newline] = ACTIONS(2857),
  },
  [1862] = {
    [sym_block_comment] = STATE(1862),
    [sym_compiler_directive_decl] = STATE(1862),
    [sym_fsi_directive_decl] = STATE(1862),
    [sym_preproc_line] = STATE(1862),
    [sym_identifier] = ACTIONS(2859),
    [anon_sym_EQ] = ACTIONS(2861),
    [anon_sym_COLON] = ACTIONS(2859),
    [anon_sym_return] = ACTIONS(2859),
    [anon_sym_do] = ACTIONS(2859),
    [anon_sym_let] = ACTIONS(2859),
    [anon_sym_let_BANG] = ACTIONS(2861),
    [anon_sym_LPAREN] = ACTIONS(2859),
    [anon_sym_COMMA] = ACTIONS(2861),
    [anon_sym_null] = ACTIONS(2859),
    [anon_sym_QMARK] = ACTIONS(2859),
    [anon_sym_COLON_QMARK] = ACTIONS(2859),
    [anon_sym_COLON_COLON] = ACTIONS(2861),
    [anon_sym_AMP] = ACTIONS(2859),
    [anon_sym_LBRACK] = ACTIONS(2859),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2861),
    [anon_sym_LBRACE] = ACTIONS(2859),
    [anon_sym_LT_AT] = ACTIONS(2859),
    [anon_sym_LT_AT_AT] = ACTIONS(2859),
    [anon_sym_DOT] = ACTIONS(2859),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2861),
    [anon_sym_new] = ACTIONS(2859),
    [anon_sym_return_BANG] = ACTIONS(2861),
    [anon_sym_yield] = ACTIONS(2859),
    [anon_sym_yield_BANG] = ACTIONS(2861),
    [anon_sym_lazy] = ACTIONS(2859),
    [anon_sym_assert] = ACTIONS(2859),
    [anon_sym_upcast] = ACTIONS(2859),
    [anon_sym_downcast] = ACTIONS(2859),
    [anon_sym_COLON_GT] = ACTIONS(2861),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2861),
    [anon_sym_for] = ACTIONS(2859),
    [anon_sym_while] = ACTIONS(2859),
    [anon_sym_if] = ACTIONS(2859),
    [anon_sym_fun] = ACTIONS(2859),
    [anon_sym_DASH_GT] = ACTIONS(2859),
    [anon_sym_try] = ACTIONS(2859),
    [anon_sym_match] = ACTIONS(2859),
    [anon_sym_match_BANG] = ACTIONS(2861),
    [anon_sym_function] = ACTIONS(2859),
    [anon_sym_LT_DASH] = ACTIONS(2859),
    [anon_sym_DOT_LBRACK] = ACTIONS(2861),
    [anon_sym_LT] = ACTIONS(2861),
    [anon_sym_use] = ACTIONS(2859),
    [anon_sym_use_BANG] = ACTIONS(2861),
    [anon_sym_do_BANG] = ACTIONS(2861),
    [anon_sym_DOT_DOT] = ACTIONS(2861),
    [anon_sym_begin] = ACTIONS(2859),
    [anon_sym_LPAREN2] = ACTIONS(2859),
    [anon_sym_or] = ACTIONS(2859),
    [aux_sym_char_token1] = ACTIONS(2861),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2859),
    [anon_sym_DQUOTE] = ACTIONS(2859),
    [anon_sym_AT_DQUOTE] = ACTIONS(2861),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2861),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2861),
    [sym_bool] = ACTIONS(2859),
    [sym_unit] = ACTIONS(2861),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2859),
    [sym_op_identifier] = ACTIONS(2859),
    [anon_sym_PLUS] = ACTIONS(2859),
    [anon_sym_DASH] = ACTIONS(2859),
    [anon_sym_PLUS_DOT] = ACTIONS(2859),
    [anon_sym_DASH_DOT] = ACTIONS(2859),
    [anon_sym_PERCENT] = ACTIONS(2859),
    [anon_sym_AMP_AMP] = ACTIONS(2859),
    [anon_sym_TILDE] = ACTIONS(2861),
    [aux_sym_prefix_op_token1] = ACTIONS(2859),
    [aux_sym_infix_op_token1] = ACTIONS(2861),
    [aux_sym_infix_op_token2] = ACTIONS(2859),
    [anon_sym_PIPE_PIPE] = ACTIONS(2859),
    [anon_sym_BANG_EQ] = ACTIONS(2859),
    [anon_sym_COLON_EQ] = ACTIONS(2861),
    [anon_sym_DOLLAR] = ACTIONS(2859),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2859),
    [sym_int] = ACTIONS(2859),
    [sym_xint] = ACTIONS(2861),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2861),
    [sym__newline] = ACTIONS(2861),
  },
  [1863] = {
    [sym_block_comment] = STATE(1863),
    [sym_compiler_directive_decl] = STATE(1863),
    [sym_fsi_directive_decl] = STATE(1863),
    [sym_preproc_line] = STATE(1863),
    [sym_identifier] = ACTIONS(2873),
    [anon_sym_EQ] = ACTIONS(2875),
    [anon_sym_COLON] = ACTIONS(2873),
    [anon_sym_return] = ACTIONS(2873),
    [anon_sym_do] = ACTIONS(2873),
    [anon_sym_let] = ACTIONS(2873),
    [anon_sym_let_BANG] = ACTIONS(2875),
    [anon_sym_LPAREN] = ACTIONS(2873),
    [anon_sym_COMMA] = ACTIONS(2875),
    [anon_sym_null] = ACTIONS(2873),
    [anon_sym_QMARK] = ACTIONS(2873),
    [anon_sym_COLON_QMARK] = ACTIONS(2873),
    [anon_sym_COLON_COLON] = ACTIONS(2875),
    [anon_sym_AMP] = ACTIONS(2873),
    [anon_sym_LBRACK] = ACTIONS(2873),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2875),
    [anon_sym_LBRACE] = ACTIONS(2873),
    [anon_sym_LT_AT] = ACTIONS(2873),
    [anon_sym_LT_AT_AT] = ACTIONS(2873),
    [anon_sym_DOT] = ACTIONS(2873),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2875),
    [anon_sym_new] = ACTIONS(2873),
    [anon_sym_return_BANG] = ACTIONS(2875),
    [anon_sym_yield] = ACTIONS(2873),
    [anon_sym_yield_BANG] = ACTIONS(2875),
    [anon_sym_lazy] = ACTIONS(2873),
    [anon_sym_assert] = ACTIONS(2873),
    [anon_sym_upcast] = ACTIONS(2873),
    [anon_sym_downcast] = ACTIONS(2873),
    [anon_sym_COLON_GT] = ACTIONS(2875),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2875),
    [anon_sym_for] = ACTIONS(2873),
    [anon_sym_while] = ACTIONS(2873),
    [anon_sym_if] = ACTIONS(2873),
    [anon_sym_fun] = ACTIONS(2873),
    [anon_sym_DASH_GT] = ACTIONS(2873),
    [anon_sym_try] = ACTIONS(2873),
    [anon_sym_match] = ACTIONS(2873),
    [anon_sym_match_BANG] = ACTIONS(2875),
    [anon_sym_function] = ACTIONS(2873),
    [anon_sym_LT_DASH] = ACTIONS(2873),
    [anon_sym_DOT_LBRACK] = ACTIONS(2875),
    [anon_sym_LT] = ACTIONS(2875),
    [anon_sym_use] = ACTIONS(2873),
    [anon_sym_use_BANG] = ACTIONS(2875),
    [anon_sym_do_BANG] = ACTIONS(2875),
    [anon_sym_DOT_DOT] = ACTIONS(2875),
    [anon_sym_begin] = ACTIONS(2873),
    [anon_sym_LPAREN2] = ACTIONS(2873),
    [anon_sym_or] = ACTIONS(2873),
    [aux_sym_char_token1] = ACTIONS(2875),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2873),
    [anon_sym_DQUOTE] = ACTIONS(2873),
    [anon_sym_AT_DQUOTE] = ACTIONS(2875),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2875),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2875),
    [sym_bool] = ACTIONS(2873),
    [sym_unit] = ACTIONS(2875),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2873),
    [sym_op_identifier] = ACTIONS(2873),
    [anon_sym_PLUS] = ACTIONS(2873),
    [anon_sym_DASH] = ACTIONS(2873),
    [anon_sym_PLUS_DOT] = ACTIONS(2873),
    [anon_sym_DASH_DOT] = ACTIONS(2873),
    [anon_sym_PERCENT] = ACTIONS(2873),
    [anon_sym_AMP_AMP] = ACTIONS(2873),
    [anon_sym_TILDE] = ACTIONS(2875),
    [aux_sym_prefix_op_token1] = ACTIONS(2873),
    [aux_sym_infix_op_token1] = ACTIONS(2875),
    [aux_sym_infix_op_token2] = ACTIONS(2873),
    [anon_sym_PIPE_PIPE] = ACTIONS(2873),
    [anon_sym_BANG_EQ] = ACTIONS(2873),
    [anon_sym_COLON_EQ] = ACTIONS(2875),
    [anon_sym_DOLLAR] = ACTIONS(2873),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2873),
    [sym_int] = ACTIONS(2873),
    [sym_xint] = ACTIONS(2875),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2875),
    [sym__newline] = ACTIONS(2875),
  },
  [1864] = {
    [sym_attributes] = STATE(2698),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(3506),
    [sym__pattern] = STATE(1631),
    [sym_optional_pattern] = STATE(3506),
    [sym_type_check_pattern] = STATE(3506),
    [sym_attribute_pattern] = STATE(3506),
    [sym_paren_pattern] = STATE(3506),
    [sym_as_pattern] = STATE(3506),
    [sym_cons_pattern] = STATE(3506),
    [sym_disjunct_pattern] = STATE(3506),
    [sym_conjunct_pattern] = STATE(3506),
    [sym_typed_pattern] = STATE(3506),
    [sym_list_pattern] = STATE(3506),
    [sym_array_pattern] = STATE(3506),
    [sym_record_pattern] = STATE(3506),
    [sym_named_field_pattern] = STATE(3506),
    [sym_identifier_pattern] = STATE(3506),
    [sym_long_identifier_or_op] = STATE(1864),
    [sym_char] = STATE(3497),
    [sym_format_string] = STATE(3495),
    [sym__string_literal] = STATE(3495),
    [sym_string] = STATE(3497),
    [sym_verbatim_string] = STATE(3497),
    [sym_bytearray] = STATE(3497),
    [sym_verbatim_bytearray] = STATE(3497),
    [sym_format_triple_quoted_string] = STATE(3494),
    [sym_triple_quoted_string] = STATE(3497),
    [sym_const] = STATE(3506),
    [sym_long_identifier] = STATE(3363),
    [sym_active_pattern] = STATE(3521),
    [sym__identifier_or_op] = STATE(3510),
    [sym_sbyte] = STATE(3497),
    [sym_byte] = STATE(3497),
    [sym_int16] = STATE(3497),
    [sym_uint16] = STATE(3497),
    [sym_int32] = STATE(3497),
    [sym_uint32] = STATE(3497),
    [sym_nativeint] = STATE(3497),
    [sym_unativeint] = STATE(3497),
    [sym_int64] = STATE(3497),
    [sym_uint64] = STATE(3497),
    [sym_ieee32] = STATE(3497),
    [sym_ieee64] = STATE(3497),
    [sym_bignum] = STATE(3497),
    [sym_decimal] = STATE(3497),
    [sym_float] = STATE(3305),
    [sym_block_comment] = STATE(1864),
    [sym_compiler_directive_decl] = STATE(1864),
    [sym_fsi_directive_decl] = STATE(1864),
    [sym_preproc_line] = STATE(1864),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(3960),
    [anon_sym_LBRACK_LT] = ACTIONS(3964),
    [anon_sym_COLON] = ACTIONS(3960),
    [anon_sym_as] = ACTIONS(3960),
    [anon_sym_LPAREN] = ACTIONS(3960),
    [anon_sym_RPAREN] = ACTIONS(3964),
    [anon_sym_COMMA] = ACTIONS(3964),
    [anon_sym_null] = ACTIONS(3960),
    [anon_sym__] = ACTIONS(3960),
    [anon_sym_QMARK] = ACTIONS(3964),
    [anon_sym_COLON_QMARK] = ACTIONS(3964),
    [anon_sym_COLON_COLON] = ACTIONS(3964),
    [anon_sym_PIPE] = ACTIONS(3964),
    [anon_sym_AMP] = ACTIONS(3964),
    [anon_sym_LBRACK] = ACTIONS(3960),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3964),
    [anon_sym_LBRACE] = ACTIONS(3964),
    [anon_sym_RBRACE] = ACTIONS(3964),
    [aux_sym_char_token1] = ACTIONS(3964),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3960),
    [anon_sym_DQUOTE] = ACTIONS(3960),
    [anon_sym_AT_DQUOTE] = ACTIONS(3964),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3964),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3964),
    [sym_bool] = ACTIONS(3960),
    [sym_unit] = ACTIONS(3964),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3960),
    [sym_op_identifier] = ACTIONS(3964),
    [sym_int] = ACTIONS(3960),
    [sym_xint] = ACTIONS(3964),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [sym__newline] = ACTIONS(3964),
  },
  [1865] = {
    [sym_block_comment] = STATE(1865),
    [sym_compiler_directive_decl] = STATE(1865),
    [sym_fsi_directive_decl] = STATE(1865),
    [sym_preproc_line] = STATE(1865),
    [sym_identifier] = ACTIONS(2877),
    [anon_sym_EQ] = ACTIONS(2879),
    [anon_sym_COLON] = ACTIONS(2877),
    [anon_sym_return] = ACTIONS(2877),
    [anon_sym_do] = ACTIONS(2877),
    [anon_sym_let] = ACTIONS(2877),
    [anon_sym_let_BANG] = ACTIONS(2879),
    [anon_sym_LPAREN] = ACTIONS(2877),
    [anon_sym_COMMA] = ACTIONS(2879),
    [anon_sym_null] = ACTIONS(2877),
    [anon_sym_QMARK] = ACTIONS(2877),
    [anon_sym_COLON_QMARK] = ACTIONS(2877),
    [anon_sym_COLON_COLON] = ACTIONS(2879),
    [anon_sym_AMP] = ACTIONS(2877),
    [anon_sym_LBRACK] = ACTIONS(2877),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2879),
    [anon_sym_LBRACE] = ACTIONS(2877),
    [anon_sym_LT_AT] = ACTIONS(2877),
    [anon_sym_LT_AT_AT] = ACTIONS(2877),
    [anon_sym_DOT] = ACTIONS(2877),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2879),
    [anon_sym_new] = ACTIONS(2877),
    [anon_sym_return_BANG] = ACTIONS(2879),
    [anon_sym_yield] = ACTIONS(2877),
    [anon_sym_yield_BANG] = ACTIONS(2879),
    [anon_sym_lazy] = ACTIONS(2877),
    [anon_sym_assert] = ACTIONS(2877),
    [anon_sym_upcast] = ACTIONS(2877),
    [anon_sym_downcast] = ACTIONS(2877),
    [anon_sym_COLON_GT] = ACTIONS(2879),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2879),
    [anon_sym_for] = ACTIONS(2877),
    [anon_sym_while] = ACTIONS(2877),
    [anon_sym_if] = ACTIONS(2877),
    [anon_sym_fun] = ACTIONS(2877),
    [anon_sym_DASH_GT] = ACTIONS(2877),
    [anon_sym_try] = ACTIONS(2877),
    [anon_sym_match] = ACTIONS(2877),
    [anon_sym_match_BANG] = ACTIONS(2879),
    [anon_sym_function] = ACTIONS(2877),
    [anon_sym_LT_DASH] = ACTIONS(2877),
    [anon_sym_DOT_LBRACK] = ACTIONS(2879),
    [anon_sym_LT] = ACTIONS(2879),
    [anon_sym_use] = ACTIONS(2877),
    [anon_sym_use_BANG] = ACTIONS(2879),
    [anon_sym_do_BANG] = ACTIONS(2879),
    [anon_sym_DOT_DOT] = ACTIONS(2879),
    [anon_sym_begin] = ACTIONS(2877),
    [anon_sym_LPAREN2] = ACTIONS(2877),
    [anon_sym_or] = ACTIONS(2877),
    [aux_sym_char_token1] = ACTIONS(2879),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2877),
    [anon_sym_DQUOTE] = ACTIONS(2877),
    [anon_sym_AT_DQUOTE] = ACTIONS(2879),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2879),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2879),
    [sym_bool] = ACTIONS(2877),
    [sym_unit] = ACTIONS(2879),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2877),
    [sym_op_identifier] = ACTIONS(2877),
    [anon_sym_PLUS] = ACTIONS(2877),
    [anon_sym_DASH] = ACTIONS(2877),
    [anon_sym_PLUS_DOT] = ACTIONS(2877),
    [anon_sym_DASH_DOT] = ACTIONS(2877),
    [anon_sym_PERCENT] = ACTIONS(2877),
    [anon_sym_AMP_AMP] = ACTIONS(2877),
    [anon_sym_TILDE] = ACTIONS(2879),
    [aux_sym_prefix_op_token1] = ACTIONS(2877),
    [aux_sym_infix_op_token1] = ACTIONS(2879),
    [aux_sym_infix_op_token2] = ACTIONS(2877),
    [anon_sym_PIPE_PIPE] = ACTIONS(2877),
    [anon_sym_BANG_EQ] = ACTIONS(2877),
    [anon_sym_COLON_EQ] = ACTIONS(2879),
    [anon_sym_DOLLAR] = ACTIONS(2877),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2877),
    [sym_int] = ACTIONS(2877),
    [sym_xint] = ACTIONS(2879),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2879),
    [sym__newline] = ACTIONS(2879),
  },
  [1866] = {
    [sym_block_comment] = STATE(1866),
    [sym_compiler_directive_decl] = STATE(1866),
    [sym_fsi_directive_decl] = STATE(1866),
    [sym_preproc_line] = STATE(1866),
    [sym_identifier] = ACTIONS(3095),
    [anon_sym_EQ] = ACTIONS(3097),
    [anon_sym_COLON] = ACTIONS(3095),
    [anon_sym_return] = ACTIONS(3095),
    [anon_sym_do] = ACTIONS(3095),
    [anon_sym_let] = ACTIONS(3095),
    [anon_sym_let_BANG] = ACTIONS(3097),
    [anon_sym_LPAREN] = ACTIONS(3095),
    [anon_sym_COMMA] = ACTIONS(3097),
    [anon_sym_null] = ACTIONS(3095),
    [anon_sym_QMARK] = ACTIONS(3095),
    [anon_sym_COLON_QMARK] = ACTIONS(3095),
    [anon_sym_COLON_COLON] = ACTIONS(3097),
    [anon_sym_AMP] = ACTIONS(3095),
    [anon_sym_LBRACK] = ACTIONS(3095),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3097),
    [anon_sym_LBRACE] = ACTIONS(3095),
    [anon_sym_LT_AT] = ACTIONS(3095),
    [anon_sym_LT_AT_AT] = ACTIONS(3095),
    [anon_sym_DOT] = ACTIONS(3095),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3097),
    [anon_sym_new] = ACTIONS(3095),
    [anon_sym_return_BANG] = ACTIONS(3097),
    [anon_sym_yield] = ACTIONS(3095),
    [anon_sym_yield_BANG] = ACTIONS(3097),
    [anon_sym_lazy] = ACTIONS(3095),
    [anon_sym_assert] = ACTIONS(3095),
    [anon_sym_upcast] = ACTIONS(3095),
    [anon_sym_downcast] = ACTIONS(3095),
    [anon_sym_COLON_GT] = ACTIONS(3097),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3097),
    [anon_sym_for] = ACTIONS(3095),
    [anon_sym_while] = ACTIONS(3095),
    [anon_sym_if] = ACTIONS(3095),
    [anon_sym_fun] = ACTIONS(3095),
    [anon_sym_try] = ACTIONS(3095),
    [anon_sym_match] = ACTIONS(3095),
    [anon_sym_match_BANG] = ACTIONS(3097),
    [anon_sym_function] = ACTIONS(3095),
    [anon_sym_LT_DASH] = ACTIONS(3095),
    [anon_sym_DOT_LBRACK] = ACTIONS(3097),
    [anon_sym_LT] = ACTIONS(3097),
    [anon_sym_use] = ACTIONS(3095),
    [anon_sym_use_BANG] = ACTIONS(3097),
    [anon_sym_do_BANG] = ACTIONS(3097),
    [anon_sym_begin] = ACTIONS(3095),
    [anon_sym_LPAREN2] = ACTIONS(3095),
    [anon_sym_or] = ACTIONS(3095),
    [aux_sym_char_token1] = ACTIONS(3097),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3095),
    [anon_sym_DQUOTE] = ACTIONS(3095),
    [anon_sym_AT_DQUOTE] = ACTIONS(3097),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3097),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3097),
    [sym_bool] = ACTIONS(3095),
    [sym_unit] = ACTIONS(3097),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3095),
    [sym_op_identifier] = ACTIONS(3095),
    [anon_sym_PLUS] = ACTIONS(3095),
    [anon_sym_DASH] = ACTIONS(3095),
    [anon_sym_PLUS_DOT] = ACTIONS(3095),
    [anon_sym_DASH_DOT] = ACTIONS(3095),
    [anon_sym_PERCENT] = ACTIONS(3095),
    [anon_sym_AMP_AMP] = ACTIONS(3095),
    [anon_sym_TILDE] = ACTIONS(3097),
    [aux_sym_prefix_op_token1] = ACTIONS(3095),
    [aux_sym_infix_op_token1] = ACTIONS(3097),
    [aux_sym_infix_op_token2] = ACTIONS(3095),
    [anon_sym_PIPE_PIPE] = ACTIONS(3095),
    [anon_sym_BANG_EQ] = ACTIONS(3095),
    [anon_sym_COLON_EQ] = ACTIONS(3097),
    [anon_sym_DOLLAR] = ACTIONS(3095),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3095),
    [sym_int] = ACTIONS(3095),
    [sym_xint] = ACTIONS(3097),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3097),
    [anon_sym_POUNDendif] = ACTIONS(3097),
    [anon_sym_POUNDelse] = ACTIONS(3097),
    [sym__newline] = ACTIONS(3097),
  },
  [1867] = {
    [sym_block_comment] = STATE(1867),
    [sym_compiler_directive_decl] = STATE(1867),
    [sym_fsi_directive_decl] = STATE(1867),
    [sym_preproc_line] = STATE(1867),
    [sym_identifier] = ACTIONS(2887),
    [anon_sym_EQ] = ACTIONS(2889),
    [anon_sym_COLON] = ACTIONS(2887),
    [anon_sym_return] = ACTIONS(2887),
    [anon_sym_do] = ACTIONS(2887),
    [anon_sym_let] = ACTIONS(2887),
    [anon_sym_let_BANG] = ACTIONS(2889),
    [anon_sym_LPAREN] = ACTIONS(2887),
    [anon_sym_COMMA] = ACTIONS(2889),
    [anon_sym_null] = ACTIONS(2887),
    [anon_sym_QMARK] = ACTIONS(2887),
    [anon_sym_COLON_QMARK] = ACTIONS(2887),
    [anon_sym_COLON_COLON] = ACTIONS(2889),
    [anon_sym_AMP] = ACTIONS(2887),
    [anon_sym_LBRACK] = ACTIONS(2887),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2889),
    [anon_sym_LBRACE] = ACTIONS(2887),
    [anon_sym_LT_AT] = ACTIONS(2887),
    [anon_sym_LT_AT_AT] = ACTIONS(2887),
    [anon_sym_DOT] = ACTIONS(2887),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2889),
    [anon_sym_new] = ACTIONS(2887),
    [anon_sym_return_BANG] = ACTIONS(2889),
    [anon_sym_yield] = ACTIONS(2887),
    [anon_sym_yield_BANG] = ACTIONS(2889),
    [anon_sym_lazy] = ACTIONS(2887),
    [anon_sym_assert] = ACTIONS(2887),
    [anon_sym_upcast] = ACTIONS(2887),
    [anon_sym_downcast] = ACTIONS(2887),
    [anon_sym_COLON_GT] = ACTIONS(2889),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2889),
    [anon_sym_for] = ACTIONS(2887),
    [anon_sym_while] = ACTIONS(2887),
    [anon_sym_if] = ACTIONS(2887),
    [anon_sym_fun] = ACTIONS(2887),
    [anon_sym_DASH_GT] = ACTIONS(2887),
    [anon_sym_try] = ACTIONS(2887),
    [anon_sym_match] = ACTIONS(2887),
    [anon_sym_match_BANG] = ACTIONS(2889),
    [anon_sym_function] = ACTIONS(2887),
    [anon_sym_LT_DASH] = ACTIONS(2887),
    [anon_sym_DOT_LBRACK] = ACTIONS(2889),
    [anon_sym_LT] = ACTIONS(2889),
    [anon_sym_use] = ACTIONS(2887),
    [anon_sym_use_BANG] = ACTIONS(2889),
    [anon_sym_do_BANG] = ACTIONS(2889),
    [anon_sym_DOT_DOT] = ACTIONS(2889),
    [anon_sym_begin] = ACTIONS(2887),
    [anon_sym_LPAREN2] = ACTIONS(2887),
    [anon_sym_or] = ACTIONS(2887),
    [aux_sym_char_token1] = ACTIONS(2889),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2887),
    [anon_sym_DQUOTE] = ACTIONS(2887),
    [anon_sym_AT_DQUOTE] = ACTIONS(2889),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2889),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2889),
    [sym_bool] = ACTIONS(2887),
    [sym_unit] = ACTIONS(2889),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2887),
    [sym_op_identifier] = ACTIONS(2887),
    [anon_sym_PLUS] = ACTIONS(2887),
    [anon_sym_DASH] = ACTIONS(2887),
    [anon_sym_PLUS_DOT] = ACTIONS(2887),
    [anon_sym_DASH_DOT] = ACTIONS(2887),
    [anon_sym_PERCENT] = ACTIONS(2887),
    [anon_sym_AMP_AMP] = ACTIONS(2887),
    [anon_sym_TILDE] = ACTIONS(2889),
    [aux_sym_prefix_op_token1] = ACTIONS(2887),
    [aux_sym_infix_op_token1] = ACTIONS(2889),
    [aux_sym_infix_op_token2] = ACTIONS(2887),
    [anon_sym_PIPE_PIPE] = ACTIONS(2887),
    [anon_sym_BANG_EQ] = ACTIONS(2887),
    [anon_sym_COLON_EQ] = ACTIONS(2889),
    [anon_sym_DOLLAR] = ACTIONS(2887),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2887),
    [sym_int] = ACTIONS(2887),
    [sym_xint] = ACTIONS(2889),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2889),
    [sym__newline] = ACTIONS(2889),
  },
  [1868] = {
    [sym_block_comment] = STATE(1868),
    [sym_compiler_directive_decl] = STATE(1868),
    [sym_fsi_directive_decl] = STATE(1868),
    [sym_preproc_line] = STATE(1868),
    [sym_identifier] = ACTIONS(2804),
    [anon_sym_EQ] = ACTIONS(2806),
    [anon_sym_COLON] = ACTIONS(2804),
    [anon_sym_return] = ACTIONS(2804),
    [anon_sym_do] = ACTIONS(2804),
    [anon_sym_let] = ACTIONS(2804),
    [anon_sym_let_BANG] = ACTIONS(2806),
    [anon_sym_LPAREN] = ACTIONS(2804),
    [anon_sym_COMMA] = ACTIONS(2806),
    [anon_sym_null] = ACTIONS(2804),
    [anon_sym_QMARK] = ACTIONS(2804),
    [anon_sym_COLON_QMARK] = ACTIONS(2804),
    [anon_sym_COLON_COLON] = ACTIONS(2806),
    [anon_sym_AMP] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2804),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(2804),
    [anon_sym_LT_AT] = ACTIONS(2804),
    [anon_sym_LT_AT_AT] = ACTIONS(2804),
    [anon_sym_DOT] = ACTIONS(2804),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2806),
    [anon_sym_new] = ACTIONS(2804),
    [anon_sym_return_BANG] = ACTIONS(2806),
    [anon_sym_yield] = ACTIONS(2804),
    [anon_sym_yield_BANG] = ACTIONS(2806),
    [anon_sym_lazy] = ACTIONS(2804),
    [anon_sym_assert] = ACTIONS(2804),
    [anon_sym_upcast] = ACTIONS(2804),
    [anon_sym_downcast] = ACTIONS(2804),
    [anon_sym_COLON_GT] = ACTIONS(2806),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2806),
    [anon_sym_for] = ACTIONS(2804),
    [anon_sym_done] = ACTIONS(4135),
    [anon_sym_while] = ACTIONS(2804),
    [anon_sym_if] = ACTIONS(2804),
    [anon_sym_fun] = ACTIONS(2804),
    [anon_sym_try] = ACTIONS(2804),
    [anon_sym_match] = ACTIONS(2804),
    [anon_sym_match_BANG] = ACTIONS(2806),
    [anon_sym_function] = ACTIONS(2804),
    [anon_sym_LT_DASH] = ACTIONS(2804),
    [anon_sym_DOT_LBRACK] = ACTIONS(2806),
    [anon_sym_LT] = ACTIONS(2806),
    [anon_sym_use] = ACTIONS(2804),
    [anon_sym_use_BANG] = ACTIONS(2806),
    [anon_sym_do_BANG] = ACTIONS(2806),
    [anon_sym_begin] = ACTIONS(2804),
    [anon_sym_LPAREN2] = ACTIONS(2804),
    [anon_sym_or] = ACTIONS(2804),
    [aux_sym_char_token1] = ACTIONS(2806),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2804),
    [anon_sym_DQUOTE] = ACTIONS(2804),
    [anon_sym_AT_DQUOTE] = ACTIONS(2806),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2806),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2806),
    [sym_bool] = ACTIONS(2804),
    [sym_unit] = ACTIONS(2806),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2804),
    [sym_op_identifier] = ACTIONS(2804),
    [anon_sym_PLUS] = ACTIONS(2804),
    [anon_sym_DASH] = ACTIONS(2804),
    [anon_sym_PLUS_DOT] = ACTIONS(2804),
    [anon_sym_DASH_DOT] = ACTIONS(2804),
    [anon_sym_PERCENT] = ACTIONS(2804),
    [anon_sym_AMP_AMP] = ACTIONS(2804),
    [anon_sym_TILDE] = ACTIONS(2806),
    [aux_sym_prefix_op_token1] = ACTIONS(2804),
    [aux_sym_infix_op_token1] = ACTIONS(2806),
    [aux_sym_infix_op_token2] = ACTIONS(2804),
    [anon_sym_PIPE_PIPE] = ACTIONS(2804),
    [anon_sym_BANG_EQ] = ACTIONS(2804),
    [anon_sym_COLON_EQ] = ACTIONS(2806),
    [anon_sym_DOLLAR] = ACTIONS(2804),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2804),
    [sym_int] = ACTIONS(2804),
    [sym_xint] = ACTIONS(2806),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2806),
    [anon_sym_POUNDendif] = ACTIONS(2806),
    [sym__newline] = ACTIONS(2806),
  },
  [1869] = {
    [sym_block_comment] = STATE(1869),
    [sym_compiler_directive_decl] = STATE(1869),
    [sym_fsi_directive_decl] = STATE(1869),
    [sym_preproc_line] = STATE(1869),
    [sym_identifier] = ACTIONS(2891),
    [anon_sym_EQ] = ACTIONS(2893),
    [anon_sym_COLON] = ACTIONS(2891),
    [anon_sym_return] = ACTIONS(2891),
    [anon_sym_do] = ACTIONS(2891),
    [anon_sym_let] = ACTIONS(2891),
    [anon_sym_let_BANG] = ACTIONS(2893),
    [anon_sym_LPAREN] = ACTIONS(2891),
    [anon_sym_COMMA] = ACTIONS(2893),
    [anon_sym_null] = ACTIONS(2891),
    [anon_sym_QMARK] = ACTIONS(2891),
    [anon_sym_COLON_QMARK] = ACTIONS(2891),
    [anon_sym_COLON_COLON] = ACTIONS(2893),
    [anon_sym_AMP] = ACTIONS(2891),
    [anon_sym_LBRACK] = ACTIONS(2891),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2893),
    [anon_sym_LBRACE] = ACTIONS(2891),
    [anon_sym_LT_AT] = ACTIONS(2891),
    [anon_sym_LT_AT_AT] = ACTIONS(2891),
    [anon_sym_DOT] = ACTIONS(2891),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2893),
    [anon_sym_new] = ACTIONS(2891),
    [anon_sym_return_BANG] = ACTIONS(2893),
    [anon_sym_yield] = ACTIONS(2891),
    [anon_sym_yield_BANG] = ACTIONS(2893),
    [anon_sym_lazy] = ACTIONS(2891),
    [anon_sym_assert] = ACTIONS(2891),
    [anon_sym_upcast] = ACTIONS(2891),
    [anon_sym_downcast] = ACTIONS(2891),
    [anon_sym_COLON_GT] = ACTIONS(2893),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2893),
    [anon_sym_for] = ACTIONS(2891),
    [anon_sym_while] = ACTIONS(2891),
    [anon_sym_if] = ACTIONS(2891),
    [anon_sym_fun] = ACTIONS(2891),
    [anon_sym_DASH_GT] = ACTIONS(2891),
    [anon_sym_try] = ACTIONS(2891),
    [anon_sym_match] = ACTIONS(2891),
    [anon_sym_match_BANG] = ACTIONS(2893),
    [anon_sym_function] = ACTIONS(2891),
    [anon_sym_LT_DASH] = ACTIONS(2891),
    [anon_sym_DOT_LBRACK] = ACTIONS(2893),
    [anon_sym_LT] = ACTIONS(2893),
    [anon_sym_use] = ACTIONS(2891),
    [anon_sym_use_BANG] = ACTIONS(2893),
    [anon_sym_do_BANG] = ACTIONS(2893),
    [anon_sym_DOT_DOT] = ACTIONS(2893),
    [anon_sym_begin] = ACTIONS(2891),
    [anon_sym_LPAREN2] = ACTIONS(2891),
    [anon_sym_or] = ACTIONS(2891),
    [aux_sym_char_token1] = ACTIONS(2893),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2891),
    [anon_sym_DQUOTE] = ACTIONS(2891),
    [anon_sym_AT_DQUOTE] = ACTIONS(2893),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2893),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2893),
    [sym_bool] = ACTIONS(2891),
    [sym_unit] = ACTIONS(2893),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2891),
    [sym_op_identifier] = ACTIONS(2891),
    [anon_sym_PLUS] = ACTIONS(2891),
    [anon_sym_DASH] = ACTIONS(2891),
    [anon_sym_PLUS_DOT] = ACTIONS(2891),
    [anon_sym_DASH_DOT] = ACTIONS(2891),
    [anon_sym_PERCENT] = ACTIONS(2891),
    [anon_sym_AMP_AMP] = ACTIONS(2891),
    [anon_sym_TILDE] = ACTIONS(2893),
    [aux_sym_prefix_op_token1] = ACTIONS(2891),
    [aux_sym_infix_op_token1] = ACTIONS(2893),
    [aux_sym_infix_op_token2] = ACTIONS(2891),
    [anon_sym_PIPE_PIPE] = ACTIONS(2891),
    [anon_sym_BANG_EQ] = ACTIONS(2891),
    [anon_sym_COLON_EQ] = ACTIONS(2893),
    [anon_sym_DOLLAR] = ACTIONS(2891),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2891),
    [sym_int] = ACTIONS(2891),
    [sym_xint] = ACTIONS(2893),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2893),
    [sym__newline] = ACTIONS(2893),
  },
  [1870] = {
    [sym_block_comment] = STATE(1870),
    [sym_compiler_directive_decl] = STATE(1870),
    [sym_fsi_directive_decl] = STATE(1870),
    [sym_preproc_line] = STATE(1870),
    [sym_identifier] = ACTIONS(2910),
    [anon_sym_EQ] = ACTIONS(2912),
    [anon_sym_COLON] = ACTIONS(2910),
    [anon_sym_return] = ACTIONS(2910),
    [anon_sym_do] = ACTIONS(2910),
    [anon_sym_let] = ACTIONS(2910),
    [anon_sym_let_BANG] = ACTIONS(2912),
    [anon_sym_LPAREN] = ACTIONS(2910),
    [anon_sym_COMMA] = ACTIONS(2912),
    [anon_sym_null] = ACTIONS(2910),
    [anon_sym_QMARK] = ACTIONS(2910),
    [anon_sym_COLON_QMARK] = ACTIONS(2910),
    [anon_sym_COLON_COLON] = ACTIONS(2912),
    [anon_sym_AMP] = ACTIONS(2910),
    [anon_sym_LBRACK] = ACTIONS(2910),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2912),
    [anon_sym_LBRACE] = ACTIONS(2910),
    [anon_sym_LT_AT] = ACTIONS(2910),
    [anon_sym_LT_AT_AT] = ACTIONS(2910),
    [anon_sym_DOT] = ACTIONS(2910),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2912),
    [anon_sym_new] = ACTIONS(2910),
    [anon_sym_return_BANG] = ACTIONS(2912),
    [anon_sym_yield] = ACTIONS(2910),
    [anon_sym_yield_BANG] = ACTIONS(2912),
    [anon_sym_lazy] = ACTIONS(2910),
    [anon_sym_assert] = ACTIONS(2910),
    [anon_sym_upcast] = ACTIONS(2910),
    [anon_sym_downcast] = ACTIONS(2910),
    [anon_sym_COLON_GT] = ACTIONS(2912),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2912),
    [anon_sym_for] = ACTIONS(2910),
    [anon_sym_while] = ACTIONS(2910),
    [anon_sym_if] = ACTIONS(2910),
    [anon_sym_fun] = ACTIONS(2910),
    [anon_sym_DASH_GT] = ACTIONS(2910),
    [anon_sym_try] = ACTIONS(2910),
    [anon_sym_match] = ACTIONS(2910),
    [anon_sym_match_BANG] = ACTIONS(2912),
    [anon_sym_function] = ACTIONS(2910),
    [anon_sym_LT_DASH] = ACTIONS(2910),
    [anon_sym_DOT_LBRACK] = ACTIONS(2912),
    [anon_sym_LT] = ACTIONS(2912),
    [anon_sym_use] = ACTIONS(2910),
    [anon_sym_use_BANG] = ACTIONS(2912),
    [anon_sym_do_BANG] = ACTIONS(2912),
    [anon_sym_DOT_DOT] = ACTIONS(2912),
    [anon_sym_begin] = ACTIONS(2910),
    [anon_sym_LPAREN2] = ACTIONS(2910),
    [anon_sym_or] = ACTIONS(2910),
    [aux_sym_char_token1] = ACTIONS(2912),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2910),
    [anon_sym_DQUOTE] = ACTIONS(2910),
    [anon_sym_AT_DQUOTE] = ACTIONS(2912),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2912),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2912),
    [sym_bool] = ACTIONS(2910),
    [sym_unit] = ACTIONS(2912),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2910),
    [sym_op_identifier] = ACTIONS(2910),
    [anon_sym_PLUS] = ACTIONS(2910),
    [anon_sym_DASH] = ACTIONS(2910),
    [anon_sym_PLUS_DOT] = ACTIONS(2910),
    [anon_sym_DASH_DOT] = ACTIONS(2910),
    [anon_sym_PERCENT] = ACTIONS(2910),
    [anon_sym_AMP_AMP] = ACTIONS(2910),
    [anon_sym_TILDE] = ACTIONS(2912),
    [aux_sym_prefix_op_token1] = ACTIONS(2910),
    [aux_sym_infix_op_token1] = ACTIONS(2912),
    [aux_sym_infix_op_token2] = ACTIONS(2910),
    [anon_sym_PIPE_PIPE] = ACTIONS(2910),
    [anon_sym_BANG_EQ] = ACTIONS(2910),
    [anon_sym_COLON_EQ] = ACTIONS(2912),
    [anon_sym_DOLLAR] = ACTIONS(2910),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2910),
    [sym_int] = ACTIONS(2910),
    [sym_xint] = ACTIONS(2912),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2912),
    [sym__newline] = ACTIONS(2912),
  },
  [1871] = {
    [sym_block_comment] = STATE(1871),
    [sym_compiler_directive_decl] = STATE(1871),
    [sym_fsi_directive_decl] = STATE(1871),
    [sym_preproc_line] = STATE(1871),
    [sym_identifier] = ACTIONS(2783),
    [anon_sym_EQ] = ACTIONS(2785),
    [anon_sym_COLON] = ACTIONS(2783),
    [anon_sym_return] = ACTIONS(2783),
    [anon_sym_do] = ACTIONS(2783),
    [anon_sym_let] = ACTIONS(2783),
    [anon_sym_let_BANG] = ACTIONS(2785),
    [anon_sym_LPAREN] = ACTIONS(2783),
    [anon_sym_COMMA] = ACTIONS(2785),
    [anon_sym_null] = ACTIONS(2783),
    [anon_sym_QMARK] = ACTIONS(2783),
    [anon_sym_COLON_QMARK] = ACTIONS(2783),
    [anon_sym_COLON_COLON] = ACTIONS(2785),
    [anon_sym_AMP] = ACTIONS(2783),
    [anon_sym_LBRACK] = ACTIONS(2783),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2785),
    [anon_sym_LBRACE] = ACTIONS(2783),
    [anon_sym_LT_AT] = ACTIONS(2783),
    [anon_sym_LT_AT_AT] = ACTIONS(2783),
    [anon_sym_DOT] = ACTIONS(2783),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2785),
    [anon_sym_new] = ACTIONS(2783),
    [anon_sym_return_BANG] = ACTIONS(2785),
    [anon_sym_yield] = ACTIONS(2783),
    [anon_sym_yield_BANG] = ACTIONS(2785),
    [anon_sym_lazy] = ACTIONS(2783),
    [anon_sym_assert] = ACTIONS(2783),
    [anon_sym_upcast] = ACTIONS(2783),
    [anon_sym_downcast] = ACTIONS(2783),
    [anon_sym_COLON_GT] = ACTIONS(2785),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2785),
    [anon_sym_for] = ACTIONS(2783),
    [anon_sym_done] = ACTIONS(3951),
    [anon_sym_while] = ACTIONS(2783),
    [anon_sym_if] = ACTIONS(2783),
    [anon_sym_fun] = ACTIONS(2783),
    [anon_sym_try] = ACTIONS(2783),
    [anon_sym_match] = ACTIONS(2783),
    [anon_sym_match_BANG] = ACTIONS(2785),
    [anon_sym_function] = ACTIONS(2783),
    [anon_sym_LT_DASH] = ACTIONS(2783),
    [anon_sym_DOT_LBRACK] = ACTIONS(2785),
    [anon_sym_LT] = ACTIONS(2785),
    [anon_sym_use] = ACTIONS(2783),
    [anon_sym_use_BANG] = ACTIONS(2785),
    [anon_sym_do_BANG] = ACTIONS(2785),
    [anon_sym_begin] = ACTIONS(2783),
    [anon_sym_LPAREN2] = ACTIONS(2783),
    [anon_sym_or] = ACTIONS(2783),
    [aux_sym_char_token1] = ACTIONS(2785),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2783),
    [anon_sym_DQUOTE] = ACTIONS(2783),
    [anon_sym_AT_DQUOTE] = ACTIONS(2785),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2785),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2785),
    [sym_bool] = ACTIONS(2783),
    [sym_unit] = ACTIONS(2785),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2783),
    [sym_op_identifier] = ACTIONS(2783),
    [anon_sym_PLUS] = ACTIONS(2783),
    [anon_sym_DASH] = ACTIONS(2783),
    [anon_sym_PLUS_DOT] = ACTIONS(2783),
    [anon_sym_DASH_DOT] = ACTIONS(2783),
    [anon_sym_PERCENT] = ACTIONS(2783),
    [anon_sym_AMP_AMP] = ACTIONS(2783),
    [anon_sym_TILDE] = ACTIONS(2785),
    [aux_sym_prefix_op_token1] = ACTIONS(2783),
    [aux_sym_infix_op_token1] = ACTIONS(2785),
    [aux_sym_infix_op_token2] = ACTIONS(2783),
    [anon_sym_PIPE_PIPE] = ACTIONS(2783),
    [anon_sym_BANG_EQ] = ACTIONS(2783),
    [anon_sym_COLON_EQ] = ACTIONS(2785),
    [anon_sym_DOLLAR] = ACTIONS(2783),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2783),
    [sym_int] = ACTIONS(2783),
    [sym_xint] = ACTIONS(2785),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2785),
    [anon_sym_POUNDendif] = ACTIONS(2785),
    [sym__newline] = ACTIONS(2785),
  },
  [1872] = {
    [sym_block_comment] = STATE(1872),
    [sym_compiler_directive_decl] = STATE(1872),
    [sym_fsi_directive_decl] = STATE(1872),
    [sym_preproc_line] = STATE(1872),
    [sym_identifier] = ACTIONS(2914),
    [anon_sym_EQ] = ACTIONS(2916),
    [anon_sym_COLON] = ACTIONS(2914),
    [anon_sym_return] = ACTIONS(2914),
    [anon_sym_do] = ACTIONS(2914),
    [anon_sym_let] = ACTIONS(2914),
    [anon_sym_let_BANG] = ACTIONS(2916),
    [anon_sym_LPAREN] = ACTIONS(2914),
    [anon_sym_COMMA] = ACTIONS(2916),
    [anon_sym_null] = ACTIONS(2914),
    [anon_sym_QMARK] = ACTIONS(2914),
    [anon_sym_COLON_QMARK] = ACTIONS(2914),
    [anon_sym_COLON_COLON] = ACTIONS(2916),
    [anon_sym_AMP] = ACTIONS(2914),
    [anon_sym_LBRACK] = ACTIONS(2914),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2916),
    [anon_sym_LBRACE] = ACTIONS(2914),
    [anon_sym_LT_AT] = ACTIONS(2914),
    [anon_sym_LT_AT_AT] = ACTIONS(2914),
    [anon_sym_DOT] = ACTIONS(2914),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2916),
    [anon_sym_new] = ACTIONS(2914),
    [anon_sym_return_BANG] = ACTIONS(2916),
    [anon_sym_yield] = ACTIONS(2914),
    [anon_sym_yield_BANG] = ACTIONS(2916),
    [anon_sym_lazy] = ACTIONS(2914),
    [anon_sym_assert] = ACTIONS(2914),
    [anon_sym_upcast] = ACTIONS(2914),
    [anon_sym_downcast] = ACTIONS(2914),
    [anon_sym_COLON_GT] = ACTIONS(2916),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2916),
    [anon_sym_for] = ACTIONS(2914),
    [anon_sym_while] = ACTIONS(2914),
    [anon_sym_if] = ACTIONS(2914),
    [anon_sym_fun] = ACTIONS(2914),
    [anon_sym_DASH_GT] = ACTIONS(2914),
    [anon_sym_try] = ACTIONS(2914),
    [anon_sym_match] = ACTIONS(2914),
    [anon_sym_match_BANG] = ACTIONS(2916),
    [anon_sym_function] = ACTIONS(2914),
    [anon_sym_LT_DASH] = ACTIONS(2914),
    [anon_sym_DOT_LBRACK] = ACTIONS(2916),
    [anon_sym_LT] = ACTIONS(2916),
    [anon_sym_use] = ACTIONS(2914),
    [anon_sym_use_BANG] = ACTIONS(2916),
    [anon_sym_do_BANG] = ACTIONS(2916),
    [anon_sym_DOT_DOT] = ACTIONS(2916),
    [anon_sym_begin] = ACTIONS(2914),
    [anon_sym_LPAREN2] = ACTIONS(2914),
    [anon_sym_or] = ACTIONS(2914),
    [aux_sym_char_token1] = ACTIONS(2916),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2914),
    [anon_sym_DQUOTE] = ACTIONS(2914),
    [anon_sym_AT_DQUOTE] = ACTIONS(2916),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2916),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2916),
    [sym_bool] = ACTIONS(2914),
    [sym_unit] = ACTIONS(2916),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2914),
    [sym_op_identifier] = ACTIONS(2914),
    [anon_sym_PLUS] = ACTIONS(2914),
    [anon_sym_DASH] = ACTIONS(2914),
    [anon_sym_PLUS_DOT] = ACTIONS(2914),
    [anon_sym_DASH_DOT] = ACTIONS(2914),
    [anon_sym_PERCENT] = ACTIONS(2914),
    [anon_sym_AMP_AMP] = ACTIONS(2914),
    [anon_sym_TILDE] = ACTIONS(2916),
    [aux_sym_prefix_op_token1] = ACTIONS(2914),
    [aux_sym_infix_op_token1] = ACTIONS(2916),
    [aux_sym_infix_op_token2] = ACTIONS(2914),
    [anon_sym_PIPE_PIPE] = ACTIONS(2914),
    [anon_sym_BANG_EQ] = ACTIONS(2914),
    [anon_sym_COLON_EQ] = ACTIONS(2916),
    [anon_sym_DOLLAR] = ACTIONS(2914),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2914),
    [sym_int] = ACTIONS(2914),
    [sym_xint] = ACTIONS(2916),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2916),
    [sym__newline] = ACTIONS(2916),
  },
  [1873] = {
    [sym_block_comment] = STATE(1873),
    [sym_compiler_directive_decl] = STATE(1873),
    [sym_fsi_directive_decl] = STATE(1873),
    [sym_preproc_line] = STATE(1873),
    [sym_identifier] = ACTIONS(2918),
    [anon_sym_EQ] = ACTIONS(2920),
    [anon_sym_COLON] = ACTIONS(2918),
    [anon_sym_return] = ACTIONS(2918),
    [anon_sym_do] = ACTIONS(2918),
    [anon_sym_let] = ACTIONS(2918),
    [anon_sym_let_BANG] = ACTIONS(2920),
    [anon_sym_LPAREN] = ACTIONS(2918),
    [anon_sym_COMMA] = ACTIONS(2920),
    [anon_sym_null] = ACTIONS(2918),
    [anon_sym_QMARK] = ACTIONS(2918),
    [anon_sym_COLON_QMARK] = ACTIONS(2918),
    [anon_sym_COLON_COLON] = ACTIONS(2920),
    [anon_sym_AMP] = ACTIONS(2918),
    [anon_sym_LBRACK] = ACTIONS(2918),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2920),
    [anon_sym_LBRACE] = ACTIONS(2918),
    [anon_sym_LT_AT] = ACTIONS(2918),
    [anon_sym_LT_AT_AT] = ACTIONS(2918),
    [anon_sym_DOT] = ACTIONS(2918),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2920),
    [anon_sym_new] = ACTIONS(2918),
    [anon_sym_return_BANG] = ACTIONS(2920),
    [anon_sym_yield] = ACTIONS(2918),
    [anon_sym_yield_BANG] = ACTIONS(2920),
    [anon_sym_lazy] = ACTIONS(2918),
    [anon_sym_assert] = ACTIONS(2918),
    [anon_sym_upcast] = ACTIONS(2918),
    [anon_sym_downcast] = ACTIONS(2918),
    [anon_sym_COLON_GT] = ACTIONS(2920),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2920),
    [anon_sym_for] = ACTIONS(2918),
    [anon_sym_while] = ACTIONS(2918),
    [anon_sym_if] = ACTIONS(2918),
    [anon_sym_fun] = ACTIONS(2918),
    [anon_sym_DASH_GT] = ACTIONS(2918),
    [anon_sym_try] = ACTIONS(2918),
    [anon_sym_match] = ACTIONS(2918),
    [anon_sym_match_BANG] = ACTIONS(2920),
    [anon_sym_function] = ACTIONS(2918),
    [anon_sym_LT_DASH] = ACTIONS(2918),
    [anon_sym_DOT_LBRACK] = ACTIONS(2920),
    [anon_sym_LT] = ACTIONS(2920),
    [anon_sym_use] = ACTIONS(2918),
    [anon_sym_use_BANG] = ACTIONS(2920),
    [anon_sym_do_BANG] = ACTIONS(2920),
    [anon_sym_DOT_DOT] = ACTIONS(2920),
    [anon_sym_begin] = ACTIONS(2918),
    [anon_sym_LPAREN2] = ACTIONS(2918),
    [anon_sym_or] = ACTIONS(2918),
    [aux_sym_char_token1] = ACTIONS(2920),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2918),
    [anon_sym_DQUOTE] = ACTIONS(2918),
    [anon_sym_AT_DQUOTE] = ACTIONS(2920),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2920),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2920),
    [sym_bool] = ACTIONS(2918),
    [sym_unit] = ACTIONS(2920),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2918),
    [sym_op_identifier] = ACTIONS(2918),
    [anon_sym_PLUS] = ACTIONS(2918),
    [anon_sym_DASH] = ACTIONS(2918),
    [anon_sym_PLUS_DOT] = ACTIONS(2918),
    [anon_sym_DASH_DOT] = ACTIONS(2918),
    [anon_sym_PERCENT] = ACTIONS(2918),
    [anon_sym_AMP_AMP] = ACTIONS(2918),
    [anon_sym_TILDE] = ACTIONS(2920),
    [aux_sym_prefix_op_token1] = ACTIONS(2918),
    [aux_sym_infix_op_token1] = ACTIONS(2920),
    [aux_sym_infix_op_token2] = ACTIONS(2918),
    [anon_sym_PIPE_PIPE] = ACTIONS(2918),
    [anon_sym_BANG_EQ] = ACTIONS(2918),
    [anon_sym_COLON_EQ] = ACTIONS(2920),
    [anon_sym_DOLLAR] = ACTIONS(2918),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2918),
    [sym_int] = ACTIONS(2918),
    [sym_xint] = ACTIONS(2920),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2920),
    [sym__newline] = ACTIONS(2920),
  },
  [1874] = {
    [sym_block_comment] = STATE(1874),
    [sym_compiler_directive_decl] = STATE(1874),
    [sym_fsi_directive_decl] = STATE(1874),
    [sym_preproc_line] = STATE(1874),
    [sym_identifier] = ACTIONS(2922),
    [anon_sym_EQ] = ACTIONS(2924),
    [anon_sym_COLON] = ACTIONS(2922),
    [anon_sym_return] = ACTIONS(2922),
    [anon_sym_do] = ACTIONS(2922),
    [anon_sym_let] = ACTIONS(2922),
    [anon_sym_let_BANG] = ACTIONS(2924),
    [anon_sym_LPAREN] = ACTIONS(2922),
    [anon_sym_COMMA] = ACTIONS(2924),
    [anon_sym_null] = ACTIONS(2922),
    [anon_sym_QMARK] = ACTIONS(2922),
    [anon_sym_COLON_QMARK] = ACTIONS(2922),
    [anon_sym_COLON_COLON] = ACTIONS(2924),
    [anon_sym_AMP] = ACTIONS(2922),
    [anon_sym_LBRACK] = ACTIONS(2922),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2924),
    [anon_sym_LBRACE] = ACTIONS(2922),
    [anon_sym_LT_AT] = ACTIONS(2922),
    [anon_sym_LT_AT_AT] = ACTIONS(2922),
    [anon_sym_DOT] = ACTIONS(2922),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2924),
    [anon_sym_new] = ACTIONS(2922),
    [anon_sym_return_BANG] = ACTIONS(2924),
    [anon_sym_yield] = ACTIONS(2922),
    [anon_sym_yield_BANG] = ACTIONS(2924),
    [anon_sym_lazy] = ACTIONS(2922),
    [anon_sym_assert] = ACTIONS(2922),
    [anon_sym_upcast] = ACTIONS(2922),
    [anon_sym_downcast] = ACTIONS(2922),
    [anon_sym_COLON_GT] = ACTIONS(2924),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2924),
    [anon_sym_for] = ACTIONS(2922),
    [anon_sym_while] = ACTIONS(2922),
    [anon_sym_if] = ACTIONS(2922),
    [anon_sym_fun] = ACTIONS(2922),
    [anon_sym_DASH_GT] = ACTIONS(2922),
    [anon_sym_try] = ACTIONS(2922),
    [anon_sym_match] = ACTIONS(2922),
    [anon_sym_match_BANG] = ACTIONS(2924),
    [anon_sym_function] = ACTIONS(2922),
    [anon_sym_LT_DASH] = ACTIONS(2922),
    [anon_sym_DOT_LBRACK] = ACTIONS(2924),
    [anon_sym_LT] = ACTIONS(2924),
    [anon_sym_use] = ACTIONS(2922),
    [anon_sym_use_BANG] = ACTIONS(2924),
    [anon_sym_do_BANG] = ACTIONS(2924),
    [anon_sym_DOT_DOT] = ACTIONS(2924),
    [anon_sym_begin] = ACTIONS(2922),
    [anon_sym_LPAREN2] = ACTIONS(2922),
    [anon_sym_or] = ACTIONS(2922),
    [aux_sym_char_token1] = ACTIONS(2924),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2922),
    [anon_sym_DQUOTE] = ACTIONS(2922),
    [anon_sym_AT_DQUOTE] = ACTIONS(2924),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2924),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2924),
    [sym_bool] = ACTIONS(2922),
    [sym_unit] = ACTIONS(2924),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2922),
    [sym_op_identifier] = ACTIONS(2922),
    [anon_sym_PLUS] = ACTIONS(2922),
    [anon_sym_DASH] = ACTIONS(2922),
    [anon_sym_PLUS_DOT] = ACTIONS(2922),
    [anon_sym_DASH_DOT] = ACTIONS(2922),
    [anon_sym_PERCENT] = ACTIONS(2922),
    [anon_sym_AMP_AMP] = ACTIONS(2922),
    [anon_sym_TILDE] = ACTIONS(2924),
    [aux_sym_prefix_op_token1] = ACTIONS(2922),
    [aux_sym_infix_op_token1] = ACTIONS(2924),
    [aux_sym_infix_op_token2] = ACTIONS(2922),
    [anon_sym_PIPE_PIPE] = ACTIONS(2922),
    [anon_sym_BANG_EQ] = ACTIONS(2922),
    [anon_sym_COLON_EQ] = ACTIONS(2924),
    [anon_sym_DOLLAR] = ACTIONS(2922),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2922),
    [sym_int] = ACTIONS(2922),
    [sym_xint] = ACTIONS(2924),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2924),
    [sym__newline] = ACTIONS(2924),
  },
  [1875] = {
    [sym_block_comment] = STATE(1875),
    [sym_compiler_directive_decl] = STATE(1875),
    [sym_fsi_directive_decl] = STATE(1875),
    [sym_preproc_line] = STATE(1875),
    [sym_identifier] = ACTIONS(2770),
    [anon_sym_EQ] = ACTIONS(2772),
    [anon_sym_COLON] = ACTIONS(2770),
    [anon_sym_return] = ACTIONS(2770),
    [anon_sym_do] = ACTIONS(2770),
    [anon_sym_let] = ACTIONS(2770),
    [anon_sym_let_BANG] = ACTIONS(2772),
    [anon_sym_LPAREN] = ACTIONS(2770),
    [anon_sym_COMMA] = ACTIONS(2772),
    [anon_sym_null] = ACTIONS(2770),
    [anon_sym_QMARK] = ACTIONS(2770),
    [anon_sym_COLON_QMARK] = ACTIONS(2770),
    [anon_sym_COLON_COLON] = ACTIONS(2772),
    [anon_sym_AMP] = ACTIONS(2770),
    [anon_sym_LBRACK] = ACTIONS(2770),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2772),
    [anon_sym_LBRACE] = ACTIONS(2770),
    [anon_sym_LT_AT] = ACTIONS(2770),
    [anon_sym_LT_AT_AT] = ACTIONS(2770),
    [anon_sym_DOT] = ACTIONS(2770),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2772),
    [anon_sym_new] = ACTIONS(2770),
    [anon_sym_return_BANG] = ACTIONS(2772),
    [anon_sym_yield] = ACTIONS(2770),
    [anon_sym_yield_BANG] = ACTIONS(2772),
    [anon_sym_lazy] = ACTIONS(2770),
    [anon_sym_assert] = ACTIONS(2770),
    [anon_sym_upcast] = ACTIONS(2770),
    [anon_sym_downcast] = ACTIONS(2770),
    [anon_sym_COLON_GT] = ACTIONS(2772),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2772),
    [anon_sym_for] = ACTIONS(2770),
    [anon_sym_done] = ACTIONS(4137),
    [anon_sym_while] = ACTIONS(2770),
    [anon_sym_if] = ACTIONS(2770),
    [anon_sym_fun] = ACTIONS(2770),
    [anon_sym_try] = ACTIONS(2770),
    [anon_sym_match] = ACTIONS(2770),
    [anon_sym_match_BANG] = ACTIONS(2772),
    [anon_sym_function] = ACTIONS(2770),
    [anon_sym_LT_DASH] = ACTIONS(2770),
    [anon_sym_DOT_LBRACK] = ACTIONS(2772),
    [anon_sym_LT] = ACTIONS(2772),
    [anon_sym_use] = ACTIONS(2770),
    [anon_sym_use_BANG] = ACTIONS(2772),
    [anon_sym_do_BANG] = ACTIONS(2772),
    [anon_sym_begin] = ACTIONS(2770),
    [anon_sym_LPAREN2] = ACTIONS(2770),
    [anon_sym_or] = ACTIONS(2770),
    [aux_sym_char_token1] = ACTIONS(2772),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2770),
    [anon_sym_DQUOTE] = ACTIONS(2770),
    [anon_sym_AT_DQUOTE] = ACTIONS(2772),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2772),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2772),
    [sym_bool] = ACTIONS(2770),
    [sym_unit] = ACTIONS(2772),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2770),
    [sym_op_identifier] = ACTIONS(2770),
    [anon_sym_PLUS] = ACTIONS(2770),
    [anon_sym_DASH] = ACTIONS(2770),
    [anon_sym_PLUS_DOT] = ACTIONS(2770),
    [anon_sym_DASH_DOT] = ACTIONS(2770),
    [anon_sym_PERCENT] = ACTIONS(2770),
    [anon_sym_AMP_AMP] = ACTIONS(2770),
    [anon_sym_TILDE] = ACTIONS(2772),
    [aux_sym_prefix_op_token1] = ACTIONS(2770),
    [aux_sym_infix_op_token1] = ACTIONS(2772),
    [aux_sym_infix_op_token2] = ACTIONS(2770),
    [anon_sym_PIPE_PIPE] = ACTIONS(2770),
    [anon_sym_BANG_EQ] = ACTIONS(2770),
    [anon_sym_COLON_EQ] = ACTIONS(2772),
    [anon_sym_DOLLAR] = ACTIONS(2770),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2770),
    [sym_int] = ACTIONS(2770),
    [sym_xint] = ACTIONS(2772),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2772),
    [anon_sym_POUNDendif] = ACTIONS(2772),
    [sym__newline] = ACTIONS(2772),
  },
  [1876] = {
    [sym_block_comment] = STATE(1876),
    [sym_compiler_directive_decl] = STATE(1876),
    [sym_fsi_directive_decl] = STATE(1876),
    [sym_preproc_line] = STATE(1876),
    [aux_sym_long_identifier_repeat1] = STATE(1914),
    [sym_identifier] = ACTIONS(2791),
    [anon_sym_EQ] = ACTIONS(2794),
    [anon_sym_COLON] = ACTIONS(2791),
    [anon_sym_return] = ACTIONS(2791),
    [anon_sym_do] = ACTIONS(2791),
    [anon_sym_let] = ACTIONS(2791),
    [anon_sym_let_BANG] = ACTIONS(2794),
    [anon_sym_LPAREN] = ACTIONS(2791),
    [anon_sym_COMMA] = ACTIONS(2794),
    [anon_sym_null] = ACTIONS(2791),
    [anon_sym_QMARK] = ACTIONS(2791),
    [anon_sym_COLON_QMARK] = ACTIONS(2791),
    [anon_sym_COLON_COLON] = ACTIONS(2794),
    [anon_sym_AMP] = ACTIONS(2791),
    [anon_sym_LBRACK] = ACTIONS(2791),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2794),
    [anon_sym_LBRACE] = ACTIONS(2791),
    [anon_sym_LT_AT] = ACTIONS(2791),
    [anon_sym_LT_AT_AT] = ACTIONS(2791),
    [anon_sym_AT_AT_GT] = ACTIONS(2791),
    [anon_sym_DOT] = ACTIONS(4139),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2794),
    [anon_sym_new] = ACTIONS(2791),
    [anon_sym_return_BANG] = ACTIONS(2794),
    [anon_sym_yield] = ACTIONS(2791),
    [anon_sym_yield_BANG] = ACTIONS(2794),
    [anon_sym_lazy] = ACTIONS(2791),
    [anon_sym_assert] = ACTIONS(2791),
    [anon_sym_upcast] = ACTIONS(2791),
    [anon_sym_downcast] = ACTIONS(2791),
    [anon_sym_COLON_GT] = ACTIONS(2794),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2794),
    [anon_sym_for] = ACTIONS(2791),
    [anon_sym_while] = ACTIONS(2791),
    [anon_sym_if] = ACTIONS(2791),
    [anon_sym_fun] = ACTIONS(2791),
    [anon_sym_try] = ACTIONS(2791),
    [anon_sym_match] = ACTIONS(2791),
    [anon_sym_match_BANG] = ACTIONS(2794),
    [anon_sym_function] = ACTIONS(2791),
    [anon_sym_LT_DASH] = ACTIONS(2791),
    [anon_sym_DOT_LBRACK] = ACTIONS(2794),
    [anon_sym_LT] = ACTIONS(2794),
    [anon_sym_use] = ACTIONS(2791),
    [anon_sym_use_BANG] = ACTIONS(2794),
    [anon_sym_do_BANG] = ACTIONS(2794),
    [anon_sym_begin] = ACTIONS(2791),
    [anon_sym_LPAREN2] = ACTIONS(2791),
    [anon_sym_or] = ACTIONS(2791),
    [aux_sym_char_token1] = ACTIONS(2794),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2791),
    [anon_sym_DQUOTE] = ACTIONS(2791),
    [anon_sym_AT_DQUOTE] = ACTIONS(2794),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2794),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2794),
    [sym_bool] = ACTIONS(2791),
    [sym_unit] = ACTIONS(2794),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2791),
    [sym_op_identifier] = ACTIONS(2791),
    [anon_sym_PLUS] = ACTIONS(2791),
    [anon_sym_DASH] = ACTIONS(2791),
    [anon_sym_PLUS_DOT] = ACTIONS(2791),
    [anon_sym_DASH_DOT] = ACTIONS(2791),
    [anon_sym_PERCENT] = ACTIONS(2791),
    [anon_sym_AMP_AMP] = ACTIONS(2791),
    [anon_sym_TILDE] = ACTIONS(2794),
    [aux_sym_prefix_op_token1] = ACTIONS(2791),
    [aux_sym_infix_op_token1] = ACTIONS(2794),
    [aux_sym_infix_op_token2] = ACTIONS(2791),
    [anon_sym_PIPE_PIPE] = ACTIONS(2791),
    [anon_sym_BANG_EQ] = ACTIONS(2791),
    [anon_sym_COLON_EQ] = ACTIONS(2794),
    [anon_sym_DOLLAR] = ACTIONS(2791),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2791),
    [sym_int] = ACTIONS(2791),
    [sym_xint] = ACTIONS(2794),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2794),
    [sym__newline] = ACTIONS(2794),
  },
  [1877] = {
    [sym_block_comment] = STATE(1877),
    [sym_compiler_directive_decl] = STATE(1877),
    [sym_fsi_directive_decl] = STATE(1877),
    [sym_preproc_line] = STATE(1877),
    [sym_identifier] = ACTIONS(2926),
    [anon_sym_EQ] = ACTIONS(2928),
    [anon_sym_COLON] = ACTIONS(2926),
    [anon_sym_return] = ACTIONS(2926),
    [anon_sym_do] = ACTIONS(2926),
    [anon_sym_let] = ACTIONS(2926),
    [anon_sym_let_BANG] = ACTIONS(2928),
    [anon_sym_LPAREN] = ACTIONS(2926),
    [anon_sym_COMMA] = ACTIONS(2928),
    [anon_sym_null] = ACTIONS(2926),
    [anon_sym_QMARK] = ACTIONS(2926),
    [anon_sym_COLON_QMARK] = ACTIONS(2926),
    [anon_sym_COLON_COLON] = ACTIONS(2928),
    [anon_sym_AMP] = ACTIONS(2926),
    [anon_sym_LBRACK] = ACTIONS(2926),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2928),
    [anon_sym_LBRACE] = ACTIONS(2926),
    [anon_sym_LT_AT] = ACTIONS(2926),
    [anon_sym_LT_AT_AT] = ACTIONS(2926),
    [anon_sym_DOT] = ACTIONS(2926),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2928),
    [anon_sym_new] = ACTIONS(2926),
    [anon_sym_return_BANG] = ACTIONS(2928),
    [anon_sym_yield] = ACTIONS(2926),
    [anon_sym_yield_BANG] = ACTIONS(2928),
    [anon_sym_lazy] = ACTIONS(2926),
    [anon_sym_assert] = ACTIONS(2926),
    [anon_sym_upcast] = ACTIONS(2926),
    [anon_sym_downcast] = ACTIONS(2926),
    [anon_sym_COLON_GT] = ACTIONS(2928),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2928),
    [anon_sym_for] = ACTIONS(2926),
    [anon_sym_while] = ACTIONS(2926),
    [anon_sym_if] = ACTIONS(2926),
    [anon_sym_fun] = ACTIONS(2926),
    [anon_sym_DASH_GT] = ACTIONS(2926),
    [anon_sym_try] = ACTIONS(2926),
    [anon_sym_match] = ACTIONS(2926),
    [anon_sym_match_BANG] = ACTIONS(2928),
    [anon_sym_function] = ACTIONS(2926),
    [anon_sym_LT_DASH] = ACTIONS(2926),
    [anon_sym_DOT_LBRACK] = ACTIONS(2928),
    [anon_sym_LT] = ACTIONS(2928),
    [anon_sym_use] = ACTIONS(2926),
    [anon_sym_use_BANG] = ACTIONS(2928),
    [anon_sym_do_BANG] = ACTIONS(2928),
    [anon_sym_DOT_DOT] = ACTIONS(2928),
    [anon_sym_begin] = ACTIONS(2926),
    [anon_sym_LPAREN2] = ACTIONS(2926),
    [anon_sym_or] = ACTIONS(2926),
    [aux_sym_char_token1] = ACTIONS(2928),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2926),
    [anon_sym_DQUOTE] = ACTIONS(2926),
    [anon_sym_AT_DQUOTE] = ACTIONS(2928),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2928),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2928),
    [sym_bool] = ACTIONS(2926),
    [sym_unit] = ACTIONS(2928),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2926),
    [sym_op_identifier] = ACTIONS(2926),
    [anon_sym_PLUS] = ACTIONS(2926),
    [anon_sym_DASH] = ACTIONS(2926),
    [anon_sym_PLUS_DOT] = ACTIONS(2926),
    [anon_sym_DASH_DOT] = ACTIONS(2926),
    [anon_sym_PERCENT] = ACTIONS(2926),
    [anon_sym_AMP_AMP] = ACTIONS(2926),
    [anon_sym_TILDE] = ACTIONS(2928),
    [aux_sym_prefix_op_token1] = ACTIONS(2926),
    [aux_sym_infix_op_token1] = ACTIONS(2928),
    [aux_sym_infix_op_token2] = ACTIONS(2926),
    [anon_sym_PIPE_PIPE] = ACTIONS(2926),
    [anon_sym_BANG_EQ] = ACTIONS(2926),
    [anon_sym_COLON_EQ] = ACTIONS(2928),
    [anon_sym_DOLLAR] = ACTIONS(2926),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2926),
    [sym_int] = ACTIONS(2926),
    [sym_xint] = ACTIONS(2928),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2928),
    [sym__newline] = ACTIONS(2928),
  },
  [1878] = {
    [sym_block_comment] = STATE(1878),
    [sym_compiler_directive_decl] = STATE(1878),
    [sym_fsi_directive_decl] = STATE(1878),
    [sym_preproc_line] = STATE(1878),
    [sym_identifier] = ACTIONS(2938),
    [anon_sym_EQ] = ACTIONS(2940),
    [anon_sym_COLON] = ACTIONS(2938),
    [anon_sym_return] = ACTIONS(2938),
    [anon_sym_do] = ACTIONS(2938),
    [anon_sym_let] = ACTIONS(2938),
    [anon_sym_let_BANG] = ACTIONS(2940),
    [anon_sym_LPAREN] = ACTIONS(2938),
    [anon_sym_COMMA] = ACTIONS(2940),
    [anon_sym_null] = ACTIONS(2938),
    [anon_sym_QMARK] = ACTIONS(2938),
    [anon_sym_COLON_QMARK] = ACTIONS(2938),
    [anon_sym_COLON_COLON] = ACTIONS(2940),
    [anon_sym_AMP] = ACTIONS(2938),
    [anon_sym_LBRACK] = ACTIONS(2938),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2940),
    [anon_sym_LBRACE] = ACTIONS(2938),
    [anon_sym_LT_AT] = ACTIONS(2938),
    [anon_sym_LT_AT_AT] = ACTIONS(2938),
    [anon_sym_DOT] = ACTIONS(2938),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2940),
    [anon_sym_new] = ACTIONS(2938),
    [anon_sym_return_BANG] = ACTIONS(2940),
    [anon_sym_yield] = ACTIONS(2938),
    [anon_sym_yield_BANG] = ACTIONS(2940),
    [anon_sym_lazy] = ACTIONS(2938),
    [anon_sym_assert] = ACTIONS(2938),
    [anon_sym_upcast] = ACTIONS(2938),
    [anon_sym_downcast] = ACTIONS(2938),
    [anon_sym_COLON_GT] = ACTIONS(2940),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2940),
    [anon_sym_for] = ACTIONS(2938),
    [anon_sym_while] = ACTIONS(2938),
    [anon_sym_if] = ACTIONS(2938),
    [anon_sym_fun] = ACTIONS(2938),
    [anon_sym_DASH_GT] = ACTIONS(2938),
    [anon_sym_try] = ACTIONS(2938),
    [anon_sym_match] = ACTIONS(2938),
    [anon_sym_match_BANG] = ACTIONS(2940),
    [anon_sym_function] = ACTIONS(2938),
    [anon_sym_LT_DASH] = ACTIONS(2938),
    [anon_sym_DOT_LBRACK] = ACTIONS(2940),
    [anon_sym_LT] = ACTIONS(2940),
    [anon_sym_use] = ACTIONS(2938),
    [anon_sym_use_BANG] = ACTIONS(2940),
    [anon_sym_do_BANG] = ACTIONS(2940),
    [anon_sym_DOT_DOT] = ACTIONS(2940),
    [anon_sym_begin] = ACTIONS(2938),
    [anon_sym_LPAREN2] = ACTIONS(2938),
    [anon_sym_or] = ACTIONS(2938),
    [aux_sym_char_token1] = ACTIONS(2940),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2938),
    [anon_sym_DQUOTE] = ACTIONS(2938),
    [anon_sym_AT_DQUOTE] = ACTIONS(2940),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2940),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2940),
    [sym_bool] = ACTIONS(2938),
    [sym_unit] = ACTIONS(2940),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2938),
    [sym_op_identifier] = ACTIONS(2938),
    [anon_sym_PLUS] = ACTIONS(2938),
    [anon_sym_DASH] = ACTIONS(2938),
    [anon_sym_PLUS_DOT] = ACTIONS(2938),
    [anon_sym_DASH_DOT] = ACTIONS(2938),
    [anon_sym_PERCENT] = ACTIONS(2938),
    [anon_sym_AMP_AMP] = ACTIONS(2938),
    [anon_sym_TILDE] = ACTIONS(2940),
    [aux_sym_prefix_op_token1] = ACTIONS(2938),
    [aux_sym_infix_op_token1] = ACTIONS(2940),
    [aux_sym_infix_op_token2] = ACTIONS(2938),
    [anon_sym_PIPE_PIPE] = ACTIONS(2938),
    [anon_sym_BANG_EQ] = ACTIONS(2938),
    [anon_sym_COLON_EQ] = ACTIONS(2940),
    [anon_sym_DOLLAR] = ACTIONS(2938),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2938),
    [sym_int] = ACTIONS(2938),
    [sym_xint] = ACTIONS(2940),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2940),
    [sym__newline] = ACTIONS(2940),
  },
  [1879] = {
    [sym_block_comment] = STATE(1879),
    [sym_compiler_directive_decl] = STATE(1879),
    [sym_fsi_directive_decl] = STATE(1879),
    [sym_preproc_line] = STATE(1879),
    [sym_identifier] = ACTIONS(2946),
    [anon_sym_EQ] = ACTIONS(2948),
    [anon_sym_COLON] = ACTIONS(2946),
    [anon_sym_return] = ACTIONS(2946),
    [anon_sym_do] = ACTIONS(2946),
    [anon_sym_let] = ACTIONS(2946),
    [anon_sym_let_BANG] = ACTIONS(2948),
    [anon_sym_LPAREN] = ACTIONS(2946),
    [anon_sym_COMMA] = ACTIONS(2948),
    [anon_sym_null] = ACTIONS(2946),
    [anon_sym_QMARK] = ACTIONS(2946),
    [anon_sym_COLON_QMARK] = ACTIONS(2946),
    [anon_sym_COLON_COLON] = ACTIONS(2948),
    [anon_sym_AMP] = ACTIONS(2946),
    [anon_sym_LBRACK] = ACTIONS(2946),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2948),
    [anon_sym_LBRACE] = ACTIONS(2946),
    [anon_sym_LT_AT] = ACTIONS(2946),
    [anon_sym_LT_AT_AT] = ACTIONS(2946),
    [anon_sym_DOT] = ACTIONS(2946),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2948),
    [anon_sym_new] = ACTIONS(2946),
    [anon_sym_return_BANG] = ACTIONS(2948),
    [anon_sym_yield] = ACTIONS(2946),
    [anon_sym_yield_BANG] = ACTIONS(2948),
    [anon_sym_lazy] = ACTIONS(2946),
    [anon_sym_assert] = ACTIONS(2946),
    [anon_sym_upcast] = ACTIONS(2946),
    [anon_sym_downcast] = ACTIONS(2946),
    [anon_sym_COLON_GT] = ACTIONS(2948),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2948),
    [anon_sym_for] = ACTIONS(2946),
    [anon_sym_while] = ACTIONS(2946),
    [anon_sym_if] = ACTIONS(2946),
    [anon_sym_fun] = ACTIONS(2946),
    [anon_sym_DASH_GT] = ACTIONS(2946),
    [anon_sym_try] = ACTIONS(2946),
    [anon_sym_match] = ACTIONS(2946),
    [anon_sym_match_BANG] = ACTIONS(2948),
    [anon_sym_function] = ACTIONS(2946),
    [anon_sym_LT_DASH] = ACTIONS(2946),
    [anon_sym_DOT_LBRACK] = ACTIONS(2948),
    [anon_sym_LT] = ACTIONS(2948),
    [anon_sym_use] = ACTIONS(2946),
    [anon_sym_use_BANG] = ACTIONS(2948),
    [anon_sym_do_BANG] = ACTIONS(2948),
    [anon_sym_DOT_DOT] = ACTIONS(2948),
    [anon_sym_begin] = ACTIONS(2946),
    [anon_sym_LPAREN2] = ACTIONS(2946),
    [anon_sym_or] = ACTIONS(2946),
    [aux_sym_char_token1] = ACTIONS(2948),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2946),
    [anon_sym_DQUOTE] = ACTIONS(2946),
    [anon_sym_AT_DQUOTE] = ACTIONS(2948),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2948),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2948),
    [sym_bool] = ACTIONS(2946),
    [sym_unit] = ACTIONS(2948),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2946),
    [sym_op_identifier] = ACTIONS(2946),
    [anon_sym_PLUS] = ACTIONS(2946),
    [anon_sym_DASH] = ACTIONS(2946),
    [anon_sym_PLUS_DOT] = ACTIONS(2946),
    [anon_sym_DASH_DOT] = ACTIONS(2946),
    [anon_sym_PERCENT] = ACTIONS(2946),
    [anon_sym_AMP_AMP] = ACTIONS(2946),
    [anon_sym_TILDE] = ACTIONS(2948),
    [aux_sym_prefix_op_token1] = ACTIONS(2946),
    [aux_sym_infix_op_token1] = ACTIONS(2948),
    [aux_sym_infix_op_token2] = ACTIONS(2946),
    [anon_sym_PIPE_PIPE] = ACTIONS(2946),
    [anon_sym_BANG_EQ] = ACTIONS(2946),
    [anon_sym_COLON_EQ] = ACTIONS(2948),
    [anon_sym_DOLLAR] = ACTIONS(2946),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2946),
    [sym_int] = ACTIONS(2946),
    [sym_xint] = ACTIONS(2948),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2948),
    [sym__newline] = ACTIONS(2948),
  },
  [1880] = {
    [sym_block_comment] = STATE(1880),
    [sym_compiler_directive_decl] = STATE(1880),
    [sym_fsi_directive_decl] = STATE(1880),
    [sym_preproc_line] = STATE(1880),
    [sym_identifier] = ACTIONS(2950),
    [anon_sym_EQ] = ACTIONS(2952),
    [anon_sym_COLON] = ACTIONS(2950),
    [anon_sym_return] = ACTIONS(2950),
    [anon_sym_do] = ACTIONS(2950),
    [anon_sym_let] = ACTIONS(2950),
    [anon_sym_let_BANG] = ACTIONS(2952),
    [anon_sym_LPAREN] = ACTIONS(2950),
    [anon_sym_COMMA] = ACTIONS(2952),
    [anon_sym_null] = ACTIONS(2950),
    [anon_sym_QMARK] = ACTIONS(2950),
    [anon_sym_COLON_QMARK] = ACTIONS(2950),
    [anon_sym_COLON_COLON] = ACTIONS(2952),
    [anon_sym_AMP] = ACTIONS(2950),
    [anon_sym_LBRACK] = ACTIONS(2950),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2952),
    [anon_sym_LBRACE] = ACTIONS(2950),
    [anon_sym_LT_AT] = ACTIONS(2950),
    [anon_sym_LT_AT_AT] = ACTIONS(2950),
    [anon_sym_DOT] = ACTIONS(2950),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2952),
    [anon_sym_new] = ACTIONS(2950),
    [anon_sym_return_BANG] = ACTIONS(2952),
    [anon_sym_yield] = ACTIONS(2950),
    [anon_sym_yield_BANG] = ACTIONS(2952),
    [anon_sym_lazy] = ACTIONS(2950),
    [anon_sym_assert] = ACTIONS(2950),
    [anon_sym_upcast] = ACTIONS(2950),
    [anon_sym_downcast] = ACTIONS(2950),
    [anon_sym_COLON_GT] = ACTIONS(2952),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2952),
    [anon_sym_for] = ACTIONS(2950),
    [anon_sym_while] = ACTIONS(2950),
    [anon_sym_if] = ACTIONS(2950),
    [anon_sym_fun] = ACTIONS(2950),
    [anon_sym_DASH_GT] = ACTIONS(2950),
    [anon_sym_try] = ACTIONS(2950),
    [anon_sym_match] = ACTIONS(2950),
    [anon_sym_match_BANG] = ACTIONS(2952),
    [anon_sym_function] = ACTIONS(2950),
    [anon_sym_LT_DASH] = ACTIONS(2950),
    [anon_sym_DOT_LBRACK] = ACTIONS(2952),
    [anon_sym_LT] = ACTIONS(2952),
    [anon_sym_use] = ACTIONS(2950),
    [anon_sym_use_BANG] = ACTIONS(2952),
    [anon_sym_do_BANG] = ACTIONS(2952),
    [anon_sym_DOT_DOT] = ACTIONS(2952),
    [anon_sym_begin] = ACTIONS(2950),
    [anon_sym_LPAREN2] = ACTIONS(2950),
    [anon_sym_or] = ACTIONS(2950),
    [aux_sym_char_token1] = ACTIONS(2952),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2950),
    [anon_sym_DQUOTE] = ACTIONS(2950),
    [anon_sym_AT_DQUOTE] = ACTIONS(2952),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2952),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2952),
    [sym_bool] = ACTIONS(2950),
    [sym_unit] = ACTIONS(2952),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2950),
    [sym_op_identifier] = ACTIONS(2950),
    [anon_sym_PLUS] = ACTIONS(2950),
    [anon_sym_DASH] = ACTIONS(2950),
    [anon_sym_PLUS_DOT] = ACTIONS(2950),
    [anon_sym_DASH_DOT] = ACTIONS(2950),
    [anon_sym_PERCENT] = ACTIONS(2950),
    [anon_sym_AMP_AMP] = ACTIONS(2950),
    [anon_sym_TILDE] = ACTIONS(2952),
    [aux_sym_prefix_op_token1] = ACTIONS(2950),
    [aux_sym_infix_op_token1] = ACTIONS(2952),
    [aux_sym_infix_op_token2] = ACTIONS(2950),
    [anon_sym_PIPE_PIPE] = ACTIONS(2950),
    [anon_sym_BANG_EQ] = ACTIONS(2950),
    [anon_sym_COLON_EQ] = ACTIONS(2952),
    [anon_sym_DOLLAR] = ACTIONS(2950),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2950),
    [sym_int] = ACTIONS(2950),
    [sym_xint] = ACTIONS(2952),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2952),
    [sym__newline] = ACTIONS(2952),
  },
  [1881] = {
    [sym_block_comment] = STATE(1881),
    [sym_compiler_directive_decl] = STATE(1881),
    [sym_fsi_directive_decl] = STATE(1881),
    [sym_preproc_line] = STATE(1881),
    [aux_sym_sequential_expression_repeat1] = STATE(1881),
    [sym_identifier] = ACTIONS(2895),
    [anon_sym_EQ] = ACTIONS(2897),
    [anon_sym_COLON] = ACTIONS(2895),
    [anon_sym_return] = ACTIONS(2895),
    [anon_sym_do] = ACTIONS(2895),
    [anon_sym_let] = ACTIONS(2895),
    [anon_sym_let_BANG] = ACTIONS(2897),
    [anon_sym_LPAREN] = ACTIONS(2895),
    [anon_sym_COMMA] = ACTIONS(2897),
    [anon_sym_null] = ACTIONS(2895),
    [anon_sym_QMARK] = ACTIONS(2895),
    [anon_sym_COLON_QMARK] = ACTIONS(2895),
    [anon_sym_COLON_COLON] = ACTIONS(2897),
    [anon_sym_AMP] = ACTIONS(2895),
    [anon_sym_LBRACK] = ACTIONS(2895),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2897),
    [anon_sym_LBRACE] = ACTIONS(2895),
    [anon_sym_LT_AT] = ACTIONS(2895),
    [anon_sym_LT_AT_AT] = ACTIONS(2895),
    [anon_sym_DOT] = ACTIONS(2895),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2897),
    [anon_sym_new] = ACTIONS(2895),
    [anon_sym_return_BANG] = ACTIONS(2897),
    [anon_sym_yield] = ACTIONS(2895),
    [anon_sym_yield_BANG] = ACTIONS(2897),
    [anon_sym_lazy] = ACTIONS(2895),
    [anon_sym_assert] = ACTIONS(2895),
    [anon_sym_upcast] = ACTIONS(2895),
    [anon_sym_downcast] = ACTIONS(2895),
    [anon_sym_COLON_GT] = ACTIONS(2897),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2897),
    [anon_sym_for] = ACTIONS(2895),
    [anon_sym_while] = ACTIONS(2895),
    [anon_sym_if] = ACTIONS(2895),
    [anon_sym_fun] = ACTIONS(2895),
    [anon_sym_DASH_GT] = ACTIONS(2895),
    [anon_sym_try] = ACTIONS(2895),
    [anon_sym_match] = ACTIONS(2895),
    [anon_sym_match_BANG] = ACTIONS(2897),
    [anon_sym_function] = ACTIONS(2895),
    [anon_sym_LT_DASH] = ACTIONS(2895),
    [anon_sym_DOT_LBRACK] = ACTIONS(2897),
    [anon_sym_LT] = ACTIONS(2897),
    [anon_sym_use] = ACTIONS(2895),
    [anon_sym_use_BANG] = ACTIONS(2897),
    [anon_sym_do_BANG] = ACTIONS(2897),
    [anon_sym_begin] = ACTIONS(2895),
    [anon_sym_LPAREN2] = ACTIONS(2895),
    [anon_sym_or] = ACTIONS(2895),
    [aux_sym_char_token1] = ACTIONS(2897),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2895),
    [anon_sym_DQUOTE] = ACTIONS(2895),
    [anon_sym_AT_DQUOTE] = ACTIONS(2897),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2897),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2897),
    [sym_bool] = ACTIONS(2895),
    [sym_unit] = ACTIONS(2897),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2895),
    [sym_op_identifier] = ACTIONS(2895),
    [anon_sym_PLUS] = ACTIONS(2895),
    [anon_sym_DASH] = ACTIONS(2895),
    [anon_sym_PLUS_DOT] = ACTIONS(2895),
    [anon_sym_DASH_DOT] = ACTIONS(2895),
    [anon_sym_PERCENT] = ACTIONS(2895),
    [anon_sym_AMP_AMP] = ACTIONS(2895),
    [anon_sym_TILDE] = ACTIONS(2897),
    [aux_sym_prefix_op_token1] = ACTIONS(2895),
    [aux_sym_infix_op_token1] = ACTIONS(2897),
    [aux_sym_infix_op_token2] = ACTIONS(2895),
    [anon_sym_PIPE_PIPE] = ACTIONS(2895),
    [anon_sym_BANG_EQ] = ACTIONS(2895),
    [anon_sym_COLON_EQ] = ACTIONS(2897),
    [anon_sym_DOLLAR] = ACTIONS(2895),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2895),
    [sym_int] = ACTIONS(2895),
    [sym_xint] = ACTIONS(2897),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2897),
    [sym__newline] = ACTIONS(4143),
  },
  [1882] = {
    [sym_block_comment] = STATE(1882),
    [sym_compiler_directive_decl] = STATE(1882),
    [sym_fsi_directive_decl] = STATE(1882),
    [sym_preproc_line] = STATE(1882),
    [aux_sym_sequential_expression_repeat1] = STATE(1928),
    [sym_identifier] = ACTIONS(2847),
    [anon_sym_EQ] = ACTIONS(2849),
    [anon_sym_COLON] = ACTIONS(2847),
    [anon_sym_return] = ACTIONS(2847),
    [anon_sym_do] = ACTIONS(2847),
    [anon_sym_let] = ACTIONS(2847),
    [anon_sym_let_BANG] = ACTIONS(2849),
    [anon_sym_LPAREN] = ACTIONS(2847),
    [anon_sym_COMMA] = ACTIONS(2849),
    [anon_sym_null] = ACTIONS(2847),
    [anon_sym_QMARK] = ACTIONS(2847),
    [anon_sym_COLON_QMARK] = ACTIONS(2847),
    [anon_sym_COLON_COLON] = ACTIONS(2849),
    [anon_sym_AMP] = ACTIONS(2847),
    [anon_sym_LBRACK] = ACTIONS(2847),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2849),
    [anon_sym_LBRACE] = ACTIONS(2847),
    [anon_sym_LT_AT] = ACTIONS(2847),
    [anon_sym_LT_AT_AT] = ACTIONS(2847),
    [anon_sym_AT_AT_GT] = ACTIONS(2847),
    [anon_sym_DOT] = ACTIONS(2847),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2849),
    [anon_sym_new] = ACTIONS(2847),
    [anon_sym_return_BANG] = ACTIONS(2849),
    [anon_sym_yield] = ACTIONS(2847),
    [anon_sym_yield_BANG] = ACTIONS(2849),
    [anon_sym_lazy] = ACTIONS(2847),
    [anon_sym_assert] = ACTIONS(2847),
    [anon_sym_upcast] = ACTIONS(2847),
    [anon_sym_downcast] = ACTIONS(2847),
    [anon_sym_COLON_GT] = ACTIONS(2849),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2849),
    [anon_sym_for] = ACTIONS(2847),
    [anon_sym_while] = ACTIONS(2847),
    [anon_sym_if] = ACTIONS(2847),
    [anon_sym_fun] = ACTIONS(2847),
    [anon_sym_try] = ACTIONS(2847),
    [anon_sym_match] = ACTIONS(2847),
    [anon_sym_match_BANG] = ACTIONS(2849),
    [anon_sym_function] = ACTIONS(2847),
    [anon_sym_LT_DASH] = ACTIONS(2847),
    [anon_sym_DOT_LBRACK] = ACTIONS(2849),
    [anon_sym_LT] = ACTIONS(2849),
    [anon_sym_use] = ACTIONS(2847),
    [anon_sym_use_BANG] = ACTIONS(2849),
    [anon_sym_do_BANG] = ACTIONS(2849),
    [anon_sym_begin] = ACTIONS(2847),
    [anon_sym_LPAREN2] = ACTIONS(2847),
    [anon_sym_or] = ACTIONS(2847),
    [aux_sym_char_token1] = ACTIONS(2849),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2847),
    [anon_sym_DQUOTE] = ACTIONS(2847),
    [anon_sym_AT_DQUOTE] = ACTIONS(2849),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2849),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2849),
    [sym_bool] = ACTIONS(2847),
    [sym_unit] = ACTIONS(2849),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2847),
    [sym_op_identifier] = ACTIONS(2847),
    [anon_sym_PLUS] = ACTIONS(2847),
    [anon_sym_DASH] = ACTIONS(2847),
    [anon_sym_PLUS_DOT] = ACTIONS(2847),
    [anon_sym_DASH_DOT] = ACTIONS(2847),
    [anon_sym_PERCENT] = ACTIONS(2847),
    [anon_sym_AMP_AMP] = ACTIONS(2847),
    [anon_sym_TILDE] = ACTIONS(2849),
    [aux_sym_prefix_op_token1] = ACTIONS(2847),
    [aux_sym_infix_op_token1] = ACTIONS(2849),
    [aux_sym_infix_op_token2] = ACTIONS(2847),
    [anon_sym_PIPE_PIPE] = ACTIONS(2847),
    [anon_sym_BANG_EQ] = ACTIONS(2847),
    [anon_sym_COLON_EQ] = ACTIONS(2849),
    [anon_sym_DOLLAR] = ACTIONS(2847),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2847),
    [sym_int] = ACTIONS(2847),
    [sym_xint] = ACTIONS(2849),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2849),
    [sym__newline] = ACTIONS(2849),
  },
  [1883] = {
    [sym_block_comment] = STATE(1883),
    [sym_compiler_directive_decl] = STATE(1883),
    [sym_fsi_directive_decl] = STATE(1883),
    [sym_preproc_line] = STATE(1883),
    [sym_identifier] = ACTIONS(2958),
    [anon_sym_EQ] = ACTIONS(2960),
    [anon_sym_COLON] = ACTIONS(2958),
    [anon_sym_return] = ACTIONS(2958),
    [anon_sym_do] = ACTIONS(2958),
    [anon_sym_let] = ACTIONS(2958),
    [anon_sym_let_BANG] = ACTIONS(2960),
    [anon_sym_LPAREN] = ACTIONS(2958),
    [anon_sym_COMMA] = ACTIONS(2960),
    [anon_sym_null] = ACTIONS(2958),
    [anon_sym_QMARK] = ACTIONS(2958),
    [anon_sym_COLON_QMARK] = ACTIONS(2958),
    [anon_sym_COLON_COLON] = ACTIONS(2960),
    [anon_sym_AMP] = ACTIONS(2958),
    [anon_sym_LBRACK] = ACTIONS(2958),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2960),
    [anon_sym_LBRACE] = ACTIONS(2958),
    [anon_sym_LT_AT] = ACTIONS(2958),
    [anon_sym_LT_AT_AT] = ACTIONS(2958),
    [anon_sym_DOT] = ACTIONS(2958),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2960),
    [anon_sym_new] = ACTIONS(2958),
    [anon_sym_return_BANG] = ACTIONS(2960),
    [anon_sym_yield] = ACTIONS(2958),
    [anon_sym_yield_BANG] = ACTIONS(2960),
    [anon_sym_lazy] = ACTIONS(2958),
    [anon_sym_assert] = ACTIONS(2958),
    [anon_sym_upcast] = ACTIONS(2958),
    [anon_sym_downcast] = ACTIONS(2958),
    [anon_sym_COLON_GT] = ACTIONS(2960),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2960),
    [anon_sym_for] = ACTIONS(2958),
    [anon_sym_while] = ACTIONS(2958),
    [anon_sym_if] = ACTIONS(2958),
    [anon_sym_fun] = ACTIONS(2958),
    [anon_sym_DASH_GT] = ACTIONS(2958),
    [anon_sym_try] = ACTIONS(2958),
    [anon_sym_match] = ACTIONS(2958),
    [anon_sym_match_BANG] = ACTIONS(2960),
    [anon_sym_function] = ACTIONS(2958),
    [anon_sym_LT_DASH] = ACTIONS(2958),
    [anon_sym_DOT_LBRACK] = ACTIONS(2960),
    [anon_sym_LT] = ACTIONS(2960),
    [anon_sym_use] = ACTIONS(2958),
    [anon_sym_use_BANG] = ACTIONS(2960),
    [anon_sym_do_BANG] = ACTIONS(2960),
    [anon_sym_DOT_DOT] = ACTIONS(2960),
    [anon_sym_begin] = ACTIONS(2958),
    [anon_sym_LPAREN2] = ACTIONS(2958),
    [anon_sym_or] = ACTIONS(2958),
    [aux_sym_char_token1] = ACTIONS(2960),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2958),
    [anon_sym_DQUOTE] = ACTIONS(2958),
    [anon_sym_AT_DQUOTE] = ACTIONS(2960),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2960),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2960),
    [sym_bool] = ACTIONS(2958),
    [sym_unit] = ACTIONS(2960),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2958),
    [sym_op_identifier] = ACTIONS(2958),
    [anon_sym_PLUS] = ACTIONS(2958),
    [anon_sym_DASH] = ACTIONS(2958),
    [anon_sym_PLUS_DOT] = ACTIONS(2958),
    [anon_sym_DASH_DOT] = ACTIONS(2958),
    [anon_sym_PERCENT] = ACTIONS(2958),
    [anon_sym_AMP_AMP] = ACTIONS(2958),
    [anon_sym_TILDE] = ACTIONS(2960),
    [aux_sym_prefix_op_token1] = ACTIONS(2958),
    [aux_sym_infix_op_token1] = ACTIONS(2960),
    [aux_sym_infix_op_token2] = ACTIONS(2958),
    [anon_sym_PIPE_PIPE] = ACTIONS(2958),
    [anon_sym_BANG_EQ] = ACTIONS(2958),
    [anon_sym_COLON_EQ] = ACTIONS(2960),
    [anon_sym_DOLLAR] = ACTIONS(2958),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2958),
    [sym_int] = ACTIONS(2958),
    [sym_xint] = ACTIONS(2960),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2960),
    [sym__newline] = ACTIONS(2960),
  },
  [1884] = {
    [sym_block_comment] = STATE(1884),
    [sym_compiler_directive_decl] = STATE(1884),
    [sym_fsi_directive_decl] = STATE(1884),
    [sym_preproc_line] = STATE(1884),
    [sym_identifier] = ACTIONS(2962),
    [anon_sym_EQ] = ACTIONS(2964),
    [anon_sym_COLON] = ACTIONS(2962),
    [anon_sym_return] = ACTIONS(2962),
    [anon_sym_do] = ACTIONS(2962),
    [anon_sym_let] = ACTIONS(2962),
    [anon_sym_let_BANG] = ACTIONS(2964),
    [anon_sym_LPAREN] = ACTIONS(2962),
    [anon_sym_COMMA] = ACTIONS(2964),
    [anon_sym_null] = ACTIONS(2962),
    [anon_sym_QMARK] = ACTIONS(2962),
    [anon_sym_COLON_QMARK] = ACTIONS(2962),
    [anon_sym_COLON_COLON] = ACTIONS(2964),
    [anon_sym_AMP] = ACTIONS(2962),
    [anon_sym_LBRACK] = ACTIONS(2962),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2964),
    [anon_sym_LBRACE] = ACTIONS(2962),
    [anon_sym_LT_AT] = ACTIONS(2962),
    [anon_sym_LT_AT_AT] = ACTIONS(2962),
    [anon_sym_DOT] = ACTIONS(2962),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2964),
    [anon_sym_new] = ACTIONS(2962),
    [anon_sym_return_BANG] = ACTIONS(2964),
    [anon_sym_yield] = ACTIONS(2962),
    [anon_sym_yield_BANG] = ACTIONS(2964),
    [anon_sym_lazy] = ACTIONS(2962),
    [anon_sym_assert] = ACTIONS(2962),
    [anon_sym_upcast] = ACTIONS(2962),
    [anon_sym_downcast] = ACTIONS(2962),
    [anon_sym_COLON_GT] = ACTIONS(2964),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2964),
    [anon_sym_for] = ACTIONS(2962),
    [anon_sym_while] = ACTIONS(2962),
    [anon_sym_if] = ACTIONS(2962),
    [anon_sym_fun] = ACTIONS(2962),
    [anon_sym_DASH_GT] = ACTIONS(2962),
    [anon_sym_try] = ACTIONS(2962),
    [anon_sym_match] = ACTIONS(2962),
    [anon_sym_match_BANG] = ACTIONS(2964),
    [anon_sym_function] = ACTIONS(2962),
    [anon_sym_LT_DASH] = ACTIONS(2962),
    [anon_sym_DOT_LBRACK] = ACTIONS(2964),
    [anon_sym_LT] = ACTIONS(2964),
    [anon_sym_use] = ACTIONS(2962),
    [anon_sym_use_BANG] = ACTIONS(2964),
    [anon_sym_do_BANG] = ACTIONS(2964),
    [anon_sym_DOT_DOT] = ACTIONS(2964),
    [anon_sym_begin] = ACTIONS(2962),
    [anon_sym_LPAREN2] = ACTIONS(2962),
    [anon_sym_or] = ACTIONS(2962),
    [aux_sym_char_token1] = ACTIONS(2964),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2962),
    [anon_sym_DQUOTE] = ACTIONS(2962),
    [anon_sym_AT_DQUOTE] = ACTIONS(2964),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2964),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2964),
    [sym_bool] = ACTIONS(2962),
    [sym_unit] = ACTIONS(2964),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2962),
    [sym_op_identifier] = ACTIONS(2962),
    [anon_sym_PLUS] = ACTIONS(2962),
    [anon_sym_DASH] = ACTIONS(2962),
    [anon_sym_PLUS_DOT] = ACTIONS(2962),
    [anon_sym_DASH_DOT] = ACTIONS(2962),
    [anon_sym_PERCENT] = ACTIONS(2962),
    [anon_sym_AMP_AMP] = ACTIONS(2962),
    [anon_sym_TILDE] = ACTIONS(2964),
    [aux_sym_prefix_op_token1] = ACTIONS(2962),
    [aux_sym_infix_op_token1] = ACTIONS(2964),
    [aux_sym_infix_op_token2] = ACTIONS(2962),
    [anon_sym_PIPE_PIPE] = ACTIONS(2962),
    [anon_sym_BANG_EQ] = ACTIONS(2962),
    [anon_sym_COLON_EQ] = ACTIONS(2964),
    [anon_sym_DOLLAR] = ACTIONS(2962),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2962),
    [sym_int] = ACTIONS(2962),
    [sym_xint] = ACTIONS(2964),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2964),
    [sym__newline] = ACTIONS(2964),
  },
  [1885] = {
    [sym_block_comment] = STATE(1885),
    [sym_compiler_directive_decl] = STATE(1885),
    [sym_fsi_directive_decl] = STATE(1885),
    [sym_preproc_line] = STATE(1885),
    [sym_identifier] = ACTIONS(2966),
    [anon_sym_EQ] = ACTIONS(2968),
    [anon_sym_COLON] = ACTIONS(2966),
    [anon_sym_return] = ACTIONS(2966),
    [anon_sym_do] = ACTIONS(2966),
    [anon_sym_let] = ACTIONS(2966),
    [anon_sym_let_BANG] = ACTIONS(2968),
    [anon_sym_LPAREN] = ACTIONS(2966),
    [anon_sym_COMMA] = ACTIONS(2968),
    [anon_sym_null] = ACTIONS(2966),
    [anon_sym_QMARK] = ACTIONS(2966),
    [anon_sym_COLON_QMARK] = ACTIONS(2966),
    [anon_sym_COLON_COLON] = ACTIONS(2968),
    [anon_sym_AMP] = ACTIONS(2966),
    [anon_sym_LBRACK] = ACTIONS(2966),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2968),
    [anon_sym_LBRACE] = ACTIONS(2966),
    [anon_sym_LT_AT] = ACTIONS(2966),
    [anon_sym_LT_AT_AT] = ACTIONS(2966),
    [anon_sym_DOT] = ACTIONS(2966),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2968),
    [anon_sym_new] = ACTIONS(2966),
    [anon_sym_return_BANG] = ACTIONS(2968),
    [anon_sym_yield] = ACTIONS(2966),
    [anon_sym_yield_BANG] = ACTIONS(2968),
    [anon_sym_lazy] = ACTIONS(2966),
    [anon_sym_assert] = ACTIONS(2966),
    [anon_sym_upcast] = ACTIONS(2966),
    [anon_sym_downcast] = ACTIONS(2966),
    [anon_sym_COLON_GT] = ACTIONS(2968),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2968),
    [anon_sym_for] = ACTIONS(2966),
    [anon_sym_while] = ACTIONS(2966),
    [anon_sym_if] = ACTIONS(2966),
    [anon_sym_fun] = ACTIONS(2966),
    [anon_sym_DASH_GT] = ACTIONS(2966),
    [anon_sym_try] = ACTIONS(2966),
    [anon_sym_match] = ACTIONS(2966),
    [anon_sym_match_BANG] = ACTIONS(2968),
    [anon_sym_function] = ACTIONS(2966),
    [anon_sym_LT_DASH] = ACTIONS(2966),
    [anon_sym_DOT_LBRACK] = ACTIONS(2968),
    [anon_sym_LT] = ACTIONS(2968),
    [anon_sym_use] = ACTIONS(2966),
    [anon_sym_use_BANG] = ACTIONS(2968),
    [anon_sym_do_BANG] = ACTIONS(2968),
    [anon_sym_DOT_DOT] = ACTIONS(2968),
    [anon_sym_begin] = ACTIONS(2966),
    [anon_sym_LPAREN2] = ACTIONS(2966),
    [anon_sym_or] = ACTIONS(2966),
    [aux_sym_char_token1] = ACTIONS(2968),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2966),
    [anon_sym_DQUOTE] = ACTIONS(2966),
    [anon_sym_AT_DQUOTE] = ACTIONS(2968),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2968),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2968),
    [sym_bool] = ACTIONS(2966),
    [sym_unit] = ACTIONS(2968),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2966),
    [sym_op_identifier] = ACTIONS(2966),
    [anon_sym_PLUS] = ACTIONS(2966),
    [anon_sym_DASH] = ACTIONS(2966),
    [anon_sym_PLUS_DOT] = ACTIONS(2966),
    [anon_sym_DASH_DOT] = ACTIONS(2966),
    [anon_sym_PERCENT] = ACTIONS(2966),
    [anon_sym_AMP_AMP] = ACTIONS(2966),
    [anon_sym_TILDE] = ACTIONS(2968),
    [aux_sym_prefix_op_token1] = ACTIONS(2966),
    [aux_sym_infix_op_token1] = ACTIONS(2968),
    [aux_sym_infix_op_token2] = ACTIONS(2966),
    [anon_sym_PIPE_PIPE] = ACTIONS(2966),
    [anon_sym_BANG_EQ] = ACTIONS(2966),
    [anon_sym_COLON_EQ] = ACTIONS(2968),
    [anon_sym_DOLLAR] = ACTIONS(2966),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2966),
    [sym_int] = ACTIONS(2966),
    [sym_xint] = ACTIONS(2968),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2968),
    [sym__newline] = ACTIONS(2968),
  },
  [1886] = {
    [sym_block_comment] = STATE(1886),
    [sym_compiler_directive_decl] = STATE(1886),
    [sym_fsi_directive_decl] = STATE(1886),
    [sym_preproc_line] = STATE(1886),
    [sym_identifier] = ACTIONS(2978),
    [anon_sym_EQ] = ACTIONS(2980),
    [anon_sym_COLON] = ACTIONS(2978),
    [anon_sym_return] = ACTIONS(2978),
    [anon_sym_do] = ACTIONS(2978),
    [anon_sym_let] = ACTIONS(2978),
    [anon_sym_let_BANG] = ACTIONS(2980),
    [anon_sym_as] = ACTIONS(2978),
    [anon_sym_LPAREN] = ACTIONS(2978),
    [anon_sym_COMMA] = ACTIONS(2980),
    [anon_sym_null] = ACTIONS(2978),
    [anon_sym_QMARK] = ACTIONS(2978),
    [anon_sym_COLON_QMARK] = ACTIONS(2978),
    [anon_sym_COLON_COLON] = ACTIONS(2980),
    [anon_sym_AMP] = ACTIONS(2978),
    [anon_sym_LBRACK] = ACTIONS(2978),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2980),
    [anon_sym_LBRACE] = ACTIONS(2978),
    [anon_sym_LT_AT] = ACTIONS(2978),
    [anon_sym_LT_AT_AT] = ACTIONS(2978),
    [anon_sym_DOT] = ACTIONS(2978),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2980),
    [anon_sym_new] = ACTIONS(2978),
    [anon_sym_with] = ACTIONS(2978),
    [anon_sym_return_BANG] = ACTIONS(2980),
    [anon_sym_yield] = ACTIONS(2978),
    [anon_sym_yield_BANG] = ACTIONS(2980),
    [anon_sym_lazy] = ACTIONS(2978),
    [anon_sym_assert] = ACTIONS(2978),
    [anon_sym_upcast] = ACTIONS(2978),
    [anon_sym_downcast] = ACTIONS(2978),
    [anon_sym_COLON_GT] = ACTIONS(2980),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2980),
    [anon_sym_for] = ACTIONS(2978),
    [anon_sym_while] = ACTIONS(2978),
    [anon_sym_if] = ACTIONS(2978),
    [anon_sym_fun] = ACTIONS(2978),
    [anon_sym_try] = ACTIONS(2978),
    [anon_sym_match] = ACTIONS(2978),
    [anon_sym_match_BANG] = ACTIONS(2980),
    [anon_sym_function] = ACTIONS(2978),
    [anon_sym_LT_DASH] = ACTIONS(2978),
    [anon_sym_DOT_LBRACK] = ACTIONS(2980),
    [anon_sym_LT] = ACTIONS(2980),
    [anon_sym_use] = ACTIONS(2978),
    [anon_sym_use_BANG] = ACTIONS(2980),
    [anon_sym_do_BANG] = ACTIONS(2980),
    [anon_sym_begin] = ACTIONS(2978),
    [anon_sym_LPAREN2] = ACTIONS(2978),
    [anon_sym_or] = ACTIONS(2978),
    [aux_sym_char_token1] = ACTIONS(2980),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2978),
    [anon_sym_DQUOTE] = ACTIONS(2978),
    [anon_sym_AT_DQUOTE] = ACTIONS(2980),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2980),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2980),
    [sym_bool] = ACTIONS(2978),
    [sym_unit] = ACTIONS(2980),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2978),
    [sym_op_identifier] = ACTIONS(2978),
    [anon_sym_PLUS] = ACTIONS(2978),
    [anon_sym_DASH] = ACTIONS(2978),
    [anon_sym_PLUS_DOT] = ACTIONS(2978),
    [anon_sym_DASH_DOT] = ACTIONS(2978),
    [anon_sym_PERCENT] = ACTIONS(2978),
    [anon_sym_AMP_AMP] = ACTIONS(2978),
    [anon_sym_TILDE] = ACTIONS(2980),
    [aux_sym_prefix_op_token1] = ACTIONS(2978),
    [aux_sym_infix_op_token1] = ACTIONS(2980),
    [aux_sym_infix_op_token2] = ACTIONS(2978),
    [anon_sym_PIPE_PIPE] = ACTIONS(2978),
    [anon_sym_BANG_EQ] = ACTIONS(2978),
    [anon_sym_COLON_EQ] = ACTIONS(2980),
    [anon_sym_DOLLAR] = ACTIONS(2978),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2978),
    [sym_int] = ACTIONS(2978),
    [sym_xint] = ACTIONS(2980),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2980),
    [sym__newline] = ACTIONS(2980),
  },
  [1887] = {
    [sym_block_comment] = STATE(1887),
    [sym_compiler_directive_decl] = STATE(1887),
    [sym_fsi_directive_decl] = STATE(1887),
    [sym_preproc_line] = STATE(1887),
    [sym_identifier] = ACTIONS(2992),
    [anon_sym_EQ] = ACTIONS(2994),
    [anon_sym_COLON] = ACTIONS(2992),
    [anon_sym_return] = ACTIONS(2992),
    [anon_sym_do] = ACTIONS(2992),
    [anon_sym_let] = ACTIONS(2992),
    [anon_sym_let_BANG] = ACTIONS(2994),
    [anon_sym_as] = ACTIONS(2992),
    [anon_sym_LPAREN] = ACTIONS(2992),
    [anon_sym_COMMA] = ACTIONS(2994),
    [anon_sym_null] = ACTIONS(2992),
    [anon_sym_QMARK] = ACTIONS(2992),
    [anon_sym_COLON_QMARK] = ACTIONS(2992),
    [anon_sym_COLON_COLON] = ACTIONS(2994),
    [anon_sym_AMP] = ACTIONS(2992),
    [anon_sym_LBRACK] = ACTIONS(2992),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2994),
    [anon_sym_LBRACE] = ACTIONS(2992),
    [anon_sym_LT_AT] = ACTIONS(2992),
    [anon_sym_LT_AT_AT] = ACTIONS(2992),
    [anon_sym_DOT] = ACTIONS(2992),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2994),
    [anon_sym_new] = ACTIONS(2992),
    [anon_sym_with] = ACTIONS(2992),
    [anon_sym_return_BANG] = ACTIONS(2994),
    [anon_sym_yield] = ACTIONS(2992),
    [anon_sym_yield_BANG] = ACTIONS(2994),
    [anon_sym_lazy] = ACTIONS(2992),
    [anon_sym_assert] = ACTIONS(2992),
    [anon_sym_upcast] = ACTIONS(2992),
    [anon_sym_downcast] = ACTIONS(2992),
    [anon_sym_COLON_GT] = ACTIONS(2994),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2994),
    [anon_sym_for] = ACTIONS(2992),
    [anon_sym_while] = ACTIONS(2992),
    [anon_sym_if] = ACTIONS(2992),
    [anon_sym_fun] = ACTIONS(2992),
    [anon_sym_try] = ACTIONS(2992),
    [anon_sym_match] = ACTIONS(2992),
    [anon_sym_match_BANG] = ACTIONS(2994),
    [anon_sym_function] = ACTIONS(2992),
    [anon_sym_LT_DASH] = ACTIONS(2992),
    [anon_sym_DOT_LBRACK] = ACTIONS(2994),
    [anon_sym_LT] = ACTIONS(2994),
    [anon_sym_use] = ACTIONS(2992),
    [anon_sym_use_BANG] = ACTIONS(2994),
    [anon_sym_do_BANG] = ACTIONS(2994),
    [anon_sym_begin] = ACTIONS(2992),
    [anon_sym_LPAREN2] = ACTIONS(2992),
    [anon_sym_or] = ACTIONS(2992),
    [aux_sym_char_token1] = ACTIONS(2994),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2992),
    [anon_sym_DQUOTE] = ACTIONS(2992),
    [anon_sym_AT_DQUOTE] = ACTIONS(2994),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2994),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2994),
    [sym_bool] = ACTIONS(2992),
    [sym_unit] = ACTIONS(2994),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2992),
    [sym_op_identifier] = ACTIONS(2992),
    [anon_sym_PLUS] = ACTIONS(2992),
    [anon_sym_DASH] = ACTIONS(2992),
    [anon_sym_PLUS_DOT] = ACTIONS(2992),
    [anon_sym_DASH_DOT] = ACTIONS(2992),
    [anon_sym_PERCENT] = ACTIONS(2992),
    [anon_sym_AMP_AMP] = ACTIONS(2992),
    [anon_sym_TILDE] = ACTIONS(2994),
    [aux_sym_prefix_op_token1] = ACTIONS(2992),
    [aux_sym_infix_op_token1] = ACTIONS(2994),
    [aux_sym_infix_op_token2] = ACTIONS(2992),
    [anon_sym_PIPE_PIPE] = ACTIONS(2992),
    [anon_sym_BANG_EQ] = ACTIONS(2992),
    [anon_sym_COLON_EQ] = ACTIONS(2994),
    [anon_sym_DOLLAR] = ACTIONS(2992),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2992),
    [sym_int] = ACTIONS(2992),
    [sym_xint] = ACTIONS(2994),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2994),
    [sym__newline] = ACTIONS(2994),
  },
  [1888] = {
    [sym_block_comment] = STATE(1888),
    [sym_compiler_directive_decl] = STATE(1888),
    [sym_fsi_directive_decl] = STATE(1888),
    [sym_preproc_line] = STATE(1888),
    [sym_identifier] = ACTIONS(2996),
    [anon_sym_EQ] = ACTIONS(2998),
    [anon_sym_COLON] = ACTIONS(2996),
    [anon_sym_return] = ACTIONS(2996),
    [anon_sym_do] = ACTIONS(2996),
    [anon_sym_let] = ACTIONS(2996),
    [anon_sym_let_BANG] = ACTIONS(2998),
    [anon_sym_as] = ACTIONS(2996),
    [anon_sym_LPAREN] = ACTIONS(2996),
    [anon_sym_COMMA] = ACTIONS(2998),
    [anon_sym_null] = ACTIONS(2996),
    [anon_sym_QMARK] = ACTIONS(2996),
    [anon_sym_COLON_QMARK] = ACTIONS(2996),
    [anon_sym_COLON_COLON] = ACTIONS(2998),
    [anon_sym_AMP] = ACTIONS(2996),
    [anon_sym_LBRACK] = ACTIONS(2996),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2998),
    [anon_sym_LBRACE] = ACTIONS(2996),
    [anon_sym_LT_AT] = ACTIONS(2996),
    [anon_sym_LT_AT_AT] = ACTIONS(2996),
    [anon_sym_DOT] = ACTIONS(2996),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2998),
    [anon_sym_new] = ACTIONS(2996),
    [anon_sym_with] = ACTIONS(2996),
    [anon_sym_return_BANG] = ACTIONS(2998),
    [anon_sym_yield] = ACTIONS(2996),
    [anon_sym_yield_BANG] = ACTIONS(2998),
    [anon_sym_lazy] = ACTIONS(2996),
    [anon_sym_assert] = ACTIONS(2996),
    [anon_sym_upcast] = ACTIONS(2996),
    [anon_sym_downcast] = ACTIONS(2996),
    [anon_sym_COLON_GT] = ACTIONS(2998),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2998),
    [anon_sym_for] = ACTIONS(2996),
    [anon_sym_while] = ACTIONS(2996),
    [anon_sym_if] = ACTIONS(2996),
    [anon_sym_fun] = ACTIONS(2996),
    [anon_sym_try] = ACTIONS(2996),
    [anon_sym_match] = ACTIONS(2996),
    [anon_sym_match_BANG] = ACTIONS(2998),
    [anon_sym_function] = ACTIONS(2996),
    [anon_sym_LT_DASH] = ACTIONS(2996),
    [anon_sym_DOT_LBRACK] = ACTIONS(2998),
    [anon_sym_LT] = ACTIONS(2998),
    [anon_sym_use] = ACTIONS(2996),
    [anon_sym_use_BANG] = ACTIONS(2998),
    [anon_sym_do_BANG] = ACTIONS(2998),
    [anon_sym_begin] = ACTIONS(2996),
    [anon_sym_LPAREN2] = ACTIONS(2996),
    [anon_sym_or] = ACTIONS(2996),
    [aux_sym_char_token1] = ACTIONS(2998),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2996),
    [anon_sym_DQUOTE] = ACTIONS(2996),
    [anon_sym_AT_DQUOTE] = ACTIONS(2998),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2998),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2998),
    [sym_bool] = ACTIONS(2996),
    [sym_unit] = ACTIONS(2998),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2996),
    [sym_op_identifier] = ACTIONS(2996),
    [anon_sym_PLUS] = ACTIONS(2996),
    [anon_sym_DASH] = ACTIONS(2996),
    [anon_sym_PLUS_DOT] = ACTIONS(2996),
    [anon_sym_DASH_DOT] = ACTIONS(2996),
    [anon_sym_PERCENT] = ACTIONS(2996),
    [anon_sym_AMP_AMP] = ACTIONS(2996),
    [anon_sym_TILDE] = ACTIONS(2998),
    [aux_sym_prefix_op_token1] = ACTIONS(2996),
    [aux_sym_infix_op_token1] = ACTIONS(2998),
    [aux_sym_infix_op_token2] = ACTIONS(2996),
    [anon_sym_PIPE_PIPE] = ACTIONS(2996),
    [anon_sym_BANG_EQ] = ACTIONS(2996),
    [anon_sym_COLON_EQ] = ACTIONS(2998),
    [anon_sym_DOLLAR] = ACTIONS(2996),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2996),
    [sym_int] = ACTIONS(2996),
    [sym_xint] = ACTIONS(2998),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2998),
    [sym__newline] = ACTIONS(2998),
  },
  [1889] = {
    [sym_block_comment] = STATE(1889),
    [sym_compiler_directive_decl] = STATE(1889),
    [sym_fsi_directive_decl] = STATE(1889),
    [sym_preproc_line] = STATE(1889),
    [sym_identifier] = ACTIONS(3003),
    [anon_sym_EQ] = ACTIONS(3005),
    [anon_sym_COLON] = ACTIONS(3003),
    [anon_sym_return] = ACTIONS(3003),
    [anon_sym_do] = ACTIONS(3003),
    [anon_sym_let] = ACTIONS(3003),
    [anon_sym_let_BANG] = ACTIONS(3005),
    [anon_sym_as] = ACTIONS(3003),
    [anon_sym_LPAREN] = ACTIONS(3003),
    [anon_sym_COMMA] = ACTIONS(3005),
    [anon_sym_null] = ACTIONS(3003),
    [anon_sym_QMARK] = ACTIONS(3003),
    [anon_sym_COLON_QMARK] = ACTIONS(3003),
    [anon_sym_COLON_COLON] = ACTIONS(3005),
    [anon_sym_AMP] = ACTIONS(3003),
    [anon_sym_LBRACK] = ACTIONS(3003),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3005),
    [anon_sym_LBRACE] = ACTIONS(3003),
    [anon_sym_LT_AT] = ACTIONS(3003),
    [anon_sym_LT_AT_AT] = ACTIONS(3003),
    [anon_sym_DOT] = ACTIONS(3003),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3005),
    [anon_sym_new] = ACTIONS(3003),
    [anon_sym_with] = ACTIONS(3003),
    [anon_sym_return_BANG] = ACTIONS(3005),
    [anon_sym_yield] = ACTIONS(3003),
    [anon_sym_yield_BANG] = ACTIONS(3005),
    [anon_sym_lazy] = ACTIONS(3003),
    [anon_sym_assert] = ACTIONS(3003),
    [anon_sym_upcast] = ACTIONS(3003),
    [anon_sym_downcast] = ACTIONS(3003),
    [anon_sym_COLON_GT] = ACTIONS(3005),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3005),
    [anon_sym_for] = ACTIONS(3003),
    [anon_sym_while] = ACTIONS(3003),
    [anon_sym_if] = ACTIONS(3003),
    [anon_sym_fun] = ACTIONS(3003),
    [anon_sym_try] = ACTIONS(3003),
    [anon_sym_match] = ACTIONS(3003),
    [anon_sym_match_BANG] = ACTIONS(3005),
    [anon_sym_function] = ACTIONS(3003),
    [anon_sym_LT_DASH] = ACTIONS(3003),
    [anon_sym_DOT_LBRACK] = ACTIONS(3005),
    [anon_sym_LT] = ACTIONS(3005),
    [anon_sym_use] = ACTIONS(3003),
    [anon_sym_use_BANG] = ACTIONS(3005),
    [anon_sym_do_BANG] = ACTIONS(3005),
    [anon_sym_begin] = ACTIONS(3003),
    [anon_sym_LPAREN2] = ACTIONS(3003),
    [anon_sym_or] = ACTIONS(3003),
    [aux_sym_char_token1] = ACTIONS(3005),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3003),
    [anon_sym_DQUOTE] = ACTIONS(3003),
    [anon_sym_AT_DQUOTE] = ACTIONS(3005),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3005),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3005),
    [sym_bool] = ACTIONS(3003),
    [sym_unit] = ACTIONS(3005),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3003),
    [sym_op_identifier] = ACTIONS(3003),
    [anon_sym_PLUS] = ACTIONS(3003),
    [anon_sym_DASH] = ACTIONS(3003),
    [anon_sym_PLUS_DOT] = ACTIONS(3003),
    [anon_sym_DASH_DOT] = ACTIONS(3003),
    [anon_sym_PERCENT] = ACTIONS(3003),
    [anon_sym_AMP_AMP] = ACTIONS(3003),
    [anon_sym_TILDE] = ACTIONS(3005),
    [aux_sym_prefix_op_token1] = ACTIONS(3003),
    [aux_sym_infix_op_token1] = ACTIONS(3005),
    [aux_sym_infix_op_token2] = ACTIONS(3003),
    [anon_sym_PIPE_PIPE] = ACTIONS(3003),
    [anon_sym_BANG_EQ] = ACTIONS(3003),
    [anon_sym_COLON_EQ] = ACTIONS(3005),
    [anon_sym_DOLLAR] = ACTIONS(3003),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3003),
    [sym_int] = ACTIONS(3003),
    [sym_xint] = ACTIONS(3005),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3005),
    [sym__newline] = ACTIONS(3005),
  },
  [1890] = {
    [sym_block_comment] = STATE(1890),
    [sym_compiler_directive_decl] = STATE(1890),
    [sym_fsi_directive_decl] = STATE(1890),
    [sym_preproc_line] = STATE(1890),
    [sym_identifier] = ACTIONS(2974),
    [anon_sym_EQ] = ACTIONS(2976),
    [anon_sym_COLON] = ACTIONS(2974),
    [anon_sym_return] = ACTIONS(2974),
    [anon_sym_do] = ACTIONS(2974),
    [anon_sym_let] = ACTIONS(2974),
    [anon_sym_let_BANG] = ACTIONS(2976),
    [anon_sym_LPAREN] = ACTIONS(2974),
    [anon_sym_COMMA] = ACTIONS(2976),
    [anon_sym_null] = ACTIONS(2974),
    [anon_sym_QMARK] = ACTIONS(2974),
    [anon_sym_COLON_QMARK] = ACTIONS(2974),
    [anon_sym_COLON_COLON] = ACTIONS(2976),
    [anon_sym_AMP] = ACTIONS(2974),
    [anon_sym_LBRACK] = ACTIONS(2974),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2976),
    [anon_sym_LBRACE] = ACTIONS(2974),
    [anon_sym_LT_AT] = ACTIONS(2974),
    [anon_sym_LT_AT_AT] = ACTIONS(2974),
    [anon_sym_DOT] = ACTIONS(2974),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2976),
    [anon_sym_new] = ACTIONS(2974),
    [anon_sym_return_BANG] = ACTIONS(2976),
    [anon_sym_yield] = ACTIONS(2974),
    [anon_sym_yield_BANG] = ACTIONS(2976),
    [anon_sym_lazy] = ACTIONS(2974),
    [anon_sym_assert] = ACTIONS(2974),
    [anon_sym_upcast] = ACTIONS(2974),
    [anon_sym_downcast] = ACTIONS(2974),
    [anon_sym_COLON_GT] = ACTIONS(2976),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2976),
    [anon_sym_for] = ACTIONS(2974),
    [anon_sym_while] = ACTIONS(2974),
    [anon_sym_if] = ACTIONS(2974),
    [anon_sym_fun] = ACTIONS(2974),
    [anon_sym_DASH_GT] = ACTIONS(2974),
    [anon_sym_try] = ACTIONS(2974),
    [anon_sym_match] = ACTIONS(2974),
    [anon_sym_match_BANG] = ACTIONS(2976),
    [anon_sym_function] = ACTIONS(2974),
    [anon_sym_LT_DASH] = ACTIONS(2974),
    [anon_sym_DOT_LBRACK] = ACTIONS(2976),
    [anon_sym_LT] = ACTIONS(2976),
    [anon_sym_use] = ACTIONS(2974),
    [anon_sym_use_BANG] = ACTIONS(2976),
    [anon_sym_do_BANG] = ACTIONS(2976),
    [anon_sym_DOT_DOT] = ACTIONS(2976),
    [anon_sym_begin] = ACTIONS(2974),
    [anon_sym_LPAREN2] = ACTIONS(2974),
    [anon_sym_or] = ACTIONS(2974),
    [aux_sym_char_token1] = ACTIONS(2976),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2974),
    [anon_sym_DQUOTE] = ACTIONS(2974),
    [anon_sym_AT_DQUOTE] = ACTIONS(2976),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2976),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2976),
    [sym_bool] = ACTIONS(2974),
    [sym_unit] = ACTIONS(2976),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2974),
    [sym_op_identifier] = ACTIONS(2974),
    [anon_sym_PLUS] = ACTIONS(2974),
    [anon_sym_DASH] = ACTIONS(2974),
    [anon_sym_PLUS_DOT] = ACTIONS(2974),
    [anon_sym_DASH_DOT] = ACTIONS(2974),
    [anon_sym_PERCENT] = ACTIONS(2974),
    [anon_sym_AMP_AMP] = ACTIONS(2974),
    [anon_sym_TILDE] = ACTIONS(2976),
    [aux_sym_prefix_op_token1] = ACTIONS(2974),
    [aux_sym_infix_op_token1] = ACTIONS(2976),
    [aux_sym_infix_op_token2] = ACTIONS(2974),
    [anon_sym_PIPE_PIPE] = ACTIONS(2974),
    [anon_sym_BANG_EQ] = ACTIONS(2974),
    [anon_sym_COLON_EQ] = ACTIONS(2976),
    [anon_sym_DOLLAR] = ACTIONS(2974),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2974),
    [sym_int] = ACTIONS(2974),
    [sym_xint] = ACTIONS(2976),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2976),
    [sym__newline] = ACTIONS(2976),
  },
  [1891] = {
    [sym_block_comment] = STATE(1891),
    [sym_compiler_directive_decl] = STATE(1891),
    [sym_fsi_directive_decl] = STATE(1891),
    [sym_preproc_line] = STATE(1891),
    [sym_identifier] = ACTIONS(3019),
    [anon_sym_EQ] = ACTIONS(3021),
    [anon_sym_COLON] = ACTIONS(3019),
    [anon_sym_return] = ACTIONS(3019),
    [anon_sym_do] = ACTIONS(3019),
    [anon_sym_let] = ACTIONS(3019),
    [anon_sym_let_BANG] = ACTIONS(3021),
    [anon_sym_LPAREN] = ACTIONS(3019),
    [anon_sym_COMMA] = ACTIONS(3021),
    [anon_sym_null] = ACTIONS(3019),
    [anon_sym_QMARK] = ACTIONS(3019),
    [anon_sym_COLON_QMARK] = ACTIONS(3019),
    [anon_sym_COLON_COLON] = ACTIONS(3021),
    [anon_sym_AMP] = ACTIONS(3019),
    [anon_sym_LBRACK] = ACTIONS(3019),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3021),
    [anon_sym_LBRACE] = ACTIONS(3019),
    [anon_sym_LT_AT] = ACTIONS(3019),
    [anon_sym_LT_AT_AT] = ACTIONS(3019),
    [anon_sym_DOT] = ACTIONS(3019),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3021),
    [anon_sym_new] = ACTIONS(3019),
    [anon_sym_return_BANG] = ACTIONS(3021),
    [anon_sym_yield] = ACTIONS(3019),
    [anon_sym_yield_BANG] = ACTIONS(3021),
    [anon_sym_lazy] = ACTIONS(3019),
    [anon_sym_assert] = ACTIONS(3019),
    [anon_sym_upcast] = ACTIONS(3019),
    [anon_sym_downcast] = ACTIONS(3019),
    [anon_sym_COLON_GT] = ACTIONS(3021),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3021),
    [anon_sym_for] = ACTIONS(3019),
    [anon_sym_while] = ACTIONS(3019),
    [anon_sym_if] = ACTIONS(3019),
    [anon_sym_fun] = ACTIONS(3019),
    [anon_sym_DASH_GT] = ACTIONS(3019),
    [anon_sym_try] = ACTIONS(3019),
    [anon_sym_match] = ACTIONS(3019),
    [anon_sym_match_BANG] = ACTIONS(3021),
    [anon_sym_function] = ACTIONS(3019),
    [anon_sym_LT_DASH] = ACTIONS(3019),
    [anon_sym_DOT_LBRACK] = ACTIONS(3021),
    [anon_sym_LT] = ACTIONS(3021),
    [anon_sym_use] = ACTIONS(3019),
    [anon_sym_use_BANG] = ACTIONS(3021),
    [anon_sym_do_BANG] = ACTIONS(3021),
    [anon_sym_DOT_DOT] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3019),
    [anon_sym_LPAREN2] = ACTIONS(3019),
    [anon_sym_or] = ACTIONS(3019),
    [aux_sym_char_token1] = ACTIONS(3021),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3019),
    [anon_sym_DQUOTE] = ACTIONS(3019),
    [anon_sym_AT_DQUOTE] = ACTIONS(3021),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3021),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3021),
    [sym_bool] = ACTIONS(3019),
    [sym_unit] = ACTIONS(3021),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3019),
    [sym_op_identifier] = ACTIONS(3019),
    [anon_sym_PLUS] = ACTIONS(3019),
    [anon_sym_DASH] = ACTIONS(3019),
    [anon_sym_PLUS_DOT] = ACTIONS(3019),
    [anon_sym_DASH_DOT] = ACTIONS(3019),
    [anon_sym_PERCENT] = ACTIONS(3019),
    [anon_sym_AMP_AMP] = ACTIONS(3019),
    [anon_sym_TILDE] = ACTIONS(3021),
    [aux_sym_prefix_op_token1] = ACTIONS(3019),
    [aux_sym_infix_op_token1] = ACTIONS(3021),
    [aux_sym_infix_op_token2] = ACTIONS(3019),
    [anon_sym_PIPE_PIPE] = ACTIONS(3019),
    [anon_sym_BANG_EQ] = ACTIONS(3019),
    [anon_sym_COLON_EQ] = ACTIONS(3021),
    [anon_sym_DOLLAR] = ACTIONS(3019),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3019),
    [sym_int] = ACTIONS(3019),
    [sym_xint] = ACTIONS(3021),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3021),
    [sym__newline] = ACTIONS(3021),
  },
  [1892] = {
    [sym_block_comment] = STATE(1892),
    [sym_compiler_directive_decl] = STATE(1892),
    [sym_fsi_directive_decl] = STATE(1892),
    [sym_preproc_line] = STATE(1892),
    [sym_identifier] = ACTIONS(3023),
    [anon_sym_EQ] = ACTIONS(3025),
    [anon_sym_COLON] = ACTIONS(3023),
    [anon_sym_return] = ACTIONS(3023),
    [anon_sym_do] = ACTIONS(3023),
    [anon_sym_let] = ACTIONS(3023),
    [anon_sym_let_BANG] = ACTIONS(3025),
    [anon_sym_LPAREN] = ACTIONS(3023),
    [anon_sym_COMMA] = ACTIONS(3025),
    [anon_sym_null] = ACTIONS(3023),
    [anon_sym_QMARK] = ACTIONS(3023),
    [anon_sym_COLON_QMARK] = ACTIONS(3023),
    [anon_sym_COLON_COLON] = ACTIONS(3025),
    [anon_sym_AMP] = ACTIONS(3023),
    [anon_sym_LBRACK] = ACTIONS(3023),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3025),
    [anon_sym_LBRACE] = ACTIONS(3023),
    [anon_sym_LT_AT] = ACTIONS(3023),
    [anon_sym_LT_AT_AT] = ACTIONS(3023),
    [anon_sym_DOT] = ACTIONS(3023),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3025),
    [anon_sym_new] = ACTIONS(3023),
    [anon_sym_return_BANG] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(3023),
    [anon_sym_yield_BANG] = ACTIONS(3025),
    [anon_sym_lazy] = ACTIONS(3023),
    [anon_sym_assert] = ACTIONS(3023),
    [anon_sym_upcast] = ACTIONS(3023),
    [anon_sym_downcast] = ACTIONS(3023),
    [anon_sym_COLON_GT] = ACTIONS(3025),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3025),
    [anon_sym_for] = ACTIONS(3023),
    [anon_sym_while] = ACTIONS(3023),
    [anon_sym_if] = ACTIONS(3023),
    [anon_sym_fun] = ACTIONS(3023),
    [anon_sym_DASH_GT] = ACTIONS(3023),
    [anon_sym_try] = ACTIONS(3023),
    [anon_sym_match] = ACTIONS(3023),
    [anon_sym_match_BANG] = ACTIONS(3025),
    [anon_sym_function] = ACTIONS(3023),
    [anon_sym_LT_DASH] = ACTIONS(3023),
    [anon_sym_DOT_LBRACK] = ACTIONS(3025),
    [anon_sym_LT] = ACTIONS(3025),
    [anon_sym_use] = ACTIONS(3023),
    [anon_sym_use_BANG] = ACTIONS(3025),
    [anon_sym_do_BANG] = ACTIONS(3025),
    [anon_sym_DOT_DOT] = ACTIONS(3025),
    [anon_sym_begin] = ACTIONS(3023),
    [anon_sym_LPAREN2] = ACTIONS(3023),
    [anon_sym_or] = ACTIONS(3023),
    [aux_sym_char_token1] = ACTIONS(3025),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3023),
    [anon_sym_DQUOTE] = ACTIONS(3023),
    [anon_sym_AT_DQUOTE] = ACTIONS(3025),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3025),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3025),
    [sym_bool] = ACTIONS(3023),
    [sym_unit] = ACTIONS(3025),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3023),
    [sym_op_identifier] = ACTIONS(3023),
    [anon_sym_PLUS] = ACTIONS(3023),
    [anon_sym_DASH] = ACTIONS(3023),
    [anon_sym_PLUS_DOT] = ACTIONS(3023),
    [anon_sym_DASH_DOT] = ACTIONS(3023),
    [anon_sym_PERCENT] = ACTIONS(3023),
    [anon_sym_AMP_AMP] = ACTIONS(3023),
    [anon_sym_TILDE] = ACTIONS(3025),
    [aux_sym_prefix_op_token1] = ACTIONS(3023),
    [aux_sym_infix_op_token1] = ACTIONS(3025),
    [aux_sym_infix_op_token2] = ACTIONS(3023),
    [anon_sym_PIPE_PIPE] = ACTIONS(3023),
    [anon_sym_BANG_EQ] = ACTIONS(3023),
    [anon_sym_COLON_EQ] = ACTIONS(3025),
    [anon_sym_DOLLAR] = ACTIONS(3023),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3023),
    [sym_int] = ACTIONS(3023),
    [sym_xint] = ACTIONS(3025),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3025),
    [sym__newline] = ACTIONS(3025),
  },
  [1893] = {
    [sym_block_comment] = STATE(1893),
    [sym_compiler_directive_decl] = STATE(1893),
    [sym_fsi_directive_decl] = STATE(1893),
    [sym_preproc_line] = STATE(1893),
    [sym_identifier] = ACTIONS(2411),
    [anon_sym_EQ] = ACTIONS(2413),
    [anon_sym_COLON] = ACTIONS(2411),
    [anon_sym_return] = ACTIONS(2411),
    [anon_sym_do] = ACTIONS(2411),
    [anon_sym_let] = ACTIONS(2411),
    [anon_sym_let_BANG] = ACTIONS(2413),
    [anon_sym_LPAREN] = ACTIONS(2411),
    [anon_sym_COMMA] = ACTIONS(2413),
    [anon_sym_null] = ACTIONS(2411),
    [anon_sym_QMARK] = ACTIONS(2411),
    [anon_sym_COLON_QMARK] = ACTIONS(2411),
    [anon_sym_COLON_COLON] = ACTIONS(2413),
    [anon_sym_AMP] = ACTIONS(2411),
    [anon_sym_LBRACK] = ACTIONS(2411),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2413),
    [anon_sym_LBRACE] = ACTIONS(2411),
    [anon_sym_LT_AT] = ACTIONS(2411),
    [anon_sym_LT_AT_AT] = ACTIONS(2411),
    [anon_sym_DOT] = ACTIONS(2411),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2413),
    [anon_sym_new] = ACTIONS(2411),
    [anon_sym_return_BANG] = ACTIONS(2413),
    [anon_sym_yield] = ACTIONS(2411),
    [anon_sym_yield_BANG] = ACTIONS(2413),
    [anon_sym_lazy] = ACTIONS(2411),
    [anon_sym_assert] = ACTIONS(2411),
    [anon_sym_upcast] = ACTIONS(2411),
    [anon_sym_downcast] = ACTIONS(2411),
    [anon_sym_COLON_GT] = ACTIONS(2413),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2413),
    [anon_sym_for] = ACTIONS(2411),
    [anon_sym_while] = ACTIONS(2411),
    [anon_sym_if] = ACTIONS(2411),
    [anon_sym_fun] = ACTIONS(2411),
    [anon_sym_try] = ACTIONS(2411),
    [anon_sym_match] = ACTIONS(2411),
    [anon_sym_match_BANG] = ACTIONS(2413),
    [anon_sym_function] = ACTIONS(2411),
    [anon_sym_LT_DASH] = ACTIONS(2411),
    [anon_sym_DOT_LBRACK] = ACTIONS(2413),
    [anon_sym_LT] = ACTIONS(2413),
    [anon_sym_use] = ACTIONS(2411),
    [anon_sym_use_BANG] = ACTIONS(2413),
    [anon_sym_do_BANG] = ACTIONS(2413),
    [anon_sym_begin] = ACTIONS(2411),
    [anon_sym_LPAREN2] = ACTIONS(2411),
    [anon_sym_or] = ACTIONS(2411),
    [aux_sym_char_token1] = ACTIONS(2413),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2411),
    [anon_sym_DQUOTE] = ACTIONS(2411),
    [anon_sym_AT_DQUOTE] = ACTIONS(2413),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2413),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2413),
    [sym_bool] = ACTIONS(2411),
    [sym_unit] = ACTIONS(2413),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2411),
    [sym_op_identifier] = ACTIONS(2411),
    [anon_sym_PLUS] = ACTIONS(2411),
    [anon_sym_DASH] = ACTIONS(2411),
    [anon_sym_PLUS_DOT] = ACTIONS(2411),
    [anon_sym_DASH_DOT] = ACTIONS(2411),
    [anon_sym_PERCENT] = ACTIONS(2411),
    [anon_sym_AMP_AMP] = ACTIONS(2411),
    [anon_sym_TILDE] = ACTIONS(2413),
    [aux_sym_prefix_op_token1] = ACTIONS(2411),
    [aux_sym_infix_op_token1] = ACTIONS(2413),
    [aux_sym_infix_op_token2] = ACTIONS(2411),
    [anon_sym_PIPE_PIPE] = ACTIONS(2411),
    [anon_sym_BANG_EQ] = ACTIONS(2411),
    [anon_sym_COLON_EQ] = ACTIONS(2413),
    [anon_sym_DOLLAR] = ACTIONS(2411),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2411),
    [sym_int] = ACTIONS(2411),
    [sym_xint] = ACTIONS(2413),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2413),
    [anon_sym_POUNDendif] = ACTIONS(2413),
    [anon_sym_POUNDelse] = ACTIONS(2413),
    [sym__newline] = ACTIONS(2413),
  },
  [1894] = {
    [sym_block_comment] = STATE(1894),
    [sym_compiler_directive_decl] = STATE(1894),
    [sym_fsi_directive_decl] = STATE(1894),
    [sym_preproc_line] = STATE(1894),
    [sym_identifier] = ACTIONS(3115),
    [anon_sym_EQ] = ACTIONS(3117),
    [anon_sym_COLON] = ACTIONS(3115),
    [anon_sym_return] = ACTIONS(3115),
    [anon_sym_do] = ACTIONS(3115),
    [anon_sym_let] = ACTIONS(3115),
    [anon_sym_let_BANG] = ACTIONS(3117),
    [anon_sym_LPAREN] = ACTIONS(3115),
    [anon_sym_COMMA] = ACTIONS(3117),
    [anon_sym_null] = ACTIONS(3115),
    [anon_sym_QMARK] = ACTIONS(3115),
    [anon_sym_COLON_QMARK] = ACTIONS(3115),
    [anon_sym_COLON_COLON] = ACTIONS(3117),
    [anon_sym_AMP] = ACTIONS(3115),
    [anon_sym_LBRACK] = ACTIONS(3115),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3117),
    [anon_sym_LBRACE] = ACTIONS(3115),
    [anon_sym_LT_AT] = ACTIONS(3115),
    [anon_sym_LT_AT_AT] = ACTIONS(3115),
    [anon_sym_DOT] = ACTIONS(3115),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3117),
    [anon_sym_new] = ACTIONS(3115),
    [anon_sym_return_BANG] = ACTIONS(3117),
    [anon_sym_yield] = ACTIONS(3115),
    [anon_sym_yield_BANG] = ACTIONS(3117),
    [anon_sym_lazy] = ACTIONS(3115),
    [anon_sym_assert] = ACTIONS(3115),
    [anon_sym_upcast] = ACTIONS(3115),
    [anon_sym_downcast] = ACTIONS(3115),
    [anon_sym_COLON_GT] = ACTIONS(3117),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3117),
    [anon_sym_for] = ACTIONS(3115),
    [anon_sym_while] = ACTIONS(3115),
    [anon_sym_if] = ACTIONS(3115),
    [anon_sym_fun] = ACTIONS(3115),
    [anon_sym_try] = ACTIONS(3115),
    [anon_sym_match] = ACTIONS(3115),
    [anon_sym_match_BANG] = ACTIONS(3117),
    [anon_sym_function] = ACTIONS(3115),
    [anon_sym_LT_DASH] = ACTIONS(3115),
    [anon_sym_DOT_LBRACK] = ACTIONS(3117),
    [anon_sym_LT] = ACTIONS(3117),
    [anon_sym_use] = ACTIONS(3115),
    [anon_sym_use_BANG] = ACTIONS(3117),
    [anon_sym_do_BANG] = ACTIONS(3117),
    [anon_sym_begin] = ACTIONS(3115),
    [anon_sym_LPAREN2] = ACTIONS(3115),
    [anon_sym_or] = ACTIONS(3115),
    [aux_sym_char_token1] = ACTIONS(3117),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3115),
    [anon_sym_DQUOTE] = ACTIONS(3115),
    [anon_sym_AT_DQUOTE] = ACTIONS(3117),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3117),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3117),
    [sym_bool] = ACTIONS(3115),
    [sym_unit] = ACTIONS(3117),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3115),
    [sym_op_identifier] = ACTIONS(3115),
    [anon_sym_PLUS] = ACTIONS(3115),
    [anon_sym_DASH] = ACTIONS(3115),
    [anon_sym_PLUS_DOT] = ACTIONS(3115),
    [anon_sym_DASH_DOT] = ACTIONS(3115),
    [anon_sym_PERCENT] = ACTIONS(3115),
    [anon_sym_AMP_AMP] = ACTIONS(3115),
    [anon_sym_TILDE] = ACTIONS(3117),
    [aux_sym_prefix_op_token1] = ACTIONS(3115),
    [aux_sym_infix_op_token1] = ACTIONS(3117),
    [aux_sym_infix_op_token2] = ACTIONS(3115),
    [anon_sym_PIPE_PIPE] = ACTIONS(3115),
    [anon_sym_BANG_EQ] = ACTIONS(3115),
    [anon_sym_COLON_EQ] = ACTIONS(3117),
    [anon_sym_DOLLAR] = ACTIONS(3115),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3115),
    [sym_int] = ACTIONS(3115),
    [sym_xint] = ACTIONS(3117),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3117),
    [anon_sym_POUNDendif] = ACTIONS(3117),
    [anon_sym_POUNDelse] = ACTIONS(3117),
    [sym__newline] = ACTIONS(3117),
  },
  [1895] = {
    [sym_block_comment] = STATE(1895),
    [sym_compiler_directive_decl] = STATE(1895),
    [sym_fsi_directive_decl] = STATE(1895),
    [sym_preproc_line] = STATE(1895),
    [sym_identifier] = ACTIONS(3027),
    [anon_sym_EQ] = ACTIONS(3029),
    [anon_sym_COLON] = ACTIONS(3027),
    [anon_sym_return] = ACTIONS(3027),
    [anon_sym_do] = ACTIONS(3027),
    [anon_sym_let] = ACTIONS(3027),
    [anon_sym_let_BANG] = ACTIONS(3029),
    [anon_sym_LPAREN] = ACTIONS(3027),
    [anon_sym_COMMA] = ACTIONS(3029),
    [anon_sym_null] = ACTIONS(3027),
    [anon_sym_QMARK] = ACTIONS(3027),
    [anon_sym_COLON_QMARK] = ACTIONS(3027),
    [anon_sym_COLON_COLON] = ACTIONS(3029),
    [anon_sym_AMP] = ACTIONS(3027),
    [anon_sym_LBRACK] = ACTIONS(3027),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3027),
    [anon_sym_LT_AT] = ACTIONS(3027),
    [anon_sym_LT_AT_AT] = ACTIONS(3027),
    [anon_sym_DOT] = ACTIONS(3027),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3029),
    [anon_sym_new] = ACTIONS(3027),
    [anon_sym_return_BANG] = ACTIONS(3029),
    [anon_sym_yield] = ACTIONS(3027),
    [anon_sym_yield_BANG] = ACTIONS(3029),
    [anon_sym_lazy] = ACTIONS(3027),
    [anon_sym_assert] = ACTIONS(3027),
    [anon_sym_upcast] = ACTIONS(3027),
    [anon_sym_downcast] = ACTIONS(3027),
    [anon_sym_COLON_GT] = ACTIONS(3029),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3029),
    [anon_sym_for] = ACTIONS(3027),
    [anon_sym_while] = ACTIONS(3027),
    [anon_sym_if] = ACTIONS(3027),
    [anon_sym_fun] = ACTIONS(3027),
    [anon_sym_DASH_GT] = ACTIONS(3027),
    [anon_sym_try] = ACTIONS(3027),
    [anon_sym_match] = ACTIONS(3027),
    [anon_sym_match_BANG] = ACTIONS(3029),
    [anon_sym_function] = ACTIONS(3027),
    [anon_sym_LT_DASH] = ACTIONS(3027),
    [anon_sym_DOT_LBRACK] = ACTIONS(3029),
    [anon_sym_LT] = ACTIONS(3029),
    [anon_sym_use] = ACTIONS(3027),
    [anon_sym_use_BANG] = ACTIONS(3029),
    [anon_sym_do_BANG] = ACTIONS(3029),
    [anon_sym_DOT_DOT] = ACTIONS(3029),
    [anon_sym_begin] = ACTIONS(3027),
    [anon_sym_LPAREN2] = ACTIONS(3027),
    [anon_sym_or] = ACTIONS(3027),
    [aux_sym_char_token1] = ACTIONS(3029),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3027),
    [anon_sym_DQUOTE] = ACTIONS(3027),
    [anon_sym_AT_DQUOTE] = ACTIONS(3029),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3029),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3029),
    [sym_bool] = ACTIONS(3027),
    [sym_unit] = ACTIONS(3029),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3027),
    [sym_op_identifier] = ACTIONS(3027),
    [anon_sym_PLUS] = ACTIONS(3027),
    [anon_sym_DASH] = ACTIONS(3027),
    [anon_sym_PLUS_DOT] = ACTIONS(3027),
    [anon_sym_DASH_DOT] = ACTIONS(3027),
    [anon_sym_PERCENT] = ACTIONS(3027),
    [anon_sym_AMP_AMP] = ACTIONS(3027),
    [anon_sym_TILDE] = ACTIONS(3029),
    [aux_sym_prefix_op_token1] = ACTIONS(3027),
    [aux_sym_infix_op_token1] = ACTIONS(3029),
    [aux_sym_infix_op_token2] = ACTIONS(3027),
    [anon_sym_PIPE_PIPE] = ACTIONS(3027),
    [anon_sym_BANG_EQ] = ACTIONS(3027),
    [anon_sym_COLON_EQ] = ACTIONS(3029),
    [anon_sym_DOLLAR] = ACTIONS(3027),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3027),
    [sym_int] = ACTIONS(3027),
    [sym_xint] = ACTIONS(3029),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3029),
    [sym__newline] = ACTIONS(3029),
  },
  [1896] = {
    [sym_block_comment] = STATE(1896),
    [sym_compiler_directive_decl] = STATE(1896),
    [sym_fsi_directive_decl] = STATE(1896),
    [sym_preproc_line] = STATE(1896),
    [sym_identifier] = ACTIONS(3007),
    [anon_sym_EQ] = ACTIONS(3009),
    [anon_sym_COLON] = ACTIONS(3007),
    [anon_sym_return] = ACTIONS(3007),
    [anon_sym_do] = ACTIONS(3007),
    [anon_sym_let] = ACTIONS(3007),
    [anon_sym_let_BANG] = ACTIONS(3009),
    [anon_sym_as] = ACTIONS(3007),
    [anon_sym_LPAREN] = ACTIONS(3007),
    [anon_sym_COMMA] = ACTIONS(3009),
    [anon_sym_null] = ACTIONS(3007),
    [anon_sym_QMARK] = ACTIONS(3007),
    [anon_sym_COLON_QMARK] = ACTIONS(3007),
    [anon_sym_COLON_COLON] = ACTIONS(3009),
    [anon_sym_AMP] = ACTIONS(3007),
    [anon_sym_LBRACK] = ACTIONS(3007),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3009),
    [anon_sym_LBRACE] = ACTIONS(3007),
    [anon_sym_LT_AT] = ACTIONS(3007),
    [anon_sym_LT_AT_AT] = ACTIONS(3007),
    [anon_sym_DOT] = ACTIONS(3007),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3009),
    [anon_sym_new] = ACTIONS(3007),
    [anon_sym_with] = ACTIONS(3007),
    [anon_sym_return_BANG] = ACTIONS(3009),
    [anon_sym_yield] = ACTIONS(3007),
    [anon_sym_yield_BANG] = ACTIONS(3009),
    [anon_sym_lazy] = ACTIONS(3007),
    [anon_sym_assert] = ACTIONS(3007),
    [anon_sym_upcast] = ACTIONS(3007),
    [anon_sym_downcast] = ACTIONS(3007),
    [anon_sym_COLON_GT] = ACTIONS(3009),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3009),
    [anon_sym_for] = ACTIONS(3007),
    [anon_sym_while] = ACTIONS(3007),
    [anon_sym_if] = ACTIONS(3007),
    [anon_sym_fun] = ACTIONS(3007),
    [anon_sym_try] = ACTIONS(3007),
    [anon_sym_match] = ACTIONS(3007),
    [anon_sym_match_BANG] = ACTIONS(3009),
    [anon_sym_function] = ACTIONS(3007),
    [anon_sym_LT_DASH] = ACTIONS(3007),
    [anon_sym_DOT_LBRACK] = ACTIONS(3009),
    [anon_sym_LT] = ACTIONS(3009),
    [anon_sym_use] = ACTIONS(3007),
    [anon_sym_use_BANG] = ACTIONS(3009),
    [anon_sym_do_BANG] = ACTIONS(3009),
    [anon_sym_begin] = ACTIONS(3007),
    [anon_sym_LPAREN2] = ACTIONS(3007),
    [anon_sym_or] = ACTIONS(3007),
    [aux_sym_char_token1] = ACTIONS(3009),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3007),
    [anon_sym_DQUOTE] = ACTIONS(3007),
    [anon_sym_AT_DQUOTE] = ACTIONS(3009),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3009),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3009),
    [sym_bool] = ACTIONS(3007),
    [sym_unit] = ACTIONS(3009),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3007),
    [sym_op_identifier] = ACTIONS(3007),
    [anon_sym_PLUS] = ACTIONS(3007),
    [anon_sym_DASH] = ACTIONS(3007),
    [anon_sym_PLUS_DOT] = ACTIONS(3007),
    [anon_sym_DASH_DOT] = ACTIONS(3007),
    [anon_sym_PERCENT] = ACTIONS(3007),
    [anon_sym_AMP_AMP] = ACTIONS(3007),
    [anon_sym_TILDE] = ACTIONS(3009),
    [aux_sym_prefix_op_token1] = ACTIONS(3007),
    [aux_sym_infix_op_token1] = ACTIONS(3009),
    [aux_sym_infix_op_token2] = ACTIONS(3007),
    [anon_sym_PIPE_PIPE] = ACTIONS(3007),
    [anon_sym_BANG_EQ] = ACTIONS(3007),
    [anon_sym_COLON_EQ] = ACTIONS(3009),
    [anon_sym_DOLLAR] = ACTIONS(3007),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3007),
    [sym_int] = ACTIONS(3007),
    [sym_xint] = ACTIONS(3009),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3009),
    [sym__newline] = ACTIONS(3009),
  },
  [1897] = {
    [sym_block_comment] = STATE(1897),
    [sym_compiler_directive_decl] = STATE(1897),
    [sym_fsi_directive_decl] = STATE(1897),
    [sym_preproc_line] = STATE(1897),
    [sym_identifier] = ACTIONS(3031),
    [anon_sym_EQ] = ACTIONS(3033),
    [anon_sym_COLON] = ACTIONS(3031),
    [anon_sym_return] = ACTIONS(3031),
    [anon_sym_do] = ACTIONS(3031),
    [anon_sym_let] = ACTIONS(3031),
    [anon_sym_let_BANG] = ACTIONS(3033),
    [anon_sym_LPAREN] = ACTIONS(3031),
    [anon_sym_COMMA] = ACTIONS(3033),
    [anon_sym_null] = ACTIONS(3031),
    [anon_sym_QMARK] = ACTIONS(3031),
    [anon_sym_COLON_QMARK] = ACTIONS(3031),
    [anon_sym_COLON_COLON] = ACTIONS(3033),
    [anon_sym_AMP] = ACTIONS(3031),
    [anon_sym_LBRACK] = ACTIONS(3031),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3033),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [anon_sym_LT_AT] = ACTIONS(3031),
    [anon_sym_LT_AT_AT] = ACTIONS(3031),
    [anon_sym_DOT] = ACTIONS(3031),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3033),
    [anon_sym_new] = ACTIONS(3031),
    [anon_sym_return_BANG] = ACTIONS(3033),
    [anon_sym_yield] = ACTIONS(3031),
    [anon_sym_yield_BANG] = ACTIONS(3033),
    [anon_sym_lazy] = ACTIONS(3031),
    [anon_sym_assert] = ACTIONS(3031),
    [anon_sym_upcast] = ACTIONS(3031),
    [anon_sym_downcast] = ACTIONS(3031),
    [anon_sym_COLON_GT] = ACTIONS(3033),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3033),
    [anon_sym_for] = ACTIONS(3031),
    [anon_sym_while] = ACTIONS(3031),
    [anon_sym_if] = ACTIONS(3031),
    [anon_sym_fun] = ACTIONS(3031),
    [anon_sym_DASH_GT] = ACTIONS(3031),
    [anon_sym_try] = ACTIONS(3031),
    [anon_sym_match] = ACTIONS(3031),
    [anon_sym_match_BANG] = ACTIONS(3033),
    [anon_sym_function] = ACTIONS(3031),
    [anon_sym_LT_DASH] = ACTIONS(3031),
    [anon_sym_DOT_LBRACK] = ACTIONS(3033),
    [anon_sym_LT] = ACTIONS(3033),
    [anon_sym_use] = ACTIONS(3031),
    [anon_sym_use_BANG] = ACTIONS(3033),
    [anon_sym_do_BANG] = ACTIONS(3033),
    [anon_sym_DOT_DOT] = ACTIONS(3033),
    [anon_sym_begin] = ACTIONS(3031),
    [anon_sym_LPAREN2] = ACTIONS(3031),
    [anon_sym_or] = ACTIONS(3031),
    [aux_sym_char_token1] = ACTIONS(3033),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3031),
    [anon_sym_DQUOTE] = ACTIONS(3031),
    [anon_sym_AT_DQUOTE] = ACTIONS(3033),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3033),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3033),
    [sym_bool] = ACTIONS(3031),
    [sym_unit] = ACTIONS(3033),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3031),
    [sym_op_identifier] = ACTIONS(3031),
    [anon_sym_PLUS] = ACTIONS(3031),
    [anon_sym_DASH] = ACTIONS(3031),
    [anon_sym_PLUS_DOT] = ACTIONS(3031),
    [anon_sym_DASH_DOT] = ACTIONS(3031),
    [anon_sym_PERCENT] = ACTIONS(3031),
    [anon_sym_AMP_AMP] = ACTIONS(3031),
    [anon_sym_TILDE] = ACTIONS(3033),
    [aux_sym_prefix_op_token1] = ACTIONS(3031),
    [aux_sym_infix_op_token1] = ACTIONS(3033),
    [aux_sym_infix_op_token2] = ACTIONS(3031),
    [anon_sym_PIPE_PIPE] = ACTIONS(3031),
    [anon_sym_BANG_EQ] = ACTIONS(3031),
    [anon_sym_COLON_EQ] = ACTIONS(3033),
    [anon_sym_DOLLAR] = ACTIONS(3031),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3031),
    [sym_int] = ACTIONS(3031),
    [sym_xint] = ACTIONS(3033),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3033),
    [sym__newline] = ACTIONS(3033),
  },
  [1898] = {
    [sym_block_comment] = STATE(1898),
    [sym_compiler_directive_decl] = STATE(1898),
    [sym_fsi_directive_decl] = STATE(1898),
    [sym_preproc_line] = STATE(1898),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_EQ] = ACTIONS(3017),
    [anon_sym_COLON] = ACTIONS(3015),
    [anon_sym_return] = ACTIONS(3015),
    [anon_sym_do] = ACTIONS(3015),
    [anon_sym_let] = ACTIONS(3015),
    [anon_sym_let_BANG] = ACTIONS(3017),
    [anon_sym_as] = ACTIONS(3015),
    [anon_sym_LPAREN] = ACTIONS(3015),
    [anon_sym_COMMA] = ACTIONS(3017),
    [anon_sym_null] = ACTIONS(3015),
    [anon_sym_QMARK] = ACTIONS(3015),
    [anon_sym_COLON_QMARK] = ACTIONS(3015),
    [anon_sym_COLON_COLON] = ACTIONS(3017),
    [anon_sym_AMP] = ACTIONS(3015),
    [anon_sym_LBRACK] = ACTIONS(3015),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3017),
    [anon_sym_LBRACE] = ACTIONS(3015),
    [anon_sym_LT_AT] = ACTIONS(3015),
    [anon_sym_LT_AT_AT] = ACTIONS(3015),
    [anon_sym_DOT] = ACTIONS(3015),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3017),
    [anon_sym_new] = ACTIONS(3015),
    [anon_sym_with] = ACTIONS(3015),
    [anon_sym_return_BANG] = ACTIONS(3017),
    [anon_sym_yield] = ACTIONS(3015),
    [anon_sym_yield_BANG] = ACTIONS(3017),
    [anon_sym_lazy] = ACTIONS(3015),
    [anon_sym_assert] = ACTIONS(3015),
    [anon_sym_upcast] = ACTIONS(3015),
    [anon_sym_downcast] = ACTIONS(3015),
    [anon_sym_COLON_GT] = ACTIONS(3017),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3017),
    [anon_sym_for] = ACTIONS(3015),
    [anon_sym_while] = ACTIONS(3015),
    [anon_sym_if] = ACTIONS(3015),
    [anon_sym_fun] = ACTIONS(3015),
    [anon_sym_try] = ACTIONS(3015),
    [anon_sym_match] = ACTIONS(3015),
    [anon_sym_match_BANG] = ACTIONS(3017),
    [anon_sym_function] = ACTIONS(3015),
    [anon_sym_LT_DASH] = ACTIONS(3015),
    [anon_sym_DOT_LBRACK] = ACTIONS(3017),
    [anon_sym_LT] = ACTIONS(3017),
    [anon_sym_use] = ACTIONS(3015),
    [anon_sym_use_BANG] = ACTIONS(3017),
    [anon_sym_do_BANG] = ACTIONS(3017),
    [anon_sym_begin] = ACTIONS(3015),
    [anon_sym_LPAREN2] = ACTIONS(3015),
    [anon_sym_or] = ACTIONS(3015),
    [aux_sym_char_token1] = ACTIONS(3017),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3015),
    [anon_sym_DQUOTE] = ACTIONS(3015),
    [anon_sym_AT_DQUOTE] = ACTIONS(3017),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3017),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3017),
    [sym_bool] = ACTIONS(3015),
    [sym_unit] = ACTIONS(3017),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3015),
    [sym_op_identifier] = ACTIONS(3015),
    [anon_sym_PLUS] = ACTIONS(3015),
    [anon_sym_DASH] = ACTIONS(3015),
    [anon_sym_PLUS_DOT] = ACTIONS(3015),
    [anon_sym_DASH_DOT] = ACTIONS(3015),
    [anon_sym_PERCENT] = ACTIONS(3015),
    [anon_sym_AMP_AMP] = ACTIONS(3015),
    [anon_sym_TILDE] = ACTIONS(3017),
    [aux_sym_prefix_op_token1] = ACTIONS(3015),
    [aux_sym_infix_op_token1] = ACTIONS(3017),
    [aux_sym_infix_op_token2] = ACTIONS(3015),
    [anon_sym_PIPE_PIPE] = ACTIONS(3015),
    [anon_sym_BANG_EQ] = ACTIONS(3015),
    [anon_sym_COLON_EQ] = ACTIONS(3017),
    [anon_sym_DOLLAR] = ACTIONS(3015),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3015),
    [sym_int] = ACTIONS(3015),
    [sym_xint] = ACTIONS(3017),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3017),
    [sym__newline] = ACTIONS(3017),
  },
  [1899] = {
    [sym_block_comment] = STATE(1899),
    [sym_compiler_directive_decl] = STATE(1899),
    [sym_fsi_directive_decl] = STATE(1899),
    [sym_preproc_line] = STATE(1899),
    [sym_identifier] = ACTIONS(3035),
    [anon_sym_EQ] = ACTIONS(3037),
    [anon_sym_COLON] = ACTIONS(3035),
    [anon_sym_return] = ACTIONS(3035),
    [anon_sym_do] = ACTIONS(3035),
    [anon_sym_let] = ACTIONS(3035),
    [anon_sym_let_BANG] = ACTIONS(3037),
    [anon_sym_LPAREN] = ACTIONS(3035),
    [anon_sym_COMMA] = ACTIONS(3037),
    [anon_sym_null] = ACTIONS(3035),
    [anon_sym_QMARK] = ACTIONS(3035),
    [anon_sym_COLON_QMARK] = ACTIONS(3035),
    [anon_sym_COLON_COLON] = ACTIONS(3037),
    [anon_sym_AMP] = ACTIONS(3035),
    [anon_sym_LBRACK] = ACTIONS(3035),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3037),
    [anon_sym_LBRACE] = ACTIONS(3035),
    [anon_sym_LT_AT] = ACTIONS(3035),
    [anon_sym_LT_AT_AT] = ACTIONS(3035),
    [anon_sym_DOT] = ACTIONS(3035),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3037),
    [anon_sym_new] = ACTIONS(3035),
    [anon_sym_return_BANG] = ACTIONS(3037),
    [anon_sym_yield] = ACTIONS(3035),
    [anon_sym_yield_BANG] = ACTIONS(3037),
    [anon_sym_lazy] = ACTIONS(3035),
    [anon_sym_assert] = ACTIONS(3035),
    [anon_sym_upcast] = ACTIONS(3035),
    [anon_sym_downcast] = ACTIONS(3035),
    [anon_sym_COLON_GT] = ACTIONS(3037),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3037),
    [anon_sym_for] = ACTIONS(3035),
    [anon_sym_while] = ACTIONS(3035),
    [anon_sym_if] = ACTIONS(3035),
    [anon_sym_fun] = ACTIONS(3035),
    [anon_sym_DASH_GT] = ACTIONS(3035),
    [anon_sym_try] = ACTIONS(3035),
    [anon_sym_match] = ACTIONS(3035),
    [anon_sym_match_BANG] = ACTIONS(3037),
    [anon_sym_function] = ACTIONS(3035),
    [anon_sym_LT_DASH] = ACTIONS(3035),
    [anon_sym_DOT_LBRACK] = ACTIONS(3037),
    [anon_sym_LT] = ACTIONS(3037),
    [anon_sym_use] = ACTIONS(3035),
    [anon_sym_use_BANG] = ACTIONS(3037),
    [anon_sym_do_BANG] = ACTIONS(3037),
    [anon_sym_DOT_DOT] = ACTIONS(3037),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_LPAREN2] = ACTIONS(3035),
    [anon_sym_or] = ACTIONS(3035),
    [aux_sym_char_token1] = ACTIONS(3037),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3035),
    [anon_sym_DQUOTE] = ACTIONS(3035),
    [anon_sym_AT_DQUOTE] = ACTIONS(3037),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3037),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3037),
    [sym_bool] = ACTIONS(3035),
    [sym_unit] = ACTIONS(3037),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3035),
    [sym_op_identifier] = ACTIONS(3035),
    [anon_sym_PLUS] = ACTIONS(3035),
    [anon_sym_DASH] = ACTIONS(3035),
    [anon_sym_PLUS_DOT] = ACTIONS(3035),
    [anon_sym_DASH_DOT] = ACTIONS(3035),
    [anon_sym_PERCENT] = ACTIONS(3035),
    [anon_sym_AMP_AMP] = ACTIONS(3035),
    [anon_sym_TILDE] = ACTIONS(3037),
    [aux_sym_prefix_op_token1] = ACTIONS(3035),
    [aux_sym_infix_op_token1] = ACTIONS(3037),
    [aux_sym_infix_op_token2] = ACTIONS(3035),
    [anon_sym_PIPE_PIPE] = ACTIONS(3035),
    [anon_sym_BANG_EQ] = ACTIONS(3035),
    [anon_sym_COLON_EQ] = ACTIONS(3037),
    [anon_sym_DOLLAR] = ACTIONS(3035),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3035),
    [sym_int] = ACTIONS(3035),
    [sym_xint] = ACTIONS(3037),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3037),
    [sym__newline] = ACTIONS(3037),
  },
  [1900] = {
    [sym_block_comment] = STATE(1900),
    [sym_compiler_directive_decl] = STATE(1900),
    [sym_fsi_directive_decl] = STATE(1900),
    [sym_preproc_line] = STATE(1900),
    [sym_identifier] = ACTIONS(2942),
    [anon_sym_EQ] = ACTIONS(2944),
    [anon_sym_COLON] = ACTIONS(2942),
    [anon_sym_return] = ACTIONS(2942),
    [anon_sym_do] = ACTIONS(2942),
    [anon_sym_and] = ACTIONS(2942),
    [anon_sym_let] = ACTIONS(2942),
    [anon_sym_let_BANG] = ACTIONS(2944),
    [anon_sym_LPAREN] = ACTIONS(2942),
    [anon_sym_COMMA] = ACTIONS(2944),
    [anon_sym_null] = ACTIONS(2942),
    [anon_sym_QMARK] = ACTIONS(2942),
    [anon_sym_COLON_QMARK] = ACTIONS(2942),
    [anon_sym_COLON_COLON] = ACTIONS(2944),
    [anon_sym_AMP] = ACTIONS(2942),
    [anon_sym_LBRACK] = ACTIONS(2942),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2944),
    [anon_sym_LBRACE] = ACTIONS(2942),
    [anon_sym_LT_AT] = ACTIONS(2942),
    [anon_sym_LT_AT_AT] = ACTIONS(2942),
    [anon_sym_DOT] = ACTIONS(2942),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2944),
    [anon_sym_new] = ACTIONS(2942),
    [anon_sym_return_BANG] = ACTIONS(2944),
    [anon_sym_yield] = ACTIONS(2942),
    [anon_sym_yield_BANG] = ACTIONS(2944),
    [anon_sym_lazy] = ACTIONS(2942),
    [anon_sym_assert] = ACTIONS(2942),
    [anon_sym_upcast] = ACTIONS(2942),
    [anon_sym_downcast] = ACTIONS(2942),
    [anon_sym_COLON_GT] = ACTIONS(2944),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2944),
    [anon_sym_for] = ACTIONS(2942),
    [anon_sym_while] = ACTIONS(2942),
    [anon_sym_if] = ACTIONS(2942),
    [anon_sym_fun] = ACTIONS(2942),
    [anon_sym_try] = ACTIONS(2942),
    [anon_sym_match] = ACTIONS(2942),
    [anon_sym_match_BANG] = ACTIONS(2944),
    [anon_sym_function] = ACTIONS(2942),
    [anon_sym_LT_DASH] = ACTIONS(2942),
    [anon_sym_DOT_LBRACK] = ACTIONS(2944),
    [anon_sym_LT] = ACTIONS(2944),
    [anon_sym_use] = ACTIONS(2942),
    [anon_sym_use_BANG] = ACTIONS(2944),
    [anon_sym_do_BANG] = ACTIONS(2944),
    [anon_sym_begin] = ACTIONS(2942),
    [anon_sym_LPAREN2] = ACTIONS(2942),
    [anon_sym_or] = ACTIONS(2942),
    [aux_sym_char_token1] = ACTIONS(2944),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2942),
    [anon_sym_DQUOTE] = ACTIONS(2942),
    [anon_sym_AT_DQUOTE] = ACTIONS(2944),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2944),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2944),
    [sym_bool] = ACTIONS(2942),
    [sym_unit] = ACTIONS(2944),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2942),
    [sym_op_identifier] = ACTIONS(2942),
    [anon_sym_PLUS] = ACTIONS(2942),
    [anon_sym_DASH] = ACTIONS(2942),
    [anon_sym_PLUS_DOT] = ACTIONS(2942),
    [anon_sym_DASH_DOT] = ACTIONS(2942),
    [anon_sym_PERCENT] = ACTIONS(2942),
    [anon_sym_AMP_AMP] = ACTIONS(2942),
    [anon_sym_TILDE] = ACTIONS(2944),
    [aux_sym_prefix_op_token1] = ACTIONS(2942),
    [aux_sym_infix_op_token1] = ACTIONS(2944),
    [aux_sym_infix_op_token2] = ACTIONS(2942),
    [anon_sym_PIPE_PIPE] = ACTIONS(2942),
    [anon_sym_BANG_EQ] = ACTIONS(2942),
    [anon_sym_COLON_EQ] = ACTIONS(2944),
    [anon_sym_DOLLAR] = ACTIONS(2942),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2942),
    [sym_int] = ACTIONS(2942),
    [sym_xint] = ACTIONS(2944),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2944),
    [sym__newline] = ACTIONS(2944),
    [sym__dedent] = ACTIONS(2944),
  },
  [1901] = {
    [sym_block_comment] = STATE(1901),
    [sym_compiler_directive_decl] = STATE(1901),
    [sym_fsi_directive_decl] = STATE(1901),
    [sym_preproc_line] = STATE(1901),
    [aux_sym_sequential_expression_repeat1] = STATE(1833),
    [sym_identifier] = ACTIONS(2847),
    [anon_sym_EQ] = ACTIONS(2849),
    [anon_sym_COLON] = ACTIONS(2847),
    [anon_sym_return] = ACTIONS(2847),
    [anon_sym_do] = ACTIONS(2847),
    [anon_sym_let] = ACTIONS(2847),
    [anon_sym_let_BANG] = ACTIONS(2849),
    [anon_sym_LPAREN] = ACTIONS(2847),
    [anon_sym_COMMA] = ACTIONS(2849),
    [anon_sym_null] = ACTIONS(2847),
    [anon_sym_QMARK] = ACTIONS(2847),
    [anon_sym_COLON_QMARK] = ACTIONS(2847),
    [anon_sym_COLON_COLON] = ACTIONS(2849),
    [anon_sym_AMP] = ACTIONS(2847),
    [anon_sym_LBRACK] = ACTIONS(2847),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2849),
    [anon_sym_LBRACE] = ACTIONS(2847),
    [anon_sym_LT_AT] = ACTIONS(2847),
    [anon_sym_LT_AT_AT] = ACTIONS(2847),
    [anon_sym_DOT] = ACTIONS(2847),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2849),
    [anon_sym_new] = ACTIONS(2847),
    [anon_sym_return_BANG] = ACTIONS(2849),
    [anon_sym_yield] = ACTIONS(2847),
    [anon_sym_yield_BANG] = ACTIONS(2849),
    [anon_sym_lazy] = ACTIONS(2847),
    [anon_sym_assert] = ACTIONS(2847),
    [anon_sym_upcast] = ACTIONS(2847),
    [anon_sym_downcast] = ACTIONS(2847),
    [anon_sym_COLON_GT] = ACTIONS(2849),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2849),
    [anon_sym_for] = ACTIONS(2847),
    [anon_sym_while] = ACTIONS(2847),
    [anon_sym_if] = ACTIONS(2847),
    [anon_sym_fun] = ACTIONS(2847),
    [anon_sym_try] = ACTIONS(2847),
    [anon_sym_match] = ACTIONS(2847),
    [anon_sym_match_BANG] = ACTIONS(2849),
    [anon_sym_function] = ACTIONS(2847),
    [anon_sym_LT_DASH] = ACTIONS(2847),
    [anon_sym_DOT_LBRACK] = ACTIONS(2849),
    [anon_sym_LT] = ACTIONS(2849),
    [anon_sym_use] = ACTIONS(2847),
    [anon_sym_use_BANG] = ACTIONS(2849),
    [anon_sym_do_BANG] = ACTIONS(2849),
    [anon_sym_begin] = ACTIONS(2847),
    [anon_sym_LPAREN2] = ACTIONS(2847),
    [anon_sym_or] = ACTIONS(2847),
    [aux_sym_char_token1] = ACTIONS(2849),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2847),
    [anon_sym_DQUOTE] = ACTIONS(2847),
    [anon_sym_AT_DQUOTE] = ACTIONS(2849),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2849),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2849),
    [sym_bool] = ACTIONS(2847),
    [sym_unit] = ACTIONS(2849),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2847),
    [sym_op_identifier] = ACTIONS(2847),
    [anon_sym_PLUS] = ACTIONS(2847),
    [anon_sym_DASH] = ACTIONS(2847),
    [anon_sym_PLUS_DOT] = ACTIONS(2847),
    [anon_sym_DASH_DOT] = ACTIONS(2847),
    [anon_sym_PERCENT] = ACTIONS(2847),
    [anon_sym_AMP_AMP] = ACTIONS(2847),
    [anon_sym_TILDE] = ACTIONS(2849),
    [aux_sym_prefix_op_token1] = ACTIONS(2847),
    [aux_sym_infix_op_token1] = ACTIONS(2849),
    [aux_sym_infix_op_token2] = ACTIONS(2847),
    [anon_sym_PIPE_PIPE] = ACTIONS(2847),
    [anon_sym_BANG_EQ] = ACTIONS(2847),
    [anon_sym_COLON_EQ] = ACTIONS(2849),
    [anon_sym_DOLLAR] = ACTIONS(2847),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2847),
    [sym_int] = ACTIONS(2847),
    [sym_xint] = ACTIONS(2849),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2849),
    [anon_sym_POUNDendif] = ACTIONS(2849),
    [sym__newline] = ACTIONS(2849),
  },
  [1902] = {
    [sym_block_comment] = STATE(1902),
    [sym_compiler_directive_decl] = STATE(1902),
    [sym_fsi_directive_decl] = STATE(1902),
    [sym_preproc_line] = STATE(1902),
    [sym_identifier] = ACTIONS(2970),
    [anon_sym_EQ] = ACTIONS(2972),
    [anon_sym_COLON] = ACTIONS(2970),
    [anon_sym_return] = ACTIONS(2970),
    [anon_sym_do] = ACTIONS(2970),
    [anon_sym_and] = ACTIONS(2970),
    [anon_sym_let] = ACTIONS(2970),
    [anon_sym_let_BANG] = ACTIONS(2972),
    [anon_sym_LPAREN] = ACTIONS(2970),
    [anon_sym_COMMA] = ACTIONS(2972),
    [anon_sym_null] = ACTIONS(2970),
    [anon_sym_QMARK] = ACTIONS(2970),
    [anon_sym_COLON_QMARK] = ACTIONS(2970),
    [anon_sym_COLON_COLON] = ACTIONS(2972),
    [anon_sym_AMP] = ACTIONS(2970),
    [anon_sym_LBRACK] = ACTIONS(2970),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2972),
    [anon_sym_LBRACE] = ACTIONS(2970),
    [anon_sym_LT_AT] = ACTIONS(2970),
    [anon_sym_LT_AT_AT] = ACTIONS(2970),
    [anon_sym_DOT] = ACTIONS(2970),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2972),
    [anon_sym_new] = ACTIONS(2970),
    [anon_sym_return_BANG] = ACTIONS(2972),
    [anon_sym_yield] = ACTIONS(2970),
    [anon_sym_yield_BANG] = ACTIONS(2972),
    [anon_sym_lazy] = ACTIONS(2970),
    [anon_sym_assert] = ACTIONS(2970),
    [anon_sym_upcast] = ACTIONS(2970),
    [anon_sym_downcast] = ACTIONS(2970),
    [anon_sym_COLON_GT] = ACTIONS(2972),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2972),
    [anon_sym_for] = ACTIONS(2970),
    [anon_sym_while] = ACTIONS(2970),
    [anon_sym_if] = ACTIONS(2970),
    [anon_sym_fun] = ACTIONS(2970),
    [anon_sym_try] = ACTIONS(2970),
    [anon_sym_match] = ACTIONS(2970),
    [anon_sym_match_BANG] = ACTIONS(2972),
    [anon_sym_function] = ACTIONS(2970),
    [anon_sym_LT_DASH] = ACTIONS(2970),
    [anon_sym_DOT_LBRACK] = ACTIONS(2972),
    [anon_sym_LT] = ACTIONS(2972),
    [anon_sym_use] = ACTIONS(2970),
    [anon_sym_use_BANG] = ACTIONS(2972),
    [anon_sym_do_BANG] = ACTIONS(2972),
    [anon_sym_begin] = ACTIONS(2970),
    [anon_sym_LPAREN2] = ACTIONS(2970),
    [anon_sym_or] = ACTIONS(2970),
    [aux_sym_char_token1] = ACTIONS(2972),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2970),
    [anon_sym_DQUOTE] = ACTIONS(2970),
    [anon_sym_AT_DQUOTE] = ACTIONS(2972),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2972),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2972),
    [sym_bool] = ACTIONS(2970),
    [sym_unit] = ACTIONS(2972),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2970),
    [sym_op_identifier] = ACTIONS(2970),
    [anon_sym_PLUS] = ACTIONS(2970),
    [anon_sym_DASH] = ACTIONS(2970),
    [anon_sym_PLUS_DOT] = ACTIONS(2970),
    [anon_sym_DASH_DOT] = ACTIONS(2970),
    [anon_sym_PERCENT] = ACTIONS(2970),
    [anon_sym_AMP_AMP] = ACTIONS(2970),
    [anon_sym_TILDE] = ACTIONS(2972),
    [aux_sym_prefix_op_token1] = ACTIONS(2970),
    [aux_sym_infix_op_token1] = ACTIONS(2972),
    [aux_sym_infix_op_token2] = ACTIONS(2970),
    [anon_sym_PIPE_PIPE] = ACTIONS(2970),
    [anon_sym_BANG_EQ] = ACTIONS(2970),
    [anon_sym_COLON_EQ] = ACTIONS(2972),
    [anon_sym_DOLLAR] = ACTIONS(2970),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2970),
    [sym_int] = ACTIONS(2970),
    [sym_xint] = ACTIONS(2972),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2972),
    [sym__newline] = ACTIONS(2972),
    [sym__dedent] = ACTIONS(2972),
  },
  [1903] = {
    [sym_block_comment] = STATE(1903),
    [sym_compiler_directive_decl] = STATE(1903),
    [sym_fsi_directive_decl] = STATE(1903),
    [sym_preproc_line] = STATE(1903),
    [sym_identifier] = ACTIONS(2760),
    [anon_sym_EQ] = ACTIONS(2762),
    [anon_sym_COLON] = ACTIONS(2760),
    [anon_sym_return] = ACTIONS(2760),
    [anon_sym_do] = ACTIONS(2760),
    [anon_sym_let] = ACTIONS(2760),
    [anon_sym_let_BANG] = ACTIONS(2762),
    [anon_sym_LPAREN] = ACTIONS(2760),
    [anon_sym_COMMA] = ACTIONS(2762),
    [anon_sym_null] = ACTIONS(2760),
    [anon_sym_QMARK] = ACTIONS(2760),
    [anon_sym_COLON_QMARK] = ACTIONS(2760),
    [anon_sym_COLON_COLON] = ACTIONS(2762),
    [anon_sym_PIPE] = ACTIONS(2760),
    [anon_sym_AMP] = ACTIONS(2760),
    [anon_sym_LBRACK] = ACTIONS(2760),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2762),
    [anon_sym_LBRACE] = ACTIONS(2760),
    [anon_sym_LT_AT] = ACTIONS(2760),
    [anon_sym_LT_AT_AT] = ACTIONS(2760),
    [anon_sym_AT_AT_GT] = ACTIONS(2760),
    [anon_sym_DOT] = ACTIONS(2760),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2762),
    [anon_sym_new] = ACTIONS(2760),
    [anon_sym_return_BANG] = ACTIONS(2762),
    [anon_sym_yield] = ACTIONS(2760),
    [anon_sym_yield_BANG] = ACTIONS(2762),
    [anon_sym_lazy] = ACTIONS(2760),
    [anon_sym_assert] = ACTIONS(2760),
    [anon_sym_upcast] = ACTIONS(2760),
    [anon_sym_downcast] = ACTIONS(2760),
    [anon_sym_COLON_GT] = ACTIONS(2762),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2762),
    [anon_sym_for] = ACTIONS(2760),
    [anon_sym_while] = ACTIONS(2760),
    [anon_sym_if] = ACTIONS(2760),
    [anon_sym_fun] = ACTIONS(2760),
    [anon_sym_try] = ACTIONS(2760),
    [anon_sym_match] = ACTIONS(2760),
    [anon_sym_match_BANG] = ACTIONS(2762),
    [anon_sym_function] = ACTIONS(2760),
    [anon_sym_LT_DASH] = ACTIONS(2760),
    [anon_sym_DOT_LBRACK] = ACTIONS(2762),
    [anon_sym_LT] = ACTIONS(2762),
    [anon_sym_use] = ACTIONS(2760),
    [anon_sym_use_BANG] = ACTIONS(2762),
    [anon_sym_do_BANG] = ACTIONS(2762),
    [anon_sym_begin] = ACTIONS(2760),
    [anon_sym_LPAREN2] = ACTIONS(2760),
    [anon_sym_or] = ACTIONS(2760),
    [aux_sym_char_token1] = ACTIONS(2762),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2760),
    [anon_sym_DQUOTE] = ACTIONS(2760),
    [anon_sym_AT_DQUOTE] = ACTIONS(2762),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2762),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2762),
    [sym_bool] = ACTIONS(2760),
    [sym_unit] = ACTIONS(2762),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2760),
    [sym_op_identifier] = ACTIONS(2760),
    [anon_sym_PLUS] = ACTIONS(2760),
    [anon_sym_DASH] = ACTIONS(2760),
    [anon_sym_PLUS_DOT] = ACTIONS(2760),
    [anon_sym_DASH_DOT] = ACTIONS(2760),
    [anon_sym_PERCENT] = ACTIONS(2760),
    [anon_sym_AMP_AMP] = ACTIONS(2760),
    [anon_sym_TILDE] = ACTIONS(2762),
    [aux_sym_prefix_op_token1] = ACTIONS(2760),
    [aux_sym_infix_op_token1] = ACTIONS(2762),
    [aux_sym_infix_op_token2] = ACTIONS(2760),
    [anon_sym_PIPE_PIPE] = ACTIONS(2760),
    [anon_sym_BANG_EQ] = ACTIONS(2760),
    [anon_sym_COLON_EQ] = ACTIONS(2762),
    [anon_sym_DOLLAR] = ACTIONS(2760),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2760),
    [sym_int] = ACTIONS(2760),
    [sym_xint] = ACTIONS(2762),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2762),
    [sym__newline] = ACTIONS(2762),
  },
  [1904] = {
    [sym_block_comment] = STATE(1904),
    [sym_compiler_directive_decl] = STATE(1904),
    [sym_fsi_directive_decl] = STATE(1904),
    [sym_preproc_line] = STATE(1904),
    [aux_sym_long_identifier_repeat1] = STATE(1904),
    [sym_identifier] = ACTIONS(2411),
    [anon_sym_EQ] = ACTIONS(2413),
    [anon_sym_COLON] = ACTIONS(2411),
    [anon_sym_return] = ACTIONS(2411),
    [anon_sym_do] = ACTIONS(2411),
    [anon_sym_let] = ACTIONS(2411),
    [anon_sym_let_BANG] = ACTIONS(2413),
    [anon_sym_LPAREN] = ACTIONS(2411),
    [anon_sym_COMMA] = ACTIONS(2413),
    [anon_sym_null] = ACTIONS(2411),
    [anon_sym_QMARK] = ACTIONS(2411),
    [anon_sym_COLON_QMARK] = ACTIONS(2411),
    [anon_sym_COLON_COLON] = ACTIONS(2413),
    [anon_sym_AMP] = ACTIONS(2411),
    [anon_sym_LBRACK] = ACTIONS(2411),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2413),
    [anon_sym_LBRACE] = ACTIONS(2411),
    [anon_sym_LT_AT] = ACTIONS(2411),
    [anon_sym_LT_AT_AT] = ACTIONS(2411),
    [anon_sym_AT_AT_GT] = ACTIONS(2411),
    [anon_sym_DOT] = ACTIONS(4146),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2413),
    [anon_sym_new] = ACTIONS(2411),
    [anon_sym_return_BANG] = ACTIONS(2413),
    [anon_sym_yield] = ACTIONS(2411),
    [anon_sym_yield_BANG] = ACTIONS(2413),
    [anon_sym_lazy] = ACTIONS(2411),
    [anon_sym_assert] = ACTIONS(2411),
    [anon_sym_upcast] = ACTIONS(2411),
    [anon_sym_downcast] = ACTIONS(2411),
    [anon_sym_COLON_GT] = ACTIONS(2413),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2413),
    [anon_sym_for] = ACTIONS(2411),
    [anon_sym_while] = ACTIONS(2411),
    [anon_sym_if] = ACTIONS(2411),
    [anon_sym_fun] = ACTIONS(2411),
    [anon_sym_try] = ACTIONS(2411),
    [anon_sym_match] = ACTIONS(2411),
    [anon_sym_match_BANG] = ACTIONS(2413),
    [anon_sym_function] = ACTIONS(2411),
    [anon_sym_LT_DASH] = ACTIONS(2411),
    [anon_sym_DOT_LBRACK] = ACTIONS(2413),
    [anon_sym_LT] = ACTIONS(2413),
    [anon_sym_use] = ACTIONS(2411),
    [anon_sym_use_BANG] = ACTIONS(2413),
    [anon_sym_do_BANG] = ACTIONS(2413),
    [anon_sym_begin] = ACTIONS(2411),
    [anon_sym_LPAREN2] = ACTIONS(2411),
    [anon_sym_or] = ACTIONS(2411),
    [aux_sym_char_token1] = ACTIONS(2413),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2411),
    [anon_sym_DQUOTE] = ACTIONS(2411),
    [anon_sym_AT_DQUOTE] = ACTIONS(2413),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2413),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2413),
    [sym_bool] = ACTIONS(2411),
    [sym_unit] = ACTIONS(2413),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2411),
    [sym_op_identifier] = ACTIONS(2411),
    [anon_sym_PLUS] = ACTIONS(2411),
    [anon_sym_DASH] = ACTIONS(2411),
    [anon_sym_PLUS_DOT] = ACTIONS(2411),
    [anon_sym_DASH_DOT] = ACTIONS(2411),
    [anon_sym_PERCENT] = ACTIONS(2411),
    [anon_sym_AMP_AMP] = ACTIONS(2411),
    [anon_sym_TILDE] = ACTIONS(2413),
    [aux_sym_prefix_op_token1] = ACTIONS(2411),
    [aux_sym_infix_op_token1] = ACTIONS(2413),
    [aux_sym_infix_op_token2] = ACTIONS(2411),
    [anon_sym_PIPE_PIPE] = ACTIONS(2411),
    [anon_sym_BANG_EQ] = ACTIONS(2411),
    [anon_sym_COLON_EQ] = ACTIONS(2413),
    [anon_sym_DOLLAR] = ACTIONS(2411),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2411),
    [sym_int] = ACTIONS(2411),
    [sym_xint] = ACTIONS(2413),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2413),
    [sym__newline] = ACTIONS(2413),
  },
  [1905] = {
    [sym_attributes] = STATE(2630),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(3640),
    [sym__pattern] = STATE(3538),
    [sym_optional_pattern] = STATE(3640),
    [sym_type_check_pattern] = STATE(3640),
    [sym_attribute_pattern] = STATE(3640),
    [sym_paren_pattern] = STATE(3640),
    [sym_as_pattern] = STATE(3640),
    [sym_cons_pattern] = STATE(3640),
    [sym_disjunct_pattern] = STATE(3640),
    [sym_conjunct_pattern] = STATE(3640),
    [sym_typed_pattern] = STATE(3640),
    [sym_list_pattern] = STATE(3640),
    [sym_array_pattern] = STATE(3640),
    [sym_record_pattern] = STATE(3640),
    [sym_named_field_pattern] = STATE(3640),
    [sym_identifier_pattern] = STATE(3640),
    [sym_long_identifier_or_op] = STATE(2393),
    [sym_char] = STATE(3606),
    [sym_format_string] = STATE(3688),
    [sym__string_literal] = STATE(3688),
    [sym_string] = STATE(3606),
    [sym_verbatim_string] = STATE(3606),
    [sym_bytearray] = STATE(3606),
    [sym_verbatim_bytearray] = STATE(3606),
    [sym_format_triple_quoted_string] = STATE(3686),
    [sym_triple_quoted_string] = STATE(3606),
    [sym_const] = STATE(3640),
    [sym_long_identifier] = STATE(3437),
    [sym_active_pattern] = STATE(3653),
    [sym__identifier_or_op] = STATE(3660),
    [sym_sbyte] = STATE(3606),
    [sym_byte] = STATE(3606),
    [sym_int16] = STATE(3606),
    [sym_uint16] = STATE(3606),
    [sym_int32] = STATE(3606),
    [sym_uint32] = STATE(3606),
    [sym_nativeint] = STATE(3606),
    [sym_unativeint] = STATE(3606),
    [sym_int64] = STATE(3606),
    [sym_uint64] = STATE(3606),
    [sym_ieee32] = STATE(3606),
    [sym_ieee64] = STATE(3606),
    [sym_bignum] = STATE(3606),
    [sym_decimal] = STATE(3606),
    [sym_float] = STATE(3332),
    [sym_block_comment] = STATE(1905),
    [sym_compiler_directive_decl] = STATE(1905),
    [sym_fsi_directive_decl] = STATE(1905),
    [sym_preproc_line] = STATE(1905),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [aux_sym_repeat_pattern_repeat1] = STATE(3555),
    [sym_identifier] = ACTIONS(3716),
    [anon_sym_LBRACK_LT] = ACTIONS(3714),
    [anon_sym_COLON] = ACTIONS(3716),
    [anon_sym_as] = ACTIONS(4075),
    [anon_sym_LPAREN] = ACTIONS(3716),
    [anon_sym_COMMA] = ACTIONS(4079),
    [anon_sym_null] = ACTIONS(3716),
    [anon_sym__] = ACTIONS(3716),
    [anon_sym_QMARK] = ACTIONS(3714),
    [anon_sym_COLON_QMARK] = ACTIONS(3714),
    [anon_sym_COLON_COLON] = ACTIONS(4089),
    [anon_sym_PIPE] = ACTIONS(4091),
    [anon_sym_AMP] = ACTIONS(4093),
    [anon_sym_LBRACK] = ACTIONS(3716),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3714),
    [anon_sym_LBRACE] = ACTIONS(3714),
    [aux_sym_char_token1] = ACTIONS(3714),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3716),
    [anon_sym_DQUOTE] = ACTIONS(3716),
    [anon_sym_AT_DQUOTE] = ACTIONS(3714),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3714),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3714),
    [sym_bool] = ACTIONS(3716),
    [sym_unit] = ACTIONS(3714),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3716),
    [sym_op_identifier] = ACTIONS(3714),
    [sym_int] = ACTIONS(3716),
    [sym_xint] = ACTIONS(3714),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [sym__newline] = ACTIONS(3714),
    [sym__dedent] = ACTIONS(3714),
  },
  [1906] = {
    [sym_block_comment] = STATE(1906),
    [sym_compiler_directive_decl] = STATE(1906),
    [sym_fsi_directive_decl] = STATE(1906),
    [sym_preproc_line] = STATE(1906),
    [sym_identifier] = ACTIONS(2756),
    [anon_sym_EQ] = ACTIONS(2758),
    [anon_sym_COLON] = ACTIONS(2756),
    [anon_sym_return] = ACTIONS(2756),
    [anon_sym_do] = ACTIONS(2756),
    [anon_sym_let] = ACTIONS(2756),
    [anon_sym_let_BANG] = ACTIONS(2758),
    [anon_sym_LPAREN] = ACTIONS(2756),
    [anon_sym_COMMA] = ACTIONS(2758),
    [anon_sym_null] = ACTIONS(2756),
    [anon_sym_QMARK] = ACTIONS(2756),
    [anon_sym_COLON_QMARK] = ACTIONS(2756),
    [anon_sym_COLON_COLON] = ACTIONS(2758),
    [anon_sym_PIPE] = ACTIONS(2756),
    [anon_sym_AMP] = ACTIONS(2756),
    [anon_sym_LBRACK] = ACTIONS(2756),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2758),
    [anon_sym_LBRACE] = ACTIONS(2756),
    [anon_sym_LT_AT] = ACTIONS(2756),
    [anon_sym_LT_AT_AT] = ACTIONS(2756),
    [anon_sym_AT_AT_GT] = ACTIONS(2756),
    [anon_sym_DOT] = ACTIONS(2756),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2758),
    [anon_sym_new] = ACTIONS(2756),
    [anon_sym_return_BANG] = ACTIONS(2758),
    [anon_sym_yield] = ACTIONS(2756),
    [anon_sym_yield_BANG] = ACTIONS(2758),
    [anon_sym_lazy] = ACTIONS(2756),
    [anon_sym_assert] = ACTIONS(2756),
    [anon_sym_upcast] = ACTIONS(2756),
    [anon_sym_downcast] = ACTIONS(2756),
    [anon_sym_COLON_GT] = ACTIONS(2758),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2758),
    [anon_sym_for] = ACTIONS(2756),
    [anon_sym_while] = ACTIONS(2756),
    [anon_sym_if] = ACTIONS(2756),
    [anon_sym_fun] = ACTIONS(2756),
    [anon_sym_try] = ACTIONS(2756),
    [anon_sym_match] = ACTIONS(2756),
    [anon_sym_match_BANG] = ACTIONS(2758),
    [anon_sym_function] = ACTIONS(2756),
    [anon_sym_LT_DASH] = ACTIONS(2756),
    [anon_sym_DOT_LBRACK] = ACTIONS(2758),
    [anon_sym_LT] = ACTIONS(2758),
    [anon_sym_use] = ACTIONS(2756),
    [anon_sym_use_BANG] = ACTIONS(2758),
    [anon_sym_do_BANG] = ACTIONS(2758),
    [anon_sym_begin] = ACTIONS(2756),
    [anon_sym_LPAREN2] = ACTIONS(2756),
    [anon_sym_or] = ACTIONS(2756),
    [aux_sym_char_token1] = ACTIONS(2758),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2756),
    [anon_sym_DQUOTE] = ACTIONS(2756),
    [anon_sym_AT_DQUOTE] = ACTIONS(2758),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2758),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2758),
    [sym_bool] = ACTIONS(2756),
    [sym_unit] = ACTIONS(2758),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2756),
    [sym_op_identifier] = ACTIONS(2756),
    [anon_sym_PLUS] = ACTIONS(2756),
    [anon_sym_DASH] = ACTIONS(2756),
    [anon_sym_PLUS_DOT] = ACTIONS(2756),
    [anon_sym_DASH_DOT] = ACTIONS(2756),
    [anon_sym_PERCENT] = ACTIONS(2756),
    [anon_sym_AMP_AMP] = ACTIONS(2756),
    [anon_sym_TILDE] = ACTIONS(2758),
    [aux_sym_prefix_op_token1] = ACTIONS(2756),
    [aux_sym_infix_op_token1] = ACTIONS(2758),
    [aux_sym_infix_op_token2] = ACTIONS(2756),
    [anon_sym_PIPE_PIPE] = ACTIONS(2756),
    [anon_sym_BANG_EQ] = ACTIONS(2756),
    [anon_sym_COLON_EQ] = ACTIONS(2758),
    [anon_sym_DOLLAR] = ACTIONS(2756),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2756),
    [sym_int] = ACTIONS(2756),
    [sym_xint] = ACTIONS(2758),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2758),
    [sym__newline] = ACTIONS(2758),
  },
  [1907] = {
    [sym_block_comment] = STATE(1907),
    [sym_compiler_directive_decl] = STATE(1907),
    [sym_fsi_directive_decl] = STATE(1907),
    [sym_preproc_line] = STATE(1907),
    [sym_identifier] = ACTIONS(2988),
    [anon_sym_EQ] = ACTIONS(2990),
    [anon_sym_COLON] = ACTIONS(2988),
    [anon_sym_return] = ACTIONS(2988),
    [anon_sym_do] = ACTIONS(2988),
    [anon_sym_and] = ACTIONS(2988),
    [anon_sym_let] = ACTIONS(2988),
    [anon_sym_let_BANG] = ACTIONS(2990),
    [anon_sym_LPAREN] = ACTIONS(2988),
    [anon_sym_COMMA] = ACTIONS(2990),
    [anon_sym_null] = ACTIONS(2988),
    [anon_sym_QMARK] = ACTIONS(2988),
    [anon_sym_COLON_QMARK] = ACTIONS(2988),
    [anon_sym_COLON_COLON] = ACTIONS(2990),
    [anon_sym_AMP] = ACTIONS(2988),
    [anon_sym_LBRACK] = ACTIONS(2988),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2990),
    [anon_sym_LBRACE] = ACTIONS(2988),
    [anon_sym_LT_AT] = ACTIONS(2988),
    [anon_sym_LT_AT_AT] = ACTIONS(2988),
    [anon_sym_DOT] = ACTIONS(2988),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2990),
    [anon_sym_new] = ACTIONS(2988),
    [anon_sym_return_BANG] = ACTIONS(2990),
    [anon_sym_yield] = ACTIONS(2988),
    [anon_sym_yield_BANG] = ACTIONS(2990),
    [anon_sym_lazy] = ACTIONS(2988),
    [anon_sym_assert] = ACTIONS(2988),
    [anon_sym_upcast] = ACTIONS(2988),
    [anon_sym_downcast] = ACTIONS(2988),
    [anon_sym_COLON_GT] = ACTIONS(2990),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2990),
    [anon_sym_for] = ACTIONS(2988),
    [anon_sym_while] = ACTIONS(2988),
    [anon_sym_if] = ACTIONS(2988),
    [anon_sym_fun] = ACTIONS(2988),
    [anon_sym_try] = ACTIONS(2988),
    [anon_sym_match] = ACTIONS(2988),
    [anon_sym_match_BANG] = ACTIONS(2990),
    [anon_sym_function] = ACTIONS(2988),
    [anon_sym_LT_DASH] = ACTIONS(2988),
    [anon_sym_DOT_LBRACK] = ACTIONS(2990),
    [anon_sym_LT] = ACTIONS(2990),
    [anon_sym_use] = ACTIONS(2988),
    [anon_sym_use_BANG] = ACTIONS(2990),
    [anon_sym_do_BANG] = ACTIONS(2990),
    [anon_sym_begin] = ACTIONS(2988),
    [anon_sym_LPAREN2] = ACTIONS(2988),
    [anon_sym_or] = ACTIONS(2988),
    [aux_sym_char_token1] = ACTIONS(2990),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2988),
    [anon_sym_DQUOTE] = ACTIONS(2988),
    [anon_sym_AT_DQUOTE] = ACTIONS(2990),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2990),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2990),
    [sym_bool] = ACTIONS(2988),
    [sym_unit] = ACTIONS(2990),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2988),
    [sym_op_identifier] = ACTIONS(2988),
    [anon_sym_PLUS] = ACTIONS(2988),
    [anon_sym_DASH] = ACTIONS(2988),
    [anon_sym_PLUS_DOT] = ACTIONS(2988),
    [anon_sym_DASH_DOT] = ACTIONS(2988),
    [anon_sym_PERCENT] = ACTIONS(2988),
    [anon_sym_AMP_AMP] = ACTIONS(2988),
    [anon_sym_TILDE] = ACTIONS(2990),
    [aux_sym_prefix_op_token1] = ACTIONS(2988),
    [aux_sym_infix_op_token1] = ACTIONS(2990),
    [aux_sym_infix_op_token2] = ACTIONS(2988),
    [anon_sym_PIPE_PIPE] = ACTIONS(2988),
    [anon_sym_BANG_EQ] = ACTIONS(2988),
    [anon_sym_COLON_EQ] = ACTIONS(2990),
    [anon_sym_DOLLAR] = ACTIONS(2988),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2988),
    [sym_int] = ACTIONS(2988),
    [sym_xint] = ACTIONS(2990),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2990),
    [sym__newline] = ACTIONS(2990),
    [sym__dedent] = ACTIONS(2990),
  },
  [1908] = {
    [sym_block_comment] = STATE(1908),
    [sym_compiler_directive_decl] = STATE(1908),
    [sym_fsi_directive_decl] = STATE(1908),
    [sym_preproc_line] = STATE(1908),
    [sym_identifier] = ACTIONS(3011),
    [anon_sym_EQ] = ACTIONS(3013),
    [anon_sym_COLON] = ACTIONS(3011),
    [anon_sym_return] = ACTIONS(3011),
    [anon_sym_do] = ACTIONS(3011),
    [anon_sym_and] = ACTIONS(3011),
    [anon_sym_let] = ACTIONS(3011),
    [anon_sym_let_BANG] = ACTIONS(3013),
    [anon_sym_LPAREN] = ACTIONS(3011),
    [anon_sym_COMMA] = ACTIONS(3013),
    [anon_sym_null] = ACTIONS(3011),
    [anon_sym_QMARK] = ACTIONS(3011),
    [anon_sym_COLON_QMARK] = ACTIONS(3011),
    [anon_sym_COLON_COLON] = ACTIONS(3013),
    [anon_sym_AMP] = ACTIONS(3011),
    [anon_sym_LBRACK] = ACTIONS(3011),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3013),
    [anon_sym_LBRACE] = ACTIONS(3011),
    [anon_sym_LT_AT] = ACTIONS(3011),
    [anon_sym_LT_AT_AT] = ACTIONS(3011),
    [anon_sym_DOT] = ACTIONS(3011),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3013),
    [anon_sym_new] = ACTIONS(3011),
    [anon_sym_return_BANG] = ACTIONS(3013),
    [anon_sym_yield] = ACTIONS(3011),
    [anon_sym_yield_BANG] = ACTIONS(3013),
    [anon_sym_lazy] = ACTIONS(3011),
    [anon_sym_assert] = ACTIONS(3011),
    [anon_sym_upcast] = ACTIONS(3011),
    [anon_sym_downcast] = ACTIONS(3011),
    [anon_sym_COLON_GT] = ACTIONS(3013),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3013),
    [anon_sym_for] = ACTIONS(3011),
    [anon_sym_while] = ACTIONS(3011),
    [anon_sym_if] = ACTIONS(3011),
    [anon_sym_fun] = ACTIONS(3011),
    [anon_sym_try] = ACTIONS(3011),
    [anon_sym_match] = ACTIONS(3011),
    [anon_sym_match_BANG] = ACTIONS(3013),
    [anon_sym_function] = ACTIONS(3011),
    [anon_sym_LT_DASH] = ACTIONS(3011),
    [anon_sym_DOT_LBRACK] = ACTIONS(3013),
    [anon_sym_LT] = ACTIONS(3013),
    [anon_sym_use] = ACTIONS(3011),
    [anon_sym_use_BANG] = ACTIONS(3013),
    [anon_sym_do_BANG] = ACTIONS(3013),
    [anon_sym_begin] = ACTIONS(3011),
    [anon_sym_LPAREN2] = ACTIONS(3011),
    [anon_sym_or] = ACTIONS(3011),
    [aux_sym_char_token1] = ACTIONS(3013),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3011),
    [anon_sym_DQUOTE] = ACTIONS(3011),
    [anon_sym_AT_DQUOTE] = ACTIONS(3013),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3013),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3013),
    [sym_bool] = ACTIONS(3011),
    [sym_unit] = ACTIONS(3013),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3011),
    [sym_op_identifier] = ACTIONS(3011),
    [anon_sym_PLUS] = ACTIONS(3011),
    [anon_sym_DASH] = ACTIONS(3011),
    [anon_sym_PLUS_DOT] = ACTIONS(3011),
    [anon_sym_DASH_DOT] = ACTIONS(3011),
    [anon_sym_PERCENT] = ACTIONS(3011),
    [anon_sym_AMP_AMP] = ACTIONS(3011),
    [anon_sym_TILDE] = ACTIONS(3013),
    [aux_sym_prefix_op_token1] = ACTIONS(3011),
    [aux_sym_infix_op_token1] = ACTIONS(3013),
    [aux_sym_infix_op_token2] = ACTIONS(3011),
    [anon_sym_PIPE_PIPE] = ACTIONS(3011),
    [anon_sym_BANG_EQ] = ACTIONS(3011),
    [anon_sym_COLON_EQ] = ACTIONS(3013),
    [anon_sym_DOLLAR] = ACTIONS(3011),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3011),
    [sym_int] = ACTIONS(3011),
    [sym_xint] = ACTIONS(3013),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3013),
    [sym__newline] = ACTIONS(3013),
    [sym__dedent] = ACTIONS(3013),
  },
  [1909] = {
    [sym_block_comment] = STATE(1909),
    [sym_compiler_directive_decl] = STATE(1909),
    [sym_fsi_directive_decl] = STATE(1909),
    [sym_preproc_line] = STATE(1909),
    [sym_identifier] = ACTIONS(2984),
    [anon_sym_EQ] = ACTIONS(2986),
    [anon_sym_COLON] = ACTIONS(2984),
    [anon_sym_return] = ACTIONS(2984),
    [anon_sym_do] = ACTIONS(2984),
    [anon_sym_let] = ACTIONS(2984),
    [anon_sym_let_BANG] = ACTIONS(2986),
    [anon_sym_LPAREN] = ACTIONS(2984),
    [anon_sym_COMMA] = ACTIONS(2986),
    [anon_sym_null] = ACTIONS(2984),
    [anon_sym_QMARK] = ACTIONS(2984),
    [anon_sym_COLON_QMARK] = ACTIONS(2984),
    [anon_sym_COLON_COLON] = ACTIONS(2986),
    [anon_sym_AMP] = ACTIONS(2984),
    [anon_sym_LBRACK] = ACTIONS(2984),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2986),
    [anon_sym_LBRACE] = ACTIONS(2984),
    [anon_sym_LT_AT] = ACTIONS(2984),
    [anon_sym_LT_AT_AT] = ACTIONS(2984),
    [anon_sym_DOT] = ACTIONS(2984),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2986),
    [anon_sym_new] = ACTIONS(2984),
    [anon_sym_return_BANG] = ACTIONS(2986),
    [anon_sym_yield] = ACTIONS(2984),
    [anon_sym_yield_BANG] = ACTIONS(2986),
    [anon_sym_lazy] = ACTIONS(2984),
    [anon_sym_assert] = ACTIONS(2984),
    [anon_sym_upcast] = ACTIONS(2984),
    [anon_sym_downcast] = ACTIONS(2984),
    [anon_sym_COLON_GT] = ACTIONS(2986),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2986),
    [anon_sym_for] = ACTIONS(2984),
    [anon_sym_while] = ACTIONS(2984),
    [anon_sym_if] = ACTIONS(2984),
    [anon_sym_fun] = ACTIONS(2984),
    [anon_sym_try] = ACTIONS(2984),
    [anon_sym_match] = ACTIONS(2984),
    [anon_sym_match_BANG] = ACTIONS(2986),
    [anon_sym_function] = ACTIONS(2984),
    [anon_sym_LT_DASH] = ACTIONS(2984),
    [anon_sym_DOT_LBRACK] = ACTIONS(2986),
    [anon_sym_LT] = ACTIONS(2986),
    [anon_sym_use] = ACTIONS(2984),
    [anon_sym_use_BANG] = ACTIONS(2986),
    [anon_sym_do_BANG] = ACTIONS(2986),
    [anon_sym_begin] = ACTIONS(2984),
    [anon_sym_LPAREN2] = ACTIONS(2984),
    [anon_sym_or] = ACTIONS(2984),
    [aux_sym_char_token1] = ACTIONS(2986),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2984),
    [anon_sym_DQUOTE] = ACTIONS(2984),
    [anon_sym_AT_DQUOTE] = ACTIONS(2986),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2986),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2986),
    [sym_bool] = ACTIONS(2984),
    [sym_unit] = ACTIONS(2986),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2984),
    [sym_op_identifier] = ACTIONS(2984),
    [anon_sym_PLUS] = ACTIONS(2984),
    [anon_sym_DASH] = ACTIONS(2984),
    [anon_sym_PLUS_DOT] = ACTIONS(2984),
    [anon_sym_DASH_DOT] = ACTIONS(2984),
    [anon_sym_PERCENT] = ACTIONS(2984),
    [anon_sym_AMP_AMP] = ACTIONS(2984),
    [anon_sym_TILDE] = ACTIONS(2986),
    [aux_sym_prefix_op_token1] = ACTIONS(2984),
    [aux_sym_infix_op_token1] = ACTIONS(2986),
    [aux_sym_infix_op_token2] = ACTIONS(2984),
    [anon_sym_PIPE_PIPE] = ACTIONS(2984),
    [anon_sym_BANG_EQ] = ACTIONS(2984),
    [anon_sym_COLON_EQ] = ACTIONS(2986),
    [anon_sym_DOLLAR] = ACTIONS(2984),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2984),
    [sym_int] = ACTIONS(2984),
    [sym_xint] = ACTIONS(2986),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2986),
    [anon_sym_POUNDendif] = ACTIONS(2986),
    [anon_sym_POUNDelse] = ACTIONS(2986),
    [sym__newline] = ACTIONS(2986),
  },
  [1910] = {
    [sym_block_comment] = STATE(1910),
    [sym_compiler_directive_decl] = STATE(1910),
    [sym_fsi_directive_decl] = STATE(1910),
    [sym_preproc_line] = STATE(1910),
    [aux_sym_long_identifier_repeat1] = STATE(1917),
    [sym_identifier] = ACTIONS(2418),
    [anon_sym_EQ] = ACTIONS(2420),
    [anon_sym_COLON] = ACTIONS(2418),
    [anon_sym_return] = ACTIONS(2418),
    [anon_sym_do] = ACTIONS(2418),
    [anon_sym_let] = ACTIONS(2418),
    [anon_sym_let_BANG] = ACTIONS(2420),
    [anon_sym_LPAREN] = ACTIONS(2418),
    [anon_sym_COMMA] = ACTIONS(2420),
    [anon_sym_null] = ACTIONS(2418),
    [anon_sym_QMARK] = ACTIONS(2418),
    [anon_sym_COLON_QMARK] = ACTIONS(2418),
    [anon_sym_COLON_COLON] = ACTIONS(2420),
    [anon_sym_AMP] = ACTIONS(2418),
    [anon_sym_LBRACK] = ACTIONS(2418),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2420),
    [anon_sym_LBRACE] = ACTIONS(2418),
    [anon_sym_LT_AT] = ACTIONS(2418),
    [anon_sym_LT_AT_AT] = ACTIONS(2418),
    [anon_sym_DOT] = ACTIONS(4149),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2420),
    [anon_sym_new] = ACTIONS(2418),
    [anon_sym_return_BANG] = ACTIONS(2420),
    [anon_sym_yield] = ACTIONS(2418),
    [anon_sym_yield_BANG] = ACTIONS(2420),
    [anon_sym_lazy] = ACTIONS(2418),
    [anon_sym_assert] = ACTIONS(2418),
    [anon_sym_upcast] = ACTIONS(2418),
    [anon_sym_downcast] = ACTIONS(2418),
    [anon_sym_COLON_GT] = ACTIONS(2420),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2420),
    [anon_sym_for] = ACTIONS(2418),
    [anon_sym_while] = ACTIONS(2418),
    [anon_sym_if] = ACTIONS(2418),
    [anon_sym_fun] = ACTIONS(2418),
    [anon_sym_try] = ACTIONS(2418),
    [anon_sym_match] = ACTIONS(2418),
    [anon_sym_match_BANG] = ACTIONS(2420),
    [anon_sym_function] = ACTIONS(2418),
    [anon_sym_LT_DASH] = ACTIONS(2418),
    [anon_sym_DOT_LBRACK] = ACTIONS(2420),
    [anon_sym_LT] = ACTIONS(2420),
    [anon_sym_GT] = ACTIONS(2418),
    [anon_sym_use] = ACTIONS(2418),
    [anon_sym_use_BANG] = ACTIONS(2420),
    [anon_sym_do_BANG] = ACTIONS(2420),
    [anon_sym_begin] = ACTIONS(2418),
    [anon_sym_LPAREN2] = ACTIONS(2418),
    [anon_sym_or] = ACTIONS(2418),
    [aux_sym_char_token1] = ACTIONS(2420),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2418),
    [anon_sym_DQUOTE] = ACTIONS(2418),
    [anon_sym_AT_DQUOTE] = ACTIONS(2420),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2420),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2420),
    [sym_bool] = ACTIONS(2418),
    [sym_unit] = ACTIONS(2420),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2418),
    [sym_op_identifier] = ACTIONS(2418),
    [anon_sym_PLUS] = ACTIONS(2418),
    [anon_sym_DASH] = ACTIONS(2418),
    [anon_sym_PLUS_DOT] = ACTIONS(2418),
    [anon_sym_DASH_DOT] = ACTIONS(2418),
    [anon_sym_PERCENT] = ACTIONS(2418),
    [anon_sym_AMP_AMP] = ACTIONS(2418),
    [anon_sym_TILDE] = ACTIONS(2420),
    [aux_sym_prefix_op_token1] = ACTIONS(2418),
    [aux_sym_infix_op_token1] = ACTIONS(2420),
    [aux_sym_infix_op_token2] = ACTIONS(2418),
    [anon_sym_PIPE_PIPE] = ACTIONS(2418),
    [anon_sym_BANG_EQ] = ACTIONS(2418),
    [anon_sym_COLON_EQ] = ACTIONS(2420),
    [anon_sym_DOLLAR] = ACTIONS(2418),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2418),
    [sym_int] = ACTIONS(2418),
    [sym_xint] = ACTIONS(2420),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2420),
    [sym__newline] = ACTIONS(2420),
  },
  [1911] = {
    [sym_block_comment] = STATE(1911),
    [sym_compiler_directive_decl] = STATE(1911),
    [sym_fsi_directive_decl] = STATE(1911),
    [sym_preproc_line] = STATE(1911),
    [sym_identifier] = ACTIONS(3095),
    [anon_sym_EQ] = ACTIONS(3097),
    [anon_sym_COLON] = ACTIONS(3095),
    [anon_sym_return] = ACTIONS(3095),
    [anon_sym_do] = ACTIONS(3095),
    [anon_sym_let] = ACTIONS(3095),
    [anon_sym_let_BANG] = ACTIONS(3097),
    [anon_sym_LPAREN] = ACTIONS(3095),
    [anon_sym_COMMA] = ACTIONS(3097),
    [anon_sym_null] = ACTIONS(3095),
    [anon_sym_QMARK] = ACTIONS(3095),
    [anon_sym_COLON_QMARK] = ACTIONS(3095),
    [anon_sym_COLON_COLON] = ACTIONS(3097),
    [anon_sym_AMP] = ACTIONS(3095),
    [anon_sym_LBRACK] = ACTIONS(3095),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3097),
    [anon_sym_LBRACE] = ACTIONS(3095),
    [anon_sym_LT_AT] = ACTIONS(3095),
    [anon_sym_LT_AT_AT] = ACTIONS(3095),
    [anon_sym_DOT] = ACTIONS(3095),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3097),
    [anon_sym_new] = ACTIONS(3095),
    [anon_sym_return_BANG] = ACTIONS(3097),
    [anon_sym_yield] = ACTIONS(3095),
    [anon_sym_yield_BANG] = ACTIONS(3097),
    [anon_sym_lazy] = ACTIONS(3095),
    [anon_sym_assert] = ACTIONS(3095),
    [anon_sym_upcast] = ACTIONS(3095),
    [anon_sym_downcast] = ACTIONS(3095),
    [anon_sym_COLON_GT] = ACTIONS(3097),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3097),
    [anon_sym_for] = ACTIONS(3095),
    [anon_sym_while] = ACTIONS(3095),
    [anon_sym_if] = ACTIONS(3095),
    [anon_sym_fun] = ACTIONS(3095),
    [anon_sym_DASH_GT] = ACTIONS(3095),
    [anon_sym_try] = ACTIONS(3095),
    [anon_sym_match] = ACTIONS(3095),
    [anon_sym_match_BANG] = ACTIONS(3097),
    [anon_sym_function] = ACTIONS(3095),
    [anon_sym_LT_DASH] = ACTIONS(3095),
    [anon_sym_DOT_LBRACK] = ACTIONS(3097),
    [anon_sym_LT] = ACTIONS(3097),
    [anon_sym_use] = ACTIONS(3095),
    [anon_sym_use_BANG] = ACTIONS(3097),
    [anon_sym_do_BANG] = ACTIONS(3097),
    [anon_sym_DOT_DOT] = ACTIONS(3097),
    [anon_sym_begin] = ACTIONS(3095),
    [anon_sym_LPAREN2] = ACTIONS(3095),
    [anon_sym_or] = ACTIONS(3095),
    [aux_sym_char_token1] = ACTIONS(3097),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3095),
    [anon_sym_DQUOTE] = ACTIONS(3095),
    [anon_sym_AT_DQUOTE] = ACTIONS(3097),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3097),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3097),
    [sym_bool] = ACTIONS(3095),
    [sym_unit] = ACTIONS(3097),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3095),
    [sym_op_identifier] = ACTIONS(3095),
    [anon_sym_PLUS] = ACTIONS(3095),
    [anon_sym_DASH] = ACTIONS(3095),
    [anon_sym_PLUS_DOT] = ACTIONS(3095),
    [anon_sym_DASH_DOT] = ACTIONS(3095),
    [anon_sym_PERCENT] = ACTIONS(3095),
    [anon_sym_AMP_AMP] = ACTIONS(3095),
    [anon_sym_TILDE] = ACTIONS(3097),
    [aux_sym_prefix_op_token1] = ACTIONS(3095),
    [aux_sym_infix_op_token1] = ACTIONS(3097),
    [aux_sym_infix_op_token2] = ACTIONS(3095),
    [anon_sym_PIPE_PIPE] = ACTIONS(3095),
    [anon_sym_BANG_EQ] = ACTIONS(3095),
    [anon_sym_COLON_EQ] = ACTIONS(3097),
    [anon_sym_DOLLAR] = ACTIONS(3095),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3095),
    [sym_int] = ACTIONS(3095),
    [sym_xint] = ACTIONS(3097),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3097),
    [sym__newline] = ACTIONS(3097),
  },
  [1912] = {
    [sym_block_comment] = STATE(1912),
    [sym_compiler_directive_decl] = STATE(1912),
    [sym_fsi_directive_decl] = STATE(1912),
    [sym_preproc_line] = STATE(1912),
    [sym_identifier] = ACTIONS(3039),
    [anon_sym_EQ] = ACTIONS(3041),
    [anon_sym_COLON] = ACTIONS(3039),
    [anon_sym_return] = ACTIONS(3039),
    [anon_sym_do] = ACTIONS(3039),
    [anon_sym_let] = ACTIONS(3039),
    [anon_sym_let_BANG] = ACTIONS(3041),
    [anon_sym_as] = ACTIONS(3039),
    [anon_sym_LPAREN] = ACTIONS(3039),
    [anon_sym_COMMA] = ACTIONS(3041),
    [anon_sym_null] = ACTIONS(3039),
    [anon_sym_QMARK] = ACTIONS(3039),
    [anon_sym_COLON_QMARK] = ACTIONS(3039),
    [anon_sym_COLON_COLON] = ACTIONS(3041),
    [anon_sym_AMP] = ACTIONS(3039),
    [anon_sym_LBRACK] = ACTIONS(3039),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3041),
    [anon_sym_LBRACE] = ACTIONS(3039),
    [anon_sym_LT_AT] = ACTIONS(3039),
    [anon_sym_LT_AT_AT] = ACTIONS(3039),
    [anon_sym_DOT] = ACTIONS(3039),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3041),
    [anon_sym_new] = ACTIONS(3039),
    [anon_sym_with] = ACTIONS(3039),
    [anon_sym_return_BANG] = ACTIONS(3041),
    [anon_sym_yield] = ACTIONS(3039),
    [anon_sym_yield_BANG] = ACTIONS(3041),
    [anon_sym_lazy] = ACTIONS(3039),
    [anon_sym_assert] = ACTIONS(3039),
    [anon_sym_upcast] = ACTIONS(3039),
    [anon_sym_downcast] = ACTIONS(3039),
    [anon_sym_COLON_GT] = ACTIONS(3041),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3041),
    [anon_sym_for] = ACTIONS(3039),
    [anon_sym_while] = ACTIONS(3039),
    [anon_sym_if] = ACTIONS(3039),
    [anon_sym_fun] = ACTIONS(3039),
    [anon_sym_try] = ACTIONS(3039),
    [anon_sym_match] = ACTIONS(3039),
    [anon_sym_match_BANG] = ACTIONS(3041),
    [anon_sym_function] = ACTIONS(3039),
    [anon_sym_LT_DASH] = ACTIONS(3039),
    [anon_sym_DOT_LBRACK] = ACTIONS(3041),
    [anon_sym_LT] = ACTIONS(3041),
    [anon_sym_use] = ACTIONS(3039),
    [anon_sym_use_BANG] = ACTIONS(3041),
    [anon_sym_do_BANG] = ACTIONS(3041),
    [anon_sym_begin] = ACTIONS(3039),
    [anon_sym_LPAREN2] = ACTIONS(3039),
    [anon_sym_or] = ACTIONS(3039),
    [aux_sym_char_token1] = ACTIONS(3041),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3039),
    [anon_sym_DQUOTE] = ACTIONS(3039),
    [anon_sym_AT_DQUOTE] = ACTIONS(3041),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3041),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3041),
    [sym_bool] = ACTIONS(3039),
    [sym_unit] = ACTIONS(3041),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3039),
    [sym_op_identifier] = ACTIONS(3039),
    [anon_sym_PLUS] = ACTIONS(3039),
    [anon_sym_DASH] = ACTIONS(3039),
    [anon_sym_PLUS_DOT] = ACTIONS(3039),
    [anon_sym_DASH_DOT] = ACTIONS(3039),
    [anon_sym_PERCENT] = ACTIONS(3039),
    [anon_sym_AMP_AMP] = ACTIONS(3039),
    [anon_sym_TILDE] = ACTIONS(3041),
    [aux_sym_prefix_op_token1] = ACTIONS(3039),
    [aux_sym_infix_op_token1] = ACTIONS(3041),
    [aux_sym_infix_op_token2] = ACTIONS(3039),
    [anon_sym_PIPE_PIPE] = ACTIONS(3039),
    [anon_sym_BANG_EQ] = ACTIONS(3039),
    [anon_sym_COLON_EQ] = ACTIONS(3041),
    [anon_sym_DOLLAR] = ACTIONS(3039),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3039),
    [sym_int] = ACTIONS(3039),
    [sym_xint] = ACTIONS(3041),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3041),
    [sym__newline] = ACTIONS(3041),
  },
  [1913] = {
    [sym_block_comment] = STATE(1913),
    [sym_compiler_directive_decl] = STATE(1913),
    [sym_fsi_directive_decl] = STATE(1913),
    [sym_preproc_line] = STATE(1913),
    [sym_identifier] = ACTIONS(3043),
    [anon_sym_EQ] = ACTIONS(3045),
    [anon_sym_COLON] = ACTIONS(3043),
    [anon_sym_return] = ACTIONS(3043),
    [anon_sym_do] = ACTIONS(3043),
    [anon_sym_let] = ACTIONS(3043),
    [anon_sym_let_BANG] = ACTIONS(3045),
    [anon_sym_as] = ACTIONS(3043),
    [anon_sym_LPAREN] = ACTIONS(3043),
    [anon_sym_COMMA] = ACTIONS(3045),
    [anon_sym_null] = ACTIONS(3043),
    [anon_sym_QMARK] = ACTIONS(3043),
    [anon_sym_COLON_QMARK] = ACTIONS(3043),
    [anon_sym_COLON_COLON] = ACTIONS(3045),
    [anon_sym_AMP] = ACTIONS(3043),
    [anon_sym_LBRACK] = ACTIONS(3043),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3045),
    [anon_sym_LBRACE] = ACTIONS(3043),
    [anon_sym_LT_AT] = ACTIONS(3043),
    [anon_sym_LT_AT_AT] = ACTIONS(3043),
    [anon_sym_DOT] = ACTIONS(3043),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3045),
    [anon_sym_new] = ACTIONS(3043),
    [anon_sym_with] = ACTIONS(3043),
    [anon_sym_return_BANG] = ACTIONS(3045),
    [anon_sym_yield] = ACTIONS(3043),
    [anon_sym_yield_BANG] = ACTIONS(3045),
    [anon_sym_lazy] = ACTIONS(3043),
    [anon_sym_assert] = ACTIONS(3043),
    [anon_sym_upcast] = ACTIONS(3043),
    [anon_sym_downcast] = ACTIONS(3043),
    [anon_sym_COLON_GT] = ACTIONS(3045),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3045),
    [anon_sym_for] = ACTIONS(3043),
    [anon_sym_while] = ACTIONS(3043),
    [anon_sym_if] = ACTIONS(3043),
    [anon_sym_fun] = ACTIONS(3043),
    [anon_sym_try] = ACTIONS(3043),
    [anon_sym_match] = ACTIONS(3043),
    [anon_sym_match_BANG] = ACTIONS(3045),
    [anon_sym_function] = ACTIONS(3043),
    [anon_sym_LT_DASH] = ACTIONS(3043),
    [anon_sym_DOT_LBRACK] = ACTIONS(3045),
    [anon_sym_LT] = ACTIONS(3045),
    [anon_sym_use] = ACTIONS(3043),
    [anon_sym_use_BANG] = ACTIONS(3045),
    [anon_sym_do_BANG] = ACTIONS(3045),
    [anon_sym_begin] = ACTIONS(3043),
    [anon_sym_LPAREN2] = ACTIONS(3043),
    [anon_sym_or] = ACTIONS(3043),
    [aux_sym_char_token1] = ACTIONS(3045),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3043),
    [anon_sym_DQUOTE] = ACTIONS(3043),
    [anon_sym_AT_DQUOTE] = ACTIONS(3045),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3045),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3045),
    [sym_bool] = ACTIONS(3043),
    [sym_unit] = ACTIONS(3045),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3043),
    [sym_op_identifier] = ACTIONS(3043),
    [anon_sym_PLUS] = ACTIONS(3043),
    [anon_sym_DASH] = ACTIONS(3043),
    [anon_sym_PLUS_DOT] = ACTIONS(3043),
    [anon_sym_DASH_DOT] = ACTIONS(3043),
    [anon_sym_PERCENT] = ACTIONS(3043),
    [anon_sym_AMP_AMP] = ACTIONS(3043),
    [anon_sym_TILDE] = ACTIONS(3045),
    [aux_sym_prefix_op_token1] = ACTIONS(3043),
    [aux_sym_infix_op_token1] = ACTIONS(3045),
    [aux_sym_infix_op_token2] = ACTIONS(3043),
    [anon_sym_PIPE_PIPE] = ACTIONS(3043),
    [anon_sym_BANG_EQ] = ACTIONS(3043),
    [anon_sym_COLON_EQ] = ACTIONS(3045),
    [anon_sym_DOLLAR] = ACTIONS(3043),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3043),
    [sym_int] = ACTIONS(3043),
    [sym_xint] = ACTIONS(3045),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3045),
    [sym__newline] = ACTIONS(3045),
  },
  [1914] = {
    [sym_block_comment] = STATE(1914),
    [sym_compiler_directive_decl] = STATE(1914),
    [sym_fsi_directive_decl] = STATE(1914),
    [sym_preproc_line] = STATE(1914),
    [aux_sym_long_identifier_repeat1] = STATE(1904),
    [sym_identifier] = ACTIONS(2418),
    [anon_sym_EQ] = ACTIONS(2420),
    [anon_sym_COLON] = ACTIONS(2418),
    [anon_sym_return] = ACTIONS(2418),
    [anon_sym_do] = ACTIONS(2418),
    [anon_sym_let] = ACTIONS(2418),
    [anon_sym_let_BANG] = ACTIONS(2420),
    [anon_sym_LPAREN] = ACTIONS(2418),
    [anon_sym_COMMA] = ACTIONS(2420),
    [anon_sym_null] = ACTIONS(2418),
    [anon_sym_QMARK] = ACTIONS(2418),
    [anon_sym_COLON_QMARK] = ACTIONS(2418),
    [anon_sym_COLON_COLON] = ACTIONS(2420),
    [anon_sym_AMP] = ACTIONS(2418),
    [anon_sym_LBRACK] = ACTIONS(2418),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2420),
    [anon_sym_LBRACE] = ACTIONS(2418),
    [anon_sym_LT_AT] = ACTIONS(2418),
    [anon_sym_LT_AT_AT] = ACTIONS(2418),
    [anon_sym_AT_AT_GT] = ACTIONS(2418),
    [anon_sym_DOT] = ACTIONS(4151),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2420),
    [anon_sym_new] = ACTIONS(2418),
    [anon_sym_return_BANG] = ACTIONS(2420),
    [anon_sym_yield] = ACTIONS(2418),
    [anon_sym_yield_BANG] = ACTIONS(2420),
    [anon_sym_lazy] = ACTIONS(2418),
    [anon_sym_assert] = ACTIONS(2418),
    [anon_sym_upcast] = ACTIONS(2418),
    [anon_sym_downcast] = ACTIONS(2418),
    [anon_sym_COLON_GT] = ACTIONS(2420),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2420),
    [anon_sym_for] = ACTIONS(2418),
    [anon_sym_while] = ACTIONS(2418),
    [anon_sym_if] = ACTIONS(2418),
    [anon_sym_fun] = ACTIONS(2418),
    [anon_sym_try] = ACTIONS(2418),
    [anon_sym_match] = ACTIONS(2418),
    [anon_sym_match_BANG] = ACTIONS(2420),
    [anon_sym_function] = ACTIONS(2418),
    [anon_sym_LT_DASH] = ACTIONS(2418),
    [anon_sym_DOT_LBRACK] = ACTIONS(2420),
    [anon_sym_LT] = ACTIONS(2420),
    [anon_sym_use] = ACTIONS(2418),
    [anon_sym_use_BANG] = ACTIONS(2420),
    [anon_sym_do_BANG] = ACTIONS(2420),
    [anon_sym_begin] = ACTIONS(2418),
    [anon_sym_LPAREN2] = ACTIONS(2418),
    [anon_sym_or] = ACTIONS(2418),
    [aux_sym_char_token1] = ACTIONS(2420),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2418),
    [anon_sym_DQUOTE] = ACTIONS(2418),
    [anon_sym_AT_DQUOTE] = ACTIONS(2420),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2420),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2420),
    [sym_bool] = ACTIONS(2418),
    [sym_unit] = ACTIONS(2420),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2418),
    [sym_op_identifier] = ACTIONS(2418),
    [anon_sym_PLUS] = ACTIONS(2418),
    [anon_sym_DASH] = ACTIONS(2418),
    [anon_sym_PLUS_DOT] = ACTIONS(2418),
    [anon_sym_DASH_DOT] = ACTIONS(2418),
    [anon_sym_PERCENT] = ACTIONS(2418),
    [anon_sym_AMP_AMP] = ACTIONS(2418),
    [anon_sym_TILDE] = ACTIONS(2420),
    [aux_sym_prefix_op_token1] = ACTIONS(2418),
    [aux_sym_infix_op_token1] = ACTIONS(2420),
    [aux_sym_infix_op_token2] = ACTIONS(2418),
    [anon_sym_PIPE_PIPE] = ACTIONS(2418),
    [anon_sym_BANG_EQ] = ACTIONS(2418),
    [anon_sym_COLON_EQ] = ACTIONS(2420),
    [anon_sym_DOLLAR] = ACTIONS(2418),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2418),
    [sym_int] = ACTIONS(2418),
    [sym_xint] = ACTIONS(2420),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2420),
    [sym__newline] = ACTIONS(2420),
  },
  [1915] = {
    [sym_block_comment] = STATE(1915),
    [sym_compiler_directive_decl] = STATE(1915),
    [sym_fsi_directive_decl] = STATE(1915),
    [sym_preproc_line] = STATE(1915),
    [sym_identifier] = ACTIONS(2934),
    [anon_sym_EQ] = ACTIONS(2936),
    [anon_sym_COLON] = ACTIONS(2934),
    [anon_sym_return] = ACTIONS(2934),
    [anon_sym_do] = ACTIONS(2934),
    [anon_sym_let] = ACTIONS(2934),
    [anon_sym_let_BANG] = ACTIONS(2936),
    [anon_sym_LPAREN] = ACTIONS(2934),
    [anon_sym_COMMA] = ACTIONS(2936),
    [anon_sym_null] = ACTIONS(2934),
    [anon_sym_QMARK] = ACTIONS(2934),
    [anon_sym_COLON_QMARK] = ACTIONS(2934),
    [anon_sym_COLON_COLON] = ACTIONS(2936),
    [anon_sym_AMP] = ACTIONS(2934),
    [anon_sym_LBRACK] = ACTIONS(2934),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2936),
    [anon_sym_LBRACE] = ACTIONS(2934),
    [anon_sym_LT_AT] = ACTIONS(2934),
    [anon_sym_LT_AT_AT] = ACTIONS(2934),
    [anon_sym_DOT] = ACTIONS(2934),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2936),
    [anon_sym_new] = ACTIONS(2934),
    [anon_sym_return_BANG] = ACTIONS(2936),
    [anon_sym_yield] = ACTIONS(2934),
    [anon_sym_yield_BANG] = ACTIONS(2936),
    [anon_sym_lazy] = ACTIONS(2934),
    [anon_sym_assert] = ACTIONS(2934),
    [anon_sym_upcast] = ACTIONS(2934),
    [anon_sym_downcast] = ACTIONS(2934),
    [anon_sym_COLON_GT] = ACTIONS(2936),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2936),
    [anon_sym_for] = ACTIONS(2934),
    [anon_sym_while] = ACTIONS(2934),
    [anon_sym_if] = ACTIONS(2934),
    [anon_sym_fun] = ACTIONS(2934),
    [anon_sym_try] = ACTIONS(2934),
    [anon_sym_match] = ACTIONS(2934),
    [anon_sym_match_BANG] = ACTIONS(2936),
    [anon_sym_function] = ACTIONS(2934),
    [anon_sym_LT_DASH] = ACTIONS(2934),
    [anon_sym_DOT_LBRACK] = ACTIONS(2936),
    [anon_sym_LT] = ACTIONS(2936),
    [anon_sym_use] = ACTIONS(2934),
    [anon_sym_use_BANG] = ACTIONS(2936),
    [anon_sym_do_BANG] = ACTIONS(2936),
    [anon_sym_begin] = ACTIONS(2934),
    [anon_sym_LPAREN2] = ACTIONS(2934),
    [anon_sym_or] = ACTIONS(2934),
    [aux_sym_char_token1] = ACTIONS(2936),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2934),
    [anon_sym_DQUOTE] = ACTIONS(2934),
    [anon_sym_AT_DQUOTE] = ACTIONS(2936),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2936),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2936),
    [sym_bool] = ACTIONS(2934),
    [sym_unit] = ACTIONS(2936),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2934),
    [sym_op_identifier] = ACTIONS(2934),
    [anon_sym_PLUS] = ACTIONS(2934),
    [anon_sym_DASH] = ACTIONS(2934),
    [anon_sym_PLUS_DOT] = ACTIONS(2934),
    [anon_sym_DASH_DOT] = ACTIONS(2934),
    [anon_sym_PERCENT] = ACTIONS(2934),
    [anon_sym_AMP_AMP] = ACTIONS(2934),
    [anon_sym_TILDE] = ACTIONS(2936),
    [aux_sym_prefix_op_token1] = ACTIONS(2934),
    [aux_sym_infix_op_token1] = ACTIONS(2936),
    [aux_sym_infix_op_token2] = ACTIONS(2934),
    [anon_sym_PIPE_PIPE] = ACTIONS(2934),
    [anon_sym_BANG_EQ] = ACTIONS(2934),
    [anon_sym_COLON_EQ] = ACTIONS(2936),
    [anon_sym_DOLLAR] = ACTIONS(2934),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2934),
    [sym_int] = ACTIONS(2934),
    [sym_xint] = ACTIONS(2936),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2936),
    [anon_sym_POUNDendif] = ACTIONS(2936),
    [anon_sym_POUNDelse] = ACTIONS(2936),
    [sym__newline] = ACTIONS(2936),
  },
  [1916] = {
    [sym_block_comment] = STATE(1916),
    [sym_compiler_directive_decl] = STATE(1916),
    [sym_fsi_directive_decl] = STATE(1916),
    [sym_preproc_line] = STATE(1916),
    [sym_identifier] = ACTIONS(3047),
    [anon_sym_EQ] = ACTIONS(3049),
    [anon_sym_COLON] = ACTIONS(3047),
    [anon_sym_return] = ACTIONS(3047),
    [anon_sym_do] = ACTIONS(3047),
    [anon_sym_let] = ACTIONS(3047),
    [anon_sym_let_BANG] = ACTIONS(3049),
    [anon_sym_as] = ACTIONS(3047),
    [anon_sym_LPAREN] = ACTIONS(3047),
    [anon_sym_COMMA] = ACTIONS(3049),
    [anon_sym_null] = ACTIONS(3047),
    [anon_sym_QMARK] = ACTIONS(3047),
    [anon_sym_COLON_QMARK] = ACTIONS(3047),
    [anon_sym_COLON_COLON] = ACTIONS(3049),
    [anon_sym_AMP] = ACTIONS(3047),
    [anon_sym_LBRACK] = ACTIONS(3047),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3049),
    [anon_sym_LBRACE] = ACTIONS(3047),
    [anon_sym_LT_AT] = ACTIONS(3047),
    [anon_sym_LT_AT_AT] = ACTIONS(3047),
    [anon_sym_DOT] = ACTIONS(3047),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3049),
    [anon_sym_new] = ACTIONS(3047),
    [anon_sym_with] = ACTIONS(3047),
    [anon_sym_return_BANG] = ACTIONS(3049),
    [anon_sym_yield] = ACTIONS(3047),
    [anon_sym_yield_BANG] = ACTIONS(3049),
    [anon_sym_lazy] = ACTIONS(3047),
    [anon_sym_assert] = ACTIONS(3047),
    [anon_sym_upcast] = ACTIONS(3047),
    [anon_sym_downcast] = ACTIONS(3047),
    [anon_sym_COLON_GT] = ACTIONS(3049),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3049),
    [anon_sym_for] = ACTIONS(3047),
    [anon_sym_while] = ACTIONS(3047),
    [anon_sym_if] = ACTIONS(3047),
    [anon_sym_fun] = ACTIONS(3047),
    [anon_sym_try] = ACTIONS(3047),
    [anon_sym_match] = ACTIONS(3047),
    [anon_sym_match_BANG] = ACTIONS(3049),
    [anon_sym_function] = ACTIONS(3047),
    [anon_sym_LT_DASH] = ACTIONS(3047),
    [anon_sym_DOT_LBRACK] = ACTIONS(3049),
    [anon_sym_LT] = ACTIONS(3049),
    [anon_sym_use] = ACTIONS(3047),
    [anon_sym_use_BANG] = ACTIONS(3049),
    [anon_sym_do_BANG] = ACTIONS(3049),
    [anon_sym_begin] = ACTIONS(3047),
    [anon_sym_LPAREN2] = ACTIONS(3047),
    [anon_sym_or] = ACTIONS(3047),
    [aux_sym_char_token1] = ACTIONS(3049),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3047),
    [anon_sym_DQUOTE] = ACTIONS(3047),
    [anon_sym_AT_DQUOTE] = ACTIONS(3049),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3049),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3049),
    [sym_bool] = ACTIONS(3047),
    [sym_unit] = ACTIONS(3049),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3047),
    [sym_op_identifier] = ACTIONS(3047),
    [anon_sym_PLUS] = ACTIONS(3047),
    [anon_sym_DASH] = ACTIONS(3047),
    [anon_sym_PLUS_DOT] = ACTIONS(3047),
    [anon_sym_DASH_DOT] = ACTIONS(3047),
    [anon_sym_PERCENT] = ACTIONS(3047),
    [anon_sym_AMP_AMP] = ACTIONS(3047),
    [anon_sym_TILDE] = ACTIONS(3049),
    [aux_sym_prefix_op_token1] = ACTIONS(3047),
    [aux_sym_infix_op_token1] = ACTIONS(3049),
    [aux_sym_infix_op_token2] = ACTIONS(3047),
    [anon_sym_PIPE_PIPE] = ACTIONS(3047),
    [anon_sym_BANG_EQ] = ACTIONS(3047),
    [anon_sym_COLON_EQ] = ACTIONS(3049),
    [anon_sym_DOLLAR] = ACTIONS(3047),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3047),
    [sym_int] = ACTIONS(3047),
    [sym_xint] = ACTIONS(3049),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3049),
    [sym__newline] = ACTIONS(3049),
  },
  [1917] = {
    [sym_block_comment] = STATE(1917),
    [sym_compiler_directive_decl] = STATE(1917),
    [sym_fsi_directive_decl] = STATE(1917),
    [sym_preproc_line] = STATE(1917),
    [aux_sym_long_identifier_repeat1] = STATE(1917),
    [sym_identifier] = ACTIONS(2411),
    [anon_sym_EQ] = ACTIONS(2413),
    [anon_sym_COLON] = ACTIONS(2411),
    [anon_sym_return] = ACTIONS(2411),
    [anon_sym_do] = ACTIONS(2411),
    [anon_sym_let] = ACTIONS(2411),
    [anon_sym_let_BANG] = ACTIONS(2413),
    [anon_sym_LPAREN] = ACTIONS(2411),
    [anon_sym_COMMA] = ACTIONS(2413),
    [anon_sym_null] = ACTIONS(2411),
    [anon_sym_QMARK] = ACTIONS(2411),
    [anon_sym_COLON_QMARK] = ACTIONS(2411),
    [anon_sym_COLON_COLON] = ACTIONS(2413),
    [anon_sym_AMP] = ACTIONS(2411),
    [anon_sym_LBRACK] = ACTIONS(2411),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2413),
    [anon_sym_LBRACE] = ACTIONS(2411),
    [anon_sym_LT_AT] = ACTIONS(2411),
    [anon_sym_LT_AT_AT] = ACTIONS(2411),
    [anon_sym_DOT] = ACTIONS(4153),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2413),
    [anon_sym_new] = ACTIONS(2411),
    [anon_sym_return_BANG] = ACTIONS(2413),
    [anon_sym_yield] = ACTIONS(2411),
    [anon_sym_yield_BANG] = ACTIONS(2413),
    [anon_sym_lazy] = ACTIONS(2411),
    [anon_sym_assert] = ACTIONS(2411),
    [anon_sym_upcast] = ACTIONS(2411),
    [anon_sym_downcast] = ACTIONS(2411),
    [anon_sym_COLON_GT] = ACTIONS(2413),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2413),
    [anon_sym_for] = ACTIONS(2411),
    [anon_sym_while] = ACTIONS(2411),
    [anon_sym_if] = ACTIONS(2411),
    [anon_sym_fun] = ACTIONS(2411),
    [anon_sym_try] = ACTIONS(2411),
    [anon_sym_match] = ACTIONS(2411),
    [anon_sym_match_BANG] = ACTIONS(2413),
    [anon_sym_function] = ACTIONS(2411),
    [anon_sym_LT_DASH] = ACTIONS(2411),
    [anon_sym_DOT_LBRACK] = ACTIONS(2413),
    [anon_sym_LT] = ACTIONS(2413),
    [anon_sym_GT] = ACTIONS(2411),
    [anon_sym_use] = ACTIONS(2411),
    [anon_sym_use_BANG] = ACTIONS(2413),
    [anon_sym_do_BANG] = ACTIONS(2413),
    [anon_sym_begin] = ACTIONS(2411),
    [anon_sym_LPAREN2] = ACTIONS(2411),
    [anon_sym_or] = ACTIONS(2411),
    [aux_sym_char_token1] = ACTIONS(2413),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2411),
    [anon_sym_DQUOTE] = ACTIONS(2411),
    [anon_sym_AT_DQUOTE] = ACTIONS(2413),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2413),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2413),
    [sym_bool] = ACTIONS(2411),
    [sym_unit] = ACTIONS(2413),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2411),
    [sym_op_identifier] = ACTIONS(2411),
    [anon_sym_PLUS] = ACTIONS(2411),
    [anon_sym_DASH] = ACTIONS(2411),
    [anon_sym_PLUS_DOT] = ACTIONS(2411),
    [anon_sym_DASH_DOT] = ACTIONS(2411),
    [anon_sym_PERCENT] = ACTIONS(2411),
    [anon_sym_AMP_AMP] = ACTIONS(2411),
    [anon_sym_TILDE] = ACTIONS(2413),
    [aux_sym_prefix_op_token1] = ACTIONS(2411),
    [aux_sym_infix_op_token1] = ACTIONS(2413),
    [aux_sym_infix_op_token2] = ACTIONS(2411),
    [anon_sym_PIPE_PIPE] = ACTIONS(2411),
    [anon_sym_BANG_EQ] = ACTIONS(2411),
    [anon_sym_COLON_EQ] = ACTIONS(2413),
    [anon_sym_DOLLAR] = ACTIONS(2411),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2411),
    [sym_int] = ACTIONS(2411),
    [sym_xint] = ACTIONS(2413),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2413),
    [sym__newline] = ACTIONS(2413),
  },
  [1918] = {
    [sym_block_comment] = STATE(1918),
    [sym_compiler_directive_decl] = STATE(1918),
    [sym_fsi_directive_decl] = STATE(1918),
    [sym_preproc_line] = STATE(1918),
    [sym_identifier] = ACTIONS(2713),
    [anon_sym_EQ] = ACTIONS(2715),
    [anon_sym_COLON] = ACTIONS(2713),
    [anon_sym_return] = ACTIONS(2713),
    [anon_sym_do] = ACTIONS(2713),
    [anon_sym_let] = ACTIONS(2713),
    [anon_sym_let_BANG] = ACTIONS(2715),
    [anon_sym_LPAREN] = ACTIONS(2713),
    [anon_sym_COMMA] = ACTIONS(2715),
    [anon_sym_null] = ACTIONS(2713),
    [anon_sym_QMARK] = ACTIONS(2713),
    [anon_sym_COLON_QMARK] = ACTIONS(2713),
    [anon_sym_COLON_COLON] = ACTIONS(2715),
    [anon_sym_PIPE] = ACTIONS(2713),
    [anon_sym_AMP] = ACTIONS(2713),
    [anon_sym_LBRACK] = ACTIONS(2713),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2715),
    [anon_sym_LBRACE] = ACTIONS(2713),
    [anon_sym_LT_AT] = ACTIONS(2713),
    [anon_sym_LT_AT_AT] = ACTIONS(2713),
    [anon_sym_AT_AT_GT] = ACTIONS(2713),
    [anon_sym_DOT] = ACTIONS(2713),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2715),
    [anon_sym_new] = ACTIONS(2713),
    [anon_sym_return_BANG] = ACTIONS(2715),
    [anon_sym_yield] = ACTIONS(2713),
    [anon_sym_yield_BANG] = ACTIONS(2715),
    [anon_sym_lazy] = ACTIONS(2713),
    [anon_sym_assert] = ACTIONS(2713),
    [anon_sym_upcast] = ACTIONS(2713),
    [anon_sym_downcast] = ACTIONS(2713),
    [anon_sym_COLON_GT] = ACTIONS(2715),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2715),
    [anon_sym_for] = ACTIONS(2713),
    [anon_sym_while] = ACTIONS(2713),
    [anon_sym_if] = ACTIONS(2713),
    [anon_sym_fun] = ACTIONS(2713),
    [anon_sym_try] = ACTIONS(2713),
    [anon_sym_match] = ACTIONS(2713),
    [anon_sym_match_BANG] = ACTIONS(2715),
    [anon_sym_function] = ACTIONS(2713),
    [anon_sym_LT_DASH] = ACTIONS(2713),
    [anon_sym_DOT_LBRACK] = ACTIONS(2715),
    [anon_sym_LT] = ACTIONS(2715),
    [anon_sym_use] = ACTIONS(2713),
    [anon_sym_use_BANG] = ACTIONS(2715),
    [anon_sym_do_BANG] = ACTIONS(2715),
    [anon_sym_begin] = ACTIONS(2713),
    [anon_sym_LPAREN2] = ACTIONS(2713),
    [anon_sym_or] = ACTIONS(2713),
    [aux_sym_char_token1] = ACTIONS(2715),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2713),
    [anon_sym_DQUOTE] = ACTIONS(2713),
    [anon_sym_AT_DQUOTE] = ACTIONS(2715),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2715),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2715),
    [sym_bool] = ACTIONS(2713),
    [sym_unit] = ACTIONS(2715),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2713),
    [sym_op_identifier] = ACTIONS(2713),
    [anon_sym_PLUS] = ACTIONS(2713),
    [anon_sym_DASH] = ACTIONS(2713),
    [anon_sym_PLUS_DOT] = ACTIONS(2713),
    [anon_sym_DASH_DOT] = ACTIONS(2713),
    [anon_sym_PERCENT] = ACTIONS(2713),
    [anon_sym_AMP_AMP] = ACTIONS(2713),
    [anon_sym_TILDE] = ACTIONS(2715),
    [aux_sym_prefix_op_token1] = ACTIONS(2713),
    [aux_sym_infix_op_token1] = ACTIONS(2715),
    [aux_sym_infix_op_token2] = ACTIONS(2713),
    [anon_sym_PIPE_PIPE] = ACTIONS(2713),
    [anon_sym_BANG_EQ] = ACTIONS(2713),
    [anon_sym_COLON_EQ] = ACTIONS(2715),
    [anon_sym_DOLLAR] = ACTIONS(2713),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2713),
    [sym_int] = ACTIONS(2713),
    [sym_xint] = ACTIONS(2715),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2715),
    [sym__newline] = ACTIONS(2715),
  },
  [1919] = {
    [sym_block_comment] = STATE(1919),
    [sym_compiler_directive_decl] = STATE(1919),
    [sym_fsi_directive_decl] = STATE(1919),
    [sym_preproc_line] = STATE(1919),
    [sym_identifier] = ACTIONS(3055),
    [anon_sym_EQ] = ACTIONS(3057),
    [anon_sym_COLON] = ACTIONS(3055),
    [anon_sym_return] = ACTIONS(3055),
    [anon_sym_do] = ACTIONS(3055),
    [anon_sym_let] = ACTIONS(3055),
    [anon_sym_let_BANG] = ACTIONS(3057),
    [anon_sym_LPAREN] = ACTIONS(3055),
    [anon_sym_COMMA] = ACTIONS(3057),
    [anon_sym_null] = ACTIONS(3055),
    [anon_sym_QMARK] = ACTIONS(3055),
    [anon_sym_COLON_QMARK] = ACTIONS(3055),
    [anon_sym_COLON_COLON] = ACTIONS(3057),
    [anon_sym_AMP] = ACTIONS(3055),
    [anon_sym_LBRACK] = ACTIONS(3055),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3057),
    [anon_sym_LBRACE] = ACTIONS(3055),
    [anon_sym_LT_AT] = ACTIONS(3055),
    [anon_sym_LT_AT_AT] = ACTIONS(3055),
    [anon_sym_DOT] = ACTIONS(3055),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3057),
    [anon_sym_new] = ACTIONS(3055),
    [anon_sym_return_BANG] = ACTIONS(3057),
    [anon_sym_yield] = ACTIONS(3055),
    [anon_sym_yield_BANG] = ACTIONS(3057),
    [anon_sym_lazy] = ACTIONS(3055),
    [anon_sym_assert] = ACTIONS(3055),
    [anon_sym_upcast] = ACTIONS(3055),
    [anon_sym_downcast] = ACTIONS(3055),
    [anon_sym_COLON_GT] = ACTIONS(3057),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3057),
    [anon_sym_for] = ACTIONS(3055),
    [anon_sym_while] = ACTIONS(3055),
    [anon_sym_if] = ACTIONS(3055),
    [anon_sym_fun] = ACTIONS(3055),
    [anon_sym_DASH_GT] = ACTIONS(3055),
    [anon_sym_try] = ACTIONS(3055),
    [anon_sym_match] = ACTIONS(3055),
    [anon_sym_match_BANG] = ACTIONS(3057),
    [anon_sym_function] = ACTIONS(3055),
    [anon_sym_LT_DASH] = ACTIONS(3055),
    [anon_sym_DOT_LBRACK] = ACTIONS(3057),
    [anon_sym_LT] = ACTIONS(3057),
    [anon_sym_use] = ACTIONS(3055),
    [anon_sym_use_BANG] = ACTIONS(3057),
    [anon_sym_do_BANG] = ACTIONS(3057),
    [anon_sym_DOT_DOT] = ACTIONS(3057),
    [anon_sym_begin] = ACTIONS(3055),
    [anon_sym_LPAREN2] = ACTIONS(3055),
    [anon_sym_or] = ACTIONS(3055),
    [aux_sym_char_token1] = ACTIONS(3057),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3055),
    [anon_sym_DQUOTE] = ACTIONS(3055),
    [anon_sym_AT_DQUOTE] = ACTIONS(3057),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3057),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3057),
    [sym_bool] = ACTIONS(3055),
    [sym_unit] = ACTIONS(3057),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3055),
    [sym_op_identifier] = ACTIONS(3055),
    [anon_sym_PLUS] = ACTIONS(3055),
    [anon_sym_DASH] = ACTIONS(3055),
    [anon_sym_PLUS_DOT] = ACTIONS(3055),
    [anon_sym_DASH_DOT] = ACTIONS(3055),
    [anon_sym_PERCENT] = ACTIONS(3055),
    [anon_sym_AMP_AMP] = ACTIONS(3055),
    [anon_sym_TILDE] = ACTIONS(3057),
    [aux_sym_prefix_op_token1] = ACTIONS(3055),
    [aux_sym_infix_op_token1] = ACTIONS(3057),
    [aux_sym_infix_op_token2] = ACTIONS(3055),
    [anon_sym_PIPE_PIPE] = ACTIONS(3055),
    [anon_sym_BANG_EQ] = ACTIONS(3055),
    [anon_sym_COLON_EQ] = ACTIONS(3057),
    [anon_sym_DOLLAR] = ACTIONS(3055),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3055),
    [sym_int] = ACTIONS(3055),
    [sym_xint] = ACTIONS(3057),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3057),
    [sym__newline] = ACTIONS(3057),
  },
  [1920] = {
    [sym_block_comment] = STATE(1920),
    [sym_compiler_directive_decl] = STATE(1920),
    [sym_fsi_directive_decl] = STATE(1920),
    [sym_preproc_line] = STATE(1920),
    [sym_identifier] = ACTIONS(3051),
    [anon_sym_EQ] = ACTIONS(3053),
    [anon_sym_COLON] = ACTIONS(3051),
    [anon_sym_return] = ACTIONS(3051),
    [anon_sym_do] = ACTIONS(3051),
    [anon_sym_let] = ACTIONS(3051),
    [anon_sym_let_BANG] = ACTIONS(3053),
    [anon_sym_as] = ACTIONS(3051),
    [anon_sym_LPAREN] = ACTIONS(3051),
    [anon_sym_COMMA] = ACTIONS(3053),
    [anon_sym_null] = ACTIONS(3051),
    [anon_sym_QMARK] = ACTIONS(3051),
    [anon_sym_COLON_QMARK] = ACTIONS(3051),
    [anon_sym_COLON_COLON] = ACTIONS(3053),
    [anon_sym_AMP] = ACTIONS(3051),
    [anon_sym_LBRACK] = ACTIONS(3051),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3053),
    [anon_sym_LBRACE] = ACTIONS(3051),
    [anon_sym_LT_AT] = ACTIONS(3051),
    [anon_sym_LT_AT_AT] = ACTIONS(3051),
    [anon_sym_DOT] = ACTIONS(3051),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3053),
    [anon_sym_new] = ACTIONS(3051),
    [anon_sym_with] = ACTIONS(3051),
    [anon_sym_return_BANG] = ACTIONS(3053),
    [anon_sym_yield] = ACTIONS(3051),
    [anon_sym_yield_BANG] = ACTIONS(3053),
    [anon_sym_lazy] = ACTIONS(3051),
    [anon_sym_assert] = ACTIONS(3051),
    [anon_sym_upcast] = ACTIONS(3051),
    [anon_sym_downcast] = ACTIONS(3051),
    [anon_sym_COLON_GT] = ACTIONS(3053),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3053),
    [anon_sym_for] = ACTIONS(3051),
    [anon_sym_while] = ACTIONS(3051),
    [anon_sym_if] = ACTIONS(3051),
    [anon_sym_fun] = ACTIONS(3051),
    [anon_sym_try] = ACTIONS(3051),
    [anon_sym_match] = ACTIONS(3051),
    [anon_sym_match_BANG] = ACTIONS(3053),
    [anon_sym_function] = ACTIONS(3051),
    [anon_sym_LT_DASH] = ACTIONS(3051),
    [anon_sym_DOT_LBRACK] = ACTIONS(3053),
    [anon_sym_LT] = ACTIONS(3053),
    [anon_sym_use] = ACTIONS(3051),
    [anon_sym_use_BANG] = ACTIONS(3053),
    [anon_sym_do_BANG] = ACTIONS(3053),
    [anon_sym_begin] = ACTIONS(3051),
    [anon_sym_LPAREN2] = ACTIONS(3051),
    [anon_sym_or] = ACTIONS(3051),
    [aux_sym_char_token1] = ACTIONS(3053),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3051),
    [anon_sym_DQUOTE] = ACTIONS(3051),
    [anon_sym_AT_DQUOTE] = ACTIONS(3053),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3053),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3053),
    [sym_bool] = ACTIONS(3051),
    [sym_unit] = ACTIONS(3053),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3051),
    [sym_op_identifier] = ACTIONS(3051),
    [anon_sym_PLUS] = ACTIONS(3051),
    [anon_sym_DASH] = ACTIONS(3051),
    [anon_sym_PLUS_DOT] = ACTIONS(3051),
    [anon_sym_DASH_DOT] = ACTIONS(3051),
    [anon_sym_PERCENT] = ACTIONS(3051),
    [anon_sym_AMP_AMP] = ACTIONS(3051),
    [anon_sym_TILDE] = ACTIONS(3053),
    [aux_sym_prefix_op_token1] = ACTIONS(3051),
    [aux_sym_infix_op_token1] = ACTIONS(3053),
    [aux_sym_infix_op_token2] = ACTIONS(3051),
    [anon_sym_PIPE_PIPE] = ACTIONS(3051),
    [anon_sym_BANG_EQ] = ACTIONS(3051),
    [anon_sym_COLON_EQ] = ACTIONS(3053),
    [anon_sym_DOLLAR] = ACTIONS(3051),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3051),
    [sym_int] = ACTIONS(3051),
    [sym_xint] = ACTIONS(3053),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3053),
    [sym__newline] = ACTIONS(3053),
  },
  [1921] = {
    [sym_block_comment] = STATE(1921),
    [sym_compiler_directive_decl] = STATE(1921),
    [sym_fsi_directive_decl] = STATE(1921),
    [sym_preproc_line] = STATE(1921),
    [sym_identifier] = ACTIONS(3115),
    [anon_sym_EQ] = ACTIONS(3117),
    [anon_sym_COLON] = ACTIONS(3115),
    [anon_sym_return] = ACTIONS(3115),
    [anon_sym_do] = ACTIONS(3115),
    [anon_sym_let] = ACTIONS(3115),
    [anon_sym_let_BANG] = ACTIONS(3117),
    [anon_sym_LPAREN] = ACTIONS(3115),
    [anon_sym_COMMA] = ACTIONS(3117),
    [anon_sym_null] = ACTIONS(3115),
    [anon_sym_QMARK] = ACTIONS(3115),
    [anon_sym_COLON_QMARK] = ACTIONS(3115),
    [anon_sym_COLON_COLON] = ACTIONS(3117),
    [anon_sym_AMP] = ACTIONS(3115),
    [anon_sym_LBRACK] = ACTIONS(3115),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3117),
    [anon_sym_LBRACE] = ACTIONS(3115),
    [anon_sym_LT_AT] = ACTIONS(3115),
    [anon_sym_LT_AT_AT] = ACTIONS(3115),
    [anon_sym_DOT] = ACTIONS(3115),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3117),
    [anon_sym_new] = ACTIONS(3115),
    [anon_sym_return_BANG] = ACTIONS(3117),
    [anon_sym_yield] = ACTIONS(3115),
    [anon_sym_yield_BANG] = ACTIONS(3117),
    [anon_sym_lazy] = ACTIONS(3115),
    [anon_sym_assert] = ACTIONS(3115),
    [anon_sym_upcast] = ACTIONS(3115),
    [anon_sym_downcast] = ACTIONS(3115),
    [anon_sym_COLON_GT] = ACTIONS(3117),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3117),
    [anon_sym_for] = ACTIONS(3115),
    [anon_sym_while] = ACTIONS(3115),
    [anon_sym_if] = ACTIONS(3115),
    [anon_sym_fun] = ACTIONS(3115),
    [anon_sym_DASH_GT] = ACTIONS(3115),
    [anon_sym_try] = ACTIONS(3115),
    [anon_sym_match] = ACTIONS(3115),
    [anon_sym_match_BANG] = ACTIONS(3117),
    [anon_sym_function] = ACTIONS(3115),
    [anon_sym_LT_DASH] = ACTIONS(3115),
    [anon_sym_DOT_LBRACK] = ACTIONS(3117),
    [anon_sym_LT] = ACTIONS(3117),
    [anon_sym_use] = ACTIONS(3115),
    [anon_sym_use_BANG] = ACTIONS(3117),
    [anon_sym_do_BANG] = ACTIONS(3117),
    [anon_sym_DOT_DOT] = ACTIONS(3117),
    [anon_sym_begin] = ACTIONS(3115),
    [anon_sym_LPAREN2] = ACTIONS(3115),
    [anon_sym_or] = ACTIONS(3115),
    [aux_sym_char_token1] = ACTIONS(3117),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3115),
    [anon_sym_DQUOTE] = ACTIONS(3115),
    [anon_sym_AT_DQUOTE] = ACTIONS(3117),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3117),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3117),
    [sym_bool] = ACTIONS(3115),
    [sym_unit] = ACTIONS(3117),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3115),
    [sym_op_identifier] = ACTIONS(3115),
    [anon_sym_PLUS] = ACTIONS(3115),
    [anon_sym_DASH] = ACTIONS(3115),
    [anon_sym_PLUS_DOT] = ACTIONS(3115),
    [anon_sym_DASH_DOT] = ACTIONS(3115),
    [anon_sym_PERCENT] = ACTIONS(3115),
    [anon_sym_AMP_AMP] = ACTIONS(3115),
    [anon_sym_TILDE] = ACTIONS(3117),
    [aux_sym_prefix_op_token1] = ACTIONS(3115),
    [aux_sym_infix_op_token1] = ACTIONS(3117),
    [aux_sym_infix_op_token2] = ACTIONS(3115),
    [anon_sym_PIPE_PIPE] = ACTIONS(3115),
    [anon_sym_BANG_EQ] = ACTIONS(3115),
    [anon_sym_COLON_EQ] = ACTIONS(3117),
    [anon_sym_DOLLAR] = ACTIONS(3115),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3115),
    [sym_int] = ACTIONS(3115),
    [sym_xint] = ACTIONS(3117),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3117),
    [sym__newline] = ACTIONS(3117),
  },
  [1922] = {
    [sym_block_comment] = STATE(1922),
    [sym_compiler_directive_decl] = STATE(1922),
    [sym_fsi_directive_decl] = STATE(1922),
    [sym_preproc_line] = STATE(1922),
    [sym_identifier] = ACTIONS(3059),
    [anon_sym_EQ] = ACTIONS(3061),
    [anon_sym_COLON] = ACTIONS(3059),
    [anon_sym_return] = ACTIONS(3059),
    [anon_sym_do] = ACTIONS(3059),
    [anon_sym_let] = ACTIONS(3059),
    [anon_sym_let_BANG] = ACTIONS(3061),
    [anon_sym_as] = ACTIONS(3059),
    [anon_sym_LPAREN] = ACTIONS(3059),
    [anon_sym_COMMA] = ACTIONS(3061),
    [anon_sym_null] = ACTIONS(3059),
    [anon_sym_QMARK] = ACTIONS(3059),
    [anon_sym_COLON_QMARK] = ACTIONS(3059),
    [anon_sym_COLON_COLON] = ACTIONS(3061),
    [anon_sym_AMP] = ACTIONS(3059),
    [anon_sym_LBRACK] = ACTIONS(3059),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3061),
    [anon_sym_LBRACE] = ACTIONS(3059),
    [anon_sym_LT_AT] = ACTIONS(3059),
    [anon_sym_LT_AT_AT] = ACTIONS(3059),
    [anon_sym_DOT] = ACTIONS(3059),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3061),
    [anon_sym_new] = ACTIONS(3059),
    [anon_sym_with] = ACTIONS(3059),
    [anon_sym_return_BANG] = ACTIONS(3061),
    [anon_sym_yield] = ACTIONS(3059),
    [anon_sym_yield_BANG] = ACTIONS(3061),
    [anon_sym_lazy] = ACTIONS(3059),
    [anon_sym_assert] = ACTIONS(3059),
    [anon_sym_upcast] = ACTIONS(3059),
    [anon_sym_downcast] = ACTIONS(3059),
    [anon_sym_COLON_GT] = ACTIONS(3061),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3061),
    [anon_sym_for] = ACTIONS(3059),
    [anon_sym_while] = ACTIONS(3059),
    [anon_sym_if] = ACTIONS(3059),
    [anon_sym_fun] = ACTIONS(3059),
    [anon_sym_try] = ACTIONS(3059),
    [anon_sym_match] = ACTIONS(3059),
    [anon_sym_match_BANG] = ACTIONS(3061),
    [anon_sym_function] = ACTIONS(3059),
    [anon_sym_LT_DASH] = ACTIONS(3059),
    [anon_sym_DOT_LBRACK] = ACTIONS(3061),
    [anon_sym_LT] = ACTIONS(3061),
    [anon_sym_use] = ACTIONS(3059),
    [anon_sym_use_BANG] = ACTIONS(3061),
    [anon_sym_do_BANG] = ACTIONS(3061),
    [anon_sym_begin] = ACTIONS(3059),
    [anon_sym_LPAREN2] = ACTIONS(3059),
    [anon_sym_or] = ACTIONS(3059),
    [aux_sym_char_token1] = ACTIONS(3061),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3059),
    [anon_sym_DQUOTE] = ACTIONS(3059),
    [anon_sym_AT_DQUOTE] = ACTIONS(3061),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3061),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3061),
    [sym_bool] = ACTIONS(3059),
    [sym_unit] = ACTIONS(3061),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3059),
    [sym_op_identifier] = ACTIONS(3059),
    [anon_sym_PLUS] = ACTIONS(3059),
    [anon_sym_DASH] = ACTIONS(3059),
    [anon_sym_PLUS_DOT] = ACTIONS(3059),
    [anon_sym_DASH_DOT] = ACTIONS(3059),
    [anon_sym_PERCENT] = ACTIONS(3059),
    [anon_sym_AMP_AMP] = ACTIONS(3059),
    [anon_sym_TILDE] = ACTIONS(3061),
    [aux_sym_prefix_op_token1] = ACTIONS(3059),
    [aux_sym_infix_op_token1] = ACTIONS(3061),
    [aux_sym_infix_op_token2] = ACTIONS(3059),
    [anon_sym_PIPE_PIPE] = ACTIONS(3059),
    [anon_sym_BANG_EQ] = ACTIONS(3059),
    [anon_sym_COLON_EQ] = ACTIONS(3061),
    [anon_sym_DOLLAR] = ACTIONS(3059),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3059),
    [sym_int] = ACTIONS(3059),
    [sym_xint] = ACTIONS(3061),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3061),
    [sym__newline] = ACTIONS(3061),
  },
  [1923] = {
    [sym_block_comment] = STATE(1923),
    [sym_compiler_directive_decl] = STATE(1923),
    [sym_fsi_directive_decl] = STATE(1923),
    [sym_preproc_line] = STATE(1923),
    [sym_identifier] = ACTIONS(3063),
    [anon_sym_EQ] = ACTIONS(3065),
    [anon_sym_COLON] = ACTIONS(3063),
    [anon_sym_return] = ACTIONS(3063),
    [anon_sym_do] = ACTIONS(3063),
    [anon_sym_let] = ACTIONS(3063),
    [anon_sym_let_BANG] = ACTIONS(3065),
    [anon_sym_as] = ACTIONS(3063),
    [anon_sym_LPAREN] = ACTIONS(3063),
    [anon_sym_COMMA] = ACTIONS(3065),
    [anon_sym_null] = ACTIONS(3063),
    [anon_sym_QMARK] = ACTIONS(3063),
    [anon_sym_COLON_QMARK] = ACTIONS(3063),
    [anon_sym_COLON_COLON] = ACTIONS(3065),
    [anon_sym_AMP] = ACTIONS(3063),
    [anon_sym_LBRACK] = ACTIONS(3063),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3065),
    [anon_sym_LBRACE] = ACTIONS(3063),
    [anon_sym_LT_AT] = ACTIONS(3063),
    [anon_sym_LT_AT_AT] = ACTIONS(3063),
    [anon_sym_DOT] = ACTIONS(3063),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3065),
    [anon_sym_new] = ACTIONS(3063),
    [anon_sym_with] = ACTIONS(3063),
    [anon_sym_return_BANG] = ACTIONS(3065),
    [anon_sym_yield] = ACTIONS(3063),
    [anon_sym_yield_BANG] = ACTIONS(3065),
    [anon_sym_lazy] = ACTIONS(3063),
    [anon_sym_assert] = ACTIONS(3063),
    [anon_sym_upcast] = ACTIONS(3063),
    [anon_sym_downcast] = ACTIONS(3063),
    [anon_sym_COLON_GT] = ACTIONS(3065),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3065),
    [anon_sym_for] = ACTIONS(3063),
    [anon_sym_while] = ACTIONS(3063),
    [anon_sym_if] = ACTIONS(3063),
    [anon_sym_fun] = ACTIONS(3063),
    [anon_sym_try] = ACTIONS(3063),
    [anon_sym_match] = ACTIONS(3063),
    [anon_sym_match_BANG] = ACTIONS(3065),
    [anon_sym_function] = ACTIONS(3063),
    [anon_sym_LT_DASH] = ACTIONS(3063),
    [anon_sym_DOT_LBRACK] = ACTIONS(3065),
    [anon_sym_LT] = ACTIONS(3065),
    [anon_sym_use] = ACTIONS(3063),
    [anon_sym_use_BANG] = ACTIONS(3065),
    [anon_sym_do_BANG] = ACTIONS(3065),
    [anon_sym_begin] = ACTIONS(3063),
    [anon_sym_LPAREN2] = ACTIONS(3063),
    [anon_sym_or] = ACTIONS(3063),
    [aux_sym_char_token1] = ACTIONS(3065),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3063),
    [anon_sym_DQUOTE] = ACTIONS(3063),
    [anon_sym_AT_DQUOTE] = ACTIONS(3065),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3065),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3065),
    [sym_bool] = ACTIONS(3063),
    [sym_unit] = ACTIONS(3065),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3063),
    [sym_op_identifier] = ACTIONS(3063),
    [anon_sym_PLUS] = ACTIONS(3063),
    [anon_sym_DASH] = ACTIONS(3063),
    [anon_sym_PLUS_DOT] = ACTIONS(3063),
    [anon_sym_DASH_DOT] = ACTIONS(3063),
    [anon_sym_PERCENT] = ACTIONS(3063),
    [anon_sym_AMP_AMP] = ACTIONS(3063),
    [anon_sym_TILDE] = ACTIONS(3065),
    [aux_sym_prefix_op_token1] = ACTIONS(3063),
    [aux_sym_infix_op_token1] = ACTIONS(3065),
    [aux_sym_infix_op_token2] = ACTIONS(3063),
    [anon_sym_PIPE_PIPE] = ACTIONS(3063),
    [anon_sym_BANG_EQ] = ACTIONS(3063),
    [anon_sym_COLON_EQ] = ACTIONS(3065),
    [anon_sym_DOLLAR] = ACTIONS(3063),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3063),
    [sym_int] = ACTIONS(3063),
    [sym_xint] = ACTIONS(3065),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3065),
    [sym__newline] = ACTIONS(3065),
  },
  [1924] = {
    [sym_block_comment] = STATE(1924),
    [sym_compiler_directive_decl] = STATE(1924),
    [sym_fsi_directive_decl] = STATE(1924),
    [sym_preproc_line] = STATE(1924),
    [sym_identifier] = ACTIONS(3079),
    [anon_sym_EQ] = ACTIONS(3081),
    [anon_sym_COLON] = ACTIONS(3079),
    [anon_sym_return] = ACTIONS(3079),
    [anon_sym_do] = ACTIONS(3079),
    [anon_sym_let] = ACTIONS(3079),
    [anon_sym_let_BANG] = ACTIONS(3081),
    [anon_sym_as] = ACTIONS(3079),
    [anon_sym_LPAREN] = ACTIONS(3079),
    [anon_sym_COMMA] = ACTIONS(3081),
    [anon_sym_null] = ACTIONS(3079),
    [anon_sym_QMARK] = ACTIONS(3079),
    [anon_sym_COLON_QMARK] = ACTIONS(3079),
    [anon_sym_COLON_COLON] = ACTIONS(3081),
    [anon_sym_AMP] = ACTIONS(3079),
    [anon_sym_LBRACK] = ACTIONS(3079),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3081),
    [anon_sym_LBRACE] = ACTIONS(3079),
    [anon_sym_LT_AT] = ACTIONS(3079),
    [anon_sym_LT_AT_AT] = ACTIONS(3079),
    [anon_sym_DOT] = ACTIONS(3079),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3081),
    [anon_sym_new] = ACTIONS(3079),
    [anon_sym_with] = ACTIONS(3079),
    [anon_sym_return_BANG] = ACTIONS(3081),
    [anon_sym_yield] = ACTIONS(3079),
    [anon_sym_yield_BANG] = ACTIONS(3081),
    [anon_sym_lazy] = ACTIONS(3079),
    [anon_sym_assert] = ACTIONS(3079),
    [anon_sym_upcast] = ACTIONS(3079),
    [anon_sym_downcast] = ACTIONS(3079),
    [anon_sym_COLON_GT] = ACTIONS(3081),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3081),
    [anon_sym_for] = ACTIONS(3079),
    [anon_sym_while] = ACTIONS(3079),
    [anon_sym_if] = ACTIONS(3079),
    [anon_sym_fun] = ACTIONS(3079),
    [anon_sym_try] = ACTIONS(3079),
    [anon_sym_match] = ACTIONS(3079),
    [anon_sym_match_BANG] = ACTIONS(3081),
    [anon_sym_function] = ACTIONS(3079),
    [anon_sym_LT_DASH] = ACTIONS(3079),
    [anon_sym_DOT_LBRACK] = ACTIONS(3081),
    [anon_sym_LT] = ACTIONS(3081),
    [anon_sym_use] = ACTIONS(3079),
    [anon_sym_use_BANG] = ACTIONS(3081),
    [anon_sym_do_BANG] = ACTIONS(3081),
    [anon_sym_begin] = ACTIONS(3079),
    [anon_sym_LPAREN2] = ACTIONS(3079),
    [anon_sym_or] = ACTIONS(3079),
    [aux_sym_char_token1] = ACTIONS(3081),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3079),
    [anon_sym_DQUOTE] = ACTIONS(3079),
    [anon_sym_AT_DQUOTE] = ACTIONS(3081),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3081),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3081),
    [sym_bool] = ACTIONS(3079),
    [sym_unit] = ACTIONS(3081),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3079),
    [sym_op_identifier] = ACTIONS(3079),
    [anon_sym_PLUS] = ACTIONS(3079),
    [anon_sym_DASH] = ACTIONS(3079),
    [anon_sym_PLUS_DOT] = ACTIONS(3079),
    [anon_sym_DASH_DOT] = ACTIONS(3079),
    [anon_sym_PERCENT] = ACTIONS(3079),
    [anon_sym_AMP_AMP] = ACTIONS(3079),
    [anon_sym_TILDE] = ACTIONS(3081),
    [aux_sym_prefix_op_token1] = ACTIONS(3079),
    [aux_sym_infix_op_token1] = ACTIONS(3081),
    [aux_sym_infix_op_token2] = ACTIONS(3079),
    [anon_sym_PIPE_PIPE] = ACTIONS(3079),
    [anon_sym_BANG_EQ] = ACTIONS(3079),
    [anon_sym_COLON_EQ] = ACTIONS(3081),
    [anon_sym_DOLLAR] = ACTIONS(3079),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3079),
    [sym_int] = ACTIONS(3079),
    [sym_xint] = ACTIONS(3081),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3081),
    [sym__newline] = ACTIONS(3081),
  },
  [1925] = {
    [sym_block_comment] = STATE(1925),
    [sym_compiler_directive_decl] = STATE(1925),
    [sym_fsi_directive_decl] = STATE(1925),
    [sym_preproc_line] = STATE(1925),
    [sym_identifier] = ACTIONS(3083),
    [anon_sym_EQ] = ACTIONS(3085),
    [anon_sym_COLON] = ACTIONS(3083),
    [anon_sym_return] = ACTIONS(3083),
    [anon_sym_do] = ACTIONS(3083),
    [anon_sym_let] = ACTIONS(3083),
    [anon_sym_let_BANG] = ACTIONS(3085),
    [anon_sym_as] = ACTIONS(3083),
    [anon_sym_LPAREN] = ACTIONS(3083),
    [anon_sym_COMMA] = ACTIONS(3085),
    [anon_sym_null] = ACTIONS(3083),
    [anon_sym_QMARK] = ACTIONS(3083),
    [anon_sym_COLON_QMARK] = ACTIONS(3083),
    [anon_sym_COLON_COLON] = ACTIONS(3085),
    [anon_sym_AMP] = ACTIONS(3083),
    [anon_sym_LBRACK] = ACTIONS(3083),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3085),
    [anon_sym_LBRACE] = ACTIONS(3083),
    [anon_sym_LT_AT] = ACTIONS(3083),
    [anon_sym_LT_AT_AT] = ACTIONS(3083),
    [anon_sym_DOT] = ACTIONS(3083),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3085),
    [anon_sym_new] = ACTIONS(3083),
    [anon_sym_with] = ACTIONS(3083),
    [anon_sym_return_BANG] = ACTIONS(3085),
    [anon_sym_yield] = ACTIONS(3083),
    [anon_sym_yield_BANG] = ACTIONS(3085),
    [anon_sym_lazy] = ACTIONS(3083),
    [anon_sym_assert] = ACTIONS(3083),
    [anon_sym_upcast] = ACTIONS(3083),
    [anon_sym_downcast] = ACTIONS(3083),
    [anon_sym_COLON_GT] = ACTIONS(3085),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3085),
    [anon_sym_for] = ACTIONS(3083),
    [anon_sym_while] = ACTIONS(3083),
    [anon_sym_if] = ACTIONS(3083),
    [anon_sym_fun] = ACTIONS(3083),
    [anon_sym_try] = ACTIONS(3083),
    [anon_sym_match] = ACTIONS(3083),
    [anon_sym_match_BANG] = ACTIONS(3085),
    [anon_sym_function] = ACTIONS(3083),
    [anon_sym_LT_DASH] = ACTIONS(3083),
    [anon_sym_DOT_LBRACK] = ACTIONS(3085),
    [anon_sym_LT] = ACTIONS(3085),
    [anon_sym_use] = ACTIONS(3083),
    [anon_sym_use_BANG] = ACTIONS(3085),
    [anon_sym_do_BANG] = ACTIONS(3085),
    [anon_sym_begin] = ACTIONS(3083),
    [anon_sym_LPAREN2] = ACTIONS(3083),
    [anon_sym_or] = ACTIONS(3083),
    [aux_sym_char_token1] = ACTIONS(3085),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3083),
    [anon_sym_DQUOTE] = ACTIONS(3083),
    [anon_sym_AT_DQUOTE] = ACTIONS(3085),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3085),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3085),
    [sym_bool] = ACTIONS(3083),
    [sym_unit] = ACTIONS(3085),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3083),
    [sym_op_identifier] = ACTIONS(3083),
    [anon_sym_PLUS] = ACTIONS(3083),
    [anon_sym_DASH] = ACTIONS(3083),
    [anon_sym_PLUS_DOT] = ACTIONS(3083),
    [anon_sym_DASH_DOT] = ACTIONS(3083),
    [anon_sym_PERCENT] = ACTIONS(3083),
    [anon_sym_AMP_AMP] = ACTIONS(3083),
    [anon_sym_TILDE] = ACTIONS(3085),
    [aux_sym_prefix_op_token1] = ACTIONS(3083),
    [aux_sym_infix_op_token1] = ACTIONS(3085),
    [aux_sym_infix_op_token2] = ACTIONS(3083),
    [anon_sym_PIPE_PIPE] = ACTIONS(3083),
    [anon_sym_BANG_EQ] = ACTIONS(3083),
    [anon_sym_COLON_EQ] = ACTIONS(3085),
    [anon_sym_DOLLAR] = ACTIONS(3083),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3083),
    [sym_int] = ACTIONS(3083),
    [sym_xint] = ACTIONS(3085),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3085),
    [sym__newline] = ACTIONS(3085),
  },
  [1926] = {
    [sym_block_comment] = STATE(1926),
    [sym_compiler_directive_decl] = STATE(1926),
    [sym_fsi_directive_decl] = STATE(1926),
    [sym_preproc_line] = STATE(1926),
    [sym_identifier] = ACTIONS(3099),
    [anon_sym_EQ] = ACTIONS(3101),
    [anon_sym_COLON] = ACTIONS(3099),
    [anon_sym_return] = ACTIONS(3099),
    [anon_sym_do] = ACTIONS(3099),
    [anon_sym_let] = ACTIONS(3099),
    [anon_sym_let_BANG] = ACTIONS(3101),
    [anon_sym_as] = ACTIONS(3099),
    [anon_sym_LPAREN] = ACTIONS(3099),
    [anon_sym_COMMA] = ACTIONS(3101),
    [anon_sym_null] = ACTIONS(3099),
    [anon_sym_QMARK] = ACTIONS(3099),
    [anon_sym_COLON_QMARK] = ACTIONS(3099),
    [anon_sym_COLON_COLON] = ACTIONS(3101),
    [anon_sym_AMP] = ACTIONS(3099),
    [anon_sym_LBRACK] = ACTIONS(3099),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3101),
    [anon_sym_LBRACE] = ACTIONS(3099),
    [anon_sym_LT_AT] = ACTIONS(3099),
    [anon_sym_LT_AT_AT] = ACTIONS(3099),
    [anon_sym_DOT] = ACTIONS(3099),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3101),
    [anon_sym_new] = ACTIONS(3099),
    [anon_sym_with] = ACTIONS(3099),
    [anon_sym_return_BANG] = ACTIONS(3101),
    [anon_sym_yield] = ACTIONS(3099),
    [anon_sym_yield_BANG] = ACTIONS(3101),
    [anon_sym_lazy] = ACTIONS(3099),
    [anon_sym_assert] = ACTIONS(3099),
    [anon_sym_upcast] = ACTIONS(3099),
    [anon_sym_downcast] = ACTIONS(3099),
    [anon_sym_COLON_GT] = ACTIONS(3101),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3101),
    [anon_sym_for] = ACTIONS(3099),
    [anon_sym_while] = ACTIONS(3099),
    [anon_sym_if] = ACTIONS(3099),
    [anon_sym_fun] = ACTIONS(3099),
    [anon_sym_try] = ACTIONS(3099),
    [anon_sym_match] = ACTIONS(3099),
    [anon_sym_match_BANG] = ACTIONS(3101),
    [anon_sym_function] = ACTIONS(3099),
    [anon_sym_LT_DASH] = ACTIONS(3099),
    [anon_sym_DOT_LBRACK] = ACTIONS(3101),
    [anon_sym_LT] = ACTIONS(3101),
    [anon_sym_use] = ACTIONS(3099),
    [anon_sym_use_BANG] = ACTIONS(3101),
    [anon_sym_do_BANG] = ACTIONS(3101),
    [anon_sym_begin] = ACTIONS(3099),
    [anon_sym_LPAREN2] = ACTIONS(3099),
    [anon_sym_or] = ACTIONS(3099),
    [aux_sym_char_token1] = ACTIONS(3101),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3099),
    [anon_sym_DQUOTE] = ACTIONS(3099),
    [anon_sym_AT_DQUOTE] = ACTIONS(3101),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3101),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3101),
    [sym_bool] = ACTIONS(3099),
    [sym_unit] = ACTIONS(3101),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3099),
    [sym_op_identifier] = ACTIONS(3099),
    [anon_sym_PLUS] = ACTIONS(3099),
    [anon_sym_DASH] = ACTIONS(3099),
    [anon_sym_PLUS_DOT] = ACTIONS(3099),
    [anon_sym_DASH_DOT] = ACTIONS(3099),
    [anon_sym_PERCENT] = ACTIONS(3099),
    [anon_sym_AMP_AMP] = ACTIONS(3099),
    [anon_sym_TILDE] = ACTIONS(3101),
    [aux_sym_prefix_op_token1] = ACTIONS(3099),
    [aux_sym_infix_op_token1] = ACTIONS(3101),
    [aux_sym_infix_op_token2] = ACTIONS(3099),
    [anon_sym_PIPE_PIPE] = ACTIONS(3099),
    [anon_sym_BANG_EQ] = ACTIONS(3099),
    [anon_sym_COLON_EQ] = ACTIONS(3101),
    [anon_sym_DOLLAR] = ACTIONS(3099),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3099),
    [sym_int] = ACTIONS(3099),
    [sym_xint] = ACTIONS(3101),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3101),
    [sym__newline] = ACTIONS(3101),
  },
  [1927] = {
    [sym_block_comment] = STATE(1927),
    [sym_compiler_directive_decl] = STATE(1927),
    [sym_fsi_directive_decl] = STATE(1927),
    [sym_preproc_line] = STATE(1927),
    [sym_identifier] = ACTIONS(2766),
    [anon_sym_EQ] = ACTIONS(2768),
    [anon_sym_COLON] = ACTIONS(2766),
    [anon_sym_return] = ACTIONS(2766),
    [anon_sym_do] = ACTIONS(2766),
    [anon_sym_let] = ACTIONS(2766),
    [anon_sym_let_BANG] = ACTIONS(2768),
    [anon_sym_LPAREN] = ACTIONS(2766),
    [anon_sym_COMMA] = ACTIONS(2768),
    [anon_sym_null] = ACTIONS(2766),
    [anon_sym_QMARK] = ACTIONS(2766),
    [anon_sym_COLON_QMARK] = ACTIONS(2766),
    [anon_sym_COLON_COLON] = ACTIONS(2768),
    [anon_sym_PIPE] = ACTIONS(2766),
    [anon_sym_AMP] = ACTIONS(2766),
    [anon_sym_LBRACK] = ACTIONS(2766),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2768),
    [anon_sym_LBRACE] = ACTIONS(2766),
    [anon_sym_LT_AT] = ACTIONS(2766),
    [anon_sym_LT_AT_AT] = ACTIONS(2766),
    [anon_sym_AT_AT_GT] = ACTIONS(2766),
    [anon_sym_DOT] = ACTIONS(2766),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2768),
    [anon_sym_new] = ACTIONS(2766),
    [anon_sym_return_BANG] = ACTIONS(2768),
    [anon_sym_yield] = ACTIONS(2766),
    [anon_sym_yield_BANG] = ACTIONS(2768),
    [anon_sym_lazy] = ACTIONS(2766),
    [anon_sym_assert] = ACTIONS(2766),
    [anon_sym_upcast] = ACTIONS(2766),
    [anon_sym_downcast] = ACTIONS(2766),
    [anon_sym_COLON_GT] = ACTIONS(2768),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2768),
    [anon_sym_for] = ACTIONS(2766),
    [anon_sym_while] = ACTIONS(2766),
    [anon_sym_if] = ACTIONS(2766),
    [anon_sym_fun] = ACTIONS(2766),
    [anon_sym_try] = ACTIONS(2766),
    [anon_sym_match] = ACTIONS(2766),
    [anon_sym_match_BANG] = ACTIONS(2768),
    [anon_sym_function] = ACTIONS(2766),
    [anon_sym_LT_DASH] = ACTIONS(2766),
    [anon_sym_DOT_LBRACK] = ACTIONS(2768),
    [anon_sym_LT] = ACTIONS(2768),
    [anon_sym_use] = ACTIONS(2766),
    [anon_sym_use_BANG] = ACTIONS(2768),
    [anon_sym_do_BANG] = ACTIONS(2768),
    [anon_sym_begin] = ACTIONS(2766),
    [anon_sym_LPAREN2] = ACTIONS(2766),
    [anon_sym_or] = ACTIONS(2766),
    [aux_sym_char_token1] = ACTIONS(2768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2766),
    [anon_sym_DQUOTE] = ACTIONS(2766),
    [anon_sym_AT_DQUOTE] = ACTIONS(2768),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2768),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2768),
    [sym_bool] = ACTIONS(2766),
    [sym_unit] = ACTIONS(2768),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2766),
    [sym_op_identifier] = ACTIONS(2766),
    [anon_sym_PLUS] = ACTIONS(2766),
    [anon_sym_DASH] = ACTIONS(2766),
    [anon_sym_PLUS_DOT] = ACTIONS(2766),
    [anon_sym_DASH_DOT] = ACTIONS(2766),
    [anon_sym_PERCENT] = ACTIONS(2766),
    [anon_sym_AMP_AMP] = ACTIONS(2766),
    [anon_sym_TILDE] = ACTIONS(2768),
    [aux_sym_prefix_op_token1] = ACTIONS(2766),
    [aux_sym_infix_op_token1] = ACTIONS(2768),
    [aux_sym_infix_op_token2] = ACTIONS(2766),
    [anon_sym_PIPE_PIPE] = ACTIONS(2766),
    [anon_sym_BANG_EQ] = ACTIONS(2766),
    [anon_sym_COLON_EQ] = ACTIONS(2768),
    [anon_sym_DOLLAR] = ACTIONS(2766),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2766),
    [sym_int] = ACTIONS(2766),
    [sym_xint] = ACTIONS(2768),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2768),
    [sym__newline] = ACTIONS(2768),
  },
  [1928] = {
    [sym_block_comment] = STATE(1928),
    [sym_compiler_directive_decl] = STATE(1928),
    [sym_fsi_directive_decl] = STATE(1928),
    [sym_preproc_line] = STATE(1928),
    [aux_sym_sequential_expression_repeat1] = STATE(1928),
    [sym_identifier] = ACTIONS(2895),
    [anon_sym_EQ] = ACTIONS(2897),
    [anon_sym_COLON] = ACTIONS(2895),
    [anon_sym_return] = ACTIONS(2895),
    [anon_sym_do] = ACTIONS(2895),
    [anon_sym_let] = ACTIONS(2895),
    [anon_sym_let_BANG] = ACTIONS(2897),
    [anon_sym_LPAREN] = ACTIONS(2895),
    [anon_sym_COMMA] = ACTIONS(2897),
    [anon_sym_null] = ACTIONS(2895),
    [anon_sym_QMARK] = ACTIONS(2895),
    [anon_sym_COLON_QMARK] = ACTIONS(2895),
    [anon_sym_COLON_COLON] = ACTIONS(2897),
    [anon_sym_AMP] = ACTIONS(2895),
    [anon_sym_LBRACK] = ACTIONS(2895),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2897),
    [anon_sym_LBRACE] = ACTIONS(2895),
    [anon_sym_LT_AT] = ACTIONS(2895),
    [anon_sym_LT_AT_AT] = ACTIONS(2895),
    [anon_sym_AT_AT_GT] = ACTIONS(2895),
    [anon_sym_DOT] = ACTIONS(2895),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2897),
    [anon_sym_new] = ACTIONS(2895),
    [anon_sym_return_BANG] = ACTIONS(2897),
    [anon_sym_yield] = ACTIONS(2895),
    [anon_sym_yield_BANG] = ACTIONS(2897),
    [anon_sym_lazy] = ACTIONS(2895),
    [anon_sym_assert] = ACTIONS(2895),
    [anon_sym_upcast] = ACTIONS(2895),
    [anon_sym_downcast] = ACTIONS(2895),
    [anon_sym_COLON_GT] = ACTIONS(2897),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2897),
    [anon_sym_for] = ACTIONS(2895),
    [anon_sym_while] = ACTIONS(2895),
    [anon_sym_if] = ACTIONS(2895),
    [anon_sym_fun] = ACTIONS(2895),
    [anon_sym_try] = ACTIONS(2895),
    [anon_sym_match] = ACTIONS(2895),
    [anon_sym_match_BANG] = ACTIONS(2897),
    [anon_sym_function] = ACTIONS(2895),
    [anon_sym_LT_DASH] = ACTIONS(2895),
    [anon_sym_DOT_LBRACK] = ACTIONS(2897),
    [anon_sym_LT] = ACTIONS(2897),
    [anon_sym_use] = ACTIONS(2895),
    [anon_sym_use_BANG] = ACTIONS(2897),
    [anon_sym_do_BANG] = ACTIONS(2897),
    [anon_sym_begin] = ACTIONS(2895),
    [anon_sym_LPAREN2] = ACTIONS(2895),
    [anon_sym_or] = ACTIONS(2895),
    [aux_sym_char_token1] = ACTIONS(2897),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2895),
    [anon_sym_DQUOTE] = ACTIONS(2895),
    [anon_sym_AT_DQUOTE] = ACTIONS(2897),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2897),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2897),
    [sym_bool] = ACTIONS(2895),
    [sym_unit] = ACTIONS(2897),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2895),
    [sym_op_identifier] = ACTIONS(2895),
    [anon_sym_PLUS] = ACTIONS(2895),
    [anon_sym_DASH] = ACTIONS(2895),
    [anon_sym_PLUS_DOT] = ACTIONS(2895),
    [anon_sym_DASH_DOT] = ACTIONS(2895),
    [anon_sym_PERCENT] = ACTIONS(2895),
    [anon_sym_AMP_AMP] = ACTIONS(2895),
    [anon_sym_TILDE] = ACTIONS(2897),
    [aux_sym_prefix_op_token1] = ACTIONS(2895),
    [aux_sym_infix_op_token1] = ACTIONS(2897),
    [aux_sym_infix_op_token2] = ACTIONS(2895),
    [anon_sym_PIPE_PIPE] = ACTIONS(2895),
    [anon_sym_BANG_EQ] = ACTIONS(2895),
    [anon_sym_COLON_EQ] = ACTIONS(2897),
    [anon_sym_DOLLAR] = ACTIONS(2895),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2895),
    [sym_int] = ACTIONS(2895),
    [sym_xint] = ACTIONS(2897),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2897),
    [sym__newline] = ACTIONS(4156),
  },
  [1929] = {
    [sym_block_comment] = STATE(1929),
    [sym_compiler_directive_decl] = STATE(1929),
    [sym_fsi_directive_decl] = STATE(1929),
    [sym_preproc_line] = STATE(1929),
    [sym_identifier] = ACTIONS(2831),
    [anon_sym_EQ] = ACTIONS(2833),
    [anon_sym_COLON] = ACTIONS(2831),
    [anon_sym_return] = ACTIONS(2831),
    [anon_sym_do] = ACTIONS(2831),
    [anon_sym_let] = ACTIONS(2831),
    [anon_sym_let_BANG] = ACTIONS(2833),
    [anon_sym_LPAREN] = ACTIONS(2831),
    [anon_sym_COMMA] = ACTIONS(2833),
    [anon_sym_null] = ACTIONS(2831),
    [anon_sym_QMARK] = ACTIONS(2831),
    [anon_sym_COLON_QMARK] = ACTIONS(2831),
    [anon_sym_COLON_COLON] = ACTIONS(2833),
    [anon_sym_AMP] = ACTIONS(2831),
    [anon_sym_LBRACK] = ACTIONS(2831),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2833),
    [anon_sym_LBRACE] = ACTIONS(2831),
    [anon_sym_LT_AT] = ACTIONS(2831),
    [anon_sym_LT_AT_AT] = ACTIONS(2831),
    [anon_sym_DOT] = ACTIONS(2831),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2833),
    [anon_sym_new] = ACTIONS(2831),
    [anon_sym_return_BANG] = ACTIONS(2833),
    [anon_sym_yield] = ACTIONS(2831),
    [anon_sym_yield_BANG] = ACTIONS(2833),
    [anon_sym_lazy] = ACTIONS(2831),
    [anon_sym_assert] = ACTIONS(2831),
    [anon_sym_upcast] = ACTIONS(2831),
    [anon_sym_downcast] = ACTIONS(2831),
    [anon_sym_COLON_GT] = ACTIONS(2833),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2833),
    [anon_sym_for] = ACTIONS(2831),
    [anon_sym_while] = ACTIONS(2831),
    [anon_sym_if] = ACTIONS(2831),
    [anon_sym_fun] = ACTIONS(2831),
    [anon_sym_DASH_GT] = ACTIONS(2831),
    [anon_sym_try] = ACTIONS(2831),
    [anon_sym_match] = ACTIONS(2831),
    [anon_sym_match_BANG] = ACTIONS(2833),
    [anon_sym_function] = ACTIONS(2831),
    [anon_sym_LT_DASH] = ACTIONS(2831),
    [anon_sym_DOT_LBRACK] = ACTIONS(2833),
    [anon_sym_LT] = ACTIONS(2833),
    [anon_sym_use] = ACTIONS(2831),
    [anon_sym_use_BANG] = ACTIONS(2833),
    [anon_sym_do_BANG] = ACTIONS(2833),
    [anon_sym_DOT_DOT] = ACTIONS(2833),
    [anon_sym_begin] = ACTIONS(2831),
    [anon_sym_LPAREN2] = ACTIONS(2831),
    [anon_sym_or] = ACTIONS(2831),
    [aux_sym_char_token1] = ACTIONS(2833),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2831),
    [anon_sym_DQUOTE] = ACTIONS(2831),
    [anon_sym_AT_DQUOTE] = ACTIONS(2833),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2833),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2833),
    [sym_bool] = ACTIONS(2831),
    [sym_unit] = ACTIONS(2833),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2831),
    [sym_op_identifier] = ACTIONS(2831),
    [anon_sym_PLUS] = ACTIONS(2831),
    [anon_sym_DASH] = ACTIONS(2831),
    [anon_sym_PLUS_DOT] = ACTIONS(2831),
    [anon_sym_DASH_DOT] = ACTIONS(2831),
    [anon_sym_PERCENT] = ACTIONS(2831),
    [anon_sym_AMP_AMP] = ACTIONS(2831),
    [anon_sym_TILDE] = ACTIONS(2833),
    [aux_sym_prefix_op_token1] = ACTIONS(2831),
    [aux_sym_infix_op_token1] = ACTIONS(2833),
    [aux_sym_infix_op_token2] = ACTIONS(2831),
    [anon_sym_PIPE_PIPE] = ACTIONS(2831),
    [anon_sym_BANG_EQ] = ACTIONS(2831),
    [anon_sym_COLON_EQ] = ACTIONS(2833),
    [anon_sym_DOLLAR] = ACTIONS(2831),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2831),
    [sym_int] = ACTIONS(2831),
    [sym_xint] = ACTIONS(2833),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2833),
    [sym__newline] = ACTIONS(2833),
  },
  [1930] = {
    [sym_block_comment] = STATE(1930),
    [sym_compiler_directive_decl] = STATE(1930),
    [sym_fsi_directive_decl] = STATE(1930),
    [sym_preproc_line] = STATE(1930),
    [sym_identifier] = ACTIONS(3067),
    [anon_sym_EQ] = ACTIONS(3069),
    [anon_sym_COLON] = ACTIONS(3067),
    [anon_sym_return] = ACTIONS(3067),
    [anon_sym_do] = ACTIONS(3067),
    [anon_sym_let] = ACTIONS(3067),
    [anon_sym_let_BANG] = ACTIONS(3069),
    [anon_sym_LPAREN] = ACTIONS(3067),
    [anon_sym_COMMA] = ACTIONS(3069),
    [anon_sym_null] = ACTIONS(3067),
    [anon_sym_QMARK] = ACTIONS(3067),
    [anon_sym_COLON_QMARK] = ACTIONS(3067),
    [anon_sym_COLON_COLON] = ACTIONS(3069),
    [anon_sym_AMP] = ACTIONS(3067),
    [anon_sym_LBRACK] = ACTIONS(3067),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3069),
    [anon_sym_LBRACE] = ACTIONS(3067),
    [anon_sym_LT_AT] = ACTIONS(3067),
    [anon_sym_LT_AT_AT] = ACTIONS(3067),
    [anon_sym_DOT] = ACTIONS(3067),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3069),
    [anon_sym_new] = ACTIONS(3067),
    [anon_sym_return_BANG] = ACTIONS(3069),
    [anon_sym_yield] = ACTIONS(3067),
    [anon_sym_yield_BANG] = ACTIONS(3069),
    [anon_sym_lazy] = ACTIONS(3067),
    [anon_sym_assert] = ACTIONS(3067),
    [anon_sym_upcast] = ACTIONS(3067),
    [anon_sym_downcast] = ACTIONS(3067),
    [anon_sym_COLON_GT] = ACTIONS(3069),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3069),
    [anon_sym_for] = ACTIONS(3067),
    [anon_sym_while] = ACTIONS(3067),
    [anon_sym_if] = ACTIONS(3067),
    [anon_sym_fun] = ACTIONS(3067),
    [anon_sym_DASH_GT] = ACTIONS(3067),
    [anon_sym_try] = ACTIONS(3067),
    [anon_sym_match] = ACTIONS(3067),
    [anon_sym_match_BANG] = ACTIONS(3069),
    [anon_sym_function] = ACTIONS(3067),
    [anon_sym_LT_DASH] = ACTIONS(3067),
    [anon_sym_DOT_LBRACK] = ACTIONS(3069),
    [anon_sym_LT] = ACTIONS(3069),
    [anon_sym_use] = ACTIONS(3067),
    [anon_sym_use_BANG] = ACTIONS(3069),
    [anon_sym_do_BANG] = ACTIONS(3069),
    [anon_sym_DOT_DOT] = ACTIONS(3069),
    [anon_sym_begin] = ACTIONS(3067),
    [anon_sym_LPAREN2] = ACTIONS(3067),
    [anon_sym_or] = ACTIONS(3067),
    [aux_sym_char_token1] = ACTIONS(3069),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3067),
    [anon_sym_DQUOTE] = ACTIONS(3067),
    [anon_sym_AT_DQUOTE] = ACTIONS(3069),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3069),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3069),
    [sym_bool] = ACTIONS(3067),
    [sym_unit] = ACTIONS(3069),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3067),
    [sym_op_identifier] = ACTIONS(3067),
    [anon_sym_PLUS] = ACTIONS(3067),
    [anon_sym_DASH] = ACTIONS(3067),
    [anon_sym_PLUS_DOT] = ACTIONS(3067),
    [anon_sym_DASH_DOT] = ACTIONS(3067),
    [anon_sym_PERCENT] = ACTIONS(3067),
    [anon_sym_AMP_AMP] = ACTIONS(3067),
    [anon_sym_TILDE] = ACTIONS(3069),
    [aux_sym_prefix_op_token1] = ACTIONS(3067),
    [aux_sym_infix_op_token1] = ACTIONS(3069),
    [aux_sym_infix_op_token2] = ACTIONS(3067),
    [anon_sym_PIPE_PIPE] = ACTIONS(3067),
    [anon_sym_BANG_EQ] = ACTIONS(3067),
    [anon_sym_COLON_EQ] = ACTIONS(3069),
    [anon_sym_DOLLAR] = ACTIONS(3067),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3067),
    [sym_int] = ACTIONS(3067),
    [sym_xint] = ACTIONS(3069),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3069),
    [sym__newline] = ACTIONS(3069),
  },
  [1931] = {
    [sym_block_comment] = STATE(1931),
    [sym_compiler_directive_decl] = STATE(1931),
    [sym_fsi_directive_decl] = STATE(1931),
    [sym_preproc_line] = STATE(1931),
    [sym_identifier] = ACTIONS(3071),
    [anon_sym_EQ] = ACTIONS(3073),
    [anon_sym_COLON] = ACTIONS(3071),
    [anon_sym_return] = ACTIONS(3071),
    [anon_sym_do] = ACTIONS(3071),
    [anon_sym_let] = ACTIONS(3071),
    [anon_sym_let_BANG] = ACTIONS(3073),
    [anon_sym_LPAREN] = ACTIONS(3071),
    [anon_sym_COMMA] = ACTIONS(3073),
    [anon_sym_null] = ACTIONS(3071),
    [anon_sym_QMARK] = ACTIONS(3071),
    [anon_sym_COLON_QMARK] = ACTIONS(3071),
    [anon_sym_COLON_COLON] = ACTIONS(3073),
    [anon_sym_AMP] = ACTIONS(3071),
    [anon_sym_LBRACK] = ACTIONS(3071),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3073),
    [anon_sym_LBRACE] = ACTIONS(3071),
    [anon_sym_LT_AT] = ACTIONS(3071),
    [anon_sym_LT_AT_AT] = ACTIONS(3071),
    [anon_sym_DOT] = ACTIONS(3071),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3073),
    [anon_sym_new] = ACTIONS(3071),
    [anon_sym_return_BANG] = ACTIONS(3073),
    [anon_sym_yield] = ACTIONS(3071),
    [anon_sym_yield_BANG] = ACTIONS(3073),
    [anon_sym_lazy] = ACTIONS(3071),
    [anon_sym_assert] = ACTIONS(3071),
    [anon_sym_upcast] = ACTIONS(3071),
    [anon_sym_downcast] = ACTIONS(3071),
    [anon_sym_COLON_GT] = ACTIONS(3073),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3073),
    [anon_sym_for] = ACTIONS(3071),
    [anon_sym_while] = ACTIONS(3071),
    [anon_sym_if] = ACTIONS(3071),
    [anon_sym_fun] = ACTIONS(3071),
    [anon_sym_DASH_GT] = ACTIONS(3071),
    [anon_sym_try] = ACTIONS(3071),
    [anon_sym_match] = ACTIONS(3071),
    [anon_sym_match_BANG] = ACTIONS(3073),
    [anon_sym_function] = ACTIONS(3071),
    [anon_sym_LT_DASH] = ACTIONS(3071),
    [anon_sym_DOT_LBRACK] = ACTIONS(3073),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_use] = ACTIONS(3071),
    [anon_sym_use_BANG] = ACTIONS(3073),
    [anon_sym_do_BANG] = ACTIONS(3073),
    [anon_sym_DOT_DOT] = ACTIONS(3073),
    [anon_sym_begin] = ACTIONS(3071),
    [anon_sym_LPAREN2] = ACTIONS(3071),
    [anon_sym_or] = ACTIONS(3071),
    [aux_sym_char_token1] = ACTIONS(3073),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3071),
    [anon_sym_DQUOTE] = ACTIONS(3071),
    [anon_sym_AT_DQUOTE] = ACTIONS(3073),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3073),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3073),
    [sym_bool] = ACTIONS(3071),
    [sym_unit] = ACTIONS(3073),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3071),
    [sym_op_identifier] = ACTIONS(3071),
    [anon_sym_PLUS] = ACTIONS(3071),
    [anon_sym_DASH] = ACTIONS(3071),
    [anon_sym_PLUS_DOT] = ACTIONS(3071),
    [anon_sym_DASH_DOT] = ACTIONS(3071),
    [anon_sym_PERCENT] = ACTIONS(3071),
    [anon_sym_AMP_AMP] = ACTIONS(3071),
    [anon_sym_TILDE] = ACTIONS(3073),
    [aux_sym_prefix_op_token1] = ACTIONS(3071),
    [aux_sym_infix_op_token1] = ACTIONS(3073),
    [aux_sym_infix_op_token2] = ACTIONS(3071),
    [anon_sym_PIPE_PIPE] = ACTIONS(3071),
    [anon_sym_BANG_EQ] = ACTIONS(3071),
    [anon_sym_COLON_EQ] = ACTIONS(3073),
    [anon_sym_DOLLAR] = ACTIONS(3071),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3071),
    [sym_int] = ACTIONS(3071),
    [sym_xint] = ACTIONS(3073),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3073),
    [sym__newline] = ACTIONS(3073),
  },
  [1932] = {
    [sym_block_comment] = STATE(1932),
    [sym_compiler_directive_decl] = STATE(1932),
    [sym_fsi_directive_decl] = STATE(1932),
    [sym_preproc_line] = STATE(1932),
    [sym_identifier] = ACTIONS(3103),
    [anon_sym_EQ] = ACTIONS(3105),
    [anon_sym_COLON] = ACTIONS(3103),
    [anon_sym_return] = ACTIONS(3103),
    [anon_sym_do] = ACTIONS(3103),
    [anon_sym_let] = ACTIONS(3103),
    [anon_sym_let_BANG] = ACTIONS(3105),
    [anon_sym_as] = ACTIONS(3103),
    [anon_sym_LPAREN] = ACTIONS(3103),
    [anon_sym_COMMA] = ACTIONS(3105),
    [anon_sym_null] = ACTIONS(3103),
    [anon_sym_QMARK] = ACTIONS(3103),
    [anon_sym_COLON_QMARK] = ACTIONS(3103),
    [anon_sym_COLON_COLON] = ACTIONS(3105),
    [anon_sym_AMP] = ACTIONS(3103),
    [anon_sym_LBRACK] = ACTIONS(3103),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3105),
    [anon_sym_LBRACE] = ACTIONS(3103),
    [anon_sym_LT_AT] = ACTIONS(3103),
    [anon_sym_LT_AT_AT] = ACTIONS(3103),
    [anon_sym_DOT] = ACTIONS(3103),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3105),
    [anon_sym_new] = ACTIONS(3103),
    [anon_sym_with] = ACTIONS(3103),
    [anon_sym_return_BANG] = ACTIONS(3105),
    [anon_sym_yield] = ACTIONS(3103),
    [anon_sym_yield_BANG] = ACTIONS(3105),
    [anon_sym_lazy] = ACTIONS(3103),
    [anon_sym_assert] = ACTIONS(3103),
    [anon_sym_upcast] = ACTIONS(3103),
    [anon_sym_downcast] = ACTIONS(3103),
    [anon_sym_COLON_GT] = ACTIONS(3105),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3105),
    [anon_sym_for] = ACTIONS(3103),
    [anon_sym_while] = ACTIONS(3103),
    [anon_sym_if] = ACTIONS(3103),
    [anon_sym_fun] = ACTIONS(3103),
    [anon_sym_try] = ACTIONS(3103),
    [anon_sym_match] = ACTIONS(3103),
    [anon_sym_match_BANG] = ACTIONS(3105),
    [anon_sym_function] = ACTIONS(3103),
    [anon_sym_LT_DASH] = ACTIONS(3103),
    [anon_sym_DOT_LBRACK] = ACTIONS(3105),
    [anon_sym_LT] = ACTIONS(3105),
    [anon_sym_use] = ACTIONS(3103),
    [anon_sym_use_BANG] = ACTIONS(3105),
    [anon_sym_do_BANG] = ACTIONS(3105),
    [anon_sym_begin] = ACTIONS(3103),
    [anon_sym_LPAREN2] = ACTIONS(3103),
    [anon_sym_or] = ACTIONS(3103),
    [aux_sym_char_token1] = ACTIONS(3105),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3103),
    [anon_sym_DQUOTE] = ACTIONS(3103),
    [anon_sym_AT_DQUOTE] = ACTIONS(3105),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3105),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3105),
    [sym_bool] = ACTIONS(3103),
    [sym_unit] = ACTIONS(3105),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3103),
    [sym_op_identifier] = ACTIONS(3103),
    [anon_sym_PLUS] = ACTIONS(3103),
    [anon_sym_DASH] = ACTIONS(3103),
    [anon_sym_PLUS_DOT] = ACTIONS(3103),
    [anon_sym_DASH_DOT] = ACTIONS(3103),
    [anon_sym_PERCENT] = ACTIONS(3103),
    [anon_sym_AMP_AMP] = ACTIONS(3103),
    [anon_sym_TILDE] = ACTIONS(3105),
    [aux_sym_prefix_op_token1] = ACTIONS(3103),
    [aux_sym_infix_op_token1] = ACTIONS(3105),
    [aux_sym_infix_op_token2] = ACTIONS(3103),
    [anon_sym_PIPE_PIPE] = ACTIONS(3103),
    [anon_sym_BANG_EQ] = ACTIONS(3103),
    [anon_sym_COLON_EQ] = ACTIONS(3105),
    [anon_sym_DOLLAR] = ACTIONS(3103),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3103),
    [sym_int] = ACTIONS(3103),
    [sym_xint] = ACTIONS(3105),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3105),
    [sym__newline] = ACTIONS(3105),
  },
  [1933] = {
    [sym_block_comment] = STATE(1933),
    [sym_compiler_directive_decl] = STATE(1933),
    [sym_fsi_directive_decl] = STATE(1933),
    [sym_preproc_line] = STATE(1933),
    [sym_identifier] = ACTIONS(3107),
    [anon_sym_EQ] = ACTIONS(3109),
    [anon_sym_COLON] = ACTIONS(3107),
    [anon_sym_return] = ACTIONS(3107),
    [anon_sym_do] = ACTIONS(3107),
    [anon_sym_let] = ACTIONS(3107),
    [anon_sym_let_BANG] = ACTIONS(3109),
    [anon_sym_as] = ACTIONS(3107),
    [anon_sym_LPAREN] = ACTIONS(3107),
    [anon_sym_COMMA] = ACTIONS(3109),
    [anon_sym_null] = ACTIONS(3107),
    [anon_sym_QMARK] = ACTIONS(3107),
    [anon_sym_COLON_QMARK] = ACTIONS(3107),
    [anon_sym_COLON_COLON] = ACTIONS(3109),
    [anon_sym_AMP] = ACTIONS(3107),
    [anon_sym_LBRACK] = ACTIONS(3107),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3109),
    [anon_sym_LBRACE] = ACTIONS(3107),
    [anon_sym_LT_AT] = ACTIONS(3107),
    [anon_sym_LT_AT_AT] = ACTIONS(3107),
    [anon_sym_DOT] = ACTIONS(3107),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3109),
    [anon_sym_new] = ACTIONS(3107),
    [anon_sym_with] = ACTIONS(3107),
    [anon_sym_return_BANG] = ACTIONS(3109),
    [anon_sym_yield] = ACTIONS(3107),
    [anon_sym_yield_BANG] = ACTIONS(3109),
    [anon_sym_lazy] = ACTIONS(3107),
    [anon_sym_assert] = ACTIONS(3107),
    [anon_sym_upcast] = ACTIONS(3107),
    [anon_sym_downcast] = ACTIONS(3107),
    [anon_sym_COLON_GT] = ACTIONS(3109),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3109),
    [anon_sym_for] = ACTIONS(3107),
    [anon_sym_while] = ACTIONS(3107),
    [anon_sym_if] = ACTIONS(3107),
    [anon_sym_fun] = ACTIONS(3107),
    [anon_sym_try] = ACTIONS(3107),
    [anon_sym_match] = ACTIONS(3107),
    [anon_sym_match_BANG] = ACTIONS(3109),
    [anon_sym_function] = ACTIONS(3107),
    [anon_sym_LT_DASH] = ACTIONS(3107),
    [anon_sym_DOT_LBRACK] = ACTIONS(3109),
    [anon_sym_LT] = ACTIONS(3109),
    [anon_sym_use] = ACTIONS(3107),
    [anon_sym_use_BANG] = ACTIONS(3109),
    [anon_sym_do_BANG] = ACTIONS(3109),
    [anon_sym_begin] = ACTIONS(3107),
    [anon_sym_LPAREN2] = ACTIONS(3107),
    [anon_sym_or] = ACTIONS(3107),
    [aux_sym_char_token1] = ACTIONS(3109),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3107),
    [anon_sym_DQUOTE] = ACTIONS(3107),
    [anon_sym_AT_DQUOTE] = ACTIONS(3109),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3109),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3109),
    [sym_bool] = ACTIONS(3107),
    [sym_unit] = ACTIONS(3109),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3107),
    [sym_op_identifier] = ACTIONS(3107),
    [anon_sym_PLUS] = ACTIONS(3107),
    [anon_sym_DASH] = ACTIONS(3107),
    [anon_sym_PLUS_DOT] = ACTIONS(3107),
    [anon_sym_DASH_DOT] = ACTIONS(3107),
    [anon_sym_PERCENT] = ACTIONS(3107),
    [anon_sym_AMP_AMP] = ACTIONS(3107),
    [anon_sym_TILDE] = ACTIONS(3109),
    [aux_sym_prefix_op_token1] = ACTIONS(3107),
    [aux_sym_infix_op_token1] = ACTIONS(3109),
    [aux_sym_infix_op_token2] = ACTIONS(3107),
    [anon_sym_PIPE_PIPE] = ACTIONS(3107),
    [anon_sym_BANG_EQ] = ACTIONS(3107),
    [anon_sym_COLON_EQ] = ACTIONS(3109),
    [anon_sym_DOLLAR] = ACTIONS(3107),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3107),
    [sym_int] = ACTIONS(3107),
    [sym_xint] = ACTIONS(3109),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3109),
    [sym__newline] = ACTIONS(3109),
  },
  [1934] = {
    [sym_block_comment] = STATE(1934),
    [sym_compiler_directive_decl] = STATE(1934),
    [sym_fsi_directive_decl] = STATE(1934),
    [sym_preproc_line] = STATE(1934),
    [sym_identifier] = ACTIONS(3111),
    [anon_sym_EQ] = ACTIONS(3113),
    [anon_sym_COLON] = ACTIONS(3111),
    [anon_sym_return] = ACTIONS(3111),
    [anon_sym_do] = ACTIONS(3111),
    [anon_sym_let] = ACTIONS(3111),
    [anon_sym_let_BANG] = ACTIONS(3113),
    [anon_sym_as] = ACTIONS(3111),
    [anon_sym_LPAREN] = ACTIONS(3111),
    [anon_sym_COMMA] = ACTIONS(3113),
    [anon_sym_null] = ACTIONS(3111),
    [anon_sym_QMARK] = ACTIONS(3111),
    [anon_sym_COLON_QMARK] = ACTIONS(3111),
    [anon_sym_COLON_COLON] = ACTIONS(3113),
    [anon_sym_AMP] = ACTIONS(3111),
    [anon_sym_LBRACK] = ACTIONS(3111),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3113),
    [anon_sym_LBRACE] = ACTIONS(3111),
    [anon_sym_LT_AT] = ACTIONS(3111),
    [anon_sym_LT_AT_AT] = ACTIONS(3111),
    [anon_sym_DOT] = ACTIONS(3111),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3113),
    [anon_sym_new] = ACTIONS(3111),
    [anon_sym_with] = ACTIONS(3111),
    [anon_sym_return_BANG] = ACTIONS(3113),
    [anon_sym_yield] = ACTIONS(3111),
    [anon_sym_yield_BANG] = ACTIONS(3113),
    [anon_sym_lazy] = ACTIONS(3111),
    [anon_sym_assert] = ACTIONS(3111),
    [anon_sym_upcast] = ACTIONS(3111),
    [anon_sym_downcast] = ACTIONS(3111),
    [anon_sym_COLON_GT] = ACTIONS(3113),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3113),
    [anon_sym_for] = ACTIONS(3111),
    [anon_sym_while] = ACTIONS(3111),
    [anon_sym_if] = ACTIONS(3111),
    [anon_sym_fun] = ACTIONS(3111),
    [anon_sym_try] = ACTIONS(3111),
    [anon_sym_match] = ACTIONS(3111),
    [anon_sym_match_BANG] = ACTIONS(3113),
    [anon_sym_function] = ACTIONS(3111),
    [anon_sym_LT_DASH] = ACTIONS(3111),
    [anon_sym_DOT_LBRACK] = ACTIONS(3113),
    [anon_sym_LT] = ACTIONS(3113),
    [anon_sym_use] = ACTIONS(3111),
    [anon_sym_use_BANG] = ACTIONS(3113),
    [anon_sym_do_BANG] = ACTIONS(3113),
    [anon_sym_begin] = ACTIONS(3111),
    [anon_sym_LPAREN2] = ACTIONS(3111),
    [anon_sym_or] = ACTIONS(3111),
    [aux_sym_char_token1] = ACTIONS(3113),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3111),
    [anon_sym_DQUOTE] = ACTIONS(3111),
    [anon_sym_AT_DQUOTE] = ACTIONS(3113),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3113),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3113),
    [sym_bool] = ACTIONS(3111),
    [sym_unit] = ACTIONS(3113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3111),
    [sym_op_identifier] = ACTIONS(3111),
    [anon_sym_PLUS] = ACTIONS(3111),
    [anon_sym_DASH] = ACTIONS(3111),
    [anon_sym_PLUS_DOT] = ACTIONS(3111),
    [anon_sym_DASH_DOT] = ACTIONS(3111),
    [anon_sym_PERCENT] = ACTIONS(3111),
    [anon_sym_AMP_AMP] = ACTIONS(3111),
    [anon_sym_TILDE] = ACTIONS(3113),
    [aux_sym_prefix_op_token1] = ACTIONS(3111),
    [aux_sym_infix_op_token1] = ACTIONS(3113),
    [aux_sym_infix_op_token2] = ACTIONS(3111),
    [anon_sym_PIPE_PIPE] = ACTIONS(3111),
    [anon_sym_BANG_EQ] = ACTIONS(3111),
    [anon_sym_COLON_EQ] = ACTIONS(3113),
    [anon_sym_DOLLAR] = ACTIONS(3111),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3111),
    [sym_int] = ACTIONS(3111),
    [sym_xint] = ACTIONS(3113),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3113),
    [sym__newline] = ACTIONS(3113),
  },
  [1935] = {
    [sym_block_comment] = STATE(1935),
    [sym_compiler_directive_decl] = STATE(1935),
    [sym_fsi_directive_decl] = STATE(1935),
    [sym_preproc_line] = STATE(1935),
    [sym_identifier] = ACTIONS(2835),
    [anon_sym_EQ] = ACTIONS(2837),
    [anon_sym_COLON] = ACTIONS(2835),
    [anon_sym_return] = ACTIONS(2835),
    [anon_sym_do] = ACTIONS(2835),
    [anon_sym_let] = ACTIONS(2835),
    [anon_sym_let_BANG] = ACTIONS(2837),
    [anon_sym_as] = ACTIONS(2835),
    [anon_sym_LPAREN] = ACTIONS(2835),
    [anon_sym_COMMA] = ACTIONS(2837),
    [anon_sym_null] = ACTIONS(2835),
    [anon_sym_QMARK] = ACTIONS(2835),
    [anon_sym_COLON_QMARK] = ACTIONS(2835),
    [anon_sym_COLON_COLON] = ACTIONS(2837),
    [anon_sym_AMP] = ACTIONS(2835),
    [anon_sym_LBRACK] = ACTIONS(2835),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2837),
    [anon_sym_LBRACE] = ACTIONS(2835),
    [anon_sym_LT_AT] = ACTIONS(2835),
    [anon_sym_LT_AT_AT] = ACTIONS(2835),
    [anon_sym_DOT] = ACTIONS(2835),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2837),
    [anon_sym_new] = ACTIONS(2835),
    [anon_sym_with] = ACTIONS(2835),
    [anon_sym_return_BANG] = ACTIONS(2837),
    [anon_sym_yield] = ACTIONS(2835),
    [anon_sym_yield_BANG] = ACTIONS(2837),
    [anon_sym_lazy] = ACTIONS(2835),
    [anon_sym_assert] = ACTIONS(2835),
    [anon_sym_upcast] = ACTIONS(2835),
    [anon_sym_downcast] = ACTIONS(2835),
    [anon_sym_COLON_GT] = ACTIONS(2837),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2837),
    [anon_sym_for] = ACTIONS(2835),
    [anon_sym_while] = ACTIONS(2835),
    [anon_sym_if] = ACTIONS(2835),
    [anon_sym_fun] = ACTIONS(2835),
    [anon_sym_try] = ACTIONS(2835),
    [anon_sym_match] = ACTIONS(2835),
    [anon_sym_match_BANG] = ACTIONS(2837),
    [anon_sym_function] = ACTIONS(2835),
    [anon_sym_LT_DASH] = ACTIONS(2835),
    [anon_sym_DOT_LBRACK] = ACTIONS(2837),
    [anon_sym_LT] = ACTIONS(2837),
    [anon_sym_use] = ACTIONS(2835),
    [anon_sym_use_BANG] = ACTIONS(2837),
    [anon_sym_do_BANG] = ACTIONS(2837),
    [anon_sym_begin] = ACTIONS(2835),
    [anon_sym_LPAREN2] = ACTIONS(2835),
    [anon_sym_or] = ACTIONS(2835),
    [aux_sym_char_token1] = ACTIONS(2837),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2835),
    [anon_sym_DQUOTE] = ACTIONS(2835),
    [anon_sym_AT_DQUOTE] = ACTIONS(2837),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2837),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2837),
    [sym_bool] = ACTIONS(2835),
    [sym_unit] = ACTIONS(2837),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2835),
    [sym_op_identifier] = ACTIONS(2835),
    [anon_sym_PLUS] = ACTIONS(2835),
    [anon_sym_DASH] = ACTIONS(2835),
    [anon_sym_PLUS_DOT] = ACTIONS(2835),
    [anon_sym_DASH_DOT] = ACTIONS(2835),
    [anon_sym_PERCENT] = ACTIONS(2835),
    [anon_sym_AMP_AMP] = ACTIONS(2835),
    [anon_sym_TILDE] = ACTIONS(2837),
    [aux_sym_prefix_op_token1] = ACTIONS(2835),
    [aux_sym_infix_op_token1] = ACTIONS(2837),
    [aux_sym_infix_op_token2] = ACTIONS(2835),
    [anon_sym_PIPE_PIPE] = ACTIONS(2835),
    [anon_sym_BANG_EQ] = ACTIONS(2835),
    [anon_sym_COLON_EQ] = ACTIONS(2837),
    [anon_sym_DOLLAR] = ACTIONS(2835),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2835),
    [sym_int] = ACTIONS(2835),
    [sym_xint] = ACTIONS(2837),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2837),
    [sym__newline] = ACTIONS(2837),
  },
  [1936] = {
    [sym_block_comment] = STATE(1936),
    [sym_compiler_directive_decl] = STATE(1936),
    [sym_fsi_directive_decl] = STATE(1936),
    [sym_preproc_line] = STATE(1936),
    [sym_identifier] = ACTIONS(3119),
    [anon_sym_EQ] = ACTIONS(3121),
    [anon_sym_COLON] = ACTIONS(3119),
    [anon_sym_return] = ACTIONS(3119),
    [anon_sym_do] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_let_BANG] = ACTIONS(3121),
    [anon_sym_as] = ACTIONS(3119),
    [anon_sym_LPAREN] = ACTIONS(3119),
    [anon_sym_COMMA] = ACTIONS(3121),
    [anon_sym_null] = ACTIONS(3119),
    [anon_sym_QMARK] = ACTIONS(3119),
    [anon_sym_COLON_QMARK] = ACTIONS(3119),
    [anon_sym_COLON_COLON] = ACTIONS(3121),
    [anon_sym_AMP] = ACTIONS(3119),
    [anon_sym_LBRACK] = ACTIONS(3119),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3121),
    [anon_sym_LBRACE] = ACTIONS(3119),
    [anon_sym_LT_AT] = ACTIONS(3119),
    [anon_sym_LT_AT_AT] = ACTIONS(3119),
    [anon_sym_DOT] = ACTIONS(3119),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3121),
    [anon_sym_new] = ACTIONS(3119),
    [anon_sym_with] = ACTIONS(3119),
    [anon_sym_return_BANG] = ACTIONS(3121),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_yield_BANG] = ACTIONS(3121),
    [anon_sym_lazy] = ACTIONS(3119),
    [anon_sym_assert] = ACTIONS(3119),
    [anon_sym_upcast] = ACTIONS(3119),
    [anon_sym_downcast] = ACTIONS(3119),
    [anon_sym_COLON_GT] = ACTIONS(3121),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3121),
    [anon_sym_for] = ACTIONS(3119),
    [anon_sym_while] = ACTIONS(3119),
    [anon_sym_if] = ACTIONS(3119),
    [anon_sym_fun] = ACTIONS(3119),
    [anon_sym_try] = ACTIONS(3119),
    [anon_sym_match] = ACTIONS(3119),
    [anon_sym_match_BANG] = ACTIONS(3121),
    [anon_sym_function] = ACTIONS(3119),
    [anon_sym_LT_DASH] = ACTIONS(3119),
    [anon_sym_DOT_LBRACK] = ACTIONS(3121),
    [anon_sym_LT] = ACTIONS(3121),
    [anon_sym_use] = ACTIONS(3119),
    [anon_sym_use_BANG] = ACTIONS(3121),
    [anon_sym_do_BANG] = ACTIONS(3121),
    [anon_sym_begin] = ACTIONS(3119),
    [anon_sym_LPAREN2] = ACTIONS(3119),
    [anon_sym_or] = ACTIONS(3119),
    [aux_sym_char_token1] = ACTIONS(3121),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3119),
    [anon_sym_DQUOTE] = ACTIONS(3119),
    [anon_sym_AT_DQUOTE] = ACTIONS(3121),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3121),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3121),
    [sym_bool] = ACTIONS(3119),
    [sym_unit] = ACTIONS(3121),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3119),
    [sym_op_identifier] = ACTIONS(3119),
    [anon_sym_PLUS] = ACTIONS(3119),
    [anon_sym_DASH] = ACTIONS(3119),
    [anon_sym_PLUS_DOT] = ACTIONS(3119),
    [anon_sym_DASH_DOT] = ACTIONS(3119),
    [anon_sym_PERCENT] = ACTIONS(3119),
    [anon_sym_AMP_AMP] = ACTIONS(3119),
    [anon_sym_TILDE] = ACTIONS(3121),
    [aux_sym_prefix_op_token1] = ACTIONS(3119),
    [aux_sym_infix_op_token1] = ACTIONS(3121),
    [aux_sym_infix_op_token2] = ACTIONS(3119),
    [anon_sym_PIPE_PIPE] = ACTIONS(3119),
    [anon_sym_BANG_EQ] = ACTIONS(3119),
    [anon_sym_COLON_EQ] = ACTIONS(3121),
    [anon_sym_DOLLAR] = ACTIONS(3119),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3119),
    [sym_int] = ACTIONS(3119),
    [sym_xint] = ACTIONS(3121),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3121),
    [sym__newline] = ACTIONS(3121),
  },
  [1937] = {
    [sym_block_comment] = STATE(1937),
    [sym_compiler_directive_decl] = STATE(1937),
    [sym_fsi_directive_decl] = STATE(1937),
    [sym_preproc_line] = STATE(1937),
    [sym_identifier] = ACTIONS(3075),
    [anon_sym_EQ] = ACTIONS(3077),
    [anon_sym_COLON] = ACTIONS(3075),
    [anon_sym_return] = ACTIONS(3075),
    [anon_sym_do] = ACTIONS(3075),
    [anon_sym_let] = ACTIONS(3075),
    [anon_sym_let_BANG] = ACTIONS(3077),
    [anon_sym_LPAREN] = ACTIONS(3075),
    [anon_sym_COMMA] = ACTIONS(3077),
    [anon_sym_null] = ACTIONS(3075),
    [anon_sym_QMARK] = ACTIONS(3075),
    [anon_sym_COLON_QMARK] = ACTIONS(3075),
    [anon_sym_COLON_COLON] = ACTIONS(3077),
    [anon_sym_AMP] = ACTIONS(3075),
    [anon_sym_LBRACK] = ACTIONS(3075),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3077),
    [anon_sym_LBRACE] = ACTIONS(3075),
    [anon_sym_LT_AT] = ACTIONS(3075),
    [anon_sym_LT_AT_AT] = ACTIONS(3075),
    [anon_sym_DOT] = ACTIONS(3075),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3077),
    [anon_sym_new] = ACTIONS(3075),
    [anon_sym_return_BANG] = ACTIONS(3077),
    [anon_sym_yield] = ACTIONS(3075),
    [anon_sym_yield_BANG] = ACTIONS(3077),
    [anon_sym_lazy] = ACTIONS(3075),
    [anon_sym_assert] = ACTIONS(3075),
    [anon_sym_upcast] = ACTIONS(3075),
    [anon_sym_downcast] = ACTIONS(3075),
    [anon_sym_COLON_GT] = ACTIONS(3077),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3077),
    [anon_sym_for] = ACTIONS(3075),
    [anon_sym_while] = ACTIONS(3075),
    [anon_sym_if] = ACTIONS(3075),
    [anon_sym_fun] = ACTIONS(3075),
    [anon_sym_DASH_GT] = ACTIONS(3075),
    [anon_sym_try] = ACTIONS(3075),
    [anon_sym_match] = ACTIONS(3075),
    [anon_sym_match_BANG] = ACTIONS(3077),
    [anon_sym_function] = ACTIONS(3075),
    [anon_sym_LT_DASH] = ACTIONS(3075),
    [anon_sym_DOT_LBRACK] = ACTIONS(3077),
    [anon_sym_LT] = ACTIONS(3077),
    [anon_sym_use] = ACTIONS(3075),
    [anon_sym_use_BANG] = ACTIONS(3077),
    [anon_sym_do_BANG] = ACTIONS(3077),
    [anon_sym_DOT_DOT] = ACTIONS(3077),
    [anon_sym_begin] = ACTIONS(3075),
    [anon_sym_LPAREN2] = ACTIONS(3075),
    [anon_sym_or] = ACTIONS(3075),
    [aux_sym_char_token1] = ACTIONS(3077),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3075),
    [anon_sym_DQUOTE] = ACTIONS(3075),
    [anon_sym_AT_DQUOTE] = ACTIONS(3077),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3077),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3077),
    [sym_bool] = ACTIONS(3075),
    [sym_unit] = ACTIONS(3077),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3075),
    [sym_op_identifier] = ACTIONS(3075),
    [anon_sym_PLUS] = ACTIONS(3075),
    [anon_sym_DASH] = ACTIONS(3075),
    [anon_sym_PLUS_DOT] = ACTIONS(3075),
    [anon_sym_DASH_DOT] = ACTIONS(3075),
    [anon_sym_PERCENT] = ACTIONS(3075),
    [anon_sym_AMP_AMP] = ACTIONS(3075),
    [anon_sym_TILDE] = ACTIONS(3077),
    [aux_sym_prefix_op_token1] = ACTIONS(3075),
    [aux_sym_infix_op_token1] = ACTIONS(3077),
    [aux_sym_infix_op_token2] = ACTIONS(3075),
    [anon_sym_PIPE_PIPE] = ACTIONS(3075),
    [anon_sym_BANG_EQ] = ACTIONS(3075),
    [anon_sym_COLON_EQ] = ACTIONS(3077),
    [anon_sym_DOLLAR] = ACTIONS(3075),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3075),
    [sym_int] = ACTIONS(3075),
    [sym_xint] = ACTIONS(3077),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3077),
    [sym__newline] = ACTIONS(3077),
  },
  [1938] = {
    [sym_block_comment] = STATE(1938),
    [sym_compiler_directive_decl] = STATE(1938),
    [sym_fsi_directive_decl] = STATE(1938),
    [sym_preproc_line] = STATE(1938),
    [sym_identifier] = ACTIONS(2766),
    [anon_sym_EQ] = ACTIONS(2768),
    [anon_sym_COLON] = ACTIONS(2766),
    [anon_sym_return] = ACTIONS(2766),
    [anon_sym_do] = ACTIONS(2766),
    [anon_sym_let] = ACTIONS(2766),
    [anon_sym_let_BANG] = ACTIONS(2768),
    [anon_sym_LPAREN] = ACTIONS(2766),
    [anon_sym_COMMA] = ACTIONS(2768),
    [anon_sym_null] = ACTIONS(2766),
    [anon_sym_QMARK] = ACTIONS(2766),
    [anon_sym_COLON_QMARK] = ACTIONS(2766),
    [anon_sym_COLON_COLON] = ACTIONS(2768),
    [anon_sym_PIPE] = ACTIONS(2766),
    [anon_sym_AMP] = ACTIONS(2766),
    [anon_sym_LBRACK] = ACTIONS(2766),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2768),
    [anon_sym_LBRACE] = ACTIONS(2766),
    [anon_sym_LT_AT] = ACTIONS(2766),
    [anon_sym_LT_AT_AT] = ACTIONS(2766),
    [anon_sym_DOT] = ACTIONS(2766),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2768),
    [anon_sym_new] = ACTIONS(2766),
    [anon_sym_return_BANG] = ACTIONS(2768),
    [anon_sym_yield] = ACTIONS(2766),
    [anon_sym_yield_BANG] = ACTIONS(2768),
    [anon_sym_lazy] = ACTIONS(2766),
    [anon_sym_assert] = ACTIONS(2766),
    [anon_sym_upcast] = ACTIONS(2766),
    [anon_sym_downcast] = ACTIONS(2766),
    [anon_sym_COLON_GT] = ACTIONS(2768),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2768),
    [anon_sym_for] = ACTIONS(2766),
    [anon_sym_while] = ACTIONS(2766),
    [anon_sym_if] = ACTIONS(2766),
    [anon_sym_fun] = ACTIONS(2766),
    [anon_sym_try] = ACTIONS(2766),
    [anon_sym_match] = ACTIONS(2766),
    [anon_sym_match_BANG] = ACTIONS(2768),
    [anon_sym_function] = ACTIONS(2766),
    [anon_sym_LT_DASH] = ACTIONS(2766),
    [anon_sym_DOT_LBRACK] = ACTIONS(2768),
    [anon_sym_LT] = ACTIONS(2768),
    [anon_sym_GT] = ACTIONS(2766),
    [anon_sym_use] = ACTIONS(2766),
    [anon_sym_use_BANG] = ACTIONS(2768),
    [anon_sym_do_BANG] = ACTIONS(2768),
    [anon_sym_begin] = ACTIONS(2766),
    [anon_sym_LPAREN2] = ACTIONS(2766),
    [anon_sym_or] = ACTIONS(2766),
    [aux_sym_char_token1] = ACTIONS(2768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2766),
    [anon_sym_DQUOTE] = ACTIONS(2766),
    [anon_sym_AT_DQUOTE] = ACTIONS(2768),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2768),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2768),
    [sym_bool] = ACTIONS(2766),
    [sym_unit] = ACTIONS(2768),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2766),
    [sym_op_identifier] = ACTIONS(2766),
    [anon_sym_PLUS] = ACTIONS(2766),
    [anon_sym_DASH] = ACTIONS(2766),
    [anon_sym_PLUS_DOT] = ACTIONS(2766),
    [anon_sym_DASH_DOT] = ACTIONS(2766),
    [anon_sym_PERCENT] = ACTIONS(2766),
    [anon_sym_AMP_AMP] = ACTIONS(2766),
    [anon_sym_TILDE] = ACTIONS(2768),
    [aux_sym_prefix_op_token1] = ACTIONS(2766),
    [aux_sym_infix_op_token1] = ACTIONS(2768),
    [aux_sym_infix_op_token2] = ACTIONS(2766),
    [anon_sym_PIPE_PIPE] = ACTIONS(2766),
    [anon_sym_BANG_EQ] = ACTIONS(2766),
    [anon_sym_COLON_EQ] = ACTIONS(2768),
    [anon_sym_DOLLAR] = ACTIONS(2766),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2766),
    [sym_int] = ACTIONS(2766),
    [sym_xint] = ACTIONS(2768),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2768),
    [sym__newline] = ACTIONS(2768),
  },
  [1939] = {
    [sym_block_comment] = STATE(1939),
    [sym_compiler_directive_decl] = STATE(1939),
    [sym_fsi_directive_decl] = STATE(1939),
    [sym_preproc_line] = STATE(1939),
    [sym_identifier] = ACTIONS(2713),
    [anon_sym_EQ] = ACTIONS(2715),
    [anon_sym_COLON] = ACTIONS(2713),
    [anon_sym_return] = ACTIONS(2713),
    [anon_sym_do] = ACTIONS(2713),
    [anon_sym_let] = ACTIONS(2713),
    [anon_sym_let_BANG] = ACTIONS(2715),
    [anon_sym_LPAREN] = ACTIONS(2713),
    [anon_sym_COMMA] = ACTIONS(2715),
    [anon_sym_null] = ACTIONS(2713),
    [anon_sym_QMARK] = ACTIONS(2713),
    [anon_sym_COLON_QMARK] = ACTIONS(2713),
    [anon_sym_COLON_COLON] = ACTIONS(2715),
    [anon_sym_PIPE] = ACTIONS(2713),
    [anon_sym_AMP] = ACTIONS(2713),
    [anon_sym_LBRACK] = ACTIONS(2713),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2715),
    [anon_sym_LBRACE] = ACTIONS(2713),
    [anon_sym_LT_AT] = ACTIONS(2713),
    [anon_sym_LT_AT_AT] = ACTIONS(2713),
    [anon_sym_DOT] = ACTIONS(2713),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2715),
    [anon_sym_new] = ACTIONS(2713),
    [anon_sym_return_BANG] = ACTIONS(2715),
    [anon_sym_yield] = ACTIONS(2713),
    [anon_sym_yield_BANG] = ACTIONS(2715),
    [anon_sym_lazy] = ACTIONS(2713),
    [anon_sym_assert] = ACTIONS(2713),
    [anon_sym_upcast] = ACTIONS(2713),
    [anon_sym_downcast] = ACTIONS(2713),
    [anon_sym_COLON_GT] = ACTIONS(2715),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2715),
    [anon_sym_for] = ACTIONS(2713),
    [anon_sym_while] = ACTIONS(2713),
    [anon_sym_if] = ACTIONS(2713),
    [anon_sym_fun] = ACTIONS(2713),
    [anon_sym_try] = ACTIONS(2713),
    [anon_sym_match] = ACTIONS(2713),
    [anon_sym_match_BANG] = ACTIONS(2715),
    [anon_sym_function] = ACTIONS(2713),
    [anon_sym_LT_DASH] = ACTIONS(2713),
    [anon_sym_DOT_LBRACK] = ACTIONS(2715),
    [anon_sym_LT] = ACTIONS(2715),
    [anon_sym_GT] = ACTIONS(2713),
    [anon_sym_use] = ACTIONS(2713),
    [anon_sym_use_BANG] = ACTIONS(2715),
    [anon_sym_do_BANG] = ACTIONS(2715),
    [anon_sym_begin] = ACTIONS(2713),
    [anon_sym_LPAREN2] = ACTIONS(2713),
    [anon_sym_or] = ACTIONS(2713),
    [aux_sym_char_token1] = ACTIONS(2715),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2713),
    [anon_sym_DQUOTE] = ACTIONS(2713),
    [anon_sym_AT_DQUOTE] = ACTIONS(2715),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2715),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2715),
    [sym_bool] = ACTIONS(2713),
    [sym_unit] = ACTIONS(2715),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2713),
    [sym_op_identifier] = ACTIONS(2713),
    [anon_sym_PLUS] = ACTIONS(2713),
    [anon_sym_DASH] = ACTIONS(2713),
    [anon_sym_PLUS_DOT] = ACTIONS(2713),
    [anon_sym_DASH_DOT] = ACTIONS(2713),
    [anon_sym_PERCENT] = ACTIONS(2713),
    [anon_sym_AMP_AMP] = ACTIONS(2713),
    [anon_sym_TILDE] = ACTIONS(2715),
    [aux_sym_prefix_op_token1] = ACTIONS(2713),
    [aux_sym_infix_op_token1] = ACTIONS(2715),
    [aux_sym_infix_op_token2] = ACTIONS(2713),
    [anon_sym_PIPE_PIPE] = ACTIONS(2713),
    [anon_sym_BANG_EQ] = ACTIONS(2713),
    [anon_sym_COLON_EQ] = ACTIONS(2715),
    [anon_sym_DOLLAR] = ACTIONS(2713),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2713),
    [sym_int] = ACTIONS(2713),
    [sym_xint] = ACTIONS(2715),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2715),
    [sym__newline] = ACTIONS(2715),
  },
  [1940] = {
    [sym_block_comment] = STATE(1940),
    [sym_compiler_directive_decl] = STATE(1940),
    [sym_fsi_directive_decl] = STATE(1940),
    [sym_preproc_line] = STATE(1940),
    [sym_identifier] = ACTIONS(3087),
    [anon_sym_EQ] = ACTIONS(3089),
    [anon_sym_COLON] = ACTIONS(3087),
    [anon_sym_return] = ACTIONS(3087),
    [anon_sym_do] = ACTIONS(3087),
    [anon_sym_let] = ACTIONS(3087),
    [anon_sym_let_BANG] = ACTIONS(3089),
    [anon_sym_LPAREN] = ACTIONS(3087),
    [anon_sym_COMMA] = ACTIONS(3089),
    [anon_sym_null] = ACTIONS(3087),
    [anon_sym_QMARK] = ACTIONS(3087),
    [anon_sym_COLON_QMARK] = ACTIONS(3087),
    [anon_sym_COLON_COLON] = ACTIONS(3089),
    [anon_sym_AMP] = ACTIONS(3087),
    [anon_sym_LBRACK] = ACTIONS(3087),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3089),
    [anon_sym_LBRACE] = ACTIONS(3087),
    [anon_sym_LT_AT] = ACTIONS(3087),
    [anon_sym_LT_AT_AT] = ACTIONS(3087),
    [anon_sym_DOT] = ACTIONS(3087),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3089),
    [anon_sym_new] = ACTIONS(3087),
    [anon_sym_return_BANG] = ACTIONS(3089),
    [anon_sym_yield] = ACTIONS(3087),
    [anon_sym_yield_BANG] = ACTIONS(3089),
    [anon_sym_lazy] = ACTIONS(3087),
    [anon_sym_assert] = ACTIONS(3087),
    [anon_sym_upcast] = ACTIONS(3087),
    [anon_sym_downcast] = ACTIONS(3087),
    [anon_sym_COLON_GT] = ACTIONS(3089),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3089),
    [anon_sym_for] = ACTIONS(3087),
    [anon_sym_while] = ACTIONS(3087),
    [anon_sym_if] = ACTIONS(3087),
    [anon_sym_fun] = ACTIONS(3087),
    [anon_sym_DASH_GT] = ACTIONS(3087),
    [anon_sym_try] = ACTIONS(3087),
    [anon_sym_match] = ACTIONS(3087),
    [anon_sym_match_BANG] = ACTIONS(3089),
    [anon_sym_function] = ACTIONS(3087),
    [anon_sym_LT_DASH] = ACTIONS(3087),
    [anon_sym_DOT_LBRACK] = ACTIONS(3089),
    [anon_sym_LT] = ACTIONS(3089),
    [anon_sym_use] = ACTIONS(3087),
    [anon_sym_use_BANG] = ACTIONS(3089),
    [anon_sym_do_BANG] = ACTIONS(3089),
    [anon_sym_DOT_DOT] = ACTIONS(3089),
    [anon_sym_begin] = ACTIONS(3087),
    [anon_sym_LPAREN2] = ACTIONS(3087),
    [anon_sym_or] = ACTIONS(3087),
    [aux_sym_char_token1] = ACTIONS(3089),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3087),
    [anon_sym_DQUOTE] = ACTIONS(3087),
    [anon_sym_AT_DQUOTE] = ACTIONS(3089),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3089),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3089),
    [sym_bool] = ACTIONS(3087),
    [sym_unit] = ACTIONS(3089),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3087),
    [sym_op_identifier] = ACTIONS(3087),
    [anon_sym_PLUS] = ACTIONS(3087),
    [anon_sym_DASH] = ACTIONS(3087),
    [anon_sym_PLUS_DOT] = ACTIONS(3087),
    [anon_sym_DASH_DOT] = ACTIONS(3087),
    [anon_sym_PERCENT] = ACTIONS(3087),
    [anon_sym_AMP_AMP] = ACTIONS(3087),
    [anon_sym_TILDE] = ACTIONS(3089),
    [aux_sym_prefix_op_token1] = ACTIONS(3087),
    [aux_sym_infix_op_token1] = ACTIONS(3089),
    [aux_sym_infix_op_token2] = ACTIONS(3087),
    [anon_sym_PIPE_PIPE] = ACTIONS(3087),
    [anon_sym_BANG_EQ] = ACTIONS(3087),
    [anon_sym_COLON_EQ] = ACTIONS(3089),
    [anon_sym_DOLLAR] = ACTIONS(3087),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3087),
    [sym_int] = ACTIONS(3087),
    [sym_xint] = ACTIONS(3089),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3089),
    [sym__newline] = ACTIONS(3089),
  },
  [1941] = {
    [sym_block_comment] = STATE(1941),
    [sym_compiler_directive_decl] = STATE(1941),
    [sym_fsi_directive_decl] = STATE(1941),
    [sym_preproc_line] = STATE(1941),
    [sym_identifier] = ACTIONS(3091),
    [anon_sym_EQ] = ACTIONS(3093),
    [anon_sym_COLON] = ACTIONS(3091),
    [anon_sym_return] = ACTIONS(3091),
    [anon_sym_do] = ACTIONS(3091),
    [anon_sym_let] = ACTIONS(3091),
    [anon_sym_let_BANG] = ACTIONS(3093),
    [anon_sym_LPAREN] = ACTIONS(3091),
    [anon_sym_COMMA] = ACTIONS(3093),
    [anon_sym_null] = ACTIONS(3091),
    [anon_sym_QMARK] = ACTIONS(3091),
    [anon_sym_COLON_QMARK] = ACTIONS(3091),
    [anon_sym_COLON_COLON] = ACTIONS(3093),
    [anon_sym_AMP] = ACTIONS(3091),
    [anon_sym_LBRACK] = ACTIONS(3091),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3093),
    [anon_sym_LBRACE] = ACTIONS(3091),
    [anon_sym_LT_AT] = ACTIONS(3091),
    [anon_sym_LT_AT_AT] = ACTIONS(3091),
    [anon_sym_DOT] = ACTIONS(3091),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3093),
    [anon_sym_new] = ACTIONS(3091),
    [anon_sym_return_BANG] = ACTIONS(3093),
    [anon_sym_yield] = ACTIONS(3091),
    [anon_sym_yield_BANG] = ACTIONS(3093),
    [anon_sym_lazy] = ACTIONS(3091),
    [anon_sym_assert] = ACTIONS(3091),
    [anon_sym_upcast] = ACTIONS(3091),
    [anon_sym_downcast] = ACTIONS(3091),
    [anon_sym_COLON_GT] = ACTIONS(3093),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3093),
    [anon_sym_for] = ACTIONS(3091),
    [anon_sym_while] = ACTIONS(3091),
    [anon_sym_if] = ACTIONS(3091),
    [anon_sym_fun] = ACTIONS(3091),
    [anon_sym_DASH_GT] = ACTIONS(3091),
    [anon_sym_try] = ACTIONS(3091),
    [anon_sym_match] = ACTIONS(3091),
    [anon_sym_match_BANG] = ACTIONS(3093),
    [anon_sym_function] = ACTIONS(3091),
    [anon_sym_LT_DASH] = ACTIONS(3091),
    [anon_sym_DOT_LBRACK] = ACTIONS(3093),
    [anon_sym_LT] = ACTIONS(3093),
    [anon_sym_use] = ACTIONS(3091),
    [anon_sym_use_BANG] = ACTIONS(3093),
    [anon_sym_do_BANG] = ACTIONS(3093),
    [anon_sym_DOT_DOT] = ACTIONS(3093),
    [anon_sym_begin] = ACTIONS(3091),
    [anon_sym_LPAREN2] = ACTIONS(3091),
    [anon_sym_or] = ACTIONS(3091),
    [aux_sym_char_token1] = ACTIONS(3093),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3091),
    [anon_sym_DQUOTE] = ACTIONS(3091),
    [anon_sym_AT_DQUOTE] = ACTIONS(3093),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3093),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3093),
    [sym_bool] = ACTIONS(3091),
    [sym_unit] = ACTIONS(3093),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3091),
    [sym_op_identifier] = ACTIONS(3091),
    [anon_sym_PLUS] = ACTIONS(3091),
    [anon_sym_DASH] = ACTIONS(3091),
    [anon_sym_PLUS_DOT] = ACTIONS(3091),
    [anon_sym_DASH_DOT] = ACTIONS(3091),
    [anon_sym_PERCENT] = ACTIONS(3091),
    [anon_sym_AMP_AMP] = ACTIONS(3091),
    [anon_sym_TILDE] = ACTIONS(3093),
    [aux_sym_prefix_op_token1] = ACTIONS(3091),
    [aux_sym_infix_op_token1] = ACTIONS(3093),
    [aux_sym_infix_op_token2] = ACTIONS(3091),
    [anon_sym_PIPE_PIPE] = ACTIONS(3091),
    [anon_sym_BANG_EQ] = ACTIONS(3091),
    [anon_sym_COLON_EQ] = ACTIONS(3093),
    [anon_sym_DOLLAR] = ACTIONS(3091),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3091),
    [sym_int] = ACTIONS(3091),
    [sym_xint] = ACTIONS(3093),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3093),
    [sym__newline] = ACTIONS(3093),
  },
  [1942] = {
    [sym_block_comment] = STATE(1942),
    [sym_compiler_directive_decl] = STATE(1942),
    [sym_fsi_directive_decl] = STATE(1942),
    [sym_preproc_line] = STATE(1942),
    [sym_identifier] = ACTIONS(3135),
    [anon_sym_EQ] = ACTIONS(3137),
    [anon_sym_COLON] = ACTIONS(3135),
    [anon_sym_return] = ACTIONS(3135),
    [anon_sym_do] = ACTIONS(3135),
    [anon_sym_let] = ACTIONS(3135),
    [anon_sym_let_BANG] = ACTIONS(3137),
    [anon_sym_as] = ACTIONS(3135),
    [anon_sym_LPAREN] = ACTIONS(3135),
    [anon_sym_COMMA] = ACTIONS(3137),
    [anon_sym_null] = ACTIONS(3135),
    [anon_sym_QMARK] = ACTIONS(3135),
    [anon_sym_COLON_QMARK] = ACTIONS(3135),
    [anon_sym_COLON_COLON] = ACTIONS(3137),
    [anon_sym_AMP] = ACTIONS(3135),
    [anon_sym_LBRACK] = ACTIONS(3135),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3137),
    [anon_sym_LBRACE] = ACTIONS(3135),
    [anon_sym_LT_AT] = ACTIONS(3135),
    [anon_sym_LT_AT_AT] = ACTIONS(3135),
    [anon_sym_DOT] = ACTIONS(3135),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3137),
    [anon_sym_new] = ACTIONS(3135),
    [anon_sym_with] = ACTIONS(3135),
    [anon_sym_return_BANG] = ACTIONS(3137),
    [anon_sym_yield] = ACTIONS(3135),
    [anon_sym_yield_BANG] = ACTIONS(3137),
    [anon_sym_lazy] = ACTIONS(3135),
    [anon_sym_assert] = ACTIONS(3135),
    [anon_sym_upcast] = ACTIONS(3135),
    [anon_sym_downcast] = ACTIONS(3135),
    [anon_sym_COLON_GT] = ACTIONS(3137),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3137),
    [anon_sym_for] = ACTIONS(3135),
    [anon_sym_while] = ACTIONS(3135),
    [anon_sym_if] = ACTIONS(3135),
    [anon_sym_fun] = ACTIONS(3135),
    [anon_sym_try] = ACTIONS(3135),
    [anon_sym_match] = ACTIONS(3135),
    [anon_sym_match_BANG] = ACTIONS(3137),
    [anon_sym_function] = ACTIONS(3135),
    [anon_sym_LT_DASH] = ACTIONS(3135),
    [anon_sym_DOT_LBRACK] = ACTIONS(3137),
    [anon_sym_LT] = ACTIONS(3137),
    [anon_sym_use] = ACTIONS(3135),
    [anon_sym_use_BANG] = ACTIONS(3137),
    [anon_sym_do_BANG] = ACTIONS(3137),
    [anon_sym_begin] = ACTIONS(3135),
    [anon_sym_LPAREN2] = ACTIONS(3135),
    [anon_sym_or] = ACTIONS(3135),
    [aux_sym_char_token1] = ACTIONS(3137),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3135),
    [anon_sym_DQUOTE] = ACTIONS(3135),
    [anon_sym_AT_DQUOTE] = ACTIONS(3137),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3137),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3137),
    [sym_bool] = ACTIONS(3135),
    [sym_unit] = ACTIONS(3137),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3135),
    [sym_op_identifier] = ACTIONS(3135),
    [anon_sym_PLUS] = ACTIONS(3135),
    [anon_sym_DASH] = ACTIONS(3135),
    [anon_sym_PLUS_DOT] = ACTIONS(3135),
    [anon_sym_DASH_DOT] = ACTIONS(3135),
    [anon_sym_PERCENT] = ACTIONS(3135),
    [anon_sym_AMP_AMP] = ACTIONS(3135),
    [anon_sym_TILDE] = ACTIONS(3137),
    [aux_sym_prefix_op_token1] = ACTIONS(3135),
    [aux_sym_infix_op_token1] = ACTIONS(3137),
    [aux_sym_infix_op_token2] = ACTIONS(3135),
    [anon_sym_PIPE_PIPE] = ACTIONS(3135),
    [anon_sym_BANG_EQ] = ACTIONS(3135),
    [anon_sym_COLON_EQ] = ACTIONS(3137),
    [anon_sym_DOLLAR] = ACTIONS(3135),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3135),
    [sym_int] = ACTIONS(3135),
    [sym_xint] = ACTIONS(3137),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3137),
    [sym__newline] = ACTIONS(3137),
  },
  [1943] = {
    [sym_block_comment] = STATE(1943),
    [sym_compiler_directive_decl] = STATE(1943),
    [sym_fsi_directive_decl] = STATE(1943),
    [sym_preproc_line] = STATE(1943),
    [sym_identifier] = ACTIONS(2770),
    [anon_sym_EQ] = ACTIONS(2772),
    [anon_sym_COLON] = ACTIONS(2770),
    [anon_sym_return] = ACTIONS(2770),
    [anon_sym_do] = ACTIONS(2770),
    [anon_sym_let] = ACTIONS(2770),
    [anon_sym_let_BANG] = ACTIONS(2772),
    [anon_sym_LPAREN] = ACTIONS(2770),
    [anon_sym_COMMA] = ACTIONS(2772),
    [anon_sym_null] = ACTIONS(2770),
    [anon_sym_QMARK] = ACTIONS(2770),
    [anon_sym_COLON_QMARK] = ACTIONS(2770),
    [anon_sym_COLON_COLON] = ACTIONS(2772),
    [anon_sym_AMP] = ACTIONS(2770),
    [anon_sym_LBRACK] = ACTIONS(2770),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2772),
    [anon_sym_LBRACE] = ACTIONS(2770),
    [anon_sym_LT_AT] = ACTIONS(2770),
    [anon_sym_LT_AT_AT] = ACTIONS(2770),
    [anon_sym_AT_AT_GT] = ACTIONS(2770),
    [anon_sym_DOT] = ACTIONS(2770),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2772),
    [anon_sym_new] = ACTIONS(2770),
    [anon_sym_return_BANG] = ACTIONS(2772),
    [anon_sym_yield] = ACTIONS(2770),
    [anon_sym_yield_BANG] = ACTIONS(2772),
    [anon_sym_lazy] = ACTIONS(2770),
    [anon_sym_assert] = ACTIONS(2770),
    [anon_sym_upcast] = ACTIONS(2770),
    [anon_sym_downcast] = ACTIONS(2770),
    [anon_sym_COLON_GT] = ACTIONS(2772),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2772),
    [anon_sym_for] = ACTIONS(2770),
    [anon_sym_done] = ACTIONS(4159),
    [anon_sym_while] = ACTIONS(2770),
    [anon_sym_if] = ACTIONS(2770),
    [anon_sym_fun] = ACTIONS(2770),
    [anon_sym_try] = ACTIONS(2770),
    [anon_sym_match] = ACTIONS(2770),
    [anon_sym_match_BANG] = ACTIONS(2772),
    [anon_sym_function] = ACTIONS(2770),
    [anon_sym_LT_DASH] = ACTIONS(2770),
    [anon_sym_DOT_LBRACK] = ACTIONS(2772),
    [anon_sym_LT] = ACTIONS(2772),
    [anon_sym_use] = ACTIONS(2770),
    [anon_sym_use_BANG] = ACTIONS(2772),
    [anon_sym_do_BANG] = ACTIONS(2772),
    [anon_sym_begin] = ACTIONS(2770),
    [anon_sym_LPAREN2] = ACTIONS(2770),
    [anon_sym_or] = ACTIONS(2770),
    [aux_sym_char_token1] = ACTIONS(2772),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2770),
    [anon_sym_DQUOTE] = ACTIONS(2770),
    [anon_sym_AT_DQUOTE] = ACTIONS(2772),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2772),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2772),
    [sym_bool] = ACTIONS(2770),
    [sym_unit] = ACTIONS(2772),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2770),
    [sym_op_identifier] = ACTIONS(2770),
    [anon_sym_PLUS] = ACTIONS(2770),
    [anon_sym_DASH] = ACTIONS(2770),
    [anon_sym_PLUS_DOT] = ACTIONS(2770),
    [anon_sym_DASH_DOT] = ACTIONS(2770),
    [anon_sym_PERCENT] = ACTIONS(2770),
    [anon_sym_AMP_AMP] = ACTIONS(2770),
    [anon_sym_TILDE] = ACTIONS(2772),
    [aux_sym_prefix_op_token1] = ACTIONS(2770),
    [aux_sym_infix_op_token1] = ACTIONS(2772),
    [aux_sym_infix_op_token2] = ACTIONS(2770),
    [anon_sym_PIPE_PIPE] = ACTIONS(2770),
    [anon_sym_BANG_EQ] = ACTIONS(2770),
    [anon_sym_COLON_EQ] = ACTIONS(2772),
    [anon_sym_DOLLAR] = ACTIONS(2770),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2770),
    [sym_int] = ACTIONS(2770),
    [sym_xint] = ACTIONS(2772),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2772),
    [sym__newline] = ACTIONS(2772),
  },
  [1944] = {
    [sym_block_comment] = STATE(1944),
    [sym_compiler_directive_decl] = STATE(1944),
    [sym_fsi_directive_decl] = STATE(1944),
    [sym_preproc_line] = STATE(1944),
    [sym_identifier] = ACTIONS(3123),
    [anon_sym_EQ] = ACTIONS(3125),
    [anon_sym_COLON] = ACTIONS(3123),
    [anon_sym_return] = ACTIONS(3123),
    [anon_sym_do] = ACTIONS(3123),
    [anon_sym_let] = ACTIONS(3123),
    [anon_sym_let_BANG] = ACTIONS(3125),
    [anon_sym_LPAREN] = ACTIONS(3123),
    [anon_sym_COMMA] = ACTIONS(3125),
    [anon_sym_null] = ACTIONS(3123),
    [anon_sym_QMARK] = ACTIONS(3123),
    [anon_sym_COLON_QMARK] = ACTIONS(3123),
    [anon_sym_COLON_COLON] = ACTIONS(3125),
    [anon_sym_AMP] = ACTIONS(3123),
    [anon_sym_LBRACK] = ACTIONS(3123),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3125),
    [anon_sym_LBRACE] = ACTIONS(3123),
    [anon_sym_LT_AT] = ACTIONS(3123),
    [anon_sym_LT_AT_AT] = ACTIONS(3123),
    [anon_sym_DOT] = ACTIONS(3123),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3125),
    [anon_sym_new] = ACTIONS(3123),
    [anon_sym_return_BANG] = ACTIONS(3125),
    [anon_sym_yield] = ACTIONS(3123),
    [anon_sym_yield_BANG] = ACTIONS(3125),
    [anon_sym_lazy] = ACTIONS(3123),
    [anon_sym_assert] = ACTIONS(3123),
    [anon_sym_upcast] = ACTIONS(3123),
    [anon_sym_downcast] = ACTIONS(3123),
    [anon_sym_COLON_GT] = ACTIONS(3125),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3125),
    [anon_sym_for] = ACTIONS(3123),
    [anon_sym_while] = ACTIONS(3123),
    [anon_sym_if] = ACTIONS(3123),
    [anon_sym_fun] = ACTIONS(3123),
    [anon_sym_DASH_GT] = ACTIONS(3123),
    [anon_sym_try] = ACTIONS(3123),
    [anon_sym_match] = ACTIONS(3123),
    [anon_sym_match_BANG] = ACTIONS(3125),
    [anon_sym_function] = ACTIONS(3123),
    [anon_sym_LT_DASH] = ACTIONS(3123),
    [anon_sym_DOT_LBRACK] = ACTIONS(3125),
    [anon_sym_LT] = ACTIONS(3125),
    [anon_sym_use] = ACTIONS(3123),
    [anon_sym_use_BANG] = ACTIONS(3125),
    [anon_sym_do_BANG] = ACTIONS(3125),
    [anon_sym_DOT_DOT] = ACTIONS(3125),
    [anon_sym_begin] = ACTIONS(3123),
    [anon_sym_LPAREN2] = ACTIONS(3123),
    [anon_sym_or] = ACTIONS(3123),
    [aux_sym_char_token1] = ACTIONS(3125),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3123),
    [anon_sym_DQUOTE] = ACTIONS(3123),
    [anon_sym_AT_DQUOTE] = ACTIONS(3125),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3125),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3125),
    [sym_bool] = ACTIONS(3123),
    [sym_unit] = ACTIONS(3125),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3123),
    [sym_op_identifier] = ACTIONS(3123),
    [anon_sym_PLUS] = ACTIONS(3123),
    [anon_sym_DASH] = ACTIONS(3123),
    [anon_sym_PLUS_DOT] = ACTIONS(3123),
    [anon_sym_DASH_DOT] = ACTIONS(3123),
    [anon_sym_PERCENT] = ACTIONS(3123),
    [anon_sym_AMP_AMP] = ACTIONS(3123),
    [anon_sym_TILDE] = ACTIONS(3125),
    [aux_sym_prefix_op_token1] = ACTIONS(3123),
    [aux_sym_infix_op_token1] = ACTIONS(3125),
    [aux_sym_infix_op_token2] = ACTIONS(3123),
    [anon_sym_PIPE_PIPE] = ACTIONS(3123),
    [anon_sym_BANG_EQ] = ACTIONS(3123),
    [anon_sym_COLON_EQ] = ACTIONS(3125),
    [anon_sym_DOLLAR] = ACTIONS(3123),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3123),
    [sym_int] = ACTIONS(3123),
    [sym_xint] = ACTIONS(3125),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3125),
    [sym__newline] = ACTIONS(3125),
  },
  [1945] = {
    [sym_block_comment] = STATE(1945),
    [sym_compiler_directive_decl] = STATE(1945),
    [sym_fsi_directive_decl] = STATE(1945),
    [sym_preproc_line] = STATE(1945),
    [sym_identifier] = ACTIONS(3139),
    [anon_sym_EQ] = ACTIONS(3141),
    [anon_sym_COLON] = ACTIONS(3139),
    [anon_sym_return] = ACTIONS(3139),
    [anon_sym_do] = ACTIONS(3139),
    [anon_sym_let] = ACTIONS(3139),
    [anon_sym_let_BANG] = ACTIONS(3141),
    [anon_sym_as] = ACTIONS(3139),
    [anon_sym_LPAREN] = ACTIONS(3139),
    [anon_sym_COMMA] = ACTIONS(3141),
    [anon_sym_null] = ACTIONS(3139),
    [anon_sym_QMARK] = ACTIONS(3139),
    [anon_sym_COLON_QMARK] = ACTIONS(3139),
    [anon_sym_COLON_COLON] = ACTIONS(3141),
    [anon_sym_AMP] = ACTIONS(3139),
    [anon_sym_LBRACK] = ACTIONS(3139),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3141),
    [anon_sym_LBRACE] = ACTIONS(3139),
    [anon_sym_LT_AT] = ACTIONS(3139),
    [anon_sym_LT_AT_AT] = ACTIONS(3139),
    [anon_sym_DOT] = ACTIONS(3139),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3141),
    [anon_sym_new] = ACTIONS(3139),
    [anon_sym_with] = ACTIONS(3139),
    [anon_sym_return_BANG] = ACTIONS(3141),
    [anon_sym_yield] = ACTIONS(3139),
    [anon_sym_yield_BANG] = ACTIONS(3141),
    [anon_sym_lazy] = ACTIONS(3139),
    [anon_sym_assert] = ACTIONS(3139),
    [anon_sym_upcast] = ACTIONS(3139),
    [anon_sym_downcast] = ACTIONS(3139),
    [anon_sym_COLON_GT] = ACTIONS(3141),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3141),
    [anon_sym_for] = ACTIONS(3139),
    [anon_sym_while] = ACTIONS(3139),
    [anon_sym_if] = ACTIONS(3139),
    [anon_sym_fun] = ACTIONS(3139),
    [anon_sym_try] = ACTIONS(3139),
    [anon_sym_match] = ACTIONS(3139),
    [anon_sym_match_BANG] = ACTIONS(3141),
    [anon_sym_function] = ACTIONS(3139),
    [anon_sym_LT_DASH] = ACTIONS(3139),
    [anon_sym_DOT_LBRACK] = ACTIONS(3141),
    [anon_sym_LT] = ACTIONS(3141),
    [anon_sym_use] = ACTIONS(3139),
    [anon_sym_use_BANG] = ACTIONS(3141),
    [anon_sym_do_BANG] = ACTIONS(3141),
    [anon_sym_begin] = ACTIONS(3139),
    [anon_sym_LPAREN2] = ACTIONS(3139),
    [anon_sym_or] = ACTIONS(3139),
    [aux_sym_char_token1] = ACTIONS(3141),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3139),
    [anon_sym_DQUOTE] = ACTIONS(3139),
    [anon_sym_AT_DQUOTE] = ACTIONS(3141),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3141),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3141),
    [sym_bool] = ACTIONS(3139),
    [sym_unit] = ACTIONS(3141),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3139),
    [sym_op_identifier] = ACTIONS(3139),
    [anon_sym_PLUS] = ACTIONS(3139),
    [anon_sym_DASH] = ACTIONS(3139),
    [anon_sym_PLUS_DOT] = ACTIONS(3139),
    [anon_sym_DASH_DOT] = ACTIONS(3139),
    [anon_sym_PERCENT] = ACTIONS(3139),
    [anon_sym_AMP_AMP] = ACTIONS(3139),
    [anon_sym_TILDE] = ACTIONS(3141),
    [aux_sym_prefix_op_token1] = ACTIONS(3139),
    [aux_sym_infix_op_token1] = ACTIONS(3141),
    [aux_sym_infix_op_token2] = ACTIONS(3139),
    [anon_sym_PIPE_PIPE] = ACTIONS(3139),
    [anon_sym_BANG_EQ] = ACTIONS(3139),
    [anon_sym_COLON_EQ] = ACTIONS(3141),
    [anon_sym_DOLLAR] = ACTIONS(3139),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3139),
    [sym_int] = ACTIONS(3139),
    [sym_xint] = ACTIONS(3141),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3141),
    [sym__newline] = ACTIONS(3141),
  },
  [1946] = {
    [sym_block_comment] = STATE(1946),
    [sym_compiler_directive_decl] = STATE(1946),
    [sym_fsi_directive_decl] = STATE(1946),
    [sym_preproc_line] = STATE(1946),
    [sym_identifier] = ACTIONS(3131),
    [anon_sym_EQ] = ACTIONS(3133),
    [anon_sym_COLON] = ACTIONS(3131),
    [anon_sym_return] = ACTIONS(3131),
    [anon_sym_do] = ACTIONS(3131),
    [anon_sym_let] = ACTIONS(3131),
    [anon_sym_let_BANG] = ACTIONS(3133),
    [anon_sym_as] = ACTIONS(3131),
    [anon_sym_LPAREN] = ACTIONS(3131),
    [anon_sym_COMMA] = ACTIONS(3133),
    [anon_sym_null] = ACTIONS(3131),
    [anon_sym_QMARK] = ACTIONS(3131),
    [anon_sym_COLON_QMARK] = ACTIONS(3131),
    [anon_sym_COLON_COLON] = ACTIONS(3133),
    [anon_sym_AMP] = ACTIONS(3131),
    [anon_sym_LBRACK] = ACTIONS(3131),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3133),
    [anon_sym_LBRACE] = ACTIONS(3131),
    [anon_sym_LT_AT] = ACTIONS(3131),
    [anon_sym_LT_AT_AT] = ACTIONS(3131),
    [anon_sym_DOT] = ACTIONS(3131),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3133),
    [anon_sym_new] = ACTIONS(3131),
    [anon_sym_with] = ACTIONS(3131),
    [anon_sym_return_BANG] = ACTIONS(3133),
    [anon_sym_yield] = ACTIONS(3131),
    [anon_sym_yield_BANG] = ACTIONS(3133),
    [anon_sym_lazy] = ACTIONS(3131),
    [anon_sym_assert] = ACTIONS(3131),
    [anon_sym_upcast] = ACTIONS(3131),
    [anon_sym_downcast] = ACTIONS(3131),
    [anon_sym_COLON_GT] = ACTIONS(3133),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3133),
    [anon_sym_for] = ACTIONS(3131),
    [anon_sym_while] = ACTIONS(3131),
    [anon_sym_if] = ACTIONS(3131),
    [anon_sym_fun] = ACTIONS(3131),
    [anon_sym_try] = ACTIONS(3131),
    [anon_sym_match] = ACTIONS(3131),
    [anon_sym_match_BANG] = ACTIONS(3133),
    [anon_sym_function] = ACTIONS(3131),
    [anon_sym_LT_DASH] = ACTIONS(3131),
    [anon_sym_DOT_LBRACK] = ACTIONS(3133),
    [anon_sym_LT] = ACTIONS(3133),
    [anon_sym_use] = ACTIONS(3131),
    [anon_sym_use_BANG] = ACTIONS(3133),
    [anon_sym_do_BANG] = ACTIONS(3133),
    [anon_sym_begin] = ACTIONS(3131),
    [anon_sym_LPAREN2] = ACTIONS(3131),
    [anon_sym_or] = ACTIONS(3131),
    [aux_sym_char_token1] = ACTIONS(3133),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3131),
    [anon_sym_DQUOTE] = ACTIONS(3131),
    [anon_sym_AT_DQUOTE] = ACTIONS(3133),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3133),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3133),
    [sym_bool] = ACTIONS(3131),
    [sym_unit] = ACTIONS(3133),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3131),
    [sym_op_identifier] = ACTIONS(3131),
    [anon_sym_PLUS] = ACTIONS(3131),
    [anon_sym_DASH] = ACTIONS(3131),
    [anon_sym_PLUS_DOT] = ACTIONS(3131),
    [anon_sym_DASH_DOT] = ACTIONS(3131),
    [anon_sym_PERCENT] = ACTIONS(3131),
    [anon_sym_AMP_AMP] = ACTIONS(3131),
    [anon_sym_TILDE] = ACTIONS(3133),
    [aux_sym_prefix_op_token1] = ACTIONS(3131),
    [aux_sym_infix_op_token1] = ACTIONS(3133),
    [aux_sym_infix_op_token2] = ACTIONS(3131),
    [anon_sym_PIPE_PIPE] = ACTIONS(3131),
    [anon_sym_BANG_EQ] = ACTIONS(3131),
    [anon_sym_COLON_EQ] = ACTIONS(3133),
    [anon_sym_DOLLAR] = ACTIONS(3131),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3131),
    [sym_int] = ACTIONS(3131),
    [sym_xint] = ACTIONS(3133),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3133),
    [sym__newline] = ACTIONS(3133),
  },
  [1947] = {
    [sym_block_comment] = STATE(1947),
    [sym_compiler_directive_decl] = STATE(1947),
    [sym_fsi_directive_decl] = STATE(1947),
    [sym_preproc_line] = STATE(1947),
    [sym_identifier] = ACTIONS(3127),
    [anon_sym_EQ] = ACTIONS(3129),
    [anon_sym_COLON] = ACTIONS(3127),
    [anon_sym_return] = ACTIONS(3127),
    [anon_sym_do] = ACTIONS(3127),
    [anon_sym_let] = ACTIONS(3127),
    [anon_sym_let_BANG] = ACTIONS(3129),
    [anon_sym_as] = ACTIONS(3127),
    [anon_sym_LPAREN] = ACTIONS(3127),
    [anon_sym_COMMA] = ACTIONS(3129),
    [anon_sym_null] = ACTIONS(3127),
    [anon_sym_QMARK] = ACTIONS(3127),
    [anon_sym_COLON_QMARK] = ACTIONS(3127),
    [anon_sym_COLON_COLON] = ACTIONS(3129),
    [anon_sym_AMP] = ACTIONS(3127),
    [anon_sym_LBRACK] = ACTIONS(3127),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3129),
    [anon_sym_LBRACE] = ACTIONS(3127),
    [anon_sym_LT_AT] = ACTIONS(3127),
    [anon_sym_LT_AT_AT] = ACTIONS(3127),
    [anon_sym_DOT] = ACTIONS(3127),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3129),
    [anon_sym_new] = ACTIONS(3127),
    [anon_sym_with] = ACTIONS(3127),
    [anon_sym_return_BANG] = ACTIONS(3129),
    [anon_sym_yield] = ACTIONS(3127),
    [anon_sym_yield_BANG] = ACTIONS(3129),
    [anon_sym_lazy] = ACTIONS(3127),
    [anon_sym_assert] = ACTIONS(3127),
    [anon_sym_upcast] = ACTIONS(3127),
    [anon_sym_downcast] = ACTIONS(3127),
    [anon_sym_COLON_GT] = ACTIONS(3129),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3129),
    [anon_sym_for] = ACTIONS(3127),
    [anon_sym_while] = ACTIONS(3127),
    [anon_sym_if] = ACTIONS(3127),
    [anon_sym_fun] = ACTIONS(3127),
    [anon_sym_try] = ACTIONS(3127),
    [anon_sym_match] = ACTIONS(3127),
    [anon_sym_match_BANG] = ACTIONS(3129),
    [anon_sym_function] = ACTIONS(3127),
    [anon_sym_LT_DASH] = ACTIONS(3127),
    [anon_sym_DOT_LBRACK] = ACTIONS(3129),
    [anon_sym_LT] = ACTIONS(3129),
    [anon_sym_use] = ACTIONS(3127),
    [anon_sym_use_BANG] = ACTIONS(3129),
    [anon_sym_do_BANG] = ACTIONS(3129),
    [anon_sym_begin] = ACTIONS(3127),
    [anon_sym_LPAREN2] = ACTIONS(3127),
    [anon_sym_or] = ACTIONS(3127),
    [aux_sym_char_token1] = ACTIONS(3129),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3127),
    [anon_sym_DQUOTE] = ACTIONS(3127),
    [anon_sym_AT_DQUOTE] = ACTIONS(3129),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3129),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3129),
    [sym_bool] = ACTIONS(3127),
    [sym_unit] = ACTIONS(3129),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3127),
    [sym_op_identifier] = ACTIONS(3127),
    [anon_sym_PLUS] = ACTIONS(3127),
    [anon_sym_DASH] = ACTIONS(3127),
    [anon_sym_PLUS_DOT] = ACTIONS(3127),
    [anon_sym_DASH_DOT] = ACTIONS(3127),
    [anon_sym_PERCENT] = ACTIONS(3127),
    [anon_sym_AMP_AMP] = ACTIONS(3127),
    [anon_sym_TILDE] = ACTIONS(3129),
    [aux_sym_prefix_op_token1] = ACTIONS(3127),
    [aux_sym_infix_op_token1] = ACTIONS(3129),
    [aux_sym_infix_op_token2] = ACTIONS(3127),
    [anon_sym_PIPE_PIPE] = ACTIONS(3127),
    [anon_sym_BANG_EQ] = ACTIONS(3127),
    [anon_sym_COLON_EQ] = ACTIONS(3129),
    [anon_sym_DOLLAR] = ACTIONS(3127),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3127),
    [sym_int] = ACTIONS(3127),
    [sym_xint] = ACTIONS(3129),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3129),
    [sym__newline] = ACTIONS(3129),
  },
  [1948] = {
    [sym_block_comment] = STATE(1948),
    [sym_compiler_directive_decl] = STATE(1948),
    [sym_fsi_directive_decl] = STATE(1948),
    [sym_preproc_line] = STATE(1948),
    [sym_identifier] = ACTIONS(3123),
    [anon_sym_EQ] = ACTIONS(3125),
    [anon_sym_COLON] = ACTIONS(3123),
    [anon_sym_return] = ACTIONS(3123),
    [anon_sym_do] = ACTIONS(3123),
    [anon_sym_let] = ACTIONS(3123),
    [anon_sym_let_BANG] = ACTIONS(3125),
    [anon_sym_as] = ACTIONS(3123),
    [anon_sym_LPAREN] = ACTIONS(3123),
    [anon_sym_COMMA] = ACTIONS(3125),
    [anon_sym_null] = ACTIONS(3123),
    [anon_sym_QMARK] = ACTIONS(3123),
    [anon_sym_COLON_QMARK] = ACTIONS(3123),
    [anon_sym_COLON_COLON] = ACTIONS(3125),
    [anon_sym_AMP] = ACTIONS(3123),
    [anon_sym_LBRACK] = ACTIONS(3123),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3125),
    [anon_sym_LBRACE] = ACTIONS(3123),
    [anon_sym_LT_AT] = ACTIONS(3123),
    [anon_sym_LT_AT_AT] = ACTIONS(3123),
    [anon_sym_DOT] = ACTIONS(3123),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3125),
    [anon_sym_new] = ACTIONS(3123),
    [anon_sym_with] = ACTIONS(3123),
    [anon_sym_return_BANG] = ACTIONS(3125),
    [anon_sym_yield] = ACTIONS(3123),
    [anon_sym_yield_BANG] = ACTIONS(3125),
    [anon_sym_lazy] = ACTIONS(3123),
    [anon_sym_assert] = ACTIONS(3123),
    [anon_sym_upcast] = ACTIONS(3123),
    [anon_sym_downcast] = ACTIONS(3123),
    [anon_sym_COLON_GT] = ACTIONS(3125),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3125),
    [anon_sym_for] = ACTIONS(3123),
    [anon_sym_while] = ACTIONS(3123),
    [anon_sym_if] = ACTIONS(3123),
    [anon_sym_fun] = ACTIONS(3123),
    [anon_sym_try] = ACTIONS(3123),
    [anon_sym_match] = ACTIONS(3123),
    [anon_sym_match_BANG] = ACTIONS(3125),
    [anon_sym_function] = ACTIONS(3123),
    [anon_sym_LT_DASH] = ACTIONS(3123),
    [anon_sym_DOT_LBRACK] = ACTIONS(3125),
    [anon_sym_LT] = ACTIONS(3125),
    [anon_sym_use] = ACTIONS(3123),
    [anon_sym_use_BANG] = ACTIONS(3125),
    [anon_sym_do_BANG] = ACTIONS(3125),
    [anon_sym_begin] = ACTIONS(3123),
    [anon_sym_LPAREN2] = ACTIONS(3123),
    [anon_sym_or] = ACTIONS(3123),
    [aux_sym_char_token1] = ACTIONS(3125),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3123),
    [anon_sym_DQUOTE] = ACTIONS(3123),
    [anon_sym_AT_DQUOTE] = ACTIONS(3125),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3125),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3125),
    [sym_bool] = ACTIONS(3123),
    [sym_unit] = ACTIONS(3125),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3123),
    [sym_op_identifier] = ACTIONS(3123),
    [anon_sym_PLUS] = ACTIONS(3123),
    [anon_sym_DASH] = ACTIONS(3123),
    [anon_sym_PLUS_DOT] = ACTIONS(3123),
    [anon_sym_DASH_DOT] = ACTIONS(3123),
    [anon_sym_PERCENT] = ACTIONS(3123),
    [anon_sym_AMP_AMP] = ACTIONS(3123),
    [anon_sym_TILDE] = ACTIONS(3125),
    [aux_sym_prefix_op_token1] = ACTIONS(3123),
    [aux_sym_infix_op_token1] = ACTIONS(3125),
    [aux_sym_infix_op_token2] = ACTIONS(3123),
    [anon_sym_PIPE_PIPE] = ACTIONS(3123),
    [anon_sym_BANG_EQ] = ACTIONS(3123),
    [anon_sym_COLON_EQ] = ACTIONS(3125),
    [anon_sym_DOLLAR] = ACTIONS(3123),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3123),
    [sym_int] = ACTIONS(3123),
    [sym_xint] = ACTIONS(3125),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3125),
    [sym__newline] = ACTIONS(3125),
  },
  [1949] = {
    [sym_block_comment] = STATE(1949),
    [sym_compiler_directive_decl] = STATE(1949),
    [sym_fsi_directive_decl] = STATE(1949),
    [sym_preproc_line] = STATE(1949),
    [sym_identifier] = ACTIONS(3127),
    [anon_sym_EQ] = ACTIONS(3129),
    [anon_sym_COLON] = ACTIONS(3127),
    [anon_sym_return] = ACTIONS(3127),
    [anon_sym_do] = ACTIONS(3127),
    [anon_sym_let] = ACTIONS(3127),
    [anon_sym_let_BANG] = ACTIONS(3129),
    [anon_sym_LPAREN] = ACTIONS(3127),
    [anon_sym_COMMA] = ACTIONS(3129),
    [anon_sym_null] = ACTIONS(3127),
    [anon_sym_QMARK] = ACTIONS(3127),
    [anon_sym_COLON_QMARK] = ACTIONS(3127),
    [anon_sym_COLON_COLON] = ACTIONS(3129),
    [anon_sym_AMP] = ACTIONS(3127),
    [anon_sym_LBRACK] = ACTIONS(3127),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3129),
    [anon_sym_LBRACE] = ACTIONS(3127),
    [anon_sym_LT_AT] = ACTIONS(3127),
    [anon_sym_LT_AT_AT] = ACTIONS(3127),
    [anon_sym_DOT] = ACTIONS(3127),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3129),
    [anon_sym_new] = ACTIONS(3127),
    [anon_sym_return_BANG] = ACTIONS(3129),
    [anon_sym_yield] = ACTIONS(3127),
    [anon_sym_yield_BANG] = ACTIONS(3129),
    [anon_sym_lazy] = ACTIONS(3127),
    [anon_sym_assert] = ACTIONS(3127),
    [anon_sym_upcast] = ACTIONS(3127),
    [anon_sym_downcast] = ACTIONS(3127),
    [anon_sym_COLON_GT] = ACTIONS(3129),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3129),
    [anon_sym_for] = ACTIONS(3127),
    [anon_sym_while] = ACTIONS(3127),
    [anon_sym_if] = ACTIONS(3127),
    [anon_sym_fun] = ACTIONS(3127),
    [anon_sym_DASH_GT] = ACTIONS(3127),
    [anon_sym_try] = ACTIONS(3127),
    [anon_sym_match] = ACTIONS(3127),
    [anon_sym_match_BANG] = ACTIONS(3129),
    [anon_sym_function] = ACTIONS(3127),
    [anon_sym_LT_DASH] = ACTIONS(3127),
    [anon_sym_DOT_LBRACK] = ACTIONS(3129),
    [anon_sym_LT] = ACTIONS(3129),
    [anon_sym_use] = ACTIONS(3127),
    [anon_sym_use_BANG] = ACTIONS(3129),
    [anon_sym_do_BANG] = ACTIONS(3129),
    [anon_sym_DOT_DOT] = ACTIONS(3129),
    [anon_sym_begin] = ACTIONS(3127),
    [anon_sym_LPAREN2] = ACTIONS(3127),
    [anon_sym_or] = ACTIONS(3127),
    [aux_sym_char_token1] = ACTIONS(3129),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3127),
    [anon_sym_DQUOTE] = ACTIONS(3127),
    [anon_sym_AT_DQUOTE] = ACTIONS(3129),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3129),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3129),
    [sym_bool] = ACTIONS(3127),
    [sym_unit] = ACTIONS(3129),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3127),
    [sym_op_identifier] = ACTIONS(3127),
    [anon_sym_PLUS] = ACTIONS(3127),
    [anon_sym_DASH] = ACTIONS(3127),
    [anon_sym_PLUS_DOT] = ACTIONS(3127),
    [anon_sym_DASH_DOT] = ACTIONS(3127),
    [anon_sym_PERCENT] = ACTIONS(3127),
    [anon_sym_AMP_AMP] = ACTIONS(3127),
    [anon_sym_TILDE] = ACTIONS(3129),
    [aux_sym_prefix_op_token1] = ACTIONS(3127),
    [aux_sym_infix_op_token1] = ACTIONS(3129),
    [aux_sym_infix_op_token2] = ACTIONS(3127),
    [anon_sym_PIPE_PIPE] = ACTIONS(3127),
    [anon_sym_BANG_EQ] = ACTIONS(3127),
    [anon_sym_COLON_EQ] = ACTIONS(3129),
    [anon_sym_DOLLAR] = ACTIONS(3127),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3127),
    [sym_int] = ACTIONS(3127),
    [sym_xint] = ACTIONS(3129),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3129),
    [sym__newline] = ACTIONS(3129),
  },
  [1950] = {
    [sym_block_comment] = STATE(1950),
    [sym_compiler_directive_decl] = STATE(1950),
    [sym_fsi_directive_decl] = STATE(1950),
    [sym_preproc_line] = STATE(1950),
    [sym_identifier] = ACTIONS(3131),
    [anon_sym_EQ] = ACTIONS(3133),
    [anon_sym_COLON] = ACTIONS(3131),
    [anon_sym_return] = ACTIONS(3131),
    [anon_sym_do] = ACTIONS(3131),
    [anon_sym_let] = ACTIONS(3131),
    [anon_sym_let_BANG] = ACTIONS(3133),
    [anon_sym_LPAREN] = ACTIONS(3131),
    [anon_sym_COMMA] = ACTIONS(3133),
    [anon_sym_null] = ACTIONS(3131),
    [anon_sym_QMARK] = ACTIONS(3131),
    [anon_sym_COLON_QMARK] = ACTIONS(3131),
    [anon_sym_COLON_COLON] = ACTIONS(3133),
    [anon_sym_AMP] = ACTIONS(3131),
    [anon_sym_LBRACK] = ACTIONS(3131),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3133),
    [anon_sym_LBRACE] = ACTIONS(3131),
    [anon_sym_LT_AT] = ACTIONS(3131),
    [anon_sym_LT_AT_AT] = ACTIONS(3131),
    [anon_sym_DOT] = ACTIONS(3131),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3133),
    [anon_sym_new] = ACTIONS(3131),
    [anon_sym_return_BANG] = ACTIONS(3133),
    [anon_sym_yield] = ACTIONS(3131),
    [anon_sym_yield_BANG] = ACTIONS(3133),
    [anon_sym_lazy] = ACTIONS(3131),
    [anon_sym_assert] = ACTIONS(3131),
    [anon_sym_upcast] = ACTIONS(3131),
    [anon_sym_downcast] = ACTIONS(3131),
    [anon_sym_COLON_GT] = ACTIONS(3133),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3133),
    [anon_sym_for] = ACTIONS(3131),
    [anon_sym_while] = ACTIONS(3131),
    [anon_sym_if] = ACTIONS(3131),
    [anon_sym_fun] = ACTIONS(3131),
    [anon_sym_DASH_GT] = ACTIONS(3131),
    [anon_sym_try] = ACTIONS(3131),
    [anon_sym_match] = ACTIONS(3131),
    [anon_sym_match_BANG] = ACTIONS(3133),
    [anon_sym_function] = ACTIONS(3131),
    [anon_sym_LT_DASH] = ACTIONS(3131),
    [anon_sym_DOT_LBRACK] = ACTIONS(3133),
    [anon_sym_LT] = ACTIONS(3133),
    [anon_sym_use] = ACTIONS(3131),
    [anon_sym_use_BANG] = ACTIONS(3133),
    [anon_sym_do_BANG] = ACTIONS(3133),
    [anon_sym_DOT_DOT] = ACTIONS(3133),
    [anon_sym_begin] = ACTIONS(3131),
    [anon_sym_LPAREN2] = ACTIONS(3131),
    [anon_sym_or] = ACTIONS(3131),
    [aux_sym_char_token1] = ACTIONS(3133),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3131),
    [anon_sym_DQUOTE] = ACTIONS(3131),
    [anon_sym_AT_DQUOTE] = ACTIONS(3133),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3133),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3133),
    [sym_bool] = ACTIONS(3131),
    [sym_unit] = ACTIONS(3133),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3131),
    [sym_op_identifier] = ACTIONS(3131),
    [anon_sym_PLUS] = ACTIONS(3131),
    [anon_sym_DASH] = ACTIONS(3131),
    [anon_sym_PLUS_DOT] = ACTIONS(3131),
    [anon_sym_DASH_DOT] = ACTIONS(3131),
    [anon_sym_PERCENT] = ACTIONS(3131),
    [anon_sym_AMP_AMP] = ACTIONS(3131),
    [anon_sym_TILDE] = ACTIONS(3133),
    [aux_sym_prefix_op_token1] = ACTIONS(3131),
    [aux_sym_infix_op_token1] = ACTIONS(3133),
    [aux_sym_infix_op_token2] = ACTIONS(3131),
    [anon_sym_PIPE_PIPE] = ACTIONS(3131),
    [anon_sym_BANG_EQ] = ACTIONS(3131),
    [anon_sym_COLON_EQ] = ACTIONS(3133),
    [anon_sym_DOLLAR] = ACTIONS(3131),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3131),
    [sym_int] = ACTIONS(3131),
    [sym_xint] = ACTIONS(3133),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3133),
    [sym__newline] = ACTIONS(3133),
  },
  [1951] = {
    [sym_block_comment] = STATE(1951),
    [sym_compiler_directive_decl] = STATE(1951),
    [sym_fsi_directive_decl] = STATE(1951),
    [sym_preproc_line] = STATE(1951),
    [sym_identifier] = ACTIONS(3139),
    [anon_sym_EQ] = ACTIONS(3141),
    [anon_sym_COLON] = ACTIONS(3139),
    [anon_sym_return] = ACTIONS(3139),
    [anon_sym_do] = ACTIONS(3139),
    [anon_sym_let] = ACTIONS(3139),
    [anon_sym_let_BANG] = ACTIONS(3141),
    [anon_sym_LPAREN] = ACTIONS(3139),
    [anon_sym_COMMA] = ACTIONS(3141),
    [anon_sym_null] = ACTIONS(3139),
    [anon_sym_QMARK] = ACTIONS(3139),
    [anon_sym_COLON_QMARK] = ACTIONS(3139),
    [anon_sym_COLON_COLON] = ACTIONS(3141),
    [anon_sym_AMP] = ACTIONS(3139),
    [anon_sym_LBRACK] = ACTIONS(3139),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3141),
    [anon_sym_LBRACE] = ACTIONS(3139),
    [anon_sym_LT_AT] = ACTIONS(3139),
    [anon_sym_LT_AT_AT] = ACTIONS(3139),
    [anon_sym_DOT] = ACTIONS(3139),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3141),
    [anon_sym_new] = ACTIONS(3139),
    [anon_sym_return_BANG] = ACTIONS(3141),
    [anon_sym_yield] = ACTIONS(3139),
    [anon_sym_yield_BANG] = ACTIONS(3141),
    [anon_sym_lazy] = ACTIONS(3139),
    [anon_sym_assert] = ACTIONS(3139),
    [anon_sym_upcast] = ACTIONS(3139),
    [anon_sym_downcast] = ACTIONS(3139),
    [anon_sym_COLON_GT] = ACTIONS(3141),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3141),
    [anon_sym_for] = ACTIONS(3139),
    [anon_sym_while] = ACTIONS(3139),
    [anon_sym_if] = ACTIONS(3139),
    [anon_sym_fun] = ACTIONS(3139),
    [anon_sym_DASH_GT] = ACTIONS(3139),
    [anon_sym_try] = ACTIONS(3139),
    [anon_sym_match] = ACTIONS(3139),
    [anon_sym_match_BANG] = ACTIONS(3141),
    [anon_sym_function] = ACTIONS(3139),
    [anon_sym_LT_DASH] = ACTIONS(3139),
    [anon_sym_DOT_LBRACK] = ACTIONS(3141),
    [anon_sym_LT] = ACTIONS(3141),
    [anon_sym_use] = ACTIONS(3139),
    [anon_sym_use_BANG] = ACTIONS(3141),
    [anon_sym_do_BANG] = ACTIONS(3141),
    [anon_sym_DOT_DOT] = ACTIONS(3141),
    [anon_sym_begin] = ACTIONS(3139),
    [anon_sym_LPAREN2] = ACTIONS(3139),
    [anon_sym_or] = ACTIONS(3139),
    [aux_sym_char_token1] = ACTIONS(3141),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3139),
    [anon_sym_DQUOTE] = ACTIONS(3139),
    [anon_sym_AT_DQUOTE] = ACTIONS(3141),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3141),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3141),
    [sym_bool] = ACTIONS(3139),
    [sym_unit] = ACTIONS(3141),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3139),
    [sym_op_identifier] = ACTIONS(3139),
    [anon_sym_PLUS] = ACTIONS(3139),
    [anon_sym_DASH] = ACTIONS(3139),
    [anon_sym_PLUS_DOT] = ACTIONS(3139),
    [anon_sym_DASH_DOT] = ACTIONS(3139),
    [anon_sym_PERCENT] = ACTIONS(3139),
    [anon_sym_AMP_AMP] = ACTIONS(3139),
    [anon_sym_TILDE] = ACTIONS(3141),
    [aux_sym_prefix_op_token1] = ACTIONS(3139),
    [aux_sym_infix_op_token1] = ACTIONS(3141),
    [aux_sym_infix_op_token2] = ACTIONS(3139),
    [anon_sym_PIPE_PIPE] = ACTIONS(3139),
    [anon_sym_BANG_EQ] = ACTIONS(3139),
    [anon_sym_COLON_EQ] = ACTIONS(3141),
    [anon_sym_DOLLAR] = ACTIONS(3139),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3139),
    [sym_int] = ACTIONS(3139),
    [sym_xint] = ACTIONS(3141),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3141),
    [sym__newline] = ACTIONS(3141),
  },
  [1952] = {
    [sym_block_comment] = STATE(1952),
    [sym_compiler_directive_decl] = STATE(1952),
    [sym_fsi_directive_decl] = STATE(1952),
    [sym_preproc_line] = STATE(1952),
    [sym_identifier] = ACTIONS(3135),
    [anon_sym_EQ] = ACTIONS(3137),
    [anon_sym_COLON] = ACTIONS(3135),
    [anon_sym_return] = ACTIONS(3135),
    [anon_sym_do] = ACTIONS(3135),
    [anon_sym_let] = ACTIONS(3135),
    [anon_sym_let_BANG] = ACTIONS(3137),
    [anon_sym_LPAREN] = ACTIONS(3135),
    [anon_sym_COMMA] = ACTIONS(3137),
    [anon_sym_null] = ACTIONS(3135),
    [anon_sym_QMARK] = ACTIONS(3135),
    [anon_sym_COLON_QMARK] = ACTIONS(3135),
    [anon_sym_COLON_COLON] = ACTIONS(3137),
    [anon_sym_AMP] = ACTIONS(3135),
    [anon_sym_LBRACK] = ACTIONS(3135),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3137),
    [anon_sym_LBRACE] = ACTIONS(3135),
    [anon_sym_LT_AT] = ACTIONS(3135),
    [anon_sym_LT_AT_AT] = ACTIONS(3135),
    [anon_sym_DOT] = ACTIONS(3135),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3137),
    [anon_sym_new] = ACTIONS(3135),
    [anon_sym_return_BANG] = ACTIONS(3137),
    [anon_sym_yield] = ACTIONS(3135),
    [anon_sym_yield_BANG] = ACTIONS(3137),
    [anon_sym_lazy] = ACTIONS(3135),
    [anon_sym_assert] = ACTIONS(3135),
    [anon_sym_upcast] = ACTIONS(3135),
    [anon_sym_downcast] = ACTIONS(3135),
    [anon_sym_COLON_GT] = ACTIONS(3137),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3137),
    [anon_sym_for] = ACTIONS(3135),
    [anon_sym_while] = ACTIONS(3135),
    [anon_sym_if] = ACTIONS(3135),
    [anon_sym_fun] = ACTIONS(3135),
    [anon_sym_DASH_GT] = ACTIONS(3135),
    [anon_sym_try] = ACTIONS(3135),
    [anon_sym_match] = ACTIONS(3135),
    [anon_sym_match_BANG] = ACTIONS(3137),
    [anon_sym_function] = ACTIONS(3135),
    [anon_sym_LT_DASH] = ACTIONS(3135),
    [anon_sym_DOT_LBRACK] = ACTIONS(3137),
    [anon_sym_LT] = ACTIONS(3137),
    [anon_sym_use] = ACTIONS(3135),
    [anon_sym_use_BANG] = ACTIONS(3137),
    [anon_sym_do_BANG] = ACTIONS(3137),
    [anon_sym_DOT_DOT] = ACTIONS(3137),
    [anon_sym_begin] = ACTIONS(3135),
    [anon_sym_LPAREN2] = ACTIONS(3135),
    [anon_sym_or] = ACTIONS(3135),
    [aux_sym_char_token1] = ACTIONS(3137),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3135),
    [anon_sym_DQUOTE] = ACTIONS(3135),
    [anon_sym_AT_DQUOTE] = ACTIONS(3137),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3137),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3137),
    [sym_bool] = ACTIONS(3135),
    [sym_unit] = ACTIONS(3137),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3135),
    [sym_op_identifier] = ACTIONS(3135),
    [anon_sym_PLUS] = ACTIONS(3135),
    [anon_sym_DASH] = ACTIONS(3135),
    [anon_sym_PLUS_DOT] = ACTIONS(3135),
    [anon_sym_DASH_DOT] = ACTIONS(3135),
    [anon_sym_PERCENT] = ACTIONS(3135),
    [anon_sym_AMP_AMP] = ACTIONS(3135),
    [anon_sym_TILDE] = ACTIONS(3137),
    [aux_sym_prefix_op_token1] = ACTIONS(3135),
    [aux_sym_infix_op_token1] = ACTIONS(3137),
    [aux_sym_infix_op_token2] = ACTIONS(3135),
    [anon_sym_PIPE_PIPE] = ACTIONS(3135),
    [anon_sym_BANG_EQ] = ACTIONS(3135),
    [anon_sym_COLON_EQ] = ACTIONS(3137),
    [anon_sym_DOLLAR] = ACTIONS(3135),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3135),
    [sym_int] = ACTIONS(3135),
    [sym_xint] = ACTIONS(3137),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3137),
    [sym__newline] = ACTIONS(3137),
  },
  [1953] = {
    [sym_block_comment] = STATE(1953),
    [sym_compiler_directive_decl] = STATE(1953),
    [sym_fsi_directive_decl] = STATE(1953),
    [sym_preproc_line] = STATE(1953),
    [sym_identifier] = ACTIONS(3091),
    [anon_sym_EQ] = ACTIONS(3093),
    [anon_sym_COLON] = ACTIONS(3091),
    [anon_sym_return] = ACTIONS(3091),
    [anon_sym_do] = ACTIONS(3091),
    [anon_sym_let] = ACTIONS(3091),
    [anon_sym_let_BANG] = ACTIONS(3093),
    [anon_sym_as] = ACTIONS(3091),
    [anon_sym_LPAREN] = ACTIONS(3091),
    [anon_sym_COMMA] = ACTIONS(3093),
    [anon_sym_null] = ACTIONS(3091),
    [anon_sym_QMARK] = ACTIONS(3091),
    [anon_sym_COLON_QMARK] = ACTIONS(3091),
    [anon_sym_COLON_COLON] = ACTIONS(3093),
    [anon_sym_AMP] = ACTIONS(3091),
    [anon_sym_LBRACK] = ACTIONS(3091),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3093),
    [anon_sym_LBRACE] = ACTIONS(3091),
    [anon_sym_LT_AT] = ACTIONS(3091),
    [anon_sym_LT_AT_AT] = ACTIONS(3091),
    [anon_sym_DOT] = ACTIONS(3091),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3093),
    [anon_sym_new] = ACTIONS(3091),
    [anon_sym_with] = ACTIONS(3091),
    [anon_sym_return_BANG] = ACTIONS(3093),
    [anon_sym_yield] = ACTIONS(3091),
    [anon_sym_yield_BANG] = ACTIONS(3093),
    [anon_sym_lazy] = ACTIONS(3091),
    [anon_sym_assert] = ACTIONS(3091),
    [anon_sym_upcast] = ACTIONS(3091),
    [anon_sym_downcast] = ACTIONS(3091),
    [anon_sym_COLON_GT] = ACTIONS(3093),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3093),
    [anon_sym_for] = ACTIONS(3091),
    [anon_sym_while] = ACTIONS(3091),
    [anon_sym_if] = ACTIONS(3091),
    [anon_sym_fun] = ACTIONS(3091),
    [anon_sym_try] = ACTIONS(3091),
    [anon_sym_match] = ACTIONS(3091),
    [anon_sym_match_BANG] = ACTIONS(3093),
    [anon_sym_function] = ACTIONS(3091),
    [anon_sym_LT_DASH] = ACTIONS(3091),
    [anon_sym_DOT_LBRACK] = ACTIONS(3093),
    [anon_sym_LT] = ACTIONS(3093),
    [anon_sym_use] = ACTIONS(3091),
    [anon_sym_use_BANG] = ACTIONS(3093),
    [anon_sym_do_BANG] = ACTIONS(3093),
    [anon_sym_begin] = ACTIONS(3091),
    [anon_sym_LPAREN2] = ACTIONS(3091),
    [anon_sym_or] = ACTIONS(3091),
    [aux_sym_char_token1] = ACTIONS(3093),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3091),
    [anon_sym_DQUOTE] = ACTIONS(3091),
    [anon_sym_AT_DQUOTE] = ACTIONS(3093),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3093),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3093),
    [sym_bool] = ACTIONS(3091),
    [sym_unit] = ACTIONS(3093),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3091),
    [sym_op_identifier] = ACTIONS(3091),
    [anon_sym_PLUS] = ACTIONS(3091),
    [anon_sym_DASH] = ACTIONS(3091),
    [anon_sym_PLUS_DOT] = ACTIONS(3091),
    [anon_sym_DASH_DOT] = ACTIONS(3091),
    [anon_sym_PERCENT] = ACTIONS(3091),
    [anon_sym_AMP_AMP] = ACTIONS(3091),
    [anon_sym_TILDE] = ACTIONS(3093),
    [aux_sym_prefix_op_token1] = ACTIONS(3091),
    [aux_sym_infix_op_token1] = ACTIONS(3093),
    [aux_sym_infix_op_token2] = ACTIONS(3091),
    [anon_sym_PIPE_PIPE] = ACTIONS(3091),
    [anon_sym_BANG_EQ] = ACTIONS(3091),
    [anon_sym_COLON_EQ] = ACTIONS(3093),
    [anon_sym_DOLLAR] = ACTIONS(3091),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3091),
    [sym_int] = ACTIONS(3091),
    [sym_xint] = ACTIONS(3093),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3093),
    [sym__newline] = ACTIONS(3093),
  },
  [1954] = {
    [sym_block_comment] = STATE(1954),
    [sym_compiler_directive_decl] = STATE(1954),
    [sym_fsi_directive_decl] = STATE(1954),
    [sym_preproc_line] = STATE(1954),
    [sym_identifier] = ACTIONS(3087),
    [anon_sym_EQ] = ACTIONS(3089),
    [anon_sym_COLON] = ACTIONS(3087),
    [anon_sym_return] = ACTIONS(3087),
    [anon_sym_do] = ACTIONS(3087),
    [anon_sym_let] = ACTIONS(3087),
    [anon_sym_let_BANG] = ACTIONS(3089),
    [anon_sym_as] = ACTIONS(3087),
    [anon_sym_LPAREN] = ACTIONS(3087),
    [anon_sym_COMMA] = ACTIONS(3089),
    [anon_sym_null] = ACTIONS(3087),
    [anon_sym_QMARK] = ACTIONS(3087),
    [anon_sym_COLON_QMARK] = ACTIONS(3087),
    [anon_sym_COLON_COLON] = ACTIONS(3089),
    [anon_sym_AMP] = ACTIONS(3087),
    [anon_sym_LBRACK] = ACTIONS(3087),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3089),
    [anon_sym_LBRACE] = ACTIONS(3087),
    [anon_sym_LT_AT] = ACTIONS(3087),
    [anon_sym_LT_AT_AT] = ACTIONS(3087),
    [anon_sym_DOT] = ACTIONS(3087),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3089),
    [anon_sym_new] = ACTIONS(3087),
    [anon_sym_with] = ACTIONS(3087),
    [anon_sym_return_BANG] = ACTIONS(3089),
    [anon_sym_yield] = ACTIONS(3087),
    [anon_sym_yield_BANG] = ACTIONS(3089),
    [anon_sym_lazy] = ACTIONS(3087),
    [anon_sym_assert] = ACTIONS(3087),
    [anon_sym_upcast] = ACTIONS(3087),
    [anon_sym_downcast] = ACTIONS(3087),
    [anon_sym_COLON_GT] = ACTIONS(3089),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3089),
    [anon_sym_for] = ACTIONS(3087),
    [anon_sym_while] = ACTIONS(3087),
    [anon_sym_if] = ACTIONS(3087),
    [anon_sym_fun] = ACTIONS(3087),
    [anon_sym_try] = ACTIONS(3087),
    [anon_sym_match] = ACTIONS(3087),
    [anon_sym_match_BANG] = ACTIONS(3089),
    [anon_sym_function] = ACTIONS(3087),
    [anon_sym_LT_DASH] = ACTIONS(3087),
    [anon_sym_DOT_LBRACK] = ACTIONS(3089),
    [anon_sym_LT] = ACTIONS(3089),
    [anon_sym_use] = ACTIONS(3087),
    [anon_sym_use_BANG] = ACTIONS(3089),
    [anon_sym_do_BANG] = ACTIONS(3089),
    [anon_sym_begin] = ACTIONS(3087),
    [anon_sym_LPAREN2] = ACTIONS(3087),
    [anon_sym_or] = ACTIONS(3087),
    [aux_sym_char_token1] = ACTIONS(3089),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3087),
    [anon_sym_DQUOTE] = ACTIONS(3087),
    [anon_sym_AT_DQUOTE] = ACTIONS(3089),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3089),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3089),
    [sym_bool] = ACTIONS(3087),
    [sym_unit] = ACTIONS(3089),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3087),
    [sym_op_identifier] = ACTIONS(3087),
    [anon_sym_PLUS] = ACTIONS(3087),
    [anon_sym_DASH] = ACTIONS(3087),
    [anon_sym_PLUS_DOT] = ACTIONS(3087),
    [anon_sym_DASH_DOT] = ACTIONS(3087),
    [anon_sym_PERCENT] = ACTIONS(3087),
    [anon_sym_AMP_AMP] = ACTIONS(3087),
    [anon_sym_TILDE] = ACTIONS(3089),
    [aux_sym_prefix_op_token1] = ACTIONS(3087),
    [aux_sym_infix_op_token1] = ACTIONS(3089),
    [aux_sym_infix_op_token2] = ACTIONS(3087),
    [anon_sym_PIPE_PIPE] = ACTIONS(3087),
    [anon_sym_BANG_EQ] = ACTIONS(3087),
    [anon_sym_COLON_EQ] = ACTIONS(3089),
    [anon_sym_DOLLAR] = ACTIONS(3087),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3087),
    [sym_int] = ACTIONS(3087),
    [sym_xint] = ACTIONS(3089),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3089),
    [sym__newline] = ACTIONS(3089),
  },
  [1955] = {
    [sym_block_comment] = STATE(1955),
    [sym_compiler_directive_decl] = STATE(1955),
    [sym_fsi_directive_decl] = STATE(1955),
    [sym_preproc_line] = STATE(1955),
    [sym_identifier] = ACTIONS(2756),
    [anon_sym_EQ] = ACTIONS(2758),
    [anon_sym_COLON] = ACTIONS(2756),
    [anon_sym_return] = ACTIONS(2756),
    [anon_sym_do] = ACTIONS(2756),
    [anon_sym_let] = ACTIONS(2756),
    [anon_sym_let_BANG] = ACTIONS(2758),
    [anon_sym_LPAREN] = ACTIONS(2756),
    [anon_sym_COMMA] = ACTIONS(2758),
    [anon_sym_null] = ACTIONS(2756),
    [anon_sym_QMARK] = ACTIONS(2756),
    [anon_sym_COLON_QMARK] = ACTIONS(2756),
    [anon_sym_COLON_COLON] = ACTIONS(2758),
    [anon_sym_PIPE] = ACTIONS(2756),
    [anon_sym_AMP] = ACTIONS(2756),
    [anon_sym_LBRACK] = ACTIONS(2756),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2758),
    [anon_sym_LBRACE] = ACTIONS(2756),
    [anon_sym_LT_AT] = ACTIONS(2756),
    [anon_sym_LT_AT_AT] = ACTIONS(2756),
    [anon_sym_DOT] = ACTIONS(2756),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2758),
    [anon_sym_new] = ACTIONS(2756),
    [anon_sym_return_BANG] = ACTIONS(2758),
    [anon_sym_yield] = ACTIONS(2756),
    [anon_sym_yield_BANG] = ACTIONS(2758),
    [anon_sym_lazy] = ACTIONS(2756),
    [anon_sym_assert] = ACTIONS(2756),
    [anon_sym_upcast] = ACTIONS(2756),
    [anon_sym_downcast] = ACTIONS(2756),
    [anon_sym_COLON_GT] = ACTIONS(2758),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2758),
    [anon_sym_for] = ACTIONS(2756),
    [anon_sym_while] = ACTIONS(2756),
    [anon_sym_if] = ACTIONS(2756),
    [anon_sym_fun] = ACTIONS(2756),
    [anon_sym_try] = ACTIONS(2756),
    [anon_sym_match] = ACTIONS(2756),
    [anon_sym_match_BANG] = ACTIONS(2758),
    [anon_sym_function] = ACTIONS(2756),
    [anon_sym_LT_DASH] = ACTIONS(2756),
    [anon_sym_DOT_LBRACK] = ACTIONS(2758),
    [anon_sym_LT] = ACTIONS(2758),
    [anon_sym_GT] = ACTIONS(2756),
    [anon_sym_use] = ACTIONS(2756),
    [anon_sym_use_BANG] = ACTIONS(2758),
    [anon_sym_do_BANG] = ACTIONS(2758),
    [anon_sym_begin] = ACTIONS(2756),
    [anon_sym_LPAREN2] = ACTIONS(2756),
    [anon_sym_or] = ACTIONS(2756),
    [aux_sym_char_token1] = ACTIONS(2758),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2756),
    [anon_sym_DQUOTE] = ACTIONS(2756),
    [anon_sym_AT_DQUOTE] = ACTIONS(2758),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2758),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2758),
    [sym_bool] = ACTIONS(2756),
    [sym_unit] = ACTIONS(2758),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2756),
    [sym_op_identifier] = ACTIONS(2756),
    [anon_sym_PLUS] = ACTIONS(2756),
    [anon_sym_DASH] = ACTIONS(2756),
    [anon_sym_PLUS_DOT] = ACTIONS(2756),
    [anon_sym_DASH_DOT] = ACTIONS(2756),
    [anon_sym_PERCENT] = ACTIONS(2756),
    [anon_sym_AMP_AMP] = ACTIONS(2756),
    [anon_sym_TILDE] = ACTIONS(2758),
    [aux_sym_prefix_op_token1] = ACTIONS(2756),
    [aux_sym_infix_op_token1] = ACTIONS(2758),
    [aux_sym_infix_op_token2] = ACTIONS(2756),
    [anon_sym_PIPE_PIPE] = ACTIONS(2756),
    [anon_sym_BANG_EQ] = ACTIONS(2756),
    [anon_sym_COLON_EQ] = ACTIONS(2758),
    [anon_sym_DOLLAR] = ACTIONS(2756),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2756),
    [sym_int] = ACTIONS(2756),
    [sym_xint] = ACTIONS(2758),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2758),
    [sym__newline] = ACTIONS(2758),
  },
  [1956] = {
    [sym_block_comment] = STATE(1956),
    [sym_compiler_directive_decl] = STATE(1956),
    [sym_fsi_directive_decl] = STATE(1956),
    [sym_preproc_line] = STATE(1956),
    [sym_identifier] = ACTIONS(3119),
    [anon_sym_EQ] = ACTIONS(3121),
    [anon_sym_COLON] = ACTIONS(3119),
    [anon_sym_return] = ACTIONS(3119),
    [anon_sym_do] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_let_BANG] = ACTIONS(3121),
    [anon_sym_LPAREN] = ACTIONS(3119),
    [anon_sym_COMMA] = ACTIONS(3121),
    [anon_sym_null] = ACTIONS(3119),
    [anon_sym_QMARK] = ACTIONS(3119),
    [anon_sym_COLON_QMARK] = ACTIONS(3119),
    [anon_sym_COLON_COLON] = ACTIONS(3121),
    [anon_sym_AMP] = ACTIONS(3119),
    [anon_sym_LBRACK] = ACTIONS(3119),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3121),
    [anon_sym_LBRACE] = ACTIONS(3119),
    [anon_sym_LT_AT] = ACTIONS(3119),
    [anon_sym_LT_AT_AT] = ACTIONS(3119),
    [anon_sym_DOT] = ACTIONS(3119),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3121),
    [anon_sym_new] = ACTIONS(3119),
    [anon_sym_return_BANG] = ACTIONS(3121),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_yield_BANG] = ACTIONS(3121),
    [anon_sym_lazy] = ACTIONS(3119),
    [anon_sym_assert] = ACTIONS(3119),
    [anon_sym_upcast] = ACTIONS(3119),
    [anon_sym_downcast] = ACTIONS(3119),
    [anon_sym_COLON_GT] = ACTIONS(3121),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3121),
    [anon_sym_for] = ACTIONS(3119),
    [anon_sym_while] = ACTIONS(3119),
    [anon_sym_if] = ACTIONS(3119),
    [anon_sym_fun] = ACTIONS(3119),
    [anon_sym_DASH_GT] = ACTIONS(3119),
    [anon_sym_try] = ACTIONS(3119),
    [anon_sym_match] = ACTIONS(3119),
    [anon_sym_match_BANG] = ACTIONS(3121),
    [anon_sym_function] = ACTIONS(3119),
    [anon_sym_LT_DASH] = ACTIONS(3119),
    [anon_sym_DOT_LBRACK] = ACTIONS(3121),
    [anon_sym_LT] = ACTIONS(3121),
    [anon_sym_use] = ACTIONS(3119),
    [anon_sym_use_BANG] = ACTIONS(3121),
    [anon_sym_do_BANG] = ACTIONS(3121),
    [anon_sym_DOT_DOT] = ACTIONS(3121),
    [anon_sym_begin] = ACTIONS(3119),
    [anon_sym_LPAREN2] = ACTIONS(3119),
    [anon_sym_or] = ACTIONS(3119),
    [aux_sym_char_token1] = ACTIONS(3121),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3119),
    [anon_sym_DQUOTE] = ACTIONS(3119),
    [anon_sym_AT_DQUOTE] = ACTIONS(3121),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3121),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3121),
    [sym_bool] = ACTIONS(3119),
    [sym_unit] = ACTIONS(3121),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3119),
    [sym_op_identifier] = ACTIONS(3119),
    [anon_sym_PLUS] = ACTIONS(3119),
    [anon_sym_DASH] = ACTIONS(3119),
    [anon_sym_PLUS_DOT] = ACTIONS(3119),
    [anon_sym_DASH_DOT] = ACTIONS(3119),
    [anon_sym_PERCENT] = ACTIONS(3119),
    [anon_sym_AMP_AMP] = ACTIONS(3119),
    [anon_sym_TILDE] = ACTIONS(3121),
    [aux_sym_prefix_op_token1] = ACTIONS(3119),
    [aux_sym_infix_op_token1] = ACTIONS(3121),
    [aux_sym_infix_op_token2] = ACTIONS(3119),
    [anon_sym_PIPE_PIPE] = ACTIONS(3119),
    [anon_sym_BANG_EQ] = ACTIONS(3119),
    [anon_sym_COLON_EQ] = ACTIONS(3121),
    [anon_sym_DOLLAR] = ACTIONS(3119),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3119),
    [sym_int] = ACTIONS(3119),
    [sym_xint] = ACTIONS(3121),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3121),
    [sym__newline] = ACTIONS(3121),
  },
  [1957] = {
    [sym_block_comment] = STATE(1957),
    [sym_compiler_directive_decl] = STATE(1957),
    [sym_fsi_directive_decl] = STATE(1957),
    [sym_preproc_line] = STATE(1957),
    [sym_identifier] = ACTIONS(2835),
    [anon_sym_EQ] = ACTIONS(2837),
    [anon_sym_COLON] = ACTIONS(2835),
    [anon_sym_return] = ACTIONS(2835),
    [anon_sym_do] = ACTIONS(2835),
    [anon_sym_let] = ACTIONS(2835),
    [anon_sym_let_BANG] = ACTIONS(2837),
    [anon_sym_LPAREN] = ACTIONS(2835),
    [anon_sym_COMMA] = ACTIONS(2837),
    [anon_sym_null] = ACTIONS(2835),
    [anon_sym_QMARK] = ACTIONS(2835),
    [anon_sym_COLON_QMARK] = ACTIONS(2835),
    [anon_sym_COLON_COLON] = ACTIONS(2837),
    [anon_sym_AMP] = ACTIONS(2835),
    [anon_sym_LBRACK] = ACTIONS(2835),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2837),
    [anon_sym_LBRACE] = ACTIONS(2835),
    [anon_sym_LT_AT] = ACTIONS(2835),
    [anon_sym_LT_AT_AT] = ACTIONS(2835),
    [anon_sym_DOT] = ACTIONS(2835),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2837),
    [anon_sym_new] = ACTIONS(2835),
    [anon_sym_return_BANG] = ACTIONS(2837),
    [anon_sym_yield] = ACTIONS(2835),
    [anon_sym_yield_BANG] = ACTIONS(2837),
    [anon_sym_lazy] = ACTIONS(2835),
    [anon_sym_assert] = ACTIONS(2835),
    [anon_sym_upcast] = ACTIONS(2835),
    [anon_sym_downcast] = ACTIONS(2835),
    [anon_sym_COLON_GT] = ACTIONS(2837),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2837),
    [anon_sym_for] = ACTIONS(2835),
    [anon_sym_while] = ACTIONS(2835),
    [anon_sym_if] = ACTIONS(2835),
    [anon_sym_fun] = ACTIONS(2835),
    [anon_sym_DASH_GT] = ACTIONS(2835),
    [anon_sym_try] = ACTIONS(2835),
    [anon_sym_match] = ACTIONS(2835),
    [anon_sym_match_BANG] = ACTIONS(2837),
    [anon_sym_function] = ACTIONS(2835),
    [anon_sym_LT_DASH] = ACTIONS(2835),
    [anon_sym_DOT_LBRACK] = ACTIONS(2837),
    [anon_sym_LT] = ACTIONS(2837),
    [anon_sym_use] = ACTIONS(2835),
    [anon_sym_use_BANG] = ACTIONS(2837),
    [anon_sym_do_BANG] = ACTIONS(2837),
    [anon_sym_DOT_DOT] = ACTIONS(2837),
    [anon_sym_begin] = ACTIONS(2835),
    [anon_sym_LPAREN2] = ACTIONS(2835),
    [anon_sym_or] = ACTIONS(2835),
    [aux_sym_char_token1] = ACTIONS(2837),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2835),
    [anon_sym_DQUOTE] = ACTIONS(2835),
    [anon_sym_AT_DQUOTE] = ACTIONS(2837),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2837),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2837),
    [sym_bool] = ACTIONS(2835),
    [sym_unit] = ACTIONS(2837),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2835),
    [sym_op_identifier] = ACTIONS(2835),
    [anon_sym_PLUS] = ACTIONS(2835),
    [anon_sym_DASH] = ACTIONS(2835),
    [anon_sym_PLUS_DOT] = ACTIONS(2835),
    [anon_sym_DASH_DOT] = ACTIONS(2835),
    [anon_sym_PERCENT] = ACTIONS(2835),
    [anon_sym_AMP_AMP] = ACTIONS(2835),
    [anon_sym_TILDE] = ACTIONS(2837),
    [aux_sym_prefix_op_token1] = ACTIONS(2835),
    [aux_sym_infix_op_token1] = ACTIONS(2837),
    [aux_sym_infix_op_token2] = ACTIONS(2835),
    [anon_sym_PIPE_PIPE] = ACTIONS(2835),
    [anon_sym_BANG_EQ] = ACTIONS(2835),
    [anon_sym_COLON_EQ] = ACTIONS(2837),
    [anon_sym_DOLLAR] = ACTIONS(2835),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2835),
    [sym_int] = ACTIONS(2835),
    [sym_xint] = ACTIONS(2837),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2837),
    [sym__newline] = ACTIONS(2837),
  },
  [1958] = {
    [sym_block_comment] = STATE(1958),
    [sym_compiler_directive_decl] = STATE(1958),
    [sym_fsi_directive_decl] = STATE(1958),
    [sym_preproc_line] = STATE(1958),
    [sym_identifier] = ACTIONS(2934),
    [anon_sym_EQ] = ACTIONS(2936),
    [anon_sym_COLON] = ACTIONS(2934),
    [anon_sym_return] = ACTIONS(2934),
    [anon_sym_do] = ACTIONS(2934),
    [anon_sym_and] = ACTIONS(2934),
    [anon_sym_let] = ACTIONS(2934),
    [anon_sym_let_BANG] = ACTIONS(2936),
    [anon_sym_LPAREN] = ACTIONS(2934),
    [anon_sym_COMMA] = ACTIONS(2936),
    [anon_sym_null] = ACTIONS(2934),
    [anon_sym_QMARK] = ACTIONS(2934),
    [anon_sym_COLON_QMARK] = ACTIONS(2934),
    [anon_sym_COLON_COLON] = ACTIONS(2936),
    [anon_sym_AMP] = ACTIONS(2934),
    [anon_sym_LBRACK] = ACTIONS(2934),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2936),
    [anon_sym_LBRACE] = ACTIONS(2934),
    [anon_sym_LT_AT] = ACTIONS(2934),
    [anon_sym_LT_AT_AT] = ACTIONS(2934),
    [anon_sym_DOT] = ACTIONS(2934),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2936),
    [anon_sym_new] = ACTIONS(2934),
    [anon_sym_return_BANG] = ACTIONS(2936),
    [anon_sym_yield] = ACTIONS(2934),
    [anon_sym_yield_BANG] = ACTIONS(2936),
    [anon_sym_lazy] = ACTIONS(2934),
    [anon_sym_assert] = ACTIONS(2934),
    [anon_sym_upcast] = ACTIONS(2934),
    [anon_sym_downcast] = ACTIONS(2934),
    [anon_sym_COLON_GT] = ACTIONS(2936),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2936),
    [anon_sym_for] = ACTIONS(2934),
    [anon_sym_while] = ACTIONS(2934),
    [anon_sym_if] = ACTIONS(2934),
    [anon_sym_fun] = ACTIONS(2934),
    [anon_sym_try] = ACTIONS(2934),
    [anon_sym_match] = ACTIONS(2934),
    [anon_sym_match_BANG] = ACTIONS(2936),
    [anon_sym_function] = ACTIONS(2934),
    [anon_sym_LT_DASH] = ACTIONS(2934),
    [anon_sym_DOT_LBRACK] = ACTIONS(2936),
    [anon_sym_LT] = ACTIONS(2936),
    [anon_sym_use] = ACTIONS(2934),
    [anon_sym_use_BANG] = ACTIONS(2936),
    [anon_sym_do_BANG] = ACTIONS(2936),
    [anon_sym_begin] = ACTIONS(2934),
    [anon_sym_LPAREN2] = ACTIONS(2934),
    [anon_sym_or] = ACTIONS(2934),
    [aux_sym_char_token1] = ACTIONS(2936),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2934),
    [anon_sym_DQUOTE] = ACTIONS(2934),
    [anon_sym_AT_DQUOTE] = ACTIONS(2936),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2936),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2936),
    [sym_bool] = ACTIONS(2934),
    [sym_unit] = ACTIONS(2936),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2934),
    [sym_op_identifier] = ACTIONS(2934),
    [anon_sym_PLUS] = ACTIONS(2934),
    [anon_sym_DASH] = ACTIONS(2934),
    [anon_sym_PLUS_DOT] = ACTIONS(2934),
    [anon_sym_DASH_DOT] = ACTIONS(2934),
    [anon_sym_PERCENT] = ACTIONS(2934),
    [anon_sym_AMP_AMP] = ACTIONS(2934),
    [anon_sym_TILDE] = ACTIONS(2936),
    [aux_sym_prefix_op_token1] = ACTIONS(2934),
    [aux_sym_infix_op_token1] = ACTIONS(2936),
    [aux_sym_infix_op_token2] = ACTIONS(2934),
    [anon_sym_PIPE_PIPE] = ACTIONS(2934),
    [anon_sym_BANG_EQ] = ACTIONS(2934),
    [anon_sym_COLON_EQ] = ACTIONS(2936),
    [anon_sym_DOLLAR] = ACTIONS(2934),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2934),
    [sym_int] = ACTIONS(2934),
    [sym_xint] = ACTIONS(2936),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2936),
    [sym__newline] = ACTIONS(2936),
    [sym__dedent] = ACTIONS(2936),
  },
  [1959] = {
    [sym_block_comment] = STATE(1959),
    [sym_compiler_directive_decl] = STATE(1959),
    [sym_fsi_directive_decl] = STATE(1959),
    [sym_preproc_line] = STATE(1959),
    [sym_identifier] = ACTIONS(3111),
    [anon_sym_EQ] = ACTIONS(3113),
    [anon_sym_COLON] = ACTIONS(3111),
    [anon_sym_return] = ACTIONS(3111),
    [anon_sym_do] = ACTIONS(3111),
    [anon_sym_let] = ACTIONS(3111),
    [anon_sym_let_BANG] = ACTIONS(3113),
    [anon_sym_LPAREN] = ACTIONS(3111),
    [anon_sym_COMMA] = ACTIONS(3113),
    [anon_sym_null] = ACTIONS(3111),
    [anon_sym_QMARK] = ACTIONS(3111),
    [anon_sym_COLON_QMARK] = ACTIONS(3111),
    [anon_sym_COLON_COLON] = ACTIONS(3113),
    [anon_sym_AMP] = ACTIONS(3111),
    [anon_sym_LBRACK] = ACTIONS(3111),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3113),
    [anon_sym_LBRACE] = ACTIONS(3111),
    [anon_sym_LT_AT] = ACTIONS(3111),
    [anon_sym_LT_AT_AT] = ACTIONS(3111),
    [anon_sym_DOT] = ACTIONS(3111),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3113),
    [anon_sym_new] = ACTIONS(3111),
    [anon_sym_return_BANG] = ACTIONS(3113),
    [anon_sym_yield] = ACTIONS(3111),
    [anon_sym_yield_BANG] = ACTIONS(3113),
    [anon_sym_lazy] = ACTIONS(3111),
    [anon_sym_assert] = ACTIONS(3111),
    [anon_sym_upcast] = ACTIONS(3111),
    [anon_sym_downcast] = ACTIONS(3111),
    [anon_sym_COLON_GT] = ACTIONS(3113),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3113),
    [anon_sym_for] = ACTIONS(3111),
    [anon_sym_while] = ACTIONS(3111),
    [anon_sym_if] = ACTIONS(3111),
    [anon_sym_fun] = ACTIONS(3111),
    [anon_sym_DASH_GT] = ACTIONS(3111),
    [anon_sym_try] = ACTIONS(3111),
    [anon_sym_match] = ACTIONS(3111),
    [anon_sym_match_BANG] = ACTIONS(3113),
    [anon_sym_function] = ACTIONS(3111),
    [anon_sym_LT_DASH] = ACTIONS(3111),
    [anon_sym_DOT_LBRACK] = ACTIONS(3113),
    [anon_sym_LT] = ACTIONS(3113),
    [anon_sym_use] = ACTIONS(3111),
    [anon_sym_use_BANG] = ACTIONS(3113),
    [anon_sym_do_BANG] = ACTIONS(3113),
    [anon_sym_DOT_DOT] = ACTIONS(3113),
    [anon_sym_begin] = ACTIONS(3111),
    [anon_sym_LPAREN2] = ACTIONS(3111),
    [anon_sym_or] = ACTIONS(3111),
    [aux_sym_char_token1] = ACTIONS(3113),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3111),
    [anon_sym_DQUOTE] = ACTIONS(3111),
    [anon_sym_AT_DQUOTE] = ACTIONS(3113),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3113),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3113),
    [sym_bool] = ACTIONS(3111),
    [sym_unit] = ACTIONS(3113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3111),
    [sym_op_identifier] = ACTIONS(3111),
    [anon_sym_PLUS] = ACTIONS(3111),
    [anon_sym_DASH] = ACTIONS(3111),
    [anon_sym_PLUS_DOT] = ACTIONS(3111),
    [anon_sym_DASH_DOT] = ACTIONS(3111),
    [anon_sym_PERCENT] = ACTIONS(3111),
    [anon_sym_AMP_AMP] = ACTIONS(3111),
    [anon_sym_TILDE] = ACTIONS(3113),
    [aux_sym_prefix_op_token1] = ACTIONS(3111),
    [aux_sym_infix_op_token1] = ACTIONS(3113),
    [aux_sym_infix_op_token2] = ACTIONS(3111),
    [anon_sym_PIPE_PIPE] = ACTIONS(3111),
    [anon_sym_BANG_EQ] = ACTIONS(3111),
    [anon_sym_COLON_EQ] = ACTIONS(3113),
    [anon_sym_DOLLAR] = ACTIONS(3111),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3111),
    [sym_int] = ACTIONS(3111),
    [sym_xint] = ACTIONS(3113),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3113),
    [sym__newline] = ACTIONS(3113),
  },
  [1960] = {
    [sym_block_comment] = STATE(1960),
    [sym_compiler_directive_decl] = STATE(1960),
    [sym_fsi_directive_decl] = STATE(1960),
    [sym_preproc_line] = STATE(1960),
    [sym_identifier] = ACTIONS(3075),
    [anon_sym_EQ] = ACTIONS(3077),
    [anon_sym_COLON] = ACTIONS(3075),
    [anon_sym_return] = ACTIONS(3075),
    [anon_sym_do] = ACTIONS(3075),
    [anon_sym_let] = ACTIONS(3075),
    [anon_sym_let_BANG] = ACTIONS(3077),
    [anon_sym_as] = ACTIONS(3075),
    [anon_sym_LPAREN] = ACTIONS(3075),
    [anon_sym_COMMA] = ACTIONS(3077),
    [anon_sym_null] = ACTIONS(3075),
    [anon_sym_QMARK] = ACTIONS(3075),
    [anon_sym_COLON_QMARK] = ACTIONS(3075),
    [anon_sym_COLON_COLON] = ACTIONS(3077),
    [anon_sym_AMP] = ACTIONS(3075),
    [anon_sym_LBRACK] = ACTIONS(3075),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3077),
    [anon_sym_LBRACE] = ACTIONS(3075),
    [anon_sym_LT_AT] = ACTIONS(3075),
    [anon_sym_LT_AT_AT] = ACTIONS(3075),
    [anon_sym_DOT] = ACTIONS(3075),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3077),
    [anon_sym_new] = ACTIONS(3075),
    [anon_sym_with] = ACTIONS(3075),
    [anon_sym_return_BANG] = ACTIONS(3077),
    [anon_sym_yield] = ACTIONS(3075),
    [anon_sym_yield_BANG] = ACTIONS(3077),
    [anon_sym_lazy] = ACTIONS(3075),
    [anon_sym_assert] = ACTIONS(3075),
    [anon_sym_upcast] = ACTIONS(3075),
    [anon_sym_downcast] = ACTIONS(3075),
    [anon_sym_COLON_GT] = ACTIONS(3077),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3077),
    [anon_sym_for] = ACTIONS(3075),
    [anon_sym_while] = ACTIONS(3075),
    [anon_sym_if] = ACTIONS(3075),
    [anon_sym_fun] = ACTIONS(3075),
    [anon_sym_try] = ACTIONS(3075),
    [anon_sym_match] = ACTIONS(3075),
    [anon_sym_match_BANG] = ACTIONS(3077),
    [anon_sym_function] = ACTIONS(3075),
    [anon_sym_LT_DASH] = ACTIONS(3075),
    [anon_sym_DOT_LBRACK] = ACTIONS(3077),
    [anon_sym_LT] = ACTIONS(3077),
    [anon_sym_use] = ACTIONS(3075),
    [anon_sym_use_BANG] = ACTIONS(3077),
    [anon_sym_do_BANG] = ACTIONS(3077),
    [anon_sym_begin] = ACTIONS(3075),
    [anon_sym_LPAREN2] = ACTIONS(3075),
    [anon_sym_or] = ACTIONS(3075),
    [aux_sym_char_token1] = ACTIONS(3077),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3075),
    [anon_sym_DQUOTE] = ACTIONS(3075),
    [anon_sym_AT_DQUOTE] = ACTIONS(3077),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3077),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3077),
    [sym_bool] = ACTIONS(3075),
    [sym_unit] = ACTIONS(3077),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3075),
    [sym_op_identifier] = ACTIONS(3075),
    [anon_sym_PLUS] = ACTIONS(3075),
    [anon_sym_DASH] = ACTIONS(3075),
    [anon_sym_PLUS_DOT] = ACTIONS(3075),
    [anon_sym_DASH_DOT] = ACTIONS(3075),
    [anon_sym_PERCENT] = ACTIONS(3075),
    [anon_sym_AMP_AMP] = ACTIONS(3075),
    [anon_sym_TILDE] = ACTIONS(3077),
    [aux_sym_prefix_op_token1] = ACTIONS(3075),
    [aux_sym_infix_op_token1] = ACTIONS(3077),
    [aux_sym_infix_op_token2] = ACTIONS(3075),
    [anon_sym_PIPE_PIPE] = ACTIONS(3075),
    [anon_sym_BANG_EQ] = ACTIONS(3075),
    [anon_sym_COLON_EQ] = ACTIONS(3077),
    [anon_sym_DOLLAR] = ACTIONS(3075),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3075),
    [sym_int] = ACTIONS(3075),
    [sym_xint] = ACTIONS(3077),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3077),
    [sym__newline] = ACTIONS(3077),
  },
  [1961] = {
    [sym_block_comment] = STATE(1961),
    [sym_compiler_directive_decl] = STATE(1961),
    [sym_fsi_directive_decl] = STATE(1961),
    [sym_preproc_line] = STATE(1961),
    [sym_identifier] = ACTIONS(3071),
    [anon_sym_EQ] = ACTIONS(3073),
    [anon_sym_COLON] = ACTIONS(3071),
    [anon_sym_return] = ACTIONS(3071),
    [anon_sym_do] = ACTIONS(3071),
    [anon_sym_let] = ACTIONS(3071),
    [anon_sym_let_BANG] = ACTIONS(3073),
    [anon_sym_as] = ACTIONS(3071),
    [anon_sym_LPAREN] = ACTIONS(3071),
    [anon_sym_COMMA] = ACTIONS(3073),
    [anon_sym_null] = ACTIONS(3071),
    [anon_sym_QMARK] = ACTIONS(3071),
    [anon_sym_COLON_QMARK] = ACTIONS(3071),
    [anon_sym_COLON_COLON] = ACTIONS(3073),
    [anon_sym_AMP] = ACTIONS(3071),
    [anon_sym_LBRACK] = ACTIONS(3071),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3073),
    [anon_sym_LBRACE] = ACTIONS(3071),
    [anon_sym_LT_AT] = ACTIONS(3071),
    [anon_sym_LT_AT_AT] = ACTIONS(3071),
    [anon_sym_DOT] = ACTIONS(3071),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3073),
    [anon_sym_new] = ACTIONS(3071),
    [anon_sym_with] = ACTIONS(3071),
    [anon_sym_return_BANG] = ACTIONS(3073),
    [anon_sym_yield] = ACTIONS(3071),
    [anon_sym_yield_BANG] = ACTIONS(3073),
    [anon_sym_lazy] = ACTIONS(3071),
    [anon_sym_assert] = ACTIONS(3071),
    [anon_sym_upcast] = ACTIONS(3071),
    [anon_sym_downcast] = ACTIONS(3071),
    [anon_sym_COLON_GT] = ACTIONS(3073),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3073),
    [anon_sym_for] = ACTIONS(3071),
    [anon_sym_while] = ACTIONS(3071),
    [anon_sym_if] = ACTIONS(3071),
    [anon_sym_fun] = ACTIONS(3071),
    [anon_sym_try] = ACTIONS(3071),
    [anon_sym_match] = ACTIONS(3071),
    [anon_sym_match_BANG] = ACTIONS(3073),
    [anon_sym_function] = ACTIONS(3071),
    [anon_sym_LT_DASH] = ACTIONS(3071),
    [anon_sym_DOT_LBRACK] = ACTIONS(3073),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_use] = ACTIONS(3071),
    [anon_sym_use_BANG] = ACTIONS(3073),
    [anon_sym_do_BANG] = ACTIONS(3073),
    [anon_sym_begin] = ACTIONS(3071),
    [anon_sym_LPAREN2] = ACTIONS(3071),
    [anon_sym_or] = ACTIONS(3071),
    [aux_sym_char_token1] = ACTIONS(3073),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3071),
    [anon_sym_DQUOTE] = ACTIONS(3071),
    [anon_sym_AT_DQUOTE] = ACTIONS(3073),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3073),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3073),
    [sym_bool] = ACTIONS(3071),
    [sym_unit] = ACTIONS(3073),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3071),
    [sym_op_identifier] = ACTIONS(3071),
    [anon_sym_PLUS] = ACTIONS(3071),
    [anon_sym_DASH] = ACTIONS(3071),
    [anon_sym_PLUS_DOT] = ACTIONS(3071),
    [anon_sym_DASH_DOT] = ACTIONS(3071),
    [anon_sym_PERCENT] = ACTIONS(3071),
    [anon_sym_AMP_AMP] = ACTIONS(3071),
    [anon_sym_TILDE] = ACTIONS(3073),
    [aux_sym_prefix_op_token1] = ACTIONS(3071),
    [aux_sym_infix_op_token1] = ACTIONS(3073),
    [aux_sym_infix_op_token2] = ACTIONS(3071),
    [anon_sym_PIPE_PIPE] = ACTIONS(3071),
    [anon_sym_BANG_EQ] = ACTIONS(3071),
    [anon_sym_COLON_EQ] = ACTIONS(3073),
    [anon_sym_DOLLAR] = ACTIONS(3071),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3071),
    [sym_int] = ACTIONS(3071),
    [sym_xint] = ACTIONS(3073),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3073),
    [sym__newline] = ACTIONS(3073),
  },
  [1962] = {
    [sym_block_comment] = STATE(1962),
    [sym_compiler_directive_decl] = STATE(1962),
    [sym_fsi_directive_decl] = STATE(1962),
    [sym_preproc_line] = STATE(1962),
    [sym_identifier] = ACTIONS(3067),
    [anon_sym_EQ] = ACTIONS(3069),
    [anon_sym_COLON] = ACTIONS(3067),
    [anon_sym_return] = ACTIONS(3067),
    [anon_sym_do] = ACTIONS(3067),
    [anon_sym_let] = ACTIONS(3067),
    [anon_sym_let_BANG] = ACTIONS(3069),
    [anon_sym_as] = ACTIONS(3067),
    [anon_sym_LPAREN] = ACTIONS(3067),
    [anon_sym_COMMA] = ACTIONS(3069),
    [anon_sym_null] = ACTIONS(3067),
    [anon_sym_QMARK] = ACTIONS(3067),
    [anon_sym_COLON_QMARK] = ACTIONS(3067),
    [anon_sym_COLON_COLON] = ACTIONS(3069),
    [anon_sym_AMP] = ACTIONS(3067),
    [anon_sym_LBRACK] = ACTIONS(3067),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3069),
    [anon_sym_LBRACE] = ACTIONS(3067),
    [anon_sym_LT_AT] = ACTIONS(3067),
    [anon_sym_LT_AT_AT] = ACTIONS(3067),
    [anon_sym_DOT] = ACTIONS(3067),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3069),
    [anon_sym_new] = ACTIONS(3067),
    [anon_sym_with] = ACTIONS(3067),
    [anon_sym_return_BANG] = ACTIONS(3069),
    [anon_sym_yield] = ACTIONS(3067),
    [anon_sym_yield_BANG] = ACTIONS(3069),
    [anon_sym_lazy] = ACTIONS(3067),
    [anon_sym_assert] = ACTIONS(3067),
    [anon_sym_upcast] = ACTIONS(3067),
    [anon_sym_downcast] = ACTIONS(3067),
    [anon_sym_COLON_GT] = ACTIONS(3069),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3069),
    [anon_sym_for] = ACTIONS(3067),
    [anon_sym_while] = ACTIONS(3067),
    [anon_sym_if] = ACTIONS(3067),
    [anon_sym_fun] = ACTIONS(3067),
    [anon_sym_try] = ACTIONS(3067),
    [anon_sym_match] = ACTIONS(3067),
    [anon_sym_match_BANG] = ACTIONS(3069),
    [anon_sym_function] = ACTIONS(3067),
    [anon_sym_LT_DASH] = ACTIONS(3067),
    [anon_sym_DOT_LBRACK] = ACTIONS(3069),
    [anon_sym_LT] = ACTIONS(3069),
    [anon_sym_use] = ACTIONS(3067),
    [anon_sym_use_BANG] = ACTIONS(3069),
    [anon_sym_do_BANG] = ACTIONS(3069),
    [anon_sym_begin] = ACTIONS(3067),
    [anon_sym_LPAREN2] = ACTIONS(3067),
    [anon_sym_or] = ACTIONS(3067),
    [aux_sym_char_token1] = ACTIONS(3069),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3067),
    [anon_sym_DQUOTE] = ACTIONS(3067),
    [anon_sym_AT_DQUOTE] = ACTIONS(3069),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3069),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3069),
    [sym_bool] = ACTIONS(3067),
    [sym_unit] = ACTIONS(3069),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3067),
    [sym_op_identifier] = ACTIONS(3067),
    [anon_sym_PLUS] = ACTIONS(3067),
    [anon_sym_DASH] = ACTIONS(3067),
    [anon_sym_PLUS_DOT] = ACTIONS(3067),
    [anon_sym_DASH_DOT] = ACTIONS(3067),
    [anon_sym_PERCENT] = ACTIONS(3067),
    [anon_sym_AMP_AMP] = ACTIONS(3067),
    [anon_sym_TILDE] = ACTIONS(3069),
    [aux_sym_prefix_op_token1] = ACTIONS(3067),
    [aux_sym_infix_op_token1] = ACTIONS(3069),
    [aux_sym_infix_op_token2] = ACTIONS(3067),
    [anon_sym_PIPE_PIPE] = ACTIONS(3067),
    [anon_sym_BANG_EQ] = ACTIONS(3067),
    [anon_sym_COLON_EQ] = ACTIONS(3069),
    [anon_sym_DOLLAR] = ACTIONS(3067),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3067),
    [sym_int] = ACTIONS(3067),
    [sym_xint] = ACTIONS(3069),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3069),
    [sym__newline] = ACTIONS(3069),
  },
  [1963] = {
    [sym_block_comment] = STATE(1963),
    [sym_compiler_directive_decl] = STATE(1963),
    [sym_fsi_directive_decl] = STATE(1963),
    [sym_preproc_line] = STATE(1963),
    [sym_identifier] = ACTIONS(2831),
    [anon_sym_EQ] = ACTIONS(2833),
    [anon_sym_COLON] = ACTIONS(2831),
    [anon_sym_return] = ACTIONS(2831),
    [anon_sym_do] = ACTIONS(2831),
    [anon_sym_let] = ACTIONS(2831),
    [anon_sym_let_BANG] = ACTIONS(2833),
    [anon_sym_as] = ACTIONS(2831),
    [anon_sym_LPAREN] = ACTIONS(2831),
    [anon_sym_COMMA] = ACTIONS(2833),
    [anon_sym_null] = ACTIONS(2831),
    [anon_sym_QMARK] = ACTIONS(2831),
    [anon_sym_COLON_QMARK] = ACTIONS(2831),
    [anon_sym_COLON_COLON] = ACTIONS(2833),
    [anon_sym_AMP] = ACTIONS(2831),
    [anon_sym_LBRACK] = ACTIONS(2831),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2833),
    [anon_sym_LBRACE] = ACTIONS(2831),
    [anon_sym_LT_AT] = ACTIONS(2831),
    [anon_sym_LT_AT_AT] = ACTIONS(2831),
    [anon_sym_DOT] = ACTIONS(2831),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2833),
    [anon_sym_new] = ACTIONS(2831),
    [anon_sym_with] = ACTIONS(2831),
    [anon_sym_return_BANG] = ACTIONS(2833),
    [anon_sym_yield] = ACTIONS(2831),
    [anon_sym_yield_BANG] = ACTIONS(2833),
    [anon_sym_lazy] = ACTIONS(2831),
    [anon_sym_assert] = ACTIONS(2831),
    [anon_sym_upcast] = ACTIONS(2831),
    [anon_sym_downcast] = ACTIONS(2831),
    [anon_sym_COLON_GT] = ACTIONS(2833),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2833),
    [anon_sym_for] = ACTIONS(2831),
    [anon_sym_while] = ACTIONS(2831),
    [anon_sym_if] = ACTIONS(2831),
    [anon_sym_fun] = ACTIONS(2831),
    [anon_sym_try] = ACTIONS(2831),
    [anon_sym_match] = ACTIONS(2831),
    [anon_sym_match_BANG] = ACTIONS(2833),
    [anon_sym_function] = ACTIONS(2831),
    [anon_sym_LT_DASH] = ACTIONS(2831),
    [anon_sym_DOT_LBRACK] = ACTIONS(2833),
    [anon_sym_LT] = ACTIONS(2833),
    [anon_sym_use] = ACTIONS(2831),
    [anon_sym_use_BANG] = ACTIONS(2833),
    [anon_sym_do_BANG] = ACTIONS(2833),
    [anon_sym_begin] = ACTIONS(2831),
    [anon_sym_LPAREN2] = ACTIONS(2831),
    [anon_sym_or] = ACTIONS(2831),
    [aux_sym_char_token1] = ACTIONS(2833),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2831),
    [anon_sym_DQUOTE] = ACTIONS(2831),
    [anon_sym_AT_DQUOTE] = ACTIONS(2833),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2833),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2833),
    [sym_bool] = ACTIONS(2831),
    [sym_unit] = ACTIONS(2833),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2831),
    [sym_op_identifier] = ACTIONS(2831),
    [anon_sym_PLUS] = ACTIONS(2831),
    [anon_sym_DASH] = ACTIONS(2831),
    [anon_sym_PLUS_DOT] = ACTIONS(2831),
    [anon_sym_DASH_DOT] = ACTIONS(2831),
    [anon_sym_PERCENT] = ACTIONS(2831),
    [anon_sym_AMP_AMP] = ACTIONS(2831),
    [anon_sym_TILDE] = ACTIONS(2833),
    [aux_sym_prefix_op_token1] = ACTIONS(2831),
    [aux_sym_infix_op_token1] = ACTIONS(2833),
    [aux_sym_infix_op_token2] = ACTIONS(2831),
    [anon_sym_PIPE_PIPE] = ACTIONS(2831),
    [anon_sym_BANG_EQ] = ACTIONS(2831),
    [anon_sym_COLON_EQ] = ACTIONS(2833),
    [anon_sym_DOLLAR] = ACTIONS(2831),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2831),
    [sym_int] = ACTIONS(2831),
    [sym_xint] = ACTIONS(2833),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2833),
    [sym__newline] = ACTIONS(2833),
  },
  [1964] = {
    [sym_block_comment] = STATE(1964),
    [sym_compiler_directive_decl] = STATE(1964),
    [sym_fsi_directive_decl] = STATE(1964),
    [sym_preproc_line] = STATE(1964),
    [sym_identifier] = ACTIONS(2760),
    [anon_sym_EQ] = ACTIONS(2762),
    [anon_sym_COLON] = ACTIONS(2760),
    [anon_sym_return] = ACTIONS(2760),
    [anon_sym_do] = ACTIONS(2760),
    [anon_sym_let] = ACTIONS(2760),
    [anon_sym_let_BANG] = ACTIONS(2762),
    [anon_sym_LPAREN] = ACTIONS(2760),
    [anon_sym_COMMA] = ACTIONS(2762),
    [anon_sym_null] = ACTIONS(2760),
    [anon_sym_QMARK] = ACTIONS(2760),
    [anon_sym_COLON_QMARK] = ACTIONS(2760),
    [anon_sym_COLON_COLON] = ACTIONS(2762),
    [anon_sym_PIPE] = ACTIONS(2760),
    [anon_sym_AMP] = ACTIONS(2760),
    [anon_sym_LBRACK] = ACTIONS(2760),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2762),
    [anon_sym_LBRACE] = ACTIONS(2760),
    [anon_sym_LT_AT] = ACTIONS(2760),
    [anon_sym_LT_AT_AT] = ACTIONS(2760),
    [anon_sym_DOT] = ACTIONS(2760),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2762),
    [anon_sym_new] = ACTIONS(2760),
    [anon_sym_return_BANG] = ACTIONS(2762),
    [anon_sym_yield] = ACTIONS(2760),
    [anon_sym_yield_BANG] = ACTIONS(2762),
    [anon_sym_lazy] = ACTIONS(2760),
    [anon_sym_assert] = ACTIONS(2760),
    [anon_sym_upcast] = ACTIONS(2760),
    [anon_sym_downcast] = ACTIONS(2760),
    [anon_sym_COLON_GT] = ACTIONS(2762),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2762),
    [anon_sym_for] = ACTIONS(2760),
    [anon_sym_while] = ACTIONS(2760),
    [anon_sym_if] = ACTIONS(2760),
    [anon_sym_fun] = ACTIONS(2760),
    [anon_sym_try] = ACTIONS(2760),
    [anon_sym_match] = ACTIONS(2760),
    [anon_sym_match_BANG] = ACTIONS(2762),
    [anon_sym_function] = ACTIONS(2760),
    [anon_sym_LT_DASH] = ACTIONS(2760),
    [anon_sym_DOT_LBRACK] = ACTIONS(2762),
    [anon_sym_LT] = ACTIONS(2762),
    [anon_sym_GT] = ACTIONS(2760),
    [anon_sym_use] = ACTIONS(2760),
    [anon_sym_use_BANG] = ACTIONS(2762),
    [anon_sym_do_BANG] = ACTIONS(2762),
    [anon_sym_begin] = ACTIONS(2760),
    [anon_sym_LPAREN2] = ACTIONS(2760),
    [anon_sym_or] = ACTIONS(2760),
    [aux_sym_char_token1] = ACTIONS(2762),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2760),
    [anon_sym_DQUOTE] = ACTIONS(2760),
    [anon_sym_AT_DQUOTE] = ACTIONS(2762),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2762),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2762),
    [sym_bool] = ACTIONS(2760),
    [sym_unit] = ACTIONS(2762),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2760),
    [sym_op_identifier] = ACTIONS(2760),
    [anon_sym_PLUS] = ACTIONS(2760),
    [anon_sym_DASH] = ACTIONS(2760),
    [anon_sym_PLUS_DOT] = ACTIONS(2760),
    [anon_sym_DASH_DOT] = ACTIONS(2760),
    [anon_sym_PERCENT] = ACTIONS(2760),
    [anon_sym_AMP_AMP] = ACTIONS(2760),
    [anon_sym_TILDE] = ACTIONS(2762),
    [aux_sym_prefix_op_token1] = ACTIONS(2760),
    [aux_sym_infix_op_token1] = ACTIONS(2762),
    [aux_sym_infix_op_token2] = ACTIONS(2760),
    [anon_sym_PIPE_PIPE] = ACTIONS(2760),
    [anon_sym_BANG_EQ] = ACTIONS(2760),
    [anon_sym_COLON_EQ] = ACTIONS(2762),
    [anon_sym_DOLLAR] = ACTIONS(2760),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2760),
    [sym_int] = ACTIONS(2760),
    [sym_xint] = ACTIONS(2762),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2762),
    [sym__newline] = ACTIONS(2762),
  },
  [1965] = {
    [sym_block_comment] = STATE(1965),
    [sym_compiler_directive_decl] = STATE(1965),
    [sym_fsi_directive_decl] = STATE(1965),
    [sym_preproc_line] = STATE(1965),
    [sym_identifier] = ACTIONS(3107),
    [anon_sym_EQ] = ACTIONS(3109),
    [anon_sym_COLON] = ACTIONS(3107),
    [anon_sym_return] = ACTIONS(3107),
    [anon_sym_do] = ACTIONS(3107),
    [anon_sym_let] = ACTIONS(3107),
    [anon_sym_let_BANG] = ACTIONS(3109),
    [anon_sym_LPAREN] = ACTIONS(3107),
    [anon_sym_COMMA] = ACTIONS(3109),
    [anon_sym_null] = ACTIONS(3107),
    [anon_sym_QMARK] = ACTIONS(3107),
    [anon_sym_COLON_QMARK] = ACTIONS(3107),
    [anon_sym_COLON_COLON] = ACTIONS(3109),
    [anon_sym_AMP] = ACTIONS(3107),
    [anon_sym_LBRACK] = ACTIONS(3107),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3109),
    [anon_sym_LBRACE] = ACTIONS(3107),
    [anon_sym_LT_AT] = ACTIONS(3107),
    [anon_sym_LT_AT_AT] = ACTIONS(3107),
    [anon_sym_DOT] = ACTIONS(3107),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3109),
    [anon_sym_new] = ACTIONS(3107),
    [anon_sym_return_BANG] = ACTIONS(3109),
    [anon_sym_yield] = ACTIONS(3107),
    [anon_sym_yield_BANG] = ACTIONS(3109),
    [anon_sym_lazy] = ACTIONS(3107),
    [anon_sym_assert] = ACTIONS(3107),
    [anon_sym_upcast] = ACTIONS(3107),
    [anon_sym_downcast] = ACTIONS(3107),
    [anon_sym_COLON_GT] = ACTIONS(3109),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3109),
    [anon_sym_for] = ACTIONS(3107),
    [anon_sym_while] = ACTIONS(3107),
    [anon_sym_if] = ACTIONS(3107),
    [anon_sym_fun] = ACTIONS(3107),
    [anon_sym_DASH_GT] = ACTIONS(3107),
    [anon_sym_try] = ACTIONS(3107),
    [anon_sym_match] = ACTIONS(3107),
    [anon_sym_match_BANG] = ACTIONS(3109),
    [anon_sym_function] = ACTIONS(3107),
    [anon_sym_LT_DASH] = ACTIONS(3107),
    [anon_sym_DOT_LBRACK] = ACTIONS(3109),
    [anon_sym_LT] = ACTIONS(3109),
    [anon_sym_use] = ACTIONS(3107),
    [anon_sym_use_BANG] = ACTIONS(3109),
    [anon_sym_do_BANG] = ACTIONS(3109),
    [anon_sym_DOT_DOT] = ACTIONS(3109),
    [anon_sym_begin] = ACTIONS(3107),
    [anon_sym_LPAREN2] = ACTIONS(3107),
    [anon_sym_or] = ACTIONS(3107),
    [aux_sym_char_token1] = ACTIONS(3109),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3107),
    [anon_sym_DQUOTE] = ACTIONS(3107),
    [anon_sym_AT_DQUOTE] = ACTIONS(3109),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3109),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3109),
    [sym_bool] = ACTIONS(3107),
    [sym_unit] = ACTIONS(3109),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3107),
    [sym_op_identifier] = ACTIONS(3107),
    [anon_sym_PLUS] = ACTIONS(3107),
    [anon_sym_DASH] = ACTIONS(3107),
    [anon_sym_PLUS_DOT] = ACTIONS(3107),
    [anon_sym_DASH_DOT] = ACTIONS(3107),
    [anon_sym_PERCENT] = ACTIONS(3107),
    [anon_sym_AMP_AMP] = ACTIONS(3107),
    [anon_sym_TILDE] = ACTIONS(3109),
    [aux_sym_prefix_op_token1] = ACTIONS(3107),
    [aux_sym_infix_op_token1] = ACTIONS(3109),
    [aux_sym_infix_op_token2] = ACTIONS(3107),
    [anon_sym_PIPE_PIPE] = ACTIONS(3107),
    [anon_sym_BANG_EQ] = ACTIONS(3107),
    [anon_sym_COLON_EQ] = ACTIONS(3109),
    [anon_sym_DOLLAR] = ACTIONS(3107),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3107),
    [sym_int] = ACTIONS(3107),
    [sym_xint] = ACTIONS(3109),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3109),
    [sym__newline] = ACTIONS(3109),
  },
  [1966] = {
    [sym_block_comment] = STATE(1966),
    [sym_compiler_directive_decl] = STATE(1966),
    [sym_fsi_directive_decl] = STATE(1966),
    [sym_preproc_line] = STATE(1966),
    [sym_identifier] = ACTIONS(3103),
    [anon_sym_EQ] = ACTIONS(3105),
    [anon_sym_COLON] = ACTIONS(3103),
    [anon_sym_return] = ACTIONS(3103),
    [anon_sym_do] = ACTIONS(3103),
    [anon_sym_let] = ACTIONS(3103),
    [anon_sym_let_BANG] = ACTIONS(3105),
    [anon_sym_LPAREN] = ACTIONS(3103),
    [anon_sym_COMMA] = ACTIONS(3105),
    [anon_sym_null] = ACTIONS(3103),
    [anon_sym_QMARK] = ACTIONS(3103),
    [anon_sym_COLON_QMARK] = ACTIONS(3103),
    [anon_sym_COLON_COLON] = ACTIONS(3105),
    [anon_sym_AMP] = ACTIONS(3103),
    [anon_sym_LBRACK] = ACTIONS(3103),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3105),
    [anon_sym_LBRACE] = ACTIONS(3103),
    [anon_sym_LT_AT] = ACTIONS(3103),
    [anon_sym_LT_AT_AT] = ACTIONS(3103),
    [anon_sym_DOT] = ACTIONS(3103),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3105),
    [anon_sym_new] = ACTIONS(3103),
    [anon_sym_return_BANG] = ACTIONS(3105),
    [anon_sym_yield] = ACTIONS(3103),
    [anon_sym_yield_BANG] = ACTIONS(3105),
    [anon_sym_lazy] = ACTIONS(3103),
    [anon_sym_assert] = ACTIONS(3103),
    [anon_sym_upcast] = ACTIONS(3103),
    [anon_sym_downcast] = ACTIONS(3103),
    [anon_sym_COLON_GT] = ACTIONS(3105),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3105),
    [anon_sym_for] = ACTIONS(3103),
    [anon_sym_while] = ACTIONS(3103),
    [anon_sym_if] = ACTIONS(3103),
    [anon_sym_fun] = ACTIONS(3103),
    [anon_sym_DASH_GT] = ACTIONS(3103),
    [anon_sym_try] = ACTIONS(3103),
    [anon_sym_match] = ACTIONS(3103),
    [anon_sym_match_BANG] = ACTIONS(3105),
    [anon_sym_function] = ACTIONS(3103),
    [anon_sym_LT_DASH] = ACTIONS(3103),
    [anon_sym_DOT_LBRACK] = ACTIONS(3105),
    [anon_sym_LT] = ACTIONS(3105),
    [anon_sym_use] = ACTIONS(3103),
    [anon_sym_use_BANG] = ACTIONS(3105),
    [anon_sym_do_BANG] = ACTIONS(3105),
    [anon_sym_DOT_DOT] = ACTIONS(3105),
    [anon_sym_begin] = ACTIONS(3103),
    [anon_sym_LPAREN2] = ACTIONS(3103),
    [anon_sym_or] = ACTIONS(3103),
    [aux_sym_char_token1] = ACTIONS(3105),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3103),
    [anon_sym_DQUOTE] = ACTIONS(3103),
    [anon_sym_AT_DQUOTE] = ACTIONS(3105),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3105),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3105),
    [sym_bool] = ACTIONS(3103),
    [sym_unit] = ACTIONS(3105),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3103),
    [sym_op_identifier] = ACTIONS(3103),
    [anon_sym_PLUS] = ACTIONS(3103),
    [anon_sym_DASH] = ACTIONS(3103),
    [anon_sym_PLUS_DOT] = ACTIONS(3103),
    [anon_sym_DASH_DOT] = ACTIONS(3103),
    [anon_sym_PERCENT] = ACTIONS(3103),
    [anon_sym_AMP_AMP] = ACTIONS(3103),
    [anon_sym_TILDE] = ACTIONS(3105),
    [aux_sym_prefix_op_token1] = ACTIONS(3103),
    [aux_sym_infix_op_token1] = ACTIONS(3105),
    [aux_sym_infix_op_token2] = ACTIONS(3103),
    [anon_sym_PIPE_PIPE] = ACTIONS(3103),
    [anon_sym_BANG_EQ] = ACTIONS(3103),
    [anon_sym_COLON_EQ] = ACTIONS(3105),
    [anon_sym_DOLLAR] = ACTIONS(3103),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3103),
    [sym_int] = ACTIONS(3103),
    [sym_xint] = ACTIONS(3105),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3105),
    [sym__newline] = ACTIONS(3105),
  },
  [1967] = {
    [sym_block_comment] = STATE(1967),
    [sym_compiler_directive_decl] = STATE(1967),
    [sym_fsi_directive_decl] = STATE(1967),
    [sym_preproc_line] = STATE(1967),
    [sym_identifier] = ACTIONS(3099),
    [anon_sym_EQ] = ACTIONS(3101),
    [anon_sym_COLON] = ACTIONS(3099),
    [anon_sym_return] = ACTIONS(3099),
    [anon_sym_do] = ACTIONS(3099),
    [anon_sym_let] = ACTIONS(3099),
    [anon_sym_let_BANG] = ACTIONS(3101),
    [anon_sym_LPAREN] = ACTIONS(3099),
    [anon_sym_COMMA] = ACTIONS(3101),
    [anon_sym_null] = ACTIONS(3099),
    [anon_sym_QMARK] = ACTIONS(3099),
    [anon_sym_COLON_QMARK] = ACTIONS(3099),
    [anon_sym_COLON_COLON] = ACTIONS(3101),
    [anon_sym_AMP] = ACTIONS(3099),
    [anon_sym_LBRACK] = ACTIONS(3099),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3101),
    [anon_sym_LBRACE] = ACTIONS(3099),
    [anon_sym_LT_AT] = ACTIONS(3099),
    [anon_sym_LT_AT_AT] = ACTIONS(3099),
    [anon_sym_DOT] = ACTIONS(3099),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3101),
    [anon_sym_new] = ACTIONS(3099),
    [anon_sym_return_BANG] = ACTIONS(3101),
    [anon_sym_yield] = ACTIONS(3099),
    [anon_sym_yield_BANG] = ACTIONS(3101),
    [anon_sym_lazy] = ACTIONS(3099),
    [anon_sym_assert] = ACTIONS(3099),
    [anon_sym_upcast] = ACTIONS(3099),
    [anon_sym_downcast] = ACTIONS(3099),
    [anon_sym_COLON_GT] = ACTIONS(3101),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3101),
    [anon_sym_for] = ACTIONS(3099),
    [anon_sym_while] = ACTIONS(3099),
    [anon_sym_if] = ACTIONS(3099),
    [anon_sym_fun] = ACTIONS(3099),
    [anon_sym_DASH_GT] = ACTIONS(3099),
    [anon_sym_try] = ACTIONS(3099),
    [anon_sym_match] = ACTIONS(3099),
    [anon_sym_match_BANG] = ACTIONS(3101),
    [anon_sym_function] = ACTIONS(3099),
    [anon_sym_LT_DASH] = ACTIONS(3099),
    [anon_sym_DOT_LBRACK] = ACTIONS(3101),
    [anon_sym_LT] = ACTIONS(3101),
    [anon_sym_use] = ACTIONS(3099),
    [anon_sym_use_BANG] = ACTIONS(3101),
    [anon_sym_do_BANG] = ACTIONS(3101),
    [anon_sym_DOT_DOT] = ACTIONS(3101),
    [anon_sym_begin] = ACTIONS(3099),
    [anon_sym_LPAREN2] = ACTIONS(3099),
    [anon_sym_or] = ACTIONS(3099),
    [aux_sym_char_token1] = ACTIONS(3101),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3099),
    [anon_sym_DQUOTE] = ACTIONS(3099),
    [anon_sym_AT_DQUOTE] = ACTIONS(3101),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3101),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3101),
    [sym_bool] = ACTIONS(3099),
    [sym_unit] = ACTIONS(3101),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3099),
    [sym_op_identifier] = ACTIONS(3099),
    [anon_sym_PLUS] = ACTIONS(3099),
    [anon_sym_DASH] = ACTIONS(3099),
    [anon_sym_PLUS_DOT] = ACTIONS(3099),
    [anon_sym_DASH_DOT] = ACTIONS(3099),
    [anon_sym_PERCENT] = ACTIONS(3099),
    [anon_sym_AMP_AMP] = ACTIONS(3099),
    [anon_sym_TILDE] = ACTIONS(3101),
    [aux_sym_prefix_op_token1] = ACTIONS(3099),
    [aux_sym_infix_op_token1] = ACTIONS(3101),
    [aux_sym_infix_op_token2] = ACTIONS(3099),
    [anon_sym_PIPE_PIPE] = ACTIONS(3099),
    [anon_sym_BANG_EQ] = ACTIONS(3099),
    [anon_sym_COLON_EQ] = ACTIONS(3101),
    [anon_sym_DOLLAR] = ACTIONS(3099),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3099),
    [sym_int] = ACTIONS(3099),
    [sym_xint] = ACTIONS(3101),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3101),
    [sym__newline] = ACTIONS(3101),
  },
  [1968] = {
    [sym_block_comment] = STATE(1968),
    [sym_compiler_directive_decl] = STATE(1968),
    [sym_fsi_directive_decl] = STATE(1968),
    [sym_preproc_line] = STATE(1968),
    [sym_identifier] = ACTIONS(3083),
    [anon_sym_EQ] = ACTIONS(3085),
    [anon_sym_COLON] = ACTIONS(3083),
    [anon_sym_return] = ACTIONS(3083),
    [anon_sym_do] = ACTIONS(3083),
    [anon_sym_let] = ACTIONS(3083),
    [anon_sym_let_BANG] = ACTIONS(3085),
    [anon_sym_LPAREN] = ACTIONS(3083),
    [anon_sym_COMMA] = ACTIONS(3085),
    [anon_sym_null] = ACTIONS(3083),
    [anon_sym_QMARK] = ACTIONS(3083),
    [anon_sym_COLON_QMARK] = ACTIONS(3083),
    [anon_sym_COLON_COLON] = ACTIONS(3085),
    [anon_sym_AMP] = ACTIONS(3083),
    [anon_sym_LBRACK] = ACTIONS(3083),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3085),
    [anon_sym_LBRACE] = ACTIONS(3083),
    [anon_sym_LT_AT] = ACTIONS(3083),
    [anon_sym_LT_AT_AT] = ACTIONS(3083),
    [anon_sym_DOT] = ACTIONS(3083),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3085),
    [anon_sym_new] = ACTIONS(3083),
    [anon_sym_return_BANG] = ACTIONS(3085),
    [anon_sym_yield] = ACTIONS(3083),
    [anon_sym_yield_BANG] = ACTIONS(3085),
    [anon_sym_lazy] = ACTIONS(3083),
    [anon_sym_assert] = ACTIONS(3083),
    [anon_sym_upcast] = ACTIONS(3083),
    [anon_sym_downcast] = ACTIONS(3083),
    [anon_sym_COLON_GT] = ACTIONS(3085),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3085),
    [anon_sym_for] = ACTIONS(3083),
    [anon_sym_while] = ACTIONS(3083),
    [anon_sym_if] = ACTIONS(3083),
    [anon_sym_fun] = ACTIONS(3083),
    [anon_sym_DASH_GT] = ACTIONS(3083),
    [anon_sym_try] = ACTIONS(3083),
    [anon_sym_match] = ACTIONS(3083),
    [anon_sym_match_BANG] = ACTIONS(3085),
    [anon_sym_function] = ACTIONS(3083),
    [anon_sym_LT_DASH] = ACTIONS(3083),
    [anon_sym_DOT_LBRACK] = ACTIONS(3085),
    [anon_sym_LT] = ACTIONS(3085),
    [anon_sym_use] = ACTIONS(3083),
    [anon_sym_use_BANG] = ACTIONS(3085),
    [anon_sym_do_BANG] = ACTIONS(3085),
    [anon_sym_DOT_DOT] = ACTIONS(3085),
    [anon_sym_begin] = ACTIONS(3083),
    [anon_sym_LPAREN2] = ACTIONS(3083),
    [anon_sym_or] = ACTIONS(3083),
    [aux_sym_char_token1] = ACTIONS(3085),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3083),
    [anon_sym_DQUOTE] = ACTIONS(3083),
    [anon_sym_AT_DQUOTE] = ACTIONS(3085),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3085),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3085),
    [sym_bool] = ACTIONS(3083),
    [sym_unit] = ACTIONS(3085),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3083),
    [sym_op_identifier] = ACTIONS(3083),
    [anon_sym_PLUS] = ACTIONS(3083),
    [anon_sym_DASH] = ACTIONS(3083),
    [anon_sym_PLUS_DOT] = ACTIONS(3083),
    [anon_sym_DASH_DOT] = ACTIONS(3083),
    [anon_sym_PERCENT] = ACTIONS(3083),
    [anon_sym_AMP_AMP] = ACTIONS(3083),
    [anon_sym_TILDE] = ACTIONS(3085),
    [aux_sym_prefix_op_token1] = ACTIONS(3083),
    [aux_sym_infix_op_token1] = ACTIONS(3085),
    [aux_sym_infix_op_token2] = ACTIONS(3083),
    [anon_sym_PIPE_PIPE] = ACTIONS(3083),
    [anon_sym_BANG_EQ] = ACTIONS(3083),
    [anon_sym_COLON_EQ] = ACTIONS(3085),
    [anon_sym_DOLLAR] = ACTIONS(3083),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3083),
    [sym_int] = ACTIONS(3083),
    [sym_xint] = ACTIONS(3085),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3085),
    [sym__newline] = ACTIONS(3085),
  },
  [1969] = {
    [sym_block_comment] = STATE(1969),
    [sym_compiler_directive_decl] = STATE(1969),
    [sym_fsi_directive_decl] = STATE(1969),
    [sym_preproc_line] = STATE(1969),
    [sym_identifier] = ACTIONS(3079),
    [anon_sym_EQ] = ACTIONS(3081),
    [anon_sym_COLON] = ACTIONS(3079),
    [anon_sym_return] = ACTIONS(3079),
    [anon_sym_do] = ACTIONS(3079),
    [anon_sym_let] = ACTIONS(3079),
    [anon_sym_let_BANG] = ACTIONS(3081),
    [anon_sym_LPAREN] = ACTIONS(3079),
    [anon_sym_COMMA] = ACTIONS(3081),
    [anon_sym_null] = ACTIONS(3079),
    [anon_sym_QMARK] = ACTIONS(3079),
    [anon_sym_COLON_QMARK] = ACTIONS(3079),
    [anon_sym_COLON_COLON] = ACTIONS(3081),
    [anon_sym_AMP] = ACTIONS(3079),
    [anon_sym_LBRACK] = ACTIONS(3079),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3081),
    [anon_sym_LBRACE] = ACTIONS(3079),
    [anon_sym_LT_AT] = ACTIONS(3079),
    [anon_sym_LT_AT_AT] = ACTIONS(3079),
    [anon_sym_DOT] = ACTIONS(3079),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3081),
    [anon_sym_new] = ACTIONS(3079),
    [anon_sym_return_BANG] = ACTIONS(3081),
    [anon_sym_yield] = ACTIONS(3079),
    [anon_sym_yield_BANG] = ACTIONS(3081),
    [anon_sym_lazy] = ACTIONS(3079),
    [anon_sym_assert] = ACTIONS(3079),
    [anon_sym_upcast] = ACTIONS(3079),
    [anon_sym_downcast] = ACTIONS(3079),
    [anon_sym_COLON_GT] = ACTIONS(3081),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3081),
    [anon_sym_for] = ACTIONS(3079),
    [anon_sym_while] = ACTIONS(3079),
    [anon_sym_if] = ACTIONS(3079),
    [anon_sym_fun] = ACTIONS(3079),
    [anon_sym_DASH_GT] = ACTIONS(3079),
    [anon_sym_try] = ACTIONS(3079),
    [anon_sym_match] = ACTIONS(3079),
    [anon_sym_match_BANG] = ACTIONS(3081),
    [anon_sym_function] = ACTIONS(3079),
    [anon_sym_LT_DASH] = ACTIONS(3079),
    [anon_sym_DOT_LBRACK] = ACTIONS(3081),
    [anon_sym_LT] = ACTIONS(3081),
    [anon_sym_use] = ACTIONS(3079),
    [anon_sym_use_BANG] = ACTIONS(3081),
    [anon_sym_do_BANG] = ACTIONS(3081),
    [anon_sym_DOT_DOT] = ACTIONS(3081),
    [anon_sym_begin] = ACTIONS(3079),
    [anon_sym_LPAREN2] = ACTIONS(3079),
    [anon_sym_or] = ACTIONS(3079),
    [aux_sym_char_token1] = ACTIONS(3081),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3079),
    [anon_sym_DQUOTE] = ACTIONS(3079),
    [anon_sym_AT_DQUOTE] = ACTIONS(3081),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3081),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3081),
    [sym_bool] = ACTIONS(3079),
    [sym_unit] = ACTIONS(3081),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3079),
    [sym_op_identifier] = ACTIONS(3079),
    [anon_sym_PLUS] = ACTIONS(3079),
    [anon_sym_DASH] = ACTIONS(3079),
    [anon_sym_PLUS_DOT] = ACTIONS(3079),
    [anon_sym_DASH_DOT] = ACTIONS(3079),
    [anon_sym_PERCENT] = ACTIONS(3079),
    [anon_sym_AMP_AMP] = ACTIONS(3079),
    [anon_sym_TILDE] = ACTIONS(3081),
    [aux_sym_prefix_op_token1] = ACTIONS(3079),
    [aux_sym_infix_op_token1] = ACTIONS(3081),
    [aux_sym_infix_op_token2] = ACTIONS(3079),
    [anon_sym_PIPE_PIPE] = ACTIONS(3079),
    [anon_sym_BANG_EQ] = ACTIONS(3079),
    [anon_sym_COLON_EQ] = ACTIONS(3081),
    [anon_sym_DOLLAR] = ACTIONS(3079),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3079),
    [sym_int] = ACTIONS(3079),
    [sym_xint] = ACTIONS(3081),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3081),
    [sym__newline] = ACTIONS(3081),
  },
  [1970] = {
    [sym_block_comment] = STATE(1970),
    [sym_compiler_directive_decl] = STATE(1970),
    [sym_fsi_directive_decl] = STATE(1970),
    [sym_preproc_line] = STATE(1970),
    [sym_identifier] = ACTIONS(3055),
    [anon_sym_EQ] = ACTIONS(3057),
    [anon_sym_COLON] = ACTIONS(3055),
    [anon_sym_return] = ACTIONS(3055),
    [anon_sym_do] = ACTIONS(3055),
    [anon_sym_let] = ACTIONS(3055),
    [anon_sym_let_BANG] = ACTIONS(3057),
    [anon_sym_as] = ACTIONS(3055),
    [anon_sym_LPAREN] = ACTIONS(3055),
    [anon_sym_COMMA] = ACTIONS(3057),
    [anon_sym_null] = ACTIONS(3055),
    [anon_sym_QMARK] = ACTIONS(3055),
    [anon_sym_COLON_QMARK] = ACTIONS(3055),
    [anon_sym_COLON_COLON] = ACTIONS(3057),
    [anon_sym_AMP] = ACTIONS(3055),
    [anon_sym_LBRACK] = ACTIONS(3055),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3057),
    [anon_sym_LBRACE] = ACTIONS(3055),
    [anon_sym_LT_AT] = ACTIONS(3055),
    [anon_sym_LT_AT_AT] = ACTIONS(3055),
    [anon_sym_DOT] = ACTIONS(3055),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3057),
    [anon_sym_new] = ACTIONS(3055),
    [anon_sym_with] = ACTIONS(3055),
    [anon_sym_return_BANG] = ACTIONS(3057),
    [anon_sym_yield] = ACTIONS(3055),
    [anon_sym_yield_BANG] = ACTIONS(3057),
    [anon_sym_lazy] = ACTIONS(3055),
    [anon_sym_assert] = ACTIONS(3055),
    [anon_sym_upcast] = ACTIONS(3055),
    [anon_sym_downcast] = ACTIONS(3055),
    [anon_sym_COLON_GT] = ACTIONS(3057),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3057),
    [anon_sym_for] = ACTIONS(3055),
    [anon_sym_while] = ACTIONS(3055),
    [anon_sym_if] = ACTIONS(3055),
    [anon_sym_fun] = ACTIONS(3055),
    [anon_sym_try] = ACTIONS(3055),
    [anon_sym_match] = ACTIONS(3055),
    [anon_sym_match_BANG] = ACTIONS(3057),
    [anon_sym_function] = ACTIONS(3055),
    [anon_sym_LT_DASH] = ACTIONS(3055),
    [anon_sym_DOT_LBRACK] = ACTIONS(3057),
    [anon_sym_LT] = ACTIONS(3057),
    [anon_sym_use] = ACTIONS(3055),
    [anon_sym_use_BANG] = ACTIONS(3057),
    [anon_sym_do_BANG] = ACTIONS(3057),
    [anon_sym_begin] = ACTIONS(3055),
    [anon_sym_LPAREN2] = ACTIONS(3055),
    [anon_sym_or] = ACTIONS(3055),
    [aux_sym_char_token1] = ACTIONS(3057),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3055),
    [anon_sym_DQUOTE] = ACTIONS(3055),
    [anon_sym_AT_DQUOTE] = ACTIONS(3057),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3057),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3057),
    [sym_bool] = ACTIONS(3055),
    [sym_unit] = ACTIONS(3057),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3055),
    [sym_op_identifier] = ACTIONS(3055),
    [anon_sym_PLUS] = ACTIONS(3055),
    [anon_sym_DASH] = ACTIONS(3055),
    [anon_sym_PLUS_DOT] = ACTIONS(3055),
    [anon_sym_DASH_DOT] = ACTIONS(3055),
    [anon_sym_PERCENT] = ACTIONS(3055),
    [anon_sym_AMP_AMP] = ACTIONS(3055),
    [anon_sym_TILDE] = ACTIONS(3057),
    [aux_sym_prefix_op_token1] = ACTIONS(3055),
    [aux_sym_infix_op_token1] = ACTIONS(3057),
    [aux_sym_infix_op_token2] = ACTIONS(3055),
    [anon_sym_PIPE_PIPE] = ACTIONS(3055),
    [anon_sym_BANG_EQ] = ACTIONS(3055),
    [anon_sym_COLON_EQ] = ACTIONS(3057),
    [anon_sym_DOLLAR] = ACTIONS(3055),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3055),
    [sym_int] = ACTIONS(3055),
    [sym_xint] = ACTIONS(3057),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3057),
    [sym__newline] = ACTIONS(3057),
  },
  [1971] = {
    [sym_block_comment] = STATE(1971),
    [sym_compiler_directive_decl] = STATE(1971),
    [sym_fsi_directive_decl] = STATE(1971),
    [sym_preproc_line] = STATE(1971),
    [sym_identifier] = ACTIONS(3063),
    [anon_sym_EQ] = ACTIONS(3065),
    [anon_sym_COLON] = ACTIONS(3063),
    [anon_sym_return] = ACTIONS(3063),
    [anon_sym_do] = ACTIONS(3063),
    [anon_sym_let] = ACTIONS(3063),
    [anon_sym_let_BANG] = ACTIONS(3065),
    [anon_sym_LPAREN] = ACTIONS(3063),
    [anon_sym_COMMA] = ACTIONS(3065),
    [anon_sym_null] = ACTIONS(3063),
    [anon_sym_QMARK] = ACTIONS(3063),
    [anon_sym_COLON_QMARK] = ACTIONS(3063),
    [anon_sym_COLON_COLON] = ACTIONS(3065),
    [anon_sym_AMP] = ACTIONS(3063),
    [anon_sym_LBRACK] = ACTIONS(3063),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3065),
    [anon_sym_LBRACE] = ACTIONS(3063),
    [anon_sym_LT_AT] = ACTIONS(3063),
    [anon_sym_LT_AT_AT] = ACTIONS(3063),
    [anon_sym_DOT] = ACTIONS(3063),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3065),
    [anon_sym_new] = ACTIONS(3063),
    [anon_sym_return_BANG] = ACTIONS(3065),
    [anon_sym_yield] = ACTIONS(3063),
    [anon_sym_yield_BANG] = ACTIONS(3065),
    [anon_sym_lazy] = ACTIONS(3063),
    [anon_sym_assert] = ACTIONS(3063),
    [anon_sym_upcast] = ACTIONS(3063),
    [anon_sym_downcast] = ACTIONS(3063),
    [anon_sym_COLON_GT] = ACTIONS(3065),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3065),
    [anon_sym_for] = ACTIONS(3063),
    [anon_sym_while] = ACTIONS(3063),
    [anon_sym_if] = ACTIONS(3063),
    [anon_sym_fun] = ACTIONS(3063),
    [anon_sym_DASH_GT] = ACTIONS(3063),
    [anon_sym_try] = ACTIONS(3063),
    [anon_sym_match] = ACTIONS(3063),
    [anon_sym_match_BANG] = ACTIONS(3065),
    [anon_sym_function] = ACTIONS(3063),
    [anon_sym_LT_DASH] = ACTIONS(3063),
    [anon_sym_DOT_LBRACK] = ACTIONS(3065),
    [anon_sym_LT] = ACTIONS(3065),
    [anon_sym_use] = ACTIONS(3063),
    [anon_sym_use_BANG] = ACTIONS(3065),
    [anon_sym_do_BANG] = ACTIONS(3065),
    [anon_sym_DOT_DOT] = ACTIONS(3065),
    [anon_sym_begin] = ACTIONS(3063),
    [anon_sym_LPAREN2] = ACTIONS(3063),
    [anon_sym_or] = ACTIONS(3063),
    [aux_sym_char_token1] = ACTIONS(3065),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3063),
    [anon_sym_DQUOTE] = ACTIONS(3063),
    [anon_sym_AT_DQUOTE] = ACTIONS(3065),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3065),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3065),
    [sym_bool] = ACTIONS(3063),
    [sym_unit] = ACTIONS(3065),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3063),
    [sym_op_identifier] = ACTIONS(3063),
    [anon_sym_PLUS] = ACTIONS(3063),
    [anon_sym_DASH] = ACTIONS(3063),
    [anon_sym_PLUS_DOT] = ACTIONS(3063),
    [anon_sym_DASH_DOT] = ACTIONS(3063),
    [anon_sym_PERCENT] = ACTIONS(3063),
    [anon_sym_AMP_AMP] = ACTIONS(3063),
    [anon_sym_TILDE] = ACTIONS(3065),
    [aux_sym_prefix_op_token1] = ACTIONS(3063),
    [aux_sym_infix_op_token1] = ACTIONS(3065),
    [aux_sym_infix_op_token2] = ACTIONS(3063),
    [anon_sym_PIPE_PIPE] = ACTIONS(3063),
    [anon_sym_BANG_EQ] = ACTIONS(3063),
    [anon_sym_COLON_EQ] = ACTIONS(3065),
    [anon_sym_DOLLAR] = ACTIONS(3063),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3063),
    [sym_int] = ACTIONS(3063),
    [sym_xint] = ACTIONS(3065),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3065),
    [sym__newline] = ACTIONS(3065),
  },
  [1972] = {
    [sym_block_comment] = STATE(1972),
    [sym_compiler_directive_decl] = STATE(1972),
    [sym_fsi_directive_decl] = STATE(1972),
    [sym_preproc_line] = STATE(1972),
    [sym_identifier] = ACTIONS(3059),
    [anon_sym_EQ] = ACTIONS(3061),
    [anon_sym_COLON] = ACTIONS(3059),
    [anon_sym_return] = ACTIONS(3059),
    [anon_sym_do] = ACTIONS(3059),
    [anon_sym_let] = ACTIONS(3059),
    [anon_sym_let_BANG] = ACTIONS(3061),
    [anon_sym_LPAREN] = ACTIONS(3059),
    [anon_sym_COMMA] = ACTIONS(3061),
    [anon_sym_null] = ACTIONS(3059),
    [anon_sym_QMARK] = ACTIONS(3059),
    [anon_sym_COLON_QMARK] = ACTIONS(3059),
    [anon_sym_COLON_COLON] = ACTIONS(3061),
    [anon_sym_AMP] = ACTIONS(3059),
    [anon_sym_LBRACK] = ACTIONS(3059),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3061),
    [anon_sym_LBRACE] = ACTIONS(3059),
    [anon_sym_LT_AT] = ACTIONS(3059),
    [anon_sym_LT_AT_AT] = ACTIONS(3059),
    [anon_sym_DOT] = ACTIONS(3059),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3061),
    [anon_sym_new] = ACTIONS(3059),
    [anon_sym_return_BANG] = ACTIONS(3061),
    [anon_sym_yield] = ACTIONS(3059),
    [anon_sym_yield_BANG] = ACTIONS(3061),
    [anon_sym_lazy] = ACTIONS(3059),
    [anon_sym_assert] = ACTIONS(3059),
    [anon_sym_upcast] = ACTIONS(3059),
    [anon_sym_downcast] = ACTIONS(3059),
    [anon_sym_COLON_GT] = ACTIONS(3061),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3061),
    [anon_sym_for] = ACTIONS(3059),
    [anon_sym_while] = ACTIONS(3059),
    [anon_sym_if] = ACTIONS(3059),
    [anon_sym_fun] = ACTIONS(3059),
    [anon_sym_DASH_GT] = ACTIONS(3059),
    [anon_sym_try] = ACTIONS(3059),
    [anon_sym_match] = ACTIONS(3059),
    [anon_sym_match_BANG] = ACTIONS(3061),
    [anon_sym_function] = ACTIONS(3059),
    [anon_sym_LT_DASH] = ACTIONS(3059),
    [anon_sym_DOT_LBRACK] = ACTIONS(3061),
    [anon_sym_LT] = ACTIONS(3061),
    [anon_sym_use] = ACTIONS(3059),
    [anon_sym_use_BANG] = ACTIONS(3061),
    [anon_sym_do_BANG] = ACTIONS(3061),
    [anon_sym_DOT_DOT] = ACTIONS(3061),
    [anon_sym_begin] = ACTIONS(3059),
    [anon_sym_LPAREN2] = ACTIONS(3059),
    [anon_sym_or] = ACTIONS(3059),
    [aux_sym_char_token1] = ACTIONS(3061),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3059),
    [anon_sym_DQUOTE] = ACTIONS(3059),
    [anon_sym_AT_DQUOTE] = ACTIONS(3061),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3061),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3061),
    [sym_bool] = ACTIONS(3059),
    [sym_unit] = ACTIONS(3061),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3059),
    [sym_op_identifier] = ACTIONS(3059),
    [anon_sym_PLUS] = ACTIONS(3059),
    [anon_sym_DASH] = ACTIONS(3059),
    [anon_sym_PLUS_DOT] = ACTIONS(3059),
    [anon_sym_DASH_DOT] = ACTIONS(3059),
    [anon_sym_PERCENT] = ACTIONS(3059),
    [anon_sym_AMP_AMP] = ACTIONS(3059),
    [anon_sym_TILDE] = ACTIONS(3061),
    [aux_sym_prefix_op_token1] = ACTIONS(3059),
    [aux_sym_infix_op_token1] = ACTIONS(3061),
    [aux_sym_infix_op_token2] = ACTIONS(3059),
    [anon_sym_PIPE_PIPE] = ACTIONS(3059),
    [anon_sym_BANG_EQ] = ACTIONS(3059),
    [anon_sym_COLON_EQ] = ACTIONS(3061),
    [anon_sym_DOLLAR] = ACTIONS(3059),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3059),
    [sym_int] = ACTIONS(3059),
    [sym_xint] = ACTIONS(3061),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3061),
    [sym__newline] = ACTIONS(3061),
  },
  [1973] = {
    [sym_block_comment] = STATE(1973),
    [sym_compiler_directive_decl] = STATE(1973),
    [sym_fsi_directive_decl] = STATE(1973),
    [sym_preproc_line] = STATE(1973),
    [sym_identifier] = ACTIONS(3051),
    [anon_sym_EQ] = ACTIONS(3053),
    [anon_sym_COLON] = ACTIONS(3051),
    [anon_sym_return] = ACTIONS(3051),
    [anon_sym_do] = ACTIONS(3051),
    [anon_sym_let] = ACTIONS(3051),
    [anon_sym_let_BANG] = ACTIONS(3053),
    [anon_sym_LPAREN] = ACTIONS(3051),
    [anon_sym_COMMA] = ACTIONS(3053),
    [anon_sym_null] = ACTIONS(3051),
    [anon_sym_QMARK] = ACTIONS(3051),
    [anon_sym_COLON_QMARK] = ACTIONS(3051),
    [anon_sym_COLON_COLON] = ACTIONS(3053),
    [anon_sym_AMP] = ACTIONS(3051),
    [anon_sym_LBRACK] = ACTIONS(3051),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3053),
    [anon_sym_LBRACE] = ACTIONS(3051),
    [anon_sym_LT_AT] = ACTIONS(3051),
    [anon_sym_LT_AT_AT] = ACTIONS(3051),
    [anon_sym_DOT] = ACTIONS(3051),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3053),
    [anon_sym_new] = ACTIONS(3051),
    [anon_sym_return_BANG] = ACTIONS(3053),
    [anon_sym_yield] = ACTIONS(3051),
    [anon_sym_yield_BANG] = ACTIONS(3053),
    [anon_sym_lazy] = ACTIONS(3051),
    [anon_sym_assert] = ACTIONS(3051),
    [anon_sym_upcast] = ACTIONS(3051),
    [anon_sym_downcast] = ACTIONS(3051),
    [anon_sym_COLON_GT] = ACTIONS(3053),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3053),
    [anon_sym_for] = ACTIONS(3051),
    [anon_sym_while] = ACTIONS(3051),
    [anon_sym_if] = ACTIONS(3051),
    [anon_sym_fun] = ACTIONS(3051),
    [anon_sym_DASH_GT] = ACTIONS(3051),
    [anon_sym_try] = ACTIONS(3051),
    [anon_sym_match] = ACTIONS(3051),
    [anon_sym_match_BANG] = ACTIONS(3053),
    [anon_sym_function] = ACTIONS(3051),
    [anon_sym_LT_DASH] = ACTIONS(3051),
    [anon_sym_DOT_LBRACK] = ACTIONS(3053),
    [anon_sym_LT] = ACTIONS(3053),
    [anon_sym_use] = ACTIONS(3051),
    [anon_sym_use_BANG] = ACTIONS(3053),
    [anon_sym_do_BANG] = ACTIONS(3053),
    [anon_sym_DOT_DOT] = ACTIONS(3053),
    [anon_sym_begin] = ACTIONS(3051),
    [anon_sym_LPAREN2] = ACTIONS(3051),
    [anon_sym_or] = ACTIONS(3051),
    [aux_sym_char_token1] = ACTIONS(3053),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3051),
    [anon_sym_DQUOTE] = ACTIONS(3051),
    [anon_sym_AT_DQUOTE] = ACTIONS(3053),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3053),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3053),
    [sym_bool] = ACTIONS(3051),
    [sym_unit] = ACTIONS(3053),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3051),
    [sym_op_identifier] = ACTIONS(3051),
    [anon_sym_PLUS] = ACTIONS(3051),
    [anon_sym_DASH] = ACTIONS(3051),
    [anon_sym_PLUS_DOT] = ACTIONS(3051),
    [anon_sym_DASH_DOT] = ACTIONS(3051),
    [anon_sym_PERCENT] = ACTIONS(3051),
    [anon_sym_AMP_AMP] = ACTIONS(3051),
    [anon_sym_TILDE] = ACTIONS(3053),
    [aux_sym_prefix_op_token1] = ACTIONS(3051),
    [aux_sym_infix_op_token1] = ACTIONS(3053),
    [aux_sym_infix_op_token2] = ACTIONS(3051),
    [anon_sym_PIPE_PIPE] = ACTIONS(3051),
    [anon_sym_BANG_EQ] = ACTIONS(3051),
    [anon_sym_COLON_EQ] = ACTIONS(3053),
    [anon_sym_DOLLAR] = ACTIONS(3051),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3051),
    [sym_int] = ACTIONS(3051),
    [sym_xint] = ACTIONS(3053),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3053),
    [sym__newline] = ACTIONS(3053),
  },
  [1974] = {
    [sym_block_comment] = STATE(1974),
    [sym_compiler_directive_decl] = STATE(1974),
    [sym_fsi_directive_decl] = STATE(1974),
    [sym_preproc_line] = STATE(1974),
    [sym_identifier] = ACTIONS(3047),
    [anon_sym_EQ] = ACTIONS(3049),
    [anon_sym_COLON] = ACTIONS(3047),
    [anon_sym_return] = ACTIONS(3047),
    [anon_sym_do] = ACTIONS(3047),
    [anon_sym_let] = ACTIONS(3047),
    [anon_sym_let_BANG] = ACTIONS(3049),
    [anon_sym_LPAREN] = ACTIONS(3047),
    [anon_sym_COMMA] = ACTIONS(3049),
    [anon_sym_null] = ACTIONS(3047),
    [anon_sym_QMARK] = ACTIONS(3047),
    [anon_sym_COLON_QMARK] = ACTIONS(3047),
    [anon_sym_COLON_COLON] = ACTIONS(3049),
    [anon_sym_AMP] = ACTIONS(3047),
    [anon_sym_LBRACK] = ACTIONS(3047),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3049),
    [anon_sym_LBRACE] = ACTIONS(3047),
    [anon_sym_LT_AT] = ACTIONS(3047),
    [anon_sym_LT_AT_AT] = ACTIONS(3047),
    [anon_sym_DOT] = ACTIONS(3047),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3049),
    [anon_sym_new] = ACTIONS(3047),
    [anon_sym_return_BANG] = ACTIONS(3049),
    [anon_sym_yield] = ACTIONS(3047),
    [anon_sym_yield_BANG] = ACTIONS(3049),
    [anon_sym_lazy] = ACTIONS(3047),
    [anon_sym_assert] = ACTIONS(3047),
    [anon_sym_upcast] = ACTIONS(3047),
    [anon_sym_downcast] = ACTIONS(3047),
    [anon_sym_COLON_GT] = ACTIONS(3049),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3049),
    [anon_sym_for] = ACTIONS(3047),
    [anon_sym_while] = ACTIONS(3047),
    [anon_sym_if] = ACTIONS(3047),
    [anon_sym_fun] = ACTIONS(3047),
    [anon_sym_DASH_GT] = ACTIONS(3047),
    [anon_sym_try] = ACTIONS(3047),
    [anon_sym_match] = ACTIONS(3047),
    [anon_sym_match_BANG] = ACTIONS(3049),
    [anon_sym_function] = ACTIONS(3047),
    [anon_sym_LT_DASH] = ACTIONS(3047),
    [anon_sym_DOT_LBRACK] = ACTIONS(3049),
    [anon_sym_LT] = ACTIONS(3049),
    [anon_sym_use] = ACTIONS(3047),
    [anon_sym_use_BANG] = ACTIONS(3049),
    [anon_sym_do_BANG] = ACTIONS(3049),
    [anon_sym_DOT_DOT] = ACTIONS(3049),
    [anon_sym_begin] = ACTIONS(3047),
    [anon_sym_LPAREN2] = ACTIONS(3047),
    [anon_sym_or] = ACTIONS(3047),
    [aux_sym_char_token1] = ACTIONS(3049),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3047),
    [anon_sym_DQUOTE] = ACTIONS(3047),
    [anon_sym_AT_DQUOTE] = ACTIONS(3049),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3049),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3049),
    [sym_bool] = ACTIONS(3047),
    [sym_unit] = ACTIONS(3049),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3047),
    [sym_op_identifier] = ACTIONS(3047),
    [anon_sym_PLUS] = ACTIONS(3047),
    [anon_sym_DASH] = ACTIONS(3047),
    [anon_sym_PLUS_DOT] = ACTIONS(3047),
    [anon_sym_DASH_DOT] = ACTIONS(3047),
    [anon_sym_PERCENT] = ACTIONS(3047),
    [anon_sym_AMP_AMP] = ACTIONS(3047),
    [anon_sym_TILDE] = ACTIONS(3049),
    [aux_sym_prefix_op_token1] = ACTIONS(3047),
    [aux_sym_infix_op_token1] = ACTIONS(3049),
    [aux_sym_infix_op_token2] = ACTIONS(3047),
    [anon_sym_PIPE_PIPE] = ACTIONS(3047),
    [anon_sym_BANG_EQ] = ACTIONS(3047),
    [anon_sym_COLON_EQ] = ACTIONS(3049),
    [anon_sym_DOLLAR] = ACTIONS(3047),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3047),
    [sym_int] = ACTIONS(3047),
    [sym_xint] = ACTIONS(3049),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3049),
    [sym__newline] = ACTIONS(3049),
  },
  [1975] = {
    [sym_block_comment] = STATE(1975),
    [sym_compiler_directive_decl] = STATE(1975),
    [sym_fsi_directive_decl] = STATE(1975),
    [sym_preproc_line] = STATE(1975),
    [aux_sym_long_identifier_repeat1] = STATE(1975),
    [sym_identifier] = ACTIONS(2411),
    [anon_sym_EQ] = ACTIONS(2413),
    [anon_sym_COLON] = ACTIONS(2411),
    [anon_sym_return] = ACTIONS(2411),
    [anon_sym_do] = ACTIONS(2411),
    [anon_sym_let] = ACTIONS(2411),
    [anon_sym_let_BANG] = ACTIONS(2413),
    [anon_sym_LPAREN] = ACTIONS(2411),
    [anon_sym_COMMA] = ACTIONS(2413),
    [anon_sym_null] = ACTIONS(2411),
    [anon_sym_QMARK] = ACTIONS(2411),
    [anon_sym_COLON_QMARK] = ACTIONS(2411),
    [anon_sym_COLON_COLON] = ACTIONS(2413),
    [anon_sym_AMP] = ACTIONS(2411),
    [anon_sym_LBRACK] = ACTIONS(2411),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2413),
    [anon_sym_LBRACE] = ACTIONS(2411),
    [anon_sym_LT_AT] = ACTIONS(2411),
    [anon_sym_LT_AT_AT] = ACTIONS(2411),
    [anon_sym_DOT] = ACTIONS(4161),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2413),
    [anon_sym_new] = ACTIONS(2411),
    [anon_sym_return_BANG] = ACTIONS(2413),
    [anon_sym_yield] = ACTIONS(2411),
    [anon_sym_yield_BANG] = ACTIONS(2413),
    [anon_sym_lazy] = ACTIONS(2411),
    [anon_sym_assert] = ACTIONS(2411),
    [anon_sym_upcast] = ACTIONS(2411),
    [anon_sym_downcast] = ACTIONS(2411),
    [anon_sym_COLON_GT] = ACTIONS(2413),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2413),
    [anon_sym_for] = ACTIONS(2411),
    [anon_sym_while] = ACTIONS(2411),
    [anon_sym_if] = ACTIONS(2411),
    [anon_sym_fun] = ACTIONS(2411),
    [anon_sym_try] = ACTIONS(2411),
    [anon_sym_match] = ACTIONS(2411),
    [anon_sym_match_BANG] = ACTIONS(2413),
    [anon_sym_function] = ACTIONS(2411),
    [anon_sym_LT_DASH] = ACTIONS(2411),
    [anon_sym_DOT_LBRACK] = ACTIONS(2413),
    [anon_sym_LT] = ACTIONS(2413),
    [anon_sym_use] = ACTIONS(2411),
    [anon_sym_use_BANG] = ACTIONS(2413),
    [anon_sym_do_BANG] = ACTIONS(2413),
    [anon_sym_begin] = ACTIONS(2411),
    [anon_sym_LPAREN2] = ACTIONS(2411),
    [anon_sym_or] = ACTIONS(2411),
    [aux_sym_char_token1] = ACTIONS(2413),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2411),
    [anon_sym_DQUOTE] = ACTIONS(2411),
    [anon_sym_AT_DQUOTE] = ACTIONS(2413),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2413),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2413),
    [sym_bool] = ACTIONS(2411),
    [sym_unit] = ACTIONS(2413),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2411),
    [sym_op_identifier] = ACTIONS(2411),
    [anon_sym_PLUS] = ACTIONS(2411),
    [anon_sym_DASH] = ACTIONS(2411),
    [anon_sym_PLUS_DOT] = ACTIONS(2411),
    [anon_sym_DASH_DOT] = ACTIONS(2411),
    [anon_sym_PERCENT] = ACTIONS(2411),
    [anon_sym_AMP_AMP] = ACTIONS(2411),
    [anon_sym_TILDE] = ACTIONS(2413),
    [aux_sym_prefix_op_token1] = ACTIONS(2411),
    [aux_sym_infix_op_token1] = ACTIONS(2413),
    [aux_sym_infix_op_token2] = ACTIONS(2411),
    [anon_sym_PIPE_PIPE] = ACTIONS(2411),
    [anon_sym_BANG_EQ] = ACTIONS(2411),
    [anon_sym_COLON_EQ] = ACTIONS(2413),
    [anon_sym_DOLLAR] = ACTIONS(2411),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2411),
    [sym_int] = ACTIONS(2411),
    [sym_xint] = ACTIONS(2413),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2413),
    [anon_sym_POUNDendif] = ACTIONS(2413),
    [sym__newline] = ACTIONS(2413),
  },
  [1976] = {
    [sym_block_comment] = STATE(1976),
    [sym_compiler_directive_decl] = STATE(1976),
    [sym_fsi_directive_decl] = STATE(1976),
    [sym_preproc_line] = STATE(1976),
    [sym_identifier] = ACTIONS(3043),
    [anon_sym_EQ] = ACTIONS(3045),
    [anon_sym_COLON] = ACTIONS(3043),
    [anon_sym_return] = ACTIONS(3043),
    [anon_sym_do] = ACTIONS(3043),
    [anon_sym_let] = ACTIONS(3043),
    [anon_sym_let_BANG] = ACTIONS(3045),
    [anon_sym_LPAREN] = ACTIONS(3043),
    [anon_sym_COMMA] = ACTIONS(3045),
    [anon_sym_null] = ACTIONS(3043),
    [anon_sym_QMARK] = ACTIONS(3043),
    [anon_sym_COLON_QMARK] = ACTIONS(3043),
    [anon_sym_COLON_COLON] = ACTIONS(3045),
    [anon_sym_AMP] = ACTIONS(3043),
    [anon_sym_LBRACK] = ACTIONS(3043),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3045),
    [anon_sym_LBRACE] = ACTIONS(3043),
    [anon_sym_LT_AT] = ACTIONS(3043),
    [anon_sym_LT_AT_AT] = ACTIONS(3043),
    [anon_sym_DOT] = ACTIONS(3043),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3045),
    [anon_sym_new] = ACTIONS(3043),
    [anon_sym_return_BANG] = ACTIONS(3045),
    [anon_sym_yield] = ACTIONS(3043),
    [anon_sym_yield_BANG] = ACTIONS(3045),
    [anon_sym_lazy] = ACTIONS(3043),
    [anon_sym_assert] = ACTIONS(3043),
    [anon_sym_upcast] = ACTIONS(3043),
    [anon_sym_downcast] = ACTIONS(3043),
    [anon_sym_COLON_GT] = ACTIONS(3045),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3045),
    [anon_sym_for] = ACTIONS(3043),
    [anon_sym_while] = ACTIONS(3043),
    [anon_sym_if] = ACTIONS(3043),
    [anon_sym_fun] = ACTIONS(3043),
    [anon_sym_DASH_GT] = ACTIONS(3043),
    [anon_sym_try] = ACTIONS(3043),
    [anon_sym_match] = ACTIONS(3043),
    [anon_sym_match_BANG] = ACTIONS(3045),
    [anon_sym_function] = ACTIONS(3043),
    [anon_sym_LT_DASH] = ACTIONS(3043),
    [anon_sym_DOT_LBRACK] = ACTIONS(3045),
    [anon_sym_LT] = ACTIONS(3045),
    [anon_sym_use] = ACTIONS(3043),
    [anon_sym_use_BANG] = ACTIONS(3045),
    [anon_sym_do_BANG] = ACTIONS(3045),
    [anon_sym_DOT_DOT] = ACTIONS(3045),
    [anon_sym_begin] = ACTIONS(3043),
    [anon_sym_LPAREN2] = ACTIONS(3043),
    [anon_sym_or] = ACTIONS(3043),
    [aux_sym_char_token1] = ACTIONS(3045),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3043),
    [anon_sym_DQUOTE] = ACTIONS(3043),
    [anon_sym_AT_DQUOTE] = ACTIONS(3045),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3045),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3045),
    [sym_bool] = ACTIONS(3043),
    [sym_unit] = ACTIONS(3045),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3043),
    [sym_op_identifier] = ACTIONS(3043),
    [anon_sym_PLUS] = ACTIONS(3043),
    [anon_sym_DASH] = ACTIONS(3043),
    [anon_sym_PLUS_DOT] = ACTIONS(3043),
    [anon_sym_DASH_DOT] = ACTIONS(3043),
    [anon_sym_PERCENT] = ACTIONS(3043),
    [anon_sym_AMP_AMP] = ACTIONS(3043),
    [anon_sym_TILDE] = ACTIONS(3045),
    [aux_sym_prefix_op_token1] = ACTIONS(3043),
    [aux_sym_infix_op_token1] = ACTIONS(3045),
    [aux_sym_infix_op_token2] = ACTIONS(3043),
    [anon_sym_PIPE_PIPE] = ACTIONS(3043),
    [anon_sym_BANG_EQ] = ACTIONS(3043),
    [anon_sym_COLON_EQ] = ACTIONS(3045),
    [anon_sym_DOLLAR] = ACTIONS(3043),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3043),
    [sym_int] = ACTIONS(3043),
    [sym_xint] = ACTIONS(3045),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3045),
    [sym__newline] = ACTIONS(3045),
  },
  [1977] = {
    [sym_block_comment] = STATE(1977),
    [sym_compiler_directive_decl] = STATE(1977),
    [sym_fsi_directive_decl] = STATE(1977),
    [sym_preproc_line] = STATE(1977),
    [sym_identifier] = ACTIONS(3039),
    [anon_sym_EQ] = ACTIONS(3041),
    [anon_sym_COLON] = ACTIONS(3039),
    [anon_sym_return] = ACTIONS(3039),
    [anon_sym_do] = ACTIONS(3039),
    [anon_sym_let] = ACTIONS(3039),
    [anon_sym_let_BANG] = ACTIONS(3041),
    [anon_sym_LPAREN] = ACTIONS(3039),
    [anon_sym_COMMA] = ACTIONS(3041),
    [anon_sym_null] = ACTIONS(3039),
    [anon_sym_QMARK] = ACTIONS(3039),
    [anon_sym_COLON_QMARK] = ACTIONS(3039),
    [anon_sym_COLON_COLON] = ACTIONS(3041),
    [anon_sym_AMP] = ACTIONS(3039),
    [anon_sym_LBRACK] = ACTIONS(3039),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3041),
    [anon_sym_LBRACE] = ACTIONS(3039),
    [anon_sym_LT_AT] = ACTIONS(3039),
    [anon_sym_LT_AT_AT] = ACTIONS(3039),
    [anon_sym_DOT] = ACTIONS(3039),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3041),
    [anon_sym_new] = ACTIONS(3039),
    [anon_sym_return_BANG] = ACTIONS(3041),
    [anon_sym_yield] = ACTIONS(3039),
    [anon_sym_yield_BANG] = ACTIONS(3041),
    [anon_sym_lazy] = ACTIONS(3039),
    [anon_sym_assert] = ACTIONS(3039),
    [anon_sym_upcast] = ACTIONS(3039),
    [anon_sym_downcast] = ACTIONS(3039),
    [anon_sym_COLON_GT] = ACTIONS(3041),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3041),
    [anon_sym_for] = ACTIONS(3039),
    [anon_sym_while] = ACTIONS(3039),
    [anon_sym_if] = ACTIONS(3039),
    [anon_sym_fun] = ACTIONS(3039),
    [anon_sym_DASH_GT] = ACTIONS(3039),
    [anon_sym_try] = ACTIONS(3039),
    [anon_sym_match] = ACTIONS(3039),
    [anon_sym_match_BANG] = ACTIONS(3041),
    [anon_sym_function] = ACTIONS(3039),
    [anon_sym_LT_DASH] = ACTIONS(3039),
    [anon_sym_DOT_LBRACK] = ACTIONS(3041),
    [anon_sym_LT] = ACTIONS(3041),
    [anon_sym_use] = ACTIONS(3039),
    [anon_sym_use_BANG] = ACTIONS(3041),
    [anon_sym_do_BANG] = ACTIONS(3041),
    [anon_sym_DOT_DOT] = ACTIONS(3041),
    [anon_sym_begin] = ACTIONS(3039),
    [anon_sym_LPAREN2] = ACTIONS(3039),
    [anon_sym_or] = ACTIONS(3039),
    [aux_sym_char_token1] = ACTIONS(3041),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3039),
    [anon_sym_DQUOTE] = ACTIONS(3039),
    [anon_sym_AT_DQUOTE] = ACTIONS(3041),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3041),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3041),
    [sym_bool] = ACTIONS(3039),
    [sym_unit] = ACTIONS(3041),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3039),
    [sym_op_identifier] = ACTIONS(3039),
    [anon_sym_PLUS] = ACTIONS(3039),
    [anon_sym_DASH] = ACTIONS(3039),
    [anon_sym_PLUS_DOT] = ACTIONS(3039),
    [anon_sym_DASH_DOT] = ACTIONS(3039),
    [anon_sym_PERCENT] = ACTIONS(3039),
    [anon_sym_AMP_AMP] = ACTIONS(3039),
    [anon_sym_TILDE] = ACTIONS(3041),
    [aux_sym_prefix_op_token1] = ACTIONS(3039),
    [aux_sym_infix_op_token1] = ACTIONS(3041),
    [aux_sym_infix_op_token2] = ACTIONS(3039),
    [anon_sym_PIPE_PIPE] = ACTIONS(3039),
    [anon_sym_BANG_EQ] = ACTIONS(3039),
    [anon_sym_COLON_EQ] = ACTIONS(3041),
    [anon_sym_DOLLAR] = ACTIONS(3039),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3039),
    [sym_int] = ACTIONS(3039),
    [sym_xint] = ACTIONS(3041),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3041),
    [sym__newline] = ACTIONS(3041),
  },
  [1978] = {
    [sym_block_comment] = STATE(1978),
    [sym_compiler_directive_decl] = STATE(1978),
    [sym_fsi_directive_decl] = STATE(1978),
    [sym_preproc_line] = STATE(1978),
    [sym_identifier] = ACTIONS(2984),
    [anon_sym_EQ] = ACTIONS(2986),
    [anon_sym_COLON] = ACTIONS(2984),
    [anon_sym_return] = ACTIONS(2984),
    [anon_sym_do] = ACTIONS(2984),
    [anon_sym_and] = ACTIONS(2984),
    [anon_sym_let] = ACTIONS(2984),
    [anon_sym_let_BANG] = ACTIONS(2986),
    [anon_sym_LPAREN] = ACTIONS(2984),
    [anon_sym_COMMA] = ACTIONS(2986),
    [anon_sym_null] = ACTIONS(2984),
    [anon_sym_QMARK] = ACTIONS(2984),
    [anon_sym_COLON_QMARK] = ACTIONS(2984),
    [anon_sym_COLON_COLON] = ACTIONS(2986),
    [anon_sym_AMP] = ACTIONS(2984),
    [anon_sym_LBRACK] = ACTIONS(2984),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2986),
    [anon_sym_LBRACE] = ACTIONS(2984),
    [anon_sym_LT_AT] = ACTIONS(2984),
    [anon_sym_LT_AT_AT] = ACTIONS(2984),
    [anon_sym_DOT] = ACTIONS(2984),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2986),
    [anon_sym_new] = ACTIONS(2984),
    [anon_sym_return_BANG] = ACTIONS(2986),
    [anon_sym_yield] = ACTIONS(2984),
    [anon_sym_yield_BANG] = ACTIONS(2986),
    [anon_sym_lazy] = ACTIONS(2984),
    [anon_sym_assert] = ACTIONS(2984),
    [anon_sym_upcast] = ACTIONS(2984),
    [anon_sym_downcast] = ACTIONS(2984),
    [anon_sym_COLON_GT] = ACTIONS(2986),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2986),
    [anon_sym_for] = ACTIONS(2984),
    [anon_sym_while] = ACTIONS(2984),
    [anon_sym_if] = ACTIONS(2984),
    [anon_sym_fun] = ACTIONS(2984),
    [anon_sym_try] = ACTIONS(2984),
    [anon_sym_match] = ACTIONS(2984),
    [anon_sym_match_BANG] = ACTIONS(2986),
    [anon_sym_function] = ACTIONS(2984),
    [anon_sym_LT_DASH] = ACTIONS(2984),
    [anon_sym_DOT_LBRACK] = ACTIONS(2986),
    [anon_sym_LT] = ACTIONS(2986),
    [anon_sym_use] = ACTIONS(2984),
    [anon_sym_use_BANG] = ACTIONS(2986),
    [anon_sym_do_BANG] = ACTIONS(2986),
    [anon_sym_begin] = ACTIONS(2984),
    [anon_sym_LPAREN2] = ACTIONS(2984),
    [anon_sym_or] = ACTIONS(2984),
    [aux_sym_char_token1] = ACTIONS(2986),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2984),
    [anon_sym_DQUOTE] = ACTIONS(2984),
    [anon_sym_AT_DQUOTE] = ACTIONS(2986),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2986),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2986),
    [sym_bool] = ACTIONS(2984),
    [sym_unit] = ACTIONS(2986),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2984),
    [sym_op_identifier] = ACTIONS(2984),
    [anon_sym_PLUS] = ACTIONS(2984),
    [anon_sym_DASH] = ACTIONS(2984),
    [anon_sym_PLUS_DOT] = ACTIONS(2984),
    [anon_sym_DASH_DOT] = ACTIONS(2984),
    [anon_sym_PERCENT] = ACTIONS(2984),
    [anon_sym_AMP_AMP] = ACTIONS(2984),
    [anon_sym_TILDE] = ACTIONS(2986),
    [aux_sym_prefix_op_token1] = ACTIONS(2984),
    [aux_sym_infix_op_token1] = ACTIONS(2986),
    [aux_sym_infix_op_token2] = ACTIONS(2984),
    [anon_sym_PIPE_PIPE] = ACTIONS(2984),
    [anon_sym_BANG_EQ] = ACTIONS(2984),
    [anon_sym_COLON_EQ] = ACTIONS(2986),
    [anon_sym_DOLLAR] = ACTIONS(2984),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2984),
    [sym_int] = ACTIONS(2984),
    [sym_xint] = ACTIONS(2986),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2986),
    [sym__newline] = ACTIONS(2986),
    [sym__dedent] = ACTIONS(2986),
  },
  [1979] = {
    [sym_block_comment] = STATE(1979),
    [sym_compiler_directive_decl] = STATE(1979),
    [sym_fsi_directive_decl] = STATE(1979),
    [sym_preproc_line] = STATE(1979),
    [sym_identifier] = ACTIONS(2766),
    [anon_sym_EQ] = ACTIONS(2768),
    [anon_sym_COLON] = ACTIONS(2766),
    [anon_sym_return] = ACTIONS(2766),
    [anon_sym_do] = ACTIONS(2766),
    [anon_sym_let] = ACTIONS(2766),
    [anon_sym_let_BANG] = ACTIONS(2768),
    [anon_sym_LPAREN] = ACTIONS(2766),
    [anon_sym_COMMA] = ACTIONS(2768),
    [anon_sym_null] = ACTIONS(2766),
    [anon_sym_QMARK] = ACTIONS(2766),
    [anon_sym_COLON_QMARK] = ACTIONS(2766),
    [anon_sym_COLON_COLON] = ACTIONS(2768),
    [anon_sym_PIPE] = ACTIONS(2766),
    [anon_sym_AMP] = ACTIONS(2766),
    [anon_sym_LBRACK] = ACTIONS(2766),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2768),
    [anon_sym_LBRACE] = ACTIONS(2766),
    [anon_sym_LT_AT] = ACTIONS(2766),
    [anon_sym_AT_GT] = ACTIONS(2766),
    [anon_sym_LT_AT_AT] = ACTIONS(2766),
    [anon_sym_DOT] = ACTIONS(2766),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2768),
    [anon_sym_new] = ACTIONS(2766),
    [anon_sym_return_BANG] = ACTIONS(2768),
    [anon_sym_yield] = ACTIONS(2766),
    [anon_sym_yield_BANG] = ACTIONS(2768),
    [anon_sym_lazy] = ACTIONS(2766),
    [anon_sym_assert] = ACTIONS(2766),
    [anon_sym_upcast] = ACTIONS(2766),
    [anon_sym_downcast] = ACTIONS(2766),
    [anon_sym_COLON_GT] = ACTIONS(2768),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2768),
    [anon_sym_for] = ACTIONS(2766),
    [anon_sym_while] = ACTIONS(2766),
    [anon_sym_if] = ACTIONS(2766),
    [anon_sym_fun] = ACTIONS(2766),
    [anon_sym_try] = ACTIONS(2766),
    [anon_sym_match] = ACTIONS(2766),
    [anon_sym_match_BANG] = ACTIONS(2768),
    [anon_sym_function] = ACTIONS(2766),
    [anon_sym_LT_DASH] = ACTIONS(2766),
    [anon_sym_DOT_LBRACK] = ACTIONS(2768),
    [anon_sym_LT] = ACTIONS(2768),
    [anon_sym_use] = ACTIONS(2766),
    [anon_sym_use_BANG] = ACTIONS(2768),
    [anon_sym_do_BANG] = ACTIONS(2768),
    [anon_sym_begin] = ACTIONS(2766),
    [anon_sym_LPAREN2] = ACTIONS(2766),
    [anon_sym_or] = ACTIONS(2766),
    [aux_sym_char_token1] = ACTIONS(2768),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2766),
    [anon_sym_DQUOTE] = ACTIONS(2766),
    [anon_sym_AT_DQUOTE] = ACTIONS(2768),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2768),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2768),
    [sym_bool] = ACTIONS(2766),
    [sym_unit] = ACTIONS(2768),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2766),
    [sym_op_identifier] = ACTIONS(2766),
    [anon_sym_PLUS] = ACTIONS(2766),
    [anon_sym_DASH] = ACTIONS(2766),
    [anon_sym_PLUS_DOT] = ACTIONS(2766),
    [anon_sym_DASH_DOT] = ACTIONS(2766),
    [anon_sym_PERCENT] = ACTIONS(2766),
    [anon_sym_AMP_AMP] = ACTIONS(2766),
    [anon_sym_TILDE] = ACTIONS(2768),
    [aux_sym_prefix_op_token1] = ACTIONS(2766),
    [aux_sym_infix_op_token1] = ACTIONS(2768),
    [aux_sym_infix_op_token2] = ACTIONS(2766),
    [anon_sym_PIPE_PIPE] = ACTIONS(2766),
    [anon_sym_BANG_EQ] = ACTIONS(2766),
    [anon_sym_COLON_EQ] = ACTIONS(2768),
    [anon_sym_DOLLAR] = ACTIONS(2766),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2766),
    [sym_int] = ACTIONS(2766),
    [sym_xint] = ACTIONS(2768),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2768),
    [sym__newline] = ACTIONS(2768),
  },
  [1980] = {
    [sym_block_comment] = STATE(1980),
    [sym_compiler_directive_decl] = STATE(1980),
    [sym_fsi_directive_decl] = STATE(1980),
    [sym_preproc_line] = STATE(1980),
    [sym_identifier] = ACTIONS(2713),
    [anon_sym_EQ] = ACTIONS(2715),
    [anon_sym_COLON] = ACTIONS(2713),
    [anon_sym_return] = ACTIONS(2713),
    [anon_sym_do] = ACTIONS(2713),
    [anon_sym_let] = ACTIONS(2713),
    [anon_sym_let_BANG] = ACTIONS(2715),
    [anon_sym_LPAREN] = ACTIONS(2713),
    [anon_sym_COMMA] = ACTIONS(2715),
    [anon_sym_null] = ACTIONS(2713),
    [anon_sym_QMARK] = ACTIONS(2713),
    [anon_sym_COLON_QMARK] = ACTIONS(2713),
    [anon_sym_COLON_COLON] = ACTIONS(2715),
    [anon_sym_PIPE] = ACTIONS(2713),
    [anon_sym_AMP] = ACTIONS(2713),
    [anon_sym_LBRACK] = ACTIONS(2713),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2715),
    [anon_sym_LBRACE] = ACTIONS(2713),
    [anon_sym_LT_AT] = ACTIONS(2713),
    [anon_sym_AT_GT] = ACTIONS(2713),
    [anon_sym_LT_AT_AT] = ACTIONS(2713),
    [anon_sym_DOT] = ACTIONS(2713),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2715),
    [anon_sym_new] = ACTIONS(2713),
    [anon_sym_return_BANG] = ACTIONS(2715),
    [anon_sym_yield] = ACTIONS(2713),
    [anon_sym_yield_BANG] = ACTIONS(2715),
    [anon_sym_lazy] = ACTIONS(2713),
    [anon_sym_assert] = ACTIONS(2713),
    [anon_sym_upcast] = ACTIONS(2713),
    [anon_sym_downcast] = ACTIONS(2713),
    [anon_sym_COLON_GT] = ACTIONS(2715),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2715),
    [anon_sym_for] = ACTIONS(2713),
    [anon_sym_while] = ACTIONS(2713),
    [anon_sym_if] = ACTIONS(2713),
    [anon_sym_fun] = ACTIONS(2713),
    [anon_sym_try] = ACTIONS(2713),
    [anon_sym_match] = ACTIONS(2713),
    [anon_sym_match_BANG] = ACTIONS(2715),
    [anon_sym_function] = ACTIONS(2713),
    [anon_sym_LT_DASH] = ACTIONS(2713),
    [anon_sym_DOT_LBRACK] = ACTIONS(2715),
    [anon_sym_LT] = ACTIONS(2715),
    [anon_sym_use] = ACTIONS(2713),
    [anon_sym_use_BANG] = ACTIONS(2715),
    [anon_sym_do_BANG] = ACTIONS(2715),
    [anon_sym_begin] = ACTIONS(2713),
    [anon_sym_LPAREN2] = ACTIONS(2713),
    [anon_sym_or] = ACTIONS(2713),
    [aux_sym_char_token1] = ACTIONS(2715),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2713),
    [anon_sym_DQUOTE] = ACTIONS(2713),
    [anon_sym_AT_DQUOTE] = ACTIONS(2715),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2715),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2715),
    [sym_bool] = ACTIONS(2713),
    [sym_unit] = ACTIONS(2715),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2713),
    [sym_op_identifier] = ACTIONS(2713),
    [anon_sym_PLUS] = ACTIONS(2713),
    [anon_sym_DASH] = ACTIONS(2713),
    [anon_sym_PLUS_DOT] = ACTIONS(2713),
    [anon_sym_DASH_DOT] = ACTIONS(2713),
    [anon_sym_PERCENT] = ACTIONS(2713),
    [anon_sym_AMP_AMP] = ACTIONS(2713),
    [anon_sym_TILDE] = ACTIONS(2715),
    [aux_sym_prefix_op_token1] = ACTIONS(2713),
    [aux_sym_infix_op_token1] = ACTIONS(2715),
    [aux_sym_infix_op_token2] = ACTIONS(2713),
    [anon_sym_PIPE_PIPE] = ACTIONS(2713),
    [anon_sym_BANG_EQ] = ACTIONS(2713),
    [anon_sym_COLON_EQ] = ACTIONS(2715),
    [anon_sym_DOLLAR] = ACTIONS(2713),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2713),
    [sym_int] = ACTIONS(2713),
    [sym_xint] = ACTIONS(2715),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2715),
    [sym__newline] = ACTIONS(2715),
  },
  [1981] = {
    [sym_block_comment] = STATE(1981),
    [sym_compiler_directive_decl] = STATE(1981),
    [sym_fsi_directive_decl] = STATE(1981),
    [sym_preproc_line] = STATE(1981),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_EQ] = ACTIONS(3017),
    [anon_sym_COLON] = ACTIONS(3015),
    [anon_sym_return] = ACTIONS(3015),
    [anon_sym_do] = ACTIONS(3015),
    [anon_sym_let] = ACTIONS(3015),
    [anon_sym_let_BANG] = ACTIONS(3017),
    [anon_sym_LPAREN] = ACTIONS(3015),
    [anon_sym_COMMA] = ACTIONS(3017),
    [anon_sym_null] = ACTIONS(3015),
    [anon_sym_QMARK] = ACTIONS(3015),
    [anon_sym_COLON_QMARK] = ACTIONS(3015),
    [anon_sym_COLON_COLON] = ACTIONS(3017),
    [anon_sym_AMP] = ACTIONS(3015),
    [anon_sym_LBRACK] = ACTIONS(3015),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3017),
    [anon_sym_LBRACE] = ACTIONS(3015),
    [anon_sym_LT_AT] = ACTIONS(3015),
    [anon_sym_LT_AT_AT] = ACTIONS(3015),
    [anon_sym_DOT] = ACTIONS(3015),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3017),
    [anon_sym_new] = ACTIONS(3015),
    [anon_sym_return_BANG] = ACTIONS(3017),
    [anon_sym_yield] = ACTIONS(3015),
    [anon_sym_yield_BANG] = ACTIONS(3017),
    [anon_sym_lazy] = ACTIONS(3015),
    [anon_sym_assert] = ACTIONS(3015),
    [anon_sym_upcast] = ACTIONS(3015),
    [anon_sym_downcast] = ACTIONS(3015),
    [anon_sym_COLON_GT] = ACTIONS(3017),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3017),
    [anon_sym_for] = ACTIONS(3015),
    [anon_sym_while] = ACTIONS(3015),
    [anon_sym_if] = ACTIONS(3015),
    [anon_sym_fun] = ACTIONS(3015),
    [anon_sym_DASH_GT] = ACTIONS(3015),
    [anon_sym_try] = ACTIONS(3015),
    [anon_sym_match] = ACTIONS(3015),
    [anon_sym_match_BANG] = ACTIONS(3017),
    [anon_sym_function] = ACTIONS(3015),
    [anon_sym_LT_DASH] = ACTIONS(3015),
    [anon_sym_DOT_LBRACK] = ACTIONS(3017),
    [anon_sym_LT] = ACTIONS(3017),
    [anon_sym_use] = ACTIONS(3015),
    [anon_sym_use_BANG] = ACTIONS(3017),
    [anon_sym_do_BANG] = ACTIONS(3017),
    [anon_sym_DOT_DOT] = ACTIONS(3017),
    [anon_sym_begin] = ACTIONS(3015),
    [anon_sym_LPAREN2] = ACTIONS(3015),
    [anon_sym_or] = ACTIONS(3015),
    [aux_sym_char_token1] = ACTIONS(3017),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3015),
    [anon_sym_DQUOTE] = ACTIONS(3015),
    [anon_sym_AT_DQUOTE] = ACTIONS(3017),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3017),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3017),
    [sym_bool] = ACTIONS(3015),
    [sym_unit] = ACTIONS(3017),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3015),
    [sym_op_identifier] = ACTIONS(3015),
    [anon_sym_PLUS] = ACTIONS(3015),
    [anon_sym_DASH] = ACTIONS(3015),
    [anon_sym_PLUS_DOT] = ACTIONS(3015),
    [anon_sym_DASH_DOT] = ACTIONS(3015),
    [anon_sym_PERCENT] = ACTIONS(3015),
    [anon_sym_AMP_AMP] = ACTIONS(3015),
    [anon_sym_TILDE] = ACTIONS(3017),
    [aux_sym_prefix_op_token1] = ACTIONS(3015),
    [aux_sym_infix_op_token1] = ACTIONS(3017),
    [aux_sym_infix_op_token2] = ACTIONS(3015),
    [anon_sym_PIPE_PIPE] = ACTIONS(3015),
    [anon_sym_BANG_EQ] = ACTIONS(3015),
    [anon_sym_COLON_EQ] = ACTIONS(3017),
    [anon_sym_DOLLAR] = ACTIONS(3015),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3015),
    [sym_int] = ACTIONS(3015),
    [sym_xint] = ACTIONS(3017),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3017),
    [sym__newline] = ACTIONS(3017),
  },
  [1982] = {
    [sym_block_comment] = STATE(1982),
    [sym_compiler_directive_decl] = STATE(1982),
    [sym_fsi_directive_decl] = STATE(1982),
    [sym_preproc_line] = STATE(1982),
    [sym_identifier] = ACTIONS(3007),
    [anon_sym_EQ] = ACTIONS(3009),
    [anon_sym_COLON] = ACTIONS(3007),
    [anon_sym_return] = ACTIONS(3007),
    [anon_sym_do] = ACTIONS(3007),
    [anon_sym_let] = ACTIONS(3007),
    [anon_sym_let_BANG] = ACTIONS(3009),
    [anon_sym_LPAREN] = ACTIONS(3007),
    [anon_sym_COMMA] = ACTIONS(3009),
    [anon_sym_null] = ACTIONS(3007),
    [anon_sym_QMARK] = ACTIONS(3007),
    [anon_sym_COLON_QMARK] = ACTIONS(3007),
    [anon_sym_COLON_COLON] = ACTIONS(3009),
    [anon_sym_AMP] = ACTIONS(3007),
    [anon_sym_LBRACK] = ACTIONS(3007),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3009),
    [anon_sym_LBRACE] = ACTIONS(3007),
    [anon_sym_LT_AT] = ACTIONS(3007),
    [anon_sym_LT_AT_AT] = ACTIONS(3007),
    [anon_sym_DOT] = ACTIONS(3007),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3009),
    [anon_sym_new] = ACTIONS(3007),
    [anon_sym_return_BANG] = ACTIONS(3009),
    [anon_sym_yield] = ACTIONS(3007),
    [anon_sym_yield_BANG] = ACTIONS(3009),
    [anon_sym_lazy] = ACTIONS(3007),
    [anon_sym_assert] = ACTIONS(3007),
    [anon_sym_upcast] = ACTIONS(3007),
    [anon_sym_downcast] = ACTIONS(3007),
    [anon_sym_COLON_GT] = ACTIONS(3009),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3009),
    [anon_sym_for] = ACTIONS(3007),
    [anon_sym_while] = ACTIONS(3007),
    [anon_sym_if] = ACTIONS(3007),
    [anon_sym_fun] = ACTIONS(3007),
    [anon_sym_DASH_GT] = ACTIONS(3007),
    [anon_sym_try] = ACTIONS(3007),
    [anon_sym_match] = ACTIONS(3007),
    [anon_sym_match_BANG] = ACTIONS(3009),
    [anon_sym_function] = ACTIONS(3007),
    [anon_sym_LT_DASH] = ACTIONS(3007),
    [anon_sym_DOT_LBRACK] = ACTIONS(3009),
    [anon_sym_LT] = ACTIONS(3009),
    [anon_sym_use] = ACTIONS(3007),
    [anon_sym_use_BANG] = ACTIONS(3009),
    [anon_sym_do_BANG] = ACTIONS(3009),
    [anon_sym_DOT_DOT] = ACTIONS(3009),
    [anon_sym_begin] = ACTIONS(3007),
    [anon_sym_LPAREN2] = ACTIONS(3007),
    [anon_sym_or] = ACTIONS(3007),
    [aux_sym_char_token1] = ACTIONS(3009),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3007),
    [anon_sym_DQUOTE] = ACTIONS(3007),
    [anon_sym_AT_DQUOTE] = ACTIONS(3009),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3009),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3009),
    [sym_bool] = ACTIONS(3007),
    [sym_unit] = ACTIONS(3009),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3007),
    [sym_op_identifier] = ACTIONS(3007),
    [anon_sym_PLUS] = ACTIONS(3007),
    [anon_sym_DASH] = ACTIONS(3007),
    [anon_sym_PLUS_DOT] = ACTIONS(3007),
    [anon_sym_DASH_DOT] = ACTIONS(3007),
    [anon_sym_PERCENT] = ACTIONS(3007),
    [anon_sym_AMP_AMP] = ACTIONS(3007),
    [anon_sym_TILDE] = ACTIONS(3009),
    [aux_sym_prefix_op_token1] = ACTIONS(3007),
    [aux_sym_infix_op_token1] = ACTIONS(3009),
    [aux_sym_infix_op_token2] = ACTIONS(3007),
    [anon_sym_PIPE_PIPE] = ACTIONS(3007),
    [anon_sym_BANG_EQ] = ACTIONS(3007),
    [anon_sym_COLON_EQ] = ACTIONS(3009),
    [anon_sym_DOLLAR] = ACTIONS(3007),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3007),
    [sym_int] = ACTIONS(3007),
    [sym_xint] = ACTIONS(3009),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3009),
    [sym__newline] = ACTIONS(3009),
  },
  [1983] = {
    [sym_block_comment] = STATE(1983),
    [sym_compiler_directive_decl] = STATE(1983),
    [sym_fsi_directive_decl] = STATE(1983),
    [sym_preproc_line] = STATE(1983),
    [aux_sym_long_identifier_repeat1] = STATE(1975),
    [sym_identifier] = ACTIONS(2418),
    [anon_sym_EQ] = ACTIONS(2420),
    [anon_sym_COLON] = ACTIONS(2418),
    [anon_sym_return] = ACTIONS(2418),
    [anon_sym_do] = ACTIONS(2418),
    [anon_sym_let] = ACTIONS(2418),
    [anon_sym_let_BANG] = ACTIONS(2420),
    [anon_sym_LPAREN] = ACTIONS(2418),
    [anon_sym_COMMA] = ACTIONS(2420),
    [anon_sym_null] = ACTIONS(2418),
    [anon_sym_QMARK] = ACTIONS(2418),
    [anon_sym_COLON_QMARK] = ACTIONS(2418),
    [anon_sym_COLON_COLON] = ACTIONS(2420),
    [anon_sym_AMP] = ACTIONS(2418),
    [anon_sym_LBRACK] = ACTIONS(2418),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2420),
    [anon_sym_LBRACE] = ACTIONS(2418),
    [anon_sym_LT_AT] = ACTIONS(2418),
    [anon_sym_LT_AT_AT] = ACTIONS(2418),
    [anon_sym_DOT] = ACTIONS(4164),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2420),
    [anon_sym_new] = ACTIONS(2418),
    [anon_sym_return_BANG] = ACTIONS(2420),
    [anon_sym_yield] = ACTIONS(2418),
    [anon_sym_yield_BANG] = ACTIONS(2420),
    [anon_sym_lazy] = ACTIONS(2418),
    [anon_sym_assert] = ACTIONS(2418),
    [anon_sym_upcast] = ACTIONS(2418),
    [anon_sym_downcast] = ACTIONS(2418),
    [anon_sym_COLON_GT] = ACTIONS(2420),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2420),
    [anon_sym_for] = ACTIONS(2418),
    [anon_sym_while] = ACTIONS(2418),
    [anon_sym_if] = ACTIONS(2418),
    [anon_sym_fun] = ACTIONS(2418),
    [anon_sym_try] = ACTIONS(2418),
    [anon_sym_match] = ACTIONS(2418),
    [anon_sym_match_BANG] = ACTIONS(2420),
    [anon_sym_function] = ACTIONS(2418),
    [anon_sym_LT_DASH] = ACTIONS(2418),
    [anon_sym_DOT_LBRACK] = ACTIONS(2420),
    [anon_sym_LT] = ACTIONS(2420),
    [anon_sym_use] = ACTIONS(2418),
    [anon_sym_use_BANG] = ACTIONS(2420),
    [anon_sym_do_BANG] = ACTIONS(2420),
    [anon_sym_begin] = ACTIONS(2418),
    [anon_sym_LPAREN2] = ACTIONS(2418),
    [anon_sym_or] = ACTIONS(2418),
    [aux_sym_char_token1] = ACTIONS(2420),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2418),
    [anon_sym_DQUOTE] = ACTIONS(2418),
    [anon_sym_AT_DQUOTE] = ACTIONS(2420),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2420),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2420),
    [sym_bool] = ACTIONS(2418),
    [sym_unit] = ACTIONS(2420),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2418),
    [sym_op_identifier] = ACTIONS(2418),
    [anon_sym_PLUS] = ACTIONS(2418),
    [anon_sym_DASH] = ACTIONS(2418),
    [anon_sym_PLUS_DOT] = ACTIONS(2418),
    [anon_sym_DASH_DOT] = ACTIONS(2418),
    [anon_sym_PERCENT] = ACTIONS(2418),
    [anon_sym_AMP_AMP] = ACTIONS(2418),
    [anon_sym_TILDE] = ACTIONS(2420),
    [aux_sym_prefix_op_token1] = ACTIONS(2418),
    [aux_sym_infix_op_token1] = ACTIONS(2420),
    [aux_sym_infix_op_token2] = ACTIONS(2418),
    [anon_sym_PIPE_PIPE] = ACTIONS(2418),
    [anon_sym_BANG_EQ] = ACTIONS(2418),
    [anon_sym_COLON_EQ] = ACTIONS(2420),
    [anon_sym_DOLLAR] = ACTIONS(2418),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2418),
    [sym_int] = ACTIONS(2418),
    [sym_xint] = ACTIONS(2420),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2420),
    [anon_sym_POUNDendif] = ACTIONS(2420),
    [sym__newline] = ACTIONS(2420),
  },
  [1984] = {
    [sym_block_comment] = STATE(1984),
    [sym_compiler_directive_decl] = STATE(1984),
    [sym_fsi_directive_decl] = STATE(1984),
    [sym_preproc_line] = STATE(1984),
    [sym_identifier] = ACTIONS(3003),
    [anon_sym_EQ] = ACTIONS(3005),
    [anon_sym_COLON] = ACTIONS(3003),
    [anon_sym_return] = ACTIONS(3003),
    [anon_sym_do] = ACTIONS(3003),
    [anon_sym_let] = ACTIONS(3003),
    [anon_sym_let_BANG] = ACTIONS(3005),
    [anon_sym_LPAREN] = ACTIONS(3003),
    [anon_sym_COMMA] = ACTIONS(3005),
    [anon_sym_null] = ACTIONS(3003),
    [anon_sym_QMARK] = ACTIONS(3003),
    [anon_sym_COLON_QMARK] = ACTIONS(3003),
    [anon_sym_COLON_COLON] = ACTIONS(3005),
    [anon_sym_AMP] = ACTIONS(3003),
    [anon_sym_LBRACK] = ACTIONS(3003),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3005),
    [anon_sym_LBRACE] = ACTIONS(3003),
    [anon_sym_LT_AT] = ACTIONS(3003),
    [anon_sym_LT_AT_AT] = ACTIONS(3003),
    [anon_sym_DOT] = ACTIONS(3003),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3005),
    [anon_sym_new] = ACTIONS(3003),
    [anon_sym_return_BANG] = ACTIONS(3005),
    [anon_sym_yield] = ACTIONS(3003),
    [anon_sym_yield_BANG] = ACTIONS(3005),
    [anon_sym_lazy] = ACTIONS(3003),
    [anon_sym_assert] = ACTIONS(3003),
    [anon_sym_upcast] = ACTIONS(3003),
    [anon_sym_downcast] = ACTIONS(3003),
    [anon_sym_COLON_GT] = ACTIONS(3005),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3005),
    [anon_sym_for] = ACTIONS(3003),
    [anon_sym_while] = ACTIONS(3003),
    [anon_sym_if] = ACTIONS(3003),
    [anon_sym_fun] = ACTIONS(3003),
    [anon_sym_DASH_GT] = ACTIONS(3003),
    [anon_sym_try] = ACTIONS(3003),
    [anon_sym_match] = ACTIONS(3003),
    [anon_sym_match_BANG] = ACTIONS(3005),
    [anon_sym_function] = ACTIONS(3003),
    [anon_sym_LT_DASH] = ACTIONS(3003),
    [anon_sym_DOT_LBRACK] = ACTIONS(3005),
    [anon_sym_LT] = ACTIONS(3005),
    [anon_sym_use] = ACTIONS(3003),
    [anon_sym_use_BANG] = ACTIONS(3005),
    [anon_sym_do_BANG] = ACTIONS(3005),
    [anon_sym_DOT_DOT] = ACTIONS(3005),
    [anon_sym_begin] = ACTIONS(3003),
    [anon_sym_LPAREN2] = ACTIONS(3003),
    [anon_sym_or] = ACTIONS(3003),
    [aux_sym_char_token1] = ACTIONS(3005),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3003),
    [anon_sym_DQUOTE] = ACTIONS(3003),
    [anon_sym_AT_DQUOTE] = ACTIONS(3005),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3005),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3005),
    [sym_bool] = ACTIONS(3003),
    [sym_unit] = ACTIONS(3005),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3003),
    [sym_op_identifier] = ACTIONS(3003),
    [anon_sym_PLUS] = ACTIONS(3003),
    [anon_sym_DASH] = ACTIONS(3003),
    [anon_sym_PLUS_DOT] = ACTIONS(3003),
    [anon_sym_DASH_DOT] = ACTIONS(3003),
    [anon_sym_PERCENT] = ACTIONS(3003),
    [anon_sym_AMP_AMP] = ACTIONS(3003),
    [anon_sym_TILDE] = ACTIONS(3005),
    [aux_sym_prefix_op_token1] = ACTIONS(3003),
    [aux_sym_infix_op_token1] = ACTIONS(3005),
    [aux_sym_infix_op_token2] = ACTIONS(3003),
    [anon_sym_PIPE_PIPE] = ACTIONS(3003),
    [anon_sym_BANG_EQ] = ACTIONS(3003),
    [anon_sym_COLON_EQ] = ACTIONS(3005),
    [anon_sym_DOLLAR] = ACTIONS(3003),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3003),
    [sym_int] = ACTIONS(3003),
    [sym_xint] = ACTIONS(3005),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3005),
    [sym__newline] = ACTIONS(3005),
  },
  [1985] = {
    [sym_block_comment] = STATE(1985),
    [sym_compiler_directive_decl] = STATE(1985),
    [sym_fsi_directive_decl] = STATE(1985),
    [sym_preproc_line] = STATE(1985),
    [sym_identifier] = ACTIONS(2996),
    [anon_sym_EQ] = ACTIONS(2998),
    [anon_sym_COLON] = ACTIONS(2996),
    [anon_sym_return] = ACTIONS(2996),
    [anon_sym_do] = ACTIONS(2996),
    [anon_sym_let] = ACTIONS(2996),
    [anon_sym_let_BANG] = ACTIONS(2998),
    [anon_sym_LPAREN] = ACTIONS(2996),
    [anon_sym_COMMA] = ACTIONS(2998),
    [anon_sym_null] = ACTIONS(2996),
    [anon_sym_QMARK] = ACTIONS(2996),
    [anon_sym_COLON_QMARK] = ACTIONS(2996),
    [anon_sym_COLON_COLON] = ACTIONS(2998),
    [anon_sym_AMP] = ACTIONS(2996),
    [anon_sym_LBRACK] = ACTIONS(2996),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2998),
    [anon_sym_LBRACE] = ACTIONS(2996),
    [anon_sym_LT_AT] = ACTIONS(2996),
    [anon_sym_LT_AT_AT] = ACTIONS(2996),
    [anon_sym_DOT] = ACTIONS(2996),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2998),
    [anon_sym_new] = ACTIONS(2996),
    [anon_sym_return_BANG] = ACTIONS(2998),
    [anon_sym_yield] = ACTIONS(2996),
    [anon_sym_yield_BANG] = ACTIONS(2998),
    [anon_sym_lazy] = ACTIONS(2996),
    [anon_sym_assert] = ACTIONS(2996),
    [anon_sym_upcast] = ACTIONS(2996),
    [anon_sym_downcast] = ACTIONS(2996),
    [anon_sym_COLON_GT] = ACTIONS(2998),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2998),
    [anon_sym_for] = ACTIONS(2996),
    [anon_sym_while] = ACTIONS(2996),
    [anon_sym_if] = ACTIONS(2996),
    [anon_sym_fun] = ACTIONS(2996),
    [anon_sym_DASH_GT] = ACTIONS(2996),
    [anon_sym_try] = ACTIONS(2996),
    [anon_sym_match] = ACTIONS(2996),
    [anon_sym_match_BANG] = ACTIONS(2998),
    [anon_sym_function] = ACTIONS(2996),
    [anon_sym_LT_DASH] = ACTIONS(2996),
    [anon_sym_DOT_LBRACK] = ACTIONS(2998),
    [anon_sym_LT] = ACTIONS(2998),
    [anon_sym_use] = ACTIONS(2996),
    [anon_sym_use_BANG] = ACTIONS(2998),
    [anon_sym_do_BANG] = ACTIONS(2998),
    [anon_sym_DOT_DOT] = ACTIONS(2998),
    [anon_sym_begin] = ACTIONS(2996),
    [anon_sym_LPAREN2] = ACTIONS(2996),
    [anon_sym_or] = ACTIONS(2996),
    [aux_sym_char_token1] = ACTIONS(2998),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2996),
    [anon_sym_DQUOTE] = ACTIONS(2996),
    [anon_sym_AT_DQUOTE] = ACTIONS(2998),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2998),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2998),
    [sym_bool] = ACTIONS(2996),
    [sym_unit] = ACTIONS(2998),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2996),
    [sym_op_identifier] = ACTIONS(2996),
    [anon_sym_PLUS] = ACTIONS(2996),
    [anon_sym_DASH] = ACTIONS(2996),
    [anon_sym_PLUS_DOT] = ACTIONS(2996),
    [anon_sym_DASH_DOT] = ACTIONS(2996),
    [anon_sym_PERCENT] = ACTIONS(2996),
    [anon_sym_AMP_AMP] = ACTIONS(2996),
    [anon_sym_TILDE] = ACTIONS(2998),
    [aux_sym_prefix_op_token1] = ACTIONS(2996),
    [aux_sym_infix_op_token1] = ACTIONS(2998),
    [aux_sym_infix_op_token2] = ACTIONS(2996),
    [anon_sym_PIPE_PIPE] = ACTIONS(2996),
    [anon_sym_BANG_EQ] = ACTIONS(2996),
    [anon_sym_COLON_EQ] = ACTIONS(2998),
    [anon_sym_DOLLAR] = ACTIONS(2996),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2996),
    [sym_int] = ACTIONS(2996),
    [sym_xint] = ACTIONS(2998),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2998),
    [sym__newline] = ACTIONS(2998),
  },
  [1986] = {
    [sym_block_comment] = STATE(1986),
    [sym_compiler_directive_decl] = STATE(1986),
    [sym_fsi_directive_decl] = STATE(1986),
    [sym_preproc_line] = STATE(1986),
    [sym_identifier] = ACTIONS(2992),
    [anon_sym_EQ] = ACTIONS(2994),
    [anon_sym_COLON] = ACTIONS(2992),
    [anon_sym_return] = ACTIONS(2992),
    [anon_sym_do] = ACTIONS(2992),
    [anon_sym_let] = ACTIONS(2992),
    [anon_sym_let_BANG] = ACTIONS(2994),
    [anon_sym_LPAREN] = ACTIONS(2992),
    [anon_sym_COMMA] = ACTIONS(2994),
    [anon_sym_null] = ACTIONS(2992),
    [anon_sym_QMARK] = ACTIONS(2992),
    [anon_sym_COLON_QMARK] = ACTIONS(2992),
    [anon_sym_COLON_COLON] = ACTIONS(2994),
    [anon_sym_AMP] = ACTIONS(2992),
    [anon_sym_LBRACK] = ACTIONS(2992),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2994),
    [anon_sym_LBRACE] = ACTIONS(2992),
    [anon_sym_LT_AT] = ACTIONS(2992),
    [anon_sym_LT_AT_AT] = ACTIONS(2992),
    [anon_sym_DOT] = ACTIONS(2992),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2994),
    [anon_sym_new] = ACTIONS(2992),
    [anon_sym_return_BANG] = ACTIONS(2994),
    [anon_sym_yield] = ACTIONS(2992),
    [anon_sym_yield_BANG] = ACTIONS(2994),
    [anon_sym_lazy] = ACTIONS(2992),
    [anon_sym_assert] = ACTIONS(2992),
    [anon_sym_upcast] = ACTIONS(2992),
    [anon_sym_downcast] = ACTIONS(2992),
    [anon_sym_COLON_GT] = ACTIONS(2994),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2994),
    [anon_sym_for] = ACTIONS(2992),
    [anon_sym_while] = ACTIONS(2992),
    [anon_sym_if] = ACTIONS(2992),
    [anon_sym_fun] = ACTIONS(2992),
    [anon_sym_DASH_GT] = ACTIONS(2992),
    [anon_sym_try] = ACTIONS(2992),
    [anon_sym_match] = ACTIONS(2992),
    [anon_sym_match_BANG] = ACTIONS(2994),
    [anon_sym_function] = ACTIONS(2992),
    [anon_sym_LT_DASH] = ACTIONS(2992),
    [anon_sym_DOT_LBRACK] = ACTIONS(2994),
    [anon_sym_LT] = ACTIONS(2994),
    [anon_sym_use] = ACTIONS(2992),
    [anon_sym_use_BANG] = ACTIONS(2994),
    [anon_sym_do_BANG] = ACTIONS(2994),
    [anon_sym_DOT_DOT] = ACTIONS(2994),
    [anon_sym_begin] = ACTIONS(2992),
    [anon_sym_LPAREN2] = ACTIONS(2992),
    [anon_sym_or] = ACTIONS(2992),
    [aux_sym_char_token1] = ACTIONS(2994),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2992),
    [anon_sym_DQUOTE] = ACTIONS(2992),
    [anon_sym_AT_DQUOTE] = ACTIONS(2994),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2994),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2994),
    [sym_bool] = ACTIONS(2992),
    [sym_unit] = ACTIONS(2994),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2992),
    [sym_op_identifier] = ACTIONS(2992),
    [anon_sym_PLUS] = ACTIONS(2992),
    [anon_sym_DASH] = ACTIONS(2992),
    [anon_sym_PLUS_DOT] = ACTIONS(2992),
    [anon_sym_DASH_DOT] = ACTIONS(2992),
    [anon_sym_PERCENT] = ACTIONS(2992),
    [anon_sym_AMP_AMP] = ACTIONS(2992),
    [anon_sym_TILDE] = ACTIONS(2994),
    [aux_sym_prefix_op_token1] = ACTIONS(2992),
    [aux_sym_infix_op_token1] = ACTIONS(2994),
    [aux_sym_infix_op_token2] = ACTIONS(2992),
    [anon_sym_PIPE_PIPE] = ACTIONS(2992),
    [anon_sym_BANG_EQ] = ACTIONS(2992),
    [anon_sym_COLON_EQ] = ACTIONS(2994),
    [anon_sym_DOLLAR] = ACTIONS(2992),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2992),
    [sym_int] = ACTIONS(2992),
    [sym_xint] = ACTIONS(2994),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2994),
    [sym__newline] = ACTIONS(2994),
  },
  [1987] = {
    [sym_block_comment] = STATE(1987),
    [sym_compiler_directive_decl] = STATE(1987),
    [sym_fsi_directive_decl] = STATE(1987),
    [sym_preproc_line] = STATE(1987),
    [sym_identifier] = ACTIONS(2978),
    [anon_sym_EQ] = ACTIONS(2980),
    [anon_sym_COLON] = ACTIONS(2978),
    [anon_sym_return] = ACTIONS(2978),
    [anon_sym_do] = ACTIONS(2978),
    [anon_sym_let] = ACTIONS(2978),
    [anon_sym_let_BANG] = ACTIONS(2980),
    [anon_sym_LPAREN] = ACTIONS(2978),
    [anon_sym_COMMA] = ACTIONS(2980),
    [anon_sym_null] = ACTIONS(2978),
    [anon_sym_QMARK] = ACTIONS(2978),
    [anon_sym_COLON_QMARK] = ACTIONS(2978),
    [anon_sym_COLON_COLON] = ACTIONS(2980),
    [anon_sym_AMP] = ACTIONS(2978),
    [anon_sym_LBRACK] = ACTIONS(2978),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2980),
    [anon_sym_LBRACE] = ACTIONS(2978),
    [anon_sym_LT_AT] = ACTIONS(2978),
    [anon_sym_LT_AT_AT] = ACTIONS(2978),
    [anon_sym_DOT] = ACTIONS(2978),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2980),
    [anon_sym_new] = ACTIONS(2978),
    [anon_sym_return_BANG] = ACTIONS(2980),
    [anon_sym_yield] = ACTIONS(2978),
    [anon_sym_yield_BANG] = ACTIONS(2980),
    [anon_sym_lazy] = ACTIONS(2978),
    [anon_sym_assert] = ACTIONS(2978),
    [anon_sym_upcast] = ACTIONS(2978),
    [anon_sym_downcast] = ACTIONS(2978),
    [anon_sym_COLON_GT] = ACTIONS(2980),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2980),
    [anon_sym_for] = ACTIONS(2978),
    [anon_sym_while] = ACTIONS(2978),
    [anon_sym_if] = ACTIONS(2978),
    [anon_sym_fun] = ACTIONS(2978),
    [anon_sym_DASH_GT] = ACTIONS(2978),
    [anon_sym_try] = ACTIONS(2978),
    [anon_sym_match] = ACTIONS(2978),
    [anon_sym_match_BANG] = ACTIONS(2980),
    [anon_sym_function] = ACTIONS(2978),
    [anon_sym_LT_DASH] = ACTIONS(2978),
    [anon_sym_DOT_LBRACK] = ACTIONS(2980),
    [anon_sym_LT] = ACTIONS(2980),
    [anon_sym_use] = ACTIONS(2978),
    [anon_sym_use_BANG] = ACTIONS(2980),
    [anon_sym_do_BANG] = ACTIONS(2980),
    [anon_sym_DOT_DOT] = ACTIONS(2980),
    [anon_sym_begin] = ACTIONS(2978),
    [anon_sym_LPAREN2] = ACTIONS(2978),
    [anon_sym_or] = ACTIONS(2978),
    [aux_sym_char_token1] = ACTIONS(2980),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2978),
    [anon_sym_DQUOTE] = ACTIONS(2978),
    [anon_sym_AT_DQUOTE] = ACTIONS(2980),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2980),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2980),
    [sym_bool] = ACTIONS(2978),
    [sym_unit] = ACTIONS(2980),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2978),
    [sym_op_identifier] = ACTIONS(2978),
    [anon_sym_PLUS] = ACTIONS(2978),
    [anon_sym_DASH] = ACTIONS(2978),
    [anon_sym_PLUS_DOT] = ACTIONS(2978),
    [anon_sym_DASH_DOT] = ACTIONS(2978),
    [anon_sym_PERCENT] = ACTIONS(2978),
    [anon_sym_AMP_AMP] = ACTIONS(2978),
    [anon_sym_TILDE] = ACTIONS(2980),
    [aux_sym_prefix_op_token1] = ACTIONS(2978),
    [aux_sym_infix_op_token1] = ACTIONS(2980),
    [aux_sym_infix_op_token2] = ACTIONS(2978),
    [anon_sym_PIPE_PIPE] = ACTIONS(2978),
    [anon_sym_BANG_EQ] = ACTIONS(2978),
    [anon_sym_COLON_EQ] = ACTIONS(2980),
    [anon_sym_DOLLAR] = ACTIONS(2978),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2978),
    [sym_int] = ACTIONS(2978),
    [sym_xint] = ACTIONS(2980),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2980),
    [sym__newline] = ACTIONS(2980),
  },
  [1988] = {
    [sym_block_comment] = STATE(1988),
    [sym_compiler_directive_decl] = STATE(1988),
    [sym_fsi_directive_decl] = STATE(1988),
    [sym_preproc_line] = STATE(1988),
    [aux_sym_long_identifier_repeat1] = STATE(1817),
    [sym_identifier] = ACTIONS(2791),
    [anon_sym_EQ] = ACTIONS(2794),
    [anon_sym_COLON] = ACTIONS(2791),
    [anon_sym_return] = ACTIONS(2791),
    [anon_sym_do] = ACTIONS(2791),
    [anon_sym_let] = ACTIONS(2791),
    [anon_sym_let_BANG] = ACTIONS(2794),
    [anon_sym_LPAREN] = ACTIONS(2791),
    [anon_sym_COMMA] = ACTIONS(2794),
    [anon_sym_null] = ACTIONS(2791),
    [anon_sym_QMARK] = ACTIONS(2791),
    [anon_sym_COLON_QMARK] = ACTIONS(2791),
    [anon_sym_COLON_COLON] = ACTIONS(2794),
    [anon_sym_AMP] = ACTIONS(2791),
    [anon_sym_LBRACK] = ACTIONS(2791),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2794),
    [anon_sym_LBRACE] = ACTIONS(2791),
    [anon_sym_LT_AT] = ACTIONS(2791),
    [anon_sym_LT_AT_AT] = ACTIONS(2791),
    [anon_sym_DOT] = ACTIONS(4166),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2794),
    [anon_sym_new] = ACTIONS(2791),
    [anon_sym_return_BANG] = ACTIONS(2794),
    [anon_sym_yield] = ACTIONS(2791),
    [anon_sym_yield_BANG] = ACTIONS(2794),
    [anon_sym_lazy] = ACTIONS(2791),
    [anon_sym_assert] = ACTIONS(2791),
    [anon_sym_upcast] = ACTIONS(2791),
    [anon_sym_downcast] = ACTIONS(2791),
    [anon_sym_COLON_GT] = ACTIONS(2794),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2794),
    [anon_sym_for] = ACTIONS(2791),
    [anon_sym_while] = ACTIONS(2791),
    [anon_sym_if] = ACTIONS(2791),
    [anon_sym_fun] = ACTIONS(2791),
    [anon_sym_try] = ACTIONS(2791),
    [anon_sym_match] = ACTIONS(2791),
    [anon_sym_match_BANG] = ACTIONS(2794),
    [anon_sym_function] = ACTIONS(2791),
    [anon_sym_LT_DASH] = ACTIONS(2791),
    [anon_sym_DOT_LBRACK] = ACTIONS(2794),
    [anon_sym_LT] = ACTIONS(2794),
    [anon_sym_use] = ACTIONS(2791),
    [anon_sym_use_BANG] = ACTIONS(2794),
    [anon_sym_do_BANG] = ACTIONS(2794),
    [anon_sym_DOT_DOT] = ACTIONS(2794),
    [anon_sym_begin] = ACTIONS(2791),
    [anon_sym_LPAREN2] = ACTIONS(2791),
    [anon_sym_or] = ACTIONS(2791),
    [aux_sym_char_token1] = ACTIONS(2794),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2791),
    [anon_sym_DQUOTE] = ACTIONS(2791),
    [anon_sym_AT_DQUOTE] = ACTIONS(2794),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2794),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2794),
    [sym_bool] = ACTIONS(2791),
    [sym_unit] = ACTIONS(2794),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2791),
    [sym_op_identifier] = ACTIONS(2791),
    [anon_sym_PLUS] = ACTIONS(2791),
    [anon_sym_DASH] = ACTIONS(2791),
    [anon_sym_PLUS_DOT] = ACTIONS(2791),
    [anon_sym_DASH_DOT] = ACTIONS(2791),
    [anon_sym_PERCENT] = ACTIONS(2791),
    [anon_sym_AMP_AMP] = ACTIONS(2791),
    [anon_sym_TILDE] = ACTIONS(2794),
    [aux_sym_prefix_op_token1] = ACTIONS(2791),
    [aux_sym_infix_op_token1] = ACTIONS(2794),
    [aux_sym_infix_op_token2] = ACTIONS(2791),
    [anon_sym_PIPE_PIPE] = ACTIONS(2791),
    [anon_sym_BANG_EQ] = ACTIONS(2791),
    [anon_sym_COLON_EQ] = ACTIONS(2794),
    [anon_sym_DOLLAR] = ACTIONS(2791),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2791),
    [sym_int] = ACTIONS(2791),
    [sym_xint] = ACTIONS(2794),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2794),
    [sym__newline] = ACTIONS(2794),
  },
  [1989] = {
    [sym_block_comment] = STATE(1989),
    [sym_compiler_directive_decl] = STATE(1989),
    [sym_fsi_directive_decl] = STATE(1989),
    [sym_preproc_line] = STATE(1989),
    [sym_identifier] = ACTIONS(2984),
    [anon_sym_EQ] = ACTIONS(2986),
    [anon_sym_COLON] = ACTIONS(2984),
    [anon_sym_return] = ACTIONS(2984),
    [anon_sym_do] = ACTIONS(2984),
    [anon_sym_let] = ACTIONS(2984),
    [anon_sym_let_BANG] = ACTIONS(2986),
    [anon_sym_LPAREN] = ACTIONS(2984),
    [anon_sym_COMMA] = ACTIONS(2986),
    [anon_sym_null] = ACTIONS(2984),
    [anon_sym_QMARK] = ACTIONS(2984),
    [anon_sym_COLON_QMARK] = ACTIONS(2984),
    [anon_sym_COLON_COLON] = ACTIONS(2986),
    [anon_sym_AMP] = ACTIONS(2984),
    [anon_sym_LBRACK] = ACTIONS(2984),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2986),
    [anon_sym_LBRACE] = ACTIONS(2984),
    [anon_sym_LT_AT] = ACTIONS(2984),
    [anon_sym_LT_AT_AT] = ACTIONS(2984),
    [anon_sym_DOT] = ACTIONS(2984),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2986),
    [anon_sym_new] = ACTIONS(2984),
    [anon_sym_return_BANG] = ACTIONS(2986),
    [anon_sym_yield] = ACTIONS(2984),
    [anon_sym_yield_BANG] = ACTIONS(2986),
    [anon_sym_lazy] = ACTIONS(2984),
    [anon_sym_assert] = ACTIONS(2984),
    [anon_sym_upcast] = ACTIONS(2984),
    [anon_sym_downcast] = ACTIONS(2984),
    [anon_sym_COLON_GT] = ACTIONS(2986),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2986),
    [anon_sym_for] = ACTIONS(2984),
    [anon_sym_while] = ACTIONS(2984),
    [anon_sym_if] = ACTIONS(2984),
    [anon_sym_fun] = ACTIONS(2984),
    [anon_sym_DASH_GT] = ACTIONS(2984),
    [anon_sym_try] = ACTIONS(2984),
    [anon_sym_match] = ACTIONS(2984),
    [anon_sym_match_BANG] = ACTIONS(2986),
    [anon_sym_function] = ACTIONS(2984),
    [anon_sym_LT_DASH] = ACTIONS(2984),
    [anon_sym_DOT_LBRACK] = ACTIONS(2986),
    [anon_sym_LT] = ACTIONS(2986),
    [anon_sym_use] = ACTIONS(2984),
    [anon_sym_use_BANG] = ACTIONS(2986),
    [anon_sym_do_BANG] = ACTIONS(2986),
    [anon_sym_DOT_DOT] = ACTIONS(2986),
    [anon_sym_begin] = ACTIONS(2984),
    [anon_sym_LPAREN2] = ACTIONS(2984),
    [anon_sym_or] = ACTIONS(2984),
    [aux_sym_char_token1] = ACTIONS(2986),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2984),
    [anon_sym_DQUOTE] = ACTIONS(2984),
    [anon_sym_AT_DQUOTE] = ACTIONS(2986),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2986),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2986),
    [sym_bool] = ACTIONS(2984),
    [sym_unit] = ACTIONS(2986),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2984),
    [sym_op_identifier] = ACTIONS(2984),
    [anon_sym_PLUS] = ACTIONS(2984),
    [anon_sym_DASH] = ACTIONS(2984),
    [anon_sym_PLUS_DOT] = ACTIONS(2984),
    [anon_sym_DASH_DOT] = ACTIONS(2984),
    [anon_sym_PERCENT] = ACTIONS(2984),
    [anon_sym_AMP_AMP] = ACTIONS(2984),
    [anon_sym_TILDE] = ACTIONS(2986),
    [aux_sym_prefix_op_token1] = ACTIONS(2984),
    [aux_sym_infix_op_token1] = ACTIONS(2986),
    [aux_sym_infix_op_token2] = ACTIONS(2984),
    [anon_sym_PIPE_PIPE] = ACTIONS(2984),
    [anon_sym_BANG_EQ] = ACTIONS(2984),
    [anon_sym_COLON_EQ] = ACTIONS(2986),
    [anon_sym_DOLLAR] = ACTIONS(2984),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2984),
    [sym_int] = ACTIONS(2984),
    [sym_xint] = ACTIONS(2986),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2986),
    [sym__newline] = ACTIONS(2986),
  },
  [1990] = {
    [sym_block_comment] = STATE(1990),
    [sym_compiler_directive_decl] = STATE(1990),
    [sym_fsi_directive_decl] = STATE(1990),
    [sym_preproc_line] = STATE(1990),
    [sym_identifier] = ACTIONS(2783),
    [anon_sym_EQ] = ACTIONS(2785),
    [anon_sym_COLON] = ACTIONS(2783),
    [anon_sym_return] = ACTIONS(2783),
    [anon_sym_do] = ACTIONS(2783),
    [anon_sym_let] = ACTIONS(2783),
    [anon_sym_let_BANG] = ACTIONS(2785),
    [anon_sym_LPAREN] = ACTIONS(2783),
    [anon_sym_COMMA] = ACTIONS(2785),
    [anon_sym_null] = ACTIONS(2783),
    [anon_sym_QMARK] = ACTIONS(2783),
    [anon_sym_COLON_QMARK] = ACTIONS(2783),
    [anon_sym_COLON_COLON] = ACTIONS(2785),
    [anon_sym_AMP] = ACTIONS(2783),
    [anon_sym_LBRACK] = ACTIONS(2783),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2785),
    [anon_sym_LBRACE] = ACTIONS(2783),
    [anon_sym_LT_AT] = ACTIONS(2783),
    [anon_sym_LT_AT_AT] = ACTIONS(2783),
    [anon_sym_AT_AT_GT] = ACTIONS(2783),
    [anon_sym_DOT] = ACTIONS(2783),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2785),
    [anon_sym_new] = ACTIONS(2783),
    [anon_sym_return_BANG] = ACTIONS(2785),
    [anon_sym_yield] = ACTIONS(2783),
    [anon_sym_yield_BANG] = ACTIONS(2785),
    [anon_sym_lazy] = ACTIONS(2783),
    [anon_sym_assert] = ACTIONS(2783),
    [anon_sym_upcast] = ACTIONS(2783),
    [anon_sym_downcast] = ACTIONS(2783),
    [anon_sym_COLON_GT] = ACTIONS(2785),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2785),
    [anon_sym_for] = ACTIONS(2783),
    [anon_sym_done] = ACTIONS(3698),
    [anon_sym_while] = ACTIONS(2783),
    [anon_sym_if] = ACTIONS(2783),
    [anon_sym_fun] = ACTIONS(2783),
    [anon_sym_try] = ACTIONS(2783),
    [anon_sym_match] = ACTIONS(2783),
    [anon_sym_match_BANG] = ACTIONS(2785),
    [anon_sym_function] = ACTIONS(2783),
    [anon_sym_LT_DASH] = ACTIONS(2783),
    [anon_sym_DOT_LBRACK] = ACTIONS(2785),
    [anon_sym_LT] = ACTIONS(2785),
    [anon_sym_use] = ACTIONS(2783),
    [anon_sym_use_BANG] = ACTIONS(2785),
    [anon_sym_do_BANG] = ACTIONS(2785),
    [anon_sym_begin] = ACTIONS(2783),
    [anon_sym_LPAREN2] = ACTIONS(2783),
    [anon_sym_or] = ACTIONS(2783),
    [aux_sym_char_token1] = ACTIONS(2785),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2783),
    [anon_sym_DQUOTE] = ACTIONS(2783),
    [anon_sym_AT_DQUOTE] = ACTIONS(2785),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2785),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2785),
    [sym_bool] = ACTIONS(2783),
    [sym_unit] = ACTIONS(2785),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2783),
    [sym_op_identifier] = ACTIONS(2783),
    [anon_sym_PLUS] = ACTIONS(2783),
    [anon_sym_DASH] = ACTIONS(2783),
    [anon_sym_PLUS_DOT] = ACTIONS(2783),
    [anon_sym_DASH_DOT] = ACTIONS(2783),
    [anon_sym_PERCENT] = ACTIONS(2783),
    [anon_sym_AMP_AMP] = ACTIONS(2783),
    [anon_sym_TILDE] = ACTIONS(2785),
    [aux_sym_prefix_op_token1] = ACTIONS(2783),
    [aux_sym_infix_op_token1] = ACTIONS(2785),
    [aux_sym_infix_op_token2] = ACTIONS(2783),
    [anon_sym_PIPE_PIPE] = ACTIONS(2783),
    [anon_sym_BANG_EQ] = ACTIONS(2783),
    [anon_sym_COLON_EQ] = ACTIONS(2785),
    [anon_sym_DOLLAR] = ACTIONS(2783),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2783),
    [sym_int] = ACTIONS(2783),
    [sym_xint] = ACTIONS(2785),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2785),
    [sym__newline] = ACTIONS(2785),
  },
  [1991] = {
    [sym_block_comment] = STATE(1991),
    [sym_compiler_directive_decl] = STATE(1991),
    [sym_fsi_directive_decl] = STATE(1991),
    [sym_preproc_line] = STATE(1991),
    [sym_identifier] = ACTIONS(2756),
    [anon_sym_EQ] = ACTIONS(2758),
    [anon_sym_COLON] = ACTIONS(2756),
    [anon_sym_return] = ACTIONS(2756),
    [anon_sym_do] = ACTIONS(2756),
    [anon_sym_let] = ACTIONS(2756),
    [anon_sym_let_BANG] = ACTIONS(2758),
    [anon_sym_LPAREN] = ACTIONS(2756),
    [anon_sym_COMMA] = ACTIONS(2758),
    [anon_sym_null] = ACTIONS(2756),
    [anon_sym_QMARK] = ACTIONS(2756),
    [anon_sym_COLON_QMARK] = ACTIONS(2756),
    [anon_sym_COLON_COLON] = ACTIONS(2758),
    [anon_sym_PIPE] = ACTIONS(2756),
    [anon_sym_AMP] = ACTIONS(2756),
    [anon_sym_LBRACK] = ACTIONS(2756),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2758),
    [anon_sym_LBRACE] = ACTIONS(2756),
    [anon_sym_LT_AT] = ACTIONS(2756),
    [anon_sym_AT_GT] = ACTIONS(2756),
    [anon_sym_LT_AT_AT] = ACTIONS(2756),
    [anon_sym_DOT] = ACTIONS(2756),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2758),
    [anon_sym_new] = ACTIONS(2756),
    [anon_sym_return_BANG] = ACTIONS(2758),
    [anon_sym_yield] = ACTIONS(2756),
    [anon_sym_yield_BANG] = ACTIONS(2758),
    [anon_sym_lazy] = ACTIONS(2756),
    [anon_sym_assert] = ACTIONS(2756),
    [anon_sym_upcast] = ACTIONS(2756),
    [anon_sym_downcast] = ACTIONS(2756),
    [anon_sym_COLON_GT] = ACTIONS(2758),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2758),
    [anon_sym_for] = ACTIONS(2756),
    [anon_sym_while] = ACTIONS(2756),
    [anon_sym_if] = ACTIONS(2756),
    [anon_sym_fun] = ACTIONS(2756),
    [anon_sym_try] = ACTIONS(2756),
    [anon_sym_match] = ACTIONS(2756),
    [anon_sym_match_BANG] = ACTIONS(2758),
    [anon_sym_function] = ACTIONS(2756),
    [anon_sym_LT_DASH] = ACTIONS(2756),
    [anon_sym_DOT_LBRACK] = ACTIONS(2758),
    [anon_sym_LT] = ACTIONS(2758),
    [anon_sym_use] = ACTIONS(2756),
    [anon_sym_use_BANG] = ACTIONS(2758),
    [anon_sym_do_BANG] = ACTIONS(2758),
    [anon_sym_begin] = ACTIONS(2756),
    [anon_sym_LPAREN2] = ACTIONS(2756),
    [anon_sym_or] = ACTIONS(2756),
    [aux_sym_char_token1] = ACTIONS(2758),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2756),
    [anon_sym_DQUOTE] = ACTIONS(2756),
    [anon_sym_AT_DQUOTE] = ACTIONS(2758),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2758),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2758),
    [sym_bool] = ACTIONS(2756),
    [sym_unit] = ACTIONS(2758),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2756),
    [sym_op_identifier] = ACTIONS(2756),
    [anon_sym_PLUS] = ACTIONS(2756),
    [anon_sym_DASH] = ACTIONS(2756),
    [anon_sym_PLUS_DOT] = ACTIONS(2756),
    [anon_sym_DASH_DOT] = ACTIONS(2756),
    [anon_sym_PERCENT] = ACTIONS(2756),
    [anon_sym_AMP_AMP] = ACTIONS(2756),
    [anon_sym_TILDE] = ACTIONS(2758),
    [aux_sym_prefix_op_token1] = ACTIONS(2756),
    [aux_sym_infix_op_token1] = ACTIONS(2758),
    [aux_sym_infix_op_token2] = ACTIONS(2756),
    [anon_sym_PIPE_PIPE] = ACTIONS(2756),
    [anon_sym_BANG_EQ] = ACTIONS(2756),
    [anon_sym_COLON_EQ] = ACTIONS(2758),
    [anon_sym_DOLLAR] = ACTIONS(2756),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2756),
    [sym_int] = ACTIONS(2756),
    [sym_xint] = ACTIONS(2758),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2758),
    [sym__newline] = ACTIONS(2758),
  },
  [1992] = {
    [sym_block_comment] = STATE(1992),
    [sym_compiler_directive_decl] = STATE(1992),
    [sym_fsi_directive_decl] = STATE(1992),
    [sym_preproc_line] = STATE(1992),
    [sym_identifier] = ACTIONS(2411),
    [anon_sym_EQ] = ACTIONS(2413),
    [anon_sym_COLON] = ACTIONS(2411),
    [anon_sym_return] = ACTIONS(2411),
    [anon_sym_do] = ACTIONS(2411),
    [anon_sym_let] = ACTIONS(2411),
    [anon_sym_let_BANG] = ACTIONS(2413),
    [anon_sym_LPAREN] = ACTIONS(2411),
    [anon_sym_COMMA] = ACTIONS(2413),
    [anon_sym_null] = ACTIONS(2411),
    [anon_sym_QMARK] = ACTIONS(2411),
    [anon_sym_COLON_QMARK] = ACTIONS(2411),
    [anon_sym_COLON_COLON] = ACTIONS(2413),
    [anon_sym_AMP] = ACTIONS(2411),
    [anon_sym_LBRACK] = ACTIONS(2411),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2413),
    [anon_sym_LBRACE] = ACTIONS(2411),
    [anon_sym_LT_AT] = ACTIONS(2411),
    [anon_sym_LT_AT_AT] = ACTIONS(2411),
    [anon_sym_DOT] = ACTIONS(2411),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2413),
    [anon_sym_new] = ACTIONS(2411),
    [anon_sym_return_BANG] = ACTIONS(2413),
    [anon_sym_yield] = ACTIONS(2411),
    [anon_sym_yield_BANG] = ACTIONS(2413),
    [anon_sym_lazy] = ACTIONS(2411),
    [anon_sym_assert] = ACTIONS(2411),
    [anon_sym_upcast] = ACTIONS(2411),
    [anon_sym_downcast] = ACTIONS(2411),
    [anon_sym_COLON_GT] = ACTIONS(2413),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2413),
    [anon_sym_for] = ACTIONS(2411),
    [anon_sym_while] = ACTIONS(2411),
    [anon_sym_if] = ACTIONS(2411),
    [anon_sym_fun] = ACTIONS(2411),
    [anon_sym_DASH_GT] = ACTIONS(2411),
    [anon_sym_try] = ACTIONS(2411),
    [anon_sym_match] = ACTIONS(2411),
    [anon_sym_match_BANG] = ACTIONS(2413),
    [anon_sym_function] = ACTIONS(2411),
    [anon_sym_LT_DASH] = ACTIONS(2411),
    [anon_sym_DOT_LBRACK] = ACTIONS(2413),
    [anon_sym_LT] = ACTIONS(2413),
    [anon_sym_use] = ACTIONS(2411),
    [anon_sym_use_BANG] = ACTIONS(2413),
    [anon_sym_do_BANG] = ACTIONS(2413),
    [anon_sym_DOT_DOT] = ACTIONS(2413),
    [anon_sym_begin] = ACTIONS(2411),
    [anon_sym_LPAREN2] = ACTIONS(2411),
    [anon_sym_or] = ACTIONS(2411),
    [aux_sym_char_token1] = ACTIONS(2413),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2411),
    [anon_sym_DQUOTE] = ACTIONS(2411),
    [anon_sym_AT_DQUOTE] = ACTIONS(2413),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2413),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2413),
    [sym_bool] = ACTIONS(2411),
    [sym_unit] = ACTIONS(2413),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2411),
    [sym_op_identifier] = ACTIONS(2411),
    [anon_sym_PLUS] = ACTIONS(2411),
    [anon_sym_DASH] = ACTIONS(2411),
    [anon_sym_PLUS_DOT] = ACTIONS(2411),
    [anon_sym_DASH_DOT] = ACTIONS(2411),
    [anon_sym_PERCENT] = ACTIONS(2411),
    [anon_sym_AMP_AMP] = ACTIONS(2411),
    [anon_sym_TILDE] = ACTIONS(2413),
    [aux_sym_prefix_op_token1] = ACTIONS(2411),
    [aux_sym_infix_op_token1] = ACTIONS(2413),
    [aux_sym_infix_op_token2] = ACTIONS(2411),
    [anon_sym_PIPE_PIPE] = ACTIONS(2411),
    [anon_sym_BANG_EQ] = ACTIONS(2411),
    [anon_sym_COLON_EQ] = ACTIONS(2413),
    [anon_sym_DOLLAR] = ACTIONS(2411),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2411),
    [sym_int] = ACTIONS(2411),
    [sym_xint] = ACTIONS(2413),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2413),
    [sym__newline] = ACTIONS(2413),
  },
  [1993] = {
    [sym_block_comment] = STATE(1993),
    [sym_compiler_directive_decl] = STATE(1993),
    [sym_fsi_directive_decl] = STATE(1993),
    [sym_preproc_line] = STATE(1993),
    [sym_identifier] = ACTIONS(2685),
    [anon_sym_EQ] = ACTIONS(2687),
    [anon_sym_COLON] = ACTIONS(2685),
    [anon_sym_return] = ACTIONS(2685),
    [anon_sym_do] = ACTIONS(2685),
    [anon_sym_let] = ACTIONS(2685),
    [anon_sym_let_BANG] = ACTIONS(2687),
    [anon_sym_LPAREN] = ACTIONS(2685),
    [anon_sym_COMMA] = ACTIONS(2687),
    [anon_sym_null] = ACTIONS(2685),
    [anon_sym_QMARK] = ACTIONS(2685),
    [anon_sym_COLON_QMARK] = ACTIONS(2685),
    [anon_sym_COLON_COLON] = ACTIONS(2687),
    [anon_sym_PIPE] = ACTIONS(2685),
    [anon_sym_AMP] = ACTIONS(2685),
    [anon_sym_LBRACK] = ACTIONS(2685),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2687),
    [anon_sym_LBRACE] = ACTIONS(2685),
    [anon_sym_LT_AT] = ACTIONS(2685),
    [anon_sym_LT_AT_AT] = ACTIONS(2685),
    [anon_sym_DOT] = ACTIONS(2685),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2687),
    [anon_sym_new] = ACTIONS(2685),
    [anon_sym_return_BANG] = ACTIONS(2687),
    [anon_sym_yield] = ACTIONS(2685),
    [anon_sym_yield_BANG] = ACTIONS(2687),
    [anon_sym_lazy] = ACTIONS(2685),
    [anon_sym_assert] = ACTIONS(2685),
    [anon_sym_upcast] = ACTIONS(2685),
    [anon_sym_downcast] = ACTIONS(2685),
    [anon_sym_COLON_GT] = ACTIONS(2687),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2687),
    [anon_sym_for] = ACTIONS(2685),
    [anon_sym_while] = ACTIONS(2685),
    [anon_sym_if] = ACTIONS(2685),
    [anon_sym_fun] = ACTIONS(2685),
    [anon_sym_try] = ACTIONS(2685),
    [anon_sym_match] = ACTIONS(2685),
    [anon_sym_match_BANG] = ACTIONS(2687),
    [anon_sym_function] = ACTIONS(2685),
    [anon_sym_LT_DASH] = ACTIONS(2685),
    [anon_sym_DOT_LBRACK] = ACTIONS(2687),
    [anon_sym_LT] = ACTIONS(2687),
    [anon_sym_GT] = ACTIONS(2685),
    [anon_sym_use] = ACTIONS(2685),
    [anon_sym_use_BANG] = ACTIONS(2687),
    [anon_sym_do_BANG] = ACTIONS(2687),
    [anon_sym_begin] = ACTIONS(2685),
    [anon_sym_LPAREN2] = ACTIONS(2685),
    [anon_sym_or] = ACTIONS(2685),
    [aux_sym_char_token1] = ACTIONS(2687),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2685),
    [anon_sym_DQUOTE] = ACTIONS(2685),
    [anon_sym_AT_DQUOTE] = ACTIONS(2687),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2687),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2687),
    [sym_bool] = ACTIONS(2685),
    [sym_unit] = ACTIONS(2687),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2685),
    [sym_op_identifier] = ACTIONS(2685),
    [anon_sym_PLUS] = ACTIONS(2685),
    [anon_sym_DASH] = ACTIONS(2685),
    [anon_sym_PLUS_DOT] = ACTIONS(2685),
    [anon_sym_DASH_DOT] = ACTIONS(2685),
    [anon_sym_PERCENT] = ACTIONS(2685),
    [anon_sym_AMP_AMP] = ACTIONS(2685),
    [anon_sym_TILDE] = ACTIONS(2687),
    [aux_sym_prefix_op_token1] = ACTIONS(2685),
    [aux_sym_infix_op_token1] = ACTIONS(2687),
    [aux_sym_infix_op_token2] = ACTIONS(2685),
    [anon_sym_PIPE_PIPE] = ACTIONS(2685),
    [anon_sym_BANG_EQ] = ACTIONS(2685),
    [anon_sym_COLON_EQ] = ACTIONS(2687),
    [anon_sym_DOLLAR] = ACTIONS(2685),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2685),
    [sym_int] = ACTIONS(2685),
    [sym_xint] = ACTIONS(2687),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2687),
    [sym__newline] = ACTIONS(2687),
  },
  [1994] = {
    [sym_block_comment] = STATE(1994),
    [sym_compiler_directive_decl] = STATE(1994),
    [sym_fsi_directive_decl] = STATE(1994),
    [sym_preproc_line] = STATE(1994),
    [sym_identifier] = ACTIONS(2760),
    [anon_sym_EQ] = ACTIONS(2762),
    [anon_sym_COLON] = ACTIONS(2760),
    [anon_sym_return] = ACTIONS(2760),
    [anon_sym_do] = ACTIONS(2760),
    [anon_sym_let] = ACTIONS(2760),
    [anon_sym_let_BANG] = ACTIONS(2762),
    [anon_sym_LPAREN] = ACTIONS(2760),
    [anon_sym_COMMA] = ACTIONS(2762),
    [anon_sym_null] = ACTIONS(2760),
    [anon_sym_QMARK] = ACTIONS(2760),
    [anon_sym_COLON_QMARK] = ACTIONS(2760),
    [anon_sym_COLON_COLON] = ACTIONS(2762),
    [anon_sym_PIPE] = ACTIONS(2760),
    [anon_sym_AMP] = ACTIONS(2760),
    [anon_sym_LBRACK] = ACTIONS(2760),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2762),
    [anon_sym_LBRACE] = ACTIONS(2760),
    [anon_sym_LT_AT] = ACTIONS(2760),
    [anon_sym_AT_GT] = ACTIONS(2760),
    [anon_sym_LT_AT_AT] = ACTIONS(2760),
    [anon_sym_DOT] = ACTIONS(2760),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2762),
    [anon_sym_new] = ACTIONS(2760),
    [anon_sym_return_BANG] = ACTIONS(2762),
    [anon_sym_yield] = ACTIONS(2760),
    [anon_sym_yield_BANG] = ACTIONS(2762),
    [anon_sym_lazy] = ACTIONS(2760),
    [anon_sym_assert] = ACTIONS(2760),
    [anon_sym_upcast] = ACTIONS(2760),
    [anon_sym_downcast] = ACTIONS(2760),
    [anon_sym_COLON_GT] = ACTIONS(2762),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2762),
    [anon_sym_for] = ACTIONS(2760),
    [anon_sym_while] = ACTIONS(2760),
    [anon_sym_if] = ACTIONS(2760),
    [anon_sym_fun] = ACTIONS(2760),
    [anon_sym_try] = ACTIONS(2760),
    [anon_sym_match] = ACTIONS(2760),
    [anon_sym_match_BANG] = ACTIONS(2762),
    [anon_sym_function] = ACTIONS(2760),
    [anon_sym_LT_DASH] = ACTIONS(2760),
    [anon_sym_DOT_LBRACK] = ACTIONS(2762),
    [anon_sym_LT] = ACTIONS(2762),
    [anon_sym_use] = ACTIONS(2760),
    [anon_sym_use_BANG] = ACTIONS(2762),
    [anon_sym_do_BANG] = ACTIONS(2762),
    [anon_sym_begin] = ACTIONS(2760),
    [anon_sym_LPAREN2] = ACTIONS(2760),
    [anon_sym_or] = ACTIONS(2760),
    [aux_sym_char_token1] = ACTIONS(2762),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2760),
    [anon_sym_DQUOTE] = ACTIONS(2760),
    [anon_sym_AT_DQUOTE] = ACTIONS(2762),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2762),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2762),
    [sym_bool] = ACTIONS(2760),
    [sym_unit] = ACTIONS(2762),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2760),
    [sym_op_identifier] = ACTIONS(2760),
    [anon_sym_PLUS] = ACTIONS(2760),
    [anon_sym_DASH] = ACTIONS(2760),
    [anon_sym_PLUS_DOT] = ACTIONS(2760),
    [anon_sym_DASH_DOT] = ACTIONS(2760),
    [anon_sym_PERCENT] = ACTIONS(2760),
    [anon_sym_AMP_AMP] = ACTIONS(2760),
    [anon_sym_TILDE] = ACTIONS(2762),
    [aux_sym_prefix_op_token1] = ACTIONS(2760),
    [aux_sym_infix_op_token1] = ACTIONS(2762),
    [aux_sym_infix_op_token2] = ACTIONS(2760),
    [anon_sym_PIPE_PIPE] = ACTIONS(2760),
    [anon_sym_BANG_EQ] = ACTIONS(2760),
    [anon_sym_COLON_EQ] = ACTIONS(2762),
    [anon_sym_DOLLAR] = ACTIONS(2760),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2760),
    [sym_int] = ACTIONS(2760),
    [sym_xint] = ACTIONS(2762),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2762),
    [sym__newline] = ACTIONS(2762),
  },
  [1995] = {
    [sym_block_comment] = STATE(1995),
    [sym_compiler_directive_decl] = STATE(1995),
    [sym_fsi_directive_decl] = STATE(1995),
    [sym_preproc_line] = STATE(1995),
    [aux_sym_sequential_expression_repeat1] = STATE(1881),
    [sym_identifier] = ACTIONS(2847),
    [anon_sym_EQ] = ACTIONS(2849),
    [anon_sym_COLON] = ACTIONS(2847),
    [anon_sym_return] = ACTIONS(2847),
    [anon_sym_do] = ACTIONS(2847),
    [anon_sym_let] = ACTIONS(2847),
    [anon_sym_let_BANG] = ACTIONS(2849),
    [anon_sym_LPAREN] = ACTIONS(2847),
    [anon_sym_COMMA] = ACTIONS(2849),
    [anon_sym_null] = ACTIONS(2847),
    [anon_sym_QMARK] = ACTIONS(2847),
    [anon_sym_COLON_QMARK] = ACTIONS(2847),
    [anon_sym_COLON_COLON] = ACTIONS(2849),
    [anon_sym_AMP] = ACTIONS(2847),
    [anon_sym_LBRACK] = ACTIONS(2847),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2849),
    [anon_sym_LBRACE] = ACTIONS(2847),
    [anon_sym_LT_AT] = ACTIONS(2847),
    [anon_sym_LT_AT_AT] = ACTIONS(2847),
    [anon_sym_DOT] = ACTIONS(2847),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2849),
    [anon_sym_new] = ACTIONS(2847),
    [anon_sym_return_BANG] = ACTIONS(2849),
    [anon_sym_yield] = ACTIONS(2847),
    [anon_sym_yield_BANG] = ACTIONS(2849),
    [anon_sym_lazy] = ACTIONS(2847),
    [anon_sym_assert] = ACTIONS(2847),
    [anon_sym_upcast] = ACTIONS(2847),
    [anon_sym_downcast] = ACTIONS(2847),
    [anon_sym_COLON_GT] = ACTIONS(2849),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2849),
    [anon_sym_for] = ACTIONS(2847),
    [anon_sym_while] = ACTIONS(2847),
    [anon_sym_if] = ACTIONS(2847),
    [anon_sym_fun] = ACTIONS(2847),
    [anon_sym_DASH_GT] = ACTIONS(2847),
    [anon_sym_try] = ACTIONS(2847),
    [anon_sym_match] = ACTIONS(2847),
    [anon_sym_match_BANG] = ACTIONS(2849),
    [anon_sym_function] = ACTIONS(2847),
    [anon_sym_LT_DASH] = ACTIONS(2847),
    [anon_sym_DOT_LBRACK] = ACTIONS(2849),
    [anon_sym_LT] = ACTIONS(2849),
    [anon_sym_use] = ACTIONS(2847),
    [anon_sym_use_BANG] = ACTIONS(2849),
    [anon_sym_do_BANG] = ACTIONS(2849),
    [anon_sym_begin] = ACTIONS(2847),
    [anon_sym_LPAREN2] = ACTIONS(2847),
    [anon_sym_or] = ACTIONS(2847),
    [aux_sym_char_token1] = ACTIONS(2849),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2847),
    [anon_sym_DQUOTE] = ACTIONS(2847),
    [anon_sym_AT_DQUOTE] = ACTIONS(2849),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2849),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2849),
    [sym_bool] = ACTIONS(2847),
    [sym_unit] = ACTIONS(2849),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2847),
    [sym_op_identifier] = ACTIONS(2847),
    [anon_sym_PLUS] = ACTIONS(2847),
    [anon_sym_DASH] = ACTIONS(2847),
    [anon_sym_PLUS_DOT] = ACTIONS(2847),
    [anon_sym_DASH_DOT] = ACTIONS(2847),
    [anon_sym_PERCENT] = ACTIONS(2847),
    [anon_sym_AMP_AMP] = ACTIONS(2847),
    [anon_sym_TILDE] = ACTIONS(2849),
    [aux_sym_prefix_op_token1] = ACTIONS(2847),
    [aux_sym_infix_op_token1] = ACTIONS(2849),
    [aux_sym_infix_op_token2] = ACTIONS(2847),
    [anon_sym_PIPE_PIPE] = ACTIONS(2847),
    [anon_sym_BANG_EQ] = ACTIONS(2847),
    [anon_sym_COLON_EQ] = ACTIONS(2849),
    [anon_sym_DOLLAR] = ACTIONS(2847),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2847),
    [sym_int] = ACTIONS(2847),
    [sym_xint] = ACTIONS(2849),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2849),
    [sym__newline] = ACTIONS(2849),
  },
  [1996] = {
    [sym_block_comment] = STATE(1996),
    [sym_compiler_directive_decl] = STATE(1996),
    [sym_fsi_directive_decl] = STATE(1996),
    [sym_preproc_line] = STATE(1996),
    [sym_identifier] = ACTIONS(2930),
    [anon_sym_EQ] = ACTIONS(2932),
    [anon_sym_COLON] = ACTIONS(2930),
    [anon_sym_return] = ACTIONS(2930),
    [anon_sym_do] = ACTIONS(2930),
    [anon_sym_let] = ACTIONS(2930),
    [anon_sym_let_BANG] = ACTIONS(2932),
    [anon_sym_LPAREN] = ACTIONS(2930),
    [anon_sym_COMMA] = ACTIONS(2932),
    [anon_sym_null] = ACTIONS(2930),
    [anon_sym_QMARK] = ACTIONS(2930),
    [anon_sym_COLON_QMARK] = ACTIONS(2930),
    [anon_sym_COLON_COLON] = ACTIONS(2932),
    [anon_sym_AMP] = ACTIONS(2930),
    [anon_sym_LBRACK] = ACTIONS(2930),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2932),
    [anon_sym_LBRACE] = ACTIONS(2930),
    [anon_sym_LT_AT] = ACTIONS(2930),
    [anon_sym_LT_AT_AT] = ACTIONS(2930),
    [anon_sym_DOT] = ACTIONS(2930),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2932),
    [anon_sym_new] = ACTIONS(2930),
    [anon_sym_return_BANG] = ACTIONS(2932),
    [anon_sym_yield] = ACTIONS(2930),
    [anon_sym_yield_BANG] = ACTIONS(2932),
    [anon_sym_lazy] = ACTIONS(2930),
    [anon_sym_assert] = ACTIONS(2930),
    [anon_sym_upcast] = ACTIONS(2930),
    [anon_sym_downcast] = ACTIONS(2930),
    [anon_sym_COLON_GT] = ACTIONS(2932),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2932),
    [anon_sym_for] = ACTIONS(2930),
    [anon_sym_while] = ACTIONS(2930),
    [anon_sym_if] = ACTIONS(2930),
    [anon_sym_fun] = ACTIONS(2930),
    [anon_sym_DASH_GT] = ACTIONS(2930),
    [anon_sym_try] = ACTIONS(2930),
    [anon_sym_match] = ACTIONS(2930),
    [anon_sym_match_BANG] = ACTIONS(2932),
    [anon_sym_function] = ACTIONS(2930),
    [anon_sym_LT_DASH] = ACTIONS(2930),
    [anon_sym_DOT_LBRACK] = ACTIONS(2932),
    [anon_sym_LT] = ACTIONS(2932),
    [anon_sym_use] = ACTIONS(2930),
    [anon_sym_use_BANG] = ACTIONS(2932),
    [anon_sym_do_BANG] = ACTIONS(2932),
    [anon_sym_DOT_DOT] = ACTIONS(2932),
    [anon_sym_begin] = ACTIONS(2930),
    [anon_sym_LPAREN2] = ACTIONS(2930),
    [anon_sym_or] = ACTIONS(2930),
    [aux_sym_char_token1] = ACTIONS(2932),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2930),
    [anon_sym_DQUOTE] = ACTIONS(2930),
    [anon_sym_AT_DQUOTE] = ACTIONS(2932),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2932),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2932),
    [sym_bool] = ACTIONS(2930),
    [sym_unit] = ACTIONS(2932),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2930),
    [sym_op_identifier] = ACTIONS(2930),
    [anon_sym_PLUS] = ACTIONS(2930),
    [anon_sym_DASH] = ACTIONS(2930),
    [anon_sym_PLUS_DOT] = ACTIONS(2930),
    [anon_sym_DASH_DOT] = ACTIONS(2930),
    [anon_sym_PERCENT] = ACTIONS(2930),
    [anon_sym_AMP_AMP] = ACTIONS(2930),
    [anon_sym_TILDE] = ACTIONS(2932),
    [aux_sym_prefix_op_token1] = ACTIONS(2930),
    [aux_sym_infix_op_token1] = ACTIONS(2932),
    [aux_sym_infix_op_token2] = ACTIONS(2930),
    [anon_sym_PIPE_PIPE] = ACTIONS(2930),
    [anon_sym_BANG_EQ] = ACTIONS(2930),
    [anon_sym_COLON_EQ] = ACTIONS(2932),
    [anon_sym_DOLLAR] = ACTIONS(2930),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2930),
    [sym_int] = ACTIONS(2930),
    [sym_xint] = ACTIONS(2932),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2932),
    [sym__newline] = ACTIONS(2932),
  },
  [1997] = {
    [sym_block_comment] = STATE(1997),
    [sym_compiler_directive_decl] = STATE(1997),
    [sym_fsi_directive_decl] = STATE(1997),
    [sym_preproc_line] = STATE(1997),
    [sym_identifier] = ACTIONS(2804),
    [anon_sym_EQ] = ACTIONS(2806),
    [anon_sym_COLON] = ACTIONS(2804),
    [anon_sym_return] = ACTIONS(2804),
    [anon_sym_do] = ACTIONS(2804),
    [anon_sym_let] = ACTIONS(2804),
    [anon_sym_let_BANG] = ACTIONS(2806),
    [anon_sym_LPAREN] = ACTIONS(2804),
    [anon_sym_COMMA] = ACTIONS(2806),
    [anon_sym_null] = ACTIONS(2804),
    [anon_sym_QMARK] = ACTIONS(2804),
    [anon_sym_COLON_QMARK] = ACTIONS(2804),
    [anon_sym_COLON_COLON] = ACTIONS(2806),
    [anon_sym_AMP] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2804),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2806),
    [anon_sym_LBRACE] = ACTIONS(2804),
    [anon_sym_LT_AT] = ACTIONS(2804),
    [anon_sym_LT_AT_AT] = ACTIONS(2804),
    [anon_sym_AT_AT_GT] = ACTIONS(2804),
    [anon_sym_DOT] = ACTIONS(2804),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2806),
    [anon_sym_new] = ACTIONS(2804),
    [anon_sym_return_BANG] = ACTIONS(2806),
    [anon_sym_yield] = ACTIONS(2804),
    [anon_sym_yield_BANG] = ACTIONS(2806),
    [anon_sym_lazy] = ACTIONS(2804),
    [anon_sym_assert] = ACTIONS(2804),
    [anon_sym_upcast] = ACTIONS(2804),
    [anon_sym_downcast] = ACTIONS(2804),
    [anon_sym_COLON_GT] = ACTIONS(2806),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2806),
    [anon_sym_for] = ACTIONS(2804),
    [anon_sym_done] = ACTIONS(4170),
    [anon_sym_while] = ACTIONS(2804),
    [anon_sym_if] = ACTIONS(2804),
    [anon_sym_fun] = ACTIONS(2804),
    [anon_sym_try] = ACTIONS(2804),
    [anon_sym_match] = ACTIONS(2804),
    [anon_sym_match_BANG] = ACTIONS(2806),
    [anon_sym_function] = ACTIONS(2804),
    [anon_sym_LT_DASH] = ACTIONS(2804),
    [anon_sym_DOT_LBRACK] = ACTIONS(2806),
    [anon_sym_LT] = ACTIONS(2806),
    [anon_sym_use] = ACTIONS(2804),
    [anon_sym_use_BANG] = ACTIONS(2806),
    [anon_sym_do_BANG] = ACTIONS(2806),
    [anon_sym_begin] = ACTIONS(2804),
    [anon_sym_LPAREN2] = ACTIONS(2804),
    [anon_sym_or] = ACTIONS(2804),
    [aux_sym_char_token1] = ACTIONS(2806),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2804),
    [anon_sym_DQUOTE] = ACTIONS(2804),
    [anon_sym_AT_DQUOTE] = ACTIONS(2806),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2806),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2806),
    [sym_bool] = ACTIONS(2804),
    [sym_unit] = ACTIONS(2806),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2804),
    [sym_op_identifier] = ACTIONS(2804),
    [anon_sym_PLUS] = ACTIONS(2804),
    [anon_sym_DASH] = ACTIONS(2804),
    [anon_sym_PLUS_DOT] = ACTIONS(2804),
    [anon_sym_DASH_DOT] = ACTIONS(2804),
    [anon_sym_PERCENT] = ACTIONS(2804),
    [anon_sym_AMP_AMP] = ACTIONS(2804),
    [anon_sym_TILDE] = ACTIONS(2806),
    [aux_sym_prefix_op_token1] = ACTIONS(2804),
    [aux_sym_infix_op_token1] = ACTIONS(2806),
    [aux_sym_infix_op_token2] = ACTIONS(2804),
    [anon_sym_PIPE_PIPE] = ACTIONS(2804),
    [anon_sym_BANG_EQ] = ACTIONS(2804),
    [anon_sym_COLON_EQ] = ACTIONS(2806),
    [anon_sym_DOLLAR] = ACTIONS(2804),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2804),
    [sym_int] = ACTIONS(2804),
    [sym_xint] = ACTIONS(2806),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2806),
    [sym__newline] = ACTIONS(2806),
  },
  [1998] = {
    [sym_block_comment] = STATE(1998),
    [sym_compiler_directive_decl] = STATE(1998),
    [sym_fsi_directive_decl] = STATE(1998),
    [sym_preproc_line] = STATE(1998),
    [sym_identifier] = ACTIONS(2906),
    [anon_sym_EQ] = ACTIONS(2908),
    [anon_sym_COLON] = ACTIONS(2906),
    [anon_sym_return] = ACTIONS(2906),
    [anon_sym_do] = ACTIONS(2906),
    [anon_sym_let] = ACTIONS(2906),
    [anon_sym_let_BANG] = ACTIONS(2908),
    [anon_sym_LPAREN] = ACTIONS(2906),
    [anon_sym_COMMA] = ACTIONS(2908),
    [anon_sym_null] = ACTIONS(2906),
    [anon_sym_QMARK] = ACTIONS(2906),
    [anon_sym_COLON_QMARK] = ACTIONS(2906),
    [anon_sym_COLON_COLON] = ACTIONS(2908),
    [anon_sym_AMP] = ACTIONS(2906),
    [anon_sym_LBRACK] = ACTIONS(2906),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2908),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_LT_AT] = ACTIONS(2906),
    [anon_sym_LT_AT_AT] = ACTIONS(2906),
    [anon_sym_DOT] = ACTIONS(2906),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2908),
    [anon_sym_new] = ACTIONS(2906),
    [anon_sym_return_BANG] = ACTIONS(2908),
    [anon_sym_yield] = ACTIONS(2906),
    [anon_sym_yield_BANG] = ACTIONS(2908),
    [anon_sym_lazy] = ACTIONS(2906),
    [anon_sym_assert] = ACTIONS(2906),
    [anon_sym_upcast] = ACTIONS(2906),
    [anon_sym_downcast] = ACTIONS(2906),
    [anon_sym_COLON_GT] = ACTIONS(2908),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2908),
    [anon_sym_for] = ACTIONS(2906),
    [anon_sym_while] = ACTIONS(2906),
    [anon_sym_if] = ACTIONS(2906),
    [anon_sym_fun] = ACTIONS(2906),
    [anon_sym_DASH_GT] = ACTIONS(2906),
    [anon_sym_try] = ACTIONS(2906),
    [anon_sym_match] = ACTIONS(2906),
    [anon_sym_match_BANG] = ACTIONS(2908),
    [anon_sym_function] = ACTIONS(2906),
    [anon_sym_LT_DASH] = ACTIONS(2906),
    [anon_sym_DOT_LBRACK] = ACTIONS(2908),
    [anon_sym_LT] = ACTIONS(2908),
    [anon_sym_use] = ACTIONS(2906),
    [anon_sym_use_BANG] = ACTIONS(2908),
    [anon_sym_do_BANG] = ACTIONS(2908),
    [anon_sym_DOT_DOT] = ACTIONS(2908),
    [anon_sym_begin] = ACTIONS(2906),
    [anon_sym_LPAREN2] = ACTIONS(2906),
    [anon_sym_or] = ACTIONS(2906),
    [aux_sym_char_token1] = ACTIONS(2908),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2906),
    [anon_sym_DQUOTE] = ACTIONS(2906),
    [anon_sym_AT_DQUOTE] = ACTIONS(2908),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2908),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2908),
    [sym_bool] = ACTIONS(2906),
    [sym_unit] = ACTIONS(2908),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2906),
    [sym_op_identifier] = ACTIONS(2906),
    [anon_sym_PLUS] = ACTIONS(2906),
    [anon_sym_DASH] = ACTIONS(2906),
    [anon_sym_PLUS_DOT] = ACTIONS(2906),
    [anon_sym_DASH_DOT] = ACTIONS(2906),
    [anon_sym_PERCENT] = ACTIONS(2906),
    [anon_sym_AMP_AMP] = ACTIONS(2906),
    [anon_sym_TILDE] = ACTIONS(2908),
    [aux_sym_prefix_op_token1] = ACTIONS(2906),
    [aux_sym_infix_op_token1] = ACTIONS(2908),
    [aux_sym_infix_op_token2] = ACTIONS(2906),
    [anon_sym_PIPE_PIPE] = ACTIONS(2906),
    [anon_sym_BANG_EQ] = ACTIONS(2906),
    [anon_sym_COLON_EQ] = ACTIONS(2908),
    [anon_sym_DOLLAR] = ACTIONS(2906),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2906),
    [sym_int] = ACTIONS(2906),
    [sym_xint] = ACTIONS(2908),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2908),
    [sym__newline] = ACTIONS(2908),
  },
  [1999] = {
    [sym_block_comment] = STATE(1999),
    [sym_compiler_directive_decl] = STATE(1999),
    [sym_fsi_directive_decl] = STATE(1999),
    [sym_preproc_line] = STATE(1999),
    [sym_identifier] = ACTIONS(2902),
    [anon_sym_EQ] = ACTIONS(2904),
    [anon_sym_COLON] = ACTIONS(2902),
    [anon_sym_return] = ACTIONS(2902),
    [anon_sym_do] = ACTIONS(2902),
    [anon_sym_let] = ACTIONS(2902),
    [anon_sym_let_BANG] = ACTIONS(2904),
    [anon_sym_LPAREN] = ACTIONS(2902),
    [anon_sym_COMMA] = ACTIONS(2904),
    [anon_sym_null] = ACTIONS(2902),
    [anon_sym_QMARK] = ACTIONS(2902),
    [anon_sym_COLON_QMARK] = ACTIONS(2902),
    [anon_sym_COLON_COLON] = ACTIONS(2904),
    [anon_sym_AMP] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2902),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2902),
    [anon_sym_LT_AT] = ACTIONS(2902),
    [anon_sym_LT_AT_AT] = ACTIONS(2902),
    [anon_sym_DOT] = ACTIONS(2902),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2904),
    [anon_sym_new] = ACTIONS(2902),
    [anon_sym_return_BANG] = ACTIONS(2904),
    [anon_sym_yield] = ACTIONS(2902),
    [anon_sym_yield_BANG] = ACTIONS(2904),
    [anon_sym_lazy] = ACTIONS(2902),
    [anon_sym_assert] = ACTIONS(2902),
    [anon_sym_upcast] = ACTIONS(2902),
    [anon_sym_downcast] = ACTIONS(2902),
    [anon_sym_COLON_GT] = ACTIONS(2904),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2904),
    [anon_sym_for] = ACTIONS(2902),
    [anon_sym_while] = ACTIONS(2902),
    [anon_sym_if] = ACTIONS(2902),
    [anon_sym_fun] = ACTIONS(2902),
    [anon_sym_DASH_GT] = ACTIONS(2902),
    [anon_sym_try] = ACTIONS(2902),
    [anon_sym_match] = ACTIONS(2902),
    [anon_sym_match_BANG] = ACTIONS(2904),
    [anon_sym_function] = ACTIONS(2902),
    [anon_sym_LT_DASH] = ACTIONS(2902),
    [anon_sym_DOT_LBRACK] = ACTIONS(2904),
    [anon_sym_LT] = ACTIONS(2904),
    [anon_sym_use] = ACTIONS(2902),
    [anon_sym_use_BANG] = ACTIONS(2904),
    [anon_sym_do_BANG] = ACTIONS(2904),
    [anon_sym_DOT_DOT] = ACTIONS(2904),
    [anon_sym_begin] = ACTIONS(2902),
    [anon_sym_LPAREN2] = ACTIONS(2902),
    [anon_sym_or] = ACTIONS(2902),
    [aux_sym_char_token1] = ACTIONS(2904),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2902),
    [anon_sym_DQUOTE] = ACTIONS(2902),
    [anon_sym_AT_DQUOTE] = ACTIONS(2904),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2904),
    [sym_bool] = ACTIONS(2902),
    [sym_unit] = ACTIONS(2904),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2902),
    [sym_op_identifier] = ACTIONS(2902),
    [anon_sym_PLUS] = ACTIONS(2902),
    [anon_sym_DASH] = ACTIONS(2902),
    [anon_sym_PLUS_DOT] = ACTIONS(2902),
    [anon_sym_DASH_DOT] = ACTIONS(2902),
    [anon_sym_PERCENT] = ACTIONS(2902),
    [anon_sym_AMP_AMP] = ACTIONS(2902),
    [anon_sym_TILDE] = ACTIONS(2904),
    [aux_sym_prefix_op_token1] = ACTIONS(2902),
    [aux_sym_infix_op_token1] = ACTIONS(2904),
    [aux_sym_infix_op_token2] = ACTIONS(2902),
    [anon_sym_PIPE_PIPE] = ACTIONS(2902),
    [anon_sym_BANG_EQ] = ACTIONS(2902),
    [anon_sym_COLON_EQ] = ACTIONS(2904),
    [anon_sym_DOLLAR] = ACTIONS(2902),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2902),
    [sym_int] = ACTIONS(2902),
    [sym_xint] = ACTIONS(2904),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2904),
    [sym__newline] = ACTIONS(2904),
  },
  [2000] = {
    [sym_block_comment] = STATE(2000),
    [sym_compiler_directive_decl] = STATE(2000),
    [sym_fsi_directive_decl] = STATE(2000),
    [sym_preproc_line] = STATE(2000),
    [sym_identifier] = ACTIONS(2851),
    [anon_sym_EQ] = ACTIONS(2853),
    [anon_sym_COLON] = ACTIONS(2851),
    [anon_sym_return] = ACTIONS(2851),
    [anon_sym_do] = ACTIONS(2851),
    [anon_sym_let] = ACTIONS(2851),
    [anon_sym_let_BANG] = ACTIONS(2853),
    [anon_sym_LPAREN] = ACTIONS(2851),
    [anon_sym_COMMA] = ACTIONS(2853),
    [anon_sym_null] = ACTIONS(2851),
    [anon_sym_QMARK] = ACTIONS(2851),
    [anon_sym_COLON_QMARK] = ACTIONS(2851),
    [anon_sym_COLON_COLON] = ACTIONS(2853),
    [anon_sym_AMP] = ACTIONS(2851),
    [anon_sym_LBRACK] = ACTIONS(2851),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2853),
    [anon_sym_LBRACE] = ACTIONS(2851),
    [anon_sym_LT_AT] = ACTIONS(2851),
    [anon_sym_LT_AT_AT] = ACTIONS(2851),
    [anon_sym_DOT] = ACTIONS(2851),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2853),
    [anon_sym_new] = ACTIONS(2851),
    [anon_sym_return_BANG] = ACTIONS(2853),
    [anon_sym_yield] = ACTIONS(2851),
    [anon_sym_yield_BANG] = ACTIONS(2853),
    [anon_sym_lazy] = ACTIONS(2851),
    [anon_sym_assert] = ACTIONS(2851),
    [anon_sym_upcast] = ACTIONS(2851),
    [anon_sym_downcast] = ACTIONS(2851),
    [anon_sym_COLON_GT] = ACTIONS(2853),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2853),
    [anon_sym_for] = ACTIONS(2851),
    [anon_sym_while] = ACTIONS(2851),
    [anon_sym_if] = ACTIONS(2851),
    [anon_sym_fun] = ACTIONS(2851),
    [anon_sym_try] = ACTIONS(2851),
    [anon_sym_match] = ACTIONS(2851),
    [anon_sym_match_BANG] = ACTIONS(2853),
    [anon_sym_function] = ACTIONS(2851),
    [anon_sym_LT_DASH] = ACTIONS(2851),
    [anon_sym_DOT_LBRACK] = ACTIONS(2853),
    [anon_sym_LT] = ACTIONS(2853),
    [anon_sym_use] = ACTIONS(2851),
    [anon_sym_use_BANG] = ACTIONS(2853),
    [anon_sym_do_BANG] = ACTIONS(2853),
    [anon_sym_begin] = ACTIONS(2851),
    [anon_sym_LPAREN2] = ACTIONS(2851),
    [anon_sym_or] = ACTIONS(2851),
    [aux_sym_char_token1] = ACTIONS(2853),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2851),
    [anon_sym_DQUOTE] = ACTIONS(2851),
    [anon_sym_AT_DQUOTE] = ACTIONS(2853),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2853),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2853),
    [sym_bool] = ACTIONS(2851),
    [sym_unit] = ACTIONS(2853),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2851),
    [sym_op_identifier] = ACTIONS(2851),
    [anon_sym_PLUS] = ACTIONS(2851),
    [anon_sym_DASH] = ACTIONS(2851),
    [anon_sym_PLUS_DOT] = ACTIONS(2851),
    [anon_sym_DASH_DOT] = ACTIONS(2851),
    [anon_sym_PERCENT] = ACTIONS(2851),
    [anon_sym_AMP_AMP] = ACTIONS(2851),
    [anon_sym_TILDE] = ACTIONS(2853),
    [aux_sym_prefix_op_token1] = ACTIONS(2851),
    [aux_sym_infix_op_token1] = ACTIONS(2853),
    [aux_sym_infix_op_token2] = ACTIONS(2851),
    [anon_sym_PIPE_PIPE] = ACTIONS(2851),
    [anon_sym_BANG_EQ] = ACTIONS(2851),
    [anon_sym_COLON_EQ] = ACTIONS(2853),
    [anon_sym_DOLLAR] = ACTIONS(2851),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2851),
    [sym_int] = ACTIONS(2851),
    [sym_xint] = ACTIONS(2853),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2853),
    [anon_sym_POUNDendif] = ACTIONS(2853),
    [anon_sym_POUNDelse] = ACTIONS(2853),
    [sym__newline] = ACTIONS(2853),
  },
  [2001] = {
    [sym_block_comment] = STATE(2001),
    [sym_compiler_directive_decl] = STATE(2001),
    [sym_fsi_directive_decl] = STATE(2001),
    [sym_preproc_line] = STATE(2001),
    [sym_identifier] = ACTIONS(2881),
    [anon_sym_EQ] = ACTIONS(2789),
    [anon_sym_COLON] = ACTIONS(2881),
    [anon_sym_return] = ACTIONS(2881),
    [anon_sym_do] = ACTIONS(2881),
    [anon_sym_let] = ACTIONS(2881),
    [anon_sym_let_BANG] = ACTIONS(2789),
    [anon_sym_LPAREN] = ACTIONS(2881),
    [anon_sym_COMMA] = ACTIONS(2789),
    [anon_sym_null] = ACTIONS(2881),
    [anon_sym_QMARK] = ACTIONS(2881),
    [anon_sym_COLON_QMARK] = ACTIONS(2881),
    [anon_sym_COLON_COLON] = ACTIONS(2789),
    [anon_sym_AMP] = ACTIONS(2881),
    [anon_sym_LBRACK] = ACTIONS(2881),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2789),
    [anon_sym_LBRACE] = ACTIONS(2881),
    [anon_sym_LT_AT] = ACTIONS(2881),
    [anon_sym_LT_AT_AT] = ACTIONS(2881),
    [anon_sym_DOT] = ACTIONS(2881),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2789),
    [anon_sym_new] = ACTIONS(2881),
    [anon_sym_return_BANG] = ACTIONS(2789),
    [anon_sym_yield] = ACTIONS(2881),
    [anon_sym_yield_BANG] = ACTIONS(2789),
    [anon_sym_lazy] = ACTIONS(2881),
    [anon_sym_assert] = ACTIONS(2881),
    [anon_sym_upcast] = ACTIONS(2881),
    [anon_sym_downcast] = ACTIONS(2881),
    [anon_sym_COLON_GT] = ACTIONS(2789),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2789),
    [anon_sym_for] = ACTIONS(2881),
    [anon_sym_while] = ACTIONS(2881),
    [anon_sym_if] = ACTIONS(2881),
    [anon_sym_fun] = ACTIONS(2881),
    [anon_sym_DASH_GT] = ACTIONS(2881),
    [anon_sym_try] = ACTIONS(2881),
    [anon_sym_match] = ACTIONS(2881),
    [anon_sym_match_BANG] = ACTIONS(2789),
    [anon_sym_function] = ACTIONS(2881),
    [anon_sym_LT_DASH] = ACTIONS(2881),
    [anon_sym_DOT_LBRACK] = ACTIONS(2789),
    [anon_sym_LT] = ACTIONS(2789),
    [anon_sym_use] = ACTIONS(2881),
    [anon_sym_use_BANG] = ACTIONS(2789),
    [anon_sym_do_BANG] = ACTIONS(2789),
    [anon_sym_DOT_DOT] = ACTIONS(2789),
    [anon_sym_begin] = ACTIONS(2881),
    [anon_sym_LPAREN2] = ACTIONS(2881),
    [anon_sym_or] = ACTIONS(2881),
    [aux_sym_char_token1] = ACTIONS(2789),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2881),
    [anon_sym_DQUOTE] = ACTIONS(2881),
    [anon_sym_AT_DQUOTE] = ACTIONS(2789),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2789),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2789),
    [sym_bool] = ACTIONS(2881),
    [sym_unit] = ACTIONS(2789),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2881),
    [sym_op_identifier] = ACTIONS(2881),
    [anon_sym_PLUS] = ACTIONS(2881),
    [anon_sym_DASH] = ACTIONS(2881),
    [anon_sym_PLUS_DOT] = ACTIONS(2881),
    [anon_sym_DASH_DOT] = ACTIONS(2881),
    [anon_sym_PERCENT] = ACTIONS(2881),
    [anon_sym_AMP_AMP] = ACTIONS(2881),
    [anon_sym_TILDE] = ACTIONS(2789),
    [aux_sym_prefix_op_token1] = ACTIONS(2881),
    [aux_sym_infix_op_token1] = ACTIONS(2789),
    [aux_sym_infix_op_token2] = ACTIONS(2881),
    [anon_sym_PIPE_PIPE] = ACTIONS(2881),
    [anon_sym_BANG_EQ] = ACTIONS(2881),
    [anon_sym_COLON_EQ] = ACTIONS(2789),
    [anon_sym_DOLLAR] = ACTIONS(2881),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2881),
    [sym_int] = ACTIONS(2881),
    [sym_xint] = ACTIONS(2789),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2789),
    [sym__newline] = ACTIONS(2789),
  },
  [2002] = {
    [sym_block_comment] = STATE(2002),
    [sym_compiler_directive_decl] = STATE(2002),
    [sym_fsi_directive_decl] = STATE(2002),
    [sym_preproc_line] = STATE(2002),
    [aux_sym_long_identifier_repeat1] = STATE(2002),
    [sym_identifier] = ACTIONS(2411),
    [anon_sym_EQ] = ACTIONS(2413),
    [anon_sym_COLON] = ACTIONS(2411),
    [anon_sym_return] = ACTIONS(2411),
    [anon_sym_do] = ACTIONS(2411),
    [anon_sym_let] = ACTIONS(2411),
    [anon_sym_let_BANG] = ACTIONS(2413),
    [anon_sym_LPAREN] = ACTIONS(2411),
    [anon_sym_COMMA] = ACTIONS(2413),
    [anon_sym_null] = ACTIONS(2411),
    [anon_sym_QMARK] = ACTIONS(2411),
    [anon_sym_COLON_QMARK] = ACTIONS(2411),
    [anon_sym_COLON_COLON] = ACTIONS(2413),
    [anon_sym_AMP] = ACTIONS(2411),
    [anon_sym_LBRACK] = ACTIONS(2411),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2413),
    [anon_sym_LBRACE] = ACTIONS(2411),
    [anon_sym_LT_AT] = ACTIONS(2411),
    [anon_sym_AT_GT] = ACTIONS(2411),
    [anon_sym_LT_AT_AT] = ACTIONS(2411),
    [anon_sym_DOT] = ACTIONS(4172),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2413),
    [anon_sym_new] = ACTIONS(2411),
    [anon_sym_return_BANG] = ACTIONS(2413),
    [anon_sym_yield] = ACTIONS(2411),
    [anon_sym_yield_BANG] = ACTIONS(2413),
    [anon_sym_lazy] = ACTIONS(2411),
    [anon_sym_assert] = ACTIONS(2411),
    [anon_sym_upcast] = ACTIONS(2411),
    [anon_sym_downcast] = ACTIONS(2411),
    [anon_sym_COLON_GT] = ACTIONS(2413),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2413),
    [anon_sym_for] = ACTIONS(2411),
    [anon_sym_while] = ACTIONS(2411),
    [anon_sym_if] = ACTIONS(2411),
    [anon_sym_fun] = ACTIONS(2411),
    [anon_sym_try] = ACTIONS(2411),
    [anon_sym_match] = ACTIONS(2411),
    [anon_sym_match_BANG] = ACTIONS(2413),
    [anon_sym_function] = ACTIONS(2411),
    [anon_sym_LT_DASH] = ACTIONS(2411),
    [anon_sym_DOT_LBRACK] = ACTIONS(2413),
    [anon_sym_LT] = ACTIONS(2413),
    [anon_sym_use] = ACTIONS(2411),
    [anon_sym_use_BANG] = ACTIONS(2413),
    [anon_sym_do_BANG] = ACTIONS(2413),
    [anon_sym_begin] = ACTIONS(2411),
    [anon_sym_LPAREN2] = ACTIONS(2411),
    [anon_sym_or] = ACTIONS(2411),
    [aux_sym_char_token1] = ACTIONS(2413),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2411),
    [anon_sym_DQUOTE] = ACTIONS(2411),
    [anon_sym_AT_DQUOTE] = ACTIONS(2413),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2413),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2413),
    [sym_bool] = ACTIONS(2411),
    [sym_unit] = ACTIONS(2413),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2411),
    [sym_op_identifier] = ACTIONS(2411),
    [anon_sym_PLUS] = ACTIONS(2411),
    [anon_sym_DASH] = ACTIONS(2411),
    [anon_sym_PLUS_DOT] = ACTIONS(2411),
    [anon_sym_DASH_DOT] = ACTIONS(2411),
    [anon_sym_PERCENT] = ACTIONS(2411),
    [anon_sym_AMP_AMP] = ACTIONS(2411),
    [anon_sym_TILDE] = ACTIONS(2413),
    [aux_sym_prefix_op_token1] = ACTIONS(2411),
    [aux_sym_infix_op_token1] = ACTIONS(2413),
    [aux_sym_infix_op_token2] = ACTIONS(2411),
    [anon_sym_PIPE_PIPE] = ACTIONS(2411),
    [anon_sym_BANG_EQ] = ACTIONS(2411),
    [anon_sym_COLON_EQ] = ACTIONS(2413),
    [anon_sym_DOLLAR] = ACTIONS(2411),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2411),
    [sym_int] = ACTIONS(2411),
    [sym_xint] = ACTIONS(2413),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2413),
    [sym__newline] = ACTIONS(2413),
  },
  [2003] = {
    [sym_block_comment] = STATE(2003),
    [sym_compiler_directive_decl] = STATE(2003),
    [sym_fsi_directive_decl] = STATE(2003),
    [sym_preproc_line] = STATE(2003),
    [sym_identifier] = ACTIONS(2839),
    [anon_sym_EQ] = ACTIONS(2841),
    [anon_sym_COLON] = ACTIONS(2839),
    [anon_sym_return] = ACTIONS(2839),
    [anon_sym_do] = ACTIONS(2839),
    [anon_sym_let] = ACTIONS(2839),
    [anon_sym_let_BANG] = ACTIONS(2841),
    [anon_sym_LPAREN] = ACTIONS(2839),
    [anon_sym_COMMA] = ACTIONS(2841),
    [anon_sym_null] = ACTIONS(2839),
    [anon_sym_QMARK] = ACTIONS(2839),
    [anon_sym_COLON_QMARK] = ACTIONS(2839),
    [anon_sym_COLON_COLON] = ACTIONS(2841),
    [anon_sym_AMP] = ACTIONS(2839),
    [anon_sym_LBRACK] = ACTIONS(2839),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2841),
    [anon_sym_LBRACE] = ACTIONS(2839),
    [anon_sym_LT_AT] = ACTIONS(2839),
    [anon_sym_LT_AT_AT] = ACTIONS(2839),
    [anon_sym_DOT] = ACTIONS(2839),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2841),
    [anon_sym_new] = ACTIONS(2839),
    [anon_sym_return_BANG] = ACTIONS(2841),
    [anon_sym_yield] = ACTIONS(2839),
    [anon_sym_yield_BANG] = ACTIONS(2841),
    [anon_sym_lazy] = ACTIONS(2839),
    [anon_sym_assert] = ACTIONS(2839),
    [anon_sym_upcast] = ACTIONS(2839),
    [anon_sym_downcast] = ACTIONS(2839),
    [anon_sym_COLON_GT] = ACTIONS(2841),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2841),
    [anon_sym_for] = ACTIONS(2839),
    [anon_sym_while] = ACTIONS(2839),
    [anon_sym_if] = ACTIONS(2839),
    [anon_sym_fun] = ACTIONS(2839),
    [anon_sym_try] = ACTIONS(2839),
    [anon_sym_match] = ACTIONS(2839),
    [anon_sym_match_BANG] = ACTIONS(2841),
    [anon_sym_function] = ACTIONS(2839),
    [anon_sym_LT_DASH] = ACTIONS(2839),
    [anon_sym_DOT_LBRACK] = ACTIONS(2841),
    [anon_sym_LT] = ACTIONS(2841),
    [anon_sym_use] = ACTIONS(2839),
    [anon_sym_use_BANG] = ACTIONS(2841),
    [anon_sym_do_BANG] = ACTIONS(2841),
    [anon_sym_begin] = ACTIONS(2839),
    [anon_sym_LPAREN2] = ACTIONS(2839),
    [anon_sym_or] = ACTIONS(2839),
    [aux_sym_char_token1] = ACTIONS(2841),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2839),
    [anon_sym_DQUOTE] = ACTIONS(2839),
    [anon_sym_AT_DQUOTE] = ACTIONS(2841),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2841),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2841),
    [sym_bool] = ACTIONS(2839),
    [sym_unit] = ACTIONS(2841),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2839),
    [sym_op_identifier] = ACTIONS(2839),
    [anon_sym_PLUS] = ACTIONS(2839),
    [anon_sym_DASH] = ACTIONS(2839),
    [anon_sym_PLUS_DOT] = ACTIONS(2839),
    [anon_sym_DASH_DOT] = ACTIONS(2839),
    [anon_sym_PERCENT] = ACTIONS(2839),
    [anon_sym_AMP_AMP] = ACTIONS(2839),
    [anon_sym_TILDE] = ACTIONS(2841),
    [aux_sym_prefix_op_token1] = ACTIONS(2839),
    [aux_sym_infix_op_token1] = ACTIONS(2841),
    [aux_sym_infix_op_token2] = ACTIONS(2839),
    [anon_sym_PIPE_PIPE] = ACTIONS(2839),
    [anon_sym_BANG_EQ] = ACTIONS(2839),
    [anon_sym_COLON_EQ] = ACTIONS(2841),
    [anon_sym_DOLLAR] = ACTIONS(2839),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2839),
    [sym_int] = ACTIONS(2839),
    [sym_xint] = ACTIONS(2841),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2841),
    [anon_sym_POUNDendif] = ACTIONS(2841),
    [anon_sym_POUNDelse] = ACTIONS(2841),
    [sym__newline] = ACTIONS(2841),
  },
  [2004] = {
    [sym_attributes] = STATE(2699),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(4815),
    [sym__pattern] = STATE(5220),
    [sym_optional_pattern] = STATE(4815),
    [sym_type_check_pattern] = STATE(4815),
    [sym_attribute_pattern] = STATE(4815),
    [sym_paren_pattern] = STATE(4815),
    [sym_as_pattern] = STATE(4815),
    [sym_cons_pattern] = STATE(4815),
    [sym_disjunct_pattern] = STATE(4815),
    [sym_conjunct_pattern] = STATE(4815),
    [sym_typed_pattern] = STATE(4815),
    [sym_list_pattern] = STATE(4815),
    [sym_array_pattern] = STATE(4815),
    [sym_record_pattern] = STATE(4815),
    [sym_named_field_pattern] = STATE(4815),
    [sym_identifier_pattern] = STATE(4815),
    [sym_long_identifier_or_op] = STATE(2193),
    [sym_char] = STATE(4765),
    [sym_format_string] = STATE(4746),
    [sym__string_literal] = STATE(4746),
    [sym_string] = STATE(4765),
    [sym_verbatim_string] = STATE(4765),
    [sym_bytearray] = STATE(4765),
    [sym_verbatim_bytearray] = STATE(4765),
    [sym_format_triple_quoted_string] = STATE(4720),
    [sym_triple_quoted_string] = STATE(4765),
    [sym_const] = STATE(4815),
    [sym_long_identifier] = STATE(3493),
    [sym_active_pattern] = STATE(3613),
    [sym__identifier_or_op] = STATE(3650),
    [sym_sbyte] = STATE(4765),
    [sym_byte] = STATE(4765),
    [sym_int16] = STATE(4765),
    [sym_uint16] = STATE(4765),
    [sym_int32] = STATE(4765),
    [sym_uint32] = STATE(4765),
    [sym_nativeint] = STATE(4765),
    [sym_unativeint] = STATE(4765),
    [sym_int64] = STATE(4765),
    [sym_uint64] = STATE(4765),
    [sym_ieee32] = STATE(4765),
    [sym_ieee64] = STATE(4765),
    [sym_bignum] = STATE(4765),
    [sym_decimal] = STATE(4765),
    [sym_float] = STATE(4512),
    [sym_block_comment] = STATE(2004),
    [sym_compiler_directive_decl] = STATE(2004),
    [sym_fsi_directive_decl] = STATE(2004),
    [sym_preproc_line] = STATE(2004),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [aux_sym_repeat_pattern_repeat1] = STATE(3452),
    [sym_identifier] = ACTIONS(4175),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_COLON] = ACTIONS(3716),
    [anon_sym_as] = ACTIONS(4125),
    [anon_sym_LPAREN] = ACTIONS(3572),
    [anon_sym_COMMA] = ACTIONS(4127),
    [anon_sym_null] = ACTIONS(3574),
    [anon_sym__] = ACTIONS(3576),
    [anon_sym_QMARK] = ACTIONS(4177),
    [anon_sym_COLON_QMARK] = ACTIONS(4179),
    [anon_sym_COLON_COLON] = ACTIONS(4129),
    [anon_sym_PIPE] = ACTIONS(4131),
    [anon_sym_AMP] = ACTIONS(4133),
    [anon_sym_LBRACK] = ACTIONS(3582),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3584),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [anon_sym_DASH_GT] = ACTIONS(3714),
    [anon_sym_when] = ACTIONS(3716),
    [aux_sym_char_token1] = ACTIONS(3590),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3592),
    [anon_sym_DQUOTE] = ACTIONS(3594),
    [anon_sym_AT_DQUOTE] = ACTIONS(3596),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3598),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3600),
    [sym_bool] = ACTIONS(3602),
    [sym_unit] = ACTIONS(3604),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4181),
    [sym_op_identifier] = ACTIONS(4183),
    [sym_int] = ACTIONS(3610),
    [sym_xint] = ACTIONS(3612),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2005] = {
    [sym_block_comment] = STATE(2005),
    [sym_compiler_directive_decl] = STATE(2005),
    [sym_fsi_directive_decl] = STATE(2005),
    [sym_preproc_line] = STATE(2005),
    [sym_identifier] = ACTIONS(2934),
    [anon_sym_EQ] = ACTIONS(2936),
    [anon_sym_COLON] = ACTIONS(2934),
    [anon_sym_return] = ACTIONS(2934),
    [anon_sym_do] = ACTIONS(2934),
    [anon_sym_let] = ACTIONS(2934),
    [anon_sym_let_BANG] = ACTIONS(2936),
    [anon_sym_LPAREN] = ACTIONS(2934),
    [anon_sym_COMMA] = ACTIONS(2936),
    [anon_sym_null] = ACTIONS(2934),
    [anon_sym_QMARK] = ACTIONS(2934),
    [anon_sym_COLON_QMARK] = ACTIONS(2934),
    [anon_sym_COLON_COLON] = ACTIONS(2936),
    [anon_sym_AMP] = ACTIONS(2934),
    [anon_sym_LBRACK] = ACTIONS(2934),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2936),
    [anon_sym_LBRACE] = ACTIONS(2934),
    [anon_sym_LT_AT] = ACTIONS(2934),
    [anon_sym_LT_AT_AT] = ACTIONS(2934),
    [anon_sym_DOT] = ACTIONS(2934),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2936),
    [anon_sym_new] = ACTIONS(2934),
    [anon_sym_return_BANG] = ACTIONS(2936),
    [anon_sym_yield] = ACTIONS(2934),
    [anon_sym_yield_BANG] = ACTIONS(2936),
    [anon_sym_lazy] = ACTIONS(2934),
    [anon_sym_assert] = ACTIONS(2934),
    [anon_sym_upcast] = ACTIONS(2934),
    [anon_sym_downcast] = ACTIONS(2934),
    [anon_sym_COLON_GT] = ACTIONS(2936),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2936),
    [anon_sym_for] = ACTIONS(2934),
    [anon_sym_while] = ACTIONS(2934),
    [anon_sym_if] = ACTIONS(2934),
    [anon_sym_fun] = ACTIONS(2934),
    [anon_sym_DASH_GT] = ACTIONS(2934),
    [anon_sym_try] = ACTIONS(2934),
    [anon_sym_match] = ACTIONS(2934),
    [anon_sym_match_BANG] = ACTIONS(2936),
    [anon_sym_function] = ACTIONS(2934),
    [anon_sym_LT_DASH] = ACTIONS(2934),
    [anon_sym_DOT_LBRACK] = ACTIONS(2936),
    [anon_sym_LT] = ACTIONS(2936),
    [anon_sym_use] = ACTIONS(2934),
    [anon_sym_use_BANG] = ACTIONS(2936),
    [anon_sym_do_BANG] = ACTIONS(2936),
    [anon_sym_DOT_DOT] = ACTIONS(2936),
    [anon_sym_begin] = ACTIONS(2934),
    [anon_sym_LPAREN2] = ACTIONS(2934),
    [anon_sym_or] = ACTIONS(2934),
    [aux_sym_char_token1] = ACTIONS(2936),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2934),
    [anon_sym_DQUOTE] = ACTIONS(2934),
    [anon_sym_AT_DQUOTE] = ACTIONS(2936),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2936),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2936),
    [sym_bool] = ACTIONS(2934),
    [sym_unit] = ACTIONS(2936),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2934),
    [sym_op_identifier] = ACTIONS(2934),
    [anon_sym_PLUS] = ACTIONS(2934),
    [anon_sym_DASH] = ACTIONS(2934),
    [anon_sym_PLUS_DOT] = ACTIONS(2934),
    [anon_sym_DASH_DOT] = ACTIONS(2934),
    [anon_sym_PERCENT] = ACTIONS(2934),
    [anon_sym_AMP_AMP] = ACTIONS(2934),
    [anon_sym_TILDE] = ACTIONS(2936),
    [aux_sym_prefix_op_token1] = ACTIONS(2934),
    [aux_sym_infix_op_token1] = ACTIONS(2936),
    [aux_sym_infix_op_token2] = ACTIONS(2934),
    [anon_sym_PIPE_PIPE] = ACTIONS(2934),
    [anon_sym_BANG_EQ] = ACTIONS(2934),
    [anon_sym_COLON_EQ] = ACTIONS(2936),
    [anon_sym_DOLLAR] = ACTIONS(2934),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2934),
    [sym_int] = ACTIONS(2934),
    [sym_xint] = ACTIONS(2936),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2936),
    [sym__newline] = ACTIONS(2936),
  },
  [2006] = {
    [sym_block_comment] = STATE(2006),
    [sym_compiler_directive_decl] = STATE(2006),
    [sym_fsi_directive_decl] = STATE(2006),
    [sym_preproc_line] = STATE(2006),
    [sym_identifier] = ACTIONS(3115),
    [anon_sym_EQ] = ACTIONS(3117),
    [anon_sym_COLON] = ACTIONS(3115),
    [anon_sym_return] = ACTIONS(3115),
    [anon_sym_do] = ACTIONS(3115),
    [anon_sym_and] = ACTIONS(3115),
    [anon_sym_let] = ACTIONS(3115),
    [anon_sym_let_BANG] = ACTIONS(3117),
    [anon_sym_LPAREN] = ACTIONS(3115),
    [anon_sym_COMMA] = ACTIONS(3117),
    [anon_sym_null] = ACTIONS(3115),
    [anon_sym_QMARK] = ACTIONS(3115),
    [anon_sym_COLON_QMARK] = ACTIONS(3115),
    [anon_sym_COLON_COLON] = ACTIONS(3117),
    [anon_sym_AMP] = ACTIONS(3115),
    [anon_sym_LBRACK] = ACTIONS(3115),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3117),
    [anon_sym_LBRACE] = ACTIONS(3115),
    [anon_sym_LT_AT] = ACTIONS(3115),
    [anon_sym_LT_AT_AT] = ACTIONS(3115),
    [anon_sym_DOT] = ACTIONS(3115),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3117),
    [anon_sym_new] = ACTIONS(3115),
    [anon_sym_return_BANG] = ACTIONS(3117),
    [anon_sym_yield] = ACTIONS(3115),
    [anon_sym_yield_BANG] = ACTIONS(3117),
    [anon_sym_lazy] = ACTIONS(3115),
    [anon_sym_assert] = ACTIONS(3115),
    [anon_sym_upcast] = ACTIONS(3115),
    [anon_sym_downcast] = ACTIONS(3115),
    [anon_sym_COLON_GT] = ACTIONS(3117),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3117),
    [anon_sym_for] = ACTIONS(3115),
    [anon_sym_while] = ACTIONS(3115),
    [anon_sym_if] = ACTIONS(3115),
    [anon_sym_fun] = ACTIONS(3115),
    [anon_sym_try] = ACTIONS(3115),
    [anon_sym_match] = ACTIONS(3115),
    [anon_sym_match_BANG] = ACTIONS(3117),
    [anon_sym_function] = ACTIONS(3115),
    [anon_sym_LT_DASH] = ACTIONS(3115),
    [anon_sym_DOT_LBRACK] = ACTIONS(3117),
    [anon_sym_LT] = ACTIONS(3117),
    [anon_sym_use] = ACTIONS(3115),
    [anon_sym_use_BANG] = ACTIONS(3117),
    [anon_sym_do_BANG] = ACTIONS(3117),
    [anon_sym_begin] = ACTIONS(3115),
    [anon_sym_LPAREN2] = ACTIONS(3115),
    [anon_sym_or] = ACTIONS(3115),
    [aux_sym_char_token1] = ACTIONS(3117),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3115),
    [anon_sym_DQUOTE] = ACTIONS(3115),
    [anon_sym_AT_DQUOTE] = ACTIONS(3117),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3117),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3117),
    [sym_bool] = ACTIONS(3115),
    [sym_unit] = ACTIONS(3117),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3115),
    [sym_op_identifier] = ACTIONS(3115),
    [anon_sym_PLUS] = ACTIONS(3115),
    [anon_sym_DASH] = ACTIONS(3115),
    [anon_sym_PLUS_DOT] = ACTIONS(3115),
    [anon_sym_DASH_DOT] = ACTIONS(3115),
    [anon_sym_PERCENT] = ACTIONS(3115),
    [anon_sym_AMP_AMP] = ACTIONS(3115),
    [anon_sym_TILDE] = ACTIONS(3117),
    [aux_sym_prefix_op_token1] = ACTIONS(3115),
    [aux_sym_infix_op_token1] = ACTIONS(3117),
    [aux_sym_infix_op_token2] = ACTIONS(3115),
    [anon_sym_PIPE_PIPE] = ACTIONS(3115),
    [anon_sym_BANG_EQ] = ACTIONS(3115),
    [anon_sym_COLON_EQ] = ACTIONS(3117),
    [anon_sym_DOLLAR] = ACTIONS(3115),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3115),
    [sym_int] = ACTIONS(3115),
    [sym_xint] = ACTIONS(3117),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3117),
    [sym__newline] = ACTIONS(3117),
    [sym__dedent] = ACTIONS(3117),
  },
  [2007] = {
    [sym_block_comment] = STATE(2007),
    [sym_compiler_directive_decl] = STATE(2007),
    [sym_fsi_directive_decl] = STATE(2007),
    [sym_preproc_line] = STATE(2007),
    [sym_identifier] = ACTIONS(2839),
    [anon_sym_EQ] = ACTIONS(2841),
    [anon_sym_COLON] = ACTIONS(2839),
    [anon_sym_return] = ACTIONS(2839),
    [anon_sym_do] = ACTIONS(2839),
    [anon_sym_let] = ACTIONS(2839),
    [anon_sym_let_BANG] = ACTIONS(2841),
    [anon_sym_LPAREN] = ACTIONS(2839),
    [anon_sym_COMMA] = ACTIONS(2841),
    [anon_sym_null] = ACTIONS(2839),
    [anon_sym_QMARK] = ACTIONS(2839),
    [anon_sym_COLON_QMARK] = ACTIONS(2839),
    [anon_sym_COLON_COLON] = ACTIONS(2841),
    [anon_sym_AMP] = ACTIONS(2839),
    [anon_sym_LBRACK] = ACTIONS(2839),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2841),
    [anon_sym_LBRACE] = ACTIONS(2839),
    [anon_sym_LT_AT] = ACTIONS(2839),
    [anon_sym_LT_AT_AT] = ACTIONS(2839),
    [anon_sym_DOT] = ACTIONS(2839),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2841),
    [anon_sym_new] = ACTIONS(2839),
    [anon_sym_return_BANG] = ACTIONS(2841),
    [anon_sym_yield] = ACTIONS(2839),
    [anon_sym_yield_BANG] = ACTIONS(2841),
    [anon_sym_lazy] = ACTIONS(2839),
    [anon_sym_assert] = ACTIONS(2839),
    [anon_sym_upcast] = ACTIONS(2839),
    [anon_sym_downcast] = ACTIONS(2839),
    [anon_sym_COLON_GT] = ACTIONS(2841),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2841),
    [anon_sym_for] = ACTIONS(2839),
    [anon_sym_while] = ACTIONS(2839),
    [anon_sym_if] = ACTIONS(2839),
    [anon_sym_fun] = ACTIONS(2839),
    [anon_sym_DASH_GT] = ACTIONS(2839),
    [anon_sym_try] = ACTIONS(2839),
    [anon_sym_match] = ACTIONS(2839),
    [anon_sym_match_BANG] = ACTIONS(2841),
    [anon_sym_function] = ACTIONS(2839),
    [anon_sym_LT_DASH] = ACTIONS(2839),
    [anon_sym_DOT_LBRACK] = ACTIONS(2841),
    [anon_sym_LT] = ACTIONS(2841),
    [anon_sym_use] = ACTIONS(2839),
    [anon_sym_use_BANG] = ACTIONS(2841),
    [anon_sym_do_BANG] = ACTIONS(2841),
    [anon_sym_DOT_DOT] = ACTIONS(2841),
    [anon_sym_begin] = ACTIONS(2839),
    [anon_sym_LPAREN2] = ACTIONS(2839),
    [anon_sym_or] = ACTIONS(2839),
    [aux_sym_char_token1] = ACTIONS(2841),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2839),
    [anon_sym_DQUOTE] = ACTIONS(2839),
    [anon_sym_AT_DQUOTE] = ACTIONS(2841),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2841),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2841),
    [sym_bool] = ACTIONS(2839),
    [sym_unit] = ACTIONS(2841),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2839),
    [sym_op_identifier] = ACTIONS(2839),
    [anon_sym_PLUS] = ACTIONS(2839),
    [anon_sym_DASH] = ACTIONS(2839),
    [anon_sym_PLUS_DOT] = ACTIONS(2839),
    [anon_sym_DASH_DOT] = ACTIONS(2839),
    [anon_sym_PERCENT] = ACTIONS(2839),
    [anon_sym_AMP_AMP] = ACTIONS(2839),
    [anon_sym_TILDE] = ACTIONS(2841),
    [aux_sym_prefix_op_token1] = ACTIONS(2839),
    [aux_sym_infix_op_token1] = ACTIONS(2841),
    [aux_sym_infix_op_token2] = ACTIONS(2839),
    [anon_sym_PIPE_PIPE] = ACTIONS(2839),
    [anon_sym_BANG_EQ] = ACTIONS(2839),
    [anon_sym_COLON_EQ] = ACTIONS(2841),
    [anon_sym_DOLLAR] = ACTIONS(2839),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2839),
    [sym_int] = ACTIONS(2839),
    [sym_xint] = ACTIONS(2841),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2841),
    [sym__newline] = ACTIONS(2841),
  },
  [2008] = {
    [sym_block_comment] = STATE(2008),
    [sym_compiler_directive_decl] = STATE(2008),
    [sym_fsi_directive_decl] = STATE(2008),
    [sym_preproc_line] = STATE(2008),
    [sym_identifier] = ACTIONS(2851),
    [anon_sym_EQ] = ACTIONS(2853),
    [anon_sym_COLON] = ACTIONS(2851),
    [anon_sym_return] = ACTIONS(2851),
    [anon_sym_do] = ACTIONS(2851),
    [anon_sym_let] = ACTIONS(2851),
    [anon_sym_let_BANG] = ACTIONS(2853),
    [anon_sym_LPAREN] = ACTIONS(2851),
    [anon_sym_COMMA] = ACTIONS(2853),
    [anon_sym_null] = ACTIONS(2851),
    [anon_sym_QMARK] = ACTIONS(2851),
    [anon_sym_COLON_QMARK] = ACTIONS(2851),
    [anon_sym_COLON_COLON] = ACTIONS(2853),
    [anon_sym_AMP] = ACTIONS(2851),
    [anon_sym_LBRACK] = ACTIONS(2851),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2853),
    [anon_sym_LBRACE] = ACTIONS(2851),
    [anon_sym_LT_AT] = ACTIONS(2851),
    [anon_sym_LT_AT_AT] = ACTIONS(2851),
    [anon_sym_DOT] = ACTIONS(2851),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2853),
    [anon_sym_new] = ACTIONS(2851),
    [anon_sym_return_BANG] = ACTIONS(2853),
    [anon_sym_yield] = ACTIONS(2851),
    [anon_sym_yield_BANG] = ACTIONS(2853),
    [anon_sym_lazy] = ACTIONS(2851),
    [anon_sym_assert] = ACTIONS(2851),
    [anon_sym_upcast] = ACTIONS(2851),
    [anon_sym_downcast] = ACTIONS(2851),
    [anon_sym_COLON_GT] = ACTIONS(2853),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2853),
    [anon_sym_for] = ACTIONS(2851),
    [anon_sym_while] = ACTIONS(2851),
    [anon_sym_if] = ACTIONS(2851),
    [anon_sym_fun] = ACTIONS(2851),
    [anon_sym_DASH_GT] = ACTIONS(2851),
    [anon_sym_try] = ACTIONS(2851),
    [anon_sym_match] = ACTIONS(2851),
    [anon_sym_match_BANG] = ACTIONS(2853),
    [anon_sym_function] = ACTIONS(2851),
    [anon_sym_LT_DASH] = ACTIONS(2851),
    [anon_sym_DOT_LBRACK] = ACTIONS(2853),
    [anon_sym_LT] = ACTIONS(2853),
    [anon_sym_use] = ACTIONS(2851),
    [anon_sym_use_BANG] = ACTIONS(2853),
    [anon_sym_do_BANG] = ACTIONS(2853),
    [anon_sym_DOT_DOT] = ACTIONS(2853),
    [anon_sym_begin] = ACTIONS(2851),
    [anon_sym_LPAREN2] = ACTIONS(2851),
    [anon_sym_or] = ACTIONS(2851),
    [aux_sym_char_token1] = ACTIONS(2853),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2851),
    [anon_sym_DQUOTE] = ACTIONS(2851),
    [anon_sym_AT_DQUOTE] = ACTIONS(2853),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2853),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2853),
    [sym_bool] = ACTIONS(2851),
    [sym_unit] = ACTIONS(2853),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2851),
    [sym_op_identifier] = ACTIONS(2851),
    [anon_sym_PLUS] = ACTIONS(2851),
    [anon_sym_DASH] = ACTIONS(2851),
    [anon_sym_PLUS_DOT] = ACTIONS(2851),
    [anon_sym_DASH_DOT] = ACTIONS(2851),
    [anon_sym_PERCENT] = ACTIONS(2851),
    [anon_sym_AMP_AMP] = ACTIONS(2851),
    [anon_sym_TILDE] = ACTIONS(2853),
    [aux_sym_prefix_op_token1] = ACTIONS(2851),
    [aux_sym_infix_op_token1] = ACTIONS(2853),
    [aux_sym_infix_op_token2] = ACTIONS(2851),
    [anon_sym_PIPE_PIPE] = ACTIONS(2851),
    [anon_sym_BANG_EQ] = ACTIONS(2851),
    [anon_sym_COLON_EQ] = ACTIONS(2853),
    [anon_sym_DOLLAR] = ACTIONS(2851),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2851),
    [sym_int] = ACTIONS(2851),
    [sym_xint] = ACTIONS(2853),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2853),
    [sym__newline] = ACTIONS(2853),
  },
  [2009] = {
    [sym_block_comment] = STATE(2009),
    [sym_compiler_directive_decl] = STATE(2009),
    [sym_fsi_directive_decl] = STATE(2009),
    [sym_preproc_line] = STATE(2009),
    [aux_sym_long_identifier_repeat1] = STATE(2002),
    [sym_identifier] = ACTIONS(2418),
    [anon_sym_EQ] = ACTIONS(2420),
    [anon_sym_COLON] = ACTIONS(2418),
    [anon_sym_return] = ACTIONS(2418),
    [anon_sym_do] = ACTIONS(2418),
    [anon_sym_let] = ACTIONS(2418),
    [anon_sym_let_BANG] = ACTIONS(2420),
    [anon_sym_LPAREN] = ACTIONS(2418),
    [anon_sym_COMMA] = ACTIONS(2420),
    [anon_sym_null] = ACTIONS(2418),
    [anon_sym_QMARK] = ACTIONS(2418),
    [anon_sym_COLON_QMARK] = ACTIONS(2418),
    [anon_sym_COLON_COLON] = ACTIONS(2420),
    [anon_sym_AMP] = ACTIONS(2418),
    [anon_sym_LBRACK] = ACTIONS(2418),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2420),
    [anon_sym_LBRACE] = ACTIONS(2418),
    [anon_sym_LT_AT] = ACTIONS(2418),
    [anon_sym_AT_GT] = ACTIONS(2418),
    [anon_sym_LT_AT_AT] = ACTIONS(2418),
    [anon_sym_DOT] = ACTIONS(4185),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2420),
    [anon_sym_new] = ACTIONS(2418),
    [anon_sym_return_BANG] = ACTIONS(2420),
    [anon_sym_yield] = ACTIONS(2418),
    [anon_sym_yield_BANG] = ACTIONS(2420),
    [anon_sym_lazy] = ACTIONS(2418),
    [anon_sym_assert] = ACTIONS(2418),
    [anon_sym_upcast] = ACTIONS(2418),
    [anon_sym_downcast] = ACTIONS(2418),
    [anon_sym_COLON_GT] = ACTIONS(2420),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2420),
    [anon_sym_for] = ACTIONS(2418),
    [anon_sym_while] = ACTIONS(2418),
    [anon_sym_if] = ACTIONS(2418),
    [anon_sym_fun] = ACTIONS(2418),
    [anon_sym_try] = ACTIONS(2418),
    [anon_sym_match] = ACTIONS(2418),
    [anon_sym_match_BANG] = ACTIONS(2420),
    [anon_sym_function] = ACTIONS(2418),
    [anon_sym_LT_DASH] = ACTIONS(2418),
    [anon_sym_DOT_LBRACK] = ACTIONS(2420),
    [anon_sym_LT] = ACTIONS(2420),
    [anon_sym_use] = ACTIONS(2418),
    [anon_sym_use_BANG] = ACTIONS(2420),
    [anon_sym_do_BANG] = ACTIONS(2420),
    [anon_sym_begin] = ACTIONS(2418),
    [anon_sym_LPAREN2] = ACTIONS(2418),
    [anon_sym_or] = ACTIONS(2418),
    [aux_sym_char_token1] = ACTIONS(2420),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2418),
    [anon_sym_DQUOTE] = ACTIONS(2418),
    [anon_sym_AT_DQUOTE] = ACTIONS(2420),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2420),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2420),
    [sym_bool] = ACTIONS(2418),
    [sym_unit] = ACTIONS(2420),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2418),
    [sym_op_identifier] = ACTIONS(2418),
    [anon_sym_PLUS] = ACTIONS(2418),
    [anon_sym_DASH] = ACTIONS(2418),
    [anon_sym_PLUS_DOT] = ACTIONS(2418),
    [anon_sym_DASH_DOT] = ACTIONS(2418),
    [anon_sym_PERCENT] = ACTIONS(2418),
    [anon_sym_AMP_AMP] = ACTIONS(2418),
    [anon_sym_TILDE] = ACTIONS(2420),
    [aux_sym_prefix_op_token1] = ACTIONS(2418),
    [aux_sym_infix_op_token1] = ACTIONS(2420),
    [aux_sym_infix_op_token2] = ACTIONS(2418),
    [anon_sym_PIPE_PIPE] = ACTIONS(2418),
    [anon_sym_BANG_EQ] = ACTIONS(2418),
    [anon_sym_COLON_EQ] = ACTIONS(2420),
    [anon_sym_DOLLAR] = ACTIONS(2418),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2418),
    [sym_int] = ACTIONS(2418),
    [sym_xint] = ACTIONS(2420),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2420),
    [sym__newline] = ACTIONS(2420),
  },
  [2010] = {
    [sym_block_comment] = STATE(2010),
    [sym_compiler_directive_decl] = STATE(2010),
    [sym_fsi_directive_decl] = STATE(2010),
    [sym_preproc_line] = STATE(2010),
    [aux_sym_long_identifier_repeat1] = STATE(2009),
    [sym_identifier] = ACTIONS(2791),
    [anon_sym_EQ] = ACTIONS(2794),
    [anon_sym_COLON] = ACTIONS(2791),
    [anon_sym_return] = ACTIONS(2791),
    [anon_sym_do] = ACTIONS(2791),
    [anon_sym_let] = ACTIONS(2791),
    [anon_sym_let_BANG] = ACTIONS(2794),
    [anon_sym_LPAREN] = ACTIONS(2791),
    [anon_sym_COMMA] = ACTIONS(2794),
    [anon_sym_null] = ACTIONS(2791),
    [anon_sym_QMARK] = ACTIONS(2791),
    [anon_sym_COLON_QMARK] = ACTIONS(2791),
    [anon_sym_COLON_COLON] = ACTIONS(2794),
    [anon_sym_AMP] = ACTIONS(2791),
    [anon_sym_LBRACK] = ACTIONS(2791),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2794),
    [anon_sym_LBRACE] = ACTIONS(2791),
    [anon_sym_LT_AT] = ACTIONS(2791),
    [anon_sym_AT_GT] = ACTIONS(2791),
    [anon_sym_LT_AT_AT] = ACTIONS(2791),
    [anon_sym_DOT] = ACTIONS(4187),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2794),
    [anon_sym_new] = ACTIONS(2791),
    [anon_sym_return_BANG] = ACTIONS(2794),
    [anon_sym_yield] = ACTIONS(2791),
    [anon_sym_yield_BANG] = ACTIONS(2794),
    [anon_sym_lazy] = ACTIONS(2791),
    [anon_sym_assert] = ACTIONS(2791),
    [anon_sym_upcast] = ACTIONS(2791),
    [anon_sym_downcast] = ACTIONS(2791),
    [anon_sym_COLON_GT] = ACTIONS(2794),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2794),
    [anon_sym_for] = ACTIONS(2791),
    [anon_sym_while] = ACTIONS(2791),
    [anon_sym_if] = ACTIONS(2791),
    [anon_sym_fun] = ACTIONS(2791),
    [anon_sym_try] = ACTIONS(2791),
    [anon_sym_match] = ACTIONS(2791),
    [anon_sym_match_BANG] = ACTIONS(2794),
    [anon_sym_function] = ACTIONS(2791),
    [anon_sym_LT_DASH] = ACTIONS(2791),
    [anon_sym_DOT_LBRACK] = ACTIONS(2794),
    [anon_sym_LT] = ACTIONS(2794),
    [anon_sym_use] = ACTIONS(2791),
    [anon_sym_use_BANG] = ACTIONS(2794),
    [anon_sym_do_BANG] = ACTIONS(2794),
    [anon_sym_begin] = ACTIONS(2791),
    [anon_sym_LPAREN2] = ACTIONS(2791),
    [anon_sym_or] = ACTIONS(2791),
    [aux_sym_char_token1] = ACTIONS(2794),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2791),
    [anon_sym_DQUOTE] = ACTIONS(2791),
    [anon_sym_AT_DQUOTE] = ACTIONS(2794),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2794),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2794),
    [sym_bool] = ACTIONS(2791),
    [sym_unit] = ACTIONS(2794),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2791),
    [sym_op_identifier] = ACTIONS(2791),
    [anon_sym_PLUS] = ACTIONS(2791),
    [anon_sym_DASH] = ACTIONS(2791),
    [anon_sym_PLUS_DOT] = ACTIONS(2791),
    [anon_sym_DASH_DOT] = ACTIONS(2791),
    [anon_sym_PERCENT] = ACTIONS(2791),
    [anon_sym_AMP_AMP] = ACTIONS(2791),
    [anon_sym_TILDE] = ACTIONS(2794),
    [aux_sym_prefix_op_token1] = ACTIONS(2791),
    [aux_sym_infix_op_token1] = ACTIONS(2794),
    [aux_sym_infix_op_token2] = ACTIONS(2791),
    [anon_sym_PIPE_PIPE] = ACTIONS(2791),
    [anon_sym_BANG_EQ] = ACTIONS(2791),
    [anon_sym_COLON_EQ] = ACTIONS(2794),
    [anon_sym_DOLLAR] = ACTIONS(2791),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2791),
    [sym_int] = ACTIONS(2791),
    [sym_xint] = ACTIONS(2794),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2794),
    [sym__newline] = ACTIONS(2794),
  },
  [2011] = {
    [sym_block_comment] = STATE(2011),
    [sym_compiler_directive_decl] = STATE(2011),
    [sym_fsi_directive_decl] = STATE(2011),
    [sym_preproc_line] = STATE(2011),
    [sym_identifier] = ACTIONS(2685),
    [anon_sym_EQ] = ACTIONS(2687),
    [anon_sym_COLON] = ACTIONS(2685),
    [anon_sym_return] = ACTIONS(2685),
    [anon_sym_do] = ACTIONS(2685),
    [anon_sym_let] = ACTIONS(2685),
    [anon_sym_let_BANG] = ACTIONS(2687),
    [anon_sym_LPAREN] = ACTIONS(2685),
    [anon_sym_COMMA] = ACTIONS(2687),
    [anon_sym_null] = ACTIONS(2685),
    [anon_sym_QMARK] = ACTIONS(2685),
    [anon_sym_COLON_QMARK] = ACTIONS(2685),
    [anon_sym_COLON_COLON] = ACTIONS(2687),
    [anon_sym_PIPE] = ACTIONS(2685),
    [anon_sym_AMP] = ACTIONS(2685),
    [anon_sym_LBRACK] = ACTIONS(2685),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2687),
    [anon_sym_LBRACE] = ACTIONS(2685),
    [anon_sym_LT_AT] = ACTIONS(2685),
    [anon_sym_LT_AT_AT] = ACTIONS(2685),
    [anon_sym_DOT] = ACTIONS(2685),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2687),
    [anon_sym_new] = ACTIONS(2685),
    [anon_sym_return_BANG] = ACTIONS(2687),
    [anon_sym_yield] = ACTIONS(2685),
    [anon_sym_yield_BANG] = ACTIONS(2687),
    [anon_sym_lazy] = ACTIONS(2685),
    [anon_sym_assert] = ACTIONS(2685),
    [anon_sym_upcast] = ACTIONS(2685),
    [anon_sym_downcast] = ACTIONS(2685),
    [anon_sym_COLON_GT] = ACTIONS(2687),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2687),
    [anon_sym_for] = ACTIONS(2685),
    [anon_sym_while] = ACTIONS(2685),
    [anon_sym_if] = ACTIONS(2685),
    [anon_sym_fun] = ACTIONS(2685),
    [anon_sym_try] = ACTIONS(2685),
    [anon_sym_match] = ACTIONS(2685),
    [anon_sym_match_BANG] = ACTIONS(2687),
    [anon_sym_function] = ACTIONS(2685),
    [anon_sym_LT_DASH] = ACTIONS(2685),
    [anon_sym_DOT_LBRACK] = ACTIONS(2687),
    [anon_sym_LT] = ACTIONS(2687),
    [anon_sym_use] = ACTIONS(2685),
    [anon_sym_use_BANG] = ACTIONS(2687),
    [anon_sym_do_BANG] = ACTIONS(2687),
    [anon_sym_begin] = ACTIONS(2685),
    [anon_sym_LPAREN2] = ACTIONS(2685),
    [anon_sym_or] = ACTIONS(2685),
    [aux_sym_char_token1] = ACTIONS(2687),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2685),
    [anon_sym_DQUOTE] = ACTIONS(2685),
    [anon_sym_AT_DQUOTE] = ACTIONS(2687),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2687),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2687),
    [sym_bool] = ACTIONS(2685),
    [sym_unit] = ACTIONS(2687),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2685),
    [sym_op_identifier] = ACTIONS(2685),
    [anon_sym_PLUS] = ACTIONS(2685),
    [anon_sym_DASH] = ACTIONS(2685),
    [anon_sym_PLUS_DOT] = ACTIONS(2685),
    [anon_sym_DASH_DOT] = ACTIONS(2685),
    [anon_sym_PERCENT] = ACTIONS(2685),
    [anon_sym_AMP_AMP] = ACTIONS(2685),
    [anon_sym_TILDE] = ACTIONS(2687),
    [aux_sym_prefix_op_token1] = ACTIONS(2685),
    [aux_sym_infix_op_token1] = ACTIONS(2687),
    [aux_sym_infix_op_token2] = ACTIONS(2685),
    [anon_sym_PIPE_PIPE] = ACTIONS(2685),
    [anon_sym_BANG_EQ] = ACTIONS(2685),
    [anon_sym_COLON_EQ] = ACTIONS(2687),
    [anon_sym_DOLLAR] = ACTIONS(2685),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2685),
    [sym_int] = ACTIONS(2685),
    [sym_xint] = ACTIONS(2687),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2687),
    [anon_sym_POUNDendif] = ACTIONS(2687),
    [sym__newline] = ACTIONS(2687),
  },
  [2012] = {
    [sym_block_comment] = STATE(2012),
    [sym_compiler_directive_decl] = STATE(2012),
    [sym_fsi_directive_decl] = STATE(2012),
    [sym_preproc_line] = STATE(2012),
    [sym_identifier] = ACTIONS(2843),
    [anon_sym_EQ] = ACTIONS(2845),
    [anon_sym_COLON] = ACTIONS(2843),
    [anon_sym_return] = ACTIONS(2843),
    [anon_sym_do] = ACTIONS(2843),
    [anon_sym_and] = ACTIONS(2843),
    [anon_sym_let] = ACTIONS(2843),
    [anon_sym_let_BANG] = ACTIONS(2845),
    [anon_sym_LPAREN] = ACTIONS(2843),
    [anon_sym_COMMA] = ACTIONS(2845),
    [anon_sym_null] = ACTIONS(2843),
    [anon_sym_QMARK] = ACTIONS(2843),
    [anon_sym_COLON_QMARK] = ACTIONS(2843),
    [anon_sym_COLON_COLON] = ACTIONS(2845),
    [anon_sym_AMP] = ACTIONS(2843),
    [anon_sym_LBRACK] = ACTIONS(2843),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2845),
    [anon_sym_LBRACE] = ACTIONS(2843),
    [anon_sym_LT_AT] = ACTIONS(2843),
    [anon_sym_LT_AT_AT] = ACTIONS(2843),
    [anon_sym_DOT] = ACTIONS(2843),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2845),
    [anon_sym_new] = ACTIONS(2843),
    [anon_sym_return_BANG] = ACTIONS(2845),
    [anon_sym_yield] = ACTIONS(2843),
    [anon_sym_yield_BANG] = ACTIONS(2845),
    [anon_sym_lazy] = ACTIONS(2843),
    [anon_sym_assert] = ACTIONS(2843),
    [anon_sym_upcast] = ACTIONS(2843),
    [anon_sym_downcast] = ACTIONS(2843),
    [anon_sym_COLON_GT] = ACTIONS(2845),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2845),
    [anon_sym_for] = ACTIONS(2843),
    [anon_sym_while] = ACTIONS(2843),
    [anon_sym_if] = ACTIONS(2843),
    [anon_sym_fun] = ACTIONS(2843),
    [anon_sym_try] = ACTIONS(2843),
    [anon_sym_match] = ACTIONS(2843),
    [anon_sym_match_BANG] = ACTIONS(2845),
    [anon_sym_function] = ACTIONS(2843),
    [anon_sym_LT_DASH] = ACTIONS(2843),
    [anon_sym_DOT_LBRACK] = ACTIONS(2845),
    [anon_sym_LT] = ACTIONS(2845),
    [anon_sym_use] = ACTIONS(2843),
    [anon_sym_use_BANG] = ACTIONS(2845),
    [anon_sym_do_BANG] = ACTIONS(2845),
    [anon_sym_begin] = ACTIONS(2843),
    [anon_sym_LPAREN2] = ACTIONS(2843),
    [anon_sym_or] = ACTIONS(2843),
    [aux_sym_char_token1] = ACTIONS(2845),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2843),
    [anon_sym_DQUOTE] = ACTIONS(2843),
    [anon_sym_AT_DQUOTE] = ACTIONS(2845),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2845),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2845),
    [sym_bool] = ACTIONS(2843),
    [sym_unit] = ACTIONS(2845),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2843),
    [sym_op_identifier] = ACTIONS(2843),
    [anon_sym_PLUS] = ACTIONS(2843),
    [anon_sym_DASH] = ACTIONS(2843),
    [anon_sym_PLUS_DOT] = ACTIONS(2843),
    [anon_sym_DASH_DOT] = ACTIONS(2843),
    [anon_sym_PERCENT] = ACTIONS(2843),
    [anon_sym_AMP_AMP] = ACTIONS(2843),
    [anon_sym_TILDE] = ACTIONS(2845),
    [aux_sym_prefix_op_token1] = ACTIONS(2843),
    [aux_sym_infix_op_token1] = ACTIONS(2845),
    [aux_sym_infix_op_token2] = ACTIONS(2843),
    [anon_sym_PIPE_PIPE] = ACTIONS(2843),
    [anon_sym_BANG_EQ] = ACTIONS(2843),
    [anon_sym_COLON_EQ] = ACTIONS(2845),
    [anon_sym_DOLLAR] = ACTIONS(2843),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2843),
    [sym_int] = ACTIONS(2843),
    [sym_xint] = ACTIONS(2845),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2845),
    [sym__newline] = ACTIONS(2845),
    [sym__dedent] = ACTIONS(2845),
  },
  [2013] = {
    [sym_block_comment] = STATE(2013),
    [sym_compiler_directive_decl] = STATE(2013),
    [sym_fsi_directive_decl] = STATE(2013),
    [sym_preproc_line] = STATE(2013),
    [sym_identifier] = ACTIONS(3055),
    [anon_sym_EQ] = ACTIONS(3057),
    [anon_sym_COLON] = ACTIONS(3055),
    [anon_sym_return] = ACTIONS(3055),
    [anon_sym_do] = ACTIONS(3055),
    [anon_sym_let] = ACTIONS(3055),
    [anon_sym_let_BANG] = ACTIONS(3057),
    [anon_sym_LPAREN] = ACTIONS(3055),
    [anon_sym_COMMA] = ACTIONS(3057),
    [anon_sym_null] = ACTIONS(3055),
    [anon_sym_QMARK] = ACTIONS(3055),
    [anon_sym_COLON_QMARK] = ACTIONS(3055),
    [anon_sym_COLON_COLON] = ACTIONS(3057),
    [anon_sym_AMP] = ACTIONS(3055),
    [anon_sym_LBRACK] = ACTIONS(3055),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3057),
    [anon_sym_LBRACE] = ACTIONS(3055),
    [anon_sym_LT_AT] = ACTIONS(3055),
    [anon_sym_LT_AT_AT] = ACTIONS(3055),
    [anon_sym_DOT] = ACTIONS(3055),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3057),
    [anon_sym_new] = ACTIONS(3055),
    [anon_sym_return_BANG] = ACTIONS(3057),
    [anon_sym_yield] = ACTIONS(3055),
    [anon_sym_yield_BANG] = ACTIONS(3057),
    [anon_sym_lazy] = ACTIONS(3055),
    [anon_sym_assert] = ACTIONS(3055),
    [anon_sym_upcast] = ACTIONS(3055),
    [anon_sym_downcast] = ACTIONS(3055),
    [anon_sym_COLON_GT] = ACTIONS(3057),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3057),
    [anon_sym_for] = ACTIONS(3055),
    [anon_sym_while] = ACTIONS(3055),
    [anon_sym_if] = ACTIONS(3055),
    [anon_sym_fun] = ACTIONS(3055),
    [anon_sym_try] = ACTIONS(3055),
    [anon_sym_match] = ACTIONS(3055),
    [anon_sym_match_BANG] = ACTIONS(3057),
    [anon_sym_function] = ACTIONS(3055),
    [anon_sym_LT_DASH] = ACTIONS(3055),
    [anon_sym_DOT_LBRACK] = ACTIONS(3057),
    [anon_sym_LT] = ACTIONS(3057),
    [anon_sym_use] = ACTIONS(3055),
    [anon_sym_use_BANG] = ACTIONS(3057),
    [anon_sym_do_BANG] = ACTIONS(3057),
    [anon_sym_begin] = ACTIONS(3055),
    [anon_sym_LPAREN2] = ACTIONS(3055),
    [anon_sym_or] = ACTIONS(3055),
    [aux_sym_char_token1] = ACTIONS(3057),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3055),
    [anon_sym_DQUOTE] = ACTIONS(3055),
    [anon_sym_AT_DQUOTE] = ACTIONS(3057),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3057),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3057),
    [sym_bool] = ACTIONS(3055),
    [sym_unit] = ACTIONS(3057),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3055),
    [sym_op_identifier] = ACTIONS(3055),
    [anon_sym_PLUS] = ACTIONS(3055),
    [anon_sym_DASH] = ACTIONS(3055),
    [anon_sym_PLUS_DOT] = ACTIONS(3055),
    [anon_sym_DASH_DOT] = ACTIONS(3055),
    [anon_sym_PERCENT] = ACTIONS(3055),
    [anon_sym_AMP_AMP] = ACTIONS(3055),
    [anon_sym_TILDE] = ACTIONS(3057),
    [aux_sym_prefix_op_token1] = ACTIONS(3055),
    [aux_sym_infix_op_token1] = ACTIONS(3057),
    [aux_sym_infix_op_token2] = ACTIONS(3055),
    [anon_sym_PIPE_PIPE] = ACTIONS(3055),
    [anon_sym_BANG_EQ] = ACTIONS(3055),
    [anon_sym_COLON_EQ] = ACTIONS(3057),
    [anon_sym_DOLLAR] = ACTIONS(3055),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3055),
    [sym_int] = ACTIONS(3055),
    [sym_xint] = ACTIONS(3057),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3057),
    [anon_sym_POUNDendif] = ACTIONS(3057),
    [anon_sym_POUNDelse] = ACTIONS(3057),
    [sym__newline] = ACTIONS(3057),
  },
  [2014] = {
    [sym_block_comment] = STATE(2014),
    [sym_compiler_directive_decl] = STATE(2014),
    [sym_fsi_directive_decl] = STATE(2014),
    [sym_preproc_line] = STATE(2014),
    [sym_identifier] = ACTIONS(2158),
    [anon_sym_EQ] = ACTIONS(2160),
    [anon_sym_COLON] = ACTIONS(2158),
    [anon_sym_return] = ACTIONS(2158),
    [anon_sym_do] = ACTIONS(2158),
    [anon_sym_and] = ACTIONS(2158),
    [anon_sym_let] = ACTIONS(2158),
    [anon_sym_let_BANG] = ACTIONS(2160),
    [anon_sym_LPAREN] = ACTIONS(2158),
    [anon_sym_COMMA] = ACTIONS(2160),
    [anon_sym_null] = ACTIONS(2158),
    [anon_sym_QMARK] = ACTIONS(2158),
    [anon_sym_COLON_QMARK] = ACTIONS(2158),
    [anon_sym_COLON_COLON] = ACTIONS(2160),
    [anon_sym_AMP] = ACTIONS(2158),
    [anon_sym_LBRACK] = ACTIONS(2158),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2160),
    [anon_sym_LBRACE] = ACTIONS(2158),
    [anon_sym_LT_AT] = ACTIONS(2158),
    [anon_sym_LT_AT_AT] = ACTIONS(2158),
    [anon_sym_DOT] = ACTIONS(2158),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2160),
    [anon_sym_new] = ACTIONS(2158),
    [anon_sym_return_BANG] = ACTIONS(2160),
    [anon_sym_yield] = ACTIONS(2158),
    [anon_sym_yield_BANG] = ACTIONS(2160),
    [anon_sym_lazy] = ACTIONS(2158),
    [anon_sym_assert] = ACTIONS(2158),
    [anon_sym_upcast] = ACTIONS(2158),
    [anon_sym_downcast] = ACTIONS(2158),
    [anon_sym_COLON_GT] = ACTIONS(2160),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2160),
    [anon_sym_for] = ACTIONS(2158),
    [anon_sym_while] = ACTIONS(2158),
    [anon_sym_if] = ACTIONS(2158),
    [anon_sym_fun] = ACTIONS(2158),
    [anon_sym_try] = ACTIONS(2158),
    [anon_sym_match] = ACTIONS(2158),
    [anon_sym_match_BANG] = ACTIONS(2160),
    [anon_sym_function] = ACTIONS(2158),
    [anon_sym_LT_DASH] = ACTIONS(2158),
    [anon_sym_DOT_LBRACK] = ACTIONS(2160),
    [anon_sym_LT] = ACTIONS(2160),
    [anon_sym_use] = ACTIONS(2158),
    [anon_sym_use_BANG] = ACTIONS(2160),
    [anon_sym_do_BANG] = ACTIONS(2160),
    [anon_sym_begin] = ACTIONS(2158),
    [anon_sym_LPAREN2] = ACTIONS(2158),
    [anon_sym_or] = ACTIONS(2158),
    [aux_sym_char_token1] = ACTIONS(2160),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2158),
    [anon_sym_DQUOTE] = ACTIONS(2158),
    [anon_sym_AT_DQUOTE] = ACTIONS(2160),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2160),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2160),
    [sym_bool] = ACTIONS(2158),
    [sym_unit] = ACTIONS(2160),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2158),
    [sym_op_identifier] = ACTIONS(2158),
    [anon_sym_PLUS] = ACTIONS(2158),
    [anon_sym_DASH] = ACTIONS(2158),
    [anon_sym_PLUS_DOT] = ACTIONS(2158),
    [anon_sym_DASH_DOT] = ACTIONS(2158),
    [anon_sym_PERCENT] = ACTIONS(2158),
    [anon_sym_AMP_AMP] = ACTIONS(2158),
    [anon_sym_TILDE] = ACTIONS(2160),
    [aux_sym_prefix_op_token1] = ACTIONS(2158),
    [aux_sym_infix_op_token1] = ACTIONS(2160),
    [aux_sym_infix_op_token2] = ACTIONS(2158),
    [anon_sym_PIPE_PIPE] = ACTIONS(2158),
    [anon_sym_BANG_EQ] = ACTIONS(2158),
    [anon_sym_COLON_EQ] = ACTIONS(2160),
    [anon_sym_DOLLAR] = ACTIONS(2158),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2158),
    [sym_int] = ACTIONS(2158),
    [sym_xint] = ACTIONS(2160),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2160),
    [sym__newline] = ACTIONS(2160),
    [sym__dedent] = ACTIONS(2160),
  },
  [2015] = {
    [sym_block_comment] = STATE(2015),
    [sym_compiler_directive_decl] = STATE(2015),
    [sym_fsi_directive_decl] = STATE(2015),
    [sym_preproc_line] = STATE(2015),
    [sym_identifier] = ACTIONS(2831),
    [anon_sym_EQ] = ACTIONS(2833),
    [anon_sym_COLON] = ACTIONS(2831),
    [anon_sym_return] = ACTIONS(2831),
    [anon_sym_do] = ACTIONS(2831),
    [anon_sym_let] = ACTIONS(2831),
    [anon_sym_let_BANG] = ACTIONS(2833),
    [anon_sym_LPAREN] = ACTIONS(2831),
    [anon_sym_COMMA] = ACTIONS(2833),
    [anon_sym_null] = ACTIONS(2831),
    [anon_sym_QMARK] = ACTIONS(2831),
    [anon_sym_COLON_QMARK] = ACTIONS(2831),
    [anon_sym_COLON_COLON] = ACTIONS(2833),
    [anon_sym_AMP] = ACTIONS(2831),
    [anon_sym_LBRACK] = ACTIONS(2831),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2833),
    [anon_sym_LBRACE] = ACTIONS(2831),
    [anon_sym_LT_AT] = ACTIONS(2831),
    [anon_sym_LT_AT_AT] = ACTIONS(2831),
    [anon_sym_DOT] = ACTIONS(2831),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2833),
    [anon_sym_new] = ACTIONS(2831),
    [anon_sym_return_BANG] = ACTIONS(2833),
    [anon_sym_yield] = ACTIONS(2831),
    [anon_sym_yield_BANG] = ACTIONS(2833),
    [anon_sym_lazy] = ACTIONS(2831),
    [anon_sym_assert] = ACTIONS(2831),
    [anon_sym_upcast] = ACTIONS(2831),
    [anon_sym_downcast] = ACTIONS(2831),
    [anon_sym_COLON_GT] = ACTIONS(2833),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2833),
    [anon_sym_for] = ACTIONS(2831),
    [anon_sym_while] = ACTIONS(2831),
    [anon_sym_if] = ACTIONS(2831),
    [anon_sym_fun] = ACTIONS(2831),
    [anon_sym_try] = ACTIONS(2831),
    [anon_sym_match] = ACTIONS(2831),
    [anon_sym_match_BANG] = ACTIONS(2833),
    [anon_sym_function] = ACTIONS(2831),
    [anon_sym_LT_DASH] = ACTIONS(2831),
    [anon_sym_DOT_LBRACK] = ACTIONS(2833),
    [anon_sym_LT] = ACTIONS(2833),
    [anon_sym_use] = ACTIONS(2831),
    [anon_sym_use_BANG] = ACTIONS(2833),
    [anon_sym_do_BANG] = ACTIONS(2833),
    [anon_sym_begin] = ACTIONS(2831),
    [anon_sym_LPAREN2] = ACTIONS(2831),
    [anon_sym_or] = ACTIONS(2831),
    [aux_sym_char_token1] = ACTIONS(2833),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2831),
    [anon_sym_DQUOTE] = ACTIONS(2831),
    [anon_sym_AT_DQUOTE] = ACTIONS(2833),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2833),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2833),
    [sym_bool] = ACTIONS(2831),
    [sym_unit] = ACTIONS(2833),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2831),
    [sym_op_identifier] = ACTIONS(2831),
    [anon_sym_PLUS] = ACTIONS(2831),
    [anon_sym_DASH] = ACTIONS(2831),
    [anon_sym_PLUS_DOT] = ACTIONS(2831),
    [anon_sym_DASH_DOT] = ACTIONS(2831),
    [anon_sym_PERCENT] = ACTIONS(2831),
    [anon_sym_AMP_AMP] = ACTIONS(2831),
    [anon_sym_TILDE] = ACTIONS(2833),
    [aux_sym_prefix_op_token1] = ACTIONS(2831),
    [aux_sym_infix_op_token1] = ACTIONS(2833),
    [aux_sym_infix_op_token2] = ACTIONS(2831),
    [anon_sym_PIPE_PIPE] = ACTIONS(2831),
    [anon_sym_BANG_EQ] = ACTIONS(2831),
    [anon_sym_COLON_EQ] = ACTIONS(2833),
    [anon_sym_DOLLAR] = ACTIONS(2831),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2831),
    [sym_int] = ACTIONS(2831),
    [sym_xint] = ACTIONS(2833),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2833),
    [anon_sym_POUNDendif] = ACTIONS(2833),
    [anon_sym_POUNDelse] = ACTIONS(2833),
    [sym__newline] = ACTIONS(2833),
  },
  [2016] = {
    [sym_block_comment] = STATE(2016),
    [sym_compiler_directive_decl] = STATE(2016),
    [sym_fsi_directive_decl] = STATE(2016),
    [sym_preproc_line] = STATE(2016),
    [sym_identifier] = ACTIONS(3067),
    [anon_sym_EQ] = ACTIONS(3069),
    [anon_sym_COLON] = ACTIONS(3067),
    [anon_sym_return] = ACTIONS(3067),
    [anon_sym_do] = ACTIONS(3067),
    [anon_sym_let] = ACTIONS(3067),
    [anon_sym_let_BANG] = ACTIONS(3069),
    [anon_sym_LPAREN] = ACTIONS(3067),
    [anon_sym_COMMA] = ACTIONS(3069),
    [anon_sym_null] = ACTIONS(3067),
    [anon_sym_QMARK] = ACTIONS(3067),
    [anon_sym_COLON_QMARK] = ACTIONS(3067),
    [anon_sym_COLON_COLON] = ACTIONS(3069),
    [anon_sym_AMP] = ACTIONS(3067),
    [anon_sym_LBRACK] = ACTIONS(3067),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3069),
    [anon_sym_LBRACE] = ACTIONS(3067),
    [anon_sym_LT_AT] = ACTIONS(3067),
    [anon_sym_LT_AT_AT] = ACTIONS(3067),
    [anon_sym_DOT] = ACTIONS(3067),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3069),
    [anon_sym_new] = ACTIONS(3067),
    [anon_sym_return_BANG] = ACTIONS(3069),
    [anon_sym_yield] = ACTIONS(3067),
    [anon_sym_yield_BANG] = ACTIONS(3069),
    [anon_sym_lazy] = ACTIONS(3067),
    [anon_sym_assert] = ACTIONS(3067),
    [anon_sym_upcast] = ACTIONS(3067),
    [anon_sym_downcast] = ACTIONS(3067),
    [anon_sym_COLON_GT] = ACTIONS(3069),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3069),
    [anon_sym_for] = ACTIONS(3067),
    [anon_sym_while] = ACTIONS(3067),
    [anon_sym_if] = ACTIONS(3067),
    [anon_sym_fun] = ACTIONS(3067),
    [anon_sym_try] = ACTIONS(3067),
    [anon_sym_match] = ACTIONS(3067),
    [anon_sym_match_BANG] = ACTIONS(3069),
    [anon_sym_function] = ACTIONS(3067),
    [anon_sym_LT_DASH] = ACTIONS(3067),
    [anon_sym_DOT_LBRACK] = ACTIONS(3069),
    [anon_sym_LT] = ACTIONS(3069),
    [anon_sym_use] = ACTIONS(3067),
    [anon_sym_use_BANG] = ACTIONS(3069),
    [anon_sym_do_BANG] = ACTIONS(3069),
    [anon_sym_begin] = ACTIONS(3067),
    [anon_sym_LPAREN2] = ACTIONS(3067),
    [anon_sym_or] = ACTIONS(3067),
    [aux_sym_char_token1] = ACTIONS(3069),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3067),
    [anon_sym_DQUOTE] = ACTIONS(3067),
    [anon_sym_AT_DQUOTE] = ACTIONS(3069),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3069),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3069),
    [sym_bool] = ACTIONS(3067),
    [sym_unit] = ACTIONS(3069),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3067),
    [sym_op_identifier] = ACTIONS(3067),
    [anon_sym_PLUS] = ACTIONS(3067),
    [anon_sym_DASH] = ACTIONS(3067),
    [anon_sym_PLUS_DOT] = ACTIONS(3067),
    [anon_sym_DASH_DOT] = ACTIONS(3067),
    [anon_sym_PERCENT] = ACTIONS(3067),
    [anon_sym_AMP_AMP] = ACTIONS(3067),
    [anon_sym_TILDE] = ACTIONS(3069),
    [aux_sym_prefix_op_token1] = ACTIONS(3067),
    [aux_sym_infix_op_token1] = ACTIONS(3069),
    [aux_sym_infix_op_token2] = ACTIONS(3067),
    [anon_sym_PIPE_PIPE] = ACTIONS(3067),
    [anon_sym_BANG_EQ] = ACTIONS(3067),
    [anon_sym_COLON_EQ] = ACTIONS(3069),
    [anon_sym_DOLLAR] = ACTIONS(3067),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3067),
    [sym_int] = ACTIONS(3067),
    [sym_xint] = ACTIONS(3069),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3069),
    [anon_sym_POUNDendif] = ACTIONS(3069),
    [anon_sym_POUNDelse] = ACTIONS(3069),
    [sym__newline] = ACTIONS(3069),
  },
  [2017] = {
    [sym_block_comment] = STATE(2017),
    [sym_compiler_directive_decl] = STATE(2017),
    [sym_fsi_directive_decl] = STATE(2017),
    [sym_preproc_line] = STATE(2017),
    [sym_identifier] = ACTIONS(3071),
    [anon_sym_EQ] = ACTIONS(3073),
    [anon_sym_COLON] = ACTIONS(3071),
    [anon_sym_return] = ACTIONS(3071),
    [anon_sym_do] = ACTIONS(3071),
    [anon_sym_let] = ACTIONS(3071),
    [anon_sym_let_BANG] = ACTIONS(3073),
    [anon_sym_LPAREN] = ACTIONS(3071),
    [anon_sym_COMMA] = ACTIONS(3073),
    [anon_sym_null] = ACTIONS(3071),
    [anon_sym_QMARK] = ACTIONS(3071),
    [anon_sym_COLON_QMARK] = ACTIONS(3071),
    [anon_sym_COLON_COLON] = ACTIONS(3073),
    [anon_sym_AMP] = ACTIONS(3071),
    [anon_sym_LBRACK] = ACTIONS(3071),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3073),
    [anon_sym_LBRACE] = ACTIONS(3071),
    [anon_sym_LT_AT] = ACTIONS(3071),
    [anon_sym_LT_AT_AT] = ACTIONS(3071),
    [anon_sym_DOT] = ACTIONS(3071),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3073),
    [anon_sym_new] = ACTIONS(3071),
    [anon_sym_return_BANG] = ACTIONS(3073),
    [anon_sym_yield] = ACTIONS(3071),
    [anon_sym_yield_BANG] = ACTIONS(3073),
    [anon_sym_lazy] = ACTIONS(3071),
    [anon_sym_assert] = ACTIONS(3071),
    [anon_sym_upcast] = ACTIONS(3071),
    [anon_sym_downcast] = ACTIONS(3071),
    [anon_sym_COLON_GT] = ACTIONS(3073),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3073),
    [anon_sym_for] = ACTIONS(3071),
    [anon_sym_while] = ACTIONS(3071),
    [anon_sym_if] = ACTIONS(3071),
    [anon_sym_fun] = ACTIONS(3071),
    [anon_sym_try] = ACTIONS(3071),
    [anon_sym_match] = ACTIONS(3071),
    [anon_sym_match_BANG] = ACTIONS(3073),
    [anon_sym_function] = ACTIONS(3071),
    [anon_sym_LT_DASH] = ACTIONS(3071),
    [anon_sym_DOT_LBRACK] = ACTIONS(3073),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_use] = ACTIONS(3071),
    [anon_sym_use_BANG] = ACTIONS(3073),
    [anon_sym_do_BANG] = ACTIONS(3073),
    [anon_sym_begin] = ACTIONS(3071),
    [anon_sym_LPAREN2] = ACTIONS(3071),
    [anon_sym_or] = ACTIONS(3071),
    [aux_sym_char_token1] = ACTIONS(3073),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3071),
    [anon_sym_DQUOTE] = ACTIONS(3071),
    [anon_sym_AT_DQUOTE] = ACTIONS(3073),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3073),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3073),
    [sym_bool] = ACTIONS(3071),
    [sym_unit] = ACTIONS(3073),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3071),
    [sym_op_identifier] = ACTIONS(3071),
    [anon_sym_PLUS] = ACTIONS(3071),
    [anon_sym_DASH] = ACTIONS(3071),
    [anon_sym_PLUS_DOT] = ACTIONS(3071),
    [anon_sym_DASH_DOT] = ACTIONS(3071),
    [anon_sym_PERCENT] = ACTIONS(3071),
    [anon_sym_AMP_AMP] = ACTIONS(3071),
    [anon_sym_TILDE] = ACTIONS(3073),
    [aux_sym_prefix_op_token1] = ACTIONS(3071),
    [aux_sym_infix_op_token1] = ACTIONS(3073),
    [aux_sym_infix_op_token2] = ACTIONS(3071),
    [anon_sym_PIPE_PIPE] = ACTIONS(3071),
    [anon_sym_BANG_EQ] = ACTIONS(3071),
    [anon_sym_COLON_EQ] = ACTIONS(3073),
    [anon_sym_DOLLAR] = ACTIONS(3071),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3071),
    [sym_int] = ACTIONS(3071),
    [sym_xint] = ACTIONS(3073),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3073),
    [anon_sym_POUNDendif] = ACTIONS(3073),
    [anon_sym_POUNDelse] = ACTIONS(3073),
    [sym__newline] = ACTIONS(3073),
  },
  [2018] = {
    [sym_block_comment] = STATE(2018),
    [sym_compiler_directive_decl] = STATE(2018),
    [sym_fsi_directive_decl] = STATE(2018),
    [sym_preproc_line] = STATE(2018),
    [sym_identifier] = ACTIONS(3075),
    [anon_sym_EQ] = ACTIONS(3077),
    [anon_sym_COLON] = ACTIONS(3075),
    [anon_sym_return] = ACTIONS(3075),
    [anon_sym_do] = ACTIONS(3075),
    [anon_sym_let] = ACTIONS(3075),
    [anon_sym_let_BANG] = ACTIONS(3077),
    [anon_sym_LPAREN] = ACTIONS(3075),
    [anon_sym_COMMA] = ACTIONS(3077),
    [anon_sym_null] = ACTIONS(3075),
    [anon_sym_QMARK] = ACTIONS(3075),
    [anon_sym_COLON_QMARK] = ACTIONS(3075),
    [anon_sym_COLON_COLON] = ACTIONS(3077),
    [anon_sym_AMP] = ACTIONS(3075),
    [anon_sym_LBRACK] = ACTIONS(3075),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3077),
    [anon_sym_LBRACE] = ACTIONS(3075),
    [anon_sym_LT_AT] = ACTIONS(3075),
    [anon_sym_LT_AT_AT] = ACTIONS(3075),
    [anon_sym_DOT] = ACTIONS(3075),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3077),
    [anon_sym_new] = ACTIONS(3075),
    [anon_sym_return_BANG] = ACTIONS(3077),
    [anon_sym_yield] = ACTIONS(3075),
    [anon_sym_yield_BANG] = ACTIONS(3077),
    [anon_sym_lazy] = ACTIONS(3075),
    [anon_sym_assert] = ACTIONS(3075),
    [anon_sym_upcast] = ACTIONS(3075),
    [anon_sym_downcast] = ACTIONS(3075),
    [anon_sym_COLON_GT] = ACTIONS(3077),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3077),
    [anon_sym_for] = ACTIONS(3075),
    [anon_sym_while] = ACTIONS(3075),
    [anon_sym_if] = ACTIONS(3075),
    [anon_sym_fun] = ACTIONS(3075),
    [anon_sym_try] = ACTIONS(3075),
    [anon_sym_match] = ACTIONS(3075),
    [anon_sym_match_BANG] = ACTIONS(3077),
    [anon_sym_function] = ACTIONS(3075),
    [anon_sym_LT_DASH] = ACTIONS(3075),
    [anon_sym_DOT_LBRACK] = ACTIONS(3077),
    [anon_sym_LT] = ACTIONS(3077),
    [anon_sym_use] = ACTIONS(3075),
    [anon_sym_use_BANG] = ACTIONS(3077),
    [anon_sym_do_BANG] = ACTIONS(3077),
    [anon_sym_begin] = ACTIONS(3075),
    [anon_sym_LPAREN2] = ACTIONS(3075),
    [anon_sym_or] = ACTIONS(3075),
    [aux_sym_char_token1] = ACTIONS(3077),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3075),
    [anon_sym_DQUOTE] = ACTIONS(3075),
    [anon_sym_AT_DQUOTE] = ACTIONS(3077),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3077),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3077),
    [sym_bool] = ACTIONS(3075),
    [sym_unit] = ACTIONS(3077),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3075),
    [sym_op_identifier] = ACTIONS(3075),
    [anon_sym_PLUS] = ACTIONS(3075),
    [anon_sym_DASH] = ACTIONS(3075),
    [anon_sym_PLUS_DOT] = ACTIONS(3075),
    [anon_sym_DASH_DOT] = ACTIONS(3075),
    [anon_sym_PERCENT] = ACTIONS(3075),
    [anon_sym_AMP_AMP] = ACTIONS(3075),
    [anon_sym_TILDE] = ACTIONS(3077),
    [aux_sym_prefix_op_token1] = ACTIONS(3075),
    [aux_sym_infix_op_token1] = ACTIONS(3077),
    [aux_sym_infix_op_token2] = ACTIONS(3075),
    [anon_sym_PIPE_PIPE] = ACTIONS(3075),
    [anon_sym_BANG_EQ] = ACTIONS(3075),
    [anon_sym_COLON_EQ] = ACTIONS(3077),
    [anon_sym_DOLLAR] = ACTIONS(3075),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3075),
    [sym_int] = ACTIONS(3075),
    [sym_xint] = ACTIONS(3077),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3077),
    [anon_sym_POUNDendif] = ACTIONS(3077),
    [anon_sym_POUNDelse] = ACTIONS(3077),
    [sym__newline] = ACTIONS(3077),
  },
  [2019] = {
    [sym_block_comment] = STATE(2019),
    [sym_compiler_directive_decl] = STATE(2019),
    [sym_fsi_directive_decl] = STATE(2019),
    [sym_preproc_line] = STATE(2019),
    [sym_identifier] = ACTIONS(2855),
    [anon_sym_EQ] = ACTIONS(2857),
    [anon_sym_COLON] = ACTIONS(2855),
    [anon_sym_return] = ACTIONS(2855),
    [anon_sym_do] = ACTIONS(2855),
    [anon_sym_and] = ACTIONS(2855),
    [anon_sym_let] = ACTIONS(2855),
    [anon_sym_let_BANG] = ACTIONS(2857),
    [anon_sym_LPAREN] = ACTIONS(2855),
    [anon_sym_COMMA] = ACTIONS(2857),
    [anon_sym_null] = ACTIONS(2855),
    [anon_sym_QMARK] = ACTIONS(2855),
    [anon_sym_COLON_QMARK] = ACTIONS(2855),
    [anon_sym_COLON_COLON] = ACTIONS(2857),
    [anon_sym_AMP] = ACTIONS(2855),
    [anon_sym_LBRACK] = ACTIONS(2855),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2857),
    [anon_sym_LBRACE] = ACTIONS(2855),
    [anon_sym_LT_AT] = ACTIONS(2855),
    [anon_sym_LT_AT_AT] = ACTIONS(2855),
    [anon_sym_DOT] = ACTIONS(2855),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2857),
    [anon_sym_new] = ACTIONS(2855),
    [anon_sym_return_BANG] = ACTIONS(2857),
    [anon_sym_yield] = ACTIONS(2855),
    [anon_sym_yield_BANG] = ACTIONS(2857),
    [anon_sym_lazy] = ACTIONS(2855),
    [anon_sym_assert] = ACTIONS(2855),
    [anon_sym_upcast] = ACTIONS(2855),
    [anon_sym_downcast] = ACTIONS(2855),
    [anon_sym_COLON_GT] = ACTIONS(2857),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2857),
    [anon_sym_for] = ACTIONS(2855),
    [anon_sym_while] = ACTIONS(2855),
    [anon_sym_if] = ACTIONS(2855),
    [anon_sym_fun] = ACTIONS(2855),
    [anon_sym_try] = ACTIONS(2855),
    [anon_sym_match] = ACTIONS(2855),
    [anon_sym_match_BANG] = ACTIONS(2857),
    [anon_sym_function] = ACTIONS(2855),
    [anon_sym_LT_DASH] = ACTIONS(2855),
    [anon_sym_DOT_LBRACK] = ACTIONS(2857),
    [anon_sym_LT] = ACTIONS(2857),
    [anon_sym_use] = ACTIONS(2855),
    [anon_sym_use_BANG] = ACTIONS(2857),
    [anon_sym_do_BANG] = ACTIONS(2857),
    [anon_sym_begin] = ACTIONS(2855),
    [anon_sym_LPAREN2] = ACTIONS(2855),
    [anon_sym_or] = ACTIONS(2855),
    [aux_sym_char_token1] = ACTIONS(2857),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2855),
    [anon_sym_DQUOTE] = ACTIONS(2855),
    [anon_sym_AT_DQUOTE] = ACTIONS(2857),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2857),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2857),
    [sym_bool] = ACTIONS(2855),
    [sym_unit] = ACTIONS(2857),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2855),
    [sym_op_identifier] = ACTIONS(2855),
    [anon_sym_PLUS] = ACTIONS(2855),
    [anon_sym_DASH] = ACTIONS(2855),
    [anon_sym_PLUS_DOT] = ACTIONS(2855),
    [anon_sym_DASH_DOT] = ACTIONS(2855),
    [anon_sym_PERCENT] = ACTIONS(2855),
    [anon_sym_AMP_AMP] = ACTIONS(2855),
    [anon_sym_TILDE] = ACTIONS(2857),
    [aux_sym_prefix_op_token1] = ACTIONS(2855),
    [aux_sym_infix_op_token1] = ACTIONS(2857),
    [aux_sym_infix_op_token2] = ACTIONS(2855),
    [anon_sym_PIPE_PIPE] = ACTIONS(2855),
    [anon_sym_BANG_EQ] = ACTIONS(2855),
    [anon_sym_COLON_EQ] = ACTIONS(2857),
    [anon_sym_DOLLAR] = ACTIONS(2855),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2855),
    [sym_int] = ACTIONS(2855),
    [sym_xint] = ACTIONS(2857),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2857),
    [sym__newline] = ACTIONS(2857),
    [sym__dedent] = ACTIONS(2857),
  },
  [2020] = {
    [sym_block_comment] = STATE(2020),
    [sym_compiler_directive_decl] = STATE(2020),
    [sym_fsi_directive_decl] = STATE(2020),
    [sym_preproc_line] = STATE(2020),
    [sym_identifier] = ACTIONS(2859),
    [anon_sym_EQ] = ACTIONS(2861),
    [anon_sym_COLON] = ACTIONS(2859),
    [anon_sym_return] = ACTIONS(2859),
    [anon_sym_do] = ACTIONS(2859),
    [anon_sym_and] = ACTIONS(2859),
    [anon_sym_let] = ACTIONS(2859),
    [anon_sym_let_BANG] = ACTIONS(2861),
    [anon_sym_LPAREN] = ACTIONS(2859),
    [anon_sym_COMMA] = ACTIONS(2861),
    [anon_sym_null] = ACTIONS(2859),
    [anon_sym_QMARK] = ACTIONS(2859),
    [anon_sym_COLON_QMARK] = ACTIONS(2859),
    [anon_sym_COLON_COLON] = ACTIONS(2861),
    [anon_sym_AMP] = ACTIONS(2859),
    [anon_sym_LBRACK] = ACTIONS(2859),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2861),
    [anon_sym_LBRACE] = ACTIONS(2859),
    [anon_sym_LT_AT] = ACTIONS(2859),
    [anon_sym_LT_AT_AT] = ACTIONS(2859),
    [anon_sym_DOT] = ACTIONS(2859),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2861),
    [anon_sym_new] = ACTIONS(2859),
    [anon_sym_return_BANG] = ACTIONS(2861),
    [anon_sym_yield] = ACTIONS(2859),
    [anon_sym_yield_BANG] = ACTIONS(2861),
    [anon_sym_lazy] = ACTIONS(2859),
    [anon_sym_assert] = ACTIONS(2859),
    [anon_sym_upcast] = ACTIONS(2859),
    [anon_sym_downcast] = ACTIONS(2859),
    [anon_sym_COLON_GT] = ACTIONS(2861),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2861),
    [anon_sym_for] = ACTIONS(2859),
    [anon_sym_while] = ACTIONS(2859),
    [anon_sym_if] = ACTIONS(2859),
    [anon_sym_fun] = ACTIONS(2859),
    [anon_sym_try] = ACTIONS(2859),
    [anon_sym_match] = ACTIONS(2859),
    [anon_sym_match_BANG] = ACTIONS(2861),
    [anon_sym_function] = ACTIONS(2859),
    [anon_sym_LT_DASH] = ACTIONS(2859),
    [anon_sym_DOT_LBRACK] = ACTIONS(2861),
    [anon_sym_LT] = ACTIONS(2861),
    [anon_sym_use] = ACTIONS(2859),
    [anon_sym_use_BANG] = ACTIONS(2861),
    [anon_sym_do_BANG] = ACTIONS(2861),
    [anon_sym_begin] = ACTIONS(2859),
    [anon_sym_LPAREN2] = ACTIONS(2859),
    [anon_sym_or] = ACTIONS(2859),
    [aux_sym_char_token1] = ACTIONS(2861),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2859),
    [anon_sym_DQUOTE] = ACTIONS(2859),
    [anon_sym_AT_DQUOTE] = ACTIONS(2861),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2861),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2861),
    [sym_bool] = ACTIONS(2859),
    [sym_unit] = ACTIONS(2861),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2859),
    [sym_op_identifier] = ACTIONS(2859),
    [anon_sym_PLUS] = ACTIONS(2859),
    [anon_sym_DASH] = ACTIONS(2859),
    [anon_sym_PLUS_DOT] = ACTIONS(2859),
    [anon_sym_DASH_DOT] = ACTIONS(2859),
    [anon_sym_PERCENT] = ACTIONS(2859),
    [anon_sym_AMP_AMP] = ACTIONS(2859),
    [anon_sym_TILDE] = ACTIONS(2861),
    [aux_sym_prefix_op_token1] = ACTIONS(2859),
    [aux_sym_infix_op_token1] = ACTIONS(2861),
    [aux_sym_infix_op_token2] = ACTIONS(2859),
    [anon_sym_PIPE_PIPE] = ACTIONS(2859),
    [anon_sym_BANG_EQ] = ACTIONS(2859),
    [anon_sym_COLON_EQ] = ACTIONS(2861),
    [anon_sym_DOLLAR] = ACTIONS(2859),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2859),
    [sym_int] = ACTIONS(2859),
    [sym_xint] = ACTIONS(2861),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2861),
    [sym__newline] = ACTIONS(2861),
    [sym__dedent] = ACTIONS(2861),
  },
  [2021] = {
    [sym_block_comment] = STATE(2021),
    [sym_compiler_directive_decl] = STATE(2021),
    [sym_fsi_directive_decl] = STATE(2021),
    [sym_preproc_line] = STATE(2021),
    [sym_identifier] = ACTIONS(3087),
    [anon_sym_EQ] = ACTIONS(3089),
    [anon_sym_COLON] = ACTIONS(3087),
    [anon_sym_return] = ACTIONS(3087),
    [anon_sym_do] = ACTIONS(3087),
    [anon_sym_let] = ACTIONS(3087),
    [anon_sym_let_BANG] = ACTIONS(3089),
    [anon_sym_LPAREN] = ACTIONS(3087),
    [anon_sym_COMMA] = ACTIONS(3089),
    [anon_sym_null] = ACTIONS(3087),
    [anon_sym_QMARK] = ACTIONS(3087),
    [anon_sym_COLON_QMARK] = ACTIONS(3087),
    [anon_sym_COLON_COLON] = ACTIONS(3089),
    [anon_sym_AMP] = ACTIONS(3087),
    [anon_sym_LBRACK] = ACTIONS(3087),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3089),
    [anon_sym_LBRACE] = ACTIONS(3087),
    [anon_sym_LT_AT] = ACTIONS(3087),
    [anon_sym_LT_AT_AT] = ACTIONS(3087),
    [anon_sym_DOT] = ACTIONS(3087),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3089),
    [anon_sym_new] = ACTIONS(3087),
    [anon_sym_return_BANG] = ACTIONS(3089),
    [anon_sym_yield] = ACTIONS(3087),
    [anon_sym_yield_BANG] = ACTIONS(3089),
    [anon_sym_lazy] = ACTIONS(3087),
    [anon_sym_assert] = ACTIONS(3087),
    [anon_sym_upcast] = ACTIONS(3087),
    [anon_sym_downcast] = ACTIONS(3087),
    [anon_sym_COLON_GT] = ACTIONS(3089),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3089),
    [anon_sym_for] = ACTIONS(3087),
    [anon_sym_while] = ACTIONS(3087),
    [anon_sym_if] = ACTIONS(3087),
    [anon_sym_fun] = ACTIONS(3087),
    [anon_sym_try] = ACTIONS(3087),
    [anon_sym_match] = ACTIONS(3087),
    [anon_sym_match_BANG] = ACTIONS(3089),
    [anon_sym_function] = ACTIONS(3087),
    [anon_sym_LT_DASH] = ACTIONS(3087),
    [anon_sym_DOT_LBRACK] = ACTIONS(3089),
    [anon_sym_LT] = ACTIONS(3089),
    [anon_sym_use] = ACTIONS(3087),
    [anon_sym_use_BANG] = ACTIONS(3089),
    [anon_sym_do_BANG] = ACTIONS(3089),
    [anon_sym_begin] = ACTIONS(3087),
    [anon_sym_LPAREN2] = ACTIONS(3087),
    [anon_sym_or] = ACTIONS(3087),
    [aux_sym_char_token1] = ACTIONS(3089),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3087),
    [anon_sym_DQUOTE] = ACTIONS(3087),
    [anon_sym_AT_DQUOTE] = ACTIONS(3089),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3089),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3089),
    [sym_bool] = ACTIONS(3087),
    [sym_unit] = ACTIONS(3089),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3087),
    [sym_op_identifier] = ACTIONS(3087),
    [anon_sym_PLUS] = ACTIONS(3087),
    [anon_sym_DASH] = ACTIONS(3087),
    [anon_sym_PLUS_DOT] = ACTIONS(3087),
    [anon_sym_DASH_DOT] = ACTIONS(3087),
    [anon_sym_PERCENT] = ACTIONS(3087),
    [anon_sym_AMP_AMP] = ACTIONS(3087),
    [anon_sym_TILDE] = ACTIONS(3089),
    [aux_sym_prefix_op_token1] = ACTIONS(3087),
    [aux_sym_infix_op_token1] = ACTIONS(3089),
    [aux_sym_infix_op_token2] = ACTIONS(3087),
    [anon_sym_PIPE_PIPE] = ACTIONS(3087),
    [anon_sym_BANG_EQ] = ACTIONS(3087),
    [anon_sym_COLON_EQ] = ACTIONS(3089),
    [anon_sym_DOLLAR] = ACTIONS(3087),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3087),
    [sym_int] = ACTIONS(3087),
    [sym_xint] = ACTIONS(3089),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3089),
    [anon_sym_POUNDendif] = ACTIONS(3089),
    [anon_sym_POUNDelse] = ACTIONS(3089),
    [sym__newline] = ACTIONS(3089),
  },
  [2022] = {
    [sym_block_comment] = STATE(2022),
    [sym_compiler_directive_decl] = STATE(2022),
    [sym_fsi_directive_decl] = STATE(2022),
    [sym_preproc_line] = STATE(2022),
    [sym_identifier] = ACTIONS(3091),
    [anon_sym_EQ] = ACTIONS(3093),
    [anon_sym_COLON] = ACTIONS(3091),
    [anon_sym_return] = ACTIONS(3091),
    [anon_sym_do] = ACTIONS(3091),
    [anon_sym_let] = ACTIONS(3091),
    [anon_sym_let_BANG] = ACTIONS(3093),
    [anon_sym_LPAREN] = ACTIONS(3091),
    [anon_sym_COMMA] = ACTIONS(3093),
    [anon_sym_null] = ACTIONS(3091),
    [anon_sym_QMARK] = ACTIONS(3091),
    [anon_sym_COLON_QMARK] = ACTIONS(3091),
    [anon_sym_COLON_COLON] = ACTIONS(3093),
    [anon_sym_AMP] = ACTIONS(3091),
    [anon_sym_LBRACK] = ACTIONS(3091),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3093),
    [anon_sym_LBRACE] = ACTIONS(3091),
    [anon_sym_LT_AT] = ACTIONS(3091),
    [anon_sym_LT_AT_AT] = ACTIONS(3091),
    [anon_sym_DOT] = ACTIONS(3091),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3093),
    [anon_sym_new] = ACTIONS(3091),
    [anon_sym_return_BANG] = ACTIONS(3093),
    [anon_sym_yield] = ACTIONS(3091),
    [anon_sym_yield_BANG] = ACTIONS(3093),
    [anon_sym_lazy] = ACTIONS(3091),
    [anon_sym_assert] = ACTIONS(3091),
    [anon_sym_upcast] = ACTIONS(3091),
    [anon_sym_downcast] = ACTIONS(3091),
    [anon_sym_COLON_GT] = ACTIONS(3093),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3093),
    [anon_sym_for] = ACTIONS(3091),
    [anon_sym_while] = ACTIONS(3091),
    [anon_sym_if] = ACTIONS(3091),
    [anon_sym_fun] = ACTIONS(3091),
    [anon_sym_try] = ACTIONS(3091),
    [anon_sym_match] = ACTIONS(3091),
    [anon_sym_match_BANG] = ACTIONS(3093),
    [anon_sym_function] = ACTIONS(3091),
    [anon_sym_LT_DASH] = ACTIONS(3091),
    [anon_sym_DOT_LBRACK] = ACTIONS(3093),
    [anon_sym_LT] = ACTIONS(3093),
    [anon_sym_use] = ACTIONS(3091),
    [anon_sym_use_BANG] = ACTIONS(3093),
    [anon_sym_do_BANG] = ACTIONS(3093),
    [anon_sym_begin] = ACTIONS(3091),
    [anon_sym_LPAREN2] = ACTIONS(3091),
    [anon_sym_or] = ACTIONS(3091),
    [aux_sym_char_token1] = ACTIONS(3093),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3091),
    [anon_sym_DQUOTE] = ACTIONS(3091),
    [anon_sym_AT_DQUOTE] = ACTIONS(3093),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3093),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3093),
    [sym_bool] = ACTIONS(3091),
    [sym_unit] = ACTIONS(3093),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3091),
    [sym_op_identifier] = ACTIONS(3091),
    [anon_sym_PLUS] = ACTIONS(3091),
    [anon_sym_DASH] = ACTIONS(3091),
    [anon_sym_PLUS_DOT] = ACTIONS(3091),
    [anon_sym_DASH_DOT] = ACTIONS(3091),
    [anon_sym_PERCENT] = ACTIONS(3091),
    [anon_sym_AMP_AMP] = ACTIONS(3091),
    [anon_sym_TILDE] = ACTIONS(3093),
    [aux_sym_prefix_op_token1] = ACTIONS(3091),
    [aux_sym_infix_op_token1] = ACTIONS(3093),
    [aux_sym_infix_op_token2] = ACTIONS(3091),
    [anon_sym_PIPE_PIPE] = ACTIONS(3091),
    [anon_sym_BANG_EQ] = ACTIONS(3091),
    [anon_sym_COLON_EQ] = ACTIONS(3093),
    [anon_sym_DOLLAR] = ACTIONS(3091),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3091),
    [sym_int] = ACTIONS(3091),
    [sym_xint] = ACTIONS(3093),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3093),
    [anon_sym_POUNDendif] = ACTIONS(3093),
    [anon_sym_POUNDelse] = ACTIONS(3093),
    [sym__newline] = ACTIONS(3093),
  },
  [2023] = {
    [sym_block_comment] = STATE(2023),
    [sym_compiler_directive_decl] = STATE(2023),
    [sym_fsi_directive_decl] = STATE(2023),
    [sym_preproc_line] = STATE(2023),
    [sym_identifier] = ACTIONS(3123),
    [anon_sym_EQ] = ACTIONS(3125),
    [anon_sym_COLON] = ACTIONS(3123),
    [anon_sym_return] = ACTIONS(3123),
    [anon_sym_do] = ACTIONS(3123),
    [anon_sym_let] = ACTIONS(3123),
    [anon_sym_let_BANG] = ACTIONS(3125),
    [anon_sym_LPAREN] = ACTIONS(3123),
    [anon_sym_COMMA] = ACTIONS(3125),
    [anon_sym_null] = ACTIONS(3123),
    [anon_sym_QMARK] = ACTIONS(3123),
    [anon_sym_COLON_QMARK] = ACTIONS(3123),
    [anon_sym_COLON_COLON] = ACTIONS(3125),
    [anon_sym_AMP] = ACTIONS(3123),
    [anon_sym_LBRACK] = ACTIONS(3123),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3125),
    [anon_sym_LBRACE] = ACTIONS(3123),
    [anon_sym_LT_AT] = ACTIONS(3123),
    [anon_sym_LT_AT_AT] = ACTIONS(3123),
    [anon_sym_DOT] = ACTIONS(3123),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3125),
    [anon_sym_new] = ACTIONS(3123),
    [anon_sym_return_BANG] = ACTIONS(3125),
    [anon_sym_yield] = ACTIONS(3123),
    [anon_sym_yield_BANG] = ACTIONS(3125),
    [anon_sym_lazy] = ACTIONS(3123),
    [anon_sym_assert] = ACTIONS(3123),
    [anon_sym_upcast] = ACTIONS(3123),
    [anon_sym_downcast] = ACTIONS(3123),
    [anon_sym_COLON_GT] = ACTIONS(3125),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3125),
    [anon_sym_for] = ACTIONS(3123),
    [anon_sym_while] = ACTIONS(3123),
    [anon_sym_if] = ACTIONS(3123),
    [anon_sym_fun] = ACTIONS(3123),
    [anon_sym_try] = ACTIONS(3123),
    [anon_sym_match] = ACTIONS(3123),
    [anon_sym_match_BANG] = ACTIONS(3125),
    [anon_sym_function] = ACTIONS(3123),
    [anon_sym_LT_DASH] = ACTIONS(3123),
    [anon_sym_DOT_LBRACK] = ACTIONS(3125),
    [anon_sym_LT] = ACTIONS(3125),
    [anon_sym_use] = ACTIONS(3123),
    [anon_sym_use_BANG] = ACTIONS(3125),
    [anon_sym_do_BANG] = ACTIONS(3125),
    [anon_sym_begin] = ACTIONS(3123),
    [anon_sym_LPAREN2] = ACTIONS(3123),
    [anon_sym_or] = ACTIONS(3123),
    [aux_sym_char_token1] = ACTIONS(3125),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3123),
    [anon_sym_DQUOTE] = ACTIONS(3123),
    [anon_sym_AT_DQUOTE] = ACTIONS(3125),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3125),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3125),
    [sym_bool] = ACTIONS(3123),
    [sym_unit] = ACTIONS(3125),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3123),
    [sym_op_identifier] = ACTIONS(3123),
    [anon_sym_PLUS] = ACTIONS(3123),
    [anon_sym_DASH] = ACTIONS(3123),
    [anon_sym_PLUS_DOT] = ACTIONS(3123),
    [anon_sym_DASH_DOT] = ACTIONS(3123),
    [anon_sym_PERCENT] = ACTIONS(3123),
    [anon_sym_AMP_AMP] = ACTIONS(3123),
    [anon_sym_TILDE] = ACTIONS(3125),
    [aux_sym_prefix_op_token1] = ACTIONS(3123),
    [aux_sym_infix_op_token1] = ACTIONS(3125),
    [aux_sym_infix_op_token2] = ACTIONS(3123),
    [anon_sym_PIPE_PIPE] = ACTIONS(3123),
    [anon_sym_BANG_EQ] = ACTIONS(3123),
    [anon_sym_COLON_EQ] = ACTIONS(3125),
    [anon_sym_DOLLAR] = ACTIONS(3123),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3123),
    [sym_int] = ACTIONS(3123),
    [sym_xint] = ACTIONS(3125),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3125),
    [anon_sym_POUNDendif] = ACTIONS(3125),
    [anon_sym_POUNDelse] = ACTIONS(3125),
    [sym__newline] = ACTIONS(3125),
  },
  [2024] = {
    [sym_block_comment] = STATE(2024),
    [sym_compiler_directive_decl] = STATE(2024),
    [sym_fsi_directive_decl] = STATE(2024),
    [sym_preproc_line] = STATE(2024),
    [sym_identifier] = ACTIONS(3127),
    [anon_sym_EQ] = ACTIONS(3129),
    [anon_sym_COLON] = ACTIONS(3127),
    [anon_sym_return] = ACTIONS(3127),
    [anon_sym_do] = ACTIONS(3127),
    [anon_sym_let] = ACTIONS(3127),
    [anon_sym_let_BANG] = ACTIONS(3129),
    [anon_sym_LPAREN] = ACTIONS(3127),
    [anon_sym_COMMA] = ACTIONS(3129),
    [anon_sym_null] = ACTIONS(3127),
    [anon_sym_QMARK] = ACTIONS(3127),
    [anon_sym_COLON_QMARK] = ACTIONS(3127),
    [anon_sym_COLON_COLON] = ACTIONS(3129),
    [anon_sym_AMP] = ACTIONS(3127),
    [anon_sym_LBRACK] = ACTIONS(3127),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3129),
    [anon_sym_LBRACE] = ACTIONS(3127),
    [anon_sym_LT_AT] = ACTIONS(3127),
    [anon_sym_LT_AT_AT] = ACTIONS(3127),
    [anon_sym_DOT] = ACTIONS(3127),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3129),
    [anon_sym_new] = ACTIONS(3127),
    [anon_sym_return_BANG] = ACTIONS(3129),
    [anon_sym_yield] = ACTIONS(3127),
    [anon_sym_yield_BANG] = ACTIONS(3129),
    [anon_sym_lazy] = ACTIONS(3127),
    [anon_sym_assert] = ACTIONS(3127),
    [anon_sym_upcast] = ACTIONS(3127),
    [anon_sym_downcast] = ACTIONS(3127),
    [anon_sym_COLON_GT] = ACTIONS(3129),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3129),
    [anon_sym_for] = ACTIONS(3127),
    [anon_sym_while] = ACTIONS(3127),
    [anon_sym_if] = ACTIONS(3127),
    [anon_sym_fun] = ACTIONS(3127),
    [anon_sym_try] = ACTIONS(3127),
    [anon_sym_match] = ACTIONS(3127),
    [anon_sym_match_BANG] = ACTIONS(3129),
    [anon_sym_function] = ACTIONS(3127),
    [anon_sym_LT_DASH] = ACTIONS(3127),
    [anon_sym_DOT_LBRACK] = ACTIONS(3129),
    [anon_sym_LT] = ACTIONS(3129),
    [anon_sym_use] = ACTIONS(3127),
    [anon_sym_use_BANG] = ACTIONS(3129),
    [anon_sym_do_BANG] = ACTIONS(3129),
    [anon_sym_begin] = ACTIONS(3127),
    [anon_sym_LPAREN2] = ACTIONS(3127),
    [anon_sym_or] = ACTIONS(3127),
    [aux_sym_char_token1] = ACTIONS(3129),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3127),
    [anon_sym_DQUOTE] = ACTIONS(3127),
    [anon_sym_AT_DQUOTE] = ACTIONS(3129),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3129),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3129),
    [sym_bool] = ACTIONS(3127),
    [sym_unit] = ACTIONS(3129),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3127),
    [sym_op_identifier] = ACTIONS(3127),
    [anon_sym_PLUS] = ACTIONS(3127),
    [anon_sym_DASH] = ACTIONS(3127),
    [anon_sym_PLUS_DOT] = ACTIONS(3127),
    [anon_sym_DASH_DOT] = ACTIONS(3127),
    [anon_sym_PERCENT] = ACTIONS(3127),
    [anon_sym_AMP_AMP] = ACTIONS(3127),
    [anon_sym_TILDE] = ACTIONS(3129),
    [aux_sym_prefix_op_token1] = ACTIONS(3127),
    [aux_sym_infix_op_token1] = ACTIONS(3129),
    [aux_sym_infix_op_token2] = ACTIONS(3127),
    [anon_sym_PIPE_PIPE] = ACTIONS(3127),
    [anon_sym_BANG_EQ] = ACTIONS(3127),
    [anon_sym_COLON_EQ] = ACTIONS(3129),
    [anon_sym_DOLLAR] = ACTIONS(3127),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3127),
    [sym_int] = ACTIONS(3127),
    [sym_xint] = ACTIONS(3129),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3129),
    [anon_sym_POUNDendif] = ACTIONS(3129),
    [anon_sym_POUNDelse] = ACTIONS(3129),
    [sym__newline] = ACTIONS(3129),
  },
  [2025] = {
    [sym_block_comment] = STATE(2025),
    [sym_compiler_directive_decl] = STATE(2025),
    [sym_fsi_directive_decl] = STATE(2025),
    [sym_preproc_line] = STATE(2025),
    [sym_identifier] = ACTIONS(3131),
    [anon_sym_EQ] = ACTIONS(3133),
    [anon_sym_COLON] = ACTIONS(3131),
    [anon_sym_return] = ACTIONS(3131),
    [anon_sym_do] = ACTIONS(3131),
    [anon_sym_let] = ACTIONS(3131),
    [anon_sym_let_BANG] = ACTIONS(3133),
    [anon_sym_LPAREN] = ACTIONS(3131),
    [anon_sym_COMMA] = ACTIONS(3133),
    [anon_sym_null] = ACTIONS(3131),
    [anon_sym_QMARK] = ACTIONS(3131),
    [anon_sym_COLON_QMARK] = ACTIONS(3131),
    [anon_sym_COLON_COLON] = ACTIONS(3133),
    [anon_sym_AMP] = ACTIONS(3131),
    [anon_sym_LBRACK] = ACTIONS(3131),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3133),
    [anon_sym_LBRACE] = ACTIONS(3131),
    [anon_sym_LT_AT] = ACTIONS(3131),
    [anon_sym_LT_AT_AT] = ACTIONS(3131),
    [anon_sym_DOT] = ACTIONS(3131),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3133),
    [anon_sym_new] = ACTIONS(3131),
    [anon_sym_return_BANG] = ACTIONS(3133),
    [anon_sym_yield] = ACTIONS(3131),
    [anon_sym_yield_BANG] = ACTIONS(3133),
    [anon_sym_lazy] = ACTIONS(3131),
    [anon_sym_assert] = ACTIONS(3131),
    [anon_sym_upcast] = ACTIONS(3131),
    [anon_sym_downcast] = ACTIONS(3131),
    [anon_sym_COLON_GT] = ACTIONS(3133),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3133),
    [anon_sym_for] = ACTIONS(3131),
    [anon_sym_while] = ACTIONS(3131),
    [anon_sym_if] = ACTIONS(3131),
    [anon_sym_fun] = ACTIONS(3131),
    [anon_sym_try] = ACTIONS(3131),
    [anon_sym_match] = ACTIONS(3131),
    [anon_sym_match_BANG] = ACTIONS(3133),
    [anon_sym_function] = ACTIONS(3131),
    [anon_sym_LT_DASH] = ACTIONS(3131),
    [anon_sym_DOT_LBRACK] = ACTIONS(3133),
    [anon_sym_LT] = ACTIONS(3133),
    [anon_sym_use] = ACTIONS(3131),
    [anon_sym_use_BANG] = ACTIONS(3133),
    [anon_sym_do_BANG] = ACTIONS(3133),
    [anon_sym_begin] = ACTIONS(3131),
    [anon_sym_LPAREN2] = ACTIONS(3131),
    [anon_sym_or] = ACTIONS(3131),
    [aux_sym_char_token1] = ACTIONS(3133),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3131),
    [anon_sym_DQUOTE] = ACTIONS(3131),
    [anon_sym_AT_DQUOTE] = ACTIONS(3133),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3133),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3133),
    [sym_bool] = ACTIONS(3131),
    [sym_unit] = ACTIONS(3133),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3131),
    [sym_op_identifier] = ACTIONS(3131),
    [anon_sym_PLUS] = ACTIONS(3131),
    [anon_sym_DASH] = ACTIONS(3131),
    [anon_sym_PLUS_DOT] = ACTIONS(3131),
    [anon_sym_DASH_DOT] = ACTIONS(3131),
    [anon_sym_PERCENT] = ACTIONS(3131),
    [anon_sym_AMP_AMP] = ACTIONS(3131),
    [anon_sym_TILDE] = ACTIONS(3133),
    [aux_sym_prefix_op_token1] = ACTIONS(3131),
    [aux_sym_infix_op_token1] = ACTIONS(3133),
    [aux_sym_infix_op_token2] = ACTIONS(3131),
    [anon_sym_PIPE_PIPE] = ACTIONS(3131),
    [anon_sym_BANG_EQ] = ACTIONS(3131),
    [anon_sym_COLON_EQ] = ACTIONS(3133),
    [anon_sym_DOLLAR] = ACTIONS(3131),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3131),
    [sym_int] = ACTIONS(3131),
    [sym_xint] = ACTIONS(3133),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3133),
    [anon_sym_POUNDendif] = ACTIONS(3133),
    [anon_sym_POUNDelse] = ACTIONS(3133),
    [sym__newline] = ACTIONS(3133),
  },
  [2026] = {
    [sym_block_comment] = STATE(2026),
    [sym_compiler_directive_decl] = STATE(2026),
    [sym_fsi_directive_decl] = STATE(2026),
    [sym_preproc_line] = STATE(2026),
    [sym_identifier] = ACTIONS(3139),
    [anon_sym_EQ] = ACTIONS(3141),
    [anon_sym_COLON] = ACTIONS(3139),
    [anon_sym_return] = ACTIONS(3139),
    [anon_sym_do] = ACTIONS(3139),
    [anon_sym_let] = ACTIONS(3139),
    [anon_sym_let_BANG] = ACTIONS(3141),
    [anon_sym_LPAREN] = ACTIONS(3139),
    [anon_sym_COMMA] = ACTIONS(3141),
    [anon_sym_null] = ACTIONS(3139),
    [anon_sym_QMARK] = ACTIONS(3139),
    [anon_sym_COLON_QMARK] = ACTIONS(3139),
    [anon_sym_COLON_COLON] = ACTIONS(3141),
    [anon_sym_AMP] = ACTIONS(3139),
    [anon_sym_LBRACK] = ACTIONS(3139),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3141),
    [anon_sym_LBRACE] = ACTIONS(3139),
    [anon_sym_LT_AT] = ACTIONS(3139),
    [anon_sym_LT_AT_AT] = ACTIONS(3139),
    [anon_sym_DOT] = ACTIONS(3139),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3141),
    [anon_sym_new] = ACTIONS(3139),
    [anon_sym_return_BANG] = ACTIONS(3141),
    [anon_sym_yield] = ACTIONS(3139),
    [anon_sym_yield_BANG] = ACTIONS(3141),
    [anon_sym_lazy] = ACTIONS(3139),
    [anon_sym_assert] = ACTIONS(3139),
    [anon_sym_upcast] = ACTIONS(3139),
    [anon_sym_downcast] = ACTIONS(3139),
    [anon_sym_COLON_GT] = ACTIONS(3141),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3141),
    [anon_sym_for] = ACTIONS(3139),
    [anon_sym_while] = ACTIONS(3139),
    [anon_sym_if] = ACTIONS(3139),
    [anon_sym_fun] = ACTIONS(3139),
    [anon_sym_try] = ACTIONS(3139),
    [anon_sym_match] = ACTIONS(3139),
    [anon_sym_match_BANG] = ACTIONS(3141),
    [anon_sym_function] = ACTIONS(3139),
    [anon_sym_LT_DASH] = ACTIONS(3139),
    [anon_sym_DOT_LBRACK] = ACTIONS(3141),
    [anon_sym_LT] = ACTIONS(3141),
    [anon_sym_use] = ACTIONS(3139),
    [anon_sym_use_BANG] = ACTIONS(3141),
    [anon_sym_do_BANG] = ACTIONS(3141),
    [anon_sym_begin] = ACTIONS(3139),
    [anon_sym_LPAREN2] = ACTIONS(3139),
    [anon_sym_or] = ACTIONS(3139),
    [aux_sym_char_token1] = ACTIONS(3141),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3139),
    [anon_sym_DQUOTE] = ACTIONS(3139),
    [anon_sym_AT_DQUOTE] = ACTIONS(3141),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3141),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3141),
    [sym_bool] = ACTIONS(3139),
    [sym_unit] = ACTIONS(3141),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3139),
    [sym_op_identifier] = ACTIONS(3139),
    [anon_sym_PLUS] = ACTIONS(3139),
    [anon_sym_DASH] = ACTIONS(3139),
    [anon_sym_PLUS_DOT] = ACTIONS(3139),
    [anon_sym_DASH_DOT] = ACTIONS(3139),
    [anon_sym_PERCENT] = ACTIONS(3139),
    [anon_sym_AMP_AMP] = ACTIONS(3139),
    [anon_sym_TILDE] = ACTIONS(3141),
    [aux_sym_prefix_op_token1] = ACTIONS(3139),
    [aux_sym_infix_op_token1] = ACTIONS(3141),
    [aux_sym_infix_op_token2] = ACTIONS(3139),
    [anon_sym_PIPE_PIPE] = ACTIONS(3139),
    [anon_sym_BANG_EQ] = ACTIONS(3139),
    [anon_sym_COLON_EQ] = ACTIONS(3141),
    [anon_sym_DOLLAR] = ACTIONS(3139),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3139),
    [sym_int] = ACTIONS(3139),
    [sym_xint] = ACTIONS(3141),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3141),
    [anon_sym_POUNDendif] = ACTIONS(3141),
    [anon_sym_POUNDelse] = ACTIONS(3141),
    [sym__newline] = ACTIONS(3141),
  },
  [2027] = {
    [sym_block_comment] = STATE(2027),
    [sym_compiler_directive_decl] = STATE(2027),
    [sym_fsi_directive_decl] = STATE(2027),
    [sym_preproc_line] = STATE(2027),
    [sym_identifier] = ACTIONS(2873),
    [anon_sym_EQ] = ACTIONS(2875),
    [anon_sym_COLON] = ACTIONS(2873),
    [anon_sym_return] = ACTIONS(2873),
    [anon_sym_do] = ACTIONS(2873),
    [anon_sym_and] = ACTIONS(2873),
    [anon_sym_let] = ACTIONS(2873),
    [anon_sym_let_BANG] = ACTIONS(2875),
    [anon_sym_LPAREN] = ACTIONS(2873),
    [anon_sym_COMMA] = ACTIONS(2875),
    [anon_sym_null] = ACTIONS(2873),
    [anon_sym_QMARK] = ACTIONS(2873),
    [anon_sym_COLON_QMARK] = ACTIONS(2873),
    [anon_sym_COLON_COLON] = ACTIONS(2875),
    [anon_sym_AMP] = ACTIONS(2873),
    [anon_sym_LBRACK] = ACTIONS(2873),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2875),
    [anon_sym_LBRACE] = ACTIONS(2873),
    [anon_sym_LT_AT] = ACTIONS(2873),
    [anon_sym_LT_AT_AT] = ACTIONS(2873),
    [anon_sym_DOT] = ACTIONS(2873),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2875),
    [anon_sym_new] = ACTIONS(2873),
    [anon_sym_return_BANG] = ACTIONS(2875),
    [anon_sym_yield] = ACTIONS(2873),
    [anon_sym_yield_BANG] = ACTIONS(2875),
    [anon_sym_lazy] = ACTIONS(2873),
    [anon_sym_assert] = ACTIONS(2873),
    [anon_sym_upcast] = ACTIONS(2873),
    [anon_sym_downcast] = ACTIONS(2873),
    [anon_sym_COLON_GT] = ACTIONS(2875),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2875),
    [anon_sym_for] = ACTIONS(2873),
    [anon_sym_while] = ACTIONS(2873),
    [anon_sym_if] = ACTIONS(2873),
    [anon_sym_fun] = ACTIONS(2873),
    [anon_sym_try] = ACTIONS(2873),
    [anon_sym_match] = ACTIONS(2873),
    [anon_sym_match_BANG] = ACTIONS(2875),
    [anon_sym_function] = ACTIONS(2873),
    [anon_sym_LT_DASH] = ACTIONS(2873),
    [anon_sym_DOT_LBRACK] = ACTIONS(2875),
    [anon_sym_LT] = ACTIONS(2875),
    [anon_sym_use] = ACTIONS(2873),
    [anon_sym_use_BANG] = ACTIONS(2875),
    [anon_sym_do_BANG] = ACTIONS(2875),
    [anon_sym_begin] = ACTIONS(2873),
    [anon_sym_LPAREN2] = ACTIONS(2873),
    [anon_sym_or] = ACTIONS(2873),
    [aux_sym_char_token1] = ACTIONS(2875),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2873),
    [anon_sym_DQUOTE] = ACTIONS(2873),
    [anon_sym_AT_DQUOTE] = ACTIONS(2875),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2875),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2875),
    [sym_bool] = ACTIONS(2873),
    [sym_unit] = ACTIONS(2875),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2873),
    [sym_op_identifier] = ACTIONS(2873),
    [anon_sym_PLUS] = ACTIONS(2873),
    [anon_sym_DASH] = ACTIONS(2873),
    [anon_sym_PLUS_DOT] = ACTIONS(2873),
    [anon_sym_DASH_DOT] = ACTIONS(2873),
    [anon_sym_PERCENT] = ACTIONS(2873),
    [anon_sym_AMP_AMP] = ACTIONS(2873),
    [anon_sym_TILDE] = ACTIONS(2875),
    [aux_sym_prefix_op_token1] = ACTIONS(2873),
    [aux_sym_infix_op_token1] = ACTIONS(2875),
    [aux_sym_infix_op_token2] = ACTIONS(2873),
    [anon_sym_PIPE_PIPE] = ACTIONS(2873),
    [anon_sym_BANG_EQ] = ACTIONS(2873),
    [anon_sym_COLON_EQ] = ACTIONS(2875),
    [anon_sym_DOLLAR] = ACTIONS(2873),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2873),
    [sym_int] = ACTIONS(2873),
    [sym_xint] = ACTIONS(2875),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2875),
    [sym__newline] = ACTIONS(2875),
    [sym__dedent] = ACTIONS(2875),
  },
  [2028] = {
    [sym_block_comment] = STATE(2028),
    [sym_compiler_directive_decl] = STATE(2028),
    [sym_fsi_directive_decl] = STATE(2028),
    [sym_preproc_line] = STATE(2028),
    [sym_identifier] = ACTIONS(2877),
    [anon_sym_EQ] = ACTIONS(2879),
    [anon_sym_COLON] = ACTIONS(2877),
    [anon_sym_return] = ACTIONS(2877),
    [anon_sym_do] = ACTIONS(2877),
    [anon_sym_and] = ACTIONS(2877),
    [anon_sym_let] = ACTIONS(2877),
    [anon_sym_let_BANG] = ACTIONS(2879),
    [anon_sym_LPAREN] = ACTIONS(2877),
    [anon_sym_COMMA] = ACTIONS(2879),
    [anon_sym_null] = ACTIONS(2877),
    [anon_sym_QMARK] = ACTIONS(2877),
    [anon_sym_COLON_QMARK] = ACTIONS(2877),
    [anon_sym_COLON_COLON] = ACTIONS(2879),
    [anon_sym_AMP] = ACTIONS(2877),
    [anon_sym_LBRACK] = ACTIONS(2877),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2879),
    [anon_sym_LBRACE] = ACTIONS(2877),
    [anon_sym_LT_AT] = ACTIONS(2877),
    [anon_sym_LT_AT_AT] = ACTIONS(2877),
    [anon_sym_DOT] = ACTIONS(2877),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2879),
    [anon_sym_new] = ACTIONS(2877),
    [anon_sym_return_BANG] = ACTIONS(2879),
    [anon_sym_yield] = ACTIONS(2877),
    [anon_sym_yield_BANG] = ACTIONS(2879),
    [anon_sym_lazy] = ACTIONS(2877),
    [anon_sym_assert] = ACTIONS(2877),
    [anon_sym_upcast] = ACTIONS(2877),
    [anon_sym_downcast] = ACTIONS(2877),
    [anon_sym_COLON_GT] = ACTIONS(2879),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2879),
    [anon_sym_for] = ACTIONS(2877),
    [anon_sym_while] = ACTIONS(2877),
    [anon_sym_if] = ACTIONS(2877),
    [anon_sym_fun] = ACTIONS(2877),
    [anon_sym_try] = ACTIONS(2877),
    [anon_sym_match] = ACTIONS(2877),
    [anon_sym_match_BANG] = ACTIONS(2879),
    [anon_sym_function] = ACTIONS(2877),
    [anon_sym_LT_DASH] = ACTIONS(2877),
    [anon_sym_DOT_LBRACK] = ACTIONS(2879),
    [anon_sym_LT] = ACTIONS(2879),
    [anon_sym_use] = ACTIONS(2877),
    [anon_sym_use_BANG] = ACTIONS(2879),
    [anon_sym_do_BANG] = ACTIONS(2879),
    [anon_sym_begin] = ACTIONS(2877),
    [anon_sym_LPAREN2] = ACTIONS(2877),
    [anon_sym_or] = ACTIONS(2877),
    [aux_sym_char_token1] = ACTIONS(2879),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2877),
    [anon_sym_DQUOTE] = ACTIONS(2877),
    [anon_sym_AT_DQUOTE] = ACTIONS(2879),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2879),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2879),
    [sym_bool] = ACTIONS(2877),
    [sym_unit] = ACTIONS(2879),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2877),
    [sym_op_identifier] = ACTIONS(2877),
    [anon_sym_PLUS] = ACTIONS(2877),
    [anon_sym_DASH] = ACTIONS(2877),
    [anon_sym_PLUS_DOT] = ACTIONS(2877),
    [anon_sym_DASH_DOT] = ACTIONS(2877),
    [anon_sym_PERCENT] = ACTIONS(2877),
    [anon_sym_AMP_AMP] = ACTIONS(2877),
    [anon_sym_TILDE] = ACTIONS(2879),
    [aux_sym_prefix_op_token1] = ACTIONS(2877),
    [aux_sym_infix_op_token1] = ACTIONS(2879),
    [aux_sym_infix_op_token2] = ACTIONS(2877),
    [anon_sym_PIPE_PIPE] = ACTIONS(2877),
    [anon_sym_BANG_EQ] = ACTIONS(2877),
    [anon_sym_COLON_EQ] = ACTIONS(2879),
    [anon_sym_DOLLAR] = ACTIONS(2877),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2877),
    [sym_int] = ACTIONS(2877),
    [sym_xint] = ACTIONS(2879),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2879),
    [sym__newline] = ACTIONS(2879),
    [sym__dedent] = ACTIONS(2879),
  },
  [2029] = {
    [sym_block_comment] = STATE(2029),
    [sym_compiler_directive_decl] = STATE(2029),
    [sym_fsi_directive_decl] = STATE(2029),
    [sym_preproc_line] = STATE(2029),
    [sym_identifier] = ACTIONS(3135),
    [anon_sym_EQ] = ACTIONS(3137),
    [anon_sym_COLON] = ACTIONS(3135),
    [anon_sym_return] = ACTIONS(3135),
    [anon_sym_do] = ACTIONS(3135),
    [anon_sym_let] = ACTIONS(3135),
    [anon_sym_let_BANG] = ACTIONS(3137),
    [anon_sym_LPAREN] = ACTIONS(3135),
    [anon_sym_COMMA] = ACTIONS(3137),
    [anon_sym_null] = ACTIONS(3135),
    [anon_sym_QMARK] = ACTIONS(3135),
    [anon_sym_COLON_QMARK] = ACTIONS(3135),
    [anon_sym_COLON_COLON] = ACTIONS(3137),
    [anon_sym_AMP] = ACTIONS(3135),
    [anon_sym_LBRACK] = ACTIONS(3135),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3137),
    [anon_sym_LBRACE] = ACTIONS(3135),
    [anon_sym_LT_AT] = ACTIONS(3135),
    [anon_sym_LT_AT_AT] = ACTIONS(3135),
    [anon_sym_DOT] = ACTIONS(3135),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3137),
    [anon_sym_new] = ACTIONS(3135),
    [anon_sym_return_BANG] = ACTIONS(3137),
    [anon_sym_yield] = ACTIONS(3135),
    [anon_sym_yield_BANG] = ACTIONS(3137),
    [anon_sym_lazy] = ACTIONS(3135),
    [anon_sym_assert] = ACTIONS(3135),
    [anon_sym_upcast] = ACTIONS(3135),
    [anon_sym_downcast] = ACTIONS(3135),
    [anon_sym_COLON_GT] = ACTIONS(3137),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3137),
    [anon_sym_for] = ACTIONS(3135),
    [anon_sym_while] = ACTIONS(3135),
    [anon_sym_if] = ACTIONS(3135),
    [anon_sym_fun] = ACTIONS(3135),
    [anon_sym_try] = ACTIONS(3135),
    [anon_sym_match] = ACTIONS(3135),
    [anon_sym_match_BANG] = ACTIONS(3137),
    [anon_sym_function] = ACTIONS(3135),
    [anon_sym_LT_DASH] = ACTIONS(3135),
    [anon_sym_DOT_LBRACK] = ACTIONS(3137),
    [anon_sym_LT] = ACTIONS(3137),
    [anon_sym_use] = ACTIONS(3135),
    [anon_sym_use_BANG] = ACTIONS(3137),
    [anon_sym_do_BANG] = ACTIONS(3137),
    [anon_sym_begin] = ACTIONS(3135),
    [anon_sym_LPAREN2] = ACTIONS(3135),
    [anon_sym_or] = ACTIONS(3135),
    [aux_sym_char_token1] = ACTIONS(3137),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3135),
    [anon_sym_DQUOTE] = ACTIONS(3135),
    [anon_sym_AT_DQUOTE] = ACTIONS(3137),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3137),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3137),
    [sym_bool] = ACTIONS(3135),
    [sym_unit] = ACTIONS(3137),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3135),
    [sym_op_identifier] = ACTIONS(3135),
    [anon_sym_PLUS] = ACTIONS(3135),
    [anon_sym_DASH] = ACTIONS(3135),
    [anon_sym_PLUS_DOT] = ACTIONS(3135),
    [anon_sym_DASH_DOT] = ACTIONS(3135),
    [anon_sym_PERCENT] = ACTIONS(3135),
    [anon_sym_AMP_AMP] = ACTIONS(3135),
    [anon_sym_TILDE] = ACTIONS(3137),
    [aux_sym_prefix_op_token1] = ACTIONS(3135),
    [aux_sym_infix_op_token1] = ACTIONS(3137),
    [aux_sym_infix_op_token2] = ACTIONS(3135),
    [anon_sym_PIPE_PIPE] = ACTIONS(3135),
    [anon_sym_BANG_EQ] = ACTIONS(3135),
    [anon_sym_COLON_EQ] = ACTIONS(3137),
    [anon_sym_DOLLAR] = ACTIONS(3135),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3135),
    [sym_int] = ACTIONS(3135),
    [sym_xint] = ACTIONS(3137),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3137),
    [anon_sym_POUNDendif] = ACTIONS(3137),
    [anon_sym_POUNDelse] = ACTIONS(3137),
    [sym__newline] = ACTIONS(3137),
  },
  [2030] = {
    [sym_block_comment] = STATE(2030),
    [sym_compiler_directive_decl] = STATE(2030),
    [sym_fsi_directive_decl] = STATE(2030),
    [sym_preproc_line] = STATE(2030),
    [sym_identifier] = ACTIONS(3119),
    [anon_sym_EQ] = ACTIONS(3121),
    [anon_sym_COLON] = ACTIONS(3119),
    [anon_sym_return] = ACTIONS(3119),
    [anon_sym_do] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_let_BANG] = ACTIONS(3121),
    [anon_sym_LPAREN] = ACTIONS(3119),
    [anon_sym_COMMA] = ACTIONS(3121),
    [anon_sym_null] = ACTIONS(3119),
    [anon_sym_QMARK] = ACTIONS(3119),
    [anon_sym_COLON_QMARK] = ACTIONS(3119),
    [anon_sym_COLON_COLON] = ACTIONS(3121),
    [anon_sym_AMP] = ACTIONS(3119),
    [anon_sym_LBRACK] = ACTIONS(3119),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3121),
    [anon_sym_LBRACE] = ACTIONS(3119),
    [anon_sym_LT_AT] = ACTIONS(3119),
    [anon_sym_LT_AT_AT] = ACTIONS(3119),
    [anon_sym_DOT] = ACTIONS(3119),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3121),
    [anon_sym_new] = ACTIONS(3119),
    [anon_sym_return_BANG] = ACTIONS(3121),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_yield_BANG] = ACTIONS(3121),
    [anon_sym_lazy] = ACTIONS(3119),
    [anon_sym_assert] = ACTIONS(3119),
    [anon_sym_upcast] = ACTIONS(3119),
    [anon_sym_downcast] = ACTIONS(3119),
    [anon_sym_COLON_GT] = ACTIONS(3121),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3121),
    [anon_sym_for] = ACTIONS(3119),
    [anon_sym_while] = ACTIONS(3119),
    [anon_sym_if] = ACTIONS(3119),
    [anon_sym_fun] = ACTIONS(3119),
    [anon_sym_try] = ACTIONS(3119),
    [anon_sym_match] = ACTIONS(3119),
    [anon_sym_match_BANG] = ACTIONS(3121),
    [anon_sym_function] = ACTIONS(3119),
    [anon_sym_LT_DASH] = ACTIONS(3119),
    [anon_sym_DOT_LBRACK] = ACTIONS(3121),
    [anon_sym_LT] = ACTIONS(3121),
    [anon_sym_use] = ACTIONS(3119),
    [anon_sym_use_BANG] = ACTIONS(3121),
    [anon_sym_do_BANG] = ACTIONS(3121),
    [anon_sym_begin] = ACTIONS(3119),
    [anon_sym_LPAREN2] = ACTIONS(3119),
    [anon_sym_or] = ACTIONS(3119),
    [aux_sym_char_token1] = ACTIONS(3121),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3119),
    [anon_sym_DQUOTE] = ACTIONS(3119),
    [anon_sym_AT_DQUOTE] = ACTIONS(3121),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3121),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3121),
    [sym_bool] = ACTIONS(3119),
    [sym_unit] = ACTIONS(3121),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3119),
    [sym_op_identifier] = ACTIONS(3119),
    [anon_sym_PLUS] = ACTIONS(3119),
    [anon_sym_DASH] = ACTIONS(3119),
    [anon_sym_PLUS_DOT] = ACTIONS(3119),
    [anon_sym_DASH_DOT] = ACTIONS(3119),
    [anon_sym_PERCENT] = ACTIONS(3119),
    [anon_sym_AMP_AMP] = ACTIONS(3119),
    [anon_sym_TILDE] = ACTIONS(3121),
    [aux_sym_prefix_op_token1] = ACTIONS(3119),
    [aux_sym_infix_op_token1] = ACTIONS(3121),
    [aux_sym_infix_op_token2] = ACTIONS(3119),
    [anon_sym_PIPE_PIPE] = ACTIONS(3119),
    [anon_sym_BANG_EQ] = ACTIONS(3119),
    [anon_sym_COLON_EQ] = ACTIONS(3121),
    [anon_sym_DOLLAR] = ACTIONS(3119),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3119),
    [sym_int] = ACTIONS(3119),
    [sym_xint] = ACTIONS(3121),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3121),
    [anon_sym_POUNDendif] = ACTIONS(3121),
    [anon_sym_POUNDelse] = ACTIONS(3121),
    [sym__newline] = ACTIONS(3121),
  },
  [2031] = {
    [sym_block_comment] = STATE(2031),
    [sym_compiler_directive_decl] = STATE(2031),
    [sym_fsi_directive_decl] = STATE(2031),
    [sym_preproc_line] = STATE(2031),
    [sym_identifier] = ACTIONS(2835),
    [anon_sym_EQ] = ACTIONS(2837),
    [anon_sym_COLON] = ACTIONS(2835),
    [anon_sym_return] = ACTIONS(2835),
    [anon_sym_do] = ACTIONS(2835),
    [anon_sym_let] = ACTIONS(2835),
    [anon_sym_let_BANG] = ACTIONS(2837),
    [anon_sym_LPAREN] = ACTIONS(2835),
    [anon_sym_COMMA] = ACTIONS(2837),
    [anon_sym_null] = ACTIONS(2835),
    [anon_sym_QMARK] = ACTIONS(2835),
    [anon_sym_COLON_QMARK] = ACTIONS(2835),
    [anon_sym_COLON_COLON] = ACTIONS(2837),
    [anon_sym_AMP] = ACTIONS(2835),
    [anon_sym_LBRACK] = ACTIONS(2835),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2837),
    [anon_sym_LBRACE] = ACTIONS(2835),
    [anon_sym_LT_AT] = ACTIONS(2835),
    [anon_sym_LT_AT_AT] = ACTIONS(2835),
    [anon_sym_DOT] = ACTIONS(2835),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2837),
    [anon_sym_new] = ACTIONS(2835),
    [anon_sym_return_BANG] = ACTIONS(2837),
    [anon_sym_yield] = ACTIONS(2835),
    [anon_sym_yield_BANG] = ACTIONS(2837),
    [anon_sym_lazy] = ACTIONS(2835),
    [anon_sym_assert] = ACTIONS(2835),
    [anon_sym_upcast] = ACTIONS(2835),
    [anon_sym_downcast] = ACTIONS(2835),
    [anon_sym_COLON_GT] = ACTIONS(2837),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2837),
    [anon_sym_for] = ACTIONS(2835),
    [anon_sym_while] = ACTIONS(2835),
    [anon_sym_if] = ACTIONS(2835),
    [anon_sym_fun] = ACTIONS(2835),
    [anon_sym_try] = ACTIONS(2835),
    [anon_sym_match] = ACTIONS(2835),
    [anon_sym_match_BANG] = ACTIONS(2837),
    [anon_sym_function] = ACTIONS(2835),
    [anon_sym_LT_DASH] = ACTIONS(2835),
    [anon_sym_DOT_LBRACK] = ACTIONS(2837),
    [anon_sym_LT] = ACTIONS(2837),
    [anon_sym_use] = ACTIONS(2835),
    [anon_sym_use_BANG] = ACTIONS(2837),
    [anon_sym_do_BANG] = ACTIONS(2837),
    [anon_sym_begin] = ACTIONS(2835),
    [anon_sym_LPAREN2] = ACTIONS(2835),
    [anon_sym_or] = ACTIONS(2835),
    [aux_sym_char_token1] = ACTIONS(2837),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2835),
    [anon_sym_DQUOTE] = ACTIONS(2835),
    [anon_sym_AT_DQUOTE] = ACTIONS(2837),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2837),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2837),
    [sym_bool] = ACTIONS(2835),
    [sym_unit] = ACTIONS(2837),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2835),
    [sym_op_identifier] = ACTIONS(2835),
    [anon_sym_PLUS] = ACTIONS(2835),
    [anon_sym_DASH] = ACTIONS(2835),
    [anon_sym_PLUS_DOT] = ACTIONS(2835),
    [anon_sym_DASH_DOT] = ACTIONS(2835),
    [anon_sym_PERCENT] = ACTIONS(2835),
    [anon_sym_AMP_AMP] = ACTIONS(2835),
    [anon_sym_TILDE] = ACTIONS(2837),
    [aux_sym_prefix_op_token1] = ACTIONS(2835),
    [aux_sym_infix_op_token1] = ACTIONS(2837),
    [aux_sym_infix_op_token2] = ACTIONS(2835),
    [anon_sym_PIPE_PIPE] = ACTIONS(2835),
    [anon_sym_BANG_EQ] = ACTIONS(2835),
    [anon_sym_COLON_EQ] = ACTIONS(2837),
    [anon_sym_DOLLAR] = ACTIONS(2835),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2835),
    [sym_int] = ACTIONS(2835),
    [sym_xint] = ACTIONS(2837),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2837),
    [anon_sym_POUNDendif] = ACTIONS(2837),
    [anon_sym_POUNDelse] = ACTIONS(2837),
    [sym__newline] = ACTIONS(2837),
  },
  [2032] = {
    [sym_block_comment] = STATE(2032),
    [sym_compiler_directive_decl] = STATE(2032),
    [sym_fsi_directive_decl] = STATE(2032),
    [sym_preproc_line] = STATE(2032),
    [sym_identifier] = ACTIONS(3095),
    [anon_sym_EQ] = ACTIONS(3097),
    [anon_sym_COLON] = ACTIONS(3095),
    [anon_sym_return] = ACTIONS(3095),
    [anon_sym_do] = ACTIONS(3095),
    [anon_sym_and] = ACTIONS(3095),
    [anon_sym_let] = ACTIONS(3095),
    [anon_sym_let_BANG] = ACTIONS(3097),
    [anon_sym_LPAREN] = ACTIONS(3095),
    [anon_sym_COMMA] = ACTIONS(3097),
    [anon_sym_null] = ACTIONS(3095),
    [anon_sym_QMARK] = ACTIONS(3095),
    [anon_sym_COLON_QMARK] = ACTIONS(3095),
    [anon_sym_COLON_COLON] = ACTIONS(3097),
    [anon_sym_AMP] = ACTIONS(3095),
    [anon_sym_LBRACK] = ACTIONS(3095),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3097),
    [anon_sym_LBRACE] = ACTIONS(3095),
    [anon_sym_LT_AT] = ACTIONS(3095),
    [anon_sym_LT_AT_AT] = ACTIONS(3095),
    [anon_sym_DOT] = ACTIONS(3095),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3097),
    [anon_sym_new] = ACTIONS(3095),
    [anon_sym_return_BANG] = ACTIONS(3097),
    [anon_sym_yield] = ACTIONS(3095),
    [anon_sym_yield_BANG] = ACTIONS(3097),
    [anon_sym_lazy] = ACTIONS(3095),
    [anon_sym_assert] = ACTIONS(3095),
    [anon_sym_upcast] = ACTIONS(3095),
    [anon_sym_downcast] = ACTIONS(3095),
    [anon_sym_COLON_GT] = ACTIONS(3097),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3097),
    [anon_sym_for] = ACTIONS(3095),
    [anon_sym_while] = ACTIONS(3095),
    [anon_sym_if] = ACTIONS(3095),
    [anon_sym_fun] = ACTIONS(3095),
    [anon_sym_try] = ACTIONS(3095),
    [anon_sym_match] = ACTIONS(3095),
    [anon_sym_match_BANG] = ACTIONS(3097),
    [anon_sym_function] = ACTIONS(3095),
    [anon_sym_LT_DASH] = ACTIONS(3095),
    [anon_sym_DOT_LBRACK] = ACTIONS(3097),
    [anon_sym_LT] = ACTIONS(3097),
    [anon_sym_use] = ACTIONS(3095),
    [anon_sym_use_BANG] = ACTIONS(3097),
    [anon_sym_do_BANG] = ACTIONS(3097),
    [anon_sym_begin] = ACTIONS(3095),
    [anon_sym_LPAREN2] = ACTIONS(3095),
    [anon_sym_or] = ACTIONS(3095),
    [aux_sym_char_token1] = ACTIONS(3097),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3095),
    [anon_sym_DQUOTE] = ACTIONS(3095),
    [anon_sym_AT_DQUOTE] = ACTIONS(3097),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3097),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3097),
    [sym_bool] = ACTIONS(3095),
    [sym_unit] = ACTIONS(3097),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3095),
    [sym_op_identifier] = ACTIONS(3095),
    [anon_sym_PLUS] = ACTIONS(3095),
    [anon_sym_DASH] = ACTIONS(3095),
    [anon_sym_PLUS_DOT] = ACTIONS(3095),
    [anon_sym_DASH_DOT] = ACTIONS(3095),
    [anon_sym_PERCENT] = ACTIONS(3095),
    [anon_sym_AMP_AMP] = ACTIONS(3095),
    [anon_sym_TILDE] = ACTIONS(3097),
    [aux_sym_prefix_op_token1] = ACTIONS(3095),
    [aux_sym_infix_op_token1] = ACTIONS(3097),
    [aux_sym_infix_op_token2] = ACTIONS(3095),
    [anon_sym_PIPE_PIPE] = ACTIONS(3095),
    [anon_sym_BANG_EQ] = ACTIONS(3095),
    [anon_sym_COLON_EQ] = ACTIONS(3097),
    [anon_sym_DOLLAR] = ACTIONS(3095),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3095),
    [sym_int] = ACTIONS(3095),
    [sym_xint] = ACTIONS(3097),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3097),
    [sym__newline] = ACTIONS(3097),
    [sym__dedent] = ACTIONS(3097),
  },
  [2033] = {
    [sym_block_comment] = STATE(2033),
    [sym_compiler_directive_decl] = STATE(2033),
    [sym_fsi_directive_decl] = STATE(2033),
    [sym_preproc_line] = STATE(2033),
    [sym_identifier] = ACTIONS(3111),
    [anon_sym_EQ] = ACTIONS(3113),
    [anon_sym_COLON] = ACTIONS(3111),
    [anon_sym_return] = ACTIONS(3111),
    [anon_sym_do] = ACTIONS(3111),
    [anon_sym_let] = ACTIONS(3111),
    [anon_sym_let_BANG] = ACTIONS(3113),
    [anon_sym_LPAREN] = ACTIONS(3111),
    [anon_sym_COMMA] = ACTIONS(3113),
    [anon_sym_null] = ACTIONS(3111),
    [anon_sym_QMARK] = ACTIONS(3111),
    [anon_sym_COLON_QMARK] = ACTIONS(3111),
    [anon_sym_COLON_COLON] = ACTIONS(3113),
    [anon_sym_AMP] = ACTIONS(3111),
    [anon_sym_LBRACK] = ACTIONS(3111),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3113),
    [anon_sym_LBRACE] = ACTIONS(3111),
    [anon_sym_LT_AT] = ACTIONS(3111),
    [anon_sym_LT_AT_AT] = ACTIONS(3111),
    [anon_sym_DOT] = ACTIONS(3111),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3113),
    [anon_sym_new] = ACTIONS(3111),
    [anon_sym_return_BANG] = ACTIONS(3113),
    [anon_sym_yield] = ACTIONS(3111),
    [anon_sym_yield_BANG] = ACTIONS(3113),
    [anon_sym_lazy] = ACTIONS(3111),
    [anon_sym_assert] = ACTIONS(3111),
    [anon_sym_upcast] = ACTIONS(3111),
    [anon_sym_downcast] = ACTIONS(3111),
    [anon_sym_COLON_GT] = ACTIONS(3113),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3113),
    [anon_sym_for] = ACTIONS(3111),
    [anon_sym_while] = ACTIONS(3111),
    [anon_sym_if] = ACTIONS(3111),
    [anon_sym_fun] = ACTIONS(3111),
    [anon_sym_try] = ACTIONS(3111),
    [anon_sym_match] = ACTIONS(3111),
    [anon_sym_match_BANG] = ACTIONS(3113),
    [anon_sym_function] = ACTIONS(3111),
    [anon_sym_LT_DASH] = ACTIONS(3111),
    [anon_sym_DOT_LBRACK] = ACTIONS(3113),
    [anon_sym_LT] = ACTIONS(3113),
    [anon_sym_use] = ACTIONS(3111),
    [anon_sym_use_BANG] = ACTIONS(3113),
    [anon_sym_do_BANG] = ACTIONS(3113),
    [anon_sym_begin] = ACTIONS(3111),
    [anon_sym_LPAREN2] = ACTIONS(3111),
    [anon_sym_or] = ACTIONS(3111),
    [aux_sym_char_token1] = ACTIONS(3113),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3111),
    [anon_sym_DQUOTE] = ACTIONS(3111),
    [anon_sym_AT_DQUOTE] = ACTIONS(3113),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3113),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3113),
    [sym_bool] = ACTIONS(3111),
    [sym_unit] = ACTIONS(3113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3111),
    [sym_op_identifier] = ACTIONS(3111),
    [anon_sym_PLUS] = ACTIONS(3111),
    [anon_sym_DASH] = ACTIONS(3111),
    [anon_sym_PLUS_DOT] = ACTIONS(3111),
    [anon_sym_DASH_DOT] = ACTIONS(3111),
    [anon_sym_PERCENT] = ACTIONS(3111),
    [anon_sym_AMP_AMP] = ACTIONS(3111),
    [anon_sym_TILDE] = ACTIONS(3113),
    [aux_sym_prefix_op_token1] = ACTIONS(3111),
    [aux_sym_infix_op_token1] = ACTIONS(3113),
    [aux_sym_infix_op_token2] = ACTIONS(3111),
    [anon_sym_PIPE_PIPE] = ACTIONS(3111),
    [anon_sym_BANG_EQ] = ACTIONS(3111),
    [anon_sym_COLON_EQ] = ACTIONS(3113),
    [anon_sym_DOLLAR] = ACTIONS(3111),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3111),
    [sym_int] = ACTIONS(3111),
    [sym_xint] = ACTIONS(3113),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3113),
    [anon_sym_POUNDendif] = ACTIONS(3113),
    [anon_sym_POUNDelse] = ACTIONS(3113),
    [sym__newline] = ACTIONS(3113),
  },
  [2034] = {
    [sym_block_comment] = STATE(2034),
    [sym_compiler_directive_decl] = STATE(2034),
    [sym_fsi_directive_decl] = STATE(2034),
    [sym_preproc_line] = STATE(2034),
    [sym_identifier] = ACTIONS(3107),
    [anon_sym_EQ] = ACTIONS(3109),
    [anon_sym_COLON] = ACTIONS(3107),
    [anon_sym_return] = ACTIONS(3107),
    [anon_sym_do] = ACTIONS(3107),
    [anon_sym_let] = ACTIONS(3107),
    [anon_sym_let_BANG] = ACTIONS(3109),
    [anon_sym_LPAREN] = ACTIONS(3107),
    [anon_sym_COMMA] = ACTIONS(3109),
    [anon_sym_null] = ACTIONS(3107),
    [anon_sym_QMARK] = ACTIONS(3107),
    [anon_sym_COLON_QMARK] = ACTIONS(3107),
    [anon_sym_COLON_COLON] = ACTIONS(3109),
    [anon_sym_AMP] = ACTIONS(3107),
    [anon_sym_LBRACK] = ACTIONS(3107),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3109),
    [anon_sym_LBRACE] = ACTIONS(3107),
    [anon_sym_LT_AT] = ACTIONS(3107),
    [anon_sym_LT_AT_AT] = ACTIONS(3107),
    [anon_sym_DOT] = ACTIONS(3107),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3109),
    [anon_sym_new] = ACTIONS(3107),
    [anon_sym_return_BANG] = ACTIONS(3109),
    [anon_sym_yield] = ACTIONS(3107),
    [anon_sym_yield_BANG] = ACTIONS(3109),
    [anon_sym_lazy] = ACTIONS(3107),
    [anon_sym_assert] = ACTIONS(3107),
    [anon_sym_upcast] = ACTIONS(3107),
    [anon_sym_downcast] = ACTIONS(3107),
    [anon_sym_COLON_GT] = ACTIONS(3109),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3109),
    [anon_sym_for] = ACTIONS(3107),
    [anon_sym_while] = ACTIONS(3107),
    [anon_sym_if] = ACTIONS(3107),
    [anon_sym_fun] = ACTIONS(3107),
    [anon_sym_try] = ACTIONS(3107),
    [anon_sym_match] = ACTIONS(3107),
    [anon_sym_match_BANG] = ACTIONS(3109),
    [anon_sym_function] = ACTIONS(3107),
    [anon_sym_LT_DASH] = ACTIONS(3107),
    [anon_sym_DOT_LBRACK] = ACTIONS(3109),
    [anon_sym_LT] = ACTIONS(3109),
    [anon_sym_use] = ACTIONS(3107),
    [anon_sym_use_BANG] = ACTIONS(3109),
    [anon_sym_do_BANG] = ACTIONS(3109),
    [anon_sym_begin] = ACTIONS(3107),
    [anon_sym_LPAREN2] = ACTIONS(3107),
    [anon_sym_or] = ACTIONS(3107),
    [aux_sym_char_token1] = ACTIONS(3109),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3107),
    [anon_sym_DQUOTE] = ACTIONS(3107),
    [anon_sym_AT_DQUOTE] = ACTIONS(3109),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3109),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3109),
    [sym_bool] = ACTIONS(3107),
    [sym_unit] = ACTIONS(3109),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3107),
    [sym_op_identifier] = ACTIONS(3107),
    [anon_sym_PLUS] = ACTIONS(3107),
    [anon_sym_DASH] = ACTIONS(3107),
    [anon_sym_PLUS_DOT] = ACTIONS(3107),
    [anon_sym_DASH_DOT] = ACTIONS(3107),
    [anon_sym_PERCENT] = ACTIONS(3107),
    [anon_sym_AMP_AMP] = ACTIONS(3107),
    [anon_sym_TILDE] = ACTIONS(3109),
    [aux_sym_prefix_op_token1] = ACTIONS(3107),
    [aux_sym_infix_op_token1] = ACTIONS(3109),
    [aux_sym_infix_op_token2] = ACTIONS(3107),
    [anon_sym_PIPE_PIPE] = ACTIONS(3107),
    [anon_sym_BANG_EQ] = ACTIONS(3107),
    [anon_sym_COLON_EQ] = ACTIONS(3109),
    [anon_sym_DOLLAR] = ACTIONS(3107),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3107),
    [sym_int] = ACTIONS(3107),
    [sym_xint] = ACTIONS(3109),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3109),
    [anon_sym_POUNDendif] = ACTIONS(3109),
    [anon_sym_POUNDelse] = ACTIONS(3109),
    [sym__newline] = ACTIONS(3109),
  },
  [2035] = {
    [sym_block_comment] = STATE(2035),
    [sym_compiler_directive_decl] = STATE(2035),
    [sym_fsi_directive_decl] = STATE(2035),
    [sym_preproc_line] = STATE(2035),
    [sym_identifier] = ACTIONS(3103),
    [anon_sym_EQ] = ACTIONS(3105),
    [anon_sym_COLON] = ACTIONS(3103),
    [anon_sym_return] = ACTIONS(3103),
    [anon_sym_do] = ACTIONS(3103),
    [anon_sym_let] = ACTIONS(3103),
    [anon_sym_let_BANG] = ACTIONS(3105),
    [anon_sym_LPAREN] = ACTIONS(3103),
    [anon_sym_COMMA] = ACTIONS(3105),
    [anon_sym_null] = ACTIONS(3103),
    [anon_sym_QMARK] = ACTIONS(3103),
    [anon_sym_COLON_QMARK] = ACTIONS(3103),
    [anon_sym_COLON_COLON] = ACTIONS(3105),
    [anon_sym_AMP] = ACTIONS(3103),
    [anon_sym_LBRACK] = ACTIONS(3103),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3105),
    [anon_sym_LBRACE] = ACTIONS(3103),
    [anon_sym_LT_AT] = ACTIONS(3103),
    [anon_sym_LT_AT_AT] = ACTIONS(3103),
    [anon_sym_DOT] = ACTIONS(3103),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3105),
    [anon_sym_new] = ACTIONS(3103),
    [anon_sym_return_BANG] = ACTIONS(3105),
    [anon_sym_yield] = ACTIONS(3103),
    [anon_sym_yield_BANG] = ACTIONS(3105),
    [anon_sym_lazy] = ACTIONS(3103),
    [anon_sym_assert] = ACTIONS(3103),
    [anon_sym_upcast] = ACTIONS(3103),
    [anon_sym_downcast] = ACTIONS(3103),
    [anon_sym_COLON_GT] = ACTIONS(3105),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3105),
    [anon_sym_for] = ACTIONS(3103),
    [anon_sym_while] = ACTIONS(3103),
    [anon_sym_if] = ACTIONS(3103),
    [anon_sym_fun] = ACTIONS(3103),
    [anon_sym_try] = ACTIONS(3103),
    [anon_sym_match] = ACTIONS(3103),
    [anon_sym_match_BANG] = ACTIONS(3105),
    [anon_sym_function] = ACTIONS(3103),
    [anon_sym_LT_DASH] = ACTIONS(3103),
    [anon_sym_DOT_LBRACK] = ACTIONS(3105),
    [anon_sym_LT] = ACTIONS(3105),
    [anon_sym_use] = ACTIONS(3103),
    [anon_sym_use_BANG] = ACTIONS(3105),
    [anon_sym_do_BANG] = ACTIONS(3105),
    [anon_sym_begin] = ACTIONS(3103),
    [anon_sym_LPAREN2] = ACTIONS(3103),
    [anon_sym_or] = ACTIONS(3103),
    [aux_sym_char_token1] = ACTIONS(3105),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3103),
    [anon_sym_DQUOTE] = ACTIONS(3103),
    [anon_sym_AT_DQUOTE] = ACTIONS(3105),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3105),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3105),
    [sym_bool] = ACTIONS(3103),
    [sym_unit] = ACTIONS(3105),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3103),
    [sym_op_identifier] = ACTIONS(3103),
    [anon_sym_PLUS] = ACTIONS(3103),
    [anon_sym_DASH] = ACTIONS(3103),
    [anon_sym_PLUS_DOT] = ACTIONS(3103),
    [anon_sym_DASH_DOT] = ACTIONS(3103),
    [anon_sym_PERCENT] = ACTIONS(3103),
    [anon_sym_AMP_AMP] = ACTIONS(3103),
    [anon_sym_TILDE] = ACTIONS(3105),
    [aux_sym_prefix_op_token1] = ACTIONS(3103),
    [aux_sym_infix_op_token1] = ACTIONS(3105),
    [aux_sym_infix_op_token2] = ACTIONS(3103),
    [anon_sym_PIPE_PIPE] = ACTIONS(3103),
    [anon_sym_BANG_EQ] = ACTIONS(3103),
    [anon_sym_COLON_EQ] = ACTIONS(3105),
    [anon_sym_DOLLAR] = ACTIONS(3103),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3103),
    [sym_int] = ACTIONS(3103),
    [sym_xint] = ACTIONS(3105),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3105),
    [anon_sym_POUNDendif] = ACTIONS(3105),
    [anon_sym_POUNDelse] = ACTIONS(3105),
    [sym__newline] = ACTIONS(3105),
  },
  [2036] = {
    [sym_block_comment] = STATE(2036),
    [sym_compiler_directive_decl] = STATE(2036),
    [sym_fsi_directive_decl] = STATE(2036),
    [sym_preproc_line] = STATE(2036),
    [sym_identifier] = ACTIONS(2883),
    [anon_sym_EQ] = ACTIONS(2885),
    [anon_sym_COLON] = ACTIONS(2883),
    [anon_sym_return] = ACTIONS(2883),
    [anon_sym_do] = ACTIONS(2883),
    [anon_sym_and] = ACTIONS(2883),
    [anon_sym_let] = ACTIONS(2883),
    [anon_sym_let_BANG] = ACTIONS(2885),
    [anon_sym_LPAREN] = ACTIONS(2883),
    [anon_sym_COMMA] = ACTIONS(2885),
    [anon_sym_null] = ACTIONS(2883),
    [anon_sym_QMARK] = ACTIONS(2883),
    [anon_sym_COLON_QMARK] = ACTIONS(2883),
    [anon_sym_COLON_COLON] = ACTIONS(2885),
    [anon_sym_AMP] = ACTIONS(2883),
    [anon_sym_LBRACK] = ACTIONS(2883),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2885),
    [anon_sym_LBRACE] = ACTIONS(2883),
    [anon_sym_LT_AT] = ACTIONS(2883),
    [anon_sym_LT_AT_AT] = ACTIONS(2883),
    [anon_sym_DOT] = ACTIONS(2883),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2885),
    [anon_sym_new] = ACTIONS(2883),
    [anon_sym_return_BANG] = ACTIONS(2885),
    [anon_sym_yield] = ACTIONS(2883),
    [anon_sym_yield_BANG] = ACTIONS(2885),
    [anon_sym_lazy] = ACTIONS(2883),
    [anon_sym_assert] = ACTIONS(2883),
    [anon_sym_upcast] = ACTIONS(2883),
    [anon_sym_downcast] = ACTIONS(2883),
    [anon_sym_COLON_GT] = ACTIONS(2885),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2885),
    [anon_sym_for] = ACTIONS(2883),
    [anon_sym_while] = ACTIONS(2883),
    [anon_sym_if] = ACTIONS(2883),
    [anon_sym_fun] = ACTIONS(2883),
    [anon_sym_try] = ACTIONS(2883),
    [anon_sym_match] = ACTIONS(2883),
    [anon_sym_match_BANG] = ACTIONS(2885),
    [anon_sym_function] = ACTIONS(2883),
    [anon_sym_LT_DASH] = ACTIONS(2883),
    [anon_sym_DOT_LBRACK] = ACTIONS(2885),
    [anon_sym_LT] = ACTIONS(2885),
    [anon_sym_use] = ACTIONS(2883),
    [anon_sym_use_BANG] = ACTIONS(2885),
    [anon_sym_do_BANG] = ACTIONS(2885),
    [anon_sym_begin] = ACTIONS(2883),
    [anon_sym_LPAREN2] = ACTIONS(2883),
    [anon_sym_or] = ACTIONS(2883),
    [aux_sym_char_token1] = ACTIONS(2885),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2883),
    [anon_sym_DQUOTE] = ACTIONS(2883),
    [anon_sym_AT_DQUOTE] = ACTIONS(2885),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2885),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2885),
    [sym_bool] = ACTIONS(2883),
    [sym_unit] = ACTIONS(2885),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2883),
    [sym_op_identifier] = ACTIONS(2883),
    [anon_sym_PLUS] = ACTIONS(2883),
    [anon_sym_DASH] = ACTIONS(2883),
    [anon_sym_PLUS_DOT] = ACTIONS(2883),
    [anon_sym_DASH_DOT] = ACTIONS(2883),
    [anon_sym_PERCENT] = ACTIONS(2883),
    [anon_sym_AMP_AMP] = ACTIONS(2883),
    [anon_sym_TILDE] = ACTIONS(2885),
    [aux_sym_prefix_op_token1] = ACTIONS(2883),
    [aux_sym_infix_op_token1] = ACTIONS(2885),
    [aux_sym_infix_op_token2] = ACTIONS(2883),
    [anon_sym_PIPE_PIPE] = ACTIONS(2883),
    [anon_sym_BANG_EQ] = ACTIONS(2883),
    [anon_sym_COLON_EQ] = ACTIONS(2885),
    [anon_sym_DOLLAR] = ACTIONS(2883),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2883),
    [sym_int] = ACTIONS(2883),
    [sym_xint] = ACTIONS(2885),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2885),
    [sym__newline] = ACTIONS(2885),
    [sym__dedent] = ACTIONS(2885),
  },
  [2037] = {
    [sym_block_comment] = STATE(2037),
    [sym_compiler_directive_decl] = STATE(2037),
    [sym_fsi_directive_decl] = STATE(2037),
    [sym_preproc_line] = STATE(2037),
    [sym_identifier] = ACTIONS(2887),
    [anon_sym_EQ] = ACTIONS(2889),
    [anon_sym_COLON] = ACTIONS(2887),
    [anon_sym_return] = ACTIONS(2887),
    [anon_sym_do] = ACTIONS(2887),
    [anon_sym_and] = ACTIONS(2887),
    [anon_sym_let] = ACTIONS(2887),
    [anon_sym_let_BANG] = ACTIONS(2889),
    [anon_sym_LPAREN] = ACTIONS(2887),
    [anon_sym_COMMA] = ACTIONS(2889),
    [anon_sym_null] = ACTIONS(2887),
    [anon_sym_QMARK] = ACTIONS(2887),
    [anon_sym_COLON_QMARK] = ACTIONS(2887),
    [anon_sym_COLON_COLON] = ACTIONS(2889),
    [anon_sym_AMP] = ACTIONS(2887),
    [anon_sym_LBRACK] = ACTIONS(2887),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2889),
    [anon_sym_LBRACE] = ACTIONS(2887),
    [anon_sym_LT_AT] = ACTIONS(2887),
    [anon_sym_LT_AT_AT] = ACTIONS(2887),
    [anon_sym_DOT] = ACTIONS(2887),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2889),
    [anon_sym_new] = ACTIONS(2887),
    [anon_sym_return_BANG] = ACTIONS(2889),
    [anon_sym_yield] = ACTIONS(2887),
    [anon_sym_yield_BANG] = ACTIONS(2889),
    [anon_sym_lazy] = ACTIONS(2887),
    [anon_sym_assert] = ACTIONS(2887),
    [anon_sym_upcast] = ACTIONS(2887),
    [anon_sym_downcast] = ACTIONS(2887),
    [anon_sym_COLON_GT] = ACTIONS(2889),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2889),
    [anon_sym_for] = ACTIONS(2887),
    [anon_sym_while] = ACTIONS(2887),
    [anon_sym_if] = ACTIONS(2887),
    [anon_sym_fun] = ACTIONS(2887),
    [anon_sym_try] = ACTIONS(2887),
    [anon_sym_match] = ACTIONS(2887),
    [anon_sym_match_BANG] = ACTIONS(2889),
    [anon_sym_function] = ACTIONS(2887),
    [anon_sym_LT_DASH] = ACTIONS(2887),
    [anon_sym_DOT_LBRACK] = ACTIONS(2889),
    [anon_sym_LT] = ACTIONS(2889),
    [anon_sym_use] = ACTIONS(2887),
    [anon_sym_use_BANG] = ACTIONS(2889),
    [anon_sym_do_BANG] = ACTIONS(2889),
    [anon_sym_begin] = ACTIONS(2887),
    [anon_sym_LPAREN2] = ACTIONS(2887),
    [anon_sym_or] = ACTIONS(2887),
    [aux_sym_char_token1] = ACTIONS(2889),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2887),
    [anon_sym_DQUOTE] = ACTIONS(2887),
    [anon_sym_AT_DQUOTE] = ACTIONS(2889),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2889),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2889),
    [sym_bool] = ACTIONS(2887),
    [sym_unit] = ACTIONS(2889),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2887),
    [sym_op_identifier] = ACTIONS(2887),
    [anon_sym_PLUS] = ACTIONS(2887),
    [anon_sym_DASH] = ACTIONS(2887),
    [anon_sym_PLUS_DOT] = ACTIONS(2887),
    [anon_sym_DASH_DOT] = ACTIONS(2887),
    [anon_sym_PERCENT] = ACTIONS(2887),
    [anon_sym_AMP_AMP] = ACTIONS(2887),
    [anon_sym_TILDE] = ACTIONS(2889),
    [aux_sym_prefix_op_token1] = ACTIONS(2887),
    [aux_sym_infix_op_token1] = ACTIONS(2889),
    [aux_sym_infix_op_token2] = ACTIONS(2887),
    [anon_sym_PIPE_PIPE] = ACTIONS(2887),
    [anon_sym_BANG_EQ] = ACTIONS(2887),
    [anon_sym_COLON_EQ] = ACTIONS(2889),
    [anon_sym_DOLLAR] = ACTIONS(2887),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2887),
    [sym_int] = ACTIONS(2887),
    [sym_xint] = ACTIONS(2889),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2889),
    [sym__newline] = ACTIONS(2889),
    [sym__dedent] = ACTIONS(2889),
  },
  [2038] = {
    [sym_block_comment] = STATE(2038),
    [sym_compiler_directive_decl] = STATE(2038),
    [sym_fsi_directive_decl] = STATE(2038),
    [sym_preproc_line] = STATE(2038),
    [sym_identifier] = ACTIONS(3099),
    [anon_sym_EQ] = ACTIONS(3101),
    [anon_sym_COLON] = ACTIONS(3099),
    [anon_sym_return] = ACTIONS(3099),
    [anon_sym_do] = ACTIONS(3099),
    [anon_sym_let] = ACTIONS(3099),
    [anon_sym_let_BANG] = ACTIONS(3101),
    [anon_sym_LPAREN] = ACTIONS(3099),
    [anon_sym_COMMA] = ACTIONS(3101),
    [anon_sym_null] = ACTIONS(3099),
    [anon_sym_QMARK] = ACTIONS(3099),
    [anon_sym_COLON_QMARK] = ACTIONS(3099),
    [anon_sym_COLON_COLON] = ACTIONS(3101),
    [anon_sym_AMP] = ACTIONS(3099),
    [anon_sym_LBRACK] = ACTIONS(3099),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3101),
    [anon_sym_LBRACE] = ACTIONS(3099),
    [anon_sym_LT_AT] = ACTIONS(3099),
    [anon_sym_LT_AT_AT] = ACTIONS(3099),
    [anon_sym_DOT] = ACTIONS(3099),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3101),
    [anon_sym_new] = ACTIONS(3099),
    [anon_sym_return_BANG] = ACTIONS(3101),
    [anon_sym_yield] = ACTIONS(3099),
    [anon_sym_yield_BANG] = ACTIONS(3101),
    [anon_sym_lazy] = ACTIONS(3099),
    [anon_sym_assert] = ACTIONS(3099),
    [anon_sym_upcast] = ACTIONS(3099),
    [anon_sym_downcast] = ACTIONS(3099),
    [anon_sym_COLON_GT] = ACTIONS(3101),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3101),
    [anon_sym_for] = ACTIONS(3099),
    [anon_sym_while] = ACTIONS(3099),
    [anon_sym_if] = ACTIONS(3099),
    [anon_sym_fun] = ACTIONS(3099),
    [anon_sym_try] = ACTIONS(3099),
    [anon_sym_match] = ACTIONS(3099),
    [anon_sym_match_BANG] = ACTIONS(3101),
    [anon_sym_function] = ACTIONS(3099),
    [anon_sym_LT_DASH] = ACTIONS(3099),
    [anon_sym_DOT_LBRACK] = ACTIONS(3101),
    [anon_sym_LT] = ACTIONS(3101),
    [anon_sym_use] = ACTIONS(3099),
    [anon_sym_use_BANG] = ACTIONS(3101),
    [anon_sym_do_BANG] = ACTIONS(3101),
    [anon_sym_begin] = ACTIONS(3099),
    [anon_sym_LPAREN2] = ACTIONS(3099),
    [anon_sym_or] = ACTIONS(3099),
    [aux_sym_char_token1] = ACTIONS(3101),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3099),
    [anon_sym_DQUOTE] = ACTIONS(3099),
    [anon_sym_AT_DQUOTE] = ACTIONS(3101),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3101),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3101),
    [sym_bool] = ACTIONS(3099),
    [sym_unit] = ACTIONS(3101),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3099),
    [sym_op_identifier] = ACTIONS(3099),
    [anon_sym_PLUS] = ACTIONS(3099),
    [anon_sym_DASH] = ACTIONS(3099),
    [anon_sym_PLUS_DOT] = ACTIONS(3099),
    [anon_sym_DASH_DOT] = ACTIONS(3099),
    [anon_sym_PERCENT] = ACTIONS(3099),
    [anon_sym_AMP_AMP] = ACTIONS(3099),
    [anon_sym_TILDE] = ACTIONS(3101),
    [aux_sym_prefix_op_token1] = ACTIONS(3099),
    [aux_sym_infix_op_token1] = ACTIONS(3101),
    [aux_sym_infix_op_token2] = ACTIONS(3099),
    [anon_sym_PIPE_PIPE] = ACTIONS(3099),
    [anon_sym_BANG_EQ] = ACTIONS(3099),
    [anon_sym_COLON_EQ] = ACTIONS(3101),
    [anon_sym_DOLLAR] = ACTIONS(3099),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3099),
    [sym_int] = ACTIONS(3099),
    [sym_xint] = ACTIONS(3101),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3101),
    [anon_sym_POUNDendif] = ACTIONS(3101),
    [anon_sym_POUNDelse] = ACTIONS(3101),
    [sym__newline] = ACTIONS(3101),
  },
  [2039] = {
    [sym_block_comment] = STATE(2039),
    [sym_compiler_directive_decl] = STATE(2039),
    [sym_fsi_directive_decl] = STATE(2039),
    [sym_preproc_line] = STATE(2039),
    [sym_identifier] = ACTIONS(3083),
    [anon_sym_EQ] = ACTIONS(3085),
    [anon_sym_COLON] = ACTIONS(3083),
    [anon_sym_return] = ACTIONS(3083),
    [anon_sym_do] = ACTIONS(3083),
    [anon_sym_let] = ACTIONS(3083),
    [anon_sym_let_BANG] = ACTIONS(3085),
    [anon_sym_LPAREN] = ACTIONS(3083),
    [anon_sym_COMMA] = ACTIONS(3085),
    [anon_sym_null] = ACTIONS(3083),
    [anon_sym_QMARK] = ACTIONS(3083),
    [anon_sym_COLON_QMARK] = ACTIONS(3083),
    [anon_sym_COLON_COLON] = ACTIONS(3085),
    [anon_sym_AMP] = ACTIONS(3083),
    [anon_sym_LBRACK] = ACTIONS(3083),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3085),
    [anon_sym_LBRACE] = ACTIONS(3083),
    [anon_sym_LT_AT] = ACTIONS(3083),
    [anon_sym_LT_AT_AT] = ACTIONS(3083),
    [anon_sym_DOT] = ACTIONS(3083),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3085),
    [anon_sym_new] = ACTIONS(3083),
    [anon_sym_return_BANG] = ACTIONS(3085),
    [anon_sym_yield] = ACTIONS(3083),
    [anon_sym_yield_BANG] = ACTIONS(3085),
    [anon_sym_lazy] = ACTIONS(3083),
    [anon_sym_assert] = ACTIONS(3083),
    [anon_sym_upcast] = ACTIONS(3083),
    [anon_sym_downcast] = ACTIONS(3083),
    [anon_sym_COLON_GT] = ACTIONS(3085),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3085),
    [anon_sym_for] = ACTIONS(3083),
    [anon_sym_while] = ACTIONS(3083),
    [anon_sym_if] = ACTIONS(3083),
    [anon_sym_fun] = ACTIONS(3083),
    [anon_sym_try] = ACTIONS(3083),
    [anon_sym_match] = ACTIONS(3083),
    [anon_sym_match_BANG] = ACTIONS(3085),
    [anon_sym_function] = ACTIONS(3083),
    [anon_sym_LT_DASH] = ACTIONS(3083),
    [anon_sym_DOT_LBRACK] = ACTIONS(3085),
    [anon_sym_LT] = ACTIONS(3085),
    [anon_sym_use] = ACTIONS(3083),
    [anon_sym_use_BANG] = ACTIONS(3085),
    [anon_sym_do_BANG] = ACTIONS(3085),
    [anon_sym_begin] = ACTIONS(3083),
    [anon_sym_LPAREN2] = ACTIONS(3083),
    [anon_sym_or] = ACTIONS(3083),
    [aux_sym_char_token1] = ACTIONS(3085),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3083),
    [anon_sym_DQUOTE] = ACTIONS(3083),
    [anon_sym_AT_DQUOTE] = ACTIONS(3085),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3085),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3085),
    [sym_bool] = ACTIONS(3083),
    [sym_unit] = ACTIONS(3085),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3083),
    [sym_op_identifier] = ACTIONS(3083),
    [anon_sym_PLUS] = ACTIONS(3083),
    [anon_sym_DASH] = ACTIONS(3083),
    [anon_sym_PLUS_DOT] = ACTIONS(3083),
    [anon_sym_DASH_DOT] = ACTIONS(3083),
    [anon_sym_PERCENT] = ACTIONS(3083),
    [anon_sym_AMP_AMP] = ACTIONS(3083),
    [anon_sym_TILDE] = ACTIONS(3085),
    [aux_sym_prefix_op_token1] = ACTIONS(3083),
    [aux_sym_infix_op_token1] = ACTIONS(3085),
    [aux_sym_infix_op_token2] = ACTIONS(3083),
    [anon_sym_PIPE_PIPE] = ACTIONS(3083),
    [anon_sym_BANG_EQ] = ACTIONS(3083),
    [anon_sym_COLON_EQ] = ACTIONS(3085),
    [anon_sym_DOLLAR] = ACTIONS(3083),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3083),
    [sym_int] = ACTIONS(3083),
    [sym_xint] = ACTIONS(3085),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3085),
    [anon_sym_POUNDendif] = ACTIONS(3085),
    [anon_sym_POUNDelse] = ACTIONS(3085),
    [sym__newline] = ACTIONS(3085),
  },
  [2040] = {
    [sym_block_comment] = STATE(2040),
    [sym_compiler_directive_decl] = STATE(2040),
    [sym_fsi_directive_decl] = STATE(2040),
    [sym_preproc_line] = STATE(2040),
    [sym_identifier] = ACTIONS(3079),
    [anon_sym_EQ] = ACTIONS(3081),
    [anon_sym_COLON] = ACTIONS(3079),
    [anon_sym_return] = ACTIONS(3079),
    [anon_sym_do] = ACTIONS(3079),
    [anon_sym_let] = ACTIONS(3079),
    [anon_sym_let_BANG] = ACTIONS(3081),
    [anon_sym_LPAREN] = ACTIONS(3079),
    [anon_sym_COMMA] = ACTIONS(3081),
    [anon_sym_null] = ACTIONS(3079),
    [anon_sym_QMARK] = ACTIONS(3079),
    [anon_sym_COLON_QMARK] = ACTIONS(3079),
    [anon_sym_COLON_COLON] = ACTIONS(3081),
    [anon_sym_AMP] = ACTIONS(3079),
    [anon_sym_LBRACK] = ACTIONS(3079),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3081),
    [anon_sym_LBRACE] = ACTIONS(3079),
    [anon_sym_LT_AT] = ACTIONS(3079),
    [anon_sym_LT_AT_AT] = ACTIONS(3079),
    [anon_sym_DOT] = ACTIONS(3079),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3081),
    [anon_sym_new] = ACTIONS(3079),
    [anon_sym_return_BANG] = ACTIONS(3081),
    [anon_sym_yield] = ACTIONS(3079),
    [anon_sym_yield_BANG] = ACTIONS(3081),
    [anon_sym_lazy] = ACTIONS(3079),
    [anon_sym_assert] = ACTIONS(3079),
    [anon_sym_upcast] = ACTIONS(3079),
    [anon_sym_downcast] = ACTIONS(3079),
    [anon_sym_COLON_GT] = ACTIONS(3081),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3081),
    [anon_sym_for] = ACTIONS(3079),
    [anon_sym_while] = ACTIONS(3079),
    [anon_sym_if] = ACTIONS(3079),
    [anon_sym_fun] = ACTIONS(3079),
    [anon_sym_try] = ACTIONS(3079),
    [anon_sym_match] = ACTIONS(3079),
    [anon_sym_match_BANG] = ACTIONS(3081),
    [anon_sym_function] = ACTIONS(3079),
    [anon_sym_LT_DASH] = ACTIONS(3079),
    [anon_sym_DOT_LBRACK] = ACTIONS(3081),
    [anon_sym_LT] = ACTIONS(3081),
    [anon_sym_use] = ACTIONS(3079),
    [anon_sym_use_BANG] = ACTIONS(3081),
    [anon_sym_do_BANG] = ACTIONS(3081),
    [anon_sym_begin] = ACTIONS(3079),
    [anon_sym_LPAREN2] = ACTIONS(3079),
    [anon_sym_or] = ACTIONS(3079),
    [aux_sym_char_token1] = ACTIONS(3081),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3079),
    [anon_sym_DQUOTE] = ACTIONS(3079),
    [anon_sym_AT_DQUOTE] = ACTIONS(3081),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3081),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3081),
    [sym_bool] = ACTIONS(3079),
    [sym_unit] = ACTIONS(3081),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3079),
    [sym_op_identifier] = ACTIONS(3079),
    [anon_sym_PLUS] = ACTIONS(3079),
    [anon_sym_DASH] = ACTIONS(3079),
    [anon_sym_PLUS_DOT] = ACTIONS(3079),
    [anon_sym_DASH_DOT] = ACTIONS(3079),
    [anon_sym_PERCENT] = ACTIONS(3079),
    [anon_sym_AMP_AMP] = ACTIONS(3079),
    [anon_sym_TILDE] = ACTIONS(3081),
    [aux_sym_prefix_op_token1] = ACTIONS(3079),
    [aux_sym_infix_op_token1] = ACTIONS(3081),
    [aux_sym_infix_op_token2] = ACTIONS(3079),
    [anon_sym_PIPE_PIPE] = ACTIONS(3079),
    [anon_sym_BANG_EQ] = ACTIONS(3079),
    [anon_sym_COLON_EQ] = ACTIONS(3081),
    [anon_sym_DOLLAR] = ACTIONS(3079),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3079),
    [sym_int] = ACTIONS(3079),
    [sym_xint] = ACTIONS(3081),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3081),
    [anon_sym_POUNDendif] = ACTIONS(3081),
    [anon_sym_POUNDelse] = ACTIONS(3081),
    [sym__newline] = ACTIONS(3081),
  },
  [2041] = {
    [sym_block_comment] = STATE(2041),
    [sym_compiler_directive_decl] = STATE(2041),
    [sym_fsi_directive_decl] = STATE(2041),
    [sym_preproc_line] = STATE(2041),
    [sym_identifier] = ACTIONS(3063),
    [anon_sym_EQ] = ACTIONS(3065),
    [anon_sym_COLON] = ACTIONS(3063),
    [anon_sym_return] = ACTIONS(3063),
    [anon_sym_do] = ACTIONS(3063),
    [anon_sym_let] = ACTIONS(3063),
    [anon_sym_let_BANG] = ACTIONS(3065),
    [anon_sym_LPAREN] = ACTIONS(3063),
    [anon_sym_COMMA] = ACTIONS(3065),
    [anon_sym_null] = ACTIONS(3063),
    [anon_sym_QMARK] = ACTIONS(3063),
    [anon_sym_COLON_QMARK] = ACTIONS(3063),
    [anon_sym_COLON_COLON] = ACTIONS(3065),
    [anon_sym_AMP] = ACTIONS(3063),
    [anon_sym_LBRACK] = ACTIONS(3063),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3065),
    [anon_sym_LBRACE] = ACTIONS(3063),
    [anon_sym_LT_AT] = ACTIONS(3063),
    [anon_sym_LT_AT_AT] = ACTIONS(3063),
    [anon_sym_DOT] = ACTIONS(3063),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3065),
    [anon_sym_new] = ACTIONS(3063),
    [anon_sym_return_BANG] = ACTIONS(3065),
    [anon_sym_yield] = ACTIONS(3063),
    [anon_sym_yield_BANG] = ACTIONS(3065),
    [anon_sym_lazy] = ACTIONS(3063),
    [anon_sym_assert] = ACTIONS(3063),
    [anon_sym_upcast] = ACTIONS(3063),
    [anon_sym_downcast] = ACTIONS(3063),
    [anon_sym_COLON_GT] = ACTIONS(3065),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3065),
    [anon_sym_for] = ACTIONS(3063),
    [anon_sym_while] = ACTIONS(3063),
    [anon_sym_if] = ACTIONS(3063),
    [anon_sym_fun] = ACTIONS(3063),
    [anon_sym_try] = ACTIONS(3063),
    [anon_sym_match] = ACTIONS(3063),
    [anon_sym_match_BANG] = ACTIONS(3065),
    [anon_sym_function] = ACTIONS(3063),
    [anon_sym_LT_DASH] = ACTIONS(3063),
    [anon_sym_DOT_LBRACK] = ACTIONS(3065),
    [anon_sym_LT] = ACTIONS(3065),
    [anon_sym_use] = ACTIONS(3063),
    [anon_sym_use_BANG] = ACTIONS(3065),
    [anon_sym_do_BANG] = ACTIONS(3065),
    [anon_sym_begin] = ACTIONS(3063),
    [anon_sym_LPAREN2] = ACTIONS(3063),
    [anon_sym_or] = ACTIONS(3063),
    [aux_sym_char_token1] = ACTIONS(3065),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3063),
    [anon_sym_DQUOTE] = ACTIONS(3063),
    [anon_sym_AT_DQUOTE] = ACTIONS(3065),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3065),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3065),
    [sym_bool] = ACTIONS(3063),
    [sym_unit] = ACTIONS(3065),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3063),
    [sym_op_identifier] = ACTIONS(3063),
    [anon_sym_PLUS] = ACTIONS(3063),
    [anon_sym_DASH] = ACTIONS(3063),
    [anon_sym_PLUS_DOT] = ACTIONS(3063),
    [anon_sym_DASH_DOT] = ACTIONS(3063),
    [anon_sym_PERCENT] = ACTIONS(3063),
    [anon_sym_AMP_AMP] = ACTIONS(3063),
    [anon_sym_TILDE] = ACTIONS(3065),
    [aux_sym_prefix_op_token1] = ACTIONS(3063),
    [aux_sym_infix_op_token1] = ACTIONS(3065),
    [aux_sym_infix_op_token2] = ACTIONS(3063),
    [anon_sym_PIPE_PIPE] = ACTIONS(3063),
    [anon_sym_BANG_EQ] = ACTIONS(3063),
    [anon_sym_COLON_EQ] = ACTIONS(3065),
    [anon_sym_DOLLAR] = ACTIONS(3063),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3063),
    [sym_int] = ACTIONS(3063),
    [sym_xint] = ACTIONS(3065),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3065),
    [anon_sym_POUNDendif] = ACTIONS(3065),
    [anon_sym_POUNDelse] = ACTIONS(3065),
    [sym__newline] = ACTIONS(3065),
  },
  [2042] = {
    [sym_block_comment] = STATE(2042),
    [sym_compiler_directive_decl] = STATE(2042),
    [sym_fsi_directive_decl] = STATE(2042),
    [sym_preproc_line] = STATE(2042),
    [sym_identifier] = ACTIONS(3059),
    [anon_sym_EQ] = ACTIONS(3061),
    [anon_sym_COLON] = ACTIONS(3059),
    [anon_sym_return] = ACTIONS(3059),
    [anon_sym_do] = ACTIONS(3059),
    [anon_sym_let] = ACTIONS(3059),
    [anon_sym_let_BANG] = ACTIONS(3061),
    [anon_sym_LPAREN] = ACTIONS(3059),
    [anon_sym_COMMA] = ACTIONS(3061),
    [anon_sym_null] = ACTIONS(3059),
    [anon_sym_QMARK] = ACTIONS(3059),
    [anon_sym_COLON_QMARK] = ACTIONS(3059),
    [anon_sym_COLON_COLON] = ACTIONS(3061),
    [anon_sym_AMP] = ACTIONS(3059),
    [anon_sym_LBRACK] = ACTIONS(3059),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3061),
    [anon_sym_LBRACE] = ACTIONS(3059),
    [anon_sym_LT_AT] = ACTIONS(3059),
    [anon_sym_LT_AT_AT] = ACTIONS(3059),
    [anon_sym_DOT] = ACTIONS(3059),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3061),
    [anon_sym_new] = ACTIONS(3059),
    [anon_sym_return_BANG] = ACTIONS(3061),
    [anon_sym_yield] = ACTIONS(3059),
    [anon_sym_yield_BANG] = ACTIONS(3061),
    [anon_sym_lazy] = ACTIONS(3059),
    [anon_sym_assert] = ACTIONS(3059),
    [anon_sym_upcast] = ACTIONS(3059),
    [anon_sym_downcast] = ACTIONS(3059),
    [anon_sym_COLON_GT] = ACTIONS(3061),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3061),
    [anon_sym_for] = ACTIONS(3059),
    [anon_sym_while] = ACTIONS(3059),
    [anon_sym_if] = ACTIONS(3059),
    [anon_sym_fun] = ACTIONS(3059),
    [anon_sym_try] = ACTIONS(3059),
    [anon_sym_match] = ACTIONS(3059),
    [anon_sym_match_BANG] = ACTIONS(3061),
    [anon_sym_function] = ACTIONS(3059),
    [anon_sym_LT_DASH] = ACTIONS(3059),
    [anon_sym_DOT_LBRACK] = ACTIONS(3061),
    [anon_sym_LT] = ACTIONS(3061),
    [anon_sym_use] = ACTIONS(3059),
    [anon_sym_use_BANG] = ACTIONS(3061),
    [anon_sym_do_BANG] = ACTIONS(3061),
    [anon_sym_begin] = ACTIONS(3059),
    [anon_sym_LPAREN2] = ACTIONS(3059),
    [anon_sym_or] = ACTIONS(3059),
    [aux_sym_char_token1] = ACTIONS(3061),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3059),
    [anon_sym_DQUOTE] = ACTIONS(3059),
    [anon_sym_AT_DQUOTE] = ACTIONS(3061),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3061),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3061),
    [sym_bool] = ACTIONS(3059),
    [sym_unit] = ACTIONS(3061),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3059),
    [sym_op_identifier] = ACTIONS(3059),
    [anon_sym_PLUS] = ACTIONS(3059),
    [anon_sym_DASH] = ACTIONS(3059),
    [anon_sym_PLUS_DOT] = ACTIONS(3059),
    [anon_sym_DASH_DOT] = ACTIONS(3059),
    [anon_sym_PERCENT] = ACTIONS(3059),
    [anon_sym_AMP_AMP] = ACTIONS(3059),
    [anon_sym_TILDE] = ACTIONS(3061),
    [aux_sym_prefix_op_token1] = ACTIONS(3059),
    [aux_sym_infix_op_token1] = ACTIONS(3061),
    [aux_sym_infix_op_token2] = ACTIONS(3059),
    [anon_sym_PIPE_PIPE] = ACTIONS(3059),
    [anon_sym_BANG_EQ] = ACTIONS(3059),
    [anon_sym_COLON_EQ] = ACTIONS(3061),
    [anon_sym_DOLLAR] = ACTIONS(3059),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3059),
    [sym_int] = ACTIONS(3059),
    [sym_xint] = ACTIONS(3061),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3061),
    [anon_sym_POUNDendif] = ACTIONS(3061),
    [anon_sym_POUNDelse] = ACTIONS(3061),
    [sym__newline] = ACTIONS(3061),
  },
  [2043] = {
    [sym_block_comment] = STATE(2043),
    [sym_compiler_directive_decl] = STATE(2043),
    [sym_fsi_directive_decl] = STATE(2043),
    [sym_preproc_line] = STATE(2043),
    [sym_identifier] = ACTIONS(3051),
    [anon_sym_EQ] = ACTIONS(3053),
    [anon_sym_COLON] = ACTIONS(3051),
    [anon_sym_return] = ACTIONS(3051),
    [anon_sym_do] = ACTIONS(3051),
    [anon_sym_let] = ACTIONS(3051),
    [anon_sym_let_BANG] = ACTIONS(3053),
    [anon_sym_LPAREN] = ACTIONS(3051),
    [anon_sym_COMMA] = ACTIONS(3053),
    [anon_sym_null] = ACTIONS(3051),
    [anon_sym_QMARK] = ACTIONS(3051),
    [anon_sym_COLON_QMARK] = ACTIONS(3051),
    [anon_sym_COLON_COLON] = ACTIONS(3053),
    [anon_sym_AMP] = ACTIONS(3051),
    [anon_sym_LBRACK] = ACTIONS(3051),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3053),
    [anon_sym_LBRACE] = ACTIONS(3051),
    [anon_sym_LT_AT] = ACTIONS(3051),
    [anon_sym_LT_AT_AT] = ACTIONS(3051),
    [anon_sym_DOT] = ACTIONS(3051),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3053),
    [anon_sym_new] = ACTIONS(3051),
    [anon_sym_return_BANG] = ACTIONS(3053),
    [anon_sym_yield] = ACTIONS(3051),
    [anon_sym_yield_BANG] = ACTIONS(3053),
    [anon_sym_lazy] = ACTIONS(3051),
    [anon_sym_assert] = ACTIONS(3051),
    [anon_sym_upcast] = ACTIONS(3051),
    [anon_sym_downcast] = ACTIONS(3051),
    [anon_sym_COLON_GT] = ACTIONS(3053),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3053),
    [anon_sym_for] = ACTIONS(3051),
    [anon_sym_while] = ACTIONS(3051),
    [anon_sym_if] = ACTIONS(3051),
    [anon_sym_fun] = ACTIONS(3051),
    [anon_sym_try] = ACTIONS(3051),
    [anon_sym_match] = ACTIONS(3051),
    [anon_sym_match_BANG] = ACTIONS(3053),
    [anon_sym_function] = ACTIONS(3051),
    [anon_sym_LT_DASH] = ACTIONS(3051),
    [anon_sym_DOT_LBRACK] = ACTIONS(3053),
    [anon_sym_LT] = ACTIONS(3053),
    [anon_sym_use] = ACTIONS(3051),
    [anon_sym_use_BANG] = ACTIONS(3053),
    [anon_sym_do_BANG] = ACTIONS(3053),
    [anon_sym_begin] = ACTIONS(3051),
    [anon_sym_LPAREN2] = ACTIONS(3051),
    [anon_sym_or] = ACTIONS(3051),
    [aux_sym_char_token1] = ACTIONS(3053),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3051),
    [anon_sym_DQUOTE] = ACTIONS(3051),
    [anon_sym_AT_DQUOTE] = ACTIONS(3053),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3053),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3053),
    [sym_bool] = ACTIONS(3051),
    [sym_unit] = ACTIONS(3053),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3051),
    [sym_op_identifier] = ACTIONS(3051),
    [anon_sym_PLUS] = ACTIONS(3051),
    [anon_sym_DASH] = ACTIONS(3051),
    [anon_sym_PLUS_DOT] = ACTIONS(3051),
    [anon_sym_DASH_DOT] = ACTIONS(3051),
    [anon_sym_PERCENT] = ACTIONS(3051),
    [anon_sym_AMP_AMP] = ACTIONS(3051),
    [anon_sym_TILDE] = ACTIONS(3053),
    [aux_sym_prefix_op_token1] = ACTIONS(3051),
    [aux_sym_infix_op_token1] = ACTIONS(3053),
    [aux_sym_infix_op_token2] = ACTIONS(3051),
    [anon_sym_PIPE_PIPE] = ACTIONS(3051),
    [anon_sym_BANG_EQ] = ACTIONS(3051),
    [anon_sym_COLON_EQ] = ACTIONS(3053),
    [anon_sym_DOLLAR] = ACTIONS(3051),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3051),
    [sym_int] = ACTIONS(3051),
    [sym_xint] = ACTIONS(3053),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3053),
    [anon_sym_POUNDendif] = ACTIONS(3053),
    [anon_sym_POUNDelse] = ACTIONS(3053),
    [sym__newline] = ACTIONS(3053),
  },
  [2044] = {
    [sym_block_comment] = STATE(2044),
    [sym_compiler_directive_decl] = STATE(2044),
    [sym_fsi_directive_decl] = STATE(2044),
    [sym_preproc_line] = STATE(2044),
    [sym_identifier] = ACTIONS(2891),
    [anon_sym_EQ] = ACTIONS(2893),
    [anon_sym_COLON] = ACTIONS(2891),
    [anon_sym_return] = ACTIONS(2891),
    [anon_sym_do] = ACTIONS(2891),
    [anon_sym_and] = ACTIONS(2891),
    [anon_sym_let] = ACTIONS(2891),
    [anon_sym_let_BANG] = ACTIONS(2893),
    [anon_sym_LPAREN] = ACTIONS(2891),
    [anon_sym_COMMA] = ACTIONS(2893),
    [anon_sym_null] = ACTIONS(2891),
    [anon_sym_QMARK] = ACTIONS(2891),
    [anon_sym_COLON_QMARK] = ACTIONS(2891),
    [anon_sym_COLON_COLON] = ACTIONS(2893),
    [anon_sym_AMP] = ACTIONS(2891),
    [anon_sym_LBRACK] = ACTIONS(2891),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2893),
    [anon_sym_LBRACE] = ACTIONS(2891),
    [anon_sym_LT_AT] = ACTIONS(2891),
    [anon_sym_LT_AT_AT] = ACTIONS(2891),
    [anon_sym_DOT] = ACTIONS(2891),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2893),
    [anon_sym_new] = ACTIONS(2891),
    [anon_sym_return_BANG] = ACTIONS(2893),
    [anon_sym_yield] = ACTIONS(2891),
    [anon_sym_yield_BANG] = ACTIONS(2893),
    [anon_sym_lazy] = ACTIONS(2891),
    [anon_sym_assert] = ACTIONS(2891),
    [anon_sym_upcast] = ACTIONS(2891),
    [anon_sym_downcast] = ACTIONS(2891),
    [anon_sym_COLON_GT] = ACTIONS(2893),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2893),
    [anon_sym_for] = ACTIONS(2891),
    [anon_sym_while] = ACTIONS(2891),
    [anon_sym_if] = ACTIONS(2891),
    [anon_sym_fun] = ACTIONS(2891),
    [anon_sym_try] = ACTIONS(2891),
    [anon_sym_match] = ACTIONS(2891),
    [anon_sym_match_BANG] = ACTIONS(2893),
    [anon_sym_function] = ACTIONS(2891),
    [anon_sym_LT_DASH] = ACTIONS(2891),
    [anon_sym_DOT_LBRACK] = ACTIONS(2893),
    [anon_sym_LT] = ACTIONS(2893),
    [anon_sym_use] = ACTIONS(2891),
    [anon_sym_use_BANG] = ACTIONS(2893),
    [anon_sym_do_BANG] = ACTIONS(2893),
    [anon_sym_begin] = ACTIONS(2891),
    [anon_sym_LPAREN2] = ACTIONS(2891),
    [anon_sym_or] = ACTIONS(2891),
    [aux_sym_char_token1] = ACTIONS(2893),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2891),
    [anon_sym_DQUOTE] = ACTIONS(2891),
    [anon_sym_AT_DQUOTE] = ACTIONS(2893),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2893),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2893),
    [sym_bool] = ACTIONS(2891),
    [sym_unit] = ACTIONS(2893),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2891),
    [sym_op_identifier] = ACTIONS(2891),
    [anon_sym_PLUS] = ACTIONS(2891),
    [anon_sym_DASH] = ACTIONS(2891),
    [anon_sym_PLUS_DOT] = ACTIONS(2891),
    [anon_sym_DASH_DOT] = ACTIONS(2891),
    [anon_sym_PERCENT] = ACTIONS(2891),
    [anon_sym_AMP_AMP] = ACTIONS(2891),
    [anon_sym_TILDE] = ACTIONS(2893),
    [aux_sym_prefix_op_token1] = ACTIONS(2891),
    [aux_sym_infix_op_token1] = ACTIONS(2893),
    [aux_sym_infix_op_token2] = ACTIONS(2891),
    [anon_sym_PIPE_PIPE] = ACTIONS(2891),
    [anon_sym_BANG_EQ] = ACTIONS(2891),
    [anon_sym_COLON_EQ] = ACTIONS(2893),
    [anon_sym_DOLLAR] = ACTIONS(2891),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2891),
    [sym_int] = ACTIONS(2891),
    [sym_xint] = ACTIONS(2893),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2893),
    [sym__newline] = ACTIONS(2893),
    [sym__dedent] = ACTIONS(2893),
  },
  [2045] = {
    [sym_block_comment] = STATE(2045),
    [sym_compiler_directive_decl] = STATE(2045),
    [sym_fsi_directive_decl] = STATE(2045),
    [sym_preproc_line] = STATE(2045),
    [sym_identifier] = ACTIONS(2910),
    [anon_sym_EQ] = ACTIONS(2912),
    [anon_sym_COLON] = ACTIONS(2910),
    [anon_sym_return] = ACTIONS(2910),
    [anon_sym_do] = ACTIONS(2910),
    [anon_sym_and] = ACTIONS(2910),
    [anon_sym_let] = ACTIONS(2910),
    [anon_sym_let_BANG] = ACTIONS(2912),
    [anon_sym_LPAREN] = ACTIONS(2910),
    [anon_sym_COMMA] = ACTIONS(2912),
    [anon_sym_null] = ACTIONS(2910),
    [anon_sym_QMARK] = ACTIONS(2910),
    [anon_sym_COLON_QMARK] = ACTIONS(2910),
    [anon_sym_COLON_COLON] = ACTIONS(2912),
    [anon_sym_AMP] = ACTIONS(2910),
    [anon_sym_LBRACK] = ACTIONS(2910),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2912),
    [anon_sym_LBRACE] = ACTIONS(2910),
    [anon_sym_LT_AT] = ACTIONS(2910),
    [anon_sym_LT_AT_AT] = ACTIONS(2910),
    [anon_sym_DOT] = ACTIONS(2910),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2912),
    [anon_sym_new] = ACTIONS(2910),
    [anon_sym_return_BANG] = ACTIONS(2912),
    [anon_sym_yield] = ACTIONS(2910),
    [anon_sym_yield_BANG] = ACTIONS(2912),
    [anon_sym_lazy] = ACTIONS(2910),
    [anon_sym_assert] = ACTIONS(2910),
    [anon_sym_upcast] = ACTIONS(2910),
    [anon_sym_downcast] = ACTIONS(2910),
    [anon_sym_COLON_GT] = ACTIONS(2912),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2912),
    [anon_sym_for] = ACTIONS(2910),
    [anon_sym_while] = ACTIONS(2910),
    [anon_sym_if] = ACTIONS(2910),
    [anon_sym_fun] = ACTIONS(2910),
    [anon_sym_try] = ACTIONS(2910),
    [anon_sym_match] = ACTIONS(2910),
    [anon_sym_match_BANG] = ACTIONS(2912),
    [anon_sym_function] = ACTIONS(2910),
    [anon_sym_LT_DASH] = ACTIONS(2910),
    [anon_sym_DOT_LBRACK] = ACTIONS(2912),
    [anon_sym_LT] = ACTIONS(2912),
    [anon_sym_use] = ACTIONS(2910),
    [anon_sym_use_BANG] = ACTIONS(2912),
    [anon_sym_do_BANG] = ACTIONS(2912),
    [anon_sym_begin] = ACTIONS(2910),
    [anon_sym_LPAREN2] = ACTIONS(2910),
    [anon_sym_or] = ACTIONS(2910),
    [aux_sym_char_token1] = ACTIONS(2912),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2910),
    [anon_sym_DQUOTE] = ACTIONS(2910),
    [anon_sym_AT_DQUOTE] = ACTIONS(2912),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2912),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2912),
    [sym_bool] = ACTIONS(2910),
    [sym_unit] = ACTIONS(2912),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2910),
    [sym_op_identifier] = ACTIONS(2910),
    [anon_sym_PLUS] = ACTIONS(2910),
    [anon_sym_DASH] = ACTIONS(2910),
    [anon_sym_PLUS_DOT] = ACTIONS(2910),
    [anon_sym_DASH_DOT] = ACTIONS(2910),
    [anon_sym_PERCENT] = ACTIONS(2910),
    [anon_sym_AMP_AMP] = ACTIONS(2910),
    [anon_sym_TILDE] = ACTIONS(2912),
    [aux_sym_prefix_op_token1] = ACTIONS(2910),
    [aux_sym_infix_op_token1] = ACTIONS(2912),
    [aux_sym_infix_op_token2] = ACTIONS(2910),
    [anon_sym_PIPE_PIPE] = ACTIONS(2910),
    [anon_sym_BANG_EQ] = ACTIONS(2910),
    [anon_sym_COLON_EQ] = ACTIONS(2912),
    [anon_sym_DOLLAR] = ACTIONS(2910),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2910),
    [sym_int] = ACTIONS(2910),
    [sym_xint] = ACTIONS(2912),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2912),
    [sym__newline] = ACTIONS(2912),
    [sym__dedent] = ACTIONS(2912),
  },
  [2046] = {
    [sym_block_comment] = STATE(2046),
    [sym_compiler_directive_decl] = STATE(2046),
    [sym_fsi_directive_decl] = STATE(2046),
    [sym_preproc_line] = STATE(2046),
    [sym_identifier] = ACTIONS(3047),
    [anon_sym_EQ] = ACTIONS(3049),
    [anon_sym_COLON] = ACTIONS(3047),
    [anon_sym_return] = ACTIONS(3047),
    [anon_sym_do] = ACTIONS(3047),
    [anon_sym_let] = ACTIONS(3047),
    [anon_sym_let_BANG] = ACTIONS(3049),
    [anon_sym_LPAREN] = ACTIONS(3047),
    [anon_sym_COMMA] = ACTIONS(3049),
    [anon_sym_null] = ACTIONS(3047),
    [anon_sym_QMARK] = ACTIONS(3047),
    [anon_sym_COLON_QMARK] = ACTIONS(3047),
    [anon_sym_COLON_COLON] = ACTIONS(3049),
    [anon_sym_AMP] = ACTIONS(3047),
    [anon_sym_LBRACK] = ACTIONS(3047),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3049),
    [anon_sym_LBRACE] = ACTIONS(3047),
    [anon_sym_LT_AT] = ACTIONS(3047),
    [anon_sym_LT_AT_AT] = ACTIONS(3047),
    [anon_sym_DOT] = ACTIONS(3047),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3049),
    [anon_sym_new] = ACTIONS(3047),
    [anon_sym_return_BANG] = ACTIONS(3049),
    [anon_sym_yield] = ACTIONS(3047),
    [anon_sym_yield_BANG] = ACTIONS(3049),
    [anon_sym_lazy] = ACTIONS(3047),
    [anon_sym_assert] = ACTIONS(3047),
    [anon_sym_upcast] = ACTIONS(3047),
    [anon_sym_downcast] = ACTIONS(3047),
    [anon_sym_COLON_GT] = ACTIONS(3049),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3049),
    [anon_sym_for] = ACTIONS(3047),
    [anon_sym_while] = ACTIONS(3047),
    [anon_sym_if] = ACTIONS(3047),
    [anon_sym_fun] = ACTIONS(3047),
    [anon_sym_try] = ACTIONS(3047),
    [anon_sym_match] = ACTIONS(3047),
    [anon_sym_match_BANG] = ACTIONS(3049),
    [anon_sym_function] = ACTIONS(3047),
    [anon_sym_LT_DASH] = ACTIONS(3047),
    [anon_sym_DOT_LBRACK] = ACTIONS(3049),
    [anon_sym_LT] = ACTIONS(3049),
    [anon_sym_use] = ACTIONS(3047),
    [anon_sym_use_BANG] = ACTIONS(3049),
    [anon_sym_do_BANG] = ACTIONS(3049),
    [anon_sym_begin] = ACTIONS(3047),
    [anon_sym_LPAREN2] = ACTIONS(3047),
    [anon_sym_or] = ACTIONS(3047),
    [aux_sym_char_token1] = ACTIONS(3049),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3047),
    [anon_sym_DQUOTE] = ACTIONS(3047),
    [anon_sym_AT_DQUOTE] = ACTIONS(3049),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3049),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3049),
    [sym_bool] = ACTIONS(3047),
    [sym_unit] = ACTIONS(3049),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3047),
    [sym_op_identifier] = ACTIONS(3047),
    [anon_sym_PLUS] = ACTIONS(3047),
    [anon_sym_DASH] = ACTIONS(3047),
    [anon_sym_PLUS_DOT] = ACTIONS(3047),
    [anon_sym_DASH_DOT] = ACTIONS(3047),
    [anon_sym_PERCENT] = ACTIONS(3047),
    [anon_sym_AMP_AMP] = ACTIONS(3047),
    [anon_sym_TILDE] = ACTIONS(3049),
    [aux_sym_prefix_op_token1] = ACTIONS(3047),
    [aux_sym_infix_op_token1] = ACTIONS(3049),
    [aux_sym_infix_op_token2] = ACTIONS(3047),
    [anon_sym_PIPE_PIPE] = ACTIONS(3047),
    [anon_sym_BANG_EQ] = ACTIONS(3047),
    [anon_sym_COLON_EQ] = ACTIONS(3049),
    [anon_sym_DOLLAR] = ACTIONS(3047),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3047),
    [sym_int] = ACTIONS(3047),
    [sym_xint] = ACTIONS(3049),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3049),
    [anon_sym_POUNDendif] = ACTIONS(3049),
    [anon_sym_POUNDelse] = ACTIONS(3049),
    [sym__newline] = ACTIONS(3049),
  },
  [2047] = {
    [sym_block_comment] = STATE(2047),
    [sym_compiler_directive_decl] = STATE(2047),
    [sym_fsi_directive_decl] = STATE(2047),
    [sym_preproc_line] = STATE(2047),
    [sym_identifier] = ACTIONS(2881),
    [anon_sym_EQ] = ACTIONS(2789),
    [anon_sym_COLON] = ACTIONS(2881),
    [anon_sym_return] = ACTIONS(2881),
    [anon_sym_do] = ACTIONS(2881),
    [anon_sym_let] = ACTIONS(2881),
    [anon_sym_let_BANG] = ACTIONS(2789),
    [anon_sym_LPAREN] = ACTIONS(2881),
    [anon_sym_COMMA] = ACTIONS(2789),
    [anon_sym_null] = ACTIONS(2881),
    [anon_sym_QMARK] = ACTIONS(2881),
    [anon_sym_COLON_QMARK] = ACTIONS(2881),
    [anon_sym_COLON_COLON] = ACTIONS(2789),
    [anon_sym_AMP] = ACTIONS(2881),
    [anon_sym_LBRACK] = ACTIONS(2881),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2789),
    [anon_sym_LBRACE] = ACTIONS(2881),
    [anon_sym_LT_AT] = ACTIONS(2881),
    [anon_sym_LT_AT_AT] = ACTIONS(2881),
    [anon_sym_DOT] = ACTIONS(2881),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2789),
    [anon_sym_new] = ACTIONS(2881),
    [anon_sym_return_BANG] = ACTIONS(2789),
    [anon_sym_yield] = ACTIONS(2881),
    [anon_sym_yield_BANG] = ACTIONS(2789),
    [anon_sym_lazy] = ACTIONS(2881),
    [anon_sym_assert] = ACTIONS(2881),
    [anon_sym_upcast] = ACTIONS(2881),
    [anon_sym_downcast] = ACTIONS(2881),
    [anon_sym_COLON_GT] = ACTIONS(2789),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2789),
    [anon_sym_for] = ACTIONS(2881),
    [anon_sym_while] = ACTIONS(2881),
    [anon_sym_if] = ACTIONS(2881),
    [anon_sym_fun] = ACTIONS(2881),
    [anon_sym_try] = ACTIONS(2881),
    [anon_sym_match] = ACTIONS(2881),
    [anon_sym_match_BANG] = ACTIONS(2789),
    [anon_sym_function] = ACTIONS(2881),
    [anon_sym_LT_DASH] = ACTIONS(2881),
    [anon_sym_DOT_LBRACK] = ACTIONS(2789),
    [anon_sym_LT] = ACTIONS(2789),
    [anon_sym_use] = ACTIONS(2881),
    [anon_sym_use_BANG] = ACTIONS(2789),
    [anon_sym_do_BANG] = ACTIONS(2789),
    [anon_sym_begin] = ACTIONS(2881),
    [anon_sym_LPAREN2] = ACTIONS(2881),
    [anon_sym_or] = ACTIONS(2881),
    [aux_sym_char_token1] = ACTIONS(2789),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2881),
    [anon_sym_DQUOTE] = ACTIONS(2881),
    [anon_sym_AT_DQUOTE] = ACTIONS(2789),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2789),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2789),
    [sym_bool] = ACTIONS(2881),
    [sym_unit] = ACTIONS(2789),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2881),
    [sym_op_identifier] = ACTIONS(2881),
    [anon_sym_PLUS] = ACTIONS(2881),
    [anon_sym_DASH] = ACTIONS(2881),
    [anon_sym_PLUS_DOT] = ACTIONS(2881),
    [anon_sym_DASH_DOT] = ACTIONS(2881),
    [anon_sym_PERCENT] = ACTIONS(2881),
    [anon_sym_AMP_AMP] = ACTIONS(2881),
    [anon_sym_TILDE] = ACTIONS(2789),
    [aux_sym_prefix_op_token1] = ACTIONS(2881),
    [aux_sym_infix_op_token1] = ACTIONS(2789),
    [aux_sym_infix_op_token2] = ACTIONS(2881),
    [anon_sym_PIPE_PIPE] = ACTIONS(2881),
    [anon_sym_BANG_EQ] = ACTIONS(2881),
    [anon_sym_COLON_EQ] = ACTIONS(2789),
    [anon_sym_DOLLAR] = ACTIONS(2881),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2881),
    [sym_int] = ACTIONS(2881),
    [sym_xint] = ACTIONS(2789),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2789),
    [anon_sym_POUNDendif] = ACTIONS(2789),
    [anon_sym_POUNDelse] = ACTIONS(2789),
    [sym__newline] = ACTIONS(2789),
  },
  [2048] = {
    [sym_block_comment] = STATE(2048),
    [sym_compiler_directive_decl] = STATE(2048),
    [sym_fsi_directive_decl] = STATE(2048),
    [sym_preproc_line] = STATE(2048),
    [sym_identifier] = ACTIONS(2902),
    [anon_sym_EQ] = ACTIONS(2904),
    [anon_sym_COLON] = ACTIONS(2902),
    [anon_sym_return] = ACTIONS(2902),
    [anon_sym_do] = ACTIONS(2902),
    [anon_sym_let] = ACTIONS(2902),
    [anon_sym_let_BANG] = ACTIONS(2904),
    [anon_sym_LPAREN] = ACTIONS(2902),
    [anon_sym_COMMA] = ACTIONS(2904),
    [anon_sym_null] = ACTIONS(2902),
    [anon_sym_QMARK] = ACTIONS(2902),
    [anon_sym_COLON_QMARK] = ACTIONS(2902),
    [anon_sym_COLON_COLON] = ACTIONS(2904),
    [anon_sym_AMP] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2902),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2902),
    [anon_sym_LT_AT] = ACTIONS(2902),
    [anon_sym_LT_AT_AT] = ACTIONS(2902),
    [anon_sym_DOT] = ACTIONS(2902),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2904),
    [anon_sym_new] = ACTIONS(2902),
    [anon_sym_return_BANG] = ACTIONS(2904),
    [anon_sym_yield] = ACTIONS(2902),
    [anon_sym_yield_BANG] = ACTIONS(2904),
    [anon_sym_lazy] = ACTIONS(2902),
    [anon_sym_assert] = ACTIONS(2902),
    [anon_sym_upcast] = ACTIONS(2902),
    [anon_sym_downcast] = ACTIONS(2902),
    [anon_sym_COLON_GT] = ACTIONS(2904),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2904),
    [anon_sym_for] = ACTIONS(2902),
    [anon_sym_while] = ACTIONS(2902),
    [anon_sym_if] = ACTIONS(2902),
    [anon_sym_fun] = ACTIONS(2902),
    [anon_sym_try] = ACTIONS(2902),
    [anon_sym_match] = ACTIONS(2902),
    [anon_sym_match_BANG] = ACTIONS(2904),
    [anon_sym_function] = ACTIONS(2902),
    [anon_sym_LT_DASH] = ACTIONS(2902),
    [anon_sym_DOT_LBRACK] = ACTIONS(2904),
    [anon_sym_LT] = ACTIONS(2904),
    [anon_sym_use] = ACTIONS(2902),
    [anon_sym_use_BANG] = ACTIONS(2904),
    [anon_sym_do_BANG] = ACTIONS(2904),
    [anon_sym_begin] = ACTIONS(2902),
    [anon_sym_LPAREN2] = ACTIONS(2902),
    [anon_sym_or] = ACTIONS(2902),
    [aux_sym_char_token1] = ACTIONS(2904),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2902),
    [anon_sym_DQUOTE] = ACTIONS(2902),
    [anon_sym_AT_DQUOTE] = ACTIONS(2904),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2904),
    [sym_bool] = ACTIONS(2902),
    [sym_unit] = ACTIONS(2904),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2902),
    [sym_op_identifier] = ACTIONS(2902),
    [anon_sym_PLUS] = ACTIONS(2902),
    [anon_sym_DASH] = ACTIONS(2902),
    [anon_sym_PLUS_DOT] = ACTIONS(2902),
    [anon_sym_DASH_DOT] = ACTIONS(2902),
    [anon_sym_PERCENT] = ACTIONS(2902),
    [anon_sym_AMP_AMP] = ACTIONS(2902),
    [anon_sym_TILDE] = ACTIONS(2904),
    [aux_sym_prefix_op_token1] = ACTIONS(2902),
    [aux_sym_infix_op_token1] = ACTIONS(2904),
    [aux_sym_infix_op_token2] = ACTIONS(2902),
    [anon_sym_PIPE_PIPE] = ACTIONS(2902),
    [anon_sym_BANG_EQ] = ACTIONS(2902),
    [anon_sym_COLON_EQ] = ACTIONS(2904),
    [anon_sym_DOLLAR] = ACTIONS(2902),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2902),
    [sym_int] = ACTIONS(2902),
    [sym_xint] = ACTIONS(2904),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2904),
    [anon_sym_POUNDendif] = ACTIONS(2904),
    [anon_sym_POUNDelse] = ACTIONS(2904),
    [sym__newline] = ACTIONS(2904),
  },
  [2049] = {
    [sym_block_comment] = STATE(2049),
    [sym_compiler_directive_decl] = STATE(2049),
    [sym_fsi_directive_decl] = STATE(2049),
    [sym_preproc_line] = STATE(2049),
    [sym_identifier] = ACTIONS(2906),
    [anon_sym_EQ] = ACTIONS(2908),
    [anon_sym_COLON] = ACTIONS(2906),
    [anon_sym_return] = ACTIONS(2906),
    [anon_sym_do] = ACTIONS(2906),
    [anon_sym_let] = ACTIONS(2906),
    [anon_sym_let_BANG] = ACTIONS(2908),
    [anon_sym_LPAREN] = ACTIONS(2906),
    [anon_sym_COMMA] = ACTIONS(2908),
    [anon_sym_null] = ACTIONS(2906),
    [anon_sym_QMARK] = ACTIONS(2906),
    [anon_sym_COLON_QMARK] = ACTIONS(2906),
    [anon_sym_COLON_COLON] = ACTIONS(2908),
    [anon_sym_AMP] = ACTIONS(2906),
    [anon_sym_LBRACK] = ACTIONS(2906),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2908),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_LT_AT] = ACTIONS(2906),
    [anon_sym_LT_AT_AT] = ACTIONS(2906),
    [anon_sym_DOT] = ACTIONS(2906),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2908),
    [anon_sym_new] = ACTIONS(2906),
    [anon_sym_return_BANG] = ACTIONS(2908),
    [anon_sym_yield] = ACTIONS(2906),
    [anon_sym_yield_BANG] = ACTIONS(2908),
    [anon_sym_lazy] = ACTIONS(2906),
    [anon_sym_assert] = ACTIONS(2906),
    [anon_sym_upcast] = ACTIONS(2906),
    [anon_sym_downcast] = ACTIONS(2906),
    [anon_sym_COLON_GT] = ACTIONS(2908),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2908),
    [anon_sym_for] = ACTIONS(2906),
    [anon_sym_while] = ACTIONS(2906),
    [anon_sym_if] = ACTIONS(2906),
    [anon_sym_fun] = ACTIONS(2906),
    [anon_sym_try] = ACTIONS(2906),
    [anon_sym_match] = ACTIONS(2906),
    [anon_sym_match_BANG] = ACTIONS(2908),
    [anon_sym_function] = ACTIONS(2906),
    [anon_sym_LT_DASH] = ACTIONS(2906),
    [anon_sym_DOT_LBRACK] = ACTIONS(2908),
    [anon_sym_LT] = ACTIONS(2908),
    [anon_sym_use] = ACTIONS(2906),
    [anon_sym_use_BANG] = ACTIONS(2908),
    [anon_sym_do_BANG] = ACTIONS(2908),
    [anon_sym_begin] = ACTIONS(2906),
    [anon_sym_LPAREN2] = ACTIONS(2906),
    [anon_sym_or] = ACTIONS(2906),
    [aux_sym_char_token1] = ACTIONS(2908),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2906),
    [anon_sym_DQUOTE] = ACTIONS(2906),
    [anon_sym_AT_DQUOTE] = ACTIONS(2908),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2908),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2908),
    [sym_bool] = ACTIONS(2906),
    [sym_unit] = ACTIONS(2908),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2906),
    [sym_op_identifier] = ACTIONS(2906),
    [anon_sym_PLUS] = ACTIONS(2906),
    [anon_sym_DASH] = ACTIONS(2906),
    [anon_sym_PLUS_DOT] = ACTIONS(2906),
    [anon_sym_DASH_DOT] = ACTIONS(2906),
    [anon_sym_PERCENT] = ACTIONS(2906),
    [anon_sym_AMP_AMP] = ACTIONS(2906),
    [anon_sym_TILDE] = ACTIONS(2908),
    [aux_sym_prefix_op_token1] = ACTIONS(2906),
    [aux_sym_infix_op_token1] = ACTIONS(2908),
    [aux_sym_infix_op_token2] = ACTIONS(2906),
    [anon_sym_PIPE_PIPE] = ACTIONS(2906),
    [anon_sym_BANG_EQ] = ACTIONS(2906),
    [anon_sym_COLON_EQ] = ACTIONS(2908),
    [anon_sym_DOLLAR] = ACTIONS(2906),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2906),
    [sym_int] = ACTIONS(2906),
    [sym_xint] = ACTIONS(2908),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2908),
    [anon_sym_POUNDendif] = ACTIONS(2908),
    [anon_sym_POUNDelse] = ACTIONS(2908),
    [sym__newline] = ACTIONS(2908),
  },
  [2050] = {
    [sym_block_comment] = STATE(2050),
    [sym_compiler_directive_decl] = STATE(2050),
    [sym_fsi_directive_decl] = STATE(2050),
    [sym_preproc_line] = STATE(2050),
    [sym_identifier] = ACTIONS(3043),
    [anon_sym_EQ] = ACTIONS(3045),
    [anon_sym_COLON] = ACTIONS(3043),
    [anon_sym_return] = ACTIONS(3043),
    [anon_sym_do] = ACTIONS(3043),
    [anon_sym_let] = ACTIONS(3043),
    [anon_sym_let_BANG] = ACTIONS(3045),
    [anon_sym_LPAREN] = ACTIONS(3043),
    [anon_sym_COMMA] = ACTIONS(3045),
    [anon_sym_null] = ACTIONS(3043),
    [anon_sym_QMARK] = ACTIONS(3043),
    [anon_sym_COLON_QMARK] = ACTIONS(3043),
    [anon_sym_COLON_COLON] = ACTIONS(3045),
    [anon_sym_AMP] = ACTIONS(3043),
    [anon_sym_LBRACK] = ACTIONS(3043),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3045),
    [anon_sym_LBRACE] = ACTIONS(3043),
    [anon_sym_LT_AT] = ACTIONS(3043),
    [anon_sym_LT_AT_AT] = ACTIONS(3043),
    [anon_sym_DOT] = ACTIONS(3043),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3045),
    [anon_sym_new] = ACTIONS(3043),
    [anon_sym_return_BANG] = ACTIONS(3045),
    [anon_sym_yield] = ACTIONS(3043),
    [anon_sym_yield_BANG] = ACTIONS(3045),
    [anon_sym_lazy] = ACTIONS(3043),
    [anon_sym_assert] = ACTIONS(3043),
    [anon_sym_upcast] = ACTIONS(3043),
    [anon_sym_downcast] = ACTIONS(3043),
    [anon_sym_COLON_GT] = ACTIONS(3045),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3045),
    [anon_sym_for] = ACTIONS(3043),
    [anon_sym_while] = ACTIONS(3043),
    [anon_sym_if] = ACTIONS(3043),
    [anon_sym_fun] = ACTIONS(3043),
    [anon_sym_try] = ACTIONS(3043),
    [anon_sym_match] = ACTIONS(3043),
    [anon_sym_match_BANG] = ACTIONS(3045),
    [anon_sym_function] = ACTIONS(3043),
    [anon_sym_LT_DASH] = ACTIONS(3043),
    [anon_sym_DOT_LBRACK] = ACTIONS(3045),
    [anon_sym_LT] = ACTIONS(3045),
    [anon_sym_use] = ACTIONS(3043),
    [anon_sym_use_BANG] = ACTIONS(3045),
    [anon_sym_do_BANG] = ACTIONS(3045),
    [anon_sym_begin] = ACTIONS(3043),
    [anon_sym_LPAREN2] = ACTIONS(3043),
    [anon_sym_or] = ACTIONS(3043),
    [aux_sym_char_token1] = ACTIONS(3045),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3043),
    [anon_sym_DQUOTE] = ACTIONS(3043),
    [anon_sym_AT_DQUOTE] = ACTIONS(3045),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3045),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3045),
    [sym_bool] = ACTIONS(3043),
    [sym_unit] = ACTIONS(3045),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3043),
    [sym_op_identifier] = ACTIONS(3043),
    [anon_sym_PLUS] = ACTIONS(3043),
    [anon_sym_DASH] = ACTIONS(3043),
    [anon_sym_PLUS_DOT] = ACTIONS(3043),
    [anon_sym_DASH_DOT] = ACTIONS(3043),
    [anon_sym_PERCENT] = ACTIONS(3043),
    [anon_sym_AMP_AMP] = ACTIONS(3043),
    [anon_sym_TILDE] = ACTIONS(3045),
    [aux_sym_prefix_op_token1] = ACTIONS(3043),
    [aux_sym_infix_op_token1] = ACTIONS(3045),
    [aux_sym_infix_op_token2] = ACTIONS(3043),
    [anon_sym_PIPE_PIPE] = ACTIONS(3043),
    [anon_sym_BANG_EQ] = ACTIONS(3043),
    [anon_sym_COLON_EQ] = ACTIONS(3045),
    [anon_sym_DOLLAR] = ACTIONS(3043),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3043),
    [sym_int] = ACTIONS(3043),
    [sym_xint] = ACTIONS(3045),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3045),
    [anon_sym_POUNDendif] = ACTIONS(3045),
    [anon_sym_POUNDelse] = ACTIONS(3045),
    [sym__newline] = ACTIONS(3045),
  },
  [2051] = {
    [sym_block_comment] = STATE(2051),
    [sym_compiler_directive_decl] = STATE(2051),
    [sym_fsi_directive_decl] = STATE(2051),
    [sym_preproc_line] = STATE(2051),
    [sym_identifier] = ACTIONS(3039),
    [anon_sym_EQ] = ACTIONS(3041),
    [anon_sym_COLON] = ACTIONS(3039),
    [anon_sym_return] = ACTIONS(3039),
    [anon_sym_do] = ACTIONS(3039),
    [anon_sym_let] = ACTIONS(3039),
    [anon_sym_let_BANG] = ACTIONS(3041),
    [anon_sym_LPAREN] = ACTIONS(3039),
    [anon_sym_COMMA] = ACTIONS(3041),
    [anon_sym_null] = ACTIONS(3039),
    [anon_sym_QMARK] = ACTIONS(3039),
    [anon_sym_COLON_QMARK] = ACTIONS(3039),
    [anon_sym_COLON_COLON] = ACTIONS(3041),
    [anon_sym_AMP] = ACTIONS(3039),
    [anon_sym_LBRACK] = ACTIONS(3039),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3041),
    [anon_sym_LBRACE] = ACTIONS(3039),
    [anon_sym_LT_AT] = ACTIONS(3039),
    [anon_sym_LT_AT_AT] = ACTIONS(3039),
    [anon_sym_DOT] = ACTIONS(3039),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3041),
    [anon_sym_new] = ACTIONS(3039),
    [anon_sym_return_BANG] = ACTIONS(3041),
    [anon_sym_yield] = ACTIONS(3039),
    [anon_sym_yield_BANG] = ACTIONS(3041),
    [anon_sym_lazy] = ACTIONS(3039),
    [anon_sym_assert] = ACTIONS(3039),
    [anon_sym_upcast] = ACTIONS(3039),
    [anon_sym_downcast] = ACTIONS(3039),
    [anon_sym_COLON_GT] = ACTIONS(3041),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3041),
    [anon_sym_for] = ACTIONS(3039),
    [anon_sym_while] = ACTIONS(3039),
    [anon_sym_if] = ACTIONS(3039),
    [anon_sym_fun] = ACTIONS(3039),
    [anon_sym_try] = ACTIONS(3039),
    [anon_sym_match] = ACTIONS(3039),
    [anon_sym_match_BANG] = ACTIONS(3041),
    [anon_sym_function] = ACTIONS(3039),
    [anon_sym_LT_DASH] = ACTIONS(3039),
    [anon_sym_DOT_LBRACK] = ACTIONS(3041),
    [anon_sym_LT] = ACTIONS(3041),
    [anon_sym_use] = ACTIONS(3039),
    [anon_sym_use_BANG] = ACTIONS(3041),
    [anon_sym_do_BANG] = ACTIONS(3041),
    [anon_sym_begin] = ACTIONS(3039),
    [anon_sym_LPAREN2] = ACTIONS(3039),
    [anon_sym_or] = ACTIONS(3039),
    [aux_sym_char_token1] = ACTIONS(3041),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3039),
    [anon_sym_DQUOTE] = ACTIONS(3039),
    [anon_sym_AT_DQUOTE] = ACTIONS(3041),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3041),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3041),
    [sym_bool] = ACTIONS(3039),
    [sym_unit] = ACTIONS(3041),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3039),
    [sym_op_identifier] = ACTIONS(3039),
    [anon_sym_PLUS] = ACTIONS(3039),
    [anon_sym_DASH] = ACTIONS(3039),
    [anon_sym_PLUS_DOT] = ACTIONS(3039),
    [anon_sym_DASH_DOT] = ACTIONS(3039),
    [anon_sym_PERCENT] = ACTIONS(3039),
    [anon_sym_AMP_AMP] = ACTIONS(3039),
    [anon_sym_TILDE] = ACTIONS(3041),
    [aux_sym_prefix_op_token1] = ACTIONS(3039),
    [aux_sym_infix_op_token1] = ACTIONS(3041),
    [aux_sym_infix_op_token2] = ACTIONS(3039),
    [anon_sym_PIPE_PIPE] = ACTIONS(3039),
    [anon_sym_BANG_EQ] = ACTIONS(3039),
    [anon_sym_COLON_EQ] = ACTIONS(3041),
    [anon_sym_DOLLAR] = ACTIONS(3039),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3039),
    [sym_int] = ACTIONS(3039),
    [sym_xint] = ACTIONS(3041),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3041),
    [anon_sym_POUNDendif] = ACTIONS(3041),
    [anon_sym_POUNDelse] = ACTIONS(3041),
    [sym__newline] = ACTIONS(3041),
  },
  [2052] = {
    [sym_block_comment] = STATE(2052),
    [sym_compiler_directive_decl] = STATE(2052),
    [sym_fsi_directive_decl] = STATE(2052),
    [sym_preproc_line] = STATE(2052),
    [sym_identifier] = ACTIONS(2914),
    [anon_sym_EQ] = ACTIONS(2916),
    [anon_sym_COLON] = ACTIONS(2914),
    [anon_sym_return] = ACTIONS(2914),
    [anon_sym_do] = ACTIONS(2914),
    [anon_sym_and] = ACTIONS(2914),
    [anon_sym_let] = ACTIONS(2914),
    [anon_sym_let_BANG] = ACTIONS(2916),
    [anon_sym_LPAREN] = ACTIONS(2914),
    [anon_sym_COMMA] = ACTIONS(2916),
    [anon_sym_null] = ACTIONS(2914),
    [anon_sym_QMARK] = ACTIONS(2914),
    [anon_sym_COLON_QMARK] = ACTIONS(2914),
    [anon_sym_COLON_COLON] = ACTIONS(2916),
    [anon_sym_AMP] = ACTIONS(2914),
    [anon_sym_LBRACK] = ACTIONS(2914),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2916),
    [anon_sym_LBRACE] = ACTIONS(2914),
    [anon_sym_LT_AT] = ACTIONS(2914),
    [anon_sym_LT_AT_AT] = ACTIONS(2914),
    [anon_sym_DOT] = ACTIONS(2914),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2916),
    [anon_sym_new] = ACTIONS(2914),
    [anon_sym_return_BANG] = ACTIONS(2916),
    [anon_sym_yield] = ACTIONS(2914),
    [anon_sym_yield_BANG] = ACTIONS(2916),
    [anon_sym_lazy] = ACTIONS(2914),
    [anon_sym_assert] = ACTIONS(2914),
    [anon_sym_upcast] = ACTIONS(2914),
    [anon_sym_downcast] = ACTIONS(2914),
    [anon_sym_COLON_GT] = ACTIONS(2916),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2916),
    [anon_sym_for] = ACTIONS(2914),
    [anon_sym_while] = ACTIONS(2914),
    [anon_sym_if] = ACTIONS(2914),
    [anon_sym_fun] = ACTIONS(2914),
    [anon_sym_try] = ACTIONS(2914),
    [anon_sym_match] = ACTIONS(2914),
    [anon_sym_match_BANG] = ACTIONS(2916),
    [anon_sym_function] = ACTIONS(2914),
    [anon_sym_LT_DASH] = ACTIONS(2914),
    [anon_sym_DOT_LBRACK] = ACTIONS(2916),
    [anon_sym_LT] = ACTIONS(2916),
    [anon_sym_use] = ACTIONS(2914),
    [anon_sym_use_BANG] = ACTIONS(2916),
    [anon_sym_do_BANG] = ACTIONS(2916),
    [anon_sym_begin] = ACTIONS(2914),
    [anon_sym_LPAREN2] = ACTIONS(2914),
    [anon_sym_or] = ACTIONS(2914),
    [aux_sym_char_token1] = ACTIONS(2916),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2914),
    [anon_sym_DQUOTE] = ACTIONS(2914),
    [anon_sym_AT_DQUOTE] = ACTIONS(2916),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2916),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2916),
    [sym_bool] = ACTIONS(2914),
    [sym_unit] = ACTIONS(2916),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2914),
    [sym_op_identifier] = ACTIONS(2914),
    [anon_sym_PLUS] = ACTIONS(2914),
    [anon_sym_DASH] = ACTIONS(2914),
    [anon_sym_PLUS_DOT] = ACTIONS(2914),
    [anon_sym_DASH_DOT] = ACTIONS(2914),
    [anon_sym_PERCENT] = ACTIONS(2914),
    [anon_sym_AMP_AMP] = ACTIONS(2914),
    [anon_sym_TILDE] = ACTIONS(2916),
    [aux_sym_prefix_op_token1] = ACTIONS(2914),
    [aux_sym_infix_op_token1] = ACTIONS(2916),
    [aux_sym_infix_op_token2] = ACTIONS(2914),
    [anon_sym_PIPE_PIPE] = ACTIONS(2914),
    [anon_sym_BANG_EQ] = ACTIONS(2914),
    [anon_sym_COLON_EQ] = ACTIONS(2916),
    [anon_sym_DOLLAR] = ACTIONS(2914),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2914),
    [sym_int] = ACTIONS(2914),
    [sym_xint] = ACTIONS(2916),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2916),
    [sym__newline] = ACTIONS(2916),
    [sym__dedent] = ACTIONS(2916),
  },
  [2053] = {
    [sym_block_comment] = STATE(2053),
    [sym_compiler_directive_decl] = STATE(2053),
    [sym_fsi_directive_decl] = STATE(2053),
    [sym_preproc_line] = STATE(2053),
    [sym_identifier] = ACTIONS(2867),
    [anon_sym_EQ] = ACTIONS(2867),
    [anon_sym_COLON] = ACTIONS(2867),
    [anon_sym_return] = ACTIONS(2867),
    [anon_sym_do] = ACTIONS(2867),
    [anon_sym_let] = ACTIONS(2867),
    [anon_sym_let_BANG] = ACTIONS(2869),
    [anon_sym_LPAREN] = ACTIONS(2867),
    [anon_sym_COMMA] = ACTIONS(2869),
    [anon_sym_null] = ACTIONS(2867),
    [anon_sym_QMARK] = ACTIONS(2867),
    [anon_sym_COLON_QMARK] = ACTIONS(2867),
    [anon_sym_COLON_COLON] = ACTIONS(2869),
    [anon_sym_AMP] = ACTIONS(2867),
    [anon_sym_LBRACK] = ACTIONS(2867),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2869),
    [anon_sym_LBRACE] = ACTIONS(2867),
    [anon_sym_LT_AT] = ACTIONS(2867),
    [anon_sym_LT_AT_AT] = ACTIONS(2867),
    [anon_sym_DOT] = ACTIONS(3342),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2869),
    [anon_sym_new] = ACTIONS(2867),
    [anon_sym_with] = ACTIONS(2867),
    [anon_sym_return_BANG] = ACTIONS(2869),
    [anon_sym_yield] = ACTIONS(2867),
    [anon_sym_yield_BANG] = ACTIONS(2869),
    [anon_sym_lazy] = ACTIONS(2867),
    [anon_sym_assert] = ACTIONS(2867),
    [anon_sym_upcast] = ACTIONS(2867),
    [anon_sym_downcast] = ACTIONS(2867),
    [anon_sym_COLON_GT] = ACTIONS(2869),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2869),
    [anon_sym_for] = ACTIONS(2867),
    [anon_sym_while] = ACTIONS(2867),
    [anon_sym_if] = ACTIONS(2867),
    [anon_sym_fun] = ACTIONS(2867),
    [anon_sym_try] = ACTIONS(2867),
    [anon_sym_match] = ACTIONS(2867),
    [anon_sym_match_BANG] = ACTIONS(2869),
    [anon_sym_function] = ACTIONS(2867),
    [anon_sym_LT_DASH] = ACTIONS(2867),
    [anon_sym_DOT_LBRACK] = ACTIONS(2869),
    [anon_sym_LT] = ACTIONS(2869),
    [anon_sym_use] = ACTIONS(2867),
    [anon_sym_use_BANG] = ACTIONS(2869),
    [anon_sym_do_BANG] = ACTIONS(2869),
    [anon_sym_begin] = ACTIONS(2867),
    [anon_sym_LPAREN2] = ACTIONS(2867),
    [anon_sym_or] = ACTIONS(2867),
    [anon_sym_EQ2] = ACTIONS(3845),
    [aux_sym_char_token1] = ACTIONS(2869),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2867),
    [anon_sym_DQUOTE] = ACTIONS(2867),
    [anon_sym_AT_DQUOTE] = ACTIONS(2869),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2869),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2869),
    [sym_bool] = ACTIONS(2867),
    [sym_unit] = ACTIONS(2869),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2867),
    [sym_op_identifier] = ACTIONS(2867),
    [anon_sym_PLUS] = ACTIONS(2867),
    [anon_sym_DASH] = ACTIONS(2867),
    [anon_sym_PLUS_DOT] = ACTIONS(2867),
    [anon_sym_DASH_DOT] = ACTIONS(2867),
    [anon_sym_PERCENT] = ACTIONS(2867),
    [anon_sym_AMP_AMP] = ACTIONS(2867),
    [anon_sym_TILDE] = ACTIONS(2869),
    [aux_sym_prefix_op_token1] = ACTIONS(2867),
    [aux_sym_infix_op_token1] = ACTIONS(2869),
    [aux_sym_infix_op_token2] = ACTIONS(2867),
    [anon_sym_PIPE_PIPE] = ACTIONS(2867),
    [anon_sym_BANG_EQ] = ACTIONS(2867),
    [anon_sym_COLON_EQ] = ACTIONS(2869),
    [anon_sym_DOLLAR] = ACTIONS(2867),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2867),
    [sym_int] = ACTIONS(2867),
    [sym_xint] = ACTIONS(2869),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2869),
    [sym__newline] = ACTIONS(2869),
  },
  [2054] = {
    [sym_block_comment] = STATE(2054),
    [sym_compiler_directive_decl] = STATE(2054),
    [sym_fsi_directive_decl] = STATE(2054),
    [sym_preproc_line] = STATE(2054),
    [sym_identifier] = ACTIONS(2918),
    [anon_sym_EQ] = ACTIONS(2920),
    [anon_sym_COLON] = ACTIONS(2918),
    [anon_sym_return] = ACTIONS(2918),
    [anon_sym_do] = ACTIONS(2918),
    [anon_sym_and] = ACTIONS(2918),
    [anon_sym_let] = ACTIONS(2918),
    [anon_sym_let_BANG] = ACTIONS(2920),
    [anon_sym_LPAREN] = ACTIONS(2918),
    [anon_sym_COMMA] = ACTIONS(2920),
    [anon_sym_null] = ACTIONS(2918),
    [anon_sym_QMARK] = ACTIONS(2918),
    [anon_sym_COLON_QMARK] = ACTIONS(2918),
    [anon_sym_COLON_COLON] = ACTIONS(2920),
    [anon_sym_AMP] = ACTIONS(2918),
    [anon_sym_LBRACK] = ACTIONS(2918),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2920),
    [anon_sym_LBRACE] = ACTIONS(2918),
    [anon_sym_LT_AT] = ACTIONS(2918),
    [anon_sym_LT_AT_AT] = ACTIONS(2918),
    [anon_sym_DOT] = ACTIONS(2918),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2920),
    [anon_sym_new] = ACTIONS(2918),
    [anon_sym_return_BANG] = ACTIONS(2920),
    [anon_sym_yield] = ACTIONS(2918),
    [anon_sym_yield_BANG] = ACTIONS(2920),
    [anon_sym_lazy] = ACTIONS(2918),
    [anon_sym_assert] = ACTIONS(2918),
    [anon_sym_upcast] = ACTIONS(2918),
    [anon_sym_downcast] = ACTIONS(2918),
    [anon_sym_COLON_GT] = ACTIONS(2920),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2920),
    [anon_sym_for] = ACTIONS(2918),
    [anon_sym_while] = ACTIONS(2918),
    [anon_sym_if] = ACTIONS(2918),
    [anon_sym_fun] = ACTIONS(2918),
    [anon_sym_try] = ACTIONS(2918),
    [anon_sym_match] = ACTIONS(2918),
    [anon_sym_match_BANG] = ACTIONS(2920),
    [anon_sym_function] = ACTIONS(2918),
    [anon_sym_LT_DASH] = ACTIONS(2918),
    [anon_sym_DOT_LBRACK] = ACTIONS(2920),
    [anon_sym_LT] = ACTIONS(2920),
    [anon_sym_use] = ACTIONS(2918),
    [anon_sym_use_BANG] = ACTIONS(2920),
    [anon_sym_do_BANG] = ACTIONS(2920),
    [anon_sym_begin] = ACTIONS(2918),
    [anon_sym_LPAREN2] = ACTIONS(2918),
    [anon_sym_or] = ACTIONS(2918),
    [aux_sym_char_token1] = ACTIONS(2920),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2918),
    [anon_sym_DQUOTE] = ACTIONS(2918),
    [anon_sym_AT_DQUOTE] = ACTIONS(2920),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2920),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2920),
    [sym_bool] = ACTIONS(2918),
    [sym_unit] = ACTIONS(2920),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2918),
    [sym_op_identifier] = ACTIONS(2918),
    [anon_sym_PLUS] = ACTIONS(2918),
    [anon_sym_DASH] = ACTIONS(2918),
    [anon_sym_PLUS_DOT] = ACTIONS(2918),
    [anon_sym_DASH_DOT] = ACTIONS(2918),
    [anon_sym_PERCENT] = ACTIONS(2918),
    [anon_sym_AMP_AMP] = ACTIONS(2918),
    [anon_sym_TILDE] = ACTIONS(2920),
    [aux_sym_prefix_op_token1] = ACTIONS(2918),
    [aux_sym_infix_op_token1] = ACTIONS(2920),
    [aux_sym_infix_op_token2] = ACTIONS(2918),
    [anon_sym_PIPE_PIPE] = ACTIONS(2918),
    [anon_sym_BANG_EQ] = ACTIONS(2918),
    [anon_sym_COLON_EQ] = ACTIONS(2920),
    [anon_sym_DOLLAR] = ACTIONS(2918),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2918),
    [sym_int] = ACTIONS(2918),
    [sym_xint] = ACTIONS(2920),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2920),
    [sym__newline] = ACTIONS(2920),
    [sym__dedent] = ACTIONS(2920),
  },
  [2055] = {
    [sym_block_comment] = STATE(2055),
    [sym_compiler_directive_decl] = STATE(2055),
    [sym_fsi_directive_decl] = STATE(2055),
    [sym_preproc_line] = STATE(2055),
    [sym_identifier] = ACTIONS(2922),
    [anon_sym_EQ] = ACTIONS(2924),
    [anon_sym_COLON] = ACTIONS(2922),
    [anon_sym_return] = ACTIONS(2922),
    [anon_sym_do] = ACTIONS(2922),
    [anon_sym_and] = ACTIONS(2922),
    [anon_sym_let] = ACTIONS(2922),
    [anon_sym_let_BANG] = ACTIONS(2924),
    [anon_sym_LPAREN] = ACTIONS(2922),
    [anon_sym_COMMA] = ACTIONS(2924),
    [anon_sym_null] = ACTIONS(2922),
    [anon_sym_QMARK] = ACTIONS(2922),
    [anon_sym_COLON_QMARK] = ACTIONS(2922),
    [anon_sym_COLON_COLON] = ACTIONS(2924),
    [anon_sym_AMP] = ACTIONS(2922),
    [anon_sym_LBRACK] = ACTIONS(2922),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2924),
    [anon_sym_LBRACE] = ACTIONS(2922),
    [anon_sym_LT_AT] = ACTIONS(2922),
    [anon_sym_LT_AT_AT] = ACTIONS(2922),
    [anon_sym_DOT] = ACTIONS(2922),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2924),
    [anon_sym_new] = ACTIONS(2922),
    [anon_sym_return_BANG] = ACTIONS(2924),
    [anon_sym_yield] = ACTIONS(2922),
    [anon_sym_yield_BANG] = ACTIONS(2924),
    [anon_sym_lazy] = ACTIONS(2922),
    [anon_sym_assert] = ACTIONS(2922),
    [anon_sym_upcast] = ACTIONS(2922),
    [anon_sym_downcast] = ACTIONS(2922),
    [anon_sym_COLON_GT] = ACTIONS(2924),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2924),
    [anon_sym_for] = ACTIONS(2922),
    [anon_sym_while] = ACTIONS(2922),
    [anon_sym_if] = ACTIONS(2922),
    [anon_sym_fun] = ACTIONS(2922),
    [anon_sym_try] = ACTIONS(2922),
    [anon_sym_match] = ACTIONS(2922),
    [anon_sym_match_BANG] = ACTIONS(2924),
    [anon_sym_function] = ACTIONS(2922),
    [anon_sym_LT_DASH] = ACTIONS(2922),
    [anon_sym_DOT_LBRACK] = ACTIONS(2924),
    [anon_sym_LT] = ACTIONS(2924),
    [anon_sym_use] = ACTIONS(2922),
    [anon_sym_use_BANG] = ACTIONS(2924),
    [anon_sym_do_BANG] = ACTIONS(2924),
    [anon_sym_begin] = ACTIONS(2922),
    [anon_sym_LPAREN2] = ACTIONS(2922),
    [anon_sym_or] = ACTIONS(2922),
    [aux_sym_char_token1] = ACTIONS(2924),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2922),
    [anon_sym_DQUOTE] = ACTIONS(2922),
    [anon_sym_AT_DQUOTE] = ACTIONS(2924),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2924),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2924),
    [sym_bool] = ACTIONS(2922),
    [sym_unit] = ACTIONS(2924),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2922),
    [sym_op_identifier] = ACTIONS(2922),
    [anon_sym_PLUS] = ACTIONS(2922),
    [anon_sym_DASH] = ACTIONS(2922),
    [anon_sym_PLUS_DOT] = ACTIONS(2922),
    [anon_sym_DASH_DOT] = ACTIONS(2922),
    [anon_sym_PERCENT] = ACTIONS(2922),
    [anon_sym_AMP_AMP] = ACTIONS(2922),
    [anon_sym_TILDE] = ACTIONS(2924),
    [aux_sym_prefix_op_token1] = ACTIONS(2922),
    [aux_sym_infix_op_token1] = ACTIONS(2924),
    [aux_sym_infix_op_token2] = ACTIONS(2922),
    [anon_sym_PIPE_PIPE] = ACTIONS(2922),
    [anon_sym_BANG_EQ] = ACTIONS(2922),
    [anon_sym_COLON_EQ] = ACTIONS(2924),
    [anon_sym_DOLLAR] = ACTIONS(2922),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2922),
    [sym_int] = ACTIONS(2922),
    [sym_xint] = ACTIONS(2924),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2924),
    [sym__newline] = ACTIONS(2924),
    [sym__dedent] = ACTIONS(2924),
  },
  [2056] = {
    [sym_block_comment] = STATE(2056),
    [sym_compiler_directive_decl] = STATE(2056),
    [sym_fsi_directive_decl] = STATE(2056),
    [sym_preproc_line] = STATE(2056),
    [sym_identifier] = ACTIONS(2930),
    [anon_sym_EQ] = ACTIONS(2932),
    [anon_sym_COLON] = ACTIONS(2930),
    [anon_sym_return] = ACTIONS(2930),
    [anon_sym_do] = ACTIONS(2930),
    [anon_sym_let] = ACTIONS(2930),
    [anon_sym_let_BANG] = ACTIONS(2932),
    [anon_sym_LPAREN] = ACTIONS(2930),
    [anon_sym_COMMA] = ACTIONS(2932),
    [anon_sym_null] = ACTIONS(2930),
    [anon_sym_QMARK] = ACTIONS(2930),
    [anon_sym_COLON_QMARK] = ACTIONS(2930),
    [anon_sym_COLON_COLON] = ACTIONS(2932),
    [anon_sym_AMP] = ACTIONS(2930),
    [anon_sym_LBRACK] = ACTIONS(2930),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2932),
    [anon_sym_LBRACE] = ACTIONS(2930),
    [anon_sym_LT_AT] = ACTIONS(2930),
    [anon_sym_LT_AT_AT] = ACTIONS(2930),
    [anon_sym_DOT] = ACTIONS(2930),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2932),
    [anon_sym_new] = ACTIONS(2930),
    [anon_sym_return_BANG] = ACTIONS(2932),
    [anon_sym_yield] = ACTIONS(2930),
    [anon_sym_yield_BANG] = ACTIONS(2932),
    [anon_sym_lazy] = ACTIONS(2930),
    [anon_sym_assert] = ACTIONS(2930),
    [anon_sym_upcast] = ACTIONS(2930),
    [anon_sym_downcast] = ACTIONS(2930),
    [anon_sym_COLON_GT] = ACTIONS(2932),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2932),
    [anon_sym_for] = ACTIONS(2930),
    [anon_sym_while] = ACTIONS(2930),
    [anon_sym_if] = ACTIONS(2930),
    [anon_sym_fun] = ACTIONS(2930),
    [anon_sym_try] = ACTIONS(2930),
    [anon_sym_match] = ACTIONS(2930),
    [anon_sym_match_BANG] = ACTIONS(2932),
    [anon_sym_function] = ACTIONS(2930),
    [anon_sym_LT_DASH] = ACTIONS(2930),
    [anon_sym_DOT_LBRACK] = ACTIONS(2932),
    [anon_sym_LT] = ACTIONS(2932),
    [anon_sym_use] = ACTIONS(2930),
    [anon_sym_use_BANG] = ACTIONS(2932),
    [anon_sym_do_BANG] = ACTIONS(2932),
    [anon_sym_begin] = ACTIONS(2930),
    [anon_sym_LPAREN2] = ACTIONS(2930),
    [anon_sym_or] = ACTIONS(2930),
    [aux_sym_char_token1] = ACTIONS(2932),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2930),
    [anon_sym_DQUOTE] = ACTIONS(2930),
    [anon_sym_AT_DQUOTE] = ACTIONS(2932),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2932),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2932),
    [sym_bool] = ACTIONS(2930),
    [sym_unit] = ACTIONS(2932),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2930),
    [sym_op_identifier] = ACTIONS(2930),
    [anon_sym_PLUS] = ACTIONS(2930),
    [anon_sym_DASH] = ACTIONS(2930),
    [anon_sym_PLUS_DOT] = ACTIONS(2930),
    [anon_sym_DASH_DOT] = ACTIONS(2930),
    [anon_sym_PERCENT] = ACTIONS(2930),
    [anon_sym_AMP_AMP] = ACTIONS(2930),
    [anon_sym_TILDE] = ACTIONS(2932),
    [aux_sym_prefix_op_token1] = ACTIONS(2930),
    [aux_sym_infix_op_token1] = ACTIONS(2932),
    [aux_sym_infix_op_token2] = ACTIONS(2930),
    [anon_sym_PIPE_PIPE] = ACTIONS(2930),
    [anon_sym_BANG_EQ] = ACTIONS(2930),
    [anon_sym_COLON_EQ] = ACTIONS(2932),
    [anon_sym_DOLLAR] = ACTIONS(2930),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2930),
    [sym_int] = ACTIONS(2930),
    [sym_xint] = ACTIONS(2932),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2932),
    [anon_sym_POUNDendif] = ACTIONS(2932),
    [anon_sym_POUNDelse] = ACTIONS(2932),
    [sym__newline] = ACTIONS(2932),
  },
  [2057] = {
    [sym_block_comment] = STATE(2057),
    [sym_compiler_directive_decl] = STATE(2057),
    [sym_fsi_directive_decl] = STATE(2057),
    [sym_preproc_line] = STATE(2057),
    [sym_identifier] = ACTIONS(2926),
    [anon_sym_EQ] = ACTIONS(2928),
    [anon_sym_COLON] = ACTIONS(2926),
    [anon_sym_return] = ACTIONS(2926),
    [anon_sym_do] = ACTIONS(2926),
    [anon_sym_and] = ACTIONS(2926),
    [anon_sym_let] = ACTIONS(2926),
    [anon_sym_let_BANG] = ACTIONS(2928),
    [anon_sym_LPAREN] = ACTIONS(2926),
    [anon_sym_COMMA] = ACTIONS(2928),
    [anon_sym_null] = ACTIONS(2926),
    [anon_sym_QMARK] = ACTIONS(2926),
    [anon_sym_COLON_QMARK] = ACTIONS(2926),
    [anon_sym_COLON_COLON] = ACTIONS(2928),
    [anon_sym_AMP] = ACTIONS(2926),
    [anon_sym_LBRACK] = ACTIONS(2926),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2928),
    [anon_sym_LBRACE] = ACTIONS(2926),
    [anon_sym_LT_AT] = ACTIONS(2926),
    [anon_sym_LT_AT_AT] = ACTIONS(2926),
    [anon_sym_DOT] = ACTIONS(2926),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2928),
    [anon_sym_new] = ACTIONS(2926),
    [anon_sym_return_BANG] = ACTIONS(2928),
    [anon_sym_yield] = ACTIONS(2926),
    [anon_sym_yield_BANG] = ACTIONS(2928),
    [anon_sym_lazy] = ACTIONS(2926),
    [anon_sym_assert] = ACTIONS(2926),
    [anon_sym_upcast] = ACTIONS(2926),
    [anon_sym_downcast] = ACTIONS(2926),
    [anon_sym_COLON_GT] = ACTIONS(2928),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2928),
    [anon_sym_for] = ACTIONS(2926),
    [anon_sym_while] = ACTIONS(2926),
    [anon_sym_if] = ACTIONS(2926),
    [anon_sym_fun] = ACTIONS(2926),
    [anon_sym_try] = ACTIONS(2926),
    [anon_sym_match] = ACTIONS(2926),
    [anon_sym_match_BANG] = ACTIONS(2928),
    [anon_sym_function] = ACTIONS(2926),
    [anon_sym_LT_DASH] = ACTIONS(2926),
    [anon_sym_DOT_LBRACK] = ACTIONS(2928),
    [anon_sym_LT] = ACTIONS(2928),
    [anon_sym_use] = ACTIONS(2926),
    [anon_sym_use_BANG] = ACTIONS(2928),
    [anon_sym_do_BANG] = ACTIONS(2928),
    [anon_sym_begin] = ACTIONS(2926),
    [anon_sym_LPAREN2] = ACTIONS(2926),
    [anon_sym_or] = ACTIONS(2926),
    [aux_sym_char_token1] = ACTIONS(2928),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2926),
    [anon_sym_DQUOTE] = ACTIONS(2926),
    [anon_sym_AT_DQUOTE] = ACTIONS(2928),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2928),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2928),
    [sym_bool] = ACTIONS(2926),
    [sym_unit] = ACTIONS(2928),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2926),
    [sym_op_identifier] = ACTIONS(2926),
    [anon_sym_PLUS] = ACTIONS(2926),
    [anon_sym_DASH] = ACTIONS(2926),
    [anon_sym_PLUS_DOT] = ACTIONS(2926),
    [anon_sym_DASH_DOT] = ACTIONS(2926),
    [anon_sym_PERCENT] = ACTIONS(2926),
    [anon_sym_AMP_AMP] = ACTIONS(2926),
    [anon_sym_TILDE] = ACTIONS(2928),
    [aux_sym_prefix_op_token1] = ACTIONS(2926),
    [aux_sym_infix_op_token1] = ACTIONS(2928),
    [aux_sym_infix_op_token2] = ACTIONS(2926),
    [anon_sym_PIPE_PIPE] = ACTIONS(2926),
    [anon_sym_BANG_EQ] = ACTIONS(2926),
    [anon_sym_COLON_EQ] = ACTIONS(2928),
    [anon_sym_DOLLAR] = ACTIONS(2926),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2926),
    [sym_int] = ACTIONS(2926),
    [sym_xint] = ACTIONS(2928),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2928),
    [sym__newline] = ACTIONS(2928),
    [sym__dedent] = ACTIONS(2928),
  },
  [2058] = {
    [sym_block_comment] = STATE(2058),
    [sym_compiler_directive_decl] = STATE(2058),
    [sym_fsi_directive_decl] = STATE(2058),
    [sym_preproc_line] = STATE(2058),
    [sym_identifier] = ACTIONS(2938),
    [anon_sym_EQ] = ACTIONS(2940),
    [anon_sym_COLON] = ACTIONS(2938),
    [anon_sym_return] = ACTIONS(2938),
    [anon_sym_do] = ACTIONS(2938),
    [anon_sym_and] = ACTIONS(2938),
    [anon_sym_let] = ACTIONS(2938),
    [anon_sym_let_BANG] = ACTIONS(2940),
    [anon_sym_LPAREN] = ACTIONS(2938),
    [anon_sym_COMMA] = ACTIONS(2940),
    [anon_sym_null] = ACTIONS(2938),
    [anon_sym_QMARK] = ACTIONS(2938),
    [anon_sym_COLON_QMARK] = ACTIONS(2938),
    [anon_sym_COLON_COLON] = ACTIONS(2940),
    [anon_sym_AMP] = ACTIONS(2938),
    [anon_sym_LBRACK] = ACTIONS(2938),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2940),
    [anon_sym_LBRACE] = ACTIONS(2938),
    [anon_sym_LT_AT] = ACTIONS(2938),
    [anon_sym_LT_AT_AT] = ACTIONS(2938),
    [anon_sym_DOT] = ACTIONS(2938),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2940),
    [anon_sym_new] = ACTIONS(2938),
    [anon_sym_return_BANG] = ACTIONS(2940),
    [anon_sym_yield] = ACTIONS(2938),
    [anon_sym_yield_BANG] = ACTIONS(2940),
    [anon_sym_lazy] = ACTIONS(2938),
    [anon_sym_assert] = ACTIONS(2938),
    [anon_sym_upcast] = ACTIONS(2938),
    [anon_sym_downcast] = ACTIONS(2938),
    [anon_sym_COLON_GT] = ACTIONS(2940),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2940),
    [anon_sym_for] = ACTIONS(2938),
    [anon_sym_while] = ACTIONS(2938),
    [anon_sym_if] = ACTIONS(2938),
    [anon_sym_fun] = ACTIONS(2938),
    [anon_sym_try] = ACTIONS(2938),
    [anon_sym_match] = ACTIONS(2938),
    [anon_sym_match_BANG] = ACTIONS(2940),
    [anon_sym_function] = ACTIONS(2938),
    [anon_sym_LT_DASH] = ACTIONS(2938),
    [anon_sym_DOT_LBRACK] = ACTIONS(2940),
    [anon_sym_LT] = ACTIONS(2940),
    [anon_sym_use] = ACTIONS(2938),
    [anon_sym_use_BANG] = ACTIONS(2940),
    [anon_sym_do_BANG] = ACTIONS(2940),
    [anon_sym_begin] = ACTIONS(2938),
    [anon_sym_LPAREN2] = ACTIONS(2938),
    [anon_sym_or] = ACTIONS(2938),
    [aux_sym_char_token1] = ACTIONS(2940),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2938),
    [anon_sym_DQUOTE] = ACTIONS(2938),
    [anon_sym_AT_DQUOTE] = ACTIONS(2940),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2940),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2940),
    [sym_bool] = ACTIONS(2938),
    [sym_unit] = ACTIONS(2940),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2938),
    [sym_op_identifier] = ACTIONS(2938),
    [anon_sym_PLUS] = ACTIONS(2938),
    [anon_sym_DASH] = ACTIONS(2938),
    [anon_sym_PLUS_DOT] = ACTIONS(2938),
    [anon_sym_DASH_DOT] = ACTIONS(2938),
    [anon_sym_PERCENT] = ACTIONS(2938),
    [anon_sym_AMP_AMP] = ACTIONS(2938),
    [anon_sym_TILDE] = ACTIONS(2940),
    [aux_sym_prefix_op_token1] = ACTIONS(2938),
    [aux_sym_infix_op_token1] = ACTIONS(2940),
    [aux_sym_infix_op_token2] = ACTIONS(2938),
    [anon_sym_PIPE_PIPE] = ACTIONS(2938),
    [anon_sym_BANG_EQ] = ACTIONS(2938),
    [anon_sym_COLON_EQ] = ACTIONS(2940),
    [anon_sym_DOLLAR] = ACTIONS(2938),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2938),
    [sym_int] = ACTIONS(2938),
    [sym_xint] = ACTIONS(2940),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2940),
    [sym__newline] = ACTIONS(2940),
    [sym__dedent] = ACTIONS(2940),
  },
  [2059] = {
    [sym_block_comment] = STATE(2059),
    [sym_compiler_directive_decl] = STATE(2059),
    [sym_fsi_directive_decl] = STATE(2059),
    [sym_preproc_line] = STATE(2059),
    [sym_identifier] = ACTIONS(2946),
    [anon_sym_EQ] = ACTIONS(2948),
    [anon_sym_COLON] = ACTIONS(2946),
    [anon_sym_return] = ACTIONS(2946),
    [anon_sym_do] = ACTIONS(2946),
    [anon_sym_and] = ACTIONS(2946),
    [anon_sym_let] = ACTIONS(2946),
    [anon_sym_let_BANG] = ACTIONS(2948),
    [anon_sym_LPAREN] = ACTIONS(2946),
    [anon_sym_COMMA] = ACTIONS(2948),
    [anon_sym_null] = ACTIONS(2946),
    [anon_sym_QMARK] = ACTIONS(2946),
    [anon_sym_COLON_QMARK] = ACTIONS(2946),
    [anon_sym_COLON_COLON] = ACTIONS(2948),
    [anon_sym_AMP] = ACTIONS(2946),
    [anon_sym_LBRACK] = ACTIONS(2946),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2948),
    [anon_sym_LBRACE] = ACTIONS(2946),
    [anon_sym_LT_AT] = ACTIONS(2946),
    [anon_sym_LT_AT_AT] = ACTIONS(2946),
    [anon_sym_DOT] = ACTIONS(2946),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2948),
    [anon_sym_new] = ACTIONS(2946),
    [anon_sym_return_BANG] = ACTIONS(2948),
    [anon_sym_yield] = ACTIONS(2946),
    [anon_sym_yield_BANG] = ACTIONS(2948),
    [anon_sym_lazy] = ACTIONS(2946),
    [anon_sym_assert] = ACTIONS(2946),
    [anon_sym_upcast] = ACTIONS(2946),
    [anon_sym_downcast] = ACTIONS(2946),
    [anon_sym_COLON_GT] = ACTIONS(2948),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2948),
    [anon_sym_for] = ACTIONS(2946),
    [anon_sym_while] = ACTIONS(2946),
    [anon_sym_if] = ACTIONS(2946),
    [anon_sym_fun] = ACTIONS(2946),
    [anon_sym_try] = ACTIONS(2946),
    [anon_sym_match] = ACTIONS(2946),
    [anon_sym_match_BANG] = ACTIONS(2948),
    [anon_sym_function] = ACTIONS(2946),
    [anon_sym_LT_DASH] = ACTIONS(2946),
    [anon_sym_DOT_LBRACK] = ACTIONS(2948),
    [anon_sym_LT] = ACTIONS(2948),
    [anon_sym_use] = ACTIONS(2946),
    [anon_sym_use_BANG] = ACTIONS(2948),
    [anon_sym_do_BANG] = ACTIONS(2948),
    [anon_sym_begin] = ACTIONS(2946),
    [anon_sym_LPAREN2] = ACTIONS(2946),
    [anon_sym_or] = ACTIONS(2946),
    [aux_sym_char_token1] = ACTIONS(2948),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2946),
    [anon_sym_DQUOTE] = ACTIONS(2946),
    [anon_sym_AT_DQUOTE] = ACTIONS(2948),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2948),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2948),
    [sym_bool] = ACTIONS(2946),
    [sym_unit] = ACTIONS(2948),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2946),
    [sym_op_identifier] = ACTIONS(2946),
    [anon_sym_PLUS] = ACTIONS(2946),
    [anon_sym_DASH] = ACTIONS(2946),
    [anon_sym_PLUS_DOT] = ACTIONS(2946),
    [anon_sym_DASH_DOT] = ACTIONS(2946),
    [anon_sym_PERCENT] = ACTIONS(2946),
    [anon_sym_AMP_AMP] = ACTIONS(2946),
    [anon_sym_TILDE] = ACTIONS(2948),
    [aux_sym_prefix_op_token1] = ACTIONS(2946),
    [aux_sym_infix_op_token1] = ACTIONS(2948),
    [aux_sym_infix_op_token2] = ACTIONS(2946),
    [anon_sym_PIPE_PIPE] = ACTIONS(2946),
    [anon_sym_BANG_EQ] = ACTIONS(2946),
    [anon_sym_COLON_EQ] = ACTIONS(2948),
    [anon_sym_DOLLAR] = ACTIONS(2946),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2946),
    [sym_int] = ACTIONS(2946),
    [sym_xint] = ACTIONS(2948),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2948),
    [sym__newline] = ACTIONS(2948),
    [sym__dedent] = ACTIONS(2948),
  },
  [2060] = {
    [sym_block_comment] = STATE(2060),
    [sym_compiler_directive_decl] = STATE(2060),
    [sym_fsi_directive_decl] = STATE(2060),
    [sym_preproc_line] = STATE(2060),
    [sym_identifier] = ACTIONS(2950),
    [anon_sym_EQ] = ACTIONS(2952),
    [anon_sym_COLON] = ACTIONS(2950),
    [anon_sym_return] = ACTIONS(2950),
    [anon_sym_do] = ACTIONS(2950),
    [anon_sym_and] = ACTIONS(2950),
    [anon_sym_let] = ACTIONS(2950),
    [anon_sym_let_BANG] = ACTIONS(2952),
    [anon_sym_LPAREN] = ACTIONS(2950),
    [anon_sym_COMMA] = ACTIONS(2952),
    [anon_sym_null] = ACTIONS(2950),
    [anon_sym_QMARK] = ACTIONS(2950),
    [anon_sym_COLON_QMARK] = ACTIONS(2950),
    [anon_sym_COLON_COLON] = ACTIONS(2952),
    [anon_sym_AMP] = ACTIONS(2950),
    [anon_sym_LBRACK] = ACTIONS(2950),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2952),
    [anon_sym_LBRACE] = ACTIONS(2950),
    [anon_sym_LT_AT] = ACTIONS(2950),
    [anon_sym_LT_AT_AT] = ACTIONS(2950),
    [anon_sym_DOT] = ACTIONS(2950),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2952),
    [anon_sym_new] = ACTIONS(2950),
    [anon_sym_return_BANG] = ACTIONS(2952),
    [anon_sym_yield] = ACTIONS(2950),
    [anon_sym_yield_BANG] = ACTIONS(2952),
    [anon_sym_lazy] = ACTIONS(2950),
    [anon_sym_assert] = ACTIONS(2950),
    [anon_sym_upcast] = ACTIONS(2950),
    [anon_sym_downcast] = ACTIONS(2950),
    [anon_sym_COLON_GT] = ACTIONS(2952),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2952),
    [anon_sym_for] = ACTIONS(2950),
    [anon_sym_while] = ACTIONS(2950),
    [anon_sym_if] = ACTIONS(2950),
    [anon_sym_fun] = ACTIONS(2950),
    [anon_sym_try] = ACTIONS(2950),
    [anon_sym_match] = ACTIONS(2950),
    [anon_sym_match_BANG] = ACTIONS(2952),
    [anon_sym_function] = ACTIONS(2950),
    [anon_sym_LT_DASH] = ACTIONS(2950),
    [anon_sym_DOT_LBRACK] = ACTIONS(2952),
    [anon_sym_LT] = ACTIONS(2952),
    [anon_sym_use] = ACTIONS(2950),
    [anon_sym_use_BANG] = ACTIONS(2952),
    [anon_sym_do_BANG] = ACTIONS(2952),
    [anon_sym_begin] = ACTIONS(2950),
    [anon_sym_LPAREN2] = ACTIONS(2950),
    [anon_sym_or] = ACTIONS(2950),
    [aux_sym_char_token1] = ACTIONS(2952),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2950),
    [anon_sym_DQUOTE] = ACTIONS(2950),
    [anon_sym_AT_DQUOTE] = ACTIONS(2952),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2952),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2952),
    [sym_bool] = ACTIONS(2950),
    [sym_unit] = ACTIONS(2952),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2950),
    [sym_op_identifier] = ACTIONS(2950),
    [anon_sym_PLUS] = ACTIONS(2950),
    [anon_sym_DASH] = ACTIONS(2950),
    [anon_sym_PLUS_DOT] = ACTIONS(2950),
    [anon_sym_DASH_DOT] = ACTIONS(2950),
    [anon_sym_PERCENT] = ACTIONS(2950),
    [anon_sym_AMP_AMP] = ACTIONS(2950),
    [anon_sym_TILDE] = ACTIONS(2952),
    [aux_sym_prefix_op_token1] = ACTIONS(2950),
    [aux_sym_infix_op_token1] = ACTIONS(2952),
    [aux_sym_infix_op_token2] = ACTIONS(2950),
    [anon_sym_PIPE_PIPE] = ACTIONS(2950),
    [anon_sym_BANG_EQ] = ACTIONS(2950),
    [anon_sym_COLON_EQ] = ACTIONS(2952),
    [anon_sym_DOLLAR] = ACTIONS(2950),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2950),
    [sym_int] = ACTIONS(2950),
    [sym_xint] = ACTIONS(2952),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2952),
    [sym__newline] = ACTIONS(2952),
    [sym__dedent] = ACTIONS(2952),
  },
  [2061] = {
    [sym_block_comment] = STATE(2061),
    [sym_compiler_directive_decl] = STATE(2061),
    [sym_fsi_directive_decl] = STATE(2061),
    [sym_preproc_line] = STATE(2061),
    [sym_identifier] = ACTIONS(2958),
    [anon_sym_EQ] = ACTIONS(2960),
    [anon_sym_COLON] = ACTIONS(2958),
    [anon_sym_return] = ACTIONS(2958),
    [anon_sym_do] = ACTIONS(2958),
    [anon_sym_and] = ACTIONS(2958),
    [anon_sym_let] = ACTIONS(2958),
    [anon_sym_let_BANG] = ACTIONS(2960),
    [anon_sym_LPAREN] = ACTIONS(2958),
    [anon_sym_COMMA] = ACTIONS(2960),
    [anon_sym_null] = ACTIONS(2958),
    [anon_sym_QMARK] = ACTIONS(2958),
    [anon_sym_COLON_QMARK] = ACTIONS(2958),
    [anon_sym_COLON_COLON] = ACTIONS(2960),
    [anon_sym_AMP] = ACTIONS(2958),
    [anon_sym_LBRACK] = ACTIONS(2958),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2960),
    [anon_sym_LBRACE] = ACTIONS(2958),
    [anon_sym_LT_AT] = ACTIONS(2958),
    [anon_sym_LT_AT_AT] = ACTIONS(2958),
    [anon_sym_DOT] = ACTIONS(2958),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2960),
    [anon_sym_new] = ACTIONS(2958),
    [anon_sym_return_BANG] = ACTIONS(2960),
    [anon_sym_yield] = ACTIONS(2958),
    [anon_sym_yield_BANG] = ACTIONS(2960),
    [anon_sym_lazy] = ACTIONS(2958),
    [anon_sym_assert] = ACTIONS(2958),
    [anon_sym_upcast] = ACTIONS(2958),
    [anon_sym_downcast] = ACTIONS(2958),
    [anon_sym_COLON_GT] = ACTIONS(2960),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2960),
    [anon_sym_for] = ACTIONS(2958),
    [anon_sym_while] = ACTIONS(2958),
    [anon_sym_if] = ACTIONS(2958),
    [anon_sym_fun] = ACTIONS(2958),
    [anon_sym_try] = ACTIONS(2958),
    [anon_sym_match] = ACTIONS(2958),
    [anon_sym_match_BANG] = ACTIONS(2960),
    [anon_sym_function] = ACTIONS(2958),
    [anon_sym_LT_DASH] = ACTIONS(2958),
    [anon_sym_DOT_LBRACK] = ACTIONS(2960),
    [anon_sym_LT] = ACTIONS(2960),
    [anon_sym_use] = ACTIONS(2958),
    [anon_sym_use_BANG] = ACTIONS(2960),
    [anon_sym_do_BANG] = ACTIONS(2960),
    [anon_sym_begin] = ACTIONS(2958),
    [anon_sym_LPAREN2] = ACTIONS(2958),
    [anon_sym_or] = ACTIONS(2958),
    [aux_sym_char_token1] = ACTIONS(2960),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2958),
    [anon_sym_DQUOTE] = ACTIONS(2958),
    [anon_sym_AT_DQUOTE] = ACTIONS(2960),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2960),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2960),
    [sym_bool] = ACTIONS(2958),
    [sym_unit] = ACTIONS(2960),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2958),
    [sym_op_identifier] = ACTIONS(2958),
    [anon_sym_PLUS] = ACTIONS(2958),
    [anon_sym_DASH] = ACTIONS(2958),
    [anon_sym_PLUS_DOT] = ACTIONS(2958),
    [anon_sym_DASH_DOT] = ACTIONS(2958),
    [anon_sym_PERCENT] = ACTIONS(2958),
    [anon_sym_AMP_AMP] = ACTIONS(2958),
    [anon_sym_TILDE] = ACTIONS(2960),
    [aux_sym_prefix_op_token1] = ACTIONS(2958),
    [aux_sym_infix_op_token1] = ACTIONS(2960),
    [aux_sym_infix_op_token2] = ACTIONS(2958),
    [anon_sym_PIPE_PIPE] = ACTIONS(2958),
    [anon_sym_BANG_EQ] = ACTIONS(2958),
    [anon_sym_COLON_EQ] = ACTIONS(2960),
    [anon_sym_DOLLAR] = ACTIONS(2958),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2958),
    [sym_int] = ACTIONS(2958),
    [sym_xint] = ACTIONS(2960),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2960),
    [sym__newline] = ACTIONS(2960),
    [sym__dedent] = ACTIONS(2960),
  },
  [2062] = {
    [sym_block_comment] = STATE(2062),
    [sym_compiler_directive_decl] = STATE(2062),
    [sym_fsi_directive_decl] = STATE(2062),
    [sym_preproc_line] = STATE(2062),
    [aux_sym_sequential_expression_repeat1] = STATE(2062),
    [sym_identifier] = ACTIONS(2895),
    [anon_sym_EQ] = ACTIONS(2897),
    [anon_sym_COLON] = ACTIONS(2895),
    [anon_sym_return] = ACTIONS(2895),
    [anon_sym_do] = ACTIONS(2895),
    [anon_sym_let] = ACTIONS(2895),
    [anon_sym_let_BANG] = ACTIONS(2897),
    [anon_sym_LPAREN] = ACTIONS(2895),
    [anon_sym_COMMA] = ACTIONS(2897),
    [anon_sym_null] = ACTIONS(2895),
    [anon_sym_QMARK] = ACTIONS(2895),
    [anon_sym_COLON_QMARK] = ACTIONS(2895),
    [anon_sym_COLON_COLON] = ACTIONS(2897),
    [anon_sym_AMP] = ACTIONS(2895),
    [anon_sym_LBRACK] = ACTIONS(2895),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2897),
    [anon_sym_LBRACE] = ACTIONS(2895),
    [anon_sym_LT_AT] = ACTIONS(2895),
    [anon_sym_LT_AT_AT] = ACTIONS(2895),
    [anon_sym_DOT] = ACTIONS(2895),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2897),
    [anon_sym_new] = ACTIONS(2895),
    [anon_sym_return_BANG] = ACTIONS(2897),
    [anon_sym_yield] = ACTIONS(2895),
    [anon_sym_yield_BANG] = ACTIONS(2897),
    [anon_sym_lazy] = ACTIONS(2895),
    [anon_sym_assert] = ACTIONS(2895),
    [anon_sym_upcast] = ACTIONS(2895),
    [anon_sym_downcast] = ACTIONS(2895),
    [anon_sym_COLON_GT] = ACTIONS(2897),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2897),
    [anon_sym_for] = ACTIONS(2895),
    [anon_sym_while] = ACTIONS(2895),
    [anon_sym_if] = ACTIONS(2895),
    [anon_sym_fun] = ACTIONS(2895),
    [anon_sym_try] = ACTIONS(2895),
    [anon_sym_match] = ACTIONS(2895),
    [anon_sym_match_BANG] = ACTIONS(2897),
    [anon_sym_function] = ACTIONS(2895),
    [anon_sym_LT_DASH] = ACTIONS(2895),
    [anon_sym_DOT_LBRACK] = ACTIONS(2897),
    [anon_sym_LT] = ACTIONS(2897),
    [anon_sym_use] = ACTIONS(2895),
    [anon_sym_use_BANG] = ACTIONS(2897),
    [anon_sym_do_BANG] = ACTIONS(2897),
    [anon_sym_DOT_DOT] = ACTIONS(2897),
    [anon_sym_begin] = ACTIONS(2895),
    [anon_sym_LPAREN2] = ACTIONS(2895),
    [anon_sym_or] = ACTIONS(2895),
    [aux_sym_char_token1] = ACTIONS(2897),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2895),
    [anon_sym_DQUOTE] = ACTIONS(2895),
    [anon_sym_AT_DQUOTE] = ACTIONS(2897),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2897),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2897),
    [sym_bool] = ACTIONS(2895),
    [sym_unit] = ACTIONS(2897),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2895),
    [sym_op_identifier] = ACTIONS(2895),
    [anon_sym_PLUS] = ACTIONS(2895),
    [anon_sym_DASH] = ACTIONS(2895),
    [anon_sym_PLUS_DOT] = ACTIONS(2895),
    [anon_sym_DASH_DOT] = ACTIONS(2895),
    [anon_sym_PERCENT] = ACTIONS(2895),
    [anon_sym_AMP_AMP] = ACTIONS(2895),
    [anon_sym_TILDE] = ACTIONS(2897),
    [aux_sym_prefix_op_token1] = ACTIONS(2895),
    [aux_sym_infix_op_token1] = ACTIONS(2897),
    [aux_sym_infix_op_token2] = ACTIONS(2895),
    [anon_sym_PIPE_PIPE] = ACTIONS(2895),
    [anon_sym_BANG_EQ] = ACTIONS(2895),
    [anon_sym_COLON_EQ] = ACTIONS(2897),
    [anon_sym_DOLLAR] = ACTIONS(2895),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2895),
    [sym_int] = ACTIONS(2895),
    [sym_xint] = ACTIONS(2897),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2897),
    [sym__newline] = ACTIONS(4191),
  },
  [2063] = {
    [sym_block_comment] = STATE(2063),
    [sym_compiler_directive_decl] = STATE(2063),
    [sym_fsi_directive_decl] = STATE(2063),
    [sym_preproc_line] = STATE(2063),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_EQ] = ACTIONS(3017),
    [anon_sym_COLON] = ACTIONS(3015),
    [anon_sym_return] = ACTIONS(3015),
    [anon_sym_do] = ACTIONS(3015),
    [anon_sym_let] = ACTIONS(3015),
    [anon_sym_let_BANG] = ACTIONS(3017),
    [anon_sym_LPAREN] = ACTIONS(3015),
    [anon_sym_COMMA] = ACTIONS(3017),
    [anon_sym_null] = ACTIONS(3015),
    [anon_sym_QMARK] = ACTIONS(3015),
    [anon_sym_COLON_QMARK] = ACTIONS(3015),
    [anon_sym_COLON_COLON] = ACTIONS(3017),
    [anon_sym_AMP] = ACTIONS(3015),
    [anon_sym_LBRACK] = ACTIONS(3015),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3017),
    [anon_sym_LBRACE] = ACTIONS(3015),
    [anon_sym_LT_AT] = ACTIONS(3015),
    [anon_sym_LT_AT_AT] = ACTIONS(3015),
    [anon_sym_DOT] = ACTIONS(3015),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3017),
    [anon_sym_new] = ACTIONS(3015),
    [anon_sym_return_BANG] = ACTIONS(3017),
    [anon_sym_yield] = ACTIONS(3015),
    [anon_sym_yield_BANG] = ACTIONS(3017),
    [anon_sym_lazy] = ACTIONS(3015),
    [anon_sym_assert] = ACTIONS(3015),
    [anon_sym_upcast] = ACTIONS(3015),
    [anon_sym_downcast] = ACTIONS(3015),
    [anon_sym_COLON_GT] = ACTIONS(3017),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3017),
    [anon_sym_for] = ACTIONS(3015),
    [anon_sym_while] = ACTIONS(3015),
    [anon_sym_if] = ACTIONS(3015),
    [anon_sym_fun] = ACTIONS(3015),
    [anon_sym_try] = ACTIONS(3015),
    [anon_sym_match] = ACTIONS(3015),
    [anon_sym_match_BANG] = ACTIONS(3017),
    [anon_sym_function] = ACTIONS(3015),
    [anon_sym_LT_DASH] = ACTIONS(3015),
    [anon_sym_DOT_LBRACK] = ACTIONS(3017),
    [anon_sym_LT] = ACTIONS(3017),
    [anon_sym_use] = ACTIONS(3015),
    [anon_sym_use_BANG] = ACTIONS(3017),
    [anon_sym_do_BANG] = ACTIONS(3017),
    [anon_sym_begin] = ACTIONS(3015),
    [anon_sym_LPAREN2] = ACTIONS(3015),
    [anon_sym_or] = ACTIONS(3015),
    [aux_sym_char_token1] = ACTIONS(3017),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3015),
    [anon_sym_DQUOTE] = ACTIONS(3015),
    [anon_sym_AT_DQUOTE] = ACTIONS(3017),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3017),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3017),
    [sym_bool] = ACTIONS(3015),
    [sym_unit] = ACTIONS(3017),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3015),
    [sym_op_identifier] = ACTIONS(3015),
    [anon_sym_PLUS] = ACTIONS(3015),
    [anon_sym_DASH] = ACTIONS(3015),
    [anon_sym_PLUS_DOT] = ACTIONS(3015),
    [anon_sym_DASH_DOT] = ACTIONS(3015),
    [anon_sym_PERCENT] = ACTIONS(3015),
    [anon_sym_AMP_AMP] = ACTIONS(3015),
    [anon_sym_TILDE] = ACTIONS(3017),
    [aux_sym_prefix_op_token1] = ACTIONS(3015),
    [aux_sym_infix_op_token1] = ACTIONS(3017),
    [aux_sym_infix_op_token2] = ACTIONS(3015),
    [anon_sym_PIPE_PIPE] = ACTIONS(3015),
    [anon_sym_BANG_EQ] = ACTIONS(3015),
    [anon_sym_COLON_EQ] = ACTIONS(3017),
    [anon_sym_DOLLAR] = ACTIONS(3015),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3015),
    [sym_int] = ACTIONS(3015),
    [sym_xint] = ACTIONS(3017),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3017),
    [anon_sym_POUNDendif] = ACTIONS(3017),
    [anon_sym_POUNDelse] = ACTIONS(3017),
    [sym__newline] = ACTIONS(3017),
  },
  [2064] = {
    [sym_block_comment] = STATE(2064),
    [sym_compiler_directive_decl] = STATE(2064),
    [sym_fsi_directive_decl] = STATE(2064),
    [sym_preproc_line] = STATE(2064),
    [sym_identifier] = ACTIONS(3007),
    [anon_sym_EQ] = ACTIONS(3009),
    [anon_sym_COLON] = ACTIONS(3007),
    [anon_sym_return] = ACTIONS(3007),
    [anon_sym_do] = ACTIONS(3007),
    [anon_sym_let] = ACTIONS(3007),
    [anon_sym_let_BANG] = ACTIONS(3009),
    [anon_sym_LPAREN] = ACTIONS(3007),
    [anon_sym_COMMA] = ACTIONS(3009),
    [anon_sym_null] = ACTIONS(3007),
    [anon_sym_QMARK] = ACTIONS(3007),
    [anon_sym_COLON_QMARK] = ACTIONS(3007),
    [anon_sym_COLON_COLON] = ACTIONS(3009),
    [anon_sym_AMP] = ACTIONS(3007),
    [anon_sym_LBRACK] = ACTIONS(3007),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3009),
    [anon_sym_LBRACE] = ACTIONS(3007),
    [anon_sym_LT_AT] = ACTIONS(3007),
    [anon_sym_LT_AT_AT] = ACTIONS(3007),
    [anon_sym_DOT] = ACTIONS(3007),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3009),
    [anon_sym_new] = ACTIONS(3007),
    [anon_sym_return_BANG] = ACTIONS(3009),
    [anon_sym_yield] = ACTIONS(3007),
    [anon_sym_yield_BANG] = ACTIONS(3009),
    [anon_sym_lazy] = ACTIONS(3007),
    [anon_sym_assert] = ACTIONS(3007),
    [anon_sym_upcast] = ACTIONS(3007),
    [anon_sym_downcast] = ACTIONS(3007),
    [anon_sym_COLON_GT] = ACTIONS(3009),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3009),
    [anon_sym_for] = ACTIONS(3007),
    [anon_sym_while] = ACTIONS(3007),
    [anon_sym_if] = ACTIONS(3007),
    [anon_sym_fun] = ACTIONS(3007),
    [anon_sym_try] = ACTIONS(3007),
    [anon_sym_match] = ACTIONS(3007),
    [anon_sym_match_BANG] = ACTIONS(3009),
    [anon_sym_function] = ACTIONS(3007),
    [anon_sym_LT_DASH] = ACTIONS(3007),
    [anon_sym_DOT_LBRACK] = ACTIONS(3009),
    [anon_sym_LT] = ACTIONS(3009),
    [anon_sym_use] = ACTIONS(3007),
    [anon_sym_use_BANG] = ACTIONS(3009),
    [anon_sym_do_BANG] = ACTIONS(3009),
    [anon_sym_begin] = ACTIONS(3007),
    [anon_sym_LPAREN2] = ACTIONS(3007),
    [anon_sym_or] = ACTIONS(3007),
    [aux_sym_char_token1] = ACTIONS(3009),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3007),
    [anon_sym_DQUOTE] = ACTIONS(3007),
    [anon_sym_AT_DQUOTE] = ACTIONS(3009),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3009),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3009),
    [sym_bool] = ACTIONS(3007),
    [sym_unit] = ACTIONS(3009),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3007),
    [sym_op_identifier] = ACTIONS(3007),
    [anon_sym_PLUS] = ACTIONS(3007),
    [anon_sym_DASH] = ACTIONS(3007),
    [anon_sym_PLUS_DOT] = ACTIONS(3007),
    [anon_sym_DASH_DOT] = ACTIONS(3007),
    [anon_sym_PERCENT] = ACTIONS(3007),
    [anon_sym_AMP_AMP] = ACTIONS(3007),
    [anon_sym_TILDE] = ACTIONS(3009),
    [aux_sym_prefix_op_token1] = ACTIONS(3007),
    [aux_sym_infix_op_token1] = ACTIONS(3009),
    [aux_sym_infix_op_token2] = ACTIONS(3007),
    [anon_sym_PIPE_PIPE] = ACTIONS(3007),
    [anon_sym_BANG_EQ] = ACTIONS(3007),
    [anon_sym_COLON_EQ] = ACTIONS(3009),
    [anon_sym_DOLLAR] = ACTIONS(3007),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3007),
    [sym_int] = ACTIONS(3007),
    [sym_xint] = ACTIONS(3009),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3009),
    [anon_sym_POUNDendif] = ACTIONS(3009),
    [anon_sym_POUNDelse] = ACTIONS(3009),
    [sym__newline] = ACTIONS(3009),
  },
  [2065] = {
    [sym_block_comment] = STATE(2065),
    [sym_compiler_directive_decl] = STATE(2065),
    [sym_fsi_directive_decl] = STATE(2065),
    [sym_preproc_line] = STATE(2065),
    [sym_identifier] = ACTIONS(2962),
    [anon_sym_EQ] = ACTIONS(2964),
    [anon_sym_COLON] = ACTIONS(2962),
    [anon_sym_return] = ACTIONS(2962),
    [anon_sym_do] = ACTIONS(2962),
    [anon_sym_and] = ACTIONS(2962),
    [anon_sym_let] = ACTIONS(2962),
    [anon_sym_let_BANG] = ACTIONS(2964),
    [anon_sym_LPAREN] = ACTIONS(2962),
    [anon_sym_COMMA] = ACTIONS(2964),
    [anon_sym_null] = ACTIONS(2962),
    [anon_sym_QMARK] = ACTIONS(2962),
    [anon_sym_COLON_QMARK] = ACTIONS(2962),
    [anon_sym_COLON_COLON] = ACTIONS(2964),
    [anon_sym_AMP] = ACTIONS(2962),
    [anon_sym_LBRACK] = ACTIONS(2962),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2964),
    [anon_sym_LBRACE] = ACTIONS(2962),
    [anon_sym_LT_AT] = ACTIONS(2962),
    [anon_sym_LT_AT_AT] = ACTIONS(2962),
    [anon_sym_DOT] = ACTIONS(2962),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2964),
    [anon_sym_new] = ACTIONS(2962),
    [anon_sym_return_BANG] = ACTIONS(2964),
    [anon_sym_yield] = ACTIONS(2962),
    [anon_sym_yield_BANG] = ACTIONS(2964),
    [anon_sym_lazy] = ACTIONS(2962),
    [anon_sym_assert] = ACTIONS(2962),
    [anon_sym_upcast] = ACTIONS(2962),
    [anon_sym_downcast] = ACTIONS(2962),
    [anon_sym_COLON_GT] = ACTIONS(2964),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2964),
    [anon_sym_for] = ACTIONS(2962),
    [anon_sym_while] = ACTIONS(2962),
    [anon_sym_if] = ACTIONS(2962),
    [anon_sym_fun] = ACTIONS(2962),
    [anon_sym_try] = ACTIONS(2962),
    [anon_sym_match] = ACTIONS(2962),
    [anon_sym_match_BANG] = ACTIONS(2964),
    [anon_sym_function] = ACTIONS(2962),
    [anon_sym_LT_DASH] = ACTIONS(2962),
    [anon_sym_DOT_LBRACK] = ACTIONS(2964),
    [anon_sym_LT] = ACTIONS(2964),
    [anon_sym_use] = ACTIONS(2962),
    [anon_sym_use_BANG] = ACTIONS(2964),
    [anon_sym_do_BANG] = ACTIONS(2964),
    [anon_sym_begin] = ACTIONS(2962),
    [anon_sym_LPAREN2] = ACTIONS(2962),
    [anon_sym_or] = ACTIONS(2962),
    [aux_sym_char_token1] = ACTIONS(2964),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2962),
    [anon_sym_DQUOTE] = ACTIONS(2962),
    [anon_sym_AT_DQUOTE] = ACTIONS(2964),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2964),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2964),
    [sym_bool] = ACTIONS(2962),
    [sym_unit] = ACTIONS(2964),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2962),
    [sym_op_identifier] = ACTIONS(2962),
    [anon_sym_PLUS] = ACTIONS(2962),
    [anon_sym_DASH] = ACTIONS(2962),
    [anon_sym_PLUS_DOT] = ACTIONS(2962),
    [anon_sym_DASH_DOT] = ACTIONS(2962),
    [anon_sym_PERCENT] = ACTIONS(2962),
    [anon_sym_AMP_AMP] = ACTIONS(2962),
    [anon_sym_TILDE] = ACTIONS(2964),
    [aux_sym_prefix_op_token1] = ACTIONS(2962),
    [aux_sym_infix_op_token1] = ACTIONS(2964),
    [aux_sym_infix_op_token2] = ACTIONS(2962),
    [anon_sym_PIPE_PIPE] = ACTIONS(2962),
    [anon_sym_BANG_EQ] = ACTIONS(2962),
    [anon_sym_COLON_EQ] = ACTIONS(2964),
    [anon_sym_DOLLAR] = ACTIONS(2962),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2962),
    [sym_int] = ACTIONS(2962),
    [sym_xint] = ACTIONS(2964),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2964),
    [sym__newline] = ACTIONS(2964),
    [sym__dedent] = ACTIONS(2964),
  },
  [2066] = {
    [sym_block_comment] = STATE(2066),
    [sym_compiler_directive_decl] = STATE(2066),
    [sym_fsi_directive_decl] = STATE(2066),
    [sym_preproc_line] = STATE(2066),
    [sym_identifier] = ACTIONS(3003),
    [anon_sym_EQ] = ACTIONS(3005),
    [anon_sym_COLON] = ACTIONS(3003),
    [anon_sym_return] = ACTIONS(3003),
    [anon_sym_do] = ACTIONS(3003),
    [anon_sym_let] = ACTIONS(3003),
    [anon_sym_let_BANG] = ACTIONS(3005),
    [anon_sym_LPAREN] = ACTIONS(3003),
    [anon_sym_COMMA] = ACTIONS(3005),
    [anon_sym_null] = ACTIONS(3003),
    [anon_sym_QMARK] = ACTIONS(3003),
    [anon_sym_COLON_QMARK] = ACTIONS(3003),
    [anon_sym_COLON_COLON] = ACTIONS(3005),
    [anon_sym_AMP] = ACTIONS(3003),
    [anon_sym_LBRACK] = ACTIONS(3003),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3005),
    [anon_sym_LBRACE] = ACTIONS(3003),
    [anon_sym_LT_AT] = ACTIONS(3003),
    [anon_sym_LT_AT_AT] = ACTIONS(3003),
    [anon_sym_DOT] = ACTIONS(3003),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3005),
    [anon_sym_new] = ACTIONS(3003),
    [anon_sym_return_BANG] = ACTIONS(3005),
    [anon_sym_yield] = ACTIONS(3003),
    [anon_sym_yield_BANG] = ACTIONS(3005),
    [anon_sym_lazy] = ACTIONS(3003),
    [anon_sym_assert] = ACTIONS(3003),
    [anon_sym_upcast] = ACTIONS(3003),
    [anon_sym_downcast] = ACTIONS(3003),
    [anon_sym_COLON_GT] = ACTIONS(3005),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3005),
    [anon_sym_for] = ACTIONS(3003),
    [anon_sym_while] = ACTIONS(3003),
    [anon_sym_if] = ACTIONS(3003),
    [anon_sym_fun] = ACTIONS(3003),
    [anon_sym_try] = ACTIONS(3003),
    [anon_sym_match] = ACTIONS(3003),
    [anon_sym_match_BANG] = ACTIONS(3005),
    [anon_sym_function] = ACTIONS(3003),
    [anon_sym_LT_DASH] = ACTIONS(3003),
    [anon_sym_DOT_LBRACK] = ACTIONS(3005),
    [anon_sym_LT] = ACTIONS(3005),
    [anon_sym_use] = ACTIONS(3003),
    [anon_sym_use_BANG] = ACTIONS(3005),
    [anon_sym_do_BANG] = ACTIONS(3005),
    [anon_sym_begin] = ACTIONS(3003),
    [anon_sym_LPAREN2] = ACTIONS(3003),
    [anon_sym_or] = ACTIONS(3003),
    [aux_sym_char_token1] = ACTIONS(3005),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3003),
    [anon_sym_DQUOTE] = ACTIONS(3003),
    [anon_sym_AT_DQUOTE] = ACTIONS(3005),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3005),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3005),
    [sym_bool] = ACTIONS(3003),
    [sym_unit] = ACTIONS(3005),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3003),
    [sym_op_identifier] = ACTIONS(3003),
    [anon_sym_PLUS] = ACTIONS(3003),
    [anon_sym_DASH] = ACTIONS(3003),
    [anon_sym_PLUS_DOT] = ACTIONS(3003),
    [anon_sym_DASH_DOT] = ACTIONS(3003),
    [anon_sym_PERCENT] = ACTIONS(3003),
    [anon_sym_AMP_AMP] = ACTIONS(3003),
    [anon_sym_TILDE] = ACTIONS(3005),
    [aux_sym_prefix_op_token1] = ACTIONS(3003),
    [aux_sym_infix_op_token1] = ACTIONS(3005),
    [aux_sym_infix_op_token2] = ACTIONS(3003),
    [anon_sym_PIPE_PIPE] = ACTIONS(3003),
    [anon_sym_BANG_EQ] = ACTIONS(3003),
    [anon_sym_COLON_EQ] = ACTIONS(3005),
    [anon_sym_DOLLAR] = ACTIONS(3003),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3003),
    [sym_int] = ACTIONS(3003),
    [sym_xint] = ACTIONS(3005),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3005),
    [anon_sym_POUNDendif] = ACTIONS(3005),
    [anon_sym_POUNDelse] = ACTIONS(3005),
    [sym__newline] = ACTIONS(3005),
  },
  [2067] = {
    [sym_block_comment] = STATE(2067),
    [sym_compiler_directive_decl] = STATE(2067),
    [sym_fsi_directive_decl] = STATE(2067),
    [sym_preproc_line] = STATE(2067),
    [sym_identifier] = ACTIONS(2996),
    [anon_sym_EQ] = ACTIONS(2998),
    [anon_sym_COLON] = ACTIONS(2996),
    [anon_sym_return] = ACTIONS(2996),
    [anon_sym_do] = ACTIONS(2996),
    [anon_sym_let] = ACTIONS(2996),
    [anon_sym_let_BANG] = ACTIONS(2998),
    [anon_sym_LPAREN] = ACTIONS(2996),
    [anon_sym_COMMA] = ACTIONS(2998),
    [anon_sym_null] = ACTIONS(2996),
    [anon_sym_QMARK] = ACTIONS(2996),
    [anon_sym_COLON_QMARK] = ACTIONS(2996),
    [anon_sym_COLON_COLON] = ACTIONS(2998),
    [anon_sym_AMP] = ACTIONS(2996),
    [anon_sym_LBRACK] = ACTIONS(2996),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2998),
    [anon_sym_LBRACE] = ACTIONS(2996),
    [anon_sym_LT_AT] = ACTIONS(2996),
    [anon_sym_LT_AT_AT] = ACTIONS(2996),
    [anon_sym_DOT] = ACTIONS(2996),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2998),
    [anon_sym_new] = ACTIONS(2996),
    [anon_sym_return_BANG] = ACTIONS(2998),
    [anon_sym_yield] = ACTIONS(2996),
    [anon_sym_yield_BANG] = ACTIONS(2998),
    [anon_sym_lazy] = ACTIONS(2996),
    [anon_sym_assert] = ACTIONS(2996),
    [anon_sym_upcast] = ACTIONS(2996),
    [anon_sym_downcast] = ACTIONS(2996),
    [anon_sym_COLON_GT] = ACTIONS(2998),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2998),
    [anon_sym_for] = ACTIONS(2996),
    [anon_sym_while] = ACTIONS(2996),
    [anon_sym_if] = ACTIONS(2996),
    [anon_sym_fun] = ACTIONS(2996),
    [anon_sym_try] = ACTIONS(2996),
    [anon_sym_match] = ACTIONS(2996),
    [anon_sym_match_BANG] = ACTIONS(2998),
    [anon_sym_function] = ACTIONS(2996),
    [anon_sym_LT_DASH] = ACTIONS(2996),
    [anon_sym_DOT_LBRACK] = ACTIONS(2998),
    [anon_sym_LT] = ACTIONS(2998),
    [anon_sym_use] = ACTIONS(2996),
    [anon_sym_use_BANG] = ACTIONS(2998),
    [anon_sym_do_BANG] = ACTIONS(2998),
    [anon_sym_begin] = ACTIONS(2996),
    [anon_sym_LPAREN2] = ACTIONS(2996),
    [anon_sym_or] = ACTIONS(2996),
    [aux_sym_char_token1] = ACTIONS(2998),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2996),
    [anon_sym_DQUOTE] = ACTIONS(2996),
    [anon_sym_AT_DQUOTE] = ACTIONS(2998),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2998),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2998),
    [sym_bool] = ACTIONS(2996),
    [sym_unit] = ACTIONS(2998),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2996),
    [sym_op_identifier] = ACTIONS(2996),
    [anon_sym_PLUS] = ACTIONS(2996),
    [anon_sym_DASH] = ACTIONS(2996),
    [anon_sym_PLUS_DOT] = ACTIONS(2996),
    [anon_sym_DASH_DOT] = ACTIONS(2996),
    [anon_sym_PERCENT] = ACTIONS(2996),
    [anon_sym_AMP_AMP] = ACTIONS(2996),
    [anon_sym_TILDE] = ACTIONS(2998),
    [aux_sym_prefix_op_token1] = ACTIONS(2996),
    [aux_sym_infix_op_token1] = ACTIONS(2998),
    [aux_sym_infix_op_token2] = ACTIONS(2996),
    [anon_sym_PIPE_PIPE] = ACTIONS(2996),
    [anon_sym_BANG_EQ] = ACTIONS(2996),
    [anon_sym_COLON_EQ] = ACTIONS(2998),
    [anon_sym_DOLLAR] = ACTIONS(2996),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2996),
    [sym_int] = ACTIONS(2996),
    [sym_xint] = ACTIONS(2998),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2998),
    [anon_sym_POUNDendif] = ACTIONS(2998),
    [anon_sym_POUNDelse] = ACTIONS(2998),
    [sym__newline] = ACTIONS(2998),
  },
  [2068] = {
    [sym_block_comment] = STATE(2068),
    [sym_compiler_directive_decl] = STATE(2068),
    [sym_fsi_directive_decl] = STATE(2068),
    [sym_preproc_line] = STATE(2068),
    [sym_identifier] = ACTIONS(2992),
    [anon_sym_EQ] = ACTIONS(2994),
    [anon_sym_COLON] = ACTIONS(2992),
    [anon_sym_return] = ACTIONS(2992),
    [anon_sym_do] = ACTIONS(2992),
    [anon_sym_let] = ACTIONS(2992),
    [anon_sym_let_BANG] = ACTIONS(2994),
    [anon_sym_LPAREN] = ACTIONS(2992),
    [anon_sym_COMMA] = ACTIONS(2994),
    [anon_sym_null] = ACTIONS(2992),
    [anon_sym_QMARK] = ACTIONS(2992),
    [anon_sym_COLON_QMARK] = ACTIONS(2992),
    [anon_sym_COLON_COLON] = ACTIONS(2994),
    [anon_sym_AMP] = ACTIONS(2992),
    [anon_sym_LBRACK] = ACTIONS(2992),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2994),
    [anon_sym_LBRACE] = ACTIONS(2992),
    [anon_sym_LT_AT] = ACTIONS(2992),
    [anon_sym_LT_AT_AT] = ACTIONS(2992),
    [anon_sym_DOT] = ACTIONS(2992),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2994),
    [anon_sym_new] = ACTIONS(2992),
    [anon_sym_return_BANG] = ACTIONS(2994),
    [anon_sym_yield] = ACTIONS(2992),
    [anon_sym_yield_BANG] = ACTIONS(2994),
    [anon_sym_lazy] = ACTIONS(2992),
    [anon_sym_assert] = ACTIONS(2992),
    [anon_sym_upcast] = ACTIONS(2992),
    [anon_sym_downcast] = ACTIONS(2992),
    [anon_sym_COLON_GT] = ACTIONS(2994),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2994),
    [anon_sym_for] = ACTIONS(2992),
    [anon_sym_while] = ACTIONS(2992),
    [anon_sym_if] = ACTIONS(2992),
    [anon_sym_fun] = ACTIONS(2992),
    [anon_sym_try] = ACTIONS(2992),
    [anon_sym_match] = ACTIONS(2992),
    [anon_sym_match_BANG] = ACTIONS(2994),
    [anon_sym_function] = ACTIONS(2992),
    [anon_sym_LT_DASH] = ACTIONS(2992),
    [anon_sym_DOT_LBRACK] = ACTIONS(2994),
    [anon_sym_LT] = ACTIONS(2994),
    [anon_sym_use] = ACTIONS(2992),
    [anon_sym_use_BANG] = ACTIONS(2994),
    [anon_sym_do_BANG] = ACTIONS(2994),
    [anon_sym_begin] = ACTIONS(2992),
    [anon_sym_LPAREN2] = ACTIONS(2992),
    [anon_sym_or] = ACTIONS(2992),
    [aux_sym_char_token1] = ACTIONS(2994),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2992),
    [anon_sym_DQUOTE] = ACTIONS(2992),
    [anon_sym_AT_DQUOTE] = ACTIONS(2994),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2994),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2994),
    [sym_bool] = ACTIONS(2992),
    [sym_unit] = ACTIONS(2994),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2992),
    [sym_op_identifier] = ACTIONS(2992),
    [anon_sym_PLUS] = ACTIONS(2992),
    [anon_sym_DASH] = ACTIONS(2992),
    [anon_sym_PLUS_DOT] = ACTIONS(2992),
    [anon_sym_DASH_DOT] = ACTIONS(2992),
    [anon_sym_PERCENT] = ACTIONS(2992),
    [anon_sym_AMP_AMP] = ACTIONS(2992),
    [anon_sym_TILDE] = ACTIONS(2994),
    [aux_sym_prefix_op_token1] = ACTIONS(2992),
    [aux_sym_infix_op_token1] = ACTIONS(2994),
    [aux_sym_infix_op_token2] = ACTIONS(2992),
    [anon_sym_PIPE_PIPE] = ACTIONS(2992),
    [anon_sym_BANG_EQ] = ACTIONS(2992),
    [anon_sym_COLON_EQ] = ACTIONS(2994),
    [anon_sym_DOLLAR] = ACTIONS(2992),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2992),
    [sym_int] = ACTIONS(2992),
    [sym_xint] = ACTIONS(2994),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2994),
    [anon_sym_POUNDendif] = ACTIONS(2994),
    [anon_sym_POUNDelse] = ACTIONS(2994),
    [sym__newline] = ACTIONS(2994),
  },
  [2069] = {
    [sym_block_comment] = STATE(2069),
    [sym_compiler_directive_decl] = STATE(2069),
    [sym_fsi_directive_decl] = STATE(2069),
    [sym_preproc_line] = STATE(2069),
    [sym_identifier] = ACTIONS(2978),
    [anon_sym_EQ] = ACTIONS(2980),
    [anon_sym_COLON] = ACTIONS(2978),
    [anon_sym_return] = ACTIONS(2978),
    [anon_sym_do] = ACTIONS(2978),
    [anon_sym_let] = ACTIONS(2978),
    [anon_sym_let_BANG] = ACTIONS(2980),
    [anon_sym_LPAREN] = ACTIONS(2978),
    [anon_sym_COMMA] = ACTIONS(2980),
    [anon_sym_null] = ACTIONS(2978),
    [anon_sym_QMARK] = ACTIONS(2978),
    [anon_sym_COLON_QMARK] = ACTIONS(2978),
    [anon_sym_COLON_COLON] = ACTIONS(2980),
    [anon_sym_AMP] = ACTIONS(2978),
    [anon_sym_LBRACK] = ACTIONS(2978),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2980),
    [anon_sym_LBRACE] = ACTIONS(2978),
    [anon_sym_LT_AT] = ACTIONS(2978),
    [anon_sym_LT_AT_AT] = ACTIONS(2978),
    [anon_sym_DOT] = ACTIONS(2978),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2980),
    [anon_sym_new] = ACTIONS(2978),
    [anon_sym_return_BANG] = ACTIONS(2980),
    [anon_sym_yield] = ACTIONS(2978),
    [anon_sym_yield_BANG] = ACTIONS(2980),
    [anon_sym_lazy] = ACTIONS(2978),
    [anon_sym_assert] = ACTIONS(2978),
    [anon_sym_upcast] = ACTIONS(2978),
    [anon_sym_downcast] = ACTIONS(2978),
    [anon_sym_COLON_GT] = ACTIONS(2980),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2980),
    [anon_sym_for] = ACTIONS(2978),
    [anon_sym_while] = ACTIONS(2978),
    [anon_sym_if] = ACTIONS(2978),
    [anon_sym_fun] = ACTIONS(2978),
    [anon_sym_try] = ACTIONS(2978),
    [anon_sym_match] = ACTIONS(2978),
    [anon_sym_match_BANG] = ACTIONS(2980),
    [anon_sym_function] = ACTIONS(2978),
    [anon_sym_LT_DASH] = ACTIONS(2978),
    [anon_sym_DOT_LBRACK] = ACTIONS(2980),
    [anon_sym_LT] = ACTIONS(2980),
    [anon_sym_use] = ACTIONS(2978),
    [anon_sym_use_BANG] = ACTIONS(2980),
    [anon_sym_do_BANG] = ACTIONS(2980),
    [anon_sym_begin] = ACTIONS(2978),
    [anon_sym_LPAREN2] = ACTIONS(2978),
    [anon_sym_or] = ACTIONS(2978),
    [aux_sym_char_token1] = ACTIONS(2980),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2978),
    [anon_sym_DQUOTE] = ACTIONS(2978),
    [anon_sym_AT_DQUOTE] = ACTIONS(2980),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2980),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2980),
    [sym_bool] = ACTIONS(2978),
    [sym_unit] = ACTIONS(2980),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2978),
    [sym_op_identifier] = ACTIONS(2978),
    [anon_sym_PLUS] = ACTIONS(2978),
    [anon_sym_DASH] = ACTIONS(2978),
    [anon_sym_PLUS_DOT] = ACTIONS(2978),
    [anon_sym_DASH_DOT] = ACTIONS(2978),
    [anon_sym_PERCENT] = ACTIONS(2978),
    [anon_sym_AMP_AMP] = ACTIONS(2978),
    [anon_sym_TILDE] = ACTIONS(2980),
    [aux_sym_prefix_op_token1] = ACTIONS(2978),
    [aux_sym_infix_op_token1] = ACTIONS(2980),
    [aux_sym_infix_op_token2] = ACTIONS(2978),
    [anon_sym_PIPE_PIPE] = ACTIONS(2978),
    [anon_sym_BANG_EQ] = ACTIONS(2978),
    [anon_sym_COLON_EQ] = ACTIONS(2980),
    [anon_sym_DOLLAR] = ACTIONS(2978),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2978),
    [sym_int] = ACTIONS(2978),
    [sym_xint] = ACTIONS(2980),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2980),
    [anon_sym_POUNDendif] = ACTIONS(2980),
    [anon_sym_POUNDelse] = ACTIONS(2980),
    [sym__newline] = ACTIONS(2980),
  },
  [2070] = {
    [sym_block_comment] = STATE(2070),
    [sym_compiler_directive_decl] = STATE(2070),
    [sym_fsi_directive_decl] = STATE(2070),
    [sym_preproc_line] = STATE(2070),
    [sym_identifier] = ACTIONS(2966),
    [anon_sym_EQ] = ACTIONS(2968),
    [anon_sym_COLON] = ACTIONS(2966),
    [anon_sym_return] = ACTIONS(2966),
    [anon_sym_do] = ACTIONS(2966),
    [anon_sym_and] = ACTIONS(2966),
    [anon_sym_let] = ACTIONS(2966),
    [anon_sym_let_BANG] = ACTIONS(2968),
    [anon_sym_LPAREN] = ACTIONS(2966),
    [anon_sym_COMMA] = ACTIONS(2968),
    [anon_sym_null] = ACTIONS(2966),
    [anon_sym_QMARK] = ACTIONS(2966),
    [anon_sym_COLON_QMARK] = ACTIONS(2966),
    [anon_sym_COLON_COLON] = ACTIONS(2968),
    [anon_sym_AMP] = ACTIONS(2966),
    [anon_sym_LBRACK] = ACTIONS(2966),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2968),
    [anon_sym_LBRACE] = ACTIONS(2966),
    [anon_sym_LT_AT] = ACTIONS(2966),
    [anon_sym_LT_AT_AT] = ACTIONS(2966),
    [anon_sym_DOT] = ACTIONS(2966),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2968),
    [anon_sym_new] = ACTIONS(2966),
    [anon_sym_return_BANG] = ACTIONS(2968),
    [anon_sym_yield] = ACTIONS(2966),
    [anon_sym_yield_BANG] = ACTIONS(2968),
    [anon_sym_lazy] = ACTIONS(2966),
    [anon_sym_assert] = ACTIONS(2966),
    [anon_sym_upcast] = ACTIONS(2966),
    [anon_sym_downcast] = ACTIONS(2966),
    [anon_sym_COLON_GT] = ACTIONS(2968),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2968),
    [anon_sym_for] = ACTIONS(2966),
    [anon_sym_while] = ACTIONS(2966),
    [anon_sym_if] = ACTIONS(2966),
    [anon_sym_fun] = ACTIONS(2966),
    [anon_sym_try] = ACTIONS(2966),
    [anon_sym_match] = ACTIONS(2966),
    [anon_sym_match_BANG] = ACTIONS(2968),
    [anon_sym_function] = ACTIONS(2966),
    [anon_sym_LT_DASH] = ACTIONS(2966),
    [anon_sym_DOT_LBRACK] = ACTIONS(2968),
    [anon_sym_LT] = ACTIONS(2968),
    [anon_sym_use] = ACTIONS(2966),
    [anon_sym_use_BANG] = ACTIONS(2968),
    [anon_sym_do_BANG] = ACTIONS(2968),
    [anon_sym_begin] = ACTIONS(2966),
    [anon_sym_LPAREN2] = ACTIONS(2966),
    [anon_sym_or] = ACTIONS(2966),
    [aux_sym_char_token1] = ACTIONS(2968),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2966),
    [anon_sym_DQUOTE] = ACTIONS(2966),
    [anon_sym_AT_DQUOTE] = ACTIONS(2968),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2968),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2968),
    [sym_bool] = ACTIONS(2966),
    [sym_unit] = ACTIONS(2968),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2966),
    [sym_op_identifier] = ACTIONS(2966),
    [anon_sym_PLUS] = ACTIONS(2966),
    [anon_sym_DASH] = ACTIONS(2966),
    [anon_sym_PLUS_DOT] = ACTIONS(2966),
    [anon_sym_DASH_DOT] = ACTIONS(2966),
    [anon_sym_PERCENT] = ACTIONS(2966),
    [anon_sym_AMP_AMP] = ACTIONS(2966),
    [anon_sym_TILDE] = ACTIONS(2968),
    [aux_sym_prefix_op_token1] = ACTIONS(2966),
    [aux_sym_infix_op_token1] = ACTIONS(2968),
    [aux_sym_infix_op_token2] = ACTIONS(2966),
    [anon_sym_PIPE_PIPE] = ACTIONS(2966),
    [anon_sym_BANG_EQ] = ACTIONS(2966),
    [anon_sym_COLON_EQ] = ACTIONS(2968),
    [anon_sym_DOLLAR] = ACTIONS(2966),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2966),
    [sym_int] = ACTIONS(2966),
    [sym_xint] = ACTIONS(2968),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2968),
    [sym__newline] = ACTIONS(2968),
    [sym__dedent] = ACTIONS(2968),
  },
  [2071] = {
    [sym_block_comment] = STATE(2071),
    [sym_compiler_directive_decl] = STATE(2071),
    [sym_fsi_directive_decl] = STATE(2071),
    [sym_preproc_line] = STATE(2071),
    [sym_identifier] = ACTIONS(2974),
    [anon_sym_EQ] = ACTIONS(2976),
    [anon_sym_COLON] = ACTIONS(2974),
    [anon_sym_return] = ACTIONS(2974),
    [anon_sym_do] = ACTIONS(2974),
    [anon_sym_and] = ACTIONS(2974),
    [anon_sym_let] = ACTIONS(2974),
    [anon_sym_let_BANG] = ACTIONS(2976),
    [anon_sym_LPAREN] = ACTIONS(2974),
    [anon_sym_COMMA] = ACTIONS(2976),
    [anon_sym_null] = ACTIONS(2974),
    [anon_sym_QMARK] = ACTIONS(2974),
    [anon_sym_COLON_QMARK] = ACTIONS(2974),
    [anon_sym_COLON_COLON] = ACTIONS(2976),
    [anon_sym_AMP] = ACTIONS(2974),
    [anon_sym_LBRACK] = ACTIONS(2974),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2976),
    [anon_sym_LBRACE] = ACTIONS(2974),
    [anon_sym_LT_AT] = ACTIONS(2974),
    [anon_sym_LT_AT_AT] = ACTIONS(2974),
    [anon_sym_DOT] = ACTIONS(2974),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2976),
    [anon_sym_new] = ACTIONS(2974),
    [anon_sym_return_BANG] = ACTIONS(2976),
    [anon_sym_yield] = ACTIONS(2974),
    [anon_sym_yield_BANG] = ACTIONS(2976),
    [anon_sym_lazy] = ACTIONS(2974),
    [anon_sym_assert] = ACTIONS(2974),
    [anon_sym_upcast] = ACTIONS(2974),
    [anon_sym_downcast] = ACTIONS(2974),
    [anon_sym_COLON_GT] = ACTIONS(2976),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2976),
    [anon_sym_for] = ACTIONS(2974),
    [anon_sym_while] = ACTIONS(2974),
    [anon_sym_if] = ACTIONS(2974),
    [anon_sym_fun] = ACTIONS(2974),
    [anon_sym_try] = ACTIONS(2974),
    [anon_sym_match] = ACTIONS(2974),
    [anon_sym_match_BANG] = ACTIONS(2976),
    [anon_sym_function] = ACTIONS(2974),
    [anon_sym_LT_DASH] = ACTIONS(2974),
    [anon_sym_DOT_LBRACK] = ACTIONS(2976),
    [anon_sym_LT] = ACTIONS(2976),
    [anon_sym_use] = ACTIONS(2974),
    [anon_sym_use_BANG] = ACTIONS(2976),
    [anon_sym_do_BANG] = ACTIONS(2976),
    [anon_sym_begin] = ACTIONS(2974),
    [anon_sym_LPAREN2] = ACTIONS(2974),
    [anon_sym_or] = ACTIONS(2974),
    [aux_sym_char_token1] = ACTIONS(2976),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2974),
    [anon_sym_DQUOTE] = ACTIONS(2974),
    [anon_sym_AT_DQUOTE] = ACTIONS(2976),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2976),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2976),
    [sym_bool] = ACTIONS(2974),
    [sym_unit] = ACTIONS(2976),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2974),
    [sym_op_identifier] = ACTIONS(2974),
    [anon_sym_PLUS] = ACTIONS(2974),
    [anon_sym_DASH] = ACTIONS(2974),
    [anon_sym_PLUS_DOT] = ACTIONS(2974),
    [anon_sym_DASH_DOT] = ACTIONS(2974),
    [anon_sym_PERCENT] = ACTIONS(2974),
    [anon_sym_AMP_AMP] = ACTIONS(2974),
    [anon_sym_TILDE] = ACTIONS(2976),
    [aux_sym_prefix_op_token1] = ACTIONS(2974),
    [aux_sym_infix_op_token1] = ACTIONS(2976),
    [aux_sym_infix_op_token2] = ACTIONS(2974),
    [anon_sym_PIPE_PIPE] = ACTIONS(2974),
    [anon_sym_BANG_EQ] = ACTIONS(2974),
    [anon_sym_COLON_EQ] = ACTIONS(2976),
    [anon_sym_DOLLAR] = ACTIONS(2974),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2974),
    [sym_int] = ACTIONS(2974),
    [sym_xint] = ACTIONS(2976),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2976),
    [sym__newline] = ACTIONS(2976),
    [sym__dedent] = ACTIONS(2976),
  },
  [2072] = {
    [sym_block_comment] = STATE(2072),
    [sym_compiler_directive_decl] = STATE(2072),
    [sym_fsi_directive_decl] = STATE(2072),
    [sym_preproc_line] = STATE(2072),
    [sym_identifier] = ACTIONS(3019),
    [anon_sym_EQ] = ACTIONS(3021),
    [anon_sym_COLON] = ACTIONS(3019),
    [anon_sym_return] = ACTIONS(3019),
    [anon_sym_do] = ACTIONS(3019),
    [anon_sym_and] = ACTIONS(3019),
    [anon_sym_let] = ACTIONS(3019),
    [anon_sym_let_BANG] = ACTIONS(3021),
    [anon_sym_LPAREN] = ACTIONS(3019),
    [anon_sym_COMMA] = ACTIONS(3021),
    [anon_sym_null] = ACTIONS(3019),
    [anon_sym_QMARK] = ACTIONS(3019),
    [anon_sym_COLON_QMARK] = ACTIONS(3019),
    [anon_sym_COLON_COLON] = ACTIONS(3021),
    [anon_sym_AMP] = ACTIONS(3019),
    [anon_sym_LBRACK] = ACTIONS(3019),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3021),
    [anon_sym_LBRACE] = ACTIONS(3019),
    [anon_sym_LT_AT] = ACTIONS(3019),
    [anon_sym_LT_AT_AT] = ACTIONS(3019),
    [anon_sym_DOT] = ACTIONS(3019),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3021),
    [anon_sym_new] = ACTIONS(3019),
    [anon_sym_return_BANG] = ACTIONS(3021),
    [anon_sym_yield] = ACTIONS(3019),
    [anon_sym_yield_BANG] = ACTIONS(3021),
    [anon_sym_lazy] = ACTIONS(3019),
    [anon_sym_assert] = ACTIONS(3019),
    [anon_sym_upcast] = ACTIONS(3019),
    [anon_sym_downcast] = ACTIONS(3019),
    [anon_sym_COLON_GT] = ACTIONS(3021),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3021),
    [anon_sym_for] = ACTIONS(3019),
    [anon_sym_while] = ACTIONS(3019),
    [anon_sym_if] = ACTIONS(3019),
    [anon_sym_fun] = ACTIONS(3019),
    [anon_sym_try] = ACTIONS(3019),
    [anon_sym_match] = ACTIONS(3019),
    [anon_sym_match_BANG] = ACTIONS(3021),
    [anon_sym_function] = ACTIONS(3019),
    [anon_sym_LT_DASH] = ACTIONS(3019),
    [anon_sym_DOT_LBRACK] = ACTIONS(3021),
    [anon_sym_LT] = ACTIONS(3021),
    [anon_sym_use] = ACTIONS(3019),
    [anon_sym_use_BANG] = ACTIONS(3021),
    [anon_sym_do_BANG] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3019),
    [anon_sym_LPAREN2] = ACTIONS(3019),
    [anon_sym_or] = ACTIONS(3019),
    [aux_sym_char_token1] = ACTIONS(3021),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3019),
    [anon_sym_DQUOTE] = ACTIONS(3019),
    [anon_sym_AT_DQUOTE] = ACTIONS(3021),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3021),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3021),
    [sym_bool] = ACTIONS(3019),
    [sym_unit] = ACTIONS(3021),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3019),
    [sym_op_identifier] = ACTIONS(3019),
    [anon_sym_PLUS] = ACTIONS(3019),
    [anon_sym_DASH] = ACTIONS(3019),
    [anon_sym_PLUS_DOT] = ACTIONS(3019),
    [anon_sym_DASH_DOT] = ACTIONS(3019),
    [anon_sym_PERCENT] = ACTIONS(3019),
    [anon_sym_AMP_AMP] = ACTIONS(3019),
    [anon_sym_TILDE] = ACTIONS(3021),
    [aux_sym_prefix_op_token1] = ACTIONS(3019),
    [aux_sym_infix_op_token1] = ACTIONS(3021),
    [aux_sym_infix_op_token2] = ACTIONS(3019),
    [anon_sym_PIPE_PIPE] = ACTIONS(3019),
    [anon_sym_BANG_EQ] = ACTIONS(3019),
    [anon_sym_COLON_EQ] = ACTIONS(3021),
    [anon_sym_DOLLAR] = ACTIONS(3019),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3019),
    [sym_int] = ACTIONS(3019),
    [sym_xint] = ACTIONS(3021),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3021),
    [sym__newline] = ACTIONS(3021),
    [sym__dedent] = ACTIONS(3021),
  },
  [2073] = {
    [sym_block_comment] = STATE(2073),
    [sym_compiler_directive_decl] = STATE(2073),
    [sym_fsi_directive_decl] = STATE(2073),
    [sym_preproc_line] = STATE(2073),
    [sym_identifier] = ACTIONS(3023),
    [anon_sym_EQ] = ACTIONS(3025),
    [anon_sym_COLON] = ACTIONS(3023),
    [anon_sym_return] = ACTIONS(3023),
    [anon_sym_do] = ACTIONS(3023),
    [anon_sym_and] = ACTIONS(3023),
    [anon_sym_let] = ACTIONS(3023),
    [anon_sym_let_BANG] = ACTIONS(3025),
    [anon_sym_LPAREN] = ACTIONS(3023),
    [anon_sym_COMMA] = ACTIONS(3025),
    [anon_sym_null] = ACTIONS(3023),
    [anon_sym_QMARK] = ACTIONS(3023),
    [anon_sym_COLON_QMARK] = ACTIONS(3023),
    [anon_sym_COLON_COLON] = ACTIONS(3025),
    [anon_sym_AMP] = ACTIONS(3023),
    [anon_sym_LBRACK] = ACTIONS(3023),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3025),
    [anon_sym_LBRACE] = ACTIONS(3023),
    [anon_sym_LT_AT] = ACTIONS(3023),
    [anon_sym_LT_AT_AT] = ACTIONS(3023),
    [anon_sym_DOT] = ACTIONS(3023),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3025),
    [anon_sym_new] = ACTIONS(3023),
    [anon_sym_return_BANG] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(3023),
    [anon_sym_yield_BANG] = ACTIONS(3025),
    [anon_sym_lazy] = ACTIONS(3023),
    [anon_sym_assert] = ACTIONS(3023),
    [anon_sym_upcast] = ACTIONS(3023),
    [anon_sym_downcast] = ACTIONS(3023),
    [anon_sym_COLON_GT] = ACTIONS(3025),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3025),
    [anon_sym_for] = ACTIONS(3023),
    [anon_sym_while] = ACTIONS(3023),
    [anon_sym_if] = ACTIONS(3023),
    [anon_sym_fun] = ACTIONS(3023),
    [anon_sym_try] = ACTIONS(3023),
    [anon_sym_match] = ACTIONS(3023),
    [anon_sym_match_BANG] = ACTIONS(3025),
    [anon_sym_function] = ACTIONS(3023),
    [anon_sym_LT_DASH] = ACTIONS(3023),
    [anon_sym_DOT_LBRACK] = ACTIONS(3025),
    [anon_sym_LT] = ACTIONS(3025),
    [anon_sym_use] = ACTIONS(3023),
    [anon_sym_use_BANG] = ACTIONS(3025),
    [anon_sym_do_BANG] = ACTIONS(3025),
    [anon_sym_begin] = ACTIONS(3023),
    [anon_sym_LPAREN2] = ACTIONS(3023),
    [anon_sym_or] = ACTIONS(3023),
    [aux_sym_char_token1] = ACTIONS(3025),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3023),
    [anon_sym_DQUOTE] = ACTIONS(3023),
    [anon_sym_AT_DQUOTE] = ACTIONS(3025),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3025),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3025),
    [sym_bool] = ACTIONS(3023),
    [sym_unit] = ACTIONS(3025),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3023),
    [sym_op_identifier] = ACTIONS(3023),
    [anon_sym_PLUS] = ACTIONS(3023),
    [anon_sym_DASH] = ACTIONS(3023),
    [anon_sym_PLUS_DOT] = ACTIONS(3023),
    [anon_sym_DASH_DOT] = ACTIONS(3023),
    [anon_sym_PERCENT] = ACTIONS(3023),
    [anon_sym_AMP_AMP] = ACTIONS(3023),
    [anon_sym_TILDE] = ACTIONS(3025),
    [aux_sym_prefix_op_token1] = ACTIONS(3023),
    [aux_sym_infix_op_token1] = ACTIONS(3025),
    [aux_sym_infix_op_token2] = ACTIONS(3023),
    [anon_sym_PIPE_PIPE] = ACTIONS(3023),
    [anon_sym_BANG_EQ] = ACTIONS(3023),
    [anon_sym_COLON_EQ] = ACTIONS(3025),
    [anon_sym_DOLLAR] = ACTIONS(3023),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3023),
    [sym_int] = ACTIONS(3023),
    [sym_xint] = ACTIONS(3025),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3025),
    [sym__newline] = ACTIONS(3025),
    [sym__dedent] = ACTIONS(3025),
  },
  [2074] = {
    [sym_block_comment] = STATE(2074),
    [sym_compiler_directive_decl] = STATE(2074),
    [sym_fsi_directive_decl] = STATE(2074),
    [sym_preproc_line] = STATE(2074),
    [sym_identifier] = ACTIONS(3027),
    [anon_sym_EQ] = ACTIONS(3029),
    [anon_sym_COLON] = ACTIONS(3027),
    [anon_sym_return] = ACTIONS(3027),
    [anon_sym_do] = ACTIONS(3027),
    [anon_sym_and] = ACTIONS(3027),
    [anon_sym_let] = ACTIONS(3027),
    [anon_sym_let_BANG] = ACTIONS(3029),
    [anon_sym_LPAREN] = ACTIONS(3027),
    [anon_sym_COMMA] = ACTIONS(3029),
    [anon_sym_null] = ACTIONS(3027),
    [anon_sym_QMARK] = ACTIONS(3027),
    [anon_sym_COLON_QMARK] = ACTIONS(3027),
    [anon_sym_COLON_COLON] = ACTIONS(3029),
    [anon_sym_AMP] = ACTIONS(3027),
    [anon_sym_LBRACK] = ACTIONS(3027),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3027),
    [anon_sym_LT_AT] = ACTIONS(3027),
    [anon_sym_LT_AT_AT] = ACTIONS(3027),
    [anon_sym_DOT] = ACTIONS(3027),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3029),
    [anon_sym_new] = ACTIONS(3027),
    [anon_sym_return_BANG] = ACTIONS(3029),
    [anon_sym_yield] = ACTIONS(3027),
    [anon_sym_yield_BANG] = ACTIONS(3029),
    [anon_sym_lazy] = ACTIONS(3027),
    [anon_sym_assert] = ACTIONS(3027),
    [anon_sym_upcast] = ACTIONS(3027),
    [anon_sym_downcast] = ACTIONS(3027),
    [anon_sym_COLON_GT] = ACTIONS(3029),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3029),
    [anon_sym_for] = ACTIONS(3027),
    [anon_sym_while] = ACTIONS(3027),
    [anon_sym_if] = ACTIONS(3027),
    [anon_sym_fun] = ACTIONS(3027),
    [anon_sym_try] = ACTIONS(3027),
    [anon_sym_match] = ACTIONS(3027),
    [anon_sym_match_BANG] = ACTIONS(3029),
    [anon_sym_function] = ACTIONS(3027),
    [anon_sym_LT_DASH] = ACTIONS(3027),
    [anon_sym_DOT_LBRACK] = ACTIONS(3029),
    [anon_sym_LT] = ACTIONS(3029),
    [anon_sym_use] = ACTIONS(3027),
    [anon_sym_use_BANG] = ACTIONS(3029),
    [anon_sym_do_BANG] = ACTIONS(3029),
    [anon_sym_begin] = ACTIONS(3027),
    [anon_sym_LPAREN2] = ACTIONS(3027),
    [anon_sym_or] = ACTIONS(3027),
    [aux_sym_char_token1] = ACTIONS(3029),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3027),
    [anon_sym_DQUOTE] = ACTIONS(3027),
    [anon_sym_AT_DQUOTE] = ACTIONS(3029),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3029),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3029),
    [sym_bool] = ACTIONS(3027),
    [sym_unit] = ACTIONS(3029),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3027),
    [sym_op_identifier] = ACTIONS(3027),
    [anon_sym_PLUS] = ACTIONS(3027),
    [anon_sym_DASH] = ACTIONS(3027),
    [anon_sym_PLUS_DOT] = ACTIONS(3027),
    [anon_sym_DASH_DOT] = ACTIONS(3027),
    [anon_sym_PERCENT] = ACTIONS(3027),
    [anon_sym_AMP_AMP] = ACTIONS(3027),
    [anon_sym_TILDE] = ACTIONS(3029),
    [aux_sym_prefix_op_token1] = ACTIONS(3027),
    [aux_sym_infix_op_token1] = ACTIONS(3029),
    [aux_sym_infix_op_token2] = ACTIONS(3027),
    [anon_sym_PIPE_PIPE] = ACTIONS(3027),
    [anon_sym_BANG_EQ] = ACTIONS(3027),
    [anon_sym_COLON_EQ] = ACTIONS(3029),
    [anon_sym_DOLLAR] = ACTIONS(3027),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3027),
    [sym_int] = ACTIONS(3027),
    [sym_xint] = ACTIONS(3029),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3029),
    [sym__newline] = ACTIONS(3029),
    [sym__dedent] = ACTIONS(3029),
  },
  [2075] = {
    [sym_block_comment] = STATE(2075),
    [sym_compiler_directive_decl] = STATE(2075),
    [sym_fsi_directive_decl] = STATE(2075),
    [sym_preproc_line] = STATE(2075),
    [sym_identifier] = ACTIONS(3035),
    [anon_sym_EQ] = ACTIONS(3037),
    [anon_sym_COLON] = ACTIONS(3035),
    [anon_sym_return] = ACTIONS(3035),
    [anon_sym_do] = ACTIONS(3035),
    [anon_sym_and] = ACTIONS(3035),
    [anon_sym_let] = ACTIONS(3035),
    [anon_sym_let_BANG] = ACTIONS(3037),
    [anon_sym_LPAREN] = ACTIONS(3035),
    [anon_sym_COMMA] = ACTIONS(3037),
    [anon_sym_null] = ACTIONS(3035),
    [anon_sym_QMARK] = ACTIONS(3035),
    [anon_sym_COLON_QMARK] = ACTIONS(3035),
    [anon_sym_COLON_COLON] = ACTIONS(3037),
    [anon_sym_AMP] = ACTIONS(3035),
    [anon_sym_LBRACK] = ACTIONS(3035),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3037),
    [anon_sym_LBRACE] = ACTIONS(3035),
    [anon_sym_LT_AT] = ACTIONS(3035),
    [anon_sym_LT_AT_AT] = ACTIONS(3035),
    [anon_sym_DOT] = ACTIONS(3035),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3037),
    [anon_sym_new] = ACTIONS(3035),
    [anon_sym_return_BANG] = ACTIONS(3037),
    [anon_sym_yield] = ACTIONS(3035),
    [anon_sym_yield_BANG] = ACTIONS(3037),
    [anon_sym_lazy] = ACTIONS(3035),
    [anon_sym_assert] = ACTIONS(3035),
    [anon_sym_upcast] = ACTIONS(3035),
    [anon_sym_downcast] = ACTIONS(3035),
    [anon_sym_COLON_GT] = ACTIONS(3037),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3037),
    [anon_sym_for] = ACTIONS(3035),
    [anon_sym_while] = ACTIONS(3035),
    [anon_sym_if] = ACTIONS(3035),
    [anon_sym_fun] = ACTIONS(3035),
    [anon_sym_try] = ACTIONS(3035),
    [anon_sym_match] = ACTIONS(3035),
    [anon_sym_match_BANG] = ACTIONS(3037),
    [anon_sym_function] = ACTIONS(3035),
    [anon_sym_LT_DASH] = ACTIONS(3035),
    [anon_sym_DOT_LBRACK] = ACTIONS(3037),
    [anon_sym_LT] = ACTIONS(3037),
    [anon_sym_use] = ACTIONS(3035),
    [anon_sym_use_BANG] = ACTIONS(3037),
    [anon_sym_do_BANG] = ACTIONS(3037),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_LPAREN2] = ACTIONS(3035),
    [anon_sym_or] = ACTIONS(3035),
    [aux_sym_char_token1] = ACTIONS(3037),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3035),
    [anon_sym_DQUOTE] = ACTIONS(3035),
    [anon_sym_AT_DQUOTE] = ACTIONS(3037),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3037),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3037),
    [sym_bool] = ACTIONS(3035),
    [sym_unit] = ACTIONS(3037),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3035),
    [sym_op_identifier] = ACTIONS(3035),
    [anon_sym_PLUS] = ACTIONS(3035),
    [anon_sym_DASH] = ACTIONS(3035),
    [anon_sym_PLUS_DOT] = ACTIONS(3035),
    [anon_sym_DASH_DOT] = ACTIONS(3035),
    [anon_sym_PERCENT] = ACTIONS(3035),
    [anon_sym_AMP_AMP] = ACTIONS(3035),
    [anon_sym_TILDE] = ACTIONS(3037),
    [aux_sym_prefix_op_token1] = ACTIONS(3035),
    [aux_sym_infix_op_token1] = ACTIONS(3037),
    [aux_sym_infix_op_token2] = ACTIONS(3035),
    [anon_sym_PIPE_PIPE] = ACTIONS(3035),
    [anon_sym_BANG_EQ] = ACTIONS(3035),
    [anon_sym_COLON_EQ] = ACTIONS(3037),
    [anon_sym_DOLLAR] = ACTIONS(3035),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3035),
    [sym_int] = ACTIONS(3035),
    [sym_xint] = ACTIONS(3037),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3037),
    [sym__newline] = ACTIONS(3037),
    [sym__dedent] = ACTIONS(3037),
  },
  [2076] = {
    [sym_block_comment] = STATE(2076),
    [sym_compiler_directive_decl] = STATE(2076),
    [sym_fsi_directive_decl] = STATE(2076),
    [sym_preproc_line] = STATE(2076),
    [sym_identifier] = ACTIONS(2926),
    [anon_sym_EQ] = ACTIONS(2928),
    [anon_sym_COLON] = ACTIONS(2926),
    [anon_sym_return] = ACTIONS(2926),
    [anon_sym_do] = ACTIONS(2926),
    [anon_sym_let] = ACTIONS(2926),
    [anon_sym_let_BANG] = ACTIONS(2928),
    [anon_sym_LPAREN] = ACTIONS(2926),
    [anon_sym_COMMA] = ACTIONS(2928),
    [anon_sym_null] = ACTIONS(2926),
    [anon_sym_QMARK] = ACTIONS(2926),
    [anon_sym_COLON_QMARK] = ACTIONS(2926),
    [anon_sym_COLON_COLON] = ACTIONS(2928),
    [anon_sym_AMP] = ACTIONS(2926),
    [anon_sym_LBRACK] = ACTIONS(2926),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2928),
    [anon_sym_LBRACE] = ACTIONS(2926),
    [anon_sym_LT_AT] = ACTIONS(2926),
    [anon_sym_LT_AT_AT] = ACTIONS(2926),
    [anon_sym_DOT] = ACTIONS(2926),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2928),
    [anon_sym_new] = ACTIONS(2926),
    [anon_sym_return_BANG] = ACTIONS(2928),
    [anon_sym_yield] = ACTIONS(2926),
    [anon_sym_yield_BANG] = ACTIONS(2928),
    [anon_sym_lazy] = ACTIONS(2926),
    [anon_sym_assert] = ACTIONS(2926),
    [anon_sym_upcast] = ACTIONS(2926),
    [anon_sym_downcast] = ACTIONS(2926),
    [anon_sym_COLON_GT] = ACTIONS(2928),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2928),
    [anon_sym_for] = ACTIONS(2926),
    [anon_sym_while] = ACTIONS(2926),
    [anon_sym_if] = ACTIONS(2926),
    [anon_sym_fun] = ACTIONS(2926),
    [anon_sym_try] = ACTIONS(2926),
    [anon_sym_match] = ACTIONS(2926),
    [anon_sym_match_BANG] = ACTIONS(2928),
    [anon_sym_function] = ACTIONS(2926),
    [anon_sym_LT_DASH] = ACTIONS(2926),
    [anon_sym_DOT_LBRACK] = ACTIONS(2928),
    [anon_sym_LT] = ACTIONS(2928),
    [anon_sym_use] = ACTIONS(2926),
    [anon_sym_use_BANG] = ACTIONS(2928),
    [anon_sym_do_BANG] = ACTIONS(2928),
    [anon_sym_begin] = ACTIONS(2926),
    [anon_sym_LPAREN2] = ACTIONS(2926),
    [anon_sym_or] = ACTIONS(2926),
    [aux_sym_char_token1] = ACTIONS(2928),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2926),
    [anon_sym_DQUOTE] = ACTIONS(2926),
    [anon_sym_AT_DQUOTE] = ACTIONS(2928),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2928),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2928),
    [sym_bool] = ACTIONS(2926),
    [sym_unit] = ACTIONS(2928),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2926),
    [sym_op_identifier] = ACTIONS(2926),
    [anon_sym_PLUS] = ACTIONS(2926),
    [anon_sym_DASH] = ACTIONS(2926),
    [anon_sym_PLUS_DOT] = ACTIONS(2926),
    [anon_sym_DASH_DOT] = ACTIONS(2926),
    [anon_sym_PERCENT] = ACTIONS(2926),
    [anon_sym_AMP_AMP] = ACTIONS(2926),
    [anon_sym_TILDE] = ACTIONS(2928),
    [aux_sym_prefix_op_token1] = ACTIONS(2926),
    [aux_sym_infix_op_token1] = ACTIONS(2928),
    [aux_sym_infix_op_token2] = ACTIONS(2926),
    [anon_sym_PIPE_PIPE] = ACTIONS(2926),
    [anon_sym_BANG_EQ] = ACTIONS(2926),
    [anon_sym_COLON_EQ] = ACTIONS(2928),
    [anon_sym_DOLLAR] = ACTIONS(2926),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2926),
    [sym_int] = ACTIONS(2926),
    [sym_xint] = ACTIONS(2928),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2928),
    [anon_sym_POUNDendif] = ACTIONS(2928),
    [sym__newline] = ACTIONS(2928),
  },
  [2077] = {
    [sym_block_comment] = STATE(2077),
    [sym_compiler_directive_decl] = STATE(2077),
    [sym_fsi_directive_decl] = STATE(2077),
    [sym_preproc_line] = STATE(2077),
    [sym_identifier] = ACTIONS(2926),
    [anon_sym_EQ] = ACTIONS(2928),
    [anon_sym_COLON] = ACTIONS(2926),
    [anon_sym_return] = ACTIONS(2926),
    [anon_sym_do] = ACTIONS(2926),
    [anon_sym_let] = ACTIONS(2926),
    [anon_sym_let_BANG] = ACTIONS(2928),
    [anon_sym_LPAREN] = ACTIONS(2926),
    [anon_sym_COMMA] = ACTIONS(2928),
    [anon_sym_null] = ACTIONS(2926),
    [anon_sym_QMARK] = ACTIONS(2926),
    [anon_sym_COLON_QMARK] = ACTIONS(2926),
    [anon_sym_COLON_COLON] = ACTIONS(2928),
    [anon_sym_AMP] = ACTIONS(2926),
    [anon_sym_LBRACK] = ACTIONS(2926),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2928),
    [anon_sym_LBRACE] = ACTIONS(2926),
    [anon_sym_LT_AT] = ACTIONS(2926),
    [anon_sym_AT_GT] = ACTIONS(2926),
    [anon_sym_LT_AT_AT] = ACTIONS(2926),
    [anon_sym_DOT] = ACTIONS(2926),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2928),
    [anon_sym_new] = ACTIONS(2926),
    [anon_sym_return_BANG] = ACTIONS(2928),
    [anon_sym_yield] = ACTIONS(2926),
    [anon_sym_yield_BANG] = ACTIONS(2928),
    [anon_sym_lazy] = ACTIONS(2926),
    [anon_sym_assert] = ACTIONS(2926),
    [anon_sym_upcast] = ACTIONS(2926),
    [anon_sym_downcast] = ACTIONS(2926),
    [anon_sym_COLON_GT] = ACTIONS(2928),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2928),
    [anon_sym_for] = ACTIONS(2926),
    [anon_sym_while] = ACTIONS(2926),
    [anon_sym_if] = ACTIONS(2926),
    [anon_sym_fun] = ACTIONS(2926),
    [anon_sym_try] = ACTIONS(2926),
    [anon_sym_match] = ACTIONS(2926),
    [anon_sym_match_BANG] = ACTIONS(2928),
    [anon_sym_function] = ACTIONS(2926),
    [anon_sym_LT_DASH] = ACTIONS(2926),
    [anon_sym_DOT_LBRACK] = ACTIONS(2928),
    [anon_sym_LT] = ACTIONS(2928),
    [anon_sym_use] = ACTIONS(2926),
    [anon_sym_use_BANG] = ACTIONS(2928),
    [anon_sym_do_BANG] = ACTIONS(2928),
    [anon_sym_begin] = ACTIONS(2926),
    [anon_sym_LPAREN2] = ACTIONS(2926),
    [anon_sym_or] = ACTIONS(2926),
    [aux_sym_char_token1] = ACTIONS(2928),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2926),
    [anon_sym_DQUOTE] = ACTIONS(2926),
    [anon_sym_AT_DQUOTE] = ACTIONS(2928),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2928),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2928),
    [sym_bool] = ACTIONS(2926),
    [sym_unit] = ACTIONS(2928),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2926),
    [sym_op_identifier] = ACTIONS(2926),
    [anon_sym_PLUS] = ACTIONS(2926),
    [anon_sym_DASH] = ACTIONS(2926),
    [anon_sym_PLUS_DOT] = ACTIONS(2926),
    [anon_sym_DASH_DOT] = ACTIONS(2926),
    [anon_sym_PERCENT] = ACTIONS(2926),
    [anon_sym_AMP_AMP] = ACTIONS(2926),
    [anon_sym_TILDE] = ACTIONS(2928),
    [aux_sym_prefix_op_token1] = ACTIONS(2926),
    [aux_sym_infix_op_token1] = ACTIONS(2928),
    [aux_sym_infix_op_token2] = ACTIONS(2926),
    [anon_sym_PIPE_PIPE] = ACTIONS(2926),
    [anon_sym_BANG_EQ] = ACTIONS(2926),
    [anon_sym_COLON_EQ] = ACTIONS(2928),
    [anon_sym_DOLLAR] = ACTIONS(2926),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2926),
    [sym_int] = ACTIONS(2926),
    [sym_xint] = ACTIONS(2928),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2928),
    [sym__newline] = ACTIONS(2928),
  },
  [2078] = {
    [sym_block_comment] = STATE(2078),
    [sym_compiler_directive_decl] = STATE(2078),
    [sym_fsi_directive_decl] = STATE(2078),
    [sym_preproc_line] = STATE(2078),
    [sym_identifier] = ACTIONS(2984),
    [anon_sym_EQ] = ACTIONS(2986),
    [anon_sym_COLON] = ACTIONS(2984),
    [anon_sym_return] = ACTIONS(2984),
    [anon_sym_do] = ACTIONS(2984),
    [anon_sym_let] = ACTIONS(2984),
    [anon_sym_let_BANG] = ACTIONS(2986),
    [anon_sym_LPAREN] = ACTIONS(2984),
    [anon_sym_COMMA] = ACTIONS(2986),
    [anon_sym_null] = ACTIONS(2984),
    [anon_sym_QMARK] = ACTIONS(2984),
    [anon_sym_COLON_QMARK] = ACTIONS(2984),
    [anon_sym_COLON_COLON] = ACTIONS(2986),
    [anon_sym_AMP] = ACTIONS(2984),
    [anon_sym_LBRACK] = ACTIONS(2984),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2986),
    [anon_sym_LBRACE] = ACTIONS(2984),
    [anon_sym_LT_AT] = ACTIONS(2984),
    [anon_sym_LT_AT_AT] = ACTIONS(2984),
    [anon_sym_DOT] = ACTIONS(2984),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2986),
    [anon_sym_new] = ACTIONS(2984),
    [anon_sym_return_BANG] = ACTIONS(2986),
    [anon_sym_yield] = ACTIONS(2984),
    [anon_sym_yield_BANG] = ACTIONS(2986),
    [anon_sym_lazy] = ACTIONS(2984),
    [anon_sym_assert] = ACTIONS(2984),
    [anon_sym_upcast] = ACTIONS(2984),
    [anon_sym_downcast] = ACTIONS(2984),
    [anon_sym_COLON_GT] = ACTIONS(2986),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2986),
    [anon_sym_for] = ACTIONS(2984),
    [anon_sym_while] = ACTIONS(2984),
    [anon_sym_if] = ACTIONS(2984),
    [anon_sym_fun] = ACTIONS(2984),
    [anon_sym_try] = ACTIONS(2984),
    [anon_sym_match] = ACTIONS(2984),
    [anon_sym_match_BANG] = ACTIONS(2986),
    [anon_sym_function] = ACTIONS(2984),
    [anon_sym_LT_DASH] = ACTIONS(2984),
    [anon_sym_DOT_LBRACK] = ACTIONS(2986),
    [anon_sym_LT] = ACTIONS(2986),
    [anon_sym_GT] = ACTIONS(2984),
    [anon_sym_use] = ACTIONS(2984),
    [anon_sym_use_BANG] = ACTIONS(2986),
    [anon_sym_do_BANG] = ACTIONS(2986),
    [anon_sym_begin] = ACTIONS(2984),
    [anon_sym_LPAREN2] = ACTIONS(2984),
    [anon_sym_or] = ACTIONS(2984),
    [aux_sym_char_token1] = ACTIONS(2986),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2984),
    [anon_sym_DQUOTE] = ACTIONS(2984),
    [anon_sym_AT_DQUOTE] = ACTIONS(2986),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2986),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2986),
    [sym_bool] = ACTIONS(2984),
    [sym_unit] = ACTIONS(2986),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2984),
    [sym_op_identifier] = ACTIONS(2984),
    [anon_sym_PLUS] = ACTIONS(2984),
    [anon_sym_DASH] = ACTIONS(2984),
    [anon_sym_PLUS_DOT] = ACTIONS(2984),
    [anon_sym_DASH_DOT] = ACTIONS(2984),
    [anon_sym_PERCENT] = ACTIONS(2984),
    [anon_sym_AMP_AMP] = ACTIONS(2984),
    [anon_sym_TILDE] = ACTIONS(2986),
    [aux_sym_prefix_op_token1] = ACTIONS(2984),
    [aux_sym_infix_op_token1] = ACTIONS(2986),
    [aux_sym_infix_op_token2] = ACTIONS(2984),
    [anon_sym_PIPE_PIPE] = ACTIONS(2984),
    [anon_sym_BANG_EQ] = ACTIONS(2984),
    [anon_sym_COLON_EQ] = ACTIONS(2986),
    [anon_sym_DOLLAR] = ACTIONS(2984),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2984),
    [sym_int] = ACTIONS(2984),
    [sym_xint] = ACTIONS(2986),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2986),
    [sym__newline] = ACTIONS(2986),
  },
  [2079] = {
    [sym_block_comment] = STATE(2079),
    [sym_compiler_directive_decl] = STATE(2079),
    [sym_fsi_directive_decl] = STATE(2079),
    [sym_preproc_line] = STATE(2079),
    [sym_identifier] = ACTIONS(2867),
    [anon_sym_EQ] = ACTIONS(2869),
    [anon_sym_COLON] = ACTIONS(2867),
    [anon_sym_return] = ACTIONS(2867),
    [anon_sym_do] = ACTIONS(2867),
    [anon_sym_let] = ACTIONS(2867),
    [anon_sym_let_BANG] = ACTIONS(2869),
    [anon_sym_LPAREN] = ACTIONS(2867),
    [anon_sym_COMMA] = ACTIONS(2869),
    [anon_sym_null] = ACTIONS(2867),
    [anon_sym_QMARK] = ACTIONS(2867),
    [anon_sym_COLON_QMARK] = ACTIONS(2867),
    [anon_sym_COLON_COLON] = ACTIONS(2869),
    [anon_sym_AMP] = ACTIONS(2867),
    [anon_sym_LBRACK] = ACTIONS(2867),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2869),
    [anon_sym_LBRACE] = ACTIONS(2867),
    [anon_sym_LT_AT] = ACTIONS(2867),
    [anon_sym_LT_AT_AT] = ACTIONS(2867),
    [anon_sym_DOT] = ACTIONS(4194),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2869),
    [anon_sym_new] = ACTIONS(2867),
    [anon_sym_return_BANG] = ACTIONS(2869),
    [anon_sym_yield] = ACTIONS(2867),
    [anon_sym_yield_BANG] = ACTIONS(2869),
    [anon_sym_lazy] = ACTIONS(2867),
    [anon_sym_assert] = ACTIONS(2867),
    [anon_sym_upcast] = ACTIONS(2867),
    [anon_sym_downcast] = ACTIONS(2867),
    [anon_sym_COLON_GT] = ACTIONS(2869),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2869),
    [anon_sym_for] = ACTIONS(2867),
    [anon_sym_while] = ACTIONS(2867),
    [anon_sym_if] = ACTIONS(2867),
    [anon_sym_fun] = ACTIONS(2867),
    [anon_sym_try] = ACTIONS(2867),
    [anon_sym_match] = ACTIONS(2867),
    [anon_sym_match_BANG] = ACTIONS(2869),
    [anon_sym_function] = ACTIONS(2867),
    [anon_sym_LT_DASH] = ACTIONS(2867),
    [anon_sym_DOT_LBRACK] = ACTIONS(2869),
    [anon_sym_LT] = ACTIONS(2869),
    [anon_sym_use] = ACTIONS(2867),
    [anon_sym_use_BANG] = ACTIONS(2869),
    [anon_sym_do_BANG] = ACTIONS(2869),
    [anon_sym_begin] = ACTIONS(2867),
    [anon_sym_LPAREN2] = ACTIONS(2867),
    [anon_sym_or] = ACTIONS(2867),
    [aux_sym_char_token1] = ACTIONS(2869),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2867),
    [anon_sym_DQUOTE] = ACTIONS(2867),
    [anon_sym_AT_DQUOTE] = ACTIONS(2869),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2869),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2869),
    [sym_bool] = ACTIONS(2867),
    [sym_unit] = ACTIONS(2869),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2867),
    [sym_op_identifier] = ACTIONS(2867),
    [anon_sym_PLUS] = ACTIONS(2867),
    [anon_sym_DASH] = ACTIONS(2867),
    [anon_sym_PLUS_DOT] = ACTIONS(2867),
    [anon_sym_DASH_DOT] = ACTIONS(2867),
    [anon_sym_PERCENT] = ACTIONS(2867),
    [anon_sym_AMP_AMP] = ACTIONS(2867),
    [anon_sym_TILDE] = ACTIONS(2869),
    [aux_sym_prefix_op_token1] = ACTIONS(2867),
    [aux_sym_infix_op_token1] = ACTIONS(2869),
    [aux_sym_infix_op_token2] = ACTIONS(2867),
    [anon_sym_PIPE_PIPE] = ACTIONS(2867),
    [anon_sym_BANG_EQ] = ACTIONS(2867),
    [anon_sym_COLON_EQ] = ACTIONS(2869),
    [anon_sym_DOLLAR] = ACTIONS(2867),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2867),
    [sym_int] = ACTIONS(2867),
    [sym_xint] = ACTIONS(2869),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2869),
    [anon_sym_POUNDendif] = ACTIONS(2869),
    [sym__newline] = ACTIONS(2869),
  },
  [2080] = {
    [sym_block_comment] = STATE(2080),
    [sym_compiler_directive_decl] = STATE(2080),
    [sym_fsi_directive_decl] = STATE(2080),
    [sym_preproc_line] = STATE(2080),
    [sym_identifier] = ACTIONS(2863),
    [anon_sym_EQ] = ACTIONS(2865),
    [anon_sym_COLON] = ACTIONS(2863),
    [anon_sym_return] = ACTIONS(2863),
    [anon_sym_do] = ACTIONS(2863),
    [anon_sym_let] = ACTIONS(2863),
    [anon_sym_let_BANG] = ACTIONS(2865),
    [anon_sym_LPAREN] = ACTIONS(2863),
    [anon_sym_COMMA] = ACTIONS(2865),
    [anon_sym_null] = ACTIONS(2863),
    [anon_sym_QMARK] = ACTIONS(2863),
    [anon_sym_COLON_QMARK] = ACTIONS(2863),
    [anon_sym_COLON_COLON] = ACTIONS(2865),
    [anon_sym_AMP] = ACTIONS(2863),
    [anon_sym_LBRACK] = ACTIONS(2863),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2865),
    [anon_sym_LBRACE] = ACTIONS(2863),
    [anon_sym_LT_AT] = ACTIONS(2863),
    [anon_sym_LT_AT_AT] = ACTIONS(2863),
    [anon_sym_DOT] = ACTIONS(2863),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2865),
    [anon_sym_new] = ACTIONS(2863),
    [anon_sym_return_BANG] = ACTIONS(2865),
    [anon_sym_yield] = ACTIONS(2863),
    [anon_sym_yield_BANG] = ACTIONS(2865),
    [anon_sym_lazy] = ACTIONS(2863),
    [anon_sym_assert] = ACTIONS(2863),
    [anon_sym_upcast] = ACTIONS(2863),
    [anon_sym_downcast] = ACTIONS(2863),
    [anon_sym_COLON_GT] = ACTIONS(2865),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2865),
    [anon_sym_for] = ACTIONS(2863),
    [anon_sym_while] = ACTIONS(2863),
    [anon_sym_if] = ACTIONS(2863),
    [anon_sym_fun] = ACTIONS(2863),
    [anon_sym_try] = ACTIONS(2863),
    [anon_sym_match] = ACTIONS(2863),
    [anon_sym_match_BANG] = ACTIONS(2865),
    [anon_sym_function] = ACTIONS(2863),
    [anon_sym_LT_DASH] = ACTIONS(2863),
    [anon_sym_DOT_LBRACK] = ACTIONS(2865),
    [anon_sym_LT] = ACTIONS(2865),
    [anon_sym_use] = ACTIONS(2863),
    [anon_sym_use_BANG] = ACTIONS(2865),
    [anon_sym_do_BANG] = ACTIONS(2865),
    [anon_sym_begin] = ACTIONS(2863),
    [anon_sym_LPAREN2] = ACTIONS(2863),
    [anon_sym_or] = ACTIONS(2863),
    [aux_sym_char_token1] = ACTIONS(2865),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2863),
    [anon_sym_DQUOTE] = ACTIONS(2863),
    [anon_sym_AT_DQUOTE] = ACTIONS(2865),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2865),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2865),
    [sym_bool] = ACTIONS(2863),
    [sym_unit] = ACTIONS(2865),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2863),
    [sym_op_identifier] = ACTIONS(2863),
    [anon_sym_PLUS] = ACTIONS(2863),
    [anon_sym_DASH] = ACTIONS(2863),
    [anon_sym_PLUS_DOT] = ACTIONS(2863),
    [anon_sym_DASH_DOT] = ACTIONS(2863),
    [anon_sym_PERCENT] = ACTIONS(2863),
    [anon_sym_AMP_AMP] = ACTIONS(2863),
    [anon_sym_TILDE] = ACTIONS(2865),
    [aux_sym_prefix_op_token1] = ACTIONS(2863),
    [aux_sym_infix_op_token1] = ACTIONS(2865),
    [aux_sym_infix_op_token2] = ACTIONS(2863),
    [anon_sym_PIPE_PIPE] = ACTIONS(2863),
    [anon_sym_BANG_EQ] = ACTIONS(2863),
    [anon_sym_COLON_EQ] = ACTIONS(2865),
    [anon_sym_DOLLAR] = ACTIONS(2863),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2863),
    [sym_int] = ACTIONS(2863),
    [sym_xint] = ACTIONS(2865),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2865),
    [anon_sym_POUNDendif] = ACTIONS(2865),
    [sym__newline] = ACTIONS(2865),
  },
  [2081] = {
    [sym_block_comment] = STATE(2081),
    [sym_compiler_directive_decl] = STATE(2081),
    [sym_fsi_directive_decl] = STATE(2081),
    [sym_preproc_line] = STATE(2081),
    [sym_identifier] = ACTIONS(3023),
    [anon_sym_EQ] = ACTIONS(3025),
    [anon_sym_COLON] = ACTIONS(3023),
    [anon_sym_return] = ACTIONS(3023),
    [anon_sym_do] = ACTIONS(3023),
    [anon_sym_let] = ACTIONS(3023),
    [anon_sym_let_BANG] = ACTIONS(3025),
    [anon_sym_LPAREN] = ACTIONS(3023),
    [anon_sym_COMMA] = ACTIONS(3025),
    [anon_sym_null] = ACTIONS(3023),
    [anon_sym_QMARK] = ACTIONS(3023),
    [anon_sym_COLON_QMARK] = ACTIONS(3023),
    [anon_sym_COLON_COLON] = ACTIONS(3025),
    [anon_sym_AMP] = ACTIONS(3023),
    [anon_sym_LBRACK] = ACTIONS(3023),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3025),
    [anon_sym_LBRACE] = ACTIONS(3023),
    [anon_sym_LT_AT] = ACTIONS(3023),
    [anon_sym_LT_AT_AT] = ACTIONS(3023),
    [anon_sym_DOT] = ACTIONS(3023),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3025),
    [anon_sym_new] = ACTIONS(3023),
    [anon_sym_return_BANG] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(3023),
    [anon_sym_yield_BANG] = ACTIONS(3025),
    [anon_sym_lazy] = ACTIONS(3023),
    [anon_sym_assert] = ACTIONS(3023),
    [anon_sym_upcast] = ACTIONS(3023),
    [anon_sym_downcast] = ACTIONS(3023),
    [anon_sym_COLON_GT] = ACTIONS(3025),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3025),
    [anon_sym_for] = ACTIONS(3023),
    [anon_sym_while] = ACTIONS(3023),
    [anon_sym_if] = ACTIONS(3023),
    [anon_sym_fun] = ACTIONS(3023),
    [anon_sym_try] = ACTIONS(3023),
    [anon_sym_match] = ACTIONS(3023),
    [anon_sym_match_BANG] = ACTIONS(3025),
    [anon_sym_function] = ACTIONS(3023),
    [anon_sym_LT_DASH] = ACTIONS(3023),
    [anon_sym_DOT_LBRACK] = ACTIONS(3025),
    [anon_sym_LT] = ACTIONS(3025),
    [anon_sym_use] = ACTIONS(3023),
    [anon_sym_use_BANG] = ACTIONS(3025),
    [anon_sym_do_BANG] = ACTIONS(3025),
    [anon_sym_DOT_DOT] = ACTIONS(3025),
    [anon_sym_begin] = ACTIONS(3023),
    [anon_sym_LPAREN2] = ACTIONS(3023),
    [anon_sym_or] = ACTIONS(3023),
    [aux_sym_char_token1] = ACTIONS(3025),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3023),
    [anon_sym_DQUOTE] = ACTIONS(3023),
    [anon_sym_AT_DQUOTE] = ACTIONS(3025),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3025),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3025),
    [sym_bool] = ACTIONS(3023),
    [sym_unit] = ACTIONS(3025),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3023),
    [sym_op_identifier] = ACTIONS(3023),
    [anon_sym_PLUS] = ACTIONS(3023),
    [anon_sym_DASH] = ACTIONS(3023),
    [anon_sym_PLUS_DOT] = ACTIONS(3023),
    [anon_sym_DASH_DOT] = ACTIONS(3023),
    [anon_sym_PERCENT] = ACTIONS(3023),
    [anon_sym_AMP_AMP] = ACTIONS(3023),
    [anon_sym_TILDE] = ACTIONS(3025),
    [aux_sym_prefix_op_token1] = ACTIONS(3023),
    [aux_sym_infix_op_token1] = ACTIONS(3025),
    [aux_sym_infix_op_token2] = ACTIONS(3023),
    [anon_sym_PIPE_PIPE] = ACTIONS(3023),
    [anon_sym_BANG_EQ] = ACTIONS(3023),
    [anon_sym_COLON_EQ] = ACTIONS(3025),
    [anon_sym_DOLLAR] = ACTIONS(3023),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3023),
    [sym_int] = ACTIONS(3023),
    [sym_xint] = ACTIONS(3025),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3025),
    [sym__newline] = ACTIONS(3025),
  },
  [2082] = {
    [sym_block_comment] = STATE(2082),
    [sym_compiler_directive_decl] = STATE(2082),
    [sym_fsi_directive_decl] = STATE(2082),
    [sym_preproc_line] = STATE(2082),
    [sym_identifier] = ACTIONS(3007),
    [anon_sym_EQ] = ACTIONS(3009),
    [anon_sym_COLON] = ACTIONS(3007),
    [anon_sym_return] = ACTIONS(3007),
    [anon_sym_do] = ACTIONS(3007),
    [anon_sym_let] = ACTIONS(3007),
    [anon_sym_let_BANG] = ACTIONS(3009),
    [anon_sym_LPAREN] = ACTIONS(3007),
    [anon_sym_COMMA] = ACTIONS(3009),
    [anon_sym_null] = ACTIONS(3007),
    [anon_sym_QMARK] = ACTIONS(3007),
    [anon_sym_COLON_QMARK] = ACTIONS(3007),
    [anon_sym_COLON_COLON] = ACTIONS(3009),
    [anon_sym_AMP] = ACTIONS(3007),
    [anon_sym_LBRACK] = ACTIONS(3007),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3009),
    [anon_sym_LBRACE] = ACTIONS(3007),
    [anon_sym_LT_AT] = ACTIONS(3007),
    [anon_sym_LT_AT_AT] = ACTIONS(3007),
    [anon_sym_DOT] = ACTIONS(3007),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3009),
    [anon_sym_new] = ACTIONS(3007),
    [anon_sym_return_BANG] = ACTIONS(3009),
    [anon_sym_yield] = ACTIONS(3007),
    [anon_sym_yield_BANG] = ACTIONS(3009),
    [anon_sym_lazy] = ACTIONS(3007),
    [anon_sym_assert] = ACTIONS(3007),
    [anon_sym_upcast] = ACTIONS(3007),
    [anon_sym_downcast] = ACTIONS(3007),
    [anon_sym_COLON_GT] = ACTIONS(3009),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3009),
    [anon_sym_for] = ACTIONS(3007),
    [anon_sym_while] = ACTIONS(3007),
    [anon_sym_if] = ACTIONS(3007),
    [anon_sym_fun] = ACTIONS(3007),
    [anon_sym_try] = ACTIONS(3007),
    [anon_sym_match] = ACTIONS(3007),
    [anon_sym_match_BANG] = ACTIONS(3009),
    [anon_sym_function] = ACTIONS(3007),
    [anon_sym_LT_DASH] = ACTIONS(3007),
    [anon_sym_DOT_LBRACK] = ACTIONS(3009),
    [anon_sym_LT] = ACTIONS(3009),
    [anon_sym_GT] = ACTIONS(3007),
    [anon_sym_use] = ACTIONS(3007),
    [anon_sym_use_BANG] = ACTIONS(3009),
    [anon_sym_do_BANG] = ACTIONS(3009),
    [anon_sym_begin] = ACTIONS(3007),
    [anon_sym_LPAREN2] = ACTIONS(3007),
    [anon_sym_or] = ACTIONS(3007),
    [aux_sym_char_token1] = ACTIONS(3009),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3007),
    [anon_sym_DQUOTE] = ACTIONS(3007),
    [anon_sym_AT_DQUOTE] = ACTIONS(3009),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3009),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3009),
    [sym_bool] = ACTIONS(3007),
    [sym_unit] = ACTIONS(3009),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3007),
    [sym_op_identifier] = ACTIONS(3007),
    [anon_sym_PLUS] = ACTIONS(3007),
    [anon_sym_DASH] = ACTIONS(3007),
    [anon_sym_PLUS_DOT] = ACTIONS(3007),
    [anon_sym_DASH_DOT] = ACTIONS(3007),
    [anon_sym_PERCENT] = ACTIONS(3007),
    [anon_sym_AMP_AMP] = ACTIONS(3007),
    [anon_sym_TILDE] = ACTIONS(3009),
    [aux_sym_prefix_op_token1] = ACTIONS(3007),
    [aux_sym_infix_op_token1] = ACTIONS(3009),
    [aux_sym_infix_op_token2] = ACTIONS(3007),
    [anon_sym_PIPE_PIPE] = ACTIONS(3007),
    [anon_sym_BANG_EQ] = ACTIONS(3007),
    [anon_sym_COLON_EQ] = ACTIONS(3009),
    [anon_sym_DOLLAR] = ACTIONS(3007),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3007),
    [sym_int] = ACTIONS(3007),
    [sym_xint] = ACTIONS(3009),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3009),
    [sym__newline] = ACTIONS(3009),
  },
  [2083] = {
    [sym_block_comment] = STATE(2083),
    [sym_compiler_directive_decl] = STATE(2083),
    [sym_fsi_directive_decl] = STATE(2083),
    [sym_preproc_line] = STATE(2083),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_EQ] = ACTIONS(3017),
    [anon_sym_COLON] = ACTIONS(3015),
    [anon_sym_return] = ACTIONS(3015),
    [anon_sym_do] = ACTIONS(3015),
    [anon_sym_let] = ACTIONS(3015),
    [anon_sym_let_BANG] = ACTIONS(3017),
    [anon_sym_LPAREN] = ACTIONS(3015),
    [anon_sym_COMMA] = ACTIONS(3017),
    [anon_sym_null] = ACTIONS(3015),
    [anon_sym_QMARK] = ACTIONS(3015),
    [anon_sym_COLON_QMARK] = ACTIONS(3015),
    [anon_sym_COLON_COLON] = ACTIONS(3017),
    [anon_sym_AMP] = ACTIONS(3015),
    [anon_sym_LBRACK] = ACTIONS(3015),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3017),
    [anon_sym_LBRACE] = ACTIONS(3015),
    [anon_sym_LT_AT] = ACTIONS(3015),
    [anon_sym_LT_AT_AT] = ACTIONS(3015),
    [anon_sym_DOT] = ACTIONS(3015),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3017),
    [anon_sym_new] = ACTIONS(3015),
    [anon_sym_return_BANG] = ACTIONS(3017),
    [anon_sym_yield] = ACTIONS(3015),
    [anon_sym_yield_BANG] = ACTIONS(3017),
    [anon_sym_lazy] = ACTIONS(3015),
    [anon_sym_assert] = ACTIONS(3015),
    [anon_sym_upcast] = ACTIONS(3015),
    [anon_sym_downcast] = ACTIONS(3015),
    [anon_sym_COLON_GT] = ACTIONS(3017),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3017),
    [anon_sym_for] = ACTIONS(3015),
    [anon_sym_while] = ACTIONS(3015),
    [anon_sym_if] = ACTIONS(3015),
    [anon_sym_fun] = ACTIONS(3015),
    [anon_sym_try] = ACTIONS(3015),
    [anon_sym_match] = ACTIONS(3015),
    [anon_sym_match_BANG] = ACTIONS(3017),
    [anon_sym_function] = ACTIONS(3015),
    [anon_sym_LT_DASH] = ACTIONS(3015),
    [anon_sym_DOT_LBRACK] = ACTIONS(3017),
    [anon_sym_LT] = ACTIONS(3017),
    [anon_sym_GT] = ACTIONS(3015),
    [anon_sym_use] = ACTIONS(3015),
    [anon_sym_use_BANG] = ACTIONS(3017),
    [anon_sym_do_BANG] = ACTIONS(3017),
    [anon_sym_begin] = ACTIONS(3015),
    [anon_sym_LPAREN2] = ACTIONS(3015),
    [anon_sym_or] = ACTIONS(3015),
    [aux_sym_char_token1] = ACTIONS(3017),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3015),
    [anon_sym_DQUOTE] = ACTIONS(3015),
    [anon_sym_AT_DQUOTE] = ACTIONS(3017),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3017),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3017),
    [sym_bool] = ACTIONS(3015),
    [sym_unit] = ACTIONS(3017),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3015),
    [sym_op_identifier] = ACTIONS(3015),
    [anon_sym_PLUS] = ACTIONS(3015),
    [anon_sym_DASH] = ACTIONS(3015),
    [anon_sym_PLUS_DOT] = ACTIONS(3015),
    [anon_sym_DASH_DOT] = ACTIONS(3015),
    [anon_sym_PERCENT] = ACTIONS(3015),
    [anon_sym_AMP_AMP] = ACTIONS(3015),
    [anon_sym_TILDE] = ACTIONS(3017),
    [aux_sym_prefix_op_token1] = ACTIONS(3015),
    [aux_sym_infix_op_token1] = ACTIONS(3017),
    [aux_sym_infix_op_token2] = ACTIONS(3015),
    [anon_sym_PIPE_PIPE] = ACTIONS(3015),
    [anon_sym_BANG_EQ] = ACTIONS(3015),
    [anon_sym_COLON_EQ] = ACTIONS(3017),
    [anon_sym_DOLLAR] = ACTIONS(3015),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3015),
    [sym_int] = ACTIONS(3015),
    [sym_xint] = ACTIONS(3017),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3017),
    [sym__newline] = ACTIONS(3017),
  },
  [2084] = {
    [sym_block_comment] = STATE(2084),
    [sym_compiler_directive_decl] = STATE(2084),
    [sym_fsi_directive_decl] = STATE(2084),
    [sym_preproc_line] = STATE(2084),
    [sym_identifier] = ACTIONS(2954),
    [anon_sym_EQ] = ACTIONS(2956),
    [anon_sym_COLON] = ACTIONS(2954),
    [anon_sym_return] = ACTIONS(2954),
    [anon_sym_do] = ACTIONS(2954),
    [anon_sym_let] = ACTIONS(2954),
    [anon_sym_let_BANG] = ACTIONS(2956),
    [anon_sym_LPAREN] = ACTIONS(2954),
    [anon_sym_COMMA] = ACTIONS(2956),
    [anon_sym_null] = ACTIONS(2954),
    [anon_sym_QMARK] = ACTIONS(2954),
    [anon_sym_COLON_QMARK] = ACTIONS(2954),
    [anon_sym_COLON_COLON] = ACTIONS(2956),
    [anon_sym_AMP] = ACTIONS(2954),
    [anon_sym_LBRACK] = ACTIONS(2954),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2956),
    [anon_sym_LBRACE] = ACTIONS(2954),
    [anon_sym_LT_AT] = ACTIONS(2954),
    [anon_sym_LT_AT_AT] = ACTIONS(2954),
    [anon_sym_DOT] = ACTIONS(2954),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2956),
    [anon_sym_new] = ACTIONS(2954),
    [anon_sym_return_BANG] = ACTIONS(2956),
    [anon_sym_yield] = ACTIONS(2954),
    [anon_sym_yield_BANG] = ACTIONS(2956),
    [anon_sym_lazy] = ACTIONS(2954),
    [anon_sym_assert] = ACTIONS(2954),
    [anon_sym_upcast] = ACTIONS(2954),
    [anon_sym_downcast] = ACTIONS(2954),
    [anon_sym_COLON_GT] = ACTIONS(2956),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2956),
    [anon_sym_for] = ACTIONS(2954),
    [anon_sym_while] = ACTIONS(2954),
    [anon_sym_if] = ACTIONS(2954),
    [anon_sym_fun] = ACTIONS(2954),
    [anon_sym_try] = ACTIONS(2954),
    [anon_sym_match] = ACTIONS(2954),
    [anon_sym_match_BANG] = ACTIONS(2956),
    [anon_sym_function] = ACTIONS(2954),
    [anon_sym_LT_DASH] = ACTIONS(2954),
    [anon_sym_DOT_LBRACK] = ACTIONS(2956),
    [anon_sym_LT] = ACTIONS(2956),
    [anon_sym_use] = ACTIONS(2954),
    [anon_sym_use_BANG] = ACTIONS(2956),
    [anon_sym_do_BANG] = ACTIONS(2956),
    [anon_sym_begin] = ACTIONS(2954),
    [anon_sym_LPAREN2] = ACTIONS(2954),
    [anon_sym_or] = ACTIONS(2954),
    [aux_sym_char_token1] = ACTIONS(2956),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2954),
    [anon_sym_DQUOTE] = ACTIONS(2954),
    [anon_sym_AT_DQUOTE] = ACTIONS(2956),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2956),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2956),
    [sym_bool] = ACTIONS(2954),
    [sym_unit] = ACTIONS(2956),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2954),
    [sym_op_identifier] = ACTIONS(2954),
    [anon_sym_PLUS] = ACTIONS(2954),
    [anon_sym_DASH] = ACTIONS(2954),
    [anon_sym_PLUS_DOT] = ACTIONS(2954),
    [anon_sym_DASH_DOT] = ACTIONS(2954),
    [anon_sym_PERCENT] = ACTIONS(2954),
    [anon_sym_AMP_AMP] = ACTIONS(2954),
    [anon_sym_TILDE] = ACTIONS(2956),
    [aux_sym_prefix_op_token1] = ACTIONS(2954),
    [aux_sym_infix_op_token1] = ACTIONS(2956),
    [aux_sym_infix_op_token2] = ACTIONS(2954),
    [anon_sym_PIPE_PIPE] = ACTIONS(2954),
    [anon_sym_BANG_EQ] = ACTIONS(2954),
    [anon_sym_COLON_EQ] = ACTIONS(2956),
    [anon_sym_DOLLAR] = ACTIONS(2954),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2954),
    [sym_int] = ACTIONS(2954),
    [sym_xint] = ACTIONS(2956),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2956),
    [anon_sym_POUNDendif] = ACTIONS(2956),
    [sym__newline] = ACTIONS(2956),
  },
  [2085] = {
    [sym_block_comment] = STATE(2085),
    [sym_compiler_directive_decl] = STATE(2085),
    [sym_fsi_directive_decl] = STATE(2085),
    [sym_preproc_line] = STATE(2085),
    [sym_identifier] = ACTIONS(2934),
    [anon_sym_EQ] = ACTIONS(2936),
    [anon_sym_COLON] = ACTIONS(2934),
    [anon_sym_return] = ACTIONS(2934),
    [anon_sym_do] = ACTIONS(2934),
    [anon_sym_let] = ACTIONS(2934),
    [anon_sym_let_BANG] = ACTIONS(2936),
    [anon_sym_LPAREN] = ACTIONS(2934),
    [anon_sym_COMMA] = ACTIONS(2936),
    [anon_sym_null] = ACTIONS(2934),
    [anon_sym_QMARK] = ACTIONS(2934),
    [anon_sym_COLON_QMARK] = ACTIONS(2934),
    [anon_sym_COLON_COLON] = ACTIONS(2936),
    [anon_sym_AMP] = ACTIONS(2934),
    [anon_sym_LBRACK] = ACTIONS(2934),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2936),
    [anon_sym_LBRACE] = ACTIONS(2934),
    [anon_sym_LT_AT] = ACTIONS(2934),
    [anon_sym_LT_AT_AT] = ACTIONS(2934),
    [anon_sym_DOT] = ACTIONS(2934),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2936),
    [anon_sym_new] = ACTIONS(2934),
    [anon_sym_return_BANG] = ACTIONS(2936),
    [anon_sym_yield] = ACTIONS(2934),
    [anon_sym_yield_BANG] = ACTIONS(2936),
    [anon_sym_lazy] = ACTIONS(2934),
    [anon_sym_assert] = ACTIONS(2934),
    [anon_sym_upcast] = ACTIONS(2934),
    [anon_sym_downcast] = ACTIONS(2934),
    [anon_sym_COLON_GT] = ACTIONS(2936),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2936),
    [anon_sym_for] = ACTIONS(2934),
    [anon_sym_while] = ACTIONS(2934),
    [anon_sym_if] = ACTIONS(2934),
    [anon_sym_fun] = ACTIONS(2934),
    [anon_sym_try] = ACTIONS(2934),
    [anon_sym_match] = ACTIONS(2934),
    [anon_sym_match_BANG] = ACTIONS(2936),
    [anon_sym_function] = ACTIONS(2934),
    [anon_sym_LT_DASH] = ACTIONS(2934),
    [anon_sym_DOT_LBRACK] = ACTIONS(2936),
    [anon_sym_LT] = ACTIONS(2936),
    [anon_sym_use] = ACTIONS(2934),
    [anon_sym_use_BANG] = ACTIONS(2936),
    [anon_sym_do_BANG] = ACTIONS(2936),
    [anon_sym_begin] = ACTIONS(2934),
    [anon_sym_LPAREN2] = ACTIONS(2934),
    [anon_sym_or] = ACTIONS(2934),
    [aux_sym_char_token1] = ACTIONS(2936),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2934),
    [anon_sym_DQUOTE] = ACTIONS(2934),
    [anon_sym_AT_DQUOTE] = ACTIONS(2936),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2936),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2936),
    [sym_bool] = ACTIONS(2934),
    [sym_unit] = ACTIONS(2936),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2934),
    [sym_op_identifier] = ACTIONS(2934),
    [anon_sym_PLUS] = ACTIONS(2934),
    [anon_sym_DASH] = ACTIONS(2934),
    [anon_sym_PLUS_DOT] = ACTIONS(2934),
    [anon_sym_DASH_DOT] = ACTIONS(2934),
    [anon_sym_PERCENT] = ACTIONS(2934),
    [anon_sym_AMP_AMP] = ACTIONS(2934),
    [anon_sym_TILDE] = ACTIONS(2936),
    [aux_sym_prefix_op_token1] = ACTIONS(2934),
    [aux_sym_infix_op_token1] = ACTIONS(2936),
    [aux_sym_infix_op_token2] = ACTIONS(2934),
    [anon_sym_PIPE_PIPE] = ACTIONS(2934),
    [anon_sym_BANG_EQ] = ACTIONS(2934),
    [anon_sym_COLON_EQ] = ACTIONS(2936),
    [anon_sym_DOLLAR] = ACTIONS(2934),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2934),
    [sym_int] = ACTIONS(2934),
    [sym_xint] = ACTIONS(2936),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2936),
    [anon_sym_POUNDendif] = ACTIONS(2936),
    [sym__newline] = ACTIONS(2936),
  },
  [2086] = {
    [sym_block_comment] = STATE(2086),
    [sym_compiler_directive_decl] = STATE(2086),
    [sym_fsi_directive_decl] = STATE(2086),
    [sym_preproc_line] = STATE(2086),
    [sym_identifier] = ACTIONS(2996),
    [anon_sym_EQ] = ACTIONS(2998),
    [anon_sym_COLON] = ACTIONS(2996),
    [anon_sym_return] = ACTIONS(2996),
    [anon_sym_do] = ACTIONS(2996),
    [anon_sym_let] = ACTIONS(2996),
    [anon_sym_let_BANG] = ACTIONS(2998),
    [anon_sym_LPAREN] = ACTIONS(2996),
    [anon_sym_COMMA] = ACTIONS(2998),
    [anon_sym_null] = ACTIONS(2996),
    [anon_sym_QMARK] = ACTIONS(2996),
    [anon_sym_COLON_QMARK] = ACTIONS(2996),
    [anon_sym_COLON_COLON] = ACTIONS(2998),
    [anon_sym_AMP] = ACTIONS(2996),
    [anon_sym_LBRACK] = ACTIONS(2996),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2998),
    [anon_sym_LBRACE] = ACTIONS(2996),
    [anon_sym_LT_AT] = ACTIONS(2996),
    [anon_sym_LT_AT_AT] = ACTIONS(2996),
    [anon_sym_DOT] = ACTIONS(2996),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2998),
    [anon_sym_new] = ACTIONS(2996),
    [anon_sym_return_BANG] = ACTIONS(2998),
    [anon_sym_yield] = ACTIONS(2996),
    [anon_sym_yield_BANG] = ACTIONS(2998),
    [anon_sym_lazy] = ACTIONS(2996),
    [anon_sym_assert] = ACTIONS(2996),
    [anon_sym_upcast] = ACTIONS(2996),
    [anon_sym_downcast] = ACTIONS(2996),
    [anon_sym_COLON_GT] = ACTIONS(2998),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2998),
    [anon_sym_for] = ACTIONS(2996),
    [anon_sym_while] = ACTIONS(2996),
    [anon_sym_if] = ACTIONS(2996),
    [anon_sym_fun] = ACTIONS(2996),
    [anon_sym_try] = ACTIONS(2996),
    [anon_sym_match] = ACTIONS(2996),
    [anon_sym_match_BANG] = ACTIONS(2998),
    [anon_sym_function] = ACTIONS(2996),
    [anon_sym_LT_DASH] = ACTIONS(2996),
    [anon_sym_DOT_LBRACK] = ACTIONS(2998),
    [anon_sym_LT] = ACTIONS(2998),
    [anon_sym_GT] = ACTIONS(2996),
    [anon_sym_use] = ACTIONS(2996),
    [anon_sym_use_BANG] = ACTIONS(2998),
    [anon_sym_do_BANG] = ACTIONS(2998),
    [anon_sym_begin] = ACTIONS(2996),
    [anon_sym_LPAREN2] = ACTIONS(2996),
    [anon_sym_or] = ACTIONS(2996),
    [aux_sym_char_token1] = ACTIONS(2998),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2996),
    [anon_sym_DQUOTE] = ACTIONS(2996),
    [anon_sym_AT_DQUOTE] = ACTIONS(2998),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2998),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2998),
    [sym_bool] = ACTIONS(2996),
    [sym_unit] = ACTIONS(2998),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2996),
    [sym_op_identifier] = ACTIONS(2996),
    [anon_sym_PLUS] = ACTIONS(2996),
    [anon_sym_DASH] = ACTIONS(2996),
    [anon_sym_PLUS_DOT] = ACTIONS(2996),
    [anon_sym_DASH_DOT] = ACTIONS(2996),
    [anon_sym_PERCENT] = ACTIONS(2996),
    [anon_sym_AMP_AMP] = ACTIONS(2996),
    [anon_sym_TILDE] = ACTIONS(2998),
    [aux_sym_prefix_op_token1] = ACTIONS(2996),
    [aux_sym_infix_op_token1] = ACTIONS(2998),
    [aux_sym_infix_op_token2] = ACTIONS(2996),
    [anon_sym_PIPE_PIPE] = ACTIONS(2996),
    [anon_sym_BANG_EQ] = ACTIONS(2996),
    [anon_sym_COLON_EQ] = ACTIONS(2998),
    [anon_sym_DOLLAR] = ACTIONS(2996),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2996),
    [sym_int] = ACTIONS(2996),
    [sym_xint] = ACTIONS(2998),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2998),
    [sym__newline] = ACTIONS(2998),
  },
  [2087] = {
    [sym_block_comment] = STATE(2087),
    [sym_compiler_directive_decl] = STATE(2087),
    [sym_fsi_directive_decl] = STATE(2087),
    [sym_preproc_line] = STATE(2087),
    [sym_identifier] = ACTIONS(3115),
    [anon_sym_EQ] = ACTIONS(3117),
    [anon_sym_COLON] = ACTIONS(3115),
    [anon_sym_return] = ACTIONS(3115),
    [anon_sym_do] = ACTIONS(3115),
    [anon_sym_let] = ACTIONS(3115),
    [anon_sym_let_BANG] = ACTIONS(3117),
    [anon_sym_LPAREN] = ACTIONS(3115),
    [anon_sym_COMMA] = ACTIONS(3117),
    [anon_sym_null] = ACTIONS(3115),
    [anon_sym_QMARK] = ACTIONS(3115),
    [anon_sym_COLON_QMARK] = ACTIONS(3115),
    [anon_sym_COLON_COLON] = ACTIONS(3117),
    [anon_sym_AMP] = ACTIONS(3115),
    [anon_sym_LBRACK] = ACTIONS(3115),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3117),
    [anon_sym_LBRACE] = ACTIONS(3115),
    [anon_sym_LT_AT] = ACTIONS(3115),
    [anon_sym_LT_AT_AT] = ACTIONS(3115),
    [anon_sym_DOT] = ACTIONS(3115),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3117),
    [anon_sym_new] = ACTIONS(3115),
    [anon_sym_return_BANG] = ACTIONS(3117),
    [anon_sym_yield] = ACTIONS(3115),
    [anon_sym_yield_BANG] = ACTIONS(3117),
    [anon_sym_lazy] = ACTIONS(3115),
    [anon_sym_assert] = ACTIONS(3115),
    [anon_sym_upcast] = ACTIONS(3115),
    [anon_sym_downcast] = ACTIONS(3115),
    [anon_sym_COLON_GT] = ACTIONS(3117),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3117),
    [anon_sym_for] = ACTIONS(3115),
    [anon_sym_while] = ACTIONS(3115),
    [anon_sym_if] = ACTIONS(3115),
    [anon_sym_fun] = ACTIONS(3115),
    [anon_sym_try] = ACTIONS(3115),
    [anon_sym_match] = ACTIONS(3115),
    [anon_sym_match_BANG] = ACTIONS(3117),
    [anon_sym_function] = ACTIONS(3115),
    [anon_sym_LT_DASH] = ACTIONS(3115),
    [anon_sym_DOT_LBRACK] = ACTIONS(3117),
    [anon_sym_LT] = ACTIONS(3117),
    [anon_sym_GT] = ACTIONS(3115),
    [anon_sym_use] = ACTIONS(3115),
    [anon_sym_use_BANG] = ACTIONS(3117),
    [anon_sym_do_BANG] = ACTIONS(3117),
    [anon_sym_begin] = ACTIONS(3115),
    [anon_sym_LPAREN2] = ACTIONS(3115),
    [anon_sym_or] = ACTIONS(3115),
    [aux_sym_char_token1] = ACTIONS(3117),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3115),
    [anon_sym_DQUOTE] = ACTIONS(3115),
    [anon_sym_AT_DQUOTE] = ACTIONS(3117),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3117),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3117),
    [sym_bool] = ACTIONS(3115),
    [sym_unit] = ACTIONS(3117),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3115),
    [sym_op_identifier] = ACTIONS(3115),
    [anon_sym_PLUS] = ACTIONS(3115),
    [anon_sym_DASH] = ACTIONS(3115),
    [anon_sym_PLUS_DOT] = ACTIONS(3115),
    [anon_sym_DASH_DOT] = ACTIONS(3115),
    [anon_sym_PERCENT] = ACTIONS(3115),
    [anon_sym_AMP_AMP] = ACTIONS(3115),
    [anon_sym_TILDE] = ACTIONS(3117),
    [aux_sym_prefix_op_token1] = ACTIONS(3115),
    [aux_sym_infix_op_token1] = ACTIONS(3117),
    [aux_sym_infix_op_token2] = ACTIONS(3115),
    [anon_sym_PIPE_PIPE] = ACTIONS(3115),
    [anon_sym_BANG_EQ] = ACTIONS(3115),
    [anon_sym_COLON_EQ] = ACTIONS(3117),
    [anon_sym_DOLLAR] = ACTIONS(3115),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3115),
    [sym_int] = ACTIONS(3115),
    [sym_xint] = ACTIONS(3117),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3117),
    [sym__newline] = ACTIONS(3117),
  },
  [2088] = {
    [sym_block_comment] = STATE(2088),
    [sym_compiler_directive_decl] = STATE(2088),
    [sym_fsi_directive_decl] = STATE(2088),
    [sym_preproc_line] = STATE(2088),
    [sym_identifier] = ACTIONS(3095),
    [anon_sym_EQ] = ACTIONS(3097),
    [anon_sym_COLON] = ACTIONS(3095),
    [anon_sym_return] = ACTIONS(3095),
    [anon_sym_do] = ACTIONS(3095),
    [anon_sym_let] = ACTIONS(3095),
    [anon_sym_let_BANG] = ACTIONS(3097),
    [anon_sym_LPAREN] = ACTIONS(3095),
    [anon_sym_COMMA] = ACTIONS(3097),
    [anon_sym_null] = ACTIONS(3095),
    [anon_sym_QMARK] = ACTIONS(3095),
    [anon_sym_COLON_QMARK] = ACTIONS(3095),
    [anon_sym_COLON_COLON] = ACTIONS(3097),
    [anon_sym_AMP] = ACTIONS(3095),
    [anon_sym_LBRACK] = ACTIONS(3095),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3097),
    [anon_sym_LBRACE] = ACTIONS(3095),
    [anon_sym_LT_AT] = ACTIONS(3095),
    [anon_sym_LT_AT_AT] = ACTIONS(3095),
    [anon_sym_DOT] = ACTIONS(3095),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3097),
    [anon_sym_new] = ACTIONS(3095),
    [anon_sym_return_BANG] = ACTIONS(3097),
    [anon_sym_yield] = ACTIONS(3095),
    [anon_sym_yield_BANG] = ACTIONS(3097),
    [anon_sym_lazy] = ACTIONS(3095),
    [anon_sym_assert] = ACTIONS(3095),
    [anon_sym_upcast] = ACTIONS(3095),
    [anon_sym_downcast] = ACTIONS(3095),
    [anon_sym_COLON_GT] = ACTIONS(3097),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3097),
    [anon_sym_for] = ACTIONS(3095),
    [anon_sym_while] = ACTIONS(3095),
    [anon_sym_if] = ACTIONS(3095),
    [anon_sym_fun] = ACTIONS(3095),
    [anon_sym_try] = ACTIONS(3095),
    [anon_sym_match] = ACTIONS(3095),
    [anon_sym_match_BANG] = ACTIONS(3097),
    [anon_sym_function] = ACTIONS(3095),
    [anon_sym_LT_DASH] = ACTIONS(3095),
    [anon_sym_DOT_LBRACK] = ACTIONS(3097),
    [anon_sym_LT] = ACTIONS(3097),
    [anon_sym_GT] = ACTIONS(3095),
    [anon_sym_use] = ACTIONS(3095),
    [anon_sym_use_BANG] = ACTIONS(3097),
    [anon_sym_do_BANG] = ACTIONS(3097),
    [anon_sym_begin] = ACTIONS(3095),
    [anon_sym_LPAREN2] = ACTIONS(3095),
    [anon_sym_or] = ACTIONS(3095),
    [aux_sym_char_token1] = ACTIONS(3097),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3095),
    [anon_sym_DQUOTE] = ACTIONS(3095),
    [anon_sym_AT_DQUOTE] = ACTIONS(3097),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3097),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3097),
    [sym_bool] = ACTIONS(3095),
    [sym_unit] = ACTIONS(3097),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3095),
    [sym_op_identifier] = ACTIONS(3095),
    [anon_sym_PLUS] = ACTIONS(3095),
    [anon_sym_DASH] = ACTIONS(3095),
    [anon_sym_PLUS_DOT] = ACTIONS(3095),
    [anon_sym_DASH_DOT] = ACTIONS(3095),
    [anon_sym_PERCENT] = ACTIONS(3095),
    [anon_sym_AMP_AMP] = ACTIONS(3095),
    [anon_sym_TILDE] = ACTIONS(3097),
    [aux_sym_prefix_op_token1] = ACTIONS(3095),
    [aux_sym_infix_op_token1] = ACTIONS(3097),
    [aux_sym_infix_op_token2] = ACTIONS(3095),
    [anon_sym_PIPE_PIPE] = ACTIONS(3095),
    [anon_sym_BANG_EQ] = ACTIONS(3095),
    [anon_sym_COLON_EQ] = ACTIONS(3097),
    [anon_sym_DOLLAR] = ACTIONS(3095),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3095),
    [sym_int] = ACTIONS(3095),
    [sym_xint] = ACTIONS(3097),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3097),
    [sym__newline] = ACTIONS(3097),
  },
  [2089] = {
    [sym_block_comment] = STATE(2089),
    [sym_compiler_directive_decl] = STATE(2089),
    [sym_fsi_directive_decl] = STATE(2089),
    [sym_preproc_line] = STATE(2089),
    [sym_identifier] = ACTIONS(2867),
    [anon_sym_EQ] = ACTIONS(2869),
    [anon_sym_COLON] = ACTIONS(2867),
    [anon_sym_return] = ACTIONS(2867),
    [anon_sym_do] = ACTIONS(2867),
    [anon_sym_let] = ACTIONS(2867),
    [anon_sym_let_BANG] = ACTIONS(2869),
    [anon_sym_LPAREN] = ACTIONS(2867),
    [anon_sym_COMMA] = ACTIONS(2869),
    [anon_sym_null] = ACTIONS(2867),
    [anon_sym_QMARK] = ACTIONS(2867),
    [anon_sym_COLON_QMARK] = ACTIONS(2867),
    [anon_sym_COLON_COLON] = ACTIONS(2869),
    [anon_sym_AMP] = ACTIONS(2867),
    [anon_sym_LBRACK] = ACTIONS(2867),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2869),
    [anon_sym_LBRACE] = ACTIONS(2867),
    [anon_sym_LT_AT] = ACTIONS(2867),
    [anon_sym_LT_AT_AT] = ACTIONS(2867),
    [anon_sym_DOT] = ACTIONS(2867),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2869),
    [anon_sym_new] = ACTIONS(2867),
    [anon_sym_return_BANG] = ACTIONS(2869),
    [anon_sym_yield] = ACTIONS(2867),
    [anon_sym_yield_BANG] = ACTIONS(2869),
    [anon_sym_lazy] = ACTIONS(2867),
    [anon_sym_assert] = ACTIONS(2867),
    [anon_sym_upcast] = ACTIONS(2867),
    [anon_sym_downcast] = ACTIONS(2867),
    [anon_sym_COLON_GT] = ACTIONS(2869),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2869),
    [anon_sym_for] = ACTIONS(2867),
    [anon_sym_while] = ACTIONS(2867),
    [anon_sym_if] = ACTIONS(2867),
    [anon_sym_fun] = ACTIONS(2867),
    [anon_sym_try] = ACTIONS(2867),
    [anon_sym_match] = ACTIONS(2867),
    [anon_sym_match_BANG] = ACTIONS(2869),
    [anon_sym_function] = ACTIONS(2867),
    [anon_sym_LT_DASH] = ACTIONS(2867),
    [anon_sym_DOT_LBRACK] = ACTIONS(2869),
    [anon_sym_LT] = ACTIONS(2869),
    [anon_sym_use] = ACTIONS(2867),
    [anon_sym_use_BANG] = ACTIONS(2869),
    [anon_sym_do_BANG] = ACTIONS(2869),
    [anon_sym_begin] = ACTIONS(2867),
    [anon_sym_LPAREN2] = ACTIONS(2867),
    [anon_sym_or] = ACTIONS(2867),
    [aux_sym_char_token1] = ACTIONS(2869),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2867),
    [anon_sym_DQUOTE] = ACTIONS(2867),
    [anon_sym_AT_DQUOTE] = ACTIONS(2869),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2869),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2869),
    [sym_bool] = ACTIONS(2867),
    [sym_unit] = ACTIONS(2869),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2867),
    [sym_op_identifier] = ACTIONS(2867),
    [anon_sym_PLUS] = ACTIONS(2867),
    [anon_sym_DASH] = ACTIONS(2867),
    [anon_sym_PLUS_DOT] = ACTIONS(2867),
    [anon_sym_DASH_DOT] = ACTIONS(2867),
    [anon_sym_PERCENT] = ACTIONS(2867),
    [anon_sym_AMP_AMP] = ACTIONS(2867),
    [anon_sym_TILDE] = ACTIONS(2869),
    [aux_sym_prefix_op_token1] = ACTIONS(2867),
    [aux_sym_infix_op_token1] = ACTIONS(2869),
    [aux_sym_infix_op_token2] = ACTIONS(2867),
    [anon_sym_PIPE_PIPE] = ACTIONS(2867),
    [anon_sym_BANG_EQ] = ACTIONS(2867),
    [anon_sym_COLON_EQ] = ACTIONS(2869),
    [anon_sym_DOLLAR] = ACTIONS(2867),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2867),
    [sym_int] = ACTIONS(2867),
    [sym_xint] = ACTIONS(2869),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2869),
    [anon_sym_POUNDendif] = ACTIONS(2869),
    [sym__newline] = ACTIONS(2869),
  },
  [2090] = {
    [sym_block_comment] = STATE(2090),
    [sym_compiler_directive_decl] = STATE(2090),
    [sym_fsi_directive_decl] = STATE(2090),
    [sym_preproc_line] = STATE(2090),
    [sym_identifier] = ACTIONS(2970),
    [anon_sym_EQ] = ACTIONS(2972),
    [anon_sym_COLON] = ACTIONS(2970),
    [anon_sym_return] = ACTIONS(2970),
    [anon_sym_do] = ACTIONS(2970),
    [anon_sym_let] = ACTIONS(2970),
    [anon_sym_let_BANG] = ACTIONS(2972),
    [anon_sym_LPAREN] = ACTIONS(2970),
    [anon_sym_COMMA] = ACTIONS(2972),
    [anon_sym_null] = ACTIONS(2970),
    [anon_sym_QMARK] = ACTIONS(2970),
    [anon_sym_COLON_QMARK] = ACTIONS(2970),
    [anon_sym_COLON_COLON] = ACTIONS(2972),
    [anon_sym_AMP] = ACTIONS(2970),
    [anon_sym_LBRACK] = ACTIONS(2970),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2972),
    [anon_sym_LBRACE] = ACTIONS(2970),
    [anon_sym_LT_AT] = ACTIONS(2970),
    [anon_sym_LT_AT_AT] = ACTIONS(2970),
    [anon_sym_AT_AT_GT] = ACTIONS(2970),
    [anon_sym_DOT] = ACTIONS(2970),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2972),
    [anon_sym_new] = ACTIONS(2970),
    [anon_sym_return_BANG] = ACTIONS(2972),
    [anon_sym_yield] = ACTIONS(2970),
    [anon_sym_yield_BANG] = ACTIONS(2972),
    [anon_sym_lazy] = ACTIONS(2970),
    [anon_sym_assert] = ACTIONS(2970),
    [anon_sym_upcast] = ACTIONS(2970),
    [anon_sym_downcast] = ACTIONS(2970),
    [anon_sym_COLON_GT] = ACTIONS(2972),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2972),
    [anon_sym_for] = ACTIONS(2970),
    [anon_sym_while] = ACTIONS(2970),
    [anon_sym_if] = ACTIONS(2970),
    [anon_sym_fun] = ACTIONS(2970),
    [anon_sym_try] = ACTIONS(2970),
    [anon_sym_match] = ACTIONS(2970),
    [anon_sym_match_BANG] = ACTIONS(2972),
    [anon_sym_function] = ACTIONS(2970),
    [anon_sym_LT_DASH] = ACTIONS(2970),
    [anon_sym_DOT_LBRACK] = ACTIONS(2972),
    [anon_sym_LT] = ACTIONS(2972),
    [anon_sym_use] = ACTIONS(2970),
    [anon_sym_use_BANG] = ACTIONS(2972),
    [anon_sym_do_BANG] = ACTIONS(2972),
    [anon_sym_begin] = ACTIONS(2970),
    [anon_sym_LPAREN2] = ACTIONS(2970),
    [anon_sym_or] = ACTIONS(2970),
    [aux_sym_char_token1] = ACTIONS(2972),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2970),
    [anon_sym_DQUOTE] = ACTIONS(2970),
    [anon_sym_AT_DQUOTE] = ACTIONS(2972),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2972),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2972),
    [sym_bool] = ACTIONS(2970),
    [sym_unit] = ACTIONS(2972),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2970),
    [sym_op_identifier] = ACTIONS(2970),
    [anon_sym_PLUS] = ACTIONS(2970),
    [anon_sym_DASH] = ACTIONS(2970),
    [anon_sym_PLUS_DOT] = ACTIONS(2970),
    [anon_sym_DASH_DOT] = ACTIONS(2970),
    [anon_sym_PERCENT] = ACTIONS(2970),
    [anon_sym_AMP_AMP] = ACTIONS(2970),
    [anon_sym_TILDE] = ACTIONS(2972),
    [aux_sym_prefix_op_token1] = ACTIONS(2970),
    [aux_sym_infix_op_token1] = ACTIONS(2972),
    [aux_sym_infix_op_token2] = ACTIONS(2970),
    [anon_sym_PIPE_PIPE] = ACTIONS(2970),
    [anon_sym_BANG_EQ] = ACTIONS(2970),
    [anon_sym_COLON_EQ] = ACTIONS(2972),
    [anon_sym_DOLLAR] = ACTIONS(2970),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2970),
    [sym_int] = ACTIONS(2970),
    [sym_xint] = ACTIONS(2972),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2972),
    [sym__newline] = ACTIONS(2972),
  },
  [2091] = {
    [sym_block_comment] = STATE(2091),
    [sym_compiler_directive_decl] = STATE(2091),
    [sym_fsi_directive_decl] = STATE(2091),
    [sym_preproc_line] = STATE(2091),
    [sym_identifier] = ACTIONS(2992),
    [anon_sym_EQ] = ACTIONS(2994),
    [anon_sym_COLON] = ACTIONS(2992),
    [anon_sym_return] = ACTIONS(2992),
    [anon_sym_do] = ACTIONS(2992),
    [anon_sym_let] = ACTIONS(2992),
    [anon_sym_let_BANG] = ACTIONS(2994),
    [anon_sym_LPAREN] = ACTIONS(2992),
    [anon_sym_COMMA] = ACTIONS(2994),
    [anon_sym_null] = ACTIONS(2992),
    [anon_sym_QMARK] = ACTIONS(2992),
    [anon_sym_COLON_QMARK] = ACTIONS(2992),
    [anon_sym_COLON_COLON] = ACTIONS(2994),
    [anon_sym_AMP] = ACTIONS(2992),
    [anon_sym_LBRACK] = ACTIONS(2992),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2994),
    [anon_sym_LBRACE] = ACTIONS(2992),
    [anon_sym_LT_AT] = ACTIONS(2992),
    [anon_sym_LT_AT_AT] = ACTIONS(2992),
    [anon_sym_DOT] = ACTIONS(2992),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2994),
    [anon_sym_new] = ACTIONS(2992),
    [anon_sym_return_BANG] = ACTIONS(2994),
    [anon_sym_yield] = ACTIONS(2992),
    [anon_sym_yield_BANG] = ACTIONS(2994),
    [anon_sym_lazy] = ACTIONS(2992),
    [anon_sym_assert] = ACTIONS(2992),
    [anon_sym_upcast] = ACTIONS(2992),
    [anon_sym_downcast] = ACTIONS(2992),
    [anon_sym_COLON_GT] = ACTIONS(2994),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2994),
    [anon_sym_for] = ACTIONS(2992),
    [anon_sym_while] = ACTIONS(2992),
    [anon_sym_if] = ACTIONS(2992),
    [anon_sym_fun] = ACTIONS(2992),
    [anon_sym_try] = ACTIONS(2992),
    [anon_sym_match] = ACTIONS(2992),
    [anon_sym_match_BANG] = ACTIONS(2994),
    [anon_sym_function] = ACTIONS(2992),
    [anon_sym_LT_DASH] = ACTIONS(2992),
    [anon_sym_DOT_LBRACK] = ACTIONS(2994),
    [anon_sym_LT] = ACTIONS(2994),
    [anon_sym_GT] = ACTIONS(2992),
    [anon_sym_use] = ACTIONS(2992),
    [anon_sym_use_BANG] = ACTIONS(2994),
    [anon_sym_do_BANG] = ACTIONS(2994),
    [anon_sym_begin] = ACTIONS(2992),
    [anon_sym_LPAREN2] = ACTIONS(2992),
    [anon_sym_or] = ACTIONS(2992),
    [aux_sym_char_token1] = ACTIONS(2994),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2992),
    [anon_sym_DQUOTE] = ACTIONS(2992),
    [anon_sym_AT_DQUOTE] = ACTIONS(2994),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2994),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2994),
    [sym_bool] = ACTIONS(2992),
    [sym_unit] = ACTIONS(2994),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2992),
    [sym_op_identifier] = ACTIONS(2992),
    [anon_sym_PLUS] = ACTIONS(2992),
    [anon_sym_DASH] = ACTIONS(2992),
    [anon_sym_PLUS_DOT] = ACTIONS(2992),
    [anon_sym_DASH_DOT] = ACTIONS(2992),
    [anon_sym_PERCENT] = ACTIONS(2992),
    [anon_sym_AMP_AMP] = ACTIONS(2992),
    [anon_sym_TILDE] = ACTIONS(2994),
    [aux_sym_prefix_op_token1] = ACTIONS(2992),
    [aux_sym_infix_op_token1] = ACTIONS(2994),
    [aux_sym_infix_op_token2] = ACTIONS(2992),
    [anon_sym_PIPE_PIPE] = ACTIONS(2992),
    [anon_sym_BANG_EQ] = ACTIONS(2992),
    [anon_sym_COLON_EQ] = ACTIONS(2994),
    [anon_sym_DOLLAR] = ACTIONS(2992),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2992),
    [sym_int] = ACTIONS(2992),
    [sym_xint] = ACTIONS(2994),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2994),
    [sym__newline] = ACTIONS(2994),
  },
  [2092] = {
    [sym_block_comment] = STATE(2092),
    [sym_compiler_directive_decl] = STATE(2092),
    [sym_fsi_directive_decl] = STATE(2092),
    [sym_preproc_line] = STATE(2092),
    [sym_identifier] = ACTIONS(2978),
    [anon_sym_EQ] = ACTIONS(2980),
    [anon_sym_COLON] = ACTIONS(2978),
    [anon_sym_return] = ACTIONS(2978),
    [anon_sym_do] = ACTIONS(2978),
    [anon_sym_let] = ACTIONS(2978),
    [anon_sym_let_BANG] = ACTIONS(2980),
    [anon_sym_LPAREN] = ACTIONS(2978),
    [anon_sym_COMMA] = ACTIONS(2980),
    [anon_sym_null] = ACTIONS(2978),
    [anon_sym_QMARK] = ACTIONS(2978),
    [anon_sym_COLON_QMARK] = ACTIONS(2978),
    [anon_sym_COLON_COLON] = ACTIONS(2980),
    [anon_sym_AMP] = ACTIONS(2978),
    [anon_sym_LBRACK] = ACTIONS(2978),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2980),
    [anon_sym_LBRACE] = ACTIONS(2978),
    [anon_sym_LT_AT] = ACTIONS(2978),
    [anon_sym_LT_AT_AT] = ACTIONS(2978),
    [anon_sym_DOT] = ACTIONS(2978),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2980),
    [anon_sym_new] = ACTIONS(2978),
    [anon_sym_return_BANG] = ACTIONS(2980),
    [anon_sym_yield] = ACTIONS(2978),
    [anon_sym_yield_BANG] = ACTIONS(2980),
    [anon_sym_lazy] = ACTIONS(2978),
    [anon_sym_assert] = ACTIONS(2978),
    [anon_sym_upcast] = ACTIONS(2978),
    [anon_sym_downcast] = ACTIONS(2978),
    [anon_sym_COLON_GT] = ACTIONS(2980),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2980),
    [anon_sym_for] = ACTIONS(2978),
    [anon_sym_while] = ACTIONS(2978),
    [anon_sym_if] = ACTIONS(2978),
    [anon_sym_fun] = ACTIONS(2978),
    [anon_sym_try] = ACTIONS(2978),
    [anon_sym_match] = ACTIONS(2978),
    [anon_sym_match_BANG] = ACTIONS(2980),
    [anon_sym_function] = ACTIONS(2978),
    [anon_sym_LT_DASH] = ACTIONS(2978),
    [anon_sym_DOT_LBRACK] = ACTIONS(2980),
    [anon_sym_LT] = ACTIONS(2980),
    [anon_sym_GT] = ACTIONS(2978),
    [anon_sym_use] = ACTIONS(2978),
    [anon_sym_use_BANG] = ACTIONS(2980),
    [anon_sym_do_BANG] = ACTIONS(2980),
    [anon_sym_begin] = ACTIONS(2978),
    [anon_sym_LPAREN2] = ACTIONS(2978),
    [anon_sym_or] = ACTIONS(2978),
    [aux_sym_char_token1] = ACTIONS(2980),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2978),
    [anon_sym_DQUOTE] = ACTIONS(2978),
    [anon_sym_AT_DQUOTE] = ACTIONS(2980),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2980),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2980),
    [sym_bool] = ACTIONS(2978),
    [sym_unit] = ACTIONS(2980),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2978),
    [sym_op_identifier] = ACTIONS(2978),
    [anon_sym_PLUS] = ACTIONS(2978),
    [anon_sym_DASH] = ACTIONS(2978),
    [anon_sym_PLUS_DOT] = ACTIONS(2978),
    [anon_sym_DASH_DOT] = ACTIONS(2978),
    [anon_sym_PERCENT] = ACTIONS(2978),
    [anon_sym_AMP_AMP] = ACTIONS(2978),
    [anon_sym_TILDE] = ACTIONS(2980),
    [aux_sym_prefix_op_token1] = ACTIONS(2978),
    [aux_sym_infix_op_token1] = ACTIONS(2980),
    [aux_sym_infix_op_token2] = ACTIONS(2978),
    [anon_sym_PIPE_PIPE] = ACTIONS(2978),
    [anon_sym_BANG_EQ] = ACTIONS(2978),
    [anon_sym_COLON_EQ] = ACTIONS(2980),
    [anon_sym_DOLLAR] = ACTIONS(2978),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2978),
    [sym_int] = ACTIONS(2978),
    [sym_xint] = ACTIONS(2980),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2980),
    [sym__newline] = ACTIONS(2980),
  },
  [2093] = {
    [sym_block_comment] = STATE(2093),
    [sym_compiler_directive_decl] = STATE(2093),
    [sym_fsi_directive_decl] = STATE(2093),
    [sym_preproc_line] = STATE(2093),
    [sym_identifier] = ACTIONS(2867),
    [anon_sym_EQ] = ACTIONS(2869),
    [anon_sym_COLON] = ACTIONS(2867),
    [anon_sym_return] = ACTIONS(2867),
    [anon_sym_do] = ACTIONS(2867),
    [anon_sym_let] = ACTIONS(2867),
    [anon_sym_let_BANG] = ACTIONS(2869),
    [anon_sym_LPAREN] = ACTIONS(2867),
    [anon_sym_COMMA] = ACTIONS(2869),
    [anon_sym_null] = ACTIONS(2867),
    [anon_sym_QMARK] = ACTIONS(2867),
    [anon_sym_COLON_QMARK] = ACTIONS(2867),
    [anon_sym_COLON_COLON] = ACTIONS(2869),
    [anon_sym_AMP] = ACTIONS(2867),
    [anon_sym_LBRACK] = ACTIONS(2867),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2869),
    [anon_sym_LBRACE] = ACTIONS(2867),
    [anon_sym_LT_AT] = ACTIONS(2867),
    [anon_sym_AT_GT] = ACTIONS(2867),
    [anon_sym_LT_AT_AT] = ACTIONS(2867),
    [anon_sym_DOT] = ACTIONS(2867),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2869),
    [anon_sym_new] = ACTIONS(2867),
    [anon_sym_return_BANG] = ACTIONS(2869),
    [anon_sym_yield] = ACTIONS(2867),
    [anon_sym_yield_BANG] = ACTIONS(2869),
    [anon_sym_lazy] = ACTIONS(2867),
    [anon_sym_assert] = ACTIONS(2867),
    [anon_sym_upcast] = ACTIONS(2867),
    [anon_sym_downcast] = ACTIONS(2867),
    [anon_sym_COLON_GT] = ACTIONS(2869),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2869),
    [anon_sym_for] = ACTIONS(2867),
    [anon_sym_while] = ACTIONS(2867),
    [anon_sym_if] = ACTIONS(2867),
    [anon_sym_fun] = ACTIONS(2867),
    [anon_sym_try] = ACTIONS(2867),
    [anon_sym_match] = ACTIONS(2867),
    [anon_sym_match_BANG] = ACTIONS(2869),
    [anon_sym_function] = ACTIONS(2867),
    [anon_sym_LT_DASH] = ACTIONS(2867),
    [anon_sym_DOT_LBRACK] = ACTIONS(2869),
    [anon_sym_LT] = ACTIONS(2869),
    [anon_sym_use] = ACTIONS(2867),
    [anon_sym_use_BANG] = ACTIONS(2869),
    [anon_sym_do_BANG] = ACTIONS(2869),
    [anon_sym_begin] = ACTIONS(2867),
    [anon_sym_LPAREN2] = ACTIONS(2867),
    [anon_sym_or] = ACTIONS(2867),
    [aux_sym_char_token1] = ACTIONS(2869),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2867),
    [anon_sym_DQUOTE] = ACTIONS(2867),
    [anon_sym_AT_DQUOTE] = ACTIONS(2869),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2869),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2869),
    [sym_bool] = ACTIONS(2867),
    [sym_unit] = ACTIONS(2869),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2867),
    [sym_op_identifier] = ACTIONS(2867),
    [anon_sym_PLUS] = ACTIONS(2867),
    [anon_sym_DASH] = ACTIONS(2867),
    [anon_sym_PLUS_DOT] = ACTIONS(2867),
    [anon_sym_DASH_DOT] = ACTIONS(2867),
    [anon_sym_PERCENT] = ACTIONS(2867),
    [anon_sym_AMP_AMP] = ACTIONS(2867),
    [anon_sym_TILDE] = ACTIONS(2869),
    [aux_sym_prefix_op_token1] = ACTIONS(2867),
    [aux_sym_infix_op_token1] = ACTIONS(2869),
    [aux_sym_infix_op_token2] = ACTIONS(2867),
    [anon_sym_PIPE_PIPE] = ACTIONS(2867),
    [anon_sym_BANG_EQ] = ACTIONS(2867),
    [anon_sym_COLON_EQ] = ACTIONS(2869),
    [anon_sym_DOLLAR] = ACTIONS(2867),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2867),
    [sym_int] = ACTIONS(2867),
    [sym_xint] = ACTIONS(2869),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2869),
    [sym__newline] = ACTIONS(2869),
  },
  [2094] = {
    [sym_block_comment] = STATE(2094),
    [sym_compiler_directive_decl] = STATE(2094),
    [sym_fsi_directive_decl] = STATE(2094),
    [sym_preproc_line] = STATE(2094),
    [sym_identifier] = ACTIONS(2954),
    [anon_sym_EQ] = ACTIONS(2956),
    [anon_sym_COLON] = ACTIONS(2954),
    [anon_sym_return] = ACTIONS(2954),
    [anon_sym_do] = ACTIONS(2954),
    [anon_sym_let] = ACTIONS(2954),
    [anon_sym_let_BANG] = ACTIONS(2956),
    [anon_sym_LPAREN] = ACTIONS(2954),
    [anon_sym_COMMA] = ACTIONS(2956),
    [anon_sym_null] = ACTIONS(2954),
    [anon_sym_QMARK] = ACTIONS(2954),
    [anon_sym_COLON_QMARK] = ACTIONS(2954),
    [anon_sym_COLON_COLON] = ACTIONS(2956),
    [anon_sym_AMP] = ACTIONS(2954),
    [anon_sym_LBRACK] = ACTIONS(2954),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2956),
    [anon_sym_LBRACE] = ACTIONS(2954),
    [anon_sym_LT_AT] = ACTIONS(2954),
    [anon_sym_LT_AT_AT] = ACTIONS(2954),
    [anon_sym_AT_AT_GT] = ACTIONS(2954),
    [anon_sym_DOT] = ACTIONS(2954),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2956),
    [anon_sym_new] = ACTIONS(2954),
    [anon_sym_return_BANG] = ACTIONS(2956),
    [anon_sym_yield] = ACTIONS(2954),
    [anon_sym_yield_BANG] = ACTIONS(2956),
    [anon_sym_lazy] = ACTIONS(2954),
    [anon_sym_assert] = ACTIONS(2954),
    [anon_sym_upcast] = ACTIONS(2954),
    [anon_sym_downcast] = ACTIONS(2954),
    [anon_sym_COLON_GT] = ACTIONS(2956),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2956),
    [anon_sym_for] = ACTIONS(2954),
    [anon_sym_while] = ACTIONS(2954),
    [anon_sym_if] = ACTIONS(2954),
    [anon_sym_fun] = ACTIONS(2954),
    [anon_sym_try] = ACTIONS(2954),
    [anon_sym_match] = ACTIONS(2954),
    [anon_sym_match_BANG] = ACTIONS(2956),
    [anon_sym_function] = ACTIONS(2954),
    [anon_sym_LT_DASH] = ACTIONS(2954),
    [anon_sym_DOT_LBRACK] = ACTIONS(2956),
    [anon_sym_LT] = ACTIONS(2956),
    [anon_sym_use] = ACTIONS(2954),
    [anon_sym_use_BANG] = ACTIONS(2956),
    [anon_sym_do_BANG] = ACTIONS(2956),
    [anon_sym_begin] = ACTIONS(2954),
    [anon_sym_LPAREN2] = ACTIONS(2954),
    [anon_sym_or] = ACTIONS(2954),
    [aux_sym_char_token1] = ACTIONS(2956),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2954),
    [anon_sym_DQUOTE] = ACTIONS(2954),
    [anon_sym_AT_DQUOTE] = ACTIONS(2956),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2956),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2956),
    [sym_bool] = ACTIONS(2954),
    [sym_unit] = ACTIONS(2956),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2954),
    [sym_op_identifier] = ACTIONS(2954),
    [anon_sym_PLUS] = ACTIONS(2954),
    [anon_sym_DASH] = ACTIONS(2954),
    [anon_sym_PLUS_DOT] = ACTIONS(2954),
    [anon_sym_DASH_DOT] = ACTIONS(2954),
    [anon_sym_PERCENT] = ACTIONS(2954),
    [anon_sym_AMP_AMP] = ACTIONS(2954),
    [anon_sym_TILDE] = ACTIONS(2956),
    [aux_sym_prefix_op_token1] = ACTIONS(2954),
    [aux_sym_infix_op_token1] = ACTIONS(2956),
    [aux_sym_infix_op_token2] = ACTIONS(2954),
    [anon_sym_PIPE_PIPE] = ACTIONS(2954),
    [anon_sym_BANG_EQ] = ACTIONS(2954),
    [anon_sym_COLON_EQ] = ACTIONS(2956),
    [anon_sym_DOLLAR] = ACTIONS(2954),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2954),
    [sym_int] = ACTIONS(2954),
    [sym_xint] = ACTIONS(2956),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2956),
    [sym__newline] = ACTIONS(2956),
  },
  [2095] = {
    [sym_block_comment] = STATE(2095),
    [sym_compiler_directive_decl] = STATE(2095),
    [sym_fsi_directive_decl] = STATE(2095),
    [sym_preproc_line] = STATE(2095),
    [sym_identifier] = ACTIONS(3039),
    [anon_sym_EQ] = ACTIONS(3041),
    [anon_sym_COLON] = ACTIONS(3039),
    [anon_sym_return] = ACTIONS(3039),
    [anon_sym_do] = ACTIONS(3039),
    [anon_sym_let] = ACTIONS(3039),
    [anon_sym_let_BANG] = ACTIONS(3041),
    [anon_sym_LPAREN] = ACTIONS(3039),
    [anon_sym_COMMA] = ACTIONS(3041),
    [anon_sym_null] = ACTIONS(3039),
    [anon_sym_QMARK] = ACTIONS(3039),
    [anon_sym_COLON_QMARK] = ACTIONS(3039),
    [anon_sym_COLON_COLON] = ACTIONS(3041),
    [anon_sym_AMP] = ACTIONS(3039),
    [anon_sym_LBRACK] = ACTIONS(3039),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3041),
    [anon_sym_LBRACE] = ACTIONS(3039),
    [anon_sym_LT_AT] = ACTIONS(3039),
    [anon_sym_LT_AT_AT] = ACTIONS(3039),
    [anon_sym_DOT] = ACTIONS(3039),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3041),
    [anon_sym_new] = ACTIONS(3039),
    [anon_sym_return_BANG] = ACTIONS(3041),
    [anon_sym_yield] = ACTIONS(3039),
    [anon_sym_yield_BANG] = ACTIONS(3041),
    [anon_sym_lazy] = ACTIONS(3039),
    [anon_sym_assert] = ACTIONS(3039),
    [anon_sym_upcast] = ACTIONS(3039),
    [anon_sym_downcast] = ACTIONS(3039),
    [anon_sym_COLON_GT] = ACTIONS(3041),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3041),
    [anon_sym_for] = ACTIONS(3039),
    [anon_sym_while] = ACTIONS(3039),
    [anon_sym_if] = ACTIONS(3039),
    [anon_sym_fun] = ACTIONS(3039),
    [anon_sym_try] = ACTIONS(3039),
    [anon_sym_match] = ACTIONS(3039),
    [anon_sym_match_BANG] = ACTIONS(3041),
    [anon_sym_function] = ACTIONS(3039),
    [anon_sym_LT_DASH] = ACTIONS(3039),
    [anon_sym_DOT_LBRACK] = ACTIONS(3041),
    [anon_sym_LT] = ACTIONS(3041),
    [anon_sym_GT] = ACTIONS(3039),
    [anon_sym_use] = ACTIONS(3039),
    [anon_sym_use_BANG] = ACTIONS(3041),
    [anon_sym_do_BANG] = ACTIONS(3041),
    [anon_sym_begin] = ACTIONS(3039),
    [anon_sym_LPAREN2] = ACTIONS(3039),
    [anon_sym_or] = ACTIONS(3039),
    [aux_sym_char_token1] = ACTIONS(3041),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3039),
    [anon_sym_DQUOTE] = ACTIONS(3039),
    [anon_sym_AT_DQUOTE] = ACTIONS(3041),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3041),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3041),
    [sym_bool] = ACTIONS(3039),
    [sym_unit] = ACTIONS(3041),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3039),
    [sym_op_identifier] = ACTIONS(3039),
    [anon_sym_PLUS] = ACTIONS(3039),
    [anon_sym_DASH] = ACTIONS(3039),
    [anon_sym_PLUS_DOT] = ACTIONS(3039),
    [anon_sym_DASH_DOT] = ACTIONS(3039),
    [anon_sym_PERCENT] = ACTIONS(3039),
    [anon_sym_AMP_AMP] = ACTIONS(3039),
    [anon_sym_TILDE] = ACTIONS(3041),
    [aux_sym_prefix_op_token1] = ACTIONS(3039),
    [aux_sym_infix_op_token1] = ACTIONS(3041),
    [aux_sym_infix_op_token2] = ACTIONS(3039),
    [anon_sym_PIPE_PIPE] = ACTIONS(3039),
    [anon_sym_BANG_EQ] = ACTIONS(3039),
    [anon_sym_COLON_EQ] = ACTIONS(3041),
    [anon_sym_DOLLAR] = ACTIONS(3039),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3039),
    [sym_int] = ACTIONS(3039),
    [sym_xint] = ACTIONS(3041),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3041),
    [sym__newline] = ACTIONS(3041),
  },
  [2096] = {
    [sym_block_comment] = STATE(2096),
    [sym_compiler_directive_decl] = STATE(2096),
    [sym_fsi_directive_decl] = STATE(2096),
    [sym_preproc_line] = STATE(2096),
    [sym_identifier] = ACTIONS(3043),
    [anon_sym_EQ] = ACTIONS(3045),
    [anon_sym_COLON] = ACTIONS(3043),
    [anon_sym_return] = ACTIONS(3043),
    [anon_sym_do] = ACTIONS(3043),
    [anon_sym_let] = ACTIONS(3043),
    [anon_sym_let_BANG] = ACTIONS(3045),
    [anon_sym_LPAREN] = ACTIONS(3043),
    [anon_sym_COMMA] = ACTIONS(3045),
    [anon_sym_null] = ACTIONS(3043),
    [anon_sym_QMARK] = ACTIONS(3043),
    [anon_sym_COLON_QMARK] = ACTIONS(3043),
    [anon_sym_COLON_COLON] = ACTIONS(3045),
    [anon_sym_AMP] = ACTIONS(3043),
    [anon_sym_LBRACK] = ACTIONS(3043),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3045),
    [anon_sym_LBRACE] = ACTIONS(3043),
    [anon_sym_LT_AT] = ACTIONS(3043),
    [anon_sym_LT_AT_AT] = ACTIONS(3043),
    [anon_sym_DOT] = ACTIONS(3043),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3045),
    [anon_sym_new] = ACTIONS(3043),
    [anon_sym_return_BANG] = ACTIONS(3045),
    [anon_sym_yield] = ACTIONS(3043),
    [anon_sym_yield_BANG] = ACTIONS(3045),
    [anon_sym_lazy] = ACTIONS(3043),
    [anon_sym_assert] = ACTIONS(3043),
    [anon_sym_upcast] = ACTIONS(3043),
    [anon_sym_downcast] = ACTIONS(3043),
    [anon_sym_COLON_GT] = ACTIONS(3045),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3045),
    [anon_sym_for] = ACTIONS(3043),
    [anon_sym_while] = ACTIONS(3043),
    [anon_sym_if] = ACTIONS(3043),
    [anon_sym_fun] = ACTIONS(3043),
    [anon_sym_try] = ACTIONS(3043),
    [anon_sym_match] = ACTIONS(3043),
    [anon_sym_match_BANG] = ACTIONS(3045),
    [anon_sym_function] = ACTIONS(3043),
    [anon_sym_LT_DASH] = ACTIONS(3043),
    [anon_sym_DOT_LBRACK] = ACTIONS(3045),
    [anon_sym_LT] = ACTIONS(3045),
    [anon_sym_GT] = ACTIONS(3043),
    [anon_sym_use] = ACTIONS(3043),
    [anon_sym_use_BANG] = ACTIONS(3045),
    [anon_sym_do_BANG] = ACTIONS(3045),
    [anon_sym_begin] = ACTIONS(3043),
    [anon_sym_LPAREN2] = ACTIONS(3043),
    [anon_sym_or] = ACTIONS(3043),
    [aux_sym_char_token1] = ACTIONS(3045),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3043),
    [anon_sym_DQUOTE] = ACTIONS(3043),
    [anon_sym_AT_DQUOTE] = ACTIONS(3045),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3045),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3045),
    [sym_bool] = ACTIONS(3043),
    [sym_unit] = ACTIONS(3045),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3043),
    [sym_op_identifier] = ACTIONS(3043),
    [anon_sym_PLUS] = ACTIONS(3043),
    [anon_sym_DASH] = ACTIONS(3043),
    [anon_sym_PLUS_DOT] = ACTIONS(3043),
    [anon_sym_DASH_DOT] = ACTIONS(3043),
    [anon_sym_PERCENT] = ACTIONS(3043),
    [anon_sym_AMP_AMP] = ACTIONS(3043),
    [anon_sym_TILDE] = ACTIONS(3045),
    [aux_sym_prefix_op_token1] = ACTIONS(3043),
    [aux_sym_infix_op_token1] = ACTIONS(3045),
    [aux_sym_infix_op_token2] = ACTIONS(3043),
    [anon_sym_PIPE_PIPE] = ACTIONS(3043),
    [anon_sym_BANG_EQ] = ACTIONS(3043),
    [anon_sym_COLON_EQ] = ACTIONS(3045),
    [anon_sym_DOLLAR] = ACTIONS(3043),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3043),
    [sym_int] = ACTIONS(3043),
    [sym_xint] = ACTIONS(3045),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3045),
    [sym__newline] = ACTIONS(3045),
  },
  [2097] = {
    [sym_block_comment] = STATE(2097),
    [sym_compiler_directive_decl] = STATE(2097),
    [sym_fsi_directive_decl] = STATE(2097),
    [sym_preproc_line] = STATE(2097),
    [sym_identifier] = ACTIONS(3047),
    [anon_sym_EQ] = ACTIONS(3049),
    [anon_sym_COLON] = ACTIONS(3047),
    [anon_sym_return] = ACTIONS(3047),
    [anon_sym_do] = ACTIONS(3047),
    [anon_sym_let] = ACTIONS(3047),
    [anon_sym_let_BANG] = ACTIONS(3049),
    [anon_sym_LPAREN] = ACTIONS(3047),
    [anon_sym_COMMA] = ACTIONS(3049),
    [anon_sym_null] = ACTIONS(3047),
    [anon_sym_QMARK] = ACTIONS(3047),
    [anon_sym_COLON_QMARK] = ACTIONS(3047),
    [anon_sym_COLON_COLON] = ACTIONS(3049),
    [anon_sym_AMP] = ACTIONS(3047),
    [anon_sym_LBRACK] = ACTIONS(3047),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3049),
    [anon_sym_LBRACE] = ACTIONS(3047),
    [anon_sym_LT_AT] = ACTIONS(3047),
    [anon_sym_LT_AT_AT] = ACTIONS(3047),
    [anon_sym_DOT] = ACTIONS(3047),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3049),
    [anon_sym_new] = ACTIONS(3047),
    [anon_sym_return_BANG] = ACTIONS(3049),
    [anon_sym_yield] = ACTIONS(3047),
    [anon_sym_yield_BANG] = ACTIONS(3049),
    [anon_sym_lazy] = ACTIONS(3047),
    [anon_sym_assert] = ACTIONS(3047),
    [anon_sym_upcast] = ACTIONS(3047),
    [anon_sym_downcast] = ACTIONS(3047),
    [anon_sym_COLON_GT] = ACTIONS(3049),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3049),
    [anon_sym_for] = ACTIONS(3047),
    [anon_sym_while] = ACTIONS(3047),
    [anon_sym_if] = ACTIONS(3047),
    [anon_sym_fun] = ACTIONS(3047),
    [anon_sym_try] = ACTIONS(3047),
    [anon_sym_match] = ACTIONS(3047),
    [anon_sym_match_BANG] = ACTIONS(3049),
    [anon_sym_function] = ACTIONS(3047),
    [anon_sym_LT_DASH] = ACTIONS(3047),
    [anon_sym_DOT_LBRACK] = ACTIONS(3049),
    [anon_sym_LT] = ACTIONS(3049),
    [anon_sym_GT] = ACTIONS(3047),
    [anon_sym_use] = ACTIONS(3047),
    [anon_sym_use_BANG] = ACTIONS(3049),
    [anon_sym_do_BANG] = ACTIONS(3049),
    [anon_sym_begin] = ACTIONS(3047),
    [anon_sym_LPAREN2] = ACTIONS(3047),
    [anon_sym_or] = ACTIONS(3047),
    [aux_sym_char_token1] = ACTIONS(3049),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3047),
    [anon_sym_DQUOTE] = ACTIONS(3047),
    [anon_sym_AT_DQUOTE] = ACTIONS(3049),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3049),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3049),
    [sym_bool] = ACTIONS(3047),
    [sym_unit] = ACTIONS(3049),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3047),
    [sym_op_identifier] = ACTIONS(3047),
    [anon_sym_PLUS] = ACTIONS(3047),
    [anon_sym_DASH] = ACTIONS(3047),
    [anon_sym_PLUS_DOT] = ACTIONS(3047),
    [anon_sym_DASH_DOT] = ACTIONS(3047),
    [anon_sym_PERCENT] = ACTIONS(3047),
    [anon_sym_AMP_AMP] = ACTIONS(3047),
    [anon_sym_TILDE] = ACTIONS(3049),
    [aux_sym_prefix_op_token1] = ACTIONS(3047),
    [aux_sym_infix_op_token1] = ACTIONS(3049),
    [aux_sym_infix_op_token2] = ACTIONS(3047),
    [anon_sym_PIPE_PIPE] = ACTIONS(3047),
    [anon_sym_BANG_EQ] = ACTIONS(3047),
    [anon_sym_COLON_EQ] = ACTIONS(3049),
    [anon_sym_DOLLAR] = ACTIONS(3047),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3047),
    [sym_int] = ACTIONS(3047),
    [sym_xint] = ACTIONS(3049),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3049),
    [sym__newline] = ACTIONS(3049),
  },
  [2098] = {
    [sym_block_comment] = STATE(2098),
    [sym_compiler_directive_decl] = STATE(2098),
    [sym_fsi_directive_decl] = STATE(2098),
    [sym_preproc_line] = STATE(2098),
    [sym_identifier] = ACTIONS(2843),
    [anon_sym_EQ] = ACTIONS(2845),
    [anon_sym_COLON] = ACTIONS(2843),
    [anon_sym_return] = ACTIONS(2843),
    [anon_sym_do] = ACTIONS(2843),
    [anon_sym_let] = ACTIONS(2843),
    [anon_sym_let_BANG] = ACTIONS(2845),
    [anon_sym_LPAREN] = ACTIONS(2843),
    [anon_sym_COMMA] = ACTIONS(2845),
    [anon_sym_null] = ACTIONS(2843),
    [anon_sym_QMARK] = ACTIONS(2843),
    [anon_sym_COLON_QMARK] = ACTIONS(2843),
    [anon_sym_COLON_COLON] = ACTIONS(2845),
    [anon_sym_AMP] = ACTIONS(2843),
    [anon_sym_LBRACK] = ACTIONS(2843),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2845),
    [anon_sym_LBRACE] = ACTIONS(2843),
    [anon_sym_LT_AT] = ACTIONS(2843),
    [anon_sym_LT_AT_AT] = ACTIONS(2843),
    [anon_sym_DOT] = ACTIONS(2843),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2845),
    [anon_sym_new] = ACTIONS(2843),
    [anon_sym_return_BANG] = ACTIONS(2845),
    [anon_sym_yield] = ACTIONS(2843),
    [anon_sym_yield_BANG] = ACTIONS(2845),
    [anon_sym_lazy] = ACTIONS(2843),
    [anon_sym_assert] = ACTIONS(2843),
    [anon_sym_upcast] = ACTIONS(2843),
    [anon_sym_downcast] = ACTIONS(2843),
    [anon_sym_COLON_GT] = ACTIONS(2845),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2845),
    [anon_sym_for] = ACTIONS(2843),
    [anon_sym_while] = ACTIONS(2843),
    [anon_sym_if] = ACTIONS(2843),
    [anon_sym_fun] = ACTIONS(2843),
    [anon_sym_try] = ACTIONS(2843),
    [anon_sym_match] = ACTIONS(2843),
    [anon_sym_match_BANG] = ACTIONS(2845),
    [anon_sym_function] = ACTIONS(2843),
    [anon_sym_LT_DASH] = ACTIONS(2843),
    [anon_sym_DOT_LBRACK] = ACTIONS(2845),
    [anon_sym_LT] = ACTIONS(2845),
    [anon_sym_use] = ACTIONS(2843),
    [anon_sym_use_BANG] = ACTIONS(2845),
    [anon_sym_do_BANG] = ACTIONS(2845),
    [anon_sym_DOT_DOT] = ACTIONS(2845),
    [anon_sym_begin] = ACTIONS(2843),
    [anon_sym_LPAREN2] = ACTIONS(2843),
    [anon_sym_or] = ACTIONS(2843),
    [aux_sym_char_token1] = ACTIONS(2845),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2843),
    [anon_sym_DQUOTE] = ACTIONS(2843),
    [anon_sym_AT_DQUOTE] = ACTIONS(2845),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2845),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2845),
    [sym_bool] = ACTIONS(2843),
    [sym_unit] = ACTIONS(2845),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2843),
    [sym_op_identifier] = ACTIONS(2843),
    [anon_sym_PLUS] = ACTIONS(2843),
    [anon_sym_DASH] = ACTIONS(2843),
    [anon_sym_PLUS_DOT] = ACTIONS(2843),
    [anon_sym_DASH_DOT] = ACTIONS(2843),
    [anon_sym_PERCENT] = ACTIONS(2843),
    [anon_sym_AMP_AMP] = ACTIONS(2843),
    [anon_sym_TILDE] = ACTIONS(2845),
    [aux_sym_prefix_op_token1] = ACTIONS(2843),
    [aux_sym_infix_op_token1] = ACTIONS(2845),
    [aux_sym_infix_op_token2] = ACTIONS(2843),
    [anon_sym_PIPE_PIPE] = ACTIONS(2843),
    [anon_sym_BANG_EQ] = ACTIONS(2843),
    [anon_sym_COLON_EQ] = ACTIONS(2845),
    [anon_sym_DOLLAR] = ACTIONS(2843),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2843),
    [sym_int] = ACTIONS(2843),
    [sym_xint] = ACTIONS(2845),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2845),
    [sym__newline] = ACTIONS(2845),
  },
  [2099] = {
    [sym_block_comment] = STATE(2099),
    [sym_compiler_directive_decl] = STATE(2099),
    [sym_fsi_directive_decl] = STATE(2099),
    [sym_preproc_line] = STATE(2099),
    [sym_identifier] = ACTIONS(3035),
    [anon_sym_EQ] = ACTIONS(3037),
    [anon_sym_COLON] = ACTIONS(3035),
    [anon_sym_return] = ACTIONS(3035),
    [anon_sym_do] = ACTIONS(3035),
    [anon_sym_let] = ACTIONS(3035),
    [anon_sym_let_BANG] = ACTIONS(3037),
    [anon_sym_LPAREN] = ACTIONS(3035),
    [anon_sym_COMMA] = ACTIONS(3037),
    [anon_sym_null] = ACTIONS(3035),
    [anon_sym_QMARK] = ACTIONS(3035),
    [anon_sym_COLON_QMARK] = ACTIONS(3035),
    [anon_sym_COLON_COLON] = ACTIONS(3037),
    [anon_sym_AMP] = ACTIONS(3035),
    [anon_sym_LBRACK] = ACTIONS(3035),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3037),
    [anon_sym_LBRACE] = ACTIONS(3035),
    [anon_sym_LT_AT] = ACTIONS(3035),
    [anon_sym_LT_AT_AT] = ACTIONS(3035),
    [anon_sym_DOT] = ACTIONS(3035),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3037),
    [anon_sym_new] = ACTIONS(3035),
    [anon_sym_return_BANG] = ACTIONS(3037),
    [anon_sym_yield] = ACTIONS(3035),
    [anon_sym_yield_BANG] = ACTIONS(3037),
    [anon_sym_lazy] = ACTIONS(3035),
    [anon_sym_assert] = ACTIONS(3035),
    [anon_sym_upcast] = ACTIONS(3035),
    [anon_sym_downcast] = ACTIONS(3035),
    [anon_sym_COLON_GT] = ACTIONS(3037),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3037),
    [anon_sym_for] = ACTIONS(3035),
    [anon_sym_while] = ACTIONS(3035),
    [anon_sym_if] = ACTIONS(3035),
    [anon_sym_fun] = ACTIONS(3035),
    [anon_sym_try] = ACTIONS(3035),
    [anon_sym_match] = ACTIONS(3035),
    [anon_sym_match_BANG] = ACTIONS(3037),
    [anon_sym_function] = ACTIONS(3035),
    [anon_sym_LT_DASH] = ACTIONS(3035),
    [anon_sym_DOT_LBRACK] = ACTIONS(3037),
    [anon_sym_LT] = ACTIONS(3037),
    [anon_sym_GT] = ACTIONS(3035),
    [anon_sym_use] = ACTIONS(3035),
    [anon_sym_use_BANG] = ACTIONS(3037),
    [anon_sym_do_BANG] = ACTIONS(3037),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_LPAREN2] = ACTIONS(3035),
    [anon_sym_or] = ACTIONS(3035),
    [aux_sym_char_token1] = ACTIONS(3037),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3035),
    [anon_sym_DQUOTE] = ACTIONS(3035),
    [anon_sym_AT_DQUOTE] = ACTIONS(3037),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3037),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3037),
    [sym_bool] = ACTIONS(3035),
    [sym_unit] = ACTIONS(3037),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3035),
    [sym_op_identifier] = ACTIONS(3035),
    [anon_sym_PLUS] = ACTIONS(3035),
    [anon_sym_DASH] = ACTIONS(3035),
    [anon_sym_PLUS_DOT] = ACTIONS(3035),
    [anon_sym_DASH_DOT] = ACTIONS(3035),
    [anon_sym_PERCENT] = ACTIONS(3035),
    [anon_sym_AMP_AMP] = ACTIONS(3035),
    [anon_sym_TILDE] = ACTIONS(3037),
    [aux_sym_prefix_op_token1] = ACTIONS(3035),
    [aux_sym_infix_op_token1] = ACTIONS(3037),
    [aux_sym_infix_op_token2] = ACTIONS(3035),
    [anon_sym_PIPE_PIPE] = ACTIONS(3035),
    [anon_sym_BANG_EQ] = ACTIONS(3035),
    [anon_sym_COLON_EQ] = ACTIONS(3037),
    [anon_sym_DOLLAR] = ACTIONS(3035),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3035),
    [sym_int] = ACTIONS(3035),
    [sym_xint] = ACTIONS(3037),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3037),
    [sym__newline] = ACTIONS(3037),
  },
  [2100] = {
    [sym_block_comment] = STATE(2100),
    [sym_compiler_directive_decl] = STATE(2100),
    [sym_fsi_directive_decl] = STATE(2100),
    [sym_preproc_line] = STATE(2100),
    [sym_identifier] = ACTIONS(2158),
    [anon_sym_EQ] = ACTIONS(2160),
    [anon_sym_COLON] = ACTIONS(2158),
    [anon_sym_return] = ACTIONS(2158),
    [anon_sym_do] = ACTIONS(2158),
    [anon_sym_let] = ACTIONS(2158),
    [anon_sym_let_BANG] = ACTIONS(2160),
    [anon_sym_LPAREN] = ACTIONS(2158),
    [anon_sym_COMMA] = ACTIONS(2160),
    [anon_sym_null] = ACTIONS(2158),
    [anon_sym_QMARK] = ACTIONS(2158),
    [anon_sym_COLON_QMARK] = ACTIONS(2158),
    [anon_sym_COLON_COLON] = ACTIONS(2160),
    [anon_sym_AMP] = ACTIONS(2158),
    [anon_sym_LBRACK] = ACTIONS(2158),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2160),
    [anon_sym_LBRACE] = ACTIONS(2158),
    [anon_sym_LT_AT] = ACTIONS(2158),
    [anon_sym_LT_AT_AT] = ACTIONS(2158),
    [anon_sym_DOT] = ACTIONS(2158),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2160),
    [anon_sym_new] = ACTIONS(2158),
    [anon_sym_return_BANG] = ACTIONS(2160),
    [anon_sym_yield] = ACTIONS(2158),
    [anon_sym_yield_BANG] = ACTIONS(2160),
    [anon_sym_lazy] = ACTIONS(2158),
    [anon_sym_assert] = ACTIONS(2158),
    [anon_sym_upcast] = ACTIONS(2158),
    [anon_sym_downcast] = ACTIONS(2158),
    [anon_sym_COLON_GT] = ACTIONS(2160),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2160),
    [anon_sym_for] = ACTIONS(2158),
    [anon_sym_while] = ACTIONS(2158),
    [anon_sym_if] = ACTIONS(2158),
    [anon_sym_fun] = ACTIONS(2158),
    [anon_sym_try] = ACTIONS(2158),
    [anon_sym_match] = ACTIONS(2158),
    [anon_sym_match_BANG] = ACTIONS(2160),
    [anon_sym_function] = ACTIONS(2158),
    [anon_sym_LT_DASH] = ACTIONS(2158),
    [anon_sym_DOT_LBRACK] = ACTIONS(2160),
    [anon_sym_LT] = ACTIONS(2160),
    [anon_sym_use] = ACTIONS(2158),
    [anon_sym_use_BANG] = ACTIONS(2160),
    [anon_sym_do_BANG] = ACTIONS(2160),
    [anon_sym_DOT_DOT] = ACTIONS(2160),
    [anon_sym_begin] = ACTIONS(2158),
    [anon_sym_LPAREN2] = ACTIONS(2158),
    [anon_sym_or] = ACTIONS(2158),
    [aux_sym_char_token1] = ACTIONS(2160),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2158),
    [anon_sym_DQUOTE] = ACTIONS(2158),
    [anon_sym_AT_DQUOTE] = ACTIONS(2160),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2160),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2160),
    [sym_bool] = ACTIONS(2158),
    [sym_unit] = ACTIONS(2160),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2158),
    [sym_op_identifier] = ACTIONS(2158),
    [anon_sym_PLUS] = ACTIONS(2158),
    [anon_sym_DASH] = ACTIONS(2158),
    [anon_sym_PLUS_DOT] = ACTIONS(2158),
    [anon_sym_DASH_DOT] = ACTIONS(2158),
    [anon_sym_PERCENT] = ACTIONS(2158),
    [anon_sym_AMP_AMP] = ACTIONS(2158),
    [anon_sym_TILDE] = ACTIONS(2160),
    [aux_sym_prefix_op_token1] = ACTIONS(2158),
    [aux_sym_infix_op_token1] = ACTIONS(2160),
    [aux_sym_infix_op_token2] = ACTIONS(2158),
    [anon_sym_PIPE_PIPE] = ACTIONS(2158),
    [anon_sym_BANG_EQ] = ACTIONS(2158),
    [anon_sym_COLON_EQ] = ACTIONS(2160),
    [anon_sym_DOLLAR] = ACTIONS(2158),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2158),
    [sym_int] = ACTIONS(2158),
    [sym_xint] = ACTIONS(2160),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2160),
    [sym__newline] = ACTIONS(2160),
  },
  [2101] = {
    [sym_block_comment] = STATE(2101),
    [sym_compiler_directive_decl] = STATE(2101),
    [sym_fsi_directive_decl] = STATE(2101),
    [sym_preproc_line] = STATE(2101),
    [sym_identifier] = ACTIONS(3031),
    [anon_sym_EQ] = ACTIONS(3033),
    [anon_sym_COLON] = ACTIONS(3031),
    [anon_sym_return] = ACTIONS(3031),
    [anon_sym_do] = ACTIONS(3031),
    [anon_sym_let] = ACTIONS(3031),
    [anon_sym_let_BANG] = ACTIONS(3033),
    [anon_sym_LPAREN] = ACTIONS(3031),
    [anon_sym_COMMA] = ACTIONS(3033),
    [anon_sym_null] = ACTIONS(3031),
    [anon_sym_QMARK] = ACTIONS(3031),
    [anon_sym_COLON_QMARK] = ACTIONS(3031),
    [anon_sym_COLON_COLON] = ACTIONS(3033),
    [anon_sym_AMP] = ACTIONS(3031),
    [anon_sym_LBRACK] = ACTIONS(3031),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3033),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [anon_sym_LT_AT] = ACTIONS(3031),
    [anon_sym_LT_AT_AT] = ACTIONS(3031),
    [anon_sym_DOT] = ACTIONS(3031),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3033),
    [anon_sym_new] = ACTIONS(3031),
    [anon_sym_return_BANG] = ACTIONS(3033),
    [anon_sym_yield] = ACTIONS(3031),
    [anon_sym_yield_BANG] = ACTIONS(3033),
    [anon_sym_lazy] = ACTIONS(3031),
    [anon_sym_assert] = ACTIONS(3031),
    [anon_sym_upcast] = ACTIONS(3031),
    [anon_sym_downcast] = ACTIONS(3031),
    [anon_sym_COLON_GT] = ACTIONS(3033),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3033),
    [anon_sym_for] = ACTIONS(3031),
    [anon_sym_while] = ACTIONS(3031),
    [anon_sym_if] = ACTIONS(3031),
    [anon_sym_fun] = ACTIONS(3031),
    [anon_sym_try] = ACTIONS(3031),
    [anon_sym_match] = ACTIONS(3031),
    [anon_sym_match_BANG] = ACTIONS(3033),
    [anon_sym_function] = ACTIONS(3031),
    [anon_sym_LT_DASH] = ACTIONS(3031),
    [anon_sym_DOT_LBRACK] = ACTIONS(3033),
    [anon_sym_LT] = ACTIONS(3033),
    [anon_sym_GT] = ACTIONS(3031),
    [anon_sym_use] = ACTIONS(3031),
    [anon_sym_use_BANG] = ACTIONS(3033),
    [anon_sym_do_BANG] = ACTIONS(3033),
    [anon_sym_begin] = ACTIONS(3031),
    [anon_sym_LPAREN2] = ACTIONS(3031),
    [anon_sym_or] = ACTIONS(3031),
    [aux_sym_char_token1] = ACTIONS(3033),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3031),
    [anon_sym_DQUOTE] = ACTIONS(3031),
    [anon_sym_AT_DQUOTE] = ACTIONS(3033),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3033),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3033),
    [sym_bool] = ACTIONS(3031),
    [sym_unit] = ACTIONS(3033),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3031),
    [sym_op_identifier] = ACTIONS(3031),
    [anon_sym_PLUS] = ACTIONS(3031),
    [anon_sym_DASH] = ACTIONS(3031),
    [anon_sym_PLUS_DOT] = ACTIONS(3031),
    [anon_sym_DASH_DOT] = ACTIONS(3031),
    [anon_sym_PERCENT] = ACTIONS(3031),
    [anon_sym_AMP_AMP] = ACTIONS(3031),
    [anon_sym_TILDE] = ACTIONS(3033),
    [aux_sym_prefix_op_token1] = ACTIONS(3031),
    [aux_sym_infix_op_token1] = ACTIONS(3033),
    [aux_sym_infix_op_token2] = ACTIONS(3031),
    [anon_sym_PIPE_PIPE] = ACTIONS(3031),
    [anon_sym_BANG_EQ] = ACTIONS(3031),
    [anon_sym_COLON_EQ] = ACTIONS(3033),
    [anon_sym_DOLLAR] = ACTIONS(3031),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3031),
    [sym_int] = ACTIONS(3031),
    [sym_xint] = ACTIONS(3033),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3033),
    [sym__newline] = ACTIONS(3033),
  },
  [2102] = {
    [sym_block_comment] = STATE(2102),
    [sym_compiler_directive_decl] = STATE(2102),
    [sym_fsi_directive_decl] = STATE(2102),
    [sym_preproc_line] = STATE(2102),
    [sym_identifier] = ACTIONS(3027),
    [anon_sym_EQ] = ACTIONS(3029),
    [anon_sym_COLON] = ACTIONS(3027),
    [anon_sym_return] = ACTIONS(3027),
    [anon_sym_do] = ACTIONS(3027),
    [anon_sym_let] = ACTIONS(3027),
    [anon_sym_let_BANG] = ACTIONS(3029),
    [anon_sym_LPAREN] = ACTIONS(3027),
    [anon_sym_COMMA] = ACTIONS(3029),
    [anon_sym_null] = ACTIONS(3027),
    [anon_sym_QMARK] = ACTIONS(3027),
    [anon_sym_COLON_QMARK] = ACTIONS(3027),
    [anon_sym_COLON_COLON] = ACTIONS(3029),
    [anon_sym_AMP] = ACTIONS(3027),
    [anon_sym_LBRACK] = ACTIONS(3027),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3027),
    [anon_sym_LT_AT] = ACTIONS(3027),
    [anon_sym_LT_AT_AT] = ACTIONS(3027),
    [anon_sym_DOT] = ACTIONS(3027),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3029),
    [anon_sym_new] = ACTIONS(3027),
    [anon_sym_return_BANG] = ACTIONS(3029),
    [anon_sym_yield] = ACTIONS(3027),
    [anon_sym_yield_BANG] = ACTIONS(3029),
    [anon_sym_lazy] = ACTIONS(3027),
    [anon_sym_assert] = ACTIONS(3027),
    [anon_sym_upcast] = ACTIONS(3027),
    [anon_sym_downcast] = ACTIONS(3027),
    [anon_sym_COLON_GT] = ACTIONS(3029),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3029),
    [anon_sym_for] = ACTIONS(3027),
    [anon_sym_while] = ACTIONS(3027),
    [anon_sym_if] = ACTIONS(3027),
    [anon_sym_fun] = ACTIONS(3027),
    [anon_sym_try] = ACTIONS(3027),
    [anon_sym_match] = ACTIONS(3027),
    [anon_sym_match_BANG] = ACTIONS(3029),
    [anon_sym_function] = ACTIONS(3027),
    [anon_sym_LT_DASH] = ACTIONS(3027),
    [anon_sym_DOT_LBRACK] = ACTIONS(3029),
    [anon_sym_LT] = ACTIONS(3029),
    [anon_sym_GT] = ACTIONS(3027),
    [anon_sym_use] = ACTIONS(3027),
    [anon_sym_use_BANG] = ACTIONS(3029),
    [anon_sym_do_BANG] = ACTIONS(3029),
    [anon_sym_begin] = ACTIONS(3027),
    [anon_sym_LPAREN2] = ACTIONS(3027),
    [anon_sym_or] = ACTIONS(3027),
    [aux_sym_char_token1] = ACTIONS(3029),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3027),
    [anon_sym_DQUOTE] = ACTIONS(3027),
    [anon_sym_AT_DQUOTE] = ACTIONS(3029),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3029),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3029),
    [sym_bool] = ACTIONS(3027),
    [sym_unit] = ACTIONS(3029),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3027),
    [sym_op_identifier] = ACTIONS(3027),
    [anon_sym_PLUS] = ACTIONS(3027),
    [anon_sym_DASH] = ACTIONS(3027),
    [anon_sym_PLUS_DOT] = ACTIONS(3027),
    [anon_sym_DASH_DOT] = ACTIONS(3027),
    [anon_sym_PERCENT] = ACTIONS(3027),
    [anon_sym_AMP_AMP] = ACTIONS(3027),
    [anon_sym_TILDE] = ACTIONS(3029),
    [aux_sym_prefix_op_token1] = ACTIONS(3027),
    [aux_sym_infix_op_token1] = ACTIONS(3029),
    [aux_sym_infix_op_token2] = ACTIONS(3027),
    [anon_sym_PIPE_PIPE] = ACTIONS(3027),
    [anon_sym_BANG_EQ] = ACTIONS(3027),
    [anon_sym_COLON_EQ] = ACTIONS(3029),
    [anon_sym_DOLLAR] = ACTIONS(3027),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3027),
    [sym_int] = ACTIONS(3027),
    [sym_xint] = ACTIONS(3029),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3029),
    [sym__newline] = ACTIONS(3029),
  },
  [2103] = {
    [sym_block_comment] = STATE(2103),
    [sym_compiler_directive_decl] = STATE(2103),
    [sym_fsi_directive_decl] = STATE(2103),
    [sym_preproc_line] = STATE(2103),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_EQ] = ACTIONS(3017),
    [anon_sym_COLON] = ACTIONS(3015),
    [anon_sym_return] = ACTIONS(3015),
    [anon_sym_do] = ACTIONS(3015),
    [anon_sym_let] = ACTIONS(3015),
    [anon_sym_let_BANG] = ACTIONS(3017),
    [anon_sym_LPAREN] = ACTIONS(3015),
    [anon_sym_COMMA] = ACTIONS(3017),
    [anon_sym_null] = ACTIONS(3015),
    [anon_sym_QMARK] = ACTIONS(3015),
    [anon_sym_COLON_QMARK] = ACTIONS(3015),
    [anon_sym_COLON_COLON] = ACTIONS(3017),
    [anon_sym_AMP] = ACTIONS(3015),
    [anon_sym_LBRACK] = ACTIONS(3015),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3017),
    [anon_sym_LBRACE] = ACTIONS(3015),
    [anon_sym_LT_AT] = ACTIONS(3015),
    [anon_sym_LT_AT_AT] = ACTIONS(3015),
    [anon_sym_DOT] = ACTIONS(3015),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3017),
    [anon_sym_new] = ACTIONS(3015),
    [anon_sym_return_BANG] = ACTIONS(3017),
    [anon_sym_yield] = ACTIONS(3015),
    [anon_sym_yield_BANG] = ACTIONS(3017),
    [anon_sym_lazy] = ACTIONS(3015),
    [anon_sym_assert] = ACTIONS(3015),
    [anon_sym_upcast] = ACTIONS(3015),
    [anon_sym_downcast] = ACTIONS(3015),
    [anon_sym_COLON_GT] = ACTIONS(3017),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3017),
    [anon_sym_for] = ACTIONS(3015),
    [anon_sym_while] = ACTIONS(3015),
    [anon_sym_if] = ACTIONS(3015),
    [anon_sym_fun] = ACTIONS(3015),
    [anon_sym_try] = ACTIONS(3015),
    [anon_sym_match] = ACTIONS(3015),
    [anon_sym_match_BANG] = ACTIONS(3017),
    [anon_sym_function] = ACTIONS(3015),
    [anon_sym_LT_DASH] = ACTIONS(3015),
    [anon_sym_DOT_LBRACK] = ACTIONS(3017),
    [anon_sym_LT] = ACTIONS(3017),
    [anon_sym_use] = ACTIONS(3015),
    [anon_sym_use_BANG] = ACTIONS(3017),
    [anon_sym_do_BANG] = ACTIONS(3017),
    [anon_sym_begin] = ACTIONS(3015),
    [anon_sym_LPAREN2] = ACTIONS(3015),
    [anon_sym_or] = ACTIONS(3015),
    [aux_sym_char_token1] = ACTIONS(3017),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3015),
    [anon_sym_DQUOTE] = ACTIONS(3015),
    [anon_sym_AT_DQUOTE] = ACTIONS(3017),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3017),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3017),
    [sym_bool] = ACTIONS(3015),
    [sym_unit] = ACTIONS(3017),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3015),
    [sym_op_identifier] = ACTIONS(3015),
    [anon_sym_PLUS] = ACTIONS(3015),
    [anon_sym_DASH] = ACTIONS(3015),
    [anon_sym_PLUS_DOT] = ACTIONS(3015),
    [anon_sym_DASH_DOT] = ACTIONS(3015),
    [anon_sym_PERCENT] = ACTIONS(3015),
    [anon_sym_AMP_AMP] = ACTIONS(3015),
    [anon_sym_TILDE] = ACTIONS(3017),
    [aux_sym_prefix_op_token1] = ACTIONS(3015),
    [aux_sym_infix_op_token1] = ACTIONS(3017),
    [aux_sym_infix_op_token2] = ACTIONS(3015),
    [anon_sym_PIPE_PIPE] = ACTIONS(3015),
    [anon_sym_BANG_EQ] = ACTIONS(3015),
    [anon_sym_COLON_EQ] = ACTIONS(3017),
    [anon_sym_DOLLAR] = ACTIONS(3015),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3015),
    [sym_int] = ACTIONS(3015),
    [sym_xint] = ACTIONS(3017),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3017),
    [anon_sym_POUNDendif] = ACTIONS(3017),
    [sym__newline] = ACTIONS(3017),
  },
  [2104] = {
    [sym_block_comment] = STATE(2104),
    [sym_compiler_directive_decl] = STATE(2104),
    [sym_fsi_directive_decl] = STATE(2104),
    [sym_preproc_line] = STATE(2104),
    [sym_identifier] = ACTIONS(3023),
    [anon_sym_EQ] = ACTIONS(3025),
    [anon_sym_COLON] = ACTIONS(3023),
    [anon_sym_return] = ACTIONS(3023),
    [anon_sym_do] = ACTIONS(3023),
    [anon_sym_let] = ACTIONS(3023),
    [anon_sym_let_BANG] = ACTIONS(3025),
    [anon_sym_LPAREN] = ACTIONS(3023),
    [anon_sym_COMMA] = ACTIONS(3025),
    [anon_sym_null] = ACTIONS(3023),
    [anon_sym_QMARK] = ACTIONS(3023),
    [anon_sym_COLON_QMARK] = ACTIONS(3023),
    [anon_sym_COLON_COLON] = ACTIONS(3025),
    [anon_sym_AMP] = ACTIONS(3023),
    [anon_sym_LBRACK] = ACTIONS(3023),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3025),
    [anon_sym_LBRACE] = ACTIONS(3023),
    [anon_sym_LT_AT] = ACTIONS(3023),
    [anon_sym_LT_AT_AT] = ACTIONS(3023),
    [anon_sym_DOT] = ACTIONS(3023),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3025),
    [anon_sym_new] = ACTIONS(3023),
    [anon_sym_return_BANG] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(3023),
    [anon_sym_yield_BANG] = ACTIONS(3025),
    [anon_sym_lazy] = ACTIONS(3023),
    [anon_sym_assert] = ACTIONS(3023),
    [anon_sym_upcast] = ACTIONS(3023),
    [anon_sym_downcast] = ACTIONS(3023),
    [anon_sym_COLON_GT] = ACTIONS(3025),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3025),
    [anon_sym_for] = ACTIONS(3023),
    [anon_sym_while] = ACTIONS(3023),
    [anon_sym_if] = ACTIONS(3023),
    [anon_sym_fun] = ACTIONS(3023),
    [anon_sym_try] = ACTIONS(3023),
    [anon_sym_match] = ACTIONS(3023),
    [anon_sym_match_BANG] = ACTIONS(3025),
    [anon_sym_function] = ACTIONS(3023),
    [anon_sym_LT_DASH] = ACTIONS(3023),
    [anon_sym_DOT_LBRACK] = ACTIONS(3025),
    [anon_sym_LT] = ACTIONS(3025),
    [anon_sym_GT] = ACTIONS(3023),
    [anon_sym_use] = ACTIONS(3023),
    [anon_sym_use_BANG] = ACTIONS(3025),
    [anon_sym_do_BANG] = ACTIONS(3025),
    [anon_sym_begin] = ACTIONS(3023),
    [anon_sym_LPAREN2] = ACTIONS(3023),
    [anon_sym_or] = ACTIONS(3023),
    [aux_sym_char_token1] = ACTIONS(3025),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3023),
    [anon_sym_DQUOTE] = ACTIONS(3023),
    [anon_sym_AT_DQUOTE] = ACTIONS(3025),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3025),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3025),
    [sym_bool] = ACTIONS(3023),
    [sym_unit] = ACTIONS(3025),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3023),
    [sym_op_identifier] = ACTIONS(3023),
    [anon_sym_PLUS] = ACTIONS(3023),
    [anon_sym_DASH] = ACTIONS(3023),
    [anon_sym_PLUS_DOT] = ACTIONS(3023),
    [anon_sym_DASH_DOT] = ACTIONS(3023),
    [anon_sym_PERCENT] = ACTIONS(3023),
    [anon_sym_AMP_AMP] = ACTIONS(3023),
    [anon_sym_TILDE] = ACTIONS(3025),
    [aux_sym_prefix_op_token1] = ACTIONS(3023),
    [aux_sym_infix_op_token1] = ACTIONS(3025),
    [aux_sym_infix_op_token2] = ACTIONS(3023),
    [anon_sym_PIPE_PIPE] = ACTIONS(3023),
    [anon_sym_BANG_EQ] = ACTIONS(3023),
    [anon_sym_COLON_EQ] = ACTIONS(3025),
    [anon_sym_DOLLAR] = ACTIONS(3023),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3023),
    [sym_int] = ACTIONS(3023),
    [sym_xint] = ACTIONS(3025),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3025),
    [sym__newline] = ACTIONS(3025),
  },
  [2105] = {
    [sym_attributes] = STATE(2632),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(4815),
    [sym__pattern] = STATE(5435),
    [sym_optional_pattern] = STATE(4815),
    [sym_type_check_pattern] = STATE(4815),
    [sym_attribute_pattern] = STATE(4815),
    [sym_paren_pattern] = STATE(4815),
    [sym_as_pattern] = STATE(4815),
    [sym_cons_pattern] = STATE(4815),
    [sym_disjunct_pattern] = STATE(4815),
    [sym_conjunct_pattern] = STATE(4815),
    [sym_typed_pattern] = STATE(4815),
    [sym_list_pattern] = STATE(4815),
    [sym_array_pattern] = STATE(4815),
    [sym_record_pattern] = STATE(4815),
    [sym_named_field_pattern] = STATE(4815),
    [sym_identifier_pattern] = STATE(4815),
    [sym_long_identifier_or_op] = STATE(2475),
    [sym_char] = STATE(4765),
    [sym_format_string] = STATE(4746),
    [sym__string_literal] = STATE(4746),
    [sym_string] = STATE(4765),
    [sym_verbatim_string] = STATE(4765),
    [sym_bytearray] = STATE(4765),
    [sym_verbatim_bytearray] = STATE(4765),
    [sym_format_triple_quoted_string] = STATE(4720),
    [sym_triple_quoted_string] = STATE(4765),
    [sym_const] = STATE(4815),
    [sym_long_identifier] = STATE(3655),
    [sym_active_pattern] = STATE(3734),
    [sym__identifier_or_op] = STATE(3737),
    [sym_sbyte] = STATE(4765),
    [sym_byte] = STATE(4765),
    [sym_int16] = STATE(4765),
    [sym_uint16] = STATE(4765),
    [sym_int32] = STATE(4765),
    [sym_uint32] = STATE(4765),
    [sym_nativeint] = STATE(4765),
    [sym_unativeint] = STATE(4765),
    [sym_int64] = STATE(4765),
    [sym_uint64] = STATE(4765),
    [sym_ieee32] = STATE(4765),
    [sym_ieee64] = STATE(4765),
    [sym_bignum] = STATE(4765),
    [sym_decimal] = STATE(4765),
    [sym_float] = STATE(4512),
    [sym_block_comment] = STATE(2105),
    [sym_compiler_directive_decl] = STATE(2105),
    [sym_fsi_directive_decl] = STATE(2105),
    [sym_preproc_line] = STATE(2105),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [aux_sym_repeat_pattern_repeat1] = STATE(3687),
    [sym_identifier] = ACTIONS(4196),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_COLON] = ACTIONS(3716),
    [anon_sym_as] = ACTIONS(4198),
    [anon_sym_LPAREN] = ACTIONS(3572),
    [anon_sym_COMMA] = ACTIONS(4200),
    [anon_sym_null] = ACTIONS(3574),
    [anon_sym__] = ACTIONS(3576),
    [anon_sym_QMARK] = ACTIONS(4202),
    [anon_sym_COLON_QMARK] = ACTIONS(4204),
    [anon_sym_COLON_COLON] = ACTIONS(4206),
    [anon_sym_PIPE] = ACTIONS(4208),
    [anon_sym_AMP] = ACTIONS(4210),
    [anon_sym_LBRACK] = ACTIONS(3582),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3584),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [anon_sym_in] = ACTIONS(3716),
    [aux_sym_char_token1] = ACTIONS(3590),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3592),
    [anon_sym_DQUOTE] = ACTIONS(3594),
    [anon_sym_AT_DQUOTE] = ACTIONS(3596),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3598),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3600),
    [sym_bool] = ACTIONS(3602),
    [sym_unit] = ACTIONS(3604),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4212),
    [sym_op_identifier] = ACTIONS(4214),
    [sym_int] = ACTIONS(3610),
    [sym_xint] = ACTIONS(3612),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2106] = {
    [sym_block_comment] = STATE(2106),
    [sym_compiler_directive_decl] = STATE(2106),
    [sym_fsi_directive_decl] = STATE(2106),
    [sym_preproc_line] = STATE(2106),
    [sym_identifier] = ACTIONS(2855),
    [anon_sym_EQ] = ACTIONS(2857),
    [anon_sym_COLON] = ACTIONS(2855),
    [anon_sym_return] = ACTIONS(2855),
    [anon_sym_do] = ACTIONS(2855),
    [anon_sym_let] = ACTIONS(2855),
    [anon_sym_let_BANG] = ACTIONS(2857),
    [anon_sym_LPAREN] = ACTIONS(2855),
    [anon_sym_COMMA] = ACTIONS(2857),
    [anon_sym_null] = ACTIONS(2855),
    [anon_sym_QMARK] = ACTIONS(2855),
    [anon_sym_COLON_QMARK] = ACTIONS(2855),
    [anon_sym_COLON_COLON] = ACTIONS(2857),
    [anon_sym_AMP] = ACTIONS(2855),
    [anon_sym_LBRACK] = ACTIONS(2855),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2857),
    [anon_sym_LBRACE] = ACTIONS(2855),
    [anon_sym_LT_AT] = ACTIONS(2855),
    [anon_sym_LT_AT_AT] = ACTIONS(2855),
    [anon_sym_DOT] = ACTIONS(2855),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2857),
    [anon_sym_new] = ACTIONS(2855),
    [anon_sym_return_BANG] = ACTIONS(2857),
    [anon_sym_yield] = ACTIONS(2855),
    [anon_sym_yield_BANG] = ACTIONS(2857),
    [anon_sym_lazy] = ACTIONS(2855),
    [anon_sym_assert] = ACTIONS(2855),
    [anon_sym_upcast] = ACTIONS(2855),
    [anon_sym_downcast] = ACTIONS(2855),
    [anon_sym_COLON_GT] = ACTIONS(2857),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2857),
    [anon_sym_for] = ACTIONS(2855),
    [anon_sym_while] = ACTIONS(2855),
    [anon_sym_if] = ACTIONS(2855),
    [anon_sym_fun] = ACTIONS(2855),
    [anon_sym_try] = ACTIONS(2855),
    [anon_sym_match] = ACTIONS(2855),
    [anon_sym_match_BANG] = ACTIONS(2857),
    [anon_sym_function] = ACTIONS(2855),
    [anon_sym_LT_DASH] = ACTIONS(2855),
    [anon_sym_DOT_LBRACK] = ACTIONS(2857),
    [anon_sym_LT] = ACTIONS(2857),
    [anon_sym_use] = ACTIONS(2855),
    [anon_sym_use_BANG] = ACTIONS(2857),
    [anon_sym_do_BANG] = ACTIONS(2857),
    [anon_sym_DOT_DOT] = ACTIONS(2857),
    [anon_sym_begin] = ACTIONS(2855),
    [anon_sym_LPAREN2] = ACTIONS(2855),
    [anon_sym_or] = ACTIONS(2855),
    [aux_sym_char_token1] = ACTIONS(2857),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2855),
    [anon_sym_DQUOTE] = ACTIONS(2855),
    [anon_sym_AT_DQUOTE] = ACTIONS(2857),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2857),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2857),
    [sym_bool] = ACTIONS(2855),
    [sym_unit] = ACTIONS(2857),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2855),
    [sym_op_identifier] = ACTIONS(2855),
    [anon_sym_PLUS] = ACTIONS(2855),
    [anon_sym_DASH] = ACTIONS(2855),
    [anon_sym_PLUS_DOT] = ACTIONS(2855),
    [anon_sym_DASH_DOT] = ACTIONS(2855),
    [anon_sym_PERCENT] = ACTIONS(2855),
    [anon_sym_AMP_AMP] = ACTIONS(2855),
    [anon_sym_TILDE] = ACTIONS(2857),
    [aux_sym_prefix_op_token1] = ACTIONS(2855),
    [aux_sym_infix_op_token1] = ACTIONS(2857),
    [aux_sym_infix_op_token2] = ACTIONS(2855),
    [anon_sym_PIPE_PIPE] = ACTIONS(2855),
    [anon_sym_BANG_EQ] = ACTIONS(2855),
    [anon_sym_COLON_EQ] = ACTIONS(2857),
    [anon_sym_DOLLAR] = ACTIONS(2855),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2855),
    [sym_int] = ACTIONS(2855),
    [sym_xint] = ACTIONS(2857),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2857),
    [sym__newline] = ACTIONS(2857),
  },
  [2107] = {
    [sym_block_comment] = STATE(2107),
    [sym_compiler_directive_decl] = STATE(2107),
    [sym_fsi_directive_decl] = STATE(2107),
    [sym_preproc_line] = STATE(2107),
    [sym_identifier] = ACTIONS(2859),
    [anon_sym_EQ] = ACTIONS(2861),
    [anon_sym_COLON] = ACTIONS(2859),
    [anon_sym_return] = ACTIONS(2859),
    [anon_sym_do] = ACTIONS(2859),
    [anon_sym_let] = ACTIONS(2859),
    [anon_sym_let_BANG] = ACTIONS(2861),
    [anon_sym_LPAREN] = ACTIONS(2859),
    [anon_sym_COMMA] = ACTIONS(2861),
    [anon_sym_null] = ACTIONS(2859),
    [anon_sym_QMARK] = ACTIONS(2859),
    [anon_sym_COLON_QMARK] = ACTIONS(2859),
    [anon_sym_COLON_COLON] = ACTIONS(2861),
    [anon_sym_AMP] = ACTIONS(2859),
    [anon_sym_LBRACK] = ACTIONS(2859),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2861),
    [anon_sym_LBRACE] = ACTIONS(2859),
    [anon_sym_LT_AT] = ACTIONS(2859),
    [anon_sym_LT_AT_AT] = ACTIONS(2859),
    [anon_sym_DOT] = ACTIONS(2859),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2861),
    [anon_sym_new] = ACTIONS(2859),
    [anon_sym_return_BANG] = ACTIONS(2861),
    [anon_sym_yield] = ACTIONS(2859),
    [anon_sym_yield_BANG] = ACTIONS(2861),
    [anon_sym_lazy] = ACTIONS(2859),
    [anon_sym_assert] = ACTIONS(2859),
    [anon_sym_upcast] = ACTIONS(2859),
    [anon_sym_downcast] = ACTIONS(2859),
    [anon_sym_COLON_GT] = ACTIONS(2861),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2861),
    [anon_sym_for] = ACTIONS(2859),
    [anon_sym_while] = ACTIONS(2859),
    [anon_sym_if] = ACTIONS(2859),
    [anon_sym_fun] = ACTIONS(2859),
    [anon_sym_try] = ACTIONS(2859),
    [anon_sym_match] = ACTIONS(2859),
    [anon_sym_match_BANG] = ACTIONS(2861),
    [anon_sym_function] = ACTIONS(2859),
    [anon_sym_LT_DASH] = ACTIONS(2859),
    [anon_sym_DOT_LBRACK] = ACTIONS(2861),
    [anon_sym_LT] = ACTIONS(2861),
    [anon_sym_use] = ACTIONS(2859),
    [anon_sym_use_BANG] = ACTIONS(2861),
    [anon_sym_do_BANG] = ACTIONS(2861),
    [anon_sym_DOT_DOT] = ACTIONS(2861),
    [anon_sym_begin] = ACTIONS(2859),
    [anon_sym_LPAREN2] = ACTIONS(2859),
    [anon_sym_or] = ACTIONS(2859),
    [aux_sym_char_token1] = ACTIONS(2861),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2859),
    [anon_sym_DQUOTE] = ACTIONS(2859),
    [anon_sym_AT_DQUOTE] = ACTIONS(2861),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2861),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2861),
    [sym_bool] = ACTIONS(2859),
    [sym_unit] = ACTIONS(2861),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2859),
    [sym_op_identifier] = ACTIONS(2859),
    [anon_sym_PLUS] = ACTIONS(2859),
    [anon_sym_DASH] = ACTIONS(2859),
    [anon_sym_PLUS_DOT] = ACTIONS(2859),
    [anon_sym_DASH_DOT] = ACTIONS(2859),
    [anon_sym_PERCENT] = ACTIONS(2859),
    [anon_sym_AMP_AMP] = ACTIONS(2859),
    [anon_sym_TILDE] = ACTIONS(2861),
    [aux_sym_prefix_op_token1] = ACTIONS(2859),
    [aux_sym_infix_op_token1] = ACTIONS(2861),
    [aux_sym_infix_op_token2] = ACTIONS(2859),
    [anon_sym_PIPE_PIPE] = ACTIONS(2859),
    [anon_sym_BANG_EQ] = ACTIONS(2859),
    [anon_sym_COLON_EQ] = ACTIONS(2861),
    [anon_sym_DOLLAR] = ACTIONS(2859),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2859),
    [sym_int] = ACTIONS(2859),
    [sym_xint] = ACTIONS(2861),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2861),
    [sym__newline] = ACTIONS(2861),
  },
  [2108] = {
    [sym_block_comment] = STATE(2108),
    [sym_compiler_directive_decl] = STATE(2108),
    [sym_fsi_directive_decl] = STATE(2108),
    [sym_preproc_line] = STATE(2108),
    [sym_identifier] = ACTIONS(3019),
    [anon_sym_EQ] = ACTIONS(3021),
    [anon_sym_COLON] = ACTIONS(3019),
    [anon_sym_return] = ACTIONS(3019),
    [anon_sym_do] = ACTIONS(3019),
    [anon_sym_let] = ACTIONS(3019),
    [anon_sym_let_BANG] = ACTIONS(3021),
    [anon_sym_LPAREN] = ACTIONS(3019),
    [anon_sym_COMMA] = ACTIONS(3021),
    [anon_sym_null] = ACTIONS(3019),
    [anon_sym_QMARK] = ACTIONS(3019),
    [anon_sym_COLON_QMARK] = ACTIONS(3019),
    [anon_sym_COLON_COLON] = ACTIONS(3021),
    [anon_sym_AMP] = ACTIONS(3019),
    [anon_sym_LBRACK] = ACTIONS(3019),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3021),
    [anon_sym_LBRACE] = ACTIONS(3019),
    [anon_sym_LT_AT] = ACTIONS(3019),
    [anon_sym_LT_AT_AT] = ACTIONS(3019),
    [anon_sym_DOT] = ACTIONS(3019),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3021),
    [anon_sym_new] = ACTIONS(3019),
    [anon_sym_return_BANG] = ACTIONS(3021),
    [anon_sym_yield] = ACTIONS(3019),
    [anon_sym_yield_BANG] = ACTIONS(3021),
    [anon_sym_lazy] = ACTIONS(3019),
    [anon_sym_assert] = ACTIONS(3019),
    [anon_sym_upcast] = ACTIONS(3019),
    [anon_sym_downcast] = ACTIONS(3019),
    [anon_sym_COLON_GT] = ACTIONS(3021),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3021),
    [anon_sym_for] = ACTIONS(3019),
    [anon_sym_while] = ACTIONS(3019),
    [anon_sym_if] = ACTIONS(3019),
    [anon_sym_fun] = ACTIONS(3019),
    [anon_sym_try] = ACTIONS(3019),
    [anon_sym_match] = ACTIONS(3019),
    [anon_sym_match_BANG] = ACTIONS(3021),
    [anon_sym_function] = ACTIONS(3019),
    [anon_sym_LT_DASH] = ACTIONS(3019),
    [anon_sym_DOT_LBRACK] = ACTIONS(3021),
    [anon_sym_LT] = ACTIONS(3021),
    [anon_sym_GT] = ACTIONS(3019),
    [anon_sym_use] = ACTIONS(3019),
    [anon_sym_use_BANG] = ACTIONS(3021),
    [anon_sym_do_BANG] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3019),
    [anon_sym_LPAREN2] = ACTIONS(3019),
    [anon_sym_or] = ACTIONS(3019),
    [aux_sym_char_token1] = ACTIONS(3021),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3019),
    [anon_sym_DQUOTE] = ACTIONS(3019),
    [anon_sym_AT_DQUOTE] = ACTIONS(3021),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3021),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3021),
    [sym_bool] = ACTIONS(3019),
    [sym_unit] = ACTIONS(3021),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3019),
    [sym_op_identifier] = ACTIONS(3019),
    [anon_sym_PLUS] = ACTIONS(3019),
    [anon_sym_DASH] = ACTIONS(3019),
    [anon_sym_PLUS_DOT] = ACTIONS(3019),
    [anon_sym_DASH_DOT] = ACTIONS(3019),
    [anon_sym_PERCENT] = ACTIONS(3019),
    [anon_sym_AMP_AMP] = ACTIONS(3019),
    [anon_sym_TILDE] = ACTIONS(3021),
    [aux_sym_prefix_op_token1] = ACTIONS(3019),
    [aux_sym_infix_op_token1] = ACTIONS(3021),
    [aux_sym_infix_op_token2] = ACTIONS(3019),
    [anon_sym_PIPE_PIPE] = ACTIONS(3019),
    [anon_sym_BANG_EQ] = ACTIONS(3019),
    [anon_sym_COLON_EQ] = ACTIONS(3021),
    [anon_sym_DOLLAR] = ACTIONS(3019),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3019),
    [sym_int] = ACTIONS(3019),
    [sym_xint] = ACTIONS(3021),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3021),
    [sym__newline] = ACTIONS(3021),
  },
  [2109] = {
    [sym_block_comment] = STATE(2109),
    [sym_compiler_directive_decl] = STATE(2109),
    [sym_fsi_directive_decl] = STATE(2109),
    [sym_preproc_line] = STATE(2109),
    [sym_identifier] = ACTIONS(3051),
    [anon_sym_EQ] = ACTIONS(3053),
    [anon_sym_COLON] = ACTIONS(3051),
    [anon_sym_return] = ACTIONS(3051),
    [anon_sym_do] = ACTIONS(3051),
    [anon_sym_let] = ACTIONS(3051),
    [anon_sym_let_BANG] = ACTIONS(3053),
    [anon_sym_LPAREN] = ACTIONS(3051),
    [anon_sym_COMMA] = ACTIONS(3053),
    [anon_sym_null] = ACTIONS(3051),
    [anon_sym_QMARK] = ACTIONS(3051),
    [anon_sym_COLON_QMARK] = ACTIONS(3051),
    [anon_sym_COLON_COLON] = ACTIONS(3053),
    [anon_sym_AMP] = ACTIONS(3051),
    [anon_sym_LBRACK] = ACTIONS(3051),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3053),
    [anon_sym_LBRACE] = ACTIONS(3051),
    [anon_sym_LT_AT] = ACTIONS(3051),
    [anon_sym_LT_AT_AT] = ACTIONS(3051),
    [anon_sym_DOT] = ACTIONS(3051),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3053),
    [anon_sym_new] = ACTIONS(3051),
    [anon_sym_return_BANG] = ACTIONS(3053),
    [anon_sym_yield] = ACTIONS(3051),
    [anon_sym_yield_BANG] = ACTIONS(3053),
    [anon_sym_lazy] = ACTIONS(3051),
    [anon_sym_assert] = ACTIONS(3051),
    [anon_sym_upcast] = ACTIONS(3051),
    [anon_sym_downcast] = ACTIONS(3051),
    [anon_sym_COLON_GT] = ACTIONS(3053),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3053),
    [anon_sym_for] = ACTIONS(3051),
    [anon_sym_while] = ACTIONS(3051),
    [anon_sym_if] = ACTIONS(3051),
    [anon_sym_fun] = ACTIONS(3051),
    [anon_sym_try] = ACTIONS(3051),
    [anon_sym_match] = ACTIONS(3051),
    [anon_sym_match_BANG] = ACTIONS(3053),
    [anon_sym_function] = ACTIONS(3051),
    [anon_sym_LT_DASH] = ACTIONS(3051),
    [anon_sym_DOT_LBRACK] = ACTIONS(3053),
    [anon_sym_LT] = ACTIONS(3053),
    [anon_sym_GT] = ACTIONS(3051),
    [anon_sym_use] = ACTIONS(3051),
    [anon_sym_use_BANG] = ACTIONS(3053),
    [anon_sym_do_BANG] = ACTIONS(3053),
    [anon_sym_begin] = ACTIONS(3051),
    [anon_sym_LPAREN2] = ACTIONS(3051),
    [anon_sym_or] = ACTIONS(3051),
    [aux_sym_char_token1] = ACTIONS(3053),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3051),
    [anon_sym_DQUOTE] = ACTIONS(3051),
    [anon_sym_AT_DQUOTE] = ACTIONS(3053),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3053),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3053),
    [sym_bool] = ACTIONS(3051),
    [sym_unit] = ACTIONS(3053),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3051),
    [sym_op_identifier] = ACTIONS(3051),
    [anon_sym_PLUS] = ACTIONS(3051),
    [anon_sym_DASH] = ACTIONS(3051),
    [anon_sym_PLUS_DOT] = ACTIONS(3051),
    [anon_sym_DASH_DOT] = ACTIONS(3051),
    [anon_sym_PERCENT] = ACTIONS(3051),
    [anon_sym_AMP_AMP] = ACTIONS(3051),
    [anon_sym_TILDE] = ACTIONS(3053),
    [aux_sym_prefix_op_token1] = ACTIONS(3051),
    [aux_sym_infix_op_token1] = ACTIONS(3053),
    [aux_sym_infix_op_token2] = ACTIONS(3051),
    [anon_sym_PIPE_PIPE] = ACTIONS(3051),
    [anon_sym_BANG_EQ] = ACTIONS(3051),
    [anon_sym_COLON_EQ] = ACTIONS(3053),
    [anon_sym_DOLLAR] = ACTIONS(3051),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3051),
    [sym_int] = ACTIONS(3051),
    [sym_xint] = ACTIONS(3053),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3053),
    [sym__newline] = ACTIONS(3053),
  },
  [2110] = {
    [sym_block_comment] = STATE(2110),
    [sym_compiler_directive_decl] = STATE(2110),
    [sym_fsi_directive_decl] = STATE(2110),
    [sym_preproc_line] = STATE(2110),
    [sym_identifier] = ACTIONS(3059),
    [anon_sym_EQ] = ACTIONS(3061),
    [anon_sym_COLON] = ACTIONS(3059),
    [anon_sym_return] = ACTIONS(3059),
    [anon_sym_do] = ACTIONS(3059),
    [anon_sym_let] = ACTIONS(3059),
    [anon_sym_let_BANG] = ACTIONS(3061),
    [anon_sym_LPAREN] = ACTIONS(3059),
    [anon_sym_COMMA] = ACTIONS(3061),
    [anon_sym_null] = ACTIONS(3059),
    [anon_sym_QMARK] = ACTIONS(3059),
    [anon_sym_COLON_QMARK] = ACTIONS(3059),
    [anon_sym_COLON_COLON] = ACTIONS(3061),
    [anon_sym_AMP] = ACTIONS(3059),
    [anon_sym_LBRACK] = ACTIONS(3059),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3061),
    [anon_sym_LBRACE] = ACTIONS(3059),
    [anon_sym_LT_AT] = ACTIONS(3059),
    [anon_sym_LT_AT_AT] = ACTIONS(3059),
    [anon_sym_DOT] = ACTIONS(3059),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3061),
    [anon_sym_new] = ACTIONS(3059),
    [anon_sym_return_BANG] = ACTIONS(3061),
    [anon_sym_yield] = ACTIONS(3059),
    [anon_sym_yield_BANG] = ACTIONS(3061),
    [anon_sym_lazy] = ACTIONS(3059),
    [anon_sym_assert] = ACTIONS(3059),
    [anon_sym_upcast] = ACTIONS(3059),
    [anon_sym_downcast] = ACTIONS(3059),
    [anon_sym_COLON_GT] = ACTIONS(3061),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3061),
    [anon_sym_for] = ACTIONS(3059),
    [anon_sym_while] = ACTIONS(3059),
    [anon_sym_if] = ACTIONS(3059),
    [anon_sym_fun] = ACTIONS(3059),
    [anon_sym_try] = ACTIONS(3059),
    [anon_sym_match] = ACTIONS(3059),
    [anon_sym_match_BANG] = ACTIONS(3061),
    [anon_sym_function] = ACTIONS(3059),
    [anon_sym_LT_DASH] = ACTIONS(3059),
    [anon_sym_DOT_LBRACK] = ACTIONS(3061),
    [anon_sym_LT] = ACTIONS(3061),
    [anon_sym_GT] = ACTIONS(3059),
    [anon_sym_use] = ACTIONS(3059),
    [anon_sym_use_BANG] = ACTIONS(3061),
    [anon_sym_do_BANG] = ACTIONS(3061),
    [anon_sym_begin] = ACTIONS(3059),
    [anon_sym_LPAREN2] = ACTIONS(3059),
    [anon_sym_or] = ACTIONS(3059),
    [aux_sym_char_token1] = ACTIONS(3061),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3059),
    [anon_sym_DQUOTE] = ACTIONS(3059),
    [anon_sym_AT_DQUOTE] = ACTIONS(3061),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3061),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3061),
    [sym_bool] = ACTIONS(3059),
    [sym_unit] = ACTIONS(3061),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3059),
    [sym_op_identifier] = ACTIONS(3059),
    [anon_sym_PLUS] = ACTIONS(3059),
    [anon_sym_DASH] = ACTIONS(3059),
    [anon_sym_PLUS_DOT] = ACTIONS(3059),
    [anon_sym_DASH_DOT] = ACTIONS(3059),
    [anon_sym_PERCENT] = ACTIONS(3059),
    [anon_sym_AMP_AMP] = ACTIONS(3059),
    [anon_sym_TILDE] = ACTIONS(3061),
    [aux_sym_prefix_op_token1] = ACTIONS(3059),
    [aux_sym_infix_op_token1] = ACTIONS(3061),
    [aux_sym_infix_op_token2] = ACTIONS(3059),
    [anon_sym_PIPE_PIPE] = ACTIONS(3059),
    [anon_sym_BANG_EQ] = ACTIONS(3059),
    [anon_sym_COLON_EQ] = ACTIONS(3061),
    [anon_sym_DOLLAR] = ACTIONS(3059),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3059),
    [sym_int] = ACTIONS(3059),
    [sym_xint] = ACTIONS(3061),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3061),
    [sym__newline] = ACTIONS(3061),
  },
  [2111] = {
    [sym_block_comment] = STATE(2111),
    [sym_compiler_directive_decl] = STATE(2111),
    [sym_fsi_directive_decl] = STATE(2111),
    [sym_preproc_line] = STATE(2111),
    [sym_identifier] = ACTIONS(3063),
    [anon_sym_EQ] = ACTIONS(3065),
    [anon_sym_COLON] = ACTIONS(3063),
    [anon_sym_return] = ACTIONS(3063),
    [anon_sym_do] = ACTIONS(3063),
    [anon_sym_let] = ACTIONS(3063),
    [anon_sym_let_BANG] = ACTIONS(3065),
    [anon_sym_LPAREN] = ACTIONS(3063),
    [anon_sym_COMMA] = ACTIONS(3065),
    [anon_sym_null] = ACTIONS(3063),
    [anon_sym_QMARK] = ACTIONS(3063),
    [anon_sym_COLON_QMARK] = ACTIONS(3063),
    [anon_sym_COLON_COLON] = ACTIONS(3065),
    [anon_sym_AMP] = ACTIONS(3063),
    [anon_sym_LBRACK] = ACTIONS(3063),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3065),
    [anon_sym_LBRACE] = ACTIONS(3063),
    [anon_sym_LT_AT] = ACTIONS(3063),
    [anon_sym_LT_AT_AT] = ACTIONS(3063),
    [anon_sym_DOT] = ACTIONS(3063),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3065),
    [anon_sym_new] = ACTIONS(3063),
    [anon_sym_return_BANG] = ACTIONS(3065),
    [anon_sym_yield] = ACTIONS(3063),
    [anon_sym_yield_BANG] = ACTIONS(3065),
    [anon_sym_lazy] = ACTIONS(3063),
    [anon_sym_assert] = ACTIONS(3063),
    [anon_sym_upcast] = ACTIONS(3063),
    [anon_sym_downcast] = ACTIONS(3063),
    [anon_sym_COLON_GT] = ACTIONS(3065),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3065),
    [anon_sym_for] = ACTIONS(3063),
    [anon_sym_while] = ACTIONS(3063),
    [anon_sym_if] = ACTIONS(3063),
    [anon_sym_fun] = ACTIONS(3063),
    [anon_sym_try] = ACTIONS(3063),
    [anon_sym_match] = ACTIONS(3063),
    [anon_sym_match_BANG] = ACTIONS(3065),
    [anon_sym_function] = ACTIONS(3063),
    [anon_sym_LT_DASH] = ACTIONS(3063),
    [anon_sym_DOT_LBRACK] = ACTIONS(3065),
    [anon_sym_LT] = ACTIONS(3065),
    [anon_sym_GT] = ACTIONS(3063),
    [anon_sym_use] = ACTIONS(3063),
    [anon_sym_use_BANG] = ACTIONS(3065),
    [anon_sym_do_BANG] = ACTIONS(3065),
    [anon_sym_begin] = ACTIONS(3063),
    [anon_sym_LPAREN2] = ACTIONS(3063),
    [anon_sym_or] = ACTIONS(3063),
    [aux_sym_char_token1] = ACTIONS(3065),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3063),
    [anon_sym_DQUOTE] = ACTIONS(3063),
    [anon_sym_AT_DQUOTE] = ACTIONS(3065),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3065),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3065),
    [sym_bool] = ACTIONS(3063),
    [sym_unit] = ACTIONS(3065),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3063),
    [sym_op_identifier] = ACTIONS(3063),
    [anon_sym_PLUS] = ACTIONS(3063),
    [anon_sym_DASH] = ACTIONS(3063),
    [anon_sym_PLUS_DOT] = ACTIONS(3063),
    [anon_sym_DASH_DOT] = ACTIONS(3063),
    [anon_sym_PERCENT] = ACTIONS(3063),
    [anon_sym_AMP_AMP] = ACTIONS(3063),
    [anon_sym_TILDE] = ACTIONS(3065),
    [aux_sym_prefix_op_token1] = ACTIONS(3063),
    [aux_sym_infix_op_token1] = ACTIONS(3065),
    [aux_sym_infix_op_token2] = ACTIONS(3063),
    [anon_sym_PIPE_PIPE] = ACTIONS(3063),
    [anon_sym_BANG_EQ] = ACTIONS(3063),
    [anon_sym_COLON_EQ] = ACTIONS(3065),
    [anon_sym_DOLLAR] = ACTIONS(3063),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3063),
    [sym_int] = ACTIONS(3063),
    [sym_xint] = ACTIONS(3065),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3065),
    [sym__newline] = ACTIONS(3065),
  },
  [2112] = {
    [sym_block_comment] = STATE(2112),
    [sym_compiler_directive_decl] = STATE(2112),
    [sym_fsi_directive_decl] = STATE(2112),
    [sym_preproc_line] = STATE(2112),
    [sym_identifier] = ACTIONS(2974),
    [anon_sym_EQ] = ACTIONS(2976),
    [anon_sym_COLON] = ACTIONS(2974),
    [anon_sym_return] = ACTIONS(2974),
    [anon_sym_do] = ACTIONS(2974),
    [anon_sym_let] = ACTIONS(2974),
    [anon_sym_let_BANG] = ACTIONS(2976),
    [anon_sym_LPAREN] = ACTIONS(2974),
    [anon_sym_COMMA] = ACTIONS(2976),
    [anon_sym_null] = ACTIONS(2974),
    [anon_sym_QMARK] = ACTIONS(2974),
    [anon_sym_COLON_QMARK] = ACTIONS(2974),
    [anon_sym_COLON_COLON] = ACTIONS(2976),
    [anon_sym_AMP] = ACTIONS(2974),
    [anon_sym_LBRACK] = ACTIONS(2974),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2976),
    [anon_sym_LBRACE] = ACTIONS(2974),
    [anon_sym_LT_AT] = ACTIONS(2974),
    [anon_sym_LT_AT_AT] = ACTIONS(2974),
    [anon_sym_DOT] = ACTIONS(2974),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2976),
    [anon_sym_new] = ACTIONS(2974),
    [anon_sym_return_BANG] = ACTIONS(2976),
    [anon_sym_yield] = ACTIONS(2974),
    [anon_sym_yield_BANG] = ACTIONS(2976),
    [anon_sym_lazy] = ACTIONS(2974),
    [anon_sym_assert] = ACTIONS(2974),
    [anon_sym_upcast] = ACTIONS(2974),
    [anon_sym_downcast] = ACTIONS(2974),
    [anon_sym_COLON_GT] = ACTIONS(2976),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2976),
    [anon_sym_for] = ACTIONS(2974),
    [anon_sym_while] = ACTIONS(2974),
    [anon_sym_if] = ACTIONS(2974),
    [anon_sym_fun] = ACTIONS(2974),
    [anon_sym_try] = ACTIONS(2974),
    [anon_sym_match] = ACTIONS(2974),
    [anon_sym_match_BANG] = ACTIONS(2976),
    [anon_sym_function] = ACTIONS(2974),
    [anon_sym_LT_DASH] = ACTIONS(2974),
    [anon_sym_DOT_LBRACK] = ACTIONS(2976),
    [anon_sym_LT] = ACTIONS(2976),
    [anon_sym_GT] = ACTIONS(2974),
    [anon_sym_use] = ACTIONS(2974),
    [anon_sym_use_BANG] = ACTIONS(2976),
    [anon_sym_do_BANG] = ACTIONS(2976),
    [anon_sym_begin] = ACTIONS(2974),
    [anon_sym_LPAREN2] = ACTIONS(2974),
    [anon_sym_or] = ACTIONS(2974),
    [aux_sym_char_token1] = ACTIONS(2976),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2974),
    [anon_sym_DQUOTE] = ACTIONS(2974),
    [anon_sym_AT_DQUOTE] = ACTIONS(2976),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2976),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2976),
    [sym_bool] = ACTIONS(2974),
    [sym_unit] = ACTIONS(2976),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2974),
    [sym_op_identifier] = ACTIONS(2974),
    [anon_sym_PLUS] = ACTIONS(2974),
    [anon_sym_DASH] = ACTIONS(2974),
    [anon_sym_PLUS_DOT] = ACTIONS(2974),
    [anon_sym_DASH_DOT] = ACTIONS(2974),
    [anon_sym_PERCENT] = ACTIONS(2974),
    [anon_sym_AMP_AMP] = ACTIONS(2974),
    [anon_sym_TILDE] = ACTIONS(2976),
    [aux_sym_prefix_op_token1] = ACTIONS(2974),
    [aux_sym_infix_op_token1] = ACTIONS(2976),
    [aux_sym_infix_op_token2] = ACTIONS(2974),
    [anon_sym_PIPE_PIPE] = ACTIONS(2974),
    [anon_sym_BANG_EQ] = ACTIONS(2974),
    [anon_sym_COLON_EQ] = ACTIONS(2976),
    [anon_sym_DOLLAR] = ACTIONS(2974),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2974),
    [sym_int] = ACTIONS(2974),
    [sym_xint] = ACTIONS(2976),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2976),
    [sym__newline] = ACTIONS(2976),
  },
  [2113] = {
    [sym_block_comment] = STATE(2113),
    [sym_compiler_directive_decl] = STATE(2113),
    [sym_fsi_directive_decl] = STATE(2113),
    [sym_preproc_line] = STATE(2113),
    [sym_identifier] = ACTIONS(2966),
    [anon_sym_EQ] = ACTIONS(2968),
    [anon_sym_COLON] = ACTIONS(2966),
    [anon_sym_return] = ACTIONS(2966),
    [anon_sym_do] = ACTIONS(2966),
    [anon_sym_let] = ACTIONS(2966),
    [anon_sym_let_BANG] = ACTIONS(2968),
    [anon_sym_LPAREN] = ACTIONS(2966),
    [anon_sym_COMMA] = ACTIONS(2968),
    [anon_sym_null] = ACTIONS(2966),
    [anon_sym_QMARK] = ACTIONS(2966),
    [anon_sym_COLON_QMARK] = ACTIONS(2966),
    [anon_sym_COLON_COLON] = ACTIONS(2968),
    [anon_sym_AMP] = ACTIONS(2966),
    [anon_sym_LBRACK] = ACTIONS(2966),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2968),
    [anon_sym_LBRACE] = ACTIONS(2966),
    [anon_sym_LT_AT] = ACTIONS(2966),
    [anon_sym_LT_AT_AT] = ACTIONS(2966),
    [anon_sym_DOT] = ACTIONS(2966),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2968),
    [anon_sym_new] = ACTIONS(2966),
    [anon_sym_return_BANG] = ACTIONS(2968),
    [anon_sym_yield] = ACTIONS(2966),
    [anon_sym_yield_BANG] = ACTIONS(2968),
    [anon_sym_lazy] = ACTIONS(2966),
    [anon_sym_assert] = ACTIONS(2966),
    [anon_sym_upcast] = ACTIONS(2966),
    [anon_sym_downcast] = ACTIONS(2966),
    [anon_sym_COLON_GT] = ACTIONS(2968),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2968),
    [anon_sym_for] = ACTIONS(2966),
    [anon_sym_while] = ACTIONS(2966),
    [anon_sym_if] = ACTIONS(2966),
    [anon_sym_fun] = ACTIONS(2966),
    [anon_sym_try] = ACTIONS(2966),
    [anon_sym_match] = ACTIONS(2966),
    [anon_sym_match_BANG] = ACTIONS(2968),
    [anon_sym_function] = ACTIONS(2966),
    [anon_sym_LT_DASH] = ACTIONS(2966),
    [anon_sym_DOT_LBRACK] = ACTIONS(2968),
    [anon_sym_LT] = ACTIONS(2968),
    [anon_sym_GT] = ACTIONS(2966),
    [anon_sym_use] = ACTIONS(2966),
    [anon_sym_use_BANG] = ACTIONS(2968),
    [anon_sym_do_BANG] = ACTIONS(2968),
    [anon_sym_begin] = ACTIONS(2966),
    [anon_sym_LPAREN2] = ACTIONS(2966),
    [anon_sym_or] = ACTIONS(2966),
    [aux_sym_char_token1] = ACTIONS(2968),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2966),
    [anon_sym_DQUOTE] = ACTIONS(2966),
    [anon_sym_AT_DQUOTE] = ACTIONS(2968),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2968),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2968),
    [sym_bool] = ACTIONS(2966),
    [sym_unit] = ACTIONS(2968),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2966),
    [sym_op_identifier] = ACTIONS(2966),
    [anon_sym_PLUS] = ACTIONS(2966),
    [anon_sym_DASH] = ACTIONS(2966),
    [anon_sym_PLUS_DOT] = ACTIONS(2966),
    [anon_sym_DASH_DOT] = ACTIONS(2966),
    [anon_sym_PERCENT] = ACTIONS(2966),
    [anon_sym_AMP_AMP] = ACTIONS(2966),
    [anon_sym_TILDE] = ACTIONS(2968),
    [aux_sym_prefix_op_token1] = ACTIONS(2966),
    [aux_sym_infix_op_token1] = ACTIONS(2968),
    [aux_sym_infix_op_token2] = ACTIONS(2966),
    [anon_sym_PIPE_PIPE] = ACTIONS(2966),
    [anon_sym_BANG_EQ] = ACTIONS(2966),
    [anon_sym_COLON_EQ] = ACTIONS(2968),
    [anon_sym_DOLLAR] = ACTIONS(2966),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2966),
    [sym_int] = ACTIONS(2966),
    [sym_xint] = ACTIONS(2968),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2968),
    [sym__newline] = ACTIONS(2968),
  },
  [2114] = {
    [sym_block_comment] = STATE(2114),
    [sym_compiler_directive_decl] = STATE(2114),
    [sym_fsi_directive_decl] = STATE(2114),
    [sym_preproc_line] = STATE(2114),
    [sym_identifier] = ACTIONS(2962),
    [anon_sym_EQ] = ACTIONS(2964),
    [anon_sym_COLON] = ACTIONS(2962),
    [anon_sym_return] = ACTIONS(2962),
    [anon_sym_do] = ACTIONS(2962),
    [anon_sym_let] = ACTIONS(2962),
    [anon_sym_let_BANG] = ACTIONS(2964),
    [anon_sym_LPAREN] = ACTIONS(2962),
    [anon_sym_COMMA] = ACTIONS(2964),
    [anon_sym_null] = ACTIONS(2962),
    [anon_sym_QMARK] = ACTIONS(2962),
    [anon_sym_COLON_QMARK] = ACTIONS(2962),
    [anon_sym_COLON_COLON] = ACTIONS(2964),
    [anon_sym_AMP] = ACTIONS(2962),
    [anon_sym_LBRACK] = ACTIONS(2962),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2964),
    [anon_sym_LBRACE] = ACTIONS(2962),
    [anon_sym_LT_AT] = ACTIONS(2962),
    [anon_sym_LT_AT_AT] = ACTIONS(2962),
    [anon_sym_DOT] = ACTIONS(2962),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2964),
    [anon_sym_new] = ACTIONS(2962),
    [anon_sym_return_BANG] = ACTIONS(2964),
    [anon_sym_yield] = ACTIONS(2962),
    [anon_sym_yield_BANG] = ACTIONS(2964),
    [anon_sym_lazy] = ACTIONS(2962),
    [anon_sym_assert] = ACTIONS(2962),
    [anon_sym_upcast] = ACTIONS(2962),
    [anon_sym_downcast] = ACTIONS(2962),
    [anon_sym_COLON_GT] = ACTIONS(2964),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2964),
    [anon_sym_for] = ACTIONS(2962),
    [anon_sym_while] = ACTIONS(2962),
    [anon_sym_if] = ACTIONS(2962),
    [anon_sym_fun] = ACTIONS(2962),
    [anon_sym_try] = ACTIONS(2962),
    [anon_sym_match] = ACTIONS(2962),
    [anon_sym_match_BANG] = ACTIONS(2964),
    [anon_sym_function] = ACTIONS(2962),
    [anon_sym_LT_DASH] = ACTIONS(2962),
    [anon_sym_DOT_LBRACK] = ACTIONS(2964),
    [anon_sym_LT] = ACTIONS(2964),
    [anon_sym_GT] = ACTIONS(2962),
    [anon_sym_use] = ACTIONS(2962),
    [anon_sym_use_BANG] = ACTIONS(2964),
    [anon_sym_do_BANG] = ACTIONS(2964),
    [anon_sym_begin] = ACTIONS(2962),
    [anon_sym_LPAREN2] = ACTIONS(2962),
    [anon_sym_or] = ACTIONS(2962),
    [aux_sym_char_token1] = ACTIONS(2964),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2962),
    [anon_sym_DQUOTE] = ACTIONS(2962),
    [anon_sym_AT_DQUOTE] = ACTIONS(2964),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2964),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2964),
    [sym_bool] = ACTIONS(2962),
    [sym_unit] = ACTIONS(2964),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2962),
    [sym_op_identifier] = ACTIONS(2962),
    [anon_sym_PLUS] = ACTIONS(2962),
    [anon_sym_DASH] = ACTIONS(2962),
    [anon_sym_PLUS_DOT] = ACTIONS(2962),
    [anon_sym_DASH_DOT] = ACTIONS(2962),
    [anon_sym_PERCENT] = ACTIONS(2962),
    [anon_sym_AMP_AMP] = ACTIONS(2962),
    [anon_sym_TILDE] = ACTIONS(2964),
    [aux_sym_prefix_op_token1] = ACTIONS(2962),
    [aux_sym_infix_op_token1] = ACTIONS(2964),
    [aux_sym_infix_op_token2] = ACTIONS(2962),
    [anon_sym_PIPE_PIPE] = ACTIONS(2962),
    [anon_sym_BANG_EQ] = ACTIONS(2962),
    [anon_sym_COLON_EQ] = ACTIONS(2964),
    [anon_sym_DOLLAR] = ACTIONS(2962),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2962),
    [sym_int] = ACTIONS(2962),
    [sym_xint] = ACTIONS(2964),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2964),
    [sym__newline] = ACTIONS(2964),
  },
  [2115] = {
    [sym_block_comment] = STATE(2115),
    [sym_compiler_directive_decl] = STATE(2115),
    [sym_fsi_directive_decl] = STATE(2115),
    [sym_preproc_line] = STATE(2115),
    [sym_identifier] = ACTIONS(2958),
    [anon_sym_EQ] = ACTIONS(2960),
    [anon_sym_COLON] = ACTIONS(2958),
    [anon_sym_return] = ACTIONS(2958),
    [anon_sym_do] = ACTIONS(2958),
    [anon_sym_let] = ACTIONS(2958),
    [anon_sym_let_BANG] = ACTIONS(2960),
    [anon_sym_LPAREN] = ACTIONS(2958),
    [anon_sym_COMMA] = ACTIONS(2960),
    [anon_sym_null] = ACTIONS(2958),
    [anon_sym_QMARK] = ACTIONS(2958),
    [anon_sym_COLON_QMARK] = ACTIONS(2958),
    [anon_sym_COLON_COLON] = ACTIONS(2960),
    [anon_sym_AMP] = ACTIONS(2958),
    [anon_sym_LBRACK] = ACTIONS(2958),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2960),
    [anon_sym_LBRACE] = ACTIONS(2958),
    [anon_sym_LT_AT] = ACTIONS(2958),
    [anon_sym_LT_AT_AT] = ACTIONS(2958),
    [anon_sym_DOT] = ACTIONS(2958),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2960),
    [anon_sym_new] = ACTIONS(2958),
    [anon_sym_return_BANG] = ACTIONS(2960),
    [anon_sym_yield] = ACTIONS(2958),
    [anon_sym_yield_BANG] = ACTIONS(2960),
    [anon_sym_lazy] = ACTIONS(2958),
    [anon_sym_assert] = ACTIONS(2958),
    [anon_sym_upcast] = ACTIONS(2958),
    [anon_sym_downcast] = ACTIONS(2958),
    [anon_sym_COLON_GT] = ACTIONS(2960),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2960),
    [anon_sym_for] = ACTIONS(2958),
    [anon_sym_while] = ACTIONS(2958),
    [anon_sym_if] = ACTIONS(2958),
    [anon_sym_fun] = ACTIONS(2958),
    [anon_sym_try] = ACTIONS(2958),
    [anon_sym_match] = ACTIONS(2958),
    [anon_sym_match_BANG] = ACTIONS(2960),
    [anon_sym_function] = ACTIONS(2958),
    [anon_sym_LT_DASH] = ACTIONS(2958),
    [anon_sym_DOT_LBRACK] = ACTIONS(2960),
    [anon_sym_LT] = ACTIONS(2960),
    [anon_sym_GT] = ACTIONS(2958),
    [anon_sym_use] = ACTIONS(2958),
    [anon_sym_use_BANG] = ACTIONS(2960),
    [anon_sym_do_BANG] = ACTIONS(2960),
    [anon_sym_begin] = ACTIONS(2958),
    [anon_sym_LPAREN2] = ACTIONS(2958),
    [anon_sym_or] = ACTIONS(2958),
    [aux_sym_char_token1] = ACTIONS(2960),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2958),
    [anon_sym_DQUOTE] = ACTIONS(2958),
    [anon_sym_AT_DQUOTE] = ACTIONS(2960),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2960),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2960),
    [sym_bool] = ACTIONS(2958),
    [sym_unit] = ACTIONS(2960),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2958),
    [sym_op_identifier] = ACTIONS(2958),
    [anon_sym_PLUS] = ACTIONS(2958),
    [anon_sym_DASH] = ACTIONS(2958),
    [anon_sym_PLUS_DOT] = ACTIONS(2958),
    [anon_sym_DASH_DOT] = ACTIONS(2958),
    [anon_sym_PERCENT] = ACTIONS(2958),
    [anon_sym_AMP_AMP] = ACTIONS(2958),
    [anon_sym_TILDE] = ACTIONS(2960),
    [aux_sym_prefix_op_token1] = ACTIONS(2958),
    [aux_sym_infix_op_token1] = ACTIONS(2960),
    [aux_sym_infix_op_token2] = ACTIONS(2958),
    [anon_sym_PIPE_PIPE] = ACTIONS(2958),
    [anon_sym_BANG_EQ] = ACTIONS(2958),
    [anon_sym_COLON_EQ] = ACTIONS(2960),
    [anon_sym_DOLLAR] = ACTIONS(2958),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2958),
    [sym_int] = ACTIONS(2958),
    [sym_xint] = ACTIONS(2960),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2960),
    [sym__newline] = ACTIONS(2960),
  },
  [2116] = {
    [sym_block_comment] = STATE(2116),
    [sym_compiler_directive_decl] = STATE(2116),
    [sym_fsi_directive_decl] = STATE(2116),
    [sym_preproc_line] = STATE(2116),
    [sym_identifier] = ACTIONS(2950),
    [anon_sym_EQ] = ACTIONS(2952),
    [anon_sym_COLON] = ACTIONS(2950),
    [anon_sym_return] = ACTIONS(2950),
    [anon_sym_do] = ACTIONS(2950),
    [anon_sym_let] = ACTIONS(2950),
    [anon_sym_let_BANG] = ACTIONS(2952),
    [anon_sym_LPAREN] = ACTIONS(2950),
    [anon_sym_COMMA] = ACTIONS(2952),
    [anon_sym_null] = ACTIONS(2950),
    [anon_sym_QMARK] = ACTIONS(2950),
    [anon_sym_COLON_QMARK] = ACTIONS(2950),
    [anon_sym_COLON_COLON] = ACTIONS(2952),
    [anon_sym_AMP] = ACTIONS(2950),
    [anon_sym_LBRACK] = ACTIONS(2950),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2952),
    [anon_sym_LBRACE] = ACTIONS(2950),
    [anon_sym_LT_AT] = ACTIONS(2950),
    [anon_sym_LT_AT_AT] = ACTIONS(2950),
    [anon_sym_DOT] = ACTIONS(2950),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2952),
    [anon_sym_new] = ACTIONS(2950),
    [anon_sym_return_BANG] = ACTIONS(2952),
    [anon_sym_yield] = ACTIONS(2950),
    [anon_sym_yield_BANG] = ACTIONS(2952),
    [anon_sym_lazy] = ACTIONS(2950),
    [anon_sym_assert] = ACTIONS(2950),
    [anon_sym_upcast] = ACTIONS(2950),
    [anon_sym_downcast] = ACTIONS(2950),
    [anon_sym_COLON_GT] = ACTIONS(2952),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2952),
    [anon_sym_for] = ACTIONS(2950),
    [anon_sym_while] = ACTIONS(2950),
    [anon_sym_if] = ACTIONS(2950),
    [anon_sym_fun] = ACTIONS(2950),
    [anon_sym_try] = ACTIONS(2950),
    [anon_sym_match] = ACTIONS(2950),
    [anon_sym_match_BANG] = ACTIONS(2952),
    [anon_sym_function] = ACTIONS(2950),
    [anon_sym_LT_DASH] = ACTIONS(2950),
    [anon_sym_DOT_LBRACK] = ACTIONS(2952),
    [anon_sym_LT] = ACTIONS(2952),
    [anon_sym_GT] = ACTIONS(2950),
    [anon_sym_use] = ACTIONS(2950),
    [anon_sym_use_BANG] = ACTIONS(2952),
    [anon_sym_do_BANG] = ACTIONS(2952),
    [anon_sym_begin] = ACTIONS(2950),
    [anon_sym_LPAREN2] = ACTIONS(2950),
    [anon_sym_or] = ACTIONS(2950),
    [aux_sym_char_token1] = ACTIONS(2952),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2950),
    [anon_sym_DQUOTE] = ACTIONS(2950),
    [anon_sym_AT_DQUOTE] = ACTIONS(2952),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2952),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2952),
    [sym_bool] = ACTIONS(2950),
    [sym_unit] = ACTIONS(2952),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2950),
    [sym_op_identifier] = ACTIONS(2950),
    [anon_sym_PLUS] = ACTIONS(2950),
    [anon_sym_DASH] = ACTIONS(2950),
    [anon_sym_PLUS_DOT] = ACTIONS(2950),
    [anon_sym_DASH_DOT] = ACTIONS(2950),
    [anon_sym_PERCENT] = ACTIONS(2950),
    [anon_sym_AMP_AMP] = ACTIONS(2950),
    [anon_sym_TILDE] = ACTIONS(2952),
    [aux_sym_prefix_op_token1] = ACTIONS(2950),
    [aux_sym_infix_op_token1] = ACTIONS(2952),
    [aux_sym_infix_op_token2] = ACTIONS(2950),
    [anon_sym_PIPE_PIPE] = ACTIONS(2950),
    [anon_sym_BANG_EQ] = ACTIONS(2950),
    [anon_sym_COLON_EQ] = ACTIONS(2952),
    [anon_sym_DOLLAR] = ACTIONS(2950),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2950),
    [sym_int] = ACTIONS(2950),
    [sym_xint] = ACTIONS(2952),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2952),
    [sym__newline] = ACTIONS(2952),
  },
  [2117] = {
    [sym_block_comment] = STATE(2117),
    [sym_compiler_directive_decl] = STATE(2117),
    [sym_fsi_directive_decl] = STATE(2117),
    [sym_preproc_line] = STATE(2117),
    [sym_identifier] = ACTIONS(2946),
    [anon_sym_EQ] = ACTIONS(2948),
    [anon_sym_COLON] = ACTIONS(2946),
    [anon_sym_return] = ACTIONS(2946),
    [anon_sym_do] = ACTIONS(2946),
    [anon_sym_let] = ACTIONS(2946),
    [anon_sym_let_BANG] = ACTIONS(2948),
    [anon_sym_LPAREN] = ACTIONS(2946),
    [anon_sym_COMMA] = ACTIONS(2948),
    [anon_sym_null] = ACTIONS(2946),
    [anon_sym_QMARK] = ACTIONS(2946),
    [anon_sym_COLON_QMARK] = ACTIONS(2946),
    [anon_sym_COLON_COLON] = ACTIONS(2948),
    [anon_sym_AMP] = ACTIONS(2946),
    [anon_sym_LBRACK] = ACTIONS(2946),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2948),
    [anon_sym_LBRACE] = ACTIONS(2946),
    [anon_sym_LT_AT] = ACTIONS(2946),
    [anon_sym_LT_AT_AT] = ACTIONS(2946),
    [anon_sym_DOT] = ACTIONS(2946),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2948),
    [anon_sym_new] = ACTIONS(2946),
    [anon_sym_return_BANG] = ACTIONS(2948),
    [anon_sym_yield] = ACTIONS(2946),
    [anon_sym_yield_BANG] = ACTIONS(2948),
    [anon_sym_lazy] = ACTIONS(2946),
    [anon_sym_assert] = ACTIONS(2946),
    [anon_sym_upcast] = ACTIONS(2946),
    [anon_sym_downcast] = ACTIONS(2946),
    [anon_sym_COLON_GT] = ACTIONS(2948),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2948),
    [anon_sym_for] = ACTIONS(2946),
    [anon_sym_while] = ACTIONS(2946),
    [anon_sym_if] = ACTIONS(2946),
    [anon_sym_fun] = ACTIONS(2946),
    [anon_sym_try] = ACTIONS(2946),
    [anon_sym_match] = ACTIONS(2946),
    [anon_sym_match_BANG] = ACTIONS(2948),
    [anon_sym_function] = ACTIONS(2946),
    [anon_sym_LT_DASH] = ACTIONS(2946),
    [anon_sym_DOT_LBRACK] = ACTIONS(2948),
    [anon_sym_LT] = ACTIONS(2948),
    [anon_sym_GT] = ACTIONS(2946),
    [anon_sym_use] = ACTIONS(2946),
    [anon_sym_use_BANG] = ACTIONS(2948),
    [anon_sym_do_BANG] = ACTIONS(2948),
    [anon_sym_begin] = ACTIONS(2946),
    [anon_sym_LPAREN2] = ACTIONS(2946),
    [anon_sym_or] = ACTIONS(2946),
    [aux_sym_char_token1] = ACTIONS(2948),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2946),
    [anon_sym_DQUOTE] = ACTIONS(2946),
    [anon_sym_AT_DQUOTE] = ACTIONS(2948),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2948),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2948),
    [sym_bool] = ACTIONS(2946),
    [sym_unit] = ACTIONS(2948),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2946),
    [sym_op_identifier] = ACTIONS(2946),
    [anon_sym_PLUS] = ACTIONS(2946),
    [anon_sym_DASH] = ACTIONS(2946),
    [anon_sym_PLUS_DOT] = ACTIONS(2946),
    [anon_sym_DASH_DOT] = ACTIONS(2946),
    [anon_sym_PERCENT] = ACTIONS(2946),
    [anon_sym_AMP_AMP] = ACTIONS(2946),
    [anon_sym_TILDE] = ACTIONS(2948),
    [aux_sym_prefix_op_token1] = ACTIONS(2946),
    [aux_sym_infix_op_token1] = ACTIONS(2948),
    [aux_sym_infix_op_token2] = ACTIONS(2946),
    [anon_sym_PIPE_PIPE] = ACTIONS(2946),
    [anon_sym_BANG_EQ] = ACTIONS(2946),
    [anon_sym_COLON_EQ] = ACTIONS(2948),
    [anon_sym_DOLLAR] = ACTIONS(2946),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2946),
    [sym_int] = ACTIONS(2946),
    [sym_xint] = ACTIONS(2948),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2948),
    [sym__newline] = ACTIONS(2948),
  },
  [2118] = {
    [sym_block_comment] = STATE(2118),
    [sym_compiler_directive_decl] = STATE(2118),
    [sym_fsi_directive_decl] = STATE(2118),
    [sym_preproc_line] = STATE(2118),
    [sym_identifier] = ACTIONS(2938),
    [anon_sym_EQ] = ACTIONS(2940),
    [anon_sym_COLON] = ACTIONS(2938),
    [anon_sym_return] = ACTIONS(2938),
    [anon_sym_do] = ACTIONS(2938),
    [anon_sym_let] = ACTIONS(2938),
    [anon_sym_let_BANG] = ACTIONS(2940),
    [anon_sym_LPAREN] = ACTIONS(2938),
    [anon_sym_COMMA] = ACTIONS(2940),
    [anon_sym_null] = ACTIONS(2938),
    [anon_sym_QMARK] = ACTIONS(2938),
    [anon_sym_COLON_QMARK] = ACTIONS(2938),
    [anon_sym_COLON_COLON] = ACTIONS(2940),
    [anon_sym_AMP] = ACTIONS(2938),
    [anon_sym_LBRACK] = ACTIONS(2938),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2940),
    [anon_sym_LBRACE] = ACTIONS(2938),
    [anon_sym_LT_AT] = ACTIONS(2938),
    [anon_sym_LT_AT_AT] = ACTIONS(2938),
    [anon_sym_DOT] = ACTIONS(2938),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2940),
    [anon_sym_new] = ACTIONS(2938),
    [anon_sym_return_BANG] = ACTIONS(2940),
    [anon_sym_yield] = ACTIONS(2938),
    [anon_sym_yield_BANG] = ACTIONS(2940),
    [anon_sym_lazy] = ACTIONS(2938),
    [anon_sym_assert] = ACTIONS(2938),
    [anon_sym_upcast] = ACTIONS(2938),
    [anon_sym_downcast] = ACTIONS(2938),
    [anon_sym_COLON_GT] = ACTIONS(2940),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2940),
    [anon_sym_for] = ACTIONS(2938),
    [anon_sym_while] = ACTIONS(2938),
    [anon_sym_if] = ACTIONS(2938),
    [anon_sym_fun] = ACTIONS(2938),
    [anon_sym_try] = ACTIONS(2938),
    [anon_sym_match] = ACTIONS(2938),
    [anon_sym_match_BANG] = ACTIONS(2940),
    [anon_sym_function] = ACTIONS(2938),
    [anon_sym_LT_DASH] = ACTIONS(2938),
    [anon_sym_DOT_LBRACK] = ACTIONS(2940),
    [anon_sym_LT] = ACTIONS(2940),
    [anon_sym_GT] = ACTIONS(2938),
    [anon_sym_use] = ACTIONS(2938),
    [anon_sym_use_BANG] = ACTIONS(2940),
    [anon_sym_do_BANG] = ACTIONS(2940),
    [anon_sym_begin] = ACTIONS(2938),
    [anon_sym_LPAREN2] = ACTIONS(2938),
    [anon_sym_or] = ACTIONS(2938),
    [aux_sym_char_token1] = ACTIONS(2940),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2938),
    [anon_sym_DQUOTE] = ACTIONS(2938),
    [anon_sym_AT_DQUOTE] = ACTIONS(2940),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2940),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2940),
    [sym_bool] = ACTIONS(2938),
    [sym_unit] = ACTIONS(2940),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2938),
    [sym_op_identifier] = ACTIONS(2938),
    [anon_sym_PLUS] = ACTIONS(2938),
    [anon_sym_DASH] = ACTIONS(2938),
    [anon_sym_PLUS_DOT] = ACTIONS(2938),
    [anon_sym_DASH_DOT] = ACTIONS(2938),
    [anon_sym_PERCENT] = ACTIONS(2938),
    [anon_sym_AMP_AMP] = ACTIONS(2938),
    [anon_sym_TILDE] = ACTIONS(2940),
    [aux_sym_prefix_op_token1] = ACTIONS(2938),
    [aux_sym_infix_op_token1] = ACTIONS(2940),
    [aux_sym_infix_op_token2] = ACTIONS(2938),
    [anon_sym_PIPE_PIPE] = ACTIONS(2938),
    [anon_sym_BANG_EQ] = ACTIONS(2938),
    [anon_sym_COLON_EQ] = ACTIONS(2940),
    [anon_sym_DOLLAR] = ACTIONS(2938),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2938),
    [sym_int] = ACTIONS(2938),
    [sym_xint] = ACTIONS(2940),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2940),
    [sym__newline] = ACTIONS(2940),
  },
  [2119] = {
    [sym_block_comment] = STATE(2119),
    [sym_compiler_directive_decl] = STATE(2119),
    [sym_fsi_directive_decl] = STATE(2119),
    [sym_preproc_line] = STATE(2119),
    [sym_identifier] = ACTIONS(2926),
    [anon_sym_EQ] = ACTIONS(2928),
    [anon_sym_COLON] = ACTIONS(2926),
    [anon_sym_return] = ACTIONS(2926),
    [anon_sym_do] = ACTIONS(2926),
    [anon_sym_let] = ACTIONS(2926),
    [anon_sym_let_BANG] = ACTIONS(2928),
    [anon_sym_LPAREN] = ACTIONS(2926),
    [anon_sym_COMMA] = ACTIONS(2928),
    [anon_sym_null] = ACTIONS(2926),
    [anon_sym_QMARK] = ACTIONS(2926),
    [anon_sym_COLON_QMARK] = ACTIONS(2926),
    [anon_sym_COLON_COLON] = ACTIONS(2928),
    [anon_sym_AMP] = ACTIONS(2926),
    [anon_sym_LBRACK] = ACTIONS(2926),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2928),
    [anon_sym_LBRACE] = ACTIONS(2926),
    [anon_sym_LT_AT] = ACTIONS(2926),
    [anon_sym_LT_AT_AT] = ACTIONS(2926),
    [anon_sym_DOT] = ACTIONS(2926),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2928),
    [anon_sym_new] = ACTIONS(2926),
    [anon_sym_return_BANG] = ACTIONS(2928),
    [anon_sym_yield] = ACTIONS(2926),
    [anon_sym_yield_BANG] = ACTIONS(2928),
    [anon_sym_lazy] = ACTIONS(2926),
    [anon_sym_assert] = ACTIONS(2926),
    [anon_sym_upcast] = ACTIONS(2926),
    [anon_sym_downcast] = ACTIONS(2926),
    [anon_sym_COLON_GT] = ACTIONS(2928),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2928),
    [anon_sym_for] = ACTIONS(2926),
    [anon_sym_while] = ACTIONS(2926),
    [anon_sym_if] = ACTIONS(2926),
    [anon_sym_fun] = ACTIONS(2926),
    [anon_sym_try] = ACTIONS(2926),
    [anon_sym_match] = ACTIONS(2926),
    [anon_sym_match_BANG] = ACTIONS(2928),
    [anon_sym_function] = ACTIONS(2926),
    [anon_sym_LT_DASH] = ACTIONS(2926),
    [anon_sym_DOT_LBRACK] = ACTIONS(2928),
    [anon_sym_LT] = ACTIONS(2928),
    [anon_sym_GT] = ACTIONS(2926),
    [anon_sym_use] = ACTIONS(2926),
    [anon_sym_use_BANG] = ACTIONS(2928),
    [anon_sym_do_BANG] = ACTIONS(2928),
    [anon_sym_begin] = ACTIONS(2926),
    [anon_sym_LPAREN2] = ACTIONS(2926),
    [anon_sym_or] = ACTIONS(2926),
    [aux_sym_char_token1] = ACTIONS(2928),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2926),
    [anon_sym_DQUOTE] = ACTIONS(2926),
    [anon_sym_AT_DQUOTE] = ACTIONS(2928),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2928),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2928),
    [sym_bool] = ACTIONS(2926),
    [sym_unit] = ACTIONS(2928),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2926),
    [sym_op_identifier] = ACTIONS(2926),
    [anon_sym_PLUS] = ACTIONS(2926),
    [anon_sym_DASH] = ACTIONS(2926),
    [anon_sym_PLUS_DOT] = ACTIONS(2926),
    [anon_sym_DASH_DOT] = ACTIONS(2926),
    [anon_sym_PERCENT] = ACTIONS(2926),
    [anon_sym_AMP_AMP] = ACTIONS(2926),
    [anon_sym_TILDE] = ACTIONS(2928),
    [aux_sym_prefix_op_token1] = ACTIONS(2926),
    [aux_sym_infix_op_token1] = ACTIONS(2928),
    [aux_sym_infix_op_token2] = ACTIONS(2926),
    [anon_sym_PIPE_PIPE] = ACTIONS(2926),
    [anon_sym_BANG_EQ] = ACTIONS(2926),
    [anon_sym_COLON_EQ] = ACTIONS(2928),
    [anon_sym_DOLLAR] = ACTIONS(2926),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2926),
    [sym_int] = ACTIONS(2926),
    [sym_xint] = ACTIONS(2928),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2928),
    [sym__newline] = ACTIONS(2928),
  },
  [2120] = {
    [sym_block_comment] = STATE(2120),
    [sym_compiler_directive_decl] = STATE(2120),
    [sym_fsi_directive_decl] = STATE(2120),
    [sym_preproc_line] = STATE(2120),
    [sym_identifier] = ACTIONS(2922),
    [anon_sym_EQ] = ACTIONS(2924),
    [anon_sym_COLON] = ACTIONS(2922),
    [anon_sym_return] = ACTIONS(2922),
    [anon_sym_do] = ACTIONS(2922),
    [anon_sym_let] = ACTIONS(2922),
    [anon_sym_let_BANG] = ACTIONS(2924),
    [anon_sym_LPAREN] = ACTIONS(2922),
    [anon_sym_COMMA] = ACTIONS(2924),
    [anon_sym_null] = ACTIONS(2922),
    [anon_sym_QMARK] = ACTIONS(2922),
    [anon_sym_COLON_QMARK] = ACTIONS(2922),
    [anon_sym_COLON_COLON] = ACTIONS(2924),
    [anon_sym_AMP] = ACTIONS(2922),
    [anon_sym_LBRACK] = ACTIONS(2922),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2924),
    [anon_sym_LBRACE] = ACTIONS(2922),
    [anon_sym_LT_AT] = ACTIONS(2922),
    [anon_sym_LT_AT_AT] = ACTIONS(2922),
    [anon_sym_DOT] = ACTIONS(2922),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2924),
    [anon_sym_new] = ACTIONS(2922),
    [anon_sym_return_BANG] = ACTIONS(2924),
    [anon_sym_yield] = ACTIONS(2922),
    [anon_sym_yield_BANG] = ACTIONS(2924),
    [anon_sym_lazy] = ACTIONS(2922),
    [anon_sym_assert] = ACTIONS(2922),
    [anon_sym_upcast] = ACTIONS(2922),
    [anon_sym_downcast] = ACTIONS(2922),
    [anon_sym_COLON_GT] = ACTIONS(2924),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2924),
    [anon_sym_for] = ACTIONS(2922),
    [anon_sym_while] = ACTIONS(2922),
    [anon_sym_if] = ACTIONS(2922),
    [anon_sym_fun] = ACTIONS(2922),
    [anon_sym_try] = ACTIONS(2922),
    [anon_sym_match] = ACTIONS(2922),
    [anon_sym_match_BANG] = ACTIONS(2924),
    [anon_sym_function] = ACTIONS(2922),
    [anon_sym_LT_DASH] = ACTIONS(2922),
    [anon_sym_DOT_LBRACK] = ACTIONS(2924),
    [anon_sym_LT] = ACTIONS(2924),
    [anon_sym_GT] = ACTIONS(2922),
    [anon_sym_use] = ACTIONS(2922),
    [anon_sym_use_BANG] = ACTIONS(2924),
    [anon_sym_do_BANG] = ACTIONS(2924),
    [anon_sym_begin] = ACTIONS(2922),
    [anon_sym_LPAREN2] = ACTIONS(2922),
    [anon_sym_or] = ACTIONS(2922),
    [aux_sym_char_token1] = ACTIONS(2924),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2922),
    [anon_sym_DQUOTE] = ACTIONS(2922),
    [anon_sym_AT_DQUOTE] = ACTIONS(2924),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2924),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2924),
    [sym_bool] = ACTIONS(2922),
    [sym_unit] = ACTIONS(2924),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2922),
    [sym_op_identifier] = ACTIONS(2922),
    [anon_sym_PLUS] = ACTIONS(2922),
    [anon_sym_DASH] = ACTIONS(2922),
    [anon_sym_PLUS_DOT] = ACTIONS(2922),
    [anon_sym_DASH_DOT] = ACTIONS(2922),
    [anon_sym_PERCENT] = ACTIONS(2922),
    [anon_sym_AMP_AMP] = ACTIONS(2922),
    [anon_sym_TILDE] = ACTIONS(2924),
    [aux_sym_prefix_op_token1] = ACTIONS(2922),
    [aux_sym_infix_op_token1] = ACTIONS(2924),
    [aux_sym_infix_op_token2] = ACTIONS(2922),
    [anon_sym_PIPE_PIPE] = ACTIONS(2922),
    [anon_sym_BANG_EQ] = ACTIONS(2922),
    [anon_sym_COLON_EQ] = ACTIONS(2924),
    [anon_sym_DOLLAR] = ACTIONS(2922),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2922),
    [sym_int] = ACTIONS(2922),
    [sym_xint] = ACTIONS(2924),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2924),
    [sym__newline] = ACTIONS(2924),
  },
  [2121] = {
    [sym_block_comment] = STATE(2121),
    [sym_compiler_directive_decl] = STATE(2121),
    [sym_fsi_directive_decl] = STATE(2121),
    [sym_preproc_line] = STATE(2121),
    [sym_identifier] = ACTIONS(2918),
    [anon_sym_EQ] = ACTIONS(2920),
    [anon_sym_COLON] = ACTIONS(2918),
    [anon_sym_return] = ACTIONS(2918),
    [anon_sym_do] = ACTIONS(2918),
    [anon_sym_let] = ACTIONS(2918),
    [anon_sym_let_BANG] = ACTIONS(2920),
    [anon_sym_LPAREN] = ACTIONS(2918),
    [anon_sym_COMMA] = ACTIONS(2920),
    [anon_sym_null] = ACTIONS(2918),
    [anon_sym_QMARK] = ACTIONS(2918),
    [anon_sym_COLON_QMARK] = ACTIONS(2918),
    [anon_sym_COLON_COLON] = ACTIONS(2920),
    [anon_sym_AMP] = ACTIONS(2918),
    [anon_sym_LBRACK] = ACTIONS(2918),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2920),
    [anon_sym_LBRACE] = ACTIONS(2918),
    [anon_sym_LT_AT] = ACTIONS(2918),
    [anon_sym_LT_AT_AT] = ACTIONS(2918),
    [anon_sym_DOT] = ACTIONS(2918),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2920),
    [anon_sym_new] = ACTIONS(2918),
    [anon_sym_return_BANG] = ACTIONS(2920),
    [anon_sym_yield] = ACTIONS(2918),
    [anon_sym_yield_BANG] = ACTIONS(2920),
    [anon_sym_lazy] = ACTIONS(2918),
    [anon_sym_assert] = ACTIONS(2918),
    [anon_sym_upcast] = ACTIONS(2918),
    [anon_sym_downcast] = ACTIONS(2918),
    [anon_sym_COLON_GT] = ACTIONS(2920),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2920),
    [anon_sym_for] = ACTIONS(2918),
    [anon_sym_while] = ACTIONS(2918),
    [anon_sym_if] = ACTIONS(2918),
    [anon_sym_fun] = ACTIONS(2918),
    [anon_sym_try] = ACTIONS(2918),
    [anon_sym_match] = ACTIONS(2918),
    [anon_sym_match_BANG] = ACTIONS(2920),
    [anon_sym_function] = ACTIONS(2918),
    [anon_sym_LT_DASH] = ACTIONS(2918),
    [anon_sym_DOT_LBRACK] = ACTIONS(2920),
    [anon_sym_LT] = ACTIONS(2920),
    [anon_sym_GT] = ACTIONS(2918),
    [anon_sym_use] = ACTIONS(2918),
    [anon_sym_use_BANG] = ACTIONS(2920),
    [anon_sym_do_BANG] = ACTIONS(2920),
    [anon_sym_begin] = ACTIONS(2918),
    [anon_sym_LPAREN2] = ACTIONS(2918),
    [anon_sym_or] = ACTIONS(2918),
    [aux_sym_char_token1] = ACTIONS(2920),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2918),
    [anon_sym_DQUOTE] = ACTIONS(2918),
    [anon_sym_AT_DQUOTE] = ACTIONS(2920),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2920),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2920),
    [sym_bool] = ACTIONS(2918),
    [sym_unit] = ACTIONS(2920),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2918),
    [sym_op_identifier] = ACTIONS(2918),
    [anon_sym_PLUS] = ACTIONS(2918),
    [anon_sym_DASH] = ACTIONS(2918),
    [anon_sym_PLUS_DOT] = ACTIONS(2918),
    [anon_sym_DASH_DOT] = ACTIONS(2918),
    [anon_sym_PERCENT] = ACTIONS(2918),
    [anon_sym_AMP_AMP] = ACTIONS(2918),
    [anon_sym_TILDE] = ACTIONS(2920),
    [aux_sym_prefix_op_token1] = ACTIONS(2918),
    [aux_sym_infix_op_token1] = ACTIONS(2920),
    [aux_sym_infix_op_token2] = ACTIONS(2918),
    [anon_sym_PIPE_PIPE] = ACTIONS(2918),
    [anon_sym_BANG_EQ] = ACTIONS(2918),
    [anon_sym_COLON_EQ] = ACTIONS(2920),
    [anon_sym_DOLLAR] = ACTIONS(2918),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2918),
    [sym_int] = ACTIONS(2918),
    [sym_xint] = ACTIONS(2920),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2920),
    [sym__newline] = ACTIONS(2920),
  },
  [2122] = {
    [sym_block_comment] = STATE(2122),
    [sym_compiler_directive_decl] = STATE(2122),
    [sym_fsi_directive_decl] = STATE(2122),
    [sym_preproc_line] = STATE(2122),
    [sym_identifier] = ACTIONS(2914),
    [anon_sym_EQ] = ACTIONS(2916),
    [anon_sym_COLON] = ACTIONS(2914),
    [anon_sym_return] = ACTIONS(2914),
    [anon_sym_do] = ACTIONS(2914),
    [anon_sym_let] = ACTIONS(2914),
    [anon_sym_let_BANG] = ACTIONS(2916),
    [anon_sym_LPAREN] = ACTIONS(2914),
    [anon_sym_COMMA] = ACTIONS(2916),
    [anon_sym_null] = ACTIONS(2914),
    [anon_sym_QMARK] = ACTIONS(2914),
    [anon_sym_COLON_QMARK] = ACTIONS(2914),
    [anon_sym_COLON_COLON] = ACTIONS(2916),
    [anon_sym_AMP] = ACTIONS(2914),
    [anon_sym_LBRACK] = ACTIONS(2914),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2916),
    [anon_sym_LBRACE] = ACTIONS(2914),
    [anon_sym_LT_AT] = ACTIONS(2914),
    [anon_sym_LT_AT_AT] = ACTIONS(2914),
    [anon_sym_DOT] = ACTIONS(2914),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2916),
    [anon_sym_new] = ACTIONS(2914),
    [anon_sym_return_BANG] = ACTIONS(2916),
    [anon_sym_yield] = ACTIONS(2914),
    [anon_sym_yield_BANG] = ACTIONS(2916),
    [anon_sym_lazy] = ACTIONS(2914),
    [anon_sym_assert] = ACTIONS(2914),
    [anon_sym_upcast] = ACTIONS(2914),
    [anon_sym_downcast] = ACTIONS(2914),
    [anon_sym_COLON_GT] = ACTIONS(2916),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2916),
    [anon_sym_for] = ACTIONS(2914),
    [anon_sym_while] = ACTIONS(2914),
    [anon_sym_if] = ACTIONS(2914),
    [anon_sym_fun] = ACTIONS(2914),
    [anon_sym_try] = ACTIONS(2914),
    [anon_sym_match] = ACTIONS(2914),
    [anon_sym_match_BANG] = ACTIONS(2916),
    [anon_sym_function] = ACTIONS(2914),
    [anon_sym_LT_DASH] = ACTIONS(2914),
    [anon_sym_DOT_LBRACK] = ACTIONS(2916),
    [anon_sym_LT] = ACTIONS(2916),
    [anon_sym_GT] = ACTIONS(2914),
    [anon_sym_use] = ACTIONS(2914),
    [anon_sym_use_BANG] = ACTIONS(2916),
    [anon_sym_do_BANG] = ACTIONS(2916),
    [anon_sym_begin] = ACTIONS(2914),
    [anon_sym_LPAREN2] = ACTIONS(2914),
    [anon_sym_or] = ACTIONS(2914),
    [aux_sym_char_token1] = ACTIONS(2916),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2914),
    [anon_sym_DQUOTE] = ACTIONS(2914),
    [anon_sym_AT_DQUOTE] = ACTIONS(2916),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2916),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2916),
    [sym_bool] = ACTIONS(2914),
    [sym_unit] = ACTIONS(2916),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2914),
    [sym_op_identifier] = ACTIONS(2914),
    [anon_sym_PLUS] = ACTIONS(2914),
    [anon_sym_DASH] = ACTIONS(2914),
    [anon_sym_PLUS_DOT] = ACTIONS(2914),
    [anon_sym_DASH_DOT] = ACTIONS(2914),
    [anon_sym_PERCENT] = ACTIONS(2914),
    [anon_sym_AMP_AMP] = ACTIONS(2914),
    [anon_sym_TILDE] = ACTIONS(2916),
    [aux_sym_prefix_op_token1] = ACTIONS(2914),
    [aux_sym_infix_op_token1] = ACTIONS(2916),
    [aux_sym_infix_op_token2] = ACTIONS(2914),
    [anon_sym_PIPE_PIPE] = ACTIONS(2914),
    [anon_sym_BANG_EQ] = ACTIONS(2914),
    [anon_sym_COLON_EQ] = ACTIONS(2916),
    [anon_sym_DOLLAR] = ACTIONS(2914),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2914),
    [sym_int] = ACTIONS(2914),
    [sym_xint] = ACTIONS(2916),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2916),
    [sym__newline] = ACTIONS(2916),
  },
  [2123] = {
    [sym_block_comment] = STATE(2123),
    [sym_compiler_directive_decl] = STATE(2123),
    [sym_fsi_directive_decl] = STATE(2123),
    [sym_preproc_line] = STATE(2123),
    [sym_identifier] = ACTIONS(2910),
    [anon_sym_EQ] = ACTIONS(2912),
    [anon_sym_COLON] = ACTIONS(2910),
    [anon_sym_return] = ACTIONS(2910),
    [anon_sym_do] = ACTIONS(2910),
    [anon_sym_let] = ACTIONS(2910),
    [anon_sym_let_BANG] = ACTIONS(2912),
    [anon_sym_LPAREN] = ACTIONS(2910),
    [anon_sym_COMMA] = ACTIONS(2912),
    [anon_sym_null] = ACTIONS(2910),
    [anon_sym_QMARK] = ACTIONS(2910),
    [anon_sym_COLON_QMARK] = ACTIONS(2910),
    [anon_sym_COLON_COLON] = ACTIONS(2912),
    [anon_sym_AMP] = ACTIONS(2910),
    [anon_sym_LBRACK] = ACTIONS(2910),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2912),
    [anon_sym_LBRACE] = ACTIONS(2910),
    [anon_sym_LT_AT] = ACTIONS(2910),
    [anon_sym_LT_AT_AT] = ACTIONS(2910),
    [anon_sym_DOT] = ACTIONS(2910),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2912),
    [anon_sym_new] = ACTIONS(2910),
    [anon_sym_return_BANG] = ACTIONS(2912),
    [anon_sym_yield] = ACTIONS(2910),
    [anon_sym_yield_BANG] = ACTIONS(2912),
    [anon_sym_lazy] = ACTIONS(2910),
    [anon_sym_assert] = ACTIONS(2910),
    [anon_sym_upcast] = ACTIONS(2910),
    [anon_sym_downcast] = ACTIONS(2910),
    [anon_sym_COLON_GT] = ACTIONS(2912),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2912),
    [anon_sym_for] = ACTIONS(2910),
    [anon_sym_while] = ACTIONS(2910),
    [anon_sym_if] = ACTIONS(2910),
    [anon_sym_fun] = ACTIONS(2910),
    [anon_sym_try] = ACTIONS(2910),
    [anon_sym_match] = ACTIONS(2910),
    [anon_sym_match_BANG] = ACTIONS(2912),
    [anon_sym_function] = ACTIONS(2910),
    [anon_sym_LT_DASH] = ACTIONS(2910),
    [anon_sym_DOT_LBRACK] = ACTIONS(2912),
    [anon_sym_LT] = ACTIONS(2912),
    [anon_sym_GT] = ACTIONS(2910),
    [anon_sym_use] = ACTIONS(2910),
    [anon_sym_use_BANG] = ACTIONS(2912),
    [anon_sym_do_BANG] = ACTIONS(2912),
    [anon_sym_begin] = ACTIONS(2910),
    [anon_sym_LPAREN2] = ACTIONS(2910),
    [anon_sym_or] = ACTIONS(2910),
    [aux_sym_char_token1] = ACTIONS(2912),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2910),
    [anon_sym_DQUOTE] = ACTIONS(2910),
    [anon_sym_AT_DQUOTE] = ACTIONS(2912),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2912),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2912),
    [sym_bool] = ACTIONS(2910),
    [sym_unit] = ACTIONS(2912),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2910),
    [sym_op_identifier] = ACTIONS(2910),
    [anon_sym_PLUS] = ACTIONS(2910),
    [anon_sym_DASH] = ACTIONS(2910),
    [anon_sym_PLUS_DOT] = ACTIONS(2910),
    [anon_sym_DASH_DOT] = ACTIONS(2910),
    [anon_sym_PERCENT] = ACTIONS(2910),
    [anon_sym_AMP_AMP] = ACTIONS(2910),
    [anon_sym_TILDE] = ACTIONS(2912),
    [aux_sym_prefix_op_token1] = ACTIONS(2910),
    [aux_sym_infix_op_token1] = ACTIONS(2912),
    [aux_sym_infix_op_token2] = ACTIONS(2910),
    [anon_sym_PIPE_PIPE] = ACTIONS(2910),
    [anon_sym_BANG_EQ] = ACTIONS(2910),
    [anon_sym_COLON_EQ] = ACTIONS(2912),
    [anon_sym_DOLLAR] = ACTIONS(2910),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2910),
    [sym_int] = ACTIONS(2910),
    [sym_xint] = ACTIONS(2912),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2912),
    [sym__newline] = ACTIONS(2912),
  },
  [2124] = {
    [sym_block_comment] = STATE(2124),
    [sym_compiler_directive_decl] = STATE(2124),
    [sym_fsi_directive_decl] = STATE(2124),
    [sym_preproc_line] = STATE(2124),
    [sym_identifier] = ACTIONS(2891),
    [anon_sym_EQ] = ACTIONS(2893),
    [anon_sym_COLON] = ACTIONS(2891),
    [anon_sym_return] = ACTIONS(2891),
    [anon_sym_do] = ACTIONS(2891),
    [anon_sym_let] = ACTIONS(2891),
    [anon_sym_let_BANG] = ACTIONS(2893),
    [anon_sym_LPAREN] = ACTIONS(2891),
    [anon_sym_COMMA] = ACTIONS(2893),
    [anon_sym_null] = ACTIONS(2891),
    [anon_sym_QMARK] = ACTIONS(2891),
    [anon_sym_COLON_QMARK] = ACTIONS(2891),
    [anon_sym_COLON_COLON] = ACTIONS(2893),
    [anon_sym_AMP] = ACTIONS(2891),
    [anon_sym_LBRACK] = ACTIONS(2891),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2893),
    [anon_sym_LBRACE] = ACTIONS(2891),
    [anon_sym_LT_AT] = ACTIONS(2891),
    [anon_sym_LT_AT_AT] = ACTIONS(2891),
    [anon_sym_DOT] = ACTIONS(2891),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2893),
    [anon_sym_new] = ACTIONS(2891),
    [anon_sym_return_BANG] = ACTIONS(2893),
    [anon_sym_yield] = ACTIONS(2891),
    [anon_sym_yield_BANG] = ACTIONS(2893),
    [anon_sym_lazy] = ACTIONS(2891),
    [anon_sym_assert] = ACTIONS(2891),
    [anon_sym_upcast] = ACTIONS(2891),
    [anon_sym_downcast] = ACTIONS(2891),
    [anon_sym_COLON_GT] = ACTIONS(2893),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2893),
    [anon_sym_for] = ACTIONS(2891),
    [anon_sym_while] = ACTIONS(2891),
    [anon_sym_if] = ACTIONS(2891),
    [anon_sym_fun] = ACTIONS(2891),
    [anon_sym_try] = ACTIONS(2891),
    [anon_sym_match] = ACTIONS(2891),
    [anon_sym_match_BANG] = ACTIONS(2893),
    [anon_sym_function] = ACTIONS(2891),
    [anon_sym_LT_DASH] = ACTIONS(2891),
    [anon_sym_DOT_LBRACK] = ACTIONS(2893),
    [anon_sym_LT] = ACTIONS(2893),
    [anon_sym_GT] = ACTIONS(2891),
    [anon_sym_use] = ACTIONS(2891),
    [anon_sym_use_BANG] = ACTIONS(2893),
    [anon_sym_do_BANG] = ACTIONS(2893),
    [anon_sym_begin] = ACTIONS(2891),
    [anon_sym_LPAREN2] = ACTIONS(2891),
    [anon_sym_or] = ACTIONS(2891),
    [aux_sym_char_token1] = ACTIONS(2893),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2891),
    [anon_sym_DQUOTE] = ACTIONS(2891),
    [anon_sym_AT_DQUOTE] = ACTIONS(2893),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2893),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2893),
    [sym_bool] = ACTIONS(2891),
    [sym_unit] = ACTIONS(2893),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2891),
    [sym_op_identifier] = ACTIONS(2891),
    [anon_sym_PLUS] = ACTIONS(2891),
    [anon_sym_DASH] = ACTIONS(2891),
    [anon_sym_PLUS_DOT] = ACTIONS(2891),
    [anon_sym_DASH_DOT] = ACTIONS(2891),
    [anon_sym_PERCENT] = ACTIONS(2891),
    [anon_sym_AMP_AMP] = ACTIONS(2891),
    [anon_sym_TILDE] = ACTIONS(2893),
    [aux_sym_prefix_op_token1] = ACTIONS(2891),
    [aux_sym_infix_op_token1] = ACTIONS(2893),
    [aux_sym_infix_op_token2] = ACTIONS(2891),
    [anon_sym_PIPE_PIPE] = ACTIONS(2891),
    [anon_sym_BANG_EQ] = ACTIONS(2891),
    [anon_sym_COLON_EQ] = ACTIONS(2893),
    [anon_sym_DOLLAR] = ACTIONS(2891),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2891),
    [sym_int] = ACTIONS(2891),
    [sym_xint] = ACTIONS(2893),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2893),
    [sym__newline] = ACTIONS(2893),
  },
  [2125] = {
    [sym_block_comment] = STATE(2125),
    [sym_compiler_directive_decl] = STATE(2125),
    [sym_fsi_directive_decl] = STATE(2125),
    [sym_preproc_line] = STATE(2125),
    [sym_identifier] = ACTIONS(2887),
    [anon_sym_EQ] = ACTIONS(2889),
    [anon_sym_COLON] = ACTIONS(2887),
    [anon_sym_return] = ACTIONS(2887),
    [anon_sym_do] = ACTIONS(2887),
    [anon_sym_let] = ACTIONS(2887),
    [anon_sym_let_BANG] = ACTIONS(2889),
    [anon_sym_LPAREN] = ACTIONS(2887),
    [anon_sym_COMMA] = ACTIONS(2889),
    [anon_sym_null] = ACTIONS(2887),
    [anon_sym_QMARK] = ACTIONS(2887),
    [anon_sym_COLON_QMARK] = ACTIONS(2887),
    [anon_sym_COLON_COLON] = ACTIONS(2889),
    [anon_sym_AMP] = ACTIONS(2887),
    [anon_sym_LBRACK] = ACTIONS(2887),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2889),
    [anon_sym_LBRACE] = ACTIONS(2887),
    [anon_sym_LT_AT] = ACTIONS(2887),
    [anon_sym_LT_AT_AT] = ACTIONS(2887),
    [anon_sym_DOT] = ACTIONS(2887),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2889),
    [anon_sym_new] = ACTIONS(2887),
    [anon_sym_return_BANG] = ACTIONS(2889),
    [anon_sym_yield] = ACTIONS(2887),
    [anon_sym_yield_BANG] = ACTIONS(2889),
    [anon_sym_lazy] = ACTIONS(2887),
    [anon_sym_assert] = ACTIONS(2887),
    [anon_sym_upcast] = ACTIONS(2887),
    [anon_sym_downcast] = ACTIONS(2887),
    [anon_sym_COLON_GT] = ACTIONS(2889),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2889),
    [anon_sym_for] = ACTIONS(2887),
    [anon_sym_while] = ACTIONS(2887),
    [anon_sym_if] = ACTIONS(2887),
    [anon_sym_fun] = ACTIONS(2887),
    [anon_sym_try] = ACTIONS(2887),
    [anon_sym_match] = ACTIONS(2887),
    [anon_sym_match_BANG] = ACTIONS(2889),
    [anon_sym_function] = ACTIONS(2887),
    [anon_sym_LT_DASH] = ACTIONS(2887),
    [anon_sym_DOT_LBRACK] = ACTIONS(2889),
    [anon_sym_LT] = ACTIONS(2889),
    [anon_sym_GT] = ACTIONS(2887),
    [anon_sym_use] = ACTIONS(2887),
    [anon_sym_use_BANG] = ACTIONS(2889),
    [anon_sym_do_BANG] = ACTIONS(2889),
    [anon_sym_begin] = ACTIONS(2887),
    [anon_sym_LPAREN2] = ACTIONS(2887),
    [anon_sym_or] = ACTIONS(2887),
    [aux_sym_char_token1] = ACTIONS(2889),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2887),
    [anon_sym_DQUOTE] = ACTIONS(2887),
    [anon_sym_AT_DQUOTE] = ACTIONS(2889),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2889),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2889),
    [sym_bool] = ACTIONS(2887),
    [sym_unit] = ACTIONS(2889),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2887),
    [sym_op_identifier] = ACTIONS(2887),
    [anon_sym_PLUS] = ACTIONS(2887),
    [anon_sym_DASH] = ACTIONS(2887),
    [anon_sym_PLUS_DOT] = ACTIONS(2887),
    [anon_sym_DASH_DOT] = ACTIONS(2887),
    [anon_sym_PERCENT] = ACTIONS(2887),
    [anon_sym_AMP_AMP] = ACTIONS(2887),
    [anon_sym_TILDE] = ACTIONS(2889),
    [aux_sym_prefix_op_token1] = ACTIONS(2887),
    [aux_sym_infix_op_token1] = ACTIONS(2889),
    [aux_sym_infix_op_token2] = ACTIONS(2887),
    [anon_sym_PIPE_PIPE] = ACTIONS(2887),
    [anon_sym_BANG_EQ] = ACTIONS(2887),
    [anon_sym_COLON_EQ] = ACTIONS(2889),
    [anon_sym_DOLLAR] = ACTIONS(2887),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2887),
    [sym_int] = ACTIONS(2887),
    [sym_xint] = ACTIONS(2889),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2889),
    [sym__newline] = ACTIONS(2889),
  },
  [2126] = {
    [sym_block_comment] = STATE(2126),
    [sym_compiler_directive_decl] = STATE(2126),
    [sym_fsi_directive_decl] = STATE(2126),
    [sym_preproc_line] = STATE(2126),
    [sym_identifier] = ACTIONS(2883),
    [anon_sym_EQ] = ACTIONS(2885),
    [anon_sym_COLON] = ACTIONS(2883),
    [anon_sym_return] = ACTIONS(2883),
    [anon_sym_do] = ACTIONS(2883),
    [anon_sym_let] = ACTIONS(2883),
    [anon_sym_let_BANG] = ACTIONS(2885),
    [anon_sym_LPAREN] = ACTIONS(2883),
    [anon_sym_COMMA] = ACTIONS(2885),
    [anon_sym_null] = ACTIONS(2883),
    [anon_sym_QMARK] = ACTIONS(2883),
    [anon_sym_COLON_QMARK] = ACTIONS(2883),
    [anon_sym_COLON_COLON] = ACTIONS(2885),
    [anon_sym_AMP] = ACTIONS(2883),
    [anon_sym_LBRACK] = ACTIONS(2883),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2885),
    [anon_sym_LBRACE] = ACTIONS(2883),
    [anon_sym_LT_AT] = ACTIONS(2883),
    [anon_sym_LT_AT_AT] = ACTIONS(2883),
    [anon_sym_DOT] = ACTIONS(2883),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2885),
    [anon_sym_new] = ACTIONS(2883),
    [anon_sym_return_BANG] = ACTIONS(2885),
    [anon_sym_yield] = ACTIONS(2883),
    [anon_sym_yield_BANG] = ACTIONS(2885),
    [anon_sym_lazy] = ACTIONS(2883),
    [anon_sym_assert] = ACTIONS(2883),
    [anon_sym_upcast] = ACTIONS(2883),
    [anon_sym_downcast] = ACTIONS(2883),
    [anon_sym_COLON_GT] = ACTIONS(2885),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2885),
    [anon_sym_for] = ACTIONS(2883),
    [anon_sym_while] = ACTIONS(2883),
    [anon_sym_if] = ACTIONS(2883),
    [anon_sym_fun] = ACTIONS(2883),
    [anon_sym_try] = ACTIONS(2883),
    [anon_sym_match] = ACTIONS(2883),
    [anon_sym_match_BANG] = ACTIONS(2885),
    [anon_sym_function] = ACTIONS(2883),
    [anon_sym_LT_DASH] = ACTIONS(2883),
    [anon_sym_DOT_LBRACK] = ACTIONS(2885),
    [anon_sym_LT] = ACTIONS(2885),
    [anon_sym_GT] = ACTIONS(2883),
    [anon_sym_use] = ACTIONS(2883),
    [anon_sym_use_BANG] = ACTIONS(2885),
    [anon_sym_do_BANG] = ACTIONS(2885),
    [anon_sym_begin] = ACTIONS(2883),
    [anon_sym_LPAREN2] = ACTIONS(2883),
    [anon_sym_or] = ACTIONS(2883),
    [aux_sym_char_token1] = ACTIONS(2885),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2883),
    [anon_sym_DQUOTE] = ACTIONS(2883),
    [anon_sym_AT_DQUOTE] = ACTIONS(2885),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2885),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2885),
    [sym_bool] = ACTIONS(2883),
    [sym_unit] = ACTIONS(2885),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2883),
    [sym_op_identifier] = ACTIONS(2883),
    [anon_sym_PLUS] = ACTIONS(2883),
    [anon_sym_DASH] = ACTIONS(2883),
    [anon_sym_PLUS_DOT] = ACTIONS(2883),
    [anon_sym_DASH_DOT] = ACTIONS(2883),
    [anon_sym_PERCENT] = ACTIONS(2883),
    [anon_sym_AMP_AMP] = ACTIONS(2883),
    [anon_sym_TILDE] = ACTIONS(2885),
    [aux_sym_prefix_op_token1] = ACTIONS(2883),
    [aux_sym_infix_op_token1] = ACTIONS(2885),
    [aux_sym_infix_op_token2] = ACTIONS(2883),
    [anon_sym_PIPE_PIPE] = ACTIONS(2883),
    [anon_sym_BANG_EQ] = ACTIONS(2883),
    [anon_sym_COLON_EQ] = ACTIONS(2885),
    [anon_sym_DOLLAR] = ACTIONS(2883),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2883),
    [sym_int] = ACTIONS(2883),
    [sym_xint] = ACTIONS(2885),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2885),
    [sym__newline] = ACTIONS(2885),
  },
  [2127] = {
    [sym_block_comment] = STATE(2127),
    [sym_compiler_directive_decl] = STATE(2127),
    [sym_fsi_directive_decl] = STATE(2127),
    [sym_preproc_line] = STATE(2127),
    [sym_identifier] = ACTIONS(2934),
    [anon_sym_EQ] = ACTIONS(2936),
    [anon_sym_COLON] = ACTIONS(2934),
    [anon_sym_return] = ACTIONS(2934),
    [anon_sym_do] = ACTIONS(2934),
    [anon_sym_let] = ACTIONS(2934),
    [anon_sym_let_BANG] = ACTIONS(2936),
    [anon_sym_LPAREN] = ACTIONS(2934),
    [anon_sym_COMMA] = ACTIONS(2936),
    [anon_sym_null] = ACTIONS(2934),
    [anon_sym_QMARK] = ACTIONS(2934),
    [anon_sym_COLON_QMARK] = ACTIONS(2934),
    [anon_sym_COLON_COLON] = ACTIONS(2936),
    [anon_sym_AMP] = ACTIONS(2934),
    [anon_sym_LBRACK] = ACTIONS(2934),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2936),
    [anon_sym_LBRACE] = ACTIONS(2934),
    [anon_sym_LT_AT] = ACTIONS(2934),
    [anon_sym_AT_GT] = ACTIONS(2934),
    [anon_sym_LT_AT_AT] = ACTIONS(2934),
    [anon_sym_DOT] = ACTIONS(2934),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2936),
    [anon_sym_new] = ACTIONS(2934),
    [anon_sym_return_BANG] = ACTIONS(2936),
    [anon_sym_yield] = ACTIONS(2934),
    [anon_sym_yield_BANG] = ACTIONS(2936),
    [anon_sym_lazy] = ACTIONS(2934),
    [anon_sym_assert] = ACTIONS(2934),
    [anon_sym_upcast] = ACTIONS(2934),
    [anon_sym_downcast] = ACTIONS(2934),
    [anon_sym_COLON_GT] = ACTIONS(2936),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2936),
    [anon_sym_for] = ACTIONS(2934),
    [anon_sym_while] = ACTIONS(2934),
    [anon_sym_if] = ACTIONS(2934),
    [anon_sym_fun] = ACTIONS(2934),
    [anon_sym_try] = ACTIONS(2934),
    [anon_sym_match] = ACTIONS(2934),
    [anon_sym_match_BANG] = ACTIONS(2936),
    [anon_sym_function] = ACTIONS(2934),
    [anon_sym_LT_DASH] = ACTIONS(2934),
    [anon_sym_DOT_LBRACK] = ACTIONS(2936),
    [anon_sym_LT] = ACTIONS(2936),
    [anon_sym_use] = ACTIONS(2934),
    [anon_sym_use_BANG] = ACTIONS(2936),
    [anon_sym_do_BANG] = ACTIONS(2936),
    [anon_sym_begin] = ACTIONS(2934),
    [anon_sym_LPAREN2] = ACTIONS(2934),
    [anon_sym_or] = ACTIONS(2934),
    [aux_sym_char_token1] = ACTIONS(2936),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2934),
    [anon_sym_DQUOTE] = ACTIONS(2934),
    [anon_sym_AT_DQUOTE] = ACTIONS(2936),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2936),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2936),
    [sym_bool] = ACTIONS(2934),
    [sym_unit] = ACTIONS(2936),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2934),
    [sym_op_identifier] = ACTIONS(2934),
    [anon_sym_PLUS] = ACTIONS(2934),
    [anon_sym_DASH] = ACTIONS(2934),
    [anon_sym_PLUS_DOT] = ACTIONS(2934),
    [anon_sym_DASH_DOT] = ACTIONS(2934),
    [anon_sym_PERCENT] = ACTIONS(2934),
    [anon_sym_AMP_AMP] = ACTIONS(2934),
    [anon_sym_TILDE] = ACTIONS(2936),
    [aux_sym_prefix_op_token1] = ACTIONS(2934),
    [aux_sym_infix_op_token1] = ACTIONS(2936),
    [aux_sym_infix_op_token2] = ACTIONS(2934),
    [anon_sym_PIPE_PIPE] = ACTIONS(2934),
    [anon_sym_BANG_EQ] = ACTIONS(2934),
    [anon_sym_COLON_EQ] = ACTIONS(2936),
    [anon_sym_DOLLAR] = ACTIONS(2934),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2934),
    [sym_int] = ACTIONS(2934),
    [sym_xint] = ACTIONS(2936),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2936),
    [sym__newline] = ACTIONS(2936),
  },
  [2128] = {
    [sym_block_comment] = STATE(2128),
    [sym_compiler_directive_decl] = STATE(2128),
    [sym_fsi_directive_decl] = STATE(2128),
    [sym_preproc_line] = STATE(2128),
    [sym_identifier] = ACTIONS(3079),
    [anon_sym_EQ] = ACTIONS(3081),
    [anon_sym_COLON] = ACTIONS(3079),
    [anon_sym_return] = ACTIONS(3079),
    [anon_sym_do] = ACTIONS(3079),
    [anon_sym_let] = ACTIONS(3079),
    [anon_sym_let_BANG] = ACTIONS(3081),
    [anon_sym_LPAREN] = ACTIONS(3079),
    [anon_sym_COMMA] = ACTIONS(3081),
    [anon_sym_null] = ACTIONS(3079),
    [anon_sym_QMARK] = ACTIONS(3079),
    [anon_sym_COLON_QMARK] = ACTIONS(3079),
    [anon_sym_COLON_COLON] = ACTIONS(3081),
    [anon_sym_AMP] = ACTIONS(3079),
    [anon_sym_LBRACK] = ACTIONS(3079),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3081),
    [anon_sym_LBRACE] = ACTIONS(3079),
    [anon_sym_LT_AT] = ACTIONS(3079),
    [anon_sym_LT_AT_AT] = ACTIONS(3079),
    [anon_sym_DOT] = ACTIONS(3079),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3081),
    [anon_sym_new] = ACTIONS(3079),
    [anon_sym_return_BANG] = ACTIONS(3081),
    [anon_sym_yield] = ACTIONS(3079),
    [anon_sym_yield_BANG] = ACTIONS(3081),
    [anon_sym_lazy] = ACTIONS(3079),
    [anon_sym_assert] = ACTIONS(3079),
    [anon_sym_upcast] = ACTIONS(3079),
    [anon_sym_downcast] = ACTIONS(3079),
    [anon_sym_COLON_GT] = ACTIONS(3081),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3081),
    [anon_sym_for] = ACTIONS(3079),
    [anon_sym_while] = ACTIONS(3079),
    [anon_sym_if] = ACTIONS(3079),
    [anon_sym_fun] = ACTIONS(3079),
    [anon_sym_try] = ACTIONS(3079),
    [anon_sym_match] = ACTIONS(3079),
    [anon_sym_match_BANG] = ACTIONS(3081),
    [anon_sym_function] = ACTIONS(3079),
    [anon_sym_LT_DASH] = ACTIONS(3079),
    [anon_sym_DOT_LBRACK] = ACTIONS(3081),
    [anon_sym_LT] = ACTIONS(3081),
    [anon_sym_GT] = ACTIONS(3079),
    [anon_sym_use] = ACTIONS(3079),
    [anon_sym_use_BANG] = ACTIONS(3081),
    [anon_sym_do_BANG] = ACTIONS(3081),
    [anon_sym_begin] = ACTIONS(3079),
    [anon_sym_LPAREN2] = ACTIONS(3079),
    [anon_sym_or] = ACTIONS(3079),
    [aux_sym_char_token1] = ACTIONS(3081),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3079),
    [anon_sym_DQUOTE] = ACTIONS(3079),
    [anon_sym_AT_DQUOTE] = ACTIONS(3081),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3081),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3081),
    [sym_bool] = ACTIONS(3079),
    [sym_unit] = ACTIONS(3081),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3079),
    [sym_op_identifier] = ACTIONS(3079),
    [anon_sym_PLUS] = ACTIONS(3079),
    [anon_sym_DASH] = ACTIONS(3079),
    [anon_sym_PLUS_DOT] = ACTIONS(3079),
    [anon_sym_DASH_DOT] = ACTIONS(3079),
    [anon_sym_PERCENT] = ACTIONS(3079),
    [anon_sym_AMP_AMP] = ACTIONS(3079),
    [anon_sym_TILDE] = ACTIONS(3081),
    [aux_sym_prefix_op_token1] = ACTIONS(3079),
    [aux_sym_infix_op_token1] = ACTIONS(3081),
    [aux_sym_infix_op_token2] = ACTIONS(3079),
    [anon_sym_PIPE_PIPE] = ACTIONS(3079),
    [anon_sym_BANG_EQ] = ACTIONS(3079),
    [anon_sym_COLON_EQ] = ACTIONS(3081),
    [anon_sym_DOLLAR] = ACTIONS(3079),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3079),
    [sym_int] = ACTIONS(3079),
    [sym_xint] = ACTIONS(3081),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3081),
    [sym__newline] = ACTIONS(3081),
  },
  [2129] = {
    [sym_attributes] = STATE(2689),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(3731),
    [sym__pattern] = STATE(3637),
    [sym_optional_pattern] = STATE(3731),
    [sym_type_check_pattern] = STATE(3731),
    [sym_attribute_pattern] = STATE(3731),
    [sym_paren_pattern] = STATE(3731),
    [sym_as_pattern] = STATE(3731),
    [sym_cons_pattern] = STATE(3731),
    [sym_disjunct_pattern] = STATE(3731),
    [sym_conjunct_pattern] = STATE(3731),
    [sym_typed_pattern] = STATE(3731),
    [sym_list_pattern] = STATE(3731),
    [sym_array_pattern] = STATE(3731),
    [sym_record_pattern] = STATE(3731),
    [sym_named_field_pattern] = STATE(3731),
    [sym_identifier_pattern] = STATE(3731),
    [sym_long_identifier_or_op] = STATE(2472),
    [sym_char] = STATE(3709),
    [sym_format_string] = STATE(3712),
    [sym__string_literal] = STATE(3712),
    [sym_string] = STATE(3709),
    [sym_verbatim_string] = STATE(3709),
    [sym_bytearray] = STATE(3709),
    [sym_verbatim_bytearray] = STATE(3709),
    [sym_format_triple_quoted_string] = STATE(3716),
    [sym_triple_quoted_string] = STATE(3709),
    [sym_const] = STATE(3731),
    [sym_long_identifier] = STATE(3655),
    [sym_active_pattern] = STATE(3734),
    [sym__identifier_or_op] = STATE(3737),
    [sym_sbyte] = STATE(3709),
    [sym_byte] = STATE(3709),
    [sym_int16] = STATE(3709),
    [sym_uint16] = STATE(3709),
    [sym_int32] = STATE(3709),
    [sym_uint32] = STATE(3709),
    [sym_nativeint] = STATE(3709),
    [sym_unativeint] = STATE(3709),
    [sym_int64] = STATE(3709),
    [sym_uint64] = STATE(3709),
    [sym_ieee32] = STATE(3709),
    [sym_ieee64] = STATE(3709),
    [sym_bignum] = STATE(3709),
    [sym_decimal] = STATE(3709),
    [sym_float] = STATE(3489),
    [sym_block_comment] = STATE(2129),
    [sym_compiler_directive_decl] = STATE(2129),
    [sym_fsi_directive_decl] = STATE(2129),
    [sym_preproc_line] = STATE(2129),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [aux_sym_repeat_pattern_repeat1] = STATE(3687),
    [sym_identifier] = ACTIONS(3716),
    [anon_sym_LBRACK_LT] = ACTIONS(3714),
    [anon_sym_COLON] = ACTIONS(3716),
    [anon_sym_as] = ACTIONS(4198),
    [anon_sym_LPAREN] = ACTIONS(3716),
    [anon_sym_COMMA] = ACTIONS(4200),
    [anon_sym_null] = ACTIONS(3716),
    [anon_sym__] = ACTIONS(3716),
    [anon_sym_QMARK] = ACTIONS(3714),
    [anon_sym_COLON_QMARK] = ACTIONS(3714),
    [anon_sym_COLON_COLON] = ACTIONS(4206),
    [anon_sym_PIPE] = ACTIONS(4208),
    [anon_sym_AMP] = ACTIONS(4210),
    [anon_sym_LBRACK] = ACTIONS(3716),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3714),
    [anon_sym_LBRACE] = ACTIONS(3714),
    [anon_sym_in] = ACTIONS(3716),
    [aux_sym_char_token1] = ACTIONS(3714),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3716),
    [anon_sym_DQUOTE] = ACTIONS(3716),
    [anon_sym_AT_DQUOTE] = ACTIONS(3714),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3714),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3714),
    [sym_bool] = ACTIONS(3716),
    [sym_unit] = ACTIONS(3714),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3716),
    [sym_op_identifier] = ACTIONS(3714),
    [sym_int] = ACTIONS(3716),
    [sym_xint] = ACTIONS(3714),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2130] = {
    [sym_block_comment] = STATE(2130),
    [sym_compiler_directive_decl] = STATE(2130),
    [sym_fsi_directive_decl] = STATE(2130),
    [sym_preproc_line] = STATE(2130),
    [sym_identifier] = ACTIONS(2877),
    [anon_sym_EQ] = ACTIONS(2879),
    [anon_sym_COLON] = ACTIONS(2877),
    [anon_sym_return] = ACTIONS(2877),
    [anon_sym_do] = ACTIONS(2877),
    [anon_sym_let] = ACTIONS(2877),
    [anon_sym_let_BANG] = ACTIONS(2879),
    [anon_sym_LPAREN] = ACTIONS(2877),
    [anon_sym_COMMA] = ACTIONS(2879),
    [anon_sym_null] = ACTIONS(2877),
    [anon_sym_QMARK] = ACTIONS(2877),
    [anon_sym_COLON_QMARK] = ACTIONS(2877),
    [anon_sym_COLON_COLON] = ACTIONS(2879),
    [anon_sym_AMP] = ACTIONS(2877),
    [anon_sym_LBRACK] = ACTIONS(2877),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2879),
    [anon_sym_LBRACE] = ACTIONS(2877),
    [anon_sym_LT_AT] = ACTIONS(2877),
    [anon_sym_LT_AT_AT] = ACTIONS(2877),
    [anon_sym_DOT] = ACTIONS(2877),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2879),
    [anon_sym_new] = ACTIONS(2877),
    [anon_sym_return_BANG] = ACTIONS(2879),
    [anon_sym_yield] = ACTIONS(2877),
    [anon_sym_yield_BANG] = ACTIONS(2879),
    [anon_sym_lazy] = ACTIONS(2877),
    [anon_sym_assert] = ACTIONS(2877),
    [anon_sym_upcast] = ACTIONS(2877),
    [anon_sym_downcast] = ACTIONS(2877),
    [anon_sym_COLON_GT] = ACTIONS(2879),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2879),
    [anon_sym_for] = ACTIONS(2877),
    [anon_sym_while] = ACTIONS(2877),
    [anon_sym_if] = ACTIONS(2877),
    [anon_sym_fun] = ACTIONS(2877),
    [anon_sym_try] = ACTIONS(2877),
    [anon_sym_match] = ACTIONS(2877),
    [anon_sym_match_BANG] = ACTIONS(2879),
    [anon_sym_function] = ACTIONS(2877),
    [anon_sym_LT_DASH] = ACTIONS(2877),
    [anon_sym_DOT_LBRACK] = ACTIONS(2879),
    [anon_sym_LT] = ACTIONS(2879),
    [anon_sym_GT] = ACTIONS(2877),
    [anon_sym_use] = ACTIONS(2877),
    [anon_sym_use_BANG] = ACTIONS(2879),
    [anon_sym_do_BANG] = ACTIONS(2879),
    [anon_sym_begin] = ACTIONS(2877),
    [anon_sym_LPAREN2] = ACTIONS(2877),
    [anon_sym_or] = ACTIONS(2877),
    [aux_sym_char_token1] = ACTIONS(2879),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2877),
    [anon_sym_DQUOTE] = ACTIONS(2877),
    [anon_sym_AT_DQUOTE] = ACTIONS(2879),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2879),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2879),
    [sym_bool] = ACTIONS(2877),
    [sym_unit] = ACTIONS(2879),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2877),
    [sym_op_identifier] = ACTIONS(2877),
    [anon_sym_PLUS] = ACTIONS(2877),
    [anon_sym_DASH] = ACTIONS(2877),
    [anon_sym_PLUS_DOT] = ACTIONS(2877),
    [anon_sym_DASH_DOT] = ACTIONS(2877),
    [anon_sym_PERCENT] = ACTIONS(2877),
    [anon_sym_AMP_AMP] = ACTIONS(2877),
    [anon_sym_TILDE] = ACTIONS(2879),
    [aux_sym_prefix_op_token1] = ACTIONS(2877),
    [aux_sym_infix_op_token1] = ACTIONS(2879),
    [aux_sym_infix_op_token2] = ACTIONS(2877),
    [anon_sym_PIPE_PIPE] = ACTIONS(2877),
    [anon_sym_BANG_EQ] = ACTIONS(2877),
    [anon_sym_COLON_EQ] = ACTIONS(2879),
    [anon_sym_DOLLAR] = ACTIONS(2877),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2877),
    [sym_int] = ACTIONS(2877),
    [sym_xint] = ACTIONS(2879),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2879),
    [sym__newline] = ACTIONS(2879),
  },
  [2131] = {
    [sym_block_comment] = STATE(2131),
    [sym_compiler_directive_decl] = STATE(2131),
    [sym_fsi_directive_decl] = STATE(2131),
    [sym_preproc_line] = STATE(2131),
    [sym_identifier] = ACTIONS(2873),
    [anon_sym_EQ] = ACTIONS(2875),
    [anon_sym_COLON] = ACTIONS(2873),
    [anon_sym_return] = ACTIONS(2873),
    [anon_sym_do] = ACTIONS(2873),
    [anon_sym_let] = ACTIONS(2873),
    [anon_sym_let_BANG] = ACTIONS(2875),
    [anon_sym_LPAREN] = ACTIONS(2873),
    [anon_sym_COMMA] = ACTIONS(2875),
    [anon_sym_null] = ACTIONS(2873),
    [anon_sym_QMARK] = ACTIONS(2873),
    [anon_sym_COLON_QMARK] = ACTIONS(2873),
    [anon_sym_COLON_COLON] = ACTIONS(2875),
    [anon_sym_AMP] = ACTIONS(2873),
    [anon_sym_LBRACK] = ACTIONS(2873),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2875),
    [anon_sym_LBRACE] = ACTIONS(2873),
    [anon_sym_LT_AT] = ACTIONS(2873),
    [anon_sym_LT_AT_AT] = ACTIONS(2873),
    [anon_sym_DOT] = ACTIONS(2873),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2875),
    [anon_sym_new] = ACTIONS(2873),
    [anon_sym_return_BANG] = ACTIONS(2875),
    [anon_sym_yield] = ACTIONS(2873),
    [anon_sym_yield_BANG] = ACTIONS(2875),
    [anon_sym_lazy] = ACTIONS(2873),
    [anon_sym_assert] = ACTIONS(2873),
    [anon_sym_upcast] = ACTIONS(2873),
    [anon_sym_downcast] = ACTIONS(2873),
    [anon_sym_COLON_GT] = ACTIONS(2875),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2875),
    [anon_sym_for] = ACTIONS(2873),
    [anon_sym_while] = ACTIONS(2873),
    [anon_sym_if] = ACTIONS(2873),
    [anon_sym_fun] = ACTIONS(2873),
    [anon_sym_try] = ACTIONS(2873),
    [anon_sym_match] = ACTIONS(2873),
    [anon_sym_match_BANG] = ACTIONS(2875),
    [anon_sym_function] = ACTIONS(2873),
    [anon_sym_LT_DASH] = ACTIONS(2873),
    [anon_sym_DOT_LBRACK] = ACTIONS(2875),
    [anon_sym_LT] = ACTIONS(2875),
    [anon_sym_GT] = ACTIONS(2873),
    [anon_sym_use] = ACTIONS(2873),
    [anon_sym_use_BANG] = ACTIONS(2875),
    [anon_sym_do_BANG] = ACTIONS(2875),
    [anon_sym_begin] = ACTIONS(2873),
    [anon_sym_LPAREN2] = ACTIONS(2873),
    [anon_sym_or] = ACTIONS(2873),
    [aux_sym_char_token1] = ACTIONS(2875),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2873),
    [anon_sym_DQUOTE] = ACTIONS(2873),
    [anon_sym_AT_DQUOTE] = ACTIONS(2875),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2875),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2875),
    [sym_bool] = ACTIONS(2873),
    [sym_unit] = ACTIONS(2875),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2873),
    [sym_op_identifier] = ACTIONS(2873),
    [anon_sym_PLUS] = ACTIONS(2873),
    [anon_sym_DASH] = ACTIONS(2873),
    [anon_sym_PLUS_DOT] = ACTIONS(2873),
    [anon_sym_DASH_DOT] = ACTIONS(2873),
    [anon_sym_PERCENT] = ACTIONS(2873),
    [anon_sym_AMP_AMP] = ACTIONS(2873),
    [anon_sym_TILDE] = ACTIONS(2875),
    [aux_sym_prefix_op_token1] = ACTIONS(2873),
    [aux_sym_infix_op_token1] = ACTIONS(2875),
    [aux_sym_infix_op_token2] = ACTIONS(2873),
    [anon_sym_PIPE_PIPE] = ACTIONS(2873),
    [anon_sym_BANG_EQ] = ACTIONS(2873),
    [anon_sym_COLON_EQ] = ACTIONS(2875),
    [anon_sym_DOLLAR] = ACTIONS(2873),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2873),
    [sym_int] = ACTIONS(2873),
    [sym_xint] = ACTIONS(2875),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2875),
    [sym__newline] = ACTIONS(2875),
  },
  [2132] = {
    [sym_block_comment] = STATE(2132),
    [sym_compiler_directive_decl] = STATE(2132),
    [sym_fsi_directive_decl] = STATE(2132),
    [sym_preproc_line] = STATE(2132),
    [sym_identifier] = ACTIONS(2873),
    [anon_sym_EQ] = ACTIONS(2875),
    [anon_sym_COLON] = ACTIONS(2873),
    [anon_sym_return] = ACTIONS(2873),
    [anon_sym_do] = ACTIONS(2873),
    [anon_sym_let] = ACTIONS(2873),
    [anon_sym_let_BANG] = ACTIONS(2875),
    [anon_sym_LPAREN] = ACTIONS(2873),
    [anon_sym_COMMA] = ACTIONS(2875),
    [anon_sym_null] = ACTIONS(2873),
    [anon_sym_QMARK] = ACTIONS(2873),
    [anon_sym_COLON_QMARK] = ACTIONS(2873),
    [anon_sym_COLON_COLON] = ACTIONS(2875),
    [anon_sym_AMP] = ACTIONS(2873),
    [anon_sym_LBRACK] = ACTIONS(2873),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2875),
    [anon_sym_LBRACE] = ACTIONS(2873),
    [anon_sym_LT_AT] = ACTIONS(2873),
    [anon_sym_LT_AT_AT] = ACTIONS(2873),
    [anon_sym_DOT] = ACTIONS(2873),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2875),
    [anon_sym_new] = ACTIONS(2873),
    [anon_sym_return_BANG] = ACTIONS(2875),
    [anon_sym_yield] = ACTIONS(2873),
    [anon_sym_yield_BANG] = ACTIONS(2875),
    [anon_sym_lazy] = ACTIONS(2873),
    [anon_sym_assert] = ACTIONS(2873),
    [anon_sym_upcast] = ACTIONS(2873),
    [anon_sym_downcast] = ACTIONS(2873),
    [anon_sym_COLON_GT] = ACTIONS(2875),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2875),
    [anon_sym_for] = ACTIONS(2873),
    [anon_sym_while] = ACTIONS(2873),
    [anon_sym_if] = ACTIONS(2873),
    [anon_sym_fun] = ACTIONS(2873),
    [anon_sym_try] = ACTIONS(2873),
    [anon_sym_match] = ACTIONS(2873),
    [anon_sym_match_BANG] = ACTIONS(2875),
    [anon_sym_function] = ACTIONS(2873),
    [anon_sym_LT_DASH] = ACTIONS(2873),
    [anon_sym_DOT_LBRACK] = ACTIONS(2875),
    [anon_sym_LT] = ACTIONS(2875),
    [anon_sym_use] = ACTIONS(2873),
    [anon_sym_use_BANG] = ACTIONS(2875),
    [anon_sym_do_BANG] = ACTIONS(2875),
    [anon_sym_DOT_DOT] = ACTIONS(2875),
    [anon_sym_begin] = ACTIONS(2873),
    [anon_sym_LPAREN2] = ACTIONS(2873),
    [anon_sym_or] = ACTIONS(2873),
    [aux_sym_char_token1] = ACTIONS(2875),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2873),
    [anon_sym_DQUOTE] = ACTIONS(2873),
    [anon_sym_AT_DQUOTE] = ACTIONS(2875),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2875),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2875),
    [sym_bool] = ACTIONS(2873),
    [sym_unit] = ACTIONS(2875),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2873),
    [sym_op_identifier] = ACTIONS(2873),
    [anon_sym_PLUS] = ACTIONS(2873),
    [anon_sym_DASH] = ACTIONS(2873),
    [anon_sym_PLUS_DOT] = ACTIONS(2873),
    [anon_sym_DASH_DOT] = ACTIONS(2873),
    [anon_sym_PERCENT] = ACTIONS(2873),
    [anon_sym_AMP_AMP] = ACTIONS(2873),
    [anon_sym_TILDE] = ACTIONS(2875),
    [aux_sym_prefix_op_token1] = ACTIONS(2873),
    [aux_sym_infix_op_token1] = ACTIONS(2875),
    [aux_sym_infix_op_token2] = ACTIONS(2873),
    [anon_sym_PIPE_PIPE] = ACTIONS(2873),
    [anon_sym_BANG_EQ] = ACTIONS(2873),
    [anon_sym_COLON_EQ] = ACTIONS(2875),
    [anon_sym_DOLLAR] = ACTIONS(2873),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2873),
    [sym_int] = ACTIONS(2873),
    [sym_xint] = ACTIONS(2875),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2875),
    [sym__newline] = ACTIONS(2875),
  },
  [2133] = {
    [sym_block_comment] = STATE(2133),
    [sym_compiler_directive_decl] = STATE(2133),
    [sym_fsi_directive_decl] = STATE(2133),
    [sym_preproc_line] = STATE(2133),
    [sym_identifier] = ACTIONS(3083),
    [anon_sym_EQ] = ACTIONS(3085),
    [anon_sym_COLON] = ACTIONS(3083),
    [anon_sym_return] = ACTIONS(3083),
    [anon_sym_do] = ACTIONS(3083),
    [anon_sym_let] = ACTIONS(3083),
    [anon_sym_let_BANG] = ACTIONS(3085),
    [anon_sym_LPAREN] = ACTIONS(3083),
    [anon_sym_COMMA] = ACTIONS(3085),
    [anon_sym_null] = ACTIONS(3083),
    [anon_sym_QMARK] = ACTIONS(3083),
    [anon_sym_COLON_QMARK] = ACTIONS(3083),
    [anon_sym_COLON_COLON] = ACTIONS(3085),
    [anon_sym_AMP] = ACTIONS(3083),
    [anon_sym_LBRACK] = ACTIONS(3083),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3085),
    [anon_sym_LBRACE] = ACTIONS(3083),
    [anon_sym_LT_AT] = ACTIONS(3083),
    [anon_sym_LT_AT_AT] = ACTIONS(3083),
    [anon_sym_DOT] = ACTIONS(3083),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3085),
    [anon_sym_new] = ACTIONS(3083),
    [anon_sym_return_BANG] = ACTIONS(3085),
    [anon_sym_yield] = ACTIONS(3083),
    [anon_sym_yield_BANG] = ACTIONS(3085),
    [anon_sym_lazy] = ACTIONS(3083),
    [anon_sym_assert] = ACTIONS(3083),
    [anon_sym_upcast] = ACTIONS(3083),
    [anon_sym_downcast] = ACTIONS(3083),
    [anon_sym_COLON_GT] = ACTIONS(3085),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3085),
    [anon_sym_for] = ACTIONS(3083),
    [anon_sym_while] = ACTIONS(3083),
    [anon_sym_if] = ACTIONS(3083),
    [anon_sym_fun] = ACTIONS(3083),
    [anon_sym_try] = ACTIONS(3083),
    [anon_sym_match] = ACTIONS(3083),
    [anon_sym_match_BANG] = ACTIONS(3085),
    [anon_sym_function] = ACTIONS(3083),
    [anon_sym_LT_DASH] = ACTIONS(3083),
    [anon_sym_DOT_LBRACK] = ACTIONS(3085),
    [anon_sym_LT] = ACTIONS(3085),
    [anon_sym_GT] = ACTIONS(3083),
    [anon_sym_use] = ACTIONS(3083),
    [anon_sym_use_BANG] = ACTIONS(3085),
    [anon_sym_do_BANG] = ACTIONS(3085),
    [anon_sym_begin] = ACTIONS(3083),
    [anon_sym_LPAREN2] = ACTIONS(3083),
    [anon_sym_or] = ACTIONS(3083),
    [aux_sym_char_token1] = ACTIONS(3085),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3083),
    [anon_sym_DQUOTE] = ACTIONS(3083),
    [anon_sym_AT_DQUOTE] = ACTIONS(3085),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3085),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3085),
    [sym_bool] = ACTIONS(3083),
    [sym_unit] = ACTIONS(3085),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3083),
    [sym_op_identifier] = ACTIONS(3083),
    [anon_sym_PLUS] = ACTIONS(3083),
    [anon_sym_DASH] = ACTIONS(3083),
    [anon_sym_PLUS_DOT] = ACTIONS(3083),
    [anon_sym_DASH_DOT] = ACTIONS(3083),
    [anon_sym_PERCENT] = ACTIONS(3083),
    [anon_sym_AMP_AMP] = ACTIONS(3083),
    [anon_sym_TILDE] = ACTIONS(3085),
    [aux_sym_prefix_op_token1] = ACTIONS(3083),
    [aux_sym_infix_op_token1] = ACTIONS(3085),
    [aux_sym_infix_op_token2] = ACTIONS(3083),
    [anon_sym_PIPE_PIPE] = ACTIONS(3083),
    [anon_sym_BANG_EQ] = ACTIONS(3083),
    [anon_sym_COLON_EQ] = ACTIONS(3085),
    [anon_sym_DOLLAR] = ACTIONS(3083),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3083),
    [sym_int] = ACTIONS(3083),
    [sym_xint] = ACTIONS(3085),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3085),
    [sym__newline] = ACTIONS(3085),
  },
  [2134] = {
    [sym_block_comment] = STATE(2134),
    [sym_compiler_directive_decl] = STATE(2134),
    [sym_fsi_directive_decl] = STATE(2134),
    [sym_preproc_line] = STATE(2134),
    [sym_identifier] = ACTIONS(3099),
    [anon_sym_EQ] = ACTIONS(3101),
    [anon_sym_COLON] = ACTIONS(3099),
    [anon_sym_return] = ACTIONS(3099),
    [anon_sym_do] = ACTIONS(3099),
    [anon_sym_let] = ACTIONS(3099),
    [anon_sym_let_BANG] = ACTIONS(3101),
    [anon_sym_LPAREN] = ACTIONS(3099),
    [anon_sym_COMMA] = ACTIONS(3101),
    [anon_sym_null] = ACTIONS(3099),
    [anon_sym_QMARK] = ACTIONS(3099),
    [anon_sym_COLON_QMARK] = ACTIONS(3099),
    [anon_sym_COLON_COLON] = ACTIONS(3101),
    [anon_sym_AMP] = ACTIONS(3099),
    [anon_sym_LBRACK] = ACTIONS(3099),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3101),
    [anon_sym_LBRACE] = ACTIONS(3099),
    [anon_sym_LT_AT] = ACTIONS(3099),
    [anon_sym_LT_AT_AT] = ACTIONS(3099),
    [anon_sym_DOT] = ACTIONS(3099),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3101),
    [anon_sym_new] = ACTIONS(3099),
    [anon_sym_return_BANG] = ACTIONS(3101),
    [anon_sym_yield] = ACTIONS(3099),
    [anon_sym_yield_BANG] = ACTIONS(3101),
    [anon_sym_lazy] = ACTIONS(3099),
    [anon_sym_assert] = ACTIONS(3099),
    [anon_sym_upcast] = ACTIONS(3099),
    [anon_sym_downcast] = ACTIONS(3099),
    [anon_sym_COLON_GT] = ACTIONS(3101),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3101),
    [anon_sym_for] = ACTIONS(3099),
    [anon_sym_while] = ACTIONS(3099),
    [anon_sym_if] = ACTIONS(3099),
    [anon_sym_fun] = ACTIONS(3099),
    [anon_sym_try] = ACTIONS(3099),
    [anon_sym_match] = ACTIONS(3099),
    [anon_sym_match_BANG] = ACTIONS(3101),
    [anon_sym_function] = ACTIONS(3099),
    [anon_sym_LT_DASH] = ACTIONS(3099),
    [anon_sym_DOT_LBRACK] = ACTIONS(3101),
    [anon_sym_LT] = ACTIONS(3101),
    [anon_sym_GT] = ACTIONS(3099),
    [anon_sym_use] = ACTIONS(3099),
    [anon_sym_use_BANG] = ACTIONS(3101),
    [anon_sym_do_BANG] = ACTIONS(3101),
    [anon_sym_begin] = ACTIONS(3099),
    [anon_sym_LPAREN2] = ACTIONS(3099),
    [anon_sym_or] = ACTIONS(3099),
    [aux_sym_char_token1] = ACTIONS(3101),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3099),
    [anon_sym_DQUOTE] = ACTIONS(3099),
    [anon_sym_AT_DQUOTE] = ACTIONS(3101),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3101),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3101),
    [sym_bool] = ACTIONS(3099),
    [sym_unit] = ACTIONS(3101),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3099),
    [sym_op_identifier] = ACTIONS(3099),
    [anon_sym_PLUS] = ACTIONS(3099),
    [anon_sym_DASH] = ACTIONS(3099),
    [anon_sym_PLUS_DOT] = ACTIONS(3099),
    [anon_sym_DASH_DOT] = ACTIONS(3099),
    [anon_sym_PERCENT] = ACTIONS(3099),
    [anon_sym_AMP_AMP] = ACTIONS(3099),
    [anon_sym_TILDE] = ACTIONS(3101),
    [aux_sym_prefix_op_token1] = ACTIONS(3099),
    [aux_sym_infix_op_token1] = ACTIONS(3101),
    [aux_sym_infix_op_token2] = ACTIONS(3099),
    [anon_sym_PIPE_PIPE] = ACTIONS(3099),
    [anon_sym_BANG_EQ] = ACTIONS(3099),
    [anon_sym_COLON_EQ] = ACTIONS(3101),
    [anon_sym_DOLLAR] = ACTIONS(3099),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3099),
    [sym_int] = ACTIONS(3099),
    [sym_xint] = ACTIONS(3101),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3101),
    [sym__newline] = ACTIONS(3101),
  },
  [2135] = {
    [sym_block_comment] = STATE(2135),
    [sym_compiler_directive_decl] = STATE(2135),
    [sym_fsi_directive_decl] = STATE(2135),
    [sym_preproc_line] = STATE(2135),
    [sym_identifier] = ACTIONS(2942),
    [anon_sym_EQ] = ACTIONS(2944),
    [anon_sym_COLON] = ACTIONS(2942),
    [anon_sym_return] = ACTIONS(2942),
    [anon_sym_do] = ACTIONS(2942),
    [anon_sym_let] = ACTIONS(2942),
    [anon_sym_let_BANG] = ACTIONS(2944),
    [anon_sym_LPAREN] = ACTIONS(2942),
    [anon_sym_COMMA] = ACTIONS(2944),
    [anon_sym_null] = ACTIONS(2942),
    [anon_sym_QMARK] = ACTIONS(2942),
    [anon_sym_COLON_QMARK] = ACTIONS(2942),
    [anon_sym_COLON_COLON] = ACTIONS(2944),
    [anon_sym_AMP] = ACTIONS(2942),
    [anon_sym_LBRACK] = ACTIONS(2942),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2944),
    [anon_sym_LBRACE] = ACTIONS(2942),
    [anon_sym_LT_AT] = ACTIONS(2942),
    [anon_sym_LT_AT_AT] = ACTIONS(2942),
    [anon_sym_AT_AT_GT] = ACTIONS(2942),
    [anon_sym_DOT] = ACTIONS(2942),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2944),
    [anon_sym_new] = ACTIONS(2942),
    [anon_sym_return_BANG] = ACTIONS(2944),
    [anon_sym_yield] = ACTIONS(2942),
    [anon_sym_yield_BANG] = ACTIONS(2944),
    [anon_sym_lazy] = ACTIONS(2942),
    [anon_sym_assert] = ACTIONS(2942),
    [anon_sym_upcast] = ACTIONS(2942),
    [anon_sym_downcast] = ACTIONS(2942),
    [anon_sym_COLON_GT] = ACTIONS(2944),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2944),
    [anon_sym_for] = ACTIONS(2942),
    [anon_sym_while] = ACTIONS(2942),
    [anon_sym_if] = ACTIONS(2942),
    [anon_sym_fun] = ACTIONS(2942),
    [anon_sym_try] = ACTIONS(2942),
    [anon_sym_match] = ACTIONS(2942),
    [anon_sym_match_BANG] = ACTIONS(2944),
    [anon_sym_function] = ACTIONS(2942),
    [anon_sym_LT_DASH] = ACTIONS(2942),
    [anon_sym_DOT_LBRACK] = ACTIONS(2944),
    [anon_sym_LT] = ACTIONS(2944),
    [anon_sym_use] = ACTIONS(2942),
    [anon_sym_use_BANG] = ACTIONS(2944),
    [anon_sym_do_BANG] = ACTIONS(2944),
    [anon_sym_begin] = ACTIONS(2942),
    [anon_sym_LPAREN2] = ACTIONS(2942),
    [anon_sym_or] = ACTIONS(2942),
    [aux_sym_char_token1] = ACTIONS(2944),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2942),
    [anon_sym_DQUOTE] = ACTIONS(2942),
    [anon_sym_AT_DQUOTE] = ACTIONS(2944),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2944),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2944),
    [sym_bool] = ACTIONS(2942),
    [sym_unit] = ACTIONS(2944),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2942),
    [sym_op_identifier] = ACTIONS(2942),
    [anon_sym_PLUS] = ACTIONS(2942),
    [anon_sym_DASH] = ACTIONS(2942),
    [anon_sym_PLUS_DOT] = ACTIONS(2942),
    [anon_sym_DASH_DOT] = ACTIONS(2942),
    [anon_sym_PERCENT] = ACTIONS(2942),
    [anon_sym_AMP_AMP] = ACTIONS(2942),
    [anon_sym_TILDE] = ACTIONS(2944),
    [aux_sym_prefix_op_token1] = ACTIONS(2942),
    [aux_sym_infix_op_token1] = ACTIONS(2944),
    [aux_sym_infix_op_token2] = ACTIONS(2942),
    [anon_sym_PIPE_PIPE] = ACTIONS(2942),
    [anon_sym_BANG_EQ] = ACTIONS(2942),
    [anon_sym_COLON_EQ] = ACTIONS(2944),
    [anon_sym_DOLLAR] = ACTIONS(2942),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2942),
    [sym_int] = ACTIONS(2942),
    [sym_xint] = ACTIONS(2944),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2944),
    [sym__newline] = ACTIONS(2944),
  },
  [2136] = {
    [sym_block_comment] = STATE(2136),
    [sym_compiler_directive_decl] = STATE(2136),
    [sym_fsi_directive_decl] = STATE(2136),
    [sym_preproc_line] = STATE(2136),
    [sym_identifier] = ACTIONS(3035),
    [anon_sym_EQ] = ACTIONS(3037),
    [anon_sym_COLON] = ACTIONS(3035),
    [anon_sym_return] = ACTIONS(3035),
    [anon_sym_do] = ACTIONS(3035),
    [anon_sym_let] = ACTIONS(3035),
    [anon_sym_let_BANG] = ACTIONS(3037),
    [anon_sym_LPAREN] = ACTIONS(3035),
    [anon_sym_COMMA] = ACTIONS(3037),
    [anon_sym_null] = ACTIONS(3035),
    [anon_sym_QMARK] = ACTIONS(3035),
    [anon_sym_COLON_QMARK] = ACTIONS(3035),
    [anon_sym_COLON_COLON] = ACTIONS(3037),
    [anon_sym_AMP] = ACTIONS(3035),
    [anon_sym_LBRACK] = ACTIONS(3035),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3037),
    [anon_sym_LBRACE] = ACTIONS(3035),
    [anon_sym_LT_AT] = ACTIONS(3035),
    [anon_sym_AT_GT] = ACTIONS(3035),
    [anon_sym_LT_AT_AT] = ACTIONS(3035),
    [anon_sym_DOT] = ACTIONS(3035),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3037),
    [anon_sym_new] = ACTIONS(3035),
    [anon_sym_return_BANG] = ACTIONS(3037),
    [anon_sym_yield] = ACTIONS(3035),
    [anon_sym_yield_BANG] = ACTIONS(3037),
    [anon_sym_lazy] = ACTIONS(3035),
    [anon_sym_assert] = ACTIONS(3035),
    [anon_sym_upcast] = ACTIONS(3035),
    [anon_sym_downcast] = ACTIONS(3035),
    [anon_sym_COLON_GT] = ACTIONS(3037),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3037),
    [anon_sym_for] = ACTIONS(3035),
    [anon_sym_while] = ACTIONS(3035),
    [anon_sym_if] = ACTIONS(3035),
    [anon_sym_fun] = ACTIONS(3035),
    [anon_sym_try] = ACTIONS(3035),
    [anon_sym_match] = ACTIONS(3035),
    [anon_sym_match_BANG] = ACTIONS(3037),
    [anon_sym_function] = ACTIONS(3035),
    [anon_sym_LT_DASH] = ACTIONS(3035),
    [anon_sym_DOT_LBRACK] = ACTIONS(3037),
    [anon_sym_LT] = ACTIONS(3037),
    [anon_sym_use] = ACTIONS(3035),
    [anon_sym_use_BANG] = ACTIONS(3037),
    [anon_sym_do_BANG] = ACTIONS(3037),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_LPAREN2] = ACTIONS(3035),
    [anon_sym_or] = ACTIONS(3035),
    [aux_sym_char_token1] = ACTIONS(3037),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3035),
    [anon_sym_DQUOTE] = ACTIONS(3035),
    [anon_sym_AT_DQUOTE] = ACTIONS(3037),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3037),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3037),
    [sym_bool] = ACTIONS(3035),
    [sym_unit] = ACTIONS(3037),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3035),
    [sym_op_identifier] = ACTIONS(3035),
    [anon_sym_PLUS] = ACTIONS(3035),
    [anon_sym_DASH] = ACTIONS(3035),
    [anon_sym_PLUS_DOT] = ACTIONS(3035),
    [anon_sym_DASH_DOT] = ACTIONS(3035),
    [anon_sym_PERCENT] = ACTIONS(3035),
    [anon_sym_AMP_AMP] = ACTIONS(3035),
    [anon_sym_TILDE] = ACTIONS(3037),
    [aux_sym_prefix_op_token1] = ACTIONS(3035),
    [aux_sym_infix_op_token1] = ACTIONS(3037),
    [aux_sym_infix_op_token2] = ACTIONS(3035),
    [anon_sym_PIPE_PIPE] = ACTIONS(3035),
    [anon_sym_BANG_EQ] = ACTIONS(3035),
    [anon_sym_COLON_EQ] = ACTIONS(3037),
    [anon_sym_DOLLAR] = ACTIONS(3035),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3035),
    [sym_int] = ACTIONS(3035),
    [sym_xint] = ACTIONS(3037),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3037),
    [sym__newline] = ACTIONS(3037),
  },
  [2137] = {
    [sym_block_comment] = STATE(2137),
    [sym_compiler_directive_decl] = STATE(2137),
    [sym_fsi_directive_decl] = STATE(2137),
    [sym_preproc_line] = STATE(2137),
    [sym_identifier] = ACTIONS(3031),
    [anon_sym_EQ] = ACTIONS(3033),
    [anon_sym_COLON] = ACTIONS(3031),
    [anon_sym_return] = ACTIONS(3031),
    [anon_sym_do] = ACTIONS(3031),
    [anon_sym_let] = ACTIONS(3031),
    [anon_sym_let_BANG] = ACTIONS(3033),
    [anon_sym_LPAREN] = ACTIONS(3031),
    [anon_sym_COMMA] = ACTIONS(3033),
    [anon_sym_null] = ACTIONS(3031),
    [anon_sym_QMARK] = ACTIONS(3031),
    [anon_sym_COLON_QMARK] = ACTIONS(3031),
    [anon_sym_COLON_COLON] = ACTIONS(3033),
    [anon_sym_AMP] = ACTIONS(3031),
    [anon_sym_LBRACK] = ACTIONS(3031),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3033),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [anon_sym_LT_AT] = ACTIONS(3031),
    [anon_sym_AT_GT] = ACTIONS(3031),
    [anon_sym_LT_AT_AT] = ACTIONS(3031),
    [anon_sym_DOT] = ACTIONS(3031),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3033),
    [anon_sym_new] = ACTIONS(3031),
    [anon_sym_return_BANG] = ACTIONS(3033),
    [anon_sym_yield] = ACTIONS(3031),
    [anon_sym_yield_BANG] = ACTIONS(3033),
    [anon_sym_lazy] = ACTIONS(3031),
    [anon_sym_assert] = ACTIONS(3031),
    [anon_sym_upcast] = ACTIONS(3031),
    [anon_sym_downcast] = ACTIONS(3031),
    [anon_sym_COLON_GT] = ACTIONS(3033),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3033),
    [anon_sym_for] = ACTIONS(3031),
    [anon_sym_while] = ACTIONS(3031),
    [anon_sym_if] = ACTIONS(3031),
    [anon_sym_fun] = ACTIONS(3031),
    [anon_sym_try] = ACTIONS(3031),
    [anon_sym_match] = ACTIONS(3031),
    [anon_sym_match_BANG] = ACTIONS(3033),
    [anon_sym_function] = ACTIONS(3031),
    [anon_sym_LT_DASH] = ACTIONS(3031),
    [anon_sym_DOT_LBRACK] = ACTIONS(3033),
    [anon_sym_LT] = ACTIONS(3033),
    [anon_sym_use] = ACTIONS(3031),
    [anon_sym_use_BANG] = ACTIONS(3033),
    [anon_sym_do_BANG] = ACTIONS(3033),
    [anon_sym_begin] = ACTIONS(3031),
    [anon_sym_LPAREN2] = ACTIONS(3031),
    [anon_sym_or] = ACTIONS(3031),
    [aux_sym_char_token1] = ACTIONS(3033),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3031),
    [anon_sym_DQUOTE] = ACTIONS(3031),
    [anon_sym_AT_DQUOTE] = ACTIONS(3033),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3033),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3033),
    [sym_bool] = ACTIONS(3031),
    [sym_unit] = ACTIONS(3033),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3031),
    [sym_op_identifier] = ACTIONS(3031),
    [anon_sym_PLUS] = ACTIONS(3031),
    [anon_sym_DASH] = ACTIONS(3031),
    [anon_sym_PLUS_DOT] = ACTIONS(3031),
    [anon_sym_DASH_DOT] = ACTIONS(3031),
    [anon_sym_PERCENT] = ACTIONS(3031),
    [anon_sym_AMP_AMP] = ACTIONS(3031),
    [anon_sym_TILDE] = ACTIONS(3033),
    [aux_sym_prefix_op_token1] = ACTIONS(3031),
    [aux_sym_infix_op_token1] = ACTIONS(3033),
    [aux_sym_infix_op_token2] = ACTIONS(3031),
    [anon_sym_PIPE_PIPE] = ACTIONS(3031),
    [anon_sym_BANG_EQ] = ACTIONS(3031),
    [anon_sym_COLON_EQ] = ACTIONS(3033),
    [anon_sym_DOLLAR] = ACTIONS(3031),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3031),
    [sym_int] = ACTIONS(3031),
    [sym_xint] = ACTIONS(3033),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3033),
    [sym__newline] = ACTIONS(3033),
  },
  [2138] = {
    [sym_block_comment] = STATE(2138),
    [sym_compiler_directive_decl] = STATE(2138),
    [sym_fsi_directive_decl] = STATE(2138),
    [sym_preproc_line] = STATE(2138),
    [sym_identifier] = ACTIONS(2877),
    [anon_sym_EQ] = ACTIONS(2879),
    [anon_sym_COLON] = ACTIONS(2877),
    [anon_sym_return] = ACTIONS(2877),
    [anon_sym_do] = ACTIONS(2877),
    [anon_sym_let] = ACTIONS(2877),
    [anon_sym_let_BANG] = ACTIONS(2879),
    [anon_sym_LPAREN] = ACTIONS(2877),
    [anon_sym_COMMA] = ACTIONS(2879),
    [anon_sym_null] = ACTIONS(2877),
    [anon_sym_QMARK] = ACTIONS(2877),
    [anon_sym_COLON_QMARK] = ACTIONS(2877),
    [anon_sym_COLON_COLON] = ACTIONS(2879),
    [anon_sym_AMP] = ACTIONS(2877),
    [anon_sym_LBRACK] = ACTIONS(2877),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2879),
    [anon_sym_LBRACE] = ACTIONS(2877),
    [anon_sym_LT_AT] = ACTIONS(2877),
    [anon_sym_LT_AT_AT] = ACTIONS(2877),
    [anon_sym_DOT] = ACTIONS(2877),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2879),
    [anon_sym_new] = ACTIONS(2877),
    [anon_sym_return_BANG] = ACTIONS(2879),
    [anon_sym_yield] = ACTIONS(2877),
    [anon_sym_yield_BANG] = ACTIONS(2879),
    [anon_sym_lazy] = ACTIONS(2877),
    [anon_sym_assert] = ACTIONS(2877),
    [anon_sym_upcast] = ACTIONS(2877),
    [anon_sym_downcast] = ACTIONS(2877),
    [anon_sym_COLON_GT] = ACTIONS(2879),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2879),
    [anon_sym_for] = ACTIONS(2877),
    [anon_sym_while] = ACTIONS(2877),
    [anon_sym_if] = ACTIONS(2877),
    [anon_sym_fun] = ACTIONS(2877),
    [anon_sym_try] = ACTIONS(2877),
    [anon_sym_match] = ACTIONS(2877),
    [anon_sym_match_BANG] = ACTIONS(2879),
    [anon_sym_function] = ACTIONS(2877),
    [anon_sym_LT_DASH] = ACTIONS(2877),
    [anon_sym_DOT_LBRACK] = ACTIONS(2879),
    [anon_sym_LT] = ACTIONS(2879),
    [anon_sym_use] = ACTIONS(2877),
    [anon_sym_use_BANG] = ACTIONS(2879),
    [anon_sym_do_BANG] = ACTIONS(2879),
    [anon_sym_DOT_DOT] = ACTIONS(2879),
    [anon_sym_begin] = ACTIONS(2877),
    [anon_sym_LPAREN2] = ACTIONS(2877),
    [anon_sym_or] = ACTIONS(2877),
    [aux_sym_char_token1] = ACTIONS(2879),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2877),
    [anon_sym_DQUOTE] = ACTIONS(2877),
    [anon_sym_AT_DQUOTE] = ACTIONS(2879),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2879),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2879),
    [sym_bool] = ACTIONS(2877),
    [sym_unit] = ACTIONS(2879),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2877),
    [sym_op_identifier] = ACTIONS(2877),
    [anon_sym_PLUS] = ACTIONS(2877),
    [anon_sym_DASH] = ACTIONS(2877),
    [anon_sym_PLUS_DOT] = ACTIONS(2877),
    [anon_sym_DASH_DOT] = ACTIONS(2877),
    [anon_sym_PERCENT] = ACTIONS(2877),
    [anon_sym_AMP_AMP] = ACTIONS(2877),
    [anon_sym_TILDE] = ACTIONS(2879),
    [aux_sym_prefix_op_token1] = ACTIONS(2877),
    [aux_sym_infix_op_token1] = ACTIONS(2879),
    [aux_sym_infix_op_token2] = ACTIONS(2877),
    [anon_sym_PIPE_PIPE] = ACTIONS(2877),
    [anon_sym_BANG_EQ] = ACTIONS(2877),
    [anon_sym_COLON_EQ] = ACTIONS(2879),
    [anon_sym_DOLLAR] = ACTIONS(2877),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2877),
    [sym_int] = ACTIONS(2877),
    [sym_xint] = ACTIONS(2879),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2879),
    [sym__newline] = ACTIONS(2879),
  },
  [2139] = {
    [sym_block_comment] = STATE(2139),
    [sym_compiler_directive_decl] = STATE(2139),
    [sym_fsi_directive_decl] = STATE(2139),
    [sym_preproc_line] = STATE(2139),
    [sym_identifier] = ACTIONS(2883),
    [anon_sym_EQ] = ACTIONS(2885),
    [anon_sym_COLON] = ACTIONS(2883),
    [anon_sym_return] = ACTIONS(2883),
    [anon_sym_do] = ACTIONS(2883),
    [anon_sym_let] = ACTIONS(2883),
    [anon_sym_let_BANG] = ACTIONS(2885),
    [anon_sym_LPAREN] = ACTIONS(2883),
    [anon_sym_COMMA] = ACTIONS(2885),
    [anon_sym_null] = ACTIONS(2883),
    [anon_sym_QMARK] = ACTIONS(2883),
    [anon_sym_COLON_QMARK] = ACTIONS(2883),
    [anon_sym_COLON_COLON] = ACTIONS(2885),
    [anon_sym_AMP] = ACTIONS(2883),
    [anon_sym_LBRACK] = ACTIONS(2883),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2885),
    [anon_sym_LBRACE] = ACTIONS(2883),
    [anon_sym_LT_AT] = ACTIONS(2883),
    [anon_sym_LT_AT_AT] = ACTIONS(2883),
    [anon_sym_DOT] = ACTIONS(2883),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2885),
    [anon_sym_new] = ACTIONS(2883),
    [anon_sym_return_BANG] = ACTIONS(2885),
    [anon_sym_yield] = ACTIONS(2883),
    [anon_sym_yield_BANG] = ACTIONS(2885),
    [anon_sym_lazy] = ACTIONS(2883),
    [anon_sym_assert] = ACTIONS(2883),
    [anon_sym_upcast] = ACTIONS(2883),
    [anon_sym_downcast] = ACTIONS(2883),
    [anon_sym_COLON_GT] = ACTIONS(2885),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2885),
    [anon_sym_for] = ACTIONS(2883),
    [anon_sym_while] = ACTIONS(2883),
    [anon_sym_if] = ACTIONS(2883),
    [anon_sym_fun] = ACTIONS(2883),
    [anon_sym_try] = ACTIONS(2883),
    [anon_sym_match] = ACTIONS(2883),
    [anon_sym_match_BANG] = ACTIONS(2885),
    [anon_sym_function] = ACTIONS(2883),
    [anon_sym_LT_DASH] = ACTIONS(2883),
    [anon_sym_DOT_LBRACK] = ACTIONS(2885),
    [anon_sym_LT] = ACTIONS(2885),
    [anon_sym_use] = ACTIONS(2883),
    [anon_sym_use_BANG] = ACTIONS(2885),
    [anon_sym_do_BANG] = ACTIONS(2885),
    [anon_sym_DOT_DOT] = ACTIONS(2885),
    [anon_sym_begin] = ACTIONS(2883),
    [anon_sym_LPAREN2] = ACTIONS(2883),
    [anon_sym_or] = ACTIONS(2883),
    [aux_sym_char_token1] = ACTIONS(2885),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2883),
    [anon_sym_DQUOTE] = ACTIONS(2883),
    [anon_sym_AT_DQUOTE] = ACTIONS(2885),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2885),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2885),
    [sym_bool] = ACTIONS(2883),
    [sym_unit] = ACTIONS(2885),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2883),
    [sym_op_identifier] = ACTIONS(2883),
    [anon_sym_PLUS] = ACTIONS(2883),
    [anon_sym_DASH] = ACTIONS(2883),
    [anon_sym_PLUS_DOT] = ACTIONS(2883),
    [anon_sym_DASH_DOT] = ACTIONS(2883),
    [anon_sym_PERCENT] = ACTIONS(2883),
    [anon_sym_AMP_AMP] = ACTIONS(2883),
    [anon_sym_TILDE] = ACTIONS(2885),
    [aux_sym_prefix_op_token1] = ACTIONS(2883),
    [aux_sym_infix_op_token1] = ACTIONS(2885),
    [aux_sym_infix_op_token2] = ACTIONS(2883),
    [anon_sym_PIPE_PIPE] = ACTIONS(2883),
    [anon_sym_BANG_EQ] = ACTIONS(2883),
    [anon_sym_COLON_EQ] = ACTIONS(2885),
    [anon_sym_DOLLAR] = ACTIONS(2883),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2883),
    [sym_int] = ACTIONS(2883),
    [sym_xint] = ACTIONS(2885),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2885),
    [sym__newline] = ACTIONS(2885),
  },
  [2140] = {
    [sym_block_comment] = STATE(2140),
    [sym_compiler_directive_decl] = STATE(2140),
    [sym_fsi_directive_decl] = STATE(2140),
    [sym_preproc_line] = STATE(2140),
    [sym_identifier] = ACTIONS(2988),
    [anon_sym_EQ] = ACTIONS(2990),
    [anon_sym_COLON] = ACTIONS(2988),
    [anon_sym_return] = ACTIONS(2988),
    [anon_sym_do] = ACTIONS(2988),
    [anon_sym_let] = ACTIONS(2988),
    [anon_sym_let_BANG] = ACTIONS(2990),
    [anon_sym_LPAREN] = ACTIONS(2988),
    [anon_sym_COMMA] = ACTIONS(2990),
    [anon_sym_null] = ACTIONS(2988),
    [anon_sym_QMARK] = ACTIONS(2988),
    [anon_sym_COLON_QMARK] = ACTIONS(2988),
    [anon_sym_COLON_COLON] = ACTIONS(2990),
    [anon_sym_AMP] = ACTIONS(2988),
    [anon_sym_LBRACK] = ACTIONS(2988),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2990),
    [anon_sym_LBRACE] = ACTIONS(2988),
    [anon_sym_LT_AT] = ACTIONS(2988),
    [anon_sym_LT_AT_AT] = ACTIONS(2988),
    [anon_sym_AT_AT_GT] = ACTIONS(2988),
    [anon_sym_DOT] = ACTIONS(2988),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2990),
    [anon_sym_new] = ACTIONS(2988),
    [anon_sym_return_BANG] = ACTIONS(2990),
    [anon_sym_yield] = ACTIONS(2988),
    [anon_sym_yield_BANG] = ACTIONS(2990),
    [anon_sym_lazy] = ACTIONS(2988),
    [anon_sym_assert] = ACTIONS(2988),
    [anon_sym_upcast] = ACTIONS(2988),
    [anon_sym_downcast] = ACTIONS(2988),
    [anon_sym_COLON_GT] = ACTIONS(2990),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2990),
    [anon_sym_for] = ACTIONS(2988),
    [anon_sym_while] = ACTIONS(2988),
    [anon_sym_if] = ACTIONS(2988),
    [anon_sym_fun] = ACTIONS(2988),
    [anon_sym_try] = ACTIONS(2988),
    [anon_sym_match] = ACTIONS(2988),
    [anon_sym_match_BANG] = ACTIONS(2990),
    [anon_sym_function] = ACTIONS(2988),
    [anon_sym_LT_DASH] = ACTIONS(2988),
    [anon_sym_DOT_LBRACK] = ACTIONS(2990),
    [anon_sym_LT] = ACTIONS(2990),
    [anon_sym_use] = ACTIONS(2988),
    [anon_sym_use_BANG] = ACTIONS(2990),
    [anon_sym_do_BANG] = ACTIONS(2990),
    [anon_sym_begin] = ACTIONS(2988),
    [anon_sym_LPAREN2] = ACTIONS(2988),
    [anon_sym_or] = ACTIONS(2988),
    [aux_sym_char_token1] = ACTIONS(2990),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2988),
    [anon_sym_DQUOTE] = ACTIONS(2988),
    [anon_sym_AT_DQUOTE] = ACTIONS(2990),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2990),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2990),
    [sym_bool] = ACTIONS(2988),
    [sym_unit] = ACTIONS(2990),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2988),
    [sym_op_identifier] = ACTIONS(2988),
    [anon_sym_PLUS] = ACTIONS(2988),
    [anon_sym_DASH] = ACTIONS(2988),
    [anon_sym_PLUS_DOT] = ACTIONS(2988),
    [anon_sym_DASH_DOT] = ACTIONS(2988),
    [anon_sym_PERCENT] = ACTIONS(2988),
    [anon_sym_AMP_AMP] = ACTIONS(2988),
    [anon_sym_TILDE] = ACTIONS(2990),
    [aux_sym_prefix_op_token1] = ACTIONS(2988),
    [aux_sym_infix_op_token1] = ACTIONS(2990),
    [aux_sym_infix_op_token2] = ACTIONS(2988),
    [anon_sym_PIPE_PIPE] = ACTIONS(2988),
    [anon_sym_BANG_EQ] = ACTIONS(2988),
    [anon_sym_COLON_EQ] = ACTIONS(2990),
    [anon_sym_DOLLAR] = ACTIONS(2988),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2988),
    [sym_int] = ACTIONS(2988),
    [sym_xint] = ACTIONS(2990),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2990),
    [sym__newline] = ACTIONS(2990),
  },
  [2141] = {
    [sym_block_comment] = STATE(2141),
    [sym_compiler_directive_decl] = STATE(2141),
    [sym_fsi_directive_decl] = STATE(2141),
    [sym_preproc_line] = STATE(2141),
    [sym_identifier] = ACTIONS(2859),
    [anon_sym_EQ] = ACTIONS(2861),
    [anon_sym_COLON] = ACTIONS(2859),
    [anon_sym_return] = ACTIONS(2859),
    [anon_sym_do] = ACTIONS(2859),
    [anon_sym_let] = ACTIONS(2859),
    [anon_sym_let_BANG] = ACTIONS(2861),
    [anon_sym_LPAREN] = ACTIONS(2859),
    [anon_sym_COMMA] = ACTIONS(2861),
    [anon_sym_null] = ACTIONS(2859),
    [anon_sym_QMARK] = ACTIONS(2859),
    [anon_sym_COLON_QMARK] = ACTIONS(2859),
    [anon_sym_COLON_COLON] = ACTIONS(2861),
    [anon_sym_AMP] = ACTIONS(2859),
    [anon_sym_LBRACK] = ACTIONS(2859),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2861),
    [anon_sym_LBRACE] = ACTIONS(2859),
    [anon_sym_LT_AT] = ACTIONS(2859),
    [anon_sym_LT_AT_AT] = ACTIONS(2859),
    [anon_sym_DOT] = ACTIONS(2859),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2861),
    [anon_sym_new] = ACTIONS(2859),
    [anon_sym_return_BANG] = ACTIONS(2861),
    [anon_sym_yield] = ACTIONS(2859),
    [anon_sym_yield_BANG] = ACTIONS(2861),
    [anon_sym_lazy] = ACTIONS(2859),
    [anon_sym_assert] = ACTIONS(2859),
    [anon_sym_upcast] = ACTIONS(2859),
    [anon_sym_downcast] = ACTIONS(2859),
    [anon_sym_COLON_GT] = ACTIONS(2861),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2861),
    [anon_sym_for] = ACTIONS(2859),
    [anon_sym_while] = ACTIONS(2859),
    [anon_sym_if] = ACTIONS(2859),
    [anon_sym_fun] = ACTIONS(2859),
    [anon_sym_try] = ACTIONS(2859),
    [anon_sym_match] = ACTIONS(2859),
    [anon_sym_match_BANG] = ACTIONS(2861),
    [anon_sym_function] = ACTIONS(2859),
    [anon_sym_LT_DASH] = ACTIONS(2859),
    [anon_sym_DOT_LBRACK] = ACTIONS(2861),
    [anon_sym_LT] = ACTIONS(2861),
    [anon_sym_GT] = ACTIONS(2859),
    [anon_sym_use] = ACTIONS(2859),
    [anon_sym_use_BANG] = ACTIONS(2861),
    [anon_sym_do_BANG] = ACTIONS(2861),
    [anon_sym_begin] = ACTIONS(2859),
    [anon_sym_LPAREN2] = ACTIONS(2859),
    [anon_sym_or] = ACTIONS(2859),
    [aux_sym_char_token1] = ACTIONS(2861),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2859),
    [anon_sym_DQUOTE] = ACTIONS(2859),
    [anon_sym_AT_DQUOTE] = ACTIONS(2861),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2861),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2861),
    [sym_bool] = ACTIONS(2859),
    [sym_unit] = ACTIONS(2861),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2859),
    [sym_op_identifier] = ACTIONS(2859),
    [anon_sym_PLUS] = ACTIONS(2859),
    [anon_sym_DASH] = ACTIONS(2859),
    [anon_sym_PLUS_DOT] = ACTIONS(2859),
    [anon_sym_DASH_DOT] = ACTIONS(2859),
    [anon_sym_PERCENT] = ACTIONS(2859),
    [anon_sym_AMP_AMP] = ACTIONS(2859),
    [anon_sym_TILDE] = ACTIONS(2861),
    [aux_sym_prefix_op_token1] = ACTIONS(2859),
    [aux_sym_infix_op_token1] = ACTIONS(2861),
    [aux_sym_infix_op_token2] = ACTIONS(2859),
    [anon_sym_PIPE_PIPE] = ACTIONS(2859),
    [anon_sym_BANG_EQ] = ACTIONS(2859),
    [anon_sym_COLON_EQ] = ACTIONS(2861),
    [anon_sym_DOLLAR] = ACTIONS(2859),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2859),
    [sym_int] = ACTIONS(2859),
    [sym_xint] = ACTIONS(2861),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2861),
    [sym__newline] = ACTIONS(2861),
  },
  [2142] = {
    [sym_block_comment] = STATE(2142),
    [sym_compiler_directive_decl] = STATE(2142),
    [sym_fsi_directive_decl] = STATE(2142),
    [sym_preproc_line] = STATE(2142),
    [sym_identifier] = ACTIONS(2855),
    [anon_sym_EQ] = ACTIONS(2857),
    [anon_sym_COLON] = ACTIONS(2855),
    [anon_sym_return] = ACTIONS(2855),
    [anon_sym_do] = ACTIONS(2855),
    [anon_sym_let] = ACTIONS(2855),
    [anon_sym_let_BANG] = ACTIONS(2857),
    [anon_sym_LPAREN] = ACTIONS(2855),
    [anon_sym_COMMA] = ACTIONS(2857),
    [anon_sym_null] = ACTIONS(2855),
    [anon_sym_QMARK] = ACTIONS(2855),
    [anon_sym_COLON_QMARK] = ACTIONS(2855),
    [anon_sym_COLON_COLON] = ACTIONS(2857),
    [anon_sym_AMP] = ACTIONS(2855),
    [anon_sym_LBRACK] = ACTIONS(2855),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2857),
    [anon_sym_LBRACE] = ACTIONS(2855),
    [anon_sym_LT_AT] = ACTIONS(2855),
    [anon_sym_LT_AT_AT] = ACTIONS(2855),
    [anon_sym_DOT] = ACTIONS(2855),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2857),
    [anon_sym_new] = ACTIONS(2855),
    [anon_sym_return_BANG] = ACTIONS(2857),
    [anon_sym_yield] = ACTIONS(2855),
    [anon_sym_yield_BANG] = ACTIONS(2857),
    [anon_sym_lazy] = ACTIONS(2855),
    [anon_sym_assert] = ACTIONS(2855),
    [anon_sym_upcast] = ACTIONS(2855),
    [anon_sym_downcast] = ACTIONS(2855),
    [anon_sym_COLON_GT] = ACTIONS(2857),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2857),
    [anon_sym_for] = ACTIONS(2855),
    [anon_sym_while] = ACTIONS(2855),
    [anon_sym_if] = ACTIONS(2855),
    [anon_sym_fun] = ACTIONS(2855),
    [anon_sym_try] = ACTIONS(2855),
    [anon_sym_match] = ACTIONS(2855),
    [anon_sym_match_BANG] = ACTIONS(2857),
    [anon_sym_function] = ACTIONS(2855),
    [anon_sym_LT_DASH] = ACTIONS(2855),
    [anon_sym_DOT_LBRACK] = ACTIONS(2857),
    [anon_sym_LT] = ACTIONS(2857),
    [anon_sym_GT] = ACTIONS(2855),
    [anon_sym_use] = ACTIONS(2855),
    [anon_sym_use_BANG] = ACTIONS(2857),
    [anon_sym_do_BANG] = ACTIONS(2857),
    [anon_sym_begin] = ACTIONS(2855),
    [anon_sym_LPAREN2] = ACTIONS(2855),
    [anon_sym_or] = ACTIONS(2855),
    [aux_sym_char_token1] = ACTIONS(2857),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2855),
    [anon_sym_DQUOTE] = ACTIONS(2855),
    [anon_sym_AT_DQUOTE] = ACTIONS(2857),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2857),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2857),
    [sym_bool] = ACTIONS(2855),
    [sym_unit] = ACTIONS(2857),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2855),
    [sym_op_identifier] = ACTIONS(2855),
    [anon_sym_PLUS] = ACTIONS(2855),
    [anon_sym_DASH] = ACTIONS(2855),
    [anon_sym_PLUS_DOT] = ACTIONS(2855),
    [anon_sym_DASH_DOT] = ACTIONS(2855),
    [anon_sym_PERCENT] = ACTIONS(2855),
    [anon_sym_AMP_AMP] = ACTIONS(2855),
    [anon_sym_TILDE] = ACTIONS(2857),
    [aux_sym_prefix_op_token1] = ACTIONS(2855),
    [aux_sym_infix_op_token1] = ACTIONS(2857),
    [aux_sym_infix_op_token2] = ACTIONS(2855),
    [anon_sym_PIPE_PIPE] = ACTIONS(2855),
    [anon_sym_BANG_EQ] = ACTIONS(2855),
    [anon_sym_COLON_EQ] = ACTIONS(2857),
    [anon_sym_DOLLAR] = ACTIONS(2855),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2855),
    [sym_int] = ACTIONS(2855),
    [sym_xint] = ACTIONS(2857),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2857),
    [sym__newline] = ACTIONS(2857),
  },
  [2143] = {
    [sym_block_comment] = STATE(2143),
    [sym_compiler_directive_decl] = STATE(2143),
    [sym_fsi_directive_decl] = STATE(2143),
    [sym_preproc_line] = STATE(2143),
    [sym_identifier] = ACTIONS(3027),
    [anon_sym_EQ] = ACTIONS(3029),
    [anon_sym_COLON] = ACTIONS(3027),
    [anon_sym_return] = ACTIONS(3027),
    [anon_sym_do] = ACTIONS(3027),
    [anon_sym_let] = ACTIONS(3027),
    [anon_sym_let_BANG] = ACTIONS(3029),
    [anon_sym_LPAREN] = ACTIONS(3027),
    [anon_sym_COMMA] = ACTIONS(3029),
    [anon_sym_null] = ACTIONS(3027),
    [anon_sym_QMARK] = ACTIONS(3027),
    [anon_sym_COLON_QMARK] = ACTIONS(3027),
    [anon_sym_COLON_COLON] = ACTIONS(3029),
    [anon_sym_AMP] = ACTIONS(3027),
    [anon_sym_LBRACK] = ACTIONS(3027),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3027),
    [anon_sym_LT_AT] = ACTIONS(3027),
    [anon_sym_AT_GT] = ACTIONS(3027),
    [anon_sym_LT_AT_AT] = ACTIONS(3027),
    [anon_sym_DOT] = ACTIONS(3027),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3029),
    [anon_sym_new] = ACTIONS(3027),
    [anon_sym_return_BANG] = ACTIONS(3029),
    [anon_sym_yield] = ACTIONS(3027),
    [anon_sym_yield_BANG] = ACTIONS(3029),
    [anon_sym_lazy] = ACTIONS(3027),
    [anon_sym_assert] = ACTIONS(3027),
    [anon_sym_upcast] = ACTIONS(3027),
    [anon_sym_downcast] = ACTIONS(3027),
    [anon_sym_COLON_GT] = ACTIONS(3029),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3029),
    [anon_sym_for] = ACTIONS(3027),
    [anon_sym_while] = ACTIONS(3027),
    [anon_sym_if] = ACTIONS(3027),
    [anon_sym_fun] = ACTIONS(3027),
    [anon_sym_try] = ACTIONS(3027),
    [anon_sym_match] = ACTIONS(3027),
    [anon_sym_match_BANG] = ACTIONS(3029),
    [anon_sym_function] = ACTIONS(3027),
    [anon_sym_LT_DASH] = ACTIONS(3027),
    [anon_sym_DOT_LBRACK] = ACTIONS(3029),
    [anon_sym_LT] = ACTIONS(3029),
    [anon_sym_use] = ACTIONS(3027),
    [anon_sym_use_BANG] = ACTIONS(3029),
    [anon_sym_do_BANG] = ACTIONS(3029),
    [anon_sym_begin] = ACTIONS(3027),
    [anon_sym_LPAREN2] = ACTIONS(3027),
    [anon_sym_or] = ACTIONS(3027),
    [aux_sym_char_token1] = ACTIONS(3029),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3027),
    [anon_sym_DQUOTE] = ACTIONS(3027),
    [anon_sym_AT_DQUOTE] = ACTIONS(3029),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3029),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3029),
    [sym_bool] = ACTIONS(3027),
    [sym_unit] = ACTIONS(3029),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3027),
    [sym_op_identifier] = ACTIONS(3027),
    [anon_sym_PLUS] = ACTIONS(3027),
    [anon_sym_DASH] = ACTIONS(3027),
    [anon_sym_PLUS_DOT] = ACTIONS(3027),
    [anon_sym_DASH_DOT] = ACTIONS(3027),
    [anon_sym_PERCENT] = ACTIONS(3027),
    [anon_sym_AMP_AMP] = ACTIONS(3027),
    [anon_sym_TILDE] = ACTIONS(3029),
    [aux_sym_prefix_op_token1] = ACTIONS(3027),
    [aux_sym_infix_op_token1] = ACTIONS(3029),
    [aux_sym_infix_op_token2] = ACTIONS(3027),
    [anon_sym_PIPE_PIPE] = ACTIONS(3027),
    [anon_sym_BANG_EQ] = ACTIONS(3027),
    [anon_sym_COLON_EQ] = ACTIONS(3029),
    [anon_sym_DOLLAR] = ACTIONS(3027),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3027),
    [sym_int] = ACTIONS(3027),
    [sym_xint] = ACTIONS(3029),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3029),
    [sym__newline] = ACTIONS(3029),
  },
  [2144] = {
    [sym_block_comment] = STATE(2144),
    [sym_compiler_directive_decl] = STATE(2144),
    [sym_fsi_directive_decl] = STATE(2144),
    [sym_preproc_line] = STATE(2144),
    [sym_identifier] = ACTIONS(2158),
    [anon_sym_EQ] = ACTIONS(2160),
    [anon_sym_COLON] = ACTIONS(2158),
    [anon_sym_return] = ACTIONS(2158),
    [anon_sym_do] = ACTIONS(2158),
    [anon_sym_let] = ACTIONS(2158),
    [anon_sym_let_BANG] = ACTIONS(2160),
    [anon_sym_LPAREN] = ACTIONS(2158),
    [anon_sym_COMMA] = ACTIONS(2160),
    [anon_sym_null] = ACTIONS(2158),
    [anon_sym_QMARK] = ACTIONS(2158),
    [anon_sym_COLON_QMARK] = ACTIONS(2158),
    [anon_sym_COLON_COLON] = ACTIONS(2160),
    [anon_sym_AMP] = ACTIONS(2158),
    [anon_sym_LBRACK] = ACTIONS(2158),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2160),
    [anon_sym_LBRACE] = ACTIONS(2158),
    [anon_sym_LT_AT] = ACTIONS(2158),
    [anon_sym_LT_AT_AT] = ACTIONS(2158),
    [anon_sym_DOT] = ACTIONS(2158),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2160),
    [anon_sym_new] = ACTIONS(2158),
    [anon_sym_return_BANG] = ACTIONS(2160),
    [anon_sym_yield] = ACTIONS(2158),
    [anon_sym_yield_BANG] = ACTIONS(2160),
    [anon_sym_lazy] = ACTIONS(2158),
    [anon_sym_assert] = ACTIONS(2158),
    [anon_sym_upcast] = ACTIONS(2158),
    [anon_sym_downcast] = ACTIONS(2158),
    [anon_sym_COLON_GT] = ACTIONS(2160),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2160),
    [anon_sym_for] = ACTIONS(2158),
    [anon_sym_while] = ACTIONS(2158),
    [anon_sym_if] = ACTIONS(2158),
    [anon_sym_fun] = ACTIONS(2158),
    [anon_sym_try] = ACTIONS(2158),
    [anon_sym_match] = ACTIONS(2158),
    [anon_sym_match_BANG] = ACTIONS(2160),
    [anon_sym_function] = ACTIONS(2158),
    [anon_sym_LT_DASH] = ACTIONS(2158),
    [anon_sym_DOT_LBRACK] = ACTIONS(2160),
    [anon_sym_LT] = ACTIONS(2160),
    [anon_sym_GT] = ACTIONS(2158),
    [anon_sym_use] = ACTIONS(2158),
    [anon_sym_use_BANG] = ACTIONS(2160),
    [anon_sym_do_BANG] = ACTIONS(2160),
    [anon_sym_begin] = ACTIONS(2158),
    [anon_sym_LPAREN2] = ACTIONS(2158),
    [anon_sym_or] = ACTIONS(2158),
    [aux_sym_char_token1] = ACTIONS(2160),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2158),
    [anon_sym_DQUOTE] = ACTIONS(2158),
    [anon_sym_AT_DQUOTE] = ACTIONS(2160),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2160),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2160),
    [sym_bool] = ACTIONS(2158),
    [sym_unit] = ACTIONS(2160),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2158),
    [sym_op_identifier] = ACTIONS(2158),
    [anon_sym_PLUS] = ACTIONS(2158),
    [anon_sym_DASH] = ACTIONS(2158),
    [anon_sym_PLUS_DOT] = ACTIONS(2158),
    [anon_sym_DASH_DOT] = ACTIONS(2158),
    [anon_sym_PERCENT] = ACTIONS(2158),
    [anon_sym_AMP_AMP] = ACTIONS(2158),
    [anon_sym_TILDE] = ACTIONS(2160),
    [aux_sym_prefix_op_token1] = ACTIONS(2158),
    [aux_sym_infix_op_token1] = ACTIONS(2160),
    [aux_sym_infix_op_token2] = ACTIONS(2158),
    [anon_sym_PIPE_PIPE] = ACTIONS(2158),
    [anon_sym_BANG_EQ] = ACTIONS(2158),
    [anon_sym_COLON_EQ] = ACTIONS(2160),
    [anon_sym_DOLLAR] = ACTIONS(2158),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2158),
    [sym_int] = ACTIONS(2158),
    [sym_xint] = ACTIONS(2160),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2160),
    [sym__newline] = ACTIONS(2160),
  },
  [2145] = {
    [sym_block_comment] = STATE(2145),
    [sym_compiler_directive_decl] = STATE(2145),
    [sym_fsi_directive_decl] = STATE(2145),
    [sym_preproc_line] = STATE(2145),
    [sym_identifier] = ACTIONS(2887),
    [anon_sym_EQ] = ACTIONS(2889),
    [anon_sym_COLON] = ACTIONS(2887),
    [anon_sym_return] = ACTIONS(2887),
    [anon_sym_do] = ACTIONS(2887),
    [anon_sym_let] = ACTIONS(2887),
    [anon_sym_let_BANG] = ACTIONS(2889),
    [anon_sym_LPAREN] = ACTIONS(2887),
    [anon_sym_COMMA] = ACTIONS(2889),
    [anon_sym_null] = ACTIONS(2887),
    [anon_sym_QMARK] = ACTIONS(2887),
    [anon_sym_COLON_QMARK] = ACTIONS(2887),
    [anon_sym_COLON_COLON] = ACTIONS(2889),
    [anon_sym_AMP] = ACTIONS(2887),
    [anon_sym_LBRACK] = ACTIONS(2887),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2889),
    [anon_sym_LBRACE] = ACTIONS(2887),
    [anon_sym_LT_AT] = ACTIONS(2887),
    [anon_sym_LT_AT_AT] = ACTIONS(2887),
    [anon_sym_DOT] = ACTIONS(2887),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2889),
    [anon_sym_new] = ACTIONS(2887),
    [anon_sym_return_BANG] = ACTIONS(2889),
    [anon_sym_yield] = ACTIONS(2887),
    [anon_sym_yield_BANG] = ACTIONS(2889),
    [anon_sym_lazy] = ACTIONS(2887),
    [anon_sym_assert] = ACTIONS(2887),
    [anon_sym_upcast] = ACTIONS(2887),
    [anon_sym_downcast] = ACTIONS(2887),
    [anon_sym_COLON_GT] = ACTIONS(2889),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2889),
    [anon_sym_for] = ACTIONS(2887),
    [anon_sym_while] = ACTIONS(2887),
    [anon_sym_if] = ACTIONS(2887),
    [anon_sym_fun] = ACTIONS(2887),
    [anon_sym_try] = ACTIONS(2887),
    [anon_sym_match] = ACTIONS(2887),
    [anon_sym_match_BANG] = ACTIONS(2889),
    [anon_sym_function] = ACTIONS(2887),
    [anon_sym_LT_DASH] = ACTIONS(2887),
    [anon_sym_DOT_LBRACK] = ACTIONS(2889),
    [anon_sym_LT] = ACTIONS(2889),
    [anon_sym_use] = ACTIONS(2887),
    [anon_sym_use_BANG] = ACTIONS(2889),
    [anon_sym_do_BANG] = ACTIONS(2889),
    [anon_sym_DOT_DOT] = ACTIONS(2889),
    [anon_sym_begin] = ACTIONS(2887),
    [anon_sym_LPAREN2] = ACTIONS(2887),
    [anon_sym_or] = ACTIONS(2887),
    [aux_sym_char_token1] = ACTIONS(2889),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2887),
    [anon_sym_DQUOTE] = ACTIONS(2887),
    [anon_sym_AT_DQUOTE] = ACTIONS(2889),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2889),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2889),
    [sym_bool] = ACTIONS(2887),
    [sym_unit] = ACTIONS(2889),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2887),
    [sym_op_identifier] = ACTIONS(2887),
    [anon_sym_PLUS] = ACTIONS(2887),
    [anon_sym_DASH] = ACTIONS(2887),
    [anon_sym_PLUS_DOT] = ACTIONS(2887),
    [anon_sym_DASH_DOT] = ACTIONS(2887),
    [anon_sym_PERCENT] = ACTIONS(2887),
    [anon_sym_AMP_AMP] = ACTIONS(2887),
    [anon_sym_TILDE] = ACTIONS(2889),
    [aux_sym_prefix_op_token1] = ACTIONS(2887),
    [aux_sym_infix_op_token1] = ACTIONS(2889),
    [aux_sym_infix_op_token2] = ACTIONS(2887),
    [anon_sym_PIPE_PIPE] = ACTIONS(2887),
    [anon_sym_BANG_EQ] = ACTIONS(2887),
    [anon_sym_COLON_EQ] = ACTIONS(2889),
    [anon_sym_DOLLAR] = ACTIONS(2887),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2887),
    [sym_int] = ACTIONS(2887),
    [sym_xint] = ACTIONS(2889),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2889),
    [sym__newline] = ACTIONS(2889),
  },
  [2146] = {
    [sym_block_comment] = STATE(2146),
    [sym_compiler_directive_decl] = STATE(2146),
    [sym_fsi_directive_decl] = STATE(2146),
    [sym_preproc_line] = STATE(2146),
    [sym_identifier] = ACTIONS(2891),
    [anon_sym_EQ] = ACTIONS(2893),
    [anon_sym_COLON] = ACTIONS(2891),
    [anon_sym_return] = ACTIONS(2891),
    [anon_sym_do] = ACTIONS(2891),
    [anon_sym_let] = ACTIONS(2891),
    [anon_sym_let_BANG] = ACTIONS(2893),
    [anon_sym_LPAREN] = ACTIONS(2891),
    [anon_sym_COMMA] = ACTIONS(2893),
    [anon_sym_null] = ACTIONS(2891),
    [anon_sym_QMARK] = ACTIONS(2891),
    [anon_sym_COLON_QMARK] = ACTIONS(2891),
    [anon_sym_COLON_COLON] = ACTIONS(2893),
    [anon_sym_AMP] = ACTIONS(2891),
    [anon_sym_LBRACK] = ACTIONS(2891),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2893),
    [anon_sym_LBRACE] = ACTIONS(2891),
    [anon_sym_LT_AT] = ACTIONS(2891),
    [anon_sym_LT_AT_AT] = ACTIONS(2891),
    [anon_sym_DOT] = ACTIONS(2891),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2893),
    [anon_sym_new] = ACTIONS(2891),
    [anon_sym_return_BANG] = ACTIONS(2893),
    [anon_sym_yield] = ACTIONS(2891),
    [anon_sym_yield_BANG] = ACTIONS(2893),
    [anon_sym_lazy] = ACTIONS(2891),
    [anon_sym_assert] = ACTIONS(2891),
    [anon_sym_upcast] = ACTIONS(2891),
    [anon_sym_downcast] = ACTIONS(2891),
    [anon_sym_COLON_GT] = ACTIONS(2893),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2893),
    [anon_sym_for] = ACTIONS(2891),
    [anon_sym_while] = ACTIONS(2891),
    [anon_sym_if] = ACTIONS(2891),
    [anon_sym_fun] = ACTIONS(2891),
    [anon_sym_try] = ACTIONS(2891),
    [anon_sym_match] = ACTIONS(2891),
    [anon_sym_match_BANG] = ACTIONS(2893),
    [anon_sym_function] = ACTIONS(2891),
    [anon_sym_LT_DASH] = ACTIONS(2891),
    [anon_sym_DOT_LBRACK] = ACTIONS(2893),
    [anon_sym_LT] = ACTIONS(2893),
    [anon_sym_use] = ACTIONS(2891),
    [anon_sym_use_BANG] = ACTIONS(2893),
    [anon_sym_do_BANG] = ACTIONS(2893),
    [anon_sym_DOT_DOT] = ACTIONS(2893),
    [anon_sym_begin] = ACTIONS(2891),
    [anon_sym_LPAREN2] = ACTIONS(2891),
    [anon_sym_or] = ACTIONS(2891),
    [aux_sym_char_token1] = ACTIONS(2893),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2891),
    [anon_sym_DQUOTE] = ACTIONS(2891),
    [anon_sym_AT_DQUOTE] = ACTIONS(2893),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2893),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2893),
    [sym_bool] = ACTIONS(2891),
    [sym_unit] = ACTIONS(2893),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2891),
    [sym_op_identifier] = ACTIONS(2891),
    [anon_sym_PLUS] = ACTIONS(2891),
    [anon_sym_DASH] = ACTIONS(2891),
    [anon_sym_PLUS_DOT] = ACTIONS(2891),
    [anon_sym_DASH_DOT] = ACTIONS(2891),
    [anon_sym_PERCENT] = ACTIONS(2891),
    [anon_sym_AMP_AMP] = ACTIONS(2891),
    [anon_sym_TILDE] = ACTIONS(2893),
    [aux_sym_prefix_op_token1] = ACTIONS(2891),
    [aux_sym_infix_op_token1] = ACTIONS(2893),
    [aux_sym_infix_op_token2] = ACTIONS(2891),
    [anon_sym_PIPE_PIPE] = ACTIONS(2891),
    [anon_sym_BANG_EQ] = ACTIONS(2891),
    [anon_sym_COLON_EQ] = ACTIONS(2893),
    [anon_sym_DOLLAR] = ACTIONS(2891),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2891),
    [sym_int] = ACTIONS(2891),
    [sym_xint] = ACTIONS(2893),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2893),
    [sym__newline] = ACTIONS(2893),
  },
  [2147] = {
    [sym_block_comment] = STATE(2147),
    [sym_compiler_directive_decl] = STATE(2147),
    [sym_fsi_directive_decl] = STATE(2147),
    [sym_preproc_line] = STATE(2147),
    [sym_identifier] = ACTIONS(2910),
    [anon_sym_EQ] = ACTIONS(2912),
    [anon_sym_COLON] = ACTIONS(2910),
    [anon_sym_return] = ACTIONS(2910),
    [anon_sym_do] = ACTIONS(2910),
    [anon_sym_let] = ACTIONS(2910),
    [anon_sym_let_BANG] = ACTIONS(2912),
    [anon_sym_LPAREN] = ACTIONS(2910),
    [anon_sym_COMMA] = ACTIONS(2912),
    [anon_sym_null] = ACTIONS(2910),
    [anon_sym_QMARK] = ACTIONS(2910),
    [anon_sym_COLON_QMARK] = ACTIONS(2910),
    [anon_sym_COLON_COLON] = ACTIONS(2912),
    [anon_sym_AMP] = ACTIONS(2910),
    [anon_sym_LBRACK] = ACTIONS(2910),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2912),
    [anon_sym_LBRACE] = ACTIONS(2910),
    [anon_sym_LT_AT] = ACTIONS(2910),
    [anon_sym_LT_AT_AT] = ACTIONS(2910),
    [anon_sym_DOT] = ACTIONS(2910),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2912),
    [anon_sym_new] = ACTIONS(2910),
    [anon_sym_return_BANG] = ACTIONS(2912),
    [anon_sym_yield] = ACTIONS(2910),
    [anon_sym_yield_BANG] = ACTIONS(2912),
    [anon_sym_lazy] = ACTIONS(2910),
    [anon_sym_assert] = ACTIONS(2910),
    [anon_sym_upcast] = ACTIONS(2910),
    [anon_sym_downcast] = ACTIONS(2910),
    [anon_sym_COLON_GT] = ACTIONS(2912),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2912),
    [anon_sym_for] = ACTIONS(2910),
    [anon_sym_while] = ACTIONS(2910),
    [anon_sym_if] = ACTIONS(2910),
    [anon_sym_fun] = ACTIONS(2910),
    [anon_sym_try] = ACTIONS(2910),
    [anon_sym_match] = ACTIONS(2910),
    [anon_sym_match_BANG] = ACTIONS(2912),
    [anon_sym_function] = ACTIONS(2910),
    [anon_sym_LT_DASH] = ACTIONS(2910),
    [anon_sym_DOT_LBRACK] = ACTIONS(2912),
    [anon_sym_LT] = ACTIONS(2912),
    [anon_sym_use] = ACTIONS(2910),
    [anon_sym_use_BANG] = ACTIONS(2912),
    [anon_sym_do_BANG] = ACTIONS(2912),
    [anon_sym_DOT_DOT] = ACTIONS(2912),
    [anon_sym_begin] = ACTIONS(2910),
    [anon_sym_LPAREN2] = ACTIONS(2910),
    [anon_sym_or] = ACTIONS(2910),
    [aux_sym_char_token1] = ACTIONS(2912),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2910),
    [anon_sym_DQUOTE] = ACTIONS(2910),
    [anon_sym_AT_DQUOTE] = ACTIONS(2912),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2912),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2912),
    [sym_bool] = ACTIONS(2910),
    [sym_unit] = ACTIONS(2912),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2910),
    [sym_op_identifier] = ACTIONS(2910),
    [anon_sym_PLUS] = ACTIONS(2910),
    [anon_sym_DASH] = ACTIONS(2910),
    [anon_sym_PLUS_DOT] = ACTIONS(2910),
    [anon_sym_DASH_DOT] = ACTIONS(2910),
    [anon_sym_PERCENT] = ACTIONS(2910),
    [anon_sym_AMP_AMP] = ACTIONS(2910),
    [anon_sym_TILDE] = ACTIONS(2912),
    [aux_sym_prefix_op_token1] = ACTIONS(2910),
    [aux_sym_infix_op_token1] = ACTIONS(2912),
    [aux_sym_infix_op_token2] = ACTIONS(2910),
    [anon_sym_PIPE_PIPE] = ACTIONS(2910),
    [anon_sym_BANG_EQ] = ACTIONS(2910),
    [anon_sym_COLON_EQ] = ACTIONS(2912),
    [anon_sym_DOLLAR] = ACTIONS(2910),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2910),
    [sym_int] = ACTIONS(2910),
    [sym_xint] = ACTIONS(2912),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2912),
    [sym__newline] = ACTIONS(2912),
  },
  [2148] = {
    [sym_block_comment] = STATE(2148),
    [sym_compiler_directive_decl] = STATE(2148),
    [sym_fsi_directive_decl] = STATE(2148),
    [sym_preproc_line] = STATE(2148),
    [sym_identifier] = ACTIONS(2914),
    [anon_sym_EQ] = ACTIONS(2916),
    [anon_sym_COLON] = ACTIONS(2914),
    [anon_sym_return] = ACTIONS(2914),
    [anon_sym_do] = ACTIONS(2914),
    [anon_sym_let] = ACTIONS(2914),
    [anon_sym_let_BANG] = ACTIONS(2916),
    [anon_sym_LPAREN] = ACTIONS(2914),
    [anon_sym_COMMA] = ACTIONS(2916),
    [anon_sym_null] = ACTIONS(2914),
    [anon_sym_QMARK] = ACTIONS(2914),
    [anon_sym_COLON_QMARK] = ACTIONS(2914),
    [anon_sym_COLON_COLON] = ACTIONS(2916),
    [anon_sym_AMP] = ACTIONS(2914),
    [anon_sym_LBRACK] = ACTIONS(2914),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2916),
    [anon_sym_LBRACE] = ACTIONS(2914),
    [anon_sym_LT_AT] = ACTIONS(2914),
    [anon_sym_LT_AT_AT] = ACTIONS(2914),
    [anon_sym_DOT] = ACTIONS(2914),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2916),
    [anon_sym_new] = ACTIONS(2914),
    [anon_sym_return_BANG] = ACTIONS(2916),
    [anon_sym_yield] = ACTIONS(2914),
    [anon_sym_yield_BANG] = ACTIONS(2916),
    [anon_sym_lazy] = ACTIONS(2914),
    [anon_sym_assert] = ACTIONS(2914),
    [anon_sym_upcast] = ACTIONS(2914),
    [anon_sym_downcast] = ACTIONS(2914),
    [anon_sym_COLON_GT] = ACTIONS(2916),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2916),
    [anon_sym_for] = ACTIONS(2914),
    [anon_sym_while] = ACTIONS(2914),
    [anon_sym_if] = ACTIONS(2914),
    [anon_sym_fun] = ACTIONS(2914),
    [anon_sym_try] = ACTIONS(2914),
    [anon_sym_match] = ACTIONS(2914),
    [anon_sym_match_BANG] = ACTIONS(2916),
    [anon_sym_function] = ACTIONS(2914),
    [anon_sym_LT_DASH] = ACTIONS(2914),
    [anon_sym_DOT_LBRACK] = ACTIONS(2916),
    [anon_sym_LT] = ACTIONS(2916),
    [anon_sym_use] = ACTIONS(2914),
    [anon_sym_use_BANG] = ACTIONS(2916),
    [anon_sym_do_BANG] = ACTIONS(2916),
    [anon_sym_DOT_DOT] = ACTIONS(2916),
    [anon_sym_begin] = ACTIONS(2914),
    [anon_sym_LPAREN2] = ACTIONS(2914),
    [anon_sym_or] = ACTIONS(2914),
    [aux_sym_char_token1] = ACTIONS(2916),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2914),
    [anon_sym_DQUOTE] = ACTIONS(2914),
    [anon_sym_AT_DQUOTE] = ACTIONS(2916),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2916),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2916),
    [sym_bool] = ACTIONS(2914),
    [sym_unit] = ACTIONS(2916),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2914),
    [sym_op_identifier] = ACTIONS(2914),
    [anon_sym_PLUS] = ACTIONS(2914),
    [anon_sym_DASH] = ACTIONS(2914),
    [anon_sym_PLUS_DOT] = ACTIONS(2914),
    [anon_sym_DASH_DOT] = ACTIONS(2914),
    [anon_sym_PERCENT] = ACTIONS(2914),
    [anon_sym_AMP_AMP] = ACTIONS(2914),
    [anon_sym_TILDE] = ACTIONS(2916),
    [aux_sym_prefix_op_token1] = ACTIONS(2914),
    [aux_sym_infix_op_token1] = ACTIONS(2916),
    [aux_sym_infix_op_token2] = ACTIONS(2914),
    [anon_sym_PIPE_PIPE] = ACTIONS(2914),
    [anon_sym_BANG_EQ] = ACTIONS(2914),
    [anon_sym_COLON_EQ] = ACTIONS(2916),
    [anon_sym_DOLLAR] = ACTIONS(2914),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2914),
    [sym_int] = ACTIONS(2914),
    [sym_xint] = ACTIONS(2916),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2916),
    [sym__newline] = ACTIONS(2916),
  },
  [2149] = {
    [sym_block_comment] = STATE(2149),
    [sym_compiler_directive_decl] = STATE(2149),
    [sym_fsi_directive_decl] = STATE(2149),
    [sym_preproc_line] = STATE(2149),
    [sym_identifier] = ACTIONS(2918),
    [anon_sym_EQ] = ACTIONS(2920),
    [anon_sym_COLON] = ACTIONS(2918),
    [anon_sym_return] = ACTIONS(2918),
    [anon_sym_do] = ACTIONS(2918),
    [anon_sym_let] = ACTIONS(2918),
    [anon_sym_let_BANG] = ACTIONS(2920),
    [anon_sym_LPAREN] = ACTIONS(2918),
    [anon_sym_COMMA] = ACTIONS(2920),
    [anon_sym_null] = ACTIONS(2918),
    [anon_sym_QMARK] = ACTIONS(2918),
    [anon_sym_COLON_QMARK] = ACTIONS(2918),
    [anon_sym_COLON_COLON] = ACTIONS(2920),
    [anon_sym_AMP] = ACTIONS(2918),
    [anon_sym_LBRACK] = ACTIONS(2918),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2920),
    [anon_sym_LBRACE] = ACTIONS(2918),
    [anon_sym_LT_AT] = ACTIONS(2918),
    [anon_sym_LT_AT_AT] = ACTIONS(2918),
    [anon_sym_DOT] = ACTIONS(2918),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2920),
    [anon_sym_new] = ACTIONS(2918),
    [anon_sym_return_BANG] = ACTIONS(2920),
    [anon_sym_yield] = ACTIONS(2918),
    [anon_sym_yield_BANG] = ACTIONS(2920),
    [anon_sym_lazy] = ACTIONS(2918),
    [anon_sym_assert] = ACTIONS(2918),
    [anon_sym_upcast] = ACTIONS(2918),
    [anon_sym_downcast] = ACTIONS(2918),
    [anon_sym_COLON_GT] = ACTIONS(2920),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2920),
    [anon_sym_for] = ACTIONS(2918),
    [anon_sym_while] = ACTIONS(2918),
    [anon_sym_if] = ACTIONS(2918),
    [anon_sym_fun] = ACTIONS(2918),
    [anon_sym_try] = ACTIONS(2918),
    [anon_sym_match] = ACTIONS(2918),
    [anon_sym_match_BANG] = ACTIONS(2920),
    [anon_sym_function] = ACTIONS(2918),
    [anon_sym_LT_DASH] = ACTIONS(2918),
    [anon_sym_DOT_LBRACK] = ACTIONS(2920),
    [anon_sym_LT] = ACTIONS(2920),
    [anon_sym_use] = ACTIONS(2918),
    [anon_sym_use_BANG] = ACTIONS(2920),
    [anon_sym_do_BANG] = ACTIONS(2920),
    [anon_sym_DOT_DOT] = ACTIONS(2920),
    [anon_sym_begin] = ACTIONS(2918),
    [anon_sym_LPAREN2] = ACTIONS(2918),
    [anon_sym_or] = ACTIONS(2918),
    [aux_sym_char_token1] = ACTIONS(2920),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2918),
    [anon_sym_DQUOTE] = ACTIONS(2918),
    [anon_sym_AT_DQUOTE] = ACTIONS(2920),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2920),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2920),
    [sym_bool] = ACTIONS(2918),
    [sym_unit] = ACTIONS(2920),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2918),
    [sym_op_identifier] = ACTIONS(2918),
    [anon_sym_PLUS] = ACTIONS(2918),
    [anon_sym_DASH] = ACTIONS(2918),
    [anon_sym_PLUS_DOT] = ACTIONS(2918),
    [anon_sym_DASH_DOT] = ACTIONS(2918),
    [anon_sym_PERCENT] = ACTIONS(2918),
    [anon_sym_AMP_AMP] = ACTIONS(2918),
    [anon_sym_TILDE] = ACTIONS(2920),
    [aux_sym_prefix_op_token1] = ACTIONS(2918),
    [aux_sym_infix_op_token1] = ACTIONS(2920),
    [aux_sym_infix_op_token2] = ACTIONS(2918),
    [anon_sym_PIPE_PIPE] = ACTIONS(2918),
    [anon_sym_BANG_EQ] = ACTIONS(2918),
    [anon_sym_COLON_EQ] = ACTIONS(2920),
    [anon_sym_DOLLAR] = ACTIONS(2918),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2918),
    [sym_int] = ACTIONS(2918),
    [sym_xint] = ACTIONS(2920),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2920),
    [sym__newline] = ACTIONS(2920),
  },
  [2150] = {
    [sym_block_comment] = STATE(2150),
    [sym_compiler_directive_decl] = STATE(2150),
    [sym_fsi_directive_decl] = STATE(2150),
    [sym_preproc_line] = STATE(2150),
    [sym_identifier] = ACTIONS(2922),
    [anon_sym_EQ] = ACTIONS(2924),
    [anon_sym_COLON] = ACTIONS(2922),
    [anon_sym_return] = ACTIONS(2922),
    [anon_sym_do] = ACTIONS(2922),
    [anon_sym_let] = ACTIONS(2922),
    [anon_sym_let_BANG] = ACTIONS(2924),
    [anon_sym_LPAREN] = ACTIONS(2922),
    [anon_sym_COMMA] = ACTIONS(2924),
    [anon_sym_null] = ACTIONS(2922),
    [anon_sym_QMARK] = ACTIONS(2922),
    [anon_sym_COLON_QMARK] = ACTIONS(2922),
    [anon_sym_COLON_COLON] = ACTIONS(2924),
    [anon_sym_AMP] = ACTIONS(2922),
    [anon_sym_LBRACK] = ACTIONS(2922),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2924),
    [anon_sym_LBRACE] = ACTIONS(2922),
    [anon_sym_LT_AT] = ACTIONS(2922),
    [anon_sym_LT_AT_AT] = ACTIONS(2922),
    [anon_sym_DOT] = ACTIONS(2922),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2924),
    [anon_sym_new] = ACTIONS(2922),
    [anon_sym_return_BANG] = ACTIONS(2924),
    [anon_sym_yield] = ACTIONS(2922),
    [anon_sym_yield_BANG] = ACTIONS(2924),
    [anon_sym_lazy] = ACTIONS(2922),
    [anon_sym_assert] = ACTIONS(2922),
    [anon_sym_upcast] = ACTIONS(2922),
    [anon_sym_downcast] = ACTIONS(2922),
    [anon_sym_COLON_GT] = ACTIONS(2924),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2924),
    [anon_sym_for] = ACTIONS(2922),
    [anon_sym_while] = ACTIONS(2922),
    [anon_sym_if] = ACTIONS(2922),
    [anon_sym_fun] = ACTIONS(2922),
    [anon_sym_try] = ACTIONS(2922),
    [anon_sym_match] = ACTIONS(2922),
    [anon_sym_match_BANG] = ACTIONS(2924),
    [anon_sym_function] = ACTIONS(2922),
    [anon_sym_LT_DASH] = ACTIONS(2922),
    [anon_sym_DOT_LBRACK] = ACTIONS(2924),
    [anon_sym_LT] = ACTIONS(2924),
    [anon_sym_use] = ACTIONS(2922),
    [anon_sym_use_BANG] = ACTIONS(2924),
    [anon_sym_do_BANG] = ACTIONS(2924),
    [anon_sym_DOT_DOT] = ACTIONS(2924),
    [anon_sym_begin] = ACTIONS(2922),
    [anon_sym_LPAREN2] = ACTIONS(2922),
    [anon_sym_or] = ACTIONS(2922),
    [aux_sym_char_token1] = ACTIONS(2924),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2922),
    [anon_sym_DQUOTE] = ACTIONS(2922),
    [anon_sym_AT_DQUOTE] = ACTIONS(2924),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2924),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2924),
    [sym_bool] = ACTIONS(2922),
    [sym_unit] = ACTIONS(2924),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2922),
    [sym_op_identifier] = ACTIONS(2922),
    [anon_sym_PLUS] = ACTIONS(2922),
    [anon_sym_DASH] = ACTIONS(2922),
    [anon_sym_PLUS_DOT] = ACTIONS(2922),
    [anon_sym_DASH_DOT] = ACTIONS(2922),
    [anon_sym_PERCENT] = ACTIONS(2922),
    [anon_sym_AMP_AMP] = ACTIONS(2922),
    [anon_sym_TILDE] = ACTIONS(2924),
    [aux_sym_prefix_op_token1] = ACTIONS(2922),
    [aux_sym_infix_op_token1] = ACTIONS(2924),
    [aux_sym_infix_op_token2] = ACTIONS(2922),
    [anon_sym_PIPE_PIPE] = ACTIONS(2922),
    [anon_sym_BANG_EQ] = ACTIONS(2922),
    [anon_sym_COLON_EQ] = ACTIONS(2924),
    [anon_sym_DOLLAR] = ACTIONS(2922),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2922),
    [sym_int] = ACTIONS(2922),
    [sym_xint] = ACTIONS(2924),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2924),
    [sym__newline] = ACTIONS(2924),
  },
  [2151] = {
    [sym_block_comment] = STATE(2151),
    [sym_compiler_directive_decl] = STATE(2151),
    [sym_fsi_directive_decl] = STATE(2151),
    [sym_preproc_line] = STATE(2151),
    [sym_identifier] = ACTIONS(2926),
    [anon_sym_EQ] = ACTIONS(2928),
    [anon_sym_COLON] = ACTIONS(2926),
    [anon_sym_return] = ACTIONS(2926),
    [anon_sym_do] = ACTIONS(2926),
    [anon_sym_let] = ACTIONS(2926),
    [anon_sym_let_BANG] = ACTIONS(2928),
    [anon_sym_LPAREN] = ACTIONS(2926),
    [anon_sym_COMMA] = ACTIONS(2928),
    [anon_sym_null] = ACTIONS(2926),
    [anon_sym_QMARK] = ACTIONS(2926),
    [anon_sym_COLON_QMARK] = ACTIONS(2926),
    [anon_sym_COLON_COLON] = ACTIONS(2928),
    [anon_sym_AMP] = ACTIONS(2926),
    [anon_sym_LBRACK] = ACTIONS(2926),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2928),
    [anon_sym_LBRACE] = ACTIONS(2926),
    [anon_sym_LT_AT] = ACTIONS(2926),
    [anon_sym_LT_AT_AT] = ACTIONS(2926),
    [anon_sym_DOT] = ACTIONS(2926),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2928),
    [anon_sym_new] = ACTIONS(2926),
    [anon_sym_return_BANG] = ACTIONS(2928),
    [anon_sym_yield] = ACTIONS(2926),
    [anon_sym_yield_BANG] = ACTIONS(2928),
    [anon_sym_lazy] = ACTIONS(2926),
    [anon_sym_assert] = ACTIONS(2926),
    [anon_sym_upcast] = ACTIONS(2926),
    [anon_sym_downcast] = ACTIONS(2926),
    [anon_sym_COLON_GT] = ACTIONS(2928),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2928),
    [anon_sym_for] = ACTIONS(2926),
    [anon_sym_while] = ACTIONS(2926),
    [anon_sym_if] = ACTIONS(2926),
    [anon_sym_fun] = ACTIONS(2926),
    [anon_sym_try] = ACTIONS(2926),
    [anon_sym_match] = ACTIONS(2926),
    [anon_sym_match_BANG] = ACTIONS(2928),
    [anon_sym_function] = ACTIONS(2926),
    [anon_sym_LT_DASH] = ACTIONS(2926),
    [anon_sym_DOT_LBRACK] = ACTIONS(2928),
    [anon_sym_LT] = ACTIONS(2928),
    [anon_sym_use] = ACTIONS(2926),
    [anon_sym_use_BANG] = ACTIONS(2928),
    [anon_sym_do_BANG] = ACTIONS(2928),
    [anon_sym_DOT_DOT] = ACTIONS(2928),
    [anon_sym_begin] = ACTIONS(2926),
    [anon_sym_LPAREN2] = ACTIONS(2926),
    [anon_sym_or] = ACTIONS(2926),
    [aux_sym_char_token1] = ACTIONS(2928),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2926),
    [anon_sym_DQUOTE] = ACTIONS(2926),
    [anon_sym_AT_DQUOTE] = ACTIONS(2928),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2928),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2928),
    [sym_bool] = ACTIONS(2926),
    [sym_unit] = ACTIONS(2928),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2926),
    [sym_op_identifier] = ACTIONS(2926),
    [anon_sym_PLUS] = ACTIONS(2926),
    [anon_sym_DASH] = ACTIONS(2926),
    [anon_sym_PLUS_DOT] = ACTIONS(2926),
    [anon_sym_DASH_DOT] = ACTIONS(2926),
    [anon_sym_PERCENT] = ACTIONS(2926),
    [anon_sym_AMP_AMP] = ACTIONS(2926),
    [anon_sym_TILDE] = ACTIONS(2928),
    [aux_sym_prefix_op_token1] = ACTIONS(2926),
    [aux_sym_infix_op_token1] = ACTIONS(2928),
    [aux_sym_infix_op_token2] = ACTIONS(2926),
    [anon_sym_PIPE_PIPE] = ACTIONS(2926),
    [anon_sym_BANG_EQ] = ACTIONS(2926),
    [anon_sym_COLON_EQ] = ACTIONS(2928),
    [anon_sym_DOLLAR] = ACTIONS(2926),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2926),
    [sym_int] = ACTIONS(2926),
    [sym_xint] = ACTIONS(2928),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2928),
    [sym__newline] = ACTIONS(2928),
  },
  [2152] = {
    [sym_block_comment] = STATE(2152),
    [sym_compiler_directive_decl] = STATE(2152),
    [sym_fsi_directive_decl] = STATE(2152),
    [sym_preproc_line] = STATE(2152),
    [sym_identifier] = ACTIONS(2843),
    [anon_sym_EQ] = ACTIONS(2845),
    [anon_sym_COLON] = ACTIONS(2843),
    [anon_sym_return] = ACTIONS(2843),
    [anon_sym_do] = ACTIONS(2843),
    [anon_sym_let] = ACTIONS(2843),
    [anon_sym_let_BANG] = ACTIONS(2845),
    [anon_sym_LPAREN] = ACTIONS(2843),
    [anon_sym_COMMA] = ACTIONS(2845),
    [anon_sym_null] = ACTIONS(2843),
    [anon_sym_QMARK] = ACTIONS(2843),
    [anon_sym_COLON_QMARK] = ACTIONS(2843),
    [anon_sym_COLON_COLON] = ACTIONS(2845),
    [anon_sym_AMP] = ACTIONS(2843),
    [anon_sym_LBRACK] = ACTIONS(2843),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2845),
    [anon_sym_LBRACE] = ACTIONS(2843),
    [anon_sym_LT_AT] = ACTIONS(2843),
    [anon_sym_LT_AT_AT] = ACTIONS(2843),
    [anon_sym_DOT] = ACTIONS(2843),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2845),
    [anon_sym_new] = ACTIONS(2843),
    [anon_sym_return_BANG] = ACTIONS(2845),
    [anon_sym_yield] = ACTIONS(2843),
    [anon_sym_yield_BANG] = ACTIONS(2845),
    [anon_sym_lazy] = ACTIONS(2843),
    [anon_sym_assert] = ACTIONS(2843),
    [anon_sym_upcast] = ACTIONS(2843),
    [anon_sym_downcast] = ACTIONS(2843),
    [anon_sym_COLON_GT] = ACTIONS(2845),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2845),
    [anon_sym_for] = ACTIONS(2843),
    [anon_sym_while] = ACTIONS(2843),
    [anon_sym_if] = ACTIONS(2843),
    [anon_sym_fun] = ACTIONS(2843),
    [anon_sym_try] = ACTIONS(2843),
    [anon_sym_match] = ACTIONS(2843),
    [anon_sym_match_BANG] = ACTIONS(2845),
    [anon_sym_function] = ACTIONS(2843),
    [anon_sym_LT_DASH] = ACTIONS(2843),
    [anon_sym_DOT_LBRACK] = ACTIONS(2845),
    [anon_sym_LT] = ACTIONS(2845),
    [anon_sym_GT] = ACTIONS(2843),
    [anon_sym_use] = ACTIONS(2843),
    [anon_sym_use_BANG] = ACTIONS(2845),
    [anon_sym_do_BANG] = ACTIONS(2845),
    [anon_sym_begin] = ACTIONS(2843),
    [anon_sym_LPAREN2] = ACTIONS(2843),
    [anon_sym_or] = ACTIONS(2843),
    [aux_sym_char_token1] = ACTIONS(2845),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2843),
    [anon_sym_DQUOTE] = ACTIONS(2843),
    [anon_sym_AT_DQUOTE] = ACTIONS(2845),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2845),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2845),
    [sym_bool] = ACTIONS(2843),
    [sym_unit] = ACTIONS(2845),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2843),
    [sym_op_identifier] = ACTIONS(2843),
    [anon_sym_PLUS] = ACTIONS(2843),
    [anon_sym_DASH] = ACTIONS(2843),
    [anon_sym_PLUS_DOT] = ACTIONS(2843),
    [anon_sym_DASH_DOT] = ACTIONS(2843),
    [anon_sym_PERCENT] = ACTIONS(2843),
    [anon_sym_AMP_AMP] = ACTIONS(2843),
    [anon_sym_TILDE] = ACTIONS(2845),
    [aux_sym_prefix_op_token1] = ACTIONS(2843),
    [aux_sym_infix_op_token1] = ACTIONS(2845),
    [aux_sym_infix_op_token2] = ACTIONS(2843),
    [anon_sym_PIPE_PIPE] = ACTIONS(2843),
    [anon_sym_BANG_EQ] = ACTIONS(2843),
    [anon_sym_COLON_EQ] = ACTIONS(2845),
    [anon_sym_DOLLAR] = ACTIONS(2843),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2843),
    [sym_int] = ACTIONS(2843),
    [sym_xint] = ACTIONS(2845),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2845),
    [sym__newline] = ACTIONS(2845),
  },
  [2153] = {
    [sym_block_comment] = STATE(2153),
    [sym_compiler_directive_decl] = STATE(2153),
    [sym_fsi_directive_decl] = STATE(2153),
    [sym_preproc_line] = STATE(2153),
    [sym_identifier] = ACTIONS(3103),
    [anon_sym_EQ] = ACTIONS(3105),
    [anon_sym_COLON] = ACTIONS(3103),
    [anon_sym_return] = ACTIONS(3103),
    [anon_sym_do] = ACTIONS(3103),
    [anon_sym_let] = ACTIONS(3103),
    [anon_sym_let_BANG] = ACTIONS(3105),
    [anon_sym_LPAREN] = ACTIONS(3103),
    [anon_sym_COMMA] = ACTIONS(3105),
    [anon_sym_null] = ACTIONS(3103),
    [anon_sym_QMARK] = ACTIONS(3103),
    [anon_sym_COLON_QMARK] = ACTIONS(3103),
    [anon_sym_COLON_COLON] = ACTIONS(3105),
    [anon_sym_AMP] = ACTIONS(3103),
    [anon_sym_LBRACK] = ACTIONS(3103),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3105),
    [anon_sym_LBRACE] = ACTIONS(3103),
    [anon_sym_LT_AT] = ACTIONS(3103),
    [anon_sym_LT_AT_AT] = ACTIONS(3103),
    [anon_sym_DOT] = ACTIONS(3103),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3105),
    [anon_sym_new] = ACTIONS(3103),
    [anon_sym_return_BANG] = ACTIONS(3105),
    [anon_sym_yield] = ACTIONS(3103),
    [anon_sym_yield_BANG] = ACTIONS(3105),
    [anon_sym_lazy] = ACTIONS(3103),
    [anon_sym_assert] = ACTIONS(3103),
    [anon_sym_upcast] = ACTIONS(3103),
    [anon_sym_downcast] = ACTIONS(3103),
    [anon_sym_COLON_GT] = ACTIONS(3105),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3105),
    [anon_sym_for] = ACTIONS(3103),
    [anon_sym_while] = ACTIONS(3103),
    [anon_sym_if] = ACTIONS(3103),
    [anon_sym_fun] = ACTIONS(3103),
    [anon_sym_try] = ACTIONS(3103),
    [anon_sym_match] = ACTIONS(3103),
    [anon_sym_match_BANG] = ACTIONS(3105),
    [anon_sym_function] = ACTIONS(3103),
    [anon_sym_LT_DASH] = ACTIONS(3103),
    [anon_sym_DOT_LBRACK] = ACTIONS(3105),
    [anon_sym_LT] = ACTIONS(3105),
    [anon_sym_GT] = ACTIONS(3103),
    [anon_sym_use] = ACTIONS(3103),
    [anon_sym_use_BANG] = ACTIONS(3105),
    [anon_sym_do_BANG] = ACTIONS(3105),
    [anon_sym_begin] = ACTIONS(3103),
    [anon_sym_LPAREN2] = ACTIONS(3103),
    [anon_sym_or] = ACTIONS(3103),
    [aux_sym_char_token1] = ACTIONS(3105),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3103),
    [anon_sym_DQUOTE] = ACTIONS(3103),
    [anon_sym_AT_DQUOTE] = ACTIONS(3105),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3105),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3105),
    [sym_bool] = ACTIONS(3103),
    [sym_unit] = ACTIONS(3105),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3103),
    [sym_op_identifier] = ACTIONS(3103),
    [anon_sym_PLUS] = ACTIONS(3103),
    [anon_sym_DASH] = ACTIONS(3103),
    [anon_sym_PLUS_DOT] = ACTIONS(3103),
    [anon_sym_DASH_DOT] = ACTIONS(3103),
    [anon_sym_PERCENT] = ACTIONS(3103),
    [anon_sym_AMP_AMP] = ACTIONS(3103),
    [anon_sym_TILDE] = ACTIONS(3105),
    [aux_sym_prefix_op_token1] = ACTIONS(3103),
    [aux_sym_infix_op_token1] = ACTIONS(3105),
    [aux_sym_infix_op_token2] = ACTIONS(3103),
    [anon_sym_PIPE_PIPE] = ACTIONS(3103),
    [anon_sym_BANG_EQ] = ACTIONS(3103),
    [anon_sym_COLON_EQ] = ACTIONS(3105),
    [anon_sym_DOLLAR] = ACTIONS(3103),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3103),
    [sym_int] = ACTIONS(3103),
    [sym_xint] = ACTIONS(3105),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3105),
    [sym__newline] = ACTIONS(3105),
  },
  [2154] = {
    [sym_block_comment] = STATE(2154),
    [sym_compiler_directive_decl] = STATE(2154),
    [sym_fsi_directive_decl] = STATE(2154),
    [sym_preproc_line] = STATE(2154),
    [sym_identifier] = ACTIONS(3107),
    [anon_sym_EQ] = ACTIONS(3109),
    [anon_sym_COLON] = ACTIONS(3107),
    [anon_sym_return] = ACTIONS(3107),
    [anon_sym_do] = ACTIONS(3107),
    [anon_sym_let] = ACTIONS(3107),
    [anon_sym_let_BANG] = ACTIONS(3109),
    [anon_sym_LPAREN] = ACTIONS(3107),
    [anon_sym_COMMA] = ACTIONS(3109),
    [anon_sym_null] = ACTIONS(3107),
    [anon_sym_QMARK] = ACTIONS(3107),
    [anon_sym_COLON_QMARK] = ACTIONS(3107),
    [anon_sym_COLON_COLON] = ACTIONS(3109),
    [anon_sym_AMP] = ACTIONS(3107),
    [anon_sym_LBRACK] = ACTIONS(3107),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3109),
    [anon_sym_LBRACE] = ACTIONS(3107),
    [anon_sym_LT_AT] = ACTIONS(3107),
    [anon_sym_LT_AT_AT] = ACTIONS(3107),
    [anon_sym_DOT] = ACTIONS(3107),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3109),
    [anon_sym_new] = ACTIONS(3107),
    [anon_sym_return_BANG] = ACTIONS(3109),
    [anon_sym_yield] = ACTIONS(3107),
    [anon_sym_yield_BANG] = ACTIONS(3109),
    [anon_sym_lazy] = ACTIONS(3107),
    [anon_sym_assert] = ACTIONS(3107),
    [anon_sym_upcast] = ACTIONS(3107),
    [anon_sym_downcast] = ACTIONS(3107),
    [anon_sym_COLON_GT] = ACTIONS(3109),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3109),
    [anon_sym_for] = ACTIONS(3107),
    [anon_sym_while] = ACTIONS(3107),
    [anon_sym_if] = ACTIONS(3107),
    [anon_sym_fun] = ACTIONS(3107),
    [anon_sym_try] = ACTIONS(3107),
    [anon_sym_match] = ACTIONS(3107),
    [anon_sym_match_BANG] = ACTIONS(3109),
    [anon_sym_function] = ACTIONS(3107),
    [anon_sym_LT_DASH] = ACTIONS(3107),
    [anon_sym_DOT_LBRACK] = ACTIONS(3109),
    [anon_sym_LT] = ACTIONS(3109),
    [anon_sym_GT] = ACTIONS(3107),
    [anon_sym_use] = ACTIONS(3107),
    [anon_sym_use_BANG] = ACTIONS(3109),
    [anon_sym_do_BANG] = ACTIONS(3109),
    [anon_sym_begin] = ACTIONS(3107),
    [anon_sym_LPAREN2] = ACTIONS(3107),
    [anon_sym_or] = ACTIONS(3107),
    [aux_sym_char_token1] = ACTIONS(3109),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3107),
    [anon_sym_DQUOTE] = ACTIONS(3107),
    [anon_sym_AT_DQUOTE] = ACTIONS(3109),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3109),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3109),
    [sym_bool] = ACTIONS(3107),
    [sym_unit] = ACTIONS(3109),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3107),
    [sym_op_identifier] = ACTIONS(3107),
    [anon_sym_PLUS] = ACTIONS(3107),
    [anon_sym_DASH] = ACTIONS(3107),
    [anon_sym_PLUS_DOT] = ACTIONS(3107),
    [anon_sym_DASH_DOT] = ACTIONS(3107),
    [anon_sym_PERCENT] = ACTIONS(3107),
    [anon_sym_AMP_AMP] = ACTIONS(3107),
    [anon_sym_TILDE] = ACTIONS(3109),
    [aux_sym_prefix_op_token1] = ACTIONS(3107),
    [aux_sym_infix_op_token1] = ACTIONS(3109),
    [aux_sym_infix_op_token2] = ACTIONS(3107),
    [anon_sym_PIPE_PIPE] = ACTIONS(3107),
    [anon_sym_BANG_EQ] = ACTIONS(3107),
    [anon_sym_COLON_EQ] = ACTIONS(3109),
    [anon_sym_DOLLAR] = ACTIONS(3107),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3107),
    [sym_int] = ACTIONS(3107),
    [sym_xint] = ACTIONS(3109),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3109),
    [sym__newline] = ACTIONS(3109),
  },
  [2155] = {
    [sym_block_comment] = STATE(2155),
    [sym_compiler_directive_decl] = STATE(2155),
    [sym_fsi_directive_decl] = STATE(2155),
    [sym_preproc_line] = STATE(2155),
    [sym_identifier] = ACTIONS(3055),
    [anon_sym_EQ] = ACTIONS(3057),
    [anon_sym_COLON] = ACTIONS(3055),
    [anon_sym_return] = ACTIONS(3055),
    [anon_sym_do] = ACTIONS(3055),
    [anon_sym_let] = ACTIONS(3055),
    [anon_sym_let_BANG] = ACTIONS(3057),
    [anon_sym_LPAREN] = ACTIONS(3055),
    [anon_sym_COMMA] = ACTIONS(3057),
    [anon_sym_null] = ACTIONS(3055),
    [anon_sym_QMARK] = ACTIONS(3055),
    [anon_sym_COLON_QMARK] = ACTIONS(3055),
    [anon_sym_COLON_COLON] = ACTIONS(3057),
    [anon_sym_AMP] = ACTIONS(3055),
    [anon_sym_LBRACK] = ACTIONS(3055),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3057),
    [anon_sym_LBRACE] = ACTIONS(3055),
    [anon_sym_LT_AT] = ACTIONS(3055),
    [anon_sym_LT_AT_AT] = ACTIONS(3055),
    [anon_sym_DOT] = ACTIONS(3055),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3057),
    [anon_sym_new] = ACTIONS(3055),
    [anon_sym_return_BANG] = ACTIONS(3057),
    [anon_sym_yield] = ACTIONS(3055),
    [anon_sym_yield_BANG] = ACTIONS(3057),
    [anon_sym_lazy] = ACTIONS(3055),
    [anon_sym_assert] = ACTIONS(3055),
    [anon_sym_upcast] = ACTIONS(3055),
    [anon_sym_downcast] = ACTIONS(3055),
    [anon_sym_COLON_GT] = ACTIONS(3057),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3057),
    [anon_sym_for] = ACTIONS(3055),
    [anon_sym_while] = ACTIONS(3055),
    [anon_sym_if] = ACTIONS(3055),
    [anon_sym_fun] = ACTIONS(3055),
    [anon_sym_try] = ACTIONS(3055),
    [anon_sym_match] = ACTIONS(3055),
    [anon_sym_match_BANG] = ACTIONS(3057),
    [anon_sym_function] = ACTIONS(3055),
    [anon_sym_LT_DASH] = ACTIONS(3055),
    [anon_sym_DOT_LBRACK] = ACTIONS(3057),
    [anon_sym_LT] = ACTIONS(3057),
    [anon_sym_use] = ACTIONS(3055),
    [anon_sym_use_BANG] = ACTIONS(3057),
    [anon_sym_do_BANG] = ACTIONS(3057),
    [anon_sym_DOT_DOT] = ACTIONS(3057),
    [anon_sym_begin] = ACTIONS(3055),
    [anon_sym_LPAREN2] = ACTIONS(3055),
    [anon_sym_or] = ACTIONS(3055),
    [aux_sym_char_token1] = ACTIONS(3057),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3055),
    [anon_sym_DQUOTE] = ACTIONS(3055),
    [anon_sym_AT_DQUOTE] = ACTIONS(3057),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3057),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3057),
    [sym_bool] = ACTIONS(3055),
    [sym_unit] = ACTIONS(3057),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3055),
    [sym_op_identifier] = ACTIONS(3055),
    [anon_sym_PLUS] = ACTIONS(3055),
    [anon_sym_DASH] = ACTIONS(3055),
    [anon_sym_PLUS_DOT] = ACTIONS(3055),
    [anon_sym_DASH_DOT] = ACTIONS(3055),
    [anon_sym_PERCENT] = ACTIONS(3055),
    [anon_sym_AMP_AMP] = ACTIONS(3055),
    [anon_sym_TILDE] = ACTIONS(3057),
    [aux_sym_prefix_op_token1] = ACTIONS(3055),
    [aux_sym_infix_op_token1] = ACTIONS(3057),
    [aux_sym_infix_op_token2] = ACTIONS(3055),
    [anon_sym_PIPE_PIPE] = ACTIONS(3055),
    [anon_sym_BANG_EQ] = ACTIONS(3055),
    [anon_sym_COLON_EQ] = ACTIONS(3057),
    [anon_sym_DOLLAR] = ACTIONS(3055),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3055),
    [sym_int] = ACTIONS(3055),
    [sym_xint] = ACTIONS(3057),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3057),
    [sym__newline] = ACTIONS(3057),
  },
  [2156] = {
    [sym_block_comment] = STATE(2156),
    [sym_compiler_directive_decl] = STATE(2156),
    [sym_fsi_directive_decl] = STATE(2156),
    [sym_preproc_line] = STATE(2156),
    [sym_identifier] = ACTIONS(2938),
    [anon_sym_EQ] = ACTIONS(2940),
    [anon_sym_COLON] = ACTIONS(2938),
    [anon_sym_return] = ACTIONS(2938),
    [anon_sym_do] = ACTIONS(2938),
    [anon_sym_let] = ACTIONS(2938),
    [anon_sym_let_BANG] = ACTIONS(2940),
    [anon_sym_LPAREN] = ACTIONS(2938),
    [anon_sym_COMMA] = ACTIONS(2940),
    [anon_sym_null] = ACTIONS(2938),
    [anon_sym_QMARK] = ACTIONS(2938),
    [anon_sym_COLON_QMARK] = ACTIONS(2938),
    [anon_sym_COLON_COLON] = ACTIONS(2940),
    [anon_sym_AMP] = ACTIONS(2938),
    [anon_sym_LBRACK] = ACTIONS(2938),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2940),
    [anon_sym_LBRACE] = ACTIONS(2938),
    [anon_sym_LT_AT] = ACTIONS(2938),
    [anon_sym_LT_AT_AT] = ACTIONS(2938),
    [anon_sym_DOT] = ACTIONS(2938),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2940),
    [anon_sym_new] = ACTIONS(2938),
    [anon_sym_return_BANG] = ACTIONS(2940),
    [anon_sym_yield] = ACTIONS(2938),
    [anon_sym_yield_BANG] = ACTIONS(2940),
    [anon_sym_lazy] = ACTIONS(2938),
    [anon_sym_assert] = ACTIONS(2938),
    [anon_sym_upcast] = ACTIONS(2938),
    [anon_sym_downcast] = ACTIONS(2938),
    [anon_sym_COLON_GT] = ACTIONS(2940),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2940),
    [anon_sym_for] = ACTIONS(2938),
    [anon_sym_while] = ACTIONS(2938),
    [anon_sym_if] = ACTIONS(2938),
    [anon_sym_fun] = ACTIONS(2938),
    [anon_sym_try] = ACTIONS(2938),
    [anon_sym_match] = ACTIONS(2938),
    [anon_sym_match_BANG] = ACTIONS(2940),
    [anon_sym_function] = ACTIONS(2938),
    [anon_sym_LT_DASH] = ACTIONS(2938),
    [anon_sym_DOT_LBRACK] = ACTIONS(2940),
    [anon_sym_LT] = ACTIONS(2940),
    [anon_sym_use] = ACTIONS(2938),
    [anon_sym_use_BANG] = ACTIONS(2940),
    [anon_sym_do_BANG] = ACTIONS(2940),
    [anon_sym_DOT_DOT] = ACTIONS(2940),
    [anon_sym_begin] = ACTIONS(2938),
    [anon_sym_LPAREN2] = ACTIONS(2938),
    [anon_sym_or] = ACTIONS(2938),
    [aux_sym_char_token1] = ACTIONS(2940),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2938),
    [anon_sym_DQUOTE] = ACTIONS(2938),
    [anon_sym_AT_DQUOTE] = ACTIONS(2940),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2940),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2940),
    [sym_bool] = ACTIONS(2938),
    [sym_unit] = ACTIONS(2940),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2938),
    [sym_op_identifier] = ACTIONS(2938),
    [anon_sym_PLUS] = ACTIONS(2938),
    [anon_sym_DASH] = ACTIONS(2938),
    [anon_sym_PLUS_DOT] = ACTIONS(2938),
    [anon_sym_DASH_DOT] = ACTIONS(2938),
    [anon_sym_PERCENT] = ACTIONS(2938),
    [anon_sym_AMP_AMP] = ACTIONS(2938),
    [anon_sym_TILDE] = ACTIONS(2940),
    [aux_sym_prefix_op_token1] = ACTIONS(2938),
    [aux_sym_infix_op_token1] = ACTIONS(2940),
    [aux_sym_infix_op_token2] = ACTIONS(2938),
    [anon_sym_PIPE_PIPE] = ACTIONS(2938),
    [anon_sym_BANG_EQ] = ACTIONS(2938),
    [anon_sym_COLON_EQ] = ACTIONS(2940),
    [anon_sym_DOLLAR] = ACTIONS(2938),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2938),
    [sym_int] = ACTIONS(2938),
    [sym_xint] = ACTIONS(2940),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2940),
    [sym__newline] = ACTIONS(2940),
  },
  [2157] = {
    [sym_block_comment] = STATE(2157),
    [sym_compiler_directive_decl] = STATE(2157),
    [sym_fsi_directive_decl] = STATE(2157),
    [sym_preproc_line] = STATE(2157),
    [sym_identifier] = ACTIONS(2946),
    [anon_sym_EQ] = ACTIONS(2948),
    [anon_sym_COLON] = ACTIONS(2946),
    [anon_sym_return] = ACTIONS(2946),
    [anon_sym_do] = ACTIONS(2946),
    [anon_sym_let] = ACTIONS(2946),
    [anon_sym_let_BANG] = ACTIONS(2948),
    [anon_sym_LPAREN] = ACTIONS(2946),
    [anon_sym_COMMA] = ACTIONS(2948),
    [anon_sym_null] = ACTIONS(2946),
    [anon_sym_QMARK] = ACTIONS(2946),
    [anon_sym_COLON_QMARK] = ACTIONS(2946),
    [anon_sym_COLON_COLON] = ACTIONS(2948),
    [anon_sym_AMP] = ACTIONS(2946),
    [anon_sym_LBRACK] = ACTIONS(2946),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2948),
    [anon_sym_LBRACE] = ACTIONS(2946),
    [anon_sym_LT_AT] = ACTIONS(2946),
    [anon_sym_LT_AT_AT] = ACTIONS(2946),
    [anon_sym_DOT] = ACTIONS(2946),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2948),
    [anon_sym_new] = ACTIONS(2946),
    [anon_sym_return_BANG] = ACTIONS(2948),
    [anon_sym_yield] = ACTIONS(2946),
    [anon_sym_yield_BANG] = ACTIONS(2948),
    [anon_sym_lazy] = ACTIONS(2946),
    [anon_sym_assert] = ACTIONS(2946),
    [anon_sym_upcast] = ACTIONS(2946),
    [anon_sym_downcast] = ACTIONS(2946),
    [anon_sym_COLON_GT] = ACTIONS(2948),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2948),
    [anon_sym_for] = ACTIONS(2946),
    [anon_sym_while] = ACTIONS(2946),
    [anon_sym_if] = ACTIONS(2946),
    [anon_sym_fun] = ACTIONS(2946),
    [anon_sym_try] = ACTIONS(2946),
    [anon_sym_match] = ACTIONS(2946),
    [anon_sym_match_BANG] = ACTIONS(2948),
    [anon_sym_function] = ACTIONS(2946),
    [anon_sym_LT_DASH] = ACTIONS(2946),
    [anon_sym_DOT_LBRACK] = ACTIONS(2948),
    [anon_sym_LT] = ACTIONS(2948),
    [anon_sym_use] = ACTIONS(2946),
    [anon_sym_use_BANG] = ACTIONS(2948),
    [anon_sym_do_BANG] = ACTIONS(2948),
    [anon_sym_DOT_DOT] = ACTIONS(2948),
    [anon_sym_begin] = ACTIONS(2946),
    [anon_sym_LPAREN2] = ACTIONS(2946),
    [anon_sym_or] = ACTIONS(2946),
    [aux_sym_char_token1] = ACTIONS(2948),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2946),
    [anon_sym_DQUOTE] = ACTIONS(2946),
    [anon_sym_AT_DQUOTE] = ACTIONS(2948),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2948),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2948),
    [sym_bool] = ACTIONS(2946),
    [sym_unit] = ACTIONS(2948),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2946),
    [sym_op_identifier] = ACTIONS(2946),
    [anon_sym_PLUS] = ACTIONS(2946),
    [anon_sym_DASH] = ACTIONS(2946),
    [anon_sym_PLUS_DOT] = ACTIONS(2946),
    [anon_sym_DASH_DOT] = ACTIONS(2946),
    [anon_sym_PERCENT] = ACTIONS(2946),
    [anon_sym_AMP_AMP] = ACTIONS(2946),
    [anon_sym_TILDE] = ACTIONS(2948),
    [aux_sym_prefix_op_token1] = ACTIONS(2946),
    [aux_sym_infix_op_token1] = ACTIONS(2948),
    [aux_sym_infix_op_token2] = ACTIONS(2946),
    [anon_sym_PIPE_PIPE] = ACTIONS(2946),
    [anon_sym_BANG_EQ] = ACTIONS(2946),
    [anon_sym_COLON_EQ] = ACTIONS(2948),
    [anon_sym_DOLLAR] = ACTIONS(2946),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2946),
    [sym_int] = ACTIONS(2946),
    [sym_xint] = ACTIONS(2948),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2948),
    [sym__newline] = ACTIONS(2948),
  },
  [2158] = {
    [sym_block_comment] = STATE(2158),
    [sym_compiler_directive_decl] = STATE(2158),
    [sym_fsi_directive_decl] = STATE(2158),
    [sym_preproc_line] = STATE(2158),
    [sym_identifier] = ACTIONS(2831),
    [anon_sym_EQ] = ACTIONS(2833),
    [anon_sym_COLON] = ACTIONS(2831),
    [anon_sym_return] = ACTIONS(2831),
    [anon_sym_do] = ACTIONS(2831),
    [anon_sym_let] = ACTIONS(2831),
    [anon_sym_let_BANG] = ACTIONS(2833),
    [anon_sym_LPAREN] = ACTIONS(2831),
    [anon_sym_COMMA] = ACTIONS(2833),
    [anon_sym_null] = ACTIONS(2831),
    [anon_sym_QMARK] = ACTIONS(2831),
    [anon_sym_COLON_QMARK] = ACTIONS(2831),
    [anon_sym_COLON_COLON] = ACTIONS(2833),
    [anon_sym_AMP] = ACTIONS(2831),
    [anon_sym_LBRACK] = ACTIONS(2831),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2833),
    [anon_sym_LBRACE] = ACTIONS(2831),
    [anon_sym_LT_AT] = ACTIONS(2831),
    [anon_sym_LT_AT_AT] = ACTIONS(2831),
    [anon_sym_DOT] = ACTIONS(2831),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2833),
    [anon_sym_new] = ACTIONS(2831),
    [anon_sym_return_BANG] = ACTIONS(2833),
    [anon_sym_yield] = ACTIONS(2831),
    [anon_sym_yield_BANG] = ACTIONS(2833),
    [anon_sym_lazy] = ACTIONS(2831),
    [anon_sym_assert] = ACTIONS(2831),
    [anon_sym_upcast] = ACTIONS(2831),
    [anon_sym_downcast] = ACTIONS(2831),
    [anon_sym_COLON_GT] = ACTIONS(2833),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2833),
    [anon_sym_for] = ACTIONS(2831),
    [anon_sym_while] = ACTIONS(2831),
    [anon_sym_if] = ACTIONS(2831),
    [anon_sym_fun] = ACTIONS(2831),
    [anon_sym_try] = ACTIONS(2831),
    [anon_sym_match] = ACTIONS(2831),
    [anon_sym_match_BANG] = ACTIONS(2833),
    [anon_sym_function] = ACTIONS(2831),
    [anon_sym_LT_DASH] = ACTIONS(2831),
    [anon_sym_DOT_LBRACK] = ACTIONS(2833),
    [anon_sym_LT] = ACTIONS(2833),
    [anon_sym_use] = ACTIONS(2831),
    [anon_sym_use_BANG] = ACTIONS(2833),
    [anon_sym_do_BANG] = ACTIONS(2833),
    [anon_sym_DOT_DOT] = ACTIONS(2833),
    [anon_sym_begin] = ACTIONS(2831),
    [anon_sym_LPAREN2] = ACTIONS(2831),
    [anon_sym_or] = ACTIONS(2831),
    [aux_sym_char_token1] = ACTIONS(2833),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2831),
    [anon_sym_DQUOTE] = ACTIONS(2831),
    [anon_sym_AT_DQUOTE] = ACTIONS(2833),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2833),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2833),
    [sym_bool] = ACTIONS(2831),
    [sym_unit] = ACTIONS(2833),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2831),
    [sym_op_identifier] = ACTIONS(2831),
    [anon_sym_PLUS] = ACTIONS(2831),
    [anon_sym_DASH] = ACTIONS(2831),
    [anon_sym_PLUS_DOT] = ACTIONS(2831),
    [anon_sym_DASH_DOT] = ACTIONS(2831),
    [anon_sym_PERCENT] = ACTIONS(2831),
    [anon_sym_AMP_AMP] = ACTIONS(2831),
    [anon_sym_TILDE] = ACTIONS(2833),
    [aux_sym_prefix_op_token1] = ACTIONS(2831),
    [aux_sym_infix_op_token1] = ACTIONS(2833),
    [aux_sym_infix_op_token2] = ACTIONS(2831),
    [anon_sym_PIPE_PIPE] = ACTIONS(2831),
    [anon_sym_BANG_EQ] = ACTIONS(2831),
    [anon_sym_COLON_EQ] = ACTIONS(2833),
    [anon_sym_DOLLAR] = ACTIONS(2831),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2831),
    [sym_int] = ACTIONS(2831),
    [sym_xint] = ACTIONS(2833),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2833),
    [sym__newline] = ACTIONS(2833),
  },
  [2159] = {
    [sym_block_comment] = STATE(2159),
    [sym_compiler_directive_decl] = STATE(2159),
    [sym_fsi_directive_decl] = STATE(2159),
    [sym_preproc_line] = STATE(2159),
    [sym_identifier] = ACTIONS(2984),
    [anon_sym_EQ] = ACTIONS(2986),
    [anon_sym_COLON] = ACTIONS(2984),
    [anon_sym_return] = ACTIONS(2984),
    [anon_sym_do] = ACTIONS(2984),
    [anon_sym_let] = ACTIONS(2984),
    [anon_sym_let_BANG] = ACTIONS(2986),
    [anon_sym_LPAREN] = ACTIONS(2984),
    [anon_sym_COMMA] = ACTIONS(2986),
    [anon_sym_null] = ACTIONS(2984),
    [anon_sym_QMARK] = ACTIONS(2984),
    [anon_sym_COLON_QMARK] = ACTIONS(2984),
    [anon_sym_COLON_COLON] = ACTIONS(2986),
    [anon_sym_AMP] = ACTIONS(2984),
    [anon_sym_LBRACK] = ACTIONS(2984),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2986),
    [anon_sym_LBRACE] = ACTIONS(2984),
    [anon_sym_LT_AT] = ACTIONS(2984),
    [anon_sym_LT_AT_AT] = ACTIONS(2984),
    [anon_sym_DOT] = ACTIONS(2984),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2986),
    [anon_sym_new] = ACTIONS(2984),
    [anon_sym_return_BANG] = ACTIONS(2986),
    [anon_sym_yield] = ACTIONS(2984),
    [anon_sym_yield_BANG] = ACTIONS(2986),
    [anon_sym_lazy] = ACTIONS(2984),
    [anon_sym_assert] = ACTIONS(2984),
    [anon_sym_upcast] = ACTIONS(2984),
    [anon_sym_downcast] = ACTIONS(2984),
    [anon_sym_COLON_GT] = ACTIONS(2986),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2986),
    [anon_sym_for] = ACTIONS(2984),
    [anon_sym_while] = ACTIONS(2984),
    [anon_sym_if] = ACTIONS(2984),
    [anon_sym_fun] = ACTIONS(2984),
    [anon_sym_try] = ACTIONS(2984),
    [anon_sym_match] = ACTIONS(2984),
    [anon_sym_match_BANG] = ACTIONS(2986),
    [anon_sym_function] = ACTIONS(2984),
    [anon_sym_LT_DASH] = ACTIONS(2984),
    [anon_sym_DOT_LBRACK] = ACTIONS(2986),
    [anon_sym_LT] = ACTIONS(2986),
    [anon_sym_use] = ACTIONS(2984),
    [anon_sym_use_BANG] = ACTIONS(2986),
    [anon_sym_do_BANG] = ACTIONS(2986),
    [anon_sym_begin] = ACTIONS(2984),
    [anon_sym_LPAREN2] = ACTIONS(2984),
    [anon_sym_or] = ACTIONS(2984),
    [aux_sym_char_token1] = ACTIONS(2986),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2984),
    [anon_sym_DQUOTE] = ACTIONS(2984),
    [anon_sym_AT_DQUOTE] = ACTIONS(2986),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2986),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2986),
    [sym_bool] = ACTIONS(2984),
    [sym_unit] = ACTIONS(2986),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2984),
    [sym_op_identifier] = ACTIONS(2984),
    [anon_sym_PLUS] = ACTIONS(2984),
    [anon_sym_DASH] = ACTIONS(2984),
    [anon_sym_PLUS_DOT] = ACTIONS(2984),
    [anon_sym_DASH_DOT] = ACTIONS(2984),
    [anon_sym_PERCENT] = ACTIONS(2984),
    [anon_sym_AMP_AMP] = ACTIONS(2984),
    [anon_sym_TILDE] = ACTIONS(2986),
    [aux_sym_prefix_op_token1] = ACTIONS(2984),
    [aux_sym_infix_op_token1] = ACTIONS(2986),
    [aux_sym_infix_op_token2] = ACTIONS(2984),
    [anon_sym_PIPE_PIPE] = ACTIONS(2984),
    [anon_sym_BANG_EQ] = ACTIONS(2984),
    [anon_sym_COLON_EQ] = ACTIONS(2986),
    [anon_sym_DOLLAR] = ACTIONS(2984),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2984),
    [sym_int] = ACTIONS(2984),
    [sym_xint] = ACTIONS(2986),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2986),
    [anon_sym_POUNDendif] = ACTIONS(2986),
    [sym__newline] = ACTIONS(2986),
  },
  [2160] = {
    [sym_block_comment] = STATE(2160),
    [sym_compiler_directive_decl] = STATE(2160),
    [sym_fsi_directive_decl] = STATE(2160),
    [sym_preproc_line] = STATE(2160),
    [sym_identifier] = ACTIONS(3067),
    [anon_sym_EQ] = ACTIONS(3069),
    [anon_sym_COLON] = ACTIONS(3067),
    [anon_sym_return] = ACTIONS(3067),
    [anon_sym_do] = ACTIONS(3067),
    [anon_sym_let] = ACTIONS(3067),
    [anon_sym_let_BANG] = ACTIONS(3069),
    [anon_sym_LPAREN] = ACTIONS(3067),
    [anon_sym_COMMA] = ACTIONS(3069),
    [anon_sym_null] = ACTIONS(3067),
    [anon_sym_QMARK] = ACTIONS(3067),
    [anon_sym_COLON_QMARK] = ACTIONS(3067),
    [anon_sym_COLON_COLON] = ACTIONS(3069),
    [anon_sym_AMP] = ACTIONS(3067),
    [anon_sym_LBRACK] = ACTIONS(3067),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3069),
    [anon_sym_LBRACE] = ACTIONS(3067),
    [anon_sym_LT_AT] = ACTIONS(3067),
    [anon_sym_LT_AT_AT] = ACTIONS(3067),
    [anon_sym_DOT] = ACTIONS(3067),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3069),
    [anon_sym_new] = ACTIONS(3067),
    [anon_sym_return_BANG] = ACTIONS(3069),
    [anon_sym_yield] = ACTIONS(3067),
    [anon_sym_yield_BANG] = ACTIONS(3069),
    [anon_sym_lazy] = ACTIONS(3067),
    [anon_sym_assert] = ACTIONS(3067),
    [anon_sym_upcast] = ACTIONS(3067),
    [anon_sym_downcast] = ACTIONS(3067),
    [anon_sym_COLON_GT] = ACTIONS(3069),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3069),
    [anon_sym_for] = ACTIONS(3067),
    [anon_sym_while] = ACTIONS(3067),
    [anon_sym_if] = ACTIONS(3067),
    [anon_sym_fun] = ACTIONS(3067),
    [anon_sym_try] = ACTIONS(3067),
    [anon_sym_match] = ACTIONS(3067),
    [anon_sym_match_BANG] = ACTIONS(3069),
    [anon_sym_function] = ACTIONS(3067),
    [anon_sym_LT_DASH] = ACTIONS(3067),
    [anon_sym_DOT_LBRACK] = ACTIONS(3069),
    [anon_sym_LT] = ACTIONS(3069),
    [anon_sym_use] = ACTIONS(3067),
    [anon_sym_use_BANG] = ACTIONS(3069),
    [anon_sym_do_BANG] = ACTIONS(3069),
    [anon_sym_DOT_DOT] = ACTIONS(3069),
    [anon_sym_begin] = ACTIONS(3067),
    [anon_sym_LPAREN2] = ACTIONS(3067),
    [anon_sym_or] = ACTIONS(3067),
    [aux_sym_char_token1] = ACTIONS(3069),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3067),
    [anon_sym_DQUOTE] = ACTIONS(3067),
    [anon_sym_AT_DQUOTE] = ACTIONS(3069),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3069),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3069),
    [sym_bool] = ACTIONS(3067),
    [sym_unit] = ACTIONS(3069),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3067),
    [sym_op_identifier] = ACTIONS(3067),
    [anon_sym_PLUS] = ACTIONS(3067),
    [anon_sym_DASH] = ACTIONS(3067),
    [anon_sym_PLUS_DOT] = ACTIONS(3067),
    [anon_sym_DASH_DOT] = ACTIONS(3067),
    [anon_sym_PERCENT] = ACTIONS(3067),
    [anon_sym_AMP_AMP] = ACTIONS(3067),
    [anon_sym_TILDE] = ACTIONS(3069),
    [aux_sym_prefix_op_token1] = ACTIONS(3067),
    [aux_sym_infix_op_token1] = ACTIONS(3069),
    [aux_sym_infix_op_token2] = ACTIONS(3067),
    [anon_sym_PIPE_PIPE] = ACTIONS(3067),
    [anon_sym_BANG_EQ] = ACTIONS(3067),
    [anon_sym_COLON_EQ] = ACTIONS(3069),
    [anon_sym_DOLLAR] = ACTIONS(3067),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3067),
    [sym_int] = ACTIONS(3067),
    [sym_xint] = ACTIONS(3069),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3069),
    [sym__newline] = ACTIONS(3069),
  },
  [2161] = {
    [sym_block_comment] = STATE(2161),
    [sym_compiler_directive_decl] = STATE(2161),
    [sym_fsi_directive_decl] = STATE(2161),
    [sym_preproc_line] = STATE(2161),
    [sym_identifier] = ACTIONS(2950),
    [anon_sym_EQ] = ACTIONS(2952),
    [anon_sym_COLON] = ACTIONS(2950),
    [anon_sym_return] = ACTIONS(2950),
    [anon_sym_do] = ACTIONS(2950),
    [anon_sym_let] = ACTIONS(2950),
    [anon_sym_let_BANG] = ACTIONS(2952),
    [anon_sym_LPAREN] = ACTIONS(2950),
    [anon_sym_COMMA] = ACTIONS(2952),
    [anon_sym_null] = ACTIONS(2950),
    [anon_sym_QMARK] = ACTIONS(2950),
    [anon_sym_COLON_QMARK] = ACTIONS(2950),
    [anon_sym_COLON_COLON] = ACTIONS(2952),
    [anon_sym_AMP] = ACTIONS(2950),
    [anon_sym_LBRACK] = ACTIONS(2950),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2952),
    [anon_sym_LBRACE] = ACTIONS(2950),
    [anon_sym_LT_AT] = ACTIONS(2950),
    [anon_sym_LT_AT_AT] = ACTIONS(2950),
    [anon_sym_DOT] = ACTIONS(2950),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2952),
    [anon_sym_new] = ACTIONS(2950),
    [anon_sym_return_BANG] = ACTIONS(2952),
    [anon_sym_yield] = ACTIONS(2950),
    [anon_sym_yield_BANG] = ACTIONS(2952),
    [anon_sym_lazy] = ACTIONS(2950),
    [anon_sym_assert] = ACTIONS(2950),
    [anon_sym_upcast] = ACTIONS(2950),
    [anon_sym_downcast] = ACTIONS(2950),
    [anon_sym_COLON_GT] = ACTIONS(2952),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2952),
    [anon_sym_for] = ACTIONS(2950),
    [anon_sym_while] = ACTIONS(2950),
    [anon_sym_if] = ACTIONS(2950),
    [anon_sym_fun] = ACTIONS(2950),
    [anon_sym_try] = ACTIONS(2950),
    [anon_sym_match] = ACTIONS(2950),
    [anon_sym_match_BANG] = ACTIONS(2952),
    [anon_sym_function] = ACTIONS(2950),
    [anon_sym_LT_DASH] = ACTIONS(2950),
    [anon_sym_DOT_LBRACK] = ACTIONS(2952),
    [anon_sym_LT] = ACTIONS(2952),
    [anon_sym_use] = ACTIONS(2950),
    [anon_sym_use_BANG] = ACTIONS(2952),
    [anon_sym_do_BANG] = ACTIONS(2952),
    [anon_sym_DOT_DOT] = ACTIONS(2952),
    [anon_sym_begin] = ACTIONS(2950),
    [anon_sym_LPAREN2] = ACTIONS(2950),
    [anon_sym_or] = ACTIONS(2950),
    [aux_sym_char_token1] = ACTIONS(2952),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2950),
    [anon_sym_DQUOTE] = ACTIONS(2950),
    [anon_sym_AT_DQUOTE] = ACTIONS(2952),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2952),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2952),
    [sym_bool] = ACTIONS(2950),
    [sym_unit] = ACTIONS(2952),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2950),
    [sym_op_identifier] = ACTIONS(2950),
    [anon_sym_PLUS] = ACTIONS(2950),
    [anon_sym_DASH] = ACTIONS(2950),
    [anon_sym_PLUS_DOT] = ACTIONS(2950),
    [anon_sym_DASH_DOT] = ACTIONS(2950),
    [anon_sym_PERCENT] = ACTIONS(2950),
    [anon_sym_AMP_AMP] = ACTIONS(2950),
    [anon_sym_TILDE] = ACTIONS(2952),
    [aux_sym_prefix_op_token1] = ACTIONS(2950),
    [aux_sym_infix_op_token1] = ACTIONS(2952),
    [aux_sym_infix_op_token2] = ACTIONS(2950),
    [anon_sym_PIPE_PIPE] = ACTIONS(2950),
    [anon_sym_BANG_EQ] = ACTIONS(2950),
    [anon_sym_COLON_EQ] = ACTIONS(2952),
    [anon_sym_DOLLAR] = ACTIONS(2950),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2950),
    [sym_int] = ACTIONS(2950),
    [sym_xint] = ACTIONS(2952),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2952),
    [sym__newline] = ACTIONS(2952),
  },
  [2162] = {
    [sym_block_comment] = STATE(2162),
    [sym_compiler_directive_decl] = STATE(2162),
    [sym_fsi_directive_decl] = STATE(2162),
    [sym_preproc_line] = STATE(2162),
    [sym_identifier] = ACTIONS(2958),
    [anon_sym_EQ] = ACTIONS(2960),
    [anon_sym_COLON] = ACTIONS(2958),
    [anon_sym_return] = ACTIONS(2958),
    [anon_sym_do] = ACTIONS(2958),
    [anon_sym_let] = ACTIONS(2958),
    [anon_sym_let_BANG] = ACTIONS(2960),
    [anon_sym_LPAREN] = ACTIONS(2958),
    [anon_sym_COMMA] = ACTIONS(2960),
    [anon_sym_null] = ACTIONS(2958),
    [anon_sym_QMARK] = ACTIONS(2958),
    [anon_sym_COLON_QMARK] = ACTIONS(2958),
    [anon_sym_COLON_COLON] = ACTIONS(2960),
    [anon_sym_AMP] = ACTIONS(2958),
    [anon_sym_LBRACK] = ACTIONS(2958),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2960),
    [anon_sym_LBRACE] = ACTIONS(2958),
    [anon_sym_LT_AT] = ACTIONS(2958),
    [anon_sym_LT_AT_AT] = ACTIONS(2958),
    [anon_sym_DOT] = ACTIONS(2958),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2960),
    [anon_sym_new] = ACTIONS(2958),
    [anon_sym_return_BANG] = ACTIONS(2960),
    [anon_sym_yield] = ACTIONS(2958),
    [anon_sym_yield_BANG] = ACTIONS(2960),
    [anon_sym_lazy] = ACTIONS(2958),
    [anon_sym_assert] = ACTIONS(2958),
    [anon_sym_upcast] = ACTIONS(2958),
    [anon_sym_downcast] = ACTIONS(2958),
    [anon_sym_COLON_GT] = ACTIONS(2960),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2960),
    [anon_sym_for] = ACTIONS(2958),
    [anon_sym_while] = ACTIONS(2958),
    [anon_sym_if] = ACTIONS(2958),
    [anon_sym_fun] = ACTIONS(2958),
    [anon_sym_try] = ACTIONS(2958),
    [anon_sym_match] = ACTIONS(2958),
    [anon_sym_match_BANG] = ACTIONS(2960),
    [anon_sym_function] = ACTIONS(2958),
    [anon_sym_LT_DASH] = ACTIONS(2958),
    [anon_sym_DOT_LBRACK] = ACTIONS(2960),
    [anon_sym_LT] = ACTIONS(2960),
    [anon_sym_use] = ACTIONS(2958),
    [anon_sym_use_BANG] = ACTIONS(2960),
    [anon_sym_do_BANG] = ACTIONS(2960),
    [anon_sym_DOT_DOT] = ACTIONS(2960),
    [anon_sym_begin] = ACTIONS(2958),
    [anon_sym_LPAREN2] = ACTIONS(2958),
    [anon_sym_or] = ACTIONS(2958),
    [aux_sym_char_token1] = ACTIONS(2960),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2958),
    [anon_sym_DQUOTE] = ACTIONS(2958),
    [anon_sym_AT_DQUOTE] = ACTIONS(2960),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2960),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2960),
    [sym_bool] = ACTIONS(2958),
    [sym_unit] = ACTIONS(2960),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2958),
    [sym_op_identifier] = ACTIONS(2958),
    [anon_sym_PLUS] = ACTIONS(2958),
    [anon_sym_DASH] = ACTIONS(2958),
    [anon_sym_PLUS_DOT] = ACTIONS(2958),
    [anon_sym_DASH_DOT] = ACTIONS(2958),
    [anon_sym_PERCENT] = ACTIONS(2958),
    [anon_sym_AMP_AMP] = ACTIONS(2958),
    [anon_sym_TILDE] = ACTIONS(2960),
    [aux_sym_prefix_op_token1] = ACTIONS(2958),
    [aux_sym_infix_op_token1] = ACTIONS(2960),
    [aux_sym_infix_op_token2] = ACTIONS(2958),
    [anon_sym_PIPE_PIPE] = ACTIONS(2958),
    [anon_sym_BANG_EQ] = ACTIONS(2958),
    [anon_sym_COLON_EQ] = ACTIONS(2960),
    [anon_sym_DOLLAR] = ACTIONS(2958),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2958),
    [sym_int] = ACTIONS(2958),
    [sym_xint] = ACTIONS(2960),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2960),
    [sym__newline] = ACTIONS(2960),
  },
  [2163] = {
    [sym_block_comment] = STATE(2163),
    [sym_compiler_directive_decl] = STATE(2163),
    [sym_fsi_directive_decl] = STATE(2163),
    [sym_preproc_line] = STATE(2163),
    [sym_identifier] = ACTIONS(2962),
    [anon_sym_EQ] = ACTIONS(2964),
    [anon_sym_COLON] = ACTIONS(2962),
    [anon_sym_return] = ACTIONS(2962),
    [anon_sym_do] = ACTIONS(2962),
    [anon_sym_let] = ACTIONS(2962),
    [anon_sym_let_BANG] = ACTIONS(2964),
    [anon_sym_LPAREN] = ACTIONS(2962),
    [anon_sym_COMMA] = ACTIONS(2964),
    [anon_sym_null] = ACTIONS(2962),
    [anon_sym_QMARK] = ACTIONS(2962),
    [anon_sym_COLON_QMARK] = ACTIONS(2962),
    [anon_sym_COLON_COLON] = ACTIONS(2964),
    [anon_sym_AMP] = ACTIONS(2962),
    [anon_sym_LBRACK] = ACTIONS(2962),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2964),
    [anon_sym_LBRACE] = ACTIONS(2962),
    [anon_sym_LT_AT] = ACTIONS(2962),
    [anon_sym_LT_AT_AT] = ACTIONS(2962),
    [anon_sym_DOT] = ACTIONS(2962),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2964),
    [anon_sym_new] = ACTIONS(2962),
    [anon_sym_return_BANG] = ACTIONS(2964),
    [anon_sym_yield] = ACTIONS(2962),
    [anon_sym_yield_BANG] = ACTIONS(2964),
    [anon_sym_lazy] = ACTIONS(2962),
    [anon_sym_assert] = ACTIONS(2962),
    [anon_sym_upcast] = ACTIONS(2962),
    [anon_sym_downcast] = ACTIONS(2962),
    [anon_sym_COLON_GT] = ACTIONS(2964),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2964),
    [anon_sym_for] = ACTIONS(2962),
    [anon_sym_while] = ACTIONS(2962),
    [anon_sym_if] = ACTIONS(2962),
    [anon_sym_fun] = ACTIONS(2962),
    [anon_sym_try] = ACTIONS(2962),
    [anon_sym_match] = ACTIONS(2962),
    [anon_sym_match_BANG] = ACTIONS(2964),
    [anon_sym_function] = ACTIONS(2962),
    [anon_sym_LT_DASH] = ACTIONS(2962),
    [anon_sym_DOT_LBRACK] = ACTIONS(2964),
    [anon_sym_LT] = ACTIONS(2964),
    [anon_sym_use] = ACTIONS(2962),
    [anon_sym_use_BANG] = ACTIONS(2964),
    [anon_sym_do_BANG] = ACTIONS(2964),
    [anon_sym_DOT_DOT] = ACTIONS(2964),
    [anon_sym_begin] = ACTIONS(2962),
    [anon_sym_LPAREN2] = ACTIONS(2962),
    [anon_sym_or] = ACTIONS(2962),
    [aux_sym_char_token1] = ACTIONS(2964),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2962),
    [anon_sym_DQUOTE] = ACTIONS(2962),
    [anon_sym_AT_DQUOTE] = ACTIONS(2964),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2964),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2964),
    [sym_bool] = ACTIONS(2962),
    [sym_unit] = ACTIONS(2964),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2962),
    [sym_op_identifier] = ACTIONS(2962),
    [anon_sym_PLUS] = ACTIONS(2962),
    [anon_sym_DASH] = ACTIONS(2962),
    [anon_sym_PLUS_DOT] = ACTIONS(2962),
    [anon_sym_DASH_DOT] = ACTIONS(2962),
    [anon_sym_PERCENT] = ACTIONS(2962),
    [anon_sym_AMP_AMP] = ACTIONS(2962),
    [anon_sym_TILDE] = ACTIONS(2964),
    [aux_sym_prefix_op_token1] = ACTIONS(2962),
    [aux_sym_infix_op_token1] = ACTIONS(2964),
    [aux_sym_infix_op_token2] = ACTIONS(2962),
    [anon_sym_PIPE_PIPE] = ACTIONS(2962),
    [anon_sym_BANG_EQ] = ACTIONS(2962),
    [anon_sym_COLON_EQ] = ACTIONS(2964),
    [anon_sym_DOLLAR] = ACTIONS(2962),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2962),
    [sym_int] = ACTIONS(2962),
    [sym_xint] = ACTIONS(2964),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2964),
    [sym__newline] = ACTIONS(2964),
  },
  [2164] = {
    [sym_block_comment] = STATE(2164),
    [sym_compiler_directive_decl] = STATE(2164),
    [sym_fsi_directive_decl] = STATE(2164),
    [sym_preproc_line] = STATE(2164),
    [sym_identifier] = ACTIONS(3071),
    [anon_sym_EQ] = ACTIONS(3073),
    [anon_sym_COLON] = ACTIONS(3071),
    [anon_sym_return] = ACTIONS(3071),
    [anon_sym_do] = ACTIONS(3071),
    [anon_sym_let] = ACTIONS(3071),
    [anon_sym_let_BANG] = ACTIONS(3073),
    [anon_sym_LPAREN] = ACTIONS(3071),
    [anon_sym_COMMA] = ACTIONS(3073),
    [anon_sym_null] = ACTIONS(3071),
    [anon_sym_QMARK] = ACTIONS(3071),
    [anon_sym_COLON_QMARK] = ACTIONS(3071),
    [anon_sym_COLON_COLON] = ACTIONS(3073),
    [anon_sym_AMP] = ACTIONS(3071),
    [anon_sym_LBRACK] = ACTIONS(3071),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3073),
    [anon_sym_LBRACE] = ACTIONS(3071),
    [anon_sym_LT_AT] = ACTIONS(3071),
    [anon_sym_LT_AT_AT] = ACTIONS(3071),
    [anon_sym_DOT] = ACTIONS(3071),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3073),
    [anon_sym_new] = ACTIONS(3071),
    [anon_sym_return_BANG] = ACTIONS(3073),
    [anon_sym_yield] = ACTIONS(3071),
    [anon_sym_yield_BANG] = ACTIONS(3073),
    [anon_sym_lazy] = ACTIONS(3071),
    [anon_sym_assert] = ACTIONS(3071),
    [anon_sym_upcast] = ACTIONS(3071),
    [anon_sym_downcast] = ACTIONS(3071),
    [anon_sym_COLON_GT] = ACTIONS(3073),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3073),
    [anon_sym_for] = ACTIONS(3071),
    [anon_sym_while] = ACTIONS(3071),
    [anon_sym_if] = ACTIONS(3071),
    [anon_sym_fun] = ACTIONS(3071),
    [anon_sym_try] = ACTIONS(3071),
    [anon_sym_match] = ACTIONS(3071),
    [anon_sym_match_BANG] = ACTIONS(3073),
    [anon_sym_function] = ACTIONS(3071),
    [anon_sym_LT_DASH] = ACTIONS(3071),
    [anon_sym_DOT_LBRACK] = ACTIONS(3073),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_use] = ACTIONS(3071),
    [anon_sym_use_BANG] = ACTIONS(3073),
    [anon_sym_do_BANG] = ACTIONS(3073),
    [anon_sym_DOT_DOT] = ACTIONS(3073),
    [anon_sym_begin] = ACTIONS(3071),
    [anon_sym_LPAREN2] = ACTIONS(3071),
    [anon_sym_or] = ACTIONS(3071),
    [aux_sym_char_token1] = ACTIONS(3073),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3071),
    [anon_sym_DQUOTE] = ACTIONS(3071),
    [anon_sym_AT_DQUOTE] = ACTIONS(3073),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3073),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3073),
    [sym_bool] = ACTIONS(3071),
    [sym_unit] = ACTIONS(3073),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3071),
    [sym_op_identifier] = ACTIONS(3071),
    [anon_sym_PLUS] = ACTIONS(3071),
    [anon_sym_DASH] = ACTIONS(3071),
    [anon_sym_PLUS_DOT] = ACTIONS(3071),
    [anon_sym_DASH_DOT] = ACTIONS(3071),
    [anon_sym_PERCENT] = ACTIONS(3071),
    [anon_sym_AMP_AMP] = ACTIONS(3071),
    [anon_sym_TILDE] = ACTIONS(3073),
    [aux_sym_prefix_op_token1] = ACTIONS(3071),
    [aux_sym_infix_op_token1] = ACTIONS(3073),
    [aux_sym_infix_op_token2] = ACTIONS(3071),
    [anon_sym_PIPE_PIPE] = ACTIONS(3071),
    [anon_sym_BANG_EQ] = ACTIONS(3071),
    [anon_sym_COLON_EQ] = ACTIONS(3073),
    [anon_sym_DOLLAR] = ACTIONS(3071),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3071),
    [sym_int] = ACTIONS(3071),
    [sym_xint] = ACTIONS(3073),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3073),
    [sym__newline] = ACTIONS(3073),
  },
  [2165] = {
    [sym_block_comment] = STATE(2165),
    [sym_compiler_directive_decl] = STATE(2165),
    [sym_fsi_directive_decl] = STATE(2165),
    [sym_preproc_line] = STATE(2165),
    [sym_identifier] = ACTIONS(2966),
    [anon_sym_EQ] = ACTIONS(2968),
    [anon_sym_COLON] = ACTIONS(2966),
    [anon_sym_return] = ACTIONS(2966),
    [anon_sym_do] = ACTIONS(2966),
    [anon_sym_let] = ACTIONS(2966),
    [anon_sym_let_BANG] = ACTIONS(2968),
    [anon_sym_LPAREN] = ACTIONS(2966),
    [anon_sym_COMMA] = ACTIONS(2968),
    [anon_sym_null] = ACTIONS(2966),
    [anon_sym_QMARK] = ACTIONS(2966),
    [anon_sym_COLON_QMARK] = ACTIONS(2966),
    [anon_sym_COLON_COLON] = ACTIONS(2968),
    [anon_sym_AMP] = ACTIONS(2966),
    [anon_sym_LBRACK] = ACTIONS(2966),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2968),
    [anon_sym_LBRACE] = ACTIONS(2966),
    [anon_sym_LT_AT] = ACTIONS(2966),
    [anon_sym_LT_AT_AT] = ACTIONS(2966),
    [anon_sym_DOT] = ACTIONS(2966),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2968),
    [anon_sym_new] = ACTIONS(2966),
    [anon_sym_return_BANG] = ACTIONS(2968),
    [anon_sym_yield] = ACTIONS(2966),
    [anon_sym_yield_BANG] = ACTIONS(2968),
    [anon_sym_lazy] = ACTIONS(2966),
    [anon_sym_assert] = ACTIONS(2966),
    [anon_sym_upcast] = ACTIONS(2966),
    [anon_sym_downcast] = ACTIONS(2966),
    [anon_sym_COLON_GT] = ACTIONS(2968),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2968),
    [anon_sym_for] = ACTIONS(2966),
    [anon_sym_while] = ACTIONS(2966),
    [anon_sym_if] = ACTIONS(2966),
    [anon_sym_fun] = ACTIONS(2966),
    [anon_sym_try] = ACTIONS(2966),
    [anon_sym_match] = ACTIONS(2966),
    [anon_sym_match_BANG] = ACTIONS(2968),
    [anon_sym_function] = ACTIONS(2966),
    [anon_sym_LT_DASH] = ACTIONS(2966),
    [anon_sym_DOT_LBRACK] = ACTIONS(2968),
    [anon_sym_LT] = ACTIONS(2968),
    [anon_sym_use] = ACTIONS(2966),
    [anon_sym_use_BANG] = ACTIONS(2968),
    [anon_sym_do_BANG] = ACTIONS(2968),
    [anon_sym_DOT_DOT] = ACTIONS(2968),
    [anon_sym_begin] = ACTIONS(2966),
    [anon_sym_LPAREN2] = ACTIONS(2966),
    [anon_sym_or] = ACTIONS(2966),
    [aux_sym_char_token1] = ACTIONS(2968),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2966),
    [anon_sym_DQUOTE] = ACTIONS(2966),
    [anon_sym_AT_DQUOTE] = ACTIONS(2968),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2968),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2968),
    [sym_bool] = ACTIONS(2966),
    [sym_unit] = ACTIONS(2968),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2966),
    [sym_op_identifier] = ACTIONS(2966),
    [anon_sym_PLUS] = ACTIONS(2966),
    [anon_sym_DASH] = ACTIONS(2966),
    [anon_sym_PLUS_DOT] = ACTIONS(2966),
    [anon_sym_DASH_DOT] = ACTIONS(2966),
    [anon_sym_PERCENT] = ACTIONS(2966),
    [anon_sym_AMP_AMP] = ACTIONS(2966),
    [anon_sym_TILDE] = ACTIONS(2968),
    [aux_sym_prefix_op_token1] = ACTIONS(2966),
    [aux_sym_infix_op_token1] = ACTIONS(2968),
    [aux_sym_infix_op_token2] = ACTIONS(2966),
    [anon_sym_PIPE_PIPE] = ACTIONS(2966),
    [anon_sym_BANG_EQ] = ACTIONS(2966),
    [anon_sym_COLON_EQ] = ACTIONS(2968),
    [anon_sym_DOLLAR] = ACTIONS(2966),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2966),
    [sym_int] = ACTIONS(2966),
    [sym_xint] = ACTIONS(2968),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2968),
    [sym__newline] = ACTIONS(2968),
  },
  [2166] = {
    [sym_block_comment] = STATE(2166),
    [sym_compiler_directive_decl] = STATE(2166),
    [sym_fsi_directive_decl] = STATE(2166),
    [sym_preproc_line] = STATE(2166),
    [sym_identifier] = ACTIONS(3095),
    [anon_sym_EQ] = ACTIONS(3097),
    [anon_sym_COLON] = ACTIONS(3095),
    [anon_sym_return] = ACTIONS(3095),
    [anon_sym_do] = ACTIONS(3095),
    [anon_sym_let] = ACTIONS(3095),
    [anon_sym_let_BANG] = ACTIONS(3097),
    [anon_sym_LPAREN] = ACTIONS(3095),
    [anon_sym_COMMA] = ACTIONS(3097),
    [anon_sym_null] = ACTIONS(3095),
    [anon_sym_QMARK] = ACTIONS(3095),
    [anon_sym_COLON_QMARK] = ACTIONS(3095),
    [anon_sym_COLON_COLON] = ACTIONS(3097),
    [anon_sym_AMP] = ACTIONS(3095),
    [anon_sym_LBRACK] = ACTIONS(3095),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3097),
    [anon_sym_LBRACE] = ACTIONS(3095),
    [anon_sym_LT_AT] = ACTIONS(3095),
    [anon_sym_LT_AT_AT] = ACTIONS(3095),
    [anon_sym_AT_AT_GT] = ACTIONS(3095),
    [anon_sym_DOT] = ACTIONS(3095),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3097),
    [anon_sym_new] = ACTIONS(3095),
    [anon_sym_return_BANG] = ACTIONS(3097),
    [anon_sym_yield] = ACTIONS(3095),
    [anon_sym_yield_BANG] = ACTIONS(3097),
    [anon_sym_lazy] = ACTIONS(3095),
    [anon_sym_assert] = ACTIONS(3095),
    [anon_sym_upcast] = ACTIONS(3095),
    [anon_sym_downcast] = ACTIONS(3095),
    [anon_sym_COLON_GT] = ACTIONS(3097),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3097),
    [anon_sym_for] = ACTIONS(3095),
    [anon_sym_while] = ACTIONS(3095),
    [anon_sym_if] = ACTIONS(3095),
    [anon_sym_fun] = ACTIONS(3095),
    [anon_sym_try] = ACTIONS(3095),
    [anon_sym_match] = ACTIONS(3095),
    [anon_sym_match_BANG] = ACTIONS(3097),
    [anon_sym_function] = ACTIONS(3095),
    [anon_sym_LT_DASH] = ACTIONS(3095),
    [anon_sym_DOT_LBRACK] = ACTIONS(3097),
    [anon_sym_LT] = ACTIONS(3097),
    [anon_sym_use] = ACTIONS(3095),
    [anon_sym_use_BANG] = ACTIONS(3097),
    [anon_sym_do_BANG] = ACTIONS(3097),
    [anon_sym_begin] = ACTIONS(3095),
    [anon_sym_LPAREN2] = ACTIONS(3095),
    [anon_sym_or] = ACTIONS(3095),
    [aux_sym_char_token1] = ACTIONS(3097),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3095),
    [anon_sym_DQUOTE] = ACTIONS(3095),
    [anon_sym_AT_DQUOTE] = ACTIONS(3097),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3097),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3097),
    [sym_bool] = ACTIONS(3095),
    [sym_unit] = ACTIONS(3097),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3095),
    [sym_op_identifier] = ACTIONS(3095),
    [anon_sym_PLUS] = ACTIONS(3095),
    [anon_sym_DASH] = ACTIONS(3095),
    [anon_sym_PLUS_DOT] = ACTIONS(3095),
    [anon_sym_DASH_DOT] = ACTIONS(3095),
    [anon_sym_PERCENT] = ACTIONS(3095),
    [anon_sym_AMP_AMP] = ACTIONS(3095),
    [anon_sym_TILDE] = ACTIONS(3097),
    [aux_sym_prefix_op_token1] = ACTIONS(3095),
    [aux_sym_infix_op_token1] = ACTIONS(3097),
    [aux_sym_infix_op_token2] = ACTIONS(3095),
    [anon_sym_PIPE_PIPE] = ACTIONS(3095),
    [anon_sym_BANG_EQ] = ACTIONS(3095),
    [anon_sym_COLON_EQ] = ACTIONS(3097),
    [anon_sym_DOLLAR] = ACTIONS(3095),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3095),
    [sym_int] = ACTIONS(3095),
    [sym_xint] = ACTIONS(3097),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3097),
    [sym__newline] = ACTIONS(3097),
  },
  [2167] = {
    [sym_block_comment] = STATE(2167),
    [sym_compiler_directive_decl] = STATE(2167),
    [sym_fsi_directive_decl] = STATE(2167),
    [sym_preproc_line] = STATE(2167),
    [sym_identifier] = ACTIONS(3075),
    [anon_sym_EQ] = ACTIONS(3077),
    [anon_sym_COLON] = ACTIONS(3075),
    [anon_sym_return] = ACTIONS(3075),
    [anon_sym_do] = ACTIONS(3075),
    [anon_sym_let] = ACTIONS(3075),
    [anon_sym_let_BANG] = ACTIONS(3077),
    [anon_sym_LPAREN] = ACTIONS(3075),
    [anon_sym_COMMA] = ACTIONS(3077),
    [anon_sym_null] = ACTIONS(3075),
    [anon_sym_QMARK] = ACTIONS(3075),
    [anon_sym_COLON_QMARK] = ACTIONS(3075),
    [anon_sym_COLON_COLON] = ACTIONS(3077),
    [anon_sym_AMP] = ACTIONS(3075),
    [anon_sym_LBRACK] = ACTIONS(3075),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3077),
    [anon_sym_LBRACE] = ACTIONS(3075),
    [anon_sym_LT_AT] = ACTIONS(3075),
    [anon_sym_LT_AT_AT] = ACTIONS(3075),
    [anon_sym_DOT] = ACTIONS(3075),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3077),
    [anon_sym_new] = ACTIONS(3075),
    [anon_sym_return_BANG] = ACTIONS(3077),
    [anon_sym_yield] = ACTIONS(3075),
    [anon_sym_yield_BANG] = ACTIONS(3077),
    [anon_sym_lazy] = ACTIONS(3075),
    [anon_sym_assert] = ACTIONS(3075),
    [anon_sym_upcast] = ACTIONS(3075),
    [anon_sym_downcast] = ACTIONS(3075),
    [anon_sym_COLON_GT] = ACTIONS(3077),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3077),
    [anon_sym_for] = ACTIONS(3075),
    [anon_sym_while] = ACTIONS(3075),
    [anon_sym_if] = ACTIONS(3075),
    [anon_sym_fun] = ACTIONS(3075),
    [anon_sym_try] = ACTIONS(3075),
    [anon_sym_match] = ACTIONS(3075),
    [anon_sym_match_BANG] = ACTIONS(3077),
    [anon_sym_function] = ACTIONS(3075),
    [anon_sym_LT_DASH] = ACTIONS(3075),
    [anon_sym_DOT_LBRACK] = ACTIONS(3077),
    [anon_sym_LT] = ACTIONS(3077),
    [anon_sym_use] = ACTIONS(3075),
    [anon_sym_use_BANG] = ACTIONS(3077),
    [anon_sym_do_BANG] = ACTIONS(3077),
    [anon_sym_DOT_DOT] = ACTIONS(3077),
    [anon_sym_begin] = ACTIONS(3075),
    [anon_sym_LPAREN2] = ACTIONS(3075),
    [anon_sym_or] = ACTIONS(3075),
    [aux_sym_char_token1] = ACTIONS(3077),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3075),
    [anon_sym_DQUOTE] = ACTIONS(3075),
    [anon_sym_AT_DQUOTE] = ACTIONS(3077),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3077),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3077),
    [sym_bool] = ACTIONS(3075),
    [sym_unit] = ACTIONS(3077),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3075),
    [sym_op_identifier] = ACTIONS(3075),
    [anon_sym_PLUS] = ACTIONS(3075),
    [anon_sym_DASH] = ACTIONS(3075),
    [anon_sym_PLUS_DOT] = ACTIONS(3075),
    [anon_sym_DASH_DOT] = ACTIONS(3075),
    [anon_sym_PERCENT] = ACTIONS(3075),
    [anon_sym_AMP_AMP] = ACTIONS(3075),
    [anon_sym_TILDE] = ACTIONS(3077),
    [aux_sym_prefix_op_token1] = ACTIONS(3075),
    [aux_sym_infix_op_token1] = ACTIONS(3077),
    [aux_sym_infix_op_token2] = ACTIONS(3075),
    [anon_sym_PIPE_PIPE] = ACTIONS(3075),
    [anon_sym_BANG_EQ] = ACTIONS(3075),
    [anon_sym_COLON_EQ] = ACTIONS(3077),
    [anon_sym_DOLLAR] = ACTIONS(3075),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3075),
    [sym_int] = ACTIONS(3075),
    [sym_xint] = ACTIONS(3077),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3077),
    [sym__newline] = ACTIONS(3077),
  },
  [2168] = {
    [sym_block_comment] = STATE(2168),
    [sym_compiler_directive_decl] = STATE(2168),
    [sym_fsi_directive_decl] = STATE(2168),
    [sym_preproc_line] = STATE(2168),
    [sym_identifier] = ACTIONS(2851),
    [anon_sym_EQ] = ACTIONS(2853),
    [anon_sym_COLON] = ACTIONS(2851),
    [anon_sym_return] = ACTIONS(2851),
    [anon_sym_do] = ACTIONS(2851),
    [anon_sym_let] = ACTIONS(2851),
    [anon_sym_let_BANG] = ACTIONS(2853),
    [anon_sym_LPAREN] = ACTIONS(2851),
    [anon_sym_COMMA] = ACTIONS(2853),
    [anon_sym_null] = ACTIONS(2851),
    [anon_sym_QMARK] = ACTIONS(2851),
    [anon_sym_COLON_QMARK] = ACTIONS(2851),
    [anon_sym_COLON_COLON] = ACTIONS(2853),
    [anon_sym_AMP] = ACTIONS(2851),
    [anon_sym_LBRACK] = ACTIONS(2851),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2853),
    [anon_sym_LBRACE] = ACTIONS(2851),
    [anon_sym_LT_AT] = ACTIONS(2851),
    [anon_sym_AT_GT] = ACTIONS(2851),
    [anon_sym_LT_AT_AT] = ACTIONS(2851),
    [anon_sym_DOT] = ACTIONS(2851),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2853),
    [anon_sym_new] = ACTIONS(2851),
    [anon_sym_return_BANG] = ACTIONS(2853),
    [anon_sym_yield] = ACTIONS(2851),
    [anon_sym_yield_BANG] = ACTIONS(2853),
    [anon_sym_lazy] = ACTIONS(2851),
    [anon_sym_assert] = ACTIONS(2851),
    [anon_sym_upcast] = ACTIONS(2851),
    [anon_sym_downcast] = ACTIONS(2851),
    [anon_sym_COLON_GT] = ACTIONS(2853),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2853),
    [anon_sym_for] = ACTIONS(2851),
    [anon_sym_while] = ACTIONS(2851),
    [anon_sym_if] = ACTIONS(2851),
    [anon_sym_fun] = ACTIONS(2851),
    [anon_sym_try] = ACTIONS(2851),
    [anon_sym_match] = ACTIONS(2851),
    [anon_sym_match_BANG] = ACTIONS(2853),
    [anon_sym_function] = ACTIONS(2851),
    [anon_sym_LT_DASH] = ACTIONS(2851),
    [anon_sym_DOT_LBRACK] = ACTIONS(2853),
    [anon_sym_LT] = ACTIONS(2853),
    [anon_sym_use] = ACTIONS(2851),
    [anon_sym_use_BANG] = ACTIONS(2853),
    [anon_sym_do_BANG] = ACTIONS(2853),
    [anon_sym_begin] = ACTIONS(2851),
    [anon_sym_LPAREN2] = ACTIONS(2851),
    [anon_sym_or] = ACTIONS(2851),
    [aux_sym_char_token1] = ACTIONS(2853),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2851),
    [anon_sym_DQUOTE] = ACTIONS(2851),
    [anon_sym_AT_DQUOTE] = ACTIONS(2853),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2853),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2853),
    [sym_bool] = ACTIONS(2851),
    [sym_unit] = ACTIONS(2853),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2851),
    [sym_op_identifier] = ACTIONS(2851),
    [anon_sym_PLUS] = ACTIONS(2851),
    [anon_sym_DASH] = ACTIONS(2851),
    [anon_sym_PLUS_DOT] = ACTIONS(2851),
    [anon_sym_DASH_DOT] = ACTIONS(2851),
    [anon_sym_PERCENT] = ACTIONS(2851),
    [anon_sym_AMP_AMP] = ACTIONS(2851),
    [anon_sym_TILDE] = ACTIONS(2853),
    [aux_sym_prefix_op_token1] = ACTIONS(2851),
    [aux_sym_infix_op_token1] = ACTIONS(2853),
    [aux_sym_infix_op_token2] = ACTIONS(2851),
    [anon_sym_PIPE_PIPE] = ACTIONS(2851),
    [anon_sym_BANG_EQ] = ACTIONS(2851),
    [anon_sym_COLON_EQ] = ACTIONS(2853),
    [anon_sym_DOLLAR] = ACTIONS(2851),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2851),
    [sym_int] = ACTIONS(2851),
    [sym_xint] = ACTIONS(2853),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2853),
    [sym__newline] = ACTIONS(2853),
  },
  [2169] = {
    [sym_block_comment] = STATE(2169),
    [sym_compiler_directive_decl] = STATE(2169),
    [sym_fsi_directive_decl] = STATE(2169),
    [sym_preproc_line] = STATE(2169),
    [sym_identifier] = ACTIONS(3087),
    [anon_sym_EQ] = ACTIONS(3089),
    [anon_sym_COLON] = ACTIONS(3087),
    [anon_sym_return] = ACTIONS(3087),
    [anon_sym_do] = ACTIONS(3087),
    [anon_sym_let] = ACTIONS(3087),
    [anon_sym_let_BANG] = ACTIONS(3089),
    [anon_sym_LPAREN] = ACTIONS(3087),
    [anon_sym_COMMA] = ACTIONS(3089),
    [anon_sym_null] = ACTIONS(3087),
    [anon_sym_QMARK] = ACTIONS(3087),
    [anon_sym_COLON_QMARK] = ACTIONS(3087),
    [anon_sym_COLON_COLON] = ACTIONS(3089),
    [anon_sym_AMP] = ACTIONS(3087),
    [anon_sym_LBRACK] = ACTIONS(3087),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3089),
    [anon_sym_LBRACE] = ACTIONS(3087),
    [anon_sym_LT_AT] = ACTIONS(3087),
    [anon_sym_LT_AT_AT] = ACTIONS(3087),
    [anon_sym_DOT] = ACTIONS(3087),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3089),
    [anon_sym_new] = ACTIONS(3087),
    [anon_sym_return_BANG] = ACTIONS(3089),
    [anon_sym_yield] = ACTIONS(3087),
    [anon_sym_yield_BANG] = ACTIONS(3089),
    [anon_sym_lazy] = ACTIONS(3087),
    [anon_sym_assert] = ACTIONS(3087),
    [anon_sym_upcast] = ACTIONS(3087),
    [anon_sym_downcast] = ACTIONS(3087),
    [anon_sym_COLON_GT] = ACTIONS(3089),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3089),
    [anon_sym_for] = ACTIONS(3087),
    [anon_sym_while] = ACTIONS(3087),
    [anon_sym_if] = ACTIONS(3087),
    [anon_sym_fun] = ACTIONS(3087),
    [anon_sym_try] = ACTIONS(3087),
    [anon_sym_match] = ACTIONS(3087),
    [anon_sym_match_BANG] = ACTIONS(3089),
    [anon_sym_function] = ACTIONS(3087),
    [anon_sym_LT_DASH] = ACTIONS(3087),
    [anon_sym_DOT_LBRACK] = ACTIONS(3089),
    [anon_sym_LT] = ACTIONS(3089),
    [anon_sym_use] = ACTIONS(3087),
    [anon_sym_use_BANG] = ACTIONS(3089),
    [anon_sym_do_BANG] = ACTIONS(3089),
    [anon_sym_DOT_DOT] = ACTIONS(3089),
    [anon_sym_begin] = ACTIONS(3087),
    [anon_sym_LPAREN2] = ACTIONS(3087),
    [anon_sym_or] = ACTIONS(3087),
    [aux_sym_char_token1] = ACTIONS(3089),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3087),
    [anon_sym_DQUOTE] = ACTIONS(3087),
    [anon_sym_AT_DQUOTE] = ACTIONS(3089),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3089),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3089),
    [sym_bool] = ACTIONS(3087),
    [sym_unit] = ACTIONS(3089),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3087),
    [sym_op_identifier] = ACTIONS(3087),
    [anon_sym_PLUS] = ACTIONS(3087),
    [anon_sym_DASH] = ACTIONS(3087),
    [anon_sym_PLUS_DOT] = ACTIONS(3087),
    [anon_sym_DASH_DOT] = ACTIONS(3087),
    [anon_sym_PERCENT] = ACTIONS(3087),
    [anon_sym_AMP_AMP] = ACTIONS(3087),
    [anon_sym_TILDE] = ACTIONS(3089),
    [aux_sym_prefix_op_token1] = ACTIONS(3087),
    [aux_sym_infix_op_token1] = ACTIONS(3089),
    [aux_sym_infix_op_token2] = ACTIONS(3087),
    [anon_sym_PIPE_PIPE] = ACTIONS(3087),
    [anon_sym_BANG_EQ] = ACTIONS(3087),
    [anon_sym_COLON_EQ] = ACTIONS(3089),
    [anon_sym_DOLLAR] = ACTIONS(3087),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3087),
    [sym_int] = ACTIONS(3087),
    [sym_xint] = ACTIONS(3089),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3089),
    [sym__newline] = ACTIONS(3089),
  },
  [2170] = {
    [sym_block_comment] = STATE(2170),
    [sym_compiler_directive_decl] = STATE(2170),
    [sym_fsi_directive_decl] = STATE(2170),
    [sym_preproc_line] = STATE(2170),
    [sym_identifier] = ACTIONS(3091),
    [anon_sym_EQ] = ACTIONS(3093),
    [anon_sym_COLON] = ACTIONS(3091),
    [anon_sym_return] = ACTIONS(3091),
    [anon_sym_do] = ACTIONS(3091),
    [anon_sym_let] = ACTIONS(3091),
    [anon_sym_let_BANG] = ACTIONS(3093),
    [anon_sym_LPAREN] = ACTIONS(3091),
    [anon_sym_COMMA] = ACTIONS(3093),
    [anon_sym_null] = ACTIONS(3091),
    [anon_sym_QMARK] = ACTIONS(3091),
    [anon_sym_COLON_QMARK] = ACTIONS(3091),
    [anon_sym_COLON_COLON] = ACTIONS(3093),
    [anon_sym_AMP] = ACTIONS(3091),
    [anon_sym_LBRACK] = ACTIONS(3091),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3093),
    [anon_sym_LBRACE] = ACTIONS(3091),
    [anon_sym_LT_AT] = ACTIONS(3091),
    [anon_sym_LT_AT_AT] = ACTIONS(3091),
    [anon_sym_DOT] = ACTIONS(3091),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3093),
    [anon_sym_new] = ACTIONS(3091),
    [anon_sym_return_BANG] = ACTIONS(3093),
    [anon_sym_yield] = ACTIONS(3091),
    [anon_sym_yield_BANG] = ACTIONS(3093),
    [anon_sym_lazy] = ACTIONS(3091),
    [anon_sym_assert] = ACTIONS(3091),
    [anon_sym_upcast] = ACTIONS(3091),
    [anon_sym_downcast] = ACTIONS(3091),
    [anon_sym_COLON_GT] = ACTIONS(3093),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3093),
    [anon_sym_for] = ACTIONS(3091),
    [anon_sym_while] = ACTIONS(3091),
    [anon_sym_if] = ACTIONS(3091),
    [anon_sym_fun] = ACTIONS(3091),
    [anon_sym_try] = ACTIONS(3091),
    [anon_sym_match] = ACTIONS(3091),
    [anon_sym_match_BANG] = ACTIONS(3093),
    [anon_sym_function] = ACTIONS(3091),
    [anon_sym_LT_DASH] = ACTIONS(3091),
    [anon_sym_DOT_LBRACK] = ACTIONS(3093),
    [anon_sym_LT] = ACTIONS(3093),
    [anon_sym_use] = ACTIONS(3091),
    [anon_sym_use_BANG] = ACTIONS(3093),
    [anon_sym_do_BANG] = ACTIONS(3093),
    [anon_sym_DOT_DOT] = ACTIONS(3093),
    [anon_sym_begin] = ACTIONS(3091),
    [anon_sym_LPAREN2] = ACTIONS(3091),
    [anon_sym_or] = ACTIONS(3091),
    [aux_sym_char_token1] = ACTIONS(3093),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3091),
    [anon_sym_DQUOTE] = ACTIONS(3091),
    [anon_sym_AT_DQUOTE] = ACTIONS(3093),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3093),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3093),
    [sym_bool] = ACTIONS(3091),
    [sym_unit] = ACTIONS(3093),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3091),
    [sym_op_identifier] = ACTIONS(3091),
    [anon_sym_PLUS] = ACTIONS(3091),
    [anon_sym_DASH] = ACTIONS(3091),
    [anon_sym_PLUS_DOT] = ACTIONS(3091),
    [anon_sym_DASH_DOT] = ACTIONS(3091),
    [anon_sym_PERCENT] = ACTIONS(3091),
    [anon_sym_AMP_AMP] = ACTIONS(3091),
    [anon_sym_TILDE] = ACTIONS(3093),
    [aux_sym_prefix_op_token1] = ACTIONS(3091),
    [aux_sym_infix_op_token1] = ACTIONS(3093),
    [aux_sym_infix_op_token2] = ACTIONS(3091),
    [anon_sym_PIPE_PIPE] = ACTIONS(3091),
    [anon_sym_BANG_EQ] = ACTIONS(3091),
    [anon_sym_COLON_EQ] = ACTIONS(3093),
    [anon_sym_DOLLAR] = ACTIONS(3091),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3091),
    [sym_int] = ACTIONS(3091),
    [sym_xint] = ACTIONS(3093),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3093),
    [sym__newline] = ACTIONS(3093),
  },
  [2171] = {
    [sym_block_comment] = STATE(2171),
    [sym_compiler_directive_decl] = STATE(2171),
    [sym_fsi_directive_decl] = STATE(2171),
    [sym_preproc_line] = STATE(2171),
    [sym_identifier] = ACTIONS(2835),
    [anon_sym_EQ] = ACTIONS(2837),
    [anon_sym_COLON] = ACTIONS(2835),
    [anon_sym_return] = ACTIONS(2835),
    [anon_sym_do] = ACTIONS(2835),
    [anon_sym_let] = ACTIONS(2835),
    [anon_sym_let_BANG] = ACTIONS(2837),
    [anon_sym_LPAREN] = ACTIONS(2835),
    [anon_sym_COMMA] = ACTIONS(2837),
    [anon_sym_null] = ACTIONS(2835),
    [anon_sym_QMARK] = ACTIONS(2835),
    [anon_sym_COLON_QMARK] = ACTIONS(2835),
    [anon_sym_COLON_COLON] = ACTIONS(2837),
    [anon_sym_AMP] = ACTIONS(2835),
    [anon_sym_LBRACK] = ACTIONS(2835),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2837),
    [anon_sym_LBRACE] = ACTIONS(2835),
    [anon_sym_LT_AT] = ACTIONS(2835),
    [anon_sym_LT_AT_AT] = ACTIONS(2835),
    [anon_sym_DOT] = ACTIONS(2835),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2837),
    [anon_sym_new] = ACTIONS(2835),
    [anon_sym_return_BANG] = ACTIONS(2837),
    [anon_sym_yield] = ACTIONS(2835),
    [anon_sym_yield_BANG] = ACTIONS(2837),
    [anon_sym_lazy] = ACTIONS(2835),
    [anon_sym_assert] = ACTIONS(2835),
    [anon_sym_upcast] = ACTIONS(2835),
    [anon_sym_downcast] = ACTIONS(2835),
    [anon_sym_COLON_GT] = ACTIONS(2837),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2837),
    [anon_sym_for] = ACTIONS(2835),
    [anon_sym_while] = ACTIONS(2835),
    [anon_sym_if] = ACTIONS(2835),
    [anon_sym_fun] = ACTIONS(2835),
    [anon_sym_try] = ACTIONS(2835),
    [anon_sym_match] = ACTIONS(2835),
    [anon_sym_match_BANG] = ACTIONS(2837),
    [anon_sym_function] = ACTIONS(2835),
    [anon_sym_LT_DASH] = ACTIONS(2835),
    [anon_sym_DOT_LBRACK] = ACTIONS(2837),
    [anon_sym_LT] = ACTIONS(2837),
    [anon_sym_GT] = ACTIONS(2835),
    [anon_sym_use] = ACTIONS(2835),
    [anon_sym_use_BANG] = ACTIONS(2837),
    [anon_sym_do_BANG] = ACTIONS(2837),
    [anon_sym_begin] = ACTIONS(2835),
    [anon_sym_LPAREN2] = ACTIONS(2835),
    [anon_sym_or] = ACTIONS(2835),
    [aux_sym_char_token1] = ACTIONS(2837),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2835),
    [anon_sym_DQUOTE] = ACTIONS(2835),
    [anon_sym_AT_DQUOTE] = ACTIONS(2837),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2837),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2837),
    [sym_bool] = ACTIONS(2835),
    [sym_unit] = ACTIONS(2837),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2835),
    [sym_op_identifier] = ACTIONS(2835),
    [anon_sym_PLUS] = ACTIONS(2835),
    [anon_sym_DASH] = ACTIONS(2835),
    [anon_sym_PLUS_DOT] = ACTIONS(2835),
    [anon_sym_DASH_DOT] = ACTIONS(2835),
    [anon_sym_PERCENT] = ACTIONS(2835),
    [anon_sym_AMP_AMP] = ACTIONS(2835),
    [anon_sym_TILDE] = ACTIONS(2837),
    [aux_sym_prefix_op_token1] = ACTIONS(2835),
    [aux_sym_infix_op_token1] = ACTIONS(2837),
    [aux_sym_infix_op_token2] = ACTIONS(2835),
    [anon_sym_PIPE_PIPE] = ACTIONS(2835),
    [anon_sym_BANG_EQ] = ACTIONS(2835),
    [anon_sym_COLON_EQ] = ACTIONS(2837),
    [anon_sym_DOLLAR] = ACTIONS(2835),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2835),
    [sym_int] = ACTIONS(2835),
    [sym_xint] = ACTIONS(2837),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2837),
    [sym__newline] = ACTIONS(2837),
  },
  [2172] = {
    [sym_block_comment] = STATE(2172),
    [sym_compiler_directive_decl] = STATE(2172),
    [sym_fsi_directive_decl] = STATE(2172),
    [sym_preproc_line] = STATE(2172),
    [sym_identifier] = ACTIONS(2974),
    [anon_sym_EQ] = ACTIONS(2976),
    [anon_sym_COLON] = ACTIONS(2974),
    [anon_sym_return] = ACTIONS(2974),
    [anon_sym_do] = ACTIONS(2974),
    [anon_sym_let] = ACTIONS(2974),
    [anon_sym_let_BANG] = ACTIONS(2976),
    [anon_sym_LPAREN] = ACTIONS(2974),
    [anon_sym_COMMA] = ACTIONS(2976),
    [anon_sym_null] = ACTIONS(2974),
    [anon_sym_QMARK] = ACTIONS(2974),
    [anon_sym_COLON_QMARK] = ACTIONS(2974),
    [anon_sym_COLON_COLON] = ACTIONS(2976),
    [anon_sym_AMP] = ACTIONS(2974),
    [anon_sym_LBRACK] = ACTIONS(2974),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2976),
    [anon_sym_LBRACE] = ACTIONS(2974),
    [anon_sym_LT_AT] = ACTIONS(2974),
    [anon_sym_LT_AT_AT] = ACTIONS(2974),
    [anon_sym_DOT] = ACTIONS(2974),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2976),
    [anon_sym_new] = ACTIONS(2974),
    [anon_sym_return_BANG] = ACTIONS(2976),
    [anon_sym_yield] = ACTIONS(2974),
    [anon_sym_yield_BANG] = ACTIONS(2976),
    [anon_sym_lazy] = ACTIONS(2974),
    [anon_sym_assert] = ACTIONS(2974),
    [anon_sym_upcast] = ACTIONS(2974),
    [anon_sym_downcast] = ACTIONS(2974),
    [anon_sym_COLON_GT] = ACTIONS(2976),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2976),
    [anon_sym_for] = ACTIONS(2974),
    [anon_sym_while] = ACTIONS(2974),
    [anon_sym_if] = ACTIONS(2974),
    [anon_sym_fun] = ACTIONS(2974),
    [anon_sym_try] = ACTIONS(2974),
    [anon_sym_match] = ACTIONS(2974),
    [anon_sym_match_BANG] = ACTIONS(2976),
    [anon_sym_function] = ACTIONS(2974),
    [anon_sym_LT_DASH] = ACTIONS(2974),
    [anon_sym_DOT_LBRACK] = ACTIONS(2976),
    [anon_sym_LT] = ACTIONS(2976),
    [anon_sym_use] = ACTIONS(2974),
    [anon_sym_use_BANG] = ACTIONS(2976),
    [anon_sym_do_BANG] = ACTIONS(2976),
    [anon_sym_DOT_DOT] = ACTIONS(2976),
    [anon_sym_begin] = ACTIONS(2974),
    [anon_sym_LPAREN2] = ACTIONS(2974),
    [anon_sym_or] = ACTIONS(2974),
    [aux_sym_char_token1] = ACTIONS(2976),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2974),
    [anon_sym_DQUOTE] = ACTIONS(2974),
    [anon_sym_AT_DQUOTE] = ACTIONS(2976),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2976),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2976),
    [sym_bool] = ACTIONS(2974),
    [sym_unit] = ACTIONS(2976),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2974),
    [sym_op_identifier] = ACTIONS(2974),
    [anon_sym_PLUS] = ACTIONS(2974),
    [anon_sym_DASH] = ACTIONS(2974),
    [anon_sym_PLUS_DOT] = ACTIONS(2974),
    [anon_sym_DASH_DOT] = ACTIONS(2974),
    [anon_sym_PERCENT] = ACTIONS(2974),
    [anon_sym_AMP_AMP] = ACTIONS(2974),
    [anon_sym_TILDE] = ACTIONS(2976),
    [aux_sym_prefix_op_token1] = ACTIONS(2974),
    [aux_sym_infix_op_token1] = ACTIONS(2976),
    [aux_sym_infix_op_token2] = ACTIONS(2974),
    [anon_sym_PIPE_PIPE] = ACTIONS(2974),
    [anon_sym_BANG_EQ] = ACTIONS(2974),
    [anon_sym_COLON_EQ] = ACTIONS(2976),
    [anon_sym_DOLLAR] = ACTIONS(2974),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2974),
    [sym_int] = ACTIONS(2974),
    [sym_xint] = ACTIONS(2976),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2976),
    [sym__newline] = ACTIONS(2976),
  },
  [2173] = {
    [sym_block_comment] = STATE(2173),
    [sym_compiler_directive_decl] = STATE(2173),
    [sym_fsi_directive_decl] = STATE(2173),
    [sym_preproc_line] = STATE(2173),
    [sym_identifier] = ACTIONS(3119),
    [anon_sym_EQ] = ACTIONS(3121),
    [anon_sym_COLON] = ACTIONS(3119),
    [anon_sym_return] = ACTIONS(3119),
    [anon_sym_do] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_let_BANG] = ACTIONS(3121),
    [anon_sym_LPAREN] = ACTIONS(3119),
    [anon_sym_COMMA] = ACTIONS(3121),
    [anon_sym_null] = ACTIONS(3119),
    [anon_sym_QMARK] = ACTIONS(3119),
    [anon_sym_COLON_QMARK] = ACTIONS(3119),
    [anon_sym_COLON_COLON] = ACTIONS(3121),
    [anon_sym_AMP] = ACTIONS(3119),
    [anon_sym_LBRACK] = ACTIONS(3119),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3121),
    [anon_sym_LBRACE] = ACTIONS(3119),
    [anon_sym_LT_AT] = ACTIONS(3119),
    [anon_sym_LT_AT_AT] = ACTIONS(3119),
    [anon_sym_DOT] = ACTIONS(3119),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3121),
    [anon_sym_new] = ACTIONS(3119),
    [anon_sym_return_BANG] = ACTIONS(3121),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_yield_BANG] = ACTIONS(3121),
    [anon_sym_lazy] = ACTIONS(3119),
    [anon_sym_assert] = ACTIONS(3119),
    [anon_sym_upcast] = ACTIONS(3119),
    [anon_sym_downcast] = ACTIONS(3119),
    [anon_sym_COLON_GT] = ACTIONS(3121),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3121),
    [anon_sym_for] = ACTIONS(3119),
    [anon_sym_while] = ACTIONS(3119),
    [anon_sym_if] = ACTIONS(3119),
    [anon_sym_fun] = ACTIONS(3119),
    [anon_sym_try] = ACTIONS(3119),
    [anon_sym_match] = ACTIONS(3119),
    [anon_sym_match_BANG] = ACTIONS(3121),
    [anon_sym_function] = ACTIONS(3119),
    [anon_sym_LT_DASH] = ACTIONS(3119),
    [anon_sym_DOT_LBRACK] = ACTIONS(3121),
    [anon_sym_LT] = ACTIONS(3121),
    [anon_sym_GT] = ACTIONS(3119),
    [anon_sym_use] = ACTIONS(3119),
    [anon_sym_use_BANG] = ACTIONS(3121),
    [anon_sym_do_BANG] = ACTIONS(3121),
    [anon_sym_begin] = ACTIONS(3119),
    [anon_sym_LPAREN2] = ACTIONS(3119),
    [anon_sym_or] = ACTIONS(3119),
    [aux_sym_char_token1] = ACTIONS(3121),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3119),
    [anon_sym_DQUOTE] = ACTIONS(3119),
    [anon_sym_AT_DQUOTE] = ACTIONS(3121),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3121),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3121),
    [sym_bool] = ACTIONS(3119),
    [sym_unit] = ACTIONS(3121),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3119),
    [sym_op_identifier] = ACTIONS(3119),
    [anon_sym_PLUS] = ACTIONS(3119),
    [anon_sym_DASH] = ACTIONS(3119),
    [anon_sym_PLUS_DOT] = ACTIONS(3119),
    [anon_sym_DASH_DOT] = ACTIONS(3119),
    [anon_sym_PERCENT] = ACTIONS(3119),
    [anon_sym_AMP_AMP] = ACTIONS(3119),
    [anon_sym_TILDE] = ACTIONS(3121),
    [aux_sym_prefix_op_token1] = ACTIONS(3119),
    [aux_sym_infix_op_token1] = ACTIONS(3121),
    [aux_sym_infix_op_token2] = ACTIONS(3119),
    [anon_sym_PIPE_PIPE] = ACTIONS(3119),
    [anon_sym_BANG_EQ] = ACTIONS(3119),
    [anon_sym_COLON_EQ] = ACTIONS(3121),
    [anon_sym_DOLLAR] = ACTIONS(3119),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3119),
    [sym_int] = ACTIONS(3119),
    [sym_xint] = ACTIONS(3121),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3121),
    [sym__newline] = ACTIONS(3121),
  },
  [2174] = {
    [sym_block_comment] = STATE(2174),
    [sym_compiler_directive_decl] = STATE(2174),
    [sym_fsi_directive_decl] = STATE(2174),
    [sym_preproc_line] = STATE(2174),
    [sym_identifier] = ACTIONS(3123),
    [anon_sym_EQ] = ACTIONS(3125),
    [anon_sym_COLON] = ACTIONS(3123),
    [anon_sym_return] = ACTIONS(3123),
    [anon_sym_do] = ACTIONS(3123),
    [anon_sym_let] = ACTIONS(3123),
    [anon_sym_let_BANG] = ACTIONS(3125),
    [anon_sym_LPAREN] = ACTIONS(3123),
    [anon_sym_COMMA] = ACTIONS(3125),
    [anon_sym_null] = ACTIONS(3123),
    [anon_sym_QMARK] = ACTIONS(3123),
    [anon_sym_COLON_QMARK] = ACTIONS(3123),
    [anon_sym_COLON_COLON] = ACTIONS(3125),
    [anon_sym_AMP] = ACTIONS(3123),
    [anon_sym_LBRACK] = ACTIONS(3123),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3125),
    [anon_sym_LBRACE] = ACTIONS(3123),
    [anon_sym_LT_AT] = ACTIONS(3123),
    [anon_sym_LT_AT_AT] = ACTIONS(3123),
    [anon_sym_DOT] = ACTIONS(3123),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3125),
    [anon_sym_new] = ACTIONS(3123),
    [anon_sym_return_BANG] = ACTIONS(3125),
    [anon_sym_yield] = ACTIONS(3123),
    [anon_sym_yield_BANG] = ACTIONS(3125),
    [anon_sym_lazy] = ACTIONS(3123),
    [anon_sym_assert] = ACTIONS(3123),
    [anon_sym_upcast] = ACTIONS(3123),
    [anon_sym_downcast] = ACTIONS(3123),
    [anon_sym_COLON_GT] = ACTIONS(3125),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3125),
    [anon_sym_for] = ACTIONS(3123),
    [anon_sym_while] = ACTIONS(3123),
    [anon_sym_if] = ACTIONS(3123),
    [anon_sym_fun] = ACTIONS(3123),
    [anon_sym_try] = ACTIONS(3123),
    [anon_sym_match] = ACTIONS(3123),
    [anon_sym_match_BANG] = ACTIONS(3125),
    [anon_sym_function] = ACTIONS(3123),
    [anon_sym_LT_DASH] = ACTIONS(3123),
    [anon_sym_DOT_LBRACK] = ACTIONS(3125),
    [anon_sym_LT] = ACTIONS(3125),
    [anon_sym_use] = ACTIONS(3123),
    [anon_sym_use_BANG] = ACTIONS(3125),
    [anon_sym_do_BANG] = ACTIONS(3125),
    [anon_sym_DOT_DOT] = ACTIONS(3125),
    [anon_sym_begin] = ACTIONS(3123),
    [anon_sym_LPAREN2] = ACTIONS(3123),
    [anon_sym_or] = ACTIONS(3123),
    [aux_sym_char_token1] = ACTIONS(3125),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3123),
    [anon_sym_DQUOTE] = ACTIONS(3123),
    [anon_sym_AT_DQUOTE] = ACTIONS(3125),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3125),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3125),
    [sym_bool] = ACTIONS(3123),
    [sym_unit] = ACTIONS(3125),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3123),
    [sym_op_identifier] = ACTIONS(3123),
    [anon_sym_PLUS] = ACTIONS(3123),
    [anon_sym_DASH] = ACTIONS(3123),
    [anon_sym_PLUS_DOT] = ACTIONS(3123),
    [anon_sym_DASH_DOT] = ACTIONS(3123),
    [anon_sym_PERCENT] = ACTIONS(3123),
    [anon_sym_AMP_AMP] = ACTIONS(3123),
    [anon_sym_TILDE] = ACTIONS(3125),
    [aux_sym_prefix_op_token1] = ACTIONS(3123),
    [aux_sym_infix_op_token1] = ACTIONS(3125),
    [aux_sym_infix_op_token2] = ACTIONS(3123),
    [anon_sym_PIPE_PIPE] = ACTIONS(3123),
    [anon_sym_BANG_EQ] = ACTIONS(3123),
    [anon_sym_COLON_EQ] = ACTIONS(3125),
    [anon_sym_DOLLAR] = ACTIONS(3123),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3123),
    [sym_int] = ACTIONS(3123),
    [sym_xint] = ACTIONS(3125),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3125),
    [sym__newline] = ACTIONS(3125),
  },
  [2175] = {
    [sym_block_comment] = STATE(2175),
    [sym_compiler_directive_decl] = STATE(2175),
    [sym_fsi_directive_decl] = STATE(2175),
    [sym_preproc_line] = STATE(2175),
    [sym_identifier] = ACTIONS(3127),
    [anon_sym_EQ] = ACTIONS(3129),
    [anon_sym_COLON] = ACTIONS(3127),
    [anon_sym_return] = ACTIONS(3127),
    [anon_sym_do] = ACTIONS(3127),
    [anon_sym_let] = ACTIONS(3127),
    [anon_sym_let_BANG] = ACTIONS(3129),
    [anon_sym_LPAREN] = ACTIONS(3127),
    [anon_sym_COMMA] = ACTIONS(3129),
    [anon_sym_null] = ACTIONS(3127),
    [anon_sym_QMARK] = ACTIONS(3127),
    [anon_sym_COLON_QMARK] = ACTIONS(3127),
    [anon_sym_COLON_COLON] = ACTIONS(3129),
    [anon_sym_AMP] = ACTIONS(3127),
    [anon_sym_LBRACK] = ACTIONS(3127),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3129),
    [anon_sym_LBRACE] = ACTIONS(3127),
    [anon_sym_LT_AT] = ACTIONS(3127),
    [anon_sym_LT_AT_AT] = ACTIONS(3127),
    [anon_sym_DOT] = ACTIONS(3127),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3129),
    [anon_sym_new] = ACTIONS(3127),
    [anon_sym_return_BANG] = ACTIONS(3129),
    [anon_sym_yield] = ACTIONS(3127),
    [anon_sym_yield_BANG] = ACTIONS(3129),
    [anon_sym_lazy] = ACTIONS(3127),
    [anon_sym_assert] = ACTIONS(3127),
    [anon_sym_upcast] = ACTIONS(3127),
    [anon_sym_downcast] = ACTIONS(3127),
    [anon_sym_COLON_GT] = ACTIONS(3129),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3129),
    [anon_sym_for] = ACTIONS(3127),
    [anon_sym_while] = ACTIONS(3127),
    [anon_sym_if] = ACTIONS(3127),
    [anon_sym_fun] = ACTIONS(3127),
    [anon_sym_try] = ACTIONS(3127),
    [anon_sym_match] = ACTIONS(3127),
    [anon_sym_match_BANG] = ACTIONS(3129),
    [anon_sym_function] = ACTIONS(3127),
    [anon_sym_LT_DASH] = ACTIONS(3127),
    [anon_sym_DOT_LBRACK] = ACTIONS(3129),
    [anon_sym_LT] = ACTIONS(3129),
    [anon_sym_use] = ACTIONS(3127),
    [anon_sym_use_BANG] = ACTIONS(3129),
    [anon_sym_do_BANG] = ACTIONS(3129),
    [anon_sym_DOT_DOT] = ACTIONS(3129),
    [anon_sym_begin] = ACTIONS(3127),
    [anon_sym_LPAREN2] = ACTIONS(3127),
    [anon_sym_or] = ACTIONS(3127),
    [aux_sym_char_token1] = ACTIONS(3129),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3127),
    [anon_sym_DQUOTE] = ACTIONS(3127),
    [anon_sym_AT_DQUOTE] = ACTIONS(3129),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3129),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3129),
    [sym_bool] = ACTIONS(3127),
    [sym_unit] = ACTIONS(3129),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3127),
    [sym_op_identifier] = ACTIONS(3127),
    [anon_sym_PLUS] = ACTIONS(3127),
    [anon_sym_DASH] = ACTIONS(3127),
    [anon_sym_PLUS_DOT] = ACTIONS(3127),
    [anon_sym_DASH_DOT] = ACTIONS(3127),
    [anon_sym_PERCENT] = ACTIONS(3127),
    [anon_sym_AMP_AMP] = ACTIONS(3127),
    [anon_sym_TILDE] = ACTIONS(3129),
    [aux_sym_prefix_op_token1] = ACTIONS(3127),
    [aux_sym_infix_op_token1] = ACTIONS(3129),
    [aux_sym_infix_op_token2] = ACTIONS(3127),
    [anon_sym_PIPE_PIPE] = ACTIONS(3127),
    [anon_sym_BANG_EQ] = ACTIONS(3127),
    [anon_sym_COLON_EQ] = ACTIONS(3129),
    [anon_sym_DOLLAR] = ACTIONS(3127),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3127),
    [sym_int] = ACTIONS(3127),
    [sym_xint] = ACTIONS(3129),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3129),
    [sym__newline] = ACTIONS(3129),
  },
  [2176] = {
    [sym_block_comment] = STATE(2176),
    [sym_compiler_directive_decl] = STATE(2176),
    [sym_fsi_directive_decl] = STATE(2176),
    [sym_preproc_line] = STATE(2176),
    [sym_identifier] = ACTIONS(3131),
    [anon_sym_EQ] = ACTIONS(3133),
    [anon_sym_COLON] = ACTIONS(3131),
    [anon_sym_return] = ACTIONS(3131),
    [anon_sym_do] = ACTIONS(3131),
    [anon_sym_let] = ACTIONS(3131),
    [anon_sym_let_BANG] = ACTIONS(3133),
    [anon_sym_LPAREN] = ACTIONS(3131),
    [anon_sym_COMMA] = ACTIONS(3133),
    [anon_sym_null] = ACTIONS(3131),
    [anon_sym_QMARK] = ACTIONS(3131),
    [anon_sym_COLON_QMARK] = ACTIONS(3131),
    [anon_sym_COLON_COLON] = ACTIONS(3133),
    [anon_sym_AMP] = ACTIONS(3131),
    [anon_sym_LBRACK] = ACTIONS(3131),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3133),
    [anon_sym_LBRACE] = ACTIONS(3131),
    [anon_sym_LT_AT] = ACTIONS(3131),
    [anon_sym_LT_AT_AT] = ACTIONS(3131),
    [anon_sym_DOT] = ACTIONS(3131),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3133),
    [anon_sym_new] = ACTIONS(3131),
    [anon_sym_return_BANG] = ACTIONS(3133),
    [anon_sym_yield] = ACTIONS(3131),
    [anon_sym_yield_BANG] = ACTIONS(3133),
    [anon_sym_lazy] = ACTIONS(3131),
    [anon_sym_assert] = ACTIONS(3131),
    [anon_sym_upcast] = ACTIONS(3131),
    [anon_sym_downcast] = ACTIONS(3131),
    [anon_sym_COLON_GT] = ACTIONS(3133),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3133),
    [anon_sym_for] = ACTIONS(3131),
    [anon_sym_while] = ACTIONS(3131),
    [anon_sym_if] = ACTIONS(3131),
    [anon_sym_fun] = ACTIONS(3131),
    [anon_sym_try] = ACTIONS(3131),
    [anon_sym_match] = ACTIONS(3131),
    [anon_sym_match_BANG] = ACTIONS(3133),
    [anon_sym_function] = ACTIONS(3131),
    [anon_sym_LT_DASH] = ACTIONS(3131),
    [anon_sym_DOT_LBRACK] = ACTIONS(3133),
    [anon_sym_LT] = ACTIONS(3133),
    [anon_sym_use] = ACTIONS(3131),
    [anon_sym_use_BANG] = ACTIONS(3133),
    [anon_sym_do_BANG] = ACTIONS(3133),
    [anon_sym_DOT_DOT] = ACTIONS(3133),
    [anon_sym_begin] = ACTIONS(3131),
    [anon_sym_LPAREN2] = ACTIONS(3131),
    [anon_sym_or] = ACTIONS(3131),
    [aux_sym_char_token1] = ACTIONS(3133),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3131),
    [anon_sym_DQUOTE] = ACTIONS(3131),
    [anon_sym_AT_DQUOTE] = ACTIONS(3133),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3133),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3133),
    [sym_bool] = ACTIONS(3131),
    [sym_unit] = ACTIONS(3133),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3131),
    [sym_op_identifier] = ACTIONS(3131),
    [anon_sym_PLUS] = ACTIONS(3131),
    [anon_sym_DASH] = ACTIONS(3131),
    [anon_sym_PLUS_DOT] = ACTIONS(3131),
    [anon_sym_DASH_DOT] = ACTIONS(3131),
    [anon_sym_PERCENT] = ACTIONS(3131),
    [anon_sym_AMP_AMP] = ACTIONS(3131),
    [anon_sym_TILDE] = ACTIONS(3133),
    [aux_sym_prefix_op_token1] = ACTIONS(3131),
    [aux_sym_infix_op_token1] = ACTIONS(3133),
    [aux_sym_infix_op_token2] = ACTIONS(3131),
    [anon_sym_PIPE_PIPE] = ACTIONS(3131),
    [anon_sym_BANG_EQ] = ACTIONS(3131),
    [anon_sym_COLON_EQ] = ACTIONS(3133),
    [anon_sym_DOLLAR] = ACTIONS(3131),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3131),
    [sym_int] = ACTIONS(3131),
    [sym_xint] = ACTIONS(3133),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3133),
    [sym__newline] = ACTIONS(3133),
  },
  [2177] = {
    [sym_block_comment] = STATE(2177),
    [sym_compiler_directive_decl] = STATE(2177),
    [sym_fsi_directive_decl] = STATE(2177),
    [sym_preproc_line] = STATE(2177),
    [sym_identifier] = ACTIONS(3139),
    [anon_sym_EQ] = ACTIONS(3141),
    [anon_sym_COLON] = ACTIONS(3139),
    [anon_sym_return] = ACTIONS(3139),
    [anon_sym_do] = ACTIONS(3139),
    [anon_sym_let] = ACTIONS(3139),
    [anon_sym_let_BANG] = ACTIONS(3141),
    [anon_sym_LPAREN] = ACTIONS(3139),
    [anon_sym_COMMA] = ACTIONS(3141),
    [anon_sym_null] = ACTIONS(3139),
    [anon_sym_QMARK] = ACTIONS(3139),
    [anon_sym_COLON_QMARK] = ACTIONS(3139),
    [anon_sym_COLON_COLON] = ACTIONS(3141),
    [anon_sym_AMP] = ACTIONS(3139),
    [anon_sym_LBRACK] = ACTIONS(3139),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3141),
    [anon_sym_LBRACE] = ACTIONS(3139),
    [anon_sym_LT_AT] = ACTIONS(3139),
    [anon_sym_LT_AT_AT] = ACTIONS(3139),
    [anon_sym_DOT] = ACTIONS(3139),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3141),
    [anon_sym_new] = ACTIONS(3139),
    [anon_sym_return_BANG] = ACTIONS(3141),
    [anon_sym_yield] = ACTIONS(3139),
    [anon_sym_yield_BANG] = ACTIONS(3141),
    [anon_sym_lazy] = ACTIONS(3139),
    [anon_sym_assert] = ACTIONS(3139),
    [anon_sym_upcast] = ACTIONS(3139),
    [anon_sym_downcast] = ACTIONS(3139),
    [anon_sym_COLON_GT] = ACTIONS(3141),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3141),
    [anon_sym_for] = ACTIONS(3139),
    [anon_sym_while] = ACTIONS(3139),
    [anon_sym_if] = ACTIONS(3139),
    [anon_sym_fun] = ACTIONS(3139),
    [anon_sym_try] = ACTIONS(3139),
    [anon_sym_match] = ACTIONS(3139),
    [anon_sym_match_BANG] = ACTIONS(3141),
    [anon_sym_function] = ACTIONS(3139),
    [anon_sym_LT_DASH] = ACTIONS(3139),
    [anon_sym_DOT_LBRACK] = ACTIONS(3141),
    [anon_sym_LT] = ACTIONS(3141),
    [anon_sym_use] = ACTIONS(3139),
    [anon_sym_use_BANG] = ACTIONS(3141),
    [anon_sym_do_BANG] = ACTIONS(3141),
    [anon_sym_DOT_DOT] = ACTIONS(3141),
    [anon_sym_begin] = ACTIONS(3139),
    [anon_sym_LPAREN2] = ACTIONS(3139),
    [anon_sym_or] = ACTIONS(3139),
    [aux_sym_char_token1] = ACTIONS(3141),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3139),
    [anon_sym_DQUOTE] = ACTIONS(3139),
    [anon_sym_AT_DQUOTE] = ACTIONS(3141),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3141),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3141),
    [sym_bool] = ACTIONS(3139),
    [sym_unit] = ACTIONS(3141),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3139),
    [sym_op_identifier] = ACTIONS(3139),
    [anon_sym_PLUS] = ACTIONS(3139),
    [anon_sym_DASH] = ACTIONS(3139),
    [anon_sym_PLUS_DOT] = ACTIONS(3139),
    [anon_sym_DASH_DOT] = ACTIONS(3139),
    [anon_sym_PERCENT] = ACTIONS(3139),
    [anon_sym_AMP_AMP] = ACTIONS(3139),
    [anon_sym_TILDE] = ACTIONS(3141),
    [aux_sym_prefix_op_token1] = ACTIONS(3139),
    [aux_sym_infix_op_token1] = ACTIONS(3141),
    [aux_sym_infix_op_token2] = ACTIONS(3139),
    [anon_sym_PIPE_PIPE] = ACTIONS(3139),
    [anon_sym_BANG_EQ] = ACTIONS(3139),
    [anon_sym_COLON_EQ] = ACTIONS(3141),
    [anon_sym_DOLLAR] = ACTIONS(3139),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3139),
    [sym_int] = ACTIONS(3139),
    [sym_xint] = ACTIONS(3141),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3141),
    [sym__newline] = ACTIONS(3141),
  },
  [2178] = {
    [sym_block_comment] = STATE(2178),
    [sym_compiler_directive_decl] = STATE(2178),
    [sym_fsi_directive_decl] = STATE(2178),
    [sym_preproc_line] = STATE(2178),
    [sym_identifier] = ACTIONS(3135),
    [anon_sym_EQ] = ACTIONS(3137),
    [anon_sym_COLON] = ACTIONS(3135),
    [anon_sym_return] = ACTIONS(3135),
    [anon_sym_do] = ACTIONS(3135),
    [anon_sym_let] = ACTIONS(3135),
    [anon_sym_let_BANG] = ACTIONS(3137),
    [anon_sym_LPAREN] = ACTIONS(3135),
    [anon_sym_COMMA] = ACTIONS(3137),
    [anon_sym_null] = ACTIONS(3135),
    [anon_sym_QMARK] = ACTIONS(3135),
    [anon_sym_COLON_QMARK] = ACTIONS(3135),
    [anon_sym_COLON_COLON] = ACTIONS(3137),
    [anon_sym_AMP] = ACTIONS(3135),
    [anon_sym_LBRACK] = ACTIONS(3135),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3137),
    [anon_sym_LBRACE] = ACTIONS(3135),
    [anon_sym_LT_AT] = ACTIONS(3135),
    [anon_sym_LT_AT_AT] = ACTIONS(3135),
    [anon_sym_DOT] = ACTIONS(3135),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3137),
    [anon_sym_new] = ACTIONS(3135),
    [anon_sym_return_BANG] = ACTIONS(3137),
    [anon_sym_yield] = ACTIONS(3135),
    [anon_sym_yield_BANG] = ACTIONS(3137),
    [anon_sym_lazy] = ACTIONS(3135),
    [anon_sym_assert] = ACTIONS(3135),
    [anon_sym_upcast] = ACTIONS(3135),
    [anon_sym_downcast] = ACTIONS(3135),
    [anon_sym_COLON_GT] = ACTIONS(3137),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3137),
    [anon_sym_for] = ACTIONS(3135),
    [anon_sym_while] = ACTIONS(3135),
    [anon_sym_if] = ACTIONS(3135),
    [anon_sym_fun] = ACTIONS(3135),
    [anon_sym_try] = ACTIONS(3135),
    [anon_sym_match] = ACTIONS(3135),
    [anon_sym_match_BANG] = ACTIONS(3137),
    [anon_sym_function] = ACTIONS(3135),
    [anon_sym_LT_DASH] = ACTIONS(3135),
    [anon_sym_DOT_LBRACK] = ACTIONS(3137),
    [anon_sym_LT] = ACTIONS(3137),
    [anon_sym_use] = ACTIONS(3135),
    [anon_sym_use_BANG] = ACTIONS(3137),
    [anon_sym_do_BANG] = ACTIONS(3137),
    [anon_sym_DOT_DOT] = ACTIONS(3137),
    [anon_sym_begin] = ACTIONS(3135),
    [anon_sym_LPAREN2] = ACTIONS(3135),
    [anon_sym_or] = ACTIONS(3135),
    [aux_sym_char_token1] = ACTIONS(3137),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3135),
    [anon_sym_DQUOTE] = ACTIONS(3135),
    [anon_sym_AT_DQUOTE] = ACTIONS(3137),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3137),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3137),
    [sym_bool] = ACTIONS(3135),
    [sym_unit] = ACTIONS(3137),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3135),
    [sym_op_identifier] = ACTIONS(3135),
    [anon_sym_PLUS] = ACTIONS(3135),
    [anon_sym_DASH] = ACTIONS(3135),
    [anon_sym_PLUS_DOT] = ACTIONS(3135),
    [anon_sym_DASH_DOT] = ACTIONS(3135),
    [anon_sym_PERCENT] = ACTIONS(3135),
    [anon_sym_AMP_AMP] = ACTIONS(3135),
    [anon_sym_TILDE] = ACTIONS(3137),
    [aux_sym_prefix_op_token1] = ACTIONS(3135),
    [aux_sym_infix_op_token1] = ACTIONS(3137),
    [aux_sym_infix_op_token2] = ACTIONS(3135),
    [anon_sym_PIPE_PIPE] = ACTIONS(3135),
    [anon_sym_BANG_EQ] = ACTIONS(3135),
    [anon_sym_COLON_EQ] = ACTIONS(3137),
    [anon_sym_DOLLAR] = ACTIONS(3135),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3135),
    [sym_int] = ACTIONS(3135),
    [sym_xint] = ACTIONS(3137),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3137),
    [sym__newline] = ACTIONS(3137),
  },
  [2179] = {
    [sym_block_comment] = STATE(2179),
    [sym_compiler_directive_decl] = STATE(2179),
    [sym_fsi_directive_decl] = STATE(2179),
    [sym_preproc_line] = STATE(2179),
    [sym_identifier] = ACTIONS(2839),
    [anon_sym_EQ] = ACTIONS(2841),
    [anon_sym_COLON] = ACTIONS(2839),
    [anon_sym_return] = ACTIONS(2839),
    [anon_sym_do] = ACTIONS(2839),
    [anon_sym_let] = ACTIONS(2839),
    [anon_sym_let_BANG] = ACTIONS(2841),
    [anon_sym_LPAREN] = ACTIONS(2839),
    [anon_sym_COMMA] = ACTIONS(2841),
    [anon_sym_null] = ACTIONS(2839),
    [anon_sym_QMARK] = ACTIONS(2839),
    [anon_sym_COLON_QMARK] = ACTIONS(2839),
    [anon_sym_COLON_COLON] = ACTIONS(2841),
    [anon_sym_AMP] = ACTIONS(2839),
    [anon_sym_LBRACK] = ACTIONS(2839),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2841),
    [anon_sym_LBRACE] = ACTIONS(2839),
    [anon_sym_LT_AT] = ACTIONS(2839),
    [anon_sym_AT_GT] = ACTIONS(2839),
    [anon_sym_LT_AT_AT] = ACTIONS(2839),
    [anon_sym_DOT] = ACTIONS(2839),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2841),
    [anon_sym_new] = ACTIONS(2839),
    [anon_sym_return_BANG] = ACTIONS(2841),
    [anon_sym_yield] = ACTIONS(2839),
    [anon_sym_yield_BANG] = ACTIONS(2841),
    [anon_sym_lazy] = ACTIONS(2839),
    [anon_sym_assert] = ACTIONS(2839),
    [anon_sym_upcast] = ACTIONS(2839),
    [anon_sym_downcast] = ACTIONS(2839),
    [anon_sym_COLON_GT] = ACTIONS(2841),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2841),
    [anon_sym_for] = ACTIONS(2839),
    [anon_sym_while] = ACTIONS(2839),
    [anon_sym_if] = ACTIONS(2839),
    [anon_sym_fun] = ACTIONS(2839),
    [anon_sym_try] = ACTIONS(2839),
    [anon_sym_match] = ACTIONS(2839),
    [anon_sym_match_BANG] = ACTIONS(2841),
    [anon_sym_function] = ACTIONS(2839),
    [anon_sym_LT_DASH] = ACTIONS(2839),
    [anon_sym_DOT_LBRACK] = ACTIONS(2841),
    [anon_sym_LT] = ACTIONS(2841),
    [anon_sym_use] = ACTIONS(2839),
    [anon_sym_use_BANG] = ACTIONS(2841),
    [anon_sym_do_BANG] = ACTIONS(2841),
    [anon_sym_begin] = ACTIONS(2839),
    [anon_sym_LPAREN2] = ACTIONS(2839),
    [anon_sym_or] = ACTIONS(2839),
    [aux_sym_char_token1] = ACTIONS(2841),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2839),
    [anon_sym_DQUOTE] = ACTIONS(2839),
    [anon_sym_AT_DQUOTE] = ACTIONS(2841),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2841),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2841),
    [sym_bool] = ACTIONS(2839),
    [sym_unit] = ACTIONS(2841),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2839),
    [sym_op_identifier] = ACTIONS(2839),
    [anon_sym_PLUS] = ACTIONS(2839),
    [anon_sym_DASH] = ACTIONS(2839),
    [anon_sym_PLUS_DOT] = ACTIONS(2839),
    [anon_sym_DASH_DOT] = ACTIONS(2839),
    [anon_sym_PERCENT] = ACTIONS(2839),
    [anon_sym_AMP_AMP] = ACTIONS(2839),
    [anon_sym_TILDE] = ACTIONS(2841),
    [aux_sym_prefix_op_token1] = ACTIONS(2839),
    [aux_sym_infix_op_token1] = ACTIONS(2841),
    [aux_sym_infix_op_token2] = ACTIONS(2839),
    [anon_sym_PIPE_PIPE] = ACTIONS(2839),
    [anon_sym_BANG_EQ] = ACTIONS(2839),
    [anon_sym_COLON_EQ] = ACTIONS(2841),
    [anon_sym_DOLLAR] = ACTIONS(2839),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2839),
    [sym_int] = ACTIONS(2839),
    [sym_xint] = ACTIONS(2841),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2841),
    [sym__newline] = ACTIONS(2841),
  },
  [2180] = {
    [sym_block_comment] = STATE(2180),
    [sym_compiler_directive_decl] = STATE(2180),
    [sym_fsi_directive_decl] = STATE(2180),
    [sym_preproc_line] = STATE(2180),
    [sym_identifier] = ACTIONS(3119),
    [anon_sym_EQ] = ACTIONS(3121),
    [anon_sym_COLON] = ACTIONS(3119),
    [anon_sym_return] = ACTIONS(3119),
    [anon_sym_do] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_let_BANG] = ACTIONS(3121),
    [anon_sym_LPAREN] = ACTIONS(3119),
    [anon_sym_COMMA] = ACTIONS(3121),
    [anon_sym_null] = ACTIONS(3119),
    [anon_sym_QMARK] = ACTIONS(3119),
    [anon_sym_COLON_QMARK] = ACTIONS(3119),
    [anon_sym_COLON_COLON] = ACTIONS(3121),
    [anon_sym_AMP] = ACTIONS(3119),
    [anon_sym_LBRACK] = ACTIONS(3119),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3121),
    [anon_sym_LBRACE] = ACTIONS(3119),
    [anon_sym_LT_AT] = ACTIONS(3119),
    [anon_sym_LT_AT_AT] = ACTIONS(3119),
    [anon_sym_DOT] = ACTIONS(3119),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3121),
    [anon_sym_new] = ACTIONS(3119),
    [anon_sym_return_BANG] = ACTIONS(3121),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_yield_BANG] = ACTIONS(3121),
    [anon_sym_lazy] = ACTIONS(3119),
    [anon_sym_assert] = ACTIONS(3119),
    [anon_sym_upcast] = ACTIONS(3119),
    [anon_sym_downcast] = ACTIONS(3119),
    [anon_sym_COLON_GT] = ACTIONS(3121),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3121),
    [anon_sym_for] = ACTIONS(3119),
    [anon_sym_while] = ACTIONS(3119),
    [anon_sym_if] = ACTIONS(3119),
    [anon_sym_fun] = ACTIONS(3119),
    [anon_sym_try] = ACTIONS(3119),
    [anon_sym_match] = ACTIONS(3119),
    [anon_sym_match_BANG] = ACTIONS(3121),
    [anon_sym_function] = ACTIONS(3119),
    [anon_sym_LT_DASH] = ACTIONS(3119),
    [anon_sym_DOT_LBRACK] = ACTIONS(3121),
    [anon_sym_LT] = ACTIONS(3121),
    [anon_sym_use] = ACTIONS(3119),
    [anon_sym_use_BANG] = ACTIONS(3121),
    [anon_sym_do_BANG] = ACTIONS(3121),
    [anon_sym_DOT_DOT] = ACTIONS(3121),
    [anon_sym_begin] = ACTIONS(3119),
    [anon_sym_LPAREN2] = ACTIONS(3119),
    [anon_sym_or] = ACTIONS(3119),
    [aux_sym_char_token1] = ACTIONS(3121),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3119),
    [anon_sym_DQUOTE] = ACTIONS(3119),
    [anon_sym_AT_DQUOTE] = ACTIONS(3121),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3121),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3121),
    [sym_bool] = ACTIONS(3119),
    [sym_unit] = ACTIONS(3121),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3119),
    [sym_op_identifier] = ACTIONS(3119),
    [anon_sym_PLUS] = ACTIONS(3119),
    [anon_sym_DASH] = ACTIONS(3119),
    [anon_sym_PLUS_DOT] = ACTIONS(3119),
    [anon_sym_DASH_DOT] = ACTIONS(3119),
    [anon_sym_PERCENT] = ACTIONS(3119),
    [anon_sym_AMP_AMP] = ACTIONS(3119),
    [anon_sym_TILDE] = ACTIONS(3121),
    [aux_sym_prefix_op_token1] = ACTIONS(3119),
    [aux_sym_infix_op_token1] = ACTIONS(3121),
    [aux_sym_infix_op_token2] = ACTIONS(3119),
    [anon_sym_PIPE_PIPE] = ACTIONS(3119),
    [anon_sym_BANG_EQ] = ACTIONS(3119),
    [anon_sym_COLON_EQ] = ACTIONS(3121),
    [anon_sym_DOLLAR] = ACTIONS(3119),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3119),
    [sym_int] = ACTIONS(3119),
    [sym_xint] = ACTIONS(3121),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3121),
    [sym__newline] = ACTIONS(3121),
  },
  [2181] = {
    [sym_block_comment] = STATE(2181),
    [sym_compiler_directive_decl] = STATE(2181),
    [sym_fsi_directive_decl] = STATE(2181),
    [sym_preproc_line] = STATE(2181),
    [sym_identifier] = ACTIONS(2835),
    [anon_sym_EQ] = ACTIONS(2837),
    [anon_sym_COLON] = ACTIONS(2835),
    [anon_sym_return] = ACTIONS(2835),
    [anon_sym_do] = ACTIONS(2835),
    [anon_sym_let] = ACTIONS(2835),
    [anon_sym_let_BANG] = ACTIONS(2837),
    [anon_sym_LPAREN] = ACTIONS(2835),
    [anon_sym_COMMA] = ACTIONS(2837),
    [anon_sym_null] = ACTIONS(2835),
    [anon_sym_QMARK] = ACTIONS(2835),
    [anon_sym_COLON_QMARK] = ACTIONS(2835),
    [anon_sym_COLON_COLON] = ACTIONS(2837),
    [anon_sym_AMP] = ACTIONS(2835),
    [anon_sym_LBRACK] = ACTIONS(2835),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2837),
    [anon_sym_LBRACE] = ACTIONS(2835),
    [anon_sym_LT_AT] = ACTIONS(2835),
    [anon_sym_LT_AT_AT] = ACTIONS(2835),
    [anon_sym_DOT] = ACTIONS(2835),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2837),
    [anon_sym_new] = ACTIONS(2835),
    [anon_sym_return_BANG] = ACTIONS(2837),
    [anon_sym_yield] = ACTIONS(2835),
    [anon_sym_yield_BANG] = ACTIONS(2837),
    [anon_sym_lazy] = ACTIONS(2835),
    [anon_sym_assert] = ACTIONS(2835),
    [anon_sym_upcast] = ACTIONS(2835),
    [anon_sym_downcast] = ACTIONS(2835),
    [anon_sym_COLON_GT] = ACTIONS(2837),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2837),
    [anon_sym_for] = ACTIONS(2835),
    [anon_sym_while] = ACTIONS(2835),
    [anon_sym_if] = ACTIONS(2835),
    [anon_sym_fun] = ACTIONS(2835),
    [anon_sym_try] = ACTIONS(2835),
    [anon_sym_match] = ACTIONS(2835),
    [anon_sym_match_BANG] = ACTIONS(2837),
    [anon_sym_function] = ACTIONS(2835),
    [anon_sym_LT_DASH] = ACTIONS(2835),
    [anon_sym_DOT_LBRACK] = ACTIONS(2837),
    [anon_sym_LT] = ACTIONS(2837),
    [anon_sym_use] = ACTIONS(2835),
    [anon_sym_use_BANG] = ACTIONS(2837),
    [anon_sym_do_BANG] = ACTIONS(2837),
    [anon_sym_DOT_DOT] = ACTIONS(2837),
    [anon_sym_begin] = ACTIONS(2835),
    [anon_sym_LPAREN2] = ACTIONS(2835),
    [anon_sym_or] = ACTIONS(2835),
    [aux_sym_char_token1] = ACTIONS(2837),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2835),
    [anon_sym_DQUOTE] = ACTIONS(2835),
    [anon_sym_AT_DQUOTE] = ACTIONS(2837),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2837),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2837),
    [sym_bool] = ACTIONS(2835),
    [sym_unit] = ACTIONS(2837),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2835),
    [sym_op_identifier] = ACTIONS(2835),
    [anon_sym_PLUS] = ACTIONS(2835),
    [anon_sym_DASH] = ACTIONS(2835),
    [anon_sym_PLUS_DOT] = ACTIONS(2835),
    [anon_sym_DASH_DOT] = ACTIONS(2835),
    [anon_sym_PERCENT] = ACTIONS(2835),
    [anon_sym_AMP_AMP] = ACTIONS(2835),
    [anon_sym_TILDE] = ACTIONS(2837),
    [aux_sym_prefix_op_token1] = ACTIONS(2835),
    [aux_sym_infix_op_token1] = ACTIONS(2837),
    [aux_sym_infix_op_token2] = ACTIONS(2835),
    [anon_sym_PIPE_PIPE] = ACTIONS(2835),
    [anon_sym_BANG_EQ] = ACTIONS(2835),
    [anon_sym_COLON_EQ] = ACTIONS(2837),
    [anon_sym_DOLLAR] = ACTIONS(2835),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2835),
    [sym_int] = ACTIONS(2835),
    [sym_xint] = ACTIONS(2837),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2837),
    [sym__newline] = ACTIONS(2837),
  },
  [2182] = {
    [sym_block_comment] = STATE(2182),
    [sym_compiler_directive_decl] = STATE(2182),
    [sym_fsi_directive_decl] = STATE(2182),
    [sym_preproc_line] = STATE(2182),
    [sym_identifier] = ACTIONS(2863),
    [anon_sym_EQ] = ACTIONS(2865),
    [anon_sym_COLON] = ACTIONS(2863),
    [anon_sym_return] = ACTIONS(2863),
    [anon_sym_do] = ACTIONS(2863),
    [anon_sym_let] = ACTIONS(2863),
    [anon_sym_let_BANG] = ACTIONS(2865),
    [anon_sym_LPAREN] = ACTIONS(2863),
    [anon_sym_COMMA] = ACTIONS(2865),
    [anon_sym_null] = ACTIONS(2863),
    [anon_sym_QMARK] = ACTIONS(2863),
    [anon_sym_COLON_QMARK] = ACTIONS(2863),
    [anon_sym_COLON_COLON] = ACTIONS(2865),
    [anon_sym_AMP] = ACTIONS(2863),
    [anon_sym_LBRACK] = ACTIONS(2863),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2865),
    [anon_sym_LBRACE] = ACTIONS(2863),
    [anon_sym_LT_AT] = ACTIONS(2863),
    [anon_sym_AT_GT] = ACTIONS(2863),
    [anon_sym_LT_AT_AT] = ACTIONS(2863),
    [anon_sym_DOT] = ACTIONS(2863),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2865),
    [anon_sym_new] = ACTIONS(2863),
    [anon_sym_return_BANG] = ACTIONS(2865),
    [anon_sym_yield] = ACTIONS(2863),
    [anon_sym_yield_BANG] = ACTIONS(2865),
    [anon_sym_lazy] = ACTIONS(2863),
    [anon_sym_assert] = ACTIONS(2863),
    [anon_sym_upcast] = ACTIONS(2863),
    [anon_sym_downcast] = ACTIONS(2863),
    [anon_sym_COLON_GT] = ACTIONS(2865),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2865),
    [anon_sym_for] = ACTIONS(2863),
    [anon_sym_while] = ACTIONS(2863),
    [anon_sym_if] = ACTIONS(2863),
    [anon_sym_fun] = ACTIONS(2863),
    [anon_sym_try] = ACTIONS(2863),
    [anon_sym_match] = ACTIONS(2863),
    [anon_sym_match_BANG] = ACTIONS(2865),
    [anon_sym_function] = ACTIONS(2863),
    [anon_sym_LT_DASH] = ACTIONS(2863),
    [anon_sym_DOT_LBRACK] = ACTIONS(2865),
    [anon_sym_LT] = ACTIONS(2865),
    [anon_sym_use] = ACTIONS(2863),
    [anon_sym_use_BANG] = ACTIONS(2865),
    [anon_sym_do_BANG] = ACTIONS(2865),
    [anon_sym_begin] = ACTIONS(2863),
    [anon_sym_LPAREN2] = ACTIONS(2863),
    [anon_sym_or] = ACTIONS(2863),
    [aux_sym_char_token1] = ACTIONS(2865),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2863),
    [anon_sym_DQUOTE] = ACTIONS(2863),
    [anon_sym_AT_DQUOTE] = ACTIONS(2865),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2865),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2865),
    [sym_bool] = ACTIONS(2863),
    [sym_unit] = ACTIONS(2865),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2863),
    [sym_op_identifier] = ACTIONS(2863),
    [anon_sym_PLUS] = ACTIONS(2863),
    [anon_sym_DASH] = ACTIONS(2863),
    [anon_sym_PLUS_DOT] = ACTIONS(2863),
    [anon_sym_DASH_DOT] = ACTIONS(2863),
    [anon_sym_PERCENT] = ACTIONS(2863),
    [anon_sym_AMP_AMP] = ACTIONS(2863),
    [anon_sym_TILDE] = ACTIONS(2865),
    [aux_sym_prefix_op_token1] = ACTIONS(2863),
    [aux_sym_infix_op_token1] = ACTIONS(2865),
    [aux_sym_infix_op_token2] = ACTIONS(2863),
    [anon_sym_PIPE_PIPE] = ACTIONS(2863),
    [anon_sym_BANG_EQ] = ACTIONS(2863),
    [anon_sym_COLON_EQ] = ACTIONS(2865),
    [anon_sym_DOLLAR] = ACTIONS(2863),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2863),
    [sym_int] = ACTIONS(2863),
    [sym_xint] = ACTIONS(2865),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2865),
    [sym__newline] = ACTIONS(2865),
  },
  [2183] = {
    [sym_block_comment] = STATE(2183),
    [sym_compiler_directive_decl] = STATE(2183),
    [sym_fsi_directive_decl] = STATE(2183),
    [sym_preproc_line] = STATE(2183),
    [sym_identifier] = ACTIONS(2867),
    [anon_sym_EQ] = ACTIONS(2869),
    [anon_sym_COLON] = ACTIONS(2867),
    [anon_sym_return] = ACTIONS(2867),
    [anon_sym_do] = ACTIONS(2867),
    [anon_sym_let] = ACTIONS(2867),
    [anon_sym_let_BANG] = ACTIONS(2869),
    [anon_sym_LPAREN] = ACTIONS(2867),
    [anon_sym_COMMA] = ACTIONS(2869),
    [anon_sym_null] = ACTIONS(2867),
    [anon_sym_QMARK] = ACTIONS(2867),
    [anon_sym_COLON_QMARK] = ACTIONS(2867),
    [anon_sym_COLON_COLON] = ACTIONS(2869),
    [anon_sym_AMP] = ACTIONS(2867),
    [anon_sym_LBRACK] = ACTIONS(2867),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2869),
    [anon_sym_LBRACE] = ACTIONS(2867),
    [anon_sym_LT_AT] = ACTIONS(2867),
    [anon_sym_AT_GT] = ACTIONS(2867),
    [anon_sym_LT_AT_AT] = ACTIONS(2867),
    [anon_sym_DOT] = ACTIONS(4216),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2869),
    [anon_sym_new] = ACTIONS(2867),
    [anon_sym_return_BANG] = ACTIONS(2869),
    [anon_sym_yield] = ACTIONS(2867),
    [anon_sym_yield_BANG] = ACTIONS(2869),
    [anon_sym_lazy] = ACTIONS(2867),
    [anon_sym_assert] = ACTIONS(2867),
    [anon_sym_upcast] = ACTIONS(2867),
    [anon_sym_downcast] = ACTIONS(2867),
    [anon_sym_COLON_GT] = ACTIONS(2869),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2869),
    [anon_sym_for] = ACTIONS(2867),
    [anon_sym_while] = ACTIONS(2867),
    [anon_sym_if] = ACTIONS(2867),
    [anon_sym_fun] = ACTIONS(2867),
    [anon_sym_try] = ACTIONS(2867),
    [anon_sym_match] = ACTIONS(2867),
    [anon_sym_match_BANG] = ACTIONS(2869),
    [anon_sym_function] = ACTIONS(2867),
    [anon_sym_LT_DASH] = ACTIONS(2867),
    [anon_sym_DOT_LBRACK] = ACTIONS(2869),
    [anon_sym_LT] = ACTIONS(2869),
    [anon_sym_use] = ACTIONS(2867),
    [anon_sym_use_BANG] = ACTIONS(2869),
    [anon_sym_do_BANG] = ACTIONS(2869),
    [anon_sym_begin] = ACTIONS(2867),
    [anon_sym_LPAREN2] = ACTIONS(2867),
    [anon_sym_or] = ACTIONS(2867),
    [aux_sym_char_token1] = ACTIONS(2869),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2867),
    [anon_sym_DQUOTE] = ACTIONS(2867),
    [anon_sym_AT_DQUOTE] = ACTIONS(2869),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2869),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2869),
    [sym_bool] = ACTIONS(2867),
    [sym_unit] = ACTIONS(2869),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2867),
    [sym_op_identifier] = ACTIONS(2867),
    [anon_sym_PLUS] = ACTIONS(2867),
    [anon_sym_DASH] = ACTIONS(2867),
    [anon_sym_PLUS_DOT] = ACTIONS(2867),
    [anon_sym_DASH_DOT] = ACTIONS(2867),
    [anon_sym_PERCENT] = ACTIONS(2867),
    [anon_sym_AMP_AMP] = ACTIONS(2867),
    [anon_sym_TILDE] = ACTIONS(2869),
    [aux_sym_prefix_op_token1] = ACTIONS(2867),
    [aux_sym_infix_op_token1] = ACTIONS(2869),
    [aux_sym_infix_op_token2] = ACTIONS(2867),
    [anon_sym_PIPE_PIPE] = ACTIONS(2867),
    [anon_sym_BANG_EQ] = ACTIONS(2867),
    [anon_sym_COLON_EQ] = ACTIONS(2869),
    [anon_sym_DOLLAR] = ACTIONS(2867),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2867),
    [sym_int] = ACTIONS(2867),
    [sym_xint] = ACTIONS(2869),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2869),
    [sym__newline] = ACTIONS(2869),
  },
  [2184] = {
    [sym_block_comment] = STATE(2184),
    [sym_compiler_directive_decl] = STATE(2184),
    [sym_fsi_directive_decl] = STATE(2184),
    [sym_preproc_line] = STATE(2184),
    [sym_identifier] = ACTIONS(3111),
    [anon_sym_EQ] = ACTIONS(3113),
    [anon_sym_COLON] = ACTIONS(3111),
    [anon_sym_return] = ACTIONS(3111),
    [anon_sym_do] = ACTIONS(3111),
    [anon_sym_let] = ACTIONS(3111),
    [anon_sym_let_BANG] = ACTIONS(3113),
    [anon_sym_LPAREN] = ACTIONS(3111),
    [anon_sym_COMMA] = ACTIONS(3113),
    [anon_sym_null] = ACTIONS(3111),
    [anon_sym_QMARK] = ACTIONS(3111),
    [anon_sym_COLON_QMARK] = ACTIONS(3111),
    [anon_sym_COLON_COLON] = ACTIONS(3113),
    [anon_sym_AMP] = ACTIONS(3111),
    [anon_sym_LBRACK] = ACTIONS(3111),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3113),
    [anon_sym_LBRACE] = ACTIONS(3111),
    [anon_sym_LT_AT] = ACTIONS(3111),
    [anon_sym_LT_AT_AT] = ACTIONS(3111),
    [anon_sym_DOT] = ACTIONS(3111),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3113),
    [anon_sym_new] = ACTIONS(3111),
    [anon_sym_return_BANG] = ACTIONS(3113),
    [anon_sym_yield] = ACTIONS(3111),
    [anon_sym_yield_BANG] = ACTIONS(3113),
    [anon_sym_lazy] = ACTIONS(3111),
    [anon_sym_assert] = ACTIONS(3111),
    [anon_sym_upcast] = ACTIONS(3111),
    [anon_sym_downcast] = ACTIONS(3111),
    [anon_sym_COLON_GT] = ACTIONS(3113),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3113),
    [anon_sym_for] = ACTIONS(3111),
    [anon_sym_while] = ACTIONS(3111),
    [anon_sym_if] = ACTIONS(3111),
    [anon_sym_fun] = ACTIONS(3111),
    [anon_sym_try] = ACTIONS(3111),
    [anon_sym_match] = ACTIONS(3111),
    [anon_sym_match_BANG] = ACTIONS(3113),
    [anon_sym_function] = ACTIONS(3111),
    [anon_sym_LT_DASH] = ACTIONS(3111),
    [anon_sym_DOT_LBRACK] = ACTIONS(3113),
    [anon_sym_LT] = ACTIONS(3113),
    [anon_sym_use] = ACTIONS(3111),
    [anon_sym_use_BANG] = ACTIONS(3113),
    [anon_sym_do_BANG] = ACTIONS(3113),
    [anon_sym_DOT_DOT] = ACTIONS(3113),
    [anon_sym_begin] = ACTIONS(3111),
    [anon_sym_LPAREN2] = ACTIONS(3111),
    [anon_sym_or] = ACTIONS(3111),
    [aux_sym_char_token1] = ACTIONS(3113),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3111),
    [anon_sym_DQUOTE] = ACTIONS(3111),
    [anon_sym_AT_DQUOTE] = ACTIONS(3113),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3113),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3113),
    [sym_bool] = ACTIONS(3111),
    [sym_unit] = ACTIONS(3113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3111),
    [sym_op_identifier] = ACTIONS(3111),
    [anon_sym_PLUS] = ACTIONS(3111),
    [anon_sym_DASH] = ACTIONS(3111),
    [anon_sym_PLUS_DOT] = ACTIONS(3111),
    [anon_sym_DASH_DOT] = ACTIONS(3111),
    [anon_sym_PERCENT] = ACTIONS(3111),
    [anon_sym_AMP_AMP] = ACTIONS(3111),
    [anon_sym_TILDE] = ACTIONS(3113),
    [aux_sym_prefix_op_token1] = ACTIONS(3111),
    [aux_sym_infix_op_token1] = ACTIONS(3113),
    [aux_sym_infix_op_token2] = ACTIONS(3111),
    [anon_sym_PIPE_PIPE] = ACTIONS(3111),
    [anon_sym_BANG_EQ] = ACTIONS(3111),
    [anon_sym_COLON_EQ] = ACTIONS(3113),
    [anon_sym_DOLLAR] = ACTIONS(3111),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3111),
    [sym_int] = ACTIONS(3111),
    [sym_xint] = ACTIONS(3113),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3113),
    [sym__newline] = ACTIONS(3113),
  },
  [2185] = {
    [sym_block_comment] = STATE(2185),
    [sym_compiler_directive_decl] = STATE(2185),
    [sym_fsi_directive_decl] = STATE(2185),
    [sym_preproc_line] = STATE(2185),
    [sym_identifier] = ACTIONS(3107),
    [anon_sym_EQ] = ACTIONS(3109),
    [anon_sym_COLON] = ACTIONS(3107),
    [anon_sym_return] = ACTIONS(3107),
    [anon_sym_do] = ACTIONS(3107),
    [anon_sym_let] = ACTIONS(3107),
    [anon_sym_let_BANG] = ACTIONS(3109),
    [anon_sym_LPAREN] = ACTIONS(3107),
    [anon_sym_COMMA] = ACTIONS(3109),
    [anon_sym_null] = ACTIONS(3107),
    [anon_sym_QMARK] = ACTIONS(3107),
    [anon_sym_COLON_QMARK] = ACTIONS(3107),
    [anon_sym_COLON_COLON] = ACTIONS(3109),
    [anon_sym_AMP] = ACTIONS(3107),
    [anon_sym_LBRACK] = ACTIONS(3107),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3109),
    [anon_sym_LBRACE] = ACTIONS(3107),
    [anon_sym_LT_AT] = ACTIONS(3107),
    [anon_sym_LT_AT_AT] = ACTIONS(3107),
    [anon_sym_DOT] = ACTIONS(3107),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3109),
    [anon_sym_new] = ACTIONS(3107),
    [anon_sym_return_BANG] = ACTIONS(3109),
    [anon_sym_yield] = ACTIONS(3107),
    [anon_sym_yield_BANG] = ACTIONS(3109),
    [anon_sym_lazy] = ACTIONS(3107),
    [anon_sym_assert] = ACTIONS(3107),
    [anon_sym_upcast] = ACTIONS(3107),
    [anon_sym_downcast] = ACTIONS(3107),
    [anon_sym_COLON_GT] = ACTIONS(3109),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3109),
    [anon_sym_for] = ACTIONS(3107),
    [anon_sym_while] = ACTIONS(3107),
    [anon_sym_if] = ACTIONS(3107),
    [anon_sym_fun] = ACTIONS(3107),
    [anon_sym_try] = ACTIONS(3107),
    [anon_sym_match] = ACTIONS(3107),
    [anon_sym_match_BANG] = ACTIONS(3109),
    [anon_sym_function] = ACTIONS(3107),
    [anon_sym_LT_DASH] = ACTIONS(3107),
    [anon_sym_DOT_LBRACK] = ACTIONS(3109),
    [anon_sym_LT] = ACTIONS(3109),
    [anon_sym_use] = ACTIONS(3107),
    [anon_sym_use_BANG] = ACTIONS(3109),
    [anon_sym_do_BANG] = ACTIONS(3109),
    [anon_sym_DOT_DOT] = ACTIONS(3109),
    [anon_sym_begin] = ACTIONS(3107),
    [anon_sym_LPAREN2] = ACTIONS(3107),
    [anon_sym_or] = ACTIONS(3107),
    [aux_sym_char_token1] = ACTIONS(3109),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3107),
    [anon_sym_DQUOTE] = ACTIONS(3107),
    [anon_sym_AT_DQUOTE] = ACTIONS(3109),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3109),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3109),
    [sym_bool] = ACTIONS(3107),
    [sym_unit] = ACTIONS(3109),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3107),
    [sym_op_identifier] = ACTIONS(3107),
    [anon_sym_PLUS] = ACTIONS(3107),
    [anon_sym_DASH] = ACTIONS(3107),
    [anon_sym_PLUS_DOT] = ACTIONS(3107),
    [anon_sym_DASH_DOT] = ACTIONS(3107),
    [anon_sym_PERCENT] = ACTIONS(3107),
    [anon_sym_AMP_AMP] = ACTIONS(3107),
    [anon_sym_TILDE] = ACTIONS(3109),
    [aux_sym_prefix_op_token1] = ACTIONS(3107),
    [aux_sym_infix_op_token1] = ACTIONS(3109),
    [aux_sym_infix_op_token2] = ACTIONS(3107),
    [anon_sym_PIPE_PIPE] = ACTIONS(3107),
    [anon_sym_BANG_EQ] = ACTIONS(3107),
    [anon_sym_COLON_EQ] = ACTIONS(3109),
    [anon_sym_DOLLAR] = ACTIONS(3107),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3107),
    [sym_int] = ACTIONS(3107),
    [sym_xint] = ACTIONS(3109),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3109),
    [sym__newline] = ACTIONS(3109),
  },
  [2186] = {
    [sym_block_comment] = STATE(2186),
    [sym_compiler_directive_decl] = STATE(2186),
    [sym_fsi_directive_decl] = STATE(2186),
    [sym_preproc_line] = STATE(2186),
    [sym_identifier] = ACTIONS(3103),
    [anon_sym_EQ] = ACTIONS(3105),
    [anon_sym_COLON] = ACTIONS(3103),
    [anon_sym_return] = ACTIONS(3103),
    [anon_sym_do] = ACTIONS(3103),
    [anon_sym_let] = ACTIONS(3103),
    [anon_sym_let_BANG] = ACTIONS(3105),
    [anon_sym_LPAREN] = ACTIONS(3103),
    [anon_sym_COMMA] = ACTIONS(3105),
    [anon_sym_null] = ACTIONS(3103),
    [anon_sym_QMARK] = ACTIONS(3103),
    [anon_sym_COLON_QMARK] = ACTIONS(3103),
    [anon_sym_COLON_COLON] = ACTIONS(3105),
    [anon_sym_AMP] = ACTIONS(3103),
    [anon_sym_LBRACK] = ACTIONS(3103),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3105),
    [anon_sym_LBRACE] = ACTIONS(3103),
    [anon_sym_LT_AT] = ACTIONS(3103),
    [anon_sym_LT_AT_AT] = ACTIONS(3103),
    [anon_sym_DOT] = ACTIONS(3103),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3105),
    [anon_sym_new] = ACTIONS(3103),
    [anon_sym_return_BANG] = ACTIONS(3105),
    [anon_sym_yield] = ACTIONS(3103),
    [anon_sym_yield_BANG] = ACTIONS(3105),
    [anon_sym_lazy] = ACTIONS(3103),
    [anon_sym_assert] = ACTIONS(3103),
    [anon_sym_upcast] = ACTIONS(3103),
    [anon_sym_downcast] = ACTIONS(3103),
    [anon_sym_COLON_GT] = ACTIONS(3105),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3105),
    [anon_sym_for] = ACTIONS(3103),
    [anon_sym_while] = ACTIONS(3103),
    [anon_sym_if] = ACTIONS(3103),
    [anon_sym_fun] = ACTIONS(3103),
    [anon_sym_try] = ACTIONS(3103),
    [anon_sym_match] = ACTIONS(3103),
    [anon_sym_match_BANG] = ACTIONS(3105),
    [anon_sym_function] = ACTIONS(3103),
    [anon_sym_LT_DASH] = ACTIONS(3103),
    [anon_sym_DOT_LBRACK] = ACTIONS(3105),
    [anon_sym_LT] = ACTIONS(3105),
    [anon_sym_use] = ACTIONS(3103),
    [anon_sym_use_BANG] = ACTIONS(3105),
    [anon_sym_do_BANG] = ACTIONS(3105),
    [anon_sym_DOT_DOT] = ACTIONS(3105),
    [anon_sym_begin] = ACTIONS(3103),
    [anon_sym_LPAREN2] = ACTIONS(3103),
    [anon_sym_or] = ACTIONS(3103),
    [aux_sym_char_token1] = ACTIONS(3105),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3103),
    [anon_sym_DQUOTE] = ACTIONS(3103),
    [anon_sym_AT_DQUOTE] = ACTIONS(3105),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3105),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3105),
    [sym_bool] = ACTIONS(3103),
    [sym_unit] = ACTIONS(3105),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3103),
    [sym_op_identifier] = ACTIONS(3103),
    [anon_sym_PLUS] = ACTIONS(3103),
    [anon_sym_DASH] = ACTIONS(3103),
    [anon_sym_PLUS_DOT] = ACTIONS(3103),
    [anon_sym_DASH_DOT] = ACTIONS(3103),
    [anon_sym_PERCENT] = ACTIONS(3103),
    [anon_sym_AMP_AMP] = ACTIONS(3103),
    [anon_sym_TILDE] = ACTIONS(3105),
    [aux_sym_prefix_op_token1] = ACTIONS(3103),
    [aux_sym_infix_op_token1] = ACTIONS(3105),
    [aux_sym_infix_op_token2] = ACTIONS(3103),
    [anon_sym_PIPE_PIPE] = ACTIONS(3103),
    [anon_sym_BANG_EQ] = ACTIONS(3103),
    [anon_sym_COLON_EQ] = ACTIONS(3105),
    [anon_sym_DOLLAR] = ACTIONS(3103),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3103),
    [sym_int] = ACTIONS(3103),
    [sym_xint] = ACTIONS(3105),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3105),
    [sym__newline] = ACTIONS(3105),
  },
  [2187] = {
    [sym_block_comment] = STATE(2187),
    [sym_compiler_directive_decl] = STATE(2187),
    [sym_fsi_directive_decl] = STATE(2187),
    [sym_preproc_line] = STATE(2187),
    [sym_identifier] = ACTIONS(3099),
    [anon_sym_EQ] = ACTIONS(3101),
    [anon_sym_COLON] = ACTIONS(3099),
    [anon_sym_return] = ACTIONS(3099),
    [anon_sym_do] = ACTIONS(3099),
    [anon_sym_let] = ACTIONS(3099),
    [anon_sym_let_BANG] = ACTIONS(3101),
    [anon_sym_LPAREN] = ACTIONS(3099),
    [anon_sym_COMMA] = ACTIONS(3101),
    [anon_sym_null] = ACTIONS(3099),
    [anon_sym_QMARK] = ACTIONS(3099),
    [anon_sym_COLON_QMARK] = ACTIONS(3099),
    [anon_sym_COLON_COLON] = ACTIONS(3101),
    [anon_sym_AMP] = ACTIONS(3099),
    [anon_sym_LBRACK] = ACTIONS(3099),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3101),
    [anon_sym_LBRACE] = ACTIONS(3099),
    [anon_sym_LT_AT] = ACTIONS(3099),
    [anon_sym_LT_AT_AT] = ACTIONS(3099),
    [anon_sym_DOT] = ACTIONS(3099),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3101),
    [anon_sym_new] = ACTIONS(3099),
    [anon_sym_return_BANG] = ACTIONS(3101),
    [anon_sym_yield] = ACTIONS(3099),
    [anon_sym_yield_BANG] = ACTIONS(3101),
    [anon_sym_lazy] = ACTIONS(3099),
    [anon_sym_assert] = ACTIONS(3099),
    [anon_sym_upcast] = ACTIONS(3099),
    [anon_sym_downcast] = ACTIONS(3099),
    [anon_sym_COLON_GT] = ACTIONS(3101),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3101),
    [anon_sym_for] = ACTIONS(3099),
    [anon_sym_while] = ACTIONS(3099),
    [anon_sym_if] = ACTIONS(3099),
    [anon_sym_fun] = ACTIONS(3099),
    [anon_sym_try] = ACTIONS(3099),
    [anon_sym_match] = ACTIONS(3099),
    [anon_sym_match_BANG] = ACTIONS(3101),
    [anon_sym_function] = ACTIONS(3099),
    [anon_sym_LT_DASH] = ACTIONS(3099),
    [anon_sym_DOT_LBRACK] = ACTIONS(3101),
    [anon_sym_LT] = ACTIONS(3101),
    [anon_sym_use] = ACTIONS(3099),
    [anon_sym_use_BANG] = ACTIONS(3101),
    [anon_sym_do_BANG] = ACTIONS(3101),
    [anon_sym_DOT_DOT] = ACTIONS(3101),
    [anon_sym_begin] = ACTIONS(3099),
    [anon_sym_LPAREN2] = ACTIONS(3099),
    [anon_sym_or] = ACTIONS(3099),
    [aux_sym_char_token1] = ACTIONS(3101),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3099),
    [anon_sym_DQUOTE] = ACTIONS(3099),
    [anon_sym_AT_DQUOTE] = ACTIONS(3101),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3101),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3101),
    [sym_bool] = ACTIONS(3099),
    [sym_unit] = ACTIONS(3101),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3099),
    [sym_op_identifier] = ACTIONS(3099),
    [anon_sym_PLUS] = ACTIONS(3099),
    [anon_sym_DASH] = ACTIONS(3099),
    [anon_sym_PLUS_DOT] = ACTIONS(3099),
    [anon_sym_DASH_DOT] = ACTIONS(3099),
    [anon_sym_PERCENT] = ACTIONS(3099),
    [anon_sym_AMP_AMP] = ACTIONS(3099),
    [anon_sym_TILDE] = ACTIONS(3101),
    [aux_sym_prefix_op_token1] = ACTIONS(3099),
    [aux_sym_infix_op_token1] = ACTIONS(3101),
    [aux_sym_infix_op_token2] = ACTIONS(3099),
    [anon_sym_PIPE_PIPE] = ACTIONS(3099),
    [anon_sym_BANG_EQ] = ACTIONS(3099),
    [anon_sym_COLON_EQ] = ACTIONS(3101),
    [anon_sym_DOLLAR] = ACTIONS(3099),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3099),
    [sym_int] = ACTIONS(3099),
    [sym_xint] = ACTIONS(3101),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3101),
    [sym__newline] = ACTIONS(3101),
  },
  [2188] = {
    [sym_block_comment] = STATE(2188),
    [sym_compiler_directive_decl] = STATE(2188),
    [sym_fsi_directive_decl] = STATE(2188),
    [sym_preproc_line] = STATE(2188),
    [sym_identifier] = ACTIONS(3007),
    [anon_sym_EQ] = ACTIONS(3009),
    [anon_sym_COLON] = ACTIONS(3007),
    [anon_sym_return] = ACTIONS(3007),
    [anon_sym_do] = ACTIONS(3007),
    [anon_sym_let] = ACTIONS(3007),
    [anon_sym_let_BANG] = ACTIONS(3009),
    [anon_sym_LPAREN] = ACTIONS(3007),
    [anon_sym_COMMA] = ACTIONS(3009),
    [anon_sym_null] = ACTIONS(3007),
    [anon_sym_QMARK] = ACTIONS(3007),
    [anon_sym_COLON_QMARK] = ACTIONS(3007),
    [anon_sym_COLON_COLON] = ACTIONS(3009),
    [anon_sym_AMP] = ACTIONS(3007),
    [anon_sym_LBRACK] = ACTIONS(3007),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3009),
    [anon_sym_LBRACE] = ACTIONS(3007),
    [anon_sym_LT_AT] = ACTIONS(3007),
    [anon_sym_LT_AT_AT] = ACTIONS(3007),
    [anon_sym_DOT] = ACTIONS(3007),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3009),
    [anon_sym_new] = ACTIONS(3007),
    [anon_sym_return_BANG] = ACTIONS(3009),
    [anon_sym_yield] = ACTIONS(3007),
    [anon_sym_yield_BANG] = ACTIONS(3009),
    [anon_sym_lazy] = ACTIONS(3007),
    [anon_sym_assert] = ACTIONS(3007),
    [anon_sym_upcast] = ACTIONS(3007),
    [anon_sym_downcast] = ACTIONS(3007),
    [anon_sym_COLON_GT] = ACTIONS(3009),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3009),
    [anon_sym_for] = ACTIONS(3007),
    [anon_sym_while] = ACTIONS(3007),
    [anon_sym_if] = ACTIONS(3007),
    [anon_sym_fun] = ACTIONS(3007),
    [anon_sym_try] = ACTIONS(3007),
    [anon_sym_match] = ACTIONS(3007),
    [anon_sym_match_BANG] = ACTIONS(3009),
    [anon_sym_function] = ACTIONS(3007),
    [anon_sym_LT_DASH] = ACTIONS(3007),
    [anon_sym_DOT_LBRACK] = ACTIONS(3009),
    [anon_sym_LT] = ACTIONS(3009),
    [anon_sym_use] = ACTIONS(3007),
    [anon_sym_use_BANG] = ACTIONS(3009),
    [anon_sym_do_BANG] = ACTIONS(3009),
    [anon_sym_begin] = ACTIONS(3007),
    [anon_sym_LPAREN2] = ACTIONS(3007),
    [anon_sym_or] = ACTIONS(3007),
    [aux_sym_char_token1] = ACTIONS(3009),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3007),
    [anon_sym_DQUOTE] = ACTIONS(3007),
    [anon_sym_AT_DQUOTE] = ACTIONS(3009),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3009),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3009),
    [sym_bool] = ACTIONS(3007),
    [sym_unit] = ACTIONS(3009),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3007),
    [sym_op_identifier] = ACTIONS(3007),
    [anon_sym_PLUS] = ACTIONS(3007),
    [anon_sym_DASH] = ACTIONS(3007),
    [anon_sym_PLUS_DOT] = ACTIONS(3007),
    [anon_sym_DASH_DOT] = ACTIONS(3007),
    [anon_sym_PERCENT] = ACTIONS(3007),
    [anon_sym_AMP_AMP] = ACTIONS(3007),
    [anon_sym_TILDE] = ACTIONS(3009),
    [aux_sym_prefix_op_token1] = ACTIONS(3007),
    [aux_sym_infix_op_token1] = ACTIONS(3009),
    [aux_sym_infix_op_token2] = ACTIONS(3007),
    [anon_sym_PIPE_PIPE] = ACTIONS(3007),
    [anon_sym_BANG_EQ] = ACTIONS(3007),
    [anon_sym_COLON_EQ] = ACTIONS(3009),
    [anon_sym_DOLLAR] = ACTIONS(3007),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3007),
    [sym_int] = ACTIONS(3007),
    [sym_xint] = ACTIONS(3009),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3009),
    [anon_sym_POUNDendif] = ACTIONS(3009),
    [sym__newline] = ACTIONS(3009),
  },
  [2189] = {
    [sym_block_comment] = STATE(2189),
    [sym_compiler_directive_decl] = STATE(2189),
    [sym_fsi_directive_decl] = STATE(2189),
    [sym_preproc_line] = STATE(2189),
    [sym_identifier] = ACTIONS(3083),
    [anon_sym_EQ] = ACTIONS(3085),
    [anon_sym_COLON] = ACTIONS(3083),
    [anon_sym_return] = ACTIONS(3083),
    [anon_sym_do] = ACTIONS(3083),
    [anon_sym_let] = ACTIONS(3083),
    [anon_sym_let_BANG] = ACTIONS(3085),
    [anon_sym_LPAREN] = ACTIONS(3083),
    [anon_sym_COMMA] = ACTIONS(3085),
    [anon_sym_null] = ACTIONS(3083),
    [anon_sym_QMARK] = ACTIONS(3083),
    [anon_sym_COLON_QMARK] = ACTIONS(3083),
    [anon_sym_COLON_COLON] = ACTIONS(3085),
    [anon_sym_AMP] = ACTIONS(3083),
    [anon_sym_LBRACK] = ACTIONS(3083),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3085),
    [anon_sym_LBRACE] = ACTIONS(3083),
    [anon_sym_LT_AT] = ACTIONS(3083),
    [anon_sym_LT_AT_AT] = ACTIONS(3083),
    [anon_sym_DOT] = ACTIONS(3083),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3085),
    [anon_sym_new] = ACTIONS(3083),
    [anon_sym_return_BANG] = ACTIONS(3085),
    [anon_sym_yield] = ACTIONS(3083),
    [anon_sym_yield_BANG] = ACTIONS(3085),
    [anon_sym_lazy] = ACTIONS(3083),
    [anon_sym_assert] = ACTIONS(3083),
    [anon_sym_upcast] = ACTIONS(3083),
    [anon_sym_downcast] = ACTIONS(3083),
    [anon_sym_COLON_GT] = ACTIONS(3085),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3085),
    [anon_sym_for] = ACTIONS(3083),
    [anon_sym_while] = ACTIONS(3083),
    [anon_sym_if] = ACTIONS(3083),
    [anon_sym_fun] = ACTIONS(3083),
    [anon_sym_try] = ACTIONS(3083),
    [anon_sym_match] = ACTIONS(3083),
    [anon_sym_match_BANG] = ACTIONS(3085),
    [anon_sym_function] = ACTIONS(3083),
    [anon_sym_LT_DASH] = ACTIONS(3083),
    [anon_sym_DOT_LBRACK] = ACTIONS(3085),
    [anon_sym_LT] = ACTIONS(3085),
    [anon_sym_use] = ACTIONS(3083),
    [anon_sym_use_BANG] = ACTIONS(3085),
    [anon_sym_do_BANG] = ACTIONS(3085),
    [anon_sym_DOT_DOT] = ACTIONS(3085),
    [anon_sym_begin] = ACTIONS(3083),
    [anon_sym_LPAREN2] = ACTIONS(3083),
    [anon_sym_or] = ACTIONS(3083),
    [aux_sym_char_token1] = ACTIONS(3085),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3083),
    [anon_sym_DQUOTE] = ACTIONS(3083),
    [anon_sym_AT_DQUOTE] = ACTIONS(3085),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3085),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3085),
    [sym_bool] = ACTIONS(3083),
    [sym_unit] = ACTIONS(3085),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3083),
    [sym_op_identifier] = ACTIONS(3083),
    [anon_sym_PLUS] = ACTIONS(3083),
    [anon_sym_DASH] = ACTIONS(3083),
    [anon_sym_PLUS_DOT] = ACTIONS(3083),
    [anon_sym_DASH_DOT] = ACTIONS(3083),
    [anon_sym_PERCENT] = ACTIONS(3083),
    [anon_sym_AMP_AMP] = ACTIONS(3083),
    [anon_sym_TILDE] = ACTIONS(3085),
    [aux_sym_prefix_op_token1] = ACTIONS(3083),
    [aux_sym_infix_op_token1] = ACTIONS(3085),
    [aux_sym_infix_op_token2] = ACTIONS(3083),
    [anon_sym_PIPE_PIPE] = ACTIONS(3083),
    [anon_sym_BANG_EQ] = ACTIONS(3083),
    [anon_sym_COLON_EQ] = ACTIONS(3085),
    [anon_sym_DOLLAR] = ACTIONS(3083),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3083),
    [sym_int] = ACTIONS(3083),
    [sym_xint] = ACTIONS(3085),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3085),
    [sym__newline] = ACTIONS(3085),
  },
  [2190] = {
    [sym_block_comment] = STATE(2190),
    [sym_compiler_directive_decl] = STATE(2190),
    [sym_fsi_directive_decl] = STATE(2190),
    [sym_preproc_line] = STATE(2190),
    [sym_identifier] = ACTIONS(3079),
    [anon_sym_EQ] = ACTIONS(3081),
    [anon_sym_COLON] = ACTIONS(3079),
    [anon_sym_return] = ACTIONS(3079),
    [anon_sym_do] = ACTIONS(3079),
    [anon_sym_let] = ACTIONS(3079),
    [anon_sym_let_BANG] = ACTIONS(3081),
    [anon_sym_LPAREN] = ACTIONS(3079),
    [anon_sym_COMMA] = ACTIONS(3081),
    [anon_sym_null] = ACTIONS(3079),
    [anon_sym_QMARK] = ACTIONS(3079),
    [anon_sym_COLON_QMARK] = ACTIONS(3079),
    [anon_sym_COLON_COLON] = ACTIONS(3081),
    [anon_sym_AMP] = ACTIONS(3079),
    [anon_sym_LBRACK] = ACTIONS(3079),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3081),
    [anon_sym_LBRACE] = ACTIONS(3079),
    [anon_sym_LT_AT] = ACTIONS(3079),
    [anon_sym_LT_AT_AT] = ACTIONS(3079),
    [anon_sym_DOT] = ACTIONS(3079),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3081),
    [anon_sym_new] = ACTIONS(3079),
    [anon_sym_return_BANG] = ACTIONS(3081),
    [anon_sym_yield] = ACTIONS(3079),
    [anon_sym_yield_BANG] = ACTIONS(3081),
    [anon_sym_lazy] = ACTIONS(3079),
    [anon_sym_assert] = ACTIONS(3079),
    [anon_sym_upcast] = ACTIONS(3079),
    [anon_sym_downcast] = ACTIONS(3079),
    [anon_sym_COLON_GT] = ACTIONS(3081),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3081),
    [anon_sym_for] = ACTIONS(3079),
    [anon_sym_while] = ACTIONS(3079),
    [anon_sym_if] = ACTIONS(3079),
    [anon_sym_fun] = ACTIONS(3079),
    [anon_sym_try] = ACTIONS(3079),
    [anon_sym_match] = ACTIONS(3079),
    [anon_sym_match_BANG] = ACTIONS(3081),
    [anon_sym_function] = ACTIONS(3079),
    [anon_sym_LT_DASH] = ACTIONS(3079),
    [anon_sym_DOT_LBRACK] = ACTIONS(3081),
    [anon_sym_LT] = ACTIONS(3081),
    [anon_sym_use] = ACTIONS(3079),
    [anon_sym_use_BANG] = ACTIONS(3081),
    [anon_sym_do_BANG] = ACTIONS(3081),
    [anon_sym_DOT_DOT] = ACTIONS(3081),
    [anon_sym_begin] = ACTIONS(3079),
    [anon_sym_LPAREN2] = ACTIONS(3079),
    [anon_sym_or] = ACTIONS(3079),
    [aux_sym_char_token1] = ACTIONS(3081),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3079),
    [anon_sym_DQUOTE] = ACTIONS(3079),
    [anon_sym_AT_DQUOTE] = ACTIONS(3081),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3081),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3081),
    [sym_bool] = ACTIONS(3079),
    [sym_unit] = ACTIONS(3081),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3079),
    [sym_op_identifier] = ACTIONS(3079),
    [anon_sym_PLUS] = ACTIONS(3079),
    [anon_sym_DASH] = ACTIONS(3079),
    [anon_sym_PLUS_DOT] = ACTIONS(3079),
    [anon_sym_DASH_DOT] = ACTIONS(3079),
    [anon_sym_PERCENT] = ACTIONS(3079),
    [anon_sym_AMP_AMP] = ACTIONS(3079),
    [anon_sym_TILDE] = ACTIONS(3081),
    [aux_sym_prefix_op_token1] = ACTIONS(3079),
    [aux_sym_infix_op_token1] = ACTIONS(3081),
    [aux_sym_infix_op_token2] = ACTIONS(3079),
    [anon_sym_PIPE_PIPE] = ACTIONS(3079),
    [anon_sym_BANG_EQ] = ACTIONS(3079),
    [anon_sym_COLON_EQ] = ACTIONS(3081),
    [anon_sym_DOLLAR] = ACTIONS(3079),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3079),
    [sym_int] = ACTIONS(3079),
    [sym_xint] = ACTIONS(3081),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3081),
    [sym__newline] = ACTIONS(3081),
  },
  [2191] = {
    [sym_block_comment] = STATE(2191),
    [sym_compiler_directive_decl] = STATE(2191),
    [sym_fsi_directive_decl] = STATE(2191),
    [sym_preproc_line] = STATE(2191),
    [sym_identifier] = ACTIONS(3063),
    [anon_sym_EQ] = ACTIONS(3065),
    [anon_sym_COLON] = ACTIONS(3063),
    [anon_sym_return] = ACTIONS(3063),
    [anon_sym_do] = ACTIONS(3063),
    [anon_sym_let] = ACTIONS(3063),
    [anon_sym_let_BANG] = ACTIONS(3065),
    [anon_sym_LPAREN] = ACTIONS(3063),
    [anon_sym_COMMA] = ACTIONS(3065),
    [anon_sym_null] = ACTIONS(3063),
    [anon_sym_QMARK] = ACTIONS(3063),
    [anon_sym_COLON_QMARK] = ACTIONS(3063),
    [anon_sym_COLON_COLON] = ACTIONS(3065),
    [anon_sym_AMP] = ACTIONS(3063),
    [anon_sym_LBRACK] = ACTIONS(3063),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3065),
    [anon_sym_LBRACE] = ACTIONS(3063),
    [anon_sym_LT_AT] = ACTIONS(3063),
    [anon_sym_LT_AT_AT] = ACTIONS(3063),
    [anon_sym_DOT] = ACTIONS(3063),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3065),
    [anon_sym_new] = ACTIONS(3063),
    [anon_sym_return_BANG] = ACTIONS(3065),
    [anon_sym_yield] = ACTIONS(3063),
    [anon_sym_yield_BANG] = ACTIONS(3065),
    [anon_sym_lazy] = ACTIONS(3063),
    [anon_sym_assert] = ACTIONS(3063),
    [anon_sym_upcast] = ACTIONS(3063),
    [anon_sym_downcast] = ACTIONS(3063),
    [anon_sym_COLON_GT] = ACTIONS(3065),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3065),
    [anon_sym_for] = ACTIONS(3063),
    [anon_sym_while] = ACTIONS(3063),
    [anon_sym_if] = ACTIONS(3063),
    [anon_sym_fun] = ACTIONS(3063),
    [anon_sym_try] = ACTIONS(3063),
    [anon_sym_match] = ACTIONS(3063),
    [anon_sym_match_BANG] = ACTIONS(3065),
    [anon_sym_function] = ACTIONS(3063),
    [anon_sym_LT_DASH] = ACTIONS(3063),
    [anon_sym_DOT_LBRACK] = ACTIONS(3065),
    [anon_sym_LT] = ACTIONS(3065),
    [anon_sym_use] = ACTIONS(3063),
    [anon_sym_use_BANG] = ACTIONS(3065),
    [anon_sym_do_BANG] = ACTIONS(3065),
    [anon_sym_DOT_DOT] = ACTIONS(3065),
    [anon_sym_begin] = ACTIONS(3063),
    [anon_sym_LPAREN2] = ACTIONS(3063),
    [anon_sym_or] = ACTIONS(3063),
    [aux_sym_char_token1] = ACTIONS(3065),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3063),
    [anon_sym_DQUOTE] = ACTIONS(3063),
    [anon_sym_AT_DQUOTE] = ACTIONS(3065),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3065),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3065),
    [sym_bool] = ACTIONS(3063),
    [sym_unit] = ACTIONS(3065),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3063),
    [sym_op_identifier] = ACTIONS(3063),
    [anon_sym_PLUS] = ACTIONS(3063),
    [anon_sym_DASH] = ACTIONS(3063),
    [anon_sym_PLUS_DOT] = ACTIONS(3063),
    [anon_sym_DASH_DOT] = ACTIONS(3063),
    [anon_sym_PERCENT] = ACTIONS(3063),
    [anon_sym_AMP_AMP] = ACTIONS(3063),
    [anon_sym_TILDE] = ACTIONS(3065),
    [aux_sym_prefix_op_token1] = ACTIONS(3063),
    [aux_sym_infix_op_token1] = ACTIONS(3065),
    [aux_sym_infix_op_token2] = ACTIONS(3063),
    [anon_sym_PIPE_PIPE] = ACTIONS(3063),
    [anon_sym_BANG_EQ] = ACTIONS(3063),
    [anon_sym_COLON_EQ] = ACTIONS(3065),
    [anon_sym_DOLLAR] = ACTIONS(3063),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3063),
    [sym_int] = ACTIONS(3063),
    [sym_xint] = ACTIONS(3065),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3065),
    [sym__newline] = ACTIONS(3065),
  },
  [2192] = {
    [sym_block_comment] = STATE(2192),
    [sym_compiler_directive_decl] = STATE(2192),
    [sym_fsi_directive_decl] = STATE(2192),
    [sym_preproc_line] = STATE(2192),
    [sym_identifier] = ACTIONS(3059),
    [anon_sym_EQ] = ACTIONS(3061),
    [anon_sym_COLON] = ACTIONS(3059),
    [anon_sym_return] = ACTIONS(3059),
    [anon_sym_do] = ACTIONS(3059),
    [anon_sym_let] = ACTIONS(3059),
    [anon_sym_let_BANG] = ACTIONS(3061),
    [anon_sym_LPAREN] = ACTIONS(3059),
    [anon_sym_COMMA] = ACTIONS(3061),
    [anon_sym_null] = ACTIONS(3059),
    [anon_sym_QMARK] = ACTIONS(3059),
    [anon_sym_COLON_QMARK] = ACTIONS(3059),
    [anon_sym_COLON_COLON] = ACTIONS(3061),
    [anon_sym_AMP] = ACTIONS(3059),
    [anon_sym_LBRACK] = ACTIONS(3059),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3061),
    [anon_sym_LBRACE] = ACTIONS(3059),
    [anon_sym_LT_AT] = ACTIONS(3059),
    [anon_sym_LT_AT_AT] = ACTIONS(3059),
    [anon_sym_DOT] = ACTIONS(3059),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3061),
    [anon_sym_new] = ACTIONS(3059),
    [anon_sym_return_BANG] = ACTIONS(3061),
    [anon_sym_yield] = ACTIONS(3059),
    [anon_sym_yield_BANG] = ACTIONS(3061),
    [anon_sym_lazy] = ACTIONS(3059),
    [anon_sym_assert] = ACTIONS(3059),
    [anon_sym_upcast] = ACTIONS(3059),
    [anon_sym_downcast] = ACTIONS(3059),
    [anon_sym_COLON_GT] = ACTIONS(3061),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3061),
    [anon_sym_for] = ACTIONS(3059),
    [anon_sym_while] = ACTIONS(3059),
    [anon_sym_if] = ACTIONS(3059),
    [anon_sym_fun] = ACTIONS(3059),
    [anon_sym_try] = ACTIONS(3059),
    [anon_sym_match] = ACTIONS(3059),
    [anon_sym_match_BANG] = ACTIONS(3061),
    [anon_sym_function] = ACTIONS(3059),
    [anon_sym_LT_DASH] = ACTIONS(3059),
    [anon_sym_DOT_LBRACK] = ACTIONS(3061),
    [anon_sym_LT] = ACTIONS(3061),
    [anon_sym_use] = ACTIONS(3059),
    [anon_sym_use_BANG] = ACTIONS(3061),
    [anon_sym_do_BANG] = ACTIONS(3061),
    [anon_sym_DOT_DOT] = ACTIONS(3061),
    [anon_sym_begin] = ACTIONS(3059),
    [anon_sym_LPAREN2] = ACTIONS(3059),
    [anon_sym_or] = ACTIONS(3059),
    [aux_sym_char_token1] = ACTIONS(3061),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3059),
    [anon_sym_DQUOTE] = ACTIONS(3059),
    [anon_sym_AT_DQUOTE] = ACTIONS(3061),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3061),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3061),
    [sym_bool] = ACTIONS(3059),
    [sym_unit] = ACTIONS(3061),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3059),
    [sym_op_identifier] = ACTIONS(3059),
    [anon_sym_PLUS] = ACTIONS(3059),
    [anon_sym_DASH] = ACTIONS(3059),
    [anon_sym_PLUS_DOT] = ACTIONS(3059),
    [anon_sym_DASH_DOT] = ACTIONS(3059),
    [anon_sym_PERCENT] = ACTIONS(3059),
    [anon_sym_AMP_AMP] = ACTIONS(3059),
    [anon_sym_TILDE] = ACTIONS(3061),
    [aux_sym_prefix_op_token1] = ACTIONS(3059),
    [aux_sym_infix_op_token1] = ACTIONS(3061),
    [aux_sym_infix_op_token2] = ACTIONS(3059),
    [anon_sym_PIPE_PIPE] = ACTIONS(3059),
    [anon_sym_BANG_EQ] = ACTIONS(3059),
    [anon_sym_COLON_EQ] = ACTIONS(3061),
    [anon_sym_DOLLAR] = ACTIONS(3059),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3059),
    [sym_int] = ACTIONS(3059),
    [sym_xint] = ACTIONS(3061),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3061),
    [sym__newline] = ACTIONS(3061),
  },
  [2193] = {
    [sym_attributes] = STATE(2652),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(3588),
    [sym__pattern] = STATE(2004),
    [sym_optional_pattern] = STATE(3588),
    [sym_type_check_pattern] = STATE(3588),
    [sym_attribute_pattern] = STATE(3588),
    [sym_paren_pattern] = STATE(3588),
    [sym_as_pattern] = STATE(3588),
    [sym_cons_pattern] = STATE(3588),
    [sym_disjunct_pattern] = STATE(3588),
    [sym_conjunct_pattern] = STATE(3588),
    [sym_typed_pattern] = STATE(3588),
    [sym_list_pattern] = STATE(3588),
    [sym_array_pattern] = STATE(3588),
    [sym_record_pattern] = STATE(3588),
    [sym_named_field_pattern] = STATE(3588),
    [sym_identifier_pattern] = STATE(3588),
    [sym_long_identifier_or_op] = STATE(2401),
    [sym_char] = STATE(3658),
    [sym_format_string] = STATE(3670),
    [sym__string_literal] = STATE(3670),
    [sym_string] = STATE(3658),
    [sym_verbatim_string] = STATE(3658),
    [sym_bytearray] = STATE(3658),
    [sym_verbatim_bytearray] = STATE(3658),
    [sym_format_triple_quoted_string] = STATE(3673),
    [sym_triple_quoted_string] = STATE(3658),
    [sym_const] = STATE(3588),
    [sym_long_identifier] = STATE(3493),
    [sym_active_pattern] = STATE(3613),
    [sym__identifier_or_op] = STATE(3650),
    [sym_sbyte] = STATE(3658),
    [sym_byte] = STATE(3658),
    [sym_int16] = STATE(3658),
    [sym_uint16] = STATE(3658),
    [sym_int32] = STATE(3658),
    [sym_uint32] = STATE(3658),
    [sym_nativeint] = STATE(3658),
    [sym_unativeint] = STATE(3658),
    [sym_int64] = STATE(3658),
    [sym_uint64] = STATE(3658),
    [sym_ieee32] = STATE(3658),
    [sym_ieee64] = STATE(3658),
    [sym_bignum] = STATE(3658),
    [sym_decimal] = STATE(3658),
    [sym_float] = STATE(3376),
    [sym_block_comment] = STATE(2193),
    [sym_compiler_directive_decl] = STATE(2193),
    [sym_fsi_directive_decl] = STATE(2193),
    [sym_preproc_line] = STATE(2193),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(4175),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_COLON] = ACTIONS(3960),
    [anon_sym_as] = ACTIONS(3960),
    [anon_sym_LPAREN] = ACTIONS(4218),
    [anon_sym_COMMA] = ACTIONS(3964),
    [anon_sym_null] = ACTIONS(4220),
    [anon_sym__] = ACTIONS(4222),
    [anon_sym_QMARK] = ACTIONS(4224),
    [anon_sym_COLON_QMARK] = ACTIONS(4226),
    [anon_sym_COLON_COLON] = ACTIONS(3964),
    [anon_sym_PIPE] = ACTIONS(3964),
    [anon_sym_AMP] = ACTIONS(3964),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4230),
    [anon_sym_LBRACE] = ACTIONS(4232),
    [anon_sym_DASH_GT] = ACTIONS(3964),
    [anon_sym_when] = ACTIONS(3960),
    [aux_sym_char_token1] = ACTIONS(4234),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4236),
    [anon_sym_DQUOTE] = ACTIONS(4238),
    [anon_sym_AT_DQUOTE] = ACTIONS(4240),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4242),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4244),
    [sym_bool] = ACTIONS(4246),
    [sym_unit] = ACTIONS(4248),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4181),
    [sym_op_identifier] = ACTIONS(4183),
    [sym_int] = ACTIONS(4250),
    [sym_xint] = ACTIONS(4252),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2194] = {
    [sym_block_comment] = STATE(2194),
    [sym_compiler_directive_decl] = STATE(2194),
    [sym_fsi_directive_decl] = STATE(2194),
    [sym_preproc_line] = STATE(2194),
    [sym_identifier] = ACTIONS(3051),
    [anon_sym_EQ] = ACTIONS(3053),
    [anon_sym_COLON] = ACTIONS(3051),
    [anon_sym_return] = ACTIONS(3051),
    [anon_sym_do] = ACTIONS(3051),
    [anon_sym_let] = ACTIONS(3051),
    [anon_sym_let_BANG] = ACTIONS(3053),
    [anon_sym_LPAREN] = ACTIONS(3051),
    [anon_sym_COMMA] = ACTIONS(3053),
    [anon_sym_null] = ACTIONS(3051),
    [anon_sym_QMARK] = ACTIONS(3051),
    [anon_sym_COLON_QMARK] = ACTIONS(3051),
    [anon_sym_COLON_COLON] = ACTIONS(3053),
    [anon_sym_AMP] = ACTIONS(3051),
    [anon_sym_LBRACK] = ACTIONS(3051),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3053),
    [anon_sym_LBRACE] = ACTIONS(3051),
    [anon_sym_LT_AT] = ACTIONS(3051),
    [anon_sym_LT_AT_AT] = ACTIONS(3051),
    [anon_sym_DOT] = ACTIONS(3051),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3053),
    [anon_sym_new] = ACTIONS(3051),
    [anon_sym_return_BANG] = ACTIONS(3053),
    [anon_sym_yield] = ACTIONS(3051),
    [anon_sym_yield_BANG] = ACTIONS(3053),
    [anon_sym_lazy] = ACTIONS(3051),
    [anon_sym_assert] = ACTIONS(3051),
    [anon_sym_upcast] = ACTIONS(3051),
    [anon_sym_downcast] = ACTIONS(3051),
    [anon_sym_COLON_GT] = ACTIONS(3053),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3053),
    [anon_sym_for] = ACTIONS(3051),
    [anon_sym_while] = ACTIONS(3051),
    [anon_sym_if] = ACTIONS(3051),
    [anon_sym_fun] = ACTIONS(3051),
    [anon_sym_try] = ACTIONS(3051),
    [anon_sym_match] = ACTIONS(3051),
    [anon_sym_match_BANG] = ACTIONS(3053),
    [anon_sym_function] = ACTIONS(3051),
    [anon_sym_LT_DASH] = ACTIONS(3051),
    [anon_sym_DOT_LBRACK] = ACTIONS(3053),
    [anon_sym_LT] = ACTIONS(3053),
    [anon_sym_use] = ACTIONS(3051),
    [anon_sym_use_BANG] = ACTIONS(3053),
    [anon_sym_do_BANG] = ACTIONS(3053),
    [anon_sym_DOT_DOT] = ACTIONS(3053),
    [anon_sym_begin] = ACTIONS(3051),
    [anon_sym_LPAREN2] = ACTIONS(3051),
    [anon_sym_or] = ACTIONS(3051),
    [aux_sym_char_token1] = ACTIONS(3053),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3051),
    [anon_sym_DQUOTE] = ACTIONS(3051),
    [anon_sym_AT_DQUOTE] = ACTIONS(3053),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3053),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3053),
    [sym_bool] = ACTIONS(3051),
    [sym_unit] = ACTIONS(3053),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3051),
    [sym_op_identifier] = ACTIONS(3051),
    [anon_sym_PLUS] = ACTIONS(3051),
    [anon_sym_DASH] = ACTIONS(3051),
    [anon_sym_PLUS_DOT] = ACTIONS(3051),
    [anon_sym_DASH_DOT] = ACTIONS(3051),
    [anon_sym_PERCENT] = ACTIONS(3051),
    [anon_sym_AMP_AMP] = ACTIONS(3051),
    [anon_sym_TILDE] = ACTIONS(3053),
    [aux_sym_prefix_op_token1] = ACTIONS(3051),
    [aux_sym_infix_op_token1] = ACTIONS(3053),
    [aux_sym_infix_op_token2] = ACTIONS(3051),
    [anon_sym_PIPE_PIPE] = ACTIONS(3051),
    [anon_sym_BANG_EQ] = ACTIONS(3051),
    [anon_sym_COLON_EQ] = ACTIONS(3053),
    [anon_sym_DOLLAR] = ACTIONS(3051),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3051),
    [sym_int] = ACTIONS(3051),
    [sym_xint] = ACTIONS(3053),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3053),
    [sym__newline] = ACTIONS(3053),
  },
  [2195] = {
    [sym_block_comment] = STATE(2195),
    [sym_compiler_directive_decl] = STATE(2195),
    [sym_fsi_directive_decl] = STATE(2195),
    [sym_preproc_line] = STATE(2195),
    [sym_identifier] = ACTIONS(3047),
    [anon_sym_EQ] = ACTIONS(3049),
    [anon_sym_COLON] = ACTIONS(3047),
    [anon_sym_return] = ACTIONS(3047),
    [anon_sym_do] = ACTIONS(3047),
    [anon_sym_let] = ACTIONS(3047),
    [anon_sym_let_BANG] = ACTIONS(3049),
    [anon_sym_LPAREN] = ACTIONS(3047),
    [anon_sym_COMMA] = ACTIONS(3049),
    [anon_sym_null] = ACTIONS(3047),
    [anon_sym_QMARK] = ACTIONS(3047),
    [anon_sym_COLON_QMARK] = ACTIONS(3047),
    [anon_sym_COLON_COLON] = ACTIONS(3049),
    [anon_sym_AMP] = ACTIONS(3047),
    [anon_sym_LBRACK] = ACTIONS(3047),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3049),
    [anon_sym_LBRACE] = ACTIONS(3047),
    [anon_sym_LT_AT] = ACTIONS(3047),
    [anon_sym_LT_AT_AT] = ACTIONS(3047),
    [anon_sym_DOT] = ACTIONS(3047),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3049),
    [anon_sym_new] = ACTIONS(3047),
    [anon_sym_return_BANG] = ACTIONS(3049),
    [anon_sym_yield] = ACTIONS(3047),
    [anon_sym_yield_BANG] = ACTIONS(3049),
    [anon_sym_lazy] = ACTIONS(3047),
    [anon_sym_assert] = ACTIONS(3047),
    [anon_sym_upcast] = ACTIONS(3047),
    [anon_sym_downcast] = ACTIONS(3047),
    [anon_sym_COLON_GT] = ACTIONS(3049),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3049),
    [anon_sym_for] = ACTIONS(3047),
    [anon_sym_while] = ACTIONS(3047),
    [anon_sym_if] = ACTIONS(3047),
    [anon_sym_fun] = ACTIONS(3047),
    [anon_sym_try] = ACTIONS(3047),
    [anon_sym_match] = ACTIONS(3047),
    [anon_sym_match_BANG] = ACTIONS(3049),
    [anon_sym_function] = ACTIONS(3047),
    [anon_sym_LT_DASH] = ACTIONS(3047),
    [anon_sym_DOT_LBRACK] = ACTIONS(3049),
    [anon_sym_LT] = ACTIONS(3049),
    [anon_sym_use] = ACTIONS(3047),
    [anon_sym_use_BANG] = ACTIONS(3049),
    [anon_sym_do_BANG] = ACTIONS(3049),
    [anon_sym_DOT_DOT] = ACTIONS(3049),
    [anon_sym_begin] = ACTIONS(3047),
    [anon_sym_LPAREN2] = ACTIONS(3047),
    [anon_sym_or] = ACTIONS(3047),
    [aux_sym_char_token1] = ACTIONS(3049),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3047),
    [anon_sym_DQUOTE] = ACTIONS(3047),
    [anon_sym_AT_DQUOTE] = ACTIONS(3049),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3049),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3049),
    [sym_bool] = ACTIONS(3047),
    [sym_unit] = ACTIONS(3049),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3047),
    [sym_op_identifier] = ACTIONS(3047),
    [anon_sym_PLUS] = ACTIONS(3047),
    [anon_sym_DASH] = ACTIONS(3047),
    [anon_sym_PLUS_DOT] = ACTIONS(3047),
    [anon_sym_DASH_DOT] = ACTIONS(3047),
    [anon_sym_PERCENT] = ACTIONS(3047),
    [anon_sym_AMP_AMP] = ACTIONS(3047),
    [anon_sym_TILDE] = ACTIONS(3049),
    [aux_sym_prefix_op_token1] = ACTIONS(3047),
    [aux_sym_infix_op_token1] = ACTIONS(3049),
    [aux_sym_infix_op_token2] = ACTIONS(3047),
    [anon_sym_PIPE_PIPE] = ACTIONS(3047),
    [anon_sym_BANG_EQ] = ACTIONS(3047),
    [anon_sym_COLON_EQ] = ACTIONS(3049),
    [anon_sym_DOLLAR] = ACTIONS(3047),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3047),
    [sym_int] = ACTIONS(3047),
    [sym_xint] = ACTIONS(3049),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3049),
    [sym__newline] = ACTIONS(3049),
  },
  [2196] = {
    [sym_block_comment] = STATE(2196),
    [sym_compiler_directive_decl] = STATE(2196),
    [sym_fsi_directive_decl] = STATE(2196),
    [sym_preproc_line] = STATE(2196),
    [sym_identifier] = ACTIONS(3043),
    [anon_sym_EQ] = ACTIONS(3045),
    [anon_sym_COLON] = ACTIONS(3043),
    [anon_sym_return] = ACTIONS(3043),
    [anon_sym_do] = ACTIONS(3043),
    [anon_sym_let] = ACTIONS(3043),
    [anon_sym_let_BANG] = ACTIONS(3045),
    [anon_sym_LPAREN] = ACTIONS(3043),
    [anon_sym_COMMA] = ACTIONS(3045),
    [anon_sym_null] = ACTIONS(3043),
    [anon_sym_QMARK] = ACTIONS(3043),
    [anon_sym_COLON_QMARK] = ACTIONS(3043),
    [anon_sym_COLON_COLON] = ACTIONS(3045),
    [anon_sym_AMP] = ACTIONS(3043),
    [anon_sym_LBRACK] = ACTIONS(3043),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3045),
    [anon_sym_LBRACE] = ACTIONS(3043),
    [anon_sym_LT_AT] = ACTIONS(3043),
    [anon_sym_LT_AT_AT] = ACTIONS(3043),
    [anon_sym_DOT] = ACTIONS(3043),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3045),
    [anon_sym_new] = ACTIONS(3043),
    [anon_sym_return_BANG] = ACTIONS(3045),
    [anon_sym_yield] = ACTIONS(3043),
    [anon_sym_yield_BANG] = ACTIONS(3045),
    [anon_sym_lazy] = ACTIONS(3043),
    [anon_sym_assert] = ACTIONS(3043),
    [anon_sym_upcast] = ACTIONS(3043),
    [anon_sym_downcast] = ACTIONS(3043),
    [anon_sym_COLON_GT] = ACTIONS(3045),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3045),
    [anon_sym_for] = ACTIONS(3043),
    [anon_sym_while] = ACTIONS(3043),
    [anon_sym_if] = ACTIONS(3043),
    [anon_sym_fun] = ACTIONS(3043),
    [anon_sym_try] = ACTIONS(3043),
    [anon_sym_match] = ACTIONS(3043),
    [anon_sym_match_BANG] = ACTIONS(3045),
    [anon_sym_function] = ACTIONS(3043),
    [anon_sym_LT_DASH] = ACTIONS(3043),
    [anon_sym_DOT_LBRACK] = ACTIONS(3045),
    [anon_sym_LT] = ACTIONS(3045),
    [anon_sym_use] = ACTIONS(3043),
    [anon_sym_use_BANG] = ACTIONS(3045),
    [anon_sym_do_BANG] = ACTIONS(3045),
    [anon_sym_DOT_DOT] = ACTIONS(3045),
    [anon_sym_begin] = ACTIONS(3043),
    [anon_sym_LPAREN2] = ACTIONS(3043),
    [anon_sym_or] = ACTIONS(3043),
    [aux_sym_char_token1] = ACTIONS(3045),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3043),
    [anon_sym_DQUOTE] = ACTIONS(3043),
    [anon_sym_AT_DQUOTE] = ACTIONS(3045),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3045),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3045),
    [sym_bool] = ACTIONS(3043),
    [sym_unit] = ACTIONS(3045),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3043),
    [sym_op_identifier] = ACTIONS(3043),
    [anon_sym_PLUS] = ACTIONS(3043),
    [anon_sym_DASH] = ACTIONS(3043),
    [anon_sym_PLUS_DOT] = ACTIONS(3043),
    [anon_sym_DASH_DOT] = ACTIONS(3043),
    [anon_sym_PERCENT] = ACTIONS(3043),
    [anon_sym_AMP_AMP] = ACTIONS(3043),
    [anon_sym_TILDE] = ACTIONS(3045),
    [aux_sym_prefix_op_token1] = ACTIONS(3043),
    [aux_sym_infix_op_token1] = ACTIONS(3045),
    [aux_sym_infix_op_token2] = ACTIONS(3043),
    [anon_sym_PIPE_PIPE] = ACTIONS(3043),
    [anon_sym_BANG_EQ] = ACTIONS(3043),
    [anon_sym_COLON_EQ] = ACTIONS(3045),
    [anon_sym_DOLLAR] = ACTIONS(3043),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3043),
    [sym_int] = ACTIONS(3043),
    [sym_xint] = ACTIONS(3045),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3045),
    [sym__newline] = ACTIONS(3045),
  },
  [2197] = {
    [sym_block_comment] = STATE(2197),
    [sym_compiler_directive_decl] = STATE(2197),
    [sym_fsi_directive_decl] = STATE(2197),
    [sym_preproc_line] = STATE(2197),
    [sym_identifier] = ACTIONS(3039),
    [anon_sym_EQ] = ACTIONS(3041),
    [anon_sym_COLON] = ACTIONS(3039),
    [anon_sym_return] = ACTIONS(3039),
    [anon_sym_do] = ACTIONS(3039),
    [anon_sym_let] = ACTIONS(3039),
    [anon_sym_let_BANG] = ACTIONS(3041),
    [anon_sym_LPAREN] = ACTIONS(3039),
    [anon_sym_COMMA] = ACTIONS(3041),
    [anon_sym_null] = ACTIONS(3039),
    [anon_sym_QMARK] = ACTIONS(3039),
    [anon_sym_COLON_QMARK] = ACTIONS(3039),
    [anon_sym_COLON_COLON] = ACTIONS(3041),
    [anon_sym_AMP] = ACTIONS(3039),
    [anon_sym_LBRACK] = ACTIONS(3039),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3041),
    [anon_sym_LBRACE] = ACTIONS(3039),
    [anon_sym_LT_AT] = ACTIONS(3039),
    [anon_sym_LT_AT_AT] = ACTIONS(3039),
    [anon_sym_DOT] = ACTIONS(3039),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3041),
    [anon_sym_new] = ACTIONS(3039),
    [anon_sym_return_BANG] = ACTIONS(3041),
    [anon_sym_yield] = ACTIONS(3039),
    [anon_sym_yield_BANG] = ACTIONS(3041),
    [anon_sym_lazy] = ACTIONS(3039),
    [anon_sym_assert] = ACTIONS(3039),
    [anon_sym_upcast] = ACTIONS(3039),
    [anon_sym_downcast] = ACTIONS(3039),
    [anon_sym_COLON_GT] = ACTIONS(3041),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3041),
    [anon_sym_for] = ACTIONS(3039),
    [anon_sym_while] = ACTIONS(3039),
    [anon_sym_if] = ACTIONS(3039),
    [anon_sym_fun] = ACTIONS(3039),
    [anon_sym_try] = ACTIONS(3039),
    [anon_sym_match] = ACTIONS(3039),
    [anon_sym_match_BANG] = ACTIONS(3041),
    [anon_sym_function] = ACTIONS(3039),
    [anon_sym_LT_DASH] = ACTIONS(3039),
    [anon_sym_DOT_LBRACK] = ACTIONS(3041),
    [anon_sym_LT] = ACTIONS(3041),
    [anon_sym_use] = ACTIONS(3039),
    [anon_sym_use_BANG] = ACTIONS(3041),
    [anon_sym_do_BANG] = ACTIONS(3041),
    [anon_sym_DOT_DOT] = ACTIONS(3041),
    [anon_sym_begin] = ACTIONS(3039),
    [anon_sym_LPAREN2] = ACTIONS(3039),
    [anon_sym_or] = ACTIONS(3039),
    [aux_sym_char_token1] = ACTIONS(3041),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3039),
    [anon_sym_DQUOTE] = ACTIONS(3039),
    [anon_sym_AT_DQUOTE] = ACTIONS(3041),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3041),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3041),
    [sym_bool] = ACTIONS(3039),
    [sym_unit] = ACTIONS(3041),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3039),
    [sym_op_identifier] = ACTIONS(3039),
    [anon_sym_PLUS] = ACTIONS(3039),
    [anon_sym_DASH] = ACTIONS(3039),
    [anon_sym_PLUS_DOT] = ACTIONS(3039),
    [anon_sym_DASH_DOT] = ACTIONS(3039),
    [anon_sym_PERCENT] = ACTIONS(3039),
    [anon_sym_AMP_AMP] = ACTIONS(3039),
    [anon_sym_TILDE] = ACTIONS(3041),
    [aux_sym_prefix_op_token1] = ACTIONS(3039),
    [aux_sym_infix_op_token1] = ACTIONS(3041),
    [aux_sym_infix_op_token2] = ACTIONS(3039),
    [anon_sym_PIPE_PIPE] = ACTIONS(3039),
    [anon_sym_BANG_EQ] = ACTIONS(3039),
    [anon_sym_COLON_EQ] = ACTIONS(3041),
    [anon_sym_DOLLAR] = ACTIONS(3039),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3039),
    [sym_int] = ACTIONS(3039),
    [sym_xint] = ACTIONS(3041),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3041),
    [sym__newline] = ACTIONS(3041),
  },
  [2198] = {
    [sym_block_comment] = STATE(2198),
    [sym_compiler_directive_decl] = STATE(2198),
    [sym_fsi_directive_decl] = STATE(2198),
    [sym_preproc_line] = STATE(2198),
    [sym_identifier] = ACTIONS(3023),
    [anon_sym_EQ] = ACTIONS(3025),
    [anon_sym_COLON] = ACTIONS(3023),
    [anon_sym_return] = ACTIONS(3023),
    [anon_sym_do] = ACTIONS(3023),
    [anon_sym_let] = ACTIONS(3023),
    [anon_sym_let_BANG] = ACTIONS(3025),
    [anon_sym_LPAREN] = ACTIONS(3023),
    [anon_sym_COMMA] = ACTIONS(3025),
    [anon_sym_null] = ACTIONS(3023),
    [anon_sym_QMARK] = ACTIONS(3023),
    [anon_sym_COLON_QMARK] = ACTIONS(3023),
    [anon_sym_COLON_COLON] = ACTIONS(3025),
    [anon_sym_AMP] = ACTIONS(3023),
    [anon_sym_LBRACK] = ACTIONS(3023),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3025),
    [anon_sym_LBRACE] = ACTIONS(3023),
    [anon_sym_LT_AT] = ACTIONS(3023),
    [anon_sym_AT_GT] = ACTIONS(3023),
    [anon_sym_LT_AT_AT] = ACTIONS(3023),
    [anon_sym_DOT] = ACTIONS(3023),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3025),
    [anon_sym_new] = ACTIONS(3023),
    [anon_sym_return_BANG] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(3023),
    [anon_sym_yield_BANG] = ACTIONS(3025),
    [anon_sym_lazy] = ACTIONS(3023),
    [anon_sym_assert] = ACTIONS(3023),
    [anon_sym_upcast] = ACTIONS(3023),
    [anon_sym_downcast] = ACTIONS(3023),
    [anon_sym_COLON_GT] = ACTIONS(3025),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3025),
    [anon_sym_for] = ACTIONS(3023),
    [anon_sym_while] = ACTIONS(3023),
    [anon_sym_if] = ACTIONS(3023),
    [anon_sym_fun] = ACTIONS(3023),
    [anon_sym_try] = ACTIONS(3023),
    [anon_sym_match] = ACTIONS(3023),
    [anon_sym_match_BANG] = ACTIONS(3025),
    [anon_sym_function] = ACTIONS(3023),
    [anon_sym_LT_DASH] = ACTIONS(3023),
    [anon_sym_DOT_LBRACK] = ACTIONS(3025),
    [anon_sym_LT] = ACTIONS(3025),
    [anon_sym_use] = ACTIONS(3023),
    [anon_sym_use_BANG] = ACTIONS(3025),
    [anon_sym_do_BANG] = ACTIONS(3025),
    [anon_sym_begin] = ACTIONS(3023),
    [anon_sym_LPAREN2] = ACTIONS(3023),
    [anon_sym_or] = ACTIONS(3023),
    [aux_sym_char_token1] = ACTIONS(3025),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3023),
    [anon_sym_DQUOTE] = ACTIONS(3023),
    [anon_sym_AT_DQUOTE] = ACTIONS(3025),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3025),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3025),
    [sym_bool] = ACTIONS(3023),
    [sym_unit] = ACTIONS(3025),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3023),
    [sym_op_identifier] = ACTIONS(3023),
    [anon_sym_PLUS] = ACTIONS(3023),
    [anon_sym_DASH] = ACTIONS(3023),
    [anon_sym_PLUS_DOT] = ACTIONS(3023),
    [anon_sym_DASH_DOT] = ACTIONS(3023),
    [anon_sym_PERCENT] = ACTIONS(3023),
    [anon_sym_AMP_AMP] = ACTIONS(3023),
    [anon_sym_TILDE] = ACTIONS(3025),
    [aux_sym_prefix_op_token1] = ACTIONS(3023),
    [aux_sym_infix_op_token1] = ACTIONS(3025),
    [aux_sym_infix_op_token2] = ACTIONS(3023),
    [anon_sym_PIPE_PIPE] = ACTIONS(3023),
    [anon_sym_BANG_EQ] = ACTIONS(3023),
    [anon_sym_COLON_EQ] = ACTIONS(3025),
    [anon_sym_DOLLAR] = ACTIONS(3023),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3023),
    [sym_int] = ACTIONS(3023),
    [sym_xint] = ACTIONS(3025),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3025),
    [sym__newline] = ACTIONS(3025),
  },
  [2199] = {
    [sym_block_comment] = STATE(2199),
    [sym_compiler_directive_decl] = STATE(2199),
    [sym_fsi_directive_decl] = STATE(2199),
    [sym_preproc_line] = STATE(2199),
    [sym_identifier] = ACTIONS(2984),
    [anon_sym_EQ] = ACTIONS(2986),
    [anon_sym_COLON] = ACTIONS(2984),
    [anon_sym_return] = ACTIONS(2984),
    [anon_sym_do] = ACTIONS(2984),
    [anon_sym_let] = ACTIONS(2984),
    [anon_sym_let_BANG] = ACTIONS(2986),
    [anon_sym_LPAREN] = ACTIONS(2984),
    [anon_sym_COMMA] = ACTIONS(2986),
    [anon_sym_null] = ACTIONS(2984),
    [anon_sym_QMARK] = ACTIONS(2984),
    [anon_sym_COLON_QMARK] = ACTIONS(2984),
    [anon_sym_COLON_COLON] = ACTIONS(2986),
    [anon_sym_AMP] = ACTIONS(2984),
    [anon_sym_LBRACK] = ACTIONS(2984),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2986),
    [anon_sym_LBRACE] = ACTIONS(2984),
    [anon_sym_LT_AT] = ACTIONS(2984),
    [anon_sym_LT_AT_AT] = ACTIONS(2984),
    [anon_sym_AT_AT_GT] = ACTIONS(2984),
    [anon_sym_DOT] = ACTIONS(2984),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2986),
    [anon_sym_new] = ACTIONS(2984),
    [anon_sym_return_BANG] = ACTIONS(2986),
    [anon_sym_yield] = ACTIONS(2984),
    [anon_sym_yield_BANG] = ACTIONS(2986),
    [anon_sym_lazy] = ACTIONS(2984),
    [anon_sym_assert] = ACTIONS(2984),
    [anon_sym_upcast] = ACTIONS(2984),
    [anon_sym_downcast] = ACTIONS(2984),
    [anon_sym_COLON_GT] = ACTIONS(2986),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2986),
    [anon_sym_for] = ACTIONS(2984),
    [anon_sym_while] = ACTIONS(2984),
    [anon_sym_if] = ACTIONS(2984),
    [anon_sym_fun] = ACTIONS(2984),
    [anon_sym_try] = ACTIONS(2984),
    [anon_sym_match] = ACTIONS(2984),
    [anon_sym_match_BANG] = ACTIONS(2986),
    [anon_sym_function] = ACTIONS(2984),
    [anon_sym_LT_DASH] = ACTIONS(2984),
    [anon_sym_DOT_LBRACK] = ACTIONS(2986),
    [anon_sym_LT] = ACTIONS(2986),
    [anon_sym_use] = ACTIONS(2984),
    [anon_sym_use_BANG] = ACTIONS(2986),
    [anon_sym_do_BANG] = ACTIONS(2986),
    [anon_sym_begin] = ACTIONS(2984),
    [anon_sym_LPAREN2] = ACTIONS(2984),
    [anon_sym_or] = ACTIONS(2984),
    [aux_sym_char_token1] = ACTIONS(2986),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2984),
    [anon_sym_DQUOTE] = ACTIONS(2984),
    [anon_sym_AT_DQUOTE] = ACTIONS(2986),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2986),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2986),
    [sym_bool] = ACTIONS(2984),
    [sym_unit] = ACTIONS(2986),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2984),
    [sym_op_identifier] = ACTIONS(2984),
    [anon_sym_PLUS] = ACTIONS(2984),
    [anon_sym_DASH] = ACTIONS(2984),
    [anon_sym_PLUS_DOT] = ACTIONS(2984),
    [anon_sym_DASH_DOT] = ACTIONS(2984),
    [anon_sym_PERCENT] = ACTIONS(2984),
    [anon_sym_AMP_AMP] = ACTIONS(2984),
    [anon_sym_TILDE] = ACTIONS(2986),
    [aux_sym_prefix_op_token1] = ACTIONS(2984),
    [aux_sym_infix_op_token1] = ACTIONS(2986),
    [aux_sym_infix_op_token2] = ACTIONS(2984),
    [anon_sym_PIPE_PIPE] = ACTIONS(2984),
    [anon_sym_BANG_EQ] = ACTIONS(2984),
    [anon_sym_COLON_EQ] = ACTIONS(2986),
    [anon_sym_DOLLAR] = ACTIONS(2984),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2984),
    [sym_int] = ACTIONS(2984),
    [sym_xint] = ACTIONS(2986),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2986),
    [sym__newline] = ACTIONS(2986),
  },
  [2200] = {
    [sym_block_comment] = STATE(2200),
    [sym_compiler_directive_decl] = STATE(2200),
    [sym_fsi_directive_decl] = STATE(2200),
    [sym_preproc_line] = STATE(2200),
    [sym_identifier] = ACTIONS(3019),
    [anon_sym_EQ] = ACTIONS(3021),
    [anon_sym_COLON] = ACTIONS(3019),
    [anon_sym_return] = ACTIONS(3019),
    [anon_sym_do] = ACTIONS(3019),
    [anon_sym_let] = ACTIONS(3019),
    [anon_sym_let_BANG] = ACTIONS(3021),
    [anon_sym_LPAREN] = ACTIONS(3019),
    [anon_sym_COMMA] = ACTIONS(3021),
    [anon_sym_null] = ACTIONS(3019),
    [anon_sym_QMARK] = ACTIONS(3019),
    [anon_sym_COLON_QMARK] = ACTIONS(3019),
    [anon_sym_COLON_COLON] = ACTIONS(3021),
    [anon_sym_AMP] = ACTIONS(3019),
    [anon_sym_LBRACK] = ACTIONS(3019),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3021),
    [anon_sym_LBRACE] = ACTIONS(3019),
    [anon_sym_LT_AT] = ACTIONS(3019),
    [anon_sym_AT_GT] = ACTIONS(3019),
    [anon_sym_LT_AT_AT] = ACTIONS(3019),
    [anon_sym_DOT] = ACTIONS(3019),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3021),
    [anon_sym_new] = ACTIONS(3019),
    [anon_sym_return_BANG] = ACTIONS(3021),
    [anon_sym_yield] = ACTIONS(3019),
    [anon_sym_yield_BANG] = ACTIONS(3021),
    [anon_sym_lazy] = ACTIONS(3019),
    [anon_sym_assert] = ACTIONS(3019),
    [anon_sym_upcast] = ACTIONS(3019),
    [anon_sym_downcast] = ACTIONS(3019),
    [anon_sym_COLON_GT] = ACTIONS(3021),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3021),
    [anon_sym_for] = ACTIONS(3019),
    [anon_sym_while] = ACTIONS(3019),
    [anon_sym_if] = ACTIONS(3019),
    [anon_sym_fun] = ACTIONS(3019),
    [anon_sym_try] = ACTIONS(3019),
    [anon_sym_match] = ACTIONS(3019),
    [anon_sym_match_BANG] = ACTIONS(3021),
    [anon_sym_function] = ACTIONS(3019),
    [anon_sym_LT_DASH] = ACTIONS(3019),
    [anon_sym_DOT_LBRACK] = ACTIONS(3021),
    [anon_sym_LT] = ACTIONS(3021),
    [anon_sym_use] = ACTIONS(3019),
    [anon_sym_use_BANG] = ACTIONS(3021),
    [anon_sym_do_BANG] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3019),
    [anon_sym_LPAREN2] = ACTIONS(3019),
    [anon_sym_or] = ACTIONS(3019),
    [aux_sym_char_token1] = ACTIONS(3021),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3019),
    [anon_sym_DQUOTE] = ACTIONS(3019),
    [anon_sym_AT_DQUOTE] = ACTIONS(3021),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3021),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3021),
    [sym_bool] = ACTIONS(3019),
    [sym_unit] = ACTIONS(3021),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3019),
    [sym_op_identifier] = ACTIONS(3019),
    [anon_sym_PLUS] = ACTIONS(3019),
    [anon_sym_DASH] = ACTIONS(3019),
    [anon_sym_PLUS_DOT] = ACTIONS(3019),
    [anon_sym_DASH_DOT] = ACTIONS(3019),
    [anon_sym_PERCENT] = ACTIONS(3019),
    [anon_sym_AMP_AMP] = ACTIONS(3019),
    [anon_sym_TILDE] = ACTIONS(3021),
    [aux_sym_prefix_op_token1] = ACTIONS(3019),
    [aux_sym_infix_op_token1] = ACTIONS(3021),
    [aux_sym_infix_op_token2] = ACTIONS(3019),
    [anon_sym_PIPE_PIPE] = ACTIONS(3019),
    [anon_sym_BANG_EQ] = ACTIONS(3019),
    [anon_sym_COLON_EQ] = ACTIONS(3021),
    [anon_sym_DOLLAR] = ACTIONS(3019),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3019),
    [sym_int] = ACTIONS(3019),
    [sym_xint] = ACTIONS(3021),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3021),
    [sym__newline] = ACTIONS(3021),
  },
  [2201] = {
    [sym_block_comment] = STATE(2201),
    [sym_compiler_directive_decl] = STATE(2201),
    [sym_fsi_directive_decl] = STATE(2201),
    [sym_preproc_line] = STATE(2201),
    [sym_identifier] = ACTIONS(3115),
    [anon_sym_EQ] = ACTIONS(3117),
    [anon_sym_COLON] = ACTIONS(3115),
    [anon_sym_return] = ACTIONS(3115),
    [anon_sym_do] = ACTIONS(3115),
    [anon_sym_let] = ACTIONS(3115),
    [anon_sym_let_BANG] = ACTIONS(3117),
    [anon_sym_LPAREN] = ACTIONS(3115),
    [anon_sym_COMMA] = ACTIONS(3117),
    [anon_sym_null] = ACTIONS(3115),
    [anon_sym_QMARK] = ACTIONS(3115),
    [anon_sym_COLON_QMARK] = ACTIONS(3115),
    [anon_sym_COLON_COLON] = ACTIONS(3117),
    [anon_sym_AMP] = ACTIONS(3115),
    [anon_sym_LBRACK] = ACTIONS(3115),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3117),
    [anon_sym_LBRACE] = ACTIONS(3115),
    [anon_sym_LT_AT] = ACTIONS(3115),
    [anon_sym_LT_AT_AT] = ACTIONS(3115),
    [anon_sym_DOT] = ACTIONS(3115),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3117),
    [anon_sym_new] = ACTIONS(3115),
    [anon_sym_return_BANG] = ACTIONS(3117),
    [anon_sym_yield] = ACTIONS(3115),
    [anon_sym_yield_BANG] = ACTIONS(3117),
    [anon_sym_lazy] = ACTIONS(3115),
    [anon_sym_assert] = ACTIONS(3115),
    [anon_sym_upcast] = ACTIONS(3115),
    [anon_sym_downcast] = ACTIONS(3115),
    [anon_sym_COLON_GT] = ACTIONS(3117),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3117),
    [anon_sym_for] = ACTIONS(3115),
    [anon_sym_while] = ACTIONS(3115),
    [anon_sym_if] = ACTIONS(3115),
    [anon_sym_fun] = ACTIONS(3115),
    [anon_sym_try] = ACTIONS(3115),
    [anon_sym_match] = ACTIONS(3115),
    [anon_sym_match_BANG] = ACTIONS(3117),
    [anon_sym_function] = ACTIONS(3115),
    [anon_sym_LT_DASH] = ACTIONS(3115),
    [anon_sym_DOT_LBRACK] = ACTIONS(3117),
    [anon_sym_LT] = ACTIONS(3117),
    [anon_sym_use] = ACTIONS(3115),
    [anon_sym_use_BANG] = ACTIONS(3117),
    [anon_sym_do_BANG] = ACTIONS(3117),
    [anon_sym_begin] = ACTIONS(3115),
    [anon_sym_LPAREN2] = ACTIONS(3115),
    [anon_sym_or] = ACTIONS(3115),
    [aux_sym_char_token1] = ACTIONS(3117),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3115),
    [anon_sym_DQUOTE] = ACTIONS(3115),
    [anon_sym_AT_DQUOTE] = ACTIONS(3117),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3117),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3117),
    [sym_bool] = ACTIONS(3115),
    [sym_unit] = ACTIONS(3117),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3115),
    [sym_op_identifier] = ACTIONS(3115),
    [anon_sym_PLUS] = ACTIONS(3115),
    [anon_sym_DASH] = ACTIONS(3115),
    [anon_sym_PLUS_DOT] = ACTIONS(3115),
    [anon_sym_DASH_DOT] = ACTIONS(3115),
    [anon_sym_PERCENT] = ACTIONS(3115),
    [anon_sym_AMP_AMP] = ACTIONS(3115),
    [anon_sym_TILDE] = ACTIONS(3117),
    [aux_sym_prefix_op_token1] = ACTIONS(3115),
    [aux_sym_infix_op_token1] = ACTIONS(3117),
    [aux_sym_infix_op_token2] = ACTIONS(3115),
    [anon_sym_PIPE_PIPE] = ACTIONS(3115),
    [anon_sym_BANG_EQ] = ACTIONS(3115),
    [anon_sym_COLON_EQ] = ACTIONS(3117),
    [anon_sym_DOLLAR] = ACTIONS(3115),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3115),
    [sym_int] = ACTIONS(3115),
    [sym_xint] = ACTIONS(3117),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3117),
    [anon_sym_POUNDendif] = ACTIONS(3117),
    [sym__newline] = ACTIONS(3117),
  },
  [2202] = {
    [sym_block_comment] = STATE(2202),
    [sym_compiler_directive_decl] = STATE(2202),
    [sym_fsi_directive_decl] = STATE(2202),
    [sym_preproc_line] = STATE(2202),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_EQ] = ACTIONS(3017),
    [anon_sym_COLON] = ACTIONS(3015),
    [anon_sym_return] = ACTIONS(3015),
    [anon_sym_do] = ACTIONS(3015),
    [anon_sym_let] = ACTIONS(3015),
    [anon_sym_let_BANG] = ACTIONS(3017),
    [anon_sym_LPAREN] = ACTIONS(3015),
    [anon_sym_COMMA] = ACTIONS(3017),
    [anon_sym_null] = ACTIONS(3015),
    [anon_sym_QMARK] = ACTIONS(3015),
    [anon_sym_COLON_QMARK] = ACTIONS(3015),
    [anon_sym_COLON_COLON] = ACTIONS(3017),
    [anon_sym_AMP] = ACTIONS(3015),
    [anon_sym_LBRACK] = ACTIONS(3015),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3017),
    [anon_sym_LBRACE] = ACTIONS(3015),
    [anon_sym_LT_AT] = ACTIONS(3015),
    [anon_sym_LT_AT_AT] = ACTIONS(3015),
    [anon_sym_DOT] = ACTIONS(3015),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3017),
    [anon_sym_new] = ACTIONS(3015),
    [anon_sym_return_BANG] = ACTIONS(3017),
    [anon_sym_yield] = ACTIONS(3015),
    [anon_sym_yield_BANG] = ACTIONS(3017),
    [anon_sym_lazy] = ACTIONS(3015),
    [anon_sym_assert] = ACTIONS(3015),
    [anon_sym_upcast] = ACTIONS(3015),
    [anon_sym_downcast] = ACTIONS(3015),
    [anon_sym_COLON_GT] = ACTIONS(3017),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3017),
    [anon_sym_for] = ACTIONS(3015),
    [anon_sym_while] = ACTIONS(3015),
    [anon_sym_if] = ACTIONS(3015),
    [anon_sym_fun] = ACTIONS(3015),
    [anon_sym_try] = ACTIONS(3015),
    [anon_sym_match] = ACTIONS(3015),
    [anon_sym_match_BANG] = ACTIONS(3017),
    [anon_sym_function] = ACTIONS(3015),
    [anon_sym_LT_DASH] = ACTIONS(3015),
    [anon_sym_DOT_LBRACK] = ACTIONS(3017),
    [anon_sym_LT] = ACTIONS(3017),
    [anon_sym_use] = ACTIONS(3015),
    [anon_sym_use_BANG] = ACTIONS(3017),
    [anon_sym_do_BANG] = ACTIONS(3017),
    [anon_sym_DOT_DOT] = ACTIONS(3017),
    [anon_sym_begin] = ACTIONS(3015),
    [anon_sym_LPAREN2] = ACTIONS(3015),
    [anon_sym_or] = ACTIONS(3015),
    [aux_sym_char_token1] = ACTIONS(3017),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3015),
    [anon_sym_DQUOTE] = ACTIONS(3015),
    [anon_sym_AT_DQUOTE] = ACTIONS(3017),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3017),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3017),
    [sym_bool] = ACTIONS(3015),
    [sym_unit] = ACTIONS(3017),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3015),
    [sym_op_identifier] = ACTIONS(3015),
    [anon_sym_PLUS] = ACTIONS(3015),
    [anon_sym_DASH] = ACTIONS(3015),
    [anon_sym_PLUS_DOT] = ACTIONS(3015),
    [anon_sym_DASH_DOT] = ACTIONS(3015),
    [anon_sym_PERCENT] = ACTIONS(3015),
    [anon_sym_AMP_AMP] = ACTIONS(3015),
    [anon_sym_TILDE] = ACTIONS(3017),
    [aux_sym_prefix_op_token1] = ACTIONS(3015),
    [aux_sym_infix_op_token1] = ACTIONS(3017),
    [aux_sym_infix_op_token2] = ACTIONS(3015),
    [anon_sym_PIPE_PIPE] = ACTIONS(3015),
    [anon_sym_BANG_EQ] = ACTIONS(3015),
    [anon_sym_COLON_EQ] = ACTIONS(3017),
    [anon_sym_DOLLAR] = ACTIONS(3015),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3015),
    [sym_int] = ACTIONS(3015),
    [sym_xint] = ACTIONS(3017),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3017),
    [sym__newline] = ACTIONS(3017),
  },
  [2203] = {
    [sym_block_comment] = STATE(2203),
    [sym_compiler_directive_decl] = STATE(2203),
    [sym_fsi_directive_decl] = STATE(2203),
    [sym_preproc_line] = STATE(2203),
    [sym_identifier] = ACTIONS(3007),
    [anon_sym_EQ] = ACTIONS(3009),
    [anon_sym_COLON] = ACTIONS(3007),
    [anon_sym_return] = ACTIONS(3007),
    [anon_sym_do] = ACTIONS(3007),
    [anon_sym_let] = ACTIONS(3007),
    [anon_sym_let_BANG] = ACTIONS(3009),
    [anon_sym_LPAREN] = ACTIONS(3007),
    [anon_sym_COMMA] = ACTIONS(3009),
    [anon_sym_null] = ACTIONS(3007),
    [anon_sym_QMARK] = ACTIONS(3007),
    [anon_sym_COLON_QMARK] = ACTIONS(3007),
    [anon_sym_COLON_COLON] = ACTIONS(3009),
    [anon_sym_AMP] = ACTIONS(3007),
    [anon_sym_LBRACK] = ACTIONS(3007),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3009),
    [anon_sym_LBRACE] = ACTIONS(3007),
    [anon_sym_LT_AT] = ACTIONS(3007),
    [anon_sym_LT_AT_AT] = ACTIONS(3007),
    [anon_sym_DOT] = ACTIONS(3007),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3009),
    [anon_sym_new] = ACTIONS(3007),
    [anon_sym_return_BANG] = ACTIONS(3009),
    [anon_sym_yield] = ACTIONS(3007),
    [anon_sym_yield_BANG] = ACTIONS(3009),
    [anon_sym_lazy] = ACTIONS(3007),
    [anon_sym_assert] = ACTIONS(3007),
    [anon_sym_upcast] = ACTIONS(3007),
    [anon_sym_downcast] = ACTIONS(3007),
    [anon_sym_COLON_GT] = ACTIONS(3009),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3009),
    [anon_sym_for] = ACTIONS(3007),
    [anon_sym_while] = ACTIONS(3007),
    [anon_sym_if] = ACTIONS(3007),
    [anon_sym_fun] = ACTIONS(3007),
    [anon_sym_try] = ACTIONS(3007),
    [anon_sym_match] = ACTIONS(3007),
    [anon_sym_match_BANG] = ACTIONS(3009),
    [anon_sym_function] = ACTIONS(3007),
    [anon_sym_LT_DASH] = ACTIONS(3007),
    [anon_sym_DOT_LBRACK] = ACTIONS(3009),
    [anon_sym_LT] = ACTIONS(3009),
    [anon_sym_use] = ACTIONS(3007),
    [anon_sym_use_BANG] = ACTIONS(3009),
    [anon_sym_do_BANG] = ACTIONS(3009),
    [anon_sym_DOT_DOT] = ACTIONS(3009),
    [anon_sym_begin] = ACTIONS(3007),
    [anon_sym_LPAREN2] = ACTIONS(3007),
    [anon_sym_or] = ACTIONS(3007),
    [aux_sym_char_token1] = ACTIONS(3009),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3007),
    [anon_sym_DQUOTE] = ACTIONS(3007),
    [anon_sym_AT_DQUOTE] = ACTIONS(3009),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3009),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3009),
    [sym_bool] = ACTIONS(3007),
    [sym_unit] = ACTIONS(3009),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3007),
    [sym_op_identifier] = ACTIONS(3007),
    [anon_sym_PLUS] = ACTIONS(3007),
    [anon_sym_DASH] = ACTIONS(3007),
    [anon_sym_PLUS_DOT] = ACTIONS(3007),
    [anon_sym_DASH_DOT] = ACTIONS(3007),
    [anon_sym_PERCENT] = ACTIONS(3007),
    [anon_sym_AMP_AMP] = ACTIONS(3007),
    [anon_sym_TILDE] = ACTIONS(3009),
    [aux_sym_prefix_op_token1] = ACTIONS(3007),
    [aux_sym_infix_op_token1] = ACTIONS(3009),
    [aux_sym_infix_op_token2] = ACTIONS(3007),
    [anon_sym_PIPE_PIPE] = ACTIONS(3007),
    [anon_sym_BANG_EQ] = ACTIONS(3007),
    [anon_sym_COLON_EQ] = ACTIONS(3009),
    [anon_sym_DOLLAR] = ACTIONS(3007),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3007),
    [sym_int] = ACTIONS(3007),
    [sym_xint] = ACTIONS(3009),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3009),
    [sym__newline] = ACTIONS(3009),
  },
  [2204] = {
    [sym_block_comment] = STATE(2204),
    [sym_compiler_directive_decl] = STATE(2204),
    [sym_fsi_directive_decl] = STATE(2204),
    [sym_preproc_line] = STATE(2204),
    [sym_identifier] = ACTIONS(3003),
    [anon_sym_EQ] = ACTIONS(3005),
    [anon_sym_COLON] = ACTIONS(3003),
    [anon_sym_return] = ACTIONS(3003),
    [anon_sym_do] = ACTIONS(3003),
    [anon_sym_let] = ACTIONS(3003),
    [anon_sym_let_BANG] = ACTIONS(3005),
    [anon_sym_LPAREN] = ACTIONS(3003),
    [anon_sym_COMMA] = ACTIONS(3005),
    [anon_sym_null] = ACTIONS(3003),
    [anon_sym_QMARK] = ACTIONS(3003),
    [anon_sym_COLON_QMARK] = ACTIONS(3003),
    [anon_sym_COLON_COLON] = ACTIONS(3005),
    [anon_sym_AMP] = ACTIONS(3003),
    [anon_sym_LBRACK] = ACTIONS(3003),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3005),
    [anon_sym_LBRACE] = ACTIONS(3003),
    [anon_sym_LT_AT] = ACTIONS(3003),
    [anon_sym_LT_AT_AT] = ACTIONS(3003),
    [anon_sym_DOT] = ACTIONS(3003),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3005),
    [anon_sym_new] = ACTIONS(3003),
    [anon_sym_return_BANG] = ACTIONS(3005),
    [anon_sym_yield] = ACTIONS(3003),
    [anon_sym_yield_BANG] = ACTIONS(3005),
    [anon_sym_lazy] = ACTIONS(3003),
    [anon_sym_assert] = ACTIONS(3003),
    [anon_sym_upcast] = ACTIONS(3003),
    [anon_sym_downcast] = ACTIONS(3003),
    [anon_sym_COLON_GT] = ACTIONS(3005),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3005),
    [anon_sym_for] = ACTIONS(3003),
    [anon_sym_while] = ACTIONS(3003),
    [anon_sym_if] = ACTIONS(3003),
    [anon_sym_fun] = ACTIONS(3003),
    [anon_sym_try] = ACTIONS(3003),
    [anon_sym_match] = ACTIONS(3003),
    [anon_sym_match_BANG] = ACTIONS(3005),
    [anon_sym_function] = ACTIONS(3003),
    [anon_sym_LT_DASH] = ACTIONS(3003),
    [anon_sym_DOT_LBRACK] = ACTIONS(3005),
    [anon_sym_LT] = ACTIONS(3005),
    [anon_sym_use] = ACTIONS(3003),
    [anon_sym_use_BANG] = ACTIONS(3005),
    [anon_sym_do_BANG] = ACTIONS(3005),
    [anon_sym_DOT_DOT] = ACTIONS(3005),
    [anon_sym_begin] = ACTIONS(3003),
    [anon_sym_LPAREN2] = ACTIONS(3003),
    [anon_sym_or] = ACTIONS(3003),
    [aux_sym_char_token1] = ACTIONS(3005),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3003),
    [anon_sym_DQUOTE] = ACTIONS(3003),
    [anon_sym_AT_DQUOTE] = ACTIONS(3005),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3005),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3005),
    [sym_bool] = ACTIONS(3003),
    [sym_unit] = ACTIONS(3005),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3003),
    [sym_op_identifier] = ACTIONS(3003),
    [anon_sym_PLUS] = ACTIONS(3003),
    [anon_sym_DASH] = ACTIONS(3003),
    [anon_sym_PLUS_DOT] = ACTIONS(3003),
    [anon_sym_DASH_DOT] = ACTIONS(3003),
    [anon_sym_PERCENT] = ACTIONS(3003),
    [anon_sym_AMP_AMP] = ACTIONS(3003),
    [anon_sym_TILDE] = ACTIONS(3005),
    [aux_sym_prefix_op_token1] = ACTIONS(3003),
    [aux_sym_infix_op_token1] = ACTIONS(3005),
    [aux_sym_infix_op_token2] = ACTIONS(3003),
    [anon_sym_PIPE_PIPE] = ACTIONS(3003),
    [anon_sym_BANG_EQ] = ACTIONS(3003),
    [anon_sym_COLON_EQ] = ACTIONS(3005),
    [anon_sym_DOLLAR] = ACTIONS(3003),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3003),
    [sym_int] = ACTIONS(3003),
    [sym_xint] = ACTIONS(3005),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3005),
    [sym__newline] = ACTIONS(3005),
  },
  [2205] = {
    [sym_block_comment] = STATE(2205),
    [sym_compiler_directive_decl] = STATE(2205),
    [sym_fsi_directive_decl] = STATE(2205),
    [sym_preproc_line] = STATE(2205),
    [sym_identifier] = ACTIONS(2996),
    [anon_sym_EQ] = ACTIONS(2998),
    [anon_sym_COLON] = ACTIONS(2996),
    [anon_sym_return] = ACTIONS(2996),
    [anon_sym_do] = ACTIONS(2996),
    [anon_sym_let] = ACTIONS(2996),
    [anon_sym_let_BANG] = ACTIONS(2998),
    [anon_sym_LPAREN] = ACTIONS(2996),
    [anon_sym_COMMA] = ACTIONS(2998),
    [anon_sym_null] = ACTIONS(2996),
    [anon_sym_QMARK] = ACTIONS(2996),
    [anon_sym_COLON_QMARK] = ACTIONS(2996),
    [anon_sym_COLON_COLON] = ACTIONS(2998),
    [anon_sym_AMP] = ACTIONS(2996),
    [anon_sym_LBRACK] = ACTIONS(2996),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2998),
    [anon_sym_LBRACE] = ACTIONS(2996),
    [anon_sym_LT_AT] = ACTIONS(2996),
    [anon_sym_LT_AT_AT] = ACTIONS(2996),
    [anon_sym_DOT] = ACTIONS(2996),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2998),
    [anon_sym_new] = ACTIONS(2996),
    [anon_sym_return_BANG] = ACTIONS(2998),
    [anon_sym_yield] = ACTIONS(2996),
    [anon_sym_yield_BANG] = ACTIONS(2998),
    [anon_sym_lazy] = ACTIONS(2996),
    [anon_sym_assert] = ACTIONS(2996),
    [anon_sym_upcast] = ACTIONS(2996),
    [anon_sym_downcast] = ACTIONS(2996),
    [anon_sym_COLON_GT] = ACTIONS(2998),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2998),
    [anon_sym_for] = ACTIONS(2996),
    [anon_sym_while] = ACTIONS(2996),
    [anon_sym_if] = ACTIONS(2996),
    [anon_sym_fun] = ACTIONS(2996),
    [anon_sym_try] = ACTIONS(2996),
    [anon_sym_match] = ACTIONS(2996),
    [anon_sym_match_BANG] = ACTIONS(2998),
    [anon_sym_function] = ACTIONS(2996),
    [anon_sym_LT_DASH] = ACTIONS(2996),
    [anon_sym_DOT_LBRACK] = ACTIONS(2998),
    [anon_sym_LT] = ACTIONS(2998),
    [anon_sym_use] = ACTIONS(2996),
    [anon_sym_use_BANG] = ACTIONS(2998),
    [anon_sym_do_BANG] = ACTIONS(2998),
    [anon_sym_DOT_DOT] = ACTIONS(2998),
    [anon_sym_begin] = ACTIONS(2996),
    [anon_sym_LPAREN2] = ACTIONS(2996),
    [anon_sym_or] = ACTIONS(2996),
    [aux_sym_char_token1] = ACTIONS(2998),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2996),
    [anon_sym_DQUOTE] = ACTIONS(2996),
    [anon_sym_AT_DQUOTE] = ACTIONS(2998),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2998),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2998),
    [sym_bool] = ACTIONS(2996),
    [sym_unit] = ACTIONS(2998),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2996),
    [sym_op_identifier] = ACTIONS(2996),
    [anon_sym_PLUS] = ACTIONS(2996),
    [anon_sym_DASH] = ACTIONS(2996),
    [anon_sym_PLUS_DOT] = ACTIONS(2996),
    [anon_sym_DASH_DOT] = ACTIONS(2996),
    [anon_sym_PERCENT] = ACTIONS(2996),
    [anon_sym_AMP_AMP] = ACTIONS(2996),
    [anon_sym_TILDE] = ACTIONS(2998),
    [aux_sym_prefix_op_token1] = ACTIONS(2996),
    [aux_sym_infix_op_token1] = ACTIONS(2998),
    [aux_sym_infix_op_token2] = ACTIONS(2996),
    [anon_sym_PIPE_PIPE] = ACTIONS(2996),
    [anon_sym_BANG_EQ] = ACTIONS(2996),
    [anon_sym_COLON_EQ] = ACTIONS(2998),
    [anon_sym_DOLLAR] = ACTIONS(2996),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2996),
    [sym_int] = ACTIONS(2996),
    [sym_xint] = ACTIONS(2998),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2998),
    [sym__newline] = ACTIONS(2998),
  },
  [2206] = {
    [sym_block_comment] = STATE(2206),
    [sym_compiler_directive_decl] = STATE(2206),
    [sym_fsi_directive_decl] = STATE(2206),
    [sym_preproc_line] = STATE(2206),
    [sym_identifier] = ACTIONS(3019),
    [anon_sym_EQ] = ACTIONS(3021),
    [anon_sym_COLON] = ACTIONS(3019),
    [anon_sym_return] = ACTIONS(3019),
    [anon_sym_do] = ACTIONS(3019),
    [anon_sym_let] = ACTIONS(3019),
    [anon_sym_let_BANG] = ACTIONS(3021),
    [anon_sym_LPAREN] = ACTIONS(3019),
    [anon_sym_COMMA] = ACTIONS(3021),
    [anon_sym_null] = ACTIONS(3019),
    [anon_sym_QMARK] = ACTIONS(3019),
    [anon_sym_COLON_QMARK] = ACTIONS(3019),
    [anon_sym_COLON_COLON] = ACTIONS(3021),
    [anon_sym_AMP] = ACTIONS(3019),
    [anon_sym_LBRACK] = ACTIONS(3019),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3021),
    [anon_sym_LBRACE] = ACTIONS(3019),
    [anon_sym_LT_AT] = ACTIONS(3019),
    [anon_sym_LT_AT_AT] = ACTIONS(3019),
    [anon_sym_DOT] = ACTIONS(3019),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3021),
    [anon_sym_new] = ACTIONS(3019),
    [anon_sym_return_BANG] = ACTIONS(3021),
    [anon_sym_yield] = ACTIONS(3019),
    [anon_sym_yield_BANG] = ACTIONS(3021),
    [anon_sym_lazy] = ACTIONS(3019),
    [anon_sym_assert] = ACTIONS(3019),
    [anon_sym_upcast] = ACTIONS(3019),
    [anon_sym_downcast] = ACTIONS(3019),
    [anon_sym_COLON_GT] = ACTIONS(3021),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3021),
    [anon_sym_for] = ACTIONS(3019),
    [anon_sym_while] = ACTIONS(3019),
    [anon_sym_if] = ACTIONS(3019),
    [anon_sym_fun] = ACTIONS(3019),
    [anon_sym_try] = ACTIONS(3019),
    [anon_sym_match] = ACTIONS(3019),
    [anon_sym_match_BANG] = ACTIONS(3021),
    [anon_sym_function] = ACTIONS(3019),
    [anon_sym_LT_DASH] = ACTIONS(3019),
    [anon_sym_DOT_LBRACK] = ACTIONS(3021),
    [anon_sym_LT] = ACTIONS(3021),
    [anon_sym_use] = ACTIONS(3019),
    [anon_sym_use_BANG] = ACTIONS(3021),
    [anon_sym_do_BANG] = ACTIONS(3021),
    [anon_sym_DOT_DOT] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3019),
    [anon_sym_LPAREN2] = ACTIONS(3019),
    [anon_sym_or] = ACTIONS(3019),
    [aux_sym_char_token1] = ACTIONS(3021),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3019),
    [anon_sym_DQUOTE] = ACTIONS(3019),
    [anon_sym_AT_DQUOTE] = ACTIONS(3021),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3021),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3021),
    [sym_bool] = ACTIONS(3019),
    [sym_unit] = ACTIONS(3021),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3019),
    [sym_op_identifier] = ACTIONS(3019),
    [anon_sym_PLUS] = ACTIONS(3019),
    [anon_sym_DASH] = ACTIONS(3019),
    [anon_sym_PLUS_DOT] = ACTIONS(3019),
    [anon_sym_DASH_DOT] = ACTIONS(3019),
    [anon_sym_PERCENT] = ACTIONS(3019),
    [anon_sym_AMP_AMP] = ACTIONS(3019),
    [anon_sym_TILDE] = ACTIONS(3021),
    [aux_sym_prefix_op_token1] = ACTIONS(3019),
    [aux_sym_infix_op_token1] = ACTIONS(3021),
    [aux_sym_infix_op_token2] = ACTIONS(3019),
    [anon_sym_PIPE_PIPE] = ACTIONS(3019),
    [anon_sym_BANG_EQ] = ACTIONS(3019),
    [anon_sym_COLON_EQ] = ACTIONS(3021),
    [anon_sym_DOLLAR] = ACTIONS(3019),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3019),
    [sym_int] = ACTIONS(3019),
    [sym_xint] = ACTIONS(3021),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3021),
    [sym__newline] = ACTIONS(3021),
  },
  [2207] = {
    [sym_block_comment] = STATE(2207),
    [sym_compiler_directive_decl] = STATE(2207),
    [sym_fsi_directive_decl] = STATE(2207),
    [sym_preproc_line] = STATE(2207),
    [sym_identifier] = ACTIONS(2992),
    [anon_sym_EQ] = ACTIONS(2994),
    [anon_sym_COLON] = ACTIONS(2992),
    [anon_sym_return] = ACTIONS(2992),
    [anon_sym_do] = ACTIONS(2992),
    [anon_sym_let] = ACTIONS(2992),
    [anon_sym_let_BANG] = ACTIONS(2994),
    [anon_sym_LPAREN] = ACTIONS(2992),
    [anon_sym_COMMA] = ACTIONS(2994),
    [anon_sym_null] = ACTIONS(2992),
    [anon_sym_QMARK] = ACTIONS(2992),
    [anon_sym_COLON_QMARK] = ACTIONS(2992),
    [anon_sym_COLON_COLON] = ACTIONS(2994),
    [anon_sym_AMP] = ACTIONS(2992),
    [anon_sym_LBRACK] = ACTIONS(2992),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2994),
    [anon_sym_LBRACE] = ACTIONS(2992),
    [anon_sym_LT_AT] = ACTIONS(2992),
    [anon_sym_LT_AT_AT] = ACTIONS(2992),
    [anon_sym_DOT] = ACTIONS(2992),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2994),
    [anon_sym_new] = ACTIONS(2992),
    [anon_sym_return_BANG] = ACTIONS(2994),
    [anon_sym_yield] = ACTIONS(2992),
    [anon_sym_yield_BANG] = ACTIONS(2994),
    [anon_sym_lazy] = ACTIONS(2992),
    [anon_sym_assert] = ACTIONS(2992),
    [anon_sym_upcast] = ACTIONS(2992),
    [anon_sym_downcast] = ACTIONS(2992),
    [anon_sym_COLON_GT] = ACTIONS(2994),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2994),
    [anon_sym_for] = ACTIONS(2992),
    [anon_sym_while] = ACTIONS(2992),
    [anon_sym_if] = ACTIONS(2992),
    [anon_sym_fun] = ACTIONS(2992),
    [anon_sym_try] = ACTIONS(2992),
    [anon_sym_match] = ACTIONS(2992),
    [anon_sym_match_BANG] = ACTIONS(2994),
    [anon_sym_function] = ACTIONS(2992),
    [anon_sym_LT_DASH] = ACTIONS(2992),
    [anon_sym_DOT_LBRACK] = ACTIONS(2994),
    [anon_sym_LT] = ACTIONS(2994),
    [anon_sym_use] = ACTIONS(2992),
    [anon_sym_use_BANG] = ACTIONS(2994),
    [anon_sym_do_BANG] = ACTIONS(2994),
    [anon_sym_DOT_DOT] = ACTIONS(2994),
    [anon_sym_begin] = ACTIONS(2992),
    [anon_sym_LPAREN2] = ACTIONS(2992),
    [anon_sym_or] = ACTIONS(2992),
    [aux_sym_char_token1] = ACTIONS(2994),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2992),
    [anon_sym_DQUOTE] = ACTIONS(2992),
    [anon_sym_AT_DQUOTE] = ACTIONS(2994),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2994),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2994),
    [sym_bool] = ACTIONS(2992),
    [sym_unit] = ACTIONS(2994),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2992),
    [sym_op_identifier] = ACTIONS(2992),
    [anon_sym_PLUS] = ACTIONS(2992),
    [anon_sym_DASH] = ACTIONS(2992),
    [anon_sym_PLUS_DOT] = ACTIONS(2992),
    [anon_sym_DASH_DOT] = ACTIONS(2992),
    [anon_sym_PERCENT] = ACTIONS(2992),
    [anon_sym_AMP_AMP] = ACTIONS(2992),
    [anon_sym_TILDE] = ACTIONS(2994),
    [aux_sym_prefix_op_token1] = ACTIONS(2992),
    [aux_sym_infix_op_token1] = ACTIONS(2994),
    [aux_sym_infix_op_token2] = ACTIONS(2992),
    [anon_sym_PIPE_PIPE] = ACTIONS(2992),
    [anon_sym_BANG_EQ] = ACTIONS(2992),
    [anon_sym_COLON_EQ] = ACTIONS(2994),
    [anon_sym_DOLLAR] = ACTIONS(2992),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2992),
    [sym_int] = ACTIONS(2992),
    [sym_xint] = ACTIONS(2994),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2994),
    [sym__newline] = ACTIONS(2994),
  },
  [2208] = {
    [sym_block_comment] = STATE(2208),
    [sym_compiler_directive_decl] = STATE(2208),
    [sym_fsi_directive_decl] = STATE(2208),
    [sym_preproc_line] = STATE(2208),
    [sym_identifier] = ACTIONS(2978),
    [anon_sym_EQ] = ACTIONS(2980),
    [anon_sym_COLON] = ACTIONS(2978),
    [anon_sym_return] = ACTIONS(2978),
    [anon_sym_do] = ACTIONS(2978),
    [anon_sym_let] = ACTIONS(2978),
    [anon_sym_let_BANG] = ACTIONS(2980),
    [anon_sym_LPAREN] = ACTIONS(2978),
    [anon_sym_COMMA] = ACTIONS(2980),
    [anon_sym_null] = ACTIONS(2978),
    [anon_sym_QMARK] = ACTIONS(2978),
    [anon_sym_COLON_QMARK] = ACTIONS(2978),
    [anon_sym_COLON_COLON] = ACTIONS(2980),
    [anon_sym_AMP] = ACTIONS(2978),
    [anon_sym_LBRACK] = ACTIONS(2978),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2980),
    [anon_sym_LBRACE] = ACTIONS(2978),
    [anon_sym_LT_AT] = ACTIONS(2978),
    [anon_sym_LT_AT_AT] = ACTIONS(2978),
    [anon_sym_DOT] = ACTIONS(2978),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2980),
    [anon_sym_new] = ACTIONS(2978),
    [anon_sym_return_BANG] = ACTIONS(2980),
    [anon_sym_yield] = ACTIONS(2978),
    [anon_sym_yield_BANG] = ACTIONS(2980),
    [anon_sym_lazy] = ACTIONS(2978),
    [anon_sym_assert] = ACTIONS(2978),
    [anon_sym_upcast] = ACTIONS(2978),
    [anon_sym_downcast] = ACTIONS(2978),
    [anon_sym_COLON_GT] = ACTIONS(2980),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2980),
    [anon_sym_for] = ACTIONS(2978),
    [anon_sym_while] = ACTIONS(2978),
    [anon_sym_if] = ACTIONS(2978),
    [anon_sym_fun] = ACTIONS(2978),
    [anon_sym_try] = ACTIONS(2978),
    [anon_sym_match] = ACTIONS(2978),
    [anon_sym_match_BANG] = ACTIONS(2980),
    [anon_sym_function] = ACTIONS(2978),
    [anon_sym_LT_DASH] = ACTIONS(2978),
    [anon_sym_DOT_LBRACK] = ACTIONS(2980),
    [anon_sym_LT] = ACTIONS(2980),
    [anon_sym_use] = ACTIONS(2978),
    [anon_sym_use_BANG] = ACTIONS(2980),
    [anon_sym_do_BANG] = ACTIONS(2980),
    [anon_sym_DOT_DOT] = ACTIONS(2980),
    [anon_sym_begin] = ACTIONS(2978),
    [anon_sym_LPAREN2] = ACTIONS(2978),
    [anon_sym_or] = ACTIONS(2978),
    [aux_sym_char_token1] = ACTIONS(2980),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2978),
    [anon_sym_DQUOTE] = ACTIONS(2978),
    [anon_sym_AT_DQUOTE] = ACTIONS(2980),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2980),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2980),
    [sym_bool] = ACTIONS(2978),
    [sym_unit] = ACTIONS(2980),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2978),
    [sym_op_identifier] = ACTIONS(2978),
    [anon_sym_PLUS] = ACTIONS(2978),
    [anon_sym_DASH] = ACTIONS(2978),
    [anon_sym_PLUS_DOT] = ACTIONS(2978),
    [anon_sym_DASH_DOT] = ACTIONS(2978),
    [anon_sym_PERCENT] = ACTIONS(2978),
    [anon_sym_AMP_AMP] = ACTIONS(2978),
    [anon_sym_TILDE] = ACTIONS(2980),
    [aux_sym_prefix_op_token1] = ACTIONS(2978),
    [aux_sym_infix_op_token1] = ACTIONS(2980),
    [aux_sym_infix_op_token2] = ACTIONS(2978),
    [anon_sym_PIPE_PIPE] = ACTIONS(2978),
    [anon_sym_BANG_EQ] = ACTIONS(2978),
    [anon_sym_COLON_EQ] = ACTIONS(2980),
    [anon_sym_DOLLAR] = ACTIONS(2978),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2978),
    [sym_int] = ACTIONS(2978),
    [sym_xint] = ACTIONS(2980),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2980),
    [sym__newline] = ACTIONS(2980),
  },
  [2209] = {
    [sym_block_comment] = STATE(2209),
    [sym_compiler_directive_decl] = STATE(2209),
    [sym_fsi_directive_decl] = STATE(2209),
    [sym_preproc_line] = STATE(2209),
    [sym_identifier] = ACTIONS(3135),
    [anon_sym_EQ] = ACTIONS(3137),
    [anon_sym_COLON] = ACTIONS(3135),
    [anon_sym_return] = ACTIONS(3135),
    [anon_sym_do] = ACTIONS(3135),
    [anon_sym_let] = ACTIONS(3135),
    [anon_sym_let_BANG] = ACTIONS(3137),
    [anon_sym_LPAREN] = ACTIONS(3135),
    [anon_sym_COMMA] = ACTIONS(3137),
    [anon_sym_null] = ACTIONS(3135),
    [anon_sym_QMARK] = ACTIONS(3135),
    [anon_sym_COLON_QMARK] = ACTIONS(3135),
    [anon_sym_COLON_COLON] = ACTIONS(3137),
    [anon_sym_AMP] = ACTIONS(3135),
    [anon_sym_LBRACK] = ACTIONS(3135),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3137),
    [anon_sym_LBRACE] = ACTIONS(3135),
    [anon_sym_LT_AT] = ACTIONS(3135),
    [anon_sym_LT_AT_AT] = ACTIONS(3135),
    [anon_sym_DOT] = ACTIONS(3135),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3137),
    [anon_sym_new] = ACTIONS(3135),
    [anon_sym_return_BANG] = ACTIONS(3137),
    [anon_sym_yield] = ACTIONS(3135),
    [anon_sym_yield_BANG] = ACTIONS(3137),
    [anon_sym_lazy] = ACTIONS(3135),
    [anon_sym_assert] = ACTIONS(3135),
    [anon_sym_upcast] = ACTIONS(3135),
    [anon_sym_downcast] = ACTIONS(3135),
    [anon_sym_COLON_GT] = ACTIONS(3137),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3137),
    [anon_sym_for] = ACTIONS(3135),
    [anon_sym_while] = ACTIONS(3135),
    [anon_sym_if] = ACTIONS(3135),
    [anon_sym_fun] = ACTIONS(3135),
    [anon_sym_try] = ACTIONS(3135),
    [anon_sym_match] = ACTIONS(3135),
    [anon_sym_match_BANG] = ACTIONS(3137),
    [anon_sym_function] = ACTIONS(3135),
    [anon_sym_LT_DASH] = ACTIONS(3135),
    [anon_sym_DOT_LBRACK] = ACTIONS(3137),
    [anon_sym_LT] = ACTIONS(3137),
    [anon_sym_GT] = ACTIONS(3135),
    [anon_sym_use] = ACTIONS(3135),
    [anon_sym_use_BANG] = ACTIONS(3137),
    [anon_sym_do_BANG] = ACTIONS(3137),
    [anon_sym_begin] = ACTIONS(3135),
    [anon_sym_LPAREN2] = ACTIONS(3135),
    [anon_sym_or] = ACTIONS(3135),
    [aux_sym_char_token1] = ACTIONS(3137),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3135),
    [anon_sym_DQUOTE] = ACTIONS(3135),
    [anon_sym_AT_DQUOTE] = ACTIONS(3137),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3137),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3137),
    [sym_bool] = ACTIONS(3135),
    [sym_unit] = ACTIONS(3137),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3135),
    [sym_op_identifier] = ACTIONS(3135),
    [anon_sym_PLUS] = ACTIONS(3135),
    [anon_sym_DASH] = ACTIONS(3135),
    [anon_sym_PLUS_DOT] = ACTIONS(3135),
    [anon_sym_DASH_DOT] = ACTIONS(3135),
    [anon_sym_PERCENT] = ACTIONS(3135),
    [anon_sym_AMP_AMP] = ACTIONS(3135),
    [anon_sym_TILDE] = ACTIONS(3137),
    [aux_sym_prefix_op_token1] = ACTIONS(3135),
    [aux_sym_infix_op_token1] = ACTIONS(3137),
    [aux_sym_infix_op_token2] = ACTIONS(3135),
    [anon_sym_PIPE_PIPE] = ACTIONS(3135),
    [anon_sym_BANG_EQ] = ACTIONS(3135),
    [anon_sym_COLON_EQ] = ACTIONS(3137),
    [anon_sym_DOLLAR] = ACTIONS(3135),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3135),
    [sym_int] = ACTIONS(3135),
    [sym_xint] = ACTIONS(3137),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3137),
    [sym__newline] = ACTIONS(3137),
  },
  [2210] = {
    [sym_block_comment] = STATE(2210),
    [sym_compiler_directive_decl] = STATE(2210),
    [sym_fsi_directive_decl] = STATE(2210),
    [sym_preproc_line] = STATE(2210),
    [sym_identifier] = ACTIONS(3139),
    [anon_sym_EQ] = ACTIONS(3141),
    [anon_sym_COLON] = ACTIONS(3139),
    [anon_sym_return] = ACTIONS(3139),
    [anon_sym_do] = ACTIONS(3139),
    [anon_sym_let] = ACTIONS(3139),
    [anon_sym_let_BANG] = ACTIONS(3141),
    [anon_sym_LPAREN] = ACTIONS(3139),
    [anon_sym_COMMA] = ACTIONS(3141),
    [anon_sym_null] = ACTIONS(3139),
    [anon_sym_QMARK] = ACTIONS(3139),
    [anon_sym_COLON_QMARK] = ACTIONS(3139),
    [anon_sym_COLON_COLON] = ACTIONS(3141),
    [anon_sym_AMP] = ACTIONS(3139),
    [anon_sym_LBRACK] = ACTIONS(3139),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3141),
    [anon_sym_LBRACE] = ACTIONS(3139),
    [anon_sym_LT_AT] = ACTIONS(3139),
    [anon_sym_LT_AT_AT] = ACTIONS(3139),
    [anon_sym_DOT] = ACTIONS(3139),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3141),
    [anon_sym_new] = ACTIONS(3139),
    [anon_sym_return_BANG] = ACTIONS(3141),
    [anon_sym_yield] = ACTIONS(3139),
    [anon_sym_yield_BANG] = ACTIONS(3141),
    [anon_sym_lazy] = ACTIONS(3139),
    [anon_sym_assert] = ACTIONS(3139),
    [anon_sym_upcast] = ACTIONS(3139),
    [anon_sym_downcast] = ACTIONS(3139),
    [anon_sym_COLON_GT] = ACTIONS(3141),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3141),
    [anon_sym_for] = ACTIONS(3139),
    [anon_sym_while] = ACTIONS(3139),
    [anon_sym_if] = ACTIONS(3139),
    [anon_sym_fun] = ACTIONS(3139),
    [anon_sym_try] = ACTIONS(3139),
    [anon_sym_match] = ACTIONS(3139),
    [anon_sym_match_BANG] = ACTIONS(3141),
    [anon_sym_function] = ACTIONS(3139),
    [anon_sym_LT_DASH] = ACTIONS(3139),
    [anon_sym_DOT_LBRACK] = ACTIONS(3141),
    [anon_sym_LT] = ACTIONS(3141),
    [anon_sym_GT] = ACTIONS(3139),
    [anon_sym_use] = ACTIONS(3139),
    [anon_sym_use_BANG] = ACTIONS(3141),
    [anon_sym_do_BANG] = ACTIONS(3141),
    [anon_sym_begin] = ACTIONS(3139),
    [anon_sym_LPAREN2] = ACTIONS(3139),
    [anon_sym_or] = ACTIONS(3139),
    [aux_sym_char_token1] = ACTIONS(3141),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3139),
    [anon_sym_DQUOTE] = ACTIONS(3139),
    [anon_sym_AT_DQUOTE] = ACTIONS(3141),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3141),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3141),
    [sym_bool] = ACTIONS(3139),
    [sym_unit] = ACTIONS(3141),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3139),
    [sym_op_identifier] = ACTIONS(3139),
    [anon_sym_PLUS] = ACTIONS(3139),
    [anon_sym_DASH] = ACTIONS(3139),
    [anon_sym_PLUS_DOT] = ACTIONS(3139),
    [anon_sym_DASH_DOT] = ACTIONS(3139),
    [anon_sym_PERCENT] = ACTIONS(3139),
    [anon_sym_AMP_AMP] = ACTIONS(3139),
    [anon_sym_TILDE] = ACTIONS(3141),
    [aux_sym_prefix_op_token1] = ACTIONS(3139),
    [aux_sym_infix_op_token1] = ACTIONS(3141),
    [aux_sym_infix_op_token2] = ACTIONS(3139),
    [anon_sym_PIPE_PIPE] = ACTIONS(3139),
    [anon_sym_BANG_EQ] = ACTIONS(3139),
    [anon_sym_COLON_EQ] = ACTIONS(3141),
    [anon_sym_DOLLAR] = ACTIONS(3139),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3139),
    [sym_int] = ACTIONS(3139),
    [sym_xint] = ACTIONS(3141),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3141),
    [sym__newline] = ACTIONS(3141),
  },
  [2211] = {
    [sym_block_comment] = STATE(2211),
    [sym_compiler_directive_decl] = STATE(2211),
    [sym_fsi_directive_decl] = STATE(2211),
    [sym_preproc_line] = STATE(2211),
    [sym_identifier] = ACTIONS(3131),
    [anon_sym_EQ] = ACTIONS(3133),
    [anon_sym_COLON] = ACTIONS(3131),
    [anon_sym_return] = ACTIONS(3131),
    [anon_sym_do] = ACTIONS(3131),
    [anon_sym_let] = ACTIONS(3131),
    [anon_sym_let_BANG] = ACTIONS(3133),
    [anon_sym_LPAREN] = ACTIONS(3131),
    [anon_sym_COMMA] = ACTIONS(3133),
    [anon_sym_null] = ACTIONS(3131),
    [anon_sym_QMARK] = ACTIONS(3131),
    [anon_sym_COLON_QMARK] = ACTIONS(3131),
    [anon_sym_COLON_COLON] = ACTIONS(3133),
    [anon_sym_AMP] = ACTIONS(3131),
    [anon_sym_LBRACK] = ACTIONS(3131),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3133),
    [anon_sym_LBRACE] = ACTIONS(3131),
    [anon_sym_LT_AT] = ACTIONS(3131),
    [anon_sym_LT_AT_AT] = ACTIONS(3131),
    [anon_sym_DOT] = ACTIONS(3131),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3133),
    [anon_sym_new] = ACTIONS(3131),
    [anon_sym_return_BANG] = ACTIONS(3133),
    [anon_sym_yield] = ACTIONS(3131),
    [anon_sym_yield_BANG] = ACTIONS(3133),
    [anon_sym_lazy] = ACTIONS(3131),
    [anon_sym_assert] = ACTIONS(3131),
    [anon_sym_upcast] = ACTIONS(3131),
    [anon_sym_downcast] = ACTIONS(3131),
    [anon_sym_COLON_GT] = ACTIONS(3133),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3133),
    [anon_sym_for] = ACTIONS(3131),
    [anon_sym_while] = ACTIONS(3131),
    [anon_sym_if] = ACTIONS(3131),
    [anon_sym_fun] = ACTIONS(3131),
    [anon_sym_try] = ACTIONS(3131),
    [anon_sym_match] = ACTIONS(3131),
    [anon_sym_match_BANG] = ACTIONS(3133),
    [anon_sym_function] = ACTIONS(3131),
    [anon_sym_LT_DASH] = ACTIONS(3131),
    [anon_sym_DOT_LBRACK] = ACTIONS(3133),
    [anon_sym_LT] = ACTIONS(3133),
    [anon_sym_GT] = ACTIONS(3131),
    [anon_sym_use] = ACTIONS(3131),
    [anon_sym_use_BANG] = ACTIONS(3133),
    [anon_sym_do_BANG] = ACTIONS(3133),
    [anon_sym_begin] = ACTIONS(3131),
    [anon_sym_LPAREN2] = ACTIONS(3131),
    [anon_sym_or] = ACTIONS(3131),
    [aux_sym_char_token1] = ACTIONS(3133),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3131),
    [anon_sym_DQUOTE] = ACTIONS(3131),
    [anon_sym_AT_DQUOTE] = ACTIONS(3133),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3133),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3133),
    [sym_bool] = ACTIONS(3131),
    [sym_unit] = ACTIONS(3133),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3131),
    [sym_op_identifier] = ACTIONS(3131),
    [anon_sym_PLUS] = ACTIONS(3131),
    [anon_sym_DASH] = ACTIONS(3131),
    [anon_sym_PLUS_DOT] = ACTIONS(3131),
    [anon_sym_DASH_DOT] = ACTIONS(3131),
    [anon_sym_PERCENT] = ACTIONS(3131),
    [anon_sym_AMP_AMP] = ACTIONS(3131),
    [anon_sym_TILDE] = ACTIONS(3133),
    [aux_sym_prefix_op_token1] = ACTIONS(3131),
    [aux_sym_infix_op_token1] = ACTIONS(3133),
    [aux_sym_infix_op_token2] = ACTIONS(3131),
    [anon_sym_PIPE_PIPE] = ACTIONS(3131),
    [anon_sym_BANG_EQ] = ACTIONS(3131),
    [anon_sym_COLON_EQ] = ACTIONS(3133),
    [anon_sym_DOLLAR] = ACTIONS(3131),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3131),
    [sym_int] = ACTIONS(3131),
    [sym_xint] = ACTIONS(3133),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3133),
    [sym__newline] = ACTIONS(3133),
  },
  [2212] = {
    [sym_block_comment] = STATE(2212),
    [sym_compiler_directive_decl] = STATE(2212),
    [sym_fsi_directive_decl] = STATE(2212),
    [sym_preproc_line] = STATE(2212),
    [sym_identifier] = ACTIONS(2934),
    [anon_sym_EQ] = ACTIONS(2936),
    [anon_sym_COLON] = ACTIONS(2934),
    [anon_sym_return] = ACTIONS(2934),
    [anon_sym_do] = ACTIONS(2934),
    [anon_sym_let] = ACTIONS(2934),
    [anon_sym_let_BANG] = ACTIONS(2936),
    [anon_sym_LPAREN] = ACTIONS(2934),
    [anon_sym_COMMA] = ACTIONS(2936),
    [anon_sym_null] = ACTIONS(2934),
    [anon_sym_QMARK] = ACTIONS(2934),
    [anon_sym_COLON_QMARK] = ACTIONS(2934),
    [anon_sym_COLON_COLON] = ACTIONS(2936),
    [anon_sym_AMP] = ACTIONS(2934),
    [anon_sym_LBRACK] = ACTIONS(2934),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2936),
    [anon_sym_LBRACE] = ACTIONS(2934),
    [anon_sym_LT_AT] = ACTIONS(2934),
    [anon_sym_LT_AT_AT] = ACTIONS(2934),
    [anon_sym_DOT] = ACTIONS(2934),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2936),
    [anon_sym_new] = ACTIONS(2934),
    [anon_sym_return_BANG] = ACTIONS(2936),
    [anon_sym_yield] = ACTIONS(2934),
    [anon_sym_yield_BANG] = ACTIONS(2936),
    [anon_sym_lazy] = ACTIONS(2934),
    [anon_sym_assert] = ACTIONS(2934),
    [anon_sym_upcast] = ACTIONS(2934),
    [anon_sym_downcast] = ACTIONS(2934),
    [anon_sym_COLON_GT] = ACTIONS(2936),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2936),
    [anon_sym_for] = ACTIONS(2934),
    [anon_sym_while] = ACTIONS(2934),
    [anon_sym_if] = ACTIONS(2934),
    [anon_sym_fun] = ACTIONS(2934),
    [anon_sym_try] = ACTIONS(2934),
    [anon_sym_match] = ACTIONS(2934),
    [anon_sym_match_BANG] = ACTIONS(2936),
    [anon_sym_function] = ACTIONS(2934),
    [anon_sym_LT_DASH] = ACTIONS(2934),
    [anon_sym_DOT_LBRACK] = ACTIONS(2936),
    [anon_sym_LT] = ACTIONS(2936),
    [anon_sym_GT] = ACTIONS(2934),
    [anon_sym_use] = ACTIONS(2934),
    [anon_sym_use_BANG] = ACTIONS(2936),
    [anon_sym_do_BANG] = ACTIONS(2936),
    [anon_sym_begin] = ACTIONS(2934),
    [anon_sym_LPAREN2] = ACTIONS(2934),
    [anon_sym_or] = ACTIONS(2934),
    [aux_sym_char_token1] = ACTIONS(2936),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2934),
    [anon_sym_DQUOTE] = ACTIONS(2934),
    [anon_sym_AT_DQUOTE] = ACTIONS(2936),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2936),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2936),
    [sym_bool] = ACTIONS(2934),
    [sym_unit] = ACTIONS(2936),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2934),
    [sym_op_identifier] = ACTIONS(2934),
    [anon_sym_PLUS] = ACTIONS(2934),
    [anon_sym_DASH] = ACTIONS(2934),
    [anon_sym_PLUS_DOT] = ACTIONS(2934),
    [anon_sym_DASH_DOT] = ACTIONS(2934),
    [anon_sym_PERCENT] = ACTIONS(2934),
    [anon_sym_AMP_AMP] = ACTIONS(2934),
    [anon_sym_TILDE] = ACTIONS(2936),
    [aux_sym_prefix_op_token1] = ACTIONS(2934),
    [aux_sym_infix_op_token1] = ACTIONS(2936),
    [aux_sym_infix_op_token2] = ACTIONS(2934),
    [anon_sym_PIPE_PIPE] = ACTIONS(2934),
    [anon_sym_BANG_EQ] = ACTIONS(2934),
    [anon_sym_COLON_EQ] = ACTIONS(2936),
    [anon_sym_DOLLAR] = ACTIONS(2934),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2934),
    [sym_int] = ACTIONS(2934),
    [sym_xint] = ACTIONS(2936),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2936),
    [sym__newline] = ACTIONS(2936),
  },
  [2213] = {
    [sym_block_comment] = STATE(2213),
    [sym_compiler_directive_decl] = STATE(2213),
    [sym_fsi_directive_decl] = STATE(2213),
    [sym_preproc_line] = STATE(2213),
    [sym_identifier] = ACTIONS(3127),
    [anon_sym_EQ] = ACTIONS(3129),
    [anon_sym_COLON] = ACTIONS(3127),
    [anon_sym_return] = ACTIONS(3127),
    [anon_sym_do] = ACTIONS(3127),
    [anon_sym_let] = ACTIONS(3127),
    [anon_sym_let_BANG] = ACTIONS(3129),
    [anon_sym_LPAREN] = ACTIONS(3127),
    [anon_sym_COMMA] = ACTIONS(3129),
    [anon_sym_null] = ACTIONS(3127),
    [anon_sym_QMARK] = ACTIONS(3127),
    [anon_sym_COLON_QMARK] = ACTIONS(3127),
    [anon_sym_COLON_COLON] = ACTIONS(3129),
    [anon_sym_AMP] = ACTIONS(3127),
    [anon_sym_LBRACK] = ACTIONS(3127),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3129),
    [anon_sym_LBRACE] = ACTIONS(3127),
    [anon_sym_LT_AT] = ACTIONS(3127),
    [anon_sym_LT_AT_AT] = ACTIONS(3127),
    [anon_sym_DOT] = ACTIONS(3127),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3129),
    [anon_sym_new] = ACTIONS(3127),
    [anon_sym_return_BANG] = ACTIONS(3129),
    [anon_sym_yield] = ACTIONS(3127),
    [anon_sym_yield_BANG] = ACTIONS(3129),
    [anon_sym_lazy] = ACTIONS(3127),
    [anon_sym_assert] = ACTIONS(3127),
    [anon_sym_upcast] = ACTIONS(3127),
    [anon_sym_downcast] = ACTIONS(3127),
    [anon_sym_COLON_GT] = ACTIONS(3129),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3129),
    [anon_sym_for] = ACTIONS(3127),
    [anon_sym_while] = ACTIONS(3127),
    [anon_sym_if] = ACTIONS(3127),
    [anon_sym_fun] = ACTIONS(3127),
    [anon_sym_try] = ACTIONS(3127),
    [anon_sym_match] = ACTIONS(3127),
    [anon_sym_match_BANG] = ACTIONS(3129),
    [anon_sym_function] = ACTIONS(3127),
    [anon_sym_LT_DASH] = ACTIONS(3127),
    [anon_sym_DOT_LBRACK] = ACTIONS(3129),
    [anon_sym_LT] = ACTIONS(3129),
    [anon_sym_GT] = ACTIONS(3127),
    [anon_sym_use] = ACTIONS(3127),
    [anon_sym_use_BANG] = ACTIONS(3129),
    [anon_sym_do_BANG] = ACTIONS(3129),
    [anon_sym_begin] = ACTIONS(3127),
    [anon_sym_LPAREN2] = ACTIONS(3127),
    [anon_sym_or] = ACTIONS(3127),
    [aux_sym_char_token1] = ACTIONS(3129),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3127),
    [anon_sym_DQUOTE] = ACTIONS(3127),
    [anon_sym_AT_DQUOTE] = ACTIONS(3129),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3129),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3129),
    [sym_bool] = ACTIONS(3127),
    [sym_unit] = ACTIONS(3129),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3127),
    [sym_op_identifier] = ACTIONS(3127),
    [anon_sym_PLUS] = ACTIONS(3127),
    [anon_sym_DASH] = ACTIONS(3127),
    [anon_sym_PLUS_DOT] = ACTIONS(3127),
    [anon_sym_DASH_DOT] = ACTIONS(3127),
    [anon_sym_PERCENT] = ACTIONS(3127),
    [anon_sym_AMP_AMP] = ACTIONS(3127),
    [anon_sym_TILDE] = ACTIONS(3129),
    [aux_sym_prefix_op_token1] = ACTIONS(3127),
    [aux_sym_infix_op_token1] = ACTIONS(3129),
    [aux_sym_infix_op_token2] = ACTIONS(3127),
    [anon_sym_PIPE_PIPE] = ACTIONS(3127),
    [anon_sym_BANG_EQ] = ACTIONS(3127),
    [anon_sym_COLON_EQ] = ACTIONS(3129),
    [anon_sym_DOLLAR] = ACTIONS(3127),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3127),
    [sym_int] = ACTIONS(3127),
    [sym_xint] = ACTIONS(3129),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3129),
    [sym__newline] = ACTIONS(3129),
  },
  [2214] = {
    [sym_block_comment] = STATE(2214),
    [sym_compiler_directive_decl] = STATE(2214),
    [sym_fsi_directive_decl] = STATE(2214),
    [sym_preproc_line] = STATE(2214),
    [sym_identifier] = ACTIONS(3123),
    [anon_sym_EQ] = ACTIONS(3125),
    [anon_sym_COLON] = ACTIONS(3123),
    [anon_sym_return] = ACTIONS(3123),
    [anon_sym_do] = ACTIONS(3123),
    [anon_sym_let] = ACTIONS(3123),
    [anon_sym_let_BANG] = ACTIONS(3125),
    [anon_sym_LPAREN] = ACTIONS(3123),
    [anon_sym_COMMA] = ACTIONS(3125),
    [anon_sym_null] = ACTIONS(3123),
    [anon_sym_QMARK] = ACTIONS(3123),
    [anon_sym_COLON_QMARK] = ACTIONS(3123),
    [anon_sym_COLON_COLON] = ACTIONS(3125),
    [anon_sym_AMP] = ACTIONS(3123),
    [anon_sym_LBRACK] = ACTIONS(3123),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3125),
    [anon_sym_LBRACE] = ACTIONS(3123),
    [anon_sym_LT_AT] = ACTIONS(3123),
    [anon_sym_LT_AT_AT] = ACTIONS(3123),
    [anon_sym_DOT] = ACTIONS(3123),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3125),
    [anon_sym_new] = ACTIONS(3123),
    [anon_sym_return_BANG] = ACTIONS(3125),
    [anon_sym_yield] = ACTIONS(3123),
    [anon_sym_yield_BANG] = ACTIONS(3125),
    [anon_sym_lazy] = ACTIONS(3123),
    [anon_sym_assert] = ACTIONS(3123),
    [anon_sym_upcast] = ACTIONS(3123),
    [anon_sym_downcast] = ACTIONS(3123),
    [anon_sym_COLON_GT] = ACTIONS(3125),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3125),
    [anon_sym_for] = ACTIONS(3123),
    [anon_sym_while] = ACTIONS(3123),
    [anon_sym_if] = ACTIONS(3123),
    [anon_sym_fun] = ACTIONS(3123),
    [anon_sym_try] = ACTIONS(3123),
    [anon_sym_match] = ACTIONS(3123),
    [anon_sym_match_BANG] = ACTIONS(3125),
    [anon_sym_function] = ACTIONS(3123),
    [anon_sym_LT_DASH] = ACTIONS(3123),
    [anon_sym_DOT_LBRACK] = ACTIONS(3125),
    [anon_sym_LT] = ACTIONS(3125),
    [anon_sym_GT] = ACTIONS(3123),
    [anon_sym_use] = ACTIONS(3123),
    [anon_sym_use_BANG] = ACTIONS(3125),
    [anon_sym_do_BANG] = ACTIONS(3125),
    [anon_sym_begin] = ACTIONS(3123),
    [anon_sym_LPAREN2] = ACTIONS(3123),
    [anon_sym_or] = ACTIONS(3123),
    [aux_sym_char_token1] = ACTIONS(3125),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3123),
    [anon_sym_DQUOTE] = ACTIONS(3123),
    [anon_sym_AT_DQUOTE] = ACTIONS(3125),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3125),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3125),
    [sym_bool] = ACTIONS(3123),
    [sym_unit] = ACTIONS(3125),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3123),
    [sym_op_identifier] = ACTIONS(3123),
    [anon_sym_PLUS] = ACTIONS(3123),
    [anon_sym_DASH] = ACTIONS(3123),
    [anon_sym_PLUS_DOT] = ACTIONS(3123),
    [anon_sym_DASH_DOT] = ACTIONS(3123),
    [anon_sym_PERCENT] = ACTIONS(3123),
    [anon_sym_AMP_AMP] = ACTIONS(3123),
    [anon_sym_TILDE] = ACTIONS(3125),
    [aux_sym_prefix_op_token1] = ACTIONS(3123),
    [aux_sym_infix_op_token1] = ACTIONS(3125),
    [aux_sym_infix_op_token2] = ACTIONS(3123),
    [anon_sym_PIPE_PIPE] = ACTIONS(3123),
    [anon_sym_BANG_EQ] = ACTIONS(3123),
    [anon_sym_COLON_EQ] = ACTIONS(3125),
    [anon_sym_DOLLAR] = ACTIONS(3123),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3123),
    [sym_int] = ACTIONS(3123),
    [sym_xint] = ACTIONS(3125),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3125),
    [sym__newline] = ACTIONS(3125),
  },
  [2215] = {
    [sym_block_comment] = STATE(2215),
    [sym_compiler_directive_decl] = STATE(2215),
    [sym_fsi_directive_decl] = STATE(2215),
    [sym_preproc_line] = STATE(2215),
    [sym_identifier] = ACTIONS(3079),
    [anon_sym_EQ] = ACTIONS(3081),
    [anon_sym_COLON] = ACTIONS(3079),
    [anon_sym_return] = ACTIONS(3079),
    [anon_sym_do] = ACTIONS(3079),
    [anon_sym_let] = ACTIONS(3079),
    [anon_sym_let_BANG] = ACTIONS(3081),
    [anon_sym_LPAREN] = ACTIONS(3079),
    [anon_sym_COMMA] = ACTIONS(3081),
    [anon_sym_null] = ACTIONS(3079),
    [anon_sym_QMARK] = ACTIONS(3079),
    [anon_sym_COLON_QMARK] = ACTIONS(3079),
    [anon_sym_COLON_COLON] = ACTIONS(3081),
    [anon_sym_AMP] = ACTIONS(3079),
    [anon_sym_LBRACK] = ACTIONS(3079),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3081),
    [anon_sym_LBRACE] = ACTIONS(3079),
    [anon_sym_LT_AT] = ACTIONS(3079),
    [anon_sym_LT_AT_AT] = ACTIONS(3079),
    [anon_sym_AT_AT_GT] = ACTIONS(3079),
    [anon_sym_DOT] = ACTIONS(3079),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3081),
    [anon_sym_new] = ACTIONS(3079),
    [anon_sym_return_BANG] = ACTIONS(3081),
    [anon_sym_yield] = ACTIONS(3079),
    [anon_sym_yield_BANG] = ACTIONS(3081),
    [anon_sym_lazy] = ACTIONS(3079),
    [anon_sym_assert] = ACTIONS(3079),
    [anon_sym_upcast] = ACTIONS(3079),
    [anon_sym_downcast] = ACTIONS(3079),
    [anon_sym_COLON_GT] = ACTIONS(3081),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3081),
    [anon_sym_for] = ACTIONS(3079),
    [anon_sym_while] = ACTIONS(3079),
    [anon_sym_if] = ACTIONS(3079),
    [anon_sym_fun] = ACTIONS(3079),
    [anon_sym_try] = ACTIONS(3079),
    [anon_sym_match] = ACTIONS(3079),
    [anon_sym_match_BANG] = ACTIONS(3081),
    [anon_sym_function] = ACTIONS(3079),
    [anon_sym_LT_DASH] = ACTIONS(3079),
    [anon_sym_DOT_LBRACK] = ACTIONS(3081),
    [anon_sym_LT] = ACTIONS(3081),
    [anon_sym_use] = ACTIONS(3079),
    [anon_sym_use_BANG] = ACTIONS(3081),
    [anon_sym_do_BANG] = ACTIONS(3081),
    [anon_sym_begin] = ACTIONS(3079),
    [anon_sym_LPAREN2] = ACTIONS(3079),
    [anon_sym_or] = ACTIONS(3079),
    [aux_sym_char_token1] = ACTIONS(3081),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3079),
    [anon_sym_DQUOTE] = ACTIONS(3079),
    [anon_sym_AT_DQUOTE] = ACTIONS(3081),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3081),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3081),
    [sym_bool] = ACTIONS(3079),
    [sym_unit] = ACTIONS(3081),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3079),
    [sym_op_identifier] = ACTIONS(3079),
    [anon_sym_PLUS] = ACTIONS(3079),
    [anon_sym_DASH] = ACTIONS(3079),
    [anon_sym_PLUS_DOT] = ACTIONS(3079),
    [anon_sym_DASH_DOT] = ACTIONS(3079),
    [anon_sym_PERCENT] = ACTIONS(3079),
    [anon_sym_AMP_AMP] = ACTIONS(3079),
    [anon_sym_TILDE] = ACTIONS(3081),
    [aux_sym_prefix_op_token1] = ACTIONS(3079),
    [aux_sym_infix_op_token1] = ACTIONS(3081),
    [aux_sym_infix_op_token2] = ACTIONS(3079),
    [anon_sym_PIPE_PIPE] = ACTIONS(3079),
    [anon_sym_BANG_EQ] = ACTIONS(3079),
    [anon_sym_COLON_EQ] = ACTIONS(3081),
    [anon_sym_DOLLAR] = ACTIONS(3079),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3079),
    [sym_int] = ACTIONS(3079),
    [sym_xint] = ACTIONS(3081),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3081),
    [sym__newline] = ACTIONS(3081),
  },
  [2216] = {
    [sym_block_comment] = STATE(2216),
    [sym_compiler_directive_decl] = STATE(2216),
    [sym_fsi_directive_decl] = STATE(2216),
    [sym_preproc_line] = STATE(2216),
    [sym_identifier] = ACTIONS(2930),
    [anon_sym_EQ] = ACTIONS(2932),
    [anon_sym_COLON] = ACTIONS(2930),
    [anon_sym_return] = ACTIONS(2930),
    [anon_sym_do] = ACTIONS(2930),
    [anon_sym_let] = ACTIONS(2930),
    [anon_sym_let_BANG] = ACTIONS(2932),
    [anon_sym_LPAREN] = ACTIONS(2930),
    [anon_sym_COMMA] = ACTIONS(2932),
    [anon_sym_null] = ACTIONS(2930),
    [anon_sym_QMARK] = ACTIONS(2930),
    [anon_sym_COLON_QMARK] = ACTIONS(2930),
    [anon_sym_COLON_COLON] = ACTIONS(2932),
    [anon_sym_AMP] = ACTIONS(2930),
    [anon_sym_LBRACK] = ACTIONS(2930),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2932),
    [anon_sym_LBRACE] = ACTIONS(2930),
    [anon_sym_LT_AT] = ACTIONS(2930),
    [anon_sym_LT_AT_AT] = ACTIONS(2930),
    [anon_sym_DOT] = ACTIONS(2930),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2932),
    [anon_sym_new] = ACTIONS(2930),
    [anon_sym_return_BANG] = ACTIONS(2932),
    [anon_sym_yield] = ACTIONS(2930),
    [anon_sym_yield_BANG] = ACTIONS(2932),
    [anon_sym_lazy] = ACTIONS(2930),
    [anon_sym_assert] = ACTIONS(2930),
    [anon_sym_upcast] = ACTIONS(2930),
    [anon_sym_downcast] = ACTIONS(2930),
    [anon_sym_COLON_GT] = ACTIONS(2932),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2932),
    [anon_sym_for] = ACTIONS(2930),
    [anon_sym_while] = ACTIONS(2930),
    [anon_sym_if] = ACTIONS(2930),
    [anon_sym_fun] = ACTIONS(2930),
    [anon_sym_try] = ACTIONS(2930),
    [anon_sym_match] = ACTIONS(2930),
    [anon_sym_match_BANG] = ACTIONS(2932),
    [anon_sym_function] = ACTIONS(2930),
    [anon_sym_LT_DASH] = ACTIONS(2930),
    [anon_sym_DOT_LBRACK] = ACTIONS(2932),
    [anon_sym_LT] = ACTIONS(2932),
    [anon_sym_use] = ACTIONS(2930),
    [anon_sym_use_BANG] = ACTIONS(2932),
    [anon_sym_do_BANG] = ACTIONS(2932),
    [anon_sym_DOT_DOT] = ACTIONS(2932),
    [anon_sym_begin] = ACTIONS(2930),
    [anon_sym_LPAREN2] = ACTIONS(2930),
    [anon_sym_or] = ACTIONS(2930),
    [aux_sym_char_token1] = ACTIONS(2932),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2930),
    [anon_sym_DQUOTE] = ACTIONS(2930),
    [anon_sym_AT_DQUOTE] = ACTIONS(2932),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2932),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2932),
    [sym_bool] = ACTIONS(2930),
    [sym_unit] = ACTIONS(2932),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2930),
    [sym_op_identifier] = ACTIONS(2930),
    [anon_sym_PLUS] = ACTIONS(2930),
    [anon_sym_DASH] = ACTIONS(2930),
    [anon_sym_PLUS_DOT] = ACTIONS(2930),
    [anon_sym_DASH_DOT] = ACTIONS(2930),
    [anon_sym_PERCENT] = ACTIONS(2930),
    [anon_sym_AMP_AMP] = ACTIONS(2930),
    [anon_sym_TILDE] = ACTIONS(2932),
    [aux_sym_prefix_op_token1] = ACTIONS(2930),
    [aux_sym_infix_op_token1] = ACTIONS(2932),
    [aux_sym_infix_op_token2] = ACTIONS(2930),
    [anon_sym_PIPE_PIPE] = ACTIONS(2930),
    [anon_sym_BANG_EQ] = ACTIONS(2930),
    [anon_sym_COLON_EQ] = ACTIONS(2932),
    [anon_sym_DOLLAR] = ACTIONS(2930),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2930),
    [sym_int] = ACTIONS(2930),
    [sym_xint] = ACTIONS(2932),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2932),
    [sym__newline] = ACTIONS(2932),
  },
  [2217] = {
    [sym_block_comment] = STATE(2217),
    [sym_compiler_directive_decl] = STATE(2217),
    [sym_fsi_directive_decl] = STATE(2217),
    [sym_preproc_line] = STATE(2217),
    [sym_identifier] = ACTIONS(2906),
    [anon_sym_EQ] = ACTIONS(2908),
    [anon_sym_COLON] = ACTIONS(2906),
    [anon_sym_return] = ACTIONS(2906),
    [anon_sym_do] = ACTIONS(2906),
    [anon_sym_let] = ACTIONS(2906),
    [anon_sym_let_BANG] = ACTIONS(2908),
    [anon_sym_LPAREN] = ACTIONS(2906),
    [anon_sym_COMMA] = ACTIONS(2908),
    [anon_sym_null] = ACTIONS(2906),
    [anon_sym_QMARK] = ACTIONS(2906),
    [anon_sym_COLON_QMARK] = ACTIONS(2906),
    [anon_sym_COLON_COLON] = ACTIONS(2908),
    [anon_sym_AMP] = ACTIONS(2906),
    [anon_sym_LBRACK] = ACTIONS(2906),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2908),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_LT_AT] = ACTIONS(2906),
    [anon_sym_LT_AT_AT] = ACTIONS(2906),
    [anon_sym_DOT] = ACTIONS(2906),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2908),
    [anon_sym_new] = ACTIONS(2906),
    [anon_sym_return_BANG] = ACTIONS(2908),
    [anon_sym_yield] = ACTIONS(2906),
    [anon_sym_yield_BANG] = ACTIONS(2908),
    [anon_sym_lazy] = ACTIONS(2906),
    [anon_sym_assert] = ACTIONS(2906),
    [anon_sym_upcast] = ACTIONS(2906),
    [anon_sym_downcast] = ACTIONS(2906),
    [anon_sym_COLON_GT] = ACTIONS(2908),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2908),
    [anon_sym_for] = ACTIONS(2906),
    [anon_sym_while] = ACTIONS(2906),
    [anon_sym_if] = ACTIONS(2906),
    [anon_sym_fun] = ACTIONS(2906),
    [anon_sym_try] = ACTIONS(2906),
    [anon_sym_match] = ACTIONS(2906),
    [anon_sym_match_BANG] = ACTIONS(2908),
    [anon_sym_function] = ACTIONS(2906),
    [anon_sym_LT_DASH] = ACTIONS(2906),
    [anon_sym_DOT_LBRACK] = ACTIONS(2908),
    [anon_sym_LT] = ACTIONS(2908),
    [anon_sym_use] = ACTIONS(2906),
    [anon_sym_use_BANG] = ACTIONS(2908),
    [anon_sym_do_BANG] = ACTIONS(2908),
    [anon_sym_DOT_DOT] = ACTIONS(2908),
    [anon_sym_begin] = ACTIONS(2906),
    [anon_sym_LPAREN2] = ACTIONS(2906),
    [anon_sym_or] = ACTIONS(2906),
    [aux_sym_char_token1] = ACTIONS(2908),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2906),
    [anon_sym_DQUOTE] = ACTIONS(2906),
    [anon_sym_AT_DQUOTE] = ACTIONS(2908),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2908),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2908),
    [sym_bool] = ACTIONS(2906),
    [sym_unit] = ACTIONS(2908),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2906),
    [sym_op_identifier] = ACTIONS(2906),
    [anon_sym_PLUS] = ACTIONS(2906),
    [anon_sym_DASH] = ACTIONS(2906),
    [anon_sym_PLUS_DOT] = ACTIONS(2906),
    [anon_sym_DASH_DOT] = ACTIONS(2906),
    [anon_sym_PERCENT] = ACTIONS(2906),
    [anon_sym_AMP_AMP] = ACTIONS(2906),
    [anon_sym_TILDE] = ACTIONS(2908),
    [aux_sym_prefix_op_token1] = ACTIONS(2906),
    [aux_sym_infix_op_token1] = ACTIONS(2908),
    [aux_sym_infix_op_token2] = ACTIONS(2906),
    [anon_sym_PIPE_PIPE] = ACTIONS(2906),
    [anon_sym_BANG_EQ] = ACTIONS(2906),
    [anon_sym_COLON_EQ] = ACTIONS(2908),
    [anon_sym_DOLLAR] = ACTIONS(2906),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2906),
    [sym_int] = ACTIONS(2906),
    [sym_xint] = ACTIONS(2908),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2908),
    [sym__newline] = ACTIONS(2908),
  },
  [2218] = {
    [sym_block_comment] = STATE(2218),
    [sym_compiler_directive_decl] = STATE(2218),
    [sym_fsi_directive_decl] = STATE(2218),
    [sym_preproc_line] = STATE(2218),
    [sym_identifier] = ACTIONS(2902),
    [anon_sym_EQ] = ACTIONS(2904),
    [anon_sym_COLON] = ACTIONS(2902),
    [anon_sym_return] = ACTIONS(2902),
    [anon_sym_do] = ACTIONS(2902),
    [anon_sym_let] = ACTIONS(2902),
    [anon_sym_let_BANG] = ACTIONS(2904),
    [anon_sym_LPAREN] = ACTIONS(2902),
    [anon_sym_COMMA] = ACTIONS(2904),
    [anon_sym_null] = ACTIONS(2902),
    [anon_sym_QMARK] = ACTIONS(2902),
    [anon_sym_COLON_QMARK] = ACTIONS(2902),
    [anon_sym_COLON_COLON] = ACTIONS(2904),
    [anon_sym_AMP] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2902),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2902),
    [anon_sym_LT_AT] = ACTIONS(2902),
    [anon_sym_LT_AT_AT] = ACTIONS(2902),
    [anon_sym_DOT] = ACTIONS(2902),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2904),
    [anon_sym_new] = ACTIONS(2902),
    [anon_sym_return_BANG] = ACTIONS(2904),
    [anon_sym_yield] = ACTIONS(2902),
    [anon_sym_yield_BANG] = ACTIONS(2904),
    [anon_sym_lazy] = ACTIONS(2902),
    [anon_sym_assert] = ACTIONS(2902),
    [anon_sym_upcast] = ACTIONS(2902),
    [anon_sym_downcast] = ACTIONS(2902),
    [anon_sym_COLON_GT] = ACTIONS(2904),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2904),
    [anon_sym_for] = ACTIONS(2902),
    [anon_sym_while] = ACTIONS(2902),
    [anon_sym_if] = ACTIONS(2902),
    [anon_sym_fun] = ACTIONS(2902),
    [anon_sym_try] = ACTIONS(2902),
    [anon_sym_match] = ACTIONS(2902),
    [anon_sym_match_BANG] = ACTIONS(2904),
    [anon_sym_function] = ACTIONS(2902),
    [anon_sym_LT_DASH] = ACTIONS(2902),
    [anon_sym_DOT_LBRACK] = ACTIONS(2904),
    [anon_sym_LT] = ACTIONS(2904),
    [anon_sym_use] = ACTIONS(2902),
    [anon_sym_use_BANG] = ACTIONS(2904),
    [anon_sym_do_BANG] = ACTIONS(2904),
    [anon_sym_DOT_DOT] = ACTIONS(2904),
    [anon_sym_begin] = ACTIONS(2902),
    [anon_sym_LPAREN2] = ACTIONS(2902),
    [anon_sym_or] = ACTIONS(2902),
    [aux_sym_char_token1] = ACTIONS(2904),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2902),
    [anon_sym_DQUOTE] = ACTIONS(2902),
    [anon_sym_AT_DQUOTE] = ACTIONS(2904),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2904),
    [sym_bool] = ACTIONS(2902),
    [sym_unit] = ACTIONS(2904),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2902),
    [sym_op_identifier] = ACTIONS(2902),
    [anon_sym_PLUS] = ACTIONS(2902),
    [anon_sym_DASH] = ACTIONS(2902),
    [anon_sym_PLUS_DOT] = ACTIONS(2902),
    [anon_sym_DASH_DOT] = ACTIONS(2902),
    [anon_sym_PERCENT] = ACTIONS(2902),
    [anon_sym_AMP_AMP] = ACTIONS(2902),
    [anon_sym_TILDE] = ACTIONS(2904),
    [aux_sym_prefix_op_token1] = ACTIONS(2902),
    [aux_sym_infix_op_token1] = ACTIONS(2904),
    [aux_sym_infix_op_token2] = ACTIONS(2902),
    [anon_sym_PIPE_PIPE] = ACTIONS(2902),
    [anon_sym_BANG_EQ] = ACTIONS(2902),
    [anon_sym_COLON_EQ] = ACTIONS(2904),
    [anon_sym_DOLLAR] = ACTIONS(2902),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2902),
    [sym_int] = ACTIONS(2902),
    [sym_xint] = ACTIONS(2904),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2904),
    [sym__newline] = ACTIONS(2904),
  },
  [2219] = {
    [sym_block_comment] = STATE(2219),
    [sym_compiler_directive_decl] = STATE(2219),
    [sym_fsi_directive_decl] = STATE(2219),
    [sym_preproc_line] = STATE(2219),
    [sym_identifier] = ACTIONS(2881),
    [anon_sym_EQ] = ACTIONS(2789),
    [anon_sym_COLON] = ACTIONS(2881),
    [anon_sym_return] = ACTIONS(2881),
    [anon_sym_do] = ACTIONS(2881),
    [anon_sym_let] = ACTIONS(2881),
    [anon_sym_let_BANG] = ACTIONS(2789),
    [anon_sym_LPAREN] = ACTIONS(2881),
    [anon_sym_COMMA] = ACTIONS(2789),
    [anon_sym_null] = ACTIONS(2881),
    [anon_sym_QMARK] = ACTIONS(2881),
    [anon_sym_COLON_QMARK] = ACTIONS(2881),
    [anon_sym_COLON_COLON] = ACTIONS(2789),
    [anon_sym_AMP] = ACTIONS(2881),
    [anon_sym_LBRACK] = ACTIONS(2881),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2789),
    [anon_sym_LBRACE] = ACTIONS(2881),
    [anon_sym_LT_AT] = ACTIONS(2881),
    [anon_sym_LT_AT_AT] = ACTIONS(2881),
    [anon_sym_DOT] = ACTIONS(2881),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2789),
    [anon_sym_new] = ACTIONS(2881),
    [anon_sym_return_BANG] = ACTIONS(2789),
    [anon_sym_yield] = ACTIONS(2881),
    [anon_sym_yield_BANG] = ACTIONS(2789),
    [anon_sym_lazy] = ACTIONS(2881),
    [anon_sym_assert] = ACTIONS(2881),
    [anon_sym_upcast] = ACTIONS(2881),
    [anon_sym_downcast] = ACTIONS(2881),
    [anon_sym_COLON_GT] = ACTIONS(2789),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2789),
    [anon_sym_for] = ACTIONS(2881),
    [anon_sym_while] = ACTIONS(2881),
    [anon_sym_if] = ACTIONS(2881),
    [anon_sym_fun] = ACTIONS(2881),
    [anon_sym_try] = ACTIONS(2881),
    [anon_sym_match] = ACTIONS(2881),
    [anon_sym_match_BANG] = ACTIONS(2789),
    [anon_sym_function] = ACTIONS(2881),
    [anon_sym_LT_DASH] = ACTIONS(2881),
    [anon_sym_DOT_LBRACK] = ACTIONS(2789),
    [anon_sym_LT] = ACTIONS(2789),
    [anon_sym_use] = ACTIONS(2881),
    [anon_sym_use_BANG] = ACTIONS(2789),
    [anon_sym_do_BANG] = ACTIONS(2789),
    [anon_sym_DOT_DOT] = ACTIONS(2789),
    [anon_sym_begin] = ACTIONS(2881),
    [anon_sym_LPAREN2] = ACTIONS(2881),
    [anon_sym_or] = ACTIONS(2881),
    [aux_sym_char_token1] = ACTIONS(2789),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2881),
    [anon_sym_DQUOTE] = ACTIONS(2881),
    [anon_sym_AT_DQUOTE] = ACTIONS(2789),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2789),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2789),
    [sym_bool] = ACTIONS(2881),
    [sym_unit] = ACTIONS(2789),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2881),
    [sym_op_identifier] = ACTIONS(2881),
    [anon_sym_PLUS] = ACTIONS(2881),
    [anon_sym_DASH] = ACTIONS(2881),
    [anon_sym_PLUS_DOT] = ACTIONS(2881),
    [anon_sym_DASH_DOT] = ACTIONS(2881),
    [anon_sym_PERCENT] = ACTIONS(2881),
    [anon_sym_AMP_AMP] = ACTIONS(2881),
    [anon_sym_TILDE] = ACTIONS(2789),
    [aux_sym_prefix_op_token1] = ACTIONS(2881),
    [aux_sym_infix_op_token1] = ACTIONS(2789),
    [aux_sym_infix_op_token2] = ACTIONS(2881),
    [anon_sym_PIPE_PIPE] = ACTIONS(2881),
    [anon_sym_BANG_EQ] = ACTIONS(2881),
    [anon_sym_COLON_EQ] = ACTIONS(2789),
    [anon_sym_DOLLAR] = ACTIONS(2881),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2881),
    [sym_int] = ACTIONS(2881),
    [sym_xint] = ACTIONS(2789),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2789),
    [sym__newline] = ACTIONS(2789),
  },
  [2220] = {
    [sym_block_comment] = STATE(2220),
    [sym_compiler_directive_decl] = STATE(2220),
    [sym_fsi_directive_decl] = STATE(2220),
    [sym_preproc_line] = STATE(2220),
    [sym_identifier] = ACTIONS(3011),
    [anon_sym_EQ] = ACTIONS(3013),
    [anon_sym_COLON] = ACTIONS(3011),
    [anon_sym_return] = ACTIONS(3011),
    [anon_sym_do] = ACTIONS(3011),
    [anon_sym_let] = ACTIONS(3011),
    [anon_sym_let_BANG] = ACTIONS(3013),
    [anon_sym_LPAREN] = ACTIONS(3011),
    [anon_sym_COMMA] = ACTIONS(3013),
    [anon_sym_null] = ACTIONS(3011),
    [anon_sym_QMARK] = ACTIONS(3011),
    [anon_sym_COLON_QMARK] = ACTIONS(3011),
    [anon_sym_COLON_COLON] = ACTIONS(3013),
    [anon_sym_AMP] = ACTIONS(3011),
    [anon_sym_LBRACK] = ACTIONS(3011),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3013),
    [anon_sym_LBRACE] = ACTIONS(3011),
    [anon_sym_LT_AT] = ACTIONS(3011),
    [anon_sym_LT_AT_AT] = ACTIONS(3011),
    [anon_sym_AT_AT_GT] = ACTIONS(3011),
    [anon_sym_DOT] = ACTIONS(3011),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3013),
    [anon_sym_new] = ACTIONS(3011),
    [anon_sym_return_BANG] = ACTIONS(3013),
    [anon_sym_yield] = ACTIONS(3011),
    [anon_sym_yield_BANG] = ACTIONS(3013),
    [anon_sym_lazy] = ACTIONS(3011),
    [anon_sym_assert] = ACTIONS(3011),
    [anon_sym_upcast] = ACTIONS(3011),
    [anon_sym_downcast] = ACTIONS(3011),
    [anon_sym_COLON_GT] = ACTIONS(3013),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3013),
    [anon_sym_for] = ACTIONS(3011),
    [anon_sym_while] = ACTIONS(3011),
    [anon_sym_if] = ACTIONS(3011),
    [anon_sym_fun] = ACTIONS(3011),
    [anon_sym_try] = ACTIONS(3011),
    [anon_sym_match] = ACTIONS(3011),
    [anon_sym_match_BANG] = ACTIONS(3013),
    [anon_sym_function] = ACTIONS(3011),
    [anon_sym_LT_DASH] = ACTIONS(3011),
    [anon_sym_DOT_LBRACK] = ACTIONS(3013),
    [anon_sym_LT] = ACTIONS(3013),
    [anon_sym_use] = ACTIONS(3011),
    [anon_sym_use_BANG] = ACTIONS(3013),
    [anon_sym_do_BANG] = ACTIONS(3013),
    [anon_sym_begin] = ACTIONS(3011),
    [anon_sym_LPAREN2] = ACTIONS(3011),
    [anon_sym_or] = ACTIONS(3011),
    [aux_sym_char_token1] = ACTIONS(3013),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3011),
    [anon_sym_DQUOTE] = ACTIONS(3011),
    [anon_sym_AT_DQUOTE] = ACTIONS(3013),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3013),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3013),
    [sym_bool] = ACTIONS(3011),
    [sym_unit] = ACTIONS(3013),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3011),
    [sym_op_identifier] = ACTIONS(3011),
    [anon_sym_PLUS] = ACTIONS(3011),
    [anon_sym_DASH] = ACTIONS(3011),
    [anon_sym_PLUS_DOT] = ACTIONS(3011),
    [anon_sym_DASH_DOT] = ACTIONS(3011),
    [anon_sym_PERCENT] = ACTIONS(3011),
    [anon_sym_AMP_AMP] = ACTIONS(3011),
    [anon_sym_TILDE] = ACTIONS(3013),
    [aux_sym_prefix_op_token1] = ACTIONS(3011),
    [aux_sym_infix_op_token1] = ACTIONS(3013),
    [aux_sym_infix_op_token2] = ACTIONS(3011),
    [anon_sym_PIPE_PIPE] = ACTIONS(3011),
    [anon_sym_BANG_EQ] = ACTIONS(3011),
    [anon_sym_COLON_EQ] = ACTIONS(3013),
    [anon_sym_DOLLAR] = ACTIONS(3011),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3011),
    [sym_int] = ACTIONS(3011),
    [sym_xint] = ACTIONS(3013),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3013),
    [sym__newline] = ACTIONS(3013),
  },
  [2221] = {
    [sym_block_comment] = STATE(2221),
    [sym_compiler_directive_decl] = STATE(2221),
    [sym_fsi_directive_decl] = STATE(2221),
    [sym_preproc_line] = STATE(2221),
    [sym_identifier] = ACTIONS(3091),
    [anon_sym_EQ] = ACTIONS(3093),
    [anon_sym_COLON] = ACTIONS(3091),
    [anon_sym_return] = ACTIONS(3091),
    [anon_sym_do] = ACTIONS(3091),
    [anon_sym_let] = ACTIONS(3091),
    [anon_sym_let_BANG] = ACTIONS(3093),
    [anon_sym_LPAREN] = ACTIONS(3091),
    [anon_sym_COMMA] = ACTIONS(3093),
    [anon_sym_null] = ACTIONS(3091),
    [anon_sym_QMARK] = ACTIONS(3091),
    [anon_sym_COLON_QMARK] = ACTIONS(3091),
    [anon_sym_COLON_COLON] = ACTIONS(3093),
    [anon_sym_AMP] = ACTIONS(3091),
    [anon_sym_LBRACK] = ACTIONS(3091),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3093),
    [anon_sym_LBRACE] = ACTIONS(3091),
    [anon_sym_LT_AT] = ACTIONS(3091),
    [anon_sym_LT_AT_AT] = ACTIONS(3091),
    [anon_sym_DOT] = ACTIONS(3091),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3093),
    [anon_sym_new] = ACTIONS(3091),
    [anon_sym_return_BANG] = ACTIONS(3093),
    [anon_sym_yield] = ACTIONS(3091),
    [anon_sym_yield_BANG] = ACTIONS(3093),
    [anon_sym_lazy] = ACTIONS(3091),
    [anon_sym_assert] = ACTIONS(3091),
    [anon_sym_upcast] = ACTIONS(3091),
    [anon_sym_downcast] = ACTIONS(3091),
    [anon_sym_COLON_GT] = ACTIONS(3093),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3093),
    [anon_sym_for] = ACTIONS(3091),
    [anon_sym_while] = ACTIONS(3091),
    [anon_sym_if] = ACTIONS(3091),
    [anon_sym_fun] = ACTIONS(3091),
    [anon_sym_try] = ACTIONS(3091),
    [anon_sym_match] = ACTIONS(3091),
    [anon_sym_match_BANG] = ACTIONS(3093),
    [anon_sym_function] = ACTIONS(3091),
    [anon_sym_LT_DASH] = ACTIONS(3091),
    [anon_sym_DOT_LBRACK] = ACTIONS(3093),
    [anon_sym_LT] = ACTIONS(3093),
    [anon_sym_GT] = ACTIONS(3091),
    [anon_sym_use] = ACTIONS(3091),
    [anon_sym_use_BANG] = ACTIONS(3093),
    [anon_sym_do_BANG] = ACTIONS(3093),
    [anon_sym_begin] = ACTIONS(3091),
    [anon_sym_LPAREN2] = ACTIONS(3091),
    [anon_sym_or] = ACTIONS(3091),
    [aux_sym_char_token1] = ACTIONS(3093),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3091),
    [anon_sym_DQUOTE] = ACTIONS(3091),
    [anon_sym_AT_DQUOTE] = ACTIONS(3093),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3093),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3093),
    [sym_bool] = ACTIONS(3091),
    [sym_unit] = ACTIONS(3093),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3091),
    [sym_op_identifier] = ACTIONS(3091),
    [anon_sym_PLUS] = ACTIONS(3091),
    [anon_sym_DASH] = ACTIONS(3091),
    [anon_sym_PLUS_DOT] = ACTIONS(3091),
    [anon_sym_DASH_DOT] = ACTIONS(3091),
    [anon_sym_PERCENT] = ACTIONS(3091),
    [anon_sym_AMP_AMP] = ACTIONS(3091),
    [anon_sym_TILDE] = ACTIONS(3093),
    [aux_sym_prefix_op_token1] = ACTIONS(3091),
    [aux_sym_infix_op_token1] = ACTIONS(3093),
    [aux_sym_infix_op_token2] = ACTIONS(3091),
    [anon_sym_PIPE_PIPE] = ACTIONS(3091),
    [anon_sym_BANG_EQ] = ACTIONS(3091),
    [anon_sym_COLON_EQ] = ACTIONS(3093),
    [anon_sym_DOLLAR] = ACTIONS(3091),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3091),
    [sym_int] = ACTIONS(3091),
    [sym_xint] = ACTIONS(3093),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3093),
    [sym__newline] = ACTIONS(3093),
  },
  [2222] = {
    [sym_block_comment] = STATE(2222),
    [sym_compiler_directive_decl] = STATE(2222),
    [sym_fsi_directive_decl] = STATE(2222),
    [sym_preproc_line] = STATE(2222),
    [sym_identifier] = ACTIONS(2942),
    [anon_sym_EQ] = ACTIONS(2944),
    [anon_sym_COLON] = ACTIONS(2942),
    [anon_sym_return] = ACTIONS(2942),
    [anon_sym_do] = ACTIONS(2942),
    [anon_sym_let] = ACTIONS(2942),
    [anon_sym_let_BANG] = ACTIONS(2944),
    [anon_sym_LPAREN] = ACTIONS(2942),
    [anon_sym_COMMA] = ACTIONS(2944),
    [anon_sym_null] = ACTIONS(2942),
    [anon_sym_QMARK] = ACTIONS(2942),
    [anon_sym_COLON_QMARK] = ACTIONS(2942),
    [anon_sym_COLON_COLON] = ACTIONS(2944),
    [anon_sym_AMP] = ACTIONS(2942),
    [anon_sym_LBRACK] = ACTIONS(2942),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2944),
    [anon_sym_LBRACE] = ACTIONS(2942),
    [anon_sym_LT_AT] = ACTIONS(2942),
    [anon_sym_LT_AT_AT] = ACTIONS(2942),
    [anon_sym_DOT] = ACTIONS(2942),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2944),
    [anon_sym_new] = ACTIONS(2942),
    [anon_sym_return_BANG] = ACTIONS(2944),
    [anon_sym_yield] = ACTIONS(2942),
    [anon_sym_yield_BANG] = ACTIONS(2944),
    [anon_sym_lazy] = ACTIONS(2942),
    [anon_sym_assert] = ACTIONS(2942),
    [anon_sym_upcast] = ACTIONS(2942),
    [anon_sym_downcast] = ACTIONS(2942),
    [anon_sym_COLON_GT] = ACTIONS(2944),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2944),
    [anon_sym_for] = ACTIONS(2942),
    [anon_sym_while] = ACTIONS(2942),
    [anon_sym_if] = ACTIONS(2942),
    [anon_sym_fun] = ACTIONS(2942),
    [anon_sym_try] = ACTIONS(2942),
    [anon_sym_match] = ACTIONS(2942),
    [anon_sym_match_BANG] = ACTIONS(2944),
    [anon_sym_function] = ACTIONS(2942),
    [anon_sym_LT_DASH] = ACTIONS(2942),
    [anon_sym_DOT_LBRACK] = ACTIONS(2944),
    [anon_sym_LT] = ACTIONS(2944),
    [anon_sym_use] = ACTIONS(2942),
    [anon_sym_use_BANG] = ACTIONS(2944),
    [anon_sym_do_BANG] = ACTIONS(2944),
    [anon_sym_begin] = ACTIONS(2942),
    [anon_sym_LPAREN2] = ACTIONS(2942),
    [anon_sym_or] = ACTIONS(2942),
    [aux_sym_char_token1] = ACTIONS(2944),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2942),
    [anon_sym_DQUOTE] = ACTIONS(2942),
    [anon_sym_AT_DQUOTE] = ACTIONS(2944),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2944),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2944),
    [sym_bool] = ACTIONS(2942),
    [sym_unit] = ACTIONS(2944),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2942),
    [sym_op_identifier] = ACTIONS(2942),
    [anon_sym_PLUS] = ACTIONS(2942),
    [anon_sym_DASH] = ACTIONS(2942),
    [anon_sym_PLUS_DOT] = ACTIONS(2942),
    [anon_sym_DASH_DOT] = ACTIONS(2942),
    [anon_sym_PERCENT] = ACTIONS(2942),
    [anon_sym_AMP_AMP] = ACTIONS(2942),
    [anon_sym_TILDE] = ACTIONS(2944),
    [aux_sym_prefix_op_token1] = ACTIONS(2942),
    [aux_sym_infix_op_token1] = ACTIONS(2944),
    [aux_sym_infix_op_token2] = ACTIONS(2942),
    [anon_sym_PIPE_PIPE] = ACTIONS(2942),
    [anon_sym_BANG_EQ] = ACTIONS(2942),
    [anon_sym_COLON_EQ] = ACTIONS(2944),
    [anon_sym_DOLLAR] = ACTIONS(2942),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2942),
    [sym_int] = ACTIONS(2942),
    [sym_xint] = ACTIONS(2944),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2944),
    [anon_sym_POUNDendif] = ACTIONS(2944),
    [sym__newline] = ACTIONS(2944),
  },
  [2223] = {
    [sym_block_comment] = STATE(2223),
    [sym_compiler_directive_decl] = STATE(2223),
    [sym_fsi_directive_decl] = STATE(2223),
    [sym_preproc_line] = STATE(2223),
    [sym_identifier] = ACTIONS(2970),
    [anon_sym_EQ] = ACTIONS(2972),
    [anon_sym_COLON] = ACTIONS(2970),
    [anon_sym_return] = ACTIONS(2970),
    [anon_sym_do] = ACTIONS(2970),
    [anon_sym_let] = ACTIONS(2970),
    [anon_sym_let_BANG] = ACTIONS(2972),
    [anon_sym_LPAREN] = ACTIONS(2970),
    [anon_sym_COMMA] = ACTIONS(2972),
    [anon_sym_null] = ACTIONS(2970),
    [anon_sym_QMARK] = ACTIONS(2970),
    [anon_sym_COLON_QMARK] = ACTIONS(2970),
    [anon_sym_COLON_COLON] = ACTIONS(2972),
    [anon_sym_AMP] = ACTIONS(2970),
    [anon_sym_LBRACK] = ACTIONS(2970),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2972),
    [anon_sym_LBRACE] = ACTIONS(2970),
    [anon_sym_LT_AT] = ACTIONS(2970),
    [anon_sym_LT_AT_AT] = ACTIONS(2970),
    [anon_sym_DOT] = ACTIONS(2970),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2972),
    [anon_sym_new] = ACTIONS(2970),
    [anon_sym_return_BANG] = ACTIONS(2972),
    [anon_sym_yield] = ACTIONS(2970),
    [anon_sym_yield_BANG] = ACTIONS(2972),
    [anon_sym_lazy] = ACTIONS(2970),
    [anon_sym_assert] = ACTIONS(2970),
    [anon_sym_upcast] = ACTIONS(2970),
    [anon_sym_downcast] = ACTIONS(2970),
    [anon_sym_COLON_GT] = ACTIONS(2972),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2972),
    [anon_sym_for] = ACTIONS(2970),
    [anon_sym_while] = ACTIONS(2970),
    [anon_sym_if] = ACTIONS(2970),
    [anon_sym_fun] = ACTIONS(2970),
    [anon_sym_try] = ACTIONS(2970),
    [anon_sym_match] = ACTIONS(2970),
    [anon_sym_match_BANG] = ACTIONS(2972),
    [anon_sym_function] = ACTIONS(2970),
    [anon_sym_LT_DASH] = ACTIONS(2970),
    [anon_sym_DOT_LBRACK] = ACTIONS(2972),
    [anon_sym_LT] = ACTIONS(2972),
    [anon_sym_use] = ACTIONS(2970),
    [anon_sym_use_BANG] = ACTIONS(2972),
    [anon_sym_do_BANG] = ACTIONS(2972),
    [anon_sym_begin] = ACTIONS(2970),
    [anon_sym_LPAREN2] = ACTIONS(2970),
    [anon_sym_or] = ACTIONS(2970),
    [aux_sym_char_token1] = ACTIONS(2972),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2970),
    [anon_sym_DQUOTE] = ACTIONS(2970),
    [anon_sym_AT_DQUOTE] = ACTIONS(2972),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2972),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2972),
    [sym_bool] = ACTIONS(2970),
    [sym_unit] = ACTIONS(2972),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2970),
    [sym_op_identifier] = ACTIONS(2970),
    [anon_sym_PLUS] = ACTIONS(2970),
    [anon_sym_DASH] = ACTIONS(2970),
    [anon_sym_PLUS_DOT] = ACTIONS(2970),
    [anon_sym_DASH_DOT] = ACTIONS(2970),
    [anon_sym_PERCENT] = ACTIONS(2970),
    [anon_sym_AMP_AMP] = ACTIONS(2970),
    [anon_sym_TILDE] = ACTIONS(2972),
    [aux_sym_prefix_op_token1] = ACTIONS(2970),
    [aux_sym_infix_op_token1] = ACTIONS(2972),
    [aux_sym_infix_op_token2] = ACTIONS(2970),
    [anon_sym_PIPE_PIPE] = ACTIONS(2970),
    [anon_sym_BANG_EQ] = ACTIONS(2970),
    [anon_sym_COLON_EQ] = ACTIONS(2972),
    [anon_sym_DOLLAR] = ACTIONS(2970),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2970),
    [sym_int] = ACTIONS(2970),
    [sym_xint] = ACTIONS(2972),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2972),
    [anon_sym_POUNDendif] = ACTIONS(2972),
    [sym__newline] = ACTIONS(2972),
  },
  [2224] = {
    [sym_block_comment] = STATE(2224),
    [sym_compiler_directive_decl] = STATE(2224),
    [sym_fsi_directive_decl] = STATE(2224),
    [sym_preproc_line] = STATE(2224),
    [sym_identifier] = ACTIONS(2988),
    [anon_sym_EQ] = ACTIONS(2990),
    [anon_sym_COLON] = ACTIONS(2988),
    [anon_sym_return] = ACTIONS(2988),
    [anon_sym_do] = ACTIONS(2988),
    [anon_sym_let] = ACTIONS(2988),
    [anon_sym_let_BANG] = ACTIONS(2990),
    [anon_sym_LPAREN] = ACTIONS(2988),
    [anon_sym_COMMA] = ACTIONS(2990),
    [anon_sym_null] = ACTIONS(2988),
    [anon_sym_QMARK] = ACTIONS(2988),
    [anon_sym_COLON_QMARK] = ACTIONS(2988),
    [anon_sym_COLON_COLON] = ACTIONS(2990),
    [anon_sym_AMP] = ACTIONS(2988),
    [anon_sym_LBRACK] = ACTIONS(2988),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2990),
    [anon_sym_LBRACE] = ACTIONS(2988),
    [anon_sym_LT_AT] = ACTIONS(2988),
    [anon_sym_LT_AT_AT] = ACTIONS(2988),
    [anon_sym_DOT] = ACTIONS(2988),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2990),
    [anon_sym_new] = ACTIONS(2988),
    [anon_sym_return_BANG] = ACTIONS(2990),
    [anon_sym_yield] = ACTIONS(2988),
    [anon_sym_yield_BANG] = ACTIONS(2990),
    [anon_sym_lazy] = ACTIONS(2988),
    [anon_sym_assert] = ACTIONS(2988),
    [anon_sym_upcast] = ACTIONS(2988),
    [anon_sym_downcast] = ACTIONS(2988),
    [anon_sym_COLON_GT] = ACTIONS(2990),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2990),
    [anon_sym_for] = ACTIONS(2988),
    [anon_sym_while] = ACTIONS(2988),
    [anon_sym_if] = ACTIONS(2988),
    [anon_sym_fun] = ACTIONS(2988),
    [anon_sym_try] = ACTIONS(2988),
    [anon_sym_match] = ACTIONS(2988),
    [anon_sym_match_BANG] = ACTIONS(2990),
    [anon_sym_function] = ACTIONS(2988),
    [anon_sym_LT_DASH] = ACTIONS(2988),
    [anon_sym_DOT_LBRACK] = ACTIONS(2990),
    [anon_sym_LT] = ACTIONS(2990),
    [anon_sym_use] = ACTIONS(2988),
    [anon_sym_use_BANG] = ACTIONS(2990),
    [anon_sym_do_BANG] = ACTIONS(2990),
    [anon_sym_begin] = ACTIONS(2988),
    [anon_sym_LPAREN2] = ACTIONS(2988),
    [anon_sym_or] = ACTIONS(2988),
    [aux_sym_char_token1] = ACTIONS(2990),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2988),
    [anon_sym_DQUOTE] = ACTIONS(2988),
    [anon_sym_AT_DQUOTE] = ACTIONS(2990),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2990),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2990),
    [sym_bool] = ACTIONS(2988),
    [sym_unit] = ACTIONS(2990),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2988),
    [sym_op_identifier] = ACTIONS(2988),
    [anon_sym_PLUS] = ACTIONS(2988),
    [anon_sym_DASH] = ACTIONS(2988),
    [anon_sym_PLUS_DOT] = ACTIONS(2988),
    [anon_sym_DASH_DOT] = ACTIONS(2988),
    [anon_sym_PERCENT] = ACTIONS(2988),
    [anon_sym_AMP_AMP] = ACTIONS(2988),
    [anon_sym_TILDE] = ACTIONS(2990),
    [aux_sym_prefix_op_token1] = ACTIONS(2988),
    [aux_sym_infix_op_token1] = ACTIONS(2990),
    [aux_sym_infix_op_token2] = ACTIONS(2988),
    [anon_sym_PIPE_PIPE] = ACTIONS(2988),
    [anon_sym_BANG_EQ] = ACTIONS(2988),
    [anon_sym_COLON_EQ] = ACTIONS(2990),
    [anon_sym_DOLLAR] = ACTIONS(2988),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2988),
    [sym_int] = ACTIONS(2988),
    [sym_xint] = ACTIONS(2990),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2990),
    [anon_sym_POUNDendif] = ACTIONS(2990),
    [sym__newline] = ACTIONS(2990),
  },
  [2225] = {
    [sym_block_comment] = STATE(2225),
    [sym_compiler_directive_decl] = STATE(2225),
    [sym_fsi_directive_decl] = STATE(2225),
    [sym_preproc_line] = STATE(2225),
    [sym_identifier] = ACTIONS(3011),
    [anon_sym_EQ] = ACTIONS(3013),
    [anon_sym_COLON] = ACTIONS(3011),
    [anon_sym_return] = ACTIONS(3011),
    [anon_sym_do] = ACTIONS(3011),
    [anon_sym_let] = ACTIONS(3011),
    [anon_sym_let_BANG] = ACTIONS(3013),
    [anon_sym_LPAREN] = ACTIONS(3011),
    [anon_sym_COMMA] = ACTIONS(3013),
    [anon_sym_null] = ACTIONS(3011),
    [anon_sym_QMARK] = ACTIONS(3011),
    [anon_sym_COLON_QMARK] = ACTIONS(3011),
    [anon_sym_COLON_COLON] = ACTIONS(3013),
    [anon_sym_AMP] = ACTIONS(3011),
    [anon_sym_LBRACK] = ACTIONS(3011),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3013),
    [anon_sym_LBRACE] = ACTIONS(3011),
    [anon_sym_LT_AT] = ACTIONS(3011),
    [anon_sym_LT_AT_AT] = ACTIONS(3011),
    [anon_sym_DOT] = ACTIONS(3011),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3013),
    [anon_sym_new] = ACTIONS(3011),
    [anon_sym_return_BANG] = ACTIONS(3013),
    [anon_sym_yield] = ACTIONS(3011),
    [anon_sym_yield_BANG] = ACTIONS(3013),
    [anon_sym_lazy] = ACTIONS(3011),
    [anon_sym_assert] = ACTIONS(3011),
    [anon_sym_upcast] = ACTIONS(3011),
    [anon_sym_downcast] = ACTIONS(3011),
    [anon_sym_COLON_GT] = ACTIONS(3013),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3013),
    [anon_sym_for] = ACTIONS(3011),
    [anon_sym_while] = ACTIONS(3011),
    [anon_sym_if] = ACTIONS(3011),
    [anon_sym_fun] = ACTIONS(3011),
    [anon_sym_try] = ACTIONS(3011),
    [anon_sym_match] = ACTIONS(3011),
    [anon_sym_match_BANG] = ACTIONS(3013),
    [anon_sym_function] = ACTIONS(3011),
    [anon_sym_LT_DASH] = ACTIONS(3011),
    [anon_sym_DOT_LBRACK] = ACTIONS(3013),
    [anon_sym_LT] = ACTIONS(3013),
    [anon_sym_use] = ACTIONS(3011),
    [anon_sym_use_BANG] = ACTIONS(3013),
    [anon_sym_do_BANG] = ACTIONS(3013),
    [anon_sym_begin] = ACTIONS(3011),
    [anon_sym_LPAREN2] = ACTIONS(3011),
    [anon_sym_or] = ACTIONS(3011),
    [aux_sym_char_token1] = ACTIONS(3013),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3011),
    [anon_sym_DQUOTE] = ACTIONS(3011),
    [anon_sym_AT_DQUOTE] = ACTIONS(3013),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3013),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3013),
    [sym_bool] = ACTIONS(3011),
    [sym_unit] = ACTIONS(3013),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3011),
    [sym_op_identifier] = ACTIONS(3011),
    [anon_sym_PLUS] = ACTIONS(3011),
    [anon_sym_DASH] = ACTIONS(3011),
    [anon_sym_PLUS_DOT] = ACTIONS(3011),
    [anon_sym_DASH_DOT] = ACTIONS(3011),
    [anon_sym_PERCENT] = ACTIONS(3011),
    [anon_sym_AMP_AMP] = ACTIONS(3011),
    [anon_sym_TILDE] = ACTIONS(3013),
    [aux_sym_prefix_op_token1] = ACTIONS(3011),
    [aux_sym_infix_op_token1] = ACTIONS(3013),
    [aux_sym_infix_op_token2] = ACTIONS(3011),
    [anon_sym_PIPE_PIPE] = ACTIONS(3011),
    [anon_sym_BANG_EQ] = ACTIONS(3011),
    [anon_sym_COLON_EQ] = ACTIONS(3013),
    [anon_sym_DOLLAR] = ACTIONS(3011),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3011),
    [sym_int] = ACTIONS(3011),
    [sym_xint] = ACTIONS(3013),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3013),
    [anon_sym_POUNDendif] = ACTIONS(3013),
    [sym__newline] = ACTIONS(3013),
  },
  [2226] = {
    [sym_block_comment] = STATE(2226),
    [sym_compiler_directive_decl] = STATE(2226),
    [sym_fsi_directive_decl] = STATE(2226),
    [sym_preproc_line] = STATE(2226),
    [sym_identifier] = ACTIONS(2881),
    [anon_sym_EQ] = ACTIONS(2789),
    [anon_sym_COLON] = ACTIONS(2881),
    [anon_sym_return] = ACTIONS(2881),
    [anon_sym_do] = ACTIONS(2881),
    [anon_sym_let] = ACTIONS(2881),
    [anon_sym_let_BANG] = ACTIONS(2789),
    [anon_sym_LPAREN] = ACTIONS(2881),
    [anon_sym_COMMA] = ACTIONS(2789),
    [anon_sym_null] = ACTIONS(2881),
    [anon_sym_QMARK] = ACTIONS(2881),
    [anon_sym_COLON_QMARK] = ACTIONS(2881),
    [anon_sym_COLON_COLON] = ACTIONS(2789),
    [anon_sym_AMP] = ACTIONS(2881),
    [anon_sym_LBRACK] = ACTIONS(2881),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2789),
    [anon_sym_LBRACE] = ACTIONS(2881),
    [anon_sym_LT_AT] = ACTIONS(2881),
    [anon_sym_AT_GT] = ACTIONS(2881),
    [anon_sym_LT_AT_AT] = ACTIONS(2881),
    [anon_sym_DOT] = ACTIONS(2881),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2789),
    [anon_sym_new] = ACTIONS(2881),
    [anon_sym_return_BANG] = ACTIONS(2789),
    [anon_sym_yield] = ACTIONS(2881),
    [anon_sym_yield_BANG] = ACTIONS(2789),
    [anon_sym_lazy] = ACTIONS(2881),
    [anon_sym_assert] = ACTIONS(2881),
    [anon_sym_upcast] = ACTIONS(2881),
    [anon_sym_downcast] = ACTIONS(2881),
    [anon_sym_COLON_GT] = ACTIONS(2789),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2789),
    [anon_sym_for] = ACTIONS(2881),
    [anon_sym_while] = ACTIONS(2881),
    [anon_sym_if] = ACTIONS(2881),
    [anon_sym_fun] = ACTIONS(2881),
    [anon_sym_try] = ACTIONS(2881),
    [anon_sym_match] = ACTIONS(2881),
    [anon_sym_match_BANG] = ACTIONS(2789),
    [anon_sym_function] = ACTIONS(2881),
    [anon_sym_LT_DASH] = ACTIONS(2881),
    [anon_sym_DOT_LBRACK] = ACTIONS(2789),
    [anon_sym_LT] = ACTIONS(2789),
    [anon_sym_use] = ACTIONS(2881),
    [anon_sym_use_BANG] = ACTIONS(2789),
    [anon_sym_do_BANG] = ACTIONS(2789),
    [anon_sym_begin] = ACTIONS(2881),
    [anon_sym_LPAREN2] = ACTIONS(2881),
    [anon_sym_or] = ACTIONS(2881),
    [aux_sym_char_token1] = ACTIONS(2789),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2881),
    [anon_sym_DQUOTE] = ACTIONS(2881),
    [anon_sym_AT_DQUOTE] = ACTIONS(2789),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2789),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2789),
    [sym_bool] = ACTIONS(2881),
    [sym_unit] = ACTIONS(2789),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2881),
    [sym_op_identifier] = ACTIONS(2881),
    [anon_sym_PLUS] = ACTIONS(2881),
    [anon_sym_DASH] = ACTIONS(2881),
    [anon_sym_PLUS_DOT] = ACTIONS(2881),
    [anon_sym_DASH_DOT] = ACTIONS(2881),
    [anon_sym_PERCENT] = ACTIONS(2881),
    [anon_sym_AMP_AMP] = ACTIONS(2881),
    [anon_sym_TILDE] = ACTIONS(2789),
    [aux_sym_prefix_op_token1] = ACTIONS(2881),
    [aux_sym_infix_op_token1] = ACTIONS(2789),
    [aux_sym_infix_op_token2] = ACTIONS(2881),
    [anon_sym_PIPE_PIPE] = ACTIONS(2881),
    [anon_sym_BANG_EQ] = ACTIONS(2881),
    [anon_sym_COLON_EQ] = ACTIONS(2789),
    [anon_sym_DOLLAR] = ACTIONS(2881),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2881),
    [sym_int] = ACTIONS(2881),
    [sym_xint] = ACTIONS(2789),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2789),
    [sym__newline] = ACTIONS(2789),
  },
  [2227] = {
    [sym_block_comment] = STATE(2227),
    [sym_compiler_directive_decl] = STATE(2227),
    [sym_fsi_directive_decl] = STATE(2227),
    [sym_preproc_line] = STATE(2227),
    [sym_identifier] = ACTIONS(2902),
    [anon_sym_EQ] = ACTIONS(2904),
    [anon_sym_COLON] = ACTIONS(2902),
    [anon_sym_return] = ACTIONS(2902),
    [anon_sym_do] = ACTIONS(2902),
    [anon_sym_let] = ACTIONS(2902),
    [anon_sym_let_BANG] = ACTIONS(2904),
    [anon_sym_LPAREN] = ACTIONS(2902),
    [anon_sym_COMMA] = ACTIONS(2904),
    [anon_sym_null] = ACTIONS(2902),
    [anon_sym_QMARK] = ACTIONS(2902),
    [anon_sym_COLON_QMARK] = ACTIONS(2902),
    [anon_sym_COLON_COLON] = ACTIONS(2904),
    [anon_sym_AMP] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2902),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2902),
    [anon_sym_LT_AT] = ACTIONS(2902),
    [anon_sym_AT_GT] = ACTIONS(2902),
    [anon_sym_LT_AT_AT] = ACTIONS(2902),
    [anon_sym_DOT] = ACTIONS(2902),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2904),
    [anon_sym_new] = ACTIONS(2902),
    [anon_sym_return_BANG] = ACTIONS(2904),
    [anon_sym_yield] = ACTIONS(2902),
    [anon_sym_yield_BANG] = ACTIONS(2904),
    [anon_sym_lazy] = ACTIONS(2902),
    [anon_sym_assert] = ACTIONS(2902),
    [anon_sym_upcast] = ACTIONS(2902),
    [anon_sym_downcast] = ACTIONS(2902),
    [anon_sym_COLON_GT] = ACTIONS(2904),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2904),
    [anon_sym_for] = ACTIONS(2902),
    [anon_sym_while] = ACTIONS(2902),
    [anon_sym_if] = ACTIONS(2902),
    [anon_sym_fun] = ACTIONS(2902),
    [anon_sym_try] = ACTIONS(2902),
    [anon_sym_match] = ACTIONS(2902),
    [anon_sym_match_BANG] = ACTIONS(2904),
    [anon_sym_function] = ACTIONS(2902),
    [anon_sym_LT_DASH] = ACTIONS(2902),
    [anon_sym_DOT_LBRACK] = ACTIONS(2904),
    [anon_sym_LT] = ACTIONS(2904),
    [anon_sym_use] = ACTIONS(2902),
    [anon_sym_use_BANG] = ACTIONS(2904),
    [anon_sym_do_BANG] = ACTIONS(2904),
    [anon_sym_begin] = ACTIONS(2902),
    [anon_sym_LPAREN2] = ACTIONS(2902),
    [anon_sym_or] = ACTIONS(2902),
    [aux_sym_char_token1] = ACTIONS(2904),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2902),
    [anon_sym_DQUOTE] = ACTIONS(2902),
    [anon_sym_AT_DQUOTE] = ACTIONS(2904),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2904),
    [sym_bool] = ACTIONS(2902),
    [sym_unit] = ACTIONS(2904),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2902),
    [sym_op_identifier] = ACTIONS(2902),
    [anon_sym_PLUS] = ACTIONS(2902),
    [anon_sym_DASH] = ACTIONS(2902),
    [anon_sym_PLUS_DOT] = ACTIONS(2902),
    [anon_sym_DASH_DOT] = ACTIONS(2902),
    [anon_sym_PERCENT] = ACTIONS(2902),
    [anon_sym_AMP_AMP] = ACTIONS(2902),
    [anon_sym_TILDE] = ACTIONS(2904),
    [aux_sym_prefix_op_token1] = ACTIONS(2902),
    [aux_sym_infix_op_token1] = ACTIONS(2904),
    [aux_sym_infix_op_token2] = ACTIONS(2902),
    [anon_sym_PIPE_PIPE] = ACTIONS(2902),
    [anon_sym_BANG_EQ] = ACTIONS(2902),
    [anon_sym_COLON_EQ] = ACTIONS(2904),
    [anon_sym_DOLLAR] = ACTIONS(2902),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2902),
    [sym_int] = ACTIONS(2902),
    [sym_xint] = ACTIONS(2904),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2904),
    [sym__newline] = ACTIONS(2904),
  },
  [2228] = {
    [sym_block_comment] = STATE(2228),
    [sym_compiler_directive_decl] = STATE(2228),
    [sym_fsi_directive_decl] = STATE(2228),
    [sym_preproc_line] = STATE(2228),
    [sym_identifier] = ACTIONS(2906),
    [anon_sym_EQ] = ACTIONS(2908),
    [anon_sym_COLON] = ACTIONS(2906),
    [anon_sym_return] = ACTIONS(2906),
    [anon_sym_do] = ACTIONS(2906),
    [anon_sym_let] = ACTIONS(2906),
    [anon_sym_let_BANG] = ACTIONS(2908),
    [anon_sym_LPAREN] = ACTIONS(2906),
    [anon_sym_COMMA] = ACTIONS(2908),
    [anon_sym_null] = ACTIONS(2906),
    [anon_sym_QMARK] = ACTIONS(2906),
    [anon_sym_COLON_QMARK] = ACTIONS(2906),
    [anon_sym_COLON_COLON] = ACTIONS(2908),
    [anon_sym_AMP] = ACTIONS(2906),
    [anon_sym_LBRACK] = ACTIONS(2906),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2908),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_LT_AT] = ACTIONS(2906),
    [anon_sym_AT_GT] = ACTIONS(2906),
    [anon_sym_LT_AT_AT] = ACTIONS(2906),
    [anon_sym_DOT] = ACTIONS(2906),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2908),
    [anon_sym_new] = ACTIONS(2906),
    [anon_sym_return_BANG] = ACTIONS(2908),
    [anon_sym_yield] = ACTIONS(2906),
    [anon_sym_yield_BANG] = ACTIONS(2908),
    [anon_sym_lazy] = ACTIONS(2906),
    [anon_sym_assert] = ACTIONS(2906),
    [anon_sym_upcast] = ACTIONS(2906),
    [anon_sym_downcast] = ACTIONS(2906),
    [anon_sym_COLON_GT] = ACTIONS(2908),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2908),
    [anon_sym_for] = ACTIONS(2906),
    [anon_sym_while] = ACTIONS(2906),
    [anon_sym_if] = ACTIONS(2906),
    [anon_sym_fun] = ACTIONS(2906),
    [anon_sym_try] = ACTIONS(2906),
    [anon_sym_match] = ACTIONS(2906),
    [anon_sym_match_BANG] = ACTIONS(2908),
    [anon_sym_function] = ACTIONS(2906),
    [anon_sym_LT_DASH] = ACTIONS(2906),
    [anon_sym_DOT_LBRACK] = ACTIONS(2908),
    [anon_sym_LT] = ACTIONS(2908),
    [anon_sym_use] = ACTIONS(2906),
    [anon_sym_use_BANG] = ACTIONS(2908),
    [anon_sym_do_BANG] = ACTIONS(2908),
    [anon_sym_begin] = ACTIONS(2906),
    [anon_sym_LPAREN2] = ACTIONS(2906),
    [anon_sym_or] = ACTIONS(2906),
    [aux_sym_char_token1] = ACTIONS(2908),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2906),
    [anon_sym_DQUOTE] = ACTIONS(2906),
    [anon_sym_AT_DQUOTE] = ACTIONS(2908),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2908),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2908),
    [sym_bool] = ACTIONS(2906),
    [sym_unit] = ACTIONS(2908),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2906),
    [sym_op_identifier] = ACTIONS(2906),
    [anon_sym_PLUS] = ACTIONS(2906),
    [anon_sym_DASH] = ACTIONS(2906),
    [anon_sym_PLUS_DOT] = ACTIONS(2906),
    [anon_sym_DASH_DOT] = ACTIONS(2906),
    [anon_sym_PERCENT] = ACTIONS(2906),
    [anon_sym_AMP_AMP] = ACTIONS(2906),
    [anon_sym_TILDE] = ACTIONS(2908),
    [aux_sym_prefix_op_token1] = ACTIONS(2906),
    [aux_sym_infix_op_token1] = ACTIONS(2908),
    [aux_sym_infix_op_token2] = ACTIONS(2906),
    [anon_sym_PIPE_PIPE] = ACTIONS(2906),
    [anon_sym_BANG_EQ] = ACTIONS(2906),
    [anon_sym_COLON_EQ] = ACTIONS(2908),
    [anon_sym_DOLLAR] = ACTIONS(2906),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2906),
    [sym_int] = ACTIONS(2906),
    [sym_xint] = ACTIONS(2908),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2908),
    [sym__newline] = ACTIONS(2908),
  },
  [2229] = {
    [sym_block_comment] = STATE(2229),
    [sym_compiler_directive_decl] = STATE(2229),
    [sym_fsi_directive_decl] = STATE(2229),
    [sym_preproc_line] = STATE(2229),
    [sym_identifier] = ACTIONS(2839),
    [anon_sym_EQ] = ACTIONS(2841),
    [anon_sym_COLON] = ACTIONS(2839),
    [anon_sym_return] = ACTIONS(2839),
    [anon_sym_do] = ACTIONS(2839),
    [anon_sym_let] = ACTIONS(2839),
    [anon_sym_let_BANG] = ACTIONS(2841),
    [anon_sym_LPAREN] = ACTIONS(2839),
    [anon_sym_COMMA] = ACTIONS(2841),
    [anon_sym_null] = ACTIONS(2839),
    [anon_sym_QMARK] = ACTIONS(2839),
    [anon_sym_COLON_QMARK] = ACTIONS(2839),
    [anon_sym_COLON_COLON] = ACTIONS(2841),
    [anon_sym_AMP] = ACTIONS(2839),
    [anon_sym_LBRACK] = ACTIONS(2839),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2841),
    [anon_sym_LBRACE] = ACTIONS(2839),
    [anon_sym_LT_AT] = ACTIONS(2839),
    [anon_sym_LT_AT_AT] = ACTIONS(2839),
    [anon_sym_DOT] = ACTIONS(2839),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2841),
    [anon_sym_new] = ACTIONS(2839),
    [anon_sym_return_BANG] = ACTIONS(2841),
    [anon_sym_yield] = ACTIONS(2839),
    [anon_sym_yield_BANG] = ACTIONS(2841),
    [anon_sym_lazy] = ACTIONS(2839),
    [anon_sym_assert] = ACTIONS(2839),
    [anon_sym_upcast] = ACTIONS(2839),
    [anon_sym_downcast] = ACTIONS(2839),
    [anon_sym_COLON_GT] = ACTIONS(2841),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2841),
    [anon_sym_for] = ACTIONS(2839),
    [anon_sym_while] = ACTIONS(2839),
    [anon_sym_if] = ACTIONS(2839),
    [anon_sym_fun] = ACTIONS(2839),
    [anon_sym_try] = ACTIONS(2839),
    [anon_sym_match] = ACTIONS(2839),
    [anon_sym_match_BANG] = ACTIONS(2841),
    [anon_sym_function] = ACTIONS(2839),
    [anon_sym_LT_DASH] = ACTIONS(2839),
    [anon_sym_DOT_LBRACK] = ACTIONS(2841),
    [anon_sym_LT] = ACTIONS(2841),
    [anon_sym_use] = ACTIONS(2839),
    [anon_sym_use_BANG] = ACTIONS(2841),
    [anon_sym_do_BANG] = ACTIONS(2841),
    [anon_sym_DOT_DOT] = ACTIONS(2841),
    [anon_sym_begin] = ACTIONS(2839),
    [anon_sym_LPAREN2] = ACTIONS(2839),
    [anon_sym_or] = ACTIONS(2839),
    [aux_sym_char_token1] = ACTIONS(2841),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2839),
    [anon_sym_DQUOTE] = ACTIONS(2839),
    [anon_sym_AT_DQUOTE] = ACTIONS(2841),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2841),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2841),
    [sym_bool] = ACTIONS(2839),
    [sym_unit] = ACTIONS(2841),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2839),
    [sym_op_identifier] = ACTIONS(2839),
    [anon_sym_PLUS] = ACTIONS(2839),
    [anon_sym_DASH] = ACTIONS(2839),
    [anon_sym_PLUS_DOT] = ACTIONS(2839),
    [anon_sym_DASH_DOT] = ACTIONS(2839),
    [anon_sym_PERCENT] = ACTIONS(2839),
    [anon_sym_AMP_AMP] = ACTIONS(2839),
    [anon_sym_TILDE] = ACTIONS(2841),
    [aux_sym_prefix_op_token1] = ACTIONS(2839),
    [aux_sym_infix_op_token1] = ACTIONS(2841),
    [aux_sym_infix_op_token2] = ACTIONS(2839),
    [anon_sym_PIPE_PIPE] = ACTIONS(2839),
    [anon_sym_BANG_EQ] = ACTIONS(2839),
    [anon_sym_COLON_EQ] = ACTIONS(2841),
    [anon_sym_DOLLAR] = ACTIONS(2839),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2839),
    [sym_int] = ACTIONS(2839),
    [sym_xint] = ACTIONS(2841),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2841),
    [sym__newline] = ACTIONS(2841),
  },
  [2230] = {
    [sym_block_comment] = STATE(2230),
    [sym_compiler_directive_decl] = STATE(2230),
    [sym_fsi_directive_decl] = STATE(2230),
    [sym_preproc_line] = STATE(2230),
    [sym_identifier] = ACTIONS(2851),
    [anon_sym_EQ] = ACTIONS(2853),
    [anon_sym_COLON] = ACTIONS(2851),
    [anon_sym_return] = ACTIONS(2851),
    [anon_sym_do] = ACTIONS(2851),
    [anon_sym_let] = ACTIONS(2851),
    [anon_sym_let_BANG] = ACTIONS(2853),
    [anon_sym_LPAREN] = ACTIONS(2851),
    [anon_sym_COMMA] = ACTIONS(2853),
    [anon_sym_null] = ACTIONS(2851),
    [anon_sym_QMARK] = ACTIONS(2851),
    [anon_sym_COLON_QMARK] = ACTIONS(2851),
    [anon_sym_COLON_COLON] = ACTIONS(2853),
    [anon_sym_AMP] = ACTIONS(2851),
    [anon_sym_LBRACK] = ACTIONS(2851),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2853),
    [anon_sym_LBRACE] = ACTIONS(2851),
    [anon_sym_LT_AT] = ACTIONS(2851),
    [anon_sym_LT_AT_AT] = ACTIONS(2851),
    [anon_sym_DOT] = ACTIONS(2851),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2853),
    [anon_sym_new] = ACTIONS(2851),
    [anon_sym_return_BANG] = ACTIONS(2853),
    [anon_sym_yield] = ACTIONS(2851),
    [anon_sym_yield_BANG] = ACTIONS(2853),
    [anon_sym_lazy] = ACTIONS(2851),
    [anon_sym_assert] = ACTIONS(2851),
    [anon_sym_upcast] = ACTIONS(2851),
    [anon_sym_downcast] = ACTIONS(2851),
    [anon_sym_COLON_GT] = ACTIONS(2853),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2853),
    [anon_sym_for] = ACTIONS(2851),
    [anon_sym_while] = ACTIONS(2851),
    [anon_sym_if] = ACTIONS(2851),
    [anon_sym_fun] = ACTIONS(2851),
    [anon_sym_try] = ACTIONS(2851),
    [anon_sym_match] = ACTIONS(2851),
    [anon_sym_match_BANG] = ACTIONS(2853),
    [anon_sym_function] = ACTIONS(2851),
    [anon_sym_LT_DASH] = ACTIONS(2851),
    [anon_sym_DOT_LBRACK] = ACTIONS(2853),
    [anon_sym_LT] = ACTIONS(2853),
    [anon_sym_use] = ACTIONS(2851),
    [anon_sym_use_BANG] = ACTIONS(2853),
    [anon_sym_do_BANG] = ACTIONS(2853),
    [anon_sym_DOT_DOT] = ACTIONS(2853),
    [anon_sym_begin] = ACTIONS(2851),
    [anon_sym_LPAREN2] = ACTIONS(2851),
    [anon_sym_or] = ACTIONS(2851),
    [aux_sym_char_token1] = ACTIONS(2853),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2851),
    [anon_sym_DQUOTE] = ACTIONS(2851),
    [anon_sym_AT_DQUOTE] = ACTIONS(2853),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2853),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2853),
    [sym_bool] = ACTIONS(2851),
    [sym_unit] = ACTIONS(2853),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2851),
    [sym_op_identifier] = ACTIONS(2851),
    [anon_sym_PLUS] = ACTIONS(2851),
    [anon_sym_DASH] = ACTIONS(2851),
    [anon_sym_PLUS_DOT] = ACTIONS(2851),
    [anon_sym_DASH_DOT] = ACTIONS(2851),
    [anon_sym_PERCENT] = ACTIONS(2851),
    [anon_sym_AMP_AMP] = ACTIONS(2851),
    [anon_sym_TILDE] = ACTIONS(2853),
    [aux_sym_prefix_op_token1] = ACTIONS(2851),
    [aux_sym_infix_op_token1] = ACTIONS(2853),
    [aux_sym_infix_op_token2] = ACTIONS(2851),
    [anon_sym_PIPE_PIPE] = ACTIONS(2851),
    [anon_sym_BANG_EQ] = ACTIONS(2851),
    [anon_sym_COLON_EQ] = ACTIONS(2853),
    [anon_sym_DOLLAR] = ACTIONS(2851),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2851),
    [sym_int] = ACTIONS(2851),
    [sym_xint] = ACTIONS(2853),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2853),
    [sym__newline] = ACTIONS(2853),
  },
  [2231] = {
    [sym_block_comment] = STATE(2231),
    [sym_compiler_directive_decl] = STATE(2231),
    [sym_fsi_directive_decl] = STATE(2231),
    [sym_preproc_line] = STATE(2231),
    [sym_identifier] = ACTIONS(3087),
    [anon_sym_EQ] = ACTIONS(3089),
    [anon_sym_COLON] = ACTIONS(3087),
    [anon_sym_return] = ACTIONS(3087),
    [anon_sym_do] = ACTIONS(3087),
    [anon_sym_let] = ACTIONS(3087),
    [anon_sym_let_BANG] = ACTIONS(3089),
    [anon_sym_LPAREN] = ACTIONS(3087),
    [anon_sym_COMMA] = ACTIONS(3089),
    [anon_sym_null] = ACTIONS(3087),
    [anon_sym_QMARK] = ACTIONS(3087),
    [anon_sym_COLON_QMARK] = ACTIONS(3087),
    [anon_sym_COLON_COLON] = ACTIONS(3089),
    [anon_sym_AMP] = ACTIONS(3087),
    [anon_sym_LBRACK] = ACTIONS(3087),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3089),
    [anon_sym_LBRACE] = ACTIONS(3087),
    [anon_sym_LT_AT] = ACTIONS(3087),
    [anon_sym_LT_AT_AT] = ACTIONS(3087),
    [anon_sym_DOT] = ACTIONS(3087),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3089),
    [anon_sym_new] = ACTIONS(3087),
    [anon_sym_return_BANG] = ACTIONS(3089),
    [anon_sym_yield] = ACTIONS(3087),
    [anon_sym_yield_BANG] = ACTIONS(3089),
    [anon_sym_lazy] = ACTIONS(3087),
    [anon_sym_assert] = ACTIONS(3087),
    [anon_sym_upcast] = ACTIONS(3087),
    [anon_sym_downcast] = ACTIONS(3087),
    [anon_sym_COLON_GT] = ACTIONS(3089),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3089),
    [anon_sym_for] = ACTIONS(3087),
    [anon_sym_while] = ACTIONS(3087),
    [anon_sym_if] = ACTIONS(3087),
    [anon_sym_fun] = ACTIONS(3087),
    [anon_sym_try] = ACTIONS(3087),
    [anon_sym_match] = ACTIONS(3087),
    [anon_sym_match_BANG] = ACTIONS(3089),
    [anon_sym_function] = ACTIONS(3087),
    [anon_sym_LT_DASH] = ACTIONS(3087),
    [anon_sym_DOT_LBRACK] = ACTIONS(3089),
    [anon_sym_LT] = ACTIONS(3089),
    [anon_sym_GT] = ACTIONS(3087),
    [anon_sym_use] = ACTIONS(3087),
    [anon_sym_use_BANG] = ACTIONS(3089),
    [anon_sym_do_BANG] = ACTIONS(3089),
    [anon_sym_begin] = ACTIONS(3087),
    [anon_sym_LPAREN2] = ACTIONS(3087),
    [anon_sym_or] = ACTIONS(3087),
    [aux_sym_char_token1] = ACTIONS(3089),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3087),
    [anon_sym_DQUOTE] = ACTIONS(3087),
    [anon_sym_AT_DQUOTE] = ACTIONS(3089),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3089),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3089),
    [sym_bool] = ACTIONS(3087),
    [sym_unit] = ACTIONS(3089),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3087),
    [sym_op_identifier] = ACTIONS(3087),
    [anon_sym_PLUS] = ACTIONS(3087),
    [anon_sym_DASH] = ACTIONS(3087),
    [anon_sym_PLUS_DOT] = ACTIONS(3087),
    [anon_sym_DASH_DOT] = ACTIONS(3087),
    [anon_sym_PERCENT] = ACTIONS(3087),
    [anon_sym_AMP_AMP] = ACTIONS(3087),
    [anon_sym_TILDE] = ACTIONS(3089),
    [aux_sym_prefix_op_token1] = ACTIONS(3087),
    [aux_sym_infix_op_token1] = ACTIONS(3089),
    [aux_sym_infix_op_token2] = ACTIONS(3087),
    [anon_sym_PIPE_PIPE] = ACTIONS(3087),
    [anon_sym_BANG_EQ] = ACTIONS(3087),
    [anon_sym_COLON_EQ] = ACTIONS(3089),
    [anon_sym_DOLLAR] = ACTIONS(3087),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3087),
    [sym_int] = ACTIONS(3087),
    [sym_xint] = ACTIONS(3089),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3089),
    [sym__newline] = ACTIONS(3089),
  },
  [2232] = {
    [sym_block_comment] = STATE(2232),
    [sym_compiler_directive_decl] = STATE(2232),
    [sym_fsi_directive_decl] = STATE(2232),
    [sym_preproc_line] = STATE(2232),
    [sym_identifier] = ACTIONS(2867),
    [anon_sym_EQ] = ACTIONS(2869),
    [anon_sym_COLON] = ACTIONS(2867),
    [anon_sym_return] = ACTIONS(2867),
    [anon_sym_do] = ACTIONS(2867),
    [anon_sym_let] = ACTIONS(2867),
    [anon_sym_let_BANG] = ACTIONS(2869),
    [anon_sym_LPAREN] = ACTIONS(2867),
    [anon_sym_COMMA] = ACTIONS(2869),
    [anon_sym_null] = ACTIONS(2867),
    [anon_sym_QMARK] = ACTIONS(2867),
    [anon_sym_COLON_QMARK] = ACTIONS(2867),
    [anon_sym_COLON_COLON] = ACTIONS(2869),
    [anon_sym_AMP] = ACTIONS(2867),
    [anon_sym_LBRACK] = ACTIONS(2867),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2869),
    [anon_sym_LBRACE] = ACTIONS(2867),
    [anon_sym_LT_AT] = ACTIONS(2867),
    [anon_sym_LT_AT_AT] = ACTIONS(2867),
    [anon_sym_DOT] = ACTIONS(4254),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2869),
    [anon_sym_new] = ACTIONS(2867),
    [anon_sym_return_BANG] = ACTIONS(2869),
    [anon_sym_yield] = ACTIONS(2867),
    [anon_sym_yield_BANG] = ACTIONS(2869),
    [anon_sym_lazy] = ACTIONS(2867),
    [anon_sym_assert] = ACTIONS(2867),
    [anon_sym_upcast] = ACTIONS(2867),
    [anon_sym_downcast] = ACTIONS(2867),
    [anon_sym_COLON_GT] = ACTIONS(2869),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2869),
    [anon_sym_for] = ACTIONS(2867),
    [anon_sym_while] = ACTIONS(2867),
    [anon_sym_if] = ACTIONS(2867),
    [anon_sym_fun] = ACTIONS(2867),
    [anon_sym_try] = ACTIONS(2867),
    [anon_sym_match] = ACTIONS(2867),
    [anon_sym_match_BANG] = ACTIONS(2869),
    [anon_sym_function] = ACTIONS(2867),
    [anon_sym_LT_DASH] = ACTIONS(2867),
    [anon_sym_DOT_LBRACK] = ACTIONS(2869),
    [anon_sym_LT] = ACTIONS(2869),
    [anon_sym_use] = ACTIONS(2867),
    [anon_sym_use_BANG] = ACTIONS(2869),
    [anon_sym_do_BANG] = ACTIONS(2869),
    [anon_sym_DOT_DOT] = ACTIONS(2869),
    [anon_sym_begin] = ACTIONS(2867),
    [anon_sym_LPAREN2] = ACTIONS(2867),
    [anon_sym_or] = ACTIONS(2867),
    [aux_sym_char_token1] = ACTIONS(2869),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2867),
    [anon_sym_DQUOTE] = ACTIONS(2867),
    [anon_sym_AT_DQUOTE] = ACTIONS(2869),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2869),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2869),
    [sym_bool] = ACTIONS(2867),
    [sym_unit] = ACTIONS(2869),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2867),
    [sym_op_identifier] = ACTIONS(2867),
    [anon_sym_PLUS] = ACTIONS(2867),
    [anon_sym_DASH] = ACTIONS(2867),
    [anon_sym_PLUS_DOT] = ACTIONS(2867),
    [anon_sym_DASH_DOT] = ACTIONS(2867),
    [anon_sym_PERCENT] = ACTIONS(2867),
    [anon_sym_AMP_AMP] = ACTIONS(2867),
    [anon_sym_TILDE] = ACTIONS(2869),
    [aux_sym_prefix_op_token1] = ACTIONS(2867),
    [aux_sym_infix_op_token1] = ACTIONS(2869),
    [aux_sym_infix_op_token2] = ACTIONS(2867),
    [anon_sym_PIPE_PIPE] = ACTIONS(2867),
    [anon_sym_BANG_EQ] = ACTIONS(2867),
    [anon_sym_COLON_EQ] = ACTIONS(2869),
    [anon_sym_DOLLAR] = ACTIONS(2867),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2867),
    [sym_int] = ACTIONS(2867),
    [sym_xint] = ACTIONS(2869),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2869),
    [sym__newline] = ACTIONS(2869),
  },
  [2233] = {
    [sym_block_comment] = STATE(2233),
    [sym_compiler_directive_decl] = STATE(2233),
    [sym_fsi_directive_decl] = STATE(2233),
    [sym_preproc_line] = STATE(2233),
    [sym_identifier] = ACTIONS(2930),
    [anon_sym_EQ] = ACTIONS(2932),
    [anon_sym_COLON] = ACTIONS(2930),
    [anon_sym_return] = ACTIONS(2930),
    [anon_sym_do] = ACTIONS(2930),
    [anon_sym_let] = ACTIONS(2930),
    [anon_sym_let_BANG] = ACTIONS(2932),
    [anon_sym_LPAREN] = ACTIONS(2930),
    [anon_sym_COMMA] = ACTIONS(2932),
    [anon_sym_null] = ACTIONS(2930),
    [anon_sym_QMARK] = ACTIONS(2930),
    [anon_sym_COLON_QMARK] = ACTIONS(2930),
    [anon_sym_COLON_COLON] = ACTIONS(2932),
    [anon_sym_AMP] = ACTIONS(2930),
    [anon_sym_LBRACK] = ACTIONS(2930),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2932),
    [anon_sym_LBRACE] = ACTIONS(2930),
    [anon_sym_LT_AT] = ACTIONS(2930),
    [anon_sym_LT_AT_AT] = ACTIONS(2930),
    [anon_sym_DOT] = ACTIONS(2930),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2932),
    [anon_sym_new] = ACTIONS(2930),
    [anon_sym_return_BANG] = ACTIONS(2932),
    [anon_sym_yield] = ACTIONS(2930),
    [anon_sym_yield_BANG] = ACTIONS(2932),
    [anon_sym_lazy] = ACTIONS(2930),
    [anon_sym_assert] = ACTIONS(2930),
    [anon_sym_upcast] = ACTIONS(2930),
    [anon_sym_downcast] = ACTIONS(2930),
    [anon_sym_COLON_GT] = ACTIONS(2932),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2932),
    [anon_sym_for] = ACTIONS(2930),
    [anon_sym_while] = ACTIONS(2930),
    [anon_sym_if] = ACTIONS(2930),
    [anon_sym_fun] = ACTIONS(2930),
    [anon_sym_try] = ACTIONS(2930),
    [anon_sym_match] = ACTIONS(2930),
    [anon_sym_match_BANG] = ACTIONS(2932),
    [anon_sym_function] = ACTIONS(2930),
    [anon_sym_LT_DASH] = ACTIONS(2930),
    [anon_sym_DOT_LBRACK] = ACTIONS(2932),
    [anon_sym_LT] = ACTIONS(2932),
    [anon_sym_GT] = ACTIONS(2930),
    [anon_sym_use] = ACTIONS(2930),
    [anon_sym_use_BANG] = ACTIONS(2932),
    [anon_sym_do_BANG] = ACTIONS(2932),
    [anon_sym_begin] = ACTIONS(2930),
    [anon_sym_LPAREN2] = ACTIONS(2930),
    [anon_sym_or] = ACTIONS(2930),
    [aux_sym_char_token1] = ACTIONS(2932),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2930),
    [anon_sym_DQUOTE] = ACTIONS(2930),
    [anon_sym_AT_DQUOTE] = ACTIONS(2932),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2932),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2932),
    [sym_bool] = ACTIONS(2930),
    [sym_unit] = ACTIONS(2932),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2930),
    [sym_op_identifier] = ACTIONS(2930),
    [anon_sym_PLUS] = ACTIONS(2930),
    [anon_sym_DASH] = ACTIONS(2930),
    [anon_sym_PLUS_DOT] = ACTIONS(2930),
    [anon_sym_DASH_DOT] = ACTIONS(2930),
    [anon_sym_PERCENT] = ACTIONS(2930),
    [anon_sym_AMP_AMP] = ACTIONS(2930),
    [anon_sym_TILDE] = ACTIONS(2932),
    [aux_sym_prefix_op_token1] = ACTIONS(2930),
    [aux_sym_infix_op_token1] = ACTIONS(2932),
    [aux_sym_infix_op_token2] = ACTIONS(2930),
    [anon_sym_PIPE_PIPE] = ACTIONS(2930),
    [anon_sym_BANG_EQ] = ACTIONS(2930),
    [anon_sym_COLON_EQ] = ACTIONS(2932),
    [anon_sym_DOLLAR] = ACTIONS(2930),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2930),
    [sym_int] = ACTIONS(2930),
    [sym_xint] = ACTIONS(2932),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2932),
    [sym__newline] = ACTIONS(2932),
  },
  [2234] = {
    [sym_block_comment] = STATE(2234),
    [sym_compiler_directive_decl] = STATE(2234),
    [sym_fsi_directive_decl] = STATE(2234),
    [sym_preproc_line] = STATE(2234),
    [sym_identifier] = ACTIONS(3115),
    [anon_sym_EQ] = ACTIONS(3117),
    [anon_sym_COLON] = ACTIONS(3115),
    [anon_sym_return] = ACTIONS(3115),
    [anon_sym_do] = ACTIONS(3115),
    [anon_sym_let] = ACTIONS(3115),
    [anon_sym_let_BANG] = ACTIONS(3117),
    [anon_sym_LPAREN] = ACTIONS(3115),
    [anon_sym_COMMA] = ACTIONS(3117),
    [anon_sym_null] = ACTIONS(3115),
    [anon_sym_QMARK] = ACTIONS(3115),
    [anon_sym_COLON_QMARK] = ACTIONS(3115),
    [anon_sym_COLON_COLON] = ACTIONS(3117),
    [anon_sym_AMP] = ACTIONS(3115),
    [anon_sym_LBRACK] = ACTIONS(3115),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3117),
    [anon_sym_LBRACE] = ACTIONS(3115),
    [anon_sym_LT_AT] = ACTIONS(3115),
    [anon_sym_LT_AT_AT] = ACTIONS(3115),
    [anon_sym_AT_AT_GT] = ACTIONS(3115),
    [anon_sym_DOT] = ACTIONS(3115),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3117),
    [anon_sym_new] = ACTIONS(3115),
    [anon_sym_return_BANG] = ACTIONS(3117),
    [anon_sym_yield] = ACTIONS(3115),
    [anon_sym_yield_BANG] = ACTIONS(3117),
    [anon_sym_lazy] = ACTIONS(3115),
    [anon_sym_assert] = ACTIONS(3115),
    [anon_sym_upcast] = ACTIONS(3115),
    [anon_sym_downcast] = ACTIONS(3115),
    [anon_sym_COLON_GT] = ACTIONS(3117),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3117),
    [anon_sym_for] = ACTIONS(3115),
    [anon_sym_while] = ACTIONS(3115),
    [anon_sym_if] = ACTIONS(3115),
    [anon_sym_fun] = ACTIONS(3115),
    [anon_sym_try] = ACTIONS(3115),
    [anon_sym_match] = ACTIONS(3115),
    [anon_sym_match_BANG] = ACTIONS(3117),
    [anon_sym_function] = ACTIONS(3115),
    [anon_sym_LT_DASH] = ACTIONS(3115),
    [anon_sym_DOT_LBRACK] = ACTIONS(3117),
    [anon_sym_LT] = ACTIONS(3117),
    [anon_sym_use] = ACTIONS(3115),
    [anon_sym_use_BANG] = ACTIONS(3117),
    [anon_sym_do_BANG] = ACTIONS(3117),
    [anon_sym_begin] = ACTIONS(3115),
    [anon_sym_LPAREN2] = ACTIONS(3115),
    [anon_sym_or] = ACTIONS(3115),
    [aux_sym_char_token1] = ACTIONS(3117),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3115),
    [anon_sym_DQUOTE] = ACTIONS(3115),
    [anon_sym_AT_DQUOTE] = ACTIONS(3117),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3117),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3117),
    [sym_bool] = ACTIONS(3115),
    [sym_unit] = ACTIONS(3117),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3115),
    [sym_op_identifier] = ACTIONS(3115),
    [anon_sym_PLUS] = ACTIONS(3115),
    [anon_sym_DASH] = ACTIONS(3115),
    [anon_sym_PLUS_DOT] = ACTIONS(3115),
    [anon_sym_DASH_DOT] = ACTIONS(3115),
    [anon_sym_PERCENT] = ACTIONS(3115),
    [anon_sym_AMP_AMP] = ACTIONS(3115),
    [anon_sym_TILDE] = ACTIONS(3117),
    [aux_sym_prefix_op_token1] = ACTIONS(3115),
    [aux_sym_infix_op_token1] = ACTIONS(3117),
    [aux_sym_infix_op_token2] = ACTIONS(3115),
    [anon_sym_PIPE_PIPE] = ACTIONS(3115),
    [anon_sym_BANG_EQ] = ACTIONS(3115),
    [anon_sym_COLON_EQ] = ACTIONS(3117),
    [anon_sym_DOLLAR] = ACTIONS(3115),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3115),
    [sym_int] = ACTIONS(3115),
    [sym_xint] = ACTIONS(3117),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3117),
    [sym__newline] = ACTIONS(3117),
  },
  [2235] = {
    [sym_block_comment] = STATE(2235),
    [sym_compiler_directive_decl] = STATE(2235),
    [sym_fsi_directive_decl] = STATE(2235),
    [sym_preproc_line] = STATE(2235),
    [sym_identifier] = ACTIONS(3111),
    [anon_sym_EQ] = ACTIONS(3113),
    [anon_sym_COLON] = ACTIONS(3111),
    [anon_sym_return] = ACTIONS(3111),
    [anon_sym_do] = ACTIONS(3111),
    [anon_sym_let] = ACTIONS(3111),
    [anon_sym_let_BANG] = ACTIONS(3113),
    [anon_sym_LPAREN] = ACTIONS(3111),
    [anon_sym_COMMA] = ACTIONS(3113),
    [anon_sym_null] = ACTIONS(3111),
    [anon_sym_QMARK] = ACTIONS(3111),
    [anon_sym_COLON_QMARK] = ACTIONS(3111),
    [anon_sym_COLON_COLON] = ACTIONS(3113),
    [anon_sym_AMP] = ACTIONS(3111),
    [anon_sym_LBRACK] = ACTIONS(3111),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3113),
    [anon_sym_LBRACE] = ACTIONS(3111),
    [anon_sym_LT_AT] = ACTIONS(3111),
    [anon_sym_LT_AT_AT] = ACTIONS(3111),
    [anon_sym_DOT] = ACTIONS(3111),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3113),
    [anon_sym_new] = ACTIONS(3111),
    [anon_sym_return_BANG] = ACTIONS(3113),
    [anon_sym_yield] = ACTIONS(3111),
    [anon_sym_yield_BANG] = ACTIONS(3113),
    [anon_sym_lazy] = ACTIONS(3111),
    [anon_sym_assert] = ACTIONS(3111),
    [anon_sym_upcast] = ACTIONS(3111),
    [anon_sym_downcast] = ACTIONS(3111),
    [anon_sym_COLON_GT] = ACTIONS(3113),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3113),
    [anon_sym_for] = ACTIONS(3111),
    [anon_sym_while] = ACTIONS(3111),
    [anon_sym_if] = ACTIONS(3111),
    [anon_sym_fun] = ACTIONS(3111),
    [anon_sym_try] = ACTIONS(3111),
    [anon_sym_match] = ACTIONS(3111),
    [anon_sym_match_BANG] = ACTIONS(3113),
    [anon_sym_function] = ACTIONS(3111),
    [anon_sym_LT_DASH] = ACTIONS(3111),
    [anon_sym_DOT_LBRACK] = ACTIONS(3113),
    [anon_sym_LT] = ACTIONS(3113),
    [anon_sym_GT] = ACTIONS(3111),
    [anon_sym_use] = ACTIONS(3111),
    [anon_sym_use_BANG] = ACTIONS(3113),
    [anon_sym_do_BANG] = ACTIONS(3113),
    [anon_sym_begin] = ACTIONS(3111),
    [anon_sym_LPAREN2] = ACTIONS(3111),
    [anon_sym_or] = ACTIONS(3111),
    [aux_sym_char_token1] = ACTIONS(3113),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3111),
    [anon_sym_DQUOTE] = ACTIONS(3111),
    [anon_sym_AT_DQUOTE] = ACTIONS(3113),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3113),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3113),
    [sym_bool] = ACTIONS(3111),
    [sym_unit] = ACTIONS(3113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3111),
    [sym_op_identifier] = ACTIONS(3111),
    [anon_sym_PLUS] = ACTIONS(3111),
    [anon_sym_DASH] = ACTIONS(3111),
    [anon_sym_PLUS_DOT] = ACTIONS(3111),
    [anon_sym_DASH_DOT] = ACTIONS(3111),
    [anon_sym_PERCENT] = ACTIONS(3111),
    [anon_sym_AMP_AMP] = ACTIONS(3111),
    [anon_sym_TILDE] = ACTIONS(3113),
    [aux_sym_prefix_op_token1] = ACTIONS(3111),
    [aux_sym_infix_op_token1] = ACTIONS(3113),
    [aux_sym_infix_op_token2] = ACTIONS(3111),
    [anon_sym_PIPE_PIPE] = ACTIONS(3111),
    [anon_sym_BANG_EQ] = ACTIONS(3111),
    [anon_sym_COLON_EQ] = ACTIONS(3113),
    [anon_sym_DOLLAR] = ACTIONS(3111),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3111),
    [sym_int] = ACTIONS(3111),
    [sym_xint] = ACTIONS(3113),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3113),
    [sym__newline] = ACTIONS(3113),
  },
  [2236] = {
    [sym_block_comment] = STATE(2236),
    [sym_compiler_directive_decl] = STATE(2236),
    [sym_fsi_directive_decl] = STATE(2236),
    [sym_preproc_line] = STATE(2236),
    [sym_identifier] = ACTIONS(2906),
    [anon_sym_EQ] = ACTIONS(2908),
    [anon_sym_COLON] = ACTIONS(2906),
    [anon_sym_return] = ACTIONS(2906),
    [anon_sym_do] = ACTIONS(2906),
    [anon_sym_let] = ACTIONS(2906),
    [anon_sym_let_BANG] = ACTIONS(2908),
    [anon_sym_LPAREN] = ACTIONS(2906),
    [anon_sym_COMMA] = ACTIONS(2908),
    [anon_sym_null] = ACTIONS(2906),
    [anon_sym_QMARK] = ACTIONS(2906),
    [anon_sym_COLON_QMARK] = ACTIONS(2906),
    [anon_sym_COLON_COLON] = ACTIONS(2908),
    [anon_sym_AMP] = ACTIONS(2906),
    [anon_sym_LBRACK] = ACTIONS(2906),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2908),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_LT_AT] = ACTIONS(2906),
    [anon_sym_LT_AT_AT] = ACTIONS(2906),
    [anon_sym_DOT] = ACTIONS(2906),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2908),
    [anon_sym_new] = ACTIONS(2906),
    [anon_sym_return_BANG] = ACTIONS(2908),
    [anon_sym_yield] = ACTIONS(2906),
    [anon_sym_yield_BANG] = ACTIONS(2908),
    [anon_sym_lazy] = ACTIONS(2906),
    [anon_sym_assert] = ACTIONS(2906),
    [anon_sym_upcast] = ACTIONS(2906),
    [anon_sym_downcast] = ACTIONS(2906),
    [anon_sym_COLON_GT] = ACTIONS(2908),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2908),
    [anon_sym_for] = ACTIONS(2906),
    [anon_sym_while] = ACTIONS(2906),
    [anon_sym_if] = ACTIONS(2906),
    [anon_sym_fun] = ACTIONS(2906),
    [anon_sym_try] = ACTIONS(2906),
    [anon_sym_match] = ACTIONS(2906),
    [anon_sym_match_BANG] = ACTIONS(2908),
    [anon_sym_function] = ACTIONS(2906),
    [anon_sym_LT_DASH] = ACTIONS(2906),
    [anon_sym_DOT_LBRACK] = ACTIONS(2908),
    [anon_sym_LT] = ACTIONS(2908),
    [anon_sym_GT] = ACTIONS(2906),
    [anon_sym_use] = ACTIONS(2906),
    [anon_sym_use_BANG] = ACTIONS(2908),
    [anon_sym_do_BANG] = ACTIONS(2908),
    [anon_sym_begin] = ACTIONS(2906),
    [anon_sym_LPAREN2] = ACTIONS(2906),
    [anon_sym_or] = ACTIONS(2906),
    [aux_sym_char_token1] = ACTIONS(2908),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2906),
    [anon_sym_DQUOTE] = ACTIONS(2906),
    [anon_sym_AT_DQUOTE] = ACTIONS(2908),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2908),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2908),
    [sym_bool] = ACTIONS(2906),
    [sym_unit] = ACTIONS(2908),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2906),
    [sym_op_identifier] = ACTIONS(2906),
    [anon_sym_PLUS] = ACTIONS(2906),
    [anon_sym_DASH] = ACTIONS(2906),
    [anon_sym_PLUS_DOT] = ACTIONS(2906),
    [anon_sym_DASH_DOT] = ACTIONS(2906),
    [anon_sym_PERCENT] = ACTIONS(2906),
    [anon_sym_AMP_AMP] = ACTIONS(2906),
    [anon_sym_TILDE] = ACTIONS(2908),
    [aux_sym_prefix_op_token1] = ACTIONS(2906),
    [aux_sym_infix_op_token1] = ACTIONS(2908),
    [aux_sym_infix_op_token2] = ACTIONS(2906),
    [anon_sym_PIPE_PIPE] = ACTIONS(2906),
    [anon_sym_BANG_EQ] = ACTIONS(2906),
    [anon_sym_COLON_EQ] = ACTIONS(2908),
    [anon_sym_DOLLAR] = ACTIONS(2906),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2906),
    [sym_int] = ACTIONS(2906),
    [sym_xint] = ACTIONS(2908),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2908),
    [sym__newline] = ACTIONS(2908),
  },
  [2237] = {
    [sym_block_comment] = STATE(2237),
    [sym_compiler_directive_decl] = STATE(2237),
    [sym_fsi_directive_decl] = STATE(2237),
    [sym_preproc_line] = STATE(2237),
    [sym_identifier] = ACTIONS(2930),
    [anon_sym_EQ] = ACTIONS(2932),
    [anon_sym_COLON] = ACTIONS(2930),
    [anon_sym_return] = ACTIONS(2930),
    [anon_sym_do] = ACTIONS(2930),
    [anon_sym_let] = ACTIONS(2930),
    [anon_sym_let_BANG] = ACTIONS(2932),
    [anon_sym_LPAREN] = ACTIONS(2930),
    [anon_sym_COMMA] = ACTIONS(2932),
    [anon_sym_null] = ACTIONS(2930),
    [anon_sym_QMARK] = ACTIONS(2930),
    [anon_sym_COLON_QMARK] = ACTIONS(2930),
    [anon_sym_COLON_COLON] = ACTIONS(2932),
    [anon_sym_AMP] = ACTIONS(2930),
    [anon_sym_LBRACK] = ACTIONS(2930),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2932),
    [anon_sym_LBRACE] = ACTIONS(2930),
    [anon_sym_LT_AT] = ACTIONS(2930),
    [anon_sym_AT_GT] = ACTIONS(2930),
    [anon_sym_LT_AT_AT] = ACTIONS(2930),
    [anon_sym_DOT] = ACTIONS(2930),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2932),
    [anon_sym_new] = ACTIONS(2930),
    [anon_sym_return_BANG] = ACTIONS(2932),
    [anon_sym_yield] = ACTIONS(2930),
    [anon_sym_yield_BANG] = ACTIONS(2932),
    [anon_sym_lazy] = ACTIONS(2930),
    [anon_sym_assert] = ACTIONS(2930),
    [anon_sym_upcast] = ACTIONS(2930),
    [anon_sym_downcast] = ACTIONS(2930),
    [anon_sym_COLON_GT] = ACTIONS(2932),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2932),
    [anon_sym_for] = ACTIONS(2930),
    [anon_sym_while] = ACTIONS(2930),
    [anon_sym_if] = ACTIONS(2930),
    [anon_sym_fun] = ACTIONS(2930),
    [anon_sym_try] = ACTIONS(2930),
    [anon_sym_match] = ACTIONS(2930),
    [anon_sym_match_BANG] = ACTIONS(2932),
    [anon_sym_function] = ACTIONS(2930),
    [anon_sym_LT_DASH] = ACTIONS(2930),
    [anon_sym_DOT_LBRACK] = ACTIONS(2932),
    [anon_sym_LT] = ACTIONS(2932),
    [anon_sym_use] = ACTIONS(2930),
    [anon_sym_use_BANG] = ACTIONS(2932),
    [anon_sym_do_BANG] = ACTIONS(2932),
    [anon_sym_begin] = ACTIONS(2930),
    [anon_sym_LPAREN2] = ACTIONS(2930),
    [anon_sym_or] = ACTIONS(2930),
    [aux_sym_char_token1] = ACTIONS(2932),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2930),
    [anon_sym_DQUOTE] = ACTIONS(2930),
    [anon_sym_AT_DQUOTE] = ACTIONS(2932),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2932),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2932),
    [sym_bool] = ACTIONS(2930),
    [sym_unit] = ACTIONS(2932),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2930),
    [sym_op_identifier] = ACTIONS(2930),
    [anon_sym_PLUS] = ACTIONS(2930),
    [anon_sym_DASH] = ACTIONS(2930),
    [anon_sym_PLUS_DOT] = ACTIONS(2930),
    [anon_sym_DASH_DOT] = ACTIONS(2930),
    [anon_sym_PERCENT] = ACTIONS(2930),
    [anon_sym_AMP_AMP] = ACTIONS(2930),
    [anon_sym_TILDE] = ACTIONS(2932),
    [aux_sym_prefix_op_token1] = ACTIONS(2930),
    [aux_sym_infix_op_token1] = ACTIONS(2932),
    [aux_sym_infix_op_token2] = ACTIONS(2930),
    [anon_sym_PIPE_PIPE] = ACTIONS(2930),
    [anon_sym_BANG_EQ] = ACTIONS(2930),
    [anon_sym_COLON_EQ] = ACTIONS(2932),
    [anon_sym_DOLLAR] = ACTIONS(2930),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2930),
    [sym_int] = ACTIONS(2930),
    [sym_xint] = ACTIONS(2932),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2932),
    [sym__newline] = ACTIONS(2932),
  },
  [2238] = {
    [sym_block_comment] = STATE(2238),
    [sym_compiler_directive_decl] = STATE(2238),
    [sym_fsi_directive_decl] = STATE(2238),
    [sym_preproc_line] = STATE(2238),
    [sym_identifier] = ACTIONS(2902),
    [anon_sym_EQ] = ACTIONS(2904),
    [anon_sym_COLON] = ACTIONS(2902),
    [anon_sym_return] = ACTIONS(2902),
    [anon_sym_do] = ACTIONS(2902),
    [anon_sym_let] = ACTIONS(2902),
    [anon_sym_let_BANG] = ACTIONS(2904),
    [anon_sym_LPAREN] = ACTIONS(2902),
    [anon_sym_COMMA] = ACTIONS(2904),
    [anon_sym_null] = ACTIONS(2902),
    [anon_sym_QMARK] = ACTIONS(2902),
    [anon_sym_COLON_QMARK] = ACTIONS(2902),
    [anon_sym_COLON_COLON] = ACTIONS(2904),
    [anon_sym_AMP] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2902),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2902),
    [anon_sym_LT_AT] = ACTIONS(2902),
    [anon_sym_LT_AT_AT] = ACTIONS(2902),
    [anon_sym_DOT] = ACTIONS(2902),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2904),
    [anon_sym_new] = ACTIONS(2902),
    [anon_sym_return_BANG] = ACTIONS(2904),
    [anon_sym_yield] = ACTIONS(2902),
    [anon_sym_yield_BANG] = ACTIONS(2904),
    [anon_sym_lazy] = ACTIONS(2902),
    [anon_sym_assert] = ACTIONS(2902),
    [anon_sym_upcast] = ACTIONS(2902),
    [anon_sym_downcast] = ACTIONS(2902),
    [anon_sym_COLON_GT] = ACTIONS(2904),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2904),
    [anon_sym_for] = ACTIONS(2902),
    [anon_sym_while] = ACTIONS(2902),
    [anon_sym_if] = ACTIONS(2902),
    [anon_sym_fun] = ACTIONS(2902),
    [anon_sym_try] = ACTIONS(2902),
    [anon_sym_match] = ACTIONS(2902),
    [anon_sym_match_BANG] = ACTIONS(2904),
    [anon_sym_function] = ACTIONS(2902),
    [anon_sym_LT_DASH] = ACTIONS(2902),
    [anon_sym_DOT_LBRACK] = ACTIONS(2904),
    [anon_sym_LT] = ACTIONS(2904),
    [anon_sym_GT] = ACTIONS(2902),
    [anon_sym_use] = ACTIONS(2902),
    [anon_sym_use_BANG] = ACTIONS(2904),
    [anon_sym_do_BANG] = ACTIONS(2904),
    [anon_sym_begin] = ACTIONS(2902),
    [anon_sym_LPAREN2] = ACTIONS(2902),
    [anon_sym_or] = ACTIONS(2902),
    [aux_sym_char_token1] = ACTIONS(2904),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2902),
    [anon_sym_DQUOTE] = ACTIONS(2902),
    [anon_sym_AT_DQUOTE] = ACTIONS(2904),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2904),
    [sym_bool] = ACTIONS(2902),
    [sym_unit] = ACTIONS(2904),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2902),
    [sym_op_identifier] = ACTIONS(2902),
    [anon_sym_PLUS] = ACTIONS(2902),
    [anon_sym_DASH] = ACTIONS(2902),
    [anon_sym_PLUS_DOT] = ACTIONS(2902),
    [anon_sym_DASH_DOT] = ACTIONS(2902),
    [anon_sym_PERCENT] = ACTIONS(2902),
    [anon_sym_AMP_AMP] = ACTIONS(2902),
    [anon_sym_TILDE] = ACTIONS(2904),
    [aux_sym_prefix_op_token1] = ACTIONS(2902),
    [aux_sym_infix_op_token1] = ACTIONS(2904),
    [aux_sym_infix_op_token2] = ACTIONS(2902),
    [anon_sym_PIPE_PIPE] = ACTIONS(2902),
    [anon_sym_BANG_EQ] = ACTIONS(2902),
    [anon_sym_COLON_EQ] = ACTIONS(2904),
    [anon_sym_DOLLAR] = ACTIONS(2902),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2902),
    [sym_int] = ACTIONS(2902),
    [sym_xint] = ACTIONS(2904),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2904),
    [sym__newline] = ACTIONS(2904),
  },
  [2239] = {
    [sym_block_comment] = STATE(2239),
    [sym_compiler_directive_decl] = STATE(2239),
    [sym_fsi_directive_decl] = STATE(2239),
    [sym_preproc_line] = STATE(2239),
    [sym_identifier] = ACTIONS(3075),
    [anon_sym_EQ] = ACTIONS(3077),
    [anon_sym_COLON] = ACTIONS(3075),
    [anon_sym_return] = ACTIONS(3075),
    [anon_sym_do] = ACTIONS(3075),
    [anon_sym_let] = ACTIONS(3075),
    [anon_sym_let_BANG] = ACTIONS(3077),
    [anon_sym_LPAREN] = ACTIONS(3075),
    [anon_sym_COMMA] = ACTIONS(3077),
    [anon_sym_null] = ACTIONS(3075),
    [anon_sym_QMARK] = ACTIONS(3075),
    [anon_sym_COLON_QMARK] = ACTIONS(3075),
    [anon_sym_COLON_COLON] = ACTIONS(3077),
    [anon_sym_AMP] = ACTIONS(3075),
    [anon_sym_LBRACK] = ACTIONS(3075),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3077),
    [anon_sym_LBRACE] = ACTIONS(3075),
    [anon_sym_LT_AT] = ACTIONS(3075),
    [anon_sym_LT_AT_AT] = ACTIONS(3075),
    [anon_sym_DOT] = ACTIONS(3075),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3077),
    [anon_sym_new] = ACTIONS(3075),
    [anon_sym_return_BANG] = ACTIONS(3077),
    [anon_sym_yield] = ACTIONS(3075),
    [anon_sym_yield_BANG] = ACTIONS(3077),
    [anon_sym_lazy] = ACTIONS(3075),
    [anon_sym_assert] = ACTIONS(3075),
    [anon_sym_upcast] = ACTIONS(3075),
    [anon_sym_downcast] = ACTIONS(3075),
    [anon_sym_COLON_GT] = ACTIONS(3077),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3077),
    [anon_sym_for] = ACTIONS(3075),
    [anon_sym_while] = ACTIONS(3075),
    [anon_sym_if] = ACTIONS(3075),
    [anon_sym_fun] = ACTIONS(3075),
    [anon_sym_try] = ACTIONS(3075),
    [anon_sym_match] = ACTIONS(3075),
    [anon_sym_match_BANG] = ACTIONS(3077),
    [anon_sym_function] = ACTIONS(3075),
    [anon_sym_LT_DASH] = ACTIONS(3075),
    [anon_sym_DOT_LBRACK] = ACTIONS(3077),
    [anon_sym_LT] = ACTIONS(3077),
    [anon_sym_GT] = ACTIONS(3075),
    [anon_sym_use] = ACTIONS(3075),
    [anon_sym_use_BANG] = ACTIONS(3077),
    [anon_sym_do_BANG] = ACTIONS(3077),
    [anon_sym_begin] = ACTIONS(3075),
    [anon_sym_LPAREN2] = ACTIONS(3075),
    [anon_sym_or] = ACTIONS(3075),
    [aux_sym_char_token1] = ACTIONS(3077),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3075),
    [anon_sym_DQUOTE] = ACTIONS(3075),
    [anon_sym_AT_DQUOTE] = ACTIONS(3077),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3077),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3077),
    [sym_bool] = ACTIONS(3075),
    [sym_unit] = ACTIONS(3077),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3075),
    [sym_op_identifier] = ACTIONS(3075),
    [anon_sym_PLUS] = ACTIONS(3075),
    [anon_sym_DASH] = ACTIONS(3075),
    [anon_sym_PLUS_DOT] = ACTIONS(3075),
    [anon_sym_DASH_DOT] = ACTIONS(3075),
    [anon_sym_PERCENT] = ACTIONS(3075),
    [anon_sym_AMP_AMP] = ACTIONS(3075),
    [anon_sym_TILDE] = ACTIONS(3077),
    [aux_sym_prefix_op_token1] = ACTIONS(3075),
    [aux_sym_infix_op_token1] = ACTIONS(3077),
    [aux_sym_infix_op_token2] = ACTIONS(3075),
    [anon_sym_PIPE_PIPE] = ACTIONS(3075),
    [anon_sym_BANG_EQ] = ACTIONS(3075),
    [anon_sym_COLON_EQ] = ACTIONS(3077),
    [anon_sym_DOLLAR] = ACTIONS(3075),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3075),
    [sym_int] = ACTIONS(3075),
    [sym_xint] = ACTIONS(3077),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3077),
    [sym__newline] = ACTIONS(3077),
  },
  [2240] = {
    [sym_block_comment] = STATE(2240),
    [sym_compiler_directive_decl] = STATE(2240),
    [sym_fsi_directive_decl] = STATE(2240),
    [sym_preproc_line] = STATE(2240),
    [sym_identifier] = ACTIONS(3071),
    [anon_sym_EQ] = ACTIONS(3073),
    [anon_sym_COLON] = ACTIONS(3071),
    [anon_sym_return] = ACTIONS(3071),
    [anon_sym_do] = ACTIONS(3071),
    [anon_sym_let] = ACTIONS(3071),
    [anon_sym_let_BANG] = ACTIONS(3073),
    [anon_sym_LPAREN] = ACTIONS(3071),
    [anon_sym_COMMA] = ACTIONS(3073),
    [anon_sym_null] = ACTIONS(3071),
    [anon_sym_QMARK] = ACTIONS(3071),
    [anon_sym_COLON_QMARK] = ACTIONS(3071),
    [anon_sym_COLON_COLON] = ACTIONS(3073),
    [anon_sym_AMP] = ACTIONS(3071),
    [anon_sym_LBRACK] = ACTIONS(3071),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3073),
    [anon_sym_LBRACE] = ACTIONS(3071),
    [anon_sym_LT_AT] = ACTIONS(3071),
    [anon_sym_LT_AT_AT] = ACTIONS(3071),
    [anon_sym_DOT] = ACTIONS(3071),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3073),
    [anon_sym_new] = ACTIONS(3071),
    [anon_sym_return_BANG] = ACTIONS(3073),
    [anon_sym_yield] = ACTIONS(3071),
    [anon_sym_yield_BANG] = ACTIONS(3073),
    [anon_sym_lazy] = ACTIONS(3071),
    [anon_sym_assert] = ACTIONS(3071),
    [anon_sym_upcast] = ACTIONS(3071),
    [anon_sym_downcast] = ACTIONS(3071),
    [anon_sym_COLON_GT] = ACTIONS(3073),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3073),
    [anon_sym_for] = ACTIONS(3071),
    [anon_sym_while] = ACTIONS(3071),
    [anon_sym_if] = ACTIONS(3071),
    [anon_sym_fun] = ACTIONS(3071),
    [anon_sym_try] = ACTIONS(3071),
    [anon_sym_match] = ACTIONS(3071),
    [anon_sym_match_BANG] = ACTIONS(3073),
    [anon_sym_function] = ACTIONS(3071),
    [anon_sym_LT_DASH] = ACTIONS(3071),
    [anon_sym_DOT_LBRACK] = ACTIONS(3073),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_GT] = ACTIONS(3071),
    [anon_sym_use] = ACTIONS(3071),
    [anon_sym_use_BANG] = ACTIONS(3073),
    [anon_sym_do_BANG] = ACTIONS(3073),
    [anon_sym_begin] = ACTIONS(3071),
    [anon_sym_LPAREN2] = ACTIONS(3071),
    [anon_sym_or] = ACTIONS(3071),
    [aux_sym_char_token1] = ACTIONS(3073),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3071),
    [anon_sym_DQUOTE] = ACTIONS(3071),
    [anon_sym_AT_DQUOTE] = ACTIONS(3073),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3073),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3073),
    [sym_bool] = ACTIONS(3071),
    [sym_unit] = ACTIONS(3073),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3071),
    [sym_op_identifier] = ACTIONS(3071),
    [anon_sym_PLUS] = ACTIONS(3071),
    [anon_sym_DASH] = ACTIONS(3071),
    [anon_sym_PLUS_DOT] = ACTIONS(3071),
    [anon_sym_DASH_DOT] = ACTIONS(3071),
    [anon_sym_PERCENT] = ACTIONS(3071),
    [anon_sym_AMP_AMP] = ACTIONS(3071),
    [anon_sym_TILDE] = ACTIONS(3073),
    [aux_sym_prefix_op_token1] = ACTIONS(3071),
    [aux_sym_infix_op_token1] = ACTIONS(3073),
    [aux_sym_infix_op_token2] = ACTIONS(3071),
    [anon_sym_PIPE_PIPE] = ACTIONS(3071),
    [anon_sym_BANG_EQ] = ACTIONS(3071),
    [anon_sym_COLON_EQ] = ACTIONS(3073),
    [anon_sym_DOLLAR] = ACTIONS(3071),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3071),
    [sym_int] = ACTIONS(3071),
    [sym_xint] = ACTIONS(3073),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3073),
    [sym__newline] = ACTIONS(3073),
  },
  [2241] = {
    [sym_block_comment] = STATE(2241),
    [sym_compiler_directive_decl] = STATE(2241),
    [sym_fsi_directive_decl] = STATE(2241),
    [sym_preproc_line] = STATE(2241),
    [sym_identifier] = ACTIONS(3067),
    [anon_sym_EQ] = ACTIONS(3069),
    [anon_sym_COLON] = ACTIONS(3067),
    [anon_sym_return] = ACTIONS(3067),
    [anon_sym_do] = ACTIONS(3067),
    [anon_sym_let] = ACTIONS(3067),
    [anon_sym_let_BANG] = ACTIONS(3069),
    [anon_sym_LPAREN] = ACTIONS(3067),
    [anon_sym_COMMA] = ACTIONS(3069),
    [anon_sym_null] = ACTIONS(3067),
    [anon_sym_QMARK] = ACTIONS(3067),
    [anon_sym_COLON_QMARK] = ACTIONS(3067),
    [anon_sym_COLON_COLON] = ACTIONS(3069),
    [anon_sym_AMP] = ACTIONS(3067),
    [anon_sym_LBRACK] = ACTIONS(3067),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3069),
    [anon_sym_LBRACE] = ACTIONS(3067),
    [anon_sym_LT_AT] = ACTIONS(3067),
    [anon_sym_LT_AT_AT] = ACTIONS(3067),
    [anon_sym_DOT] = ACTIONS(3067),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3069),
    [anon_sym_new] = ACTIONS(3067),
    [anon_sym_return_BANG] = ACTIONS(3069),
    [anon_sym_yield] = ACTIONS(3067),
    [anon_sym_yield_BANG] = ACTIONS(3069),
    [anon_sym_lazy] = ACTIONS(3067),
    [anon_sym_assert] = ACTIONS(3067),
    [anon_sym_upcast] = ACTIONS(3067),
    [anon_sym_downcast] = ACTIONS(3067),
    [anon_sym_COLON_GT] = ACTIONS(3069),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3069),
    [anon_sym_for] = ACTIONS(3067),
    [anon_sym_while] = ACTIONS(3067),
    [anon_sym_if] = ACTIONS(3067),
    [anon_sym_fun] = ACTIONS(3067),
    [anon_sym_try] = ACTIONS(3067),
    [anon_sym_match] = ACTIONS(3067),
    [anon_sym_match_BANG] = ACTIONS(3069),
    [anon_sym_function] = ACTIONS(3067),
    [anon_sym_LT_DASH] = ACTIONS(3067),
    [anon_sym_DOT_LBRACK] = ACTIONS(3069),
    [anon_sym_LT] = ACTIONS(3069),
    [anon_sym_GT] = ACTIONS(3067),
    [anon_sym_use] = ACTIONS(3067),
    [anon_sym_use_BANG] = ACTIONS(3069),
    [anon_sym_do_BANG] = ACTIONS(3069),
    [anon_sym_begin] = ACTIONS(3067),
    [anon_sym_LPAREN2] = ACTIONS(3067),
    [anon_sym_or] = ACTIONS(3067),
    [aux_sym_char_token1] = ACTIONS(3069),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3067),
    [anon_sym_DQUOTE] = ACTIONS(3067),
    [anon_sym_AT_DQUOTE] = ACTIONS(3069),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3069),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3069),
    [sym_bool] = ACTIONS(3067),
    [sym_unit] = ACTIONS(3069),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3067),
    [sym_op_identifier] = ACTIONS(3067),
    [anon_sym_PLUS] = ACTIONS(3067),
    [anon_sym_DASH] = ACTIONS(3067),
    [anon_sym_PLUS_DOT] = ACTIONS(3067),
    [anon_sym_DASH_DOT] = ACTIONS(3067),
    [anon_sym_PERCENT] = ACTIONS(3067),
    [anon_sym_AMP_AMP] = ACTIONS(3067),
    [anon_sym_TILDE] = ACTIONS(3069),
    [aux_sym_prefix_op_token1] = ACTIONS(3067),
    [aux_sym_infix_op_token1] = ACTIONS(3069),
    [aux_sym_infix_op_token2] = ACTIONS(3067),
    [anon_sym_PIPE_PIPE] = ACTIONS(3067),
    [anon_sym_BANG_EQ] = ACTIONS(3067),
    [anon_sym_COLON_EQ] = ACTIONS(3069),
    [anon_sym_DOLLAR] = ACTIONS(3067),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3067),
    [sym_int] = ACTIONS(3067),
    [sym_xint] = ACTIONS(3069),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3069),
    [sym__newline] = ACTIONS(3069),
  },
  [2242] = {
    [sym_block_comment] = STATE(2242),
    [sym_compiler_directive_decl] = STATE(2242),
    [sym_fsi_directive_decl] = STATE(2242),
    [sym_preproc_line] = STATE(2242),
    [sym_identifier] = ACTIONS(3027),
    [anon_sym_EQ] = ACTIONS(3029),
    [anon_sym_COLON] = ACTIONS(3027),
    [anon_sym_return] = ACTIONS(3027),
    [anon_sym_do] = ACTIONS(3027),
    [anon_sym_let] = ACTIONS(3027),
    [anon_sym_let_BANG] = ACTIONS(3029),
    [anon_sym_LPAREN] = ACTIONS(3027),
    [anon_sym_COMMA] = ACTIONS(3029),
    [anon_sym_null] = ACTIONS(3027),
    [anon_sym_QMARK] = ACTIONS(3027),
    [anon_sym_COLON_QMARK] = ACTIONS(3027),
    [anon_sym_COLON_COLON] = ACTIONS(3029),
    [anon_sym_AMP] = ACTIONS(3027),
    [anon_sym_LBRACK] = ACTIONS(3027),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3027),
    [anon_sym_LT_AT] = ACTIONS(3027),
    [anon_sym_LT_AT_AT] = ACTIONS(3027),
    [anon_sym_DOT] = ACTIONS(3027),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3029),
    [anon_sym_new] = ACTIONS(3027),
    [anon_sym_return_BANG] = ACTIONS(3029),
    [anon_sym_yield] = ACTIONS(3027),
    [anon_sym_yield_BANG] = ACTIONS(3029),
    [anon_sym_lazy] = ACTIONS(3027),
    [anon_sym_assert] = ACTIONS(3027),
    [anon_sym_upcast] = ACTIONS(3027),
    [anon_sym_downcast] = ACTIONS(3027),
    [anon_sym_COLON_GT] = ACTIONS(3029),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3029),
    [anon_sym_for] = ACTIONS(3027),
    [anon_sym_while] = ACTIONS(3027),
    [anon_sym_if] = ACTIONS(3027),
    [anon_sym_fun] = ACTIONS(3027),
    [anon_sym_try] = ACTIONS(3027),
    [anon_sym_match] = ACTIONS(3027),
    [anon_sym_match_BANG] = ACTIONS(3029),
    [anon_sym_function] = ACTIONS(3027),
    [anon_sym_LT_DASH] = ACTIONS(3027),
    [anon_sym_DOT_LBRACK] = ACTIONS(3029),
    [anon_sym_LT] = ACTIONS(3029),
    [anon_sym_use] = ACTIONS(3027),
    [anon_sym_use_BANG] = ACTIONS(3029),
    [anon_sym_do_BANG] = ACTIONS(3029),
    [anon_sym_DOT_DOT] = ACTIONS(3029),
    [anon_sym_begin] = ACTIONS(3027),
    [anon_sym_LPAREN2] = ACTIONS(3027),
    [anon_sym_or] = ACTIONS(3027),
    [aux_sym_char_token1] = ACTIONS(3029),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3027),
    [anon_sym_DQUOTE] = ACTIONS(3027),
    [anon_sym_AT_DQUOTE] = ACTIONS(3029),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3029),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3029),
    [sym_bool] = ACTIONS(3027),
    [sym_unit] = ACTIONS(3029),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3027),
    [sym_op_identifier] = ACTIONS(3027),
    [anon_sym_PLUS] = ACTIONS(3027),
    [anon_sym_DASH] = ACTIONS(3027),
    [anon_sym_PLUS_DOT] = ACTIONS(3027),
    [anon_sym_DASH_DOT] = ACTIONS(3027),
    [anon_sym_PERCENT] = ACTIONS(3027),
    [anon_sym_AMP_AMP] = ACTIONS(3027),
    [anon_sym_TILDE] = ACTIONS(3029),
    [aux_sym_prefix_op_token1] = ACTIONS(3027),
    [aux_sym_infix_op_token1] = ACTIONS(3029),
    [aux_sym_infix_op_token2] = ACTIONS(3027),
    [anon_sym_PIPE_PIPE] = ACTIONS(3027),
    [anon_sym_BANG_EQ] = ACTIONS(3027),
    [anon_sym_COLON_EQ] = ACTIONS(3029),
    [anon_sym_DOLLAR] = ACTIONS(3027),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3027),
    [sym_int] = ACTIONS(3027),
    [sym_xint] = ACTIONS(3029),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3029),
    [sym__newline] = ACTIONS(3029),
  },
  [2243] = {
    [sym_block_comment] = STATE(2243),
    [sym_compiler_directive_decl] = STATE(2243),
    [sym_fsi_directive_decl] = STATE(2243),
    [sym_preproc_line] = STATE(2243),
    [sym_identifier] = ACTIONS(2831),
    [anon_sym_EQ] = ACTIONS(2833),
    [anon_sym_COLON] = ACTIONS(2831),
    [anon_sym_return] = ACTIONS(2831),
    [anon_sym_do] = ACTIONS(2831),
    [anon_sym_let] = ACTIONS(2831),
    [anon_sym_let_BANG] = ACTIONS(2833),
    [anon_sym_LPAREN] = ACTIONS(2831),
    [anon_sym_COMMA] = ACTIONS(2833),
    [anon_sym_null] = ACTIONS(2831),
    [anon_sym_QMARK] = ACTIONS(2831),
    [anon_sym_COLON_QMARK] = ACTIONS(2831),
    [anon_sym_COLON_COLON] = ACTIONS(2833),
    [anon_sym_AMP] = ACTIONS(2831),
    [anon_sym_LBRACK] = ACTIONS(2831),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2833),
    [anon_sym_LBRACE] = ACTIONS(2831),
    [anon_sym_LT_AT] = ACTIONS(2831),
    [anon_sym_LT_AT_AT] = ACTIONS(2831),
    [anon_sym_DOT] = ACTIONS(2831),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2833),
    [anon_sym_new] = ACTIONS(2831),
    [anon_sym_return_BANG] = ACTIONS(2833),
    [anon_sym_yield] = ACTIONS(2831),
    [anon_sym_yield_BANG] = ACTIONS(2833),
    [anon_sym_lazy] = ACTIONS(2831),
    [anon_sym_assert] = ACTIONS(2831),
    [anon_sym_upcast] = ACTIONS(2831),
    [anon_sym_downcast] = ACTIONS(2831),
    [anon_sym_COLON_GT] = ACTIONS(2833),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2833),
    [anon_sym_for] = ACTIONS(2831),
    [anon_sym_while] = ACTIONS(2831),
    [anon_sym_if] = ACTIONS(2831),
    [anon_sym_fun] = ACTIONS(2831),
    [anon_sym_try] = ACTIONS(2831),
    [anon_sym_match] = ACTIONS(2831),
    [anon_sym_match_BANG] = ACTIONS(2833),
    [anon_sym_function] = ACTIONS(2831),
    [anon_sym_LT_DASH] = ACTIONS(2831),
    [anon_sym_DOT_LBRACK] = ACTIONS(2833),
    [anon_sym_LT] = ACTIONS(2833),
    [anon_sym_GT] = ACTIONS(2831),
    [anon_sym_use] = ACTIONS(2831),
    [anon_sym_use_BANG] = ACTIONS(2833),
    [anon_sym_do_BANG] = ACTIONS(2833),
    [anon_sym_begin] = ACTIONS(2831),
    [anon_sym_LPAREN2] = ACTIONS(2831),
    [anon_sym_or] = ACTIONS(2831),
    [aux_sym_char_token1] = ACTIONS(2833),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2831),
    [anon_sym_DQUOTE] = ACTIONS(2831),
    [anon_sym_AT_DQUOTE] = ACTIONS(2833),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2833),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2833),
    [sym_bool] = ACTIONS(2831),
    [sym_unit] = ACTIONS(2833),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2831),
    [sym_op_identifier] = ACTIONS(2831),
    [anon_sym_PLUS] = ACTIONS(2831),
    [anon_sym_DASH] = ACTIONS(2831),
    [anon_sym_PLUS_DOT] = ACTIONS(2831),
    [anon_sym_DASH_DOT] = ACTIONS(2831),
    [anon_sym_PERCENT] = ACTIONS(2831),
    [anon_sym_AMP_AMP] = ACTIONS(2831),
    [anon_sym_TILDE] = ACTIONS(2833),
    [aux_sym_prefix_op_token1] = ACTIONS(2831),
    [aux_sym_infix_op_token1] = ACTIONS(2833),
    [aux_sym_infix_op_token2] = ACTIONS(2831),
    [anon_sym_PIPE_PIPE] = ACTIONS(2831),
    [anon_sym_BANG_EQ] = ACTIONS(2831),
    [anon_sym_COLON_EQ] = ACTIONS(2833),
    [anon_sym_DOLLAR] = ACTIONS(2831),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2831),
    [sym_int] = ACTIONS(2831),
    [sym_xint] = ACTIONS(2833),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2833),
    [sym__newline] = ACTIONS(2833),
  },
  [2244] = {
    [sym_block_comment] = STATE(2244),
    [sym_compiler_directive_decl] = STATE(2244),
    [sym_fsi_directive_decl] = STATE(2244),
    [sym_preproc_line] = STATE(2244),
    [sym_identifier] = ACTIONS(2934),
    [anon_sym_EQ] = ACTIONS(2936),
    [anon_sym_COLON] = ACTIONS(2934),
    [anon_sym_return] = ACTIONS(2934),
    [anon_sym_do] = ACTIONS(2934),
    [anon_sym_let] = ACTIONS(2934),
    [anon_sym_let_BANG] = ACTIONS(2936),
    [anon_sym_LPAREN] = ACTIONS(2934),
    [anon_sym_COMMA] = ACTIONS(2936),
    [anon_sym_null] = ACTIONS(2934),
    [anon_sym_QMARK] = ACTIONS(2934),
    [anon_sym_COLON_QMARK] = ACTIONS(2934),
    [anon_sym_COLON_COLON] = ACTIONS(2936),
    [anon_sym_AMP] = ACTIONS(2934),
    [anon_sym_LBRACK] = ACTIONS(2934),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2936),
    [anon_sym_LBRACE] = ACTIONS(2934),
    [anon_sym_LT_AT] = ACTIONS(2934),
    [anon_sym_LT_AT_AT] = ACTIONS(2934),
    [anon_sym_AT_AT_GT] = ACTIONS(2934),
    [anon_sym_DOT] = ACTIONS(2934),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2936),
    [anon_sym_new] = ACTIONS(2934),
    [anon_sym_return_BANG] = ACTIONS(2936),
    [anon_sym_yield] = ACTIONS(2934),
    [anon_sym_yield_BANG] = ACTIONS(2936),
    [anon_sym_lazy] = ACTIONS(2934),
    [anon_sym_assert] = ACTIONS(2934),
    [anon_sym_upcast] = ACTIONS(2934),
    [anon_sym_downcast] = ACTIONS(2934),
    [anon_sym_COLON_GT] = ACTIONS(2936),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2936),
    [anon_sym_for] = ACTIONS(2934),
    [anon_sym_while] = ACTIONS(2934),
    [anon_sym_if] = ACTIONS(2934),
    [anon_sym_fun] = ACTIONS(2934),
    [anon_sym_try] = ACTIONS(2934),
    [anon_sym_match] = ACTIONS(2934),
    [anon_sym_match_BANG] = ACTIONS(2936),
    [anon_sym_function] = ACTIONS(2934),
    [anon_sym_LT_DASH] = ACTIONS(2934),
    [anon_sym_DOT_LBRACK] = ACTIONS(2936),
    [anon_sym_LT] = ACTIONS(2936),
    [anon_sym_use] = ACTIONS(2934),
    [anon_sym_use_BANG] = ACTIONS(2936),
    [anon_sym_do_BANG] = ACTIONS(2936),
    [anon_sym_begin] = ACTIONS(2934),
    [anon_sym_LPAREN2] = ACTIONS(2934),
    [anon_sym_or] = ACTIONS(2934),
    [aux_sym_char_token1] = ACTIONS(2936),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2934),
    [anon_sym_DQUOTE] = ACTIONS(2934),
    [anon_sym_AT_DQUOTE] = ACTIONS(2936),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2936),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2936),
    [sym_bool] = ACTIONS(2934),
    [sym_unit] = ACTIONS(2936),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2934),
    [sym_op_identifier] = ACTIONS(2934),
    [anon_sym_PLUS] = ACTIONS(2934),
    [anon_sym_DASH] = ACTIONS(2934),
    [anon_sym_PLUS_DOT] = ACTIONS(2934),
    [anon_sym_DASH_DOT] = ACTIONS(2934),
    [anon_sym_PERCENT] = ACTIONS(2934),
    [anon_sym_AMP_AMP] = ACTIONS(2934),
    [anon_sym_TILDE] = ACTIONS(2936),
    [aux_sym_prefix_op_token1] = ACTIONS(2934),
    [aux_sym_infix_op_token1] = ACTIONS(2936),
    [aux_sym_infix_op_token2] = ACTIONS(2934),
    [anon_sym_PIPE_PIPE] = ACTIONS(2934),
    [anon_sym_BANG_EQ] = ACTIONS(2934),
    [anon_sym_COLON_EQ] = ACTIONS(2936),
    [anon_sym_DOLLAR] = ACTIONS(2934),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2934),
    [sym_int] = ACTIONS(2934),
    [sym_xint] = ACTIONS(2936),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2936),
    [sym__newline] = ACTIONS(2936),
  },
  [2245] = {
    [sym_block_comment] = STATE(2245),
    [sym_compiler_directive_decl] = STATE(2245),
    [sym_fsi_directive_decl] = STATE(2245),
    [sym_preproc_line] = STATE(2245),
    [sym_identifier] = ACTIONS(2411),
    [anon_sym_EQ] = ACTIONS(2413),
    [anon_sym_COLON] = ACTIONS(2411),
    [anon_sym_return] = ACTIONS(2411),
    [anon_sym_do] = ACTIONS(2411),
    [anon_sym_let] = ACTIONS(2411),
    [anon_sym_let_BANG] = ACTIONS(2413),
    [anon_sym_LPAREN] = ACTIONS(2411),
    [anon_sym_COMMA] = ACTIONS(2413),
    [anon_sym_null] = ACTIONS(2411),
    [anon_sym_QMARK] = ACTIONS(2411),
    [anon_sym_COLON_QMARK] = ACTIONS(2411),
    [anon_sym_COLON_COLON] = ACTIONS(2413),
    [anon_sym_AMP] = ACTIONS(2411),
    [anon_sym_LBRACK] = ACTIONS(2411),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2413),
    [anon_sym_LBRACE] = ACTIONS(2411),
    [anon_sym_LT_AT] = ACTIONS(2411),
    [anon_sym_AT_GT] = ACTIONS(2411),
    [anon_sym_LT_AT_AT] = ACTIONS(2411),
    [anon_sym_DOT] = ACTIONS(2411),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2413),
    [anon_sym_new] = ACTIONS(2411),
    [anon_sym_return_BANG] = ACTIONS(2413),
    [anon_sym_yield] = ACTIONS(2411),
    [anon_sym_yield_BANG] = ACTIONS(2413),
    [anon_sym_lazy] = ACTIONS(2411),
    [anon_sym_assert] = ACTIONS(2411),
    [anon_sym_upcast] = ACTIONS(2411),
    [anon_sym_downcast] = ACTIONS(2411),
    [anon_sym_COLON_GT] = ACTIONS(2413),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2413),
    [anon_sym_for] = ACTIONS(2411),
    [anon_sym_while] = ACTIONS(2411),
    [anon_sym_if] = ACTIONS(2411),
    [anon_sym_fun] = ACTIONS(2411),
    [anon_sym_try] = ACTIONS(2411),
    [anon_sym_match] = ACTIONS(2411),
    [anon_sym_match_BANG] = ACTIONS(2413),
    [anon_sym_function] = ACTIONS(2411),
    [anon_sym_LT_DASH] = ACTIONS(2411),
    [anon_sym_DOT_LBRACK] = ACTIONS(2413),
    [anon_sym_LT] = ACTIONS(2413),
    [anon_sym_use] = ACTIONS(2411),
    [anon_sym_use_BANG] = ACTIONS(2413),
    [anon_sym_do_BANG] = ACTIONS(2413),
    [anon_sym_begin] = ACTIONS(2411),
    [anon_sym_LPAREN2] = ACTIONS(2411),
    [anon_sym_or] = ACTIONS(2411),
    [aux_sym_char_token1] = ACTIONS(2413),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2411),
    [anon_sym_DQUOTE] = ACTIONS(2411),
    [anon_sym_AT_DQUOTE] = ACTIONS(2413),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2413),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2413),
    [sym_bool] = ACTIONS(2411),
    [sym_unit] = ACTIONS(2413),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2411),
    [sym_op_identifier] = ACTIONS(2411),
    [anon_sym_PLUS] = ACTIONS(2411),
    [anon_sym_DASH] = ACTIONS(2411),
    [anon_sym_PLUS_DOT] = ACTIONS(2411),
    [anon_sym_DASH_DOT] = ACTIONS(2411),
    [anon_sym_PERCENT] = ACTIONS(2411),
    [anon_sym_AMP_AMP] = ACTIONS(2411),
    [anon_sym_TILDE] = ACTIONS(2413),
    [aux_sym_prefix_op_token1] = ACTIONS(2411),
    [aux_sym_infix_op_token1] = ACTIONS(2413),
    [aux_sym_infix_op_token2] = ACTIONS(2411),
    [anon_sym_PIPE_PIPE] = ACTIONS(2411),
    [anon_sym_BANG_EQ] = ACTIONS(2411),
    [anon_sym_COLON_EQ] = ACTIONS(2413),
    [anon_sym_DOLLAR] = ACTIONS(2411),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2411),
    [sym_int] = ACTIONS(2411),
    [sym_xint] = ACTIONS(2413),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2413),
    [sym__newline] = ACTIONS(2413),
  },
  [2246] = {
    [sym_block_comment] = STATE(2246),
    [sym_compiler_directive_decl] = STATE(2246),
    [sym_fsi_directive_decl] = STATE(2246),
    [sym_preproc_line] = STATE(2246),
    [sym_identifier] = ACTIONS(3031),
    [anon_sym_EQ] = ACTIONS(3033),
    [anon_sym_COLON] = ACTIONS(3031),
    [anon_sym_return] = ACTIONS(3031),
    [anon_sym_do] = ACTIONS(3031),
    [anon_sym_let] = ACTIONS(3031),
    [anon_sym_let_BANG] = ACTIONS(3033),
    [anon_sym_LPAREN] = ACTIONS(3031),
    [anon_sym_COMMA] = ACTIONS(3033),
    [anon_sym_null] = ACTIONS(3031),
    [anon_sym_QMARK] = ACTIONS(3031),
    [anon_sym_COLON_QMARK] = ACTIONS(3031),
    [anon_sym_COLON_COLON] = ACTIONS(3033),
    [anon_sym_AMP] = ACTIONS(3031),
    [anon_sym_LBRACK] = ACTIONS(3031),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3033),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [anon_sym_LT_AT] = ACTIONS(3031),
    [anon_sym_LT_AT_AT] = ACTIONS(3031),
    [anon_sym_DOT] = ACTIONS(3031),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3033),
    [anon_sym_new] = ACTIONS(3031),
    [anon_sym_return_BANG] = ACTIONS(3033),
    [anon_sym_yield] = ACTIONS(3031),
    [anon_sym_yield_BANG] = ACTIONS(3033),
    [anon_sym_lazy] = ACTIONS(3031),
    [anon_sym_assert] = ACTIONS(3031),
    [anon_sym_upcast] = ACTIONS(3031),
    [anon_sym_downcast] = ACTIONS(3031),
    [anon_sym_COLON_GT] = ACTIONS(3033),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3033),
    [anon_sym_for] = ACTIONS(3031),
    [anon_sym_while] = ACTIONS(3031),
    [anon_sym_if] = ACTIONS(3031),
    [anon_sym_fun] = ACTIONS(3031),
    [anon_sym_try] = ACTIONS(3031),
    [anon_sym_match] = ACTIONS(3031),
    [anon_sym_match_BANG] = ACTIONS(3033),
    [anon_sym_function] = ACTIONS(3031),
    [anon_sym_LT_DASH] = ACTIONS(3031),
    [anon_sym_DOT_LBRACK] = ACTIONS(3033),
    [anon_sym_LT] = ACTIONS(3033),
    [anon_sym_use] = ACTIONS(3031),
    [anon_sym_use_BANG] = ACTIONS(3033),
    [anon_sym_do_BANG] = ACTIONS(3033),
    [anon_sym_DOT_DOT] = ACTIONS(3033),
    [anon_sym_begin] = ACTIONS(3031),
    [anon_sym_LPAREN2] = ACTIONS(3031),
    [anon_sym_or] = ACTIONS(3031),
    [aux_sym_char_token1] = ACTIONS(3033),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3031),
    [anon_sym_DQUOTE] = ACTIONS(3031),
    [anon_sym_AT_DQUOTE] = ACTIONS(3033),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3033),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3033),
    [sym_bool] = ACTIONS(3031),
    [sym_unit] = ACTIONS(3033),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3031),
    [sym_op_identifier] = ACTIONS(3031),
    [anon_sym_PLUS] = ACTIONS(3031),
    [anon_sym_DASH] = ACTIONS(3031),
    [anon_sym_PLUS_DOT] = ACTIONS(3031),
    [anon_sym_DASH_DOT] = ACTIONS(3031),
    [anon_sym_PERCENT] = ACTIONS(3031),
    [anon_sym_AMP_AMP] = ACTIONS(3031),
    [anon_sym_TILDE] = ACTIONS(3033),
    [aux_sym_prefix_op_token1] = ACTIONS(3031),
    [aux_sym_infix_op_token1] = ACTIONS(3033),
    [aux_sym_infix_op_token2] = ACTIONS(3031),
    [anon_sym_PIPE_PIPE] = ACTIONS(3031),
    [anon_sym_BANG_EQ] = ACTIONS(3031),
    [anon_sym_COLON_EQ] = ACTIONS(3033),
    [anon_sym_DOLLAR] = ACTIONS(3031),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3031),
    [sym_int] = ACTIONS(3031),
    [sym_xint] = ACTIONS(3033),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3033),
    [sym__newline] = ACTIONS(3033),
  },
  [2247] = {
    [sym_block_comment] = STATE(2247),
    [sym_compiler_directive_decl] = STATE(2247),
    [sym_fsi_directive_decl] = STATE(2247),
    [sym_preproc_line] = STATE(2247),
    [sym_identifier] = ACTIONS(2881),
    [anon_sym_EQ] = ACTIONS(2789),
    [anon_sym_COLON] = ACTIONS(2881),
    [anon_sym_return] = ACTIONS(2881),
    [anon_sym_do] = ACTIONS(2881),
    [anon_sym_let] = ACTIONS(2881),
    [anon_sym_let_BANG] = ACTIONS(2789),
    [anon_sym_LPAREN] = ACTIONS(2881),
    [anon_sym_COMMA] = ACTIONS(2789),
    [anon_sym_null] = ACTIONS(2881),
    [anon_sym_QMARK] = ACTIONS(2881),
    [anon_sym_COLON_QMARK] = ACTIONS(2881),
    [anon_sym_COLON_COLON] = ACTIONS(2789),
    [anon_sym_AMP] = ACTIONS(2881),
    [anon_sym_LBRACK] = ACTIONS(2881),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2789),
    [anon_sym_LBRACE] = ACTIONS(2881),
    [anon_sym_LT_AT] = ACTIONS(2881),
    [anon_sym_LT_AT_AT] = ACTIONS(2881),
    [anon_sym_DOT] = ACTIONS(2881),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2789),
    [anon_sym_new] = ACTIONS(2881),
    [anon_sym_return_BANG] = ACTIONS(2789),
    [anon_sym_yield] = ACTIONS(2881),
    [anon_sym_yield_BANG] = ACTIONS(2789),
    [anon_sym_lazy] = ACTIONS(2881),
    [anon_sym_assert] = ACTIONS(2881),
    [anon_sym_upcast] = ACTIONS(2881),
    [anon_sym_downcast] = ACTIONS(2881),
    [anon_sym_COLON_GT] = ACTIONS(2789),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2789),
    [anon_sym_for] = ACTIONS(2881),
    [anon_sym_while] = ACTIONS(2881),
    [anon_sym_if] = ACTIONS(2881),
    [anon_sym_fun] = ACTIONS(2881),
    [anon_sym_try] = ACTIONS(2881),
    [anon_sym_match] = ACTIONS(2881),
    [anon_sym_match_BANG] = ACTIONS(2789),
    [anon_sym_function] = ACTIONS(2881),
    [anon_sym_LT_DASH] = ACTIONS(2881),
    [anon_sym_DOT_LBRACK] = ACTIONS(2789),
    [anon_sym_LT] = ACTIONS(2789),
    [anon_sym_GT] = ACTIONS(2881),
    [anon_sym_use] = ACTIONS(2881),
    [anon_sym_use_BANG] = ACTIONS(2789),
    [anon_sym_do_BANG] = ACTIONS(2789),
    [anon_sym_begin] = ACTIONS(2881),
    [anon_sym_LPAREN2] = ACTIONS(2881),
    [anon_sym_or] = ACTIONS(2881),
    [aux_sym_char_token1] = ACTIONS(2789),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2881),
    [anon_sym_DQUOTE] = ACTIONS(2881),
    [anon_sym_AT_DQUOTE] = ACTIONS(2789),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2789),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2789),
    [sym_bool] = ACTIONS(2881),
    [sym_unit] = ACTIONS(2789),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2881),
    [sym_op_identifier] = ACTIONS(2881),
    [anon_sym_PLUS] = ACTIONS(2881),
    [anon_sym_DASH] = ACTIONS(2881),
    [anon_sym_PLUS_DOT] = ACTIONS(2881),
    [anon_sym_DASH_DOT] = ACTIONS(2881),
    [anon_sym_PERCENT] = ACTIONS(2881),
    [anon_sym_AMP_AMP] = ACTIONS(2881),
    [anon_sym_TILDE] = ACTIONS(2789),
    [aux_sym_prefix_op_token1] = ACTIONS(2881),
    [aux_sym_infix_op_token1] = ACTIONS(2789),
    [aux_sym_infix_op_token2] = ACTIONS(2881),
    [anon_sym_PIPE_PIPE] = ACTIONS(2881),
    [anon_sym_BANG_EQ] = ACTIONS(2881),
    [anon_sym_COLON_EQ] = ACTIONS(2789),
    [anon_sym_DOLLAR] = ACTIONS(2881),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2881),
    [sym_int] = ACTIONS(2881),
    [sym_xint] = ACTIONS(2789),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2789),
    [sym__newline] = ACTIONS(2789),
  },
  [2248] = {
    [sym_block_comment] = STATE(2248),
    [sym_compiler_directive_decl] = STATE(2248),
    [sym_fsi_directive_decl] = STATE(2248),
    [sym_preproc_line] = STATE(2248),
    [sym_identifier] = ACTIONS(3011),
    [anon_sym_EQ] = ACTIONS(3013),
    [anon_sym_COLON] = ACTIONS(3011),
    [anon_sym_return] = ACTIONS(3011),
    [anon_sym_do] = ACTIONS(3011),
    [anon_sym_let] = ACTIONS(3011),
    [anon_sym_let_BANG] = ACTIONS(3013),
    [anon_sym_LPAREN] = ACTIONS(3011),
    [anon_sym_COMMA] = ACTIONS(3013),
    [anon_sym_null] = ACTIONS(3011),
    [anon_sym_QMARK] = ACTIONS(3011),
    [anon_sym_COLON_QMARK] = ACTIONS(3011),
    [anon_sym_COLON_COLON] = ACTIONS(3013),
    [anon_sym_AMP] = ACTIONS(3011),
    [anon_sym_LBRACK] = ACTIONS(3011),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3013),
    [anon_sym_LBRACE] = ACTIONS(3011),
    [anon_sym_LT_AT] = ACTIONS(3011),
    [anon_sym_LT_AT_AT] = ACTIONS(3011),
    [anon_sym_DOT] = ACTIONS(3011),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3013),
    [anon_sym_new] = ACTIONS(3011),
    [anon_sym_return_BANG] = ACTIONS(3013),
    [anon_sym_yield] = ACTIONS(3011),
    [anon_sym_yield_BANG] = ACTIONS(3013),
    [anon_sym_lazy] = ACTIONS(3011),
    [anon_sym_assert] = ACTIONS(3011),
    [anon_sym_upcast] = ACTIONS(3011),
    [anon_sym_downcast] = ACTIONS(3011),
    [anon_sym_COLON_GT] = ACTIONS(3013),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3013),
    [anon_sym_for] = ACTIONS(3011),
    [anon_sym_while] = ACTIONS(3011),
    [anon_sym_if] = ACTIONS(3011),
    [anon_sym_fun] = ACTIONS(3011),
    [anon_sym_try] = ACTIONS(3011),
    [anon_sym_match] = ACTIONS(3011),
    [anon_sym_match_BANG] = ACTIONS(3013),
    [anon_sym_function] = ACTIONS(3011),
    [anon_sym_LT_DASH] = ACTIONS(3011),
    [anon_sym_DOT_LBRACK] = ACTIONS(3013),
    [anon_sym_LT] = ACTIONS(3013),
    [anon_sym_GT] = ACTIONS(3011),
    [anon_sym_use] = ACTIONS(3011),
    [anon_sym_use_BANG] = ACTIONS(3013),
    [anon_sym_do_BANG] = ACTIONS(3013),
    [anon_sym_begin] = ACTIONS(3011),
    [anon_sym_LPAREN2] = ACTIONS(3011),
    [anon_sym_or] = ACTIONS(3011),
    [aux_sym_char_token1] = ACTIONS(3013),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3011),
    [anon_sym_DQUOTE] = ACTIONS(3011),
    [anon_sym_AT_DQUOTE] = ACTIONS(3013),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3013),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3013),
    [sym_bool] = ACTIONS(3011),
    [sym_unit] = ACTIONS(3013),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3011),
    [sym_op_identifier] = ACTIONS(3011),
    [anon_sym_PLUS] = ACTIONS(3011),
    [anon_sym_DASH] = ACTIONS(3011),
    [anon_sym_PLUS_DOT] = ACTIONS(3011),
    [anon_sym_DASH_DOT] = ACTIONS(3011),
    [anon_sym_PERCENT] = ACTIONS(3011),
    [anon_sym_AMP_AMP] = ACTIONS(3011),
    [anon_sym_TILDE] = ACTIONS(3013),
    [aux_sym_prefix_op_token1] = ACTIONS(3011),
    [aux_sym_infix_op_token1] = ACTIONS(3013),
    [aux_sym_infix_op_token2] = ACTIONS(3011),
    [anon_sym_PIPE_PIPE] = ACTIONS(3011),
    [anon_sym_BANG_EQ] = ACTIONS(3011),
    [anon_sym_COLON_EQ] = ACTIONS(3013),
    [anon_sym_DOLLAR] = ACTIONS(3011),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3011),
    [sym_int] = ACTIONS(3011),
    [sym_xint] = ACTIONS(3013),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3013),
    [sym__newline] = ACTIONS(3013),
  },
  [2249] = {
    [sym_block_comment] = STATE(2249),
    [sym_compiler_directive_decl] = STATE(2249),
    [sym_fsi_directive_decl] = STATE(2249),
    [sym_preproc_line] = STATE(2249),
    [sym_identifier] = ACTIONS(2839),
    [anon_sym_EQ] = ACTIONS(2841),
    [anon_sym_COLON] = ACTIONS(2839),
    [anon_sym_return] = ACTIONS(2839),
    [anon_sym_do] = ACTIONS(2839),
    [anon_sym_let] = ACTIONS(2839),
    [anon_sym_let_BANG] = ACTIONS(2841),
    [anon_sym_LPAREN] = ACTIONS(2839),
    [anon_sym_COMMA] = ACTIONS(2841),
    [anon_sym_null] = ACTIONS(2839),
    [anon_sym_QMARK] = ACTIONS(2839),
    [anon_sym_COLON_QMARK] = ACTIONS(2839),
    [anon_sym_COLON_COLON] = ACTIONS(2841),
    [anon_sym_AMP] = ACTIONS(2839),
    [anon_sym_LBRACK] = ACTIONS(2839),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2841),
    [anon_sym_LBRACE] = ACTIONS(2839),
    [anon_sym_LT_AT] = ACTIONS(2839),
    [anon_sym_LT_AT_AT] = ACTIONS(2839),
    [anon_sym_DOT] = ACTIONS(2839),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2841),
    [anon_sym_new] = ACTIONS(2839),
    [anon_sym_return_BANG] = ACTIONS(2841),
    [anon_sym_yield] = ACTIONS(2839),
    [anon_sym_yield_BANG] = ACTIONS(2841),
    [anon_sym_lazy] = ACTIONS(2839),
    [anon_sym_assert] = ACTIONS(2839),
    [anon_sym_upcast] = ACTIONS(2839),
    [anon_sym_downcast] = ACTIONS(2839),
    [anon_sym_COLON_GT] = ACTIONS(2841),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2841),
    [anon_sym_for] = ACTIONS(2839),
    [anon_sym_while] = ACTIONS(2839),
    [anon_sym_if] = ACTIONS(2839),
    [anon_sym_fun] = ACTIONS(2839),
    [anon_sym_try] = ACTIONS(2839),
    [anon_sym_match] = ACTIONS(2839),
    [anon_sym_match_BANG] = ACTIONS(2841),
    [anon_sym_function] = ACTIONS(2839),
    [anon_sym_LT_DASH] = ACTIONS(2839),
    [anon_sym_DOT_LBRACK] = ACTIONS(2841),
    [anon_sym_LT] = ACTIONS(2841),
    [anon_sym_GT] = ACTIONS(2839),
    [anon_sym_use] = ACTIONS(2839),
    [anon_sym_use_BANG] = ACTIONS(2841),
    [anon_sym_do_BANG] = ACTIONS(2841),
    [anon_sym_begin] = ACTIONS(2839),
    [anon_sym_LPAREN2] = ACTIONS(2839),
    [anon_sym_or] = ACTIONS(2839),
    [aux_sym_char_token1] = ACTIONS(2841),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2839),
    [anon_sym_DQUOTE] = ACTIONS(2839),
    [anon_sym_AT_DQUOTE] = ACTIONS(2841),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2841),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2841),
    [sym_bool] = ACTIONS(2839),
    [sym_unit] = ACTIONS(2841),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2839),
    [sym_op_identifier] = ACTIONS(2839),
    [anon_sym_PLUS] = ACTIONS(2839),
    [anon_sym_DASH] = ACTIONS(2839),
    [anon_sym_PLUS_DOT] = ACTIONS(2839),
    [anon_sym_DASH_DOT] = ACTIONS(2839),
    [anon_sym_PERCENT] = ACTIONS(2839),
    [anon_sym_AMP_AMP] = ACTIONS(2839),
    [anon_sym_TILDE] = ACTIONS(2841),
    [aux_sym_prefix_op_token1] = ACTIONS(2839),
    [aux_sym_infix_op_token1] = ACTIONS(2841),
    [aux_sym_infix_op_token2] = ACTIONS(2839),
    [anon_sym_PIPE_PIPE] = ACTIONS(2839),
    [anon_sym_BANG_EQ] = ACTIONS(2839),
    [anon_sym_COLON_EQ] = ACTIONS(2841),
    [anon_sym_DOLLAR] = ACTIONS(2839),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2839),
    [sym_int] = ACTIONS(2839),
    [sym_xint] = ACTIONS(2841),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2841),
    [sym__newline] = ACTIONS(2841),
  },
  [2250] = {
    [sym_block_comment] = STATE(2250),
    [sym_compiler_directive_decl] = STATE(2250),
    [sym_fsi_directive_decl] = STATE(2250),
    [sym_preproc_line] = STATE(2250),
    [sym_identifier] = ACTIONS(3055),
    [anon_sym_EQ] = ACTIONS(3057),
    [anon_sym_COLON] = ACTIONS(3055),
    [anon_sym_return] = ACTIONS(3055),
    [anon_sym_do] = ACTIONS(3055),
    [anon_sym_let] = ACTIONS(3055),
    [anon_sym_let_BANG] = ACTIONS(3057),
    [anon_sym_LPAREN] = ACTIONS(3055),
    [anon_sym_COMMA] = ACTIONS(3057),
    [anon_sym_null] = ACTIONS(3055),
    [anon_sym_QMARK] = ACTIONS(3055),
    [anon_sym_COLON_QMARK] = ACTIONS(3055),
    [anon_sym_COLON_COLON] = ACTIONS(3057),
    [anon_sym_AMP] = ACTIONS(3055),
    [anon_sym_LBRACK] = ACTIONS(3055),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3057),
    [anon_sym_LBRACE] = ACTIONS(3055),
    [anon_sym_LT_AT] = ACTIONS(3055),
    [anon_sym_LT_AT_AT] = ACTIONS(3055),
    [anon_sym_DOT] = ACTIONS(3055),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3057),
    [anon_sym_new] = ACTIONS(3055),
    [anon_sym_return_BANG] = ACTIONS(3057),
    [anon_sym_yield] = ACTIONS(3055),
    [anon_sym_yield_BANG] = ACTIONS(3057),
    [anon_sym_lazy] = ACTIONS(3055),
    [anon_sym_assert] = ACTIONS(3055),
    [anon_sym_upcast] = ACTIONS(3055),
    [anon_sym_downcast] = ACTIONS(3055),
    [anon_sym_COLON_GT] = ACTIONS(3057),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3057),
    [anon_sym_for] = ACTIONS(3055),
    [anon_sym_while] = ACTIONS(3055),
    [anon_sym_if] = ACTIONS(3055),
    [anon_sym_fun] = ACTIONS(3055),
    [anon_sym_try] = ACTIONS(3055),
    [anon_sym_match] = ACTIONS(3055),
    [anon_sym_match_BANG] = ACTIONS(3057),
    [anon_sym_function] = ACTIONS(3055),
    [anon_sym_LT_DASH] = ACTIONS(3055),
    [anon_sym_DOT_LBRACK] = ACTIONS(3057),
    [anon_sym_LT] = ACTIONS(3057),
    [anon_sym_GT] = ACTIONS(3055),
    [anon_sym_use] = ACTIONS(3055),
    [anon_sym_use_BANG] = ACTIONS(3057),
    [anon_sym_do_BANG] = ACTIONS(3057),
    [anon_sym_begin] = ACTIONS(3055),
    [anon_sym_LPAREN2] = ACTIONS(3055),
    [anon_sym_or] = ACTIONS(3055),
    [aux_sym_char_token1] = ACTIONS(3057),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3055),
    [anon_sym_DQUOTE] = ACTIONS(3055),
    [anon_sym_AT_DQUOTE] = ACTIONS(3057),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3057),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3057),
    [sym_bool] = ACTIONS(3055),
    [sym_unit] = ACTIONS(3057),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3055),
    [sym_op_identifier] = ACTIONS(3055),
    [anon_sym_PLUS] = ACTIONS(3055),
    [anon_sym_DASH] = ACTIONS(3055),
    [anon_sym_PLUS_DOT] = ACTIONS(3055),
    [anon_sym_DASH_DOT] = ACTIONS(3055),
    [anon_sym_PERCENT] = ACTIONS(3055),
    [anon_sym_AMP_AMP] = ACTIONS(3055),
    [anon_sym_TILDE] = ACTIONS(3057),
    [aux_sym_prefix_op_token1] = ACTIONS(3055),
    [aux_sym_infix_op_token1] = ACTIONS(3057),
    [aux_sym_infix_op_token2] = ACTIONS(3055),
    [anon_sym_PIPE_PIPE] = ACTIONS(3055),
    [anon_sym_BANG_EQ] = ACTIONS(3055),
    [anon_sym_COLON_EQ] = ACTIONS(3057),
    [anon_sym_DOLLAR] = ACTIONS(3055),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3055),
    [sym_int] = ACTIONS(3055),
    [sym_xint] = ACTIONS(3057),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3057),
    [sym__newline] = ACTIONS(3057),
  },
  [2251] = {
    [sym_block_comment] = STATE(2251),
    [sym_compiler_directive_decl] = STATE(2251),
    [sym_fsi_directive_decl] = STATE(2251),
    [sym_preproc_line] = STATE(2251),
    [sym_identifier] = ACTIONS(3035),
    [anon_sym_EQ] = ACTIONS(3037),
    [anon_sym_COLON] = ACTIONS(3035),
    [anon_sym_return] = ACTIONS(3035),
    [anon_sym_do] = ACTIONS(3035),
    [anon_sym_let] = ACTIONS(3035),
    [anon_sym_let_BANG] = ACTIONS(3037),
    [anon_sym_LPAREN] = ACTIONS(3035),
    [anon_sym_COMMA] = ACTIONS(3037),
    [anon_sym_null] = ACTIONS(3035),
    [anon_sym_QMARK] = ACTIONS(3035),
    [anon_sym_COLON_QMARK] = ACTIONS(3035),
    [anon_sym_COLON_COLON] = ACTIONS(3037),
    [anon_sym_AMP] = ACTIONS(3035),
    [anon_sym_LBRACK] = ACTIONS(3035),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3037),
    [anon_sym_LBRACE] = ACTIONS(3035),
    [anon_sym_LT_AT] = ACTIONS(3035),
    [anon_sym_LT_AT_AT] = ACTIONS(3035),
    [anon_sym_DOT] = ACTIONS(3035),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3037),
    [anon_sym_new] = ACTIONS(3035),
    [anon_sym_return_BANG] = ACTIONS(3037),
    [anon_sym_yield] = ACTIONS(3035),
    [anon_sym_yield_BANG] = ACTIONS(3037),
    [anon_sym_lazy] = ACTIONS(3035),
    [anon_sym_assert] = ACTIONS(3035),
    [anon_sym_upcast] = ACTIONS(3035),
    [anon_sym_downcast] = ACTIONS(3035),
    [anon_sym_COLON_GT] = ACTIONS(3037),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3037),
    [anon_sym_for] = ACTIONS(3035),
    [anon_sym_while] = ACTIONS(3035),
    [anon_sym_if] = ACTIONS(3035),
    [anon_sym_fun] = ACTIONS(3035),
    [anon_sym_try] = ACTIONS(3035),
    [anon_sym_match] = ACTIONS(3035),
    [anon_sym_match_BANG] = ACTIONS(3037),
    [anon_sym_function] = ACTIONS(3035),
    [anon_sym_LT_DASH] = ACTIONS(3035),
    [anon_sym_DOT_LBRACK] = ACTIONS(3037),
    [anon_sym_LT] = ACTIONS(3037),
    [anon_sym_use] = ACTIONS(3035),
    [anon_sym_use_BANG] = ACTIONS(3037),
    [anon_sym_do_BANG] = ACTIONS(3037),
    [anon_sym_DOT_DOT] = ACTIONS(3037),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_LPAREN2] = ACTIONS(3035),
    [anon_sym_or] = ACTIONS(3035),
    [aux_sym_char_token1] = ACTIONS(3037),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3035),
    [anon_sym_DQUOTE] = ACTIONS(3035),
    [anon_sym_AT_DQUOTE] = ACTIONS(3037),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3037),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3037),
    [sym_bool] = ACTIONS(3035),
    [sym_unit] = ACTIONS(3037),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3035),
    [sym_op_identifier] = ACTIONS(3035),
    [anon_sym_PLUS] = ACTIONS(3035),
    [anon_sym_DASH] = ACTIONS(3035),
    [anon_sym_PLUS_DOT] = ACTIONS(3035),
    [anon_sym_DASH_DOT] = ACTIONS(3035),
    [anon_sym_PERCENT] = ACTIONS(3035),
    [anon_sym_AMP_AMP] = ACTIONS(3035),
    [anon_sym_TILDE] = ACTIONS(3037),
    [aux_sym_prefix_op_token1] = ACTIONS(3035),
    [aux_sym_infix_op_token1] = ACTIONS(3037),
    [aux_sym_infix_op_token2] = ACTIONS(3035),
    [anon_sym_PIPE_PIPE] = ACTIONS(3035),
    [anon_sym_BANG_EQ] = ACTIONS(3035),
    [anon_sym_COLON_EQ] = ACTIONS(3037),
    [anon_sym_DOLLAR] = ACTIONS(3035),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3035),
    [sym_int] = ACTIONS(3035),
    [sym_xint] = ACTIONS(3037),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3037),
    [sym__newline] = ACTIONS(3037),
  },
  [2252] = {
    [sym_block_comment] = STATE(2252),
    [sym_compiler_directive_decl] = STATE(2252),
    [sym_fsi_directive_decl] = STATE(2252),
    [sym_preproc_line] = STATE(2252),
    [sym_identifier] = ACTIONS(2974),
    [anon_sym_EQ] = ACTIONS(2976),
    [anon_sym_COLON] = ACTIONS(2974),
    [anon_sym_return] = ACTIONS(2974),
    [anon_sym_do] = ACTIONS(2974),
    [anon_sym_let] = ACTIONS(2974),
    [anon_sym_let_BANG] = ACTIONS(2976),
    [anon_sym_LPAREN] = ACTIONS(2974),
    [anon_sym_COMMA] = ACTIONS(2976),
    [anon_sym_null] = ACTIONS(2974),
    [anon_sym_QMARK] = ACTIONS(2974),
    [anon_sym_COLON_QMARK] = ACTIONS(2974),
    [anon_sym_COLON_COLON] = ACTIONS(2976),
    [anon_sym_AMP] = ACTIONS(2974),
    [anon_sym_LBRACK] = ACTIONS(2974),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2976),
    [anon_sym_LBRACE] = ACTIONS(2974),
    [anon_sym_LT_AT] = ACTIONS(2974),
    [anon_sym_AT_GT] = ACTIONS(2974),
    [anon_sym_LT_AT_AT] = ACTIONS(2974),
    [anon_sym_DOT] = ACTIONS(2974),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2976),
    [anon_sym_new] = ACTIONS(2974),
    [anon_sym_return_BANG] = ACTIONS(2976),
    [anon_sym_yield] = ACTIONS(2974),
    [anon_sym_yield_BANG] = ACTIONS(2976),
    [anon_sym_lazy] = ACTIONS(2974),
    [anon_sym_assert] = ACTIONS(2974),
    [anon_sym_upcast] = ACTIONS(2974),
    [anon_sym_downcast] = ACTIONS(2974),
    [anon_sym_COLON_GT] = ACTIONS(2976),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2976),
    [anon_sym_for] = ACTIONS(2974),
    [anon_sym_while] = ACTIONS(2974),
    [anon_sym_if] = ACTIONS(2974),
    [anon_sym_fun] = ACTIONS(2974),
    [anon_sym_try] = ACTIONS(2974),
    [anon_sym_match] = ACTIONS(2974),
    [anon_sym_match_BANG] = ACTIONS(2976),
    [anon_sym_function] = ACTIONS(2974),
    [anon_sym_LT_DASH] = ACTIONS(2974),
    [anon_sym_DOT_LBRACK] = ACTIONS(2976),
    [anon_sym_LT] = ACTIONS(2976),
    [anon_sym_use] = ACTIONS(2974),
    [anon_sym_use_BANG] = ACTIONS(2976),
    [anon_sym_do_BANG] = ACTIONS(2976),
    [anon_sym_begin] = ACTIONS(2974),
    [anon_sym_LPAREN2] = ACTIONS(2974),
    [anon_sym_or] = ACTIONS(2974),
    [aux_sym_char_token1] = ACTIONS(2976),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2974),
    [anon_sym_DQUOTE] = ACTIONS(2974),
    [anon_sym_AT_DQUOTE] = ACTIONS(2976),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2976),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2976),
    [sym_bool] = ACTIONS(2974),
    [sym_unit] = ACTIONS(2976),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2974),
    [sym_op_identifier] = ACTIONS(2974),
    [anon_sym_PLUS] = ACTIONS(2974),
    [anon_sym_DASH] = ACTIONS(2974),
    [anon_sym_PLUS_DOT] = ACTIONS(2974),
    [anon_sym_DASH_DOT] = ACTIONS(2974),
    [anon_sym_PERCENT] = ACTIONS(2974),
    [anon_sym_AMP_AMP] = ACTIONS(2974),
    [anon_sym_TILDE] = ACTIONS(2976),
    [aux_sym_prefix_op_token1] = ACTIONS(2974),
    [aux_sym_infix_op_token1] = ACTIONS(2976),
    [aux_sym_infix_op_token2] = ACTIONS(2974),
    [anon_sym_PIPE_PIPE] = ACTIONS(2974),
    [anon_sym_BANG_EQ] = ACTIONS(2974),
    [anon_sym_COLON_EQ] = ACTIONS(2976),
    [anon_sym_DOLLAR] = ACTIONS(2974),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2974),
    [sym_int] = ACTIONS(2974),
    [sym_xint] = ACTIONS(2976),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2976),
    [sym__newline] = ACTIONS(2976),
  },
  [2253] = {
    [sym_block_comment] = STATE(2253),
    [sym_compiler_directive_decl] = STATE(2253),
    [sym_fsi_directive_decl] = STATE(2253),
    [sym_preproc_line] = STATE(2253),
    [sym_identifier] = ACTIONS(3055),
    [anon_sym_EQ] = ACTIONS(3057),
    [anon_sym_COLON] = ACTIONS(3055),
    [anon_sym_return] = ACTIONS(3055),
    [anon_sym_do] = ACTIONS(3055),
    [anon_sym_let] = ACTIONS(3055),
    [anon_sym_let_BANG] = ACTIONS(3057),
    [anon_sym_LPAREN] = ACTIONS(3055),
    [anon_sym_COMMA] = ACTIONS(3057),
    [anon_sym_null] = ACTIONS(3055),
    [anon_sym_QMARK] = ACTIONS(3055),
    [anon_sym_COLON_QMARK] = ACTIONS(3055),
    [anon_sym_COLON_COLON] = ACTIONS(3057),
    [anon_sym_AMP] = ACTIONS(3055),
    [anon_sym_LBRACK] = ACTIONS(3055),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3057),
    [anon_sym_LBRACE] = ACTIONS(3055),
    [anon_sym_LT_AT] = ACTIONS(3055),
    [anon_sym_LT_AT_AT] = ACTIONS(3055),
    [anon_sym_AT_AT_GT] = ACTIONS(3055),
    [anon_sym_DOT] = ACTIONS(3055),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3057),
    [anon_sym_new] = ACTIONS(3055),
    [anon_sym_return_BANG] = ACTIONS(3057),
    [anon_sym_yield] = ACTIONS(3055),
    [anon_sym_yield_BANG] = ACTIONS(3057),
    [anon_sym_lazy] = ACTIONS(3055),
    [anon_sym_assert] = ACTIONS(3055),
    [anon_sym_upcast] = ACTIONS(3055),
    [anon_sym_downcast] = ACTIONS(3055),
    [anon_sym_COLON_GT] = ACTIONS(3057),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3057),
    [anon_sym_for] = ACTIONS(3055),
    [anon_sym_while] = ACTIONS(3055),
    [anon_sym_if] = ACTIONS(3055),
    [anon_sym_fun] = ACTIONS(3055),
    [anon_sym_try] = ACTIONS(3055),
    [anon_sym_match] = ACTIONS(3055),
    [anon_sym_match_BANG] = ACTIONS(3057),
    [anon_sym_function] = ACTIONS(3055),
    [anon_sym_LT_DASH] = ACTIONS(3055),
    [anon_sym_DOT_LBRACK] = ACTIONS(3057),
    [anon_sym_LT] = ACTIONS(3057),
    [anon_sym_use] = ACTIONS(3055),
    [anon_sym_use_BANG] = ACTIONS(3057),
    [anon_sym_do_BANG] = ACTIONS(3057),
    [anon_sym_begin] = ACTIONS(3055),
    [anon_sym_LPAREN2] = ACTIONS(3055),
    [anon_sym_or] = ACTIONS(3055),
    [aux_sym_char_token1] = ACTIONS(3057),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3055),
    [anon_sym_DQUOTE] = ACTIONS(3055),
    [anon_sym_AT_DQUOTE] = ACTIONS(3057),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3057),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3057),
    [sym_bool] = ACTIONS(3055),
    [sym_unit] = ACTIONS(3057),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3055),
    [sym_op_identifier] = ACTIONS(3055),
    [anon_sym_PLUS] = ACTIONS(3055),
    [anon_sym_DASH] = ACTIONS(3055),
    [anon_sym_PLUS_DOT] = ACTIONS(3055),
    [anon_sym_DASH_DOT] = ACTIONS(3055),
    [anon_sym_PERCENT] = ACTIONS(3055),
    [anon_sym_AMP_AMP] = ACTIONS(3055),
    [anon_sym_TILDE] = ACTIONS(3057),
    [aux_sym_prefix_op_token1] = ACTIONS(3055),
    [aux_sym_infix_op_token1] = ACTIONS(3057),
    [aux_sym_infix_op_token2] = ACTIONS(3055),
    [anon_sym_PIPE_PIPE] = ACTIONS(3055),
    [anon_sym_BANG_EQ] = ACTIONS(3055),
    [anon_sym_COLON_EQ] = ACTIONS(3057),
    [anon_sym_DOLLAR] = ACTIONS(3055),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3055),
    [sym_int] = ACTIONS(3055),
    [sym_xint] = ACTIONS(3057),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3057),
    [sym__newline] = ACTIONS(3057),
  },
  [2254] = {
    [sym_block_comment] = STATE(2254),
    [sym_compiler_directive_decl] = STATE(2254),
    [sym_fsi_directive_decl] = STATE(2254),
    [sym_preproc_line] = STATE(2254),
    [sym_identifier] = ACTIONS(2988),
    [anon_sym_EQ] = ACTIONS(2990),
    [anon_sym_COLON] = ACTIONS(2988),
    [anon_sym_return] = ACTIONS(2988),
    [anon_sym_do] = ACTIONS(2988),
    [anon_sym_let] = ACTIONS(2988),
    [anon_sym_let_BANG] = ACTIONS(2990),
    [anon_sym_LPAREN] = ACTIONS(2988),
    [anon_sym_COMMA] = ACTIONS(2990),
    [anon_sym_null] = ACTIONS(2988),
    [anon_sym_QMARK] = ACTIONS(2988),
    [anon_sym_COLON_QMARK] = ACTIONS(2988),
    [anon_sym_COLON_COLON] = ACTIONS(2990),
    [anon_sym_AMP] = ACTIONS(2988),
    [anon_sym_LBRACK] = ACTIONS(2988),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2990),
    [anon_sym_LBRACE] = ACTIONS(2988),
    [anon_sym_LT_AT] = ACTIONS(2988),
    [anon_sym_LT_AT_AT] = ACTIONS(2988),
    [anon_sym_DOT] = ACTIONS(2988),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2990),
    [anon_sym_new] = ACTIONS(2988),
    [anon_sym_return_BANG] = ACTIONS(2990),
    [anon_sym_yield] = ACTIONS(2988),
    [anon_sym_yield_BANG] = ACTIONS(2990),
    [anon_sym_lazy] = ACTIONS(2988),
    [anon_sym_assert] = ACTIONS(2988),
    [anon_sym_upcast] = ACTIONS(2988),
    [anon_sym_downcast] = ACTIONS(2988),
    [anon_sym_COLON_GT] = ACTIONS(2990),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2990),
    [anon_sym_for] = ACTIONS(2988),
    [anon_sym_while] = ACTIONS(2988),
    [anon_sym_if] = ACTIONS(2988),
    [anon_sym_fun] = ACTIONS(2988),
    [anon_sym_try] = ACTIONS(2988),
    [anon_sym_match] = ACTIONS(2988),
    [anon_sym_match_BANG] = ACTIONS(2990),
    [anon_sym_function] = ACTIONS(2988),
    [anon_sym_LT_DASH] = ACTIONS(2988),
    [anon_sym_DOT_LBRACK] = ACTIONS(2990),
    [anon_sym_LT] = ACTIONS(2990),
    [anon_sym_GT] = ACTIONS(2988),
    [anon_sym_use] = ACTIONS(2988),
    [anon_sym_use_BANG] = ACTIONS(2990),
    [anon_sym_do_BANG] = ACTIONS(2990),
    [anon_sym_begin] = ACTIONS(2988),
    [anon_sym_LPAREN2] = ACTIONS(2988),
    [anon_sym_or] = ACTIONS(2988),
    [aux_sym_char_token1] = ACTIONS(2990),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2988),
    [anon_sym_DQUOTE] = ACTIONS(2988),
    [anon_sym_AT_DQUOTE] = ACTIONS(2990),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2990),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2990),
    [sym_bool] = ACTIONS(2988),
    [sym_unit] = ACTIONS(2990),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2988),
    [sym_op_identifier] = ACTIONS(2988),
    [anon_sym_PLUS] = ACTIONS(2988),
    [anon_sym_DASH] = ACTIONS(2988),
    [anon_sym_PLUS_DOT] = ACTIONS(2988),
    [anon_sym_DASH_DOT] = ACTIONS(2988),
    [anon_sym_PERCENT] = ACTIONS(2988),
    [anon_sym_AMP_AMP] = ACTIONS(2988),
    [anon_sym_TILDE] = ACTIONS(2990),
    [aux_sym_prefix_op_token1] = ACTIONS(2988),
    [aux_sym_infix_op_token1] = ACTIONS(2990),
    [aux_sym_infix_op_token2] = ACTIONS(2988),
    [anon_sym_PIPE_PIPE] = ACTIONS(2988),
    [anon_sym_BANG_EQ] = ACTIONS(2988),
    [anon_sym_COLON_EQ] = ACTIONS(2990),
    [anon_sym_DOLLAR] = ACTIONS(2988),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2988),
    [sym_int] = ACTIONS(2988),
    [sym_xint] = ACTIONS(2990),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2990),
    [sym__newline] = ACTIONS(2990),
  },
  [2255] = {
    [sym_block_comment] = STATE(2255),
    [sym_compiler_directive_decl] = STATE(2255),
    [sym_fsi_directive_decl] = STATE(2255),
    [sym_preproc_line] = STATE(2255),
    [sym_identifier] = ACTIONS(3003),
    [anon_sym_EQ] = ACTIONS(3005),
    [anon_sym_COLON] = ACTIONS(3003),
    [anon_sym_return] = ACTIONS(3003),
    [anon_sym_do] = ACTIONS(3003),
    [anon_sym_let] = ACTIONS(3003),
    [anon_sym_let_BANG] = ACTIONS(3005),
    [anon_sym_LPAREN] = ACTIONS(3003),
    [anon_sym_COMMA] = ACTIONS(3005),
    [anon_sym_null] = ACTIONS(3003),
    [anon_sym_QMARK] = ACTIONS(3003),
    [anon_sym_COLON_QMARK] = ACTIONS(3003),
    [anon_sym_COLON_COLON] = ACTIONS(3005),
    [anon_sym_AMP] = ACTIONS(3003),
    [anon_sym_LBRACK] = ACTIONS(3003),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3005),
    [anon_sym_LBRACE] = ACTIONS(3003),
    [anon_sym_LT_AT] = ACTIONS(3003),
    [anon_sym_LT_AT_AT] = ACTIONS(3003),
    [anon_sym_DOT] = ACTIONS(3003),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3005),
    [anon_sym_new] = ACTIONS(3003),
    [anon_sym_return_BANG] = ACTIONS(3005),
    [anon_sym_yield] = ACTIONS(3003),
    [anon_sym_yield_BANG] = ACTIONS(3005),
    [anon_sym_lazy] = ACTIONS(3003),
    [anon_sym_assert] = ACTIONS(3003),
    [anon_sym_upcast] = ACTIONS(3003),
    [anon_sym_downcast] = ACTIONS(3003),
    [anon_sym_COLON_GT] = ACTIONS(3005),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3005),
    [anon_sym_for] = ACTIONS(3003),
    [anon_sym_while] = ACTIONS(3003),
    [anon_sym_if] = ACTIONS(3003),
    [anon_sym_fun] = ACTIONS(3003),
    [anon_sym_try] = ACTIONS(3003),
    [anon_sym_match] = ACTIONS(3003),
    [anon_sym_match_BANG] = ACTIONS(3005),
    [anon_sym_function] = ACTIONS(3003),
    [anon_sym_LT_DASH] = ACTIONS(3003),
    [anon_sym_DOT_LBRACK] = ACTIONS(3005),
    [anon_sym_LT] = ACTIONS(3005),
    [anon_sym_use] = ACTIONS(3003),
    [anon_sym_use_BANG] = ACTIONS(3005),
    [anon_sym_do_BANG] = ACTIONS(3005),
    [anon_sym_begin] = ACTIONS(3003),
    [anon_sym_LPAREN2] = ACTIONS(3003),
    [anon_sym_or] = ACTIONS(3003),
    [aux_sym_char_token1] = ACTIONS(3005),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3003),
    [anon_sym_DQUOTE] = ACTIONS(3003),
    [anon_sym_AT_DQUOTE] = ACTIONS(3005),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3005),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3005),
    [sym_bool] = ACTIONS(3003),
    [sym_unit] = ACTIONS(3005),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3003),
    [sym_op_identifier] = ACTIONS(3003),
    [anon_sym_PLUS] = ACTIONS(3003),
    [anon_sym_DASH] = ACTIONS(3003),
    [anon_sym_PLUS_DOT] = ACTIONS(3003),
    [anon_sym_DASH_DOT] = ACTIONS(3003),
    [anon_sym_PERCENT] = ACTIONS(3003),
    [anon_sym_AMP_AMP] = ACTIONS(3003),
    [anon_sym_TILDE] = ACTIONS(3005),
    [aux_sym_prefix_op_token1] = ACTIONS(3003),
    [aux_sym_infix_op_token1] = ACTIONS(3005),
    [aux_sym_infix_op_token2] = ACTIONS(3003),
    [anon_sym_PIPE_PIPE] = ACTIONS(3003),
    [anon_sym_BANG_EQ] = ACTIONS(3003),
    [anon_sym_COLON_EQ] = ACTIONS(3005),
    [anon_sym_DOLLAR] = ACTIONS(3003),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3003),
    [sym_int] = ACTIONS(3003),
    [sym_xint] = ACTIONS(3005),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3005),
    [anon_sym_POUNDendif] = ACTIONS(3005),
    [sym__newline] = ACTIONS(3005),
  },
  [2256] = {
    [sym_block_comment] = STATE(2256),
    [sym_compiler_directive_decl] = STATE(2256),
    [sym_fsi_directive_decl] = STATE(2256),
    [sym_preproc_line] = STATE(2256),
    [sym_identifier] = ACTIONS(2966),
    [anon_sym_EQ] = ACTIONS(2968),
    [anon_sym_COLON] = ACTIONS(2966),
    [anon_sym_return] = ACTIONS(2966),
    [anon_sym_do] = ACTIONS(2966),
    [anon_sym_let] = ACTIONS(2966),
    [anon_sym_let_BANG] = ACTIONS(2968),
    [anon_sym_LPAREN] = ACTIONS(2966),
    [anon_sym_COMMA] = ACTIONS(2968),
    [anon_sym_null] = ACTIONS(2966),
    [anon_sym_QMARK] = ACTIONS(2966),
    [anon_sym_COLON_QMARK] = ACTIONS(2966),
    [anon_sym_COLON_COLON] = ACTIONS(2968),
    [anon_sym_AMP] = ACTIONS(2966),
    [anon_sym_LBRACK] = ACTIONS(2966),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2968),
    [anon_sym_LBRACE] = ACTIONS(2966),
    [anon_sym_LT_AT] = ACTIONS(2966),
    [anon_sym_AT_GT] = ACTIONS(2966),
    [anon_sym_LT_AT_AT] = ACTIONS(2966),
    [anon_sym_DOT] = ACTIONS(2966),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2968),
    [anon_sym_new] = ACTIONS(2966),
    [anon_sym_return_BANG] = ACTIONS(2968),
    [anon_sym_yield] = ACTIONS(2966),
    [anon_sym_yield_BANG] = ACTIONS(2968),
    [anon_sym_lazy] = ACTIONS(2966),
    [anon_sym_assert] = ACTIONS(2966),
    [anon_sym_upcast] = ACTIONS(2966),
    [anon_sym_downcast] = ACTIONS(2966),
    [anon_sym_COLON_GT] = ACTIONS(2968),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2968),
    [anon_sym_for] = ACTIONS(2966),
    [anon_sym_while] = ACTIONS(2966),
    [anon_sym_if] = ACTIONS(2966),
    [anon_sym_fun] = ACTIONS(2966),
    [anon_sym_try] = ACTIONS(2966),
    [anon_sym_match] = ACTIONS(2966),
    [anon_sym_match_BANG] = ACTIONS(2968),
    [anon_sym_function] = ACTIONS(2966),
    [anon_sym_LT_DASH] = ACTIONS(2966),
    [anon_sym_DOT_LBRACK] = ACTIONS(2968),
    [anon_sym_LT] = ACTIONS(2968),
    [anon_sym_use] = ACTIONS(2966),
    [anon_sym_use_BANG] = ACTIONS(2968),
    [anon_sym_do_BANG] = ACTIONS(2968),
    [anon_sym_begin] = ACTIONS(2966),
    [anon_sym_LPAREN2] = ACTIONS(2966),
    [anon_sym_or] = ACTIONS(2966),
    [aux_sym_char_token1] = ACTIONS(2968),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2966),
    [anon_sym_DQUOTE] = ACTIONS(2966),
    [anon_sym_AT_DQUOTE] = ACTIONS(2968),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2968),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2968),
    [sym_bool] = ACTIONS(2966),
    [sym_unit] = ACTIONS(2968),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2966),
    [sym_op_identifier] = ACTIONS(2966),
    [anon_sym_PLUS] = ACTIONS(2966),
    [anon_sym_DASH] = ACTIONS(2966),
    [anon_sym_PLUS_DOT] = ACTIONS(2966),
    [anon_sym_DASH_DOT] = ACTIONS(2966),
    [anon_sym_PERCENT] = ACTIONS(2966),
    [anon_sym_AMP_AMP] = ACTIONS(2966),
    [anon_sym_TILDE] = ACTIONS(2968),
    [aux_sym_prefix_op_token1] = ACTIONS(2966),
    [aux_sym_infix_op_token1] = ACTIONS(2968),
    [aux_sym_infix_op_token2] = ACTIONS(2966),
    [anon_sym_PIPE_PIPE] = ACTIONS(2966),
    [anon_sym_BANG_EQ] = ACTIONS(2966),
    [anon_sym_COLON_EQ] = ACTIONS(2968),
    [anon_sym_DOLLAR] = ACTIONS(2966),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2966),
    [sym_int] = ACTIONS(2966),
    [sym_xint] = ACTIONS(2968),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2968),
    [sym__newline] = ACTIONS(2968),
  },
  [2257] = {
    [sym_block_comment] = STATE(2257),
    [sym_compiler_directive_decl] = STATE(2257),
    [sym_fsi_directive_decl] = STATE(2257),
    [sym_preproc_line] = STATE(2257),
    [sym_identifier] = ACTIONS(2962),
    [anon_sym_EQ] = ACTIONS(2964),
    [anon_sym_COLON] = ACTIONS(2962),
    [anon_sym_return] = ACTIONS(2962),
    [anon_sym_do] = ACTIONS(2962),
    [anon_sym_let] = ACTIONS(2962),
    [anon_sym_let_BANG] = ACTIONS(2964),
    [anon_sym_LPAREN] = ACTIONS(2962),
    [anon_sym_COMMA] = ACTIONS(2964),
    [anon_sym_null] = ACTIONS(2962),
    [anon_sym_QMARK] = ACTIONS(2962),
    [anon_sym_COLON_QMARK] = ACTIONS(2962),
    [anon_sym_COLON_COLON] = ACTIONS(2964),
    [anon_sym_AMP] = ACTIONS(2962),
    [anon_sym_LBRACK] = ACTIONS(2962),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2964),
    [anon_sym_LBRACE] = ACTIONS(2962),
    [anon_sym_LT_AT] = ACTIONS(2962),
    [anon_sym_AT_GT] = ACTIONS(2962),
    [anon_sym_LT_AT_AT] = ACTIONS(2962),
    [anon_sym_DOT] = ACTIONS(2962),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2964),
    [anon_sym_new] = ACTIONS(2962),
    [anon_sym_return_BANG] = ACTIONS(2964),
    [anon_sym_yield] = ACTIONS(2962),
    [anon_sym_yield_BANG] = ACTIONS(2964),
    [anon_sym_lazy] = ACTIONS(2962),
    [anon_sym_assert] = ACTIONS(2962),
    [anon_sym_upcast] = ACTIONS(2962),
    [anon_sym_downcast] = ACTIONS(2962),
    [anon_sym_COLON_GT] = ACTIONS(2964),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2964),
    [anon_sym_for] = ACTIONS(2962),
    [anon_sym_while] = ACTIONS(2962),
    [anon_sym_if] = ACTIONS(2962),
    [anon_sym_fun] = ACTIONS(2962),
    [anon_sym_try] = ACTIONS(2962),
    [anon_sym_match] = ACTIONS(2962),
    [anon_sym_match_BANG] = ACTIONS(2964),
    [anon_sym_function] = ACTIONS(2962),
    [anon_sym_LT_DASH] = ACTIONS(2962),
    [anon_sym_DOT_LBRACK] = ACTIONS(2964),
    [anon_sym_LT] = ACTIONS(2964),
    [anon_sym_use] = ACTIONS(2962),
    [anon_sym_use_BANG] = ACTIONS(2964),
    [anon_sym_do_BANG] = ACTIONS(2964),
    [anon_sym_begin] = ACTIONS(2962),
    [anon_sym_LPAREN2] = ACTIONS(2962),
    [anon_sym_or] = ACTIONS(2962),
    [aux_sym_char_token1] = ACTIONS(2964),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2962),
    [anon_sym_DQUOTE] = ACTIONS(2962),
    [anon_sym_AT_DQUOTE] = ACTIONS(2964),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2964),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2964),
    [sym_bool] = ACTIONS(2962),
    [sym_unit] = ACTIONS(2964),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2962),
    [sym_op_identifier] = ACTIONS(2962),
    [anon_sym_PLUS] = ACTIONS(2962),
    [anon_sym_DASH] = ACTIONS(2962),
    [anon_sym_PLUS_DOT] = ACTIONS(2962),
    [anon_sym_DASH_DOT] = ACTIONS(2962),
    [anon_sym_PERCENT] = ACTIONS(2962),
    [anon_sym_AMP_AMP] = ACTIONS(2962),
    [anon_sym_TILDE] = ACTIONS(2964),
    [aux_sym_prefix_op_token1] = ACTIONS(2962),
    [aux_sym_infix_op_token1] = ACTIONS(2964),
    [aux_sym_infix_op_token2] = ACTIONS(2962),
    [anon_sym_PIPE_PIPE] = ACTIONS(2962),
    [anon_sym_BANG_EQ] = ACTIONS(2962),
    [anon_sym_COLON_EQ] = ACTIONS(2964),
    [anon_sym_DOLLAR] = ACTIONS(2962),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2962),
    [sym_int] = ACTIONS(2962),
    [sym_xint] = ACTIONS(2964),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2964),
    [sym__newline] = ACTIONS(2964),
  },
  [2258] = {
    [sym_block_comment] = STATE(2258),
    [sym_compiler_directive_decl] = STATE(2258),
    [sym_fsi_directive_decl] = STATE(2258),
    [sym_preproc_line] = STATE(2258),
    [sym_identifier] = ACTIONS(2958),
    [anon_sym_EQ] = ACTIONS(2960),
    [anon_sym_COLON] = ACTIONS(2958),
    [anon_sym_return] = ACTIONS(2958),
    [anon_sym_do] = ACTIONS(2958),
    [anon_sym_let] = ACTIONS(2958),
    [anon_sym_let_BANG] = ACTIONS(2960),
    [anon_sym_LPAREN] = ACTIONS(2958),
    [anon_sym_COMMA] = ACTIONS(2960),
    [anon_sym_null] = ACTIONS(2958),
    [anon_sym_QMARK] = ACTIONS(2958),
    [anon_sym_COLON_QMARK] = ACTIONS(2958),
    [anon_sym_COLON_COLON] = ACTIONS(2960),
    [anon_sym_AMP] = ACTIONS(2958),
    [anon_sym_LBRACK] = ACTIONS(2958),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2960),
    [anon_sym_LBRACE] = ACTIONS(2958),
    [anon_sym_LT_AT] = ACTIONS(2958),
    [anon_sym_AT_GT] = ACTIONS(2958),
    [anon_sym_LT_AT_AT] = ACTIONS(2958),
    [anon_sym_DOT] = ACTIONS(2958),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2960),
    [anon_sym_new] = ACTIONS(2958),
    [anon_sym_return_BANG] = ACTIONS(2960),
    [anon_sym_yield] = ACTIONS(2958),
    [anon_sym_yield_BANG] = ACTIONS(2960),
    [anon_sym_lazy] = ACTIONS(2958),
    [anon_sym_assert] = ACTIONS(2958),
    [anon_sym_upcast] = ACTIONS(2958),
    [anon_sym_downcast] = ACTIONS(2958),
    [anon_sym_COLON_GT] = ACTIONS(2960),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2960),
    [anon_sym_for] = ACTIONS(2958),
    [anon_sym_while] = ACTIONS(2958),
    [anon_sym_if] = ACTIONS(2958),
    [anon_sym_fun] = ACTIONS(2958),
    [anon_sym_try] = ACTIONS(2958),
    [anon_sym_match] = ACTIONS(2958),
    [anon_sym_match_BANG] = ACTIONS(2960),
    [anon_sym_function] = ACTIONS(2958),
    [anon_sym_LT_DASH] = ACTIONS(2958),
    [anon_sym_DOT_LBRACK] = ACTIONS(2960),
    [anon_sym_LT] = ACTIONS(2960),
    [anon_sym_use] = ACTIONS(2958),
    [anon_sym_use_BANG] = ACTIONS(2960),
    [anon_sym_do_BANG] = ACTIONS(2960),
    [anon_sym_begin] = ACTIONS(2958),
    [anon_sym_LPAREN2] = ACTIONS(2958),
    [anon_sym_or] = ACTIONS(2958),
    [aux_sym_char_token1] = ACTIONS(2960),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2958),
    [anon_sym_DQUOTE] = ACTIONS(2958),
    [anon_sym_AT_DQUOTE] = ACTIONS(2960),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2960),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2960),
    [sym_bool] = ACTIONS(2958),
    [sym_unit] = ACTIONS(2960),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2958),
    [sym_op_identifier] = ACTIONS(2958),
    [anon_sym_PLUS] = ACTIONS(2958),
    [anon_sym_DASH] = ACTIONS(2958),
    [anon_sym_PLUS_DOT] = ACTIONS(2958),
    [anon_sym_DASH_DOT] = ACTIONS(2958),
    [anon_sym_PERCENT] = ACTIONS(2958),
    [anon_sym_AMP_AMP] = ACTIONS(2958),
    [anon_sym_TILDE] = ACTIONS(2960),
    [aux_sym_prefix_op_token1] = ACTIONS(2958),
    [aux_sym_infix_op_token1] = ACTIONS(2960),
    [aux_sym_infix_op_token2] = ACTIONS(2958),
    [anon_sym_PIPE_PIPE] = ACTIONS(2958),
    [anon_sym_BANG_EQ] = ACTIONS(2958),
    [anon_sym_COLON_EQ] = ACTIONS(2960),
    [anon_sym_DOLLAR] = ACTIONS(2958),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2958),
    [sym_int] = ACTIONS(2958),
    [sym_xint] = ACTIONS(2960),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2960),
    [sym__newline] = ACTIONS(2960),
  },
  [2259] = {
    [sym_block_comment] = STATE(2259),
    [sym_compiler_directive_decl] = STATE(2259),
    [sym_fsi_directive_decl] = STATE(2259),
    [sym_preproc_line] = STATE(2259),
    [sym_identifier] = ACTIONS(2950),
    [anon_sym_EQ] = ACTIONS(2952),
    [anon_sym_COLON] = ACTIONS(2950),
    [anon_sym_return] = ACTIONS(2950),
    [anon_sym_do] = ACTIONS(2950),
    [anon_sym_let] = ACTIONS(2950),
    [anon_sym_let_BANG] = ACTIONS(2952),
    [anon_sym_LPAREN] = ACTIONS(2950),
    [anon_sym_COMMA] = ACTIONS(2952),
    [anon_sym_null] = ACTIONS(2950),
    [anon_sym_QMARK] = ACTIONS(2950),
    [anon_sym_COLON_QMARK] = ACTIONS(2950),
    [anon_sym_COLON_COLON] = ACTIONS(2952),
    [anon_sym_AMP] = ACTIONS(2950),
    [anon_sym_LBRACK] = ACTIONS(2950),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2952),
    [anon_sym_LBRACE] = ACTIONS(2950),
    [anon_sym_LT_AT] = ACTIONS(2950),
    [anon_sym_AT_GT] = ACTIONS(2950),
    [anon_sym_LT_AT_AT] = ACTIONS(2950),
    [anon_sym_DOT] = ACTIONS(2950),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2952),
    [anon_sym_new] = ACTIONS(2950),
    [anon_sym_return_BANG] = ACTIONS(2952),
    [anon_sym_yield] = ACTIONS(2950),
    [anon_sym_yield_BANG] = ACTIONS(2952),
    [anon_sym_lazy] = ACTIONS(2950),
    [anon_sym_assert] = ACTIONS(2950),
    [anon_sym_upcast] = ACTIONS(2950),
    [anon_sym_downcast] = ACTIONS(2950),
    [anon_sym_COLON_GT] = ACTIONS(2952),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2952),
    [anon_sym_for] = ACTIONS(2950),
    [anon_sym_while] = ACTIONS(2950),
    [anon_sym_if] = ACTIONS(2950),
    [anon_sym_fun] = ACTIONS(2950),
    [anon_sym_try] = ACTIONS(2950),
    [anon_sym_match] = ACTIONS(2950),
    [anon_sym_match_BANG] = ACTIONS(2952),
    [anon_sym_function] = ACTIONS(2950),
    [anon_sym_LT_DASH] = ACTIONS(2950),
    [anon_sym_DOT_LBRACK] = ACTIONS(2952),
    [anon_sym_LT] = ACTIONS(2952),
    [anon_sym_use] = ACTIONS(2950),
    [anon_sym_use_BANG] = ACTIONS(2952),
    [anon_sym_do_BANG] = ACTIONS(2952),
    [anon_sym_begin] = ACTIONS(2950),
    [anon_sym_LPAREN2] = ACTIONS(2950),
    [anon_sym_or] = ACTIONS(2950),
    [aux_sym_char_token1] = ACTIONS(2952),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2950),
    [anon_sym_DQUOTE] = ACTIONS(2950),
    [anon_sym_AT_DQUOTE] = ACTIONS(2952),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2952),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2952),
    [sym_bool] = ACTIONS(2950),
    [sym_unit] = ACTIONS(2952),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2950),
    [sym_op_identifier] = ACTIONS(2950),
    [anon_sym_PLUS] = ACTIONS(2950),
    [anon_sym_DASH] = ACTIONS(2950),
    [anon_sym_PLUS_DOT] = ACTIONS(2950),
    [anon_sym_DASH_DOT] = ACTIONS(2950),
    [anon_sym_PERCENT] = ACTIONS(2950),
    [anon_sym_AMP_AMP] = ACTIONS(2950),
    [anon_sym_TILDE] = ACTIONS(2952),
    [aux_sym_prefix_op_token1] = ACTIONS(2950),
    [aux_sym_infix_op_token1] = ACTIONS(2952),
    [aux_sym_infix_op_token2] = ACTIONS(2950),
    [anon_sym_PIPE_PIPE] = ACTIONS(2950),
    [anon_sym_BANG_EQ] = ACTIONS(2950),
    [anon_sym_COLON_EQ] = ACTIONS(2952),
    [anon_sym_DOLLAR] = ACTIONS(2950),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2950),
    [sym_int] = ACTIONS(2950),
    [sym_xint] = ACTIONS(2952),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2952),
    [sym__newline] = ACTIONS(2952),
  },
  [2260] = {
    [sym_block_comment] = STATE(2260),
    [sym_compiler_directive_decl] = STATE(2260),
    [sym_fsi_directive_decl] = STATE(2260),
    [sym_preproc_line] = STATE(2260),
    [sym_identifier] = ACTIONS(2843),
    [anon_sym_EQ] = ACTIONS(2845),
    [anon_sym_COLON] = ACTIONS(2843),
    [anon_sym_return] = ACTIONS(2843),
    [anon_sym_do] = ACTIONS(2843),
    [anon_sym_let] = ACTIONS(2843),
    [anon_sym_let_BANG] = ACTIONS(2845),
    [anon_sym_LPAREN] = ACTIONS(2843),
    [anon_sym_COMMA] = ACTIONS(2845),
    [anon_sym_null] = ACTIONS(2843),
    [anon_sym_QMARK] = ACTIONS(2843),
    [anon_sym_COLON_QMARK] = ACTIONS(2843),
    [anon_sym_COLON_COLON] = ACTIONS(2845),
    [anon_sym_AMP] = ACTIONS(2843),
    [anon_sym_LBRACK] = ACTIONS(2843),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2845),
    [anon_sym_LBRACE] = ACTIONS(2843),
    [anon_sym_LT_AT] = ACTIONS(2843),
    [anon_sym_LT_AT_AT] = ACTIONS(2843),
    [anon_sym_AT_AT_GT] = ACTIONS(2843),
    [anon_sym_DOT] = ACTIONS(2843),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2845),
    [anon_sym_new] = ACTIONS(2843),
    [anon_sym_return_BANG] = ACTIONS(2845),
    [anon_sym_yield] = ACTIONS(2843),
    [anon_sym_yield_BANG] = ACTIONS(2845),
    [anon_sym_lazy] = ACTIONS(2843),
    [anon_sym_assert] = ACTIONS(2843),
    [anon_sym_upcast] = ACTIONS(2843),
    [anon_sym_downcast] = ACTIONS(2843),
    [anon_sym_COLON_GT] = ACTIONS(2845),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2845),
    [anon_sym_for] = ACTIONS(2843),
    [anon_sym_while] = ACTIONS(2843),
    [anon_sym_if] = ACTIONS(2843),
    [anon_sym_fun] = ACTIONS(2843),
    [anon_sym_try] = ACTIONS(2843),
    [anon_sym_match] = ACTIONS(2843),
    [anon_sym_match_BANG] = ACTIONS(2845),
    [anon_sym_function] = ACTIONS(2843),
    [anon_sym_LT_DASH] = ACTIONS(2843),
    [anon_sym_DOT_LBRACK] = ACTIONS(2845),
    [anon_sym_LT] = ACTIONS(2845),
    [anon_sym_use] = ACTIONS(2843),
    [anon_sym_use_BANG] = ACTIONS(2845),
    [anon_sym_do_BANG] = ACTIONS(2845),
    [anon_sym_begin] = ACTIONS(2843),
    [anon_sym_LPAREN2] = ACTIONS(2843),
    [anon_sym_or] = ACTIONS(2843),
    [aux_sym_char_token1] = ACTIONS(2845),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2843),
    [anon_sym_DQUOTE] = ACTIONS(2843),
    [anon_sym_AT_DQUOTE] = ACTIONS(2845),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2845),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2845),
    [sym_bool] = ACTIONS(2843),
    [sym_unit] = ACTIONS(2845),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2843),
    [sym_op_identifier] = ACTIONS(2843),
    [anon_sym_PLUS] = ACTIONS(2843),
    [anon_sym_DASH] = ACTIONS(2843),
    [anon_sym_PLUS_DOT] = ACTIONS(2843),
    [anon_sym_DASH_DOT] = ACTIONS(2843),
    [anon_sym_PERCENT] = ACTIONS(2843),
    [anon_sym_AMP_AMP] = ACTIONS(2843),
    [anon_sym_TILDE] = ACTIONS(2845),
    [aux_sym_prefix_op_token1] = ACTIONS(2843),
    [aux_sym_infix_op_token1] = ACTIONS(2845),
    [aux_sym_infix_op_token2] = ACTIONS(2843),
    [anon_sym_PIPE_PIPE] = ACTIONS(2843),
    [anon_sym_BANG_EQ] = ACTIONS(2843),
    [anon_sym_COLON_EQ] = ACTIONS(2845),
    [anon_sym_DOLLAR] = ACTIONS(2843),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2843),
    [sym_int] = ACTIONS(2843),
    [sym_xint] = ACTIONS(2845),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2845),
    [sym__newline] = ACTIONS(2845),
  },
  [2261] = {
    [sym_block_comment] = STATE(2261),
    [sym_compiler_directive_decl] = STATE(2261),
    [sym_fsi_directive_decl] = STATE(2261),
    [sym_preproc_line] = STATE(2261),
    [sym_identifier] = ACTIONS(2158),
    [anon_sym_EQ] = ACTIONS(2160),
    [anon_sym_COLON] = ACTIONS(2158),
    [anon_sym_return] = ACTIONS(2158),
    [anon_sym_do] = ACTIONS(2158),
    [anon_sym_let] = ACTIONS(2158),
    [anon_sym_let_BANG] = ACTIONS(2160),
    [anon_sym_LPAREN] = ACTIONS(2158),
    [anon_sym_COMMA] = ACTIONS(2160),
    [anon_sym_null] = ACTIONS(2158),
    [anon_sym_QMARK] = ACTIONS(2158),
    [anon_sym_COLON_QMARK] = ACTIONS(2158),
    [anon_sym_COLON_COLON] = ACTIONS(2160),
    [anon_sym_AMP] = ACTIONS(2158),
    [anon_sym_LBRACK] = ACTIONS(2158),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2160),
    [anon_sym_LBRACE] = ACTIONS(2158),
    [anon_sym_LT_AT] = ACTIONS(2158),
    [anon_sym_LT_AT_AT] = ACTIONS(2158),
    [anon_sym_AT_AT_GT] = ACTIONS(2158),
    [anon_sym_DOT] = ACTIONS(2158),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2160),
    [anon_sym_new] = ACTIONS(2158),
    [anon_sym_return_BANG] = ACTIONS(2160),
    [anon_sym_yield] = ACTIONS(2158),
    [anon_sym_yield_BANG] = ACTIONS(2160),
    [anon_sym_lazy] = ACTIONS(2158),
    [anon_sym_assert] = ACTIONS(2158),
    [anon_sym_upcast] = ACTIONS(2158),
    [anon_sym_downcast] = ACTIONS(2158),
    [anon_sym_COLON_GT] = ACTIONS(2160),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2160),
    [anon_sym_for] = ACTIONS(2158),
    [anon_sym_while] = ACTIONS(2158),
    [anon_sym_if] = ACTIONS(2158),
    [anon_sym_fun] = ACTIONS(2158),
    [anon_sym_try] = ACTIONS(2158),
    [anon_sym_match] = ACTIONS(2158),
    [anon_sym_match_BANG] = ACTIONS(2160),
    [anon_sym_function] = ACTIONS(2158),
    [anon_sym_LT_DASH] = ACTIONS(2158),
    [anon_sym_DOT_LBRACK] = ACTIONS(2160),
    [anon_sym_LT] = ACTIONS(2160),
    [anon_sym_use] = ACTIONS(2158),
    [anon_sym_use_BANG] = ACTIONS(2160),
    [anon_sym_do_BANG] = ACTIONS(2160),
    [anon_sym_begin] = ACTIONS(2158),
    [anon_sym_LPAREN2] = ACTIONS(2158),
    [anon_sym_or] = ACTIONS(2158),
    [aux_sym_char_token1] = ACTIONS(2160),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2158),
    [anon_sym_DQUOTE] = ACTIONS(2158),
    [anon_sym_AT_DQUOTE] = ACTIONS(2160),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2160),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2160),
    [sym_bool] = ACTIONS(2158),
    [sym_unit] = ACTIONS(2160),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2158),
    [sym_op_identifier] = ACTIONS(2158),
    [anon_sym_PLUS] = ACTIONS(2158),
    [anon_sym_DASH] = ACTIONS(2158),
    [anon_sym_PLUS_DOT] = ACTIONS(2158),
    [anon_sym_DASH_DOT] = ACTIONS(2158),
    [anon_sym_PERCENT] = ACTIONS(2158),
    [anon_sym_AMP_AMP] = ACTIONS(2158),
    [anon_sym_TILDE] = ACTIONS(2160),
    [aux_sym_prefix_op_token1] = ACTIONS(2158),
    [aux_sym_infix_op_token1] = ACTIONS(2160),
    [aux_sym_infix_op_token2] = ACTIONS(2158),
    [anon_sym_PIPE_PIPE] = ACTIONS(2158),
    [anon_sym_BANG_EQ] = ACTIONS(2158),
    [anon_sym_COLON_EQ] = ACTIONS(2160),
    [anon_sym_DOLLAR] = ACTIONS(2158),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2158),
    [sym_int] = ACTIONS(2158),
    [sym_xint] = ACTIONS(2160),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2160),
    [sym__newline] = ACTIONS(2160),
  },
  [2262] = {
    [sym_block_comment] = STATE(2262),
    [sym_compiler_directive_decl] = STATE(2262),
    [sym_fsi_directive_decl] = STATE(2262),
    [sym_preproc_line] = STATE(2262),
    [sym_identifier] = ACTIONS(2984),
    [anon_sym_EQ] = ACTIONS(2986),
    [anon_sym_COLON] = ACTIONS(2984),
    [anon_sym_return] = ACTIONS(2984),
    [anon_sym_do] = ACTIONS(2984),
    [anon_sym_let] = ACTIONS(2984),
    [anon_sym_let_BANG] = ACTIONS(2986),
    [anon_sym_LPAREN] = ACTIONS(2984),
    [anon_sym_COMMA] = ACTIONS(2986),
    [anon_sym_null] = ACTIONS(2984),
    [anon_sym_QMARK] = ACTIONS(2984),
    [anon_sym_COLON_QMARK] = ACTIONS(2984),
    [anon_sym_COLON_COLON] = ACTIONS(2986),
    [anon_sym_AMP] = ACTIONS(2984),
    [anon_sym_LBRACK] = ACTIONS(2984),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2986),
    [anon_sym_LBRACE] = ACTIONS(2984),
    [anon_sym_LT_AT] = ACTIONS(2984),
    [anon_sym_AT_GT] = ACTIONS(2984),
    [anon_sym_LT_AT_AT] = ACTIONS(2984),
    [anon_sym_DOT] = ACTIONS(2984),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2986),
    [anon_sym_new] = ACTIONS(2984),
    [anon_sym_return_BANG] = ACTIONS(2986),
    [anon_sym_yield] = ACTIONS(2984),
    [anon_sym_yield_BANG] = ACTIONS(2986),
    [anon_sym_lazy] = ACTIONS(2984),
    [anon_sym_assert] = ACTIONS(2984),
    [anon_sym_upcast] = ACTIONS(2984),
    [anon_sym_downcast] = ACTIONS(2984),
    [anon_sym_COLON_GT] = ACTIONS(2986),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2986),
    [anon_sym_for] = ACTIONS(2984),
    [anon_sym_while] = ACTIONS(2984),
    [anon_sym_if] = ACTIONS(2984),
    [anon_sym_fun] = ACTIONS(2984),
    [anon_sym_try] = ACTIONS(2984),
    [anon_sym_match] = ACTIONS(2984),
    [anon_sym_match_BANG] = ACTIONS(2986),
    [anon_sym_function] = ACTIONS(2984),
    [anon_sym_LT_DASH] = ACTIONS(2984),
    [anon_sym_DOT_LBRACK] = ACTIONS(2986),
    [anon_sym_LT] = ACTIONS(2986),
    [anon_sym_use] = ACTIONS(2984),
    [anon_sym_use_BANG] = ACTIONS(2986),
    [anon_sym_do_BANG] = ACTIONS(2986),
    [anon_sym_begin] = ACTIONS(2984),
    [anon_sym_LPAREN2] = ACTIONS(2984),
    [anon_sym_or] = ACTIONS(2984),
    [aux_sym_char_token1] = ACTIONS(2986),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2984),
    [anon_sym_DQUOTE] = ACTIONS(2984),
    [anon_sym_AT_DQUOTE] = ACTIONS(2986),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2986),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2986),
    [sym_bool] = ACTIONS(2984),
    [sym_unit] = ACTIONS(2986),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2984),
    [sym_op_identifier] = ACTIONS(2984),
    [anon_sym_PLUS] = ACTIONS(2984),
    [anon_sym_DASH] = ACTIONS(2984),
    [anon_sym_PLUS_DOT] = ACTIONS(2984),
    [anon_sym_DASH_DOT] = ACTIONS(2984),
    [anon_sym_PERCENT] = ACTIONS(2984),
    [anon_sym_AMP_AMP] = ACTIONS(2984),
    [anon_sym_TILDE] = ACTIONS(2986),
    [aux_sym_prefix_op_token1] = ACTIONS(2984),
    [aux_sym_infix_op_token1] = ACTIONS(2986),
    [aux_sym_infix_op_token2] = ACTIONS(2984),
    [anon_sym_PIPE_PIPE] = ACTIONS(2984),
    [anon_sym_BANG_EQ] = ACTIONS(2984),
    [anon_sym_COLON_EQ] = ACTIONS(2986),
    [anon_sym_DOLLAR] = ACTIONS(2984),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2984),
    [sym_int] = ACTIONS(2984),
    [sym_xint] = ACTIONS(2986),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2986),
    [sym__newline] = ACTIONS(2986),
  },
  [2263] = {
    [sym_block_comment] = STATE(2263),
    [sym_compiler_directive_decl] = STATE(2263),
    [sym_fsi_directive_decl] = STATE(2263),
    [sym_preproc_line] = STATE(2263),
    [sym_identifier] = ACTIONS(2946),
    [anon_sym_EQ] = ACTIONS(2948),
    [anon_sym_COLON] = ACTIONS(2946),
    [anon_sym_return] = ACTIONS(2946),
    [anon_sym_do] = ACTIONS(2946),
    [anon_sym_let] = ACTIONS(2946),
    [anon_sym_let_BANG] = ACTIONS(2948),
    [anon_sym_LPAREN] = ACTIONS(2946),
    [anon_sym_COMMA] = ACTIONS(2948),
    [anon_sym_null] = ACTIONS(2946),
    [anon_sym_QMARK] = ACTIONS(2946),
    [anon_sym_COLON_QMARK] = ACTIONS(2946),
    [anon_sym_COLON_COLON] = ACTIONS(2948),
    [anon_sym_AMP] = ACTIONS(2946),
    [anon_sym_LBRACK] = ACTIONS(2946),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2948),
    [anon_sym_LBRACE] = ACTIONS(2946),
    [anon_sym_LT_AT] = ACTIONS(2946),
    [anon_sym_AT_GT] = ACTIONS(2946),
    [anon_sym_LT_AT_AT] = ACTIONS(2946),
    [anon_sym_DOT] = ACTIONS(2946),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2948),
    [anon_sym_new] = ACTIONS(2946),
    [anon_sym_return_BANG] = ACTIONS(2948),
    [anon_sym_yield] = ACTIONS(2946),
    [anon_sym_yield_BANG] = ACTIONS(2948),
    [anon_sym_lazy] = ACTIONS(2946),
    [anon_sym_assert] = ACTIONS(2946),
    [anon_sym_upcast] = ACTIONS(2946),
    [anon_sym_downcast] = ACTIONS(2946),
    [anon_sym_COLON_GT] = ACTIONS(2948),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2948),
    [anon_sym_for] = ACTIONS(2946),
    [anon_sym_while] = ACTIONS(2946),
    [anon_sym_if] = ACTIONS(2946),
    [anon_sym_fun] = ACTIONS(2946),
    [anon_sym_try] = ACTIONS(2946),
    [anon_sym_match] = ACTIONS(2946),
    [anon_sym_match_BANG] = ACTIONS(2948),
    [anon_sym_function] = ACTIONS(2946),
    [anon_sym_LT_DASH] = ACTIONS(2946),
    [anon_sym_DOT_LBRACK] = ACTIONS(2948),
    [anon_sym_LT] = ACTIONS(2948),
    [anon_sym_use] = ACTIONS(2946),
    [anon_sym_use_BANG] = ACTIONS(2948),
    [anon_sym_do_BANG] = ACTIONS(2948),
    [anon_sym_begin] = ACTIONS(2946),
    [anon_sym_LPAREN2] = ACTIONS(2946),
    [anon_sym_or] = ACTIONS(2946),
    [aux_sym_char_token1] = ACTIONS(2948),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2946),
    [anon_sym_DQUOTE] = ACTIONS(2946),
    [anon_sym_AT_DQUOTE] = ACTIONS(2948),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2948),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2948),
    [sym_bool] = ACTIONS(2946),
    [sym_unit] = ACTIONS(2948),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2946),
    [sym_op_identifier] = ACTIONS(2946),
    [anon_sym_PLUS] = ACTIONS(2946),
    [anon_sym_DASH] = ACTIONS(2946),
    [anon_sym_PLUS_DOT] = ACTIONS(2946),
    [anon_sym_DASH_DOT] = ACTIONS(2946),
    [anon_sym_PERCENT] = ACTIONS(2946),
    [anon_sym_AMP_AMP] = ACTIONS(2946),
    [anon_sym_TILDE] = ACTIONS(2948),
    [aux_sym_prefix_op_token1] = ACTIONS(2946),
    [aux_sym_infix_op_token1] = ACTIONS(2948),
    [aux_sym_infix_op_token2] = ACTIONS(2946),
    [anon_sym_PIPE_PIPE] = ACTIONS(2946),
    [anon_sym_BANG_EQ] = ACTIONS(2946),
    [anon_sym_COLON_EQ] = ACTIONS(2948),
    [anon_sym_DOLLAR] = ACTIONS(2946),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2946),
    [sym_int] = ACTIONS(2946),
    [sym_xint] = ACTIONS(2948),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2948),
    [sym__newline] = ACTIONS(2948),
  },
  [2264] = {
    [sym_block_comment] = STATE(2264),
    [sym_compiler_directive_decl] = STATE(2264),
    [sym_fsi_directive_decl] = STATE(2264),
    [sym_preproc_line] = STATE(2264),
    [sym_identifier] = ACTIONS(2831),
    [anon_sym_EQ] = ACTIONS(2833),
    [anon_sym_COLON] = ACTIONS(2831),
    [anon_sym_return] = ACTIONS(2831),
    [anon_sym_do] = ACTIONS(2831),
    [anon_sym_let] = ACTIONS(2831),
    [anon_sym_let_BANG] = ACTIONS(2833),
    [anon_sym_LPAREN] = ACTIONS(2831),
    [anon_sym_COMMA] = ACTIONS(2833),
    [anon_sym_null] = ACTIONS(2831),
    [anon_sym_QMARK] = ACTIONS(2831),
    [anon_sym_COLON_QMARK] = ACTIONS(2831),
    [anon_sym_COLON_COLON] = ACTIONS(2833),
    [anon_sym_AMP] = ACTIONS(2831),
    [anon_sym_LBRACK] = ACTIONS(2831),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2833),
    [anon_sym_LBRACE] = ACTIONS(2831),
    [anon_sym_LT_AT] = ACTIONS(2831),
    [anon_sym_LT_AT_AT] = ACTIONS(2831),
    [anon_sym_AT_AT_GT] = ACTIONS(2831),
    [anon_sym_DOT] = ACTIONS(2831),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2833),
    [anon_sym_new] = ACTIONS(2831),
    [anon_sym_return_BANG] = ACTIONS(2833),
    [anon_sym_yield] = ACTIONS(2831),
    [anon_sym_yield_BANG] = ACTIONS(2833),
    [anon_sym_lazy] = ACTIONS(2831),
    [anon_sym_assert] = ACTIONS(2831),
    [anon_sym_upcast] = ACTIONS(2831),
    [anon_sym_downcast] = ACTIONS(2831),
    [anon_sym_COLON_GT] = ACTIONS(2833),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2833),
    [anon_sym_for] = ACTIONS(2831),
    [anon_sym_while] = ACTIONS(2831),
    [anon_sym_if] = ACTIONS(2831),
    [anon_sym_fun] = ACTIONS(2831),
    [anon_sym_try] = ACTIONS(2831),
    [anon_sym_match] = ACTIONS(2831),
    [anon_sym_match_BANG] = ACTIONS(2833),
    [anon_sym_function] = ACTIONS(2831),
    [anon_sym_LT_DASH] = ACTIONS(2831),
    [anon_sym_DOT_LBRACK] = ACTIONS(2833),
    [anon_sym_LT] = ACTIONS(2833),
    [anon_sym_use] = ACTIONS(2831),
    [anon_sym_use_BANG] = ACTIONS(2833),
    [anon_sym_do_BANG] = ACTIONS(2833),
    [anon_sym_begin] = ACTIONS(2831),
    [anon_sym_LPAREN2] = ACTIONS(2831),
    [anon_sym_or] = ACTIONS(2831),
    [aux_sym_char_token1] = ACTIONS(2833),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2831),
    [anon_sym_DQUOTE] = ACTIONS(2831),
    [anon_sym_AT_DQUOTE] = ACTIONS(2833),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2833),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2833),
    [sym_bool] = ACTIONS(2831),
    [sym_unit] = ACTIONS(2833),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2831),
    [sym_op_identifier] = ACTIONS(2831),
    [anon_sym_PLUS] = ACTIONS(2831),
    [anon_sym_DASH] = ACTIONS(2831),
    [anon_sym_PLUS_DOT] = ACTIONS(2831),
    [anon_sym_DASH_DOT] = ACTIONS(2831),
    [anon_sym_PERCENT] = ACTIONS(2831),
    [anon_sym_AMP_AMP] = ACTIONS(2831),
    [anon_sym_TILDE] = ACTIONS(2833),
    [aux_sym_prefix_op_token1] = ACTIONS(2831),
    [aux_sym_infix_op_token1] = ACTIONS(2833),
    [aux_sym_infix_op_token2] = ACTIONS(2831),
    [anon_sym_PIPE_PIPE] = ACTIONS(2831),
    [anon_sym_BANG_EQ] = ACTIONS(2831),
    [anon_sym_COLON_EQ] = ACTIONS(2833),
    [anon_sym_DOLLAR] = ACTIONS(2831),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2831),
    [sym_int] = ACTIONS(2831),
    [sym_xint] = ACTIONS(2833),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2833),
    [sym__newline] = ACTIONS(2833),
  },
  [2265] = {
    [sym_block_comment] = STATE(2265),
    [sym_compiler_directive_decl] = STATE(2265),
    [sym_fsi_directive_decl] = STATE(2265),
    [sym_preproc_line] = STATE(2265),
    [sym_identifier] = ACTIONS(3067),
    [anon_sym_EQ] = ACTIONS(3069),
    [anon_sym_COLON] = ACTIONS(3067),
    [anon_sym_return] = ACTIONS(3067),
    [anon_sym_do] = ACTIONS(3067),
    [anon_sym_let] = ACTIONS(3067),
    [anon_sym_let_BANG] = ACTIONS(3069),
    [anon_sym_LPAREN] = ACTIONS(3067),
    [anon_sym_COMMA] = ACTIONS(3069),
    [anon_sym_null] = ACTIONS(3067),
    [anon_sym_QMARK] = ACTIONS(3067),
    [anon_sym_COLON_QMARK] = ACTIONS(3067),
    [anon_sym_COLON_COLON] = ACTIONS(3069),
    [anon_sym_AMP] = ACTIONS(3067),
    [anon_sym_LBRACK] = ACTIONS(3067),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3069),
    [anon_sym_LBRACE] = ACTIONS(3067),
    [anon_sym_LT_AT] = ACTIONS(3067),
    [anon_sym_LT_AT_AT] = ACTIONS(3067),
    [anon_sym_AT_AT_GT] = ACTIONS(3067),
    [anon_sym_DOT] = ACTIONS(3067),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3069),
    [anon_sym_new] = ACTIONS(3067),
    [anon_sym_return_BANG] = ACTIONS(3069),
    [anon_sym_yield] = ACTIONS(3067),
    [anon_sym_yield_BANG] = ACTIONS(3069),
    [anon_sym_lazy] = ACTIONS(3067),
    [anon_sym_assert] = ACTIONS(3067),
    [anon_sym_upcast] = ACTIONS(3067),
    [anon_sym_downcast] = ACTIONS(3067),
    [anon_sym_COLON_GT] = ACTIONS(3069),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3069),
    [anon_sym_for] = ACTIONS(3067),
    [anon_sym_while] = ACTIONS(3067),
    [anon_sym_if] = ACTIONS(3067),
    [anon_sym_fun] = ACTIONS(3067),
    [anon_sym_try] = ACTIONS(3067),
    [anon_sym_match] = ACTIONS(3067),
    [anon_sym_match_BANG] = ACTIONS(3069),
    [anon_sym_function] = ACTIONS(3067),
    [anon_sym_LT_DASH] = ACTIONS(3067),
    [anon_sym_DOT_LBRACK] = ACTIONS(3069),
    [anon_sym_LT] = ACTIONS(3069),
    [anon_sym_use] = ACTIONS(3067),
    [anon_sym_use_BANG] = ACTIONS(3069),
    [anon_sym_do_BANG] = ACTIONS(3069),
    [anon_sym_begin] = ACTIONS(3067),
    [anon_sym_LPAREN2] = ACTIONS(3067),
    [anon_sym_or] = ACTIONS(3067),
    [aux_sym_char_token1] = ACTIONS(3069),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3067),
    [anon_sym_DQUOTE] = ACTIONS(3067),
    [anon_sym_AT_DQUOTE] = ACTIONS(3069),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3069),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3069),
    [sym_bool] = ACTIONS(3067),
    [sym_unit] = ACTIONS(3069),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3067),
    [sym_op_identifier] = ACTIONS(3067),
    [anon_sym_PLUS] = ACTIONS(3067),
    [anon_sym_DASH] = ACTIONS(3067),
    [anon_sym_PLUS_DOT] = ACTIONS(3067),
    [anon_sym_DASH_DOT] = ACTIONS(3067),
    [anon_sym_PERCENT] = ACTIONS(3067),
    [anon_sym_AMP_AMP] = ACTIONS(3067),
    [anon_sym_TILDE] = ACTIONS(3069),
    [aux_sym_prefix_op_token1] = ACTIONS(3067),
    [aux_sym_infix_op_token1] = ACTIONS(3069),
    [aux_sym_infix_op_token2] = ACTIONS(3067),
    [anon_sym_PIPE_PIPE] = ACTIONS(3067),
    [anon_sym_BANG_EQ] = ACTIONS(3067),
    [anon_sym_COLON_EQ] = ACTIONS(3069),
    [anon_sym_DOLLAR] = ACTIONS(3067),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3067),
    [sym_int] = ACTIONS(3067),
    [sym_xint] = ACTIONS(3069),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3069),
    [sym__newline] = ACTIONS(3069),
  },
  [2266] = {
    [sym_block_comment] = STATE(2266),
    [sym_compiler_directive_decl] = STATE(2266),
    [sym_fsi_directive_decl] = STATE(2266),
    [sym_preproc_line] = STATE(2266),
    [sym_identifier] = ACTIONS(3071),
    [anon_sym_EQ] = ACTIONS(3073),
    [anon_sym_COLON] = ACTIONS(3071),
    [anon_sym_return] = ACTIONS(3071),
    [anon_sym_do] = ACTIONS(3071),
    [anon_sym_let] = ACTIONS(3071),
    [anon_sym_let_BANG] = ACTIONS(3073),
    [anon_sym_LPAREN] = ACTIONS(3071),
    [anon_sym_COMMA] = ACTIONS(3073),
    [anon_sym_null] = ACTIONS(3071),
    [anon_sym_QMARK] = ACTIONS(3071),
    [anon_sym_COLON_QMARK] = ACTIONS(3071),
    [anon_sym_COLON_COLON] = ACTIONS(3073),
    [anon_sym_AMP] = ACTIONS(3071),
    [anon_sym_LBRACK] = ACTIONS(3071),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3073),
    [anon_sym_LBRACE] = ACTIONS(3071),
    [anon_sym_LT_AT] = ACTIONS(3071),
    [anon_sym_LT_AT_AT] = ACTIONS(3071),
    [anon_sym_AT_AT_GT] = ACTIONS(3071),
    [anon_sym_DOT] = ACTIONS(3071),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3073),
    [anon_sym_new] = ACTIONS(3071),
    [anon_sym_return_BANG] = ACTIONS(3073),
    [anon_sym_yield] = ACTIONS(3071),
    [anon_sym_yield_BANG] = ACTIONS(3073),
    [anon_sym_lazy] = ACTIONS(3071),
    [anon_sym_assert] = ACTIONS(3071),
    [anon_sym_upcast] = ACTIONS(3071),
    [anon_sym_downcast] = ACTIONS(3071),
    [anon_sym_COLON_GT] = ACTIONS(3073),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3073),
    [anon_sym_for] = ACTIONS(3071),
    [anon_sym_while] = ACTIONS(3071),
    [anon_sym_if] = ACTIONS(3071),
    [anon_sym_fun] = ACTIONS(3071),
    [anon_sym_try] = ACTIONS(3071),
    [anon_sym_match] = ACTIONS(3071),
    [anon_sym_match_BANG] = ACTIONS(3073),
    [anon_sym_function] = ACTIONS(3071),
    [anon_sym_LT_DASH] = ACTIONS(3071),
    [anon_sym_DOT_LBRACK] = ACTIONS(3073),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_use] = ACTIONS(3071),
    [anon_sym_use_BANG] = ACTIONS(3073),
    [anon_sym_do_BANG] = ACTIONS(3073),
    [anon_sym_begin] = ACTIONS(3071),
    [anon_sym_LPAREN2] = ACTIONS(3071),
    [anon_sym_or] = ACTIONS(3071),
    [aux_sym_char_token1] = ACTIONS(3073),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3071),
    [anon_sym_DQUOTE] = ACTIONS(3071),
    [anon_sym_AT_DQUOTE] = ACTIONS(3073),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3073),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3073),
    [sym_bool] = ACTIONS(3071),
    [sym_unit] = ACTIONS(3073),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3071),
    [sym_op_identifier] = ACTIONS(3071),
    [anon_sym_PLUS] = ACTIONS(3071),
    [anon_sym_DASH] = ACTIONS(3071),
    [anon_sym_PLUS_DOT] = ACTIONS(3071),
    [anon_sym_DASH_DOT] = ACTIONS(3071),
    [anon_sym_PERCENT] = ACTIONS(3071),
    [anon_sym_AMP_AMP] = ACTIONS(3071),
    [anon_sym_TILDE] = ACTIONS(3073),
    [aux_sym_prefix_op_token1] = ACTIONS(3071),
    [aux_sym_infix_op_token1] = ACTIONS(3073),
    [aux_sym_infix_op_token2] = ACTIONS(3071),
    [anon_sym_PIPE_PIPE] = ACTIONS(3071),
    [anon_sym_BANG_EQ] = ACTIONS(3071),
    [anon_sym_COLON_EQ] = ACTIONS(3073),
    [anon_sym_DOLLAR] = ACTIONS(3071),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3071),
    [sym_int] = ACTIONS(3071),
    [sym_xint] = ACTIONS(3073),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3073),
    [sym__newline] = ACTIONS(3073),
  },
  [2267] = {
    [sym_block_comment] = STATE(2267),
    [sym_compiler_directive_decl] = STATE(2267),
    [sym_fsi_directive_decl] = STATE(2267),
    [sym_preproc_line] = STATE(2267),
    [sym_identifier] = ACTIONS(3075),
    [anon_sym_EQ] = ACTIONS(3077),
    [anon_sym_COLON] = ACTIONS(3075),
    [anon_sym_return] = ACTIONS(3075),
    [anon_sym_do] = ACTIONS(3075),
    [anon_sym_let] = ACTIONS(3075),
    [anon_sym_let_BANG] = ACTIONS(3077),
    [anon_sym_LPAREN] = ACTIONS(3075),
    [anon_sym_COMMA] = ACTIONS(3077),
    [anon_sym_null] = ACTIONS(3075),
    [anon_sym_QMARK] = ACTIONS(3075),
    [anon_sym_COLON_QMARK] = ACTIONS(3075),
    [anon_sym_COLON_COLON] = ACTIONS(3077),
    [anon_sym_AMP] = ACTIONS(3075),
    [anon_sym_LBRACK] = ACTIONS(3075),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3077),
    [anon_sym_LBRACE] = ACTIONS(3075),
    [anon_sym_LT_AT] = ACTIONS(3075),
    [anon_sym_LT_AT_AT] = ACTIONS(3075),
    [anon_sym_AT_AT_GT] = ACTIONS(3075),
    [anon_sym_DOT] = ACTIONS(3075),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3077),
    [anon_sym_new] = ACTIONS(3075),
    [anon_sym_return_BANG] = ACTIONS(3077),
    [anon_sym_yield] = ACTIONS(3075),
    [anon_sym_yield_BANG] = ACTIONS(3077),
    [anon_sym_lazy] = ACTIONS(3075),
    [anon_sym_assert] = ACTIONS(3075),
    [anon_sym_upcast] = ACTIONS(3075),
    [anon_sym_downcast] = ACTIONS(3075),
    [anon_sym_COLON_GT] = ACTIONS(3077),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3077),
    [anon_sym_for] = ACTIONS(3075),
    [anon_sym_while] = ACTIONS(3075),
    [anon_sym_if] = ACTIONS(3075),
    [anon_sym_fun] = ACTIONS(3075),
    [anon_sym_try] = ACTIONS(3075),
    [anon_sym_match] = ACTIONS(3075),
    [anon_sym_match_BANG] = ACTIONS(3077),
    [anon_sym_function] = ACTIONS(3075),
    [anon_sym_LT_DASH] = ACTIONS(3075),
    [anon_sym_DOT_LBRACK] = ACTIONS(3077),
    [anon_sym_LT] = ACTIONS(3077),
    [anon_sym_use] = ACTIONS(3075),
    [anon_sym_use_BANG] = ACTIONS(3077),
    [anon_sym_do_BANG] = ACTIONS(3077),
    [anon_sym_begin] = ACTIONS(3075),
    [anon_sym_LPAREN2] = ACTIONS(3075),
    [anon_sym_or] = ACTIONS(3075),
    [aux_sym_char_token1] = ACTIONS(3077),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3075),
    [anon_sym_DQUOTE] = ACTIONS(3075),
    [anon_sym_AT_DQUOTE] = ACTIONS(3077),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3077),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3077),
    [sym_bool] = ACTIONS(3075),
    [sym_unit] = ACTIONS(3077),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3075),
    [sym_op_identifier] = ACTIONS(3075),
    [anon_sym_PLUS] = ACTIONS(3075),
    [anon_sym_DASH] = ACTIONS(3075),
    [anon_sym_PLUS_DOT] = ACTIONS(3075),
    [anon_sym_DASH_DOT] = ACTIONS(3075),
    [anon_sym_PERCENT] = ACTIONS(3075),
    [anon_sym_AMP_AMP] = ACTIONS(3075),
    [anon_sym_TILDE] = ACTIONS(3077),
    [aux_sym_prefix_op_token1] = ACTIONS(3075),
    [aux_sym_infix_op_token1] = ACTIONS(3077),
    [aux_sym_infix_op_token2] = ACTIONS(3075),
    [anon_sym_PIPE_PIPE] = ACTIONS(3075),
    [anon_sym_BANG_EQ] = ACTIONS(3075),
    [anon_sym_COLON_EQ] = ACTIONS(3077),
    [anon_sym_DOLLAR] = ACTIONS(3075),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3075),
    [sym_int] = ACTIONS(3075),
    [sym_xint] = ACTIONS(3077),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3077),
    [sym__newline] = ACTIONS(3077),
  },
  [2268] = {
    [sym_block_comment] = STATE(2268),
    [sym_compiler_directive_decl] = STATE(2268),
    [sym_fsi_directive_decl] = STATE(2268),
    [sym_preproc_line] = STATE(2268),
    [sym_identifier] = ACTIONS(2970),
    [anon_sym_EQ] = ACTIONS(2972),
    [anon_sym_COLON] = ACTIONS(2970),
    [anon_sym_return] = ACTIONS(2970),
    [anon_sym_do] = ACTIONS(2970),
    [anon_sym_let] = ACTIONS(2970),
    [anon_sym_let_BANG] = ACTIONS(2972),
    [anon_sym_LPAREN] = ACTIONS(2970),
    [anon_sym_COMMA] = ACTIONS(2972),
    [anon_sym_null] = ACTIONS(2970),
    [anon_sym_QMARK] = ACTIONS(2970),
    [anon_sym_COLON_QMARK] = ACTIONS(2970),
    [anon_sym_COLON_COLON] = ACTIONS(2972),
    [anon_sym_AMP] = ACTIONS(2970),
    [anon_sym_LBRACK] = ACTIONS(2970),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2972),
    [anon_sym_LBRACE] = ACTIONS(2970),
    [anon_sym_LT_AT] = ACTIONS(2970),
    [anon_sym_LT_AT_AT] = ACTIONS(2970),
    [anon_sym_DOT] = ACTIONS(2970),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2972),
    [anon_sym_new] = ACTIONS(2970),
    [anon_sym_return_BANG] = ACTIONS(2972),
    [anon_sym_yield] = ACTIONS(2970),
    [anon_sym_yield_BANG] = ACTIONS(2972),
    [anon_sym_lazy] = ACTIONS(2970),
    [anon_sym_assert] = ACTIONS(2970),
    [anon_sym_upcast] = ACTIONS(2970),
    [anon_sym_downcast] = ACTIONS(2970),
    [anon_sym_COLON_GT] = ACTIONS(2972),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2972),
    [anon_sym_for] = ACTIONS(2970),
    [anon_sym_while] = ACTIONS(2970),
    [anon_sym_if] = ACTIONS(2970),
    [anon_sym_fun] = ACTIONS(2970),
    [anon_sym_try] = ACTIONS(2970),
    [anon_sym_match] = ACTIONS(2970),
    [anon_sym_match_BANG] = ACTIONS(2972),
    [anon_sym_function] = ACTIONS(2970),
    [anon_sym_LT_DASH] = ACTIONS(2970),
    [anon_sym_DOT_LBRACK] = ACTIONS(2972),
    [anon_sym_LT] = ACTIONS(2972),
    [anon_sym_GT] = ACTIONS(2970),
    [anon_sym_use] = ACTIONS(2970),
    [anon_sym_use_BANG] = ACTIONS(2972),
    [anon_sym_do_BANG] = ACTIONS(2972),
    [anon_sym_begin] = ACTIONS(2970),
    [anon_sym_LPAREN2] = ACTIONS(2970),
    [anon_sym_or] = ACTIONS(2970),
    [aux_sym_char_token1] = ACTIONS(2972),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2970),
    [anon_sym_DQUOTE] = ACTIONS(2970),
    [anon_sym_AT_DQUOTE] = ACTIONS(2972),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2972),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2972),
    [sym_bool] = ACTIONS(2970),
    [sym_unit] = ACTIONS(2972),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2970),
    [sym_op_identifier] = ACTIONS(2970),
    [anon_sym_PLUS] = ACTIONS(2970),
    [anon_sym_DASH] = ACTIONS(2970),
    [anon_sym_PLUS_DOT] = ACTIONS(2970),
    [anon_sym_DASH_DOT] = ACTIONS(2970),
    [anon_sym_PERCENT] = ACTIONS(2970),
    [anon_sym_AMP_AMP] = ACTIONS(2970),
    [anon_sym_TILDE] = ACTIONS(2972),
    [aux_sym_prefix_op_token1] = ACTIONS(2970),
    [aux_sym_infix_op_token1] = ACTIONS(2972),
    [aux_sym_infix_op_token2] = ACTIONS(2970),
    [anon_sym_PIPE_PIPE] = ACTIONS(2970),
    [anon_sym_BANG_EQ] = ACTIONS(2970),
    [anon_sym_COLON_EQ] = ACTIONS(2972),
    [anon_sym_DOLLAR] = ACTIONS(2970),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2970),
    [sym_int] = ACTIONS(2970),
    [sym_xint] = ACTIONS(2972),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2972),
    [sym__newline] = ACTIONS(2972),
  },
  [2269] = {
    [sym_block_comment] = STATE(2269),
    [sym_compiler_directive_decl] = STATE(2269),
    [sym_fsi_directive_decl] = STATE(2269),
    [sym_preproc_line] = STATE(2269),
    [sym_identifier] = ACTIONS(3095),
    [anon_sym_EQ] = ACTIONS(3097),
    [anon_sym_COLON] = ACTIONS(3095),
    [anon_sym_return] = ACTIONS(3095),
    [anon_sym_do] = ACTIONS(3095),
    [anon_sym_let] = ACTIONS(3095),
    [anon_sym_let_BANG] = ACTIONS(3097),
    [anon_sym_LPAREN] = ACTIONS(3095),
    [anon_sym_COMMA] = ACTIONS(3097),
    [anon_sym_null] = ACTIONS(3095),
    [anon_sym_QMARK] = ACTIONS(3095),
    [anon_sym_COLON_QMARK] = ACTIONS(3095),
    [anon_sym_COLON_COLON] = ACTIONS(3097),
    [anon_sym_AMP] = ACTIONS(3095),
    [anon_sym_LBRACK] = ACTIONS(3095),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3097),
    [anon_sym_LBRACE] = ACTIONS(3095),
    [anon_sym_LT_AT] = ACTIONS(3095),
    [anon_sym_LT_AT_AT] = ACTIONS(3095),
    [anon_sym_DOT] = ACTIONS(3095),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3097),
    [anon_sym_new] = ACTIONS(3095),
    [anon_sym_return_BANG] = ACTIONS(3097),
    [anon_sym_yield] = ACTIONS(3095),
    [anon_sym_yield_BANG] = ACTIONS(3097),
    [anon_sym_lazy] = ACTIONS(3095),
    [anon_sym_assert] = ACTIONS(3095),
    [anon_sym_upcast] = ACTIONS(3095),
    [anon_sym_downcast] = ACTIONS(3095),
    [anon_sym_COLON_GT] = ACTIONS(3097),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3097),
    [anon_sym_for] = ACTIONS(3095),
    [anon_sym_while] = ACTIONS(3095),
    [anon_sym_if] = ACTIONS(3095),
    [anon_sym_fun] = ACTIONS(3095),
    [anon_sym_try] = ACTIONS(3095),
    [anon_sym_match] = ACTIONS(3095),
    [anon_sym_match_BANG] = ACTIONS(3097),
    [anon_sym_function] = ACTIONS(3095),
    [anon_sym_LT_DASH] = ACTIONS(3095),
    [anon_sym_DOT_LBRACK] = ACTIONS(3097),
    [anon_sym_LT] = ACTIONS(3097),
    [anon_sym_use] = ACTIONS(3095),
    [anon_sym_use_BANG] = ACTIONS(3097),
    [anon_sym_do_BANG] = ACTIONS(3097),
    [anon_sym_begin] = ACTIONS(3095),
    [anon_sym_LPAREN2] = ACTIONS(3095),
    [anon_sym_or] = ACTIONS(3095),
    [aux_sym_char_token1] = ACTIONS(3097),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3095),
    [anon_sym_DQUOTE] = ACTIONS(3095),
    [anon_sym_AT_DQUOTE] = ACTIONS(3097),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3097),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3097),
    [sym_bool] = ACTIONS(3095),
    [sym_unit] = ACTIONS(3097),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3095),
    [sym_op_identifier] = ACTIONS(3095),
    [anon_sym_PLUS] = ACTIONS(3095),
    [anon_sym_DASH] = ACTIONS(3095),
    [anon_sym_PLUS_DOT] = ACTIONS(3095),
    [anon_sym_DASH_DOT] = ACTIONS(3095),
    [anon_sym_PERCENT] = ACTIONS(3095),
    [anon_sym_AMP_AMP] = ACTIONS(3095),
    [anon_sym_TILDE] = ACTIONS(3097),
    [aux_sym_prefix_op_token1] = ACTIONS(3095),
    [aux_sym_infix_op_token1] = ACTIONS(3097),
    [aux_sym_infix_op_token2] = ACTIONS(3095),
    [anon_sym_PIPE_PIPE] = ACTIONS(3095),
    [anon_sym_BANG_EQ] = ACTIONS(3095),
    [anon_sym_COLON_EQ] = ACTIONS(3097),
    [anon_sym_DOLLAR] = ACTIONS(3095),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3095),
    [sym_int] = ACTIONS(3095),
    [sym_xint] = ACTIONS(3097),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3097),
    [anon_sym_POUNDendif] = ACTIONS(3097),
    [sym__newline] = ACTIONS(3097),
  },
  [2270] = {
    [sym_block_comment] = STATE(2270),
    [sym_compiler_directive_decl] = STATE(2270),
    [sym_fsi_directive_decl] = STATE(2270),
    [sym_preproc_line] = STATE(2270),
    [sym_identifier] = ACTIONS(2996),
    [anon_sym_EQ] = ACTIONS(2998),
    [anon_sym_COLON] = ACTIONS(2996),
    [anon_sym_return] = ACTIONS(2996),
    [anon_sym_do] = ACTIONS(2996),
    [anon_sym_let] = ACTIONS(2996),
    [anon_sym_let_BANG] = ACTIONS(2998),
    [anon_sym_LPAREN] = ACTIONS(2996),
    [anon_sym_COMMA] = ACTIONS(2998),
    [anon_sym_null] = ACTIONS(2996),
    [anon_sym_QMARK] = ACTIONS(2996),
    [anon_sym_COLON_QMARK] = ACTIONS(2996),
    [anon_sym_COLON_COLON] = ACTIONS(2998),
    [anon_sym_AMP] = ACTIONS(2996),
    [anon_sym_LBRACK] = ACTIONS(2996),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2998),
    [anon_sym_LBRACE] = ACTIONS(2996),
    [anon_sym_LT_AT] = ACTIONS(2996),
    [anon_sym_LT_AT_AT] = ACTIONS(2996),
    [anon_sym_DOT] = ACTIONS(2996),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2998),
    [anon_sym_new] = ACTIONS(2996),
    [anon_sym_return_BANG] = ACTIONS(2998),
    [anon_sym_yield] = ACTIONS(2996),
    [anon_sym_yield_BANG] = ACTIONS(2998),
    [anon_sym_lazy] = ACTIONS(2996),
    [anon_sym_assert] = ACTIONS(2996),
    [anon_sym_upcast] = ACTIONS(2996),
    [anon_sym_downcast] = ACTIONS(2996),
    [anon_sym_COLON_GT] = ACTIONS(2998),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2998),
    [anon_sym_for] = ACTIONS(2996),
    [anon_sym_while] = ACTIONS(2996),
    [anon_sym_if] = ACTIONS(2996),
    [anon_sym_fun] = ACTIONS(2996),
    [anon_sym_try] = ACTIONS(2996),
    [anon_sym_match] = ACTIONS(2996),
    [anon_sym_match_BANG] = ACTIONS(2998),
    [anon_sym_function] = ACTIONS(2996),
    [anon_sym_LT_DASH] = ACTIONS(2996),
    [anon_sym_DOT_LBRACK] = ACTIONS(2998),
    [anon_sym_LT] = ACTIONS(2998),
    [anon_sym_use] = ACTIONS(2996),
    [anon_sym_use_BANG] = ACTIONS(2998),
    [anon_sym_do_BANG] = ACTIONS(2998),
    [anon_sym_begin] = ACTIONS(2996),
    [anon_sym_LPAREN2] = ACTIONS(2996),
    [anon_sym_or] = ACTIONS(2996),
    [aux_sym_char_token1] = ACTIONS(2998),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2996),
    [anon_sym_DQUOTE] = ACTIONS(2996),
    [anon_sym_AT_DQUOTE] = ACTIONS(2998),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2998),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2998),
    [sym_bool] = ACTIONS(2996),
    [sym_unit] = ACTIONS(2998),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2996),
    [sym_op_identifier] = ACTIONS(2996),
    [anon_sym_PLUS] = ACTIONS(2996),
    [anon_sym_DASH] = ACTIONS(2996),
    [anon_sym_PLUS_DOT] = ACTIONS(2996),
    [anon_sym_DASH_DOT] = ACTIONS(2996),
    [anon_sym_PERCENT] = ACTIONS(2996),
    [anon_sym_AMP_AMP] = ACTIONS(2996),
    [anon_sym_TILDE] = ACTIONS(2998),
    [aux_sym_prefix_op_token1] = ACTIONS(2996),
    [aux_sym_infix_op_token1] = ACTIONS(2998),
    [aux_sym_infix_op_token2] = ACTIONS(2996),
    [anon_sym_PIPE_PIPE] = ACTIONS(2996),
    [anon_sym_BANG_EQ] = ACTIONS(2996),
    [anon_sym_COLON_EQ] = ACTIONS(2998),
    [anon_sym_DOLLAR] = ACTIONS(2996),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2996),
    [sym_int] = ACTIONS(2996),
    [sym_xint] = ACTIONS(2998),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2998),
    [anon_sym_POUNDendif] = ACTIONS(2998),
    [sym__newline] = ACTIONS(2998),
  },
  [2271] = {
    [sym_block_comment] = STATE(2271),
    [sym_compiler_directive_decl] = STATE(2271),
    [sym_fsi_directive_decl] = STATE(2271),
    [sym_preproc_line] = STATE(2271),
    [sym_identifier] = ACTIONS(2938),
    [anon_sym_EQ] = ACTIONS(2940),
    [anon_sym_COLON] = ACTIONS(2938),
    [anon_sym_return] = ACTIONS(2938),
    [anon_sym_do] = ACTIONS(2938),
    [anon_sym_let] = ACTIONS(2938),
    [anon_sym_let_BANG] = ACTIONS(2940),
    [anon_sym_LPAREN] = ACTIONS(2938),
    [anon_sym_COMMA] = ACTIONS(2940),
    [anon_sym_null] = ACTIONS(2938),
    [anon_sym_QMARK] = ACTIONS(2938),
    [anon_sym_COLON_QMARK] = ACTIONS(2938),
    [anon_sym_COLON_COLON] = ACTIONS(2940),
    [anon_sym_AMP] = ACTIONS(2938),
    [anon_sym_LBRACK] = ACTIONS(2938),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2940),
    [anon_sym_LBRACE] = ACTIONS(2938),
    [anon_sym_LT_AT] = ACTIONS(2938),
    [anon_sym_AT_GT] = ACTIONS(2938),
    [anon_sym_LT_AT_AT] = ACTIONS(2938),
    [anon_sym_DOT] = ACTIONS(2938),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2940),
    [anon_sym_new] = ACTIONS(2938),
    [anon_sym_return_BANG] = ACTIONS(2940),
    [anon_sym_yield] = ACTIONS(2938),
    [anon_sym_yield_BANG] = ACTIONS(2940),
    [anon_sym_lazy] = ACTIONS(2938),
    [anon_sym_assert] = ACTIONS(2938),
    [anon_sym_upcast] = ACTIONS(2938),
    [anon_sym_downcast] = ACTIONS(2938),
    [anon_sym_COLON_GT] = ACTIONS(2940),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2940),
    [anon_sym_for] = ACTIONS(2938),
    [anon_sym_while] = ACTIONS(2938),
    [anon_sym_if] = ACTIONS(2938),
    [anon_sym_fun] = ACTIONS(2938),
    [anon_sym_try] = ACTIONS(2938),
    [anon_sym_match] = ACTIONS(2938),
    [anon_sym_match_BANG] = ACTIONS(2940),
    [anon_sym_function] = ACTIONS(2938),
    [anon_sym_LT_DASH] = ACTIONS(2938),
    [anon_sym_DOT_LBRACK] = ACTIONS(2940),
    [anon_sym_LT] = ACTIONS(2940),
    [anon_sym_use] = ACTIONS(2938),
    [anon_sym_use_BANG] = ACTIONS(2940),
    [anon_sym_do_BANG] = ACTIONS(2940),
    [anon_sym_begin] = ACTIONS(2938),
    [anon_sym_LPAREN2] = ACTIONS(2938),
    [anon_sym_or] = ACTIONS(2938),
    [aux_sym_char_token1] = ACTIONS(2940),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2938),
    [anon_sym_DQUOTE] = ACTIONS(2938),
    [anon_sym_AT_DQUOTE] = ACTIONS(2940),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2940),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2940),
    [sym_bool] = ACTIONS(2938),
    [sym_unit] = ACTIONS(2940),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2938),
    [sym_op_identifier] = ACTIONS(2938),
    [anon_sym_PLUS] = ACTIONS(2938),
    [anon_sym_DASH] = ACTIONS(2938),
    [anon_sym_PLUS_DOT] = ACTIONS(2938),
    [anon_sym_DASH_DOT] = ACTIONS(2938),
    [anon_sym_PERCENT] = ACTIONS(2938),
    [anon_sym_AMP_AMP] = ACTIONS(2938),
    [anon_sym_TILDE] = ACTIONS(2940),
    [aux_sym_prefix_op_token1] = ACTIONS(2938),
    [aux_sym_infix_op_token1] = ACTIONS(2940),
    [aux_sym_infix_op_token2] = ACTIONS(2938),
    [anon_sym_PIPE_PIPE] = ACTIONS(2938),
    [anon_sym_BANG_EQ] = ACTIONS(2938),
    [anon_sym_COLON_EQ] = ACTIONS(2940),
    [anon_sym_DOLLAR] = ACTIONS(2938),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2938),
    [sym_int] = ACTIONS(2938),
    [sym_xint] = ACTIONS(2940),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2940),
    [sym__newline] = ACTIONS(2940),
  },
  [2272] = {
    [sym_block_comment] = STATE(2272),
    [sym_compiler_directive_decl] = STATE(2272),
    [sym_fsi_directive_decl] = STATE(2272),
    [sym_preproc_line] = STATE(2272),
    [sym_identifier] = ACTIONS(2978),
    [anon_sym_EQ] = ACTIONS(2980),
    [anon_sym_COLON] = ACTIONS(2978),
    [anon_sym_return] = ACTIONS(2978),
    [anon_sym_do] = ACTIONS(2978),
    [anon_sym_let] = ACTIONS(2978),
    [anon_sym_let_BANG] = ACTIONS(2980),
    [anon_sym_LPAREN] = ACTIONS(2978),
    [anon_sym_COMMA] = ACTIONS(2980),
    [anon_sym_null] = ACTIONS(2978),
    [anon_sym_QMARK] = ACTIONS(2978),
    [anon_sym_COLON_QMARK] = ACTIONS(2978),
    [anon_sym_COLON_COLON] = ACTIONS(2980),
    [anon_sym_AMP] = ACTIONS(2978),
    [anon_sym_LBRACK] = ACTIONS(2978),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2980),
    [anon_sym_LBRACE] = ACTIONS(2978),
    [anon_sym_LT_AT] = ACTIONS(2978),
    [anon_sym_AT_GT] = ACTIONS(2978),
    [anon_sym_LT_AT_AT] = ACTIONS(2978),
    [anon_sym_DOT] = ACTIONS(2978),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2980),
    [anon_sym_new] = ACTIONS(2978),
    [anon_sym_return_BANG] = ACTIONS(2980),
    [anon_sym_yield] = ACTIONS(2978),
    [anon_sym_yield_BANG] = ACTIONS(2980),
    [anon_sym_lazy] = ACTIONS(2978),
    [anon_sym_assert] = ACTIONS(2978),
    [anon_sym_upcast] = ACTIONS(2978),
    [anon_sym_downcast] = ACTIONS(2978),
    [anon_sym_COLON_GT] = ACTIONS(2980),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2980),
    [anon_sym_for] = ACTIONS(2978),
    [anon_sym_while] = ACTIONS(2978),
    [anon_sym_if] = ACTIONS(2978),
    [anon_sym_fun] = ACTIONS(2978),
    [anon_sym_try] = ACTIONS(2978),
    [anon_sym_match] = ACTIONS(2978),
    [anon_sym_match_BANG] = ACTIONS(2980),
    [anon_sym_function] = ACTIONS(2978),
    [anon_sym_LT_DASH] = ACTIONS(2978),
    [anon_sym_DOT_LBRACK] = ACTIONS(2980),
    [anon_sym_LT] = ACTIONS(2980),
    [anon_sym_use] = ACTIONS(2978),
    [anon_sym_use_BANG] = ACTIONS(2980),
    [anon_sym_do_BANG] = ACTIONS(2980),
    [anon_sym_begin] = ACTIONS(2978),
    [anon_sym_LPAREN2] = ACTIONS(2978),
    [anon_sym_or] = ACTIONS(2978),
    [aux_sym_char_token1] = ACTIONS(2980),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2978),
    [anon_sym_DQUOTE] = ACTIONS(2978),
    [anon_sym_AT_DQUOTE] = ACTIONS(2980),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2980),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2980),
    [sym_bool] = ACTIONS(2978),
    [sym_unit] = ACTIONS(2980),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2978),
    [sym_op_identifier] = ACTIONS(2978),
    [anon_sym_PLUS] = ACTIONS(2978),
    [anon_sym_DASH] = ACTIONS(2978),
    [anon_sym_PLUS_DOT] = ACTIONS(2978),
    [anon_sym_DASH_DOT] = ACTIONS(2978),
    [anon_sym_PERCENT] = ACTIONS(2978),
    [anon_sym_AMP_AMP] = ACTIONS(2978),
    [anon_sym_TILDE] = ACTIONS(2980),
    [aux_sym_prefix_op_token1] = ACTIONS(2978),
    [aux_sym_infix_op_token1] = ACTIONS(2980),
    [aux_sym_infix_op_token2] = ACTIONS(2978),
    [anon_sym_PIPE_PIPE] = ACTIONS(2978),
    [anon_sym_BANG_EQ] = ACTIONS(2978),
    [anon_sym_COLON_EQ] = ACTIONS(2980),
    [anon_sym_DOLLAR] = ACTIONS(2978),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2978),
    [sym_int] = ACTIONS(2978),
    [sym_xint] = ACTIONS(2980),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2980),
    [sym__newline] = ACTIONS(2980),
  },
  [2273] = {
    [sym_attributes] = STATE(2630),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(3640),
    [sym__pattern] = STATE(1836),
    [sym_optional_pattern] = STATE(3640),
    [sym_type_check_pattern] = STATE(3640),
    [sym_attribute_pattern] = STATE(3640),
    [sym_paren_pattern] = STATE(3640),
    [sym_as_pattern] = STATE(3640),
    [sym_cons_pattern] = STATE(3640),
    [sym_disjunct_pattern] = STATE(3640),
    [sym_conjunct_pattern] = STATE(3640),
    [sym_typed_pattern] = STATE(3640),
    [sym_list_pattern] = STATE(3640),
    [sym_array_pattern] = STATE(3640),
    [sym_record_pattern] = STATE(3640),
    [sym_named_field_pattern] = STATE(3640),
    [sym_identifier_pattern] = STATE(3640),
    [sym_long_identifier_or_op] = STATE(2393),
    [sym_char] = STATE(3606),
    [sym_format_string] = STATE(3688),
    [sym__string_literal] = STATE(3688),
    [sym_string] = STATE(3606),
    [sym_verbatim_string] = STATE(3606),
    [sym_bytearray] = STATE(3606),
    [sym_verbatim_bytearray] = STATE(3606),
    [sym_format_triple_quoted_string] = STATE(3686),
    [sym_triple_quoted_string] = STATE(3606),
    [sym_const] = STATE(3640),
    [sym_long_identifier] = STATE(3437),
    [sym_active_pattern] = STATE(3653),
    [sym__identifier_or_op] = STATE(3660),
    [sym_sbyte] = STATE(3606),
    [sym_byte] = STATE(3606),
    [sym_int16] = STATE(3606),
    [sym_uint16] = STATE(3606),
    [sym_int32] = STATE(3606),
    [sym_uint32] = STATE(3606),
    [sym_nativeint] = STATE(3606),
    [sym_unativeint] = STATE(3606),
    [sym_int64] = STATE(3606),
    [sym_uint64] = STATE(3606),
    [sym_ieee32] = STATE(3606),
    [sym_ieee64] = STATE(3606),
    [sym_bignum] = STATE(3606),
    [sym_decimal] = STATE(3606),
    [sym_float] = STATE(3332),
    [sym_block_comment] = STATE(2273),
    [sym_compiler_directive_decl] = STATE(2273),
    [sym_fsi_directive_decl] = STATE(2273),
    [sym_preproc_line] = STATE(2273),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(4073),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_COLON] = ACTIONS(3960),
    [anon_sym_as] = ACTIONS(3960),
    [anon_sym_LPAREN] = ACTIONS(4256),
    [anon_sym_COMMA] = ACTIONS(3964),
    [anon_sym_null] = ACTIONS(4258),
    [anon_sym__] = ACTIONS(4260),
    [anon_sym_QMARK] = ACTIONS(4262),
    [anon_sym_COLON_QMARK] = ACTIONS(4264),
    [anon_sym_COLON_COLON] = ACTIONS(3964),
    [anon_sym_PIPE] = ACTIONS(3964),
    [anon_sym_AMP] = ACTIONS(3964),
    [anon_sym_LBRACK] = ACTIONS(4266),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4268),
    [anon_sym_LBRACE] = ACTIONS(4270),
    [aux_sym_char_token1] = ACTIONS(4272),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4274),
    [anon_sym_DQUOTE] = ACTIONS(4276),
    [anon_sym_AT_DQUOTE] = ACTIONS(4278),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4280),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4282),
    [sym_bool] = ACTIONS(4284),
    [sym_unit] = ACTIONS(4286),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4117),
    [sym_op_identifier] = ACTIONS(4119),
    [sym_int] = ACTIONS(4288),
    [sym_xint] = ACTIONS(4290),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [sym__newline] = ACTIONS(3964),
    [sym__dedent] = ACTIONS(3964),
  },
  [2274] = {
    [sym_block_comment] = STATE(2274),
    [sym_compiler_directive_decl] = STATE(2274),
    [sym_fsi_directive_decl] = STATE(2274),
    [sym_preproc_line] = STATE(2274),
    [sym_identifier] = ACTIONS(2855),
    [anon_sym_EQ] = ACTIONS(2857),
    [anon_sym_COLON] = ACTIONS(2855),
    [anon_sym_return] = ACTIONS(2855),
    [anon_sym_do] = ACTIONS(2855),
    [anon_sym_let] = ACTIONS(2855),
    [anon_sym_let_BANG] = ACTIONS(2857),
    [anon_sym_LPAREN] = ACTIONS(2855),
    [anon_sym_COMMA] = ACTIONS(2857),
    [anon_sym_null] = ACTIONS(2855),
    [anon_sym_QMARK] = ACTIONS(2855),
    [anon_sym_COLON_QMARK] = ACTIONS(2855),
    [anon_sym_COLON_COLON] = ACTIONS(2857),
    [anon_sym_AMP] = ACTIONS(2855),
    [anon_sym_LBRACK] = ACTIONS(2855),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2857),
    [anon_sym_LBRACE] = ACTIONS(2855),
    [anon_sym_LT_AT] = ACTIONS(2855),
    [anon_sym_LT_AT_AT] = ACTIONS(2855),
    [anon_sym_AT_AT_GT] = ACTIONS(2855),
    [anon_sym_DOT] = ACTIONS(2855),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2857),
    [anon_sym_new] = ACTIONS(2855),
    [anon_sym_return_BANG] = ACTIONS(2857),
    [anon_sym_yield] = ACTIONS(2855),
    [anon_sym_yield_BANG] = ACTIONS(2857),
    [anon_sym_lazy] = ACTIONS(2855),
    [anon_sym_assert] = ACTIONS(2855),
    [anon_sym_upcast] = ACTIONS(2855),
    [anon_sym_downcast] = ACTIONS(2855),
    [anon_sym_COLON_GT] = ACTIONS(2857),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2857),
    [anon_sym_for] = ACTIONS(2855),
    [anon_sym_while] = ACTIONS(2855),
    [anon_sym_if] = ACTIONS(2855),
    [anon_sym_fun] = ACTIONS(2855),
    [anon_sym_try] = ACTIONS(2855),
    [anon_sym_match] = ACTIONS(2855),
    [anon_sym_match_BANG] = ACTIONS(2857),
    [anon_sym_function] = ACTIONS(2855),
    [anon_sym_LT_DASH] = ACTIONS(2855),
    [anon_sym_DOT_LBRACK] = ACTIONS(2857),
    [anon_sym_LT] = ACTIONS(2857),
    [anon_sym_use] = ACTIONS(2855),
    [anon_sym_use_BANG] = ACTIONS(2857),
    [anon_sym_do_BANG] = ACTIONS(2857),
    [anon_sym_begin] = ACTIONS(2855),
    [anon_sym_LPAREN2] = ACTIONS(2855),
    [anon_sym_or] = ACTIONS(2855),
    [aux_sym_char_token1] = ACTIONS(2857),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2855),
    [anon_sym_DQUOTE] = ACTIONS(2855),
    [anon_sym_AT_DQUOTE] = ACTIONS(2857),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2857),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2857),
    [sym_bool] = ACTIONS(2855),
    [sym_unit] = ACTIONS(2857),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2855),
    [sym_op_identifier] = ACTIONS(2855),
    [anon_sym_PLUS] = ACTIONS(2855),
    [anon_sym_DASH] = ACTIONS(2855),
    [anon_sym_PLUS_DOT] = ACTIONS(2855),
    [anon_sym_DASH_DOT] = ACTIONS(2855),
    [anon_sym_PERCENT] = ACTIONS(2855),
    [anon_sym_AMP_AMP] = ACTIONS(2855),
    [anon_sym_TILDE] = ACTIONS(2857),
    [aux_sym_prefix_op_token1] = ACTIONS(2855),
    [aux_sym_infix_op_token1] = ACTIONS(2857),
    [aux_sym_infix_op_token2] = ACTIONS(2855),
    [anon_sym_PIPE_PIPE] = ACTIONS(2855),
    [anon_sym_BANG_EQ] = ACTIONS(2855),
    [anon_sym_COLON_EQ] = ACTIONS(2857),
    [anon_sym_DOLLAR] = ACTIONS(2855),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2855),
    [sym_int] = ACTIONS(2855),
    [sym_xint] = ACTIONS(2857),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2857),
    [sym__newline] = ACTIONS(2857),
  },
  [2275] = {
    [sym_block_comment] = STATE(2275),
    [sym_compiler_directive_decl] = STATE(2275),
    [sym_fsi_directive_decl] = STATE(2275),
    [sym_preproc_line] = STATE(2275),
    [sym_identifier] = ACTIONS(2859),
    [anon_sym_EQ] = ACTIONS(2861),
    [anon_sym_COLON] = ACTIONS(2859),
    [anon_sym_return] = ACTIONS(2859),
    [anon_sym_do] = ACTIONS(2859),
    [anon_sym_let] = ACTIONS(2859),
    [anon_sym_let_BANG] = ACTIONS(2861),
    [anon_sym_LPAREN] = ACTIONS(2859),
    [anon_sym_COMMA] = ACTIONS(2861),
    [anon_sym_null] = ACTIONS(2859),
    [anon_sym_QMARK] = ACTIONS(2859),
    [anon_sym_COLON_QMARK] = ACTIONS(2859),
    [anon_sym_COLON_COLON] = ACTIONS(2861),
    [anon_sym_AMP] = ACTIONS(2859),
    [anon_sym_LBRACK] = ACTIONS(2859),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2861),
    [anon_sym_LBRACE] = ACTIONS(2859),
    [anon_sym_LT_AT] = ACTIONS(2859),
    [anon_sym_LT_AT_AT] = ACTIONS(2859),
    [anon_sym_AT_AT_GT] = ACTIONS(2859),
    [anon_sym_DOT] = ACTIONS(2859),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2861),
    [anon_sym_new] = ACTIONS(2859),
    [anon_sym_return_BANG] = ACTIONS(2861),
    [anon_sym_yield] = ACTIONS(2859),
    [anon_sym_yield_BANG] = ACTIONS(2861),
    [anon_sym_lazy] = ACTIONS(2859),
    [anon_sym_assert] = ACTIONS(2859),
    [anon_sym_upcast] = ACTIONS(2859),
    [anon_sym_downcast] = ACTIONS(2859),
    [anon_sym_COLON_GT] = ACTIONS(2861),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2861),
    [anon_sym_for] = ACTIONS(2859),
    [anon_sym_while] = ACTIONS(2859),
    [anon_sym_if] = ACTIONS(2859),
    [anon_sym_fun] = ACTIONS(2859),
    [anon_sym_try] = ACTIONS(2859),
    [anon_sym_match] = ACTIONS(2859),
    [anon_sym_match_BANG] = ACTIONS(2861),
    [anon_sym_function] = ACTIONS(2859),
    [anon_sym_LT_DASH] = ACTIONS(2859),
    [anon_sym_DOT_LBRACK] = ACTIONS(2861),
    [anon_sym_LT] = ACTIONS(2861),
    [anon_sym_use] = ACTIONS(2859),
    [anon_sym_use_BANG] = ACTIONS(2861),
    [anon_sym_do_BANG] = ACTIONS(2861),
    [anon_sym_begin] = ACTIONS(2859),
    [anon_sym_LPAREN2] = ACTIONS(2859),
    [anon_sym_or] = ACTIONS(2859),
    [aux_sym_char_token1] = ACTIONS(2861),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2859),
    [anon_sym_DQUOTE] = ACTIONS(2859),
    [anon_sym_AT_DQUOTE] = ACTIONS(2861),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2861),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2861),
    [sym_bool] = ACTIONS(2859),
    [sym_unit] = ACTIONS(2861),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2859),
    [sym_op_identifier] = ACTIONS(2859),
    [anon_sym_PLUS] = ACTIONS(2859),
    [anon_sym_DASH] = ACTIONS(2859),
    [anon_sym_PLUS_DOT] = ACTIONS(2859),
    [anon_sym_DASH_DOT] = ACTIONS(2859),
    [anon_sym_PERCENT] = ACTIONS(2859),
    [anon_sym_AMP_AMP] = ACTIONS(2859),
    [anon_sym_TILDE] = ACTIONS(2861),
    [aux_sym_prefix_op_token1] = ACTIONS(2859),
    [aux_sym_infix_op_token1] = ACTIONS(2861),
    [aux_sym_infix_op_token2] = ACTIONS(2859),
    [anon_sym_PIPE_PIPE] = ACTIONS(2859),
    [anon_sym_BANG_EQ] = ACTIONS(2859),
    [anon_sym_COLON_EQ] = ACTIONS(2861),
    [anon_sym_DOLLAR] = ACTIONS(2859),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2859),
    [sym_int] = ACTIONS(2859),
    [sym_xint] = ACTIONS(2861),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2861),
    [sym__newline] = ACTIONS(2861),
  },
  [2276] = {
    [sym_block_comment] = STATE(2276),
    [sym_compiler_directive_decl] = STATE(2276),
    [sym_fsi_directive_decl] = STATE(2276),
    [sym_preproc_line] = STATE(2276),
    [sym_identifier] = ACTIONS(3087),
    [anon_sym_EQ] = ACTIONS(3089),
    [anon_sym_COLON] = ACTIONS(3087),
    [anon_sym_return] = ACTIONS(3087),
    [anon_sym_do] = ACTIONS(3087),
    [anon_sym_let] = ACTIONS(3087),
    [anon_sym_let_BANG] = ACTIONS(3089),
    [anon_sym_LPAREN] = ACTIONS(3087),
    [anon_sym_COMMA] = ACTIONS(3089),
    [anon_sym_null] = ACTIONS(3087),
    [anon_sym_QMARK] = ACTIONS(3087),
    [anon_sym_COLON_QMARK] = ACTIONS(3087),
    [anon_sym_COLON_COLON] = ACTIONS(3089),
    [anon_sym_AMP] = ACTIONS(3087),
    [anon_sym_LBRACK] = ACTIONS(3087),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3089),
    [anon_sym_LBRACE] = ACTIONS(3087),
    [anon_sym_LT_AT] = ACTIONS(3087),
    [anon_sym_LT_AT_AT] = ACTIONS(3087),
    [anon_sym_AT_AT_GT] = ACTIONS(3087),
    [anon_sym_DOT] = ACTIONS(3087),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3089),
    [anon_sym_new] = ACTIONS(3087),
    [anon_sym_return_BANG] = ACTIONS(3089),
    [anon_sym_yield] = ACTIONS(3087),
    [anon_sym_yield_BANG] = ACTIONS(3089),
    [anon_sym_lazy] = ACTIONS(3087),
    [anon_sym_assert] = ACTIONS(3087),
    [anon_sym_upcast] = ACTIONS(3087),
    [anon_sym_downcast] = ACTIONS(3087),
    [anon_sym_COLON_GT] = ACTIONS(3089),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3089),
    [anon_sym_for] = ACTIONS(3087),
    [anon_sym_while] = ACTIONS(3087),
    [anon_sym_if] = ACTIONS(3087),
    [anon_sym_fun] = ACTIONS(3087),
    [anon_sym_try] = ACTIONS(3087),
    [anon_sym_match] = ACTIONS(3087),
    [anon_sym_match_BANG] = ACTIONS(3089),
    [anon_sym_function] = ACTIONS(3087),
    [anon_sym_LT_DASH] = ACTIONS(3087),
    [anon_sym_DOT_LBRACK] = ACTIONS(3089),
    [anon_sym_LT] = ACTIONS(3089),
    [anon_sym_use] = ACTIONS(3087),
    [anon_sym_use_BANG] = ACTIONS(3089),
    [anon_sym_do_BANG] = ACTIONS(3089),
    [anon_sym_begin] = ACTIONS(3087),
    [anon_sym_LPAREN2] = ACTIONS(3087),
    [anon_sym_or] = ACTIONS(3087),
    [aux_sym_char_token1] = ACTIONS(3089),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3087),
    [anon_sym_DQUOTE] = ACTIONS(3087),
    [anon_sym_AT_DQUOTE] = ACTIONS(3089),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3089),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3089),
    [sym_bool] = ACTIONS(3087),
    [sym_unit] = ACTIONS(3089),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3087),
    [sym_op_identifier] = ACTIONS(3087),
    [anon_sym_PLUS] = ACTIONS(3087),
    [anon_sym_DASH] = ACTIONS(3087),
    [anon_sym_PLUS_DOT] = ACTIONS(3087),
    [anon_sym_DASH_DOT] = ACTIONS(3087),
    [anon_sym_PERCENT] = ACTIONS(3087),
    [anon_sym_AMP_AMP] = ACTIONS(3087),
    [anon_sym_TILDE] = ACTIONS(3089),
    [aux_sym_prefix_op_token1] = ACTIONS(3087),
    [aux_sym_infix_op_token1] = ACTIONS(3089),
    [aux_sym_infix_op_token2] = ACTIONS(3087),
    [anon_sym_PIPE_PIPE] = ACTIONS(3087),
    [anon_sym_BANG_EQ] = ACTIONS(3087),
    [anon_sym_COLON_EQ] = ACTIONS(3089),
    [anon_sym_DOLLAR] = ACTIONS(3087),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3087),
    [sym_int] = ACTIONS(3087),
    [sym_xint] = ACTIONS(3089),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3089),
    [sym__newline] = ACTIONS(3089),
  },
  [2277] = {
    [sym_block_comment] = STATE(2277),
    [sym_compiler_directive_decl] = STATE(2277),
    [sym_fsi_directive_decl] = STATE(2277),
    [sym_preproc_line] = STATE(2277),
    [sym_identifier] = ACTIONS(2984),
    [anon_sym_EQ] = ACTIONS(2986),
    [anon_sym_COLON] = ACTIONS(2984),
    [anon_sym_return] = ACTIONS(2984),
    [anon_sym_do] = ACTIONS(2984),
    [anon_sym_let] = ACTIONS(2984),
    [anon_sym_let_BANG] = ACTIONS(2986),
    [anon_sym_LPAREN] = ACTIONS(2984),
    [anon_sym_COMMA] = ACTIONS(2986),
    [anon_sym_null] = ACTIONS(2984),
    [anon_sym_QMARK] = ACTIONS(2984),
    [anon_sym_COLON_QMARK] = ACTIONS(2984),
    [anon_sym_COLON_COLON] = ACTIONS(2986),
    [anon_sym_AMP] = ACTIONS(2984),
    [anon_sym_LBRACK] = ACTIONS(2984),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2986),
    [anon_sym_LBRACE] = ACTIONS(2984),
    [anon_sym_LT_AT] = ACTIONS(2984),
    [anon_sym_LT_AT_AT] = ACTIONS(2984),
    [anon_sym_DOT] = ACTIONS(2984),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2986),
    [anon_sym_new] = ACTIONS(2984),
    [anon_sym_return_BANG] = ACTIONS(2986),
    [anon_sym_yield] = ACTIONS(2984),
    [anon_sym_yield_BANG] = ACTIONS(2986),
    [anon_sym_lazy] = ACTIONS(2984),
    [anon_sym_assert] = ACTIONS(2984),
    [anon_sym_upcast] = ACTIONS(2984),
    [anon_sym_downcast] = ACTIONS(2984),
    [anon_sym_COLON_GT] = ACTIONS(2986),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2986),
    [anon_sym_for] = ACTIONS(2984),
    [anon_sym_while] = ACTIONS(2984),
    [anon_sym_if] = ACTIONS(2984),
    [anon_sym_fun] = ACTIONS(2984),
    [anon_sym_try] = ACTIONS(2984),
    [anon_sym_match] = ACTIONS(2984),
    [anon_sym_match_BANG] = ACTIONS(2986),
    [anon_sym_function] = ACTIONS(2984),
    [anon_sym_LT_DASH] = ACTIONS(2984),
    [anon_sym_DOT_LBRACK] = ACTIONS(2986),
    [anon_sym_LT] = ACTIONS(2986),
    [anon_sym_use] = ACTIONS(2984),
    [anon_sym_use_BANG] = ACTIONS(2986),
    [anon_sym_do_BANG] = ACTIONS(2986),
    [anon_sym_DOT_DOT] = ACTIONS(2986),
    [anon_sym_begin] = ACTIONS(2984),
    [anon_sym_LPAREN2] = ACTIONS(2984),
    [anon_sym_or] = ACTIONS(2984),
    [aux_sym_char_token1] = ACTIONS(2986),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2984),
    [anon_sym_DQUOTE] = ACTIONS(2984),
    [anon_sym_AT_DQUOTE] = ACTIONS(2986),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2986),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2986),
    [sym_bool] = ACTIONS(2984),
    [sym_unit] = ACTIONS(2986),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2984),
    [sym_op_identifier] = ACTIONS(2984),
    [anon_sym_PLUS] = ACTIONS(2984),
    [anon_sym_DASH] = ACTIONS(2984),
    [anon_sym_PLUS_DOT] = ACTIONS(2984),
    [anon_sym_DASH_DOT] = ACTIONS(2984),
    [anon_sym_PERCENT] = ACTIONS(2984),
    [anon_sym_AMP_AMP] = ACTIONS(2984),
    [anon_sym_TILDE] = ACTIONS(2986),
    [aux_sym_prefix_op_token1] = ACTIONS(2984),
    [aux_sym_infix_op_token1] = ACTIONS(2986),
    [aux_sym_infix_op_token2] = ACTIONS(2984),
    [anon_sym_PIPE_PIPE] = ACTIONS(2984),
    [anon_sym_BANG_EQ] = ACTIONS(2984),
    [anon_sym_COLON_EQ] = ACTIONS(2986),
    [anon_sym_DOLLAR] = ACTIONS(2984),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2984),
    [sym_int] = ACTIONS(2984),
    [sym_xint] = ACTIONS(2986),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2986),
    [sym__newline] = ACTIONS(2986),
  },
  [2278] = {
    [sym_block_comment] = STATE(2278),
    [sym_compiler_directive_decl] = STATE(2278),
    [sym_fsi_directive_decl] = STATE(2278),
    [sym_preproc_line] = STATE(2278),
    [sym_identifier] = ACTIONS(2942),
    [anon_sym_EQ] = ACTIONS(2944),
    [anon_sym_COLON] = ACTIONS(2942),
    [anon_sym_return] = ACTIONS(2942),
    [anon_sym_do] = ACTIONS(2942),
    [anon_sym_let] = ACTIONS(2942),
    [anon_sym_let_BANG] = ACTIONS(2944),
    [anon_sym_LPAREN] = ACTIONS(2942),
    [anon_sym_COMMA] = ACTIONS(2944),
    [anon_sym_null] = ACTIONS(2942),
    [anon_sym_QMARK] = ACTIONS(2942),
    [anon_sym_COLON_QMARK] = ACTIONS(2942),
    [anon_sym_COLON_COLON] = ACTIONS(2944),
    [anon_sym_AMP] = ACTIONS(2942),
    [anon_sym_LBRACK] = ACTIONS(2942),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2944),
    [anon_sym_LBRACE] = ACTIONS(2942),
    [anon_sym_LT_AT] = ACTIONS(2942),
    [anon_sym_LT_AT_AT] = ACTIONS(2942),
    [anon_sym_DOT] = ACTIONS(2942),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2944),
    [anon_sym_new] = ACTIONS(2942),
    [anon_sym_return_BANG] = ACTIONS(2944),
    [anon_sym_yield] = ACTIONS(2942),
    [anon_sym_yield_BANG] = ACTIONS(2944),
    [anon_sym_lazy] = ACTIONS(2942),
    [anon_sym_assert] = ACTIONS(2942),
    [anon_sym_upcast] = ACTIONS(2942),
    [anon_sym_downcast] = ACTIONS(2942),
    [anon_sym_COLON_GT] = ACTIONS(2944),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2944),
    [anon_sym_for] = ACTIONS(2942),
    [anon_sym_while] = ACTIONS(2942),
    [anon_sym_if] = ACTIONS(2942),
    [anon_sym_fun] = ACTIONS(2942),
    [anon_sym_try] = ACTIONS(2942),
    [anon_sym_match] = ACTIONS(2942),
    [anon_sym_match_BANG] = ACTIONS(2944),
    [anon_sym_function] = ACTIONS(2942),
    [anon_sym_LT_DASH] = ACTIONS(2942),
    [anon_sym_DOT_LBRACK] = ACTIONS(2944),
    [anon_sym_LT] = ACTIONS(2944),
    [anon_sym_GT] = ACTIONS(2942),
    [anon_sym_use] = ACTIONS(2942),
    [anon_sym_use_BANG] = ACTIONS(2944),
    [anon_sym_do_BANG] = ACTIONS(2944),
    [anon_sym_begin] = ACTIONS(2942),
    [anon_sym_LPAREN2] = ACTIONS(2942),
    [anon_sym_or] = ACTIONS(2942),
    [aux_sym_char_token1] = ACTIONS(2944),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2942),
    [anon_sym_DQUOTE] = ACTIONS(2942),
    [anon_sym_AT_DQUOTE] = ACTIONS(2944),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2944),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2944),
    [sym_bool] = ACTIONS(2942),
    [sym_unit] = ACTIONS(2944),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2942),
    [sym_op_identifier] = ACTIONS(2942),
    [anon_sym_PLUS] = ACTIONS(2942),
    [anon_sym_DASH] = ACTIONS(2942),
    [anon_sym_PLUS_DOT] = ACTIONS(2942),
    [anon_sym_DASH_DOT] = ACTIONS(2942),
    [anon_sym_PERCENT] = ACTIONS(2942),
    [anon_sym_AMP_AMP] = ACTIONS(2942),
    [anon_sym_TILDE] = ACTIONS(2944),
    [aux_sym_prefix_op_token1] = ACTIONS(2942),
    [aux_sym_infix_op_token1] = ACTIONS(2944),
    [aux_sym_infix_op_token2] = ACTIONS(2942),
    [anon_sym_PIPE_PIPE] = ACTIONS(2942),
    [anon_sym_BANG_EQ] = ACTIONS(2942),
    [anon_sym_COLON_EQ] = ACTIONS(2944),
    [anon_sym_DOLLAR] = ACTIONS(2942),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2942),
    [sym_int] = ACTIONS(2942),
    [sym_xint] = ACTIONS(2944),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2944),
    [sym__newline] = ACTIONS(2944),
  },
  [2279] = {
    [sym_block_comment] = STATE(2279),
    [sym_compiler_directive_decl] = STATE(2279),
    [sym_fsi_directive_decl] = STATE(2279),
    [sym_preproc_line] = STATE(2279),
    [sym_identifier] = ACTIONS(2992),
    [anon_sym_EQ] = ACTIONS(2994),
    [anon_sym_COLON] = ACTIONS(2992),
    [anon_sym_return] = ACTIONS(2992),
    [anon_sym_do] = ACTIONS(2992),
    [anon_sym_let] = ACTIONS(2992),
    [anon_sym_let_BANG] = ACTIONS(2994),
    [anon_sym_LPAREN] = ACTIONS(2992),
    [anon_sym_COMMA] = ACTIONS(2994),
    [anon_sym_null] = ACTIONS(2992),
    [anon_sym_QMARK] = ACTIONS(2992),
    [anon_sym_COLON_QMARK] = ACTIONS(2992),
    [anon_sym_COLON_COLON] = ACTIONS(2994),
    [anon_sym_AMP] = ACTIONS(2992),
    [anon_sym_LBRACK] = ACTIONS(2992),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2994),
    [anon_sym_LBRACE] = ACTIONS(2992),
    [anon_sym_LT_AT] = ACTIONS(2992),
    [anon_sym_AT_GT] = ACTIONS(2992),
    [anon_sym_LT_AT_AT] = ACTIONS(2992),
    [anon_sym_DOT] = ACTIONS(2992),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2994),
    [anon_sym_new] = ACTIONS(2992),
    [anon_sym_return_BANG] = ACTIONS(2994),
    [anon_sym_yield] = ACTIONS(2992),
    [anon_sym_yield_BANG] = ACTIONS(2994),
    [anon_sym_lazy] = ACTIONS(2992),
    [anon_sym_assert] = ACTIONS(2992),
    [anon_sym_upcast] = ACTIONS(2992),
    [anon_sym_downcast] = ACTIONS(2992),
    [anon_sym_COLON_GT] = ACTIONS(2994),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2994),
    [anon_sym_for] = ACTIONS(2992),
    [anon_sym_while] = ACTIONS(2992),
    [anon_sym_if] = ACTIONS(2992),
    [anon_sym_fun] = ACTIONS(2992),
    [anon_sym_try] = ACTIONS(2992),
    [anon_sym_match] = ACTIONS(2992),
    [anon_sym_match_BANG] = ACTIONS(2994),
    [anon_sym_function] = ACTIONS(2992),
    [anon_sym_LT_DASH] = ACTIONS(2992),
    [anon_sym_DOT_LBRACK] = ACTIONS(2994),
    [anon_sym_LT] = ACTIONS(2994),
    [anon_sym_use] = ACTIONS(2992),
    [anon_sym_use_BANG] = ACTIONS(2994),
    [anon_sym_do_BANG] = ACTIONS(2994),
    [anon_sym_begin] = ACTIONS(2992),
    [anon_sym_LPAREN2] = ACTIONS(2992),
    [anon_sym_or] = ACTIONS(2992),
    [aux_sym_char_token1] = ACTIONS(2994),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2992),
    [anon_sym_DQUOTE] = ACTIONS(2992),
    [anon_sym_AT_DQUOTE] = ACTIONS(2994),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2994),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2994),
    [sym_bool] = ACTIONS(2992),
    [sym_unit] = ACTIONS(2994),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2992),
    [sym_op_identifier] = ACTIONS(2992),
    [anon_sym_PLUS] = ACTIONS(2992),
    [anon_sym_DASH] = ACTIONS(2992),
    [anon_sym_PLUS_DOT] = ACTIONS(2992),
    [anon_sym_DASH_DOT] = ACTIONS(2992),
    [anon_sym_PERCENT] = ACTIONS(2992),
    [anon_sym_AMP_AMP] = ACTIONS(2992),
    [anon_sym_TILDE] = ACTIONS(2994),
    [aux_sym_prefix_op_token1] = ACTIONS(2992),
    [aux_sym_infix_op_token1] = ACTIONS(2994),
    [aux_sym_infix_op_token2] = ACTIONS(2992),
    [anon_sym_PIPE_PIPE] = ACTIONS(2992),
    [anon_sym_BANG_EQ] = ACTIONS(2992),
    [anon_sym_COLON_EQ] = ACTIONS(2994),
    [anon_sym_DOLLAR] = ACTIONS(2992),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2992),
    [sym_int] = ACTIONS(2992),
    [sym_xint] = ACTIONS(2994),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2994),
    [sym__newline] = ACTIONS(2994),
  },
  [2280] = {
    [sym_block_comment] = STATE(2280),
    [sym_compiler_directive_decl] = STATE(2280),
    [sym_fsi_directive_decl] = STATE(2280),
    [sym_preproc_line] = STATE(2280),
    [sym_identifier] = ACTIONS(3091),
    [anon_sym_EQ] = ACTIONS(3093),
    [anon_sym_COLON] = ACTIONS(3091),
    [anon_sym_return] = ACTIONS(3091),
    [anon_sym_do] = ACTIONS(3091),
    [anon_sym_let] = ACTIONS(3091),
    [anon_sym_let_BANG] = ACTIONS(3093),
    [anon_sym_LPAREN] = ACTIONS(3091),
    [anon_sym_COMMA] = ACTIONS(3093),
    [anon_sym_null] = ACTIONS(3091),
    [anon_sym_QMARK] = ACTIONS(3091),
    [anon_sym_COLON_QMARK] = ACTIONS(3091),
    [anon_sym_COLON_COLON] = ACTIONS(3093),
    [anon_sym_AMP] = ACTIONS(3091),
    [anon_sym_LBRACK] = ACTIONS(3091),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3093),
    [anon_sym_LBRACE] = ACTIONS(3091),
    [anon_sym_LT_AT] = ACTIONS(3091),
    [anon_sym_LT_AT_AT] = ACTIONS(3091),
    [anon_sym_AT_AT_GT] = ACTIONS(3091),
    [anon_sym_DOT] = ACTIONS(3091),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3093),
    [anon_sym_new] = ACTIONS(3091),
    [anon_sym_return_BANG] = ACTIONS(3093),
    [anon_sym_yield] = ACTIONS(3091),
    [anon_sym_yield_BANG] = ACTIONS(3093),
    [anon_sym_lazy] = ACTIONS(3091),
    [anon_sym_assert] = ACTIONS(3091),
    [anon_sym_upcast] = ACTIONS(3091),
    [anon_sym_downcast] = ACTIONS(3091),
    [anon_sym_COLON_GT] = ACTIONS(3093),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3093),
    [anon_sym_for] = ACTIONS(3091),
    [anon_sym_while] = ACTIONS(3091),
    [anon_sym_if] = ACTIONS(3091),
    [anon_sym_fun] = ACTIONS(3091),
    [anon_sym_try] = ACTIONS(3091),
    [anon_sym_match] = ACTIONS(3091),
    [anon_sym_match_BANG] = ACTIONS(3093),
    [anon_sym_function] = ACTIONS(3091),
    [anon_sym_LT_DASH] = ACTIONS(3091),
    [anon_sym_DOT_LBRACK] = ACTIONS(3093),
    [anon_sym_LT] = ACTIONS(3093),
    [anon_sym_use] = ACTIONS(3091),
    [anon_sym_use_BANG] = ACTIONS(3093),
    [anon_sym_do_BANG] = ACTIONS(3093),
    [anon_sym_begin] = ACTIONS(3091),
    [anon_sym_LPAREN2] = ACTIONS(3091),
    [anon_sym_or] = ACTIONS(3091),
    [aux_sym_char_token1] = ACTIONS(3093),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3091),
    [anon_sym_DQUOTE] = ACTIONS(3091),
    [anon_sym_AT_DQUOTE] = ACTIONS(3093),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3093),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3093),
    [sym_bool] = ACTIONS(3091),
    [sym_unit] = ACTIONS(3093),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3091),
    [sym_op_identifier] = ACTIONS(3091),
    [anon_sym_PLUS] = ACTIONS(3091),
    [anon_sym_DASH] = ACTIONS(3091),
    [anon_sym_PLUS_DOT] = ACTIONS(3091),
    [anon_sym_DASH_DOT] = ACTIONS(3091),
    [anon_sym_PERCENT] = ACTIONS(3091),
    [anon_sym_AMP_AMP] = ACTIONS(3091),
    [anon_sym_TILDE] = ACTIONS(3093),
    [aux_sym_prefix_op_token1] = ACTIONS(3091),
    [aux_sym_infix_op_token1] = ACTIONS(3093),
    [aux_sym_infix_op_token2] = ACTIONS(3091),
    [anon_sym_PIPE_PIPE] = ACTIONS(3091),
    [anon_sym_BANG_EQ] = ACTIONS(3091),
    [anon_sym_COLON_EQ] = ACTIONS(3093),
    [anon_sym_DOLLAR] = ACTIONS(3091),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3091),
    [sym_int] = ACTIONS(3091),
    [sym_xint] = ACTIONS(3093),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3093),
    [sym__newline] = ACTIONS(3093),
  },
  [2281] = {
    [sym_block_comment] = STATE(2281),
    [sym_compiler_directive_decl] = STATE(2281),
    [sym_fsi_directive_decl] = STATE(2281),
    [sym_preproc_line] = STATE(2281),
    [sym_identifier] = ACTIONS(2922),
    [anon_sym_EQ] = ACTIONS(2924),
    [anon_sym_COLON] = ACTIONS(2922),
    [anon_sym_return] = ACTIONS(2922),
    [anon_sym_do] = ACTIONS(2922),
    [anon_sym_let] = ACTIONS(2922),
    [anon_sym_let_BANG] = ACTIONS(2924),
    [anon_sym_LPAREN] = ACTIONS(2922),
    [anon_sym_COMMA] = ACTIONS(2924),
    [anon_sym_null] = ACTIONS(2922),
    [anon_sym_QMARK] = ACTIONS(2922),
    [anon_sym_COLON_QMARK] = ACTIONS(2922),
    [anon_sym_COLON_COLON] = ACTIONS(2924),
    [anon_sym_AMP] = ACTIONS(2922),
    [anon_sym_LBRACK] = ACTIONS(2922),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2924),
    [anon_sym_LBRACE] = ACTIONS(2922),
    [anon_sym_LT_AT] = ACTIONS(2922),
    [anon_sym_AT_GT] = ACTIONS(2922),
    [anon_sym_LT_AT_AT] = ACTIONS(2922),
    [anon_sym_DOT] = ACTIONS(2922),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2924),
    [anon_sym_new] = ACTIONS(2922),
    [anon_sym_return_BANG] = ACTIONS(2924),
    [anon_sym_yield] = ACTIONS(2922),
    [anon_sym_yield_BANG] = ACTIONS(2924),
    [anon_sym_lazy] = ACTIONS(2922),
    [anon_sym_assert] = ACTIONS(2922),
    [anon_sym_upcast] = ACTIONS(2922),
    [anon_sym_downcast] = ACTIONS(2922),
    [anon_sym_COLON_GT] = ACTIONS(2924),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2924),
    [anon_sym_for] = ACTIONS(2922),
    [anon_sym_while] = ACTIONS(2922),
    [anon_sym_if] = ACTIONS(2922),
    [anon_sym_fun] = ACTIONS(2922),
    [anon_sym_try] = ACTIONS(2922),
    [anon_sym_match] = ACTIONS(2922),
    [anon_sym_match_BANG] = ACTIONS(2924),
    [anon_sym_function] = ACTIONS(2922),
    [anon_sym_LT_DASH] = ACTIONS(2922),
    [anon_sym_DOT_LBRACK] = ACTIONS(2924),
    [anon_sym_LT] = ACTIONS(2924),
    [anon_sym_use] = ACTIONS(2922),
    [anon_sym_use_BANG] = ACTIONS(2924),
    [anon_sym_do_BANG] = ACTIONS(2924),
    [anon_sym_begin] = ACTIONS(2922),
    [anon_sym_LPAREN2] = ACTIONS(2922),
    [anon_sym_or] = ACTIONS(2922),
    [aux_sym_char_token1] = ACTIONS(2924),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2922),
    [anon_sym_DQUOTE] = ACTIONS(2922),
    [anon_sym_AT_DQUOTE] = ACTIONS(2924),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2924),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2924),
    [sym_bool] = ACTIONS(2922),
    [sym_unit] = ACTIONS(2924),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2922),
    [sym_op_identifier] = ACTIONS(2922),
    [anon_sym_PLUS] = ACTIONS(2922),
    [anon_sym_DASH] = ACTIONS(2922),
    [anon_sym_PLUS_DOT] = ACTIONS(2922),
    [anon_sym_DASH_DOT] = ACTIONS(2922),
    [anon_sym_PERCENT] = ACTIONS(2922),
    [anon_sym_AMP_AMP] = ACTIONS(2922),
    [anon_sym_TILDE] = ACTIONS(2924),
    [aux_sym_prefix_op_token1] = ACTIONS(2922),
    [aux_sym_infix_op_token1] = ACTIONS(2924),
    [aux_sym_infix_op_token2] = ACTIONS(2922),
    [anon_sym_PIPE_PIPE] = ACTIONS(2922),
    [anon_sym_BANG_EQ] = ACTIONS(2922),
    [anon_sym_COLON_EQ] = ACTIONS(2924),
    [anon_sym_DOLLAR] = ACTIONS(2922),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2922),
    [sym_int] = ACTIONS(2922),
    [sym_xint] = ACTIONS(2924),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2924),
    [sym__newline] = ACTIONS(2924),
  },
  [2282] = {
    [sym_block_comment] = STATE(2282),
    [sym_compiler_directive_decl] = STATE(2282),
    [sym_fsi_directive_decl] = STATE(2282),
    [sym_preproc_line] = STATE(2282),
    [sym_identifier] = ACTIONS(2996),
    [anon_sym_EQ] = ACTIONS(2998),
    [anon_sym_COLON] = ACTIONS(2996),
    [anon_sym_return] = ACTIONS(2996),
    [anon_sym_do] = ACTIONS(2996),
    [anon_sym_let] = ACTIONS(2996),
    [anon_sym_let_BANG] = ACTIONS(2998),
    [anon_sym_LPAREN] = ACTIONS(2996),
    [anon_sym_COMMA] = ACTIONS(2998),
    [anon_sym_null] = ACTIONS(2996),
    [anon_sym_QMARK] = ACTIONS(2996),
    [anon_sym_COLON_QMARK] = ACTIONS(2996),
    [anon_sym_COLON_COLON] = ACTIONS(2998),
    [anon_sym_AMP] = ACTIONS(2996),
    [anon_sym_LBRACK] = ACTIONS(2996),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2998),
    [anon_sym_LBRACE] = ACTIONS(2996),
    [anon_sym_LT_AT] = ACTIONS(2996),
    [anon_sym_AT_GT] = ACTIONS(2996),
    [anon_sym_LT_AT_AT] = ACTIONS(2996),
    [anon_sym_DOT] = ACTIONS(2996),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2998),
    [anon_sym_new] = ACTIONS(2996),
    [anon_sym_return_BANG] = ACTIONS(2998),
    [anon_sym_yield] = ACTIONS(2996),
    [anon_sym_yield_BANG] = ACTIONS(2998),
    [anon_sym_lazy] = ACTIONS(2996),
    [anon_sym_assert] = ACTIONS(2996),
    [anon_sym_upcast] = ACTIONS(2996),
    [anon_sym_downcast] = ACTIONS(2996),
    [anon_sym_COLON_GT] = ACTIONS(2998),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2998),
    [anon_sym_for] = ACTIONS(2996),
    [anon_sym_while] = ACTIONS(2996),
    [anon_sym_if] = ACTIONS(2996),
    [anon_sym_fun] = ACTIONS(2996),
    [anon_sym_try] = ACTIONS(2996),
    [anon_sym_match] = ACTIONS(2996),
    [anon_sym_match_BANG] = ACTIONS(2998),
    [anon_sym_function] = ACTIONS(2996),
    [anon_sym_LT_DASH] = ACTIONS(2996),
    [anon_sym_DOT_LBRACK] = ACTIONS(2998),
    [anon_sym_LT] = ACTIONS(2998),
    [anon_sym_use] = ACTIONS(2996),
    [anon_sym_use_BANG] = ACTIONS(2998),
    [anon_sym_do_BANG] = ACTIONS(2998),
    [anon_sym_begin] = ACTIONS(2996),
    [anon_sym_LPAREN2] = ACTIONS(2996),
    [anon_sym_or] = ACTIONS(2996),
    [aux_sym_char_token1] = ACTIONS(2998),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2996),
    [anon_sym_DQUOTE] = ACTIONS(2996),
    [anon_sym_AT_DQUOTE] = ACTIONS(2998),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2998),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2998),
    [sym_bool] = ACTIONS(2996),
    [sym_unit] = ACTIONS(2998),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2996),
    [sym_op_identifier] = ACTIONS(2996),
    [anon_sym_PLUS] = ACTIONS(2996),
    [anon_sym_DASH] = ACTIONS(2996),
    [anon_sym_PLUS_DOT] = ACTIONS(2996),
    [anon_sym_DASH_DOT] = ACTIONS(2996),
    [anon_sym_PERCENT] = ACTIONS(2996),
    [anon_sym_AMP_AMP] = ACTIONS(2996),
    [anon_sym_TILDE] = ACTIONS(2998),
    [aux_sym_prefix_op_token1] = ACTIONS(2996),
    [aux_sym_infix_op_token1] = ACTIONS(2998),
    [aux_sym_infix_op_token2] = ACTIONS(2996),
    [anon_sym_PIPE_PIPE] = ACTIONS(2996),
    [anon_sym_BANG_EQ] = ACTIONS(2996),
    [anon_sym_COLON_EQ] = ACTIONS(2998),
    [anon_sym_DOLLAR] = ACTIONS(2996),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2996),
    [sym_int] = ACTIONS(2996),
    [sym_xint] = ACTIONS(2998),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2998),
    [sym__newline] = ACTIONS(2998),
  },
  [2283] = {
    [sym_block_comment] = STATE(2283),
    [sym_compiler_directive_decl] = STATE(2283),
    [sym_fsi_directive_decl] = STATE(2283),
    [sym_preproc_line] = STATE(2283),
    [sym_identifier] = ACTIONS(3003),
    [anon_sym_EQ] = ACTIONS(3005),
    [anon_sym_COLON] = ACTIONS(3003),
    [anon_sym_return] = ACTIONS(3003),
    [anon_sym_do] = ACTIONS(3003),
    [anon_sym_let] = ACTIONS(3003),
    [anon_sym_let_BANG] = ACTIONS(3005),
    [anon_sym_LPAREN] = ACTIONS(3003),
    [anon_sym_COMMA] = ACTIONS(3005),
    [anon_sym_null] = ACTIONS(3003),
    [anon_sym_QMARK] = ACTIONS(3003),
    [anon_sym_COLON_QMARK] = ACTIONS(3003),
    [anon_sym_COLON_COLON] = ACTIONS(3005),
    [anon_sym_AMP] = ACTIONS(3003),
    [anon_sym_LBRACK] = ACTIONS(3003),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3005),
    [anon_sym_LBRACE] = ACTIONS(3003),
    [anon_sym_LT_AT] = ACTIONS(3003),
    [anon_sym_AT_GT] = ACTIONS(3003),
    [anon_sym_LT_AT_AT] = ACTIONS(3003),
    [anon_sym_DOT] = ACTIONS(3003),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3005),
    [anon_sym_new] = ACTIONS(3003),
    [anon_sym_return_BANG] = ACTIONS(3005),
    [anon_sym_yield] = ACTIONS(3003),
    [anon_sym_yield_BANG] = ACTIONS(3005),
    [anon_sym_lazy] = ACTIONS(3003),
    [anon_sym_assert] = ACTIONS(3003),
    [anon_sym_upcast] = ACTIONS(3003),
    [anon_sym_downcast] = ACTIONS(3003),
    [anon_sym_COLON_GT] = ACTIONS(3005),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3005),
    [anon_sym_for] = ACTIONS(3003),
    [anon_sym_while] = ACTIONS(3003),
    [anon_sym_if] = ACTIONS(3003),
    [anon_sym_fun] = ACTIONS(3003),
    [anon_sym_try] = ACTIONS(3003),
    [anon_sym_match] = ACTIONS(3003),
    [anon_sym_match_BANG] = ACTIONS(3005),
    [anon_sym_function] = ACTIONS(3003),
    [anon_sym_LT_DASH] = ACTIONS(3003),
    [anon_sym_DOT_LBRACK] = ACTIONS(3005),
    [anon_sym_LT] = ACTIONS(3005),
    [anon_sym_use] = ACTIONS(3003),
    [anon_sym_use_BANG] = ACTIONS(3005),
    [anon_sym_do_BANG] = ACTIONS(3005),
    [anon_sym_begin] = ACTIONS(3003),
    [anon_sym_LPAREN2] = ACTIONS(3003),
    [anon_sym_or] = ACTIONS(3003),
    [aux_sym_char_token1] = ACTIONS(3005),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3003),
    [anon_sym_DQUOTE] = ACTIONS(3003),
    [anon_sym_AT_DQUOTE] = ACTIONS(3005),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3005),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3005),
    [sym_bool] = ACTIONS(3003),
    [sym_unit] = ACTIONS(3005),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3003),
    [sym_op_identifier] = ACTIONS(3003),
    [anon_sym_PLUS] = ACTIONS(3003),
    [anon_sym_DASH] = ACTIONS(3003),
    [anon_sym_PLUS_DOT] = ACTIONS(3003),
    [anon_sym_DASH_DOT] = ACTIONS(3003),
    [anon_sym_PERCENT] = ACTIONS(3003),
    [anon_sym_AMP_AMP] = ACTIONS(3003),
    [anon_sym_TILDE] = ACTIONS(3005),
    [aux_sym_prefix_op_token1] = ACTIONS(3003),
    [aux_sym_infix_op_token1] = ACTIONS(3005),
    [aux_sym_infix_op_token2] = ACTIONS(3003),
    [anon_sym_PIPE_PIPE] = ACTIONS(3003),
    [anon_sym_BANG_EQ] = ACTIONS(3003),
    [anon_sym_COLON_EQ] = ACTIONS(3005),
    [anon_sym_DOLLAR] = ACTIONS(3003),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3003),
    [sym_int] = ACTIONS(3003),
    [sym_xint] = ACTIONS(3005),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3005),
    [sym__newline] = ACTIONS(3005),
  },
  [2284] = {
    [sym_block_comment] = STATE(2284),
    [sym_compiler_directive_decl] = STATE(2284),
    [sym_fsi_directive_decl] = STATE(2284),
    [sym_preproc_line] = STATE(2284),
    [sym_identifier] = ACTIONS(2992),
    [anon_sym_EQ] = ACTIONS(2994),
    [anon_sym_COLON] = ACTIONS(2992),
    [anon_sym_return] = ACTIONS(2992),
    [anon_sym_do] = ACTIONS(2992),
    [anon_sym_let] = ACTIONS(2992),
    [anon_sym_let_BANG] = ACTIONS(2994),
    [anon_sym_LPAREN] = ACTIONS(2992),
    [anon_sym_COMMA] = ACTIONS(2994),
    [anon_sym_null] = ACTIONS(2992),
    [anon_sym_QMARK] = ACTIONS(2992),
    [anon_sym_COLON_QMARK] = ACTIONS(2992),
    [anon_sym_COLON_COLON] = ACTIONS(2994),
    [anon_sym_AMP] = ACTIONS(2992),
    [anon_sym_LBRACK] = ACTIONS(2992),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2994),
    [anon_sym_LBRACE] = ACTIONS(2992),
    [anon_sym_LT_AT] = ACTIONS(2992),
    [anon_sym_LT_AT_AT] = ACTIONS(2992),
    [anon_sym_DOT] = ACTIONS(2992),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2994),
    [anon_sym_new] = ACTIONS(2992),
    [anon_sym_return_BANG] = ACTIONS(2994),
    [anon_sym_yield] = ACTIONS(2992),
    [anon_sym_yield_BANG] = ACTIONS(2994),
    [anon_sym_lazy] = ACTIONS(2992),
    [anon_sym_assert] = ACTIONS(2992),
    [anon_sym_upcast] = ACTIONS(2992),
    [anon_sym_downcast] = ACTIONS(2992),
    [anon_sym_COLON_GT] = ACTIONS(2994),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2994),
    [anon_sym_for] = ACTIONS(2992),
    [anon_sym_while] = ACTIONS(2992),
    [anon_sym_if] = ACTIONS(2992),
    [anon_sym_fun] = ACTIONS(2992),
    [anon_sym_try] = ACTIONS(2992),
    [anon_sym_match] = ACTIONS(2992),
    [anon_sym_match_BANG] = ACTIONS(2994),
    [anon_sym_function] = ACTIONS(2992),
    [anon_sym_LT_DASH] = ACTIONS(2992),
    [anon_sym_DOT_LBRACK] = ACTIONS(2994),
    [anon_sym_LT] = ACTIONS(2994),
    [anon_sym_use] = ACTIONS(2992),
    [anon_sym_use_BANG] = ACTIONS(2994),
    [anon_sym_do_BANG] = ACTIONS(2994),
    [anon_sym_begin] = ACTIONS(2992),
    [anon_sym_LPAREN2] = ACTIONS(2992),
    [anon_sym_or] = ACTIONS(2992),
    [aux_sym_char_token1] = ACTIONS(2994),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2992),
    [anon_sym_DQUOTE] = ACTIONS(2992),
    [anon_sym_AT_DQUOTE] = ACTIONS(2994),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2994),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2994),
    [sym_bool] = ACTIONS(2992),
    [sym_unit] = ACTIONS(2994),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2992),
    [sym_op_identifier] = ACTIONS(2992),
    [anon_sym_PLUS] = ACTIONS(2992),
    [anon_sym_DASH] = ACTIONS(2992),
    [anon_sym_PLUS_DOT] = ACTIONS(2992),
    [anon_sym_DASH_DOT] = ACTIONS(2992),
    [anon_sym_PERCENT] = ACTIONS(2992),
    [anon_sym_AMP_AMP] = ACTIONS(2992),
    [anon_sym_TILDE] = ACTIONS(2994),
    [aux_sym_prefix_op_token1] = ACTIONS(2992),
    [aux_sym_infix_op_token1] = ACTIONS(2994),
    [aux_sym_infix_op_token2] = ACTIONS(2992),
    [anon_sym_PIPE_PIPE] = ACTIONS(2992),
    [anon_sym_BANG_EQ] = ACTIONS(2992),
    [anon_sym_COLON_EQ] = ACTIONS(2994),
    [anon_sym_DOLLAR] = ACTIONS(2992),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2992),
    [sym_int] = ACTIONS(2992),
    [sym_xint] = ACTIONS(2994),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2994),
    [anon_sym_POUNDendif] = ACTIONS(2994),
    [sym__newline] = ACTIONS(2994),
  },
  [2285] = {
    [sym_block_comment] = STATE(2285),
    [sym_compiler_directive_decl] = STATE(2285),
    [sym_fsi_directive_decl] = STATE(2285),
    [sym_preproc_line] = STATE(2285),
    [sym_identifier] = ACTIONS(3007),
    [anon_sym_EQ] = ACTIONS(3009),
    [anon_sym_COLON] = ACTIONS(3007),
    [anon_sym_return] = ACTIONS(3007),
    [anon_sym_do] = ACTIONS(3007),
    [anon_sym_let] = ACTIONS(3007),
    [anon_sym_let_BANG] = ACTIONS(3009),
    [anon_sym_LPAREN] = ACTIONS(3007),
    [anon_sym_COMMA] = ACTIONS(3009),
    [anon_sym_null] = ACTIONS(3007),
    [anon_sym_QMARK] = ACTIONS(3007),
    [anon_sym_COLON_QMARK] = ACTIONS(3007),
    [anon_sym_COLON_COLON] = ACTIONS(3009),
    [anon_sym_AMP] = ACTIONS(3007),
    [anon_sym_LBRACK] = ACTIONS(3007),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3009),
    [anon_sym_LBRACE] = ACTIONS(3007),
    [anon_sym_LT_AT] = ACTIONS(3007),
    [anon_sym_AT_GT] = ACTIONS(3007),
    [anon_sym_LT_AT_AT] = ACTIONS(3007),
    [anon_sym_DOT] = ACTIONS(3007),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3009),
    [anon_sym_new] = ACTIONS(3007),
    [anon_sym_return_BANG] = ACTIONS(3009),
    [anon_sym_yield] = ACTIONS(3007),
    [anon_sym_yield_BANG] = ACTIONS(3009),
    [anon_sym_lazy] = ACTIONS(3007),
    [anon_sym_assert] = ACTIONS(3007),
    [anon_sym_upcast] = ACTIONS(3007),
    [anon_sym_downcast] = ACTIONS(3007),
    [anon_sym_COLON_GT] = ACTIONS(3009),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3009),
    [anon_sym_for] = ACTIONS(3007),
    [anon_sym_while] = ACTIONS(3007),
    [anon_sym_if] = ACTIONS(3007),
    [anon_sym_fun] = ACTIONS(3007),
    [anon_sym_try] = ACTIONS(3007),
    [anon_sym_match] = ACTIONS(3007),
    [anon_sym_match_BANG] = ACTIONS(3009),
    [anon_sym_function] = ACTIONS(3007),
    [anon_sym_LT_DASH] = ACTIONS(3007),
    [anon_sym_DOT_LBRACK] = ACTIONS(3009),
    [anon_sym_LT] = ACTIONS(3009),
    [anon_sym_use] = ACTIONS(3007),
    [anon_sym_use_BANG] = ACTIONS(3009),
    [anon_sym_do_BANG] = ACTIONS(3009),
    [anon_sym_begin] = ACTIONS(3007),
    [anon_sym_LPAREN2] = ACTIONS(3007),
    [anon_sym_or] = ACTIONS(3007),
    [aux_sym_char_token1] = ACTIONS(3009),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3007),
    [anon_sym_DQUOTE] = ACTIONS(3007),
    [anon_sym_AT_DQUOTE] = ACTIONS(3009),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3009),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3009),
    [sym_bool] = ACTIONS(3007),
    [sym_unit] = ACTIONS(3009),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3007),
    [sym_op_identifier] = ACTIONS(3007),
    [anon_sym_PLUS] = ACTIONS(3007),
    [anon_sym_DASH] = ACTIONS(3007),
    [anon_sym_PLUS_DOT] = ACTIONS(3007),
    [anon_sym_DASH_DOT] = ACTIONS(3007),
    [anon_sym_PERCENT] = ACTIONS(3007),
    [anon_sym_AMP_AMP] = ACTIONS(3007),
    [anon_sym_TILDE] = ACTIONS(3009),
    [aux_sym_prefix_op_token1] = ACTIONS(3007),
    [aux_sym_infix_op_token1] = ACTIONS(3009),
    [aux_sym_infix_op_token2] = ACTIONS(3007),
    [anon_sym_PIPE_PIPE] = ACTIONS(3007),
    [anon_sym_BANG_EQ] = ACTIONS(3007),
    [anon_sym_COLON_EQ] = ACTIONS(3009),
    [anon_sym_DOLLAR] = ACTIONS(3007),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3007),
    [sym_int] = ACTIONS(3007),
    [sym_xint] = ACTIONS(3009),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3009),
    [sym__newline] = ACTIONS(3009),
  },
  [2286] = {
    [sym_block_comment] = STATE(2286),
    [sym_compiler_directive_decl] = STATE(2286),
    [sym_fsi_directive_decl] = STATE(2286),
    [sym_preproc_line] = STATE(2286),
    [sym_identifier] = ACTIONS(3123),
    [anon_sym_EQ] = ACTIONS(3125),
    [anon_sym_COLON] = ACTIONS(3123),
    [anon_sym_return] = ACTIONS(3123),
    [anon_sym_do] = ACTIONS(3123),
    [anon_sym_let] = ACTIONS(3123),
    [anon_sym_let_BANG] = ACTIONS(3125),
    [anon_sym_LPAREN] = ACTIONS(3123),
    [anon_sym_COMMA] = ACTIONS(3125),
    [anon_sym_null] = ACTIONS(3123),
    [anon_sym_QMARK] = ACTIONS(3123),
    [anon_sym_COLON_QMARK] = ACTIONS(3123),
    [anon_sym_COLON_COLON] = ACTIONS(3125),
    [anon_sym_AMP] = ACTIONS(3123),
    [anon_sym_LBRACK] = ACTIONS(3123),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3125),
    [anon_sym_LBRACE] = ACTIONS(3123),
    [anon_sym_LT_AT] = ACTIONS(3123),
    [anon_sym_LT_AT_AT] = ACTIONS(3123),
    [anon_sym_AT_AT_GT] = ACTIONS(3123),
    [anon_sym_DOT] = ACTIONS(3123),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3125),
    [anon_sym_new] = ACTIONS(3123),
    [anon_sym_return_BANG] = ACTIONS(3125),
    [anon_sym_yield] = ACTIONS(3123),
    [anon_sym_yield_BANG] = ACTIONS(3125),
    [anon_sym_lazy] = ACTIONS(3123),
    [anon_sym_assert] = ACTIONS(3123),
    [anon_sym_upcast] = ACTIONS(3123),
    [anon_sym_downcast] = ACTIONS(3123),
    [anon_sym_COLON_GT] = ACTIONS(3125),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3125),
    [anon_sym_for] = ACTIONS(3123),
    [anon_sym_while] = ACTIONS(3123),
    [anon_sym_if] = ACTIONS(3123),
    [anon_sym_fun] = ACTIONS(3123),
    [anon_sym_try] = ACTIONS(3123),
    [anon_sym_match] = ACTIONS(3123),
    [anon_sym_match_BANG] = ACTIONS(3125),
    [anon_sym_function] = ACTIONS(3123),
    [anon_sym_LT_DASH] = ACTIONS(3123),
    [anon_sym_DOT_LBRACK] = ACTIONS(3125),
    [anon_sym_LT] = ACTIONS(3125),
    [anon_sym_use] = ACTIONS(3123),
    [anon_sym_use_BANG] = ACTIONS(3125),
    [anon_sym_do_BANG] = ACTIONS(3125),
    [anon_sym_begin] = ACTIONS(3123),
    [anon_sym_LPAREN2] = ACTIONS(3123),
    [anon_sym_or] = ACTIONS(3123),
    [aux_sym_char_token1] = ACTIONS(3125),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3123),
    [anon_sym_DQUOTE] = ACTIONS(3123),
    [anon_sym_AT_DQUOTE] = ACTIONS(3125),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3125),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3125),
    [sym_bool] = ACTIONS(3123),
    [sym_unit] = ACTIONS(3125),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3123),
    [sym_op_identifier] = ACTIONS(3123),
    [anon_sym_PLUS] = ACTIONS(3123),
    [anon_sym_DASH] = ACTIONS(3123),
    [anon_sym_PLUS_DOT] = ACTIONS(3123),
    [anon_sym_DASH_DOT] = ACTIONS(3123),
    [anon_sym_PERCENT] = ACTIONS(3123),
    [anon_sym_AMP_AMP] = ACTIONS(3123),
    [anon_sym_TILDE] = ACTIONS(3125),
    [aux_sym_prefix_op_token1] = ACTIONS(3123),
    [aux_sym_infix_op_token1] = ACTIONS(3125),
    [aux_sym_infix_op_token2] = ACTIONS(3123),
    [anon_sym_PIPE_PIPE] = ACTIONS(3123),
    [anon_sym_BANG_EQ] = ACTIONS(3123),
    [anon_sym_COLON_EQ] = ACTIONS(3125),
    [anon_sym_DOLLAR] = ACTIONS(3123),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3123),
    [sym_int] = ACTIONS(3123),
    [sym_xint] = ACTIONS(3125),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3125),
    [sym__newline] = ACTIONS(3125),
  },
  [2287] = {
    [sym_block_comment] = STATE(2287),
    [sym_compiler_directive_decl] = STATE(2287),
    [sym_fsi_directive_decl] = STATE(2287),
    [sym_preproc_line] = STATE(2287),
    [sym_identifier] = ACTIONS(3127),
    [anon_sym_EQ] = ACTIONS(3129),
    [anon_sym_COLON] = ACTIONS(3127),
    [anon_sym_return] = ACTIONS(3127),
    [anon_sym_do] = ACTIONS(3127),
    [anon_sym_let] = ACTIONS(3127),
    [anon_sym_let_BANG] = ACTIONS(3129),
    [anon_sym_LPAREN] = ACTIONS(3127),
    [anon_sym_COMMA] = ACTIONS(3129),
    [anon_sym_null] = ACTIONS(3127),
    [anon_sym_QMARK] = ACTIONS(3127),
    [anon_sym_COLON_QMARK] = ACTIONS(3127),
    [anon_sym_COLON_COLON] = ACTIONS(3129),
    [anon_sym_AMP] = ACTIONS(3127),
    [anon_sym_LBRACK] = ACTIONS(3127),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3129),
    [anon_sym_LBRACE] = ACTIONS(3127),
    [anon_sym_LT_AT] = ACTIONS(3127),
    [anon_sym_LT_AT_AT] = ACTIONS(3127),
    [anon_sym_AT_AT_GT] = ACTIONS(3127),
    [anon_sym_DOT] = ACTIONS(3127),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3129),
    [anon_sym_new] = ACTIONS(3127),
    [anon_sym_return_BANG] = ACTIONS(3129),
    [anon_sym_yield] = ACTIONS(3127),
    [anon_sym_yield_BANG] = ACTIONS(3129),
    [anon_sym_lazy] = ACTIONS(3127),
    [anon_sym_assert] = ACTIONS(3127),
    [anon_sym_upcast] = ACTIONS(3127),
    [anon_sym_downcast] = ACTIONS(3127),
    [anon_sym_COLON_GT] = ACTIONS(3129),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3129),
    [anon_sym_for] = ACTIONS(3127),
    [anon_sym_while] = ACTIONS(3127),
    [anon_sym_if] = ACTIONS(3127),
    [anon_sym_fun] = ACTIONS(3127),
    [anon_sym_try] = ACTIONS(3127),
    [anon_sym_match] = ACTIONS(3127),
    [anon_sym_match_BANG] = ACTIONS(3129),
    [anon_sym_function] = ACTIONS(3127),
    [anon_sym_LT_DASH] = ACTIONS(3127),
    [anon_sym_DOT_LBRACK] = ACTIONS(3129),
    [anon_sym_LT] = ACTIONS(3129),
    [anon_sym_use] = ACTIONS(3127),
    [anon_sym_use_BANG] = ACTIONS(3129),
    [anon_sym_do_BANG] = ACTIONS(3129),
    [anon_sym_begin] = ACTIONS(3127),
    [anon_sym_LPAREN2] = ACTIONS(3127),
    [anon_sym_or] = ACTIONS(3127),
    [aux_sym_char_token1] = ACTIONS(3129),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3127),
    [anon_sym_DQUOTE] = ACTIONS(3127),
    [anon_sym_AT_DQUOTE] = ACTIONS(3129),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3129),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3129),
    [sym_bool] = ACTIONS(3127),
    [sym_unit] = ACTIONS(3129),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3127),
    [sym_op_identifier] = ACTIONS(3127),
    [anon_sym_PLUS] = ACTIONS(3127),
    [anon_sym_DASH] = ACTIONS(3127),
    [anon_sym_PLUS_DOT] = ACTIONS(3127),
    [anon_sym_DASH_DOT] = ACTIONS(3127),
    [anon_sym_PERCENT] = ACTIONS(3127),
    [anon_sym_AMP_AMP] = ACTIONS(3127),
    [anon_sym_TILDE] = ACTIONS(3129),
    [aux_sym_prefix_op_token1] = ACTIONS(3127),
    [aux_sym_infix_op_token1] = ACTIONS(3129),
    [aux_sym_infix_op_token2] = ACTIONS(3127),
    [anon_sym_PIPE_PIPE] = ACTIONS(3127),
    [anon_sym_BANG_EQ] = ACTIONS(3127),
    [anon_sym_COLON_EQ] = ACTIONS(3129),
    [anon_sym_DOLLAR] = ACTIONS(3127),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3127),
    [sym_int] = ACTIONS(3127),
    [sym_xint] = ACTIONS(3129),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3129),
    [sym__newline] = ACTIONS(3129),
  },
  [2288] = {
    [sym_attributes] = STATE(2636),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(3546),
    [sym__pattern] = STATE(3706),
    [sym_optional_pattern] = STATE(3546),
    [sym_type_check_pattern] = STATE(3546),
    [sym_attribute_pattern] = STATE(3546),
    [sym_paren_pattern] = STATE(3546),
    [sym_as_pattern] = STATE(3546),
    [sym_cons_pattern] = STATE(3546),
    [sym_disjunct_pattern] = STATE(3546),
    [sym_conjunct_pattern] = STATE(3546),
    [sym_typed_pattern] = STATE(3546),
    [sym_list_pattern] = STATE(3546),
    [sym_array_pattern] = STATE(3546),
    [sym_record_pattern] = STATE(3546),
    [sym_named_field_pattern] = STATE(3546),
    [sym_identifier_pattern] = STATE(3546),
    [sym_long_identifier_or_op] = STATE(1834),
    [sym_type_arguments] = STATE(2572),
    [sym__method_defn] = STATE(4900),
    [sym__property_defn] = STATE(4865),
    [sym_char] = STATE(3509),
    [sym_format_string] = STATE(3517),
    [sym__string_literal] = STATE(3517),
    [sym_string] = STATE(3509),
    [sym_verbatim_string] = STATE(3509),
    [sym_bytearray] = STATE(3509),
    [sym_verbatim_bytearray] = STATE(3509),
    [sym_format_triple_quoted_string] = STATE(3519),
    [sym_triple_quoted_string] = STATE(3509),
    [sym_const] = STATE(3546),
    [sym_long_identifier] = STATE(3320),
    [sym_active_pattern] = STATE(3488),
    [sym__identifier_or_op] = STATE(3410),
    [sym_sbyte] = STATE(3509),
    [sym_byte] = STATE(3509),
    [sym_int16] = STATE(3509),
    [sym_uint16] = STATE(3509),
    [sym_int32] = STATE(3509),
    [sym_uint32] = STATE(3509),
    [sym_nativeint] = STATE(3509),
    [sym_unativeint] = STATE(3509),
    [sym_int64] = STATE(3509),
    [sym_uint64] = STATE(3509),
    [sym_ieee32] = STATE(3509),
    [sym_ieee64] = STATE(3509),
    [sym_bignum] = STATE(3509),
    [sym_decimal] = STATE(3509),
    [sym_float] = STATE(3291),
    [sym_block_comment] = STATE(2288),
    [sym_compiler_directive_decl] = STATE(2288),
    [sym_fsi_directive_decl] = STATE(2288),
    [sym_preproc_line] = STATE(2288),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [aux_sym__method_defn_repeat1] = STATE(2566),
    [sym_identifier] = ACTIONS(3562),
    [anon_sym_EQ] = ACTIONS(4292),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_COLON] = ACTIONS(4294),
    [anon_sym_LPAREN] = ACTIONS(4014),
    [anon_sym_null] = ACTIONS(4016),
    [anon_sym__] = ACTIONS(4018),
    [anon_sym_QMARK] = ACTIONS(4020),
    [anon_sym_COLON_QMARK] = ACTIONS(4022),
    [anon_sym_LBRACK] = ACTIONS(4024),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4026),
    [anon_sym_LBRACE] = ACTIONS(4028),
    [anon_sym_with] = ACTIONS(4296),
    [anon_sym_LT2] = ACTIONS(4298),
    [aux_sym_char_token1] = ACTIONS(4030),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4032),
    [anon_sym_DQUOTE] = ACTIONS(4034),
    [anon_sym_AT_DQUOTE] = ACTIONS(4036),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4038),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4040),
    [sym_bool] = ACTIONS(4042),
    [sym_unit] = ACTIONS(4044),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3606),
    [sym_op_identifier] = ACTIONS(3608),
    [sym_int] = ACTIONS(4046),
    [sym_xint] = ACTIONS(4048),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2289] = {
    [sym_block_comment] = STATE(2289),
    [sym_compiler_directive_decl] = STATE(2289),
    [sym_fsi_directive_decl] = STATE(2289),
    [sym_preproc_line] = STATE(2289),
    [sym_identifier] = ACTIONS(2918),
    [anon_sym_EQ] = ACTIONS(2920),
    [anon_sym_COLON] = ACTIONS(2918),
    [anon_sym_return] = ACTIONS(2918),
    [anon_sym_do] = ACTIONS(2918),
    [anon_sym_let] = ACTIONS(2918),
    [anon_sym_let_BANG] = ACTIONS(2920),
    [anon_sym_LPAREN] = ACTIONS(2918),
    [anon_sym_COMMA] = ACTIONS(2920),
    [anon_sym_null] = ACTIONS(2918),
    [anon_sym_QMARK] = ACTIONS(2918),
    [anon_sym_COLON_QMARK] = ACTIONS(2918),
    [anon_sym_COLON_COLON] = ACTIONS(2920),
    [anon_sym_AMP] = ACTIONS(2918),
    [anon_sym_LBRACK] = ACTIONS(2918),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2920),
    [anon_sym_LBRACE] = ACTIONS(2918),
    [anon_sym_LT_AT] = ACTIONS(2918),
    [anon_sym_AT_GT] = ACTIONS(2918),
    [anon_sym_LT_AT_AT] = ACTIONS(2918),
    [anon_sym_DOT] = ACTIONS(2918),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2920),
    [anon_sym_new] = ACTIONS(2918),
    [anon_sym_return_BANG] = ACTIONS(2920),
    [anon_sym_yield] = ACTIONS(2918),
    [anon_sym_yield_BANG] = ACTIONS(2920),
    [anon_sym_lazy] = ACTIONS(2918),
    [anon_sym_assert] = ACTIONS(2918),
    [anon_sym_upcast] = ACTIONS(2918),
    [anon_sym_downcast] = ACTIONS(2918),
    [anon_sym_COLON_GT] = ACTIONS(2920),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2920),
    [anon_sym_for] = ACTIONS(2918),
    [anon_sym_while] = ACTIONS(2918),
    [anon_sym_if] = ACTIONS(2918),
    [anon_sym_fun] = ACTIONS(2918),
    [anon_sym_try] = ACTIONS(2918),
    [anon_sym_match] = ACTIONS(2918),
    [anon_sym_match_BANG] = ACTIONS(2920),
    [anon_sym_function] = ACTIONS(2918),
    [anon_sym_LT_DASH] = ACTIONS(2918),
    [anon_sym_DOT_LBRACK] = ACTIONS(2920),
    [anon_sym_LT] = ACTIONS(2920),
    [anon_sym_use] = ACTIONS(2918),
    [anon_sym_use_BANG] = ACTIONS(2920),
    [anon_sym_do_BANG] = ACTIONS(2920),
    [anon_sym_begin] = ACTIONS(2918),
    [anon_sym_LPAREN2] = ACTIONS(2918),
    [anon_sym_or] = ACTIONS(2918),
    [aux_sym_char_token1] = ACTIONS(2920),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2918),
    [anon_sym_DQUOTE] = ACTIONS(2918),
    [anon_sym_AT_DQUOTE] = ACTIONS(2920),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2920),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2920),
    [sym_bool] = ACTIONS(2918),
    [sym_unit] = ACTIONS(2920),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2918),
    [sym_op_identifier] = ACTIONS(2918),
    [anon_sym_PLUS] = ACTIONS(2918),
    [anon_sym_DASH] = ACTIONS(2918),
    [anon_sym_PLUS_DOT] = ACTIONS(2918),
    [anon_sym_DASH_DOT] = ACTIONS(2918),
    [anon_sym_PERCENT] = ACTIONS(2918),
    [anon_sym_AMP_AMP] = ACTIONS(2918),
    [anon_sym_TILDE] = ACTIONS(2920),
    [aux_sym_prefix_op_token1] = ACTIONS(2918),
    [aux_sym_infix_op_token1] = ACTIONS(2920),
    [aux_sym_infix_op_token2] = ACTIONS(2918),
    [anon_sym_PIPE_PIPE] = ACTIONS(2918),
    [anon_sym_BANG_EQ] = ACTIONS(2918),
    [anon_sym_COLON_EQ] = ACTIONS(2920),
    [anon_sym_DOLLAR] = ACTIONS(2918),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2918),
    [sym_int] = ACTIONS(2918),
    [sym_xint] = ACTIONS(2920),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2920),
    [sym__newline] = ACTIONS(2920),
  },
  [2290] = {
    [sym_block_comment] = STATE(2290),
    [sym_compiler_directive_decl] = STATE(2290),
    [sym_fsi_directive_decl] = STATE(2290),
    [sym_preproc_line] = STATE(2290),
    [sym_identifier] = ACTIONS(2914),
    [anon_sym_EQ] = ACTIONS(2916),
    [anon_sym_COLON] = ACTIONS(2914),
    [anon_sym_return] = ACTIONS(2914),
    [anon_sym_do] = ACTIONS(2914),
    [anon_sym_let] = ACTIONS(2914),
    [anon_sym_let_BANG] = ACTIONS(2916),
    [anon_sym_LPAREN] = ACTIONS(2914),
    [anon_sym_COMMA] = ACTIONS(2916),
    [anon_sym_null] = ACTIONS(2914),
    [anon_sym_QMARK] = ACTIONS(2914),
    [anon_sym_COLON_QMARK] = ACTIONS(2914),
    [anon_sym_COLON_COLON] = ACTIONS(2916),
    [anon_sym_AMP] = ACTIONS(2914),
    [anon_sym_LBRACK] = ACTIONS(2914),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2916),
    [anon_sym_LBRACE] = ACTIONS(2914),
    [anon_sym_LT_AT] = ACTIONS(2914),
    [anon_sym_AT_GT] = ACTIONS(2914),
    [anon_sym_LT_AT_AT] = ACTIONS(2914),
    [anon_sym_DOT] = ACTIONS(2914),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2916),
    [anon_sym_new] = ACTIONS(2914),
    [anon_sym_return_BANG] = ACTIONS(2916),
    [anon_sym_yield] = ACTIONS(2914),
    [anon_sym_yield_BANG] = ACTIONS(2916),
    [anon_sym_lazy] = ACTIONS(2914),
    [anon_sym_assert] = ACTIONS(2914),
    [anon_sym_upcast] = ACTIONS(2914),
    [anon_sym_downcast] = ACTIONS(2914),
    [anon_sym_COLON_GT] = ACTIONS(2916),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2916),
    [anon_sym_for] = ACTIONS(2914),
    [anon_sym_while] = ACTIONS(2914),
    [anon_sym_if] = ACTIONS(2914),
    [anon_sym_fun] = ACTIONS(2914),
    [anon_sym_try] = ACTIONS(2914),
    [anon_sym_match] = ACTIONS(2914),
    [anon_sym_match_BANG] = ACTIONS(2916),
    [anon_sym_function] = ACTIONS(2914),
    [anon_sym_LT_DASH] = ACTIONS(2914),
    [anon_sym_DOT_LBRACK] = ACTIONS(2916),
    [anon_sym_LT] = ACTIONS(2916),
    [anon_sym_use] = ACTIONS(2914),
    [anon_sym_use_BANG] = ACTIONS(2916),
    [anon_sym_do_BANG] = ACTIONS(2916),
    [anon_sym_begin] = ACTIONS(2914),
    [anon_sym_LPAREN2] = ACTIONS(2914),
    [anon_sym_or] = ACTIONS(2914),
    [aux_sym_char_token1] = ACTIONS(2916),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2914),
    [anon_sym_DQUOTE] = ACTIONS(2914),
    [anon_sym_AT_DQUOTE] = ACTIONS(2916),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2916),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2916),
    [sym_bool] = ACTIONS(2914),
    [sym_unit] = ACTIONS(2916),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2914),
    [sym_op_identifier] = ACTIONS(2914),
    [anon_sym_PLUS] = ACTIONS(2914),
    [anon_sym_DASH] = ACTIONS(2914),
    [anon_sym_PLUS_DOT] = ACTIONS(2914),
    [anon_sym_DASH_DOT] = ACTIONS(2914),
    [anon_sym_PERCENT] = ACTIONS(2914),
    [anon_sym_AMP_AMP] = ACTIONS(2914),
    [anon_sym_TILDE] = ACTIONS(2916),
    [aux_sym_prefix_op_token1] = ACTIONS(2914),
    [aux_sym_infix_op_token1] = ACTIONS(2916),
    [aux_sym_infix_op_token2] = ACTIONS(2914),
    [anon_sym_PIPE_PIPE] = ACTIONS(2914),
    [anon_sym_BANG_EQ] = ACTIONS(2914),
    [anon_sym_COLON_EQ] = ACTIONS(2916),
    [anon_sym_DOLLAR] = ACTIONS(2914),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2914),
    [sym_int] = ACTIONS(2914),
    [sym_xint] = ACTIONS(2916),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2916),
    [sym__newline] = ACTIONS(2916),
  },
  [2291] = {
    [sym_block_comment] = STATE(2291),
    [sym_compiler_directive_decl] = STATE(2291),
    [sym_fsi_directive_decl] = STATE(2291),
    [sym_preproc_line] = STATE(2291),
    [sym_identifier] = ACTIONS(3131),
    [anon_sym_EQ] = ACTIONS(3133),
    [anon_sym_COLON] = ACTIONS(3131),
    [anon_sym_return] = ACTIONS(3131),
    [anon_sym_do] = ACTIONS(3131),
    [anon_sym_let] = ACTIONS(3131),
    [anon_sym_let_BANG] = ACTIONS(3133),
    [anon_sym_LPAREN] = ACTIONS(3131),
    [anon_sym_COMMA] = ACTIONS(3133),
    [anon_sym_null] = ACTIONS(3131),
    [anon_sym_QMARK] = ACTIONS(3131),
    [anon_sym_COLON_QMARK] = ACTIONS(3131),
    [anon_sym_COLON_COLON] = ACTIONS(3133),
    [anon_sym_AMP] = ACTIONS(3131),
    [anon_sym_LBRACK] = ACTIONS(3131),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3133),
    [anon_sym_LBRACE] = ACTIONS(3131),
    [anon_sym_LT_AT] = ACTIONS(3131),
    [anon_sym_LT_AT_AT] = ACTIONS(3131),
    [anon_sym_AT_AT_GT] = ACTIONS(3131),
    [anon_sym_DOT] = ACTIONS(3131),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3133),
    [anon_sym_new] = ACTIONS(3131),
    [anon_sym_return_BANG] = ACTIONS(3133),
    [anon_sym_yield] = ACTIONS(3131),
    [anon_sym_yield_BANG] = ACTIONS(3133),
    [anon_sym_lazy] = ACTIONS(3131),
    [anon_sym_assert] = ACTIONS(3131),
    [anon_sym_upcast] = ACTIONS(3131),
    [anon_sym_downcast] = ACTIONS(3131),
    [anon_sym_COLON_GT] = ACTIONS(3133),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3133),
    [anon_sym_for] = ACTIONS(3131),
    [anon_sym_while] = ACTIONS(3131),
    [anon_sym_if] = ACTIONS(3131),
    [anon_sym_fun] = ACTIONS(3131),
    [anon_sym_try] = ACTIONS(3131),
    [anon_sym_match] = ACTIONS(3131),
    [anon_sym_match_BANG] = ACTIONS(3133),
    [anon_sym_function] = ACTIONS(3131),
    [anon_sym_LT_DASH] = ACTIONS(3131),
    [anon_sym_DOT_LBRACK] = ACTIONS(3133),
    [anon_sym_LT] = ACTIONS(3133),
    [anon_sym_use] = ACTIONS(3131),
    [anon_sym_use_BANG] = ACTIONS(3133),
    [anon_sym_do_BANG] = ACTIONS(3133),
    [anon_sym_begin] = ACTIONS(3131),
    [anon_sym_LPAREN2] = ACTIONS(3131),
    [anon_sym_or] = ACTIONS(3131),
    [aux_sym_char_token1] = ACTIONS(3133),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3131),
    [anon_sym_DQUOTE] = ACTIONS(3131),
    [anon_sym_AT_DQUOTE] = ACTIONS(3133),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3133),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3133),
    [sym_bool] = ACTIONS(3131),
    [sym_unit] = ACTIONS(3133),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3131),
    [sym_op_identifier] = ACTIONS(3131),
    [anon_sym_PLUS] = ACTIONS(3131),
    [anon_sym_DASH] = ACTIONS(3131),
    [anon_sym_PLUS_DOT] = ACTIONS(3131),
    [anon_sym_DASH_DOT] = ACTIONS(3131),
    [anon_sym_PERCENT] = ACTIONS(3131),
    [anon_sym_AMP_AMP] = ACTIONS(3131),
    [anon_sym_TILDE] = ACTIONS(3133),
    [aux_sym_prefix_op_token1] = ACTIONS(3131),
    [aux_sym_infix_op_token1] = ACTIONS(3133),
    [aux_sym_infix_op_token2] = ACTIONS(3131),
    [anon_sym_PIPE_PIPE] = ACTIONS(3131),
    [anon_sym_BANG_EQ] = ACTIONS(3131),
    [anon_sym_COLON_EQ] = ACTIONS(3133),
    [anon_sym_DOLLAR] = ACTIONS(3131),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3131),
    [sym_int] = ACTIONS(3131),
    [sym_xint] = ACTIONS(3133),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3133),
    [sym__newline] = ACTIONS(3133),
  },
  [2292] = {
    [sym_block_comment] = STATE(2292),
    [sym_compiler_directive_decl] = STATE(2292),
    [sym_fsi_directive_decl] = STATE(2292),
    [sym_preproc_line] = STATE(2292),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_EQ] = ACTIONS(3017),
    [anon_sym_COLON] = ACTIONS(3015),
    [anon_sym_return] = ACTIONS(3015),
    [anon_sym_do] = ACTIONS(3015),
    [anon_sym_let] = ACTIONS(3015),
    [anon_sym_let_BANG] = ACTIONS(3017),
    [anon_sym_LPAREN] = ACTIONS(3015),
    [anon_sym_COMMA] = ACTIONS(3017),
    [anon_sym_null] = ACTIONS(3015),
    [anon_sym_QMARK] = ACTIONS(3015),
    [anon_sym_COLON_QMARK] = ACTIONS(3015),
    [anon_sym_COLON_COLON] = ACTIONS(3017),
    [anon_sym_AMP] = ACTIONS(3015),
    [anon_sym_LBRACK] = ACTIONS(3015),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3017),
    [anon_sym_LBRACE] = ACTIONS(3015),
    [anon_sym_LT_AT] = ACTIONS(3015),
    [anon_sym_AT_GT] = ACTIONS(3015),
    [anon_sym_LT_AT_AT] = ACTIONS(3015),
    [anon_sym_DOT] = ACTIONS(3015),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3017),
    [anon_sym_new] = ACTIONS(3015),
    [anon_sym_return_BANG] = ACTIONS(3017),
    [anon_sym_yield] = ACTIONS(3015),
    [anon_sym_yield_BANG] = ACTIONS(3017),
    [anon_sym_lazy] = ACTIONS(3015),
    [anon_sym_assert] = ACTIONS(3015),
    [anon_sym_upcast] = ACTIONS(3015),
    [anon_sym_downcast] = ACTIONS(3015),
    [anon_sym_COLON_GT] = ACTIONS(3017),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3017),
    [anon_sym_for] = ACTIONS(3015),
    [anon_sym_while] = ACTIONS(3015),
    [anon_sym_if] = ACTIONS(3015),
    [anon_sym_fun] = ACTIONS(3015),
    [anon_sym_try] = ACTIONS(3015),
    [anon_sym_match] = ACTIONS(3015),
    [anon_sym_match_BANG] = ACTIONS(3017),
    [anon_sym_function] = ACTIONS(3015),
    [anon_sym_LT_DASH] = ACTIONS(3015),
    [anon_sym_DOT_LBRACK] = ACTIONS(3017),
    [anon_sym_LT] = ACTIONS(3017),
    [anon_sym_use] = ACTIONS(3015),
    [anon_sym_use_BANG] = ACTIONS(3017),
    [anon_sym_do_BANG] = ACTIONS(3017),
    [anon_sym_begin] = ACTIONS(3015),
    [anon_sym_LPAREN2] = ACTIONS(3015),
    [anon_sym_or] = ACTIONS(3015),
    [aux_sym_char_token1] = ACTIONS(3017),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3015),
    [anon_sym_DQUOTE] = ACTIONS(3015),
    [anon_sym_AT_DQUOTE] = ACTIONS(3017),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3017),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3017),
    [sym_bool] = ACTIONS(3015),
    [sym_unit] = ACTIONS(3017),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3015),
    [sym_op_identifier] = ACTIONS(3015),
    [anon_sym_PLUS] = ACTIONS(3015),
    [anon_sym_DASH] = ACTIONS(3015),
    [anon_sym_PLUS_DOT] = ACTIONS(3015),
    [anon_sym_DASH_DOT] = ACTIONS(3015),
    [anon_sym_PERCENT] = ACTIONS(3015),
    [anon_sym_AMP_AMP] = ACTIONS(3015),
    [anon_sym_TILDE] = ACTIONS(3017),
    [aux_sym_prefix_op_token1] = ACTIONS(3015),
    [aux_sym_infix_op_token1] = ACTIONS(3017),
    [aux_sym_infix_op_token2] = ACTIONS(3015),
    [anon_sym_PIPE_PIPE] = ACTIONS(3015),
    [anon_sym_BANG_EQ] = ACTIONS(3015),
    [anon_sym_COLON_EQ] = ACTIONS(3017),
    [anon_sym_DOLLAR] = ACTIONS(3015),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3015),
    [sym_int] = ACTIONS(3015),
    [sym_xint] = ACTIONS(3017),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3017),
    [sym__newline] = ACTIONS(3017),
  },
  [2293] = {
    [sym_block_comment] = STATE(2293),
    [sym_compiler_directive_decl] = STATE(2293),
    [sym_fsi_directive_decl] = STATE(2293),
    [sym_preproc_line] = STATE(2293),
    [sym_identifier] = ACTIONS(2910),
    [anon_sym_EQ] = ACTIONS(2912),
    [anon_sym_COLON] = ACTIONS(2910),
    [anon_sym_return] = ACTIONS(2910),
    [anon_sym_do] = ACTIONS(2910),
    [anon_sym_let] = ACTIONS(2910),
    [anon_sym_let_BANG] = ACTIONS(2912),
    [anon_sym_LPAREN] = ACTIONS(2910),
    [anon_sym_COMMA] = ACTIONS(2912),
    [anon_sym_null] = ACTIONS(2910),
    [anon_sym_QMARK] = ACTIONS(2910),
    [anon_sym_COLON_QMARK] = ACTIONS(2910),
    [anon_sym_COLON_COLON] = ACTIONS(2912),
    [anon_sym_AMP] = ACTIONS(2910),
    [anon_sym_LBRACK] = ACTIONS(2910),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2912),
    [anon_sym_LBRACE] = ACTIONS(2910),
    [anon_sym_LT_AT] = ACTIONS(2910),
    [anon_sym_AT_GT] = ACTIONS(2910),
    [anon_sym_LT_AT_AT] = ACTIONS(2910),
    [anon_sym_DOT] = ACTIONS(2910),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2912),
    [anon_sym_new] = ACTIONS(2910),
    [anon_sym_return_BANG] = ACTIONS(2912),
    [anon_sym_yield] = ACTIONS(2910),
    [anon_sym_yield_BANG] = ACTIONS(2912),
    [anon_sym_lazy] = ACTIONS(2910),
    [anon_sym_assert] = ACTIONS(2910),
    [anon_sym_upcast] = ACTIONS(2910),
    [anon_sym_downcast] = ACTIONS(2910),
    [anon_sym_COLON_GT] = ACTIONS(2912),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2912),
    [anon_sym_for] = ACTIONS(2910),
    [anon_sym_while] = ACTIONS(2910),
    [anon_sym_if] = ACTIONS(2910),
    [anon_sym_fun] = ACTIONS(2910),
    [anon_sym_try] = ACTIONS(2910),
    [anon_sym_match] = ACTIONS(2910),
    [anon_sym_match_BANG] = ACTIONS(2912),
    [anon_sym_function] = ACTIONS(2910),
    [anon_sym_LT_DASH] = ACTIONS(2910),
    [anon_sym_DOT_LBRACK] = ACTIONS(2912),
    [anon_sym_LT] = ACTIONS(2912),
    [anon_sym_use] = ACTIONS(2910),
    [anon_sym_use_BANG] = ACTIONS(2912),
    [anon_sym_do_BANG] = ACTIONS(2912),
    [anon_sym_begin] = ACTIONS(2910),
    [anon_sym_LPAREN2] = ACTIONS(2910),
    [anon_sym_or] = ACTIONS(2910),
    [aux_sym_char_token1] = ACTIONS(2912),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2910),
    [anon_sym_DQUOTE] = ACTIONS(2910),
    [anon_sym_AT_DQUOTE] = ACTIONS(2912),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2912),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2912),
    [sym_bool] = ACTIONS(2910),
    [sym_unit] = ACTIONS(2912),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2910),
    [sym_op_identifier] = ACTIONS(2910),
    [anon_sym_PLUS] = ACTIONS(2910),
    [anon_sym_DASH] = ACTIONS(2910),
    [anon_sym_PLUS_DOT] = ACTIONS(2910),
    [anon_sym_DASH_DOT] = ACTIONS(2910),
    [anon_sym_PERCENT] = ACTIONS(2910),
    [anon_sym_AMP_AMP] = ACTIONS(2910),
    [anon_sym_TILDE] = ACTIONS(2912),
    [aux_sym_prefix_op_token1] = ACTIONS(2910),
    [aux_sym_infix_op_token1] = ACTIONS(2912),
    [aux_sym_infix_op_token2] = ACTIONS(2910),
    [anon_sym_PIPE_PIPE] = ACTIONS(2910),
    [anon_sym_BANG_EQ] = ACTIONS(2910),
    [anon_sym_COLON_EQ] = ACTIONS(2912),
    [anon_sym_DOLLAR] = ACTIONS(2910),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2910),
    [sym_int] = ACTIONS(2910),
    [sym_xint] = ACTIONS(2912),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2912),
    [sym__newline] = ACTIONS(2912),
  },
  [2294] = {
    [sym_block_comment] = STATE(2294),
    [sym_compiler_directive_decl] = STATE(2294),
    [sym_fsi_directive_decl] = STATE(2294),
    [sym_preproc_line] = STATE(2294),
    [sym_identifier] = ACTIONS(2891),
    [anon_sym_EQ] = ACTIONS(2893),
    [anon_sym_COLON] = ACTIONS(2891),
    [anon_sym_return] = ACTIONS(2891),
    [anon_sym_do] = ACTIONS(2891),
    [anon_sym_let] = ACTIONS(2891),
    [anon_sym_let_BANG] = ACTIONS(2893),
    [anon_sym_LPAREN] = ACTIONS(2891),
    [anon_sym_COMMA] = ACTIONS(2893),
    [anon_sym_null] = ACTIONS(2891),
    [anon_sym_QMARK] = ACTIONS(2891),
    [anon_sym_COLON_QMARK] = ACTIONS(2891),
    [anon_sym_COLON_COLON] = ACTIONS(2893),
    [anon_sym_AMP] = ACTIONS(2891),
    [anon_sym_LBRACK] = ACTIONS(2891),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2893),
    [anon_sym_LBRACE] = ACTIONS(2891),
    [anon_sym_LT_AT] = ACTIONS(2891),
    [anon_sym_AT_GT] = ACTIONS(2891),
    [anon_sym_LT_AT_AT] = ACTIONS(2891),
    [anon_sym_DOT] = ACTIONS(2891),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2893),
    [anon_sym_new] = ACTIONS(2891),
    [anon_sym_return_BANG] = ACTIONS(2893),
    [anon_sym_yield] = ACTIONS(2891),
    [anon_sym_yield_BANG] = ACTIONS(2893),
    [anon_sym_lazy] = ACTIONS(2891),
    [anon_sym_assert] = ACTIONS(2891),
    [anon_sym_upcast] = ACTIONS(2891),
    [anon_sym_downcast] = ACTIONS(2891),
    [anon_sym_COLON_GT] = ACTIONS(2893),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2893),
    [anon_sym_for] = ACTIONS(2891),
    [anon_sym_while] = ACTIONS(2891),
    [anon_sym_if] = ACTIONS(2891),
    [anon_sym_fun] = ACTIONS(2891),
    [anon_sym_try] = ACTIONS(2891),
    [anon_sym_match] = ACTIONS(2891),
    [anon_sym_match_BANG] = ACTIONS(2893),
    [anon_sym_function] = ACTIONS(2891),
    [anon_sym_LT_DASH] = ACTIONS(2891),
    [anon_sym_DOT_LBRACK] = ACTIONS(2893),
    [anon_sym_LT] = ACTIONS(2893),
    [anon_sym_use] = ACTIONS(2891),
    [anon_sym_use_BANG] = ACTIONS(2893),
    [anon_sym_do_BANG] = ACTIONS(2893),
    [anon_sym_begin] = ACTIONS(2891),
    [anon_sym_LPAREN2] = ACTIONS(2891),
    [anon_sym_or] = ACTIONS(2891),
    [aux_sym_char_token1] = ACTIONS(2893),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2891),
    [anon_sym_DQUOTE] = ACTIONS(2891),
    [anon_sym_AT_DQUOTE] = ACTIONS(2893),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2893),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2893),
    [sym_bool] = ACTIONS(2891),
    [sym_unit] = ACTIONS(2893),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2891),
    [sym_op_identifier] = ACTIONS(2891),
    [anon_sym_PLUS] = ACTIONS(2891),
    [anon_sym_DASH] = ACTIONS(2891),
    [anon_sym_PLUS_DOT] = ACTIONS(2891),
    [anon_sym_DASH_DOT] = ACTIONS(2891),
    [anon_sym_PERCENT] = ACTIONS(2891),
    [anon_sym_AMP_AMP] = ACTIONS(2891),
    [anon_sym_TILDE] = ACTIONS(2893),
    [aux_sym_prefix_op_token1] = ACTIONS(2891),
    [aux_sym_infix_op_token1] = ACTIONS(2893),
    [aux_sym_infix_op_token2] = ACTIONS(2891),
    [anon_sym_PIPE_PIPE] = ACTIONS(2891),
    [anon_sym_BANG_EQ] = ACTIONS(2891),
    [anon_sym_COLON_EQ] = ACTIONS(2893),
    [anon_sym_DOLLAR] = ACTIONS(2891),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2891),
    [sym_int] = ACTIONS(2891),
    [sym_xint] = ACTIONS(2893),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2893),
    [sym__newline] = ACTIONS(2893),
  },
  [2295] = {
    [sym_attributes] = STATE(2676),
    [sym__attribute_set] = STATE(4045),
    [sym__function_or_value_defns] = STATE(4902),
    [sym__function_or_value_defn_body] = STATE(4617),
    [sym_function_declaration_left] = STATE(6321),
    [sym_value_declaration_left] = STATE(6321),
    [sym_access_modifier] = STATE(2693),
    [sym_repeat_pattern] = STATE(4815),
    [sym__pattern] = STATE(5168),
    [sym_optional_pattern] = STATE(4815),
    [sym_type_check_pattern] = STATE(4815),
    [sym_attribute_pattern] = STATE(4815),
    [sym_paren_pattern] = STATE(4815),
    [sym_as_pattern] = STATE(4815),
    [sym_cons_pattern] = STATE(4815),
    [sym_disjunct_pattern] = STATE(4815),
    [sym_conjunct_pattern] = STATE(4815),
    [sym_typed_pattern] = STATE(4815),
    [sym_list_pattern] = STATE(4815),
    [sym_array_pattern] = STATE(4815),
    [sym_record_pattern] = STATE(4815),
    [sym_named_field_pattern] = STATE(4815),
    [sym_identifier_pattern] = STATE(4815),
    [sym_long_identifier_or_op] = STATE(1792),
    [sym_char] = STATE(4765),
    [sym_format_string] = STATE(4746),
    [sym__string_literal] = STATE(4746),
    [sym_string] = STATE(4765),
    [sym_verbatim_string] = STATE(4765),
    [sym_bytearray] = STATE(4765),
    [sym_verbatim_bytearray] = STATE(4765),
    [sym_format_triple_quoted_string] = STATE(4720),
    [sym_triple_quoted_string] = STATE(4765),
    [sym_const] = STATE(4815),
    [sym_long_identifier] = STATE(3320),
    [sym_active_pattern] = STATE(3488),
    [sym__identifier_or_op] = STATE(2746),
    [sym_sbyte] = STATE(4765),
    [sym_byte] = STATE(4765),
    [sym_int16] = STATE(4765),
    [sym_uint16] = STATE(4765),
    [sym_int32] = STATE(4765),
    [sym_uint32] = STATE(4765),
    [sym_nativeint] = STATE(4765),
    [sym_unativeint] = STATE(4765),
    [sym_int64] = STATE(4765),
    [sym_uint64] = STATE(4765),
    [sym_ieee32] = STATE(4765),
    [sym_ieee64] = STATE(4765),
    [sym_bignum] = STATE(4765),
    [sym_decimal] = STATE(4765),
    [sym_float] = STATE(4512),
    [sym_block_comment] = STATE(2295),
    [sym_compiler_directive_decl] = STATE(2295),
    [sym_fsi_directive_decl] = STATE(2295),
    [sym_preproc_line] = STATE(2295),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(3562),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_inline] = ACTIONS(3566),
    [anon_sym_mutable] = ACTIONS(3568),
    [aux_sym_access_modifier_token1] = ACTIONS(3570),
    [anon_sym_LPAREN] = ACTIONS(3572),
    [anon_sym_null] = ACTIONS(3574),
    [anon_sym__] = ACTIONS(3576),
    [anon_sym_QMARK] = ACTIONS(3578),
    [anon_sym_COLON_QMARK] = ACTIONS(3580),
    [anon_sym_LBRACK] = ACTIONS(3582),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3584),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [aux_sym_char_token1] = ACTIONS(3590),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3592),
    [anon_sym_DQUOTE] = ACTIONS(3594),
    [anon_sym_AT_DQUOTE] = ACTIONS(3596),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3598),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3600),
    [sym_bool] = ACTIONS(3602),
    [sym_unit] = ACTIONS(3604),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3606),
    [sym_op_identifier] = ACTIONS(3608),
    [sym_int] = ACTIONS(3610),
    [sym_xint] = ACTIONS(3612),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2296] = {
    [sym_block_comment] = STATE(2296),
    [sym_compiler_directive_decl] = STATE(2296),
    [sym_fsi_directive_decl] = STATE(2296),
    [sym_preproc_line] = STATE(2296),
    [sym_identifier] = ACTIONS(3139),
    [anon_sym_EQ] = ACTIONS(3141),
    [anon_sym_COLON] = ACTIONS(3139),
    [anon_sym_return] = ACTIONS(3139),
    [anon_sym_do] = ACTIONS(3139),
    [anon_sym_let] = ACTIONS(3139),
    [anon_sym_let_BANG] = ACTIONS(3141),
    [anon_sym_LPAREN] = ACTIONS(3139),
    [anon_sym_COMMA] = ACTIONS(3141),
    [anon_sym_null] = ACTIONS(3139),
    [anon_sym_QMARK] = ACTIONS(3139),
    [anon_sym_COLON_QMARK] = ACTIONS(3139),
    [anon_sym_COLON_COLON] = ACTIONS(3141),
    [anon_sym_AMP] = ACTIONS(3139),
    [anon_sym_LBRACK] = ACTIONS(3139),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3141),
    [anon_sym_LBRACE] = ACTIONS(3139),
    [anon_sym_LT_AT] = ACTIONS(3139),
    [anon_sym_LT_AT_AT] = ACTIONS(3139),
    [anon_sym_AT_AT_GT] = ACTIONS(3139),
    [anon_sym_DOT] = ACTIONS(3139),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3141),
    [anon_sym_new] = ACTIONS(3139),
    [anon_sym_return_BANG] = ACTIONS(3141),
    [anon_sym_yield] = ACTIONS(3139),
    [anon_sym_yield_BANG] = ACTIONS(3141),
    [anon_sym_lazy] = ACTIONS(3139),
    [anon_sym_assert] = ACTIONS(3139),
    [anon_sym_upcast] = ACTIONS(3139),
    [anon_sym_downcast] = ACTIONS(3139),
    [anon_sym_COLON_GT] = ACTIONS(3141),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3141),
    [anon_sym_for] = ACTIONS(3139),
    [anon_sym_while] = ACTIONS(3139),
    [anon_sym_if] = ACTIONS(3139),
    [anon_sym_fun] = ACTIONS(3139),
    [anon_sym_try] = ACTIONS(3139),
    [anon_sym_match] = ACTIONS(3139),
    [anon_sym_match_BANG] = ACTIONS(3141),
    [anon_sym_function] = ACTIONS(3139),
    [anon_sym_LT_DASH] = ACTIONS(3139),
    [anon_sym_DOT_LBRACK] = ACTIONS(3141),
    [anon_sym_LT] = ACTIONS(3141),
    [anon_sym_use] = ACTIONS(3139),
    [anon_sym_use_BANG] = ACTIONS(3141),
    [anon_sym_do_BANG] = ACTIONS(3141),
    [anon_sym_begin] = ACTIONS(3139),
    [anon_sym_LPAREN2] = ACTIONS(3139),
    [anon_sym_or] = ACTIONS(3139),
    [aux_sym_char_token1] = ACTIONS(3141),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3139),
    [anon_sym_DQUOTE] = ACTIONS(3139),
    [anon_sym_AT_DQUOTE] = ACTIONS(3141),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3141),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3141),
    [sym_bool] = ACTIONS(3139),
    [sym_unit] = ACTIONS(3141),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3139),
    [sym_op_identifier] = ACTIONS(3139),
    [anon_sym_PLUS] = ACTIONS(3139),
    [anon_sym_DASH] = ACTIONS(3139),
    [anon_sym_PLUS_DOT] = ACTIONS(3139),
    [anon_sym_DASH_DOT] = ACTIONS(3139),
    [anon_sym_PERCENT] = ACTIONS(3139),
    [anon_sym_AMP_AMP] = ACTIONS(3139),
    [anon_sym_TILDE] = ACTIONS(3141),
    [aux_sym_prefix_op_token1] = ACTIONS(3139),
    [aux_sym_infix_op_token1] = ACTIONS(3141),
    [aux_sym_infix_op_token2] = ACTIONS(3139),
    [anon_sym_PIPE_PIPE] = ACTIONS(3139),
    [anon_sym_BANG_EQ] = ACTIONS(3139),
    [anon_sym_COLON_EQ] = ACTIONS(3141),
    [anon_sym_DOLLAR] = ACTIONS(3139),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3139),
    [sym_int] = ACTIONS(3139),
    [sym_xint] = ACTIONS(3141),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3141),
    [sym__newline] = ACTIONS(3141),
  },
  [2297] = {
    [sym_attributes] = STATE(2676),
    [sym__attribute_set] = STATE(4045),
    [sym__function_or_value_defn_body] = STATE(4861),
    [sym_function_declaration_left] = STATE(6355),
    [sym_value_declaration_left] = STATE(6355),
    [sym_access_modifier] = STATE(2693),
    [sym_repeat_pattern] = STATE(4815),
    [sym__pattern] = STATE(5168),
    [sym_optional_pattern] = STATE(4815),
    [sym_type_check_pattern] = STATE(4815),
    [sym_attribute_pattern] = STATE(4815),
    [sym_paren_pattern] = STATE(4815),
    [sym_as_pattern] = STATE(4815),
    [sym_cons_pattern] = STATE(4815),
    [sym_disjunct_pattern] = STATE(4815),
    [sym_conjunct_pattern] = STATE(4815),
    [sym_typed_pattern] = STATE(4815),
    [sym_list_pattern] = STATE(4815),
    [sym_array_pattern] = STATE(4815),
    [sym_record_pattern] = STATE(4815),
    [sym_named_field_pattern] = STATE(4815),
    [sym_identifier_pattern] = STATE(4815),
    [sym_long_identifier_or_op] = STATE(1792),
    [sym_char] = STATE(4765),
    [sym_format_string] = STATE(4746),
    [sym__string_literal] = STATE(4746),
    [sym_string] = STATE(4765),
    [sym_verbatim_string] = STATE(4765),
    [sym_bytearray] = STATE(4765),
    [sym_verbatim_bytearray] = STATE(4765),
    [sym_format_triple_quoted_string] = STATE(4720),
    [sym_triple_quoted_string] = STATE(4765),
    [sym_const] = STATE(4815),
    [sym_long_identifier] = STATE(3320),
    [sym_active_pattern] = STATE(3488),
    [sym__identifier_or_op] = STATE(2746),
    [sym_sbyte] = STATE(4765),
    [sym_byte] = STATE(4765),
    [sym_int16] = STATE(4765),
    [sym_uint16] = STATE(4765),
    [sym_int32] = STATE(4765),
    [sym_uint32] = STATE(4765),
    [sym_nativeint] = STATE(4765),
    [sym_unativeint] = STATE(4765),
    [sym_int64] = STATE(4765),
    [sym_uint64] = STATE(4765),
    [sym_ieee32] = STATE(4765),
    [sym_ieee64] = STATE(4765),
    [sym_bignum] = STATE(4765),
    [sym_decimal] = STATE(4765),
    [sym_float] = STATE(4512),
    [sym_block_comment] = STATE(2297),
    [sym_compiler_directive_decl] = STATE(2297),
    [sym_fsi_directive_decl] = STATE(2297),
    [sym_preproc_line] = STATE(2297),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(3562),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_rec] = ACTIONS(4300),
    [anon_sym_inline] = ACTIONS(3566),
    [anon_sym_mutable] = ACTIONS(3568),
    [aux_sym_access_modifier_token1] = ACTIONS(3570),
    [anon_sym_LPAREN] = ACTIONS(3572),
    [anon_sym_null] = ACTIONS(3574),
    [anon_sym__] = ACTIONS(3576),
    [anon_sym_QMARK] = ACTIONS(3578),
    [anon_sym_COLON_QMARK] = ACTIONS(3580),
    [anon_sym_LBRACK] = ACTIONS(3582),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3584),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [aux_sym_char_token1] = ACTIONS(3590),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3592),
    [anon_sym_DQUOTE] = ACTIONS(3594),
    [anon_sym_AT_DQUOTE] = ACTIONS(3596),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3598),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3600),
    [sym_bool] = ACTIONS(3602),
    [sym_unit] = ACTIONS(3604),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3606),
    [sym_op_identifier] = ACTIONS(3608),
    [sym_int] = ACTIONS(3610),
    [sym_xint] = ACTIONS(3612),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2298] = {
    [sym_block_comment] = STATE(2298),
    [sym_compiler_directive_decl] = STATE(2298),
    [sym_fsi_directive_decl] = STATE(2298),
    [sym_preproc_line] = STATE(2298),
    [sym_identifier] = ACTIONS(3039),
    [anon_sym_EQ] = ACTIONS(3041),
    [anon_sym_COLON] = ACTIONS(3039),
    [anon_sym_return] = ACTIONS(3039),
    [anon_sym_do] = ACTIONS(3039),
    [anon_sym_let] = ACTIONS(3039),
    [anon_sym_let_BANG] = ACTIONS(3041),
    [anon_sym_LPAREN] = ACTIONS(3039),
    [anon_sym_COMMA] = ACTIONS(3041),
    [anon_sym_null] = ACTIONS(3039),
    [anon_sym_QMARK] = ACTIONS(3039),
    [anon_sym_COLON_QMARK] = ACTIONS(3039),
    [anon_sym_COLON_COLON] = ACTIONS(3041),
    [anon_sym_AMP] = ACTIONS(3039),
    [anon_sym_LBRACK] = ACTIONS(3039),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3041),
    [anon_sym_LBRACE] = ACTIONS(3039),
    [anon_sym_LT_AT] = ACTIONS(3039),
    [anon_sym_AT_GT] = ACTIONS(3039),
    [anon_sym_LT_AT_AT] = ACTIONS(3039),
    [anon_sym_DOT] = ACTIONS(3039),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3041),
    [anon_sym_new] = ACTIONS(3039),
    [anon_sym_return_BANG] = ACTIONS(3041),
    [anon_sym_yield] = ACTIONS(3039),
    [anon_sym_yield_BANG] = ACTIONS(3041),
    [anon_sym_lazy] = ACTIONS(3039),
    [anon_sym_assert] = ACTIONS(3039),
    [anon_sym_upcast] = ACTIONS(3039),
    [anon_sym_downcast] = ACTIONS(3039),
    [anon_sym_COLON_GT] = ACTIONS(3041),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3041),
    [anon_sym_for] = ACTIONS(3039),
    [anon_sym_while] = ACTIONS(3039),
    [anon_sym_if] = ACTIONS(3039),
    [anon_sym_fun] = ACTIONS(3039),
    [anon_sym_try] = ACTIONS(3039),
    [anon_sym_match] = ACTIONS(3039),
    [anon_sym_match_BANG] = ACTIONS(3041),
    [anon_sym_function] = ACTIONS(3039),
    [anon_sym_LT_DASH] = ACTIONS(3039),
    [anon_sym_DOT_LBRACK] = ACTIONS(3041),
    [anon_sym_LT] = ACTIONS(3041),
    [anon_sym_use] = ACTIONS(3039),
    [anon_sym_use_BANG] = ACTIONS(3041),
    [anon_sym_do_BANG] = ACTIONS(3041),
    [anon_sym_begin] = ACTIONS(3039),
    [anon_sym_LPAREN2] = ACTIONS(3039),
    [anon_sym_or] = ACTIONS(3039),
    [aux_sym_char_token1] = ACTIONS(3041),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3039),
    [anon_sym_DQUOTE] = ACTIONS(3039),
    [anon_sym_AT_DQUOTE] = ACTIONS(3041),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3041),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3041),
    [sym_bool] = ACTIONS(3039),
    [sym_unit] = ACTIONS(3041),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3039),
    [sym_op_identifier] = ACTIONS(3039),
    [anon_sym_PLUS] = ACTIONS(3039),
    [anon_sym_DASH] = ACTIONS(3039),
    [anon_sym_PLUS_DOT] = ACTIONS(3039),
    [anon_sym_DASH_DOT] = ACTIONS(3039),
    [anon_sym_PERCENT] = ACTIONS(3039),
    [anon_sym_AMP_AMP] = ACTIONS(3039),
    [anon_sym_TILDE] = ACTIONS(3041),
    [aux_sym_prefix_op_token1] = ACTIONS(3039),
    [aux_sym_infix_op_token1] = ACTIONS(3041),
    [aux_sym_infix_op_token2] = ACTIONS(3039),
    [anon_sym_PIPE_PIPE] = ACTIONS(3039),
    [anon_sym_BANG_EQ] = ACTIONS(3039),
    [anon_sym_COLON_EQ] = ACTIONS(3041),
    [anon_sym_DOLLAR] = ACTIONS(3039),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3039),
    [sym_int] = ACTIONS(3039),
    [sym_xint] = ACTIONS(3041),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3041),
    [sym__newline] = ACTIONS(3041),
  },
  [2299] = {
    [sym_block_comment] = STATE(2299),
    [sym_compiler_directive_decl] = STATE(2299),
    [sym_fsi_directive_decl] = STATE(2299),
    [sym_preproc_line] = STATE(2299),
    [sym_identifier] = ACTIONS(3135),
    [anon_sym_EQ] = ACTIONS(3137),
    [anon_sym_COLON] = ACTIONS(3135),
    [anon_sym_return] = ACTIONS(3135),
    [anon_sym_do] = ACTIONS(3135),
    [anon_sym_let] = ACTIONS(3135),
    [anon_sym_let_BANG] = ACTIONS(3137),
    [anon_sym_LPAREN] = ACTIONS(3135),
    [anon_sym_COMMA] = ACTIONS(3137),
    [anon_sym_null] = ACTIONS(3135),
    [anon_sym_QMARK] = ACTIONS(3135),
    [anon_sym_COLON_QMARK] = ACTIONS(3135),
    [anon_sym_COLON_COLON] = ACTIONS(3137),
    [anon_sym_AMP] = ACTIONS(3135),
    [anon_sym_LBRACK] = ACTIONS(3135),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3137),
    [anon_sym_LBRACE] = ACTIONS(3135),
    [anon_sym_LT_AT] = ACTIONS(3135),
    [anon_sym_LT_AT_AT] = ACTIONS(3135),
    [anon_sym_AT_AT_GT] = ACTIONS(3135),
    [anon_sym_DOT] = ACTIONS(3135),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3137),
    [anon_sym_new] = ACTIONS(3135),
    [anon_sym_return_BANG] = ACTIONS(3137),
    [anon_sym_yield] = ACTIONS(3135),
    [anon_sym_yield_BANG] = ACTIONS(3137),
    [anon_sym_lazy] = ACTIONS(3135),
    [anon_sym_assert] = ACTIONS(3135),
    [anon_sym_upcast] = ACTIONS(3135),
    [anon_sym_downcast] = ACTIONS(3135),
    [anon_sym_COLON_GT] = ACTIONS(3137),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3137),
    [anon_sym_for] = ACTIONS(3135),
    [anon_sym_while] = ACTIONS(3135),
    [anon_sym_if] = ACTIONS(3135),
    [anon_sym_fun] = ACTIONS(3135),
    [anon_sym_try] = ACTIONS(3135),
    [anon_sym_match] = ACTIONS(3135),
    [anon_sym_match_BANG] = ACTIONS(3137),
    [anon_sym_function] = ACTIONS(3135),
    [anon_sym_LT_DASH] = ACTIONS(3135),
    [anon_sym_DOT_LBRACK] = ACTIONS(3137),
    [anon_sym_LT] = ACTIONS(3137),
    [anon_sym_use] = ACTIONS(3135),
    [anon_sym_use_BANG] = ACTIONS(3137),
    [anon_sym_do_BANG] = ACTIONS(3137),
    [anon_sym_begin] = ACTIONS(3135),
    [anon_sym_LPAREN2] = ACTIONS(3135),
    [anon_sym_or] = ACTIONS(3135),
    [aux_sym_char_token1] = ACTIONS(3137),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3135),
    [anon_sym_DQUOTE] = ACTIONS(3135),
    [anon_sym_AT_DQUOTE] = ACTIONS(3137),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3137),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3137),
    [sym_bool] = ACTIONS(3135),
    [sym_unit] = ACTIONS(3137),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3135),
    [sym_op_identifier] = ACTIONS(3135),
    [anon_sym_PLUS] = ACTIONS(3135),
    [anon_sym_DASH] = ACTIONS(3135),
    [anon_sym_PLUS_DOT] = ACTIONS(3135),
    [anon_sym_DASH_DOT] = ACTIONS(3135),
    [anon_sym_PERCENT] = ACTIONS(3135),
    [anon_sym_AMP_AMP] = ACTIONS(3135),
    [anon_sym_TILDE] = ACTIONS(3137),
    [aux_sym_prefix_op_token1] = ACTIONS(3135),
    [aux_sym_infix_op_token1] = ACTIONS(3137),
    [aux_sym_infix_op_token2] = ACTIONS(3135),
    [anon_sym_PIPE_PIPE] = ACTIONS(3135),
    [anon_sym_BANG_EQ] = ACTIONS(3135),
    [anon_sym_COLON_EQ] = ACTIONS(3137),
    [anon_sym_DOLLAR] = ACTIONS(3135),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3135),
    [sym_int] = ACTIONS(3135),
    [sym_xint] = ACTIONS(3137),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3137),
    [sym__newline] = ACTIONS(3137),
  },
  [2300] = {
    [sym_attributes] = STATE(2676),
    [sym__attribute_set] = STATE(4045),
    [sym__function_or_value_defns] = STATE(2836),
    [sym__function_or_value_defn_body] = STATE(2825),
    [sym_function_declaration_left] = STATE(6066),
    [sym_value_declaration_left] = STATE(6066),
    [sym_access_modifier] = STATE(2693),
    [sym_repeat_pattern] = STATE(4815),
    [sym__pattern] = STATE(5168),
    [sym_optional_pattern] = STATE(4815),
    [sym_type_check_pattern] = STATE(4815),
    [sym_attribute_pattern] = STATE(4815),
    [sym_paren_pattern] = STATE(4815),
    [sym_as_pattern] = STATE(4815),
    [sym_cons_pattern] = STATE(4815),
    [sym_disjunct_pattern] = STATE(4815),
    [sym_conjunct_pattern] = STATE(4815),
    [sym_typed_pattern] = STATE(4815),
    [sym_list_pattern] = STATE(4815),
    [sym_array_pattern] = STATE(4815),
    [sym_record_pattern] = STATE(4815),
    [sym_named_field_pattern] = STATE(4815),
    [sym_identifier_pattern] = STATE(4815),
    [sym_long_identifier_or_op] = STATE(1792),
    [sym_char] = STATE(4765),
    [sym_format_string] = STATE(4746),
    [sym__string_literal] = STATE(4746),
    [sym_string] = STATE(4765),
    [sym_verbatim_string] = STATE(4765),
    [sym_bytearray] = STATE(4765),
    [sym_verbatim_bytearray] = STATE(4765),
    [sym_format_triple_quoted_string] = STATE(4720),
    [sym_triple_quoted_string] = STATE(4765),
    [sym_const] = STATE(4815),
    [sym_long_identifier] = STATE(3320),
    [sym_active_pattern] = STATE(3488),
    [sym__identifier_or_op] = STATE(2746),
    [sym_sbyte] = STATE(4765),
    [sym_byte] = STATE(4765),
    [sym_int16] = STATE(4765),
    [sym_uint16] = STATE(4765),
    [sym_int32] = STATE(4765),
    [sym_uint32] = STATE(4765),
    [sym_nativeint] = STATE(4765),
    [sym_unativeint] = STATE(4765),
    [sym_int64] = STATE(4765),
    [sym_uint64] = STATE(4765),
    [sym_ieee32] = STATE(4765),
    [sym_ieee64] = STATE(4765),
    [sym_bignum] = STATE(4765),
    [sym_decimal] = STATE(4765),
    [sym_float] = STATE(4512),
    [sym_block_comment] = STATE(2300),
    [sym_compiler_directive_decl] = STATE(2300),
    [sym_fsi_directive_decl] = STATE(2300),
    [sym_preproc_line] = STATE(2300),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(3562),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_inline] = ACTIONS(3566),
    [anon_sym_mutable] = ACTIONS(3568),
    [aux_sym_access_modifier_token1] = ACTIONS(3570),
    [anon_sym_LPAREN] = ACTIONS(3572),
    [anon_sym_null] = ACTIONS(3574),
    [anon_sym__] = ACTIONS(3576),
    [anon_sym_QMARK] = ACTIONS(3578),
    [anon_sym_COLON_QMARK] = ACTIONS(3580),
    [anon_sym_LBRACK] = ACTIONS(3582),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3584),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [aux_sym_char_token1] = ACTIONS(3590),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3592),
    [anon_sym_DQUOTE] = ACTIONS(3594),
    [anon_sym_AT_DQUOTE] = ACTIONS(3596),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3598),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3600),
    [sym_bool] = ACTIONS(3602),
    [sym_unit] = ACTIONS(3604),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3606),
    [sym_op_identifier] = ACTIONS(3608),
    [sym_int] = ACTIONS(3610),
    [sym_xint] = ACTIONS(3612),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2301] = {
    [sym_block_comment] = STATE(2301),
    [sym_compiler_directive_decl] = STATE(2301),
    [sym_fsi_directive_decl] = STATE(2301),
    [sym_preproc_line] = STATE(2301),
    [sym_identifier] = ACTIONS(3043),
    [anon_sym_EQ] = ACTIONS(3045),
    [anon_sym_COLON] = ACTIONS(3043),
    [anon_sym_return] = ACTIONS(3043),
    [anon_sym_do] = ACTIONS(3043),
    [anon_sym_let] = ACTIONS(3043),
    [anon_sym_let_BANG] = ACTIONS(3045),
    [anon_sym_LPAREN] = ACTIONS(3043),
    [anon_sym_COMMA] = ACTIONS(3045),
    [anon_sym_null] = ACTIONS(3043),
    [anon_sym_QMARK] = ACTIONS(3043),
    [anon_sym_COLON_QMARK] = ACTIONS(3043),
    [anon_sym_COLON_COLON] = ACTIONS(3045),
    [anon_sym_AMP] = ACTIONS(3043),
    [anon_sym_LBRACK] = ACTIONS(3043),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3045),
    [anon_sym_LBRACE] = ACTIONS(3043),
    [anon_sym_LT_AT] = ACTIONS(3043),
    [anon_sym_AT_GT] = ACTIONS(3043),
    [anon_sym_LT_AT_AT] = ACTIONS(3043),
    [anon_sym_DOT] = ACTIONS(3043),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3045),
    [anon_sym_new] = ACTIONS(3043),
    [anon_sym_return_BANG] = ACTIONS(3045),
    [anon_sym_yield] = ACTIONS(3043),
    [anon_sym_yield_BANG] = ACTIONS(3045),
    [anon_sym_lazy] = ACTIONS(3043),
    [anon_sym_assert] = ACTIONS(3043),
    [anon_sym_upcast] = ACTIONS(3043),
    [anon_sym_downcast] = ACTIONS(3043),
    [anon_sym_COLON_GT] = ACTIONS(3045),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3045),
    [anon_sym_for] = ACTIONS(3043),
    [anon_sym_while] = ACTIONS(3043),
    [anon_sym_if] = ACTIONS(3043),
    [anon_sym_fun] = ACTIONS(3043),
    [anon_sym_try] = ACTIONS(3043),
    [anon_sym_match] = ACTIONS(3043),
    [anon_sym_match_BANG] = ACTIONS(3045),
    [anon_sym_function] = ACTIONS(3043),
    [anon_sym_LT_DASH] = ACTIONS(3043),
    [anon_sym_DOT_LBRACK] = ACTIONS(3045),
    [anon_sym_LT] = ACTIONS(3045),
    [anon_sym_use] = ACTIONS(3043),
    [anon_sym_use_BANG] = ACTIONS(3045),
    [anon_sym_do_BANG] = ACTIONS(3045),
    [anon_sym_begin] = ACTIONS(3043),
    [anon_sym_LPAREN2] = ACTIONS(3043),
    [anon_sym_or] = ACTIONS(3043),
    [aux_sym_char_token1] = ACTIONS(3045),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3043),
    [anon_sym_DQUOTE] = ACTIONS(3043),
    [anon_sym_AT_DQUOTE] = ACTIONS(3045),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3045),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3045),
    [sym_bool] = ACTIONS(3043),
    [sym_unit] = ACTIONS(3045),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3043),
    [sym_op_identifier] = ACTIONS(3043),
    [anon_sym_PLUS] = ACTIONS(3043),
    [anon_sym_DASH] = ACTIONS(3043),
    [anon_sym_PLUS_DOT] = ACTIONS(3043),
    [anon_sym_DASH_DOT] = ACTIONS(3043),
    [anon_sym_PERCENT] = ACTIONS(3043),
    [anon_sym_AMP_AMP] = ACTIONS(3043),
    [anon_sym_TILDE] = ACTIONS(3045),
    [aux_sym_prefix_op_token1] = ACTIONS(3043),
    [aux_sym_infix_op_token1] = ACTIONS(3045),
    [aux_sym_infix_op_token2] = ACTIONS(3043),
    [anon_sym_PIPE_PIPE] = ACTIONS(3043),
    [anon_sym_BANG_EQ] = ACTIONS(3043),
    [anon_sym_COLON_EQ] = ACTIONS(3045),
    [anon_sym_DOLLAR] = ACTIONS(3043),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3043),
    [sym_int] = ACTIONS(3043),
    [sym_xint] = ACTIONS(3045),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3045),
    [sym__newline] = ACTIONS(3045),
  },
  [2302] = {
    [sym_block_comment] = STATE(2302),
    [sym_compiler_directive_decl] = STATE(2302),
    [sym_fsi_directive_decl] = STATE(2302),
    [sym_preproc_line] = STATE(2302),
    [sym_identifier] = ACTIONS(2883),
    [anon_sym_EQ] = ACTIONS(2885),
    [anon_sym_COLON] = ACTIONS(2883),
    [anon_sym_return] = ACTIONS(2883),
    [anon_sym_do] = ACTIONS(2883),
    [anon_sym_let] = ACTIONS(2883),
    [anon_sym_let_BANG] = ACTIONS(2885),
    [anon_sym_LPAREN] = ACTIONS(2883),
    [anon_sym_COMMA] = ACTIONS(2885),
    [anon_sym_null] = ACTIONS(2883),
    [anon_sym_QMARK] = ACTIONS(2883),
    [anon_sym_COLON_QMARK] = ACTIONS(2883),
    [anon_sym_COLON_COLON] = ACTIONS(2885),
    [anon_sym_AMP] = ACTIONS(2883),
    [anon_sym_LBRACK] = ACTIONS(2883),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2885),
    [anon_sym_LBRACE] = ACTIONS(2883),
    [anon_sym_LT_AT] = ACTIONS(2883),
    [anon_sym_AT_GT] = ACTIONS(2883),
    [anon_sym_LT_AT_AT] = ACTIONS(2883),
    [anon_sym_DOT] = ACTIONS(2883),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2885),
    [anon_sym_new] = ACTIONS(2883),
    [anon_sym_return_BANG] = ACTIONS(2885),
    [anon_sym_yield] = ACTIONS(2883),
    [anon_sym_yield_BANG] = ACTIONS(2885),
    [anon_sym_lazy] = ACTIONS(2883),
    [anon_sym_assert] = ACTIONS(2883),
    [anon_sym_upcast] = ACTIONS(2883),
    [anon_sym_downcast] = ACTIONS(2883),
    [anon_sym_COLON_GT] = ACTIONS(2885),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2885),
    [anon_sym_for] = ACTIONS(2883),
    [anon_sym_while] = ACTIONS(2883),
    [anon_sym_if] = ACTIONS(2883),
    [anon_sym_fun] = ACTIONS(2883),
    [anon_sym_try] = ACTIONS(2883),
    [anon_sym_match] = ACTIONS(2883),
    [anon_sym_match_BANG] = ACTIONS(2885),
    [anon_sym_function] = ACTIONS(2883),
    [anon_sym_LT_DASH] = ACTIONS(2883),
    [anon_sym_DOT_LBRACK] = ACTIONS(2885),
    [anon_sym_LT] = ACTIONS(2885),
    [anon_sym_use] = ACTIONS(2883),
    [anon_sym_use_BANG] = ACTIONS(2885),
    [anon_sym_do_BANG] = ACTIONS(2885),
    [anon_sym_begin] = ACTIONS(2883),
    [anon_sym_LPAREN2] = ACTIONS(2883),
    [anon_sym_or] = ACTIONS(2883),
    [aux_sym_char_token1] = ACTIONS(2885),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2883),
    [anon_sym_DQUOTE] = ACTIONS(2883),
    [anon_sym_AT_DQUOTE] = ACTIONS(2885),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2885),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2885),
    [sym_bool] = ACTIONS(2883),
    [sym_unit] = ACTIONS(2885),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2883),
    [sym_op_identifier] = ACTIONS(2883),
    [anon_sym_PLUS] = ACTIONS(2883),
    [anon_sym_DASH] = ACTIONS(2883),
    [anon_sym_PLUS_DOT] = ACTIONS(2883),
    [anon_sym_DASH_DOT] = ACTIONS(2883),
    [anon_sym_PERCENT] = ACTIONS(2883),
    [anon_sym_AMP_AMP] = ACTIONS(2883),
    [anon_sym_TILDE] = ACTIONS(2885),
    [aux_sym_prefix_op_token1] = ACTIONS(2883),
    [aux_sym_infix_op_token1] = ACTIONS(2885),
    [aux_sym_infix_op_token2] = ACTIONS(2883),
    [anon_sym_PIPE_PIPE] = ACTIONS(2883),
    [anon_sym_BANG_EQ] = ACTIONS(2883),
    [anon_sym_COLON_EQ] = ACTIONS(2885),
    [anon_sym_DOLLAR] = ACTIONS(2883),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2883),
    [sym_int] = ACTIONS(2883),
    [sym_xint] = ACTIONS(2885),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2885),
    [sym__newline] = ACTIONS(2885),
  },
  [2303] = {
    [sym_block_comment] = STATE(2303),
    [sym_compiler_directive_decl] = STATE(2303),
    [sym_fsi_directive_decl] = STATE(2303),
    [sym_preproc_line] = STATE(2303),
    [sym_identifier] = ACTIONS(2877),
    [anon_sym_EQ] = ACTIONS(2879),
    [anon_sym_COLON] = ACTIONS(2877),
    [anon_sym_return] = ACTIONS(2877),
    [anon_sym_do] = ACTIONS(2877),
    [anon_sym_let] = ACTIONS(2877),
    [anon_sym_let_BANG] = ACTIONS(2879),
    [anon_sym_LPAREN] = ACTIONS(2877),
    [anon_sym_COMMA] = ACTIONS(2879),
    [anon_sym_null] = ACTIONS(2877),
    [anon_sym_QMARK] = ACTIONS(2877),
    [anon_sym_COLON_QMARK] = ACTIONS(2877),
    [anon_sym_COLON_COLON] = ACTIONS(2879),
    [anon_sym_AMP] = ACTIONS(2877),
    [anon_sym_LBRACK] = ACTIONS(2877),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2879),
    [anon_sym_LBRACE] = ACTIONS(2877),
    [anon_sym_LT_AT] = ACTIONS(2877),
    [anon_sym_AT_GT] = ACTIONS(2877),
    [anon_sym_LT_AT_AT] = ACTIONS(2877),
    [anon_sym_DOT] = ACTIONS(2877),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2879),
    [anon_sym_new] = ACTIONS(2877),
    [anon_sym_return_BANG] = ACTIONS(2879),
    [anon_sym_yield] = ACTIONS(2877),
    [anon_sym_yield_BANG] = ACTIONS(2879),
    [anon_sym_lazy] = ACTIONS(2877),
    [anon_sym_assert] = ACTIONS(2877),
    [anon_sym_upcast] = ACTIONS(2877),
    [anon_sym_downcast] = ACTIONS(2877),
    [anon_sym_COLON_GT] = ACTIONS(2879),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2879),
    [anon_sym_for] = ACTIONS(2877),
    [anon_sym_while] = ACTIONS(2877),
    [anon_sym_if] = ACTIONS(2877),
    [anon_sym_fun] = ACTIONS(2877),
    [anon_sym_try] = ACTIONS(2877),
    [anon_sym_match] = ACTIONS(2877),
    [anon_sym_match_BANG] = ACTIONS(2879),
    [anon_sym_function] = ACTIONS(2877),
    [anon_sym_LT_DASH] = ACTIONS(2877),
    [anon_sym_DOT_LBRACK] = ACTIONS(2879),
    [anon_sym_LT] = ACTIONS(2879),
    [anon_sym_use] = ACTIONS(2877),
    [anon_sym_use_BANG] = ACTIONS(2879),
    [anon_sym_do_BANG] = ACTIONS(2879),
    [anon_sym_begin] = ACTIONS(2877),
    [anon_sym_LPAREN2] = ACTIONS(2877),
    [anon_sym_or] = ACTIONS(2877),
    [aux_sym_char_token1] = ACTIONS(2879),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2877),
    [anon_sym_DQUOTE] = ACTIONS(2877),
    [anon_sym_AT_DQUOTE] = ACTIONS(2879),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2879),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2879),
    [sym_bool] = ACTIONS(2877),
    [sym_unit] = ACTIONS(2879),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2877),
    [sym_op_identifier] = ACTIONS(2877),
    [anon_sym_PLUS] = ACTIONS(2877),
    [anon_sym_DASH] = ACTIONS(2877),
    [anon_sym_PLUS_DOT] = ACTIONS(2877),
    [anon_sym_DASH_DOT] = ACTIONS(2877),
    [anon_sym_PERCENT] = ACTIONS(2877),
    [anon_sym_AMP_AMP] = ACTIONS(2877),
    [anon_sym_TILDE] = ACTIONS(2879),
    [aux_sym_prefix_op_token1] = ACTIONS(2877),
    [aux_sym_infix_op_token1] = ACTIONS(2879),
    [aux_sym_infix_op_token2] = ACTIONS(2877),
    [anon_sym_PIPE_PIPE] = ACTIONS(2877),
    [anon_sym_BANG_EQ] = ACTIONS(2877),
    [anon_sym_COLON_EQ] = ACTIONS(2879),
    [anon_sym_DOLLAR] = ACTIONS(2877),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2877),
    [sym_int] = ACTIONS(2877),
    [sym_xint] = ACTIONS(2879),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2879),
    [sym__newline] = ACTIONS(2879),
  },
  [2304] = {
    [sym_block_comment] = STATE(2304),
    [sym_compiler_directive_decl] = STATE(2304),
    [sym_fsi_directive_decl] = STATE(2304),
    [sym_preproc_line] = STATE(2304),
    [sym_identifier] = ACTIONS(2873),
    [anon_sym_EQ] = ACTIONS(2875),
    [anon_sym_COLON] = ACTIONS(2873),
    [anon_sym_return] = ACTIONS(2873),
    [anon_sym_do] = ACTIONS(2873),
    [anon_sym_let] = ACTIONS(2873),
    [anon_sym_let_BANG] = ACTIONS(2875),
    [anon_sym_LPAREN] = ACTIONS(2873),
    [anon_sym_COMMA] = ACTIONS(2875),
    [anon_sym_null] = ACTIONS(2873),
    [anon_sym_QMARK] = ACTIONS(2873),
    [anon_sym_COLON_QMARK] = ACTIONS(2873),
    [anon_sym_COLON_COLON] = ACTIONS(2875),
    [anon_sym_AMP] = ACTIONS(2873),
    [anon_sym_LBRACK] = ACTIONS(2873),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2875),
    [anon_sym_LBRACE] = ACTIONS(2873),
    [anon_sym_LT_AT] = ACTIONS(2873),
    [anon_sym_LT_AT_AT] = ACTIONS(2873),
    [anon_sym_AT_AT_GT] = ACTIONS(2873),
    [anon_sym_DOT] = ACTIONS(2873),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2875),
    [anon_sym_new] = ACTIONS(2873),
    [anon_sym_return_BANG] = ACTIONS(2875),
    [anon_sym_yield] = ACTIONS(2873),
    [anon_sym_yield_BANG] = ACTIONS(2875),
    [anon_sym_lazy] = ACTIONS(2873),
    [anon_sym_assert] = ACTIONS(2873),
    [anon_sym_upcast] = ACTIONS(2873),
    [anon_sym_downcast] = ACTIONS(2873),
    [anon_sym_COLON_GT] = ACTIONS(2875),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2875),
    [anon_sym_for] = ACTIONS(2873),
    [anon_sym_while] = ACTIONS(2873),
    [anon_sym_if] = ACTIONS(2873),
    [anon_sym_fun] = ACTIONS(2873),
    [anon_sym_try] = ACTIONS(2873),
    [anon_sym_match] = ACTIONS(2873),
    [anon_sym_match_BANG] = ACTIONS(2875),
    [anon_sym_function] = ACTIONS(2873),
    [anon_sym_LT_DASH] = ACTIONS(2873),
    [anon_sym_DOT_LBRACK] = ACTIONS(2875),
    [anon_sym_LT] = ACTIONS(2875),
    [anon_sym_use] = ACTIONS(2873),
    [anon_sym_use_BANG] = ACTIONS(2875),
    [anon_sym_do_BANG] = ACTIONS(2875),
    [anon_sym_begin] = ACTIONS(2873),
    [anon_sym_LPAREN2] = ACTIONS(2873),
    [anon_sym_or] = ACTIONS(2873),
    [aux_sym_char_token1] = ACTIONS(2875),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2873),
    [anon_sym_DQUOTE] = ACTIONS(2873),
    [anon_sym_AT_DQUOTE] = ACTIONS(2875),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2875),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2875),
    [sym_bool] = ACTIONS(2873),
    [sym_unit] = ACTIONS(2875),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2873),
    [sym_op_identifier] = ACTIONS(2873),
    [anon_sym_PLUS] = ACTIONS(2873),
    [anon_sym_DASH] = ACTIONS(2873),
    [anon_sym_PLUS_DOT] = ACTIONS(2873),
    [anon_sym_DASH_DOT] = ACTIONS(2873),
    [anon_sym_PERCENT] = ACTIONS(2873),
    [anon_sym_AMP_AMP] = ACTIONS(2873),
    [anon_sym_TILDE] = ACTIONS(2875),
    [aux_sym_prefix_op_token1] = ACTIONS(2873),
    [aux_sym_infix_op_token1] = ACTIONS(2875),
    [aux_sym_infix_op_token2] = ACTIONS(2873),
    [anon_sym_PIPE_PIPE] = ACTIONS(2873),
    [anon_sym_BANG_EQ] = ACTIONS(2873),
    [anon_sym_COLON_EQ] = ACTIONS(2875),
    [anon_sym_DOLLAR] = ACTIONS(2873),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2873),
    [sym_int] = ACTIONS(2873),
    [sym_xint] = ACTIONS(2875),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2875),
    [sym__newline] = ACTIONS(2875),
  },
  [2305] = {
    [sym_block_comment] = STATE(2305),
    [sym_compiler_directive_decl] = STATE(2305),
    [sym_fsi_directive_decl] = STATE(2305),
    [sym_preproc_line] = STATE(2305),
    [sym_identifier] = ACTIONS(2867),
    [anon_sym_EQ] = ACTIONS(2869),
    [anon_sym_COLON] = ACTIONS(2867),
    [anon_sym_return] = ACTIONS(2867),
    [anon_sym_do] = ACTIONS(2867),
    [anon_sym_let] = ACTIONS(2867),
    [anon_sym_let_BANG] = ACTIONS(2869),
    [anon_sym_LPAREN] = ACTIONS(2867),
    [anon_sym_COMMA] = ACTIONS(2869),
    [anon_sym_null] = ACTIONS(2867),
    [anon_sym_QMARK] = ACTIONS(2867),
    [anon_sym_COLON_QMARK] = ACTIONS(2867),
    [anon_sym_COLON_COLON] = ACTIONS(2869),
    [anon_sym_AMP] = ACTIONS(2867),
    [anon_sym_LBRACK] = ACTIONS(2867),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2869),
    [anon_sym_LBRACE] = ACTIONS(2867),
    [anon_sym_LT_AT] = ACTIONS(2867),
    [anon_sym_LT_AT_AT] = ACTIONS(2867),
    [anon_sym_DOT] = ACTIONS(2867),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2869),
    [anon_sym_new] = ACTIONS(2867),
    [anon_sym_return_BANG] = ACTIONS(2869),
    [anon_sym_yield] = ACTIONS(2867),
    [anon_sym_yield_BANG] = ACTIONS(2869),
    [anon_sym_lazy] = ACTIONS(2867),
    [anon_sym_assert] = ACTIONS(2867),
    [anon_sym_upcast] = ACTIONS(2867),
    [anon_sym_downcast] = ACTIONS(2867),
    [anon_sym_COLON_GT] = ACTIONS(2869),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2869),
    [anon_sym_for] = ACTIONS(2867),
    [anon_sym_while] = ACTIONS(2867),
    [anon_sym_if] = ACTIONS(2867),
    [anon_sym_fun] = ACTIONS(2867),
    [anon_sym_try] = ACTIONS(2867),
    [anon_sym_match] = ACTIONS(2867),
    [anon_sym_match_BANG] = ACTIONS(2869),
    [anon_sym_function] = ACTIONS(2867),
    [anon_sym_LT_DASH] = ACTIONS(2867),
    [anon_sym_DOT_LBRACK] = ACTIONS(2869),
    [anon_sym_LT] = ACTIONS(2869),
    [anon_sym_use] = ACTIONS(2867),
    [anon_sym_use_BANG] = ACTIONS(2869),
    [anon_sym_do_BANG] = ACTIONS(2869),
    [anon_sym_DOT_DOT] = ACTIONS(2869),
    [anon_sym_begin] = ACTIONS(2867),
    [anon_sym_LPAREN2] = ACTIONS(2867),
    [anon_sym_or] = ACTIONS(2867),
    [aux_sym_char_token1] = ACTIONS(2869),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2867),
    [anon_sym_DQUOTE] = ACTIONS(2867),
    [anon_sym_AT_DQUOTE] = ACTIONS(2869),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2869),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2869),
    [sym_bool] = ACTIONS(2867),
    [sym_unit] = ACTIONS(2869),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2867),
    [sym_op_identifier] = ACTIONS(2867),
    [anon_sym_PLUS] = ACTIONS(2867),
    [anon_sym_DASH] = ACTIONS(2867),
    [anon_sym_PLUS_DOT] = ACTIONS(2867),
    [anon_sym_DASH_DOT] = ACTIONS(2867),
    [anon_sym_PERCENT] = ACTIONS(2867),
    [anon_sym_AMP_AMP] = ACTIONS(2867),
    [anon_sym_TILDE] = ACTIONS(2869),
    [aux_sym_prefix_op_token1] = ACTIONS(2867),
    [aux_sym_infix_op_token1] = ACTIONS(2869),
    [aux_sym_infix_op_token2] = ACTIONS(2867),
    [anon_sym_PIPE_PIPE] = ACTIONS(2867),
    [anon_sym_BANG_EQ] = ACTIONS(2867),
    [anon_sym_COLON_EQ] = ACTIONS(2869),
    [anon_sym_DOLLAR] = ACTIONS(2867),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2867),
    [sym_int] = ACTIONS(2867),
    [sym_xint] = ACTIONS(2869),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2869),
    [sym__newline] = ACTIONS(2869),
  },
  [2306] = {
    [sym_block_comment] = STATE(2306),
    [sym_compiler_directive_decl] = STATE(2306),
    [sym_fsi_directive_decl] = STATE(2306),
    [sym_preproc_line] = STATE(2306),
    [sym_identifier] = ACTIONS(3047),
    [anon_sym_EQ] = ACTIONS(3049),
    [anon_sym_COLON] = ACTIONS(3047),
    [anon_sym_return] = ACTIONS(3047),
    [anon_sym_do] = ACTIONS(3047),
    [anon_sym_let] = ACTIONS(3047),
    [anon_sym_let_BANG] = ACTIONS(3049),
    [anon_sym_LPAREN] = ACTIONS(3047),
    [anon_sym_COMMA] = ACTIONS(3049),
    [anon_sym_null] = ACTIONS(3047),
    [anon_sym_QMARK] = ACTIONS(3047),
    [anon_sym_COLON_QMARK] = ACTIONS(3047),
    [anon_sym_COLON_COLON] = ACTIONS(3049),
    [anon_sym_AMP] = ACTIONS(3047),
    [anon_sym_LBRACK] = ACTIONS(3047),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3049),
    [anon_sym_LBRACE] = ACTIONS(3047),
    [anon_sym_LT_AT] = ACTIONS(3047),
    [anon_sym_AT_GT] = ACTIONS(3047),
    [anon_sym_LT_AT_AT] = ACTIONS(3047),
    [anon_sym_DOT] = ACTIONS(3047),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3049),
    [anon_sym_new] = ACTIONS(3047),
    [anon_sym_return_BANG] = ACTIONS(3049),
    [anon_sym_yield] = ACTIONS(3047),
    [anon_sym_yield_BANG] = ACTIONS(3049),
    [anon_sym_lazy] = ACTIONS(3047),
    [anon_sym_assert] = ACTIONS(3047),
    [anon_sym_upcast] = ACTIONS(3047),
    [anon_sym_downcast] = ACTIONS(3047),
    [anon_sym_COLON_GT] = ACTIONS(3049),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3049),
    [anon_sym_for] = ACTIONS(3047),
    [anon_sym_while] = ACTIONS(3047),
    [anon_sym_if] = ACTIONS(3047),
    [anon_sym_fun] = ACTIONS(3047),
    [anon_sym_try] = ACTIONS(3047),
    [anon_sym_match] = ACTIONS(3047),
    [anon_sym_match_BANG] = ACTIONS(3049),
    [anon_sym_function] = ACTIONS(3047),
    [anon_sym_LT_DASH] = ACTIONS(3047),
    [anon_sym_DOT_LBRACK] = ACTIONS(3049),
    [anon_sym_LT] = ACTIONS(3049),
    [anon_sym_use] = ACTIONS(3047),
    [anon_sym_use_BANG] = ACTIONS(3049),
    [anon_sym_do_BANG] = ACTIONS(3049),
    [anon_sym_begin] = ACTIONS(3047),
    [anon_sym_LPAREN2] = ACTIONS(3047),
    [anon_sym_or] = ACTIONS(3047),
    [aux_sym_char_token1] = ACTIONS(3049),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3047),
    [anon_sym_DQUOTE] = ACTIONS(3047),
    [anon_sym_AT_DQUOTE] = ACTIONS(3049),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3049),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3049),
    [sym_bool] = ACTIONS(3047),
    [sym_unit] = ACTIONS(3049),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3047),
    [sym_op_identifier] = ACTIONS(3047),
    [anon_sym_PLUS] = ACTIONS(3047),
    [anon_sym_DASH] = ACTIONS(3047),
    [anon_sym_PLUS_DOT] = ACTIONS(3047),
    [anon_sym_DASH_DOT] = ACTIONS(3047),
    [anon_sym_PERCENT] = ACTIONS(3047),
    [anon_sym_AMP_AMP] = ACTIONS(3047),
    [anon_sym_TILDE] = ACTIONS(3049),
    [aux_sym_prefix_op_token1] = ACTIONS(3047),
    [aux_sym_infix_op_token1] = ACTIONS(3049),
    [aux_sym_infix_op_token2] = ACTIONS(3047),
    [anon_sym_PIPE_PIPE] = ACTIONS(3047),
    [anon_sym_BANG_EQ] = ACTIONS(3047),
    [anon_sym_COLON_EQ] = ACTIONS(3049),
    [anon_sym_DOLLAR] = ACTIONS(3047),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3047),
    [sym_int] = ACTIONS(3047),
    [sym_xint] = ACTIONS(3049),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3049),
    [sym__newline] = ACTIONS(3049),
  },
  [2307] = {
    [sym_block_comment] = STATE(2307),
    [sym_compiler_directive_decl] = STATE(2307),
    [sym_fsi_directive_decl] = STATE(2307),
    [sym_preproc_line] = STATE(2307),
    [sym_identifier] = ACTIONS(2877),
    [anon_sym_EQ] = ACTIONS(2879),
    [anon_sym_COLON] = ACTIONS(2877),
    [anon_sym_return] = ACTIONS(2877),
    [anon_sym_do] = ACTIONS(2877),
    [anon_sym_let] = ACTIONS(2877),
    [anon_sym_let_BANG] = ACTIONS(2879),
    [anon_sym_LPAREN] = ACTIONS(2877),
    [anon_sym_COMMA] = ACTIONS(2879),
    [anon_sym_null] = ACTIONS(2877),
    [anon_sym_QMARK] = ACTIONS(2877),
    [anon_sym_COLON_QMARK] = ACTIONS(2877),
    [anon_sym_COLON_COLON] = ACTIONS(2879),
    [anon_sym_AMP] = ACTIONS(2877),
    [anon_sym_LBRACK] = ACTIONS(2877),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2879),
    [anon_sym_LBRACE] = ACTIONS(2877),
    [anon_sym_LT_AT] = ACTIONS(2877),
    [anon_sym_LT_AT_AT] = ACTIONS(2877),
    [anon_sym_AT_AT_GT] = ACTIONS(2877),
    [anon_sym_DOT] = ACTIONS(2877),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2879),
    [anon_sym_new] = ACTIONS(2877),
    [anon_sym_return_BANG] = ACTIONS(2879),
    [anon_sym_yield] = ACTIONS(2877),
    [anon_sym_yield_BANG] = ACTIONS(2879),
    [anon_sym_lazy] = ACTIONS(2877),
    [anon_sym_assert] = ACTIONS(2877),
    [anon_sym_upcast] = ACTIONS(2877),
    [anon_sym_downcast] = ACTIONS(2877),
    [anon_sym_COLON_GT] = ACTIONS(2879),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2879),
    [anon_sym_for] = ACTIONS(2877),
    [anon_sym_while] = ACTIONS(2877),
    [anon_sym_if] = ACTIONS(2877),
    [anon_sym_fun] = ACTIONS(2877),
    [anon_sym_try] = ACTIONS(2877),
    [anon_sym_match] = ACTIONS(2877),
    [anon_sym_match_BANG] = ACTIONS(2879),
    [anon_sym_function] = ACTIONS(2877),
    [anon_sym_LT_DASH] = ACTIONS(2877),
    [anon_sym_DOT_LBRACK] = ACTIONS(2879),
    [anon_sym_LT] = ACTIONS(2879),
    [anon_sym_use] = ACTIONS(2877),
    [anon_sym_use_BANG] = ACTIONS(2879),
    [anon_sym_do_BANG] = ACTIONS(2879),
    [anon_sym_begin] = ACTIONS(2877),
    [anon_sym_LPAREN2] = ACTIONS(2877),
    [anon_sym_or] = ACTIONS(2877),
    [aux_sym_char_token1] = ACTIONS(2879),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2877),
    [anon_sym_DQUOTE] = ACTIONS(2877),
    [anon_sym_AT_DQUOTE] = ACTIONS(2879),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2879),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2879),
    [sym_bool] = ACTIONS(2877),
    [sym_unit] = ACTIONS(2879),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2877),
    [sym_op_identifier] = ACTIONS(2877),
    [anon_sym_PLUS] = ACTIONS(2877),
    [anon_sym_DASH] = ACTIONS(2877),
    [anon_sym_PLUS_DOT] = ACTIONS(2877),
    [anon_sym_DASH_DOT] = ACTIONS(2877),
    [anon_sym_PERCENT] = ACTIONS(2877),
    [anon_sym_AMP_AMP] = ACTIONS(2877),
    [anon_sym_TILDE] = ACTIONS(2879),
    [aux_sym_prefix_op_token1] = ACTIONS(2877),
    [aux_sym_infix_op_token1] = ACTIONS(2879),
    [aux_sym_infix_op_token2] = ACTIONS(2877),
    [anon_sym_PIPE_PIPE] = ACTIONS(2877),
    [anon_sym_BANG_EQ] = ACTIONS(2877),
    [anon_sym_COLON_EQ] = ACTIONS(2879),
    [anon_sym_DOLLAR] = ACTIONS(2877),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2877),
    [sym_int] = ACTIONS(2877),
    [sym_xint] = ACTIONS(2879),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2879),
    [sym__newline] = ACTIONS(2879),
  },
  [2308] = {
    [sym_block_comment] = STATE(2308),
    [sym_compiler_directive_decl] = STATE(2308),
    [sym_fsi_directive_decl] = STATE(2308),
    [sym_preproc_line] = STATE(2308),
    [sym_identifier] = ACTIONS(3119),
    [anon_sym_EQ] = ACTIONS(3121),
    [anon_sym_COLON] = ACTIONS(3119),
    [anon_sym_return] = ACTIONS(3119),
    [anon_sym_do] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_let_BANG] = ACTIONS(3121),
    [anon_sym_LPAREN] = ACTIONS(3119),
    [anon_sym_COMMA] = ACTIONS(3121),
    [anon_sym_null] = ACTIONS(3119),
    [anon_sym_QMARK] = ACTIONS(3119),
    [anon_sym_COLON_QMARK] = ACTIONS(3119),
    [anon_sym_COLON_COLON] = ACTIONS(3121),
    [anon_sym_AMP] = ACTIONS(3119),
    [anon_sym_LBRACK] = ACTIONS(3119),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3121),
    [anon_sym_LBRACE] = ACTIONS(3119),
    [anon_sym_LT_AT] = ACTIONS(3119),
    [anon_sym_LT_AT_AT] = ACTIONS(3119),
    [anon_sym_AT_AT_GT] = ACTIONS(3119),
    [anon_sym_DOT] = ACTIONS(3119),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3121),
    [anon_sym_new] = ACTIONS(3119),
    [anon_sym_return_BANG] = ACTIONS(3121),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_yield_BANG] = ACTIONS(3121),
    [anon_sym_lazy] = ACTIONS(3119),
    [anon_sym_assert] = ACTIONS(3119),
    [anon_sym_upcast] = ACTIONS(3119),
    [anon_sym_downcast] = ACTIONS(3119),
    [anon_sym_COLON_GT] = ACTIONS(3121),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3121),
    [anon_sym_for] = ACTIONS(3119),
    [anon_sym_while] = ACTIONS(3119),
    [anon_sym_if] = ACTIONS(3119),
    [anon_sym_fun] = ACTIONS(3119),
    [anon_sym_try] = ACTIONS(3119),
    [anon_sym_match] = ACTIONS(3119),
    [anon_sym_match_BANG] = ACTIONS(3121),
    [anon_sym_function] = ACTIONS(3119),
    [anon_sym_LT_DASH] = ACTIONS(3119),
    [anon_sym_DOT_LBRACK] = ACTIONS(3121),
    [anon_sym_LT] = ACTIONS(3121),
    [anon_sym_use] = ACTIONS(3119),
    [anon_sym_use_BANG] = ACTIONS(3121),
    [anon_sym_do_BANG] = ACTIONS(3121),
    [anon_sym_begin] = ACTIONS(3119),
    [anon_sym_LPAREN2] = ACTIONS(3119),
    [anon_sym_or] = ACTIONS(3119),
    [aux_sym_char_token1] = ACTIONS(3121),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3119),
    [anon_sym_DQUOTE] = ACTIONS(3119),
    [anon_sym_AT_DQUOTE] = ACTIONS(3121),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3121),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3121),
    [sym_bool] = ACTIONS(3119),
    [sym_unit] = ACTIONS(3121),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3119),
    [sym_op_identifier] = ACTIONS(3119),
    [anon_sym_PLUS] = ACTIONS(3119),
    [anon_sym_DASH] = ACTIONS(3119),
    [anon_sym_PLUS_DOT] = ACTIONS(3119),
    [anon_sym_DASH_DOT] = ACTIONS(3119),
    [anon_sym_PERCENT] = ACTIONS(3119),
    [anon_sym_AMP_AMP] = ACTIONS(3119),
    [anon_sym_TILDE] = ACTIONS(3121),
    [aux_sym_prefix_op_token1] = ACTIONS(3119),
    [aux_sym_infix_op_token1] = ACTIONS(3121),
    [aux_sym_infix_op_token2] = ACTIONS(3119),
    [anon_sym_PIPE_PIPE] = ACTIONS(3119),
    [anon_sym_BANG_EQ] = ACTIONS(3119),
    [anon_sym_COLON_EQ] = ACTIONS(3121),
    [anon_sym_DOLLAR] = ACTIONS(3119),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3119),
    [sym_int] = ACTIONS(3119),
    [sym_xint] = ACTIONS(3121),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3121),
    [sym__newline] = ACTIONS(3121),
  },
  [2309] = {
    [sym_block_comment] = STATE(2309),
    [sym_compiler_directive_decl] = STATE(2309),
    [sym_fsi_directive_decl] = STATE(2309),
    [sym_preproc_line] = STATE(2309),
    [sym_identifier] = ACTIONS(3095),
    [anon_sym_EQ] = ACTIONS(3097),
    [anon_sym_COLON] = ACTIONS(3095),
    [anon_sym_return] = ACTIONS(3095),
    [anon_sym_do] = ACTIONS(3095),
    [anon_sym_let] = ACTIONS(3095),
    [anon_sym_let_BANG] = ACTIONS(3097),
    [anon_sym_LPAREN] = ACTIONS(3095),
    [anon_sym_COMMA] = ACTIONS(3097),
    [anon_sym_null] = ACTIONS(3095),
    [anon_sym_QMARK] = ACTIONS(3095),
    [anon_sym_COLON_QMARK] = ACTIONS(3095),
    [anon_sym_COLON_COLON] = ACTIONS(3097),
    [anon_sym_AMP] = ACTIONS(3095),
    [anon_sym_LBRACK] = ACTIONS(3095),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3097),
    [anon_sym_LBRACE] = ACTIONS(3095),
    [anon_sym_LT_AT] = ACTIONS(3095),
    [anon_sym_AT_GT] = ACTIONS(3095),
    [anon_sym_LT_AT_AT] = ACTIONS(3095),
    [anon_sym_DOT] = ACTIONS(3095),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3097),
    [anon_sym_new] = ACTIONS(3095),
    [anon_sym_return_BANG] = ACTIONS(3097),
    [anon_sym_yield] = ACTIONS(3095),
    [anon_sym_yield_BANG] = ACTIONS(3097),
    [anon_sym_lazy] = ACTIONS(3095),
    [anon_sym_assert] = ACTIONS(3095),
    [anon_sym_upcast] = ACTIONS(3095),
    [anon_sym_downcast] = ACTIONS(3095),
    [anon_sym_COLON_GT] = ACTIONS(3097),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3097),
    [anon_sym_for] = ACTIONS(3095),
    [anon_sym_while] = ACTIONS(3095),
    [anon_sym_if] = ACTIONS(3095),
    [anon_sym_fun] = ACTIONS(3095),
    [anon_sym_try] = ACTIONS(3095),
    [anon_sym_match] = ACTIONS(3095),
    [anon_sym_match_BANG] = ACTIONS(3097),
    [anon_sym_function] = ACTIONS(3095),
    [anon_sym_LT_DASH] = ACTIONS(3095),
    [anon_sym_DOT_LBRACK] = ACTIONS(3097),
    [anon_sym_LT] = ACTIONS(3097),
    [anon_sym_use] = ACTIONS(3095),
    [anon_sym_use_BANG] = ACTIONS(3097),
    [anon_sym_do_BANG] = ACTIONS(3097),
    [anon_sym_begin] = ACTIONS(3095),
    [anon_sym_LPAREN2] = ACTIONS(3095),
    [anon_sym_or] = ACTIONS(3095),
    [aux_sym_char_token1] = ACTIONS(3097),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3095),
    [anon_sym_DQUOTE] = ACTIONS(3095),
    [anon_sym_AT_DQUOTE] = ACTIONS(3097),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3097),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3097),
    [sym_bool] = ACTIONS(3095),
    [sym_unit] = ACTIONS(3097),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3095),
    [sym_op_identifier] = ACTIONS(3095),
    [anon_sym_PLUS] = ACTIONS(3095),
    [anon_sym_DASH] = ACTIONS(3095),
    [anon_sym_PLUS_DOT] = ACTIONS(3095),
    [anon_sym_DASH_DOT] = ACTIONS(3095),
    [anon_sym_PERCENT] = ACTIONS(3095),
    [anon_sym_AMP_AMP] = ACTIONS(3095),
    [anon_sym_TILDE] = ACTIONS(3097),
    [aux_sym_prefix_op_token1] = ACTIONS(3095),
    [aux_sym_infix_op_token1] = ACTIONS(3097),
    [aux_sym_infix_op_token2] = ACTIONS(3095),
    [anon_sym_PIPE_PIPE] = ACTIONS(3095),
    [anon_sym_BANG_EQ] = ACTIONS(3095),
    [anon_sym_COLON_EQ] = ACTIONS(3097),
    [anon_sym_DOLLAR] = ACTIONS(3095),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3095),
    [sym_int] = ACTIONS(3095),
    [sym_xint] = ACTIONS(3097),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3097),
    [sym__newline] = ACTIONS(3097),
  },
  [2310] = {
    [sym_block_comment] = STATE(2310),
    [sym_compiler_directive_decl] = STATE(2310),
    [sym_fsi_directive_decl] = STATE(2310),
    [sym_preproc_line] = STATE(2310),
    [sym_identifier] = ACTIONS(2883),
    [anon_sym_EQ] = ACTIONS(2885),
    [anon_sym_COLON] = ACTIONS(2883),
    [anon_sym_return] = ACTIONS(2883),
    [anon_sym_do] = ACTIONS(2883),
    [anon_sym_let] = ACTIONS(2883),
    [anon_sym_let_BANG] = ACTIONS(2885),
    [anon_sym_LPAREN] = ACTIONS(2883),
    [anon_sym_COMMA] = ACTIONS(2885),
    [anon_sym_null] = ACTIONS(2883),
    [anon_sym_QMARK] = ACTIONS(2883),
    [anon_sym_COLON_QMARK] = ACTIONS(2883),
    [anon_sym_COLON_COLON] = ACTIONS(2885),
    [anon_sym_AMP] = ACTIONS(2883),
    [anon_sym_LBRACK] = ACTIONS(2883),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2885),
    [anon_sym_LBRACE] = ACTIONS(2883),
    [anon_sym_LT_AT] = ACTIONS(2883),
    [anon_sym_LT_AT_AT] = ACTIONS(2883),
    [anon_sym_AT_AT_GT] = ACTIONS(2883),
    [anon_sym_DOT] = ACTIONS(2883),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2885),
    [anon_sym_new] = ACTIONS(2883),
    [anon_sym_return_BANG] = ACTIONS(2885),
    [anon_sym_yield] = ACTIONS(2883),
    [anon_sym_yield_BANG] = ACTIONS(2885),
    [anon_sym_lazy] = ACTIONS(2883),
    [anon_sym_assert] = ACTIONS(2883),
    [anon_sym_upcast] = ACTIONS(2883),
    [anon_sym_downcast] = ACTIONS(2883),
    [anon_sym_COLON_GT] = ACTIONS(2885),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2885),
    [anon_sym_for] = ACTIONS(2883),
    [anon_sym_while] = ACTIONS(2883),
    [anon_sym_if] = ACTIONS(2883),
    [anon_sym_fun] = ACTIONS(2883),
    [anon_sym_try] = ACTIONS(2883),
    [anon_sym_match] = ACTIONS(2883),
    [anon_sym_match_BANG] = ACTIONS(2885),
    [anon_sym_function] = ACTIONS(2883),
    [anon_sym_LT_DASH] = ACTIONS(2883),
    [anon_sym_DOT_LBRACK] = ACTIONS(2885),
    [anon_sym_LT] = ACTIONS(2885),
    [anon_sym_use] = ACTIONS(2883),
    [anon_sym_use_BANG] = ACTIONS(2885),
    [anon_sym_do_BANG] = ACTIONS(2885),
    [anon_sym_begin] = ACTIONS(2883),
    [anon_sym_LPAREN2] = ACTIONS(2883),
    [anon_sym_or] = ACTIONS(2883),
    [aux_sym_char_token1] = ACTIONS(2885),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2883),
    [anon_sym_DQUOTE] = ACTIONS(2883),
    [anon_sym_AT_DQUOTE] = ACTIONS(2885),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2885),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2885),
    [sym_bool] = ACTIONS(2883),
    [sym_unit] = ACTIONS(2885),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2883),
    [sym_op_identifier] = ACTIONS(2883),
    [anon_sym_PLUS] = ACTIONS(2883),
    [anon_sym_DASH] = ACTIONS(2883),
    [anon_sym_PLUS_DOT] = ACTIONS(2883),
    [anon_sym_DASH_DOT] = ACTIONS(2883),
    [anon_sym_PERCENT] = ACTIONS(2883),
    [anon_sym_AMP_AMP] = ACTIONS(2883),
    [anon_sym_TILDE] = ACTIONS(2885),
    [aux_sym_prefix_op_token1] = ACTIONS(2883),
    [aux_sym_infix_op_token1] = ACTIONS(2885),
    [aux_sym_infix_op_token2] = ACTIONS(2883),
    [anon_sym_PIPE_PIPE] = ACTIONS(2883),
    [anon_sym_BANG_EQ] = ACTIONS(2883),
    [anon_sym_COLON_EQ] = ACTIONS(2885),
    [anon_sym_DOLLAR] = ACTIONS(2883),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2883),
    [sym_int] = ACTIONS(2883),
    [sym_xint] = ACTIONS(2885),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2885),
    [sym__newline] = ACTIONS(2885),
  },
  [2311] = {
    [sym_block_comment] = STATE(2311),
    [sym_compiler_directive_decl] = STATE(2311),
    [sym_fsi_directive_decl] = STATE(2311),
    [sym_preproc_line] = STATE(2311),
    [sym_identifier] = ACTIONS(2835),
    [anon_sym_EQ] = ACTIONS(2837),
    [anon_sym_COLON] = ACTIONS(2835),
    [anon_sym_return] = ACTIONS(2835),
    [anon_sym_do] = ACTIONS(2835),
    [anon_sym_let] = ACTIONS(2835),
    [anon_sym_let_BANG] = ACTIONS(2837),
    [anon_sym_LPAREN] = ACTIONS(2835),
    [anon_sym_COMMA] = ACTIONS(2837),
    [anon_sym_null] = ACTIONS(2835),
    [anon_sym_QMARK] = ACTIONS(2835),
    [anon_sym_COLON_QMARK] = ACTIONS(2835),
    [anon_sym_COLON_COLON] = ACTIONS(2837),
    [anon_sym_AMP] = ACTIONS(2835),
    [anon_sym_LBRACK] = ACTIONS(2835),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2837),
    [anon_sym_LBRACE] = ACTIONS(2835),
    [anon_sym_LT_AT] = ACTIONS(2835),
    [anon_sym_LT_AT_AT] = ACTIONS(2835),
    [anon_sym_AT_AT_GT] = ACTIONS(2835),
    [anon_sym_DOT] = ACTIONS(2835),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2837),
    [anon_sym_new] = ACTIONS(2835),
    [anon_sym_return_BANG] = ACTIONS(2837),
    [anon_sym_yield] = ACTIONS(2835),
    [anon_sym_yield_BANG] = ACTIONS(2837),
    [anon_sym_lazy] = ACTIONS(2835),
    [anon_sym_assert] = ACTIONS(2835),
    [anon_sym_upcast] = ACTIONS(2835),
    [anon_sym_downcast] = ACTIONS(2835),
    [anon_sym_COLON_GT] = ACTIONS(2837),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2837),
    [anon_sym_for] = ACTIONS(2835),
    [anon_sym_while] = ACTIONS(2835),
    [anon_sym_if] = ACTIONS(2835),
    [anon_sym_fun] = ACTIONS(2835),
    [anon_sym_try] = ACTIONS(2835),
    [anon_sym_match] = ACTIONS(2835),
    [anon_sym_match_BANG] = ACTIONS(2837),
    [anon_sym_function] = ACTIONS(2835),
    [anon_sym_LT_DASH] = ACTIONS(2835),
    [anon_sym_DOT_LBRACK] = ACTIONS(2837),
    [anon_sym_LT] = ACTIONS(2837),
    [anon_sym_use] = ACTIONS(2835),
    [anon_sym_use_BANG] = ACTIONS(2837),
    [anon_sym_do_BANG] = ACTIONS(2837),
    [anon_sym_begin] = ACTIONS(2835),
    [anon_sym_LPAREN2] = ACTIONS(2835),
    [anon_sym_or] = ACTIONS(2835),
    [aux_sym_char_token1] = ACTIONS(2837),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2835),
    [anon_sym_DQUOTE] = ACTIONS(2835),
    [anon_sym_AT_DQUOTE] = ACTIONS(2837),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2837),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2837),
    [sym_bool] = ACTIONS(2835),
    [sym_unit] = ACTIONS(2837),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2835),
    [sym_op_identifier] = ACTIONS(2835),
    [anon_sym_PLUS] = ACTIONS(2835),
    [anon_sym_DASH] = ACTIONS(2835),
    [anon_sym_PLUS_DOT] = ACTIONS(2835),
    [anon_sym_DASH_DOT] = ACTIONS(2835),
    [anon_sym_PERCENT] = ACTIONS(2835),
    [anon_sym_AMP_AMP] = ACTIONS(2835),
    [anon_sym_TILDE] = ACTIONS(2837),
    [aux_sym_prefix_op_token1] = ACTIONS(2835),
    [aux_sym_infix_op_token1] = ACTIONS(2837),
    [aux_sym_infix_op_token2] = ACTIONS(2835),
    [anon_sym_PIPE_PIPE] = ACTIONS(2835),
    [anon_sym_BANG_EQ] = ACTIONS(2835),
    [anon_sym_COLON_EQ] = ACTIONS(2837),
    [anon_sym_DOLLAR] = ACTIONS(2835),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2835),
    [sym_int] = ACTIONS(2835),
    [sym_xint] = ACTIONS(2837),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2837),
    [sym__newline] = ACTIONS(2837),
  },
  [2312] = {
    [sym_block_comment] = STATE(2312),
    [sym_compiler_directive_decl] = STATE(2312),
    [sym_fsi_directive_decl] = STATE(2312),
    [sym_preproc_line] = STATE(2312),
    [sym_identifier] = ACTIONS(3111),
    [anon_sym_EQ] = ACTIONS(3113),
    [anon_sym_COLON] = ACTIONS(3111),
    [anon_sym_return] = ACTIONS(3111),
    [anon_sym_do] = ACTIONS(3111),
    [anon_sym_let] = ACTIONS(3111),
    [anon_sym_let_BANG] = ACTIONS(3113),
    [anon_sym_LPAREN] = ACTIONS(3111),
    [anon_sym_COMMA] = ACTIONS(3113),
    [anon_sym_null] = ACTIONS(3111),
    [anon_sym_QMARK] = ACTIONS(3111),
    [anon_sym_COLON_QMARK] = ACTIONS(3111),
    [anon_sym_COLON_COLON] = ACTIONS(3113),
    [anon_sym_AMP] = ACTIONS(3111),
    [anon_sym_LBRACK] = ACTIONS(3111),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3113),
    [anon_sym_LBRACE] = ACTIONS(3111),
    [anon_sym_LT_AT] = ACTIONS(3111),
    [anon_sym_LT_AT_AT] = ACTIONS(3111),
    [anon_sym_AT_AT_GT] = ACTIONS(3111),
    [anon_sym_DOT] = ACTIONS(3111),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3113),
    [anon_sym_new] = ACTIONS(3111),
    [anon_sym_return_BANG] = ACTIONS(3113),
    [anon_sym_yield] = ACTIONS(3111),
    [anon_sym_yield_BANG] = ACTIONS(3113),
    [anon_sym_lazy] = ACTIONS(3111),
    [anon_sym_assert] = ACTIONS(3111),
    [anon_sym_upcast] = ACTIONS(3111),
    [anon_sym_downcast] = ACTIONS(3111),
    [anon_sym_COLON_GT] = ACTIONS(3113),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3113),
    [anon_sym_for] = ACTIONS(3111),
    [anon_sym_while] = ACTIONS(3111),
    [anon_sym_if] = ACTIONS(3111),
    [anon_sym_fun] = ACTIONS(3111),
    [anon_sym_try] = ACTIONS(3111),
    [anon_sym_match] = ACTIONS(3111),
    [anon_sym_match_BANG] = ACTIONS(3113),
    [anon_sym_function] = ACTIONS(3111),
    [anon_sym_LT_DASH] = ACTIONS(3111),
    [anon_sym_DOT_LBRACK] = ACTIONS(3113),
    [anon_sym_LT] = ACTIONS(3113),
    [anon_sym_use] = ACTIONS(3111),
    [anon_sym_use_BANG] = ACTIONS(3113),
    [anon_sym_do_BANG] = ACTIONS(3113),
    [anon_sym_begin] = ACTIONS(3111),
    [anon_sym_LPAREN2] = ACTIONS(3111),
    [anon_sym_or] = ACTIONS(3111),
    [aux_sym_char_token1] = ACTIONS(3113),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3111),
    [anon_sym_DQUOTE] = ACTIONS(3111),
    [anon_sym_AT_DQUOTE] = ACTIONS(3113),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3113),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3113),
    [sym_bool] = ACTIONS(3111),
    [sym_unit] = ACTIONS(3113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3111),
    [sym_op_identifier] = ACTIONS(3111),
    [anon_sym_PLUS] = ACTIONS(3111),
    [anon_sym_DASH] = ACTIONS(3111),
    [anon_sym_PLUS_DOT] = ACTIONS(3111),
    [anon_sym_DASH_DOT] = ACTIONS(3111),
    [anon_sym_PERCENT] = ACTIONS(3111),
    [anon_sym_AMP_AMP] = ACTIONS(3111),
    [anon_sym_TILDE] = ACTIONS(3113),
    [aux_sym_prefix_op_token1] = ACTIONS(3111),
    [aux_sym_infix_op_token1] = ACTIONS(3113),
    [aux_sym_infix_op_token2] = ACTIONS(3111),
    [anon_sym_PIPE_PIPE] = ACTIONS(3111),
    [anon_sym_BANG_EQ] = ACTIONS(3111),
    [anon_sym_COLON_EQ] = ACTIONS(3113),
    [anon_sym_DOLLAR] = ACTIONS(3111),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3111),
    [sym_int] = ACTIONS(3111),
    [sym_xint] = ACTIONS(3113),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3113),
    [sym__newline] = ACTIONS(3113),
  },
  [2313] = {
    [sym_block_comment] = STATE(2313),
    [sym_compiler_directive_decl] = STATE(2313),
    [sym_fsi_directive_decl] = STATE(2313),
    [sym_preproc_line] = STATE(2313),
    [sym_identifier] = ACTIONS(3107),
    [anon_sym_EQ] = ACTIONS(3109),
    [anon_sym_COLON] = ACTIONS(3107),
    [anon_sym_return] = ACTIONS(3107),
    [anon_sym_do] = ACTIONS(3107),
    [anon_sym_let] = ACTIONS(3107),
    [anon_sym_let_BANG] = ACTIONS(3109),
    [anon_sym_LPAREN] = ACTIONS(3107),
    [anon_sym_COMMA] = ACTIONS(3109),
    [anon_sym_null] = ACTIONS(3107),
    [anon_sym_QMARK] = ACTIONS(3107),
    [anon_sym_COLON_QMARK] = ACTIONS(3107),
    [anon_sym_COLON_COLON] = ACTIONS(3109),
    [anon_sym_AMP] = ACTIONS(3107),
    [anon_sym_LBRACK] = ACTIONS(3107),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3109),
    [anon_sym_LBRACE] = ACTIONS(3107),
    [anon_sym_LT_AT] = ACTIONS(3107),
    [anon_sym_LT_AT_AT] = ACTIONS(3107),
    [anon_sym_AT_AT_GT] = ACTIONS(3107),
    [anon_sym_DOT] = ACTIONS(3107),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3109),
    [anon_sym_new] = ACTIONS(3107),
    [anon_sym_return_BANG] = ACTIONS(3109),
    [anon_sym_yield] = ACTIONS(3107),
    [anon_sym_yield_BANG] = ACTIONS(3109),
    [anon_sym_lazy] = ACTIONS(3107),
    [anon_sym_assert] = ACTIONS(3107),
    [anon_sym_upcast] = ACTIONS(3107),
    [anon_sym_downcast] = ACTIONS(3107),
    [anon_sym_COLON_GT] = ACTIONS(3109),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3109),
    [anon_sym_for] = ACTIONS(3107),
    [anon_sym_while] = ACTIONS(3107),
    [anon_sym_if] = ACTIONS(3107),
    [anon_sym_fun] = ACTIONS(3107),
    [anon_sym_try] = ACTIONS(3107),
    [anon_sym_match] = ACTIONS(3107),
    [anon_sym_match_BANG] = ACTIONS(3109),
    [anon_sym_function] = ACTIONS(3107),
    [anon_sym_LT_DASH] = ACTIONS(3107),
    [anon_sym_DOT_LBRACK] = ACTIONS(3109),
    [anon_sym_LT] = ACTIONS(3109),
    [anon_sym_use] = ACTIONS(3107),
    [anon_sym_use_BANG] = ACTIONS(3109),
    [anon_sym_do_BANG] = ACTIONS(3109),
    [anon_sym_begin] = ACTIONS(3107),
    [anon_sym_LPAREN2] = ACTIONS(3107),
    [anon_sym_or] = ACTIONS(3107),
    [aux_sym_char_token1] = ACTIONS(3109),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3107),
    [anon_sym_DQUOTE] = ACTIONS(3107),
    [anon_sym_AT_DQUOTE] = ACTIONS(3109),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3109),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3109),
    [sym_bool] = ACTIONS(3107),
    [sym_unit] = ACTIONS(3109),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3107),
    [sym_op_identifier] = ACTIONS(3107),
    [anon_sym_PLUS] = ACTIONS(3107),
    [anon_sym_DASH] = ACTIONS(3107),
    [anon_sym_PLUS_DOT] = ACTIONS(3107),
    [anon_sym_DASH_DOT] = ACTIONS(3107),
    [anon_sym_PERCENT] = ACTIONS(3107),
    [anon_sym_AMP_AMP] = ACTIONS(3107),
    [anon_sym_TILDE] = ACTIONS(3109),
    [aux_sym_prefix_op_token1] = ACTIONS(3107),
    [aux_sym_infix_op_token1] = ACTIONS(3109),
    [aux_sym_infix_op_token2] = ACTIONS(3107),
    [anon_sym_PIPE_PIPE] = ACTIONS(3107),
    [anon_sym_BANG_EQ] = ACTIONS(3107),
    [anon_sym_COLON_EQ] = ACTIONS(3109),
    [anon_sym_DOLLAR] = ACTIONS(3107),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3107),
    [sym_int] = ACTIONS(3107),
    [sym_xint] = ACTIONS(3109),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3109),
    [sym__newline] = ACTIONS(3109),
  },
  [2314] = {
    [sym_block_comment] = STATE(2314),
    [sym_compiler_directive_decl] = STATE(2314),
    [sym_fsi_directive_decl] = STATE(2314),
    [sym_preproc_line] = STATE(2314),
    [sym_identifier] = ACTIONS(3011),
    [anon_sym_EQ] = ACTIONS(3013),
    [anon_sym_COLON] = ACTIONS(3011),
    [anon_sym_return] = ACTIONS(3011),
    [anon_sym_do] = ACTIONS(3011),
    [anon_sym_let] = ACTIONS(3011),
    [anon_sym_let_BANG] = ACTIONS(3013),
    [anon_sym_LPAREN] = ACTIONS(3011),
    [anon_sym_COMMA] = ACTIONS(3013),
    [anon_sym_null] = ACTIONS(3011),
    [anon_sym_QMARK] = ACTIONS(3011),
    [anon_sym_COLON_QMARK] = ACTIONS(3011),
    [anon_sym_COLON_COLON] = ACTIONS(3013),
    [anon_sym_AMP] = ACTIONS(3011),
    [anon_sym_LBRACK] = ACTIONS(3011),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3013),
    [anon_sym_LBRACE] = ACTIONS(3011),
    [anon_sym_LT_AT] = ACTIONS(3011),
    [anon_sym_LT_AT_AT] = ACTIONS(3011),
    [anon_sym_DOT] = ACTIONS(3011),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3013),
    [anon_sym_new] = ACTIONS(3011),
    [anon_sym_return_BANG] = ACTIONS(3013),
    [anon_sym_yield] = ACTIONS(3011),
    [anon_sym_yield_BANG] = ACTIONS(3013),
    [anon_sym_lazy] = ACTIONS(3011),
    [anon_sym_assert] = ACTIONS(3011),
    [anon_sym_upcast] = ACTIONS(3011),
    [anon_sym_downcast] = ACTIONS(3011),
    [anon_sym_COLON_GT] = ACTIONS(3013),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3013),
    [anon_sym_for] = ACTIONS(3011),
    [anon_sym_while] = ACTIONS(3011),
    [anon_sym_if] = ACTIONS(3011),
    [anon_sym_fun] = ACTIONS(3011),
    [anon_sym_try] = ACTIONS(3011),
    [anon_sym_match] = ACTIONS(3011),
    [anon_sym_match_BANG] = ACTIONS(3013),
    [anon_sym_function] = ACTIONS(3011),
    [anon_sym_LT_DASH] = ACTIONS(3011),
    [anon_sym_DOT_LBRACK] = ACTIONS(3013),
    [anon_sym_LT] = ACTIONS(3013),
    [anon_sym_use] = ACTIONS(3011),
    [anon_sym_use_BANG] = ACTIONS(3013),
    [anon_sym_do_BANG] = ACTIONS(3013),
    [anon_sym_DOT_DOT] = ACTIONS(3013),
    [anon_sym_begin] = ACTIONS(3011),
    [anon_sym_LPAREN2] = ACTIONS(3011),
    [anon_sym_or] = ACTIONS(3011),
    [aux_sym_char_token1] = ACTIONS(3013),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3011),
    [anon_sym_DQUOTE] = ACTIONS(3011),
    [anon_sym_AT_DQUOTE] = ACTIONS(3013),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3013),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3013),
    [sym_bool] = ACTIONS(3011),
    [sym_unit] = ACTIONS(3013),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3011),
    [sym_op_identifier] = ACTIONS(3011),
    [anon_sym_PLUS] = ACTIONS(3011),
    [anon_sym_DASH] = ACTIONS(3011),
    [anon_sym_PLUS_DOT] = ACTIONS(3011),
    [anon_sym_DASH_DOT] = ACTIONS(3011),
    [anon_sym_PERCENT] = ACTIONS(3011),
    [anon_sym_AMP_AMP] = ACTIONS(3011),
    [anon_sym_TILDE] = ACTIONS(3013),
    [aux_sym_prefix_op_token1] = ACTIONS(3011),
    [aux_sym_infix_op_token1] = ACTIONS(3013),
    [aux_sym_infix_op_token2] = ACTIONS(3011),
    [anon_sym_PIPE_PIPE] = ACTIONS(3011),
    [anon_sym_BANG_EQ] = ACTIONS(3011),
    [anon_sym_COLON_EQ] = ACTIONS(3013),
    [anon_sym_DOLLAR] = ACTIONS(3011),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3011),
    [sym_int] = ACTIONS(3011),
    [sym_xint] = ACTIONS(3013),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3013),
    [sym__newline] = ACTIONS(3013),
  },
  [2315] = {
    [sym_block_comment] = STATE(2315),
    [sym_compiler_directive_decl] = STATE(2315),
    [sym_fsi_directive_decl] = STATE(2315),
    [sym_preproc_line] = STATE(2315),
    [sym_identifier] = ACTIONS(3103),
    [anon_sym_EQ] = ACTIONS(3105),
    [anon_sym_COLON] = ACTIONS(3103),
    [anon_sym_return] = ACTIONS(3103),
    [anon_sym_do] = ACTIONS(3103),
    [anon_sym_let] = ACTIONS(3103),
    [anon_sym_let_BANG] = ACTIONS(3105),
    [anon_sym_LPAREN] = ACTIONS(3103),
    [anon_sym_COMMA] = ACTIONS(3105),
    [anon_sym_null] = ACTIONS(3103),
    [anon_sym_QMARK] = ACTIONS(3103),
    [anon_sym_COLON_QMARK] = ACTIONS(3103),
    [anon_sym_COLON_COLON] = ACTIONS(3105),
    [anon_sym_AMP] = ACTIONS(3103),
    [anon_sym_LBRACK] = ACTIONS(3103),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3105),
    [anon_sym_LBRACE] = ACTIONS(3103),
    [anon_sym_LT_AT] = ACTIONS(3103),
    [anon_sym_LT_AT_AT] = ACTIONS(3103),
    [anon_sym_AT_AT_GT] = ACTIONS(3103),
    [anon_sym_DOT] = ACTIONS(3103),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3105),
    [anon_sym_new] = ACTIONS(3103),
    [anon_sym_return_BANG] = ACTIONS(3105),
    [anon_sym_yield] = ACTIONS(3103),
    [anon_sym_yield_BANG] = ACTIONS(3105),
    [anon_sym_lazy] = ACTIONS(3103),
    [anon_sym_assert] = ACTIONS(3103),
    [anon_sym_upcast] = ACTIONS(3103),
    [anon_sym_downcast] = ACTIONS(3103),
    [anon_sym_COLON_GT] = ACTIONS(3105),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3105),
    [anon_sym_for] = ACTIONS(3103),
    [anon_sym_while] = ACTIONS(3103),
    [anon_sym_if] = ACTIONS(3103),
    [anon_sym_fun] = ACTIONS(3103),
    [anon_sym_try] = ACTIONS(3103),
    [anon_sym_match] = ACTIONS(3103),
    [anon_sym_match_BANG] = ACTIONS(3105),
    [anon_sym_function] = ACTIONS(3103),
    [anon_sym_LT_DASH] = ACTIONS(3103),
    [anon_sym_DOT_LBRACK] = ACTIONS(3105),
    [anon_sym_LT] = ACTIONS(3105),
    [anon_sym_use] = ACTIONS(3103),
    [anon_sym_use_BANG] = ACTIONS(3105),
    [anon_sym_do_BANG] = ACTIONS(3105),
    [anon_sym_begin] = ACTIONS(3103),
    [anon_sym_LPAREN2] = ACTIONS(3103),
    [anon_sym_or] = ACTIONS(3103),
    [aux_sym_char_token1] = ACTIONS(3105),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3103),
    [anon_sym_DQUOTE] = ACTIONS(3103),
    [anon_sym_AT_DQUOTE] = ACTIONS(3105),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3105),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3105),
    [sym_bool] = ACTIONS(3103),
    [sym_unit] = ACTIONS(3105),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3103),
    [sym_op_identifier] = ACTIONS(3103),
    [anon_sym_PLUS] = ACTIONS(3103),
    [anon_sym_DASH] = ACTIONS(3103),
    [anon_sym_PLUS_DOT] = ACTIONS(3103),
    [anon_sym_DASH_DOT] = ACTIONS(3103),
    [anon_sym_PERCENT] = ACTIONS(3103),
    [anon_sym_AMP_AMP] = ACTIONS(3103),
    [anon_sym_TILDE] = ACTIONS(3105),
    [aux_sym_prefix_op_token1] = ACTIONS(3103),
    [aux_sym_infix_op_token1] = ACTIONS(3105),
    [aux_sym_infix_op_token2] = ACTIONS(3103),
    [anon_sym_PIPE_PIPE] = ACTIONS(3103),
    [anon_sym_BANG_EQ] = ACTIONS(3103),
    [anon_sym_COLON_EQ] = ACTIONS(3105),
    [anon_sym_DOLLAR] = ACTIONS(3103),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3103),
    [sym_int] = ACTIONS(3103),
    [sym_xint] = ACTIONS(3105),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3105),
    [sym__newline] = ACTIONS(3105),
  },
  [2316] = {
    [sym_block_comment] = STATE(2316),
    [sym_compiler_directive_decl] = STATE(2316),
    [sym_fsi_directive_decl] = STATE(2316),
    [sym_preproc_line] = STATE(2316),
    [sym_identifier] = ACTIONS(3051),
    [anon_sym_EQ] = ACTIONS(3053),
    [anon_sym_COLON] = ACTIONS(3051),
    [anon_sym_return] = ACTIONS(3051),
    [anon_sym_do] = ACTIONS(3051),
    [anon_sym_let] = ACTIONS(3051),
    [anon_sym_let_BANG] = ACTIONS(3053),
    [anon_sym_LPAREN] = ACTIONS(3051),
    [anon_sym_COMMA] = ACTIONS(3053),
    [anon_sym_null] = ACTIONS(3051),
    [anon_sym_QMARK] = ACTIONS(3051),
    [anon_sym_COLON_QMARK] = ACTIONS(3051),
    [anon_sym_COLON_COLON] = ACTIONS(3053),
    [anon_sym_AMP] = ACTIONS(3051),
    [anon_sym_LBRACK] = ACTIONS(3051),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3053),
    [anon_sym_LBRACE] = ACTIONS(3051),
    [anon_sym_LT_AT] = ACTIONS(3051),
    [anon_sym_AT_GT] = ACTIONS(3051),
    [anon_sym_LT_AT_AT] = ACTIONS(3051),
    [anon_sym_DOT] = ACTIONS(3051),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3053),
    [anon_sym_new] = ACTIONS(3051),
    [anon_sym_return_BANG] = ACTIONS(3053),
    [anon_sym_yield] = ACTIONS(3051),
    [anon_sym_yield_BANG] = ACTIONS(3053),
    [anon_sym_lazy] = ACTIONS(3051),
    [anon_sym_assert] = ACTIONS(3051),
    [anon_sym_upcast] = ACTIONS(3051),
    [anon_sym_downcast] = ACTIONS(3051),
    [anon_sym_COLON_GT] = ACTIONS(3053),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3053),
    [anon_sym_for] = ACTIONS(3051),
    [anon_sym_while] = ACTIONS(3051),
    [anon_sym_if] = ACTIONS(3051),
    [anon_sym_fun] = ACTIONS(3051),
    [anon_sym_try] = ACTIONS(3051),
    [anon_sym_match] = ACTIONS(3051),
    [anon_sym_match_BANG] = ACTIONS(3053),
    [anon_sym_function] = ACTIONS(3051),
    [anon_sym_LT_DASH] = ACTIONS(3051),
    [anon_sym_DOT_LBRACK] = ACTIONS(3053),
    [anon_sym_LT] = ACTIONS(3053),
    [anon_sym_use] = ACTIONS(3051),
    [anon_sym_use_BANG] = ACTIONS(3053),
    [anon_sym_do_BANG] = ACTIONS(3053),
    [anon_sym_begin] = ACTIONS(3051),
    [anon_sym_LPAREN2] = ACTIONS(3051),
    [anon_sym_or] = ACTIONS(3051),
    [aux_sym_char_token1] = ACTIONS(3053),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3051),
    [anon_sym_DQUOTE] = ACTIONS(3051),
    [anon_sym_AT_DQUOTE] = ACTIONS(3053),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3053),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3053),
    [sym_bool] = ACTIONS(3051),
    [sym_unit] = ACTIONS(3053),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3051),
    [sym_op_identifier] = ACTIONS(3051),
    [anon_sym_PLUS] = ACTIONS(3051),
    [anon_sym_DASH] = ACTIONS(3051),
    [anon_sym_PLUS_DOT] = ACTIONS(3051),
    [anon_sym_DASH_DOT] = ACTIONS(3051),
    [anon_sym_PERCENT] = ACTIONS(3051),
    [anon_sym_AMP_AMP] = ACTIONS(3051),
    [anon_sym_TILDE] = ACTIONS(3053),
    [aux_sym_prefix_op_token1] = ACTIONS(3051),
    [aux_sym_infix_op_token1] = ACTIONS(3053),
    [aux_sym_infix_op_token2] = ACTIONS(3051),
    [anon_sym_PIPE_PIPE] = ACTIONS(3051),
    [anon_sym_BANG_EQ] = ACTIONS(3051),
    [anon_sym_COLON_EQ] = ACTIONS(3053),
    [anon_sym_DOLLAR] = ACTIONS(3051),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3051),
    [sym_int] = ACTIONS(3051),
    [sym_xint] = ACTIONS(3053),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3053),
    [sym__newline] = ACTIONS(3053),
  },
  [2317] = {
    [sym_block_comment] = STATE(2317),
    [sym_compiler_directive_decl] = STATE(2317),
    [sym_fsi_directive_decl] = STATE(2317),
    [sym_preproc_line] = STATE(2317),
    [sym_identifier] = ACTIONS(2863),
    [anon_sym_EQ] = ACTIONS(2865),
    [anon_sym_COLON] = ACTIONS(2863),
    [anon_sym_return] = ACTIONS(2863),
    [anon_sym_do] = ACTIONS(2863),
    [anon_sym_let] = ACTIONS(2863),
    [anon_sym_let_BANG] = ACTIONS(2865),
    [anon_sym_LPAREN] = ACTIONS(2863),
    [anon_sym_COMMA] = ACTIONS(2865),
    [anon_sym_null] = ACTIONS(2863),
    [anon_sym_QMARK] = ACTIONS(2863),
    [anon_sym_COLON_QMARK] = ACTIONS(2863),
    [anon_sym_COLON_COLON] = ACTIONS(2865),
    [anon_sym_AMP] = ACTIONS(2863),
    [anon_sym_LBRACK] = ACTIONS(2863),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2865),
    [anon_sym_LBRACE] = ACTIONS(2863),
    [anon_sym_LT_AT] = ACTIONS(2863),
    [anon_sym_LT_AT_AT] = ACTIONS(2863),
    [anon_sym_DOT] = ACTIONS(2863),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2865),
    [anon_sym_new] = ACTIONS(2863),
    [anon_sym_return_BANG] = ACTIONS(2865),
    [anon_sym_yield] = ACTIONS(2863),
    [anon_sym_yield_BANG] = ACTIONS(2865),
    [anon_sym_lazy] = ACTIONS(2863),
    [anon_sym_assert] = ACTIONS(2863),
    [anon_sym_upcast] = ACTIONS(2863),
    [anon_sym_downcast] = ACTIONS(2863),
    [anon_sym_COLON_GT] = ACTIONS(2865),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2865),
    [anon_sym_for] = ACTIONS(2863),
    [anon_sym_while] = ACTIONS(2863),
    [anon_sym_if] = ACTIONS(2863),
    [anon_sym_fun] = ACTIONS(2863),
    [anon_sym_try] = ACTIONS(2863),
    [anon_sym_match] = ACTIONS(2863),
    [anon_sym_match_BANG] = ACTIONS(2865),
    [anon_sym_function] = ACTIONS(2863),
    [anon_sym_LT_DASH] = ACTIONS(2863),
    [anon_sym_DOT_LBRACK] = ACTIONS(2865),
    [anon_sym_LT] = ACTIONS(2865),
    [anon_sym_GT] = ACTIONS(2863),
    [anon_sym_use] = ACTIONS(2863),
    [anon_sym_use_BANG] = ACTIONS(2865),
    [anon_sym_do_BANG] = ACTIONS(2865),
    [anon_sym_begin] = ACTIONS(2863),
    [anon_sym_LPAREN2] = ACTIONS(2863),
    [anon_sym_or] = ACTIONS(2863),
    [aux_sym_char_token1] = ACTIONS(2865),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2863),
    [anon_sym_DQUOTE] = ACTIONS(2863),
    [anon_sym_AT_DQUOTE] = ACTIONS(2865),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2865),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2865),
    [sym_bool] = ACTIONS(2863),
    [sym_unit] = ACTIONS(2865),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2863),
    [sym_op_identifier] = ACTIONS(2863),
    [anon_sym_PLUS] = ACTIONS(2863),
    [anon_sym_DASH] = ACTIONS(2863),
    [anon_sym_PLUS_DOT] = ACTIONS(2863),
    [anon_sym_DASH_DOT] = ACTIONS(2863),
    [anon_sym_PERCENT] = ACTIONS(2863),
    [anon_sym_AMP_AMP] = ACTIONS(2863),
    [anon_sym_TILDE] = ACTIONS(2865),
    [aux_sym_prefix_op_token1] = ACTIONS(2863),
    [aux_sym_infix_op_token1] = ACTIONS(2865),
    [aux_sym_infix_op_token2] = ACTIONS(2863),
    [anon_sym_PIPE_PIPE] = ACTIONS(2863),
    [anon_sym_BANG_EQ] = ACTIONS(2863),
    [anon_sym_COLON_EQ] = ACTIONS(2865),
    [anon_sym_DOLLAR] = ACTIONS(2863),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2863),
    [sym_int] = ACTIONS(2863),
    [sym_xint] = ACTIONS(2865),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2865),
    [sym__newline] = ACTIONS(2865),
  },
  [2318] = {
    [sym_block_comment] = STATE(2318),
    [sym_compiler_directive_decl] = STATE(2318),
    [sym_fsi_directive_decl] = STATE(2318),
    [sym_preproc_line] = STATE(2318),
    [sym_identifier] = ACTIONS(2942),
    [anon_sym_EQ] = ACTIONS(2944),
    [anon_sym_COLON] = ACTIONS(2942),
    [anon_sym_return] = ACTIONS(2942),
    [anon_sym_do] = ACTIONS(2942),
    [anon_sym_let] = ACTIONS(2942),
    [anon_sym_let_BANG] = ACTIONS(2944),
    [anon_sym_LPAREN] = ACTIONS(2942),
    [anon_sym_COMMA] = ACTIONS(2944),
    [anon_sym_null] = ACTIONS(2942),
    [anon_sym_QMARK] = ACTIONS(2942),
    [anon_sym_COLON_QMARK] = ACTIONS(2942),
    [anon_sym_COLON_COLON] = ACTIONS(2944),
    [anon_sym_AMP] = ACTIONS(2942),
    [anon_sym_LBRACK] = ACTIONS(2942),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2944),
    [anon_sym_LBRACE] = ACTIONS(2942),
    [anon_sym_LT_AT] = ACTIONS(2942),
    [anon_sym_AT_GT] = ACTIONS(2942),
    [anon_sym_LT_AT_AT] = ACTIONS(2942),
    [anon_sym_DOT] = ACTIONS(2942),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2944),
    [anon_sym_new] = ACTIONS(2942),
    [anon_sym_return_BANG] = ACTIONS(2944),
    [anon_sym_yield] = ACTIONS(2942),
    [anon_sym_yield_BANG] = ACTIONS(2944),
    [anon_sym_lazy] = ACTIONS(2942),
    [anon_sym_assert] = ACTIONS(2942),
    [anon_sym_upcast] = ACTIONS(2942),
    [anon_sym_downcast] = ACTIONS(2942),
    [anon_sym_COLON_GT] = ACTIONS(2944),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2944),
    [anon_sym_for] = ACTIONS(2942),
    [anon_sym_while] = ACTIONS(2942),
    [anon_sym_if] = ACTIONS(2942),
    [anon_sym_fun] = ACTIONS(2942),
    [anon_sym_try] = ACTIONS(2942),
    [anon_sym_match] = ACTIONS(2942),
    [anon_sym_match_BANG] = ACTIONS(2944),
    [anon_sym_function] = ACTIONS(2942),
    [anon_sym_LT_DASH] = ACTIONS(2942),
    [anon_sym_DOT_LBRACK] = ACTIONS(2944),
    [anon_sym_LT] = ACTIONS(2944),
    [anon_sym_use] = ACTIONS(2942),
    [anon_sym_use_BANG] = ACTIONS(2944),
    [anon_sym_do_BANG] = ACTIONS(2944),
    [anon_sym_begin] = ACTIONS(2942),
    [anon_sym_LPAREN2] = ACTIONS(2942),
    [anon_sym_or] = ACTIONS(2942),
    [aux_sym_char_token1] = ACTIONS(2944),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2942),
    [anon_sym_DQUOTE] = ACTIONS(2942),
    [anon_sym_AT_DQUOTE] = ACTIONS(2944),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2944),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2944),
    [sym_bool] = ACTIONS(2942),
    [sym_unit] = ACTIONS(2944),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2942),
    [sym_op_identifier] = ACTIONS(2942),
    [anon_sym_PLUS] = ACTIONS(2942),
    [anon_sym_DASH] = ACTIONS(2942),
    [anon_sym_PLUS_DOT] = ACTIONS(2942),
    [anon_sym_DASH_DOT] = ACTIONS(2942),
    [anon_sym_PERCENT] = ACTIONS(2942),
    [anon_sym_AMP_AMP] = ACTIONS(2942),
    [anon_sym_TILDE] = ACTIONS(2944),
    [aux_sym_prefix_op_token1] = ACTIONS(2942),
    [aux_sym_infix_op_token1] = ACTIONS(2944),
    [aux_sym_infix_op_token2] = ACTIONS(2942),
    [anon_sym_PIPE_PIPE] = ACTIONS(2942),
    [anon_sym_BANG_EQ] = ACTIONS(2942),
    [anon_sym_COLON_EQ] = ACTIONS(2944),
    [anon_sym_DOLLAR] = ACTIONS(2942),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2942),
    [sym_int] = ACTIONS(2942),
    [sym_xint] = ACTIONS(2944),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2944),
    [sym__newline] = ACTIONS(2944),
  },
  [2319] = {
    [sym_block_comment] = STATE(2319),
    [sym_compiler_directive_decl] = STATE(2319),
    [sym_fsi_directive_decl] = STATE(2319),
    [sym_preproc_line] = STATE(2319),
    [sym_identifier] = ACTIONS(3059),
    [anon_sym_EQ] = ACTIONS(3061),
    [anon_sym_COLON] = ACTIONS(3059),
    [anon_sym_return] = ACTIONS(3059),
    [anon_sym_do] = ACTIONS(3059),
    [anon_sym_let] = ACTIONS(3059),
    [anon_sym_let_BANG] = ACTIONS(3061),
    [anon_sym_LPAREN] = ACTIONS(3059),
    [anon_sym_COMMA] = ACTIONS(3061),
    [anon_sym_null] = ACTIONS(3059),
    [anon_sym_QMARK] = ACTIONS(3059),
    [anon_sym_COLON_QMARK] = ACTIONS(3059),
    [anon_sym_COLON_COLON] = ACTIONS(3061),
    [anon_sym_AMP] = ACTIONS(3059),
    [anon_sym_LBRACK] = ACTIONS(3059),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3061),
    [anon_sym_LBRACE] = ACTIONS(3059),
    [anon_sym_LT_AT] = ACTIONS(3059),
    [anon_sym_AT_GT] = ACTIONS(3059),
    [anon_sym_LT_AT_AT] = ACTIONS(3059),
    [anon_sym_DOT] = ACTIONS(3059),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3061),
    [anon_sym_new] = ACTIONS(3059),
    [anon_sym_return_BANG] = ACTIONS(3061),
    [anon_sym_yield] = ACTIONS(3059),
    [anon_sym_yield_BANG] = ACTIONS(3061),
    [anon_sym_lazy] = ACTIONS(3059),
    [anon_sym_assert] = ACTIONS(3059),
    [anon_sym_upcast] = ACTIONS(3059),
    [anon_sym_downcast] = ACTIONS(3059),
    [anon_sym_COLON_GT] = ACTIONS(3061),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3061),
    [anon_sym_for] = ACTIONS(3059),
    [anon_sym_while] = ACTIONS(3059),
    [anon_sym_if] = ACTIONS(3059),
    [anon_sym_fun] = ACTIONS(3059),
    [anon_sym_try] = ACTIONS(3059),
    [anon_sym_match] = ACTIONS(3059),
    [anon_sym_match_BANG] = ACTIONS(3061),
    [anon_sym_function] = ACTIONS(3059),
    [anon_sym_LT_DASH] = ACTIONS(3059),
    [anon_sym_DOT_LBRACK] = ACTIONS(3061),
    [anon_sym_LT] = ACTIONS(3061),
    [anon_sym_use] = ACTIONS(3059),
    [anon_sym_use_BANG] = ACTIONS(3061),
    [anon_sym_do_BANG] = ACTIONS(3061),
    [anon_sym_begin] = ACTIONS(3059),
    [anon_sym_LPAREN2] = ACTIONS(3059),
    [anon_sym_or] = ACTIONS(3059),
    [aux_sym_char_token1] = ACTIONS(3061),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3059),
    [anon_sym_DQUOTE] = ACTIONS(3059),
    [anon_sym_AT_DQUOTE] = ACTIONS(3061),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3061),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3061),
    [sym_bool] = ACTIONS(3059),
    [sym_unit] = ACTIONS(3061),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3059),
    [sym_op_identifier] = ACTIONS(3059),
    [anon_sym_PLUS] = ACTIONS(3059),
    [anon_sym_DASH] = ACTIONS(3059),
    [anon_sym_PLUS_DOT] = ACTIONS(3059),
    [anon_sym_DASH_DOT] = ACTIONS(3059),
    [anon_sym_PERCENT] = ACTIONS(3059),
    [anon_sym_AMP_AMP] = ACTIONS(3059),
    [anon_sym_TILDE] = ACTIONS(3061),
    [aux_sym_prefix_op_token1] = ACTIONS(3059),
    [aux_sym_infix_op_token1] = ACTIONS(3061),
    [aux_sym_infix_op_token2] = ACTIONS(3059),
    [anon_sym_PIPE_PIPE] = ACTIONS(3059),
    [anon_sym_BANG_EQ] = ACTIONS(3059),
    [anon_sym_COLON_EQ] = ACTIONS(3061),
    [anon_sym_DOLLAR] = ACTIONS(3059),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3059),
    [sym_int] = ACTIONS(3059),
    [sym_xint] = ACTIONS(3061),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3061),
    [sym__newline] = ACTIONS(3061),
  },
  [2320] = {
    [sym_block_comment] = STATE(2320),
    [sym_compiler_directive_decl] = STATE(2320),
    [sym_fsi_directive_decl] = STATE(2320),
    [sym_preproc_line] = STATE(2320),
    [sym_identifier] = ACTIONS(2411),
    [anon_sym_EQ] = ACTIONS(2413),
    [anon_sym_COLON] = ACTIONS(2411),
    [anon_sym_return] = ACTIONS(2411),
    [anon_sym_do] = ACTIONS(2411),
    [anon_sym_let] = ACTIONS(2411),
    [anon_sym_let_BANG] = ACTIONS(2413),
    [anon_sym_LPAREN] = ACTIONS(2411),
    [anon_sym_COMMA] = ACTIONS(2413),
    [anon_sym_null] = ACTIONS(2411),
    [anon_sym_QMARK] = ACTIONS(2411),
    [anon_sym_COLON_QMARK] = ACTIONS(2411),
    [anon_sym_COLON_COLON] = ACTIONS(2413),
    [anon_sym_AMP] = ACTIONS(2411),
    [anon_sym_LBRACK] = ACTIONS(2411),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2413),
    [anon_sym_LBRACE] = ACTIONS(2411),
    [anon_sym_LT_AT] = ACTIONS(2411),
    [anon_sym_LT_AT_AT] = ACTIONS(2411),
    [anon_sym_DOT] = ACTIONS(2411),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2413),
    [anon_sym_new] = ACTIONS(2411),
    [anon_sym_return_BANG] = ACTIONS(2413),
    [anon_sym_yield] = ACTIONS(2411),
    [anon_sym_yield_BANG] = ACTIONS(2413),
    [anon_sym_lazy] = ACTIONS(2411),
    [anon_sym_assert] = ACTIONS(2411),
    [anon_sym_upcast] = ACTIONS(2411),
    [anon_sym_downcast] = ACTIONS(2411),
    [anon_sym_COLON_GT] = ACTIONS(2413),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2413),
    [anon_sym_for] = ACTIONS(2411),
    [anon_sym_while] = ACTIONS(2411),
    [anon_sym_if] = ACTIONS(2411),
    [anon_sym_fun] = ACTIONS(2411),
    [anon_sym_try] = ACTIONS(2411),
    [anon_sym_match] = ACTIONS(2411),
    [anon_sym_match_BANG] = ACTIONS(2413),
    [anon_sym_function] = ACTIONS(2411),
    [anon_sym_LT_DASH] = ACTIONS(2411),
    [anon_sym_DOT_LBRACK] = ACTIONS(2413),
    [anon_sym_LT] = ACTIONS(2413),
    [anon_sym_use] = ACTIONS(2411),
    [anon_sym_use_BANG] = ACTIONS(2413),
    [anon_sym_do_BANG] = ACTIONS(2413),
    [anon_sym_begin] = ACTIONS(2411),
    [anon_sym_LPAREN2] = ACTIONS(2411),
    [anon_sym_or] = ACTIONS(2411),
    [aux_sym_char_token1] = ACTIONS(2413),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2411),
    [anon_sym_DQUOTE] = ACTIONS(2411),
    [anon_sym_AT_DQUOTE] = ACTIONS(2413),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2413),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2413),
    [sym_bool] = ACTIONS(2411),
    [sym_unit] = ACTIONS(2413),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2411),
    [sym_op_identifier] = ACTIONS(2411),
    [anon_sym_PLUS] = ACTIONS(2411),
    [anon_sym_DASH] = ACTIONS(2411),
    [anon_sym_PLUS_DOT] = ACTIONS(2411),
    [anon_sym_DASH_DOT] = ACTIONS(2411),
    [anon_sym_PERCENT] = ACTIONS(2411),
    [anon_sym_AMP_AMP] = ACTIONS(2411),
    [anon_sym_TILDE] = ACTIONS(2413),
    [aux_sym_prefix_op_token1] = ACTIONS(2411),
    [aux_sym_infix_op_token1] = ACTIONS(2413),
    [aux_sym_infix_op_token2] = ACTIONS(2411),
    [anon_sym_PIPE_PIPE] = ACTIONS(2411),
    [anon_sym_BANG_EQ] = ACTIONS(2411),
    [anon_sym_COLON_EQ] = ACTIONS(2413),
    [anon_sym_DOLLAR] = ACTIONS(2411),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2411),
    [sym_int] = ACTIONS(2411),
    [sym_xint] = ACTIONS(2413),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2413),
    [anon_sym_POUNDendif] = ACTIONS(2413),
    [sym__newline] = ACTIONS(2413),
  },
  [2321] = {
    [sym_block_comment] = STATE(2321),
    [sym_compiler_directive_decl] = STATE(2321),
    [sym_fsi_directive_decl] = STATE(2321),
    [sym_preproc_line] = STATE(2321),
    [sym_identifier] = ACTIONS(3063),
    [anon_sym_EQ] = ACTIONS(3065),
    [anon_sym_COLON] = ACTIONS(3063),
    [anon_sym_return] = ACTIONS(3063),
    [anon_sym_do] = ACTIONS(3063),
    [anon_sym_let] = ACTIONS(3063),
    [anon_sym_let_BANG] = ACTIONS(3065),
    [anon_sym_LPAREN] = ACTIONS(3063),
    [anon_sym_COMMA] = ACTIONS(3065),
    [anon_sym_null] = ACTIONS(3063),
    [anon_sym_QMARK] = ACTIONS(3063),
    [anon_sym_COLON_QMARK] = ACTIONS(3063),
    [anon_sym_COLON_COLON] = ACTIONS(3065),
    [anon_sym_AMP] = ACTIONS(3063),
    [anon_sym_LBRACK] = ACTIONS(3063),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3065),
    [anon_sym_LBRACE] = ACTIONS(3063),
    [anon_sym_LT_AT] = ACTIONS(3063),
    [anon_sym_AT_GT] = ACTIONS(3063),
    [anon_sym_LT_AT_AT] = ACTIONS(3063),
    [anon_sym_DOT] = ACTIONS(3063),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3065),
    [anon_sym_new] = ACTIONS(3063),
    [anon_sym_return_BANG] = ACTIONS(3065),
    [anon_sym_yield] = ACTIONS(3063),
    [anon_sym_yield_BANG] = ACTIONS(3065),
    [anon_sym_lazy] = ACTIONS(3063),
    [anon_sym_assert] = ACTIONS(3063),
    [anon_sym_upcast] = ACTIONS(3063),
    [anon_sym_downcast] = ACTIONS(3063),
    [anon_sym_COLON_GT] = ACTIONS(3065),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3065),
    [anon_sym_for] = ACTIONS(3063),
    [anon_sym_while] = ACTIONS(3063),
    [anon_sym_if] = ACTIONS(3063),
    [anon_sym_fun] = ACTIONS(3063),
    [anon_sym_try] = ACTIONS(3063),
    [anon_sym_match] = ACTIONS(3063),
    [anon_sym_match_BANG] = ACTIONS(3065),
    [anon_sym_function] = ACTIONS(3063),
    [anon_sym_LT_DASH] = ACTIONS(3063),
    [anon_sym_DOT_LBRACK] = ACTIONS(3065),
    [anon_sym_LT] = ACTIONS(3065),
    [anon_sym_use] = ACTIONS(3063),
    [anon_sym_use_BANG] = ACTIONS(3065),
    [anon_sym_do_BANG] = ACTIONS(3065),
    [anon_sym_begin] = ACTIONS(3063),
    [anon_sym_LPAREN2] = ACTIONS(3063),
    [anon_sym_or] = ACTIONS(3063),
    [aux_sym_char_token1] = ACTIONS(3065),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3063),
    [anon_sym_DQUOTE] = ACTIONS(3063),
    [anon_sym_AT_DQUOTE] = ACTIONS(3065),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3065),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3065),
    [sym_bool] = ACTIONS(3063),
    [sym_unit] = ACTIONS(3065),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3063),
    [sym_op_identifier] = ACTIONS(3063),
    [anon_sym_PLUS] = ACTIONS(3063),
    [anon_sym_DASH] = ACTIONS(3063),
    [anon_sym_PLUS_DOT] = ACTIONS(3063),
    [anon_sym_DASH_DOT] = ACTIONS(3063),
    [anon_sym_PERCENT] = ACTIONS(3063),
    [anon_sym_AMP_AMP] = ACTIONS(3063),
    [anon_sym_TILDE] = ACTIONS(3065),
    [aux_sym_prefix_op_token1] = ACTIONS(3063),
    [aux_sym_infix_op_token1] = ACTIONS(3065),
    [aux_sym_infix_op_token2] = ACTIONS(3063),
    [anon_sym_PIPE_PIPE] = ACTIONS(3063),
    [anon_sym_BANG_EQ] = ACTIONS(3063),
    [anon_sym_COLON_EQ] = ACTIONS(3065),
    [anon_sym_DOLLAR] = ACTIONS(3063),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3063),
    [sym_int] = ACTIONS(3063),
    [sym_xint] = ACTIONS(3065),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3065),
    [sym__newline] = ACTIONS(3065),
  },
  [2322] = {
    [sym_block_comment] = STATE(2322),
    [sym_compiler_directive_decl] = STATE(2322),
    [sym_fsi_directive_decl] = STATE(2322),
    [sym_preproc_line] = STATE(2322),
    [sym_identifier] = ACTIONS(3079),
    [anon_sym_EQ] = ACTIONS(3081),
    [anon_sym_COLON] = ACTIONS(3079),
    [anon_sym_return] = ACTIONS(3079),
    [anon_sym_do] = ACTIONS(3079),
    [anon_sym_let] = ACTIONS(3079),
    [anon_sym_let_BANG] = ACTIONS(3081),
    [anon_sym_LPAREN] = ACTIONS(3079),
    [anon_sym_COMMA] = ACTIONS(3081),
    [anon_sym_null] = ACTIONS(3079),
    [anon_sym_QMARK] = ACTIONS(3079),
    [anon_sym_COLON_QMARK] = ACTIONS(3079),
    [anon_sym_COLON_COLON] = ACTIONS(3081),
    [anon_sym_AMP] = ACTIONS(3079),
    [anon_sym_LBRACK] = ACTIONS(3079),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3081),
    [anon_sym_LBRACE] = ACTIONS(3079),
    [anon_sym_LT_AT] = ACTIONS(3079),
    [anon_sym_AT_GT] = ACTIONS(3079),
    [anon_sym_LT_AT_AT] = ACTIONS(3079),
    [anon_sym_DOT] = ACTIONS(3079),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3081),
    [anon_sym_new] = ACTIONS(3079),
    [anon_sym_return_BANG] = ACTIONS(3081),
    [anon_sym_yield] = ACTIONS(3079),
    [anon_sym_yield_BANG] = ACTIONS(3081),
    [anon_sym_lazy] = ACTIONS(3079),
    [anon_sym_assert] = ACTIONS(3079),
    [anon_sym_upcast] = ACTIONS(3079),
    [anon_sym_downcast] = ACTIONS(3079),
    [anon_sym_COLON_GT] = ACTIONS(3081),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3081),
    [anon_sym_for] = ACTIONS(3079),
    [anon_sym_while] = ACTIONS(3079),
    [anon_sym_if] = ACTIONS(3079),
    [anon_sym_fun] = ACTIONS(3079),
    [anon_sym_try] = ACTIONS(3079),
    [anon_sym_match] = ACTIONS(3079),
    [anon_sym_match_BANG] = ACTIONS(3081),
    [anon_sym_function] = ACTIONS(3079),
    [anon_sym_LT_DASH] = ACTIONS(3079),
    [anon_sym_DOT_LBRACK] = ACTIONS(3081),
    [anon_sym_LT] = ACTIONS(3081),
    [anon_sym_use] = ACTIONS(3079),
    [anon_sym_use_BANG] = ACTIONS(3081),
    [anon_sym_do_BANG] = ACTIONS(3081),
    [anon_sym_begin] = ACTIONS(3079),
    [anon_sym_LPAREN2] = ACTIONS(3079),
    [anon_sym_or] = ACTIONS(3079),
    [aux_sym_char_token1] = ACTIONS(3081),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3079),
    [anon_sym_DQUOTE] = ACTIONS(3079),
    [anon_sym_AT_DQUOTE] = ACTIONS(3081),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3081),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3081),
    [sym_bool] = ACTIONS(3079),
    [sym_unit] = ACTIONS(3081),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3079),
    [sym_op_identifier] = ACTIONS(3079),
    [anon_sym_PLUS] = ACTIONS(3079),
    [anon_sym_DASH] = ACTIONS(3079),
    [anon_sym_PLUS_DOT] = ACTIONS(3079),
    [anon_sym_DASH_DOT] = ACTIONS(3079),
    [anon_sym_PERCENT] = ACTIONS(3079),
    [anon_sym_AMP_AMP] = ACTIONS(3079),
    [anon_sym_TILDE] = ACTIONS(3081),
    [aux_sym_prefix_op_token1] = ACTIONS(3079),
    [aux_sym_infix_op_token1] = ACTIONS(3081),
    [aux_sym_infix_op_token2] = ACTIONS(3079),
    [anon_sym_PIPE_PIPE] = ACTIONS(3079),
    [anon_sym_BANG_EQ] = ACTIONS(3079),
    [anon_sym_COLON_EQ] = ACTIONS(3081),
    [anon_sym_DOLLAR] = ACTIONS(3079),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3079),
    [sym_int] = ACTIONS(3079),
    [sym_xint] = ACTIONS(3081),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3081),
    [sym__newline] = ACTIONS(3081),
  },
  [2323] = {
    [sym_block_comment] = STATE(2323),
    [sym_compiler_directive_decl] = STATE(2323),
    [sym_fsi_directive_decl] = STATE(2323),
    [sym_preproc_line] = STATE(2323),
    [sym_identifier] = ACTIONS(3083),
    [anon_sym_EQ] = ACTIONS(3085),
    [anon_sym_COLON] = ACTIONS(3083),
    [anon_sym_return] = ACTIONS(3083),
    [anon_sym_do] = ACTIONS(3083),
    [anon_sym_let] = ACTIONS(3083),
    [anon_sym_let_BANG] = ACTIONS(3085),
    [anon_sym_LPAREN] = ACTIONS(3083),
    [anon_sym_COMMA] = ACTIONS(3085),
    [anon_sym_null] = ACTIONS(3083),
    [anon_sym_QMARK] = ACTIONS(3083),
    [anon_sym_COLON_QMARK] = ACTIONS(3083),
    [anon_sym_COLON_COLON] = ACTIONS(3085),
    [anon_sym_AMP] = ACTIONS(3083),
    [anon_sym_LBRACK] = ACTIONS(3083),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3085),
    [anon_sym_LBRACE] = ACTIONS(3083),
    [anon_sym_LT_AT] = ACTIONS(3083),
    [anon_sym_AT_GT] = ACTIONS(3083),
    [anon_sym_LT_AT_AT] = ACTIONS(3083),
    [anon_sym_DOT] = ACTIONS(3083),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3085),
    [anon_sym_new] = ACTIONS(3083),
    [anon_sym_return_BANG] = ACTIONS(3085),
    [anon_sym_yield] = ACTIONS(3083),
    [anon_sym_yield_BANG] = ACTIONS(3085),
    [anon_sym_lazy] = ACTIONS(3083),
    [anon_sym_assert] = ACTIONS(3083),
    [anon_sym_upcast] = ACTIONS(3083),
    [anon_sym_downcast] = ACTIONS(3083),
    [anon_sym_COLON_GT] = ACTIONS(3085),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3085),
    [anon_sym_for] = ACTIONS(3083),
    [anon_sym_while] = ACTIONS(3083),
    [anon_sym_if] = ACTIONS(3083),
    [anon_sym_fun] = ACTIONS(3083),
    [anon_sym_try] = ACTIONS(3083),
    [anon_sym_match] = ACTIONS(3083),
    [anon_sym_match_BANG] = ACTIONS(3085),
    [anon_sym_function] = ACTIONS(3083),
    [anon_sym_LT_DASH] = ACTIONS(3083),
    [anon_sym_DOT_LBRACK] = ACTIONS(3085),
    [anon_sym_LT] = ACTIONS(3085),
    [anon_sym_use] = ACTIONS(3083),
    [anon_sym_use_BANG] = ACTIONS(3085),
    [anon_sym_do_BANG] = ACTIONS(3085),
    [anon_sym_begin] = ACTIONS(3083),
    [anon_sym_LPAREN2] = ACTIONS(3083),
    [anon_sym_or] = ACTIONS(3083),
    [aux_sym_char_token1] = ACTIONS(3085),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3083),
    [anon_sym_DQUOTE] = ACTIONS(3083),
    [anon_sym_AT_DQUOTE] = ACTIONS(3085),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3085),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3085),
    [sym_bool] = ACTIONS(3083),
    [sym_unit] = ACTIONS(3085),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3083),
    [sym_op_identifier] = ACTIONS(3083),
    [anon_sym_PLUS] = ACTIONS(3083),
    [anon_sym_DASH] = ACTIONS(3083),
    [anon_sym_PLUS_DOT] = ACTIONS(3083),
    [anon_sym_DASH_DOT] = ACTIONS(3083),
    [anon_sym_PERCENT] = ACTIONS(3083),
    [anon_sym_AMP_AMP] = ACTIONS(3083),
    [anon_sym_TILDE] = ACTIONS(3085),
    [aux_sym_prefix_op_token1] = ACTIONS(3083),
    [aux_sym_infix_op_token1] = ACTIONS(3085),
    [aux_sym_infix_op_token2] = ACTIONS(3083),
    [anon_sym_PIPE_PIPE] = ACTIONS(3083),
    [anon_sym_BANG_EQ] = ACTIONS(3083),
    [anon_sym_COLON_EQ] = ACTIONS(3085),
    [anon_sym_DOLLAR] = ACTIONS(3083),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3083),
    [sym_int] = ACTIONS(3083),
    [sym_xint] = ACTIONS(3085),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3085),
    [sym__newline] = ACTIONS(3085),
  },
  [2324] = {
    [sym_block_comment] = STATE(2324),
    [sym_compiler_directive_decl] = STATE(2324),
    [sym_fsi_directive_decl] = STATE(2324),
    [sym_preproc_line] = STATE(2324),
    [sym_identifier] = ACTIONS(2988),
    [anon_sym_EQ] = ACTIONS(2990),
    [anon_sym_COLON] = ACTIONS(2988),
    [anon_sym_return] = ACTIONS(2988),
    [anon_sym_do] = ACTIONS(2988),
    [anon_sym_let] = ACTIONS(2988),
    [anon_sym_let_BANG] = ACTIONS(2990),
    [anon_sym_LPAREN] = ACTIONS(2988),
    [anon_sym_COMMA] = ACTIONS(2990),
    [anon_sym_null] = ACTIONS(2988),
    [anon_sym_QMARK] = ACTIONS(2988),
    [anon_sym_COLON_QMARK] = ACTIONS(2988),
    [anon_sym_COLON_COLON] = ACTIONS(2990),
    [anon_sym_AMP] = ACTIONS(2988),
    [anon_sym_LBRACK] = ACTIONS(2988),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2990),
    [anon_sym_LBRACE] = ACTIONS(2988),
    [anon_sym_LT_AT] = ACTIONS(2988),
    [anon_sym_LT_AT_AT] = ACTIONS(2988),
    [anon_sym_DOT] = ACTIONS(2988),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2990),
    [anon_sym_new] = ACTIONS(2988),
    [anon_sym_return_BANG] = ACTIONS(2990),
    [anon_sym_yield] = ACTIONS(2988),
    [anon_sym_yield_BANG] = ACTIONS(2990),
    [anon_sym_lazy] = ACTIONS(2988),
    [anon_sym_assert] = ACTIONS(2988),
    [anon_sym_upcast] = ACTIONS(2988),
    [anon_sym_downcast] = ACTIONS(2988),
    [anon_sym_COLON_GT] = ACTIONS(2990),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2990),
    [anon_sym_for] = ACTIONS(2988),
    [anon_sym_while] = ACTIONS(2988),
    [anon_sym_if] = ACTIONS(2988),
    [anon_sym_fun] = ACTIONS(2988),
    [anon_sym_try] = ACTIONS(2988),
    [anon_sym_match] = ACTIONS(2988),
    [anon_sym_match_BANG] = ACTIONS(2990),
    [anon_sym_function] = ACTIONS(2988),
    [anon_sym_LT_DASH] = ACTIONS(2988),
    [anon_sym_DOT_LBRACK] = ACTIONS(2990),
    [anon_sym_LT] = ACTIONS(2990),
    [anon_sym_use] = ACTIONS(2988),
    [anon_sym_use_BANG] = ACTIONS(2990),
    [anon_sym_do_BANG] = ACTIONS(2990),
    [anon_sym_DOT_DOT] = ACTIONS(2990),
    [anon_sym_begin] = ACTIONS(2988),
    [anon_sym_LPAREN2] = ACTIONS(2988),
    [anon_sym_or] = ACTIONS(2988),
    [aux_sym_char_token1] = ACTIONS(2990),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2988),
    [anon_sym_DQUOTE] = ACTIONS(2988),
    [anon_sym_AT_DQUOTE] = ACTIONS(2990),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2990),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2990),
    [sym_bool] = ACTIONS(2988),
    [sym_unit] = ACTIONS(2990),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2988),
    [sym_op_identifier] = ACTIONS(2988),
    [anon_sym_PLUS] = ACTIONS(2988),
    [anon_sym_DASH] = ACTIONS(2988),
    [anon_sym_PLUS_DOT] = ACTIONS(2988),
    [anon_sym_DASH_DOT] = ACTIONS(2988),
    [anon_sym_PERCENT] = ACTIONS(2988),
    [anon_sym_AMP_AMP] = ACTIONS(2988),
    [anon_sym_TILDE] = ACTIONS(2990),
    [aux_sym_prefix_op_token1] = ACTIONS(2988),
    [aux_sym_infix_op_token1] = ACTIONS(2990),
    [aux_sym_infix_op_token2] = ACTIONS(2988),
    [anon_sym_PIPE_PIPE] = ACTIONS(2988),
    [anon_sym_BANG_EQ] = ACTIONS(2988),
    [anon_sym_COLON_EQ] = ACTIONS(2990),
    [anon_sym_DOLLAR] = ACTIONS(2988),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2988),
    [sym_int] = ACTIONS(2988),
    [sym_xint] = ACTIONS(2990),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2990),
    [sym__newline] = ACTIONS(2990),
  },
  [2325] = {
    [sym_block_comment] = STATE(2325),
    [sym_compiler_directive_decl] = STATE(2325),
    [sym_fsi_directive_decl] = STATE(2325),
    [sym_preproc_line] = STATE(2325),
    [sym_identifier] = ACTIONS(3099),
    [anon_sym_EQ] = ACTIONS(3101),
    [anon_sym_COLON] = ACTIONS(3099),
    [anon_sym_return] = ACTIONS(3099),
    [anon_sym_do] = ACTIONS(3099),
    [anon_sym_let] = ACTIONS(3099),
    [anon_sym_let_BANG] = ACTIONS(3101),
    [anon_sym_LPAREN] = ACTIONS(3099),
    [anon_sym_COMMA] = ACTIONS(3101),
    [anon_sym_null] = ACTIONS(3099),
    [anon_sym_QMARK] = ACTIONS(3099),
    [anon_sym_COLON_QMARK] = ACTIONS(3099),
    [anon_sym_COLON_COLON] = ACTIONS(3101),
    [anon_sym_AMP] = ACTIONS(3099),
    [anon_sym_LBRACK] = ACTIONS(3099),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3101),
    [anon_sym_LBRACE] = ACTIONS(3099),
    [anon_sym_LT_AT] = ACTIONS(3099),
    [anon_sym_AT_GT] = ACTIONS(3099),
    [anon_sym_LT_AT_AT] = ACTIONS(3099),
    [anon_sym_DOT] = ACTIONS(3099),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3101),
    [anon_sym_new] = ACTIONS(3099),
    [anon_sym_return_BANG] = ACTIONS(3101),
    [anon_sym_yield] = ACTIONS(3099),
    [anon_sym_yield_BANG] = ACTIONS(3101),
    [anon_sym_lazy] = ACTIONS(3099),
    [anon_sym_assert] = ACTIONS(3099),
    [anon_sym_upcast] = ACTIONS(3099),
    [anon_sym_downcast] = ACTIONS(3099),
    [anon_sym_COLON_GT] = ACTIONS(3101),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3101),
    [anon_sym_for] = ACTIONS(3099),
    [anon_sym_while] = ACTIONS(3099),
    [anon_sym_if] = ACTIONS(3099),
    [anon_sym_fun] = ACTIONS(3099),
    [anon_sym_try] = ACTIONS(3099),
    [anon_sym_match] = ACTIONS(3099),
    [anon_sym_match_BANG] = ACTIONS(3101),
    [anon_sym_function] = ACTIONS(3099),
    [anon_sym_LT_DASH] = ACTIONS(3099),
    [anon_sym_DOT_LBRACK] = ACTIONS(3101),
    [anon_sym_LT] = ACTIONS(3101),
    [anon_sym_use] = ACTIONS(3099),
    [anon_sym_use_BANG] = ACTIONS(3101),
    [anon_sym_do_BANG] = ACTIONS(3101),
    [anon_sym_begin] = ACTIONS(3099),
    [anon_sym_LPAREN2] = ACTIONS(3099),
    [anon_sym_or] = ACTIONS(3099),
    [aux_sym_char_token1] = ACTIONS(3101),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3099),
    [anon_sym_DQUOTE] = ACTIONS(3099),
    [anon_sym_AT_DQUOTE] = ACTIONS(3101),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3101),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3101),
    [sym_bool] = ACTIONS(3099),
    [sym_unit] = ACTIONS(3101),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3099),
    [sym_op_identifier] = ACTIONS(3099),
    [anon_sym_PLUS] = ACTIONS(3099),
    [anon_sym_DASH] = ACTIONS(3099),
    [anon_sym_PLUS_DOT] = ACTIONS(3099),
    [anon_sym_DASH_DOT] = ACTIONS(3099),
    [anon_sym_PERCENT] = ACTIONS(3099),
    [anon_sym_AMP_AMP] = ACTIONS(3099),
    [anon_sym_TILDE] = ACTIONS(3101),
    [aux_sym_prefix_op_token1] = ACTIONS(3099),
    [aux_sym_infix_op_token1] = ACTIONS(3101),
    [aux_sym_infix_op_token2] = ACTIONS(3099),
    [anon_sym_PIPE_PIPE] = ACTIONS(3099),
    [anon_sym_BANG_EQ] = ACTIONS(3099),
    [anon_sym_COLON_EQ] = ACTIONS(3101),
    [anon_sym_DOLLAR] = ACTIONS(3099),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3099),
    [sym_int] = ACTIONS(3099),
    [sym_xint] = ACTIONS(3101),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3101),
    [sym__newline] = ACTIONS(3101),
  },
  [2326] = {
    [sym_block_comment] = STATE(2326),
    [sym_compiler_directive_decl] = STATE(2326),
    [sym_fsi_directive_decl] = STATE(2326),
    [sym_preproc_line] = STATE(2326),
    [sym_identifier] = ACTIONS(2887),
    [anon_sym_EQ] = ACTIONS(2889),
    [anon_sym_COLON] = ACTIONS(2887),
    [anon_sym_return] = ACTIONS(2887),
    [anon_sym_do] = ACTIONS(2887),
    [anon_sym_let] = ACTIONS(2887),
    [anon_sym_let_BANG] = ACTIONS(2889),
    [anon_sym_LPAREN] = ACTIONS(2887),
    [anon_sym_COMMA] = ACTIONS(2889),
    [anon_sym_null] = ACTIONS(2887),
    [anon_sym_QMARK] = ACTIONS(2887),
    [anon_sym_COLON_QMARK] = ACTIONS(2887),
    [anon_sym_COLON_COLON] = ACTIONS(2889),
    [anon_sym_AMP] = ACTIONS(2887),
    [anon_sym_LBRACK] = ACTIONS(2887),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2889),
    [anon_sym_LBRACE] = ACTIONS(2887),
    [anon_sym_LT_AT] = ACTIONS(2887),
    [anon_sym_LT_AT_AT] = ACTIONS(2887),
    [anon_sym_AT_AT_GT] = ACTIONS(2887),
    [anon_sym_DOT] = ACTIONS(2887),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2889),
    [anon_sym_new] = ACTIONS(2887),
    [anon_sym_return_BANG] = ACTIONS(2889),
    [anon_sym_yield] = ACTIONS(2887),
    [anon_sym_yield_BANG] = ACTIONS(2889),
    [anon_sym_lazy] = ACTIONS(2887),
    [anon_sym_assert] = ACTIONS(2887),
    [anon_sym_upcast] = ACTIONS(2887),
    [anon_sym_downcast] = ACTIONS(2887),
    [anon_sym_COLON_GT] = ACTIONS(2889),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2889),
    [anon_sym_for] = ACTIONS(2887),
    [anon_sym_while] = ACTIONS(2887),
    [anon_sym_if] = ACTIONS(2887),
    [anon_sym_fun] = ACTIONS(2887),
    [anon_sym_try] = ACTIONS(2887),
    [anon_sym_match] = ACTIONS(2887),
    [anon_sym_match_BANG] = ACTIONS(2889),
    [anon_sym_function] = ACTIONS(2887),
    [anon_sym_LT_DASH] = ACTIONS(2887),
    [anon_sym_DOT_LBRACK] = ACTIONS(2889),
    [anon_sym_LT] = ACTIONS(2889),
    [anon_sym_use] = ACTIONS(2887),
    [anon_sym_use_BANG] = ACTIONS(2889),
    [anon_sym_do_BANG] = ACTIONS(2889),
    [anon_sym_begin] = ACTIONS(2887),
    [anon_sym_LPAREN2] = ACTIONS(2887),
    [anon_sym_or] = ACTIONS(2887),
    [aux_sym_char_token1] = ACTIONS(2889),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2887),
    [anon_sym_DQUOTE] = ACTIONS(2887),
    [anon_sym_AT_DQUOTE] = ACTIONS(2889),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2889),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2889),
    [sym_bool] = ACTIONS(2887),
    [sym_unit] = ACTIONS(2889),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2887),
    [sym_op_identifier] = ACTIONS(2887),
    [anon_sym_PLUS] = ACTIONS(2887),
    [anon_sym_DASH] = ACTIONS(2887),
    [anon_sym_PLUS_DOT] = ACTIONS(2887),
    [anon_sym_DASH_DOT] = ACTIONS(2887),
    [anon_sym_PERCENT] = ACTIONS(2887),
    [anon_sym_AMP_AMP] = ACTIONS(2887),
    [anon_sym_TILDE] = ACTIONS(2889),
    [aux_sym_prefix_op_token1] = ACTIONS(2887),
    [aux_sym_infix_op_token1] = ACTIONS(2889),
    [aux_sym_infix_op_token2] = ACTIONS(2887),
    [anon_sym_PIPE_PIPE] = ACTIONS(2887),
    [anon_sym_BANG_EQ] = ACTIONS(2887),
    [anon_sym_COLON_EQ] = ACTIONS(2889),
    [anon_sym_DOLLAR] = ACTIONS(2887),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2887),
    [sym_int] = ACTIONS(2887),
    [sym_xint] = ACTIONS(2889),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2889),
    [sym__newline] = ACTIONS(2889),
  },
  [2327] = {
    [sym_block_comment] = STATE(2327),
    [sym_compiler_directive_decl] = STATE(2327),
    [sym_fsi_directive_decl] = STATE(2327),
    [sym_preproc_line] = STATE(2327),
    [sym_identifier] = ACTIONS(2891),
    [anon_sym_EQ] = ACTIONS(2893),
    [anon_sym_COLON] = ACTIONS(2891),
    [anon_sym_return] = ACTIONS(2891),
    [anon_sym_do] = ACTIONS(2891),
    [anon_sym_let] = ACTIONS(2891),
    [anon_sym_let_BANG] = ACTIONS(2893),
    [anon_sym_LPAREN] = ACTIONS(2891),
    [anon_sym_COMMA] = ACTIONS(2893),
    [anon_sym_null] = ACTIONS(2891),
    [anon_sym_QMARK] = ACTIONS(2891),
    [anon_sym_COLON_QMARK] = ACTIONS(2891),
    [anon_sym_COLON_COLON] = ACTIONS(2893),
    [anon_sym_AMP] = ACTIONS(2891),
    [anon_sym_LBRACK] = ACTIONS(2891),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2893),
    [anon_sym_LBRACE] = ACTIONS(2891),
    [anon_sym_LT_AT] = ACTIONS(2891),
    [anon_sym_LT_AT_AT] = ACTIONS(2891),
    [anon_sym_AT_AT_GT] = ACTIONS(2891),
    [anon_sym_DOT] = ACTIONS(2891),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2893),
    [anon_sym_new] = ACTIONS(2891),
    [anon_sym_return_BANG] = ACTIONS(2893),
    [anon_sym_yield] = ACTIONS(2891),
    [anon_sym_yield_BANG] = ACTIONS(2893),
    [anon_sym_lazy] = ACTIONS(2891),
    [anon_sym_assert] = ACTIONS(2891),
    [anon_sym_upcast] = ACTIONS(2891),
    [anon_sym_downcast] = ACTIONS(2891),
    [anon_sym_COLON_GT] = ACTIONS(2893),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2893),
    [anon_sym_for] = ACTIONS(2891),
    [anon_sym_while] = ACTIONS(2891),
    [anon_sym_if] = ACTIONS(2891),
    [anon_sym_fun] = ACTIONS(2891),
    [anon_sym_try] = ACTIONS(2891),
    [anon_sym_match] = ACTIONS(2891),
    [anon_sym_match_BANG] = ACTIONS(2893),
    [anon_sym_function] = ACTIONS(2891),
    [anon_sym_LT_DASH] = ACTIONS(2891),
    [anon_sym_DOT_LBRACK] = ACTIONS(2893),
    [anon_sym_LT] = ACTIONS(2893),
    [anon_sym_use] = ACTIONS(2891),
    [anon_sym_use_BANG] = ACTIONS(2893),
    [anon_sym_do_BANG] = ACTIONS(2893),
    [anon_sym_begin] = ACTIONS(2891),
    [anon_sym_LPAREN2] = ACTIONS(2891),
    [anon_sym_or] = ACTIONS(2891),
    [aux_sym_char_token1] = ACTIONS(2893),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2891),
    [anon_sym_DQUOTE] = ACTIONS(2891),
    [anon_sym_AT_DQUOTE] = ACTIONS(2893),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2893),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2893),
    [sym_bool] = ACTIONS(2891),
    [sym_unit] = ACTIONS(2893),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2891),
    [sym_op_identifier] = ACTIONS(2891),
    [anon_sym_PLUS] = ACTIONS(2891),
    [anon_sym_DASH] = ACTIONS(2891),
    [anon_sym_PLUS_DOT] = ACTIONS(2891),
    [anon_sym_DASH_DOT] = ACTIONS(2891),
    [anon_sym_PERCENT] = ACTIONS(2891),
    [anon_sym_AMP_AMP] = ACTIONS(2891),
    [anon_sym_TILDE] = ACTIONS(2893),
    [aux_sym_prefix_op_token1] = ACTIONS(2891),
    [aux_sym_infix_op_token1] = ACTIONS(2893),
    [aux_sym_infix_op_token2] = ACTIONS(2891),
    [anon_sym_PIPE_PIPE] = ACTIONS(2891),
    [anon_sym_BANG_EQ] = ACTIONS(2891),
    [anon_sym_COLON_EQ] = ACTIONS(2893),
    [anon_sym_DOLLAR] = ACTIONS(2891),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2891),
    [sym_int] = ACTIONS(2891),
    [sym_xint] = ACTIONS(2893),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2893),
    [sym__newline] = ACTIONS(2893),
  },
  [2328] = {
    [sym_block_comment] = STATE(2328),
    [sym_compiler_directive_decl] = STATE(2328),
    [sym_fsi_directive_decl] = STATE(2328),
    [sym_preproc_line] = STATE(2328),
    [sym_identifier] = ACTIONS(2910),
    [anon_sym_EQ] = ACTIONS(2912),
    [anon_sym_COLON] = ACTIONS(2910),
    [anon_sym_return] = ACTIONS(2910),
    [anon_sym_do] = ACTIONS(2910),
    [anon_sym_let] = ACTIONS(2910),
    [anon_sym_let_BANG] = ACTIONS(2912),
    [anon_sym_LPAREN] = ACTIONS(2910),
    [anon_sym_COMMA] = ACTIONS(2912),
    [anon_sym_null] = ACTIONS(2910),
    [anon_sym_QMARK] = ACTIONS(2910),
    [anon_sym_COLON_QMARK] = ACTIONS(2910),
    [anon_sym_COLON_COLON] = ACTIONS(2912),
    [anon_sym_AMP] = ACTIONS(2910),
    [anon_sym_LBRACK] = ACTIONS(2910),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2912),
    [anon_sym_LBRACE] = ACTIONS(2910),
    [anon_sym_LT_AT] = ACTIONS(2910),
    [anon_sym_LT_AT_AT] = ACTIONS(2910),
    [anon_sym_AT_AT_GT] = ACTIONS(2910),
    [anon_sym_DOT] = ACTIONS(2910),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2912),
    [anon_sym_new] = ACTIONS(2910),
    [anon_sym_return_BANG] = ACTIONS(2912),
    [anon_sym_yield] = ACTIONS(2910),
    [anon_sym_yield_BANG] = ACTIONS(2912),
    [anon_sym_lazy] = ACTIONS(2910),
    [anon_sym_assert] = ACTIONS(2910),
    [anon_sym_upcast] = ACTIONS(2910),
    [anon_sym_downcast] = ACTIONS(2910),
    [anon_sym_COLON_GT] = ACTIONS(2912),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2912),
    [anon_sym_for] = ACTIONS(2910),
    [anon_sym_while] = ACTIONS(2910),
    [anon_sym_if] = ACTIONS(2910),
    [anon_sym_fun] = ACTIONS(2910),
    [anon_sym_try] = ACTIONS(2910),
    [anon_sym_match] = ACTIONS(2910),
    [anon_sym_match_BANG] = ACTIONS(2912),
    [anon_sym_function] = ACTIONS(2910),
    [anon_sym_LT_DASH] = ACTIONS(2910),
    [anon_sym_DOT_LBRACK] = ACTIONS(2912),
    [anon_sym_LT] = ACTIONS(2912),
    [anon_sym_use] = ACTIONS(2910),
    [anon_sym_use_BANG] = ACTIONS(2912),
    [anon_sym_do_BANG] = ACTIONS(2912),
    [anon_sym_begin] = ACTIONS(2910),
    [anon_sym_LPAREN2] = ACTIONS(2910),
    [anon_sym_or] = ACTIONS(2910),
    [aux_sym_char_token1] = ACTIONS(2912),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2910),
    [anon_sym_DQUOTE] = ACTIONS(2910),
    [anon_sym_AT_DQUOTE] = ACTIONS(2912),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2912),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2912),
    [sym_bool] = ACTIONS(2910),
    [sym_unit] = ACTIONS(2912),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2910),
    [sym_op_identifier] = ACTIONS(2910),
    [anon_sym_PLUS] = ACTIONS(2910),
    [anon_sym_DASH] = ACTIONS(2910),
    [anon_sym_PLUS_DOT] = ACTIONS(2910),
    [anon_sym_DASH_DOT] = ACTIONS(2910),
    [anon_sym_PERCENT] = ACTIONS(2910),
    [anon_sym_AMP_AMP] = ACTIONS(2910),
    [anon_sym_TILDE] = ACTIONS(2912),
    [aux_sym_prefix_op_token1] = ACTIONS(2910),
    [aux_sym_infix_op_token1] = ACTIONS(2912),
    [aux_sym_infix_op_token2] = ACTIONS(2910),
    [anon_sym_PIPE_PIPE] = ACTIONS(2910),
    [anon_sym_BANG_EQ] = ACTIONS(2910),
    [anon_sym_COLON_EQ] = ACTIONS(2912),
    [anon_sym_DOLLAR] = ACTIONS(2910),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2910),
    [sym_int] = ACTIONS(2910),
    [sym_xint] = ACTIONS(2912),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2912),
    [sym__newline] = ACTIONS(2912),
  },
  [2329] = {
    [sym_block_comment] = STATE(2329),
    [sym_compiler_directive_decl] = STATE(2329),
    [sym_fsi_directive_decl] = STATE(2329),
    [sym_preproc_line] = STATE(2329),
    [sym_identifier] = ACTIONS(2411),
    [anon_sym_EQ] = ACTIONS(2413),
    [anon_sym_COLON] = ACTIONS(2411),
    [anon_sym_return] = ACTIONS(2411),
    [anon_sym_do] = ACTIONS(2411),
    [anon_sym_let] = ACTIONS(2411),
    [anon_sym_let_BANG] = ACTIONS(2413),
    [anon_sym_LPAREN] = ACTIONS(2411),
    [anon_sym_COMMA] = ACTIONS(2413),
    [anon_sym_null] = ACTIONS(2411),
    [anon_sym_QMARK] = ACTIONS(2411),
    [anon_sym_COLON_QMARK] = ACTIONS(2411),
    [anon_sym_COLON_COLON] = ACTIONS(2413),
    [anon_sym_AMP] = ACTIONS(2411),
    [anon_sym_LBRACK] = ACTIONS(2411),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2413),
    [anon_sym_LBRACE] = ACTIONS(2411),
    [anon_sym_LT_AT] = ACTIONS(2411),
    [anon_sym_LT_AT_AT] = ACTIONS(2411),
    [anon_sym_DOT] = ACTIONS(2411),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2413),
    [anon_sym_new] = ACTIONS(2411),
    [anon_sym_return_BANG] = ACTIONS(2413),
    [anon_sym_yield] = ACTIONS(2411),
    [anon_sym_yield_BANG] = ACTIONS(2413),
    [anon_sym_lazy] = ACTIONS(2411),
    [anon_sym_assert] = ACTIONS(2411),
    [anon_sym_upcast] = ACTIONS(2411),
    [anon_sym_downcast] = ACTIONS(2411),
    [anon_sym_COLON_GT] = ACTIONS(2413),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2413),
    [anon_sym_for] = ACTIONS(2411),
    [anon_sym_while] = ACTIONS(2411),
    [anon_sym_if] = ACTIONS(2411),
    [anon_sym_fun] = ACTIONS(2411),
    [anon_sym_try] = ACTIONS(2411),
    [anon_sym_match] = ACTIONS(2411),
    [anon_sym_match_BANG] = ACTIONS(2413),
    [anon_sym_function] = ACTIONS(2411),
    [anon_sym_LT_DASH] = ACTIONS(2411),
    [anon_sym_DOT_LBRACK] = ACTIONS(2413),
    [anon_sym_LT] = ACTIONS(2413),
    [anon_sym_use] = ACTIONS(2411),
    [anon_sym_use_BANG] = ACTIONS(2413),
    [anon_sym_do_BANG] = ACTIONS(2413),
    [anon_sym_DOT_DOT] = ACTIONS(2413),
    [anon_sym_begin] = ACTIONS(2411),
    [anon_sym_LPAREN2] = ACTIONS(2411),
    [anon_sym_or] = ACTIONS(2411),
    [aux_sym_char_token1] = ACTIONS(2413),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2411),
    [anon_sym_DQUOTE] = ACTIONS(2411),
    [anon_sym_AT_DQUOTE] = ACTIONS(2413),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2413),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2413),
    [sym_bool] = ACTIONS(2411),
    [sym_unit] = ACTIONS(2413),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2411),
    [sym_op_identifier] = ACTIONS(2411),
    [anon_sym_PLUS] = ACTIONS(2411),
    [anon_sym_DASH] = ACTIONS(2411),
    [anon_sym_PLUS_DOT] = ACTIONS(2411),
    [anon_sym_DASH_DOT] = ACTIONS(2411),
    [anon_sym_PERCENT] = ACTIONS(2411),
    [anon_sym_AMP_AMP] = ACTIONS(2411),
    [anon_sym_TILDE] = ACTIONS(2413),
    [aux_sym_prefix_op_token1] = ACTIONS(2411),
    [aux_sym_infix_op_token1] = ACTIONS(2413),
    [aux_sym_infix_op_token2] = ACTIONS(2411),
    [anon_sym_PIPE_PIPE] = ACTIONS(2411),
    [anon_sym_BANG_EQ] = ACTIONS(2411),
    [anon_sym_COLON_EQ] = ACTIONS(2413),
    [anon_sym_DOLLAR] = ACTIONS(2411),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2411),
    [sym_int] = ACTIONS(2411),
    [sym_xint] = ACTIONS(2413),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2413),
    [sym__newline] = ACTIONS(2413),
  },
  [2330] = {
    [sym_block_comment] = STATE(2330),
    [sym_compiler_directive_decl] = STATE(2330),
    [sym_fsi_directive_decl] = STATE(2330),
    [sym_preproc_line] = STATE(2330),
    [sym_identifier] = ACTIONS(2914),
    [anon_sym_EQ] = ACTIONS(2916),
    [anon_sym_COLON] = ACTIONS(2914),
    [anon_sym_return] = ACTIONS(2914),
    [anon_sym_do] = ACTIONS(2914),
    [anon_sym_let] = ACTIONS(2914),
    [anon_sym_let_BANG] = ACTIONS(2916),
    [anon_sym_LPAREN] = ACTIONS(2914),
    [anon_sym_COMMA] = ACTIONS(2916),
    [anon_sym_null] = ACTIONS(2914),
    [anon_sym_QMARK] = ACTIONS(2914),
    [anon_sym_COLON_QMARK] = ACTIONS(2914),
    [anon_sym_COLON_COLON] = ACTIONS(2916),
    [anon_sym_AMP] = ACTIONS(2914),
    [anon_sym_LBRACK] = ACTIONS(2914),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2916),
    [anon_sym_LBRACE] = ACTIONS(2914),
    [anon_sym_LT_AT] = ACTIONS(2914),
    [anon_sym_LT_AT_AT] = ACTIONS(2914),
    [anon_sym_AT_AT_GT] = ACTIONS(2914),
    [anon_sym_DOT] = ACTIONS(2914),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2916),
    [anon_sym_new] = ACTIONS(2914),
    [anon_sym_return_BANG] = ACTIONS(2916),
    [anon_sym_yield] = ACTIONS(2914),
    [anon_sym_yield_BANG] = ACTIONS(2916),
    [anon_sym_lazy] = ACTIONS(2914),
    [anon_sym_assert] = ACTIONS(2914),
    [anon_sym_upcast] = ACTIONS(2914),
    [anon_sym_downcast] = ACTIONS(2914),
    [anon_sym_COLON_GT] = ACTIONS(2916),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2916),
    [anon_sym_for] = ACTIONS(2914),
    [anon_sym_while] = ACTIONS(2914),
    [anon_sym_if] = ACTIONS(2914),
    [anon_sym_fun] = ACTIONS(2914),
    [anon_sym_try] = ACTIONS(2914),
    [anon_sym_match] = ACTIONS(2914),
    [anon_sym_match_BANG] = ACTIONS(2916),
    [anon_sym_function] = ACTIONS(2914),
    [anon_sym_LT_DASH] = ACTIONS(2914),
    [anon_sym_DOT_LBRACK] = ACTIONS(2916),
    [anon_sym_LT] = ACTIONS(2916),
    [anon_sym_use] = ACTIONS(2914),
    [anon_sym_use_BANG] = ACTIONS(2916),
    [anon_sym_do_BANG] = ACTIONS(2916),
    [anon_sym_begin] = ACTIONS(2914),
    [anon_sym_LPAREN2] = ACTIONS(2914),
    [anon_sym_or] = ACTIONS(2914),
    [aux_sym_char_token1] = ACTIONS(2916),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2914),
    [anon_sym_DQUOTE] = ACTIONS(2914),
    [anon_sym_AT_DQUOTE] = ACTIONS(2916),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2916),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2916),
    [sym_bool] = ACTIONS(2914),
    [sym_unit] = ACTIONS(2916),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2914),
    [sym_op_identifier] = ACTIONS(2914),
    [anon_sym_PLUS] = ACTIONS(2914),
    [anon_sym_DASH] = ACTIONS(2914),
    [anon_sym_PLUS_DOT] = ACTIONS(2914),
    [anon_sym_DASH_DOT] = ACTIONS(2914),
    [anon_sym_PERCENT] = ACTIONS(2914),
    [anon_sym_AMP_AMP] = ACTIONS(2914),
    [anon_sym_TILDE] = ACTIONS(2916),
    [aux_sym_prefix_op_token1] = ACTIONS(2914),
    [aux_sym_infix_op_token1] = ACTIONS(2916),
    [aux_sym_infix_op_token2] = ACTIONS(2914),
    [anon_sym_PIPE_PIPE] = ACTIONS(2914),
    [anon_sym_BANG_EQ] = ACTIONS(2914),
    [anon_sym_COLON_EQ] = ACTIONS(2916),
    [anon_sym_DOLLAR] = ACTIONS(2914),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2914),
    [sym_int] = ACTIONS(2914),
    [sym_xint] = ACTIONS(2916),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2916),
    [sym__newline] = ACTIONS(2916),
  },
  [2331] = {
    [sym_block_comment] = STATE(2331),
    [sym_compiler_directive_decl] = STATE(2331),
    [sym_fsi_directive_decl] = STATE(2331),
    [sym_preproc_line] = STATE(2331),
    [sym_identifier] = ACTIONS(3095),
    [anon_sym_EQ] = ACTIONS(3097),
    [anon_sym_COLON] = ACTIONS(3095),
    [anon_sym_return] = ACTIONS(3095),
    [anon_sym_do] = ACTIONS(3095),
    [anon_sym_let] = ACTIONS(3095),
    [anon_sym_let_BANG] = ACTIONS(3097),
    [anon_sym_LPAREN] = ACTIONS(3095),
    [anon_sym_COMMA] = ACTIONS(3097),
    [anon_sym_null] = ACTIONS(3095),
    [anon_sym_QMARK] = ACTIONS(3095),
    [anon_sym_COLON_QMARK] = ACTIONS(3095),
    [anon_sym_COLON_COLON] = ACTIONS(3097),
    [anon_sym_AMP] = ACTIONS(3095),
    [anon_sym_LBRACK] = ACTIONS(3095),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3097),
    [anon_sym_LBRACE] = ACTIONS(3095),
    [anon_sym_LT_AT] = ACTIONS(3095),
    [anon_sym_LT_AT_AT] = ACTIONS(3095),
    [anon_sym_DOT] = ACTIONS(3095),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3097),
    [anon_sym_new] = ACTIONS(3095),
    [anon_sym_return_BANG] = ACTIONS(3097),
    [anon_sym_yield] = ACTIONS(3095),
    [anon_sym_yield_BANG] = ACTIONS(3097),
    [anon_sym_lazy] = ACTIONS(3095),
    [anon_sym_assert] = ACTIONS(3095),
    [anon_sym_upcast] = ACTIONS(3095),
    [anon_sym_downcast] = ACTIONS(3095),
    [anon_sym_COLON_GT] = ACTIONS(3097),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3097),
    [anon_sym_for] = ACTIONS(3095),
    [anon_sym_while] = ACTIONS(3095),
    [anon_sym_if] = ACTIONS(3095),
    [anon_sym_fun] = ACTIONS(3095),
    [anon_sym_try] = ACTIONS(3095),
    [anon_sym_match] = ACTIONS(3095),
    [anon_sym_match_BANG] = ACTIONS(3097),
    [anon_sym_function] = ACTIONS(3095),
    [anon_sym_LT_DASH] = ACTIONS(3095),
    [anon_sym_DOT_LBRACK] = ACTIONS(3097),
    [anon_sym_LT] = ACTIONS(3097),
    [anon_sym_use] = ACTIONS(3095),
    [anon_sym_use_BANG] = ACTIONS(3097),
    [anon_sym_do_BANG] = ACTIONS(3097),
    [anon_sym_DOT_DOT] = ACTIONS(3097),
    [anon_sym_begin] = ACTIONS(3095),
    [anon_sym_LPAREN2] = ACTIONS(3095),
    [anon_sym_or] = ACTIONS(3095),
    [aux_sym_char_token1] = ACTIONS(3097),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3095),
    [anon_sym_DQUOTE] = ACTIONS(3095),
    [anon_sym_AT_DQUOTE] = ACTIONS(3097),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3097),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3097),
    [sym_bool] = ACTIONS(3095),
    [sym_unit] = ACTIONS(3097),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3095),
    [sym_op_identifier] = ACTIONS(3095),
    [anon_sym_PLUS] = ACTIONS(3095),
    [anon_sym_DASH] = ACTIONS(3095),
    [anon_sym_PLUS_DOT] = ACTIONS(3095),
    [anon_sym_DASH_DOT] = ACTIONS(3095),
    [anon_sym_PERCENT] = ACTIONS(3095),
    [anon_sym_AMP_AMP] = ACTIONS(3095),
    [anon_sym_TILDE] = ACTIONS(3097),
    [aux_sym_prefix_op_token1] = ACTIONS(3095),
    [aux_sym_infix_op_token1] = ACTIONS(3097),
    [aux_sym_infix_op_token2] = ACTIONS(3095),
    [anon_sym_PIPE_PIPE] = ACTIONS(3095),
    [anon_sym_BANG_EQ] = ACTIONS(3095),
    [anon_sym_COLON_EQ] = ACTIONS(3097),
    [anon_sym_DOLLAR] = ACTIONS(3095),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3095),
    [sym_int] = ACTIONS(3095),
    [sym_xint] = ACTIONS(3097),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3097),
    [sym__newline] = ACTIONS(3097),
  },
  [2332] = {
    [sym_block_comment] = STATE(2332),
    [sym_compiler_directive_decl] = STATE(2332),
    [sym_fsi_directive_decl] = STATE(2332),
    [sym_preproc_line] = STATE(2332),
    [sym_identifier] = ACTIONS(2918),
    [anon_sym_EQ] = ACTIONS(2920),
    [anon_sym_COLON] = ACTIONS(2918),
    [anon_sym_return] = ACTIONS(2918),
    [anon_sym_do] = ACTIONS(2918),
    [anon_sym_let] = ACTIONS(2918),
    [anon_sym_let_BANG] = ACTIONS(2920),
    [anon_sym_LPAREN] = ACTIONS(2918),
    [anon_sym_COMMA] = ACTIONS(2920),
    [anon_sym_null] = ACTIONS(2918),
    [anon_sym_QMARK] = ACTIONS(2918),
    [anon_sym_COLON_QMARK] = ACTIONS(2918),
    [anon_sym_COLON_COLON] = ACTIONS(2920),
    [anon_sym_AMP] = ACTIONS(2918),
    [anon_sym_LBRACK] = ACTIONS(2918),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2920),
    [anon_sym_LBRACE] = ACTIONS(2918),
    [anon_sym_LT_AT] = ACTIONS(2918),
    [anon_sym_LT_AT_AT] = ACTIONS(2918),
    [anon_sym_AT_AT_GT] = ACTIONS(2918),
    [anon_sym_DOT] = ACTIONS(2918),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2920),
    [anon_sym_new] = ACTIONS(2918),
    [anon_sym_return_BANG] = ACTIONS(2920),
    [anon_sym_yield] = ACTIONS(2918),
    [anon_sym_yield_BANG] = ACTIONS(2920),
    [anon_sym_lazy] = ACTIONS(2918),
    [anon_sym_assert] = ACTIONS(2918),
    [anon_sym_upcast] = ACTIONS(2918),
    [anon_sym_downcast] = ACTIONS(2918),
    [anon_sym_COLON_GT] = ACTIONS(2920),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2920),
    [anon_sym_for] = ACTIONS(2918),
    [anon_sym_while] = ACTIONS(2918),
    [anon_sym_if] = ACTIONS(2918),
    [anon_sym_fun] = ACTIONS(2918),
    [anon_sym_try] = ACTIONS(2918),
    [anon_sym_match] = ACTIONS(2918),
    [anon_sym_match_BANG] = ACTIONS(2920),
    [anon_sym_function] = ACTIONS(2918),
    [anon_sym_LT_DASH] = ACTIONS(2918),
    [anon_sym_DOT_LBRACK] = ACTIONS(2920),
    [anon_sym_LT] = ACTIONS(2920),
    [anon_sym_use] = ACTIONS(2918),
    [anon_sym_use_BANG] = ACTIONS(2920),
    [anon_sym_do_BANG] = ACTIONS(2920),
    [anon_sym_begin] = ACTIONS(2918),
    [anon_sym_LPAREN2] = ACTIONS(2918),
    [anon_sym_or] = ACTIONS(2918),
    [aux_sym_char_token1] = ACTIONS(2920),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2918),
    [anon_sym_DQUOTE] = ACTIONS(2918),
    [anon_sym_AT_DQUOTE] = ACTIONS(2920),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2920),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2920),
    [sym_bool] = ACTIONS(2918),
    [sym_unit] = ACTIONS(2920),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2918),
    [sym_op_identifier] = ACTIONS(2918),
    [anon_sym_PLUS] = ACTIONS(2918),
    [anon_sym_DASH] = ACTIONS(2918),
    [anon_sym_PLUS_DOT] = ACTIONS(2918),
    [anon_sym_DASH_DOT] = ACTIONS(2918),
    [anon_sym_PERCENT] = ACTIONS(2918),
    [anon_sym_AMP_AMP] = ACTIONS(2918),
    [anon_sym_TILDE] = ACTIONS(2920),
    [aux_sym_prefix_op_token1] = ACTIONS(2918),
    [aux_sym_infix_op_token1] = ACTIONS(2920),
    [aux_sym_infix_op_token2] = ACTIONS(2918),
    [anon_sym_PIPE_PIPE] = ACTIONS(2918),
    [anon_sym_BANG_EQ] = ACTIONS(2918),
    [anon_sym_COLON_EQ] = ACTIONS(2920),
    [anon_sym_DOLLAR] = ACTIONS(2918),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2918),
    [sym_int] = ACTIONS(2918),
    [sym_xint] = ACTIONS(2920),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2920),
    [sym__newline] = ACTIONS(2920),
  },
  [2333] = {
    [sym_block_comment] = STATE(2333),
    [sym_compiler_directive_decl] = STATE(2333),
    [sym_fsi_directive_decl] = STATE(2333),
    [sym_preproc_line] = STATE(2333),
    [sym_identifier] = ACTIONS(2887),
    [anon_sym_EQ] = ACTIONS(2889),
    [anon_sym_COLON] = ACTIONS(2887),
    [anon_sym_return] = ACTIONS(2887),
    [anon_sym_do] = ACTIONS(2887),
    [anon_sym_let] = ACTIONS(2887),
    [anon_sym_let_BANG] = ACTIONS(2889),
    [anon_sym_LPAREN] = ACTIONS(2887),
    [anon_sym_COMMA] = ACTIONS(2889),
    [anon_sym_null] = ACTIONS(2887),
    [anon_sym_QMARK] = ACTIONS(2887),
    [anon_sym_COLON_QMARK] = ACTIONS(2887),
    [anon_sym_COLON_COLON] = ACTIONS(2889),
    [anon_sym_AMP] = ACTIONS(2887),
    [anon_sym_LBRACK] = ACTIONS(2887),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2889),
    [anon_sym_LBRACE] = ACTIONS(2887),
    [anon_sym_LT_AT] = ACTIONS(2887),
    [anon_sym_AT_GT] = ACTIONS(2887),
    [anon_sym_LT_AT_AT] = ACTIONS(2887),
    [anon_sym_DOT] = ACTIONS(2887),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2889),
    [anon_sym_new] = ACTIONS(2887),
    [anon_sym_return_BANG] = ACTIONS(2889),
    [anon_sym_yield] = ACTIONS(2887),
    [anon_sym_yield_BANG] = ACTIONS(2889),
    [anon_sym_lazy] = ACTIONS(2887),
    [anon_sym_assert] = ACTIONS(2887),
    [anon_sym_upcast] = ACTIONS(2887),
    [anon_sym_downcast] = ACTIONS(2887),
    [anon_sym_COLON_GT] = ACTIONS(2889),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2889),
    [anon_sym_for] = ACTIONS(2887),
    [anon_sym_while] = ACTIONS(2887),
    [anon_sym_if] = ACTIONS(2887),
    [anon_sym_fun] = ACTIONS(2887),
    [anon_sym_try] = ACTIONS(2887),
    [anon_sym_match] = ACTIONS(2887),
    [anon_sym_match_BANG] = ACTIONS(2889),
    [anon_sym_function] = ACTIONS(2887),
    [anon_sym_LT_DASH] = ACTIONS(2887),
    [anon_sym_DOT_LBRACK] = ACTIONS(2889),
    [anon_sym_LT] = ACTIONS(2889),
    [anon_sym_use] = ACTIONS(2887),
    [anon_sym_use_BANG] = ACTIONS(2889),
    [anon_sym_do_BANG] = ACTIONS(2889),
    [anon_sym_begin] = ACTIONS(2887),
    [anon_sym_LPAREN2] = ACTIONS(2887),
    [anon_sym_or] = ACTIONS(2887),
    [aux_sym_char_token1] = ACTIONS(2889),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2887),
    [anon_sym_DQUOTE] = ACTIONS(2887),
    [anon_sym_AT_DQUOTE] = ACTIONS(2889),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2889),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2889),
    [sym_bool] = ACTIONS(2887),
    [sym_unit] = ACTIONS(2889),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2887),
    [sym_op_identifier] = ACTIONS(2887),
    [anon_sym_PLUS] = ACTIONS(2887),
    [anon_sym_DASH] = ACTIONS(2887),
    [anon_sym_PLUS_DOT] = ACTIONS(2887),
    [anon_sym_DASH_DOT] = ACTIONS(2887),
    [anon_sym_PERCENT] = ACTIONS(2887),
    [anon_sym_AMP_AMP] = ACTIONS(2887),
    [anon_sym_TILDE] = ACTIONS(2889),
    [aux_sym_prefix_op_token1] = ACTIONS(2887),
    [aux_sym_infix_op_token1] = ACTIONS(2889),
    [aux_sym_infix_op_token2] = ACTIONS(2887),
    [anon_sym_PIPE_PIPE] = ACTIONS(2887),
    [anon_sym_BANG_EQ] = ACTIONS(2887),
    [anon_sym_COLON_EQ] = ACTIONS(2889),
    [anon_sym_DOLLAR] = ACTIONS(2887),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2887),
    [sym_int] = ACTIONS(2887),
    [sym_xint] = ACTIONS(2889),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2889),
    [sym__newline] = ACTIONS(2889),
  },
  [2334] = {
    [sym_block_comment] = STATE(2334),
    [sym_compiler_directive_decl] = STATE(2334),
    [sym_fsi_directive_decl] = STATE(2334),
    [sym_preproc_line] = STATE(2334),
    [sym_identifier] = ACTIONS(3099),
    [anon_sym_EQ] = ACTIONS(3101),
    [anon_sym_COLON] = ACTIONS(3099),
    [anon_sym_return] = ACTIONS(3099),
    [anon_sym_do] = ACTIONS(3099),
    [anon_sym_let] = ACTIONS(3099),
    [anon_sym_let_BANG] = ACTIONS(3101),
    [anon_sym_LPAREN] = ACTIONS(3099),
    [anon_sym_COMMA] = ACTIONS(3101),
    [anon_sym_null] = ACTIONS(3099),
    [anon_sym_QMARK] = ACTIONS(3099),
    [anon_sym_COLON_QMARK] = ACTIONS(3099),
    [anon_sym_COLON_COLON] = ACTIONS(3101),
    [anon_sym_AMP] = ACTIONS(3099),
    [anon_sym_LBRACK] = ACTIONS(3099),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3101),
    [anon_sym_LBRACE] = ACTIONS(3099),
    [anon_sym_LT_AT] = ACTIONS(3099),
    [anon_sym_LT_AT_AT] = ACTIONS(3099),
    [anon_sym_AT_AT_GT] = ACTIONS(3099),
    [anon_sym_DOT] = ACTIONS(3099),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3101),
    [anon_sym_new] = ACTIONS(3099),
    [anon_sym_return_BANG] = ACTIONS(3101),
    [anon_sym_yield] = ACTIONS(3099),
    [anon_sym_yield_BANG] = ACTIONS(3101),
    [anon_sym_lazy] = ACTIONS(3099),
    [anon_sym_assert] = ACTIONS(3099),
    [anon_sym_upcast] = ACTIONS(3099),
    [anon_sym_downcast] = ACTIONS(3099),
    [anon_sym_COLON_GT] = ACTIONS(3101),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3101),
    [anon_sym_for] = ACTIONS(3099),
    [anon_sym_while] = ACTIONS(3099),
    [anon_sym_if] = ACTIONS(3099),
    [anon_sym_fun] = ACTIONS(3099),
    [anon_sym_try] = ACTIONS(3099),
    [anon_sym_match] = ACTIONS(3099),
    [anon_sym_match_BANG] = ACTIONS(3101),
    [anon_sym_function] = ACTIONS(3099),
    [anon_sym_LT_DASH] = ACTIONS(3099),
    [anon_sym_DOT_LBRACK] = ACTIONS(3101),
    [anon_sym_LT] = ACTIONS(3101),
    [anon_sym_use] = ACTIONS(3099),
    [anon_sym_use_BANG] = ACTIONS(3101),
    [anon_sym_do_BANG] = ACTIONS(3101),
    [anon_sym_begin] = ACTIONS(3099),
    [anon_sym_LPAREN2] = ACTIONS(3099),
    [anon_sym_or] = ACTIONS(3099),
    [aux_sym_char_token1] = ACTIONS(3101),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3099),
    [anon_sym_DQUOTE] = ACTIONS(3099),
    [anon_sym_AT_DQUOTE] = ACTIONS(3101),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3101),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3101),
    [sym_bool] = ACTIONS(3099),
    [sym_unit] = ACTIONS(3101),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3099),
    [sym_op_identifier] = ACTIONS(3099),
    [anon_sym_PLUS] = ACTIONS(3099),
    [anon_sym_DASH] = ACTIONS(3099),
    [anon_sym_PLUS_DOT] = ACTIONS(3099),
    [anon_sym_DASH_DOT] = ACTIONS(3099),
    [anon_sym_PERCENT] = ACTIONS(3099),
    [anon_sym_AMP_AMP] = ACTIONS(3099),
    [anon_sym_TILDE] = ACTIONS(3101),
    [aux_sym_prefix_op_token1] = ACTIONS(3099),
    [aux_sym_infix_op_token1] = ACTIONS(3101),
    [aux_sym_infix_op_token2] = ACTIONS(3099),
    [anon_sym_PIPE_PIPE] = ACTIONS(3099),
    [anon_sym_BANG_EQ] = ACTIONS(3099),
    [anon_sym_COLON_EQ] = ACTIONS(3101),
    [anon_sym_DOLLAR] = ACTIONS(3099),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3099),
    [sym_int] = ACTIONS(3099),
    [sym_xint] = ACTIONS(3101),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3101),
    [sym__newline] = ACTIONS(3101),
  },
  [2335] = {
    [sym_block_comment] = STATE(2335),
    [sym_compiler_directive_decl] = STATE(2335),
    [sym_fsi_directive_decl] = STATE(2335),
    [sym_preproc_line] = STATE(2335),
    [sym_identifier] = ACTIONS(2970),
    [anon_sym_EQ] = ACTIONS(2972),
    [anon_sym_COLON] = ACTIONS(2970),
    [anon_sym_return] = ACTIONS(2970),
    [anon_sym_do] = ACTIONS(2970),
    [anon_sym_let] = ACTIONS(2970),
    [anon_sym_let_BANG] = ACTIONS(2972),
    [anon_sym_LPAREN] = ACTIONS(2970),
    [anon_sym_COMMA] = ACTIONS(2972),
    [anon_sym_null] = ACTIONS(2970),
    [anon_sym_QMARK] = ACTIONS(2970),
    [anon_sym_COLON_QMARK] = ACTIONS(2970),
    [anon_sym_COLON_COLON] = ACTIONS(2972),
    [anon_sym_AMP] = ACTIONS(2970),
    [anon_sym_LBRACK] = ACTIONS(2970),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2972),
    [anon_sym_LBRACE] = ACTIONS(2970),
    [anon_sym_LT_AT] = ACTIONS(2970),
    [anon_sym_LT_AT_AT] = ACTIONS(2970),
    [anon_sym_DOT] = ACTIONS(2970),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2972),
    [anon_sym_new] = ACTIONS(2970),
    [anon_sym_return_BANG] = ACTIONS(2972),
    [anon_sym_yield] = ACTIONS(2970),
    [anon_sym_yield_BANG] = ACTIONS(2972),
    [anon_sym_lazy] = ACTIONS(2970),
    [anon_sym_assert] = ACTIONS(2970),
    [anon_sym_upcast] = ACTIONS(2970),
    [anon_sym_downcast] = ACTIONS(2970),
    [anon_sym_COLON_GT] = ACTIONS(2972),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2972),
    [anon_sym_for] = ACTIONS(2970),
    [anon_sym_while] = ACTIONS(2970),
    [anon_sym_if] = ACTIONS(2970),
    [anon_sym_fun] = ACTIONS(2970),
    [anon_sym_try] = ACTIONS(2970),
    [anon_sym_match] = ACTIONS(2970),
    [anon_sym_match_BANG] = ACTIONS(2972),
    [anon_sym_function] = ACTIONS(2970),
    [anon_sym_LT_DASH] = ACTIONS(2970),
    [anon_sym_DOT_LBRACK] = ACTIONS(2972),
    [anon_sym_LT] = ACTIONS(2972),
    [anon_sym_use] = ACTIONS(2970),
    [anon_sym_use_BANG] = ACTIONS(2972),
    [anon_sym_do_BANG] = ACTIONS(2972),
    [anon_sym_DOT_DOT] = ACTIONS(2972),
    [anon_sym_begin] = ACTIONS(2970),
    [anon_sym_LPAREN2] = ACTIONS(2970),
    [anon_sym_or] = ACTIONS(2970),
    [aux_sym_char_token1] = ACTIONS(2972),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2970),
    [anon_sym_DQUOTE] = ACTIONS(2970),
    [anon_sym_AT_DQUOTE] = ACTIONS(2972),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2972),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2972),
    [sym_bool] = ACTIONS(2970),
    [sym_unit] = ACTIONS(2972),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2970),
    [sym_op_identifier] = ACTIONS(2970),
    [anon_sym_PLUS] = ACTIONS(2970),
    [anon_sym_DASH] = ACTIONS(2970),
    [anon_sym_PLUS_DOT] = ACTIONS(2970),
    [anon_sym_DASH_DOT] = ACTIONS(2970),
    [anon_sym_PERCENT] = ACTIONS(2970),
    [anon_sym_AMP_AMP] = ACTIONS(2970),
    [anon_sym_TILDE] = ACTIONS(2972),
    [aux_sym_prefix_op_token1] = ACTIONS(2970),
    [aux_sym_infix_op_token1] = ACTIONS(2972),
    [aux_sym_infix_op_token2] = ACTIONS(2970),
    [anon_sym_PIPE_PIPE] = ACTIONS(2970),
    [anon_sym_BANG_EQ] = ACTIONS(2970),
    [anon_sym_COLON_EQ] = ACTIONS(2972),
    [anon_sym_DOLLAR] = ACTIONS(2970),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2970),
    [sym_int] = ACTIONS(2970),
    [sym_xint] = ACTIONS(2972),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2972),
    [sym__newline] = ACTIONS(2972),
  },
  [2336] = {
    [sym_block_comment] = STATE(2336),
    [sym_compiler_directive_decl] = STATE(2336),
    [sym_fsi_directive_decl] = STATE(2336),
    [sym_preproc_line] = STATE(2336),
    [sym_identifier] = ACTIONS(3083),
    [anon_sym_EQ] = ACTIONS(3085),
    [anon_sym_COLON] = ACTIONS(3083),
    [anon_sym_return] = ACTIONS(3083),
    [anon_sym_do] = ACTIONS(3083),
    [anon_sym_let] = ACTIONS(3083),
    [anon_sym_let_BANG] = ACTIONS(3085),
    [anon_sym_LPAREN] = ACTIONS(3083),
    [anon_sym_COMMA] = ACTIONS(3085),
    [anon_sym_null] = ACTIONS(3083),
    [anon_sym_QMARK] = ACTIONS(3083),
    [anon_sym_COLON_QMARK] = ACTIONS(3083),
    [anon_sym_COLON_COLON] = ACTIONS(3085),
    [anon_sym_AMP] = ACTIONS(3083),
    [anon_sym_LBRACK] = ACTIONS(3083),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3085),
    [anon_sym_LBRACE] = ACTIONS(3083),
    [anon_sym_LT_AT] = ACTIONS(3083),
    [anon_sym_LT_AT_AT] = ACTIONS(3083),
    [anon_sym_AT_AT_GT] = ACTIONS(3083),
    [anon_sym_DOT] = ACTIONS(3083),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3085),
    [anon_sym_new] = ACTIONS(3083),
    [anon_sym_return_BANG] = ACTIONS(3085),
    [anon_sym_yield] = ACTIONS(3083),
    [anon_sym_yield_BANG] = ACTIONS(3085),
    [anon_sym_lazy] = ACTIONS(3083),
    [anon_sym_assert] = ACTIONS(3083),
    [anon_sym_upcast] = ACTIONS(3083),
    [anon_sym_downcast] = ACTIONS(3083),
    [anon_sym_COLON_GT] = ACTIONS(3085),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3085),
    [anon_sym_for] = ACTIONS(3083),
    [anon_sym_while] = ACTIONS(3083),
    [anon_sym_if] = ACTIONS(3083),
    [anon_sym_fun] = ACTIONS(3083),
    [anon_sym_try] = ACTIONS(3083),
    [anon_sym_match] = ACTIONS(3083),
    [anon_sym_match_BANG] = ACTIONS(3085),
    [anon_sym_function] = ACTIONS(3083),
    [anon_sym_LT_DASH] = ACTIONS(3083),
    [anon_sym_DOT_LBRACK] = ACTIONS(3085),
    [anon_sym_LT] = ACTIONS(3085),
    [anon_sym_use] = ACTIONS(3083),
    [anon_sym_use_BANG] = ACTIONS(3085),
    [anon_sym_do_BANG] = ACTIONS(3085),
    [anon_sym_begin] = ACTIONS(3083),
    [anon_sym_LPAREN2] = ACTIONS(3083),
    [anon_sym_or] = ACTIONS(3083),
    [aux_sym_char_token1] = ACTIONS(3085),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3083),
    [anon_sym_DQUOTE] = ACTIONS(3083),
    [anon_sym_AT_DQUOTE] = ACTIONS(3085),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3085),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3085),
    [sym_bool] = ACTIONS(3083),
    [sym_unit] = ACTIONS(3085),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3083),
    [sym_op_identifier] = ACTIONS(3083),
    [anon_sym_PLUS] = ACTIONS(3083),
    [anon_sym_DASH] = ACTIONS(3083),
    [anon_sym_PLUS_DOT] = ACTIONS(3083),
    [anon_sym_DASH_DOT] = ACTIONS(3083),
    [anon_sym_PERCENT] = ACTIONS(3083),
    [anon_sym_AMP_AMP] = ACTIONS(3083),
    [anon_sym_TILDE] = ACTIONS(3085),
    [aux_sym_prefix_op_token1] = ACTIONS(3083),
    [aux_sym_infix_op_token1] = ACTIONS(3085),
    [aux_sym_infix_op_token2] = ACTIONS(3083),
    [anon_sym_PIPE_PIPE] = ACTIONS(3083),
    [anon_sym_BANG_EQ] = ACTIONS(3083),
    [anon_sym_COLON_EQ] = ACTIONS(3085),
    [anon_sym_DOLLAR] = ACTIONS(3083),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3083),
    [sym_int] = ACTIONS(3083),
    [sym_xint] = ACTIONS(3085),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3085),
    [sym__newline] = ACTIONS(3085),
  },
  [2337] = {
    [sym_block_comment] = STATE(2337),
    [sym_compiler_directive_decl] = STATE(2337),
    [sym_fsi_directive_decl] = STATE(2337),
    [sym_preproc_line] = STATE(2337),
    [sym_identifier] = ACTIONS(3103),
    [anon_sym_EQ] = ACTIONS(3105),
    [anon_sym_COLON] = ACTIONS(3103),
    [anon_sym_return] = ACTIONS(3103),
    [anon_sym_do] = ACTIONS(3103),
    [anon_sym_let] = ACTIONS(3103),
    [anon_sym_let_BANG] = ACTIONS(3105),
    [anon_sym_LPAREN] = ACTIONS(3103),
    [anon_sym_COMMA] = ACTIONS(3105),
    [anon_sym_null] = ACTIONS(3103),
    [anon_sym_QMARK] = ACTIONS(3103),
    [anon_sym_COLON_QMARK] = ACTIONS(3103),
    [anon_sym_COLON_COLON] = ACTIONS(3105),
    [anon_sym_AMP] = ACTIONS(3103),
    [anon_sym_LBRACK] = ACTIONS(3103),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3105),
    [anon_sym_LBRACE] = ACTIONS(3103),
    [anon_sym_LT_AT] = ACTIONS(3103),
    [anon_sym_AT_GT] = ACTIONS(3103),
    [anon_sym_LT_AT_AT] = ACTIONS(3103),
    [anon_sym_DOT] = ACTIONS(3103),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3105),
    [anon_sym_new] = ACTIONS(3103),
    [anon_sym_return_BANG] = ACTIONS(3105),
    [anon_sym_yield] = ACTIONS(3103),
    [anon_sym_yield_BANG] = ACTIONS(3105),
    [anon_sym_lazy] = ACTIONS(3103),
    [anon_sym_assert] = ACTIONS(3103),
    [anon_sym_upcast] = ACTIONS(3103),
    [anon_sym_downcast] = ACTIONS(3103),
    [anon_sym_COLON_GT] = ACTIONS(3105),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3105),
    [anon_sym_for] = ACTIONS(3103),
    [anon_sym_while] = ACTIONS(3103),
    [anon_sym_if] = ACTIONS(3103),
    [anon_sym_fun] = ACTIONS(3103),
    [anon_sym_try] = ACTIONS(3103),
    [anon_sym_match] = ACTIONS(3103),
    [anon_sym_match_BANG] = ACTIONS(3105),
    [anon_sym_function] = ACTIONS(3103),
    [anon_sym_LT_DASH] = ACTIONS(3103),
    [anon_sym_DOT_LBRACK] = ACTIONS(3105),
    [anon_sym_LT] = ACTIONS(3105),
    [anon_sym_use] = ACTIONS(3103),
    [anon_sym_use_BANG] = ACTIONS(3105),
    [anon_sym_do_BANG] = ACTIONS(3105),
    [anon_sym_begin] = ACTIONS(3103),
    [anon_sym_LPAREN2] = ACTIONS(3103),
    [anon_sym_or] = ACTIONS(3103),
    [aux_sym_char_token1] = ACTIONS(3105),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3103),
    [anon_sym_DQUOTE] = ACTIONS(3103),
    [anon_sym_AT_DQUOTE] = ACTIONS(3105),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3105),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3105),
    [sym_bool] = ACTIONS(3103),
    [sym_unit] = ACTIONS(3105),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3103),
    [sym_op_identifier] = ACTIONS(3103),
    [anon_sym_PLUS] = ACTIONS(3103),
    [anon_sym_DASH] = ACTIONS(3103),
    [anon_sym_PLUS_DOT] = ACTIONS(3103),
    [anon_sym_DASH_DOT] = ACTIONS(3103),
    [anon_sym_PERCENT] = ACTIONS(3103),
    [anon_sym_AMP_AMP] = ACTIONS(3103),
    [anon_sym_TILDE] = ACTIONS(3105),
    [aux_sym_prefix_op_token1] = ACTIONS(3103),
    [aux_sym_infix_op_token1] = ACTIONS(3105),
    [aux_sym_infix_op_token2] = ACTIONS(3103),
    [anon_sym_PIPE_PIPE] = ACTIONS(3103),
    [anon_sym_BANG_EQ] = ACTIONS(3103),
    [anon_sym_COLON_EQ] = ACTIONS(3105),
    [anon_sym_DOLLAR] = ACTIONS(3103),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3103),
    [sym_int] = ACTIONS(3103),
    [sym_xint] = ACTIONS(3105),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3105),
    [sym__newline] = ACTIONS(3105),
  },
  [2338] = {
    [sym_block_comment] = STATE(2338),
    [sym_compiler_directive_decl] = STATE(2338),
    [sym_fsi_directive_decl] = STATE(2338),
    [sym_preproc_line] = STATE(2338),
    [sym_identifier] = ACTIONS(3107),
    [anon_sym_EQ] = ACTIONS(3109),
    [anon_sym_COLON] = ACTIONS(3107),
    [anon_sym_return] = ACTIONS(3107),
    [anon_sym_do] = ACTIONS(3107),
    [anon_sym_let] = ACTIONS(3107),
    [anon_sym_let_BANG] = ACTIONS(3109),
    [anon_sym_LPAREN] = ACTIONS(3107),
    [anon_sym_COMMA] = ACTIONS(3109),
    [anon_sym_null] = ACTIONS(3107),
    [anon_sym_QMARK] = ACTIONS(3107),
    [anon_sym_COLON_QMARK] = ACTIONS(3107),
    [anon_sym_COLON_COLON] = ACTIONS(3109),
    [anon_sym_AMP] = ACTIONS(3107),
    [anon_sym_LBRACK] = ACTIONS(3107),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3109),
    [anon_sym_LBRACE] = ACTIONS(3107),
    [anon_sym_LT_AT] = ACTIONS(3107),
    [anon_sym_AT_GT] = ACTIONS(3107),
    [anon_sym_LT_AT_AT] = ACTIONS(3107),
    [anon_sym_DOT] = ACTIONS(3107),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3109),
    [anon_sym_new] = ACTIONS(3107),
    [anon_sym_return_BANG] = ACTIONS(3109),
    [anon_sym_yield] = ACTIONS(3107),
    [anon_sym_yield_BANG] = ACTIONS(3109),
    [anon_sym_lazy] = ACTIONS(3107),
    [anon_sym_assert] = ACTIONS(3107),
    [anon_sym_upcast] = ACTIONS(3107),
    [anon_sym_downcast] = ACTIONS(3107),
    [anon_sym_COLON_GT] = ACTIONS(3109),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3109),
    [anon_sym_for] = ACTIONS(3107),
    [anon_sym_while] = ACTIONS(3107),
    [anon_sym_if] = ACTIONS(3107),
    [anon_sym_fun] = ACTIONS(3107),
    [anon_sym_try] = ACTIONS(3107),
    [anon_sym_match] = ACTIONS(3107),
    [anon_sym_match_BANG] = ACTIONS(3109),
    [anon_sym_function] = ACTIONS(3107),
    [anon_sym_LT_DASH] = ACTIONS(3107),
    [anon_sym_DOT_LBRACK] = ACTIONS(3109),
    [anon_sym_LT] = ACTIONS(3109),
    [anon_sym_use] = ACTIONS(3107),
    [anon_sym_use_BANG] = ACTIONS(3109),
    [anon_sym_do_BANG] = ACTIONS(3109),
    [anon_sym_begin] = ACTIONS(3107),
    [anon_sym_LPAREN2] = ACTIONS(3107),
    [anon_sym_or] = ACTIONS(3107),
    [aux_sym_char_token1] = ACTIONS(3109),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3107),
    [anon_sym_DQUOTE] = ACTIONS(3107),
    [anon_sym_AT_DQUOTE] = ACTIONS(3109),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3109),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3109),
    [sym_bool] = ACTIONS(3107),
    [sym_unit] = ACTIONS(3109),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3107),
    [sym_op_identifier] = ACTIONS(3107),
    [anon_sym_PLUS] = ACTIONS(3107),
    [anon_sym_DASH] = ACTIONS(3107),
    [anon_sym_PLUS_DOT] = ACTIONS(3107),
    [anon_sym_DASH_DOT] = ACTIONS(3107),
    [anon_sym_PERCENT] = ACTIONS(3107),
    [anon_sym_AMP_AMP] = ACTIONS(3107),
    [anon_sym_TILDE] = ACTIONS(3109),
    [aux_sym_prefix_op_token1] = ACTIONS(3107),
    [aux_sym_infix_op_token1] = ACTIONS(3109),
    [aux_sym_infix_op_token2] = ACTIONS(3107),
    [anon_sym_PIPE_PIPE] = ACTIONS(3107),
    [anon_sym_BANG_EQ] = ACTIONS(3107),
    [anon_sym_COLON_EQ] = ACTIONS(3109),
    [anon_sym_DOLLAR] = ACTIONS(3107),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3107),
    [sym_int] = ACTIONS(3107),
    [sym_xint] = ACTIONS(3109),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3109),
    [sym__newline] = ACTIONS(3109),
  },
  [2339] = {
    [sym_block_comment] = STATE(2339),
    [sym_compiler_directive_decl] = STATE(2339),
    [sym_fsi_directive_decl] = STATE(2339),
    [sym_preproc_line] = STATE(2339),
    [sym_identifier] = ACTIONS(2954),
    [anon_sym_EQ] = ACTIONS(2956),
    [anon_sym_COLON] = ACTIONS(2954),
    [anon_sym_return] = ACTIONS(2954),
    [anon_sym_do] = ACTIONS(2954),
    [anon_sym_let] = ACTIONS(2954),
    [anon_sym_let_BANG] = ACTIONS(2956),
    [anon_sym_LPAREN] = ACTIONS(2954),
    [anon_sym_COMMA] = ACTIONS(2956),
    [anon_sym_null] = ACTIONS(2954),
    [anon_sym_QMARK] = ACTIONS(2954),
    [anon_sym_COLON_QMARK] = ACTIONS(2954),
    [anon_sym_COLON_COLON] = ACTIONS(2956),
    [anon_sym_AMP] = ACTIONS(2954),
    [anon_sym_LBRACK] = ACTIONS(2954),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2956),
    [anon_sym_LBRACE] = ACTIONS(2954),
    [anon_sym_LT_AT] = ACTIONS(2954),
    [anon_sym_AT_GT] = ACTIONS(2954),
    [anon_sym_LT_AT_AT] = ACTIONS(2954),
    [anon_sym_DOT] = ACTIONS(2954),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2956),
    [anon_sym_new] = ACTIONS(2954),
    [anon_sym_return_BANG] = ACTIONS(2956),
    [anon_sym_yield] = ACTIONS(2954),
    [anon_sym_yield_BANG] = ACTIONS(2956),
    [anon_sym_lazy] = ACTIONS(2954),
    [anon_sym_assert] = ACTIONS(2954),
    [anon_sym_upcast] = ACTIONS(2954),
    [anon_sym_downcast] = ACTIONS(2954),
    [anon_sym_COLON_GT] = ACTIONS(2956),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2956),
    [anon_sym_for] = ACTIONS(2954),
    [anon_sym_while] = ACTIONS(2954),
    [anon_sym_if] = ACTIONS(2954),
    [anon_sym_fun] = ACTIONS(2954),
    [anon_sym_try] = ACTIONS(2954),
    [anon_sym_match] = ACTIONS(2954),
    [anon_sym_match_BANG] = ACTIONS(2956),
    [anon_sym_function] = ACTIONS(2954),
    [anon_sym_LT_DASH] = ACTIONS(2954),
    [anon_sym_DOT_LBRACK] = ACTIONS(2956),
    [anon_sym_LT] = ACTIONS(2956),
    [anon_sym_use] = ACTIONS(2954),
    [anon_sym_use_BANG] = ACTIONS(2956),
    [anon_sym_do_BANG] = ACTIONS(2956),
    [anon_sym_begin] = ACTIONS(2954),
    [anon_sym_LPAREN2] = ACTIONS(2954),
    [anon_sym_or] = ACTIONS(2954),
    [aux_sym_char_token1] = ACTIONS(2956),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2954),
    [anon_sym_DQUOTE] = ACTIONS(2954),
    [anon_sym_AT_DQUOTE] = ACTIONS(2956),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2956),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2956),
    [sym_bool] = ACTIONS(2954),
    [sym_unit] = ACTIONS(2956),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2954),
    [sym_op_identifier] = ACTIONS(2954),
    [anon_sym_PLUS] = ACTIONS(2954),
    [anon_sym_DASH] = ACTIONS(2954),
    [anon_sym_PLUS_DOT] = ACTIONS(2954),
    [anon_sym_DASH_DOT] = ACTIONS(2954),
    [anon_sym_PERCENT] = ACTIONS(2954),
    [anon_sym_AMP_AMP] = ACTIONS(2954),
    [anon_sym_TILDE] = ACTIONS(2956),
    [aux_sym_prefix_op_token1] = ACTIONS(2954),
    [aux_sym_infix_op_token1] = ACTIONS(2956),
    [aux_sym_infix_op_token2] = ACTIONS(2954),
    [anon_sym_PIPE_PIPE] = ACTIONS(2954),
    [anon_sym_BANG_EQ] = ACTIONS(2954),
    [anon_sym_COLON_EQ] = ACTIONS(2956),
    [anon_sym_DOLLAR] = ACTIONS(2954),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2954),
    [sym_int] = ACTIONS(2954),
    [sym_xint] = ACTIONS(2956),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2956),
    [sym__newline] = ACTIONS(2956),
  },
  [2340] = {
    [sym_block_comment] = STATE(2340),
    [sym_compiler_directive_decl] = STATE(2340),
    [sym_fsi_directive_decl] = STATE(2340),
    [sym_preproc_line] = STATE(2340),
    [sym_identifier] = ACTIONS(2926),
    [anon_sym_EQ] = ACTIONS(2928),
    [anon_sym_COLON] = ACTIONS(2926),
    [anon_sym_return] = ACTIONS(2926),
    [anon_sym_do] = ACTIONS(2926),
    [anon_sym_let] = ACTIONS(2926),
    [anon_sym_let_BANG] = ACTIONS(2928),
    [anon_sym_LPAREN] = ACTIONS(2926),
    [anon_sym_COMMA] = ACTIONS(2928),
    [anon_sym_null] = ACTIONS(2926),
    [anon_sym_QMARK] = ACTIONS(2926),
    [anon_sym_COLON_QMARK] = ACTIONS(2926),
    [anon_sym_COLON_COLON] = ACTIONS(2928),
    [anon_sym_AMP] = ACTIONS(2926),
    [anon_sym_LBRACK] = ACTIONS(2926),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2928),
    [anon_sym_LBRACE] = ACTIONS(2926),
    [anon_sym_LT_AT] = ACTIONS(2926),
    [anon_sym_LT_AT_AT] = ACTIONS(2926),
    [anon_sym_AT_AT_GT] = ACTIONS(2926),
    [anon_sym_DOT] = ACTIONS(2926),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2928),
    [anon_sym_new] = ACTIONS(2926),
    [anon_sym_return_BANG] = ACTIONS(2928),
    [anon_sym_yield] = ACTIONS(2926),
    [anon_sym_yield_BANG] = ACTIONS(2928),
    [anon_sym_lazy] = ACTIONS(2926),
    [anon_sym_assert] = ACTIONS(2926),
    [anon_sym_upcast] = ACTIONS(2926),
    [anon_sym_downcast] = ACTIONS(2926),
    [anon_sym_COLON_GT] = ACTIONS(2928),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2928),
    [anon_sym_for] = ACTIONS(2926),
    [anon_sym_while] = ACTIONS(2926),
    [anon_sym_if] = ACTIONS(2926),
    [anon_sym_fun] = ACTIONS(2926),
    [anon_sym_try] = ACTIONS(2926),
    [anon_sym_match] = ACTIONS(2926),
    [anon_sym_match_BANG] = ACTIONS(2928),
    [anon_sym_function] = ACTIONS(2926),
    [anon_sym_LT_DASH] = ACTIONS(2926),
    [anon_sym_DOT_LBRACK] = ACTIONS(2928),
    [anon_sym_LT] = ACTIONS(2928),
    [anon_sym_use] = ACTIONS(2926),
    [anon_sym_use_BANG] = ACTIONS(2928),
    [anon_sym_do_BANG] = ACTIONS(2928),
    [anon_sym_begin] = ACTIONS(2926),
    [anon_sym_LPAREN2] = ACTIONS(2926),
    [anon_sym_or] = ACTIONS(2926),
    [aux_sym_char_token1] = ACTIONS(2928),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2926),
    [anon_sym_DQUOTE] = ACTIONS(2926),
    [anon_sym_AT_DQUOTE] = ACTIONS(2928),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2928),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2928),
    [sym_bool] = ACTIONS(2926),
    [sym_unit] = ACTIONS(2928),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2926),
    [sym_op_identifier] = ACTIONS(2926),
    [anon_sym_PLUS] = ACTIONS(2926),
    [anon_sym_DASH] = ACTIONS(2926),
    [anon_sym_PLUS_DOT] = ACTIONS(2926),
    [anon_sym_DASH_DOT] = ACTIONS(2926),
    [anon_sym_PERCENT] = ACTIONS(2926),
    [anon_sym_AMP_AMP] = ACTIONS(2926),
    [anon_sym_TILDE] = ACTIONS(2928),
    [aux_sym_prefix_op_token1] = ACTIONS(2926),
    [aux_sym_infix_op_token1] = ACTIONS(2928),
    [aux_sym_infix_op_token2] = ACTIONS(2926),
    [anon_sym_PIPE_PIPE] = ACTIONS(2926),
    [anon_sym_BANG_EQ] = ACTIONS(2926),
    [anon_sym_COLON_EQ] = ACTIONS(2928),
    [anon_sym_DOLLAR] = ACTIONS(2926),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2926),
    [sym_int] = ACTIONS(2926),
    [sym_xint] = ACTIONS(2928),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2928),
    [sym__newline] = ACTIONS(2928),
  },
  [2341] = {
    [sym_block_comment] = STATE(2341),
    [sym_compiler_directive_decl] = STATE(2341),
    [sym_fsi_directive_decl] = STATE(2341),
    [sym_preproc_line] = STATE(2341),
    [sym_identifier] = ACTIONS(2938),
    [anon_sym_EQ] = ACTIONS(2940),
    [anon_sym_COLON] = ACTIONS(2938),
    [anon_sym_return] = ACTIONS(2938),
    [anon_sym_do] = ACTIONS(2938),
    [anon_sym_let] = ACTIONS(2938),
    [anon_sym_let_BANG] = ACTIONS(2940),
    [anon_sym_LPAREN] = ACTIONS(2938),
    [anon_sym_COMMA] = ACTIONS(2940),
    [anon_sym_null] = ACTIONS(2938),
    [anon_sym_QMARK] = ACTIONS(2938),
    [anon_sym_COLON_QMARK] = ACTIONS(2938),
    [anon_sym_COLON_COLON] = ACTIONS(2940),
    [anon_sym_AMP] = ACTIONS(2938),
    [anon_sym_LBRACK] = ACTIONS(2938),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2940),
    [anon_sym_LBRACE] = ACTIONS(2938),
    [anon_sym_LT_AT] = ACTIONS(2938),
    [anon_sym_LT_AT_AT] = ACTIONS(2938),
    [anon_sym_AT_AT_GT] = ACTIONS(2938),
    [anon_sym_DOT] = ACTIONS(2938),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2940),
    [anon_sym_new] = ACTIONS(2938),
    [anon_sym_return_BANG] = ACTIONS(2940),
    [anon_sym_yield] = ACTIONS(2938),
    [anon_sym_yield_BANG] = ACTIONS(2940),
    [anon_sym_lazy] = ACTIONS(2938),
    [anon_sym_assert] = ACTIONS(2938),
    [anon_sym_upcast] = ACTIONS(2938),
    [anon_sym_downcast] = ACTIONS(2938),
    [anon_sym_COLON_GT] = ACTIONS(2940),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2940),
    [anon_sym_for] = ACTIONS(2938),
    [anon_sym_while] = ACTIONS(2938),
    [anon_sym_if] = ACTIONS(2938),
    [anon_sym_fun] = ACTIONS(2938),
    [anon_sym_try] = ACTIONS(2938),
    [anon_sym_match] = ACTIONS(2938),
    [anon_sym_match_BANG] = ACTIONS(2940),
    [anon_sym_function] = ACTIONS(2938),
    [anon_sym_LT_DASH] = ACTIONS(2938),
    [anon_sym_DOT_LBRACK] = ACTIONS(2940),
    [anon_sym_LT] = ACTIONS(2940),
    [anon_sym_use] = ACTIONS(2938),
    [anon_sym_use_BANG] = ACTIONS(2940),
    [anon_sym_do_BANG] = ACTIONS(2940),
    [anon_sym_begin] = ACTIONS(2938),
    [anon_sym_LPAREN2] = ACTIONS(2938),
    [anon_sym_or] = ACTIONS(2938),
    [aux_sym_char_token1] = ACTIONS(2940),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2938),
    [anon_sym_DQUOTE] = ACTIONS(2938),
    [anon_sym_AT_DQUOTE] = ACTIONS(2940),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2940),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2940),
    [sym_bool] = ACTIONS(2938),
    [sym_unit] = ACTIONS(2940),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2938),
    [sym_op_identifier] = ACTIONS(2938),
    [anon_sym_PLUS] = ACTIONS(2938),
    [anon_sym_DASH] = ACTIONS(2938),
    [anon_sym_PLUS_DOT] = ACTIONS(2938),
    [anon_sym_DASH_DOT] = ACTIONS(2938),
    [anon_sym_PERCENT] = ACTIONS(2938),
    [anon_sym_AMP_AMP] = ACTIONS(2938),
    [anon_sym_TILDE] = ACTIONS(2940),
    [aux_sym_prefix_op_token1] = ACTIONS(2938),
    [aux_sym_infix_op_token1] = ACTIONS(2940),
    [aux_sym_infix_op_token2] = ACTIONS(2938),
    [anon_sym_PIPE_PIPE] = ACTIONS(2938),
    [anon_sym_BANG_EQ] = ACTIONS(2938),
    [anon_sym_COLON_EQ] = ACTIONS(2940),
    [anon_sym_DOLLAR] = ACTIONS(2938),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2938),
    [sym_int] = ACTIONS(2938),
    [sym_xint] = ACTIONS(2940),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2940),
    [sym__newline] = ACTIONS(2940),
  },
  [2342] = {
    [sym_block_comment] = STATE(2342),
    [sym_compiler_directive_decl] = STATE(2342),
    [sym_fsi_directive_decl] = STATE(2342),
    [sym_preproc_line] = STATE(2342),
    [sym_identifier] = ACTIONS(3111),
    [anon_sym_EQ] = ACTIONS(3113),
    [anon_sym_COLON] = ACTIONS(3111),
    [anon_sym_return] = ACTIONS(3111),
    [anon_sym_do] = ACTIONS(3111),
    [anon_sym_let] = ACTIONS(3111),
    [anon_sym_let_BANG] = ACTIONS(3113),
    [anon_sym_LPAREN] = ACTIONS(3111),
    [anon_sym_COMMA] = ACTIONS(3113),
    [anon_sym_null] = ACTIONS(3111),
    [anon_sym_QMARK] = ACTIONS(3111),
    [anon_sym_COLON_QMARK] = ACTIONS(3111),
    [anon_sym_COLON_COLON] = ACTIONS(3113),
    [anon_sym_AMP] = ACTIONS(3111),
    [anon_sym_LBRACK] = ACTIONS(3111),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3113),
    [anon_sym_LBRACE] = ACTIONS(3111),
    [anon_sym_LT_AT] = ACTIONS(3111),
    [anon_sym_AT_GT] = ACTIONS(3111),
    [anon_sym_LT_AT_AT] = ACTIONS(3111),
    [anon_sym_DOT] = ACTIONS(3111),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3113),
    [anon_sym_new] = ACTIONS(3111),
    [anon_sym_return_BANG] = ACTIONS(3113),
    [anon_sym_yield] = ACTIONS(3111),
    [anon_sym_yield_BANG] = ACTIONS(3113),
    [anon_sym_lazy] = ACTIONS(3111),
    [anon_sym_assert] = ACTIONS(3111),
    [anon_sym_upcast] = ACTIONS(3111),
    [anon_sym_downcast] = ACTIONS(3111),
    [anon_sym_COLON_GT] = ACTIONS(3113),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3113),
    [anon_sym_for] = ACTIONS(3111),
    [anon_sym_while] = ACTIONS(3111),
    [anon_sym_if] = ACTIONS(3111),
    [anon_sym_fun] = ACTIONS(3111),
    [anon_sym_try] = ACTIONS(3111),
    [anon_sym_match] = ACTIONS(3111),
    [anon_sym_match_BANG] = ACTIONS(3113),
    [anon_sym_function] = ACTIONS(3111),
    [anon_sym_LT_DASH] = ACTIONS(3111),
    [anon_sym_DOT_LBRACK] = ACTIONS(3113),
    [anon_sym_LT] = ACTIONS(3113),
    [anon_sym_use] = ACTIONS(3111),
    [anon_sym_use_BANG] = ACTIONS(3113),
    [anon_sym_do_BANG] = ACTIONS(3113),
    [anon_sym_begin] = ACTIONS(3111),
    [anon_sym_LPAREN2] = ACTIONS(3111),
    [anon_sym_or] = ACTIONS(3111),
    [aux_sym_char_token1] = ACTIONS(3113),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3111),
    [anon_sym_DQUOTE] = ACTIONS(3111),
    [anon_sym_AT_DQUOTE] = ACTIONS(3113),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3113),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3113),
    [sym_bool] = ACTIONS(3111),
    [sym_unit] = ACTIONS(3113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3111),
    [sym_op_identifier] = ACTIONS(3111),
    [anon_sym_PLUS] = ACTIONS(3111),
    [anon_sym_DASH] = ACTIONS(3111),
    [anon_sym_PLUS_DOT] = ACTIONS(3111),
    [anon_sym_DASH_DOT] = ACTIONS(3111),
    [anon_sym_PERCENT] = ACTIONS(3111),
    [anon_sym_AMP_AMP] = ACTIONS(3111),
    [anon_sym_TILDE] = ACTIONS(3113),
    [aux_sym_prefix_op_token1] = ACTIONS(3111),
    [aux_sym_infix_op_token1] = ACTIONS(3113),
    [aux_sym_infix_op_token2] = ACTIONS(3111),
    [anon_sym_PIPE_PIPE] = ACTIONS(3111),
    [anon_sym_BANG_EQ] = ACTIONS(3111),
    [anon_sym_COLON_EQ] = ACTIONS(3113),
    [anon_sym_DOLLAR] = ACTIONS(3111),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3111),
    [sym_int] = ACTIONS(3111),
    [sym_xint] = ACTIONS(3113),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3113),
    [sym__newline] = ACTIONS(3113),
  },
  [2343] = {
    [sym_block_comment] = STATE(2343),
    [sym_compiler_directive_decl] = STATE(2343),
    [sym_fsi_directive_decl] = STATE(2343),
    [sym_preproc_line] = STATE(2343),
    [sym_identifier] = ACTIONS(2835),
    [anon_sym_EQ] = ACTIONS(2837),
    [anon_sym_COLON] = ACTIONS(2835),
    [anon_sym_return] = ACTIONS(2835),
    [anon_sym_do] = ACTIONS(2835),
    [anon_sym_let] = ACTIONS(2835),
    [anon_sym_let_BANG] = ACTIONS(2837),
    [anon_sym_LPAREN] = ACTIONS(2835),
    [anon_sym_COMMA] = ACTIONS(2837),
    [anon_sym_null] = ACTIONS(2835),
    [anon_sym_QMARK] = ACTIONS(2835),
    [anon_sym_COLON_QMARK] = ACTIONS(2835),
    [anon_sym_COLON_COLON] = ACTIONS(2837),
    [anon_sym_AMP] = ACTIONS(2835),
    [anon_sym_LBRACK] = ACTIONS(2835),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2837),
    [anon_sym_LBRACE] = ACTIONS(2835),
    [anon_sym_LT_AT] = ACTIONS(2835),
    [anon_sym_AT_GT] = ACTIONS(2835),
    [anon_sym_LT_AT_AT] = ACTIONS(2835),
    [anon_sym_DOT] = ACTIONS(2835),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2837),
    [anon_sym_new] = ACTIONS(2835),
    [anon_sym_return_BANG] = ACTIONS(2837),
    [anon_sym_yield] = ACTIONS(2835),
    [anon_sym_yield_BANG] = ACTIONS(2837),
    [anon_sym_lazy] = ACTIONS(2835),
    [anon_sym_assert] = ACTIONS(2835),
    [anon_sym_upcast] = ACTIONS(2835),
    [anon_sym_downcast] = ACTIONS(2835),
    [anon_sym_COLON_GT] = ACTIONS(2837),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2837),
    [anon_sym_for] = ACTIONS(2835),
    [anon_sym_while] = ACTIONS(2835),
    [anon_sym_if] = ACTIONS(2835),
    [anon_sym_fun] = ACTIONS(2835),
    [anon_sym_try] = ACTIONS(2835),
    [anon_sym_match] = ACTIONS(2835),
    [anon_sym_match_BANG] = ACTIONS(2837),
    [anon_sym_function] = ACTIONS(2835),
    [anon_sym_LT_DASH] = ACTIONS(2835),
    [anon_sym_DOT_LBRACK] = ACTIONS(2837),
    [anon_sym_LT] = ACTIONS(2837),
    [anon_sym_use] = ACTIONS(2835),
    [anon_sym_use_BANG] = ACTIONS(2837),
    [anon_sym_do_BANG] = ACTIONS(2837),
    [anon_sym_begin] = ACTIONS(2835),
    [anon_sym_LPAREN2] = ACTIONS(2835),
    [anon_sym_or] = ACTIONS(2835),
    [aux_sym_char_token1] = ACTIONS(2837),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2835),
    [anon_sym_DQUOTE] = ACTIONS(2835),
    [anon_sym_AT_DQUOTE] = ACTIONS(2837),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2837),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2837),
    [sym_bool] = ACTIONS(2835),
    [sym_unit] = ACTIONS(2837),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2835),
    [sym_op_identifier] = ACTIONS(2835),
    [anon_sym_PLUS] = ACTIONS(2835),
    [anon_sym_DASH] = ACTIONS(2835),
    [anon_sym_PLUS_DOT] = ACTIONS(2835),
    [anon_sym_DASH_DOT] = ACTIONS(2835),
    [anon_sym_PERCENT] = ACTIONS(2835),
    [anon_sym_AMP_AMP] = ACTIONS(2835),
    [anon_sym_TILDE] = ACTIONS(2837),
    [aux_sym_prefix_op_token1] = ACTIONS(2835),
    [aux_sym_infix_op_token1] = ACTIONS(2837),
    [aux_sym_infix_op_token2] = ACTIONS(2835),
    [anon_sym_PIPE_PIPE] = ACTIONS(2835),
    [anon_sym_BANG_EQ] = ACTIONS(2835),
    [anon_sym_COLON_EQ] = ACTIONS(2837),
    [anon_sym_DOLLAR] = ACTIONS(2835),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2835),
    [sym_int] = ACTIONS(2835),
    [sym_xint] = ACTIONS(2837),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2837),
    [sym__newline] = ACTIONS(2837),
  },
  [2344] = {
    [sym_block_comment] = STATE(2344),
    [sym_compiler_directive_decl] = STATE(2344),
    [sym_fsi_directive_decl] = STATE(2344),
    [sym_preproc_line] = STATE(2344),
    [sym_identifier] = ACTIONS(3063),
    [anon_sym_EQ] = ACTIONS(3065),
    [anon_sym_COLON] = ACTIONS(3063),
    [anon_sym_return] = ACTIONS(3063),
    [anon_sym_do] = ACTIONS(3063),
    [anon_sym_let] = ACTIONS(3063),
    [anon_sym_let_BANG] = ACTIONS(3065),
    [anon_sym_LPAREN] = ACTIONS(3063),
    [anon_sym_COMMA] = ACTIONS(3065),
    [anon_sym_null] = ACTIONS(3063),
    [anon_sym_QMARK] = ACTIONS(3063),
    [anon_sym_COLON_QMARK] = ACTIONS(3063),
    [anon_sym_COLON_COLON] = ACTIONS(3065),
    [anon_sym_AMP] = ACTIONS(3063),
    [anon_sym_LBRACK] = ACTIONS(3063),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3065),
    [anon_sym_LBRACE] = ACTIONS(3063),
    [anon_sym_LT_AT] = ACTIONS(3063),
    [anon_sym_LT_AT_AT] = ACTIONS(3063),
    [anon_sym_AT_AT_GT] = ACTIONS(3063),
    [anon_sym_DOT] = ACTIONS(3063),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3065),
    [anon_sym_new] = ACTIONS(3063),
    [anon_sym_return_BANG] = ACTIONS(3065),
    [anon_sym_yield] = ACTIONS(3063),
    [anon_sym_yield_BANG] = ACTIONS(3065),
    [anon_sym_lazy] = ACTIONS(3063),
    [anon_sym_assert] = ACTIONS(3063),
    [anon_sym_upcast] = ACTIONS(3063),
    [anon_sym_downcast] = ACTIONS(3063),
    [anon_sym_COLON_GT] = ACTIONS(3065),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3065),
    [anon_sym_for] = ACTIONS(3063),
    [anon_sym_while] = ACTIONS(3063),
    [anon_sym_if] = ACTIONS(3063),
    [anon_sym_fun] = ACTIONS(3063),
    [anon_sym_try] = ACTIONS(3063),
    [anon_sym_match] = ACTIONS(3063),
    [anon_sym_match_BANG] = ACTIONS(3065),
    [anon_sym_function] = ACTIONS(3063),
    [anon_sym_LT_DASH] = ACTIONS(3063),
    [anon_sym_DOT_LBRACK] = ACTIONS(3065),
    [anon_sym_LT] = ACTIONS(3065),
    [anon_sym_use] = ACTIONS(3063),
    [anon_sym_use_BANG] = ACTIONS(3065),
    [anon_sym_do_BANG] = ACTIONS(3065),
    [anon_sym_begin] = ACTIONS(3063),
    [anon_sym_LPAREN2] = ACTIONS(3063),
    [anon_sym_or] = ACTIONS(3063),
    [aux_sym_char_token1] = ACTIONS(3065),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3063),
    [anon_sym_DQUOTE] = ACTIONS(3063),
    [anon_sym_AT_DQUOTE] = ACTIONS(3065),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3065),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3065),
    [sym_bool] = ACTIONS(3063),
    [sym_unit] = ACTIONS(3065),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3063),
    [sym_op_identifier] = ACTIONS(3063),
    [anon_sym_PLUS] = ACTIONS(3063),
    [anon_sym_DASH] = ACTIONS(3063),
    [anon_sym_PLUS_DOT] = ACTIONS(3063),
    [anon_sym_DASH_DOT] = ACTIONS(3063),
    [anon_sym_PERCENT] = ACTIONS(3063),
    [anon_sym_AMP_AMP] = ACTIONS(3063),
    [anon_sym_TILDE] = ACTIONS(3065),
    [aux_sym_prefix_op_token1] = ACTIONS(3063),
    [aux_sym_infix_op_token1] = ACTIONS(3065),
    [aux_sym_infix_op_token2] = ACTIONS(3063),
    [anon_sym_PIPE_PIPE] = ACTIONS(3063),
    [anon_sym_BANG_EQ] = ACTIONS(3063),
    [anon_sym_COLON_EQ] = ACTIONS(3065),
    [anon_sym_DOLLAR] = ACTIONS(3063),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3063),
    [sym_int] = ACTIONS(3063),
    [sym_xint] = ACTIONS(3065),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3065),
    [sym__newline] = ACTIONS(3065),
  },
  [2345] = {
    [sym_block_comment] = STATE(2345),
    [sym_compiler_directive_decl] = STATE(2345),
    [sym_fsi_directive_decl] = STATE(2345),
    [sym_preproc_line] = STATE(2345),
    [sym_identifier] = ACTIONS(3059),
    [anon_sym_EQ] = ACTIONS(3061),
    [anon_sym_COLON] = ACTIONS(3059),
    [anon_sym_return] = ACTIONS(3059),
    [anon_sym_do] = ACTIONS(3059),
    [anon_sym_let] = ACTIONS(3059),
    [anon_sym_let_BANG] = ACTIONS(3061),
    [anon_sym_LPAREN] = ACTIONS(3059),
    [anon_sym_COMMA] = ACTIONS(3061),
    [anon_sym_null] = ACTIONS(3059),
    [anon_sym_QMARK] = ACTIONS(3059),
    [anon_sym_COLON_QMARK] = ACTIONS(3059),
    [anon_sym_COLON_COLON] = ACTIONS(3061),
    [anon_sym_AMP] = ACTIONS(3059),
    [anon_sym_LBRACK] = ACTIONS(3059),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3061),
    [anon_sym_LBRACE] = ACTIONS(3059),
    [anon_sym_LT_AT] = ACTIONS(3059),
    [anon_sym_LT_AT_AT] = ACTIONS(3059),
    [anon_sym_AT_AT_GT] = ACTIONS(3059),
    [anon_sym_DOT] = ACTIONS(3059),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3061),
    [anon_sym_new] = ACTIONS(3059),
    [anon_sym_return_BANG] = ACTIONS(3061),
    [anon_sym_yield] = ACTIONS(3059),
    [anon_sym_yield_BANG] = ACTIONS(3061),
    [anon_sym_lazy] = ACTIONS(3059),
    [anon_sym_assert] = ACTIONS(3059),
    [anon_sym_upcast] = ACTIONS(3059),
    [anon_sym_downcast] = ACTIONS(3059),
    [anon_sym_COLON_GT] = ACTIONS(3061),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3061),
    [anon_sym_for] = ACTIONS(3059),
    [anon_sym_while] = ACTIONS(3059),
    [anon_sym_if] = ACTIONS(3059),
    [anon_sym_fun] = ACTIONS(3059),
    [anon_sym_try] = ACTIONS(3059),
    [anon_sym_match] = ACTIONS(3059),
    [anon_sym_match_BANG] = ACTIONS(3061),
    [anon_sym_function] = ACTIONS(3059),
    [anon_sym_LT_DASH] = ACTIONS(3059),
    [anon_sym_DOT_LBRACK] = ACTIONS(3061),
    [anon_sym_LT] = ACTIONS(3061),
    [anon_sym_use] = ACTIONS(3059),
    [anon_sym_use_BANG] = ACTIONS(3061),
    [anon_sym_do_BANG] = ACTIONS(3061),
    [anon_sym_begin] = ACTIONS(3059),
    [anon_sym_LPAREN2] = ACTIONS(3059),
    [anon_sym_or] = ACTIONS(3059),
    [aux_sym_char_token1] = ACTIONS(3061),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3059),
    [anon_sym_DQUOTE] = ACTIONS(3059),
    [anon_sym_AT_DQUOTE] = ACTIONS(3061),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3061),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3061),
    [sym_bool] = ACTIONS(3059),
    [sym_unit] = ACTIONS(3061),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3059),
    [sym_op_identifier] = ACTIONS(3059),
    [anon_sym_PLUS] = ACTIONS(3059),
    [anon_sym_DASH] = ACTIONS(3059),
    [anon_sym_PLUS_DOT] = ACTIONS(3059),
    [anon_sym_DASH_DOT] = ACTIONS(3059),
    [anon_sym_PERCENT] = ACTIONS(3059),
    [anon_sym_AMP_AMP] = ACTIONS(3059),
    [anon_sym_TILDE] = ACTIONS(3061),
    [aux_sym_prefix_op_token1] = ACTIONS(3059),
    [aux_sym_infix_op_token1] = ACTIONS(3061),
    [aux_sym_infix_op_token2] = ACTIONS(3059),
    [anon_sym_PIPE_PIPE] = ACTIONS(3059),
    [anon_sym_BANG_EQ] = ACTIONS(3059),
    [anon_sym_COLON_EQ] = ACTIONS(3061),
    [anon_sym_DOLLAR] = ACTIONS(3059),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3059),
    [sym_int] = ACTIONS(3059),
    [sym_xint] = ACTIONS(3061),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3061),
    [sym__newline] = ACTIONS(3061),
  },
  [2346] = {
    [sym_block_comment] = STATE(2346),
    [sym_compiler_directive_decl] = STATE(2346),
    [sym_fsi_directive_decl] = STATE(2346),
    [sym_preproc_line] = STATE(2346),
    [sym_identifier] = ACTIONS(3051),
    [anon_sym_EQ] = ACTIONS(3053),
    [anon_sym_COLON] = ACTIONS(3051),
    [anon_sym_return] = ACTIONS(3051),
    [anon_sym_do] = ACTIONS(3051),
    [anon_sym_let] = ACTIONS(3051),
    [anon_sym_let_BANG] = ACTIONS(3053),
    [anon_sym_LPAREN] = ACTIONS(3051),
    [anon_sym_COMMA] = ACTIONS(3053),
    [anon_sym_null] = ACTIONS(3051),
    [anon_sym_QMARK] = ACTIONS(3051),
    [anon_sym_COLON_QMARK] = ACTIONS(3051),
    [anon_sym_COLON_COLON] = ACTIONS(3053),
    [anon_sym_AMP] = ACTIONS(3051),
    [anon_sym_LBRACK] = ACTIONS(3051),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3053),
    [anon_sym_LBRACE] = ACTIONS(3051),
    [anon_sym_LT_AT] = ACTIONS(3051),
    [anon_sym_LT_AT_AT] = ACTIONS(3051),
    [anon_sym_AT_AT_GT] = ACTIONS(3051),
    [anon_sym_DOT] = ACTIONS(3051),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3053),
    [anon_sym_new] = ACTIONS(3051),
    [anon_sym_return_BANG] = ACTIONS(3053),
    [anon_sym_yield] = ACTIONS(3051),
    [anon_sym_yield_BANG] = ACTIONS(3053),
    [anon_sym_lazy] = ACTIONS(3051),
    [anon_sym_assert] = ACTIONS(3051),
    [anon_sym_upcast] = ACTIONS(3051),
    [anon_sym_downcast] = ACTIONS(3051),
    [anon_sym_COLON_GT] = ACTIONS(3053),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3053),
    [anon_sym_for] = ACTIONS(3051),
    [anon_sym_while] = ACTIONS(3051),
    [anon_sym_if] = ACTIONS(3051),
    [anon_sym_fun] = ACTIONS(3051),
    [anon_sym_try] = ACTIONS(3051),
    [anon_sym_match] = ACTIONS(3051),
    [anon_sym_match_BANG] = ACTIONS(3053),
    [anon_sym_function] = ACTIONS(3051),
    [anon_sym_LT_DASH] = ACTIONS(3051),
    [anon_sym_DOT_LBRACK] = ACTIONS(3053),
    [anon_sym_LT] = ACTIONS(3053),
    [anon_sym_use] = ACTIONS(3051),
    [anon_sym_use_BANG] = ACTIONS(3053),
    [anon_sym_do_BANG] = ACTIONS(3053),
    [anon_sym_begin] = ACTIONS(3051),
    [anon_sym_LPAREN2] = ACTIONS(3051),
    [anon_sym_or] = ACTIONS(3051),
    [aux_sym_char_token1] = ACTIONS(3053),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3051),
    [anon_sym_DQUOTE] = ACTIONS(3051),
    [anon_sym_AT_DQUOTE] = ACTIONS(3053),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3053),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3053),
    [sym_bool] = ACTIONS(3051),
    [sym_unit] = ACTIONS(3053),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3051),
    [sym_op_identifier] = ACTIONS(3051),
    [anon_sym_PLUS] = ACTIONS(3051),
    [anon_sym_DASH] = ACTIONS(3051),
    [anon_sym_PLUS_DOT] = ACTIONS(3051),
    [anon_sym_DASH_DOT] = ACTIONS(3051),
    [anon_sym_PERCENT] = ACTIONS(3051),
    [anon_sym_AMP_AMP] = ACTIONS(3051),
    [anon_sym_TILDE] = ACTIONS(3053),
    [aux_sym_prefix_op_token1] = ACTIONS(3051),
    [aux_sym_infix_op_token1] = ACTIONS(3053),
    [aux_sym_infix_op_token2] = ACTIONS(3051),
    [anon_sym_PIPE_PIPE] = ACTIONS(3051),
    [anon_sym_BANG_EQ] = ACTIONS(3051),
    [anon_sym_COLON_EQ] = ACTIONS(3053),
    [anon_sym_DOLLAR] = ACTIONS(3051),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3051),
    [sym_int] = ACTIONS(3051),
    [sym_xint] = ACTIONS(3053),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3053),
    [sym__newline] = ACTIONS(3053),
  },
  [2347] = {
    [sym_block_comment] = STATE(2347),
    [sym_compiler_directive_decl] = STATE(2347),
    [sym_fsi_directive_decl] = STATE(2347),
    [sym_preproc_line] = STATE(2347),
    [sym_identifier] = ACTIONS(3119),
    [anon_sym_EQ] = ACTIONS(3121),
    [anon_sym_COLON] = ACTIONS(3119),
    [anon_sym_return] = ACTIONS(3119),
    [anon_sym_do] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_let_BANG] = ACTIONS(3121),
    [anon_sym_LPAREN] = ACTIONS(3119),
    [anon_sym_COMMA] = ACTIONS(3121),
    [anon_sym_null] = ACTIONS(3119),
    [anon_sym_QMARK] = ACTIONS(3119),
    [anon_sym_COLON_QMARK] = ACTIONS(3119),
    [anon_sym_COLON_COLON] = ACTIONS(3121),
    [anon_sym_AMP] = ACTIONS(3119),
    [anon_sym_LBRACK] = ACTIONS(3119),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3121),
    [anon_sym_LBRACE] = ACTIONS(3119),
    [anon_sym_LT_AT] = ACTIONS(3119),
    [anon_sym_AT_GT] = ACTIONS(3119),
    [anon_sym_LT_AT_AT] = ACTIONS(3119),
    [anon_sym_DOT] = ACTIONS(3119),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3121),
    [anon_sym_new] = ACTIONS(3119),
    [anon_sym_return_BANG] = ACTIONS(3121),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_yield_BANG] = ACTIONS(3121),
    [anon_sym_lazy] = ACTIONS(3119),
    [anon_sym_assert] = ACTIONS(3119),
    [anon_sym_upcast] = ACTIONS(3119),
    [anon_sym_downcast] = ACTIONS(3119),
    [anon_sym_COLON_GT] = ACTIONS(3121),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3121),
    [anon_sym_for] = ACTIONS(3119),
    [anon_sym_while] = ACTIONS(3119),
    [anon_sym_if] = ACTIONS(3119),
    [anon_sym_fun] = ACTIONS(3119),
    [anon_sym_try] = ACTIONS(3119),
    [anon_sym_match] = ACTIONS(3119),
    [anon_sym_match_BANG] = ACTIONS(3121),
    [anon_sym_function] = ACTIONS(3119),
    [anon_sym_LT_DASH] = ACTIONS(3119),
    [anon_sym_DOT_LBRACK] = ACTIONS(3121),
    [anon_sym_LT] = ACTIONS(3121),
    [anon_sym_use] = ACTIONS(3119),
    [anon_sym_use_BANG] = ACTIONS(3121),
    [anon_sym_do_BANG] = ACTIONS(3121),
    [anon_sym_begin] = ACTIONS(3119),
    [anon_sym_LPAREN2] = ACTIONS(3119),
    [anon_sym_or] = ACTIONS(3119),
    [aux_sym_char_token1] = ACTIONS(3121),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3119),
    [anon_sym_DQUOTE] = ACTIONS(3119),
    [anon_sym_AT_DQUOTE] = ACTIONS(3121),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3121),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3121),
    [sym_bool] = ACTIONS(3119),
    [sym_unit] = ACTIONS(3121),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3119),
    [sym_op_identifier] = ACTIONS(3119),
    [anon_sym_PLUS] = ACTIONS(3119),
    [anon_sym_DASH] = ACTIONS(3119),
    [anon_sym_PLUS_DOT] = ACTIONS(3119),
    [anon_sym_DASH_DOT] = ACTIONS(3119),
    [anon_sym_PERCENT] = ACTIONS(3119),
    [anon_sym_AMP_AMP] = ACTIONS(3119),
    [anon_sym_TILDE] = ACTIONS(3121),
    [aux_sym_prefix_op_token1] = ACTIONS(3119),
    [aux_sym_infix_op_token1] = ACTIONS(3121),
    [aux_sym_infix_op_token2] = ACTIONS(3119),
    [anon_sym_PIPE_PIPE] = ACTIONS(3119),
    [anon_sym_BANG_EQ] = ACTIONS(3119),
    [anon_sym_COLON_EQ] = ACTIONS(3121),
    [anon_sym_DOLLAR] = ACTIONS(3119),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3119),
    [sym_int] = ACTIONS(3119),
    [sym_xint] = ACTIONS(3121),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3121),
    [sym__newline] = ACTIONS(3121),
  },
  [2348] = {
    [sym_block_comment] = STATE(2348),
    [sym_compiler_directive_decl] = STATE(2348),
    [sym_fsi_directive_decl] = STATE(2348),
    [sym_preproc_line] = STATE(2348),
    [sym_identifier] = ACTIONS(3135),
    [anon_sym_EQ] = ACTIONS(3137),
    [anon_sym_COLON] = ACTIONS(3135),
    [anon_sym_return] = ACTIONS(3135),
    [anon_sym_do] = ACTIONS(3135),
    [anon_sym_let] = ACTIONS(3135),
    [anon_sym_let_BANG] = ACTIONS(3137),
    [anon_sym_LPAREN] = ACTIONS(3135),
    [anon_sym_COMMA] = ACTIONS(3137),
    [anon_sym_null] = ACTIONS(3135),
    [anon_sym_QMARK] = ACTIONS(3135),
    [anon_sym_COLON_QMARK] = ACTIONS(3135),
    [anon_sym_COLON_COLON] = ACTIONS(3137),
    [anon_sym_AMP] = ACTIONS(3135),
    [anon_sym_LBRACK] = ACTIONS(3135),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3137),
    [anon_sym_LBRACE] = ACTIONS(3135),
    [anon_sym_LT_AT] = ACTIONS(3135),
    [anon_sym_AT_GT] = ACTIONS(3135),
    [anon_sym_LT_AT_AT] = ACTIONS(3135),
    [anon_sym_DOT] = ACTIONS(3135),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3137),
    [anon_sym_new] = ACTIONS(3135),
    [anon_sym_return_BANG] = ACTIONS(3137),
    [anon_sym_yield] = ACTIONS(3135),
    [anon_sym_yield_BANG] = ACTIONS(3137),
    [anon_sym_lazy] = ACTIONS(3135),
    [anon_sym_assert] = ACTIONS(3135),
    [anon_sym_upcast] = ACTIONS(3135),
    [anon_sym_downcast] = ACTIONS(3135),
    [anon_sym_COLON_GT] = ACTIONS(3137),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3137),
    [anon_sym_for] = ACTIONS(3135),
    [anon_sym_while] = ACTIONS(3135),
    [anon_sym_if] = ACTIONS(3135),
    [anon_sym_fun] = ACTIONS(3135),
    [anon_sym_try] = ACTIONS(3135),
    [anon_sym_match] = ACTIONS(3135),
    [anon_sym_match_BANG] = ACTIONS(3137),
    [anon_sym_function] = ACTIONS(3135),
    [anon_sym_LT_DASH] = ACTIONS(3135),
    [anon_sym_DOT_LBRACK] = ACTIONS(3137),
    [anon_sym_LT] = ACTIONS(3137),
    [anon_sym_use] = ACTIONS(3135),
    [anon_sym_use_BANG] = ACTIONS(3137),
    [anon_sym_do_BANG] = ACTIONS(3137),
    [anon_sym_begin] = ACTIONS(3135),
    [anon_sym_LPAREN2] = ACTIONS(3135),
    [anon_sym_or] = ACTIONS(3135),
    [aux_sym_char_token1] = ACTIONS(3137),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3135),
    [anon_sym_DQUOTE] = ACTIONS(3135),
    [anon_sym_AT_DQUOTE] = ACTIONS(3137),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3137),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3137),
    [sym_bool] = ACTIONS(3135),
    [sym_unit] = ACTIONS(3137),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3135),
    [sym_op_identifier] = ACTIONS(3135),
    [anon_sym_PLUS] = ACTIONS(3135),
    [anon_sym_DASH] = ACTIONS(3135),
    [anon_sym_PLUS_DOT] = ACTIONS(3135),
    [anon_sym_DASH_DOT] = ACTIONS(3135),
    [anon_sym_PERCENT] = ACTIONS(3135),
    [anon_sym_AMP_AMP] = ACTIONS(3135),
    [anon_sym_TILDE] = ACTIONS(3137),
    [aux_sym_prefix_op_token1] = ACTIONS(3135),
    [aux_sym_infix_op_token1] = ACTIONS(3137),
    [aux_sym_infix_op_token2] = ACTIONS(3135),
    [anon_sym_PIPE_PIPE] = ACTIONS(3135),
    [anon_sym_BANG_EQ] = ACTIONS(3135),
    [anon_sym_COLON_EQ] = ACTIONS(3137),
    [anon_sym_DOLLAR] = ACTIONS(3135),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3135),
    [sym_int] = ACTIONS(3135),
    [sym_xint] = ACTIONS(3137),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3137),
    [sym__newline] = ACTIONS(3137),
  },
  [2349] = {
    [sym_block_comment] = STATE(2349),
    [sym_compiler_directive_decl] = STATE(2349),
    [sym_fsi_directive_decl] = STATE(2349),
    [sym_preproc_line] = STATE(2349),
    [sym_identifier] = ACTIONS(3139),
    [anon_sym_EQ] = ACTIONS(3141),
    [anon_sym_COLON] = ACTIONS(3139),
    [anon_sym_return] = ACTIONS(3139),
    [anon_sym_do] = ACTIONS(3139),
    [anon_sym_let] = ACTIONS(3139),
    [anon_sym_let_BANG] = ACTIONS(3141),
    [anon_sym_LPAREN] = ACTIONS(3139),
    [anon_sym_COMMA] = ACTIONS(3141),
    [anon_sym_null] = ACTIONS(3139),
    [anon_sym_QMARK] = ACTIONS(3139),
    [anon_sym_COLON_QMARK] = ACTIONS(3139),
    [anon_sym_COLON_COLON] = ACTIONS(3141),
    [anon_sym_AMP] = ACTIONS(3139),
    [anon_sym_LBRACK] = ACTIONS(3139),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3141),
    [anon_sym_LBRACE] = ACTIONS(3139),
    [anon_sym_LT_AT] = ACTIONS(3139),
    [anon_sym_AT_GT] = ACTIONS(3139),
    [anon_sym_LT_AT_AT] = ACTIONS(3139),
    [anon_sym_DOT] = ACTIONS(3139),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3141),
    [anon_sym_new] = ACTIONS(3139),
    [anon_sym_return_BANG] = ACTIONS(3141),
    [anon_sym_yield] = ACTIONS(3139),
    [anon_sym_yield_BANG] = ACTIONS(3141),
    [anon_sym_lazy] = ACTIONS(3139),
    [anon_sym_assert] = ACTIONS(3139),
    [anon_sym_upcast] = ACTIONS(3139),
    [anon_sym_downcast] = ACTIONS(3139),
    [anon_sym_COLON_GT] = ACTIONS(3141),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3141),
    [anon_sym_for] = ACTIONS(3139),
    [anon_sym_while] = ACTIONS(3139),
    [anon_sym_if] = ACTIONS(3139),
    [anon_sym_fun] = ACTIONS(3139),
    [anon_sym_try] = ACTIONS(3139),
    [anon_sym_match] = ACTIONS(3139),
    [anon_sym_match_BANG] = ACTIONS(3141),
    [anon_sym_function] = ACTIONS(3139),
    [anon_sym_LT_DASH] = ACTIONS(3139),
    [anon_sym_DOT_LBRACK] = ACTIONS(3141),
    [anon_sym_LT] = ACTIONS(3141),
    [anon_sym_use] = ACTIONS(3139),
    [anon_sym_use_BANG] = ACTIONS(3141),
    [anon_sym_do_BANG] = ACTIONS(3141),
    [anon_sym_begin] = ACTIONS(3139),
    [anon_sym_LPAREN2] = ACTIONS(3139),
    [anon_sym_or] = ACTIONS(3139),
    [aux_sym_char_token1] = ACTIONS(3141),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3139),
    [anon_sym_DQUOTE] = ACTIONS(3139),
    [anon_sym_AT_DQUOTE] = ACTIONS(3141),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3141),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3141),
    [sym_bool] = ACTIONS(3139),
    [sym_unit] = ACTIONS(3141),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3139),
    [sym_op_identifier] = ACTIONS(3139),
    [anon_sym_PLUS] = ACTIONS(3139),
    [anon_sym_DASH] = ACTIONS(3139),
    [anon_sym_PLUS_DOT] = ACTIONS(3139),
    [anon_sym_DASH_DOT] = ACTIONS(3139),
    [anon_sym_PERCENT] = ACTIONS(3139),
    [anon_sym_AMP_AMP] = ACTIONS(3139),
    [anon_sym_TILDE] = ACTIONS(3141),
    [aux_sym_prefix_op_token1] = ACTIONS(3139),
    [aux_sym_infix_op_token1] = ACTIONS(3141),
    [aux_sym_infix_op_token2] = ACTIONS(3139),
    [anon_sym_PIPE_PIPE] = ACTIONS(3139),
    [anon_sym_BANG_EQ] = ACTIONS(3139),
    [anon_sym_COLON_EQ] = ACTIONS(3141),
    [anon_sym_DOLLAR] = ACTIONS(3139),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3139),
    [sym_int] = ACTIONS(3139),
    [sym_xint] = ACTIONS(3141),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3141),
    [sym__newline] = ACTIONS(3141),
  },
  [2350] = {
    [sym_block_comment] = STATE(2350),
    [sym_compiler_directive_decl] = STATE(2350),
    [sym_fsi_directive_decl] = STATE(2350),
    [sym_preproc_line] = STATE(2350),
    [sym_identifier] = ACTIONS(3131),
    [anon_sym_EQ] = ACTIONS(3133),
    [anon_sym_COLON] = ACTIONS(3131),
    [anon_sym_return] = ACTIONS(3131),
    [anon_sym_do] = ACTIONS(3131),
    [anon_sym_let] = ACTIONS(3131),
    [anon_sym_let_BANG] = ACTIONS(3133),
    [anon_sym_LPAREN] = ACTIONS(3131),
    [anon_sym_COMMA] = ACTIONS(3133),
    [anon_sym_null] = ACTIONS(3131),
    [anon_sym_QMARK] = ACTIONS(3131),
    [anon_sym_COLON_QMARK] = ACTIONS(3131),
    [anon_sym_COLON_COLON] = ACTIONS(3133),
    [anon_sym_AMP] = ACTIONS(3131),
    [anon_sym_LBRACK] = ACTIONS(3131),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3133),
    [anon_sym_LBRACE] = ACTIONS(3131),
    [anon_sym_LT_AT] = ACTIONS(3131),
    [anon_sym_AT_GT] = ACTIONS(3131),
    [anon_sym_LT_AT_AT] = ACTIONS(3131),
    [anon_sym_DOT] = ACTIONS(3131),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3133),
    [anon_sym_new] = ACTIONS(3131),
    [anon_sym_return_BANG] = ACTIONS(3133),
    [anon_sym_yield] = ACTIONS(3131),
    [anon_sym_yield_BANG] = ACTIONS(3133),
    [anon_sym_lazy] = ACTIONS(3131),
    [anon_sym_assert] = ACTIONS(3131),
    [anon_sym_upcast] = ACTIONS(3131),
    [anon_sym_downcast] = ACTIONS(3131),
    [anon_sym_COLON_GT] = ACTIONS(3133),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3133),
    [anon_sym_for] = ACTIONS(3131),
    [anon_sym_while] = ACTIONS(3131),
    [anon_sym_if] = ACTIONS(3131),
    [anon_sym_fun] = ACTIONS(3131),
    [anon_sym_try] = ACTIONS(3131),
    [anon_sym_match] = ACTIONS(3131),
    [anon_sym_match_BANG] = ACTIONS(3133),
    [anon_sym_function] = ACTIONS(3131),
    [anon_sym_LT_DASH] = ACTIONS(3131),
    [anon_sym_DOT_LBRACK] = ACTIONS(3133),
    [anon_sym_LT] = ACTIONS(3133),
    [anon_sym_use] = ACTIONS(3131),
    [anon_sym_use_BANG] = ACTIONS(3133),
    [anon_sym_do_BANG] = ACTIONS(3133),
    [anon_sym_begin] = ACTIONS(3131),
    [anon_sym_LPAREN2] = ACTIONS(3131),
    [anon_sym_or] = ACTIONS(3131),
    [aux_sym_char_token1] = ACTIONS(3133),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3131),
    [anon_sym_DQUOTE] = ACTIONS(3131),
    [anon_sym_AT_DQUOTE] = ACTIONS(3133),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3133),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3133),
    [sym_bool] = ACTIONS(3131),
    [sym_unit] = ACTIONS(3133),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3131),
    [sym_op_identifier] = ACTIONS(3131),
    [anon_sym_PLUS] = ACTIONS(3131),
    [anon_sym_DASH] = ACTIONS(3131),
    [anon_sym_PLUS_DOT] = ACTIONS(3131),
    [anon_sym_DASH_DOT] = ACTIONS(3131),
    [anon_sym_PERCENT] = ACTIONS(3131),
    [anon_sym_AMP_AMP] = ACTIONS(3131),
    [anon_sym_TILDE] = ACTIONS(3133),
    [aux_sym_prefix_op_token1] = ACTIONS(3131),
    [aux_sym_infix_op_token1] = ACTIONS(3133),
    [aux_sym_infix_op_token2] = ACTIONS(3131),
    [anon_sym_PIPE_PIPE] = ACTIONS(3131),
    [anon_sym_BANG_EQ] = ACTIONS(3131),
    [anon_sym_COLON_EQ] = ACTIONS(3133),
    [anon_sym_DOLLAR] = ACTIONS(3131),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3131),
    [sym_int] = ACTIONS(3131),
    [sym_xint] = ACTIONS(3133),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3133),
    [sym__newline] = ACTIONS(3133),
  },
  [2351] = {
    [sym_attributes] = STATE(2676),
    [sym__attribute_set] = STATE(4045),
    [sym__function_or_value_defn_body] = STATE(2841),
    [sym_function_declaration_left] = STATE(6065),
    [sym_value_declaration_left] = STATE(6065),
    [sym_access_modifier] = STATE(2693),
    [sym_repeat_pattern] = STATE(4815),
    [sym__pattern] = STATE(5168),
    [sym_optional_pattern] = STATE(4815),
    [sym_type_check_pattern] = STATE(4815),
    [sym_attribute_pattern] = STATE(4815),
    [sym_paren_pattern] = STATE(4815),
    [sym_as_pattern] = STATE(4815),
    [sym_cons_pattern] = STATE(4815),
    [sym_disjunct_pattern] = STATE(4815),
    [sym_conjunct_pattern] = STATE(4815),
    [sym_typed_pattern] = STATE(4815),
    [sym_list_pattern] = STATE(4815),
    [sym_array_pattern] = STATE(4815),
    [sym_record_pattern] = STATE(4815),
    [sym_named_field_pattern] = STATE(4815),
    [sym_identifier_pattern] = STATE(4815),
    [sym_long_identifier_or_op] = STATE(1792),
    [sym_char] = STATE(4765),
    [sym_format_string] = STATE(4746),
    [sym__string_literal] = STATE(4746),
    [sym_string] = STATE(4765),
    [sym_verbatim_string] = STATE(4765),
    [sym_bytearray] = STATE(4765),
    [sym_verbatim_bytearray] = STATE(4765),
    [sym_format_triple_quoted_string] = STATE(4720),
    [sym_triple_quoted_string] = STATE(4765),
    [sym_const] = STATE(4815),
    [sym_long_identifier] = STATE(3320),
    [sym_active_pattern] = STATE(3488),
    [sym__identifier_or_op] = STATE(2746),
    [sym_sbyte] = STATE(4765),
    [sym_byte] = STATE(4765),
    [sym_int16] = STATE(4765),
    [sym_uint16] = STATE(4765),
    [sym_int32] = STATE(4765),
    [sym_uint32] = STATE(4765),
    [sym_nativeint] = STATE(4765),
    [sym_unativeint] = STATE(4765),
    [sym_int64] = STATE(4765),
    [sym_uint64] = STATE(4765),
    [sym_ieee32] = STATE(4765),
    [sym_ieee64] = STATE(4765),
    [sym_bignum] = STATE(4765),
    [sym_decimal] = STATE(4765),
    [sym_float] = STATE(4512),
    [sym_block_comment] = STATE(2351),
    [sym_compiler_directive_decl] = STATE(2351),
    [sym_fsi_directive_decl] = STATE(2351),
    [sym_preproc_line] = STATE(2351),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(3562),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_rec] = ACTIONS(4302),
    [anon_sym_inline] = ACTIONS(3566),
    [anon_sym_mutable] = ACTIONS(3568),
    [aux_sym_access_modifier_token1] = ACTIONS(3570),
    [anon_sym_LPAREN] = ACTIONS(3572),
    [anon_sym_null] = ACTIONS(3574),
    [anon_sym__] = ACTIONS(3576),
    [anon_sym_QMARK] = ACTIONS(3578),
    [anon_sym_COLON_QMARK] = ACTIONS(3580),
    [anon_sym_LBRACK] = ACTIONS(3582),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3584),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [aux_sym_char_token1] = ACTIONS(3590),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3592),
    [anon_sym_DQUOTE] = ACTIONS(3594),
    [anon_sym_AT_DQUOTE] = ACTIONS(3596),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3598),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3600),
    [sym_bool] = ACTIONS(3602),
    [sym_unit] = ACTIONS(3604),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3606),
    [sym_op_identifier] = ACTIONS(3608),
    [sym_int] = ACTIONS(3610),
    [sym_xint] = ACTIONS(3612),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2352] = {
    [sym_block_comment] = STATE(2352),
    [sym_compiler_directive_decl] = STATE(2352),
    [sym_fsi_directive_decl] = STATE(2352),
    [sym_preproc_line] = STATE(2352),
    [sym_identifier] = ACTIONS(3127),
    [anon_sym_EQ] = ACTIONS(3129),
    [anon_sym_COLON] = ACTIONS(3127),
    [anon_sym_return] = ACTIONS(3127),
    [anon_sym_do] = ACTIONS(3127),
    [anon_sym_let] = ACTIONS(3127),
    [anon_sym_let_BANG] = ACTIONS(3129),
    [anon_sym_LPAREN] = ACTIONS(3127),
    [anon_sym_COMMA] = ACTIONS(3129),
    [anon_sym_null] = ACTIONS(3127),
    [anon_sym_QMARK] = ACTIONS(3127),
    [anon_sym_COLON_QMARK] = ACTIONS(3127),
    [anon_sym_COLON_COLON] = ACTIONS(3129),
    [anon_sym_AMP] = ACTIONS(3127),
    [anon_sym_LBRACK] = ACTIONS(3127),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3129),
    [anon_sym_LBRACE] = ACTIONS(3127),
    [anon_sym_LT_AT] = ACTIONS(3127),
    [anon_sym_AT_GT] = ACTIONS(3127),
    [anon_sym_LT_AT_AT] = ACTIONS(3127),
    [anon_sym_DOT] = ACTIONS(3127),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3129),
    [anon_sym_new] = ACTIONS(3127),
    [anon_sym_return_BANG] = ACTIONS(3129),
    [anon_sym_yield] = ACTIONS(3127),
    [anon_sym_yield_BANG] = ACTIONS(3129),
    [anon_sym_lazy] = ACTIONS(3127),
    [anon_sym_assert] = ACTIONS(3127),
    [anon_sym_upcast] = ACTIONS(3127),
    [anon_sym_downcast] = ACTIONS(3127),
    [anon_sym_COLON_GT] = ACTIONS(3129),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3129),
    [anon_sym_for] = ACTIONS(3127),
    [anon_sym_while] = ACTIONS(3127),
    [anon_sym_if] = ACTIONS(3127),
    [anon_sym_fun] = ACTIONS(3127),
    [anon_sym_try] = ACTIONS(3127),
    [anon_sym_match] = ACTIONS(3127),
    [anon_sym_match_BANG] = ACTIONS(3129),
    [anon_sym_function] = ACTIONS(3127),
    [anon_sym_LT_DASH] = ACTIONS(3127),
    [anon_sym_DOT_LBRACK] = ACTIONS(3129),
    [anon_sym_LT] = ACTIONS(3129),
    [anon_sym_use] = ACTIONS(3127),
    [anon_sym_use_BANG] = ACTIONS(3129),
    [anon_sym_do_BANG] = ACTIONS(3129),
    [anon_sym_begin] = ACTIONS(3127),
    [anon_sym_LPAREN2] = ACTIONS(3127),
    [anon_sym_or] = ACTIONS(3127),
    [aux_sym_char_token1] = ACTIONS(3129),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3127),
    [anon_sym_DQUOTE] = ACTIONS(3127),
    [anon_sym_AT_DQUOTE] = ACTIONS(3129),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3129),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3129),
    [sym_bool] = ACTIONS(3127),
    [sym_unit] = ACTIONS(3129),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3127),
    [sym_op_identifier] = ACTIONS(3127),
    [anon_sym_PLUS] = ACTIONS(3127),
    [anon_sym_DASH] = ACTIONS(3127),
    [anon_sym_PLUS_DOT] = ACTIONS(3127),
    [anon_sym_DASH_DOT] = ACTIONS(3127),
    [anon_sym_PERCENT] = ACTIONS(3127),
    [anon_sym_AMP_AMP] = ACTIONS(3127),
    [anon_sym_TILDE] = ACTIONS(3129),
    [aux_sym_prefix_op_token1] = ACTIONS(3127),
    [aux_sym_infix_op_token1] = ACTIONS(3129),
    [aux_sym_infix_op_token2] = ACTIONS(3127),
    [anon_sym_PIPE_PIPE] = ACTIONS(3127),
    [anon_sym_BANG_EQ] = ACTIONS(3127),
    [anon_sym_COLON_EQ] = ACTIONS(3129),
    [anon_sym_DOLLAR] = ACTIONS(3127),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3127),
    [sym_int] = ACTIONS(3127),
    [sym_xint] = ACTIONS(3129),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3129),
    [sym__newline] = ACTIONS(3129),
  },
  [2353] = {
    [sym_block_comment] = STATE(2353),
    [sym_compiler_directive_decl] = STATE(2353),
    [sym_fsi_directive_decl] = STATE(2353),
    [sym_preproc_line] = STATE(2353),
    [sym_identifier] = ACTIONS(2946),
    [anon_sym_EQ] = ACTIONS(2948),
    [anon_sym_COLON] = ACTIONS(2946),
    [anon_sym_return] = ACTIONS(2946),
    [anon_sym_do] = ACTIONS(2946),
    [anon_sym_let] = ACTIONS(2946),
    [anon_sym_let_BANG] = ACTIONS(2948),
    [anon_sym_LPAREN] = ACTIONS(2946),
    [anon_sym_COMMA] = ACTIONS(2948),
    [anon_sym_null] = ACTIONS(2946),
    [anon_sym_QMARK] = ACTIONS(2946),
    [anon_sym_COLON_QMARK] = ACTIONS(2946),
    [anon_sym_COLON_COLON] = ACTIONS(2948),
    [anon_sym_AMP] = ACTIONS(2946),
    [anon_sym_LBRACK] = ACTIONS(2946),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2948),
    [anon_sym_LBRACE] = ACTIONS(2946),
    [anon_sym_LT_AT] = ACTIONS(2946),
    [anon_sym_LT_AT_AT] = ACTIONS(2946),
    [anon_sym_AT_AT_GT] = ACTIONS(2946),
    [anon_sym_DOT] = ACTIONS(2946),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2948),
    [anon_sym_new] = ACTIONS(2946),
    [anon_sym_return_BANG] = ACTIONS(2948),
    [anon_sym_yield] = ACTIONS(2946),
    [anon_sym_yield_BANG] = ACTIONS(2948),
    [anon_sym_lazy] = ACTIONS(2946),
    [anon_sym_assert] = ACTIONS(2946),
    [anon_sym_upcast] = ACTIONS(2946),
    [anon_sym_downcast] = ACTIONS(2946),
    [anon_sym_COLON_GT] = ACTIONS(2948),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2948),
    [anon_sym_for] = ACTIONS(2946),
    [anon_sym_while] = ACTIONS(2946),
    [anon_sym_if] = ACTIONS(2946),
    [anon_sym_fun] = ACTIONS(2946),
    [anon_sym_try] = ACTIONS(2946),
    [anon_sym_match] = ACTIONS(2946),
    [anon_sym_match_BANG] = ACTIONS(2948),
    [anon_sym_function] = ACTIONS(2946),
    [anon_sym_LT_DASH] = ACTIONS(2946),
    [anon_sym_DOT_LBRACK] = ACTIONS(2948),
    [anon_sym_LT] = ACTIONS(2948),
    [anon_sym_use] = ACTIONS(2946),
    [anon_sym_use_BANG] = ACTIONS(2948),
    [anon_sym_do_BANG] = ACTIONS(2948),
    [anon_sym_begin] = ACTIONS(2946),
    [anon_sym_LPAREN2] = ACTIONS(2946),
    [anon_sym_or] = ACTIONS(2946),
    [aux_sym_char_token1] = ACTIONS(2948),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2946),
    [anon_sym_DQUOTE] = ACTIONS(2946),
    [anon_sym_AT_DQUOTE] = ACTIONS(2948),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2948),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2948),
    [sym_bool] = ACTIONS(2946),
    [sym_unit] = ACTIONS(2948),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2946),
    [sym_op_identifier] = ACTIONS(2946),
    [anon_sym_PLUS] = ACTIONS(2946),
    [anon_sym_DASH] = ACTIONS(2946),
    [anon_sym_PLUS_DOT] = ACTIONS(2946),
    [anon_sym_DASH_DOT] = ACTIONS(2946),
    [anon_sym_PERCENT] = ACTIONS(2946),
    [anon_sym_AMP_AMP] = ACTIONS(2946),
    [anon_sym_TILDE] = ACTIONS(2948),
    [aux_sym_prefix_op_token1] = ACTIONS(2946),
    [aux_sym_infix_op_token1] = ACTIONS(2948),
    [aux_sym_infix_op_token2] = ACTIONS(2946),
    [anon_sym_PIPE_PIPE] = ACTIONS(2946),
    [anon_sym_BANG_EQ] = ACTIONS(2946),
    [anon_sym_COLON_EQ] = ACTIONS(2948),
    [anon_sym_DOLLAR] = ACTIONS(2946),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2946),
    [sym_int] = ACTIONS(2946),
    [sym_xint] = ACTIONS(2948),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2948),
    [sym__newline] = ACTIONS(2948),
  },
  [2354] = {
    [sym_block_comment] = STATE(2354),
    [sym_compiler_directive_decl] = STATE(2354),
    [sym_fsi_directive_decl] = STATE(2354),
    [sym_preproc_line] = STATE(2354),
    [sym_identifier] = ACTIONS(2950),
    [anon_sym_EQ] = ACTIONS(2952),
    [anon_sym_COLON] = ACTIONS(2950),
    [anon_sym_return] = ACTIONS(2950),
    [anon_sym_do] = ACTIONS(2950),
    [anon_sym_let] = ACTIONS(2950),
    [anon_sym_let_BANG] = ACTIONS(2952),
    [anon_sym_LPAREN] = ACTIONS(2950),
    [anon_sym_COMMA] = ACTIONS(2952),
    [anon_sym_null] = ACTIONS(2950),
    [anon_sym_QMARK] = ACTIONS(2950),
    [anon_sym_COLON_QMARK] = ACTIONS(2950),
    [anon_sym_COLON_COLON] = ACTIONS(2952),
    [anon_sym_AMP] = ACTIONS(2950),
    [anon_sym_LBRACK] = ACTIONS(2950),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2952),
    [anon_sym_LBRACE] = ACTIONS(2950),
    [anon_sym_LT_AT] = ACTIONS(2950),
    [anon_sym_LT_AT_AT] = ACTIONS(2950),
    [anon_sym_AT_AT_GT] = ACTIONS(2950),
    [anon_sym_DOT] = ACTIONS(2950),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2952),
    [anon_sym_new] = ACTIONS(2950),
    [anon_sym_return_BANG] = ACTIONS(2952),
    [anon_sym_yield] = ACTIONS(2950),
    [anon_sym_yield_BANG] = ACTIONS(2952),
    [anon_sym_lazy] = ACTIONS(2950),
    [anon_sym_assert] = ACTIONS(2950),
    [anon_sym_upcast] = ACTIONS(2950),
    [anon_sym_downcast] = ACTIONS(2950),
    [anon_sym_COLON_GT] = ACTIONS(2952),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2952),
    [anon_sym_for] = ACTIONS(2950),
    [anon_sym_while] = ACTIONS(2950),
    [anon_sym_if] = ACTIONS(2950),
    [anon_sym_fun] = ACTIONS(2950),
    [anon_sym_try] = ACTIONS(2950),
    [anon_sym_match] = ACTIONS(2950),
    [anon_sym_match_BANG] = ACTIONS(2952),
    [anon_sym_function] = ACTIONS(2950),
    [anon_sym_LT_DASH] = ACTIONS(2950),
    [anon_sym_DOT_LBRACK] = ACTIONS(2952),
    [anon_sym_LT] = ACTIONS(2952),
    [anon_sym_use] = ACTIONS(2950),
    [anon_sym_use_BANG] = ACTIONS(2952),
    [anon_sym_do_BANG] = ACTIONS(2952),
    [anon_sym_begin] = ACTIONS(2950),
    [anon_sym_LPAREN2] = ACTIONS(2950),
    [anon_sym_or] = ACTIONS(2950),
    [aux_sym_char_token1] = ACTIONS(2952),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2950),
    [anon_sym_DQUOTE] = ACTIONS(2950),
    [anon_sym_AT_DQUOTE] = ACTIONS(2952),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2952),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2952),
    [sym_bool] = ACTIONS(2950),
    [sym_unit] = ACTIONS(2952),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2950),
    [sym_op_identifier] = ACTIONS(2950),
    [anon_sym_PLUS] = ACTIONS(2950),
    [anon_sym_DASH] = ACTIONS(2950),
    [anon_sym_PLUS_DOT] = ACTIONS(2950),
    [anon_sym_DASH_DOT] = ACTIONS(2950),
    [anon_sym_PERCENT] = ACTIONS(2950),
    [anon_sym_AMP_AMP] = ACTIONS(2950),
    [anon_sym_TILDE] = ACTIONS(2952),
    [aux_sym_prefix_op_token1] = ACTIONS(2950),
    [aux_sym_infix_op_token1] = ACTIONS(2952),
    [aux_sym_infix_op_token2] = ACTIONS(2950),
    [anon_sym_PIPE_PIPE] = ACTIONS(2950),
    [anon_sym_BANG_EQ] = ACTIONS(2950),
    [anon_sym_COLON_EQ] = ACTIONS(2952),
    [anon_sym_DOLLAR] = ACTIONS(2950),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2950),
    [sym_int] = ACTIONS(2950),
    [sym_xint] = ACTIONS(2952),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2952),
    [sym__newline] = ACTIONS(2952),
  },
  [2355] = {
    [sym_block_comment] = STATE(2355),
    [sym_compiler_directive_decl] = STATE(2355),
    [sym_fsi_directive_decl] = STATE(2355),
    [sym_preproc_line] = STATE(2355),
    [sym_identifier] = ACTIONS(3047),
    [anon_sym_EQ] = ACTIONS(3049),
    [anon_sym_COLON] = ACTIONS(3047),
    [anon_sym_return] = ACTIONS(3047),
    [anon_sym_do] = ACTIONS(3047),
    [anon_sym_let] = ACTIONS(3047),
    [anon_sym_let_BANG] = ACTIONS(3049),
    [anon_sym_LPAREN] = ACTIONS(3047),
    [anon_sym_COMMA] = ACTIONS(3049),
    [anon_sym_null] = ACTIONS(3047),
    [anon_sym_QMARK] = ACTIONS(3047),
    [anon_sym_COLON_QMARK] = ACTIONS(3047),
    [anon_sym_COLON_COLON] = ACTIONS(3049),
    [anon_sym_AMP] = ACTIONS(3047),
    [anon_sym_LBRACK] = ACTIONS(3047),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3049),
    [anon_sym_LBRACE] = ACTIONS(3047),
    [anon_sym_LT_AT] = ACTIONS(3047),
    [anon_sym_LT_AT_AT] = ACTIONS(3047),
    [anon_sym_AT_AT_GT] = ACTIONS(3047),
    [anon_sym_DOT] = ACTIONS(3047),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3049),
    [anon_sym_new] = ACTIONS(3047),
    [anon_sym_return_BANG] = ACTIONS(3049),
    [anon_sym_yield] = ACTIONS(3047),
    [anon_sym_yield_BANG] = ACTIONS(3049),
    [anon_sym_lazy] = ACTIONS(3047),
    [anon_sym_assert] = ACTIONS(3047),
    [anon_sym_upcast] = ACTIONS(3047),
    [anon_sym_downcast] = ACTIONS(3047),
    [anon_sym_COLON_GT] = ACTIONS(3049),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3049),
    [anon_sym_for] = ACTIONS(3047),
    [anon_sym_while] = ACTIONS(3047),
    [anon_sym_if] = ACTIONS(3047),
    [anon_sym_fun] = ACTIONS(3047),
    [anon_sym_try] = ACTIONS(3047),
    [anon_sym_match] = ACTIONS(3047),
    [anon_sym_match_BANG] = ACTIONS(3049),
    [anon_sym_function] = ACTIONS(3047),
    [anon_sym_LT_DASH] = ACTIONS(3047),
    [anon_sym_DOT_LBRACK] = ACTIONS(3049),
    [anon_sym_LT] = ACTIONS(3049),
    [anon_sym_use] = ACTIONS(3047),
    [anon_sym_use_BANG] = ACTIONS(3049),
    [anon_sym_do_BANG] = ACTIONS(3049),
    [anon_sym_begin] = ACTIONS(3047),
    [anon_sym_LPAREN2] = ACTIONS(3047),
    [anon_sym_or] = ACTIONS(3047),
    [aux_sym_char_token1] = ACTIONS(3049),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3047),
    [anon_sym_DQUOTE] = ACTIONS(3047),
    [anon_sym_AT_DQUOTE] = ACTIONS(3049),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3049),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3049),
    [sym_bool] = ACTIONS(3047),
    [sym_unit] = ACTIONS(3049),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3047),
    [sym_op_identifier] = ACTIONS(3047),
    [anon_sym_PLUS] = ACTIONS(3047),
    [anon_sym_DASH] = ACTIONS(3047),
    [anon_sym_PLUS_DOT] = ACTIONS(3047),
    [anon_sym_DASH_DOT] = ACTIONS(3047),
    [anon_sym_PERCENT] = ACTIONS(3047),
    [anon_sym_AMP_AMP] = ACTIONS(3047),
    [anon_sym_TILDE] = ACTIONS(3049),
    [aux_sym_prefix_op_token1] = ACTIONS(3047),
    [aux_sym_infix_op_token1] = ACTIONS(3049),
    [aux_sym_infix_op_token2] = ACTIONS(3047),
    [anon_sym_PIPE_PIPE] = ACTIONS(3047),
    [anon_sym_BANG_EQ] = ACTIONS(3047),
    [anon_sym_COLON_EQ] = ACTIONS(3049),
    [anon_sym_DOLLAR] = ACTIONS(3047),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3047),
    [sym_int] = ACTIONS(3047),
    [sym_xint] = ACTIONS(3049),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3049),
    [sym__newline] = ACTIONS(3049),
  },
  [2356] = {
    [sym_block_comment] = STATE(2356),
    [sym_compiler_directive_decl] = STATE(2356),
    [sym_fsi_directive_decl] = STATE(2356),
    [sym_preproc_line] = STATE(2356),
    [sym_identifier] = ACTIONS(3043),
    [anon_sym_EQ] = ACTIONS(3045),
    [anon_sym_COLON] = ACTIONS(3043),
    [anon_sym_return] = ACTIONS(3043),
    [anon_sym_do] = ACTIONS(3043),
    [anon_sym_let] = ACTIONS(3043),
    [anon_sym_let_BANG] = ACTIONS(3045),
    [anon_sym_LPAREN] = ACTIONS(3043),
    [anon_sym_COMMA] = ACTIONS(3045),
    [anon_sym_null] = ACTIONS(3043),
    [anon_sym_QMARK] = ACTIONS(3043),
    [anon_sym_COLON_QMARK] = ACTIONS(3043),
    [anon_sym_COLON_COLON] = ACTIONS(3045),
    [anon_sym_AMP] = ACTIONS(3043),
    [anon_sym_LBRACK] = ACTIONS(3043),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3045),
    [anon_sym_LBRACE] = ACTIONS(3043),
    [anon_sym_LT_AT] = ACTIONS(3043),
    [anon_sym_LT_AT_AT] = ACTIONS(3043),
    [anon_sym_AT_AT_GT] = ACTIONS(3043),
    [anon_sym_DOT] = ACTIONS(3043),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3045),
    [anon_sym_new] = ACTIONS(3043),
    [anon_sym_return_BANG] = ACTIONS(3045),
    [anon_sym_yield] = ACTIONS(3043),
    [anon_sym_yield_BANG] = ACTIONS(3045),
    [anon_sym_lazy] = ACTIONS(3043),
    [anon_sym_assert] = ACTIONS(3043),
    [anon_sym_upcast] = ACTIONS(3043),
    [anon_sym_downcast] = ACTIONS(3043),
    [anon_sym_COLON_GT] = ACTIONS(3045),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3045),
    [anon_sym_for] = ACTIONS(3043),
    [anon_sym_while] = ACTIONS(3043),
    [anon_sym_if] = ACTIONS(3043),
    [anon_sym_fun] = ACTIONS(3043),
    [anon_sym_try] = ACTIONS(3043),
    [anon_sym_match] = ACTIONS(3043),
    [anon_sym_match_BANG] = ACTIONS(3045),
    [anon_sym_function] = ACTIONS(3043),
    [anon_sym_LT_DASH] = ACTIONS(3043),
    [anon_sym_DOT_LBRACK] = ACTIONS(3045),
    [anon_sym_LT] = ACTIONS(3045),
    [anon_sym_use] = ACTIONS(3043),
    [anon_sym_use_BANG] = ACTIONS(3045),
    [anon_sym_do_BANG] = ACTIONS(3045),
    [anon_sym_begin] = ACTIONS(3043),
    [anon_sym_LPAREN2] = ACTIONS(3043),
    [anon_sym_or] = ACTIONS(3043),
    [aux_sym_char_token1] = ACTIONS(3045),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3043),
    [anon_sym_DQUOTE] = ACTIONS(3043),
    [anon_sym_AT_DQUOTE] = ACTIONS(3045),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3045),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3045),
    [sym_bool] = ACTIONS(3043),
    [sym_unit] = ACTIONS(3045),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3043),
    [sym_op_identifier] = ACTIONS(3043),
    [anon_sym_PLUS] = ACTIONS(3043),
    [anon_sym_DASH] = ACTIONS(3043),
    [anon_sym_PLUS_DOT] = ACTIONS(3043),
    [anon_sym_DASH_DOT] = ACTIONS(3043),
    [anon_sym_PERCENT] = ACTIONS(3043),
    [anon_sym_AMP_AMP] = ACTIONS(3043),
    [anon_sym_TILDE] = ACTIONS(3045),
    [aux_sym_prefix_op_token1] = ACTIONS(3043),
    [aux_sym_infix_op_token1] = ACTIONS(3045),
    [aux_sym_infix_op_token2] = ACTIONS(3043),
    [anon_sym_PIPE_PIPE] = ACTIONS(3043),
    [anon_sym_BANG_EQ] = ACTIONS(3043),
    [anon_sym_COLON_EQ] = ACTIONS(3045),
    [anon_sym_DOLLAR] = ACTIONS(3043),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3043),
    [sym_int] = ACTIONS(3043),
    [sym_xint] = ACTIONS(3045),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3045),
    [sym__newline] = ACTIONS(3045),
  },
  [2357] = {
    [sym_block_comment] = STATE(2357),
    [sym_compiler_directive_decl] = STATE(2357),
    [sym_fsi_directive_decl] = STATE(2357),
    [sym_preproc_line] = STATE(2357),
    [sym_identifier] = ACTIONS(3039),
    [anon_sym_EQ] = ACTIONS(3041),
    [anon_sym_COLON] = ACTIONS(3039),
    [anon_sym_return] = ACTIONS(3039),
    [anon_sym_do] = ACTIONS(3039),
    [anon_sym_let] = ACTIONS(3039),
    [anon_sym_let_BANG] = ACTIONS(3041),
    [anon_sym_LPAREN] = ACTIONS(3039),
    [anon_sym_COMMA] = ACTIONS(3041),
    [anon_sym_null] = ACTIONS(3039),
    [anon_sym_QMARK] = ACTIONS(3039),
    [anon_sym_COLON_QMARK] = ACTIONS(3039),
    [anon_sym_COLON_COLON] = ACTIONS(3041),
    [anon_sym_AMP] = ACTIONS(3039),
    [anon_sym_LBRACK] = ACTIONS(3039),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3041),
    [anon_sym_LBRACE] = ACTIONS(3039),
    [anon_sym_LT_AT] = ACTIONS(3039),
    [anon_sym_LT_AT_AT] = ACTIONS(3039),
    [anon_sym_AT_AT_GT] = ACTIONS(3039),
    [anon_sym_DOT] = ACTIONS(3039),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3041),
    [anon_sym_new] = ACTIONS(3039),
    [anon_sym_return_BANG] = ACTIONS(3041),
    [anon_sym_yield] = ACTIONS(3039),
    [anon_sym_yield_BANG] = ACTIONS(3041),
    [anon_sym_lazy] = ACTIONS(3039),
    [anon_sym_assert] = ACTIONS(3039),
    [anon_sym_upcast] = ACTIONS(3039),
    [anon_sym_downcast] = ACTIONS(3039),
    [anon_sym_COLON_GT] = ACTIONS(3041),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3041),
    [anon_sym_for] = ACTIONS(3039),
    [anon_sym_while] = ACTIONS(3039),
    [anon_sym_if] = ACTIONS(3039),
    [anon_sym_fun] = ACTIONS(3039),
    [anon_sym_try] = ACTIONS(3039),
    [anon_sym_match] = ACTIONS(3039),
    [anon_sym_match_BANG] = ACTIONS(3041),
    [anon_sym_function] = ACTIONS(3039),
    [anon_sym_LT_DASH] = ACTIONS(3039),
    [anon_sym_DOT_LBRACK] = ACTIONS(3041),
    [anon_sym_LT] = ACTIONS(3041),
    [anon_sym_use] = ACTIONS(3039),
    [anon_sym_use_BANG] = ACTIONS(3041),
    [anon_sym_do_BANG] = ACTIONS(3041),
    [anon_sym_begin] = ACTIONS(3039),
    [anon_sym_LPAREN2] = ACTIONS(3039),
    [anon_sym_or] = ACTIONS(3039),
    [aux_sym_char_token1] = ACTIONS(3041),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3039),
    [anon_sym_DQUOTE] = ACTIONS(3039),
    [anon_sym_AT_DQUOTE] = ACTIONS(3041),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3041),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3041),
    [sym_bool] = ACTIONS(3039),
    [sym_unit] = ACTIONS(3041),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3039),
    [sym_op_identifier] = ACTIONS(3039),
    [anon_sym_PLUS] = ACTIONS(3039),
    [anon_sym_DASH] = ACTIONS(3039),
    [anon_sym_PLUS_DOT] = ACTIONS(3039),
    [anon_sym_DASH_DOT] = ACTIONS(3039),
    [anon_sym_PERCENT] = ACTIONS(3039),
    [anon_sym_AMP_AMP] = ACTIONS(3039),
    [anon_sym_TILDE] = ACTIONS(3041),
    [aux_sym_prefix_op_token1] = ACTIONS(3039),
    [aux_sym_infix_op_token1] = ACTIONS(3041),
    [aux_sym_infix_op_token2] = ACTIONS(3039),
    [anon_sym_PIPE_PIPE] = ACTIONS(3039),
    [anon_sym_BANG_EQ] = ACTIONS(3039),
    [anon_sym_COLON_EQ] = ACTIONS(3041),
    [anon_sym_DOLLAR] = ACTIONS(3039),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3039),
    [sym_int] = ACTIONS(3039),
    [sym_xint] = ACTIONS(3041),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3041),
    [sym__newline] = ACTIONS(3041),
  },
  [2358] = {
    [sym_block_comment] = STATE(2358),
    [sym_compiler_directive_decl] = STATE(2358),
    [sym_fsi_directive_decl] = STATE(2358),
    [sym_preproc_line] = STATE(2358),
    [sym_identifier] = ACTIONS(3123),
    [anon_sym_EQ] = ACTIONS(3125),
    [anon_sym_COLON] = ACTIONS(3123),
    [anon_sym_return] = ACTIONS(3123),
    [anon_sym_do] = ACTIONS(3123),
    [anon_sym_let] = ACTIONS(3123),
    [anon_sym_let_BANG] = ACTIONS(3125),
    [anon_sym_LPAREN] = ACTIONS(3123),
    [anon_sym_COMMA] = ACTIONS(3125),
    [anon_sym_null] = ACTIONS(3123),
    [anon_sym_QMARK] = ACTIONS(3123),
    [anon_sym_COLON_QMARK] = ACTIONS(3123),
    [anon_sym_COLON_COLON] = ACTIONS(3125),
    [anon_sym_AMP] = ACTIONS(3123),
    [anon_sym_LBRACK] = ACTIONS(3123),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3125),
    [anon_sym_LBRACE] = ACTIONS(3123),
    [anon_sym_LT_AT] = ACTIONS(3123),
    [anon_sym_AT_GT] = ACTIONS(3123),
    [anon_sym_LT_AT_AT] = ACTIONS(3123),
    [anon_sym_DOT] = ACTIONS(3123),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3125),
    [anon_sym_new] = ACTIONS(3123),
    [anon_sym_return_BANG] = ACTIONS(3125),
    [anon_sym_yield] = ACTIONS(3123),
    [anon_sym_yield_BANG] = ACTIONS(3125),
    [anon_sym_lazy] = ACTIONS(3123),
    [anon_sym_assert] = ACTIONS(3123),
    [anon_sym_upcast] = ACTIONS(3123),
    [anon_sym_downcast] = ACTIONS(3123),
    [anon_sym_COLON_GT] = ACTIONS(3125),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3125),
    [anon_sym_for] = ACTIONS(3123),
    [anon_sym_while] = ACTIONS(3123),
    [anon_sym_if] = ACTIONS(3123),
    [anon_sym_fun] = ACTIONS(3123),
    [anon_sym_try] = ACTIONS(3123),
    [anon_sym_match] = ACTIONS(3123),
    [anon_sym_match_BANG] = ACTIONS(3125),
    [anon_sym_function] = ACTIONS(3123),
    [anon_sym_LT_DASH] = ACTIONS(3123),
    [anon_sym_DOT_LBRACK] = ACTIONS(3125),
    [anon_sym_LT] = ACTIONS(3125),
    [anon_sym_use] = ACTIONS(3123),
    [anon_sym_use_BANG] = ACTIONS(3125),
    [anon_sym_do_BANG] = ACTIONS(3125),
    [anon_sym_begin] = ACTIONS(3123),
    [anon_sym_LPAREN2] = ACTIONS(3123),
    [anon_sym_or] = ACTIONS(3123),
    [aux_sym_char_token1] = ACTIONS(3125),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3123),
    [anon_sym_DQUOTE] = ACTIONS(3123),
    [anon_sym_AT_DQUOTE] = ACTIONS(3125),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3125),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3125),
    [sym_bool] = ACTIONS(3123),
    [sym_unit] = ACTIONS(3125),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3123),
    [sym_op_identifier] = ACTIONS(3123),
    [anon_sym_PLUS] = ACTIONS(3123),
    [anon_sym_DASH] = ACTIONS(3123),
    [anon_sym_PLUS_DOT] = ACTIONS(3123),
    [anon_sym_DASH_DOT] = ACTIONS(3123),
    [anon_sym_PERCENT] = ACTIONS(3123),
    [anon_sym_AMP_AMP] = ACTIONS(3123),
    [anon_sym_TILDE] = ACTIONS(3125),
    [aux_sym_prefix_op_token1] = ACTIONS(3123),
    [aux_sym_infix_op_token1] = ACTIONS(3125),
    [aux_sym_infix_op_token2] = ACTIONS(3123),
    [anon_sym_PIPE_PIPE] = ACTIONS(3123),
    [anon_sym_BANG_EQ] = ACTIONS(3123),
    [anon_sym_COLON_EQ] = ACTIONS(3125),
    [anon_sym_DOLLAR] = ACTIONS(3123),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3123),
    [sym_int] = ACTIONS(3123),
    [sym_xint] = ACTIONS(3125),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3125),
    [sym__newline] = ACTIONS(3125),
  },
  [2359] = {
    [sym_block_comment] = STATE(2359),
    [sym_compiler_directive_decl] = STATE(2359),
    [sym_fsi_directive_decl] = STATE(2359),
    [sym_preproc_line] = STATE(2359),
    [sym_identifier] = ACTIONS(2970),
    [anon_sym_EQ] = ACTIONS(2972),
    [anon_sym_COLON] = ACTIONS(2970),
    [anon_sym_return] = ACTIONS(2970),
    [anon_sym_do] = ACTIONS(2970),
    [anon_sym_let] = ACTIONS(2970),
    [anon_sym_let_BANG] = ACTIONS(2972),
    [anon_sym_LPAREN] = ACTIONS(2970),
    [anon_sym_COMMA] = ACTIONS(2972),
    [anon_sym_null] = ACTIONS(2970),
    [anon_sym_QMARK] = ACTIONS(2970),
    [anon_sym_COLON_QMARK] = ACTIONS(2970),
    [anon_sym_COLON_COLON] = ACTIONS(2972),
    [anon_sym_AMP] = ACTIONS(2970),
    [anon_sym_LBRACK] = ACTIONS(2970),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2972),
    [anon_sym_LBRACE] = ACTIONS(2970),
    [anon_sym_LT_AT] = ACTIONS(2970),
    [anon_sym_AT_GT] = ACTIONS(2970),
    [anon_sym_LT_AT_AT] = ACTIONS(2970),
    [anon_sym_DOT] = ACTIONS(2970),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2972),
    [anon_sym_new] = ACTIONS(2970),
    [anon_sym_return_BANG] = ACTIONS(2972),
    [anon_sym_yield] = ACTIONS(2970),
    [anon_sym_yield_BANG] = ACTIONS(2972),
    [anon_sym_lazy] = ACTIONS(2970),
    [anon_sym_assert] = ACTIONS(2970),
    [anon_sym_upcast] = ACTIONS(2970),
    [anon_sym_downcast] = ACTIONS(2970),
    [anon_sym_COLON_GT] = ACTIONS(2972),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2972),
    [anon_sym_for] = ACTIONS(2970),
    [anon_sym_while] = ACTIONS(2970),
    [anon_sym_if] = ACTIONS(2970),
    [anon_sym_fun] = ACTIONS(2970),
    [anon_sym_try] = ACTIONS(2970),
    [anon_sym_match] = ACTIONS(2970),
    [anon_sym_match_BANG] = ACTIONS(2972),
    [anon_sym_function] = ACTIONS(2970),
    [anon_sym_LT_DASH] = ACTIONS(2970),
    [anon_sym_DOT_LBRACK] = ACTIONS(2972),
    [anon_sym_LT] = ACTIONS(2972),
    [anon_sym_use] = ACTIONS(2970),
    [anon_sym_use_BANG] = ACTIONS(2972),
    [anon_sym_do_BANG] = ACTIONS(2972),
    [anon_sym_begin] = ACTIONS(2970),
    [anon_sym_LPAREN2] = ACTIONS(2970),
    [anon_sym_or] = ACTIONS(2970),
    [aux_sym_char_token1] = ACTIONS(2972),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2970),
    [anon_sym_DQUOTE] = ACTIONS(2970),
    [anon_sym_AT_DQUOTE] = ACTIONS(2972),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2972),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2972),
    [sym_bool] = ACTIONS(2970),
    [sym_unit] = ACTIONS(2972),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2970),
    [sym_op_identifier] = ACTIONS(2970),
    [anon_sym_PLUS] = ACTIONS(2970),
    [anon_sym_DASH] = ACTIONS(2970),
    [anon_sym_PLUS_DOT] = ACTIONS(2970),
    [anon_sym_DASH_DOT] = ACTIONS(2970),
    [anon_sym_PERCENT] = ACTIONS(2970),
    [anon_sym_AMP_AMP] = ACTIONS(2970),
    [anon_sym_TILDE] = ACTIONS(2972),
    [aux_sym_prefix_op_token1] = ACTIONS(2970),
    [aux_sym_infix_op_token1] = ACTIONS(2972),
    [aux_sym_infix_op_token2] = ACTIONS(2970),
    [anon_sym_PIPE_PIPE] = ACTIONS(2970),
    [anon_sym_BANG_EQ] = ACTIONS(2970),
    [anon_sym_COLON_EQ] = ACTIONS(2972),
    [anon_sym_DOLLAR] = ACTIONS(2970),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2970),
    [sym_int] = ACTIONS(2970),
    [sym_xint] = ACTIONS(2972),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2972),
    [sym__newline] = ACTIONS(2972),
  },
  [2360] = {
    [sym_block_comment] = STATE(2360),
    [sym_compiler_directive_decl] = STATE(2360),
    [sym_fsi_directive_decl] = STATE(2360),
    [sym_preproc_line] = STATE(2360),
    [sym_identifier] = ACTIONS(2958),
    [anon_sym_EQ] = ACTIONS(2960),
    [anon_sym_COLON] = ACTIONS(2958),
    [anon_sym_return] = ACTIONS(2958),
    [anon_sym_do] = ACTIONS(2958),
    [anon_sym_let] = ACTIONS(2958),
    [anon_sym_let_BANG] = ACTIONS(2960),
    [anon_sym_LPAREN] = ACTIONS(2958),
    [anon_sym_COMMA] = ACTIONS(2960),
    [anon_sym_null] = ACTIONS(2958),
    [anon_sym_QMARK] = ACTIONS(2958),
    [anon_sym_COLON_QMARK] = ACTIONS(2958),
    [anon_sym_COLON_COLON] = ACTIONS(2960),
    [anon_sym_AMP] = ACTIONS(2958),
    [anon_sym_LBRACK] = ACTIONS(2958),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2960),
    [anon_sym_LBRACE] = ACTIONS(2958),
    [anon_sym_LT_AT] = ACTIONS(2958),
    [anon_sym_LT_AT_AT] = ACTIONS(2958),
    [anon_sym_AT_AT_GT] = ACTIONS(2958),
    [anon_sym_DOT] = ACTIONS(2958),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2960),
    [anon_sym_new] = ACTIONS(2958),
    [anon_sym_return_BANG] = ACTIONS(2960),
    [anon_sym_yield] = ACTIONS(2958),
    [anon_sym_yield_BANG] = ACTIONS(2960),
    [anon_sym_lazy] = ACTIONS(2958),
    [anon_sym_assert] = ACTIONS(2958),
    [anon_sym_upcast] = ACTIONS(2958),
    [anon_sym_downcast] = ACTIONS(2958),
    [anon_sym_COLON_GT] = ACTIONS(2960),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2960),
    [anon_sym_for] = ACTIONS(2958),
    [anon_sym_while] = ACTIONS(2958),
    [anon_sym_if] = ACTIONS(2958),
    [anon_sym_fun] = ACTIONS(2958),
    [anon_sym_try] = ACTIONS(2958),
    [anon_sym_match] = ACTIONS(2958),
    [anon_sym_match_BANG] = ACTIONS(2960),
    [anon_sym_function] = ACTIONS(2958),
    [anon_sym_LT_DASH] = ACTIONS(2958),
    [anon_sym_DOT_LBRACK] = ACTIONS(2960),
    [anon_sym_LT] = ACTIONS(2960),
    [anon_sym_use] = ACTIONS(2958),
    [anon_sym_use_BANG] = ACTIONS(2960),
    [anon_sym_do_BANG] = ACTIONS(2960),
    [anon_sym_begin] = ACTIONS(2958),
    [anon_sym_LPAREN2] = ACTIONS(2958),
    [anon_sym_or] = ACTIONS(2958),
    [aux_sym_char_token1] = ACTIONS(2960),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2958),
    [anon_sym_DQUOTE] = ACTIONS(2958),
    [anon_sym_AT_DQUOTE] = ACTIONS(2960),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2960),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2960),
    [sym_bool] = ACTIONS(2958),
    [sym_unit] = ACTIONS(2960),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2958),
    [sym_op_identifier] = ACTIONS(2958),
    [anon_sym_PLUS] = ACTIONS(2958),
    [anon_sym_DASH] = ACTIONS(2958),
    [anon_sym_PLUS_DOT] = ACTIONS(2958),
    [anon_sym_DASH_DOT] = ACTIONS(2958),
    [anon_sym_PERCENT] = ACTIONS(2958),
    [anon_sym_AMP_AMP] = ACTIONS(2958),
    [anon_sym_TILDE] = ACTIONS(2960),
    [aux_sym_prefix_op_token1] = ACTIONS(2958),
    [aux_sym_infix_op_token1] = ACTIONS(2960),
    [aux_sym_infix_op_token2] = ACTIONS(2958),
    [anon_sym_PIPE_PIPE] = ACTIONS(2958),
    [anon_sym_BANG_EQ] = ACTIONS(2958),
    [anon_sym_COLON_EQ] = ACTIONS(2960),
    [anon_sym_DOLLAR] = ACTIONS(2958),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2958),
    [sym_int] = ACTIONS(2958),
    [sym_xint] = ACTIONS(2960),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2960),
    [sym__newline] = ACTIONS(2960),
  },
  [2361] = {
    [sym_block_comment] = STATE(2361),
    [sym_compiler_directive_decl] = STATE(2361),
    [sym_fsi_directive_decl] = STATE(2361),
    [sym_preproc_line] = STATE(2361),
    [sym_identifier] = ACTIONS(3091),
    [anon_sym_EQ] = ACTIONS(3093),
    [anon_sym_COLON] = ACTIONS(3091),
    [anon_sym_return] = ACTIONS(3091),
    [anon_sym_do] = ACTIONS(3091),
    [anon_sym_let] = ACTIONS(3091),
    [anon_sym_let_BANG] = ACTIONS(3093),
    [anon_sym_LPAREN] = ACTIONS(3091),
    [anon_sym_COMMA] = ACTIONS(3093),
    [anon_sym_null] = ACTIONS(3091),
    [anon_sym_QMARK] = ACTIONS(3091),
    [anon_sym_COLON_QMARK] = ACTIONS(3091),
    [anon_sym_COLON_COLON] = ACTIONS(3093),
    [anon_sym_AMP] = ACTIONS(3091),
    [anon_sym_LBRACK] = ACTIONS(3091),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3093),
    [anon_sym_LBRACE] = ACTIONS(3091),
    [anon_sym_LT_AT] = ACTIONS(3091),
    [anon_sym_AT_GT] = ACTIONS(3091),
    [anon_sym_LT_AT_AT] = ACTIONS(3091),
    [anon_sym_DOT] = ACTIONS(3091),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3093),
    [anon_sym_new] = ACTIONS(3091),
    [anon_sym_return_BANG] = ACTIONS(3093),
    [anon_sym_yield] = ACTIONS(3091),
    [anon_sym_yield_BANG] = ACTIONS(3093),
    [anon_sym_lazy] = ACTIONS(3091),
    [anon_sym_assert] = ACTIONS(3091),
    [anon_sym_upcast] = ACTIONS(3091),
    [anon_sym_downcast] = ACTIONS(3091),
    [anon_sym_COLON_GT] = ACTIONS(3093),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3093),
    [anon_sym_for] = ACTIONS(3091),
    [anon_sym_while] = ACTIONS(3091),
    [anon_sym_if] = ACTIONS(3091),
    [anon_sym_fun] = ACTIONS(3091),
    [anon_sym_try] = ACTIONS(3091),
    [anon_sym_match] = ACTIONS(3091),
    [anon_sym_match_BANG] = ACTIONS(3093),
    [anon_sym_function] = ACTIONS(3091),
    [anon_sym_LT_DASH] = ACTIONS(3091),
    [anon_sym_DOT_LBRACK] = ACTIONS(3093),
    [anon_sym_LT] = ACTIONS(3093),
    [anon_sym_use] = ACTIONS(3091),
    [anon_sym_use_BANG] = ACTIONS(3093),
    [anon_sym_do_BANG] = ACTIONS(3093),
    [anon_sym_begin] = ACTIONS(3091),
    [anon_sym_LPAREN2] = ACTIONS(3091),
    [anon_sym_or] = ACTIONS(3091),
    [aux_sym_char_token1] = ACTIONS(3093),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3091),
    [anon_sym_DQUOTE] = ACTIONS(3091),
    [anon_sym_AT_DQUOTE] = ACTIONS(3093),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3093),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3093),
    [sym_bool] = ACTIONS(3091),
    [sym_unit] = ACTIONS(3093),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3091),
    [sym_op_identifier] = ACTIONS(3091),
    [anon_sym_PLUS] = ACTIONS(3091),
    [anon_sym_DASH] = ACTIONS(3091),
    [anon_sym_PLUS_DOT] = ACTIONS(3091),
    [anon_sym_DASH_DOT] = ACTIONS(3091),
    [anon_sym_PERCENT] = ACTIONS(3091),
    [anon_sym_AMP_AMP] = ACTIONS(3091),
    [anon_sym_TILDE] = ACTIONS(3093),
    [aux_sym_prefix_op_token1] = ACTIONS(3091),
    [aux_sym_infix_op_token1] = ACTIONS(3093),
    [aux_sym_infix_op_token2] = ACTIONS(3091),
    [anon_sym_PIPE_PIPE] = ACTIONS(3091),
    [anon_sym_BANG_EQ] = ACTIONS(3091),
    [anon_sym_COLON_EQ] = ACTIONS(3093),
    [anon_sym_DOLLAR] = ACTIONS(3091),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3091),
    [sym_int] = ACTIONS(3091),
    [sym_xint] = ACTIONS(3093),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3093),
    [sym__newline] = ACTIONS(3093),
  },
  [2362] = {
    [sym_block_comment] = STATE(2362),
    [sym_compiler_directive_decl] = STATE(2362),
    [sym_fsi_directive_decl] = STATE(2362),
    [sym_preproc_line] = STATE(2362),
    [sym_identifier] = ACTIONS(2942),
    [anon_sym_EQ] = ACTIONS(2944),
    [anon_sym_COLON] = ACTIONS(2942),
    [anon_sym_return] = ACTIONS(2942),
    [anon_sym_do] = ACTIONS(2942),
    [anon_sym_let] = ACTIONS(2942),
    [anon_sym_let_BANG] = ACTIONS(2944),
    [anon_sym_LPAREN] = ACTIONS(2942),
    [anon_sym_COMMA] = ACTIONS(2944),
    [anon_sym_null] = ACTIONS(2942),
    [anon_sym_QMARK] = ACTIONS(2942),
    [anon_sym_COLON_QMARK] = ACTIONS(2942),
    [anon_sym_COLON_COLON] = ACTIONS(2944),
    [anon_sym_AMP] = ACTIONS(2942),
    [anon_sym_LBRACK] = ACTIONS(2942),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2944),
    [anon_sym_LBRACE] = ACTIONS(2942),
    [anon_sym_LT_AT] = ACTIONS(2942),
    [anon_sym_LT_AT_AT] = ACTIONS(2942),
    [anon_sym_DOT] = ACTIONS(2942),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2944),
    [anon_sym_new] = ACTIONS(2942),
    [anon_sym_return_BANG] = ACTIONS(2944),
    [anon_sym_yield] = ACTIONS(2942),
    [anon_sym_yield_BANG] = ACTIONS(2944),
    [anon_sym_lazy] = ACTIONS(2942),
    [anon_sym_assert] = ACTIONS(2942),
    [anon_sym_upcast] = ACTIONS(2942),
    [anon_sym_downcast] = ACTIONS(2942),
    [anon_sym_COLON_GT] = ACTIONS(2944),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2944),
    [anon_sym_for] = ACTIONS(2942),
    [anon_sym_while] = ACTIONS(2942),
    [anon_sym_if] = ACTIONS(2942),
    [anon_sym_fun] = ACTIONS(2942),
    [anon_sym_try] = ACTIONS(2942),
    [anon_sym_match] = ACTIONS(2942),
    [anon_sym_match_BANG] = ACTIONS(2944),
    [anon_sym_function] = ACTIONS(2942),
    [anon_sym_LT_DASH] = ACTIONS(2942),
    [anon_sym_DOT_LBRACK] = ACTIONS(2944),
    [anon_sym_LT] = ACTIONS(2944),
    [anon_sym_use] = ACTIONS(2942),
    [anon_sym_use_BANG] = ACTIONS(2944),
    [anon_sym_do_BANG] = ACTIONS(2944),
    [anon_sym_DOT_DOT] = ACTIONS(2944),
    [anon_sym_begin] = ACTIONS(2942),
    [anon_sym_LPAREN2] = ACTIONS(2942),
    [anon_sym_or] = ACTIONS(2942),
    [aux_sym_char_token1] = ACTIONS(2944),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2942),
    [anon_sym_DQUOTE] = ACTIONS(2942),
    [anon_sym_AT_DQUOTE] = ACTIONS(2944),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2944),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2944),
    [sym_bool] = ACTIONS(2942),
    [sym_unit] = ACTIONS(2944),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2942),
    [sym_op_identifier] = ACTIONS(2942),
    [anon_sym_PLUS] = ACTIONS(2942),
    [anon_sym_DASH] = ACTIONS(2942),
    [anon_sym_PLUS_DOT] = ACTIONS(2942),
    [anon_sym_DASH_DOT] = ACTIONS(2942),
    [anon_sym_PERCENT] = ACTIONS(2942),
    [anon_sym_AMP_AMP] = ACTIONS(2942),
    [anon_sym_TILDE] = ACTIONS(2944),
    [aux_sym_prefix_op_token1] = ACTIONS(2942),
    [aux_sym_infix_op_token1] = ACTIONS(2944),
    [aux_sym_infix_op_token2] = ACTIONS(2942),
    [anon_sym_PIPE_PIPE] = ACTIONS(2942),
    [anon_sym_BANG_EQ] = ACTIONS(2942),
    [anon_sym_COLON_EQ] = ACTIONS(2944),
    [anon_sym_DOLLAR] = ACTIONS(2942),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2942),
    [sym_int] = ACTIONS(2942),
    [sym_xint] = ACTIONS(2944),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2944),
    [sym__newline] = ACTIONS(2944),
  },
  [2363] = {
    [sym_block_comment] = STATE(2363),
    [sym_compiler_directive_decl] = STATE(2363),
    [sym_fsi_directive_decl] = STATE(2363),
    [sym_preproc_line] = STATE(2363),
    [sym_identifier] = ACTIONS(3035),
    [anon_sym_EQ] = ACTIONS(3037),
    [anon_sym_COLON] = ACTIONS(3035),
    [anon_sym_return] = ACTIONS(3035),
    [anon_sym_do] = ACTIONS(3035),
    [anon_sym_let] = ACTIONS(3035),
    [anon_sym_let_BANG] = ACTIONS(3037),
    [anon_sym_LPAREN] = ACTIONS(3035),
    [anon_sym_COMMA] = ACTIONS(3037),
    [anon_sym_null] = ACTIONS(3035),
    [anon_sym_QMARK] = ACTIONS(3035),
    [anon_sym_COLON_QMARK] = ACTIONS(3035),
    [anon_sym_COLON_COLON] = ACTIONS(3037),
    [anon_sym_AMP] = ACTIONS(3035),
    [anon_sym_LBRACK] = ACTIONS(3035),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3037),
    [anon_sym_LBRACE] = ACTIONS(3035),
    [anon_sym_LT_AT] = ACTIONS(3035),
    [anon_sym_LT_AT_AT] = ACTIONS(3035),
    [anon_sym_DOT] = ACTIONS(3035),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3037),
    [anon_sym_new] = ACTIONS(3035),
    [anon_sym_return_BANG] = ACTIONS(3037),
    [anon_sym_yield] = ACTIONS(3035),
    [anon_sym_yield_BANG] = ACTIONS(3037),
    [anon_sym_lazy] = ACTIONS(3035),
    [anon_sym_assert] = ACTIONS(3035),
    [anon_sym_upcast] = ACTIONS(3035),
    [anon_sym_downcast] = ACTIONS(3035),
    [anon_sym_COLON_GT] = ACTIONS(3037),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3037),
    [anon_sym_for] = ACTIONS(3035),
    [anon_sym_while] = ACTIONS(3035),
    [anon_sym_if] = ACTIONS(3035),
    [anon_sym_fun] = ACTIONS(3035),
    [anon_sym_try] = ACTIONS(3035),
    [anon_sym_match] = ACTIONS(3035),
    [anon_sym_match_BANG] = ACTIONS(3037),
    [anon_sym_function] = ACTIONS(3035),
    [anon_sym_LT_DASH] = ACTIONS(3035),
    [anon_sym_DOT_LBRACK] = ACTIONS(3037),
    [anon_sym_LT] = ACTIONS(3037),
    [anon_sym_use] = ACTIONS(3035),
    [anon_sym_use_BANG] = ACTIONS(3037),
    [anon_sym_do_BANG] = ACTIONS(3037),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_LPAREN2] = ACTIONS(3035),
    [anon_sym_or] = ACTIONS(3035),
    [aux_sym_char_token1] = ACTIONS(3037),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3035),
    [anon_sym_DQUOTE] = ACTIONS(3035),
    [anon_sym_AT_DQUOTE] = ACTIONS(3037),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3037),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3037),
    [sym_bool] = ACTIONS(3035),
    [sym_unit] = ACTIONS(3037),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3035),
    [sym_op_identifier] = ACTIONS(3035),
    [anon_sym_PLUS] = ACTIONS(3035),
    [anon_sym_DASH] = ACTIONS(3035),
    [anon_sym_PLUS_DOT] = ACTIONS(3035),
    [anon_sym_DASH_DOT] = ACTIONS(3035),
    [anon_sym_PERCENT] = ACTIONS(3035),
    [anon_sym_AMP_AMP] = ACTIONS(3035),
    [anon_sym_TILDE] = ACTIONS(3037),
    [aux_sym_prefix_op_token1] = ACTIONS(3035),
    [aux_sym_infix_op_token1] = ACTIONS(3037),
    [aux_sym_infix_op_token2] = ACTIONS(3035),
    [anon_sym_PIPE_PIPE] = ACTIONS(3035),
    [anon_sym_BANG_EQ] = ACTIONS(3035),
    [anon_sym_COLON_EQ] = ACTIONS(3037),
    [anon_sym_DOLLAR] = ACTIONS(3035),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3035),
    [sym_int] = ACTIONS(3035),
    [sym_xint] = ACTIONS(3037),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3037),
    [anon_sym_POUNDendif] = ACTIONS(3037),
    [sym__newline] = ACTIONS(3037),
  },
  [2364] = {
    [sym_block_comment] = STATE(2364),
    [sym_compiler_directive_decl] = STATE(2364),
    [sym_fsi_directive_decl] = STATE(2364),
    [sym_preproc_line] = STATE(2364),
    [sym_identifier] = ACTIONS(3031),
    [anon_sym_EQ] = ACTIONS(3033),
    [anon_sym_COLON] = ACTIONS(3031),
    [anon_sym_return] = ACTIONS(3031),
    [anon_sym_do] = ACTIONS(3031),
    [anon_sym_let] = ACTIONS(3031),
    [anon_sym_let_BANG] = ACTIONS(3033),
    [anon_sym_LPAREN] = ACTIONS(3031),
    [anon_sym_COMMA] = ACTIONS(3033),
    [anon_sym_null] = ACTIONS(3031),
    [anon_sym_QMARK] = ACTIONS(3031),
    [anon_sym_COLON_QMARK] = ACTIONS(3031),
    [anon_sym_COLON_COLON] = ACTIONS(3033),
    [anon_sym_AMP] = ACTIONS(3031),
    [anon_sym_LBRACK] = ACTIONS(3031),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3033),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [anon_sym_LT_AT] = ACTIONS(3031),
    [anon_sym_LT_AT_AT] = ACTIONS(3031),
    [anon_sym_DOT] = ACTIONS(3031),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3033),
    [anon_sym_new] = ACTIONS(3031),
    [anon_sym_return_BANG] = ACTIONS(3033),
    [anon_sym_yield] = ACTIONS(3031),
    [anon_sym_yield_BANG] = ACTIONS(3033),
    [anon_sym_lazy] = ACTIONS(3031),
    [anon_sym_assert] = ACTIONS(3031),
    [anon_sym_upcast] = ACTIONS(3031),
    [anon_sym_downcast] = ACTIONS(3031),
    [anon_sym_COLON_GT] = ACTIONS(3033),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3033),
    [anon_sym_for] = ACTIONS(3031),
    [anon_sym_while] = ACTIONS(3031),
    [anon_sym_if] = ACTIONS(3031),
    [anon_sym_fun] = ACTIONS(3031),
    [anon_sym_try] = ACTIONS(3031),
    [anon_sym_match] = ACTIONS(3031),
    [anon_sym_match_BANG] = ACTIONS(3033),
    [anon_sym_function] = ACTIONS(3031),
    [anon_sym_LT_DASH] = ACTIONS(3031),
    [anon_sym_DOT_LBRACK] = ACTIONS(3033),
    [anon_sym_LT] = ACTIONS(3033),
    [anon_sym_use] = ACTIONS(3031),
    [anon_sym_use_BANG] = ACTIONS(3033),
    [anon_sym_do_BANG] = ACTIONS(3033),
    [anon_sym_begin] = ACTIONS(3031),
    [anon_sym_LPAREN2] = ACTIONS(3031),
    [anon_sym_or] = ACTIONS(3031),
    [aux_sym_char_token1] = ACTIONS(3033),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3031),
    [anon_sym_DQUOTE] = ACTIONS(3031),
    [anon_sym_AT_DQUOTE] = ACTIONS(3033),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3033),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3033),
    [sym_bool] = ACTIONS(3031),
    [sym_unit] = ACTIONS(3033),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3031),
    [sym_op_identifier] = ACTIONS(3031),
    [anon_sym_PLUS] = ACTIONS(3031),
    [anon_sym_DASH] = ACTIONS(3031),
    [anon_sym_PLUS_DOT] = ACTIONS(3031),
    [anon_sym_DASH_DOT] = ACTIONS(3031),
    [anon_sym_PERCENT] = ACTIONS(3031),
    [anon_sym_AMP_AMP] = ACTIONS(3031),
    [anon_sym_TILDE] = ACTIONS(3033),
    [aux_sym_prefix_op_token1] = ACTIONS(3031),
    [aux_sym_infix_op_token1] = ACTIONS(3033),
    [aux_sym_infix_op_token2] = ACTIONS(3031),
    [anon_sym_PIPE_PIPE] = ACTIONS(3031),
    [anon_sym_BANG_EQ] = ACTIONS(3031),
    [anon_sym_COLON_EQ] = ACTIONS(3033),
    [anon_sym_DOLLAR] = ACTIONS(3031),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3031),
    [sym_int] = ACTIONS(3031),
    [sym_xint] = ACTIONS(3033),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3033),
    [anon_sym_POUNDendif] = ACTIONS(3033),
    [sym__newline] = ACTIONS(3033),
  },
  [2365] = {
    [sym_block_comment] = STATE(2365),
    [sym_compiler_directive_decl] = STATE(2365),
    [sym_fsi_directive_decl] = STATE(2365),
    [sym_preproc_line] = STATE(2365),
    [sym_identifier] = ACTIONS(3087),
    [anon_sym_EQ] = ACTIONS(3089),
    [anon_sym_COLON] = ACTIONS(3087),
    [anon_sym_return] = ACTIONS(3087),
    [anon_sym_do] = ACTIONS(3087),
    [anon_sym_let] = ACTIONS(3087),
    [anon_sym_let_BANG] = ACTIONS(3089),
    [anon_sym_LPAREN] = ACTIONS(3087),
    [anon_sym_COMMA] = ACTIONS(3089),
    [anon_sym_null] = ACTIONS(3087),
    [anon_sym_QMARK] = ACTIONS(3087),
    [anon_sym_COLON_QMARK] = ACTIONS(3087),
    [anon_sym_COLON_COLON] = ACTIONS(3089),
    [anon_sym_AMP] = ACTIONS(3087),
    [anon_sym_LBRACK] = ACTIONS(3087),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3089),
    [anon_sym_LBRACE] = ACTIONS(3087),
    [anon_sym_LT_AT] = ACTIONS(3087),
    [anon_sym_AT_GT] = ACTIONS(3087),
    [anon_sym_LT_AT_AT] = ACTIONS(3087),
    [anon_sym_DOT] = ACTIONS(3087),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3089),
    [anon_sym_new] = ACTIONS(3087),
    [anon_sym_return_BANG] = ACTIONS(3089),
    [anon_sym_yield] = ACTIONS(3087),
    [anon_sym_yield_BANG] = ACTIONS(3089),
    [anon_sym_lazy] = ACTIONS(3087),
    [anon_sym_assert] = ACTIONS(3087),
    [anon_sym_upcast] = ACTIONS(3087),
    [anon_sym_downcast] = ACTIONS(3087),
    [anon_sym_COLON_GT] = ACTIONS(3089),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3089),
    [anon_sym_for] = ACTIONS(3087),
    [anon_sym_while] = ACTIONS(3087),
    [anon_sym_if] = ACTIONS(3087),
    [anon_sym_fun] = ACTIONS(3087),
    [anon_sym_try] = ACTIONS(3087),
    [anon_sym_match] = ACTIONS(3087),
    [anon_sym_match_BANG] = ACTIONS(3089),
    [anon_sym_function] = ACTIONS(3087),
    [anon_sym_LT_DASH] = ACTIONS(3087),
    [anon_sym_DOT_LBRACK] = ACTIONS(3089),
    [anon_sym_LT] = ACTIONS(3089),
    [anon_sym_use] = ACTIONS(3087),
    [anon_sym_use_BANG] = ACTIONS(3089),
    [anon_sym_do_BANG] = ACTIONS(3089),
    [anon_sym_begin] = ACTIONS(3087),
    [anon_sym_LPAREN2] = ACTIONS(3087),
    [anon_sym_or] = ACTIONS(3087),
    [aux_sym_char_token1] = ACTIONS(3089),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3087),
    [anon_sym_DQUOTE] = ACTIONS(3087),
    [anon_sym_AT_DQUOTE] = ACTIONS(3089),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3089),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3089),
    [sym_bool] = ACTIONS(3087),
    [sym_unit] = ACTIONS(3089),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3087),
    [sym_op_identifier] = ACTIONS(3087),
    [anon_sym_PLUS] = ACTIONS(3087),
    [anon_sym_DASH] = ACTIONS(3087),
    [anon_sym_PLUS_DOT] = ACTIONS(3087),
    [anon_sym_DASH_DOT] = ACTIONS(3087),
    [anon_sym_PERCENT] = ACTIONS(3087),
    [anon_sym_AMP_AMP] = ACTIONS(3087),
    [anon_sym_TILDE] = ACTIONS(3089),
    [aux_sym_prefix_op_token1] = ACTIONS(3087),
    [aux_sym_infix_op_token1] = ACTIONS(3089),
    [aux_sym_infix_op_token2] = ACTIONS(3087),
    [anon_sym_PIPE_PIPE] = ACTIONS(3087),
    [anon_sym_BANG_EQ] = ACTIONS(3087),
    [anon_sym_COLON_EQ] = ACTIONS(3089),
    [anon_sym_DOLLAR] = ACTIONS(3087),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3087),
    [sym_int] = ACTIONS(3087),
    [sym_xint] = ACTIONS(3089),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3089),
    [sym__newline] = ACTIONS(3089),
  },
  [2366] = {
    [sym_block_comment] = STATE(2366),
    [sym_compiler_directive_decl] = STATE(2366),
    [sym_fsi_directive_decl] = STATE(2366),
    [sym_preproc_line] = STATE(2366),
    [sym_identifier] = ACTIONS(2962),
    [anon_sym_EQ] = ACTIONS(2964),
    [anon_sym_COLON] = ACTIONS(2962),
    [anon_sym_return] = ACTIONS(2962),
    [anon_sym_do] = ACTIONS(2962),
    [anon_sym_let] = ACTIONS(2962),
    [anon_sym_let_BANG] = ACTIONS(2964),
    [anon_sym_LPAREN] = ACTIONS(2962),
    [anon_sym_COMMA] = ACTIONS(2964),
    [anon_sym_null] = ACTIONS(2962),
    [anon_sym_QMARK] = ACTIONS(2962),
    [anon_sym_COLON_QMARK] = ACTIONS(2962),
    [anon_sym_COLON_COLON] = ACTIONS(2964),
    [anon_sym_AMP] = ACTIONS(2962),
    [anon_sym_LBRACK] = ACTIONS(2962),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2964),
    [anon_sym_LBRACE] = ACTIONS(2962),
    [anon_sym_LT_AT] = ACTIONS(2962),
    [anon_sym_LT_AT_AT] = ACTIONS(2962),
    [anon_sym_AT_AT_GT] = ACTIONS(2962),
    [anon_sym_DOT] = ACTIONS(2962),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2964),
    [anon_sym_new] = ACTIONS(2962),
    [anon_sym_return_BANG] = ACTIONS(2964),
    [anon_sym_yield] = ACTIONS(2962),
    [anon_sym_yield_BANG] = ACTIONS(2964),
    [anon_sym_lazy] = ACTIONS(2962),
    [anon_sym_assert] = ACTIONS(2962),
    [anon_sym_upcast] = ACTIONS(2962),
    [anon_sym_downcast] = ACTIONS(2962),
    [anon_sym_COLON_GT] = ACTIONS(2964),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2964),
    [anon_sym_for] = ACTIONS(2962),
    [anon_sym_while] = ACTIONS(2962),
    [anon_sym_if] = ACTIONS(2962),
    [anon_sym_fun] = ACTIONS(2962),
    [anon_sym_try] = ACTIONS(2962),
    [anon_sym_match] = ACTIONS(2962),
    [anon_sym_match_BANG] = ACTIONS(2964),
    [anon_sym_function] = ACTIONS(2962),
    [anon_sym_LT_DASH] = ACTIONS(2962),
    [anon_sym_DOT_LBRACK] = ACTIONS(2964),
    [anon_sym_LT] = ACTIONS(2964),
    [anon_sym_use] = ACTIONS(2962),
    [anon_sym_use_BANG] = ACTIONS(2964),
    [anon_sym_do_BANG] = ACTIONS(2964),
    [anon_sym_begin] = ACTIONS(2962),
    [anon_sym_LPAREN2] = ACTIONS(2962),
    [anon_sym_or] = ACTIONS(2962),
    [aux_sym_char_token1] = ACTIONS(2964),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2962),
    [anon_sym_DQUOTE] = ACTIONS(2962),
    [anon_sym_AT_DQUOTE] = ACTIONS(2964),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2964),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2964),
    [sym_bool] = ACTIONS(2962),
    [sym_unit] = ACTIONS(2964),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2962),
    [sym_op_identifier] = ACTIONS(2962),
    [anon_sym_PLUS] = ACTIONS(2962),
    [anon_sym_DASH] = ACTIONS(2962),
    [anon_sym_PLUS_DOT] = ACTIONS(2962),
    [anon_sym_DASH_DOT] = ACTIONS(2962),
    [anon_sym_PERCENT] = ACTIONS(2962),
    [anon_sym_AMP_AMP] = ACTIONS(2962),
    [anon_sym_TILDE] = ACTIONS(2964),
    [aux_sym_prefix_op_token1] = ACTIONS(2962),
    [aux_sym_infix_op_token1] = ACTIONS(2964),
    [aux_sym_infix_op_token2] = ACTIONS(2962),
    [anon_sym_PIPE_PIPE] = ACTIONS(2962),
    [anon_sym_BANG_EQ] = ACTIONS(2962),
    [anon_sym_COLON_EQ] = ACTIONS(2964),
    [anon_sym_DOLLAR] = ACTIONS(2962),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2962),
    [sym_int] = ACTIONS(2962),
    [sym_xint] = ACTIONS(2964),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2964),
    [sym__newline] = ACTIONS(2964),
  },
  [2367] = {
    [sym_block_comment] = STATE(2367),
    [sym_compiler_directive_decl] = STATE(2367),
    [sym_fsi_directive_decl] = STATE(2367),
    [sym_preproc_line] = STATE(2367),
    [sym_identifier] = ACTIONS(2873),
    [anon_sym_EQ] = ACTIONS(2875),
    [anon_sym_COLON] = ACTIONS(2873),
    [anon_sym_return] = ACTIONS(2873),
    [anon_sym_do] = ACTIONS(2873),
    [anon_sym_let] = ACTIONS(2873),
    [anon_sym_let_BANG] = ACTIONS(2875),
    [anon_sym_LPAREN] = ACTIONS(2873),
    [anon_sym_COMMA] = ACTIONS(2875),
    [anon_sym_null] = ACTIONS(2873),
    [anon_sym_QMARK] = ACTIONS(2873),
    [anon_sym_COLON_QMARK] = ACTIONS(2873),
    [anon_sym_COLON_COLON] = ACTIONS(2875),
    [anon_sym_AMP] = ACTIONS(2873),
    [anon_sym_LBRACK] = ACTIONS(2873),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2875),
    [anon_sym_LBRACE] = ACTIONS(2873),
    [anon_sym_LT_AT] = ACTIONS(2873),
    [anon_sym_AT_GT] = ACTIONS(2873),
    [anon_sym_LT_AT_AT] = ACTIONS(2873),
    [anon_sym_DOT] = ACTIONS(2873),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2875),
    [anon_sym_new] = ACTIONS(2873),
    [anon_sym_return_BANG] = ACTIONS(2875),
    [anon_sym_yield] = ACTIONS(2873),
    [anon_sym_yield_BANG] = ACTIONS(2875),
    [anon_sym_lazy] = ACTIONS(2873),
    [anon_sym_assert] = ACTIONS(2873),
    [anon_sym_upcast] = ACTIONS(2873),
    [anon_sym_downcast] = ACTIONS(2873),
    [anon_sym_COLON_GT] = ACTIONS(2875),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2875),
    [anon_sym_for] = ACTIONS(2873),
    [anon_sym_while] = ACTIONS(2873),
    [anon_sym_if] = ACTIONS(2873),
    [anon_sym_fun] = ACTIONS(2873),
    [anon_sym_try] = ACTIONS(2873),
    [anon_sym_match] = ACTIONS(2873),
    [anon_sym_match_BANG] = ACTIONS(2875),
    [anon_sym_function] = ACTIONS(2873),
    [anon_sym_LT_DASH] = ACTIONS(2873),
    [anon_sym_DOT_LBRACK] = ACTIONS(2875),
    [anon_sym_LT] = ACTIONS(2875),
    [anon_sym_use] = ACTIONS(2873),
    [anon_sym_use_BANG] = ACTIONS(2875),
    [anon_sym_do_BANG] = ACTIONS(2875),
    [anon_sym_begin] = ACTIONS(2873),
    [anon_sym_LPAREN2] = ACTIONS(2873),
    [anon_sym_or] = ACTIONS(2873),
    [aux_sym_char_token1] = ACTIONS(2875),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2873),
    [anon_sym_DQUOTE] = ACTIONS(2873),
    [anon_sym_AT_DQUOTE] = ACTIONS(2875),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2875),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2875),
    [sym_bool] = ACTIONS(2873),
    [sym_unit] = ACTIONS(2875),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2873),
    [sym_op_identifier] = ACTIONS(2873),
    [anon_sym_PLUS] = ACTIONS(2873),
    [anon_sym_DASH] = ACTIONS(2873),
    [anon_sym_PLUS_DOT] = ACTIONS(2873),
    [anon_sym_DASH_DOT] = ACTIONS(2873),
    [anon_sym_PERCENT] = ACTIONS(2873),
    [anon_sym_AMP_AMP] = ACTIONS(2873),
    [anon_sym_TILDE] = ACTIONS(2875),
    [aux_sym_prefix_op_token1] = ACTIONS(2873),
    [aux_sym_infix_op_token1] = ACTIONS(2875),
    [aux_sym_infix_op_token2] = ACTIONS(2873),
    [anon_sym_PIPE_PIPE] = ACTIONS(2873),
    [anon_sym_BANG_EQ] = ACTIONS(2873),
    [anon_sym_COLON_EQ] = ACTIONS(2875),
    [anon_sym_DOLLAR] = ACTIONS(2873),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2873),
    [sym_int] = ACTIONS(2873),
    [sym_xint] = ACTIONS(2875),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2875),
    [sym__newline] = ACTIONS(2875),
  },
  [2368] = {
    [sym_block_comment] = STATE(2368),
    [sym_compiler_directive_decl] = STATE(2368),
    [sym_fsi_directive_decl] = STATE(2368),
    [sym_preproc_line] = STATE(2368),
    [sym_identifier] = ACTIONS(2966),
    [anon_sym_EQ] = ACTIONS(2968),
    [anon_sym_COLON] = ACTIONS(2966),
    [anon_sym_return] = ACTIONS(2966),
    [anon_sym_do] = ACTIONS(2966),
    [anon_sym_let] = ACTIONS(2966),
    [anon_sym_let_BANG] = ACTIONS(2968),
    [anon_sym_LPAREN] = ACTIONS(2966),
    [anon_sym_COMMA] = ACTIONS(2968),
    [anon_sym_null] = ACTIONS(2966),
    [anon_sym_QMARK] = ACTIONS(2966),
    [anon_sym_COLON_QMARK] = ACTIONS(2966),
    [anon_sym_COLON_COLON] = ACTIONS(2968),
    [anon_sym_AMP] = ACTIONS(2966),
    [anon_sym_LBRACK] = ACTIONS(2966),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2968),
    [anon_sym_LBRACE] = ACTIONS(2966),
    [anon_sym_LT_AT] = ACTIONS(2966),
    [anon_sym_LT_AT_AT] = ACTIONS(2966),
    [anon_sym_AT_AT_GT] = ACTIONS(2966),
    [anon_sym_DOT] = ACTIONS(2966),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2968),
    [anon_sym_new] = ACTIONS(2966),
    [anon_sym_return_BANG] = ACTIONS(2968),
    [anon_sym_yield] = ACTIONS(2966),
    [anon_sym_yield_BANG] = ACTIONS(2968),
    [anon_sym_lazy] = ACTIONS(2966),
    [anon_sym_assert] = ACTIONS(2966),
    [anon_sym_upcast] = ACTIONS(2966),
    [anon_sym_downcast] = ACTIONS(2966),
    [anon_sym_COLON_GT] = ACTIONS(2968),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2968),
    [anon_sym_for] = ACTIONS(2966),
    [anon_sym_while] = ACTIONS(2966),
    [anon_sym_if] = ACTIONS(2966),
    [anon_sym_fun] = ACTIONS(2966),
    [anon_sym_try] = ACTIONS(2966),
    [anon_sym_match] = ACTIONS(2966),
    [anon_sym_match_BANG] = ACTIONS(2968),
    [anon_sym_function] = ACTIONS(2966),
    [anon_sym_LT_DASH] = ACTIONS(2966),
    [anon_sym_DOT_LBRACK] = ACTIONS(2968),
    [anon_sym_LT] = ACTIONS(2968),
    [anon_sym_use] = ACTIONS(2966),
    [anon_sym_use_BANG] = ACTIONS(2968),
    [anon_sym_do_BANG] = ACTIONS(2968),
    [anon_sym_begin] = ACTIONS(2966),
    [anon_sym_LPAREN2] = ACTIONS(2966),
    [anon_sym_or] = ACTIONS(2966),
    [aux_sym_char_token1] = ACTIONS(2968),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2966),
    [anon_sym_DQUOTE] = ACTIONS(2966),
    [anon_sym_AT_DQUOTE] = ACTIONS(2968),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2968),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2968),
    [sym_bool] = ACTIONS(2966),
    [sym_unit] = ACTIONS(2968),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2966),
    [sym_op_identifier] = ACTIONS(2966),
    [anon_sym_PLUS] = ACTIONS(2966),
    [anon_sym_DASH] = ACTIONS(2966),
    [anon_sym_PLUS_DOT] = ACTIONS(2966),
    [anon_sym_DASH_DOT] = ACTIONS(2966),
    [anon_sym_PERCENT] = ACTIONS(2966),
    [anon_sym_AMP_AMP] = ACTIONS(2966),
    [anon_sym_TILDE] = ACTIONS(2968),
    [aux_sym_prefix_op_token1] = ACTIONS(2966),
    [aux_sym_infix_op_token1] = ACTIONS(2968),
    [aux_sym_infix_op_token2] = ACTIONS(2966),
    [anon_sym_PIPE_PIPE] = ACTIONS(2966),
    [anon_sym_BANG_EQ] = ACTIONS(2966),
    [anon_sym_COLON_EQ] = ACTIONS(2968),
    [anon_sym_DOLLAR] = ACTIONS(2966),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2966),
    [sym_int] = ACTIONS(2966),
    [sym_xint] = ACTIONS(2968),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2968),
    [sym__newline] = ACTIONS(2968),
  },
  [2369] = {
    [sym_block_comment] = STATE(2369),
    [sym_compiler_directive_decl] = STATE(2369),
    [sym_fsi_directive_decl] = STATE(2369),
    [sym_preproc_line] = STATE(2369),
    [sym_identifier] = ACTIONS(3075),
    [anon_sym_EQ] = ACTIONS(3077),
    [anon_sym_COLON] = ACTIONS(3075),
    [anon_sym_return] = ACTIONS(3075),
    [anon_sym_do] = ACTIONS(3075),
    [anon_sym_let] = ACTIONS(3075),
    [anon_sym_let_BANG] = ACTIONS(3077),
    [anon_sym_LPAREN] = ACTIONS(3075),
    [anon_sym_COMMA] = ACTIONS(3077),
    [anon_sym_null] = ACTIONS(3075),
    [anon_sym_QMARK] = ACTIONS(3075),
    [anon_sym_COLON_QMARK] = ACTIONS(3075),
    [anon_sym_COLON_COLON] = ACTIONS(3077),
    [anon_sym_AMP] = ACTIONS(3075),
    [anon_sym_LBRACK] = ACTIONS(3075),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3077),
    [anon_sym_LBRACE] = ACTIONS(3075),
    [anon_sym_LT_AT] = ACTIONS(3075),
    [anon_sym_AT_GT] = ACTIONS(3075),
    [anon_sym_LT_AT_AT] = ACTIONS(3075),
    [anon_sym_DOT] = ACTIONS(3075),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3077),
    [anon_sym_new] = ACTIONS(3075),
    [anon_sym_return_BANG] = ACTIONS(3077),
    [anon_sym_yield] = ACTIONS(3075),
    [anon_sym_yield_BANG] = ACTIONS(3077),
    [anon_sym_lazy] = ACTIONS(3075),
    [anon_sym_assert] = ACTIONS(3075),
    [anon_sym_upcast] = ACTIONS(3075),
    [anon_sym_downcast] = ACTIONS(3075),
    [anon_sym_COLON_GT] = ACTIONS(3077),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3077),
    [anon_sym_for] = ACTIONS(3075),
    [anon_sym_while] = ACTIONS(3075),
    [anon_sym_if] = ACTIONS(3075),
    [anon_sym_fun] = ACTIONS(3075),
    [anon_sym_try] = ACTIONS(3075),
    [anon_sym_match] = ACTIONS(3075),
    [anon_sym_match_BANG] = ACTIONS(3077),
    [anon_sym_function] = ACTIONS(3075),
    [anon_sym_LT_DASH] = ACTIONS(3075),
    [anon_sym_DOT_LBRACK] = ACTIONS(3077),
    [anon_sym_LT] = ACTIONS(3077),
    [anon_sym_use] = ACTIONS(3075),
    [anon_sym_use_BANG] = ACTIONS(3077),
    [anon_sym_do_BANG] = ACTIONS(3077),
    [anon_sym_begin] = ACTIONS(3075),
    [anon_sym_LPAREN2] = ACTIONS(3075),
    [anon_sym_or] = ACTIONS(3075),
    [aux_sym_char_token1] = ACTIONS(3077),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3075),
    [anon_sym_DQUOTE] = ACTIONS(3075),
    [anon_sym_AT_DQUOTE] = ACTIONS(3077),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3077),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3077),
    [sym_bool] = ACTIONS(3075),
    [sym_unit] = ACTIONS(3077),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3075),
    [sym_op_identifier] = ACTIONS(3075),
    [anon_sym_PLUS] = ACTIONS(3075),
    [anon_sym_DASH] = ACTIONS(3075),
    [anon_sym_PLUS_DOT] = ACTIONS(3075),
    [anon_sym_DASH_DOT] = ACTIONS(3075),
    [anon_sym_PERCENT] = ACTIONS(3075),
    [anon_sym_AMP_AMP] = ACTIONS(3075),
    [anon_sym_TILDE] = ACTIONS(3077),
    [aux_sym_prefix_op_token1] = ACTIONS(3075),
    [aux_sym_infix_op_token1] = ACTIONS(3077),
    [aux_sym_infix_op_token2] = ACTIONS(3075),
    [anon_sym_PIPE_PIPE] = ACTIONS(3075),
    [anon_sym_BANG_EQ] = ACTIONS(3075),
    [anon_sym_COLON_EQ] = ACTIONS(3077),
    [anon_sym_DOLLAR] = ACTIONS(3075),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3075),
    [sym_int] = ACTIONS(3075),
    [sym_xint] = ACTIONS(3077),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3077),
    [sym__newline] = ACTIONS(3077),
  },
  [2370] = {
    [sym_block_comment] = STATE(2370),
    [sym_compiler_directive_decl] = STATE(2370),
    [sym_fsi_directive_decl] = STATE(2370),
    [sym_preproc_line] = STATE(2370),
    [sym_identifier] = ACTIONS(3071),
    [anon_sym_EQ] = ACTIONS(3073),
    [anon_sym_COLON] = ACTIONS(3071),
    [anon_sym_return] = ACTIONS(3071),
    [anon_sym_do] = ACTIONS(3071),
    [anon_sym_let] = ACTIONS(3071),
    [anon_sym_let_BANG] = ACTIONS(3073),
    [anon_sym_LPAREN] = ACTIONS(3071),
    [anon_sym_COMMA] = ACTIONS(3073),
    [anon_sym_null] = ACTIONS(3071),
    [anon_sym_QMARK] = ACTIONS(3071),
    [anon_sym_COLON_QMARK] = ACTIONS(3071),
    [anon_sym_COLON_COLON] = ACTIONS(3073),
    [anon_sym_AMP] = ACTIONS(3071),
    [anon_sym_LBRACK] = ACTIONS(3071),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3073),
    [anon_sym_LBRACE] = ACTIONS(3071),
    [anon_sym_LT_AT] = ACTIONS(3071),
    [anon_sym_AT_GT] = ACTIONS(3071),
    [anon_sym_LT_AT_AT] = ACTIONS(3071),
    [anon_sym_DOT] = ACTIONS(3071),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3073),
    [anon_sym_new] = ACTIONS(3071),
    [anon_sym_return_BANG] = ACTIONS(3073),
    [anon_sym_yield] = ACTIONS(3071),
    [anon_sym_yield_BANG] = ACTIONS(3073),
    [anon_sym_lazy] = ACTIONS(3071),
    [anon_sym_assert] = ACTIONS(3071),
    [anon_sym_upcast] = ACTIONS(3071),
    [anon_sym_downcast] = ACTIONS(3071),
    [anon_sym_COLON_GT] = ACTIONS(3073),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3073),
    [anon_sym_for] = ACTIONS(3071),
    [anon_sym_while] = ACTIONS(3071),
    [anon_sym_if] = ACTIONS(3071),
    [anon_sym_fun] = ACTIONS(3071),
    [anon_sym_try] = ACTIONS(3071),
    [anon_sym_match] = ACTIONS(3071),
    [anon_sym_match_BANG] = ACTIONS(3073),
    [anon_sym_function] = ACTIONS(3071),
    [anon_sym_LT_DASH] = ACTIONS(3071),
    [anon_sym_DOT_LBRACK] = ACTIONS(3073),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_use] = ACTIONS(3071),
    [anon_sym_use_BANG] = ACTIONS(3073),
    [anon_sym_do_BANG] = ACTIONS(3073),
    [anon_sym_begin] = ACTIONS(3071),
    [anon_sym_LPAREN2] = ACTIONS(3071),
    [anon_sym_or] = ACTIONS(3071),
    [aux_sym_char_token1] = ACTIONS(3073),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3071),
    [anon_sym_DQUOTE] = ACTIONS(3071),
    [anon_sym_AT_DQUOTE] = ACTIONS(3073),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3073),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3073),
    [sym_bool] = ACTIONS(3071),
    [sym_unit] = ACTIONS(3073),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3071),
    [sym_op_identifier] = ACTIONS(3071),
    [anon_sym_PLUS] = ACTIONS(3071),
    [anon_sym_DASH] = ACTIONS(3071),
    [anon_sym_PLUS_DOT] = ACTIONS(3071),
    [anon_sym_DASH_DOT] = ACTIONS(3071),
    [anon_sym_PERCENT] = ACTIONS(3071),
    [anon_sym_AMP_AMP] = ACTIONS(3071),
    [anon_sym_TILDE] = ACTIONS(3073),
    [aux_sym_prefix_op_token1] = ACTIONS(3071),
    [aux_sym_infix_op_token1] = ACTIONS(3073),
    [aux_sym_infix_op_token2] = ACTIONS(3071),
    [anon_sym_PIPE_PIPE] = ACTIONS(3071),
    [anon_sym_BANG_EQ] = ACTIONS(3071),
    [anon_sym_COLON_EQ] = ACTIONS(3073),
    [anon_sym_DOLLAR] = ACTIONS(3071),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3071),
    [sym_int] = ACTIONS(3071),
    [sym_xint] = ACTIONS(3073),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3073),
    [sym__newline] = ACTIONS(3073),
  },
  [2371] = {
    [sym_block_comment] = STATE(2371),
    [sym_compiler_directive_decl] = STATE(2371),
    [sym_fsi_directive_decl] = STATE(2371),
    [sym_preproc_line] = STATE(2371),
    [sym_identifier] = ACTIONS(3067),
    [anon_sym_EQ] = ACTIONS(3069),
    [anon_sym_COLON] = ACTIONS(3067),
    [anon_sym_return] = ACTIONS(3067),
    [anon_sym_do] = ACTIONS(3067),
    [anon_sym_let] = ACTIONS(3067),
    [anon_sym_let_BANG] = ACTIONS(3069),
    [anon_sym_LPAREN] = ACTIONS(3067),
    [anon_sym_COMMA] = ACTIONS(3069),
    [anon_sym_null] = ACTIONS(3067),
    [anon_sym_QMARK] = ACTIONS(3067),
    [anon_sym_COLON_QMARK] = ACTIONS(3067),
    [anon_sym_COLON_COLON] = ACTIONS(3069),
    [anon_sym_AMP] = ACTIONS(3067),
    [anon_sym_LBRACK] = ACTIONS(3067),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3069),
    [anon_sym_LBRACE] = ACTIONS(3067),
    [anon_sym_LT_AT] = ACTIONS(3067),
    [anon_sym_AT_GT] = ACTIONS(3067),
    [anon_sym_LT_AT_AT] = ACTIONS(3067),
    [anon_sym_DOT] = ACTIONS(3067),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3069),
    [anon_sym_new] = ACTIONS(3067),
    [anon_sym_return_BANG] = ACTIONS(3069),
    [anon_sym_yield] = ACTIONS(3067),
    [anon_sym_yield_BANG] = ACTIONS(3069),
    [anon_sym_lazy] = ACTIONS(3067),
    [anon_sym_assert] = ACTIONS(3067),
    [anon_sym_upcast] = ACTIONS(3067),
    [anon_sym_downcast] = ACTIONS(3067),
    [anon_sym_COLON_GT] = ACTIONS(3069),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3069),
    [anon_sym_for] = ACTIONS(3067),
    [anon_sym_while] = ACTIONS(3067),
    [anon_sym_if] = ACTIONS(3067),
    [anon_sym_fun] = ACTIONS(3067),
    [anon_sym_try] = ACTIONS(3067),
    [anon_sym_match] = ACTIONS(3067),
    [anon_sym_match_BANG] = ACTIONS(3069),
    [anon_sym_function] = ACTIONS(3067),
    [anon_sym_LT_DASH] = ACTIONS(3067),
    [anon_sym_DOT_LBRACK] = ACTIONS(3069),
    [anon_sym_LT] = ACTIONS(3069),
    [anon_sym_use] = ACTIONS(3067),
    [anon_sym_use_BANG] = ACTIONS(3069),
    [anon_sym_do_BANG] = ACTIONS(3069),
    [anon_sym_begin] = ACTIONS(3067),
    [anon_sym_LPAREN2] = ACTIONS(3067),
    [anon_sym_or] = ACTIONS(3067),
    [aux_sym_char_token1] = ACTIONS(3069),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3067),
    [anon_sym_DQUOTE] = ACTIONS(3067),
    [anon_sym_AT_DQUOTE] = ACTIONS(3069),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3069),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3069),
    [sym_bool] = ACTIONS(3067),
    [sym_unit] = ACTIONS(3069),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3067),
    [sym_op_identifier] = ACTIONS(3067),
    [anon_sym_PLUS] = ACTIONS(3067),
    [anon_sym_DASH] = ACTIONS(3067),
    [anon_sym_PLUS_DOT] = ACTIONS(3067),
    [anon_sym_DASH_DOT] = ACTIONS(3067),
    [anon_sym_PERCENT] = ACTIONS(3067),
    [anon_sym_AMP_AMP] = ACTIONS(3067),
    [anon_sym_TILDE] = ACTIONS(3069),
    [aux_sym_prefix_op_token1] = ACTIONS(3067),
    [aux_sym_infix_op_token1] = ACTIONS(3069),
    [aux_sym_infix_op_token2] = ACTIONS(3067),
    [anon_sym_PIPE_PIPE] = ACTIONS(3067),
    [anon_sym_BANG_EQ] = ACTIONS(3067),
    [anon_sym_COLON_EQ] = ACTIONS(3069),
    [anon_sym_DOLLAR] = ACTIONS(3067),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3067),
    [sym_int] = ACTIONS(3067),
    [sym_xint] = ACTIONS(3069),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3069),
    [sym__newline] = ACTIONS(3069),
  },
  [2372] = {
    [sym_block_comment] = STATE(2372),
    [sym_compiler_directive_decl] = STATE(2372),
    [sym_fsi_directive_decl] = STATE(2372),
    [sym_preproc_line] = STATE(2372),
    [sym_identifier] = ACTIONS(3027),
    [anon_sym_EQ] = ACTIONS(3029),
    [anon_sym_COLON] = ACTIONS(3027),
    [anon_sym_return] = ACTIONS(3027),
    [anon_sym_do] = ACTIONS(3027),
    [anon_sym_let] = ACTIONS(3027),
    [anon_sym_let_BANG] = ACTIONS(3029),
    [anon_sym_LPAREN] = ACTIONS(3027),
    [anon_sym_COMMA] = ACTIONS(3029),
    [anon_sym_null] = ACTIONS(3027),
    [anon_sym_QMARK] = ACTIONS(3027),
    [anon_sym_COLON_QMARK] = ACTIONS(3027),
    [anon_sym_COLON_COLON] = ACTIONS(3029),
    [anon_sym_AMP] = ACTIONS(3027),
    [anon_sym_LBRACK] = ACTIONS(3027),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3027),
    [anon_sym_LT_AT] = ACTIONS(3027),
    [anon_sym_LT_AT_AT] = ACTIONS(3027),
    [anon_sym_DOT] = ACTIONS(3027),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3029),
    [anon_sym_new] = ACTIONS(3027),
    [anon_sym_return_BANG] = ACTIONS(3029),
    [anon_sym_yield] = ACTIONS(3027),
    [anon_sym_yield_BANG] = ACTIONS(3029),
    [anon_sym_lazy] = ACTIONS(3027),
    [anon_sym_assert] = ACTIONS(3027),
    [anon_sym_upcast] = ACTIONS(3027),
    [anon_sym_downcast] = ACTIONS(3027),
    [anon_sym_COLON_GT] = ACTIONS(3029),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3029),
    [anon_sym_for] = ACTIONS(3027),
    [anon_sym_while] = ACTIONS(3027),
    [anon_sym_if] = ACTIONS(3027),
    [anon_sym_fun] = ACTIONS(3027),
    [anon_sym_try] = ACTIONS(3027),
    [anon_sym_match] = ACTIONS(3027),
    [anon_sym_match_BANG] = ACTIONS(3029),
    [anon_sym_function] = ACTIONS(3027),
    [anon_sym_LT_DASH] = ACTIONS(3027),
    [anon_sym_DOT_LBRACK] = ACTIONS(3029),
    [anon_sym_LT] = ACTIONS(3029),
    [anon_sym_use] = ACTIONS(3027),
    [anon_sym_use_BANG] = ACTIONS(3029),
    [anon_sym_do_BANG] = ACTIONS(3029),
    [anon_sym_begin] = ACTIONS(3027),
    [anon_sym_LPAREN2] = ACTIONS(3027),
    [anon_sym_or] = ACTIONS(3027),
    [aux_sym_char_token1] = ACTIONS(3029),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3027),
    [anon_sym_DQUOTE] = ACTIONS(3027),
    [anon_sym_AT_DQUOTE] = ACTIONS(3029),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3029),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3029),
    [sym_bool] = ACTIONS(3027),
    [sym_unit] = ACTIONS(3029),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3027),
    [sym_op_identifier] = ACTIONS(3027),
    [anon_sym_PLUS] = ACTIONS(3027),
    [anon_sym_DASH] = ACTIONS(3027),
    [anon_sym_PLUS_DOT] = ACTIONS(3027),
    [anon_sym_DASH_DOT] = ACTIONS(3027),
    [anon_sym_PERCENT] = ACTIONS(3027),
    [anon_sym_AMP_AMP] = ACTIONS(3027),
    [anon_sym_TILDE] = ACTIONS(3029),
    [aux_sym_prefix_op_token1] = ACTIONS(3027),
    [aux_sym_infix_op_token1] = ACTIONS(3029),
    [aux_sym_infix_op_token2] = ACTIONS(3027),
    [anon_sym_PIPE_PIPE] = ACTIONS(3027),
    [anon_sym_BANG_EQ] = ACTIONS(3027),
    [anon_sym_COLON_EQ] = ACTIONS(3029),
    [anon_sym_DOLLAR] = ACTIONS(3027),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3027),
    [sym_int] = ACTIONS(3027),
    [sym_xint] = ACTIONS(3029),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3029),
    [anon_sym_POUNDendif] = ACTIONS(3029),
    [sym__newline] = ACTIONS(3029),
  },
  [2373] = {
    [sym_block_comment] = STATE(2373),
    [sym_compiler_directive_decl] = STATE(2373),
    [sym_fsi_directive_decl] = STATE(2373),
    [sym_preproc_line] = STATE(2373),
    [sym_identifier] = ACTIONS(2831),
    [anon_sym_EQ] = ACTIONS(2833),
    [anon_sym_COLON] = ACTIONS(2831),
    [anon_sym_return] = ACTIONS(2831),
    [anon_sym_do] = ACTIONS(2831),
    [anon_sym_let] = ACTIONS(2831),
    [anon_sym_let_BANG] = ACTIONS(2833),
    [anon_sym_LPAREN] = ACTIONS(2831),
    [anon_sym_COMMA] = ACTIONS(2833),
    [anon_sym_null] = ACTIONS(2831),
    [anon_sym_QMARK] = ACTIONS(2831),
    [anon_sym_COLON_QMARK] = ACTIONS(2831),
    [anon_sym_COLON_COLON] = ACTIONS(2833),
    [anon_sym_AMP] = ACTIONS(2831),
    [anon_sym_LBRACK] = ACTIONS(2831),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2833),
    [anon_sym_LBRACE] = ACTIONS(2831),
    [anon_sym_LT_AT] = ACTIONS(2831),
    [anon_sym_AT_GT] = ACTIONS(2831),
    [anon_sym_LT_AT_AT] = ACTIONS(2831),
    [anon_sym_DOT] = ACTIONS(2831),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2833),
    [anon_sym_new] = ACTIONS(2831),
    [anon_sym_return_BANG] = ACTIONS(2833),
    [anon_sym_yield] = ACTIONS(2831),
    [anon_sym_yield_BANG] = ACTIONS(2833),
    [anon_sym_lazy] = ACTIONS(2831),
    [anon_sym_assert] = ACTIONS(2831),
    [anon_sym_upcast] = ACTIONS(2831),
    [anon_sym_downcast] = ACTIONS(2831),
    [anon_sym_COLON_GT] = ACTIONS(2833),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2833),
    [anon_sym_for] = ACTIONS(2831),
    [anon_sym_while] = ACTIONS(2831),
    [anon_sym_if] = ACTIONS(2831),
    [anon_sym_fun] = ACTIONS(2831),
    [anon_sym_try] = ACTIONS(2831),
    [anon_sym_match] = ACTIONS(2831),
    [anon_sym_match_BANG] = ACTIONS(2833),
    [anon_sym_function] = ACTIONS(2831),
    [anon_sym_LT_DASH] = ACTIONS(2831),
    [anon_sym_DOT_LBRACK] = ACTIONS(2833),
    [anon_sym_LT] = ACTIONS(2833),
    [anon_sym_use] = ACTIONS(2831),
    [anon_sym_use_BANG] = ACTIONS(2833),
    [anon_sym_do_BANG] = ACTIONS(2833),
    [anon_sym_begin] = ACTIONS(2831),
    [anon_sym_LPAREN2] = ACTIONS(2831),
    [anon_sym_or] = ACTIONS(2831),
    [aux_sym_char_token1] = ACTIONS(2833),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2831),
    [anon_sym_DQUOTE] = ACTIONS(2831),
    [anon_sym_AT_DQUOTE] = ACTIONS(2833),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2833),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2833),
    [sym_bool] = ACTIONS(2831),
    [sym_unit] = ACTIONS(2833),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2831),
    [sym_op_identifier] = ACTIONS(2831),
    [anon_sym_PLUS] = ACTIONS(2831),
    [anon_sym_DASH] = ACTIONS(2831),
    [anon_sym_PLUS_DOT] = ACTIONS(2831),
    [anon_sym_DASH_DOT] = ACTIONS(2831),
    [anon_sym_PERCENT] = ACTIONS(2831),
    [anon_sym_AMP_AMP] = ACTIONS(2831),
    [anon_sym_TILDE] = ACTIONS(2833),
    [aux_sym_prefix_op_token1] = ACTIONS(2831),
    [aux_sym_infix_op_token1] = ACTIONS(2833),
    [aux_sym_infix_op_token2] = ACTIONS(2831),
    [anon_sym_PIPE_PIPE] = ACTIONS(2831),
    [anon_sym_BANG_EQ] = ACTIONS(2831),
    [anon_sym_COLON_EQ] = ACTIONS(2833),
    [anon_sym_DOLLAR] = ACTIONS(2831),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2831),
    [sym_int] = ACTIONS(2831),
    [sym_xint] = ACTIONS(2833),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2833),
    [sym__newline] = ACTIONS(2833),
  },
  [2374] = {
    [sym_block_comment] = STATE(2374),
    [sym_compiler_directive_decl] = STATE(2374),
    [sym_fsi_directive_decl] = STATE(2374),
    [sym_preproc_line] = STATE(2374),
    [sym_identifier] = ACTIONS(2974),
    [anon_sym_EQ] = ACTIONS(2976),
    [anon_sym_COLON] = ACTIONS(2974),
    [anon_sym_return] = ACTIONS(2974),
    [anon_sym_do] = ACTIONS(2974),
    [anon_sym_let] = ACTIONS(2974),
    [anon_sym_let_BANG] = ACTIONS(2976),
    [anon_sym_LPAREN] = ACTIONS(2974),
    [anon_sym_COMMA] = ACTIONS(2976),
    [anon_sym_null] = ACTIONS(2974),
    [anon_sym_QMARK] = ACTIONS(2974),
    [anon_sym_COLON_QMARK] = ACTIONS(2974),
    [anon_sym_COLON_COLON] = ACTIONS(2976),
    [anon_sym_AMP] = ACTIONS(2974),
    [anon_sym_LBRACK] = ACTIONS(2974),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2976),
    [anon_sym_LBRACE] = ACTIONS(2974),
    [anon_sym_LT_AT] = ACTIONS(2974),
    [anon_sym_LT_AT_AT] = ACTIONS(2974),
    [anon_sym_AT_AT_GT] = ACTIONS(2974),
    [anon_sym_DOT] = ACTIONS(2974),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2976),
    [anon_sym_new] = ACTIONS(2974),
    [anon_sym_return_BANG] = ACTIONS(2976),
    [anon_sym_yield] = ACTIONS(2974),
    [anon_sym_yield_BANG] = ACTIONS(2976),
    [anon_sym_lazy] = ACTIONS(2974),
    [anon_sym_assert] = ACTIONS(2974),
    [anon_sym_upcast] = ACTIONS(2974),
    [anon_sym_downcast] = ACTIONS(2974),
    [anon_sym_COLON_GT] = ACTIONS(2976),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2976),
    [anon_sym_for] = ACTIONS(2974),
    [anon_sym_while] = ACTIONS(2974),
    [anon_sym_if] = ACTIONS(2974),
    [anon_sym_fun] = ACTIONS(2974),
    [anon_sym_try] = ACTIONS(2974),
    [anon_sym_match] = ACTIONS(2974),
    [anon_sym_match_BANG] = ACTIONS(2976),
    [anon_sym_function] = ACTIONS(2974),
    [anon_sym_LT_DASH] = ACTIONS(2974),
    [anon_sym_DOT_LBRACK] = ACTIONS(2976),
    [anon_sym_LT] = ACTIONS(2976),
    [anon_sym_use] = ACTIONS(2974),
    [anon_sym_use_BANG] = ACTIONS(2976),
    [anon_sym_do_BANG] = ACTIONS(2976),
    [anon_sym_begin] = ACTIONS(2974),
    [anon_sym_LPAREN2] = ACTIONS(2974),
    [anon_sym_or] = ACTIONS(2974),
    [aux_sym_char_token1] = ACTIONS(2976),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2974),
    [anon_sym_DQUOTE] = ACTIONS(2974),
    [anon_sym_AT_DQUOTE] = ACTIONS(2976),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2976),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2976),
    [sym_bool] = ACTIONS(2974),
    [sym_unit] = ACTIONS(2976),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2974),
    [sym_op_identifier] = ACTIONS(2974),
    [anon_sym_PLUS] = ACTIONS(2974),
    [anon_sym_DASH] = ACTIONS(2974),
    [anon_sym_PLUS_DOT] = ACTIONS(2974),
    [anon_sym_DASH_DOT] = ACTIONS(2974),
    [anon_sym_PERCENT] = ACTIONS(2974),
    [anon_sym_AMP_AMP] = ACTIONS(2974),
    [anon_sym_TILDE] = ACTIONS(2976),
    [aux_sym_prefix_op_token1] = ACTIONS(2974),
    [aux_sym_infix_op_token1] = ACTIONS(2976),
    [aux_sym_infix_op_token2] = ACTIONS(2974),
    [anon_sym_PIPE_PIPE] = ACTIONS(2974),
    [anon_sym_BANG_EQ] = ACTIONS(2974),
    [anon_sym_COLON_EQ] = ACTIONS(2976),
    [anon_sym_DOLLAR] = ACTIONS(2974),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2974),
    [sym_int] = ACTIONS(2974),
    [sym_xint] = ACTIONS(2976),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2976),
    [sym__newline] = ACTIONS(2976),
  },
  [2375] = {
    [sym_block_comment] = STATE(2375),
    [sym_compiler_directive_decl] = STATE(2375),
    [sym_fsi_directive_decl] = STATE(2375),
    [sym_preproc_line] = STATE(2375),
    [sym_identifier] = ACTIONS(2988),
    [anon_sym_EQ] = ACTIONS(2990),
    [anon_sym_COLON] = ACTIONS(2988),
    [anon_sym_return] = ACTIONS(2988),
    [anon_sym_do] = ACTIONS(2988),
    [anon_sym_let] = ACTIONS(2988),
    [anon_sym_let_BANG] = ACTIONS(2990),
    [anon_sym_LPAREN] = ACTIONS(2988),
    [anon_sym_COMMA] = ACTIONS(2990),
    [anon_sym_null] = ACTIONS(2988),
    [anon_sym_QMARK] = ACTIONS(2988),
    [anon_sym_COLON_QMARK] = ACTIONS(2988),
    [anon_sym_COLON_COLON] = ACTIONS(2990),
    [anon_sym_AMP] = ACTIONS(2988),
    [anon_sym_LBRACK] = ACTIONS(2988),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2990),
    [anon_sym_LBRACE] = ACTIONS(2988),
    [anon_sym_LT_AT] = ACTIONS(2988),
    [anon_sym_AT_GT] = ACTIONS(2988),
    [anon_sym_LT_AT_AT] = ACTIONS(2988),
    [anon_sym_DOT] = ACTIONS(2988),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2990),
    [anon_sym_new] = ACTIONS(2988),
    [anon_sym_return_BANG] = ACTIONS(2990),
    [anon_sym_yield] = ACTIONS(2988),
    [anon_sym_yield_BANG] = ACTIONS(2990),
    [anon_sym_lazy] = ACTIONS(2988),
    [anon_sym_assert] = ACTIONS(2988),
    [anon_sym_upcast] = ACTIONS(2988),
    [anon_sym_downcast] = ACTIONS(2988),
    [anon_sym_COLON_GT] = ACTIONS(2990),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2990),
    [anon_sym_for] = ACTIONS(2988),
    [anon_sym_while] = ACTIONS(2988),
    [anon_sym_if] = ACTIONS(2988),
    [anon_sym_fun] = ACTIONS(2988),
    [anon_sym_try] = ACTIONS(2988),
    [anon_sym_match] = ACTIONS(2988),
    [anon_sym_match_BANG] = ACTIONS(2990),
    [anon_sym_function] = ACTIONS(2988),
    [anon_sym_LT_DASH] = ACTIONS(2988),
    [anon_sym_DOT_LBRACK] = ACTIONS(2990),
    [anon_sym_LT] = ACTIONS(2990),
    [anon_sym_use] = ACTIONS(2988),
    [anon_sym_use_BANG] = ACTIONS(2990),
    [anon_sym_do_BANG] = ACTIONS(2990),
    [anon_sym_begin] = ACTIONS(2988),
    [anon_sym_LPAREN2] = ACTIONS(2988),
    [anon_sym_or] = ACTIONS(2988),
    [aux_sym_char_token1] = ACTIONS(2990),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2988),
    [anon_sym_DQUOTE] = ACTIONS(2988),
    [anon_sym_AT_DQUOTE] = ACTIONS(2990),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2990),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2990),
    [sym_bool] = ACTIONS(2988),
    [sym_unit] = ACTIONS(2990),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2988),
    [sym_op_identifier] = ACTIONS(2988),
    [anon_sym_PLUS] = ACTIONS(2988),
    [anon_sym_DASH] = ACTIONS(2988),
    [anon_sym_PLUS_DOT] = ACTIONS(2988),
    [anon_sym_DASH_DOT] = ACTIONS(2988),
    [anon_sym_PERCENT] = ACTIONS(2988),
    [anon_sym_AMP_AMP] = ACTIONS(2988),
    [anon_sym_TILDE] = ACTIONS(2990),
    [aux_sym_prefix_op_token1] = ACTIONS(2988),
    [aux_sym_infix_op_token1] = ACTIONS(2990),
    [aux_sym_infix_op_token2] = ACTIONS(2988),
    [anon_sym_PIPE_PIPE] = ACTIONS(2988),
    [anon_sym_BANG_EQ] = ACTIONS(2988),
    [anon_sym_COLON_EQ] = ACTIONS(2990),
    [anon_sym_DOLLAR] = ACTIONS(2988),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2988),
    [sym_int] = ACTIONS(2988),
    [sym_xint] = ACTIONS(2990),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2990),
    [sym__newline] = ACTIONS(2990),
  },
  [2376] = {
    [sym_block_comment] = STATE(2376),
    [sym_compiler_directive_decl] = STATE(2376),
    [sym_fsi_directive_decl] = STATE(2376),
    [sym_preproc_line] = STATE(2376),
    [sym_identifier] = ACTIONS(3055),
    [anon_sym_EQ] = ACTIONS(3057),
    [anon_sym_COLON] = ACTIONS(3055),
    [anon_sym_return] = ACTIONS(3055),
    [anon_sym_do] = ACTIONS(3055),
    [anon_sym_let] = ACTIONS(3055),
    [anon_sym_let_BANG] = ACTIONS(3057),
    [anon_sym_LPAREN] = ACTIONS(3055),
    [anon_sym_COMMA] = ACTIONS(3057),
    [anon_sym_null] = ACTIONS(3055),
    [anon_sym_QMARK] = ACTIONS(3055),
    [anon_sym_COLON_QMARK] = ACTIONS(3055),
    [anon_sym_COLON_COLON] = ACTIONS(3057),
    [anon_sym_AMP] = ACTIONS(3055),
    [anon_sym_LBRACK] = ACTIONS(3055),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3057),
    [anon_sym_LBRACE] = ACTIONS(3055),
    [anon_sym_LT_AT] = ACTIONS(3055),
    [anon_sym_AT_GT] = ACTIONS(3055),
    [anon_sym_LT_AT_AT] = ACTIONS(3055),
    [anon_sym_DOT] = ACTIONS(3055),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3057),
    [anon_sym_new] = ACTIONS(3055),
    [anon_sym_return_BANG] = ACTIONS(3057),
    [anon_sym_yield] = ACTIONS(3055),
    [anon_sym_yield_BANG] = ACTIONS(3057),
    [anon_sym_lazy] = ACTIONS(3055),
    [anon_sym_assert] = ACTIONS(3055),
    [anon_sym_upcast] = ACTIONS(3055),
    [anon_sym_downcast] = ACTIONS(3055),
    [anon_sym_COLON_GT] = ACTIONS(3057),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3057),
    [anon_sym_for] = ACTIONS(3055),
    [anon_sym_while] = ACTIONS(3055),
    [anon_sym_if] = ACTIONS(3055),
    [anon_sym_fun] = ACTIONS(3055),
    [anon_sym_try] = ACTIONS(3055),
    [anon_sym_match] = ACTIONS(3055),
    [anon_sym_match_BANG] = ACTIONS(3057),
    [anon_sym_function] = ACTIONS(3055),
    [anon_sym_LT_DASH] = ACTIONS(3055),
    [anon_sym_DOT_LBRACK] = ACTIONS(3057),
    [anon_sym_LT] = ACTIONS(3057),
    [anon_sym_use] = ACTIONS(3055),
    [anon_sym_use_BANG] = ACTIONS(3057),
    [anon_sym_do_BANG] = ACTIONS(3057),
    [anon_sym_begin] = ACTIONS(3055),
    [anon_sym_LPAREN2] = ACTIONS(3055),
    [anon_sym_or] = ACTIONS(3055),
    [aux_sym_char_token1] = ACTIONS(3057),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3055),
    [anon_sym_DQUOTE] = ACTIONS(3055),
    [anon_sym_AT_DQUOTE] = ACTIONS(3057),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3057),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3057),
    [sym_bool] = ACTIONS(3055),
    [sym_unit] = ACTIONS(3057),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3055),
    [sym_op_identifier] = ACTIONS(3055),
    [anon_sym_PLUS] = ACTIONS(3055),
    [anon_sym_DASH] = ACTIONS(3055),
    [anon_sym_PLUS_DOT] = ACTIONS(3055),
    [anon_sym_DASH_DOT] = ACTIONS(3055),
    [anon_sym_PERCENT] = ACTIONS(3055),
    [anon_sym_AMP_AMP] = ACTIONS(3055),
    [anon_sym_TILDE] = ACTIONS(3057),
    [aux_sym_prefix_op_token1] = ACTIONS(3055),
    [aux_sym_infix_op_token1] = ACTIONS(3057),
    [aux_sym_infix_op_token2] = ACTIONS(3055),
    [anon_sym_PIPE_PIPE] = ACTIONS(3055),
    [anon_sym_BANG_EQ] = ACTIONS(3055),
    [anon_sym_COLON_EQ] = ACTIONS(3057),
    [anon_sym_DOLLAR] = ACTIONS(3055),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3055),
    [sym_int] = ACTIONS(3055),
    [sym_xint] = ACTIONS(3057),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3057),
    [sym__newline] = ACTIONS(3057),
  },
  [2377] = {
    [sym_block_comment] = STATE(2377),
    [sym_compiler_directive_decl] = STATE(2377),
    [sym_fsi_directive_decl] = STATE(2377),
    [sym_preproc_line] = STATE(2377),
    [sym_identifier] = ACTIONS(3023),
    [anon_sym_EQ] = ACTIONS(3025),
    [anon_sym_COLON] = ACTIONS(3023),
    [anon_sym_return] = ACTIONS(3023),
    [anon_sym_do] = ACTIONS(3023),
    [anon_sym_let] = ACTIONS(3023),
    [anon_sym_let_BANG] = ACTIONS(3025),
    [anon_sym_LPAREN] = ACTIONS(3023),
    [anon_sym_COMMA] = ACTIONS(3025),
    [anon_sym_null] = ACTIONS(3023),
    [anon_sym_QMARK] = ACTIONS(3023),
    [anon_sym_COLON_QMARK] = ACTIONS(3023),
    [anon_sym_COLON_COLON] = ACTIONS(3025),
    [anon_sym_AMP] = ACTIONS(3023),
    [anon_sym_LBRACK] = ACTIONS(3023),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3025),
    [anon_sym_LBRACE] = ACTIONS(3023),
    [anon_sym_LT_AT] = ACTIONS(3023),
    [anon_sym_LT_AT_AT] = ACTIONS(3023),
    [anon_sym_DOT] = ACTIONS(3023),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3025),
    [anon_sym_new] = ACTIONS(3023),
    [anon_sym_return_BANG] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(3023),
    [anon_sym_yield_BANG] = ACTIONS(3025),
    [anon_sym_lazy] = ACTIONS(3023),
    [anon_sym_assert] = ACTIONS(3023),
    [anon_sym_upcast] = ACTIONS(3023),
    [anon_sym_downcast] = ACTIONS(3023),
    [anon_sym_COLON_GT] = ACTIONS(3025),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3025),
    [anon_sym_for] = ACTIONS(3023),
    [anon_sym_while] = ACTIONS(3023),
    [anon_sym_if] = ACTIONS(3023),
    [anon_sym_fun] = ACTIONS(3023),
    [anon_sym_try] = ACTIONS(3023),
    [anon_sym_match] = ACTIONS(3023),
    [anon_sym_match_BANG] = ACTIONS(3025),
    [anon_sym_function] = ACTIONS(3023),
    [anon_sym_LT_DASH] = ACTIONS(3023),
    [anon_sym_DOT_LBRACK] = ACTIONS(3025),
    [anon_sym_LT] = ACTIONS(3025),
    [anon_sym_use] = ACTIONS(3023),
    [anon_sym_use_BANG] = ACTIONS(3025),
    [anon_sym_do_BANG] = ACTIONS(3025),
    [anon_sym_begin] = ACTIONS(3023),
    [anon_sym_LPAREN2] = ACTIONS(3023),
    [anon_sym_or] = ACTIONS(3023),
    [aux_sym_char_token1] = ACTIONS(3025),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3023),
    [anon_sym_DQUOTE] = ACTIONS(3023),
    [anon_sym_AT_DQUOTE] = ACTIONS(3025),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3025),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3025),
    [sym_bool] = ACTIONS(3023),
    [sym_unit] = ACTIONS(3025),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3023),
    [sym_op_identifier] = ACTIONS(3023),
    [anon_sym_PLUS] = ACTIONS(3023),
    [anon_sym_DASH] = ACTIONS(3023),
    [anon_sym_PLUS_DOT] = ACTIONS(3023),
    [anon_sym_DASH_DOT] = ACTIONS(3023),
    [anon_sym_PERCENT] = ACTIONS(3023),
    [anon_sym_AMP_AMP] = ACTIONS(3023),
    [anon_sym_TILDE] = ACTIONS(3025),
    [aux_sym_prefix_op_token1] = ACTIONS(3023),
    [aux_sym_infix_op_token1] = ACTIONS(3025),
    [aux_sym_infix_op_token2] = ACTIONS(3023),
    [anon_sym_PIPE_PIPE] = ACTIONS(3023),
    [anon_sym_BANG_EQ] = ACTIONS(3023),
    [anon_sym_COLON_EQ] = ACTIONS(3025),
    [anon_sym_DOLLAR] = ACTIONS(3023),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3023),
    [sym_int] = ACTIONS(3023),
    [sym_xint] = ACTIONS(3025),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3025),
    [anon_sym_POUNDendif] = ACTIONS(3025),
    [sym__newline] = ACTIONS(3025),
  },
  [2378] = {
    [sym_block_comment] = STATE(2378),
    [sym_compiler_directive_decl] = STATE(2378),
    [sym_fsi_directive_decl] = STATE(2378),
    [sym_preproc_line] = STATE(2378),
    [sym_identifier] = ACTIONS(3019),
    [anon_sym_EQ] = ACTIONS(3021),
    [anon_sym_COLON] = ACTIONS(3019),
    [anon_sym_return] = ACTIONS(3019),
    [anon_sym_do] = ACTIONS(3019),
    [anon_sym_let] = ACTIONS(3019),
    [anon_sym_let_BANG] = ACTIONS(3021),
    [anon_sym_LPAREN] = ACTIONS(3019),
    [anon_sym_COMMA] = ACTIONS(3021),
    [anon_sym_null] = ACTIONS(3019),
    [anon_sym_QMARK] = ACTIONS(3019),
    [anon_sym_COLON_QMARK] = ACTIONS(3019),
    [anon_sym_COLON_COLON] = ACTIONS(3021),
    [anon_sym_AMP] = ACTIONS(3019),
    [anon_sym_LBRACK] = ACTIONS(3019),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3021),
    [anon_sym_LBRACE] = ACTIONS(3019),
    [anon_sym_LT_AT] = ACTIONS(3019),
    [anon_sym_LT_AT_AT] = ACTIONS(3019),
    [anon_sym_DOT] = ACTIONS(3019),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3021),
    [anon_sym_new] = ACTIONS(3019),
    [anon_sym_return_BANG] = ACTIONS(3021),
    [anon_sym_yield] = ACTIONS(3019),
    [anon_sym_yield_BANG] = ACTIONS(3021),
    [anon_sym_lazy] = ACTIONS(3019),
    [anon_sym_assert] = ACTIONS(3019),
    [anon_sym_upcast] = ACTIONS(3019),
    [anon_sym_downcast] = ACTIONS(3019),
    [anon_sym_COLON_GT] = ACTIONS(3021),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3021),
    [anon_sym_for] = ACTIONS(3019),
    [anon_sym_while] = ACTIONS(3019),
    [anon_sym_if] = ACTIONS(3019),
    [anon_sym_fun] = ACTIONS(3019),
    [anon_sym_try] = ACTIONS(3019),
    [anon_sym_match] = ACTIONS(3019),
    [anon_sym_match_BANG] = ACTIONS(3021),
    [anon_sym_function] = ACTIONS(3019),
    [anon_sym_LT_DASH] = ACTIONS(3019),
    [anon_sym_DOT_LBRACK] = ACTIONS(3021),
    [anon_sym_LT] = ACTIONS(3021),
    [anon_sym_use] = ACTIONS(3019),
    [anon_sym_use_BANG] = ACTIONS(3021),
    [anon_sym_do_BANG] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3019),
    [anon_sym_LPAREN2] = ACTIONS(3019),
    [anon_sym_or] = ACTIONS(3019),
    [aux_sym_char_token1] = ACTIONS(3021),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3019),
    [anon_sym_DQUOTE] = ACTIONS(3019),
    [anon_sym_AT_DQUOTE] = ACTIONS(3021),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3021),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3021),
    [sym_bool] = ACTIONS(3019),
    [sym_unit] = ACTIONS(3021),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3019),
    [sym_op_identifier] = ACTIONS(3019),
    [anon_sym_PLUS] = ACTIONS(3019),
    [anon_sym_DASH] = ACTIONS(3019),
    [anon_sym_PLUS_DOT] = ACTIONS(3019),
    [anon_sym_DASH_DOT] = ACTIONS(3019),
    [anon_sym_PERCENT] = ACTIONS(3019),
    [anon_sym_AMP_AMP] = ACTIONS(3019),
    [anon_sym_TILDE] = ACTIONS(3021),
    [aux_sym_prefix_op_token1] = ACTIONS(3019),
    [aux_sym_infix_op_token1] = ACTIONS(3021),
    [aux_sym_infix_op_token2] = ACTIONS(3019),
    [anon_sym_PIPE_PIPE] = ACTIONS(3019),
    [anon_sym_BANG_EQ] = ACTIONS(3019),
    [anon_sym_COLON_EQ] = ACTIONS(3021),
    [anon_sym_DOLLAR] = ACTIONS(3019),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3019),
    [sym_int] = ACTIONS(3019),
    [sym_xint] = ACTIONS(3021),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3021),
    [anon_sym_POUNDendif] = ACTIONS(3021),
    [sym__newline] = ACTIONS(3021),
  },
  [2379] = {
    [sym_block_comment] = STATE(2379),
    [sym_compiler_directive_decl] = STATE(2379),
    [sym_fsi_directive_decl] = STATE(2379),
    [sym_preproc_line] = STATE(2379),
    [sym_identifier] = ACTIONS(2954),
    [anon_sym_EQ] = ACTIONS(2956),
    [anon_sym_COLON] = ACTIONS(2954),
    [anon_sym_return] = ACTIONS(2954),
    [anon_sym_do] = ACTIONS(2954),
    [anon_sym_let] = ACTIONS(2954),
    [anon_sym_let_BANG] = ACTIONS(2956),
    [anon_sym_LPAREN] = ACTIONS(2954),
    [anon_sym_COMMA] = ACTIONS(2956),
    [anon_sym_null] = ACTIONS(2954),
    [anon_sym_QMARK] = ACTIONS(2954),
    [anon_sym_COLON_QMARK] = ACTIONS(2954),
    [anon_sym_COLON_COLON] = ACTIONS(2956),
    [anon_sym_AMP] = ACTIONS(2954),
    [anon_sym_LBRACK] = ACTIONS(2954),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2956),
    [anon_sym_LBRACE] = ACTIONS(2954),
    [anon_sym_LT_AT] = ACTIONS(2954),
    [anon_sym_LT_AT_AT] = ACTIONS(2954),
    [anon_sym_DOT] = ACTIONS(2954),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2956),
    [anon_sym_new] = ACTIONS(2954),
    [anon_sym_return_BANG] = ACTIONS(2956),
    [anon_sym_yield] = ACTIONS(2954),
    [anon_sym_yield_BANG] = ACTIONS(2956),
    [anon_sym_lazy] = ACTIONS(2954),
    [anon_sym_assert] = ACTIONS(2954),
    [anon_sym_upcast] = ACTIONS(2954),
    [anon_sym_downcast] = ACTIONS(2954),
    [anon_sym_COLON_GT] = ACTIONS(2956),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2956),
    [anon_sym_for] = ACTIONS(2954),
    [anon_sym_while] = ACTIONS(2954),
    [anon_sym_if] = ACTIONS(2954),
    [anon_sym_fun] = ACTIONS(2954),
    [anon_sym_try] = ACTIONS(2954),
    [anon_sym_match] = ACTIONS(2954),
    [anon_sym_match_BANG] = ACTIONS(2956),
    [anon_sym_function] = ACTIONS(2954),
    [anon_sym_LT_DASH] = ACTIONS(2954),
    [anon_sym_DOT_LBRACK] = ACTIONS(2956),
    [anon_sym_LT] = ACTIONS(2956),
    [anon_sym_GT] = ACTIONS(2954),
    [anon_sym_use] = ACTIONS(2954),
    [anon_sym_use_BANG] = ACTIONS(2956),
    [anon_sym_do_BANG] = ACTIONS(2956),
    [anon_sym_begin] = ACTIONS(2954),
    [anon_sym_LPAREN2] = ACTIONS(2954),
    [anon_sym_or] = ACTIONS(2954),
    [aux_sym_char_token1] = ACTIONS(2956),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2954),
    [anon_sym_DQUOTE] = ACTIONS(2954),
    [anon_sym_AT_DQUOTE] = ACTIONS(2956),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2956),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2956),
    [sym_bool] = ACTIONS(2954),
    [sym_unit] = ACTIONS(2956),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2954),
    [sym_op_identifier] = ACTIONS(2954),
    [anon_sym_PLUS] = ACTIONS(2954),
    [anon_sym_DASH] = ACTIONS(2954),
    [anon_sym_PLUS_DOT] = ACTIONS(2954),
    [anon_sym_DASH_DOT] = ACTIONS(2954),
    [anon_sym_PERCENT] = ACTIONS(2954),
    [anon_sym_AMP_AMP] = ACTIONS(2954),
    [anon_sym_TILDE] = ACTIONS(2956),
    [aux_sym_prefix_op_token1] = ACTIONS(2954),
    [aux_sym_infix_op_token1] = ACTIONS(2956),
    [aux_sym_infix_op_token2] = ACTIONS(2954),
    [anon_sym_PIPE_PIPE] = ACTIONS(2954),
    [anon_sym_BANG_EQ] = ACTIONS(2954),
    [anon_sym_COLON_EQ] = ACTIONS(2956),
    [anon_sym_DOLLAR] = ACTIONS(2954),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2954),
    [sym_int] = ACTIONS(2954),
    [sym_xint] = ACTIONS(2956),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2956),
    [sym__newline] = ACTIONS(2956),
  },
  [2380] = {
    [sym_block_comment] = STATE(2380),
    [sym_compiler_directive_decl] = STATE(2380),
    [sym_fsi_directive_decl] = STATE(2380),
    [sym_preproc_line] = STATE(2380),
    [sym_identifier] = ACTIONS(2851),
    [anon_sym_EQ] = ACTIONS(2853),
    [anon_sym_COLON] = ACTIONS(2851),
    [anon_sym_return] = ACTIONS(2851),
    [anon_sym_do] = ACTIONS(2851),
    [anon_sym_let] = ACTIONS(2851),
    [anon_sym_let_BANG] = ACTIONS(2853),
    [anon_sym_LPAREN] = ACTIONS(2851),
    [anon_sym_COMMA] = ACTIONS(2853),
    [anon_sym_null] = ACTIONS(2851),
    [anon_sym_QMARK] = ACTIONS(2851),
    [anon_sym_COLON_QMARK] = ACTIONS(2851),
    [anon_sym_COLON_COLON] = ACTIONS(2853),
    [anon_sym_AMP] = ACTIONS(2851),
    [anon_sym_LBRACK] = ACTIONS(2851),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2853),
    [anon_sym_LBRACE] = ACTIONS(2851),
    [anon_sym_LT_AT] = ACTIONS(2851),
    [anon_sym_LT_AT_AT] = ACTIONS(2851),
    [anon_sym_AT_AT_GT] = ACTIONS(2851),
    [anon_sym_DOT] = ACTIONS(2851),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2853),
    [anon_sym_new] = ACTIONS(2851),
    [anon_sym_return_BANG] = ACTIONS(2853),
    [anon_sym_yield] = ACTIONS(2851),
    [anon_sym_yield_BANG] = ACTIONS(2853),
    [anon_sym_lazy] = ACTIONS(2851),
    [anon_sym_assert] = ACTIONS(2851),
    [anon_sym_upcast] = ACTIONS(2851),
    [anon_sym_downcast] = ACTIONS(2851),
    [anon_sym_COLON_GT] = ACTIONS(2853),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2853),
    [anon_sym_for] = ACTIONS(2851),
    [anon_sym_while] = ACTIONS(2851),
    [anon_sym_if] = ACTIONS(2851),
    [anon_sym_fun] = ACTIONS(2851),
    [anon_sym_try] = ACTIONS(2851),
    [anon_sym_match] = ACTIONS(2851),
    [anon_sym_match_BANG] = ACTIONS(2853),
    [anon_sym_function] = ACTIONS(2851),
    [anon_sym_LT_DASH] = ACTIONS(2851),
    [anon_sym_DOT_LBRACK] = ACTIONS(2853),
    [anon_sym_LT] = ACTIONS(2853),
    [anon_sym_use] = ACTIONS(2851),
    [anon_sym_use_BANG] = ACTIONS(2853),
    [anon_sym_do_BANG] = ACTIONS(2853),
    [anon_sym_begin] = ACTIONS(2851),
    [anon_sym_LPAREN2] = ACTIONS(2851),
    [anon_sym_or] = ACTIONS(2851),
    [aux_sym_char_token1] = ACTIONS(2853),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2851),
    [anon_sym_DQUOTE] = ACTIONS(2851),
    [anon_sym_AT_DQUOTE] = ACTIONS(2853),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2853),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2853),
    [sym_bool] = ACTIONS(2851),
    [sym_unit] = ACTIONS(2853),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2851),
    [sym_op_identifier] = ACTIONS(2851),
    [anon_sym_PLUS] = ACTIONS(2851),
    [anon_sym_DASH] = ACTIONS(2851),
    [anon_sym_PLUS_DOT] = ACTIONS(2851),
    [anon_sym_DASH_DOT] = ACTIONS(2851),
    [anon_sym_PERCENT] = ACTIONS(2851),
    [anon_sym_AMP_AMP] = ACTIONS(2851),
    [anon_sym_TILDE] = ACTIONS(2853),
    [aux_sym_prefix_op_token1] = ACTIONS(2851),
    [aux_sym_infix_op_token1] = ACTIONS(2853),
    [aux_sym_infix_op_token2] = ACTIONS(2851),
    [anon_sym_PIPE_PIPE] = ACTIONS(2851),
    [anon_sym_BANG_EQ] = ACTIONS(2851),
    [anon_sym_COLON_EQ] = ACTIONS(2853),
    [anon_sym_DOLLAR] = ACTIONS(2851),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2851),
    [sym_int] = ACTIONS(2851),
    [sym_xint] = ACTIONS(2853),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2853),
    [sym__newline] = ACTIONS(2853),
  },
  [2381] = {
    [sym_block_comment] = STATE(2381),
    [sym_compiler_directive_decl] = STATE(2381),
    [sym_fsi_directive_decl] = STATE(2381),
    [sym_preproc_line] = STATE(2381),
    [sym_identifier] = ACTIONS(2922),
    [anon_sym_EQ] = ACTIONS(2924),
    [anon_sym_COLON] = ACTIONS(2922),
    [anon_sym_return] = ACTIONS(2922),
    [anon_sym_do] = ACTIONS(2922),
    [anon_sym_let] = ACTIONS(2922),
    [anon_sym_let_BANG] = ACTIONS(2924),
    [anon_sym_LPAREN] = ACTIONS(2922),
    [anon_sym_COMMA] = ACTIONS(2924),
    [anon_sym_null] = ACTIONS(2922),
    [anon_sym_QMARK] = ACTIONS(2922),
    [anon_sym_COLON_QMARK] = ACTIONS(2922),
    [anon_sym_COLON_COLON] = ACTIONS(2924),
    [anon_sym_AMP] = ACTIONS(2922),
    [anon_sym_LBRACK] = ACTIONS(2922),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2924),
    [anon_sym_LBRACE] = ACTIONS(2922),
    [anon_sym_LT_AT] = ACTIONS(2922),
    [anon_sym_LT_AT_AT] = ACTIONS(2922),
    [anon_sym_AT_AT_GT] = ACTIONS(2922),
    [anon_sym_DOT] = ACTIONS(2922),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2924),
    [anon_sym_new] = ACTIONS(2922),
    [anon_sym_return_BANG] = ACTIONS(2924),
    [anon_sym_yield] = ACTIONS(2922),
    [anon_sym_yield_BANG] = ACTIONS(2924),
    [anon_sym_lazy] = ACTIONS(2922),
    [anon_sym_assert] = ACTIONS(2922),
    [anon_sym_upcast] = ACTIONS(2922),
    [anon_sym_downcast] = ACTIONS(2922),
    [anon_sym_COLON_GT] = ACTIONS(2924),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2924),
    [anon_sym_for] = ACTIONS(2922),
    [anon_sym_while] = ACTIONS(2922),
    [anon_sym_if] = ACTIONS(2922),
    [anon_sym_fun] = ACTIONS(2922),
    [anon_sym_try] = ACTIONS(2922),
    [anon_sym_match] = ACTIONS(2922),
    [anon_sym_match_BANG] = ACTIONS(2924),
    [anon_sym_function] = ACTIONS(2922),
    [anon_sym_LT_DASH] = ACTIONS(2922),
    [anon_sym_DOT_LBRACK] = ACTIONS(2924),
    [anon_sym_LT] = ACTIONS(2924),
    [anon_sym_use] = ACTIONS(2922),
    [anon_sym_use_BANG] = ACTIONS(2924),
    [anon_sym_do_BANG] = ACTIONS(2924),
    [anon_sym_begin] = ACTIONS(2922),
    [anon_sym_LPAREN2] = ACTIONS(2922),
    [anon_sym_or] = ACTIONS(2922),
    [aux_sym_char_token1] = ACTIONS(2924),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2922),
    [anon_sym_DQUOTE] = ACTIONS(2922),
    [anon_sym_AT_DQUOTE] = ACTIONS(2924),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2924),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2924),
    [sym_bool] = ACTIONS(2922),
    [sym_unit] = ACTIONS(2924),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2922),
    [sym_op_identifier] = ACTIONS(2922),
    [anon_sym_PLUS] = ACTIONS(2922),
    [anon_sym_DASH] = ACTIONS(2922),
    [anon_sym_PLUS_DOT] = ACTIONS(2922),
    [anon_sym_DASH_DOT] = ACTIONS(2922),
    [anon_sym_PERCENT] = ACTIONS(2922),
    [anon_sym_AMP_AMP] = ACTIONS(2922),
    [anon_sym_TILDE] = ACTIONS(2924),
    [aux_sym_prefix_op_token1] = ACTIONS(2922),
    [aux_sym_infix_op_token1] = ACTIONS(2924),
    [aux_sym_infix_op_token2] = ACTIONS(2922),
    [anon_sym_PIPE_PIPE] = ACTIONS(2922),
    [anon_sym_BANG_EQ] = ACTIONS(2922),
    [anon_sym_COLON_EQ] = ACTIONS(2924),
    [anon_sym_DOLLAR] = ACTIONS(2922),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2922),
    [sym_int] = ACTIONS(2922),
    [sym_xint] = ACTIONS(2924),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2924),
    [sym__newline] = ACTIONS(2924),
  },
  [2382] = {
    [sym_block_comment] = STATE(2382),
    [sym_compiler_directive_decl] = STATE(2382),
    [sym_fsi_directive_decl] = STATE(2382),
    [sym_preproc_line] = STATE(2382),
    [sym_identifier] = ACTIONS(2411),
    [anon_sym_EQ] = ACTIONS(2413),
    [anon_sym_COLON] = ACTIONS(2411),
    [anon_sym_return] = ACTIONS(2411),
    [anon_sym_do] = ACTIONS(2411),
    [anon_sym_let] = ACTIONS(2411),
    [anon_sym_let_BANG] = ACTIONS(2413),
    [anon_sym_LPAREN] = ACTIONS(2411),
    [anon_sym_COMMA] = ACTIONS(2413),
    [anon_sym_null] = ACTIONS(2411),
    [anon_sym_QMARK] = ACTIONS(2411),
    [anon_sym_COLON_QMARK] = ACTIONS(2411),
    [anon_sym_COLON_COLON] = ACTIONS(2413),
    [anon_sym_AMP] = ACTIONS(2411),
    [anon_sym_LBRACK] = ACTIONS(2411),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2413),
    [anon_sym_LBRACE] = ACTIONS(2411),
    [anon_sym_LT_AT] = ACTIONS(2411),
    [anon_sym_LT_AT_AT] = ACTIONS(2411),
    [anon_sym_DOT] = ACTIONS(2411),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2413),
    [anon_sym_new] = ACTIONS(2411),
    [anon_sym_return_BANG] = ACTIONS(2413),
    [anon_sym_yield] = ACTIONS(2411),
    [anon_sym_yield_BANG] = ACTIONS(2413),
    [anon_sym_lazy] = ACTIONS(2411),
    [anon_sym_assert] = ACTIONS(2411),
    [anon_sym_upcast] = ACTIONS(2411),
    [anon_sym_downcast] = ACTIONS(2411),
    [anon_sym_COLON_GT] = ACTIONS(2413),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2413),
    [anon_sym_for] = ACTIONS(2411),
    [anon_sym_while] = ACTIONS(2411),
    [anon_sym_if] = ACTIONS(2411),
    [anon_sym_fun] = ACTIONS(2411),
    [anon_sym_try] = ACTIONS(2411),
    [anon_sym_match] = ACTIONS(2411),
    [anon_sym_match_BANG] = ACTIONS(2413),
    [anon_sym_function] = ACTIONS(2411),
    [anon_sym_LT_DASH] = ACTIONS(2411),
    [anon_sym_DOT_LBRACK] = ACTIONS(2413),
    [anon_sym_LT] = ACTIONS(2413),
    [anon_sym_GT] = ACTIONS(2411),
    [anon_sym_use] = ACTIONS(2411),
    [anon_sym_use_BANG] = ACTIONS(2413),
    [anon_sym_do_BANG] = ACTIONS(2413),
    [anon_sym_begin] = ACTIONS(2411),
    [anon_sym_LPAREN2] = ACTIONS(2411),
    [anon_sym_or] = ACTIONS(2411),
    [aux_sym_char_token1] = ACTIONS(2413),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2411),
    [anon_sym_DQUOTE] = ACTIONS(2411),
    [anon_sym_AT_DQUOTE] = ACTIONS(2413),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2413),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2413),
    [sym_bool] = ACTIONS(2411),
    [sym_unit] = ACTIONS(2413),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2411),
    [sym_op_identifier] = ACTIONS(2411),
    [anon_sym_PLUS] = ACTIONS(2411),
    [anon_sym_DASH] = ACTIONS(2411),
    [anon_sym_PLUS_DOT] = ACTIONS(2411),
    [anon_sym_DASH_DOT] = ACTIONS(2411),
    [anon_sym_PERCENT] = ACTIONS(2411),
    [anon_sym_AMP_AMP] = ACTIONS(2411),
    [anon_sym_TILDE] = ACTIONS(2413),
    [aux_sym_prefix_op_token1] = ACTIONS(2411),
    [aux_sym_infix_op_token1] = ACTIONS(2413),
    [aux_sym_infix_op_token2] = ACTIONS(2411),
    [anon_sym_PIPE_PIPE] = ACTIONS(2411),
    [anon_sym_BANG_EQ] = ACTIONS(2411),
    [anon_sym_COLON_EQ] = ACTIONS(2413),
    [anon_sym_DOLLAR] = ACTIONS(2411),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2411),
    [sym_int] = ACTIONS(2411),
    [sym_xint] = ACTIONS(2413),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2413),
    [sym__newline] = ACTIONS(2413),
  },
  [2383] = {
    [sym_block_comment] = STATE(2383),
    [sym_compiler_directive_decl] = STATE(2383),
    [sym_fsi_directive_decl] = STATE(2383),
    [sym_preproc_line] = STATE(2383),
    [sym_identifier] = ACTIONS(2839),
    [anon_sym_EQ] = ACTIONS(2841),
    [anon_sym_COLON] = ACTIONS(2839),
    [anon_sym_return] = ACTIONS(2839),
    [anon_sym_do] = ACTIONS(2839),
    [anon_sym_let] = ACTIONS(2839),
    [anon_sym_let_BANG] = ACTIONS(2841),
    [anon_sym_LPAREN] = ACTIONS(2839),
    [anon_sym_COMMA] = ACTIONS(2841),
    [anon_sym_null] = ACTIONS(2839),
    [anon_sym_QMARK] = ACTIONS(2839),
    [anon_sym_COLON_QMARK] = ACTIONS(2839),
    [anon_sym_COLON_COLON] = ACTIONS(2841),
    [anon_sym_AMP] = ACTIONS(2839),
    [anon_sym_LBRACK] = ACTIONS(2839),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2841),
    [anon_sym_LBRACE] = ACTIONS(2839),
    [anon_sym_LT_AT] = ACTIONS(2839),
    [anon_sym_LT_AT_AT] = ACTIONS(2839),
    [anon_sym_AT_AT_GT] = ACTIONS(2839),
    [anon_sym_DOT] = ACTIONS(2839),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2841),
    [anon_sym_new] = ACTIONS(2839),
    [anon_sym_return_BANG] = ACTIONS(2841),
    [anon_sym_yield] = ACTIONS(2839),
    [anon_sym_yield_BANG] = ACTIONS(2841),
    [anon_sym_lazy] = ACTIONS(2839),
    [anon_sym_assert] = ACTIONS(2839),
    [anon_sym_upcast] = ACTIONS(2839),
    [anon_sym_downcast] = ACTIONS(2839),
    [anon_sym_COLON_GT] = ACTIONS(2841),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2841),
    [anon_sym_for] = ACTIONS(2839),
    [anon_sym_while] = ACTIONS(2839),
    [anon_sym_if] = ACTIONS(2839),
    [anon_sym_fun] = ACTIONS(2839),
    [anon_sym_try] = ACTIONS(2839),
    [anon_sym_match] = ACTIONS(2839),
    [anon_sym_match_BANG] = ACTIONS(2841),
    [anon_sym_function] = ACTIONS(2839),
    [anon_sym_LT_DASH] = ACTIONS(2839),
    [anon_sym_DOT_LBRACK] = ACTIONS(2841),
    [anon_sym_LT] = ACTIONS(2841),
    [anon_sym_use] = ACTIONS(2839),
    [anon_sym_use_BANG] = ACTIONS(2841),
    [anon_sym_do_BANG] = ACTIONS(2841),
    [anon_sym_begin] = ACTIONS(2839),
    [anon_sym_LPAREN2] = ACTIONS(2839),
    [anon_sym_or] = ACTIONS(2839),
    [aux_sym_char_token1] = ACTIONS(2841),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2839),
    [anon_sym_DQUOTE] = ACTIONS(2839),
    [anon_sym_AT_DQUOTE] = ACTIONS(2841),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2841),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2841),
    [sym_bool] = ACTIONS(2839),
    [sym_unit] = ACTIONS(2841),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2839),
    [sym_op_identifier] = ACTIONS(2839),
    [anon_sym_PLUS] = ACTIONS(2839),
    [anon_sym_DASH] = ACTIONS(2839),
    [anon_sym_PLUS_DOT] = ACTIONS(2839),
    [anon_sym_DASH_DOT] = ACTIONS(2839),
    [anon_sym_PERCENT] = ACTIONS(2839),
    [anon_sym_AMP_AMP] = ACTIONS(2839),
    [anon_sym_TILDE] = ACTIONS(2841),
    [aux_sym_prefix_op_token1] = ACTIONS(2839),
    [aux_sym_infix_op_token1] = ACTIONS(2841),
    [aux_sym_infix_op_token2] = ACTIONS(2839),
    [anon_sym_PIPE_PIPE] = ACTIONS(2839),
    [anon_sym_BANG_EQ] = ACTIONS(2839),
    [anon_sym_COLON_EQ] = ACTIONS(2841),
    [anon_sym_DOLLAR] = ACTIONS(2839),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2839),
    [sym_int] = ACTIONS(2839),
    [sym_xint] = ACTIONS(2841),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2841),
    [sym__newline] = ACTIONS(2841),
  },
  [2384] = {
    [sym_block_comment] = STATE(2384),
    [sym_compiler_directive_decl] = STATE(2384),
    [sym_fsi_directive_decl] = STATE(2384),
    [sym_preproc_line] = STATE(2384),
    [sym_identifier] = ACTIONS(2851),
    [anon_sym_EQ] = ACTIONS(2853),
    [anon_sym_COLON] = ACTIONS(2851),
    [anon_sym_return] = ACTIONS(2851),
    [anon_sym_do] = ACTIONS(2851),
    [anon_sym_let] = ACTIONS(2851),
    [anon_sym_let_BANG] = ACTIONS(2853),
    [anon_sym_LPAREN] = ACTIONS(2851),
    [anon_sym_COMMA] = ACTIONS(2853),
    [anon_sym_null] = ACTIONS(2851),
    [anon_sym_QMARK] = ACTIONS(2851),
    [anon_sym_COLON_QMARK] = ACTIONS(2851),
    [anon_sym_COLON_COLON] = ACTIONS(2853),
    [anon_sym_AMP] = ACTIONS(2851),
    [anon_sym_LBRACK] = ACTIONS(2851),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2853),
    [anon_sym_LBRACE] = ACTIONS(2851),
    [anon_sym_LT_AT] = ACTIONS(2851),
    [anon_sym_LT_AT_AT] = ACTIONS(2851),
    [anon_sym_DOT] = ACTIONS(2851),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2853),
    [anon_sym_new] = ACTIONS(2851),
    [anon_sym_return_BANG] = ACTIONS(2853),
    [anon_sym_yield] = ACTIONS(2851),
    [anon_sym_yield_BANG] = ACTIONS(2853),
    [anon_sym_lazy] = ACTIONS(2851),
    [anon_sym_assert] = ACTIONS(2851),
    [anon_sym_upcast] = ACTIONS(2851),
    [anon_sym_downcast] = ACTIONS(2851),
    [anon_sym_COLON_GT] = ACTIONS(2853),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2853),
    [anon_sym_for] = ACTIONS(2851),
    [anon_sym_while] = ACTIONS(2851),
    [anon_sym_if] = ACTIONS(2851),
    [anon_sym_fun] = ACTIONS(2851),
    [anon_sym_try] = ACTIONS(2851),
    [anon_sym_match] = ACTIONS(2851),
    [anon_sym_match_BANG] = ACTIONS(2853),
    [anon_sym_function] = ACTIONS(2851),
    [anon_sym_LT_DASH] = ACTIONS(2851),
    [anon_sym_DOT_LBRACK] = ACTIONS(2853),
    [anon_sym_LT] = ACTIONS(2853),
    [anon_sym_GT] = ACTIONS(2851),
    [anon_sym_use] = ACTIONS(2851),
    [anon_sym_use_BANG] = ACTIONS(2853),
    [anon_sym_do_BANG] = ACTIONS(2853),
    [anon_sym_begin] = ACTIONS(2851),
    [anon_sym_LPAREN2] = ACTIONS(2851),
    [anon_sym_or] = ACTIONS(2851),
    [aux_sym_char_token1] = ACTIONS(2853),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2851),
    [anon_sym_DQUOTE] = ACTIONS(2851),
    [anon_sym_AT_DQUOTE] = ACTIONS(2853),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2853),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2853),
    [sym_bool] = ACTIONS(2851),
    [sym_unit] = ACTIONS(2853),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2851),
    [sym_op_identifier] = ACTIONS(2851),
    [anon_sym_PLUS] = ACTIONS(2851),
    [anon_sym_DASH] = ACTIONS(2851),
    [anon_sym_PLUS_DOT] = ACTIONS(2851),
    [anon_sym_DASH_DOT] = ACTIONS(2851),
    [anon_sym_PERCENT] = ACTIONS(2851),
    [anon_sym_AMP_AMP] = ACTIONS(2851),
    [anon_sym_TILDE] = ACTIONS(2853),
    [aux_sym_prefix_op_token1] = ACTIONS(2851),
    [aux_sym_infix_op_token1] = ACTIONS(2853),
    [aux_sym_infix_op_token2] = ACTIONS(2851),
    [anon_sym_PIPE_PIPE] = ACTIONS(2851),
    [anon_sym_BANG_EQ] = ACTIONS(2851),
    [anon_sym_COLON_EQ] = ACTIONS(2853),
    [anon_sym_DOLLAR] = ACTIONS(2851),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2851),
    [sym_int] = ACTIONS(2851),
    [sym_xint] = ACTIONS(2853),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2853),
    [sym__newline] = ACTIONS(2853),
  },
  [2385] = {
    [sym_block_comment] = STATE(2385),
    [sym_compiler_directive_decl] = STATE(2385),
    [sym_fsi_directive_decl] = STATE(2385),
    [sym_preproc_line] = STATE(2385),
    [sym_identifier] = ACTIONS(2974),
    [anon_sym_EQ] = ACTIONS(2976),
    [anon_sym_COLON] = ACTIONS(2974),
    [anon_sym_return] = ACTIONS(2974),
    [anon_sym_do] = ACTIONS(2974),
    [anon_sym_let] = ACTIONS(2974),
    [anon_sym_let_BANG] = ACTIONS(2976),
    [anon_sym_LPAREN] = ACTIONS(2974),
    [anon_sym_COMMA] = ACTIONS(2976),
    [anon_sym_null] = ACTIONS(2974),
    [anon_sym_QMARK] = ACTIONS(2974),
    [anon_sym_COLON_QMARK] = ACTIONS(2974),
    [anon_sym_COLON_COLON] = ACTIONS(2976),
    [anon_sym_AMP] = ACTIONS(2974),
    [anon_sym_LBRACK] = ACTIONS(2974),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2976),
    [anon_sym_LBRACE] = ACTIONS(2974),
    [anon_sym_LT_AT] = ACTIONS(2974),
    [anon_sym_LT_AT_AT] = ACTIONS(2974),
    [anon_sym_DOT] = ACTIONS(2974),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2976),
    [anon_sym_new] = ACTIONS(2974),
    [anon_sym_return_BANG] = ACTIONS(2976),
    [anon_sym_yield] = ACTIONS(2974),
    [anon_sym_yield_BANG] = ACTIONS(2976),
    [anon_sym_lazy] = ACTIONS(2974),
    [anon_sym_assert] = ACTIONS(2974),
    [anon_sym_upcast] = ACTIONS(2974),
    [anon_sym_downcast] = ACTIONS(2974),
    [anon_sym_COLON_GT] = ACTIONS(2976),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2976),
    [anon_sym_for] = ACTIONS(2974),
    [anon_sym_while] = ACTIONS(2974),
    [anon_sym_if] = ACTIONS(2974),
    [anon_sym_fun] = ACTIONS(2974),
    [anon_sym_try] = ACTIONS(2974),
    [anon_sym_match] = ACTIONS(2974),
    [anon_sym_match_BANG] = ACTIONS(2976),
    [anon_sym_function] = ACTIONS(2974),
    [anon_sym_LT_DASH] = ACTIONS(2974),
    [anon_sym_DOT_LBRACK] = ACTIONS(2976),
    [anon_sym_LT] = ACTIONS(2976),
    [anon_sym_use] = ACTIONS(2974),
    [anon_sym_use_BANG] = ACTIONS(2976),
    [anon_sym_do_BANG] = ACTIONS(2976),
    [anon_sym_begin] = ACTIONS(2974),
    [anon_sym_LPAREN2] = ACTIONS(2974),
    [anon_sym_or] = ACTIONS(2974),
    [aux_sym_char_token1] = ACTIONS(2976),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2974),
    [anon_sym_DQUOTE] = ACTIONS(2974),
    [anon_sym_AT_DQUOTE] = ACTIONS(2976),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2976),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2976),
    [sym_bool] = ACTIONS(2974),
    [sym_unit] = ACTIONS(2976),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2974),
    [sym_op_identifier] = ACTIONS(2974),
    [anon_sym_PLUS] = ACTIONS(2974),
    [anon_sym_DASH] = ACTIONS(2974),
    [anon_sym_PLUS_DOT] = ACTIONS(2974),
    [anon_sym_DASH_DOT] = ACTIONS(2974),
    [anon_sym_PERCENT] = ACTIONS(2974),
    [anon_sym_AMP_AMP] = ACTIONS(2974),
    [anon_sym_TILDE] = ACTIONS(2976),
    [aux_sym_prefix_op_token1] = ACTIONS(2974),
    [aux_sym_infix_op_token1] = ACTIONS(2976),
    [aux_sym_infix_op_token2] = ACTIONS(2974),
    [anon_sym_PIPE_PIPE] = ACTIONS(2974),
    [anon_sym_BANG_EQ] = ACTIONS(2974),
    [anon_sym_COLON_EQ] = ACTIONS(2976),
    [anon_sym_DOLLAR] = ACTIONS(2974),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2974),
    [sym_int] = ACTIONS(2974),
    [sym_xint] = ACTIONS(2976),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2976),
    [anon_sym_POUNDendif] = ACTIONS(2976),
    [sym__newline] = ACTIONS(2976),
  },
  [2386] = {
    [sym_block_comment] = STATE(2386),
    [sym_compiler_directive_decl] = STATE(2386),
    [sym_fsi_directive_decl] = STATE(2386),
    [sym_preproc_line] = STATE(2386),
    [sym_identifier] = ACTIONS(2966),
    [anon_sym_EQ] = ACTIONS(2968),
    [anon_sym_COLON] = ACTIONS(2966),
    [anon_sym_return] = ACTIONS(2966),
    [anon_sym_do] = ACTIONS(2966),
    [anon_sym_let] = ACTIONS(2966),
    [anon_sym_let_BANG] = ACTIONS(2968),
    [anon_sym_LPAREN] = ACTIONS(2966),
    [anon_sym_COMMA] = ACTIONS(2968),
    [anon_sym_null] = ACTIONS(2966),
    [anon_sym_QMARK] = ACTIONS(2966),
    [anon_sym_COLON_QMARK] = ACTIONS(2966),
    [anon_sym_COLON_COLON] = ACTIONS(2968),
    [anon_sym_AMP] = ACTIONS(2966),
    [anon_sym_LBRACK] = ACTIONS(2966),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2968),
    [anon_sym_LBRACE] = ACTIONS(2966),
    [anon_sym_LT_AT] = ACTIONS(2966),
    [anon_sym_LT_AT_AT] = ACTIONS(2966),
    [anon_sym_DOT] = ACTIONS(2966),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2968),
    [anon_sym_new] = ACTIONS(2966),
    [anon_sym_return_BANG] = ACTIONS(2968),
    [anon_sym_yield] = ACTIONS(2966),
    [anon_sym_yield_BANG] = ACTIONS(2968),
    [anon_sym_lazy] = ACTIONS(2966),
    [anon_sym_assert] = ACTIONS(2966),
    [anon_sym_upcast] = ACTIONS(2966),
    [anon_sym_downcast] = ACTIONS(2966),
    [anon_sym_COLON_GT] = ACTIONS(2968),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2968),
    [anon_sym_for] = ACTIONS(2966),
    [anon_sym_while] = ACTIONS(2966),
    [anon_sym_if] = ACTIONS(2966),
    [anon_sym_fun] = ACTIONS(2966),
    [anon_sym_try] = ACTIONS(2966),
    [anon_sym_match] = ACTIONS(2966),
    [anon_sym_match_BANG] = ACTIONS(2968),
    [anon_sym_function] = ACTIONS(2966),
    [anon_sym_LT_DASH] = ACTIONS(2966),
    [anon_sym_DOT_LBRACK] = ACTIONS(2968),
    [anon_sym_LT] = ACTIONS(2968),
    [anon_sym_use] = ACTIONS(2966),
    [anon_sym_use_BANG] = ACTIONS(2968),
    [anon_sym_do_BANG] = ACTIONS(2968),
    [anon_sym_begin] = ACTIONS(2966),
    [anon_sym_LPAREN2] = ACTIONS(2966),
    [anon_sym_or] = ACTIONS(2966),
    [aux_sym_char_token1] = ACTIONS(2968),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2966),
    [anon_sym_DQUOTE] = ACTIONS(2966),
    [anon_sym_AT_DQUOTE] = ACTIONS(2968),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2968),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2968),
    [sym_bool] = ACTIONS(2966),
    [sym_unit] = ACTIONS(2968),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2966),
    [sym_op_identifier] = ACTIONS(2966),
    [anon_sym_PLUS] = ACTIONS(2966),
    [anon_sym_DASH] = ACTIONS(2966),
    [anon_sym_PLUS_DOT] = ACTIONS(2966),
    [anon_sym_DASH_DOT] = ACTIONS(2966),
    [anon_sym_PERCENT] = ACTIONS(2966),
    [anon_sym_AMP_AMP] = ACTIONS(2966),
    [anon_sym_TILDE] = ACTIONS(2968),
    [aux_sym_prefix_op_token1] = ACTIONS(2966),
    [aux_sym_infix_op_token1] = ACTIONS(2968),
    [aux_sym_infix_op_token2] = ACTIONS(2966),
    [anon_sym_PIPE_PIPE] = ACTIONS(2966),
    [anon_sym_BANG_EQ] = ACTIONS(2966),
    [anon_sym_COLON_EQ] = ACTIONS(2968),
    [anon_sym_DOLLAR] = ACTIONS(2966),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2966),
    [sym_int] = ACTIONS(2966),
    [sym_xint] = ACTIONS(2968),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2968),
    [anon_sym_POUNDendif] = ACTIONS(2968),
    [sym__newline] = ACTIONS(2968),
  },
  [2387] = {
    [sym_block_comment] = STATE(2387),
    [sym_compiler_directive_decl] = STATE(2387),
    [sym_fsi_directive_decl] = STATE(2387),
    [sym_preproc_line] = STATE(2387),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_EQ] = ACTIONS(3017),
    [anon_sym_COLON] = ACTIONS(3015),
    [anon_sym_return] = ACTIONS(3015),
    [anon_sym_do] = ACTIONS(3015),
    [anon_sym_let] = ACTIONS(3015),
    [anon_sym_let_BANG] = ACTIONS(3017),
    [anon_sym_LPAREN] = ACTIONS(3015),
    [anon_sym_COMMA] = ACTIONS(3017),
    [anon_sym_null] = ACTIONS(3015),
    [anon_sym_QMARK] = ACTIONS(3015),
    [anon_sym_COLON_QMARK] = ACTIONS(3015),
    [anon_sym_COLON_COLON] = ACTIONS(3017),
    [anon_sym_AMP] = ACTIONS(3015),
    [anon_sym_LBRACK] = ACTIONS(3015),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3017),
    [anon_sym_LBRACE] = ACTIONS(3015),
    [anon_sym_LT_AT] = ACTIONS(3015),
    [anon_sym_LT_AT_AT] = ACTIONS(3015),
    [anon_sym_AT_AT_GT] = ACTIONS(3015),
    [anon_sym_DOT] = ACTIONS(3015),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3017),
    [anon_sym_new] = ACTIONS(3015),
    [anon_sym_return_BANG] = ACTIONS(3017),
    [anon_sym_yield] = ACTIONS(3015),
    [anon_sym_yield_BANG] = ACTIONS(3017),
    [anon_sym_lazy] = ACTIONS(3015),
    [anon_sym_assert] = ACTIONS(3015),
    [anon_sym_upcast] = ACTIONS(3015),
    [anon_sym_downcast] = ACTIONS(3015),
    [anon_sym_COLON_GT] = ACTIONS(3017),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3017),
    [anon_sym_for] = ACTIONS(3015),
    [anon_sym_while] = ACTIONS(3015),
    [anon_sym_if] = ACTIONS(3015),
    [anon_sym_fun] = ACTIONS(3015),
    [anon_sym_try] = ACTIONS(3015),
    [anon_sym_match] = ACTIONS(3015),
    [anon_sym_match_BANG] = ACTIONS(3017),
    [anon_sym_function] = ACTIONS(3015),
    [anon_sym_LT_DASH] = ACTIONS(3015),
    [anon_sym_DOT_LBRACK] = ACTIONS(3017),
    [anon_sym_LT] = ACTIONS(3017),
    [anon_sym_use] = ACTIONS(3015),
    [anon_sym_use_BANG] = ACTIONS(3017),
    [anon_sym_do_BANG] = ACTIONS(3017),
    [anon_sym_begin] = ACTIONS(3015),
    [anon_sym_LPAREN2] = ACTIONS(3015),
    [anon_sym_or] = ACTIONS(3015),
    [aux_sym_char_token1] = ACTIONS(3017),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3015),
    [anon_sym_DQUOTE] = ACTIONS(3015),
    [anon_sym_AT_DQUOTE] = ACTIONS(3017),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3017),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3017),
    [sym_bool] = ACTIONS(3015),
    [sym_unit] = ACTIONS(3017),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3015),
    [sym_op_identifier] = ACTIONS(3015),
    [anon_sym_PLUS] = ACTIONS(3015),
    [anon_sym_DASH] = ACTIONS(3015),
    [anon_sym_PLUS_DOT] = ACTIONS(3015),
    [anon_sym_DASH_DOT] = ACTIONS(3015),
    [anon_sym_PERCENT] = ACTIONS(3015),
    [anon_sym_AMP_AMP] = ACTIONS(3015),
    [anon_sym_TILDE] = ACTIONS(3017),
    [aux_sym_prefix_op_token1] = ACTIONS(3015),
    [aux_sym_infix_op_token1] = ACTIONS(3017),
    [aux_sym_infix_op_token2] = ACTIONS(3015),
    [anon_sym_PIPE_PIPE] = ACTIONS(3015),
    [anon_sym_BANG_EQ] = ACTIONS(3015),
    [anon_sym_COLON_EQ] = ACTIONS(3017),
    [anon_sym_DOLLAR] = ACTIONS(3015),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3015),
    [sym_int] = ACTIONS(3015),
    [sym_xint] = ACTIONS(3017),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3017),
    [sym__newline] = ACTIONS(3017),
  },
  [2388] = {
    [sym_block_comment] = STATE(2388),
    [sym_compiler_directive_decl] = STATE(2388),
    [sym_fsi_directive_decl] = STATE(2388),
    [sym_preproc_line] = STATE(2388),
    [sym_identifier] = ACTIONS(2962),
    [anon_sym_EQ] = ACTIONS(2964),
    [anon_sym_COLON] = ACTIONS(2962),
    [anon_sym_return] = ACTIONS(2962),
    [anon_sym_do] = ACTIONS(2962),
    [anon_sym_let] = ACTIONS(2962),
    [anon_sym_let_BANG] = ACTIONS(2964),
    [anon_sym_LPAREN] = ACTIONS(2962),
    [anon_sym_COMMA] = ACTIONS(2964),
    [anon_sym_null] = ACTIONS(2962),
    [anon_sym_QMARK] = ACTIONS(2962),
    [anon_sym_COLON_QMARK] = ACTIONS(2962),
    [anon_sym_COLON_COLON] = ACTIONS(2964),
    [anon_sym_AMP] = ACTIONS(2962),
    [anon_sym_LBRACK] = ACTIONS(2962),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2964),
    [anon_sym_LBRACE] = ACTIONS(2962),
    [anon_sym_LT_AT] = ACTIONS(2962),
    [anon_sym_LT_AT_AT] = ACTIONS(2962),
    [anon_sym_DOT] = ACTIONS(2962),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2964),
    [anon_sym_new] = ACTIONS(2962),
    [anon_sym_return_BANG] = ACTIONS(2964),
    [anon_sym_yield] = ACTIONS(2962),
    [anon_sym_yield_BANG] = ACTIONS(2964),
    [anon_sym_lazy] = ACTIONS(2962),
    [anon_sym_assert] = ACTIONS(2962),
    [anon_sym_upcast] = ACTIONS(2962),
    [anon_sym_downcast] = ACTIONS(2962),
    [anon_sym_COLON_GT] = ACTIONS(2964),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2964),
    [anon_sym_for] = ACTIONS(2962),
    [anon_sym_while] = ACTIONS(2962),
    [anon_sym_if] = ACTIONS(2962),
    [anon_sym_fun] = ACTIONS(2962),
    [anon_sym_try] = ACTIONS(2962),
    [anon_sym_match] = ACTIONS(2962),
    [anon_sym_match_BANG] = ACTIONS(2964),
    [anon_sym_function] = ACTIONS(2962),
    [anon_sym_LT_DASH] = ACTIONS(2962),
    [anon_sym_DOT_LBRACK] = ACTIONS(2964),
    [anon_sym_LT] = ACTIONS(2964),
    [anon_sym_use] = ACTIONS(2962),
    [anon_sym_use_BANG] = ACTIONS(2964),
    [anon_sym_do_BANG] = ACTIONS(2964),
    [anon_sym_begin] = ACTIONS(2962),
    [anon_sym_LPAREN2] = ACTIONS(2962),
    [anon_sym_or] = ACTIONS(2962),
    [aux_sym_char_token1] = ACTIONS(2964),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2962),
    [anon_sym_DQUOTE] = ACTIONS(2962),
    [anon_sym_AT_DQUOTE] = ACTIONS(2964),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2964),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2964),
    [sym_bool] = ACTIONS(2962),
    [sym_unit] = ACTIONS(2964),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2962),
    [sym_op_identifier] = ACTIONS(2962),
    [anon_sym_PLUS] = ACTIONS(2962),
    [anon_sym_DASH] = ACTIONS(2962),
    [anon_sym_PLUS_DOT] = ACTIONS(2962),
    [anon_sym_DASH_DOT] = ACTIONS(2962),
    [anon_sym_PERCENT] = ACTIONS(2962),
    [anon_sym_AMP_AMP] = ACTIONS(2962),
    [anon_sym_TILDE] = ACTIONS(2964),
    [aux_sym_prefix_op_token1] = ACTIONS(2962),
    [aux_sym_infix_op_token1] = ACTIONS(2964),
    [aux_sym_infix_op_token2] = ACTIONS(2962),
    [anon_sym_PIPE_PIPE] = ACTIONS(2962),
    [anon_sym_BANG_EQ] = ACTIONS(2962),
    [anon_sym_COLON_EQ] = ACTIONS(2964),
    [anon_sym_DOLLAR] = ACTIONS(2962),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2962),
    [sym_int] = ACTIONS(2962),
    [sym_xint] = ACTIONS(2964),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2964),
    [anon_sym_POUNDendif] = ACTIONS(2964),
    [sym__newline] = ACTIONS(2964),
  },
  [2389] = {
    [sym_block_comment] = STATE(2389),
    [sym_compiler_directive_decl] = STATE(2389),
    [sym_fsi_directive_decl] = STATE(2389),
    [sym_preproc_line] = STATE(2389),
    [sym_identifier] = ACTIONS(2954),
    [anon_sym_EQ] = ACTIONS(2956),
    [anon_sym_COLON] = ACTIONS(2954),
    [anon_sym_return] = ACTIONS(2954),
    [anon_sym_do] = ACTIONS(2954),
    [anon_sym_let] = ACTIONS(2954),
    [anon_sym_let_BANG] = ACTIONS(2956),
    [anon_sym_LPAREN] = ACTIONS(2954),
    [anon_sym_COMMA] = ACTIONS(2956),
    [anon_sym_null] = ACTIONS(2954),
    [anon_sym_QMARK] = ACTIONS(2954),
    [anon_sym_COLON_QMARK] = ACTIONS(2954),
    [anon_sym_COLON_COLON] = ACTIONS(2956),
    [anon_sym_AMP] = ACTIONS(2954),
    [anon_sym_LBRACK] = ACTIONS(2954),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2956),
    [anon_sym_LBRACE] = ACTIONS(2954),
    [anon_sym_LT_AT] = ACTIONS(2954),
    [anon_sym_LT_AT_AT] = ACTIONS(2954),
    [anon_sym_DOT] = ACTIONS(2954),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2956),
    [anon_sym_new] = ACTIONS(2954),
    [anon_sym_return_BANG] = ACTIONS(2956),
    [anon_sym_yield] = ACTIONS(2954),
    [anon_sym_yield_BANG] = ACTIONS(2956),
    [anon_sym_lazy] = ACTIONS(2954),
    [anon_sym_assert] = ACTIONS(2954),
    [anon_sym_upcast] = ACTIONS(2954),
    [anon_sym_downcast] = ACTIONS(2954),
    [anon_sym_COLON_GT] = ACTIONS(2956),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2956),
    [anon_sym_for] = ACTIONS(2954),
    [anon_sym_while] = ACTIONS(2954),
    [anon_sym_if] = ACTIONS(2954),
    [anon_sym_fun] = ACTIONS(2954),
    [anon_sym_try] = ACTIONS(2954),
    [anon_sym_match] = ACTIONS(2954),
    [anon_sym_match_BANG] = ACTIONS(2956),
    [anon_sym_function] = ACTIONS(2954),
    [anon_sym_LT_DASH] = ACTIONS(2954),
    [anon_sym_DOT_LBRACK] = ACTIONS(2956),
    [anon_sym_LT] = ACTIONS(2956),
    [anon_sym_use] = ACTIONS(2954),
    [anon_sym_use_BANG] = ACTIONS(2956),
    [anon_sym_do_BANG] = ACTIONS(2956),
    [anon_sym_DOT_DOT] = ACTIONS(2956),
    [anon_sym_begin] = ACTIONS(2954),
    [anon_sym_LPAREN2] = ACTIONS(2954),
    [anon_sym_or] = ACTIONS(2954),
    [aux_sym_char_token1] = ACTIONS(2956),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2954),
    [anon_sym_DQUOTE] = ACTIONS(2954),
    [anon_sym_AT_DQUOTE] = ACTIONS(2956),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2956),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2956),
    [sym_bool] = ACTIONS(2954),
    [sym_unit] = ACTIONS(2956),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2954),
    [sym_op_identifier] = ACTIONS(2954),
    [anon_sym_PLUS] = ACTIONS(2954),
    [anon_sym_DASH] = ACTIONS(2954),
    [anon_sym_PLUS_DOT] = ACTIONS(2954),
    [anon_sym_DASH_DOT] = ACTIONS(2954),
    [anon_sym_PERCENT] = ACTIONS(2954),
    [anon_sym_AMP_AMP] = ACTIONS(2954),
    [anon_sym_TILDE] = ACTIONS(2956),
    [aux_sym_prefix_op_token1] = ACTIONS(2954),
    [aux_sym_infix_op_token1] = ACTIONS(2956),
    [aux_sym_infix_op_token2] = ACTIONS(2954),
    [anon_sym_PIPE_PIPE] = ACTIONS(2954),
    [anon_sym_BANG_EQ] = ACTIONS(2954),
    [anon_sym_COLON_EQ] = ACTIONS(2956),
    [anon_sym_DOLLAR] = ACTIONS(2954),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2954),
    [sym_int] = ACTIONS(2954),
    [sym_xint] = ACTIONS(2956),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2956),
    [sym__newline] = ACTIONS(2956),
  },
  [2390] = {
    [sym_block_comment] = STATE(2390),
    [sym_compiler_directive_decl] = STATE(2390),
    [sym_fsi_directive_decl] = STATE(2390),
    [sym_preproc_line] = STATE(2390),
    [sym_identifier] = ACTIONS(2867),
    [anon_sym_EQ] = ACTIONS(2869),
    [anon_sym_COLON] = ACTIONS(2867),
    [anon_sym_return] = ACTIONS(2867),
    [anon_sym_do] = ACTIONS(2867),
    [anon_sym_let] = ACTIONS(2867),
    [anon_sym_let_BANG] = ACTIONS(2869),
    [anon_sym_LPAREN] = ACTIONS(2867),
    [anon_sym_COMMA] = ACTIONS(2869),
    [anon_sym_null] = ACTIONS(2867),
    [anon_sym_QMARK] = ACTIONS(2867),
    [anon_sym_COLON_QMARK] = ACTIONS(2867),
    [anon_sym_COLON_COLON] = ACTIONS(2869),
    [anon_sym_AMP] = ACTIONS(2867),
    [anon_sym_LBRACK] = ACTIONS(2867),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2869),
    [anon_sym_LBRACE] = ACTIONS(2867),
    [anon_sym_LT_AT] = ACTIONS(2867),
    [anon_sym_LT_AT_AT] = ACTIONS(2867),
    [anon_sym_AT_AT_GT] = ACTIONS(2867),
    [anon_sym_DOT] = ACTIONS(2867),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2869),
    [anon_sym_new] = ACTIONS(2867),
    [anon_sym_return_BANG] = ACTIONS(2869),
    [anon_sym_yield] = ACTIONS(2867),
    [anon_sym_yield_BANG] = ACTIONS(2869),
    [anon_sym_lazy] = ACTIONS(2867),
    [anon_sym_assert] = ACTIONS(2867),
    [anon_sym_upcast] = ACTIONS(2867),
    [anon_sym_downcast] = ACTIONS(2867),
    [anon_sym_COLON_GT] = ACTIONS(2869),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2869),
    [anon_sym_for] = ACTIONS(2867),
    [anon_sym_while] = ACTIONS(2867),
    [anon_sym_if] = ACTIONS(2867),
    [anon_sym_fun] = ACTIONS(2867),
    [anon_sym_try] = ACTIONS(2867),
    [anon_sym_match] = ACTIONS(2867),
    [anon_sym_match_BANG] = ACTIONS(2869),
    [anon_sym_function] = ACTIONS(2867),
    [anon_sym_LT_DASH] = ACTIONS(2867),
    [anon_sym_DOT_LBRACK] = ACTIONS(2869),
    [anon_sym_LT] = ACTIONS(2869),
    [anon_sym_use] = ACTIONS(2867),
    [anon_sym_use_BANG] = ACTIONS(2869),
    [anon_sym_do_BANG] = ACTIONS(2869),
    [anon_sym_begin] = ACTIONS(2867),
    [anon_sym_LPAREN2] = ACTIONS(2867),
    [anon_sym_or] = ACTIONS(2867),
    [aux_sym_char_token1] = ACTIONS(2869),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2867),
    [anon_sym_DQUOTE] = ACTIONS(2867),
    [anon_sym_AT_DQUOTE] = ACTIONS(2869),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2869),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2869),
    [sym_bool] = ACTIONS(2867),
    [sym_unit] = ACTIONS(2869),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2867),
    [sym_op_identifier] = ACTIONS(2867),
    [anon_sym_PLUS] = ACTIONS(2867),
    [anon_sym_DASH] = ACTIONS(2867),
    [anon_sym_PLUS_DOT] = ACTIONS(2867),
    [anon_sym_DASH_DOT] = ACTIONS(2867),
    [anon_sym_PERCENT] = ACTIONS(2867),
    [anon_sym_AMP_AMP] = ACTIONS(2867),
    [anon_sym_TILDE] = ACTIONS(2869),
    [aux_sym_prefix_op_token1] = ACTIONS(2867),
    [aux_sym_infix_op_token1] = ACTIONS(2869),
    [aux_sym_infix_op_token2] = ACTIONS(2867),
    [anon_sym_PIPE_PIPE] = ACTIONS(2867),
    [anon_sym_BANG_EQ] = ACTIONS(2867),
    [anon_sym_COLON_EQ] = ACTIONS(2869),
    [anon_sym_DOLLAR] = ACTIONS(2867),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2867),
    [sym_int] = ACTIONS(2867),
    [sym_xint] = ACTIONS(2869),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2869),
    [sym__newline] = ACTIONS(2869),
  },
  [2391] = {
    [sym_block_comment] = STATE(2391),
    [sym_compiler_directive_decl] = STATE(2391),
    [sym_fsi_directive_decl] = STATE(2391),
    [sym_preproc_line] = STATE(2391),
    [sym_identifier] = ACTIONS(2867),
    [anon_sym_EQ] = ACTIONS(2869),
    [anon_sym_COLON] = ACTIONS(2867),
    [anon_sym_return] = ACTIONS(2867),
    [anon_sym_do] = ACTIONS(2867),
    [anon_sym_let] = ACTIONS(2867),
    [anon_sym_let_BANG] = ACTIONS(2869),
    [anon_sym_LPAREN] = ACTIONS(2867),
    [anon_sym_COMMA] = ACTIONS(2869),
    [anon_sym_null] = ACTIONS(2867),
    [anon_sym_QMARK] = ACTIONS(2867),
    [anon_sym_COLON_QMARK] = ACTIONS(2867),
    [anon_sym_COLON_COLON] = ACTIONS(2869),
    [anon_sym_AMP] = ACTIONS(2867),
    [anon_sym_LBRACK] = ACTIONS(2867),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2869),
    [anon_sym_LBRACE] = ACTIONS(2867),
    [anon_sym_LT_AT] = ACTIONS(2867),
    [anon_sym_LT_AT_AT] = ACTIONS(2867),
    [anon_sym_AT_AT_GT] = ACTIONS(2867),
    [anon_sym_DOT] = ACTIONS(4304),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2869),
    [anon_sym_new] = ACTIONS(2867),
    [anon_sym_return_BANG] = ACTIONS(2869),
    [anon_sym_yield] = ACTIONS(2867),
    [anon_sym_yield_BANG] = ACTIONS(2869),
    [anon_sym_lazy] = ACTIONS(2867),
    [anon_sym_assert] = ACTIONS(2867),
    [anon_sym_upcast] = ACTIONS(2867),
    [anon_sym_downcast] = ACTIONS(2867),
    [anon_sym_COLON_GT] = ACTIONS(2869),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2869),
    [anon_sym_for] = ACTIONS(2867),
    [anon_sym_while] = ACTIONS(2867),
    [anon_sym_if] = ACTIONS(2867),
    [anon_sym_fun] = ACTIONS(2867),
    [anon_sym_try] = ACTIONS(2867),
    [anon_sym_match] = ACTIONS(2867),
    [anon_sym_match_BANG] = ACTIONS(2869),
    [anon_sym_function] = ACTIONS(2867),
    [anon_sym_LT_DASH] = ACTIONS(2867),
    [anon_sym_DOT_LBRACK] = ACTIONS(2869),
    [anon_sym_LT] = ACTIONS(2869),
    [anon_sym_use] = ACTIONS(2867),
    [anon_sym_use_BANG] = ACTIONS(2869),
    [anon_sym_do_BANG] = ACTIONS(2869),
    [anon_sym_begin] = ACTIONS(2867),
    [anon_sym_LPAREN2] = ACTIONS(2867),
    [anon_sym_or] = ACTIONS(2867),
    [aux_sym_char_token1] = ACTIONS(2869),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2867),
    [anon_sym_DQUOTE] = ACTIONS(2867),
    [anon_sym_AT_DQUOTE] = ACTIONS(2869),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2869),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2869),
    [sym_bool] = ACTIONS(2867),
    [sym_unit] = ACTIONS(2869),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2867),
    [sym_op_identifier] = ACTIONS(2867),
    [anon_sym_PLUS] = ACTIONS(2867),
    [anon_sym_DASH] = ACTIONS(2867),
    [anon_sym_PLUS_DOT] = ACTIONS(2867),
    [anon_sym_DASH_DOT] = ACTIONS(2867),
    [anon_sym_PERCENT] = ACTIONS(2867),
    [anon_sym_AMP_AMP] = ACTIONS(2867),
    [anon_sym_TILDE] = ACTIONS(2869),
    [aux_sym_prefix_op_token1] = ACTIONS(2867),
    [aux_sym_infix_op_token1] = ACTIONS(2869),
    [aux_sym_infix_op_token2] = ACTIONS(2867),
    [anon_sym_PIPE_PIPE] = ACTIONS(2867),
    [anon_sym_BANG_EQ] = ACTIONS(2867),
    [anon_sym_COLON_EQ] = ACTIONS(2869),
    [anon_sym_DOLLAR] = ACTIONS(2867),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2867),
    [sym_int] = ACTIONS(2867),
    [sym_xint] = ACTIONS(2869),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2869),
    [sym__newline] = ACTIONS(2869),
  },
  [2392] = {
    [sym_block_comment] = STATE(2392),
    [sym_compiler_directive_decl] = STATE(2392),
    [sym_fsi_directive_decl] = STATE(2392),
    [sym_preproc_line] = STATE(2392),
    [sym_identifier] = ACTIONS(2867),
    [anon_sym_EQ] = ACTIONS(2869),
    [anon_sym_COLON] = ACTIONS(2867),
    [anon_sym_return] = ACTIONS(2867),
    [anon_sym_do] = ACTIONS(2867),
    [anon_sym_let] = ACTIONS(2867),
    [anon_sym_let_BANG] = ACTIONS(2869),
    [anon_sym_LPAREN] = ACTIONS(2867),
    [anon_sym_COMMA] = ACTIONS(2869),
    [anon_sym_null] = ACTIONS(2867),
    [anon_sym_QMARK] = ACTIONS(2867),
    [anon_sym_COLON_QMARK] = ACTIONS(2867),
    [anon_sym_COLON_COLON] = ACTIONS(2869),
    [anon_sym_AMP] = ACTIONS(2867),
    [anon_sym_LBRACK] = ACTIONS(2867),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2869),
    [anon_sym_LBRACE] = ACTIONS(2867),
    [anon_sym_LT_AT] = ACTIONS(2867),
    [anon_sym_LT_AT_AT] = ACTIONS(2867),
    [anon_sym_DOT] = ACTIONS(2867),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2869),
    [anon_sym_new] = ACTIONS(2867),
    [anon_sym_return_BANG] = ACTIONS(2869),
    [anon_sym_yield] = ACTIONS(2867),
    [anon_sym_yield_BANG] = ACTIONS(2869),
    [anon_sym_lazy] = ACTIONS(2867),
    [anon_sym_assert] = ACTIONS(2867),
    [anon_sym_upcast] = ACTIONS(2867),
    [anon_sym_downcast] = ACTIONS(2867),
    [anon_sym_COLON_GT] = ACTIONS(2869),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2869),
    [anon_sym_for] = ACTIONS(2867),
    [anon_sym_while] = ACTIONS(2867),
    [anon_sym_if] = ACTIONS(2867),
    [anon_sym_fun] = ACTIONS(2867),
    [anon_sym_try] = ACTIONS(2867),
    [anon_sym_match] = ACTIONS(2867),
    [anon_sym_match_BANG] = ACTIONS(2869),
    [anon_sym_function] = ACTIONS(2867),
    [anon_sym_LT_DASH] = ACTIONS(2867),
    [anon_sym_DOT_LBRACK] = ACTIONS(2869),
    [anon_sym_LT] = ACTIONS(2869),
    [anon_sym_GT] = ACTIONS(2867),
    [anon_sym_use] = ACTIONS(2867),
    [anon_sym_use_BANG] = ACTIONS(2869),
    [anon_sym_do_BANG] = ACTIONS(2869),
    [anon_sym_begin] = ACTIONS(2867),
    [anon_sym_LPAREN2] = ACTIONS(2867),
    [anon_sym_or] = ACTIONS(2867),
    [aux_sym_char_token1] = ACTIONS(2869),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2867),
    [anon_sym_DQUOTE] = ACTIONS(2867),
    [anon_sym_AT_DQUOTE] = ACTIONS(2869),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2869),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2869),
    [sym_bool] = ACTIONS(2867),
    [sym_unit] = ACTIONS(2869),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2867),
    [sym_op_identifier] = ACTIONS(2867),
    [anon_sym_PLUS] = ACTIONS(2867),
    [anon_sym_DASH] = ACTIONS(2867),
    [anon_sym_PLUS_DOT] = ACTIONS(2867),
    [anon_sym_DASH_DOT] = ACTIONS(2867),
    [anon_sym_PERCENT] = ACTIONS(2867),
    [anon_sym_AMP_AMP] = ACTIONS(2867),
    [anon_sym_TILDE] = ACTIONS(2869),
    [aux_sym_prefix_op_token1] = ACTIONS(2867),
    [aux_sym_infix_op_token1] = ACTIONS(2869),
    [aux_sym_infix_op_token2] = ACTIONS(2867),
    [anon_sym_PIPE_PIPE] = ACTIONS(2867),
    [anon_sym_BANG_EQ] = ACTIONS(2867),
    [anon_sym_COLON_EQ] = ACTIONS(2869),
    [anon_sym_DOLLAR] = ACTIONS(2867),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2867),
    [sym_int] = ACTIONS(2867),
    [sym_xint] = ACTIONS(2869),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2869),
    [sym__newline] = ACTIONS(2869),
  },
  [2393] = {
    [sym_attributes] = STATE(2630),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(3640),
    [sym__pattern] = STATE(1905),
    [sym_optional_pattern] = STATE(3640),
    [sym_type_check_pattern] = STATE(3640),
    [sym_attribute_pattern] = STATE(3640),
    [sym_paren_pattern] = STATE(3640),
    [sym_as_pattern] = STATE(3640),
    [sym_cons_pattern] = STATE(3640),
    [sym_disjunct_pattern] = STATE(3640),
    [sym_conjunct_pattern] = STATE(3640),
    [sym_typed_pattern] = STATE(3640),
    [sym_list_pattern] = STATE(3640),
    [sym_array_pattern] = STATE(3640),
    [sym_record_pattern] = STATE(3640),
    [sym_named_field_pattern] = STATE(3640),
    [sym_identifier_pattern] = STATE(3640),
    [sym_long_identifier_or_op] = STATE(2393),
    [sym_char] = STATE(3606),
    [sym_format_string] = STATE(3688),
    [sym__string_literal] = STATE(3688),
    [sym_string] = STATE(3606),
    [sym_verbatim_string] = STATE(3606),
    [sym_bytearray] = STATE(3606),
    [sym_verbatim_bytearray] = STATE(3606),
    [sym_format_triple_quoted_string] = STATE(3686),
    [sym_triple_quoted_string] = STATE(3606),
    [sym_const] = STATE(3640),
    [sym_long_identifier] = STATE(3437),
    [sym_active_pattern] = STATE(3653),
    [sym__identifier_or_op] = STATE(3660),
    [sym_sbyte] = STATE(3606),
    [sym_byte] = STATE(3606),
    [sym_int16] = STATE(3606),
    [sym_uint16] = STATE(3606),
    [sym_int32] = STATE(3606),
    [sym_uint32] = STATE(3606),
    [sym_nativeint] = STATE(3606),
    [sym_unativeint] = STATE(3606),
    [sym_int64] = STATE(3606),
    [sym_uint64] = STATE(3606),
    [sym_ieee32] = STATE(3606),
    [sym_ieee64] = STATE(3606),
    [sym_bignum] = STATE(3606),
    [sym_decimal] = STATE(3606),
    [sym_float] = STATE(3332),
    [sym_block_comment] = STATE(2393),
    [sym_compiler_directive_decl] = STATE(2393),
    [sym_fsi_directive_decl] = STATE(2393),
    [sym_preproc_line] = STATE(2393),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(3960),
    [anon_sym_LBRACK_LT] = ACTIONS(3964),
    [anon_sym_COLON] = ACTIONS(3960),
    [anon_sym_as] = ACTIONS(3960),
    [anon_sym_LPAREN] = ACTIONS(3960),
    [anon_sym_COMMA] = ACTIONS(3964),
    [anon_sym_null] = ACTIONS(3960),
    [anon_sym__] = ACTIONS(3960),
    [anon_sym_QMARK] = ACTIONS(3964),
    [anon_sym_COLON_QMARK] = ACTIONS(3964),
    [anon_sym_COLON_COLON] = ACTIONS(3964),
    [anon_sym_PIPE] = ACTIONS(3964),
    [anon_sym_AMP] = ACTIONS(3964),
    [anon_sym_LBRACK] = ACTIONS(3960),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3964),
    [anon_sym_LBRACE] = ACTIONS(3964),
    [aux_sym_char_token1] = ACTIONS(3964),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3960),
    [anon_sym_DQUOTE] = ACTIONS(3960),
    [anon_sym_AT_DQUOTE] = ACTIONS(3964),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3964),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3964),
    [sym_bool] = ACTIONS(3960),
    [sym_unit] = ACTIONS(3964),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3960),
    [sym_op_identifier] = ACTIONS(3964),
    [sym_int] = ACTIONS(3960),
    [sym_xint] = ACTIONS(3964),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [sym__newline] = ACTIONS(3964),
    [sym__dedent] = ACTIONS(3964),
  },
  [2394] = {
    [sym_block_comment] = STATE(2394),
    [sym_compiler_directive_decl] = STATE(2394),
    [sym_fsi_directive_decl] = STATE(2394),
    [sym_preproc_line] = STATE(2394),
    [sym_identifier] = ACTIONS(2958),
    [anon_sym_EQ] = ACTIONS(2960),
    [anon_sym_COLON] = ACTIONS(2958),
    [anon_sym_return] = ACTIONS(2958),
    [anon_sym_do] = ACTIONS(2958),
    [anon_sym_let] = ACTIONS(2958),
    [anon_sym_let_BANG] = ACTIONS(2960),
    [anon_sym_LPAREN] = ACTIONS(2958),
    [anon_sym_COMMA] = ACTIONS(2960),
    [anon_sym_null] = ACTIONS(2958),
    [anon_sym_QMARK] = ACTIONS(2958),
    [anon_sym_COLON_QMARK] = ACTIONS(2958),
    [anon_sym_COLON_COLON] = ACTIONS(2960),
    [anon_sym_AMP] = ACTIONS(2958),
    [anon_sym_LBRACK] = ACTIONS(2958),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2960),
    [anon_sym_LBRACE] = ACTIONS(2958),
    [anon_sym_LT_AT] = ACTIONS(2958),
    [anon_sym_LT_AT_AT] = ACTIONS(2958),
    [anon_sym_DOT] = ACTIONS(2958),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2960),
    [anon_sym_new] = ACTIONS(2958),
    [anon_sym_return_BANG] = ACTIONS(2960),
    [anon_sym_yield] = ACTIONS(2958),
    [anon_sym_yield_BANG] = ACTIONS(2960),
    [anon_sym_lazy] = ACTIONS(2958),
    [anon_sym_assert] = ACTIONS(2958),
    [anon_sym_upcast] = ACTIONS(2958),
    [anon_sym_downcast] = ACTIONS(2958),
    [anon_sym_COLON_GT] = ACTIONS(2960),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2960),
    [anon_sym_for] = ACTIONS(2958),
    [anon_sym_while] = ACTIONS(2958),
    [anon_sym_if] = ACTIONS(2958),
    [anon_sym_fun] = ACTIONS(2958),
    [anon_sym_try] = ACTIONS(2958),
    [anon_sym_match] = ACTIONS(2958),
    [anon_sym_match_BANG] = ACTIONS(2960),
    [anon_sym_function] = ACTIONS(2958),
    [anon_sym_LT_DASH] = ACTIONS(2958),
    [anon_sym_DOT_LBRACK] = ACTIONS(2960),
    [anon_sym_LT] = ACTIONS(2960),
    [anon_sym_use] = ACTIONS(2958),
    [anon_sym_use_BANG] = ACTIONS(2960),
    [anon_sym_do_BANG] = ACTIONS(2960),
    [anon_sym_begin] = ACTIONS(2958),
    [anon_sym_LPAREN2] = ACTIONS(2958),
    [anon_sym_or] = ACTIONS(2958),
    [aux_sym_char_token1] = ACTIONS(2960),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2958),
    [anon_sym_DQUOTE] = ACTIONS(2958),
    [anon_sym_AT_DQUOTE] = ACTIONS(2960),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2960),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2960),
    [sym_bool] = ACTIONS(2958),
    [sym_unit] = ACTIONS(2960),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2958),
    [sym_op_identifier] = ACTIONS(2958),
    [anon_sym_PLUS] = ACTIONS(2958),
    [anon_sym_DASH] = ACTIONS(2958),
    [anon_sym_PLUS_DOT] = ACTIONS(2958),
    [anon_sym_DASH_DOT] = ACTIONS(2958),
    [anon_sym_PERCENT] = ACTIONS(2958),
    [anon_sym_AMP_AMP] = ACTIONS(2958),
    [anon_sym_TILDE] = ACTIONS(2960),
    [aux_sym_prefix_op_token1] = ACTIONS(2958),
    [aux_sym_infix_op_token1] = ACTIONS(2960),
    [aux_sym_infix_op_token2] = ACTIONS(2958),
    [anon_sym_PIPE_PIPE] = ACTIONS(2958),
    [anon_sym_BANG_EQ] = ACTIONS(2958),
    [anon_sym_COLON_EQ] = ACTIONS(2960),
    [anon_sym_DOLLAR] = ACTIONS(2958),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2958),
    [sym_int] = ACTIONS(2958),
    [sym_xint] = ACTIONS(2960),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2960),
    [anon_sym_POUNDendif] = ACTIONS(2960),
    [sym__newline] = ACTIONS(2960),
  },
  [2395] = {
    [sym_block_comment] = STATE(2395),
    [sym_compiler_directive_decl] = STATE(2395),
    [sym_fsi_directive_decl] = STATE(2395),
    [sym_preproc_line] = STATE(2395),
    [sym_identifier] = ACTIONS(2950),
    [anon_sym_EQ] = ACTIONS(2952),
    [anon_sym_COLON] = ACTIONS(2950),
    [anon_sym_return] = ACTIONS(2950),
    [anon_sym_do] = ACTIONS(2950),
    [anon_sym_let] = ACTIONS(2950),
    [anon_sym_let_BANG] = ACTIONS(2952),
    [anon_sym_LPAREN] = ACTIONS(2950),
    [anon_sym_COMMA] = ACTIONS(2952),
    [anon_sym_null] = ACTIONS(2950),
    [anon_sym_QMARK] = ACTIONS(2950),
    [anon_sym_COLON_QMARK] = ACTIONS(2950),
    [anon_sym_COLON_COLON] = ACTIONS(2952),
    [anon_sym_AMP] = ACTIONS(2950),
    [anon_sym_LBRACK] = ACTIONS(2950),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2952),
    [anon_sym_LBRACE] = ACTIONS(2950),
    [anon_sym_LT_AT] = ACTIONS(2950),
    [anon_sym_LT_AT_AT] = ACTIONS(2950),
    [anon_sym_DOT] = ACTIONS(2950),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2952),
    [anon_sym_new] = ACTIONS(2950),
    [anon_sym_return_BANG] = ACTIONS(2952),
    [anon_sym_yield] = ACTIONS(2950),
    [anon_sym_yield_BANG] = ACTIONS(2952),
    [anon_sym_lazy] = ACTIONS(2950),
    [anon_sym_assert] = ACTIONS(2950),
    [anon_sym_upcast] = ACTIONS(2950),
    [anon_sym_downcast] = ACTIONS(2950),
    [anon_sym_COLON_GT] = ACTIONS(2952),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2952),
    [anon_sym_for] = ACTIONS(2950),
    [anon_sym_while] = ACTIONS(2950),
    [anon_sym_if] = ACTIONS(2950),
    [anon_sym_fun] = ACTIONS(2950),
    [anon_sym_try] = ACTIONS(2950),
    [anon_sym_match] = ACTIONS(2950),
    [anon_sym_match_BANG] = ACTIONS(2952),
    [anon_sym_function] = ACTIONS(2950),
    [anon_sym_LT_DASH] = ACTIONS(2950),
    [anon_sym_DOT_LBRACK] = ACTIONS(2952),
    [anon_sym_LT] = ACTIONS(2952),
    [anon_sym_use] = ACTIONS(2950),
    [anon_sym_use_BANG] = ACTIONS(2952),
    [anon_sym_do_BANG] = ACTIONS(2952),
    [anon_sym_begin] = ACTIONS(2950),
    [anon_sym_LPAREN2] = ACTIONS(2950),
    [anon_sym_or] = ACTIONS(2950),
    [aux_sym_char_token1] = ACTIONS(2952),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2950),
    [anon_sym_DQUOTE] = ACTIONS(2950),
    [anon_sym_AT_DQUOTE] = ACTIONS(2952),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2952),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2952),
    [sym_bool] = ACTIONS(2950),
    [sym_unit] = ACTIONS(2952),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2950),
    [sym_op_identifier] = ACTIONS(2950),
    [anon_sym_PLUS] = ACTIONS(2950),
    [anon_sym_DASH] = ACTIONS(2950),
    [anon_sym_PLUS_DOT] = ACTIONS(2950),
    [anon_sym_DASH_DOT] = ACTIONS(2950),
    [anon_sym_PERCENT] = ACTIONS(2950),
    [anon_sym_AMP_AMP] = ACTIONS(2950),
    [anon_sym_TILDE] = ACTIONS(2952),
    [aux_sym_prefix_op_token1] = ACTIONS(2950),
    [aux_sym_infix_op_token1] = ACTIONS(2952),
    [aux_sym_infix_op_token2] = ACTIONS(2950),
    [anon_sym_PIPE_PIPE] = ACTIONS(2950),
    [anon_sym_BANG_EQ] = ACTIONS(2950),
    [anon_sym_COLON_EQ] = ACTIONS(2952),
    [anon_sym_DOLLAR] = ACTIONS(2950),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2950),
    [sym_int] = ACTIONS(2950),
    [sym_xint] = ACTIONS(2952),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2952),
    [anon_sym_POUNDendif] = ACTIONS(2952),
    [sym__newline] = ACTIONS(2952),
  },
  [2396] = {
    [sym_block_comment] = STATE(2396),
    [sym_compiler_directive_decl] = STATE(2396),
    [sym_fsi_directive_decl] = STATE(2396),
    [sym_preproc_line] = STATE(2396),
    [sym_identifier] = ACTIONS(2946),
    [anon_sym_EQ] = ACTIONS(2948),
    [anon_sym_COLON] = ACTIONS(2946),
    [anon_sym_return] = ACTIONS(2946),
    [anon_sym_do] = ACTIONS(2946),
    [anon_sym_let] = ACTIONS(2946),
    [anon_sym_let_BANG] = ACTIONS(2948),
    [anon_sym_LPAREN] = ACTIONS(2946),
    [anon_sym_COMMA] = ACTIONS(2948),
    [anon_sym_null] = ACTIONS(2946),
    [anon_sym_QMARK] = ACTIONS(2946),
    [anon_sym_COLON_QMARK] = ACTIONS(2946),
    [anon_sym_COLON_COLON] = ACTIONS(2948),
    [anon_sym_AMP] = ACTIONS(2946),
    [anon_sym_LBRACK] = ACTIONS(2946),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2948),
    [anon_sym_LBRACE] = ACTIONS(2946),
    [anon_sym_LT_AT] = ACTIONS(2946),
    [anon_sym_LT_AT_AT] = ACTIONS(2946),
    [anon_sym_DOT] = ACTIONS(2946),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2948),
    [anon_sym_new] = ACTIONS(2946),
    [anon_sym_return_BANG] = ACTIONS(2948),
    [anon_sym_yield] = ACTIONS(2946),
    [anon_sym_yield_BANG] = ACTIONS(2948),
    [anon_sym_lazy] = ACTIONS(2946),
    [anon_sym_assert] = ACTIONS(2946),
    [anon_sym_upcast] = ACTIONS(2946),
    [anon_sym_downcast] = ACTIONS(2946),
    [anon_sym_COLON_GT] = ACTIONS(2948),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2948),
    [anon_sym_for] = ACTIONS(2946),
    [anon_sym_while] = ACTIONS(2946),
    [anon_sym_if] = ACTIONS(2946),
    [anon_sym_fun] = ACTIONS(2946),
    [anon_sym_try] = ACTIONS(2946),
    [anon_sym_match] = ACTIONS(2946),
    [anon_sym_match_BANG] = ACTIONS(2948),
    [anon_sym_function] = ACTIONS(2946),
    [anon_sym_LT_DASH] = ACTIONS(2946),
    [anon_sym_DOT_LBRACK] = ACTIONS(2948),
    [anon_sym_LT] = ACTIONS(2948),
    [anon_sym_use] = ACTIONS(2946),
    [anon_sym_use_BANG] = ACTIONS(2948),
    [anon_sym_do_BANG] = ACTIONS(2948),
    [anon_sym_begin] = ACTIONS(2946),
    [anon_sym_LPAREN2] = ACTIONS(2946),
    [anon_sym_or] = ACTIONS(2946),
    [aux_sym_char_token1] = ACTIONS(2948),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2946),
    [anon_sym_DQUOTE] = ACTIONS(2946),
    [anon_sym_AT_DQUOTE] = ACTIONS(2948),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2948),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2948),
    [sym_bool] = ACTIONS(2946),
    [sym_unit] = ACTIONS(2948),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2946),
    [sym_op_identifier] = ACTIONS(2946),
    [anon_sym_PLUS] = ACTIONS(2946),
    [anon_sym_DASH] = ACTIONS(2946),
    [anon_sym_PLUS_DOT] = ACTIONS(2946),
    [anon_sym_DASH_DOT] = ACTIONS(2946),
    [anon_sym_PERCENT] = ACTIONS(2946),
    [anon_sym_AMP_AMP] = ACTIONS(2946),
    [anon_sym_TILDE] = ACTIONS(2948),
    [aux_sym_prefix_op_token1] = ACTIONS(2946),
    [aux_sym_infix_op_token1] = ACTIONS(2948),
    [aux_sym_infix_op_token2] = ACTIONS(2946),
    [anon_sym_PIPE_PIPE] = ACTIONS(2946),
    [anon_sym_BANG_EQ] = ACTIONS(2946),
    [anon_sym_COLON_EQ] = ACTIONS(2948),
    [anon_sym_DOLLAR] = ACTIONS(2946),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2946),
    [sym_int] = ACTIONS(2946),
    [sym_xint] = ACTIONS(2948),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2948),
    [anon_sym_POUNDendif] = ACTIONS(2948),
    [sym__newline] = ACTIONS(2948),
  },
  [2397] = {
    [sym_block_comment] = STATE(2397),
    [sym_compiler_directive_decl] = STATE(2397),
    [sym_fsi_directive_decl] = STATE(2397),
    [sym_preproc_line] = STATE(2397),
    [sym_identifier] = ACTIONS(2938),
    [anon_sym_EQ] = ACTIONS(2940),
    [anon_sym_COLON] = ACTIONS(2938),
    [anon_sym_return] = ACTIONS(2938),
    [anon_sym_do] = ACTIONS(2938),
    [anon_sym_let] = ACTIONS(2938),
    [anon_sym_let_BANG] = ACTIONS(2940),
    [anon_sym_LPAREN] = ACTIONS(2938),
    [anon_sym_COMMA] = ACTIONS(2940),
    [anon_sym_null] = ACTIONS(2938),
    [anon_sym_QMARK] = ACTIONS(2938),
    [anon_sym_COLON_QMARK] = ACTIONS(2938),
    [anon_sym_COLON_COLON] = ACTIONS(2940),
    [anon_sym_AMP] = ACTIONS(2938),
    [anon_sym_LBRACK] = ACTIONS(2938),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2940),
    [anon_sym_LBRACE] = ACTIONS(2938),
    [anon_sym_LT_AT] = ACTIONS(2938),
    [anon_sym_LT_AT_AT] = ACTIONS(2938),
    [anon_sym_DOT] = ACTIONS(2938),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2940),
    [anon_sym_new] = ACTIONS(2938),
    [anon_sym_return_BANG] = ACTIONS(2940),
    [anon_sym_yield] = ACTIONS(2938),
    [anon_sym_yield_BANG] = ACTIONS(2940),
    [anon_sym_lazy] = ACTIONS(2938),
    [anon_sym_assert] = ACTIONS(2938),
    [anon_sym_upcast] = ACTIONS(2938),
    [anon_sym_downcast] = ACTIONS(2938),
    [anon_sym_COLON_GT] = ACTIONS(2940),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2940),
    [anon_sym_for] = ACTIONS(2938),
    [anon_sym_while] = ACTIONS(2938),
    [anon_sym_if] = ACTIONS(2938),
    [anon_sym_fun] = ACTIONS(2938),
    [anon_sym_try] = ACTIONS(2938),
    [anon_sym_match] = ACTIONS(2938),
    [anon_sym_match_BANG] = ACTIONS(2940),
    [anon_sym_function] = ACTIONS(2938),
    [anon_sym_LT_DASH] = ACTIONS(2938),
    [anon_sym_DOT_LBRACK] = ACTIONS(2940),
    [anon_sym_LT] = ACTIONS(2940),
    [anon_sym_use] = ACTIONS(2938),
    [anon_sym_use_BANG] = ACTIONS(2940),
    [anon_sym_do_BANG] = ACTIONS(2940),
    [anon_sym_begin] = ACTIONS(2938),
    [anon_sym_LPAREN2] = ACTIONS(2938),
    [anon_sym_or] = ACTIONS(2938),
    [aux_sym_char_token1] = ACTIONS(2940),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2938),
    [anon_sym_DQUOTE] = ACTIONS(2938),
    [anon_sym_AT_DQUOTE] = ACTIONS(2940),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2940),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2940),
    [sym_bool] = ACTIONS(2938),
    [sym_unit] = ACTIONS(2940),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2938),
    [sym_op_identifier] = ACTIONS(2938),
    [anon_sym_PLUS] = ACTIONS(2938),
    [anon_sym_DASH] = ACTIONS(2938),
    [anon_sym_PLUS_DOT] = ACTIONS(2938),
    [anon_sym_DASH_DOT] = ACTIONS(2938),
    [anon_sym_PERCENT] = ACTIONS(2938),
    [anon_sym_AMP_AMP] = ACTIONS(2938),
    [anon_sym_TILDE] = ACTIONS(2940),
    [aux_sym_prefix_op_token1] = ACTIONS(2938),
    [aux_sym_infix_op_token1] = ACTIONS(2940),
    [aux_sym_infix_op_token2] = ACTIONS(2938),
    [anon_sym_PIPE_PIPE] = ACTIONS(2938),
    [anon_sym_BANG_EQ] = ACTIONS(2938),
    [anon_sym_COLON_EQ] = ACTIONS(2940),
    [anon_sym_DOLLAR] = ACTIONS(2938),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2938),
    [sym_int] = ACTIONS(2938),
    [sym_xint] = ACTIONS(2940),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2940),
    [anon_sym_POUNDendif] = ACTIONS(2940),
    [sym__newline] = ACTIONS(2940),
  },
  [2398] = {
    [sym_block_comment] = STATE(2398),
    [sym_compiler_directive_decl] = STATE(2398),
    [sym_fsi_directive_decl] = STATE(2398),
    [sym_preproc_line] = STATE(2398),
    [sym_identifier] = ACTIONS(3003),
    [anon_sym_EQ] = ACTIONS(3005),
    [anon_sym_COLON] = ACTIONS(3003),
    [anon_sym_return] = ACTIONS(3003),
    [anon_sym_do] = ACTIONS(3003),
    [anon_sym_let] = ACTIONS(3003),
    [anon_sym_let_BANG] = ACTIONS(3005),
    [anon_sym_LPAREN] = ACTIONS(3003),
    [anon_sym_COMMA] = ACTIONS(3005),
    [anon_sym_null] = ACTIONS(3003),
    [anon_sym_QMARK] = ACTIONS(3003),
    [anon_sym_COLON_QMARK] = ACTIONS(3003),
    [anon_sym_COLON_COLON] = ACTIONS(3005),
    [anon_sym_AMP] = ACTIONS(3003),
    [anon_sym_LBRACK] = ACTIONS(3003),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3005),
    [anon_sym_LBRACE] = ACTIONS(3003),
    [anon_sym_LT_AT] = ACTIONS(3003),
    [anon_sym_LT_AT_AT] = ACTIONS(3003),
    [anon_sym_DOT] = ACTIONS(3003),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3005),
    [anon_sym_new] = ACTIONS(3003),
    [anon_sym_return_BANG] = ACTIONS(3005),
    [anon_sym_yield] = ACTIONS(3003),
    [anon_sym_yield_BANG] = ACTIONS(3005),
    [anon_sym_lazy] = ACTIONS(3003),
    [anon_sym_assert] = ACTIONS(3003),
    [anon_sym_upcast] = ACTIONS(3003),
    [anon_sym_downcast] = ACTIONS(3003),
    [anon_sym_COLON_GT] = ACTIONS(3005),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3005),
    [anon_sym_for] = ACTIONS(3003),
    [anon_sym_while] = ACTIONS(3003),
    [anon_sym_if] = ACTIONS(3003),
    [anon_sym_fun] = ACTIONS(3003),
    [anon_sym_try] = ACTIONS(3003),
    [anon_sym_match] = ACTIONS(3003),
    [anon_sym_match_BANG] = ACTIONS(3005),
    [anon_sym_function] = ACTIONS(3003),
    [anon_sym_LT_DASH] = ACTIONS(3003),
    [anon_sym_DOT_LBRACK] = ACTIONS(3005),
    [anon_sym_LT] = ACTIONS(3005),
    [anon_sym_GT] = ACTIONS(3003),
    [anon_sym_use] = ACTIONS(3003),
    [anon_sym_use_BANG] = ACTIONS(3005),
    [anon_sym_do_BANG] = ACTIONS(3005),
    [anon_sym_begin] = ACTIONS(3003),
    [anon_sym_LPAREN2] = ACTIONS(3003),
    [anon_sym_or] = ACTIONS(3003),
    [aux_sym_char_token1] = ACTIONS(3005),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3003),
    [anon_sym_DQUOTE] = ACTIONS(3003),
    [anon_sym_AT_DQUOTE] = ACTIONS(3005),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3005),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3005),
    [sym_bool] = ACTIONS(3003),
    [sym_unit] = ACTIONS(3005),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3003),
    [sym_op_identifier] = ACTIONS(3003),
    [anon_sym_PLUS] = ACTIONS(3003),
    [anon_sym_DASH] = ACTIONS(3003),
    [anon_sym_PLUS_DOT] = ACTIONS(3003),
    [anon_sym_DASH_DOT] = ACTIONS(3003),
    [anon_sym_PERCENT] = ACTIONS(3003),
    [anon_sym_AMP_AMP] = ACTIONS(3003),
    [anon_sym_TILDE] = ACTIONS(3005),
    [aux_sym_prefix_op_token1] = ACTIONS(3003),
    [aux_sym_infix_op_token1] = ACTIONS(3005),
    [aux_sym_infix_op_token2] = ACTIONS(3003),
    [anon_sym_PIPE_PIPE] = ACTIONS(3003),
    [anon_sym_BANG_EQ] = ACTIONS(3003),
    [anon_sym_COLON_EQ] = ACTIONS(3005),
    [anon_sym_DOLLAR] = ACTIONS(3003),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3003),
    [sym_int] = ACTIONS(3003),
    [sym_xint] = ACTIONS(3005),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3005),
    [sym__newline] = ACTIONS(3005),
  },
  [2399] = {
    [sym_block_comment] = STATE(2399),
    [sym_compiler_directive_decl] = STATE(2399),
    [sym_fsi_directive_decl] = STATE(2399),
    [sym_preproc_line] = STATE(2399),
    [sym_identifier] = ACTIONS(2922),
    [anon_sym_EQ] = ACTIONS(2924),
    [anon_sym_COLON] = ACTIONS(2922),
    [anon_sym_return] = ACTIONS(2922),
    [anon_sym_do] = ACTIONS(2922),
    [anon_sym_let] = ACTIONS(2922),
    [anon_sym_let_BANG] = ACTIONS(2924),
    [anon_sym_LPAREN] = ACTIONS(2922),
    [anon_sym_COMMA] = ACTIONS(2924),
    [anon_sym_null] = ACTIONS(2922),
    [anon_sym_QMARK] = ACTIONS(2922),
    [anon_sym_COLON_QMARK] = ACTIONS(2922),
    [anon_sym_COLON_COLON] = ACTIONS(2924),
    [anon_sym_AMP] = ACTIONS(2922),
    [anon_sym_LBRACK] = ACTIONS(2922),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2924),
    [anon_sym_LBRACE] = ACTIONS(2922),
    [anon_sym_LT_AT] = ACTIONS(2922),
    [anon_sym_LT_AT_AT] = ACTIONS(2922),
    [anon_sym_DOT] = ACTIONS(2922),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2924),
    [anon_sym_new] = ACTIONS(2922),
    [anon_sym_return_BANG] = ACTIONS(2924),
    [anon_sym_yield] = ACTIONS(2922),
    [anon_sym_yield_BANG] = ACTIONS(2924),
    [anon_sym_lazy] = ACTIONS(2922),
    [anon_sym_assert] = ACTIONS(2922),
    [anon_sym_upcast] = ACTIONS(2922),
    [anon_sym_downcast] = ACTIONS(2922),
    [anon_sym_COLON_GT] = ACTIONS(2924),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2924),
    [anon_sym_for] = ACTIONS(2922),
    [anon_sym_while] = ACTIONS(2922),
    [anon_sym_if] = ACTIONS(2922),
    [anon_sym_fun] = ACTIONS(2922),
    [anon_sym_try] = ACTIONS(2922),
    [anon_sym_match] = ACTIONS(2922),
    [anon_sym_match_BANG] = ACTIONS(2924),
    [anon_sym_function] = ACTIONS(2922),
    [anon_sym_LT_DASH] = ACTIONS(2922),
    [anon_sym_DOT_LBRACK] = ACTIONS(2924),
    [anon_sym_LT] = ACTIONS(2924),
    [anon_sym_use] = ACTIONS(2922),
    [anon_sym_use_BANG] = ACTIONS(2924),
    [anon_sym_do_BANG] = ACTIONS(2924),
    [anon_sym_begin] = ACTIONS(2922),
    [anon_sym_LPAREN2] = ACTIONS(2922),
    [anon_sym_or] = ACTIONS(2922),
    [aux_sym_char_token1] = ACTIONS(2924),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2922),
    [anon_sym_DQUOTE] = ACTIONS(2922),
    [anon_sym_AT_DQUOTE] = ACTIONS(2924),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2924),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2924),
    [sym_bool] = ACTIONS(2922),
    [sym_unit] = ACTIONS(2924),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2922),
    [sym_op_identifier] = ACTIONS(2922),
    [anon_sym_PLUS] = ACTIONS(2922),
    [anon_sym_DASH] = ACTIONS(2922),
    [anon_sym_PLUS_DOT] = ACTIONS(2922),
    [anon_sym_DASH_DOT] = ACTIONS(2922),
    [anon_sym_PERCENT] = ACTIONS(2922),
    [anon_sym_AMP_AMP] = ACTIONS(2922),
    [anon_sym_TILDE] = ACTIONS(2924),
    [aux_sym_prefix_op_token1] = ACTIONS(2922),
    [aux_sym_infix_op_token1] = ACTIONS(2924),
    [aux_sym_infix_op_token2] = ACTIONS(2922),
    [anon_sym_PIPE_PIPE] = ACTIONS(2922),
    [anon_sym_BANG_EQ] = ACTIONS(2922),
    [anon_sym_COLON_EQ] = ACTIONS(2924),
    [anon_sym_DOLLAR] = ACTIONS(2922),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2922),
    [sym_int] = ACTIONS(2922),
    [sym_xint] = ACTIONS(2924),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2924),
    [anon_sym_POUNDendif] = ACTIONS(2924),
    [sym__newline] = ACTIONS(2924),
  },
  [2400] = {
    [sym_block_comment] = STATE(2400),
    [sym_compiler_directive_decl] = STATE(2400),
    [sym_fsi_directive_decl] = STATE(2400),
    [sym_preproc_line] = STATE(2400),
    [sym_identifier] = ACTIONS(2867),
    [anon_sym_EQ] = ACTIONS(2869),
    [anon_sym_COLON] = ACTIONS(2867),
    [anon_sym_return] = ACTIONS(2867),
    [anon_sym_do] = ACTIONS(2867),
    [anon_sym_let] = ACTIONS(2867),
    [anon_sym_let_BANG] = ACTIONS(2869),
    [anon_sym_LPAREN] = ACTIONS(2867),
    [anon_sym_COMMA] = ACTIONS(2869),
    [anon_sym_null] = ACTIONS(2867),
    [anon_sym_QMARK] = ACTIONS(2867),
    [anon_sym_COLON_QMARK] = ACTIONS(2867),
    [anon_sym_COLON_COLON] = ACTIONS(2869),
    [anon_sym_AMP] = ACTIONS(2867),
    [anon_sym_LBRACK] = ACTIONS(2867),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2869),
    [anon_sym_LBRACE] = ACTIONS(2867),
    [anon_sym_LT_AT] = ACTIONS(2867),
    [anon_sym_LT_AT_AT] = ACTIONS(2867),
    [anon_sym_DOT] = ACTIONS(4306),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2869),
    [anon_sym_new] = ACTIONS(2867),
    [anon_sym_return_BANG] = ACTIONS(2869),
    [anon_sym_yield] = ACTIONS(2867),
    [anon_sym_yield_BANG] = ACTIONS(2869),
    [anon_sym_lazy] = ACTIONS(2867),
    [anon_sym_assert] = ACTIONS(2867),
    [anon_sym_upcast] = ACTIONS(2867),
    [anon_sym_downcast] = ACTIONS(2867),
    [anon_sym_COLON_GT] = ACTIONS(2869),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2869),
    [anon_sym_for] = ACTIONS(2867),
    [anon_sym_while] = ACTIONS(2867),
    [anon_sym_if] = ACTIONS(2867),
    [anon_sym_fun] = ACTIONS(2867),
    [anon_sym_try] = ACTIONS(2867),
    [anon_sym_match] = ACTIONS(2867),
    [anon_sym_match_BANG] = ACTIONS(2869),
    [anon_sym_function] = ACTIONS(2867),
    [anon_sym_LT_DASH] = ACTIONS(2867),
    [anon_sym_DOT_LBRACK] = ACTIONS(2869),
    [anon_sym_LT] = ACTIONS(2869),
    [anon_sym_GT] = ACTIONS(2867),
    [anon_sym_use] = ACTIONS(2867),
    [anon_sym_use_BANG] = ACTIONS(2869),
    [anon_sym_do_BANG] = ACTIONS(2869),
    [anon_sym_begin] = ACTIONS(2867),
    [anon_sym_LPAREN2] = ACTIONS(2867),
    [anon_sym_or] = ACTIONS(2867),
    [aux_sym_char_token1] = ACTIONS(2869),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2867),
    [anon_sym_DQUOTE] = ACTIONS(2867),
    [anon_sym_AT_DQUOTE] = ACTIONS(2869),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2869),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2869),
    [sym_bool] = ACTIONS(2867),
    [sym_unit] = ACTIONS(2869),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2867),
    [sym_op_identifier] = ACTIONS(2867),
    [anon_sym_PLUS] = ACTIONS(2867),
    [anon_sym_DASH] = ACTIONS(2867),
    [anon_sym_PLUS_DOT] = ACTIONS(2867),
    [anon_sym_DASH_DOT] = ACTIONS(2867),
    [anon_sym_PERCENT] = ACTIONS(2867),
    [anon_sym_AMP_AMP] = ACTIONS(2867),
    [anon_sym_TILDE] = ACTIONS(2869),
    [aux_sym_prefix_op_token1] = ACTIONS(2867),
    [aux_sym_infix_op_token1] = ACTIONS(2869),
    [aux_sym_infix_op_token2] = ACTIONS(2867),
    [anon_sym_PIPE_PIPE] = ACTIONS(2867),
    [anon_sym_BANG_EQ] = ACTIONS(2867),
    [anon_sym_COLON_EQ] = ACTIONS(2869),
    [anon_sym_DOLLAR] = ACTIONS(2867),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2867),
    [sym_int] = ACTIONS(2867),
    [sym_xint] = ACTIONS(2869),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2869),
    [sym__newline] = ACTIONS(2869),
  },
  [2401] = {
    [sym_attributes] = STATE(2652),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(3588),
    [sym__pattern] = STATE(1851),
    [sym_optional_pattern] = STATE(3588),
    [sym_type_check_pattern] = STATE(3588),
    [sym_attribute_pattern] = STATE(3588),
    [sym_paren_pattern] = STATE(3588),
    [sym_as_pattern] = STATE(3588),
    [sym_cons_pattern] = STATE(3588),
    [sym_disjunct_pattern] = STATE(3588),
    [sym_conjunct_pattern] = STATE(3588),
    [sym_typed_pattern] = STATE(3588),
    [sym_list_pattern] = STATE(3588),
    [sym_array_pattern] = STATE(3588),
    [sym_record_pattern] = STATE(3588),
    [sym_named_field_pattern] = STATE(3588),
    [sym_identifier_pattern] = STATE(3588),
    [sym_long_identifier_or_op] = STATE(2401),
    [sym_char] = STATE(3658),
    [sym_format_string] = STATE(3670),
    [sym__string_literal] = STATE(3670),
    [sym_string] = STATE(3658),
    [sym_verbatim_string] = STATE(3658),
    [sym_bytearray] = STATE(3658),
    [sym_verbatim_bytearray] = STATE(3658),
    [sym_format_triple_quoted_string] = STATE(3673),
    [sym_triple_quoted_string] = STATE(3658),
    [sym_const] = STATE(3588),
    [sym_long_identifier] = STATE(3493),
    [sym_active_pattern] = STATE(3613),
    [sym__identifier_or_op] = STATE(3650),
    [sym_sbyte] = STATE(3658),
    [sym_byte] = STATE(3658),
    [sym_int16] = STATE(3658),
    [sym_uint16] = STATE(3658),
    [sym_int32] = STATE(3658),
    [sym_uint32] = STATE(3658),
    [sym_nativeint] = STATE(3658),
    [sym_unativeint] = STATE(3658),
    [sym_int64] = STATE(3658),
    [sym_uint64] = STATE(3658),
    [sym_ieee32] = STATE(3658),
    [sym_ieee64] = STATE(3658),
    [sym_bignum] = STATE(3658),
    [sym_decimal] = STATE(3658),
    [sym_float] = STATE(3376),
    [sym_block_comment] = STATE(2401),
    [sym_compiler_directive_decl] = STATE(2401),
    [sym_fsi_directive_decl] = STATE(2401),
    [sym_preproc_line] = STATE(2401),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(3960),
    [anon_sym_LBRACK_LT] = ACTIONS(3964),
    [anon_sym_COLON] = ACTIONS(3960),
    [anon_sym_as] = ACTIONS(3960),
    [anon_sym_LPAREN] = ACTIONS(3960),
    [anon_sym_COMMA] = ACTIONS(3964),
    [anon_sym_null] = ACTIONS(3960),
    [anon_sym__] = ACTIONS(3960),
    [anon_sym_QMARK] = ACTIONS(3964),
    [anon_sym_COLON_QMARK] = ACTIONS(3964),
    [anon_sym_COLON_COLON] = ACTIONS(3964),
    [anon_sym_PIPE] = ACTIONS(3964),
    [anon_sym_AMP] = ACTIONS(3964),
    [anon_sym_LBRACK] = ACTIONS(3960),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3964),
    [anon_sym_LBRACE] = ACTIONS(3964),
    [anon_sym_DASH_GT] = ACTIONS(3964),
    [anon_sym_when] = ACTIONS(3960),
    [aux_sym_char_token1] = ACTIONS(3964),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3960),
    [anon_sym_DQUOTE] = ACTIONS(3960),
    [anon_sym_AT_DQUOTE] = ACTIONS(3964),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3964),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3964),
    [sym_bool] = ACTIONS(3960),
    [sym_unit] = ACTIONS(3964),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3960),
    [sym_op_identifier] = ACTIONS(3964),
    [sym_int] = ACTIONS(3960),
    [sym_xint] = ACTIONS(3964),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2402] = {
    [sym_block_comment] = STATE(2402),
    [sym_compiler_directive_decl] = STATE(2402),
    [sym_fsi_directive_decl] = STATE(2402),
    [sym_preproc_line] = STATE(2402),
    [sym_identifier] = ACTIONS(3007),
    [anon_sym_EQ] = ACTIONS(3009),
    [anon_sym_COLON] = ACTIONS(3007),
    [anon_sym_return] = ACTIONS(3007),
    [anon_sym_do] = ACTIONS(3007),
    [anon_sym_let] = ACTIONS(3007),
    [anon_sym_let_BANG] = ACTIONS(3009),
    [anon_sym_LPAREN] = ACTIONS(3007),
    [anon_sym_COMMA] = ACTIONS(3009),
    [anon_sym_null] = ACTIONS(3007),
    [anon_sym_QMARK] = ACTIONS(3007),
    [anon_sym_COLON_QMARK] = ACTIONS(3007),
    [anon_sym_COLON_COLON] = ACTIONS(3009),
    [anon_sym_AMP] = ACTIONS(3007),
    [anon_sym_LBRACK] = ACTIONS(3007),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3009),
    [anon_sym_LBRACE] = ACTIONS(3007),
    [anon_sym_LT_AT] = ACTIONS(3007),
    [anon_sym_LT_AT_AT] = ACTIONS(3007),
    [anon_sym_AT_AT_GT] = ACTIONS(3007),
    [anon_sym_DOT] = ACTIONS(3007),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3009),
    [anon_sym_new] = ACTIONS(3007),
    [anon_sym_return_BANG] = ACTIONS(3009),
    [anon_sym_yield] = ACTIONS(3007),
    [anon_sym_yield_BANG] = ACTIONS(3009),
    [anon_sym_lazy] = ACTIONS(3007),
    [anon_sym_assert] = ACTIONS(3007),
    [anon_sym_upcast] = ACTIONS(3007),
    [anon_sym_downcast] = ACTIONS(3007),
    [anon_sym_COLON_GT] = ACTIONS(3009),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3009),
    [anon_sym_for] = ACTIONS(3007),
    [anon_sym_while] = ACTIONS(3007),
    [anon_sym_if] = ACTIONS(3007),
    [anon_sym_fun] = ACTIONS(3007),
    [anon_sym_try] = ACTIONS(3007),
    [anon_sym_match] = ACTIONS(3007),
    [anon_sym_match_BANG] = ACTIONS(3009),
    [anon_sym_function] = ACTIONS(3007),
    [anon_sym_LT_DASH] = ACTIONS(3007),
    [anon_sym_DOT_LBRACK] = ACTIONS(3009),
    [anon_sym_LT] = ACTIONS(3009),
    [anon_sym_use] = ACTIONS(3007),
    [anon_sym_use_BANG] = ACTIONS(3009),
    [anon_sym_do_BANG] = ACTIONS(3009),
    [anon_sym_begin] = ACTIONS(3007),
    [anon_sym_LPAREN2] = ACTIONS(3007),
    [anon_sym_or] = ACTIONS(3007),
    [aux_sym_char_token1] = ACTIONS(3009),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3007),
    [anon_sym_DQUOTE] = ACTIONS(3007),
    [anon_sym_AT_DQUOTE] = ACTIONS(3009),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3009),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3009),
    [sym_bool] = ACTIONS(3007),
    [sym_unit] = ACTIONS(3009),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3007),
    [sym_op_identifier] = ACTIONS(3007),
    [anon_sym_PLUS] = ACTIONS(3007),
    [anon_sym_DASH] = ACTIONS(3007),
    [anon_sym_PLUS_DOT] = ACTIONS(3007),
    [anon_sym_DASH_DOT] = ACTIONS(3007),
    [anon_sym_PERCENT] = ACTIONS(3007),
    [anon_sym_AMP_AMP] = ACTIONS(3007),
    [anon_sym_TILDE] = ACTIONS(3009),
    [aux_sym_prefix_op_token1] = ACTIONS(3007),
    [aux_sym_infix_op_token1] = ACTIONS(3009),
    [aux_sym_infix_op_token2] = ACTIONS(3007),
    [anon_sym_PIPE_PIPE] = ACTIONS(3007),
    [anon_sym_BANG_EQ] = ACTIONS(3007),
    [anon_sym_COLON_EQ] = ACTIONS(3009),
    [anon_sym_DOLLAR] = ACTIONS(3007),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3007),
    [sym_int] = ACTIONS(3007),
    [sym_xint] = ACTIONS(3009),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3009),
    [sym__newline] = ACTIONS(3009),
  },
  [2403] = {
    [sym_block_comment] = STATE(2403),
    [sym_compiler_directive_decl] = STATE(2403),
    [sym_fsi_directive_decl] = STATE(2403),
    [sym_preproc_line] = STATE(2403),
    [sym_identifier] = ACTIONS(2851),
    [anon_sym_EQ] = ACTIONS(2853),
    [anon_sym_COLON] = ACTIONS(2851),
    [anon_sym_return] = ACTIONS(2851),
    [anon_sym_do] = ACTIONS(2851),
    [anon_sym_let] = ACTIONS(2851),
    [anon_sym_let_BANG] = ACTIONS(2853),
    [anon_sym_LPAREN] = ACTIONS(2851),
    [anon_sym_COMMA] = ACTIONS(2853),
    [anon_sym_null] = ACTIONS(2851),
    [anon_sym_QMARK] = ACTIONS(2851),
    [anon_sym_COLON_QMARK] = ACTIONS(2851),
    [anon_sym_COLON_COLON] = ACTIONS(2853),
    [anon_sym_AMP] = ACTIONS(2851),
    [anon_sym_LBRACK] = ACTIONS(2851),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2853),
    [anon_sym_LBRACE] = ACTIONS(2851),
    [anon_sym_LT_AT] = ACTIONS(2851),
    [anon_sym_LT_AT_AT] = ACTIONS(2851),
    [anon_sym_DOT] = ACTIONS(2851),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2853),
    [anon_sym_new] = ACTIONS(2851),
    [anon_sym_return_BANG] = ACTIONS(2853),
    [anon_sym_yield] = ACTIONS(2851),
    [anon_sym_yield_BANG] = ACTIONS(2853),
    [anon_sym_lazy] = ACTIONS(2851),
    [anon_sym_assert] = ACTIONS(2851),
    [anon_sym_upcast] = ACTIONS(2851),
    [anon_sym_downcast] = ACTIONS(2851),
    [anon_sym_COLON_GT] = ACTIONS(2853),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2853),
    [anon_sym_for] = ACTIONS(2851),
    [anon_sym_while] = ACTIONS(2851),
    [anon_sym_if] = ACTIONS(2851),
    [anon_sym_fun] = ACTIONS(2851),
    [anon_sym_try] = ACTIONS(2851),
    [anon_sym_match] = ACTIONS(2851),
    [anon_sym_match_BANG] = ACTIONS(2853),
    [anon_sym_function] = ACTIONS(2851),
    [anon_sym_LT_DASH] = ACTIONS(2851),
    [anon_sym_DOT_LBRACK] = ACTIONS(2853),
    [anon_sym_LT] = ACTIONS(2853),
    [anon_sym_use] = ACTIONS(2851),
    [anon_sym_use_BANG] = ACTIONS(2853),
    [anon_sym_do_BANG] = ACTIONS(2853),
    [anon_sym_begin] = ACTIONS(2851),
    [anon_sym_LPAREN2] = ACTIONS(2851),
    [anon_sym_or] = ACTIONS(2851),
    [aux_sym_char_token1] = ACTIONS(2853),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2851),
    [anon_sym_DQUOTE] = ACTIONS(2851),
    [anon_sym_AT_DQUOTE] = ACTIONS(2853),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2853),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2853),
    [sym_bool] = ACTIONS(2851),
    [sym_unit] = ACTIONS(2853),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2851),
    [sym_op_identifier] = ACTIONS(2851),
    [anon_sym_PLUS] = ACTIONS(2851),
    [anon_sym_DASH] = ACTIONS(2851),
    [anon_sym_PLUS_DOT] = ACTIONS(2851),
    [anon_sym_DASH_DOT] = ACTIONS(2851),
    [anon_sym_PERCENT] = ACTIONS(2851),
    [anon_sym_AMP_AMP] = ACTIONS(2851),
    [anon_sym_TILDE] = ACTIONS(2853),
    [aux_sym_prefix_op_token1] = ACTIONS(2851),
    [aux_sym_infix_op_token1] = ACTIONS(2853),
    [aux_sym_infix_op_token2] = ACTIONS(2851),
    [anon_sym_PIPE_PIPE] = ACTIONS(2851),
    [anon_sym_BANG_EQ] = ACTIONS(2851),
    [anon_sym_COLON_EQ] = ACTIONS(2853),
    [anon_sym_DOLLAR] = ACTIONS(2851),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2851),
    [sym_int] = ACTIONS(2851),
    [sym_xint] = ACTIONS(2853),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2853),
    [anon_sym_POUNDendif] = ACTIONS(2853),
    [sym__newline] = ACTIONS(2853),
  },
  [2404] = {
    [sym_block_comment] = STATE(2404),
    [sym_compiler_directive_decl] = STATE(2404),
    [sym_fsi_directive_decl] = STATE(2404),
    [sym_preproc_line] = STATE(2404),
    [sym_identifier] = ACTIONS(2918),
    [anon_sym_EQ] = ACTIONS(2920),
    [anon_sym_COLON] = ACTIONS(2918),
    [anon_sym_return] = ACTIONS(2918),
    [anon_sym_do] = ACTIONS(2918),
    [anon_sym_let] = ACTIONS(2918),
    [anon_sym_let_BANG] = ACTIONS(2920),
    [anon_sym_LPAREN] = ACTIONS(2918),
    [anon_sym_COMMA] = ACTIONS(2920),
    [anon_sym_null] = ACTIONS(2918),
    [anon_sym_QMARK] = ACTIONS(2918),
    [anon_sym_COLON_QMARK] = ACTIONS(2918),
    [anon_sym_COLON_COLON] = ACTIONS(2920),
    [anon_sym_AMP] = ACTIONS(2918),
    [anon_sym_LBRACK] = ACTIONS(2918),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2920),
    [anon_sym_LBRACE] = ACTIONS(2918),
    [anon_sym_LT_AT] = ACTIONS(2918),
    [anon_sym_LT_AT_AT] = ACTIONS(2918),
    [anon_sym_DOT] = ACTIONS(2918),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2920),
    [anon_sym_new] = ACTIONS(2918),
    [anon_sym_return_BANG] = ACTIONS(2920),
    [anon_sym_yield] = ACTIONS(2918),
    [anon_sym_yield_BANG] = ACTIONS(2920),
    [anon_sym_lazy] = ACTIONS(2918),
    [anon_sym_assert] = ACTIONS(2918),
    [anon_sym_upcast] = ACTIONS(2918),
    [anon_sym_downcast] = ACTIONS(2918),
    [anon_sym_COLON_GT] = ACTIONS(2920),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2920),
    [anon_sym_for] = ACTIONS(2918),
    [anon_sym_while] = ACTIONS(2918),
    [anon_sym_if] = ACTIONS(2918),
    [anon_sym_fun] = ACTIONS(2918),
    [anon_sym_try] = ACTIONS(2918),
    [anon_sym_match] = ACTIONS(2918),
    [anon_sym_match_BANG] = ACTIONS(2920),
    [anon_sym_function] = ACTIONS(2918),
    [anon_sym_LT_DASH] = ACTIONS(2918),
    [anon_sym_DOT_LBRACK] = ACTIONS(2920),
    [anon_sym_LT] = ACTIONS(2920),
    [anon_sym_use] = ACTIONS(2918),
    [anon_sym_use_BANG] = ACTIONS(2920),
    [anon_sym_do_BANG] = ACTIONS(2920),
    [anon_sym_begin] = ACTIONS(2918),
    [anon_sym_LPAREN2] = ACTIONS(2918),
    [anon_sym_or] = ACTIONS(2918),
    [aux_sym_char_token1] = ACTIONS(2920),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2918),
    [anon_sym_DQUOTE] = ACTIONS(2918),
    [anon_sym_AT_DQUOTE] = ACTIONS(2920),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2920),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2920),
    [sym_bool] = ACTIONS(2918),
    [sym_unit] = ACTIONS(2920),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2918),
    [sym_op_identifier] = ACTIONS(2918),
    [anon_sym_PLUS] = ACTIONS(2918),
    [anon_sym_DASH] = ACTIONS(2918),
    [anon_sym_PLUS_DOT] = ACTIONS(2918),
    [anon_sym_DASH_DOT] = ACTIONS(2918),
    [anon_sym_PERCENT] = ACTIONS(2918),
    [anon_sym_AMP_AMP] = ACTIONS(2918),
    [anon_sym_TILDE] = ACTIONS(2920),
    [aux_sym_prefix_op_token1] = ACTIONS(2918),
    [aux_sym_infix_op_token1] = ACTIONS(2920),
    [aux_sym_infix_op_token2] = ACTIONS(2918),
    [anon_sym_PIPE_PIPE] = ACTIONS(2918),
    [anon_sym_BANG_EQ] = ACTIONS(2918),
    [anon_sym_COLON_EQ] = ACTIONS(2920),
    [anon_sym_DOLLAR] = ACTIONS(2918),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2918),
    [sym_int] = ACTIONS(2918),
    [sym_xint] = ACTIONS(2920),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2920),
    [anon_sym_POUNDendif] = ACTIONS(2920),
    [sym__newline] = ACTIONS(2920),
  },
  [2405] = {
    [sym_block_comment] = STATE(2405),
    [sym_compiler_directive_decl] = STATE(2405),
    [sym_fsi_directive_decl] = STATE(2405),
    [sym_preproc_line] = STATE(2405),
    [sym_identifier] = ACTIONS(2839),
    [anon_sym_EQ] = ACTIONS(2841),
    [anon_sym_COLON] = ACTIONS(2839),
    [anon_sym_return] = ACTIONS(2839),
    [anon_sym_do] = ACTIONS(2839),
    [anon_sym_let] = ACTIONS(2839),
    [anon_sym_let_BANG] = ACTIONS(2841),
    [anon_sym_LPAREN] = ACTIONS(2839),
    [anon_sym_COMMA] = ACTIONS(2841),
    [anon_sym_null] = ACTIONS(2839),
    [anon_sym_QMARK] = ACTIONS(2839),
    [anon_sym_COLON_QMARK] = ACTIONS(2839),
    [anon_sym_COLON_COLON] = ACTIONS(2841),
    [anon_sym_AMP] = ACTIONS(2839),
    [anon_sym_LBRACK] = ACTIONS(2839),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2841),
    [anon_sym_LBRACE] = ACTIONS(2839),
    [anon_sym_LT_AT] = ACTIONS(2839),
    [anon_sym_LT_AT_AT] = ACTIONS(2839),
    [anon_sym_DOT] = ACTIONS(2839),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2841),
    [anon_sym_new] = ACTIONS(2839),
    [anon_sym_return_BANG] = ACTIONS(2841),
    [anon_sym_yield] = ACTIONS(2839),
    [anon_sym_yield_BANG] = ACTIONS(2841),
    [anon_sym_lazy] = ACTIONS(2839),
    [anon_sym_assert] = ACTIONS(2839),
    [anon_sym_upcast] = ACTIONS(2839),
    [anon_sym_downcast] = ACTIONS(2839),
    [anon_sym_COLON_GT] = ACTIONS(2841),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2841),
    [anon_sym_for] = ACTIONS(2839),
    [anon_sym_while] = ACTIONS(2839),
    [anon_sym_if] = ACTIONS(2839),
    [anon_sym_fun] = ACTIONS(2839),
    [anon_sym_try] = ACTIONS(2839),
    [anon_sym_match] = ACTIONS(2839),
    [anon_sym_match_BANG] = ACTIONS(2841),
    [anon_sym_function] = ACTIONS(2839),
    [anon_sym_LT_DASH] = ACTIONS(2839),
    [anon_sym_DOT_LBRACK] = ACTIONS(2841),
    [anon_sym_LT] = ACTIONS(2841),
    [anon_sym_use] = ACTIONS(2839),
    [anon_sym_use_BANG] = ACTIONS(2841),
    [anon_sym_do_BANG] = ACTIONS(2841),
    [anon_sym_begin] = ACTIONS(2839),
    [anon_sym_LPAREN2] = ACTIONS(2839),
    [anon_sym_or] = ACTIONS(2839),
    [aux_sym_char_token1] = ACTIONS(2841),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2839),
    [anon_sym_DQUOTE] = ACTIONS(2839),
    [anon_sym_AT_DQUOTE] = ACTIONS(2841),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2841),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2841),
    [sym_bool] = ACTIONS(2839),
    [sym_unit] = ACTIONS(2841),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2839),
    [sym_op_identifier] = ACTIONS(2839),
    [anon_sym_PLUS] = ACTIONS(2839),
    [anon_sym_DASH] = ACTIONS(2839),
    [anon_sym_PLUS_DOT] = ACTIONS(2839),
    [anon_sym_DASH_DOT] = ACTIONS(2839),
    [anon_sym_PERCENT] = ACTIONS(2839),
    [anon_sym_AMP_AMP] = ACTIONS(2839),
    [anon_sym_TILDE] = ACTIONS(2841),
    [aux_sym_prefix_op_token1] = ACTIONS(2839),
    [aux_sym_infix_op_token1] = ACTIONS(2841),
    [aux_sym_infix_op_token2] = ACTIONS(2839),
    [anon_sym_PIPE_PIPE] = ACTIONS(2839),
    [anon_sym_BANG_EQ] = ACTIONS(2839),
    [anon_sym_COLON_EQ] = ACTIONS(2841),
    [anon_sym_DOLLAR] = ACTIONS(2839),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2839),
    [sym_int] = ACTIONS(2839),
    [sym_xint] = ACTIONS(2841),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2841),
    [anon_sym_POUNDendif] = ACTIONS(2841),
    [sym__newline] = ACTIONS(2841),
  },
  [2406] = {
    [sym_block_comment] = STATE(2406),
    [sym_compiler_directive_decl] = STATE(2406),
    [sym_fsi_directive_decl] = STATE(2406),
    [sym_preproc_line] = STATE(2406),
    [sym_identifier] = ACTIONS(2914),
    [anon_sym_EQ] = ACTIONS(2916),
    [anon_sym_COLON] = ACTIONS(2914),
    [anon_sym_return] = ACTIONS(2914),
    [anon_sym_do] = ACTIONS(2914),
    [anon_sym_let] = ACTIONS(2914),
    [anon_sym_let_BANG] = ACTIONS(2916),
    [anon_sym_LPAREN] = ACTIONS(2914),
    [anon_sym_COMMA] = ACTIONS(2916),
    [anon_sym_null] = ACTIONS(2914),
    [anon_sym_QMARK] = ACTIONS(2914),
    [anon_sym_COLON_QMARK] = ACTIONS(2914),
    [anon_sym_COLON_COLON] = ACTIONS(2916),
    [anon_sym_AMP] = ACTIONS(2914),
    [anon_sym_LBRACK] = ACTIONS(2914),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2916),
    [anon_sym_LBRACE] = ACTIONS(2914),
    [anon_sym_LT_AT] = ACTIONS(2914),
    [anon_sym_LT_AT_AT] = ACTIONS(2914),
    [anon_sym_DOT] = ACTIONS(2914),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2916),
    [anon_sym_new] = ACTIONS(2914),
    [anon_sym_return_BANG] = ACTIONS(2916),
    [anon_sym_yield] = ACTIONS(2914),
    [anon_sym_yield_BANG] = ACTIONS(2916),
    [anon_sym_lazy] = ACTIONS(2914),
    [anon_sym_assert] = ACTIONS(2914),
    [anon_sym_upcast] = ACTIONS(2914),
    [anon_sym_downcast] = ACTIONS(2914),
    [anon_sym_COLON_GT] = ACTIONS(2916),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2916),
    [anon_sym_for] = ACTIONS(2914),
    [anon_sym_while] = ACTIONS(2914),
    [anon_sym_if] = ACTIONS(2914),
    [anon_sym_fun] = ACTIONS(2914),
    [anon_sym_try] = ACTIONS(2914),
    [anon_sym_match] = ACTIONS(2914),
    [anon_sym_match_BANG] = ACTIONS(2916),
    [anon_sym_function] = ACTIONS(2914),
    [anon_sym_LT_DASH] = ACTIONS(2914),
    [anon_sym_DOT_LBRACK] = ACTIONS(2916),
    [anon_sym_LT] = ACTIONS(2916),
    [anon_sym_use] = ACTIONS(2914),
    [anon_sym_use_BANG] = ACTIONS(2916),
    [anon_sym_do_BANG] = ACTIONS(2916),
    [anon_sym_begin] = ACTIONS(2914),
    [anon_sym_LPAREN2] = ACTIONS(2914),
    [anon_sym_or] = ACTIONS(2914),
    [aux_sym_char_token1] = ACTIONS(2916),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2914),
    [anon_sym_DQUOTE] = ACTIONS(2914),
    [anon_sym_AT_DQUOTE] = ACTIONS(2916),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2916),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2916),
    [sym_bool] = ACTIONS(2914),
    [sym_unit] = ACTIONS(2916),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2914),
    [sym_op_identifier] = ACTIONS(2914),
    [anon_sym_PLUS] = ACTIONS(2914),
    [anon_sym_DASH] = ACTIONS(2914),
    [anon_sym_PLUS_DOT] = ACTIONS(2914),
    [anon_sym_DASH_DOT] = ACTIONS(2914),
    [anon_sym_PERCENT] = ACTIONS(2914),
    [anon_sym_AMP_AMP] = ACTIONS(2914),
    [anon_sym_TILDE] = ACTIONS(2916),
    [aux_sym_prefix_op_token1] = ACTIONS(2914),
    [aux_sym_infix_op_token1] = ACTIONS(2916),
    [aux_sym_infix_op_token2] = ACTIONS(2914),
    [anon_sym_PIPE_PIPE] = ACTIONS(2914),
    [anon_sym_BANG_EQ] = ACTIONS(2914),
    [anon_sym_COLON_EQ] = ACTIONS(2916),
    [anon_sym_DOLLAR] = ACTIONS(2914),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2914),
    [sym_int] = ACTIONS(2914),
    [sym_xint] = ACTIONS(2916),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2916),
    [anon_sym_POUNDendif] = ACTIONS(2916),
    [sym__newline] = ACTIONS(2916),
  },
  [2407] = {
    [sym_block_comment] = STATE(2407),
    [sym_compiler_directive_decl] = STATE(2407),
    [sym_fsi_directive_decl] = STATE(2407),
    [sym_preproc_line] = STATE(2407),
    [sym_identifier] = ACTIONS(2910),
    [anon_sym_EQ] = ACTIONS(2912),
    [anon_sym_COLON] = ACTIONS(2910),
    [anon_sym_return] = ACTIONS(2910),
    [anon_sym_do] = ACTIONS(2910),
    [anon_sym_let] = ACTIONS(2910),
    [anon_sym_let_BANG] = ACTIONS(2912),
    [anon_sym_LPAREN] = ACTIONS(2910),
    [anon_sym_COMMA] = ACTIONS(2912),
    [anon_sym_null] = ACTIONS(2910),
    [anon_sym_QMARK] = ACTIONS(2910),
    [anon_sym_COLON_QMARK] = ACTIONS(2910),
    [anon_sym_COLON_COLON] = ACTIONS(2912),
    [anon_sym_AMP] = ACTIONS(2910),
    [anon_sym_LBRACK] = ACTIONS(2910),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2912),
    [anon_sym_LBRACE] = ACTIONS(2910),
    [anon_sym_LT_AT] = ACTIONS(2910),
    [anon_sym_LT_AT_AT] = ACTIONS(2910),
    [anon_sym_DOT] = ACTIONS(2910),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2912),
    [anon_sym_new] = ACTIONS(2910),
    [anon_sym_return_BANG] = ACTIONS(2912),
    [anon_sym_yield] = ACTIONS(2910),
    [anon_sym_yield_BANG] = ACTIONS(2912),
    [anon_sym_lazy] = ACTIONS(2910),
    [anon_sym_assert] = ACTIONS(2910),
    [anon_sym_upcast] = ACTIONS(2910),
    [anon_sym_downcast] = ACTIONS(2910),
    [anon_sym_COLON_GT] = ACTIONS(2912),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2912),
    [anon_sym_for] = ACTIONS(2910),
    [anon_sym_while] = ACTIONS(2910),
    [anon_sym_if] = ACTIONS(2910),
    [anon_sym_fun] = ACTIONS(2910),
    [anon_sym_try] = ACTIONS(2910),
    [anon_sym_match] = ACTIONS(2910),
    [anon_sym_match_BANG] = ACTIONS(2912),
    [anon_sym_function] = ACTIONS(2910),
    [anon_sym_LT_DASH] = ACTIONS(2910),
    [anon_sym_DOT_LBRACK] = ACTIONS(2912),
    [anon_sym_LT] = ACTIONS(2912),
    [anon_sym_use] = ACTIONS(2910),
    [anon_sym_use_BANG] = ACTIONS(2912),
    [anon_sym_do_BANG] = ACTIONS(2912),
    [anon_sym_begin] = ACTIONS(2910),
    [anon_sym_LPAREN2] = ACTIONS(2910),
    [anon_sym_or] = ACTIONS(2910),
    [aux_sym_char_token1] = ACTIONS(2912),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2910),
    [anon_sym_DQUOTE] = ACTIONS(2910),
    [anon_sym_AT_DQUOTE] = ACTIONS(2912),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2912),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2912),
    [sym_bool] = ACTIONS(2910),
    [sym_unit] = ACTIONS(2912),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2910),
    [sym_op_identifier] = ACTIONS(2910),
    [anon_sym_PLUS] = ACTIONS(2910),
    [anon_sym_DASH] = ACTIONS(2910),
    [anon_sym_PLUS_DOT] = ACTIONS(2910),
    [anon_sym_DASH_DOT] = ACTIONS(2910),
    [anon_sym_PERCENT] = ACTIONS(2910),
    [anon_sym_AMP_AMP] = ACTIONS(2910),
    [anon_sym_TILDE] = ACTIONS(2912),
    [aux_sym_prefix_op_token1] = ACTIONS(2910),
    [aux_sym_infix_op_token1] = ACTIONS(2912),
    [aux_sym_infix_op_token2] = ACTIONS(2910),
    [anon_sym_PIPE_PIPE] = ACTIONS(2910),
    [anon_sym_BANG_EQ] = ACTIONS(2910),
    [anon_sym_COLON_EQ] = ACTIONS(2912),
    [anon_sym_DOLLAR] = ACTIONS(2910),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2910),
    [sym_int] = ACTIONS(2910),
    [sym_xint] = ACTIONS(2912),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2912),
    [anon_sym_POUNDendif] = ACTIONS(2912),
    [sym__newline] = ACTIONS(2912),
  },
  [2408] = {
    [sym_block_comment] = STATE(2408),
    [sym_compiler_directive_decl] = STATE(2408),
    [sym_fsi_directive_decl] = STATE(2408),
    [sym_preproc_line] = STATE(2408),
    [sym_identifier] = ACTIONS(2859),
    [anon_sym_EQ] = ACTIONS(2861),
    [anon_sym_COLON] = ACTIONS(2859),
    [anon_sym_return] = ACTIONS(2859),
    [anon_sym_do] = ACTIONS(2859),
    [anon_sym_let] = ACTIONS(2859),
    [anon_sym_let_BANG] = ACTIONS(2861),
    [anon_sym_LPAREN] = ACTIONS(2859),
    [anon_sym_COMMA] = ACTIONS(2861),
    [anon_sym_null] = ACTIONS(2859),
    [anon_sym_QMARK] = ACTIONS(2859),
    [anon_sym_COLON_QMARK] = ACTIONS(2859),
    [anon_sym_COLON_COLON] = ACTIONS(2861),
    [anon_sym_AMP] = ACTIONS(2859),
    [anon_sym_LBRACK] = ACTIONS(2859),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2861),
    [anon_sym_LBRACE] = ACTIONS(2859),
    [anon_sym_LT_AT] = ACTIONS(2859),
    [anon_sym_AT_GT] = ACTIONS(2859),
    [anon_sym_LT_AT_AT] = ACTIONS(2859),
    [anon_sym_DOT] = ACTIONS(2859),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2861),
    [anon_sym_new] = ACTIONS(2859),
    [anon_sym_return_BANG] = ACTIONS(2861),
    [anon_sym_yield] = ACTIONS(2859),
    [anon_sym_yield_BANG] = ACTIONS(2861),
    [anon_sym_lazy] = ACTIONS(2859),
    [anon_sym_assert] = ACTIONS(2859),
    [anon_sym_upcast] = ACTIONS(2859),
    [anon_sym_downcast] = ACTIONS(2859),
    [anon_sym_COLON_GT] = ACTIONS(2861),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2861),
    [anon_sym_for] = ACTIONS(2859),
    [anon_sym_while] = ACTIONS(2859),
    [anon_sym_if] = ACTIONS(2859),
    [anon_sym_fun] = ACTIONS(2859),
    [anon_sym_try] = ACTIONS(2859),
    [anon_sym_match] = ACTIONS(2859),
    [anon_sym_match_BANG] = ACTIONS(2861),
    [anon_sym_function] = ACTIONS(2859),
    [anon_sym_LT_DASH] = ACTIONS(2859),
    [anon_sym_DOT_LBRACK] = ACTIONS(2861),
    [anon_sym_LT] = ACTIONS(2861),
    [anon_sym_use] = ACTIONS(2859),
    [anon_sym_use_BANG] = ACTIONS(2861),
    [anon_sym_do_BANG] = ACTIONS(2861),
    [anon_sym_begin] = ACTIONS(2859),
    [anon_sym_LPAREN2] = ACTIONS(2859),
    [anon_sym_or] = ACTIONS(2859),
    [aux_sym_char_token1] = ACTIONS(2861),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2859),
    [anon_sym_DQUOTE] = ACTIONS(2859),
    [anon_sym_AT_DQUOTE] = ACTIONS(2861),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2861),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2861),
    [sym_bool] = ACTIONS(2859),
    [sym_unit] = ACTIONS(2861),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2859),
    [sym_op_identifier] = ACTIONS(2859),
    [anon_sym_PLUS] = ACTIONS(2859),
    [anon_sym_DASH] = ACTIONS(2859),
    [anon_sym_PLUS_DOT] = ACTIONS(2859),
    [anon_sym_DASH_DOT] = ACTIONS(2859),
    [anon_sym_PERCENT] = ACTIONS(2859),
    [anon_sym_AMP_AMP] = ACTIONS(2859),
    [anon_sym_TILDE] = ACTIONS(2861),
    [aux_sym_prefix_op_token1] = ACTIONS(2859),
    [aux_sym_infix_op_token1] = ACTIONS(2861),
    [aux_sym_infix_op_token2] = ACTIONS(2859),
    [anon_sym_PIPE_PIPE] = ACTIONS(2859),
    [anon_sym_BANG_EQ] = ACTIONS(2859),
    [anon_sym_COLON_EQ] = ACTIONS(2861),
    [anon_sym_DOLLAR] = ACTIONS(2859),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2859),
    [sym_int] = ACTIONS(2859),
    [sym_xint] = ACTIONS(2861),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2861),
    [sym__newline] = ACTIONS(2861),
  },
  [2409] = {
    [sym_block_comment] = STATE(2409),
    [sym_compiler_directive_decl] = STATE(2409),
    [sym_fsi_directive_decl] = STATE(2409),
    [sym_preproc_line] = STATE(2409),
    [sym_identifier] = ACTIONS(2891),
    [anon_sym_EQ] = ACTIONS(2893),
    [anon_sym_COLON] = ACTIONS(2891),
    [anon_sym_return] = ACTIONS(2891),
    [anon_sym_do] = ACTIONS(2891),
    [anon_sym_let] = ACTIONS(2891),
    [anon_sym_let_BANG] = ACTIONS(2893),
    [anon_sym_LPAREN] = ACTIONS(2891),
    [anon_sym_COMMA] = ACTIONS(2893),
    [anon_sym_null] = ACTIONS(2891),
    [anon_sym_QMARK] = ACTIONS(2891),
    [anon_sym_COLON_QMARK] = ACTIONS(2891),
    [anon_sym_COLON_COLON] = ACTIONS(2893),
    [anon_sym_AMP] = ACTIONS(2891),
    [anon_sym_LBRACK] = ACTIONS(2891),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2893),
    [anon_sym_LBRACE] = ACTIONS(2891),
    [anon_sym_LT_AT] = ACTIONS(2891),
    [anon_sym_LT_AT_AT] = ACTIONS(2891),
    [anon_sym_DOT] = ACTIONS(2891),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2893),
    [anon_sym_new] = ACTIONS(2891),
    [anon_sym_return_BANG] = ACTIONS(2893),
    [anon_sym_yield] = ACTIONS(2891),
    [anon_sym_yield_BANG] = ACTIONS(2893),
    [anon_sym_lazy] = ACTIONS(2891),
    [anon_sym_assert] = ACTIONS(2891),
    [anon_sym_upcast] = ACTIONS(2891),
    [anon_sym_downcast] = ACTIONS(2891),
    [anon_sym_COLON_GT] = ACTIONS(2893),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2893),
    [anon_sym_for] = ACTIONS(2891),
    [anon_sym_while] = ACTIONS(2891),
    [anon_sym_if] = ACTIONS(2891),
    [anon_sym_fun] = ACTIONS(2891),
    [anon_sym_try] = ACTIONS(2891),
    [anon_sym_match] = ACTIONS(2891),
    [anon_sym_match_BANG] = ACTIONS(2893),
    [anon_sym_function] = ACTIONS(2891),
    [anon_sym_LT_DASH] = ACTIONS(2891),
    [anon_sym_DOT_LBRACK] = ACTIONS(2893),
    [anon_sym_LT] = ACTIONS(2893),
    [anon_sym_use] = ACTIONS(2891),
    [anon_sym_use_BANG] = ACTIONS(2893),
    [anon_sym_do_BANG] = ACTIONS(2893),
    [anon_sym_begin] = ACTIONS(2891),
    [anon_sym_LPAREN2] = ACTIONS(2891),
    [anon_sym_or] = ACTIONS(2891),
    [aux_sym_char_token1] = ACTIONS(2893),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2891),
    [anon_sym_DQUOTE] = ACTIONS(2891),
    [anon_sym_AT_DQUOTE] = ACTIONS(2893),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2893),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2893),
    [sym_bool] = ACTIONS(2891),
    [sym_unit] = ACTIONS(2893),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2891),
    [sym_op_identifier] = ACTIONS(2891),
    [anon_sym_PLUS] = ACTIONS(2891),
    [anon_sym_DASH] = ACTIONS(2891),
    [anon_sym_PLUS_DOT] = ACTIONS(2891),
    [anon_sym_DASH_DOT] = ACTIONS(2891),
    [anon_sym_PERCENT] = ACTIONS(2891),
    [anon_sym_AMP_AMP] = ACTIONS(2891),
    [anon_sym_TILDE] = ACTIONS(2893),
    [aux_sym_prefix_op_token1] = ACTIONS(2891),
    [aux_sym_infix_op_token1] = ACTIONS(2893),
    [aux_sym_infix_op_token2] = ACTIONS(2891),
    [anon_sym_PIPE_PIPE] = ACTIONS(2891),
    [anon_sym_BANG_EQ] = ACTIONS(2891),
    [anon_sym_COLON_EQ] = ACTIONS(2893),
    [anon_sym_DOLLAR] = ACTIONS(2891),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2891),
    [sym_int] = ACTIONS(2891),
    [sym_xint] = ACTIONS(2893),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2893),
    [anon_sym_POUNDendif] = ACTIONS(2893),
    [sym__newline] = ACTIONS(2893),
  },
  [2410] = {
    [sym_block_comment] = STATE(2410),
    [sym_compiler_directive_decl] = STATE(2410),
    [sym_fsi_directive_decl] = STATE(2410),
    [sym_preproc_line] = STATE(2410),
    [sym_identifier] = ACTIONS(2887),
    [anon_sym_EQ] = ACTIONS(2889),
    [anon_sym_COLON] = ACTIONS(2887),
    [anon_sym_return] = ACTIONS(2887),
    [anon_sym_do] = ACTIONS(2887),
    [anon_sym_let] = ACTIONS(2887),
    [anon_sym_let_BANG] = ACTIONS(2889),
    [anon_sym_LPAREN] = ACTIONS(2887),
    [anon_sym_COMMA] = ACTIONS(2889),
    [anon_sym_null] = ACTIONS(2887),
    [anon_sym_QMARK] = ACTIONS(2887),
    [anon_sym_COLON_QMARK] = ACTIONS(2887),
    [anon_sym_COLON_COLON] = ACTIONS(2889),
    [anon_sym_AMP] = ACTIONS(2887),
    [anon_sym_LBRACK] = ACTIONS(2887),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2889),
    [anon_sym_LBRACE] = ACTIONS(2887),
    [anon_sym_LT_AT] = ACTIONS(2887),
    [anon_sym_LT_AT_AT] = ACTIONS(2887),
    [anon_sym_DOT] = ACTIONS(2887),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2889),
    [anon_sym_new] = ACTIONS(2887),
    [anon_sym_return_BANG] = ACTIONS(2889),
    [anon_sym_yield] = ACTIONS(2887),
    [anon_sym_yield_BANG] = ACTIONS(2889),
    [anon_sym_lazy] = ACTIONS(2887),
    [anon_sym_assert] = ACTIONS(2887),
    [anon_sym_upcast] = ACTIONS(2887),
    [anon_sym_downcast] = ACTIONS(2887),
    [anon_sym_COLON_GT] = ACTIONS(2889),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2889),
    [anon_sym_for] = ACTIONS(2887),
    [anon_sym_while] = ACTIONS(2887),
    [anon_sym_if] = ACTIONS(2887),
    [anon_sym_fun] = ACTIONS(2887),
    [anon_sym_try] = ACTIONS(2887),
    [anon_sym_match] = ACTIONS(2887),
    [anon_sym_match_BANG] = ACTIONS(2889),
    [anon_sym_function] = ACTIONS(2887),
    [anon_sym_LT_DASH] = ACTIONS(2887),
    [anon_sym_DOT_LBRACK] = ACTIONS(2889),
    [anon_sym_LT] = ACTIONS(2889),
    [anon_sym_use] = ACTIONS(2887),
    [anon_sym_use_BANG] = ACTIONS(2889),
    [anon_sym_do_BANG] = ACTIONS(2889),
    [anon_sym_begin] = ACTIONS(2887),
    [anon_sym_LPAREN2] = ACTIONS(2887),
    [anon_sym_or] = ACTIONS(2887),
    [aux_sym_char_token1] = ACTIONS(2889),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2887),
    [anon_sym_DQUOTE] = ACTIONS(2887),
    [anon_sym_AT_DQUOTE] = ACTIONS(2889),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2889),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2889),
    [sym_bool] = ACTIONS(2887),
    [sym_unit] = ACTIONS(2889),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2887),
    [sym_op_identifier] = ACTIONS(2887),
    [anon_sym_PLUS] = ACTIONS(2887),
    [anon_sym_DASH] = ACTIONS(2887),
    [anon_sym_PLUS_DOT] = ACTIONS(2887),
    [anon_sym_DASH_DOT] = ACTIONS(2887),
    [anon_sym_PERCENT] = ACTIONS(2887),
    [anon_sym_AMP_AMP] = ACTIONS(2887),
    [anon_sym_TILDE] = ACTIONS(2889),
    [aux_sym_prefix_op_token1] = ACTIONS(2887),
    [aux_sym_infix_op_token1] = ACTIONS(2889),
    [aux_sym_infix_op_token2] = ACTIONS(2887),
    [anon_sym_PIPE_PIPE] = ACTIONS(2887),
    [anon_sym_BANG_EQ] = ACTIONS(2887),
    [anon_sym_COLON_EQ] = ACTIONS(2889),
    [anon_sym_DOLLAR] = ACTIONS(2887),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2887),
    [sym_int] = ACTIONS(2887),
    [sym_xint] = ACTIONS(2889),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2889),
    [anon_sym_POUNDendif] = ACTIONS(2889),
    [sym__newline] = ACTIONS(2889),
  },
  [2411] = {
    [sym_block_comment] = STATE(2411),
    [sym_compiler_directive_decl] = STATE(2411),
    [sym_fsi_directive_decl] = STATE(2411),
    [sym_preproc_line] = STATE(2411),
    [sym_identifier] = ACTIONS(2883),
    [anon_sym_EQ] = ACTIONS(2885),
    [anon_sym_COLON] = ACTIONS(2883),
    [anon_sym_return] = ACTIONS(2883),
    [anon_sym_do] = ACTIONS(2883),
    [anon_sym_let] = ACTIONS(2883),
    [anon_sym_let_BANG] = ACTIONS(2885),
    [anon_sym_LPAREN] = ACTIONS(2883),
    [anon_sym_COMMA] = ACTIONS(2885),
    [anon_sym_null] = ACTIONS(2883),
    [anon_sym_QMARK] = ACTIONS(2883),
    [anon_sym_COLON_QMARK] = ACTIONS(2883),
    [anon_sym_COLON_COLON] = ACTIONS(2885),
    [anon_sym_AMP] = ACTIONS(2883),
    [anon_sym_LBRACK] = ACTIONS(2883),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2885),
    [anon_sym_LBRACE] = ACTIONS(2883),
    [anon_sym_LT_AT] = ACTIONS(2883),
    [anon_sym_LT_AT_AT] = ACTIONS(2883),
    [anon_sym_DOT] = ACTIONS(2883),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2885),
    [anon_sym_new] = ACTIONS(2883),
    [anon_sym_return_BANG] = ACTIONS(2885),
    [anon_sym_yield] = ACTIONS(2883),
    [anon_sym_yield_BANG] = ACTIONS(2885),
    [anon_sym_lazy] = ACTIONS(2883),
    [anon_sym_assert] = ACTIONS(2883),
    [anon_sym_upcast] = ACTIONS(2883),
    [anon_sym_downcast] = ACTIONS(2883),
    [anon_sym_COLON_GT] = ACTIONS(2885),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2885),
    [anon_sym_for] = ACTIONS(2883),
    [anon_sym_while] = ACTIONS(2883),
    [anon_sym_if] = ACTIONS(2883),
    [anon_sym_fun] = ACTIONS(2883),
    [anon_sym_try] = ACTIONS(2883),
    [anon_sym_match] = ACTIONS(2883),
    [anon_sym_match_BANG] = ACTIONS(2885),
    [anon_sym_function] = ACTIONS(2883),
    [anon_sym_LT_DASH] = ACTIONS(2883),
    [anon_sym_DOT_LBRACK] = ACTIONS(2885),
    [anon_sym_LT] = ACTIONS(2885),
    [anon_sym_use] = ACTIONS(2883),
    [anon_sym_use_BANG] = ACTIONS(2885),
    [anon_sym_do_BANG] = ACTIONS(2885),
    [anon_sym_begin] = ACTIONS(2883),
    [anon_sym_LPAREN2] = ACTIONS(2883),
    [anon_sym_or] = ACTIONS(2883),
    [aux_sym_char_token1] = ACTIONS(2885),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2883),
    [anon_sym_DQUOTE] = ACTIONS(2883),
    [anon_sym_AT_DQUOTE] = ACTIONS(2885),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2885),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2885),
    [sym_bool] = ACTIONS(2883),
    [sym_unit] = ACTIONS(2885),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2883),
    [sym_op_identifier] = ACTIONS(2883),
    [anon_sym_PLUS] = ACTIONS(2883),
    [anon_sym_DASH] = ACTIONS(2883),
    [anon_sym_PLUS_DOT] = ACTIONS(2883),
    [anon_sym_DASH_DOT] = ACTIONS(2883),
    [anon_sym_PERCENT] = ACTIONS(2883),
    [anon_sym_AMP_AMP] = ACTIONS(2883),
    [anon_sym_TILDE] = ACTIONS(2885),
    [aux_sym_prefix_op_token1] = ACTIONS(2883),
    [aux_sym_infix_op_token1] = ACTIONS(2885),
    [aux_sym_infix_op_token2] = ACTIONS(2883),
    [anon_sym_PIPE_PIPE] = ACTIONS(2883),
    [anon_sym_BANG_EQ] = ACTIONS(2883),
    [anon_sym_COLON_EQ] = ACTIONS(2885),
    [anon_sym_DOLLAR] = ACTIONS(2883),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2883),
    [sym_int] = ACTIONS(2883),
    [sym_xint] = ACTIONS(2885),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2885),
    [anon_sym_POUNDendif] = ACTIONS(2885),
    [sym__newline] = ACTIONS(2885),
  },
  [2412] = {
    [sym_block_comment] = STATE(2412),
    [sym_compiler_directive_decl] = STATE(2412),
    [sym_fsi_directive_decl] = STATE(2412),
    [sym_preproc_line] = STATE(2412),
    [sym_identifier] = ACTIONS(2855),
    [anon_sym_EQ] = ACTIONS(2857),
    [anon_sym_COLON] = ACTIONS(2855),
    [anon_sym_return] = ACTIONS(2855),
    [anon_sym_do] = ACTIONS(2855),
    [anon_sym_let] = ACTIONS(2855),
    [anon_sym_let_BANG] = ACTIONS(2857),
    [anon_sym_LPAREN] = ACTIONS(2855),
    [anon_sym_COMMA] = ACTIONS(2857),
    [anon_sym_null] = ACTIONS(2855),
    [anon_sym_QMARK] = ACTIONS(2855),
    [anon_sym_COLON_QMARK] = ACTIONS(2855),
    [anon_sym_COLON_COLON] = ACTIONS(2857),
    [anon_sym_AMP] = ACTIONS(2855),
    [anon_sym_LBRACK] = ACTIONS(2855),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2857),
    [anon_sym_LBRACE] = ACTIONS(2855),
    [anon_sym_LT_AT] = ACTIONS(2855),
    [anon_sym_AT_GT] = ACTIONS(2855),
    [anon_sym_LT_AT_AT] = ACTIONS(2855),
    [anon_sym_DOT] = ACTIONS(2855),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2857),
    [anon_sym_new] = ACTIONS(2855),
    [anon_sym_return_BANG] = ACTIONS(2857),
    [anon_sym_yield] = ACTIONS(2855),
    [anon_sym_yield_BANG] = ACTIONS(2857),
    [anon_sym_lazy] = ACTIONS(2855),
    [anon_sym_assert] = ACTIONS(2855),
    [anon_sym_upcast] = ACTIONS(2855),
    [anon_sym_downcast] = ACTIONS(2855),
    [anon_sym_COLON_GT] = ACTIONS(2857),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2857),
    [anon_sym_for] = ACTIONS(2855),
    [anon_sym_while] = ACTIONS(2855),
    [anon_sym_if] = ACTIONS(2855),
    [anon_sym_fun] = ACTIONS(2855),
    [anon_sym_try] = ACTIONS(2855),
    [anon_sym_match] = ACTIONS(2855),
    [anon_sym_match_BANG] = ACTIONS(2857),
    [anon_sym_function] = ACTIONS(2855),
    [anon_sym_LT_DASH] = ACTIONS(2855),
    [anon_sym_DOT_LBRACK] = ACTIONS(2857),
    [anon_sym_LT] = ACTIONS(2857),
    [anon_sym_use] = ACTIONS(2855),
    [anon_sym_use_BANG] = ACTIONS(2857),
    [anon_sym_do_BANG] = ACTIONS(2857),
    [anon_sym_begin] = ACTIONS(2855),
    [anon_sym_LPAREN2] = ACTIONS(2855),
    [anon_sym_or] = ACTIONS(2855),
    [aux_sym_char_token1] = ACTIONS(2857),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2855),
    [anon_sym_DQUOTE] = ACTIONS(2855),
    [anon_sym_AT_DQUOTE] = ACTIONS(2857),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2857),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2857),
    [sym_bool] = ACTIONS(2855),
    [sym_unit] = ACTIONS(2857),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2855),
    [sym_op_identifier] = ACTIONS(2855),
    [anon_sym_PLUS] = ACTIONS(2855),
    [anon_sym_DASH] = ACTIONS(2855),
    [anon_sym_PLUS_DOT] = ACTIONS(2855),
    [anon_sym_DASH_DOT] = ACTIONS(2855),
    [anon_sym_PERCENT] = ACTIONS(2855),
    [anon_sym_AMP_AMP] = ACTIONS(2855),
    [anon_sym_TILDE] = ACTIONS(2857),
    [aux_sym_prefix_op_token1] = ACTIONS(2855),
    [aux_sym_infix_op_token1] = ACTIONS(2857),
    [aux_sym_infix_op_token2] = ACTIONS(2855),
    [anon_sym_PIPE_PIPE] = ACTIONS(2855),
    [anon_sym_BANG_EQ] = ACTIONS(2855),
    [anon_sym_COLON_EQ] = ACTIONS(2857),
    [anon_sym_DOLLAR] = ACTIONS(2855),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2855),
    [sym_int] = ACTIONS(2855),
    [sym_xint] = ACTIONS(2857),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2857),
    [sym__newline] = ACTIONS(2857),
  },
  [2413] = {
    [sym_block_comment] = STATE(2413),
    [sym_compiler_directive_decl] = STATE(2413),
    [sym_fsi_directive_decl] = STATE(2413),
    [sym_preproc_line] = STATE(2413),
    [sym_identifier] = ACTIONS(3019),
    [anon_sym_EQ] = ACTIONS(3021),
    [anon_sym_COLON] = ACTIONS(3019),
    [anon_sym_return] = ACTIONS(3019),
    [anon_sym_do] = ACTIONS(3019),
    [anon_sym_let] = ACTIONS(3019),
    [anon_sym_let_BANG] = ACTIONS(3021),
    [anon_sym_LPAREN] = ACTIONS(3019),
    [anon_sym_COMMA] = ACTIONS(3021),
    [anon_sym_null] = ACTIONS(3019),
    [anon_sym_QMARK] = ACTIONS(3019),
    [anon_sym_COLON_QMARK] = ACTIONS(3019),
    [anon_sym_COLON_COLON] = ACTIONS(3021),
    [anon_sym_AMP] = ACTIONS(3019),
    [anon_sym_LBRACK] = ACTIONS(3019),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3021),
    [anon_sym_LBRACE] = ACTIONS(3019),
    [anon_sym_LT_AT] = ACTIONS(3019),
    [anon_sym_LT_AT_AT] = ACTIONS(3019),
    [anon_sym_AT_AT_GT] = ACTIONS(3019),
    [anon_sym_DOT] = ACTIONS(3019),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3021),
    [anon_sym_new] = ACTIONS(3019),
    [anon_sym_return_BANG] = ACTIONS(3021),
    [anon_sym_yield] = ACTIONS(3019),
    [anon_sym_yield_BANG] = ACTIONS(3021),
    [anon_sym_lazy] = ACTIONS(3019),
    [anon_sym_assert] = ACTIONS(3019),
    [anon_sym_upcast] = ACTIONS(3019),
    [anon_sym_downcast] = ACTIONS(3019),
    [anon_sym_COLON_GT] = ACTIONS(3021),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3021),
    [anon_sym_for] = ACTIONS(3019),
    [anon_sym_while] = ACTIONS(3019),
    [anon_sym_if] = ACTIONS(3019),
    [anon_sym_fun] = ACTIONS(3019),
    [anon_sym_try] = ACTIONS(3019),
    [anon_sym_match] = ACTIONS(3019),
    [anon_sym_match_BANG] = ACTIONS(3021),
    [anon_sym_function] = ACTIONS(3019),
    [anon_sym_LT_DASH] = ACTIONS(3019),
    [anon_sym_DOT_LBRACK] = ACTIONS(3021),
    [anon_sym_LT] = ACTIONS(3021),
    [anon_sym_use] = ACTIONS(3019),
    [anon_sym_use_BANG] = ACTIONS(3021),
    [anon_sym_do_BANG] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3019),
    [anon_sym_LPAREN2] = ACTIONS(3019),
    [anon_sym_or] = ACTIONS(3019),
    [aux_sym_char_token1] = ACTIONS(3021),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3019),
    [anon_sym_DQUOTE] = ACTIONS(3019),
    [anon_sym_AT_DQUOTE] = ACTIONS(3021),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3021),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3021),
    [sym_bool] = ACTIONS(3019),
    [sym_unit] = ACTIONS(3021),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3019),
    [sym_op_identifier] = ACTIONS(3019),
    [anon_sym_PLUS] = ACTIONS(3019),
    [anon_sym_DASH] = ACTIONS(3019),
    [anon_sym_PLUS_DOT] = ACTIONS(3019),
    [anon_sym_DASH_DOT] = ACTIONS(3019),
    [anon_sym_PERCENT] = ACTIONS(3019),
    [anon_sym_AMP_AMP] = ACTIONS(3019),
    [anon_sym_TILDE] = ACTIONS(3021),
    [aux_sym_prefix_op_token1] = ACTIONS(3019),
    [aux_sym_infix_op_token1] = ACTIONS(3021),
    [aux_sym_infix_op_token2] = ACTIONS(3019),
    [anon_sym_PIPE_PIPE] = ACTIONS(3019),
    [anon_sym_BANG_EQ] = ACTIONS(3019),
    [anon_sym_COLON_EQ] = ACTIONS(3021),
    [anon_sym_DOLLAR] = ACTIONS(3019),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3019),
    [sym_int] = ACTIONS(3019),
    [sym_xint] = ACTIONS(3021),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3021),
    [sym__newline] = ACTIONS(3021),
  },
  [2414] = {
    [sym_block_comment] = STATE(2414),
    [sym_compiler_directive_decl] = STATE(2414),
    [sym_fsi_directive_decl] = STATE(2414),
    [sym_preproc_line] = STATE(2414),
    [sym_identifier] = ACTIONS(2877),
    [anon_sym_EQ] = ACTIONS(2879),
    [anon_sym_COLON] = ACTIONS(2877),
    [anon_sym_return] = ACTIONS(2877),
    [anon_sym_do] = ACTIONS(2877),
    [anon_sym_let] = ACTIONS(2877),
    [anon_sym_let_BANG] = ACTIONS(2879),
    [anon_sym_LPAREN] = ACTIONS(2877),
    [anon_sym_COMMA] = ACTIONS(2879),
    [anon_sym_null] = ACTIONS(2877),
    [anon_sym_QMARK] = ACTIONS(2877),
    [anon_sym_COLON_QMARK] = ACTIONS(2877),
    [anon_sym_COLON_COLON] = ACTIONS(2879),
    [anon_sym_AMP] = ACTIONS(2877),
    [anon_sym_LBRACK] = ACTIONS(2877),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2879),
    [anon_sym_LBRACE] = ACTIONS(2877),
    [anon_sym_LT_AT] = ACTIONS(2877),
    [anon_sym_LT_AT_AT] = ACTIONS(2877),
    [anon_sym_DOT] = ACTIONS(2877),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2879),
    [anon_sym_new] = ACTIONS(2877),
    [anon_sym_return_BANG] = ACTIONS(2879),
    [anon_sym_yield] = ACTIONS(2877),
    [anon_sym_yield_BANG] = ACTIONS(2879),
    [anon_sym_lazy] = ACTIONS(2877),
    [anon_sym_assert] = ACTIONS(2877),
    [anon_sym_upcast] = ACTIONS(2877),
    [anon_sym_downcast] = ACTIONS(2877),
    [anon_sym_COLON_GT] = ACTIONS(2879),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2879),
    [anon_sym_for] = ACTIONS(2877),
    [anon_sym_while] = ACTIONS(2877),
    [anon_sym_if] = ACTIONS(2877),
    [anon_sym_fun] = ACTIONS(2877),
    [anon_sym_try] = ACTIONS(2877),
    [anon_sym_match] = ACTIONS(2877),
    [anon_sym_match_BANG] = ACTIONS(2879),
    [anon_sym_function] = ACTIONS(2877),
    [anon_sym_LT_DASH] = ACTIONS(2877),
    [anon_sym_DOT_LBRACK] = ACTIONS(2879),
    [anon_sym_LT] = ACTIONS(2879),
    [anon_sym_use] = ACTIONS(2877),
    [anon_sym_use_BANG] = ACTIONS(2879),
    [anon_sym_do_BANG] = ACTIONS(2879),
    [anon_sym_begin] = ACTIONS(2877),
    [anon_sym_LPAREN2] = ACTIONS(2877),
    [anon_sym_or] = ACTIONS(2877),
    [aux_sym_char_token1] = ACTIONS(2879),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2877),
    [anon_sym_DQUOTE] = ACTIONS(2877),
    [anon_sym_AT_DQUOTE] = ACTIONS(2879),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2879),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2879),
    [sym_bool] = ACTIONS(2877),
    [sym_unit] = ACTIONS(2879),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2877),
    [sym_op_identifier] = ACTIONS(2877),
    [anon_sym_PLUS] = ACTIONS(2877),
    [anon_sym_DASH] = ACTIONS(2877),
    [anon_sym_PLUS_DOT] = ACTIONS(2877),
    [anon_sym_DASH_DOT] = ACTIONS(2877),
    [anon_sym_PERCENT] = ACTIONS(2877),
    [anon_sym_AMP_AMP] = ACTIONS(2877),
    [anon_sym_TILDE] = ACTIONS(2879),
    [aux_sym_prefix_op_token1] = ACTIONS(2877),
    [aux_sym_infix_op_token1] = ACTIONS(2879),
    [aux_sym_infix_op_token2] = ACTIONS(2877),
    [anon_sym_PIPE_PIPE] = ACTIONS(2877),
    [anon_sym_BANG_EQ] = ACTIONS(2877),
    [anon_sym_COLON_EQ] = ACTIONS(2879),
    [anon_sym_DOLLAR] = ACTIONS(2877),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2877),
    [sym_int] = ACTIONS(2877),
    [sym_xint] = ACTIONS(2879),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2879),
    [anon_sym_POUNDendif] = ACTIONS(2879),
    [sym__newline] = ACTIONS(2879),
  },
  [2415] = {
    [sym_block_comment] = STATE(2415),
    [sym_compiler_directive_decl] = STATE(2415),
    [sym_fsi_directive_decl] = STATE(2415),
    [sym_preproc_line] = STATE(2415),
    [sym_identifier] = ACTIONS(2873),
    [anon_sym_EQ] = ACTIONS(2875),
    [anon_sym_COLON] = ACTIONS(2873),
    [anon_sym_return] = ACTIONS(2873),
    [anon_sym_do] = ACTIONS(2873),
    [anon_sym_let] = ACTIONS(2873),
    [anon_sym_let_BANG] = ACTIONS(2875),
    [anon_sym_LPAREN] = ACTIONS(2873),
    [anon_sym_COMMA] = ACTIONS(2875),
    [anon_sym_null] = ACTIONS(2873),
    [anon_sym_QMARK] = ACTIONS(2873),
    [anon_sym_COLON_QMARK] = ACTIONS(2873),
    [anon_sym_COLON_COLON] = ACTIONS(2875),
    [anon_sym_AMP] = ACTIONS(2873),
    [anon_sym_LBRACK] = ACTIONS(2873),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2875),
    [anon_sym_LBRACE] = ACTIONS(2873),
    [anon_sym_LT_AT] = ACTIONS(2873),
    [anon_sym_LT_AT_AT] = ACTIONS(2873),
    [anon_sym_DOT] = ACTIONS(2873),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2875),
    [anon_sym_new] = ACTIONS(2873),
    [anon_sym_return_BANG] = ACTIONS(2875),
    [anon_sym_yield] = ACTIONS(2873),
    [anon_sym_yield_BANG] = ACTIONS(2875),
    [anon_sym_lazy] = ACTIONS(2873),
    [anon_sym_assert] = ACTIONS(2873),
    [anon_sym_upcast] = ACTIONS(2873),
    [anon_sym_downcast] = ACTIONS(2873),
    [anon_sym_COLON_GT] = ACTIONS(2875),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2875),
    [anon_sym_for] = ACTIONS(2873),
    [anon_sym_while] = ACTIONS(2873),
    [anon_sym_if] = ACTIONS(2873),
    [anon_sym_fun] = ACTIONS(2873),
    [anon_sym_try] = ACTIONS(2873),
    [anon_sym_match] = ACTIONS(2873),
    [anon_sym_match_BANG] = ACTIONS(2875),
    [anon_sym_function] = ACTIONS(2873),
    [anon_sym_LT_DASH] = ACTIONS(2873),
    [anon_sym_DOT_LBRACK] = ACTIONS(2875),
    [anon_sym_LT] = ACTIONS(2875),
    [anon_sym_use] = ACTIONS(2873),
    [anon_sym_use_BANG] = ACTIONS(2875),
    [anon_sym_do_BANG] = ACTIONS(2875),
    [anon_sym_begin] = ACTIONS(2873),
    [anon_sym_LPAREN2] = ACTIONS(2873),
    [anon_sym_or] = ACTIONS(2873),
    [aux_sym_char_token1] = ACTIONS(2875),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2873),
    [anon_sym_DQUOTE] = ACTIONS(2873),
    [anon_sym_AT_DQUOTE] = ACTIONS(2875),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2875),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2875),
    [sym_bool] = ACTIONS(2873),
    [sym_unit] = ACTIONS(2875),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2873),
    [sym_op_identifier] = ACTIONS(2873),
    [anon_sym_PLUS] = ACTIONS(2873),
    [anon_sym_DASH] = ACTIONS(2873),
    [anon_sym_PLUS_DOT] = ACTIONS(2873),
    [anon_sym_DASH_DOT] = ACTIONS(2873),
    [anon_sym_PERCENT] = ACTIONS(2873),
    [anon_sym_AMP_AMP] = ACTIONS(2873),
    [anon_sym_TILDE] = ACTIONS(2875),
    [aux_sym_prefix_op_token1] = ACTIONS(2873),
    [aux_sym_infix_op_token1] = ACTIONS(2875),
    [aux_sym_infix_op_token2] = ACTIONS(2873),
    [anon_sym_PIPE_PIPE] = ACTIONS(2873),
    [anon_sym_BANG_EQ] = ACTIONS(2873),
    [anon_sym_COLON_EQ] = ACTIONS(2875),
    [anon_sym_DOLLAR] = ACTIONS(2873),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2873),
    [sym_int] = ACTIONS(2873),
    [sym_xint] = ACTIONS(2875),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2875),
    [anon_sym_POUNDendif] = ACTIONS(2875),
    [sym__newline] = ACTIONS(2875),
  },
  [2416] = {
    [sym_block_comment] = STATE(2416),
    [sym_compiler_directive_decl] = STATE(2416),
    [sym_fsi_directive_decl] = STATE(2416),
    [sym_preproc_line] = STATE(2416),
    [sym_identifier] = ACTIONS(3055),
    [anon_sym_EQ] = ACTIONS(3057),
    [anon_sym_COLON] = ACTIONS(3055),
    [anon_sym_return] = ACTIONS(3055),
    [anon_sym_do] = ACTIONS(3055),
    [anon_sym_let] = ACTIONS(3055),
    [anon_sym_let_BANG] = ACTIONS(3057),
    [anon_sym_LPAREN] = ACTIONS(3055),
    [anon_sym_COMMA] = ACTIONS(3057),
    [anon_sym_null] = ACTIONS(3055),
    [anon_sym_QMARK] = ACTIONS(3055),
    [anon_sym_COLON_QMARK] = ACTIONS(3055),
    [anon_sym_COLON_COLON] = ACTIONS(3057),
    [anon_sym_AMP] = ACTIONS(3055),
    [anon_sym_LBRACK] = ACTIONS(3055),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3057),
    [anon_sym_LBRACE] = ACTIONS(3055),
    [anon_sym_LT_AT] = ACTIONS(3055),
    [anon_sym_LT_AT_AT] = ACTIONS(3055),
    [anon_sym_DOT] = ACTIONS(3055),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3057),
    [anon_sym_new] = ACTIONS(3055),
    [anon_sym_return_BANG] = ACTIONS(3057),
    [anon_sym_yield] = ACTIONS(3055),
    [anon_sym_yield_BANG] = ACTIONS(3057),
    [anon_sym_lazy] = ACTIONS(3055),
    [anon_sym_assert] = ACTIONS(3055),
    [anon_sym_upcast] = ACTIONS(3055),
    [anon_sym_downcast] = ACTIONS(3055),
    [anon_sym_COLON_GT] = ACTIONS(3057),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3057),
    [anon_sym_for] = ACTIONS(3055),
    [anon_sym_while] = ACTIONS(3055),
    [anon_sym_if] = ACTIONS(3055),
    [anon_sym_fun] = ACTIONS(3055),
    [anon_sym_try] = ACTIONS(3055),
    [anon_sym_match] = ACTIONS(3055),
    [anon_sym_match_BANG] = ACTIONS(3057),
    [anon_sym_function] = ACTIONS(3055),
    [anon_sym_LT_DASH] = ACTIONS(3055),
    [anon_sym_DOT_LBRACK] = ACTIONS(3057),
    [anon_sym_LT] = ACTIONS(3057),
    [anon_sym_use] = ACTIONS(3055),
    [anon_sym_use_BANG] = ACTIONS(3057),
    [anon_sym_do_BANG] = ACTIONS(3057),
    [anon_sym_begin] = ACTIONS(3055),
    [anon_sym_LPAREN2] = ACTIONS(3055),
    [anon_sym_or] = ACTIONS(3055),
    [aux_sym_char_token1] = ACTIONS(3057),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3055),
    [anon_sym_DQUOTE] = ACTIONS(3055),
    [anon_sym_AT_DQUOTE] = ACTIONS(3057),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3057),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3057),
    [sym_bool] = ACTIONS(3055),
    [sym_unit] = ACTIONS(3057),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3055),
    [sym_op_identifier] = ACTIONS(3055),
    [anon_sym_PLUS] = ACTIONS(3055),
    [anon_sym_DASH] = ACTIONS(3055),
    [anon_sym_PLUS_DOT] = ACTIONS(3055),
    [anon_sym_DASH_DOT] = ACTIONS(3055),
    [anon_sym_PERCENT] = ACTIONS(3055),
    [anon_sym_AMP_AMP] = ACTIONS(3055),
    [anon_sym_TILDE] = ACTIONS(3057),
    [aux_sym_prefix_op_token1] = ACTIONS(3055),
    [aux_sym_infix_op_token1] = ACTIONS(3057),
    [aux_sym_infix_op_token2] = ACTIONS(3055),
    [anon_sym_PIPE_PIPE] = ACTIONS(3055),
    [anon_sym_BANG_EQ] = ACTIONS(3055),
    [anon_sym_COLON_EQ] = ACTIONS(3057),
    [anon_sym_DOLLAR] = ACTIONS(3055),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3055),
    [sym_int] = ACTIONS(3055),
    [sym_xint] = ACTIONS(3057),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3057),
    [anon_sym_POUNDendif] = ACTIONS(3057),
    [sym__newline] = ACTIONS(3057),
  },
  [2417] = {
    [sym_block_comment] = STATE(2417),
    [sym_compiler_directive_decl] = STATE(2417),
    [sym_fsi_directive_decl] = STATE(2417),
    [sym_preproc_line] = STATE(2417),
    [sym_identifier] = ACTIONS(3011),
    [anon_sym_EQ] = ACTIONS(3013),
    [anon_sym_COLON] = ACTIONS(3011),
    [anon_sym_return] = ACTIONS(3011),
    [anon_sym_do] = ACTIONS(3011),
    [anon_sym_let] = ACTIONS(3011),
    [anon_sym_let_BANG] = ACTIONS(3013),
    [anon_sym_LPAREN] = ACTIONS(3011),
    [anon_sym_COMMA] = ACTIONS(3013),
    [anon_sym_null] = ACTIONS(3011),
    [anon_sym_QMARK] = ACTIONS(3011),
    [anon_sym_COLON_QMARK] = ACTIONS(3011),
    [anon_sym_COLON_COLON] = ACTIONS(3013),
    [anon_sym_AMP] = ACTIONS(3011),
    [anon_sym_LBRACK] = ACTIONS(3011),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3013),
    [anon_sym_LBRACE] = ACTIONS(3011),
    [anon_sym_LT_AT] = ACTIONS(3011),
    [anon_sym_AT_GT] = ACTIONS(3011),
    [anon_sym_LT_AT_AT] = ACTIONS(3011),
    [anon_sym_DOT] = ACTIONS(3011),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3013),
    [anon_sym_new] = ACTIONS(3011),
    [anon_sym_return_BANG] = ACTIONS(3013),
    [anon_sym_yield] = ACTIONS(3011),
    [anon_sym_yield_BANG] = ACTIONS(3013),
    [anon_sym_lazy] = ACTIONS(3011),
    [anon_sym_assert] = ACTIONS(3011),
    [anon_sym_upcast] = ACTIONS(3011),
    [anon_sym_downcast] = ACTIONS(3011),
    [anon_sym_COLON_GT] = ACTIONS(3013),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3013),
    [anon_sym_for] = ACTIONS(3011),
    [anon_sym_while] = ACTIONS(3011),
    [anon_sym_if] = ACTIONS(3011),
    [anon_sym_fun] = ACTIONS(3011),
    [anon_sym_try] = ACTIONS(3011),
    [anon_sym_match] = ACTIONS(3011),
    [anon_sym_match_BANG] = ACTIONS(3013),
    [anon_sym_function] = ACTIONS(3011),
    [anon_sym_LT_DASH] = ACTIONS(3011),
    [anon_sym_DOT_LBRACK] = ACTIONS(3013),
    [anon_sym_LT] = ACTIONS(3013),
    [anon_sym_use] = ACTIONS(3011),
    [anon_sym_use_BANG] = ACTIONS(3013),
    [anon_sym_do_BANG] = ACTIONS(3013),
    [anon_sym_begin] = ACTIONS(3011),
    [anon_sym_LPAREN2] = ACTIONS(3011),
    [anon_sym_or] = ACTIONS(3011),
    [aux_sym_char_token1] = ACTIONS(3013),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3011),
    [anon_sym_DQUOTE] = ACTIONS(3011),
    [anon_sym_AT_DQUOTE] = ACTIONS(3013),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3013),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3013),
    [sym_bool] = ACTIONS(3011),
    [sym_unit] = ACTIONS(3013),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3011),
    [sym_op_identifier] = ACTIONS(3011),
    [anon_sym_PLUS] = ACTIONS(3011),
    [anon_sym_DASH] = ACTIONS(3011),
    [anon_sym_PLUS_DOT] = ACTIONS(3011),
    [anon_sym_DASH_DOT] = ACTIONS(3011),
    [anon_sym_PERCENT] = ACTIONS(3011),
    [anon_sym_AMP_AMP] = ACTIONS(3011),
    [anon_sym_TILDE] = ACTIONS(3013),
    [aux_sym_prefix_op_token1] = ACTIONS(3011),
    [aux_sym_infix_op_token1] = ACTIONS(3013),
    [aux_sym_infix_op_token2] = ACTIONS(3011),
    [anon_sym_PIPE_PIPE] = ACTIONS(3011),
    [anon_sym_BANG_EQ] = ACTIONS(3011),
    [anon_sym_COLON_EQ] = ACTIONS(3013),
    [anon_sym_DOLLAR] = ACTIONS(3011),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3011),
    [sym_int] = ACTIONS(3011),
    [sym_xint] = ACTIONS(3013),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3013),
    [sym__newline] = ACTIONS(3013),
  },
  [2418] = {
    [sym_block_comment] = STATE(2418),
    [sym_compiler_directive_decl] = STATE(2418),
    [sym_fsi_directive_decl] = STATE(2418),
    [sym_preproc_line] = STATE(2418),
    [sym_identifier] = ACTIONS(3023),
    [anon_sym_EQ] = ACTIONS(3025),
    [anon_sym_COLON] = ACTIONS(3023),
    [anon_sym_return] = ACTIONS(3023),
    [anon_sym_do] = ACTIONS(3023),
    [anon_sym_let] = ACTIONS(3023),
    [anon_sym_let_BANG] = ACTIONS(3025),
    [anon_sym_LPAREN] = ACTIONS(3023),
    [anon_sym_COMMA] = ACTIONS(3025),
    [anon_sym_null] = ACTIONS(3023),
    [anon_sym_QMARK] = ACTIONS(3023),
    [anon_sym_COLON_QMARK] = ACTIONS(3023),
    [anon_sym_COLON_COLON] = ACTIONS(3025),
    [anon_sym_AMP] = ACTIONS(3023),
    [anon_sym_LBRACK] = ACTIONS(3023),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3025),
    [anon_sym_LBRACE] = ACTIONS(3023),
    [anon_sym_LT_AT] = ACTIONS(3023),
    [anon_sym_LT_AT_AT] = ACTIONS(3023),
    [anon_sym_AT_AT_GT] = ACTIONS(3023),
    [anon_sym_DOT] = ACTIONS(3023),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3025),
    [anon_sym_new] = ACTIONS(3023),
    [anon_sym_return_BANG] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(3023),
    [anon_sym_yield_BANG] = ACTIONS(3025),
    [anon_sym_lazy] = ACTIONS(3023),
    [anon_sym_assert] = ACTIONS(3023),
    [anon_sym_upcast] = ACTIONS(3023),
    [anon_sym_downcast] = ACTIONS(3023),
    [anon_sym_COLON_GT] = ACTIONS(3025),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3025),
    [anon_sym_for] = ACTIONS(3023),
    [anon_sym_while] = ACTIONS(3023),
    [anon_sym_if] = ACTIONS(3023),
    [anon_sym_fun] = ACTIONS(3023),
    [anon_sym_try] = ACTIONS(3023),
    [anon_sym_match] = ACTIONS(3023),
    [anon_sym_match_BANG] = ACTIONS(3025),
    [anon_sym_function] = ACTIONS(3023),
    [anon_sym_LT_DASH] = ACTIONS(3023),
    [anon_sym_DOT_LBRACK] = ACTIONS(3025),
    [anon_sym_LT] = ACTIONS(3025),
    [anon_sym_use] = ACTIONS(3023),
    [anon_sym_use_BANG] = ACTIONS(3025),
    [anon_sym_do_BANG] = ACTIONS(3025),
    [anon_sym_begin] = ACTIONS(3023),
    [anon_sym_LPAREN2] = ACTIONS(3023),
    [anon_sym_or] = ACTIONS(3023),
    [aux_sym_char_token1] = ACTIONS(3025),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3023),
    [anon_sym_DQUOTE] = ACTIONS(3023),
    [anon_sym_AT_DQUOTE] = ACTIONS(3025),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3025),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3025),
    [sym_bool] = ACTIONS(3023),
    [sym_unit] = ACTIONS(3025),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3023),
    [sym_op_identifier] = ACTIONS(3023),
    [anon_sym_PLUS] = ACTIONS(3023),
    [anon_sym_DASH] = ACTIONS(3023),
    [anon_sym_PLUS_DOT] = ACTIONS(3023),
    [anon_sym_DASH_DOT] = ACTIONS(3023),
    [anon_sym_PERCENT] = ACTIONS(3023),
    [anon_sym_AMP_AMP] = ACTIONS(3023),
    [anon_sym_TILDE] = ACTIONS(3025),
    [aux_sym_prefix_op_token1] = ACTIONS(3023),
    [aux_sym_infix_op_token1] = ACTIONS(3025),
    [aux_sym_infix_op_token2] = ACTIONS(3023),
    [anon_sym_PIPE_PIPE] = ACTIONS(3023),
    [anon_sym_BANG_EQ] = ACTIONS(3023),
    [anon_sym_COLON_EQ] = ACTIONS(3025),
    [anon_sym_DOLLAR] = ACTIONS(3023),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3023),
    [sym_int] = ACTIONS(3023),
    [sym_xint] = ACTIONS(3025),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3025),
    [sym__newline] = ACTIONS(3025),
  },
  [2419] = {
    [sym_block_comment] = STATE(2419),
    [sym_compiler_directive_decl] = STATE(2419),
    [sym_fsi_directive_decl] = STATE(2419),
    [sym_preproc_line] = STATE(2419),
    [sym_identifier] = ACTIONS(2859),
    [anon_sym_EQ] = ACTIONS(2861),
    [anon_sym_COLON] = ACTIONS(2859),
    [anon_sym_return] = ACTIONS(2859),
    [anon_sym_do] = ACTIONS(2859),
    [anon_sym_let] = ACTIONS(2859),
    [anon_sym_let_BANG] = ACTIONS(2861),
    [anon_sym_LPAREN] = ACTIONS(2859),
    [anon_sym_COMMA] = ACTIONS(2861),
    [anon_sym_null] = ACTIONS(2859),
    [anon_sym_QMARK] = ACTIONS(2859),
    [anon_sym_COLON_QMARK] = ACTIONS(2859),
    [anon_sym_COLON_COLON] = ACTIONS(2861),
    [anon_sym_AMP] = ACTIONS(2859),
    [anon_sym_LBRACK] = ACTIONS(2859),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2861),
    [anon_sym_LBRACE] = ACTIONS(2859),
    [anon_sym_LT_AT] = ACTIONS(2859),
    [anon_sym_LT_AT_AT] = ACTIONS(2859),
    [anon_sym_DOT] = ACTIONS(2859),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2861),
    [anon_sym_new] = ACTIONS(2859),
    [anon_sym_return_BANG] = ACTIONS(2861),
    [anon_sym_yield] = ACTIONS(2859),
    [anon_sym_yield_BANG] = ACTIONS(2861),
    [anon_sym_lazy] = ACTIONS(2859),
    [anon_sym_assert] = ACTIONS(2859),
    [anon_sym_upcast] = ACTIONS(2859),
    [anon_sym_downcast] = ACTIONS(2859),
    [anon_sym_COLON_GT] = ACTIONS(2861),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2861),
    [anon_sym_for] = ACTIONS(2859),
    [anon_sym_while] = ACTIONS(2859),
    [anon_sym_if] = ACTIONS(2859),
    [anon_sym_fun] = ACTIONS(2859),
    [anon_sym_try] = ACTIONS(2859),
    [anon_sym_match] = ACTIONS(2859),
    [anon_sym_match_BANG] = ACTIONS(2861),
    [anon_sym_function] = ACTIONS(2859),
    [anon_sym_LT_DASH] = ACTIONS(2859),
    [anon_sym_DOT_LBRACK] = ACTIONS(2861),
    [anon_sym_LT] = ACTIONS(2861),
    [anon_sym_use] = ACTIONS(2859),
    [anon_sym_use_BANG] = ACTIONS(2861),
    [anon_sym_do_BANG] = ACTIONS(2861),
    [anon_sym_begin] = ACTIONS(2859),
    [anon_sym_LPAREN2] = ACTIONS(2859),
    [anon_sym_or] = ACTIONS(2859),
    [aux_sym_char_token1] = ACTIONS(2861),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2859),
    [anon_sym_DQUOTE] = ACTIONS(2859),
    [anon_sym_AT_DQUOTE] = ACTIONS(2861),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2861),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2861),
    [sym_bool] = ACTIONS(2859),
    [sym_unit] = ACTIONS(2861),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2859),
    [sym_op_identifier] = ACTIONS(2859),
    [anon_sym_PLUS] = ACTIONS(2859),
    [anon_sym_DASH] = ACTIONS(2859),
    [anon_sym_PLUS_DOT] = ACTIONS(2859),
    [anon_sym_DASH_DOT] = ACTIONS(2859),
    [anon_sym_PERCENT] = ACTIONS(2859),
    [anon_sym_AMP_AMP] = ACTIONS(2859),
    [anon_sym_TILDE] = ACTIONS(2861),
    [aux_sym_prefix_op_token1] = ACTIONS(2859),
    [aux_sym_infix_op_token1] = ACTIONS(2861),
    [aux_sym_infix_op_token2] = ACTIONS(2859),
    [anon_sym_PIPE_PIPE] = ACTIONS(2859),
    [anon_sym_BANG_EQ] = ACTIONS(2859),
    [anon_sym_COLON_EQ] = ACTIONS(2861),
    [anon_sym_DOLLAR] = ACTIONS(2859),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2859),
    [sym_int] = ACTIONS(2859),
    [sym_xint] = ACTIONS(2861),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2861),
    [anon_sym_POUNDendif] = ACTIONS(2861),
    [sym__newline] = ACTIONS(2861),
  },
  [2420] = {
    [sym_block_comment] = STATE(2420),
    [sym_compiler_directive_decl] = STATE(2420),
    [sym_fsi_directive_decl] = STATE(2420),
    [sym_preproc_line] = STATE(2420),
    [sym_identifier] = ACTIONS(2855),
    [anon_sym_EQ] = ACTIONS(2857),
    [anon_sym_COLON] = ACTIONS(2855),
    [anon_sym_return] = ACTIONS(2855),
    [anon_sym_do] = ACTIONS(2855),
    [anon_sym_let] = ACTIONS(2855),
    [anon_sym_let_BANG] = ACTIONS(2857),
    [anon_sym_LPAREN] = ACTIONS(2855),
    [anon_sym_COMMA] = ACTIONS(2857),
    [anon_sym_null] = ACTIONS(2855),
    [anon_sym_QMARK] = ACTIONS(2855),
    [anon_sym_COLON_QMARK] = ACTIONS(2855),
    [anon_sym_COLON_COLON] = ACTIONS(2857),
    [anon_sym_AMP] = ACTIONS(2855),
    [anon_sym_LBRACK] = ACTIONS(2855),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2857),
    [anon_sym_LBRACE] = ACTIONS(2855),
    [anon_sym_LT_AT] = ACTIONS(2855),
    [anon_sym_LT_AT_AT] = ACTIONS(2855),
    [anon_sym_DOT] = ACTIONS(2855),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2857),
    [anon_sym_new] = ACTIONS(2855),
    [anon_sym_return_BANG] = ACTIONS(2857),
    [anon_sym_yield] = ACTIONS(2855),
    [anon_sym_yield_BANG] = ACTIONS(2857),
    [anon_sym_lazy] = ACTIONS(2855),
    [anon_sym_assert] = ACTIONS(2855),
    [anon_sym_upcast] = ACTIONS(2855),
    [anon_sym_downcast] = ACTIONS(2855),
    [anon_sym_COLON_GT] = ACTIONS(2857),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2857),
    [anon_sym_for] = ACTIONS(2855),
    [anon_sym_while] = ACTIONS(2855),
    [anon_sym_if] = ACTIONS(2855),
    [anon_sym_fun] = ACTIONS(2855),
    [anon_sym_try] = ACTIONS(2855),
    [anon_sym_match] = ACTIONS(2855),
    [anon_sym_match_BANG] = ACTIONS(2857),
    [anon_sym_function] = ACTIONS(2855),
    [anon_sym_LT_DASH] = ACTIONS(2855),
    [anon_sym_DOT_LBRACK] = ACTIONS(2857),
    [anon_sym_LT] = ACTIONS(2857),
    [anon_sym_use] = ACTIONS(2855),
    [anon_sym_use_BANG] = ACTIONS(2857),
    [anon_sym_do_BANG] = ACTIONS(2857),
    [anon_sym_begin] = ACTIONS(2855),
    [anon_sym_LPAREN2] = ACTIONS(2855),
    [anon_sym_or] = ACTIONS(2855),
    [aux_sym_char_token1] = ACTIONS(2857),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2855),
    [anon_sym_DQUOTE] = ACTIONS(2855),
    [anon_sym_AT_DQUOTE] = ACTIONS(2857),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2857),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2857),
    [sym_bool] = ACTIONS(2855),
    [sym_unit] = ACTIONS(2857),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2855),
    [sym_op_identifier] = ACTIONS(2855),
    [anon_sym_PLUS] = ACTIONS(2855),
    [anon_sym_DASH] = ACTIONS(2855),
    [anon_sym_PLUS_DOT] = ACTIONS(2855),
    [anon_sym_DASH_DOT] = ACTIONS(2855),
    [anon_sym_PERCENT] = ACTIONS(2855),
    [anon_sym_AMP_AMP] = ACTIONS(2855),
    [anon_sym_TILDE] = ACTIONS(2857),
    [aux_sym_prefix_op_token1] = ACTIONS(2855),
    [aux_sym_infix_op_token1] = ACTIONS(2857),
    [aux_sym_infix_op_token2] = ACTIONS(2855),
    [anon_sym_PIPE_PIPE] = ACTIONS(2855),
    [anon_sym_BANG_EQ] = ACTIONS(2855),
    [anon_sym_COLON_EQ] = ACTIONS(2857),
    [anon_sym_DOLLAR] = ACTIONS(2855),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2855),
    [sym_int] = ACTIONS(2855),
    [sym_xint] = ACTIONS(2857),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2857),
    [anon_sym_POUNDendif] = ACTIONS(2857),
    [sym__newline] = ACTIONS(2857),
  },
  [2421] = {
    [sym_block_comment] = STATE(2421),
    [sym_compiler_directive_decl] = STATE(2421),
    [sym_fsi_directive_decl] = STATE(2421),
    [sym_preproc_line] = STATE(2421),
    [sym_identifier] = ACTIONS(3115),
    [anon_sym_EQ] = ACTIONS(3117),
    [anon_sym_COLON] = ACTIONS(3115),
    [anon_sym_return] = ACTIONS(3115),
    [anon_sym_do] = ACTIONS(3115),
    [anon_sym_let] = ACTIONS(3115),
    [anon_sym_let_BANG] = ACTIONS(3117),
    [anon_sym_LPAREN] = ACTIONS(3115),
    [anon_sym_COMMA] = ACTIONS(3117),
    [anon_sym_null] = ACTIONS(3115),
    [anon_sym_QMARK] = ACTIONS(3115),
    [anon_sym_COLON_QMARK] = ACTIONS(3115),
    [anon_sym_COLON_COLON] = ACTIONS(3117),
    [anon_sym_AMP] = ACTIONS(3115),
    [anon_sym_LBRACK] = ACTIONS(3115),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3117),
    [anon_sym_LBRACE] = ACTIONS(3115),
    [anon_sym_LT_AT] = ACTIONS(3115),
    [anon_sym_AT_GT] = ACTIONS(3115),
    [anon_sym_LT_AT_AT] = ACTIONS(3115),
    [anon_sym_DOT] = ACTIONS(3115),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3117),
    [anon_sym_new] = ACTIONS(3115),
    [anon_sym_return_BANG] = ACTIONS(3117),
    [anon_sym_yield] = ACTIONS(3115),
    [anon_sym_yield_BANG] = ACTIONS(3117),
    [anon_sym_lazy] = ACTIONS(3115),
    [anon_sym_assert] = ACTIONS(3115),
    [anon_sym_upcast] = ACTIONS(3115),
    [anon_sym_downcast] = ACTIONS(3115),
    [anon_sym_COLON_GT] = ACTIONS(3117),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3117),
    [anon_sym_for] = ACTIONS(3115),
    [anon_sym_while] = ACTIONS(3115),
    [anon_sym_if] = ACTIONS(3115),
    [anon_sym_fun] = ACTIONS(3115),
    [anon_sym_try] = ACTIONS(3115),
    [anon_sym_match] = ACTIONS(3115),
    [anon_sym_match_BANG] = ACTIONS(3117),
    [anon_sym_function] = ACTIONS(3115),
    [anon_sym_LT_DASH] = ACTIONS(3115),
    [anon_sym_DOT_LBRACK] = ACTIONS(3117),
    [anon_sym_LT] = ACTIONS(3117),
    [anon_sym_use] = ACTIONS(3115),
    [anon_sym_use_BANG] = ACTIONS(3117),
    [anon_sym_do_BANG] = ACTIONS(3117),
    [anon_sym_begin] = ACTIONS(3115),
    [anon_sym_LPAREN2] = ACTIONS(3115),
    [anon_sym_or] = ACTIONS(3115),
    [aux_sym_char_token1] = ACTIONS(3117),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3115),
    [anon_sym_DQUOTE] = ACTIONS(3115),
    [anon_sym_AT_DQUOTE] = ACTIONS(3117),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3117),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3117),
    [sym_bool] = ACTIONS(3115),
    [sym_unit] = ACTIONS(3117),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3115),
    [sym_op_identifier] = ACTIONS(3115),
    [anon_sym_PLUS] = ACTIONS(3115),
    [anon_sym_DASH] = ACTIONS(3115),
    [anon_sym_PLUS_DOT] = ACTIONS(3115),
    [anon_sym_DASH_DOT] = ACTIONS(3115),
    [anon_sym_PERCENT] = ACTIONS(3115),
    [anon_sym_AMP_AMP] = ACTIONS(3115),
    [anon_sym_TILDE] = ACTIONS(3117),
    [aux_sym_prefix_op_token1] = ACTIONS(3115),
    [aux_sym_infix_op_token1] = ACTIONS(3117),
    [aux_sym_infix_op_token2] = ACTIONS(3115),
    [anon_sym_PIPE_PIPE] = ACTIONS(3115),
    [anon_sym_BANG_EQ] = ACTIONS(3115),
    [anon_sym_COLON_EQ] = ACTIONS(3117),
    [anon_sym_DOLLAR] = ACTIONS(3115),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3115),
    [sym_int] = ACTIONS(3115),
    [sym_xint] = ACTIONS(3117),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3117),
    [sym__newline] = ACTIONS(3117),
  },
  [2422] = {
    [sym_block_comment] = STATE(2422),
    [sym_compiler_directive_decl] = STATE(2422),
    [sym_fsi_directive_decl] = STATE(2422),
    [sym_preproc_line] = STATE(2422),
    [sym_identifier] = ACTIONS(2831),
    [anon_sym_EQ] = ACTIONS(2833),
    [anon_sym_COLON] = ACTIONS(2831),
    [anon_sym_return] = ACTIONS(2831),
    [anon_sym_do] = ACTIONS(2831),
    [anon_sym_let] = ACTIONS(2831),
    [anon_sym_let_BANG] = ACTIONS(2833),
    [anon_sym_LPAREN] = ACTIONS(2831),
    [anon_sym_COMMA] = ACTIONS(2833),
    [anon_sym_null] = ACTIONS(2831),
    [anon_sym_QMARK] = ACTIONS(2831),
    [anon_sym_COLON_QMARK] = ACTIONS(2831),
    [anon_sym_COLON_COLON] = ACTIONS(2833),
    [anon_sym_AMP] = ACTIONS(2831),
    [anon_sym_LBRACK] = ACTIONS(2831),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2833),
    [anon_sym_LBRACE] = ACTIONS(2831),
    [anon_sym_LT_AT] = ACTIONS(2831),
    [anon_sym_LT_AT_AT] = ACTIONS(2831),
    [anon_sym_DOT] = ACTIONS(2831),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2833),
    [anon_sym_new] = ACTIONS(2831),
    [anon_sym_return_BANG] = ACTIONS(2833),
    [anon_sym_yield] = ACTIONS(2831),
    [anon_sym_yield_BANG] = ACTIONS(2833),
    [anon_sym_lazy] = ACTIONS(2831),
    [anon_sym_assert] = ACTIONS(2831),
    [anon_sym_upcast] = ACTIONS(2831),
    [anon_sym_downcast] = ACTIONS(2831),
    [anon_sym_COLON_GT] = ACTIONS(2833),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2833),
    [anon_sym_for] = ACTIONS(2831),
    [anon_sym_while] = ACTIONS(2831),
    [anon_sym_if] = ACTIONS(2831),
    [anon_sym_fun] = ACTIONS(2831),
    [anon_sym_try] = ACTIONS(2831),
    [anon_sym_match] = ACTIONS(2831),
    [anon_sym_match_BANG] = ACTIONS(2833),
    [anon_sym_function] = ACTIONS(2831),
    [anon_sym_LT_DASH] = ACTIONS(2831),
    [anon_sym_DOT_LBRACK] = ACTIONS(2833),
    [anon_sym_LT] = ACTIONS(2833),
    [anon_sym_use] = ACTIONS(2831),
    [anon_sym_use_BANG] = ACTIONS(2833),
    [anon_sym_do_BANG] = ACTIONS(2833),
    [anon_sym_begin] = ACTIONS(2831),
    [anon_sym_LPAREN2] = ACTIONS(2831),
    [anon_sym_or] = ACTIONS(2831),
    [aux_sym_char_token1] = ACTIONS(2833),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2831),
    [anon_sym_DQUOTE] = ACTIONS(2831),
    [anon_sym_AT_DQUOTE] = ACTIONS(2833),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2833),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2833),
    [sym_bool] = ACTIONS(2831),
    [sym_unit] = ACTIONS(2833),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2831),
    [sym_op_identifier] = ACTIONS(2831),
    [anon_sym_PLUS] = ACTIONS(2831),
    [anon_sym_DASH] = ACTIONS(2831),
    [anon_sym_PLUS_DOT] = ACTIONS(2831),
    [anon_sym_DASH_DOT] = ACTIONS(2831),
    [anon_sym_PERCENT] = ACTIONS(2831),
    [anon_sym_AMP_AMP] = ACTIONS(2831),
    [anon_sym_TILDE] = ACTIONS(2833),
    [aux_sym_prefix_op_token1] = ACTIONS(2831),
    [aux_sym_infix_op_token1] = ACTIONS(2833),
    [aux_sym_infix_op_token2] = ACTIONS(2831),
    [anon_sym_PIPE_PIPE] = ACTIONS(2831),
    [anon_sym_BANG_EQ] = ACTIONS(2831),
    [anon_sym_COLON_EQ] = ACTIONS(2833),
    [anon_sym_DOLLAR] = ACTIONS(2831),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2831),
    [sym_int] = ACTIONS(2831),
    [sym_xint] = ACTIONS(2833),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2833),
    [anon_sym_POUNDendif] = ACTIONS(2833),
    [sym__newline] = ACTIONS(2833),
  },
  [2423] = {
    [sym_block_comment] = STATE(2423),
    [sym_compiler_directive_decl] = STATE(2423),
    [sym_fsi_directive_decl] = STATE(2423),
    [sym_preproc_line] = STATE(2423),
    [sym_identifier] = ACTIONS(3067),
    [anon_sym_EQ] = ACTIONS(3069),
    [anon_sym_COLON] = ACTIONS(3067),
    [anon_sym_return] = ACTIONS(3067),
    [anon_sym_do] = ACTIONS(3067),
    [anon_sym_let] = ACTIONS(3067),
    [anon_sym_let_BANG] = ACTIONS(3069),
    [anon_sym_LPAREN] = ACTIONS(3067),
    [anon_sym_COMMA] = ACTIONS(3069),
    [anon_sym_null] = ACTIONS(3067),
    [anon_sym_QMARK] = ACTIONS(3067),
    [anon_sym_COLON_QMARK] = ACTIONS(3067),
    [anon_sym_COLON_COLON] = ACTIONS(3069),
    [anon_sym_AMP] = ACTIONS(3067),
    [anon_sym_LBRACK] = ACTIONS(3067),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3069),
    [anon_sym_LBRACE] = ACTIONS(3067),
    [anon_sym_LT_AT] = ACTIONS(3067),
    [anon_sym_LT_AT_AT] = ACTIONS(3067),
    [anon_sym_DOT] = ACTIONS(3067),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3069),
    [anon_sym_new] = ACTIONS(3067),
    [anon_sym_return_BANG] = ACTIONS(3069),
    [anon_sym_yield] = ACTIONS(3067),
    [anon_sym_yield_BANG] = ACTIONS(3069),
    [anon_sym_lazy] = ACTIONS(3067),
    [anon_sym_assert] = ACTIONS(3067),
    [anon_sym_upcast] = ACTIONS(3067),
    [anon_sym_downcast] = ACTIONS(3067),
    [anon_sym_COLON_GT] = ACTIONS(3069),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3069),
    [anon_sym_for] = ACTIONS(3067),
    [anon_sym_while] = ACTIONS(3067),
    [anon_sym_if] = ACTIONS(3067),
    [anon_sym_fun] = ACTIONS(3067),
    [anon_sym_try] = ACTIONS(3067),
    [anon_sym_match] = ACTIONS(3067),
    [anon_sym_match_BANG] = ACTIONS(3069),
    [anon_sym_function] = ACTIONS(3067),
    [anon_sym_LT_DASH] = ACTIONS(3067),
    [anon_sym_DOT_LBRACK] = ACTIONS(3069),
    [anon_sym_LT] = ACTIONS(3069),
    [anon_sym_use] = ACTIONS(3067),
    [anon_sym_use_BANG] = ACTIONS(3069),
    [anon_sym_do_BANG] = ACTIONS(3069),
    [anon_sym_begin] = ACTIONS(3067),
    [anon_sym_LPAREN2] = ACTIONS(3067),
    [anon_sym_or] = ACTIONS(3067),
    [aux_sym_char_token1] = ACTIONS(3069),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3067),
    [anon_sym_DQUOTE] = ACTIONS(3067),
    [anon_sym_AT_DQUOTE] = ACTIONS(3069),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3069),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3069),
    [sym_bool] = ACTIONS(3067),
    [sym_unit] = ACTIONS(3069),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3067),
    [sym_op_identifier] = ACTIONS(3067),
    [anon_sym_PLUS] = ACTIONS(3067),
    [anon_sym_DASH] = ACTIONS(3067),
    [anon_sym_PLUS_DOT] = ACTIONS(3067),
    [anon_sym_DASH_DOT] = ACTIONS(3067),
    [anon_sym_PERCENT] = ACTIONS(3067),
    [anon_sym_AMP_AMP] = ACTIONS(3067),
    [anon_sym_TILDE] = ACTIONS(3069),
    [aux_sym_prefix_op_token1] = ACTIONS(3067),
    [aux_sym_infix_op_token1] = ACTIONS(3069),
    [aux_sym_infix_op_token2] = ACTIONS(3067),
    [anon_sym_PIPE_PIPE] = ACTIONS(3067),
    [anon_sym_BANG_EQ] = ACTIONS(3067),
    [anon_sym_COLON_EQ] = ACTIONS(3069),
    [anon_sym_DOLLAR] = ACTIONS(3067),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3067),
    [sym_int] = ACTIONS(3067),
    [sym_xint] = ACTIONS(3069),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3069),
    [anon_sym_POUNDendif] = ACTIONS(3069),
    [sym__newline] = ACTIONS(3069),
  },
  [2424] = {
    [sym_block_comment] = STATE(2424),
    [sym_compiler_directive_decl] = STATE(2424),
    [sym_fsi_directive_decl] = STATE(2424),
    [sym_preproc_line] = STATE(2424),
    [sym_identifier] = ACTIONS(2863),
    [anon_sym_EQ] = ACTIONS(2865),
    [anon_sym_COLON] = ACTIONS(2863),
    [anon_sym_return] = ACTIONS(2863),
    [anon_sym_do] = ACTIONS(2863),
    [anon_sym_let] = ACTIONS(2863),
    [anon_sym_let_BANG] = ACTIONS(2865),
    [anon_sym_LPAREN] = ACTIONS(2863),
    [anon_sym_COMMA] = ACTIONS(2865),
    [anon_sym_null] = ACTIONS(2863),
    [anon_sym_QMARK] = ACTIONS(2863),
    [anon_sym_COLON_QMARK] = ACTIONS(2863),
    [anon_sym_COLON_COLON] = ACTIONS(2865),
    [anon_sym_AMP] = ACTIONS(2863),
    [anon_sym_LBRACK] = ACTIONS(2863),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2865),
    [anon_sym_LBRACE] = ACTIONS(2863),
    [anon_sym_LT_AT] = ACTIONS(2863),
    [anon_sym_LT_AT_AT] = ACTIONS(2863),
    [anon_sym_DOT] = ACTIONS(2863),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2865),
    [anon_sym_new] = ACTIONS(2863),
    [anon_sym_return_BANG] = ACTIONS(2865),
    [anon_sym_yield] = ACTIONS(2863),
    [anon_sym_yield_BANG] = ACTIONS(2865),
    [anon_sym_lazy] = ACTIONS(2863),
    [anon_sym_assert] = ACTIONS(2863),
    [anon_sym_upcast] = ACTIONS(2863),
    [anon_sym_downcast] = ACTIONS(2863),
    [anon_sym_COLON_GT] = ACTIONS(2865),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2865),
    [anon_sym_for] = ACTIONS(2863),
    [anon_sym_while] = ACTIONS(2863),
    [anon_sym_if] = ACTIONS(2863),
    [anon_sym_fun] = ACTIONS(2863),
    [anon_sym_try] = ACTIONS(2863),
    [anon_sym_match] = ACTIONS(2863),
    [anon_sym_match_BANG] = ACTIONS(2865),
    [anon_sym_function] = ACTIONS(2863),
    [anon_sym_LT_DASH] = ACTIONS(2863),
    [anon_sym_DOT_LBRACK] = ACTIONS(2865),
    [anon_sym_LT] = ACTIONS(2865),
    [anon_sym_use] = ACTIONS(2863),
    [anon_sym_use_BANG] = ACTIONS(2865),
    [anon_sym_do_BANG] = ACTIONS(2865),
    [anon_sym_DOT_DOT] = ACTIONS(2865),
    [anon_sym_begin] = ACTIONS(2863),
    [anon_sym_LPAREN2] = ACTIONS(2863),
    [anon_sym_or] = ACTIONS(2863),
    [aux_sym_char_token1] = ACTIONS(2865),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2863),
    [anon_sym_DQUOTE] = ACTIONS(2863),
    [anon_sym_AT_DQUOTE] = ACTIONS(2865),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2865),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2865),
    [sym_bool] = ACTIONS(2863),
    [sym_unit] = ACTIONS(2865),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2863),
    [sym_op_identifier] = ACTIONS(2863),
    [anon_sym_PLUS] = ACTIONS(2863),
    [anon_sym_DASH] = ACTIONS(2863),
    [anon_sym_PLUS_DOT] = ACTIONS(2863),
    [anon_sym_DASH_DOT] = ACTIONS(2863),
    [anon_sym_PERCENT] = ACTIONS(2863),
    [anon_sym_AMP_AMP] = ACTIONS(2863),
    [anon_sym_TILDE] = ACTIONS(2865),
    [aux_sym_prefix_op_token1] = ACTIONS(2863),
    [aux_sym_infix_op_token1] = ACTIONS(2865),
    [aux_sym_infix_op_token2] = ACTIONS(2863),
    [anon_sym_PIPE_PIPE] = ACTIONS(2863),
    [anon_sym_BANG_EQ] = ACTIONS(2863),
    [anon_sym_COLON_EQ] = ACTIONS(2865),
    [anon_sym_DOLLAR] = ACTIONS(2863),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2863),
    [sym_int] = ACTIONS(2863),
    [sym_xint] = ACTIONS(2865),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2865),
    [sym__newline] = ACTIONS(2865),
  },
  [2425] = {
    [sym_block_comment] = STATE(2425),
    [sym_compiler_directive_decl] = STATE(2425),
    [sym_fsi_directive_decl] = STATE(2425),
    [sym_preproc_line] = STATE(2425),
    [sym_identifier] = ACTIONS(2158),
    [anon_sym_EQ] = ACTIONS(2160),
    [anon_sym_COLON] = ACTIONS(2158),
    [anon_sym_return] = ACTIONS(2158),
    [anon_sym_do] = ACTIONS(2158),
    [anon_sym_let] = ACTIONS(2158),
    [anon_sym_let_BANG] = ACTIONS(2160),
    [anon_sym_LPAREN] = ACTIONS(2158),
    [anon_sym_COMMA] = ACTIONS(2160),
    [anon_sym_null] = ACTIONS(2158),
    [anon_sym_QMARK] = ACTIONS(2158),
    [anon_sym_COLON_QMARK] = ACTIONS(2158),
    [anon_sym_COLON_COLON] = ACTIONS(2160),
    [anon_sym_AMP] = ACTIONS(2158),
    [anon_sym_LBRACK] = ACTIONS(2158),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2160),
    [anon_sym_LBRACE] = ACTIONS(2158),
    [anon_sym_LT_AT] = ACTIONS(2158),
    [anon_sym_LT_AT_AT] = ACTIONS(2158),
    [anon_sym_DOT] = ACTIONS(2158),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2160),
    [anon_sym_new] = ACTIONS(2158),
    [anon_sym_return_BANG] = ACTIONS(2160),
    [anon_sym_yield] = ACTIONS(2158),
    [anon_sym_yield_BANG] = ACTIONS(2160),
    [anon_sym_lazy] = ACTIONS(2158),
    [anon_sym_assert] = ACTIONS(2158),
    [anon_sym_upcast] = ACTIONS(2158),
    [anon_sym_downcast] = ACTIONS(2158),
    [anon_sym_COLON_GT] = ACTIONS(2160),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2160),
    [anon_sym_for] = ACTIONS(2158),
    [anon_sym_while] = ACTIONS(2158),
    [anon_sym_if] = ACTIONS(2158),
    [anon_sym_fun] = ACTIONS(2158),
    [anon_sym_try] = ACTIONS(2158),
    [anon_sym_match] = ACTIONS(2158),
    [anon_sym_match_BANG] = ACTIONS(2160),
    [anon_sym_function] = ACTIONS(2158),
    [anon_sym_LT_DASH] = ACTIONS(2158),
    [anon_sym_DOT_LBRACK] = ACTIONS(2160),
    [anon_sym_LT] = ACTIONS(2160),
    [anon_sym_use] = ACTIONS(2158),
    [anon_sym_use_BANG] = ACTIONS(2160),
    [anon_sym_do_BANG] = ACTIONS(2160),
    [anon_sym_begin] = ACTIONS(2158),
    [anon_sym_LPAREN2] = ACTIONS(2158),
    [anon_sym_or] = ACTIONS(2158),
    [aux_sym_char_token1] = ACTIONS(2160),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2158),
    [anon_sym_DQUOTE] = ACTIONS(2158),
    [anon_sym_AT_DQUOTE] = ACTIONS(2160),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2160),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2160),
    [sym_bool] = ACTIONS(2158),
    [sym_unit] = ACTIONS(2160),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2158),
    [sym_op_identifier] = ACTIONS(2158),
    [anon_sym_PLUS] = ACTIONS(2158),
    [anon_sym_DASH] = ACTIONS(2158),
    [anon_sym_PLUS_DOT] = ACTIONS(2158),
    [anon_sym_DASH_DOT] = ACTIONS(2158),
    [anon_sym_PERCENT] = ACTIONS(2158),
    [anon_sym_AMP_AMP] = ACTIONS(2158),
    [anon_sym_TILDE] = ACTIONS(2160),
    [aux_sym_prefix_op_token1] = ACTIONS(2158),
    [aux_sym_infix_op_token1] = ACTIONS(2160),
    [aux_sym_infix_op_token2] = ACTIONS(2158),
    [anon_sym_PIPE_PIPE] = ACTIONS(2158),
    [anon_sym_BANG_EQ] = ACTIONS(2158),
    [anon_sym_COLON_EQ] = ACTIONS(2160),
    [anon_sym_DOLLAR] = ACTIONS(2158),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2158),
    [sym_int] = ACTIONS(2158),
    [sym_xint] = ACTIONS(2160),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2160),
    [anon_sym_POUNDendif] = ACTIONS(2160),
    [sym__newline] = ACTIONS(2160),
  },
  [2426] = {
    [sym_block_comment] = STATE(2426),
    [sym_compiler_directive_decl] = STATE(2426),
    [sym_fsi_directive_decl] = STATE(2426),
    [sym_preproc_line] = STATE(2426),
    [sym_identifier] = ACTIONS(2843),
    [anon_sym_EQ] = ACTIONS(2845),
    [anon_sym_COLON] = ACTIONS(2843),
    [anon_sym_return] = ACTIONS(2843),
    [anon_sym_do] = ACTIONS(2843),
    [anon_sym_let] = ACTIONS(2843),
    [anon_sym_let_BANG] = ACTIONS(2845),
    [anon_sym_LPAREN] = ACTIONS(2843),
    [anon_sym_COMMA] = ACTIONS(2845),
    [anon_sym_null] = ACTIONS(2843),
    [anon_sym_QMARK] = ACTIONS(2843),
    [anon_sym_COLON_QMARK] = ACTIONS(2843),
    [anon_sym_COLON_COLON] = ACTIONS(2845),
    [anon_sym_AMP] = ACTIONS(2843),
    [anon_sym_LBRACK] = ACTIONS(2843),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2845),
    [anon_sym_LBRACE] = ACTIONS(2843),
    [anon_sym_LT_AT] = ACTIONS(2843),
    [anon_sym_LT_AT_AT] = ACTIONS(2843),
    [anon_sym_DOT] = ACTIONS(2843),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2845),
    [anon_sym_new] = ACTIONS(2843),
    [anon_sym_return_BANG] = ACTIONS(2845),
    [anon_sym_yield] = ACTIONS(2843),
    [anon_sym_yield_BANG] = ACTIONS(2845),
    [anon_sym_lazy] = ACTIONS(2843),
    [anon_sym_assert] = ACTIONS(2843),
    [anon_sym_upcast] = ACTIONS(2843),
    [anon_sym_downcast] = ACTIONS(2843),
    [anon_sym_COLON_GT] = ACTIONS(2845),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2845),
    [anon_sym_for] = ACTIONS(2843),
    [anon_sym_while] = ACTIONS(2843),
    [anon_sym_if] = ACTIONS(2843),
    [anon_sym_fun] = ACTIONS(2843),
    [anon_sym_try] = ACTIONS(2843),
    [anon_sym_match] = ACTIONS(2843),
    [anon_sym_match_BANG] = ACTIONS(2845),
    [anon_sym_function] = ACTIONS(2843),
    [anon_sym_LT_DASH] = ACTIONS(2843),
    [anon_sym_DOT_LBRACK] = ACTIONS(2845),
    [anon_sym_LT] = ACTIONS(2845),
    [anon_sym_use] = ACTIONS(2843),
    [anon_sym_use_BANG] = ACTIONS(2845),
    [anon_sym_do_BANG] = ACTIONS(2845),
    [anon_sym_begin] = ACTIONS(2843),
    [anon_sym_LPAREN2] = ACTIONS(2843),
    [anon_sym_or] = ACTIONS(2843),
    [aux_sym_char_token1] = ACTIONS(2845),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2843),
    [anon_sym_DQUOTE] = ACTIONS(2843),
    [anon_sym_AT_DQUOTE] = ACTIONS(2845),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2845),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2845),
    [sym_bool] = ACTIONS(2843),
    [sym_unit] = ACTIONS(2845),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2843),
    [sym_op_identifier] = ACTIONS(2843),
    [anon_sym_PLUS] = ACTIONS(2843),
    [anon_sym_DASH] = ACTIONS(2843),
    [anon_sym_PLUS_DOT] = ACTIONS(2843),
    [anon_sym_DASH_DOT] = ACTIONS(2843),
    [anon_sym_PERCENT] = ACTIONS(2843),
    [anon_sym_AMP_AMP] = ACTIONS(2843),
    [anon_sym_TILDE] = ACTIONS(2845),
    [aux_sym_prefix_op_token1] = ACTIONS(2843),
    [aux_sym_infix_op_token1] = ACTIONS(2845),
    [aux_sym_infix_op_token2] = ACTIONS(2843),
    [anon_sym_PIPE_PIPE] = ACTIONS(2843),
    [anon_sym_BANG_EQ] = ACTIONS(2843),
    [anon_sym_COLON_EQ] = ACTIONS(2845),
    [anon_sym_DOLLAR] = ACTIONS(2843),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2843),
    [sym_int] = ACTIONS(2843),
    [sym_xint] = ACTIONS(2845),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2845),
    [anon_sym_POUNDendif] = ACTIONS(2845),
    [sym__newline] = ACTIONS(2845),
  },
  [2427] = {
    [sym_block_comment] = STATE(2427),
    [sym_compiler_directive_decl] = STATE(2427),
    [sym_fsi_directive_decl] = STATE(2427),
    [sym_preproc_line] = STATE(2427),
    [sym_identifier] = ACTIONS(3071),
    [anon_sym_EQ] = ACTIONS(3073),
    [anon_sym_COLON] = ACTIONS(3071),
    [anon_sym_return] = ACTIONS(3071),
    [anon_sym_do] = ACTIONS(3071),
    [anon_sym_let] = ACTIONS(3071),
    [anon_sym_let_BANG] = ACTIONS(3073),
    [anon_sym_LPAREN] = ACTIONS(3071),
    [anon_sym_COMMA] = ACTIONS(3073),
    [anon_sym_null] = ACTIONS(3071),
    [anon_sym_QMARK] = ACTIONS(3071),
    [anon_sym_COLON_QMARK] = ACTIONS(3071),
    [anon_sym_COLON_COLON] = ACTIONS(3073),
    [anon_sym_AMP] = ACTIONS(3071),
    [anon_sym_LBRACK] = ACTIONS(3071),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3073),
    [anon_sym_LBRACE] = ACTIONS(3071),
    [anon_sym_LT_AT] = ACTIONS(3071),
    [anon_sym_LT_AT_AT] = ACTIONS(3071),
    [anon_sym_DOT] = ACTIONS(3071),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3073),
    [anon_sym_new] = ACTIONS(3071),
    [anon_sym_return_BANG] = ACTIONS(3073),
    [anon_sym_yield] = ACTIONS(3071),
    [anon_sym_yield_BANG] = ACTIONS(3073),
    [anon_sym_lazy] = ACTIONS(3071),
    [anon_sym_assert] = ACTIONS(3071),
    [anon_sym_upcast] = ACTIONS(3071),
    [anon_sym_downcast] = ACTIONS(3071),
    [anon_sym_COLON_GT] = ACTIONS(3073),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3073),
    [anon_sym_for] = ACTIONS(3071),
    [anon_sym_while] = ACTIONS(3071),
    [anon_sym_if] = ACTIONS(3071),
    [anon_sym_fun] = ACTIONS(3071),
    [anon_sym_try] = ACTIONS(3071),
    [anon_sym_match] = ACTIONS(3071),
    [anon_sym_match_BANG] = ACTIONS(3073),
    [anon_sym_function] = ACTIONS(3071),
    [anon_sym_LT_DASH] = ACTIONS(3071),
    [anon_sym_DOT_LBRACK] = ACTIONS(3073),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_use] = ACTIONS(3071),
    [anon_sym_use_BANG] = ACTIONS(3073),
    [anon_sym_do_BANG] = ACTIONS(3073),
    [anon_sym_begin] = ACTIONS(3071),
    [anon_sym_LPAREN2] = ACTIONS(3071),
    [anon_sym_or] = ACTIONS(3071),
    [aux_sym_char_token1] = ACTIONS(3073),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3071),
    [anon_sym_DQUOTE] = ACTIONS(3071),
    [anon_sym_AT_DQUOTE] = ACTIONS(3073),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3073),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3073),
    [sym_bool] = ACTIONS(3071),
    [sym_unit] = ACTIONS(3073),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3071),
    [sym_op_identifier] = ACTIONS(3071),
    [anon_sym_PLUS] = ACTIONS(3071),
    [anon_sym_DASH] = ACTIONS(3071),
    [anon_sym_PLUS_DOT] = ACTIONS(3071),
    [anon_sym_DASH_DOT] = ACTIONS(3071),
    [anon_sym_PERCENT] = ACTIONS(3071),
    [anon_sym_AMP_AMP] = ACTIONS(3071),
    [anon_sym_TILDE] = ACTIONS(3073),
    [aux_sym_prefix_op_token1] = ACTIONS(3071),
    [aux_sym_infix_op_token1] = ACTIONS(3073),
    [aux_sym_infix_op_token2] = ACTIONS(3071),
    [anon_sym_PIPE_PIPE] = ACTIONS(3071),
    [anon_sym_BANG_EQ] = ACTIONS(3071),
    [anon_sym_COLON_EQ] = ACTIONS(3073),
    [anon_sym_DOLLAR] = ACTIONS(3071),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3071),
    [sym_int] = ACTIONS(3071),
    [sym_xint] = ACTIONS(3073),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3073),
    [anon_sym_POUNDendif] = ACTIONS(3073),
    [sym__newline] = ACTIONS(3073),
  },
  [2428] = {
    [sym_block_comment] = STATE(2428),
    [sym_compiler_directive_decl] = STATE(2428),
    [sym_fsi_directive_decl] = STATE(2428),
    [sym_preproc_line] = STATE(2428),
    [sym_identifier] = ACTIONS(3075),
    [anon_sym_EQ] = ACTIONS(3077),
    [anon_sym_COLON] = ACTIONS(3075),
    [anon_sym_return] = ACTIONS(3075),
    [anon_sym_do] = ACTIONS(3075),
    [anon_sym_let] = ACTIONS(3075),
    [anon_sym_let_BANG] = ACTIONS(3077),
    [anon_sym_LPAREN] = ACTIONS(3075),
    [anon_sym_COMMA] = ACTIONS(3077),
    [anon_sym_null] = ACTIONS(3075),
    [anon_sym_QMARK] = ACTIONS(3075),
    [anon_sym_COLON_QMARK] = ACTIONS(3075),
    [anon_sym_COLON_COLON] = ACTIONS(3077),
    [anon_sym_AMP] = ACTIONS(3075),
    [anon_sym_LBRACK] = ACTIONS(3075),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3077),
    [anon_sym_LBRACE] = ACTIONS(3075),
    [anon_sym_LT_AT] = ACTIONS(3075),
    [anon_sym_LT_AT_AT] = ACTIONS(3075),
    [anon_sym_DOT] = ACTIONS(3075),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3077),
    [anon_sym_new] = ACTIONS(3075),
    [anon_sym_return_BANG] = ACTIONS(3077),
    [anon_sym_yield] = ACTIONS(3075),
    [anon_sym_yield_BANG] = ACTIONS(3077),
    [anon_sym_lazy] = ACTIONS(3075),
    [anon_sym_assert] = ACTIONS(3075),
    [anon_sym_upcast] = ACTIONS(3075),
    [anon_sym_downcast] = ACTIONS(3075),
    [anon_sym_COLON_GT] = ACTIONS(3077),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3077),
    [anon_sym_for] = ACTIONS(3075),
    [anon_sym_while] = ACTIONS(3075),
    [anon_sym_if] = ACTIONS(3075),
    [anon_sym_fun] = ACTIONS(3075),
    [anon_sym_try] = ACTIONS(3075),
    [anon_sym_match] = ACTIONS(3075),
    [anon_sym_match_BANG] = ACTIONS(3077),
    [anon_sym_function] = ACTIONS(3075),
    [anon_sym_LT_DASH] = ACTIONS(3075),
    [anon_sym_DOT_LBRACK] = ACTIONS(3077),
    [anon_sym_LT] = ACTIONS(3077),
    [anon_sym_use] = ACTIONS(3075),
    [anon_sym_use_BANG] = ACTIONS(3077),
    [anon_sym_do_BANG] = ACTIONS(3077),
    [anon_sym_begin] = ACTIONS(3075),
    [anon_sym_LPAREN2] = ACTIONS(3075),
    [anon_sym_or] = ACTIONS(3075),
    [aux_sym_char_token1] = ACTIONS(3077),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3075),
    [anon_sym_DQUOTE] = ACTIONS(3075),
    [anon_sym_AT_DQUOTE] = ACTIONS(3077),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3077),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3077),
    [sym_bool] = ACTIONS(3075),
    [sym_unit] = ACTIONS(3077),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3075),
    [sym_op_identifier] = ACTIONS(3075),
    [anon_sym_PLUS] = ACTIONS(3075),
    [anon_sym_DASH] = ACTIONS(3075),
    [anon_sym_PLUS_DOT] = ACTIONS(3075),
    [anon_sym_DASH_DOT] = ACTIONS(3075),
    [anon_sym_PERCENT] = ACTIONS(3075),
    [anon_sym_AMP_AMP] = ACTIONS(3075),
    [anon_sym_TILDE] = ACTIONS(3077),
    [aux_sym_prefix_op_token1] = ACTIONS(3075),
    [aux_sym_infix_op_token1] = ACTIONS(3077),
    [aux_sym_infix_op_token2] = ACTIONS(3075),
    [anon_sym_PIPE_PIPE] = ACTIONS(3075),
    [anon_sym_BANG_EQ] = ACTIONS(3075),
    [anon_sym_COLON_EQ] = ACTIONS(3077),
    [anon_sym_DOLLAR] = ACTIONS(3075),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3075),
    [sym_int] = ACTIONS(3075),
    [sym_xint] = ACTIONS(3077),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3077),
    [anon_sym_POUNDendif] = ACTIONS(3077),
    [sym__newline] = ACTIONS(3077),
  },
  [2429] = {
    [sym_block_comment] = STATE(2429),
    [sym_compiler_directive_decl] = STATE(2429),
    [sym_fsi_directive_decl] = STATE(2429),
    [sym_preproc_line] = STATE(2429),
    [sym_identifier] = ACTIONS(3003),
    [anon_sym_EQ] = ACTIONS(3005),
    [anon_sym_COLON] = ACTIONS(3003),
    [anon_sym_return] = ACTIONS(3003),
    [anon_sym_do] = ACTIONS(3003),
    [anon_sym_let] = ACTIONS(3003),
    [anon_sym_let_BANG] = ACTIONS(3005),
    [anon_sym_LPAREN] = ACTIONS(3003),
    [anon_sym_COMMA] = ACTIONS(3005),
    [anon_sym_null] = ACTIONS(3003),
    [anon_sym_QMARK] = ACTIONS(3003),
    [anon_sym_COLON_QMARK] = ACTIONS(3003),
    [anon_sym_COLON_COLON] = ACTIONS(3005),
    [anon_sym_AMP] = ACTIONS(3003),
    [anon_sym_LBRACK] = ACTIONS(3003),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3005),
    [anon_sym_LBRACE] = ACTIONS(3003),
    [anon_sym_LT_AT] = ACTIONS(3003),
    [anon_sym_LT_AT_AT] = ACTIONS(3003),
    [anon_sym_AT_AT_GT] = ACTIONS(3003),
    [anon_sym_DOT] = ACTIONS(3003),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3005),
    [anon_sym_new] = ACTIONS(3003),
    [anon_sym_return_BANG] = ACTIONS(3005),
    [anon_sym_yield] = ACTIONS(3003),
    [anon_sym_yield_BANG] = ACTIONS(3005),
    [anon_sym_lazy] = ACTIONS(3003),
    [anon_sym_assert] = ACTIONS(3003),
    [anon_sym_upcast] = ACTIONS(3003),
    [anon_sym_downcast] = ACTIONS(3003),
    [anon_sym_COLON_GT] = ACTIONS(3005),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3005),
    [anon_sym_for] = ACTIONS(3003),
    [anon_sym_while] = ACTIONS(3003),
    [anon_sym_if] = ACTIONS(3003),
    [anon_sym_fun] = ACTIONS(3003),
    [anon_sym_try] = ACTIONS(3003),
    [anon_sym_match] = ACTIONS(3003),
    [anon_sym_match_BANG] = ACTIONS(3005),
    [anon_sym_function] = ACTIONS(3003),
    [anon_sym_LT_DASH] = ACTIONS(3003),
    [anon_sym_DOT_LBRACK] = ACTIONS(3005),
    [anon_sym_LT] = ACTIONS(3005),
    [anon_sym_use] = ACTIONS(3003),
    [anon_sym_use_BANG] = ACTIONS(3005),
    [anon_sym_do_BANG] = ACTIONS(3005),
    [anon_sym_begin] = ACTIONS(3003),
    [anon_sym_LPAREN2] = ACTIONS(3003),
    [anon_sym_or] = ACTIONS(3003),
    [aux_sym_char_token1] = ACTIONS(3005),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3003),
    [anon_sym_DQUOTE] = ACTIONS(3003),
    [anon_sym_AT_DQUOTE] = ACTIONS(3005),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3005),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3005),
    [sym_bool] = ACTIONS(3003),
    [sym_unit] = ACTIONS(3005),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3003),
    [sym_op_identifier] = ACTIONS(3003),
    [anon_sym_PLUS] = ACTIONS(3003),
    [anon_sym_DASH] = ACTIONS(3003),
    [anon_sym_PLUS_DOT] = ACTIONS(3003),
    [anon_sym_DASH_DOT] = ACTIONS(3003),
    [anon_sym_PERCENT] = ACTIONS(3003),
    [anon_sym_AMP_AMP] = ACTIONS(3003),
    [anon_sym_TILDE] = ACTIONS(3005),
    [aux_sym_prefix_op_token1] = ACTIONS(3003),
    [aux_sym_infix_op_token1] = ACTIONS(3005),
    [aux_sym_infix_op_token2] = ACTIONS(3003),
    [anon_sym_PIPE_PIPE] = ACTIONS(3003),
    [anon_sym_BANG_EQ] = ACTIONS(3003),
    [anon_sym_COLON_EQ] = ACTIONS(3005),
    [anon_sym_DOLLAR] = ACTIONS(3003),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3003),
    [sym_int] = ACTIONS(3003),
    [sym_xint] = ACTIONS(3005),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3005),
    [sym__newline] = ACTIONS(3005),
  },
  [2430] = {
    [sym_block_comment] = STATE(2430),
    [sym_compiler_directive_decl] = STATE(2430),
    [sym_fsi_directive_decl] = STATE(2430),
    [sym_preproc_line] = STATE(2430),
    [sym_identifier] = ACTIONS(3027),
    [anon_sym_EQ] = ACTIONS(3029),
    [anon_sym_COLON] = ACTIONS(3027),
    [anon_sym_return] = ACTIONS(3027),
    [anon_sym_do] = ACTIONS(3027),
    [anon_sym_let] = ACTIONS(3027),
    [anon_sym_let_BANG] = ACTIONS(3029),
    [anon_sym_LPAREN] = ACTIONS(3027),
    [anon_sym_COMMA] = ACTIONS(3029),
    [anon_sym_null] = ACTIONS(3027),
    [anon_sym_QMARK] = ACTIONS(3027),
    [anon_sym_COLON_QMARK] = ACTIONS(3027),
    [anon_sym_COLON_COLON] = ACTIONS(3029),
    [anon_sym_AMP] = ACTIONS(3027),
    [anon_sym_LBRACK] = ACTIONS(3027),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3027),
    [anon_sym_LT_AT] = ACTIONS(3027),
    [anon_sym_LT_AT_AT] = ACTIONS(3027),
    [anon_sym_AT_AT_GT] = ACTIONS(3027),
    [anon_sym_DOT] = ACTIONS(3027),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3029),
    [anon_sym_new] = ACTIONS(3027),
    [anon_sym_return_BANG] = ACTIONS(3029),
    [anon_sym_yield] = ACTIONS(3027),
    [anon_sym_yield_BANG] = ACTIONS(3029),
    [anon_sym_lazy] = ACTIONS(3027),
    [anon_sym_assert] = ACTIONS(3027),
    [anon_sym_upcast] = ACTIONS(3027),
    [anon_sym_downcast] = ACTIONS(3027),
    [anon_sym_COLON_GT] = ACTIONS(3029),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3029),
    [anon_sym_for] = ACTIONS(3027),
    [anon_sym_while] = ACTIONS(3027),
    [anon_sym_if] = ACTIONS(3027),
    [anon_sym_fun] = ACTIONS(3027),
    [anon_sym_try] = ACTIONS(3027),
    [anon_sym_match] = ACTIONS(3027),
    [anon_sym_match_BANG] = ACTIONS(3029),
    [anon_sym_function] = ACTIONS(3027),
    [anon_sym_LT_DASH] = ACTIONS(3027),
    [anon_sym_DOT_LBRACK] = ACTIONS(3029),
    [anon_sym_LT] = ACTIONS(3029),
    [anon_sym_use] = ACTIONS(3027),
    [anon_sym_use_BANG] = ACTIONS(3029),
    [anon_sym_do_BANG] = ACTIONS(3029),
    [anon_sym_begin] = ACTIONS(3027),
    [anon_sym_LPAREN2] = ACTIONS(3027),
    [anon_sym_or] = ACTIONS(3027),
    [aux_sym_char_token1] = ACTIONS(3029),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3027),
    [anon_sym_DQUOTE] = ACTIONS(3027),
    [anon_sym_AT_DQUOTE] = ACTIONS(3029),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3029),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3029),
    [sym_bool] = ACTIONS(3027),
    [sym_unit] = ACTIONS(3029),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3027),
    [sym_op_identifier] = ACTIONS(3027),
    [anon_sym_PLUS] = ACTIONS(3027),
    [anon_sym_DASH] = ACTIONS(3027),
    [anon_sym_PLUS_DOT] = ACTIONS(3027),
    [anon_sym_DASH_DOT] = ACTIONS(3027),
    [anon_sym_PERCENT] = ACTIONS(3027),
    [anon_sym_AMP_AMP] = ACTIONS(3027),
    [anon_sym_TILDE] = ACTIONS(3029),
    [aux_sym_prefix_op_token1] = ACTIONS(3027),
    [aux_sym_infix_op_token1] = ACTIONS(3029),
    [aux_sym_infix_op_token2] = ACTIONS(3027),
    [anon_sym_PIPE_PIPE] = ACTIONS(3027),
    [anon_sym_BANG_EQ] = ACTIONS(3027),
    [anon_sym_COLON_EQ] = ACTIONS(3029),
    [anon_sym_DOLLAR] = ACTIONS(3027),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3027),
    [sym_int] = ACTIONS(3027),
    [sym_xint] = ACTIONS(3029),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3029),
    [sym__newline] = ACTIONS(3029),
  },
  [2431] = {
    [sym_block_comment] = STATE(2431),
    [sym_compiler_directive_decl] = STATE(2431),
    [sym_fsi_directive_decl] = STATE(2431),
    [sym_preproc_line] = STATE(2431),
    [sym_identifier] = ACTIONS(3087),
    [anon_sym_EQ] = ACTIONS(3089),
    [anon_sym_COLON] = ACTIONS(3087),
    [anon_sym_return] = ACTIONS(3087),
    [anon_sym_do] = ACTIONS(3087),
    [anon_sym_let] = ACTIONS(3087),
    [anon_sym_let_BANG] = ACTIONS(3089),
    [anon_sym_LPAREN] = ACTIONS(3087),
    [anon_sym_COMMA] = ACTIONS(3089),
    [anon_sym_null] = ACTIONS(3087),
    [anon_sym_QMARK] = ACTIONS(3087),
    [anon_sym_COLON_QMARK] = ACTIONS(3087),
    [anon_sym_COLON_COLON] = ACTIONS(3089),
    [anon_sym_AMP] = ACTIONS(3087),
    [anon_sym_LBRACK] = ACTIONS(3087),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3089),
    [anon_sym_LBRACE] = ACTIONS(3087),
    [anon_sym_LT_AT] = ACTIONS(3087),
    [anon_sym_LT_AT_AT] = ACTIONS(3087),
    [anon_sym_DOT] = ACTIONS(3087),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3089),
    [anon_sym_new] = ACTIONS(3087),
    [anon_sym_return_BANG] = ACTIONS(3089),
    [anon_sym_yield] = ACTIONS(3087),
    [anon_sym_yield_BANG] = ACTIONS(3089),
    [anon_sym_lazy] = ACTIONS(3087),
    [anon_sym_assert] = ACTIONS(3087),
    [anon_sym_upcast] = ACTIONS(3087),
    [anon_sym_downcast] = ACTIONS(3087),
    [anon_sym_COLON_GT] = ACTIONS(3089),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3089),
    [anon_sym_for] = ACTIONS(3087),
    [anon_sym_while] = ACTIONS(3087),
    [anon_sym_if] = ACTIONS(3087),
    [anon_sym_fun] = ACTIONS(3087),
    [anon_sym_try] = ACTIONS(3087),
    [anon_sym_match] = ACTIONS(3087),
    [anon_sym_match_BANG] = ACTIONS(3089),
    [anon_sym_function] = ACTIONS(3087),
    [anon_sym_LT_DASH] = ACTIONS(3087),
    [anon_sym_DOT_LBRACK] = ACTIONS(3089),
    [anon_sym_LT] = ACTIONS(3089),
    [anon_sym_use] = ACTIONS(3087),
    [anon_sym_use_BANG] = ACTIONS(3089),
    [anon_sym_do_BANG] = ACTIONS(3089),
    [anon_sym_begin] = ACTIONS(3087),
    [anon_sym_LPAREN2] = ACTIONS(3087),
    [anon_sym_or] = ACTIONS(3087),
    [aux_sym_char_token1] = ACTIONS(3089),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3087),
    [anon_sym_DQUOTE] = ACTIONS(3087),
    [anon_sym_AT_DQUOTE] = ACTIONS(3089),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3089),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3089),
    [sym_bool] = ACTIONS(3087),
    [sym_unit] = ACTIONS(3089),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3087),
    [sym_op_identifier] = ACTIONS(3087),
    [anon_sym_PLUS] = ACTIONS(3087),
    [anon_sym_DASH] = ACTIONS(3087),
    [anon_sym_PLUS_DOT] = ACTIONS(3087),
    [anon_sym_DASH_DOT] = ACTIONS(3087),
    [anon_sym_PERCENT] = ACTIONS(3087),
    [anon_sym_AMP_AMP] = ACTIONS(3087),
    [anon_sym_TILDE] = ACTIONS(3089),
    [aux_sym_prefix_op_token1] = ACTIONS(3087),
    [aux_sym_infix_op_token1] = ACTIONS(3089),
    [aux_sym_infix_op_token2] = ACTIONS(3087),
    [anon_sym_PIPE_PIPE] = ACTIONS(3087),
    [anon_sym_BANG_EQ] = ACTIONS(3087),
    [anon_sym_COLON_EQ] = ACTIONS(3089),
    [anon_sym_DOLLAR] = ACTIONS(3087),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3087),
    [sym_int] = ACTIONS(3087),
    [sym_xint] = ACTIONS(3089),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3089),
    [anon_sym_POUNDendif] = ACTIONS(3089),
    [sym__newline] = ACTIONS(3089),
  },
  [2432] = {
    [sym_block_comment] = STATE(2432),
    [sym_compiler_directive_decl] = STATE(2432),
    [sym_fsi_directive_decl] = STATE(2432),
    [sym_preproc_line] = STATE(2432),
    [sym_identifier] = ACTIONS(3091),
    [anon_sym_EQ] = ACTIONS(3093),
    [anon_sym_COLON] = ACTIONS(3091),
    [anon_sym_return] = ACTIONS(3091),
    [anon_sym_do] = ACTIONS(3091),
    [anon_sym_let] = ACTIONS(3091),
    [anon_sym_let_BANG] = ACTIONS(3093),
    [anon_sym_LPAREN] = ACTIONS(3091),
    [anon_sym_COMMA] = ACTIONS(3093),
    [anon_sym_null] = ACTIONS(3091),
    [anon_sym_QMARK] = ACTIONS(3091),
    [anon_sym_COLON_QMARK] = ACTIONS(3091),
    [anon_sym_COLON_COLON] = ACTIONS(3093),
    [anon_sym_AMP] = ACTIONS(3091),
    [anon_sym_LBRACK] = ACTIONS(3091),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3093),
    [anon_sym_LBRACE] = ACTIONS(3091),
    [anon_sym_LT_AT] = ACTIONS(3091),
    [anon_sym_LT_AT_AT] = ACTIONS(3091),
    [anon_sym_DOT] = ACTIONS(3091),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3093),
    [anon_sym_new] = ACTIONS(3091),
    [anon_sym_return_BANG] = ACTIONS(3093),
    [anon_sym_yield] = ACTIONS(3091),
    [anon_sym_yield_BANG] = ACTIONS(3093),
    [anon_sym_lazy] = ACTIONS(3091),
    [anon_sym_assert] = ACTIONS(3091),
    [anon_sym_upcast] = ACTIONS(3091),
    [anon_sym_downcast] = ACTIONS(3091),
    [anon_sym_COLON_GT] = ACTIONS(3093),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3093),
    [anon_sym_for] = ACTIONS(3091),
    [anon_sym_while] = ACTIONS(3091),
    [anon_sym_if] = ACTIONS(3091),
    [anon_sym_fun] = ACTIONS(3091),
    [anon_sym_try] = ACTIONS(3091),
    [anon_sym_match] = ACTIONS(3091),
    [anon_sym_match_BANG] = ACTIONS(3093),
    [anon_sym_function] = ACTIONS(3091),
    [anon_sym_LT_DASH] = ACTIONS(3091),
    [anon_sym_DOT_LBRACK] = ACTIONS(3093),
    [anon_sym_LT] = ACTIONS(3093),
    [anon_sym_use] = ACTIONS(3091),
    [anon_sym_use_BANG] = ACTIONS(3093),
    [anon_sym_do_BANG] = ACTIONS(3093),
    [anon_sym_begin] = ACTIONS(3091),
    [anon_sym_LPAREN2] = ACTIONS(3091),
    [anon_sym_or] = ACTIONS(3091),
    [aux_sym_char_token1] = ACTIONS(3093),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3091),
    [anon_sym_DQUOTE] = ACTIONS(3091),
    [anon_sym_AT_DQUOTE] = ACTIONS(3093),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3093),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3093),
    [sym_bool] = ACTIONS(3091),
    [sym_unit] = ACTIONS(3093),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3091),
    [sym_op_identifier] = ACTIONS(3091),
    [anon_sym_PLUS] = ACTIONS(3091),
    [anon_sym_DASH] = ACTIONS(3091),
    [anon_sym_PLUS_DOT] = ACTIONS(3091),
    [anon_sym_DASH_DOT] = ACTIONS(3091),
    [anon_sym_PERCENT] = ACTIONS(3091),
    [anon_sym_AMP_AMP] = ACTIONS(3091),
    [anon_sym_TILDE] = ACTIONS(3093),
    [aux_sym_prefix_op_token1] = ACTIONS(3091),
    [aux_sym_infix_op_token1] = ACTIONS(3093),
    [aux_sym_infix_op_token2] = ACTIONS(3091),
    [anon_sym_PIPE_PIPE] = ACTIONS(3091),
    [anon_sym_BANG_EQ] = ACTIONS(3091),
    [anon_sym_COLON_EQ] = ACTIONS(3093),
    [anon_sym_DOLLAR] = ACTIONS(3091),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3091),
    [sym_int] = ACTIONS(3091),
    [sym_xint] = ACTIONS(3093),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3093),
    [anon_sym_POUNDendif] = ACTIONS(3093),
    [sym__newline] = ACTIONS(3093),
  },
  [2433] = {
    [sym_block_comment] = STATE(2433),
    [sym_compiler_directive_decl] = STATE(2433),
    [sym_fsi_directive_decl] = STATE(2433),
    [sym_preproc_line] = STATE(2433),
    [sym_identifier] = ACTIONS(3031),
    [anon_sym_EQ] = ACTIONS(3033),
    [anon_sym_COLON] = ACTIONS(3031),
    [anon_sym_return] = ACTIONS(3031),
    [anon_sym_do] = ACTIONS(3031),
    [anon_sym_let] = ACTIONS(3031),
    [anon_sym_let_BANG] = ACTIONS(3033),
    [anon_sym_LPAREN] = ACTIONS(3031),
    [anon_sym_COMMA] = ACTIONS(3033),
    [anon_sym_null] = ACTIONS(3031),
    [anon_sym_QMARK] = ACTIONS(3031),
    [anon_sym_COLON_QMARK] = ACTIONS(3031),
    [anon_sym_COLON_COLON] = ACTIONS(3033),
    [anon_sym_AMP] = ACTIONS(3031),
    [anon_sym_LBRACK] = ACTIONS(3031),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3033),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [anon_sym_LT_AT] = ACTIONS(3031),
    [anon_sym_LT_AT_AT] = ACTIONS(3031),
    [anon_sym_AT_AT_GT] = ACTIONS(3031),
    [anon_sym_DOT] = ACTIONS(3031),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3033),
    [anon_sym_new] = ACTIONS(3031),
    [anon_sym_return_BANG] = ACTIONS(3033),
    [anon_sym_yield] = ACTIONS(3031),
    [anon_sym_yield_BANG] = ACTIONS(3033),
    [anon_sym_lazy] = ACTIONS(3031),
    [anon_sym_assert] = ACTIONS(3031),
    [anon_sym_upcast] = ACTIONS(3031),
    [anon_sym_downcast] = ACTIONS(3031),
    [anon_sym_COLON_GT] = ACTIONS(3033),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3033),
    [anon_sym_for] = ACTIONS(3031),
    [anon_sym_while] = ACTIONS(3031),
    [anon_sym_if] = ACTIONS(3031),
    [anon_sym_fun] = ACTIONS(3031),
    [anon_sym_try] = ACTIONS(3031),
    [anon_sym_match] = ACTIONS(3031),
    [anon_sym_match_BANG] = ACTIONS(3033),
    [anon_sym_function] = ACTIONS(3031),
    [anon_sym_LT_DASH] = ACTIONS(3031),
    [anon_sym_DOT_LBRACK] = ACTIONS(3033),
    [anon_sym_LT] = ACTIONS(3033),
    [anon_sym_use] = ACTIONS(3031),
    [anon_sym_use_BANG] = ACTIONS(3033),
    [anon_sym_do_BANG] = ACTIONS(3033),
    [anon_sym_begin] = ACTIONS(3031),
    [anon_sym_LPAREN2] = ACTIONS(3031),
    [anon_sym_or] = ACTIONS(3031),
    [aux_sym_char_token1] = ACTIONS(3033),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3031),
    [anon_sym_DQUOTE] = ACTIONS(3031),
    [anon_sym_AT_DQUOTE] = ACTIONS(3033),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3033),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3033),
    [sym_bool] = ACTIONS(3031),
    [sym_unit] = ACTIONS(3033),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3031),
    [sym_op_identifier] = ACTIONS(3031),
    [anon_sym_PLUS] = ACTIONS(3031),
    [anon_sym_DASH] = ACTIONS(3031),
    [anon_sym_PLUS_DOT] = ACTIONS(3031),
    [anon_sym_DASH_DOT] = ACTIONS(3031),
    [anon_sym_PERCENT] = ACTIONS(3031),
    [anon_sym_AMP_AMP] = ACTIONS(3031),
    [anon_sym_TILDE] = ACTIONS(3033),
    [aux_sym_prefix_op_token1] = ACTIONS(3031),
    [aux_sym_infix_op_token1] = ACTIONS(3033),
    [aux_sym_infix_op_token2] = ACTIONS(3031),
    [anon_sym_PIPE_PIPE] = ACTIONS(3031),
    [anon_sym_BANG_EQ] = ACTIONS(3031),
    [anon_sym_COLON_EQ] = ACTIONS(3033),
    [anon_sym_DOLLAR] = ACTIONS(3031),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3031),
    [sym_int] = ACTIONS(3031),
    [sym_xint] = ACTIONS(3033),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3033),
    [sym__newline] = ACTIONS(3033),
  },
  [2434] = {
    [sym_block_comment] = STATE(2434),
    [sym_compiler_directive_decl] = STATE(2434),
    [sym_fsi_directive_decl] = STATE(2434),
    [sym_preproc_line] = STATE(2434),
    [sym_identifier] = ACTIONS(3035),
    [anon_sym_EQ] = ACTIONS(3037),
    [anon_sym_COLON] = ACTIONS(3035),
    [anon_sym_return] = ACTIONS(3035),
    [anon_sym_do] = ACTIONS(3035),
    [anon_sym_let] = ACTIONS(3035),
    [anon_sym_let_BANG] = ACTIONS(3037),
    [anon_sym_LPAREN] = ACTIONS(3035),
    [anon_sym_COMMA] = ACTIONS(3037),
    [anon_sym_null] = ACTIONS(3035),
    [anon_sym_QMARK] = ACTIONS(3035),
    [anon_sym_COLON_QMARK] = ACTIONS(3035),
    [anon_sym_COLON_COLON] = ACTIONS(3037),
    [anon_sym_AMP] = ACTIONS(3035),
    [anon_sym_LBRACK] = ACTIONS(3035),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3037),
    [anon_sym_LBRACE] = ACTIONS(3035),
    [anon_sym_LT_AT] = ACTIONS(3035),
    [anon_sym_LT_AT_AT] = ACTIONS(3035),
    [anon_sym_AT_AT_GT] = ACTIONS(3035),
    [anon_sym_DOT] = ACTIONS(3035),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3037),
    [anon_sym_new] = ACTIONS(3035),
    [anon_sym_return_BANG] = ACTIONS(3037),
    [anon_sym_yield] = ACTIONS(3035),
    [anon_sym_yield_BANG] = ACTIONS(3037),
    [anon_sym_lazy] = ACTIONS(3035),
    [anon_sym_assert] = ACTIONS(3035),
    [anon_sym_upcast] = ACTIONS(3035),
    [anon_sym_downcast] = ACTIONS(3035),
    [anon_sym_COLON_GT] = ACTIONS(3037),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3037),
    [anon_sym_for] = ACTIONS(3035),
    [anon_sym_while] = ACTIONS(3035),
    [anon_sym_if] = ACTIONS(3035),
    [anon_sym_fun] = ACTIONS(3035),
    [anon_sym_try] = ACTIONS(3035),
    [anon_sym_match] = ACTIONS(3035),
    [anon_sym_match_BANG] = ACTIONS(3037),
    [anon_sym_function] = ACTIONS(3035),
    [anon_sym_LT_DASH] = ACTIONS(3035),
    [anon_sym_DOT_LBRACK] = ACTIONS(3037),
    [anon_sym_LT] = ACTIONS(3037),
    [anon_sym_use] = ACTIONS(3035),
    [anon_sym_use_BANG] = ACTIONS(3037),
    [anon_sym_do_BANG] = ACTIONS(3037),
    [anon_sym_begin] = ACTIONS(3035),
    [anon_sym_LPAREN2] = ACTIONS(3035),
    [anon_sym_or] = ACTIONS(3035),
    [aux_sym_char_token1] = ACTIONS(3037),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3035),
    [anon_sym_DQUOTE] = ACTIONS(3035),
    [anon_sym_AT_DQUOTE] = ACTIONS(3037),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3037),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3037),
    [sym_bool] = ACTIONS(3035),
    [sym_unit] = ACTIONS(3037),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3035),
    [sym_op_identifier] = ACTIONS(3035),
    [anon_sym_PLUS] = ACTIONS(3035),
    [anon_sym_DASH] = ACTIONS(3035),
    [anon_sym_PLUS_DOT] = ACTIONS(3035),
    [anon_sym_DASH_DOT] = ACTIONS(3035),
    [anon_sym_PERCENT] = ACTIONS(3035),
    [anon_sym_AMP_AMP] = ACTIONS(3035),
    [anon_sym_TILDE] = ACTIONS(3037),
    [aux_sym_prefix_op_token1] = ACTIONS(3035),
    [aux_sym_infix_op_token1] = ACTIONS(3037),
    [aux_sym_infix_op_token2] = ACTIONS(3035),
    [anon_sym_PIPE_PIPE] = ACTIONS(3035),
    [anon_sym_BANG_EQ] = ACTIONS(3035),
    [anon_sym_COLON_EQ] = ACTIONS(3037),
    [anon_sym_DOLLAR] = ACTIONS(3035),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3035),
    [sym_int] = ACTIONS(3035),
    [sym_xint] = ACTIONS(3037),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3037),
    [sym__newline] = ACTIONS(3037),
  },
  [2435] = {
    [sym_block_comment] = STATE(2435),
    [sym_compiler_directive_decl] = STATE(2435),
    [sym_fsi_directive_decl] = STATE(2435),
    [sym_preproc_line] = STATE(2435),
    [sym_identifier] = ACTIONS(3115),
    [anon_sym_EQ] = ACTIONS(3117),
    [anon_sym_COLON] = ACTIONS(3115),
    [anon_sym_return] = ACTIONS(3115),
    [anon_sym_do] = ACTIONS(3115),
    [anon_sym_let] = ACTIONS(3115),
    [anon_sym_let_BANG] = ACTIONS(3117),
    [anon_sym_LPAREN] = ACTIONS(3115),
    [anon_sym_COMMA] = ACTIONS(3117),
    [anon_sym_null] = ACTIONS(3115),
    [anon_sym_QMARK] = ACTIONS(3115),
    [anon_sym_COLON_QMARK] = ACTIONS(3115),
    [anon_sym_COLON_COLON] = ACTIONS(3117),
    [anon_sym_AMP] = ACTIONS(3115),
    [anon_sym_LBRACK] = ACTIONS(3115),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3117),
    [anon_sym_LBRACE] = ACTIONS(3115),
    [anon_sym_LT_AT] = ACTIONS(3115),
    [anon_sym_LT_AT_AT] = ACTIONS(3115),
    [anon_sym_DOT] = ACTIONS(3115),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3117),
    [anon_sym_new] = ACTIONS(3115),
    [anon_sym_return_BANG] = ACTIONS(3117),
    [anon_sym_yield] = ACTIONS(3115),
    [anon_sym_yield_BANG] = ACTIONS(3117),
    [anon_sym_lazy] = ACTIONS(3115),
    [anon_sym_assert] = ACTIONS(3115),
    [anon_sym_upcast] = ACTIONS(3115),
    [anon_sym_downcast] = ACTIONS(3115),
    [anon_sym_COLON_GT] = ACTIONS(3117),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3117),
    [anon_sym_for] = ACTIONS(3115),
    [anon_sym_while] = ACTIONS(3115),
    [anon_sym_if] = ACTIONS(3115),
    [anon_sym_fun] = ACTIONS(3115),
    [anon_sym_try] = ACTIONS(3115),
    [anon_sym_match] = ACTIONS(3115),
    [anon_sym_match_BANG] = ACTIONS(3117),
    [anon_sym_function] = ACTIONS(3115),
    [anon_sym_LT_DASH] = ACTIONS(3115),
    [anon_sym_DOT_LBRACK] = ACTIONS(3117),
    [anon_sym_LT] = ACTIONS(3117),
    [anon_sym_use] = ACTIONS(3115),
    [anon_sym_use_BANG] = ACTIONS(3117),
    [anon_sym_do_BANG] = ACTIONS(3117),
    [anon_sym_DOT_DOT] = ACTIONS(3117),
    [anon_sym_begin] = ACTIONS(3115),
    [anon_sym_LPAREN2] = ACTIONS(3115),
    [anon_sym_or] = ACTIONS(3115),
    [aux_sym_char_token1] = ACTIONS(3117),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3115),
    [anon_sym_DQUOTE] = ACTIONS(3115),
    [anon_sym_AT_DQUOTE] = ACTIONS(3117),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3117),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3117),
    [sym_bool] = ACTIONS(3115),
    [sym_unit] = ACTIONS(3117),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3115),
    [sym_op_identifier] = ACTIONS(3115),
    [anon_sym_PLUS] = ACTIONS(3115),
    [anon_sym_DASH] = ACTIONS(3115),
    [anon_sym_PLUS_DOT] = ACTIONS(3115),
    [anon_sym_DASH_DOT] = ACTIONS(3115),
    [anon_sym_PERCENT] = ACTIONS(3115),
    [anon_sym_AMP_AMP] = ACTIONS(3115),
    [anon_sym_TILDE] = ACTIONS(3117),
    [aux_sym_prefix_op_token1] = ACTIONS(3115),
    [aux_sym_infix_op_token1] = ACTIONS(3117),
    [aux_sym_infix_op_token2] = ACTIONS(3115),
    [anon_sym_PIPE_PIPE] = ACTIONS(3115),
    [anon_sym_BANG_EQ] = ACTIONS(3115),
    [anon_sym_COLON_EQ] = ACTIONS(3117),
    [anon_sym_DOLLAR] = ACTIONS(3115),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3115),
    [sym_int] = ACTIONS(3115),
    [sym_xint] = ACTIONS(3117),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3117),
    [sym__newline] = ACTIONS(3117),
  },
  [2436] = {
    [sym_block_comment] = STATE(2436),
    [sym_compiler_directive_decl] = STATE(2436),
    [sym_fsi_directive_decl] = STATE(2436),
    [sym_preproc_line] = STATE(2436),
    [sym_identifier] = ACTIONS(2996),
    [anon_sym_EQ] = ACTIONS(2998),
    [anon_sym_COLON] = ACTIONS(2996),
    [anon_sym_return] = ACTIONS(2996),
    [anon_sym_do] = ACTIONS(2996),
    [anon_sym_let] = ACTIONS(2996),
    [anon_sym_let_BANG] = ACTIONS(2998),
    [anon_sym_LPAREN] = ACTIONS(2996),
    [anon_sym_COMMA] = ACTIONS(2998),
    [anon_sym_null] = ACTIONS(2996),
    [anon_sym_QMARK] = ACTIONS(2996),
    [anon_sym_COLON_QMARK] = ACTIONS(2996),
    [anon_sym_COLON_COLON] = ACTIONS(2998),
    [anon_sym_AMP] = ACTIONS(2996),
    [anon_sym_LBRACK] = ACTIONS(2996),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2998),
    [anon_sym_LBRACE] = ACTIONS(2996),
    [anon_sym_LT_AT] = ACTIONS(2996),
    [anon_sym_LT_AT_AT] = ACTIONS(2996),
    [anon_sym_AT_AT_GT] = ACTIONS(2996),
    [anon_sym_DOT] = ACTIONS(2996),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2998),
    [anon_sym_new] = ACTIONS(2996),
    [anon_sym_return_BANG] = ACTIONS(2998),
    [anon_sym_yield] = ACTIONS(2996),
    [anon_sym_yield_BANG] = ACTIONS(2998),
    [anon_sym_lazy] = ACTIONS(2996),
    [anon_sym_assert] = ACTIONS(2996),
    [anon_sym_upcast] = ACTIONS(2996),
    [anon_sym_downcast] = ACTIONS(2996),
    [anon_sym_COLON_GT] = ACTIONS(2998),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2998),
    [anon_sym_for] = ACTIONS(2996),
    [anon_sym_while] = ACTIONS(2996),
    [anon_sym_if] = ACTIONS(2996),
    [anon_sym_fun] = ACTIONS(2996),
    [anon_sym_try] = ACTIONS(2996),
    [anon_sym_match] = ACTIONS(2996),
    [anon_sym_match_BANG] = ACTIONS(2998),
    [anon_sym_function] = ACTIONS(2996),
    [anon_sym_LT_DASH] = ACTIONS(2996),
    [anon_sym_DOT_LBRACK] = ACTIONS(2998),
    [anon_sym_LT] = ACTIONS(2998),
    [anon_sym_use] = ACTIONS(2996),
    [anon_sym_use_BANG] = ACTIONS(2998),
    [anon_sym_do_BANG] = ACTIONS(2998),
    [anon_sym_begin] = ACTIONS(2996),
    [anon_sym_LPAREN2] = ACTIONS(2996),
    [anon_sym_or] = ACTIONS(2996),
    [aux_sym_char_token1] = ACTIONS(2998),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2996),
    [anon_sym_DQUOTE] = ACTIONS(2996),
    [anon_sym_AT_DQUOTE] = ACTIONS(2998),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2998),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2998),
    [sym_bool] = ACTIONS(2996),
    [sym_unit] = ACTIONS(2998),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2996),
    [sym_op_identifier] = ACTIONS(2996),
    [anon_sym_PLUS] = ACTIONS(2996),
    [anon_sym_DASH] = ACTIONS(2996),
    [anon_sym_PLUS_DOT] = ACTIONS(2996),
    [anon_sym_DASH_DOT] = ACTIONS(2996),
    [anon_sym_PERCENT] = ACTIONS(2996),
    [anon_sym_AMP_AMP] = ACTIONS(2996),
    [anon_sym_TILDE] = ACTIONS(2998),
    [aux_sym_prefix_op_token1] = ACTIONS(2996),
    [aux_sym_infix_op_token1] = ACTIONS(2998),
    [aux_sym_infix_op_token2] = ACTIONS(2996),
    [anon_sym_PIPE_PIPE] = ACTIONS(2996),
    [anon_sym_BANG_EQ] = ACTIONS(2996),
    [anon_sym_COLON_EQ] = ACTIONS(2998),
    [anon_sym_DOLLAR] = ACTIONS(2996),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2996),
    [sym_int] = ACTIONS(2996),
    [sym_xint] = ACTIONS(2998),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2998),
    [sym__newline] = ACTIONS(2998),
  },
  [2437] = {
    [sym_block_comment] = STATE(2437),
    [sym_compiler_directive_decl] = STATE(2437),
    [sym_fsi_directive_decl] = STATE(2437),
    [sym_preproc_line] = STATE(2437),
    [sym_identifier] = ACTIONS(2992),
    [anon_sym_EQ] = ACTIONS(2994),
    [anon_sym_COLON] = ACTIONS(2992),
    [anon_sym_return] = ACTIONS(2992),
    [anon_sym_do] = ACTIONS(2992),
    [anon_sym_let] = ACTIONS(2992),
    [anon_sym_let_BANG] = ACTIONS(2994),
    [anon_sym_LPAREN] = ACTIONS(2992),
    [anon_sym_COMMA] = ACTIONS(2994),
    [anon_sym_null] = ACTIONS(2992),
    [anon_sym_QMARK] = ACTIONS(2992),
    [anon_sym_COLON_QMARK] = ACTIONS(2992),
    [anon_sym_COLON_COLON] = ACTIONS(2994),
    [anon_sym_AMP] = ACTIONS(2992),
    [anon_sym_LBRACK] = ACTIONS(2992),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2994),
    [anon_sym_LBRACE] = ACTIONS(2992),
    [anon_sym_LT_AT] = ACTIONS(2992),
    [anon_sym_LT_AT_AT] = ACTIONS(2992),
    [anon_sym_AT_AT_GT] = ACTIONS(2992),
    [anon_sym_DOT] = ACTIONS(2992),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2994),
    [anon_sym_new] = ACTIONS(2992),
    [anon_sym_return_BANG] = ACTIONS(2994),
    [anon_sym_yield] = ACTIONS(2992),
    [anon_sym_yield_BANG] = ACTIONS(2994),
    [anon_sym_lazy] = ACTIONS(2992),
    [anon_sym_assert] = ACTIONS(2992),
    [anon_sym_upcast] = ACTIONS(2992),
    [anon_sym_downcast] = ACTIONS(2992),
    [anon_sym_COLON_GT] = ACTIONS(2994),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2994),
    [anon_sym_for] = ACTIONS(2992),
    [anon_sym_while] = ACTIONS(2992),
    [anon_sym_if] = ACTIONS(2992),
    [anon_sym_fun] = ACTIONS(2992),
    [anon_sym_try] = ACTIONS(2992),
    [anon_sym_match] = ACTIONS(2992),
    [anon_sym_match_BANG] = ACTIONS(2994),
    [anon_sym_function] = ACTIONS(2992),
    [anon_sym_LT_DASH] = ACTIONS(2992),
    [anon_sym_DOT_LBRACK] = ACTIONS(2994),
    [anon_sym_LT] = ACTIONS(2994),
    [anon_sym_use] = ACTIONS(2992),
    [anon_sym_use_BANG] = ACTIONS(2994),
    [anon_sym_do_BANG] = ACTIONS(2994),
    [anon_sym_begin] = ACTIONS(2992),
    [anon_sym_LPAREN2] = ACTIONS(2992),
    [anon_sym_or] = ACTIONS(2992),
    [aux_sym_char_token1] = ACTIONS(2994),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2992),
    [anon_sym_DQUOTE] = ACTIONS(2992),
    [anon_sym_AT_DQUOTE] = ACTIONS(2994),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2994),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2994),
    [sym_bool] = ACTIONS(2992),
    [sym_unit] = ACTIONS(2994),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2992),
    [sym_op_identifier] = ACTIONS(2992),
    [anon_sym_PLUS] = ACTIONS(2992),
    [anon_sym_DASH] = ACTIONS(2992),
    [anon_sym_PLUS_DOT] = ACTIONS(2992),
    [anon_sym_DASH_DOT] = ACTIONS(2992),
    [anon_sym_PERCENT] = ACTIONS(2992),
    [anon_sym_AMP_AMP] = ACTIONS(2992),
    [anon_sym_TILDE] = ACTIONS(2994),
    [aux_sym_prefix_op_token1] = ACTIONS(2992),
    [aux_sym_infix_op_token1] = ACTIONS(2994),
    [aux_sym_infix_op_token2] = ACTIONS(2992),
    [anon_sym_PIPE_PIPE] = ACTIONS(2992),
    [anon_sym_BANG_EQ] = ACTIONS(2992),
    [anon_sym_COLON_EQ] = ACTIONS(2994),
    [anon_sym_DOLLAR] = ACTIONS(2992),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2992),
    [sym_int] = ACTIONS(2992),
    [sym_xint] = ACTIONS(2994),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2994),
    [sym__newline] = ACTIONS(2994),
  },
  [2438] = {
    [sym_block_comment] = STATE(2438),
    [sym_compiler_directive_decl] = STATE(2438),
    [sym_fsi_directive_decl] = STATE(2438),
    [sym_preproc_line] = STATE(2438),
    [sym_identifier] = ACTIONS(2411),
    [anon_sym_EQ] = ACTIONS(2413),
    [anon_sym_COLON] = ACTIONS(2411),
    [anon_sym_return] = ACTIONS(2411),
    [anon_sym_do] = ACTIONS(2411),
    [anon_sym_let] = ACTIONS(2411),
    [anon_sym_let_BANG] = ACTIONS(2413),
    [anon_sym_LPAREN] = ACTIONS(2411),
    [anon_sym_COMMA] = ACTIONS(2413),
    [anon_sym_null] = ACTIONS(2411),
    [anon_sym_QMARK] = ACTIONS(2411),
    [anon_sym_COLON_QMARK] = ACTIONS(2411),
    [anon_sym_COLON_COLON] = ACTIONS(2413),
    [anon_sym_AMP] = ACTIONS(2411),
    [anon_sym_LBRACK] = ACTIONS(2411),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2413),
    [anon_sym_LBRACE] = ACTIONS(2411),
    [anon_sym_LT_AT] = ACTIONS(2411),
    [anon_sym_LT_AT_AT] = ACTIONS(2411),
    [anon_sym_AT_AT_GT] = ACTIONS(2411),
    [anon_sym_DOT] = ACTIONS(2411),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2413),
    [anon_sym_new] = ACTIONS(2411),
    [anon_sym_return_BANG] = ACTIONS(2413),
    [anon_sym_yield] = ACTIONS(2411),
    [anon_sym_yield_BANG] = ACTIONS(2413),
    [anon_sym_lazy] = ACTIONS(2411),
    [anon_sym_assert] = ACTIONS(2411),
    [anon_sym_upcast] = ACTIONS(2411),
    [anon_sym_downcast] = ACTIONS(2411),
    [anon_sym_COLON_GT] = ACTIONS(2413),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2413),
    [anon_sym_for] = ACTIONS(2411),
    [anon_sym_while] = ACTIONS(2411),
    [anon_sym_if] = ACTIONS(2411),
    [anon_sym_fun] = ACTIONS(2411),
    [anon_sym_try] = ACTIONS(2411),
    [anon_sym_match] = ACTIONS(2411),
    [anon_sym_match_BANG] = ACTIONS(2413),
    [anon_sym_function] = ACTIONS(2411),
    [anon_sym_LT_DASH] = ACTIONS(2411),
    [anon_sym_DOT_LBRACK] = ACTIONS(2413),
    [anon_sym_LT] = ACTIONS(2413),
    [anon_sym_use] = ACTIONS(2411),
    [anon_sym_use_BANG] = ACTIONS(2413),
    [anon_sym_do_BANG] = ACTIONS(2413),
    [anon_sym_begin] = ACTIONS(2411),
    [anon_sym_LPAREN2] = ACTIONS(2411),
    [anon_sym_or] = ACTIONS(2411),
    [aux_sym_char_token1] = ACTIONS(2413),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2411),
    [anon_sym_DQUOTE] = ACTIONS(2411),
    [anon_sym_AT_DQUOTE] = ACTIONS(2413),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2413),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2413),
    [sym_bool] = ACTIONS(2411),
    [sym_unit] = ACTIONS(2413),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2411),
    [sym_op_identifier] = ACTIONS(2411),
    [anon_sym_PLUS] = ACTIONS(2411),
    [anon_sym_DASH] = ACTIONS(2411),
    [anon_sym_PLUS_DOT] = ACTIONS(2411),
    [anon_sym_DASH_DOT] = ACTIONS(2411),
    [anon_sym_PERCENT] = ACTIONS(2411),
    [anon_sym_AMP_AMP] = ACTIONS(2411),
    [anon_sym_TILDE] = ACTIONS(2413),
    [aux_sym_prefix_op_token1] = ACTIONS(2411),
    [aux_sym_infix_op_token1] = ACTIONS(2413),
    [aux_sym_infix_op_token2] = ACTIONS(2411),
    [anon_sym_PIPE_PIPE] = ACTIONS(2411),
    [anon_sym_BANG_EQ] = ACTIONS(2411),
    [anon_sym_COLON_EQ] = ACTIONS(2413),
    [anon_sym_DOLLAR] = ACTIONS(2411),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2411),
    [sym_int] = ACTIONS(2411),
    [sym_xint] = ACTIONS(2413),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2413),
    [sym__newline] = ACTIONS(2413),
  },
  [2439] = {
    [sym_block_comment] = STATE(2439),
    [sym_compiler_directive_decl] = STATE(2439),
    [sym_fsi_directive_decl] = STATE(2439),
    [sym_preproc_line] = STATE(2439),
    [sym_identifier] = ACTIONS(3123),
    [anon_sym_EQ] = ACTIONS(3125),
    [anon_sym_COLON] = ACTIONS(3123),
    [anon_sym_return] = ACTIONS(3123),
    [anon_sym_do] = ACTIONS(3123),
    [anon_sym_let] = ACTIONS(3123),
    [anon_sym_let_BANG] = ACTIONS(3125),
    [anon_sym_LPAREN] = ACTIONS(3123),
    [anon_sym_COMMA] = ACTIONS(3125),
    [anon_sym_null] = ACTIONS(3123),
    [anon_sym_QMARK] = ACTIONS(3123),
    [anon_sym_COLON_QMARK] = ACTIONS(3123),
    [anon_sym_COLON_COLON] = ACTIONS(3125),
    [anon_sym_AMP] = ACTIONS(3123),
    [anon_sym_LBRACK] = ACTIONS(3123),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3125),
    [anon_sym_LBRACE] = ACTIONS(3123),
    [anon_sym_LT_AT] = ACTIONS(3123),
    [anon_sym_LT_AT_AT] = ACTIONS(3123),
    [anon_sym_DOT] = ACTIONS(3123),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3125),
    [anon_sym_new] = ACTIONS(3123),
    [anon_sym_return_BANG] = ACTIONS(3125),
    [anon_sym_yield] = ACTIONS(3123),
    [anon_sym_yield_BANG] = ACTIONS(3125),
    [anon_sym_lazy] = ACTIONS(3123),
    [anon_sym_assert] = ACTIONS(3123),
    [anon_sym_upcast] = ACTIONS(3123),
    [anon_sym_downcast] = ACTIONS(3123),
    [anon_sym_COLON_GT] = ACTIONS(3125),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3125),
    [anon_sym_for] = ACTIONS(3123),
    [anon_sym_while] = ACTIONS(3123),
    [anon_sym_if] = ACTIONS(3123),
    [anon_sym_fun] = ACTIONS(3123),
    [anon_sym_try] = ACTIONS(3123),
    [anon_sym_match] = ACTIONS(3123),
    [anon_sym_match_BANG] = ACTIONS(3125),
    [anon_sym_function] = ACTIONS(3123),
    [anon_sym_LT_DASH] = ACTIONS(3123),
    [anon_sym_DOT_LBRACK] = ACTIONS(3125),
    [anon_sym_LT] = ACTIONS(3125),
    [anon_sym_use] = ACTIONS(3123),
    [anon_sym_use_BANG] = ACTIONS(3125),
    [anon_sym_do_BANG] = ACTIONS(3125),
    [anon_sym_begin] = ACTIONS(3123),
    [anon_sym_LPAREN2] = ACTIONS(3123),
    [anon_sym_or] = ACTIONS(3123),
    [aux_sym_char_token1] = ACTIONS(3125),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3123),
    [anon_sym_DQUOTE] = ACTIONS(3123),
    [anon_sym_AT_DQUOTE] = ACTIONS(3125),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3125),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3125),
    [sym_bool] = ACTIONS(3123),
    [sym_unit] = ACTIONS(3125),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3123),
    [sym_op_identifier] = ACTIONS(3123),
    [anon_sym_PLUS] = ACTIONS(3123),
    [anon_sym_DASH] = ACTIONS(3123),
    [anon_sym_PLUS_DOT] = ACTIONS(3123),
    [anon_sym_DASH_DOT] = ACTIONS(3123),
    [anon_sym_PERCENT] = ACTIONS(3123),
    [anon_sym_AMP_AMP] = ACTIONS(3123),
    [anon_sym_TILDE] = ACTIONS(3125),
    [aux_sym_prefix_op_token1] = ACTIONS(3123),
    [aux_sym_infix_op_token1] = ACTIONS(3125),
    [aux_sym_infix_op_token2] = ACTIONS(3123),
    [anon_sym_PIPE_PIPE] = ACTIONS(3123),
    [anon_sym_BANG_EQ] = ACTIONS(3123),
    [anon_sym_COLON_EQ] = ACTIONS(3125),
    [anon_sym_DOLLAR] = ACTIONS(3123),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3123),
    [sym_int] = ACTIONS(3123),
    [sym_xint] = ACTIONS(3125),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3125),
    [anon_sym_POUNDendif] = ACTIONS(3125),
    [sym__newline] = ACTIONS(3125),
  },
  [2440] = {
    [sym_block_comment] = STATE(2440),
    [sym_compiler_directive_decl] = STATE(2440),
    [sym_fsi_directive_decl] = STATE(2440),
    [sym_preproc_line] = STATE(2440),
    [sym_identifier] = ACTIONS(3127),
    [anon_sym_EQ] = ACTIONS(3129),
    [anon_sym_COLON] = ACTIONS(3127),
    [anon_sym_return] = ACTIONS(3127),
    [anon_sym_do] = ACTIONS(3127),
    [anon_sym_let] = ACTIONS(3127),
    [anon_sym_let_BANG] = ACTIONS(3129),
    [anon_sym_LPAREN] = ACTIONS(3127),
    [anon_sym_COMMA] = ACTIONS(3129),
    [anon_sym_null] = ACTIONS(3127),
    [anon_sym_QMARK] = ACTIONS(3127),
    [anon_sym_COLON_QMARK] = ACTIONS(3127),
    [anon_sym_COLON_COLON] = ACTIONS(3129),
    [anon_sym_AMP] = ACTIONS(3127),
    [anon_sym_LBRACK] = ACTIONS(3127),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3129),
    [anon_sym_LBRACE] = ACTIONS(3127),
    [anon_sym_LT_AT] = ACTIONS(3127),
    [anon_sym_LT_AT_AT] = ACTIONS(3127),
    [anon_sym_DOT] = ACTIONS(3127),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3129),
    [anon_sym_new] = ACTIONS(3127),
    [anon_sym_return_BANG] = ACTIONS(3129),
    [anon_sym_yield] = ACTIONS(3127),
    [anon_sym_yield_BANG] = ACTIONS(3129),
    [anon_sym_lazy] = ACTIONS(3127),
    [anon_sym_assert] = ACTIONS(3127),
    [anon_sym_upcast] = ACTIONS(3127),
    [anon_sym_downcast] = ACTIONS(3127),
    [anon_sym_COLON_GT] = ACTIONS(3129),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3129),
    [anon_sym_for] = ACTIONS(3127),
    [anon_sym_while] = ACTIONS(3127),
    [anon_sym_if] = ACTIONS(3127),
    [anon_sym_fun] = ACTIONS(3127),
    [anon_sym_try] = ACTIONS(3127),
    [anon_sym_match] = ACTIONS(3127),
    [anon_sym_match_BANG] = ACTIONS(3129),
    [anon_sym_function] = ACTIONS(3127),
    [anon_sym_LT_DASH] = ACTIONS(3127),
    [anon_sym_DOT_LBRACK] = ACTIONS(3129),
    [anon_sym_LT] = ACTIONS(3129),
    [anon_sym_use] = ACTIONS(3127),
    [anon_sym_use_BANG] = ACTIONS(3129),
    [anon_sym_do_BANG] = ACTIONS(3129),
    [anon_sym_begin] = ACTIONS(3127),
    [anon_sym_LPAREN2] = ACTIONS(3127),
    [anon_sym_or] = ACTIONS(3127),
    [aux_sym_char_token1] = ACTIONS(3129),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3127),
    [anon_sym_DQUOTE] = ACTIONS(3127),
    [anon_sym_AT_DQUOTE] = ACTIONS(3129),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3129),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3129),
    [sym_bool] = ACTIONS(3127),
    [sym_unit] = ACTIONS(3129),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3127),
    [sym_op_identifier] = ACTIONS(3127),
    [anon_sym_PLUS] = ACTIONS(3127),
    [anon_sym_DASH] = ACTIONS(3127),
    [anon_sym_PLUS_DOT] = ACTIONS(3127),
    [anon_sym_DASH_DOT] = ACTIONS(3127),
    [anon_sym_PERCENT] = ACTIONS(3127),
    [anon_sym_AMP_AMP] = ACTIONS(3127),
    [anon_sym_TILDE] = ACTIONS(3129),
    [aux_sym_prefix_op_token1] = ACTIONS(3127),
    [aux_sym_infix_op_token1] = ACTIONS(3129),
    [aux_sym_infix_op_token2] = ACTIONS(3127),
    [anon_sym_PIPE_PIPE] = ACTIONS(3127),
    [anon_sym_BANG_EQ] = ACTIONS(3127),
    [anon_sym_COLON_EQ] = ACTIONS(3129),
    [anon_sym_DOLLAR] = ACTIONS(3127),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3127),
    [sym_int] = ACTIONS(3127),
    [sym_xint] = ACTIONS(3129),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3129),
    [anon_sym_POUNDendif] = ACTIONS(3129),
    [sym__newline] = ACTIONS(3129),
  },
  [2441] = {
    [sym_block_comment] = STATE(2441),
    [sym_compiler_directive_decl] = STATE(2441),
    [sym_fsi_directive_decl] = STATE(2441),
    [sym_preproc_line] = STATE(2441),
    [sym_identifier] = ACTIONS(2978),
    [anon_sym_EQ] = ACTIONS(2980),
    [anon_sym_COLON] = ACTIONS(2978),
    [anon_sym_return] = ACTIONS(2978),
    [anon_sym_do] = ACTIONS(2978),
    [anon_sym_let] = ACTIONS(2978),
    [anon_sym_let_BANG] = ACTIONS(2980),
    [anon_sym_LPAREN] = ACTIONS(2978),
    [anon_sym_COMMA] = ACTIONS(2980),
    [anon_sym_null] = ACTIONS(2978),
    [anon_sym_QMARK] = ACTIONS(2978),
    [anon_sym_COLON_QMARK] = ACTIONS(2978),
    [anon_sym_COLON_COLON] = ACTIONS(2980),
    [anon_sym_AMP] = ACTIONS(2978),
    [anon_sym_LBRACK] = ACTIONS(2978),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2980),
    [anon_sym_LBRACE] = ACTIONS(2978),
    [anon_sym_LT_AT] = ACTIONS(2978),
    [anon_sym_LT_AT_AT] = ACTIONS(2978),
    [anon_sym_AT_AT_GT] = ACTIONS(2978),
    [anon_sym_DOT] = ACTIONS(2978),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2980),
    [anon_sym_new] = ACTIONS(2978),
    [anon_sym_return_BANG] = ACTIONS(2980),
    [anon_sym_yield] = ACTIONS(2978),
    [anon_sym_yield_BANG] = ACTIONS(2980),
    [anon_sym_lazy] = ACTIONS(2978),
    [anon_sym_assert] = ACTIONS(2978),
    [anon_sym_upcast] = ACTIONS(2978),
    [anon_sym_downcast] = ACTIONS(2978),
    [anon_sym_COLON_GT] = ACTIONS(2980),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2980),
    [anon_sym_for] = ACTIONS(2978),
    [anon_sym_while] = ACTIONS(2978),
    [anon_sym_if] = ACTIONS(2978),
    [anon_sym_fun] = ACTIONS(2978),
    [anon_sym_try] = ACTIONS(2978),
    [anon_sym_match] = ACTIONS(2978),
    [anon_sym_match_BANG] = ACTIONS(2980),
    [anon_sym_function] = ACTIONS(2978),
    [anon_sym_LT_DASH] = ACTIONS(2978),
    [anon_sym_DOT_LBRACK] = ACTIONS(2980),
    [anon_sym_LT] = ACTIONS(2980),
    [anon_sym_use] = ACTIONS(2978),
    [anon_sym_use_BANG] = ACTIONS(2980),
    [anon_sym_do_BANG] = ACTIONS(2980),
    [anon_sym_begin] = ACTIONS(2978),
    [anon_sym_LPAREN2] = ACTIONS(2978),
    [anon_sym_or] = ACTIONS(2978),
    [aux_sym_char_token1] = ACTIONS(2980),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2978),
    [anon_sym_DQUOTE] = ACTIONS(2978),
    [anon_sym_AT_DQUOTE] = ACTIONS(2980),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2980),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2980),
    [sym_bool] = ACTIONS(2978),
    [sym_unit] = ACTIONS(2980),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2978),
    [sym_op_identifier] = ACTIONS(2978),
    [anon_sym_PLUS] = ACTIONS(2978),
    [anon_sym_DASH] = ACTIONS(2978),
    [anon_sym_PLUS_DOT] = ACTIONS(2978),
    [anon_sym_DASH_DOT] = ACTIONS(2978),
    [anon_sym_PERCENT] = ACTIONS(2978),
    [anon_sym_AMP_AMP] = ACTIONS(2978),
    [anon_sym_TILDE] = ACTIONS(2980),
    [aux_sym_prefix_op_token1] = ACTIONS(2978),
    [aux_sym_infix_op_token1] = ACTIONS(2980),
    [aux_sym_infix_op_token2] = ACTIONS(2978),
    [anon_sym_PIPE_PIPE] = ACTIONS(2978),
    [anon_sym_BANG_EQ] = ACTIONS(2978),
    [anon_sym_COLON_EQ] = ACTIONS(2980),
    [anon_sym_DOLLAR] = ACTIONS(2978),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2978),
    [sym_int] = ACTIONS(2978),
    [sym_xint] = ACTIONS(2980),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2980),
    [sym__newline] = ACTIONS(2980),
  },
  [2442] = {
    [sym_block_comment] = STATE(2442),
    [sym_compiler_directive_decl] = STATE(2442),
    [sym_fsi_directive_decl] = STATE(2442),
    [sym_preproc_line] = STATE(2442),
    [sym_identifier] = ACTIONS(3131),
    [anon_sym_EQ] = ACTIONS(3133),
    [anon_sym_COLON] = ACTIONS(3131),
    [anon_sym_return] = ACTIONS(3131),
    [anon_sym_do] = ACTIONS(3131),
    [anon_sym_let] = ACTIONS(3131),
    [anon_sym_let_BANG] = ACTIONS(3133),
    [anon_sym_LPAREN] = ACTIONS(3131),
    [anon_sym_COMMA] = ACTIONS(3133),
    [anon_sym_null] = ACTIONS(3131),
    [anon_sym_QMARK] = ACTIONS(3131),
    [anon_sym_COLON_QMARK] = ACTIONS(3131),
    [anon_sym_COLON_COLON] = ACTIONS(3133),
    [anon_sym_AMP] = ACTIONS(3131),
    [anon_sym_LBRACK] = ACTIONS(3131),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3133),
    [anon_sym_LBRACE] = ACTIONS(3131),
    [anon_sym_LT_AT] = ACTIONS(3131),
    [anon_sym_LT_AT_AT] = ACTIONS(3131),
    [anon_sym_DOT] = ACTIONS(3131),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3133),
    [anon_sym_new] = ACTIONS(3131),
    [anon_sym_return_BANG] = ACTIONS(3133),
    [anon_sym_yield] = ACTIONS(3131),
    [anon_sym_yield_BANG] = ACTIONS(3133),
    [anon_sym_lazy] = ACTIONS(3131),
    [anon_sym_assert] = ACTIONS(3131),
    [anon_sym_upcast] = ACTIONS(3131),
    [anon_sym_downcast] = ACTIONS(3131),
    [anon_sym_COLON_GT] = ACTIONS(3133),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3133),
    [anon_sym_for] = ACTIONS(3131),
    [anon_sym_while] = ACTIONS(3131),
    [anon_sym_if] = ACTIONS(3131),
    [anon_sym_fun] = ACTIONS(3131),
    [anon_sym_try] = ACTIONS(3131),
    [anon_sym_match] = ACTIONS(3131),
    [anon_sym_match_BANG] = ACTIONS(3133),
    [anon_sym_function] = ACTIONS(3131),
    [anon_sym_LT_DASH] = ACTIONS(3131),
    [anon_sym_DOT_LBRACK] = ACTIONS(3133),
    [anon_sym_LT] = ACTIONS(3133),
    [anon_sym_use] = ACTIONS(3131),
    [anon_sym_use_BANG] = ACTIONS(3133),
    [anon_sym_do_BANG] = ACTIONS(3133),
    [anon_sym_begin] = ACTIONS(3131),
    [anon_sym_LPAREN2] = ACTIONS(3131),
    [anon_sym_or] = ACTIONS(3131),
    [aux_sym_char_token1] = ACTIONS(3133),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3131),
    [anon_sym_DQUOTE] = ACTIONS(3131),
    [anon_sym_AT_DQUOTE] = ACTIONS(3133),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3133),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3133),
    [sym_bool] = ACTIONS(3131),
    [sym_unit] = ACTIONS(3133),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3131),
    [sym_op_identifier] = ACTIONS(3131),
    [anon_sym_PLUS] = ACTIONS(3131),
    [anon_sym_DASH] = ACTIONS(3131),
    [anon_sym_PLUS_DOT] = ACTIONS(3131),
    [anon_sym_DASH_DOT] = ACTIONS(3131),
    [anon_sym_PERCENT] = ACTIONS(3131),
    [anon_sym_AMP_AMP] = ACTIONS(3131),
    [anon_sym_TILDE] = ACTIONS(3133),
    [aux_sym_prefix_op_token1] = ACTIONS(3131),
    [aux_sym_infix_op_token1] = ACTIONS(3133),
    [aux_sym_infix_op_token2] = ACTIONS(3131),
    [anon_sym_PIPE_PIPE] = ACTIONS(3131),
    [anon_sym_BANG_EQ] = ACTIONS(3131),
    [anon_sym_COLON_EQ] = ACTIONS(3133),
    [anon_sym_DOLLAR] = ACTIONS(3131),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3131),
    [sym_int] = ACTIONS(3131),
    [sym_xint] = ACTIONS(3133),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3133),
    [anon_sym_POUNDendif] = ACTIONS(3133),
    [sym__newline] = ACTIONS(3133),
  },
  [2443] = {
    [sym_block_comment] = STATE(2443),
    [sym_compiler_directive_decl] = STATE(2443),
    [sym_fsi_directive_decl] = STATE(2443),
    [sym_preproc_line] = STATE(2443),
    [sym_identifier] = ACTIONS(2881),
    [anon_sym_EQ] = ACTIONS(2789),
    [anon_sym_COLON] = ACTIONS(2881),
    [anon_sym_return] = ACTIONS(2881),
    [anon_sym_do] = ACTIONS(2881),
    [anon_sym_let] = ACTIONS(2881),
    [anon_sym_let_BANG] = ACTIONS(2789),
    [anon_sym_LPAREN] = ACTIONS(2881),
    [anon_sym_COMMA] = ACTIONS(2789),
    [anon_sym_null] = ACTIONS(2881),
    [anon_sym_QMARK] = ACTIONS(2881),
    [anon_sym_COLON_QMARK] = ACTIONS(2881),
    [anon_sym_COLON_COLON] = ACTIONS(2789),
    [anon_sym_AMP] = ACTIONS(2881),
    [anon_sym_LBRACK] = ACTIONS(2881),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2789),
    [anon_sym_LBRACE] = ACTIONS(2881),
    [anon_sym_LT_AT] = ACTIONS(2881),
    [anon_sym_LT_AT_AT] = ACTIONS(2881),
    [anon_sym_DOT] = ACTIONS(2881),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2789),
    [anon_sym_new] = ACTIONS(2881),
    [anon_sym_return_BANG] = ACTIONS(2789),
    [anon_sym_yield] = ACTIONS(2881),
    [anon_sym_yield_BANG] = ACTIONS(2789),
    [anon_sym_lazy] = ACTIONS(2881),
    [anon_sym_assert] = ACTIONS(2881),
    [anon_sym_upcast] = ACTIONS(2881),
    [anon_sym_downcast] = ACTIONS(2881),
    [anon_sym_COLON_GT] = ACTIONS(2789),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2789),
    [anon_sym_for] = ACTIONS(2881),
    [anon_sym_while] = ACTIONS(2881),
    [anon_sym_if] = ACTIONS(2881),
    [anon_sym_fun] = ACTIONS(2881),
    [anon_sym_try] = ACTIONS(2881),
    [anon_sym_match] = ACTIONS(2881),
    [anon_sym_match_BANG] = ACTIONS(2789),
    [anon_sym_function] = ACTIONS(2881),
    [anon_sym_LT_DASH] = ACTIONS(2881),
    [anon_sym_DOT_LBRACK] = ACTIONS(2789),
    [anon_sym_LT] = ACTIONS(2789),
    [anon_sym_use] = ACTIONS(2881),
    [anon_sym_use_BANG] = ACTIONS(2789),
    [anon_sym_do_BANG] = ACTIONS(2789),
    [anon_sym_begin] = ACTIONS(2881),
    [anon_sym_LPAREN2] = ACTIONS(2881),
    [anon_sym_or] = ACTIONS(2881),
    [aux_sym_char_token1] = ACTIONS(2789),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2881),
    [anon_sym_DQUOTE] = ACTIONS(2881),
    [anon_sym_AT_DQUOTE] = ACTIONS(2789),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2789),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2789),
    [sym_bool] = ACTIONS(2881),
    [sym_unit] = ACTIONS(2789),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2881),
    [sym_op_identifier] = ACTIONS(2881),
    [anon_sym_PLUS] = ACTIONS(2881),
    [anon_sym_DASH] = ACTIONS(2881),
    [anon_sym_PLUS_DOT] = ACTIONS(2881),
    [anon_sym_DASH_DOT] = ACTIONS(2881),
    [anon_sym_PERCENT] = ACTIONS(2881),
    [anon_sym_AMP_AMP] = ACTIONS(2881),
    [anon_sym_TILDE] = ACTIONS(2789),
    [aux_sym_prefix_op_token1] = ACTIONS(2881),
    [aux_sym_infix_op_token1] = ACTIONS(2789),
    [aux_sym_infix_op_token2] = ACTIONS(2881),
    [anon_sym_PIPE_PIPE] = ACTIONS(2881),
    [anon_sym_BANG_EQ] = ACTIONS(2881),
    [anon_sym_COLON_EQ] = ACTIONS(2789),
    [anon_sym_DOLLAR] = ACTIONS(2881),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2881),
    [sym_int] = ACTIONS(2881),
    [sym_xint] = ACTIONS(2789),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2789),
    [anon_sym_POUNDendif] = ACTIONS(2789),
    [sym__newline] = ACTIONS(2789),
  },
  [2444] = {
    [sym_block_comment] = STATE(2444),
    [sym_compiler_directive_decl] = STATE(2444),
    [sym_fsi_directive_decl] = STATE(2444),
    [sym_preproc_line] = STATE(2444),
    [sym_identifier] = ACTIONS(2902),
    [anon_sym_EQ] = ACTIONS(2904),
    [anon_sym_COLON] = ACTIONS(2902),
    [anon_sym_return] = ACTIONS(2902),
    [anon_sym_do] = ACTIONS(2902),
    [anon_sym_let] = ACTIONS(2902),
    [anon_sym_let_BANG] = ACTIONS(2904),
    [anon_sym_LPAREN] = ACTIONS(2902),
    [anon_sym_COMMA] = ACTIONS(2904),
    [anon_sym_null] = ACTIONS(2902),
    [anon_sym_QMARK] = ACTIONS(2902),
    [anon_sym_COLON_QMARK] = ACTIONS(2902),
    [anon_sym_COLON_COLON] = ACTIONS(2904),
    [anon_sym_AMP] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2902),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2902),
    [anon_sym_LT_AT] = ACTIONS(2902),
    [anon_sym_LT_AT_AT] = ACTIONS(2902),
    [anon_sym_DOT] = ACTIONS(2902),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2904),
    [anon_sym_new] = ACTIONS(2902),
    [anon_sym_return_BANG] = ACTIONS(2904),
    [anon_sym_yield] = ACTIONS(2902),
    [anon_sym_yield_BANG] = ACTIONS(2904),
    [anon_sym_lazy] = ACTIONS(2902),
    [anon_sym_assert] = ACTIONS(2902),
    [anon_sym_upcast] = ACTIONS(2902),
    [anon_sym_downcast] = ACTIONS(2902),
    [anon_sym_COLON_GT] = ACTIONS(2904),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2904),
    [anon_sym_for] = ACTIONS(2902),
    [anon_sym_while] = ACTIONS(2902),
    [anon_sym_if] = ACTIONS(2902),
    [anon_sym_fun] = ACTIONS(2902),
    [anon_sym_try] = ACTIONS(2902),
    [anon_sym_match] = ACTIONS(2902),
    [anon_sym_match_BANG] = ACTIONS(2904),
    [anon_sym_function] = ACTIONS(2902),
    [anon_sym_LT_DASH] = ACTIONS(2902),
    [anon_sym_DOT_LBRACK] = ACTIONS(2904),
    [anon_sym_LT] = ACTIONS(2904),
    [anon_sym_use] = ACTIONS(2902),
    [anon_sym_use_BANG] = ACTIONS(2904),
    [anon_sym_do_BANG] = ACTIONS(2904),
    [anon_sym_begin] = ACTIONS(2902),
    [anon_sym_LPAREN2] = ACTIONS(2902),
    [anon_sym_or] = ACTIONS(2902),
    [aux_sym_char_token1] = ACTIONS(2904),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2902),
    [anon_sym_DQUOTE] = ACTIONS(2902),
    [anon_sym_AT_DQUOTE] = ACTIONS(2904),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2904),
    [sym_bool] = ACTIONS(2902),
    [sym_unit] = ACTIONS(2904),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2902),
    [sym_op_identifier] = ACTIONS(2902),
    [anon_sym_PLUS] = ACTIONS(2902),
    [anon_sym_DASH] = ACTIONS(2902),
    [anon_sym_PLUS_DOT] = ACTIONS(2902),
    [anon_sym_DASH_DOT] = ACTIONS(2902),
    [anon_sym_PERCENT] = ACTIONS(2902),
    [anon_sym_AMP_AMP] = ACTIONS(2902),
    [anon_sym_TILDE] = ACTIONS(2904),
    [aux_sym_prefix_op_token1] = ACTIONS(2902),
    [aux_sym_infix_op_token1] = ACTIONS(2904),
    [aux_sym_infix_op_token2] = ACTIONS(2902),
    [anon_sym_PIPE_PIPE] = ACTIONS(2902),
    [anon_sym_BANG_EQ] = ACTIONS(2902),
    [anon_sym_COLON_EQ] = ACTIONS(2904),
    [anon_sym_DOLLAR] = ACTIONS(2902),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2902),
    [sym_int] = ACTIONS(2902),
    [sym_xint] = ACTIONS(2904),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2904),
    [anon_sym_POUNDendif] = ACTIONS(2904),
    [sym__newline] = ACTIONS(2904),
  },
  [2445] = {
    [sym_block_comment] = STATE(2445),
    [sym_compiler_directive_decl] = STATE(2445),
    [sym_fsi_directive_decl] = STATE(2445),
    [sym_preproc_line] = STATE(2445),
    [sym_identifier] = ACTIONS(2906),
    [anon_sym_EQ] = ACTIONS(2908),
    [anon_sym_COLON] = ACTIONS(2906),
    [anon_sym_return] = ACTIONS(2906),
    [anon_sym_do] = ACTIONS(2906),
    [anon_sym_let] = ACTIONS(2906),
    [anon_sym_let_BANG] = ACTIONS(2908),
    [anon_sym_LPAREN] = ACTIONS(2906),
    [anon_sym_COMMA] = ACTIONS(2908),
    [anon_sym_null] = ACTIONS(2906),
    [anon_sym_QMARK] = ACTIONS(2906),
    [anon_sym_COLON_QMARK] = ACTIONS(2906),
    [anon_sym_COLON_COLON] = ACTIONS(2908),
    [anon_sym_AMP] = ACTIONS(2906),
    [anon_sym_LBRACK] = ACTIONS(2906),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2908),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_LT_AT] = ACTIONS(2906),
    [anon_sym_LT_AT_AT] = ACTIONS(2906),
    [anon_sym_DOT] = ACTIONS(2906),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2908),
    [anon_sym_new] = ACTIONS(2906),
    [anon_sym_return_BANG] = ACTIONS(2908),
    [anon_sym_yield] = ACTIONS(2906),
    [anon_sym_yield_BANG] = ACTIONS(2908),
    [anon_sym_lazy] = ACTIONS(2906),
    [anon_sym_assert] = ACTIONS(2906),
    [anon_sym_upcast] = ACTIONS(2906),
    [anon_sym_downcast] = ACTIONS(2906),
    [anon_sym_COLON_GT] = ACTIONS(2908),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2908),
    [anon_sym_for] = ACTIONS(2906),
    [anon_sym_while] = ACTIONS(2906),
    [anon_sym_if] = ACTIONS(2906),
    [anon_sym_fun] = ACTIONS(2906),
    [anon_sym_try] = ACTIONS(2906),
    [anon_sym_match] = ACTIONS(2906),
    [anon_sym_match_BANG] = ACTIONS(2908),
    [anon_sym_function] = ACTIONS(2906),
    [anon_sym_LT_DASH] = ACTIONS(2906),
    [anon_sym_DOT_LBRACK] = ACTIONS(2908),
    [anon_sym_LT] = ACTIONS(2908),
    [anon_sym_use] = ACTIONS(2906),
    [anon_sym_use_BANG] = ACTIONS(2908),
    [anon_sym_do_BANG] = ACTIONS(2908),
    [anon_sym_begin] = ACTIONS(2906),
    [anon_sym_LPAREN2] = ACTIONS(2906),
    [anon_sym_or] = ACTIONS(2906),
    [aux_sym_char_token1] = ACTIONS(2908),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2906),
    [anon_sym_DQUOTE] = ACTIONS(2906),
    [anon_sym_AT_DQUOTE] = ACTIONS(2908),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2908),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2908),
    [sym_bool] = ACTIONS(2906),
    [sym_unit] = ACTIONS(2908),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2906),
    [sym_op_identifier] = ACTIONS(2906),
    [anon_sym_PLUS] = ACTIONS(2906),
    [anon_sym_DASH] = ACTIONS(2906),
    [anon_sym_PLUS_DOT] = ACTIONS(2906),
    [anon_sym_DASH_DOT] = ACTIONS(2906),
    [anon_sym_PERCENT] = ACTIONS(2906),
    [anon_sym_AMP_AMP] = ACTIONS(2906),
    [anon_sym_TILDE] = ACTIONS(2908),
    [aux_sym_prefix_op_token1] = ACTIONS(2906),
    [aux_sym_infix_op_token1] = ACTIONS(2908),
    [aux_sym_infix_op_token2] = ACTIONS(2906),
    [anon_sym_PIPE_PIPE] = ACTIONS(2906),
    [anon_sym_BANG_EQ] = ACTIONS(2906),
    [anon_sym_COLON_EQ] = ACTIONS(2908),
    [anon_sym_DOLLAR] = ACTIONS(2906),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2906),
    [sym_int] = ACTIONS(2906),
    [sym_xint] = ACTIONS(2908),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2908),
    [anon_sym_POUNDendif] = ACTIONS(2908),
    [sym__newline] = ACTIONS(2908),
  },
  [2446] = {
    [sym_block_comment] = STATE(2446),
    [sym_compiler_directive_decl] = STATE(2446),
    [sym_fsi_directive_decl] = STATE(2446),
    [sym_preproc_line] = STATE(2446),
    [sym_identifier] = ACTIONS(3139),
    [anon_sym_EQ] = ACTIONS(3141),
    [anon_sym_COLON] = ACTIONS(3139),
    [anon_sym_return] = ACTIONS(3139),
    [anon_sym_do] = ACTIONS(3139),
    [anon_sym_let] = ACTIONS(3139),
    [anon_sym_let_BANG] = ACTIONS(3141),
    [anon_sym_LPAREN] = ACTIONS(3139),
    [anon_sym_COMMA] = ACTIONS(3141),
    [anon_sym_null] = ACTIONS(3139),
    [anon_sym_QMARK] = ACTIONS(3139),
    [anon_sym_COLON_QMARK] = ACTIONS(3139),
    [anon_sym_COLON_COLON] = ACTIONS(3141),
    [anon_sym_AMP] = ACTIONS(3139),
    [anon_sym_LBRACK] = ACTIONS(3139),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3141),
    [anon_sym_LBRACE] = ACTIONS(3139),
    [anon_sym_LT_AT] = ACTIONS(3139),
    [anon_sym_LT_AT_AT] = ACTIONS(3139),
    [anon_sym_DOT] = ACTIONS(3139),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3141),
    [anon_sym_new] = ACTIONS(3139),
    [anon_sym_return_BANG] = ACTIONS(3141),
    [anon_sym_yield] = ACTIONS(3139),
    [anon_sym_yield_BANG] = ACTIONS(3141),
    [anon_sym_lazy] = ACTIONS(3139),
    [anon_sym_assert] = ACTIONS(3139),
    [anon_sym_upcast] = ACTIONS(3139),
    [anon_sym_downcast] = ACTIONS(3139),
    [anon_sym_COLON_GT] = ACTIONS(3141),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3141),
    [anon_sym_for] = ACTIONS(3139),
    [anon_sym_while] = ACTIONS(3139),
    [anon_sym_if] = ACTIONS(3139),
    [anon_sym_fun] = ACTIONS(3139),
    [anon_sym_try] = ACTIONS(3139),
    [anon_sym_match] = ACTIONS(3139),
    [anon_sym_match_BANG] = ACTIONS(3141),
    [anon_sym_function] = ACTIONS(3139),
    [anon_sym_LT_DASH] = ACTIONS(3139),
    [anon_sym_DOT_LBRACK] = ACTIONS(3141),
    [anon_sym_LT] = ACTIONS(3141),
    [anon_sym_use] = ACTIONS(3139),
    [anon_sym_use_BANG] = ACTIONS(3141),
    [anon_sym_do_BANG] = ACTIONS(3141),
    [anon_sym_begin] = ACTIONS(3139),
    [anon_sym_LPAREN2] = ACTIONS(3139),
    [anon_sym_or] = ACTIONS(3139),
    [aux_sym_char_token1] = ACTIONS(3141),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3139),
    [anon_sym_DQUOTE] = ACTIONS(3139),
    [anon_sym_AT_DQUOTE] = ACTIONS(3141),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3141),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3141),
    [sym_bool] = ACTIONS(3139),
    [sym_unit] = ACTIONS(3141),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3139),
    [sym_op_identifier] = ACTIONS(3139),
    [anon_sym_PLUS] = ACTIONS(3139),
    [anon_sym_DASH] = ACTIONS(3139),
    [anon_sym_PLUS_DOT] = ACTIONS(3139),
    [anon_sym_DASH_DOT] = ACTIONS(3139),
    [anon_sym_PERCENT] = ACTIONS(3139),
    [anon_sym_AMP_AMP] = ACTIONS(3139),
    [anon_sym_TILDE] = ACTIONS(3141),
    [aux_sym_prefix_op_token1] = ACTIONS(3139),
    [aux_sym_infix_op_token1] = ACTIONS(3141),
    [aux_sym_infix_op_token2] = ACTIONS(3139),
    [anon_sym_PIPE_PIPE] = ACTIONS(3139),
    [anon_sym_BANG_EQ] = ACTIONS(3139),
    [anon_sym_COLON_EQ] = ACTIONS(3141),
    [anon_sym_DOLLAR] = ACTIONS(3139),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3139),
    [sym_int] = ACTIONS(3139),
    [sym_xint] = ACTIONS(3141),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3141),
    [anon_sym_POUNDendif] = ACTIONS(3141),
    [sym__newline] = ACTIONS(3141),
  },
  [2447] = {
    [sym_block_comment] = STATE(2447),
    [sym_compiler_directive_decl] = STATE(2447),
    [sym_fsi_directive_decl] = STATE(2447),
    [sym_preproc_line] = STATE(2447),
    [sym_identifier] = ACTIONS(3135),
    [anon_sym_EQ] = ACTIONS(3137),
    [anon_sym_COLON] = ACTIONS(3135),
    [anon_sym_return] = ACTIONS(3135),
    [anon_sym_do] = ACTIONS(3135),
    [anon_sym_let] = ACTIONS(3135),
    [anon_sym_let_BANG] = ACTIONS(3137),
    [anon_sym_LPAREN] = ACTIONS(3135),
    [anon_sym_COMMA] = ACTIONS(3137),
    [anon_sym_null] = ACTIONS(3135),
    [anon_sym_QMARK] = ACTIONS(3135),
    [anon_sym_COLON_QMARK] = ACTIONS(3135),
    [anon_sym_COLON_COLON] = ACTIONS(3137),
    [anon_sym_AMP] = ACTIONS(3135),
    [anon_sym_LBRACK] = ACTIONS(3135),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3137),
    [anon_sym_LBRACE] = ACTIONS(3135),
    [anon_sym_LT_AT] = ACTIONS(3135),
    [anon_sym_LT_AT_AT] = ACTIONS(3135),
    [anon_sym_DOT] = ACTIONS(3135),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3137),
    [anon_sym_new] = ACTIONS(3135),
    [anon_sym_return_BANG] = ACTIONS(3137),
    [anon_sym_yield] = ACTIONS(3135),
    [anon_sym_yield_BANG] = ACTIONS(3137),
    [anon_sym_lazy] = ACTIONS(3135),
    [anon_sym_assert] = ACTIONS(3135),
    [anon_sym_upcast] = ACTIONS(3135),
    [anon_sym_downcast] = ACTIONS(3135),
    [anon_sym_COLON_GT] = ACTIONS(3137),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3137),
    [anon_sym_for] = ACTIONS(3135),
    [anon_sym_while] = ACTIONS(3135),
    [anon_sym_if] = ACTIONS(3135),
    [anon_sym_fun] = ACTIONS(3135),
    [anon_sym_try] = ACTIONS(3135),
    [anon_sym_match] = ACTIONS(3135),
    [anon_sym_match_BANG] = ACTIONS(3137),
    [anon_sym_function] = ACTIONS(3135),
    [anon_sym_LT_DASH] = ACTIONS(3135),
    [anon_sym_DOT_LBRACK] = ACTIONS(3137),
    [anon_sym_LT] = ACTIONS(3137),
    [anon_sym_use] = ACTIONS(3135),
    [anon_sym_use_BANG] = ACTIONS(3137),
    [anon_sym_do_BANG] = ACTIONS(3137),
    [anon_sym_begin] = ACTIONS(3135),
    [anon_sym_LPAREN2] = ACTIONS(3135),
    [anon_sym_or] = ACTIONS(3135),
    [aux_sym_char_token1] = ACTIONS(3137),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3135),
    [anon_sym_DQUOTE] = ACTIONS(3135),
    [anon_sym_AT_DQUOTE] = ACTIONS(3137),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3137),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3137),
    [sym_bool] = ACTIONS(3135),
    [sym_unit] = ACTIONS(3137),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3135),
    [sym_op_identifier] = ACTIONS(3135),
    [anon_sym_PLUS] = ACTIONS(3135),
    [anon_sym_DASH] = ACTIONS(3135),
    [anon_sym_PLUS_DOT] = ACTIONS(3135),
    [anon_sym_DASH_DOT] = ACTIONS(3135),
    [anon_sym_PERCENT] = ACTIONS(3135),
    [anon_sym_AMP_AMP] = ACTIONS(3135),
    [anon_sym_TILDE] = ACTIONS(3137),
    [aux_sym_prefix_op_token1] = ACTIONS(3135),
    [aux_sym_infix_op_token1] = ACTIONS(3137),
    [aux_sym_infix_op_token2] = ACTIONS(3135),
    [anon_sym_PIPE_PIPE] = ACTIONS(3135),
    [anon_sym_BANG_EQ] = ACTIONS(3135),
    [anon_sym_COLON_EQ] = ACTIONS(3137),
    [anon_sym_DOLLAR] = ACTIONS(3135),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3135),
    [sym_int] = ACTIONS(3135),
    [sym_xint] = ACTIONS(3137),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3137),
    [anon_sym_POUNDendif] = ACTIONS(3137),
    [sym__newline] = ACTIONS(3137),
  },
  [2448] = {
    [sym_block_comment] = STATE(2448),
    [sym_compiler_directive_decl] = STATE(2448),
    [sym_fsi_directive_decl] = STATE(2448),
    [sym_preproc_line] = STATE(2448),
    [sym_identifier] = ACTIONS(3119),
    [anon_sym_EQ] = ACTIONS(3121),
    [anon_sym_COLON] = ACTIONS(3119),
    [anon_sym_return] = ACTIONS(3119),
    [anon_sym_do] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_let_BANG] = ACTIONS(3121),
    [anon_sym_LPAREN] = ACTIONS(3119),
    [anon_sym_COMMA] = ACTIONS(3121),
    [anon_sym_null] = ACTIONS(3119),
    [anon_sym_QMARK] = ACTIONS(3119),
    [anon_sym_COLON_QMARK] = ACTIONS(3119),
    [anon_sym_COLON_COLON] = ACTIONS(3121),
    [anon_sym_AMP] = ACTIONS(3119),
    [anon_sym_LBRACK] = ACTIONS(3119),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3121),
    [anon_sym_LBRACE] = ACTIONS(3119),
    [anon_sym_LT_AT] = ACTIONS(3119),
    [anon_sym_LT_AT_AT] = ACTIONS(3119),
    [anon_sym_DOT] = ACTIONS(3119),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3121),
    [anon_sym_new] = ACTIONS(3119),
    [anon_sym_return_BANG] = ACTIONS(3121),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_yield_BANG] = ACTIONS(3121),
    [anon_sym_lazy] = ACTIONS(3119),
    [anon_sym_assert] = ACTIONS(3119),
    [anon_sym_upcast] = ACTIONS(3119),
    [anon_sym_downcast] = ACTIONS(3119),
    [anon_sym_COLON_GT] = ACTIONS(3121),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3121),
    [anon_sym_for] = ACTIONS(3119),
    [anon_sym_while] = ACTIONS(3119),
    [anon_sym_if] = ACTIONS(3119),
    [anon_sym_fun] = ACTIONS(3119),
    [anon_sym_try] = ACTIONS(3119),
    [anon_sym_match] = ACTIONS(3119),
    [anon_sym_match_BANG] = ACTIONS(3121),
    [anon_sym_function] = ACTIONS(3119),
    [anon_sym_LT_DASH] = ACTIONS(3119),
    [anon_sym_DOT_LBRACK] = ACTIONS(3121),
    [anon_sym_LT] = ACTIONS(3121),
    [anon_sym_use] = ACTIONS(3119),
    [anon_sym_use_BANG] = ACTIONS(3121),
    [anon_sym_do_BANG] = ACTIONS(3121),
    [anon_sym_begin] = ACTIONS(3119),
    [anon_sym_LPAREN2] = ACTIONS(3119),
    [anon_sym_or] = ACTIONS(3119),
    [aux_sym_char_token1] = ACTIONS(3121),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3119),
    [anon_sym_DQUOTE] = ACTIONS(3119),
    [anon_sym_AT_DQUOTE] = ACTIONS(3121),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3121),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3121),
    [sym_bool] = ACTIONS(3119),
    [sym_unit] = ACTIONS(3121),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3119),
    [sym_op_identifier] = ACTIONS(3119),
    [anon_sym_PLUS] = ACTIONS(3119),
    [anon_sym_DASH] = ACTIONS(3119),
    [anon_sym_PLUS_DOT] = ACTIONS(3119),
    [anon_sym_DASH_DOT] = ACTIONS(3119),
    [anon_sym_PERCENT] = ACTIONS(3119),
    [anon_sym_AMP_AMP] = ACTIONS(3119),
    [anon_sym_TILDE] = ACTIONS(3121),
    [aux_sym_prefix_op_token1] = ACTIONS(3119),
    [aux_sym_infix_op_token1] = ACTIONS(3121),
    [aux_sym_infix_op_token2] = ACTIONS(3119),
    [anon_sym_PIPE_PIPE] = ACTIONS(3119),
    [anon_sym_BANG_EQ] = ACTIONS(3119),
    [anon_sym_COLON_EQ] = ACTIONS(3121),
    [anon_sym_DOLLAR] = ACTIONS(3119),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3119),
    [sym_int] = ACTIONS(3119),
    [sym_xint] = ACTIONS(3121),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3121),
    [anon_sym_POUNDendif] = ACTIONS(3121),
    [sym__newline] = ACTIONS(3121),
  },
  [2449] = {
    [sym_block_comment] = STATE(2449),
    [sym_compiler_directive_decl] = STATE(2449),
    [sym_fsi_directive_decl] = STATE(2449),
    [sym_preproc_line] = STATE(2449),
    [sym_identifier] = ACTIONS(2930),
    [anon_sym_EQ] = ACTIONS(2932),
    [anon_sym_COLON] = ACTIONS(2930),
    [anon_sym_return] = ACTIONS(2930),
    [anon_sym_do] = ACTIONS(2930),
    [anon_sym_let] = ACTIONS(2930),
    [anon_sym_let_BANG] = ACTIONS(2932),
    [anon_sym_LPAREN] = ACTIONS(2930),
    [anon_sym_COMMA] = ACTIONS(2932),
    [anon_sym_null] = ACTIONS(2930),
    [anon_sym_QMARK] = ACTIONS(2930),
    [anon_sym_COLON_QMARK] = ACTIONS(2930),
    [anon_sym_COLON_COLON] = ACTIONS(2932),
    [anon_sym_AMP] = ACTIONS(2930),
    [anon_sym_LBRACK] = ACTIONS(2930),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2932),
    [anon_sym_LBRACE] = ACTIONS(2930),
    [anon_sym_LT_AT] = ACTIONS(2930),
    [anon_sym_LT_AT_AT] = ACTIONS(2930),
    [anon_sym_DOT] = ACTIONS(2930),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2932),
    [anon_sym_new] = ACTIONS(2930),
    [anon_sym_return_BANG] = ACTIONS(2932),
    [anon_sym_yield] = ACTIONS(2930),
    [anon_sym_yield_BANG] = ACTIONS(2932),
    [anon_sym_lazy] = ACTIONS(2930),
    [anon_sym_assert] = ACTIONS(2930),
    [anon_sym_upcast] = ACTIONS(2930),
    [anon_sym_downcast] = ACTIONS(2930),
    [anon_sym_COLON_GT] = ACTIONS(2932),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2932),
    [anon_sym_for] = ACTIONS(2930),
    [anon_sym_while] = ACTIONS(2930),
    [anon_sym_if] = ACTIONS(2930),
    [anon_sym_fun] = ACTIONS(2930),
    [anon_sym_try] = ACTIONS(2930),
    [anon_sym_match] = ACTIONS(2930),
    [anon_sym_match_BANG] = ACTIONS(2932),
    [anon_sym_function] = ACTIONS(2930),
    [anon_sym_LT_DASH] = ACTIONS(2930),
    [anon_sym_DOT_LBRACK] = ACTIONS(2932),
    [anon_sym_LT] = ACTIONS(2932),
    [anon_sym_use] = ACTIONS(2930),
    [anon_sym_use_BANG] = ACTIONS(2932),
    [anon_sym_do_BANG] = ACTIONS(2932),
    [anon_sym_begin] = ACTIONS(2930),
    [anon_sym_LPAREN2] = ACTIONS(2930),
    [anon_sym_or] = ACTIONS(2930),
    [aux_sym_char_token1] = ACTIONS(2932),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2930),
    [anon_sym_DQUOTE] = ACTIONS(2930),
    [anon_sym_AT_DQUOTE] = ACTIONS(2932),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2932),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2932),
    [sym_bool] = ACTIONS(2930),
    [sym_unit] = ACTIONS(2932),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2930),
    [sym_op_identifier] = ACTIONS(2930),
    [anon_sym_PLUS] = ACTIONS(2930),
    [anon_sym_DASH] = ACTIONS(2930),
    [anon_sym_PLUS_DOT] = ACTIONS(2930),
    [anon_sym_DASH_DOT] = ACTIONS(2930),
    [anon_sym_PERCENT] = ACTIONS(2930),
    [anon_sym_AMP_AMP] = ACTIONS(2930),
    [anon_sym_TILDE] = ACTIONS(2932),
    [aux_sym_prefix_op_token1] = ACTIONS(2930),
    [aux_sym_infix_op_token1] = ACTIONS(2932),
    [aux_sym_infix_op_token2] = ACTIONS(2930),
    [anon_sym_PIPE_PIPE] = ACTIONS(2930),
    [anon_sym_BANG_EQ] = ACTIONS(2930),
    [anon_sym_COLON_EQ] = ACTIONS(2932),
    [anon_sym_DOLLAR] = ACTIONS(2930),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2930),
    [sym_int] = ACTIONS(2930),
    [sym_xint] = ACTIONS(2932),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2932),
    [anon_sym_POUNDendif] = ACTIONS(2932),
    [sym__newline] = ACTIONS(2932),
  },
  [2450] = {
    [sym_block_comment] = STATE(2450),
    [sym_compiler_directive_decl] = STATE(2450),
    [sym_fsi_directive_decl] = STATE(2450),
    [sym_preproc_line] = STATE(2450),
    [sym_identifier] = ACTIONS(2835),
    [anon_sym_EQ] = ACTIONS(2837),
    [anon_sym_COLON] = ACTIONS(2835),
    [anon_sym_return] = ACTIONS(2835),
    [anon_sym_do] = ACTIONS(2835),
    [anon_sym_let] = ACTIONS(2835),
    [anon_sym_let_BANG] = ACTIONS(2837),
    [anon_sym_LPAREN] = ACTIONS(2835),
    [anon_sym_COMMA] = ACTIONS(2837),
    [anon_sym_null] = ACTIONS(2835),
    [anon_sym_QMARK] = ACTIONS(2835),
    [anon_sym_COLON_QMARK] = ACTIONS(2835),
    [anon_sym_COLON_COLON] = ACTIONS(2837),
    [anon_sym_AMP] = ACTIONS(2835),
    [anon_sym_LBRACK] = ACTIONS(2835),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2837),
    [anon_sym_LBRACE] = ACTIONS(2835),
    [anon_sym_LT_AT] = ACTIONS(2835),
    [anon_sym_LT_AT_AT] = ACTIONS(2835),
    [anon_sym_DOT] = ACTIONS(2835),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2837),
    [anon_sym_new] = ACTIONS(2835),
    [anon_sym_return_BANG] = ACTIONS(2837),
    [anon_sym_yield] = ACTIONS(2835),
    [anon_sym_yield_BANG] = ACTIONS(2837),
    [anon_sym_lazy] = ACTIONS(2835),
    [anon_sym_assert] = ACTIONS(2835),
    [anon_sym_upcast] = ACTIONS(2835),
    [anon_sym_downcast] = ACTIONS(2835),
    [anon_sym_COLON_GT] = ACTIONS(2837),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2837),
    [anon_sym_for] = ACTIONS(2835),
    [anon_sym_while] = ACTIONS(2835),
    [anon_sym_if] = ACTIONS(2835),
    [anon_sym_fun] = ACTIONS(2835),
    [anon_sym_try] = ACTIONS(2835),
    [anon_sym_match] = ACTIONS(2835),
    [anon_sym_match_BANG] = ACTIONS(2837),
    [anon_sym_function] = ACTIONS(2835),
    [anon_sym_LT_DASH] = ACTIONS(2835),
    [anon_sym_DOT_LBRACK] = ACTIONS(2837),
    [anon_sym_LT] = ACTIONS(2837),
    [anon_sym_use] = ACTIONS(2835),
    [anon_sym_use_BANG] = ACTIONS(2837),
    [anon_sym_do_BANG] = ACTIONS(2837),
    [anon_sym_begin] = ACTIONS(2835),
    [anon_sym_LPAREN2] = ACTIONS(2835),
    [anon_sym_or] = ACTIONS(2835),
    [aux_sym_char_token1] = ACTIONS(2837),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2835),
    [anon_sym_DQUOTE] = ACTIONS(2835),
    [anon_sym_AT_DQUOTE] = ACTIONS(2837),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2837),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2837),
    [sym_bool] = ACTIONS(2835),
    [sym_unit] = ACTIONS(2837),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2835),
    [sym_op_identifier] = ACTIONS(2835),
    [anon_sym_PLUS] = ACTIONS(2835),
    [anon_sym_DASH] = ACTIONS(2835),
    [anon_sym_PLUS_DOT] = ACTIONS(2835),
    [anon_sym_DASH_DOT] = ACTIONS(2835),
    [anon_sym_PERCENT] = ACTIONS(2835),
    [anon_sym_AMP_AMP] = ACTIONS(2835),
    [anon_sym_TILDE] = ACTIONS(2837),
    [aux_sym_prefix_op_token1] = ACTIONS(2835),
    [aux_sym_infix_op_token1] = ACTIONS(2837),
    [aux_sym_infix_op_token2] = ACTIONS(2835),
    [anon_sym_PIPE_PIPE] = ACTIONS(2835),
    [anon_sym_BANG_EQ] = ACTIONS(2835),
    [anon_sym_COLON_EQ] = ACTIONS(2837),
    [anon_sym_DOLLAR] = ACTIONS(2835),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2835),
    [sym_int] = ACTIONS(2835),
    [sym_xint] = ACTIONS(2837),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2837),
    [anon_sym_POUNDendif] = ACTIONS(2837),
    [sym__newline] = ACTIONS(2837),
  },
  [2451] = {
    [sym_block_comment] = STATE(2451),
    [sym_compiler_directive_decl] = STATE(2451),
    [sym_fsi_directive_decl] = STATE(2451),
    [sym_preproc_line] = STATE(2451),
    [sym_identifier] = ACTIONS(3111),
    [anon_sym_EQ] = ACTIONS(3113),
    [anon_sym_COLON] = ACTIONS(3111),
    [anon_sym_return] = ACTIONS(3111),
    [anon_sym_do] = ACTIONS(3111),
    [anon_sym_let] = ACTIONS(3111),
    [anon_sym_let_BANG] = ACTIONS(3113),
    [anon_sym_LPAREN] = ACTIONS(3111),
    [anon_sym_COMMA] = ACTIONS(3113),
    [anon_sym_null] = ACTIONS(3111),
    [anon_sym_QMARK] = ACTIONS(3111),
    [anon_sym_COLON_QMARK] = ACTIONS(3111),
    [anon_sym_COLON_COLON] = ACTIONS(3113),
    [anon_sym_AMP] = ACTIONS(3111),
    [anon_sym_LBRACK] = ACTIONS(3111),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3113),
    [anon_sym_LBRACE] = ACTIONS(3111),
    [anon_sym_LT_AT] = ACTIONS(3111),
    [anon_sym_LT_AT_AT] = ACTIONS(3111),
    [anon_sym_DOT] = ACTIONS(3111),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3113),
    [anon_sym_new] = ACTIONS(3111),
    [anon_sym_return_BANG] = ACTIONS(3113),
    [anon_sym_yield] = ACTIONS(3111),
    [anon_sym_yield_BANG] = ACTIONS(3113),
    [anon_sym_lazy] = ACTIONS(3111),
    [anon_sym_assert] = ACTIONS(3111),
    [anon_sym_upcast] = ACTIONS(3111),
    [anon_sym_downcast] = ACTIONS(3111),
    [anon_sym_COLON_GT] = ACTIONS(3113),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3113),
    [anon_sym_for] = ACTIONS(3111),
    [anon_sym_while] = ACTIONS(3111),
    [anon_sym_if] = ACTIONS(3111),
    [anon_sym_fun] = ACTIONS(3111),
    [anon_sym_try] = ACTIONS(3111),
    [anon_sym_match] = ACTIONS(3111),
    [anon_sym_match_BANG] = ACTIONS(3113),
    [anon_sym_function] = ACTIONS(3111),
    [anon_sym_LT_DASH] = ACTIONS(3111),
    [anon_sym_DOT_LBRACK] = ACTIONS(3113),
    [anon_sym_LT] = ACTIONS(3113),
    [anon_sym_use] = ACTIONS(3111),
    [anon_sym_use_BANG] = ACTIONS(3113),
    [anon_sym_do_BANG] = ACTIONS(3113),
    [anon_sym_begin] = ACTIONS(3111),
    [anon_sym_LPAREN2] = ACTIONS(3111),
    [anon_sym_or] = ACTIONS(3111),
    [aux_sym_char_token1] = ACTIONS(3113),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3111),
    [anon_sym_DQUOTE] = ACTIONS(3111),
    [anon_sym_AT_DQUOTE] = ACTIONS(3113),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3113),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3113),
    [sym_bool] = ACTIONS(3111),
    [sym_unit] = ACTIONS(3113),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3111),
    [sym_op_identifier] = ACTIONS(3111),
    [anon_sym_PLUS] = ACTIONS(3111),
    [anon_sym_DASH] = ACTIONS(3111),
    [anon_sym_PLUS_DOT] = ACTIONS(3111),
    [anon_sym_DASH_DOT] = ACTIONS(3111),
    [anon_sym_PERCENT] = ACTIONS(3111),
    [anon_sym_AMP_AMP] = ACTIONS(3111),
    [anon_sym_TILDE] = ACTIONS(3113),
    [aux_sym_prefix_op_token1] = ACTIONS(3111),
    [aux_sym_infix_op_token1] = ACTIONS(3113),
    [aux_sym_infix_op_token2] = ACTIONS(3111),
    [anon_sym_PIPE_PIPE] = ACTIONS(3111),
    [anon_sym_BANG_EQ] = ACTIONS(3111),
    [anon_sym_COLON_EQ] = ACTIONS(3113),
    [anon_sym_DOLLAR] = ACTIONS(3111),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3111),
    [sym_int] = ACTIONS(3111),
    [sym_xint] = ACTIONS(3113),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3113),
    [anon_sym_POUNDendif] = ACTIONS(3113),
    [sym__newline] = ACTIONS(3113),
  },
  [2452] = {
    [sym_block_comment] = STATE(2452),
    [sym_compiler_directive_decl] = STATE(2452),
    [sym_fsi_directive_decl] = STATE(2452),
    [sym_preproc_line] = STATE(2452),
    [sym_identifier] = ACTIONS(3107),
    [anon_sym_EQ] = ACTIONS(3109),
    [anon_sym_COLON] = ACTIONS(3107),
    [anon_sym_return] = ACTIONS(3107),
    [anon_sym_do] = ACTIONS(3107),
    [anon_sym_let] = ACTIONS(3107),
    [anon_sym_let_BANG] = ACTIONS(3109),
    [anon_sym_LPAREN] = ACTIONS(3107),
    [anon_sym_COMMA] = ACTIONS(3109),
    [anon_sym_null] = ACTIONS(3107),
    [anon_sym_QMARK] = ACTIONS(3107),
    [anon_sym_COLON_QMARK] = ACTIONS(3107),
    [anon_sym_COLON_COLON] = ACTIONS(3109),
    [anon_sym_AMP] = ACTIONS(3107),
    [anon_sym_LBRACK] = ACTIONS(3107),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3109),
    [anon_sym_LBRACE] = ACTIONS(3107),
    [anon_sym_LT_AT] = ACTIONS(3107),
    [anon_sym_LT_AT_AT] = ACTIONS(3107),
    [anon_sym_DOT] = ACTIONS(3107),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3109),
    [anon_sym_new] = ACTIONS(3107),
    [anon_sym_return_BANG] = ACTIONS(3109),
    [anon_sym_yield] = ACTIONS(3107),
    [anon_sym_yield_BANG] = ACTIONS(3109),
    [anon_sym_lazy] = ACTIONS(3107),
    [anon_sym_assert] = ACTIONS(3107),
    [anon_sym_upcast] = ACTIONS(3107),
    [anon_sym_downcast] = ACTIONS(3107),
    [anon_sym_COLON_GT] = ACTIONS(3109),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3109),
    [anon_sym_for] = ACTIONS(3107),
    [anon_sym_while] = ACTIONS(3107),
    [anon_sym_if] = ACTIONS(3107),
    [anon_sym_fun] = ACTIONS(3107),
    [anon_sym_try] = ACTIONS(3107),
    [anon_sym_match] = ACTIONS(3107),
    [anon_sym_match_BANG] = ACTIONS(3109),
    [anon_sym_function] = ACTIONS(3107),
    [anon_sym_LT_DASH] = ACTIONS(3107),
    [anon_sym_DOT_LBRACK] = ACTIONS(3109),
    [anon_sym_LT] = ACTIONS(3109),
    [anon_sym_use] = ACTIONS(3107),
    [anon_sym_use_BANG] = ACTIONS(3109),
    [anon_sym_do_BANG] = ACTIONS(3109),
    [anon_sym_begin] = ACTIONS(3107),
    [anon_sym_LPAREN2] = ACTIONS(3107),
    [anon_sym_or] = ACTIONS(3107),
    [aux_sym_char_token1] = ACTIONS(3109),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3107),
    [anon_sym_DQUOTE] = ACTIONS(3107),
    [anon_sym_AT_DQUOTE] = ACTIONS(3109),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3109),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3109),
    [sym_bool] = ACTIONS(3107),
    [sym_unit] = ACTIONS(3109),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3107),
    [sym_op_identifier] = ACTIONS(3107),
    [anon_sym_PLUS] = ACTIONS(3107),
    [anon_sym_DASH] = ACTIONS(3107),
    [anon_sym_PLUS_DOT] = ACTIONS(3107),
    [anon_sym_DASH_DOT] = ACTIONS(3107),
    [anon_sym_PERCENT] = ACTIONS(3107),
    [anon_sym_AMP_AMP] = ACTIONS(3107),
    [anon_sym_TILDE] = ACTIONS(3109),
    [aux_sym_prefix_op_token1] = ACTIONS(3107),
    [aux_sym_infix_op_token1] = ACTIONS(3109),
    [aux_sym_infix_op_token2] = ACTIONS(3107),
    [anon_sym_PIPE_PIPE] = ACTIONS(3107),
    [anon_sym_BANG_EQ] = ACTIONS(3107),
    [anon_sym_COLON_EQ] = ACTIONS(3109),
    [anon_sym_DOLLAR] = ACTIONS(3107),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3107),
    [sym_int] = ACTIONS(3107),
    [sym_xint] = ACTIONS(3109),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3109),
    [anon_sym_POUNDendif] = ACTIONS(3109),
    [sym__newline] = ACTIONS(3109),
  },
  [2453] = {
    [sym_block_comment] = STATE(2453),
    [sym_compiler_directive_decl] = STATE(2453),
    [sym_fsi_directive_decl] = STATE(2453),
    [sym_preproc_line] = STATE(2453),
    [sym_identifier] = ACTIONS(3103),
    [anon_sym_EQ] = ACTIONS(3105),
    [anon_sym_COLON] = ACTIONS(3103),
    [anon_sym_return] = ACTIONS(3103),
    [anon_sym_do] = ACTIONS(3103),
    [anon_sym_let] = ACTIONS(3103),
    [anon_sym_let_BANG] = ACTIONS(3105),
    [anon_sym_LPAREN] = ACTIONS(3103),
    [anon_sym_COMMA] = ACTIONS(3105),
    [anon_sym_null] = ACTIONS(3103),
    [anon_sym_QMARK] = ACTIONS(3103),
    [anon_sym_COLON_QMARK] = ACTIONS(3103),
    [anon_sym_COLON_COLON] = ACTIONS(3105),
    [anon_sym_AMP] = ACTIONS(3103),
    [anon_sym_LBRACK] = ACTIONS(3103),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3105),
    [anon_sym_LBRACE] = ACTIONS(3103),
    [anon_sym_LT_AT] = ACTIONS(3103),
    [anon_sym_LT_AT_AT] = ACTIONS(3103),
    [anon_sym_DOT] = ACTIONS(3103),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3105),
    [anon_sym_new] = ACTIONS(3103),
    [anon_sym_return_BANG] = ACTIONS(3105),
    [anon_sym_yield] = ACTIONS(3103),
    [anon_sym_yield_BANG] = ACTIONS(3105),
    [anon_sym_lazy] = ACTIONS(3103),
    [anon_sym_assert] = ACTIONS(3103),
    [anon_sym_upcast] = ACTIONS(3103),
    [anon_sym_downcast] = ACTIONS(3103),
    [anon_sym_COLON_GT] = ACTIONS(3105),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3105),
    [anon_sym_for] = ACTIONS(3103),
    [anon_sym_while] = ACTIONS(3103),
    [anon_sym_if] = ACTIONS(3103),
    [anon_sym_fun] = ACTIONS(3103),
    [anon_sym_try] = ACTIONS(3103),
    [anon_sym_match] = ACTIONS(3103),
    [anon_sym_match_BANG] = ACTIONS(3105),
    [anon_sym_function] = ACTIONS(3103),
    [anon_sym_LT_DASH] = ACTIONS(3103),
    [anon_sym_DOT_LBRACK] = ACTIONS(3105),
    [anon_sym_LT] = ACTIONS(3105),
    [anon_sym_use] = ACTIONS(3103),
    [anon_sym_use_BANG] = ACTIONS(3105),
    [anon_sym_do_BANG] = ACTIONS(3105),
    [anon_sym_begin] = ACTIONS(3103),
    [anon_sym_LPAREN2] = ACTIONS(3103),
    [anon_sym_or] = ACTIONS(3103),
    [aux_sym_char_token1] = ACTIONS(3105),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3103),
    [anon_sym_DQUOTE] = ACTIONS(3103),
    [anon_sym_AT_DQUOTE] = ACTIONS(3105),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3105),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3105),
    [sym_bool] = ACTIONS(3103),
    [sym_unit] = ACTIONS(3105),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3103),
    [sym_op_identifier] = ACTIONS(3103),
    [anon_sym_PLUS] = ACTIONS(3103),
    [anon_sym_DASH] = ACTIONS(3103),
    [anon_sym_PLUS_DOT] = ACTIONS(3103),
    [anon_sym_DASH_DOT] = ACTIONS(3103),
    [anon_sym_PERCENT] = ACTIONS(3103),
    [anon_sym_AMP_AMP] = ACTIONS(3103),
    [anon_sym_TILDE] = ACTIONS(3105),
    [aux_sym_prefix_op_token1] = ACTIONS(3103),
    [aux_sym_infix_op_token1] = ACTIONS(3105),
    [aux_sym_infix_op_token2] = ACTIONS(3103),
    [anon_sym_PIPE_PIPE] = ACTIONS(3103),
    [anon_sym_BANG_EQ] = ACTIONS(3103),
    [anon_sym_COLON_EQ] = ACTIONS(3105),
    [anon_sym_DOLLAR] = ACTIONS(3103),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3103),
    [sym_int] = ACTIONS(3103),
    [sym_xint] = ACTIONS(3105),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3105),
    [anon_sym_POUNDendif] = ACTIONS(3105),
    [sym__newline] = ACTIONS(3105),
  },
  [2454] = {
    [sym_block_comment] = STATE(2454),
    [sym_compiler_directive_decl] = STATE(2454),
    [sym_fsi_directive_decl] = STATE(2454),
    [sym_preproc_line] = STATE(2454),
    [sym_identifier] = ACTIONS(2881),
    [anon_sym_EQ] = ACTIONS(2789),
    [anon_sym_COLON] = ACTIONS(2881),
    [anon_sym_return] = ACTIONS(2881),
    [anon_sym_do] = ACTIONS(2881),
    [anon_sym_let] = ACTIONS(2881),
    [anon_sym_let_BANG] = ACTIONS(2789),
    [anon_sym_LPAREN] = ACTIONS(2881),
    [anon_sym_COMMA] = ACTIONS(2789),
    [anon_sym_null] = ACTIONS(2881),
    [anon_sym_QMARK] = ACTIONS(2881),
    [anon_sym_COLON_QMARK] = ACTIONS(2881),
    [anon_sym_COLON_COLON] = ACTIONS(2789),
    [anon_sym_AMP] = ACTIONS(2881),
    [anon_sym_LBRACK] = ACTIONS(2881),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2789),
    [anon_sym_LBRACE] = ACTIONS(2881),
    [anon_sym_LT_AT] = ACTIONS(2881),
    [anon_sym_LT_AT_AT] = ACTIONS(2881),
    [anon_sym_AT_AT_GT] = ACTIONS(2881),
    [anon_sym_DOT] = ACTIONS(2881),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2789),
    [anon_sym_new] = ACTIONS(2881),
    [anon_sym_return_BANG] = ACTIONS(2789),
    [anon_sym_yield] = ACTIONS(2881),
    [anon_sym_yield_BANG] = ACTIONS(2789),
    [anon_sym_lazy] = ACTIONS(2881),
    [anon_sym_assert] = ACTIONS(2881),
    [anon_sym_upcast] = ACTIONS(2881),
    [anon_sym_downcast] = ACTIONS(2881),
    [anon_sym_COLON_GT] = ACTIONS(2789),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2789),
    [anon_sym_for] = ACTIONS(2881),
    [anon_sym_while] = ACTIONS(2881),
    [anon_sym_if] = ACTIONS(2881),
    [anon_sym_fun] = ACTIONS(2881),
    [anon_sym_try] = ACTIONS(2881),
    [anon_sym_match] = ACTIONS(2881),
    [anon_sym_match_BANG] = ACTIONS(2789),
    [anon_sym_function] = ACTIONS(2881),
    [anon_sym_LT_DASH] = ACTIONS(2881),
    [anon_sym_DOT_LBRACK] = ACTIONS(2789),
    [anon_sym_LT] = ACTIONS(2789),
    [anon_sym_use] = ACTIONS(2881),
    [anon_sym_use_BANG] = ACTIONS(2789),
    [anon_sym_do_BANG] = ACTIONS(2789),
    [anon_sym_begin] = ACTIONS(2881),
    [anon_sym_LPAREN2] = ACTIONS(2881),
    [anon_sym_or] = ACTIONS(2881),
    [aux_sym_char_token1] = ACTIONS(2789),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2881),
    [anon_sym_DQUOTE] = ACTIONS(2881),
    [anon_sym_AT_DQUOTE] = ACTIONS(2789),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2789),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2789),
    [sym_bool] = ACTIONS(2881),
    [sym_unit] = ACTIONS(2789),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2881),
    [sym_op_identifier] = ACTIONS(2881),
    [anon_sym_PLUS] = ACTIONS(2881),
    [anon_sym_DASH] = ACTIONS(2881),
    [anon_sym_PLUS_DOT] = ACTIONS(2881),
    [anon_sym_DASH_DOT] = ACTIONS(2881),
    [anon_sym_PERCENT] = ACTIONS(2881),
    [anon_sym_AMP_AMP] = ACTIONS(2881),
    [anon_sym_TILDE] = ACTIONS(2789),
    [aux_sym_prefix_op_token1] = ACTIONS(2881),
    [aux_sym_infix_op_token1] = ACTIONS(2789),
    [aux_sym_infix_op_token2] = ACTIONS(2881),
    [anon_sym_PIPE_PIPE] = ACTIONS(2881),
    [anon_sym_BANG_EQ] = ACTIONS(2881),
    [anon_sym_COLON_EQ] = ACTIONS(2789),
    [anon_sym_DOLLAR] = ACTIONS(2881),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2881),
    [sym_int] = ACTIONS(2881),
    [sym_xint] = ACTIONS(2789),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2789),
    [sym__newline] = ACTIONS(2789),
  },
  [2455] = {
    [sym_block_comment] = STATE(2455),
    [sym_compiler_directive_decl] = STATE(2455),
    [sym_fsi_directive_decl] = STATE(2455),
    [sym_preproc_line] = STATE(2455),
    [sym_identifier] = ACTIONS(3099),
    [anon_sym_EQ] = ACTIONS(3101),
    [anon_sym_COLON] = ACTIONS(3099),
    [anon_sym_return] = ACTIONS(3099),
    [anon_sym_do] = ACTIONS(3099),
    [anon_sym_let] = ACTIONS(3099),
    [anon_sym_let_BANG] = ACTIONS(3101),
    [anon_sym_LPAREN] = ACTIONS(3099),
    [anon_sym_COMMA] = ACTIONS(3101),
    [anon_sym_null] = ACTIONS(3099),
    [anon_sym_QMARK] = ACTIONS(3099),
    [anon_sym_COLON_QMARK] = ACTIONS(3099),
    [anon_sym_COLON_COLON] = ACTIONS(3101),
    [anon_sym_AMP] = ACTIONS(3099),
    [anon_sym_LBRACK] = ACTIONS(3099),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3101),
    [anon_sym_LBRACE] = ACTIONS(3099),
    [anon_sym_LT_AT] = ACTIONS(3099),
    [anon_sym_LT_AT_AT] = ACTIONS(3099),
    [anon_sym_DOT] = ACTIONS(3099),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3101),
    [anon_sym_new] = ACTIONS(3099),
    [anon_sym_return_BANG] = ACTIONS(3101),
    [anon_sym_yield] = ACTIONS(3099),
    [anon_sym_yield_BANG] = ACTIONS(3101),
    [anon_sym_lazy] = ACTIONS(3099),
    [anon_sym_assert] = ACTIONS(3099),
    [anon_sym_upcast] = ACTIONS(3099),
    [anon_sym_downcast] = ACTIONS(3099),
    [anon_sym_COLON_GT] = ACTIONS(3101),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3101),
    [anon_sym_for] = ACTIONS(3099),
    [anon_sym_while] = ACTIONS(3099),
    [anon_sym_if] = ACTIONS(3099),
    [anon_sym_fun] = ACTIONS(3099),
    [anon_sym_try] = ACTIONS(3099),
    [anon_sym_match] = ACTIONS(3099),
    [anon_sym_match_BANG] = ACTIONS(3101),
    [anon_sym_function] = ACTIONS(3099),
    [anon_sym_LT_DASH] = ACTIONS(3099),
    [anon_sym_DOT_LBRACK] = ACTIONS(3101),
    [anon_sym_LT] = ACTIONS(3101),
    [anon_sym_use] = ACTIONS(3099),
    [anon_sym_use_BANG] = ACTIONS(3101),
    [anon_sym_do_BANG] = ACTIONS(3101),
    [anon_sym_begin] = ACTIONS(3099),
    [anon_sym_LPAREN2] = ACTIONS(3099),
    [anon_sym_or] = ACTIONS(3099),
    [aux_sym_char_token1] = ACTIONS(3101),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3099),
    [anon_sym_DQUOTE] = ACTIONS(3099),
    [anon_sym_AT_DQUOTE] = ACTIONS(3101),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3101),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3101),
    [sym_bool] = ACTIONS(3099),
    [sym_unit] = ACTIONS(3101),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3099),
    [sym_op_identifier] = ACTIONS(3099),
    [anon_sym_PLUS] = ACTIONS(3099),
    [anon_sym_DASH] = ACTIONS(3099),
    [anon_sym_PLUS_DOT] = ACTIONS(3099),
    [anon_sym_DASH_DOT] = ACTIONS(3099),
    [anon_sym_PERCENT] = ACTIONS(3099),
    [anon_sym_AMP_AMP] = ACTIONS(3099),
    [anon_sym_TILDE] = ACTIONS(3101),
    [aux_sym_prefix_op_token1] = ACTIONS(3099),
    [aux_sym_infix_op_token1] = ACTIONS(3101),
    [aux_sym_infix_op_token2] = ACTIONS(3099),
    [anon_sym_PIPE_PIPE] = ACTIONS(3099),
    [anon_sym_BANG_EQ] = ACTIONS(3099),
    [anon_sym_COLON_EQ] = ACTIONS(3101),
    [anon_sym_DOLLAR] = ACTIONS(3099),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3099),
    [sym_int] = ACTIONS(3099),
    [sym_xint] = ACTIONS(3101),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3101),
    [anon_sym_POUNDendif] = ACTIONS(3101),
    [sym__newline] = ACTIONS(3101),
  },
  [2456] = {
    [sym_block_comment] = STATE(2456),
    [sym_compiler_directive_decl] = STATE(2456),
    [sym_fsi_directive_decl] = STATE(2456),
    [sym_preproc_line] = STATE(2456),
    [sym_identifier] = ACTIONS(3083),
    [anon_sym_EQ] = ACTIONS(3085),
    [anon_sym_COLON] = ACTIONS(3083),
    [anon_sym_return] = ACTIONS(3083),
    [anon_sym_do] = ACTIONS(3083),
    [anon_sym_let] = ACTIONS(3083),
    [anon_sym_let_BANG] = ACTIONS(3085),
    [anon_sym_LPAREN] = ACTIONS(3083),
    [anon_sym_COMMA] = ACTIONS(3085),
    [anon_sym_null] = ACTIONS(3083),
    [anon_sym_QMARK] = ACTIONS(3083),
    [anon_sym_COLON_QMARK] = ACTIONS(3083),
    [anon_sym_COLON_COLON] = ACTIONS(3085),
    [anon_sym_AMP] = ACTIONS(3083),
    [anon_sym_LBRACK] = ACTIONS(3083),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3085),
    [anon_sym_LBRACE] = ACTIONS(3083),
    [anon_sym_LT_AT] = ACTIONS(3083),
    [anon_sym_LT_AT_AT] = ACTIONS(3083),
    [anon_sym_DOT] = ACTIONS(3083),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3085),
    [anon_sym_new] = ACTIONS(3083),
    [anon_sym_return_BANG] = ACTIONS(3085),
    [anon_sym_yield] = ACTIONS(3083),
    [anon_sym_yield_BANG] = ACTIONS(3085),
    [anon_sym_lazy] = ACTIONS(3083),
    [anon_sym_assert] = ACTIONS(3083),
    [anon_sym_upcast] = ACTIONS(3083),
    [anon_sym_downcast] = ACTIONS(3083),
    [anon_sym_COLON_GT] = ACTIONS(3085),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3085),
    [anon_sym_for] = ACTIONS(3083),
    [anon_sym_while] = ACTIONS(3083),
    [anon_sym_if] = ACTIONS(3083),
    [anon_sym_fun] = ACTIONS(3083),
    [anon_sym_try] = ACTIONS(3083),
    [anon_sym_match] = ACTIONS(3083),
    [anon_sym_match_BANG] = ACTIONS(3085),
    [anon_sym_function] = ACTIONS(3083),
    [anon_sym_LT_DASH] = ACTIONS(3083),
    [anon_sym_DOT_LBRACK] = ACTIONS(3085),
    [anon_sym_LT] = ACTIONS(3085),
    [anon_sym_use] = ACTIONS(3083),
    [anon_sym_use_BANG] = ACTIONS(3085),
    [anon_sym_do_BANG] = ACTIONS(3085),
    [anon_sym_begin] = ACTIONS(3083),
    [anon_sym_LPAREN2] = ACTIONS(3083),
    [anon_sym_or] = ACTIONS(3083),
    [aux_sym_char_token1] = ACTIONS(3085),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3083),
    [anon_sym_DQUOTE] = ACTIONS(3083),
    [anon_sym_AT_DQUOTE] = ACTIONS(3085),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3085),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3085),
    [sym_bool] = ACTIONS(3083),
    [sym_unit] = ACTIONS(3085),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3083),
    [sym_op_identifier] = ACTIONS(3083),
    [anon_sym_PLUS] = ACTIONS(3083),
    [anon_sym_DASH] = ACTIONS(3083),
    [anon_sym_PLUS_DOT] = ACTIONS(3083),
    [anon_sym_DASH_DOT] = ACTIONS(3083),
    [anon_sym_PERCENT] = ACTIONS(3083),
    [anon_sym_AMP_AMP] = ACTIONS(3083),
    [anon_sym_TILDE] = ACTIONS(3085),
    [aux_sym_prefix_op_token1] = ACTIONS(3083),
    [aux_sym_infix_op_token1] = ACTIONS(3085),
    [aux_sym_infix_op_token2] = ACTIONS(3083),
    [anon_sym_PIPE_PIPE] = ACTIONS(3083),
    [anon_sym_BANG_EQ] = ACTIONS(3083),
    [anon_sym_COLON_EQ] = ACTIONS(3085),
    [anon_sym_DOLLAR] = ACTIONS(3083),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3083),
    [sym_int] = ACTIONS(3083),
    [sym_xint] = ACTIONS(3085),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3085),
    [anon_sym_POUNDendif] = ACTIONS(3085),
    [sym__newline] = ACTIONS(3085),
  },
  [2457] = {
    [sym_block_comment] = STATE(2457),
    [sym_compiler_directive_decl] = STATE(2457),
    [sym_fsi_directive_decl] = STATE(2457),
    [sym_preproc_line] = STATE(2457),
    [sym_identifier] = ACTIONS(3079),
    [anon_sym_EQ] = ACTIONS(3081),
    [anon_sym_COLON] = ACTIONS(3079),
    [anon_sym_return] = ACTIONS(3079),
    [anon_sym_do] = ACTIONS(3079),
    [anon_sym_let] = ACTIONS(3079),
    [anon_sym_let_BANG] = ACTIONS(3081),
    [anon_sym_LPAREN] = ACTIONS(3079),
    [anon_sym_COMMA] = ACTIONS(3081),
    [anon_sym_null] = ACTIONS(3079),
    [anon_sym_QMARK] = ACTIONS(3079),
    [anon_sym_COLON_QMARK] = ACTIONS(3079),
    [anon_sym_COLON_COLON] = ACTIONS(3081),
    [anon_sym_AMP] = ACTIONS(3079),
    [anon_sym_LBRACK] = ACTIONS(3079),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3081),
    [anon_sym_LBRACE] = ACTIONS(3079),
    [anon_sym_LT_AT] = ACTIONS(3079),
    [anon_sym_LT_AT_AT] = ACTIONS(3079),
    [anon_sym_DOT] = ACTIONS(3079),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3081),
    [anon_sym_new] = ACTIONS(3079),
    [anon_sym_return_BANG] = ACTIONS(3081),
    [anon_sym_yield] = ACTIONS(3079),
    [anon_sym_yield_BANG] = ACTIONS(3081),
    [anon_sym_lazy] = ACTIONS(3079),
    [anon_sym_assert] = ACTIONS(3079),
    [anon_sym_upcast] = ACTIONS(3079),
    [anon_sym_downcast] = ACTIONS(3079),
    [anon_sym_COLON_GT] = ACTIONS(3081),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3081),
    [anon_sym_for] = ACTIONS(3079),
    [anon_sym_while] = ACTIONS(3079),
    [anon_sym_if] = ACTIONS(3079),
    [anon_sym_fun] = ACTIONS(3079),
    [anon_sym_try] = ACTIONS(3079),
    [anon_sym_match] = ACTIONS(3079),
    [anon_sym_match_BANG] = ACTIONS(3081),
    [anon_sym_function] = ACTIONS(3079),
    [anon_sym_LT_DASH] = ACTIONS(3079),
    [anon_sym_DOT_LBRACK] = ACTIONS(3081),
    [anon_sym_LT] = ACTIONS(3081),
    [anon_sym_use] = ACTIONS(3079),
    [anon_sym_use_BANG] = ACTIONS(3081),
    [anon_sym_do_BANG] = ACTIONS(3081),
    [anon_sym_begin] = ACTIONS(3079),
    [anon_sym_LPAREN2] = ACTIONS(3079),
    [anon_sym_or] = ACTIONS(3079),
    [aux_sym_char_token1] = ACTIONS(3081),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3079),
    [anon_sym_DQUOTE] = ACTIONS(3079),
    [anon_sym_AT_DQUOTE] = ACTIONS(3081),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3081),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3081),
    [sym_bool] = ACTIONS(3079),
    [sym_unit] = ACTIONS(3081),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3079),
    [sym_op_identifier] = ACTIONS(3079),
    [anon_sym_PLUS] = ACTIONS(3079),
    [anon_sym_DASH] = ACTIONS(3079),
    [anon_sym_PLUS_DOT] = ACTIONS(3079),
    [anon_sym_DASH_DOT] = ACTIONS(3079),
    [anon_sym_PERCENT] = ACTIONS(3079),
    [anon_sym_AMP_AMP] = ACTIONS(3079),
    [anon_sym_TILDE] = ACTIONS(3081),
    [aux_sym_prefix_op_token1] = ACTIONS(3079),
    [aux_sym_infix_op_token1] = ACTIONS(3081),
    [aux_sym_infix_op_token2] = ACTIONS(3079),
    [anon_sym_PIPE_PIPE] = ACTIONS(3079),
    [anon_sym_BANG_EQ] = ACTIONS(3079),
    [anon_sym_COLON_EQ] = ACTIONS(3081),
    [anon_sym_DOLLAR] = ACTIONS(3079),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3079),
    [sym_int] = ACTIONS(3079),
    [sym_xint] = ACTIONS(3081),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3081),
    [anon_sym_POUNDendif] = ACTIONS(3081),
    [sym__newline] = ACTIONS(3081),
  },
  [2458] = {
    [sym_block_comment] = STATE(2458),
    [sym_compiler_directive_decl] = STATE(2458),
    [sym_fsi_directive_decl] = STATE(2458),
    [sym_preproc_line] = STATE(2458),
    [sym_identifier] = ACTIONS(3063),
    [anon_sym_EQ] = ACTIONS(3065),
    [anon_sym_COLON] = ACTIONS(3063),
    [anon_sym_return] = ACTIONS(3063),
    [anon_sym_do] = ACTIONS(3063),
    [anon_sym_let] = ACTIONS(3063),
    [anon_sym_let_BANG] = ACTIONS(3065),
    [anon_sym_LPAREN] = ACTIONS(3063),
    [anon_sym_COMMA] = ACTIONS(3065),
    [anon_sym_null] = ACTIONS(3063),
    [anon_sym_QMARK] = ACTIONS(3063),
    [anon_sym_COLON_QMARK] = ACTIONS(3063),
    [anon_sym_COLON_COLON] = ACTIONS(3065),
    [anon_sym_AMP] = ACTIONS(3063),
    [anon_sym_LBRACK] = ACTIONS(3063),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3065),
    [anon_sym_LBRACE] = ACTIONS(3063),
    [anon_sym_LT_AT] = ACTIONS(3063),
    [anon_sym_LT_AT_AT] = ACTIONS(3063),
    [anon_sym_DOT] = ACTIONS(3063),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3065),
    [anon_sym_new] = ACTIONS(3063),
    [anon_sym_return_BANG] = ACTIONS(3065),
    [anon_sym_yield] = ACTIONS(3063),
    [anon_sym_yield_BANG] = ACTIONS(3065),
    [anon_sym_lazy] = ACTIONS(3063),
    [anon_sym_assert] = ACTIONS(3063),
    [anon_sym_upcast] = ACTIONS(3063),
    [anon_sym_downcast] = ACTIONS(3063),
    [anon_sym_COLON_GT] = ACTIONS(3065),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3065),
    [anon_sym_for] = ACTIONS(3063),
    [anon_sym_while] = ACTIONS(3063),
    [anon_sym_if] = ACTIONS(3063),
    [anon_sym_fun] = ACTIONS(3063),
    [anon_sym_try] = ACTIONS(3063),
    [anon_sym_match] = ACTIONS(3063),
    [anon_sym_match_BANG] = ACTIONS(3065),
    [anon_sym_function] = ACTIONS(3063),
    [anon_sym_LT_DASH] = ACTIONS(3063),
    [anon_sym_DOT_LBRACK] = ACTIONS(3065),
    [anon_sym_LT] = ACTIONS(3065),
    [anon_sym_use] = ACTIONS(3063),
    [anon_sym_use_BANG] = ACTIONS(3065),
    [anon_sym_do_BANG] = ACTIONS(3065),
    [anon_sym_begin] = ACTIONS(3063),
    [anon_sym_LPAREN2] = ACTIONS(3063),
    [anon_sym_or] = ACTIONS(3063),
    [aux_sym_char_token1] = ACTIONS(3065),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3063),
    [anon_sym_DQUOTE] = ACTIONS(3063),
    [anon_sym_AT_DQUOTE] = ACTIONS(3065),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3065),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3065),
    [sym_bool] = ACTIONS(3063),
    [sym_unit] = ACTIONS(3065),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3063),
    [sym_op_identifier] = ACTIONS(3063),
    [anon_sym_PLUS] = ACTIONS(3063),
    [anon_sym_DASH] = ACTIONS(3063),
    [anon_sym_PLUS_DOT] = ACTIONS(3063),
    [anon_sym_DASH_DOT] = ACTIONS(3063),
    [anon_sym_PERCENT] = ACTIONS(3063),
    [anon_sym_AMP_AMP] = ACTIONS(3063),
    [anon_sym_TILDE] = ACTIONS(3065),
    [aux_sym_prefix_op_token1] = ACTIONS(3063),
    [aux_sym_infix_op_token1] = ACTIONS(3065),
    [aux_sym_infix_op_token2] = ACTIONS(3063),
    [anon_sym_PIPE_PIPE] = ACTIONS(3063),
    [anon_sym_BANG_EQ] = ACTIONS(3063),
    [anon_sym_COLON_EQ] = ACTIONS(3065),
    [anon_sym_DOLLAR] = ACTIONS(3063),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3063),
    [sym_int] = ACTIONS(3063),
    [sym_xint] = ACTIONS(3065),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3065),
    [anon_sym_POUNDendif] = ACTIONS(3065),
    [sym__newline] = ACTIONS(3065),
  },
  [2459] = {
    [sym_block_comment] = STATE(2459),
    [sym_compiler_directive_decl] = STATE(2459),
    [sym_fsi_directive_decl] = STATE(2459),
    [sym_preproc_line] = STATE(2459),
    [sym_identifier] = ACTIONS(3059),
    [anon_sym_EQ] = ACTIONS(3061),
    [anon_sym_COLON] = ACTIONS(3059),
    [anon_sym_return] = ACTIONS(3059),
    [anon_sym_do] = ACTIONS(3059),
    [anon_sym_let] = ACTIONS(3059),
    [anon_sym_let_BANG] = ACTIONS(3061),
    [anon_sym_LPAREN] = ACTIONS(3059),
    [anon_sym_COMMA] = ACTIONS(3061),
    [anon_sym_null] = ACTIONS(3059),
    [anon_sym_QMARK] = ACTIONS(3059),
    [anon_sym_COLON_QMARK] = ACTIONS(3059),
    [anon_sym_COLON_COLON] = ACTIONS(3061),
    [anon_sym_AMP] = ACTIONS(3059),
    [anon_sym_LBRACK] = ACTIONS(3059),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3061),
    [anon_sym_LBRACE] = ACTIONS(3059),
    [anon_sym_LT_AT] = ACTIONS(3059),
    [anon_sym_LT_AT_AT] = ACTIONS(3059),
    [anon_sym_DOT] = ACTIONS(3059),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3061),
    [anon_sym_new] = ACTIONS(3059),
    [anon_sym_return_BANG] = ACTIONS(3061),
    [anon_sym_yield] = ACTIONS(3059),
    [anon_sym_yield_BANG] = ACTIONS(3061),
    [anon_sym_lazy] = ACTIONS(3059),
    [anon_sym_assert] = ACTIONS(3059),
    [anon_sym_upcast] = ACTIONS(3059),
    [anon_sym_downcast] = ACTIONS(3059),
    [anon_sym_COLON_GT] = ACTIONS(3061),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3061),
    [anon_sym_for] = ACTIONS(3059),
    [anon_sym_while] = ACTIONS(3059),
    [anon_sym_if] = ACTIONS(3059),
    [anon_sym_fun] = ACTIONS(3059),
    [anon_sym_try] = ACTIONS(3059),
    [anon_sym_match] = ACTIONS(3059),
    [anon_sym_match_BANG] = ACTIONS(3061),
    [anon_sym_function] = ACTIONS(3059),
    [anon_sym_LT_DASH] = ACTIONS(3059),
    [anon_sym_DOT_LBRACK] = ACTIONS(3061),
    [anon_sym_LT] = ACTIONS(3061),
    [anon_sym_use] = ACTIONS(3059),
    [anon_sym_use_BANG] = ACTIONS(3061),
    [anon_sym_do_BANG] = ACTIONS(3061),
    [anon_sym_begin] = ACTIONS(3059),
    [anon_sym_LPAREN2] = ACTIONS(3059),
    [anon_sym_or] = ACTIONS(3059),
    [aux_sym_char_token1] = ACTIONS(3061),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3059),
    [anon_sym_DQUOTE] = ACTIONS(3059),
    [anon_sym_AT_DQUOTE] = ACTIONS(3061),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3061),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3061),
    [sym_bool] = ACTIONS(3059),
    [sym_unit] = ACTIONS(3061),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3059),
    [sym_op_identifier] = ACTIONS(3059),
    [anon_sym_PLUS] = ACTIONS(3059),
    [anon_sym_DASH] = ACTIONS(3059),
    [anon_sym_PLUS_DOT] = ACTIONS(3059),
    [anon_sym_DASH_DOT] = ACTIONS(3059),
    [anon_sym_PERCENT] = ACTIONS(3059),
    [anon_sym_AMP_AMP] = ACTIONS(3059),
    [anon_sym_TILDE] = ACTIONS(3061),
    [aux_sym_prefix_op_token1] = ACTIONS(3059),
    [aux_sym_infix_op_token1] = ACTIONS(3061),
    [aux_sym_infix_op_token2] = ACTIONS(3059),
    [anon_sym_PIPE_PIPE] = ACTIONS(3059),
    [anon_sym_BANG_EQ] = ACTIONS(3059),
    [anon_sym_COLON_EQ] = ACTIONS(3061),
    [anon_sym_DOLLAR] = ACTIONS(3059),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3059),
    [sym_int] = ACTIONS(3059),
    [sym_xint] = ACTIONS(3061),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3061),
    [anon_sym_POUNDendif] = ACTIONS(3061),
    [sym__newline] = ACTIONS(3061),
  },
  [2460] = {
    [sym_block_comment] = STATE(2460),
    [sym_compiler_directive_decl] = STATE(2460),
    [sym_fsi_directive_decl] = STATE(2460),
    [sym_preproc_line] = STATE(2460),
    [sym_identifier] = ACTIONS(3051),
    [anon_sym_EQ] = ACTIONS(3053),
    [anon_sym_COLON] = ACTIONS(3051),
    [anon_sym_return] = ACTIONS(3051),
    [anon_sym_do] = ACTIONS(3051),
    [anon_sym_let] = ACTIONS(3051),
    [anon_sym_let_BANG] = ACTIONS(3053),
    [anon_sym_LPAREN] = ACTIONS(3051),
    [anon_sym_COMMA] = ACTIONS(3053),
    [anon_sym_null] = ACTIONS(3051),
    [anon_sym_QMARK] = ACTIONS(3051),
    [anon_sym_COLON_QMARK] = ACTIONS(3051),
    [anon_sym_COLON_COLON] = ACTIONS(3053),
    [anon_sym_AMP] = ACTIONS(3051),
    [anon_sym_LBRACK] = ACTIONS(3051),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3053),
    [anon_sym_LBRACE] = ACTIONS(3051),
    [anon_sym_LT_AT] = ACTIONS(3051),
    [anon_sym_LT_AT_AT] = ACTIONS(3051),
    [anon_sym_DOT] = ACTIONS(3051),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3053),
    [anon_sym_new] = ACTIONS(3051),
    [anon_sym_return_BANG] = ACTIONS(3053),
    [anon_sym_yield] = ACTIONS(3051),
    [anon_sym_yield_BANG] = ACTIONS(3053),
    [anon_sym_lazy] = ACTIONS(3051),
    [anon_sym_assert] = ACTIONS(3051),
    [anon_sym_upcast] = ACTIONS(3051),
    [anon_sym_downcast] = ACTIONS(3051),
    [anon_sym_COLON_GT] = ACTIONS(3053),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3053),
    [anon_sym_for] = ACTIONS(3051),
    [anon_sym_while] = ACTIONS(3051),
    [anon_sym_if] = ACTIONS(3051),
    [anon_sym_fun] = ACTIONS(3051),
    [anon_sym_try] = ACTIONS(3051),
    [anon_sym_match] = ACTIONS(3051),
    [anon_sym_match_BANG] = ACTIONS(3053),
    [anon_sym_function] = ACTIONS(3051),
    [anon_sym_LT_DASH] = ACTIONS(3051),
    [anon_sym_DOT_LBRACK] = ACTIONS(3053),
    [anon_sym_LT] = ACTIONS(3053),
    [anon_sym_use] = ACTIONS(3051),
    [anon_sym_use_BANG] = ACTIONS(3053),
    [anon_sym_do_BANG] = ACTIONS(3053),
    [anon_sym_begin] = ACTIONS(3051),
    [anon_sym_LPAREN2] = ACTIONS(3051),
    [anon_sym_or] = ACTIONS(3051),
    [aux_sym_char_token1] = ACTIONS(3053),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3051),
    [anon_sym_DQUOTE] = ACTIONS(3051),
    [anon_sym_AT_DQUOTE] = ACTIONS(3053),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3053),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3053),
    [sym_bool] = ACTIONS(3051),
    [sym_unit] = ACTIONS(3053),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3051),
    [sym_op_identifier] = ACTIONS(3051),
    [anon_sym_PLUS] = ACTIONS(3051),
    [anon_sym_DASH] = ACTIONS(3051),
    [anon_sym_PLUS_DOT] = ACTIONS(3051),
    [anon_sym_DASH_DOT] = ACTIONS(3051),
    [anon_sym_PERCENT] = ACTIONS(3051),
    [anon_sym_AMP_AMP] = ACTIONS(3051),
    [anon_sym_TILDE] = ACTIONS(3053),
    [aux_sym_prefix_op_token1] = ACTIONS(3051),
    [aux_sym_infix_op_token1] = ACTIONS(3053),
    [aux_sym_infix_op_token2] = ACTIONS(3051),
    [anon_sym_PIPE_PIPE] = ACTIONS(3051),
    [anon_sym_BANG_EQ] = ACTIONS(3051),
    [anon_sym_COLON_EQ] = ACTIONS(3053),
    [anon_sym_DOLLAR] = ACTIONS(3051),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3051),
    [sym_int] = ACTIONS(3051),
    [sym_xint] = ACTIONS(3053),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3053),
    [anon_sym_POUNDendif] = ACTIONS(3053),
    [sym__newline] = ACTIONS(3053),
  },
  [2461] = {
    [sym_block_comment] = STATE(2461),
    [sym_compiler_directive_decl] = STATE(2461),
    [sym_fsi_directive_decl] = STATE(2461),
    [sym_preproc_line] = STATE(2461),
    [sym_identifier] = ACTIONS(2902),
    [anon_sym_EQ] = ACTIONS(2904),
    [anon_sym_COLON] = ACTIONS(2902),
    [anon_sym_return] = ACTIONS(2902),
    [anon_sym_do] = ACTIONS(2902),
    [anon_sym_let] = ACTIONS(2902),
    [anon_sym_let_BANG] = ACTIONS(2904),
    [anon_sym_LPAREN] = ACTIONS(2902),
    [anon_sym_COMMA] = ACTIONS(2904),
    [anon_sym_null] = ACTIONS(2902),
    [anon_sym_QMARK] = ACTIONS(2902),
    [anon_sym_COLON_QMARK] = ACTIONS(2902),
    [anon_sym_COLON_COLON] = ACTIONS(2904),
    [anon_sym_AMP] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2902),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2902),
    [anon_sym_LT_AT] = ACTIONS(2902),
    [anon_sym_LT_AT_AT] = ACTIONS(2902),
    [anon_sym_AT_AT_GT] = ACTIONS(2902),
    [anon_sym_DOT] = ACTIONS(2902),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2904),
    [anon_sym_new] = ACTIONS(2902),
    [anon_sym_return_BANG] = ACTIONS(2904),
    [anon_sym_yield] = ACTIONS(2902),
    [anon_sym_yield_BANG] = ACTIONS(2904),
    [anon_sym_lazy] = ACTIONS(2902),
    [anon_sym_assert] = ACTIONS(2902),
    [anon_sym_upcast] = ACTIONS(2902),
    [anon_sym_downcast] = ACTIONS(2902),
    [anon_sym_COLON_GT] = ACTIONS(2904),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2904),
    [anon_sym_for] = ACTIONS(2902),
    [anon_sym_while] = ACTIONS(2902),
    [anon_sym_if] = ACTIONS(2902),
    [anon_sym_fun] = ACTIONS(2902),
    [anon_sym_try] = ACTIONS(2902),
    [anon_sym_match] = ACTIONS(2902),
    [anon_sym_match_BANG] = ACTIONS(2904),
    [anon_sym_function] = ACTIONS(2902),
    [anon_sym_LT_DASH] = ACTIONS(2902),
    [anon_sym_DOT_LBRACK] = ACTIONS(2904),
    [anon_sym_LT] = ACTIONS(2904),
    [anon_sym_use] = ACTIONS(2902),
    [anon_sym_use_BANG] = ACTIONS(2904),
    [anon_sym_do_BANG] = ACTIONS(2904),
    [anon_sym_begin] = ACTIONS(2902),
    [anon_sym_LPAREN2] = ACTIONS(2902),
    [anon_sym_or] = ACTIONS(2902),
    [aux_sym_char_token1] = ACTIONS(2904),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2902),
    [anon_sym_DQUOTE] = ACTIONS(2902),
    [anon_sym_AT_DQUOTE] = ACTIONS(2904),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2904),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2904),
    [sym_bool] = ACTIONS(2902),
    [sym_unit] = ACTIONS(2904),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2902),
    [sym_op_identifier] = ACTIONS(2902),
    [anon_sym_PLUS] = ACTIONS(2902),
    [anon_sym_DASH] = ACTIONS(2902),
    [anon_sym_PLUS_DOT] = ACTIONS(2902),
    [anon_sym_DASH_DOT] = ACTIONS(2902),
    [anon_sym_PERCENT] = ACTIONS(2902),
    [anon_sym_AMP_AMP] = ACTIONS(2902),
    [anon_sym_TILDE] = ACTIONS(2904),
    [aux_sym_prefix_op_token1] = ACTIONS(2902),
    [aux_sym_infix_op_token1] = ACTIONS(2904),
    [aux_sym_infix_op_token2] = ACTIONS(2902),
    [anon_sym_PIPE_PIPE] = ACTIONS(2902),
    [anon_sym_BANG_EQ] = ACTIONS(2902),
    [anon_sym_COLON_EQ] = ACTIONS(2904),
    [anon_sym_DOLLAR] = ACTIONS(2902),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2902),
    [sym_int] = ACTIONS(2902),
    [sym_xint] = ACTIONS(2904),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2904),
    [sym__newline] = ACTIONS(2904),
  },
  [2462] = {
    [sym_block_comment] = STATE(2462),
    [sym_compiler_directive_decl] = STATE(2462),
    [sym_fsi_directive_decl] = STATE(2462),
    [sym_preproc_line] = STATE(2462),
    [sym_identifier] = ACTIONS(3047),
    [anon_sym_EQ] = ACTIONS(3049),
    [anon_sym_COLON] = ACTIONS(3047),
    [anon_sym_return] = ACTIONS(3047),
    [anon_sym_do] = ACTIONS(3047),
    [anon_sym_let] = ACTIONS(3047),
    [anon_sym_let_BANG] = ACTIONS(3049),
    [anon_sym_LPAREN] = ACTIONS(3047),
    [anon_sym_COMMA] = ACTIONS(3049),
    [anon_sym_null] = ACTIONS(3047),
    [anon_sym_QMARK] = ACTIONS(3047),
    [anon_sym_COLON_QMARK] = ACTIONS(3047),
    [anon_sym_COLON_COLON] = ACTIONS(3049),
    [anon_sym_AMP] = ACTIONS(3047),
    [anon_sym_LBRACK] = ACTIONS(3047),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3049),
    [anon_sym_LBRACE] = ACTIONS(3047),
    [anon_sym_LT_AT] = ACTIONS(3047),
    [anon_sym_LT_AT_AT] = ACTIONS(3047),
    [anon_sym_DOT] = ACTIONS(3047),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3049),
    [anon_sym_new] = ACTIONS(3047),
    [anon_sym_return_BANG] = ACTIONS(3049),
    [anon_sym_yield] = ACTIONS(3047),
    [anon_sym_yield_BANG] = ACTIONS(3049),
    [anon_sym_lazy] = ACTIONS(3047),
    [anon_sym_assert] = ACTIONS(3047),
    [anon_sym_upcast] = ACTIONS(3047),
    [anon_sym_downcast] = ACTIONS(3047),
    [anon_sym_COLON_GT] = ACTIONS(3049),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3049),
    [anon_sym_for] = ACTIONS(3047),
    [anon_sym_while] = ACTIONS(3047),
    [anon_sym_if] = ACTIONS(3047),
    [anon_sym_fun] = ACTIONS(3047),
    [anon_sym_try] = ACTIONS(3047),
    [anon_sym_match] = ACTIONS(3047),
    [anon_sym_match_BANG] = ACTIONS(3049),
    [anon_sym_function] = ACTIONS(3047),
    [anon_sym_LT_DASH] = ACTIONS(3047),
    [anon_sym_DOT_LBRACK] = ACTIONS(3049),
    [anon_sym_LT] = ACTIONS(3049),
    [anon_sym_use] = ACTIONS(3047),
    [anon_sym_use_BANG] = ACTIONS(3049),
    [anon_sym_do_BANG] = ACTIONS(3049),
    [anon_sym_begin] = ACTIONS(3047),
    [anon_sym_LPAREN2] = ACTIONS(3047),
    [anon_sym_or] = ACTIONS(3047),
    [aux_sym_char_token1] = ACTIONS(3049),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3047),
    [anon_sym_DQUOTE] = ACTIONS(3047),
    [anon_sym_AT_DQUOTE] = ACTIONS(3049),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3049),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3049),
    [sym_bool] = ACTIONS(3047),
    [sym_unit] = ACTIONS(3049),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3047),
    [sym_op_identifier] = ACTIONS(3047),
    [anon_sym_PLUS] = ACTIONS(3047),
    [anon_sym_DASH] = ACTIONS(3047),
    [anon_sym_PLUS_DOT] = ACTIONS(3047),
    [anon_sym_DASH_DOT] = ACTIONS(3047),
    [anon_sym_PERCENT] = ACTIONS(3047),
    [anon_sym_AMP_AMP] = ACTIONS(3047),
    [anon_sym_TILDE] = ACTIONS(3049),
    [aux_sym_prefix_op_token1] = ACTIONS(3047),
    [aux_sym_infix_op_token1] = ACTIONS(3049),
    [aux_sym_infix_op_token2] = ACTIONS(3047),
    [anon_sym_PIPE_PIPE] = ACTIONS(3047),
    [anon_sym_BANG_EQ] = ACTIONS(3047),
    [anon_sym_COLON_EQ] = ACTIONS(3049),
    [anon_sym_DOLLAR] = ACTIONS(3047),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3047),
    [sym_int] = ACTIONS(3047),
    [sym_xint] = ACTIONS(3049),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3049),
    [anon_sym_POUNDendif] = ACTIONS(3049),
    [sym__newline] = ACTIONS(3049),
  },
  [2463] = {
    [sym_block_comment] = STATE(2463),
    [sym_compiler_directive_decl] = STATE(2463),
    [sym_fsi_directive_decl] = STATE(2463),
    [sym_preproc_line] = STATE(2463),
    [sym_identifier] = ACTIONS(2906),
    [anon_sym_EQ] = ACTIONS(2908),
    [anon_sym_COLON] = ACTIONS(2906),
    [anon_sym_return] = ACTIONS(2906),
    [anon_sym_do] = ACTIONS(2906),
    [anon_sym_let] = ACTIONS(2906),
    [anon_sym_let_BANG] = ACTIONS(2908),
    [anon_sym_LPAREN] = ACTIONS(2906),
    [anon_sym_COMMA] = ACTIONS(2908),
    [anon_sym_null] = ACTIONS(2906),
    [anon_sym_QMARK] = ACTIONS(2906),
    [anon_sym_COLON_QMARK] = ACTIONS(2906),
    [anon_sym_COLON_COLON] = ACTIONS(2908),
    [anon_sym_AMP] = ACTIONS(2906),
    [anon_sym_LBRACK] = ACTIONS(2906),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2908),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_LT_AT] = ACTIONS(2906),
    [anon_sym_LT_AT_AT] = ACTIONS(2906),
    [anon_sym_AT_AT_GT] = ACTIONS(2906),
    [anon_sym_DOT] = ACTIONS(2906),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2908),
    [anon_sym_new] = ACTIONS(2906),
    [anon_sym_return_BANG] = ACTIONS(2908),
    [anon_sym_yield] = ACTIONS(2906),
    [anon_sym_yield_BANG] = ACTIONS(2908),
    [anon_sym_lazy] = ACTIONS(2906),
    [anon_sym_assert] = ACTIONS(2906),
    [anon_sym_upcast] = ACTIONS(2906),
    [anon_sym_downcast] = ACTIONS(2906),
    [anon_sym_COLON_GT] = ACTIONS(2908),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2908),
    [anon_sym_for] = ACTIONS(2906),
    [anon_sym_while] = ACTIONS(2906),
    [anon_sym_if] = ACTIONS(2906),
    [anon_sym_fun] = ACTIONS(2906),
    [anon_sym_try] = ACTIONS(2906),
    [anon_sym_match] = ACTIONS(2906),
    [anon_sym_match_BANG] = ACTIONS(2908),
    [anon_sym_function] = ACTIONS(2906),
    [anon_sym_LT_DASH] = ACTIONS(2906),
    [anon_sym_DOT_LBRACK] = ACTIONS(2908),
    [anon_sym_LT] = ACTIONS(2908),
    [anon_sym_use] = ACTIONS(2906),
    [anon_sym_use_BANG] = ACTIONS(2908),
    [anon_sym_do_BANG] = ACTIONS(2908),
    [anon_sym_begin] = ACTIONS(2906),
    [anon_sym_LPAREN2] = ACTIONS(2906),
    [anon_sym_or] = ACTIONS(2906),
    [aux_sym_char_token1] = ACTIONS(2908),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2906),
    [anon_sym_DQUOTE] = ACTIONS(2906),
    [anon_sym_AT_DQUOTE] = ACTIONS(2908),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2908),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2908),
    [sym_bool] = ACTIONS(2906),
    [sym_unit] = ACTIONS(2908),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2906),
    [sym_op_identifier] = ACTIONS(2906),
    [anon_sym_PLUS] = ACTIONS(2906),
    [anon_sym_DASH] = ACTIONS(2906),
    [anon_sym_PLUS_DOT] = ACTIONS(2906),
    [anon_sym_DASH_DOT] = ACTIONS(2906),
    [anon_sym_PERCENT] = ACTIONS(2906),
    [anon_sym_AMP_AMP] = ACTIONS(2906),
    [anon_sym_TILDE] = ACTIONS(2908),
    [aux_sym_prefix_op_token1] = ACTIONS(2906),
    [aux_sym_infix_op_token1] = ACTIONS(2908),
    [aux_sym_infix_op_token2] = ACTIONS(2906),
    [anon_sym_PIPE_PIPE] = ACTIONS(2906),
    [anon_sym_BANG_EQ] = ACTIONS(2906),
    [anon_sym_COLON_EQ] = ACTIONS(2908),
    [anon_sym_DOLLAR] = ACTIONS(2906),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2906),
    [sym_int] = ACTIONS(2906),
    [sym_xint] = ACTIONS(2908),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2908),
    [sym__newline] = ACTIONS(2908),
  },
  [2464] = {
    [sym_block_comment] = STATE(2464),
    [sym_compiler_directive_decl] = STATE(2464),
    [sym_fsi_directive_decl] = STATE(2464),
    [sym_preproc_line] = STATE(2464),
    [sym_identifier] = ACTIONS(2930),
    [anon_sym_EQ] = ACTIONS(2932),
    [anon_sym_COLON] = ACTIONS(2930),
    [anon_sym_return] = ACTIONS(2930),
    [anon_sym_do] = ACTIONS(2930),
    [anon_sym_let] = ACTIONS(2930),
    [anon_sym_let_BANG] = ACTIONS(2932),
    [anon_sym_LPAREN] = ACTIONS(2930),
    [anon_sym_COMMA] = ACTIONS(2932),
    [anon_sym_null] = ACTIONS(2930),
    [anon_sym_QMARK] = ACTIONS(2930),
    [anon_sym_COLON_QMARK] = ACTIONS(2930),
    [anon_sym_COLON_COLON] = ACTIONS(2932),
    [anon_sym_AMP] = ACTIONS(2930),
    [anon_sym_LBRACK] = ACTIONS(2930),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2932),
    [anon_sym_LBRACE] = ACTIONS(2930),
    [anon_sym_LT_AT] = ACTIONS(2930),
    [anon_sym_LT_AT_AT] = ACTIONS(2930),
    [anon_sym_AT_AT_GT] = ACTIONS(2930),
    [anon_sym_DOT] = ACTIONS(2930),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2932),
    [anon_sym_new] = ACTIONS(2930),
    [anon_sym_return_BANG] = ACTIONS(2932),
    [anon_sym_yield] = ACTIONS(2930),
    [anon_sym_yield_BANG] = ACTIONS(2932),
    [anon_sym_lazy] = ACTIONS(2930),
    [anon_sym_assert] = ACTIONS(2930),
    [anon_sym_upcast] = ACTIONS(2930),
    [anon_sym_downcast] = ACTIONS(2930),
    [anon_sym_COLON_GT] = ACTIONS(2932),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2932),
    [anon_sym_for] = ACTIONS(2930),
    [anon_sym_while] = ACTIONS(2930),
    [anon_sym_if] = ACTIONS(2930),
    [anon_sym_fun] = ACTIONS(2930),
    [anon_sym_try] = ACTIONS(2930),
    [anon_sym_match] = ACTIONS(2930),
    [anon_sym_match_BANG] = ACTIONS(2932),
    [anon_sym_function] = ACTIONS(2930),
    [anon_sym_LT_DASH] = ACTIONS(2930),
    [anon_sym_DOT_LBRACK] = ACTIONS(2932),
    [anon_sym_LT] = ACTIONS(2932),
    [anon_sym_use] = ACTIONS(2930),
    [anon_sym_use_BANG] = ACTIONS(2932),
    [anon_sym_do_BANG] = ACTIONS(2932),
    [anon_sym_begin] = ACTIONS(2930),
    [anon_sym_LPAREN2] = ACTIONS(2930),
    [anon_sym_or] = ACTIONS(2930),
    [aux_sym_char_token1] = ACTIONS(2932),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2930),
    [anon_sym_DQUOTE] = ACTIONS(2930),
    [anon_sym_AT_DQUOTE] = ACTIONS(2932),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2932),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2932),
    [sym_bool] = ACTIONS(2930),
    [sym_unit] = ACTIONS(2932),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2930),
    [sym_op_identifier] = ACTIONS(2930),
    [anon_sym_PLUS] = ACTIONS(2930),
    [anon_sym_DASH] = ACTIONS(2930),
    [anon_sym_PLUS_DOT] = ACTIONS(2930),
    [anon_sym_DASH_DOT] = ACTIONS(2930),
    [anon_sym_PERCENT] = ACTIONS(2930),
    [anon_sym_AMP_AMP] = ACTIONS(2930),
    [anon_sym_TILDE] = ACTIONS(2932),
    [aux_sym_prefix_op_token1] = ACTIONS(2930),
    [aux_sym_infix_op_token1] = ACTIONS(2932),
    [aux_sym_infix_op_token2] = ACTIONS(2930),
    [anon_sym_PIPE_PIPE] = ACTIONS(2930),
    [anon_sym_BANG_EQ] = ACTIONS(2930),
    [anon_sym_COLON_EQ] = ACTIONS(2932),
    [anon_sym_DOLLAR] = ACTIONS(2930),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2930),
    [sym_int] = ACTIONS(2930),
    [sym_xint] = ACTIONS(2932),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2932),
    [sym__newline] = ACTIONS(2932),
  },
  [2465] = {
    [sym_block_comment] = STATE(2465),
    [sym_compiler_directive_decl] = STATE(2465),
    [sym_fsi_directive_decl] = STATE(2465),
    [sym_preproc_line] = STATE(2465),
    [sym_identifier] = ACTIONS(3043),
    [anon_sym_EQ] = ACTIONS(3045),
    [anon_sym_COLON] = ACTIONS(3043),
    [anon_sym_return] = ACTIONS(3043),
    [anon_sym_do] = ACTIONS(3043),
    [anon_sym_let] = ACTIONS(3043),
    [anon_sym_let_BANG] = ACTIONS(3045),
    [anon_sym_LPAREN] = ACTIONS(3043),
    [anon_sym_COMMA] = ACTIONS(3045),
    [anon_sym_null] = ACTIONS(3043),
    [anon_sym_QMARK] = ACTIONS(3043),
    [anon_sym_COLON_QMARK] = ACTIONS(3043),
    [anon_sym_COLON_COLON] = ACTIONS(3045),
    [anon_sym_AMP] = ACTIONS(3043),
    [anon_sym_LBRACK] = ACTIONS(3043),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3045),
    [anon_sym_LBRACE] = ACTIONS(3043),
    [anon_sym_LT_AT] = ACTIONS(3043),
    [anon_sym_LT_AT_AT] = ACTIONS(3043),
    [anon_sym_DOT] = ACTIONS(3043),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3045),
    [anon_sym_new] = ACTIONS(3043),
    [anon_sym_return_BANG] = ACTIONS(3045),
    [anon_sym_yield] = ACTIONS(3043),
    [anon_sym_yield_BANG] = ACTIONS(3045),
    [anon_sym_lazy] = ACTIONS(3043),
    [anon_sym_assert] = ACTIONS(3043),
    [anon_sym_upcast] = ACTIONS(3043),
    [anon_sym_downcast] = ACTIONS(3043),
    [anon_sym_COLON_GT] = ACTIONS(3045),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3045),
    [anon_sym_for] = ACTIONS(3043),
    [anon_sym_while] = ACTIONS(3043),
    [anon_sym_if] = ACTIONS(3043),
    [anon_sym_fun] = ACTIONS(3043),
    [anon_sym_try] = ACTIONS(3043),
    [anon_sym_match] = ACTIONS(3043),
    [anon_sym_match_BANG] = ACTIONS(3045),
    [anon_sym_function] = ACTIONS(3043),
    [anon_sym_LT_DASH] = ACTIONS(3043),
    [anon_sym_DOT_LBRACK] = ACTIONS(3045),
    [anon_sym_LT] = ACTIONS(3045),
    [anon_sym_use] = ACTIONS(3043),
    [anon_sym_use_BANG] = ACTIONS(3045),
    [anon_sym_do_BANG] = ACTIONS(3045),
    [anon_sym_begin] = ACTIONS(3043),
    [anon_sym_LPAREN2] = ACTIONS(3043),
    [anon_sym_or] = ACTIONS(3043),
    [aux_sym_char_token1] = ACTIONS(3045),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3043),
    [anon_sym_DQUOTE] = ACTIONS(3043),
    [anon_sym_AT_DQUOTE] = ACTIONS(3045),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3045),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3045),
    [sym_bool] = ACTIONS(3043),
    [sym_unit] = ACTIONS(3045),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3043),
    [sym_op_identifier] = ACTIONS(3043),
    [anon_sym_PLUS] = ACTIONS(3043),
    [anon_sym_DASH] = ACTIONS(3043),
    [anon_sym_PLUS_DOT] = ACTIONS(3043),
    [anon_sym_DASH_DOT] = ACTIONS(3043),
    [anon_sym_PERCENT] = ACTIONS(3043),
    [anon_sym_AMP_AMP] = ACTIONS(3043),
    [anon_sym_TILDE] = ACTIONS(3045),
    [aux_sym_prefix_op_token1] = ACTIONS(3043),
    [aux_sym_infix_op_token1] = ACTIONS(3045),
    [aux_sym_infix_op_token2] = ACTIONS(3043),
    [anon_sym_PIPE_PIPE] = ACTIONS(3043),
    [anon_sym_BANG_EQ] = ACTIONS(3043),
    [anon_sym_COLON_EQ] = ACTIONS(3045),
    [anon_sym_DOLLAR] = ACTIONS(3043),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3043),
    [sym_int] = ACTIONS(3043),
    [sym_xint] = ACTIONS(3045),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3045),
    [anon_sym_POUNDendif] = ACTIONS(3045),
    [sym__newline] = ACTIONS(3045),
  },
  [2466] = {
    [sym_block_comment] = STATE(2466),
    [sym_compiler_directive_decl] = STATE(2466),
    [sym_fsi_directive_decl] = STATE(2466),
    [sym_preproc_line] = STATE(2466),
    [sym_identifier] = ACTIONS(3039),
    [anon_sym_EQ] = ACTIONS(3041),
    [anon_sym_COLON] = ACTIONS(3039),
    [anon_sym_return] = ACTIONS(3039),
    [anon_sym_do] = ACTIONS(3039),
    [anon_sym_let] = ACTIONS(3039),
    [anon_sym_let_BANG] = ACTIONS(3041),
    [anon_sym_LPAREN] = ACTIONS(3039),
    [anon_sym_COMMA] = ACTIONS(3041),
    [anon_sym_null] = ACTIONS(3039),
    [anon_sym_QMARK] = ACTIONS(3039),
    [anon_sym_COLON_QMARK] = ACTIONS(3039),
    [anon_sym_COLON_COLON] = ACTIONS(3041),
    [anon_sym_AMP] = ACTIONS(3039),
    [anon_sym_LBRACK] = ACTIONS(3039),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3041),
    [anon_sym_LBRACE] = ACTIONS(3039),
    [anon_sym_LT_AT] = ACTIONS(3039),
    [anon_sym_LT_AT_AT] = ACTIONS(3039),
    [anon_sym_DOT] = ACTIONS(3039),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3041),
    [anon_sym_new] = ACTIONS(3039),
    [anon_sym_return_BANG] = ACTIONS(3041),
    [anon_sym_yield] = ACTIONS(3039),
    [anon_sym_yield_BANG] = ACTIONS(3041),
    [anon_sym_lazy] = ACTIONS(3039),
    [anon_sym_assert] = ACTIONS(3039),
    [anon_sym_upcast] = ACTIONS(3039),
    [anon_sym_downcast] = ACTIONS(3039),
    [anon_sym_COLON_GT] = ACTIONS(3041),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(3041),
    [anon_sym_for] = ACTIONS(3039),
    [anon_sym_while] = ACTIONS(3039),
    [anon_sym_if] = ACTIONS(3039),
    [anon_sym_fun] = ACTIONS(3039),
    [anon_sym_try] = ACTIONS(3039),
    [anon_sym_match] = ACTIONS(3039),
    [anon_sym_match_BANG] = ACTIONS(3041),
    [anon_sym_function] = ACTIONS(3039),
    [anon_sym_LT_DASH] = ACTIONS(3039),
    [anon_sym_DOT_LBRACK] = ACTIONS(3041),
    [anon_sym_LT] = ACTIONS(3041),
    [anon_sym_use] = ACTIONS(3039),
    [anon_sym_use_BANG] = ACTIONS(3041),
    [anon_sym_do_BANG] = ACTIONS(3041),
    [anon_sym_begin] = ACTIONS(3039),
    [anon_sym_LPAREN2] = ACTIONS(3039),
    [anon_sym_or] = ACTIONS(3039),
    [aux_sym_char_token1] = ACTIONS(3041),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3039),
    [anon_sym_DQUOTE] = ACTIONS(3039),
    [anon_sym_AT_DQUOTE] = ACTIONS(3041),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3041),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3041),
    [sym_bool] = ACTIONS(3039),
    [sym_unit] = ACTIONS(3041),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3039),
    [sym_op_identifier] = ACTIONS(3039),
    [anon_sym_PLUS] = ACTIONS(3039),
    [anon_sym_DASH] = ACTIONS(3039),
    [anon_sym_PLUS_DOT] = ACTIONS(3039),
    [anon_sym_DASH_DOT] = ACTIONS(3039),
    [anon_sym_PERCENT] = ACTIONS(3039),
    [anon_sym_AMP_AMP] = ACTIONS(3039),
    [anon_sym_TILDE] = ACTIONS(3041),
    [aux_sym_prefix_op_token1] = ACTIONS(3039),
    [aux_sym_infix_op_token1] = ACTIONS(3041),
    [aux_sym_infix_op_token2] = ACTIONS(3039),
    [anon_sym_PIPE_PIPE] = ACTIONS(3039),
    [anon_sym_BANG_EQ] = ACTIONS(3039),
    [anon_sym_COLON_EQ] = ACTIONS(3041),
    [anon_sym_DOLLAR] = ACTIONS(3039),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(3039),
    [sym_int] = ACTIONS(3039),
    [sym_xint] = ACTIONS(3041),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3041),
    [anon_sym_POUNDendif] = ACTIONS(3041),
    [sym__newline] = ACTIONS(3041),
  },
  [2467] = {
    [sym_block_comment] = STATE(2467),
    [sym_compiler_directive_decl] = STATE(2467),
    [sym_fsi_directive_decl] = STATE(2467),
    [sym_preproc_line] = STATE(2467),
    [sym_identifier] = ACTIONS(2934),
    [anon_sym_EQ] = ACTIONS(2936),
    [anon_sym_COLON] = ACTIONS(2934),
    [anon_sym_return] = ACTIONS(2934),
    [anon_sym_do] = ACTIONS(2934),
    [anon_sym_let] = ACTIONS(2934),
    [anon_sym_let_BANG] = ACTIONS(2936),
    [anon_sym_LPAREN] = ACTIONS(2934),
    [anon_sym_COMMA] = ACTIONS(2936),
    [anon_sym_null] = ACTIONS(2934),
    [anon_sym_QMARK] = ACTIONS(2934),
    [anon_sym_COLON_QMARK] = ACTIONS(2934),
    [anon_sym_COLON_COLON] = ACTIONS(2936),
    [anon_sym_AMP] = ACTIONS(2934),
    [anon_sym_LBRACK] = ACTIONS(2934),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2936),
    [anon_sym_LBRACE] = ACTIONS(2934),
    [anon_sym_LT_AT] = ACTIONS(2934),
    [anon_sym_LT_AT_AT] = ACTIONS(2934),
    [anon_sym_DOT] = ACTIONS(2934),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2936),
    [anon_sym_new] = ACTIONS(2934),
    [anon_sym_return_BANG] = ACTIONS(2936),
    [anon_sym_yield] = ACTIONS(2934),
    [anon_sym_yield_BANG] = ACTIONS(2936),
    [anon_sym_lazy] = ACTIONS(2934),
    [anon_sym_assert] = ACTIONS(2934),
    [anon_sym_upcast] = ACTIONS(2934),
    [anon_sym_downcast] = ACTIONS(2934),
    [anon_sym_COLON_GT] = ACTIONS(2936),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2936),
    [anon_sym_for] = ACTIONS(2934),
    [anon_sym_while] = ACTIONS(2934),
    [anon_sym_if] = ACTIONS(2934),
    [anon_sym_fun] = ACTIONS(2934),
    [anon_sym_try] = ACTIONS(2934),
    [anon_sym_match] = ACTIONS(2934),
    [anon_sym_match_BANG] = ACTIONS(2936),
    [anon_sym_function] = ACTIONS(2934),
    [anon_sym_LT_DASH] = ACTIONS(2934),
    [anon_sym_DOT_LBRACK] = ACTIONS(2936),
    [anon_sym_LT] = ACTIONS(2936),
    [anon_sym_use] = ACTIONS(2934),
    [anon_sym_use_BANG] = ACTIONS(2936),
    [anon_sym_do_BANG] = ACTIONS(2936),
    [anon_sym_DOT_DOT] = ACTIONS(2936),
    [anon_sym_begin] = ACTIONS(2934),
    [anon_sym_LPAREN2] = ACTIONS(2934),
    [anon_sym_or] = ACTIONS(2934),
    [aux_sym_char_token1] = ACTIONS(2936),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2934),
    [anon_sym_DQUOTE] = ACTIONS(2934),
    [anon_sym_AT_DQUOTE] = ACTIONS(2936),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2936),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2936),
    [sym_bool] = ACTIONS(2934),
    [sym_unit] = ACTIONS(2936),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2934),
    [sym_op_identifier] = ACTIONS(2934),
    [anon_sym_PLUS] = ACTIONS(2934),
    [anon_sym_DASH] = ACTIONS(2934),
    [anon_sym_PLUS_DOT] = ACTIONS(2934),
    [anon_sym_DASH_DOT] = ACTIONS(2934),
    [anon_sym_PERCENT] = ACTIONS(2934),
    [anon_sym_AMP_AMP] = ACTIONS(2934),
    [anon_sym_TILDE] = ACTIONS(2936),
    [aux_sym_prefix_op_token1] = ACTIONS(2934),
    [aux_sym_infix_op_token1] = ACTIONS(2936),
    [aux_sym_infix_op_token2] = ACTIONS(2934),
    [anon_sym_PIPE_PIPE] = ACTIONS(2934),
    [anon_sym_BANG_EQ] = ACTIONS(2934),
    [anon_sym_COLON_EQ] = ACTIONS(2936),
    [anon_sym_DOLLAR] = ACTIONS(2934),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2934),
    [sym_int] = ACTIONS(2934),
    [sym_xint] = ACTIONS(2936),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2936),
    [sym__newline] = ACTIONS(2936),
  },
  [2468] = {
    [sym_block_comment] = STATE(2468),
    [sym_compiler_directive_decl] = STATE(2468),
    [sym_fsi_directive_decl] = STATE(2468),
    [sym_preproc_line] = STATE(2468),
    [sym_identifier] = ACTIONS(2843),
    [anon_sym_EQ] = ACTIONS(2845),
    [anon_sym_COLON] = ACTIONS(2843),
    [anon_sym_return] = ACTIONS(2843),
    [anon_sym_do] = ACTIONS(2843),
    [anon_sym_let] = ACTIONS(2843),
    [anon_sym_let_BANG] = ACTIONS(2845),
    [anon_sym_LPAREN] = ACTIONS(2843),
    [anon_sym_COMMA] = ACTIONS(2845),
    [anon_sym_null] = ACTIONS(2843),
    [anon_sym_QMARK] = ACTIONS(2843),
    [anon_sym_COLON_QMARK] = ACTIONS(2843),
    [anon_sym_COLON_COLON] = ACTIONS(2845),
    [anon_sym_AMP] = ACTIONS(2843),
    [anon_sym_LBRACK] = ACTIONS(2843),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2845),
    [anon_sym_LBRACE] = ACTIONS(2843),
    [anon_sym_LT_AT] = ACTIONS(2843),
    [anon_sym_AT_GT] = ACTIONS(2843),
    [anon_sym_LT_AT_AT] = ACTIONS(2843),
    [anon_sym_DOT] = ACTIONS(2843),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2845),
    [anon_sym_new] = ACTIONS(2843),
    [anon_sym_return_BANG] = ACTIONS(2845),
    [anon_sym_yield] = ACTIONS(2843),
    [anon_sym_yield_BANG] = ACTIONS(2845),
    [anon_sym_lazy] = ACTIONS(2843),
    [anon_sym_assert] = ACTIONS(2843),
    [anon_sym_upcast] = ACTIONS(2843),
    [anon_sym_downcast] = ACTIONS(2843),
    [anon_sym_COLON_GT] = ACTIONS(2845),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2845),
    [anon_sym_for] = ACTIONS(2843),
    [anon_sym_while] = ACTIONS(2843),
    [anon_sym_if] = ACTIONS(2843),
    [anon_sym_fun] = ACTIONS(2843),
    [anon_sym_try] = ACTIONS(2843),
    [anon_sym_match] = ACTIONS(2843),
    [anon_sym_match_BANG] = ACTIONS(2845),
    [anon_sym_function] = ACTIONS(2843),
    [anon_sym_LT_DASH] = ACTIONS(2843),
    [anon_sym_DOT_LBRACK] = ACTIONS(2845),
    [anon_sym_LT] = ACTIONS(2845),
    [anon_sym_use] = ACTIONS(2843),
    [anon_sym_use_BANG] = ACTIONS(2845),
    [anon_sym_do_BANG] = ACTIONS(2845),
    [anon_sym_begin] = ACTIONS(2843),
    [anon_sym_LPAREN2] = ACTIONS(2843),
    [anon_sym_or] = ACTIONS(2843),
    [aux_sym_char_token1] = ACTIONS(2845),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2843),
    [anon_sym_DQUOTE] = ACTIONS(2843),
    [anon_sym_AT_DQUOTE] = ACTIONS(2845),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2845),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2845),
    [sym_bool] = ACTIONS(2843),
    [sym_unit] = ACTIONS(2845),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2843),
    [sym_op_identifier] = ACTIONS(2843),
    [anon_sym_PLUS] = ACTIONS(2843),
    [anon_sym_DASH] = ACTIONS(2843),
    [anon_sym_PLUS_DOT] = ACTIONS(2843),
    [anon_sym_DASH_DOT] = ACTIONS(2843),
    [anon_sym_PERCENT] = ACTIONS(2843),
    [anon_sym_AMP_AMP] = ACTIONS(2843),
    [anon_sym_TILDE] = ACTIONS(2845),
    [aux_sym_prefix_op_token1] = ACTIONS(2843),
    [aux_sym_infix_op_token1] = ACTIONS(2845),
    [aux_sym_infix_op_token2] = ACTIONS(2843),
    [anon_sym_PIPE_PIPE] = ACTIONS(2843),
    [anon_sym_BANG_EQ] = ACTIONS(2843),
    [anon_sym_COLON_EQ] = ACTIONS(2845),
    [anon_sym_DOLLAR] = ACTIONS(2843),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2843),
    [sym_int] = ACTIONS(2843),
    [sym_xint] = ACTIONS(2845),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2845),
    [sym__newline] = ACTIONS(2845),
  },
  [2469] = {
    [sym_block_comment] = STATE(2469),
    [sym_compiler_directive_decl] = STATE(2469),
    [sym_fsi_directive_decl] = STATE(2469),
    [sym_preproc_line] = STATE(2469),
    [sym_identifier] = ACTIONS(2158),
    [anon_sym_EQ] = ACTIONS(2160),
    [anon_sym_COLON] = ACTIONS(2158),
    [anon_sym_return] = ACTIONS(2158),
    [anon_sym_do] = ACTIONS(2158),
    [anon_sym_let] = ACTIONS(2158),
    [anon_sym_let_BANG] = ACTIONS(2160),
    [anon_sym_LPAREN] = ACTIONS(2158),
    [anon_sym_COMMA] = ACTIONS(2160),
    [anon_sym_null] = ACTIONS(2158),
    [anon_sym_QMARK] = ACTIONS(2158),
    [anon_sym_COLON_QMARK] = ACTIONS(2158),
    [anon_sym_COLON_COLON] = ACTIONS(2160),
    [anon_sym_AMP] = ACTIONS(2158),
    [anon_sym_LBRACK] = ACTIONS(2158),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2160),
    [anon_sym_LBRACE] = ACTIONS(2158),
    [anon_sym_LT_AT] = ACTIONS(2158),
    [anon_sym_AT_GT] = ACTIONS(2158),
    [anon_sym_LT_AT_AT] = ACTIONS(2158),
    [anon_sym_DOT] = ACTIONS(2158),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2160),
    [anon_sym_new] = ACTIONS(2158),
    [anon_sym_return_BANG] = ACTIONS(2160),
    [anon_sym_yield] = ACTIONS(2158),
    [anon_sym_yield_BANG] = ACTIONS(2160),
    [anon_sym_lazy] = ACTIONS(2158),
    [anon_sym_assert] = ACTIONS(2158),
    [anon_sym_upcast] = ACTIONS(2158),
    [anon_sym_downcast] = ACTIONS(2158),
    [anon_sym_COLON_GT] = ACTIONS(2160),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2160),
    [anon_sym_for] = ACTIONS(2158),
    [anon_sym_while] = ACTIONS(2158),
    [anon_sym_if] = ACTIONS(2158),
    [anon_sym_fun] = ACTIONS(2158),
    [anon_sym_try] = ACTIONS(2158),
    [anon_sym_match] = ACTIONS(2158),
    [anon_sym_match_BANG] = ACTIONS(2160),
    [anon_sym_function] = ACTIONS(2158),
    [anon_sym_LT_DASH] = ACTIONS(2158),
    [anon_sym_DOT_LBRACK] = ACTIONS(2160),
    [anon_sym_LT] = ACTIONS(2160),
    [anon_sym_use] = ACTIONS(2158),
    [anon_sym_use_BANG] = ACTIONS(2160),
    [anon_sym_do_BANG] = ACTIONS(2160),
    [anon_sym_begin] = ACTIONS(2158),
    [anon_sym_LPAREN2] = ACTIONS(2158),
    [anon_sym_or] = ACTIONS(2158),
    [aux_sym_char_token1] = ACTIONS(2160),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2158),
    [anon_sym_DQUOTE] = ACTIONS(2158),
    [anon_sym_AT_DQUOTE] = ACTIONS(2160),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2160),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2160),
    [sym_bool] = ACTIONS(2158),
    [sym_unit] = ACTIONS(2160),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2158),
    [sym_op_identifier] = ACTIONS(2158),
    [anon_sym_PLUS] = ACTIONS(2158),
    [anon_sym_DASH] = ACTIONS(2158),
    [anon_sym_PLUS_DOT] = ACTIONS(2158),
    [anon_sym_DASH_DOT] = ACTIONS(2158),
    [anon_sym_PERCENT] = ACTIONS(2158),
    [anon_sym_AMP_AMP] = ACTIONS(2158),
    [anon_sym_TILDE] = ACTIONS(2160),
    [aux_sym_prefix_op_token1] = ACTIONS(2158),
    [aux_sym_infix_op_token1] = ACTIONS(2160),
    [aux_sym_infix_op_token2] = ACTIONS(2158),
    [anon_sym_PIPE_PIPE] = ACTIONS(2158),
    [anon_sym_BANG_EQ] = ACTIONS(2158),
    [anon_sym_COLON_EQ] = ACTIONS(2160),
    [anon_sym_DOLLAR] = ACTIONS(2158),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2158),
    [sym_int] = ACTIONS(2158),
    [sym_xint] = ACTIONS(2160),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2160),
    [sym__newline] = ACTIONS(2160),
  },
  [2470] = {
    [sym_block_comment] = STATE(2470),
    [sym_compiler_directive_decl] = STATE(2470),
    [sym_fsi_directive_decl] = STATE(2470),
    [sym_preproc_line] = STATE(2470),
    [sym_identifier] = ACTIONS(2863),
    [anon_sym_EQ] = ACTIONS(2865),
    [anon_sym_COLON] = ACTIONS(2863),
    [anon_sym_return] = ACTIONS(2863),
    [anon_sym_do] = ACTIONS(2863),
    [anon_sym_let] = ACTIONS(2863),
    [anon_sym_let_BANG] = ACTIONS(2865),
    [anon_sym_LPAREN] = ACTIONS(2863),
    [anon_sym_COMMA] = ACTIONS(2865),
    [anon_sym_null] = ACTIONS(2863),
    [anon_sym_QMARK] = ACTIONS(2863),
    [anon_sym_COLON_QMARK] = ACTIONS(2863),
    [anon_sym_COLON_COLON] = ACTIONS(2865),
    [anon_sym_AMP] = ACTIONS(2863),
    [anon_sym_LBRACK] = ACTIONS(2863),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2865),
    [anon_sym_LBRACE] = ACTIONS(2863),
    [anon_sym_LT_AT] = ACTIONS(2863),
    [anon_sym_LT_AT_AT] = ACTIONS(2863),
    [anon_sym_AT_AT_GT] = ACTIONS(2863),
    [anon_sym_DOT] = ACTIONS(2863),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2865),
    [anon_sym_new] = ACTIONS(2863),
    [anon_sym_return_BANG] = ACTIONS(2865),
    [anon_sym_yield] = ACTIONS(2863),
    [anon_sym_yield_BANG] = ACTIONS(2865),
    [anon_sym_lazy] = ACTIONS(2863),
    [anon_sym_assert] = ACTIONS(2863),
    [anon_sym_upcast] = ACTIONS(2863),
    [anon_sym_downcast] = ACTIONS(2863),
    [anon_sym_COLON_GT] = ACTIONS(2865),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2865),
    [anon_sym_for] = ACTIONS(2863),
    [anon_sym_while] = ACTIONS(2863),
    [anon_sym_if] = ACTIONS(2863),
    [anon_sym_fun] = ACTIONS(2863),
    [anon_sym_try] = ACTIONS(2863),
    [anon_sym_match] = ACTIONS(2863),
    [anon_sym_match_BANG] = ACTIONS(2865),
    [anon_sym_function] = ACTIONS(2863),
    [anon_sym_LT_DASH] = ACTIONS(2863),
    [anon_sym_DOT_LBRACK] = ACTIONS(2865),
    [anon_sym_LT] = ACTIONS(2865),
    [anon_sym_use] = ACTIONS(2863),
    [anon_sym_use_BANG] = ACTIONS(2865),
    [anon_sym_do_BANG] = ACTIONS(2865),
    [anon_sym_begin] = ACTIONS(2863),
    [anon_sym_LPAREN2] = ACTIONS(2863),
    [anon_sym_or] = ACTIONS(2863),
    [aux_sym_char_token1] = ACTIONS(2865),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2863),
    [anon_sym_DQUOTE] = ACTIONS(2863),
    [anon_sym_AT_DQUOTE] = ACTIONS(2865),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2865),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2865),
    [sym_bool] = ACTIONS(2863),
    [sym_unit] = ACTIONS(2865),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2863),
    [sym_op_identifier] = ACTIONS(2863),
    [anon_sym_PLUS] = ACTIONS(2863),
    [anon_sym_DASH] = ACTIONS(2863),
    [anon_sym_PLUS_DOT] = ACTIONS(2863),
    [anon_sym_DASH_DOT] = ACTIONS(2863),
    [anon_sym_PERCENT] = ACTIONS(2863),
    [anon_sym_AMP_AMP] = ACTIONS(2863),
    [anon_sym_TILDE] = ACTIONS(2865),
    [aux_sym_prefix_op_token1] = ACTIONS(2863),
    [aux_sym_infix_op_token1] = ACTIONS(2865),
    [aux_sym_infix_op_token2] = ACTIONS(2863),
    [anon_sym_PIPE_PIPE] = ACTIONS(2863),
    [anon_sym_BANG_EQ] = ACTIONS(2863),
    [anon_sym_COLON_EQ] = ACTIONS(2865),
    [anon_sym_DOLLAR] = ACTIONS(2863),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2863),
    [sym_int] = ACTIONS(2863),
    [sym_xint] = ACTIONS(2865),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2865),
    [sym__newline] = ACTIONS(2865),
  },
  [2471] = {
    [sym_block_comment] = STATE(2471),
    [sym_compiler_directive_decl] = STATE(2471),
    [sym_fsi_directive_decl] = STATE(2471),
    [sym_preproc_line] = STATE(2471),
    [sym_identifier] = ACTIONS(2978),
    [anon_sym_EQ] = ACTIONS(2980),
    [anon_sym_COLON] = ACTIONS(2978),
    [anon_sym_return] = ACTIONS(2978),
    [anon_sym_do] = ACTIONS(2978),
    [anon_sym_let] = ACTIONS(2978),
    [anon_sym_let_BANG] = ACTIONS(2980),
    [anon_sym_LPAREN] = ACTIONS(2978),
    [anon_sym_COMMA] = ACTIONS(2980),
    [anon_sym_null] = ACTIONS(2978),
    [anon_sym_QMARK] = ACTIONS(2978),
    [anon_sym_COLON_QMARK] = ACTIONS(2978),
    [anon_sym_COLON_COLON] = ACTIONS(2980),
    [anon_sym_AMP] = ACTIONS(2978),
    [anon_sym_LBRACK] = ACTIONS(2978),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2980),
    [anon_sym_LBRACE] = ACTIONS(2978),
    [anon_sym_LT_AT] = ACTIONS(2978),
    [anon_sym_LT_AT_AT] = ACTIONS(2978),
    [anon_sym_DOT] = ACTIONS(2978),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2980),
    [anon_sym_new] = ACTIONS(2978),
    [anon_sym_return_BANG] = ACTIONS(2980),
    [anon_sym_yield] = ACTIONS(2978),
    [anon_sym_yield_BANG] = ACTIONS(2980),
    [anon_sym_lazy] = ACTIONS(2978),
    [anon_sym_assert] = ACTIONS(2978),
    [anon_sym_upcast] = ACTIONS(2978),
    [anon_sym_downcast] = ACTIONS(2978),
    [anon_sym_COLON_GT] = ACTIONS(2980),
    [anon_sym_COLON_QMARK_GT] = ACTIONS(2980),
    [anon_sym_for] = ACTIONS(2978),
    [anon_sym_while] = ACTIONS(2978),
    [anon_sym_if] = ACTIONS(2978),
    [anon_sym_fun] = ACTIONS(2978),
    [anon_sym_try] = ACTIONS(2978),
    [anon_sym_match] = ACTIONS(2978),
    [anon_sym_match_BANG] = ACTIONS(2980),
    [anon_sym_function] = ACTIONS(2978),
    [anon_sym_LT_DASH] = ACTIONS(2978),
    [anon_sym_DOT_LBRACK] = ACTIONS(2980),
    [anon_sym_LT] = ACTIONS(2980),
    [anon_sym_use] = ACTIONS(2978),
    [anon_sym_use_BANG] = ACTIONS(2980),
    [anon_sym_do_BANG] = ACTIONS(2980),
    [anon_sym_begin] = ACTIONS(2978),
    [anon_sym_LPAREN2] = ACTIONS(2978),
    [anon_sym_or] = ACTIONS(2978),
    [aux_sym_char_token1] = ACTIONS(2980),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2978),
    [anon_sym_DQUOTE] = ACTIONS(2978),
    [anon_sym_AT_DQUOTE] = ACTIONS(2980),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2980),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2980),
    [sym_bool] = ACTIONS(2978),
    [sym_unit] = ACTIONS(2980),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2978),
    [sym_op_identifier] = ACTIONS(2978),
    [anon_sym_PLUS] = ACTIONS(2978),
    [anon_sym_DASH] = ACTIONS(2978),
    [anon_sym_PLUS_DOT] = ACTIONS(2978),
    [anon_sym_DASH_DOT] = ACTIONS(2978),
    [anon_sym_PERCENT] = ACTIONS(2978),
    [anon_sym_AMP_AMP] = ACTIONS(2978),
    [anon_sym_TILDE] = ACTIONS(2980),
    [aux_sym_prefix_op_token1] = ACTIONS(2978),
    [aux_sym_infix_op_token1] = ACTIONS(2980),
    [aux_sym_infix_op_token2] = ACTIONS(2978),
    [anon_sym_PIPE_PIPE] = ACTIONS(2978),
    [anon_sym_BANG_EQ] = ACTIONS(2978),
    [anon_sym_COLON_EQ] = ACTIONS(2980),
    [anon_sym_DOLLAR] = ACTIONS(2978),
    [anon_sym_QMARK_LT_DASH] = ACTIONS(2978),
    [sym_int] = ACTIONS(2978),
    [sym_xint] = ACTIONS(2980),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(133),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2980),
    [anon_sym_POUNDendif] = ACTIONS(2980),
    [sym__newline] = ACTIONS(2980),
  },
  [2472] = {
    [sym_attributes] = STATE(2689),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(3731),
    [sym__pattern] = STATE(2129),
    [sym_optional_pattern] = STATE(3731),
    [sym_type_check_pattern] = STATE(3731),
    [sym_attribute_pattern] = STATE(3731),
    [sym_paren_pattern] = STATE(3731),
    [sym_as_pattern] = STATE(3731),
    [sym_cons_pattern] = STATE(3731),
    [sym_disjunct_pattern] = STATE(3731),
    [sym_conjunct_pattern] = STATE(3731),
    [sym_typed_pattern] = STATE(3731),
    [sym_list_pattern] = STATE(3731),
    [sym_array_pattern] = STATE(3731),
    [sym_record_pattern] = STATE(3731),
    [sym_named_field_pattern] = STATE(3731),
    [sym_identifier_pattern] = STATE(3731),
    [sym_long_identifier_or_op] = STATE(2472),
    [sym_char] = STATE(3709),
    [sym_format_string] = STATE(3712),
    [sym__string_literal] = STATE(3712),
    [sym_string] = STATE(3709),
    [sym_verbatim_string] = STATE(3709),
    [sym_bytearray] = STATE(3709),
    [sym_verbatim_bytearray] = STATE(3709),
    [sym_format_triple_quoted_string] = STATE(3716),
    [sym_triple_quoted_string] = STATE(3709),
    [sym_const] = STATE(3731),
    [sym_long_identifier] = STATE(3655),
    [sym_active_pattern] = STATE(3734),
    [sym__identifier_or_op] = STATE(3737),
    [sym_sbyte] = STATE(3709),
    [sym_byte] = STATE(3709),
    [sym_int16] = STATE(3709),
    [sym_uint16] = STATE(3709),
    [sym_int32] = STATE(3709),
    [sym_uint32] = STATE(3709),
    [sym_nativeint] = STATE(3709),
    [sym_unativeint] = STATE(3709),
    [sym_int64] = STATE(3709),
    [sym_uint64] = STATE(3709),
    [sym_ieee32] = STATE(3709),
    [sym_ieee64] = STATE(3709),
    [sym_bignum] = STATE(3709),
    [sym_decimal] = STATE(3709),
    [sym_float] = STATE(3489),
    [sym_block_comment] = STATE(2472),
    [sym_compiler_directive_decl] = STATE(2472),
    [sym_fsi_directive_decl] = STATE(2472),
    [sym_preproc_line] = STATE(2472),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(3960),
    [anon_sym_LBRACK_LT] = ACTIONS(3964),
    [anon_sym_COLON] = ACTIONS(3960),
    [anon_sym_as] = ACTIONS(3960),
    [anon_sym_LPAREN] = ACTIONS(3960),
    [anon_sym_COMMA] = ACTIONS(3964),
    [anon_sym_null] = ACTIONS(3960),
    [anon_sym__] = ACTIONS(3960),
    [anon_sym_QMARK] = ACTIONS(3964),
    [anon_sym_COLON_QMARK] = ACTIONS(3964),
    [anon_sym_COLON_COLON] = ACTIONS(3964),
    [anon_sym_PIPE] = ACTIONS(3964),
    [anon_sym_AMP] = ACTIONS(3964),
    [anon_sym_LBRACK] = ACTIONS(3960),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3964),
    [anon_sym_LBRACE] = ACTIONS(3964),
    [anon_sym_in] = ACTIONS(3960),
    [aux_sym_char_token1] = ACTIONS(3964),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3960),
    [anon_sym_DQUOTE] = ACTIONS(3960),
    [anon_sym_AT_DQUOTE] = ACTIONS(3964),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3964),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3964),
    [sym_bool] = ACTIONS(3960),
    [sym_unit] = ACTIONS(3964),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3960),
    [sym_op_identifier] = ACTIONS(3964),
    [sym_int] = ACTIONS(3960),
    [sym_xint] = ACTIONS(3964),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2473] = {
    [sym_attributes] = STATE(2676),
    [sym__attribute_set] = STATE(4045),
    [sym__function_or_value_defn_body] = STATE(2830),
    [sym_function_declaration_left] = STATE(6066),
    [sym_value_declaration_left] = STATE(6066),
    [sym_access_modifier] = STATE(2693),
    [sym_repeat_pattern] = STATE(4815),
    [sym__pattern] = STATE(5168),
    [sym_optional_pattern] = STATE(4815),
    [sym_type_check_pattern] = STATE(4815),
    [sym_attribute_pattern] = STATE(4815),
    [sym_paren_pattern] = STATE(4815),
    [sym_as_pattern] = STATE(4815),
    [sym_cons_pattern] = STATE(4815),
    [sym_disjunct_pattern] = STATE(4815),
    [sym_conjunct_pattern] = STATE(4815),
    [sym_typed_pattern] = STATE(4815),
    [sym_list_pattern] = STATE(4815),
    [sym_array_pattern] = STATE(4815),
    [sym_record_pattern] = STATE(4815),
    [sym_named_field_pattern] = STATE(4815),
    [sym_identifier_pattern] = STATE(4815),
    [sym_long_identifier_or_op] = STATE(1792),
    [sym_char] = STATE(4765),
    [sym_format_string] = STATE(4746),
    [sym__string_literal] = STATE(4746),
    [sym_string] = STATE(4765),
    [sym_verbatim_string] = STATE(4765),
    [sym_bytearray] = STATE(4765),
    [sym_verbatim_bytearray] = STATE(4765),
    [sym_format_triple_quoted_string] = STATE(4720),
    [sym_triple_quoted_string] = STATE(4765),
    [sym_const] = STATE(4815),
    [sym_long_identifier] = STATE(3320),
    [sym_active_pattern] = STATE(3488),
    [sym__identifier_or_op] = STATE(2746),
    [sym_sbyte] = STATE(4765),
    [sym_byte] = STATE(4765),
    [sym_int16] = STATE(4765),
    [sym_uint16] = STATE(4765),
    [sym_int32] = STATE(4765),
    [sym_uint32] = STATE(4765),
    [sym_nativeint] = STATE(4765),
    [sym_unativeint] = STATE(4765),
    [sym_int64] = STATE(4765),
    [sym_uint64] = STATE(4765),
    [sym_ieee32] = STATE(4765),
    [sym_ieee64] = STATE(4765),
    [sym_bignum] = STATE(4765),
    [sym_decimal] = STATE(4765),
    [sym_float] = STATE(4512),
    [sym_block_comment] = STATE(2473),
    [sym_compiler_directive_decl] = STATE(2473),
    [sym_fsi_directive_decl] = STATE(2473),
    [sym_preproc_line] = STATE(2473),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(3562),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_inline] = ACTIONS(3566),
    [anon_sym_mutable] = ACTIONS(3568),
    [aux_sym_access_modifier_token1] = ACTIONS(3570),
    [anon_sym_LPAREN] = ACTIONS(3572),
    [anon_sym_null] = ACTIONS(3574),
    [anon_sym__] = ACTIONS(3576),
    [anon_sym_QMARK] = ACTIONS(3578),
    [anon_sym_COLON_QMARK] = ACTIONS(3580),
    [anon_sym_LBRACK] = ACTIONS(3582),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3584),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [aux_sym_char_token1] = ACTIONS(3590),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3592),
    [anon_sym_DQUOTE] = ACTIONS(3594),
    [anon_sym_AT_DQUOTE] = ACTIONS(3596),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3598),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3600),
    [sym_bool] = ACTIONS(3602),
    [sym_unit] = ACTIONS(3604),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3606),
    [sym_op_identifier] = ACTIONS(3608),
    [sym_int] = ACTIONS(3610),
    [sym_xint] = ACTIONS(3612),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2474] = {
    [sym_attributes] = STATE(2676),
    [sym__attribute_set] = STATE(4045),
    [sym__function_or_value_defn_body] = STATE(4721),
    [sym_function_declaration_left] = STATE(6321),
    [sym_value_declaration_left] = STATE(6321),
    [sym_access_modifier] = STATE(2693),
    [sym_repeat_pattern] = STATE(4815),
    [sym__pattern] = STATE(5168),
    [sym_optional_pattern] = STATE(4815),
    [sym_type_check_pattern] = STATE(4815),
    [sym_attribute_pattern] = STATE(4815),
    [sym_paren_pattern] = STATE(4815),
    [sym_as_pattern] = STATE(4815),
    [sym_cons_pattern] = STATE(4815),
    [sym_disjunct_pattern] = STATE(4815),
    [sym_conjunct_pattern] = STATE(4815),
    [sym_typed_pattern] = STATE(4815),
    [sym_list_pattern] = STATE(4815),
    [sym_array_pattern] = STATE(4815),
    [sym_record_pattern] = STATE(4815),
    [sym_named_field_pattern] = STATE(4815),
    [sym_identifier_pattern] = STATE(4815),
    [sym_long_identifier_or_op] = STATE(1792),
    [sym_char] = STATE(4765),
    [sym_format_string] = STATE(4746),
    [sym__string_literal] = STATE(4746),
    [sym_string] = STATE(4765),
    [sym_verbatim_string] = STATE(4765),
    [sym_bytearray] = STATE(4765),
    [sym_verbatim_bytearray] = STATE(4765),
    [sym_format_triple_quoted_string] = STATE(4720),
    [sym_triple_quoted_string] = STATE(4765),
    [sym_const] = STATE(4815),
    [sym_long_identifier] = STATE(3320),
    [sym_active_pattern] = STATE(3488),
    [sym__identifier_or_op] = STATE(2746),
    [sym_sbyte] = STATE(4765),
    [sym_byte] = STATE(4765),
    [sym_int16] = STATE(4765),
    [sym_uint16] = STATE(4765),
    [sym_int32] = STATE(4765),
    [sym_uint32] = STATE(4765),
    [sym_nativeint] = STATE(4765),
    [sym_unativeint] = STATE(4765),
    [sym_int64] = STATE(4765),
    [sym_uint64] = STATE(4765),
    [sym_ieee32] = STATE(4765),
    [sym_ieee64] = STATE(4765),
    [sym_bignum] = STATE(4765),
    [sym_decimal] = STATE(4765),
    [sym_float] = STATE(4512),
    [sym_block_comment] = STATE(2474),
    [sym_compiler_directive_decl] = STATE(2474),
    [sym_fsi_directive_decl] = STATE(2474),
    [sym_preproc_line] = STATE(2474),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(3562),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_inline] = ACTIONS(3566),
    [anon_sym_mutable] = ACTIONS(3568),
    [aux_sym_access_modifier_token1] = ACTIONS(3570),
    [anon_sym_LPAREN] = ACTIONS(3572),
    [anon_sym_null] = ACTIONS(3574),
    [anon_sym__] = ACTIONS(3576),
    [anon_sym_QMARK] = ACTIONS(3578),
    [anon_sym_COLON_QMARK] = ACTIONS(3580),
    [anon_sym_LBRACK] = ACTIONS(3582),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3584),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [aux_sym_char_token1] = ACTIONS(3590),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3592),
    [anon_sym_DQUOTE] = ACTIONS(3594),
    [anon_sym_AT_DQUOTE] = ACTIONS(3596),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3598),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3600),
    [sym_bool] = ACTIONS(3602),
    [sym_unit] = ACTIONS(3604),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3606),
    [sym_op_identifier] = ACTIONS(3608),
    [sym_int] = ACTIONS(3610),
    [sym_xint] = ACTIONS(3612),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2475] = {
    [sym_attributes] = STATE(2689),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(3731),
    [sym__pattern] = STATE(2105),
    [sym_optional_pattern] = STATE(3731),
    [sym_type_check_pattern] = STATE(3731),
    [sym_attribute_pattern] = STATE(3731),
    [sym_paren_pattern] = STATE(3731),
    [sym_as_pattern] = STATE(3731),
    [sym_cons_pattern] = STATE(3731),
    [sym_disjunct_pattern] = STATE(3731),
    [sym_conjunct_pattern] = STATE(3731),
    [sym_typed_pattern] = STATE(3731),
    [sym_list_pattern] = STATE(3731),
    [sym_array_pattern] = STATE(3731),
    [sym_record_pattern] = STATE(3731),
    [sym_named_field_pattern] = STATE(3731),
    [sym_identifier_pattern] = STATE(3731),
    [sym_long_identifier_or_op] = STATE(2472),
    [sym_char] = STATE(3709),
    [sym_format_string] = STATE(3712),
    [sym__string_literal] = STATE(3712),
    [sym_string] = STATE(3709),
    [sym_verbatim_string] = STATE(3709),
    [sym_bytearray] = STATE(3709),
    [sym_verbatim_bytearray] = STATE(3709),
    [sym_format_triple_quoted_string] = STATE(3716),
    [sym_triple_quoted_string] = STATE(3709),
    [sym_const] = STATE(3731),
    [sym_long_identifier] = STATE(3655),
    [sym_active_pattern] = STATE(3734),
    [sym__identifier_or_op] = STATE(3737),
    [sym_sbyte] = STATE(3709),
    [sym_byte] = STATE(3709),
    [sym_int16] = STATE(3709),
    [sym_uint16] = STATE(3709),
    [sym_int32] = STATE(3709),
    [sym_uint32] = STATE(3709),
    [sym_nativeint] = STATE(3709),
    [sym_unativeint] = STATE(3709),
    [sym_int64] = STATE(3709),
    [sym_uint64] = STATE(3709),
    [sym_ieee32] = STATE(3709),
    [sym_ieee64] = STATE(3709),
    [sym_bignum] = STATE(3709),
    [sym_decimal] = STATE(3709),
    [sym_float] = STATE(3489),
    [sym_block_comment] = STATE(2475),
    [sym_compiler_directive_decl] = STATE(2475),
    [sym_fsi_directive_decl] = STATE(2475),
    [sym_preproc_line] = STATE(2475),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(4196),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_COLON] = ACTIONS(3960),
    [anon_sym_as] = ACTIONS(3960),
    [anon_sym_LPAREN] = ACTIONS(4308),
    [anon_sym_COMMA] = ACTIONS(3964),
    [anon_sym_null] = ACTIONS(4310),
    [anon_sym__] = ACTIONS(4312),
    [anon_sym_QMARK] = ACTIONS(4314),
    [anon_sym_COLON_QMARK] = ACTIONS(4316),
    [anon_sym_COLON_COLON] = ACTIONS(3964),
    [anon_sym_PIPE] = ACTIONS(3964),
    [anon_sym_AMP] = ACTIONS(3964),
    [anon_sym_LBRACK] = ACTIONS(4318),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4320),
    [anon_sym_LBRACE] = ACTIONS(4322),
    [anon_sym_in] = ACTIONS(3960),
    [aux_sym_char_token1] = ACTIONS(4324),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4326),
    [anon_sym_DQUOTE] = ACTIONS(4328),
    [anon_sym_AT_DQUOTE] = ACTIONS(4330),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4332),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4334),
    [sym_bool] = ACTIONS(4336),
    [sym_unit] = ACTIONS(4338),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4212),
    [sym_op_identifier] = ACTIONS(4214),
    [sym_int] = ACTIONS(4340),
    [sym_xint] = ACTIONS(4342),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2476] = {
    [sym_attributes] = STATE(2676),
    [sym__attribute_set] = STATE(4045),
    [sym__function_or_value_defn_body] = STATE(6392),
    [sym_function_declaration_left] = STATE(6285),
    [sym_value_declaration_left] = STATE(6285),
    [sym_access_modifier] = STATE(2693),
    [sym_repeat_pattern] = STATE(4815),
    [sym__pattern] = STATE(5168),
    [sym_optional_pattern] = STATE(4815),
    [sym_type_check_pattern] = STATE(4815),
    [sym_attribute_pattern] = STATE(4815),
    [sym_paren_pattern] = STATE(4815),
    [sym_as_pattern] = STATE(4815),
    [sym_cons_pattern] = STATE(4815),
    [sym_disjunct_pattern] = STATE(4815),
    [sym_conjunct_pattern] = STATE(4815),
    [sym_typed_pattern] = STATE(4815),
    [sym_list_pattern] = STATE(4815),
    [sym_array_pattern] = STATE(4815),
    [sym_record_pattern] = STATE(4815),
    [sym_named_field_pattern] = STATE(4815),
    [sym_identifier_pattern] = STATE(4815),
    [sym_long_identifier_or_op] = STATE(1792),
    [sym_char] = STATE(4765),
    [sym_format_string] = STATE(4746),
    [sym__string_literal] = STATE(4746),
    [sym_string] = STATE(4765),
    [sym_verbatim_string] = STATE(4765),
    [sym_bytearray] = STATE(4765),
    [sym_verbatim_bytearray] = STATE(4765),
    [sym_format_triple_quoted_string] = STATE(4720),
    [sym_triple_quoted_string] = STATE(4765),
    [sym_const] = STATE(4815),
    [sym_long_identifier] = STATE(3320),
    [sym_active_pattern] = STATE(3488),
    [sym__identifier_or_op] = STATE(2746),
    [sym_sbyte] = STATE(4765),
    [sym_byte] = STATE(4765),
    [sym_int16] = STATE(4765),
    [sym_uint16] = STATE(4765),
    [sym_int32] = STATE(4765),
    [sym_uint32] = STATE(4765),
    [sym_nativeint] = STATE(4765),
    [sym_unativeint] = STATE(4765),
    [sym_int64] = STATE(4765),
    [sym_uint64] = STATE(4765),
    [sym_ieee32] = STATE(4765),
    [sym_ieee64] = STATE(4765),
    [sym_bignum] = STATE(4765),
    [sym_decimal] = STATE(4765),
    [sym_float] = STATE(4512),
    [sym_block_comment] = STATE(2476),
    [sym_compiler_directive_decl] = STATE(2476),
    [sym_fsi_directive_decl] = STATE(2476),
    [sym_preproc_line] = STATE(2476),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(3562),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_inline] = ACTIONS(3566),
    [anon_sym_mutable] = ACTIONS(3568),
    [aux_sym_access_modifier_token1] = ACTIONS(3570),
    [anon_sym_LPAREN] = ACTIONS(3572),
    [anon_sym_null] = ACTIONS(3574),
    [anon_sym__] = ACTIONS(3576),
    [anon_sym_QMARK] = ACTIONS(3578),
    [anon_sym_COLON_QMARK] = ACTIONS(3580),
    [anon_sym_LBRACK] = ACTIONS(3582),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3584),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [aux_sym_char_token1] = ACTIONS(3590),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3592),
    [anon_sym_DQUOTE] = ACTIONS(3594),
    [anon_sym_AT_DQUOTE] = ACTIONS(3596),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3598),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3600),
    [sym_bool] = ACTIONS(3602),
    [sym_unit] = ACTIONS(3604),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3606),
    [sym_op_identifier] = ACTIONS(3608),
    [sym_int] = ACTIONS(3610),
    [sym_xint] = ACTIONS(3612),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2477] = {
    [sym_attributes] = STATE(2676),
    [sym__attribute_set] = STATE(4045),
    [sym_value_declaration_left] = STATE(7335),
    [sym_access_modifier] = STATE(2681),
    [sym_repeat_pattern] = STATE(4815),
    [sym__pattern] = STATE(5168),
    [sym_optional_pattern] = STATE(4815),
    [sym_type_check_pattern] = STATE(4815),
    [sym_attribute_pattern] = STATE(4815),
    [sym_paren_pattern] = STATE(4815),
    [sym_as_pattern] = STATE(4815),
    [sym_cons_pattern] = STATE(4815),
    [sym_disjunct_pattern] = STATE(4815),
    [sym_conjunct_pattern] = STATE(4815),
    [sym_typed_pattern] = STATE(4815),
    [sym_list_pattern] = STATE(4815),
    [sym_array_pattern] = STATE(4815),
    [sym_record_pattern] = STATE(4815),
    [sym_named_field_pattern] = STATE(4815),
    [sym_identifier_pattern] = STATE(4815),
    [sym_long_identifier_or_op] = STATE(1792),
    [sym_char] = STATE(4765),
    [sym_format_string] = STATE(4746),
    [sym__string_literal] = STATE(4746),
    [sym_string] = STATE(4765),
    [sym_verbatim_string] = STATE(4765),
    [sym_bytearray] = STATE(4765),
    [sym_verbatim_bytearray] = STATE(4765),
    [sym_format_triple_quoted_string] = STATE(4720),
    [sym_triple_quoted_string] = STATE(4765),
    [sym_const] = STATE(4815),
    [sym_long_identifier] = STATE(3320),
    [sym_active_pattern] = STATE(3488),
    [sym__identifier_or_op] = STATE(3410),
    [sym_sbyte] = STATE(4765),
    [sym_byte] = STATE(4765),
    [sym_int16] = STATE(4765),
    [sym_uint16] = STATE(4765),
    [sym_int32] = STATE(4765),
    [sym_uint32] = STATE(4765),
    [sym_nativeint] = STATE(4765),
    [sym_unativeint] = STATE(4765),
    [sym_int64] = STATE(4765),
    [sym_uint64] = STATE(4765),
    [sym_ieee32] = STATE(4765),
    [sym_ieee64] = STATE(4765),
    [sym_bignum] = STATE(4765),
    [sym_decimal] = STATE(4765),
    [sym_float] = STATE(4512),
    [sym_block_comment] = STATE(2477),
    [sym_compiler_directive_decl] = STATE(2477),
    [sym_fsi_directive_decl] = STATE(2477),
    [sym_preproc_line] = STATE(2477),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(3562),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_mutable] = ACTIONS(3568),
    [aux_sym_access_modifier_token1] = ACTIONS(3570),
    [anon_sym_LPAREN] = ACTIONS(3572),
    [anon_sym_null] = ACTIONS(3574),
    [anon_sym__] = ACTIONS(3576),
    [anon_sym_QMARK] = ACTIONS(3578),
    [anon_sym_COLON_QMARK] = ACTIONS(3580),
    [anon_sym_LBRACK] = ACTIONS(3582),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3584),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [aux_sym_char_token1] = ACTIONS(3590),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3592),
    [anon_sym_DQUOTE] = ACTIONS(3594),
    [anon_sym_AT_DQUOTE] = ACTIONS(3596),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3598),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3600),
    [sym_bool] = ACTIONS(3602),
    [sym_unit] = ACTIONS(3604),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3606),
    [sym_op_identifier] = ACTIONS(3608),
    [sym_int] = ACTIONS(3610),
    [sym_xint] = ACTIONS(3612),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2478] = {
    [sym_attributes] = STATE(2676),
    [sym__attribute_set] = STATE(4045),
    [sym_value_declaration_left] = STATE(7124),
    [sym_access_modifier] = STATE(2681),
    [sym_repeat_pattern] = STATE(4815),
    [sym__pattern] = STATE(5168),
    [sym_optional_pattern] = STATE(4815),
    [sym_type_check_pattern] = STATE(4815),
    [sym_attribute_pattern] = STATE(4815),
    [sym_paren_pattern] = STATE(4815),
    [sym_as_pattern] = STATE(4815),
    [sym_cons_pattern] = STATE(4815),
    [sym_disjunct_pattern] = STATE(4815),
    [sym_conjunct_pattern] = STATE(4815),
    [sym_typed_pattern] = STATE(4815),
    [sym_list_pattern] = STATE(4815),
    [sym_array_pattern] = STATE(4815),
    [sym_record_pattern] = STATE(4815),
    [sym_named_field_pattern] = STATE(4815),
    [sym_identifier_pattern] = STATE(4815),
    [sym_long_identifier_or_op] = STATE(1792),
    [sym_char] = STATE(4765),
    [sym_format_string] = STATE(4746),
    [sym__string_literal] = STATE(4746),
    [sym_string] = STATE(4765),
    [sym_verbatim_string] = STATE(4765),
    [sym_bytearray] = STATE(4765),
    [sym_verbatim_bytearray] = STATE(4765),
    [sym_format_triple_quoted_string] = STATE(4720),
    [sym_triple_quoted_string] = STATE(4765),
    [sym_const] = STATE(4815),
    [sym_long_identifier] = STATE(3320),
    [sym_active_pattern] = STATE(3488),
    [sym__identifier_or_op] = STATE(3410),
    [sym_sbyte] = STATE(4765),
    [sym_byte] = STATE(4765),
    [sym_int16] = STATE(4765),
    [sym_uint16] = STATE(4765),
    [sym_int32] = STATE(4765),
    [sym_uint32] = STATE(4765),
    [sym_nativeint] = STATE(4765),
    [sym_unativeint] = STATE(4765),
    [sym_int64] = STATE(4765),
    [sym_uint64] = STATE(4765),
    [sym_ieee32] = STATE(4765),
    [sym_ieee64] = STATE(4765),
    [sym_bignum] = STATE(4765),
    [sym_decimal] = STATE(4765),
    [sym_float] = STATE(4512),
    [sym_block_comment] = STATE(2478),
    [sym_compiler_directive_decl] = STATE(2478),
    [sym_fsi_directive_decl] = STATE(2478),
    [sym_preproc_line] = STATE(2478),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(3562),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_mutable] = ACTIONS(3568),
    [aux_sym_access_modifier_token1] = ACTIONS(3570),
    [anon_sym_LPAREN] = ACTIONS(3572),
    [anon_sym_null] = ACTIONS(3574),
    [anon_sym__] = ACTIONS(3576),
    [anon_sym_QMARK] = ACTIONS(3578),
    [anon_sym_COLON_QMARK] = ACTIONS(3580),
    [anon_sym_LBRACK] = ACTIONS(3582),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3584),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [aux_sym_char_token1] = ACTIONS(3590),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3592),
    [anon_sym_DQUOTE] = ACTIONS(3594),
    [anon_sym_AT_DQUOTE] = ACTIONS(3596),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3598),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3600),
    [sym_bool] = ACTIONS(3602),
    [sym_unit] = ACTIONS(3604),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3606),
    [sym_op_identifier] = ACTIONS(3608),
    [sym_int] = ACTIONS(3610),
    [sym_xint] = ACTIONS(3612),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2479] = {
    [sym_attributes] = STATE(2676),
    [sym__attribute_set] = STATE(4045),
    [sym_value_declaration_left] = STATE(6977),
    [sym_access_modifier] = STATE(2681),
    [sym_repeat_pattern] = STATE(4815),
    [sym__pattern] = STATE(5168),
    [sym_optional_pattern] = STATE(4815),
    [sym_type_check_pattern] = STATE(4815),
    [sym_attribute_pattern] = STATE(4815),
    [sym_paren_pattern] = STATE(4815),
    [sym_as_pattern] = STATE(4815),
    [sym_cons_pattern] = STATE(4815),
    [sym_disjunct_pattern] = STATE(4815),
    [sym_conjunct_pattern] = STATE(4815),
    [sym_typed_pattern] = STATE(4815),
    [sym_list_pattern] = STATE(4815),
    [sym_array_pattern] = STATE(4815),
    [sym_record_pattern] = STATE(4815),
    [sym_named_field_pattern] = STATE(4815),
    [sym_identifier_pattern] = STATE(4815),
    [sym_long_identifier_or_op] = STATE(1792),
    [sym_char] = STATE(4765),
    [sym_format_string] = STATE(4746),
    [sym__string_literal] = STATE(4746),
    [sym_string] = STATE(4765),
    [sym_verbatim_string] = STATE(4765),
    [sym_bytearray] = STATE(4765),
    [sym_verbatim_bytearray] = STATE(4765),
    [sym_format_triple_quoted_string] = STATE(4720),
    [sym_triple_quoted_string] = STATE(4765),
    [sym_const] = STATE(4815),
    [sym_long_identifier] = STATE(3320),
    [sym_active_pattern] = STATE(3488),
    [sym__identifier_or_op] = STATE(3410),
    [sym_sbyte] = STATE(4765),
    [sym_byte] = STATE(4765),
    [sym_int16] = STATE(4765),
    [sym_uint16] = STATE(4765),
    [sym_int32] = STATE(4765),
    [sym_uint32] = STATE(4765),
    [sym_nativeint] = STATE(4765),
    [sym_unativeint] = STATE(4765),
    [sym_int64] = STATE(4765),
    [sym_uint64] = STATE(4765),
    [sym_ieee32] = STATE(4765),
    [sym_ieee64] = STATE(4765),
    [sym_bignum] = STATE(4765),
    [sym_decimal] = STATE(4765),
    [sym_float] = STATE(4512),
    [sym_block_comment] = STATE(2479),
    [sym_compiler_directive_decl] = STATE(2479),
    [sym_fsi_directive_decl] = STATE(2479),
    [sym_preproc_line] = STATE(2479),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(3562),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_mutable] = ACTIONS(3568),
    [aux_sym_access_modifier_token1] = ACTIONS(3570),
    [anon_sym_LPAREN] = ACTIONS(3572),
    [anon_sym_null] = ACTIONS(3574),
    [anon_sym__] = ACTIONS(3576),
    [anon_sym_QMARK] = ACTIONS(3578),
    [anon_sym_COLON_QMARK] = ACTIONS(3580),
    [anon_sym_LBRACK] = ACTIONS(3582),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3584),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [aux_sym_char_token1] = ACTIONS(3590),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3592),
    [anon_sym_DQUOTE] = ACTIONS(3594),
    [anon_sym_AT_DQUOTE] = ACTIONS(3596),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3598),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3600),
    [sym_bool] = ACTIONS(3602),
    [sym_unit] = ACTIONS(3604),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3606),
    [sym_op_identifier] = ACTIONS(3608),
    [sym_int] = ACTIONS(3610),
    [sym_xint] = ACTIONS(3612),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2480] = {
    [sym_attributes] = STATE(2676),
    [sym__attribute_set] = STATE(4045),
    [sym_value_declaration_left] = STATE(6407),
    [sym_access_modifier] = STATE(2681),
    [sym_repeat_pattern] = STATE(4815),
    [sym__pattern] = STATE(5168),
    [sym_optional_pattern] = STATE(4815),
    [sym_type_check_pattern] = STATE(4815),
    [sym_attribute_pattern] = STATE(4815),
    [sym_paren_pattern] = STATE(4815),
    [sym_as_pattern] = STATE(4815),
    [sym_cons_pattern] = STATE(4815),
    [sym_disjunct_pattern] = STATE(4815),
    [sym_conjunct_pattern] = STATE(4815),
    [sym_typed_pattern] = STATE(4815),
    [sym_list_pattern] = STATE(4815),
    [sym_array_pattern] = STATE(4815),
    [sym_record_pattern] = STATE(4815),
    [sym_named_field_pattern] = STATE(4815),
    [sym_identifier_pattern] = STATE(4815),
    [sym_long_identifier_or_op] = STATE(1792),
    [sym_char] = STATE(4765),
    [sym_format_string] = STATE(4746),
    [sym__string_literal] = STATE(4746),
    [sym_string] = STATE(4765),
    [sym_verbatim_string] = STATE(4765),
    [sym_bytearray] = STATE(4765),
    [sym_verbatim_bytearray] = STATE(4765),
    [sym_format_triple_quoted_string] = STATE(4720),
    [sym_triple_quoted_string] = STATE(4765),
    [sym_const] = STATE(4815),
    [sym_long_identifier] = STATE(3320),
    [sym_active_pattern] = STATE(3488),
    [sym__identifier_or_op] = STATE(3410),
    [sym_sbyte] = STATE(4765),
    [sym_byte] = STATE(4765),
    [sym_int16] = STATE(4765),
    [sym_uint16] = STATE(4765),
    [sym_int32] = STATE(4765),
    [sym_uint32] = STATE(4765),
    [sym_nativeint] = STATE(4765),
    [sym_unativeint] = STATE(4765),
    [sym_int64] = STATE(4765),
    [sym_uint64] = STATE(4765),
    [sym_ieee32] = STATE(4765),
    [sym_ieee64] = STATE(4765),
    [sym_bignum] = STATE(4765),
    [sym_decimal] = STATE(4765),
    [sym_float] = STATE(4512),
    [sym_block_comment] = STATE(2480),
    [sym_compiler_directive_decl] = STATE(2480),
    [sym_fsi_directive_decl] = STATE(2480),
    [sym_preproc_line] = STATE(2480),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(3562),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_mutable] = ACTIONS(3568),
    [aux_sym_access_modifier_token1] = ACTIONS(3570),
    [anon_sym_LPAREN] = ACTIONS(3572),
    [anon_sym_null] = ACTIONS(3574),
    [anon_sym__] = ACTIONS(3576),
    [anon_sym_QMARK] = ACTIONS(3578),
    [anon_sym_COLON_QMARK] = ACTIONS(3580),
    [anon_sym_LBRACK] = ACTIONS(3582),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3584),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [aux_sym_char_token1] = ACTIONS(3590),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3592),
    [anon_sym_DQUOTE] = ACTIONS(3594),
    [anon_sym_AT_DQUOTE] = ACTIONS(3596),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3598),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3600),
    [sym_bool] = ACTIONS(3602),
    [sym_unit] = ACTIONS(3604),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3606),
    [sym_op_identifier] = ACTIONS(3608),
    [sym_int] = ACTIONS(3610),
    [sym_xint] = ACTIONS(3612),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2481] = {
    [sym_attributes] = STATE(2699),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(4815),
    [sym__pattern] = STATE(5323),
    [sym_optional_pattern] = STATE(4815),
    [sym_type_check_pattern] = STATE(4815),
    [sym_attribute_pattern] = STATE(4815),
    [sym_paren_pattern] = STATE(4815),
    [sym_as_pattern] = STATE(4815),
    [sym_cons_pattern] = STATE(4815),
    [sym_disjunct_pattern] = STATE(4815),
    [sym_conjunct_pattern] = STATE(4815),
    [sym_typed_pattern] = STATE(4815),
    [sym_list_pattern] = STATE(4815),
    [sym_array_pattern] = STATE(4815),
    [sym_record_pattern] = STATE(4815),
    [sym_named_field_pattern] = STATE(4815),
    [sym_identifier_pattern] = STATE(4815),
    [sym_long_identifier_or_op] = STATE(2193),
    [sym_rule] = STATE(1461),
    [sym_rules] = STATE(1957),
    [sym_char] = STATE(4765),
    [sym_format_string] = STATE(4746),
    [sym__string_literal] = STATE(4746),
    [sym_string] = STATE(4765),
    [sym_verbatim_string] = STATE(4765),
    [sym_bytearray] = STATE(4765),
    [sym_verbatim_bytearray] = STATE(4765),
    [sym_format_triple_quoted_string] = STATE(4720),
    [sym_triple_quoted_string] = STATE(4765),
    [sym_const] = STATE(4815),
    [sym_long_identifier] = STATE(3493),
    [sym_active_pattern] = STATE(3613),
    [sym__identifier_or_op] = STATE(3650),
    [sym_sbyte] = STATE(4765),
    [sym_byte] = STATE(4765),
    [sym_int16] = STATE(4765),
    [sym_uint16] = STATE(4765),
    [sym_int32] = STATE(4765),
    [sym_uint32] = STATE(4765),
    [sym_nativeint] = STATE(4765),
    [sym_unativeint] = STATE(4765),
    [sym_int64] = STATE(4765),
    [sym_uint64] = STATE(4765),
    [sym_ieee32] = STATE(4765),
    [sym_ieee64] = STATE(4765),
    [sym_bignum] = STATE(4765),
    [sym_decimal] = STATE(4765),
    [sym_float] = STATE(4512),
    [sym_block_comment] = STATE(2481),
    [sym_compiler_directive_decl] = STATE(2481),
    [sym_fsi_directive_decl] = STATE(2481),
    [sym_preproc_line] = STATE(2481),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(4175),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_LPAREN] = ACTIONS(3572),
    [anon_sym_null] = ACTIONS(3574),
    [anon_sym__] = ACTIONS(3576),
    [anon_sym_QMARK] = ACTIONS(4177),
    [anon_sym_COLON_QMARK] = ACTIONS(4179),
    [anon_sym_PIPE] = ACTIONS(4344),
    [anon_sym_LBRACK] = ACTIONS(3582),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3584),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [aux_sym_char_token1] = ACTIONS(3590),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3592),
    [anon_sym_DQUOTE] = ACTIONS(3594),
    [anon_sym_AT_DQUOTE] = ACTIONS(3596),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3598),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3600),
    [sym_bool] = ACTIONS(3602),
    [sym_unit] = ACTIONS(3604),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4181),
    [sym_op_identifier] = ACTIONS(4183),
    [sym_int] = ACTIONS(3610),
    [sym_xint] = ACTIONS(3612),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2482] = {
    [sym_attributes] = STATE(2699),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(4815),
    [sym__pattern] = STATE(5274),
    [sym_optional_pattern] = STATE(4815),
    [sym_type_check_pattern] = STATE(4815),
    [sym_attribute_pattern] = STATE(4815),
    [sym_paren_pattern] = STATE(4815),
    [sym_as_pattern] = STATE(4815),
    [sym_cons_pattern] = STATE(4815),
    [sym_disjunct_pattern] = STATE(4815),
    [sym_conjunct_pattern] = STATE(4815),
    [sym_typed_pattern] = STATE(4815),
    [sym_list_pattern] = STATE(4815),
    [sym_array_pattern] = STATE(4815),
    [sym_record_pattern] = STATE(4815),
    [sym_named_field_pattern] = STATE(4815),
    [sym_identifier_pattern] = STATE(4815),
    [sym_long_identifier_or_op] = STATE(2193),
    [sym_rule] = STATE(983),
    [sym_rules] = STATE(1109),
    [sym_char] = STATE(4765),
    [sym_format_string] = STATE(4746),
    [sym__string_literal] = STATE(4746),
    [sym_string] = STATE(4765),
    [sym_verbatim_string] = STATE(4765),
    [sym_bytearray] = STATE(4765),
    [sym_verbatim_bytearray] = STATE(4765),
    [sym_format_triple_quoted_string] = STATE(4720),
    [sym_triple_quoted_string] = STATE(4765),
    [sym_const] = STATE(4815),
    [sym_long_identifier] = STATE(3493),
    [sym_active_pattern] = STATE(3613),
    [sym__identifier_or_op] = STATE(3650),
    [sym_sbyte] = STATE(4765),
    [sym_byte] = STATE(4765),
    [sym_int16] = STATE(4765),
    [sym_uint16] = STATE(4765),
    [sym_int32] = STATE(4765),
    [sym_uint32] = STATE(4765),
    [sym_nativeint] = STATE(4765),
    [sym_unativeint] = STATE(4765),
    [sym_int64] = STATE(4765),
    [sym_uint64] = STATE(4765),
    [sym_ieee32] = STATE(4765),
    [sym_ieee64] = STATE(4765),
    [sym_bignum] = STATE(4765),
    [sym_decimal] = STATE(4765),
    [sym_float] = STATE(4512),
    [sym_block_comment] = STATE(2482),
    [sym_compiler_directive_decl] = STATE(2482),
    [sym_fsi_directive_decl] = STATE(2482),
    [sym_preproc_line] = STATE(2482),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(4175),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_LPAREN] = ACTIONS(3572),
    [anon_sym_null] = ACTIONS(3574),
    [anon_sym__] = ACTIONS(3576),
    [anon_sym_QMARK] = ACTIONS(4177),
    [anon_sym_COLON_QMARK] = ACTIONS(4179),
    [anon_sym_PIPE] = ACTIONS(4346),
    [anon_sym_LBRACK] = ACTIONS(3582),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3584),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [aux_sym_char_token1] = ACTIONS(3590),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3592),
    [anon_sym_DQUOTE] = ACTIONS(3594),
    [anon_sym_AT_DQUOTE] = ACTIONS(3596),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3598),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3600),
    [sym_bool] = ACTIONS(3602),
    [sym_unit] = ACTIONS(3604),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4181),
    [sym_op_identifier] = ACTIONS(4183),
    [sym_int] = ACTIONS(3610),
    [sym_xint] = ACTIONS(3612),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2483] = {
    [sym_attributes] = STATE(2699),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(4815),
    [sym__pattern] = STATE(5267),
    [sym_optional_pattern] = STATE(4815),
    [sym_type_check_pattern] = STATE(4815),
    [sym_attribute_pattern] = STATE(4815),
    [sym_paren_pattern] = STATE(4815),
    [sym_as_pattern] = STATE(4815),
    [sym_cons_pattern] = STATE(4815),
    [sym_disjunct_pattern] = STATE(4815),
    [sym_conjunct_pattern] = STATE(4815),
    [sym_typed_pattern] = STATE(4815),
    [sym_list_pattern] = STATE(4815),
    [sym_array_pattern] = STATE(4815),
    [sym_record_pattern] = STATE(4815),
    [sym_named_field_pattern] = STATE(4815),
    [sym_identifier_pattern] = STATE(4815),
    [sym_long_identifier_or_op] = STATE(2193),
    [sym_rule] = STATE(1419),
    [sym_rules] = STATE(1953),
    [sym_char] = STATE(4765),
    [sym_format_string] = STATE(4746),
    [sym__string_literal] = STATE(4746),
    [sym_string] = STATE(4765),
    [sym_verbatim_string] = STATE(4765),
    [sym_bytearray] = STATE(4765),
    [sym_verbatim_bytearray] = STATE(4765),
    [sym_format_triple_quoted_string] = STATE(4720),
    [sym_triple_quoted_string] = STATE(4765),
    [sym_const] = STATE(4815),
    [sym_long_identifier] = STATE(3493),
    [sym_active_pattern] = STATE(3613),
    [sym__identifier_or_op] = STATE(3650),
    [sym_sbyte] = STATE(4765),
    [sym_byte] = STATE(4765),
    [sym_int16] = STATE(4765),
    [sym_uint16] = STATE(4765),
    [sym_int32] = STATE(4765),
    [sym_uint32] = STATE(4765),
    [sym_nativeint] = STATE(4765),
    [sym_unativeint] = STATE(4765),
    [sym_int64] = STATE(4765),
    [sym_uint64] = STATE(4765),
    [sym_ieee32] = STATE(4765),
    [sym_ieee64] = STATE(4765),
    [sym_bignum] = STATE(4765),
    [sym_decimal] = STATE(4765),
    [sym_float] = STATE(4512),
    [sym_block_comment] = STATE(2483),
    [sym_compiler_directive_decl] = STATE(2483),
    [sym_fsi_directive_decl] = STATE(2483),
    [sym_preproc_line] = STATE(2483),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(4175),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_LPAREN] = ACTIONS(3572),
    [anon_sym_null] = ACTIONS(3574),
    [anon_sym__] = ACTIONS(3576),
    [anon_sym_QMARK] = ACTIONS(4177),
    [anon_sym_COLON_QMARK] = ACTIONS(4179),
    [anon_sym_PIPE] = ACTIONS(4348),
    [anon_sym_LBRACK] = ACTIONS(3582),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3584),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [aux_sym_char_token1] = ACTIONS(3590),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3592),
    [anon_sym_DQUOTE] = ACTIONS(3594),
    [anon_sym_AT_DQUOTE] = ACTIONS(3596),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3598),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3600),
    [sym_bool] = ACTIONS(3602),
    [sym_unit] = ACTIONS(3604),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4181),
    [sym_op_identifier] = ACTIONS(4183),
    [sym_int] = ACTIONS(3610),
    [sym_xint] = ACTIONS(3612),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2484] = {
    [sym_attributes] = STATE(2699),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(4815),
    [sym__pattern] = STATE(5404),
    [sym_optional_pattern] = STATE(4815),
    [sym_type_check_pattern] = STATE(4815),
    [sym_attribute_pattern] = STATE(4815),
    [sym_paren_pattern] = STATE(4815),
    [sym_as_pattern] = STATE(4815),
    [sym_cons_pattern] = STATE(4815),
    [sym_disjunct_pattern] = STATE(4815),
    [sym_conjunct_pattern] = STATE(4815),
    [sym_typed_pattern] = STATE(4815),
    [sym_list_pattern] = STATE(4815),
    [sym_array_pattern] = STATE(4815),
    [sym_record_pattern] = STATE(4815),
    [sym_named_field_pattern] = STATE(4815),
    [sym_identifier_pattern] = STATE(4815),
    [sym_long_identifier_or_op] = STATE(2193),
    [sym_rule] = STATE(1561),
    [sym_rules] = STATE(2450),
    [sym_char] = STATE(4765),
    [sym_format_string] = STATE(4746),
    [sym__string_literal] = STATE(4746),
    [sym_string] = STATE(4765),
    [sym_verbatim_string] = STATE(4765),
    [sym_bytearray] = STATE(4765),
    [sym_verbatim_bytearray] = STATE(4765),
    [sym_format_triple_quoted_string] = STATE(4720),
    [sym_triple_quoted_string] = STATE(4765),
    [sym_const] = STATE(4815),
    [sym_long_identifier] = STATE(3493),
    [sym_active_pattern] = STATE(3613),
    [sym__identifier_or_op] = STATE(3650),
    [sym_sbyte] = STATE(4765),
    [sym_byte] = STATE(4765),
    [sym_int16] = STATE(4765),
    [sym_uint16] = STATE(4765),
    [sym_int32] = STATE(4765),
    [sym_uint32] = STATE(4765),
    [sym_nativeint] = STATE(4765),
    [sym_unativeint] = STATE(4765),
    [sym_int64] = STATE(4765),
    [sym_uint64] = STATE(4765),
    [sym_ieee32] = STATE(4765),
    [sym_ieee64] = STATE(4765),
    [sym_bignum] = STATE(4765),
    [sym_decimal] = STATE(4765),
    [sym_float] = STATE(4512),
    [sym_block_comment] = STATE(2484),
    [sym_compiler_directive_decl] = STATE(2484),
    [sym_fsi_directive_decl] = STATE(2484),
    [sym_preproc_line] = STATE(2484),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(4175),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_LPAREN] = ACTIONS(3572),
    [anon_sym_null] = ACTIONS(3574),
    [anon_sym__] = ACTIONS(3576),
    [anon_sym_QMARK] = ACTIONS(4177),
    [anon_sym_COLON_QMARK] = ACTIONS(4179),
    [anon_sym_PIPE] = ACTIONS(4350),
    [anon_sym_LBRACK] = ACTIONS(3582),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3584),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [aux_sym_char_token1] = ACTIONS(3590),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3592),
    [anon_sym_DQUOTE] = ACTIONS(3594),
    [anon_sym_AT_DQUOTE] = ACTIONS(3596),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3598),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3600),
    [sym_bool] = ACTIONS(3602),
    [sym_unit] = ACTIONS(3604),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4181),
    [sym_op_identifier] = ACTIONS(4183),
    [sym_int] = ACTIONS(3610),
    [sym_xint] = ACTIONS(3612),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2485] = {
    [sym_attributes] = STATE(2699),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(4815),
    [sym__pattern] = STATE(5196),
    [sym_optional_pattern] = STATE(4815),
    [sym_type_check_pattern] = STATE(4815),
    [sym_attribute_pattern] = STATE(4815),
    [sym_paren_pattern] = STATE(4815),
    [sym_as_pattern] = STATE(4815),
    [sym_cons_pattern] = STATE(4815),
    [sym_disjunct_pattern] = STATE(4815),
    [sym_conjunct_pattern] = STATE(4815),
    [sym_typed_pattern] = STATE(4815),
    [sym_list_pattern] = STATE(4815),
    [sym_array_pattern] = STATE(4815),
    [sym_record_pattern] = STATE(4815),
    [sym_named_field_pattern] = STATE(4815),
    [sym_identifier_pattern] = STATE(4815),
    [sym_long_identifier_or_op] = STATE(2193),
    [sym_rule] = STATE(821),
    [sym_rules] = STATE(863),
    [sym_char] = STATE(4765),
    [sym_format_string] = STATE(4746),
    [sym__string_literal] = STATE(4746),
    [sym_string] = STATE(4765),
    [sym_verbatim_string] = STATE(4765),
    [sym_bytearray] = STATE(4765),
    [sym_verbatim_bytearray] = STATE(4765),
    [sym_format_triple_quoted_string] = STATE(4720),
    [sym_triple_quoted_string] = STATE(4765),
    [sym_const] = STATE(4815),
    [sym_long_identifier] = STATE(3493),
    [sym_active_pattern] = STATE(3613),
    [sym__identifier_or_op] = STATE(3650),
    [sym_sbyte] = STATE(4765),
    [sym_byte] = STATE(4765),
    [sym_int16] = STATE(4765),
    [sym_uint16] = STATE(4765),
    [sym_int32] = STATE(4765),
    [sym_uint32] = STATE(4765),
    [sym_nativeint] = STATE(4765),
    [sym_unativeint] = STATE(4765),
    [sym_int64] = STATE(4765),
    [sym_uint64] = STATE(4765),
    [sym_ieee32] = STATE(4765),
    [sym_ieee64] = STATE(4765),
    [sym_bignum] = STATE(4765),
    [sym_decimal] = STATE(4765),
    [sym_float] = STATE(4512),
    [sym_block_comment] = STATE(2485),
    [sym_compiler_directive_decl] = STATE(2485),
    [sym_fsi_directive_decl] = STATE(2485),
    [sym_preproc_line] = STATE(2485),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(4175),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_LPAREN] = ACTIONS(3572),
    [anon_sym_null] = ACTIONS(3574),
    [anon_sym__] = ACTIONS(3576),
    [anon_sym_QMARK] = ACTIONS(4177),
    [anon_sym_COLON_QMARK] = ACTIONS(4179),
    [anon_sym_PIPE] = ACTIONS(4352),
    [anon_sym_LBRACK] = ACTIONS(3582),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3584),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [aux_sym_char_token1] = ACTIONS(3590),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3592),
    [anon_sym_DQUOTE] = ACTIONS(3594),
    [anon_sym_AT_DQUOTE] = ACTIONS(3596),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3598),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3600),
    [sym_bool] = ACTIONS(3602),
    [sym_unit] = ACTIONS(3604),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4181),
    [sym_op_identifier] = ACTIONS(4183),
    [sym_int] = ACTIONS(3610),
    [sym_xint] = ACTIONS(3612),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2486] = {
    [sym_attributes] = STATE(2699),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(4815),
    [sym__pattern] = STATE(5282),
    [sym_optional_pattern] = STATE(4815),
    [sym_type_check_pattern] = STATE(4815),
    [sym_attribute_pattern] = STATE(4815),
    [sym_paren_pattern] = STATE(4815),
    [sym_as_pattern] = STATE(4815),
    [sym_cons_pattern] = STATE(4815),
    [sym_disjunct_pattern] = STATE(4815),
    [sym_conjunct_pattern] = STATE(4815),
    [sym_typed_pattern] = STATE(4815),
    [sym_list_pattern] = STATE(4815),
    [sym_array_pattern] = STATE(4815),
    [sym_record_pattern] = STATE(4815),
    [sym_named_field_pattern] = STATE(4815),
    [sym_identifier_pattern] = STATE(4815),
    [sym_long_identifier_or_op] = STATE(2193),
    [sym_rule] = STATE(5720),
    [sym_rules] = STATE(7206),
    [sym_char] = STATE(4765),
    [sym_format_string] = STATE(4746),
    [sym__string_literal] = STATE(4746),
    [sym_string] = STATE(4765),
    [sym_verbatim_string] = STATE(4765),
    [sym_bytearray] = STATE(4765),
    [sym_verbatim_bytearray] = STATE(4765),
    [sym_format_triple_quoted_string] = STATE(4720),
    [sym_triple_quoted_string] = STATE(4765),
    [sym_const] = STATE(4815),
    [sym_long_identifier] = STATE(3493),
    [sym_active_pattern] = STATE(3613),
    [sym__identifier_or_op] = STATE(3650),
    [sym_sbyte] = STATE(4765),
    [sym_byte] = STATE(4765),
    [sym_int16] = STATE(4765),
    [sym_uint16] = STATE(4765),
    [sym_int32] = STATE(4765),
    [sym_uint32] = STATE(4765),
    [sym_nativeint] = STATE(4765),
    [sym_unativeint] = STATE(4765),
    [sym_int64] = STATE(4765),
    [sym_uint64] = STATE(4765),
    [sym_ieee32] = STATE(4765),
    [sym_ieee64] = STATE(4765),
    [sym_bignum] = STATE(4765),
    [sym_decimal] = STATE(4765),
    [sym_float] = STATE(4512),
    [sym_block_comment] = STATE(2486),
    [sym_compiler_directive_decl] = STATE(2486),
    [sym_fsi_directive_decl] = STATE(2486),
    [sym_preproc_line] = STATE(2486),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(4175),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_LPAREN] = ACTIONS(3572),
    [anon_sym_null] = ACTIONS(3574),
    [anon_sym__] = ACTIONS(3576),
    [anon_sym_QMARK] = ACTIONS(4177),
    [anon_sym_COLON_QMARK] = ACTIONS(4179),
    [anon_sym_PIPE] = ACTIONS(4354),
    [anon_sym_LBRACK] = ACTIONS(3582),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3584),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [aux_sym_char_token1] = ACTIONS(3590),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3592),
    [anon_sym_DQUOTE] = ACTIONS(3594),
    [anon_sym_AT_DQUOTE] = ACTIONS(3596),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3598),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3600),
    [sym_bool] = ACTIONS(3602),
    [sym_unit] = ACTIONS(3604),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4181),
    [sym_op_identifier] = ACTIONS(4183),
    [sym_int] = ACTIONS(3610),
    [sym_xint] = ACTIONS(3612),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2487] = {
    [sym_attributes] = STATE(2699),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(4815),
    [sym__pattern] = STATE(5282),
    [sym_optional_pattern] = STATE(4815),
    [sym_type_check_pattern] = STATE(4815),
    [sym_attribute_pattern] = STATE(4815),
    [sym_paren_pattern] = STATE(4815),
    [sym_as_pattern] = STATE(4815),
    [sym_cons_pattern] = STATE(4815),
    [sym_disjunct_pattern] = STATE(4815),
    [sym_conjunct_pattern] = STATE(4815),
    [sym_typed_pattern] = STATE(4815),
    [sym_list_pattern] = STATE(4815),
    [sym_array_pattern] = STATE(4815),
    [sym_record_pattern] = STATE(4815),
    [sym_named_field_pattern] = STATE(4815),
    [sym_identifier_pattern] = STATE(4815),
    [sym_long_identifier_or_op] = STATE(2193),
    [sym_rule] = STATE(5720),
    [sym_rules] = STATE(6633),
    [sym_char] = STATE(4765),
    [sym_format_string] = STATE(4746),
    [sym__string_literal] = STATE(4746),
    [sym_string] = STATE(4765),
    [sym_verbatim_string] = STATE(4765),
    [sym_bytearray] = STATE(4765),
    [sym_verbatim_bytearray] = STATE(4765),
    [sym_format_triple_quoted_string] = STATE(4720),
    [sym_triple_quoted_string] = STATE(4765),
    [sym_const] = STATE(4815),
    [sym_long_identifier] = STATE(3493),
    [sym_active_pattern] = STATE(3613),
    [sym__identifier_or_op] = STATE(3650),
    [sym_sbyte] = STATE(4765),
    [sym_byte] = STATE(4765),
    [sym_int16] = STATE(4765),
    [sym_uint16] = STATE(4765),
    [sym_int32] = STATE(4765),
    [sym_uint32] = STATE(4765),
    [sym_nativeint] = STATE(4765),
    [sym_unativeint] = STATE(4765),
    [sym_int64] = STATE(4765),
    [sym_uint64] = STATE(4765),
    [sym_ieee32] = STATE(4765),
    [sym_ieee64] = STATE(4765),
    [sym_bignum] = STATE(4765),
    [sym_decimal] = STATE(4765),
    [sym_float] = STATE(4512),
    [sym_block_comment] = STATE(2487),
    [sym_compiler_directive_decl] = STATE(2487),
    [sym_fsi_directive_decl] = STATE(2487),
    [sym_preproc_line] = STATE(2487),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(4175),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_LPAREN] = ACTIONS(3572),
    [anon_sym_null] = ACTIONS(3574),
    [anon_sym__] = ACTIONS(3576),
    [anon_sym_QMARK] = ACTIONS(4177),
    [anon_sym_COLON_QMARK] = ACTIONS(4179),
    [anon_sym_PIPE] = ACTIONS(4354),
    [anon_sym_LBRACK] = ACTIONS(3582),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3584),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [aux_sym_char_token1] = ACTIONS(3590),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3592),
    [anon_sym_DQUOTE] = ACTIONS(3594),
    [anon_sym_AT_DQUOTE] = ACTIONS(3596),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3598),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3600),
    [sym_bool] = ACTIONS(3602),
    [sym_unit] = ACTIONS(3604),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4181),
    [sym_op_identifier] = ACTIONS(4183),
    [sym_int] = ACTIONS(3610),
    [sym_xint] = ACTIONS(3612),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2488] = {
    [sym_attributes] = STATE(2699),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(4815),
    [sym__pattern] = STATE(5282),
    [sym_optional_pattern] = STATE(4815),
    [sym_type_check_pattern] = STATE(4815),
    [sym_attribute_pattern] = STATE(4815),
    [sym_paren_pattern] = STATE(4815),
    [sym_as_pattern] = STATE(4815),
    [sym_cons_pattern] = STATE(4815),
    [sym_disjunct_pattern] = STATE(4815),
    [sym_conjunct_pattern] = STATE(4815),
    [sym_typed_pattern] = STATE(4815),
    [sym_list_pattern] = STATE(4815),
    [sym_array_pattern] = STATE(4815),
    [sym_record_pattern] = STATE(4815),
    [sym_named_field_pattern] = STATE(4815),
    [sym_identifier_pattern] = STATE(4815),
    [sym_long_identifier_or_op] = STATE(2193),
    [sym_rule] = STATE(5720),
    [sym_rules] = STATE(7404),
    [sym_char] = STATE(4765),
    [sym_format_string] = STATE(4746),
    [sym__string_literal] = STATE(4746),
    [sym_string] = STATE(4765),
    [sym_verbatim_string] = STATE(4765),
    [sym_bytearray] = STATE(4765),
    [sym_verbatim_bytearray] = STATE(4765),
    [sym_format_triple_quoted_string] = STATE(4720),
    [sym_triple_quoted_string] = STATE(4765),
    [sym_const] = STATE(4815),
    [sym_long_identifier] = STATE(3493),
    [sym_active_pattern] = STATE(3613),
    [sym__identifier_or_op] = STATE(3650),
    [sym_sbyte] = STATE(4765),
    [sym_byte] = STATE(4765),
    [sym_int16] = STATE(4765),
    [sym_uint16] = STATE(4765),
    [sym_int32] = STATE(4765),
    [sym_uint32] = STATE(4765),
    [sym_nativeint] = STATE(4765),
    [sym_unativeint] = STATE(4765),
    [sym_int64] = STATE(4765),
    [sym_uint64] = STATE(4765),
    [sym_ieee32] = STATE(4765),
    [sym_ieee64] = STATE(4765),
    [sym_bignum] = STATE(4765),
    [sym_decimal] = STATE(4765),
    [sym_float] = STATE(4512),
    [sym_block_comment] = STATE(2488),
    [sym_compiler_directive_decl] = STATE(2488),
    [sym_fsi_directive_decl] = STATE(2488),
    [sym_preproc_line] = STATE(2488),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(4175),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_LPAREN] = ACTIONS(3572),
    [anon_sym_null] = ACTIONS(3574),
    [anon_sym__] = ACTIONS(3576),
    [anon_sym_QMARK] = ACTIONS(4177),
    [anon_sym_COLON_QMARK] = ACTIONS(4179),
    [anon_sym_PIPE] = ACTIONS(4354),
    [anon_sym_LBRACK] = ACTIONS(3582),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3584),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [aux_sym_char_token1] = ACTIONS(3590),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3592),
    [anon_sym_DQUOTE] = ACTIONS(3594),
    [anon_sym_AT_DQUOTE] = ACTIONS(3596),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3598),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3600),
    [sym_bool] = ACTIONS(3602),
    [sym_unit] = ACTIONS(3604),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4181),
    [sym_op_identifier] = ACTIONS(4183),
    [sym_int] = ACTIONS(3610),
    [sym_xint] = ACTIONS(3612),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2489] = {
    [sym_attributes] = STATE(2699),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(4815),
    [sym__pattern] = STATE(5282),
    [sym_optional_pattern] = STATE(4815),
    [sym_type_check_pattern] = STATE(4815),
    [sym_attribute_pattern] = STATE(4815),
    [sym_paren_pattern] = STATE(4815),
    [sym_as_pattern] = STATE(4815),
    [sym_cons_pattern] = STATE(4815),
    [sym_disjunct_pattern] = STATE(4815),
    [sym_conjunct_pattern] = STATE(4815),
    [sym_typed_pattern] = STATE(4815),
    [sym_list_pattern] = STATE(4815),
    [sym_array_pattern] = STATE(4815),
    [sym_record_pattern] = STATE(4815),
    [sym_named_field_pattern] = STATE(4815),
    [sym_identifier_pattern] = STATE(4815),
    [sym_long_identifier_or_op] = STATE(2193),
    [sym_rule] = STATE(5720),
    [sym_rules] = STATE(7199),
    [sym_char] = STATE(4765),
    [sym_format_string] = STATE(4746),
    [sym__string_literal] = STATE(4746),
    [sym_string] = STATE(4765),
    [sym_verbatim_string] = STATE(4765),
    [sym_bytearray] = STATE(4765),
    [sym_verbatim_bytearray] = STATE(4765),
    [sym_format_triple_quoted_string] = STATE(4720),
    [sym_triple_quoted_string] = STATE(4765),
    [sym_const] = STATE(4815),
    [sym_long_identifier] = STATE(3493),
    [sym_active_pattern] = STATE(3613),
    [sym__identifier_or_op] = STATE(3650),
    [sym_sbyte] = STATE(4765),
    [sym_byte] = STATE(4765),
    [sym_int16] = STATE(4765),
    [sym_uint16] = STATE(4765),
    [sym_int32] = STATE(4765),
    [sym_uint32] = STATE(4765),
    [sym_nativeint] = STATE(4765),
    [sym_unativeint] = STATE(4765),
    [sym_int64] = STATE(4765),
    [sym_uint64] = STATE(4765),
    [sym_ieee32] = STATE(4765),
    [sym_ieee64] = STATE(4765),
    [sym_bignum] = STATE(4765),
    [sym_decimal] = STATE(4765),
    [sym_float] = STATE(4512),
    [sym_block_comment] = STATE(2489),
    [sym_compiler_directive_decl] = STATE(2489),
    [sym_fsi_directive_decl] = STATE(2489),
    [sym_preproc_line] = STATE(2489),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(4175),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_LPAREN] = ACTIONS(3572),
    [anon_sym_null] = ACTIONS(3574),
    [anon_sym__] = ACTIONS(3576),
    [anon_sym_QMARK] = ACTIONS(4177),
    [anon_sym_COLON_QMARK] = ACTIONS(4179),
    [anon_sym_PIPE] = ACTIONS(4354),
    [anon_sym_LBRACK] = ACTIONS(3582),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3584),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [aux_sym_char_token1] = ACTIONS(3590),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3592),
    [anon_sym_DQUOTE] = ACTIONS(3594),
    [anon_sym_AT_DQUOTE] = ACTIONS(3596),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3598),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3600),
    [sym_bool] = ACTIONS(3602),
    [sym_unit] = ACTIONS(3604),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4181),
    [sym_op_identifier] = ACTIONS(4183),
    [sym_int] = ACTIONS(3610),
    [sym_xint] = ACTIONS(3612),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2490] = {
    [sym_attributes] = STATE(2699),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(4815),
    [sym__pattern] = STATE(5404),
    [sym_optional_pattern] = STATE(4815),
    [sym_type_check_pattern] = STATE(4815),
    [sym_attribute_pattern] = STATE(4815),
    [sym_paren_pattern] = STATE(4815),
    [sym_as_pattern] = STATE(4815),
    [sym_cons_pattern] = STATE(4815),
    [sym_disjunct_pattern] = STATE(4815),
    [sym_conjunct_pattern] = STATE(4815),
    [sym_typed_pattern] = STATE(4815),
    [sym_list_pattern] = STATE(4815),
    [sym_array_pattern] = STATE(4815),
    [sym_record_pattern] = STATE(4815),
    [sym_named_field_pattern] = STATE(4815),
    [sym_identifier_pattern] = STATE(4815),
    [sym_long_identifier_or_op] = STATE(2193),
    [sym_rule] = STATE(1561),
    [sym_rules] = STATE(2448),
    [sym_char] = STATE(4765),
    [sym_format_string] = STATE(4746),
    [sym__string_literal] = STATE(4746),
    [sym_string] = STATE(4765),
    [sym_verbatim_string] = STATE(4765),
    [sym_bytearray] = STATE(4765),
    [sym_verbatim_bytearray] = STATE(4765),
    [sym_format_triple_quoted_string] = STATE(4720),
    [sym_triple_quoted_string] = STATE(4765),
    [sym_const] = STATE(4815),
    [sym_long_identifier] = STATE(3493),
    [sym_active_pattern] = STATE(3613),
    [sym__identifier_or_op] = STATE(3650),
    [sym_sbyte] = STATE(4765),
    [sym_byte] = STATE(4765),
    [sym_int16] = STATE(4765),
    [sym_uint16] = STATE(4765),
    [sym_int32] = STATE(4765),
    [sym_uint32] = STATE(4765),
    [sym_nativeint] = STATE(4765),
    [sym_unativeint] = STATE(4765),
    [sym_int64] = STATE(4765),
    [sym_uint64] = STATE(4765),
    [sym_ieee32] = STATE(4765),
    [sym_ieee64] = STATE(4765),
    [sym_bignum] = STATE(4765),
    [sym_decimal] = STATE(4765),
    [sym_float] = STATE(4512),
    [sym_block_comment] = STATE(2490),
    [sym_compiler_directive_decl] = STATE(2490),
    [sym_fsi_directive_decl] = STATE(2490),
    [sym_preproc_line] = STATE(2490),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(4175),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_LPAREN] = ACTIONS(3572),
    [anon_sym_null] = ACTIONS(3574),
    [anon_sym__] = ACTIONS(3576),
    [anon_sym_QMARK] = ACTIONS(4177),
    [anon_sym_COLON_QMARK] = ACTIONS(4179),
    [anon_sym_PIPE] = ACTIONS(4350),
    [anon_sym_LBRACK] = ACTIONS(3582),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3584),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [aux_sym_char_token1] = ACTIONS(3590),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3592),
    [anon_sym_DQUOTE] = ACTIONS(3594),
    [anon_sym_AT_DQUOTE] = ACTIONS(3596),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3598),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3600),
    [sym_bool] = ACTIONS(3602),
    [sym_unit] = ACTIONS(3604),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4181),
    [sym_op_identifier] = ACTIONS(4183),
    [sym_int] = ACTIONS(3610),
    [sym_xint] = ACTIONS(3612),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2491] = {
    [sym_attributes] = STATE(2699),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(4815),
    [sym__pattern] = STATE(5237),
    [sym_optional_pattern] = STATE(4815),
    [sym_type_check_pattern] = STATE(4815),
    [sym_attribute_pattern] = STATE(4815),
    [sym_paren_pattern] = STATE(4815),
    [sym_as_pattern] = STATE(4815),
    [sym_cons_pattern] = STATE(4815),
    [sym_disjunct_pattern] = STATE(4815),
    [sym_conjunct_pattern] = STATE(4815),
    [sym_typed_pattern] = STATE(4815),
    [sym_list_pattern] = STATE(4815),
    [sym_array_pattern] = STATE(4815),
    [sym_record_pattern] = STATE(4815),
    [sym_named_field_pattern] = STATE(4815),
    [sym_identifier_pattern] = STATE(4815),
    [sym_long_identifier_or_op] = STATE(2193),
    [sym_rule] = STATE(1515),
    [sym_rules] = STATE(2347),
    [sym_char] = STATE(4765),
    [sym_format_string] = STATE(4746),
    [sym__string_literal] = STATE(4746),
    [sym_string] = STATE(4765),
    [sym_verbatim_string] = STATE(4765),
    [sym_bytearray] = STATE(4765),
    [sym_verbatim_bytearray] = STATE(4765),
    [sym_format_triple_quoted_string] = STATE(4720),
    [sym_triple_quoted_string] = STATE(4765),
    [sym_const] = STATE(4815),
    [sym_long_identifier] = STATE(3493),
    [sym_active_pattern] = STATE(3613),
    [sym__identifier_or_op] = STATE(3650),
    [sym_sbyte] = STATE(4765),
    [sym_byte] = STATE(4765),
    [sym_int16] = STATE(4765),
    [sym_uint16] = STATE(4765),
    [sym_int32] = STATE(4765),
    [sym_uint32] = STATE(4765),
    [sym_nativeint] = STATE(4765),
    [sym_unativeint] = STATE(4765),
    [sym_int64] = STATE(4765),
    [sym_uint64] = STATE(4765),
    [sym_ieee32] = STATE(4765),
    [sym_ieee64] = STATE(4765),
    [sym_bignum] = STATE(4765),
    [sym_decimal] = STATE(4765),
    [sym_float] = STATE(4512),
    [sym_block_comment] = STATE(2491),
    [sym_compiler_directive_decl] = STATE(2491),
    [sym_fsi_directive_decl] = STATE(2491),
    [sym_preproc_line] = STATE(2491),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(4175),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_LPAREN] = ACTIONS(3572),
    [anon_sym_null] = ACTIONS(3574),
    [anon_sym__] = ACTIONS(3576),
    [anon_sym_QMARK] = ACTIONS(4177),
    [anon_sym_COLON_QMARK] = ACTIONS(4179),
    [anon_sym_PIPE] = ACTIONS(4356),
    [anon_sym_LBRACK] = ACTIONS(3582),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3584),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [aux_sym_char_token1] = ACTIONS(3590),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3592),
    [anon_sym_DQUOTE] = ACTIONS(3594),
    [anon_sym_AT_DQUOTE] = ACTIONS(3596),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3598),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3600),
    [sym_bool] = ACTIONS(3602),
    [sym_unit] = ACTIONS(3604),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4181),
    [sym_op_identifier] = ACTIONS(4183),
    [sym_int] = ACTIONS(3610),
    [sym_xint] = ACTIONS(3612),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2492] = {
    [sym_attributes] = STATE(2699),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(4815),
    [sym__pattern] = STATE(5282),
    [sym_optional_pattern] = STATE(4815),
    [sym_type_check_pattern] = STATE(4815),
    [sym_attribute_pattern] = STATE(4815),
    [sym_paren_pattern] = STATE(4815),
    [sym_as_pattern] = STATE(4815),
    [sym_cons_pattern] = STATE(4815),
    [sym_disjunct_pattern] = STATE(4815),
    [sym_conjunct_pattern] = STATE(4815),
    [sym_typed_pattern] = STATE(4815),
    [sym_list_pattern] = STATE(4815),
    [sym_array_pattern] = STATE(4815),
    [sym_record_pattern] = STATE(4815),
    [sym_named_field_pattern] = STATE(4815),
    [sym_identifier_pattern] = STATE(4815),
    [sym_long_identifier_or_op] = STATE(2193),
    [sym_rule] = STATE(5720),
    [sym_rules] = STATE(7352),
    [sym_char] = STATE(4765),
    [sym_format_string] = STATE(4746),
    [sym__string_literal] = STATE(4746),
    [sym_string] = STATE(4765),
    [sym_verbatim_string] = STATE(4765),
    [sym_bytearray] = STATE(4765),
    [sym_verbatim_bytearray] = STATE(4765),
    [sym_format_triple_quoted_string] = STATE(4720),
    [sym_triple_quoted_string] = STATE(4765),
    [sym_const] = STATE(4815),
    [sym_long_identifier] = STATE(3493),
    [sym_active_pattern] = STATE(3613),
    [sym__identifier_or_op] = STATE(3650),
    [sym_sbyte] = STATE(4765),
    [sym_byte] = STATE(4765),
    [sym_int16] = STATE(4765),
    [sym_uint16] = STATE(4765),
    [sym_int32] = STATE(4765),
    [sym_uint32] = STATE(4765),
    [sym_nativeint] = STATE(4765),
    [sym_unativeint] = STATE(4765),
    [sym_int64] = STATE(4765),
    [sym_uint64] = STATE(4765),
    [sym_ieee32] = STATE(4765),
    [sym_ieee64] = STATE(4765),
    [sym_bignum] = STATE(4765),
    [sym_decimal] = STATE(4765),
    [sym_float] = STATE(4512),
    [sym_block_comment] = STATE(2492),
    [sym_compiler_directive_decl] = STATE(2492),
    [sym_fsi_directive_decl] = STATE(2492),
    [sym_preproc_line] = STATE(2492),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(4175),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_LPAREN] = ACTIONS(3572),
    [anon_sym_null] = ACTIONS(3574),
    [anon_sym__] = ACTIONS(3576),
    [anon_sym_QMARK] = ACTIONS(4177),
    [anon_sym_COLON_QMARK] = ACTIONS(4179),
    [anon_sym_PIPE] = ACTIONS(4354),
    [anon_sym_LBRACK] = ACTIONS(3582),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3584),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [aux_sym_char_token1] = ACTIONS(3590),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3592),
    [anon_sym_DQUOTE] = ACTIONS(3594),
    [anon_sym_AT_DQUOTE] = ACTIONS(3596),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3598),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3600),
    [sym_bool] = ACTIONS(3602),
    [sym_unit] = ACTIONS(3604),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4181),
    [sym_op_identifier] = ACTIONS(4183),
    [sym_int] = ACTIONS(3610),
    [sym_xint] = ACTIONS(3612),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2493] = {
    [sym_attributes] = STATE(2699),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(4815),
    [sym__pattern] = STATE(5404),
    [sym_optional_pattern] = STATE(4815),
    [sym_type_check_pattern] = STATE(4815),
    [sym_attribute_pattern] = STATE(4815),
    [sym_paren_pattern] = STATE(4815),
    [sym_as_pattern] = STATE(4815),
    [sym_cons_pattern] = STATE(4815),
    [sym_disjunct_pattern] = STATE(4815),
    [sym_conjunct_pattern] = STATE(4815),
    [sym_typed_pattern] = STATE(4815),
    [sym_list_pattern] = STATE(4815),
    [sym_array_pattern] = STATE(4815),
    [sym_record_pattern] = STATE(4815),
    [sym_named_field_pattern] = STATE(4815),
    [sym_identifier_pattern] = STATE(4815),
    [sym_long_identifier_or_op] = STATE(2193),
    [sym_rule] = STATE(1561),
    [sym_rules] = STATE(2432),
    [sym_char] = STATE(4765),
    [sym_format_string] = STATE(4746),
    [sym__string_literal] = STATE(4746),
    [sym_string] = STATE(4765),
    [sym_verbatim_string] = STATE(4765),
    [sym_bytearray] = STATE(4765),
    [sym_verbatim_bytearray] = STATE(4765),
    [sym_format_triple_quoted_string] = STATE(4720),
    [sym_triple_quoted_string] = STATE(4765),
    [sym_const] = STATE(4815),
    [sym_long_identifier] = STATE(3493),
    [sym_active_pattern] = STATE(3613),
    [sym__identifier_or_op] = STATE(3650),
    [sym_sbyte] = STATE(4765),
    [sym_byte] = STATE(4765),
    [sym_int16] = STATE(4765),
    [sym_uint16] = STATE(4765),
    [sym_int32] = STATE(4765),
    [sym_uint32] = STATE(4765),
    [sym_nativeint] = STATE(4765),
    [sym_unativeint] = STATE(4765),
    [sym_int64] = STATE(4765),
    [sym_uint64] = STATE(4765),
    [sym_ieee32] = STATE(4765),
    [sym_ieee64] = STATE(4765),
    [sym_bignum] = STATE(4765),
    [sym_decimal] = STATE(4765),
    [sym_float] = STATE(4512),
    [sym_block_comment] = STATE(2493),
    [sym_compiler_directive_decl] = STATE(2493),
    [sym_fsi_directive_decl] = STATE(2493),
    [sym_preproc_line] = STATE(2493),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(4175),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_LPAREN] = ACTIONS(3572),
    [anon_sym_null] = ACTIONS(3574),
    [anon_sym__] = ACTIONS(3576),
    [anon_sym_QMARK] = ACTIONS(4177),
    [anon_sym_COLON_QMARK] = ACTIONS(4179),
    [anon_sym_PIPE] = ACTIONS(4350),
    [anon_sym_LBRACK] = ACTIONS(3582),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3584),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [aux_sym_char_token1] = ACTIONS(3590),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3592),
    [anon_sym_DQUOTE] = ACTIONS(3594),
    [anon_sym_AT_DQUOTE] = ACTIONS(3596),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3598),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3600),
    [sym_bool] = ACTIONS(3602),
    [sym_unit] = ACTIONS(3604),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4181),
    [sym_op_identifier] = ACTIONS(4183),
    [sym_int] = ACTIONS(3610),
    [sym_xint] = ACTIONS(3612),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2494] = {
    [sym_attributes] = STATE(2699),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(4815),
    [sym__pattern] = STATE(5177),
    [sym_optional_pattern] = STATE(4815),
    [sym_type_check_pattern] = STATE(4815),
    [sym_attribute_pattern] = STATE(4815),
    [sym_paren_pattern] = STATE(4815),
    [sym_as_pattern] = STATE(4815),
    [sym_cons_pattern] = STATE(4815),
    [sym_disjunct_pattern] = STATE(4815),
    [sym_conjunct_pattern] = STATE(4815),
    [sym_typed_pattern] = STATE(4815),
    [sym_list_pattern] = STATE(4815),
    [sym_array_pattern] = STATE(4815),
    [sym_record_pattern] = STATE(4815),
    [sym_named_field_pattern] = STATE(4815),
    [sym_identifier_pattern] = STATE(4815),
    [sym_long_identifier_or_op] = STATE(2193),
    [sym_rule] = STATE(1574),
    [sym_rules] = STATE(2096),
    [sym_char] = STATE(4765),
    [sym_format_string] = STATE(4746),
    [sym__string_literal] = STATE(4746),
    [sym_string] = STATE(4765),
    [sym_verbatim_string] = STATE(4765),
    [sym_bytearray] = STATE(4765),
    [sym_verbatim_bytearray] = STATE(4765),
    [sym_format_triple_quoted_string] = STATE(4720),
    [sym_triple_quoted_string] = STATE(4765),
    [sym_const] = STATE(4815),
    [sym_long_identifier] = STATE(3493),
    [sym_active_pattern] = STATE(3613),
    [sym__identifier_or_op] = STATE(3650),
    [sym_sbyte] = STATE(4765),
    [sym_byte] = STATE(4765),
    [sym_int16] = STATE(4765),
    [sym_uint16] = STATE(4765),
    [sym_int32] = STATE(4765),
    [sym_uint32] = STATE(4765),
    [sym_nativeint] = STATE(4765),
    [sym_unativeint] = STATE(4765),
    [sym_int64] = STATE(4765),
    [sym_uint64] = STATE(4765),
    [sym_ieee32] = STATE(4765),
    [sym_ieee64] = STATE(4765),
    [sym_bignum] = STATE(4765),
    [sym_decimal] = STATE(4765),
    [sym_float] = STATE(4512),
    [sym_block_comment] = STATE(2494),
    [sym_compiler_directive_decl] = STATE(2494),
    [sym_fsi_directive_decl] = STATE(2494),
    [sym_preproc_line] = STATE(2494),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(4175),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_LPAREN] = ACTIONS(3572),
    [anon_sym_null] = ACTIONS(3574),
    [anon_sym__] = ACTIONS(3576),
    [anon_sym_QMARK] = ACTIONS(4177),
    [anon_sym_COLON_QMARK] = ACTIONS(4179),
    [anon_sym_PIPE] = ACTIONS(4358),
    [anon_sym_LBRACK] = ACTIONS(3582),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3584),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [aux_sym_char_token1] = ACTIONS(3590),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3592),
    [anon_sym_DQUOTE] = ACTIONS(3594),
    [anon_sym_AT_DQUOTE] = ACTIONS(3596),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3598),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3600),
    [sym_bool] = ACTIONS(3602),
    [sym_unit] = ACTIONS(3604),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4181),
    [sym_op_identifier] = ACTIONS(4183),
    [sym_int] = ACTIONS(3610),
    [sym_xint] = ACTIONS(3612),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2495] = {
    [sym_attributes] = STATE(2699),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(4815),
    [sym__pattern] = STATE(5282),
    [sym_optional_pattern] = STATE(4815),
    [sym_type_check_pattern] = STATE(4815),
    [sym_attribute_pattern] = STATE(4815),
    [sym_paren_pattern] = STATE(4815),
    [sym_as_pattern] = STATE(4815),
    [sym_cons_pattern] = STATE(4815),
    [sym_disjunct_pattern] = STATE(4815),
    [sym_conjunct_pattern] = STATE(4815),
    [sym_typed_pattern] = STATE(4815),
    [sym_list_pattern] = STATE(4815),
    [sym_array_pattern] = STATE(4815),
    [sym_record_pattern] = STATE(4815),
    [sym_named_field_pattern] = STATE(4815),
    [sym_identifier_pattern] = STATE(4815),
    [sym_long_identifier_or_op] = STATE(2193),
    [sym_rule] = STATE(5720),
    [sym_rules] = STATE(6714),
    [sym_char] = STATE(4765),
    [sym_format_string] = STATE(4746),
    [sym__string_literal] = STATE(4746),
    [sym_string] = STATE(4765),
    [sym_verbatim_string] = STATE(4765),
    [sym_bytearray] = STATE(4765),
    [sym_verbatim_bytearray] = STATE(4765),
    [sym_format_triple_quoted_string] = STATE(4720),
    [sym_triple_quoted_string] = STATE(4765),
    [sym_const] = STATE(4815),
    [sym_long_identifier] = STATE(3493),
    [sym_active_pattern] = STATE(3613),
    [sym__identifier_or_op] = STATE(3650),
    [sym_sbyte] = STATE(4765),
    [sym_byte] = STATE(4765),
    [sym_int16] = STATE(4765),
    [sym_uint16] = STATE(4765),
    [sym_int32] = STATE(4765),
    [sym_uint32] = STATE(4765),
    [sym_nativeint] = STATE(4765),
    [sym_unativeint] = STATE(4765),
    [sym_int64] = STATE(4765),
    [sym_uint64] = STATE(4765),
    [sym_ieee32] = STATE(4765),
    [sym_ieee64] = STATE(4765),
    [sym_bignum] = STATE(4765),
    [sym_decimal] = STATE(4765),
    [sym_float] = STATE(4512),
    [sym_block_comment] = STATE(2495),
    [sym_compiler_directive_decl] = STATE(2495),
    [sym_fsi_directive_decl] = STATE(2495),
    [sym_preproc_line] = STATE(2495),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(4175),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_LPAREN] = ACTIONS(3572),
    [anon_sym_null] = ACTIONS(3574),
    [anon_sym__] = ACTIONS(3576),
    [anon_sym_QMARK] = ACTIONS(4177),
    [anon_sym_COLON_QMARK] = ACTIONS(4179),
    [anon_sym_PIPE] = ACTIONS(4354),
    [anon_sym_LBRACK] = ACTIONS(3582),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3584),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [aux_sym_char_token1] = ACTIONS(3590),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3592),
    [anon_sym_DQUOTE] = ACTIONS(3594),
    [anon_sym_AT_DQUOTE] = ACTIONS(3596),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3598),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3600),
    [sym_bool] = ACTIONS(3602),
    [sym_unit] = ACTIONS(3604),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4181),
    [sym_op_identifier] = ACTIONS(4183),
    [sym_int] = ACTIONS(3610),
    [sym_xint] = ACTIONS(3612),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2496] = {
    [sym_attributes] = STATE(2699),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(4815),
    [sym__pattern] = STATE(5302),
    [sym_optional_pattern] = STATE(4815),
    [sym_type_check_pattern] = STATE(4815),
    [sym_attribute_pattern] = STATE(4815),
    [sym_paren_pattern] = STATE(4815),
    [sym_as_pattern] = STATE(4815),
    [sym_cons_pattern] = STATE(4815),
    [sym_disjunct_pattern] = STATE(4815),
    [sym_conjunct_pattern] = STATE(4815),
    [sym_typed_pattern] = STATE(4815),
    [sym_list_pattern] = STATE(4815),
    [sym_array_pattern] = STATE(4815),
    [sym_record_pattern] = STATE(4815),
    [sym_named_field_pattern] = STATE(4815),
    [sym_identifier_pattern] = STATE(4815),
    [sym_long_identifier_or_op] = STATE(2193),
    [sym_rule] = STATE(1355),
    [sym_rules] = STATE(1567),
    [sym_char] = STATE(4765),
    [sym_format_string] = STATE(4746),
    [sym__string_literal] = STATE(4746),
    [sym_string] = STATE(4765),
    [sym_verbatim_string] = STATE(4765),
    [sym_bytearray] = STATE(4765),
    [sym_verbatim_bytearray] = STATE(4765),
    [sym_format_triple_quoted_string] = STATE(4720),
    [sym_triple_quoted_string] = STATE(4765),
    [sym_const] = STATE(4815),
    [sym_long_identifier] = STATE(3493),
    [sym_active_pattern] = STATE(3613),
    [sym__identifier_or_op] = STATE(3650),
    [sym_sbyte] = STATE(4765),
    [sym_byte] = STATE(4765),
    [sym_int16] = STATE(4765),
    [sym_uint16] = STATE(4765),
    [sym_int32] = STATE(4765),
    [sym_uint32] = STATE(4765),
    [sym_nativeint] = STATE(4765),
    [sym_unativeint] = STATE(4765),
    [sym_int64] = STATE(4765),
    [sym_uint64] = STATE(4765),
    [sym_ieee32] = STATE(4765),
    [sym_ieee64] = STATE(4765),
    [sym_bignum] = STATE(4765),
    [sym_decimal] = STATE(4765),
    [sym_float] = STATE(4512),
    [sym_block_comment] = STATE(2496),
    [sym_compiler_directive_decl] = STATE(2496),
    [sym_fsi_directive_decl] = STATE(2496),
    [sym_preproc_line] = STATE(2496),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(4175),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_LPAREN] = ACTIONS(3572),
    [anon_sym_null] = ACTIONS(3574),
    [anon_sym__] = ACTIONS(3576),
    [anon_sym_QMARK] = ACTIONS(4177),
    [anon_sym_COLON_QMARK] = ACTIONS(4179),
    [anon_sym_PIPE] = ACTIONS(4360),
    [anon_sym_LBRACK] = ACTIONS(3582),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3584),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [aux_sym_char_token1] = ACTIONS(3590),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3592),
    [anon_sym_DQUOTE] = ACTIONS(3594),
    [anon_sym_AT_DQUOTE] = ACTIONS(3596),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3598),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3600),
    [sym_bool] = ACTIONS(3602),
    [sym_unit] = ACTIONS(3604),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4181),
    [sym_op_identifier] = ACTIONS(4183),
    [sym_int] = ACTIONS(3610),
    [sym_xint] = ACTIONS(3612),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2497] = {
    [sym_attributes] = STATE(2699),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(4815),
    [sym__pattern] = STATE(5302),
    [sym_optional_pattern] = STATE(4815),
    [sym_type_check_pattern] = STATE(4815),
    [sym_attribute_pattern] = STATE(4815),
    [sym_paren_pattern] = STATE(4815),
    [sym_as_pattern] = STATE(4815),
    [sym_cons_pattern] = STATE(4815),
    [sym_disjunct_pattern] = STATE(4815),
    [sym_conjunct_pattern] = STATE(4815),
    [sym_typed_pattern] = STATE(4815),
    [sym_list_pattern] = STATE(4815),
    [sym_array_pattern] = STATE(4815),
    [sym_record_pattern] = STATE(4815),
    [sym_named_field_pattern] = STATE(4815),
    [sym_identifier_pattern] = STATE(4815),
    [sym_long_identifier_or_op] = STATE(2193),
    [sym_rule] = STATE(1355),
    [sym_rules] = STATE(1594),
    [sym_char] = STATE(4765),
    [sym_format_string] = STATE(4746),
    [sym__string_literal] = STATE(4746),
    [sym_string] = STATE(4765),
    [sym_verbatim_string] = STATE(4765),
    [sym_bytearray] = STATE(4765),
    [sym_verbatim_bytearray] = STATE(4765),
    [sym_format_triple_quoted_string] = STATE(4720),
    [sym_triple_quoted_string] = STATE(4765),
    [sym_const] = STATE(4815),
    [sym_long_identifier] = STATE(3493),
    [sym_active_pattern] = STATE(3613),
    [sym__identifier_or_op] = STATE(3650),
    [sym_sbyte] = STATE(4765),
    [sym_byte] = STATE(4765),
    [sym_int16] = STATE(4765),
    [sym_uint16] = STATE(4765),
    [sym_int32] = STATE(4765),
    [sym_uint32] = STATE(4765),
    [sym_nativeint] = STATE(4765),
    [sym_unativeint] = STATE(4765),
    [sym_int64] = STATE(4765),
    [sym_uint64] = STATE(4765),
    [sym_ieee32] = STATE(4765),
    [sym_ieee64] = STATE(4765),
    [sym_bignum] = STATE(4765),
    [sym_decimal] = STATE(4765),
    [sym_float] = STATE(4512),
    [sym_block_comment] = STATE(2497),
    [sym_compiler_directive_decl] = STATE(2497),
    [sym_fsi_directive_decl] = STATE(2497),
    [sym_preproc_line] = STATE(2497),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(4175),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_LPAREN] = ACTIONS(3572),
    [anon_sym_null] = ACTIONS(3574),
    [anon_sym__] = ACTIONS(3576),
    [anon_sym_QMARK] = ACTIONS(4177),
    [anon_sym_COLON_QMARK] = ACTIONS(4179),
    [anon_sym_PIPE] = ACTIONS(4360),
    [anon_sym_LBRACK] = ACTIONS(3582),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3584),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [aux_sym_char_token1] = ACTIONS(3590),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3592),
    [anon_sym_DQUOTE] = ACTIONS(3594),
    [anon_sym_AT_DQUOTE] = ACTIONS(3596),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3598),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3600),
    [sym_bool] = ACTIONS(3602),
    [sym_unit] = ACTIONS(3604),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4181),
    [sym_op_identifier] = ACTIONS(4183),
    [sym_int] = ACTIONS(3610),
    [sym_xint] = ACTIONS(3612),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2498] = {
    [sym_attributes] = STATE(2699),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(4815),
    [sym__pattern] = STATE(5282),
    [sym_optional_pattern] = STATE(4815),
    [sym_type_check_pattern] = STATE(4815),
    [sym_attribute_pattern] = STATE(4815),
    [sym_paren_pattern] = STATE(4815),
    [sym_as_pattern] = STATE(4815),
    [sym_cons_pattern] = STATE(4815),
    [sym_disjunct_pattern] = STATE(4815),
    [sym_conjunct_pattern] = STATE(4815),
    [sym_typed_pattern] = STATE(4815),
    [sym_list_pattern] = STATE(4815),
    [sym_array_pattern] = STATE(4815),
    [sym_record_pattern] = STATE(4815),
    [sym_named_field_pattern] = STATE(4815),
    [sym_identifier_pattern] = STATE(4815),
    [sym_long_identifier_or_op] = STATE(2193),
    [sym_rule] = STATE(5720),
    [sym_rules] = STATE(6435),
    [sym_char] = STATE(4765),
    [sym_format_string] = STATE(4746),
    [sym__string_literal] = STATE(4746),
    [sym_string] = STATE(4765),
    [sym_verbatim_string] = STATE(4765),
    [sym_bytearray] = STATE(4765),
    [sym_verbatim_bytearray] = STATE(4765),
    [sym_format_triple_quoted_string] = STATE(4720),
    [sym_triple_quoted_string] = STATE(4765),
    [sym_const] = STATE(4815),
    [sym_long_identifier] = STATE(3493),
    [sym_active_pattern] = STATE(3613),
    [sym__identifier_or_op] = STATE(3650),
    [sym_sbyte] = STATE(4765),
    [sym_byte] = STATE(4765),
    [sym_int16] = STATE(4765),
    [sym_uint16] = STATE(4765),
    [sym_int32] = STATE(4765),
    [sym_uint32] = STATE(4765),
    [sym_nativeint] = STATE(4765),
    [sym_unativeint] = STATE(4765),
    [sym_int64] = STATE(4765),
    [sym_uint64] = STATE(4765),
    [sym_ieee32] = STATE(4765),
    [sym_ieee64] = STATE(4765),
    [sym_bignum] = STATE(4765),
    [sym_decimal] = STATE(4765),
    [sym_float] = STATE(4512),
    [sym_block_comment] = STATE(2498),
    [sym_compiler_directive_decl] = STATE(2498),
    [sym_fsi_directive_decl] = STATE(2498),
    [sym_preproc_line] = STATE(2498),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(4175),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_LPAREN] = ACTIONS(3572),
    [anon_sym_null] = ACTIONS(3574),
    [anon_sym__] = ACTIONS(3576),
    [anon_sym_QMARK] = ACTIONS(4177),
    [anon_sym_COLON_QMARK] = ACTIONS(4179),
    [anon_sym_PIPE] = ACTIONS(4354),
    [anon_sym_LBRACK] = ACTIONS(3582),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3584),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [aux_sym_char_token1] = ACTIONS(3590),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3592),
    [anon_sym_DQUOTE] = ACTIONS(3594),
    [anon_sym_AT_DQUOTE] = ACTIONS(3596),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3598),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3600),
    [sym_bool] = ACTIONS(3602),
    [sym_unit] = ACTIONS(3604),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4181),
    [sym_op_identifier] = ACTIONS(4183),
    [sym_int] = ACTIONS(3610),
    [sym_xint] = ACTIONS(3612),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2499] = {
    [sym_attributes] = STATE(2699),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(4815),
    [sym__pattern] = STATE(5237),
    [sym_optional_pattern] = STATE(4815),
    [sym_type_check_pattern] = STATE(4815),
    [sym_attribute_pattern] = STATE(4815),
    [sym_paren_pattern] = STATE(4815),
    [sym_as_pattern] = STATE(4815),
    [sym_cons_pattern] = STATE(4815),
    [sym_disjunct_pattern] = STATE(4815),
    [sym_conjunct_pattern] = STATE(4815),
    [sym_typed_pattern] = STATE(4815),
    [sym_list_pattern] = STATE(4815),
    [sym_array_pattern] = STATE(4815),
    [sym_record_pattern] = STATE(4815),
    [sym_named_field_pattern] = STATE(4815),
    [sym_identifier_pattern] = STATE(4815),
    [sym_long_identifier_or_op] = STATE(2193),
    [sym_rule] = STATE(1515),
    [sym_rules] = STATE(2301),
    [sym_char] = STATE(4765),
    [sym_format_string] = STATE(4746),
    [sym__string_literal] = STATE(4746),
    [sym_string] = STATE(4765),
    [sym_verbatim_string] = STATE(4765),
    [sym_bytearray] = STATE(4765),
    [sym_verbatim_bytearray] = STATE(4765),
    [sym_format_triple_quoted_string] = STATE(4720),
    [sym_triple_quoted_string] = STATE(4765),
    [sym_const] = STATE(4815),
    [sym_long_identifier] = STATE(3493),
    [sym_active_pattern] = STATE(3613),
    [sym__identifier_or_op] = STATE(3650),
    [sym_sbyte] = STATE(4765),
    [sym_byte] = STATE(4765),
    [sym_int16] = STATE(4765),
    [sym_uint16] = STATE(4765),
    [sym_int32] = STATE(4765),
    [sym_uint32] = STATE(4765),
    [sym_nativeint] = STATE(4765),
    [sym_unativeint] = STATE(4765),
    [sym_int64] = STATE(4765),
    [sym_uint64] = STATE(4765),
    [sym_ieee32] = STATE(4765),
    [sym_ieee64] = STATE(4765),
    [sym_bignum] = STATE(4765),
    [sym_decimal] = STATE(4765),
    [sym_float] = STATE(4512),
    [sym_block_comment] = STATE(2499),
    [sym_compiler_directive_decl] = STATE(2499),
    [sym_fsi_directive_decl] = STATE(2499),
    [sym_preproc_line] = STATE(2499),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(4175),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_LPAREN] = ACTIONS(3572),
    [anon_sym_null] = ACTIONS(3574),
    [anon_sym__] = ACTIONS(3576),
    [anon_sym_QMARK] = ACTIONS(4177),
    [anon_sym_COLON_QMARK] = ACTIONS(4179),
    [anon_sym_PIPE] = ACTIONS(4356),
    [anon_sym_LBRACK] = ACTIONS(3582),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3584),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [aux_sym_char_token1] = ACTIONS(3590),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3592),
    [anon_sym_DQUOTE] = ACTIONS(3594),
    [anon_sym_AT_DQUOTE] = ACTIONS(3596),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3598),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3600),
    [sym_bool] = ACTIONS(3602),
    [sym_unit] = ACTIONS(3604),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4181),
    [sym_op_identifier] = ACTIONS(4183),
    [sym_int] = ACTIONS(3610),
    [sym_xint] = ACTIONS(3612),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2500] = {
    [sym_attributes] = STATE(2699),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(4815),
    [sym__pattern] = STATE(5282),
    [sym_optional_pattern] = STATE(4815),
    [sym_type_check_pattern] = STATE(4815),
    [sym_attribute_pattern] = STATE(4815),
    [sym_paren_pattern] = STATE(4815),
    [sym_as_pattern] = STATE(4815),
    [sym_cons_pattern] = STATE(4815),
    [sym_disjunct_pattern] = STATE(4815),
    [sym_conjunct_pattern] = STATE(4815),
    [sym_typed_pattern] = STATE(4815),
    [sym_list_pattern] = STATE(4815),
    [sym_array_pattern] = STATE(4815),
    [sym_record_pattern] = STATE(4815),
    [sym_named_field_pattern] = STATE(4815),
    [sym_identifier_pattern] = STATE(4815),
    [sym_long_identifier_or_op] = STATE(2193),
    [sym_rule] = STATE(5720),
    [sym_rules] = STATE(6985),
    [sym_char] = STATE(4765),
    [sym_format_string] = STATE(4746),
    [sym__string_literal] = STATE(4746),
    [sym_string] = STATE(4765),
    [sym_verbatim_string] = STATE(4765),
    [sym_bytearray] = STATE(4765),
    [sym_verbatim_bytearray] = STATE(4765),
    [sym_format_triple_quoted_string] = STATE(4720),
    [sym_triple_quoted_string] = STATE(4765),
    [sym_const] = STATE(4815),
    [sym_long_identifier] = STATE(3493),
    [sym_active_pattern] = STATE(3613),
    [sym__identifier_or_op] = STATE(3650),
    [sym_sbyte] = STATE(4765),
    [sym_byte] = STATE(4765),
    [sym_int16] = STATE(4765),
    [sym_uint16] = STATE(4765),
    [sym_int32] = STATE(4765),
    [sym_uint32] = STATE(4765),
    [sym_nativeint] = STATE(4765),
    [sym_unativeint] = STATE(4765),
    [sym_int64] = STATE(4765),
    [sym_uint64] = STATE(4765),
    [sym_ieee32] = STATE(4765),
    [sym_ieee64] = STATE(4765),
    [sym_bignum] = STATE(4765),
    [sym_decimal] = STATE(4765),
    [sym_float] = STATE(4512),
    [sym_block_comment] = STATE(2500),
    [sym_compiler_directive_decl] = STATE(2500),
    [sym_fsi_directive_decl] = STATE(2500),
    [sym_preproc_line] = STATE(2500),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(4175),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_LPAREN] = ACTIONS(3572),
    [anon_sym_null] = ACTIONS(3574),
    [anon_sym__] = ACTIONS(3576),
    [anon_sym_QMARK] = ACTIONS(4177),
    [anon_sym_COLON_QMARK] = ACTIONS(4179),
    [anon_sym_PIPE] = ACTIONS(4354),
    [anon_sym_LBRACK] = ACTIONS(3582),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3584),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [aux_sym_char_token1] = ACTIONS(3590),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3592),
    [anon_sym_DQUOTE] = ACTIONS(3594),
    [anon_sym_AT_DQUOTE] = ACTIONS(3596),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3598),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3600),
    [sym_bool] = ACTIONS(3602),
    [sym_unit] = ACTIONS(3604),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4181),
    [sym_op_identifier] = ACTIONS(4183),
    [sym_int] = ACTIONS(3610),
    [sym_xint] = ACTIONS(3612),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2501] = {
    [sym_attributes] = STATE(2699),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(4815),
    [sym__pattern] = STATE(5302),
    [sym_optional_pattern] = STATE(4815),
    [sym_type_check_pattern] = STATE(4815),
    [sym_attribute_pattern] = STATE(4815),
    [sym_paren_pattern] = STATE(4815),
    [sym_as_pattern] = STATE(4815),
    [sym_cons_pattern] = STATE(4815),
    [sym_disjunct_pattern] = STATE(4815),
    [sym_conjunct_pattern] = STATE(4815),
    [sym_typed_pattern] = STATE(4815),
    [sym_list_pattern] = STATE(4815),
    [sym_array_pattern] = STATE(4815),
    [sym_record_pattern] = STATE(4815),
    [sym_named_field_pattern] = STATE(4815),
    [sym_identifier_pattern] = STATE(4815),
    [sym_long_identifier_or_op] = STATE(2193),
    [sym_rule] = STATE(1355),
    [sym_rules] = STATE(1596),
    [sym_char] = STATE(4765),
    [sym_format_string] = STATE(4746),
    [sym__string_literal] = STATE(4746),
    [sym_string] = STATE(4765),
    [sym_verbatim_string] = STATE(4765),
    [sym_bytearray] = STATE(4765),
    [sym_verbatim_bytearray] = STATE(4765),
    [sym_format_triple_quoted_string] = STATE(4720),
    [sym_triple_quoted_string] = STATE(4765),
    [sym_const] = STATE(4815),
    [sym_long_identifier] = STATE(3493),
    [sym_active_pattern] = STATE(3613),
    [sym__identifier_or_op] = STATE(3650),
    [sym_sbyte] = STATE(4765),
    [sym_byte] = STATE(4765),
    [sym_int16] = STATE(4765),
    [sym_uint16] = STATE(4765),
    [sym_int32] = STATE(4765),
    [sym_uint32] = STATE(4765),
    [sym_nativeint] = STATE(4765),
    [sym_unativeint] = STATE(4765),
    [sym_int64] = STATE(4765),
    [sym_uint64] = STATE(4765),
    [sym_ieee32] = STATE(4765),
    [sym_ieee64] = STATE(4765),
    [sym_bignum] = STATE(4765),
    [sym_decimal] = STATE(4765),
    [sym_float] = STATE(4512),
    [sym_block_comment] = STATE(2501),
    [sym_compiler_directive_decl] = STATE(2501),
    [sym_fsi_directive_decl] = STATE(2501),
    [sym_preproc_line] = STATE(2501),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(4175),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_LPAREN] = ACTIONS(3572),
    [anon_sym_null] = ACTIONS(3574),
    [anon_sym__] = ACTIONS(3576),
    [anon_sym_QMARK] = ACTIONS(4177),
    [anon_sym_COLON_QMARK] = ACTIONS(4179),
    [anon_sym_PIPE] = ACTIONS(4360),
    [anon_sym_LBRACK] = ACTIONS(3582),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3584),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [aux_sym_char_token1] = ACTIONS(3590),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3592),
    [anon_sym_DQUOTE] = ACTIONS(3594),
    [anon_sym_AT_DQUOTE] = ACTIONS(3596),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3598),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3600),
    [sym_bool] = ACTIONS(3602),
    [sym_unit] = ACTIONS(3604),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4181),
    [sym_op_identifier] = ACTIONS(4183),
    [sym_int] = ACTIONS(3610),
    [sym_xint] = ACTIONS(3612),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2502] = {
    [sym_attributes] = STATE(2699),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(4815),
    [sym__pattern] = STATE(5302),
    [sym_optional_pattern] = STATE(4815),
    [sym_type_check_pattern] = STATE(4815),
    [sym_attribute_pattern] = STATE(4815),
    [sym_paren_pattern] = STATE(4815),
    [sym_as_pattern] = STATE(4815),
    [sym_cons_pattern] = STATE(4815),
    [sym_disjunct_pattern] = STATE(4815),
    [sym_conjunct_pattern] = STATE(4815),
    [sym_typed_pattern] = STATE(4815),
    [sym_list_pattern] = STATE(4815),
    [sym_array_pattern] = STATE(4815),
    [sym_record_pattern] = STATE(4815),
    [sym_named_field_pattern] = STATE(4815),
    [sym_identifier_pattern] = STATE(4815),
    [sym_long_identifier_or_op] = STATE(2193),
    [sym_rule] = STATE(1355),
    [sym_rules] = STATE(1608),
    [sym_char] = STATE(4765),
    [sym_format_string] = STATE(4746),
    [sym__string_literal] = STATE(4746),
    [sym_string] = STATE(4765),
    [sym_verbatim_string] = STATE(4765),
    [sym_bytearray] = STATE(4765),
    [sym_verbatim_bytearray] = STATE(4765),
    [sym_format_triple_quoted_string] = STATE(4720),
    [sym_triple_quoted_string] = STATE(4765),
    [sym_const] = STATE(4815),
    [sym_long_identifier] = STATE(3493),
    [sym_active_pattern] = STATE(3613),
    [sym__identifier_or_op] = STATE(3650),
    [sym_sbyte] = STATE(4765),
    [sym_byte] = STATE(4765),
    [sym_int16] = STATE(4765),
    [sym_uint16] = STATE(4765),
    [sym_int32] = STATE(4765),
    [sym_uint32] = STATE(4765),
    [sym_nativeint] = STATE(4765),
    [sym_unativeint] = STATE(4765),
    [sym_int64] = STATE(4765),
    [sym_uint64] = STATE(4765),
    [sym_ieee32] = STATE(4765),
    [sym_ieee64] = STATE(4765),
    [sym_bignum] = STATE(4765),
    [sym_decimal] = STATE(4765),
    [sym_float] = STATE(4512),
    [sym_block_comment] = STATE(2502),
    [sym_compiler_directive_decl] = STATE(2502),
    [sym_fsi_directive_decl] = STATE(2502),
    [sym_preproc_line] = STATE(2502),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(4175),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_LPAREN] = ACTIONS(3572),
    [anon_sym_null] = ACTIONS(3574),
    [anon_sym__] = ACTIONS(3576),
    [anon_sym_QMARK] = ACTIONS(4177),
    [anon_sym_COLON_QMARK] = ACTIONS(4179),
    [anon_sym_PIPE] = ACTIONS(4360),
    [anon_sym_LBRACK] = ACTIONS(3582),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3584),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [aux_sym_char_token1] = ACTIONS(3590),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3592),
    [anon_sym_DQUOTE] = ACTIONS(3594),
    [anon_sym_AT_DQUOTE] = ACTIONS(3596),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3598),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3600),
    [sym_bool] = ACTIONS(3602),
    [sym_unit] = ACTIONS(3604),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4181),
    [sym_op_identifier] = ACTIONS(4183),
    [sym_int] = ACTIONS(3610),
    [sym_xint] = ACTIONS(3612),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2503] = {
    [sym_attributes] = STATE(2699),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(4815),
    [sym__pattern] = STATE(5419),
    [sym_optional_pattern] = STATE(4815),
    [sym_type_check_pattern] = STATE(4815),
    [sym_attribute_pattern] = STATE(4815),
    [sym_paren_pattern] = STATE(4815),
    [sym_as_pattern] = STATE(4815),
    [sym_cons_pattern] = STATE(4815),
    [sym_disjunct_pattern] = STATE(4815),
    [sym_conjunct_pattern] = STATE(4815),
    [sym_typed_pattern] = STATE(4815),
    [sym_list_pattern] = STATE(4815),
    [sym_array_pattern] = STATE(4815),
    [sym_record_pattern] = STATE(4815),
    [sym_named_field_pattern] = STATE(4815),
    [sym_identifier_pattern] = STATE(4815),
    [sym_long_identifier_or_op] = STATE(2193),
    [sym_rule] = STATE(1413),
    [sym_rules] = STATE(1781),
    [sym_char] = STATE(4765),
    [sym_format_string] = STATE(4746),
    [sym__string_literal] = STATE(4746),
    [sym_string] = STATE(4765),
    [sym_verbatim_string] = STATE(4765),
    [sym_bytearray] = STATE(4765),
    [sym_verbatim_bytearray] = STATE(4765),
    [sym_format_triple_quoted_string] = STATE(4720),
    [sym_triple_quoted_string] = STATE(4765),
    [sym_const] = STATE(4815),
    [sym_long_identifier] = STATE(3493),
    [sym_active_pattern] = STATE(3613),
    [sym__identifier_or_op] = STATE(3650),
    [sym_sbyte] = STATE(4765),
    [sym_byte] = STATE(4765),
    [sym_int16] = STATE(4765),
    [sym_uint16] = STATE(4765),
    [sym_int32] = STATE(4765),
    [sym_uint32] = STATE(4765),
    [sym_nativeint] = STATE(4765),
    [sym_unativeint] = STATE(4765),
    [sym_int64] = STATE(4765),
    [sym_uint64] = STATE(4765),
    [sym_ieee32] = STATE(4765),
    [sym_ieee64] = STATE(4765),
    [sym_bignum] = STATE(4765),
    [sym_decimal] = STATE(4765),
    [sym_float] = STATE(4512),
    [sym_block_comment] = STATE(2503),
    [sym_compiler_directive_decl] = STATE(2503),
    [sym_fsi_directive_decl] = STATE(2503),
    [sym_preproc_line] = STATE(2503),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(4175),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_LPAREN] = ACTIONS(3572),
    [anon_sym_null] = ACTIONS(3574),
    [anon_sym__] = ACTIONS(3576),
    [anon_sym_QMARK] = ACTIONS(4177),
    [anon_sym_COLON_QMARK] = ACTIONS(4179),
    [anon_sym_PIPE] = ACTIONS(4362),
    [anon_sym_LBRACK] = ACTIONS(3582),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3584),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [aux_sym_char_token1] = ACTIONS(3590),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3592),
    [anon_sym_DQUOTE] = ACTIONS(3594),
    [anon_sym_AT_DQUOTE] = ACTIONS(3596),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3598),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3600),
    [sym_bool] = ACTIONS(3602),
    [sym_unit] = ACTIONS(3604),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4181),
    [sym_op_identifier] = ACTIONS(4183),
    [sym_int] = ACTIONS(3610),
    [sym_xint] = ACTIONS(3612),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2504] = {
    [sym_attributes] = STATE(2699),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(4815),
    [sym__pattern] = STATE(5419),
    [sym_optional_pattern] = STATE(4815),
    [sym_type_check_pattern] = STATE(4815),
    [sym_attribute_pattern] = STATE(4815),
    [sym_paren_pattern] = STATE(4815),
    [sym_as_pattern] = STATE(4815),
    [sym_cons_pattern] = STATE(4815),
    [sym_disjunct_pattern] = STATE(4815),
    [sym_conjunct_pattern] = STATE(4815),
    [sym_typed_pattern] = STATE(4815),
    [sym_list_pattern] = STATE(4815),
    [sym_array_pattern] = STATE(4815),
    [sym_record_pattern] = STATE(4815),
    [sym_named_field_pattern] = STATE(4815),
    [sym_identifier_pattern] = STATE(4815),
    [sym_long_identifier_or_op] = STATE(2193),
    [sym_rule] = STATE(1413),
    [sym_rules] = STATE(1770),
    [sym_char] = STATE(4765),
    [sym_format_string] = STATE(4746),
    [sym__string_literal] = STATE(4746),
    [sym_string] = STATE(4765),
    [sym_verbatim_string] = STATE(4765),
    [sym_bytearray] = STATE(4765),
    [sym_verbatim_bytearray] = STATE(4765),
    [sym_format_triple_quoted_string] = STATE(4720),
    [sym_triple_quoted_string] = STATE(4765),
    [sym_const] = STATE(4815),
    [sym_long_identifier] = STATE(3493),
    [sym_active_pattern] = STATE(3613),
    [sym__identifier_or_op] = STATE(3650),
    [sym_sbyte] = STATE(4765),
    [sym_byte] = STATE(4765),
    [sym_int16] = STATE(4765),
    [sym_uint16] = STATE(4765),
    [sym_int32] = STATE(4765),
    [sym_uint32] = STATE(4765),
    [sym_nativeint] = STATE(4765),
    [sym_unativeint] = STATE(4765),
    [sym_int64] = STATE(4765),
    [sym_uint64] = STATE(4765),
    [sym_ieee32] = STATE(4765),
    [sym_ieee64] = STATE(4765),
    [sym_bignum] = STATE(4765),
    [sym_decimal] = STATE(4765),
    [sym_float] = STATE(4512),
    [sym_block_comment] = STATE(2504),
    [sym_compiler_directive_decl] = STATE(2504),
    [sym_fsi_directive_decl] = STATE(2504),
    [sym_preproc_line] = STATE(2504),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(4175),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_LPAREN] = ACTIONS(3572),
    [anon_sym_null] = ACTIONS(3574),
    [anon_sym__] = ACTIONS(3576),
    [anon_sym_QMARK] = ACTIONS(4177),
    [anon_sym_COLON_QMARK] = ACTIONS(4179),
    [anon_sym_PIPE] = ACTIONS(4362),
    [anon_sym_LBRACK] = ACTIONS(3582),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3584),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [aux_sym_char_token1] = ACTIONS(3590),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3592),
    [anon_sym_DQUOTE] = ACTIONS(3594),
    [anon_sym_AT_DQUOTE] = ACTIONS(3596),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3598),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3600),
    [sym_bool] = ACTIONS(3602),
    [sym_unit] = ACTIONS(3604),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4181),
    [sym_op_identifier] = ACTIONS(4183),
    [sym_int] = ACTIONS(3610),
    [sym_xint] = ACTIONS(3612),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2505] = {
    [sym_attributes] = STATE(2699),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(4815),
    [sym__pattern] = STATE(5212),
    [sym_optional_pattern] = STATE(4815),
    [sym_type_check_pattern] = STATE(4815),
    [sym_attribute_pattern] = STATE(4815),
    [sym_paren_pattern] = STATE(4815),
    [sym_as_pattern] = STATE(4815),
    [sym_cons_pattern] = STATE(4815),
    [sym_disjunct_pattern] = STATE(4815),
    [sym_conjunct_pattern] = STATE(4815),
    [sym_typed_pattern] = STATE(4815),
    [sym_list_pattern] = STATE(4815),
    [sym_array_pattern] = STATE(4815),
    [sym_record_pattern] = STATE(4815),
    [sym_named_field_pattern] = STATE(4815),
    [sym_identifier_pattern] = STATE(4815),
    [sym_long_identifier_or_op] = STATE(2193),
    [sym_rule] = STATE(1497),
    [sym_rules] = STATE(2308),
    [sym_char] = STATE(4765),
    [sym_format_string] = STATE(4746),
    [sym__string_literal] = STATE(4746),
    [sym_string] = STATE(4765),
    [sym_verbatim_string] = STATE(4765),
    [sym_bytearray] = STATE(4765),
    [sym_verbatim_bytearray] = STATE(4765),
    [sym_format_triple_quoted_string] = STATE(4720),
    [sym_triple_quoted_string] = STATE(4765),
    [sym_const] = STATE(4815),
    [sym_long_identifier] = STATE(3493),
    [sym_active_pattern] = STATE(3613),
    [sym__identifier_or_op] = STATE(3650),
    [sym_sbyte] = STATE(4765),
    [sym_byte] = STATE(4765),
    [sym_int16] = STATE(4765),
    [sym_uint16] = STATE(4765),
    [sym_int32] = STATE(4765),
    [sym_uint32] = STATE(4765),
    [sym_nativeint] = STATE(4765),
    [sym_unativeint] = STATE(4765),
    [sym_int64] = STATE(4765),
    [sym_uint64] = STATE(4765),
    [sym_ieee32] = STATE(4765),
    [sym_ieee64] = STATE(4765),
    [sym_bignum] = STATE(4765),
    [sym_decimal] = STATE(4765),
    [sym_float] = STATE(4512),
    [sym_block_comment] = STATE(2505),
    [sym_compiler_directive_decl] = STATE(2505),
    [sym_fsi_directive_decl] = STATE(2505),
    [sym_preproc_line] = STATE(2505),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(4175),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_LPAREN] = ACTIONS(3572),
    [anon_sym_null] = ACTIONS(3574),
    [anon_sym__] = ACTIONS(3576),
    [anon_sym_QMARK] = ACTIONS(4177),
    [anon_sym_COLON_QMARK] = ACTIONS(4179),
    [anon_sym_PIPE] = ACTIONS(4364),
    [anon_sym_LBRACK] = ACTIONS(3582),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3584),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [aux_sym_char_token1] = ACTIONS(3590),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3592),
    [anon_sym_DQUOTE] = ACTIONS(3594),
    [anon_sym_AT_DQUOTE] = ACTIONS(3596),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3598),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3600),
    [sym_bool] = ACTIONS(3602),
    [sym_unit] = ACTIONS(3604),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4181),
    [sym_op_identifier] = ACTIONS(4183),
    [sym_int] = ACTIONS(3610),
    [sym_xint] = ACTIONS(3612),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2506] = {
    [sym_attributes] = STATE(2699),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(4815),
    [sym__pattern] = STATE(5282),
    [sym_optional_pattern] = STATE(4815),
    [sym_type_check_pattern] = STATE(4815),
    [sym_attribute_pattern] = STATE(4815),
    [sym_paren_pattern] = STATE(4815),
    [sym_as_pattern] = STATE(4815),
    [sym_cons_pattern] = STATE(4815),
    [sym_disjunct_pattern] = STATE(4815),
    [sym_conjunct_pattern] = STATE(4815),
    [sym_typed_pattern] = STATE(4815),
    [sym_list_pattern] = STATE(4815),
    [sym_array_pattern] = STATE(4815),
    [sym_record_pattern] = STATE(4815),
    [sym_named_field_pattern] = STATE(4815),
    [sym_identifier_pattern] = STATE(4815),
    [sym_long_identifier_or_op] = STATE(2193),
    [sym_rule] = STATE(5720),
    [sym_rules] = STATE(6905),
    [sym_char] = STATE(4765),
    [sym_format_string] = STATE(4746),
    [sym__string_literal] = STATE(4746),
    [sym_string] = STATE(4765),
    [sym_verbatim_string] = STATE(4765),
    [sym_bytearray] = STATE(4765),
    [sym_verbatim_bytearray] = STATE(4765),
    [sym_format_triple_quoted_string] = STATE(4720),
    [sym_triple_quoted_string] = STATE(4765),
    [sym_const] = STATE(4815),
    [sym_long_identifier] = STATE(3493),
    [sym_active_pattern] = STATE(3613),
    [sym__identifier_or_op] = STATE(3650),
    [sym_sbyte] = STATE(4765),
    [sym_byte] = STATE(4765),
    [sym_int16] = STATE(4765),
    [sym_uint16] = STATE(4765),
    [sym_int32] = STATE(4765),
    [sym_uint32] = STATE(4765),
    [sym_nativeint] = STATE(4765),
    [sym_unativeint] = STATE(4765),
    [sym_int64] = STATE(4765),
    [sym_uint64] = STATE(4765),
    [sym_ieee32] = STATE(4765),
    [sym_ieee64] = STATE(4765),
    [sym_bignum] = STATE(4765),
    [sym_decimal] = STATE(4765),
    [sym_float] = STATE(4512),
    [sym_block_comment] = STATE(2506),
    [sym_compiler_directive_decl] = STATE(2506),
    [sym_fsi_directive_decl] = STATE(2506),
    [sym_preproc_line] = STATE(2506),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(4175),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_LPAREN] = ACTIONS(3572),
    [anon_sym_null] = ACTIONS(3574),
    [anon_sym__] = ACTIONS(3576),
    [anon_sym_QMARK] = ACTIONS(4177),
    [anon_sym_COLON_QMARK] = ACTIONS(4179),
    [anon_sym_PIPE] = ACTIONS(4354),
    [anon_sym_LBRACK] = ACTIONS(3582),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3584),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [aux_sym_char_token1] = ACTIONS(3590),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3592),
    [anon_sym_DQUOTE] = ACTIONS(3594),
    [anon_sym_AT_DQUOTE] = ACTIONS(3596),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3598),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3600),
    [sym_bool] = ACTIONS(3602),
    [sym_unit] = ACTIONS(3604),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4181),
    [sym_op_identifier] = ACTIONS(4183),
    [sym_int] = ACTIONS(3610),
    [sym_xint] = ACTIONS(3612),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2507] = {
    [sym_attributes] = STATE(2699),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(4815),
    [sym__pattern] = STATE(5196),
    [sym_optional_pattern] = STATE(4815),
    [sym_type_check_pattern] = STATE(4815),
    [sym_attribute_pattern] = STATE(4815),
    [sym_paren_pattern] = STATE(4815),
    [sym_as_pattern] = STATE(4815),
    [sym_cons_pattern] = STATE(4815),
    [sym_disjunct_pattern] = STATE(4815),
    [sym_conjunct_pattern] = STATE(4815),
    [sym_typed_pattern] = STATE(4815),
    [sym_list_pattern] = STATE(4815),
    [sym_array_pattern] = STATE(4815),
    [sym_record_pattern] = STATE(4815),
    [sym_named_field_pattern] = STATE(4815),
    [sym_identifier_pattern] = STATE(4815),
    [sym_long_identifier_or_op] = STATE(2193),
    [sym_rule] = STATE(821),
    [sym_rules] = STATE(928),
    [sym_char] = STATE(4765),
    [sym_format_string] = STATE(4746),
    [sym__string_literal] = STATE(4746),
    [sym_string] = STATE(4765),
    [sym_verbatim_string] = STATE(4765),
    [sym_bytearray] = STATE(4765),
    [sym_verbatim_bytearray] = STATE(4765),
    [sym_format_triple_quoted_string] = STATE(4720),
    [sym_triple_quoted_string] = STATE(4765),
    [sym_const] = STATE(4815),
    [sym_long_identifier] = STATE(3493),
    [sym_active_pattern] = STATE(3613),
    [sym__identifier_or_op] = STATE(3650),
    [sym_sbyte] = STATE(4765),
    [sym_byte] = STATE(4765),
    [sym_int16] = STATE(4765),
    [sym_uint16] = STATE(4765),
    [sym_int32] = STATE(4765),
    [sym_uint32] = STATE(4765),
    [sym_nativeint] = STATE(4765),
    [sym_unativeint] = STATE(4765),
    [sym_int64] = STATE(4765),
    [sym_uint64] = STATE(4765),
    [sym_ieee32] = STATE(4765),
    [sym_ieee64] = STATE(4765),
    [sym_bignum] = STATE(4765),
    [sym_decimal] = STATE(4765),
    [sym_float] = STATE(4512),
    [sym_block_comment] = STATE(2507),
    [sym_compiler_directive_decl] = STATE(2507),
    [sym_fsi_directive_decl] = STATE(2507),
    [sym_preproc_line] = STATE(2507),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(4175),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_LPAREN] = ACTIONS(3572),
    [anon_sym_null] = ACTIONS(3574),
    [anon_sym__] = ACTIONS(3576),
    [anon_sym_QMARK] = ACTIONS(4177),
    [anon_sym_COLON_QMARK] = ACTIONS(4179),
    [anon_sym_PIPE] = ACTIONS(4352),
    [anon_sym_LBRACK] = ACTIONS(3582),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3584),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [aux_sym_char_token1] = ACTIONS(3590),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3592),
    [anon_sym_DQUOTE] = ACTIONS(3594),
    [anon_sym_AT_DQUOTE] = ACTIONS(3596),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3598),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3600),
    [sym_bool] = ACTIONS(3602),
    [sym_unit] = ACTIONS(3604),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4181),
    [sym_op_identifier] = ACTIONS(4183),
    [sym_int] = ACTIONS(3610),
    [sym_xint] = ACTIONS(3612),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2508] = {
    [sym_attributes] = STATE(2699),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(4815),
    [sym__pattern] = STATE(5419),
    [sym_optional_pattern] = STATE(4815),
    [sym_type_check_pattern] = STATE(4815),
    [sym_attribute_pattern] = STATE(4815),
    [sym_paren_pattern] = STATE(4815),
    [sym_as_pattern] = STATE(4815),
    [sym_cons_pattern] = STATE(4815),
    [sym_disjunct_pattern] = STATE(4815),
    [sym_conjunct_pattern] = STATE(4815),
    [sym_typed_pattern] = STATE(4815),
    [sym_list_pattern] = STATE(4815),
    [sym_array_pattern] = STATE(4815),
    [sym_record_pattern] = STATE(4815),
    [sym_named_field_pattern] = STATE(4815),
    [sym_identifier_pattern] = STATE(4815),
    [sym_long_identifier_or_op] = STATE(2193),
    [sym_rule] = STATE(1413),
    [sym_rules] = STATE(1769),
    [sym_char] = STATE(4765),
    [sym_format_string] = STATE(4746),
    [sym__string_literal] = STATE(4746),
    [sym_string] = STATE(4765),
    [sym_verbatim_string] = STATE(4765),
    [sym_bytearray] = STATE(4765),
    [sym_verbatim_bytearray] = STATE(4765),
    [sym_format_triple_quoted_string] = STATE(4720),
    [sym_triple_quoted_string] = STATE(4765),
    [sym_const] = STATE(4815),
    [sym_long_identifier] = STATE(3493),
    [sym_active_pattern] = STATE(3613),
    [sym__identifier_or_op] = STATE(3650),
    [sym_sbyte] = STATE(4765),
    [sym_byte] = STATE(4765),
    [sym_int16] = STATE(4765),
    [sym_uint16] = STATE(4765),
    [sym_int32] = STATE(4765),
    [sym_uint32] = STATE(4765),
    [sym_nativeint] = STATE(4765),
    [sym_unativeint] = STATE(4765),
    [sym_int64] = STATE(4765),
    [sym_uint64] = STATE(4765),
    [sym_ieee32] = STATE(4765),
    [sym_ieee64] = STATE(4765),
    [sym_bignum] = STATE(4765),
    [sym_decimal] = STATE(4765),
    [sym_float] = STATE(4512),
    [sym_block_comment] = STATE(2508),
    [sym_compiler_directive_decl] = STATE(2508),
    [sym_fsi_directive_decl] = STATE(2508),
    [sym_preproc_line] = STATE(2508),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(4175),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_LPAREN] = ACTIONS(3572),
    [anon_sym_null] = ACTIONS(3574),
    [anon_sym__] = ACTIONS(3576),
    [anon_sym_QMARK] = ACTIONS(4177),
    [anon_sym_COLON_QMARK] = ACTIONS(4179),
    [anon_sym_PIPE] = ACTIONS(4362),
    [anon_sym_LBRACK] = ACTIONS(3582),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3584),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [aux_sym_char_token1] = ACTIONS(3590),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3592),
    [anon_sym_DQUOTE] = ACTIONS(3594),
    [anon_sym_AT_DQUOTE] = ACTIONS(3596),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3598),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3600),
    [sym_bool] = ACTIONS(3602),
    [sym_unit] = ACTIONS(3604),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4181),
    [sym_op_identifier] = ACTIONS(4183),
    [sym_int] = ACTIONS(3610),
    [sym_xint] = ACTIONS(3612),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2509] = {
    [sym_attributes] = STATE(2699),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(4815),
    [sym__pattern] = STATE(5282),
    [sym_optional_pattern] = STATE(4815),
    [sym_type_check_pattern] = STATE(4815),
    [sym_attribute_pattern] = STATE(4815),
    [sym_paren_pattern] = STATE(4815),
    [sym_as_pattern] = STATE(4815),
    [sym_cons_pattern] = STATE(4815),
    [sym_disjunct_pattern] = STATE(4815),
    [sym_conjunct_pattern] = STATE(4815),
    [sym_typed_pattern] = STATE(4815),
    [sym_list_pattern] = STATE(4815),
    [sym_array_pattern] = STATE(4815),
    [sym_record_pattern] = STATE(4815),
    [sym_named_field_pattern] = STATE(4815),
    [sym_identifier_pattern] = STATE(4815),
    [sym_long_identifier_or_op] = STATE(2193),
    [sym_rule] = STATE(5720),
    [sym_rules] = STATE(7253),
    [sym_char] = STATE(4765),
    [sym_format_string] = STATE(4746),
    [sym__string_literal] = STATE(4746),
    [sym_string] = STATE(4765),
    [sym_verbatim_string] = STATE(4765),
    [sym_bytearray] = STATE(4765),
    [sym_verbatim_bytearray] = STATE(4765),
    [sym_format_triple_quoted_string] = STATE(4720),
    [sym_triple_quoted_string] = STATE(4765),
    [sym_const] = STATE(4815),
    [sym_long_identifier] = STATE(3493),
    [sym_active_pattern] = STATE(3613),
    [sym__identifier_or_op] = STATE(3650),
    [sym_sbyte] = STATE(4765),
    [sym_byte] = STATE(4765),
    [sym_int16] = STATE(4765),
    [sym_uint16] = STATE(4765),
    [sym_int32] = STATE(4765),
    [sym_uint32] = STATE(4765),
    [sym_nativeint] = STATE(4765),
    [sym_unativeint] = STATE(4765),
    [sym_int64] = STATE(4765),
    [sym_uint64] = STATE(4765),
    [sym_ieee32] = STATE(4765),
    [sym_ieee64] = STATE(4765),
    [sym_bignum] = STATE(4765),
    [sym_decimal] = STATE(4765),
    [sym_float] = STATE(4512),
    [sym_block_comment] = STATE(2509),
    [sym_compiler_directive_decl] = STATE(2509),
    [sym_fsi_directive_decl] = STATE(2509),
    [sym_preproc_line] = STATE(2509),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(4175),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_LPAREN] = ACTIONS(3572),
    [anon_sym_null] = ACTIONS(3574),
    [anon_sym__] = ACTIONS(3576),
    [anon_sym_QMARK] = ACTIONS(4177),
    [anon_sym_COLON_QMARK] = ACTIONS(4179),
    [anon_sym_PIPE] = ACTIONS(4354),
    [anon_sym_LBRACK] = ACTIONS(3582),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3584),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [aux_sym_char_token1] = ACTIONS(3590),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3592),
    [anon_sym_DQUOTE] = ACTIONS(3594),
    [anon_sym_AT_DQUOTE] = ACTIONS(3596),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3598),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3600),
    [sym_bool] = ACTIONS(3602),
    [sym_unit] = ACTIONS(3604),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4181),
    [sym_op_identifier] = ACTIONS(4183),
    [sym_int] = ACTIONS(3610),
    [sym_xint] = ACTIONS(3612),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2510] = {
    [sym_attributes] = STATE(2699),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(4815),
    [sym__pattern] = STATE(5419),
    [sym_optional_pattern] = STATE(4815),
    [sym_type_check_pattern] = STATE(4815),
    [sym_attribute_pattern] = STATE(4815),
    [sym_paren_pattern] = STATE(4815),
    [sym_as_pattern] = STATE(4815),
    [sym_cons_pattern] = STATE(4815),
    [sym_disjunct_pattern] = STATE(4815),
    [sym_conjunct_pattern] = STATE(4815),
    [sym_typed_pattern] = STATE(4815),
    [sym_list_pattern] = STATE(4815),
    [sym_array_pattern] = STATE(4815),
    [sym_record_pattern] = STATE(4815),
    [sym_named_field_pattern] = STATE(4815),
    [sym_identifier_pattern] = STATE(4815),
    [sym_long_identifier_or_op] = STATE(2193),
    [sym_rule] = STATE(1413),
    [sym_rules] = STATE(1762),
    [sym_char] = STATE(4765),
    [sym_format_string] = STATE(4746),
    [sym__string_literal] = STATE(4746),
    [sym_string] = STATE(4765),
    [sym_verbatim_string] = STATE(4765),
    [sym_bytearray] = STATE(4765),
    [sym_verbatim_bytearray] = STATE(4765),
    [sym_format_triple_quoted_string] = STATE(4720),
    [sym_triple_quoted_string] = STATE(4765),
    [sym_const] = STATE(4815),
    [sym_long_identifier] = STATE(3493),
    [sym_active_pattern] = STATE(3613),
    [sym__identifier_or_op] = STATE(3650),
    [sym_sbyte] = STATE(4765),
    [sym_byte] = STATE(4765),
    [sym_int16] = STATE(4765),
    [sym_uint16] = STATE(4765),
    [sym_int32] = STATE(4765),
    [sym_uint32] = STATE(4765),
    [sym_nativeint] = STATE(4765),
    [sym_unativeint] = STATE(4765),
    [sym_int64] = STATE(4765),
    [sym_uint64] = STATE(4765),
    [sym_ieee32] = STATE(4765),
    [sym_ieee64] = STATE(4765),
    [sym_bignum] = STATE(4765),
    [sym_decimal] = STATE(4765),
    [sym_float] = STATE(4512),
    [sym_block_comment] = STATE(2510),
    [sym_compiler_directive_decl] = STATE(2510),
    [sym_fsi_directive_decl] = STATE(2510),
    [sym_preproc_line] = STATE(2510),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(4175),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_LPAREN] = ACTIONS(3572),
    [anon_sym_null] = ACTIONS(3574),
    [anon_sym__] = ACTIONS(3576),
    [anon_sym_QMARK] = ACTIONS(4177),
    [anon_sym_COLON_QMARK] = ACTIONS(4179),
    [anon_sym_PIPE] = ACTIONS(4362),
    [anon_sym_LBRACK] = ACTIONS(3582),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3584),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [aux_sym_char_token1] = ACTIONS(3590),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3592),
    [anon_sym_DQUOTE] = ACTIONS(3594),
    [anon_sym_AT_DQUOTE] = ACTIONS(3596),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3598),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3600),
    [sym_bool] = ACTIONS(3602),
    [sym_unit] = ACTIONS(3604),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4181),
    [sym_op_identifier] = ACTIONS(4183),
    [sym_int] = ACTIONS(3610),
    [sym_xint] = ACTIONS(3612),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2511] = {
    [sym_attributes] = STATE(2699),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(4815),
    [sym__pattern] = STATE(5237),
    [sym_optional_pattern] = STATE(4815),
    [sym_type_check_pattern] = STATE(4815),
    [sym_attribute_pattern] = STATE(4815),
    [sym_paren_pattern] = STATE(4815),
    [sym_as_pattern] = STATE(4815),
    [sym_cons_pattern] = STATE(4815),
    [sym_disjunct_pattern] = STATE(4815),
    [sym_conjunct_pattern] = STATE(4815),
    [sym_typed_pattern] = STATE(4815),
    [sym_list_pattern] = STATE(4815),
    [sym_array_pattern] = STATE(4815),
    [sym_record_pattern] = STATE(4815),
    [sym_named_field_pattern] = STATE(4815),
    [sym_identifier_pattern] = STATE(4815),
    [sym_long_identifier_or_op] = STATE(2193),
    [sym_rule] = STATE(1515),
    [sym_rules] = STATE(2343),
    [sym_char] = STATE(4765),
    [sym_format_string] = STATE(4746),
    [sym__string_literal] = STATE(4746),
    [sym_string] = STATE(4765),
    [sym_verbatim_string] = STATE(4765),
    [sym_bytearray] = STATE(4765),
    [sym_verbatim_bytearray] = STATE(4765),
    [sym_format_triple_quoted_string] = STATE(4720),
    [sym_triple_quoted_string] = STATE(4765),
    [sym_const] = STATE(4815),
    [sym_long_identifier] = STATE(3493),
    [sym_active_pattern] = STATE(3613),
    [sym__identifier_or_op] = STATE(3650),
    [sym_sbyte] = STATE(4765),
    [sym_byte] = STATE(4765),
    [sym_int16] = STATE(4765),
    [sym_uint16] = STATE(4765),
    [sym_int32] = STATE(4765),
    [sym_uint32] = STATE(4765),
    [sym_nativeint] = STATE(4765),
    [sym_unativeint] = STATE(4765),
    [sym_int64] = STATE(4765),
    [sym_uint64] = STATE(4765),
    [sym_ieee32] = STATE(4765),
    [sym_ieee64] = STATE(4765),
    [sym_bignum] = STATE(4765),
    [sym_decimal] = STATE(4765),
    [sym_float] = STATE(4512),
    [sym_block_comment] = STATE(2511),
    [sym_compiler_directive_decl] = STATE(2511),
    [sym_fsi_directive_decl] = STATE(2511),
    [sym_preproc_line] = STATE(2511),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(4175),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_LPAREN] = ACTIONS(3572),
    [anon_sym_null] = ACTIONS(3574),
    [anon_sym__] = ACTIONS(3576),
    [anon_sym_QMARK] = ACTIONS(4177),
    [anon_sym_COLON_QMARK] = ACTIONS(4179),
    [anon_sym_PIPE] = ACTIONS(4356),
    [anon_sym_LBRACK] = ACTIONS(3582),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3584),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [aux_sym_char_token1] = ACTIONS(3590),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3592),
    [anon_sym_DQUOTE] = ACTIONS(3594),
    [anon_sym_AT_DQUOTE] = ACTIONS(3596),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3598),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3600),
    [sym_bool] = ACTIONS(3602),
    [sym_unit] = ACTIONS(3604),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4181),
    [sym_op_identifier] = ACTIONS(4183),
    [sym_int] = ACTIONS(3610),
    [sym_xint] = ACTIONS(3612),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2512] = {
    [sym_attributes] = STATE(2699),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(4815),
    [sym__pattern] = STATE(5282),
    [sym_optional_pattern] = STATE(4815),
    [sym_type_check_pattern] = STATE(4815),
    [sym_attribute_pattern] = STATE(4815),
    [sym_paren_pattern] = STATE(4815),
    [sym_as_pattern] = STATE(4815),
    [sym_cons_pattern] = STATE(4815),
    [sym_disjunct_pattern] = STATE(4815),
    [sym_conjunct_pattern] = STATE(4815),
    [sym_typed_pattern] = STATE(4815),
    [sym_list_pattern] = STATE(4815),
    [sym_array_pattern] = STATE(4815),
    [sym_record_pattern] = STATE(4815),
    [sym_named_field_pattern] = STATE(4815),
    [sym_identifier_pattern] = STATE(4815),
    [sym_long_identifier_or_op] = STATE(2193),
    [sym_rule] = STATE(5720),
    [sym_rules] = STATE(6845),
    [sym_char] = STATE(4765),
    [sym_format_string] = STATE(4746),
    [sym__string_literal] = STATE(4746),
    [sym_string] = STATE(4765),
    [sym_verbatim_string] = STATE(4765),
    [sym_bytearray] = STATE(4765),
    [sym_verbatim_bytearray] = STATE(4765),
    [sym_format_triple_quoted_string] = STATE(4720),
    [sym_triple_quoted_string] = STATE(4765),
    [sym_const] = STATE(4815),
    [sym_long_identifier] = STATE(3493),
    [sym_active_pattern] = STATE(3613),
    [sym__identifier_or_op] = STATE(3650),
    [sym_sbyte] = STATE(4765),
    [sym_byte] = STATE(4765),
    [sym_int16] = STATE(4765),
    [sym_uint16] = STATE(4765),
    [sym_int32] = STATE(4765),
    [sym_uint32] = STATE(4765),
    [sym_nativeint] = STATE(4765),
    [sym_unativeint] = STATE(4765),
    [sym_int64] = STATE(4765),
    [sym_uint64] = STATE(4765),
    [sym_ieee32] = STATE(4765),
    [sym_ieee64] = STATE(4765),
    [sym_bignum] = STATE(4765),
    [sym_decimal] = STATE(4765),
    [sym_float] = STATE(4512),
    [sym_block_comment] = STATE(2512),
    [sym_compiler_directive_decl] = STATE(2512),
    [sym_fsi_directive_decl] = STATE(2512),
    [sym_preproc_line] = STATE(2512),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(4175),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_LPAREN] = ACTIONS(3572),
    [anon_sym_null] = ACTIONS(3574),
    [anon_sym__] = ACTIONS(3576),
    [anon_sym_QMARK] = ACTIONS(4177),
    [anon_sym_COLON_QMARK] = ACTIONS(4179),
    [anon_sym_PIPE] = ACTIONS(4354),
    [anon_sym_LBRACK] = ACTIONS(3582),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3584),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [aux_sym_char_token1] = ACTIONS(3590),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3592),
    [anon_sym_DQUOTE] = ACTIONS(3594),
    [anon_sym_AT_DQUOTE] = ACTIONS(3596),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3598),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3600),
    [sym_bool] = ACTIONS(3602),
    [sym_unit] = ACTIONS(3604),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4181),
    [sym_op_identifier] = ACTIONS(4183),
    [sym_int] = ACTIONS(3610),
    [sym_xint] = ACTIONS(3612),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2513] = {
    [sym_attributes] = STATE(2699),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(4815),
    [sym__pattern] = STATE(5404),
    [sym_optional_pattern] = STATE(4815),
    [sym_type_check_pattern] = STATE(4815),
    [sym_attribute_pattern] = STATE(4815),
    [sym_paren_pattern] = STATE(4815),
    [sym_as_pattern] = STATE(4815),
    [sym_cons_pattern] = STATE(4815),
    [sym_disjunct_pattern] = STATE(4815),
    [sym_conjunct_pattern] = STATE(4815),
    [sym_typed_pattern] = STATE(4815),
    [sym_list_pattern] = STATE(4815),
    [sym_array_pattern] = STATE(4815),
    [sym_record_pattern] = STATE(4815),
    [sym_named_field_pattern] = STATE(4815),
    [sym_identifier_pattern] = STATE(4815),
    [sym_long_identifier_or_op] = STATE(2193),
    [sym_rule] = STATE(1561),
    [sym_rules] = STATE(2465),
    [sym_char] = STATE(4765),
    [sym_format_string] = STATE(4746),
    [sym__string_literal] = STATE(4746),
    [sym_string] = STATE(4765),
    [sym_verbatim_string] = STATE(4765),
    [sym_bytearray] = STATE(4765),
    [sym_verbatim_bytearray] = STATE(4765),
    [sym_format_triple_quoted_string] = STATE(4720),
    [sym_triple_quoted_string] = STATE(4765),
    [sym_const] = STATE(4815),
    [sym_long_identifier] = STATE(3493),
    [sym_active_pattern] = STATE(3613),
    [sym__identifier_or_op] = STATE(3650),
    [sym_sbyte] = STATE(4765),
    [sym_byte] = STATE(4765),
    [sym_int16] = STATE(4765),
    [sym_uint16] = STATE(4765),
    [sym_int32] = STATE(4765),
    [sym_uint32] = STATE(4765),
    [sym_nativeint] = STATE(4765),
    [sym_unativeint] = STATE(4765),
    [sym_int64] = STATE(4765),
    [sym_uint64] = STATE(4765),
    [sym_ieee32] = STATE(4765),
    [sym_ieee64] = STATE(4765),
    [sym_bignum] = STATE(4765),
    [sym_decimal] = STATE(4765),
    [sym_float] = STATE(4512),
    [sym_block_comment] = STATE(2513),
    [sym_compiler_directive_decl] = STATE(2513),
    [sym_fsi_directive_decl] = STATE(2513),
    [sym_preproc_line] = STATE(2513),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(4175),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_LPAREN] = ACTIONS(3572),
    [anon_sym_null] = ACTIONS(3574),
    [anon_sym__] = ACTIONS(3576),
    [anon_sym_QMARK] = ACTIONS(4177),
    [anon_sym_COLON_QMARK] = ACTIONS(4179),
    [anon_sym_PIPE] = ACTIONS(4350),
    [anon_sym_LBRACK] = ACTIONS(3582),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3584),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [aux_sym_char_token1] = ACTIONS(3590),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3592),
    [anon_sym_DQUOTE] = ACTIONS(3594),
    [anon_sym_AT_DQUOTE] = ACTIONS(3596),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3598),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3600),
    [sym_bool] = ACTIONS(3602),
    [sym_unit] = ACTIONS(3604),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4181),
    [sym_op_identifier] = ACTIONS(4183),
    [sym_int] = ACTIONS(3610),
    [sym_xint] = ACTIONS(3612),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2514] = {
    [sym_attributes] = STATE(2699),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(4815),
    [sym__pattern] = STATE(5212),
    [sym_optional_pattern] = STATE(4815),
    [sym_type_check_pattern] = STATE(4815),
    [sym_attribute_pattern] = STATE(4815),
    [sym_paren_pattern] = STATE(4815),
    [sym_as_pattern] = STATE(4815),
    [sym_cons_pattern] = STATE(4815),
    [sym_disjunct_pattern] = STATE(4815),
    [sym_conjunct_pattern] = STATE(4815),
    [sym_typed_pattern] = STATE(4815),
    [sym_list_pattern] = STATE(4815),
    [sym_array_pattern] = STATE(4815),
    [sym_record_pattern] = STATE(4815),
    [sym_named_field_pattern] = STATE(4815),
    [sym_identifier_pattern] = STATE(4815),
    [sym_long_identifier_or_op] = STATE(2193),
    [sym_rule] = STATE(1497),
    [sym_rules] = STATE(2280),
    [sym_char] = STATE(4765),
    [sym_format_string] = STATE(4746),
    [sym__string_literal] = STATE(4746),
    [sym_string] = STATE(4765),
    [sym_verbatim_string] = STATE(4765),
    [sym_bytearray] = STATE(4765),
    [sym_verbatim_bytearray] = STATE(4765),
    [sym_format_triple_quoted_string] = STATE(4720),
    [sym_triple_quoted_string] = STATE(4765),
    [sym_const] = STATE(4815),
    [sym_long_identifier] = STATE(3493),
    [sym_active_pattern] = STATE(3613),
    [sym__identifier_or_op] = STATE(3650),
    [sym_sbyte] = STATE(4765),
    [sym_byte] = STATE(4765),
    [sym_int16] = STATE(4765),
    [sym_uint16] = STATE(4765),
    [sym_int32] = STATE(4765),
    [sym_uint32] = STATE(4765),
    [sym_nativeint] = STATE(4765),
    [sym_unativeint] = STATE(4765),
    [sym_int64] = STATE(4765),
    [sym_uint64] = STATE(4765),
    [sym_ieee32] = STATE(4765),
    [sym_ieee64] = STATE(4765),
    [sym_bignum] = STATE(4765),
    [sym_decimal] = STATE(4765),
    [sym_float] = STATE(4512),
    [sym_block_comment] = STATE(2514),
    [sym_compiler_directive_decl] = STATE(2514),
    [sym_fsi_directive_decl] = STATE(2514),
    [sym_preproc_line] = STATE(2514),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(4175),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_LPAREN] = ACTIONS(3572),
    [anon_sym_null] = ACTIONS(3574),
    [anon_sym__] = ACTIONS(3576),
    [anon_sym_QMARK] = ACTIONS(4177),
    [anon_sym_COLON_QMARK] = ACTIONS(4179),
    [anon_sym_PIPE] = ACTIONS(4364),
    [anon_sym_LBRACK] = ACTIONS(3582),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3584),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [aux_sym_char_token1] = ACTIONS(3590),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3592),
    [anon_sym_DQUOTE] = ACTIONS(3594),
    [anon_sym_AT_DQUOTE] = ACTIONS(3596),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3598),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3600),
    [sym_bool] = ACTIONS(3602),
    [sym_unit] = ACTIONS(3604),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4181),
    [sym_op_identifier] = ACTIONS(4183),
    [sym_int] = ACTIONS(3610),
    [sym_xint] = ACTIONS(3612),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2515] = {
    [sym_attributes] = STATE(2699),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(4815),
    [sym__pattern] = STATE(5282),
    [sym_optional_pattern] = STATE(4815),
    [sym_type_check_pattern] = STATE(4815),
    [sym_attribute_pattern] = STATE(4815),
    [sym_paren_pattern] = STATE(4815),
    [sym_as_pattern] = STATE(4815),
    [sym_cons_pattern] = STATE(4815),
    [sym_disjunct_pattern] = STATE(4815),
    [sym_conjunct_pattern] = STATE(4815),
    [sym_typed_pattern] = STATE(4815),
    [sym_list_pattern] = STATE(4815),
    [sym_array_pattern] = STATE(4815),
    [sym_record_pattern] = STATE(4815),
    [sym_named_field_pattern] = STATE(4815),
    [sym_identifier_pattern] = STATE(4815),
    [sym_long_identifier_or_op] = STATE(2193),
    [sym_rule] = STATE(5720),
    [sym_rules] = STATE(6894),
    [sym_char] = STATE(4765),
    [sym_format_string] = STATE(4746),
    [sym__string_literal] = STATE(4746),
    [sym_string] = STATE(4765),
    [sym_verbatim_string] = STATE(4765),
    [sym_bytearray] = STATE(4765),
    [sym_verbatim_bytearray] = STATE(4765),
    [sym_format_triple_quoted_string] = STATE(4720),
    [sym_triple_quoted_string] = STATE(4765),
    [sym_const] = STATE(4815),
    [sym_long_identifier] = STATE(3493),
    [sym_active_pattern] = STATE(3613),
    [sym__identifier_or_op] = STATE(3650),
    [sym_sbyte] = STATE(4765),
    [sym_byte] = STATE(4765),
    [sym_int16] = STATE(4765),
    [sym_uint16] = STATE(4765),
    [sym_int32] = STATE(4765),
    [sym_uint32] = STATE(4765),
    [sym_nativeint] = STATE(4765),
    [sym_unativeint] = STATE(4765),
    [sym_int64] = STATE(4765),
    [sym_uint64] = STATE(4765),
    [sym_ieee32] = STATE(4765),
    [sym_ieee64] = STATE(4765),
    [sym_bignum] = STATE(4765),
    [sym_decimal] = STATE(4765),
    [sym_float] = STATE(4512),
    [sym_block_comment] = STATE(2515),
    [sym_compiler_directive_decl] = STATE(2515),
    [sym_fsi_directive_decl] = STATE(2515),
    [sym_preproc_line] = STATE(2515),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(4175),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_LPAREN] = ACTIONS(3572),
    [anon_sym_null] = ACTIONS(3574),
    [anon_sym__] = ACTIONS(3576),
    [anon_sym_QMARK] = ACTIONS(4177),
    [anon_sym_COLON_QMARK] = ACTIONS(4179),
    [anon_sym_PIPE] = ACTIONS(4354),
    [anon_sym_LBRACK] = ACTIONS(3582),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3584),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [aux_sym_char_token1] = ACTIONS(3590),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3592),
    [anon_sym_DQUOTE] = ACTIONS(3594),
    [anon_sym_AT_DQUOTE] = ACTIONS(3596),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3598),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3600),
    [sym_bool] = ACTIONS(3602),
    [sym_unit] = ACTIONS(3604),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4181),
    [sym_op_identifier] = ACTIONS(4183),
    [sym_int] = ACTIONS(3610),
    [sym_xint] = ACTIONS(3612),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2516] = {
    [sym_attributes] = STATE(2699),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(4815),
    [sym__pattern] = STATE(5177),
    [sym_optional_pattern] = STATE(4815),
    [sym_type_check_pattern] = STATE(4815),
    [sym_attribute_pattern] = STATE(4815),
    [sym_paren_pattern] = STATE(4815),
    [sym_as_pattern] = STATE(4815),
    [sym_cons_pattern] = STATE(4815),
    [sym_disjunct_pattern] = STATE(4815),
    [sym_conjunct_pattern] = STATE(4815),
    [sym_typed_pattern] = STATE(4815),
    [sym_list_pattern] = STATE(4815),
    [sym_array_pattern] = STATE(4815),
    [sym_record_pattern] = STATE(4815),
    [sym_named_field_pattern] = STATE(4815),
    [sym_identifier_pattern] = STATE(4815),
    [sym_long_identifier_or_op] = STATE(2193),
    [sym_rule] = STATE(1574),
    [sym_rules] = STATE(2173),
    [sym_char] = STATE(4765),
    [sym_format_string] = STATE(4746),
    [sym__string_literal] = STATE(4746),
    [sym_string] = STATE(4765),
    [sym_verbatim_string] = STATE(4765),
    [sym_bytearray] = STATE(4765),
    [sym_verbatim_bytearray] = STATE(4765),
    [sym_format_triple_quoted_string] = STATE(4720),
    [sym_triple_quoted_string] = STATE(4765),
    [sym_const] = STATE(4815),
    [sym_long_identifier] = STATE(3493),
    [sym_active_pattern] = STATE(3613),
    [sym__identifier_or_op] = STATE(3650),
    [sym_sbyte] = STATE(4765),
    [sym_byte] = STATE(4765),
    [sym_int16] = STATE(4765),
    [sym_uint16] = STATE(4765),
    [sym_int32] = STATE(4765),
    [sym_uint32] = STATE(4765),
    [sym_nativeint] = STATE(4765),
    [sym_unativeint] = STATE(4765),
    [sym_int64] = STATE(4765),
    [sym_uint64] = STATE(4765),
    [sym_ieee32] = STATE(4765),
    [sym_ieee64] = STATE(4765),
    [sym_bignum] = STATE(4765),
    [sym_decimal] = STATE(4765),
    [sym_float] = STATE(4512),
    [sym_block_comment] = STATE(2516),
    [sym_compiler_directive_decl] = STATE(2516),
    [sym_fsi_directive_decl] = STATE(2516),
    [sym_preproc_line] = STATE(2516),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(4175),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_LPAREN] = ACTIONS(3572),
    [anon_sym_null] = ACTIONS(3574),
    [anon_sym__] = ACTIONS(3576),
    [anon_sym_QMARK] = ACTIONS(4177),
    [anon_sym_COLON_QMARK] = ACTIONS(4179),
    [anon_sym_PIPE] = ACTIONS(4358),
    [anon_sym_LBRACK] = ACTIONS(3582),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3584),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [aux_sym_char_token1] = ACTIONS(3590),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3592),
    [anon_sym_DQUOTE] = ACTIONS(3594),
    [anon_sym_AT_DQUOTE] = ACTIONS(3596),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3598),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3600),
    [sym_bool] = ACTIONS(3602),
    [sym_unit] = ACTIONS(3604),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4181),
    [sym_op_identifier] = ACTIONS(4183),
    [sym_int] = ACTIONS(3610),
    [sym_xint] = ACTIONS(3612),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2517] = {
    [sym_attributes] = STATE(2699),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(4815),
    [sym__pattern] = STATE(5282),
    [sym_optional_pattern] = STATE(4815),
    [sym_type_check_pattern] = STATE(4815),
    [sym_attribute_pattern] = STATE(4815),
    [sym_paren_pattern] = STATE(4815),
    [sym_as_pattern] = STATE(4815),
    [sym_cons_pattern] = STATE(4815),
    [sym_disjunct_pattern] = STATE(4815),
    [sym_conjunct_pattern] = STATE(4815),
    [sym_typed_pattern] = STATE(4815),
    [sym_list_pattern] = STATE(4815),
    [sym_array_pattern] = STATE(4815),
    [sym_record_pattern] = STATE(4815),
    [sym_named_field_pattern] = STATE(4815),
    [sym_identifier_pattern] = STATE(4815),
    [sym_long_identifier_or_op] = STATE(2193),
    [sym_rule] = STATE(5720),
    [sym_rules] = STATE(6501),
    [sym_char] = STATE(4765),
    [sym_format_string] = STATE(4746),
    [sym__string_literal] = STATE(4746),
    [sym_string] = STATE(4765),
    [sym_verbatim_string] = STATE(4765),
    [sym_bytearray] = STATE(4765),
    [sym_verbatim_bytearray] = STATE(4765),
    [sym_format_triple_quoted_string] = STATE(4720),
    [sym_triple_quoted_string] = STATE(4765),
    [sym_const] = STATE(4815),
    [sym_long_identifier] = STATE(3493),
    [sym_active_pattern] = STATE(3613),
    [sym__identifier_or_op] = STATE(3650),
    [sym_sbyte] = STATE(4765),
    [sym_byte] = STATE(4765),
    [sym_int16] = STATE(4765),
    [sym_uint16] = STATE(4765),
    [sym_int32] = STATE(4765),
    [sym_uint32] = STATE(4765),
    [sym_nativeint] = STATE(4765),
    [sym_unativeint] = STATE(4765),
    [sym_int64] = STATE(4765),
    [sym_uint64] = STATE(4765),
    [sym_ieee32] = STATE(4765),
    [sym_ieee64] = STATE(4765),
    [sym_bignum] = STATE(4765),
    [sym_decimal] = STATE(4765),
    [sym_float] = STATE(4512),
    [sym_block_comment] = STATE(2517),
    [sym_compiler_directive_decl] = STATE(2517),
    [sym_fsi_directive_decl] = STATE(2517),
    [sym_preproc_line] = STATE(2517),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(4175),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_LPAREN] = ACTIONS(3572),
    [anon_sym_null] = ACTIONS(3574),
    [anon_sym__] = ACTIONS(3576),
    [anon_sym_QMARK] = ACTIONS(4177),
    [anon_sym_COLON_QMARK] = ACTIONS(4179),
    [anon_sym_PIPE] = ACTIONS(4354),
    [anon_sym_LBRACK] = ACTIONS(3582),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3584),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [aux_sym_char_token1] = ACTIONS(3590),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3592),
    [anon_sym_DQUOTE] = ACTIONS(3594),
    [anon_sym_AT_DQUOTE] = ACTIONS(3596),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3598),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3600),
    [sym_bool] = ACTIONS(3602),
    [sym_unit] = ACTIONS(3604),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4181),
    [sym_op_identifier] = ACTIONS(4183),
    [sym_int] = ACTIONS(3610),
    [sym_xint] = ACTIONS(3612),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2518] = {
    [sym_attributes] = STATE(2699),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(4815),
    [sym__pattern] = STATE(5237),
    [sym_optional_pattern] = STATE(4815),
    [sym_type_check_pattern] = STATE(4815),
    [sym_attribute_pattern] = STATE(4815),
    [sym_paren_pattern] = STATE(4815),
    [sym_as_pattern] = STATE(4815),
    [sym_cons_pattern] = STATE(4815),
    [sym_disjunct_pattern] = STATE(4815),
    [sym_conjunct_pattern] = STATE(4815),
    [sym_typed_pattern] = STATE(4815),
    [sym_list_pattern] = STATE(4815),
    [sym_array_pattern] = STATE(4815),
    [sym_record_pattern] = STATE(4815),
    [sym_named_field_pattern] = STATE(4815),
    [sym_identifier_pattern] = STATE(4815),
    [sym_long_identifier_or_op] = STATE(2193),
    [sym_rule] = STATE(1515),
    [sym_rules] = STATE(2361),
    [sym_char] = STATE(4765),
    [sym_format_string] = STATE(4746),
    [sym__string_literal] = STATE(4746),
    [sym_string] = STATE(4765),
    [sym_verbatim_string] = STATE(4765),
    [sym_bytearray] = STATE(4765),
    [sym_verbatim_bytearray] = STATE(4765),
    [sym_format_triple_quoted_string] = STATE(4720),
    [sym_triple_quoted_string] = STATE(4765),
    [sym_const] = STATE(4815),
    [sym_long_identifier] = STATE(3493),
    [sym_active_pattern] = STATE(3613),
    [sym__identifier_or_op] = STATE(3650),
    [sym_sbyte] = STATE(4765),
    [sym_byte] = STATE(4765),
    [sym_int16] = STATE(4765),
    [sym_uint16] = STATE(4765),
    [sym_int32] = STATE(4765),
    [sym_uint32] = STATE(4765),
    [sym_nativeint] = STATE(4765),
    [sym_unativeint] = STATE(4765),
    [sym_int64] = STATE(4765),
    [sym_uint64] = STATE(4765),
    [sym_ieee32] = STATE(4765),
    [sym_ieee64] = STATE(4765),
    [sym_bignum] = STATE(4765),
    [sym_decimal] = STATE(4765),
    [sym_float] = STATE(4512),
    [sym_block_comment] = STATE(2518),
    [sym_compiler_directive_decl] = STATE(2518),
    [sym_fsi_directive_decl] = STATE(2518),
    [sym_preproc_line] = STATE(2518),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(4175),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_LPAREN] = ACTIONS(3572),
    [anon_sym_null] = ACTIONS(3574),
    [anon_sym__] = ACTIONS(3576),
    [anon_sym_QMARK] = ACTIONS(4177),
    [anon_sym_COLON_QMARK] = ACTIONS(4179),
    [anon_sym_PIPE] = ACTIONS(4356),
    [anon_sym_LBRACK] = ACTIONS(3582),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3584),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [aux_sym_char_token1] = ACTIONS(3590),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3592),
    [anon_sym_DQUOTE] = ACTIONS(3594),
    [anon_sym_AT_DQUOTE] = ACTIONS(3596),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3598),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3600),
    [sym_bool] = ACTIONS(3602),
    [sym_unit] = ACTIONS(3604),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4181),
    [sym_op_identifier] = ACTIONS(4183),
    [sym_int] = ACTIONS(3610),
    [sym_xint] = ACTIONS(3612),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2519] = {
    [sym_attributes] = STATE(2699),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(4815),
    [sym__pattern] = STATE(5323),
    [sym_optional_pattern] = STATE(4815),
    [sym_type_check_pattern] = STATE(4815),
    [sym_attribute_pattern] = STATE(4815),
    [sym_paren_pattern] = STATE(4815),
    [sym_as_pattern] = STATE(4815),
    [sym_cons_pattern] = STATE(4815),
    [sym_disjunct_pattern] = STATE(4815),
    [sym_conjunct_pattern] = STATE(4815),
    [sym_typed_pattern] = STATE(4815),
    [sym_list_pattern] = STATE(4815),
    [sym_array_pattern] = STATE(4815),
    [sym_record_pattern] = STATE(4815),
    [sym_named_field_pattern] = STATE(4815),
    [sym_identifier_pattern] = STATE(4815),
    [sym_long_identifier_or_op] = STATE(2193),
    [sym_rule] = STATE(1461),
    [sym_rules] = STATE(1941),
    [sym_char] = STATE(4765),
    [sym_format_string] = STATE(4746),
    [sym__string_literal] = STATE(4746),
    [sym_string] = STATE(4765),
    [sym_verbatim_string] = STATE(4765),
    [sym_bytearray] = STATE(4765),
    [sym_verbatim_bytearray] = STATE(4765),
    [sym_format_triple_quoted_string] = STATE(4720),
    [sym_triple_quoted_string] = STATE(4765),
    [sym_const] = STATE(4815),
    [sym_long_identifier] = STATE(3493),
    [sym_active_pattern] = STATE(3613),
    [sym__identifier_or_op] = STATE(3650),
    [sym_sbyte] = STATE(4765),
    [sym_byte] = STATE(4765),
    [sym_int16] = STATE(4765),
    [sym_uint16] = STATE(4765),
    [sym_int32] = STATE(4765),
    [sym_uint32] = STATE(4765),
    [sym_nativeint] = STATE(4765),
    [sym_unativeint] = STATE(4765),
    [sym_int64] = STATE(4765),
    [sym_uint64] = STATE(4765),
    [sym_ieee32] = STATE(4765),
    [sym_ieee64] = STATE(4765),
    [sym_bignum] = STATE(4765),
    [sym_decimal] = STATE(4765),
    [sym_float] = STATE(4512),
    [sym_block_comment] = STATE(2519),
    [sym_compiler_directive_decl] = STATE(2519),
    [sym_fsi_directive_decl] = STATE(2519),
    [sym_preproc_line] = STATE(2519),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(4175),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_LPAREN] = ACTIONS(3572),
    [anon_sym_null] = ACTIONS(3574),
    [anon_sym__] = ACTIONS(3576),
    [anon_sym_QMARK] = ACTIONS(4177),
    [anon_sym_COLON_QMARK] = ACTIONS(4179),
    [anon_sym_PIPE] = ACTIONS(4344),
    [anon_sym_LBRACK] = ACTIONS(3582),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3584),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [aux_sym_char_token1] = ACTIONS(3590),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3592),
    [anon_sym_DQUOTE] = ACTIONS(3594),
    [anon_sym_AT_DQUOTE] = ACTIONS(3596),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3598),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3600),
    [sym_bool] = ACTIONS(3602),
    [sym_unit] = ACTIONS(3604),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4181),
    [sym_op_identifier] = ACTIONS(4183),
    [sym_int] = ACTIONS(3610),
    [sym_xint] = ACTIONS(3612),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2520] = {
    [sym_attributes] = STATE(2699),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(4815),
    [sym__pattern] = STATE(5282),
    [sym_optional_pattern] = STATE(4815),
    [sym_type_check_pattern] = STATE(4815),
    [sym_attribute_pattern] = STATE(4815),
    [sym_paren_pattern] = STATE(4815),
    [sym_as_pattern] = STATE(4815),
    [sym_cons_pattern] = STATE(4815),
    [sym_disjunct_pattern] = STATE(4815),
    [sym_conjunct_pattern] = STATE(4815),
    [sym_typed_pattern] = STATE(4815),
    [sym_list_pattern] = STATE(4815),
    [sym_array_pattern] = STATE(4815),
    [sym_record_pattern] = STATE(4815),
    [sym_named_field_pattern] = STATE(4815),
    [sym_identifier_pattern] = STATE(4815),
    [sym_long_identifier_or_op] = STATE(2193),
    [sym_rule] = STATE(5720),
    [sym_rules] = STATE(7055),
    [sym_char] = STATE(4765),
    [sym_format_string] = STATE(4746),
    [sym__string_literal] = STATE(4746),
    [sym_string] = STATE(4765),
    [sym_verbatim_string] = STATE(4765),
    [sym_bytearray] = STATE(4765),
    [sym_verbatim_bytearray] = STATE(4765),
    [sym_format_triple_quoted_string] = STATE(4720),
    [sym_triple_quoted_string] = STATE(4765),
    [sym_const] = STATE(4815),
    [sym_long_identifier] = STATE(3493),
    [sym_active_pattern] = STATE(3613),
    [sym__identifier_or_op] = STATE(3650),
    [sym_sbyte] = STATE(4765),
    [sym_byte] = STATE(4765),
    [sym_int16] = STATE(4765),
    [sym_uint16] = STATE(4765),
    [sym_int32] = STATE(4765),
    [sym_uint32] = STATE(4765),
    [sym_nativeint] = STATE(4765),
    [sym_unativeint] = STATE(4765),
    [sym_int64] = STATE(4765),
    [sym_uint64] = STATE(4765),
    [sym_ieee32] = STATE(4765),
    [sym_ieee64] = STATE(4765),
    [sym_bignum] = STATE(4765),
    [sym_decimal] = STATE(4765),
    [sym_float] = STATE(4512),
    [sym_block_comment] = STATE(2520),
    [sym_compiler_directive_decl] = STATE(2520),
    [sym_fsi_directive_decl] = STATE(2520),
    [sym_preproc_line] = STATE(2520),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(4175),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_LPAREN] = ACTIONS(3572),
    [anon_sym_null] = ACTIONS(3574),
    [anon_sym__] = ACTIONS(3576),
    [anon_sym_QMARK] = ACTIONS(4177),
    [anon_sym_COLON_QMARK] = ACTIONS(4179),
    [anon_sym_PIPE] = ACTIONS(4354),
    [anon_sym_LBRACK] = ACTIONS(3582),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3584),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [aux_sym_char_token1] = ACTIONS(3590),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3592),
    [anon_sym_DQUOTE] = ACTIONS(3594),
    [anon_sym_AT_DQUOTE] = ACTIONS(3596),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3598),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3600),
    [sym_bool] = ACTIONS(3602),
    [sym_unit] = ACTIONS(3604),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4181),
    [sym_op_identifier] = ACTIONS(4183),
    [sym_int] = ACTIONS(3610),
    [sym_xint] = ACTIONS(3612),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2521] = {
    [sym_attributes] = STATE(2699),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(4815),
    [sym__pattern] = STATE(5323),
    [sym_optional_pattern] = STATE(4815),
    [sym_type_check_pattern] = STATE(4815),
    [sym_attribute_pattern] = STATE(4815),
    [sym_paren_pattern] = STATE(4815),
    [sym_as_pattern] = STATE(4815),
    [sym_cons_pattern] = STATE(4815),
    [sym_disjunct_pattern] = STATE(4815),
    [sym_conjunct_pattern] = STATE(4815),
    [sym_typed_pattern] = STATE(4815),
    [sym_list_pattern] = STATE(4815),
    [sym_array_pattern] = STATE(4815),
    [sym_record_pattern] = STATE(4815),
    [sym_named_field_pattern] = STATE(4815),
    [sym_identifier_pattern] = STATE(4815),
    [sym_long_identifier_or_op] = STATE(2193),
    [sym_rule] = STATE(1461),
    [sym_rules] = STATE(1956),
    [sym_char] = STATE(4765),
    [sym_format_string] = STATE(4746),
    [sym__string_literal] = STATE(4746),
    [sym_string] = STATE(4765),
    [sym_verbatim_string] = STATE(4765),
    [sym_bytearray] = STATE(4765),
    [sym_verbatim_bytearray] = STATE(4765),
    [sym_format_triple_quoted_string] = STATE(4720),
    [sym_triple_quoted_string] = STATE(4765),
    [sym_const] = STATE(4815),
    [sym_long_identifier] = STATE(3493),
    [sym_active_pattern] = STATE(3613),
    [sym__identifier_or_op] = STATE(3650),
    [sym_sbyte] = STATE(4765),
    [sym_byte] = STATE(4765),
    [sym_int16] = STATE(4765),
    [sym_uint16] = STATE(4765),
    [sym_int32] = STATE(4765),
    [sym_uint32] = STATE(4765),
    [sym_nativeint] = STATE(4765),
    [sym_unativeint] = STATE(4765),
    [sym_int64] = STATE(4765),
    [sym_uint64] = STATE(4765),
    [sym_ieee32] = STATE(4765),
    [sym_ieee64] = STATE(4765),
    [sym_bignum] = STATE(4765),
    [sym_decimal] = STATE(4765),
    [sym_float] = STATE(4512),
    [sym_block_comment] = STATE(2521),
    [sym_compiler_directive_decl] = STATE(2521),
    [sym_fsi_directive_decl] = STATE(2521),
    [sym_preproc_line] = STATE(2521),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(4175),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_LPAREN] = ACTIONS(3572),
    [anon_sym_null] = ACTIONS(3574),
    [anon_sym__] = ACTIONS(3576),
    [anon_sym_QMARK] = ACTIONS(4177),
    [anon_sym_COLON_QMARK] = ACTIONS(4179),
    [anon_sym_PIPE] = ACTIONS(4344),
    [anon_sym_LBRACK] = ACTIONS(3582),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3584),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [aux_sym_char_token1] = ACTIONS(3590),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3592),
    [anon_sym_DQUOTE] = ACTIONS(3594),
    [anon_sym_AT_DQUOTE] = ACTIONS(3596),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3598),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3600),
    [sym_bool] = ACTIONS(3602),
    [sym_unit] = ACTIONS(3604),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4181),
    [sym_op_identifier] = ACTIONS(4183),
    [sym_int] = ACTIONS(3610),
    [sym_xint] = ACTIONS(3612),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2522] = {
    [sym_attributes] = STATE(2699),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(4815),
    [sym__pattern] = STATE(5282),
    [sym_optional_pattern] = STATE(4815),
    [sym_type_check_pattern] = STATE(4815),
    [sym_attribute_pattern] = STATE(4815),
    [sym_paren_pattern] = STATE(4815),
    [sym_as_pattern] = STATE(4815),
    [sym_cons_pattern] = STATE(4815),
    [sym_disjunct_pattern] = STATE(4815),
    [sym_conjunct_pattern] = STATE(4815),
    [sym_typed_pattern] = STATE(4815),
    [sym_list_pattern] = STATE(4815),
    [sym_array_pattern] = STATE(4815),
    [sym_record_pattern] = STATE(4815),
    [sym_named_field_pattern] = STATE(4815),
    [sym_identifier_pattern] = STATE(4815),
    [sym_long_identifier_or_op] = STATE(2193),
    [sym_rule] = STATE(5720),
    [sym_rules] = STATE(6833),
    [sym_char] = STATE(4765),
    [sym_format_string] = STATE(4746),
    [sym__string_literal] = STATE(4746),
    [sym_string] = STATE(4765),
    [sym_verbatim_string] = STATE(4765),
    [sym_bytearray] = STATE(4765),
    [sym_verbatim_bytearray] = STATE(4765),
    [sym_format_triple_quoted_string] = STATE(4720),
    [sym_triple_quoted_string] = STATE(4765),
    [sym_const] = STATE(4815),
    [sym_long_identifier] = STATE(3493),
    [sym_active_pattern] = STATE(3613),
    [sym__identifier_or_op] = STATE(3650),
    [sym_sbyte] = STATE(4765),
    [sym_byte] = STATE(4765),
    [sym_int16] = STATE(4765),
    [sym_uint16] = STATE(4765),
    [sym_int32] = STATE(4765),
    [sym_uint32] = STATE(4765),
    [sym_nativeint] = STATE(4765),
    [sym_unativeint] = STATE(4765),
    [sym_int64] = STATE(4765),
    [sym_uint64] = STATE(4765),
    [sym_ieee32] = STATE(4765),
    [sym_ieee64] = STATE(4765),
    [sym_bignum] = STATE(4765),
    [sym_decimal] = STATE(4765),
    [sym_float] = STATE(4512),
    [sym_block_comment] = STATE(2522),
    [sym_compiler_directive_decl] = STATE(2522),
    [sym_fsi_directive_decl] = STATE(2522),
    [sym_preproc_line] = STATE(2522),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(4175),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_LPAREN] = ACTIONS(3572),
    [anon_sym_null] = ACTIONS(3574),
    [anon_sym__] = ACTIONS(3576),
    [anon_sym_QMARK] = ACTIONS(4177),
    [anon_sym_COLON_QMARK] = ACTIONS(4179),
    [anon_sym_PIPE] = ACTIONS(4354),
    [anon_sym_LBRACK] = ACTIONS(3582),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3584),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [aux_sym_char_token1] = ACTIONS(3590),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3592),
    [anon_sym_DQUOTE] = ACTIONS(3594),
    [anon_sym_AT_DQUOTE] = ACTIONS(3596),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3598),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3600),
    [sym_bool] = ACTIONS(3602),
    [sym_unit] = ACTIONS(3604),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4181),
    [sym_op_identifier] = ACTIONS(4183),
    [sym_int] = ACTIONS(3610),
    [sym_xint] = ACTIONS(3612),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2523] = {
    [sym_attributes] = STATE(2699),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(4815),
    [sym__pattern] = STATE(5282),
    [sym_optional_pattern] = STATE(4815),
    [sym_type_check_pattern] = STATE(4815),
    [sym_attribute_pattern] = STATE(4815),
    [sym_paren_pattern] = STATE(4815),
    [sym_as_pattern] = STATE(4815),
    [sym_cons_pattern] = STATE(4815),
    [sym_disjunct_pattern] = STATE(4815),
    [sym_conjunct_pattern] = STATE(4815),
    [sym_typed_pattern] = STATE(4815),
    [sym_list_pattern] = STATE(4815),
    [sym_array_pattern] = STATE(4815),
    [sym_record_pattern] = STATE(4815),
    [sym_named_field_pattern] = STATE(4815),
    [sym_identifier_pattern] = STATE(4815),
    [sym_long_identifier_or_op] = STATE(2193),
    [sym_rule] = STATE(5720),
    [sym_rules] = STATE(6439),
    [sym_char] = STATE(4765),
    [sym_format_string] = STATE(4746),
    [sym__string_literal] = STATE(4746),
    [sym_string] = STATE(4765),
    [sym_verbatim_string] = STATE(4765),
    [sym_bytearray] = STATE(4765),
    [sym_verbatim_bytearray] = STATE(4765),
    [sym_format_triple_quoted_string] = STATE(4720),
    [sym_triple_quoted_string] = STATE(4765),
    [sym_const] = STATE(4815),
    [sym_long_identifier] = STATE(3493),
    [sym_active_pattern] = STATE(3613),
    [sym__identifier_or_op] = STATE(3650),
    [sym_sbyte] = STATE(4765),
    [sym_byte] = STATE(4765),
    [sym_int16] = STATE(4765),
    [sym_uint16] = STATE(4765),
    [sym_int32] = STATE(4765),
    [sym_uint32] = STATE(4765),
    [sym_nativeint] = STATE(4765),
    [sym_unativeint] = STATE(4765),
    [sym_int64] = STATE(4765),
    [sym_uint64] = STATE(4765),
    [sym_ieee32] = STATE(4765),
    [sym_ieee64] = STATE(4765),
    [sym_bignum] = STATE(4765),
    [sym_decimal] = STATE(4765),
    [sym_float] = STATE(4512),
    [sym_block_comment] = STATE(2523),
    [sym_compiler_directive_decl] = STATE(2523),
    [sym_fsi_directive_decl] = STATE(2523),
    [sym_preproc_line] = STATE(2523),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(4175),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_LPAREN] = ACTIONS(3572),
    [anon_sym_null] = ACTIONS(3574),
    [anon_sym__] = ACTIONS(3576),
    [anon_sym_QMARK] = ACTIONS(4177),
    [anon_sym_COLON_QMARK] = ACTIONS(4179),
    [anon_sym_PIPE] = ACTIONS(4354),
    [anon_sym_LBRACK] = ACTIONS(3582),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3584),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [aux_sym_char_token1] = ACTIONS(3590),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3592),
    [anon_sym_DQUOTE] = ACTIONS(3594),
    [anon_sym_AT_DQUOTE] = ACTIONS(3596),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3598),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3600),
    [sym_bool] = ACTIONS(3602),
    [sym_unit] = ACTIONS(3604),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4181),
    [sym_op_identifier] = ACTIONS(4183),
    [sym_int] = ACTIONS(3610),
    [sym_xint] = ACTIONS(3612),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2524] = {
    [sym_attributes] = STATE(2699),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(4815),
    [sym__pattern] = STATE(5196),
    [sym_optional_pattern] = STATE(4815),
    [sym_type_check_pattern] = STATE(4815),
    [sym_attribute_pattern] = STATE(4815),
    [sym_paren_pattern] = STATE(4815),
    [sym_as_pattern] = STATE(4815),
    [sym_cons_pattern] = STATE(4815),
    [sym_disjunct_pattern] = STATE(4815),
    [sym_conjunct_pattern] = STATE(4815),
    [sym_typed_pattern] = STATE(4815),
    [sym_list_pattern] = STATE(4815),
    [sym_array_pattern] = STATE(4815),
    [sym_record_pattern] = STATE(4815),
    [sym_named_field_pattern] = STATE(4815),
    [sym_identifier_pattern] = STATE(4815),
    [sym_long_identifier_or_op] = STATE(2193),
    [sym_rule] = STATE(821),
    [sym_rules] = STATE(953),
    [sym_char] = STATE(4765),
    [sym_format_string] = STATE(4746),
    [sym__string_literal] = STATE(4746),
    [sym_string] = STATE(4765),
    [sym_verbatim_string] = STATE(4765),
    [sym_bytearray] = STATE(4765),
    [sym_verbatim_bytearray] = STATE(4765),
    [sym_format_triple_quoted_string] = STATE(4720),
    [sym_triple_quoted_string] = STATE(4765),
    [sym_const] = STATE(4815),
    [sym_long_identifier] = STATE(3493),
    [sym_active_pattern] = STATE(3613),
    [sym__identifier_or_op] = STATE(3650),
    [sym_sbyte] = STATE(4765),
    [sym_byte] = STATE(4765),
    [sym_int16] = STATE(4765),
    [sym_uint16] = STATE(4765),
    [sym_int32] = STATE(4765),
    [sym_uint32] = STATE(4765),
    [sym_nativeint] = STATE(4765),
    [sym_unativeint] = STATE(4765),
    [sym_int64] = STATE(4765),
    [sym_uint64] = STATE(4765),
    [sym_ieee32] = STATE(4765),
    [sym_ieee64] = STATE(4765),
    [sym_bignum] = STATE(4765),
    [sym_decimal] = STATE(4765),
    [sym_float] = STATE(4512),
    [sym_block_comment] = STATE(2524),
    [sym_compiler_directive_decl] = STATE(2524),
    [sym_fsi_directive_decl] = STATE(2524),
    [sym_preproc_line] = STATE(2524),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(4175),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_LPAREN] = ACTIONS(3572),
    [anon_sym_null] = ACTIONS(3574),
    [anon_sym__] = ACTIONS(3576),
    [anon_sym_QMARK] = ACTIONS(4177),
    [anon_sym_COLON_QMARK] = ACTIONS(4179),
    [anon_sym_PIPE] = ACTIONS(4352),
    [anon_sym_LBRACK] = ACTIONS(3582),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3584),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [aux_sym_char_token1] = ACTIONS(3590),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3592),
    [anon_sym_DQUOTE] = ACTIONS(3594),
    [anon_sym_AT_DQUOTE] = ACTIONS(3596),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3598),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3600),
    [sym_bool] = ACTIONS(3602),
    [sym_unit] = ACTIONS(3604),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4181),
    [sym_op_identifier] = ACTIONS(4183),
    [sym_int] = ACTIONS(3610),
    [sym_xint] = ACTIONS(3612),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2525] = {
    [sym_attributes] = STATE(2699),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(4815),
    [sym__pattern] = STATE(5282),
    [sym_optional_pattern] = STATE(4815),
    [sym_type_check_pattern] = STATE(4815),
    [sym_attribute_pattern] = STATE(4815),
    [sym_paren_pattern] = STATE(4815),
    [sym_as_pattern] = STATE(4815),
    [sym_cons_pattern] = STATE(4815),
    [sym_disjunct_pattern] = STATE(4815),
    [sym_conjunct_pattern] = STATE(4815),
    [sym_typed_pattern] = STATE(4815),
    [sym_list_pattern] = STATE(4815),
    [sym_array_pattern] = STATE(4815),
    [sym_record_pattern] = STATE(4815),
    [sym_named_field_pattern] = STATE(4815),
    [sym_identifier_pattern] = STATE(4815),
    [sym_long_identifier_or_op] = STATE(2193),
    [sym_rule] = STATE(5720),
    [sym_rules] = STATE(7230),
    [sym_char] = STATE(4765),
    [sym_format_string] = STATE(4746),
    [sym__string_literal] = STATE(4746),
    [sym_string] = STATE(4765),
    [sym_verbatim_string] = STATE(4765),
    [sym_bytearray] = STATE(4765),
    [sym_verbatim_bytearray] = STATE(4765),
    [sym_format_triple_quoted_string] = STATE(4720),
    [sym_triple_quoted_string] = STATE(4765),
    [sym_const] = STATE(4815),
    [sym_long_identifier] = STATE(3493),
    [sym_active_pattern] = STATE(3613),
    [sym__identifier_or_op] = STATE(3650),
    [sym_sbyte] = STATE(4765),
    [sym_byte] = STATE(4765),
    [sym_int16] = STATE(4765),
    [sym_uint16] = STATE(4765),
    [sym_int32] = STATE(4765),
    [sym_uint32] = STATE(4765),
    [sym_nativeint] = STATE(4765),
    [sym_unativeint] = STATE(4765),
    [sym_int64] = STATE(4765),
    [sym_uint64] = STATE(4765),
    [sym_ieee32] = STATE(4765),
    [sym_ieee64] = STATE(4765),
    [sym_bignum] = STATE(4765),
    [sym_decimal] = STATE(4765),
    [sym_float] = STATE(4512),
    [sym_block_comment] = STATE(2525),
    [sym_compiler_directive_decl] = STATE(2525),
    [sym_fsi_directive_decl] = STATE(2525),
    [sym_preproc_line] = STATE(2525),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(4175),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_LPAREN] = ACTIONS(3572),
    [anon_sym_null] = ACTIONS(3574),
    [anon_sym__] = ACTIONS(3576),
    [anon_sym_QMARK] = ACTIONS(4177),
    [anon_sym_COLON_QMARK] = ACTIONS(4179),
    [anon_sym_PIPE] = ACTIONS(4354),
    [anon_sym_LBRACK] = ACTIONS(3582),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3584),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [aux_sym_char_token1] = ACTIONS(3590),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3592),
    [anon_sym_DQUOTE] = ACTIONS(3594),
    [anon_sym_AT_DQUOTE] = ACTIONS(3596),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3598),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3600),
    [sym_bool] = ACTIONS(3602),
    [sym_unit] = ACTIONS(3604),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4181),
    [sym_op_identifier] = ACTIONS(4183),
    [sym_int] = ACTIONS(3610),
    [sym_xint] = ACTIONS(3612),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2526] = {
    [sym_attributes] = STATE(2699),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(4815),
    [sym__pattern] = STATE(5282),
    [sym_optional_pattern] = STATE(4815),
    [sym_type_check_pattern] = STATE(4815),
    [sym_attribute_pattern] = STATE(4815),
    [sym_paren_pattern] = STATE(4815),
    [sym_as_pattern] = STATE(4815),
    [sym_cons_pattern] = STATE(4815),
    [sym_disjunct_pattern] = STATE(4815),
    [sym_conjunct_pattern] = STATE(4815),
    [sym_typed_pattern] = STATE(4815),
    [sym_list_pattern] = STATE(4815),
    [sym_array_pattern] = STATE(4815),
    [sym_record_pattern] = STATE(4815),
    [sym_named_field_pattern] = STATE(4815),
    [sym_identifier_pattern] = STATE(4815),
    [sym_long_identifier_or_op] = STATE(2193),
    [sym_rule] = STATE(5720),
    [sym_rules] = STATE(6866),
    [sym_char] = STATE(4765),
    [sym_format_string] = STATE(4746),
    [sym__string_literal] = STATE(4746),
    [sym_string] = STATE(4765),
    [sym_verbatim_string] = STATE(4765),
    [sym_bytearray] = STATE(4765),
    [sym_verbatim_bytearray] = STATE(4765),
    [sym_format_triple_quoted_string] = STATE(4720),
    [sym_triple_quoted_string] = STATE(4765),
    [sym_const] = STATE(4815),
    [sym_long_identifier] = STATE(3493),
    [sym_active_pattern] = STATE(3613),
    [sym__identifier_or_op] = STATE(3650),
    [sym_sbyte] = STATE(4765),
    [sym_byte] = STATE(4765),
    [sym_int16] = STATE(4765),
    [sym_uint16] = STATE(4765),
    [sym_int32] = STATE(4765),
    [sym_uint32] = STATE(4765),
    [sym_nativeint] = STATE(4765),
    [sym_unativeint] = STATE(4765),
    [sym_int64] = STATE(4765),
    [sym_uint64] = STATE(4765),
    [sym_ieee32] = STATE(4765),
    [sym_ieee64] = STATE(4765),
    [sym_bignum] = STATE(4765),
    [sym_decimal] = STATE(4765),
    [sym_float] = STATE(4512),
    [sym_block_comment] = STATE(2526),
    [sym_compiler_directive_decl] = STATE(2526),
    [sym_fsi_directive_decl] = STATE(2526),
    [sym_preproc_line] = STATE(2526),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(4175),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_LPAREN] = ACTIONS(3572),
    [anon_sym_null] = ACTIONS(3574),
    [anon_sym__] = ACTIONS(3576),
    [anon_sym_QMARK] = ACTIONS(4177),
    [anon_sym_COLON_QMARK] = ACTIONS(4179),
    [anon_sym_PIPE] = ACTIONS(4354),
    [anon_sym_LBRACK] = ACTIONS(3582),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3584),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [aux_sym_char_token1] = ACTIONS(3590),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3592),
    [anon_sym_DQUOTE] = ACTIONS(3594),
    [anon_sym_AT_DQUOTE] = ACTIONS(3596),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3598),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3600),
    [sym_bool] = ACTIONS(3602),
    [sym_unit] = ACTIONS(3604),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4181),
    [sym_op_identifier] = ACTIONS(4183),
    [sym_int] = ACTIONS(3610),
    [sym_xint] = ACTIONS(3612),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2527] = {
    [sym_attributes] = STATE(2699),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(4815),
    [sym__pattern] = STATE(5282),
    [sym_optional_pattern] = STATE(4815),
    [sym_type_check_pattern] = STATE(4815),
    [sym_attribute_pattern] = STATE(4815),
    [sym_paren_pattern] = STATE(4815),
    [sym_as_pattern] = STATE(4815),
    [sym_cons_pattern] = STATE(4815),
    [sym_disjunct_pattern] = STATE(4815),
    [sym_conjunct_pattern] = STATE(4815),
    [sym_typed_pattern] = STATE(4815),
    [sym_list_pattern] = STATE(4815),
    [sym_array_pattern] = STATE(4815),
    [sym_record_pattern] = STATE(4815),
    [sym_named_field_pattern] = STATE(4815),
    [sym_identifier_pattern] = STATE(4815),
    [sym_long_identifier_or_op] = STATE(2193),
    [sym_rule] = STATE(5720),
    [sym_rules] = STATE(6915),
    [sym_char] = STATE(4765),
    [sym_format_string] = STATE(4746),
    [sym__string_literal] = STATE(4746),
    [sym_string] = STATE(4765),
    [sym_verbatim_string] = STATE(4765),
    [sym_bytearray] = STATE(4765),
    [sym_verbatim_bytearray] = STATE(4765),
    [sym_format_triple_quoted_string] = STATE(4720),
    [sym_triple_quoted_string] = STATE(4765),
    [sym_const] = STATE(4815),
    [sym_long_identifier] = STATE(3493),
    [sym_active_pattern] = STATE(3613),
    [sym__identifier_or_op] = STATE(3650),
    [sym_sbyte] = STATE(4765),
    [sym_byte] = STATE(4765),
    [sym_int16] = STATE(4765),
    [sym_uint16] = STATE(4765),
    [sym_int32] = STATE(4765),
    [sym_uint32] = STATE(4765),
    [sym_nativeint] = STATE(4765),
    [sym_unativeint] = STATE(4765),
    [sym_int64] = STATE(4765),
    [sym_uint64] = STATE(4765),
    [sym_ieee32] = STATE(4765),
    [sym_ieee64] = STATE(4765),
    [sym_bignum] = STATE(4765),
    [sym_decimal] = STATE(4765),
    [sym_float] = STATE(4512),
    [sym_block_comment] = STATE(2527),
    [sym_compiler_directive_decl] = STATE(2527),
    [sym_fsi_directive_decl] = STATE(2527),
    [sym_preproc_line] = STATE(2527),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(4175),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_LPAREN] = ACTIONS(3572),
    [anon_sym_null] = ACTIONS(3574),
    [anon_sym__] = ACTIONS(3576),
    [anon_sym_QMARK] = ACTIONS(4177),
    [anon_sym_COLON_QMARK] = ACTIONS(4179),
    [anon_sym_PIPE] = ACTIONS(4354),
    [anon_sym_LBRACK] = ACTIONS(3582),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3584),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [aux_sym_char_token1] = ACTIONS(3590),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3592),
    [anon_sym_DQUOTE] = ACTIONS(3594),
    [anon_sym_AT_DQUOTE] = ACTIONS(3596),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3598),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3600),
    [sym_bool] = ACTIONS(3602),
    [sym_unit] = ACTIONS(3604),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4181),
    [sym_op_identifier] = ACTIONS(4183),
    [sym_int] = ACTIONS(3610),
    [sym_xint] = ACTIONS(3612),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2528] = {
    [sym_attributes] = STATE(2699),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(4815),
    [sym__pattern] = STATE(5282),
    [sym_optional_pattern] = STATE(4815),
    [sym_type_check_pattern] = STATE(4815),
    [sym_attribute_pattern] = STATE(4815),
    [sym_paren_pattern] = STATE(4815),
    [sym_as_pattern] = STATE(4815),
    [sym_cons_pattern] = STATE(4815),
    [sym_disjunct_pattern] = STATE(4815),
    [sym_conjunct_pattern] = STATE(4815),
    [sym_typed_pattern] = STATE(4815),
    [sym_list_pattern] = STATE(4815),
    [sym_array_pattern] = STATE(4815),
    [sym_record_pattern] = STATE(4815),
    [sym_named_field_pattern] = STATE(4815),
    [sym_identifier_pattern] = STATE(4815),
    [sym_long_identifier_or_op] = STATE(2193),
    [sym_rule] = STATE(5720),
    [sym_rules] = STATE(7010),
    [sym_char] = STATE(4765),
    [sym_format_string] = STATE(4746),
    [sym__string_literal] = STATE(4746),
    [sym_string] = STATE(4765),
    [sym_verbatim_string] = STATE(4765),
    [sym_bytearray] = STATE(4765),
    [sym_verbatim_bytearray] = STATE(4765),
    [sym_format_triple_quoted_string] = STATE(4720),
    [sym_triple_quoted_string] = STATE(4765),
    [sym_const] = STATE(4815),
    [sym_long_identifier] = STATE(3493),
    [sym_active_pattern] = STATE(3613),
    [sym__identifier_or_op] = STATE(3650),
    [sym_sbyte] = STATE(4765),
    [sym_byte] = STATE(4765),
    [sym_int16] = STATE(4765),
    [sym_uint16] = STATE(4765),
    [sym_int32] = STATE(4765),
    [sym_uint32] = STATE(4765),
    [sym_nativeint] = STATE(4765),
    [sym_unativeint] = STATE(4765),
    [sym_int64] = STATE(4765),
    [sym_uint64] = STATE(4765),
    [sym_ieee32] = STATE(4765),
    [sym_ieee64] = STATE(4765),
    [sym_bignum] = STATE(4765),
    [sym_decimal] = STATE(4765),
    [sym_float] = STATE(4512),
    [sym_block_comment] = STATE(2528),
    [sym_compiler_directive_decl] = STATE(2528),
    [sym_fsi_directive_decl] = STATE(2528),
    [sym_preproc_line] = STATE(2528),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(4175),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_LPAREN] = ACTIONS(3572),
    [anon_sym_null] = ACTIONS(3574),
    [anon_sym__] = ACTIONS(3576),
    [anon_sym_QMARK] = ACTIONS(4177),
    [anon_sym_COLON_QMARK] = ACTIONS(4179),
    [anon_sym_PIPE] = ACTIONS(4354),
    [anon_sym_LBRACK] = ACTIONS(3582),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3584),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [aux_sym_char_token1] = ACTIONS(3590),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3592),
    [anon_sym_DQUOTE] = ACTIONS(3594),
    [anon_sym_AT_DQUOTE] = ACTIONS(3596),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3598),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3600),
    [sym_bool] = ACTIONS(3602),
    [sym_unit] = ACTIONS(3604),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4181),
    [sym_op_identifier] = ACTIONS(4183),
    [sym_int] = ACTIONS(3610),
    [sym_xint] = ACTIONS(3612),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2529] = {
    [sym_attributes] = STATE(2699),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(4815),
    [sym__pattern] = STATE(5282),
    [sym_optional_pattern] = STATE(4815),
    [sym_type_check_pattern] = STATE(4815),
    [sym_attribute_pattern] = STATE(4815),
    [sym_paren_pattern] = STATE(4815),
    [sym_as_pattern] = STATE(4815),
    [sym_cons_pattern] = STATE(4815),
    [sym_disjunct_pattern] = STATE(4815),
    [sym_conjunct_pattern] = STATE(4815),
    [sym_typed_pattern] = STATE(4815),
    [sym_list_pattern] = STATE(4815),
    [sym_array_pattern] = STATE(4815),
    [sym_record_pattern] = STATE(4815),
    [sym_named_field_pattern] = STATE(4815),
    [sym_identifier_pattern] = STATE(4815),
    [sym_long_identifier_or_op] = STATE(2193),
    [sym_rule] = STATE(5720),
    [sym_rules] = STATE(6535),
    [sym_char] = STATE(4765),
    [sym_format_string] = STATE(4746),
    [sym__string_literal] = STATE(4746),
    [sym_string] = STATE(4765),
    [sym_verbatim_string] = STATE(4765),
    [sym_bytearray] = STATE(4765),
    [sym_verbatim_bytearray] = STATE(4765),
    [sym_format_triple_quoted_string] = STATE(4720),
    [sym_triple_quoted_string] = STATE(4765),
    [sym_const] = STATE(4815),
    [sym_long_identifier] = STATE(3493),
    [sym_active_pattern] = STATE(3613),
    [sym__identifier_or_op] = STATE(3650),
    [sym_sbyte] = STATE(4765),
    [sym_byte] = STATE(4765),
    [sym_int16] = STATE(4765),
    [sym_uint16] = STATE(4765),
    [sym_int32] = STATE(4765),
    [sym_uint32] = STATE(4765),
    [sym_nativeint] = STATE(4765),
    [sym_unativeint] = STATE(4765),
    [sym_int64] = STATE(4765),
    [sym_uint64] = STATE(4765),
    [sym_ieee32] = STATE(4765),
    [sym_ieee64] = STATE(4765),
    [sym_bignum] = STATE(4765),
    [sym_decimal] = STATE(4765),
    [sym_float] = STATE(4512),
    [sym_block_comment] = STATE(2529),
    [sym_compiler_directive_decl] = STATE(2529),
    [sym_fsi_directive_decl] = STATE(2529),
    [sym_preproc_line] = STATE(2529),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(4175),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_LPAREN] = ACTIONS(3572),
    [anon_sym_null] = ACTIONS(3574),
    [anon_sym__] = ACTIONS(3576),
    [anon_sym_QMARK] = ACTIONS(4177),
    [anon_sym_COLON_QMARK] = ACTIONS(4179),
    [anon_sym_PIPE] = ACTIONS(4354),
    [anon_sym_LBRACK] = ACTIONS(3582),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3584),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [aux_sym_char_token1] = ACTIONS(3590),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3592),
    [anon_sym_DQUOTE] = ACTIONS(3594),
    [anon_sym_AT_DQUOTE] = ACTIONS(3596),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3598),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3600),
    [sym_bool] = ACTIONS(3602),
    [sym_unit] = ACTIONS(3604),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4181),
    [sym_op_identifier] = ACTIONS(4183),
    [sym_int] = ACTIONS(3610),
    [sym_xint] = ACTIONS(3612),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2530] = {
    [sym_attributes] = STATE(2699),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(4815),
    [sym__pattern] = STATE(5177),
    [sym_optional_pattern] = STATE(4815),
    [sym_type_check_pattern] = STATE(4815),
    [sym_attribute_pattern] = STATE(4815),
    [sym_paren_pattern] = STATE(4815),
    [sym_as_pattern] = STATE(4815),
    [sym_cons_pattern] = STATE(4815),
    [sym_disjunct_pattern] = STATE(4815),
    [sym_conjunct_pattern] = STATE(4815),
    [sym_typed_pattern] = STATE(4815),
    [sym_list_pattern] = STATE(4815),
    [sym_array_pattern] = STATE(4815),
    [sym_record_pattern] = STATE(4815),
    [sym_named_field_pattern] = STATE(4815),
    [sym_identifier_pattern] = STATE(4815),
    [sym_long_identifier_or_op] = STATE(2193),
    [sym_rule] = STATE(1574),
    [sym_rules] = STATE(2171),
    [sym_char] = STATE(4765),
    [sym_format_string] = STATE(4746),
    [sym__string_literal] = STATE(4746),
    [sym_string] = STATE(4765),
    [sym_verbatim_string] = STATE(4765),
    [sym_bytearray] = STATE(4765),
    [sym_verbatim_bytearray] = STATE(4765),
    [sym_format_triple_quoted_string] = STATE(4720),
    [sym_triple_quoted_string] = STATE(4765),
    [sym_const] = STATE(4815),
    [sym_long_identifier] = STATE(3493),
    [sym_active_pattern] = STATE(3613),
    [sym__identifier_or_op] = STATE(3650),
    [sym_sbyte] = STATE(4765),
    [sym_byte] = STATE(4765),
    [sym_int16] = STATE(4765),
    [sym_uint16] = STATE(4765),
    [sym_int32] = STATE(4765),
    [sym_uint32] = STATE(4765),
    [sym_nativeint] = STATE(4765),
    [sym_unativeint] = STATE(4765),
    [sym_int64] = STATE(4765),
    [sym_uint64] = STATE(4765),
    [sym_ieee32] = STATE(4765),
    [sym_ieee64] = STATE(4765),
    [sym_bignum] = STATE(4765),
    [sym_decimal] = STATE(4765),
    [sym_float] = STATE(4512),
    [sym_block_comment] = STATE(2530),
    [sym_compiler_directive_decl] = STATE(2530),
    [sym_fsi_directive_decl] = STATE(2530),
    [sym_preproc_line] = STATE(2530),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(4175),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_LPAREN] = ACTIONS(3572),
    [anon_sym_null] = ACTIONS(3574),
    [anon_sym__] = ACTIONS(3576),
    [anon_sym_QMARK] = ACTIONS(4177),
    [anon_sym_COLON_QMARK] = ACTIONS(4179),
    [anon_sym_PIPE] = ACTIONS(4358),
    [anon_sym_LBRACK] = ACTIONS(3582),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3584),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [aux_sym_char_token1] = ACTIONS(3590),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3592),
    [anon_sym_DQUOTE] = ACTIONS(3594),
    [anon_sym_AT_DQUOTE] = ACTIONS(3596),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3598),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3600),
    [sym_bool] = ACTIONS(3602),
    [sym_unit] = ACTIONS(3604),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4181),
    [sym_op_identifier] = ACTIONS(4183),
    [sym_int] = ACTIONS(3610),
    [sym_xint] = ACTIONS(3612),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2531] = {
    [sym_attributes] = STATE(2699),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(4815),
    [sym__pattern] = STATE(5274),
    [sym_optional_pattern] = STATE(4815),
    [sym_type_check_pattern] = STATE(4815),
    [sym_attribute_pattern] = STATE(4815),
    [sym_paren_pattern] = STATE(4815),
    [sym_as_pattern] = STATE(4815),
    [sym_cons_pattern] = STATE(4815),
    [sym_disjunct_pattern] = STATE(4815),
    [sym_conjunct_pattern] = STATE(4815),
    [sym_typed_pattern] = STATE(4815),
    [sym_list_pattern] = STATE(4815),
    [sym_array_pattern] = STATE(4815),
    [sym_record_pattern] = STATE(4815),
    [sym_named_field_pattern] = STATE(4815),
    [sym_identifier_pattern] = STATE(4815),
    [sym_long_identifier_or_op] = STATE(2193),
    [sym_rule] = STATE(983),
    [sym_rules] = STATE(1139),
    [sym_char] = STATE(4765),
    [sym_format_string] = STATE(4746),
    [sym__string_literal] = STATE(4746),
    [sym_string] = STATE(4765),
    [sym_verbatim_string] = STATE(4765),
    [sym_bytearray] = STATE(4765),
    [sym_verbatim_bytearray] = STATE(4765),
    [sym_format_triple_quoted_string] = STATE(4720),
    [sym_triple_quoted_string] = STATE(4765),
    [sym_const] = STATE(4815),
    [sym_long_identifier] = STATE(3493),
    [sym_active_pattern] = STATE(3613),
    [sym__identifier_or_op] = STATE(3650),
    [sym_sbyte] = STATE(4765),
    [sym_byte] = STATE(4765),
    [sym_int16] = STATE(4765),
    [sym_uint16] = STATE(4765),
    [sym_int32] = STATE(4765),
    [sym_uint32] = STATE(4765),
    [sym_nativeint] = STATE(4765),
    [sym_unativeint] = STATE(4765),
    [sym_int64] = STATE(4765),
    [sym_uint64] = STATE(4765),
    [sym_ieee32] = STATE(4765),
    [sym_ieee64] = STATE(4765),
    [sym_bignum] = STATE(4765),
    [sym_decimal] = STATE(4765),
    [sym_float] = STATE(4512),
    [sym_block_comment] = STATE(2531),
    [sym_compiler_directive_decl] = STATE(2531),
    [sym_fsi_directive_decl] = STATE(2531),
    [sym_preproc_line] = STATE(2531),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(4175),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_LPAREN] = ACTIONS(3572),
    [anon_sym_null] = ACTIONS(3574),
    [anon_sym__] = ACTIONS(3576),
    [anon_sym_QMARK] = ACTIONS(4177),
    [anon_sym_COLON_QMARK] = ACTIONS(4179),
    [anon_sym_PIPE] = ACTIONS(4346),
    [anon_sym_LBRACK] = ACTIONS(3582),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3584),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [aux_sym_char_token1] = ACTIONS(3590),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3592),
    [anon_sym_DQUOTE] = ACTIONS(3594),
    [anon_sym_AT_DQUOTE] = ACTIONS(3596),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3598),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3600),
    [sym_bool] = ACTIONS(3602),
    [sym_unit] = ACTIONS(3604),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4181),
    [sym_op_identifier] = ACTIONS(4183),
    [sym_int] = ACTIONS(3610),
    [sym_xint] = ACTIONS(3612),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2532] = {
    [sym_attributes] = STATE(2699),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(4815),
    [sym__pattern] = STATE(5311),
    [sym_optional_pattern] = STATE(4815),
    [sym_type_check_pattern] = STATE(4815),
    [sym_attribute_pattern] = STATE(4815),
    [sym_paren_pattern] = STATE(4815),
    [sym_as_pattern] = STATE(4815),
    [sym_cons_pattern] = STATE(4815),
    [sym_disjunct_pattern] = STATE(4815),
    [sym_conjunct_pattern] = STATE(4815),
    [sym_typed_pattern] = STATE(4815),
    [sym_list_pattern] = STATE(4815),
    [sym_array_pattern] = STATE(4815),
    [sym_record_pattern] = STATE(4815),
    [sym_named_field_pattern] = STATE(4815),
    [sym_identifier_pattern] = STATE(4815),
    [sym_long_identifier_or_op] = STATE(2193),
    [sym_rule] = STATE(1458),
    [sym_rules] = STATE(2022),
    [sym_char] = STATE(4765),
    [sym_format_string] = STATE(4746),
    [sym__string_literal] = STATE(4746),
    [sym_string] = STATE(4765),
    [sym_verbatim_string] = STATE(4765),
    [sym_bytearray] = STATE(4765),
    [sym_verbatim_bytearray] = STATE(4765),
    [sym_format_triple_quoted_string] = STATE(4720),
    [sym_triple_quoted_string] = STATE(4765),
    [sym_const] = STATE(4815),
    [sym_long_identifier] = STATE(3493),
    [sym_active_pattern] = STATE(3613),
    [sym__identifier_or_op] = STATE(3650),
    [sym_sbyte] = STATE(4765),
    [sym_byte] = STATE(4765),
    [sym_int16] = STATE(4765),
    [sym_uint16] = STATE(4765),
    [sym_int32] = STATE(4765),
    [sym_uint32] = STATE(4765),
    [sym_nativeint] = STATE(4765),
    [sym_unativeint] = STATE(4765),
    [sym_int64] = STATE(4765),
    [sym_uint64] = STATE(4765),
    [sym_ieee32] = STATE(4765),
    [sym_ieee64] = STATE(4765),
    [sym_bignum] = STATE(4765),
    [sym_decimal] = STATE(4765),
    [sym_float] = STATE(4512),
    [sym_block_comment] = STATE(2532),
    [sym_compiler_directive_decl] = STATE(2532),
    [sym_fsi_directive_decl] = STATE(2532),
    [sym_preproc_line] = STATE(2532),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(4175),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_LPAREN] = ACTIONS(3572),
    [anon_sym_null] = ACTIONS(3574),
    [anon_sym__] = ACTIONS(3576),
    [anon_sym_QMARK] = ACTIONS(4177),
    [anon_sym_COLON_QMARK] = ACTIONS(4179),
    [anon_sym_PIPE] = ACTIONS(4366),
    [anon_sym_LBRACK] = ACTIONS(3582),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3584),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [aux_sym_char_token1] = ACTIONS(3590),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3592),
    [anon_sym_DQUOTE] = ACTIONS(3594),
    [anon_sym_AT_DQUOTE] = ACTIONS(3596),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3598),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3600),
    [sym_bool] = ACTIONS(3602),
    [sym_unit] = ACTIONS(3604),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4181),
    [sym_op_identifier] = ACTIONS(4183),
    [sym_int] = ACTIONS(3610),
    [sym_xint] = ACTIONS(3612),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2533] = {
    [sym_attributes] = STATE(2699),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(4815),
    [sym__pattern] = STATE(5282),
    [sym_optional_pattern] = STATE(4815),
    [sym_type_check_pattern] = STATE(4815),
    [sym_attribute_pattern] = STATE(4815),
    [sym_paren_pattern] = STATE(4815),
    [sym_as_pattern] = STATE(4815),
    [sym_cons_pattern] = STATE(4815),
    [sym_disjunct_pattern] = STATE(4815),
    [sym_conjunct_pattern] = STATE(4815),
    [sym_typed_pattern] = STATE(4815),
    [sym_list_pattern] = STATE(4815),
    [sym_array_pattern] = STATE(4815),
    [sym_record_pattern] = STATE(4815),
    [sym_named_field_pattern] = STATE(4815),
    [sym_identifier_pattern] = STATE(4815),
    [sym_long_identifier_or_op] = STATE(2193),
    [sym_rule] = STATE(5720),
    [sym_rules] = STATE(7059),
    [sym_char] = STATE(4765),
    [sym_format_string] = STATE(4746),
    [sym__string_literal] = STATE(4746),
    [sym_string] = STATE(4765),
    [sym_verbatim_string] = STATE(4765),
    [sym_bytearray] = STATE(4765),
    [sym_verbatim_bytearray] = STATE(4765),
    [sym_format_triple_quoted_string] = STATE(4720),
    [sym_triple_quoted_string] = STATE(4765),
    [sym_const] = STATE(4815),
    [sym_long_identifier] = STATE(3493),
    [sym_active_pattern] = STATE(3613),
    [sym__identifier_or_op] = STATE(3650),
    [sym_sbyte] = STATE(4765),
    [sym_byte] = STATE(4765),
    [sym_int16] = STATE(4765),
    [sym_uint16] = STATE(4765),
    [sym_int32] = STATE(4765),
    [sym_uint32] = STATE(4765),
    [sym_nativeint] = STATE(4765),
    [sym_unativeint] = STATE(4765),
    [sym_int64] = STATE(4765),
    [sym_uint64] = STATE(4765),
    [sym_ieee32] = STATE(4765),
    [sym_ieee64] = STATE(4765),
    [sym_bignum] = STATE(4765),
    [sym_decimal] = STATE(4765),
    [sym_float] = STATE(4512),
    [sym_block_comment] = STATE(2533),
    [sym_compiler_directive_decl] = STATE(2533),
    [sym_fsi_directive_decl] = STATE(2533),
    [sym_preproc_line] = STATE(2533),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(4175),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_LPAREN] = ACTIONS(3572),
    [anon_sym_null] = ACTIONS(3574),
    [anon_sym__] = ACTIONS(3576),
    [anon_sym_QMARK] = ACTIONS(4177),
    [anon_sym_COLON_QMARK] = ACTIONS(4179),
    [anon_sym_PIPE] = ACTIONS(4354),
    [anon_sym_LBRACK] = ACTIONS(3582),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3584),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [aux_sym_char_token1] = ACTIONS(3590),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3592),
    [anon_sym_DQUOTE] = ACTIONS(3594),
    [anon_sym_AT_DQUOTE] = ACTIONS(3596),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3598),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3600),
    [sym_bool] = ACTIONS(3602),
    [sym_unit] = ACTIONS(3604),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4181),
    [sym_op_identifier] = ACTIONS(4183),
    [sym_int] = ACTIONS(3610),
    [sym_xint] = ACTIONS(3612),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2534] = {
    [sym_attributes] = STATE(2699),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(4815),
    [sym__pattern] = STATE(5282),
    [sym_optional_pattern] = STATE(4815),
    [sym_type_check_pattern] = STATE(4815),
    [sym_attribute_pattern] = STATE(4815),
    [sym_paren_pattern] = STATE(4815),
    [sym_as_pattern] = STATE(4815),
    [sym_cons_pattern] = STATE(4815),
    [sym_disjunct_pattern] = STATE(4815),
    [sym_conjunct_pattern] = STATE(4815),
    [sym_typed_pattern] = STATE(4815),
    [sym_list_pattern] = STATE(4815),
    [sym_array_pattern] = STATE(4815),
    [sym_record_pattern] = STATE(4815),
    [sym_named_field_pattern] = STATE(4815),
    [sym_identifier_pattern] = STATE(4815),
    [sym_long_identifier_or_op] = STATE(2193),
    [sym_rule] = STATE(5720),
    [sym_rules] = STATE(7031),
    [sym_char] = STATE(4765),
    [sym_format_string] = STATE(4746),
    [sym__string_literal] = STATE(4746),
    [sym_string] = STATE(4765),
    [sym_verbatim_string] = STATE(4765),
    [sym_bytearray] = STATE(4765),
    [sym_verbatim_bytearray] = STATE(4765),
    [sym_format_triple_quoted_string] = STATE(4720),
    [sym_triple_quoted_string] = STATE(4765),
    [sym_const] = STATE(4815),
    [sym_long_identifier] = STATE(3493),
    [sym_active_pattern] = STATE(3613),
    [sym__identifier_or_op] = STATE(3650),
    [sym_sbyte] = STATE(4765),
    [sym_byte] = STATE(4765),
    [sym_int16] = STATE(4765),
    [sym_uint16] = STATE(4765),
    [sym_int32] = STATE(4765),
    [sym_uint32] = STATE(4765),
    [sym_nativeint] = STATE(4765),
    [sym_unativeint] = STATE(4765),
    [sym_int64] = STATE(4765),
    [sym_uint64] = STATE(4765),
    [sym_ieee32] = STATE(4765),
    [sym_ieee64] = STATE(4765),
    [sym_bignum] = STATE(4765),
    [sym_decimal] = STATE(4765),
    [sym_float] = STATE(4512),
    [sym_block_comment] = STATE(2534),
    [sym_compiler_directive_decl] = STATE(2534),
    [sym_fsi_directive_decl] = STATE(2534),
    [sym_preproc_line] = STATE(2534),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(4175),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_LPAREN] = ACTIONS(3572),
    [anon_sym_null] = ACTIONS(3574),
    [anon_sym__] = ACTIONS(3576),
    [anon_sym_QMARK] = ACTIONS(4177),
    [anon_sym_COLON_QMARK] = ACTIONS(4179),
    [anon_sym_PIPE] = ACTIONS(4354),
    [anon_sym_LBRACK] = ACTIONS(3582),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3584),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [aux_sym_char_token1] = ACTIONS(3590),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3592),
    [anon_sym_DQUOTE] = ACTIONS(3594),
    [anon_sym_AT_DQUOTE] = ACTIONS(3596),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3598),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3600),
    [sym_bool] = ACTIONS(3602),
    [sym_unit] = ACTIONS(3604),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4181),
    [sym_op_identifier] = ACTIONS(4183),
    [sym_int] = ACTIONS(3610),
    [sym_xint] = ACTIONS(3612),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2535] = {
    [sym_attributes] = STATE(2699),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(4815),
    [sym__pattern] = STATE(5311),
    [sym_optional_pattern] = STATE(4815),
    [sym_type_check_pattern] = STATE(4815),
    [sym_attribute_pattern] = STATE(4815),
    [sym_paren_pattern] = STATE(4815),
    [sym_as_pattern] = STATE(4815),
    [sym_cons_pattern] = STATE(4815),
    [sym_disjunct_pattern] = STATE(4815),
    [sym_conjunct_pattern] = STATE(4815),
    [sym_typed_pattern] = STATE(4815),
    [sym_list_pattern] = STATE(4815),
    [sym_array_pattern] = STATE(4815),
    [sym_record_pattern] = STATE(4815),
    [sym_named_field_pattern] = STATE(4815),
    [sym_identifier_pattern] = STATE(4815),
    [sym_long_identifier_or_op] = STATE(2193),
    [sym_rule] = STATE(1458),
    [sym_rules] = STATE(2030),
    [sym_char] = STATE(4765),
    [sym_format_string] = STATE(4746),
    [sym__string_literal] = STATE(4746),
    [sym_string] = STATE(4765),
    [sym_verbatim_string] = STATE(4765),
    [sym_bytearray] = STATE(4765),
    [sym_verbatim_bytearray] = STATE(4765),
    [sym_format_triple_quoted_string] = STATE(4720),
    [sym_triple_quoted_string] = STATE(4765),
    [sym_const] = STATE(4815),
    [sym_long_identifier] = STATE(3493),
    [sym_active_pattern] = STATE(3613),
    [sym__identifier_or_op] = STATE(3650),
    [sym_sbyte] = STATE(4765),
    [sym_byte] = STATE(4765),
    [sym_int16] = STATE(4765),
    [sym_uint16] = STATE(4765),
    [sym_int32] = STATE(4765),
    [sym_uint32] = STATE(4765),
    [sym_nativeint] = STATE(4765),
    [sym_unativeint] = STATE(4765),
    [sym_int64] = STATE(4765),
    [sym_uint64] = STATE(4765),
    [sym_ieee32] = STATE(4765),
    [sym_ieee64] = STATE(4765),
    [sym_bignum] = STATE(4765),
    [sym_decimal] = STATE(4765),
    [sym_float] = STATE(4512),
    [sym_block_comment] = STATE(2535),
    [sym_compiler_directive_decl] = STATE(2535),
    [sym_fsi_directive_decl] = STATE(2535),
    [sym_preproc_line] = STATE(2535),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(4175),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_LPAREN] = ACTIONS(3572),
    [anon_sym_null] = ACTIONS(3574),
    [anon_sym__] = ACTIONS(3576),
    [anon_sym_QMARK] = ACTIONS(4177),
    [anon_sym_COLON_QMARK] = ACTIONS(4179),
    [anon_sym_PIPE] = ACTIONS(4366),
    [anon_sym_LBRACK] = ACTIONS(3582),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3584),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [aux_sym_char_token1] = ACTIONS(3590),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3592),
    [anon_sym_DQUOTE] = ACTIONS(3594),
    [anon_sym_AT_DQUOTE] = ACTIONS(3596),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3598),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3600),
    [sym_bool] = ACTIONS(3602),
    [sym_unit] = ACTIONS(3604),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4181),
    [sym_op_identifier] = ACTIONS(4183),
    [sym_int] = ACTIONS(3610),
    [sym_xint] = ACTIONS(3612),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2536] = {
    [sym_attributes] = STATE(2699),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(4815),
    [sym__pattern] = STATE(5311),
    [sym_optional_pattern] = STATE(4815),
    [sym_type_check_pattern] = STATE(4815),
    [sym_attribute_pattern] = STATE(4815),
    [sym_paren_pattern] = STATE(4815),
    [sym_as_pattern] = STATE(4815),
    [sym_cons_pattern] = STATE(4815),
    [sym_disjunct_pattern] = STATE(4815),
    [sym_conjunct_pattern] = STATE(4815),
    [sym_typed_pattern] = STATE(4815),
    [sym_list_pattern] = STATE(4815),
    [sym_array_pattern] = STATE(4815),
    [sym_record_pattern] = STATE(4815),
    [sym_named_field_pattern] = STATE(4815),
    [sym_identifier_pattern] = STATE(4815),
    [sym_long_identifier_or_op] = STATE(2193),
    [sym_rule] = STATE(1458),
    [sym_rules] = STATE(2031),
    [sym_char] = STATE(4765),
    [sym_format_string] = STATE(4746),
    [sym__string_literal] = STATE(4746),
    [sym_string] = STATE(4765),
    [sym_verbatim_string] = STATE(4765),
    [sym_bytearray] = STATE(4765),
    [sym_verbatim_bytearray] = STATE(4765),
    [sym_format_triple_quoted_string] = STATE(4720),
    [sym_triple_quoted_string] = STATE(4765),
    [sym_const] = STATE(4815),
    [sym_long_identifier] = STATE(3493),
    [sym_active_pattern] = STATE(3613),
    [sym__identifier_or_op] = STATE(3650),
    [sym_sbyte] = STATE(4765),
    [sym_byte] = STATE(4765),
    [sym_int16] = STATE(4765),
    [sym_uint16] = STATE(4765),
    [sym_int32] = STATE(4765),
    [sym_uint32] = STATE(4765),
    [sym_nativeint] = STATE(4765),
    [sym_unativeint] = STATE(4765),
    [sym_int64] = STATE(4765),
    [sym_uint64] = STATE(4765),
    [sym_ieee32] = STATE(4765),
    [sym_ieee64] = STATE(4765),
    [sym_bignum] = STATE(4765),
    [sym_decimal] = STATE(4765),
    [sym_float] = STATE(4512),
    [sym_block_comment] = STATE(2536),
    [sym_compiler_directive_decl] = STATE(2536),
    [sym_fsi_directive_decl] = STATE(2536),
    [sym_preproc_line] = STATE(2536),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(4175),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_LPAREN] = ACTIONS(3572),
    [anon_sym_null] = ACTIONS(3574),
    [anon_sym__] = ACTIONS(3576),
    [anon_sym_QMARK] = ACTIONS(4177),
    [anon_sym_COLON_QMARK] = ACTIONS(4179),
    [anon_sym_PIPE] = ACTIONS(4366),
    [anon_sym_LBRACK] = ACTIONS(3582),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3584),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [aux_sym_char_token1] = ACTIONS(3590),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3592),
    [anon_sym_DQUOTE] = ACTIONS(3594),
    [anon_sym_AT_DQUOTE] = ACTIONS(3596),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3598),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3600),
    [sym_bool] = ACTIONS(3602),
    [sym_unit] = ACTIONS(3604),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4181),
    [sym_op_identifier] = ACTIONS(4183),
    [sym_int] = ACTIONS(3610),
    [sym_xint] = ACTIONS(3612),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2537] = {
    [sym_attributes] = STATE(2699),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(4815),
    [sym__pattern] = STATE(5311),
    [sym_optional_pattern] = STATE(4815),
    [sym_type_check_pattern] = STATE(4815),
    [sym_attribute_pattern] = STATE(4815),
    [sym_paren_pattern] = STATE(4815),
    [sym_as_pattern] = STATE(4815),
    [sym_cons_pattern] = STATE(4815),
    [sym_disjunct_pattern] = STATE(4815),
    [sym_conjunct_pattern] = STATE(4815),
    [sym_typed_pattern] = STATE(4815),
    [sym_list_pattern] = STATE(4815),
    [sym_array_pattern] = STATE(4815),
    [sym_record_pattern] = STATE(4815),
    [sym_named_field_pattern] = STATE(4815),
    [sym_identifier_pattern] = STATE(4815),
    [sym_long_identifier_or_op] = STATE(2193),
    [sym_rule] = STATE(1458),
    [sym_rules] = STATE(2050),
    [sym_char] = STATE(4765),
    [sym_format_string] = STATE(4746),
    [sym__string_literal] = STATE(4746),
    [sym_string] = STATE(4765),
    [sym_verbatim_string] = STATE(4765),
    [sym_bytearray] = STATE(4765),
    [sym_verbatim_bytearray] = STATE(4765),
    [sym_format_triple_quoted_string] = STATE(4720),
    [sym_triple_quoted_string] = STATE(4765),
    [sym_const] = STATE(4815),
    [sym_long_identifier] = STATE(3493),
    [sym_active_pattern] = STATE(3613),
    [sym__identifier_or_op] = STATE(3650),
    [sym_sbyte] = STATE(4765),
    [sym_byte] = STATE(4765),
    [sym_int16] = STATE(4765),
    [sym_uint16] = STATE(4765),
    [sym_int32] = STATE(4765),
    [sym_uint32] = STATE(4765),
    [sym_nativeint] = STATE(4765),
    [sym_unativeint] = STATE(4765),
    [sym_int64] = STATE(4765),
    [sym_uint64] = STATE(4765),
    [sym_ieee32] = STATE(4765),
    [sym_ieee64] = STATE(4765),
    [sym_bignum] = STATE(4765),
    [sym_decimal] = STATE(4765),
    [sym_float] = STATE(4512),
    [sym_block_comment] = STATE(2537),
    [sym_compiler_directive_decl] = STATE(2537),
    [sym_fsi_directive_decl] = STATE(2537),
    [sym_preproc_line] = STATE(2537),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(4175),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_LPAREN] = ACTIONS(3572),
    [anon_sym_null] = ACTIONS(3574),
    [anon_sym__] = ACTIONS(3576),
    [anon_sym_QMARK] = ACTIONS(4177),
    [anon_sym_COLON_QMARK] = ACTIONS(4179),
    [anon_sym_PIPE] = ACTIONS(4366),
    [anon_sym_LBRACK] = ACTIONS(3582),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3584),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [aux_sym_char_token1] = ACTIONS(3590),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3592),
    [anon_sym_DQUOTE] = ACTIONS(3594),
    [anon_sym_AT_DQUOTE] = ACTIONS(3596),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3598),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3600),
    [sym_bool] = ACTIONS(3602),
    [sym_unit] = ACTIONS(3604),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4181),
    [sym_op_identifier] = ACTIONS(4183),
    [sym_int] = ACTIONS(3610),
    [sym_xint] = ACTIONS(3612),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2538] = {
    [sym_attributes] = STATE(2699),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(4815),
    [sym__pattern] = STATE(5282),
    [sym_optional_pattern] = STATE(4815),
    [sym_type_check_pattern] = STATE(4815),
    [sym_attribute_pattern] = STATE(4815),
    [sym_paren_pattern] = STATE(4815),
    [sym_as_pattern] = STATE(4815),
    [sym_cons_pattern] = STATE(4815),
    [sym_disjunct_pattern] = STATE(4815),
    [sym_conjunct_pattern] = STATE(4815),
    [sym_typed_pattern] = STATE(4815),
    [sym_list_pattern] = STATE(4815),
    [sym_array_pattern] = STATE(4815),
    [sym_record_pattern] = STATE(4815),
    [sym_named_field_pattern] = STATE(4815),
    [sym_identifier_pattern] = STATE(4815),
    [sym_long_identifier_or_op] = STATE(2193),
    [sym_rule] = STATE(5720),
    [sym_rules] = STATE(7327),
    [sym_char] = STATE(4765),
    [sym_format_string] = STATE(4746),
    [sym__string_literal] = STATE(4746),
    [sym_string] = STATE(4765),
    [sym_verbatim_string] = STATE(4765),
    [sym_bytearray] = STATE(4765),
    [sym_verbatim_bytearray] = STATE(4765),
    [sym_format_triple_quoted_string] = STATE(4720),
    [sym_triple_quoted_string] = STATE(4765),
    [sym_const] = STATE(4815),
    [sym_long_identifier] = STATE(3493),
    [sym_active_pattern] = STATE(3613),
    [sym__identifier_or_op] = STATE(3650),
    [sym_sbyte] = STATE(4765),
    [sym_byte] = STATE(4765),
    [sym_int16] = STATE(4765),
    [sym_uint16] = STATE(4765),
    [sym_int32] = STATE(4765),
    [sym_uint32] = STATE(4765),
    [sym_nativeint] = STATE(4765),
    [sym_unativeint] = STATE(4765),
    [sym_int64] = STATE(4765),
    [sym_uint64] = STATE(4765),
    [sym_ieee32] = STATE(4765),
    [sym_ieee64] = STATE(4765),
    [sym_bignum] = STATE(4765),
    [sym_decimal] = STATE(4765),
    [sym_float] = STATE(4512),
    [sym_block_comment] = STATE(2538),
    [sym_compiler_directive_decl] = STATE(2538),
    [sym_fsi_directive_decl] = STATE(2538),
    [sym_preproc_line] = STATE(2538),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(4175),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_LPAREN] = ACTIONS(3572),
    [anon_sym_null] = ACTIONS(3574),
    [anon_sym__] = ACTIONS(3576),
    [anon_sym_QMARK] = ACTIONS(4177),
    [anon_sym_COLON_QMARK] = ACTIONS(4179),
    [anon_sym_PIPE] = ACTIONS(4354),
    [anon_sym_LBRACK] = ACTIONS(3582),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3584),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [aux_sym_char_token1] = ACTIONS(3590),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3592),
    [anon_sym_DQUOTE] = ACTIONS(3594),
    [anon_sym_AT_DQUOTE] = ACTIONS(3596),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3598),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3600),
    [sym_bool] = ACTIONS(3602),
    [sym_unit] = ACTIONS(3604),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4181),
    [sym_op_identifier] = ACTIONS(4183),
    [sym_int] = ACTIONS(3610),
    [sym_xint] = ACTIONS(3612),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2539] = {
    [sym_attributes] = STATE(2699),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(4815),
    [sym__pattern] = STATE(5212),
    [sym_optional_pattern] = STATE(4815),
    [sym_type_check_pattern] = STATE(4815),
    [sym_attribute_pattern] = STATE(4815),
    [sym_paren_pattern] = STATE(4815),
    [sym_as_pattern] = STATE(4815),
    [sym_cons_pattern] = STATE(4815),
    [sym_disjunct_pattern] = STATE(4815),
    [sym_conjunct_pattern] = STATE(4815),
    [sym_typed_pattern] = STATE(4815),
    [sym_list_pattern] = STATE(4815),
    [sym_array_pattern] = STATE(4815),
    [sym_record_pattern] = STATE(4815),
    [sym_named_field_pattern] = STATE(4815),
    [sym_identifier_pattern] = STATE(4815),
    [sym_long_identifier_or_op] = STATE(2193),
    [sym_rule] = STATE(1497),
    [sym_rules] = STATE(2356),
    [sym_char] = STATE(4765),
    [sym_format_string] = STATE(4746),
    [sym__string_literal] = STATE(4746),
    [sym_string] = STATE(4765),
    [sym_verbatim_string] = STATE(4765),
    [sym_bytearray] = STATE(4765),
    [sym_verbatim_bytearray] = STATE(4765),
    [sym_format_triple_quoted_string] = STATE(4720),
    [sym_triple_quoted_string] = STATE(4765),
    [sym_const] = STATE(4815),
    [sym_long_identifier] = STATE(3493),
    [sym_active_pattern] = STATE(3613),
    [sym__identifier_or_op] = STATE(3650),
    [sym_sbyte] = STATE(4765),
    [sym_byte] = STATE(4765),
    [sym_int16] = STATE(4765),
    [sym_uint16] = STATE(4765),
    [sym_int32] = STATE(4765),
    [sym_uint32] = STATE(4765),
    [sym_nativeint] = STATE(4765),
    [sym_unativeint] = STATE(4765),
    [sym_int64] = STATE(4765),
    [sym_uint64] = STATE(4765),
    [sym_ieee32] = STATE(4765),
    [sym_ieee64] = STATE(4765),
    [sym_bignum] = STATE(4765),
    [sym_decimal] = STATE(4765),
    [sym_float] = STATE(4512),
    [sym_block_comment] = STATE(2539),
    [sym_compiler_directive_decl] = STATE(2539),
    [sym_fsi_directive_decl] = STATE(2539),
    [sym_preproc_line] = STATE(2539),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(4175),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_LPAREN] = ACTIONS(3572),
    [anon_sym_null] = ACTIONS(3574),
    [anon_sym__] = ACTIONS(3576),
    [anon_sym_QMARK] = ACTIONS(4177),
    [anon_sym_COLON_QMARK] = ACTIONS(4179),
    [anon_sym_PIPE] = ACTIONS(4364),
    [anon_sym_LBRACK] = ACTIONS(3582),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3584),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [aux_sym_char_token1] = ACTIONS(3590),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3592),
    [anon_sym_DQUOTE] = ACTIONS(3594),
    [anon_sym_AT_DQUOTE] = ACTIONS(3596),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3598),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3600),
    [sym_bool] = ACTIONS(3602),
    [sym_unit] = ACTIONS(3604),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4181),
    [sym_op_identifier] = ACTIONS(4183),
    [sym_int] = ACTIONS(3610),
    [sym_xint] = ACTIONS(3612),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2540] = {
    [sym_attributes] = STATE(2699),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(4815),
    [sym__pattern] = STATE(5282),
    [sym_optional_pattern] = STATE(4815),
    [sym_type_check_pattern] = STATE(4815),
    [sym_attribute_pattern] = STATE(4815),
    [sym_paren_pattern] = STATE(4815),
    [sym_as_pattern] = STATE(4815),
    [sym_cons_pattern] = STATE(4815),
    [sym_disjunct_pattern] = STATE(4815),
    [sym_conjunct_pattern] = STATE(4815),
    [sym_typed_pattern] = STATE(4815),
    [sym_list_pattern] = STATE(4815),
    [sym_array_pattern] = STATE(4815),
    [sym_record_pattern] = STATE(4815),
    [sym_named_field_pattern] = STATE(4815),
    [sym_identifier_pattern] = STATE(4815),
    [sym_long_identifier_or_op] = STATE(2193),
    [sym_rule] = STATE(5720),
    [sym_rules] = STATE(6566),
    [sym_char] = STATE(4765),
    [sym_format_string] = STATE(4746),
    [sym__string_literal] = STATE(4746),
    [sym_string] = STATE(4765),
    [sym_verbatim_string] = STATE(4765),
    [sym_bytearray] = STATE(4765),
    [sym_verbatim_bytearray] = STATE(4765),
    [sym_format_triple_quoted_string] = STATE(4720),
    [sym_triple_quoted_string] = STATE(4765),
    [sym_const] = STATE(4815),
    [sym_long_identifier] = STATE(3493),
    [sym_active_pattern] = STATE(3613),
    [sym__identifier_or_op] = STATE(3650),
    [sym_sbyte] = STATE(4765),
    [sym_byte] = STATE(4765),
    [sym_int16] = STATE(4765),
    [sym_uint16] = STATE(4765),
    [sym_int32] = STATE(4765),
    [sym_uint32] = STATE(4765),
    [sym_nativeint] = STATE(4765),
    [sym_unativeint] = STATE(4765),
    [sym_int64] = STATE(4765),
    [sym_uint64] = STATE(4765),
    [sym_ieee32] = STATE(4765),
    [sym_ieee64] = STATE(4765),
    [sym_bignum] = STATE(4765),
    [sym_decimal] = STATE(4765),
    [sym_float] = STATE(4512),
    [sym_block_comment] = STATE(2540),
    [sym_compiler_directive_decl] = STATE(2540),
    [sym_fsi_directive_decl] = STATE(2540),
    [sym_preproc_line] = STATE(2540),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(4175),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_LPAREN] = ACTIONS(3572),
    [anon_sym_null] = ACTIONS(3574),
    [anon_sym__] = ACTIONS(3576),
    [anon_sym_QMARK] = ACTIONS(4177),
    [anon_sym_COLON_QMARK] = ACTIONS(4179),
    [anon_sym_PIPE] = ACTIONS(4354),
    [anon_sym_LBRACK] = ACTIONS(3582),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3584),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [aux_sym_char_token1] = ACTIONS(3590),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3592),
    [anon_sym_DQUOTE] = ACTIONS(3594),
    [anon_sym_AT_DQUOTE] = ACTIONS(3596),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3598),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3600),
    [sym_bool] = ACTIONS(3602),
    [sym_unit] = ACTIONS(3604),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4181),
    [sym_op_identifier] = ACTIONS(4183),
    [sym_int] = ACTIONS(3610),
    [sym_xint] = ACTIONS(3612),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2541] = {
    [sym_attributes] = STATE(2699),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(4815),
    [sym__pattern] = STATE(5282),
    [sym_optional_pattern] = STATE(4815),
    [sym_type_check_pattern] = STATE(4815),
    [sym_attribute_pattern] = STATE(4815),
    [sym_paren_pattern] = STATE(4815),
    [sym_as_pattern] = STATE(4815),
    [sym_cons_pattern] = STATE(4815),
    [sym_disjunct_pattern] = STATE(4815),
    [sym_conjunct_pattern] = STATE(4815),
    [sym_typed_pattern] = STATE(4815),
    [sym_list_pattern] = STATE(4815),
    [sym_array_pattern] = STATE(4815),
    [sym_record_pattern] = STATE(4815),
    [sym_named_field_pattern] = STATE(4815),
    [sym_identifier_pattern] = STATE(4815),
    [sym_long_identifier_or_op] = STATE(2193),
    [sym_rule] = STATE(5720),
    [sym_rules] = STATE(6751),
    [sym_char] = STATE(4765),
    [sym_format_string] = STATE(4746),
    [sym__string_literal] = STATE(4746),
    [sym_string] = STATE(4765),
    [sym_verbatim_string] = STATE(4765),
    [sym_bytearray] = STATE(4765),
    [sym_verbatim_bytearray] = STATE(4765),
    [sym_format_triple_quoted_string] = STATE(4720),
    [sym_triple_quoted_string] = STATE(4765),
    [sym_const] = STATE(4815),
    [sym_long_identifier] = STATE(3493),
    [sym_active_pattern] = STATE(3613),
    [sym__identifier_or_op] = STATE(3650),
    [sym_sbyte] = STATE(4765),
    [sym_byte] = STATE(4765),
    [sym_int16] = STATE(4765),
    [sym_uint16] = STATE(4765),
    [sym_int32] = STATE(4765),
    [sym_uint32] = STATE(4765),
    [sym_nativeint] = STATE(4765),
    [sym_unativeint] = STATE(4765),
    [sym_int64] = STATE(4765),
    [sym_uint64] = STATE(4765),
    [sym_ieee32] = STATE(4765),
    [sym_ieee64] = STATE(4765),
    [sym_bignum] = STATE(4765),
    [sym_decimal] = STATE(4765),
    [sym_float] = STATE(4512),
    [sym_block_comment] = STATE(2541),
    [sym_compiler_directive_decl] = STATE(2541),
    [sym_fsi_directive_decl] = STATE(2541),
    [sym_preproc_line] = STATE(2541),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(4175),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_LPAREN] = ACTIONS(3572),
    [anon_sym_null] = ACTIONS(3574),
    [anon_sym__] = ACTIONS(3576),
    [anon_sym_QMARK] = ACTIONS(4177),
    [anon_sym_COLON_QMARK] = ACTIONS(4179),
    [anon_sym_PIPE] = ACTIONS(4354),
    [anon_sym_LBRACK] = ACTIONS(3582),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3584),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [aux_sym_char_token1] = ACTIONS(3590),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3592),
    [anon_sym_DQUOTE] = ACTIONS(3594),
    [anon_sym_AT_DQUOTE] = ACTIONS(3596),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3598),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3600),
    [sym_bool] = ACTIONS(3602),
    [sym_unit] = ACTIONS(3604),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4181),
    [sym_op_identifier] = ACTIONS(4183),
    [sym_int] = ACTIONS(3610),
    [sym_xint] = ACTIONS(3612),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2542] = {
    [sym_attributes] = STATE(2699),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(4815),
    [sym__pattern] = STATE(5323),
    [sym_optional_pattern] = STATE(4815),
    [sym_type_check_pattern] = STATE(4815),
    [sym_attribute_pattern] = STATE(4815),
    [sym_paren_pattern] = STATE(4815),
    [sym_as_pattern] = STATE(4815),
    [sym_cons_pattern] = STATE(4815),
    [sym_disjunct_pattern] = STATE(4815),
    [sym_conjunct_pattern] = STATE(4815),
    [sym_typed_pattern] = STATE(4815),
    [sym_list_pattern] = STATE(4815),
    [sym_array_pattern] = STATE(4815),
    [sym_record_pattern] = STATE(4815),
    [sym_named_field_pattern] = STATE(4815),
    [sym_identifier_pattern] = STATE(4815),
    [sym_long_identifier_or_op] = STATE(2193),
    [sym_rule] = STATE(1461),
    [sym_rules] = STATE(1976),
    [sym_char] = STATE(4765),
    [sym_format_string] = STATE(4746),
    [sym__string_literal] = STATE(4746),
    [sym_string] = STATE(4765),
    [sym_verbatim_string] = STATE(4765),
    [sym_bytearray] = STATE(4765),
    [sym_verbatim_bytearray] = STATE(4765),
    [sym_format_triple_quoted_string] = STATE(4720),
    [sym_triple_quoted_string] = STATE(4765),
    [sym_const] = STATE(4815),
    [sym_long_identifier] = STATE(3493),
    [sym_active_pattern] = STATE(3613),
    [sym__identifier_or_op] = STATE(3650),
    [sym_sbyte] = STATE(4765),
    [sym_byte] = STATE(4765),
    [sym_int16] = STATE(4765),
    [sym_uint16] = STATE(4765),
    [sym_int32] = STATE(4765),
    [sym_uint32] = STATE(4765),
    [sym_nativeint] = STATE(4765),
    [sym_unativeint] = STATE(4765),
    [sym_int64] = STATE(4765),
    [sym_uint64] = STATE(4765),
    [sym_ieee32] = STATE(4765),
    [sym_ieee64] = STATE(4765),
    [sym_bignum] = STATE(4765),
    [sym_decimal] = STATE(4765),
    [sym_float] = STATE(4512),
    [sym_block_comment] = STATE(2542),
    [sym_compiler_directive_decl] = STATE(2542),
    [sym_fsi_directive_decl] = STATE(2542),
    [sym_preproc_line] = STATE(2542),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(4175),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_LPAREN] = ACTIONS(3572),
    [anon_sym_null] = ACTIONS(3574),
    [anon_sym__] = ACTIONS(3576),
    [anon_sym_QMARK] = ACTIONS(4177),
    [anon_sym_COLON_QMARK] = ACTIONS(4179),
    [anon_sym_PIPE] = ACTIONS(4344),
    [anon_sym_LBRACK] = ACTIONS(3582),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3584),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [aux_sym_char_token1] = ACTIONS(3590),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3592),
    [anon_sym_DQUOTE] = ACTIONS(3594),
    [anon_sym_AT_DQUOTE] = ACTIONS(3596),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3598),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3600),
    [sym_bool] = ACTIONS(3602),
    [sym_unit] = ACTIONS(3604),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4181),
    [sym_op_identifier] = ACTIONS(4183),
    [sym_int] = ACTIONS(3610),
    [sym_xint] = ACTIONS(3612),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2543] = {
    [sym_attributes] = STATE(2699),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(4815),
    [sym__pattern] = STATE(5282),
    [sym_optional_pattern] = STATE(4815),
    [sym_type_check_pattern] = STATE(4815),
    [sym_attribute_pattern] = STATE(4815),
    [sym_paren_pattern] = STATE(4815),
    [sym_as_pattern] = STATE(4815),
    [sym_cons_pattern] = STATE(4815),
    [sym_disjunct_pattern] = STATE(4815),
    [sym_conjunct_pattern] = STATE(4815),
    [sym_typed_pattern] = STATE(4815),
    [sym_list_pattern] = STATE(4815),
    [sym_array_pattern] = STATE(4815),
    [sym_record_pattern] = STATE(4815),
    [sym_named_field_pattern] = STATE(4815),
    [sym_identifier_pattern] = STATE(4815),
    [sym_long_identifier_or_op] = STATE(2193),
    [sym_rule] = STATE(5720),
    [sym_rules] = STATE(7439),
    [sym_char] = STATE(4765),
    [sym_format_string] = STATE(4746),
    [sym__string_literal] = STATE(4746),
    [sym_string] = STATE(4765),
    [sym_verbatim_string] = STATE(4765),
    [sym_bytearray] = STATE(4765),
    [sym_verbatim_bytearray] = STATE(4765),
    [sym_format_triple_quoted_string] = STATE(4720),
    [sym_triple_quoted_string] = STATE(4765),
    [sym_const] = STATE(4815),
    [sym_long_identifier] = STATE(3493),
    [sym_active_pattern] = STATE(3613),
    [sym__identifier_or_op] = STATE(3650),
    [sym_sbyte] = STATE(4765),
    [sym_byte] = STATE(4765),
    [sym_int16] = STATE(4765),
    [sym_uint16] = STATE(4765),
    [sym_int32] = STATE(4765),
    [sym_uint32] = STATE(4765),
    [sym_nativeint] = STATE(4765),
    [sym_unativeint] = STATE(4765),
    [sym_int64] = STATE(4765),
    [sym_uint64] = STATE(4765),
    [sym_ieee32] = STATE(4765),
    [sym_ieee64] = STATE(4765),
    [sym_bignum] = STATE(4765),
    [sym_decimal] = STATE(4765),
    [sym_float] = STATE(4512),
    [sym_block_comment] = STATE(2543),
    [sym_compiler_directive_decl] = STATE(2543),
    [sym_fsi_directive_decl] = STATE(2543),
    [sym_preproc_line] = STATE(2543),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(4175),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_LPAREN] = ACTIONS(3572),
    [anon_sym_null] = ACTIONS(3574),
    [anon_sym__] = ACTIONS(3576),
    [anon_sym_QMARK] = ACTIONS(4177),
    [anon_sym_COLON_QMARK] = ACTIONS(4179),
    [anon_sym_PIPE] = ACTIONS(4354),
    [anon_sym_LBRACK] = ACTIONS(3582),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3584),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [aux_sym_char_token1] = ACTIONS(3590),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3592),
    [anon_sym_DQUOTE] = ACTIONS(3594),
    [anon_sym_AT_DQUOTE] = ACTIONS(3596),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3598),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3600),
    [sym_bool] = ACTIONS(3602),
    [sym_unit] = ACTIONS(3604),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4181),
    [sym_op_identifier] = ACTIONS(4183),
    [sym_int] = ACTIONS(3610),
    [sym_xint] = ACTIONS(3612),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2544] = {
    [sym_attributes] = STATE(2699),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(4815),
    [sym__pattern] = STATE(5282),
    [sym_optional_pattern] = STATE(4815),
    [sym_type_check_pattern] = STATE(4815),
    [sym_attribute_pattern] = STATE(4815),
    [sym_paren_pattern] = STATE(4815),
    [sym_as_pattern] = STATE(4815),
    [sym_cons_pattern] = STATE(4815),
    [sym_disjunct_pattern] = STATE(4815),
    [sym_conjunct_pattern] = STATE(4815),
    [sym_typed_pattern] = STATE(4815),
    [sym_list_pattern] = STATE(4815),
    [sym_array_pattern] = STATE(4815),
    [sym_record_pattern] = STATE(4815),
    [sym_named_field_pattern] = STATE(4815),
    [sym_identifier_pattern] = STATE(4815),
    [sym_long_identifier_or_op] = STATE(2193),
    [sym_rule] = STATE(5720),
    [sym_rules] = STATE(6745),
    [sym_char] = STATE(4765),
    [sym_format_string] = STATE(4746),
    [sym__string_literal] = STATE(4746),
    [sym_string] = STATE(4765),
    [sym_verbatim_string] = STATE(4765),
    [sym_bytearray] = STATE(4765),
    [sym_verbatim_bytearray] = STATE(4765),
    [sym_format_triple_quoted_string] = STATE(4720),
    [sym_triple_quoted_string] = STATE(4765),
    [sym_const] = STATE(4815),
    [sym_long_identifier] = STATE(3493),
    [sym_active_pattern] = STATE(3613),
    [sym__identifier_or_op] = STATE(3650),
    [sym_sbyte] = STATE(4765),
    [sym_byte] = STATE(4765),
    [sym_int16] = STATE(4765),
    [sym_uint16] = STATE(4765),
    [sym_int32] = STATE(4765),
    [sym_uint32] = STATE(4765),
    [sym_nativeint] = STATE(4765),
    [sym_unativeint] = STATE(4765),
    [sym_int64] = STATE(4765),
    [sym_uint64] = STATE(4765),
    [sym_ieee32] = STATE(4765),
    [sym_ieee64] = STATE(4765),
    [sym_bignum] = STATE(4765),
    [sym_decimal] = STATE(4765),
    [sym_float] = STATE(4512),
    [sym_block_comment] = STATE(2544),
    [sym_compiler_directive_decl] = STATE(2544),
    [sym_fsi_directive_decl] = STATE(2544),
    [sym_preproc_line] = STATE(2544),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(4175),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_LPAREN] = ACTIONS(3572),
    [anon_sym_null] = ACTIONS(3574),
    [anon_sym__] = ACTIONS(3576),
    [anon_sym_QMARK] = ACTIONS(4177),
    [anon_sym_COLON_QMARK] = ACTIONS(4179),
    [anon_sym_PIPE] = ACTIONS(4354),
    [anon_sym_LBRACK] = ACTIONS(3582),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3584),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [aux_sym_char_token1] = ACTIONS(3590),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3592),
    [anon_sym_DQUOTE] = ACTIONS(3594),
    [anon_sym_AT_DQUOTE] = ACTIONS(3596),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3598),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3600),
    [sym_bool] = ACTIONS(3602),
    [sym_unit] = ACTIONS(3604),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4181),
    [sym_op_identifier] = ACTIONS(4183),
    [sym_int] = ACTIONS(3610),
    [sym_xint] = ACTIONS(3612),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2545] = {
    [sym_attributes] = STATE(2699),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(4815),
    [sym__pattern] = STATE(5282),
    [sym_optional_pattern] = STATE(4815),
    [sym_type_check_pattern] = STATE(4815),
    [sym_attribute_pattern] = STATE(4815),
    [sym_paren_pattern] = STATE(4815),
    [sym_as_pattern] = STATE(4815),
    [sym_cons_pattern] = STATE(4815),
    [sym_disjunct_pattern] = STATE(4815),
    [sym_conjunct_pattern] = STATE(4815),
    [sym_typed_pattern] = STATE(4815),
    [sym_list_pattern] = STATE(4815),
    [sym_array_pattern] = STATE(4815),
    [sym_record_pattern] = STATE(4815),
    [sym_named_field_pattern] = STATE(4815),
    [sym_identifier_pattern] = STATE(4815),
    [sym_long_identifier_or_op] = STATE(2193),
    [sym_rule] = STATE(5720),
    [sym_rules] = STATE(7382),
    [sym_char] = STATE(4765),
    [sym_format_string] = STATE(4746),
    [sym__string_literal] = STATE(4746),
    [sym_string] = STATE(4765),
    [sym_verbatim_string] = STATE(4765),
    [sym_bytearray] = STATE(4765),
    [sym_verbatim_bytearray] = STATE(4765),
    [sym_format_triple_quoted_string] = STATE(4720),
    [sym_triple_quoted_string] = STATE(4765),
    [sym_const] = STATE(4815),
    [sym_long_identifier] = STATE(3493),
    [sym_active_pattern] = STATE(3613),
    [sym__identifier_or_op] = STATE(3650),
    [sym_sbyte] = STATE(4765),
    [sym_byte] = STATE(4765),
    [sym_int16] = STATE(4765),
    [sym_uint16] = STATE(4765),
    [sym_int32] = STATE(4765),
    [sym_uint32] = STATE(4765),
    [sym_nativeint] = STATE(4765),
    [sym_unativeint] = STATE(4765),
    [sym_int64] = STATE(4765),
    [sym_uint64] = STATE(4765),
    [sym_ieee32] = STATE(4765),
    [sym_ieee64] = STATE(4765),
    [sym_bignum] = STATE(4765),
    [sym_decimal] = STATE(4765),
    [sym_float] = STATE(4512),
    [sym_block_comment] = STATE(2545),
    [sym_compiler_directive_decl] = STATE(2545),
    [sym_fsi_directive_decl] = STATE(2545),
    [sym_preproc_line] = STATE(2545),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(4175),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_LPAREN] = ACTIONS(3572),
    [anon_sym_null] = ACTIONS(3574),
    [anon_sym__] = ACTIONS(3576),
    [anon_sym_QMARK] = ACTIONS(4177),
    [anon_sym_COLON_QMARK] = ACTIONS(4179),
    [anon_sym_PIPE] = ACTIONS(4354),
    [anon_sym_LBRACK] = ACTIONS(3582),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3584),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [aux_sym_char_token1] = ACTIONS(3590),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3592),
    [anon_sym_DQUOTE] = ACTIONS(3594),
    [anon_sym_AT_DQUOTE] = ACTIONS(3596),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3598),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3600),
    [sym_bool] = ACTIONS(3602),
    [sym_unit] = ACTIONS(3604),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4181),
    [sym_op_identifier] = ACTIONS(4183),
    [sym_int] = ACTIONS(3610),
    [sym_xint] = ACTIONS(3612),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2546] = {
    [sym_attributes] = STATE(2699),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(4815),
    [sym__pattern] = STATE(5283),
    [sym_optional_pattern] = STATE(4815),
    [sym_type_check_pattern] = STATE(4815),
    [sym_attribute_pattern] = STATE(4815),
    [sym_paren_pattern] = STATE(4815),
    [sym_as_pattern] = STATE(4815),
    [sym_cons_pattern] = STATE(4815),
    [sym_disjunct_pattern] = STATE(4815),
    [sym_conjunct_pattern] = STATE(4815),
    [sym_typed_pattern] = STATE(4815),
    [sym_list_pattern] = STATE(4815),
    [sym_array_pattern] = STATE(4815),
    [sym_record_pattern] = STATE(4815),
    [sym_named_field_pattern] = STATE(4815),
    [sym_identifier_pattern] = STATE(4815),
    [sym_long_identifier_or_op] = STATE(2193),
    [sym_rule] = STATE(1678),
    [sym_rules] = STATE(2170),
    [sym_char] = STATE(4765),
    [sym_format_string] = STATE(4746),
    [sym__string_literal] = STATE(4746),
    [sym_string] = STATE(4765),
    [sym_verbatim_string] = STATE(4765),
    [sym_bytearray] = STATE(4765),
    [sym_verbatim_bytearray] = STATE(4765),
    [sym_format_triple_quoted_string] = STATE(4720),
    [sym_triple_quoted_string] = STATE(4765),
    [sym_const] = STATE(4815),
    [sym_long_identifier] = STATE(3493),
    [sym_active_pattern] = STATE(3613),
    [sym__identifier_or_op] = STATE(3650),
    [sym_sbyte] = STATE(4765),
    [sym_byte] = STATE(4765),
    [sym_int16] = STATE(4765),
    [sym_uint16] = STATE(4765),
    [sym_int32] = STATE(4765),
    [sym_uint32] = STATE(4765),
    [sym_nativeint] = STATE(4765),
    [sym_unativeint] = STATE(4765),
    [sym_int64] = STATE(4765),
    [sym_uint64] = STATE(4765),
    [sym_ieee32] = STATE(4765),
    [sym_ieee64] = STATE(4765),
    [sym_bignum] = STATE(4765),
    [sym_decimal] = STATE(4765),
    [sym_float] = STATE(4512),
    [sym_block_comment] = STATE(2546),
    [sym_compiler_directive_decl] = STATE(2546),
    [sym_fsi_directive_decl] = STATE(2546),
    [sym_preproc_line] = STATE(2546),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(4175),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_LPAREN] = ACTIONS(3572),
    [anon_sym_null] = ACTIONS(3574),
    [anon_sym__] = ACTIONS(3576),
    [anon_sym_QMARK] = ACTIONS(4177),
    [anon_sym_COLON_QMARK] = ACTIONS(4179),
    [anon_sym_PIPE] = ACTIONS(4368),
    [anon_sym_LBRACK] = ACTIONS(3582),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3584),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [aux_sym_char_token1] = ACTIONS(3590),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3592),
    [anon_sym_DQUOTE] = ACTIONS(3594),
    [anon_sym_AT_DQUOTE] = ACTIONS(3596),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3598),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3600),
    [sym_bool] = ACTIONS(3602),
    [sym_unit] = ACTIONS(3604),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4181),
    [sym_op_identifier] = ACTIONS(4183),
    [sym_int] = ACTIONS(3610),
    [sym_xint] = ACTIONS(3612),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2547] = {
    [sym_attributes] = STATE(2699),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(4815),
    [sym__pattern] = STATE(5177),
    [sym_optional_pattern] = STATE(4815),
    [sym_type_check_pattern] = STATE(4815),
    [sym_attribute_pattern] = STATE(4815),
    [sym_paren_pattern] = STATE(4815),
    [sym_as_pattern] = STATE(4815),
    [sym_cons_pattern] = STATE(4815),
    [sym_disjunct_pattern] = STATE(4815),
    [sym_conjunct_pattern] = STATE(4815),
    [sym_typed_pattern] = STATE(4815),
    [sym_list_pattern] = STATE(4815),
    [sym_array_pattern] = STATE(4815),
    [sym_record_pattern] = STATE(4815),
    [sym_named_field_pattern] = STATE(4815),
    [sym_identifier_pattern] = STATE(4815),
    [sym_long_identifier_or_op] = STATE(2193),
    [sym_rule] = STATE(1574),
    [sym_rules] = STATE(2221),
    [sym_char] = STATE(4765),
    [sym_format_string] = STATE(4746),
    [sym__string_literal] = STATE(4746),
    [sym_string] = STATE(4765),
    [sym_verbatim_string] = STATE(4765),
    [sym_bytearray] = STATE(4765),
    [sym_verbatim_bytearray] = STATE(4765),
    [sym_format_triple_quoted_string] = STATE(4720),
    [sym_triple_quoted_string] = STATE(4765),
    [sym_const] = STATE(4815),
    [sym_long_identifier] = STATE(3493),
    [sym_active_pattern] = STATE(3613),
    [sym__identifier_or_op] = STATE(3650),
    [sym_sbyte] = STATE(4765),
    [sym_byte] = STATE(4765),
    [sym_int16] = STATE(4765),
    [sym_uint16] = STATE(4765),
    [sym_int32] = STATE(4765),
    [sym_uint32] = STATE(4765),
    [sym_nativeint] = STATE(4765),
    [sym_unativeint] = STATE(4765),
    [sym_int64] = STATE(4765),
    [sym_uint64] = STATE(4765),
    [sym_ieee32] = STATE(4765),
    [sym_ieee64] = STATE(4765),
    [sym_bignum] = STATE(4765),
    [sym_decimal] = STATE(4765),
    [sym_float] = STATE(4512),
    [sym_block_comment] = STATE(2547),
    [sym_compiler_directive_decl] = STATE(2547),
    [sym_fsi_directive_decl] = STATE(2547),
    [sym_preproc_line] = STATE(2547),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(4175),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_LPAREN] = ACTIONS(3572),
    [anon_sym_null] = ACTIONS(3574),
    [anon_sym__] = ACTIONS(3576),
    [anon_sym_QMARK] = ACTIONS(4177),
    [anon_sym_COLON_QMARK] = ACTIONS(4179),
    [anon_sym_PIPE] = ACTIONS(4358),
    [anon_sym_LBRACK] = ACTIONS(3582),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3584),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [aux_sym_char_token1] = ACTIONS(3590),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3592),
    [anon_sym_DQUOTE] = ACTIONS(3594),
    [anon_sym_AT_DQUOTE] = ACTIONS(3596),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3598),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3600),
    [sym_bool] = ACTIONS(3602),
    [sym_unit] = ACTIONS(3604),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4181),
    [sym_op_identifier] = ACTIONS(4183),
    [sym_int] = ACTIONS(3610),
    [sym_xint] = ACTIONS(3612),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2548] = {
    [sym_attributes] = STATE(2699),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(4815),
    [sym__pattern] = STATE(5282),
    [sym_optional_pattern] = STATE(4815),
    [sym_type_check_pattern] = STATE(4815),
    [sym_attribute_pattern] = STATE(4815),
    [sym_paren_pattern] = STATE(4815),
    [sym_as_pattern] = STATE(4815),
    [sym_cons_pattern] = STATE(4815),
    [sym_disjunct_pattern] = STATE(4815),
    [sym_conjunct_pattern] = STATE(4815),
    [sym_typed_pattern] = STATE(4815),
    [sym_list_pattern] = STATE(4815),
    [sym_array_pattern] = STATE(4815),
    [sym_record_pattern] = STATE(4815),
    [sym_named_field_pattern] = STATE(4815),
    [sym_identifier_pattern] = STATE(4815),
    [sym_long_identifier_or_op] = STATE(2193),
    [sym_rule] = STATE(5720),
    [sym_rules] = STATE(6657),
    [sym_char] = STATE(4765),
    [sym_format_string] = STATE(4746),
    [sym__string_literal] = STATE(4746),
    [sym_string] = STATE(4765),
    [sym_verbatim_string] = STATE(4765),
    [sym_bytearray] = STATE(4765),
    [sym_verbatim_bytearray] = STATE(4765),
    [sym_format_triple_quoted_string] = STATE(4720),
    [sym_triple_quoted_string] = STATE(4765),
    [sym_const] = STATE(4815),
    [sym_long_identifier] = STATE(3493),
    [sym_active_pattern] = STATE(3613),
    [sym__identifier_or_op] = STATE(3650),
    [sym_sbyte] = STATE(4765),
    [sym_byte] = STATE(4765),
    [sym_int16] = STATE(4765),
    [sym_uint16] = STATE(4765),
    [sym_int32] = STATE(4765),
    [sym_uint32] = STATE(4765),
    [sym_nativeint] = STATE(4765),
    [sym_unativeint] = STATE(4765),
    [sym_int64] = STATE(4765),
    [sym_uint64] = STATE(4765),
    [sym_ieee32] = STATE(4765),
    [sym_ieee64] = STATE(4765),
    [sym_bignum] = STATE(4765),
    [sym_decimal] = STATE(4765),
    [sym_float] = STATE(4512),
    [sym_block_comment] = STATE(2548),
    [sym_compiler_directive_decl] = STATE(2548),
    [sym_fsi_directive_decl] = STATE(2548),
    [sym_preproc_line] = STATE(2548),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(4175),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_LPAREN] = ACTIONS(3572),
    [anon_sym_null] = ACTIONS(3574),
    [anon_sym__] = ACTIONS(3576),
    [anon_sym_QMARK] = ACTIONS(4177),
    [anon_sym_COLON_QMARK] = ACTIONS(4179),
    [anon_sym_PIPE] = ACTIONS(4354),
    [anon_sym_LBRACK] = ACTIONS(3582),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3584),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [aux_sym_char_token1] = ACTIONS(3590),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3592),
    [anon_sym_DQUOTE] = ACTIONS(3594),
    [anon_sym_AT_DQUOTE] = ACTIONS(3596),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3598),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3600),
    [sym_bool] = ACTIONS(3602),
    [sym_unit] = ACTIONS(3604),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4181),
    [sym_op_identifier] = ACTIONS(4183),
    [sym_int] = ACTIONS(3610),
    [sym_xint] = ACTIONS(3612),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2549] = {
    [sym_attributes] = STATE(2699),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(4815),
    [sym__pattern] = STATE(5282),
    [sym_optional_pattern] = STATE(4815),
    [sym_type_check_pattern] = STATE(4815),
    [sym_attribute_pattern] = STATE(4815),
    [sym_paren_pattern] = STATE(4815),
    [sym_as_pattern] = STATE(4815),
    [sym_cons_pattern] = STATE(4815),
    [sym_disjunct_pattern] = STATE(4815),
    [sym_conjunct_pattern] = STATE(4815),
    [sym_typed_pattern] = STATE(4815),
    [sym_list_pattern] = STATE(4815),
    [sym_array_pattern] = STATE(4815),
    [sym_record_pattern] = STATE(4815),
    [sym_named_field_pattern] = STATE(4815),
    [sym_identifier_pattern] = STATE(4815),
    [sym_long_identifier_or_op] = STATE(2193),
    [sym_rule] = STATE(5720),
    [sym_rules] = STATE(6649),
    [sym_char] = STATE(4765),
    [sym_format_string] = STATE(4746),
    [sym__string_literal] = STATE(4746),
    [sym_string] = STATE(4765),
    [sym_verbatim_string] = STATE(4765),
    [sym_bytearray] = STATE(4765),
    [sym_verbatim_bytearray] = STATE(4765),
    [sym_format_triple_quoted_string] = STATE(4720),
    [sym_triple_quoted_string] = STATE(4765),
    [sym_const] = STATE(4815),
    [sym_long_identifier] = STATE(3493),
    [sym_active_pattern] = STATE(3613),
    [sym__identifier_or_op] = STATE(3650),
    [sym_sbyte] = STATE(4765),
    [sym_byte] = STATE(4765),
    [sym_int16] = STATE(4765),
    [sym_uint16] = STATE(4765),
    [sym_int32] = STATE(4765),
    [sym_uint32] = STATE(4765),
    [sym_nativeint] = STATE(4765),
    [sym_unativeint] = STATE(4765),
    [sym_int64] = STATE(4765),
    [sym_uint64] = STATE(4765),
    [sym_ieee32] = STATE(4765),
    [sym_ieee64] = STATE(4765),
    [sym_bignum] = STATE(4765),
    [sym_decimal] = STATE(4765),
    [sym_float] = STATE(4512),
    [sym_block_comment] = STATE(2549),
    [sym_compiler_directive_decl] = STATE(2549),
    [sym_fsi_directive_decl] = STATE(2549),
    [sym_preproc_line] = STATE(2549),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(4175),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_LPAREN] = ACTIONS(3572),
    [anon_sym_null] = ACTIONS(3574),
    [anon_sym__] = ACTIONS(3576),
    [anon_sym_QMARK] = ACTIONS(4177),
    [anon_sym_COLON_QMARK] = ACTIONS(4179),
    [anon_sym_PIPE] = ACTIONS(4354),
    [anon_sym_LBRACK] = ACTIONS(3582),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3584),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [aux_sym_char_token1] = ACTIONS(3590),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3592),
    [anon_sym_DQUOTE] = ACTIONS(3594),
    [anon_sym_AT_DQUOTE] = ACTIONS(3596),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3598),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3600),
    [sym_bool] = ACTIONS(3602),
    [sym_unit] = ACTIONS(3604),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4181),
    [sym_op_identifier] = ACTIONS(4183),
    [sym_int] = ACTIONS(3610),
    [sym_xint] = ACTIONS(3612),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2550] = {
    [sym_attributes] = STATE(2699),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(4815),
    [sym__pattern] = STATE(5283),
    [sym_optional_pattern] = STATE(4815),
    [sym_type_check_pattern] = STATE(4815),
    [sym_attribute_pattern] = STATE(4815),
    [sym_paren_pattern] = STATE(4815),
    [sym_as_pattern] = STATE(4815),
    [sym_cons_pattern] = STATE(4815),
    [sym_disjunct_pattern] = STATE(4815),
    [sym_conjunct_pattern] = STATE(4815),
    [sym_typed_pattern] = STATE(4815),
    [sym_list_pattern] = STATE(4815),
    [sym_array_pattern] = STATE(4815),
    [sym_record_pattern] = STATE(4815),
    [sym_named_field_pattern] = STATE(4815),
    [sym_identifier_pattern] = STATE(4815),
    [sym_long_identifier_or_op] = STATE(2193),
    [sym_rule] = STATE(1678),
    [sym_rules] = STATE(2196),
    [sym_char] = STATE(4765),
    [sym_format_string] = STATE(4746),
    [sym__string_literal] = STATE(4746),
    [sym_string] = STATE(4765),
    [sym_verbatim_string] = STATE(4765),
    [sym_bytearray] = STATE(4765),
    [sym_verbatim_bytearray] = STATE(4765),
    [sym_format_triple_quoted_string] = STATE(4720),
    [sym_triple_quoted_string] = STATE(4765),
    [sym_const] = STATE(4815),
    [sym_long_identifier] = STATE(3493),
    [sym_active_pattern] = STATE(3613),
    [sym__identifier_or_op] = STATE(3650),
    [sym_sbyte] = STATE(4765),
    [sym_byte] = STATE(4765),
    [sym_int16] = STATE(4765),
    [sym_uint16] = STATE(4765),
    [sym_int32] = STATE(4765),
    [sym_uint32] = STATE(4765),
    [sym_nativeint] = STATE(4765),
    [sym_unativeint] = STATE(4765),
    [sym_int64] = STATE(4765),
    [sym_uint64] = STATE(4765),
    [sym_ieee32] = STATE(4765),
    [sym_ieee64] = STATE(4765),
    [sym_bignum] = STATE(4765),
    [sym_decimal] = STATE(4765),
    [sym_float] = STATE(4512),
    [sym_block_comment] = STATE(2550),
    [sym_compiler_directive_decl] = STATE(2550),
    [sym_fsi_directive_decl] = STATE(2550),
    [sym_preproc_line] = STATE(2550),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(4175),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_LPAREN] = ACTIONS(3572),
    [anon_sym_null] = ACTIONS(3574),
    [anon_sym__] = ACTIONS(3576),
    [anon_sym_QMARK] = ACTIONS(4177),
    [anon_sym_COLON_QMARK] = ACTIONS(4179),
    [anon_sym_PIPE] = ACTIONS(4368),
    [anon_sym_LBRACK] = ACTIONS(3582),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3584),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [aux_sym_char_token1] = ACTIONS(3590),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3592),
    [anon_sym_DQUOTE] = ACTIONS(3594),
    [anon_sym_AT_DQUOTE] = ACTIONS(3596),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3598),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3600),
    [sym_bool] = ACTIONS(3602),
    [sym_unit] = ACTIONS(3604),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4181),
    [sym_op_identifier] = ACTIONS(4183),
    [sym_int] = ACTIONS(3610),
    [sym_xint] = ACTIONS(3612),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2551] = {
    [sym_attributes] = STATE(2699),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(4815),
    [sym__pattern] = STATE(5196),
    [sym_optional_pattern] = STATE(4815),
    [sym_type_check_pattern] = STATE(4815),
    [sym_attribute_pattern] = STATE(4815),
    [sym_paren_pattern] = STATE(4815),
    [sym_as_pattern] = STATE(4815),
    [sym_cons_pattern] = STATE(4815),
    [sym_disjunct_pattern] = STATE(4815),
    [sym_conjunct_pattern] = STATE(4815),
    [sym_typed_pattern] = STATE(4815),
    [sym_list_pattern] = STATE(4815),
    [sym_array_pattern] = STATE(4815),
    [sym_record_pattern] = STATE(4815),
    [sym_named_field_pattern] = STATE(4815),
    [sym_identifier_pattern] = STATE(4815),
    [sym_long_identifier_or_op] = STATE(2193),
    [sym_rule] = STATE(821),
    [sym_rules] = STATE(944),
    [sym_char] = STATE(4765),
    [sym_format_string] = STATE(4746),
    [sym__string_literal] = STATE(4746),
    [sym_string] = STATE(4765),
    [sym_verbatim_string] = STATE(4765),
    [sym_bytearray] = STATE(4765),
    [sym_verbatim_bytearray] = STATE(4765),
    [sym_format_triple_quoted_string] = STATE(4720),
    [sym_triple_quoted_string] = STATE(4765),
    [sym_const] = STATE(4815),
    [sym_long_identifier] = STATE(3493),
    [sym_active_pattern] = STATE(3613),
    [sym__identifier_or_op] = STATE(3650),
    [sym_sbyte] = STATE(4765),
    [sym_byte] = STATE(4765),
    [sym_int16] = STATE(4765),
    [sym_uint16] = STATE(4765),
    [sym_int32] = STATE(4765),
    [sym_uint32] = STATE(4765),
    [sym_nativeint] = STATE(4765),
    [sym_unativeint] = STATE(4765),
    [sym_int64] = STATE(4765),
    [sym_uint64] = STATE(4765),
    [sym_ieee32] = STATE(4765),
    [sym_ieee64] = STATE(4765),
    [sym_bignum] = STATE(4765),
    [sym_decimal] = STATE(4765),
    [sym_float] = STATE(4512),
    [sym_block_comment] = STATE(2551),
    [sym_compiler_directive_decl] = STATE(2551),
    [sym_fsi_directive_decl] = STATE(2551),
    [sym_preproc_line] = STATE(2551),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(4175),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_LPAREN] = ACTIONS(3572),
    [anon_sym_null] = ACTIONS(3574),
    [anon_sym__] = ACTIONS(3576),
    [anon_sym_QMARK] = ACTIONS(4177),
    [anon_sym_COLON_QMARK] = ACTIONS(4179),
    [anon_sym_PIPE] = ACTIONS(4352),
    [anon_sym_LBRACK] = ACTIONS(3582),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3584),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [aux_sym_char_token1] = ACTIONS(3590),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3592),
    [anon_sym_DQUOTE] = ACTIONS(3594),
    [anon_sym_AT_DQUOTE] = ACTIONS(3596),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3598),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3600),
    [sym_bool] = ACTIONS(3602),
    [sym_unit] = ACTIONS(3604),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4181),
    [sym_op_identifier] = ACTIONS(4183),
    [sym_int] = ACTIONS(3610),
    [sym_xint] = ACTIONS(3612),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2552] = {
    [sym_attributes] = STATE(2699),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(4815),
    [sym__pattern] = STATE(5267),
    [sym_optional_pattern] = STATE(4815),
    [sym_type_check_pattern] = STATE(4815),
    [sym_attribute_pattern] = STATE(4815),
    [sym_paren_pattern] = STATE(4815),
    [sym_as_pattern] = STATE(4815),
    [sym_cons_pattern] = STATE(4815),
    [sym_disjunct_pattern] = STATE(4815),
    [sym_conjunct_pattern] = STATE(4815),
    [sym_typed_pattern] = STATE(4815),
    [sym_list_pattern] = STATE(4815),
    [sym_array_pattern] = STATE(4815),
    [sym_record_pattern] = STATE(4815),
    [sym_named_field_pattern] = STATE(4815),
    [sym_identifier_pattern] = STATE(4815),
    [sym_long_identifier_or_op] = STATE(2193),
    [sym_rule] = STATE(1419),
    [sym_rules] = STATE(1913),
    [sym_char] = STATE(4765),
    [sym_format_string] = STATE(4746),
    [sym__string_literal] = STATE(4746),
    [sym_string] = STATE(4765),
    [sym_verbatim_string] = STATE(4765),
    [sym_bytearray] = STATE(4765),
    [sym_verbatim_bytearray] = STATE(4765),
    [sym_format_triple_quoted_string] = STATE(4720),
    [sym_triple_quoted_string] = STATE(4765),
    [sym_const] = STATE(4815),
    [sym_long_identifier] = STATE(3493),
    [sym_active_pattern] = STATE(3613),
    [sym__identifier_or_op] = STATE(3650),
    [sym_sbyte] = STATE(4765),
    [sym_byte] = STATE(4765),
    [sym_int16] = STATE(4765),
    [sym_uint16] = STATE(4765),
    [sym_int32] = STATE(4765),
    [sym_uint32] = STATE(4765),
    [sym_nativeint] = STATE(4765),
    [sym_unativeint] = STATE(4765),
    [sym_int64] = STATE(4765),
    [sym_uint64] = STATE(4765),
    [sym_ieee32] = STATE(4765),
    [sym_ieee64] = STATE(4765),
    [sym_bignum] = STATE(4765),
    [sym_decimal] = STATE(4765),
    [sym_float] = STATE(4512),
    [sym_block_comment] = STATE(2552),
    [sym_compiler_directive_decl] = STATE(2552),
    [sym_fsi_directive_decl] = STATE(2552),
    [sym_preproc_line] = STATE(2552),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(4175),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_LPAREN] = ACTIONS(3572),
    [anon_sym_null] = ACTIONS(3574),
    [anon_sym__] = ACTIONS(3576),
    [anon_sym_QMARK] = ACTIONS(4177),
    [anon_sym_COLON_QMARK] = ACTIONS(4179),
    [anon_sym_PIPE] = ACTIONS(4348),
    [anon_sym_LBRACK] = ACTIONS(3582),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3584),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [aux_sym_char_token1] = ACTIONS(3590),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3592),
    [anon_sym_DQUOTE] = ACTIONS(3594),
    [anon_sym_AT_DQUOTE] = ACTIONS(3596),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3598),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3600),
    [sym_bool] = ACTIONS(3602),
    [sym_unit] = ACTIONS(3604),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4181),
    [sym_op_identifier] = ACTIONS(4183),
    [sym_int] = ACTIONS(3610),
    [sym_xint] = ACTIONS(3612),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2553] = {
    [sym_attributes] = STATE(2699),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(4815),
    [sym__pattern] = STATE(5282),
    [sym_optional_pattern] = STATE(4815),
    [sym_type_check_pattern] = STATE(4815),
    [sym_attribute_pattern] = STATE(4815),
    [sym_paren_pattern] = STATE(4815),
    [sym_as_pattern] = STATE(4815),
    [sym_cons_pattern] = STATE(4815),
    [sym_disjunct_pattern] = STATE(4815),
    [sym_conjunct_pattern] = STATE(4815),
    [sym_typed_pattern] = STATE(4815),
    [sym_list_pattern] = STATE(4815),
    [sym_array_pattern] = STATE(4815),
    [sym_record_pattern] = STATE(4815),
    [sym_named_field_pattern] = STATE(4815),
    [sym_identifier_pattern] = STATE(4815),
    [sym_long_identifier_or_op] = STATE(2193),
    [sym_rule] = STATE(5720),
    [sym_rules] = STATE(7349),
    [sym_char] = STATE(4765),
    [sym_format_string] = STATE(4746),
    [sym__string_literal] = STATE(4746),
    [sym_string] = STATE(4765),
    [sym_verbatim_string] = STATE(4765),
    [sym_bytearray] = STATE(4765),
    [sym_verbatim_bytearray] = STATE(4765),
    [sym_format_triple_quoted_string] = STATE(4720),
    [sym_triple_quoted_string] = STATE(4765),
    [sym_const] = STATE(4815),
    [sym_long_identifier] = STATE(3493),
    [sym_active_pattern] = STATE(3613),
    [sym__identifier_or_op] = STATE(3650),
    [sym_sbyte] = STATE(4765),
    [sym_byte] = STATE(4765),
    [sym_int16] = STATE(4765),
    [sym_uint16] = STATE(4765),
    [sym_int32] = STATE(4765),
    [sym_uint32] = STATE(4765),
    [sym_nativeint] = STATE(4765),
    [sym_unativeint] = STATE(4765),
    [sym_int64] = STATE(4765),
    [sym_uint64] = STATE(4765),
    [sym_ieee32] = STATE(4765),
    [sym_ieee64] = STATE(4765),
    [sym_bignum] = STATE(4765),
    [sym_decimal] = STATE(4765),
    [sym_float] = STATE(4512),
    [sym_block_comment] = STATE(2553),
    [sym_compiler_directive_decl] = STATE(2553),
    [sym_fsi_directive_decl] = STATE(2553),
    [sym_preproc_line] = STATE(2553),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(4175),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_LPAREN] = ACTIONS(3572),
    [anon_sym_null] = ACTIONS(3574),
    [anon_sym__] = ACTIONS(3576),
    [anon_sym_QMARK] = ACTIONS(4177),
    [anon_sym_COLON_QMARK] = ACTIONS(4179),
    [anon_sym_PIPE] = ACTIONS(4354),
    [anon_sym_LBRACK] = ACTIONS(3582),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3584),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [aux_sym_char_token1] = ACTIONS(3590),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3592),
    [anon_sym_DQUOTE] = ACTIONS(3594),
    [anon_sym_AT_DQUOTE] = ACTIONS(3596),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3598),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3600),
    [sym_bool] = ACTIONS(3602),
    [sym_unit] = ACTIONS(3604),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4181),
    [sym_op_identifier] = ACTIONS(4183),
    [sym_int] = ACTIONS(3610),
    [sym_xint] = ACTIONS(3612),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2554] = {
    [sym_attributes] = STATE(2699),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(4815),
    [sym__pattern] = STATE(5283),
    [sym_optional_pattern] = STATE(4815),
    [sym_type_check_pattern] = STATE(4815),
    [sym_attribute_pattern] = STATE(4815),
    [sym_paren_pattern] = STATE(4815),
    [sym_as_pattern] = STATE(4815),
    [sym_cons_pattern] = STATE(4815),
    [sym_disjunct_pattern] = STATE(4815),
    [sym_conjunct_pattern] = STATE(4815),
    [sym_typed_pattern] = STATE(4815),
    [sym_list_pattern] = STATE(4815),
    [sym_array_pattern] = STATE(4815),
    [sym_record_pattern] = STATE(4815),
    [sym_named_field_pattern] = STATE(4815),
    [sym_identifier_pattern] = STATE(4815),
    [sym_long_identifier_or_op] = STATE(2193),
    [sym_rule] = STATE(1678),
    [sym_rules] = STATE(2180),
    [sym_char] = STATE(4765),
    [sym_format_string] = STATE(4746),
    [sym__string_literal] = STATE(4746),
    [sym_string] = STATE(4765),
    [sym_verbatim_string] = STATE(4765),
    [sym_bytearray] = STATE(4765),
    [sym_verbatim_bytearray] = STATE(4765),
    [sym_format_triple_quoted_string] = STATE(4720),
    [sym_triple_quoted_string] = STATE(4765),
    [sym_const] = STATE(4815),
    [sym_long_identifier] = STATE(3493),
    [sym_active_pattern] = STATE(3613),
    [sym__identifier_or_op] = STATE(3650),
    [sym_sbyte] = STATE(4765),
    [sym_byte] = STATE(4765),
    [sym_int16] = STATE(4765),
    [sym_uint16] = STATE(4765),
    [sym_int32] = STATE(4765),
    [sym_uint32] = STATE(4765),
    [sym_nativeint] = STATE(4765),
    [sym_unativeint] = STATE(4765),
    [sym_int64] = STATE(4765),
    [sym_uint64] = STATE(4765),
    [sym_ieee32] = STATE(4765),
    [sym_ieee64] = STATE(4765),
    [sym_bignum] = STATE(4765),
    [sym_decimal] = STATE(4765),
    [sym_float] = STATE(4512),
    [sym_block_comment] = STATE(2554),
    [sym_compiler_directive_decl] = STATE(2554),
    [sym_fsi_directive_decl] = STATE(2554),
    [sym_preproc_line] = STATE(2554),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(4175),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_LPAREN] = ACTIONS(3572),
    [anon_sym_null] = ACTIONS(3574),
    [anon_sym__] = ACTIONS(3576),
    [anon_sym_QMARK] = ACTIONS(4177),
    [anon_sym_COLON_QMARK] = ACTIONS(4179),
    [anon_sym_PIPE] = ACTIONS(4368),
    [anon_sym_LBRACK] = ACTIONS(3582),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3584),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [aux_sym_char_token1] = ACTIONS(3590),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3592),
    [anon_sym_DQUOTE] = ACTIONS(3594),
    [anon_sym_AT_DQUOTE] = ACTIONS(3596),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3598),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3600),
    [sym_bool] = ACTIONS(3602),
    [sym_unit] = ACTIONS(3604),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4181),
    [sym_op_identifier] = ACTIONS(4183),
    [sym_int] = ACTIONS(3610),
    [sym_xint] = ACTIONS(3612),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2555] = {
    [sym_attributes] = STATE(2699),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(4815),
    [sym__pattern] = STATE(5282),
    [sym_optional_pattern] = STATE(4815),
    [sym_type_check_pattern] = STATE(4815),
    [sym_attribute_pattern] = STATE(4815),
    [sym_paren_pattern] = STATE(4815),
    [sym_as_pattern] = STATE(4815),
    [sym_cons_pattern] = STATE(4815),
    [sym_disjunct_pattern] = STATE(4815),
    [sym_conjunct_pattern] = STATE(4815),
    [sym_typed_pattern] = STATE(4815),
    [sym_list_pattern] = STATE(4815),
    [sym_array_pattern] = STATE(4815),
    [sym_record_pattern] = STATE(4815),
    [sym_named_field_pattern] = STATE(4815),
    [sym_identifier_pattern] = STATE(4815),
    [sym_long_identifier_or_op] = STATE(2193),
    [sym_rule] = STATE(5720),
    [sym_rules] = STATE(7110),
    [sym_char] = STATE(4765),
    [sym_format_string] = STATE(4746),
    [sym__string_literal] = STATE(4746),
    [sym_string] = STATE(4765),
    [sym_verbatim_string] = STATE(4765),
    [sym_bytearray] = STATE(4765),
    [sym_verbatim_bytearray] = STATE(4765),
    [sym_format_triple_quoted_string] = STATE(4720),
    [sym_triple_quoted_string] = STATE(4765),
    [sym_const] = STATE(4815),
    [sym_long_identifier] = STATE(3493),
    [sym_active_pattern] = STATE(3613),
    [sym__identifier_or_op] = STATE(3650),
    [sym_sbyte] = STATE(4765),
    [sym_byte] = STATE(4765),
    [sym_int16] = STATE(4765),
    [sym_uint16] = STATE(4765),
    [sym_int32] = STATE(4765),
    [sym_uint32] = STATE(4765),
    [sym_nativeint] = STATE(4765),
    [sym_unativeint] = STATE(4765),
    [sym_int64] = STATE(4765),
    [sym_uint64] = STATE(4765),
    [sym_ieee32] = STATE(4765),
    [sym_ieee64] = STATE(4765),
    [sym_bignum] = STATE(4765),
    [sym_decimal] = STATE(4765),
    [sym_float] = STATE(4512),
    [sym_block_comment] = STATE(2555),
    [sym_compiler_directive_decl] = STATE(2555),
    [sym_fsi_directive_decl] = STATE(2555),
    [sym_preproc_line] = STATE(2555),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(4175),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_LPAREN] = ACTIONS(3572),
    [anon_sym_null] = ACTIONS(3574),
    [anon_sym__] = ACTIONS(3576),
    [anon_sym_QMARK] = ACTIONS(4177),
    [anon_sym_COLON_QMARK] = ACTIONS(4179),
    [anon_sym_PIPE] = ACTIONS(4354),
    [anon_sym_LBRACK] = ACTIONS(3582),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3584),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [aux_sym_char_token1] = ACTIONS(3590),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3592),
    [anon_sym_DQUOTE] = ACTIONS(3594),
    [anon_sym_AT_DQUOTE] = ACTIONS(3596),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3598),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3600),
    [sym_bool] = ACTIONS(3602),
    [sym_unit] = ACTIONS(3604),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4181),
    [sym_op_identifier] = ACTIONS(4183),
    [sym_int] = ACTIONS(3610),
    [sym_xint] = ACTIONS(3612),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2556] = {
    [sym_attributes] = STATE(2699),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(4815),
    [sym__pattern] = STATE(5282),
    [sym_optional_pattern] = STATE(4815),
    [sym_type_check_pattern] = STATE(4815),
    [sym_attribute_pattern] = STATE(4815),
    [sym_paren_pattern] = STATE(4815),
    [sym_as_pattern] = STATE(4815),
    [sym_cons_pattern] = STATE(4815),
    [sym_disjunct_pattern] = STATE(4815),
    [sym_conjunct_pattern] = STATE(4815),
    [sym_typed_pattern] = STATE(4815),
    [sym_list_pattern] = STATE(4815),
    [sym_array_pattern] = STATE(4815),
    [sym_record_pattern] = STATE(4815),
    [sym_named_field_pattern] = STATE(4815),
    [sym_identifier_pattern] = STATE(4815),
    [sym_long_identifier_or_op] = STATE(2193),
    [sym_rule] = STATE(5720),
    [sym_rules] = STATE(7122),
    [sym_char] = STATE(4765),
    [sym_format_string] = STATE(4746),
    [sym__string_literal] = STATE(4746),
    [sym_string] = STATE(4765),
    [sym_verbatim_string] = STATE(4765),
    [sym_bytearray] = STATE(4765),
    [sym_verbatim_bytearray] = STATE(4765),
    [sym_format_triple_quoted_string] = STATE(4720),
    [sym_triple_quoted_string] = STATE(4765),
    [sym_const] = STATE(4815),
    [sym_long_identifier] = STATE(3493),
    [sym_active_pattern] = STATE(3613),
    [sym__identifier_or_op] = STATE(3650),
    [sym_sbyte] = STATE(4765),
    [sym_byte] = STATE(4765),
    [sym_int16] = STATE(4765),
    [sym_uint16] = STATE(4765),
    [sym_int32] = STATE(4765),
    [sym_uint32] = STATE(4765),
    [sym_nativeint] = STATE(4765),
    [sym_unativeint] = STATE(4765),
    [sym_int64] = STATE(4765),
    [sym_uint64] = STATE(4765),
    [sym_ieee32] = STATE(4765),
    [sym_ieee64] = STATE(4765),
    [sym_bignum] = STATE(4765),
    [sym_decimal] = STATE(4765),
    [sym_float] = STATE(4512),
    [sym_block_comment] = STATE(2556),
    [sym_compiler_directive_decl] = STATE(2556),
    [sym_fsi_directive_decl] = STATE(2556),
    [sym_preproc_line] = STATE(2556),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(4175),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_LPAREN] = ACTIONS(3572),
    [anon_sym_null] = ACTIONS(3574),
    [anon_sym__] = ACTIONS(3576),
    [anon_sym_QMARK] = ACTIONS(4177),
    [anon_sym_COLON_QMARK] = ACTIONS(4179),
    [anon_sym_PIPE] = ACTIONS(4354),
    [anon_sym_LBRACK] = ACTIONS(3582),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3584),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [aux_sym_char_token1] = ACTIONS(3590),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3592),
    [anon_sym_DQUOTE] = ACTIONS(3594),
    [anon_sym_AT_DQUOTE] = ACTIONS(3596),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3598),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3600),
    [sym_bool] = ACTIONS(3602),
    [sym_unit] = ACTIONS(3604),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4181),
    [sym_op_identifier] = ACTIONS(4183),
    [sym_int] = ACTIONS(3610),
    [sym_xint] = ACTIONS(3612),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2557] = {
    [sym_attributes] = STATE(2699),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(4815),
    [sym__pattern] = STATE(5282),
    [sym_optional_pattern] = STATE(4815),
    [sym_type_check_pattern] = STATE(4815),
    [sym_attribute_pattern] = STATE(4815),
    [sym_paren_pattern] = STATE(4815),
    [sym_as_pattern] = STATE(4815),
    [sym_cons_pattern] = STATE(4815),
    [sym_disjunct_pattern] = STATE(4815),
    [sym_conjunct_pattern] = STATE(4815),
    [sym_typed_pattern] = STATE(4815),
    [sym_list_pattern] = STATE(4815),
    [sym_array_pattern] = STATE(4815),
    [sym_record_pattern] = STATE(4815),
    [sym_named_field_pattern] = STATE(4815),
    [sym_identifier_pattern] = STATE(4815),
    [sym_long_identifier_or_op] = STATE(2193),
    [sym_rule] = STATE(5720),
    [sym_rules] = STATE(6641),
    [sym_char] = STATE(4765),
    [sym_format_string] = STATE(4746),
    [sym__string_literal] = STATE(4746),
    [sym_string] = STATE(4765),
    [sym_verbatim_string] = STATE(4765),
    [sym_bytearray] = STATE(4765),
    [sym_verbatim_bytearray] = STATE(4765),
    [sym_format_triple_quoted_string] = STATE(4720),
    [sym_triple_quoted_string] = STATE(4765),
    [sym_const] = STATE(4815),
    [sym_long_identifier] = STATE(3493),
    [sym_active_pattern] = STATE(3613),
    [sym__identifier_or_op] = STATE(3650),
    [sym_sbyte] = STATE(4765),
    [sym_byte] = STATE(4765),
    [sym_int16] = STATE(4765),
    [sym_uint16] = STATE(4765),
    [sym_int32] = STATE(4765),
    [sym_uint32] = STATE(4765),
    [sym_nativeint] = STATE(4765),
    [sym_unativeint] = STATE(4765),
    [sym_int64] = STATE(4765),
    [sym_uint64] = STATE(4765),
    [sym_ieee32] = STATE(4765),
    [sym_ieee64] = STATE(4765),
    [sym_bignum] = STATE(4765),
    [sym_decimal] = STATE(4765),
    [sym_float] = STATE(4512),
    [sym_block_comment] = STATE(2557),
    [sym_compiler_directive_decl] = STATE(2557),
    [sym_fsi_directive_decl] = STATE(2557),
    [sym_preproc_line] = STATE(2557),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(4175),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_LPAREN] = ACTIONS(3572),
    [anon_sym_null] = ACTIONS(3574),
    [anon_sym__] = ACTIONS(3576),
    [anon_sym_QMARK] = ACTIONS(4177),
    [anon_sym_COLON_QMARK] = ACTIONS(4179),
    [anon_sym_PIPE] = ACTIONS(4354),
    [anon_sym_LBRACK] = ACTIONS(3582),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3584),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [aux_sym_char_token1] = ACTIONS(3590),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3592),
    [anon_sym_DQUOTE] = ACTIONS(3594),
    [anon_sym_AT_DQUOTE] = ACTIONS(3596),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3598),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3600),
    [sym_bool] = ACTIONS(3602),
    [sym_unit] = ACTIONS(3604),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4181),
    [sym_op_identifier] = ACTIONS(4183),
    [sym_int] = ACTIONS(3610),
    [sym_xint] = ACTIONS(3612),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2558] = {
    [sym_attributes] = STATE(2699),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(4815),
    [sym__pattern] = STATE(5282),
    [sym_optional_pattern] = STATE(4815),
    [sym_type_check_pattern] = STATE(4815),
    [sym_attribute_pattern] = STATE(4815),
    [sym_paren_pattern] = STATE(4815),
    [sym_as_pattern] = STATE(4815),
    [sym_cons_pattern] = STATE(4815),
    [sym_disjunct_pattern] = STATE(4815),
    [sym_conjunct_pattern] = STATE(4815),
    [sym_typed_pattern] = STATE(4815),
    [sym_list_pattern] = STATE(4815),
    [sym_array_pattern] = STATE(4815),
    [sym_record_pattern] = STATE(4815),
    [sym_named_field_pattern] = STATE(4815),
    [sym_identifier_pattern] = STATE(4815),
    [sym_long_identifier_or_op] = STATE(2193),
    [sym_rule] = STATE(5720),
    [sym_rules] = STATE(7214),
    [sym_char] = STATE(4765),
    [sym_format_string] = STATE(4746),
    [sym__string_literal] = STATE(4746),
    [sym_string] = STATE(4765),
    [sym_verbatim_string] = STATE(4765),
    [sym_bytearray] = STATE(4765),
    [sym_verbatim_bytearray] = STATE(4765),
    [sym_format_triple_quoted_string] = STATE(4720),
    [sym_triple_quoted_string] = STATE(4765),
    [sym_const] = STATE(4815),
    [sym_long_identifier] = STATE(3493),
    [sym_active_pattern] = STATE(3613),
    [sym__identifier_or_op] = STATE(3650),
    [sym_sbyte] = STATE(4765),
    [sym_byte] = STATE(4765),
    [sym_int16] = STATE(4765),
    [sym_uint16] = STATE(4765),
    [sym_int32] = STATE(4765),
    [sym_uint32] = STATE(4765),
    [sym_nativeint] = STATE(4765),
    [sym_unativeint] = STATE(4765),
    [sym_int64] = STATE(4765),
    [sym_uint64] = STATE(4765),
    [sym_ieee32] = STATE(4765),
    [sym_ieee64] = STATE(4765),
    [sym_bignum] = STATE(4765),
    [sym_decimal] = STATE(4765),
    [sym_float] = STATE(4512),
    [sym_block_comment] = STATE(2558),
    [sym_compiler_directive_decl] = STATE(2558),
    [sym_fsi_directive_decl] = STATE(2558),
    [sym_preproc_line] = STATE(2558),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(4175),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_LPAREN] = ACTIONS(3572),
    [anon_sym_null] = ACTIONS(3574),
    [anon_sym__] = ACTIONS(3576),
    [anon_sym_QMARK] = ACTIONS(4177),
    [anon_sym_COLON_QMARK] = ACTIONS(4179),
    [anon_sym_PIPE] = ACTIONS(4354),
    [anon_sym_LBRACK] = ACTIONS(3582),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3584),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [aux_sym_char_token1] = ACTIONS(3590),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3592),
    [anon_sym_DQUOTE] = ACTIONS(3594),
    [anon_sym_AT_DQUOTE] = ACTIONS(3596),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3598),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3600),
    [sym_bool] = ACTIONS(3602),
    [sym_unit] = ACTIONS(3604),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4181),
    [sym_op_identifier] = ACTIONS(4183),
    [sym_int] = ACTIONS(3610),
    [sym_xint] = ACTIONS(3612),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2559] = {
    [sym_attributes] = STATE(2699),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(4815),
    [sym__pattern] = STATE(5267),
    [sym_optional_pattern] = STATE(4815),
    [sym_type_check_pattern] = STATE(4815),
    [sym_attribute_pattern] = STATE(4815),
    [sym_paren_pattern] = STATE(4815),
    [sym_as_pattern] = STATE(4815),
    [sym_cons_pattern] = STATE(4815),
    [sym_disjunct_pattern] = STATE(4815),
    [sym_conjunct_pattern] = STATE(4815),
    [sym_typed_pattern] = STATE(4815),
    [sym_list_pattern] = STATE(4815),
    [sym_array_pattern] = STATE(4815),
    [sym_record_pattern] = STATE(4815),
    [sym_named_field_pattern] = STATE(4815),
    [sym_identifier_pattern] = STATE(4815),
    [sym_long_identifier_or_op] = STATE(2193),
    [sym_rule] = STATE(1419),
    [sym_rules] = STATE(1935),
    [sym_char] = STATE(4765),
    [sym_format_string] = STATE(4746),
    [sym__string_literal] = STATE(4746),
    [sym_string] = STATE(4765),
    [sym_verbatim_string] = STATE(4765),
    [sym_bytearray] = STATE(4765),
    [sym_verbatim_bytearray] = STATE(4765),
    [sym_format_triple_quoted_string] = STATE(4720),
    [sym_triple_quoted_string] = STATE(4765),
    [sym_const] = STATE(4815),
    [sym_long_identifier] = STATE(3493),
    [sym_active_pattern] = STATE(3613),
    [sym__identifier_or_op] = STATE(3650),
    [sym_sbyte] = STATE(4765),
    [sym_byte] = STATE(4765),
    [sym_int16] = STATE(4765),
    [sym_uint16] = STATE(4765),
    [sym_int32] = STATE(4765),
    [sym_uint32] = STATE(4765),
    [sym_nativeint] = STATE(4765),
    [sym_unativeint] = STATE(4765),
    [sym_int64] = STATE(4765),
    [sym_uint64] = STATE(4765),
    [sym_ieee32] = STATE(4765),
    [sym_ieee64] = STATE(4765),
    [sym_bignum] = STATE(4765),
    [sym_decimal] = STATE(4765),
    [sym_float] = STATE(4512),
    [sym_block_comment] = STATE(2559),
    [sym_compiler_directive_decl] = STATE(2559),
    [sym_fsi_directive_decl] = STATE(2559),
    [sym_preproc_line] = STATE(2559),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(4175),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_LPAREN] = ACTIONS(3572),
    [anon_sym_null] = ACTIONS(3574),
    [anon_sym__] = ACTIONS(3576),
    [anon_sym_QMARK] = ACTIONS(4177),
    [anon_sym_COLON_QMARK] = ACTIONS(4179),
    [anon_sym_PIPE] = ACTIONS(4348),
    [anon_sym_LBRACK] = ACTIONS(3582),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3584),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [aux_sym_char_token1] = ACTIONS(3590),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3592),
    [anon_sym_DQUOTE] = ACTIONS(3594),
    [anon_sym_AT_DQUOTE] = ACTIONS(3596),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3598),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3600),
    [sym_bool] = ACTIONS(3602),
    [sym_unit] = ACTIONS(3604),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4181),
    [sym_op_identifier] = ACTIONS(4183),
    [sym_int] = ACTIONS(3610),
    [sym_xint] = ACTIONS(3612),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2560] = {
    [sym_attributes] = STATE(2699),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(4815),
    [sym__pattern] = STATE(5274),
    [sym_optional_pattern] = STATE(4815),
    [sym_type_check_pattern] = STATE(4815),
    [sym_attribute_pattern] = STATE(4815),
    [sym_paren_pattern] = STATE(4815),
    [sym_as_pattern] = STATE(4815),
    [sym_cons_pattern] = STATE(4815),
    [sym_disjunct_pattern] = STATE(4815),
    [sym_conjunct_pattern] = STATE(4815),
    [sym_typed_pattern] = STATE(4815),
    [sym_list_pattern] = STATE(4815),
    [sym_array_pattern] = STATE(4815),
    [sym_record_pattern] = STATE(4815),
    [sym_named_field_pattern] = STATE(4815),
    [sym_identifier_pattern] = STATE(4815),
    [sym_long_identifier_or_op] = STATE(2193),
    [sym_rule] = STATE(983),
    [sym_rules] = STATE(1106),
    [sym_char] = STATE(4765),
    [sym_format_string] = STATE(4746),
    [sym__string_literal] = STATE(4746),
    [sym_string] = STATE(4765),
    [sym_verbatim_string] = STATE(4765),
    [sym_bytearray] = STATE(4765),
    [sym_verbatim_bytearray] = STATE(4765),
    [sym_format_triple_quoted_string] = STATE(4720),
    [sym_triple_quoted_string] = STATE(4765),
    [sym_const] = STATE(4815),
    [sym_long_identifier] = STATE(3493),
    [sym_active_pattern] = STATE(3613),
    [sym__identifier_or_op] = STATE(3650),
    [sym_sbyte] = STATE(4765),
    [sym_byte] = STATE(4765),
    [sym_int16] = STATE(4765),
    [sym_uint16] = STATE(4765),
    [sym_int32] = STATE(4765),
    [sym_uint32] = STATE(4765),
    [sym_nativeint] = STATE(4765),
    [sym_unativeint] = STATE(4765),
    [sym_int64] = STATE(4765),
    [sym_uint64] = STATE(4765),
    [sym_ieee32] = STATE(4765),
    [sym_ieee64] = STATE(4765),
    [sym_bignum] = STATE(4765),
    [sym_decimal] = STATE(4765),
    [sym_float] = STATE(4512),
    [sym_block_comment] = STATE(2560),
    [sym_compiler_directive_decl] = STATE(2560),
    [sym_fsi_directive_decl] = STATE(2560),
    [sym_preproc_line] = STATE(2560),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(4175),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_LPAREN] = ACTIONS(3572),
    [anon_sym_null] = ACTIONS(3574),
    [anon_sym__] = ACTIONS(3576),
    [anon_sym_QMARK] = ACTIONS(4177),
    [anon_sym_COLON_QMARK] = ACTIONS(4179),
    [anon_sym_PIPE] = ACTIONS(4346),
    [anon_sym_LBRACK] = ACTIONS(3582),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3584),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [aux_sym_char_token1] = ACTIONS(3590),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3592),
    [anon_sym_DQUOTE] = ACTIONS(3594),
    [anon_sym_AT_DQUOTE] = ACTIONS(3596),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3598),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3600),
    [sym_bool] = ACTIONS(3602),
    [sym_unit] = ACTIONS(3604),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4181),
    [sym_op_identifier] = ACTIONS(4183),
    [sym_int] = ACTIONS(3610),
    [sym_xint] = ACTIONS(3612),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2561] = {
    [sym_attributes] = STATE(2699),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(4815),
    [sym__pattern] = STATE(5212),
    [sym_optional_pattern] = STATE(4815),
    [sym_type_check_pattern] = STATE(4815),
    [sym_attribute_pattern] = STATE(4815),
    [sym_paren_pattern] = STATE(4815),
    [sym_as_pattern] = STATE(4815),
    [sym_cons_pattern] = STATE(4815),
    [sym_disjunct_pattern] = STATE(4815),
    [sym_conjunct_pattern] = STATE(4815),
    [sym_typed_pattern] = STATE(4815),
    [sym_list_pattern] = STATE(4815),
    [sym_array_pattern] = STATE(4815),
    [sym_record_pattern] = STATE(4815),
    [sym_named_field_pattern] = STATE(4815),
    [sym_identifier_pattern] = STATE(4815),
    [sym_long_identifier_or_op] = STATE(2193),
    [sym_rule] = STATE(1497),
    [sym_rules] = STATE(2311),
    [sym_char] = STATE(4765),
    [sym_format_string] = STATE(4746),
    [sym__string_literal] = STATE(4746),
    [sym_string] = STATE(4765),
    [sym_verbatim_string] = STATE(4765),
    [sym_bytearray] = STATE(4765),
    [sym_verbatim_bytearray] = STATE(4765),
    [sym_format_triple_quoted_string] = STATE(4720),
    [sym_triple_quoted_string] = STATE(4765),
    [sym_const] = STATE(4815),
    [sym_long_identifier] = STATE(3493),
    [sym_active_pattern] = STATE(3613),
    [sym__identifier_or_op] = STATE(3650),
    [sym_sbyte] = STATE(4765),
    [sym_byte] = STATE(4765),
    [sym_int16] = STATE(4765),
    [sym_uint16] = STATE(4765),
    [sym_int32] = STATE(4765),
    [sym_uint32] = STATE(4765),
    [sym_nativeint] = STATE(4765),
    [sym_unativeint] = STATE(4765),
    [sym_int64] = STATE(4765),
    [sym_uint64] = STATE(4765),
    [sym_ieee32] = STATE(4765),
    [sym_ieee64] = STATE(4765),
    [sym_bignum] = STATE(4765),
    [sym_decimal] = STATE(4765),
    [sym_float] = STATE(4512),
    [sym_block_comment] = STATE(2561),
    [sym_compiler_directive_decl] = STATE(2561),
    [sym_fsi_directive_decl] = STATE(2561),
    [sym_preproc_line] = STATE(2561),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(4175),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_LPAREN] = ACTIONS(3572),
    [anon_sym_null] = ACTIONS(3574),
    [anon_sym__] = ACTIONS(3576),
    [anon_sym_QMARK] = ACTIONS(4177),
    [anon_sym_COLON_QMARK] = ACTIONS(4179),
    [anon_sym_PIPE] = ACTIONS(4364),
    [anon_sym_LBRACK] = ACTIONS(3582),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3584),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [aux_sym_char_token1] = ACTIONS(3590),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3592),
    [anon_sym_DQUOTE] = ACTIONS(3594),
    [anon_sym_AT_DQUOTE] = ACTIONS(3596),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3598),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3600),
    [sym_bool] = ACTIONS(3602),
    [sym_unit] = ACTIONS(3604),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4181),
    [sym_op_identifier] = ACTIONS(4183),
    [sym_int] = ACTIONS(3610),
    [sym_xint] = ACTIONS(3612),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2562] = {
    [sym_attributes] = STATE(2699),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(4815),
    [sym__pattern] = STATE(5267),
    [sym_optional_pattern] = STATE(4815),
    [sym_type_check_pattern] = STATE(4815),
    [sym_attribute_pattern] = STATE(4815),
    [sym_paren_pattern] = STATE(4815),
    [sym_as_pattern] = STATE(4815),
    [sym_cons_pattern] = STATE(4815),
    [sym_disjunct_pattern] = STATE(4815),
    [sym_conjunct_pattern] = STATE(4815),
    [sym_typed_pattern] = STATE(4815),
    [sym_list_pattern] = STATE(4815),
    [sym_array_pattern] = STATE(4815),
    [sym_record_pattern] = STATE(4815),
    [sym_named_field_pattern] = STATE(4815),
    [sym_identifier_pattern] = STATE(4815),
    [sym_long_identifier_or_op] = STATE(2193),
    [sym_rule] = STATE(1419),
    [sym_rules] = STATE(1936),
    [sym_char] = STATE(4765),
    [sym_format_string] = STATE(4746),
    [sym__string_literal] = STATE(4746),
    [sym_string] = STATE(4765),
    [sym_verbatim_string] = STATE(4765),
    [sym_bytearray] = STATE(4765),
    [sym_verbatim_bytearray] = STATE(4765),
    [sym_format_triple_quoted_string] = STATE(4720),
    [sym_triple_quoted_string] = STATE(4765),
    [sym_const] = STATE(4815),
    [sym_long_identifier] = STATE(3493),
    [sym_active_pattern] = STATE(3613),
    [sym__identifier_or_op] = STATE(3650),
    [sym_sbyte] = STATE(4765),
    [sym_byte] = STATE(4765),
    [sym_int16] = STATE(4765),
    [sym_uint16] = STATE(4765),
    [sym_int32] = STATE(4765),
    [sym_uint32] = STATE(4765),
    [sym_nativeint] = STATE(4765),
    [sym_unativeint] = STATE(4765),
    [sym_int64] = STATE(4765),
    [sym_uint64] = STATE(4765),
    [sym_ieee32] = STATE(4765),
    [sym_ieee64] = STATE(4765),
    [sym_bignum] = STATE(4765),
    [sym_decimal] = STATE(4765),
    [sym_float] = STATE(4512),
    [sym_block_comment] = STATE(2562),
    [sym_compiler_directive_decl] = STATE(2562),
    [sym_fsi_directive_decl] = STATE(2562),
    [sym_preproc_line] = STATE(2562),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(4175),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_LPAREN] = ACTIONS(3572),
    [anon_sym_null] = ACTIONS(3574),
    [anon_sym__] = ACTIONS(3576),
    [anon_sym_QMARK] = ACTIONS(4177),
    [anon_sym_COLON_QMARK] = ACTIONS(4179),
    [anon_sym_PIPE] = ACTIONS(4348),
    [anon_sym_LBRACK] = ACTIONS(3582),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3584),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [aux_sym_char_token1] = ACTIONS(3590),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3592),
    [anon_sym_DQUOTE] = ACTIONS(3594),
    [anon_sym_AT_DQUOTE] = ACTIONS(3596),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3598),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3600),
    [sym_bool] = ACTIONS(3602),
    [sym_unit] = ACTIONS(3604),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4181),
    [sym_op_identifier] = ACTIONS(4183),
    [sym_int] = ACTIONS(3610),
    [sym_xint] = ACTIONS(3612),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2563] = {
    [sym_attributes] = STATE(2699),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(4815),
    [sym__pattern] = STATE(5274),
    [sym_optional_pattern] = STATE(4815),
    [sym_type_check_pattern] = STATE(4815),
    [sym_attribute_pattern] = STATE(4815),
    [sym_paren_pattern] = STATE(4815),
    [sym_as_pattern] = STATE(4815),
    [sym_cons_pattern] = STATE(4815),
    [sym_disjunct_pattern] = STATE(4815),
    [sym_conjunct_pattern] = STATE(4815),
    [sym_typed_pattern] = STATE(4815),
    [sym_list_pattern] = STATE(4815),
    [sym_array_pattern] = STATE(4815),
    [sym_record_pattern] = STATE(4815),
    [sym_named_field_pattern] = STATE(4815),
    [sym_identifier_pattern] = STATE(4815),
    [sym_long_identifier_or_op] = STATE(2193),
    [sym_rule] = STATE(983),
    [sym_rules] = STATE(1111),
    [sym_char] = STATE(4765),
    [sym_format_string] = STATE(4746),
    [sym__string_literal] = STATE(4746),
    [sym_string] = STATE(4765),
    [sym_verbatim_string] = STATE(4765),
    [sym_bytearray] = STATE(4765),
    [sym_verbatim_bytearray] = STATE(4765),
    [sym_format_triple_quoted_string] = STATE(4720),
    [sym_triple_quoted_string] = STATE(4765),
    [sym_const] = STATE(4815),
    [sym_long_identifier] = STATE(3493),
    [sym_active_pattern] = STATE(3613),
    [sym__identifier_or_op] = STATE(3650),
    [sym_sbyte] = STATE(4765),
    [sym_byte] = STATE(4765),
    [sym_int16] = STATE(4765),
    [sym_uint16] = STATE(4765),
    [sym_int32] = STATE(4765),
    [sym_uint32] = STATE(4765),
    [sym_nativeint] = STATE(4765),
    [sym_unativeint] = STATE(4765),
    [sym_int64] = STATE(4765),
    [sym_uint64] = STATE(4765),
    [sym_ieee32] = STATE(4765),
    [sym_ieee64] = STATE(4765),
    [sym_bignum] = STATE(4765),
    [sym_decimal] = STATE(4765),
    [sym_float] = STATE(4512),
    [sym_block_comment] = STATE(2563),
    [sym_compiler_directive_decl] = STATE(2563),
    [sym_fsi_directive_decl] = STATE(2563),
    [sym_preproc_line] = STATE(2563),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(4175),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_LPAREN] = ACTIONS(3572),
    [anon_sym_null] = ACTIONS(3574),
    [anon_sym__] = ACTIONS(3576),
    [anon_sym_QMARK] = ACTIONS(4177),
    [anon_sym_COLON_QMARK] = ACTIONS(4179),
    [anon_sym_PIPE] = ACTIONS(4346),
    [anon_sym_LBRACK] = ACTIONS(3582),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3584),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [aux_sym_char_token1] = ACTIONS(3590),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3592),
    [anon_sym_DQUOTE] = ACTIONS(3594),
    [anon_sym_AT_DQUOTE] = ACTIONS(3596),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3598),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3600),
    [sym_bool] = ACTIONS(3602),
    [sym_unit] = ACTIONS(3604),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4181),
    [sym_op_identifier] = ACTIONS(4183),
    [sym_int] = ACTIONS(3610),
    [sym_xint] = ACTIONS(3612),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2564] = {
    [sym_attributes] = STATE(2699),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(4815),
    [sym__pattern] = STATE(5283),
    [sym_optional_pattern] = STATE(4815),
    [sym_type_check_pattern] = STATE(4815),
    [sym_attribute_pattern] = STATE(4815),
    [sym_paren_pattern] = STATE(4815),
    [sym_as_pattern] = STATE(4815),
    [sym_cons_pattern] = STATE(4815),
    [sym_disjunct_pattern] = STATE(4815),
    [sym_conjunct_pattern] = STATE(4815),
    [sym_typed_pattern] = STATE(4815),
    [sym_list_pattern] = STATE(4815),
    [sym_array_pattern] = STATE(4815),
    [sym_record_pattern] = STATE(4815),
    [sym_named_field_pattern] = STATE(4815),
    [sym_identifier_pattern] = STATE(4815),
    [sym_long_identifier_or_op] = STATE(2193),
    [sym_rule] = STATE(1678),
    [sym_rules] = STATE(2181),
    [sym_char] = STATE(4765),
    [sym_format_string] = STATE(4746),
    [sym__string_literal] = STATE(4746),
    [sym_string] = STATE(4765),
    [sym_verbatim_string] = STATE(4765),
    [sym_bytearray] = STATE(4765),
    [sym_verbatim_bytearray] = STATE(4765),
    [sym_format_triple_quoted_string] = STATE(4720),
    [sym_triple_quoted_string] = STATE(4765),
    [sym_const] = STATE(4815),
    [sym_long_identifier] = STATE(3493),
    [sym_active_pattern] = STATE(3613),
    [sym__identifier_or_op] = STATE(3650),
    [sym_sbyte] = STATE(4765),
    [sym_byte] = STATE(4765),
    [sym_int16] = STATE(4765),
    [sym_uint16] = STATE(4765),
    [sym_int32] = STATE(4765),
    [sym_uint32] = STATE(4765),
    [sym_nativeint] = STATE(4765),
    [sym_unativeint] = STATE(4765),
    [sym_int64] = STATE(4765),
    [sym_uint64] = STATE(4765),
    [sym_ieee32] = STATE(4765),
    [sym_ieee64] = STATE(4765),
    [sym_bignum] = STATE(4765),
    [sym_decimal] = STATE(4765),
    [sym_float] = STATE(4512),
    [sym_block_comment] = STATE(2564),
    [sym_compiler_directive_decl] = STATE(2564),
    [sym_fsi_directive_decl] = STATE(2564),
    [sym_preproc_line] = STATE(2564),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(4175),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_LPAREN] = ACTIONS(3572),
    [anon_sym_null] = ACTIONS(3574),
    [anon_sym__] = ACTIONS(3576),
    [anon_sym_QMARK] = ACTIONS(4177),
    [anon_sym_COLON_QMARK] = ACTIONS(4179),
    [anon_sym_PIPE] = ACTIONS(4368),
    [anon_sym_LBRACK] = ACTIONS(3582),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3584),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [aux_sym_char_token1] = ACTIONS(3590),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3592),
    [anon_sym_DQUOTE] = ACTIONS(3594),
    [anon_sym_AT_DQUOTE] = ACTIONS(3596),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3598),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3600),
    [sym_bool] = ACTIONS(3602),
    [sym_unit] = ACTIONS(3604),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4181),
    [sym_op_identifier] = ACTIONS(4183),
    [sym_int] = ACTIONS(3610),
    [sym_xint] = ACTIONS(3612),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2565] = {
    [sym_attributes] = STATE(2636),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(3546),
    [sym__pattern] = STATE(3706),
    [sym_optional_pattern] = STATE(3546),
    [sym_type_check_pattern] = STATE(3546),
    [sym_attribute_pattern] = STATE(3546),
    [sym_paren_pattern] = STATE(3546),
    [sym_as_pattern] = STATE(3546),
    [sym_cons_pattern] = STATE(3546),
    [sym_disjunct_pattern] = STATE(3546),
    [sym_conjunct_pattern] = STATE(3546),
    [sym_typed_pattern] = STATE(3546),
    [sym_list_pattern] = STATE(3546),
    [sym_array_pattern] = STATE(3546),
    [sym_record_pattern] = STATE(3546),
    [sym_named_field_pattern] = STATE(3546),
    [sym_identifier_pattern] = STATE(3546),
    [sym_long_identifier_or_op] = STATE(1834),
    [sym_char] = STATE(3509),
    [sym_format_string] = STATE(3517),
    [sym__string_literal] = STATE(3517),
    [sym_string] = STATE(3509),
    [sym_verbatim_string] = STATE(3509),
    [sym_bytearray] = STATE(3509),
    [sym_verbatim_bytearray] = STATE(3509),
    [sym_format_triple_quoted_string] = STATE(3519),
    [sym_triple_quoted_string] = STATE(3509),
    [sym_const] = STATE(3546),
    [sym_long_identifier] = STATE(3320),
    [sym_active_pattern] = STATE(3488),
    [sym__identifier_or_op] = STATE(3410),
    [sym_sbyte] = STATE(3509),
    [sym_byte] = STATE(3509),
    [sym_int16] = STATE(3509),
    [sym_uint16] = STATE(3509),
    [sym_int32] = STATE(3509),
    [sym_uint32] = STATE(3509),
    [sym_nativeint] = STATE(3509),
    [sym_unativeint] = STATE(3509),
    [sym_int64] = STATE(3509),
    [sym_uint64] = STATE(3509),
    [sym_ieee32] = STATE(3509),
    [sym_ieee64] = STATE(3509),
    [sym_bignum] = STATE(3509),
    [sym_decimal] = STATE(3509),
    [sym_float] = STATE(3291),
    [sym_block_comment] = STATE(2565),
    [sym_compiler_directive_decl] = STATE(2565),
    [sym_fsi_directive_decl] = STATE(2565),
    [sym_preproc_line] = STATE(2565),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [aux_sym__method_defn_repeat1] = STATE(2565),
    [sym_identifier] = ACTIONS(4370),
    [anon_sym_EQ] = ACTIONS(4373),
    [anon_sym_LBRACK_LT] = ACTIONS(4375),
    [anon_sym_LPAREN] = ACTIONS(4378),
    [anon_sym_null] = ACTIONS(4381),
    [anon_sym__] = ACTIONS(4384),
    [anon_sym_QMARK] = ACTIONS(4387),
    [anon_sym_COLON_QMARK] = ACTIONS(4390),
    [anon_sym_LBRACK] = ACTIONS(4393),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4396),
    [anon_sym_LBRACE] = ACTIONS(4399),
    [aux_sym_char_token1] = ACTIONS(4402),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4405),
    [anon_sym_DQUOTE] = ACTIONS(4408),
    [anon_sym_AT_DQUOTE] = ACTIONS(4411),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4414),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4417),
    [sym_bool] = ACTIONS(4420),
    [sym_unit] = ACTIONS(4423),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4426),
    [sym_op_identifier] = ACTIONS(4429),
    [sym_int] = ACTIONS(4432),
    [sym_xint] = ACTIONS(4435),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2566] = {
    [sym_attributes] = STATE(2636),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(3546),
    [sym__pattern] = STATE(3706),
    [sym_optional_pattern] = STATE(3546),
    [sym_type_check_pattern] = STATE(3546),
    [sym_attribute_pattern] = STATE(3546),
    [sym_paren_pattern] = STATE(3546),
    [sym_as_pattern] = STATE(3546),
    [sym_cons_pattern] = STATE(3546),
    [sym_disjunct_pattern] = STATE(3546),
    [sym_conjunct_pattern] = STATE(3546),
    [sym_typed_pattern] = STATE(3546),
    [sym_list_pattern] = STATE(3546),
    [sym_array_pattern] = STATE(3546),
    [sym_record_pattern] = STATE(3546),
    [sym_named_field_pattern] = STATE(3546),
    [sym_identifier_pattern] = STATE(3546),
    [sym_long_identifier_or_op] = STATE(1834),
    [sym_char] = STATE(3509),
    [sym_format_string] = STATE(3517),
    [sym__string_literal] = STATE(3517),
    [sym_string] = STATE(3509),
    [sym_verbatim_string] = STATE(3509),
    [sym_bytearray] = STATE(3509),
    [sym_verbatim_bytearray] = STATE(3509),
    [sym_format_triple_quoted_string] = STATE(3519),
    [sym_triple_quoted_string] = STATE(3509),
    [sym_const] = STATE(3546),
    [sym_long_identifier] = STATE(3320),
    [sym_active_pattern] = STATE(3488),
    [sym__identifier_or_op] = STATE(3410),
    [sym_sbyte] = STATE(3509),
    [sym_byte] = STATE(3509),
    [sym_int16] = STATE(3509),
    [sym_uint16] = STATE(3509),
    [sym_int32] = STATE(3509),
    [sym_uint32] = STATE(3509),
    [sym_nativeint] = STATE(3509),
    [sym_unativeint] = STATE(3509),
    [sym_int64] = STATE(3509),
    [sym_uint64] = STATE(3509),
    [sym_ieee32] = STATE(3509),
    [sym_ieee64] = STATE(3509),
    [sym_bignum] = STATE(3509),
    [sym_decimal] = STATE(3509),
    [sym_float] = STATE(3291),
    [sym_block_comment] = STATE(2566),
    [sym_compiler_directive_decl] = STATE(2566),
    [sym_fsi_directive_decl] = STATE(2566),
    [sym_preproc_line] = STATE(2566),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [aux_sym__method_defn_repeat1] = STATE(2565),
    [sym_identifier] = ACTIONS(3562),
    [anon_sym_EQ] = ACTIONS(4438),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_LPAREN] = ACTIONS(4014),
    [anon_sym_null] = ACTIONS(4016),
    [anon_sym__] = ACTIONS(4018),
    [anon_sym_QMARK] = ACTIONS(4020),
    [anon_sym_COLON_QMARK] = ACTIONS(4022),
    [anon_sym_LBRACK] = ACTIONS(4024),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4026),
    [anon_sym_LBRACE] = ACTIONS(4028),
    [aux_sym_char_token1] = ACTIONS(4030),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4032),
    [anon_sym_DQUOTE] = ACTIONS(4034),
    [anon_sym_AT_DQUOTE] = ACTIONS(4036),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4038),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4040),
    [sym_bool] = ACTIONS(4042),
    [sym_unit] = ACTIONS(4044),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3606),
    [sym_op_identifier] = ACTIONS(3608),
    [sym_int] = ACTIONS(4046),
    [sym_xint] = ACTIONS(4048),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2567] = {
    [sym_attributes] = STATE(2676),
    [sym__attribute_set] = STATE(4045),
    [sym_access_modifier] = STATE(2678),
    [sym_repeat_pattern] = STATE(4815),
    [sym__pattern] = STATE(5108),
    [sym_optional_pattern] = STATE(4815),
    [sym_type_check_pattern] = STATE(4815),
    [sym_attribute_pattern] = STATE(4815),
    [sym_paren_pattern] = STATE(4815),
    [sym_as_pattern] = STATE(4815),
    [sym_cons_pattern] = STATE(4815),
    [sym_disjunct_pattern] = STATE(4815),
    [sym_conjunct_pattern] = STATE(4815),
    [sym_typed_pattern] = STATE(4815),
    [sym_list_pattern] = STATE(4815),
    [sym_array_pattern] = STATE(4815),
    [sym_record_pattern] = STATE(4815),
    [sym_named_field_pattern] = STATE(4815),
    [sym_identifier_pattern] = STATE(4815),
    [sym_long_identifier_or_op] = STATE(1792),
    [sym_char] = STATE(4765),
    [sym_format_string] = STATE(4746),
    [sym__string_literal] = STATE(4746),
    [sym_string] = STATE(4765),
    [sym_verbatim_string] = STATE(4765),
    [sym_bytearray] = STATE(4765),
    [sym_verbatim_bytearray] = STATE(4765),
    [sym_format_triple_quoted_string] = STATE(4720),
    [sym_triple_quoted_string] = STATE(4765),
    [sym_const] = STATE(4815),
    [sym_long_identifier] = STATE(3320),
    [sym_active_pattern] = STATE(3488),
    [sym__identifier_or_op] = STATE(3410),
    [sym_sbyte] = STATE(4765),
    [sym_byte] = STATE(4765),
    [sym_int16] = STATE(4765),
    [sym_uint16] = STATE(4765),
    [sym_int32] = STATE(4765),
    [sym_uint32] = STATE(4765),
    [sym_nativeint] = STATE(4765),
    [sym_unativeint] = STATE(4765),
    [sym_int64] = STATE(4765),
    [sym_uint64] = STATE(4765),
    [sym_ieee32] = STATE(4765),
    [sym_ieee64] = STATE(4765),
    [sym_bignum] = STATE(4765),
    [sym_decimal] = STATE(4765),
    [sym_float] = STATE(4512),
    [sym_block_comment] = STATE(2567),
    [sym_compiler_directive_decl] = STATE(2567),
    [sym_fsi_directive_decl] = STATE(2567),
    [sym_preproc_line] = STATE(2567),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(3562),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [aux_sym_access_modifier_token1] = ACTIONS(3570),
    [anon_sym_LPAREN] = ACTIONS(3572),
    [anon_sym_null] = ACTIONS(3574),
    [anon_sym__] = ACTIONS(3576),
    [anon_sym_QMARK] = ACTIONS(3578),
    [anon_sym_COLON_QMARK] = ACTIONS(3580),
    [anon_sym_LBRACK] = ACTIONS(3582),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3584),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [aux_sym_char_token1] = ACTIONS(3590),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3592),
    [anon_sym_DQUOTE] = ACTIONS(3594),
    [anon_sym_AT_DQUOTE] = ACTIONS(3596),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3598),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3600),
    [sym_bool] = ACTIONS(3602),
    [sym_unit] = ACTIONS(3604),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3606),
    [sym_op_identifier] = ACTIONS(3608),
    [sym_int] = ACTIONS(3610),
    [sym_xint] = ACTIONS(3612),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2568] = {
    [sym_attributes] = STATE(2636),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(3546),
    [sym__pattern] = STATE(3706),
    [sym_optional_pattern] = STATE(3546),
    [sym_type_check_pattern] = STATE(3546),
    [sym_attribute_pattern] = STATE(3546),
    [sym_paren_pattern] = STATE(3546),
    [sym_as_pattern] = STATE(3546),
    [sym_cons_pattern] = STATE(3546),
    [sym_disjunct_pattern] = STATE(3546),
    [sym_conjunct_pattern] = STATE(3546),
    [sym_typed_pattern] = STATE(3546),
    [sym_list_pattern] = STATE(3546),
    [sym_array_pattern] = STATE(3546),
    [sym_record_pattern] = STATE(3546),
    [sym_named_field_pattern] = STATE(3546),
    [sym_identifier_pattern] = STATE(3546),
    [sym_long_identifier_or_op] = STATE(1834),
    [sym_char] = STATE(3509),
    [sym_format_string] = STATE(3517),
    [sym__string_literal] = STATE(3517),
    [sym_string] = STATE(3509),
    [sym_verbatim_string] = STATE(3509),
    [sym_bytearray] = STATE(3509),
    [sym_verbatim_bytearray] = STATE(3509),
    [sym_format_triple_quoted_string] = STATE(3519),
    [sym_triple_quoted_string] = STATE(3509),
    [sym_const] = STATE(3546),
    [sym_long_identifier] = STATE(3320),
    [sym_active_pattern] = STATE(3488),
    [sym__identifier_or_op] = STATE(3410),
    [sym_sbyte] = STATE(3509),
    [sym_byte] = STATE(3509),
    [sym_int16] = STATE(3509),
    [sym_uint16] = STATE(3509),
    [sym_int32] = STATE(3509),
    [sym_uint32] = STATE(3509),
    [sym_nativeint] = STATE(3509),
    [sym_unativeint] = STATE(3509),
    [sym_int64] = STATE(3509),
    [sym_uint64] = STATE(3509),
    [sym_ieee32] = STATE(3509),
    [sym_ieee64] = STATE(3509),
    [sym_bignum] = STATE(3509),
    [sym_decimal] = STATE(3509),
    [sym_float] = STATE(3291),
    [sym_block_comment] = STATE(2568),
    [sym_compiler_directive_decl] = STATE(2568),
    [sym_fsi_directive_decl] = STATE(2568),
    [sym_preproc_line] = STATE(2568),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [aux_sym__method_defn_repeat1] = STATE(2565),
    [sym_identifier] = ACTIONS(3562),
    [anon_sym_EQ] = ACTIONS(4440),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_LPAREN] = ACTIONS(4014),
    [anon_sym_null] = ACTIONS(4016),
    [anon_sym__] = ACTIONS(4018),
    [anon_sym_QMARK] = ACTIONS(4020),
    [anon_sym_COLON_QMARK] = ACTIONS(4022),
    [anon_sym_LBRACK] = ACTIONS(4024),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4026),
    [anon_sym_LBRACE] = ACTIONS(4028),
    [aux_sym_char_token1] = ACTIONS(4030),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4032),
    [anon_sym_DQUOTE] = ACTIONS(4034),
    [anon_sym_AT_DQUOTE] = ACTIONS(4036),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4038),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4040),
    [sym_bool] = ACTIONS(4042),
    [sym_unit] = ACTIONS(4044),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3606),
    [sym_op_identifier] = ACTIONS(3608),
    [sym_int] = ACTIONS(4046),
    [sym_xint] = ACTIONS(4048),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2569] = {
    [sym_attributes] = STATE(2699),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(4815),
    [sym__pattern] = STATE(5311),
    [sym_optional_pattern] = STATE(4815),
    [sym_type_check_pattern] = STATE(4815),
    [sym_attribute_pattern] = STATE(4815),
    [sym_paren_pattern] = STATE(4815),
    [sym_as_pattern] = STATE(4815),
    [sym_cons_pattern] = STATE(4815),
    [sym_disjunct_pattern] = STATE(4815),
    [sym_conjunct_pattern] = STATE(4815),
    [sym_typed_pattern] = STATE(4815),
    [sym_list_pattern] = STATE(4815),
    [sym_array_pattern] = STATE(4815),
    [sym_record_pattern] = STATE(4815),
    [sym_named_field_pattern] = STATE(4815),
    [sym_identifier_pattern] = STATE(4815),
    [sym_long_identifier_or_op] = STATE(2193),
    [sym_rule] = STATE(1505),
    [sym_char] = STATE(4765),
    [sym_format_string] = STATE(4746),
    [sym__string_literal] = STATE(4746),
    [sym_string] = STATE(4765),
    [sym_verbatim_string] = STATE(4765),
    [sym_bytearray] = STATE(4765),
    [sym_verbatim_bytearray] = STATE(4765),
    [sym_format_triple_quoted_string] = STATE(4720),
    [sym_triple_quoted_string] = STATE(4765),
    [sym_const] = STATE(4815),
    [sym_long_identifier] = STATE(3493),
    [sym_active_pattern] = STATE(3613),
    [sym__identifier_or_op] = STATE(3650),
    [sym_sbyte] = STATE(4765),
    [sym_byte] = STATE(4765),
    [sym_int16] = STATE(4765),
    [sym_uint16] = STATE(4765),
    [sym_int32] = STATE(4765),
    [sym_uint32] = STATE(4765),
    [sym_nativeint] = STATE(4765),
    [sym_unativeint] = STATE(4765),
    [sym_int64] = STATE(4765),
    [sym_uint64] = STATE(4765),
    [sym_ieee32] = STATE(4765),
    [sym_ieee64] = STATE(4765),
    [sym_bignum] = STATE(4765),
    [sym_decimal] = STATE(4765),
    [sym_float] = STATE(4512),
    [sym_block_comment] = STATE(2569),
    [sym_compiler_directive_decl] = STATE(2569),
    [sym_fsi_directive_decl] = STATE(2569),
    [sym_preproc_line] = STATE(2569),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(4175),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_LPAREN] = ACTIONS(3572),
    [anon_sym_null] = ACTIONS(3574),
    [anon_sym__] = ACTIONS(3576),
    [anon_sym_QMARK] = ACTIONS(4177),
    [anon_sym_COLON_QMARK] = ACTIONS(4179),
    [anon_sym_LBRACK] = ACTIONS(3582),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3584),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [aux_sym_char_token1] = ACTIONS(3590),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3592),
    [anon_sym_DQUOTE] = ACTIONS(3594),
    [anon_sym_AT_DQUOTE] = ACTIONS(3596),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3598),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3600),
    [sym_bool] = ACTIONS(3602),
    [sym_unit] = ACTIONS(3604),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4181),
    [sym_op_identifier] = ACTIONS(4183),
    [sym_int] = ACTIONS(3610),
    [sym_xint] = ACTIONS(3612),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2570] = {
    [sym_attributes] = STATE(2699),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(4815),
    [sym__pattern] = STATE(5237),
    [sym_optional_pattern] = STATE(4815),
    [sym_type_check_pattern] = STATE(4815),
    [sym_attribute_pattern] = STATE(4815),
    [sym_paren_pattern] = STATE(4815),
    [sym_as_pattern] = STATE(4815),
    [sym_cons_pattern] = STATE(4815),
    [sym_disjunct_pattern] = STATE(4815),
    [sym_conjunct_pattern] = STATE(4815),
    [sym_typed_pattern] = STATE(4815),
    [sym_list_pattern] = STATE(4815),
    [sym_array_pattern] = STATE(4815),
    [sym_record_pattern] = STATE(4815),
    [sym_named_field_pattern] = STATE(4815),
    [sym_identifier_pattern] = STATE(4815),
    [sym_long_identifier_or_op] = STATE(2193),
    [sym_rule] = STATE(1502),
    [sym_char] = STATE(4765),
    [sym_format_string] = STATE(4746),
    [sym__string_literal] = STATE(4746),
    [sym_string] = STATE(4765),
    [sym_verbatim_string] = STATE(4765),
    [sym_bytearray] = STATE(4765),
    [sym_verbatim_bytearray] = STATE(4765),
    [sym_format_triple_quoted_string] = STATE(4720),
    [sym_triple_quoted_string] = STATE(4765),
    [sym_const] = STATE(4815),
    [sym_long_identifier] = STATE(3493),
    [sym_active_pattern] = STATE(3613),
    [sym__identifier_or_op] = STATE(3650),
    [sym_sbyte] = STATE(4765),
    [sym_byte] = STATE(4765),
    [sym_int16] = STATE(4765),
    [sym_uint16] = STATE(4765),
    [sym_int32] = STATE(4765),
    [sym_uint32] = STATE(4765),
    [sym_nativeint] = STATE(4765),
    [sym_unativeint] = STATE(4765),
    [sym_int64] = STATE(4765),
    [sym_uint64] = STATE(4765),
    [sym_ieee32] = STATE(4765),
    [sym_ieee64] = STATE(4765),
    [sym_bignum] = STATE(4765),
    [sym_decimal] = STATE(4765),
    [sym_float] = STATE(4512),
    [sym_block_comment] = STATE(2570),
    [sym_compiler_directive_decl] = STATE(2570),
    [sym_fsi_directive_decl] = STATE(2570),
    [sym_preproc_line] = STATE(2570),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(4175),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_LPAREN] = ACTIONS(3572),
    [anon_sym_null] = ACTIONS(3574),
    [anon_sym__] = ACTIONS(3576),
    [anon_sym_QMARK] = ACTIONS(4177),
    [anon_sym_COLON_QMARK] = ACTIONS(4179),
    [anon_sym_LBRACK] = ACTIONS(3582),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3584),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [aux_sym_char_token1] = ACTIONS(3590),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3592),
    [anon_sym_DQUOTE] = ACTIONS(3594),
    [anon_sym_AT_DQUOTE] = ACTIONS(3596),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3598),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3600),
    [sym_bool] = ACTIONS(3602),
    [sym_unit] = ACTIONS(3604),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4181),
    [sym_op_identifier] = ACTIONS(4183),
    [sym_int] = ACTIONS(3610),
    [sym_xint] = ACTIONS(3612),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2571] = {
    [sym_attributes] = STATE(2641),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(5241),
    [sym__pattern] = STATE(5251),
    [sym_optional_pattern] = STATE(5241),
    [sym_type_check_pattern] = STATE(5241),
    [sym_attribute_pattern] = STATE(5241),
    [sym_paren_pattern] = STATE(5241),
    [sym_as_pattern] = STATE(5241),
    [sym_cons_pattern] = STATE(5241),
    [sym_disjunct_pattern] = STATE(5241),
    [sym_conjunct_pattern] = STATE(5241),
    [sym_typed_pattern] = STATE(5241),
    [sym_list_pattern] = STATE(5241),
    [sym_array_pattern] = STATE(5241),
    [sym_record_pattern] = STATE(5241),
    [sym_named_field] = STATE(5998),
    [sym_named_field_pattern] = STATE(5241),
    [sym_identifier_pattern] = STATE(5241),
    [sym_long_identifier_or_op] = STATE(1721),
    [sym_char] = STATE(5389),
    [sym_format_string] = STATE(5273),
    [sym__string_literal] = STATE(5273),
    [sym_string] = STATE(5389),
    [sym_verbatim_string] = STATE(5389),
    [sym_bytearray] = STATE(5389),
    [sym_verbatim_bytearray] = STATE(5389),
    [sym_format_triple_quoted_string] = STATE(5377),
    [sym_triple_quoted_string] = STATE(5389),
    [sym_const] = STATE(5241),
    [sym_long_identifier] = STATE(3363),
    [sym_active_pattern] = STATE(3521),
    [sym__identifier_or_op] = STATE(3510),
    [sym_sbyte] = STATE(5389),
    [sym_byte] = STATE(5389),
    [sym_int16] = STATE(5389),
    [sym_uint16] = STATE(5389),
    [sym_int32] = STATE(5389),
    [sym_uint32] = STATE(5389),
    [sym_nativeint] = STATE(5389),
    [sym_unativeint] = STATE(5389),
    [sym_int64] = STATE(5389),
    [sym_uint64] = STATE(5389),
    [sym_ieee32] = STATE(5389),
    [sym_ieee64] = STATE(5389),
    [sym_bignum] = STATE(5389),
    [sym_decimal] = STATE(5389),
    [sym_float] = STATE(4893),
    [sym_block_comment] = STATE(2571),
    [sym_compiler_directive_decl] = STATE(2571),
    [sym_fsi_directive_decl] = STATE(2571),
    [sym_preproc_line] = STATE(2571),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(4442),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_LPAREN] = ACTIONS(3872),
    [anon_sym_null] = ACTIONS(3874),
    [anon_sym__] = ACTIONS(3876),
    [anon_sym_QMARK] = ACTIONS(3878),
    [anon_sym_COLON_QMARK] = ACTIONS(3880),
    [anon_sym_LBRACK] = ACTIONS(3882),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3884),
    [anon_sym_LBRACE] = ACTIONS(3886),
    [aux_sym_char_token1] = ACTIONS(3888),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3890),
    [anon_sym_DQUOTE] = ACTIONS(3892),
    [anon_sym_AT_DQUOTE] = ACTIONS(3894),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3896),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3898),
    [sym_bool] = ACTIONS(3900),
    [sym_unit] = ACTIONS(3902),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3904),
    [sym_op_identifier] = ACTIONS(3906),
    [sym_int] = ACTIONS(3908),
    [sym_xint] = ACTIONS(3910),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2572] = {
    [sym_attributes] = STATE(2636),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(3546),
    [sym__pattern] = STATE(3706),
    [sym_optional_pattern] = STATE(3546),
    [sym_type_check_pattern] = STATE(3546),
    [sym_attribute_pattern] = STATE(3546),
    [sym_paren_pattern] = STATE(3546),
    [sym_as_pattern] = STATE(3546),
    [sym_cons_pattern] = STATE(3546),
    [sym_disjunct_pattern] = STATE(3546),
    [sym_conjunct_pattern] = STATE(3546),
    [sym_typed_pattern] = STATE(3546),
    [sym_list_pattern] = STATE(3546),
    [sym_array_pattern] = STATE(3546),
    [sym_record_pattern] = STATE(3546),
    [sym_named_field_pattern] = STATE(3546),
    [sym_identifier_pattern] = STATE(3546),
    [sym_long_identifier_or_op] = STATE(1834),
    [sym_char] = STATE(3509),
    [sym_format_string] = STATE(3517),
    [sym__string_literal] = STATE(3517),
    [sym_string] = STATE(3509),
    [sym_verbatim_string] = STATE(3509),
    [sym_bytearray] = STATE(3509),
    [sym_verbatim_bytearray] = STATE(3509),
    [sym_format_triple_quoted_string] = STATE(3519),
    [sym_triple_quoted_string] = STATE(3509),
    [sym_const] = STATE(3546),
    [sym_long_identifier] = STATE(3320),
    [sym_active_pattern] = STATE(3488),
    [sym__identifier_or_op] = STATE(3410),
    [sym_sbyte] = STATE(3509),
    [sym_byte] = STATE(3509),
    [sym_int16] = STATE(3509),
    [sym_uint16] = STATE(3509),
    [sym_int32] = STATE(3509),
    [sym_uint32] = STATE(3509),
    [sym_nativeint] = STATE(3509),
    [sym_unativeint] = STATE(3509),
    [sym_int64] = STATE(3509),
    [sym_uint64] = STATE(3509),
    [sym_ieee32] = STATE(3509),
    [sym_ieee64] = STATE(3509),
    [sym_bignum] = STATE(3509),
    [sym_decimal] = STATE(3509),
    [sym_float] = STATE(3291),
    [sym_block_comment] = STATE(2572),
    [sym_compiler_directive_decl] = STATE(2572),
    [sym_fsi_directive_decl] = STATE(2572),
    [sym_preproc_line] = STATE(2572),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [aux_sym__method_defn_repeat1] = STATE(2568),
    [sym_identifier] = ACTIONS(3562),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_LPAREN] = ACTIONS(4014),
    [anon_sym_null] = ACTIONS(4016),
    [anon_sym__] = ACTIONS(4018),
    [anon_sym_QMARK] = ACTIONS(4020),
    [anon_sym_COLON_QMARK] = ACTIONS(4022),
    [anon_sym_LBRACK] = ACTIONS(4024),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4026),
    [anon_sym_LBRACE] = ACTIONS(4028),
    [aux_sym_char_token1] = ACTIONS(4030),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4032),
    [anon_sym_DQUOTE] = ACTIONS(4034),
    [anon_sym_AT_DQUOTE] = ACTIONS(4036),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4038),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4040),
    [sym_bool] = ACTIONS(4042),
    [sym_unit] = ACTIONS(4044),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3606),
    [sym_op_identifier] = ACTIONS(3608),
    [sym_int] = ACTIONS(4046),
    [sym_xint] = ACTIONS(4048),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2573] = {
    [sym_attributes] = STATE(2699),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(4815),
    [sym__pattern] = STATE(5323),
    [sym_optional_pattern] = STATE(4815),
    [sym_type_check_pattern] = STATE(4815),
    [sym_attribute_pattern] = STATE(4815),
    [sym_paren_pattern] = STATE(4815),
    [sym_as_pattern] = STATE(4815),
    [sym_cons_pattern] = STATE(4815),
    [sym_disjunct_pattern] = STATE(4815),
    [sym_conjunct_pattern] = STATE(4815),
    [sym_typed_pattern] = STATE(4815),
    [sym_list_pattern] = STATE(4815),
    [sym_array_pattern] = STATE(4815),
    [sym_record_pattern] = STATE(4815),
    [sym_named_field_pattern] = STATE(4815),
    [sym_identifier_pattern] = STATE(4815),
    [sym_long_identifier_or_op] = STATE(2193),
    [sym_rule] = STATE(1463),
    [sym_char] = STATE(4765),
    [sym_format_string] = STATE(4746),
    [sym__string_literal] = STATE(4746),
    [sym_string] = STATE(4765),
    [sym_verbatim_string] = STATE(4765),
    [sym_bytearray] = STATE(4765),
    [sym_verbatim_bytearray] = STATE(4765),
    [sym_format_triple_quoted_string] = STATE(4720),
    [sym_triple_quoted_string] = STATE(4765),
    [sym_const] = STATE(4815),
    [sym_long_identifier] = STATE(3493),
    [sym_active_pattern] = STATE(3613),
    [sym__identifier_or_op] = STATE(3650),
    [sym_sbyte] = STATE(4765),
    [sym_byte] = STATE(4765),
    [sym_int16] = STATE(4765),
    [sym_uint16] = STATE(4765),
    [sym_int32] = STATE(4765),
    [sym_uint32] = STATE(4765),
    [sym_nativeint] = STATE(4765),
    [sym_unativeint] = STATE(4765),
    [sym_int64] = STATE(4765),
    [sym_uint64] = STATE(4765),
    [sym_ieee32] = STATE(4765),
    [sym_ieee64] = STATE(4765),
    [sym_bignum] = STATE(4765),
    [sym_decimal] = STATE(4765),
    [sym_float] = STATE(4512),
    [sym_block_comment] = STATE(2573),
    [sym_compiler_directive_decl] = STATE(2573),
    [sym_fsi_directive_decl] = STATE(2573),
    [sym_preproc_line] = STATE(2573),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(4175),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_LPAREN] = ACTIONS(3572),
    [anon_sym_null] = ACTIONS(3574),
    [anon_sym__] = ACTIONS(3576),
    [anon_sym_QMARK] = ACTIONS(4177),
    [anon_sym_COLON_QMARK] = ACTIONS(4179),
    [anon_sym_LBRACK] = ACTIONS(3582),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3584),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [aux_sym_char_token1] = ACTIONS(3590),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3592),
    [anon_sym_DQUOTE] = ACTIONS(3594),
    [anon_sym_AT_DQUOTE] = ACTIONS(3596),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3598),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3600),
    [sym_bool] = ACTIONS(3602),
    [sym_unit] = ACTIONS(3604),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4181),
    [sym_op_identifier] = ACTIONS(4183),
    [sym_int] = ACTIONS(3610),
    [sym_xint] = ACTIONS(3612),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2574] = {
    [sym_attributes] = STATE(2699),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(4815),
    [sym__pattern] = STATE(5196),
    [sym_optional_pattern] = STATE(4815),
    [sym_type_check_pattern] = STATE(4815),
    [sym_attribute_pattern] = STATE(4815),
    [sym_paren_pattern] = STATE(4815),
    [sym_as_pattern] = STATE(4815),
    [sym_cons_pattern] = STATE(4815),
    [sym_disjunct_pattern] = STATE(4815),
    [sym_conjunct_pattern] = STATE(4815),
    [sym_typed_pattern] = STATE(4815),
    [sym_list_pattern] = STATE(4815),
    [sym_array_pattern] = STATE(4815),
    [sym_record_pattern] = STATE(4815),
    [sym_named_field_pattern] = STATE(4815),
    [sym_identifier_pattern] = STATE(4815),
    [sym_long_identifier_or_op] = STATE(2193),
    [sym_rule] = STATE(823),
    [sym_char] = STATE(4765),
    [sym_format_string] = STATE(4746),
    [sym__string_literal] = STATE(4746),
    [sym_string] = STATE(4765),
    [sym_verbatim_string] = STATE(4765),
    [sym_bytearray] = STATE(4765),
    [sym_verbatim_bytearray] = STATE(4765),
    [sym_format_triple_quoted_string] = STATE(4720),
    [sym_triple_quoted_string] = STATE(4765),
    [sym_const] = STATE(4815),
    [sym_long_identifier] = STATE(3493),
    [sym_active_pattern] = STATE(3613),
    [sym__identifier_or_op] = STATE(3650),
    [sym_sbyte] = STATE(4765),
    [sym_byte] = STATE(4765),
    [sym_int16] = STATE(4765),
    [sym_uint16] = STATE(4765),
    [sym_int32] = STATE(4765),
    [sym_uint32] = STATE(4765),
    [sym_nativeint] = STATE(4765),
    [sym_unativeint] = STATE(4765),
    [sym_int64] = STATE(4765),
    [sym_uint64] = STATE(4765),
    [sym_ieee32] = STATE(4765),
    [sym_ieee64] = STATE(4765),
    [sym_bignum] = STATE(4765),
    [sym_decimal] = STATE(4765),
    [sym_float] = STATE(4512),
    [sym_block_comment] = STATE(2574),
    [sym_compiler_directive_decl] = STATE(2574),
    [sym_fsi_directive_decl] = STATE(2574),
    [sym_preproc_line] = STATE(2574),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(4175),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_LPAREN] = ACTIONS(3572),
    [anon_sym_null] = ACTIONS(3574),
    [anon_sym__] = ACTIONS(3576),
    [anon_sym_QMARK] = ACTIONS(4177),
    [anon_sym_COLON_QMARK] = ACTIONS(4179),
    [anon_sym_LBRACK] = ACTIONS(3582),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3584),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [aux_sym_char_token1] = ACTIONS(3590),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3592),
    [anon_sym_DQUOTE] = ACTIONS(3594),
    [anon_sym_AT_DQUOTE] = ACTIONS(3596),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3598),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3600),
    [sym_bool] = ACTIONS(3602),
    [sym_unit] = ACTIONS(3604),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4181),
    [sym_op_identifier] = ACTIONS(4183),
    [sym_int] = ACTIONS(3610),
    [sym_xint] = ACTIONS(3612),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2575] = {
    [sym_attributes] = STATE(2699),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(4815),
    [sym__pattern] = STATE(5323),
    [sym_optional_pattern] = STATE(4815),
    [sym_type_check_pattern] = STATE(4815),
    [sym_attribute_pattern] = STATE(4815),
    [sym_paren_pattern] = STATE(4815),
    [sym_as_pattern] = STATE(4815),
    [sym_cons_pattern] = STATE(4815),
    [sym_disjunct_pattern] = STATE(4815),
    [sym_conjunct_pattern] = STATE(4815),
    [sym_typed_pattern] = STATE(4815),
    [sym_list_pattern] = STATE(4815),
    [sym_array_pattern] = STATE(4815),
    [sym_record_pattern] = STATE(4815),
    [sym_named_field_pattern] = STATE(4815),
    [sym_identifier_pattern] = STATE(4815),
    [sym_long_identifier_or_op] = STATE(2193),
    [sym_rule] = STATE(1525),
    [sym_char] = STATE(4765),
    [sym_format_string] = STATE(4746),
    [sym__string_literal] = STATE(4746),
    [sym_string] = STATE(4765),
    [sym_verbatim_string] = STATE(4765),
    [sym_bytearray] = STATE(4765),
    [sym_verbatim_bytearray] = STATE(4765),
    [sym_format_triple_quoted_string] = STATE(4720),
    [sym_triple_quoted_string] = STATE(4765),
    [sym_const] = STATE(4815),
    [sym_long_identifier] = STATE(3493),
    [sym_active_pattern] = STATE(3613),
    [sym__identifier_or_op] = STATE(3650),
    [sym_sbyte] = STATE(4765),
    [sym_byte] = STATE(4765),
    [sym_int16] = STATE(4765),
    [sym_uint16] = STATE(4765),
    [sym_int32] = STATE(4765),
    [sym_uint32] = STATE(4765),
    [sym_nativeint] = STATE(4765),
    [sym_unativeint] = STATE(4765),
    [sym_int64] = STATE(4765),
    [sym_uint64] = STATE(4765),
    [sym_ieee32] = STATE(4765),
    [sym_ieee64] = STATE(4765),
    [sym_bignum] = STATE(4765),
    [sym_decimal] = STATE(4765),
    [sym_float] = STATE(4512),
    [sym_block_comment] = STATE(2575),
    [sym_compiler_directive_decl] = STATE(2575),
    [sym_fsi_directive_decl] = STATE(2575),
    [sym_preproc_line] = STATE(2575),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(4175),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_LPAREN] = ACTIONS(3572),
    [anon_sym_null] = ACTIONS(3574),
    [anon_sym__] = ACTIONS(3576),
    [anon_sym_QMARK] = ACTIONS(4177),
    [anon_sym_COLON_QMARK] = ACTIONS(4179),
    [anon_sym_LBRACK] = ACTIONS(3582),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3584),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [aux_sym_char_token1] = ACTIONS(3590),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3592),
    [anon_sym_DQUOTE] = ACTIONS(3594),
    [anon_sym_AT_DQUOTE] = ACTIONS(3596),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3598),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3600),
    [sym_bool] = ACTIONS(3602),
    [sym_unit] = ACTIONS(3604),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4181),
    [sym_op_identifier] = ACTIONS(4183),
    [sym_int] = ACTIONS(3610),
    [sym_xint] = ACTIONS(3612),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2576] = {
    [sym_attributes] = STATE(2699),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(4815),
    [sym__pattern] = STATE(5274),
    [sym_optional_pattern] = STATE(4815),
    [sym_type_check_pattern] = STATE(4815),
    [sym_attribute_pattern] = STATE(4815),
    [sym_paren_pattern] = STATE(4815),
    [sym_as_pattern] = STATE(4815),
    [sym_cons_pattern] = STATE(4815),
    [sym_disjunct_pattern] = STATE(4815),
    [sym_conjunct_pattern] = STATE(4815),
    [sym_typed_pattern] = STATE(4815),
    [sym_list_pattern] = STATE(4815),
    [sym_array_pattern] = STATE(4815),
    [sym_record_pattern] = STATE(4815),
    [sym_named_field_pattern] = STATE(4815),
    [sym_identifier_pattern] = STATE(4815),
    [sym_long_identifier_or_op] = STATE(2193),
    [sym_rule] = STATE(1000),
    [sym_char] = STATE(4765),
    [sym_format_string] = STATE(4746),
    [sym__string_literal] = STATE(4746),
    [sym_string] = STATE(4765),
    [sym_verbatim_string] = STATE(4765),
    [sym_bytearray] = STATE(4765),
    [sym_verbatim_bytearray] = STATE(4765),
    [sym_format_triple_quoted_string] = STATE(4720),
    [sym_triple_quoted_string] = STATE(4765),
    [sym_const] = STATE(4815),
    [sym_long_identifier] = STATE(3493),
    [sym_active_pattern] = STATE(3613),
    [sym__identifier_or_op] = STATE(3650),
    [sym_sbyte] = STATE(4765),
    [sym_byte] = STATE(4765),
    [sym_int16] = STATE(4765),
    [sym_uint16] = STATE(4765),
    [sym_int32] = STATE(4765),
    [sym_uint32] = STATE(4765),
    [sym_nativeint] = STATE(4765),
    [sym_unativeint] = STATE(4765),
    [sym_int64] = STATE(4765),
    [sym_uint64] = STATE(4765),
    [sym_ieee32] = STATE(4765),
    [sym_ieee64] = STATE(4765),
    [sym_bignum] = STATE(4765),
    [sym_decimal] = STATE(4765),
    [sym_float] = STATE(4512),
    [sym_block_comment] = STATE(2576),
    [sym_compiler_directive_decl] = STATE(2576),
    [sym_fsi_directive_decl] = STATE(2576),
    [sym_preproc_line] = STATE(2576),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(4175),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_LPAREN] = ACTIONS(3572),
    [anon_sym_null] = ACTIONS(3574),
    [anon_sym__] = ACTIONS(3576),
    [anon_sym_QMARK] = ACTIONS(4177),
    [anon_sym_COLON_QMARK] = ACTIONS(4179),
    [anon_sym_LBRACK] = ACTIONS(3582),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3584),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [aux_sym_char_token1] = ACTIONS(3590),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3592),
    [anon_sym_DQUOTE] = ACTIONS(3594),
    [anon_sym_AT_DQUOTE] = ACTIONS(3596),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3598),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3600),
    [sym_bool] = ACTIONS(3602),
    [sym_unit] = ACTIONS(3604),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4181),
    [sym_op_identifier] = ACTIONS(4183),
    [sym_int] = ACTIONS(3610),
    [sym_xint] = ACTIONS(3612),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2577] = {
    [sym_attributes] = STATE(2699),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(4815),
    [sym__pattern] = STATE(5311),
    [sym_optional_pattern] = STATE(4815),
    [sym_type_check_pattern] = STATE(4815),
    [sym_attribute_pattern] = STATE(4815),
    [sym_paren_pattern] = STATE(4815),
    [sym_as_pattern] = STATE(4815),
    [sym_cons_pattern] = STATE(4815),
    [sym_disjunct_pattern] = STATE(4815),
    [sym_conjunct_pattern] = STATE(4815),
    [sym_typed_pattern] = STATE(4815),
    [sym_list_pattern] = STATE(4815),
    [sym_array_pattern] = STATE(4815),
    [sym_record_pattern] = STATE(4815),
    [sym_named_field_pattern] = STATE(4815),
    [sym_identifier_pattern] = STATE(4815),
    [sym_long_identifier_or_op] = STATE(2193),
    [sym_rule] = STATE(1498),
    [sym_char] = STATE(4765),
    [sym_format_string] = STATE(4746),
    [sym__string_literal] = STATE(4746),
    [sym_string] = STATE(4765),
    [sym_verbatim_string] = STATE(4765),
    [sym_bytearray] = STATE(4765),
    [sym_verbatim_bytearray] = STATE(4765),
    [sym_format_triple_quoted_string] = STATE(4720),
    [sym_triple_quoted_string] = STATE(4765),
    [sym_const] = STATE(4815),
    [sym_long_identifier] = STATE(3493),
    [sym_active_pattern] = STATE(3613),
    [sym__identifier_or_op] = STATE(3650),
    [sym_sbyte] = STATE(4765),
    [sym_byte] = STATE(4765),
    [sym_int16] = STATE(4765),
    [sym_uint16] = STATE(4765),
    [sym_int32] = STATE(4765),
    [sym_uint32] = STATE(4765),
    [sym_nativeint] = STATE(4765),
    [sym_unativeint] = STATE(4765),
    [sym_int64] = STATE(4765),
    [sym_uint64] = STATE(4765),
    [sym_ieee32] = STATE(4765),
    [sym_ieee64] = STATE(4765),
    [sym_bignum] = STATE(4765),
    [sym_decimal] = STATE(4765),
    [sym_float] = STATE(4512),
    [sym_block_comment] = STATE(2577),
    [sym_compiler_directive_decl] = STATE(2577),
    [sym_fsi_directive_decl] = STATE(2577),
    [sym_preproc_line] = STATE(2577),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(4175),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_LPAREN] = ACTIONS(3572),
    [anon_sym_null] = ACTIONS(3574),
    [anon_sym__] = ACTIONS(3576),
    [anon_sym_QMARK] = ACTIONS(4177),
    [anon_sym_COLON_QMARK] = ACTIONS(4179),
    [anon_sym_LBRACK] = ACTIONS(3582),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3584),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [aux_sym_char_token1] = ACTIONS(3590),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3592),
    [anon_sym_DQUOTE] = ACTIONS(3594),
    [anon_sym_AT_DQUOTE] = ACTIONS(3596),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3598),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3600),
    [sym_bool] = ACTIONS(3602),
    [sym_unit] = ACTIONS(3604),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4181),
    [sym_op_identifier] = ACTIONS(4183),
    [sym_int] = ACTIONS(3610),
    [sym_xint] = ACTIONS(3612),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2578] = {
    [sym_attributes] = STATE(2641),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(5241),
    [sym__pattern] = STATE(5359),
    [sym_optional_pattern] = STATE(5241),
    [sym_type_check_pattern] = STATE(5241),
    [sym_attribute_pattern] = STATE(5241),
    [sym_paren_pattern] = STATE(5241),
    [sym_as_pattern] = STATE(5241),
    [sym_cons_pattern] = STATE(5241),
    [sym_disjunct_pattern] = STATE(5241),
    [sym_conjunct_pattern] = STATE(5241),
    [sym_typed_pattern] = STATE(5241),
    [sym_list_pattern] = STATE(5241),
    [sym_array_pattern] = STATE(5241),
    [sym_record_pattern] = STATE(5241),
    [sym_named_field] = STATE(5945),
    [sym_named_field_pattern] = STATE(5241),
    [sym_identifier_pattern] = STATE(5241),
    [sym_long_identifier_or_op] = STATE(1721),
    [sym_char] = STATE(5389),
    [sym_format_string] = STATE(5273),
    [sym__string_literal] = STATE(5273),
    [sym_string] = STATE(5389),
    [sym_verbatim_string] = STATE(5389),
    [sym_bytearray] = STATE(5389),
    [sym_verbatim_bytearray] = STATE(5389),
    [sym_format_triple_quoted_string] = STATE(5377),
    [sym_triple_quoted_string] = STATE(5389),
    [sym_const] = STATE(5241),
    [sym_long_identifier] = STATE(3363),
    [sym_active_pattern] = STATE(3521),
    [sym__identifier_or_op] = STATE(3510),
    [sym_sbyte] = STATE(5389),
    [sym_byte] = STATE(5389),
    [sym_int16] = STATE(5389),
    [sym_uint16] = STATE(5389),
    [sym_int32] = STATE(5389),
    [sym_uint32] = STATE(5389),
    [sym_nativeint] = STATE(5389),
    [sym_unativeint] = STATE(5389),
    [sym_int64] = STATE(5389),
    [sym_uint64] = STATE(5389),
    [sym_ieee32] = STATE(5389),
    [sym_ieee64] = STATE(5389),
    [sym_bignum] = STATE(5389),
    [sym_decimal] = STATE(5389),
    [sym_float] = STATE(4893),
    [sym_block_comment] = STATE(2578),
    [sym_compiler_directive_decl] = STATE(2578),
    [sym_fsi_directive_decl] = STATE(2578),
    [sym_preproc_line] = STATE(2578),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(4442),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_LPAREN] = ACTIONS(3872),
    [anon_sym_null] = ACTIONS(3874),
    [anon_sym__] = ACTIONS(3876),
    [anon_sym_QMARK] = ACTIONS(3878),
    [anon_sym_COLON_QMARK] = ACTIONS(3880),
    [anon_sym_LBRACK] = ACTIONS(3882),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3884),
    [anon_sym_LBRACE] = ACTIONS(3886),
    [aux_sym_char_token1] = ACTIONS(3888),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3890),
    [anon_sym_DQUOTE] = ACTIONS(3892),
    [anon_sym_AT_DQUOTE] = ACTIONS(3894),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3896),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3898),
    [sym_bool] = ACTIONS(3900),
    [sym_unit] = ACTIONS(3902),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3904),
    [sym_op_identifier] = ACTIONS(3906),
    [sym_int] = ACTIONS(3908),
    [sym_xint] = ACTIONS(3910),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2579] = {
    [sym_attributes] = STATE(2641),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(5241),
    [sym__pattern] = STATE(5312),
    [sym_optional_pattern] = STATE(5241),
    [sym_type_check_pattern] = STATE(5241),
    [sym_attribute_pattern] = STATE(5241),
    [sym_paren_pattern] = STATE(5241),
    [sym_as_pattern] = STATE(5241),
    [sym_cons_pattern] = STATE(5241),
    [sym_disjunct_pattern] = STATE(5241),
    [sym_conjunct_pattern] = STATE(5241),
    [sym_typed_pattern] = STATE(5241),
    [sym_list_pattern] = STATE(5241),
    [sym_array_pattern] = STATE(5241),
    [sym_record_pattern] = STATE(5241),
    [sym_named_field] = STATE(5890),
    [sym_named_field_pattern] = STATE(5241),
    [sym_identifier_pattern] = STATE(5241),
    [sym_long_identifier_or_op] = STATE(1721),
    [sym_char] = STATE(5389),
    [sym_format_string] = STATE(5273),
    [sym__string_literal] = STATE(5273),
    [sym_string] = STATE(5389),
    [sym_verbatim_string] = STATE(5389),
    [sym_bytearray] = STATE(5389),
    [sym_verbatim_bytearray] = STATE(5389),
    [sym_format_triple_quoted_string] = STATE(5377),
    [sym_triple_quoted_string] = STATE(5389),
    [sym_const] = STATE(5241),
    [sym_long_identifier] = STATE(3363),
    [sym_active_pattern] = STATE(3521),
    [sym__identifier_or_op] = STATE(3510),
    [sym_sbyte] = STATE(5389),
    [sym_byte] = STATE(5389),
    [sym_int16] = STATE(5389),
    [sym_uint16] = STATE(5389),
    [sym_int32] = STATE(5389),
    [sym_uint32] = STATE(5389),
    [sym_nativeint] = STATE(5389),
    [sym_unativeint] = STATE(5389),
    [sym_int64] = STATE(5389),
    [sym_uint64] = STATE(5389),
    [sym_ieee32] = STATE(5389),
    [sym_ieee64] = STATE(5389),
    [sym_bignum] = STATE(5389),
    [sym_decimal] = STATE(5389),
    [sym_float] = STATE(4893),
    [sym_block_comment] = STATE(2579),
    [sym_compiler_directive_decl] = STATE(2579),
    [sym_fsi_directive_decl] = STATE(2579),
    [sym_preproc_line] = STATE(2579),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(4442),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_LPAREN] = ACTIONS(3872),
    [anon_sym_null] = ACTIONS(3874),
    [anon_sym__] = ACTIONS(3876),
    [anon_sym_QMARK] = ACTIONS(3878),
    [anon_sym_COLON_QMARK] = ACTIONS(3880),
    [anon_sym_LBRACK] = ACTIONS(3882),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3884),
    [anon_sym_LBRACE] = ACTIONS(3886),
    [aux_sym_char_token1] = ACTIONS(3888),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3890),
    [anon_sym_DQUOTE] = ACTIONS(3892),
    [anon_sym_AT_DQUOTE] = ACTIONS(3894),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3896),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3898),
    [sym_bool] = ACTIONS(3900),
    [sym_unit] = ACTIONS(3902),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3904),
    [sym_op_identifier] = ACTIONS(3906),
    [sym_int] = ACTIONS(3908),
    [sym_xint] = ACTIONS(3910),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2580] = {
    [sym_attributes] = STATE(2699),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(4815),
    [sym__pattern] = STATE(5323),
    [sym_optional_pattern] = STATE(4815),
    [sym_type_check_pattern] = STATE(4815),
    [sym_attribute_pattern] = STATE(4815),
    [sym_paren_pattern] = STATE(4815),
    [sym_as_pattern] = STATE(4815),
    [sym_cons_pattern] = STATE(4815),
    [sym_disjunct_pattern] = STATE(4815),
    [sym_conjunct_pattern] = STATE(4815),
    [sym_typed_pattern] = STATE(4815),
    [sym_list_pattern] = STATE(4815),
    [sym_array_pattern] = STATE(4815),
    [sym_record_pattern] = STATE(4815),
    [sym_named_field_pattern] = STATE(4815),
    [sym_identifier_pattern] = STATE(4815),
    [sym_long_identifier_or_op] = STATE(2193),
    [sym_rule] = STATE(1526),
    [sym_char] = STATE(4765),
    [sym_format_string] = STATE(4746),
    [sym__string_literal] = STATE(4746),
    [sym_string] = STATE(4765),
    [sym_verbatim_string] = STATE(4765),
    [sym_bytearray] = STATE(4765),
    [sym_verbatim_bytearray] = STATE(4765),
    [sym_format_triple_quoted_string] = STATE(4720),
    [sym_triple_quoted_string] = STATE(4765),
    [sym_const] = STATE(4815),
    [sym_long_identifier] = STATE(3493),
    [sym_active_pattern] = STATE(3613),
    [sym__identifier_or_op] = STATE(3650),
    [sym_sbyte] = STATE(4765),
    [sym_byte] = STATE(4765),
    [sym_int16] = STATE(4765),
    [sym_uint16] = STATE(4765),
    [sym_int32] = STATE(4765),
    [sym_uint32] = STATE(4765),
    [sym_nativeint] = STATE(4765),
    [sym_unativeint] = STATE(4765),
    [sym_int64] = STATE(4765),
    [sym_uint64] = STATE(4765),
    [sym_ieee32] = STATE(4765),
    [sym_ieee64] = STATE(4765),
    [sym_bignum] = STATE(4765),
    [sym_decimal] = STATE(4765),
    [sym_float] = STATE(4512),
    [sym_block_comment] = STATE(2580),
    [sym_compiler_directive_decl] = STATE(2580),
    [sym_fsi_directive_decl] = STATE(2580),
    [sym_preproc_line] = STATE(2580),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(4175),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_LPAREN] = ACTIONS(3572),
    [anon_sym_null] = ACTIONS(3574),
    [anon_sym__] = ACTIONS(3576),
    [anon_sym_QMARK] = ACTIONS(4177),
    [anon_sym_COLON_QMARK] = ACTIONS(4179),
    [anon_sym_LBRACK] = ACTIONS(3582),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3584),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [aux_sym_char_token1] = ACTIONS(3590),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3592),
    [anon_sym_DQUOTE] = ACTIONS(3594),
    [anon_sym_AT_DQUOTE] = ACTIONS(3596),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3598),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3600),
    [sym_bool] = ACTIONS(3602),
    [sym_unit] = ACTIONS(3604),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4181),
    [sym_op_identifier] = ACTIONS(4183),
    [sym_int] = ACTIONS(3610),
    [sym_xint] = ACTIONS(3612),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2581] = {
    [sym_attributes] = STATE(2641),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(5241),
    [sym__pattern] = STATE(5191),
    [sym_optional_pattern] = STATE(5241),
    [sym_type_check_pattern] = STATE(5241),
    [sym_attribute_pattern] = STATE(5241),
    [sym_paren_pattern] = STATE(5241),
    [sym_as_pattern] = STATE(5241),
    [sym_cons_pattern] = STATE(5241),
    [sym_disjunct_pattern] = STATE(5241),
    [sym_conjunct_pattern] = STATE(5241),
    [sym_typed_pattern] = STATE(5241),
    [sym_list_pattern] = STATE(5241),
    [sym_array_pattern] = STATE(5241),
    [sym_record_pattern] = STATE(5241),
    [sym_named_field] = STATE(5840),
    [sym_named_field_pattern] = STATE(5241),
    [sym_identifier_pattern] = STATE(5241),
    [sym_long_identifier_or_op] = STATE(1721),
    [sym_char] = STATE(5389),
    [sym_format_string] = STATE(5273),
    [sym__string_literal] = STATE(5273),
    [sym_string] = STATE(5389),
    [sym_verbatim_string] = STATE(5389),
    [sym_bytearray] = STATE(5389),
    [sym_verbatim_bytearray] = STATE(5389),
    [sym_format_triple_quoted_string] = STATE(5377),
    [sym_triple_quoted_string] = STATE(5389),
    [sym_const] = STATE(5241),
    [sym_long_identifier] = STATE(3363),
    [sym_active_pattern] = STATE(3521),
    [sym__identifier_or_op] = STATE(3510),
    [sym_sbyte] = STATE(5389),
    [sym_byte] = STATE(5389),
    [sym_int16] = STATE(5389),
    [sym_uint16] = STATE(5389),
    [sym_int32] = STATE(5389),
    [sym_uint32] = STATE(5389),
    [sym_nativeint] = STATE(5389),
    [sym_unativeint] = STATE(5389),
    [sym_int64] = STATE(5389),
    [sym_uint64] = STATE(5389),
    [sym_ieee32] = STATE(5389),
    [sym_ieee64] = STATE(5389),
    [sym_bignum] = STATE(5389),
    [sym_decimal] = STATE(5389),
    [sym_float] = STATE(4893),
    [sym_block_comment] = STATE(2581),
    [sym_compiler_directive_decl] = STATE(2581),
    [sym_fsi_directive_decl] = STATE(2581),
    [sym_preproc_line] = STATE(2581),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(4442),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_LPAREN] = ACTIONS(3872),
    [anon_sym_null] = ACTIONS(3874),
    [anon_sym__] = ACTIONS(3876),
    [anon_sym_QMARK] = ACTIONS(3878),
    [anon_sym_COLON_QMARK] = ACTIONS(3880),
    [anon_sym_LBRACK] = ACTIONS(3882),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3884),
    [anon_sym_LBRACE] = ACTIONS(3886),
    [aux_sym_char_token1] = ACTIONS(3888),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3890),
    [anon_sym_DQUOTE] = ACTIONS(3892),
    [anon_sym_AT_DQUOTE] = ACTIONS(3894),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3896),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3898),
    [sym_bool] = ACTIONS(3900),
    [sym_unit] = ACTIONS(3902),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3904),
    [sym_op_identifier] = ACTIONS(3906),
    [sym_int] = ACTIONS(3908),
    [sym_xint] = ACTIONS(3910),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2582] = {
    [sym_attributes] = STATE(2699),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(4815),
    [sym__pattern] = STATE(5404),
    [sym_optional_pattern] = STATE(4815),
    [sym_type_check_pattern] = STATE(4815),
    [sym_attribute_pattern] = STATE(4815),
    [sym_paren_pattern] = STATE(4815),
    [sym_as_pattern] = STATE(4815),
    [sym_cons_pattern] = STATE(4815),
    [sym_disjunct_pattern] = STATE(4815),
    [sym_conjunct_pattern] = STATE(4815),
    [sym_typed_pattern] = STATE(4815),
    [sym_list_pattern] = STATE(4815),
    [sym_array_pattern] = STATE(4815),
    [sym_record_pattern] = STATE(4815),
    [sym_named_field_pattern] = STATE(4815),
    [sym_identifier_pattern] = STATE(4815),
    [sym_long_identifier_or_op] = STATE(2193),
    [sym_rule] = STATE(1568),
    [sym_char] = STATE(4765),
    [sym_format_string] = STATE(4746),
    [sym__string_literal] = STATE(4746),
    [sym_string] = STATE(4765),
    [sym_verbatim_string] = STATE(4765),
    [sym_bytearray] = STATE(4765),
    [sym_verbatim_bytearray] = STATE(4765),
    [sym_format_triple_quoted_string] = STATE(4720),
    [sym_triple_quoted_string] = STATE(4765),
    [sym_const] = STATE(4815),
    [sym_long_identifier] = STATE(3493),
    [sym_active_pattern] = STATE(3613),
    [sym__identifier_or_op] = STATE(3650),
    [sym_sbyte] = STATE(4765),
    [sym_byte] = STATE(4765),
    [sym_int16] = STATE(4765),
    [sym_uint16] = STATE(4765),
    [sym_int32] = STATE(4765),
    [sym_uint32] = STATE(4765),
    [sym_nativeint] = STATE(4765),
    [sym_unativeint] = STATE(4765),
    [sym_int64] = STATE(4765),
    [sym_uint64] = STATE(4765),
    [sym_ieee32] = STATE(4765),
    [sym_ieee64] = STATE(4765),
    [sym_bignum] = STATE(4765),
    [sym_decimal] = STATE(4765),
    [sym_float] = STATE(4512),
    [sym_block_comment] = STATE(2582),
    [sym_compiler_directive_decl] = STATE(2582),
    [sym_fsi_directive_decl] = STATE(2582),
    [sym_preproc_line] = STATE(2582),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(4175),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_LPAREN] = ACTIONS(3572),
    [anon_sym_null] = ACTIONS(3574),
    [anon_sym__] = ACTIONS(3576),
    [anon_sym_QMARK] = ACTIONS(4177),
    [anon_sym_COLON_QMARK] = ACTIONS(4179),
    [anon_sym_LBRACK] = ACTIONS(3582),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3584),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [aux_sym_char_token1] = ACTIONS(3590),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3592),
    [anon_sym_DQUOTE] = ACTIONS(3594),
    [anon_sym_AT_DQUOTE] = ACTIONS(3596),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3598),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3600),
    [sym_bool] = ACTIONS(3602),
    [sym_unit] = ACTIONS(3604),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4181),
    [sym_op_identifier] = ACTIONS(4183),
    [sym_int] = ACTIONS(3610),
    [sym_xint] = ACTIONS(3612),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2583] = {
    [sym_attributes] = STATE(2699),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(4815),
    [sym__pattern] = STATE(5274),
    [sym_optional_pattern] = STATE(4815),
    [sym_type_check_pattern] = STATE(4815),
    [sym_attribute_pattern] = STATE(4815),
    [sym_paren_pattern] = STATE(4815),
    [sym_as_pattern] = STATE(4815),
    [sym_cons_pattern] = STATE(4815),
    [sym_disjunct_pattern] = STATE(4815),
    [sym_conjunct_pattern] = STATE(4815),
    [sym_typed_pattern] = STATE(4815),
    [sym_list_pattern] = STATE(4815),
    [sym_array_pattern] = STATE(4815),
    [sym_record_pattern] = STATE(4815),
    [sym_named_field_pattern] = STATE(4815),
    [sym_identifier_pattern] = STATE(4815),
    [sym_long_identifier_or_op] = STATE(2193),
    [sym_rule] = STATE(975),
    [sym_char] = STATE(4765),
    [sym_format_string] = STATE(4746),
    [sym__string_literal] = STATE(4746),
    [sym_string] = STATE(4765),
    [sym_verbatim_string] = STATE(4765),
    [sym_bytearray] = STATE(4765),
    [sym_verbatim_bytearray] = STATE(4765),
    [sym_format_triple_quoted_string] = STATE(4720),
    [sym_triple_quoted_string] = STATE(4765),
    [sym_const] = STATE(4815),
    [sym_long_identifier] = STATE(3493),
    [sym_active_pattern] = STATE(3613),
    [sym__identifier_or_op] = STATE(3650),
    [sym_sbyte] = STATE(4765),
    [sym_byte] = STATE(4765),
    [sym_int16] = STATE(4765),
    [sym_uint16] = STATE(4765),
    [sym_int32] = STATE(4765),
    [sym_uint32] = STATE(4765),
    [sym_nativeint] = STATE(4765),
    [sym_unativeint] = STATE(4765),
    [sym_int64] = STATE(4765),
    [sym_uint64] = STATE(4765),
    [sym_ieee32] = STATE(4765),
    [sym_ieee64] = STATE(4765),
    [sym_bignum] = STATE(4765),
    [sym_decimal] = STATE(4765),
    [sym_float] = STATE(4512),
    [sym_block_comment] = STATE(2583),
    [sym_compiler_directive_decl] = STATE(2583),
    [sym_fsi_directive_decl] = STATE(2583),
    [sym_preproc_line] = STATE(2583),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(4175),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_LPAREN] = ACTIONS(3572),
    [anon_sym_null] = ACTIONS(3574),
    [anon_sym__] = ACTIONS(3576),
    [anon_sym_QMARK] = ACTIONS(4177),
    [anon_sym_COLON_QMARK] = ACTIONS(4179),
    [anon_sym_LBRACK] = ACTIONS(3582),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3584),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [aux_sym_char_token1] = ACTIONS(3590),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3592),
    [anon_sym_DQUOTE] = ACTIONS(3594),
    [anon_sym_AT_DQUOTE] = ACTIONS(3596),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3598),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3600),
    [sym_bool] = ACTIONS(3602),
    [sym_unit] = ACTIONS(3604),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4181),
    [sym_op_identifier] = ACTIONS(4183),
    [sym_int] = ACTIONS(3610),
    [sym_xint] = ACTIONS(3612),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2584] = {
    [sym_attributes] = STATE(2641),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(5241),
    [sym__pattern] = STATE(5287),
    [sym_optional_pattern] = STATE(5241),
    [sym_type_check_pattern] = STATE(5241),
    [sym_attribute_pattern] = STATE(5241),
    [sym_paren_pattern] = STATE(5241),
    [sym_as_pattern] = STATE(5241),
    [sym_cons_pattern] = STATE(5241),
    [sym_disjunct_pattern] = STATE(5241),
    [sym_conjunct_pattern] = STATE(5241),
    [sym_typed_pattern] = STATE(5241),
    [sym_list_pattern] = STATE(5241),
    [sym_array_pattern] = STATE(5241),
    [sym_record_pattern] = STATE(5241),
    [sym_named_field] = STATE(5751),
    [sym_named_field_pattern] = STATE(5241),
    [sym_identifier_pattern] = STATE(5241),
    [sym_long_identifier_or_op] = STATE(1721),
    [sym_char] = STATE(5389),
    [sym_format_string] = STATE(5273),
    [sym__string_literal] = STATE(5273),
    [sym_string] = STATE(5389),
    [sym_verbatim_string] = STATE(5389),
    [sym_bytearray] = STATE(5389),
    [sym_verbatim_bytearray] = STATE(5389),
    [sym_format_triple_quoted_string] = STATE(5377),
    [sym_triple_quoted_string] = STATE(5389),
    [sym_const] = STATE(5241),
    [sym_long_identifier] = STATE(3363),
    [sym_active_pattern] = STATE(3521),
    [sym__identifier_or_op] = STATE(3510),
    [sym_sbyte] = STATE(5389),
    [sym_byte] = STATE(5389),
    [sym_int16] = STATE(5389),
    [sym_uint16] = STATE(5389),
    [sym_int32] = STATE(5389),
    [sym_uint32] = STATE(5389),
    [sym_nativeint] = STATE(5389),
    [sym_unativeint] = STATE(5389),
    [sym_int64] = STATE(5389),
    [sym_uint64] = STATE(5389),
    [sym_ieee32] = STATE(5389),
    [sym_ieee64] = STATE(5389),
    [sym_bignum] = STATE(5389),
    [sym_decimal] = STATE(5389),
    [sym_float] = STATE(4893),
    [sym_block_comment] = STATE(2584),
    [sym_compiler_directive_decl] = STATE(2584),
    [sym_fsi_directive_decl] = STATE(2584),
    [sym_preproc_line] = STATE(2584),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(4442),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_LPAREN] = ACTIONS(3872),
    [anon_sym_null] = ACTIONS(3874),
    [anon_sym__] = ACTIONS(3876),
    [anon_sym_QMARK] = ACTIONS(3878),
    [anon_sym_COLON_QMARK] = ACTIONS(3880),
    [anon_sym_LBRACK] = ACTIONS(3882),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3884),
    [anon_sym_LBRACE] = ACTIONS(3886),
    [aux_sym_char_token1] = ACTIONS(3888),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3890),
    [anon_sym_DQUOTE] = ACTIONS(3892),
    [anon_sym_AT_DQUOTE] = ACTIONS(3894),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3896),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3898),
    [sym_bool] = ACTIONS(3900),
    [sym_unit] = ACTIONS(3902),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3904),
    [sym_op_identifier] = ACTIONS(3906),
    [sym_int] = ACTIONS(3908),
    [sym_xint] = ACTIONS(3910),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2585] = {
    [sym_attributes] = STATE(2699),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(4815),
    [sym__pattern] = STATE(5404),
    [sym_optional_pattern] = STATE(4815),
    [sym_type_check_pattern] = STATE(4815),
    [sym_attribute_pattern] = STATE(4815),
    [sym_paren_pattern] = STATE(4815),
    [sym_as_pattern] = STATE(4815),
    [sym_cons_pattern] = STATE(4815),
    [sym_disjunct_pattern] = STATE(4815),
    [sym_conjunct_pattern] = STATE(4815),
    [sym_typed_pattern] = STATE(4815),
    [sym_list_pattern] = STATE(4815),
    [sym_array_pattern] = STATE(4815),
    [sym_record_pattern] = STATE(4815),
    [sym_named_field_pattern] = STATE(4815),
    [sym_identifier_pattern] = STATE(4815),
    [sym_long_identifier_or_op] = STATE(2193),
    [sym_rule] = STATE(1822),
    [sym_char] = STATE(4765),
    [sym_format_string] = STATE(4746),
    [sym__string_literal] = STATE(4746),
    [sym_string] = STATE(4765),
    [sym_verbatim_string] = STATE(4765),
    [sym_bytearray] = STATE(4765),
    [sym_verbatim_bytearray] = STATE(4765),
    [sym_format_triple_quoted_string] = STATE(4720),
    [sym_triple_quoted_string] = STATE(4765),
    [sym_const] = STATE(4815),
    [sym_long_identifier] = STATE(3493),
    [sym_active_pattern] = STATE(3613),
    [sym__identifier_or_op] = STATE(3650),
    [sym_sbyte] = STATE(4765),
    [sym_byte] = STATE(4765),
    [sym_int16] = STATE(4765),
    [sym_uint16] = STATE(4765),
    [sym_int32] = STATE(4765),
    [sym_uint32] = STATE(4765),
    [sym_nativeint] = STATE(4765),
    [sym_unativeint] = STATE(4765),
    [sym_int64] = STATE(4765),
    [sym_uint64] = STATE(4765),
    [sym_ieee32] = STATE(4765),
    [sym_ieee64] = STATE(4765),
    [sym_bignum] = STATE(4765),
    [sym_decimal] = STATE(4765),
    [sym_float] = STATE(4512),
    [sym_block_comment] = STATE(2585),
    [sym_compiler_directive_decl] = STATE(2585),
    [sym_fsi_directive_decl] = STATE(2585),
    [sym_preproc_line] = STATE(2585),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(4175),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_LPAREN] = ACTIONS(3572),
    [anon_sym_null] = ACTIONS(3574),
    [anon_sym__] = ACTIONS(3576),
    [anon_sym_QMARK] = ACTIONS(4177),
    [anon_sym_COLON_QMARK] = ACTIONS(4179),
    [anon_sym_LBRACK] = ACTIONS(3582),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3584),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [aux_sym_char_token1] = ACTIONS(3590),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3592),
    [anon_sym_DQUOTE] = ACTIONS(3594),
    [anon_sym_AT_DQUOTE] = ACTIONS(3596),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3598),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3600),
    [sym_bool] = ACTIONS(3602),
    [sym_unit] = ACTIONS(3604),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4181),
    [sym_op_identifier] = ACTIONS(4183),
    [sym_int] = ACTIONS(3610),
    [sym_xint] = ACTIONS(3612),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2586] = {
    [sym_attributes] = STATE(2699),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(4815),
    [sym__pattern] = STATE(5177),
    [sym_optional_pattern] = STATE(4815),
    [sym_type_check_pattern] = STATE(4815),
    [sym_attribute_pattern] = STATE(4815),
    [sym_paren_pattern] = STATE(4815),
    [sym_as_pattern] = STATE(4815),
    [sym_cons_pattern] = STATE(4815),
    [sym_disjunct_pattern] = STATE(4815),
    [sym_conjunct_pattern] = STATE(4815),
    [sym_typed_pattern] = STATE(4815),
    [sym_list_pattern] = STATE(4815),
    [sym_array_pattern] = STATE(4815),
    [sym_record_pattern] = STATE(4815),
    [sym_named_field_pattern] = STATE(4815),
    [sym_identifier_pattern] = STATE(4815),
    [sym_long_identifier_or_op] = STATE(2193),
    [sym_rule] = STATE(1531),
    [sym_char] = STATE(4765),
    [sym_format_string] = STATE(4746),
    [sym__string_literal] = STATE(4746),
    [sym_string] = STATE(4765),
    [sym_verbatim_string] = STATE(4765),
    [sym_bytearray] = STATE(4765),
    [sym_verbatim_bytearray] = STATE(4765),
    [sym_format_triple_quoted_string] = STATE(4720),
    [sym_triple_quoted_string] = STATE(4765),
    [sym_const] = STATE(4815),
    [sym_long_identifier] = STATE(3493),
    [sym_active_pattern] = STATE(3613),
    [sym__identifier_or_op] = STATE(3650),
    [sym_sbyte] = STATE(4765),
    [sym_byte] = STATE(4765),
    [sym_int16] = STATE(4765),
    [sym_uint16] = STATE(4765),
    [sym_int32] = STATE(4765),
    [sym_uint32] = STATE(4765),
    [sym_nativeint] = STATE(4765),
    [sym_unativeint] = STATE(4765),
    [sym_int64] = STATE(4765),
    [sym_uint64] = STATE(4765),
    [sym_ieee32] = STATE(4765),
    [sym_ieee64] = STATE(4765),
    [sym_bignum] = STATE(4765),
    [sym_decimal] = STATE(4765),
    [sym_float] = STATE(4512),
    [sym_block_comment] = STATE(2586),
    [sym_compiler_directive_decl] = STATE(2586),
    [sym_fsi_directive_decl] = STATE(2586),
    [sym_preproc_line] = STATE(2586),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(4175),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_LPAREN] = ACTIONS(3572),
    [anon_sym_null] = ACTIONS(3574),
    [anon_sym__] = ACTIONS(3576),
    [anon_sym_QMARK] = ACTIONS(4177),
    [anon_sym_COLON_QMARK] = ACTIONS(4179),
    [anon_sym_LBRACK] = ACTIONS(3582),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3584),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [aux_sym_char_token1] = ACTIONS(3590),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3592),
    [anon_sym_DQUOTE] = ACTIONS(3594),
    [anon_sym_AT_DQUOTE] = ACTIONS(3596),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3598),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3600),
    [sym_bool] = ACTIONS(3602),
    [sym_unit] = ACTIONS(3604),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4181),
    [sym_op_identifier] = ACTIONS(4183),
    [sym_int] = ACTIONS(3610),
    [sym_xint] = ACTIONS(3612),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2587] = {
    [sym_attributes] = STATE(2699),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(4815),
    [sym__pattern] = STATE(5404),
    [sym_optional_pattern] = STATE(4815),
    [sym_type_check_pattern] = STATE(4815),
    [sym_attribute_pattern] = STATE(4815),
    [sym_paren_pattern] = STATE(4815),
    [sym_as_pattern] = STATE(4815),
    [sym_cons_pattern] = STATE(4815),
    [sym_disjunct_pattern] = STATE(4815),
    [sym_conjunct_pattern] = STATE(4815),
    [sym_typed_pattern] = STATE(4815),
    [sym_list_pattern] = STATE(4815),
    [sym_array_pattern] = STATE(4815),
    [sym_record_pattern] = STATE(4815),
    [sym_named_field_pattern] = STATE(4815),
    [sym_identifier_pattern] = STATE(4815),
    [sym_long_identifier_or_op] = STATE(2193),
    [sym_rule] = STATE(1819),
    [sym_char] = STATE(4765),
    [sym_format_string] = STATE(4746),
    [sym__string_literal] = STATE(4746),
    [sym_string] = STATE(4765),
    [sym_verbatim_string] = STATE(4765),
    [sym_bytearray] = STATE(4765),
    [sym_verbatim_bytearray] = STATE(4765),
    [sym_format_triple_quoted_string] = STATE(4720),
    [sym_triple_quoted_string] = STATE(4765),
    [sym_const] = STATE(4815),
    [sym_long_identifier] = STATE(3493),
    [sym_active_pattern] = STATE(3613),
    [sym__identifier_or_op] = STATE(3650),
    [sym_sbyte] = STATE(4765),
    [sym_byte] = STATE(4765),
    [sym_int16] = STATE(4765),
    [sym_uint16] = STATE(4765),
    [sym_int32] = STATE(4765),
    [sym_uint32] = STATE(4765),
    [sym_nativeint] = STATE(4765),
    [sym_unativeint] = STATE(4765),
    [sym_int64] = STATE(4765),
    [sym_uint64] = STATE(4765),
    [sym_ieee32] = STATE(4765),
    [sym_ieee64] = STATE(4765),
    [sym_bignum] = STATE(4765),
    [sym_decimal] = STATE(4765),
    [sym_float] = STATE(4512),
    [sym_block_comment] = STATE(2587),
    [sym_compiler_directive_decl] = STATE(2587),
    [sym_fsi_directive_decl] = STATE(2587),
    [sym_preproc_line] = STATE(2587),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(4175),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_LPAREN] = ACTIONS(3572),
    [anon_sym_null] = ACTIONS(3574),
    [anon_sym__] = ACTIONS(3576),
    [anon_sym_QMARK] = ACTIONS(4177),
    [anon_sym_COLON_QMARK] = ACTIONS(4179),
    [anon_sym_LBRACK] = ACTIONS(3582),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3584),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [aux_sym_char_token1] = ACTIONS(3590),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3592),
    [anon_sym_DQUOTE] = ACTIONS(3594),
    [anon_sym_AT_DQUOTE] = ACTIONS(3596),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3598),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3600),
    [sym_bool] = ACTIONS(3602),
    [sym_unit] = ACTIONS(3604),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4181),
    [sym_op_identifier] = ACTIONS(4183),
    [sym_int] = ACTIONS(3610),
    [sym_xint] = ACTIONS(3612),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2588] = {
    [sym_attributes] = STATE(2699),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(4815),
    [sym__pattern] = STATE(5212),
    [sym_optional_pattern] = STATE(4815),
    [sym_type_check_pattern] = STATE(4815),
    [sym_attribute_pattern] = STATE(4815),
    [sym_paren_pattern] = STATE(4815),
    [sym_as_pattern] = STATE(4815),
    [sym_cons_pattern] = STATE(4815),
    [sym_disjunct_pattern] = STATE(4815),
    [sym_conjunct_pattern] = STATE(4815),
    [sym_typed_pattern] = STATE(4815),
    [sym_list_pattern] = STATE(4815),
    [sym_array_pattern] = STATE(4815),
    [sym_record_pattern] = STATE(4815),
    [sym_named_field_pattern] = STATE(4815),
    [sym_identifier_pattern] = STATE(4815),
    [sym_long_identifier_or_op] = STATE(2193),
    [sym_rule] = STATE(1516),
    [sym_char] = STATE(4765),
    [sym_format_string] = STATE(4746),
    [sym__string_literal] = STATE(4746),
    [sym_string] = STATE(4765),
    [sym_verbatim_string] = STATE(4765),
    [sym_bytearray] = STATE(4765),
    [sym_verbatim_bytearray] = STATE(4765),
    [sym_format_triple_quoted_string] = STATE(4720),
    [sym_triple_quoted_string] = STATE(4765),
    [sym_const] = STATE(4815),
    [sym_long_identifier] = STATE(3493),
    [sym_active_pattern] = STATE(3613),
    [sym__identifier_or_op] = STATE(3650),
    [sym_sbyte] = STATE(4765),
    [sym_byte] = STATE(4765),
    [sym_int16] = STATE(4765),
    [sym_uint16] = STATE(4765),
    [sym_int32] = STATE(4765),
    [sym_uint32] = STATE(4765),
    [sym_nativeint] = STATE(4765),
    [sym_unativeint] = STATE(4765),
    [sym_int64] = STATE(4765),
    [sym_uint64] = STATE(4765),
    [sym_ieee32] = STATE(4765),
    [sym_ieee64] = STATE(4765),
    [sym_bignum] = STATE(4765),
    [sym_decimal] = STATE(4765),
    [sym_float] = STATE(4512),
    [sym_block_comment] = STATE(2588),
    [sym_compiler_directive_decl] = STATE(2588),
    [sym_fsi_directive_decl] = STATE(2588),
    [sym_preproc_line] = STATE(2588),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(4175),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_LPAREN] = ACTIONS(3572),
    [anon_sym_null] = ACTIONS(3574),
    [anon_sym__] = ACTIONS(3576),
    [anon_sym_QMARK] = ACTIONS(4177),
    [anon_sym_COLON_QMARK] = ACTIONS(4179),
    [anon_sym_LBRACK] = ACTIONS(3582),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3584),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [aux_sym_char_token1] = ACTIONS(3590),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3592),
    [anon_sym_DQUOTE] = ACTIONS(3594),
    [anon_sym_AT_DQUOTE] = ACTIONS(3596),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3598),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3600),
    [sym_bool] = ACTIONS(3602),
    [sym_unit] = ACTIONS(3604),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4181),
    [sym_op_identifier] = ACTIONS(4183),
    [sym_int] = ACTIONS(3610),
    [sym_xint] = ACTIONS(3612),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2589] = {
    [sym_attributes] = STATE(2699),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(4815),
    [sym__pattern] = STATE(5302),
    [sym_optional_pattern] = STATE(4815),
    [sym_type_check_pattern] = STATE(4815),
    [sym_attribute_pattern] = STATE(4815),
    [sym_paren_pattern] = STATE(4815),
    [sym_as_pattern] = STATE(4815),
    [sym_cons_pattern] = STATE(4815),
    [sym_disjunct_pattern] = STATE(4815),
    [sym_conjunct_pattern] = STATE(4815),
    [sym_typed_pattern] = STATE(4815),
    [sym_list_pattern] = STATE(4815),
    [sym_array_pattern] = STATE(4815),
    [sym_record_pattern] = STATE(4815),
    [sym_named_field_pattern] = STATE(4815),
    [sym_identifier_pattern] = STATE(4815),
    [sym_long_identifier_or_op] = STATE(2193),
    [sym_rule] = STATE(1373),
    [sym_char] = STATE(4765),
    [sym_format_string] = STATE(4746),
    [sym__string_literal] = STATE(4746),
    [sym_string] = STATE(4765),
    [sym_verbatim_string] = STATE(4765),
    [sym_bytearray] = STATE(4765),
    [sym_verbatim_bytearray] = STATE(4765),
    [sym_format_triple_quoted_string] = STATE(4720),
    [sym_triple_quoted_string] = STATE(4765),
    [sym_const] = STATE(4815),
    [sym_long_identifier] = STATE(3493),
    [sym_active_pattern] = STATE(3613),
    [sym__identifier_or_op] = STATE(3650),
    [sym_sbyte] = STATE(4765),
    [sym_byte] = STATE(4765),
    [sym_int16] = STATE(4765),
    [sym_uint16] = STATE(4765),
    [sym_int32] = STATE(4765),
    [sym_uint32] = STATE(4765),
    [sym_nativeint] = STATE(4765),
    [sym_unativeint] = STATE(4765),
    [sym_int64] = STATE(4765),
    [sym_uint64] = STATE(4765),
    [sym_ieee32] = STATE(4765),
    [sym_ieee64] = STATE(4765),
    [sym_bignum] = STATE(4765),
    [sym_decimal] = STATE(4765),
    [sym_float] = STATE(4512),
    [sym_block_comment] = STATE(2589),
    [sym_compiler_directive_decl] = STATE(2589),
    [sym_fsi_directive_decl] = STATE(2589),
    [sym_preproc_line] = STATE(2589),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(4175),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_LPAREN] = ACTIONS(3572),
    [anon_sym_null] = ACTIONS(3574),
    [anon_sym__] = ACTIONS(3576),
    [anon_sym_QMARK] = ACTIONS(4177),
    [anon_sym_COLON_QMARK] = ACTIONS(4179),
    [anon_sym_LBRACK] = ACTIONS(3582),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3584),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [aux_sym_char_token1] = ACTIONS(3590),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3592),
    [anon_sym_DQUOTE] = ACTIONS(3594),
    [anon_sym_AT_DQUOTE] = ACTIONS(3596),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3598),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3600),
    [sym_bool] = ACTIONS(3602),
    [sym_unit] = ACTIONS(3604),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4181),
    [sym_op_identifier] = ACTIONS(4183),
    [sym_int] = ACTIONS(3610),
    [sym_xint] = ACTIONS(3612),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2590] = {
    [sym_attributes] = STATE(2699),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(4815),
    [sym__pattern] = STATE(5177),
    [sym_optional_pattern] = STATE(4815),
    [sym_type_check_pattern] = STATE(4815),
    [sym_attribute_pattern] = STATE(4815),
    [sym_paren_pattern] = STATE(4815),
    [sym_as_pattern] = STATE(4815),
    [sym_cons_pattern] = STATE(4815),
    [sym_disjunct_pattern] = STATE(4815),
    [sym_conjunct_pattern] = STATE(4815),
    [sym_typed_pattern] = STATE(4815),
    [sym_list_pattern] = STATE(4815),
    [sym_array_pattern] = STATE(4815),
    [sym_record_pattern] = STATE(4815),
    [sym_named_field_pattern] = STATE(4815),
    [sym_identifier_pattern] = STATE(4815),
    [sym_long_identifier_or_op] = STATE(2193),
    [sym_rule] = STATE(1939),
    [sym_char] = STATE(4765),
    [sym_format_string] = STATE(4746),
    [sym__string_literal] = STATE(4746),
    [sym_string] = STATE(4765),
    [sym_verbatim_string] = STATE(4765),
    [sym_bytearray] = STATE(4765),
    [sym_verbatim_bytearray] = STATE(4765),
    [sym_format_triple_quoted_string] = STATE(4720),
    [sym_triple_quoted_string] = STATE(4765),
    [sym_const] = STATE(4815),
    [sym_long_identifier] = STATE(3493),
    [sym_active_pattern] = STATE(3613),
    [sym__identifier_or_op] = STATE(3650),
    [sym_sbyte] = STATE(4765),
    [sym_byte] = STATE(4765),
    [sym_int16] = STATE(4765),
    [sym_uint16] = STATE(4765),
    [sym_int32] = STATE(4765),
    [sym_uint32] = STATE(4765),
    [sym_nativeint] = STATE(4765),
    [sym_unativeint] = STATE(4765),
    [sym_int64] = STATE(4765),
    [sym_uint64] = STATE(4765),
    [sym_ieee32] = STATE(4765),
    [sym_ieee64] = STATE(4765),
    [sym_bignum] = STATE(4765),
    [sym_decimal] = STATE(4765),
    [sym_float] = STATE(4512),
    [sym_block_comment] = STATE(2590),
    [sym_compiler_directive_decl] = STATE(2590),
    [sym_fsi_directive_decl] = STATE(2590),
    [sym_preproc_line] = STATE(2590),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(4175),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_LPAREN] = ACTIONS(3572),
    [anon_sym_null] = ACTIONS(3574),
    [anon_sym__] = ACTIONS(3576),
    [anon_sym_QMARK] = ACTIONS(4177),
    [anon_sym_COLON_QMARK] = ACTIONS(4179),
    [anon_sym_LBRACK] = ACTIONS(3582),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3584),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [aux_sym_char_token1] = ACTIONS(3590),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3592),
    [anon_sym_DQUOTE] = ACTIONS(3594),
    [anon_sym_AT_DQUOTE] = ACTIONS(3596),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3598),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3600),
    [sym_bool] = ACTIONS(3602),
    [sym_unit] = ACTIONS(3604),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4181),
    [sym_op_identifier] = ACTIONS(4183),
    [sym_int] = ACTIONS(3610),
    [sym_xint] = ACTIONS(3612),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2591] = {
    [sym_attributes] = STATE(2699),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(4815),
    [sym__pattern] = STATE(5196),
    [sym_optional_pattern] = STATE(4815),
    [sym_type_check_pattern] = STATE(4815),
    [sym_attribute_pattern] = STATE(4815),
    [sym_paren_pattern] = STATE(4815),
    [sym_as_pattern] = STATE(4815),
    [sym_cons_pattern] = STATE(4815),
    [sym_disjunct_pattern] = STATE(4815),
    [sym_conjunct_pattern] = STATE(4815),
    [sym_typed_pattern] = STATE(4815),
    [sym_list_pattern] = STATE(4815),
    [sym_array_pattern] = STATE(4815),
    [sym_record_pattern] = STATE(4815),
    [sym_named_field_pattern] = STATE(4815),
    [sym_identifier_pattern] = STATE(4815),
    [sym_long_identifier_or_op] = STATE(2193),
    [sym_rule] = STATE(857),
    [sym_char] = STATE(4765),
    [sym_format_string] = STATE(4746),
    [sym__string_literal] = STATE(4746),
    [sym_string] = STATE(4765),
    [sym_verbatim_string] = STATE(4765),
    [sym_bytearray] = STATE(4765),
    [sym_verbatim_bytearray] = STATE(4765),
    [sym_format_triple_quoted_string] = STATE(4720),
    [sym_triple_quoted_string] = STATE(4765),
    [sym_const] = STATE(4815),
    [sym_long_identifier] = STATE(3493),
    [sym_active_pattern] = STATE(3613),
    [sym__identifier_or_op] = STATE(3650),
    [sym_sbyte] = STATE(4765),
    [sym_byte] = STATE(4765),
    [sym_int16] = STATE(4765),
    [sym_uint16] = STATE(4765),
    [sym_int32] = STATE(4765),
    [sym_uint32] = STATE(4765),
    [sym_nativeint] = STATE(4765),
    [sym_unativeint] = STATE(4765),
    [sym_int64] = STATE(4765),
    [sym_uint64] = STATE(4765),
    [sym_ieee32] = STATE(4765),
    [sym_ieee64] = STATE(4765),
    [sym_bignum] = STATE(4765),
    [sym_decimal] = STATE(4765),
    [sym_float] = STATE(4512),
    [sym_block_comment] = STATE(2591),
    [sym_compiler_directive_decl] = STATE(2591),
    [sym_fsi_directive_decl] = STATE(2591),
    [sym_preproc_line] = STATE(2591),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(4175),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_LPAREN] = ACTIONS(3572),
    [anon_sym_null] = ACTIONS(3574),
    [anon_sym__] = ACTIONS(3576),
    [anon_sym_QMARK] = ACTIONS(4177),
    [anon_sym_COLON_QMARK] = ACTIONS(4179),
    [anon_sym_LBRACK] = ACTIONS(3582),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3584),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [aux_sym_char_token1] = ACTIONS(3590),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3592),
    [anon_sym_DQUOTE] = ACTIONS(3594),
    [anon_sym_AT_DQUOTE] = ACTIONS(3596),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3598),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3600),
    [sym_bool] = ACTIONS(3602),
    [sym_unit] = ACTIONS(3604),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4181),
    [sym_op_identifier] = ACTIONS(4183),
    [sym_int] = ACTIONS(3610),
    [sym_xint] = ACTIONS(3612),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2592] = {
    [sym_attributes] = STATE(2699),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(4815),
    [sym__pattern] = STATE(5302),
    [sym_optional_pattern] = STATE(4815),
    [sym_type_check_pattern] = STATE(4815),
    [sym_attribute_pattern] = STATE(4815),
    [sym_paren_pattern] = STATE(4815),
    [sym_as_pattern] = STATE(4815),
    [sym_cons_pattern] = STATE(4815),
    [sym_disjunct_pattern] = STATE(4815),
    [sym_conjunct_pattern] = STATE(4815),
    [sym_typed_pattern] = STATE(4815),
    [sym_list_pattern] = STATE(4815),
    [sym_array_pattern] = STATE(4815),
    [sym_record_pattern] = STATE(4815),
    [sym_named_field_pattern] = STATE(4815),
    [sym_identifier_pattern] = STATE(4815),
    [sym_long_identifier_or_op] = STATE(2193),
    [sym_rule] = STATE(1423),
    [sym_char] = STATE(4765),
    [sym_format_string] = STATE(4746),
    [sym__string_literal] = STATE(4746),
    [sym_string] = STATE(4765),
    [sym_verbatim_string] = STATE(4765),
    [sym_bytearray] = STATE(4765),
    [sym_verbatim_bytearray] = STATE(4765),
    [sym_format_triple_quoted_string] = STATE(4720),
    [sym_triple_quoted_string] = STATE(4765),
    [sym_const] = STATE(4815),
    [sym_long_identifier] = STATE(3493),
    [sym_active_pattern] = STATE(3613),
    [sym__identifier_or_op] = STATE(3650),
    [sym_sbyte] = STATE(4765),
    [sym_byte] = STATE(4765),
    [sym_int16] = STATE(4765),
    [sym_uint16] = STATE(4765),
    [sym_int32] = STATE(4765),
    [sym_uint32] = STATE(4765),
    [sym_nativeint] = STATE(4765),
    [sym_unativeint] = STATE(4765),
    [sym_int64] = STATE(4765),
    [sym_uint64] = STATE(4765),
    [sym_ieee32] = STATE(4765),
    [sym_ieee64] = STATE(4765),
    [sym_bignum] = STATE(4765),
    [sym_decimal] = STATE(4765),
    [sym_float] = STATE(4512),
    [sym_block_comment] = STATE(2592),
    [sym_compiler_directive_decl] = STATE(2592),
    [sym_fsi_directive_decl] = STATE(2592),
    [sym_preproc_line] = STATE(2592),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(4175),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_LPAREN] = ACTIONS(3572),
    [anon_sym_null] = ACTIONS(3574),
    [anon_sym__] = ACTIONS(3576),
    [anon_sym_QMARK] = ACTIONS(4177),
    [anon_sym_COLON_QMARK] = ACTIONS(4179),
    [anon_sym_LBRACK] = ACTIONS(3582),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3584),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [aux_sym_char_token1] = ACTIONS(3590),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3592),
    [anon_sym_DQUOTE] = ACTIONS(3594),
    [anon_sym_AT_DQUOTE] = ACTIONS(3596),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3598),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3600),
    [sym_bool] = ACTIONS(3602),
    [sym_unit] = ACTIONS(3604),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4181),
    [sym_op_identifier] = ACTIONS(4183),
    [sym_int] = ACTIONS(3610),
    [sym_xint] = ACTIONS(3612),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2593] = {
    [sym_attributes] = STATE(2699),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(4815),
    [sym__pattern] = STATE(5212),
    [sym_optional_pattern] = STATE(4815),
    [sym_type_check_pattern] = STATE(4815),
    [sym_attribute_pattern] = STATE(4815),
    [sym_paren_pattern] = STATE(4815),
    [sym_as_pattern] = STATE(4815),
    [sym_cons_pattern] = STATE(4815),
    [sym_disjunct_pattern] = STATE(4815),
    [sym_conjunct_pattern] = STATE(4815),
    [sym_typed_pattern] = STATE(4815),
    [sym_list_pattern] = STATE(4815),
    [sym_array_pattern] = STATE(4815),
    [sym_record_pattern] = STATE(4815),
    [sym_named_field_pattern] = STATE(4815),
    [sym_identifier_pattern] = STATE(4815),
    [sym_long_identifier_or_op] = STATE(2193),
    [sym_rule] = STATE(1906),
    [sym_char] = STATE(4765),
    [sym_format_string] = STATE(4746),
    [sym__string_literal] = STATE(4746),
    [sym_string] = STATE(4765),
    [sym_verbatim_string] = STATE(4765),
    [sym_bytearray] = STATE(4765),
    [sym_verbatim_bytearray] = STATE(4765),
    [sym_format_triple_quoted_string] = STATE(4720),
    [sym_triple_quoted_string] = STATE(4765),
    [sym_const] = STATE(4815),
    [sym_long_identifier] = STATE(3493),
    [sym_active_pattern] = STATE(3613),
    [sym__identifier_or_op] = STATE(3650),
    [sym_sbyte] = STATE(4765),
    [sym_byte] = STATE(4765),
    [sym_int16] = STATE(4765),
    [sym_uint16] = STATE(4765),
    [sym_int32] = STATE(4765),
    [sym_uint32] = STATE(4765),
    [sym_nativeint] = STATE(4765),
    [sym_unativeint] = STATE(4765),
    [sym_int64] = STATE(4765),
    [sym_uint64] = STATE(4765),
    [sym_ieee32] = STATE(4765),
    [sym_ieee64] = STATE(4765),
    [sym_bignum] = STATE(4765),
    [sym_decimal] = STATE(4765),
    [sym_float] = STATE(4512),
    [sym_block_comment] = STATE(2593),
    [sym_compiler_directive_decl] = STATE(2593),
    [sym_fsi_directive_decl] = STATE(2593),
    [sym_preproc_line] = STATE(2593),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(4175),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_LPAREN] = ACTIONS(3572),
    [anon_sym_null] = ACTIONS(3574),
    [anon_sym__] = ACTIONS(3576),
    [anon_sym_QMARK] = ACTIONS(4177),
    [anon_sym_COLON_QMARK] = ACTIONS(4179),
    [anon_sym_LBRACK] = ACTIONS(3582),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3584),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [aux_sym_char_token1] = ACTIONS(3590),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3592),
    [anon_sym_DQUOTE] = ACTIONS(3594),
    [anon_sym_AT_DQUOTE] = ACTIONS(3596),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3598),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3600),
    [sym_bool] = ACTIONS(3602),
    [sym_unit] = ACTIONS(3604),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4181),
    [sym_op_identifier] = ACTIONS(4183),
    [sym_int] = ACTIONS(3610),
    [sym_xint] = ACTIONS(3612),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2594] = {
    [sym_attributes] = STATE(2699),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(4815),
    [sym__pattern] = STATE(5302),
    [sym_optional_pattern] = STATE(4815),
    [sym_type_check_pattern] = STATE(4815),
    [sym_attribute_pattern] = STATE(4815),
    [sym_paren_pattern] = STATE(4815),
    [sym_as_pattern] = STATE(4815),
    [sym_cons_pattern] = STATE(4815),
    [sym_disjunct_pattern] = STATE(4815),
    [sym_conjunct_pattern] = STATE(4815),
    [sym_typed_pattern] = STATE(4815),
    [sym_list_pattern] = STATE(4815),
    [sym_array_pattern] = STATE(4815),
    [sym_record_pattern] = STATE(4815),
    [sym_named_field_pattern] = STATE(4815),
    [sym_identifier_pattern] = STATE(4815),
    [sym_long_identifier_or_op] = STATE(2193),
    [sym_rule] = STATE(1421),
    [sym_char] = STATE(4765),
    [sym_format_string] = STATE(4746),
    [sym__string_literal] = STATE(4746),
    [sym_string] = STATE(4765),
    [sym_verbatim_string] = STATE(4765),
    [sym_bytearray] = STATE(4765),
    [sym_verbatim_bytearray] = STATE(4765),
    [sym_format_triple_quoted_string] = STATE(4720),
    [sym_triple_quoted_string] = STATE(4765),
    [sym_const] = STATE(4815),
    [sym_long_identifier] = STATE(3493),
    [sym_active_pattern] = STATE(3613),
    [sym__identifier_or_op] = STATE(3650),
    [sym_sbyte] = STATE(4765),
    [sym_byte] = STATE(4765),
    [sym_int16] = STATE(4765),
    [sym_uint16] = STATE(4765),
    [sym_int32] = STATE(4765),
    [sym_uint32] = STATE(4765),
    [sym_nativeint] = STATE(4765),
    [sym_unativeint] = STATE(4765),
    [sym_int64] = STATE(4765),
    [sym_uint64] = STATE(4765),
    [sym_ieee32] = STATE(4765),
    [sym_ieee64] = STATE(4765),
    [sym_bignum] = STATE(4765),
    [sym_decimal] = STATE(4765),
    [sym_float] = STATE(4512),
    [sym_block_comment] = STATE(2594),
    [sym_compiler_directive_decl] = STATE(2594),
    [sym_fsi_directive_decl] = STATE(2594),
    [sym_preproc_line] = STATE(2594),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(4175),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_LPAREN] = ACTIONS(3572),
    [anon_sym_null] = ACTIONS(3574),
    [anon_sym__] = ACTIONS(3576),
    [anon_sym_QMARK] = ACTIONS(4177),
    [anon_sym_COLON_QMARK] = ACTIONS(4179),
    [anon_sym_LBRACK] = ACTIONS(3582),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3584),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [aux_sym_char_token1] = ACTIONS(3590),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3592),
    [anon_sym_DQUOTE] = ACTIONS(3594),
    [anon_sym_AT_DQUOTE] = ACTIONS(3596),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3598),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3600),
    [sym_bool] = ACTIONS(3602),
    [sym_unit] = ACTIONS(3604),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4181),
    [sym_op_identifier] = ACTIONS(4183),
    [sym_int] = ACTIONS(3610),
    [sym_xint] = ACTIONS(3612),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2595] = {
    [sym_attributes] = STATE(2699),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(4815),
    [sym__pattern] = STATE(5419),
    [sym_optional_pattern] = STATE(4815),
    [sym_type_check_pattern] = STATE(4815),
    [sym_attribute_pattern] = STATE(4815),
    [sym_paren_pattern] = STATE(4815),
    [sym_as_pattern] = STATE(4815),
    [sym_cons_pattern] = STATE(4815),
    [sym_disjunct_pattern] = STATE(4815),
    [sym_conjunct_pattern] = STATE(4815),
    [sym_typed_pattern] = STATE(4815),
    [sym_list_pattern] = STATE(4815),
    [sym_array_pattern] = STATE(4815),
    [sym_record_pattern] = STATE(4815),
    [sym_named_field_pattern] = STATE(4815),
    [sym_identifier_pattern] = STATE(4815),
    [sym_long_identifier_or_op] = STATE(2193),
    [sym_rule] = STATE(1408),
    [sym_char] = STATE(4765),
    [sym_format_string] = STATE(4746),
    [sym__string_literal] = STATE(4746),
    [sym_string] = STATE(4765),
    [sym_verbatim_string] = STATE(4765),
    [sym_bytearray] = STATE(4765),
    [sym_verbatim_bytearray] = STATE(4765),
    [sym_format_triple_quoted_string] = STATE(4720),
    [sym_triple_quoted_string] = STATE(4765),
    [sym_const] = STATE(4815),
    [sym_long_identifier] = STATE(3493),
    [sym_active_pattern] = STATE(3613),
    [sym__identifier_or_op] = STATE(3650),
    [sym_sbyte] = STATE(4765),
    [sym_byte] = STATE(4765),
    [sym_int16] = STATE(4765),
    [sym_uint16] = STATE(4765),
    [sym_int32] = STATE(4765),
    [sym_uint32] = STATE(4765),
    [sym_nativeint] = STATE(4765),
    [sym_unativeint] = STATE(4765),
    [sym_int64] = STATE(4765),
    [sym_uint64] = STATE(4765),
    [sym_ieee32] = STATE(4765),
    [sym_ieee64] = STATE(4765),
    [sym_bignum] = STATE(4765),
    [sym_decimal] = STATE(4765),
    [sym_float] = STATE(4512),
    [sym_block_comment] = STATE(2595),
    [sym_compiler_directive_decl] = STATE(2595),
    [sym_fsi_directive_decl] = STATE(2595),
    [sym_preproc_line] = STATE(2595),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(4175),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_LPAREN] = ACTIONS(3572),
    [anon_sym_null] = ACTIONS(3574),
    [anon_sym__] = ACTIONS(3576),
    [anon_sym_QMARK] = ACTIONS(4177),
    [anon_sym_COLON_QMARK] = ACTIONS(4179),
    [anon_sym_LBRACK] = ACTIONS(3582),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3584),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [aux_sym_char_token1] = ACTIONS(3590),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3592),
    [anon_sym_DQUOTE] = ACTIONS(3594),
    [anon_sym_AT_DQUOTE] = ACTIONS(3596),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3598),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3600),
    [sym_bool] = ACTIONS(3602),
    [sym_unit] = ACTIONS(3604),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4181),
    [sym_op_identifier] = ACTIONS(4183),
    [sym_int] = ACTIONS(3610),
    [sym_xint] = ACTIONS(3612),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2596] = {
    [sym_attributes] = STATE(2699),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(4815),
    [sym__pattern] = STATE(5212),
    [sym_optional_pattern] = STATE(4815),
    [sym_type_check_pattern] = STATE(4815),
    [sym_attribute_pattern] = STATE(4815),
    [sym_paren_pattern] = STATE(4815),
    [sym_as_pattern] = STATE(4815),
    [sym_cons_pattern] = STATE(4815),
    [sym_disjunct_pattern] = STATE(4815),
    [sym_conjunct_pattern] = STATE(4815),
    [sym_typed_pattern] = STATE(4815),
    [sym_list_pattern] = STATE(4815),
    [sym_array_pattern] = STATE(4815),
    [sym_record_pattern] = STATE(4815),
    [sym_named_field_pattern] = STATE(4815),
    [sym_identifier_pattern] = STATE(4815),
    [sym_long_identifier_or_op] = STATE(2193),
    [sym_rule] = STATE(1918),
    [sym_char] = STATE(4765),
    [sym_format_string] = STATE(4746),
    [sym__string_literal] = STATE(4746),
    [sym_string] = STATE(4765),
    [sym_verbatim_string] = STATE(4765),
    [sym_bytearray] = STATE(4765),
    [sym_verbatim_bytearray] = STATE(4765),
    [sym_format_triple_quoted_string] = STATE(4720),
    [sym_triple_quoted_string] = STATE(4765),
    [sym_const] = STATE(4815),
    [sym_long_identifier] = STATE(3493),
    [sym_active_pattern] = STATE(3613),
    [sym__identifier_or_op] = STATE(3650),
    [sym_sbyte] = STATE(4765),
    [sym_byte] = STATE(4765),
    [sym_int16] = STATE(4765),
    [sym_uint16] = STATE(4765),
    [sym_int32] = STATE(4765),
    [sym_uint32] = STATE(4765),
    [sym_nativeint] = STATE(4765),
    [sym_unativeint] = STATE(4765),
    [sym_int64] = STATE(4765),
    [sym_uint64] = STATE(4765),
    [sym_ieee32] = STATE(4765),
    [sym_ieee64] = STATE(4765),
    [sym_bignum] = STATE(4765),
    [sym_decimal] = STATE(4765),
    [sym_float] = STATE(4512),
    [sym_block_comment] = STATE(2596),
    [sym_compiler_directive_decl] = STATE(2596),
    [sym_fsi_directive_decl] = STATE(2596),
    [sym_preproc_line] = STATE(2596),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(4175),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_LPAREN] = ACTIONS(3572),
    [anon_sym_null] = ACTIONS(3574),
    [anon_sym__] = ACTIONS(3576),
    [anon_sym_QMARK] = ACTIONS(4177),
    [anon_sym_COLON_QMARK] = ACTIONS(4179),
    [anon_sym_LBRACK] = ACTIONS(3582),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3584),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [aux_sym_char_token1] = ACTIONS(3590),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3592),
    [anon_sym_DQUOTE] = ACTIONS(3594),
    [anon_sym_AT_DQUOTE] = ACTIONS(3596),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3598),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3600),
    [sym_bool] = ACTIONS(3602),
    [sym_unit] = ACTIONS(3604),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4181),
    [sym_op_identifier] = ACTIONS(4183),
    [sym_int] = ACTIONS(3610),
    [sym_xint] = ACTIONS(3612),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2597] = {
    [sym_attributes] = STATE(2699),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(4815),
    [sym__pattern] = STATE(5419),
    [sym_optional_pattern] = STATE(4815),
    [sym_type_check_pattern] = STATE(4815),
    [sym_attribute_pattern] = STATE(4815),
    [sym_paren_pattern] = STATE(4815),
    [sym_as_pattern] = STATE(4815),
    [sym_cons_pattern] = STATE(4815),
    [sym_disjunct_pattern] = STATE(4815),
    [sym_conjunct_pattern] = STATE(4815),
    [sym_typed_pattern] = STATE(4815),
    [sym_list_pattern] = STATE(4815),
    [sym_array_pattern] = STATE(4815),
    [sym_record_pattern] = STATE(4815),
    [sym_named_field_pattern] = STATE(4815),
    [sym_identifier_pattern] = STATE(4815),
    [sym_long_identifier_or_op] = STATE(2193),
    [sym_rule] = STATE(1662),
    [sym_char] = STATE(4765),
    [sym_format_string] = STATE(4746),
    [sym__string_literal] = STATE(4746),
    [sym_string] = STATE(4765),
    [sym_verbatim_string] = STATE(4765),
    [sym_bytearray] = STATE(4765),
    [sym_verbatim_bytearray] = STATE(4765),
    [sym_format_triple_quoted_string] = STATE(4720),
    [sym_triple_quoted_string] = STATE(4765),
    [sym_const] = STATE(4815),
    [sym_long_identifier] = STATE(3493),
    [sym_active_pattern] = STATE(3613),
    [sym__identifier_or_op] = STATE(3650),
    [sym_sbyte] = STATE(4765),
    [sym_byte] = STATE(4765),
    [sym_int16] = STATE(4765),
    [sym_uint16] = STATE(4765),
    [sym_int32] = STATE(4765),
    [sym_uint32] = STATE(4765),
    [sym_nativeint] = STATE(4765),
    [sym_unativeint] = STATE(4765),
    [sym_int64] = STATE(4765),
    [sym_uint64] = STATE(4765),
    [sym_ieee32] = STATE(4765),
    [sym_ieee64] = STATE(4765),
    [sym_bignum] = STATE(4765),
    [sym_decimal] = STATE(4765),
    [sym_float] = STATE(4512),
    [sym_block_comment] = STATE(2597),
    [sym_compiler_directive_decl] = STATE(2597),
    [sym_fsi_directive_decl] = STATE(2597),
    [sym_preproc_line] = STATE(2597),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(4175),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_LPAREN] = ACTIONS(3572),
    [anon_sym_null] = ACTIONS(3574),
    [anon_sym__] = ACTIONS(3576),
    [anon_sym_QMARK] = ACTIONS(4177),
    [anon_sym_COLON_QMARK] = ACTIONS(4179),
    [anon_sym_LBRACK] = ACTIONS(3582),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3584),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [aux_sym_char_token1] = ACTIONS(3590),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3592),
    [anon_sym_DQUOTE] = ACTIONS(3594),
    [anon_sym_AT_DQUOTE] = ACTIONS(3596),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3598),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3600),
    [sym_bool] = ACTIONS(3602),
    [sym_unit] = ACTIONS(3604),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4181),
    [sym_op_identifier] = ACTIONS(4183),
    [sym_int] = ACTIONS(3610),
    [sym_xint] = ACTIONS(3612),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2598] = {
    [sym_attributes] = STATE(2699),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(4815),
    [sym__pattern] = STATE(5419),
    [sym_optional_pattern] = STATE(4815),
    [sym_type_check_pattern] = STATE(4815),
    [sym_attribute_pattern] = STATE(4815),
    [sym_paren_pattern] = STATE(4815),
    [sym_as_pattern] = STATE(4815),
    [sym_cons_pattern] = STATE(4815),
    [sym_disjunct_pattern] = STATE(4815),
    [sym_conjunct_pattern] = STATE(4815),
    [sym_typed_pattern] = STATE(4815),
    [sym_list_pattern] = STATE(4815),
    [sym_array_pattern] = STATE(4815),
    [sym_record_pattern] = STATE(4815),
    [sym_named_field_pattern] = STATE(4815),
    [sym_identifier_pattern] = STATE(4815),
    [sym_long_identifier_or_op] = STATE(2193),
    [sym_rule] = STATE(1665),
    [sym_char] = STATE(4765),
    [sym_format_string] = STATE(4746),
    [sym__string_literal] = STATE(4746),
    [sym_string] = STATE(4765),
    [sym_verbatim_string] = STATE(4765),
    [sym_bytearray] = STATE(4765),
    [sym_verbatim_bytearray] = STATE(4765),
    [sym_format_triple_quoted_string] = STATE(4720),
    [sym_triple_quoted_string] = STATE(4765),
    [sym_const] = STATE(4815),
    [sym_long_identifier] = STATE(3493),
    [sym_active_pattern] = STATE(3613),
    [sym__identifier_or_op] = STATE(3650),
    [sym_sbyte] = STATE(4765),
    [sym_byte] = STATE(4765),
    [sym_int16] = STATE(4765),
    [sym_uint16] = STATE(4765),
    [sym_int32] = STATE(4765),
    [sym_uint32] = STATE(4765),
    [sym_nativeint] = STATE(4765),
    [sym_unativeint] = STATE(4765),
    [sym_int64] = STATE(4765),
    [sym_uint64] = STATE(4765),
    [sym_ieee32] = STATE(4765),
    [sym_ieee64] = STATE(4765),
    [sym_bignum] = STATE(4765),
    [sym_decimal] = STATE(4765),
    [sym_float] = STATE(4512),
    [sym_block_comment] = STATE(2598),
    [sym_compiler_directive_decl] = STATE(2598),
    [sym_fsi_directive_decl] = STATE(2598),
    [sym_preproc_line] = STATE(2598),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(4175),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_LPAREN] = ACTIONS(3572),
    [anon_sym_null] = ACTIONS(3574),
    [anon_sym__] = ACTIONS(3576),
    [anon_sym_QMARK] = ACTIONS(4177),
    [anon_sym_COLON_QMARK] = ACTIONS(4179),
    [anon_sym_LBRACK] = ACTIONS(3582),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3584),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [aux_sym_char_token1] = ACTIONS(3590),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3592),
    [anon_sym_DQUOTE] = ACTIONS(3594),
    [anon_sym_AT_DQUOTE] = ACTIONS(3596),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3598),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3600),
    [sym_bool] = ACTIONS(3602),
    [sym_unit] = ACTIONS(3604),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4181),
    [sym_op_identifier] = ACTIONS(4183),
    [sym_int] = ACTIONS(3610),
    [sym_xint] = ACTIONS(3612),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2599] = {
    [sym_attributes] = STATE(2699),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(4815),
    [sym__pattern] = STATE(5237),
    [sym_optional_pattern] = STATE(4815),
    [sym_type_check_pattern] = STATE(4815),
    [sym_attribute_pattern] = STATE(4815),
    [sym_paren_pattern] = STATE(4815),
    [sym_as_pattern] = STATE(4815),
    [sym_cons_pattern] = STATE(4815),
    [sym_disjunct_pattern] = STATE(4815),
    [sym_conjunct_pattern] = STATE(4815),
    [sym_typed_pattern] = STATE(4815),
    [sym_list_pattern] = STATE(4815),
    [sym_array_pattern] = STATE(4815),
    [sym_record_pattern] = STATE(4815),
    [sym_named_field_pattern] = STATE(4815),
    [sym_identifier_pattern] = STATE(4815),
    [sym_long_identifier_or_op] = STATE(2193),
    [sym_rule] = STATE(1991),
    [sym_char] = STATE(4765),
    [sym_format_string] = STATE(4746),
    [sym__string_literal] = STATE(4746),
    [sym_string] = STATE(4765),
    [sym_verbatim_string] = STATE(4765),
    [sym_bytearray] = STATE(4765),
    [sym_verbatim_bytearray] = STATE(4765),
    [sym_format_triple_quoted_string] = STATE(4720),
    [sym_triple_quoted_string] = STATE(4765),
    [sym_const] = STATE(4815),
    [sym_long_identifier] = STATE(3493),
    [sym_active_pattern] = STATE(3613),
    [sym__identifier_or_op] = STATE(3650),
    [sym_sbyte] = STATE(4765),
    [sym_byte] = STATE(4765),
    [sym_int16] = STATE(4765),
    [sym_uint16] = STATE(4765),
    [sym_int32] = STATE(4765),
    [sym_uint32] = STATE(4765),
    [sym_nativeint] = STATE(4765),
    [sym_unativeint] = STATE(4765),
    [sym_int64] = STATE(4765),
    [sym_uint64] = STATE(4765),
    [sym_ieee32] = STATE(4765),
    [sym_ieee64] = STATE(4765),
    [sym_bignum] = STATE(4765),
    [sym_decimal] = STATE(4765),
    [sym_float] = STATE(4512),
    [sym_block_comment] = STATE(2599),
    [sym_compiler_directive_decl] = STATE(2599),
    [sym_fsi_directive_decl] = STATE(2599),
    [sym_preproc_line] = STATE(2599),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(4175),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_LPAREN] = ACTIONS(3572),
    [anon_sym_null] = ACTIONS(3574),
    [anon_sym__] = ACTIONS(3576),
    [anon_sym_QMARK] = ACTIONS(4177),
    [anon_sym_COLON_QMARK] = ACTIONS(4179),
    [anon_sym_LBRACK] = ACTIONS(3582),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3584),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [aux_sym_char_token1] = ACTIONS(3590),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3592),
    [anon_sym_DQUOTE] = ACTIONS(3594),
    [anon_sym_AT_DQUOTE] = ACTIONS(3596),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3598),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3600),
    [sym_bool] = ACTIONS(3602),
    [sym_unit] = ACTIONS(3604),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4181),
    [sym_op_identifier] = ACTIONS(4183),
    [sym_int] = ACTIONS(3610),
    [sym_xint] = ACTIONS(3612),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2600] = {
    [sym_attributes] = STATE(2641),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(5241),
    [sym__pattern] = STATE(5281),
    [sym_optional_pattern] = STATE(5241),
    [sym_type_check_pattern] = STATE(5241),
    [sym_attribute_pattern] = STATE(5241),
    [sym_paren_pattern] = STATE(5241),
    [sym_as_pattern] = STATE(5241),
    [sym_cons_pattern] = STATE(5241),
    [sym_disjunct_pattern] = STATE(5241),
    [sym_conjunct_pattern] = STATE(5241),
    [sym_typed_pattern] = STATE(5241),
    [sym_list_pattern] = STATE(5241),
    [sym_array_pattern] = STATE(5241),
    [sym_record_pattern] = STATE(5241),
    [sym_named_field] = STATE(5937),
    [sym_named_field_pattern] = STATE(5241),
    [sym_identifier_pattern] = STATE(5241),
    [sym_long_identifier_or_op] = STATE(1721),
    [sym_char] = STATE(5389),
    [sym_format_string] = STATE(5273),
    [sym__string_literal] = STATE(5273),
    [sym_string] = STATE(5389),
    [sym_verbatim_string] = STATE(5389),
    [sym_bytearray] = STATE(5389),
    [sym_verbatim_bytearray] = STATE(5389),
    [sym_format_triple_quoted_string] = STATE(5377),
    [sym_triple_quoted_string] = STATE(5389),
    [sym_const] = STATE(5241),
    [sym_long_identifier] = STATE(3363),
    [sym_active_pattern] = STATE(3521),
    [sym__identifier_or_op] = STATE(3510),
    [sym_sbyte] = STATE(5389),
    [sym_byte] = STATE(5389),
    [sym_int16] = STATE(5389),
    [sym_uint16] = STATE(5389),
    [sym_int32] = STATE(5389),
    [sym_uint32] = STATE(5389),
    [sym_nativeint] = STATE(5389),
    [sym_unativeint] = STATE(5389),
    [sym_int64] = STATE(5389),
    [sym_uint64] = STATE(5389),
    [sym_ieee32] = STATE(5389),
    [sym_ieee64] = STATE(5389),
    [sym_bignum] = STATE(5389),
    [sym_decimal] = STATE(5389),
    [sym_float] = STATE(4893),
    [sym_block_comment] = STATE(2600),
    [sym_compiler_directive_decl] = STATE(2600),
    [sym_fsi_directive_decl] = STATE(2600),
    [sym_preproc_line] = STATE(2600),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(4442),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_LPAREN] = ACTIONS(3872),
    [anon_sym_null] = ACTIONS(3874),
    [anon_sym__] = ACTIONS(3876),
    [anon_sym_QMARK] = ACTIONS(3878),
    [anon_sym_COLON_QMARK] = ACTIONS(3880),
    [anon_sym_LBRACK] = ACTIONS(3882),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3884),
    [anon_sym_LBRACE] = ACTIONS(3886),
    [aux_sym_char_token1] = ACTIONS(3888),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3890),
    [anon_sym_DQUOTE] = ACTIONS(3892),
    [anon_sym_AT_DQUOTE] = ACTIONS(3894),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3896),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3898),
    [sym_bool] = ACTIONS(3900),
    [sym_unit] = ACTIONS(3902),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3904),
    [sym_op_identifier] = ACTIONS(3906),
    [sym_int] = ACTIONS(3908),
    [sym_xint] = ACTIONS(3910),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2601] = {
    [sym_attributes] = STATE(2699),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(4815),
    [sym__pattern] = STATE(5274),
    [sym_optional_pattern] = STATE(4815),
    [sym_type_check_pattern] = STATE(4815),
    [sym_attribute_pattern] = STATE(4815),
    [sym_paren_pattern] = STATE(4815),
    [sym_as_pattern] = STATE(4815),
    [sym_cons_pattern] = STATE(4815),
    [sym_disjunct_pattern] = STATE(4815),
    [sym_conjunct_pattern] = STATE(4815),
    [sym_typed_pattern] = STATE(4815),
    [sym_list_pattern] = STATE(4815),
    [sym_array_pattern] = STATE(4815),
    [sym_record_pattern] = STATE(4815),
    [sym_named_field_pattern] = STATE(4815),
    [sym_identifier_pattern] = STATE(4815),
    [sym_long_identifier_or_op] = STATE(2193),
    [sym_rule] = STATE(1018),
    [sym_char] = STATE(4765),
    [sym_format_string] = STATE(4746),
    [sym__string_literal] = STATE(4746),
    [sym_string] = STATE(4765),
    [sym_verbatim_string] = STATE(4765),
    [sym_bytearray] = STATE(4765),
    [sym_verbatim_bytearray] = STATE(4765),
    [sym_format_triple_quoted_string] = STATE(4720),
    [sym_triple_quoted_string] = STATE(4765),
    [sym_const] = STATE(4815),
    [sym_long_identifier] = STATE(3493),
    [sym_active_pattern] = STATE(3613),
    [sym__identifier_or_op] = STATE(3650),
    [sym_sbyte] = STATE(4765),
    [sym_byte] = STATE(4765),
    [sym_int16] = STATE(4765),
    [sym_uint16] = STATE(4765),
    [sym_int32] = STATE(4765),
    [sym_uint32] = STATE(4765),
    [sym_nativeint] = STATE(4765),
    [sym_unativeint] = STATE(4765),
    [sym_int64] = STATE(4765),
    [sym_uint64] = STATE(4765),
    [sym_ieee32] = STATE(4765),
    [sym_ieee64] = STATE(4765),
    [sym_bignum] = STATE(4765),
    [sym_decimal] = STATE(4765),
    [sym_float] = STATE(4512),
    [sym_block_comment] = STATE(2601),
    [sym_compiler_directive_decl] = STATE(2601),
    [sym_fsi_directive_decl] = STATE(2601),
    [sym_preproc_line] = STATE(2601),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(4175),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_LPAREN] = ACTIONS(3572),
    [anon_sym_null] = ACTIONS(3574),
    [anon_sym__] = ACTIONS(3576),
    [anon_sym_QMARK] = ACTIONS(4177),
    [anon_sym_COLON_QMARK] = ACTIONS(4179),
    [anon_sym_LBRACK] = ACTIONS(3582),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3584),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [aux_sym_char_token1] = ACTIONS(3590),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3592),
    [anon_sym_DQUOTE] = ACTIONS(3594),
    [anon_sym_AT_DQUOTE] = ACTIONS(3596),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3598),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3600),
    [sym_bool] = ACTIONS(3602),
    [sym_unit] = ACTIONS(3604),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4181),
    [sym_op_identifier] = ACTIONS(4183),
    [sym_int] = ACTIONS(3610),
    [sym_xint] = ACTIONS(3612),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2602] = {
    [sym_attributes] = STATE(2699),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(4815),
    [sym__pattern] = STATE(5237),
    [sym_optional_pattern] = STATE(4815),
    [sym_type_check_pattern] = STATE(4815),
    [sym_attribute_pattern] = STATE(4815),
    [sym_paren_pattern] = STATE(4815),
    [sym_as_pattern] = STATE(4815),
    [sym_cons_pattern] = STATE(4815),
    [sym_disjunct_pattern] = STATE(4815),
    [sym_conjunct_pattern] = STATE(4815),
    [sym_typed_pattern] = STATE(4815),
    [sym_list_pattern] = STATE(4815),
    [sym_array_pattern] = STATE(4815),
    [sym_record_pattern] = STATE(4815),
    [sym_named_field_pattern] = STATE(4815),
    [sym_identifier_pattern] = STATE(4815),
    [sym_long_identifier_or_op] = STATE(2193),
    [sym_rule] = STATE(1980),
    [sym_char] = STATE(4765),
    [sym_format_string] = STATE(4746),
    [sym__string_literal] = STATE(4746),
    [sym_string] = STATE(4765),
    [sym_verbatim_string] = STATE(4765),
    [sym_bytearray] = STATE(4765),
    [sym_verbatim_bytearray] = STATE(4765),
    [sym_format_triple_quoted_string] = STATE(4720),
    [sym_triple_quoted_string] = STATE(4765),
    [sym_const] = STATE(4815),
    [sym_long_identifier] = STATE(3493),
    [sym_active_pattern] = STATE(3613),
    [sym__identifier_or_op] = STATE(3650),
    [sym_sbyte] = STATE(4765),
    [sym_byte] = STATE(4765),
    [sym_int16] = STATE(4765),
    [sym_uint16] = STATE(4765),
    [sym_int32] = STATE(4765),
    [sym_uint32] = STATE(4765),
    [sym_nativeint] = STATE(4765),
    [sym_unativeint] = STATE(4765),
    [sym_int64] = STATE(4765),
    [sym_uint64] = STATE(4765),
    [sym_ieee32] = STATE(4765),
    [sym_ieee64] = STATE(4765),
    [sym_bignum] = STATE(4765),
    [sym_decimal] = STATE(4765),
    [sym_float] = STATE(4512),
    [sym_block_comment] = STATE(2602),
    [sym_compiler_directive_decl] = STATE(2602),
    [sym_fsi_directive_decl] = STATE(2602),
    [sym_preproc_line] = STATE(2602),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(4175),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_LPAREN] = ACTIONS(3572),
    [anon_sym_null] = ACTIONS(3574),
    [anon_sym__] = ACTIONS(3576),
    [anon_sym_QMARK] = ACTIONS(4177),
    [anon_sym_COLON_QMARK] = ACTIONS(4179),
    [anon_sym_LBRACK] = ACTIONS(3582),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3584),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [aux_sym_char_token1] = ACTIONS(3590),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3592),
    [anon_sym_DQUOTE] = ACTIONS(3594),
    [anon_sym_AT_DQUOTE] = ACTIONS(3596),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3598),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3600),
    [sym_bool] = ACTIONS(3602),
    [sym_unit] = ACTIONS(3604),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4181),
    [sym_op_identifier] = ACTIONS(4183),
    [sym_int] = ACTIONS(3610),
    [sym_xint] = ACTIONS(3612),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2603] = {
    [sym_attributes] = STATE(2699),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(4815),
    [sym__pattern] = STATE(5177),
    [sym_optional_pattern] = STATE(4815),
    [sym_type_check_pattern] = STATE(4815),
    [sym_attribute_pattern] = STATE(4815),
    [sym_paren_pattern] = STATE(4815),
    [sym_as_pattern] = STATE(4815),
    [sym_cons_pattern] = STATE(4815),
    [sym_disjunct_pattern] = STATE(4815),
    [sym_conjunct_pattern] = STATE(4815),
    [sym_typed_pattern] = STATE(4815),
    [sym_list_pattern] = STATE(4815),
    [sym_array_pattern] = STATE(4815),
    [sym_record_pattern] = STATE(4815),
    [sym_named_field_pattern] = STATE(4815),
    [sym_identifier_pattern] = STATE(4815),
    [sym_long_identifier_or_op] = STATE(2193),
    [sym_rule] = STATE(1955),
    [sym_char] = STATE(4765),
    [sym_format_string] = STATE(4746),
    [sym__string_literal] = STATE(4746),
    [sym_string] = STATE(4765),
    [sym_verbatim_string] = STATE(4765),
    [sym_bytearray] = STATE(4765),
    [sym_verbatim_bytearray] = STATE(4765),
    [sym_format_triple_quoted_string] = STATE(4720),
    [sym_triple_quoted_string] = STATE(4765),
    [sym_const] = STATE(4815),
    [sym_long_identifier] = STATE(3493),
    [sym_active_pattern] = STATE(3613),
    [sym__identifier_or_op] = STATE(3650),
    [sym_sbyte] = STATE(4765),
    [sym_byte] = STATE(4765),
    [sym_int16] = STATE(4765),
    [sym_uint16] = STATE(4765),
    [sym_int32] = STATE(4765),
    [sym_uint32] = STATE(4765),
    [sym_nativeint] = STATE(4765),
    [sym_unativeint] = STATE(4765),
    [sym_int64] = STATE(4765),
    [sym_uint64] = STATE(4765),
    [sym_ieee32] = STATE(4765),
    [sym_ieee64] = STATE(4765),
    [sym_bignum] = STATE(4765),
    [sym_decimal] = STATE(4765),
    [sym_float] = STATE(4512),
    [sym_block_comment] = STATE(2603),
    [sym_compiler_directive_decl] = STATE(2603),
    [sym_fsi_directive_decl] = STATE(2603),
    [sym_preproc_line] = STATE(2603),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(4175),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_LPAREN] = ACTIONS(3572),
    [anon_sym_null] = ACTIONS(3574),
    [anon_sym__] = ACTIONS(3576),
    [anon_sym_QMARK] = ACTIONS(4177),
    [anon_sym_COLON_QMARK] = ACTIONS(4179),
    [anon_sym_LBRACK] = ACTIONS(3582),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3584),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [aux_sym_char_token1] = ACTIONS(3590),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3592),
    [anon_sym_DQUOTE] = ACTIONS(3594),
    [anon_sym_AT_DQUOTE] = ACTIONS(3596),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3598),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3600),
    [sym_bool] = ACTIONS(3602),
    [sym_unit] = ACTIONS(3604),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4181),
    [sym_op_identifier] = ACTIONS(4183),
    [sym_int] = ACTIONS(3610),
    [sym_xint] = ACTIONS(3612),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2604] = {
    [sym_attributes] = STATE(2674),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(5431),
    [sym__pattern] = STATE(5029),
    [sym_optional_pattern] = STATE(5431),
    [sym_type_check_pattern] = STATE(5431),
    [sym_attribute_pattern] = STATE(5431),
    [sym_paren_pattern] = STATE(5431),
    [sym_as_pattern] = STATE(5431),
    [sym_cons_pattern] = STATE(5431),
    [sym_disjunct_pattern] = STATE(5431),
    [sym_conjunct_pattern] = STATE(5431),
    [sym_typed_pattern] = STATE(5431),
    [sym_list_pattern] = STATE(5431),
    [sym_array_pattern] = STATE(5431),
    [sym_record_pattern] = STATE(5431),
    [sym_named_field_pattern] = STATE(5431),
    [sym_identifier_pattern] = STATE(5431),
    [sym_long_identifier_or_op] = STATE(2273),
    [sym_char] = STATE(5475),
    [sym_format_string] = STATE(5423),
    [sym__string_literal] = STATE(5423),
    [sym_string] = STATE(5475),
    [sym_verbatim_string] = STATE(5475),
    [sym_bytearray] = STATE(5475),
    [sym_verbatim_bytearray] = STATE(5475),
    [sym_format_triple_quoted_string] = STATE(5477),
    [sym_triple_quoted_string] = STATE(5475),
    [sym_const] = STATE(5431),
    [sym_long_identifier] = STATE(3437),
    [sym_active_pattern] = STATE(3653),
    [sym__identifier_or_op] = STATE(3660),
    [sym_sbyte] = STATE(5475),
    [sym_byte] = STATE(5475),
    [sym_int16] = STATE(5475),
    [sym_uint16] = STATE(5475),
    [sym_int32] = STATE(5475),
    [sym_uint32] = STATE(5475),
    [sym_nativeint] = STATE(5475),
    [sym_unativeint] = STATE(5475),
    [sym_int64] = STATE(5475),
    [sym_uint64] = STATE(5475),
    [sym_ieee32] = STATE(5475),
    [sym_ieee64] = STATE(5475),
    [sym_bignum] = STATE(5475),
    [sym_decimal] = STATE(5475),
    [sym_float] = STATE(4953),
    [sym_block_comment] = STATE(2604),
    [sym_compiler_directive_decl] = STATE(2604),
    [sym_fsi_directive_decl] = STATE(2604),
    [sym_preproc_line] = STATE(2604),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(4073),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_LPAREN] = ACTIONS(4077),
    [anon_sym_null] = ACTIONS(4081),
    [anon_sym__] = ACTIONS(4083),
    [anon_sym_QMARK] = ACTIONS(4085),
    [anon_sym_COLON_QMARK] = ACTIONS(4087),
    [anon_sym_LBRACK] = ACTIONS(4095),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4097),
    [anon_sym_LBRACE] = ACTIONS(4099),
    [aux_sym_char_token1] = ACTIONS(4101),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4103),
    [anon_sym_DQUOTE] = ACTIONS(4105),
    [anon_sym_AT_DQUOTE] = ACTIONS(4107),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4109),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4111),
    [sym_bool] = ACTIONS(4113),
    [sym_unit] = ACTIONS(4115),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4117),
    [sym_op_identifier] = ACTIONS(4119),
    [sym_int] = ACTIONS(4121),
    [sym_xint] = ACTIONS(4123),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [sym__newline] = ACTIONS(4444),
  },
  [2605] = {
    [sym_attributes] = STATE(2699),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(4815),
    [sym__pattern] = STATE(5282),
    [sym_optional_pattern] = STATE(4815),
    [sym_type_check_pattern] = STATE(4815),
    [sym_attribute_pattern] = STATE(4815),
    [sym_paren_pattern] = STATE(4815),
    [sym_as_pattern] = STATE(4815),
    [sym_cons_pattern] = STATE(4815),
    [sym_disjunct_pattern] = STATE(4815),
    [sym_conjunct_pattern] = STATE(4815),
    [sym_typed_pattern] = STATE(4815),
    [sym_list_pattern] = STATE(4815),
    [sym_array_pattern] = STATE(4815),
    [sym_record_pattern] = STATE(4815),
    [sym_named_field_pattern] = STATE(4815),
    [sym_identifier_pattern] = STATE(4815),
    [sym_long_identifier_or_op] = STATE(2193),
    [sym_rule] = STATE(5828),
    [sym_char] = STATE(4765),
    [sym_format_string] = STATE(4746),
    [sym__string_literal] = STATE(4746),
    [sym_string] = STATE(4765),
    [sym_verbatim_string] = STATE(4765),
    [sym_bytearray] = STATE(4765),
    [sym_verbatim_bytearray] = STATE(4765),
    [sym_format_triple_quoted_string] = STATE(4720),
    [sym_triple_quoted_string] = STATE(4765),
    [sym_const] = STATE(4815),
    [sym_long_identifier] = STATE(3493),
    [sym_active_pattern] = STATE(3613),
    [sym__identifier_or_op] = STATE(3650),
    [sym_sbyte] = STATE(4765),
    [sym_byte] = STATE(4765),
    [sym_int16] = STATE(4765),
    [sym_uint16] = STATE(4765),
    [sym_int32] = STATE(4765),
    [sym_uint32] = STATE(4765),
    [sym_nativeint] = STATE(4765),
    [sym_unativeint] = STATE(4765),
    [sym_int64] = STATE(4765),
    [sym_uint64] = STATE(4765),
    [sym_ieee32] = STATE(4765),
    [sym_ieee64] = STATE(4765),
    [sym_bignum] = STATE(4765),
    [sym_decimal] = STATE(4765),
    [sym_float] = STATE(4512),
    [sym_block_comment] = STATE(2605),
    [sym_compiler_directive_decl] = STATE(2605),
    [sym_fsi_directive_decl] = STATE(2605),
    [sym_preproc_line] = STATE(2605),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(4175),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_LPAREN] = ACTIONS(3572),
    [anon_sym_null] = ACTIONS(3574),
    [anon_sym__] = ACTIONS(3576),
    [anon_sym_QMARK] = ACTIONS(4177),
    [anon_sym_COLON_QMARK] = ACTIONS(4179),
    [anon_sym_LBRACK] = ACTIONS(3582),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3584),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [aux_sym_char_token1] = ACTIONS(3590),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3592),
    [anon_sym_DQUOTE] = ACTIONS(3594),
    [anon_sym_AT_DQUOTE] = ACTIONS(3596),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3598),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3600),
    [sym_bool] = ACTIONS(3602),
    [sym_unit] = ACTIONS(3604),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4181),
    [sym_op_identifier] = ACTIONS(4183),
    [sym_int] = ACTIONS(3610),
    [sym_xint] = ACTIONS(3612),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2606] = {
    [sym_attributes] = STATE(2699),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(4815),
    [sym__pattern] = STATE(5267),
    [sym_optional_pattern] = STATE(4815),
    [sym_type_check_pattern] = STATE(4815),
    [sym_attribute_pattern] = STATE(4815),
    [sym_paren_pattern] = STATE(4815),
    [sym_as_pattern] = STATE(4815),
    [sym_cons_pattern] = STATE(4815),
    [sym_disjunct_pattern] = STATE(4815),
    [sym_conjunct_pattern] = STATE(4815),
    [sym_typed_pattern] = STATE(4815),
    [sym_list_pattern] = STATE(4815),
    [sym_array_pattern] = STATE(4815),
    [sym_record_pattern] = STATE(4815),
    [sym_named_field_pattern] = STATE(4815),
    [sym_identifier_pattern] = STATE(4815),
    [sym_long_identifier_or_op] = STATE(2193),
    [sym_rule] = STATE(1412),
    [sym_char] = STATE(4765),
    [sym_format_string] = STATE(4746),
    [sym__string_literal] = STATE(4746),
    [sym_string] = STATE(4765),
    [sym_verbatim_string] = STATE(4765),
    [sym_bytearray] = STATE(4765),
    [sym_verbatim_bytearray] = STATE(4765),
    [sym_format_triple_quoted_string] = STATE(4720),
    [sym_triple_quoted_string] = STATE(4765),
    [sym_const] = STATE(4815),
    [sym_long_identifier] = STATE(3493),
    [sym_active_pattern] = STATE(3613),
    [sym__identifier_or_op] = STATE(3650),
    [sym_sbyte] = STATE(4765),
    [sym_byte] = STATE(4765),
    [sym_int16] = STATE(4765),
    [sym_uint16] = STATE(4765),
    [sym_int32] = STATE(4765),
    [sym_uint32] = STATE(4765),
    [sym_nativeint] = STATE(4765),
    [sym_unativeint] = STATE(4765),
    [sym_int64] = STATE(4765),
    [sym_uint64] = STATE(4765),
    [sym_ieee32] = STATE(4765),
    [sym_ieee64] = STATE(4765),
    [sym_bignum] = STATE(4765),
    [sym_decimal] = STATE(4765),
    [sym_float] = STATE(4512),
    [sym_block_comment] = STATE(2606),
    [sym_compiler_directive_decl] = STATE(2606),
    [sym_fsi_directive_decl] = STATE(2606),
    [sym_preproc_line] = STATE(2606),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(4175),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_LPAREN] = ACTIONS(3572),
    [anon_sym_null] = ACTIONS(3574),
    [anon_sym__] = ACTIONS(3576),
    [anon_sym_QMARK] = ACTIONS(4177),
    [anon_sym_COLON_QMARK] = ACTIONS(4179),
    [anon_sym_LBRACK] = ACTIONS(3582),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3584),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [aux_sym_char_token1] = ACTIONS(3590),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3592),
    [anon_sym_DQUOTE] = ACTIONS(3594),
    [anon_sym_AT_DQUOTE] = ACTIONS(3596),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3598),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3600),
    [sym_bool] = ACTIONS(3602),
    [sym_unit] = ACTIONS(3604),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4181),
    [sym_op_identifier] = ACTIONS(4183),
    [sym_int] = ACTIONS(3610),
    [sym_xint] = ACTIONS(3612),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2607] = {
    [sym_attributes] = STATE(2699),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(4815),
    [sym__pattern] = STATE(5311),
    [sym_optional_pattern] = STATE(4815),
    [sym_type_check_pattern] = STATE(4815),
    [sym_attribute_pattern] = STATE(4815),
    [sym_paren_pattern] = STATE(4815),
    [sym_as_pattern] = STATE(4815),
    [sym_cons_pattern] = STATE(4815),
    [sym_disjunct_pattern] = STATE(4815),
    [sym_conjunct_pattern] = STATE(4815),
    [sym_typed_pattern] = STATE(4815),
    [sym_list_pattern] = STATE(4815),
    [sym_array_pattern] = STATE(4815),
    [sym_record_pattern] = STATE(4815),
    [sym_named_field_pattern] = STATE(4815),
    [sym_identifier_pattern] = STATE(4815),
    [sym_long_identifier_or_op] = STATE(2193),
    [sym_rule] = STATE(1471),
    [sym_char] = STATE(4765),
    [sym_format_string] = STATE(4746),
    [sym__string_literal] = STATE(4746),
    [sym_string] = STATE(4765),
    [sym_verbatim_string] = STATE(4765),
    [sym_bytearray] = STATE(4765),
    [sym_verbatim_bytearray] = STATE(4765),
    [sym_format_triple_quoted_string] = STATE(4720),
    [sym_triple_quoted_string] = STATE(4765),
    [sym_const] = STATE(4815),
    [sym_long_identifier] = STATE(3493),
    [sym_active_pattern] = STATE(3613),
    [sym__identifier_or_op] = STATE(3650),
    [sym_sbyte] = STATE(4765),
    [sym_byte] = STATE(4765),
    [sym_int16] = STATE(4765),
    [sym_uint16] = STATE(4765),
    [sym_int32] = STATE(4765),
    [sym_uint32] = STATE(4765),
    [sym_nativeint] = STATE(4765),
    [sym_unativeint] = STATE(4765),
    [sym_int64] = STATE(4765),
    [sym_uint64] = STATE(4765),
    [sym_ieee32] = STATE(4765),
    [sym_ieee64] = STATE(4765),
    [sym_bignum] = STATE(4765),
    [sym_decimal] = STATE(4765),
    [sym_float] = STATE(4512),
    [sym_block_comment] = STATE(2607),
    [sym_compiler_directive_decl] = STATE(2607),
    [sym_fsi_directive_decl] = STATE(2607),
    [sym_preproc_line] = STATE(2607),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(4175),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_LPAREN] = ACTIONS(3572),
    [anon_sym_null] = ACTIONS(3574),
    [anon_sym__] = ACTIONS(3576),
    [anon_sym_QMARK] = ACTIONS(4177),
    [anon_sym_COLON_QMARK] = ACTIONS(4179),
    [anon_sym_LBRACK] = ACTIONS(3582),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3584),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [aux_sym_char_token1] = ACTIONS(3590),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3592),
    [anon_sym_DQUOTE] = ACTIONS(3594),
    [anon_sym_AT_DQUOTE] = ACTIONS(3596),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3598),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3600),
    [sym_bool] = ACTIONS(3602),
    [sym_unit] = ACTIONS(3604),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4181),
    [sym_op_identifier] = ACTIONS(4183),
    [sym_int] = ACTIONS(3610),
    [sym_xint] = ACTIONS(3612),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2608] = {
    [sym_attributes] = STATE(2699),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(4815),
    [sym__pattern] = STATE(5283),
    [sym_optional_pattern] = STATE(4815),
    [sym_type_check_pattern] = STATE(4815),
    [sym_attribute_pattern] = STATE(4815),
    [sym_paren_pattern] = STATE(4815),
    [sym_as_pattern] = STATE(4815),
    [sym_cons_pattern] = STATE(4815),
    [sym_disjunct_pattern] = STATE(4815),
    [sym_conjunct_pattern] = STATE(4815),
    [sym_typed_pattern] = STATE(4815),
    [sym_list_pattern] = STATE(4815),
    [sym_array_pattern] = STATE(4815),
    [sym_record_pattern] = STATE(4815),
    [sym_named_field_pattern] = STATE(4815),
    [sym_identifier_pattern] = STATE(4815),
    [sym_long_identifier_or_op] = STATE(2193),
    [sym_rule] = STATE(1706),
    [sym_char] = STATE(4765),
    [sym_format_string] = STATE(4746),
    [sym__string_literal] = STATE(4746),
    [sym_string] = STATE(4765),
    [sym_verbatim_string] = STATE(4765),
    [sym_bytearray] = STATE(4765),
    [sym_verbatim_bytearray] = STATE(4765),
    [sym_format_triple_quoted_string] = STATE(4720),
    [sym_triple_quoted_string] = STATE(4765),
    [sym_const] = STATE(4815),
    [sym_long_identifier] = STATE(3493),
    [sym_active_pattern] = STATE(3613),
    [sym__identifier_or_op] = STATE(3650),
    [sym_sbyte] = STATE(4765),
    [sym_byte] = STATE(4765),
    [sym_int16] = STATE(4765),
    [sym_uint16] = STATE(4765),
    [sym_int32] = STATE(4765),
    [sym_uint32] = STATE(4765),
    [sym_nativeint] = STATE(4765),
    [sym_unativeint] = STATE(4765),
    [sym_int64] = STATE(4765),
    [sym_uint64] = STATE(4765),
    [sym_ieee32] = STATE(4765),
    [sym_ieee64] = STATE(4765),
    [sym_bignum] = STATE(4765),
    [sym_decimal] = STATE(4765),
    [sym_float] = STATE(4512),
    [sym_block_comment] = STATE(2608),
    [sym_compiler_directive_decl] = STATE(2608),
    [sym_fsi_directive_decl] = STATE(2608),
    [sym_preproc_line] = STATE(2608),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(4175),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_LPAREN] = ACTIONS(3572),
    [anon_sym_null] = ACTIONS(3574),
    [anon_sym__] = ACTIONS(3576),
    [anon_sym_QMARK] = ACTIONS(4177),
    [anon_sym_COLON_QMARK] = ACTIONS(4179),
    [anon_sym_LBRACK] = ACTIONS(3582),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3584),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [aux_sym_char_token1] = ACTIONS(3590),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3592),
    [anon_sym_DQUOTE] = ACTIONS(3594),
    [anon_sym_AT_DQUOTE] = ACTIONS(3596),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3598),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3600),
    [sym_bool] = ACTIONS(3602),
    [sym_unit] = ACTIONS(3604),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4181),
    [sym_op_identifier] = ACTIONS(4183),
    [sym_int] = ACTIONS(3610),
    [sym_xint] = ACTIONS(3612),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2609] = {
    [sym_attributes] = STATE(2641),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(5241),
    [sym__pattern] = STATE(5259),
    [sym_optional_pattern] = STATE(5241),
    [sym_type_check_pattern] = STATE(5241),
    [sym_attribute_pattern] = STATE(5241),
    [sym_paren_pattern] = STATE(5241),
    [sym_as_pattern] = STATE(5241),
    [sym_cons_pattern] = STATE(5241),
    [sym_disjunct_pattern] = STATE(5241),
    [sym_conjunct_pattern] = STATE(5241),
    [sym_typed_pattern] = STATE(5241),
    [sym_list_pattern] = STATE(5241),
    [sym_array_pattern] = STATE(5241),
    [sym_record_pattern] = STATE(5241),
    [sym_named_field] = STATE(6216),
    [sym_named_field_pattern] = STATE(5241),
    [sym_identifier_pattern] = STATE(5241),
    [sym_long_identifier_or_op] = STATE(1721),
    [sym_char] = STATE(5389),
    [sym_format_string] = STATE(5273),
    [sym__string_literal] = STATE(5273),
    [sym_string] = STATE(5389),
    [sym_verbatim_string] = STATE(5389),
    [sym_bytearray] = STATE(5389),
    [sym_verbatim_bytearray] = STATE(5389),
    [sym_format_triple_quoted_string] = STATE(5377),
    [sym_triple_quoted_string] = STATE(5389),
    [sym_const] = STATE(5241),
    [sym_long_identifier] = STATE(3363),
    [sym_active_pattern] = STATE(3521),
    [sym__identifier_or_op] = STATE(3510),
    [sym_sbyte] = STATE(5389),
    [sym_byte] = STATE(5389),
    [sym_int16] = STATE(5389),
    [sym_uint16] = STATE(5389),
    [sym_int32] = STATE(5389),
    [sym_uint32] = STATE(5389),
    [sym_nativeint] = STATE(5389),
    [sym_unativeint] = STATE(5389),
    [sym_int64] = STATE(5389),
    [sym_uint64] = STATE(5389),
    [sym_ieee32] = STATE(5389),
    [sym_ieee64] = STATE(5389),
    [sym_bignum] = STATE(5389),
    [sym_decimal] = STATE(5389),
    [sym_float] = STATE(4893),
    [sym_block_comment] = STATE(2609),
    [sym_compiler_directive_decl] = STATE(2609),
    [sym_fsi_directive_decl] = STATE(2609),
    [sym_preproc_line] = STATE(2609),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(4442),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_LPAREN] = ACTIONS(3872),
    [anon_sym_null] = ACTIONS(3874),
    [anon_sym__] = ACTIONS(3876),
    [anon_sym_QMARK] = ACTIONS(3878),
    [anon_sym_COLON_QMARK] = ACTIONS(3880),
    [anon_sym_LBRACK] = ACTIONS(3882),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3884),
    [anon_sym_LBRACE] = ACTIONS(3886),
    [aux_sym_char_token1] = ACTIONS(3888),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3890),
    [anon_sym_DQUOTE] = ACTIONS(3892),
    [anon_sym_AT_DQUOTE] = ACTIONS(3894),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3896),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3898),
    [sym_bool] = ACTIONS(3900),
    [sym_unit] = ACTIONS(3902),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3904),
    [sym_op_identifier] = ACTIONS(3906),
    [sym_int] = ACTIONS(3908),
    [sym_xint] = ACTIONS(3910),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2610] = {
    [sym_attributes] = STATE(2699),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(4815),
    [sym__pattern] = STATE(5282),
    [sym_optional_pattern] = STATE(4815),
    [sym_type_check_pattern] = STATE(4815),
    [sym_attribute_pattern] = STATE(4815),
    [sym_paren_pattern] = STATE(4815),
    [sym_as_pattern] = STATE(4815),
    [sym_cons_pattern] = STATE(4815),
    [sym_disjunct_pattern] = STATE(4815),
    [sym_conjunct_pattern] = STATE(4815),
    [sym_typed_pattern] = STATE(4815),
    [sym_list_pattern] = STATE(4815),
    [sym_array_pattern] = STATE(4815),
    [sym_record_pattern] = STATE(4815),
    [sym_named_field_pattern] = STATE(4815),
    [sym_identifier_pattern] = STATE(4815),
    [sym_long_identifier_or_op] = STATE(2193),
    [sym_rule] = STATE(5724),
    [sym_char] = STATE(4765),
    [sym_format_string] = STATE(4746),
    [sym__string_literal] = STATE(4746),
    [sym_string] = STATE(4765),
    [sym_verbatim_string] = STATE(4765),
    [sym_bytearray] = STATE(4765),
    [sym_verbatim_bytearray] = STATE(4765),
    [sym_format_triple_quoted_string] = STATE(4720),
    [sym_triple_quoted_string] = STATE(4765),
    [sym_const] = STATE(4815),
    [sym_long_identifier] = STATE(3493),
    [sym_active_pattern] = STATE(3613),
    [sym__identifier_or_op] = STATE(3650),
    [sym_sbyte] = STATE(4765),
    [sym_byte] = STATE(4765),
    [sym_int16] = STATE(4765),
    [sym_uint16] = STATE(4765),
    [sym_int32] = STATE(4765),
    [sym_uint32] = STATE(4765),
    [sym_nativeint] = STATE(4765),
    [sym_unativeint] = STATE(4765),
    [sym_int64] = STATE(4765),
    [sym_uint64] = STATE(4765),
    [sym_ieee32] = STATE(4765),
    [sym_ieee64] = STATE(4765),
    [sym_bignum] = STATE(4765),
    [sym_decimal] = STATE(4765),
    [sym_float] = STATE(4512),
    [sym_block_comment] = STATE(2610),
    [sym_compiler_directive_decl] = STATE(2610),
    [sym_fsi_directive_decl] = STATE(2610),
    [sym_preproc_line] = STATE(2610),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(4175),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_LPAREN] = ACTIONS(3572),
    [anon_sym_null] = ACTIONS(3574),
    [anon_sym__] = ACTIONS(3576),
    [anon_sym_QMARK] = ACTIONS(4177),
    [anon_sym_COLON_QMARK] = ACTIONS(4179),
    [anon_sym_LBRACK] = ACTIONS(3582),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3584),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [aux_sym_char_token1] = ACTIONS(3590),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3592),
    [anon_sym_DQUOTE] = ACTIONS(3594),
    [anon_sym_AT_DQUOTE] = ACTIONS(3596),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3598),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3600),
    [sym_bool] = ACTIONS(3602),
    [sym_unit] = ACTIONS(3604),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4181),
    [sym_op_identifier] = ACTIONS(4183),
    [sym_int] = ACTIONS(3610),
    [sym_xint] = ACTIONS(3612),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2611] = {
    [sym_attributes] = STATE(2699),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(4815),
    [sym__pattern] = STATE(5267),
    [sym_optional_pattern] = STATE(4815),
    [sym_type_check_pattern] = STATE(4815),
    [sym_attribute_pattern] = STATE(4815),
    [sym_paren_pattern] = STATE(4815),
    [sym_as_pattern] = STATE(4815),
    [sym_cons_pattern] = STATE(4815),
    [sym_disjunct_pattern] = STATE(4815),
    [sym_conjunct_pattern] = STATE(4815),
    [sym_typed_pattern] = STATE(4815),
    [sym_list_pattern] = STATE(4815),
    [sym_array_pattern] = STATE(4815),
    [sym_record_pattern] = STATE(4815),
    [sym_named_field_pattern] = STATE(4815),
    [sym_identifier_pattern] = STATE(4815),
    [sym_long_identifier_or_op] = STATE(2193),
    [sym_rule] = STATE(1663),
    [sym_char] = STATE(4765),
    [sym_format_string] = STATE(4746),
    [sym__string_literal] = STATE(4746),
    [sym_string] = STATE(4765),
    [sym_verbatim_string] = STATE(4765),
    [sym_bytearray] = STATE(4765),
    [sym_verbatim_bytearray] = STATE(4765),
    [sym_format_triple_quoted_string] = STATE(4720),
    [sym_triple_quoted_string] = STATE(4765),
    [sym_const] = STATE(4815),
    [sym_long_identifier] = STATE(3493),
    [sym_active_pattern] = STATE(3613),
    [sym__identifier_or_op] = STATE(3650),
    [sym_sbyte] = STATE(4765),
    [sym_byte] = STATE(4765),
    [sym_int16] = STATE(4765),
    [sym_uint16] = STATE(4765),
    [sym_int32] = STATE(4765),
    [sym_uint32] = STATE(4765),
    [sym_nativeint] = STATE(4765),
    [sym_unativeint] = STATE(4765),
    [sym_int64] = STATE(4765),
    [sym_uint64] = STATE(4765),
    [sym_ieee32] = STATE(4765),
    [sym_ieee64] = STATE(4765),
    [sym_bignum] = STATE(4765),
    [sym_decimal] = STATE(4765),
    [sym_float] = STATE(4512),
    [sym_block_comment] = STATE(2611),
    [sym_compiler_directive_decl] = STATE(2611),
    [sym_fsi_directive_decl] = STATE(2611),
    [sym_preproc_line] = STATE(2611),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(4175),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_LPAREN] = ACTIONS(3572),
    [anon_sym_null] = ACTIONS(3574),
    [anon_sym__] = ACTIONS(3576),
    [anon_sym_QMARK] = ACTIONS(4177),
    [anon_sym_COLON_QMARK] = ACTIONS(4179),
    [anon_sym_LBRACK] = ACTIONS(3582),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3584),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [aux_sym_char_token1] = ACTIONS(3590),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3592),
    [anon_sym_DQUOTE] = ACTIONS(3594),
    [anon_sym_AT_DQUOTE] = ACTIONS(3596),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3598),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3600),
    [sym_bool] = ACTIONS(3602),
    [sym_unit] = ACTIONS(3604),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4181),
    [sym_op_identifier] = ACTIONS(4183),
    [sym_int] = ACTIONS(3610),
    [sym_xint] = ACTIONS(3612),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2612] = {
    [sym_attributes] = STATE(2699),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(4815),
    [sym__pattern] = STATE(5283),
    [sym_optional_pattern] = STATE(4815),
    [sym_type_check_pattern] = STATE(4815),
    [sym_attribute_pattern] = STATE(4815),
    [sym_paren_pattern] = STATE(4815),
    [sym_as_pattern] = STATE(4815),
    [sym_cons_pattern] = STATE(4815),
    [sym_disjunct_pattern] = STATE(4815),
    [sym_conjunct_pattern] = STATE(4815),
    [sym_typed_pattern] = STATE(4815),
    [sym_list_pattern] = STATE(4815),
    [sym_array_pattern] = STATE(4815),
    [sym_record_pattern] = STATE(4815),
    [sym_named_field_pattern] = STATE(4815),
    [sym_identifier_pattern] = STATE(4815),
    [sym_long_identifier_or_op] = STATE(2193),
    [sym_rule] = STATE(1679),
    [sym_char] = STATE(4765),
    [sym_format_string] = STATE(4746),
    [sym__string_literal] = STATE(4746),
    [sym_string] = STATE(4765),
    [sym_verbatim_string] = STATE(4765),
    [sym_bytearray] = STATE(4765),
    [sym_verbatim_bytearray] = STATE(4765),
    [sym_format_triple_quoted_string] = STATE(4720),
    [sym_triple_quoted_string] = STATE(4765),
    [sym_const] = STATE(4815),
    [sym_long_identifier] = STATE(3493),
    [sym_active_pattern] = STATE(3613),
    [sym__identifier_or_op] = STATE(3650),
    [sym_sbyte] = STATE(4765),
    [sym_byte] = STATE(4765),
    [sym_int16] = STATE(4765),
    [sym_uint16] = STATE(4765),
    [sym_int32] = STATE(4765),
    [sym_uint32] = STATE(4765),
    [sym_nativeint] = STATE(4765),
    [sym_unativeint] = STATE(4765),
    [sym_int64] = STATE(4765),
    [sym_uint64] = STATE(4765),
    [sym_ieee32] = STATE(4765),
    [sym_ieee64] = STATE(4765),
    [sym_bignum] = STATE(4765),
    [sym_decimal] = STATE(4765),
    [sym_float] = STATE(4512),
    [sym_block_comment] = STATE(2612),
    [sym_compiler_directive_decl] = STATE(2612),
    [sym_fsi_directive_decl] = STATE(2612),
    [sym_preproc_line] = STATE(2612),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(4175),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_LPAREN] = ACTIONS(3572),
    [anon_sym_null] = ACTIONS(3574),
    [anon_sym__] = ACTIONS(3576),
    [anon_sym_QMARK] = ACTIONS(4177),
    [anon_sym_COLON_QMARK] = ACTIONS(4179),
    [anon_sym_LBRACK] = ACTIONS(3582),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3584),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [aux_sym_char_token1] = ACTIONS(3590),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3592),
    [anon_sym_DQUOTE] = ACTIONS(3594),
    [anon_sym_AT_DQUOTE] = ACTIONS(3596),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3598),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3600),
    [sym_bool] = ACTIONS(3602),
    [sym_unit] = ACTIONS(3604),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4181),
    [sym_op_identifier] = ACTIONS(4183),
    [sym_int] = ACTIONS(3610),
    [sym_xint] = ACTIONS(3612),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2613] = {
    [sym_attributes] = STATE(2699),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(4815),
    [sym__pattern] = STATE(5267),
    [sym_optional_pattern] = STATE(4815),
    [sym_type_check_pattern] = STATE(4815),
    [sym_attribute_pattern] = STATE(4815),
    [sym_paren_pattern] = STATE(4815),
    [sym_as_pattern] = STATE(4815),
    [sym_cons_pattern] = STATE(4815),
    [sym_disjunct_pattern] = STATE(4815),
    [sym_conjunct_pattern] = STATE(4815),
    [sym_typed_pattern] = STATE(4815),
    [sym_list_pattern] = STATE(4815),
    [sym_array_pattern] = STATE(4815),
    [sym_record_pattern] = STATE(4815),
    [sym_named_field_pattern] = STATE(4815),
    [sym_identifier_pattern] = STATE(4815),
    [sym_long_identifier_or_op] = STATE(2193),
    [sym_rule] = STATE(1688),
    [sym_char] = STATE(4765),
    [sym_format_string] = STATE(4746),
    [sym__string_literal] = STATE(4746),
    [sym_string] = STATE(4765),
    [sym_verbatim_string] = STATE(4765),
    [sym_bytearray] = STATE(4765),
    [sym_verbatim_bytearray] = STATE(4765),
    [sym_format_triple_quoted_string] = STATE(4720),
    [sym_triple_quoted_string] = STATE(4765),
    [sym_const] = STATE(4815),
    [sym_long_identifier] = STATE(3493),
    [sym_active_pattern] = STATE(3613),
    [sym__identifier_or_op] = STATE(3650),
    [sym_sbyte] = STATE(4765),
    [sym_byte] = STATE(4765),
    [sym_int16] = STATE(4765),
    [sym_uint16] = STATE(4765),
    [sym_int32] = STATE(4765),
    [sym_uint32] = STATE(4765),
    [sym_nativeint] = STATE(4765),
    [sym_unativeint] = STATE(4765),
    [sym_int64] = STATE(4765),
    [sym_uint64] = STATE(4765),
    [sym_ieee32] = STATE(4765),
    [sym_ieee64] = STATE(4765),
    [sym_bignum] = STATE(4765),
    [sym_decimal] = STATE(4765),
    [sym_float] = STATE(4512),
    [sym_block_comment] = STATE(2613),
    [sym_compiler_directive_decl] = STATE(2613),
    [sym_fsi_directive_decl] = STATE(2613),
    [sym_preproc_line] = STATE(2613),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(4175),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_LPAREN] = ACTIONS(3572),
    [anon_sym_null] = ACTIONS(3574),
    [anon_sym__] = ACTIONS(3576),
    [anon_sym_QMARK] = ACTIONS(4177),
    [anon_sym_COLON_QMARK] = ACTIONS(4179),
    [anon_sym_LBRACK] = ACTIONS(3582),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3584),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [aux_sym_char_token1] = ACTIONS(3590),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3592),
    [anon_sym_DQUOTE] = ACTIONS(3594),
    [anon_sym_AT_DQUOTE] = ACTIONS(3596),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3598),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3600),
    [sym_bool] = ACTIONS(3602),
    [sym_unit] = ACTIONS(3604),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4181),
    [sym_op_identifier] = ACTIONS(4183),
    [sym_int] = ACTIONS(3610),
    [sym_xint] = ACTIONS(3612),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2614] = {
    [sym_attributes] = STATE(2699),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(4815),
    [sym__pattern] = STATE(5282),
    [sym_optional_pattern] = STATE(4815),
    [sym_type_check_pattern] = STATE(4815),
    [sym_attribute_pattern] = STATE(4815),
    [sym_paren_pattern] = STATE(4815),
    [sym_as_pattern] = STATE(4815),
    [sym_cons_pattern] = STATE(4815),
    [sym_disjunct_pattern] = STATE(4815),
    [sym_conjunct_pattern] = STATE(4815),
    [sym_typed_pattern] = STATE(4815),
    [sym_list_pattern] = STATE(4815),
    [sym_array_pattern] = STATE(4815),
    [sym_record_pattern] = STATE(4815),
    [sym_named_field_pattern] = STATE(4815),
    [sym_identifier_pattern] = STATE(4815),
    [sym_long_identifier_or_op] = STATE(2193),
    [sym_rule] = STATE(5970),
    [sym_char] = STATE(4765),
    [sym_format_string] = STATE(4746),
    [sym__string_literal] = STATE(4746),
    [sym_string] = STATE(4765),
    [sym_verbatim_string] = STATE(4765),
    [sym_bytearray] = STATE(4765),
    [sym_verbatim_bytearray] = STATE(4765),
    [sym_format_triple_quoted_string] = STATE(4720),
    [sym_triple_quoted_string] = STATE(4765),
    [sym_const] = STATE(4815),
    [sym_long_identifier] = STATE(3493),
    [sym_active_pattern] = STATE(3613),
    [sym__identifier_or_op] = STATE(3650),
    [sym_sbyte] = STATE(4765),
    [sym_byte] = STATE(4765),
    [sym_int16] = STATE(4765),
    [sym_uint16] = STATE(4765),
    [sym_int32] = STATE(4765),
    [sym_uint32] = STATE(4765),
    [sym_nativeint] = STATE(4765),
    [sym_unativeint] = STATE(4765),
    [sym_int64] = STATE(4765),
    [sym_uint64] = STATE(4765),
    [sym_ieee32] = STATE(4765),
    [sym_ieee64] = STATE(4765),
    [sym_bignum] = STATE(4765),
    [sym_decimal] = STATE(4765),
    [sym_float] = STATE(4512),
    [sym_block_comment] = STATE(2614),
    [sym_compiler_directive_decl] = STATE(2614),
    [sym_fsi_directive_decl] = STATE(2614),
    [sym_preproc_line] = STATE(2614),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(4175),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_LPAREN] = ACTIONS(3572),
    [anon_sym_null] = ACTIONS(3574),
    [anon_sym__] = ACTIONS(3576),
    [anon_sym_QMARK] = ACTIONS(4177),
    [anon_sym_COLON_QMARK] = ACTIONS(4179),
    [anon_sym_LBRACK] = ACTIONS(3582),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3584),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [aux_sym_char_token1] = ACTIONS(3590),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3592),
    [anon_sym_DQUOTE] = ACTIONS(3594),
    [anon_sym_AT_DQUOTE] = ACTIONS(3596),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3598),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3600),
    [sym_bool] = ACTIONS(3602),
    [sym_unit] = ACTIONS(3604),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4181),
    [sym_op_identifier] = ACTIONS(4183),
    [sym_int] = ACTIONS(3610),
    [sym_xint] = ACTIONS(3612),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2615] = {
    [sym_block_comment] = STATE(2615),
    [sym_compiler_directive_decl] = STATE(2615),
    [sym_fsi_directive_decl] = STATE(2615),
    [sym_preproc_line] = STATE(2615),
    [sym_identifier] = ACTIONS(2158),
    [anon_sym_return] = ACTIONS(2158),
    [anon_sym_do] = ACTIONS(2158),
    [anon_sym_let] = ACTIONS(2158),
    [anon_sym_let_BANG] = ACTIONS(2160),
    [anon_sym_LPAREN] = ACTIONS(2158),
    [anon_sym_COMMA] = ACTIONS(2160),
    [anon_sym_null] = ACTIONS(2158),
    [anon_sym_AMP] = ACTIONS(2158),
    [anon_sym_LBRACK] = ACTIONS(2158),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2160),
    [anon_sym_LBRACE] = ACTIONS(2158),
    [anon_sym_LT_AT] = ACTIONS(2158),
    [anon_sym_LT_AT_AT] = ACTIONS(2160),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2160),
    [anon_sym_new] = ACTIONS(2158),
    [anon_sym_return_BANG] = ACTIONS(2160),
    [anon_sym_yield] = ACTIONS(2158),
    [anon_sym_yield_BANG] = ACTIONS(2160),
    [anon_sym_lazy] = ACTIONS(2158),
    [anon_sym_assert] = ACTIONS(2158),
    [anon_sym_upcast] = ACTIONS(2158),
    [anon_sym_downcast] = ACTIONS(2158),
    [anon_sym_for] = ACTIONS(2158),
    [anon_sym_while] = ACTIONS(2158),
    [anon_sym_if] = ACTIONS(2158),
    [anon_sym_fun] = ACTIONS(2158),
    [anon_sym_try] = ACTIONS(2158),
    [anon_sym_match] = ACTIONS(2158),
    [anon_sym_match_BANG] = ACTIONS(2160),
    [anon_sym_function] = ACTIONS(2158),
    [anon_sym_GT] = ACTIONS(2160),
    [anon_sym_use] = ACTIONS(2158),
    [anon_sym_use_BANG] = ACTIONS(2160),
    [anon_sym_do_BANG] = ACTIONS(2160),
    [anon_sym_begin] = ACTIONS(2158),
    [aux_sym_char_token1] = ACTIONS(2160),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2158),
    [anon_sym_DQUOTE] = ACTIONS(2158),
    [anon_sym_AT_DQUOTE] = ACTIONS(2160),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2160),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2160),
    [sym_bool] = ACTIONS(2158),
    [sym_unit] = ACTIONS(2160),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2158),
    [sym_op_identifier] = ACTIONS(2160),
    [anon_sym_PLUS] = ACTIONS(2158),
    [anon_sym_DASH] = ACTIONS(2158),
    [anon_sym_PLUS_DOT] = ACTIONS(2160),
    [anon_sym_DASH_DOT] = ACTIONS(2160),
    [anon_sym_PERCENT] = ACTIONS(2160),
    [anon_sym_AMP_AMP] = ACTIONS(2160),
    [anon_sym_TILDE] = ACTIONS(2160),
    [aux_sym_prefix_op_token1] = ACTIONS(2160),
    [sym_int] = ACTIONS(2158),
    [sym_xint] = ACTIONS(2160),
    [anon_sym_y] = ACTIONS(4446),
    [anon_sym_uy] = ACTIONS(4448),
    [anon_sym_s] = ACTIONS(4450),
    [anon_sym_us] = ACTIONS(4452),
    [anon_sym_l] = ACTIONS(4454),
    [aux_sym_uint32_token1] = ACTIONS(4456),
    [anon_sym_n] = ACTIONS(4458),
    [anon_sym_un] = ACTIONS(4460),
    [anon_sym_L] = ACTIONS(4462),
    [aux_sym_uint64_token1] = ACTIONS(4464),
    [aux_sym_bignum_token1] = ACTIONS(4466),
    [aux_sym_decimal_token1] = ACTIONS(4468),
    [anon_sym_DOT2] = ACTIONS(4470),
    [aux_sym_float_token1] = ACTIONS(4472),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2160),
  },
  [2616] = {
    [sym_attributes] = STATE(2699),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(4815),
    [sym__pattern] = STATE(5196),
    [sym_optional_pattern] = STATE(4815),
    [sym_type_check_pattern] = STATE(4815),
    [sym_attribute_pattern] = STATE(4815),
    [sym_paren_pattern] = STATE(4815),
    [sym_as_pattern] = STATE(4815),
    [sym_cons_pattern] = STATE(4815),
    [sym_disjunct_pattern] = STATE(4815),
    [sym_conjunct_pattern] = STATE(4815),
    [sym_typed_pattern] = STATE(4815),
    [sym_list_pattern] = STATE(4815),
    [sym_array_pattern] = STATE(4815),
    [sym_record_pattern] = STATE(4815),
    [sym_named_field_pattern] = STATE(4815),
    [sym_identifier_pattern] = STATE(4815),
    [sym_long_identifier_or_op] = STATE(2193),
    [sym_rule] = STATE(835),
    [sym_char] = STATE(4765),
    [sym_format_string] = STATE(4746),
    [sym__string_literal] = STATE(4746),
    [sym_string] = STATE(4765),
    [sym_verbatim_string] = STATE(4765),
    [sym_bytearray] = STATE(4765),
    [sym_verbatim_bytearray] = STATE(4765),
    [sym_format_triple_quoted_string] = STATE(4720),
    [sym_triple_quoted_string] = STATE(4765),
    [sym_const] = STATE(4815),
    [sym_long_identifier] = STATE(3493),
    [sym_active_pattern] = STATE(3613),
    [sym__identifier_or_op] = STATE(3650),
    [sym_sbyte] = STATE(4765),
    [sym_byte] = STATE(4765),
    [sym_int16] = STATE(4765),
    [sym_uint16] = STATE(4765),
    [sym_int32] = STATE(4765),
    [sym_uint32] = STATE(4765),
    [sym_nativeint] = STATE(4765),
    [sym_unativeint] = STATE(4765),
    [sym_int64] = STATE(4765),
    [sym_uint64] = STATE(4765),
    [sym_ieee32] = STATE(4765),
    [sym_ieee64] = STATE(4765),
    [sym_bignum] = STATE(4765),
    [sym_decimal] = STATE(4765),
    [sym_float] = STATE(4512),
    [sym_block_comment] = STATE(2616),
    [sym_compiler_directive_decl] = STATE(2616),
    [sym_fsi_directive_decl] = STATE(2616),
    [sym_preproc_line] = STATE(2616),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(4175),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_LPAREN] = ACTIONS(3572),
    [anon_sym_null] = ACTIONS(3574),
    [anon_sym__] = ACTIONS(3576),
    [anon_sym_QMARK] = ACTIONS(4177),
    [anon_sym_COLON_QMARK] = ACTIONS(4179),
    [anon_sym_LBRACK] = ACTIONS(3582),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3584),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [aux_sym_char_token1] = ACTIONS(3590),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3592),
    [anon_sym_DQUOTE] = ACTIONS(3594),
    [anon_sym_AT_DQUOTE] = ACTIONS(3596),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3598),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3600),
    [sym_bool] = ACTIONS(3602),
    [sym_unit] = ACTIONS(3604),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4181),
    [sym_op_identifier] = ACTIONS(4183),
    [sym_int] = ACTIONS(3610),
    [sym_xint] = ACTIONS(3612),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2617] = {
    [sym_attributes] = STATE(2641),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(5241),
    [sym__pattern] = STATE(5184),
    [sym_optional_pattern] = STATE(5241),
    [sym_type_check_pattern] = STATE(5241),
    [sym_attribute_pattern] = STATE(5241),
    [sym_paren_pattern] = STATE(5241),
    [sym_as_pattern] = STATE(5241),
    [sym_cons_pattern] = STATE(5241),
    [sym_disjunct_pattern] = STATE(5241),
    [sym_conjunct_pattern] = STATE(5241),
    [sym_typed_pattern] = STATE(5241),
    [sym_list_pattern] = STATE(5241),
    [sym_array_pattern] = STATE(5241),
    [sym_record_pattern] = STATE(5241),
    [sym_named_field] = STATE(5844),
    [sym_named_field_pattern] = STATE(5241),
    [sym_identifier_pattern] = STATE(5241),
    [sym_long_identifier_or_op] = STATE(1721),
    [sym_char] = STATE(5389),
    [sym_format_string] = STATE(5273),
    [sym__string_literal] = STATE(5273),
    [sym_string] = STATE(5389),
    [sym_verbatim_string] = STATE(5389),
    [sym_bytearray] = STATE(5389),
    [sym_verbatim_bytearray] = STATE(5389),
    [sym_format_triple_quoted_string] = STATE(5377),
    [sym_triple_quoted_string] = STATE(5389),
    [sym_const] = STATE(5241),
    [sym_long_identifier] = STATE(3363),
    [sym_active_pattern] = STATE(3521),
    [sym__identifier_or_op] = STATE(3510),
    [sym_sbyte] = STATE(5389),
    [sym_byte] = STATE(5389),
    [sym_int16] = STATE(5389),
    [sym_uint16] = STATE(5389),
    [sym_int32] = STATE(5389),
    [sym_uint32] = STATE(5389),
    [sym_nativeint] = STATE(5389),
    [sym_unativeint] = STATE(5389),
    [sym_int64] = STATE(5389),
    [sym_uint64] = STATE(5389),
    [sym_ieee32] = STATE(5389),
    [sym_ieee64] = STATE(5389),
    [sym_bignum] = STATE(5389),
    [sym_decimal] = STATE(5389),
    [sym_float] = STATE(4893),
    [sym_block_comment] = STATE(2617),
    [sym_compiler_directive_decl] = STATE(2617),
    [sym_fsi_directive_decl] = STATE(2617),
    [sym_preproc_line] = STATE(2617),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(4442),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_LPAREN] = ACTIONS(3872),
    [anon_sym_null] = ACTIONS(3874),
    [anon_sym__] = ACTIONS(3876),
    [anon_sym_QMARK] = ACTIONS(3878),
    [anon_sym_COLON_QMARK] = ACTIONS(3880),
    [anon_sym_LBRACK] = ACTIONS(3882),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3884),
    [anon_sym_LBRACE] = ACTIONS(3886),
    [aux_sym_char_token1] = ACTIONS(3888),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3890),
    [anon_sym_DQUOTE] = ACTIONS(3892),
    [anon_sym_AT_DQUOTE] = ACTIONS(3894),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3896),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3898),
    [sym_bool] = ACTIONS(3900),
    [sym_unit] = ACTIONS(3902),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3904),
    [sym_op_identifier] = ACTIONS(3906),
    [sym_int] = ACTIONS(3908),
    [sym_xint] = ACTIONS(3910),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2618] = {
    [sym_attributes] = STATE(2699),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(4815),
    [sym__pattern] = STATE(5283),
    [sym_optional_pattern] = STATE(4815),
    [sym_type_check_pattern] = STATE(4815),
    [sym_attribute_pattern] = STATE(4815),
    [sym_paren_pattern] = STATE(4815),
    [sym_as_pattern] = STATE(4815),
    [sym_cons_pattern] = STATE(4815),
    [sym_disjunct_pattern] = STATE(4815),
    [sym_conjunct_pattern] = STATE(4815),
    [sym_typed_pattern] = STATE(4815),
    [sym_list_pattern] = STATE(4815),
    [sym_array_pattern] = STATE(4815),
    [sym_record_pattern] = STATE(4815),
    [sym_named_field_pattern] = STATE(4815),
    [sym_identifier_pattern] = STATE(4815),
    [sym_long_identifier_or_op] = STATE(2193),
    [sym_rule] = STATE(1704),
    [sym_char] = STATE(4765),
    [sym_format_string] = STATE(4746),
    [sym__string_literal] = STATE(4746),
    [sym_string] = STATE(4765),
    [sym_verbatim_string] = STATE(4765),
    [sym_bytearray] = STATE(4765),
    [sym_verbatim_bytearray] = STATE(4765),
    [sym_format_triple_quoted_string] = STATE(4720),
    [sym_triple_quoted_string] = STATE(4765),
    [sym_const] = STATE(4815),
    [sym_long_identifier] = STATE(3493),
    [sym_active_pattern] = STATE(3613),
    [sym__identifier_or_op] = STATE(3650),
    [sym_sbyte] = STATE(4765),
    [sym_byte] = STATE(4765),
    [sym_int16] = STATE(4765),
    [sym_uint16] = STATE(4765),
    [sym_int32] = STATE(4765),
    [sym_uint32] = STATE(4765),
    [sym_nativeint] = STATE(4765),
    [sym_unativeint] = STATE(4765),
    [sym_int64] = STATE(4765),
    [sym_uint64] = STATE(4765),
    [sym_ieee32] = STATE(4765),
    [sym_ieee64] = STATE(4765),
    [sym_bignum] = STATE(4765),
    [sym_decimal] = STATE(4765),
    [sym_float] = STATE(4512),
    [sym_block_comment] = STATE(2618),
    [sym_compiler_directive_decl] = STATE(2618),
    [sym_fsi_directive_decl] = STATE(2618),
    [sym_preproc_line] = STATE(2618),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(4175),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_LPAREN] = ACTIONS(3572),
    [anon_sym_null] = ACTIONS(3574),
    [anon_sym__] = ACTIONS(3576),
    [anon_sym_QMARK] = ACTIONS(4177),
    [anon_sym_COLON_QMARK] = ACTIONS(4179),
    [anon_sym_LBRACK] = ACTIONS(3582),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3584),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [aux_sym_char_token1] = ACTIONS(3590),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3592),
    [anon_sym_DQUOTE] = ACTIONS(3594),
    [anon_sym_AT_DQUOTE] = ACTIONS(3596),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3598),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3600),
    [sym_bool] = ACTIONS(3602),
    [sym_unit] = ACTIONS(3604),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4181),
    [sym_op_identifier] = ACTIONS(4183),
    [sym_int] = ACTIONS(3610),
    [sym_xint] = ACTIONS(3612),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2619] = {
    [sym_attributes] = STATE(2641),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(5241),
    [sym__pattern] = STATE(5397),
    [sym_optional_pattern] = STATE(5241),
    [sym_type_check_pattern] = STATE(5241),
    [sym_attribute_pattern] = STATE(5241),
    [sym_paren_pattern] = STATE(5241),
    [sym_as_pattern] = STATE(5241),
    [sym_cons_pattern] = STATE(5241),
    [sym_disjunct_pattern] = STATE(5241),
    [sym_conjunct_pattern] = STATE(5241),
    [sym_typed_pattern] = STATE(5241),
    [sym_list_pattern] = STATE(5241),
    [sym_array_pattern] = STATE(5241),
    [sym_record_pattern] = STATE(5241),
    [sym_named_field] = STATE(5794),
    [sym_named_field_pattern] = STATE(5241),
    [sym_identifier_pattern] = STATE(5241),
    [sym_long_identifier_or_op] = STATE(1721),
    [sym_char] = STATE(5389),
    [sym_format_string] = STATE(5273),
    [sym__string_literal] = STATE(5273),
    [sym_string] = STATE(5389),
    [sym_verbatim_string] = STATE(5389),
    [sym_bytearray] = STATE(5389),
    [sym_verbatim_bytearray] = STATE(5389),
    [sym_format_triple_quoted_string] = STATE(5377),
    [sym_triple_quoted_string] = STATE(5389),
    [sym_const] = STATE(5241),
    [sym_long_identifier] = STATE(3363),
    [sym_active_pattern] = STATE(3521),
    [sym__identifier_or_op] = STATE(3510),
    [sym_sbyte] = STATE(5389),
    [sym_byte] = STATE(5389),
    [sym_int16] = STATE(5389),
    [sym_uint16] = STATE(5389),
    [sym_int32] = STATE(5389),
    [sym_uint32] = STATE(5389),
    [sym_nativeint] = STATE(5389),
    [sym_unativeint] = STATE(5389),
    [sym_int64] = STATE(5389),
    [sym_uint64] = STATE(5389),
    [sym_ieee32] = STATE(5389),
    [sym_ieee64] = STATE(5389),
    [sym_bignum] = STATE(5389),
    [sym_decimal] = STATE(5389),
    [sym_float] = STATE(4893),
    [sym_block_comment] = STATE(2619),
    [sym_compiler_directive_decl] = STATE(2619),
    [sym_fsi_directive_decl] = STATE(2619),
    [sym_preproc_line] = STATE(2619),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(4442),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_LPAREN] = ACTIONS(3872),
    [anon_sym_null] = ACTIONS(3874),
    [anon_sym__] = ACTIONS(3876),
    [anon_sym_QMARK] = ACTIONS(3878),
    [anon_sym_COLON_QMARK] = ACTIONS(3880),
    [anon_sym_LBRACK] = ACTIONS(3882),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3884),
    [anon_sym_LBRACE] = ACTIONS(3886),
    [aux_sym_char_token1] = ACTIONS(3888),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3890),
    [anon_sym_DQUOTE] = ACTIONS(3892),
    [anon_sym_AT_DQUOTE] = ACTIONS(3894),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3896),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3898),
    [sym_bool] = ACTIONS(3900),
    [sym_unit] = ACTIONS(3902),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3904),
    [sym_op_identifier] = ACTIONS(3906),
    [sym_int] = ACTIONS(3908),
    [sym_xint] = ACTIONS(3910),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2620] = {
    [sym_attributes] = STATE(2632),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(4815),
    [sym__pattern] = STATE(5455),
    [sym_optional_pattern] = STATE(4815),
    [sym_type_check_pattern] = STATE(4815),
    [sym_attribute_pattern] = STATE(4815),
    [sym_paren_pattern] = STATE(4815),
    [sym_as_pattern] = STATE(4815),
    [sym_cons_pattern] = STATE(4815),
    [sym_disjunct_pattern] = STATE(4815),
    [sym_conjunct_pattern] = STATE(4815),
    [sym_typed_pattern] = STATE(4815),
    [sym_list_pattern] = STATE(4815),
    [sym_array_pattern] = STATE(4815),
    [sym_record_pattern] = STATE(4815),
    [sym_named_field_pattern] = STATE(4815),
    [sym_identifier_pattern] = STATE(4815),
    [sym_long_identifier_or_op] = STATE(2475),
    [sym_char] = STATE(4765),
    [sym_format_string] = STATE(4746),
    [sym__string_literal] = STATE(4746),
    [sym_string] = STATE(4765),
    [sym_verbatim_string] = STATE(4765),
    [sym_bytearray] = STATE(4765),
    [sym_verbatim_bytearray] = STATE(4765),
    [sym_format_triple_quoted_string] = STATE(4720),
    [sym_triple_quoted_string] = STATE(4765),
    [sym_const] = STATE(4815),
    [sym_long_identifier] = STATE(3655),
    [sym_active_pattern] = STATE(3734),
    [sym__identifier_or_op] = STATE(3737),
    [sym_sbyte] = STATE(4765),
    [sym_byte] = STATE(4765),
    [sym_int16] = STATE(4765),
    [sym_uint16] = STATE(4765),
    [sym_int32] = STATE(4765),
    [sym_uint32] = STATE(4765),
    [sym_nativeint] = STATE(4765),
    [sym_unativeint] = STATE(4765),
    [sym_int64] = STATE(4765),
    [sym_uint64] = STATE(4765),
    [sym_ieee32] = STATE(4765),
    [sym_ieee64] = STATE(4765),
    [sym_bignum] = STATE(4765),
    [sym_decimal] = STATE(4765),
    [sym_float] = STATE(4512),
    [sym_block_comment] = STATE(2620),
    [sym_compiler_directive_decl] = STATE(2620),
    [sym_fsi_directive_decl] = STATE(2620),
    [sym_preproc_line] = STATE(2620),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(4196),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_LPAREN] = ACTIONS(3572),
    [anon_sym_null] = ACTIONS(3574),
    [anon_sym__] = ACTIONS(3576),
    [anon_sym_QMARK] = ACTIONS(4202),
    [anon_sym_COLON_QMARK] = ACTIONS(4204),
    [anon_sym_LBRACK] = ACTIONS(3582),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3584),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [aux_sym_char_token1] = ACTIONS(3590),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3592),
    [anon_sym_DQUOTE] = ACTIONS(3594),
    [anon_sym_AT_DQUOTE] = ACTIONS(3596),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3598),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3600),
    [sym_bool] = ACTIONS(3602),
    [sym_unit] = ACTIONS(3604),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4212),
    [sym_op_identifier] = ACTIONS(4214),
    [sym_int] = ACTIONS(3610),
    [sym_xint] = ACTIONS(3612),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2621] = {
    [sym_attributes] = STATE(2689),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(3731),
    [sym__pattern] = STATE(3592),
    [sym_optional_pattern] = STATE(3731),
    [sym_type_check_pattern] = STATE(3731),
    [sym_attribute_pattern] = STATE(3731),
    [sym_paren_pattern] = STATE(3731),
    [sym_as_pattern] = STATE(3731),
    [sym_cons_pattern] = STATE(3731),
    [sym_disjunct_pattern] = STATE(3731),
    [sym_conjunct_pattern] = STATE(3731),
    [sym_typed_pattern] = STATE(3731),
    [sym_list_pattern] = STATE(3731),
    [sym_array_pattern] = STATE(3731),
    [sym_record_pattern] = STATE(3731),
    [sym_named_field_pattern] = STATE(3731),
    [sym_identifier_pattern] = STATE(3731),
    [sym_long_identifier_or_op] = STATE(2472),
    [sym_char] = STATE(3709),
    [sym_format_string] = STATE(3712),
    [sym__string_literal] = STATE(3712),
    [sym_string] = STATE(3709),
    [sym_verbatim_string] = STATE(3709),
    [sym_bytearray] = STATE(3709),
    [sym_verbatim_bytearray] = STATE(3709),
    [sym_format_triple_quoted_string] = STATE(3716),
    [sym_triple_quoted_string] = STATE(3709),
    [sym_const] = STATE(3731),
    [sym_long_identifier] = STATE(3655),
    [sym_active_pattern] = STATE(3734),
    [sym__identifier_or_op] = STATE(3737),
    [sym_sbyte] = STATE(3709),
    [sym_byte] = STATE(3709),
    [sym_int16] = STATE(3709),
    [sym_uint16] = STATE(3709),
    [sym_int32] = STATE(3709),
    [sym_uint32] = STATE(3709),
    [sym_nativeint] = STATE(3709),
    [sym_unativeint] = STATE(3709),
    [sym_int64] = STATE(3709),
    [sym_uint64] = STATE(3709),
    [sym_ieee32] = STATE(3709),
    [sym_ieee64] = STATE(3709),
    [sym_bignum] = STATE(3709),
    [sym_decimal] = STATE(3709),
    [sym_float] = STATE(3489),
    [sym_block_comment] = STATE(2621),
    [sym_compiler_directive_decl] = STATE(2621),
    [sym_fsi_directive_decl] = STATE(2621),
    [sym_preproc_line] = STATE(2621),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(4196),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_LPAREN] = ACTIONS(4308),
    [anon_sym_null] = ACTIONS(4310),
    [anon_sym__] = ACTIONS(4312),
    [anon_sym_QMARK] = ACTIONS(4314),
    [anon_sym_COLON_QMARK] = ACTIONS(4316),
    [anon_sym_LBRACK] = ACTIONS(4318),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4320),
    [anon_sym_LBRACE] = ACTIONS(4322),
    [aux_sym_char_token1] = ACTIONS(4324),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4326),
    [anon_sym_DQUOTE] = ACTIONS(4328),
    [anon_sym_AT_DQUOTE] = ACTIONS(4330),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4332),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4334),
    [sym_bool] = ACTIONS(4336),
    [sym_unit] = ACTIONS(4338),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4212),
    [sym_op_identifier] = ACTIONS(4214),
    [sym_int] = ACTIONS(4340),
    [sym_xint] = ACTIONS(4342),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2622] = {
    [sym_attributes] = STATE(2674),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(5431),
    [sym__pattern] = STATE(5248),
    [sym_optional_pattern] = STATE(5431),
    [sym_type_check_pattern] = STATE(5431),
    [sym_attribute_pattern] = STATE(5431),
    [sym_paren_pattern] = STATE(5431),
    [sym_as_pattern] = STATE(5431),
    [sym_cons_pattern] = STATE(5431),
    [sym_disjunct_pattern] = STATE(5431),
    [sym_conjunct_pattern] = STATE(5431),
    [sym_typed_pattern] = STATE(5431),
    [sym_list_pattern] = STATE(5431),
    [sym_array_pattern] = STATE(5431),
    [sym_record_pattern] = STATE(5431),
    [sym_named_field_pattern] = STATE(5431),
    [sym_identifier_pattern] = STATE(5431),
    [sym_long_identifier_or_op] = STATE(2273),
    [sym_char] = STATE(5475),
    [sym_format_string] = STATE(5423),
    [sym__string_literal] = STATE(5423),
    [sym_string] = STATE(5475),
    [sym_verbatim_string] = STATE(5475),
    [sym_bytearray] = STATE(5475),
    [sym_verbatim_bytearray] = STATE(5475),
    [sym_format_triple_quoted_string] = STATE(5477),
    [sym_triple_quoted_string] = STATE(5475),
    [sym_const] = STATE(5431),
    [sym_long_identifier] = STATE(3437),
    [sym_active_pattern] = STATE(3653),
    [sym__identifier_or_op] = STATE(3660),
    [sym_sbyte] = STATE(5475),
    [sym_byte] = STATE(5475),
    [sym_int16] = STATE(5475),
    [sym_uint16] = STATE(5475),
    [sym_int32] = STATE(5475),
    [sym_uint32] = STATE(5475),
    [sym_nativeint] = STATE(5475),
    [sym_unativeint] = STATE(5475),
    [sym_int64] = STATE(5475),
    [sym_uint64] = STATE(5475),
    [sym_ieee32] = STATE(5475),
    [sym_ieee64] = STATE(5475),
    [sym_bignum] = STATE(5475),
    [sym_decimal] = STATE(5475),
    [sym_float] = STATE(4953),
    [sym_block_comment] = STATE(2622),
    [sym_compiler_directive_decl] = STATE(2622),
    [sym_fsi_directive_decl] = STATE(2622),
    [sym_preproc_line] = STATE(2622),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(4073),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_LPAREN] = ACTIONS(4077),
    [anon_sym_null] = ACTIONS(4081),
    [anon_sym__] = ACTIONS(4083),
    [anon_sym_QMARK] = ACTIONS(4085),
    [anon_sym_COLON_QMARK] = ACTIONS(4087),
    [anon_sym_LBRACK] = ACTIONS(4095),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4097),
    [anon_sym_LBRACE] = ACTIONS(4099),
    [aux_sym_char_token1] = ACTIONS(4101),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4103),
    [anon_sym_DQUOTE] = ACTIONS(4105),
    [anon_sym_AT_DQUOTE] = ACTIONS(4107),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4109),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4111),
    [sym_bool] = ACTIONS(4113),
    [sym_unit] = ACTIONS(4115),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4117),
    [sym_op_identifier] = ACTIONS(4119),
    [sym_int] = ACTIONS(4121),
    [sym_xint] = ACTIONS(4123),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2623] = {
    [sym_attributes] = STATE(2652),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(3588),
    [sym__pattern] = STATE(3541),
    [sym_optional_pattern] = STATE(3588),
    [sym_type_check_pattern] = STATE(3588),
    [sym_attribute_pattern] = STATE(3588),
    [sym_paren_pattern] = STATE(3588),
    [sym_as_pattern] = STATE(3588),
    [sym_cons_pattern] = STATE(3588),
    [sym_disjunct_pattern] = STATE(3588),
    [sym_conjunct_pattern] = STATE(3588),
    [sym_typed_pattern] = STATE(3588),
    [sym_list_pattern] = STATE(3588),
    [sym_array_pattern] = STATE(3588),
    [sym_record_pattern] = STATE(3588),
    [sym_named_field_pattern] = STATE(3588),
    [sym_identifier_pattern] = STATE(3588),
    [sym_long_identifier_or_op] = STATE(2401),
    [sym_char] = STATE(3658),
    [sym_format_string] = STATE(3670),
    [sym__string_literal] = STATE(3670),
    [sym_string] = STATE(3658),
    [sym_verbatim_string] = STATE(3658),
    [sym_bytearray] = STATE(3658),
    [sym_verbatim_bytearray] = STATE(3658),
    [sym_format_triple_quoted_string] = STATE(3673),
    [sym_triple_quoted_string] = STATE(3658),
    [sym_const] = STATE(3588),
    [sym_long_identifier] = STATE(3493),
    [sym_active_pattern] = STATE(3613),
    [sym__identifier_or_op] = STATE(3650),
    [sym_sbyte] = STATE(3658),
    [sym_byte] = STATE(3658),
    [sym_int16] = STATE(3658),
    [sym_uint16] = STATE(3658),
    [sym_int32] = STATE(3658),
    [sym_uint32] = STATE(3658),
    [sym_nativeint] = STATE(3658),
    [sym_unativeint] = STATE(3658),
    [sym_int64] = STATE(3658),
    [sym_uint64] = STATE(3658),
    [sym_ieee32] = STATE(3658),
    [sym_ieee64] = STATE(3658),
    [sym_bignum] = STATE(3658),
    [sym_decimal] = STATE(3658),
    [sym_float] = STATE(3376),
    [sym_block_comment] = STATE(2623),
    [sym_compiler_directive_decl] = STATE(2623),
    [sym_fsi_directive_decl] = STATE(2623),
    [sym_preproc_line] = STATE(2623),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(4175),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_LPAREN] = ACTIONS(4218),
    [anon_sym_null] = ACTIONS(4220),
    [anon_sym__] = ACTIONS(4222),
    [anon_sym_QMARK] = ACTIONS(4224),
    [anon_sym_COLON_QMARK] = ACTIONS(4226),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4230),
    [anon_sym_LBRACE] = ACTIONS(4232),
    [aux_sym_char_token1] = ACTIONS(4234),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4236),
    [anon_sym_DQUOTE] = ACTIONS(4238),
    [anon_sym_AT_DQUOTE] = ACTIONS(4240),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4242),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4244),
    [sym_bool] = ACTIONS(4246),
    [sym_unit] = ACTIONS(4248),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4181),
    [sym_op_identifier] = ACTIONS(4183),
    [sym_int] = ACTIONS(4250),
    [sym_xint] = ACTIONS(4252),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2624] = {
    [sym_attributes] = STATE(2641),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(5241),
    [sym__pattern] = STATE(5159),
    [sym_optional_pattern] = STATE(5241),
    [sym_type_check_pattern] = STATE(5241),
    [sym_attribute_pattern] = STATE(5241),
    [sym_paren_pattern] = STATE(5241),
    [sym_as_pattern] = STATE(5241),
    [sym_cons_pattern] = STATE(5241),
    [sym_disjunct_pattern] = STATE(5241),
    [sym_conjunct_pattern] = STATE(5241),
    [sym_typed_pattern] = STATE(5241),
    [sym_list_pattern] = STATE(5241),
    [sym_array_pattern] = STATE(5241),
    [sym_record_pattern] = STATE(5241),
    [sym_named_field_pattern] = STATE(5241),
    [sym_identifier_pattern] = STATE(5241),
    [sym_long_identifier_or_op] = STATE(1721),
    [sym_char] = STATE(5389),
    [sym_format_string] = STATE(5273),
    [sym__string_literal] = STATE(5273),
    [sym_string] = STATE(5389),
    [sym_verbatim_string] = STATE(5389),
    [sym_bytearray] = STATE(5389),
    [sym_verbatim_bytearray] = STATE(5389),
    [sym_format_triple_quoted_string] = STATE(5377),
    [sym_triple_quoted_string] = STATE(5389),
    [sym_const] = STATE(5241),
    [sym_long_identifier] = STATE(3363),
    [sym_active_pattern] = STATE(3521),
    [sym__identifier_or_op] = STATE(3510),
    [sym_sbyte] = STATE(5389),
    [sym_byte] = STATE(5389),
    [sym_int16] = STATE(5389),
    [sym_uint16] = STATE(5389),
    [sym_int32] = STATE(5389),
    [sym_uint32] = STATE(5389),
    [sym_nativeint] = STATE(5389),
    [sym_unativeint] = STATE(5389),
    [sym_int64] = STATE(5389),
    [sym_uint64] = STATE(5389),
    [sym_ieee32] = STATE(5389),
    [sym_ieee64] = STATE(5389),
    [sym_bignum] = STATE(5389),
    [sym_decimal] = STATE(5389),
    [sym_float] = STATE(4893),
    [sym_block_comment] = STATE(2624),
    [sym_compiler_directive_decl] = STATE(2624),
    [sym_fsi_directive_decl] = STATE(2624),
    [sym_preproc_line] = STATE(2624),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(3870),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_LPAREN] = ACTIONS(3872),
    [anon_sym_null] = ACTIONS(3874),
    [anon_sym__] = ACTIONS(3876),
    [anon_sym_QMARK] = ACTIONS(3878),
    [anon_sym_COLON_QMARK] = ACTIONS(3880),
    [anon_sym_LBRACK] = ACTIONS(3882),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3884),
    [anon_sym_LBRACE] = ACTIONS(3886),
    [aux_sym_char_token1] = ACTIONS(3888),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3890),
    [anon_sym_DQUOTE] = ACTIONS(3892),
    [anon_sym_AT_DQUOTE] = ACTIONS(3894),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3896),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3898),
    [sym_bool] = ACTIONS(3900),
    [sym_unit] = ACTIONS(3902),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3904),
    [sym_op_identifier] = ACTIONS(3906),
    [sym_int] = ACTIONS(3908),
    [sym_xint] = ACTIONS(3910),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2625] = {
    [sym_attributes] = STATE(2636),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(3546),
    [sym__pattern] = STATE(3391),
    [sym_optional_pattern] = STATE(3546),
    [sym_type_check_pattern] = STATE(3546),
    [sym_attribute_pattern] = STATE(3546),
    [sym_paren_pattern] = STATE(3546),
    [sym_as_pattern] = STATE(3546),
    [sym_cons_pattern] = STATE(3546),
    [sym_disjunct_pattern] = STATE(3546),
    [sym_conjunct_pattern] = STATE(3546),
    [sym_typed_pattern] = STATE(3546),
    [sym_list_pattern] = STATE(3546),
    [sym_array_pattern] = STATE(3546),
    [sym_record_pattern] = STATE(3546),
    [sym_named_field_pattern] = STATE(3546),
    [sym_identifier_pattern] = STATE(3546),
    [sym_long_identifier_or_op] = STATE(1834),
    [sym_char] = STATE(3509),
    [sym_format_string] = STATE(3517),
    [sym__string_literal] = STATE(3517),
    [sym_string] = STATE(3509),
    [sym_verbatim_string] = STATE(3509),
    [sym_bytearray] = STATE(3509),
    [sym_verbatim_bytearray] = STATE(3509),
    [sym_format_triple_quoted_string] = STATE(3519),
    [sym_triple_quoted_string] = STATE(3509),
    [sym_const] = STATE(3546),
    [sym_long_identifier] = STATE(3320),
    [sym_active_pattern] = STATE(3488),
    [sym__identifier_or_op] = STATE(3410),
    [sym_sbyte] = STATE(3509),
    [sym_byte] = STATE(3509),
    [sym_int16] = STATE(3509),
    [sym_uint16] = STATE(3509),
    [sym_int32] = STATE(3509),
    [sym_uint32] = STATE(3509),
    [sym_nativeint] = STATE(3509),
    [sym_unativeint] = STATE(3509),
    [sym_int64] = STATE(3509),
    [sym_uint64] = STATE(3509),
    [sym_ieee32] = STATE(3509),
    [sym_ieee64] = STATE(3509),
    [sym_bignum] = STATE(3509),
    [sym_decimal] = STATE(3509),
    [sym_float] = STATE(3291),
    [sym_block_comment] = STATE(2625),
    [sym_compiler_directive_decl] = STATE(2625),
    [sym_fsi_directive_decl] = STATE(2625),
    [sym_preproc_line] = STATE(2625),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(3562),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_LPAREN] = ACTIONS(4014),
    [anon_sym_null] = ACTIONS(4016),
    [anon_sym__] = ACTIONS(4018),
    [anon_sym_QMARK] = ACTIONS(4020),
    [anon_sym_COLON_QMARK] = ACTIONS(4022),
    [anon_sym_LBRACK] = ACTIONS(4024),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4026),
    [anon_sym_LBRACE] = ACTIONS(4028),
    [aux_sym_char_token1] = ACTIONS(4030),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4032),
    [anon_sym_DQUOTE] = ACTIONS(4034),
    [anon_sym_AT_DQUOTE] = ACTIONS(4036),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4038),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4040),
    [sym_bool] = ACTIONS(4042),
    [sym_unit] = ACTIONS(4044),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3606),
    [sym_op_identifier] = ACTIONS(3608),
    [sym_int] = ACTIONS(4046),
    [sym_xint] = ACTIONS(4048),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2626] = {
    [sym_attributes] = STATE(2698),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(3506),
    [sym__pattern] = STATE(3395),
    [sym_optional_pattern] = STATE(3506),
    [sym_type_check_pattern] = STATE(3506),
    [sym_attribute_pattern] = STATE(3506),
    [sym_paren_pattern] = STATE(3506),
    [sym_as_pattern] = STATE(3506),
    [sym_cons_pattern] = STATE(3506),
    [sym_disjunct_pattern] = STATE(3506),
    [sym_conjunct_pattern] = STATE(3506),
    [sym_typed_pattern] = STATE(3506),
    [sym_list_pattern] = STATE(3506),
    [sym_array_pattern] = STATE(3506),
    [sym_record_pattern] = STATE(3506),
    [sym_named_field_pattern] = STATE(3506),
    [sym_identifier_pattern] = STATE(3506),
    [sym_long_identifier_or_op] = STATE(1864),
    [sym_char] = STATE(3497),
    [sym_format_string] = STATE(3495),
    [sym__string_literal] = STATE(3495),
    [sym_string] = STATE(3497),
    [sym_verbatim_string] = STATE(3497),
    [sym_bytearray] = STATE(3497),
    [sym_verbatim_bytearray] = STATE(3497),
    [sym_format_triple_quoted_string] = STATE(3494),
    [sym_triple_quoted_string] = STATE(3497),
    [sym_const] = STATE(3506),
    [sym_long_identifier] = STATE(3363),
    [sym_active_pattern] = STATE(3521),
    [sym__identifier_or_op] = STATE(3510),
    [sym_sbyte] = STATE(3497),
    [sym_byte] = STATE(3497),
    [sym_int16] = STATE(3497),
    [sym_uint16] = STATE(3497),
    [sym_int32] = STATE(3497),
    [sym_uint32] = STATE(3497),
    [sym_nativeint] = STATE(3497),
    [sym_unativeint] = STATE(3497),
    [sym_int64] = STATE(3497),
    [sym_uint64] = STATE(3497),
    [sym_ieee32] = STATE(3497),
    [sym_ieee64] = STATE(3497),
    [sym_bignum] = STATE(3497),
    [sym_decimal] = STATE(3497),
    [sym_float] = STATE(3305),
    [sym_block_comment] = STATE(2626),
    [sym_compiler_directive_decl] = STATE(2626),
    [sym_fsi_directive_decl] = STATE(2626),
    [sym_preproc_line] = STATE(2626),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(3870),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_LPAREN] = ACTIONS(3962),
    [anon_sym_null] = ACTIONS(3966),
    [anon_sym__] = ACTIONS(3968),
    [anon_sym_QMARK] = ACTIONS(3970),
    [anon_sym_COLON_QMARK] = ACTIONS(3972),
    [anon_sym_LBRACK] = ACTIONS(3974),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3976),
    [anon_sym_LBRACE] = ACTIONS(3978),
    [aux_sym_char_token1] = ACTIONS(3980),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3982),
    [anon_sym_DQUOTE] = ACTIONS(3984),
    [anon_sym_AT_DQUOTE] = ACTIONS(3986),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3988),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3990),
    [sym_bool] = ACTIONS(3992),
    [sym_unit] = ACTIONS(3994),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3904),
    [sym_op_identifier] = ACTIONS(3906),
    [sym_int] = ACTIONS(3996),
    [sym_xint] = ACTIONS(3998),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2627] = {
    [sym_attributes] = STATE(2630),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(3640),
    [sym__pattern] = STATE(3496),
    [sym_optional_pattern] = STATE(3640),
    [sym_type_check_pattern] = STATE(3640),
    [sym_attribute_pattern] = STATE(3640),
    [sym_paren_pattern] = STATE(3640),
    [sym_as_pattern] = STATE(3640),
    [sym_cons_pattern] = STATE(3640),
    [sym_disjunct_pattern] = STATE(3640),
    [sym_conjunct_pattern] = STATE(3640),
    [sym_typed_pattern] = STATE(3640),
    [sym_list_pattern] = STATE(3640),
    [sym_array_pattern] = STATE(3640),
    [sym_record_pattern] = STATE(3640),
    [sym_named_field_pattern] = STATE(3640),
    [sym_identifier_pattern] = STATE(3640),
    [sym_long_identifier_or_op] = STATE(2393),
    [sym_char] = STATE(3606),
    [sym_format_string] = STATE(3688),
    [sym__string_literal] = STATE(3688),
    [sym_string] = STATE(3606),
    [sym_verbatim_string] = STATE(3606),
    [sym_bytearray] = STATE(3606),
    [sym_verbatim_bytearray] = STATE(3606),
    [sym_format_triple_quoted_string] = STATE(3686),
    [sym_triple_quoted_string] = STATE(3606),
    [sym_const] = STATE(3640),
    [sym_long_identifier] = STATE(3437),
    [sym_active_pattern] = STATE(3653),
    [sym__identifier_or_op] = STATE(3660),
    [sym_sbyte] = STATE(3606),
    [sym_byte] = STATE(3606),
    [sym_int16] = STATE(3606),
    [sym_uint16] = STATE(3606),
    [sym_int32] = STATE(3606),
    [sym_uint32] = STATE(3606),
    [sym_nativeint] = STATE(3606),
    [sym_unativeint] = STATE(3606),
    [sym_int64] = STATE(3606),
    [sym_uint64] = STATE(3606),
    [sym_ieee32] = STATE(3606),
    [sym_ieee64] = STATE(3606),
    [sym_bignum] = STATE(3606),
    [sym_decimal] = STATE(3606),
    [sym_float] = STATE(3332),
    [sym_block_comment] = STATE(2627),
    [sym_compiler_directive_decl] = STATE(2627),
    [sym_fsi_directive_decl] = STATE(2627),
    [sym_preproc_line] = STATE(2627),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(4073),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_LPAREN] = ACTIONS(4256),
    [anon_sym_null] = ACTIONS(4258),
    [anon_sym__] = ACTIONS(4260),
    [anon_sym_QMARK] = ACTIONS(4262),
    [anon_sym_COLON_QMARK] = ACTIONS(4264),
    [anon_sym_LBRACK] = ACTIONS(4266),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4268),
    [anon_sym_LBRACE] = ACTIONS(4270),
    [aux_sym_char_token1] = ACTIONS(4272),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4274),
    [anon_sym_DQUOTE] = ACTIONS(4276),
    [anon_sym_AT_DQUOTE] = ACTIONS(4278),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4280),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4282),
    [sym_bool] = ACTIONS(4284),
    [sym_unit] = ACTIONS(4286),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4117),
    [sym_op_identifier] = ACTIONS(4119),
    [sym_int] = ACTIONS(4288),
    [sym_xint] = ACTIONS(4290),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2628] = {
    [sym_attributes] = STATE(2698),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(3506),
    [sym__pattern] = STATE(3398),
    [sym_optional_pattern] = STATE(3506),
    [sym_type_check_pattern] = STATE(3506),
    [sym_attribute_pattern] = STATE(3506),
    [sym_paren_pattern] = STATE(3506),
    [sym_as_pattern] = STATE(3506),
    [sym_cons_pattern] = STATE(3506),
    [sym_disjunct_pattern] = STATE(3506),
    [sym_conjunct_pattern] = STATE(3506),
    [sym_typed_pattern] = STATE(3506),
    [sym_list_pattern] = STATE(3506),
    [sym_array_pattern] = STATE(3506),
    [sym_record_pattern] = STATE(3506),
    [sym_named_field_pattern] = STATE(3506),
    [sym_identifier_pattern] = STATE(3506),
    [sym_long_identifier_or_op] = STATE(1864),
    [sym_char] = STATE(3497),
    [sym_format_string] = STATE(3495),
    [sym__string_literal] = STATE(3495),
    [sym_string] = STATE(3497),
    [sym_verbatim_string] = STATE(3497),
    [sym_bytearray] = STATE(3497),
    [sym_verbatim_bytearray] = STATE(3497),
    [sym_format_triple_quoted_string] = STATE(3494),
    [sym_triple_quoted_string] = STATE(3497),
    [sym_const] = STATE(3506),
    [sym_long_identifier] = STATE(3363),
    [sym_active_pattern] = STATE(3521),
    [sym__identifier_or_op] = STATE(3510),
    [sym_sbyte] = STATE(3497),
    [sym_byte] = STATE(3497),
    [sym_int16] = STATE(3497),
    [sym_uint16] = STATE(3497),
    [sym_int32] = STATE(3497),
    [sym_uint32] = STATE(3497),
    [sym_nativeint] = STATE(3497),
    [sym_unativeint] = STATE(3497),
    [sym_int64] = STATE(3497),
    [sym_uint64] = STATE(3497),
    [sym_ieee32] = STATE(3497),
    [sym_ieee64] = STATE(3497),
    [sym_bignum] = STATE(3497),
    [sym_decimal] = STATE(3497),
    [sym_float] = STATE(3305),
    [sym_block_comment] = STATE(2628),
    [sym_compiler_directive_decl] = STATE(2628),
    [sym_fsi_directive_decl] = STATE(2628),
    [sym_preproc_line] = STATE(2628),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(3870),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_LPAREN] = ACTIONS(3962),
    [anon_sym_null] = ACTIONS(3966),
    [anon_sym__] = ACTIONS(3968),
    [anon_sym_QMARK] = ACTIONS(3970),
    [anon_sym_COLON_QMARK] = ACTIONS(3972),
    [anon_sym_LBRACK] = ACTIONS(3974),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3976),
    [anon_sym_LBRACE] = ACTIONS(3978),
    [aux_sym_char_token1] = ACTIONS(3980),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3982),
    [anon_sym_DQUOTE] = ACTIONS(3984),
    [anon_sym_AT_DQUOTE] = ACTIONS(3986),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3988),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3990),
    [sym_bool] = ACTIONS(3992),
    [sym_unit] = ACTIONS(3994),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3904),
    [sym_op_identifier] = ACTIONS(3906),
    [sym_int] = ACTIONS(3996),
    [sym_xint] = ACTIONS(3998),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2629] = {
    [sym_attributes] = STATE(2632),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(4815),
    [sym__pattern] = STATE(5425),
    [sym_optional_pattern] = STATE(4815),
    [sym_type_check_pattern] = STATE(4815),
    [sym_attribute_pattern] = STATE(4815),
    [sym_paren_pattern] = STATE(4815),
    [sym_as_pattern] = STATE(4815),
    [sym_cons_pattern] = STATE(4815),
    [sym_disjunct_pattern] = STATE(4815),
    [sym_conjunct_pattern] = STATE(4815),
    [sym_typed_pattern] = STATE(4815),
    [sym_list_pattern] = STATE(4815),
    [sym_array_pattern] = STATE(4815),
    [sym_record_pattern] = STATE(4815),
    [sym_named_field_pattern] = STATE(4815),
    [sym_identifier_pattern] = STATE(4815),
    [sym_long_identifier_or_op] = STATE(2475),
    [sym_char] = STATE(4765),
    [sym_format_string] = STATE(4746),
    [sym__string_literal] = STATE(4746),
    [sym_string] = STATE(4765),
    [sym_verbatim_string] = STATE(4765),
    [sym_bytearray] = STATE(4765),
    [sym_verbatim_bytearray] = STATE(4765),
    [sym_format_triple_quoted_string] = STATE(4720),
    [sym_triple_quoted_string] = STATE(4765),
    [sym_const] = STATE(4815),
    [sym_long_identifier] = STATE(3655),
    [sym_active_pattern] = STATE(3734),
    [sym__identifier_or_op] = STATE(3737),
    [sym_sbyte] = STATE(4765),
    [sym_byte] = STATE(4765),
    [sym_int16] = STATE(4765),
    [sym_uint16] = STATE(4765),
    [sym_int32] = STATE(4765),
    [sym_uint32] = STATE(4765),
    [sym_nativeint] = STATE(4765),
    [sym_unativeint] = STATE(4765),
    [sym_int64] = STATE(4765),
    [sym_uint64] = STATE(4765),
    [sym_ieee32] = STATE(4765),
    [sym_ieee64] = STATE(4765),
    [sym_bignum] = STATE(4765),
    [sym_decimal] = STATE(4765),
    [sym_float] = STATE(4512),
    [sym_block_comment] = STATE(2629),
    [sym_compiler_directive_decl] = STATE(2629),
    [sym_fsi_directive_decl] = STATE(2629),
    [sym_preproc_line] = STATE(2629),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(4474),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_LPAREN] = ACTIONS(3572),
    [anon_sym_null] = ACTIONS(3574),
    [anon_sym__] = ACTIONS(3576),
    [anon_sym_QMARK] = ACTIONS(4202),
    [anon_sym_COLON_QMARK] = ACTIONS(4204),
    [anon_sym_LBRACK] = ACTIONS(3582),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3584),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [aux_sym_char_token1] = ACTIONS(3590),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3592),
    [anon_sym_DQUOTE] = ACTIONS(3594),
    [anon_sym_AT_DQUOTE] = ACTIONS(3596),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3598),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3600),
    [sym_bool] = ACTIONS(3602),
    [sym_unit] = ACTIONS(3604),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4212),
    [sym_op_identifier] = ACTIONS(4214),
    [sym_int] = ACTIONS(3610),
    [sym_xint] = ACTIONS(3612),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2630] = {
    [sym_attributes] = STATE(2630),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(3640),
    [sym__pattern] = STATE(3475),
    [sym_optional_pattern] = STATE(3640),
    [sym_type_check_pattern] = STATE(3640),
    [sym_attribute_pattern] = STATE(3640),
    [sym_paren_pattern] = STATE(3640),
    [sym_as_pattern] = STATE(3640),
    [sym_cons_pattern] = STATE(3640),
    [sym_disjunct_pattern] = STATE(3640),
    [sym_conjunct_pattern] = STATE(3640),
    [sym_typed_pattern] = STATE(3640),
    [sym_list_pattern] = STATE(3640),
    [sym_array_pattern] = STATE(3640),
    [sym_record_pattern] = STATE(3640),
    [sym_named_field_pattern] = STATE(3640),
    [sym_identifier_pattern] = STATE(3640),
    [sym_long_identifier_or_op] = STATE(2393),
    [sym_char] = STATE(3606),
    [sym_format_string] = STATE(3688),
    [sym__string_literal] = STATE(3688),
    [sym_string] = STATE(3606),
    [sym_verbatim_string] = STATE(3606),
    [sym_bytearray] = STATE(3606),
    [sym_verbatim_bytearray] = STATE(3606),
    [sym_format_triple_quoted_string] = STATE(3686),
    [sym_triple_quoted_string] = STATE(3606),
    [sym_const] = STATE(3640),
    [sym_long_identifier] = STATE(3437),
    [sym_active_pattern] = STATE(3653),
    [sym__identifier_or_op] = STATE(3660),
    [sym_sbyte] = STATE(3606),
    [sym_byte] = STATE(3606),
    [sym_int16] = STATE(3606),
    [sym_uint16] = STATE(3606),
    [sym_int32] = STATE(3606),
    [sym_uint32] = STATE(3606),
    [sym_nativeint] = STATE(3606),
    [sym_unativeint] = STATE(3606),
    [sym_int64] = STATE(3606),
    [sym_uint64] = STATE(3606),
    [sym_ieee32] = STATE(3606),
    [sym_ieee64] = STATE(3606),
    [sym_bignum] = STATE(3606),
    [sym_decimal] = STATE(3606),
    [sym_float] = STATE(3332),
    [sym_block_comment] = STATE(2630),
    [sym_compiler_directive_decl] = STATE(2630),
    [sym_fsi_directive_decl] = STATE(2630),
    [sym_preproc_line] = STATE(2630),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(4073),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_LPAREN] = ACTIONS(4256),
    [anon_sym_null] = ACTIONS(4258),
    [anon_sym__] = ACTIONS(4260),
    [anon_sym_QMARK] = ACTIONS(4262),
    [anon_sym_COLON_QMARK] = ACTIONS(4264),
    [anon_sym_LBRACK] = ACTIONS(4266),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4268),
    [anon_sym_LBRACE] = ACTIONS(4270),
    [aux_sym_char_token1] = ACTIONS(4272),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4274),
    [anon_sym_DQUOTE] = ACTIONS(4276),
    [anon_sym_AT_DQUOTE] = ACTIONS(4278),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4280),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4282),
    [sym_bool] = ACTIONS(4284),
    [sym_unit] = ACTIONS(4286),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4117),
    [sym_op_identifier] = ACTIONS(4119),
    [sym_int] = ACTIONS(4288),
    [sym_xint] = ACTIONS(4290),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2631] = {
    [sym_attributes] = STATE(2632),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(4815),
    [sym__pattern] = STATE(5440),
    [sym_optional_pattern] = STATE(4815),
    [sym_type_check_pattern] = STATE(4815),
    [sym_attribute_pattern] = STATE(4815),
    [sym_paren_pattern] = STATE(4815),
    [sym_as_pattern] = STATE(4815),
    [sym_cons_pattern] = STATE(4815),
    [sym_disjunct_pattern] = STATE(4815),
    [sym_conjunct_pattern] = STATE(4815),
    [sym_typed_pattern] = STATE(4815),
    [sym_list_pattern] = STATE(4815),
    [sym_array_pattern] = STATE(4815),
    [sym_record_pattern] = STATE(4815),
    [sym_named_field_pattern] = STATE(4815),
    [sym_identifier_pattern] = STATE(4815),
    [sym_long_identifier_or_op] = STATE(2475),
    [sym_char] = STATE(4765),
    [sym_format_string] = STATE(4746),
    [sym__string_literal] = STATE(4746),
    [sym_string] = STATE(4765),
    [sym_verbatim_string] = STATE(4765),
    [sym_bytearray] = STATE(4765),
    [sym_verbatim_bytearray] = STATE(4765),
    [sym_format_triple_quoted_string] = STATE(4720),
    [sym_triple_quoted_string] = STATE(4765),
    [sym_const] = STATE(4815),
    [sym_long_identifier] = STATE(3655),
    [sym_active_pattern] = STATE(3734),
    [sym__identifier_or_op] = STATE(3737),
    [sym_sbyte] = STATE(4765),
    [sym_byte] = STATE(4765),
    [sym_int16] = STATE(4765),
    [sym_uint16] = STATE(4765),
    [sym_int32] = STATE(4765),
    [sym_uint32] = STATE(4765),
    [sym_nativeint] = STATE(4765),
    [sym_unativeint] = STATE(4765),
    [sym_int64] = STATE(4765),
    [sym_uint64] = STATE(4765),
    [sym_ieee32] = STATE(4765),
    [sym_ieee64] = STATE(4765),
    [sym_bignum] = STATE(4765),
    [sym_decimal] = STATE(4765),
    [sym_float] = STATE(4512),
    [sym_block_comment] = STATE(2631),
    [sym_compiler_directive_decl] = STATE(2631),
    [sym_fsi_directive_decl] = STATE(2631),
    [sym_preproc_line] = STATE(2631),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(4476),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_LPAREN] = ACTIONS(3572),
    [anon_sym_null] = ACTIONS(3574),
    [anon_sym__] = ACTIONS(3576),
    [anon_sym_QMARK] = ACTIONS(4202),
    [anon_sym_COLON_QMARK] = ACTIONS(4204),
    [anon_sym_LBRACK] = ACTIONS(3582),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3584),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [aux_sym_char_token1] = ACTIONS(3590),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3592),
    [anon_sym_DQUOTE] = ACTIONS(3594),
    [anon_sym_AT_DQUOTE] = ACTIONS(3596),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3598),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3600),
    [sym_bool] = ACTIONS(3602),
    [sym_unit] = ACTIONS(3604),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4212),
    [sym_op_identifier] = ACTIONS(4214),
    [sym_int] = ACTIONS(3610),
    [sym_xint] = ACTIONS(3612),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2632] = {
    [sym_attributes] = STATE(2632),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(4815),
    [sym__pattern] = STATE(5442),
    [sym_optional_pattern] = STATE(4815),
    [sym_type_check_pattern] = STATE(4815),
    [sym_attribute_pattern] = STATE(4815),
    [sym_paren_pattern] = STATE(4815),
    [sym_as_pattern] = STATE(4815),
    [sym_cons_pattern] = STATE(4815),
    [sym_disjunct_pattern] = STATE(4815),
    [sym_conjunct_pattern] = STATE(4815),
    [sym_typed_pattern] = STATE(4815),
    [sym_list_pattern] = STATE(4815),
    [sym_array_pattern] = STATE(4815),
    [sym_record_pattern] = STATE(4815),
    [sym_named_field_pattern] = STATE(4815),
    [sym_identifier_pattern] = STATE(4815),
    [sym_long_identifier_or_op] = STATE(2475),
    [sym_char] = STATE(4765),
    [sym_format_string] = STATE(4746),
    [sym__string_literal] = STATE(4746),
    [sym_string] = STATE(4765),
    [sym_verbatim_string] = STATE(4765),
    [sym_bytearray] = STATE(4765),
    [sym_verbatim_bytearray] = STATE(4765),
    [sym_format_triple_quoted_string] = STATE(4720),
    [sym_triple_quoted_string] = STATE(4765),
    [sym_const] = STATE(4815),
    [sym_long_identifier] = STATE(3655),
    [sym_active_pattern] = STATE(3734),
    [sym__identifier_or_op] = STATE(3737),
    [sym_sbyte] = STATE(4765),
    [sym_byte] = STATE(4765),
    [sym_int16] = STATE(4765),
    [sym_uint16] = STATE(4765),
    [sym_int32] = STATE(4765),
    [sym_uint32] = STATE(4765),
    [sym_nativeint] = STATE(4765),
    [sym_unativeint] = STATE(4765),
    [sym_int64] = STATE(4765),
    [sym_uint64] = STATE(4765),
    [sym_ieee32] = STATE(4765),
    [sym_ieee64] = STATE(4765),
    [sym_bignum] = STATE(4765),
    [sym_decimal] = STATE(4765),
    [sym_float] = STATE(4512),
    [sym_block_comment] = STATE(2632),
    [sym_compiler_directive_decl] = STATE(2632),
    [sym_fsi_directive_decl] = STATE(2632),
    [sym_preproc_line] = STATE(2632),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(4196),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_LPAREN] = ACTIONS(3572),
    [anon_sym_null] = ACTIONS(3574),
    [anon_sym__] = ACTIONS(3576),
    [anon_sym_QMARK] = ACTIONS(4202),
    [anon_sym_COLON_QMARK] = ACTIONS(4204),
    [anon_sym_LBRACK] = ACTIONS(3582),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3584),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [aux_sym_char_token1] = ACTIONS(3590),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3592),
    [anon_sym_DQUOTE] = ACTIONS(3594),
    [anon_sym_AT_DQUOTE] = ACTIONS(3596),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3598),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3600),
    [sym_bool] = ACTIONS(3602),
    [sym_unit] = ACTIONS(3604),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4212),
    [sym_op_identifier] = ACTIONS(4214),
    [sym_int] = ACTIONS(3610),
    [sym_xint] = ACTIONS(3612),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2633] = {
    [sym_attributes] = STATE(2676),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(4815),
    [sym__pattern] = STATE(5078),
    [sym_optional_pattern] = STATE(4815),
    [sym_type_check_pattern] = STATE(4815),
    [sym_attribute_pattern] = STATE(4815),
    [sym_paren_pattern] = STATE(4815),
    [sym_as_pattern] = STATE(4815),
    [sym_cons_pattern] = STATE(4815),
    [sym_disjunct_pattern] = STATE(4815),
    [sym_conjunct_pattern] = STATE(4815),
    [sym_typed_pattern] = STATE(4815),
    [sym_list_pattern] = STATE(4815),
    [sym_array_pattern] = STATE(4815),
    [sym_record_pattern] = STATE(4815),
    [sym_named_field_pattern] = STATE(4815),
    [sym_identifier_pattern] = STATE(4815),
    [sym_long_identifier_or_op] = STATE(1792),
    [sym_char] = STATE(4765),
    [sym_format_string] = STATE(4746),
    [sym__string_literal] = STATE(4746),
    [sym_string] = STATE(4765),
    [sym_verbatim_string] = STATE(4765),
    [sym_bytearray] = STATE(4765),
    [sym_verbatim_bytearray] = STATE(4765),
    [sym_format_triple_quoted_string] = STATE(4720),
    [sym_triple_quoted_string] = STATE(4765),
    [sym_const] = STATE(4815),
    [sym_long_identifier] = STATE(3320),
    [sym_active_pattern] = STATE(3488),
    [sym__identifier_or_op] = STATE(3410),
    [sym_sbyte] = STATE(4765),
    [sym_byte] = STATE(4765),
    [sym_int16] = STATE(4765),
    [sym_uint16] = STATE(4765),
    [sym_int32] = STATE(4765),
    [sym_uint32] = STATE(4765),
    [sym_nativeint] = STATE(4765),
    [sym_unativeint] = STATE(4765),
    [sym_int64] = STATE(4765),
    [sym_uint64] = STATE(4765),
    [sym_ieee32] = STATE(4765),
    [sym_ieee64] = STATE(4765),
    [sym_bignum] = STATE(4765),
    [sym_decimal] = STATE(4765),
    [sym_float] = STATE(4512),
    [sym_block_comment] = STATE(2633),
    [sym_compiler_directive_decl] = STATE(2633),
    [sym_fsi_directive_decl] = STATE(2633),
    [sym_preproc_line] = STATE(2633),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(3562),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_LPAREN] = ACTIONS(3572),
    [anon_sym_null] = ACTIONS(3574),
    [anon_sym__] = ACTIONS(3576),
    [anon_sym_QMARK] = ACTIONS(3578),
    [anon_sym_COLON_QMARK] = ACTIONS(3580),
    [anon_sym_LBRACK] = ACTIONS(3582),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3584),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [aux_sym_char_token1] = ACTIONS(3590),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3592),
    [anon_sym_DQUOTE] = ACTIONS(3594),
    [anon_sym_AT_DQUOTE] = ACTIONS(3596),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3598),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3600),
    [sym_bool] = ACTIONS(3602),
    [sym_unit] = ACTIONS(3604),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3606),
    [sym_op_identifier] = ACTIONS(3608),
    [sym_int] = ACTIONS(3610),
    [sym_xint] = ACTIONS(3612),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2634] = {
    [sym_attributes] = STATE(2689),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(3731),
    [sym__pattern] = STATE(3594),
    [sym_optional_pattern] = STATE(3731),
    [sym_type_check_pattern] = STATE(3731),
    [sym_attribute_pattern] = STATE(3731),
    [sym_paren_pattern] = STATE(3731),
    [sym_as_pattern] = STATE(3731),
    [sym_cons_pattern] = STATE(3731),
    [sym_disjunct_pattern] = STATE(3731),
    [sym_conjunct_pattern] = STATE(3731),
    [sym_typed_pattern] = STATE(3731),
    [sym_list_pattern] = STATE(3731),
    [sym_array_pattern] = STATE(3731),
    [sym_record_pattern] = STATE(3731),
    [sym_named_field_pattern] = STATE(3731),
    [sym_identifier_pattern] = STATE(3731),
    [sym_long_identifier_or_op] = STATE(2472),
    [sym_char] = STATE(3709),
    [sym_format_string] = STATE(3712),
    [sym__string_literal] = STATE(3712),
    [sym_string] = STATE(3709),
    [sym_verbatim_string] = STATE(3709),
    [sym_bytearray] = STATE(3709),
    [sym_verbatim_bytearray] = STATE(3709),
    [sym_format_triple_quoted_string] = STATE(3716),
    [sym_triple_quoted_string] = STATE(3709),
    [sym_const] = STATE(3731),
    [sym_long_identifier] = STATE(3655),
    [sym_active_pattern] = STATE(3734),
    [sym__identifier_or_op] = STATE(3737),
    [sym_sbyte] = STATE(3709),
    [sym_byte] = STATE(3709),
    [sym_int16] = STATE(3709),
    [sym_uint16] = STATE(3709),
    [sym_int32] = STATE(3709),
    [sym_uint32] = STATE(3709),
    [sym_nativeint] = STATE(3709),
    [sym_unativeint] = STATE(3709),
    [sym_int64] = STATE(3709),
    [sym_uint64] = STATE(3709),
    [sym_ieee32] = STATE(3709),
    [sym_ieee64] = STATE(3709),
    [sym_bignum] = STATE(3709),
    [sym_decimal] = STATE(3709),
    [sym_float] = STATE(3489),
    [sym_block_comment] = STATE(2634),
    [sym_compiler_directive_decl] = STATE(2634),
    [sym_fsi_directive_decl] = STATE(2634),
    [sym_preproc_line] = STATE(2634),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(4196),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_LPAREN] = ACTIONS(4308),
    [anon_sym_null] = ACTIONS(4310),
    [anon_sym__] = ACTIONS(4312),
    [anon_sym_QMARK] = ACTIONS(4314),
    [anon_sym_COLON_QMARK] = ACTIONS(4316),
    [anon_sym_LBRACK] = ACTIONS(4318),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4320),
    [anon_sym_LBRACE] = ACTIONS(4322),
    [aux_sym_char_token1] = ACTIONS(4324),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4326),
    [anon_sym_DQUOTE] = ACTIONS(4328),
    [anon_sym_AT_DQUOTE] = ACTIONS(4330),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4332),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4334),
    [sym_bool] = ACTIONS(4336),
    [sym_unit] = ACTIONS(4338),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4212),
    [sym_op_identifier] = ACTIONS(4214),
    [sym_int] = ACTIONS(4340),
    [sym_xint] = ACTIONS(4342),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2635] = {
    [sym_attributes] = STATE(2632),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(4815),
    [sym__pattern] = STATE(5426),
    [sym_optional_pattern] = STATE(4815),
    [sym_type_check_pattern] = STATE(4815),
    [sym_attribute_pattern] = STATE(4815),
    [sym_paren_pattern] = STATE(4815),
    [sym_as_pattern] = STATE(4815),
    [sym_cons_pattern] = STATE(4815),
    [sym_disjunct_pattern] = STATE(4815),
    [sym_conjunct_pattern] = STATE(4815),
    [sym_typed_pattern] = STATE(4815),
    [sym_list_pattern] = STATE(4815),
    [sym_array_pattern] = STATE(4815),
    [sym_record_pattern] = STATE(4815),
    [sym_named_field_pattern] = STATE(4815),
    [sym_identifier_pattern] = STATE(4815),
    [sym_long_identifier_or_op] = STATE(2475),
    [sym_char] = STATE(4765),
    [sym_format_string] = STATE(4746),
    [sym__string_literal] = STATE(4746),
    [sym_string] = STATE(4765),
    [sym_verbatim_string] = STATE(4765),
    [sym_bytearray] = STATE(4765),
    [sym_verbatim_bytearray] = STATE(4765),
    [sym_format_triple_quoted_string] = STATE(4720),
    [sym_triple_quoted_string] = STATE(4765),
    [sym_const] = STATE(4815),
    [sym_long_identifier] = STATE(3655),
    [sym_active_pattern] = STATE(3734),
    [sym__identifier_or_op] = STATE(3737),
    [sym_sbyte] = STATE(4765),
    [sym_byte] = STATE(4765),
    [sym_int16] = STATE(4765),
    [sym_uint16] = STATE(4765),
    [sym_int32] = STATE(4765),
    [sym_uint32] = STATE(4765),
    [sym_nativeint] = STATE(4765),
    [sym_unativeint] = STATE(4765),
    [sym_int64] = STATE(4765),
    [sym_uint64] = STATE(4765),
    [sym_ieee32] = STATE(4765),
    [sym_ieee64] = STATE(4765),
    [sym_bignum] = STATE(4765),
    [sym_decimal] = STATE(4765),
    [sym_float] = STATE(4512),
    [sym_block_comment] = STATE(2635),
    [sym_compiler_directive_decl] = STATE(2635),
    [sym_fsi_directive_decl] = STATE(2635),
    [sym_preproc_line] = STATE(2635),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(4478),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_LPAREN] = ACTIONS(3572),
    [anon_sym_null] = ACTIONS(3574),
    [anon_sym__] = ACTIONS(3576),
    [anon_sym_QMARK] = ACTIONS(4202),
    [anon_sym_COLON_QMARK] = ACTIONS(4204),
    [anon_sym_LBRACK] = ACTIONS(3582),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3584),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [aux_sym_char_token1] = ACTIONS(3590),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3592),
    [anon_sym_DQUOTE] = ACTIONS(3594),
    [anon_sym_AT_DQUOTE] = ACTIONS(3596),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3598),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3600),
    [sym_bool] = ACTIONS(3602),
    [sym_unit] = ACTIONS(3604),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4212),
    [sym_op_identifier] = ACTIONS(4214),
    [sym_int] = ACTIONS(3610),
    [sym_xint] = ACTIONS(3612),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2636] = {
    [sym_attributes] = STATE(2636),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(3546),
    [sym__pattern] = STATE(3340),
    [sym_optional_pattern] = STATE(3546),
    [sym_type_check_pattern] = STATE(3546),
    [sym_attribute_pattern] = STATE(3546),
    [sym_paren_pattern] = STATE(3546),
    [sym_as_pattern] = STATE(3546),
    [sym_cons_pattern] = STATE(3546),
    [sym_disjunct_pattern] = STATE(3546),
    [sym_conjunct_pattern] = STATE(3546),
    [sym_typed_pattern] = STATE(3546),
    [sym_list_pattern] = STATE(3546),
    [sym_array_pattern] = STATE(3546),
    [sym_record_pattern] = STATE(3546),
    [sym_named_field_pattern] = STATE(3546),
    [sym_identifier_pattern] = STATE(3546),
    [sym_long_identifier_or_op] = STATE(1834),
    [sym_char] = STATE(3509),
    [sym_format_string] = STATE(3517),
    [sym__string_literal] = STATE(3517),
    [sym_string] = STATE(3509),
    [sym_verbatim_string] = STATE(3509),
    [sym_bytearray] = STATE(3509),
    [sym_verbatim_bytearray] = STATE(3509),
    [sym_format_triple_quoted_string] = STATE(3519),
    [sym_triple_quoted_string] = STATE(3509),
    [sym_const] = STATE(3546),
    [sym_long_identifier] = STATE(3320),
    [sym_active_pattern] = STATE(3488),
    [sym__identifier_or_op] = STATE(3410),
    [sym_sbyte] = STATE(3509),
    [sym_byte] = STATE(3509),
    [sym_int16] = STATE(3509),
    [sym_uint16] = STATE(3509),
    [sym_int32] = STATE(3509),
    [sym_uint32] = STATE(3509),
    [sym_nativeint] = STATE(3509),
    [sym_unativeint] = STATE(3509),
    [sym_int64] = STATE(3509),
    [sym_uint64] = STATE(3509),
    [sym_ieee32] = STATE(3509),
    [sym_ieee64] = STATE(3509),
    [sym_bignum] = STATE(3509),
    [sym_decimal] = STATE(3509),
    [sym_float] = STATE(3291),
    [sym_block_comment] = STATE(2636),
    [sym_compiler_directive_decl] = STATE(2636),
    [sym_fsi_directive_decl] = STATE(2636),
    [sym_preproc_line] = STATE(2636),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(3562),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_LPAREN] = ACTIONS(4014),
    [anon_sym_null] = ACTIONS(4016),
    [anon_sym__] = ACTIONS(4018),
    [anon_sym_QMARK] = ACTIONS(4020),
    [anon_sym_COLON_QMARK] = ACTIONS(4022),
    [anon_sym_LBRACK] = ACTIONS(4024),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4026),
    [anon_sym_LBRACE] = ACTIONS(4028),
    [aux_sym_char_token1] = ACTIONS(4030),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4032),
    [anon_sym_DQUOTE] = ACTIONS(4034),
    [anon_sym_AT_DQUOTE] = ACTIONS(4036),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4038),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4040),
    [sym_bool] = ACTIONS(4042),
    [sym_unit] = ACTIONS(4044),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3606),
    [sym_op_identifier] = ACTIONS(3608),
    [sym_int] = ACTIONS(4046),
    [sym_xint] = ACTIONS(4048),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2637] = {
    [sym_attributes] = STATE(2636),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(3546),
    [sym__pattern] = STATE(3321),
    [sym_optional_pattern] = STATE(3546),
    [sym_type_check_pattern] = STATE(3546),
    [sym_attribute_pattern] = STATE(3546),
    [sym_paren_pattern] = STATE(3546),
    [sym_as_pattern] = STATE(3546),
    [sym_cons_pattern] = STATE(3546),
    [sym_disjunct_pattern] = STATE(3546),
    [sym_conjunct_pattern] = STATE(3546),
    [sym_typed_pattern] = STATE(3546),
    [sym_list_pattern] = STATE(3546),
    [sym_array_pattern] = STATE(3546),
    [sym_record_pattern] = STATE(3546),
    [sym_named_field_pattern] = STATE(3546),
    [sym_identifier_pattern] = STATE(3546),
    [sym_long_identifier_or_op] = STATE(1834),
    [sym_char] = STATE(3509),
    [sym_format_string] = STATE(3517),
    [sym__string_literal] = STATE(3517),
    [sym_string] = STATE(3509),
    [sym_verbatim_string] = STATE(3509),
    [sym_bytearray] = STATE(3509),
    [sym_verbatim_bytearray] = STATE(3509),
    [sym_format_triple_quoted_string] = STATE(3519),
    [sym_triple_quoted_string] = STATE(3509),
    [sym_const] = STATE(3546),
    [sym_long_identifier] = STATE(3320),
    [sym_active_pattern] = STATE(3488),
    [sym__identifier_or_op] = STATE(3410),
    [sym_sbyte] = STATE(3509),
    [sym_byte] = STATE(3509),
    [sym_int16] = STATE(3509),
    [sym_uint16] = STATE(3509),
    [sym_int32] = STATE(3509),
    [sym_uint32] = STATE(3509),
    [sym_nativeint] = STATE(3509),
    [sym_unativeint] = STATE(3509),
    [sym_int64] = STATE(3509),
    [sym_uint64] = STATE(3509),
    [sym_ieee32] = STATE(3509),
    [sym_ieee64] = STATE(3509),
    [sym_bignum] = STATE(3509),
    [sym_decimal] = STATE(3509),
    [sym_float] = STATE(3291),
    [sym_block_comment] = STATE(2637),
    [sym_compiler_directive_decl] = STATE(2637),
    [sym_fsi_directive_decl] = STATE(2637),
    [sym_preproc_line] = STATE(2637),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(3562),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_LPAREN] = ACTIONS(4014),
    [anon_sym_null] = ACTIONS(4016),
    [anon_sym__] = ACTIONS(4018),
    [anon_sym_QMARK] = ACTIONS(4020),
    [anon_sym_COLON_QMARK] = ACTIONS(4022),
    [anon_sym_LBRACK] = ACTIONS(4024),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4026),
    [anon_sym_LBRACE] = ACTIONS(4028),
    [aux_sym_char_token1] = ACTIONS(4030),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4032),
    [anon_sym_DQUOTE] = ACTIONS(4034),
    [anon_sym_AT_DQUOTE] = ACTIONS(4036),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4038),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4040),
    [sym_bool] = ACTIONS(4042),
    [sym_unit] = ACTIONS(4044),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3606),
    [sym_op_identifier] = ACTIONS(3608),
    [sym_int] = ACTIONS(4046),
    [sym_xint] = ACTIONS(4048),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2638] = {
    [sym_attributes] = STATE(2698),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(3506),
    [sym__pattern] = STATE(3399),
    [sym_optional_pattern] = STATE(3506),
    [sym_type_check_pattern] = STATE(3506),
    [sym_attribute_pattern] = STATE(3506),
    [sym_paren_pattern] = STATE(3506),
    [sym_as_pattern] = STATE(3506),
    [sym_cons_pattern] = STATE(3506),
    [sym_disjunct_pattern] = STATE(3506),
    [sym_conjunct_pattern] = STATE(3506),
    [sym_typed_pattern] = STATE(3506),
    [sym_list_pattern] = STATE(3506),
    [sym_array_pattern] = STATE(3506),
    [sym_record_pattern] = STATE(3506),
    [sym_named_field_pattern] = STATE(3506),
    [sym_identifier_pattern] = STATE(3506),
    [sym_long_identifier_or_op] = STATE(1864),
    [sym_char] = STATE(3497),
    [sym_format_string] = STATE(3495),
    [sym__string_literal] = STATE(3495),
    [sym_string] = STATE(3497),
    [sym_verbatim_string] = STATE(3497),
    [sym_bytearray] = STATE(3497),
    [sym_verbatim_bytearray] = STATE(3497),
    [sym_format_triple_quoted_string] = STATE(3494),
    [sym_triple_quoted_string] = STATE(3497),
    [sym_const] = STATE(3506),
    [sym_long_identifier] = STATE(3363),
    [sym_active_pattern] = STATE(3521),
    [sym__identifier_or_op] = STATE(3510),
    [sym_sbyte] = STATE(3497),
    [sym_byte] = STATE(3497),
    [sym_int16] = STATE(3497),
    [sym_uint16] = STATE(3497),
    [sym_int32] = STATE(3497),
    [sym_uint32] = STATE(3497),
    [sym_nativeint] = STATE(3497),
    [sym_unativeint] = STATE(3497),
    [sym_int64] = STATE(3497),
    [sym_uint64] = STATE(3497),
    [sym_ieee32] = STATE(3497),
    [sym_ieee64] = STATE(3497),
    [sym_bignum] = STATE(3497),
    [sym_decimal] = STATE(3497),
    [sym_float] = STATE(3305),
    [sym_block_comment] = STATE(2638),
    [sym_compiler_directive_decl] = STATE(2638),
    [sym_fsi_directive_decl] = STATE(2638),
    [sym_preproc_line] = STATE(2638),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(3870),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_LPAREN] = ACTIONS(3962),
    [anon_sym_null] = ACTIONS(3966),
    [anon_sym__] = ACTIONS(3968),
    [anon_sym_QMARK] = ACTIONS(3970),
    [anon_sym_COLON_QMARK] = ACTIONS(3972),
    [anon_sym_LBRACK] = ACTIONS(3974),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3976),
    [anon_sym_LBRACE] = ACTIONS(3978),
    [aux_sym_char_token1] = ACTIONS(3980),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3982),
    [anon_sym_DQUOTE] = ACTIONS(3984),
    [anon_sym_AT_DQUOTE] = ACTIONS(3986),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3988),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3990),
    [sym_bool] = ACTIONS(3992),
    [sym_unit] = ACTIONS(3994),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3904),
    [sym_op_identifier] = ACTIONS(3906),
    [sym_int] = ACTIONS(3996),
    [sym_xint] = ACTIONS(3998),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2639] = {
    [sym_attributes] = STATE(2698),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(3506),
    [sym__pattern] = STATE(3400),
    [sym_optional_pattern] = STATE(3506),
    [sym_type_check_pattern] = STATE(3506),
    [sym_attribute_pattern] = STATE(3506),
    [sym_paren_pattern] = STATE(3506),
    [sym_as_pattern] = STATE(3506),
    [sym_cons_pattern] = STATE(3506),
    [sym_disjunct_pattern] = STATE(3506),
    [sym_conjunct_pattern] = STATE(3506),
    [sym_typed_pattern] = STATE(3506),
    [sym_list_pattern] = STATE(3506),
    [sym_array_pattern] = STATE(3506),
    [sym_record_pattern] = STATE(3506),
    [sym_named_field_pattern] = STATE(3506),
    [sym_identifier_pattern] = STATE(3506),
    [sym_long_identifier_or_op] = STATE(1864),
    [sym_char] = STATE(3497),
    [sym_format_string] = STATE(3495),
    [sym__string_literal] = STATE(3495),
    [sym_string] = STATE(3497),
    [sym_verbatim_string] = STATE(3497),
    [sym_bytearray] = STATE(3497),
    [sym_verbatim_bytearray] = STATE(3497),
    [sym_format_triple_quoted_string] = STATE(3494),
    [sym_triple_quoted_string] = STATE(3497),
    [sym_const] = STATE(3506),
    [sym_long_identifier] = STATE(3363),
    [sym_active_pattern] = STATE(3521),
    [sym__identifier_or_op] = STATE(3510),
    [sym_sbyte] = STATE(3497),
    [sym_byte] = STATE(3497),
    [sym_int16] = STATE(3497),
    [sym_uint16] = STATE(3497),
    [sym_int32] = STATE(3497),
    [sym_uint32] = STATE(3497),
    [sym_nativeint] = STATE(3497),
    [sym_unativeint] = STATE(3497),
    [sym_int64] = STATE(3497),
    [sym_uint64] = STATE(3497),
    [sym_ieee32] = STATE(3497),
    [sym_ieee64] = STATE(3497),
    [sym_bignum] = STATE(3497),
    [sym_decimal] = STATE(3497),
    [sym_float] = STATE(3305),
    [sym_block_comment] = STATE(2639),
    [sym_compiler_directive_decl] = STATE(2639),
    [sym_fsi_directive_decl] = STATE(2639),
    [sym_preproc_line] = STATE(2639),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(3870),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_LPAREN] = ACTIONS(3962),
    [anon_sym_null] = ACTIONS(3966),
    [anon_sym__] = ACTIONS(3968),
    [anon_sym_QMARK] = ACTIONS(3970),
    [anon_sym_COLON_QMARK] = ACTIONS(3972),
    [anon_sym_LBRACK] = ACTIONS(3974),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3976),
    [anon_sym_LBRACE] = ACTIONS(3978),
    [aux_sym_char_token1] = ACTIONS(3980),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3982),
    [anon_sym_DQUOTE] = ACTIONS(3984),
    [anon_sym_AT_DQUOTE] = ACTIONS(3986),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3988),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3990),
    [sym_bool] = ACTIONS(3992),
    [sym_unit] = ACTIONS(3994),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3904),
    [sym_op_identifier] = ACTIONS(3906),
    [sym_int] = ACTIONS(3996),
    [sym_xint] = ACTIONS(3998),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2640] = {
    [sym_attributes] = STATE(2632),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(4815),
    [sym__pattern] = STATE(5508),
    [sym_optional_pattern] = STATE(4815),
    [sym_type_check_pattern] = STATE(4815),
    [sym_attribute_pattern] = STATE(4815),
    [sym_paren_pattern] = STATE(4815),
    [sym_as_pattern] = STATE(4815),
    [sym_cons_pattern] = STATE(4815),
    [sym_disjunct_pattern] = STATE(4815),
    [sym_conjunct_pattern] = STATE(4815),
    [sym_typed_pattern] = STATE(4815),
    [sym_list_pattern] = STATE(4815),
    [sym_array_pattern] = STATE(4815),
    [sym_record_pattern] = STATE(4815),
    [sym_named_field_pattern] = STATE(4815),
    [sym_identifier_pattern] = STATE(4815),
    [sym_long_identifier_or_op] = STATE(2475),
    [sym_char] = STATE(4765),
    [sym_format_string] = STATE(4746),
    [sym__string_literal] = STATE(4746),
    [sym_string] = STATE(4765),
    [sym_verbatim_string] = STATE(4765),
    [sym_bytearray] = STATE(4765),
    [sym_verbatim_bytearray] = STATE(4765),
    [sym_format_triple_quoted_string] = STATE(4720),
    [sym_triple_quoted_string] = STATE(4765),
    [sym_const] = STATE(4815),
    [sym_long_identifier] = STATE(3655),
    [sym_active_pattern] = STATE(3734),
    [sym__identifier_or_op] = STATE(3737),
    [sym_sbyte] = STATE(4765),
    [sym_byte] = STATE(4765),
    [sym_int16] = STATE(4765),
    [sym_uint16] = STATE(4765),
    [sym_int32] = STATE(4765),
    [sym_uint32] = STATE(4765),
    [sym_nativeint] = STATE(4765),
    [sym_unativeint] = STATE(4765),
    [sym_int64] = STATE(4765),
    [sym_uint64] = STATE(4765),
    [sym_ieee32] = STATE(4765),
    [sym_ieee64] = STATE(4765),
    [sym_bignum] = STATE(4765),
    [sym_decimal] = STATE(4765),
    [sym_float] = STATE(4512),
    [sym_block_comment] = STATE(2640),
    [sym_compiler_directive_decl] = STATE(2640),
    [sym_fsi_directive_decl] = STATE(2640),
    [sym_preproc_line] = STATE(2640),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(4480),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_LPAREN] = ACTIONS(3572),
    [anon_sym_null] = ACTIONS(3574),
    [anon_sym__] = ACTIONS(3576),
    [anon_sym_QMARK] = ACTIONS(4202),
    [anon_sym_COLON_QMARK] = ACTIONS(4204),
    [anon_sym_LBRACK] = ACTIONS(3582),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3584),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [aux_sym_char_token1] = ACTIONS(3590),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3592),
    [anon_sym_DQUOTE] = ACTIONS(3594),
    [anon_sym_AT_DQUOTE] = ACTIONS(3596),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3598),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3600),
    [sym_bool] = ACTIONS(3602),
    [sym_unit] = ACTIONS(3604),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4212),
    [sym_op_identifier] = ACTIONS(4214),
    [sym_int] = ACTIONS(3610),
    [sym_xint] = ACTIONS(3612),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2641] = {
    [sym_attributes] = STATE(2641),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(5241),
    [sym__pattern] = STATE(5163),
    [sym_optional_pattern] = STATE(5241),
    [sym_type_check_pattern] = STATE(5241),
    [sym_attribute_pattern] = STATE(5241),
    [sym_paren_pattern] = STATE(5241),
    [sym_as_pattern] = STATE(5241),
    [sym_cons_pattern] = STATE(5241),
    [sym_disjunct_pattern] = STATE(5241),
    [sym_conjunct_pattern] = STATE(5241),
    [sym_typed_pattern] = STATE(5241),
    [sym_list_pattern] = STATE(5241),
    [sym_array_pattern] = STATE(5241),
    [sym_record_pattern] = STATE(5241),
    [sym_named_field_pattern] = STATE(5241),
    [sym_identifier_pattern] = STATE(5241),
    [sym_long_identifier_or_op] = STATE(1721),
    [sym_char] = STATE(5389),
    [sym_format_string] = STATE(5273),
    [sym__string_literal] = STATE(5273),
    [sym_string] = STATE(5389),
    [sym_verbatim_string] = STATE(5389),
    [sym_bytearray] = STATE(5389),
    [sym_verbatim_bytearray] = STATE(5389),
    [sym_format_triple_quoted_string] = STATE(5377),
    [sym_triple_quoted_string] = STATE(5389),
    [sym_const] = STATE(5241),
    [sym_long_identifier] = STATE(3363),
    [sym_active_pattern] = STATE(3521),
    [sym__identifier_or_op] = STATE(3510),
    [sym_sbyte] = STATE(5389),
    [sym_byte] = STATE(5389),
    [sym_int16] = STATE(5389),
    [sym_uint16] = STATE(5389),
    [sym_int32] = STATE(5389),
    [sym_uint32] = STATE(5389),
    [sym_nativeint] = STATE(5389),
    [sym_unativeint] = STATE(5389),
    [sym_int64] = STATE(5389),
    [sym_uint64] = STATE(5389),
    [sym_ieee32] = STATE(5389),
    [sym_ieee64] = STATE(5389),
    [sym_bignum] = STATE(5389),
    [sym_decimal] = STATE(5389),
    [sym_float] = STATE(4893),
    [sym_block_comment] = STATE(2641),
    [sym_compiler_directive_decl] = STATE(2641),
    [sym_fsi_directive_decl] = STATE(2641),
    [sym_preproc_line] = STATE(2641),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(3870),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_LPAREN] = ACTIONS(3872),
    [anon_sym_null] = ACTIONS(3874),
    [anon_sym__] = ACTIONS(3876),
    [anon_sym_QMARK] = ACTIONS(3878),
    [anon_sym_COLON_QMARK] = ACTIONS(3880),
    [anon_sym_LBRACK] = ACTIONS(3882),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3884),
    [anon_sym_LBRACE] = ACTIONS(3886),
    [aux_sym_char_token1] = ACTIONS(3888),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3890),
    [anon_sym_DQUOTE] = ACTIONS(3892),
    [anon_sym_AT_DQUOTE] = ACTIONS(3894),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3896),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3898),
    [sym_bool] = ACTIONS(3900),
    [sym_unit] = ACTIONS(3902),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3904),
    [sym_op_identifier] = ACTIONS(3906),
    [sym_int] = ACTIONS(3908),
    [sym_xint] = ACTIONS(3910),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2642] = {
    [sym_attributes] = STATE(2632),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(4815),
    [sym__pattern] = STATE(5506),
    [sym_optional_pattern] = STATE(4815),
    [sym_type_check_pattern] = STATE(4815),
    [sym_attribute_pattern] = STATE(4815),
    [sym_paren_pattern] = STATE(4815),
    [sym_as_pattern] = STATE(4815),
    [sym_cons_pattern] = STATE(4815),
    [sym_disjunct_pattern] = STATE(4815),
    [sym_conjunct_pattern] = STATE(4815),
    [sym_typed_pattern] = STATE(4815),
    [sym_list_pattern] = STATE(4815),
    [sym_array_pattern] = STATE(4815),
    [sym_record_pattern] = STATE(4815),
    [sym_named_field_pattern] = STATE(4815),
    [sym_identifier_pattern] = STATE(4815),
    [sym_long_identifier_or_op] = STATE(2475),
    [sym_char] = STATE(4765),
    [sym_format_string] = STATE(4746),
    [sym__string_literal] = STATE(4746),
    [sym_string] = STATE(4765),
    [sym_verbatim_string] = STATE(4765),
    [sym_bytearray] = STATE(4765),
    [sym_verbatim_bytearray] = STATE(4765),
    [sym_format_triple_quoted_string] = STATE(4720),
    [sym_triple_quoted_string] = STATE(4765),
    [sym_const] = STATE(4815),
    [sym_long_identifier] = STATE(3655),
    [sym_active_pattern] = STATE(3734),
    [sym__identifier_or_op] = STATE(3737),
    [sym_sbyte] = STATE(4765),
    [sym_byte] = STATE(4765),
    [sym_int16] = STATE(4765),
    [sym_uint16] = STATE(4765),
    [sym_int32] = STATE(4765),
    [sym_uint32] = STATE(4765),
    [sym_nativeint] = STATE(4765),
    [sym_unativeint] = STATE(4765),
    [sym_int64] = STATE(4765),
    [sym_uint64] = STATE(4765),
    [sym_ieee32] = STATE(4765),
    [sym_ieee64] = STATE(4765),
    [sym_bignum] = STATE(4765),
    [sym_decimal] = STATE(4765),
    [sym_float] = STATE(4512),
    [sym_block_comment] = STATE(2642),
    [sym_compiler_directive_decl] = STATE(2642),
    [sym_fsi_directive_decl] = STATE(2642),
    [sym_preproc_line] = STATE(2642),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(4482),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_LPAREN] = ACTIONS(3572),
    [anon_sym_null] = ACTIONS(3574),
    [anon_sym__] = ACTIONS(3576),
    [anon_sym_QMARK] = ACTIONS(4202),
    [anon_sym_COLON_QMARK] = ACTIONS(4204),
    [anon_sym_LBRACK] = ACTIONS(3582),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3584),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [aux_sym_char_token1] = ACTIONS(3590),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3592),
    [anon_sym_DQUOTE] = ACTIONS(3594),
    [anon_sym_AT_DQUOTE] = ACTIONS(3596),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3598),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3600),
    [sym_bool] = ACTIONS(3602),
    [sym_unit] = ACTIONS(3604),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4212),
    [sym_op_identifier] = ACTIONS(4214),
    [sym_int] = ACTIONS(3610),
    [sym_xint] = ACTIONS(3612),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2643] = {
    [sym_attributes] = STATE(2632),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(4815),
    [sym__pattern] = STATE(5441),
    [sym_optional_pattern] = STATE(4815),
    [sym_type_check_pattern] = STATE(4815),
    [sym_attribute_pattern] = STATE(4815),
    [sym_paren_pattern] = STATE(4815),
    [sym_as_pattern] = STATE(4815),
    [sym_cons_pattern] = STATE(4815),
    [sym_disjunct_pattern] = STATE(4815),
    [sym_conjunct_pattern] = STATE(4815),
    [sym_typed_pattern] = STATE(4815),
    [sym_list_pattern] = STATE(4815),
    [sym_array_pattern] = STATE(4815),
    [sym_record_pattern] = STATE(4815),
    [sym_named_field_pattern] = STATE(4815),
    [sym_identifier_pattern] = STATE(4815),
    [sym_long_identifier_or_op] = STATE(2475),
    [sym_char] = STATE(4765),
    [sym_format_string] = STATE(4746),
    [sym__string_literal] = STATE(4746),
    [sym_string] = STATE(4765),
    [sym_verbatim_string] = STATE(4765),
    [sym_bytearray] = STATE(4765),
    [sym_verbatim_bytearray] = STATE(4765),
    [sym_format_triple_quoted_string] = STATE(4720),
    [sym_triple_quoted_string] = STATE(4765),
    [sym_const] = STATE(4815),
    [sym_long_identifier] = STATE(3655),
    [sym_active_pattern] = STATE(3734),
    [sym__identifier_or_op] = STATE(3737),
    [sym_sbyte] = STATE(4765),
    [sym_byte] = STATE(4765),
    [sym_int16] = STATE(4765),
    [sym_uint16] = STATE(4765),
    [sym_int32] = STATE(4765),
    [sym_uint32] = STATE(4765),
    [sym_nativeint] = STATE(4765),
    [sym_unativeint] = STATE(4765),
    [sym_int64] = STATE(4765),
    [sym_uint64] = STATE(4765),
    [sym_ieee32] = STATE(4765),
    [sym_ieee64] = STATE(4765),
    [sym_bignum] = STATE(4765),
    [sym_decimal] = STATE(4765),
    [sym_float] = STATE(4512),
    [sym_block_comment] = STATE(2643),
    [sym_compiler_directive_decl] = STATE(2643),
    [sym_fsi_directive_decl] = STATE(2643),
    [sym_preproc_line] = STATE(2643),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(4484),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_LPAREN] = ACTIONS(3572),
    [anon_sym_null] = ACTIONS(3574),
    [anon_sym__] = ACTIONS(3576),
    [anon_sym_QMARK] = ACTIONS(4202),
    [anon_sym_COLON_QMARK] = ACTIONS(4204),
    [anon_sym_LBRACK] = ACTIONS(3582),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3584),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [aux_sym_char_token1] = ACTIONS(3590),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3592),
    [anon_sym_DQUOTE] = ACTIONS(3594),
    [anon_sym_AT_DQUOTE] = ACTIONS(3596),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3598),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3600),
    [sym_bool] = ACTIONS(3602),
    [sym_unit] = ACTIONS(3604),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4212),
    [sym_op_identifier] = ACTIONS(4214),
    [sym_int] = ACTIONS(3610),
    [sym_xint] = ACTIONS(3612),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2644] = {
    [sym_attributes] = STATE(2632),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(4815),
    [sym__pattern] = STATE(5443),
    [sym_optional_pattern] = STATE(4815),
    [sym_type_check_pattern] = STATE(4815),
    [sym_attribute_pattern] = STATE(4815),
    [sym_paren_pattern] = STATE(4815),
    [sym_as_pattern] = STATE(4815),
    [sym_cons_pattern] = STATE(4815),
    [sym_disjunct_pattern] = STATE(4815),
    [sym_conjunct_pattern] = STATE(4815),
    [sym_typed_pattern] = STATE(4815),
    [sym_list_pattern] = STATE(4815),
    [sym_array_pattern] = STATE(4815),
    [sym_record_pattern] = STATE(4815),
    [sym_named_field_pattern] = STATE(4815),
    [sym_identifier_pattern] = STATE(4815),
    [sym_long_identifier_or_op] = STATE(2475),
    [sym_char] = STATE(4765),
    [sym_format_string] = STATE(4746),
    [sym__string_literal] = STATE(4746),
    [sym_string] = STATE(4765),
    [sym_verbatim_string] = STATE(4765),
    [sym_bytearray] = STATE(4765),
    [sym_verbatim_bytearray] = STATE(4765),
    [sym_format_triple_quoted_string] = STATE(4720),
    [sym_triple_quoted_string] = STATE(4765),
    [sym_const] = STATE(4815),
    [sym_long_identifier] = STATE(3655),
    [sym_active_pattern] = STATE(3734),
    [sym__identifier_or_op] = STATE(3737),
    [sym_sbyte] = STATE(4765),
    [sym_byte] = STATE(4765),
    [sym_int16] = STATE(4765),
    [sym_uint16] = STATE(4765),
    [sym_int32] = STATE(4765),
    [sym_uint32] = STATE(4765),
    [sym_nativeint] = STATE(4765),
    [sym_unativeint] = STATE(4765),
    [sym_int64] = STATE(4765),
    [sym_uint64] = STATE(4765),
    [sym_ieee32] = STATE(4765),
    [sym_ieee64] = STATE(4765),
    [sym_bignum] = STATE(4765),
    [sym_decimal] = STATE(4765),
    [sym_float] = STATE(4512),
    [sym_block_comment] = STATE(2644),
    [sym_compiler_directive_decl] = STATE(2644),
    [sym_fsi_directive_decl] = STATE(2644),
    [sym_preproc_line] = STATE(2644),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(4480),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_LPAREN] = ACTIONS(3572),
    [anon_sym_null] = ACTIONS(3574),
    [anon_sym__] = ACTIONS(3576),
    [anon_sym_QMARK] = ACTIONS(4202),
    [anon_sym_COLON_QMARK] = ACTIONS(4204),
    [anon_sym_LBRACK] = ACTIONS(3582),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3584),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [aux_sym_char_token1] = ACTIONS(3590),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3592),
    [anon_sym_DQUOTE] = ACTIONS(3594),
    [anon_sym_AT_DQUOTE] = ACTIONS(3596),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3598),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3600),
    [sym_bool] = ACTIONS(3602),
    [sym_unit] = ACTIONS(3604),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4212),
    [sym_op_identifier] = ACTIONS(4214),
    [sym_int] = ACTIONS(3610),
    [sym_xint] = ACTIONS(3612),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2645] = {
    [sym_attributes] = STATE(2674),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(5431),
    [sym__pattern] = STATE(5380),
    [sym_optional_pattern] = STATE(5431),
    [sym_type_check_pattern] = STATE(5431),
    [sym_attribute_pattern] = STATE(5431),
    [sym_paren_pattern] = STATE(5431),
    [sym_as_pattern] = STATE(5431),
    [sym_cons_pattern] = STATE(5431),
    [sym_disjunct_pattern] = STATE(5431),
    [sym_conjunct_pattern] = STATE(5431),
    [sym_typed_pattern] = STATE(5431),
    [sym_list_pattern] = STATE(5431),
    [sym_array_pattern] = STATE(5431),
    [sym_record_pattern] = STATE(5431),
    [sym_named_field_pattern] = STATE(5431),
    [sym_identifier_pattern] = STATE(5431),
    [sym_long_identifier_or_op] = STATE(2273),
    [sym_char] = STATE(5475),
    [sym_format_string] = STATE(5423),
    [sym__string_literal] = STATE(5423),
    [sym_string] = STATE(5475),
    [sym_verbatim_string] = STATE(5475),
    [sym_bytearray] = STATE(5475),
    [sym_verbatim_bytearray] = STATE(5475),
    [sym_format_triple_quoted_string] = STATE(5477),
    [sym_triple_quoted_string] = STATE(5475),
    [sym_const] = STATE(5431),
    [sym_long_identifier] = STATE(3437),
    [sym_active_pattern] = STATE(3653),
    [sym__identifier_or_op] = STATE(3660),
    [sym_sbyte] = STATE(5475),
    [sym_byte] = STATE(5475),
    [sym_int16] = STATE(5475),
    [sym_uint16] = STATE(5475),
    [sym_int32] = STATE(5475),
    [sym_uint32] = STATE(5475),
    [sym_nativeint] = STATE(5475),
    [sym_unativeint] = STATE(5475),
    [sym_int64] = STATE(5475),
    [sym_uint64] = STATE(5475),
    [sym_ieee32] = STATE(5475),
    [sym_ieee64] = STATE(5475),
    [sym_bignum] = STATE(5475),
    [sym_decimal] = STATE(5475),
    [sym_float] = STATE(4953),
    [sym_block_comment] = STATE(2645),
    [sym_compiler_directive_decl] = STATE(2645),
    [sym_fsi_directive_decl] = STATE(2645),
    [sym_preproc_line] = STATE(2645),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(4073),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_LPAREN] = ACTIONS(4077),
    [anon_sym_null] = ACTIONS(4081),
    [anon_sym__] = ACTIONS(4083),
    [anon_sym_QMARK] = ACTIONS(4085),
    [anon_sym_COLON_QMARK] = ACTIONS(4087),
    [anon_sym_LBRACK] = ACTIONS(4095),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4097),
    [anon_sym_LBRACE] = ACTIONS(4099),
    [aux_sym_char_token1] = ACTIONS(4101),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4103),
    [anon_sym_DQUOTE] = ACTIONS(4105),
    [anon_sym_AT_DQUOTE] = ACTIONS(4107),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4109),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4111),
    [sym_bool] = ACTIONS(4113),
    [sym_unit] = ACTIONS(4115),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4117),
    [sym_op_identifier] = ACTIONS(4119),
    [sym_int] = ACTIONS(4121),
    [sym_xint] = ACTIONS(4123),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2646] = {
    [sym_attributes] = STATE(2632),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(4815),
    [sym__pattern] = STATE(5444),
    [sym_optional_pattern] = STATE(4815),
    [sym_type_check_pattern] = STATE(4815),
    [sym_attribute_pattern] = STATE(4815),
    [sym_paren_pattern] = STATE(4815),
    [sym_as_pattern] = STATE(4815),
    [sym_cons_pattern] = STATE(4815),
    [sym_disjunct_pattern] = STATE(4815),
    [sym_conjunct_pattern] = STATE(4815),
    [sym_typed_pattern] = STATE(4815),
    [sym_list_pattern] = STATE(4815),
    [sym_array_pattern] = STATE(4815),
    [sym_record_pattern] = STATE(4815),
    [sym_named_field_pattern] = STATE(4815),
    [sym_identifier_pattern] = STATE(4815),
    [sym_long_identifier_or_op] = STATE(2475),
    [sym_char] = STATE(4765),
    [sym_format_string] = STATE(4746),
    [sym__string_literal] = STATE(4746),
    [sym_string] = STATE(4765),
    [sym_verbatim_string] = STATE(4765),
    [sym_bytearray] = STATE(4765),
    [sym_verbatim_bytearray] = STATE(4765),
    [sym_format_triple_quoted_string] = STATE(4720),
    [sym_triple_quoted_string] = STATE(4765),
    [sym_const] = STATE(4815),
    [sym_long_identifier] = STATE(3655),
    [sym_active_pattern] = STATE(3734),
    [sym__identifier_or_op] = STATE(3737),
    [sym_sbyte] = STATE(4765),
    [sym_byte] = STATE(4765),
    [sym_int16] = STATE(4765),
    [sym_uint16] = STATE(4765),
    [sym_int32] = STATE(4765),
    [sym_uint32] = STATE(4765),
    [sym_nativeint] = STATE(4765),
    [sym_unativeint] = STATE(4765),
    [sym_int64] = STATE(4765),
    [sym_uint64] = STATE(4765),
    [sym_ieee32] = STATE(4765),
    [sym_ieee64] = STATE(4765),
    [sym_bignum] = STATE(4765),
    [sym_decimal] = STATE(4765),
    [sym_float] = STATE(4512),
    [sym_block_comment] = STATE(2646),
    [sym_compiler_directive_decl] = STATE(2646),
    [sym_fsi_directive_decl] = STATE(2646),
    [sym_preproc_line] = STATE(2646),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(4486),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_LPAREN] = ACTIONS(3572),
    [anon_sym_null] = ACTIONS(3574),
    [anon_sym__] = ACTIONS(3576),
    [anon_sym_QMARK] = ACTIONS(4202),
    [anon_sym_COLON_QMARK] = ACTIONS(4204),
    [anon_sym_LBRACK] = ACTIONS(3582),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3584),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [aux_sym_char_token1] = ACTIONS(3590),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3592),
    [anon_sym_DQUOTE] = ACTIONS(3594),
    [anon_sym_AT_DQUOTE] = ACTIONS(3596),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3598),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3600),
    [sym_bool] = ACTIONS(3602),
    [sym_unit] = ACTIONS(3604),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4212),
    [sym_op_identifier] = ACTIONS(4214),
    [sym_int] = ACTIONS(3610),
    [sym_xint] = ACTIONS(3612),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2647] = {
    [sym_attributes] = STATE(2674),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(5431),
    [sym__pattern] = STATE(5383),
    [sym_optional_pattern] = STATE(5431),
    [sym_type_check_pattern] = STATE(5431),
    [sym_attribute_pattern] = STATE(5431),
    [sym_paren_pattern] = STATE(5431),
    [sym_as_pattern] = STATE(5431),
    [sym_cons_pattern] = STATE(5431),
    [sym_disjunct_pattern] = STATE(5431),
    [sym_conjunct_pattern] = STATE(5431),
    [sym_typed_pattern] = STATE(5431),
    [sym_list_pattern] = STATE(5431),
    [sym_array_pattern] = STATE(5431),
    [sym_record_pattern] = STATE(5431),
    [sym_named_field_pattern] = STATE(5431),
    [sym_identifier_pattern] = STATE(5431),
    [sym_long_identifier_or_op] = STATE(2273),
    [sym_char] = STATE(5475),
    [sym_format_string] = STATE(5423),
    [sym__string_literal] = STATE(5423),
    [sym_string] = STATE(5475),
    [sym_verbatim_string] = STATE(5475),
    [sym_bytearray] = STATE(5475),
    [sym_verbatim_bytearray] = STATE(5475),
    [sym_format_triple_quoted_string] = STATE(5477),
    [sym_triple_quoted_string] = STATE(5475),
    [sym_const] = STATE(5431),
    [sym_long_identifier] = STATE(3437),
    [sym_active_pattern] = STATE(3653),
    [sym__identifier_or_op] = STATE(3660),
    [sym_sbyte] = STATE(5475),
    [sym_byte] = STATE(5475),
    [sym_int16] = STATE(5475),
    [sym_uint16] = STATE(5475),
    [sym_int32] = STATE(5475),
    [sym_uint32] = STATE(5475),
    [sym_nativeint] = STATE(5475),
    [sym_unativeint] = STATE(5475),
    [sym_int64] = STATE(5475),
    [sym_uint64] = STATE(5475),
    [sym_ieee32] = STATE(5475),
    [sym_ieee64] = STATE(5475),
    [sym_bignum] = STATE(5475),
    [sym_decimal] = STATE(5475),
    [sym_float] = STATE(4953),
    [sym_block_comment] = STATE(2647),
    [sym_compiler_directive_decl] = STATE(2647),
    [sym_fsi_directive_decl] = STATE(2647),
    [sym_preproc_line] = STATE(2647),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(4073),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_LPAREN] = ACTIONS(4077),
    [anon_sym_null] = ACTIONS(4081),
    [anon_sym__] = ACTIONS(4083),
    [anon_sym_QMARK] = ACTIONS(4085),
    [anon_sym_COLON_QMARK] = ACTIONS(4087),
    [anon_sym_LBRACK] = ACTIONS(4095),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4097),
    [anon_sym_LBRACE] = ACTIONS(4099),
    [aux_sym_char_token1] = ACTIONS(4101),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4103),
    [anon_sym_DQUOTE] = ACTIONS(4105),
    [anon_sym_AT_DQUOTE] = ACTIONS(4107),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4109),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4111),
    [sym_bool] = ACTIONS(4113),
    [sym_unit] = ACTIONS(4115),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4117),
    [sym_op_identifier] = ACTIONS(4119),
    [sym_int] = ACTIONS(4121),
    [sym_xint] = ACTIONS(4123),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2648] = {
    [sym_attributes] = STATE(2674),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(5431),
    [sym__pattern] = STATE(5386),
    [sym_optional_pattern] = STATE(5431),
    [sym_type_check_pattern] = STATE(5431),
    [sym_attribute_pattern] = STATE(5431),
    [sym_paren_pattern] = STATE(5431),
    [sym_as_pattern] = STATE(5431),
    [sym_cons_pattern] = STATE(5431),
    [sym_disjunct_pattern] = STATE(5431),
    [sym_conjunct_pattern] = STATE(5431),
    [sym_typed_pattern] = STATE(5431),
    [sym_list_pattern] = STATE(5431),
    [sym_array_pattern] = STATE(5431),
    [sym_record_pattern] = STATE(5431),
    [sym_named_field_pattern] = STATE(5431),
    [sym_identifier_pattern] = STATE(5431),
    [sym_long_identifier_or_op] = STATE(2273),
    [sym_char] = STATE(5475),
    [sym_format_string] = STATE(5423),
    [sym__string_literal] = STATE(5423),
    [sym_string] = STATE(5475),
    [sym_verbatim_string] = STATE(5475),
    [sym_bytearray] = STATE(5475),
    [sym_verbatim_bytearray] = STATE(5475),
    [sym_format_triple_quoted_string] = STATE(5477),
    [sym_triple_quoted_string] = STATE(5475),
    [sym_const] = STATE(5431),
    [sym_long_identifier] = STATE(3437),
    [sym_active_pattern] = STATE(3653),
    [sym__identifier_or_op] = STATE(3660),
    [sym_sbyte] = STATE(5475),
    [sym_byte] = STATE(5475),
    [sym_int16] = STATE(5475),
    [sym_uint16] = STATE(5475),
    [sym_int32] = STATE(5475),
    [sym_uint32] = STATE(5475),
    [sym_nativeint] = STATE(5475),
    [sym_unativeint] = STATE(5475),
    [sym_int64] = STATE(5475),
    [sym_uint64] = STATE(5475),
    [sym_ieee32] = STATE(5475),
    [sym_ieee64] = STATE(5475),
    [sym_bignum] = STATE(5475),
    [sym_decimal] = STATE(5475),
    [sym_float] = STATE(4953),
    [sym_block_comment] = STATE(2648),
    [sym_compiler_directive_decl] = STATE(2648),
    [sym_fsi_directive_decl] = STATE(2648),
    [sym_preproc_line] = STATE(2648),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(4073),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_LPAREN] = ACTIONS(4077),
    [anon_sym_null] = ACTIONS(4081),
    [anon_sym__] = ACTIONS(4083),
    [anon_sym_QMARK] = ACTIONS(4085),
    [anon_sym_COLON_QMARK] = ACTIONS(4087),
    [anon_sym_LBRACK] = ACTIONS(4095),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4097),
    [anon_sym_LBRACE] = ACTIONS(4099),
    [aux_sym_char_token1] = ACTIONS(4101),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4103),
    [anon_sym_DQUOTE] = ACTIONS(4105),
    [anon_sym_AT_DQUOTE] = ACTIONS(4107),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4109),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4111),
    [sym_bool] = ACTIONS(4113),
    [sym_unit] = ACTIONS(4115),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4117),
    [sym_op_identifier] = ACTIONS(4119),
    [sym_int] = ACTIONS(4121),
    [sym_xint] = ACTIONS(4123),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2649] = {
    [sym_attributes] = STATE(2674),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(5431),
    [sym__pattern] = STATE(5387),
    [sym_optional_pattern] = STATE(5431),
    [sym_type_check_pattern] = STATE(5431),
    [sym_attribute_pattern] = STATE(5431),
    [sym_paren_pattern] = STATE(5431),
    [sym_as_pattern] = STATE(5431),
    [sym_cons_pattern] = STATE(5431),
    [sym_disjunct_pattern] = STATE(5431),
    [sym_conjunct_pattern] = STATE(5431),
    [sym_typed_pattern] = STATE(5431),
    [sym_list_pattern] = STATE(5431),
    [sym_array_pattern] = STATE(5431),
    [sym_record_pattern] = STATE(5431),
    [sym_named_field_pattern] = STATE(5431),
    [sym_identifier_pattern] = STATE(5431),
    [sym_long_identifier_or_op] = STATE(2273),
    [sym_char] = STATE(5475),
    [sym_format_string] = STATE(5423),
    [sym__string_literal] = STATE(5423),
    [sym_string] = STATE(5475),
    [sym_verbatim_string] = STATE(5475),
    [sym_bytearray] = STATE(5475),
    [sym_verbatim_bytearray] = STATE(5475),
    [sym_format_triple_quoted_string] = STATE(5477),
    [sym_triple_quoted_string] = STATE(5475),
    [sym_const] = STATE(5431),
    [sym_long_identifier] = STATE(3437),
    [sym_active_pattern] = STATE(3653),
    [sym__identifier_or_op] = STATE(3660),
    [sym_sbyte] = STATE(5475),
    [sym_byte] = STATE(5475),
    [sym_int16] = STATE(5475),
    [sym_uint16] = STATE(5475),
    [sym_int32] = STATE(5475),
    [sym_uint32] = STATE(5475),
    [sym_nativeint] = STATE(5475),
    [sym_unativeint] = STATE(5475),
    [sym_int64] = STATE(5475),
    [sym_uint64] = STATE(5475),
    [sym_ieee32] = STATE(5475),
    [sym_ieee64] = STATE(5475),
    [sym_bignum] = STATE(5475),
    [sym_decimal] = STATE(5475),
    [sym_float] = STATE(4953),
    [sym_block_comment] = STATE(2649),
    [sym_compiler_directive_decl] = STATE(2649),
    [sym_fsi_directive_decl] = STATE(2649),
    [sym_preproc_line] = STATE(2649),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(4073),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_LPAREN] = ACTIONS(4077),
    [anon_sym_null] = ACTIONS(4081),
    [anon_sym__] = ACTIONS(4083),
    [anon_sym_QMARK] = ACTIONS(4085),
    [anon_sym_COLON_QMARK] = ACTIONS(4087),
    [anon_sym_LBRACK] = ACTIONS(4095),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4097),
    [anon_sym_LBRACE] = ACTIONS(4099),
    [aux_sym_char_token1] = ACTIONS(4101),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4103),
    [anon_sym_DQUOTE] = ACTIONS(4105),
    [anon_sym_AT_DQUOTE] = ACTIONS(4107),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4109),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4111),
    [sym_bool] = ACTIONS(4113),
    [sym_unit] = ACTIONS(4115),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4117),
    [sym_op_identifier] = ACTIONS(4119),
    [sym_int] = ACTIONS(4121),
    [sym_xint] = ACTIONS(4123),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2650] = {
    [sym_attributes] = STATE(2652),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(3588),
    [sym__pattern] = STATE(3543),
    [sym_optional_pattern] = STATE(3588),
    [sym_type_check_pattern] = STATE(3588),
    [sym_attribute_pattern] = STATE(3588),
    [sym_paren_pattern] = STATE(3588),
    [sym_as_pattern] = STATE(3588),
    [sym_cons_pattern] = STATE(3588),
    [sym_disjunct_pattern] = STATE(3588),
    [sym_conjunct_pattern] = STATE(3588),
    [sym_typed_pattern] = STATE(3588),
    [sym_list_pattern] = STATE(3588),
    [sym_array_pattern] = STATE(3588),
    [sym_record_pattern] = STATE(3588),
    [sym_named_field_pattern] = STATE(3588),
    [sym_identifier_pattern] = STATE(3588),
    [sym_long_identifier_or_op] = STATE(2401),
    [sym_char] = STATE(3658),
    [sym_format_string] = STATE(3670),
    [sym__string_literal] = STATE(3670),
    [sym_string] = STATE(3658),
    [sym_verbatim_string] = STATE(3658),
    [sym_bytearray] = STATE(3658),
    [sym_verbatim_bytearray] = STATE(3658),
    [sym_format_triple_quoted_string] = STATE(3673),
    [sym_triple_quoted_string] = STATE(3658),
    [sym_const] = STATE(3588),
    [sym_long_identifier] = STATE(3493),
    [sym_active_pattern] = STATE(3613),
    [sym__identifier_or_op] = STATE(3650),
    [sym_sbyte] = STATE(3658),
    [sym_byte] = STATE(3658),
    [sym_int16] = STATE(3658),
    [sym_uint16] = STATE(3658),
    [sym_int32] = STATE(3658),
    [sym_uint32] = STATE(3658),
    [sym_nativeint] = STATE(3658),
    [sym_unativeint] = STATE(3658),
    [sym_int64] = STATE(3658),
    [sym_uint64] = STATE(3658),
    [sym_ieee32] = STATE(3658),
    [sym_ieee64] = STATE(3658),
    [sym_bignum] = STATE(3658),
    [sym_decimal] = STATE(3658),
    [sym_float] = STATE(3376),
    [sym_block_comment] = STATE(2650),
    [sym_compiler_directive_decl] = STATE(2650),
    [sym_fsi_directive_decl] = STATE(2650),
    [sym_preproc_line] = STATE(2650),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(4175),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_LPAREN] = ACTIONS(4218),
    [anon_sym_null] = ACTIONS(4220),
    [anon_sym__] = ACTIONS(4222),
    [anon_sym_QMARK] = ACTIONS(4224),
    [anon_sym_COLON_QMARK] = ACTIONS(4226),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4230),
    [anon_sym_LBRACE] = ACTIONS(4232),
    [aux_sym_char_token1] = ACTIONS(4234),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4236),
    [anon_sym_DQUOTE] = ACTIONS(4238),
    [anon_sym_AT_DQUOTE] = ACTIONS(4240),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4242),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4244),
    [sym_bool] = ACTIONS(4246),
    [sym_unit] = ACTIONS(4248),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4181),
    [sym_op_identifier] = ACTIONS(4183),
    [sym_int] = ACTIONS(4250),
    [sym_xint] = ACTIONS(4252),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2651] = {
    [sym_attributes] = STATE(2632),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(4815),
    [sym__pattern] = STATE(5449),
    [sym_optional_pattern] = STATE(4815),
    [sym_type_check_pattern] = STATE(4815),
    [sym_attribute_pattern] = STATE(4815),
    [sym_paren_pattern] = STATE(4815),
    [sym_as_pattern] = STATE(4815),
    [sym_cons_pattern] = STATE(4815),
    [sym_disjunct_pattern] = STATE(4815),
    [sym_conjunct_pattern] = STATE(4815),
    [sym_typed_pattern] = STATE(4815),
    [sym_list_pattern] = STATE(4815),
    [sym_array_pattern] = STATE(4815),
    [sym_record_pattern] = STATE(4815),
    [sym_named_field_pattern] = STATE(4815),
    [sym_identifier_pattern] = STATE(4815),
    [sym_long_identifier_or_op] = STATE(2475),
    [sym_char] = STATE(4765),
    [sym_format_string] = STATE(4746),
    [sym__string_literal] = STATE(4746),
    [sym_string] = STATE(4765),
    [sym_verbatim_string] = STATE(4765),
    [sym_bytearray] = STATE(4765),
    [sym_verbatim_bytearray] = STATE(4765),
    [sym_format_triple_quoted_string] = STATE(4720),
    [sym_triple_quoted_string] = STATE(4765),
    [sym_const] = STATE(4815),
    [sym_long_identifier] = STATE(3655),
    [sym_active_pattern] = STATE(3734),
    [sym__identifier_or_op] = STATE(3737),
    [sym_sbyte] = STATE(4765),
    [sym_byte] = STATE(4765),
    [sym_int16] = STATE(4765),
    [sym_uint16] = STATE(4765),
    [sym_int32] = STATE(4765),
    [sym_uint32] = STATE(4765),
    [sym_nativeint] = STATE(4765),
    [sym_unativeint] = STATE(4765),
    [sym_int64] = STATE(4765),
    [sym_uint64] = STATE(4765),
    [sym_ieee32] = STATE(4765),
    [sym_ieee64] = STATE(4765),
    [sym_bignum] = STATE(4765),
    [sym_decimal] = STATE(4765),
    [sym_float] = STATE(4512),
    [sym_block_comment] = STATE(2651),
    [sym_compiler_directive_decl] = STATE(2651),
    [sym_fsi_directive_decl] = STATE(2651),
    [sym_preproc_line] = STATE(2651),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(4482),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_LPAREN] = ACTIONS(3572),
    [anon_sym_null] = ACTIONS(3574),
    [anon_sym__] = ACTIONS(3576),
    [anon_sym_QMARK] = ACTIONS(4202),
    [anon_sym_COLON_QMARK] = ACTIONS(4204),
    [anon_sym_LBRACK] = ACTIONS(3582),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3584),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [aux_sym_char_token1] = ACTIONS(3590),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3592),
    [anon_sym_DQUOTE] = ACTIONS(3594),
    [anon_sym_AT_DQUOTE] = ACTIONS(3596),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3598),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3600),
    [sym_bool] = ACTIONS(3602),
    [sym_unit] = ACTIONS(3604),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4212),
    [sym_op_identifier] = ACTIONS(4214),
    [sym_int] = ACTIONS(3610),
    [sym_xint] = ACTIONS(3612),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2652] = {
    [sym_attributes] = STATE(2652),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(3588),
    [sym__pattern] = STATE(3556),
    [sym_optional_pattern] = STATE(3588),
    [sym_type_check_pattern] = STATE(3588),
    [sym_attribute_pattern] = STATE(3588),
    [sym_paren_pattern] = STATE(3588),
    [sym_as_pattern] = STATE(3588),
    [sym_cons_pattern] = STATE(3588),
    [sym_disjunct_pattern] = STATE(3588),
    [sym_conjunct_pattern] = STATE(3588),
    [sym_typed_pattern] = STATE(3588),
    [sym_list_pattern] = STATE(3588),
    [sym_array_pattern] = STATE(3588),
    [sym_record_pattern] = STATE(3588),
    [sym_named_field_pattern] = STATE(3588),
    [sym_identifier_pattern] = STATE(3588),
    [sym_long_identifier_or_op] = STATE(2401),
    [sym_char] = STATE(3658),
    [sym_format_string] = STATE(3670),
    [sym__string_literal] = STATE(3670),
    [sym_string] = STATE(3658),
    [sym_verbatim_string] = STATE(3658),
    [sym_bytearray] = STATE(3658),
    [sym_verbatim_bytearray] = STATE(3658),
    [sym_format_triple_quoted_string] = STATE(3673),
    [sym_triple_quoted_string] = STATE(3658),
    [sym_const] = STATE(3588),
    [sym_long_identifier] = STATE(3493),
    [sym_active_pattern] = STATE(3613),
    [sym__identifier_or_op] = STATE(3650),
    [sym_sbyte] = STATE(3658),
    [sym_byte] = STATE(3658),
    [sym_int16] = STATE(3658),
    [sym_uint16] = STATE(3658),
    [sym_int32] = STATE(3658),
    [sym_uint32] = STATE(3658),
    [sym_nativeint] = STATE(3658),
    [sym_unativeint] = STATE(3658),
    [sym_int64] = STATE(3658),
    [sym_uint64] = STATE(3658),
    [sym_ieee32] = STATE(3658),
    [sym_ieee64] = STATE(3658),
    [sym_bignum] = STATE(3658),
    [sym_decimal] = STATE(3658),
    [sym_float] = STATE(3376),
    [sym_block_comment] = STATE(2652),
    [sym_compiler_directive_decl] = STATE(2652),
    [sym_fsi_directive_decl] = STATE(2652),
    [sym_preproc_line] = STATE(2652),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(4175),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_LPAREN] = ACTIONS(4218),
    [anon_sym_null] = ACTIONS(4220),
    [anon_sym__] = ACTIONS(4222),
    [anon_sym_QMARK] = ACTIONS(4224),
    [anon_sym_COLON_QMARK] = ACTIONS(4226),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4230),
    [anon_sym_LBRACE] = ACTIONS(4232),
    [aux_sym_char_token1] = ACTIONS(4234),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4236),
    [anon_sym_DQUOTE] = ACTIONS(4238),
    [anon_sym_AT_DQUOTE] = ACTIONS(4240),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4242),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4244),
    [sym_bool] = ACTIONS(4246),
    [sym_unit] = ACTIONS(4248),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4181),
    [sym_op_identifier] = ACTIONS(4183),
    [sym_int] = ACTIONS(4250),
    [sym_xint] = ACTIONS(4252),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2653] = {
    [sym_attributes] = STATE(2641),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(5241),
    [sym__pattern] = STATE(5176),
    [sym_optional_pattern] = STATE(5241),
    [sym_type_check_pattern] = STATE(5241),
    [sym_attribute_pattern] = STATE(5241),
    [sym_paren_pattern] = STATE(5241),
    [sym_as_pattern] = STATE(5241),
    [sym_cons_pattern] = STATE(5241),
    [sym_disjunct_pattern] = STATE(5241),
    [sym_conjunct_pattern] = STATE(5241),
    [sym_typed_pattern] = STATE(5241),
    [sym_list_pattern] = STATE(5241),
    [sym_array_pattern] = STATE(5241),
    [sym_record_pattern] = STATE(5241),
    [sym_named_field_pattern] = STATE(5241),
    [sym_identifier_pattern] = STATE(5241),
    [sym_long_identifier_or_op] = STATE(1721),
    [sym_char] = STATE(5389),
    [sym_format_string] = STATE(5273),
    [sym__string_literal] = STATE(5273),
    [sym_string] = STATE(5389),
    [sym_verbatim_string] = STATE(5389),
    [sym_bytearray] = STATE(5389),
    [sym_verbatim_bytearray] = STATE(5389),
    [sym_format_triple_quoted_string] = STATE(5377),
    [sym_triple_quoted_string] = STATE(5389),
    [sym_const] = STATE(5241),
    [sym_long_identifier] = STATE(3363),
    [sym_active_pattern] = STATE(3521),
    [sym__identifier_or_op] = STATE(3510),
    [sym_sbyte] = STATE(5389),
    [sym_byte] = STATE(5389),
    [sym_int16] = STATE(5389),
    [sym_uint16] = STATE(5389),
    [sym_int32] = STATE(5389),
    [sym_uint32] = STATE(5389),
    [sym_nativeint] = STATE(5389),
    [sym_unativeint] = STATE(5389),
    [sym_int64] = STATE(5389),
    [sym_uint64] = STATE(5389),
    [sym_ieee32] = STATE(5389),
    [sym_ieee64] = STATE(5389),
    [sym_bignum] = STATE(5389),
    [sym_decimal] = STATE(5389),
    [sym_float] = STATE(4893),
    [sym_block_comment] = STATE(2653),
    [sym_compiler_directive_decl] = STATE(2653),
    [sym_fsi_directive_decl] = STATE(2653),
    [sym_preproc_line] = STATE(2653),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(3870),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_LPAREN] = ACTIONS(3872),
    [anon_sym_null] = ACTIONS(3874),
    [anon_sym__] = ACTIONS(3876),
    [anon_sym_QMARK] = ACTIONS(3878),
    [anon_sym_COLON_QMARK] = ACTIONS(3880),
    [anon_sym_LBRACK] = ACTIONS(3882),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3884),
    [anon_sym_LBRACE] = ACTIONS(3886),
    [aux_sym_char_token1] = ACTIONS(3888),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3890),
    [anon_sym_DQUOTE] = ACTIONS(3892),
    [anon_sym_AT_DQUOTE] = ACTIONS(3894),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3896),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3898),
    [sym_bool] = ACTIONS(3900),
    [sym_unit] = ACTIONS(3902),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3904),
    [sym_op_identifier] = ACTIONS(3906),
    [sym_int] = ACTIONS(3908),
    [sym_xint] = ACTIONS(3910),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2654] = {
    [sym_attributes] = STATE(2676),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(4815),
    [sym__pattern] = STATE(5082),
    [sym_optional_pattern] = STATE(4815),
    [sym_type_check_pattern] = STATE(4815),
    [sym_attribute_pattern] = STATE(4815),
    [sym_paren_pattern] = STATE(4815),
    [sym_as_pattern] = STATE(4815),
    [sym_cons_pattern] = STATE(4815),
    [sym_disjunct_pattern] = STATE(4815),
    [sym_conjunct_pattern] = STATE(4815),
    [sym_typed_pattern] = STATE(4815),
    [sym_list_pattern] = STATE(4815),
    [sym_array_pattern] = STATE(4815),
    [sym_record_pattern] = STATE(4815),
    [sym_named_field_pattern] = STATE(4815),
    [sym_identifier_pattern] = STATE(4815),
    [sym_long_identifier_or_op] = STATE(1792),
    [sym_char] = STATE(4765),
    [sym_format_string] = STATE(4746),
    [sym__string_literal] = STATE(4746),
    [sym_string] = STATE(4765),
    [sym_verbatim_string] = STATE(4765),
    [sym_bytearray] = STATE(4765),
    [sym_verbatim_bytearray] = STATE(4765),
    [sym_format_triple_quoted_string] = STATE(4720),
    [sym_triple_quoted_string] = STATE(4765),
    [sym_const] = STATE(4815),
    [sym_long_identifier] = STATE(3320),
    [sym_active_pattern] = STATE(3488),
    [sym__identifier_or_op] = STATE(3410),
    [sym_sbyte] = STATE(4765),
    [sym_byte] = STATE(4765),
    [sym_int16] = STATE(4765),
    [sym_uint16] = STATE(4765),
    [sym_int32] = STATE(4765),
    [sym_uint32] = STATE(4765),
    [sym_nativeint] = STATE(4765),
    [sym_unativeint] = STATE(4765),
    [sym_int64] = STATE(4765),
    [sym_uint64] = STATE(4765),
    [sym_ieee32] = STATE(4765),
    [sym_ieee64] = STATE(4765),
    [sym_bignum] = STATE(4765),
    [sym_decimal] = STATE(4765),
    [sym_float] = STATE(4512),
    [sym_block_comment] = STATE(2654),
    [sym_compiler_directive_decl] = STATE(2654),
    [sym_fsi_directive_decl] = STATE(2654),
    [sym_preproc_line] = STATE(2654),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(3562),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_LPAREN] = ACTIONS(3572),
    [anon_sym_null] = ACTIONS(3574),
    [anon_sym__] = ACTIONS(3576),
    [anon_sym_QMARK] = ACTIONS(3578),
    [anon_sym_COLON_QMARK] = ACTIONS(3580),
    [anon_sym_LBRACK] = ACTIONS(3582),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3584),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [aux_sym_char_token1] = ACTIONS(3590),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3592),
    [anon_sym_DQUOTE] = ACTIONS(3594),
    [anon_sym_AT_DQUOTE] = ACTIONS(3596),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3598),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3600),
    [sym_bool] = ACTIONS(3602),
    [sym_unit] = ACTIONS(3604),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3606),
    [sym_op_identifier] = ACTIONS(3608),
    [sym_int] = ACTIONS(3610),
    [sym_xint] = ACTIONS(3612),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2655] = {
    [sym_attributes] = STATE(2632),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(4815),
    [sym__pattern] = STATE(5438),
    [sym_optional_pattern] = STATE(4815),
    [sym_type_check_pattern] = STATE(4815),
    [sym_attribute_pattern] = STATE(4815),
    [sym_paren_pattern] = STATE(4815),
    [sym_as_pattern] = STATE(4815),
    [sym_cons_pattern] = STATE(4815),
    [sym_disjunct_pattern] = STATE(4815),
    [sym_conjunct_pattern] = STATE(4815),
    [sym_typed_pattern] = STATE(4815),
    [sym_list_pattern] = STATE(4815),
    [sym_array_pattern] = STATE(4815),
    [sym_record_pattern] = STATE(4815),
    [sym_named_field_pattern] = STATE(4815),
    [sym_identifier_pattern] = STATE(4815),
    [sym_long_identifier_or_op] = STATE(2475),
    [sym_char] = STATE(4765),
    [sym_format_string] = STATE(4746),
    [sym__string_literal] = STATE(4746),
    [sym_string] = STATE(4765),
    [sym_verbatim_string] = STATE(4765),
    [sym_bytearray] = STATE(4765),
    [sym_verbatim_bytearray] = STATE(4765),
    [sym_format_triple_quoted_string] = STATE(4720),
    [sym_triple_quoted_string] = STATE(4765),
    [sym_const] = STATE(4815),
    [sym_long_identifier] = STATE(3655),
    [sym_active_pattern] = STATE(3734),
    [sym__identifier_or_op] = STATE(3737),
    [sym_sbyte] = STATE(4765),
    [sym_byte] = STATE(4765),
    [sym_int16] = STATE(4765),
    [sym_uint16] = STATE(4765),
    [sym_int32] = STATE(4765),
    [sym_uint32] = STATE(4765),
    [sym_nativeint] = STATE(4765),
    [sym_unativeint] = STATE(4765),
    [sym_int64] = STATE(4765),
    [sym_uint64] = STATE(4765),
    [sym_ieee32] = STATE(4765),
    [sym_ieee64] = STATE(4765),
    [sym_bignum] = STATE(4765),
    [sym_decimal] = STATE(4765),
    [sym_float] = STATE(4512),
    [sym_block_comment] = STATE(2655),
    [sym_compiler_directive_decl] = STATE(2655),
    [sym_fsi_directive_decl] = STATE(2655),
    [sym_preproc_line] = STATE(2655),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(4488),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_LPAREN] = ACTIONS(3572),
    [anon_sym_null] = ACTIONS(3574),
    [anon_sym__] = ACTIONS(3576),
    [anon_sym_QMARK] = ACTIONS(4202),
    [anon_sym_COLON_QMARK] = ACTIONS(4204),
    [anon_sym_LBRACK] = ACTIONS(3582),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3584),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [aux_sym_char_token1] = ACTIONS(3590),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3592),
    [anon_sym_DQUOTE] = ACTIONS(3594),
    [anon_sym_AT_DQUOTE] = ACTIONS(3596),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3598),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3600),
    [sym_bool] = ACTIONS(3602),
    [sym_unit] = ACTIONS(3604),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4212),
    [sym_op_identifier] = ACTIONS(4214),
    [sym_int] = ACTIONS(3610),
    [sym_xint] = ACTIONS(3612),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2656] = {
    [sym_attributes] = STATE(2630),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(3640),
    [sym__pattern] = STATE(3491),
    [sym_optional_pattern] = STATE(3640),
    [sym_type_check_pattern] = STATE(3640),
    [sym_attribute_pattern] = STATE(3640),
    [sym_paren_pattern] = STATE(3640),
    [sym_as_pattern] = STATE(3640),
    [sym_cons_pattern] = STATE(3640),
    [sym_disjunct_pattern] = STATE(3640),
    [sym_conjunct_pattern] = STATE(3640),
    [sym_typed_pattern] = STATE(3640),
    [sym_list_pattern] = STATE(3640),
    [sym_array_pattern] = STATE(3640),
    [sym_record_pattern] = STATE(3640),
    [sym_named_field_pattern] = STATE(3640),
    [sym_identifier_pattern] = STATE(3640),
    [sym_long_identifier_or_op] = STATE(2393),
    [sym_char] = STATE(3606),
    [sym_format_string] = STATE(3688),
    [sym__string_literal] = STATE(3688),
    [sym_string] = STATE(3606),
    [sym_verbatim_string] = STATE(3606),
    [sym_bytearray] = STATE(3606),
    [sym_verbatim_bytearray] = STATE(3606),
    [sym_format_triple_quoted_string] = STATE(3686),
    [sym_triple_quoted_string] = STATE(3606),
    [sym_const] = STATE(3640),
    [sym_long_identifier] = STATE(3437),
    [sym_active_pattern] = STATE(3653),
    [sym__identifier_or_op] = STATE(3660),
    [sym_sbyte] = STATE(3606),
    [sym_byte] = STATE(3606),
    [sym_int16] = STATE(3606),
    [sym_uint16] = STATE(3606),
    [sym_int32] = STATE(3606),
    [sym_uint32] = STATE(3606),
    [sym_nativeint] = STATE(3606),
    [sym_unativeint] = STATE(3606),
    [sym_int64] = STATE(3606),
    [sym_uint64] = STATE(3606),
    [sym_ieee32] = STATE(3606),
    [sym_ieee64] = STATE(3606),
    [sym_bignum] = STATE(3606),
    [sym_decimal] = STATE(3606),
    [sym_float] = STATE(3332),
    [sym_block_comment] = STATE(2656),
    [sym_compiler_directive_decl] = STATE(2656),
    [sym_fsi_directive_decl] = STATE(2656),
    [sym_preproc_line] = STATE(2656),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(4073),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_LPAREN] = ACTIONS(4256),
    [anon_sym_null] = ACTIONS(4258),
    [anon_sym__] = ACTIONS(4260),
    [anon_sym_QMARK] = ACTIONS(4262),
    [anon_sym_COLON_QMARK] = ACTIONS(4264),
    [anon_sym_LBRACK] = ACTIONS(4266),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4268),
    [anon_sym_LBRACE] = ACTIONS(4270),
    [aux_sym_char_token1] = ACTIONS(4272),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4274),
    [anon_sym_DQUOTE] = ACTIONS(4276),
    [anon_sym_AT_DQUOTE] = ACTIONS(4278),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4280),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4282),
    [sym_bool] = ACTIONS(4284),
    [sym_unit] = ACTIONS(4286),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4117),
    [sym_op_identifier] = ACTIONS(4119),
    [sym_int] = ACTIONS(4288),
    [sym_xint] = ACTIONS(4290),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2657] = {
    [sym_attributes] = STATE(2632),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(4815),
    [sym__pattern] = STATE(5432),
    [sym_optional_pattern] = STATE(4815),
    [sym_type_check_pattern] = STATE(4815),
    [sym_attribute_pattern] = STATE(4815),
    [sym_paren_pattern] = STATE(4815),
    [sym_as_pattern] = STATE(4815),
    [sym_cons_pattern] = STATE(4815),
    [sym_disjunct_pattern] = STATE(4815),
    [sym_conjunct_pattern] = STATE(4815),
    [sym_typed_pattern] = STATE(4815),
    [sym_list_pattern] = STATE(4815),
    [sym_array_pattern] = STATE(4815),
    [sym_record_pattern] = STATE(4815),
    [sym_named_field_pattern] = STATE(4815),
    [sym_identifier_pattern] = STATE(4815),
    [sym_long_identifier_or_op] = STATE(2475),
    [sym_char] = STATE(4765),
    [sym_format_string] = STATE(4746),
    [sym__string_literal] = STATE(4746),
    [sym_string] = STATE(4765),
    [sym_verbatim_string] = STATE(4765),
    [sym_bytearray] = STATE(4765),
    [sym_verbatim_bytearray] = STATE(4765),
    [sym_format_triple_quoted_string] = STATE(4720),
    [sym_triple_quoted_string] = STATE(4765),
    [sym_const] = STATE(4815),
    [sym_long_identifier] = STATE(3655),
    [sym_active_pattern] = STATE(3734),
    [sym__identifier_or_op] = STATE(3737),
    [sym_sbyte] = STATE(4765),
    [sym_byte] = STATE(4765),
    [sym_int16] = STATE(4765),
    [sym_uint16] = STATE(4765),
    [sym_int32] = STATE(4765),
    [sym_uint32] = STATE(4765),
    [sym_nativeint] = STATE(4765),
    [sym_unativeint] = STATE(4765),
    [sym_int64] = STATE(4765),
    [sym_uint64] = STATE(4765),
    [sym_ieee32] = STATE(4765),
    [sym_ieee64] = STATE(4765),
    [sym_bignum] = STATE(4765),
    [sym_decimal] = STATE(4765),
    [sym_float] = STATE(4512),
    [sym_block_comment] = STATE(2657),
    [sym_compiler_directive_decl] = STATE(2657),
    [sym_fsi_directive_decl] = STATE(2657),
    [sym_preproc_line] = STATE(2657),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(4474),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_LPAREN] = ACTIONS(3572),
    [anon_sym_null] = ACTIONS(3574),
    [anon_sym__] = ACTIONS(3576),
    [anon_sym_QMARK] = ACTIONS(4202),
    [anon_sym_COLON_QMARK] = ACTIONS(4204),
    [anon_sym_LBRACK] = ACTIONS(3582),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3584),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [aux_sym_char_token1] = ACTIONS(3590),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3592),
    [anon_sym_DQUOTE] = ACTIONS(3594),
    [anon_sym_AT_DQUOTE] = ACTIONS(3596),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3598),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3600),
    [sym_bool] = ACTIONS(3602),
    [sym_unit] = ACTIONS(3604),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4212),
    [sym_op_identifier] = ACTIONS(4214),
    [sym_int] = ACTIONS(3610),
    [sym_xint] = ACTIONS(3612),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2658] = {
    [sym_attributes] = STATE(2632),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(4815),
    [sym__pattern] = STATE(5457),
    [sym_optional_pattern] = STATE(4815),
    [sym_type_check_pattern] = STATE(4815),
    [sym_attribute_pattern] = STATE(4815),
    [sym_paren_pattern] = STATE(4815),
    [sym_as_pattern] = STATE(4815),
    [sym_cons_pattern] = STATE(4815),
    [sym_disjunct_pattern] = STATE(4815),
    [sym_conjunct_pattern] = STATE(4815),
    [sym_typed_pattern] = STATE(4815),
    [sym_list_pattern] = STATE(4815),
    [sym_array_pattern] = STATE(4815),
    [sym_record_pattern] = STATE(4815),
    [sym_named_field_pattern] = STATE(4815),
    [sym_identifier_pattern] = STATE(4815),
    [sym_long_identifier_or_op] = STATE(2475),
    [sym_char] = STATE(4765),
    [sym_format_string] = STATE(4746),
    [sym__string_literal] = STATE(4746),
    [sym_string] = STATE(4765),
    [sym_verbatim_string] = STATE(4765),
    [sym_bytearray] = STATE(4765),
    [sym_verbatim_bytearray] = STATE(4765),
    [sym_format_triple_quoted_string] = STATE(4720),
    [sym_triple_quoted_string] = STATE(4765),
    [sym_const] = STATE(4815),
    [sym_long_identifier] = STATE(3655),
    [sym_active_pattern] = STATE(3734),
    [sym__identifier_or_op] = STATE(3737),
    [sym_sbyte] = STATE(4765),
    [sym_byte] = STATE(4765),
    [sym_int16] = STATE(4765),
    [sym_uint16] = STATE(4765),
    [sym_int32] = STATE(4765),
    [sym_uint32] = STATE(4765),
    [sym_nativeint] = STATE(4765),
    [sym_unativeint] = STATE(4765),
    [sym_int64] = STATE(4765),
    [sym_uint64] = STATE(4765),
    [sym_ieee32] = STATE(4765),
    [sym_ieee64] = STATE(4765),
    [sym_bignum] = STATE(4765),
    [sym_decimal] = STATE(4765),
    [sym_float] = STATE(4512),
    [sym_block_comment] = STATE(2658),
    [sym_compiler_directive_decl] = STATE(2658),
    [sym_fsi_directive_decl] = STATE(2658),
    [sym_preproc_line] = STATE(2658),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(4196),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_LPAREN] = ACTIONS(3572),
    [anon_sym_null] = ACTIONS(3574),
    [anon_sym__] = ACTIONS(3576),
    [anon_sym_QMARK] = ACTIONS(4202),
    [anon_sym_COLON_QMARK] = ACTIONS(4204),
    [anon_sym_LBRACK] = ACTIONS(3582),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3584),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [aux_sym_char_token1] = ACTIONS(3590),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3592),
    [anon_sym_DQUOTE] = ACTIONS(3594),
    [anon_sym_AT_DQUOTE] = ACTIONS(3596),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3598),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3600),
    [sym_bool] = ACTIONS(3602),
    [sym_unit] = ACTIONS(3604),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4212),
    [sym_op_identifier] = ACTIONS(4214),
    [sym_int] = ACTIONS(3610),
    [sym_xint] = ACTIONS(3612),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2659] = {
    [sym_attributes] = STATE(2652),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(3588),
    [sym__pattern] = STATE(3542),
    [sym_optional_pattern] = STATE(3588),
    [sym_type_check_pattern] = STATE(3588),
    [sym_attribute_pattern] = STATE(3588),
    [sym_paren_pattern] = STATE(3588),
    [sym_as_pattern] = STATE(3588),
    [sym_cons_pattern] = STATE(3588),
    [sym_disjunct_pattern] = STATE(3588),
    [sym_conjunct_pattern] = STATE(3588),
    [sym_typed_pattern] = STATE(3588),
    [sym_list_pattern] = STATE(3588),
    [sym_array_pattern] = STATE(3588),
    [sym_record_pattern] = STATE(3588),
    [sym_named_field_pattern] = STATE(3588),
    [sym_identifier_pattern] = STATE(3588),
    [sym_long_identifier_or_op] = STATE(2401),
    [sym_char] = STATE(3658),
    [sym_format_string] = STATE(3670),
    [sym__string_literal] = STATE(3670),
    [sym_string] = STATE(3658),
    [sym_verbatim_string] = STATE(3658),
    [sym_bytearray] = STATE(3658),
    [sym_verbatim_bytearray] = STATE(3658),
    [sym_format_triple_quoted_string] = STATE(3673),
    [sym_triple_quoted_string] = STATE(3658),
    [sym_const] = STATE(3588),
    [sym_long_identifier] = STATE(3493),
    [sym_active_pattern] = STATE(3613),
    [sym__identifier_or_op] = STATE(3650),
    [sym_sbyte] = STATE(3658),
    [sym_byte] = STATE(3658),
    [sym_int16] = STATE(3658),
    [sym_uint16] = STATE(3658),
    [sym_int32] = STATE(3658),
    [sym_uint32] = STATE(3658),
    [sym_nativeint] = STATE(3658),
    [sym_unativeint] = STATE(3658),
    [sym_int64] = STATE(3658),
    [sym_uint64] = STATE(3658),
    [sym_ieee32] = STATE(3658),
    [sym_ieee64] = STATE(3658),
    [sym_bignum] = STATE(3658),
    [sym_decimal] = STATE(3658),
    [sym_float] = STATE(3376),
    [sym_block_comment] = STATE(2659),
    [sym_compiler_directive_decl] = STATE(2659),
    [sym_fsi_directive_decl] = STATE(2659),
    [sym_preproc_line] = STATE(2659),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(4175),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_LPAREN] = ACTIONS(4218),
    [anon_sym_null] = ACTIONS(4220),
    [anon_sym__] = ACTIONS(4222),
    [anon_sym_QMARK] = ACTIONS(4224),
    [anon_sym_COLON_QMARK] = ACTIONS(4226),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4230),
    [anon_sym_LBRACE] = ACTIONS(4232),
    [aux_sym_char_token1] = ACTIONS(4234),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4236),
    [anon_sym_DQUOTE] = ACTIONS(4238),
    [anon_sym_AT_DQUOTE] = ACTIONS(4240),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4242),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4244),
    [sym_bool] = ACTIONS(4246),
    [sym_unit] = ACTIONS(4248),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4181),
    [sym_op_identifier] = ACTIONS(4183),
    [sym_int] = ACTIONS(4250),
    [sym_xint] = ACTIONS(4252),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2660] = {
    [sym_attributes] = STATE(2641),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(5241),
    [sym__pattern] = STATE(5091),
    [sym_optional_pattern] = STATE(5241),
    [sym_type_check_pattern] = STATE(5241),
    [sym_attribute_pattern] = STATE(5241),
    [sym_paren_pattern] = STATE(5241),
    [sym_as_pattern] = STATE(5241),
    [sym_cons_pattern] = STATE(5241),
    [sym_disjunct_pattern] = STATE(5241),
    [sym_conjunct_pattern] = STATE(5241),
    [sym_typed_pattern] = STATE(5241),
    [sym_list_pattern] = STATE(5241),
    [sym_array_pattern] = STATE(5241),
    [sym_record_pattern] = STATE(5241),
    [sym_named_field_pattern] = STATE(5241),
    [sym_identifier_pattern] = STATE(5241),
    [sym_long_identifier_or_op] = STATE(1721),
    [sym_char] = STATE(5389),
    [sym_format_string] = STATE(5273),
    [sym__string_literal] = STATE(5273),
    [sym_string] = STATE(5389),
    [sym_verbatim_string] = STATE(5389),
    [sym_bytearray] = STATE(5389),
    [sym_verbatim_bytearray] = STATE(5389),
    [sym_format_triple_quoted_string] = STATE(5377),
    [sym_triple_quoted_string] = STATE(5389),
    [sym_const] = STATE(5241),
    [sym_long_identifier] = STATE(3363),
    [sym_active_pattern] = STATE(3521),
    [sym__identifier_or_op] = STATE(3510),
    [sym_sbyte] = STATE(5389),
    [sym_byte] = STATE(5389),
    [sym_int16] = STATE(5389),
    [sym_uint16] = STATE(5389),
    [sym_int32] = STATE(5389),
    [sym_uint32] = STATE(5389),
    [sym_nativeint] = STATE(5389),
    [sym_unativeint] = STATE(5389),
    [sym_int64] = STATE(5389),
    [sym_uint64] = STATE(5389),
    [sym_ieee32] = STATE(5389),
    [sym_ieee64] = STATE(5389),
    [sym_bignum] = STATE(5389),
    [sym_decimal] = STATE(5389),
    [sym_float] = STATE(4893),
    [sym_block_comment] = STATE(2660),
    [sym_compiler_directive_decl] = STATE(2660),
    [sym_fsi_directive_decl] = STATE(2660),
    [sym_preproc_line] = STATE(2660),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(3870),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_LPAREN] = ACTIONS(3872),
    [anon_sym_null] = ACTIONS(3874),
    [anon_sym__] = ACTIONS(3876),
    [anon_sym_QMARK] = ACTIONS(3878),
    [anon_sym_COLON_QMARK] = ACTIONS(3880),
    [anon_sym_LBRACK] = ACTIONS(3882),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3884),
    [anon_sym_LBRACE] = ACTIONS(3886),
    [aux_sym_char_token1] = ACTIONS(3888),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3890),
    [anon_sym_DQUOTE] = ACTIONS(3892),
    [anon_sym_AT_DQUOTE] = ACTIONS(3894),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3896),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3898),
    [sym_bool] = ACTIONS(3900),
    [sym_unit] = ACTIONS(3902),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3904),
    [sym_op_identifier] = ACTIONS(3906),
    [sym_int] = ACTIONS(3908),
    [sym_xint] = ACTIONS(3910),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2661] = {
    [sym_attributes] = STATE(2689),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(3731),
    [sym__pattern] = STATE(3639),
    [sym_optional_pattern] = STATE(3731),
    [sym_type_check_pattern] = STATE(3731),
    [sym_attribute_pattern] = STATE(3731),
    [sym_paren_pattern] = STATE(3731),
    [sym_as_pattern] = STATE(3731),
    [sym_cons_pattern] = STATE(3731),
    [sym_disjunct_pattern] = STATE(3731),
    [sym_conjunct_pattern] = STATE(3731),
    [sym_typed_pattern] = STATE(3731),
    [sym_list_pattern] = STATE(3731),
    [sym_array_pattern] = STATE(3731),
    [sym_record_pattern] = STATE(3731),
    [sym_named_field_pattern] = STATE(3731),
    [sym_identifier_pattern] = STATE(3731),
    [sym_long_identifier_or_op] = STATE(2472),
    [sym_char] = STATE(3709),
    [sym_format_string] = STATE(3712),
    [sym__string_literal] = STATE(3712),
    [sym_string] = STATE(3709),
    [sym_verbatim_string] = STATE(3709),
    [sym_bytearray] = STATE(3709),
    [sym_verbatim_bytearray] = STATE(3709),
    [sym_format_triple_quoted_string] = STATE(3716),
    [sym_triple_quoted_string] = STATE(3709),
    [sym_const] = STATE(3731),
    [sym_long_identifier] = STATE(3655),
    [sym_active_pattern] = STATE(3734),
    [sym__identifier_or_op] = STATE(3737),
    [sym_sbyte] = STATE(3709),
    [sym_byte] = STATE(3709),
    [sym_int16] = STATE(3709),
    [sym_uint16] = STATE(3709),
    [sym_int32] = STATE(3709),
    [sym_uint32] = STATE(3709),
    [sym_nativeint] = STATE(3709),
    [sym_unativeint] = STATE(3709),
    [sym_int64] = STATE(3709),
    [sym_uint64] = STATE(3709),
    [sym_ieee32] = STATE(3709),
    [sym_ieee64] = STATE(3709),
    [sym_bignum] = STATE(3709),
    [sym_decimal] = STATE(3709),
    [sym_float] = STATE(3489),
    [sym_block_comment] = STATE(2661),
    [sym_compiler_directive_decl] = STATE(2661),
    [sym_fsi_directive_decl] = STATE(2661),
    [sym_preproc_line] = STATE(2661),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(4196),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_LPAREN] = ACTIONS(4308),
    [anon_sym_null] = ACTIONS(4310),
    [anon_sym__] = ACTIONS(4312),
    [anon_sym_QMARK] = ACTIONS(4314),
    [anon_sym_COLON_QMARK] = ACTIONS(4316),
    [anon_sym_LBRACK] = ACTIONS(4318),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4320),
    [anon_sym_LBRACE] = ACTIONS(4322),
    [aux_sym_char_token1] = ACTIONS(4324),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4326),
    [anon_sym_DQUOTE] = ACTIONS(4328),
    [anon_sym_AT_DQUOTE] = ACTIONS(4330),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4332),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4334),
    [sym_bool] = ACTIONS(4336),
    [sym_unit] = ACTIONS(4338),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4212),
    [sym_op_identifier] = ACTIONS(4214),
    [sym_int] = ACTIONS(4340),
    [sym_xint] = ACTIONS(4342),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2662] = {
    [sym_attributes] = STATE(2641),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(5241),
    [sym__pattern] = STATE(5089),
    [sym_optional_pattern] = STATE(5241),
    [sym_type_check_pattern] = STATE(5241),
    [sym_attribute_pattern] = STATE(5241),
    [sym_paren_pattern] = STATE(5241),
    [sym_as_pattern] = STATE(5241),
    [sym_cons_pattern] = STATE(5241),
    [sym_disjunct_pattern] = STATE(5241),
    [sym_conjunct_pattern] = STATE(5241),
    [sym_typed_pattern] = STATE(5241),
    [sym_list_pattern] = STATE(5241),
    [sym_array_pattern] = STATE(5241),
    [sym_record_pattern] = STATE(5241),
    [sym_named_field_pattern] = STATE(5241),
    [sym_identifier_pattern] = STATE(5241),
    [sym_long_identifier_or_op] = STATE(1721),
    [sym_char] = STATE(5389),
    [sym_format_string] = STATE(5273),
    [sym__string_literal] = STATE(5273),
    [sym_string] = STATE(5389),
    [sym_verbatim_string] = STATE(5389),
    [sym_bytearray] = STATE(5389),
    [sym_verbatim_bytearray] = STATE(5389),
    [sym_format_triple_quoted_string] = STATE(5377),
    [sym_triple_quoted_string] = STATE(5389),
    [sym_const] = STATE(5241),
    [sym_long_identifier] = STATE(3363),
    [sym_active_pattern] = STATE(3521),
    [sym__identifier_or_op] = STATE(3510),
    [sym_sbyte] = STATE(5389),
    [sym_byte] = STATE(5389),
    [sym_int16] = STATE(5389),
    [sym_uint16] = STATE(5389),
    [sym_int32] = STATE(5389),
    [sym_uint32] = STATE(5389),
    [sym_nativeint] = STATE(5389),
    [sym_unativeint] = STATE(5389),
    [sym_int64] = STATE(5389),
    [sym_uint64] = STATE(5389),
    [sym_ieee32] = STATE(5389),
    [sym_ieee64] = STATE(5389),
    [sym_bignum] = STATE(5389),
    [sym_decimal] = STATE(5389),
    [sym_float] = STATE(4893),
    [sym_block_comment] = STATE(2662),
    [sym_compiler_directive_decl] = STATE(2662),
    [sym_fsi_directive_decl] = STATE(2662),
    [sym_preproc_line] = STATE(2662),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(3870),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_LPAREN] = ACTIONS(3872),
    [anon_sym_null] = ACTIONS(3874),
    [anon_sym__] = ACTIONS(3876),
    [anon_sym_QMARK] = ACTIONS(3878),
    [anon_sym_COLON_QMARK] = ACTIONS(3880),
    [anon_sym_LBRACK] = ACTIONS(3882),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3884),
    [anon_sym_LBRACE] = ACTIONS(3886),
    [aux_sym_char_token1] = ACTIONS(3888),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3890),
    [anon_sym_DQUOTE] = ACTIONS(3892),
    [anon_sym_AT_DQUOTE] = ACTIONS(3894),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3896),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3898),
    [sym_bool] = ACTIONS(3900),
    [sym_unit] = ACTIONS(3902),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3904),
    [sym_op_identifier] = ACTIONS(3906),
    [sym_int] = ACTIONS(3908),
    [sym_xint] = ACTIONS(3910),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2663] = {
    [sym_attributes] = STATE(2689),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(3731),
    [sym__pattern] = STATE(3593),
    [sym_optional_pattern] = STATE(3731),
    [sym_type_check_pattern] = STATE(3731),
    [sym_attribute_pattern] = STATE(3731),
    [sym_paren_pattern] = STATE(3731),
    [sym_as_pattern] = STATE(3731),
    [sym_cons_pattern] = STATE(3731),
    [sym_disjunct_pattern] = STATE(3731),
    [sym_conjunct_pattern] = STATE(3731),
    [sym_typed_pattern] = STATE(3731),
    [sym_list_pattern] = STATE(3731),
    [sym_array_pattern] = STATE(3731),
    [sym_record_pattern] = STATE(3731),
    [sym_named_field_pattern] = STATE(3731),
    [sym_identifier_pattern] = STATE(3731),
    [sym_long_identifier_or_op] = STATE(2472),
    [sym_char] = STATE(3709),
    [sym_format_string] = STATE(3712),
    [sym__string_literal] = STATE(3712),
    [sym_string] = STATE(3709),
    [sym_verbatim_string] = STATE(3709),
    [sym_bytearray] = STATE(3709),
    [sym_verbatim_bytearray] = STATE(3709),
    [sym_format_triple_quoted_string] = STATE(3716),
    [sym_triple_quoted_string] = STATE(3709),
    [sym_const] = STATE(3731),
    [sym_long_identifier] = STATE(3655),
    [sym_active_pattern] = STATE(3734),
    [sym__identifier_or_op] = STATE(3737),
    [sym_sbyte] = STATE(3709),
    [sym_byte] = STATE(3709),
    [sym_int16] = STATE(3709),
    [sym_uint16] = STATE(3709),
    [sym_int32] = STATE(3709),
    [sym_uint32] = STATE(3709),
    [sym_nativeint] = STATE(3709),
    [sym_unativeint] = STATE(3709),
    [sym_int64] = STATE(3709),
    [sym_uint64] = STATE(3709),
    [sym_ieee32] = STATE(3709),
    [sym_ieee64] = STATE(3709),
    [sym_bignum] = STATE(3709),
    [sym_decimal] = STATE(3709),
    [sym_float] = STATE(3489),
    [sym_block_comment] = STATE(2663),
    [sym_compiler_directive_decl] = STATE(2663),
    [sym_fsi_directive_decl] = STATE(2663),
    [sym_preproc_line] = STATE(2663),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(4196),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_LPAREN] = ACTIONS(4308),
    [anon_sym_null] = ACTIONS(4310),
    [anon_sym__] = ACTIONS(4312),
    [anon_sym_QMARK] = ACTIONS(4314),
    [anon_sym_COLON_QMARK] = ACTIONS(4316),
    [anon_sym_LBRACK] = ACTIONS(4318),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4320),
    [anon_sym_LBRACE] = ACTIONS(4322),
    [aux_sym_char_token1] = ACTIONS(4324),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4326),
    [anon_sym_DQUOTE] = ACTIONS(4328),
    [anon_sym_AT_DQUOTE] = ACTIONS(4330),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4332),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4334),
    [sym_bool] = ACTIONS(4336),
    [sym_unit] = ACTIONS(4338),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4212),
    [sym_op_identifier] = ACTIONS(4214),
    [sym_int] = ACTIONS(4340),
    [sym_xint] = ACTIONS(4342),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2664] = {
    [sym_attributes] = STATE(2636),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(3546),
    [sym__pattern] = STATE(3385),
    [sym_optional_pattern] = STATE(3546),
    [sym_type_check_pattern] = STATE(3546),
    [sym_attribute_pattern] = STATE(3546),
    [sym_paren_pattern] = STATE(3546),
    [sym_as_pattern] = STATE(3546),
    [sym_cons_pattern] = STATE(3546),
    [sym_disjunct_pattern] = STATE(3546),
    [sym_conjunct_pattern] = STATE(3546),
    [sym_typed_pattern] = STATE(3546),
    [sym_list_pattern] = STATE(3546),
    [sym_array_pattern] = STATE(3546),
    [sym_record_pattern] = STATE(3546),
    [sym_named_field_pattern] = STATE(3546),
    [sym_identifier_pattern] = STATE(3546),
    [sym_long_identifier_or_op] = STATE(1834),
    [sym_char] = STATE(3509),
    [sym_format_string] = STATE(3517),
    [sym__string_literal] = STATE(3517),
    [sym_string] = STATE(3509),
    [sym_verbatim_string] = STATE(3509),
    [sym_bytearray] = STATE(3509),
    [sym_verbatim_bytearray] = STATE(3509),
    [sym_format_triple_quoted_string] = STATE(3519),
    [sym_triple_quoted_string] = STATE(3509),
    [sym_const] = STATE(3546),
    [sym_long_identifier] = STATE(3320),
    [sym_active_pattern] = STATE(3488),
    [sym__identifier_or_op] = STATE(3410),
    [sym_sbyte] = STATE(3509),
    [sym_byte] = STATE(3509),
    [sym_int16] = STATE(3509),
    [sym_uint16] = STATE(3509),
    [sym_int32] = STATE(3509),
    [sym_uint32] = STATE(3509),
    [sym_nativeint] = STATE(3509),
    [sym_unativeint] = STATE(3509),
    [sym_int64] = STATE(3509),
    [sym_uint64] = STATE(3509),
    [sym_ieee32] = STATE(3509),
    [sym_ieee64] = STATE(3509),
    [sym_bignum] = STATE(3509),
    [sym_decimal] = STATE(3509),
    [sym_float] = STATE(3291),
    [sym_block_comment] = STATE(2664),
    [sym_compiler_directive_decl] = STATE(2664),
    [sym_fsi_directive_decl] = STATE(2664),
    [sym_preproc_line] = STATE(2664),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(3562),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_LPAREN] = ACTIONS(4014),
    [anon_sym_null] = ACTIONS(4016),
    [anon_sym__] = ACTIONS(4018),
    [anon_sym_QMARK] = ACTIONS(4020),
    [anon_sym_COLON_QMARK] = ACTIONS(4022),
    [anon_sym_LBRACK] = ACTIONS(4024),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4026),
    [anon_sym_LBRACE] = ACTIONS(4028),
    [aux_sym_char_token1] = ACTIONS(4030),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4032),
    [anon_sym_DQUOTE] = ACTIONS(4034),
    [anon_sym_AT_DQUOTE] = ACTIONS(4036),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4038),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4040),
    [sym_bool] = ACTIONS(4042),
    [sym_unit] = ACTIONS(4044),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3606),
    [sym_op_identifier] = ACTIONS(3608),
    [sym_int] = ACTIONS(4046),
    [sym_xint] = ACTIONS(4048),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2665] = {
    [sym_attributes] = STATE(2699),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(4815),
    [sym__pattern] = STATE(5183),
    [sym_optional_pattern] = STATE(4815),
    [sym_type_check_pattern] = STATE(4815),
    [sym_attribute_pattern] = STATE(4815),
    [sym_paren_pattern] = STATE(4815),
    [sym_as_pattern] = STATE(4815),
    [sym_cons_pattern] = STATE(4815),
    [sym_disjunct_pattern] = STATE(4815),
    [sym_conjunct_pattern] = STATE(4815),
    [sym_typed_pattern] = STATE(4815),
    [sym_list_pattern] = STATE(4815),
    [sym_array_pattern] = STATE(4815),
    [sym_record_pattern] = STATE(4815),
    [sym_named_field_pattern] = STATE(4815),
    [sym_identifier_pattern] = STATE(4815),
    [sym_long_identifier_or_op] = STATE(2193),
    [sym_char] = STATE(4765),
    [sym_format_string] = STATE(4746),
    [sym__string_literal] = STATE(4746),
    [sym_string] = STATE(4765),
    [sym_verbatim_string] = STATE(4765),
    [sym_bytearray] = STATE(4765),
    [sym_verbatim_bytearray] = STATE(4765),
    [sym_format_triple_quoted_string] = STATE(4720),
    [sym_triple_quoted_string] = STATE(4765),
    [sym_const] = STATE(4815),
    [sym_long_identifier] = STATE(3493),
    [sym_active_pattern] = STATE(3613),
    [sym__identifier_or_op] = STATE(3650),
    [sym_sbyte] = STATE(4765),
    [sym_byte] = STATE(4765),
    [sym_int16] = STATE(4765),
    [sym_uint16] = STATE(4765),
    [sym_int32] = STATE(4765),
    [sym_uint32] = STATE(4765),
    [sym_nativeint] = STATE(4765),
    [sym_unativeint] = STATE(4765),
    [sym_int64] = STATE(4765),
    [sym_uint64] = STATE(4765),
    [sym_ieee32] = STATE(4765),
    [sym_ieee64] = STATE(4765),
    [sym_bignum] = STATE(4765),
    [sym_decimal] = STATE(4765),
    [sym_float] = STATE(4512),
    [sym_block_comment] = STATE(2665),
    [sym_compiler_directive_decl] = STATE(2665),
    [sym_fsi_directive_decl] = STATE(2665),
    [sym_preproc_line] = STATE(2665),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(4175),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_LPAREN] = ACTIONS(3572),
    [anon_sym_null] = ACTIONS(3574),
    [anon_sym__] = ACTIONS(3576),
    [anon_sym_QMARK] = ACTIONS(4177),
    [anon_sym_COLON_QMARK] = ACTIONS(4179),
    [anon_sym_LBRACK] = ACTIONS(3582),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3584),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [aux_sym_char_token1] = ACTIONS(3590),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3592),
    [anon_sym_DQUOTE] = ACTIONS(3594),
    [anon_sym_AT_DQUOTE] = ACTIONS(3596),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3598),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3600),
    [sym_bool] = ACTIONS(3602),
    [sym_unit] = ACTIONS(3604),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4181),
    [sym_op_identifier] = ACTIONS(4183),
    [sym_int] = ACTIONS(3610),
    [sym_xint] = ACTIONS(3612),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2666] = {
    [sym_attributes] = STATE(2641),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(5241),
    [sym__pattern] = STATE(5086),
    [sym_optional_pattern] = STATE(5241),
    [sym_type_check_pattern] = STATE(5241),
    [sym_attribute_pattern] = STATE(5241),
    [sym_paren_pattern] = STATE(5241),
    [sym_as_pattern] = STATE(5241),
    [sym_cons_pattern] = STATE(5241),
    [sym_disjunct_pattern] = STATE(5241),
    [sym_conjunct_pattern] = STATE(5241),
    [sym_typed_pattern] = STATE(5241),
    [sym_list_pattern] = STATE(5241),
    [sym_array_pattern] = STATE(5241),
    [sym_record_pattern] = STATE(5241),
    [sym_named_field_pattern] = STATE(5241),
    [sym_identifier_pattern] = STATE(5241),
    [sym_long_identifier_or_op] = STATE(1721),
    [sym_char] = STATE(5389),
    [sym_format_string] = STATE(5273),
    [sym__string_literal] = STATE(5273),
    [sym_string] = STATE(5389),
    [sym_verbatim_string] = STATE(5389),
    [sym_bytearray] = STATE(5389),
    [sym_verbatim_bytearray] = STATE(5389),
    [sym_format_triple_quoted_string] = STATE(5377),
    [sym_triple_quoted_string] = STATE(5389),
    [sym_const] = STATE(5241),
    [sym_long_identifier] = STATE(3363),
    [sym_active_pattern] = STATE(3521),
    [sym__identifier_or_op] = STATE(3510),
    [sym_sbyte] = STATE(5389),
    [sym_byte] = STATE(5389),
    [sym_int16] = STATE(5389),
    [sym_uint16] = STATE(5389),
    [sym_int32] = STATE(5389),
    [sym_uint32] = STATE(5389),
    [sym_nativeint] = STATE(5389),
    [sym_unativeint] = STATE(5389),
    [sym_int64] = STATE(5389),
    [sym_uint64] = STATE(5389),
    [sym_ieee32] = STATE(5389),
    [sym_ieee64] = STATE(5389),
    [sym_bignum] = STATE(5389),
    [sym_decimal] = STATE(5389),
    [sym_float] = STATE(4893),
    [sym_block_comment] = STATE(2666),
    [sym_compiler_directive_decl] = STATE(2666),
    [sym_fsi_directive_decl] = STATE(2666),
    [sym_preproc_line] = STATE(2666),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(3870),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_LPAREN] = ACTIONS(3872),
    [anon_sym_null] = ACTIONS(3874),
    [anon_sym__] = ACTIONS(3876),
    [anon_sym_QMARK] = ACTIONS(3878),
    [anon_sym_COLON_QMARK] = ACTIONS(3880),
    [anon_sym_LBRACK] = ACTIONS(3882),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3884),
    [anon_sym_LBRACE] = ACTIONS(3886),
    [aux_sym_char_token1] = ACTIONS(3888),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3890),
    [anon_sym_DQUOTE] = ACTIONS(3892),
    [anon_sym_AT_DQUOTE] = ACTIONS(3894),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3896),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3898),
    [sym_bool] = ACTIONS(3900),
    [sym_unit] = ACTIONS(3902),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3904),
    [sym_op_identifier] = ACTIONS(3906),
    [sym_int] = ACTIONS(3908),
    [sym_xint] = ACTIONS(3910),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2667] = {
    [sym_attributes] = STATE(2636),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(3546),
    [sym__pattern] = STATE(3390),
    [sym_optional_pattern] = STATE(3546),
    [sym_type_check_pattern] = STATE(3546),
    [sym_attribute_pattern] = STATE(3546),
    [sym_paren_pattern] = STATE(3546),
    [sym_as_pattern] = STATE(3546),
    [sym_cons_pattern] = STATE(3546),
    [sym_disjunct_pattern] = STATE(3546),
    [sym_conjunct_pattern] = STATE(3546),
    [sym_typed_pattern] = STATE(3546),
    [sym_list_pattern] = STATE(3546),
    [sym_array_pattern] = STATE(3546),
    [sym_record_pattern] = STATE(3546),
    [sym_named_field_pattern] = STATE(3546),
    [sym_identifier_pattern] = STATE(3546),
    [sym_long_identifier_or_op] = STATE(1834),
    [sym_char] = STATE(3509),
    [sym_format_string] = STATE(3517),
    [sym__string_literal] = STATE(3517),
    [sym_string] = STATE(3509),
    [sym_verbatim_string] = STATE(3509),
    [sym_bytearray] = STATE(3509),
    [sym_verbatim_bytearray] = STATE(3509),
    [sym_format_triple_quoted_string] = STATE(3519),
    [sym_triple_quoted_string] = STATE(3509),
    [sym_const] = STATE(3546),
    [sym_long_identifier] = STATE(3320),
    [sym_active_pattern] = STATE(3488),
    [sym__identifier_or_op] = STATE(3410),
    [sym_sbyte] = STATE(3509),
    [sym_byte] = STATE(3509),
    [sym_int16] = STATE(3509),
    [sym_uint16] = STATE(3509),
    [sym_int32] = STATE(3509),
    [sym_uint32] = STATE(3509),
    [sym_nativeint] = STATE(3509),
    [sym_unativeint] = STATE(3509),
    [sym_int64] = STATE(3509),
    [sym_uint64] = STATE(3509),
    [sym_ieee32] = STATE(3509),
    [sym_ieee64] = STATE(3509),
    [sym_bignum] = STATE(3509),
    [sym_decimal] = STATE(3509),
    [sym_float] = STATE(3291),
    [sym_block_comment] = STATE(2667),
    [sym_compiler_directive_decl] = STATE(2667),
    [sym_fsi_directive_decl] = STATE(2667),
    [sym_preproc_line] = STATE(2667),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(3562),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_LPAREN] = ACTIONS(4014),
    [anon_sym_null] = ACTIONS(4016),
    [anon_sym__] = ACTIONS(4018),
    [anon_sym_QMARK] = ACTIONS(4020),
    [anon_sym_COLON_QMARK] = ACTIONS(4022),
    [anon_sym_LBRACK] = ACTIONS(4024),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4026),
    [anon_sym_LBRACE] = ACTIONS(4028),
    [aux_sym_char_token1] = ACTIONS(4030),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4032),
    [anon_sym_DQUOTE] = ACTIONS(4034),
    [anon_sym_AT_DQUOTE] = ACTIONS(4036),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4038),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4040),
    [sym_bool] = ACTIONS(4042),
    [sym_unit] = ACTIONS(4044),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3606),
    [sym_op_identifier] = ACTIONS(3608),
    [sym_int] = ACTIONS(4046),
    [sym_xint] = ACTIONS(4048),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2668] = {
    [sym_attributes] = STATE(2641),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(5241),
    [sym__pattern] = STATE(5083),
    [sym_optional_pattern] = STATE(5241),
    [sym_type_check_pattern] = STATE(5241),
    [sym_attribute_pattern] = STATE(5241),
    [sym_paren_pattern] = STATE(5241),
    [sym_as_pattern] = STATE(5241),
    [sym_cons_pattern] = STATE(5241),
    [sym_disjunct_pattern] = STATE(5241),
    [sym_conjunct_pattern] = STATE(5241),
    [sym_typed_pattern] = STATE(5241),
    [sym_list_pattern] = STATE(5241),
    [sym_array_pattern] = STATE(5241),
    [sym_record_pattern] = STATE(5241),
    [sym_named_field_pattern] = STATE(5241),
    [sym_identifier_pattern] = STATE(5241),
    [sym_long_identifier_or_op] = STATE(1721),
    [sym_char] = STATE(5389),
    [sym_format_string] = STATE(5273),
    [sym__string_literal] = STATE(5273),
    [sym_string] = STATE(5389),
    [sym_verbatim_string] = STATE(5389),
    [sym_bytearray] = STATE(5389),
    [sym_verbatim_bytearray] = STATE(5389),
    [sym_format_triple_quoted_string] = STATE(5377),
    [sym_triple_quoted_string] = STATE(5389),
    [sym_const] = STATE(5241),
    [sym_long_identifier] = STATE(3363),
    [sym_active_pattern] = STATE(3521),
    [sym__identifier_or_op] = STATE(3510),
    [sym_sbyte] = STATE(5389),
    [sym_byte] = STATE(5389),
    [sym_int16] = STATE(5389),
    [sym_uint16] = STATE(5389),
    [sym_int32] = STATE(5389),
    [sym_uint32] = STATE(5389),
    [sym_nativeint] = STATE(5389),
    [sym_unativeint] = STATE(5389),
    [sym_int64] = STATE(5389),
    [sym_uint64] = STATE(5389),
    [sym_ieee32] = STATE(5389),
    [sym_ieee64] = STATE(5389),
    [sym_bignum] = STATE(5389),
    [sym_decimal] = STATE(5389),
    [sym_float] = STATE(4893),
    [sym_block_comment] = STATE(2668),
    [sym_compiler_directive_decl] = STATE(2668),
    [sym_fsi_directive_decl] = STATE(2668),
    [sym_preproc_line] = STATE(2668),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(3870),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_LPAREN] = ACTIONS(3872),
    [anon_sym_null] = ACTIONS(3874),
    [anon_sym__] = ACTIONS(3876),
    [anon_sym_QMARK] = ACTIONS(3878),
    [anon_sym_COLON_QMARK] = ACTIONS(3880),
    [anon_sym_LBRACK] = ACTIONS(3882),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3884),
    [anon_sym_LBRACE] = ACTIONS(3886),
    [aux_sym_char_token1] = ACTIONS(3888),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3890),
    [anon_sym_DQUOTE] = ACTIONS(3892),
    [anon_sym_AT_DQUOTE] = ACTIONS(3894),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3896),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3898),
    [sym_bool] = ACTIONS(3900),
    [sym_unit] = ACTIONS(3902),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3904),
    [sym_op_identifier] = ACTIONS(3906),
    [sym_int] = ACTIONS(3908),
    [sym_xint] = ACTIONS(3910),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2669] = {
    [sym_attributes] = STATE(2676),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(4815),
    [sym__pattern] = STATE(5453),
    [sym_optional_pattern] = STATE(4815),
    [sym_type_check_pattern] = STATE(4815),
    [sym_attribute_pattern] = STATE(4815),
    [sym_paren_pattern] = STATE(4815),
    [sym_as_pattern] = STATE(4815),
    [sym_cons_pattern] = STATE(4815),
    [sym_disjunct_pattern] = STATE(4815),
    [sym_conjunct_pattern] = STATE(4815),
    [sym_typed_pattern] = STATE(4815),
    [sym_list_pattern] = STATE(4815),
    [sym_array_pattern] = STATE(4815),
    [sym_record_pattern] = STATE(4815),
    [sym_named_field_pattern] = STATE(4815),
    [sym_identifier_pattern] = STATE(4815),
    [sym_long_identifier_or_op] = STATE(1792),
    [sym_char] = STATE(4765),
    [sym_format_string] = STATE(4746),
    [sym__string_literal] = STATE(4746),
    [sym_string] = STATE(4765),
    [sym_verbatim_string] = STATE(4765),
    [sym_bytearray] = STATE(4765),
    [sym_verbatim_bytearray] = STATE(4765),
    [sym_format_triple_quoted_string] = STATE(4720),
    [sym_triple_quoted_string] = STATE(4765),
    [sym_const] = STATE(4815),
    [sym_long_identifier] = STATE(3320),
    [sym_active_pattern] = STATE(3488),
    [sym__identifier_or_op] = STATE(3410),
    [sym_sbyte] = STATE(4765),
    [sym_byte] = STATE(4765),
    [sym_int16] = STATE(4765),
    [sym_uint16] = STATE(4765),
    [sym_int32] = STATE(4765),
    [sym_uint32] = STATE(4765),
    [sym_nativeint] = STATE(4765),
    [sym_unativeint] = STATE(4765),
    [sym_int64] = STATE(4765),
    [sym_uint64] = STATE(4765),
    [sym_ieee32] = STATE(4765),
    [sym_ieee64] = STATE(4765),
    [sym_bignum] = STATE(4765),
    [sym_decimal] = STATE(4765),
    [sym_float] = STATE(4512),
    [sym_block_comment] = STATE(2669),
    [sym_compiler_directive_decl] = STATE(2669),
    [sym_fsi_directive_decl] = STATE(2669),
    [sym_preproc_line] = STATE(2669),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(3562),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_LPAREN] = ACTIONS(3572),
    [anon_sym_null] = ACTIONS(3574),
    [anon_sym__] = ACTIONS(3576),
    [anon_sym_QMARK] = ACTIONS(3578),
    [anon_sym_COLON_QMARK] = ACTIONS(3580),
    [anon_sym_LBRACK] = ACTIONS(3582),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3584),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [aux_sym_char_token1] = ACTIONS(3590),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3592),
    [anon_sym_DQUOTE] = ACTIONS(3594),
    [anon_sym_AT_DQUOTE] = ACTIONS(3596),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3598),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3600),
    [sym_bool] = ACTIONS(3602),
    [sym_unit] = ACTIONS(3604),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3606),
    [sym_op_identifier] = ACTIONS(3608),
    [sym_int] = ACTIONS(3610),
    [sym_xint] = ACTIONS(3612),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2670] = {
    [sym_attributes] = STATE(2641),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(5241),
    [sym__pattern] = STATE(5263),
    [sym_optional_pattern] = STATE(5241),
    [sym_type_check_pattern] = STATE(5241),
    [sym_attribute_pattern] = STATE(5241),
    [sym_paren_pattern] = STATE(5241),
    [sym_as_pattern] = STATE(5241),
    [sym_cons_pattern] = STATE(5241),
    [sym_disjunct_pattern] = STATE(5241),
    [sym_conjunct_pattern] = STATE(5241),
    [sym_typed_pattern] = STATE(5241),
    [sym_list_pattern] = STATE(5241),
    [sym_array_pattern] = STATE(5241),
    [sym_record_pattern] = STATE(5241),
    [sym_named_field_pattern] = STATE(5241),
    [sym_identifier_pattern] = STATE(5241),
    [sym_long_identifier_or_op] = STATE(1721),
    [sym_char] = STATE(5389),
    [sym_format_string] = STATE(5273),
    [sym__string_literal] = STATE(5273),
    [sym_string] = STATE(5389),
    [sym_verbatim_string] = STATE(5389),
    [sym_bytearray] = STATE(5389),
    [sym_verbatim_bytearray] = STATE(5389),
    [sym_format_triple_quoted_string] = STATE(5377),
    [sym_triple_quoted_string] = STATE(5389),
    [sym_const] = STATE(5241),
    [sym_long_identifier] = STATE(3363),
    [sym_active_pattern] = STATE(3521),
    [sym__identifier_or_op] = STATE(3510),
    [sym_sbyte] = STATE(5389),
    [sym_byte] = STATE(5389),
    [sym_int16] = STATE(5389),
    [sym_uint16] = STATE(5389),
    [sym_int32] = STATE(5389),
    [sym_uint32] = STATE(5389),
    [sym_nativeint] = STATE(5389),
    [sym_unativeint] = STATE(5389),
    [sym_int64] = STATE(5389),
    [sym_uint64] = STATE(5389),
    [sym_ieee32] = STATE(5389),
    [sym_ieee64] = STATE(5389),
    [sym_bignum] = STATE(5389),
    [sym_decimal] = STATE(5389),
    [sym_float] = STATE(4893),
    [sym_block_comment] = STATE(2670),
    [sym_compiler_directive_decl] = STATE(2670),
    [sym_fsi_directive_decl] = STATE(2670),
    [sym_preproc_line] = STATE(2670),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(3870),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_LPAREN] = ACTIONS(3872),
    [anon_sym_null] = ACTIONS(3874),
    [anon_sym__] = ACTIONS(3876),
    [anon_sym_QMARK] = ACTIONS(3878),
    [anon_sym_COLON_QMARK] = ACTIONS(3880),
    [anon_sym_LBRACK] = ACTIONS(3882),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3884),
    [anon_sym_LBRACE] = ACTIONS(3886),
    [aux_sym_char_token1] = ACTIONS(3888),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3890),
    [anon_sym_DQUOTE] = ACTIONS(3892),
    [anon_sym_AT_DQUOTE] = ACTIONS(3894),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3896),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3898),
    [sym_bool] = ACTIONS(3900),
    [sym_unit] = ACTIONS(3902),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3904),
    [sym_op_identifier] = ACTIONS(3906),
    [sym_int] = ACTIONS(3908),
    [sym_xint] = ACTIONS(3910),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2671] = {
    [sym_attributes] = STATE(2674),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(5431),
    [sym__pattern] = STATE(5411),
    [sym_optional_pattern] = STATE(5431),
    [sym_type_check_pattern] = STATE(5431),
    [sym_attribute_pattern] = STATE(5431),
    [sym_paren_pattern] = STATE(5431),
    [sym_as_pattern] = STATE(5431),
    [sym_cons_pattern] = STATE(5431),
    [sym_disjunct_pattern] = STATE(5431),
    [sym_conjunct_pattern] = STATE(5431),
    [sym_typed_pattern] = STATE(5431),
    [sym_list_pattern] = STATE(5431),
    [sym_array_pattern] = STATE(5431),
    [sym_record_pattern] = STATE(5431),
    [sym_named_field_pattern] = STATE(5431),
    [sym_identifier_pattern] = STATE(5431),
    [sym_long_identifier_or_op] = STATE(2273),
    [sym_char] = STATE(5475),
    [sym_format_string] = STATE(5423),
    [sym__string_literal] = STATE(5423),
    [sym_string] = STATE(5475),
    [sym_verbatim_string] = STATE(5475),
    [sym_bytearray] = STATE(5475),
    [sym_verbatim_bytearray] = STATE(5475),
    [sym_format_triple_quoted_string] = STATE(5477),
    [sym_triple_quoted_string] = STATE(5475),
    [sym_const] = STATE(5431),
    [sym_long_identifier] = STATE(3437),
    [sym_active_pattern] = STATE(3653),
    [sym__identifier_or_op] = STATE(3660),
    [sym_sbyte] = STATE(5475),
    [sym_byte] = STATE(5475),
    [sym_int16] = STATE(5475),
    [sym_uint16] = STATE(5475),
    [sym_int32] = STATE(5475),
    [sym_uint32] = STATE(5475),
    [sym_nativeint] = STATE(5475),
    [sym_unativeint] = STATE(5475),
    [sym_int64] = STATE(5475),
    [sym_uint64] = STATE(5475),
    [sym_ieee32] = STATE(5475),
    [sym_ieee64] = STATE(5475),
    [sym_bignum] = STATE(5475),
    [sym_decimal] = STATE(5475),
    [sym_float] = STATE(4953),
    [sym_block_comment] = STATE(2671),
    [sym_compiler_directive_decl] = STATE(2671),
    [sym_fsi_directive_decl] = STATE(2671),
    [sym_preproc_line] = STATE(2671),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(4073),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_LPAREN] = ACTIONS(4077),
    [anon_sym_null] = ACTIONS(4081),
    [anon_sym__] = ACTIONS(4083),
    [anon_sym_QMARK] = ACTIONS(4085),
    [anon_sym_COLON_QMARK] = ACTIONS(4087),
    [anon_sym_LBRACK] = ACTIONS(4095),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4097),
    [anon_sym_LBRACE] = ACTIONS(4099),
    [aux_sym_char_token1] = ACTIONS(4101),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4103),
    [anon_sym_DQUOTE] = ACTIONS(4105),
    [anon_sym_AT_DQUOTE] = ACTIONS(4107),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4109),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4111),
    [sym_bool] = ACTIONS(4113),
    [sym_unit] = ACTIONS(4115),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4117),
    [sym_op_identifier] = ACTIONS(4119),
    [sym_int] = ACTIONS(4121),
    [sym_xint] = ACTIONS(4123),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2672] = {
    [sym_attributes] = STATE(2652),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(3588),
    [sym__pattern] = STATE(3540),
    [sym_optional_pattern] = STATE(3588),
    [sym_type_check_pattern] = STATE(3588),
    [sym_attribute_pattern] = STATE(3588),
    [sym_paren_pattern] = STATE(3588),
    [sym_as_pattern] = STATE(3588),
    [sym_cons_pattern] = STATE(3588),
    [sym_disjunct_pattern] = STATE(3588),
    [sym_conjunct_pattern] = STATE(3588),
    [sym_typed_pattern] = STATE(3588),
    [sym_list_pattern] = STATE(3588),
    [sym_array_pattern] = STATE(3588),
    [sym_record_pattern] = STATE(3588),
    [sym_named_field_pattern] = STATE(3588),
    [sym_identifier_pattern] = STATE(3588),
    [sym_long_identifier_or_op] = STATE(2401),
    [sym_char] = STATE(3658),
    [sym_format_string] = STATE(3670),
    [sym__string_literal] = STATE(3670),
    [sym_string] = STATE(3658),
    [sym_verbatim_string] = STATE(3658),
    [sym_bytearray] = STATE(3658),
    [sym_verbatim_bytearray] = STATE(3658),
    [sym_format_triple_quoted_string] = STATE(3673),
    [sym_triple_quoted_string] = STATE(3658),
    [sym_const] = STATE(3588),
    [sym_long_identifier] = STATE(3493),
    [sym_active_pattern] = STATE(3613),
    [sym__identifier_or_op] = STATE(3650),
    [sym_sbyte] = STATE(3658),
    [sym_byte] = STATE(3658),
    [sym_int16] = STATE(3658),
    [sym_uint16] = STATE(3658),
    [sym_int32] = STATE(3658),
    [sym_uint32] = STATE(3658),
    [sym_nativeint] = STATE(3658),
    [sym_unativeint] = STATE(3658),
    [sym_int64] = STATE(3658),
    [sym_uint64] = STATE(3658),
    [sym_ieee32] = STATE(3658),
    [sym_ieee64] = STATE(3658),
    [sym_bignum] = STATE(3658),
    [sym_decimal] = STATE(3658),
    [sym_float] = STATE(3376),
    [sym_block_comment] = STATE(2672),
    [sym_compiler_directive_decl] = STATE(2672),
    [sym_fsi_directive_decl] = STATE(2672),
    [sym_preproc_line] = STATE(2672),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(4175),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_LPAREN] = ACTIONS(4218),
    [anon_sym_null] = ACTIONS(4220),
    [anon_sym__] = ACTIONS(4222),
    [anon_sym_QMARK] = ACTIONS(4224),
    [anon_sym_COLON_QMARK] = ACTIONS(4226),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4230),
    [anon_sym_LBRACE] = ACTIONS(4232),
    [aux_sym_char_token1] = ACTIONS(4234),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4236),
    [anon_sym_DQUOTE] = ACTIONS(4238),
    [anon_sym_AT_DQUOTE] = ACTIONS(4240),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4242),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4244),
    [sym_bool] = ACTIONS(4246),
    [sym_unit] = ACTIONS(4248),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4181),
    [sym_op_identifier] = ACTIONS(4183),
    [sym_int] = ACTIONS(4250),
    [sym_xint] = ACTIONS(4252),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2673] = {
    [sym_attributes] = STATE(2676),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(4815),
    [sym__pattern] = STATE(5094),
    [sym_optional_pattern] = STATE(4815),
    [sym_type_check_pattern] = STATE(4815),
    [sym_attribute_pattern] = STATE(4815),
    [sym_paren_pattern] = STATE(4815),
    [sym_as_pattern] = STATE(4815),
    [sym_cons_pattern] = STATE(4815),
    [sym_disjunct_pattern] = STATE(4815),
    [sym_conjunct_pattern] = STATE(4815),
    [sym_typed_pattern] = STATE(4815),
    [sym_list_pattern] = STATE(4815),
    [sym_array_pattern] = STATE(4815),
    [sym_record_pattern] = STATE(4815),
    [sym_named_field_pattern] = STATE(4815),
    [sym_identifier_pattern] = STATE(4815),
    [sym_long_identifier_or_op] = STATE(1792),
    [sym_char] = STATE(4765),
    [sym_format_string] = STATE(4746),
    [sym__string_literal] = STATE(4746),
    [sym_string] = STATE(4765),
    [sym_verbatim_string] = STATE(4765),
    [sym_bytearray] = STATE(4765),
    [sym_verbatim_bytearray] = STATE(4765),
    [sym_format_triple_quoted_string] = STATE(4720),
    [sym_triple_quoted_string] = STATE(4765),
    [sym_const] = STATE(4815),
    [sym_long_identifier] = STATE(3320),
    [sym_active_pattern] = STATE(3488),
    [sym__identifier_or_op] = STATE(3410),
    [sym_sbyte] = STATE(4765),
    [sym_byte] = STATE(4765),
    [sym_int16] = STATE(4765),
    [sym_uint16] = STATE(4765),
    [sym_int32] = STATE(4765),
    [sym_uint32] = STATE(4765),
    [sym_nativeint] = STATE(4765),
    [sym_unativeint] = STATE(4765),
    [sym_int64] = STATE(4765),
    [sym_uint64] = STATE(4765),
    [sym_ieee32] = STATE(4765),
    [sym_ieee64] = STATE(4765),
    [sym_bignum] = STATE(4765),
    [sym_decimal] = STATE(4765),
    [sym_float] = STATE(4512),
    [sym_block_comment] = STATE(2673),
    [sym_compiler_directive_decl] = STATE(2673),
    [sym_fsi_directive_decl] = STATE(2673),
    [sym_preproc_line] = STATE(2673),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(3562),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_LPAREN] = ACTIONS(3572),
    [anon_sym_null] = ACTIONS(3574),
    [anon_sym__] = ACTIONS(3576),
    [anon_sym_QMARK] = ACTIONS(3578),
    [anon_sym_COLON_QMARK] = ACTIONS(3580),
    [anon_sym_LBRACK] = ACTIONS(3582),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3584),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [aux_sym_char_token1] = ACTIONS(3590),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3592),
    [anon_sym_DQUOTE] = ACTIONS(3594),
    [anon_sym_AT_DQUOTE] = ACTIONS(3596),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3598),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3600),
    [sym_bool] = ACTIONS(3602),
    [sym_unit] = ACTIONS(3604),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3606),
    [sym_op_identifier] = ACTIONS(3608),
    [sym_int] = ACTIONS(3610),
    [sym_xint] = ACTIONS(3612),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2674] = {
    [sym_attributes] = STATE(2674),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(5431),
    [sym__pattern] = STATE(5394),
    [sym_optional_pattern] = STATE(5431),
    [sym_type_check_pattern] = STATE(5431),
    [sym_attribute_pattern] = STATE(5431),
    [sym_paren_pattern] = STATE(5431),
    [sym_as_pattern] = STATE(5431),
    [sym_cons_pattern] = STATE(5431),
    [sym_disjunct_pattern] = STATE(5431),
    [sym_conjunct_pattern] = STATE(5431),
    [sym_typed_pattern] = STATE(5431),
    [sym_list_pattern] = STATE(5431),
    [sym_array_pattern] = STATE(5431),
    [sym_record_pattern] = STATE(5431),
    [sym_named_field_pattern] = STATE(5431),
    [sym_identifier_pattern] = STATE(5431),
    [sym_long_identifier_or_op] = STATE(2273),
    [sym_char] = STATE(5475),
    [sym_format_string] = STATE(5423),
    [sym__string_literal] = STATE(5423),
    [sym_string] = STATE(5475),
    [sym_verbatim_string] = STATE(5475),
    [sym_bytearray] = STATE(5475),
    [sym_verbatim_bytearray] = STATE(5475),
    [sym_format_triple_quoted_string] = STATE(5477),
    [sym_triple_quoted_string] = STATE(5475),
    [sym_const] = STATE(5431),
    [sym_long_identifier] = STATE(3437),
    [sym_active_pattern] = STATE(3653),
    [sym__identifier_or_op] = STATE(3660),
    [sym_sbyte] = STATE(5475),
    [sym_byte] = STATE(5475),
    [sym_int16] = STATE(5475),
    [sym_uint16] = STATE(5475),
    [sym_int32] = STATE(5475),
    [sym_uint32] = STATE(5475),
    [sym_nativeint] = STATE(5475),
    [sym_unativeint] = STATE(5475),
    [sym_int64] = STATE(5475),
    [sym_uint64] = STATE(5475),
    [sym_ieee32] = STATE(5475),
    [sym_ieee64] = STATE(5475),
    [sym_bignum] = STATE(5475),
    [sym_decimal] = STATE(5475),
    [sym_float] = STATE(4953),
    [sym_block_comment] = STATE(2674),
    [sym_compiler_directive_decl] = STATE(2674),
    [sym_fsi_directive_decl] = STATE(2674),
    [sym_preproc_line] = STATE(2674),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(4073),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_LPAREN] = ACTIONS(4077),
    [anon_sym_null] = ACTIONS(4081),
    [anon_sym__] = ACTIONS(4083),
    [anon_sym_QMARK] = ACTIONS(4085),
    [anon_sym_COLON_QMARK] = ACTIONS(4087),
    [anon_sym_LBRACK] = ACTIONS(4095),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4097),
    [anon_sym_LBRACE] = ACTIONS(4099),
    [aux_sym_char_token1] = ACTIONS(4101),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4103),
    [anon_sym_DQUOTE] = ACTIONS(4105),
    [anon_sym_AT_DQUOTE] = ACTIONS(4107),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4109),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4111),
    [sym_bool] = ACTIONS(4113),
    [sym_unit] = ACTIONS(4115),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4117),
    [sym_op_identifier] = ACTIONS(4119),
    [sym_int] = ACTIONS(4121),
    [sym_xint] = ACTIONS(4123),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2675] = {
    [sym_attributes] = STATE(2698),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(3506),
    [sym__pattern] = STATE(3407),
    [sym_optional_pattern] = STATE(3506),
    [sym_type_check_pattern] = STATE(3506),
    [sym_attribute_pattern] = STATE(3506),
    [sym_paren_pattern] = STATE(3506),
    [sym_as_pattern] = STATE(3506),
    [sym_cons_pattern] = STATE(3506),
    [sym_disjunct_pattern] = STATE(3506),
    [sym_conjunct_pattern] = STATE(3506),
    [sym_typed_pattern] = STATE(3506),
    [sym_list_pattern] = STATE(3506),
    [sym_array_pattern] = STATE(3506),
    [sym_record_pattern] = STATE(3506),
    [sym_named_field_pattern] = STATE(3506),
    [sym_identifier_pattern] = STATE(3506),
    [sym_long_identifier_or_op] = STATE(1864),
    [sym_char] = STATE(3497),
    [sym_format_string] = STATE(3495),
    [sym__string_literal] = STATE(3495),
    [sym_string] = STATE(3497),
    [sym_verbatim_string] = STATE(3497),
    [sym_bytearray] = STATE(3497),
    [sym_verbatim_bytearray] = STATE(3497),
    [sym_format_triple_quoted_string] = STATE(3494),
    [sym_triple_quoted_string] = STATE(3497),
    [sym_const] = STATE(3506),
    [sym_long_identifier] = STATE(3363),
    [sym_active_pattern] = STATE(3521),
    [sym__identifier_or_op] = STATE(3510),
    [sym_sbyte] = STATE(3497),
    [sym_byte] = STATE(3497),
    [sym_int16] = STATE(3497),
    [sym_uint16] = STATE(3497),
    [sym_int32] = STATE(3497),
    [sym_uint32] = STATE(3497),
    [sym_nativeint] = STATE(3497),
    [sym_unativeint] = STATE(3497),
    [sym_int64] = STATE(3497),
    [sym_uint64] = STATE(3497),
    [sym_ieee32] = STATE(3497),
    [sym_ieee64] = STATE(3497),
    [sym_bignum] = STATE(3497),
    [sym_decimal] = STATE(3497),
    [sym_float] = STATE(3305),
    [sym_block_comment] = STATE(2675),
    [sym_compiler_directive_decl] = STATE(2675),
    [sym_fsi_directive_decl] = STATE(2675),
    [sym_preproc_line] = STATE(2675),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(3870),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_LPAREN] = ACTIONS(3962),
    [anon_sym_null] = ACTIONS(3966),
    [anon_sym__] = ACTIONS(3968),
    [anon_sym_QMARK] = ACTIONS(3970),
    [anon_sym_COLON_QMARK] = ACTIONS(3972),
    [anon_sym_LBRACK] = ACTIONS(3974),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3976),
    [anon_sym_LBRACE] = ACTIONS(3978),
    [aux_sym_char_token1] = ACTIONS(3980),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3982),
    [anon_sym_DQUOTE] = ACTIONS(3984),
    [anon_sym_AT_DQUOTE] = ACTIONS(3986),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3988),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3990),
    [sym_bool] = ACTIONS(3992),
    [sym_unit] = ACTIONS(3994),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3904),
    [sym_op_identifier] = ACTIONS(3906),
    [sym_int] = ACTIONS(3996),
    [sym_xint] = ACTIONS(3998),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2676] = {
    [sym_attributes] = STATE(2676),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(4815),
    [sym__pattern] = STATE(5033),
    [sym_optional_pattern] = STATE(4815),
    [sym_type_check_pattern] = STATE(4815),
    [sym_attribute_pattern] = STATE(4815),
    [sym_paren_pattern] = STATE(4815),
    [sym_as_pattern] = STATE(4815),
    [sym_cons_pattern] = STATE(4815),
    [sym_disjunct_pattern] = STATE(4815),
    [sym_conjunct_pattern] = STATE(4815),
    [sym_typed_pattern] = STATE(4815),
    [sym_list_pattern] = STATE(4815),
    [sym_array_pattern] = STATE(4815),
    [sym_record_pattern] = STATE(4815),
    [sym_named_field_pattern] = STATE(4815),
    [sym_identifier_pattern] = STATE(4815),
    [sym_long_identifier_or_op] = STATE(1792),
    [sym_char] = STATE(4765),
    [sym_format_string] = STATE(4746),
    [sym__string_literal] = STATE(4746),
    [sym_string] = STATE(4765),
    [sym_verbatim_string] = STATE(4765),
    [sym_bytearray] = STATE(4765),
    [sym_verbatim_bytearray] = STATE(4765),
    [sym_format_triple_quoted_string] = STATE(4720),
    [sym_triple_quoted_string] = STATE(4765),
    [sym_const] = STATE(4815),
    [sym_long_identifier] = STATE(3320),
    [sym_active_pattern] = STATE(3488),
    [sym__identifier_or_op] = STATE(3410),
    [sym_sbyte] = STATE(4765),
    [sym_byte] = STATE(4765),
    [sym_int16] = STATE(4765),
    [sym_uint16] = STATE(4765),
    [sym_int32] = STATE(4765),
    [sym_uint32] = STATE(4765),
    [sym_nativeint] = STATE(4765),
    [sym_unativeint] = STATE(4765),
    [sym_int64] = STATE(4765),
    [sym_uint64] = STATE(4765),
    [sym_ieee32] = STATE(4765),
    [sym_ieee64] = STATE(4765),
    [sym_bignum] = STATE(4765),
    [sym_decimal] = STATE(4765),
    [sym_float] = STATE(4512),
    [sym_block_comment] = STATE(2676),
    [sym_compiler_directive_decl] = STATE(2676),
    [sym_fsi_directive_decl] = STATE(2676),
    [sym_preproc_line] = STATE(2676),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(3562),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_LPAREN] = ACTIONS(3572),
    [anon_sym_null] = ACTIONS(3574),
    [anon_sym__] = ACTIONS(3576),
    [anon_sym_QMARK] = ACTIONS(3578),
    [anon_sym_COLON_QMARK] = ACTIONS(3580),
    [anon_sym_LBRACK] = ACTIONS(3582),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3584),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [aux_sym_char_token1] = ACTIONS(3590),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3592),
    [anon_sym_DQUOTE] = ACTIONS(3594),
    [anon_sym_AT_DQUOTE] = ACTIONS(3596),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3598),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3600),
    [sym_bool] = ACTIONS(3602),
    [sym_unit] = ACTIONS(3604),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3606),
    [sym_op_identifier] = ACTIONS(3608),
    [sym_int] = ACTIONS(3610),
    [sym_xint] = ACTIONS(3612),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2677] = {
    [sym_attributes] = STATE(2632),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(4815),
    [sym__pattern] = STATE(5463),
    [sym_optional_pattern] = STATE(4815),
    [sym_type_check_pattern] = STATE(4815),
    [sym_attribute_pattern] = STATE(4815),
    [sym_paren_pattern] = STATE(4815),
    [sym_as_pattern] = STATE(4815),
    [sym_cons_pattern] = STATE(4815),
    [sym_disjunct_pattern] = STATE(4815),
    [sym_conjunct_pattern] = STATE(4815),
    [sym_typed_pattern] = STATE(4815),
    [sym_list_pattern] = STATE(4815),
    [sym_array_pattern] = STATE(4815),
    [sym_record_pattern] = STATE(4815),
    [sym_named_field_pattern] = STATE(4815),
    [sym_identifier_pattern] = STATE(4815),
    [sym_long_identifier_or_op] = STATE(2475),
    [sym_char] = STATE(4765),
    [sym_format_string] = STATE(4746),
    [sym__string_literal] = STATE(4746),
    [sym_string] = STATE(4765),
    [sym_verbatim_string] = STATE(4765),
    [sym_bytearray] = STATE(4765),
    [sym_verbatim_bytearray] = STATE(4765),
    [sym_format_triple_quoted_string] = STATE(4720),
    [sym_triple_quoted_string] = STATE(4765),
    [sym_const] = STATE(4815),
    [sym_long_identifier] = STATE(3655),
    [sym_active_pattern] = STATE(3734),
    [sym__identifier_or_op] = STATE(3737),
    [sym_sbyte] = STATE(4765),
    [sym_byte] = STATE(4765),
    [sym_int16] = STATE(4765),
    [sym_uint16] = STATE(4765),
    [sym_int32] = STATE(4765),
    [sym_uint32] = STATE(4765),
    [sym_nativeint] = STATE(4765),
    [sym_unativeint] = STATE(4765),
    [sym_int64] = STATE(4765),
    [sym_uint64] = STATE(4765),
    [sym_ieee32] = STATE(4765),
    [sym_ieee64] = STATE(4765),
    [sym_bignum] = STATE(4765),
    [sym_decimal] = STATE(4765),
    [sym_float] = STATE(4512),
    [sym_block_comment] = STATE(2677),
    [sym_compiler_directive_decl] = STATE(2677),
    [sym_fsi_directive_decl] = STATE(2677),
    [sym_preproc_line] = STATE(2677),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(4196),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_LPAREN] = ACTIONS(3572),
    [anon_sym_null] = ACTIONS(3574),
    [anon_sym__] = ACTIONS(3576),
    [anon_sym_QMARK] = ACTIONS(4202),
    [anon_sym_COLON_QMARK] = ACTIONS(4204),
    [anon_sym_LBRACK] = ACTIONS(3582),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3584),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [aux_sym_char_token1] = ACTIONS(3590),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3592),
    [anon_sym_DQUOTE] = ACTIONS(3594),
    [anon_sym_AT_DQUOTE] = ACTIONS(3596),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3598),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3600),
    [sym_bool] = ACTIONS(3602),
    [sym_unit] = ACTIONS(3604),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4212),
    [sym_op_identifier] = ACTIONS(4214),
    [sym_int] = ACTIONS(3610),
    [sym_xint] = ACTIONS(3612),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2678] = {
    [sym_attributes] = STATE(2676),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(4815),
    [sym__pattern] = STATE(5015),
    [sym_optional_pattern] = STATE(4815),
    [sym_type_check_pattern] = STATE(4815),
    [sym_attribute_pattern] = STATE(4815),
    [sym_paren_pattern] = STATE(4815),
    [sym_as_pattern] = STATE(4815),
    [sym_cons_pattern] = STATE(4815),
    [sym_disjunct_pattern] = STATE(4815),
    [sym_conjunct_pattern] = STATE(4815),
    [sym_typed_pattern] = STATE(4815),
    [sym_list_pattern] = STATE(4815),
    [sym_array_pattern] = STATE(4815),
    [sym_record_pattern] = STATE(4815),
    [sym_named_field_pattern] = STATE(4815),
    [sym_identifier_pattern] = STATE(4815),
    [sym_long_identifier_or_op] = STATE(1792),
    [sym_char] = STATE(4765),
    [sym_format_string] = STATE(4746),
    [sym__string_literal] = STATE(4746),
    [sym_string] = STATE(4765),
    [sym_verbatim_string] = STATE(4765),
    [sym_bytearray] = STATE(4765),
    [sym_verbatim_bytearray] = STATE(4765),
    [sym_format_triple_quoted_string] = STATE(4720),
    [sym_triple_quoted_string] = STATE(4765),
    [sym_const] = STATE(4815),
    [sym_long_identifier] = STATE(3320),
    [sym_active_pattern] = STATE(3488),
    [sym__identifier_or_op] = STATE(3410),
    [sym_sbyte] = STATE(4765),
    [sym_byte] = STATE(4765),
    [sym_int16] = STATE(4765),
    [sym_uint16] = STATE(4765),
    [sym_int32] = STATE(4765),
    [sym_uint32] = STATE(4765),
    [sym_nativeint] = STATE(4765),
    [sym_unativeint] = STATE(4765),
    [sym_int64] = STATE(4765),
    [sym_uint64] = STATE(4765),
    [sym_ieee32] = STATE(4765),
    [sym_ieee64] = STATE(4765),
    [sym_bignum] = STATE(4765),
    [sym_decimal] = STATE(4765),
    [sym_float] = STATE(4512),
    [sym_block_comment] = STATE(2678),
    [sym_compiler_directive_decl] = STATE(2678),
    [sym_fsi_directive_decl] = STATE(2678),
    [sym_preproc_line] = STATE(2678),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(3562),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_LPAREN] = ACTIONS(3572),
    [anon_sym_null] = ACTIONS(3574),
    [anon_sym__] = ACTIONS(3576),
    [anon_sym_QMARK] = ACTIONS(3578),
    [anon_sym_COLON_QMARK] = ACTIONS(3580),
    [anon_sym_LBRACK] = ACTIONS(3582),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3584),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [aux_sym_char_token1] = ACTIONS(3590),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3592),
    [anon_sym_DQUOTE] = ACTIONS(3594),
    [anon_sym_AT_DQUOTE] = ACTIONS(3596),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3598),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3600),
    [sym_bool] = ACTIONS(3602),
    [sym_unit] = ACTIONS(3604),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3606),
    [sym_op_identifier] = ACTIONS(3608),
    [sym_int] = ACTIONS(3610),
    [sym_xint] = ACTIONS(3612),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2679] = {
    [sym_attributes] = STATE(2632),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(4815),
    [sym__pattern] = STATE(5451),
    [sym_optional_pattern] = STATE(4815),
    [sym_type_check_pattern] = STATE(4815),
    [sym_attribute_pattern] = STATE(4815),
    [sym_paren_pattern] = STATE(4815),
    [sym_as_pattern] = STATE(4815),
    [sym_cons_pattern] = STATE(4815),
    [sym_disjunct_pattern] = STATE(4815),
    [sym_conjunct_pattern] = STATE(4815),
    [sym_typed_pattern] = STATE(4815),
    [sym_list_pattern] = STATE(4815),
    [sym_array_pattern] = STATE(4815),
    [sym_record_pattern] = STATE(4815),
    [sym_named_field_pattern] = STATE(4815),
    [sym_identifier_pattern] = STATE(4815),
    [sym_long_identifier_or_op] = STATE(2475),
    [sym_char] = STATE(4765),
    [sym_format_string] = STATE(4746),
    [sym__string_literal] = STATE(4746),
    [sym_string] = STATE(4765),
    [sym_verbatim_string] = STATE(4765),
    [sym_bytearray] = STATE(4765),
    [sym_verbatim_bytearray] = STATE(4765),
    [sym_format_triple_quoted_string] = STATE(4720),
    [sym_triple_quoted_string] = STATE(4765),
    [sym_const] = STATE(4815),
    [sym_long_identifier] = STATE(3655),
    [sym_active_pattern] = STATE(3734),
    [sym__identifier_or_op] = STATE(3737),
    [sym_sbyte] = STATE(4765),
    [sym_byte] = STATE(4765),
    [sym_int16] = STATE(4765),
    [sym_uint16] = STATE(4765),
    [sym_int32] = STATE(4765),
    [sym_uint32] = STATE(4765),
    [sym_nativeint] = STATE(4765),
    [sym_unativeint] = STATE(4765),
    [sym_int64] = STATE(4765),
    [sym_uint64] = STATE(4765),
    [sym_ieee32] = STATE(4765),
    [sym_ieee64] = STATE(4765),
    [sym_bignum] = STATE(4765),
    [sym_decimal] = STATE(4765),
    [sym_float] = STATE(4512),
    [sym_block_comment] = STATE(2679),
    [sym_compiler_directive_decl] = STATE(2679),
    [sym_fsi_directive_decl] = STATE(2679),
    [sym_preproc_line] = STATE(2679),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(4480),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_LPAREN] = ACTIONS(3572),
    [anon_sym_null] = ACTIONS(3574),
    [anon_sym__] = ACTIONS(3576),
    [anon_sym_QMARK] = ACTIONS(4202),
    [anon_sym_COLON_QMARK] = ACTIONS(4204),
    [anon_sym_LBRACK] = ACTIONS(3582),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3584),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [aux_sym_char_token1] = ACTIONS(3590),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3592),
    [anon_sym_DQUOTE] = ACTIONS(3594),
    [anon_sym_AT_DQUOTE] = ACTIONS(3596),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3598),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3600),
    [sym_bool] = ACTIONS(3602),
    [sym_unit] = ACTIONS(3604),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4212),
    [sym_op_identifier] = ACTIONS(4214),
    [sym_int] = ACTIONS(3610),
    [sym_xint] = ACTIONS(3612),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2680] = {
    [sym_attributes] = STATE(2632),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(4815),
    [sym__pattern] = STATE(5458),
    [sym_optional_pattern] = STATE(4815),
    [sym_type_check_pattern] = STATE(4815),
    [sym_attribute_pattern] = STATE(4815),
    [sym_paren_pattern] = STATE(4815),
    [sym_as_pattern] = STATE(4815),
    [sym_cons_pattern] = STATE(4815),
    [sym_disjunct_pattern] = STATE(4815),
    [sym_conjunct_pattern] = STATE(4815),
    [sym_typed_pattern] = STATE(4815),
    [sym_list_pattern] = STATE(4815),
    [sym_array_pattern] = STATE(4815),
    [sym_record_pattern] = STATE(4815),
    [sym_named_field_pattern] = STATE(4815),
    [sym_identifier_pattern] = STATE(4815),
    [sym_long_identifier_or_op] = STATE(2475),
    [sym_char] = STATE(4765),
    [sym_format_string] = STATE(4746),
    [sym__string_literal] = STATE(4746),
    [sym_string] = STATE(4765),
    [sym_verbatim_string] = STATE(4765),
    [sym_bytearray] = STATE(4765),
    [sym_verbatim_bytearray] = STATE(4765),
    [sym_format_triple_quoted_string] = STATE(4720),
    [sym_triple_quoted_string] = STATE(4765),
    [sym_const] = STATE(4815),
    [sym_long_identifier] = STATE(3655),
    [sym_active_pattern] = STATE(3734),
    [sym__identifier_or_op] = STATE(3737),
    [sym_sbyte] = STATE(4765),
    [sym_byte] = STATE(4765),
    [sym_int16] = STATE(4765),
    [sym_uint16] = STATE(4765),
    [sym_int32] = STATE(4765),
    [sym_uint32] = STATE(4765),
    [sym_nativeint] = STATE(4765),
    [sym_unativeint] = STATE(4765),
    [sym_int64] = STATE(4765),
    [sym_uint64] = STATE(4765),
    [sym_ieee32] = STATE(4765),
    [sym_ieee64] = STATE(4765),
    [sym_bignum] = STATE(4765),
    [sym_decimal] = STATE(4765),
    [sym_float] = STATE(4512),
    [sym_block_comment] = STATE(2680),
    [sym_compiler_directive_decl] = STATE(2680),
    [sym_fsi_directive_decl] = STATE(2680),
    [sym_preproc_line] = STATE(2680),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(4490),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_LPAREN] = ACTIONS(3572),
    [anon_sym_null] = ACTIONS(3574),
    [anon_sym__] = ACTIONS(3576),
    [anon_sym_QMARK] = ACTIONS(4202),
    [anon_sym_COLON_QMARK] = ACTIONS(4204),
    [anon_sym_LBRACK] = ACTIONS(3582),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3584),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [aux_sym_char_token1] = ACTIONS(3590),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3592),
    [anon_sym_DQUOTE] = ACTIONS(3594),
    [anon_sym_AT_DQUOTE] = ACTIONS(3596),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3598),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3600),
    [sym_bool] = ACTIONS(3602),
    [sym_unit] = ACTIONS(3604),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4212),
    [sym_op_identifier] = ACTIONS(4214),
    [sym_int] = ACTIONS(3610),
    [sym_xint] = ACTIONS(3612),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2681] = {
    [sym_attributes] = STATE(2676),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(4815),
    [sym__pattern] = STATE(5108),
    [sym_optional_pattern] = STATE(4815),
    [sym_type_check_pattern] = STATE(4815),
    [sym_attribute_pattern] = STATE(4815),
    [sym_paren_pattern] = STATE(4815),
    [sym_as_pattern] = STATE(4815),
    [sym_cons_pattern] = STATE(4815),
    [sym_disjunct_pattern] = STATE(4815),
    [sym_conjunct_pattern] = STATE(4815),
    [sym_typed_pattern] = STATE(4815),
    [sym_list_pattern] = STATE(4815),
    [sym_array_pattern] = STATE(4815),
    [sym_record_pattern] = STATE(4815),
    [sym_named_field_pattern] = STATE(4815),
    [sym_identifier_pattern] = STATE(4815),
    [sym_long_identifier_or_op] = STATE(1792),
    [sym_char] = STATE(4765),
    [sym_format_string] = STATE(4746),
    [sym__string_literal] = STATE(4746),
    [sym_string] = STATE(4765),
    [sym_verbatim_string] = STATE(4765),
    [sym_bytearray] = STATE(4765),
    [sym_verbatim_bytearray] = STATE(4765),
    [sym_format_triple_quoted_string] = STATE(4720),
    [sym_triple_quoted_string] = STATE(4765),
    [sym_const] = STATE(4815),
    [sym_long_identifier] = STATE(3320),
    [sym_active_pattern] = STATE(3488),
    [sym__identifier_or_op] = STATE(3410),
    [sym_sbyte] = STATE(4765),
    [sym_byte] = STATE(4765),
    [sym_int16] = STATE(4765),
    [sym_uint16] = STATE(4765),
    [sym_int32] = STATE(4765),
    [sym_uint32] = STATE(4765),
    [sym_nativeint] = STATE(4765),
    [sym_unativeint] = STATE(4765),
    [sym_int64] = STATE(4765),
    [sym_uint64] = STATE(4765),
    [sym_ieee32] = STATE(4765),
    [sym_ieee64] = STATE(4765),
    [sym_bignum] = STATE(4765),
    [sym_decimal] = STATE(4765),
    [sym_float] = STATE(4512),
    [sym_block_comment] = STATE(2681),
    [sym_compiler_directive_decl] = STATE(2681),
    [sym_fsi_directive_decl] = STATE(2681),
    [sym_preproc_line] = STATE(2681),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(3562),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_LPAREN] = ACTIONS(3572),
    [anon_sym_null] = ACTIONS(3574),
    [anon_sym__] = ACTIONS(3576),
    [anon_sym_QMARK] = ACTIONS(3578),
    [anon_sym_COLON_QMARK] = ACTIONS(3580),
    [anon_sym_LBRACK] = ACTIONS(3582),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3584),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [aux_sym_char_token1] = ACTIONS(3590),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3592),
    [anon_sym_DQUOTE] = ACTIONS(3594),
    [anon_sym_AT_DQUOTE] = ACTIONS(3596),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3598),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3600),
    [sym_bool] = ACTIONS(3602),
    [sym_unit] = ACTIONS(3604),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3606),
    [sym_op_identifier] = ACTIONS(3608),
    [sym_int] = ACTIONS(3610),
    [sym_xint] = ACTIONS(3612),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2682] = {
    [sym_attributes] = STATE(2632),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(4815),
    [sym__pattern] = STATE(5459),
    [sym_optional_pattern] = STATE(4815),
    [sym_type_check_pattern] = STATE(4815),
    [sym_attribute_pattern] = STATE(4815),
    [sym_paren_pattern] = STATE(4815),
    [sym_as_pattern] = STATE(4815),
    [sym_cons_pattern] = STATE(4815),
    [sym_disjunct_pattern] = STATE(4815),
    [sym_conjunct_pattern] = STATE(4815),
    [sym_typed_pattern] = STATE(4815),
    [sym_list_pattern] = STATE(4815),
    [sym_array_pattern] = STATE(4815),
    [sym_record_pattern] = STATE(4815),
    [sym_named_field_pattern] = STATE(4815),
    [sym_identifier_pattern] = STATE(4815),
    [sym_long_identifier_or_op] = STATE(2475),
    [sym_char] = STATE(4765),
    [sym_format_string] = STATE(4746),
    [sym__string_literal] = STATE(4746),
    [sym_string] = STATE(4765),
    [sym_verbatim_string] = STATE(4765),
    [sym_bytearray] = STATE(4765),
    [sym_verbatim_bytearray] = STATE(4765),
    [sym_format_triple_quoted_string] = STATE(4720),
    [sym_triple_quoted_string] = STATE(4765),
    [sym_const] = STATE(4815),
    [sym_long_identifier] = STATE(3655),
    [sym_active_pattern] = STATE(3734),
    [sym__identifier_or_op] = STATE(3737),
    [sym_sbyte] = STATE(4765),
    [sym_byte] = STATE(4765),
    [sym_int16] = STATE(4765),
    [sym_uint16] = STATE(4765),
    [sym_int32] = STATE(4765),
    [sym_uint32] = STATE(4765),
    [sym_nativeint] = STATE(4765),
    [sym_unativeint] = STATE(4765),
    [sym_int64] = STATE(4765),
    [sym_uint64] = STATE(4765),
    [sym_ieee32] = STATE(4765),
    [sym_ieee64] = STATE(4765),
    [sym_bignum] = STATE(4765),
    [sym_decimal] = STATE(4765),
    [sym_float] = STATE(4512),
    [sym_block_comment] = STATE(2682),
    [sym_compiler_directive_decl] = STATE(2682),
    [sym_fsi_directive_decl] = STATE(2682),
    [sym_preproc_line] = STATE(2682),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(4480),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_LPAREN] = ACTIONS(3572),
    [anon_sym_null] = ACTIONS(3574),
    [anon_sym__] = ACTIONS(3576),
    [anon_sym_QMARK] = ACTIONS(4202),
    [anon_sym_COLON_QMARK] = ACTIONS(4204),
    [anon_sym_LBRACK] = ACTIONS(3582),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3584),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [aux_sym_char_token1] = ACTIONS(3590),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3592),
    [anon_sym_DQUOTE] = ACTIONS(3594),
    [anon_sym_AT_DQUOTE] = ACTIONS(3596),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3598),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3600),
    [sym_bool] = ACTIONS(3602),
    [sym_unit] = ACTIONS(3604),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4212),
    [sym_op_identifier] = ACTIONS(4214),
    [sym_int] = ACTIONS(3610),
    [sym_xint] = ACTIONS(3612),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2683] = {
    [sym_attributes] = STATE(2676),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(4815),
    [sym__pattern] = STATE(5479),
    [sym_optional_pattern] = STATE(4815),
    [sym_type_check_pattern] = STATE(4815),
    [sym_attribute_pattern] = STATE(4815),
    [sym_paren_pattern] = STATE(4815),
    [sym_as_pattern] = STATE(4815),
    [sym_cons_pattern] = STATE(4815),
    [sym_disjunct_pattern] = STATE(4815),
    [sym_conjunct_pattern] = STATE(4815),
    [sym_typed_pattern] = STATE(4815),
    [sym_list_pattern] = STATE(4815),
    [sym_array_pattern] = STATE(4815),
    [sym_record_pattern] = STATE(4815),
    [sym_named_field_pattern] = STATE(4815),
    [sym_identifier_pattern] = STATE(4815),
    [sym_long_identifier_or_op] = STATE(1792),
    [sym_char] = STATE(4765),
    [sym_format_string] = STATE(4746),
    [sym__string_literal] = STATE(4746),
    [sym_string] = STATE(4765),
    [sym_verbatim_string] = STATE(4765),
    [sym_bytearray] = STATE(4765),
    [sym_verbatim_bytearray] = STATE(4765),
    [sym_format_triple_quoted_string] = STATE(4720),
    [sym_triple_quoted_string] = STATE(4765),
    [sym_const] = STATE(4815),
    [sym_long_identifier] = STATE(3320),
    [sym_active_pattern] = STATE(3488),
    [sym__identifier_or_op] = STATE(3410),
    [sym_sbyte] = STATE(4765),
    [sym_byte] = STATE(4765),
    [sym_int16] = STATE(4765),
    [sym_uint16] = STATE(4765),
    [sym_int32] = STATE(4765),
    [sym_uint32] = STATE(4765),
    [sym_nativeint] = STATE(4765),
    [sym_unativeint] = STATE(4765),
    [sym_int64] = STATE(4765),
    [sym_uint64] = STATE(4765),
    [sym_ieee32] = STATE(4765),
    [sym_ieee64] = STATE(4765),
    [sym_bignum] = STATE(4765),
    [sym_decimal] = STATE(4765),
    [sym_float] = STATE(4512),
    [sym_block_comment] = STATE(2683),
    [sym_compiler_directive_decl] = STATE(2683),
    [sym_fsi_directive_decl] = STATE(2683),
    [sym_preproc_line] = STATE(2683),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(3562),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_LPAREN] = ACTIONS(3572),
    [anon_sym_null] = ACTIONS(3574),
    [anon_sym__] = ACTIONS(3576),
    [anon_sym_QMARK] = ACTIONS(3578),
    [anon_sym_COLON_QMARK] = ACTIONS(3580),
    [anon_sym_LBRACK] = ACTIONS(3582),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3584),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [aux_sym_char_token1] = ACTIONS(3590),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3592),
    [anon_sym_DQUOTE] = ACTIONS(3594),
    [anon_sym_AT_DQUOTE] = ACTIONS(3596),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3598),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3600),
    [sym_bool] = ACTIONS(3602),
    [sym_unit] = ACTIONS(3604),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3606),
    [sym_op_identifier] = ACTIONS(3608),
    [sym_int] = ACTIONS(3610),
    [sym_xint] = ACTIONS(3612),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2684] = {
    [sym_attributes] = STATE(2699),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(4815),
    [sym__pattern] = STATE(5269),
    [sym_optional_pattern] = STATE(4815),
    [sym_type_check_pattern] = STATE(4815),
    [sym_attribute_pattern] = STATE(4815),
    [sym_paren_pattern] = STATE(4815),
    [sym_as_pattern] = STATE(4815),
    [sym_cons_pattern] = STATE(4815),
    [sym_disjunct_pattern] = STATE(4815),
    [sym_conjunct_pattern] = STATE(4815),
    [sym_typed_pattern] = STATE(4815),
    [sym_list_pattern] = STATE(4815),
    [sym_array_pattern] = STATE(4815),
    [sym_record_pattern] = STATE(4815),
    [sym_named_field_pattern] = STATE(4815),
    [sym_identifier_pattern] = STATE(4815),
    [sym_long_identifier_or_op] = STATE(2193),
    [sym_char] = STATE(4765),
    [sym_format_string] = STATE(4746),
    [sym__string_literal] = STATE(4746),
    [sym_string] = STATE(4765),
    [sym_verbatim_string] = STATE(4765),
    [sym_bytearray] = STATE(4765),
    [sym_verbatim_bytearray] = STATE(4765),
    [sym_format_triple_quoted_string] = STATE(4720),
    [sym_triple_quoted_string] = STATE(4765),
    [sym_const] = STATE(4815),
    [sym_long_identifier] = STATE(3493),
    [sym_active_pattern] = STATE(3613),
    [sym__identifier_or_op] = STATE(3650),
    [sym_sbyte] = STATE(4765),
    [sym_byte] = STATE(4765),
    [sym_int16] = STATE(4765),
    [sym_uint16] = STATE(4765),
    [sym_int32] = STATE(4765),
    [sym_uint32] = STATE(4765),
    [sym_nativeint] = STATE(4765),
    [sym_unativeint] = STATE(4765),
    [sym_int64] = STATE(4765),
    [sym_uint64] = STATE(4765),
    [sym_ieee32] = STATE(4765),
    [sym_ieee64] = STATE(4765),
    [sym_bignum] = STATE(4765),
    [sym_decimal] = STATE(4765),
    [sym_float] = STATE(4512),
    [sym_block_comment] = STATE(2684),
    [sym_compiler_directive_decl] = STATE(2684),
    [sym_fsi_directive_decl] = STATE(2684),
    [sym_preproc_line] = STATE(2684),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(4175),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_LPAREN] = ACTIONS(3572),
    [anon_sym_null] = ACTIONS(3574),
    [anon_sym__] = ACTIONS(3576),
    [anon_sym_QMARK] = ACTIONS(4177),
    [anon_sym_COLON_QMARK] = ACTIONS(4179),
    [anon_sym_LBRACK] = ACTIONS(3582),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3584),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [aux_sym_char_token1] = ACTIONS(3590),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3592),
    [anon_sym_DQUOTE] = ACTIONS(3594),
    [anon_sym_AT_DQUOTE] = ACTIONS(3596),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3598),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3600),
    [sym_bool] = ACTIONS(3602),
    [sym_unit] = ACTIONS(3604),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4181),
    [sym_op_identifier] = ACTIONS(4183),
    [sym_int] = ACTIONS(3610),
    [sym_xint] = ACTIONS(3612),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2685] = {
    [sym_attributes] = STATE(2676),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(4815),
    [sym__pattern] = STATE(5482),
    [sym_optional_pattern] = STATE(4815),
    [sym_type_check_pattern] = STATE(4815),
    [sym_attribute_pattern] = STATE(4815),
    [sym_paren_pattern] = STATE(4815),
    [sym_as_pattern] = STATE(4815),
    [sym_cons_pattern] = STATE(4815),
    [sym_disjunct_pattern] = STATE(4815),
    [sym_conjunct_pattern] = STATE(4815),
    [sym_typed_pattern] = STATE(4815),
    [sym_list_pattern] = STATE(4815),
    [sym_array_pattern] = STATE(4815),
    [sym_record_pattern] = STATE(4815),
    [sym_named_field_pattern] = STATE(4815),
    [sym_identifier_pattern] = STATE(4815),
    [sym_long_identifier_or_op] = STATE(1792),
    [sym_char] = STATE(4765),
    [sym_format_string] = STATE(4746),
    [sym__string_literal] = STATE(4746),
    [sym_string] = STATE(4765),
    [sym_verbatim_string] = STATE(4765),
    [sym_bytearray] = STATE(4765),
    [sym_verbatim_bytearray] = STATE(4765),
    [sym_format_triple_quoted_string] = STATE(4720),
    [sym_triple_quoted_string] = STATE(4765),
    [sym_const] = STATE(4815),
    [sym_long_identifier] = STATE(3320),
    [sym_active_pattern] = STATE(3488),
    [sym__identifier_or_op] = STATE(3410),
    [sym_sbyte] = STATE(4765),
    [sym_byte] = STATE(4765),
    [sym_int16] = STATE(4765),
    [sym_uint16] = STATE(4765),
    [sym_int32] = STATE(4765),
    [sym_uint32] = STATE(4765),
    [sym_nativeint] = STATE(4765),
    [sym_unativeint] = STATE(4765),
    [sym_int64] = STATE(4765),
    [sym_uint64] = STATE(4765),
    [sym_ieee32] = STATE(4765),
    [sym_ieee64] = STATE(4765),
    [sym_bignum] = STATE(4765),
    [sym_decimal] = STATE(4765),
    [sym_float] = STATE(4512),
    [sym_block_comment] = STATE(2685),
    [sym_compiler_directive_decl] = STATE(2685),
    [sym_fsi_directive_decl] = STATE(2685),
    [sym_preproc_line] = STATE(2685),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(3562),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_LPAREN] = ACTIONS(3572),
    [anon_sym_null] = ACTIONS(3574),
    [anon_sym__] = ACTIONS(3576),
    [anon_sym_QMARK] = ACTIONS(3578),
    [anon_sym_COLON_QMARK] = ACTIONS(3580),
    [anon_sym_LBRACK] = ACTIONS(3582),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3584),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [aux_sym_char_token1] = ACTIONS(3590),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3592),
    [anon_sym_DQUOTE] = ACTIONS(3594),
    [anon_sym_AT_DQUOTE] = ACTIONS(3596),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3598),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3600),
    [sym_bool] = ACTIONS(3602),
    [sym_unit] = ACTIONS(3604),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3606),
    [sym_op_identifier] = ACTIONS(3608),
    [sym_int] = ACTIONS(3610),
    [sym_xint] = ACTIONS(3612),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2686] = {
    [sym_attributes] = STATE(2689),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(3731),
    [sym__pattern] = STATE(3582),
    [sym_optional_pattern] = STATE(3731),
    [sym_type_check_pattern] = STATE(3731),
    [sym_attribute_pattern] = STATE(3731),
    [sym_paren_pattern] = STATE(3731),
    [sym_as_pattern] = STATE(3731),
    [sym_cons_pattern] = STATE(3731),
    [sym_disjunct_pattern] = STATE(3731),
    [sym_conjunct_pattern] = STATE(3731),
    [sym_typed_pattern] = STATE(3731),
    [sym_list_pattern] = STATE(3731),
    [sym_array_pattern] = STATE(3731),
    [sym_record_pattern] = STATE(3731),
    [sym_named_field_pattern] = STATE(3731),
    [sym_identifier_pattern] = STATE(3731),
    [sym_long_identifier_or_op] = STATE(2472),
    [sym_char] = STATE(3709),
    [sym_format_string] = STATE(3712),
    [sym__string_literal] = STATE(3712),
    [sym_string] = STATE(3709),
    [sym_verbatim_string] = STATE(3709),
    [sym_bytearray] = STATE(3709),
    [sym_verbatim_bytearray] = STATE(3709),
    [sym_format_triple_quoted_string] = STATE(3716),
    [sym_triple_quoted_string] = STATE(3709),
    [sym_const] = STATE(3731),
    [sym_long_identifier] = STATE(3655),
    [sym_active_pattern] = STATE(3734),
    [sym__identifier_or_op] = STATE(3737),
    [sym_sbyte] = STATE(3709),
    [sym_byte] = STATE(3709),
    [sym_int16] = STATE(3709),
    [sym_uint16] = STATE(3709),
    [sym_int32] = STATE(3709),
    [sym_uint32] = STATE(3709),
    [sym_nativeint] = STATE(3709),
    [sym_unativeint] = STATE(3709),
    [sym_int64] = STATE(3709),
    [sym_uint64] = STATE(3709),
    [sym_ieee32] = STATE(3709),
    [sym_ieee64] = STATE(3709),
    [sym_bignum] = STATE(3709),
    [sym_decimal] = STATE(3709),
    [sym_float] = STATE(3489),
    [sym_block_comment] = STATE(2686),
    [sym_compiler_directive_decl] = STATE(2686),
    [sym_fsi_directive_decl] = STATE(2686),
    [sym_preproc_line] = STATE(2686),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(4196),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_LPAREN] = ACTIONS(4308),
    [anon_sym_null] = ACTIONS(4310),
    [anon_sym__] = ACTIONS(4312),
    [anon_sym_QMARK] = ACTIONS(4314),
    [anon_sym_COLON_QMARK] = ACTIONS(4316),
    [anon_sym_LBRACK] = ACTIONS(4318),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4320),
    [anon_sym_LBRACE] = ACTIONS(4322),
    [aux_sym_char_token1] = ACTIONS(4324),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4326),
    [anon_sym_DQUOTE] = ACTIONS(4328),
    [anon_sym_AT_DQUOTE] = ACTIONS(4330),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4332),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4334),
    [sym_bool] = ACTIONS(4336),
    [sym_unit] = ACTIONS(4338),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4212),
    [sym_op_identifier] = ACTIONS(4214),
    [sym_int] = ACTIONS(4340),
    [sym_xint] = ACTIONS(4342),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2687] = {
    [sym_attributes] = STATE(2632),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(4815),
    [sym__pattern] = STATE(5424),
    [sym_optional_pattern] = STATE(4815),
    [sym_type_check_pattern] = STATE(4815),
    [sym_attribute_pattern] = STATE(4815),
    [sym_paren_pattern] = STATE(4815),
    [sym_as_pattern] = STATE(4815),
    [sym_cons_pattern] = STATE(4815),
    [sym_disjunct_pattern] = STATE(4815),
    [sym_conjunct_pattern] = STATE(4815),
    [sym_typed_pattern] = STATE(4815),
    [sym_list_pattern] = STATE(4815),
    [sym_array_pattern] = STATE(4815),
    [sym_record_pattern] = STATE(4815),
    [sym_named_field_pattern] = STATE(4815),
    [sym_identifier_pattern] = STATE(4815),
    [sym_long_identifier_or_op] = STATE(2475),
    [sym_char] = STATE(4765),
    [sym_format_string] = STATE(4746),
    [sym__string_literal] = STATE(4746),
    [sym_string] = STATE(4765),
    [sym_verbatim_string] = STATE(4765),
    [sym_bytearray] = STATE(4765),
    [sym_verbatim_bytearray] = STATE(4765),
    [sym_format_triple_quoted_string] = STATE(4720),
    [sym_triple_quoted_string] = STATE(4765),
    [sym_const] = STATE(4815),
    [sym_long_identifier] = STATE(3655),
    [sym_active_pattern] = STATE(3734),
    [sym__identifier_or_op] = STATE(3737),
    [sym_sbyte] = STATE(4765),
    [sym_byte] = STATE(4765),
    [sym_int16] = STATE(4765),
    [sym_uint16] = STATE(4765),
    [sym_int32] = STATE(4765),
    [sym_uint32] = STATE(4765),
    [sym_nativeint] = STATE(4765),
    [sym_unativeint] = STATE(4765),
    [sym_int64] = STATE(4765),
    [sym_uint64] = STATE(4765),
    [sym_ieee32] = STATE(4765),
    [sym_ieee64] = STATE(4765),
    [sym_bignum] = STATE(4765),
    [sym_decimal] = STATE(4765),
    [sym_float] = STATE(4512),
    [sym_block_comment] = STATE(2687),
    [sym_compiler_directive_decl] = STATE(2687),
    [sym_fsi_directive_decl] = STATE(2687),
    [sym_preproc_line] = STATE(2687),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(4492),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_LPAREN] = ACTIONS(3572),
    [anon_sym_null] = ACTIONS(3574),
    [anon_sym__] = ACTIONS(3576),
    [anon_sym_QMARK] = ACTIONS(4202),
    [anon_sym_COLON_QMARK] = ACTIONS(4204),
    [anon_sym_LBRACK] = ACTIONS(3582),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3584),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [aux_sym_char_token1] = ACTIONS(3590),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3592),
    [anon_sym_DQUOTE] = ACTIONS(3594),
    [anon_sym_AT_DQUOTE] = ACTIONS(3596),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3598),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3600),
    [sym_bool] = ACTIONS(3602),
    [sym_unit] = ACTIONS(3604),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4212),
    [sym_op_identifier] = ACTIONS(4214),
    [sym_int] = ACTIONS(3610),
    [sym_xint] = ACTIONS(3612),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2688] = {
    [sym_attributes] = STATE(2699),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(4815),
    [sym__pattern] = STATE(5258),
    [sym_optional_pattern] = STATE(4815),
    [sym_type_check_pattern] = STATE(4815),
    [sym_attribute_pattern] = STATE(4815),
    [sym_paren_pattern] = STATE(4815),
    [sym_as_pattern] = STATE(4815),
    [sym_cons_pattern] = STATE(4815),
    [sym_disjunct_pattern] = STATE(4815),
    [sym_conjunct_pattern] = STATE(4815),
    [sym_typed_pattern] = STATE(4815),
    [sym_list_pattern] = STATE(4815),
    [sym_array_pattern] = STATE(4815),
    [sym_record_pattern] = STATE(4815),
    [sym_named_field_pattern] = STATE(4815),
    [sym_identifier_pattern] = STATE(4815),
    [sym_long_identifier_or_op] = STATE(2193),
    [sym_char] = STATE(4765),
    [sym_format_string] = STATE(4746),
    [sym__string_literal] = STATE(4746),
    [sym_string] = STATE(4765),
    [sym_verbatim_string] = STATE(4765),
    [sym_bytearray] = STATE(4765),
    [sym_verbatim_bytearray] = STATE(4765),
    [sym_format_triple_quoted_string] = STATE(4720),
    [sym_triple_quoted_string] = STATE(4765),
    [sym_const] = STATE(4815),
    [sym_long_identifier] = STATE(3493),
    [sym_active_pattern] = STATE(3613),
    [sym__identifier_or_op] = STATE(3650),
    [sym_sbyte] = STATE(4765),
    [sym_byte] = STATE(4765),
    [sym_int16] = STATE(4765),
    [sym_uint16] = STATE(4765),
    [sym_int32] = STATE(4765),
    [sym_uint32] = STATE(4765),
    [sym_nativeint] = STATE(4765),
    [sym_unativeint] = STATE(4765),
    [sym_int64] = STATE(4765),
    [sym_uint64] = STATE(4765),
    [sym_ieee32] = STATE(4765),
    [sym_ieee64] = STATE(4765),
    [sym_bignum] = STATE(4765),
    [sym_decimal] = STATE(4765),
    [sym_float] = STATE(4512),
    [sym_block_comment] = STATE(2688),
    [sym_compiler_directive_decl] = STATE(2688),
    [sym_fsi_directive_decl] = STATE(2688),
    [sym_preproc_line] = STATE(2688),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(4175),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_LPAREN] = ACTIONS(3572),
    [anon_sym_null] = ACTIONS(3574),
    [anon_sym__] = ACTIONS(3576),
    [anon_sym_QMARK] = ACTIONS(4177),
    [anon_sym_COLON_QMARK] = ACTIONS(4179),
    [anon_sym_LBRACK] = ACTIONS(3582),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3584),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [aux_sym_char_token1] = ACTIONS(3590),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3592),
    [anon_sym_DQUOTE] = ACTIONS(3594),
    [anon_sym_AT_DQUOTE] = ACTIONS(3596),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3598),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3600),
    [sym_bool] = ACTIONS(3602),
    [sym_unit] = ACTIONS(3604),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4181),
    [sym_op_identifier] = ACTIONS(4183),
    [sym_int] = ACTIONS(3610),
    [sym_xint] = ACTIONS(3612),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2689] = {
    [sym_attributes] = STATE(2689),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(3731),
    [sym__pattern] = STATE(3597),
    [sym_optional_pattern] = STATE(3731),
    [sym_type_check_pattern] = STATE(3731),
    [sym_attribute_pattern] = STATE(3731),
    [sym_paren_pattern] = STATE(3731),
    [sym_as_pattern] = STATE(3731),
    [sym_cons_pattern] = STATE(3731),
    [sym_disjunct_pattern] = STATE(3731),
    [sym_conjunct_pattern] = STATE(3731),
    [sym_typed_pattern] = STATE(3731),
    [sym_list_pattern] = STATE(3731),
    [sym_array_pattern] = STATE(3731),
    [sym_record_pattern] = STATE(3731),
    [sym_named_field_pattern] = STATE(3731),
    [sym_identifier_pattern] = STATE(3731),
    [sym_long_identifier_or_op] = STATE(2472),
    [sym_char] = STATE(3709),
    [sym_format_string] = STATE(3712),
    [sym__string_literal] = STATE(3712),
    [sym_string] = STATE(3709),
    [sym_verbatim_string] = STATE(3709),
    [sym_bytearray] = STATE(3709),
    [sym_verbatim_bytearray] = STATE(3709),
    [sym_format_triple_quoted_string] = STATE(3716),
    [sym_triple_quoted_string] = STATE(3709),
    [sym_const] = STATE(3731),
    [sym_long_identifier] = STATE(3655),
    [sym_active_pattern] = STATE(3734),
    [sym__identifier_or_op] = STATE(3737),
    [sym_sbyte] = STATE(3709),
    [sym_byte] = STATE(3709),
    [sym_int16] = STATE(3709),
    [sym_uint16] = STATE(3709),
    [sym_int32] = STATE(3709),
    [sym_uint32] = STATE(3709),
    [sym_nativeint] = STATE(3709),
    [sym_unativeint] = STATE(3709),
    [sym_int64] = STATE(3709),
    [sym_uint64] = STATE(3709),
    [sym_ieee32] = STATE(3709),
    [sym_ieee64] = STATE(3709),
    [sym_bignum] = STATE(3709),
    [sym_decimal] = STATE(3709),
    [sym_float] = STATE(3489),
    [sym_block_comment] = STATE(2689),
    [sym_compiler_directive_decl] = STATE(2689),
    [sym_fsi_directive_decl] = STATE(2689),
    [sym_preproc_line] = STATE(2689),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(4196),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_LPAREN] = ACTIONS(4308),
    [anon_sym_null] = ACTIONS(4310),
    [anon_sym__] = ACTIONS(4312),
    [anon_sym_QMARK] = ACTIONS(4314),
    [anon_sym_COLON_QMARK] = ACTIONS(4316),
    [anon_sym_LBRACK] = ACTIONS(4318),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4320),
    [anon_sym_LBRACE] = ACTIONS(4322),
    [aux_sym_char_token1] = ACTIONS(4324),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4326),
    [anon_sym_DQUOTE] = ACTIONS(4328),
    [anon_sym_AT_DQUOTE] = ACTIONS(4330),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4332),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4334),
    [sym_bool] = ACTIONS(4336),
    [sym_unit] = ACTIONS(4338),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4212),
    [sym_op_identifier] = ACTIONS(4214),
    [sym_int] = ACTIONS(4340),
    [sym_xint] = ACTIONS(4342),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2690] = {
    [sym_attributes] = STATE(2632),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(4815),
    [sym__pattern] = STATE(5464),
    [sym_optional_pattern] = STATE(4815),
    [sym_type_check_pattern] = STATE(4815),
    [sym_attribute_pattern] = STATE(4815),
    [sym_paren_pattern] = STATE(4815),
    [sym_as_pattern] = STATE(4815),
    [sym_cons_pattern] = STATE(4815),
    [sym_disjunct_pattern] = STATE(4815),
    [sym_conjunct_pattern] = STATE(4815),
    [sym_typed_pattern] = STATE(4815),
    [sym_list_pattern] = STATE(4815),
    [sym_array_pattern] = STATE(4815),
    [sym_record_pattern] = STATE(4815),
    [sym_named_field_pattern] = STATE(4815),
    [sym_identifier_pattern] = STATE(4815),
    [sym_long_identifier_or_op] = STATE(2475),
    [sym_char] = STATE(4765),
    [sym_format_string] = STATE(4746),
    [sym__string_literal] = STATE(4746),
    [sym_string] = STATE(4765),
    [sym_verbatim_string] = STATE(4765),
    [sym_bytearray] = STATE(4765),
    [sym_verbatim_bytearray] = STATE(4765),
    [sym_format_triple_quoted_string] = STATE(4720),
    [sym_triple_quoted_string] = STATE(4765),
    [sym_const] = STATE(4815),
    [sym_long_identifier] = STATE(3655),
    [sym_active_pattern] = STATE(3734),
    [sym__identifier_or_op] = STATE(3737),
    [sym_sbyte] = STATE(4765),
    [sym_byte] = STATE(4765),
    [sym_int16] = STATE(4765),
    [sym_uint16] = STATE(4765),
    [sym_int32] = STATE(4765),
    [sym_uint32] = STATE(4765),
    [sym_nativeint] = STATE(4765),
    [sym_unativeint] = STATE(4765),
    [sym_int64] = STATE(4765),
    [sym_uint64] = STATE(4765),
    [sym_ieee32] = STATE(4765),
    [sym_ieee64] = STATE(4765),
    [sym_bignum] = STATE(4765),
    [sym_decimal] = STATE(4765),
    [sym_float] = STATE(4512),
    [sym_block_comment] = STATE(2690),
    [sym_compiler_directive_decl] = STATE(2690),
    [sym_fsi_directive_decl] = STATE(2690),
    [sym_preproc_line] = STATE(2690),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(4494),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_LPAREN] = ACTIONS(3572),
    [anon_sym_null] = ACTIONS(3574),
    [anon_sym__] = ACTIONS(3576),
    [anon_sym_QMARK] = ACTIONS(4202),
    [anon_sym_COLON_QMARK] = ACTIONS(4204),
    [anon_sym_LBRACK] = ACTIONS(3582),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3584),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [aux_sym_char_token1] = ACTIONS(3590),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3592),
    [anon_sym_DQUOTE] = ACTIONS(3594),
    [anon_sym_AT_DQUOTE] = ACTIONS(3596),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3598),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3600),
    [sym_bool] = ACTIONS(3602),
    [sym_unit] = ACTIONS(3604),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4212),
    [sym_op_identifier] = ACTIONS(4214),
    [sym_int] = ACTIONS(3610),
    [sym_xint] = ACTIONS(3612),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2691] = {
    [sym_attributes] = STATE(2676),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(4815),
    [sym__pattern] = STATE(5084),
    [sym_optional_pattern] = STATE(4815),
    [sym_type_check_pattern] = STATE(4815),
    [sym_attribute_pattern] = STATE(4815),
    [sym_paren_pattern] = STATE(4815),
    [sym_as_pattern] = STATE(4815),
    [sym_cons_pattern] = STATE(4815),
    [sym_disjunct_pattern] = STATE(4815),
    [sym_conjunct_pattern] = STATE(4815),
    [sym_typed_pattern] = STATE(4815),
    [sym_list_pattern] = STATE(4815),
    [sym_array_pattern] = STATE(4815),
    [sym_record_pattern] = STATE(4815),
    [sym_named_field_pattern] = STATE(4815),
    [sym_identifier_pattern] = STATE(4815),
    [sym_long_identifier_or_op] = STATE(1792),
    [sym_char] = STATE(4765),
    [sym_format_string] = STATE(4746),
    [sym__string_literal] = STATE(4746),
    [sym_string] = STATE(4765),
    [sym_verbatim_string] = STATE(4765),
    [sym_bytearray] = STATE(4765),
    [sym_verbatim_bytearray] = STATE(4765),
    [sym_format_triple_quoted_string] = STATE(4720),
    [sym_triple_quoted_string] = STATE(4765),
    [sym_const] = STATE(4815),
    [sym_long_identifier] = STATE(3320),
    [sym_active_pattern] = STATE(3488),
    [sym__identifier_or_op] = STATE(3410),
    [sym_sbyte] = STATE(4765),
    [sym_byte] = STATE(4765),
    [sym_int16] = STATE(4765),
    [sym_uint16] = STATE(4765),
    [sym_int32] = STATE(4765),
    [sym_uint32] = STATE(4765),
    [sym_nativeint] = STATE(4765),
    [sym_unativeint] = STATE(4765),
    [sym_int64] = STATE(4765),
    [sym_uint64] = STATE(4765),
    [sym_ieee32] = STATE(4765),
    [sym_ieee64] = STATE(4765),
    [sym_bignum] = STATE(4765),
    [sym_decimal] = STATE(4765),
    [sym_float] = STATE(4512),
    [sym_block_comment] = STATE(2691),
    [sym_compiler_directive_decl] = STATE(2691),
    [sym_fsi_directive_decl] = STATE(2691),
    [sym_preproc_line] = STATE(2691),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(3562),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_LPAREN] = ACTIONS(3572),
    [anon_sym_null] = ACTIONS(3574),
    [anon_sym__] = ACTIONS(3576),
    [anon_sym_QMARK] = ACTIONS(3578),
    [anon_sym_COLON_QMARK] = ACTIONS(3580),
    [anon_sym_LBRACK] = ACTIONS(3582),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3584),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [aux_sym_char_token1] = ACTIONS(3590),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3592),
    [anon_sym_DQUOTE] = ACTIONS(3594),
    [anon_sym_AT_DQUOTE] = ACTIONS(3596),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3598),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3600),
    [sym_bool] = ACTIONS(3602),
    [sym_unit] = ACTIONS(3604),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3606),
    [sym_op_identifier] = ACTIONS(3608),
    [sym_int] = ACTIONS(3610),
    [sym_xint] = ACTIONS(3612),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2692] = {
    [sym_attributes] = STATE(2699),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(4815),
    [sym__pattern] = STATE(5257),
    [sym_optional_pattern] = STATE(4815),
    [sym_type_check_pattern] = STATE(4815),
    [sym_attribute_pattern] = STATE(4815),
    [sym_paren_pattern] = STATE(4815),
    [sym_as_pattern] = STATE(4815),
    [sym_cons_pattern] = STATE(4815),
    [sym_disjunct_pattern] = STATE(4815),
    [sym_conjunct_pattern] = STATE(4815),
    [sym_typed_pattern] = STATE(4815),
    [sym_list_pattern] = STATE(4815),
    [sym_array_pattern] = STATE(4815),
    [sym_record_pattern] = STATE(4815),
    [sym_named_field_pattern] = STATE(4815),
    [sym_identifier_pattern] = STATE(4815),
    [sym_long_identifier_or_op] = STATE(2193),
    [sym_char] = STATE(4765),
    [sym_format_string] = STATE(4746),
    [sym__string_literal] = STATE(4746),
    [sym_string] = STATE(4765),
    [sym_verbatim_string] = STATE(4765),
    [sym_bytearray] = STATE(4765),
    [sym_verbatim_bytearray] = STATE(4765),
    [sym_format_triple_quoted_string] = STATE(4720),
    [sym_triple_quoted_string] = STATE(4765),
    [sym_const] = STATE(4815),
    [sym_long_identifier] = STATE(3493),
    [sym_active_pattern] = STATE(3613),
    [sym__identifier_or_op] = STATE(3650),
    [sym_sbyte] = STATE(4765),
    [sym_byte] = STATE(4765),
    [sym_int16] = STATE(4765),
    [sym_uint16] = STATE(4765),
    [sym_int32] = STATE(4765),
    [sym_uint32] = STATE(4765),
    [sym_nativeint] = STATE(4765),
    [sym_unativeint] = STATE(4765),
    [sym_int64] = STATE(4765),
    [sym_uint64] = STATE(4765),
    [sym_ieee32] = STATE(4765),
    [sym_ieee64] = STATE(4765),
    [sym_bignum] = STATE(4765),
    [sym_decimal] = STATE(4765),
    [sym_float] = STATE(4512),
    [sym_block_comment] = STATE(2692),
    [sym_compiler_directive_decl] = STATE(2692),
    [sym_fsi_directive_decl] = STATE(2692),
    [sym_preproc_line] = STATE(2692),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(4175),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_LPAREN] = ACTIONS(3572),
    [anon_sym_null] = ACTIONS(3574),
    [anon_sym__] = ACTIONS(3576),
    [anon_sym_QMARK] = ACTIONS(4177),
    [anon_sym_COLON_QMARK] = ACTIONS(4179),
    [anon_sym_LBRACK] = ACTIONS(3582),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3584),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [aux_sym_char_token1] = ACTIONS(3590),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3592),
    [anon_sym_DQUOTE] = ACTIONS(3594),
    [anon_sym_AT_DQUOTE] = ACTIONS(3596),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3598),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3600),
    [sym_bool] = ACTIONS(3602),
    [sym_unit] = ACTIONS(3604),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4181),
    [sym_op_identifier] = ACTIONS(4183),
    [sym_int] = ACTIONS(3610),
    [sym_xint] = ACTIONS(3612),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2693] = {
    [sym_attributes] = STATE(2676),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(4815),
    [sym__pattern] = STATE(5108),
    [sym_optional_pattern] = STATE(4815),
    [sym_type_check_pattern] = STATE(4815),
    [sym_attribute_pattern] = STATE(4815),
    [sym_paren_pattern] = STATE(4815),
    [sym_as_pattern] = STATE(4815),
    [sym_cons_pattern] = STATE(4815),
    [sym_disjunct_pattern] = STATE(4815),
    [sym_conjunct_pattern] = STATE(4815),
    [sym_typed_pattern] = STATE(4815),
    [sym_list_pattern] = STATE(4815),
    [sym_array_pattern] = STATE(4815),
    [sym_record_pattern] = STATE(4815),
    [sym_named_field_pattern] = STATE(4815),
    [sym_identifier_pattern] = STATE(4815),
    [sym_long_identifier_or_op] = STATE(1792),
    [sym_char] = STATE(4765),
    [sym_format_string] = STATE(4746),
    [sym__string_literal] = STATE(4746),
    [sym_string] = STATE(4765),
    [sym_verbatim_string] = STATE(4765),
    [sym_bytearray] = STATE(4765),
    [sym_verbatim_bytearray] = STATE(4765),
    [sym_format_triple_quoted_string] = STATE(4720),
    [sym_triple_quoted_string] = STATE(4765),
    [sym_const] = STATE(4815),
    [sym_long_identifier] = STATE(3320),
    [sym_active_pattern] = STATE(3488),
    [sym__identifier_or_op] = STATE(2760),
    [sym_sbyte] = STATE(4765),
    [sym_byte] = STATE(4765),
    [sym_int16] = STATE(4765),
    [sym_uint16] = STATE(4765),
    [sym_int32] = STATE(4765),
    [sym_uint32] = STATE(4765),
    [sym_nativeint] = STATE(4765),
    [sym_unativeint] = STATE(4765),
    [sym_int64] = STATE(4765),
    [sym_uint64] = STATE(4765),
    [sym_ieee32] = STATE(4765),
    [sym_ieee64] = STATE(4765),
    [sym_bignum] = STATE(4765),
    [sym_decimal] = STATE(4765),
    [sym_float] = STATE(4512),
    [sym_block_comment] = STATE(2693),
    [sym_compiler_directive_decl] = STATE(2693),
    [sym_fsi_directive_decl] = STATE(2693),
    [sym_preproc_line] = STATE(2693),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(3562),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_LPAREN] = ACTIONS(3572),
    [anon_sym_null] = ACTIONS(3574),
    [anon_sym__] = ACTIONS(3576),
    [anon_sym_QMARK] = ACTIONS(3578),
    [anon_sym_COLON_QMARK] = ACTIONS(3580),
    [anon_sym_LBRACK] = ACTIONS(3582),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3584),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [aux_sym_char_token1] = ACTIONS(3590),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3592),
    [anon_sym_DQUOTE] = ACTIONS(3594),
    [anon_sym_AT_DQUOTE] = ACTIONS(3596),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3598),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3600),
    [sym_bool] = ACTIONS(3602),
    [sym_unit] = ACTIONS(3604),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3606),
    [sym_op_identifier] = ACTIONS(3608),
    [sym_int] = ACTIONS(3610),
    [sym_xint] = ACTIONS(3612),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2694] = {
    [sym_attributes] = STATE(2676),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(4815),
    [sym__pattern] = STATE(5085),
    [sym_optional_pattern] = STATE(4815),
    [sym_type_check_pattern] = STATE(4815),
    [sym_attribute_pattern] = STATE(4815),
    [sym_paren_pattern] = STATE(4815),
    [sym_as_pattern] = STATE(4815),
    [sym_cons_pattern] = STATE(4815),
    [sym_disjunct_pattern] = STATE(4815),
    [sym_conjunct_pattern] = STATE(4815),
    [sym_typed_pattern] = STATE(4815),
    [sym_list_pattern] = STATE(4815),
    [sym_array_pattern] = STATE(4815),
    [sym_record_pattern] = STATE(4815),
    [sym_named_field_pattern] = STATE(4815),
    [sym_identifier_pattern] = STATE(4815),
    [sym_long_identifier_or_op] = STATE(1792),
    [sym_char] = STATE(4765),
    [sym_format_string] = STATE(4746),
    [sym__string_literal] = STATE(4746),
    [sym_string] = STATE(4765),
    [sym_verbatim_string] = STATE(4765),
    [sym_bytearray] = STATE(4765),
    [sym_verbatim_bytearray] = STATE(4765),
    [sym_format_triple_quoted_string] = STATE(4720),
    [sym_triple_quoted_string] = STATE(4765),
    [sym_const] = STATE(4815),
    [sym_long_identifier] = STATE(3320),
    [sym_active_pattern] = STATE(3488),
    [sym__identifier_or_op] = STATE(3410),
    [sym_sbyte] = STATE(4765),
    [sym_byte] = STATE(4765),
    [sym_int16] = STATE(4765),
    [sym_uint16] = STATE(4765),
    [sym_int32] = STATE(4765),
    [sym_uint32] = STATE(4765),
    [sym_nativeint] = STATE(4765),
    [sym_unativeint] = STATE(4765),
    [sym_int64] = STATE(4765),
    [sym_uint64] = STATE(4765),
    [sym_ieee32] = STATE(4765),
    [sym_ieee64] = STATE(4765),
    [sym_bignum] = STATE(4765),
    [sym_decimal] = STATE(4765),
    [sym_float] = STATE(4512),
    [sym_block_comment] = STATE(2694),
    [sym_compiler_directive_decl] = STATE(2694),
    [sym_fsi_directive_decl] = STATE(2694),
    [sym_preproc_line] = STATE(2694),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(3562),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_LPAREN] = ACTIONS(3572),
    [anon_sym_null] = ACTIONS(3574),
    [anon_sym__] = ACTIONS(3576),
    [anon_sym_QMARK] = ACTIONS(3578),
    [anon_sym_COLON_QMARK] = ACTIONS(3580),
    [anon_sym_LBRACK] = ACTIONS(3582),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3584),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [aux_sym_char_token1] = ACTIONS(3590),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3592),
    [anon_sym_DQUOTE] = ACTIONS(3594),
    [anon_sym_AT_DQUOTE] = ACTIONS(3596),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3598),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3600),
    [sym_bool] = ACTIONS(3602),
    [sym_unit] = ACTIONS(3604),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3606),
    [sym_op_identifier] = ACTIONS(3608),
    [sym_int] = ACTIONS(3610),
    [sym_xint] = ACTIONS(3612),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2695] = {
    [sym_attributes] = STATE(2632),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(4815),
    [sym__pattern] = STATE(5428),
    [sym_optional_pattern] = STATE(4815),
    [sym_type_check_pattern] = STATE(4815),
    [sym_attribute_pattern] = STATE(4815),
    [sym_paren_pattern] = STATE(4815),
    [sym_as_pattern] = STATE(4815),
    [sym_cons_pattern] = STATE(4815),
    [sym_disjunct_pattern] = STATE(4815),
    [sym_conjunct_pattern] = STATE(4815),
    [sym_typed_pattern] = STATE(4815),
    [sym_list_pattern] = STATE(4815),
    [sym_array_pattern] = STATE(4815),
    [sym_record_pattern] = STATE(4815),
    [sym_named_field_pattern] = STATE(4815),
    [sym_identifier_pattern] = STATE(4815),
    [sym_long_identifier_or_op] = STATE(2475),
    [sym_char] = STATE(4765),
    [sym_format_string] = STATE(4746),
    [sym__string_literal] = STATE(4746),
    [sym_string] = STATE(4765),
    [sym_verbatim_string] = STATE(4765),
    [sym_bytearray] = STATE(4765),
    [sym_verbatim_bytearray] = STATE(4765),
    [sym_format_triple_quoted_string] = STATE(4720),
    [sym_triple_quoted_string] = STATE(4765),
    [sym_const] = STATE(4815),
    [sym_long_identifier] = STATE(3655),
    [sym_active_pattern] = STATE(3734),
    [sym__identifier_or_op] = STATE(3737),
    [sym_sbyte] = STATE(4765),
    [sym_byte] = STATE(4765),
    [sym_int16] = STATE(4765),
    [sym_uint16] = STATE(4765),
    [sym_int32] = STATE(4765),
    [sym_uint32] = STATE(4765),
    [sym_nativeint] = STATE(4765),
    [sym_unativeint] = STATE(4765),
    [sym_int64] = STATE(4765),
    [sym_uint64] = STATE(4765),
    [sym_ieee32] = STATE(4765),
    [sym_ieee64] = STATE(4765),
    [sym_bignum] = STATE(4765),
    [sym_decimal] = STATE(4765),
    [sym_float] = STATE(4512),
    [sym_block_comment] = STATE(2695),
    [sym_compiler_directive_decl] = STATE(2695),
    [sym_fsi_directive_decl] = STATE(2695),
    [sym_preproc_line] = STATE(2695),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(4496),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_LPAREN] = ACTIONS(3572),
    [anon_sym_null] = ACTIONS(3574),
    [anon_sym__] = ACTIONS(3576),
    [anon_sym_QMARK] = ACTIONS(4202),
    [anon_sym_COLON_QMARK] = ACTIONS(4204),
    [anon_sym_LBRACK] = ACTIONS(3582),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3584),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [aux_sym_char_token1] = ACTIONS(3590),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3592),
    [anon_sym_DQUOTE] = ACTIONS(3594),
    [anon_sym_AT_DQUOTE] = ACTIONS(3596),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3598),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3600),
    [sym_bool] = ACTIONS(3602),
    [sym_unit] = ACTIONS(3604),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4212),
    [sym_op_identifier] = ACTIONS(4214),
    [sym_int] = ACTIONS(3610),
    [sym_xint] = ACTIONS(3612),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2696] = {
    [sym_attributes] = STATE(2636),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(3546),
    [sym__pattern] = STATE(3365),
    [sym_optional_pattern] = STATE(3546),
    [sym_type_check_pattern] = STATE(3546),
    [sym_attribute_pattern] = STATE(3546),
    [sym_paren_pattern] = STATE(3546),
    [sym_as_pattern] = STATE(3546),
    [sym_cons_pattern] = STATE(3546),
    [sym_disjunct_pattern] = STATE(3546),
    [sym_conjunct_pattern] = STATE(3546),
    [sym_typed_pattern] = STATE(3546),
    [sym_list_pattern] = STATE(3546),
    [sym_array_pattern] = STATE(3546),
    [sym_record_pattern] = STATE(3546),
    [sym_named_field_pattern] = STATE(3546),
    [sym_identifier_pattern] = STATE(3546),
    [sym_long_identifier_or_op] = STATE(1834),
    [sym_char] = STATE(3509),
    [sym_format_string] = STATE(3517),
    [sym__string_literal] = STATE(3517),
    [sym_string] = STATE(3509),
    [sym_verbatim_string] = STATE(3509),
    [sym_bytearray] = STATE(3509),
    [sym_verbatim_bytearray] = STATE(3509),
    [sym_format_triple_quoted_string] = STATE(3519),
    [sym_triple_quoted_string] = STATE(3509),
    [sym_const] = STATE(3546),
    [sym_long_identifier] = STATE(3320),
    [sym_active_pattern] = STATE(3488),
    [sym__identifier_or_op] = STATE(3410),
    [sym_sbyte] = STATE(3509),
    [sym_byte] = STATE(3509),
    [sym_int16] = STATE(3509),
    [sym_uint16] = STATE(3509),
    [sym_int32] = STATE(3509),
    [sym_uint32] = STATE(3509),
    [sym_nativeint] = STATE(3509),
    [sym_unativeint] = STATE(3509),
    [sym_int64] = STATE(3509),
    [sym_uint64] = STATE(3509),
    [sym_ieee32] = STATE(3509),
    [sym_ieee64] = STATE(3509),
    [sym_bignum] = STATE(3509),
    [sym_decimal] = STATE(3509),
    [sym_float] = STATE(3291),
    [sym_block_comment] = STATE(2696),
    [sym_compiler_directive_decl] = STATE(2696),
    [sym_fsi_directive_decl] = STATE(2696),
    [sym_preproc_line] = STATE(2696),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(3562),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_LPAREN] = ACTIONS(4014),
    [anon_sym_null] = ACTIONS(4016),
    [anon_sym__] = ACTIONS(4018),
    [anon_sym_QMARK] = ACTIONS(4020),
    [anon_sym_COLON_QMARK] = ACTIONS(4022),
    [anon_sym_LBRACK] = ACTIONS(4024),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4026),
    [anon_sym_LBRACE] = ACTIONS(4028),
    [aux_sym_char_token1] = ACTIONS(4030),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4032),
    [anon_sym_DQUOTE] = ACTIONS(4034),
    [anon_sym_AT_DQUOTE] = ACTIONS(4036),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4038),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4040),
    [sym_bool] = ACTIONS(4042),
    [sym_unit] = ACTIONS(4044),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3606),
    [sym_op_identifier] = ACTIONS(3608),
    [sym_int] = ACTIONS(4046),
    [sym_xint] = ACTIONS(4048),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2697] = {
    [sym_attributes] = STATE(2699),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(4815),
    [sym__pattern] = STATE(5256),
    [sym_optional_pattern] = STATE(4815),
    [sym_type_check_pattern] = STATE(4815),
    [sym_attribute_pattern] = STATE(4815),
    [sym_paren_pattern] = STATE(4815),
    [sym_as_pattern] = STATE(4815),
    [sym_cons_pattern] = STATE(4815),
    [sym_disjunct_pattern] = STATE(4815),
    [sym_conjunct_pattern] = STATE(4815),
    [sym_typed_pattern] = STATE(4815),
    [sym_list_pattern] = STATE(4815),
    [sym_array_pattern] = STATE(4815),
    [sym_record_pattern] = STATE(4815),
    [sym_named_field_pattern] = STATE(4815),
    [sym_identifier_pattern] = STATE(4815),
    [sym_long_identifier_or_op] = STATE(2193),
    [sym_char] = STATE(4765),
    [sym_format_string] = STATE(4746),
    [sym__string_literal] = STATE(4746),
    [sym_string] = STATE(4765),
    [sym_verbatim_string] = STATE(4765),
    [sym_bytearray] = STATE(4765),
    [sym_verbatim_bytearray] = STATE(4765),
    [sym_format_triple_quoted_string] = STATE(4720),
    [sym_triple_quoted_string] = STATE(4765),
    [sym_const] = STATE(4815),
    [sym_long_identifier] = STATE(3493),
    [sym_active_pattern] = STATE(3613),
    [sym__identifier_or_op] = STATE(3650),
    [sym_sbyte] = STATE(4765),
    [sym_byte] = STATE(4765),
    [sym_int16] = STATE(4765),
    [sym_uint16] = STATE(4765),
    [sym_int32] = STATE(4765),
    [sym_uint32] = STATE(4765),
    [sym_nativeint] = STATE(4765),
    [sym_unativeint] = STATE(4765),
    [sym_int64] = STATE(4765),
    [sym_uint64] = STATE(4765),
    [sym_ieee32] = STATE(4765),
    [sym_ieee64] = STATE(4765),
    [sym_bignum] = STATE(4765),
    [sym_decimal] = STATE(4765),
    [sym_float] = STATE(4512),
    [sym_block_comment] = STATE(2697),
    [sym_compiler_directive_decl] = STATE(2697),
    [sym_fsi_directive_decl] = STATE(2697),
    [sym_preproc_line] = STATE(2697),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(4175),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_LPAREN] = ACTIONS(3572),
    [anon_sym_null] = ACTIONS(3574),
    [anon_sym__] = ACTIONS(3576),
    [anon_sym_QMARK] = ACTIONS(4177),
    [anon_sym_COLON_QMARK] = ACTIONS(4179),
    [anon_sym_LBRACK] = ACTIONS(3582),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3584),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [aux_sym_char_token1] = ACTIONS(3590),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3592),
    [anon_sym_DQUOTE] = ACTIONS(3594),
    [anon_sym_AT_DQUOTE] = ACTIONS(3596),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3598),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3600),
    [sym_bool] = ACTIONS(3602),
    [sym_unit] = ACTIONS(3604),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4181),
    [sym_op_identifier] = ACTIONS(4183),
    [sym_int] = ACTIONS(3610),
    [sym_xint] = ACTIONS(3612),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2698] = {
    [sym_attributes] = STATE(2698),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(3506),
    [sym__pattern] = STATE(3403),
    [sym_optional_pattern] = STATE(3506),
    [sym_type_check_pattern] = STATE(3506),
    [sym_attribute_pattern] = STATE(3506),
    [sym_paren_pattern] = STATE(3506),
    [sym_as_pattern] = STATE(3506),
    [sym_cons_pattern] = STATE(3506),
    [sym_disjunct_pattern] = STATE(3506),
    [sym_conjunct_pattern] = STATE(3506),
    [sym_typed_pattern] = STATE(3506),
    [sym_list_pattern] = STATE(3506),
    [sym_array_pattern] = STATE(3506),
    [sym_record_pattern] = STATE(3506),
    [sym_named_field_pattern] = STATE(3506),
    [sym_identifier_pattern] = STATE(3506),
    [sym_long_identifier_or_op] = STATE(1864),
    [sym_char] = STATE(3497),
    [sym_format_string] = STATE(3495),
    [sym__string_literal] = STATE(3495),
    [sym_string] = STATE(3497),
    [sym_verbatim_string] = STATE(3497),
    [sym_bytearray] = STATE(3497),
    [sym_verbatim_bytearray] = STATE(3497),
    [sym_format_triple_quoted_string] = STATE(3494),
    [sym_triple_quoted_string] = STATE(3497),
    [sym_const] = STATE(3506),
    [sym_long_identifier] = STATE(3363),
    [sym_active_pattern] = STATE(3521),
    [sym__identifier_or_op] = STATE(3510),
    [sym_sbyte] = STATE(3497),
    [sym_byte] = STATE(3497),
    [sym_int16] = STATE(3497),
    [sym_uint16] = STATE(3497),
    [sym_int32] = STATE(3497),
    [sym_uint32] = STATE(3497),
    [sym_nativeint] = STATE(3497),
    [sym_unativeint] = STATE(3497),
    [sym_int64] = STATE(3497),
    [sym_uint64] = STATE(3497),
    [sym_ieee32] = STATE(3497),
    [sym_ieee64] = STATE(3497),
    [sym_bignum] = STATE(3497),
    [sym_decimal] = STATE(3497),
    [sym_float] = STATE(3305),
    [sym_block_comment] = STATE(2698),
    [sym_compiler_directive_decl] = STATE(2698),
    [sym_fsi_directive_decl] = STATE(2698),
    [sym_preproc_line] = STATE(2698),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(3870),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_LPAREN] = ACTIONS(3962),
    [anon_sym_null] = ACTIONS(3966),
    [anon_sym__] = ACTIONS(3968),
    [anon_sym_QMARK] = ACTIONS(3970),
    [anon_sym_COLON_QMARK] = ACTIONS(3972),
    [anon_sym_LBRACK] = ACTIONS(3974),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3976),
    [anon_sym_LBRACE] = ACTIONS(3978),
    [aux_sym_char_token1] = ACTIONS(3980),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3982),
    [anon_sym_DQUOTE] = ACTIONS(3984),
    [anon_sym_AT_DQUOTE] = ACTIONS(3986),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3988),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3990),
    [sym_bool] = ACTIONS(3992),
    [sym_unit] = ACTIONS(3994),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3904),
    [sym_op_identifier] = ACTIONS(3906),
    [sym_int] = ACTIONS(3996),
    [sym_xint] = ACTIONS(3998),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2699] = {
    [sym_attributes] = STATE(2699),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(4815),
    [sym__pattern] = STATE(5213),
    [sym_optional_pattern] = STATE(4815),
    [sym_type_check_pattern] = STATE(4815),
    [sym_attribute_pattern] = STATE(4815),
    [sym_paren_pattern] = STATE(4815),
    [sym_as_pattern] = STATE(4815),
    [sym_cons_pattern] = STATE(4815),
    [sym_disjunct_pattern] = STATE(4815),
    [sym_conjunct_pattern] = STATE(4815),
    [sym_typed_pattern] = STATE(4815),
    [sym_list_pattern] = STATE(4815),
    [sym_array_pattern] = STATE(4815),
    [sym_record_pattern] = STATE(4815),
    [sym_named_field_pattern] = STATE(4815),
    [sym_identifier_pattern] = STATE(4815),
    [sym_long_identifier_or_op] = STATE(2193),
    [sym_char] = STATE(4765),
    [sym_format_string] = STATE(4746),
    [sym__string_literal] = STATE(4746),
    [sym_string] = STATE(4765),
    [sym_verbatim_string] = STATE(4765),
    [sym_bytearray] = STATE(4765),
    [sym_verbatim_bytearray] = STATE(4765),
    [sym_format_triple_quoted_string] = STATE(4720),
    [sym_triple_quoted_string] = STATE(4765),
    [sym_const] = STATE(4815),
    [sym_long_identifier] = STATE(3493),
    [sym_active_pattern] = STATE(3613),
    [sym__identifier_or_op] = STATE(3650),
    [sym_sbyte] = STATE(4765),
    [sym_byte] = STATE(4765),
    [sym_int16] = STATE(4765),
    [sym_uint16] = STATE(4765),
    [sym_int32] = STATE(4765),
    [sym_uint32] = STATE(4765),
    [sym_nativeint] = STATE(4765),
    [sym_unativeint] = STATE(4765),
    [sym_int64] = STATE(4765),
    [sym_uint64] = STATE(4765),
    [sym_ieee32] = STATE(4765),
    [sym_ieee64] = STATE(4765),
    [sym_bignum] = STATE(4765),
    [sym_decimal] = STATE(4765),
    [sym_float] = STATE(4512),
    [sym_block_comment] = STATE(2699),
    [sym_compiler_directive_decl] = STATE(2699),
    [sym_fsi_directive_decl] = STATE(2699),
    [sym_preproc_line] = STATE(2699),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(4175),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_LPAREN] = ACTIONS(3572),
    [anon_sym_null] = ACTIONS(3574),
    [anon_sym__] = ACTIONS(3576),
    [anon_sym_QMARK] = ACTIONS(4177),
    [anon_sym_COLON_QMARK] = ACTIONS(4179),
    [anon_sym_LBRACK] = ACTIONS(3582),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3584),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [aux_sym_char_token1] = ACTIONS(3590),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3592),
    [anon_sym_DQUOTE] = ACTIONS(3594),
    [anon_sym_AT_DQUOTE] = ACTIONS(3596),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3598),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3600),
    [sym_bool] = ACTIONS(3602),
    [sym_unit] = ACTIONS(3604),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4181),
    [sym_op_identifier] = ACTIONS(4183),
    [sym_int] = ACTIONS(3610),
    [sym_xint] = ACTIONS(3612),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2700] = {
    [sym_attributes] = STATE(2652),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(3588),
    [sym__pattern] = STATE(3537),
    [sym_optional_pattern] = STATE(3588),
    [sym_type_check_pattern] = STATE(3588),
    [sym_attribute_pattern] = STATE(3588),
    [sym_paren_pattern] = STATE(3588),
    [sym_as_pattern] = STATE(3588),
    [sym_cons_pattern] = STATE(3588),
    [sym_disjunct_pattern] = STATE(3588),
    [sym_conjunct_pattern] = STATE(3588),
    [sym_typed_pattern] = STATE(3588),
    [sym_list_pattern] = STATE(3588),
    [sym_array_pattern] = STATE(3588),
    [sym_record_pattern] = STATE(3588),
    [sym_named_field_pattern] = STATE(3588),
    [sym_identifier_pattern] = STATE(3588),
    [sym_long_identifier_or_op] = STATE(2401),
    [sym_char] = STATE(3658),
    [sym_format_string] = STATE(3670),
    [sym__string_literal] = STATE(3670),
    [sym_string] = STATE(3658),
    [sym_verbatim_string] = STATE(3658),
    [sym_bytearray] = STATE(3658),
    [sym_verbatim_bytearray] = STATE(3658),
    [sym_format_triple_quoted_string] = STATE(3673),
    [sym_triple_quoted_string] = STATE(3658),
    [sym_const] = STATE(3588),
    [sym_long_identifier] = STATE(3493),
    [sym_active_pattern] = STATE(3613),
    [sym__identifier_or_op] = STATE(3650),
    [sym_sbyte] = STATE(3658),
    [sym_byte] = STATE(3658),
    [sym_int16] = STATE(3658),
    [sym_uint16] = STATE(3658),
    [sym_int32] = STATE(3658),
    [sym_uint32] = STATE(3658),
    [sym_nativeint] = STATE(3658),
    [sym_unativeint] = STATE(3658),
    [sym_int64] = STATE(3658),
    [sym_uint64] = STATE(3658),
    [sym_ieee32] = STATE(3658),
    [sym_ieee64] = STATE(3658),
    [sym_bignum] = STATE(3658),
    [sym_decimal] = STATE(3658),
    [sym_float] = STATE(3376),
    [sym_block_comment] = STATE(2700),
    [sym_compiler_directive_decl] = STATE(2700),
    [sym_fsi_directive_decl] = STATE(2700),
    [sym_preproc_line] = STATE(2700),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(4175),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_LPAREN] = ACTIONS(4218),
    [anon_sym_null] = ACTIONS(4220),
    [anon_sym__] = ACTIONS(4222),
    [anon_sym_QMARK] = ACTIONS(4224),
    [anon_sym_COLON_QMARK] = ACTIONS(4226),
    [anon_sym_LBRACK] = ACTIONS(4228),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4230),
    [anon_sym_LBRACE] = ACTIONS(4232),
    [aux_sym_char_token1] = ACTIONS(4234),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4236),
    [anon_sym_DQUOTE] = ACTIONS(4238),
    [anon_sym_AT_DQUOTE] = ACTIONS(4240),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4242),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4244),
    [sym_bool] = ACTIONS(4246),
    [sym_unit] = ACTIONS(4248),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4181),
    [sym_op_identifier] = ACTIONS(4183),
    [sym_int] = ACTIONS(4250),
    [sym_xint] = ACTIONS(4252),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2701] = {
    [sym_attributes] = STATE(2632),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(4815),
    [sym__pattern] = STATE(5456),
    [sym_optional_pattern] = STATE(4815),
    [sym_type_check_pattern] = STATE(4815),
    [sym_attribute_pattern] = STATE(4815),
    [sym_paren_pattern] = STATE(4815),
    [sym_as_pattern] = STATE(4815),
    [sym_cons_pattern] = STATE(4815),
    [sym_disjunct_pattern] = STATE(4815),
    [sym_conjunct_pattern] = STATE(4815),
    [sym_typed_pattern] = STATE(4815),
    [sym_list_pattern] = STATE(4815),
    [sym_array_pattern] = STATE(4815),
    [sym_record_pattern] = STATE(4815),
    [sym_named_field_pattern] = STATE(4815),
    [sym_identifier_pattern] = STATE(4815),
    [sym_long_identifier_or_op] = STATE(2475),
    [sym_char] = STATE(4765),
    [sym_format_string] = STATE(4746),
    [sym__string_literal] = STATE(4746),
    [sym_string] = STATE(4765),
    [sym_verbatim_string] = STATE(4765),
    [sym_bytearray] = STATE(4765),
    [sym_verbatim_bytearray] = STATE(4765),
    [sym_format_triple_quoted_string] = STATE(4720),
    [sym_triple_quoted_string] = STATE(4765),
    [sym_const] = STATE(4815),
    [sym_long_identifier] = STATE(3655),
    [sym_active_pattern] = STATE(3734),
    [sym__identifier_or_op] = STATE(3737),
    [sym_sbyte] = STATE(4765),
    [sym_byte] = STATE(4765),
    [sym_int16] = STATE(4765),
    [sym_uint16] = STATE(4765),
    [sym_int32] = STATE(4765),
    [sym_uint32] = STATE(4765),
    [sym_nativeint] = STATE(4765),
    [sym_unativeint] = STATE(4765),
    [sym_int64] = STATE(4765),
    [sym_uint64] = STATE(4765),
    [sym_ieee32] = STATE(4765),
    [sym_ieee64] = STATE(4765),
    [sym_bignum] = STATE(4765),
    [sym_decimal] = STATE(4765),
    [sym_float] = STATE(4512),
    [sym_block_comment] = STATE(2701),
    [sym_compiler_directive_decl] = STATE(2701),
    [sym_fsi_directive_decl] = STATE(2701),
    [sym_preproc_line] = STATE(2701),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(4196),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_LPAREN] = ACTIONS(3572),
    [anon_sym_null] = ACTIONS(3574),
    [anon_sym__] = ACTIONS(3576),
    [anon_sym_QMARK] = ACTIONS(4202),
    [anon_sym_COLON_QMARK] = ACTIONS(4204),
    [anon_sym_LBRACK] = ACTIONS(3582),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3584),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [aux_sym_char_token1] = ACTIONS(3590),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3592),
    [anon_sym_DQUOTE] = ACTIONS(3594),
    [anon_sym_AT_DQUOTE] = ACTIONS(3596),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3598),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3600),
    [sym_bool] = ACTIONS(3602),
    [sym_unit] = ACTIONS(3604),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4212),
    [sym_op_identifier] = ACTIONS(4214),
    [sym_int] = ACTIONS(3610),
    [sym_xint] = ACTIONS(3612),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2702] = {
    [sym_attributes] = STATE(2630),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(3640),
    [sym__pattern] = STATE(3502),
    [sym_optional_pattern] = STATE(3640),
    [sym_type_check_pattern] = STATE(3640),
    [sym_attribute_pattern] = STATE(3640),
    [sym_paren_pattern] = STATE(3640),
    [sym_as_pattern] = STATE(3640),
    [sym_cons_pattern] = STATE(3640),
    [sym_disjunct_pattern] = STATE(3640),
    [sym_conjunct_pattern] = STATE(3640),
    [sym_typed_pattern] = STATE(3640),
    [sym_list_pattern] = STATE(3640),
    [sym_array_pattern] = STATE(3640),
    [sym_record_pattern] = STATE(3640),
    [sym_named_field_pattern] = STATE(3640),
    [sym_identifier_pattern] = STATE(3640),
    [sym_long_identifier_or_op] = STATE(2393),
    [sym_char] = STATE(3606),
    [sym_format_string] = STATE(3688),
    [sym__string_literal] = STATE(3688),
    [sym_string] = STATE(3606),
    [sym_verbatim_string] = STATE(3606),
    [sym_bytearray] = STATE(3606),
    [sym_verbatim_bytearray] = STATE(3606),
    [sym_format_triple_quoted_string] = STATE(3686),
    [sym_triple_quoted_string] = STATE(3606),
    [sym_const] = STATE(3640),
    [sym_long_identifier] = STATE(3437),
    [sym_active_pattern] = STATE(3653),
    [sym__identifier_or_op] = STATE(3660),
    [sym_sbyte] = STATE(3606),
    [sym_byte] = STATE(3606),
    [sym_int16] = STATE(3606),
    [sym_uint16] = STATE(3606),
    [sym_int32] = STATE(3606),
    [sym_uint32] = STATE(3606),
    [sym_nativeint] = STATE(3606),
    [sym_unativeint] = STATE(3606),
    [sym_int64] = STATE(3606),
    [sym_uint64] = STATE(3606),
    [sym_ieee32] = STATE(3606),
    [sym_ieee64] = STATE(3606),
    [sym_bignum] = STATE(3606),
    [sym_decimal] = STATE(3606),
    [sym_float] = STATE(3332),
    [sym_block_comment] = STATE(2702),
    [sym_compiler_directive_decl] = STATE(2702),
    [sym_fsi_directive_decl] = STATE(2702),
    [sym_preproc_line] = STATE(2702),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(4073),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_LPAREN] = ACTIONS(4256),
    [anon_sym_null] = ACTIONS(4258),
    [anon_sym__] = ACTIONS(4260),
    [anon_sym_QMARK] = ACTIONS(4262),
    [anon_sym_COLON_QMARK] = ACTIONS(4264),
    [anon_sym_LBRACK] = ACTIONS(4266),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4268),
    [anon_sym_LBRACE] = ACTIONS(4270),
    [aux_sym_char_token1] = ACTIONS(4272),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4274),
    [anon_sym_DQUOTE] = ACTIONS(4276),
    [anon_sym_AT_DQUOTE] = ACTIONS(4278),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4280),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4282),
    [sym_bool] = ACTIONS(4284),
    [sym_unit] = ACTIONS(4286),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4117),
    [sym_op_identifier] = ACTIONS(4119),
    [sym_int] = ACTIONS(4288),
    [sym_xint] = ACTIONS(4290),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2703] = {
    [sym_attributes] = STATE(2674),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(5431),
    [sym__pattern] = STATE(5152),
    [sym_optional_pattern] = STATE(5431),
    [sym_type_check_pattern] = STATE(5431),
    [sym_attribute_pattern] = STATE(5431),
    [sym_paren_pattern] = STATE(5431),
    [sym_as_pattern] = STATE(5431),
    [sym_cons_pattern] = STATE(5431),
    [sym_disjunct_pattern] = STATE(5431),
    [sym_conjunct_pattern] = STATE(5431),
    [sym_typed_pattern] = STATE(5431),
    [sym_list_pattern] = STATE(5431),
    [sym_array_pattern] = STATE(5431),
    [sym_record_pattern] = STATE(5431),
    [sym_named_field_pattern] = STATE(5431),
    [sym_identifier_pattern] = STATE(5431),
    [sym_long_identifier_or_op] = STATE(2273),
    [sym_char] = STATE(5475),
    [sym_format_string] = STATE(5423),
    [sym__string_literal] = STATE(5423),
    [sym_string] = STATE(5475),
    [sym_verbatim_string] = STATE(5475),
    [sym_bytearray] = STATE(5475),
    [sym_verbatim_bytearray] = STATE(5475),
    [sym_format_triple_quoted_string] = STATE(5477),
    [sym_triple_quoted_string] = STATE(5475),
    [sym_const] = STATE(5431),
    [sym_long_identifier] = STATE(3437),
    [sym_active_pattern] = STATE(3653),
    [sym__identifier_or_op] = STATE(3660),
    [sym_sbyte] = STATE(5475),
    [sym_byte] = STATE(5475),
    [sym_int16] = STATE(5475),
    [sym_uint16] = STATE(5475),
    [sym_int32] = STATE(5475),
    [sym_uint32] = STATE(5475),
    [sym_nativeint] = STATE(5475),
    [sym_unativeint] = STATE(5475),
    [sym_int64] = STATE(5475),
    [sym_uint64] = STATE(5475),
    [sym_ieee32] = STATE(5475),
    [sym_ieee64] = STATE(5475),
    [sym_bignum] = STATE(5475),
    [sym_decimal] = STATE(5475),
    [sym_float] = STATE(4953),
    [sym_block_comment] = STATE(2703),
    [sym_compiler_directive_decl] = STATE(2703),
    [sym_fsi_directive_decl] = STATE(2703),
    [sym_preproc_line] = STATE(2703),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(4073),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_LPAREN] = ACTIONS(4077),
    [anon_sym_null] = ACTIONS(4081),
    [anon_sym__] = ACTIONS(4083),
    [anon_sym_QMARK] = ACTIONS(4085),
    [anon_sym_COLON_QMARK] = ACTIONS(4087),
    [anon_sym_LBRACK] = ACTIONS(4095),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4097),
    [anon_sym_LBRACE] = ACTIONS(4099),
    [aux_sym_char_token1] = ACTIONS(4101),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4103),
    [anon_sym_DQUOTE] = ACTIONS(4105),
    [anon_sym_AT_DQUOTE] = ACTIONS(4107),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4109),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4111),
    [sym_bool] = ACTIONS(4113),
    [sym_unit] = ACTIONS(4115),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4117),
    [sym_op_identifier] = ACTIONS(4119),
    [sym_int] = ACTIONS(4121),
    [sym_xint] = ACTIONS(4123),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2704] = {
    [sym_attributes] = STATE(2630),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(3640),
    [sym__pattern] = STATE(3501),
    [sym_optional_pattern] = STATE(3640),
    [sym_type_check_pattern] = STATE(3640),
    [sym_attribute_pattern] = STATE(3640),
    [sym_paren_pattern] = STATE(3640),
    [sym_as_pattern] = STATE(3640),
    [sym_cons_pattern] = STATE(3640),
    [sym_disjunct_pattern] = STATE(3640),
    [sym_conjunct_pattern] = STATE(3640),
    [sym_typed_pattern] = STATE(3640),
    [sym_list_pattern] = STATE(3640),
    [sym_array_pattern] = STATE(3640),
    [sym_record_pattern] = STATE(3640),
    [sym_named_field_pattern] = STATE(3640),
    [sym_identifier_pattern] = STATE(3640),
    [sym_long_identifier_or_op] = STATE(2393),
    [sym_char] = STATE(3606),
    [sym_format_string] = STATE(3688),
    [sym__string_literal] = STATE(3688),
    [sym_string] = STATE(3606),
    [sym_verbatim_string] = STATE(3606),
    [sym_bytearray] = STATE(3606),
    [sym_verbatim_bytearray] = STATE(3606),
    [sym_format_triple_quoted_string] = STATE(3686),
    [sym_triple_quoted_string] = STATE(3606),
    [sym_const] = STATE(3640),
    [sym_long_identifier] = STATE(3437),
    [sym_active_pattern] = STATE(3653),
    [sym__identifier_or_op] = STATE(3660),
    [sym_sbyte] = STATE(3606),
    [sym_byte] = STATE(3606),
    [sym_int16] = STATE(3606),
    [sym_uint16] = STATE(3606),
    [sym_int32] = STATE(3606),
    [sym_uint32] = STATE(3606),
    [sym_nativeint] = STATE(3606),
    [sym_unativeint] = STATE(3606),
    [sym_int64] = STATE(3606),
    [sym_uint64] = STATE(3606),
    [sym_ieee32] = STATE(3606),
    [sym_ieee64] = STATE(3606),
    [sym_bignum] = STATE(3606),
    [sym_decimal] = STATE(3606),
    [sym_float] = STATE(3332),
    [sym_block_comment] = STATE(2704),
    [sym_compiler_directive_decl] = STATE(2704),
    [sym_fsi_directive_decl] = STATE(2704),
    [sym_preproc_line] = STATE(2704),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(4073),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_LPAREN] = ACTIONS(4256),
    [anon_sym_null] = ACTIONS(4258),
    [anon_sym__] = ACTIONS(4260),
    [anon_sym_QMARK] = ACTIONS(4262),
    [anon_sym_COLON_QMARK] = ACTIONS(4264),
    [anon_sym_LBRACK] = ACTIONS(4266),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4268),
    [anon_sym_LBRACE] = ACTIONS(4270),
    [aux_sym_char_token1] = ACTIONS(4272),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4274),
    [anon_sym_DQUOTE] = ACTIONS(4276),
    [anon_sym_AT_DQUOTE] = ACTIONS(4278),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4280),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4282),
    [sym_bool] = ACTIONS(4284),
    [sym_unit] = ACTIONS(4286),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4117),
    [sym_op_identifier] = ACTIONS(4119),
    [sym_int] = ACTIONS(4288),
    [sym_xint] = ACTIONS(4290),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2705] = {
    [sym_attributes] = STATE(2630),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(3640),
    [sym__pattern] = STATE(3447),
    [sym_optional_pattern] = STATE(3640),
    [sym_type_check_pattern] = STATE(3640),
    [sym_attribute_pattern] = STATE(3640),
    [sym_paren_pattern] = STATE(3640),
    [sym_as_pattern] = STATE(3640),
    [sym_cons_pattern] = STATE(3640),
    [sym_disjunct_pattern] = STATE(3640),
    [sym_conjunct_pattern] = STATE(3640),
    [sym_typed_pattern] = STATE(3640),
    [sym_list_pattern] = STATE(3640),
    [sym_array_pattern] = STATE(3640),
    [sym_record_pattern] = STATE(3640),
    [sym_named_field_pattern] = STATE(3640),
    [sym_identifier_pattern] = STATE(3640),
    [sym_long_identifier_or_op] = STATE(2393),
    [sym_char] = STATE(3606),
    [sym_format_string] = STATE(3688),
    [sym__string_literal] = STATE(3688),
    [sym_string] = STATE(3606),
    [sym_verbatim_string] = STATE(3606),
    [sym_bytearray] = STATE(3606),
    [sym_verbatim_bytearray] = STATE(3606),
    [sym_format_triple_quoted_string] = STATE(3686),
    [sym_triple_quoted_string] = STATE(3606),
    [sym_const] = STATE(3640),
    [sym_long_identifier] = STATE(3437),
    [sym_active_pattern] = STATE(3653),
    [sym__identifier_or_op] = STATE(3660),
    [sym_sbyte] = STATE(3606),
    [sym_byte] = STATE(3606),
    [sym_int16] = STATE(3606),
    [sym_uint16] = STATE(3606),
    [sym_int32] = STATE(3606),
    [sym_uint32] = STATE(3606),
    [sym_nativeint] = STATE(3606),
    [sym_unativeint] = STATE(3606),
    [sym_int64] = STATE(3606),
    [sym_uint64] = STATE(3606),
    [sym_ieee32] = STATE(3606),
    [sym_ieee64] = STATE(3606),
    [sym_bignum] = STATE(3606),
    [sym_decimal] = STATE(3606),
    [sym_float] = STATE(3332),
    [sym_block_comment] = STATE(2705),
    [sym_compiler_directive_decl] = STATE(2705),
    [sym_fsi_directive_decl] = STATE(2705),
    [sym_preproc_line] = STATE(2705),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(4073),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_LPAREN] = ACTIONS(4256),
    [anon_sym_null] = ACTIONS(4258),
    [anon_sym__] = ACTIONS(4260),
    [anon_sym_QMARK] = ACTIONS(4262),
    [anon_sym_COLON_QMARK] = ACTIONS(4264),
    [anon_sym_LBRACK] = ACTIONS(4266),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4268),
    [anon_sym_LBRACE] = ACTIONS(4270),
    [aux_sym_char_token1] = ACTIONS(4272),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4274),
    [anon_sym_DQUOTE] = ACTIONS(4276),
    [anon_sym_AT_DQUOTE] = ACTIONS(4278),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4280),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4282),
    [sym_bool] = ACTIONS(4284),
    [sym_unit] = ACTIONS(4286),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4117),
    [sym_op_identifier] = ACTIONS(4119),
    [sym_int] = ACTIONS(4288),
    [sym_xint] = ACTIONS(4290),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2706] = {
    [sym_attributes] = STATE(2632),
    [sym__attribute_set] = STATE(4045),
    [sym_repeat_pattern] = STATE(4815),
    [sym__pattern] = STATE(5439),
    [sym_optional_pattern] = STATE(4815),
    [sym_type_check_pattern] = STATE(4815),
    [sym_attribute_pattern] = STATE(4815),
    [sym_paren_pattern] = STATE(4815),
    [sym_as_pattern] = STATE(4815),
    [sym_cons_pattern] = STATE(4815),
    [sym_disjunct_pattern] = STATE(4815),
    [sym_conjunct_pattern] = STATE(4815),
    [sym_typed_pattern] = STATE(4815),
    [sym_list_pattern] = STATE(4815),
    [sym_array_pattern] = STATE(4815),
    [sym_record_pattern] = STATE(4815),
    [sym_named_field_pattern] = STATE(4815),
    [sym_identifier_pattern] = STATE(4815),
    [sym_long_identifier_or_op] = STATE(2475),
    [sym_char] = STATE(4765),
    [sym_format_string] = STATE(4746),
    [sym__string_literal] = STATE(4746),
    [sym_string] = STATE(4765),
    [sym_verbatim_string] = STATE(4765),
    [sym_bytearray] = STATE(4765),
    [sym_verbatim_bytearray] = STATE(4765),
    [sym_format_triple_quoted_string] = STATE(4720),
    [sym_triple_quoted_string] = STATE(4765),
    [sym_const] = STATE(4815),
    [sym_long_identifier] = STATE(3655),
    [sym_active_pattern] = STATE(3734),
    [sym__identifier_or_op] = STATE(3737),
    [sym_sbyte] = STATE(4765),
    [sym_byte] = STATE(4765),
    [sym_int16] = STATE(4765),
    [sym_uint16] = STATE(4765),
    [sym_int32] = STATE(4765),
    [sym_uint32] = STATE(4765),
    [sym_nativeint] = STATE(4765),
    [sym_unativeint] = STATE(4765),
    [sym_int64] = STATE(4765),
    [sym_uint64] = STATE(4765),
    [sym_ieee32] = STATE(4765),
    [sym_ieee64] = STATE(4765),
    [sym_bignum] = STATE(4765),
    [sym_decimal] = STATE(4765),
    [sym_float] = STATE(4512),
    [sym_block_comment] = STATE(2706),
    [sym_compiler_directive_decl] = STATE(2706),
    [sym_fsi_directive_decl] = STATE(2706),
    [sym_preproc_line] = STATE(2706),
    [aux_sym_attributes_repeat1] = STATE(3787),
    [sym_identifier] = ACTIONS(4196),
    [anon_sym_LBRACK_LT] = ACTIONS(3564),
    [anon_sym_LPAREN] = ACTIONS(3572),
    [anon_sym_null] = ACTIONS(3574),
    [anon_sym__] = ACTIONS(3576),
    [anon_sym_QMARK] = ACTIONS(4202),
    [anon_sym_COLON_QMARK] = ACTIONS(4204),
    [anon_sym_LBRACK] = ACTIONS(3582),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3584),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [aux_sym_char_token1] = ACTIONS(3590),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3592),
    [anon_sym_DQUOTE] = ACTIONS(3594),
    [anon_sym_AT_DQUOTE] = ACTIONS(3596),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3598),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3600),
    [sym_bool] = ACTIONS(3602),
    [sym_unit] = ACTIONS(3604),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4212),
    [sym_op_identifier] = ACTIONS(4214),
    [sym_int] = ACTIONS(3610),
    [sym_xint] = ACTIONS(3612),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2707] = {
    [sym_block_comment] = STATE(2707),
    [sym_compiler_directive_decl] = STATE(2707),
    [sym_fsi_directive_decl] = STATE(2707),
    [sym_preproc_line] = STATE(2707),
    [sym_identifier] = ACTIONS(2158),
    [anon_sym_return] = ACTIONS(2158),
    [anon_sym_do] = ACTIONS(2158),
    [anon_sym_let] = ACTIONS(2158),
    [anon_sym_let_BANG] = ACTIONS(2160),
    [anon_sym_LPAREN] = ACTIONS(2158),
    [anon_sym_COMMA] = ACTIONS(2160),
    [anon_sym_null] = ACTIONS(2158),
    [anon_sym_AMP] = ACTIONS(2158),
    [anon_sym_LBRACK] = ACTIONS(2158),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2160),
    [anon_sym_LBRACE] = ACTIONS(2158),
    [anon_sym_LT_AT] = ACTIONS(2158),
    [anon_sym_LT_AT_AT] = ACTIONS(2160),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2160),
    [anon_sym_new] = ACTIONS(2158),
    [anon_sym_return_BANG] = ACTIONS(2160),
    [anon_sym_yield] = ACTIONS(2158),
    [anon_sym_yield_BANG] = ACTIONS(2160),
    [anon_sym_lazy] = ACTIONS(2158),
    [anon_sym_assert] = ACTIONS(2158),
    [anon_sym_upcast] = ACTIONS(2158),
    [anon_sym_downcast] = ACTIONS(2158),
    [anon_sym_for] = ACTIONS(2158),
    [anon_sym_while] = ACTIONS(2158),
    [anon_sym_if] = ACTIONS(2158),
    [anon_sym_fun] = ACTIONS(2158),
    [anon_sym_try] = ACTIONS(2158),
    [anon_sym_match] = ACTIONS(2158),
    [anon_sym_match_BANG] = ACTIONS(2160),
    [anon_sym_function] = ACTIONS(2158),
    [anon_sym_GT] = ACTIONS(2160),
    [anon_sym_use] = ACTIONS(2158),
    [anon_sym_use_BANG] = ACTIONS(2160),
    [anon_sym_do_BANG] = ACTIONS(2160),
    [anon_sym_begin] = ACTIONS(2158),
    [aux_sym_char_token1] = ACTIONS(2160),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2158),
    [anon_sym_DQUOTE] = ACTIONS(2158),
    [anon_sym_AT_DQUOTE] = ACTIONS(2160),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2160),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2160),
    [sym_bool] = ACTIONS(2158),
    [sym_unit] = ACTIONS(2160),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2158),
    [sym_op_identifier] = ACTIONS(2160),
    [anon_sym_PLUS] = ACTIONS(2158),
    [anon_sym_DASH] = ACTIONS(2158),
    [anon_sym_PLUS_DOT] = ACTIONS(2160),
    [anon_sym_DASH_DOT] = ACTIONS(2160),
    [anon_sym_PERCENT] = ACTIONS(2160),
    [anon_sym_AMP_AMP] = ACTIONS(2160),
    [anon_sym_TILDE] = ACTIONS(2160),
    [aux_sym_prefix_op_token1] = ACTIONS(2160),
    [sym_int] = ACTIONS(2158),
    [sym_xint] = ACTIONS(2160),
    [anon_sym_y] = ACTIONS(4446),
    [anon_sym_uy] = ACTIONS(4448),
    [anon_sym_s] = ACTIONS(4450),
    [anon_sym_us] = ACTIONS(4452),
    [anon_sym_l] = ACTIONS(4454),
    [aux_sym_uint32_token1] = ACTIONS(4456),
    [anon_sym_n] = ACTIONS(4458),
    [anon_sym_un] = ACTIONS(4460),
    [anon_sym_L] = ACTIONS(4462),
    [aux_sym_uint64_token1] = ACTIONS(4464),
    [anon_sym_lf] = ACTIONS(4498),
    [anon_sym_LF] = ACTIONS(4500),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2160),
  },
  [2708] = {
    [sym_block_comment] = STATE(2708),
    [sym_compiler_directive_decl] = STATE(2708),
    [sym_fsi_directive_decl] = STATE(2708),
    [sym_preproc_line] = STATE(2708),
    [aux_sym_type_argument_repeat1] = STATE(2713),
    [sym_identifier] = ACTIONS(2321),
    [anon_sym_GT_RBRACK] = ACTIONS(2323),
    [anon_sym_return] = ACTIONS(2321),
    [anon_sym_do] = ACTIONS(2321),
    [anon_sym_let] = ACTIONS(2321),
    [anon_sym_let_BANG] = ACTIONS(2323),
    [anon_sym_LPAREN] = ACTIONS(2321),
    [anon_sym_null] = ACTIONS(2321),
    [anon_sym_AMP] = ACTIONS(2321),
    [anon_sym_LBRACK] = ACTIONS(2321),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2323),
    [anon_sym_LBRACE] = ACTIONS(2321),
    [anon_sym_LT_AT] = ACTIONS(2321),
    [anon_sym_LT_AT_AT] = ACTIONS(2323),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2323),
    [anon_sym_new] = ACTIONS(2321),
    [anon_sym_return_BANG] = ACTIONS(2323),
    [anon_sym_yield] = ACTIONS(2321),
    [anon_sym_yield_BANG] = ACTIONS(2323),
    [anon_sym_lazy] = ACTIONS(2321),
    [anon_sym_assert] = ACTIONS(2321),
    [anon_sym_upcast] = ACTIONS(2321),
    [anon_sym_downcast] = ACTIONS(2321),
    [anon_sym_COLON_GT] = ACTIONS(2323),
    [anon_sym_for] = ACTIONS(2321),
    [anon_sym_while] = ACTIONS(2321),
    [anon_sym_if] = ACTIONS(2321),
    [anon_sym_fun] = ACTIONS(2321),
    [anon_sym_DASH_GT] = ACTIONS(2323),
    [anon_sym_try] = ACTIONS(2321),
    [anon_sym_match] = ACTIONS(2321),
    [anon_sym_match_BANG] = ACTIONS(2323),
    [anon_sym_function] = ACTIONS(2321),
    [anon_sym_use] = ACTIONS(2321),
    [anon_sym_use_BANG] = ACTIONS(2323),
    [anon_sym_do_BANG] = ACTIONS(2323),
    [anon_sym_begin] = ACTIONS(2321),
    [anon_sym_STAR] = ACTIONS(2323),
    [anon_sym_LT2] = ACTIONS(2321),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2323),
    [anon_sym_or] = ACTIONS(4502),
    [aux_sym_char_token1] = ACTIONS(2323),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2321),
    [anon_sym_DQUOTE] = ACTIONS(2321),
    [anon_sym_AT_DQUOTE] = ACTIONS(2323),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2323),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2323),
    [sym_bool] = ACTIONS(2321),
    [sym_unit] = ACTIONS(2323),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2321),
    [sym_op_identifier] = ACTIONS(2323),
    [anon_sym_PLUS] = ACTIONS(2321),
    [anon_sym_DASH] = ACTIONS(2321),
    [anon_sym_PLUS_DOT] = ACTIONS(2323),
    [anon_sym_DASH_DOT] = ACTIONS(2323),
    [anon_sym_PERCENT] = ACTIONS(2323),
    [anon_sym_AMP_AMP] = ACTIONS(2323),
    [anon_sym_TILDE] = ACTIONS(2323),
    [aux_sym_prefix_op_token1] = ACTIONS(2323),
    [sym_int] = ACTIONS(2321),
    [sym_xint] = ACTIONS(2323),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2323),
    [sym__newline] = ACTIONS(2323),
  },
  [2709] = {
    [sym_type_arguments] = STATE(2786),
    [sym_long_identifier] = STATE(2790),
    [sym_block_comment] = STATE(2709),
    [sym_compiler_directive_decl] = STATE(2709),
    [sym_fsi_directive_decl] = STATE(2709),
    [sym_preproc_line] = STATE(2709),
    [aux_sym_compound_type_repeat1] = STATE(2768),
    [sym_identifier] = ACTIONS(4504),
    [anon_sym_GT_RBRACK] = ACTIONS(2244),
    [anon_sym_return] = ACTIONS(2246),
    [anon_sym_do] = ACTIONS(2246),
    [anon_sym_let] = ACTIONS(2246),
    [anon_sym_let_BANG] = ACTIONS(2244),
    [anon_sym_LPAREN] = ACTIONS(2246),
    [anon_sym_null] = ACTIONS(2246),
    [anon_sym_AMP] = ACTIONS(2246),
    [anon_sym_LBRACK] = ACTIONS(2246),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2244),
    [anon_sym_LBRACE] = ACTIONS(2246),
    [anon_sym_LT_AT] = ACTIONS(2246),
    [anon_sym_LT_AT_AT] = ACTIONS(2244),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2244),
    [anon_sym_new] = ACTIONS(2246),
    [anon_sym_return_BANG] = ACTIONS(2244),
    [anon_sym_yield] = ACTIONS(2246),
    [anon_sym_yield_BANG] = ACTIONS(2244),
    [anon_sym_lazy] = ACTIONS(2246),
    [anon_sym_assert] = ACTIONS(2246),
    [anon_sym_upcast] = ACTIONS(2246),
    [anon_sym_downcast] = ACTIONS(2246),
    [anon_sym_for] = ACTIONS(2246),
    [anon_sym_while] = ACTIONS(2246),
    [anon_sym_if] = ACTIONS(2246),
    [anon_sym_fun] = ACTIONS(2246),
    [anon_sym_DASH_GT] = ACTIONS(1691),
    [anon_sym_try] = ACTIONS(2246),
    [anon_sym_match] = ACTIONS(2246),
    [anon_sym_match_BANG] = ACTIONS(2244),
    [anon_sym_function] = ACTIONS(2246),
    [anon_sym_use] = ACTIONS(2246),
    [anon_sym_use_BANG] = ACTIONS(2244),
    [anon_sym_do_BANG] = ACTIONS(2244),
    [anon_sym_begin] = ACTIONS(2246),
    [anon_sym_STAR] = ACTIONS(1693),
    [anon_sym_LT2] = ACTIONS(1695),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(1697),
    [aux_sym_char_token1] = ACTIONS(2244),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2246),
    [anon_sym_DQUOTE] = ACTIONS(2246),
    [anon_sym_AT_DQUOTE] = ACTIONS(2244),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2244),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2244),
    [sym_bool] = ACTIONS(2246),
    [sym_unit] = ACTIONS(2244),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2246),
    [sym_op_identifier] = ACTIONS(2244),
    [anon_sym_PLUS] = ACTIONS(2246),
    [anon_sym_DASH] = ACTIONS(2246),
    [anon_sym_PLUS_DOT] = ACTIONS(2244),
    [anon_sym_DASH_DOT] = ACTIONS(2244),
    [anon_sym_PERCENT] = ACTIONS(2244),
    [anon_sym_AMP_AMP] = ACTIONS(2244),
    [anon_sym_TILDE] = ACTIONS(2244),
    [aux_sym_prefix_op_token1] = ACTIONS(2244),
    [sym_int] = ACTIONS(2246),
    [sym_xint] = ACTIONS(2244),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2244),
    [sym__newline] = ACTIONS(2244),
  },
  [2710] = {
    [sym_block_comment] = STATE(2710),
    [sym_compiler_directive_decl] = STATE(2710),
    [sym_fsi_directive_decl] = STATE(2710),
    [sym_preproc_line] = STATE(2710),
    [aux_sym_type_argument_repeat1] = STATE(2710),
    [sym_identifier] = ACTIONS(2340),
    [anon_sym_GT_RBRACK] = ACTIONS(2342),
    [anon_sym_return] = ACTIONS(2340),
    [anon_sym_do] = ACTIONS(2340),
    [anon_sym_let] = ACTIONS(2340),
    [anon_sym_let_BANG] = ACTIONS(2342),
    [anon_sym_LPAREN] = ACTIONS(2340),
    [anon_sym_null] = ACTIONS(2340),
    [anon_sym_AMP] = ACTIONS(2340),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2342),
    [anon_sym_LBRACE] = ACTIONS(2340),
    [anon_sym_LT_AT] = ACTIONS(2340),
    [anon_sym_LT_AT_AT] = ACTIONS(2342),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2342),
    [anon_sym_new] = ACTIONS(2340),
    [anon_sym_return_BANG] = ACTIONS(2342),
    [anon_sym_yield] = ACTIONS(2340),
    [anon_sym_yield_BANG] = ACTIONS(2342),
    [anon_sym_lazy] = ACTIONS(2340),
    [anon_sym_assert] = ACTIONS(2340),
    [anon_sym_upcast] = ACTIONS(2340),
    [anon_sym_downcast] = ACTIONS(2340),
    [anon_sym_COLON_GT] = ACTIONS(2342),
    [anon_sym_for] = ACTIONS(2340),
    [anon_sym_while] = ACTIONS(2340),
    [anon_sym_if] = ACTIONS(2340),
    [anon_sym_fun] = ACTIONS(2340),
    [anon_sym_DASH_GT] = ACTIONS(2342),
    [anon_sym_try] = ACTIONS(2340),
    [anon_sym_match] = ACTIONS(2340),
    [anon_sym_match_BANG] = ACTIONS(2342),
    [anon_sym_function] = ACTIONS(2340),
    [anon_sym_use] = ACTIONS(2340),
    [anon_sym_use_BANG] = ACTIONS(2342),
    [anon_sym_do_BANG] = ACTIONS(2342),
    [anon_sym_begin] = ACTIONS(2340),
    [anon_sym_STAR] = ACTIONS(2342),
    [anon_sym_LT2] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2342),
    [anon_sym_or] = ACTIONS(4506),
    [aux_sym_char_token1] = ACTIONS(2342),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2340),
    [anon_sym_DQUOTE] = ACTIONS(2340),
    [anon_sym_AT_DQUOTE] = ACTIONS(2342),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2342),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2342),
    [sym_bool] = ACTIONS(2340),
    [sym_unit] = ACTIONS(2342),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2340),
    [sym_op_identifier] = ACTIONS(2342),
    [anon_sym_PLUS] = ACTIONS(2340),
    [anon_sym_DASH] = ACTIONS(2340),
    [anon_sym_PLUS_DOT] = ACTIONS(2342),
    [anon_sym_DASH_DOT] = ACTIONS(2342),
    [anon_sym_PERCENT] = ACTIONS(2342),
    [anon_sym_AMP_AMP] = ACTIONS(2342),
    [anon_sym_TILDE] = ACTIONS(2342),
    [aux_sym_prefix_op_token1] = ACTIONS(2342),
    [sym_int] = ACTIONS(2340),
    [sym_xint] = ACTIONS(2342),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2342),
    [sym__newline] = ACTIONS(2342),
  },
  [2711] = {
    [sym_type_arguments] = STATE(2786),
    [sym_long_identifier] = STATE(2790),
    [sym_block_comment] = STATE(2711),
    [sym_compiler_directive_decl] = STATE(2711),
    [sym_fsi_directive_decl] = STATE(2711),
    [sym_preproc_line] = STATE(2711),
    [aux_sym_compound_type_repeat1] = STATE(2768),
    [sym_identifier] = ACTIONS(4504),
    [anon_sym_GT_RBRACK] = ACTIONS(2248),
    [anon_sym_return] = ACTIONS(2250),
    [anon_sym_do] = ACTIONS(2250),
    [anon_sym_let] = ACTIONS(2250),
    [anon_sym_let_BANG] = ACTIONS(2248),
    [anon_sym_LPAREN] = ACTIONS(2250),
    [anon_sym_null] = ACTIONS(2250),
    [anon_sym_AMP] = ACTIONS(2250),
    [anon_sym_LBRACK] = ACTIONS(2250),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2248),
    [anon_sym_LBRACE] = ACTIONS(2250),
    [anon_sym_LT_AT] = ACTIONS(2250),
    [anon_sym_LT_AT_AT] = ACTIONS(2248),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2248),
    [anon_sym_new] = ACTIONS(2250),
    [anon_sym_return_BANG] = ACTIONS(2248),
    [anon_sym_yield] = ACTIONS(2250),
    [anon_sym_yield_BANG] = ACTIONS(2248),
    [anon_sym_lazy] = ACTIONS(2250),
    [anon_sym_assert] = ACTIONS(2250),
    [anon_sym_upcast] = ACTIONS(2250),
    [anon_sym_downcast] = ACTIONS(2250),
    [anon_sym_for] = ACTIONS(2250),
    [anon_sym_while] = ACTIONS(2250),
    [anon_sym_if] = ACTIONS(2250),
    [anon_sym_fun] = ACTIONS(2250),
    [anon_sym_DASH_GT] = ACTIONS(1691),
    [anon_sym_try] = ACTIONS(2250),
    [anon_sym_match] = ACTIONS(2250),
    [anon_sym_match_BANG] = ACTIONS(2248),
    [anon_sym_function] = ACTIONS(2250),
    [anon_sym_use] = ACTIONS(2250),
    [anon_sym_use_BANG] = ACTIONS(2248),
    [anon_sym_do_BANG] = ACTIONS(2248),
    [anon_sym_begin] = ACTIONS(2250),
    [anon_sym_STAR] = ACTIONS(1693),
    [anon_sym_LT2] = ACTIONS(1695),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(1697),
    [aux_sym_char_token1] = ACTIONS(2248),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2250),
    [anon_sym_DQUOTE] = ACTIONS(2250),
    [anon_sym_AT_DQUOTE] = ACTIONS(2248),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2248),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2248),
    [sym_bool] = ACTIONS(2250),
    [sym_unit] = ACTIONS(2248),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2250),
    [sym_op_identifier] = ACTIONS(2248),
    [anon_sym_PLUS] = ACTIONS(2250),
    [anon_sym_DASH] = ACTIONS(2250),
    [anon_sym_PLUS_DOT] = ACTIONS(2248),
    [anon_sym_DASH_DOT] = ACTIONS(2248),
    [anon_sym_PERCENT] = ACTIONS(2248),
    [anon_sym_AMP_AMP] = ACTIONS(2248),
    [anon_sym_TILDE] = ACTIONS(2248),
    [aux_sym_prefix_op_token1] = ACTIONS(2248),
    [sym_int] = ACTIONS(2250),
    [sym_xint] = ACTIONS(2248),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2248),
    [sym__newline] = ACTIONS(2248),
  },
  [2712] = {
    [sym_type_arguments] = STATE(2786),
    [sym_long_identifier] = STATE(2790),
    [sym_block_comment] = STATE(2712),
    [sym_compiler_directive_decl] = STATE(2712),
    [sym_fsi_directive_decl] = STATE(2712),
    [sym_preproc_line] = STATE(2712),
    [aux_sym_compound_type_repeat1] = STATE(2768),
    [sym_identifier] = ACTIONS(4504),
    [anon_sym_GT_RBRACK] = ACTIONS(2228),
    [anon_sym_return] = ACTIONS(2230),
    [anon_sym_do] = ACTIONS(2230),
    [anon_sym_let] = ACTIONS(2230),
    [anon_sym_let_BANG] = ACTIONS(2228),
    [anon_sym_LPAREN] = ACTIONS(2230),
    [anon_sym_null] = ACTIONS(2230),
    [anon_sym_AMP] = ACTIONS(2230),
    [anon_sym_LBRACK] = ACTIONS(2230),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2228),
    [anon_sym_LBRACE] = ACTIONS(2230),
    [anon_sym_LT_AT] = ACTIONS(2230),
    [anon_sym_LT_AT_AT] = ACTIONS(2228),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2228),
    [anon_sym_new] = ACTIONS(2230),
    [anon_sym_return_BANG] = ACTIONS(2228),
    [anon_sym_yield] = ACTIONS(2230),
    [anon_sym_yield_BANG] = ACTIONS(2228),
    [anon_sym_lazy] = ACTIONS(2230),
    [anon_sym_assert] = ACTIONS(2230),
    [anon_sym_upcast] = ACTIONS(2230),
    [anon_sym_downcast] = ACTIONS(2230),
    [anon_sym_for] = ACTIONS(2230),
    [anon_sym_while] = ACTIONS(2230),
    [anon_sym_if] = ACTIONS(2230),
    [anon_sym_fun] = ACTIONS(2230),
    [anon_sym_DASH_GT] = ACTIONS(1691),
    [anon_sym_try] = ACTIONS(2230),
    [anon_sym_match] = ACTIONS(2230),
    [anon_sym_match_BANG] = ACTIONS(2228),
    [anon_sym_function] = ACTIONS(2230),
    [anon_sym_use] = ACTIONS(2230),
    [anon_sym_use_BANG] = ACTIONS(2228),
    [anon_sym_do_BANG] = ACTIONS(2228),
    [anon_sym_begin] = ACTIONS(2230),
    [anon_sym_STAR] = ACTIONS(1693),
    [anon_sym_LT2] = ACTIONS(1695),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(1697),
    [aux_sym_char_token1] = ACTIONS(2228),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2230),
    [anon_sym_DQUOTE] = ACTIONS(2230),
    [anon_sym_AT_DQUOTE] = ACTIONS(2228),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2228),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2228),
    [sym_bool] = ACTIONS(2230),
    [sym_unit] = ACTIONS(2228),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2230),
    [sym_op_identifier] = ACTIONS(2228),
    [anon_sym_PLUS] = ACTIONS(2230),
    [anon_sym_DASH] = ACTIONS(2230),
    [anon_sym_PLUS_DOT] = ACTIONS(2228),
    [anon_sym_DASH_DOT] = ACTIONS(2228),
    [anon_sym_PERCENT] = ACTIONS(2228),
    [anon_sym_AMP_AMP] = ACTIONS(2228),
    [anon_sym_TILDE] = ACTIONS(2228),
    [aux_sym_prefix_op_token1] = ACTIONS(2228),
    [sym_int] = ACTIONS(2230),
    [sym_xint] = ACTIONS(2228),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2228),
    [sym__newline] = ACTIONS(2228),
  },
  [2713] = {
    [sym_block_comment] = STATE(2713),
    [sym_compiler_directive_decl] = STATE(2713),
    [sym_fsi_directive_decl] = STATE(2713),
    [sym_preproc_line] = STATE(2713),
    [aux_sym_type_argument_repeat1] = STATE(2710),
    [sym_identifier] = ACTIONS(2328),
    [anon_sym_GT_RBRACK] = ACTIONS(2330),
    [anon_sym_return] = ACTIONS(2328),
    [anon_sym_do] = ACTIONS(2328),
    [anon_sym_let] = ACTIONS(2328),
    [anon_sym_let_BANG] = ACTIONS(2330),
    [anon_sym_LPAREN] = ACTIONS(2328),
    [anon_sym_null] = ACTIONS(2328),
    [anon_sym_AMP] = ACTIONS(2328),
    [anon_sym_LBRACK] = ACTIONS(2328),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2330),
    [anon_sym_LBRACE] = ACTIONS(2328),
    [anon_sym_LT_AT] = ACTIONS(2328),
    [anon_sym_LT_AT_AT] = ACTIONS(2330),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2330),
    [anon_sym_new] = ACTIONS(2328),
    [anon_sym_return_BANG] = ACTIONS(2330),
    [anon_sym_yield] = ACTIONS(2328),
    [anon_sym_yield_BANG] = ACTIONS(2330),
    [anon_sym_lazy] = ACTIONS(2328),
    [anon_sym_assert] = ACTIONS(2328),
    [anon_sym_upcast] = ACTIONS(2328),
    [anon_sym_downcast] = ACTIONS(2328),
    [anon_sym_COLON_GT] = ACTIONS(2330),
    [anon_sym_for] = ACTIONS(2328),
    [anon_sym_while] = ACTIONS(2328),
    [anon_sym_if] = ACTIONS(2328),
    [anon_sym_fun] = ACTIONS(2328),
    [anon_sym_DASH_GT] = ACTIONS(2330),
    [anon_sym_try] = ACTIONS(2328),
    [anon_sym_match] = ACTIONS(2328),
    [anon_sym_match_BANG] = ACTIONS(2330),
    [anon_sym_function] = ACTIONS(2328),
    [anon_sym_use] = ACTIONS(2328),
    [anon_sym_use_BANG] = ACTIONS(2330),
    [anon_sym_do_BANG] = ACTIONS(2330),
    [anon_sym_begin] = ACTIONS(2328),
    [anon_sym_STAR] = ACTIONS(2330),
    [anon_sym_LT2] = ACTIONS(2328),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2330),
    [anon_sym_or] = ACTIONS(4502),
    [aux_sym_char_token1] = ACTIONS(2330),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2328),
    [anon_sym_DQUOTE] = ACTIONS(2328),
    [anon_sym_AT_DQUOTE] = ACTIONS(2330),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2330),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2330),
    [sym_bool] = ACTIONS(2328),
    [sym_unit] = ACTIONS(2330),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2328),
    [sym_op_identifier] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(2328),
    [anon_sym_DASH] = ACTIONS(2328),
    [anon_sym_PLUS_DOT] = ACTIONS(2330),
    [anon_sym_DASH_DOT] = ACTIONS(2330),
    [anon_sym_PERCENT] = ACTIONS(2330),
    [anon_sym_AMP_AMP] = ACTIONS(2330),
    [anon_sym_TILDE] = ACTIONS(2330),
    [aux_sym_prefix_op_token1] = ACTIONS(2330),
    [sym_int] = ACTIONS(2328),
    [sym_xint] = ACTIONS(2330),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2330),
    [sym__newline] = ACTIONS(2330),
  },
  [2714] = {
    [sym_type_arguments] = STATE(2786),
    [sym_long_identifier] = STATE(2790),
    [sym_block_comment] = STATE(2714),
    [sym_compiler_directive_decl] = STATE(2714),
    [sym_fsi_directive_decl] = STATE(2714),
    [sym_preproc_line] = STATE(2714),
    [aux_sym_compound_type_repeat1] = STATE(2768),
    [sym_identifier] = ACTIONS(4504),
    [anon_sym_GT_RBRACK] = ACTIONS(2240),
    [anon_sym_return] = ACTIONS(2242),
    [anon_sym_do] = ACTIONS(2242),
    [anon_sym_let] = ACTIONS(2242),
    [anon_sym_let_BANG] = ACTIONS(2240),
    [anon_sym_LPAREN] = ACTIONS(2242),
    [anon_sym_null] = ACTIONS(2242),
    [anon_sym_AMP] = ACTIONS(2242),
    [anon_sym_LBRACK] = ACTIONS(2242),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2240),
    [anon_sym_LBRACE] = ACTIONS(2242),
    [anon_sym_LT_AT] = ACTIONS(2242),
    [anon_sym_LT_AT_AT] = ACTIONS(2240),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2240),
    [anon_sym_new] = ACTIONS(2242),
    [anon_sym_return_BANG] = ACTIONS(2240),
    [anon_sym_yield] = ACTIONS(2242),
    [anon_sym_yield_BANG] = ACTIONS(2240),
    [anon_sym_lazy] = ACTIONS(2242),
    [anon_sym_assert] = ACTIONS(2242),
    [anon_sym_upcast] = ACTIONS(2242),
    [anon_sym_downcast] = ACTIONS(2242),
    [anon_sym_for] = ACTIONS(2242),
    [anon_sym_while] = ACTIONS(2242),
    [anon_sym_if] = ACTIONS(2242),
    [anon_sym_fun] = ACTIONS(2242),
    [anon_sym_DASH_GT] = ACTIONS(1691),
    [anon_sym_try] = ACTIONS(2242),
    [anon_sym_match] = ACTIONS(2242),
    [anon_sym_match_BANG] = ACTIONS(2240),
    [anon_sym_function] = ACTIONS(2242),
    [anon_sym_use] = ACTIONS(2242),
    [anon_sym_use_BANG] = ACTIONS(2240),
    [anon_sym_do_BANG] = ACTIONS(2240),
    [anon_sym_begin] = ACTIONS(2242),
    [anon_sym_STAR] = ACTIONS(1693),
    [anon_sym_LT2] = ACTIONS(1695),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(1697),
    [aux_sym_char_token1] = ACTIONS(2240),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2242),
    [anon_sym_DQUOTE] = ACTIONS(2242),
    [anon_sym_AT_DQUOTE] = ACTIONS(2240),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2240),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2240),
    [sym_bool] = ACTIONS(2242),
    [sym_unit] = ACTIONS(2240),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2242),
    [sym_op_identifier] = ACTIONS(2240),
    [anon_sym_PLUS] = ACTIONS(2242),
    [anon_sym_DASH] = ACTIONS(2242),
    [anon_sym_PLUS_DOT] = ACTIONS(2240),
    [anon_sym_DASH_DOT] = ACTIONS(2240),
    [anon_sym_PERCENT] = ACTIONS(2240),
    [anon_sym_AMP_AMP] = ACTIONS(2240),
    [anon_sym_TILDE] = ACTIONS(2240),
    [aux_sym_prefix_op_token1] = ACTIONS(2240),
    [sym_int] = ACTIONS(2242),
    [sym_xint] = ACTIONS(2240),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2240),
    [sym__newline] = ACTIONS(2240),
  },
  [2715] = {
    [sym__type] = STATE(5002),
    [sym_simple_type] = STATE(5109),
    [sym_generic_type] = STATE(5109),
    [sym_paren_type] = STATE(5109),
    [sym_function_type] = STATE(5109),
    [sym_compound_type] = STATE(5109),
    [sym_postfix_type] = STATE(5109),
    [sym_list_type] = STATE(5109),
    [sym_static_type] = STATE(5109),
    [sym_constrained_type] = STATE(5109),
    [sym_flexible_type] = STATE(5109),
    [sym_anon_record_type] = STATE(5109),
    [sym__static_type_identifier] = STATE(4686),
    [sym__static_parameter] = STATE(6029),
    [sym_named_static_parameter] = STATE(6034),
    [sym_type_attribute] = STATE(5982),
    [sym_type_attributes] = STATE(6416),
    [sym_type_argument] = STATE(4913),
    [sym_static_parameter_value] = STATE(6034),
    [sym_char] = STATE(2803),
    [sym_format_string] = STATE(2805),
    [sym__string_literal] = STATE(2805),
    [sym_string] = STATE(2803),
    [sym_verbatim_string] = STATE(2803),
    [sym_bytearray] = STATE(2803),
    [sym_verbatim_bytearray] = STATE(2803),
    [sym_format_triple_quoted_string] = STATE(2809),
    [sym_triple_quoted_string] = STATE(2803),
    [sym_const] = STATE(432),
    [sym_long_identifier] = STATE(5121),
    [sym_sbyte] = STATE(2803),
    [sym_byte] = STATE(2803),
    [sym_int16] = STATE(2803),
    [sym_uint16] = STATE(2803),
    [sym_int32] = STATE(2803),
    [sym_uint32] = STATE(2803),
    [sym_nativeint] = STATE(2803),
    [sym_unativeint] = STATE(2803),
    [sym_int64] = STATE(2803),
    [sym_uint64] = STATE(2803),
    [sym_ieee32] = STATE(2803),
    [sym_ieee64] = STATE(2803),
    [sym_bignum] = STATE(2803),
    [sym_decimal] = STATE(2803),
    [sym_float] = STATE(2793),
    [sym_block_comment] = STATE(2715),
    [sym_compiler_directive_decl] = STATE(2715),
    [sym_fsi_directive_decl] = STATE(2715),
    [sym_preproc_line] = STATE(2715),
    [sym_identifier] = ACTIONS(4509),
    [anon_sym_LPAREN] = ACTIONS(4511),
    [anon_sym__] = ACTIONS(4513),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4515),
    [anon_sym_GT] = ACTIONS(4517),
    [anon_sym_POUND] = ACTIONS(4519),
    [anon_sym_CARET] = ACTIONS(4521),
    [anon_sym_SQUOTE] = ACTIONS(4521),
    [aux_sym_char_token1] = ACTIONS(4523),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4525),
    [anon_sym_DQUOTE] = ACTIONS(4527),
    [anon_sym_AT_DQUOTE] = ACTIONS(4529),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4531),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4533),
    [sym_bool] = ACTIONS(4535),
    [sym_unit] = ACTIONS(4537),
    [sym_int] = ACTIONS(4539),
    [sym_xint] = ACTIONS(4541),
    [anon_sym_LPAREN_STAR] = ACTIONS(27),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2716] = {
    [sym__type] = STATE(5002),
    [sym_simple_type] = STATE(5109),
    [sym_generic_type] = STATE(5109),
    [sym_paren_type] = STATE(5109),
    [sym_function_type] = STATE(5109),
    [sym_compound_type] = STATE(5109),
    [sym_postfix_type] = STATE(5109),
    [sym_list_type] = STATE(5109),
    [sym_static_type] = STATE(5109),
    [sym_constrained_type] = STATE(5109),
    [sym_flexible_type] = STATE(5109),
    [sym_anon_record_type] = STATE(5109),
    [sym__static_type_identifier] = STATE(4686),
    [sym__static_parameter] = STATE(6029),
    [sym_named_static_parameter] = STATE(6034),
    [sym_type_attribute] = STATE(5982),
    [sym_type_attributes] = STATE(6549),
    [sym_type_argument] = STATE(4913),
    [sym_static_parameter_value] = STATE(6034),
    [sym_char] = STATE(2803),
    [sym_format_string] = STATE(2805),
    [sym__string_literal] = STATE(2805),
    [sym_string] = STATE(2803),
    [sym_verbatim_string] = STATE(2803),
    [sym_bytearray] = STATE(2803),
    [sym_verbatim_bytearray] = STATE(2803),
    [sym_format_triple_quoted_string] = STATE(2809),
    [sym_triple_quoted_string] = STATE(2803),
    [sym_const] = STATE(432),
    [sym_long_identifier] = STATE(5121),
    [sym_sbyte] = STATE(2803),
    [sym_byte] = STATE(2803),
    [sym_int16] = STATE(2803),
    [sym_uint16] = STATE(2803),
    [sym_int32] = STATE(2803),
    [sym_uint32] = STATE(2803),
    [sym_nativeint] = STATE(2803),
    [sym_unativeint] = STATE(2803),
    [sym_int64] = STATE(2803),
    [sym_uint64] = STATE(2803),
    [sym_ieee32] = STATE(2803),
    [sym_ieee64] = STATE(2803),
    [sym_bignum] = STATE(2803),
    [sym_decimal] = STATE(2803),
    [sym_float] = STATE(2793),
    [sym_block_comment] = STATE(2716),
    [sym_compiler_directive_decl] = STATE(2716),
    [sym_fsi_directive_decl] = STATE(2716),
    [sym_preproc_line] = STATE(2716),
    [sym_identifier] = ACTIONS(4509),
    [anon_sym_LPAREN] = ACTIONS(4511),
    [anon_sym__] = ACTIONS(4513),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4515),
    [anon_sym_GT] = ACTIONS(4543),
    [anon_sym_POUND] = ACTIONS(4519),
    [anon_sym_CARET] = ACTIONS(4521),
    [anon_sym_SQUOTE] = ACTIONS(4521),
    [aux_sym_char_token1] = ACTIONS(4523),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4525),
    [anon_sym_DQUOTE] = ACTIONS(4527),
    [anon_sym_AT_DQUOTE] = ACTIONS(4529),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4531),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4533),
    [sym_bool] = ACTIONS(4535),
    [sym_unit] = ACTIONS(4537),
    [sym_int] = ACTIONS(4539),
    [sym_xint] = ACTIONS(4541),
    [anon_sym_LPAREN_STAR] = ACTIONS(27),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2717] = {
    [sym__type] = STATE(5002),
    [sym_simple_type] = STATE(5109),
    [sym_generic_type] = STATE(5109),
    [sym_paren_type] = STATE(5109),
    [sym_function_type] = STATE(5109),
    [sym_compound_type] = STATE(5109),
    [sym_postfix_type] = STATE(5109),
    [sym_list_type] = STATE(5109),
    [sym_static_type] = STATE(5109),
    [sym_constrained_type] = STATE(5109),
    [sym_flexible_type] = STATE(5109),
    [sym_anon_record_type] = STATE(5109),
    [sym__static_type_identifier] = STATE(4686),
    [sym__static_parameter] = STATE(6029),
    [sym_named_static_parameter] = STATE(6034),
    [sym_type_attribute] = STATE(5982),
    [sym_type_attributes] = STATE(7088),
    [sym_type_argument] = STATE(4913),
    [sym_static_parameter_value] = STATE(6034),
    [sym_char] = STATE(2803),
    [sym_format_string] = STATE(2805),
    [sym__string_literal] = STATE(2805),
    [sym_string] = STATE(2803),
    [sym_verbatim_string] = STATE(2803),
    [sym_bytearray] = STATE(2803),
    [sym_verbatim_bytearray] = STATE(2803),
    [sym_format_triple_quoted_string] = STATE(2809),
    [sym_triple_quoted_string] = STATE(2803),
    [sym_const] = STATE(432),
    [sym_long_identifier] = STATE(5121),
    [sym_sbyte] = STATE(2803),
    [sym_byte] = STATE(2803),
    [sym_int16] = STATE(2803),
    [sym_uint16] = STATE(2803),
    [sym_int32] = STATE(2803),
    [sym_uint32] = STATE(2803),
    [sym_nativeint] = STATE(2803),
    [sym_unativeint] = STATE(2803),
    [sym_int64] = STATE(2803),
    [sym_uint64] = STATE(2803),
    [sym_ieee32] = STATE(2803),
    [sym_ieee64] = STATE(2803),
    [sym_bignum] = STATE(2803),
    [sym_decimal] = STATE(2803),
    [sym_float] = STATE(2793),
    [sym_block_comment] = STATE(2717),
    [sym_compiler_directive_decl] = STATE(2717),
    [sym_fsi_directive_decl] = STATE(2717),
    [sym_preproc_line] = STATE(2717),
    [sym_identifier] = ACTIONS(4509),
    [anon_sym_LPAREN] = ACTIONS(4511),
    [anon_sym__] = ACTIONS(4513),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4515),
    [anon_sym_GT] = ACTIONS(4545),
    [anon_sym_POUND] = ACTIONS(4519),
    [anon_sym_CARET] = ACTIONS(4521),
    [anon_sym_SQUOTE] = ACTIONS(4521),
    [aux_sym_char_token1] = ACTIONS(4523),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4525),
    [anon_sym_DQUOTE] = ACTIONS(4527),
    [anon_sym_AT_DQUOTE] = ACTIONS(4529),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4531),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4533),
    [sym_bool] = ACTIONS(4535),
    [sym_unit] = ACTIONS(4537),
    [sym_int] = ACTIONS(4539),
    [sym_xint] = ACTIONS(4541),
    [anon_sym_LPAREN_STAR] = ACTIONS(27),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2718] = {
    [sym__type] = STATE(5002),
    [sym_simple_type] = STATE(5109),
    [sym_generic_type] = STATE(5109),
    [sym_paren_type] = STATE(5109),
    [sym_function_type] = STATE(5109),
    [sym_compound_type] = STATE(5109),
    [sym_postfix_type] = STATE(5109),
    [sym_list_type] = STATE(5109),
    [sym_static_type] = STATE(5109),
    [sym_constrained_type] = STATE(5109),
    [sym_flexible_type] = STATE(5109),
    [sym_anon_record_type] = STATE(5109),
    [sym__static_type_identifier] = STATE(4686),
    [sym__static_parameter] = STATE(6029),
    [sym_named_static_parameter] = STATE(6034),
    [sym_type_attribute] = STATE(5982),
    [sym_type_attributes] = STATE(7290),
    [sym_type_argument] = STATE(4913),
    [sym_static_parameter_value] = STATE(6034),
    [sym_char] = STATE(2803),
    [sym_format_string] = STATE(2805),
    [sym__string_literal] = STATE(2805),
    [sym_string] = STATE(2803),
    [sym_verbatim_string] = STATE(2803),
    [sym_bytearray] = STATE(2803),
    [sym_verbatim_bytearray] = STATE(2803),
    [sym_format_triple_quoted_string] = STATE(2809),
    [sym_triple_quoted_string] = STATE(2803),
    [sym_const] = STATE(432),
    [sym_long_identifier] = STATE(5121),
    [sym_sbyte] = STATE(2803),
    [sym_byte] = STATE(2803),
    [sym_int16] = STATE(2803),
    [sym_uint16] = STATE(2803),
    [sym_int32] = STATE(2803),
    [sym_uint32] = STATE(2803),
    [sym_nativeint] = STATE(2803),
    [sym_unativeint] = STATE(2803),
    [sym_int64] = STATE(2803),
    [sym_uint64] = STATE(2803),
    [sym_ieee32] = STATE(2803),
    [sym_ieee64] = STATE(2803),
    [sym_bignum] = STATE(2803),
    [sym_decimal] = STATE(2803),
    [sym_float] = STATE(2793),
    [sym_block_comment] = STATE(2718),
    [sym_compiler_directive_decl] = STATE(2718),
    [sym_fsi_directive_decl] = STATE(2718),
    [sym_preproc_line] = STATE(2718),
    [sym_identifier] = ACTIONS(4509),
    [anon_sym_LPAREN] = ACTIONS(4511),
    [anon_sym__] = ACTIONS(4513),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4515),
    [anon_sym_GT] = ACTIONS(4547),
    [anon_sym_POUND] = ACTIONS(4519),
    [anon_sym_CARET] = ACTIONS(4521),
    [anon_sym_SQUOTE] = ACTIONS(4521),
    [aux_sym_char_token1] = ACTIONS(4523),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4525),
    [anon_sym_DQUOTE] = ACTIONS(4527),
    [anon_sym_AT_DQUOTE] = ACTIONS(4529),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4531),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4533),
    [sym_bool] = ACTIONS(4535),
    [sym_unit] = ACTIONS(4537),
    [sym_int] = ACTIONS(4539),
    [sym_xint] = ACTIONS(4541),
    [anon_sym_LPAREN_STAR] = ACTIONS(27),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2719] = {
    [sym__type] = STATE(5002),
    [sym_simple_type] = STATE(5109),
    [sym_generic_type] = STATE(5109),
    [sym_paren_type] = STATE(5109),
    [sym_function_type] = STATE(5109),
    [sym_compound_type] = STATE(5109),
    [sym_postfix_type] = STATE(5109),
    [sym_list_type] = STATE(5109),
    [sym_static_type] = STATE(5109),
    [sym_constrained_type] = STATE(5109),
    [sym_flexible_type] = STATE(5109),
    [sym_anon_record_type] = STATE(5109),
    [sym__static_type_identifier] = STATE(4686),
    [sym__static_parameter] = STATE(6029),
    [sym_named_static_parameter] = STATE(6034),
    [sym_type_attribute] = STATE(5982),
    [sym_type_attributes] = STATE(7299),
    [sym_type_argument] = STATE(4913),
    [sym_static_parameter_value] = STATE(6034),
    [sym_char] = STATE(2803),
    [sym_format_string] = STATE(2805),
    [sym__string_literal] = STATE(2805),
    [sym_string] = STATE(2803),
    [sym_verbatim_string] = STATE(2803),
    [sym_bytearray] = STATE(2803),
    [sym_verbatim_bytearray] = STATE(2803),
    [sym_format_triple_quoted_string] = STATE(2809),
    [sym_triple_quoted_string] = STATE(2803),
    [sym_const] = STATE(432),
    [sym_long_identifier] = STATE(5121),
    [sym_sbyte] = STATE(2803),
    [sym_byte] = STATE(2803),
    [sym_int16] = STATE(2803),
    [sym_uint16] = STATE(2803),
    [sym_int32] = STATE(2803),
    [sym_uint32] = STATE(2803),
    [sym_nativeint] = STATE(2803),
    [sym_unativeint] = STATE(2803),
    [sym_int64] = STATE(2803),
    [sym_uint64] = STATE(2803),
    [sym_ieee32] = STATE(2803),
    [sym_ieee64] = STATE(2803),
    [sym_bignum] = STATE(2803),
    [sym_decimal] = STATE(2803),
    [sym_float] = STATE(2793),
    [sym_block_comment] = STATE(2719),
    [sym_compiler_directive_decl] = STATE(2719),
    [sym_fsi_directive_decl] = STATE(2719),
    [sym_preproc_line] = STATE(2719),
    [sym_identifier] = ACTIONS(4509),
    [anon_sym_LPAREN] = ACTIONS(4511),
    [anon_sym__] = ACTIONS(4513),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4515),
    [anon_sym_GT] = ACTIONS(4549),
    [anon_sym_POUND] = ACTIONS(4519),
    [anon_sym_CARET] = ACTIONS(4521),
    [anon_sym_SQUOTE] = ACTIONS(4521),
    [aux_sym_char_token1] = ACTIONS(4523),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4525),
    [anon_sym_DQUOTE] = ACTIONS(4527),
    [anon_sym_AT_DQUOTE] = ACTIONS(4529),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4531),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4533),
    [sym_bool] = ACTIONS(4535),
    [sym_unit] = ACTIONS(4537),
    [sym_int] = ACTIONS(4539),
    [sym_xint] = ACTIONS(4541),
    [anon_sym_LPAREN_STAR] = ACTIONS(27),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2720] = {
    [sym__type] = STATE(5002),
    [sym_simple_type] = STATE(5109),
    [sym_generic_type] = STATE(5109),
    [sym_paren_type] = STATE(5109),
    [sym_function_type] = STATE(5109),
    [sym_compound_type] = STATE(5109),
    [sym_postfix_type] = STATE(5109),
    [sym_list_type] = STATE(5109),
    [sym_static_type] = STATE(5109),
    [sym_constrained_type] = STATE(5109),
    [sym_flexible_type] = STATE(5109),
    [sym_anon_record_type] = STATE(5109),
    [sym__static_type_identifier] = STATE(4686),
    [sym__static_parameter] = STATE(6029),
    [sym_named_static_parameter] = STATE(6034),
    [sym_type_attribute] = STATE(5982),
    [sym_type_attributes] = STATE(6943),
    [sym_type_argument] = STATE(4913),
    [sym_static_parameter_value] = STATE(6034),
    [sym_char] = STATE(2803),
    [sym_format_string] = STATE(2805),
    [sym__string_literal] = STATE(2805),
    [sym_string] = STATE(2803),
    [sym_verbatim_string] = STATE(2803),
    [sym_bytearray] = STATE(2803),
    [sym_verbatim_bytearray] = STATE(2803),
    [sym_format_triple_quoted_string] = STATE(2809),
    [sym_triple_quoted_string] = STATE(2803),
    [sym_const] = STATE(432),
    [sym_long_identifier] = STATE(5121),
    [sym_sbyte] = STATE(2803),
    [sym_byte] = STATE(2803),
    [sym_int16] = STATE(2803),
    [sym_uint16] = STATE(2803),
    [sym_int32] = STATE(2803),
    [sym_uint32] = STATE(2803),
    [sym_nativeint] = STATE(2803),
    [sym_unativeint] = STATE(2803),
    [sym_int64] = STATE(2803),
    [sym_uint64] = STATE(2803),
    [sym_ieee32] = STATE(2803),
    [sym_ieee64] = STATE(2803),
    [sym_bignum] = STATE(2803),
    [sym_decimal] = STATE(2803),
    [sym_float] = STATE(2793),
    [sym_block_comment] = STATE(2720),
    [sym_compiler_directive_decl] = STATE(2720),
    [sym_fsi_directive_decl] = STATE(2720),
    [sym_preproc_line] = STATE(2720),
    [sym_identifier] = ACTIONS(4509),
    [anon_sym_LPAREN] = ACTIONS(4511),
    [anon_sym__] = ACTIONS(4513),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4515),
    [anon_sym_GT] = ACTIONS(4551),
    [anon_sym_POUND] = ACTIONS(4519),
    [anon_sym_CARET] = ACTIONS(4521),
    [anon_sym_SQUOTE] = ACTIONS(4521),
    [aux_sym_char_token1] = ACTIONS(4523),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4525),
    [anon_sym_DQUOTE] = ACTIONS(4527),
    [anon_sym_AT_DQUOTE] = ACTIONS(4529),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4531),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4533),
    [sym_bool] = ACTIONS(4535),
    [sym_unit] = ACTIONS(4537),
    [sym_int] = ACTIONS(4539),
    [sym_xint] = ACTIONS(4541),
    [anon_sym_LPAREN_STAR] = ACTIONS(27),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2721] = {
    [sym__type] = STATE(5002),
    [sym_simple_type] = STATE(5109),
    [sym_generic_type] = STATE(5109),
    [sym_paren_type] = STATE(5109),
    [sym_function_type] = STATE(5109),
    [sym_compound_type] = STATE(5109),
    [sym_postfix_type] = STATE(5109),
    [sym_list_type] = STATE(5109),
    [sym_static_type] = STATE(5109),
    [sym_constrained_type] = STATE(5109),
    [sym_flexible_type] = STATE(5109),
    [sym_anon_record_type] = STATE(5109),
    [sym__static_type_identifier] = STATE(4686),
    [sym__static_parameter] = STATE(6029),
    [sym_named_static_parameter] = STATE(6034),
    [sym_type_attribute] = STATE(5982),
    [sym_type_attributes] = STATE(6646),
    [sym_type_argument] = STATE(4913),
    [sym_static_parameter_value] = STATE(6034),
    [sym_char] = STATE(2803),
    [sym_format_string] = STATE(2805),
    [sym__string_literal] = STATE(2805),
    [sym_string] = STATE(2803),
    [sym_verbatim_string] = STATE(2803),
    [sym_bytearray] = STATE(2803),
    [sym_verbatim_bytearray] = STATE(2803),
    [sym_format_triple_quoted_string] = STATE(2809),
    [sym_triple_quoted_string] = STATE(2803),
    [sym_const] = STATE(432),
    [sym_long_identifier] = STATE(5121),
    [sym_sbyte] = STATE(2803),
    [sym_byte] = STATE(2803),
    [sym_int16] = STATE(2803),
    [sym_uint16] = STATE(2803),
    [sym_int32] = STATE(2803),
    [sym_uint32] = STATE(2803),
    [sym_nativeint] = STATE(2803),
    [sym_unativeint] = STATE(2803),
    [sym_int64] = STATE(2803),
    [sym_uint64] = STATE(2803),
    [sym_ieee32] = STATE(2803),
    [sym_ieee64] = STATE(2803),
    [sym_bignum] = STATE(2803),
    [sym_decimal] = STATE(2803),
    [sym_float] = STATE(2793),
    [sym_block_comment] = STATE(2721),
    [sym_compiler_directive_decl] = STATE(2721),
    [sym_fsi_directive_decl] = STATE(2721),
    [sym_preproc_line] = STATE(2721),
    [sym_identifier] = ACTIONS(4509),
    [anon_sym_LPAREN] = ACTIONS(4511),
    [anon_sym__] = ACTIONS(4513),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4515),
    [anon_sym_GT] = ACTIONS(4553),
    [anon_sym_POUND] = ACTIONS(4519),
    [anon_sym_CARET] = ACTIONS(4521),
    [anon_sym_SQUOTE] = ACTIONS(4521),
    [aux_sym_char_token1] = ACTIONS(4523),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4525),
    [anon_sym_DQUOTE] = ACTIONS(4527),
    [anon_sym_AT_DQUOTE] = ACTIONS(4529),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4531),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4533),
    [sym_bool] = ACTIONS(4535),
    [sym_unit] = ACTIONS(4537),
    [sym_int] = ACTIONS(4539),
    [sym_xint] = ACTIONS(4541),
    [anon_sym_LPAREN_STAR] = ACTIONS(27),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2722] = {
    [sym_block_comment] = STATE(2722),
    [sym_compiler_directive_decl] = STATE(2722),
    [sym_fsi_directive_decl] = STATE(2722),
    [sym_preproc_line] = STATE(2722),
    [sym_identifier] = ACTIONS(2462),
    [anon_sym_GT_RBRACK] = ACTIONS(2464),
    [anon_sym_return] = ACTIONS(2462),
    [anon_sym_do] = ACTIONS(2462),
    [anon_sym_let] = ACTIONS(2462),
    [anon_sym_let_BANG] = ACTIONS(2464),
    [anon_sym_LPAREN] = ACTIONS(2462),
    [anon_sym_null] = ACTIONS(2462),
    [anon_sym_AMP] = ACTIONS(2462),
    [anon_sym_LBRACK] = ACTIONS(2462),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2464),
    [anon_sym_LBRACE] = ACTIONS(2462),
    [anon_sym_LT_AT] = ACTIONS(2462),
    [anon_sym_LT_AT_AT] = ACTIONS(2464),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2464),
    [anon_sym_new] = ACTIONS(2462),
    [anon_sym_return_BANG] = ACTIONS(2464),
    [anon_sym_yield] = ACTIONS(2462),
    [anon_sym_yield_BANG] = ACTIONS(2464),
    [anon_sym_lazy] = ACTIONS(2462),
    [anon_sym_assert] = ACTIONS(2462),
    [anon_sym_upcast] = ACTIONS(2462),
    [anon_sym_downcast] = ACTIONS(2462),
    [anon_sym_COLON_GT] = ACTIONS(2464),
    [anon_sym_for] = ACTIONS(2462),
    [anon_sym_while] = ACTIONS(2462),
    [anon_sym_if] = ACTIONS(2462),
    [anon_sym_fun] = ACTIONS(2462),
    [anon_sym_DASH_GT] = ACTIONS(2464),
    [anon_sym_try] = ACTIONS(2462),
    [anon_sym_match] = ACTIONS(2462),
    [anon_sym_match_BANG] = ACTIONS(2464),
    [anon_sym_function] = ACTIONS(2462),
    [anon_sym_use] = ACTIONS(2462),
    [anon_sym_use_BANG] = ACTIONS(2464),
    [anon_sym_do_BANG] = ACTIONS(2464),
    [anon_sym_begin] = ACTIONS(2462),
    [anon_sym_STAR] = ACTIONS(2464),
    [anon_sym_LT2] = ACTIONS(2462),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2464),
    [anon_sym_or] = ACTIONS(2462),
    [aux_sym_char_token1] = ACTIONS(2464),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2462),
    [anon_sym_DQUOTE] = ACTIONS(2462),
    [anon_sym_AT_DQUOTE] = ACTIONS(2464),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2464),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2464),
    [sym_bool] = ACTIONS(2462),
    [sym_unit] = ACTIONS(2464),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2462),
    [sym_op_identifier] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2462),
    [anon_sym_DASH] = ACTIONS(2462),
    [anon_sym_PLUS_DOT] = ACTIONS(2464),
    [anon_sym_DASH_DOT] = ACTIONS(2464),
    [anon_sym_PERCENT] = ACTIONS(2464),
    [anon_sym_AMP_AMP] = ACTIONS(2464),
    [anon_sym_TILDE] = ACTIONS(2464),
    [aux_sym_prefix_op_token1] = ACTIONS(2464),
    [sym_int] = ACTIONS(2462),
    [sym_xint] = ACTIONS(2464),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2464),
    [sym__newline] = ACTIONS(2464),
  },
  [2723] = {
    [sym__type] = STATE(5002),
    [sym_simple_type] = STATE(5109),
    [sym_generic_type] = STATE(5109),
    [sym_paren_type] = STATE(5109),
    [sym_function_type] = STATE(5109),
    [sym_compound_type] = STATE(5109),
    [sym_postfix_type] = STATE(5109),
    [sym_list_type] = STATE(5109),
    [sym_static_type] = STATE(5109),
    [sym_constrained_type] = STATE(5109),
    [sym_flexible_type] = STATE(5109),
    [sym_anon_record_type] = STATE(5109),
    [sym__static_type_identifier] = STATE(4686),
    [sym__static_parameter] = STATE(6029),
    [sym_named_static_parameter] = STATE(6034),
    [sym_type_attribute] = STATE(5982),
    [sym_type_attributes] = STATE(6628),
    [sym_type_argument] = STATE(4913),
    [sym_static_parameter_value] = STATE(6034),
    [sym_char] = STATE(2803),
    [sym_format_string] = STATE(2805),
    [sym__string_literal] = STATE(2805),
    [sym_string] = STATE(2803),
    [sym_verbatim_string] = STATE(2803),
    [sym_bytearray] = STATE(2803),
    [sym_verbatim_bytearray] = STATE(2803),
    [sym_format_triple_quoted_string] = STATE(2809),
    [sym_triple_quoted_string] = STATE(2803),
    [sym_const] = STATE(432),
    [sym_long_identifier] = STATE(5121),
    [sym_sbyte] = STATE(2803),
    [sym_byte] = STATE(2803),
    [sym_int16] = STATE(2803),
    [sym_uint16] = STATE(2803),
    [sym_int32] = STATE(2803),
    [sym_uint32] = STATE(2803),
    [sym_nativeint] = STATE(2803),
    [sym_unativeint] = STATE(2803),
    [sym_int64] = STATE(2803),
    [sym_uint64] = STATE(2803),
    [sym_ieee32] = STATE(2803),
    [sym_ieee64] = STATE(2803),
    [sym_bignum] = STATE(2803),
    [sym_decimal] = STATE(2803),
    [sym_float] = STATE(2793),
    [sym_block_comment] = STATE(2723),
    [sym_compiler_directive_decl] = STATE(2723),
    [sym_fsi_directive_decl] = STATE(2723),
    [sym_preproc_line] = STATE(2723),
    [sym_identifier] = ACTIONS(4509),
    [anon_sym_LPAREN] = ACTIONS(4511),
    [anon_sym__] = ACTIONS(4513),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4515),
    [anon_sym_GT] = ACTIONS(4555),
    [anon_sym_POUND] = ACTIONS(4519),
    [anon_sym_CARET] = ACTIONS(4521),
    [anon_sym_SQUOTE] = ACTIONS(4521),
    [aux_sym_char_token1] = ACTIONS(4523),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4525),
    [anon_sym_DQUOTE] = ACTIONS(4527),
    [anon_sym_AT_DQUOTE] = ACTIONS(4529),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4531),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4533),
    [sym_bool] = ACTIONS(4535),
    [sym_unit] = ACTIONS(4537),
    [sym_int] = ACTIONS(4539),
    [sym_xint] = ACTIONS(4541),
    [anon_sym_LPAREN_STAR] = ACTIONS(27),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2724] = {
    [sym__type] = STATE(5002),
    [sym_simple_type] = STATE(5109),
    [sym_generic_type] = STATE(5109),
    [sym_paren_type] = STATE(5109),
    [sym_function_type] = STATE(5109),
    [sym_compound_type] = STATE(5109),
    [sym_postfix_type] = STATE(5109),
    [sym_list_type] = STATE(5109),
    [sym_static_type] = STATE(5109),
    [sym_constrained_type] = STATE(5109),
    [sym_flexible_type] = STATE(5109),
    [sym_anon_record_type] = STATE(5109),
    [sym__static_type_identifier] = STATE(4686),
    [sym__static_parameter] = STATE(6029),
    [sym_named_static_parameter] = STATE(6034),
    [sym_type_attribute] = STATE(5982),
    [sym_type_attributes] = STATE(6865),
    [sym_type_argument] = STATE(4913),
    [sym_static_parameter_value] = STATE(6034),
    [sym_char] = STATE(2803),
    [sym_format_string] = STATE(2805),
    [sym__string_literal] = STATE(2805),
    [sym_string] = STATE(2803),
    [sym_verbatim_string] = STATE(2803),
    [sym_bytearray] = STATE(2803),
    [sym_verbatim_bytearray] = STATE(2803),
    [sym_format_triple_quoted_string] = STATE(2809),
    [sym_triple_quoted_string] = STATE(2803),
    [sym_const] = STATE(432),
    [sym_long_identifier] = STATE(5121),
    [sym_sbyte] = STATE(2803),
    [sym_byte] = STATE(2803),
    [sym_int16] = STATE(2803),
    [sym_uint16] = STATE(2803),
    [sym_int32] = STATE(2803),
    [sym_uint32] = STATE(2803),
    [sym_nativeint] = STATE(2803),
    [sym_unativeint] = STATE(2803),
    [sym_int64] = STATE(2803),
    [sym_uint64] = STATE(2803),
    [sym_ieee32] = STATE(2803),
    [sym_ieee64] = STATE(2803),
    [sym_bignum] = STATE(2803),
    [sym_decimal] = STATE(2803),
    [sym_float] = STATE(2793),
    [sym_block_comment] = STATE(2724),
    [sym_compiler_directive_decl] = STATE(2724),
    [sym_fsi_directive_decl] = STATE(2724),
    [sym_preproc_line] = STATE(2724),
    [sym_identifier] = ACTIONS(4509),
    [anon_sym_LPAREN] = ACTIONS(4511),
    [anon_sym__] = ACTIONS(4513),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4515),
    [anon_sym_GT] = ACTIONS(4557),
    [anon_sym_POUND] = ACTIONS(4519),
    [anon_sym_CARET] = ACTIONS(4521),
    [anon_sym_SQUOTE] = ACTIONS(4521),
    [aux_sym_char_token1] = ACTIONS(4523),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4525),
    [anon_sym_DQUOTE] = ACTIONS(4527),
    [anon_sym_AT_DQUOTE] = ACTIONS(4529),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4531),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4533),
    [sym_bool] = ACTIONS(4535),
    [sym_unit] = ACTIONS(4537),
    [sym_int] = ACTIONS(4539),
    [sym_xint] = ACTIONS(4541),
    [anon_sym_LPAREN_STAR] = ACTIONS(27),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2725] = {
    [sym__type] = STATE(5002),
    [sym_simple_type] = STATE(5109),
    [sym_generic_type] = STATE(5109),
    [sym_paren_type] = STATE(5109),
    [sym_function_type] = STATE(5109),
    [sym_compound_type] = STATE(5109),
    [sym_postfix_type] = STATE(5109),
    [sym_list_type] = STATE(5109),
    [sym_static_type] = STATE(5109),
    [sym_constrained_type] = STATE(5109),
    [sym_flexible_type] = STATE(5109),
    [sym_anon_record_type] = STATE(5109),
    [sym__static_type_identifier] = STATE(4686),
    [sym__static_parameter] = STATE(6029),
    [sym_named_static_parameter] = STATE(6034),
    [sym_type_attribute] = STATE(5982),
    [sym_type_attributes] = STATE(7130),
    [sym_type_argument] = STATE(4913),
    [sym_static_parameter_value] = STATE(6034),
    [sym_char] = STATE(2803),
    [sym_format_string] = STATE(2805),
    [sym__string_literal] = STATE(2805),
    [sym_string] = STATE(2803),
    [sym_verbatim_string] = STATE(2803),
    [sym_bytearray] = STATE(2803),
    [sym_verbatim_bytearray] = STATE(2803),
    [sym_format_triple_quoted_string] = STATE(2809),
    [sym_triple_quoted_string] = STATE(2803),
    [sym_const] = STATE(432),
    [sym_long_identifier] = STATE(5121),
    [sym_sbyte] = STATE(2803),
    [sym_byte] = STATE(2803),
    [sym_int16] = STATE(2803),
    [sym_uint16] = STATE(2803),
    [sym_int32] = STATE(2803),
    [sym_uint32] = STATE(2803),
    [sym_nativeint] = STATE(2803),
    [sym_unativeint] = STATE(2803),
    [sym_int64] = STATE(2803),
    [sym_uint64] = STATE(2803),
    [sym_ieee32] = STATE(2803),
    [sym_ieee64] = STATE(2803),
    [sym_bignum] = STATE(2803),
    [sym_decimal] = STATE(2803),
    [sym_float] = STATE(2793),
    [sym_block_comment] = STATE(2725),
    [sym_compiler_directive_decl] = STATE(2725),
    [sym_fsi_directive_decl] = STATE(2725),
    [sym_preproc_line] = STATE(2725),
    [sym_identifier] = ACTIONS(4509),
    [anon_sym_LPAREN] = ACTIONS(4511),
    [anon_sym__] = ACTIONS(4513),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4515),
    [anon_sym_GT] = ACTIONS(4559),
    [anon_sym_POUND] = ACTIONS(4519),
    [anon_sym_CARET] = ACTIONS(4521),
    [anon_sym_SQUOTE] = ACTIONS(4521),
    [aux_sym_char_token1] = ACTIONS(4523),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4525),
    [anon_sym_DQUOTE] = ACTIONS(4527),
    [anon_sym_AT_DQUOTE] = ACTIONS(4529),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4531),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4533),
    [sym_bool] = ACTIONS(4535),
    [sym_unit] = ACTIONS(4537),
    [sym_int] = ACTIONS(4539),
    [sym_xint] = ACTIONS(4541),
    [anon_sym_LPAREN_STAR] = ACTIONS(27),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2726] = {
    [sym__type] = STATE(5002),
    [sym_simple_type] = STATE(5109),
    [sym_generic_type] = STATE(5109),
    [sym_paren_type] = STATE(5109),
    [sym_function_type] = STATE(5109),
    [sym_compound_type] = STATE(5109),
    [sym_postfix_type] = STATE(5109),
    [sym_list_type] = STATE(5109),
    [sym_static_type] = STATE(5109),
    [sym_constrained_type] = STATE(5109),
    [sym_flexible_type] = STATE(5109),
    [sym_anon_record_type] = STATE(5109),
    [sym__static_type_identifier] = STATE(4686),
    [sym__static_parameter] = STATE(6029),
    [sym_named_static_parameter] = STATE(6034),
    [sym_type_attribute] = STATE(5982),
    [sym_type_attributes] = STATE(7453),
    [sym_type_argument] = STATE(4913),
    [sym_static_parameter_value] = STATE(6034),
    [sym_char] = STATE(2803),
    [sym_format_string] = STATE(2805),
    [sym__string_literal] = STATE(2805),
    [sym_string] = STATE(2803),
    [sym_verbatim_string] = STATE(2803),
    [sym_bytearray] = STATE(2803),
    [sym_verbatim_bytearray] = STATE(2803),
    [sym_format_triple_quoted_string] = STATE(2809),
    [sym_triple_quoted_string] = STATE(2803),
    [sym_const] = STATE(432),
    [sym_long_identifier] = STATE(5121),
    [sym_sbyte] = STATE(2803),
    [sym_byte] = STATE(2803),
    [sym_int16] = STATE(2803),
    [sym_uint16] = STATE(2803),
    [sym_int32] = STATE(2803),
    [sym_uint32] = STATE(2803),
    [sym_nativeint] = STATE(2803),
    [sym_unativeint] = STATE(2803),
    [sym_int64] = STATE(2803),
    [sym_uint64] = STATE(2803),
    [sym_ieee32] = STATE(2803),
    [sym_ieee64] = STATE(2803),
    [sym_bignum] = STATE(2803),
    [sym_decimal] = STATE(2803),
    [sym_float] = STATE(2793),
    [sym_block_comment] = STATE(2726),
    [sym_compiler_directive_decl] = STATE(2726),
    [sym_fsi_directive_decl] = STATE(2726),
    [sym_preproc_line] = STATE(2726),
    [sym_identifier] = ACTIONS(4509),
    [anon_sym_LPAREN] = ACTIONS(4511),
    [anon_sym__] = ACTIONS(4513),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4515),
    [anon_sym_GT] = ACTIONS(4561),
    [anon_sym_POUND] = ACTIONS(4519),
    [anon_sym_CARET] = ACTIONS(4521),
    [anon_sym_SQUOTE] = ACTIONS(4521),
    [aux_sym_char_token1] = ACTIONS(4523),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4525),
    [anon_sym_DQUOTE] = ACTIONS(4527),
    [anon_sym_AT_DQUOTE] = ACTIONS(4529),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4531),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4533),
    [sym_bool] = ACTIONS(4535),
    [sym_unit] = ACTIONS(4537),
    [sym_int] = ACTIONS(4539),
    [sym_xint] = ACTIONS(4541),
    [anon_sym_LPAREN_STAR] = ACTIONS(27),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2727] = {
    [sym__type] = STATE(5002),
    [sym_simple_type] = STATE(5109),
    [sym_generic_type] = STATE(5109),
    [sym_paren_type] = STATE(5109),
    [sym_function_type] = STATE(5109),
    [sym_compound_type] = STATE(5109),
    [sym_postfix_type] = STATE(5109),
    [sym_list_type] = STATE(5109),
    [sym_static_type] = STATE(5109),
    [sym_constrained_type] = STATE(5109),
    [sym_flexible_type] = STATE(5109),
    [sym_anon_record_type] = STATE(5109),
    [sym__static_type_identifier] = STATE(4686),
    [sym__static_parameter] = STATE(6029),
    [sym_named_static_parameter] = STATE(6034),
    [sym_type_attribute] = STATE(5982),
    [sym_type_attributes] = STATE(6786),
    [sym_type_argument] = STATE(4913),
    [sym_static_parameter_value] = STATE(6034),
    [sym_char] = STATE(2803),
    [sym_format_string] = STATE(2805),
    [sym__string_literal] = STATE(2805),
    [sym_string] = STATE(2803),
    [sym_verbatim_string] = STATE(2803),
    [sym_bytearray] = STATE(2803),
    [sym_verbatim_bytearray] = STATE(2803),
    [sym_format_triple_quoted_string] = STATE(2809),
    [sym_triple_quoted_string] = STATE(2803),
    [sym_const] = STATE(432),
    [sym_long_identifier] = STATE(5121),
    [sym_sbyte] = STATE(2803),
    [sym_byte] = STATE(2803),
    [sym_int16] = STATE(2803),
    [sym_uint16] = STATE(2803),
    [sym_int32] = STATE(2803),
    [sym_uint32] = STATE(2803),
    [sym_nativeint] = STATE(2803),
    [sym_unativeint] = STATE(2803),
    [sym_int64] = STATE(2803),
    [sym_uint64] = STATE(2803),
    [sym_ieee32] = STATE(2803),
    [sym_ieee64] = STATE(2803),
    [sym_bignum] = STATE(2803),
    [sym_decimal] = STATE(2803),
    [sym_float] = STATE(2793),
    [sym_block_comment] = STATE(2727),
    [sym_compiler_directive_decl] = STATE(2727),
    [sym_fsi_directive_decl] = STATE(2727),
    [sym_preproc_line] = STATE(2727),
    [sym_identifier] = ACTIONS(4509),
    [anon_sym_LPAREN] = ACTIONS(4511),
    [anon_sym__] = ACTIONS(4513),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4515),
    [anon_sym_GT] = ACTIONS(4563),
    [anon_sym_POUND] = ACTIONS(4519),
    [anon_sym_CARET] = ACTIONS(4521),
    [anon_sym_SQUOTE] = ACTIONS(4521),
    [aux_sym_char_token1] = ACTIONS(4523),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4525),
    [anon_sym_DQUOTE] = ACTIONS(4527),
    [anon_sym_AT_DQUOTE] = ACTIONS(4529),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4531),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4533),
    [sym_bool] = ACTIONS(4535),
    [sym_unit] = ACTIONS(4537),
    [sym_int] = ACTIONS(4539),
    [sym_xint] = ACTIONS(4541),
    [anon_sym_LPAREN_STAR] = ACTIONS(27),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2728] = {
    [sym__type] = STATE(5002),
    [sym_simple_type] = STATE(5109),
    [sym_generic_type] = STATE(5109),
    [sym_paren_type] = STATE(5109),
    [sym_function_type] = STATE(5109),
    [sym_compound_type] = STATE(5109),
    [sym_postfix_type] = STATE(5109),
    [sym_list_type] = STATE(5109),
    [sym_static_type] = STATE(5109),
    [sym_constrained_type] = STATE(5109),
    [sym_flexible_type] = STATE(5109),
    [sym_anon_record_type] = STATE(5109),
    [sym__static_type_identifier] = STATE(4686),
    [sym__static_parameter] = STATE(6029),
    [sym_named_static_parameter] = STATE(6034),
    [sym_type_attribute] = STATE(5982),
    [sym_type_attributes] = STATE(7540),
    [sym_type_argument] = STATE(4913),
    [sym_static_parameter_value] = STATE(6034),
    [sym_char] = STATE(2803),
    [sym_format_string] = STATE(2805),
    [sym__string_literal] = STATE(2805),
    [sym_string] = STATE(2803),
    [sym_verbatim_string] = STATE(2803),
    [sym_bytearray] = STATE(2803),
    [sym_verbatim_bytearray] = STATE(2803),
    [sym_format_triple_quoted_string] = STATE(2809),
    [sym_triple_quoted_string] = STATE(2803),
    [sym_const] = STATE(432),
    [sym_long_identifier] = STATE(5121),
    [sym_sbyte] = STATE(2803),
    [sym_byte] = STATE(2803),
    [sym_int16] = STATE(2803),
    [sym_uint16] = STATE(2803),
    [sym_int32] = STATE(2803),
    [sym_uint32] = STATE(2803),
    [sym_nativeint] = STATE(2803),
    [sym_unativeint] = STATE(2803),
    [sym_int64] = STATE(2803),
    [sym_uint64] = STATE(2803),
    [sym_ieee32] = STATE(2803),
    [sym_ieee64] = STATE(2803),
    [sym_bignum] = STATE(2803),
    [sym_decimal] = STATE(2803),
    [sym_float] = STATE(2793),
    [sym_block_comment] = STATE(2728),
    [sym_compiler_directive_decl] = STATE(2728),
    [sym_fsi_directive_decl] = STATE(2728),
    [sym_preproc_line] = STATE(2728),
    [sym_identifier] = ACTIONS(4509),
    [anon_sym_LPAREN] = ACTIONS(4511),
    [anon_sym__] = ACTIONS(4513),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4515),
    [anon_sym_GT] = ACTIONS(4565),
    [anon_sym_POUND] = ACTIONS(4519),
    [anon_sym_CARET] = ACTIONS(4521),
    [anon_sym_SQUOTE] = ACTIONS(4521),
    [aux_sym_char_token1] = ACTIONS(4523),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4525),
    [anon_sym_DQUOTE] = ACTIONS(4527),
    [anon_sym_AT_DQUOTE] = ACTIONS(4529),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4531),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4533),
    [sym_bool] = ACTIONS(4535),
    [sym_unit] = ACTIONS(4537),
    [sym_int] = ACTIONS(4539),
    [sym_xint] = ACTIONS(4541),
    [anon_sym_LPAREN_STAR] = ACTIONS(27),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2729] = {
    [sym__type] = STATE(5002),
    [sym_simple_type] = STATE(5109),
    [sym_generic_type] = STATE(5109),
    [sym_paren_type] = STATE(5109),
    [sym_function_type] = STATE(5109),
    [sym_compound_type] = STATE(5109),
    [sym_postfix_type] = STATE(5109),
    [sym_list_type] = STATE(5109),
    [sym_static_type] = STATE(5109),
    [sym_constrained_type] = STATE(5109),
    [sym_flexible_type] = STATE(5109),
    [sym_anon_record_type] = STATE(5109),
    [sym__static_type_identifier] = STATE(4686),
    [sym__static_parameter] = STATE(6029),
    [sym_named_static_parameter] = STATE(6034),
    [sym_type_attribute] = STATE(5982),
    [sym_type_attributes] = STATE(6741),
    [sym_type_argument] = STATE(4913),
    [sym_static_parameter_value] = STATE(6034),
    [sym_char] = STATE(2803),
    [sym_format_string] = STATE(2805),
    [sym__string_literal] = STATE(2805),
    [sym_string] = STATE(2803),
    [sym_verbatim_string] = STATE(2803),
    [sym_bytearray] = STATE(2803),
    [sym_verbatim_bytearray] = STATE(2803),
    [sym_format_triple_quoted_string] = STATE(2809),
    [sym_triple_quoted_string] = STATE(2803),
    [sym_const] = STATE(432),
    [sym_long_identifier] = STATE(5121),
    [sym_sbyte] = STATE(2803),
    [sym_byte] = STATE(2803),
    [sym_int16] = STATE(2803),
    [sym_uint16] = STATE(2803),
    [sym_int32] = STATE(2803),
    [sym_uint32] = STATE(2803),
    [sym_nativeint] = STATE(2803),
    [sym_unativeint] = STATE(2803),
    [sym_int64] = STATE(2803),
    [sym_uint64] = STATE(2803),
    [sym_ieee32] = STATE(2803),
    [sym_ieee64] = STATE(2803),
    [sym_bignum] = STATE(2803),
    [sym_decimal] = STATE(2803),
    [sym_float] = STATE(2793),
    [sym_block_comment] = STATE(2729),
    [sym_compiler_directive_decl] = STATE(2729),
    [sym_fsi_directive_decl] = STATE(2729),
    [sym_preproc_line] = STATE(2729),
    [sym_identifier] = ACTIONS(4509),
    [anon_sym_LPAREN] = ACTIONS(4511),
    [anon_sym__] = ACTIONS(4513),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4515),
    [anon_sym_GT] = ACTIONS(4567),
    [anon_sym_POUND] = ACTIONS(4519),
    [anon_sym_CARET] = ACTIONS(4521),
    [anon_sym_SQUOTE] = ACTIONS(4521),
    [aux_sym_char_token1] = ACTIONS(4523),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4525),
    [anon_sym_DQUOTE] = ACTIONS(4527),
    [anon_sym_AT_DQUOTE] = ACTIONS(4529),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4531),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4533),
    [sym_bool] = ACTIONS(4535),
    [sym_unit] = ACTIONS(4537),
    [sym_int] = ACTIONS(4539),
    [sym_xint] = ACTIONS(4541),
    [anon_sym_LPAREN_STAR] = ACTIONS(27),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2730] = {
    [sym__type] = STATE(5002),
    [sym_simple_type] = STATE(5109),
    [sym_generic_type] = STATE(5109),
    [sym_paren_type] = STATE(5109),
    [sym_function_type] = STATE(5109),
    [sym_compound_type] = STATE(5109),
    [sym_postfix_type] = STATE(5109),
    [sym_list_type] = STATE(5109),
    [sym_static_type] = STATE(5109),
    [sym_constrained_type] = STATE(5109),
    [sym_flexible_type] = STATE(5109),
    [sym_anon_record_type] = STATE(5109),
    [sym__static_type_identifier] = STATE(4686),
    [sym__static_parameter] = STATE(6029),
    [sym_named_static_parameter] = STATE(6034),
    [sym_type_attribute] = STATE(5982),
    [sym_type_attributes] = STATE(6686),
    [sym_type_argument] = STATE(4913),
    [sym_static_parameter_value] = STATE(6034),
    [sym_char] = STATE(2803),
    [sym_format_string] = STATE(2805),
    [sym__string_literal] = STATE(2805),
    [sym_string] = STATE(2803),
    [sym_verbatim_string] = STATE(2803),
    [sym_bytearray] = STATE(2803),
    [sym_verbatim_bytearray] = STATE(2803),
    [sym_format_triple_quoted_string] = STATE(2809),
    [sym_triple_quoted_string] = STATE(2803),
    [sym_const] = STATE(432),
    [sym_long_identifier] = STATE(5121),
    [sym_sbyte] = STATE(2803),
    [sym_byte] = STATE(2803),
    [sym_int16] = STATE(2803),
    [sym_uint16] = STATE(2803),
    [sym_int32] = STATE(2803),
    [sym_uint32] = STATE(2803),
    [sym_nativeint] = STATE(2803),
    [sym_unativeint] = STATE(2803),
    [sym_int64] = STATE(2803),
    [sym_uint64] = STATE(2803),
    [sym_ieee32] = STATE(2803),
    [sym_ieee64] = STATE(2803),
    [sym_bignum] = STATE(2803),
    [sym_decimal] = STATE(2803),
    [sym_float] = STATE(2793),
    [sym_block_comment] = STATE(2730),
    [sym_compiler_directive_decl] = STATE(2730),
    [sym_fsi_directive_decl] = STATE(2730),
    [sym_preproc_line] = STATE(2730),
    [sym_identifier] = ACTIONS(4509),
    [anon_sym_LPAREN] = ACTIONS(4511),
    [anon_sym__] = ACTIONS(4513),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4515),
    [anon_sym_GT] = ACTIONS(4569),
    [anon_sym_POUND] = ACTIONS(4519),
    [anon_sym_CARET] = ACTIONS(4521),
    [anon_sym_SQUOTE] = ACTIONS(4521),
    [aux_sym_char_token1] = ACTIONS(4523),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4525),
    [anon_sym_DQUOTE] = ACTIONS(4527),
    [anon_sym_AT_DQUOTE] = ACTIONS(4529),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4531),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4533),
    [sym_bool] = ACTIONS(4535),
    [sym_unit] = ACTIONS(4537),
    [sym_int] = ACTIONS(4539),
    [sym_xint] = ACTIONS(4541),
    [anon_sym_LPAREN_STAR] = ACTIONS(27),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2731] = {
    [sym__type] = STATE(5002),
    [sym_simple_type] = STATE(5109),
    [sym_generic_type] = STATE(5109),
    [sym_paren_type] = STATE(5109),
    [sym_function_type] = STATE(5109),
    [sym_compound_type] = STATE(5109),
    [sym_postfix_type] = STATE(5109),
    [sym_list_type] = STATE(5109),
    [sym_static_type] = STATE(5109),
    [sym_constrained_type] = STATE(5109),
    [sym_flexible_type] = STATE(5109),
    [sym_anon_record_type] = STATE(5109),
    [sym__static_type_identifier] = STATE(4686),
    [sym__static_parameter] = STATE(6029),
    [sym_named_static_parameter] = STATE(6034),
    [sym_type_attribute] = STATE(5982),
    [sym_type_attributes] = STATE(7413),
    [sym_type_argument] = STATE(4913),
    [sym_static_parameter_value] = STATE(6034),
    [sym_char] = STATE(2803),
    [sym_format_string] = STATE(2805),
    [sym__string_literal] = STATE(2805),
    [sym_string] = STATE(2803),
    [sym_verbatim_string] = STATE(2803),
    [sym_bytearray] = STATE(2803),
    [sym_verbatim_bytearray] = STATE(2803),
    [sym_format_triple_quoted_string] = STATE(2809),
    [sym_triple_quoted_string] = STATE(2803),
    [sym_const] = STATE(432),
    [sym_long_identifier] = STATE(5121),
    [sym_sbyte] = STATE(2803),
    [sym_byte] = STATE(2803),
    [sym_int16] = STATE(2803),
    [sym_uint16] = STATE(2803),
    [sym_int32] = STATE(2803),
    [sym_uint32] = STATE(2803),
    [sym_nativeint] = STATE(2803),
    [sym_unativeint] = STATE(2803),
    [sym_int64] = STATE(2803),
    [sym_uint64] = STATE(2803),
    [sym_ieee32] = STATE(2803),
    [sym_ieee64] = STATE(2803),
    [sym_bignum] = STATE(2803),
    [sym_decimal] = STATE(2803),
    [sym_float] = STATE(2793),
    [sym_block_comment] = STATE(2731),
    [sym_compiler_directive_decl] = STATE(2731),
    [sym_fsi_directive_decl] = STATE(2731),
    [sym_preproc_line] = STATE(2731),
    [sym_identifier] = ACTIONS(4509),
    [anon_sym_LPAREN] = ACTIONS(4511),
    [anon_sym__] = ACTIONS(4513),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4515),
    [anon_sym_GT] = ACTIONS(4571),
    [anon_sym_POUND] = ACTIONS(4519),
    [anon_sym_CARET] = ACTIONS(4521),
    [anon_sym_SQUOTE] = ACTIONS(4521),
    [aux_sym_char_token1] = ACTIONS(4523),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4525),
    [anon_sym_DQUOTE] = ACTIONS(4527),
    [anon_sym_AT_DQUOTE] = ACTIONS(4529),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4531),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4533),
    [sym_bool] = ACTIONS(4535),
    [sym_unit] = ACTIONS(4537),
    [sym_int] = ACTIONS(4539),
    [sym_xint] = ACTIONS(4541),
    [anon_sym_LPAREN_STAR] = ACTIONS(27),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2732] = {
    [sym__type] = STATE(5002),
    [sym_simple_type] = STATE(5109),
    [sym_generic_type] = STATE(5109),
    [sym_paren_type] = STATE(5109),
    [sym_function_type] = STATE(5109),
    [sym_compound_type] = STATE(5109),
    [sym_postfix_type] = STATE(5109),
    [sym_list_type] = STATE(5109),
    [sym_static_type] = STATE(5109),
    [sym_constrained_type] = STATE(5109),
    [sym_flexible_type] = STATE(5109),
    [sym_anon_record_type] = STATE(5109),
    [sym__static_type_identifier] = STATE(4686),
    [sym__static_parameter] = STATE(6029),
    [sym_named_static_parameter] = STATE(6034),
    [sym_type_attribute] = STATE(5982),
    [sym_type_attributes] = STATE(6932),
    [sym_type_argument] = STATE(4913),
    [sym_static_parameter_value] = STATE(6034),
    [sym_char] = STATE(2803),
    [sym_format_string] = STATE(2805),
    [sym__string_literal] = STATE(2805),
    [sym_string] = STATE(2803),
    [sym_verbatim_string] = STATE(2803),
    [sym_bytearray] = STATE(2803),
    [sym_verbatim_bytearray] = STATE(2803),
    [sym_format_triple_quoted_string] = STATE(2809),
    [sym_triple_quoted_string] = STATE(2803),
    [sym_const] = STATE(432),
    [sym_long_identifier] = STATE(5121),
    [sym_sbyte] = STATE(2803),
    [sym_byte] = STATE(2803),
    [sym_int16] = STATE(2803),
    [sym_uint16] = STATE(2803),
    [sym_int32] = STATE(2803),
    [sym_uint32] = STATE(2803),
    [sym_nativeint] = STATE(2803),
    [sym_unativeint] = STATE(2803),
    [sym_int64] = STATE(2803),
    [sym_uint64] = STATE(2803),
    [sym_ieee32] = STATE(2803),
    [sym_ieee64] = STATE(2803),
    [sym_bignum] = STATE(2803),
    [sym_decimal] = STATE(2803),
    [sym_float] = STATE(2793),
    [sym_block_comment] = STATE(2732),
    [sym_compiler_directive_decl] = STATE(2732),
    [sym_fsi_directive_decl] = STATE(2732),
    [sym_preproc_line] = STATE(2732),
    [sym_identifier] = ACTIONS(4509),
    [anon_sym_LPAREN] = ACTIONS(4511),
    [anon_sym__] = ACTIONS(4513),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4515),
    [anon_sym_GT] = ACTIONS(4573),
    [anon_sym_POUND] = ACTIONS(4519),
    [anon_sym_CARET] = ACTIONS(4521),
    [anon_sym_SQUOTE] = ACTIONS(4521),
    [aux_sym_char_token1] = ACTIONS(4523),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4525),
    [anon_sym_DQUOTE] = ACTIONS(4527),
    [anon_sym_AT_DQUOTE] = ACTIONS(4529),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4531),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4533),
    [sym_bool] = ACTIONS(4535),
    [sym_unit] = ACTIONS(4537),
    [sym_int] = ACTIONS(4539),
    [sym_xint] = ACTIONS(4541),
    [anon_sym_LPAREN_STAR] = ACTIONS(27),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2733] = {
    [sym__type] = STATE(5002),
    [sym_simple_type] = STATE(5109),
    [sym_generic_type] = STATE(5109),
    [sym_paren_type] = STATE(5109),
    [sym_function_type] = STATE(5109),
    [sym_compound_type] = STATE(5109),
    [sym_postfix_type] = STATE(5109),
    [sym_list_type] = STATE(5109),
    [sym_static_type] = STATE(5109),
    [sym_constrained_type] = STATE(5109),
    [sym_flexible_type] = STATE(5109),
    [sym_anon_record_type] = STATE(5109),
    [sym__static_type_identifier] = STATE(4686),
    [sym__static_parameter] = STATE(6029),
    [sym_named_static_parameter] = STATE(6034),
    [sym_type_attribute] = STATE(5982),
    [sym_type_attributes] = STATE(6896),
    [sym_type_argument] = STATE(4913),
    [sym_static_parameter_value] = STATE(6034),
    [sym_char] = STATE(2803),
    [sym_format_string] = STATE(2805),
    [sym__string_literal] = STATE(2805),
    [sym_string] = STATE(2803),
    [sym_verbatim_string] = STATE(2803),
    [sym_bytearray] = STATE(2803),
    [sym_verbatim_bytearray] = STATE(2803),
    [sym_format_triple_quoted_string] = STATE(2809),
    [sym_triple_quoted_string] = STATE(2803),
    [sym_const] = STATE(432),
    [sym_long_identifier] = STATE(5121),
    [sym_sbyte] = STATE(2803),
    [sym_byte] = STATE(2803),
    [sym_int16] = STATE(2803),
    [sym_uint16] = STATE(2803),
    [sym_int32] = STATE(2803),
    [sym_uint32] = STATE(2803),
    [sym_nativeint] = STATE(2803),
    [sym_unativeint] = STATE(2803),
    [sym_int64] = STATE(2803),
    [sym_uint64] = STATE(2803),
    [sym_ieee32] = STATE(2803),
    [sym_ieee64] = STATE(2803),
    [sym_bignum] = STATE(2803),
    [sym_decimal] = STATE(2803),
    [sym_float] = STATE(2793),
    [sym_block_comment] = STATE(2733),
    [sym_compiler_directive_decl] = STATE(2733),
    [sym_fsi_directive_decl] = STATE(2733),
    [sym_preproc_line] = STATE(2733),
    [sym_identifier] = ACTIONS(4509),
    [anon_sym_LPAREN] = ACTIONS(4511),
    [anon_sym__] = ACTIONS(4513),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4515),
    [anon_sym_GT] = ACTIONS(4575),
    [anon_sym_POUND] = ACTIONS(4519),
    [anon_sym_CARET] = ACTIONS(4521),
    [anon_sym_SQUOTE] = ACTIONS(4521),
    [aux_sym_char_token1] = ACTIONS(4523),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4525),
    [anon_sym_DQUOTE] = ACTIONS(4527),
    [anon_sym_AT_DQUOTE] = ACTIONS(4529),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4531),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4533),
    [sym_bool] = ACTIONS(4535),
    [sym_unit] = ACTIONS(4537),
    [sym_int] = ACTIONS(4539),
    [sym_xint] = ACTIONS(4541),
    [anon_sym_LPAREN_STAR] = ACTIONS(27),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2734] = {
    [sym__type] = STATE(5002),
    [sym_simple_type] = STATE(5109),
    [sym_generic_type] = STATE(5109),
    [sym_paren_type] = STATE(5109),
    [sym_function_type] = STATE(5109),
    [sym_compound_type] = STATE(5109),
    [sym_postfix_type] = STATE(5109),
    [sym_list_type] = STATE(5109),
    [sym_static_type] = STATE(5109),
    [sym_constrained_type] = STATE(5109),
    [sym_flexible_type] = STATE(5109),
    [sym_anon_record_type] = STATE(5109),
    [sym__static_type_identifier] = STATE(4686),
    [sym__static_parameter] = STATE(6029),
    [sym_named_static_parameter] = STATE(6034),
    [sym_type_attribute] = STATE(5982),
    [sym_type_attributes] = STATE(7255),
    [sym_type_argument] = STATE(4913),
    [sym_static_parameter_value] = STATE(6034),
    [sym_char] = STATE(2803),
    [sym_format_string] = STATE(2805),
    [sym__string_literal] = STATE(2805),
    [sym_string] = STATE(2803),
    [sym_verbatim_string] = STATE(2803),
    [sym_bytearray] = STATE(2803),
    [sym_verbatim_bytearray] = STATE(2803),
    [sym_format_triple_quoted_string] = STATE(2809),
    [sym_triple_quoted_string] = STATE(2803),
    [sym_const] = STATE(432),
    [sym_long_identifier] = STATE(5121),
    [sym_sbyte] = STATE(2803),
    [sym_byte] = STATE(2803),
    [sym_int16] = STATE(2803),
    [sym_uint16] = STATE(2803),
    [sym_int32] = STATE(2803),
    [sym_uint32] = STATE(2803),
    [sym_nativeint] = STATE(2803),
    [sym_unativeint] = STATE(2803),
    [sym_int64] = STATE(2803),
    [sym_uint64] = STATE(2803),
    [sym_ieee32] = STATE(2803),
    [sym_ieee64] = STATE(2803),
    [sym_bignum] = STATE(2803),
    [sym_decimal] = STATE(2803),
    [sym_float] = STATE(2793),
    [sym_block_comment] = STATE(2734),
    [sym_compiler_directive_decl] = STATE(2734),
    [sym_fsi_directive_decl] = STATE(2734),
    [sym_preproc_line] = STATE(2734),
    [sym_identifier] = ACTIONS(4509),
    [anon_sym_LPAREN] = ACTIONS(4511),
    [anon_sym__] = ACTIONS(4513),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4515),
    [anon_sym_GT] = ACTIONS(4577),
    [anon_sym_POUND] = ACTIONS(4519),
    [anon_sym_CARET] = ACTIONS(4521),
    [anon_sym_SQUOTE] = ACTIONS(4521),
    [aux_sym_char_token1] = ACTIONS(4523),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4525),
    [anon_sym_DQUOTE] = ACTIONS(4527),
    [anon_sym_AT_DQUOTE] = ACTIONS(4529),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4531),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4533),
    [sym_bool] = ACTIONS(4535),
    [sym_unit] = ACTIONS(4537),
    [sym_int] = ACTIONS(4539),
    [sym_xint] = ACTIONS(4541),
    [anon_sym_LPAREN_STAR] = ACTIONS(27),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2735] = {
    [sym__type] = STATE(5002),
    [sym_simple_type] = STATE(5109),
    [sym_generic_type] = STATE(5109),
    [sym_paren_type] = STATE(5109),
    [sym_function_type] = STATE(5109),
    [sym_compound_type] = STATE(5109),
    [sym_postfix_type] = STATE(5109),
    [sym_list_type] = STATE(5109),
    [sym_static_type] = STATE(5109),
    [sym_constrained_type] = STATE(5109),
    [sym_flexible_type] = STATE(5109),
    [sym_anon_record_type] = STATE(5109),
    [sym__static_type_identifier] = STATE(4686),
    [sym__static_parameter] = STATE(6029),
    [sym_named_static_parameter] = STATE(6034),
    [sym_type_attribute] = STATE(5982),
    [sym_type_attributes] = STATE(7523),
    [sym_type_argument] = STATE(4913),
    [sym_static_parameter_value] = STATE(6034),
    [sym_char] = STATE(2803),
    [sym_format_string] = STATE(2805),
    [sym__string_literal] = STATE(2805),
    [sym_string] = STATE(2803),
    [sym_verbatim_string] = STATE(2803),
    [sym_bytearray] = STATE(2803),
    [sym_verbatim_bytearray] = STATE(2803),
    [sym_format_triple_quoted_string] = STATE(2809),
    [sym_triple_quoted_string] = STATE(2803),
    [sym_const] = STATE(432),
    [sym_long_identifier] = STATE(5121),
    [sym_sbyte] = STATE(2803),
    [sym_byte] = STATE(2803),
    [sym_int16] = STATE(2803),
    [sym_uint16] = STATE(2803),
    [sym_int32] = STATE(2803),
    [sym_uint32] = STATE(2803),
    [sym_nativeint] = STATE(2803),
    [sym_unativeint] = STATE(2803),
    [sym_int64] = STATE(2803),
    [sym_uint64] = STATE(2803),
    [sym_ieee32] = STATE(2803),
    [sym_ieee64] = STATE(2803),
    [sym_bignum] = STATE(2803),
    [sym_decimal] = STATE(2803),
    [sym_float] = STATE(2793),
    [sym_block_comment] = STATE(2735),
    [sym_compiler_directive_decl] = STATE(2735),
    [sym_fsi_directive_decl] = STATE(2735),
    [sym_preproc_line] = STATE(2735),
    [sym_identifier] = ACTIONS(4509),
    [anon_sym_LPAREN] = ACTIONS(4511),
    [anon_sym__] = ACTIONS(4513),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4515),
    [anon_sym_GT] = ACTIONS(4579),
    [anon_sym_POUND] = ACTIONS(4519),
    [anon_sym_CARET] = ACTIONS(4521),
    [anon_sym_SQUOTE] = ACTIONS(4521),
    [aux_sym_char_token1] = ACTIONS(4523),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4525),
    [anon_sym_DQUOTE] = ACTIONS(4527),
    [anon_sym_AT_DQUOTE] = ACTIONS(4529),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4531),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4533),
    [sym_bool] = ACTIONS(4535),
    [sym_unit] = ACTIONS(4537),
    [sym_int] = ACTIONS(4539),
    [sym_xint] = ACTIONS(4541),
    [anon_sym_LPAREN_STAR] = ACTIONS(27),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2736] = {
    [sym__type] = STATE(5002),
    [sym_simple_type] = STATE(5109),
    [sym_generic_type] = STATE(5109),
    [sym_paren_type] = STATE(5109),
    [sym_function_type] = STATE(5109),
    [sym_compound_type] = STATE(5109),
    [sym_postfix_type] = STATE(5109),
    [sym_list_type] = STATE(5109),
    [sym_static_type] = STATE(5109),
    [sym_constrained_type] = STATE(5109),
    [sym_flexible_type] = STATE(5109),
    [sym_anon_record_type] = STATE(5109),
    [sym__static_type_identifier] = STATE(4686),
    [sym__static_parameter] = STATE(6029),
    [sym_named_static_parameter] = STATE(6034),
    [sym_type_attribute] = STATE(5982),
    [sym_type_attributes] = STATE(6602),
    [sym_type_argument] = STATE(4913),
    [sym_static_parameter_value] = STATE(6034),
    [sym_char] = STATE(2803),
    [sym_format_string] = STATE(2805),
    [sym__string_literal] = STATE(2805),
    [sym_string] = STATE(2803),
    [sym_verbatim_string] = STATE(2803),
    [sym_bytearray] = STATE(2803),
    [sym_verbatim_bytearray] = STATE(2803),
    [sym_format_triple_quoted_string] = STATE(2809),
    [sym_triple_quoted_string] = STATE(2803),
    [sym_const] = STATE(432),
    [sym_long_identifier] = STATE(5121),
    [sym_sbyte] = STATE(2803),
    [sym_byte] = STATE(2803),
    [sym_int16] = STATE(2803),
    [sym_uint16] = STATE(2803),
    [sym_int32] = STATE(2803),
    [sym_uint32] = STATE(2803),
    [sym_nativeint] = STATE(2803),
    [sym_unativeint] = STATE(2803),
    [sym_int64] = STATE(2803),
    [sym_uint64] = STATE(2803),
    [sym_ieee32] = STATE(2803),
    [sym_ieee64] = STATE(2803),
    [sym_bignum] = STATE(2803),
    [sym_decimal] = STATE(2803),
    [sym_float] = STATE(2793),
    [sym_block_comment] = STATE(2736),
    [sym_compiler_directive_decl] = STATE(2736),
    [sym_fsi_directive_decl] = STATE(2736),
    [sym_preproc_line] = STATE(2736),
    [sym_identifier] = ACTIONS(4509),
    [anon_sym_LPAREN] = ACTIONS(4511),
    [anon_sym__] = ACTIONS(4513),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4515),
    [anon_sym_GT] = ACTIONS(4581),
    [anon_sym_POUND] = ACTIONS(4519),
    [anon_sym_CARET] = ACTIONS(4521),
    [anon_sym_SQUOTE] = ACTIONS(4521),
    [aux_sym_char_token1] = ACTIONS(4523),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4525),
    [anon_sym_DQUOTE] = ACTIONS(4527),
    [anon_sym_AT_DQUOTE] = ACTIONS(4529),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4531),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4533),
    [sym_bool] = ACTIONS(4535),
    [sym_unit] = ACTIONS(4537),
    [sym_int] = ACTIONS(4539),
    [sym_xint] = ACTIONS(4541),
    [anon_sym_LPAREN_STAR] = ACTIONS(27),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2737] = {
    [sym__type] = STATE(5002),
    [sym_simple_type] = STATE(5109),
    [sym_generic_type] = STATE(5109),
    [sym_paren_type] = STATE(5109),
    [sym_function_type] = STATE(5109),
    [sym_compound_type] = STATE(5109),
    [sym_postfix_type] = STATE(5109),
    [sym_list_type] = STATE(5109),
    [sym_static_type] = STATE(5109),
    [sym_constrained_type] = STATE(5109),
    [sym_flexible_type] = STATE(5109),
    [sym_anon_record_type] = STATE(5109),
    [sym__static_type_identifier] = STATE(4686),
    [sym__static_parameter] = STATE(6029),
    [sym_named_static_parameter] = STATE(6034),
    [sym_type_attribute] = STATE(5982),
    [sym_type_attributes] = STATE(7006),
    [sym_type_argument] = STATE(4913),
    [sym_static_parameter_value] = STATE(6034),
    [sym_char] = STATE(2803),
    [sym_format_string] = STATE(2805),
    [sym__string_literal] = STATE(2805),
    [sym_string] = STATE(2803),
    [sym_verbatim_string] = STATE(2803),
    [sym_bytearray] = STATE(2803),
    [sym_verbatim_bytearray] = STATE(2803),
    [sym_format_triple_quoted_string] = STATE(2809),
    [sym_triple_quoted_string] = STATE(2803),
    [sym_const] = STATE(432),
    [sym_long_identifier] = STATE(5121),
    [sym_sbyte] = STATE(2803),
    [sym_byte] = STATE(2803),
    [sym_int16] = STATE(2803),
    [sym_uint16] = STATE(2803),
    [sym_int32] = STATE(2803),
    [sym_uint32] = STATE(2803),
    [sym_nativeint] = STATE(2803),
    [sym_unativeint] = STATE(2803),
    [sym_int64] = STATE(2803),
    [sym_uint64] = STATE(2803),
    [sym_ieee32] = STATE(2803),
    [sym_ieee64] = STATE(2803),
    [sym_bignum] = STATE(2803),
    [sym_decimal] = STATE(2803),
    [sym_float] = STATE(2793),
    [sym_block_comment] = STATE(2737),
    [sym_compiler_directive_decl] = STATE(2737),
    [sym_fsi_directive_decl] = STATE(2737),
    [sym_preproc_line] = STATE(2737),
    [sym_identifier] = ACTIONS(4509),
    [anon_sym_LPAREN] = ACTIONS(4511),
    [anon_sym__] = ACTIONS(4513),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4515),
    [anon_sym_GT] = ACTIONS(4583),
    [anon_sym_POUND] = ACTIONS(4519),
    [anon_sym_CARET] = ACTIONS(4521),
    [anon_sym_SQUOTE] = ACTIONS(4521),
    [aux_sym_char_token1] = ACTIONS(4523),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4525),
    [anon_sym_DQUOTE] = ACTIONS(4527),
    [anon_sym_AT_DQUOTE] = ACTIONS(4529),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4531),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4533),
    [sym_bool] = ACTIONS(4535),
    [sym_unit] = ACTIONS(4537),
    [sym_int] = ACTIONS(4539),
    [sym_xint] = ACTIONS(4541),
    [anon_sym_LPAREN_STAR] = ACTIONS(27),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2738] = {
    [sym__type] = STATE(5002),
    [sym_simple_type] = STATE(5109),
    [sym_generic_type] = STATE(5109),
    [sym_paren_type] = STATE(5109),
    [sym_function_type] = STATE(5109),
    [sym_compound_type] = STATE(5109),
    [sym_postfix_type] = STATE(5109),
    [sym_list_type] = STATE(5109),
    [sym_static_type] = STATE(5109),
    [sym_constrained_type] = STATE(5109),
    [sym_flexible_type] = STATE(5109),
    [sym_anon_record_type] = STATE(5109),
    [sym__static_type_identifier] = STATE(4686),
    [sym__static_parameter] = STATE(6029),
    [sym_named_static_parameter] = STATE(6034),
    [sym_type_attribute] = STATE(5982),
    [sym_type_attributes] = STATE(6573),
    [sym_type_argument] = STATE(4913),
    [sym_static_parameter_value] = STATE(6034),
    [sym_char] = STATE(2803),
    [sym_format_string] = STATE(2805),
    [sym__string_literal] = STATE(2805),
    [sym_string] = STATE(2803),
    [sym_verbatim_string] = STATE(2803),
    [sym_bytearray] = STATE(2803),
    [sym_verbatim_bytearray] = STATE(2803),
    [sym_format_triple_quoted_string] = STATE(2809),
    [sym_triple_quoted_string] = STATE(2803),
    [sym_const] = STATE(432),
    [sym_long_identifier] = STATE(5121),
    [sym_sbyte] = STATE(2803),
    [sym_byte] = STATE(2803),
    [sym_int16] = STATE(2803),
    [sym_uint16] = STATE(2803),
    [sym_int32] = STATE(2803),
    [sym_uint32] = STATE(2803),
    [sym_nativeint] = STATE(2803),
    [sym_unativeint] = STATE(2803),
    [sym_int64] = STATE(2803),
    [sym_uint64] = STATE(2803),
    [sym_ieee32] = STATE(2803),
    [sym_ieee64] = STATE(2803),
    [sym_bignum] = STATE(2803),
    [sym_decimal] = STATE(2803),
    [sym_float] = STATE(2793),
    [sym_block_comment] = STATE(2738),
    [sym_compiler_directive_decl] = STATE(2738),
    [sym_fsi_directive_decl] = STATE(2738),
    [sym_preproc_line] = STATE(2738),
    [sym_identifier] = ACTIONS(4509),
    [anon_sym_LPAREN] = ACTIONS(4511),
    [anon_sym__] = ACTIONS(4513),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4515),
    [anon_sym_GT] = ACTIONS(4585),
    [anon_sym_POUND] = ACTIONS(4519),
    [anon_sym_CARET] = ACTIONS(4521),
    [anon_sym_SQUOTE] = ACTIONS(4521),
    [aux_sym_char_token1] = ACTIONS(4523),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4525),
    [anon_sym_DQUOTE] = ACTIONS(4527),
    [anon_sym_AT_DQUOTE] = ACTIONS(4529),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4531),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4533),
    [sym_bool] = ACTIONS(4535),
    [sym_unit] = ACTIONS(4537),
    [sym_int] = ACTIONS(4539),
    [sym_xint] = ACTIONS(4541),
    [anon_sym_LPAREN_STAR] = ACTIONS(27),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2739] = {
    [sym__type] = STATE(5002),
    [sym_simple_type] = STATE(5109),
    [sym_generic_type] = STATE(5109),
    [sym_paren_type] = STATE(5109),
    [sym_function_type] = STATE(5109),
    [sym_compound_type] = STATE(5109),
    [sym_postfix_type] = STATE(5109),
    [sym_list_type] = STATE(5109),
    [sym_static_type] = STATE(5109),
    [sym_constrained_type] = STATE(5109),
    [sym_flexible_type] = STATE(5109),
    [sym_anon_record_type] = STATE(5109),
    [sym__static_type_identifier] = STATE(4686),
    [sym__static_parameter] = STATE(6029),
    [sym_named_static_parameter] = STATE(6034),
    [sym_type_attribute] = STATE(5982),
    [sym_type_attributes] = STATE(7198),
    [sym_type_argument] = STATE(4913),
    [sym_static_parameter_value] = STATE(6034),
    [sym_char] = STATE(2803),
    [sym_format_string] = STATE(2805),
    [sym__string_literal] = STATE(2805),
    [sym_string] = STATE(2803),
    [sym_verbatim_string] = STATE(2803),
    [sym_bytearray] = STATE(2803),
    [sym_verbatim_bytearray] = STATE(2803),
    [sym_format_triple_quoted_string] = STATE(2809),
    [sym_triple_quoted_string] = STATE(2803),
    [sym_const] = STATE(432),
    [sym_long_identifier] = STATE(5121),
    [sym_sbyte] = STATE(2803),
    [sym_byte] = STATE(2803),
    [sym_int16] = STATE(2803),
    [sym_uint16] = STATE(2803),
    [sym_int32] = STATE(2803),
    [sym_uint32] = STATE(2803),
    [sym_nativeint] = STATE(2803),
    [sym_unativeint] = STATE(2803),
    [sym_int64] = STATE(2803),
    [sym_uint64] = STATE(2803),
    [sym_ieee32] = STATE(2803),
    [sym_ieee64] = STATE(2803),
    [sym_bignum] = STATE(2803),
    [sym_decimal] = STATE(2803),
    [sym_float] = STATE(2793),
    [sym_block_comment] = STATE(2739),
    [sym_compiler_directive_decl] = STATE(2739),
    [sym_fsi_directive_decl] = STATE(2739),
    [sym_preproc_line] = STATE(2739),
    [sym_identifier] = ACTIONS(4509),
    [anon_sym_LPAREN] = ACTIONS(4511),
    [anon_sym__] = ACTIONS(4513),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4515),
    [anon_sym_GT] = ACTIONS(4587),
    [anon_sym_POUND] = ACTIONS(4519),
    [anon_sym_CARET] = ACTIONS(4521),
    [anon_sym_SQUOTE] = ACTIONS(4521),
    [aux_sym_char_token1] = ACTIONS(4523),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4525),
    [anon_sym_DQUOTE] = ACTIONS(4527),
    [anon_sym_AT_DQUOTE] = ACTIONS(4529),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4531),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4533),
    [sym_bool] = ACTIONS(4535),
    [sym_unit] = ACTIONS(4537),
    [sym_int] = ACTIONS(4539),
    [sym_xint] = ACTIONS(4541),
    [anon_sym_LPAREN_STAR] = ACTIONS(27),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2740] = {
    [sym__type] = STATE(5002),
    [sym_simple_type] = STATE(5109),
    [sym_generic_type] = STATE(5109),
    [sym_paren_type] = STATE(5109),
    [sym_function_type] = STATE(5109),
    [sym_compound_type] = STATE(5109),
    [sym_postfix_type] = STATE(5109),
    [sym_list_type] = STATE(5109),
    [sym_static_type] = STATE(5109),
    [sym_constrained_type] = STATE(5109),
    [sym_flexible_type] = STATE(5109),
    [sym_anon_record_type] = STATE(5109),
    [sym__static_type_identifier] = STATE(4686),
    [sym__static_parameter] = STATE(6029),
    [sym_named_static_parameter] = STATE(6034),
    [sym_type_attribute] = STATE(5982),
    [sym_type_attributes] = STATE(6553),
    [sym_type_argument] = STATE(4913),
    [sym_static_parameter_value] = STATE(6034),
    [sym_char] = STATE(2803),
    [sym_format_string] = STATE(2805),
    [sym__string_literal] = STATE(2805),
    [sym_string] = STATE(2803),
    [sym_verbatim_string] = STATE(2803),
    [sym_bytearray] = STATE(2803),
    [sym_verbatim_bytearray] = STATE(2803),
    [sym_format_triple_quoted_string] = STATE(2809),
    [sym_triple_quoted_string] = STATE(2803),
    [sym_const] = STATE(432),
    [sym_long_identifier] = STATE(5121),
    [sym_sbyte] = STATE(2803),
    [sym_byte] = STATE(2803),
    [sym_int16] = STATE(2803),
    [sym_uint16] = STATE(2803),
    [sym_int32] = STATE(2803),
    [sym_uint32] = STATE(2803),
    [sym_nativeint] = STATE(2803),
    [sym_unativeint] = STATE(2803),
    [sym_int64] = STATE(2803),
    [sym_uint64] = STATE(2803),
    [sym_ieee32] = STATE(2803),
    [sym_ieee64] = STATE(2803),
    [sym_bignum] = STATE(2803),
    [sym_decimal] = STATE(2803),
    [sym_float] = STATE(2793),
    [sym_block_comment] = STATE(2740),
    [sym_compiler_directive_decl] = STATE(2740),
    [sym_fsi_directive_decl] = STATE(2740),
    [sym_preproc_line] = STATE(2740),
    [sym_identifier] = ACTIONS(4509),
    [anon_sym_LPAREN] = ACTIONS(4511),
    [anon_sym__] = ACTIONS(4513),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4515),
    [anon_sym_GT] = ACTIONS(4589),
    [anon_sym_POUND] = ACTIONS(4519),
    [anon_sym_CARET] = ACTIONS(4521),
    [anon_sym_SQUOTE] = ACTIONS(4521),
    [aux_sym_char_token1] = ACTIONS(4523),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4525),
    [anon_sym_DQUOTE] = ACTIONS(4527),
    [anon_sym_AT_DQUOTE] = ACTIONS(4529),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4531),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4533),
    [sym_bool] = ACTIONS(4535),
    [sym_unit] = ACTIONS(4537),
    [sym_int] = ACTIONS(4539),
    [sym_xint] = ACTIONS(4541),
    [anon_sym_LPAREN_STAR] = ACTIONS(27),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2741] = {
    [sym__type] = STATE(5002),
    [sym_simple_type] = STATE(5109),
    [sym_generic_type] = STATE(5109),
    [sym_paren_type] = STATE(5109),
    [sym_function_type] = STATE(5109),
    [sym_compound_type] = STATE(5109),
    [sym_postfix_type] = STATE(5109),
    [sym_list_type] = STATE(5109),
    [sym_static_type] = STATE(5109),
    [sym_constrained_type] = STATE(5109),
    [sym_flexible_type] = STATE(5109),
    [sym_anon_record_type] = STATE(5109),
    [sym__static_type_identifier] = STATE(4686),
    [sym__static_parameter] = STATE(6029),
    [sym_named_static_parameter] = STATE(6034),
    [sym_type_attribute] = STATE(5982),
    [sym_type_attributes] = STATE(6540),
    [sym_type_argument] = STATE(4913),
    [sym_static_parameter_value] = STATE(6034),
    [sym_char] = STATE(2803),
    [sym_format_string] = STATE(2805),
    [sym__string_literal] = STATE(2805),
    [sym_string] = STATE(2803),
    [sym_verbatim_string] = STATE(2803),
    [sym_bytearray] = STATE(2803),
    [sym_verbatim_bytearray] = STATE(2803),
    [sym_format_triple_quoted_string] = STATE(2809),
    [sym_triple_quoted_string] = STATE(2803),
    [sym_const] = STATE(432),
    [sym_long_identifier] = STATE(5121),
    [sym_sbyte] = STATE(2803),
    [sym_byte] = STATE(2803),
    [sym_int16] = STATE(2803),
    [sym_uint16] = STATE(2803),
    [sym_int32] = STATE(2803),
    [sym_uint32] = STATE(2803),
    [sym_nativeint] = STATE(2803),
    [sym_unativeint] = STATE(2803),
    [sym_int64] = STATE(2803),
    [sym_uint64] = STATE(2803),
    [sym_ieee32] = STATE(2803),
    [sym_ieee64] = STATE(2803),
    [sym_bignum] = STATE(2803),
    [sym_decimal] = STATE(2803),
    [sym_float] = STATE(2793),
    [sym_block_comment] = STATE(2741),
    [sym_compiler_directive_decl] = STATE(2741),
    [sym_fsi_directive_decl] = STATE(2741),
    [sym_preproc_line] = STATE(2741),
    [sym_identifier] = ACTIONS(4509),
    [anon_sym_LPAREN] = ACTIONS(4511),
    [anon_sym__] = ACTIONS(4513),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4515),
    [anon_sym_GT] = ACTIONS(4591),
    [anon_sym_POUND] = ACTIONS(4519),
    [anon_sym_CARET] = ACTIONS(4521),
    [anon_sym_SQUOTE] = ACTIONS(4521),
    [aux_sym_char_token1] = ACTIONS(4523),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4525),
    [anon_sym_DQUOTE] = ACTIONS(4527),
    [anon_sym_AT_DQUOTE] = ACTIONS(4529),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4531),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4533),
    [sym_bool] = ACTIONS(4535),
    [sym_unit] = ACTIONS(4537),
    [sym_int] = ACTIONS(4539),
    [sym_xint] = ACTIONS(4541),
    [anon_sym_LPAREN_STAR] = ACTIONS(27),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2742] = {
    [sym__type] = STATE(5002),
    [sym_simple_type] = STATE(5109),
    [sym_generic_type] = STATE(5109),
    [sym_paren_type] = STATE(5109),
    [sym_function_type] = STATE(5109),
    [sym_compound_type] = STATE(5109),
    [sym_postfix_type] = STATE(5109),
    [sym_list_type] = STATE(5109),
    [sym_static_type] = STATE(5109),
    [sym_constrained_type] = STATE(5109),
    [sym_flexible_type] = STATE(5109),
    [sym_anon_record_type] = STATE(5109),
    [sym__static_type_identifier] = STATE(4686),
    [sym__static_parameter] = STATE(6029),
    [sym_named_static_parameter] = STATE(6034),
    [sym_type_attribute] = STATE(5982),
    [sym_type_attributes] = STATE(7356),
    [sym_type_argument] = STATE(4913),
    [sym_static_parameter_value] = STATE(6034),
    [sym_char] = STATE(2803),
    [sym_format_string] = STATE(2805),
    [sym__string_literal] = STATE(2805),
    [sym_string] = STATE(2803),
    [sym_verbatim_string] = STATE(2803),
    [sym_bytearray] = STATE(2803),
    [sym_verbatim_bytearray] = STATE(2803),
    [sym_format_triple_quoted_string] = STATE(2809),
    [sym_triple_quoted_string] = STATE(2803),
    [sym_const] = STATE(432),
    [sym_long_identifier] = STATE(5121),
    [sym_sbyte] = STATE(2803),
    [sym_byte] = STATE(2803),
    [sym_int16] = STATE(2803),
    [sym_uint16] = STATE(2803),
    [sym_int32] = STATE(2803),
    [sym_uint32] = STATE(2803),
    [sym_nativeint] = STATE(2803),
    [sym_unativeint] = STATE(2803),
    [sym_int64] = STATE(2803),
    [sym_uint64] = STATE(2803),
    [sym_ieee32] = STATE(2803),
    [sym_ieee64] = STATE(2803),
    [sym_bignum] = STATE(2803),
    [sym_decimal] = STATE(2803),
    [sym_float] = STATE(2793),
    [sym_block_comment] = STATE(2742),
    [sym_compiler_directive_decl] = STATE(2742),
    [sym_fsi_directive_decl] = STATE(2742),
    [sym_preproc_line] = STATE(2742),
    [sym_identifier] = ACTIONS(4509),
    [anon_sym_LPAREN] = ACTIONS(4511),
    [anon_sym__] = ACTIONS(4513),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4515),
    [anon_sym_GT] = ACTIONS(4593),
    [anon_sym_POUND] = ACTIONS(4519),
    [anon_sym_CARET] = ACTIONS(4521),
    [anon_sym_SQUOTE] = ACTIONS(4521),
    [aux_sym_char_token1] = ACTIONS(4523),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4525),
    [anon_sym_DQUOTE] = ACTIONS(4527),
    [anon_sym_AT_DQUOTE] = ACTIONS(4529),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4531),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4533),
    [sym_bool] = ACTIONS(4535),
    [sym_unit] = ACTIONS(4537),
    [sym_int] = ACTIONS(4539),
    [sym_xint] = ACTIONS(4541),
    [anon_sym_LPAREN_STAR] = ACTIONS(27),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2743] = {
    [sym__type] = STATE(5002),
    [sym_simple_type] = STATE(5109),
    [sym_generic_type] = STATE(5109),
    [sym_paren_type] = STATE(5109),
    [sym_function_type] = STATE(5109),
    [sym_compound_type] = STATE(5109),
    [sym_postfix_type] = STATE(5109),
    [sym_list_type] = STATE(5109),
    [sym_static_type] = STATE(5109),
    [sym_constrained_type] = STATE(5109),
    [sym_flexible_type] = STATE(5109),
    [sym_anon_record_type] = STATE(5109),
    [sym__static_type_identifier] = STATE(4686),
    [sym__static_parameter] = STATE(6029),
    [sym_named_static_parameter] = STATE(6034),
    [sym_type_attribute] = STATE(5982),
    [sym_type_attributes] = STATE(6816),
    [sym_type_argument] = STATE(4913),
    [sym_static_parameter_value] = STATE(6034),
    [sym_char] = STATE(2803),
    [sym_format_string] = STATE(2805),
    [sym__string_literal] = STATE(2805),
    [sym_string] = STATE(2803),
    [sym_verbatim_string] = STATE(2803),
    [sym_bytearray] = STATE(2803),
    [sym_verbatim_bytearray] = STATE(2803),
    [sym_format_triple_quoted_string] = STATE(2809),
    [sym_triple_quoted_string] = STATE(2803),
    [sym_const] = STATE(432),
    [sym_long_identifier] = STATE(5121),
    [sym_sbyte] = STATE(2803),
    [sym_byte] = STATE(2803),
    [sym_int16] = STATE(2803),
    [sym_uint16] = STATE(2803),
    [sym_int32] = STATE(2803),
    [sym_uint32] = STATE(2803),
    [sym_nativeint] = STATE(2803),
    [sym_unativeint] = STATE(2803),
    [sym_int64] = STATE(2803),
    [sym_uint64] = STATE(2803),
    [sym_ieee32] = STATE(2803),
    [sym_ieee64] = STATE(2803),
    [sym_bignum] = STATE(2803),
    [sym_decimal] = STATE(2803),
    [sym_float] = STATE(2793),
    [sym_block_comment] = STATE(2743),
    [sym_compiler_directive_decl] = STATE(2743),
    [sym_fsi_directive_decl] = STATE(2743),
    [sym_preproc_line] = STATE(2743),
    [sym_identifier] = ACTIONS(4509),
    [anon_sym_LPAREN] = ACTIONS(4511),
    [anon_sym__] = ACTIONS(4513),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4515),
    [anon_sym_GT] = ACTIONS(4595),
    [anon_sym_POUND] = ACTIONS(4519),
    [anon_sym_CARET] = ACTIONS(4521),
    [anon_sym_SQUOTE] = ACTIONS(4521),
    [aux_sym_char_token1] = ACTIONS(4523),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4525),
    [anon_sym_DQUOTE] = ACTIONS(4527),
    [anon_sym_AT_DQUOTE] = ACTIONS(4529),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4531),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4533),
    [sym_bool] = ACTIONS(4535),
    [sym_unit] = ACTIONS(4537),
    [sym_int] = ACTIONS(4539),
    [sym_xint] = ACTIONS(4541),
    [anon_sym_LPAREN_STAR] = ACTIONS(27),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2744] = {
    [sym__type] = STATE(5002),
    [sym_simple_type] = STATE(5109),
    [sym_generic_type] = STATE(5109),
    [sym_paren_type] = STATE(5109),
    [sym_function_type] = STATE(5109),
    [sym_compound_type] = STATE(5109),
    [sym_postfix_type] = STATE(5109),
    [sym_list_type] = STATE(5109),
    [sym_static_type] = STATE(5109),
    [sym_constrained_type] = STATE(5109),
    [sym_flexible_type] = STATE(5109),
    [sym_anon_record_type] = STATE(5109),
    [sym__static_type_identifier] = STATE(4686),
    [sym__static_parameter] = STATE(6029),
    [sym_named_static_parameter] = STATE(6034),
    [sym_type_attribute] = STATE(5982),
    [sym_type_attributes] = STATE(6970),
    [sym_type_argument] = STATE(4913),
    [sym_static_parameter_value] = STATE(6034),
    [sym_char] = STATE(2803),
    [sym_format_string] = STATE(2805),
    [sym__string_literal] = STATE(2805),
    [sym_string] = STATE(2803),
    [sym_verbatim_string] = STATE(2803),
    [sym_bytearray] = STATE(2803),
    [sym_verbatim_bytearray] = STATE(2803),
    [sym_format_triple_quoted_string] = STATE(2809),
    [sym_triple_quoted_string] = STATE(2803),
    [sym_const] = STATE(432),
    [sym_long_identifier] = STATE(5121),
    [sym_sbyte] = STATE(2803),
    [sym_byte] = STATE(2803),
    [sym_int16] = STATE(2803),
    [sym_uint16] = STATE(2803),
    [sym_int32] = STATE(2803),
    [sym_uint32] = STATE(2803),
    [sym_nativeint] = STATE(2803),
    [sym_unativeint] = STATE(2803),
    [sym_int64] = STATE(2803),
    [sym_uint64] = STATE(2803),
    [sym_ieee32] = STATE(2803),
    [sym_ieee64] = STATE(2803),
    [sym_bignum] = STATE(2803),
    [sym_decimal] = STATE(2803),
    [sym_float] = STATE(2793),
    [sym_block_comment] = STATE(2744),
    [sym_compiler_directive_decl] = STATE(2744),
    [sym_fsi_directive_decl] = STATE(2744),
    [sym_preproc_line] = STATE(2744),
    [sym_identifier] = ACTIONS(4509),
    [anon_sym_LPAREN] = ACTIONS(4511),
    [anon_sym__] = ACTIONS(4513),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4515),
    [anon_sym_GT] = ACTIONS(4597),
    [anon_sym_POUND] = ACTIONS(4519),
    [anon_sym_CARET] = ACTIONS(4521),
    [anon_sym_SQUOTE] = ACTIONS(4521),
    [aux_sym_char_token1] = ACTIONS(4523),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4525),
    [anon_sym_DQUOTE] = ACTIONS(4527),
    [anon_sym_AT_DQUOTE] = ACTIONS(4529),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4531),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4533),
    [sym_bool] = ACTIONS(4535),
    [sym_unit] = ACTIONS(4537),
    [sym_int] = ACTIONS(4539),
    [sym_xint] = ACTIONS(4541),
    [anon_sym_LPAREN_STAR] = ACTIONS(27),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2745] = {
    [sym_block_comment] = STATE(2745),
    [sym_compiler_directive_decl] = STATE(2745),
    [sym_fsi_directive_decl] = STATE(2745),
    [sym_preproc_line] = STATE(2745),
    [aux_sym_long_identifier_repeat1] = STATE(2750),
    [sym_identifier] = ACTIONS(2312),
    [anon_sym_GT_RBRACK] = ACTIONS(2314),
    [anon_sym_return] = ACTIONS(2312),
    [anon_sym_do] = ACTIONS(2312),
    [anon_sym_let] = ACTIONS(2312),
    [anon_sym_let_BANG] = ACTIONS(2314),
    [anon_sym_LPAREN] = ACTIONS(2312),
    [anon_sym_null] = ACTIONS(2312),
    [anon_sym_AMP] = ACTIONS(2312),
    [anon_sym_LBRACK] = ACTIONS(2312),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2314),
    [anon_sym_LBRACE] = ACTIONS(2312),
    [anon_sym_LT_AT] = ACTIONS(2312),
    [anon_sym_LT_AT_AT] = ACTIONS(2314),
    [anon_sym_DOT] = ACTIONS(4599),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2314),
    [anon_sym_new] = ACTIONS(2312),
    [anon_sym_return_BANG] = ACTIONS(2314),
    [anon_sym_yield] = ACTIONS(2312),
    [anon_sym_yield_BANG] = ACTIONS(2314),
    [anon_sym_lazy] = ACTIONS(2312),
    [anon_sym_assert] = ACTIONS(2312),
    [anon_sym_upcast] = ACTIONS(2312),
    [anon_sym_downcast] = ACTIONS(2312),
    [anon_sym_for] = ACTIONS(2312),
    [anon_sym_while] = ACTIONS(2312),
    [anon_sym_if] = ACTIONS(2312),
    [anon_sym_fun] = ACTIONS(2312),
    [anon_sym_DASH_GT] = ACTIONS(2314),
    [anon_sym_try] = ACTIONS(2312),
    [anon_sym_match] = ACTIONS(2312),
    [anon_sym_match_BANG] = ACTIONS(2314),
    [anon_sym_function] = ACTIONS(2312),
    [anon_sym_use] = ACTIONS(2312),
    [anon_sym_use_BANG] = ACTIONS(2314),
    [anon_sym_do_BANG] = ACTIONS(2314),
    [anon_sym_begin] = ACTIONS(2312),
    [anon_sym_STAR] = ACTIONS(2314),
    [anon_sym_LT2] = ACTIONS(2312),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2314),
    [aux_sym_char_token1] = ACTIONS(2314),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2312),
    [anon_sym_DQUOTE] = ACTIONS(2312),
    [anon_sym_AT_DQUOTE] = ACTIONS(2314),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2314),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2314),
    [sym_bool] = ACTIONS(2312),
    [sym_unit] = ACTIONS(2314),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2312),
    [sym_op_identifier] = ACTIONS(2314),
    [anon_sym_PLUS] = ACTIONS(2312),
    [anon_sym_DASH] = ACTIONS(2312),
    [anon_sym_PLUS_DOT] = ACTIONS(2314),
    [anon_sym_DASH_DOT] = ACTIONS(2314),
    [anon_sym_PERCENT] = ACTIONS(2314),
    [anon_sym_AMP_AMP] = ACTIONS(2314),
    [anon_sym_TILDE] = ACTIONS(2314),
    [aux_sym_prefix_op_token1] = ACTIONS(2314),
    [sym_int] = ACTIONS(2312),
    [sym_xint] = ACTIONS(2314),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2314),
    [sym__newline] = ACTIONS(2314),
  },
  [2746] = {
    [sym_argument_patterns] = STATE(6143),
    [sym__atomic_pattern] = STATE(4141),
    [sym_list_pattern] = STATE(4163),
    [sym_array_pattern] = STATE(4163),
    [sym_record_pattern] = STATE(4163),
    [sym_type_arguments] = STATE(2863),
    [sym_char] = STATE(4152),
    [sym_format_string] = STATE(4160),
    [sym__string_literal] = STATE(4160),
    [sym_string] = STATE(4152),
    [sym_verbatim_string] = STATE(4152),
    [sym_bytearray] = STATE(4152),
    [sym_verbatim_bytearray] = STATE(4152),
    [sym_format_triple_quoted_string] = STATE(4166),
    [sym_triple_quoted_string] = STATE(4152),
    [sym_const] = STATE(4163),
    [sym_long_identifier] = STATE(4163),
    [sym_sbyte] = STATE(4152),
    [sym_byte] = STATE(4152),
    [sym_int16] = STATE(4152),
    [sym_uint16] = STATE(4152),
    [sym_int32] = STATE(4152),
    [sym_uint32] = STATE(4152),
    [sym_nativeint] = STATE(4152),
    [sym_unativeint] = STATE(4152),
    [sym_int64] = STATE(4152),
    [sym_uint64] = STATE(4152),
    [sym_ieee32] = STATE(4152),
    [sym_ieee64] = STATE(4152),
    [sym_bignum] = STATE(4152),
    [sym_decimal] = STATE(4152),
    [sym_float] = STATE(3887),
    [sym_block_comment] = STATE(2746),
    [sym_compiler_directive_decl] = STATE(2746),
    [sym_fsi_directive_decl] = STATE(2746),
    [sym_preproc_line] = STATE(2746),
    [aux_sym_argument_patterns_repeat1] = STATE(2846),
    [sym_identifier] = ACTIONS(4601),
    [anon_sym_EQ] = ACTIONS(2869),
    [anon_sym_LBRACK_LT] = ACTIONS(2869),
    [anon_sym_COLON] = ACTIONS(2867),
    [anon_sym_as] = ACTIONS(2867),
    [anon_sym_LPAREN] = ACTIONS(4603),
    [anon_sym_COMMA] = ACTIONS(2869),
    [anon_sym_null] = ACTIONS(4605),
    [anon_sym__] = ACTIONS(4605),
    [anon_sym_QMARK] = ACTIONS(2869),
    [anon_sym_COLON_QMARK] = ACTIONS(2869),
    [anon_sym_COLON_COLON] = ACTIONS(2869),
    [anon_sym_PIPE] = ACTIONS(2869),
    [anon_sym_AMP] = ACTIONS(2869),
    [anon_sym_LBRACK] = ACTIONS(4607),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4609),
    [anon_sym_LBRACE] = ACTIONS(4611),
    [anon_sym_LT2] = ACTIONS(4613),
    [aux_sym_char_token1] = ACTIONS(4615),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4617),
    [anon_sym_DQUOTE] = ACTIONS(4619),
    [anon_sym_AT_DQUOTE] = ACTIONS(4621),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4623),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4625),
    [sym_bool] = ACTIONS(4627),
    [sym_unit] = ACTIONS(4629),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2867),
    [sym_op_identifier] = ACTIONS(2869),
    [sym_int] = ACTIONS(4631),
    [sym_xint] = ACTIONS(4633),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2747] = {
    [sym__type] = STATE(5002),
    [sym_simple_type] = STATE(5109),
    [sym_generic_type] = STATE(5109),
    [sym_paren_type] = STATE(5109),
    [sym_function_type] = STATE(5109),
    [sym_compound_type] = STATE(5109),
    [sym_postfix_type] = STATE(5109),
    [sym_list_type] = STATE(5109),
    [sym_static_type] = STATE(5109),
    [sym_constrained_type] = STATE(5109),
    [sym_flexible_type] = STATE(5109),
    [sym_anon_record_type] = STATE(5109),
    [sym__static_type_identifier] = STATE(4686),
    [sym__static_parameter] = STATE(6029),
    [sym_named_static_parameter] = STATE(6034),
    [sym_type_attribute] = STATE(5982),
    [sym_type_attributes] = STATE(7002),
    [sym_type_argument] = STATE(4913),
    [sym_static_parameter_value] = STATE(6034),
    [sym_char] = STATE(2803),
    [sym_format_string] = STATE(2805),
    [sym__string_literal] = STATE(2805),
    [sym_string] = STATE(2803),
    [sym_verbatim_string] = STATE(2803),
    [sym_bytearray] = STATE(2803),
    [sym_verbatim_bytearray] = STATE(2803),
    [sym_format_triple_quoted_string] = STATE(2809),
    [sym_triple_quoted_string] = STATE(2803),
    [sym_const] = STATE(432),
    [sym_long_identifier] = STATE(5121),
    [sym_sbyte] = STATE(2803),
    [sym_byte] = STATE(2803),
    [sym_int16] = STATE(2803),
    [sym_uint16] = STATE(2803),
    [sym_int32] = STATE(2803),
    [sym_uint32] = STATE(2803),
    [sym_nativeint] = STATE(2803),
    [sym_unativeint] = STATE(2803),
    [sym_int64] = STATE(2803),
    [sym_uint64] = STATE(2803),
    [sym_ieee32] = STATE(2803),
    [sym_ieee64] = STATE(2803),
    [sym_bignum] = STATE(2803),
    [sym_decimal] = STATE(2803),
    [sym_float] = STATE(2793),
    [sym_block_comment] = STATE(2747),
    [sym_compiler_directive_decl] = STATE(2747),
    [sym_fsi_directive_decl] = STATE(2747),
    [sym_preproc_line] = STATE(2747),
    [sym_identifier] = ACTIONS(4509),
    [anon_sym_LPAREN] = ACTIONS(4511),
    [anon_sym__] = ACTIONS(4513),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4515),
    [anon_sym_GT] = ACTIONS(4635),
    [anon_sym_POUND] = ACTIONS(4519),
    [anon_sym_CARET] = ACTIONS(4521),
    [anon_sym_SQUOTE] = ACTIONS(4521),
    [aux_sym_char_token1] = ACTIONS(4523),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4525),
    [anon_sym_DQUOTE] = ACTIONS(4527),
    [anon_sym_AT_DQUOTE] = ACTIONS(4529),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4531),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4533),
    [sym_bool] = ACTIONS(4535),
    [sym_unit] = ACTIONS(4537),
    [sym_int] = ACTIONS(4539),
    [sym_xint] = ACTIONS(4541),
    [anon_sym_LPAREN_STAR] = ACTIONS(27),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2748] = {
    [sym_block_comment] = STATE(2748),
    [sym_compiler_directive_decl] = STATE(2748),
    [sym_fsi_directive_decl] = STATE(2748),
    [sym_preproc_line] = STATE(2748),
    [sym_identifier] = ACTIONS(2340),
    [anon_sym_GT_RBRACK] = ACTIONS(2342),
    [anon_sym_return] = ACTIONS(2340),
    [anon_sym_do] = ACTIONS(2340),
    [anon_sym_let] = ACTIONS(2340),
    [anon_sym_let_BANG] = ACTIONS(2342),
    [anon_sym_LPAREN] = ACTIONS(2340),
    [anon_sym_null] = ACTIONS(2340),
    [anon_sym_AMP] = ACTIONS(2340),
    [anon_sym_LBRACK] = ACTIONS(2340),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2342),
    [anon_sym_LBRACE] = ACTIONS(2340),
    [anon_sym_LT_AT] = ACTIONS(2340),
    [anon_sym_LT_AT_AT] = ACTIONS(2342),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2342),
    [anon_sym_new] = ACTIONS(2340),
    [anon_sym_return_BANG] = ACTIONS(2342),
    [anon_sym_yield] = ACTIONS(2340),
    [anon_sym_yield_BANG] = ACTIONS(2342),
    [anon_sym_lazy] = ACTIONS(2340),
    [anon_sym_assert] = ACTIONS(2340),
    [anon_sym_upcast] = ACTIONS(2340),
    [anon_sym_downcast] = ACTIONS(2340),
    [anon_sym_COLON_GT] = ACTIONS(2342),
    [anon_sym_for] = ACTIONS(2340),
    [anon_sym_while] = ACTIONS(2340),
    [anon_sym_if] = ACTIONS(2340),
    [anon_sym_fun] = ACTIONS(2340),
    [anon_sym_DASH_GT] = ACTIONS(2342),
    [anon_sym_try] = ACTIONS(2340),
    [anon_sym_match] = ACTIONS(2340),
    [anon_sym_match_BANG] = ACTIONS(2342),
    [anon_sym_function] = ACTIONS(2340),
    [anon_sym_use] = ACTIONS(2340),
    [anon_sym_use_BANG] = ACTIONS(2342),
    [anon_sym_do_BANG] = ACTIONS(2342),
    [anon_sym_begin] = ACTIONS(2340),
    [anon_sym_STAR] = ACTIONS(2342),
    [anon_sym_LT2] = ACTIONS(2340),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2342),
    [anon_sym_or] = ACTIONS(2340),
    [aux_sym_char_token1] = ACTIONS(2342),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2340),
    [anon_sym_DQUOTE] = ACTIONS(2340),
    [anon_sym_AT_DQUOTE] = ACTIONS(2342),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2342),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2342),
    [sym_bool] = ACTIONS(2340),
    [sym_unit] = ACTIONS(2342),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2340),
    [sym_op_identifier] = ACTIONS(2342),
    [anon_sym_PLUS] = ACTIONS(2340),
    [anon_sym_DASH] = ACTIONS(2340),
    [anon_sym_PLUS_DOT] = ACTIONS(2342),
    [anon_sym_DASH_DOT] = ACTIONS(2342),
    [anon_sym_PERCENT] = ACTIONS(2342),
    [anon_sym_AMP_AMP] = ACTIONS(2342),
    [anon_sym_TILDE] = ACTIONS(2342),
    [aux_sym_prefix_op_token1] = ACTIONS(2342),
    [sym_int] = ACTIONS(2340),
    [sym_xint] = ACTIONS(2342),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2342),
    [sym__newline] = ACTIONS(2342),
  },
  [2749] = {
    [sym__type] = STATE(5002),
    [sym_simple_type] = STATE(5109),
    [sym_generic_type] = STATE(5109),
    [sym_paren_type] = STATE(5109),
    [sym_function_type] = STATE(5109),
    [sym_compound_type] = STATE(5109),
    [sym_postfix_type] = STATE(5109),
    [sym_list_type] = STATE(5109),
    [sym_static_type] = STATE(5109),
    [sym_constrained_type] = STATE(5109),
    [sym_flexible_type] = STATE(5109),
    [sym_anon_record_type] = STATE(5109),
    [sym__static_type_identifier] = STATE(4686),
    [sym__static_parameter] = STATE(6029),
    [sym_named_static_parameter] = STATE(6034),
    [sym_type_attribute] = STATE(5982),
    [sym_type_attributes] = STATE(6670),
    [sym_type_argument] = STATE(4913),
    [sym_static_parameter_value] = STATE(6034),
    [sym_char] = STATE(2803),
    [sym_format_string] = STATE(2805),
    [sym__string_literal] = STATE(2805),
    [sym_string] = STATE(2803),
    [sym_verbatim_string] = STATE(2803),
    [sym_bytearray] = STATE(2803),
    [sym_verbatim_bytearray] = STATE(2803),
    [sym_format_triple_quoted_string] = STATE(2809),
    [sym_triple_quoted_string] = STATE(2803),
    [sym_const] = STATE(432),
    [sym_long_identifier] = STATE(5121),
    [sym_sbyte] = STATE(2803),
    [sym_byte] = STATE(2803),
    [sym_int16] = STATE(2803),
    [sym_uint16] = STATE(2803),
    [sym_int32] = STATE(2803),
    [sym_uint32] = STATE(2803),
    [sym_nativeint] = STATE(2803),
    [sym_unativeint] = STATE(2803),
    [sym_int64] = STATE(2803),
    [sym_uint64] = STATE(2803),
    [sym_ieee32] = STATE(2803),
    [sym_ieee64] = STATE(2803),
    [sym_bignum] = STATE(2803),
    [sym_decimal] = STATE(2803),
    [sym_float] = STATE(2793),
    [sym_block_comment] = STATE(2749),
    [sym_compiler_directive_decl] = STATE(2749),
    [sym_fsi_directive_decl] = STATE(2749),
    [sym_preproc_line] = STATE(2749),
    [sym_identifier] = ACTIONS(4509),
    [anon_sym_LPAREN] = ACTIONS(4511),
    [anon_sym__] = ACTIONS(4513),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4515),
    [anon_sym_GT] = ACTIONS(4637),
    [anon_sym_POUND] = ACTIONS(4519),
    [anon_sym_CARET] = ACTIONS(4521),
    [anon_sym_SQUOTE] = ACTIONS(4521),
    [aux_sym_char_token1] = ACTIONS(4523),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4525),
    [anon_sym_DQUOTE] = ACTIONS(4527),
    [anon_sym_AT_DQUOTE] = ACTIONS(4529),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4531),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4533),
    [sym_bool] = ACTIONS(4535),
    [sym_unit] = ACTIONS(4537),
    [sym_int] = ACTIONS(4539),
    [sym_xint] = ACTIONS(4541),
    [anon_sym_LPAREN_STAR] = ACTIONS(27),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2750] = {
    [sym_block_comment] = STATE(2750),
    [sym_compiler_directive_decl] = STATE(2750),
    [sym_fsi_directive_decl] = STATE(2750),
    [sym_preproc_line] = STATE(2750),
    [aux_sym_long_identifier_repeat1] = STATE(2758),
    [sym_identifier] = ACTIONS(2418),
    [anon_sym_GT_RBRACK] = ACTIONS(2420),
    [anon_sym_return] = ACTIONS(2418),
    [anon_sym_do] = ACTIONS(2418),
    [anon_sym_let] = ACTIONS(2418),
    [anon_sym_let_BANG] = ACTIONS(2420),
    [anon_sym_LPAREN] = ACTIONS(2418),
    [anon_sym_null] = ACTIONS(2418),
    [anon_sym_AMP] = ACTIONS(2418),
    [anon_sym_LBRACK] = ACTIONS(2418),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2420),
    [anon_sym_LBRACE] = ACTIONS(2418),
    [anon_sym_LT_AT] = ACTIONS(2418),
    [anon_sym_LT_AT_AT] = ACTIONS(2420),
    [anon_sym_DOT] = ACTIONS(4599),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2420),
    [anon_sym_new] = ACTIONS(2418),
    [anon_sym_return_BANG] = ACTIONS(2420),
    [anon_sym_yield] = ACTIONS(2418),
    [anon_sym_yield_BANG] = ACTIONS(2420),
    [anon_sym_lazy] = ACTIONS(2418),
    [anon_sym_assert] = ACTIONS(2418),
    [anon_sym_upcast] = ACTIONS(2418),
    [anon_sym_downcast] = ACTIONS(2418),
    [anon_sym_for] = ACTIONS(2418),
    [anon_sym_while] = ACTIONS(2418),
    [anon_sym_if] = ACTIONS(2418),
    [anon_sym_fun] = ACTIONS(2418),
    [anon_sym_DASH_GT] = ACTIONS(2420),
    [anon_sym_try] = ACTIONS(2418),
    [anon_sym_match] = ACTIONS(2418),
    [anon_sym_match_BANG] = ACTIONS(2420),
    [anon_sym_function] = ACTIONS(2418),
    [anon_sym_use] = ACTIONS(2418),
    [anon_sym_use_BANG] = ACTIONS(2420),
    [anon_sym_do_BANG] = ACTIONS(2420),
    [anon_sym_begin] = ACTIONS(2418),
    [anon_sym_STAR] = ACTIONS(2420),
    [anon_sym_LT2] = ACTIONS(2418),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2420),
    [aux_sym_char_token1] = ACTIONS(2420),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2418),
    [anon_sym_DQUOTE] = ACTIONS(2418),
    [anon_sym_AT_DQUOTE] = ACTIONS(2420),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2420),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2420),
    [sym_bool] = ACTIONS(2418),
    [sym_unit] = ACTIONS(2420),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2418),
    [sym_op_identifier] = ACTIONS(2420),
    [anon_sym_PLUS] = ACTIONS(2418),
    [anon_sym_DASH] = ACTIONS(2418),
    [anon_sym_PLUS_DOT] = ACTIONS(2420),
    [anon_sym_DASH_DOT] = ACTIONS(2420),
    [anon_sym_PERCENT] = ACTIONS(2420),
    [anon_sym_AMP_AMP] = ACTIONS(2420),
    [anon_sym_TILDE] = ACTIONS(2420),
    [aux_sym_prefix_op_token1] = ACTIONS(2420),
    [sym_int] = ACTIONS(2418),
    [sym_xint] = ACTIONS(2420),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2420),
    [sym__newline] = ACTIONS(2420),
  },
  [2751] = {
    [sym__type] = STATE(5002),
    [sym_simple_type] = STATE(5109),
    [sym_generic_type] = STATE(5109),
    [sym_paren_type] = STATE(5109),
    [sym_function_type] = STATE(5109),
    [sym_compound_type] = STATE(5109),
    [sym_postfix_type] = STATE(5109),
    [sym_list_type] = STATE(5109),
    [sym_static_type] = STATE(5109),
    [sym_constrained_type] = STATE(5109),
    [sym_flexible_type] = STATE(5109),
    [sym_anon_record_type] = STATE(5109),
    [sym__static_type_identifier] = STATE(4686),
    [sym__static_parameter] = STATE(6029),
    [sym_named_static_parameter] = STATE(6034),
    [sym_type_attribute] = STATE(5982),
    [sym_type_attributes] = STATE(7276),
    [sym_type_argument] = STATE(4913),
    [sym_static_parameter_value] = STATE(6034),
    [sym_char] = STATE(2803),
    [sym_format_string] = STATE(2805),
    [sym__string_literal] = STATE(2805),
    [sym_string] = STATE(2803),
    [sym_verbatim_string] = STATE(2803),
    [sym_bytearray] = STATE(2803),
    [sym_verbatim_bytearray] = STATE(2803),
    [sym_format_triple_quoted_string] = STATE(2809),
    [sym_triple_quoted_string] = STATE(2803),
    [sym_const] = STATE(432),
    [sym_long_identifier] = STATE(5121),
    [sym_sbyte] = STATE(2803),
    [sym_byte] = STATE(2803),
    [sym_int16] = STATE(2803),
    [sym_uint16] = STATE(2803),
    [sym_int32] = STATE(2803),
    [sym_uint32] = STATE(2803),
    [sym_nativeint] = STATE(2803),
    [sym_unativeint] = STATE(2803),
    [sym_int64] = STATE(2803),
    [sym_uint64] = STATE(2803),
    [sym_ieee32] = STATE(2803),
    [sym_ieee64] = STATE(2803),
    [sym_bignum] = STATE(2803),
    [sym_decimal] = STATE(2803),
    [sym_float] = STATE(2793),
    [sym_block_comment] = STATE(2751),
    [sym_compiler_directive_decl] = STATE(2751),
    [sym_fsi_directive_decl] = STATE(2751),
    [sym_preproc_line] = STATE(2751),
    [sym_identifier] = ACTIONS(4509),
    [anon_sym_LPAREN] = ACTIONS(4511),
    [anon_sym__] = ACTIONS(4513),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4515),
    [anon_sym_GT] = ACTIONS(4639),
    [anon_sym_POUND] = ACTIONS(4519),
    [anon_sym_CARET] = ACTIONS(4521),
    [anon_sym_SQUOTE] = ACTIONS(4521),
    [aux_sym_char_token1] = ACTIONS(4523),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4525),
    [anon_sym_DQUOTE] = ACTIONS(4527),
    [anon_sym_AT_DQUOTE] = ACTIONS(4529),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4531),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4533),
    [sym_bool] = ACTIONS(4535),
    [sym_unit] = ACTIONS(4537),
    [sym_int] = ACTIONS(4539),
    [sym_xint] = ACTIONS(4541),
    [anon_sym_LPAREN_STAR] = ACTIONS(27),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2752] = {
    [sym__type] = STATE(5002),
    [sym_simple_type] = STATE(5109),
    [sym_generic_type] = STATE(5109),
    [sym_paren_type] = STATE(5109),
    [sym_function_type] = STATE(5109),
    [sym_compound_type] = STATE(5109),
    [sym_postfix_type] = STATE(5109),
    [sym_list_type] = STATE(5109),
    [sym_static_type] = STATE(5109),
    [sym_constrained_type] = STATE(5109),
    [sym_flexible_type] = STATE(5109),
    [sym_anon_record_type] = STATE(5109),
    [sym__static_type_identifier] = STATE(4686),
    [sym__static_parameter] = STATE(6029),
    [sym_named_static_parameter] = STATE(6034),
    [sym_type_attribute] = STATE(5982),
    [sym_type_attributes] = STATE(6515),
    [sym_type_argument] = STATE(4913),
    [sym_static_parameter_value] = STATE(6034),
    [sym_char] = STATE(2803),
    [sym_format_string] = STATE(2805),
    [sym__string_literal] = STATE(2805),
    [sym_string] = STATE(2803),
    [sym_verbatim_string] = STATE(2803),
    [sym_bytearray] = STATE(2803),
    [sym_verbatim_bytearray] = STATE(2803),
    [sym_format_triple_quoted_string] = STATE(2809),
    [sym_triple_quoted_string] = STATE(2803),
    [sym_const] = STATE(432),
    [sym_long_identifier] = STATE(5121),
    [sym_sbyte] = STATE(2803),
    [sym_byte] = STATE(2803),
    [sym_int16] = STATE(2803),
    [sym_uint16] = STATE(2803),
    [sym_int32] = STATE(2803),
    [sym_uint32] = STATE(2803),
    [sym_nativeint] = STATE(2803),
    [sym_unativeint] = STATE(2803),
    [sym_int64] = STATE(2803),
    [sym_uint64] = STATE(2803),
    [sym_ieee32] = STATE(2803),
    [sym_ieee64] = STATE(2803),
    [sym_bignum] = STATE(2803),
    [sym_decimal] = STATE(2803),
    [sym_float] = STATE(2793),
    [sym_block_comment] = STATE(2752),
    [sym_compiler_directive_decl] = STATE(2752),
    [sym_fsi_directive_decl] = STATE(2752),
    [sym_preproc_line] = STATE(2752),
    [sym_identifier] = ACTIONS(4509),
    [anon_sym_LPAREN] = ACTIONS(4511),
    [anon_sym__] = ACTIONS(4513),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4515),
    [anon_sym_GT] = ACTIONS(4641),
    [anon_sym_POUND] = ACTIONS(4519),
    [anon_sym_CARET] = ACTIONS(4521),
    [anon_sym_SQUOTE] = ACTIONS(4521),
    [aux_sym_char_token1] = ACTIONS(4523),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4525),
    [anon_sym_DQUOTE] = ACTIONS(4527),
    [anon_sym_AT_DQUOTE] = ACTIONS(4529),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4531),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4533),
    [sym_bool] = ACTIONS(4535),
    [sym_unit] = ACTIONS(4537),
    [sym_int] = ACTIONS(4539),
    [sym_xint] = ACTIONS(4541),
    [anon_sym_LPAREN_STAR] = ACTIONS(27),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2753] = {
    [sym__type] = STATE(5002),
    [sym_simple_type] = STATE(5109),
    [sym_generic_type] = STATE(5109),
    [sym_paren_type] = STATE(5109),
    [sym_function_type] = STATE(5109),
    [sym_compound_type] = STATE(5109),
    [sym_postfix_type] = STATE(5109),
    [sym_list_type] = STATE(5109),
    [sym_static_type] = STATE(5109),
    [sym_constrained_type] = STATE(5109),
    [sym_flexible_type] = STATE(5109),
    [sym_anon_record_type] = STATE(5109),
    [sym__static_type_identifier] = STATE(4686),
    [sym__static_parameter] = STATE(6029),
    [sym_named_static_parameter] = STATE(6034),
    [sym_type_attribute] = STATE(5982),
    [sym_type_attributes] = STATE(7041),
    [sym_type_argument] = STATE(4913),
    [sym_static_parameter_value] = STATE(6034),
    [sym_char] = STATE(2803),
    [sym_format_string] = STATE(2805),
    [sym__string_literal] = STATE(2805),
    [sym_string] = STATE(2803),
    [sym_verbatim_string] = STATE(2803),
    [sym_bytearray] = STATE(2803),
    [sym_verbatim_bytearray] = STATE(2803),
    [sym_format_triple_quoted_string] = STATE(2809),
    [sym_triple_quoted_string] = STATE(2803),
    [sym_const] = STATE(432),
    [sym_long_identifier] = STATE(5121),
    [sym_sbyte] = STATE(2803),
    [sym_byte] = STATE(2803),
    [sym_int16] = STATE(2803),
    [sym_uint16] = STATE(2803),
    [sym_int32] = STATE(2803),
    [sym_uint32] = STATE(2803),
    [sym_nativeint] = STATE(2803),
    [sym_unativeint] = STATE(2803),
    [sym_int64] = STATE(2803),
    [sym_uint64] = STATE(2803),
    [sym_ieee32] = STATE(2803),
    [sym_ieee64] = STATE(2803),
    [sym_bignum] = STATE(2803),
    [sym_decimal] = STATE(2803),
    [sym_float] = STATE(2793),
    [sym_block_comment] = STATE(2753),
    [sym_compiler_directive_decl] = STATE(2753),
    [sym_fsi_directive_decl] = STATE(2753),
    [sym_preproc_line] = STATE(2753),
    [sym_identifier] = ACTIONS(4509),
    [anon_sym_LPAREN] = ACTIONS(4511),
    [anon_sym__] = ACTIONS(4513),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4515),
    [anon_sym_GT] = ACTIONS(4643),
    [anon_sym_POUND] = ACTIONS(4519),
    [anon_sym_CARET] = ACTIONS(4521),
    [anon_sym_SQUOTE] = ACTIONS(4521),
    [aux_sym_char_token1] = ACTIONS(4523),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4525),
    [anon_sym_DQUOTE] = ACTIONS(4527),
    [anon_sym_AT_DQUOTE] = ACTIONS(4529),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4531),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4533),
    [sym_bool] = ACTIONS(4535),
    [sym_unit] = ACTIONS(4537),
    [sym_int] = ACTIONS(4539),
    [sym_xint] = ACTIONS(4541),
    [anon_sym_LPAREN_STAR] = ACTIONS(27),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2754] = {
    [sym__type] = STATE(5002),
    [sym_simple_type] = STATE(5109),
    [sym_generic_type] = STATE(5109),
    [sym_paren_type] = STATE(5109),
    [sym_function_type] = STATE(5109),
    [sym_compound_type] = STATE(5109),
    [sym_postfix_type] = STATE(5109),
    [sym_list_type] = STATE(5109),
    [sym_static_type] = STATE(5109),
    [sym_constrained_type] = STATE(5109),
    [sym_flexible_type] = STATE(5109),
    [sym_anon_record_type] = STATE(5109),
    [sym__static_type_identifier] = STATE(4686),
    [sym__static_parameter] = STATE(6029),
    [sym_named_static_parameter] = STATE(6034),
    [sym_type_attribute] = STATE(5982),
    [sym_type_attributes] = STATE(7115),
    [sym_type_argument] = STATE(4913),
    [sym_static_parameter_value] = STATE(6034),
    [sym_char] = STATE(2803),
    [sym_format_string] = STATE(2805),
    [sym__string_literal] = STATE(2805),
    [sym_string] = STATE(2803),
    [sym_verbatim_string] = STATE(2803),
    [sym_bytearray] = STATE(2803),
    [sym_verbatim_bytearray] = STATE(2803),
    [sym_format_triple_quoted_string] = STATE(2809),
    [sym_triple_quoted_string] = STATE(2803),
    [sym_const] = STATE(432),
    [sym_long_identifier] = STATE(5121),
    [sym_sbyte] = STATE(2803),
    [sym_byte] = STATE(2803),
    [sym_int16] = STATE(2803),
    [sym_uint16] = STATE(2803),
    [sym_int32] = STATE(2803),
    [sym_uint32] = STATE(2803),
    [sym_nativeint] = STATE(2803),
    [sym_unativeint] = STATE(2803),
    [sym_int64] = STATE(2803),
    [sym_uint64] = STATE(2803),
    [sym_ieee32] = STATE(2803),
    [sym_ieee64] = STATE(2803),
    [sym_bignum] = STATE(2803),
    [sym_decimal] = STATE(2803),
    [sym_float] = STATE(2793),
    [sym_block_comment] = STATE(2754),
    [sym_compiler_directive_decl] = STATE(2754),
    [sym_fsi_directive_decl] = STATE(2754),
    [sym_preproc_line] = STATE(2754),
    [sym_identifier] = ACTIONS(4509),
    [anon_sym_LPAREN] = ACTIONS(4511),
    [anon_sym__] = ACTIONS(4513),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4515),
    [anon_sym_GT] = ACTIONS(4645),
    [anon_sym_POUND] = ACTIONS(4519),
    [anon_sym_CARET] = ACTIONS(4521),
    [anon_sym_SQUOTE] = ACTIONS(4521),
    [aux_sym_char_token1] = ACTIONS(4523),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4525),
    [anon_sym_DQUOTE] = ACTIONS(4527),
    [anon_sym_AT_DQUOTE] = ACTIONS(4529),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4531),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4533),
    [sym_bool] = ACTIONS(4535),
    [sym_unit] = ACTIONS(4537),
    [sym_int] = ACTIONS(4539),
    [sym_xint] = ACTIONS(4541),
    [anon_sym_LPAREN_STAR] = ACTIONS(27),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2755] = {
    [sym__type] = STATE(5002),
    [sym_simple_type] = STATE(5109),
    [sym_generic_type] = STATE(5109),
    [sym_paren_type] = STATE(5109),
    [sym_function_type] = STATE(5109),
    [sym_compound_type] = STATE(5109),
    [sym_postfix_type] = STATE(5109),
    [sym_list_type] = STATE(5109),
    [sym_static_type] = STATE(5109),
    [sym_constrained_type] = STATE(5109),
    [sym_flexible_type] = STATE(5109),
    [sym_anon_record_type] = STATE(5109),
    [sym__static_type_identifier] = STATE(4686),
    [sym__static_parameter] = STATE(6029),
    [sym_named_static_parameter] = STATE(6034),
    [sym_type_attribute] = STATE(5982),
    [sym_type_attributes] = STATE(6850),
    [sym_type_argument] = STATE(4913),
    [sym_static_parameter_value] = STATE(6034),
    [sym_char] = STATE(2803),
    [sym_format_string] = STATE(2805),
    [sym__string_literal] = STATE(2805),
    [sym_string] = STATE(2803),
    [sym_verbatim_string] = STATE(2803),
    [sym_bytearray] = STATE(2803),
    [sym_verbatim_bytearray] = STATE(2803),
    [sym_format_triple_quoted_string] = STATE(2809),
    [sym_triple_quoted_string] = STATE(2803),
    [sym_const] = STATE(432),
    [sym_long_identifier] = STATE(5121),
    [sym_sbyte] = STATE(2803),
    [sym_byte] = STATE(2803),
    [sym_int16] = STATE(2803),
    [sym_uint16] = STATE(2803),
    [sym_int32] = STATE(2803),
    [sym_uint32] = STATE(2803),
    [sym_nativeint] = STATE(2803),
    [sym_unativeint] = STATE(2803),
    [sym_int64] = STATE(2803),
    [sym_uint64] = STATE(2803),
    [sym_ieee32] = STATE(2803),
    [sym_ieee64] = STATE(2803),
    [sym_bignum] = STATE(2803),
    [sym_decimal] = STATE(2803),
    [sym_float] = STATE(2793),
    [sym_block_comment] = STATE(2755),
    [sym_compiler_directive_decl] = STATE(2755),
    [sym_fsi_directive_decl] = STATE(2755),
    [sym_preproc_line] = STATE(2755),
    [sym_identifier] = ACTIONS(4509),
    [anon_sym_LPAREN] = ACTIONS(4511),
    [anon_sym__] = ACTIONS(4513),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4515),
    [anon_sym_GT] = ACTIONS(4647),
    [anon_sym_POUND] = ACTIONS(4519),
    [anon_sym_CARET] = ACTIONS(4521),
    [anon_sym_SQUOTE] = ACTIONS(4521),
    [aux_sym_char_token1] = ACTIONS(4523),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4525),
    [anon_sym_DQUOTE] = ACTIONS(4527),
    [anon_sym_AT_DQUOTE] = ACTIONS(4529),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4531),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4533),
    [sym_bool] = ACTIONS(4535),
    [sym_unit] = ACTIONS(4537),
    [sym_int] = ACTIONS(4539),
    [sym_xint] = ACTIONS(4541),
    [anon_sym_LPAREN_STAR] = ACTIONS(27),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2756] = {
    [sym__type] = STATE(5002),
    [sym_simple_type] = STATE(5109),
    [sym_generic_type] = STATE(5109),
    [sym_paren_type] = STATE(5109),
    [sym_function_type] = STATE(5109),
    [sym_compound_type] = STATE(5109),
    [sym_postfix_type] = STATE(5109),
    [sym_list_type] = STATE(5109),
    [sym_static_type] = STATE(5109),
    [sym_constrained_type] = STATE(5109),
    [sym_flexible_type] = STATE(5109),
    [sym_anon_record_type] = STATE(5109),
    [sym__static_type_identifier] = STATE(4686),
    [sym__static_parameter] = STATE(6029),
    [sym_named_static_parameter] = STATE(6034),
    [sym_type_attribute] = STATE(5982),
    [sym_type_attributes] = STATE(6914),
    [sym_type_argument] = STATE(4913),
    [sym_static_parameter_value] = STATE(6034),
    [sym_char] = STATE(2803),
    [sym_format_string] = STATE(2805),
    [sym__string_literal] = STATE(2805),
    [sym_string] = STATE(2803),
    [sym_verbatim_string] = STATE(2803),
    [sym_bytearray] = STATE(2803),
    [sym_verbatim_bytearray] = STATE(2803),
    [sym_format_triple_quoted_string] = STATE(2809),
    [sym_triple_quoted_string] = STATE(2803),
    [sym_const] = STATE(432),
    [sym_long_identifier] = STATE(5121),
    [sym_sbyte] = STATE(2803),
    [sym_byte] = STATE(2803),
    [sym_int16] = STATE(2803),
    [sym_uint16] = STATE(2803),
    [sym_int32] = STATE(2803),
    [sym_uint32] = STATE(2803),
    [sym_nativeint] = STATE(2803),
    [sym_unativeint] = STATE(2803),
    [sym_int64] = STATE(2803),
    [sym_uint64] = STATE(2803),
    [sym_ieee32] = STATE(2803),
    [sym_ieee64] = STATE(2803),
    [sym_bignum] = STATE(2803),
    [sym_decimal] = STATE(2803),
    [sym_float] = STATE(2793),
    [sym_block_comment] = STATE(2756),
    [sym_compiler_directive_decl] = STATE(2756),
    [sym_fsi_directive_decl] = STATE(2756),
    [sym_preproc_line] = STATE(2756),
    [sym_identifier] = ACTIONS(4509),
    [anon_sym_LPAREN] = ACTIONS(4511),
    [anon_sym__] = ACTIONS(4513),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4515),
    [anon_sym_GT] = ACTIONS(4649),
    [anon_sym_POUND] = ACTIONS(4519),
    [anon_sym_CARET] = ACTIONS(4521),
    [anon_sym_SQUOTE] = ACTIONS(4521),
    [aux_sym_char_token1] = ACTIONS(4523),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4525),
    [anon_sym_DQUOTE] = ACTIONS(4527),
    [anon_sym_AT_DQUOTE] = ACTIONS(4529),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4531),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4533),
    [sym_bool] = ACTIONS(4535),
    [sym_unit] = ACTIONS(4537),
    [sym_int] = ACTIONS(4539),
    [sym_xint] = ACTIONS(4541),
    [anon_sym_LPAREN_STAR] = ACTIONS(27),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2757] = {
    [sym__type] = STATE(5002),
    [sym_simple_type] = STATE(5109),
    [sym_generic_type] = STATE(5109),
    [sym_paren_type] = STATE(5109),
    [sym_function_type] = STATE(5109),
    [sym_compound_type] = STATE(5109),
    [sym_postfix_type] = STATE(5109),
    [sym_list_type] = STATE(5109),
    [sym_static_type] = STATE(5109),
    [sym_constrained_type] = STATE(5109),
    [sym_flexible_type] = STATE(5109),
    [sym_anon_record_type] = STATE(5109),
    [sym__static_type_identifier] = STATE(4686),
    [sym__static_parameter] = STATE(6029),
    [sym_named_static_parameter] = STATE(6034),
    [sym_type_attribute] = STATE(5982),
    [sym_type_attributes] = STATE(6768),
    [sym_type_argument] = STATE(4913),
    [sym_static_parameter_value] = STATE(6034),
    [sym_char] = STATE(2803),
    [sym_format_string] = STATE(2805),
    [sym__string_literal] = STATE(2805),
    [sym_string] = STATE(2803),
    [sym_verbatim_string] = STATE(2803),
    [sym_bytearray] = STATE(2803),
    [sym_verbatim_bytearray] = STATE(2803),
    [sym_format_triple_quoted_string] = STATE(2809),
    [sym_triple_quoted_string] = STATE(2803),
    [sym_const] = STATE(432),
    [sym_long_identifier] = STATE(5121),
    [sym_sbyte] = STATE(2803),
    [sym_byte] = STATE(2803),
    [sym_int16] = STATE(2803),
    [sym_uint16] = STATE(2803),
    [sym_int32] = STATE(2803),
    [sym_uint32] = STATE(2803),
    [sym_nativeint] = STATE(2803),
    [sym_unativeint] = STATE(2803),
    [sym_int64] = STATE(2803),
    [sym_uint64] = STATE(2803),
    [sym_ieee32] = STATE(2803),
    [sym_ieee64] = STATE(2803),
    [sym_bignum] = STATE(2803),
    [sym_decimal] = STATE(2803),
    [sym_float] = STATE(2793),
    [sym_block_comment] = STATE(2757),
    [sym_compiler_directive_decl] = STATE(2757),
    [sym_fsi_directive_decl] = STATE(2757),
    [sym_preproc_line] = STATE(2757),
    [sym_identifier] = ACTIONS(4509),
    [anon_sym_LPAREN] = ACTIONS(4511),
    [anon_sym__] = ACTIONS(4513),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4515),
    [anon_sym_GT] = ACTIONS(4651),
    [anon_sym_POUND] = ACTIONS(4519),
    [anon_sym_CARET] = ACTIONS(4521),
    [anon_sym_SQUOTE] = ACTIONS(4521),
    [aux_sym_char_token1] = ACTIONS(4523),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4525),
    [anon_sym_DQUOTE] = ACTIONS(4527),
    [anon_sym_AT_DQUOTE] = ACTIONS(4529),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4531),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4533),
    [sym_bool] = ACTIONS(4535),
    [sym_unit] = ACTIONS(4537),
    [sym_int] = ACTIONS(4539),
    [sym_xint] = ACTIONS(4541),
    [anon_sym_LPAREN_STAR] = ACTIONS(27),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2758] = {
    [sym_block_comment] = STATE(2758),
    [sym_compiler_directive_decl] = STATE(2758),
    [sym_fsi_directive_decl] = STATE(2758),
    [sym_preproc_line] = STATE(2758),
    [aux_sym_long_identifier_repeat1] = STATE(2758),
    [sym_identifier] = ACTIONS(2411),
    [anon_sym_GT_RBRACK] = ACTIONS(2413),
    [anon_sym_return] = ACTIONS(2411),
    [anon_sym_do] = ACTIONS(2411),
    [anon_sym_let] = ACTIONS(2411),
    [anon_sym_let_BANG] = ACTIONS(2413),
    [anon_sym_LPAREN] = ACTIONS(2411),
    [anon_sym_null] = ACTIONS(2411),
    [anon_sym_AMP] = ACTIONS(2411),
    [anon_sym_LBRACK] = ACTIONS(2411),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2413),
    [anon_sym_LBRACE] = ACTIONS(2411),
    [anon_sym_LT_AT] = ACTIONS(2411),
    [anon_sym_LT_AT_AT] = ACTIONS(2413),
    [anon_sym_DOT] = ACTIONS(4653),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2413),
    [anon_sym_new] = ACTIONS(2411),
    [anon_sym_return_BANG] = ACTIONS(2413),
    [anon_sym_yield] = ACTIONS(2411),
    [anon_sym_yield_BANG] = ACTIONS(2413),
    [anon_sym_lazy] = ACTIONS(2411),
    [anon_sym_assert] = ACTIONS(2411),
    [anon_sym_upcast] = ACTIONS(2411),
    [anon_sym_downcast] = ACTIONS(2411),
    [anon_sym_for] = ACTIONS(2411),
    [anon_sym_while] = ACTIONS(2411),
    [anon_sym_if] = ACTIONS(2411),
    [anon_sym_fun] = ACTIONS(2411),
    [anon_sym_DASH_GT] = ACTIONS(2413),
    [anon_sym_try] = ACTIONS(2411),
    [anon_sym_match] = ACTIONS(2411),
    [anon_sym_match_BANG] = ACTIONS(2413),
    [anon_sym_function] = ACTIONS(2411),
    [anon_sym_use] = ACTIONS(2411),
    [anon_sym_use_BANG] = ACTIONS(2413),
    [anon_sym_do_BANG] = ACTIONS(2413),
    [anon_sym_begin] = ACTIONS(2411),
    [anon_sym_STAR] = ACTIONS(2413),
    [anon_sym_LT2] = ACTIONS(2411),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2413),
    [aux_sym_char_token1] = ACTIONS(2413),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2411),
    [anon_sym_DQUOTE] = ACTIONS(2411),
    [anon_sym_AT_DQUOTE] = ACTIONS(2413),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2413),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2413),
    [sym_bool] = ACTIONS(2411),
    [sym_unit] = ACTIONS(2413),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2411),
    [sym_op_identifier] = ACTIONS(2413),
    [anon_sym_PLUS] = ACTIONS(2411),
    [anon_sym_DASH] = ACTIONS(2411),
    [anon_sym_PLUS_DOT] = ACTIONS(2413),
    [anon_sym_DASH_DOT] = ACTIONS(2413),
    [anon_sym_PERCENT] = ACTIONS(2413),
    [anon_sym_AMP_AMP] = ACTIONS(2413),
    [anon_sym_TILDE] = ACTIONS(2413),
    [aux_sym_prefix_op_token1] = ACTIONS(2413),
    [sym_int] = ACTIONS(2411),
    [sym_xint] = ACTIONS(2413),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2413),
    [sym__newline] = ACTIONS(2413),
  },
  [2759] = {
    [sym__type] = STATE(5002),
    [sym_simple_type] = STATE(5109),
    [sym_generic_type] = STATE(5109),
    [sym_paren_type] = STATE(5109),
    [sym_function_type] = STATE(5109),
    [sym_compound_type] = STATE(5109),
    [sym_postfix_type] = STATE(5109),
    [sym_list_type] = STATE(5109),
    [sym_static_type] = STATE(5109),
    [sym_constrained_type] = STATE(5109),
    [sym_flexible_type] = STATE(5109),
    [sym_anon_record_type] = STATE(5109),
    [sym__static_type_identifier] = STATE(4686),
    [sym__static_parameter] = STATE(6029),
    [sym_named_static_parameter] = STATE(6034),
    [sym_type_attribute] = STATE(5982),
    [sym_type_attributes] = STATE(7136),
    [sym_type_argument] = STATE(4913),
    [sym_static_parameter_value] = STATE(6034),
    [sym_char] = STATE(2803),
    [sym_format_string] = STATE(2805),
    [sym__string_literal] = STATE(2805),
    [sym_string] = STATE(2803),
    [sym_verbatim_string] = STATE(2803),
    [sym_bytearray] = STATE(2803),
    [sym_verbatim_bytearray] = STATE(2803),
    [sym_format_triple_quoted_string] = STATE(2809),
    [sym_triple_quoted_string] = STATE(2803),
    [sym_const] = STATE(432),
    [sym_long_identifier] = STATE(5121),
    [sym_sbyte] = STATE(2803),
    [sym_byte] = STATE(2803),
    [sym_int16] = STATE(2803),
    [sym_uint16] = STATE(2803),
    [sym_int32] = STATE(2803),
    [sym_uint32] = STATE(2803),
    [sym_nativeint] = STATE(2803),
    [sym_unativeint] = STATE(2803),
    [sym_int64] = STATE(2803),
    [sym_uint64] = STATE(2803),
    [sym_ieee32] = STATE(2803),
    [sym_ieee64] = STATE(2803),
    [sym_bignum] = STATE(2803),
    [sym_decimal] = STATE(2803),
    [sym_float] = STATE(2793),
    [sym_block_comment] = STATE(2759),
    [sym_compiler_directive_decl] = STATE(2759),
    [sym_fsi_directive_decl] = STATE(2759),
    [sym_preproc_line] = STATE(2759),
    [sym_identifier] = ACTIONS(4509),
    [anon_sym_LPAREN] = ACTIONS(4511),
    [anon_sym__] = ACTIONS(4513),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4515),
    [anon_sym_GT] = ACTIONS(4656),
    [anon_sym_POUND] = ACTIONS(4519),
    [anon_sym_CARET] = ACTIONS(4521),
    [anon_sym_SQUOTE] = ACTIONS(4521),
    [aux_sym_char_token1] = ACTIONS(4523),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4525),
    [anon_sym_DQUOTE] = ACTIONS(4527),
    [anon_sym_AT_DQUOTE] = ACTIONS(4529),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4531),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4533),
    [sym_bool] = ACTIONS(4535),
    [sym_unit] = ACTIONS(4537),
    [sym_int] = ACTIONS(4539),
    [sym_xint] = ACTIONS(4541),
    [anon_sym_LPAREN_STAR] = ACTIONS(27),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2760] = {
    [sym_argument_patterns] = STATE(6284),
    [sym__atomic_pattern] = STATE(4141),
    [sym_list_pattern] = STATE(4163),
    [sym_array_pattern] = STATE(4163),
    [sym_record_pattern] = STATE(4163),
    [sym_type_arguments] = STATE(2850),
    [sym_char] = STATE(4152),
    [sym_format_string] = STATE(4160),
    [sym__string_literal] = STATE(4160),
    [sym_string] = STATE(4152),
    [sym_verbatim_string] = STATE(4152),
    [sym_bytearray] = STATE(4152),
    [sym_verbatim_bytearray] = STATE(4152),
    [sym_format_triple_quoted_string] = STATE(4166),
    [sym_triple_quoted_string] = STATE(4152),
    [sym_const] = STATE(4163),
    [sym_long_identifier] = STATE(4163),
    [sym_sbyte] = STATE(4152),
    [sym_byte] = STATE(4152),
    [sym_int16] = STATE(4152),
    [sym_uint16] = STATE(4152),
    [sym_int32] = STATE(4152),
    [sym_uint32] = STATE(4152),
    [sym_nativeint] = STATE(4152),
    [sym_unativeint] = STATE(4152),
    [sym_int64] = STATE(4152),
    [sym_uint64] = STATE(4152),
    [sym_ieee32] = STATE(4152),
    [sym_ieee64] = STATE(4152),
    [sym_bignum] = STATE(4152),
    [sym_decimal] = STATE(4152),
    [sym_float] = STATE(3887),
    [sym_block_comment] = STATE(2760),
    [sym_compiler_directive_decl] = STATE(2760),
    [sym_fsi_directive_decl] = STATE(2760),
    [sym_preproc_line] = STATE(2760),
    [aux_sym_argument_patterns_repeat1] = STATE(2846),
    [sym_identifier] = ACTIONS(4601),
    [anon_sym_EQ] = ACTIONS(2869),
    [anon_sym_LBRACK_LT] = ACTIONS(2869),
    [anon_sym_COLON] = ACTIONS(2867),
    [anon_sym_as] = ACTIONS(2867),
    [anon_sym_LPAREN] = ACTIONS(4603),
    [anon_sym_COMMA] = ACTIONS(2869),
    [anon_sym_null] = ACTIONS(4605),
    [anon_sym__] = ACTIONS(4605),
    [anon_sym_QMARK] = ACTIONS(2869),
    [anon_sym_COLON_QMARK] = ACTIONS(2869),
    [anon_sym_COLON_COLON] = ACTIONS(2869),
    [anon_sym_PIPE] = ACTIONS(2869),
    [anon_sym_AMP] = ACTIONS(2869),
    [anon_sym_LBRACK] = ACTIONS(4607),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4609),
    [anon_sym_LBRACE] = ACTIONS(4611),
    [anon_sym_LT2] = ACTIONS(4613),
    [aux_sym_char_token1] = ACTIONS(4615),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4617),
    [anon_sym_DQUOTE] = ACTIONS(4619),
    [anon_sym_AT_DQUOTE] = ACTIONS(4621),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4623),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4625),
    [sym_bool] = ACTIONS(4627),
    [sym_unit] = ACTIONS(4629),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2867),
    [sym_op_identifier] = ACTIONS(2869),
    [sym_int] = ACTIONS(4631),
    [sym_xint] = ACTIONS(4633),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2761] = {
    [sym__type] = STATE(5002),
    [sym_simple_type] = STATE(5109),
    [sym_generic_type] = STATE(5109),
    [sym_paren_type] = STATE(5109),
    [sym_function_type] = STATE(5109),
    [sym_compound_type] = STATE(5109),
    [sym_postfix_type] = STATE(5109),
    [sym_list_type] = STATE(5109),
    [sym_static_type] = STATE(5109),
    [sym_constrained_type] = STATE(5109),
    [sym_flexible_type] = STATE(5109),
    [sym_anon_record_type] = STATE(5109),
    [sym__static_type_identifier] = STATE(4686),
    [sym__static_parameter] = STATE(6029),
    [sym_named_static_parameter] = STATE(6034),
    [sym_type_attribute] = STATE(5982),
    [sym_type_attributes] = STATE(6810),
    [sym_type_argument] = STATE(4913),
    [sym_static_parameter_value] = STATE(6034),
    [sym_char] = STATE(2803),
    [sym_format_string] = STATE(2805),
    [sym__string_literal] = STATE(2805),
    [sym_string] = STATE(2803),
    [sym_verbatim_string] = STATE(2803),
    [sym_bytearray] = STATE(2803),
    [sym_verbatim_bytearray] = STATE(2803),
    [sym_format_triple_quoted_string] = STATE(2809),
    [sym_triple_quoted_string] = STATE(2803),
    [sym_const] = STATE(432),
    [sym_long_identifier] = STATE(5121),
    [sym_sbyte] = STATE(2803),
    [sym_byte] = STATE(2803),
    [sym_int16] = STATE(2803),
    [sym_uint16] = STATE(2803),
    [sym_int32] = STATE(2803),
    [sym_uint32] = STATE(2803),
    [sym_nativeint] = STATE(2803),
    [sym_unativeint] = STATE(2803),
    [sym_int64] = STATE(2803),
    [sym_uint64] = STATE(2803),
    [sym_ieee32] = STATE(2803),
    [sym_ieee64] = STATE(2803),
    [sym_bignum] = STATE(2803),
    [sym_decimal] = STATE(2803),
    [sym_float] = STATE(2793),
    [sym_block_comment] = STATE(2761),
    [sym_compiler_directive_decl] = STATE(2761),
    [sym_fsi_directive_decl] = STATE(2761),
    [sym_preproc_line] = STATE(2761),
    [sym_identifier] = ACTIONS(4509),
    [anon_sym_LPAREN] = ACTIONS(4511),
    [anon_sym__] = ACTIONS(4513),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4515),
    [anon_sym_GT] = ACTIONS(4658),
    [anon_sym_POUND] = ACTIONS(4519),
    [anon_sym_CARET] = ACTIONS(4521),
    [anon_sym_SQUOTE] = ACTIONS(4521),
    [aux_sym_char_token1] = ACTIONS(4523),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4525),
    [anon_sym_DQUOTE] = ACTIONS(4527),
    [anon_sym_AT_DQUOTE] = ACTIONS(4529),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4531),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4533),
    [sym_bool] = ACTIONS(4535),
    [sym_unit] = ACTIONS(4537),
    [sym_int] = ACTIONS(4539),
    [sym_xint] = ACTIONS(4541),
    [anon_sym_LPAREN_STAR] = ACTIONS(27),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2762] = {
    [sym__type] = STATE(5002),
    [sym_simple_type] = STATE(5109),
    [sym_generic_type] = STATE(5109),
    [sym_paren_type] = STATE(5109),
    [sym_function_type] = STATE(5109),
    [sym_compound_type] = STATE(5109),
    [sym_postfix_type] = STATE(5109),
    [sym_list_type] = STATE(5109),
    [sym_static_type] = STATE(5109),
    [sym_constrained_type] = STATE(5109),
    [sym_flexible_type] = STATE(5109),
    [sym_anon_record_type] = STATE(5109),
    [sym__static_type_identifier] = STATE(4686),
    [sym__static_parameter] = STATE(6029),
    [sym_named_static_parameter] = STATE(6034),
    [sym_type_attribute] = STATE(5982),
    [sym_type_attributes] = STATE(6729),
    [sym_type_argument] = STATE(4913),
    [sym_static_parameter_value] = STATE(6034),
    [sym_char] = STATE(2803),
    [sym_format_string] = STATE(2805),
    [sym__string_literal] = STATE(2805),
    [sym_string] = STATE(2803),
    [sym_verbatim_string] = STATE(2803),
    [sym_bytearray] = STATE(2803),
    [sym_verbatim_bytearray] = STATE(2803),
    [sym_format_triple_quoted_string] = STATE(2809),
    [sym_triple_quoted_string] = STATE(2803),
    [sym_const] = STATE(432),
    [sym_long_identifier] = STATE(5121),
    [sym_sbyte] = STATE(2803),
    [sym_byte] = STATE(2803),
    [sym_int16] = STATE(2803),
    [sym_uint16] = STATE(2803),
    [sym_int32] = STATE(2803),
    [sym_uint32] = STATE(2803),
    [sym_nativeint] = STATE(2803),
    [sym_unativeint] = STATE(2803),
    [sym_int64] = STATE(2803),
    [sym_uint64] = STATE(2803),
    [sym_ieee32] = STATE(2803),
    [sym_ieee64] = STATE(2803),
    [sym_bignum] = STATE(2803),
    [sym_decimal] = STATE(2803),
    [sym_float] = STATE(2793),
    [sym_block_comment] = STATE(2762),
    [sym_compiler_directive_decl] = STATE(2762),
    [sym_fsi_directive_decl] = STATE(2762),
    [sym_preproc_line] = STATE(2762),
    [sym_identifier] = ACTIONS(4509),
    [anon_sym_LPAREN] = ACTIONS(4511),
    [anon_sym__] = ACTIONS(4513),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4515),
    [anon_sym_GT] = ACTIONS(4660),
    [anon_sym_POUND] = ACTIONS(4519),
    [anon_sym_CARET] = ACTIONS(4521),
    [anon_sym_SQUOTE] = ACTIONS(4521),
    [aux_sym_char_token1] = ACTIONS(4523),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4525),
    [anon_sym_DQUOTE] = ACTIONS(4527),
    [anon_sym_AT_DQUOTE] = ACTIONS(4529),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4531),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4533),
    [sym_bool] = ACTIONS(4535),
    [sym_unit] = ACTIONS(4537),
    [sym_int] = ACTIONS(4539),
    [sym_xint] = ACTIONS(4541),
    [anon_sym_LPAREN_STAR] = ACTIONS(27),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2763] = {
    [sym__type] = STATE(5002),
    [sym_simple_type] = STATE(5109),
    [sym_generic_type] = STATE(5109),
    [sym_paren_type] = STATE(5109),
    [sym_function_type] = STATE(5109),
    [sym_compound_type] = STATE(5109),
    [sym_postfix_type] = STATE(5109),
    [sym_list_type] = STATE(5109),
    [sym_static_type] = STATE(5109),
    [sym_constrained_type] = STATE(5109),
    [sym_flexible_type] = STATE(5109),
    [sym_anon_record_type] = STATE(5109),
    [sym__static_type_identifier] = STATE(4686),
    [sym__static_parameter] = STATE(6029),
    [sym_named_static_parameter] = STATE(6034),
    [sym_type_attribute] = STATE(5982),
    [sym_type_attributes] = STATE(6888),
    [sym_type_argument] = STATE(4913),
    [sym_static_parameter_value] = STATE(6034),
    [sym_char] = STATE(2803),
    [sym_format_string] = STATE(2805),
    [sym__string_literal] = STATE(2805),
    [sym_string] = STATE(2803),
    [sym_verbatim_string] = STATE(2803),
    [sym_bytearray] = STATE(2803),
    [sym_verbatim_bytearray] = STATE(2803),
    [sym_format_triple_quoted_string] = STATE(2809),
    [sym_triple_quoted_string] = STATE(2803),
    [sym_const] = STATE(432),
    [sym_long_identifier] = STATE(5121),
    [sym_sbyte] = STATE(2803),
    [sym_byte] = STATE(2803),
    [sym_int16] = STATE(2803),
    [sym_uint16] = STATE(2803),
    [sym_int32] = STATE(2803),
    [sym_uint32] = STATE(2803),
    [sym_nativeint] = STATE(2803),
    [sym_unativeint] = STATE(2803),
    [sym_int64] = STATE(2803),
    [sym_uint64] = STATE(2803),
    [sym_ieee32] = STATE(2803),
    [sym_ieee64] = STATE(2803),
    [sym_bignum] = STATE(2803),
    [sym_decimal] = STATE(2803),
    [sym_float] = STATE(2793),
    [sym_block_comment] = STATE(2763),
    [sym_compiler_directive_decl] = STATE(2763),
    [sym_fsi_directive_decl] = STATE(2763),
    [sym_preproc_line] = STATE(2763),
    [sym_identifier] = ACTIONS(4509),
    [anon_sym_LPAREN] = ACTIONS(4511),
    [anon_sym__] = ACTIONS(4513),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4515),
    [anon_sym_GT] = ACTIONS(4662),
    [anon_sym_POUND] = ACTIONS(4519),
    [anon_sym_CARET] = ACTIONS(4521),
    [anon_sym_SQUOTE] = ACTIONS(4521),
    [aux_sym_char_token1] = ACTIONS(4523),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4525),
    [anon_sym_DQUOTE] = ACTIONS(4527),
    [anon_sym_AT_DQUOTE] = ACTIONS(4529),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4531),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4533),
    [sym_bool] = ACTIONS(4535),
    [sym_unit] = ACTIONS(4537),
    [sym_int] = ACTIONS(4539),
    [sym_xint] = ACTIONS(4541),
    [anon_sym_LPAREN_STAR] = ACTIONS(27),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2764] = {
    [sym__type] = STATE(5002),
    [sym_simple_type] = STATE(5109),
    [sym_generic_type] = STATE(5109),
    [sym_paren_type] = STATE(5109),
    [sym_function_type] = STATE(5109),
    [sym_compound_type] = STATE(5109),
    [sym_postfix_type] = STATE(5109),
    [sym_list_type] = STATE(5109),
    [sym_static_type] = STATE(5109),
    [sym_constrained_type] = STATE(5109),
    [sym_flexible_type] = STATE(5109),
    [sym_anon_record_type] = STATE(5109),
    [sym__static_type_identifier] = STATE(4686),
    [sym__static_parameter] = STATE(6029),
    [sym_named_static_parameter] = STATE(6034),
    [sym_type_attribute] = STATE(5982),
    [sym_type_attributes] = STATE(6723),
    [sym_type_argument] = STATE(4913),
    [sym_static_parameter_value] = STATE(6034),
    [sym_char] = STATE(2803),
    [sym_format_string] = STATE(2805),
    [sym__string_literal] = STATE(2805),
    [sym_string] = STATE(2803),
    [sym_verbatim_string] = STATE(2803),
    [sym_bytearray] = STATE(2803),
    [sym_verbatim_bytearray] = STATE(2803),
    [sym_format_triple_quoted_string] = STATE(2809),
    [sym_triple_quoted_string] = STATE(2803),
    [sym_const] = STATE(432),
    [sym_long_identifier] = STATE(5121),
    [sym_sbyte] = STATE(2803),
    [sym_byte] = STATE(2803),
    [sym_int16] = STATE(2803),
    [sym_uint16] = STATE(2803),
    [sym_int32] = STATE(2803),
    [sym_uint32] = STATE(2803),
    [sym_nativeint] = STATE(2803),
    [sym_unativeint] = STATE(2803),
    [sym_int64] = STATE(2803),
    [sym_uint64] = STATE(2803),
    [sym_ieee32] = STATE(2803),
    [sym_ieee64] = STATE(2803),
    [sym_bignum] = STATE(2803),
    [sym_decimal] = STATE(2803),
    [sym_float] = STATE(2793),
    [sym_block_comment] = STATE(2764),
    [sym_compiler_directive_decl] = STATE(2764),
    [sym_fsi_directive_decl] = STATE(2764),
    [sym_preproc_line] = STATE(2764),
    [sym_identifier] = ACTIONS(4509),
    [anon_sym_LPAREN] = ACTIONS(4511),
    [anon_sym__] = ACTIONS(4513),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4515),
    [anon_sym_GT] = ACTIONS(4664),
    [anon_sym_POUND] = ACTIONS(4519),
    [anon_sym_CARET] = ACTIONS(4521),
    [anon_sym_SQUOTE] = ACTIONS(4521),
    [aux_sym_char_token1] = ACTIONS(4523),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4525),
    [anon_sym_DQUOTE] = ACTIONS(4527),
    [anon_sym_AT_DQUOTE] = ACTIONS(4529),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4531),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4533),
    [sym_bool] = ACTIONS(4535),
    [sym_unit] = ACTIONS(4537),
    [sym_int] = ACTIONS(4539),
    [sym_xint] = ACTIONS(4541),
    [anon_sym_LPAREN_STAR] = ACTIONS(27),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2765] = {
    [sym__type] = STATE(5002),
    [sym_simple_type] = STATE(5109),
    [sym_generic_type] = STATE(5109),
    [sym_paren_type] = STATE(5109),
    [sym_function_type] = STATE(5109),
    [sym_compound_type] = STATE(5109),
    [sym_postfix_type] = STATE(5109),
    [sym_list_type] = STATE(5109),
    [sym_static_type] = STATE(5109),
    [sym_constrained_type] = STATE(5109),
    [sym_flexible_type] = STATE(5109),
    [sym_anon_record_type] = STATE(5109),
    [sym__static_type_identifier] = STATE(4686),
    [sym__static_parameter] = STATE(6029),
    [sym_named_static_parameter] = STATE(6034),
    [sym_type_attribute] = STATE(5982),
    [sym_type_attributes] = STATE(6494),
    [sym_type_argument] = STATE(4913),
    [sym_static_parameter_value] = STATE(6034),
    [sym_char] = STATE(2803),
    [sym_format_string] = STATE(2805),
    [sym__string_literal] = STATE(2805),
    [sym_string] = STATE(2803),
    [sym_verbatim_string] = STATE(2803),
    [sym_bytearray] = STATE(2803),
    [sym_verbatim_bytearray] = STATE(2803),
    [sym_format_triple_quoted_string] = STATE(2809),
    [sym_triple_quoted_string] = STATE(2803),
    [sym_const] = STATE(432),
    [sym_long_identifier] = STATE(5121),
    [sym_sbyte] = STATE(2803),
    [sym_byte] = STATE(2803),
    [sym_int16] = STATE(2803),
    [sym_uint16] = STATE(2803),
    [sym_int32] = STATE(2803),
    [sym_uint32] = STATE(2803),
    [sym_nativeint] = STATE(2803),
    [sym_unativeint] = STATE(2803),
    [sym_int64] = STATE(2803),
    [sym_uint64] = STATE(2803),
    [sym_ieee32] = STATE(2803),
    [sym_ieee64] = STATE(2803),
    [sym_bignum] = STATE(2803),
    [sym_decimal] = STATE(2803),
    [sym_float] = STATE(2793),
    [sym_block_comment] = STATE(2765),
    [sym_compiler_directive_decl] = STATE(2765),
    [sym_fsi_directive_decl] = STATE(2765),
    [sym_preproc_line] = STATE(2765),
    [sym_identifier] = ACTIONS(4509),
    [anon_sym_LPAREN] = ACTIONS(4511),
    [anon_sym__] = ACTIONS(4513),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4515),
    [anon_sym_POUND] = ACTIONS(4519),
    [anon_sym_CARET] = ACTIONS(4521),
    [anon_sym_SQUOTE] = ACTIONS(4521),
    [aux_sym_char_token1] = ACTIONS(4523),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4525),
    [anon_sym_DQUOTE] = ACTIONS(4527),
    [anon_sym_AT_DQUOTE] = ACTIONS(4529),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4531),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4533),
    [sym_bool] = ACTIONS(4535),
    [sym_unit] = ACTIONS(4537),
    [sym_int] = ACTIONS(4539),
    [sym_xint] = ACTIONS(4541),
    [anon_sym_LPAREN_STAR] = ACTIONS(27),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2766] = {
    [sym__type] = STATE(5002),
    [sym_simple_type] = STATE(5109),
    [sym_generic_type] = STATE(5109),
    [sym_paren_type] = STATE(5109),
    [sym_function_type] = STATE(5109),
    [sym_compound_type] = STATE(5109),
    [sym_postfix_type] = STATE(5109),
    [sym_list_type] = STATE(5109),
    [sym_static_type] = STATE(5109),
    [sym_constrained_type] = STATE(5109),
    [sym_flexible_type] = STATE(5109),
    [sym_anon_record_type] = STATE(5109),
    [sym__static_type_identifier] = STATE(4686),
    [sym__static_parameter] = STATE(6029),
    [sym_named_static_parameter] = STATE(6034),
    [sym_type_attribute] = STATE(5982),
    [sym_type_attributes] = STATE(6966),
    [sym_type_argument] = STATE(4913),
    [sym_static_parameter_value] = STATE(6034),
    [sym_char] = STATE(2803),
    [sym_format_string] = STATE(2805),
    [sym__string_literal] = STATE(2805),
    [sym_string] = STATE(2803),
    [sym_verbatim_string] = STATE(2803),
    [sym_bytearray] = STATE(2803),
    [sym_verbatim_bytearray] = STATE(2803),
    [sym_format_triple_quoted_string] = STATE(2809),
    [sym_triple_quoted_string] = STATE(2803),
    [sym_const] = STATE(432),
    [sym_long_identifier] = STATE(5121),
    [sym_sbyte] = STATE(2803),
    [sym_byte] = STATE(2803),
    [sym_int16] = STATE(2803),
    [sym_uint16] = STATE(2803),
    [sym_int32] = STATE(2803),
    [sym_uint32] = STATE(2803),
    [sym_nativeint] = STATE(2803),
    [sym_unativeint] = STATE(2803),
    [sym_int64] = STATE(2803),
    [sym_uint64] = STATE(2803),
    [sym_ieee32] = STATE(2803),
    [sym_ieee64] = STATE(2803),
    [sym_bignum] = STATE(2803),
    [sym_decimal] = STATE(2803),
    [sym_float] = STATE(2793),
    [sym_block_comment] = STATE(2766),
    [sym_compiler_directive_decl] = STATE(2766),
    [sym_fsi_directive_decl] = STATE(2766),
    [sym_preproc_line] = STATE(2766),
    [sym_identifier] = ACTIONS(4509),
    [anon_sym_LPAREN] = ACTIONS(4511),
    [anon_sym__] = ACTIONS(4513),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4515),
    [anon_sym_POUND] = ACTIONS(4519),
    [anon_sym_CARET] = ACTIONS(4521),
    [anon_sym_SQUOTE] = ACTIONS(4521),
    [aux_sym_char_token1] = ACTIONS(4523),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4525),
    [anon_sym_DQUOTE] = ACTIONS(4527),
    [anon_sym_AT_DQUOTE] = ACTIONS(4529),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4531),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4533),
    [sym_bool] = ACTIONS(4535),
    [sym_unit] = ACTIONS(4537),
    [sym_int] = ACTIONS(4539),
    [sym_xint] = ACTIONS(4541),
    [anon_sym_LPAREN_STAR] = ACTIONS(27),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2767] = {
    [sym__type] = STATE(5002),
    [sym_simple_type] = STATE(5109),
    [sym_generic_type] = STATE(5109),
    [sym_paren_type] = STATE(5109),
    [sym_function_type] = STATE(5109),
    [sym_compound_type] = STATE(5109),
    [sym_postfix_type] = STATE(5109),
    [sym_list_type] = STATE(5109),
    [sym_static_type] = STATE(5109),
    [sym_constrained_type] = STATE(5109),
    [sym_flexible_type] = STATE(5109),
    [sym_anon_record_type] = STATE(5109),
    [sym__static_type_identifier] = STATE(4686),
    [sym__static_parameter] = STATE(6029),
    [sym_named_static_parameter] = STATE(6034),
    [sym_type_attribute] = STATE(5982),
    [sym_type_attributes] = STATE(6522),
    [sym_type_argument] = STATE(4913),
    [sym_static_parameter_value] = STATE(6034),
    [sym_char] = STATE(2803),
    [sym_format_string] = STATE(2805),
    [sym__string_literal] = STATE(2805),
    [sym_string] = STATE(2803),
    [sym_verbatim_string] = STATE(2803),
    [sym_bytearray] = STATE(2803),
    [sym_verbatim_bytearray] = STATE(2803),
    [sym_format_triple_quoted_string] = STATE(2809),
    [sym_triple_quoted_string] = STATE(2803),
    [sym_const] = STATE(432),
    [sym_long_identifier] = STATE(5121),
    [sym_sbyte] = STATE(2803),
    [sym_byte] = STATE(2803),
    [sym_int16] = STATE(2803),
    [sym_uint16] = STATE(2803),
    [sym_int32] = STATE(2803),
    [sym_uint32] = STATE(2803),
    [sym_nativeint] = STATE(2803),
    [sym_unativeint] = STATE(2803),
    [sym_int64] = STATE(2803),
    [sym_uint64] = STATE(2803),
    [sym_ieee32] = STATE(2803),
    [sym_ieee64] = STATE(2803),
    [sym_bignum] = STATE(2803),
    [sym_decimal] = STATE(2803),
    [sym_float] = STATE(2793),
    [sym_block_comment] = STATE(2767),
    [sym_compiler_directive_decl] = STATE(2767),
    [sym_fsi_directive_decl] = STATE(2767),
    [sym_preproc_line] = STATE(2767),
    [sym_identifier] = ACTIONS(4509),
    [anon_sym_LPAREN] = ACTIONS(4511),
    [anon_sym__] = ACTIONS(4513),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4515),
    [anon_sym_POUND] = ACTIONS(4519),
    [anon_sym_CARET] = ACTIONS(4521),
    [anon_sym_SQUOTE] = ACTIONS(4521),
    [aux_sym_char_token1] = ACTIONS(4523),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4525),
    [anon_sym_DQUOTE] = ACTIONS(4527),
    [anon_sym_AT_DQUOTE] = ACTIONS(4529),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4531),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4533),
    [sym_bool] = ACTIONS(4535),
    [sym_unit] = ACTIONS(4537),
    [sym_int] = ACTIONS(4539),
    [sym_xint] = ACTIONS(4541),
    [anon_sym_LPAREN_STAR] = ACTIONS(27),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2768] = {
    [sym_block_comment] = STATE(2768),
    [sym_compiler_directive_decl] = STATE(2768),
    [sym_fsi_directive_decl] = STATE(2768),
    [sym_preproc_line] = STATE(2768),
    [aux_sym_compound_type_repeat1] = STATE(2772),
    [sym_identifier] = ACTIONS(2407),
    [anon_sym_GT_RBRACK] = ACTIONS(2409),
    [anon_sym_return] = ACTIONS(2407),
    [anon_sym_do] = ACTIONS(2407),
    [anon_sym_let] = ACTIONS(2407),
    [anon_sym_let_BANG] = ACTIONS(2409),
    [anon_sym_LPAREN] = ACTIONS(2407),
    [anon_sym_null] = ACTIONS(2407),
    [anon_sym_AMP] = ACTIONS(2407),
    [anon_sym_LBRACK] = ACTIONS(2407),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2409),
    [anon_sym_LBRACE] = ACTIONS(2407),
    [anon_sym_LT_AT] = ACTIONS(2407),
    [anon_sym_LT_AT_AT] = ACTIONS(2409),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2409),
    [anon_sym_new] = ACTIONS(2407),
    [anon_sym_return_BANG] = ACTIONS(2409),
    [anon_sym_yield] = ACTIONS(2407),
    [anon_sym_yield_BANG] = ACTIONS(2409),
    [anon_sym_lazy] = ACTIONS(2407),
    [anon_sym_assert] = ACTIONS(2407),
    [anon_sym_upcast] = ACTIONS(2407),
    [anon_sym_downcast] = ACTIONS(2407),
    [anon_sym_for] = ACTIONS(2407),
    [anon_sym_while] = ACTIONS(2407),
    [anon_sym_if] = ACTIONS(2407),
    [anon_sym_fun] = ACTIONS(2407),
    [anon_sym_DASH_GT] = ACTIONS(2409),
    [anon_sym_try] = ACTIONS(2407),
    [anon_sym_match] = ACTIONS(2407),
    [anon_sym_match_BANG] = ACTIONS(2409),
    [anon_sym_function] = ACTIONS(2407),
    [anon_sym_use] = ACTIONS(2407),
    [anon_sym_use_BANG] = ACTIONS(2409),
    [anon_sym_do_BANG] = ACTIONS(2409),
    [anon_sym_begin] = ACTIONS(2407),
    [anon_sym_STAR] = ACTIONS(1693),
    [anon_sym_LT2] = ACTIONS(2407),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2409),
    [aux_sym_char_token1] = ACTIONS(2409),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2407),
    [anon_sym_DQUOTE] = ACTIONS(2407),
    [anon_sym_AT_DQUOTE] = ACTIONS(2409),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2409),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2409),
    [sym_bool] = ACTIONS(2407),
    [sym_unit] = ACTIONS(2409),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2407),
    [sym_op_identifier] = ACTIONS(2409),
    [anon_sym_PLUS] = ACTIONS(2407),
    [anon_sym_DASH] = ACTIONS(2407),
    [anon_sym_PLUS_DOT] = ACTIONS(2409),
    [anon_sym_DASH_DOT] = ACTIONS(2409),
    [anon_sym_PERCENT] = ACTIONS(2409),
    [anon_sym_AMP_AMP] = ACTIONS(2409),
    [anon_sym_TILDE] = ACTIONS(2409),
    [aux_sym_prefix_op_token1] = ACTIONS(2409),
    [sym_int] = ACTIONS(2407),
    [sym_xint] = ACTIONS(2409),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2409),
    [sym__newline] = ACTIONS(2409),
  },
  [2769] = {
    [sym__type] = STATE(5002),
    [sym_simple_type] = STATE(5109),
    [sym_generic_type] = STATE(5109),
    [sym_paren_type] = STATE(5109),
    [sym_function_type] = STATE(5109),
    [sym_compound_type] = STATE(5109),
    [sym_postfix_type] = STATE(5109),
    [sym_list_type] = STATE(5109),
    [sym_static_type] = STATE(5109),
    [sym_constrained_type] = STATE(5109),
    [sym_flexible_type] = STATE(5109),
    [sym_anon_record_type] = STATE(5109),
    [sym__static_type_identifier] = STATE(4686),
    [sym__static_parameter] = STATE(6029),
    [sym_named_static_parameter] = STATE(6034),
    [sym_type_attribute] = STATE(5982),
    [sym_type_attributes] = STATE(6587),
    [sym_type_argument] = STATE(4913),
    [sym_static_parameter_value] = STATE(6034),
    [sym_char] = STATE(2803),
    [sym_format_string] = STATE(2805),
    [sym__string_literal] = STATE(2805),
    [sym_string] = STATE(2803),
    [sym_verbatim_string] = STATE(2803),
    [sym_bytearray] = STATE(2803),
    [sym_verbatim_bytearray] = STATE(2803),
    [sym_format_triple_quoted_string] = STATE(2809),
    [sym_triple_quoted_string] = STATE(2803),
    [sym_const] = STATE(432),
    [sym_long_identifier] = STATE(5121),
    [sym_sbyte] = STATE(2803),
    [sym_byte] = STATE(2803),
    [sym_int16] = STATE(2803),
    [sym_uint16] = STATE(2803),
    [sym_int32] = STATE(2803),
    [sym_uint32] = STATE(2803),
    [sym_nativeint] = STATE(2803),
    [sym_unativeint] = STATE(2803),
    [sym_int64] = STATE(2803),
    [sym_uint64] = STATE(2803),
    [sym_ieee32] = STATE(2803),
    [sym_ieee64] = STATE(2803),
    [sym_bignum] = STATE(2803),
    [sym_decimal] = STATE(2803),
    [sym_float] = STATE(2793),
    [sym_block_comment] = STATE(2769),
    [sym_compiler_directive_decl] = STATE(2769),
    [sym_fsi_directive_decl] = STATE(2769),
    [sym_preproc_line] = STATE(2769),
    [sym_identifier] = ACTIONS(4509),
    [anon_sym_LPAREN] = ACTIONS(4511),
    [anon_sym__] = ACTIONS(4513),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4515),
    [anon_sym_POUND] = ACTIONS(4519),
    [anon_sym_CARET] = ACTIONS(4521),
    [anon_sym_SQUOTE] = ACTIONS(4521),
    [aux_sym_char_token1] = ACTIONS(4523),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4525),
    [anon_sym_DQUOTE] = ACTIONS(4527),
    [anon_sym_AT_DQUOTE] = ACTIONS(4529),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4531),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4533),
    [sym_bool] = ACTIONS(4535),
    [sym_unit] = ACTIONS(4537),
    [sym_int] = ACTIONS(4539),
    [sym_xint] = ACTIONS(4541),
    [anon_sym_LPAREN_STAR] = ACTIONS(27),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2770] = {
    [sym_block_comment] = STATE(2770),
    [sym_compiler_directive_decl] = STATE(2770),
    [sym_fsi_directive_decl] = STATE(2770),
    [sym_preproc_line] = STATE(2770),
    [sym_identifier] = ACTIONS(2567),
    [anon_sym_GT_RBRACK] = ACTIONS(2569),
    [anon_sym_return] = ACTIONS(2567),
    [anon_sym_do] = ACTIONS(2567),
    [anon_sym_let] = ACTIONS(2567),
    [anon_sym_let_BANG] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2567),
    [anon_sym_null] = ACTIONS(2567),
    [anon_sym_AMP] = ACTIONS(2567),
    [anon_sym_LBRACK] = ACTIONS(2567),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2569),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_LT_AT] = ACTIONS(2567),
    [anon_sym_LT_AT_AT] = ACTIONS(2569),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2569),
    [anon_sym_new] = ACTIONS(2567),
    [anon_sym_return_BANG] = ACTIONS(2569),
    [anon_sym_yield] = ACTIONS(2567),
    [anon_sym_yield_BANG] = ACTIONS(2569),
    [anon_sym_lazy] = ACTIONS(2567),
    [anon_sym_assert] = ACTIONS(2567),
    [anon_sym_upcast] = ACTIONS(2567),
    [anon_sym_downcast] = ACTIONS(2567),
    [anon_sym_COLON_GT] = ACTIONS(4666),
    [anon_sym_for] = ACTIONS(2567),
    [anon_sym_while] = ACTIONS(2567),
    [anon_sym_if] = ACTIONS(2567),
    [anon_sym_fun] = ACTIONS(2567),
    [anon_sym_DASH_GT] = ACTIONS(2569),
    [anon_sym_try] = ACTIONS(2567),
    [anon_sym_match] = ACTIONS(2567),
    [anon_sym_match_BANG] = ACTIONS(2569),
    [anon_sym_function] = ACTIONS(2567),
    [anon_sym_use] = ACTIONS(2567),
    [anon_sym_use_BANG] = ACTIONS(2569),
    [anon_sym_do_BANG] = ACTIONS(2569),
    [anon_sym_begin] = ACTIONS(2567),
    [anon_sym_STAR] = ACTIONS(2569),
    [anon_sym_LT2] = ACTIONS(2567),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2569),
    [aux_sym_char_token1] = ACTIONS(2569),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2567),
    [anon_sym_DQUOTE] = ACTIONS(2567),
    [anon_sym_AT_DQUOTE] = ACTIONS(2569),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2569),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2569),
    [sym_bool] = ACTIONS(2567),
    [sym_unit] = ACTIONS(2569),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2567),
    [sym_op_identifier] = ACTIONS(2569),
    [anon_sym_PLUS] = ACTIONS(2567),
    [anon_sym_DASH] = ACTIONS(2567),
    [anon_sym_PLUS_DOT] = ACTIONS(2569),
    [anon_sym_DASH_DOT] = ACTIONS(2569),
    [anon_sym_PERCENT] = ACTIONS(2569),
    [anon_sym_AMP_AMP] = ACTIONS(2569),
    [anon_sym_TILDE] = ACTIONS(2569),
    [aux_sym_prefix_op_token1] = ACTIONS(2569),
    [sym_int] = ACTIONS(2567),
    [sym_xint] = ACTIONS(2569),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2569),
    [sym__newline] = ACTIONS(2569),
  },
  [2771] = {
    [sym__type] = STATE(5002),
    [sym_simple_type] = STATE(5109),
    [sym_generic_type] = STATE(5109),
    [sym_paren_type] = STATE(5109),
    [sym_function_type] = STATE(5109),
    [sym_compound_type] = STATE(5109),
    [sym_postfix_type] = STATE(5109),
    [sym_list_type] = STATE(5109),
    [sym_static_type] = STATE(5109),
    [sym_constrained_type] = STATE(5109),
    [sym_flexible_type] = STATE(5109),
    [sym_anon_record_type] = STATE(5109),
    [sym__static_type_identifier] = STATE(4686),
    [sym__static_parameter] = STATE(6029),
    [sym_named_static_parameter] = STATE(6034),
    [sym_type_attribute] = STATE(5982),
    [sym_type_attributes] = STATE(6717),
    [sym_type_argument] = STATE(4913),
    [sym_static_parameter_value] = STATE(6034),
    [sym_char] = STATE(2803),
    [sym_format_string] = STATE(2805),
    [sym__string_literal] = STATE(2805),
    [sym_string] = STATE(2803),
    [sym_verbatim_string] = STATE(2803),
    [sym_bytearray] = STATE(2803),
    [sym_verbatim_bytearray] = STATE(2803),
    [sym_format_triple_quoted_string] = STATE(2809),
    [sym_triple_quoted_string] = STATE(2803),
    [sym_const] = STATE(432),
    [sym_long_identifier] = STATE(5121),
    [sym_sbyte] = STATE(2803),
    [sym_byte] = STATE(2803),
    [sym_int16] = STATE(2803),
    [sym_uint16] = STATE(2803),
    [sym_int32] = STATE(2803),
    [sym_uint32] = STATE(2803),
    [sym_nativeint] = STATE(2803),
    [sym_unativeint] = STATE(2803),
    [sym_int64] = STATE(2803),
    [sym_uint64] = STATE(2803),
    [sym_ieee32] = STATE(2803),
    [sym_ieee64] = STATE(2803),
    [sym_bignum] = STATE(2803),
    [sym_decimal] = STATE(2803),
    [sym_float] = STATE(2793),
    [sym_block_comment] = STATE(2771),
    [sym_compiler_directive_decl] = STATE(2771),
    [sym_fsi_directive_decl] = STATE(2771),
    [sym_preproc_line] = STATE(2771),
    [sym_identifier] = ACTIONS(4509),
    [anon_sym_LPAREN] = ACTIONS(4511),
    [anon_sym__] = ACTIONS(4513),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4515),
    [anon_sym_POUND] = ACTIONS(4519),
    [anon_sym_CARET] = ACTIONS(4521),
    [anon_sym_SQUOTE] = ACTIONS(4521),
    [aux_sym_char_token1] = ACTIONS(4523),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4525),
    [anon_sym_DQUOTE] = ACTIONS(4527),
    [anon_sym_AT_DQUOTE] = ACTIONS(4529),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4531),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4533),
    [sym_bool] = ACTIONS(4535),
    [sym_unit] = ACTIONS(4537),
    [sym_int] = ACTIONS(4539),
    [sym_xint] = ACTIONS(4541),
    [anon_sym_LPAREN_STAR] = ACTIONS(27),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2772] = {
    [sym_block_comment] = STATE(2772),
    [sym_compiler_directive_decl] = STATE(2772),
    [sym_fsi_directive_decl] = STATE(2772),
    [sym_preproc_line] = STATE(2772),
    [aux_sym_compound_type_repeat1] = STATE(2772),
    [sym_identifier] = ACTIONS(2250),
    [anon_sym_GT_RBRACK] = ACTIONS(2248),
    [anon_sym_return] = ACTIONS(2250),
    [anon_sym_do] = ACTIONS(2250),
    [anon_sym_let] = ACTIONS(2250),
    [anon_sym_let_BANG] = ACTIONS(2248),
    [anon_sym_LPAREN] = ACTIONS(2250),
    [anon_sym_null] = ACTIONS(2250),
    [anon_sym_AMP] = ACTIONS(2250),
    [anon_sym_LBRACK] = ACTIONS(2250),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2248),
    [anon_sym_LBRACE] = ACTIONS(2250),
    [anon_sym_LT_AT] = ACTIONS(2250),
    [anon_sym_LT_AT_AT] = ACTIONS(2248),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2248),
    [anon_sym_new] = ACTIONS(2250),
    [anon_sym_return_BANG] = ACTIONS(2248),
    [anon_sym_yield] = ACTIONS(2250),
    [anon_sym_yield_BANG] = ACTIONS(2248),
    [anon_sym_lazy] = ACTIONS(2250),
    [anon_sym_assert] = ACTIONS(2250),
    [anon_sym_upcast] = ACTIONS(2250),
    [anon_sym_downcast] = ACTIONS(2250),
    [anon_sym_for] = ACTIONS(2250),
    [anon_sym_while] = ACTIONS(2250),
    [anon_sym_if] = ACTIONS(2250),
    [anon_sym_fun] = ACTIONS(2250),
    [anon_sym_DASH_GT] = ACTIONS(2248),
    [anon_sym_try] = ACTIONS(2250),
    [anon_sym_match] = ACTIONS(2250),
    [anon_sym_match_BANG] = ACTIONS(2248),
    [anon_sym_function] = ACTIONS(2250),
    [anon_sym_use] = ACTIONS(2250),
    [anon_sym_use_BANG] = ACTIONS(2248),
    [anon_sym_do_BANG] = ACTIONS(2248),
    [anon_sym_begin] = ACTIONS(2250),
    [anon_sym_STAR] = ACTIONS(4668),
    [anon_sym_LT2] = ACTIONS(2250),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2248),
    [aux_sym_char_token1] = ACTIONS(2248),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2250),
    [anon_sym_DQUOTE] = ACTIONS(2250),
    [anon_sym_AT_DQUOTE] = ACTIONS(2248),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2248),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2248),
    [sym_bool] = ACTIONS(2250),
    [sym_unit] = ACTIONS(2248),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2250),
    [sym_op_identifier] = ACTIONS(2248),
    [anon_sym_PLUS] = ACTIONS(2250),
    [anon_sym_DASH] = ACTIONS(2250),
    [anon_sym_PLUS_DOT] = ACTIONS(2248),
    [anon_sym_DASH_DOT] = ACTIONS(2248),
    [anon_sym_PERCENT] = ACTIONS(2248),
    [anon_sym_AMP_AMP] = ACTIONS(2248),
    [anon_sym_TILDE] = ACTIONS(2248),
    [aux_sym_prefix_op_token1] = ACTIONS(2248),
    [sym_int] = ACTIONS(2250),
    [sym_xint] = ACTIONS(2248),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2248),
    [sym__newline] = ACTIONS(2248),
  },
  [2773] = {
    [sym__type] = STATE(5002),
    [sym_simple_type] = STATE(5109),
    [sym_generic_type] = STATE(5109),
    [sym_paren_type] = STATE(5109),
    [sym_function_type] = STATE(5109),
    [sym_compound_type] = STATE(5109),
    [sym_postfix_type] = STATE(5109),
    [sym_list_type] = STATE(5109),
    [sym_static_type] = STATE(5109),
    [sym_constrained_type] = STATE(5109),
    [sym_flexible_type] = STATE(5109),
    [sym_anon_record_type] = STATE(5109),
    [sym__static_type_identifier] = STATE(4686),
    [sym__static_parameter] = STATE(6029),
    [sym_named_static_parameter] = STATE(6034),
    [sym_type_attribute] = STATE(5982),
    [sym_type_attributes] = STATE(7240),
    [sym_type_argument] = STATE(4913),
    [sym_static_parameter_value] = STATE(6034),
    [sym_char] = STATE(2803),
    [sym_format_string] = STATE(2805),
    [sym__string_literal] = STATE(2805),
    [sym_string] = STATE(2803),
    [sym_verbatim_string] = STATE(2803),
    [sym_bytearray] = STATE(2803),
    [sym_verbatim_bytearray] = STATE(2803),
    [sym_format_triple_quoted_string] = STATE(2809),
    [sym_triple_quoted_string] = STATE(2803),
    [sym_const] = STATE(432),
    [sym_long_identifier] = STATE(5121),
    [sym_sbyte] = STATE(2803),
    [sym_byte] = STATE(2803),
    [sym_int16] = STATE(2803),
    [sym_uint16] = STATE(2803),
    [sym_int32] = STATE(2803),
    [sym_uint32] = STATE(2803),
    [sym_nativeint] = STATE(2803),
    [sym_unativeint] = STATE(2803),
    [sym_int64] = STATE(2803),
    [sym_uint64] = STATE(2803),
    [sym_ieee32] = STATE(2803),
    [sym_ieee64] = STATE(2803),
    [sym_bignum] = STATE(2803),
    [sym_decimal] = STATE(2803),
    [sym_float] = STATE(2793),
    [sym_block_comment] = STATE(2773),
    [sym_compiler_directive_decl] = STATE(2773),
    [sym_fsi_directive_decl] = STATE(2773),
    [sym_preproc_line] = STATE(2773),
    [sym_identifier] = ACTIONS(4509),
    [anon_sym_LPAREN] = ACTIONS(4511),
    [anon_sym__] = ACTIONS(4513),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4515),
    [anon_sym_POUND] = ACTIONS(4519),
    [anon_sym_CARET] = ACTIONS(4521),
    [anon_sym_SQUOTE] = ACTIONS(4521),
    [aux_sym_char_token1] = ACTIONS(4523),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4525),
    [anon_sym_DQUOTE] = ACTIONS(4527),
    [anon_sym_AT_DQUOTE] = ACTIONS(4529),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4531),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4533),
    [sym_bool] = ACTIONS(4535),
    [sym_unit] = ACTIONS(4537),
    [sym_int] = ACTIONS(4539),
    [sym_xint] = ACTIONS(4541),
    [anon_sym_LPAREN_STAR] = ACTIONS(27),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2774] = {
    [sym_block_comment] = STATE(2774),
    [sym_compiler_directive_decl] = STATE(2774),
    [sym_fsi_directive_decl] = STATE(2774),
    [sym_preproc_line] = STATE(2774),
    [sym_identifier] = ACTIONS(2321),
    [anon_sym_GT_RBRACK] = ACTIONS(2323),
    [anon_sym_return] = ACTIONS(2321),
    [anon_sym_do] = ACTIONS(2321),
    [anon_sym_let] = ACTIONS(2321),
    [anon_sym_let_BANG] = ACTIONS(2323),
    [anon_sym_LPAREN] = ACTIONS(2321),
    [anon_sym_null] = ACTIONS(2321),
    [anon_sym_AMP] = ACTIONS(2321),
    [anon_sym_LBRACK] = ACTIONS(2321),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2323),
    [anon_sym_LBRACE] = ACTIONS(2321),
    [anon_sym_LT_AT] = ACTIONS(2321),
    [anon_sym_LT_AT_AT] = ACTIONS(2323),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2323),
    [anon_sym_new] = ACTIONS(2321),
    [anon_sym_return_BANG] = ACTIONS(2323),
    [anon_sym_yield] = ACTIONS(2321),
    [anon_sym_yield_BANG] = ACTIONS(2323),
    [anon_sym_lazy] = ACTIONS(2321),
    [anon_sym_assert] = ACTIONS(2321),
    [anon_sym_upcast] = ACTIONS(2321),
    [anon_sym_downcast] = ACTIONS(2321),
    [anon_sym_COLON_GT] = ACTIONS(2323),
    [anon_sym_for] = ACTIONS(2321),
    [anon_sym_while] = ACTIONS(2321),
    [anon_sym_if] = ACTIONS(2321),
    [anon_sym_fun] = ACTIONS(2321),
    [anon_sym_DASH_GT] = ACTIONS(2323),
    [anon_sym_try] = ACTIONS(2321),
    [anon_sym_match] = ACTIONS(2321),
    [anon_sym_match_BANG] = ACTIONS(2323),
    [anon_sym_function] = ACTIONS(2321),
    [anon_sym_use] = ACTIONS(2321),
    [anon_sym_use_BANG] = ACTIONS(2323),
    [anon_sym_do_BANG] = ACTIONS(2323),
    [anon_sym_begin] = ACTIONS(2321),
    [anon_sym_STAR] = ACTIONS(2323),
    [anon_sym_LT2] = ACTIONS(2321),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2323),
    [aux_sym_char_token1] = ACTIONS(2323),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2321),
    [anon_sym_DQUOTE] = ACTIONS(2321),
    [anon_sym_AT_DQUOTE] = ACTIONS(2323),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2323),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2323),
    [sym_bool] = ACTIONS(2321),
    [sym_unit] = ACTIONS(2323),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2321),
    [sym_op_identifier] = ACTIONS(2323),
    [anon_sym_PLUS] = ACTIONS(2321),
    [anon_sym_DASH] = ACTIONS(2321),
    [anon_sym_PLUS_DOT] = ACTIONS(2323),
    [anon_sym_DASH_DOT] = ACTIONS(2323),
    [anon_sym_PERCENT] = ACTIONS(2323),
    [anon_sym_AMP_AMP] = ACTIONS(2323),
    [anon_sym_TILDE] = ACTIONS(2323),
    [aux_sym_prefix_op_token1] = ACTIONS(2323),
    [sym_int] = ACTIONS(2321),
    [sym_xint] = ACTIONS(2323),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2323),
    [sym__newline] = ACTIONS(2323),
  },
  [2775] = {
    [sym_block_comment] = STATE(2775),
    [sym_compiler_directive_decl] = STATE(2775),
    [sym_fsi_directive_decl] = STATE(2775),
    [sym_preproc_line] = STATE(2775),
    [sym_identifier] = ACTIONS(2411),
    [anon_sym_GT_RBRACK] = ACTIONS(2413),
    [anon_sym_return] = ACTIONS(2411),
    [anon_sym_do] = ACTIONS(2411),
    [anon_sym_let] = ACTIONS(2411),
    [anon_sym_let_BANG] = ACTIONS(2413),
    [anon_sym_LPAREN] = ACTIONS(2411),
    [anon_sym_null] = ACTIONS(2411),
    [anon_sym_AMP] = ACTIONS(2411),
    [anon_sym_LBRACK] = ACTIONS(2411),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2413),
    [anon_sym_LBRACE] = ACTIONS(2411),
    [anon_sym_LT_AT] = ACTIONS(2411),
    [anon_sym_LT_AT_AT] = ACTIONS(2413),
    [anon_sym_DOT] = ACTIONS(2413),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2413),
    [anon_sym_new] = ACTIONS(2411),
    [anon_sym_return_BANG] = ACTIONS(2413),
    [anon_sym_yield] = ACTIONS(2411),
    [anon_sym_yield_BANG] = ACTIONS(2413),
    [anon_sym_lazy] = ACTIONS(2411),
    [anon_sym_assert] = ACTIONS(2411),
    [anon_sym_upcast] = ACTIONS(2411),
    [anon_sym_downcast] = ACTIONS(2411),
    [anon_sym_for] = ACTIONS(2411),
    [anon_sym_while] = ACTIONS(2411),
    [anon_sym_if] = ACTIONS(2411),
    [anon_sym_fun] = ACTIONS(2411),
    [anon_sym_DASH_GT] = ACTIONS(2413),
    [anon_sym_try] = ACTIONS(2411),
    [anon_sym_match] = ACTIONS(2411),
    [anon_sym_match_BANG] = ACTIONS(2413),
    [anon_sym_function] = ACTIONS(2411),
    [anon_sym_use] = ACTIONS(2411),
    [anon_sym_use_BANG] = ACTIONS(2413),
    [anon_sym_do_BANG] = ACTIONS(2413),
    [anon_sym_begin] = ACTIONS(2411),
    [anon_sym_STAR] = ACTIONS(2413),
    [anon_sym_LT2] = ACTIONS(2411),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2413),
    [aux_sym_char_token1] = ACTIONS(2413),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2411),
    [anon_sym_DQUOTE] = ACTIONS(2411),
    [anon_sym_AT_DQUOTE] = ACTIONS(2413),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2413),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2413),
    [sym_bool] = ACTIONS(2411),
    [sym_unit] = ACTIONS(2413),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2411),
    [sym_op_identifier] = ACTIONS(2413),
    [anon_sym_PLUS] = ACTIONS(2411),
    [anon_sym_DASH] = ACTIONS(2411),
    [anon_sym_PLUS_DOT] = ACTIONS(2413),
    [anon_sym_DASH_DOT] = ACTIONS(2413),
    [anon_sym_PERCENT] = ACTIONS(2413),
    [anon_sym_AMP_AMP] = ACTIONS(2413),
    [anon_sym_TILDE] = ACTIONS(2413),
    [aux_sym_prefix_op_token1] = ACTIONS(2413),
    [sym_int] = ACTIONS(2411),
    [sym_xint] = ACTIONS(2413),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2413),
    [sym__newline] = ACTIONS(2413),
  },
  [2776] = {
    [sym__type] = STATE(5002),
    [sym_simple_type] = STATE(5109),
    [sym_generic_type] = STATE(5109),
    [sym_paren_type] = STATE(5109),
    [sym_function_type] = STATE(5109),
    [sym_compound_type] = STATE(5109),
    [sym_postfix_type] = STATE(5109),
    [sym_list_type] = STATE(5109),
    [sym_static_type] = STATE(5109),
    [sym_constrained_type] = STATE(5109),
    [sym_flexible_type] = STATE(5109),
    [sym_anon_record_type] = STATE(5109),
    [sym__static_type_identifier] = STATE(4686),
    [sym__static_parameter] = STATE(6029),
    [sym_named_static_parameter] = STATE(6034),
    [sym_type_attribute] = STATE(5982),
    [sym_type_attributes] = STATE(7370),
    [sym_type_argument] = STATE(4913),
    [sym_static_parameter_value] = STATE(6034),
    [sym_char] = STATE(2803),
    [sym_format_string] = STATE(2805),
    [sym__string_literal] = STATE(2805),
    [sym_string] = STATE(2803),
    [sym_verbatim_string] = STATE(2803),
    [sym_bytearray] = STATE(2803),
    [sym_verbatim_bytearray] = STATE(2803),
    [sym_format_triple_quoted_string] = STATE(2809),
    [sym_triple_quoted_string] = STATE(2803),
    [sym_const] = STATE(432),
    [sym_long_identifier] = STATE(5121),
    [sym_sbyte] = STATE(2803),
    [sym_byte] = STATE(2803),
    [sym_int16] = STATE(2803),
    [sym_uint16] = STATE(2803),
    [sym_int32] = STATE(2803),
    [sym_uint32] = STATE(2803),
    [sym_nativeint] = STATE(2803),
    [sym_unativeint] = STATE(2803),
    [sym_int64] = STATE(2803),
    [sym_uint64] = STATE(2803),
    [sym_ieee32] = STATE(2803),
    [sym_ieee64] = STATE(2803),
    [sym_bignum] = STATE(2803),
    [sym_decimal] = STATE(2803),
    [sym_float] = STATE(2793),
    [sym_block_comment] = STATE(2776),
    [sym_compiler_directive_decl] = STATE(2776),
    [sym_fsi_directive_decl] = STATE(2776),
    [sym_preproc_line] = STATE(2776),
    [sym_identifier] = ACTIONS(4509),
    [anon_sym_LPAREN] = ACTIONS(4511),
    [anon_sym__] = ACTIONS(4513),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4515),
    [anon_sym_POUND] = ACTIONS(4519),
    [anon_sym_CARET] = ACTIONS(4521),
    [anon_sym_SQUOTE] = ACTIONS(4521),
    [aux_sym_char_token1] = ACTIONS(4523),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4525),
    [anon_sym_DQUOTE] = ACTIONS(4527),
    [anon_sym_AT_DQUOTE] = ACTIONS(4529),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4531),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4533),
    [sym_bool] = ACTIONS(4535),
    [sym_unit] = ACTIONS(4537),
    [sym_int] = ACTIONS(4539),
    [sym_xint] = ACTIONS(4541),
    [anon_sym_LPAREN_STAR] = ACTIONS(27),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2777] = {
    [sym__type] = STATE(5002),
    [sym_simple_type] = STATE(5109),
    [sym_generic_type] = STATE(5109),
    [sym_paren_type] = STATE(5109),
    [sym_function_type] = STATE(5109),
    [sym_compound_type] = STATE(5109),
    [sym_postfix_type] = STATE(5109),
    [sym_list_type] = STATE(5109),
    [sym_static_type] = STATE(5109),
    [sym_constrained_type] = STATE(5109),
    [sym_flexible_type] = STATE(5109),
    [sym_anon_record_type] = STATE(5109),
    [sym__static_type_identifier] = STATE(4686),
    [sym__static_parameter] = STATE(6029),
    [sym_named_static_parameter] = STATE(6034),
    [sym_type_attribute] = STATE(5982),
    [sym_type_attributes] = STATE(7099),
    [sym_type_argument] = STATE(4913),
    [sym_static_parameter_value] = STATE(6034),
    [sym_char] = STATE(2803),
    [sym_format_string] = STATE(2805),
    [sym__string_literal] = STATE(2805),
    [sym_string] = STATE(2803),
    [sym_verbatim_string] = STATE(2803),
    [sym_bytearray] = STATE(2803),
    [sym_verbatim_bytearray] = STATE(2803),
    [sym_format_triple_quoted_string] = STATE(2809),
    [sym_triple_quoted_string] = STATE(2803),
    [sym_const] = STATE(432),
    [sym_long_identifier] = STATE(5121),
    [sym_sbyte] = STATE(2803),
    [sym_byte] = STATE(2803),
    [sym_int16] = STATE(2803),
    [sym_uint16] = STATE(2803),
    [sym_int32] = STATE(2803),
    [sym_uint32] = STATE(2803),
    [sym_nativeint] = STATE(2803),
    [sym_unativeint] = STATE(2803),
    [sym_int64] = STATE(2803),
    [sym_uint64] = STATE(2803),
    [sym_ieee32] = STATE(2803),
    [sym_ieee64] = STATE(2803),
    [sym_bignum] = STATE(2803),
    [sym_decimal] = STATE(2803),
    [sym_float] = STATE(2793),
    [sym_block_comment] = STATE(2777),
    [sym_compiler_directive_decl] = STATE(2777),
    [sym_fsi_directive_decl] = STATE(2777),
    [sym_preproc_line] = STATE(2777),
    [sym_identifier] = ACTIONS(4509),
    [anon_sym_LPAREN] = ACTIONS(4511),
    [anon_sym__] = ACTIONS(4513),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4515),
    [anon_sym_POUND] = ACTIONS(4519),
    [anon_sym_CARET] = ACTIONS(4521),
    [anon_sym_SQUOTE] = ACTIONS(4521),
    [aux_sym_char_token1] = ACTIONS(4523),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4525),
    [anon_sym_DQUOTE] = ACTIONS(4527),
    [anon_sym_AT_DQUOTE] = ACTIONS(4529),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4531),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4533),
    [sym_bool] = ACTIONS(4535),
    [sym_unit] = ACTIONS(4537),
    [sym_int] = ACTIONS(4539),
    [sym_xint] = ACTIONS(4541),
    [anon_sym_LPAREN_STAR] = ACTIONS(27),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2778] = {
    [sym_block_comment] = STATE(2778),
    [sym_compiler_directive_decl] = STATE(2778),
    [sym_fsi_directive_decl] = STATE(2778),
    [sym_preproc_line] = STATE(2778),
    [sym_identifier] = ACTIONS(2567),
    [anon_sym_GT_RBRACK] = ACTIONS(2569),
    [anon_sym_return] = ACTIONS(2567),
    [anon_sym_do] = ACTIONS(2567),
    [anon_sym_let] = ACTIONS(2567),
    [anon_sym_let_BANG] = ACTIONS(2569),
    [anon_sym_LPAREN] = ACTIONS(2567),
    [anon_sym_null] = ACTIONS(2567),
    [anon_sym_AMP] = ACTIONS(2567),
    [anon_sym_LBRACK] = ACTIONS(2567),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2569),
    [anon_sym_LBRACE] = ACTIONS(2567),
    [anon_sym_LT_AT] = ACTIONS(2567),
    [anon_sym_LT_AT_AT] = ACTIONS(2569),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2569),
    [anon_sym_new] = ACTIONS(2567),
    [anon_sym_return_BANG] = ACTIONS(2569),
    [anon_sym_yield] = ACTIONS(2567),
    [anon_sym_yield_BANG] = ACTIONS(2569),
    [anon_sym_lazy] = ACTIONS(2567),
    [anon_sym_assert] = ACTIONS(2567),
    [anon_sym_upcast] = ACTIONS(2567),
    [anon_sym_downcast] = ACTIONS(2567),
    [anon_sym_for] = ACTIONS(2567),
    [anon_sym_while] = ACTIONS(2567),
    [anon_sym_if] = ACTIONS(2567),
    [anon_sym_fun] = ACTIONS(2567),
    [anon_sym_DASH_GT] = ACTIONS(2569),
    [anon_sym_try] = ACTIONS(2567),
    [anon_sym_match] = ACTIONS(2567),
    [anon_sym_match_BANG] = ACTIONS(2569),
    [anon_sym_function] = ACTIONS(2567),
    [anon_sym_use] = ACTIONS(2567),
    [anon_sym_use_BANG] = ACTIONS(2569),
    [anon_sym_do_BANG] = ACTIONS(2569),
    [anon_sym_begin] = ACTIONS(2567),
    [anon_sym_STAR] = ACTIONS(2569),
    [anon_sym_LT2] = ACTIONS(2567),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2569),
    [aux_sym_char_token1] = ACTIONS(2569),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2567),
    [anon_sym_DQUOTE] = ACTIONS(2567),
    [anon_sym_AT_DQUOTE] = ACTIONS(2569),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2569),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2569),
    [sym_bool] = ACTIONS(2567),
    [sym_unit] = ACTIONS(2569),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2567),
    [sym_op_identifier] = ACTIONS(2569),
    [anon_sym_PLUS] = ACTIONS(2567),
    [anon_sym_DASH] = ACTIONS(2567),
    [anon_sym_PLUS_DOT] = ACTIONS(2569),
    [anon_sym_DASH_DOT] = ACTIONS(2569),
    [anon_sym_PERCENT] = ACTIONS(2569),
    [anon_sym_AMP_AMP] = ACTIONS(2569),
    [anon_sym_TILDE] = ACTIONS(2569),
    [aux_sym_prefix_op_token1] = ACTIONS(2569),
    [sym_int] = ACTIONS(2567),
    [sym_xint] = ACTIONS(2569),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2569),
    [sym__newline] = ACTIONS(2569),
  },
  [2779] = {
    [sym_block_comment] = STATE(2779),
    [sym_compiler_directive_decl] = STATE(2779),
    [sym_fsi_directive_decl] = STATE(2779),
    [sym_preproc_line] = STATE(2779),
    [sym_identifier] = ACTIONS(2514),
    [anon_sym_GT_RBRACK] = ACTIONS(2516),
    [anon_sym_return] = ACTIONS(2514),
    [anon_sym_do] = ACTIONS(2514),
    [anon_sym_let] = ACTIONS(2514),
    [anon_sym_let_BANG] = ACTIONS(2516),
    [anon_sym_LPAREN] = ACTIONS(2514),
    [anon_sym_null] = ACTIONS(2514),
    [anon_sym_AMP] = ACTIONS(2514),
    [anon_sym_LBRACK] = ACTIONS(2514),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2516),
    [anon_sym_LBRACE] = ACTIONS(2514),
    [anon_sym_LT_AT] = ACTIONS(2514),
    [anon_sym_LT_AT_AT] = ACTIONS(2516),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2516),
    [anon_sym_new] = ACTIONS(2514),
    [anon_sym_return_BANG] = ACTIONS(2516),
    [anon_sym_yield] = ACTIONS(2514),
    [anon_sym_yield_BANG] = ACTIONS(2516),
    [anon_sym_lazy] = ACTIONS(2514),
    [anon_sym_assert] = ACTIONS(2514),
    [anon_sym_upcast] = ACTIONS(2514),
    [anon_sym_downcast] = ACTIONS(2514),
    [anon_sym_for] = ACTIONS(2514),
    [anon_sym_while] = ACTIONS(2514),
    [anon_sym_if] = ACTIONS(2514),
    [anon_sym_fun] = ACTIONS(2514),
    [anon_sym_DASH_GT] = ACTIONS(2516),
    [anon_sym_try] = ACTIONS(2514),
    [anon_sym_match] = ACTIONS(2514),
    [anon_sym_match_BANG] = ACTIONS(2516),
    [anon_sym_function] = ACTIONS(2514),
    [anon_sym_use] = ACTIONS(2514),
    [anon_sym_use_BANG] = ACTIONS(2516),
    [anon_sym_do_BANG] = ACTIONS(2516),
    [anon_sym_begin] = ACTIONS(2514),
    [anon_sym_STAR] = ACTIONS(2516),
    [anon_sym_LT2] = ACTIONS(2514),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2516),
    [aux_sym_char_token1] = ACTIONS(2516),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2514),
    [anon_sym_DQUOTE] = ACTIONS(2514),
    [anon_sym_AT_DQUOTE] = ACTIONS(2516),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2516),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2516),
    [sym_bool] = ACTIONS(2514),
    [sym_unit] = ACTIONS(2516),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2514),
    [sym_op_identifier] = ACTIONS(2516),
    [anon_sym_PLUS] = ACTIONS(2514),
    [anon_sym_DASH] = ACTIONS(2514),
    [anon_sym_PLUS_DOT] = ACTIONS(2516),
    [anon_sym_DASH_DOT] = ACTIONS(2516),
    [anon_sym_PERCENT] = ACTIONS(2516),
    [anon_sym_AMP_AMP] = ACTIONS(2516),
    [anon_sym_TILDE] = ACTIONS(2516),
    [aux_sym_prefix_op_token1] = ACTIONS(2516),
    [sym_int] = ACTIONS(2514),
    [sym_xint] = ACTIONS(2516),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2516),
    [sym__newline] = ACTIONS(2516),
  },
  [2780] = {
    [sym_block_comment] = STATE(2780),
    [sym_compiler_directive_decl] = STATE(2780),
    [sym_fsi_directive_decl] = STATE(2780),
    [sym_preproc_line] = STATE(2780),
    [sym_identifier] = ACTIONS(2553),
    [anon_sym_GT_RBRACK] = ACTIONS(2555),
    [anon_sym_return] = ACTIONS(2553),
    [anon_sym_do] = ACTIONS(2553),
    [anon_sym_let] = ACTIONS(2553),
    [anon_sym_let_BANG] = ACTIONS(2555),
    [anon_sym_LPAREN] = ACTIONS(2553),
    [anon_sym_null] = ACTIONS(2553),
    [anon_sym_AMP] = ACTIONS(2553),
    [anon_sym_LBRACK] = ACTIONS(2553),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2555),
    [anon_sym_LBRACE] = ACTIONS(2553),
    [anon_sym_LT_AT] = ACTIONS(2553),
    [anon_sym_LT_AT_AT] = ACTIONS(2555),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2555),
    [anon_sym_new] = ACTIONS(2553),
    [anon_sym_return_BANG] = ACTIONS(2555),
    [anon_sym_yield] = ACTIONS(2553),
    [anon_sym_yield_BANG] = ACTIONS(2555),
    [anon_sym_lazy] = ACTIONS(2553),
    [anon_sym_assert] = ACTIONS(2553),
    [anon_sym_upcast] = ACTIONS(2553),
    [anon_sym_downcast] = ACTIONS(2553),
    [anon_sym_for] = ACTIONS(2553),
    [anon_sym_while] = ACTIONS(2553),
    [anon_sym_if] = ACTIONS(2553),
    [anon_sym_fun] = ACTIONS(2553),
    [anon_sym_DASH_GT] = ACTIONS(2555),
    [anon_sym_try] = ACTIONS(2553),
    [anon_sym_match] = ACTIONS(2553),
    [anon_sym_match_BANG] = ACTIONS(2555),
    [anon_sym_function] = ACTIONS(2553),
    [anon_sym_use] = ACTIONS(2553),
    [anon_sym_use_BANG] = ACTIONS(2555),
    [anon_sym_do_BANG] = ACTIONS(2555),
    [anon_sym_begin] = ACTIONS(2553),
    [anon_sym_STAR] = ACTIONS(2555),
    [anon_sym_LT2] = ACTIONS(2553),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2555),
    [aux_sym_char_token1] = ACTIONS(2555),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2553),
    [anon_sym_DQUOTE] = ACTIONS(2553),
    [anon_sym_AT_DQUOTE] = ACTIONS(2555),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2555),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2555),
    [sym_bool] = ACTIONS(2553),
    [sym_unit] = ACTIONS(2555),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2553),
    [sym_op_identifier] = ACTIONS(2555),
    [anon_sym_PLUS] = ACTIONS(2553),
    [anon_sym_DASH] = ACTIONS(2553),
    [anon_sym_PLUS_DOT] = ACTIONS(2555),
    [anon_sym_DASH_DOT] = ACTIONS(2555),
    [anon_sym_PERCENT] = ACTIONS(2555),
    [anon_sym_AMP_AMP] = ACTIONS(2555),
    [anon_sym_TILDE] = ACTIONS(2555),
    [aux_sym_prefix_op_token1] = ACTIONS(2555),
    [sym_int] = ACTIONS(2553),
    [sym_xint] = ACTIONS(2555),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2555),
    [sym__newline] = ACTIONS(2555),
  },
  [2781] = {
    [sym_block_comment] = STATE(2781),
    [sym_compiler_directive_decl] = STATE(2781),
    [sym_fsi_directive_decl] = STATE(2781),
    [sym_preproc_line] = STATE(2781),
    [sym_identifier] = ACTIONS(2470),
    [anon_sym_GT_RBRACK] = ACTIONS(2472),
    [anon_sym_return] = ACTIONS(2470),
    [anon_sym_do] = ACTIONS(2470),
    [anon_sym_let] = ACTIONS(2470),
    [anon_sym_let_BANG] = ACTIONS(2472),
    [anon_sym_LPAREN] = ACTIONS(2470),
    [anon_sym_null] = ACTIONS(2470),
    [anon_sym_AMP] = ACTIONS(2470),
    [anon_sym_LBRACK] = ACTIONS(2470),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2472),
    [anon_sym_LBRACE] = ACTIONS(2470),
    [anon_sym_LT_AT] = ACTIONS(2470),
    [anon_sym_LT_AT_AT] = ACTIONS(2472),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2472),
    [anon_sym_new] = ACTIONS(2470),
    [anon_sym_return_BANG] = ACTIONS(2472),
    [anon_sym_yield] = ACTIONS(2470),
    [anon_sym_yield_BANG] = ACTIONS(2472),
    [anon_sym_lazy] = ACTIONS(2470),
    [anon_sym_assert] = ACTIONS(2470),
    [anon_sym_upcast] = ACTIONS(2470),
    [anon_sym_downcast] = ACTIONS(2470),
    [anon_sym_for] = ACTIONS(2470),
    [anon_sym_while] = ACTIONS(2470),
    [anon_sym_if] = ACTIONS(2470),
    [anon_sym_fun] = ACTIONS(2470),
    [anon_sym_DASH_GT] = ACTIONS(2472),
    [anon_sym_try] = ACTIONS(2470),
    [anon_sym_match] = ACTIONS(2470),
    [anon_sym_match_BANG] = ACTIONS(2472),
    [anon_sym_function] = ACTIONS(2470),
    [anon_sym_use] = ACTIONS(2470),
    [anon_sym_use_BANG] = ACTIONS(2472),
    [anon_sym_do_BANG] = ACTIONS(2472),
    [anon_sym_begin] = ACTIONS(2470),
    [anon_sym_STAR] = ACTIONS(2472),
    [anon_sym_LT2] = ACTIONS(2470),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2472),
    [aux_sym_char_token1] = ACTIONS(2472),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2470),
    [anon_sym_DQUOTE] = ACTIONS(2470),
    [anon_sym_AT_DQUOTE] = ACTIONS(2472),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2472),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2472),
    [sym_bool] = ACTIONS(2470),
    [sym_unit] = ACTIONS(2472),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2470),
    [sym_op_identifier] = ACTIONS(2472),
    [anon_sym_PLUS] = ACTIONS(2470),
    [anon_sym_DASH] = ACTIONS(2470),
    [anon_sym_PLUS_DOT] = ACTIONS(2472),
    [anon_sym_DASH_DOT] = ACTIONS(2472),
    [anon_sym_PERCENT] = ACTIONS(2472),
    [anon_sym_AMP_AMP] = ACTIONS(2472),
    [anon_sym_TILDE] = ACTIONS(2472),
    [aux_sym_prefix_op_token1] = ACTIONS(2472),
    [sym_int] = ACTIONS(2470),
    [sym_xint] = ACTIONS(2472),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2472),
    [sym__newline] = ACTIONS(2472),
  },
  [2782] = {
    [sym__type] = STATE(5002),
    [sym_simple_type] = STATE(5109),
    [sym_generic_type] = STATE(5109),
    [sym_paren_type] = STATE(5109),
    [sym_function_type] = STATE(5109),
    [sym_compound_type] = STATE(5109),
    [sym_postfix_type] = STATE(5109),
    [sym_list_type] = STATE(5109),
    [sym_static_type] = STATE(5109),
    [sym_constrained_type] = STATE(5109),
    [sym_flexible_type] = STATE(5109),
    [sym_anon_record_type] = STATE(5109),
    [sym__static_type_identifier] = STATE(4686),
    [sym__static_parameter] = STATE(6029),
    [sym_named_static_parameter] = STATE(6034),
    [sym_type_attribute] = STATE(6357),
    [sym_type_argument] = STATE(4913),
    [sym_static_parameter_value] = STATE(6034),
    [sym_char] = STATE(2803),
    [sym_format_string] = STATE(2805),
    [sym__string_literal] = STATE(2805),
    [sym_string] = STATE(2803),
    [sym_verbatim_string] = STATE(2803),
    [sym_bytearray] = STATE(2803),
    [sym_verbatim_bytearray] = STATE(2803),
    [sym_format_triple_quoted_string] = STATE(2809),
    [sym_triple_quoted_string] = STATE(2803),
    [sym_const] = STATE(432),
    [sym_long_identifier] = STATE(5121),
    [sym_sbyte] = STATE(2803),
    [sym_byte] = STATE(2803),
    [sym_int16] = STATE(2803),
    [sym_uint16] = STATE(2803),
    [sym_int32] = STATE(2803),
    [sym_uint32] = STATE(2803),
    [sym_nativeint] = STATE(2803),
    [sym_unativeint] = STATE(2803),
    [sym_int64] = STATE(2803),
    [sym_uint64] = STATE(2803),
    [sym_ieee32] = STATE(2803),
    [sym_ieee64] = STATE(2803),
    [sym_bignum] = STATE(2803),
    [sym_decimal] = STATE(2803),
    [sym_float] = STATE(2793),
    [sym_block_comment] = STATE(2782),
    [sym_compiler_directive_decl] = STATE(2782),
    [sym_fsi_directive_decl] = STATE(2782),
    [sym_preproc_line] = STATE(2782),
    [sym_identifier] = ACTIONS(4509),
    [anon_sym_LPAREN] = ACTIONS(4511),
    [anon_sym__] = ACTIONS(4513),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4515),
    [anon_sym_POUND] = ACTIONS(4519),
    [anon_sym_CARET] = ACTIONS(4521),
    [anon_sym_SQUOTE] = ACTIONS(4521),
    [aux_sym_char_token1] = ACTIONS(4523),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4525),
    [anon_sym_DQUOTE] = ACTIONS(4527),
    [anon_sym_AT_DQUOTE] = ACTIONS(4529),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4531),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4533),
    [sym_bool] = ACTIONS(4535),
    [sym_unit] = ACTIONS(4537),
    [sym_int] = ACTIONS(4539),
    [sym_xint] = ACTIONS(4541),
    [anon_sym_LPAREN_STAR] = ACTIONS(27),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
  },
  [2783] = {
    [sym_block_comment] = STATE(2783),
    [sym_compiler_directive_decl] = STATE(2783),
    [sym_fsi_directive_decl] = STATE(2783),
    [sym_preproc_line] = STATE(2783),
    [sym_identifier] = ACTIONS(2563),
    [anon_sym_GT_RBRACK] = ACTIONS(2565),
    [anon_sym_return] = ACTIONS(2563),
    [anon_sym_do] = ACTIONS(2563),
    [anon_sym_let] = ACTIONS(2563),
    [anon_sym_let_BANG] = ACTIONS(2565),
    [anon_sym_LPAREN] = ACTIONS(2563),
    [anon_sym_null] = ACTIONS(2563),
    [anon_sym_AMP] = ACTIONS(2563),
    [anon_sym_LBRACK] = ACTIONS(2563),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2565),
    [anon_sym_LBRACE] = ACTIONS(2563),
    [anon_sym_LT_AT] = ACTIONS(2563),
    [anon_sym_LT_AT_AT] = ACTIONS(2565),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2565),
    [anon_sym_new] = ACTIONS(2563),
    [anon_sym_return_BANG] = ACTIONS(2565),
    [anon_sym_yield] = ACTIONS(2563),
    [anon_sym_yield_BANG] = ACTIONS(2565),
    [anon_sym_lazy] = ACTIONS(2563),
    [anon_sym_assert] = ACTIONS(2563),
    [anon_sym_upcast] = ACTIONS(2563),
    [anon_sym_downcast] = ACTIONS(2563),
    [anon_sym_for] = ACTIONS(2563),
    [anon_sym_while] = ACTIONS(2563),
    [anon_sym_if] = ACTIONS(2563),
    [anon_sym_fun] = ACTIONS(2563),
    [anon_sym_DASH_GT] = ACTIONS(2565),
    [anon_sym_try] = ACTIONS(2563),
    [anon_sym_match] = ACTIONS(2563),
    [anon_sym_match_BANG] = ACTIONS(2565),
    [anon_sym_function] = ACTIONS(2563),
    [anon_sym_use] = ACTIONS(2563),
    [anon_sym_use_BANG] = ACTIONS(2565),
    [anon_sym_do_BANG] = ACTIONS(2565),
    [anon_sym_begin] = ACTIONS(2563),
    [anon_sym_STAR] = ACTIONS(2565),
    [anon_sym_LT2] = ACTIONS(2563),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2565),
    [aux_sym_char_token1] = ACTIONS(2565),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2563),
    [anon_sym_DQUOTE] = ACTIONS(2563),
    [anon_sym_AT_DQUOTE] = ACTIONS(2565),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2565),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2565),
    [sym_bool] = ACTIONS(2563),
    [sym_unit] = ACTIONS(2565),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2563),
    [sym_op_identifier] = ACTIONS(2565),
    [anon_sym_PLUS] = ACTIONS(2563),
    [anon_sym_DASH] = ACTIONS(2563),
    [anon_sym_PLUS_DOT] = ACTIONS(2565),
    [anon_sym_DASH_DOT] = ACTIONS(2565),
    [anon_sym_PERCENT] = ACTIONS(2565),
    [anon_sym_AMP_AMP] = ACTIONS(2565),
    [anon_sym_TILDE] = ACTIONS(2565),
    [aux_sym_prefix_op_token1] = ACTIONS(2565),
    [sym_int] = ACTIONS(2563),
    [sym_xint] = ACTIONS(2565),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2565),
    [sym__newline] = ACTIONS(2565),
  },
  [2784] = {
    [sym_block_comment] = STATE(2784),
    [sym_compiler_directive_decl] = STATE(2784),
    [sym_fsi_directive_decl] = STATE(2784),
    [sym_preproc_line] = STATE(2784),
    [sym_identifier] = ACTIONS(2466),
    [anon_sym_GT_RBRACK] = ACTIONS(2468),
    [anon_sym_return] = ACTIONS(2466),
    [anon_sym_do] = ACTIONS(2466),
    [anon_sym_let] = ACTIONS(2466),
    [anon_sym_let_BANG] = ACTIONS(2468),
    [anon_sym_LPAREN] = ACTIONS(2466),
    [anon_sym_null] = ACTIONS(2466),
    [anon_sym_AMP] = ACTIONS(2466),
    [anon_sym_LBRACK] = ACTIONS(2466),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2468),
    [anon_sym_LBRACE] = ACTIONS(2466),
    [anon_sym_LT_AT] = ACTIONS(2466),
    [anon_sym_LT_AT_AT] = ACTIONS(2468),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2468),
    [anon_sym_new] = ACTIONS(2466),
    [anon_sym_return_BANG] = ACTIONS(2468),
    [anon_sym_yield] = ACTIONS(2466),
    [anon_sym_yield_BANG] = ACTIONS(2468),
    [anon_sym_lazy] = ACTIONS(2466),
    [anon_sym_assert] = ACTIONS(2466),
    [anon_sym_upcast] = ACTIONS(2466),
    [anon_sym_downcast] = ACTIONS(2466),
    [anon_sym_for] = ACTIONS(2466),
    [anon_sym_while] = ACTIONS(2466),
    [anon_sym_if] = ACTIONS(2466),
    [anon_sym_fun] = ACTIONS(2466),
    [anon_sym_DASH_GT] = ACTIONS(2468),
    [anon_sym_try] = ACTIONS(2466),
    [anon_sym_match] = ACTIONS(2466),
    [anon_sym_match_BANG] = ACTIONS(2468),
    [anon_sym_function] = ACTIONS(2466),
    [anon_sym_use] = ACTIONS(2466),
    [anon_sym_use_BANG] = ACTIONS(2468),
    [anon_sym_do_BANG] = ACTIONS(2468),
    [anon_sym_begin] = ACTIONS(2466),
    [anon_sym_STAR] = ACTIONS(2468),
    [anon_sym_LT2] = ACTIONS(2466),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2468),
    [aux_sym_char_token1] = ACTIONS(2468),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2466),
    [anon_sym_DQUOTE] = ACTIONS(2466),
    [anon_sym_AT_DQUOTE] = ACTIONS(2468),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2468),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2468),
    [sym_bool] = ACTIONS(2466),
    [sym_unit] = ACTIONS(2468),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2466),
    [sym_op_identifier] = ACTIONS(2468),
    [anon_sym_PLUS] = ACTIONS(2466),
    [anon_sym_DASH] = ACTIONS(2466),
    [anon_sym_PLUS_DOT] = ACTIONS(2468),
    [anon_sym_DASH_DOT] = ACTIONS(2468),
    [anon_sym_PERCENT] = ACTIONS(2468),
    [anon_sym_AMP_AMP] = ACTIONS(2468),
    [anon_sym_TILDE] = ACTIONS(2468),
    [aux_sym_prefix_op_token1] = ACTIONS(2468),
    [sym_int] = ACTIONS(2466),
    [sym_xint] = ACTIONS(2468),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2468),
    [sym__newline] = ACTIONS(2468),
  },
  [2785] = {
    [sym_block_comment] = STATE(2785),
    [sym_compiler_directive_decl] = STATE(2785),
    [sym_fsi_directive_decl] = STATE(2785),
    [sym_preproc_line] = STATE(2785),
    [sym_identifier] = ACTIONS(2506),
    [anon_sym_GT_RBRACK] = ACTIONS(2508),
    [anon_sym_return] = ACTIONS(2506),
    [anon_sym_do] = ACTIONS(2506),
    [anon_sym_let] = ACTIONS(2506),
    [anon_sym_let_BANG] = ACTIONS(2508),
    [anon_sym_LPAREN] = ACTIONS(2506),
    [anon_sym_null] = ACTIONS(2506),
    [anon_sym_AMP] = ACTIONS(2506),
    [anon_sym_LBRACK] = ACTIONS(2506),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2508),
    [anon_sym_LBRACE] = ACTIONS(2506),
    [anon_sym_LT_AT] = ACTIONS(2506),
    [anon_sym_LT_AT_AT] = ACTIONS(2508),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2508),
    [anon_sym_new] = ACTIONS(2506),
    [anon_sym_return_BANG] = ACTIONS(2508),
    [anon_sym_yield] = ACTIONS(2506),
    [anon_sym_yield_BANG] = ACTIONS(2508),
    [anon_sym_lazy] = ACTIONS(2506),
    [anon_sym_assert] = ACTIONS(2506),
    [anon_sym_upcast] = ACTIONS(2506),
    [anon_sym_downcast] = ACTIONS(2506),
    [anon_sym_for] = ACTIONS(2506),
    [anon_sym_while] = ACTIONS(2506),
    [anon_sym_if] = ACTIONS(2506),
    [anon_sym_fun] = ACTIONS(2506),
    [anon_sym_DASH_GT] = ACTIONS(2508),
    [anon_sym_try] = ACTIONS(2506),
    [anon_sym_match] = ACTIONS(2506),
    [anon_sym_match_BANG] = ACTIONS(2508),
    [anon_sym_function] = ACTIONS(2506),
    [anon_sym_use] = ACTIONS(2506),
    [anon_sym_use_BANG] = ACTIONS(2508),
    [anon_sym_do_BANG] = ACTIONS(2508),
    [anon_sym_begin] = ACTIONS(2506),
    [anon_sym_STAR] = ACTIONS(2508),
    [anon_sym_LT2] = ACTIONS(2506),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2508),
    [aux_sym_char_token1] = ACTIONS(2508),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2506),
    [anon_sym_DQUOTE] = ACTIONS(2506),
    [anon_sym_AT_DQUOTE] = ACTIONS(2508),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2508),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2508),
    [sym_bool] = ACTIONS(2506),
    [sym_unit] = ACTIONS(2508),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2506),
    [sym_op_identifier] = ACTIONS(2508),
    [anon_sym_PLUS] = ACTIONS(2506),
    [anon_sym_DASH] = ACTIONS(2506),
    [anon_sym_PLUS_DOT] = ACTIONS(2508),
    [anon_sym_DASH_DOT] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_AMP_AMP] = ACTIONS(2508),
    [anon_sym_TILDE] = ACTIONS(2508),
    [aux_sym_prefix_op_token1] = ACTIONS(2508),
    [sym_int] = ACTIONS(2506),
    [sym_xint] = ACTIONS(2508),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2508),
    [sym__newline] = ACTIONS(2508),
  },
  [2786] = {
    [sym_block_comment] = STATE(2786),
    [sym_compiler_directive_decl] = STATE(2786),
    [sym_fsi_directive_decl] = STATE(2786),
    [sym_preproc_line] = STATE(2786),
    [sym_identifier] = ACTIONS(2474),
    [anon_sym_GT_RBRACK] = ACTIONS(2476),
    [anon_sym_return] = ACTIONS(2474),
    [anon_sym_do] = ACTIONS(2474),
    [anon_sym_let] = ACTIONS(2474),
    [anon_sym_let_BANG] = ACTIONS(2476),
    [anon_sym_LPAREN] = ACTIONS(2474),
    [anon_sym_null] = ACTIONS(2474),
    [anon_sym_AMP] = ACTIONS(2474),
    [anon_sym_LBRACK] = ACTIONS(2474),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2476),
    [anon_sym_LBRACE] = ACTIONS(2474),
    [anon_sym_LT_AT] = ACTIONS(2474),
    [anon_sym_LT_AT_AT] = ACTIONS(2476),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2476),
    [anon_sym_new] = ACTIONS(2474),
    [anon_sym_return_BANG] = ACTIONS(2476),
    [anon_sym_yield] = ACTIONS(2474),
    [anon_sym_yield_BANG] = ACTIONS(2476),
    [anon_sym_lazy] = ACTIONS(2474),
    [anon_sym_assert] = ACTIONS(2474),
    [anon_sym_upcast] = ACTIONS(2474),
    [anon_sym_downcast] = ACTIONS(2474),
    [anon_sym_for] = ACTIONS(2474),
    [anon_sym_while] = ACTIONS(2474),
    [anon_sym_if] = ACTIONS(2474),
    [anon_sym_fun] = ACTIONS(2474),
    [anon_sym_DASH_GT] = ACTIONS(2476),
    [anon_sym_try] = ACTIONS(2474),
    [anon_sym_match] = ACTIONS(2474),
    [anon_sym_match_BANG] = ACTIONS(2476),
    [anon_sym_function] = ACTIONS(2474),
    [anon_sym_use] = ACTIONS(2474),
    [anon_sym_use_BANG] = ACTIONS(2476),
    [anon_sym_do_BANG] = ACTIONS(2476),
    [anon_sym_begin] = ACTIONS(2474),
    [anon_sym_STAR] = ACTIONS(2476),
    [anon_sym_LT2] = ACTIONS(2474),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2476),
    [aux_sym_char_token1] = ACTIONS(2476),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2474),
    [anon_sym_DQUOTE] = ACTIONS(2474),
    [anon_sym_AT_DQUOTE] = ACTIONS(2476),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2476),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2476),
    [sym_bool] = ACTIONS(2474),
    [sym_unit] = ACTIONS(2476),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2474),
    [sym_op_identifier] = ACTIONS(2476),
    [anon_sym_PLUS] = ACTIONS(2474),
    [anon_sym_DASH] = ACTIONS(2474),
    [anon_sym_PLUS_DOT] = ACTIONS(2476),
    [anon_sym_DASH_DOT] = ACTIONS(2476),
    [anon_sym_PERCENT] = ACTIONS(2476),
    [anon_sym_AMP_AMP] = ACTIONS(2476),
    [anon_sym_TILDE] = ACTIONS(2476),
    [aux_sym_prefix_op_token1] = ACTIONS(2476),
    [sym_int] = ACTIONS(2474),
    [sym_xint] = ACTIONS(2476),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2476),
    [sym__newline] = ACTIONS(2476),
  },
  [2787] = {
    [sym_block_comment] = STATE(2787),
    [sym_compiler_directive_decl] = STATE(2787),
    [sym_fsi_directive_decl] = STATE(2787),
    [sym_preproc_line] = STATE(2787),
    [sym_identifier] = ACTIONS(2510),
    [anon_sym_GT_RBRACK] = ACTIONS(2512),
    [anon_sym_return] = ACTIONS(2510),
    [anon_sym_do] = ACTIONS(2510),
    [anon_sym_let] = ACTIONS(2510),
    [anon_sym_let_BANG] = ACTIONS(2512),
    [anon_sym_LPAREN] = ACTIONS(2510),
    [anon_sym_null] = ACTIONS(2510),
    [anon_sym_AMP] = ACTIONS(2510),
    [anon_sym_LBRACK] = ACTIONS(2510),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2512),
    [anon_sym_LBRACE] = ACTIONS(2510),
    [anon_sym_LT_AT] = ACTIONS(2510),
    [anon_sym_LT_AT_AT] = ACTIONS(2512),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2512),
    [anon_sym_new] = ACTIONS(2510),
    [anon_sym_return_BANG] = ACTIONS(2512),
    [anon_sym_yield] = ACTIONS(2510),
    [anon_sym_yield_BANG] = ACTIONS(2512),
    [anon_sym_lazy] = ACTIONS(2510),
    [anon_sym_assert] = ACTIONS(2510),
    [anon_sym_upcast] = ACTIONS(2510),
    [anon_sym_downcast] = ACTIONS(2510),
    [anon_sym_for] = ACTIONS(2510),
    [anon_sym_while] = ACTIONS(2510),
    [anon_sym_if] = ACTIONS(2510),
    [anon_sym_fun] = ACTIONS(2510),
    [anon_sym_DASH_GT] = ACTIONS(2512),
    [anon_sym_try] = ACTIONS(2510),
    [anon_sym_match] = ACTIONS(2510),
    [anon_sym_match_BANG] = ACTIONS(2512),
    [anon_sym_function] = ACTIONS(2510),
    [anon_sym_use] = ACTIONS(2510),
    [anon_sym_use_BANG] = ACTIONS(2512),
    [anon_sym_do_BANG] = ACTIONS(2512),
    [anon_sym_begin] = ACTIONS(2510),
    [anon_sym_STAR] = ACTIONS(2512),
    [anon_sym_LT2] = ACTIONS(2510),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2512),
    [aux_sym_char_token1] = ACTIONS(2512),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2510),
    [anon_sym_DQUOTE] = ACTIONS(2510),
    [anon_sym_AT_DQUOTE] = ACTIONS(2512),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2512),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2512),
    [sym_bool] = ACTIONS(2510),
    [sym_unit] = ACTIONS(2512),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2510),
    [sym_op_identifier] = ACTIONS(2512),
    [anon_sym_PLUS] = ACTIONS(2510),
    [anon_sym_DASH] = ACTIONS(2510),
    [anon_sym_PLUS_DOT] = ACTIONS(2512),
    [anon_sym_DASH_DOT] = ACTIONS(2512),
    [anon_sym_PERCENT] = ACTIONS(2512),
    [anon_sym_AMP_AMP] = ACTIONS(2512),
    [anon_sym_TILDE] = ACTIONS(2512),
    [aux_sym_prefix_op_token1] = ACTIONS(2512),
    [sym_int] = ACTIONS(2510),
    [sym_xint] = ACTIONS(2512),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2512),
    [sym__newline] = ACTIONS(2512),
  },
  [2788] = {
    [sym_block_comment] = STATE(2788),
    [sym_compiler_directive_decl] = STATE(2788),
    [sym_fsi_directive_decl] = STATE(2788),
    [sym_preproc_line] = STATE(2788),
    [sym_identifier] = ACTIONS(2557),
    [anon_sym_GT_RBRACK] = ACTIONS(2559),
    [anon_sym_return] = ACTIONS(2557),
    [anon_sym_do] = ACTIONS(2557),
    [anon_sym_let] = ACTIONS(2557),
    [anon_sym_let_BANG] = ACTIONS(2559),
    [anon_sym_LPAREN] = ACTIONS(2557),
    [anon_sym_null] = ACTIONS(2557),
    [anon_sym_AMP] = ACTIONS(2557),
    [anon_sym_LBRACK] = ACTIONS(2557),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2559),
    [anon_sym_LBRACE] = ACTIONS(2557),
    [anon_sym_LT_AT] = ACTIONS(2557),
    [anon_sym_LT_AT_AT] = ACTIONS(2559),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2559),
    [anon_sym_new] = ACTIONS(2557),
    [anon_sym_return_BANG] = ACTIONS(2559),
    [anon_sym_yield] = ACTIONS(2557),
    [anon_sym_yield_BANG] = ACTIONS(2559),
    [anon_sym_lazy] = ACTIONS(2557),
    [anon_sym_assert] = ACTIONS(2557),
    [anon_sym_upcast] = ACTIONS(2557),
    [anon_sym_downcast] = ACTIONS(2557),
    [anon_sym_for] = ACTIONS(2557),
    [anon_sym_while] = ACTIONS(2557),
    [anon_sym_if] = ACTIONS(2557),
    [anon_sym_fun] = ACTIONS(2557),
    [anon_sym_DASH_GT] = ACTIONS(2559),
    [anon_sym_try] = ACTIONS(2557),
    [anon_sym_match] = ACTIONS(2557),
    [anon_sym_match_BANG] = ACTIONS(2559),
    [anon_sym_function] = ACTIONS(2557),
    [anon_sym_use] = ACTIONS(2557),
    [anon_sym_use_BANG] = ACTIONS(2559),
    [anon_sym_do_BANG] = ACTIONS(2559),
    [anon_sym_begin] = ACTIONS(2557),
    [anon_sym_STAR] = ACTIONS(2559),
    [anon_sym_LT2] = ACTIONS(4671),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2559),
    [aux_sym_char_token1] = ACTIONS(2559),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2557),
    [anon_sym_DQUOTE] = ACTIONS(2557),
    [anon_sym_AT_DQUOTE] = ACTIONS(2559),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2559),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2559),
    [sym_bool] = ACTIONS(2557),
    [sym_unit] = ACTIONS(2559),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2557),
    [sym_op_identifier] = ACTIONS(2559),
    [anon_sym_PLUS] = ACTIONS(2557),
    [anon_sym_DASH] = ACTIONS(2557),
    [anon_sym_PLUS_DOT] = ACTIONS(2559),
    [anon_sym_DASH_DOT] = ACTIONS(2559),
    [anon_sym_PERCENT] = ACTIONS(2559),
    [anon_sym_AMP_AMP] = ACTIONS(2559),
    [anon_sym_TILDE] = ACTIONS(2559),
    [aux_sym_prefix_op_token1] = ACTIONS(2559),
    [sym_int] = ACTIONS(2557),
    [sym_xint] = ACTIONS(2559),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2559),
    [sym__newline] = ACTIONS(2559),
  },
  [2789] = {
    [sym_block_comment] = STATE(2789),
    [sym_compiler_directive_decl] = STATE(2789),
    [sym_fsi_directive_decl] = STATE(2789),
    [sym_preproc_line] = STATE(2789),
    [sym_identifier] = ACTIONS(2454),
    [anon_sym_GT_RBRACK] = ACTIONS(2456),
    [anon_sym_return] = ACTIONS(2454),
    [anon_sym_do] = ACTIONS(2454),
    [anon_sym_let] = ACTIONS(2454),
    [anon_sym_let_BANG] = ACTIONS(2456),
    [anon_sym_LPAREN] = ACTIONS(2454),
    [anon_sym_null] = ACTIONS(2454),
    [anon_sym_AMP] = ACTIONS(2454),
    [anon_sym_LBRACK] = ACTIONS(2454),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2456),
    [anon_sym_LBRACE] = ACTIONS(2454),
    [anon_sym_LT_AT] = ACTIONS(2454),
    [anon_sym_LT_AT_AT] = ACTIONS(2456),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2456),
    [anon_sym_new] = ACTIONS(2454),
    [anon_sym_return_BANG] = ACTIONS(2456),
    [anon_sym_yield] = ACTIONS(2454),
    [anon_sym_yield_BANG] = ACTIONS(2456),
    [anon_sym_lazy] = ACTIONS(2454),
    [anon_sym_assert] = ACTIONS(2454),
    [anon_sym_upcast] = ACTIONS(2454),
    [anon_sym_downcast] = ACTIONS(2454),
    [anon_sym_for] = ACTIONS(2454),
    [anon_sym_while] = ACTIONS(2454),
    [anon_sym_if] = ACTIONS(2454),
    [anon_sym_fun] = ACTIONS(2454),
    [anon_sym_DASH_GT] = ACTIONS(2456),
    [anon_sym_try] = ACTIONS(2454),
    [anon_sym_match] = ACTIONS(2454),
    [anon_sym_match_BANG] = ACTIONS(2456),
    [anon_sym_function] = ACTIONS(2454),
    [anon_sym_use] = ACTIONS(2454),
    [anon_sym_use_BANG] = ACTIONS(2456),
    [anon_sym_do_BANG] = ACTIONS(2456),
    [anon_sym_begin] = ACTIONS(2454),
    [anon_sym_STAR] = ACTIONS(2456),
    [anon_sym_LT2] = ACTIONS(2454),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2456),
    [aux_sym_char_token1] = ACTIONS(2456),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2454),
    [anon_sym_DQUOTE] = ACTIONS(2454),
    [anon_sym_AT_DQUOTE] = ACTIONS(2456),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2456),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2456),
    [sym_bool] = ACTIONS(2454),
    [sym_unit] = ACTIONS(2456),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2454),
    [sym_op_identifier] = ACTIONS(2456),
    [anon_sym_PLUS] = ACTIONS(2454),
    [anon_sym_DASH] = ACTIONS(2454),
    [anon_sym_PLUS_DOT] = ACTIONS(2456),
    [anon_sym_DASH_DOT] = ACTIONS(2456),
    [anon_sym_PERCENT] = ACTIONS(2456),
    [anon_sym_AMP_AMP] = ACTIONS(2456),
    [anon_sym_TILDE] = ACTIONS(2456),
    [aux_sym_prefix_op_token1] = ACTIONS(2456),
    [sym_int] = ACTIONS(2454),
    [sym_xint] = ACTIONS(2456),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2456),
    [sym__newline] = ACTIONS(2456),
  },
  [2790] = {
    [sym_block_comment] = STATE(2790),
    [sym_compiler_directive_decl] = STATE(2790),
    [sym_fsi_directive_decl] = STATE(2790),
    [sym_preproc_line] = STATE(2790),
    [sym_identifier] = ACTIONS(2627),
    [anon_sym_GT_RBRACK] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(2627),
    [anon_sym_do] = ACTIONS(2627),
    [anon_sym_let] = ACTIONS(2627),
    [anon_sym_let_BANG] = ACTIONS(2629),
    [anon_sym_LPAREN] = ACTIONS(2627),
    [anon_sym_null] = ACTIONS(2627),
    [anon_sym_AMP] = ACTIONS(2627),
    [anon_sym_LBRACK] = ACTIONS(2627),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2629),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_LT_AT] = ACTIONS(2627),
    [anon_sym_LT_AT_AT] = ACTIONS(2629),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2629),
    [anon_sym_new] = ACTIONS(2627),
    [anon_sym_return_BANG] = ACTIONS(2629),
    [anon_sym_yield] = ACTIONS(2627),
    [anon_sym_yield_BANG] = ACTIONS(2629),
    [anon_sym_lazy] = ACTIONS(2627),
    [anon_sym_assert] = ACTIONS(2627),
    [anon_sym_upcast] = ACTIONS(2627),
    [anon_sym_downcast] = ACTIONS(2627),
    [anon_sym_for] = ACTIONS(2627),
    [anon_sym_while] = ACTIONS(2627),
    [anon_sym_if] = ACTIONS(2627),
    [anon_sym_fun] = ACTIONS(2627),
    [anon_sym_DASH_GT] = ACTIONS(2629),
    [anon_sym_try] = ACTIONS(2627),
    [anon_sym_match] = ACTIONS(2627),
    [anon_sym_match_BANG] = ACTIONS(2629),
    [anon_sym_function] = ACTIONS(2627),
    [anon_sym_use] = ACTIONS(2627),
    [anon_sym_use_BANG] = ACTIONS(2629),
    [anon_sym_do_BANG] = ACTIONS(2629),
    [anon_sym_begin] = ACTIONS(2627),
    [anon_sym_STAR] = ACTIONS(2629),
    [anon_sym_LT2] = ACTIONS(2627),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2629),
    [aux_sym_char_token1] = ACTIONS(2629),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2627),
    [anon_sym_DQUOTE] = ACTIONS(2627),
    [anon_sym_AT_DQUOTE] = ACTIONS(2629),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2629),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2629),
    [sym_bool] = ACTIONS(2627),
    [sym_unit] = ACTIONS(2629),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2627),
    [sym_op_identifier] = ACTIONS(2629),
    [anon_sym_PLUS] = ACTIONS(2627),
    [anon_sym_DASH] = ACTIONS(2627),
    [anon_sym_PLUS_DOT] = ACTIONS(2629),
    [anon_sym_DASH_DOT] = ACTIONS(2629),
    [anon_sym_PERCENT] = ACTIONS(2629),
    [anon_sym_AMP_AMP] = ACTIONS(2629),
    [anon_sym_TILDE] = ACTIONS(2629),
    [aux_sym_prefix_op_token1] = ACTIONS(2629),
    [sym_int] = ACTIONS(2627),
    [sym_xint] = ACTIONS(2629),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2629),
    [sym__newline] = ACTIONS(2629),
  },
  [2791] = {
    [sym_block_comment] = STATE(2791),
    [sym_compiler_directive_decl] = STATE(2791),
    [sym_fsi_directive_decl] = STATE(2791),
    [sym_preproc_line] = STATE(2791),
    [sym_identifier] = ACTIONS(2723),
    [anon_sym_return] = ACTIONS(2723),
    [anon_sym_do] = ACTIONS(2723),
    [anon_sym_let] = ACTIONS(2723),
    [anon_sym_let_BANG] = ACTIONS(2725),
    [anon_sym_LPAREN] = ACTIONS(2723),
    [anon_sym_COMMA] = ACTIONS(2725),
    [anon_sym_null] = ACTIONS(2723),
    [anon_sym_AMP] = ACTIONS(2723),
    [anon_sym_LBRACK] = ACTIONS(2723),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2725),
    [anon_sym_LBRACE] = ACTIONS(2723),
    [anon_sym_LT_AT] = ACTIONS(2723),
    [anon_sym_LT_AT_AT] = ACTIONS(2725),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2725),
    [anon_sym_new] = ACTIONS(2723),
    [anon_sym_return_BANG] = ACTIONS(2725),
    [anon_sym_yield] = ACTIONS(2723),
    [anon_sym_yield_BANG] = ACTIONS(2725),
    [anon_sym_lazy] = ACTIONS(2723),
    [anon_sym_assert] = ACTIONS(2723),
    [anon_sym_upcast] = ACTIONS(2723),
    [anon_sym_downcast] = ACTIONS(2723),
    [anon_sym_for] = ACTIONS(2723),
    [anon_sym_while] = ACTIONS(2723),
    [anon_sym_if] = ACTIONS(2723),
    [anon_sym_fun] = ACTIONS(2723),
    [anon_sym_try] = ACTIONS(2723),
    [anon_sym_match] = ACTIONS(2723),
    [anon_sym_match_BANG] = ACTIONS(2725),
    [anon_sym_function] = ACTIONS(2723),
    [anon_sym_GT] = ACTIONS(2725),
    [anon_sym_use] = ACTIONS(2723),
    [anon_sym_use_BANG] = ACTIONS(2725),
    [anon_sym_do_BANG] = ACTIONS(2725),
    [anon_sym_begin] = ACTIONS(2723),
    [aux_sym_char_token1] = ACTIONS(2725),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2723),
    [anon_sym_DQUOTE] = ACTIONS(2723),
    [anon_sym_AT_DQUOTE] = ACTIONS(2725),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2725),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2725),
    [sym_bool] = ACTIONS(2723),
    [sym_unit] = ACTIONS(2725),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2723),
    [sym_op_identifier] = ACTIONS(2725),
    [anon_sym_PLUS] = ACTIONS(2723),
    [anon_sym_DASH] = ACTIONS(2723),
    [anon_sym_PLUS_DOT] = ACTIONS(2725),
    [anon_sym_DASH_DOT] = ACTIONS(2725),
    [anon_sym_PERCENT] = ACTIONS(2725),
    [anon_sym_AMP_AMP] = ACTIONS(2725),
    [anon_sym_TILDE] = ACTIONS(2725),
    [aux_sym_prefix_op_token1] = ACTIONS(2725),
    [sym_int] = ACTIONS(2723),
    [sym_xint] = ACTIONS(2725),
    [anon_sym_f] = ACTIONS(2723),
    [aux_sym_decimal_token1] = ACTIONS(2723),
    [aux_sym_float_token1] = ACTIONS(4673),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2725),
  },
  [2792] = {
    [sym_block_comment] = STATE(2792),
    [sym_compiler_directive_decl] = STATE(2792),
    [sym_fsi_directive_decl] = STATE(2792),
    [sym_preproc_line] = STATE(2792),
    [sym_identifier] = ACTIONS(2723),
    [anon_sym_return] = ACTIONS(2723),
    [anon_sym_do] = ACTIONS(2723),
    [anon_sym_let] = ACTIONS(2723),
    [anon_sym_let_BANG] = ACTIONS(2725),
    [anon_sym_LPAREN] = ACTIONS(2723),
    [anon_sym_COMMA] = ACTIONS(2725),
    [anon_sym_null] = ACTIONS(2723),
    [anon_sym_AMP] = ACTIONS(2723),
    [anon_sym_LBRACK] = ACTIONS(2723),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2725),
    [anon_sym_LBRACE] = ACTIONS(2723),
    [anon_sym_LT_AT] = ACTIONS(2723),
    [anon_sym_LT_AT_AT] = ACTIONS(2725),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2725),
    [anon_sym_new] = ACTIONS(2723),
    [anon_sym_return_BANG] = ACTIONS(2725),
    [anon_sym_yield] = ACTIONS(2723),
    [anon_sym_yield_BANG] = ACTIONS(2725),
    [anon_sym_lazy] = ACTIONS(2723),
    [anon_sym_assert] = ACTIONS(2723),
    [anon_sym_upcast] = ACTIONS(2723),
    [anon_sym_downcast] = ACTIONS(2723),
    [anon_sym_for] = ACTIONS(2723),
    [anon_sym_while] = ACTIONS(2723),
    [anon_sym_if] = ACTIONS(2723),
    [anon_sym_fun] = ACTIONS(2723),
    [anon_sym_try] = ACTIONS(2723),
    [anon_sym_match] = ACTIONS(2723),
    [anon_sym_match_BANG] = ACTIONS(2725),
    [anon_sym_function] = ACTIONS(2723),
    [anon_sym_GT] = ACTIONS(2725),
    [anon_sym_use] = ACTIONS(2723),
    [anon_sym_use_BANG] = ACTIONS(2725),
    [anon_sym_do_BANG] = ACTIONS(2725),
    [anon_sym_begin] = ACTIONS(2723),
    [aux_sym_char_token1] = ACTIONS(2725),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2723),
    [anon_sym_DQUOTE] = ACTIONS(2723),
    [anon_sym_AT_DQUOTE] = ACTIONS(2725),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2725),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2725),
    [sym_bool] = ACTIONS(2723),
    [sym_unit] = ACTIONS(2725),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2723),
    [sym_op_identifier] = ACTIONS(2725),
    [anon_sym_PLUS] = ACTIONS(2723),
    [anon_sym_DASH] = ACTIONS(2723),
    [anon_sym_PLUS_DOT] = ACTIONS(2725),
    [anon_sym_DASH_DOT] = ACTIONS(2725),
    [anon_sym_PERCENT] = ACTIONS(2725),
    [anon_sym_AMP_AMP] = ACTIONS(2725),
    [anon_sym_TILDE] = ACTIONS(2725),
    [aux_sym_prefix_op_token1] = ACTIONS(2725),
    [sym_int] = ACTIONS(2723),
    [sym_xint] = ACTIONS(2725),
    [anon_sym_f] = ACTIONS(2723),
    [aux_sym_decimal_token1] = ACTIONS(2723),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2725),
  },
  [2793] = {
    [sym_block_comment] = STATE(2793),
    [sym_compiler_directive_decl] = STATE(2793),
    [sym_fsi_directive_decl] = STATE(2793),
    [sym_preproc_line] = STATE(2793),
    [sym_identifier] = ACTIONS(2158),
    [anon_sym_return] = ACTIONS(2158),
    [anon_sym_do] = ACTIONS(2158),
    [anon_sym_let] = ACTIONS(2158),
    [anon_sym_let_BANG] = ACTIONS(2160),
    [anon_sym_LPAREN] = ACTIONS(2158),
    [anon_sym_COMMA] = ACTIONS(2160),
    [anon_sym_null] = ACTIONS(2158),
    [anon_sym_AMP] = ACTIONS(2158),
    [anon_sym_LBRACK] = ACTIONS(2158),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2160),
    [anon_sym_LBRACE] = ACTIONS(2158),
    [anon_sym_LT_AT] = ACTIONS(2158),
    [anon_sym_LT_AT_AT] = ACTIONS(2160),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2160),
    [anon_sym_new] = ACTIONS(2158),
    [anon_sym_return_BANG] = ACTIONS(2160),
    [anon_sym_yield] = ACTIONS(2158),
    [anon_sym_yield_BANG] = ACTIONS(2160),
    [anon_sym_lazy] = ACTIONS(2158),
    [anon_sym_assert] = ACTIONS(2158),
    [anon_sym_upcast] = ACTIONS(2158),
    [anon_sym_downcast] = ACTIONS(2158),
    [anon_sym_for] = ACTIONS(2158),
    [anon_sym_while] = ACTIONS(2158),
    [anon_sym_if] = ACTIONS(2158),
    [anon_sym_fun] = ACTIONS(2158),
    [anon_sym_try] = ACTIONS(2158),
    [anon_sym_match] = ACTIONS(2158),
    [anon_sym_match_BANG] = ACTIONS(2160),
    [anon_sym_function] = ACTIONS(2158),
    [anon_sym_GT] = ACTIONS(2160),
    [anon_sym_use] = ACTIONS(2158),
    [anon_sym_use_BANG] = ACTIONS(2160),
    [anon_sym_do_BANG] = ACTIONS(2160),
    [anon_sym_begin] = ACTIONS(2158),
    [aux_sym_char_token1] = ACTIONS(2160),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2158),
    [anon_sym_DQUOTE] = ACTIONS(2158),
    [anon_sym_AT_DQUOTE] = ACTIONS(2160),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2160),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2160),
    [sym_bool] = ACTIONS(2158),
    [sym_unit] = ACTIONS(2160),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2158),
    [sym_op_identifier] = ACTIONS(2160),
    [anon_sym_PLUS] = ACTIONS(2158),
    [anon_sym_DASH] = ACTIONS(2158),
    [anon_sym_PLUS_DOT] = ACTIONS(2160),
    [anon_sym_DASH_DOT] = ACTIONS(2160),
    [anon_sym_PERCENT] = ACTIONS(2160),
    [anon_sym_AMP_AMP] = ACTIONS(2160),
    [anon_sym_TILDE] = ACTIONS(2160),
    [aux_sym_prefix_op_token1] = ACTIONS(2160),
    [sym_int] = ACTIONS(2158),
    [sym_xint] = ACTIONS(2160),
    [anon_sym_f] = ACTIONS(4498),
    [aux_sym_decimal_token1] = ACTIONS(4468),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2160),
  },
  [2794] = {
    [sym_block_comment] = STATE(2794),
    [sym_compiler_directive_decl] = STATE(2794),
    [sym_fsi_directive_decl] = STATE(2794),
    [sym_preproc_line] = STATE(2794),
    [sym_identifier] = ACTIONS(2819),
    [anon_sym_return] = ACTIONS(2819),
    [anon_sym_do] = ACTIONS(2819),
    [anon_sym_let] = ACTIONS(2819),
    [anon_sym_let_BANG] = ACTIONS(2821),
    [anon_sym_LPAREN] = ACTIONS(2819),
    [anon_sym_COMMA] = ACTIONS(2821),
    [anon_sym_null] = ACTIONS(2819),
    [anon_sym_AMP] = ACTIONS(2819),
    [anon_sym_LBRACK] = ACTIONS(2819),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2821),
    [anon_sym_LBRACE] = ACTIONS(2819),
    [anon_sym_LT_AT] = ACTIONS(2819),
    [anon_sym_LT_AT_AT] = ACTIONS(2821),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2821),
    [anon_sym_new] = ACTIONS(2819),
    [anon_sym_return_BANG] = ACTIONS(2821),
    [anon_sym_yield] = ACTIONS(2819),
    [anon_sym_yield_BANG] = ACTIONS(2821),
    [anon_sym_lazy] = ACTIONS(2819),
    [anon_sym_assert] = ACTIONS(2819),
    [anon_sym_upcast] = ACTIONS(2819),
    [anon_sym_downcast] = ACTIONS(2819),
    [anon_sym_for] = ACTIONS(2819),
    [anon_sym_while] = ACTIONS(2819),
    [anon_sym_if] = ACTIONS(2819),
    [anon_sym_fun] = ACTIONS(2819),
    [anon_sym_try] = ACTIONS(2819),
    [anon_sym_match] = ACTIONS(2819),
    [anon_sym_match_BANG] = ACTIONS(2821),
    [anon_sym_function] = ACTIONS(2819),
    [anon_sym_GT] = ACTIONS(2821),
    [anon_sym_use] = ACTIONS(2819),
    [anon_sym_use_BANG] = ACTIONS(2821),
    [anon_sym_do_BANG] = ACTIONS(2821),
    [anon_sym_begin] = ACTIONS(2819),
    [aux_sym_char_token1] = ACTIONS(2821),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2819),
    [anon_sym_DQUOTE] = ACTIONS(2819),
    [anon_sym_AT_DQUOTE] = ACTIONS(2821),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2821),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2821),
    [sym_bool] = ACTIONS(2819),
    [sym_unit] = ACTIONS(2821),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2819),
    [sym_op_identifier] = ACTIONS(2821),
    [anon_sym_PLUS] = ACTIONS(2819),
    [anon_sym_DASH] = ACTIONS(2819),
    [anon_sym_PLUS_DOT] = ACTIONS(2821),
    [anon_sym_DASH_DOT] = ACTIONS(2821),
    [anon_sym_PERCENT] = ACTIONS(2821),
    [anon_sym_AMP_AMP] = ACTIONS(2821),
    [anon_sym_TILDE] = ACTIONS(2821),
    [aux_sym_prefix_op_token1] = ACTIONS(2821),
    [sym_int] = ACTIONS(4675),
    [sym_xint] = ACTIONS(2821),
    [anon_sym_f] = ACTIONS(2819),
    [aux_sym_decimal_token1] = ACTIONS(2819),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2821),
  },
  [2795] = {
    [sym_block_comment] = STATE(2795),
    [sym_compiler_directive_decl] = STATE(2795),
    [sym_fsi_directive_decl] = STATE(2795),
    [sym_preproc_line] = STATE(2795),
    [sym_identifier] = ACTIONS(2812),
    [anon_sym_return] = ACTIONS(2812),
    [anon_sym_do] = ACTIONS(2812),
    [anon_sym_let] = ACTIONS(2812),
    [anon_sym_let_BANG] = ACTIONS(2814),
    [anon_sym_LPAREN] = ACTIONS(2812),
    [anon_sym_COMMA] = ACTIONS(2814),
    [anon_sym_null] = ACTIONS(2812),
    [anon_sym_AMP] = ACTIONS(2812),
    [anon_sym_LBRACK] = ACTIONS(2812),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2814),
    [anon_sym_LBRACE] = ACTIONS(2812),
    [anon_sym_LT_AT] = ACTIONS(2812),
    [anon_sym_LT_AT_AT] = ACTIONS(2814),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2814),
    [anon_sym_new] = ACTIONS(2812),
    [anon_sym_return_BANG] = ACTIONS(2814),
    [anon_sym_yield] = ACTIONS(2812),
    [anon_sym_yield_BANG] = ACTIONS(2814),
    [anon_sym_lazy] = ACTIONS(2812),
    [anon_sym_assert] = ACTIONS(2812),
    [anon_sym_upcast] = ACTIONS(2812),
    [anon_sym_downcast] = ACTIONS(2812),
    [anon_sym_for] = ACTIONS(2812),
    [anon_sym_while] = ACTIONS(2812),
    [anon_sym_if] = ACTIONS(2812),
    [anon_sym_fun] = ACTIONS(2812),
    [anon_sym_try] = ACTIONS(2812),
    [anon_sym_match] = ACTIONS(2812),
    [anon_sym_match_BANG] = ACTIONS(2814),
    [anon_sym_function] = ACTIONS(2812),
    [anon_sym_GT] = ACTIONS(2814),
    [anon_sym_use] = ACTIONS(2812),
    [anon_sym_use_BANG] = ACTIONS(2814),
    [anon_sym_do_BANG] = ACTIONS(2814),
    [anon_sym_begin] = ACTIONS(2812),
    [aux_sym_char_token1] = ACTIONS(2814),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2812),
    [anon_sym_DQUOTE] = ACTIONS(2812),
    [anon_sym_AT_DQUOTE] = ACTIONS(2814),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2814),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2814),
    [sym_bool] = ACTIONS(2812),
    [sym_unit] = ACTIONS(2814),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2812),
    [sym_op_identifier] = ACTIONS(2814),
    [anon_sym_PLUS] = ACTIONS(2812),
    [anon_sym_DASH] = ACTIONS(2812),
    [anon_sym_PLUS_DOT] = ACTIONS(2814),
    [anon_sym_DASH_DOT] = ACTIONS(2814),
    [anon_sym_PERCENT] = ACTIONS(2814),
    [anon_sym_AMP_AMP] = ACTIONS(2814),
    [anon_sym_TILDE] = ACTIONS(2814),
    [aux_sym_prefix_op_token1] = ACTIONS(2814),
    [sym_int] = ACTIONS(2812),
    [sym_xint] = ACTIONS(2814),
    [anon_sym_f] = ACTIONS(2812),
    [aux_sym_decimal_token1] = ACTIONS(2812),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2814),
  },
  [2796] = {
    [sym_block_comment] = STATE(2796),
    [sym_compiler_directive_decl] = STATE(2796),
    [sym_fsi_directive_decl] = STATE(2796),
    [sym_preproc_line] = STATE(2796),
    [aux_sym__function_or_value_defns_repeat1] = STATE(2827),
    [sym_identifier] = ACTIONS(4677),
    [anon_sym_return] = ACTIONS(4677),
    [anon_sym_do] = ACTIONS(4677),
    [anon_sym_and] = ACTIONS(4679),
    [anon_sym_let] = ACTIONS(4677),
    [anon_sym_let_BANG] = ACTIONS(4681),
    [anon_sym_LPAREN] = ACTIONS(4677),
    [anon_sym_null] = ACTIONS(4677),
    [anon_sym_AMP] = ACTIONS(4677),
    [anon_sym_LBRACK] = ACTIONS(4677),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4681),
    [anon_sym_LBRACE] = ACTIONS(4677),
    [anon_sym_LT_AT] = ACTIONS(4677),
    [anon_sym_LT_AT_AT] = ACTIONS(4681),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4681),
    [anon_sym_new] = ACTIONS(4677),
    [anon_sym_return_BANG] = ACTIONS(4681),
    [anon_sym_yield] = ACTIONS(4677),
    [anon_sym_yield_BANG] = ACTIONS(4681),
    [anon_sym_lazy] = ACTIONS(4677),
    [anon_sym_assert] = ACTIONS(4677),
    [anon_sym_upcast] = ACTIONS(4677),
    [anon_sym_downcast] = ACTIONS(4677),
    [anon_sym_for] = ACTIONS(4677),
    [anon_sym_while] = ACTIONS(4677),
    [anon_sym_if] = ACTIONS(4677),
    [anon_sym_fun] = ACTIONS(4677),
    [anon_sym_try] = ACTIONS(4677),
    [anon_sym_match] = ACTIONS(4677),
    [anon_sym_match_BANG] = ACTIONS(4681),
    [anon_sym_function] = ACTIONS(4677),
    [anon_sym_use] = ACTIONS(4677),
    [anon_sym_use_BANG] = ACTIONS(4681),
    [anon_sym_do_BANG] = ACTIONS(4681),
    [anon_sym_begin] = ACTIONS(4677),
    [aux_sym_char_token1] = ACTIONS(4681),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4677),
    [anon_sym_DQUOTE] = ACTIONS(4677),
    [anon_sym_AT_DQUOTE] = ACTIONS(4681),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4681),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4681),
    [sym_bool] = ACTIONS(4677),
    [sym_unit] = ACTIONS(4681),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4677),
    [sym_op_identifier] = ACTIONS(4681),
    [anon_sym_PLUS] = ACTIONS(4677),
    [anon_sym_DASH] = ACTIONS(4677),
    [anon_sym_PLUS_DOT] = ACTIONS(4681),
    [anon_sym_DASH_DOT] = ACTIONS(4681),
    [anon_sym_PERCENT] = ACTIONS(4681),
    [anon_sym_AMP_AMP] = ACTIONS(4681),
    [anon_sym_TILDE] = ACTIONS(4681),
    [aux_sym_prefix_op_token1] = ACTIONS(4681),
    [sym_int] = ACTIONS(4677),
    [sym_xint] = ACTIONS(4681),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4681),
  },
  [2797] = {
    [sym_block_comment] = STATE(2797),
    [sym_compiler_directive_decl] = STATE(2797),
    [sym_fsi_directive_decl] = STATE(2797),
    [sym_preproc_line] = STATE(2797),
    [sym_identifier] = ACTIONS(2958),
    [anon_sym_return] = ACTIONS(2958),
    [anon_sym_do] = ACTIONS(2958),
    [anon_sym_let] = ACTIONS(2958),
    [anon_sym_let_BANG] = ACTIONS(2960),
    [anon_sym_LPAREN] = ACTIONS(2958),
    [anon_sym_COMMA] = ACTIONS(2960),
    [anon_sym_null] = ACTIONS(2958),
    [anon_sym_AMP] = ACTIONS(2958),
    [anon_sym_LBRACK] = ACTIONS(2958),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2960),
    [anon_sym_LBRACE] = ACTIONS(2958),
    [anon_sym_LT_AT] = ACTIONS(2958),
    [anon_sym_LT_AT_AT] = ACTIONS(2960),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2960),
    [anon_sym_new] = ACTIONS(2958),
    [anon_sym_return_BANG] = ACTIONS(2960),
    [anon_sym_yield] = ACTIONS(2958),
    [anon_sym_yield_BANG] = ACTIONS(2960),
    [anon_sym_lazy] = ACTIONS(2958),
    [anon_sym_assert] = ACTIONS(2958),
    [anon_sym_upcast] = ACTIONS(2958),
    [anon_sym_downcast] = ACTIONS(2958),
    [anon_sym_for] = ACTIONS(2958),
    [anon_sym_while] = ACTIONS(2958),
    [anon_sym_if] = ACTIONS(2958),
    [anon_sym_fun] = ACTIONS(2958),
    [anon_sym_try] = ACTIONS(2958),
    [anon_sym_match] = ACTIONS(2958),
    [anon_sym_match_BANG] = ACTIONS(2960),
    [anon_sym_function] = ACTIONS(2958),
    [anon_sym_GT] = ACTIONS(2960),
    [anon_sym_use] = ACTIONS(2958),
    [anon_sym_use_BANG] = ACTIONS(2960),
    [anon_sym_do_BANG] = ACTIONS(2960),
    [anon_sym_begin] = ACTIONS(2958),
    [aux_sym_char_token1] = ACTIONS(2960),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2958),
    [anon_sym_DQUOTE] = ACTIONS(2958),
    [anon_sym_AT_DQUOTE] = ACTIONS(2960),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2960),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2960),
    [sym_bool] = ACTIONS(2958),
    [sym_unit] = ACTIONS(2960),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2958),
    [sym_op_identifier] = ACTIONS(2960),
    [anon_sym_PLUS] = ACTIONS(2958),
    [anon_sym_DASH] = ACTIONS(2958),
    [anon_sym_PLUS_DOT] = ACTIONS(2960),
    [anon_sym_DASH_DOT] = ACTIONS(2960),
    [anon_sym_PERCENT] = ACTIONS(2960),
    [anon_sym_AMP_AMP] = ACTIONS(2960),
    [anon_sym_TILDE] = ACTIONS(2960),
    [aux_sym_prefix_op_token1] = ACTIONS(2960),
    [sym_int] = ACTIONS(2958),
    [sym_xint] = ACTIONS(2960),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2960),
  },
  [2798] = {
    [sym_block_comment] = STATE(2798),
    [sym_compiler_directive_decl] = STATE(2798),
    [sym_fsi_directive_decl] = STATE(2798),
    [sym_preproc_line] = STATE(2798),
    [sym_identifier] = ACTIONS(3023),
    [anon_sym_return] = ACTIONS(3023),
    [anon_sym_do] = ACTIONS(3023),
    [anon_sym_let] = ACTIONS(3023),
    [anon_sym_let_BANG] = ACTIONS(3025),
    [anon_sym_LPAREN] = ACTIONS(3023),
    [anon_sym_COMMA] = ACTIONS(3025),
    [anon_sym_null] = ACTIONS(3023),
    [anon_sym_AMP] = ACTIONS(3023),
    [anon_sym_LBRACK] = ACTIONS(3023),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3025),
    [anon_sym_LBRACE] = ACTIONS(3023),
    [anon_sym_LT_AT] = ACTIONS(3023),
    [anon_sym_LT_AT_AT] = ACTIONS(3025),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3025),
    [anon_sym_new] = ACTIONS(3023),
    [anon_sym_return_BANG] = ACTIONS(3025),
    [anon_sym_yield] = ACTIONS(3023),
    [anon_sym_yield_BANG] = ACTIONS(3025),
    [anon_sym_lazy] = ACTIONS(3023),
    [anon_sym_assert] = ACTIONS(3023),
    [anon_sym_upcast] = ACTIONS(3023),
    [anon_sym_downcast] = ACTIONS(3023),
    [anon_sym_for] = ACTIONS(3023),
    [anon_sym_while] = ACTIONS(3023),
    [anon_sym_if] = ACTIONS(3023),
    [anon_sym_fun] = ACTIONS(3023),
    [anon_sym_try] = ACTIONS(3023),
    [anon_sym_match] = ACTIONS(3023),
    [anon_sym_match_BANG] = ACTIONS(3025),
    [anon_sym_function] = ACTIONS(3023),
    [anon_sym_GT] = ACTIONS(3025),
    [anon_sym_use] = ACTIONS(3023),
    [anon_sym_use_BANG] = ACTIONS(3025),
    [anon_sym_do_BANG] = ACTIONS(3025),
    [anon_sym_begin] = ACTIONS(3023),
    [aux_sym_char_token1] = ACTIONS(3025),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3023),
    [anon_sym_DQUOTE] = ACTIONS(3023),
    [anon_sym_AT_DQUOTE] = ACTIONS(3025),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3025),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3025),
    [sym_bool] = ACTIONS(3023),
    [sym_unit] = ACTIONS(3025),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3023),
    [sym_op_identifier] = ACTIONS(3025),
    [anon_sym_PLUS] = ACTIONS(3023),
    [anon_sym_DASH] = ACTIONS(3023),
    [anon_sym_PLUS_DOT] = ACTIONS(3025),
    [anon_sym_DASH_DOT] = ACTIONS(3025),
    [anon_sym_PERCENT] = ACTIONS(3025),
    [anon_sym_AMP_AMP] = ACTIONS(3025),
    [anon_sym_TILDE] = ACTIONS(3025),
    [aux_sym_prefix_op_token1] = ACTIONS(3025),
    [sym_int] = ACTIONS(3023),
    [sym_xint] = ACTIONS(3025),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3025),
  },
  [2799] = {
    [sym_block_comment] = STATE(2799),
    [sym_compiler_directive_decl] = STATE(2799),
    [sym_fsi_directive_decl] = STATE(2799),
    [sym_preproc_line] = STATE(2799),
    [sym_identifier] = ACTIONS(3019),
    [anon_sym_return] = ACTIONS(3019),
    [anon_sym_do] = ACTIONS(3019),
    [anon_sym_let] = ACTIONS(3019),
    [anon_sym_let_BANG] = ACTIONS(3021),
    [anon_sym_LPAREN] = ACTIONS(3019),
    [anon_sym_COMMA] = ACTIONS(3021),
    [anon_sym_null] = ACTIONS(3019),
    [anon_sym_AMP] = ACTIONS(3019),
    [anon_sym_LBRACK] = ACTIONS(3019),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3021),
    [anon_sym_LBRACE] = ACTIONS(3019),
    [anon_sym_LT_AT] = ACTIONS(3019),
    [anon_sym_LT_AT_AT] = ACTIONS(3021),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3021),
    [anon_sym_new] = ACTIONS(3019),
    [anon_sym_return_BANG] = ACTIONS(3021),
    [anon_sym_yield] = ACTIONS(3019),
    [anon_sym_yield_BANG] = ACTIONS(3021),
    [anon_sym_lazy] = ACTIONS(3019),
    [anon_sym_assert] = ACTIONS(3019),
    [anon_sym_upcast] = ACTIONS(3019),
    [anon_sym_downcast] = ACTIONS(3019),
    [anon_sym_for] = ACTIONS(3019),
    [anon_sym_while] = ACTIONS(3019),
    [anon_sym_if] = ACTIONS(3019),
    [anon_sym_fun] = ACTIONS(3019),
    [anon_sym_try] = ACTIONS(3019),
    [anon_sym_match] = ACTIONS(3019),
    [anon_sym_match_BANG] = ACTIONS(3021),
    [anon_sym_function] = ACTIONS(3019),
    [anon_sym_GT] = ACTIONS(3021),
    [anon_sym_use] = ACTIONS(3019),
    [anon_sym_use_BANG] = ACTIONS(3021),
    [anon_sym_do_BANG] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3019),
    [aux_sym_char_token1] = ACTIONS(3021),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3019),
    [anon_sym_DQUOTE] = ACTIONS(3019),
    [anon_sym_AT_DQUOTE] = ACTIONS(3021),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3021),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3021),
    [sym_bool] = ACTIONS(3019),
    [sym_unit] = ACTIONS(3021),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3019),
    [sym_op_identifier] = ACTIONS(3021),
    [anon_sym_PLUS] = ACTIONS(3019),
    [anon_sym_DASH] = ACTIONS(3019),
    [anon_sym_PLUS_DOT] = ACTIONS(3021),
    [anon_sym_DASH_DOT] = ACTIONS(3021),
    [anon_sym_PERCENT] = ACTIONS(3021),
    [anon_sym_AMP_AMP] = ACTIONS(3021),
    [anon_sym_TILDE] = ACTIONS(3021),
    [aux_sym_prefix_op_token1] = ACTIONS(3021),
    [sym_int] = ACTIONS(3019),
    [sym_xint] = ACTIONS(3021),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3021),
  },
  [2800] = {
    [sym_block_comment] = STATE(2800),
    [sym_compiler_directive_decl] = STATE(2800),
    [sym_fsi_directive_decl] = STATE(2800),
    [sym_preproc_line] = STATE(2800),
    [sym_identifier] = ACTIONS(2918),
    [anon_sym_return] = ACTIONS(2918),
    [anon_sym_do] = ACTIONS(2918),
    [anon_sym_let] = ACTIONS(2918),
    [anon_sym_let_BANG] = ACTIONS(2920),
    [anon_sym_LPAREN] = ACTIONS(2918),
    [anon_sym_COMMA] = ACTIONS(2920),
    [anon_sym_null] = ACTIONS(2918),
    [anon_sym_AMP] = ACTIONS(2918),
    [anon_sym_LBRACK] = ACTIONS(2918),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2920),
    [anon_sym_LBRACE] = ACTIONS(2918),
    [anon_sym_LT_AT] = ACTIONS(2918),
    [anon_sym_LT_AT_AT] = ACTIONS(2920),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2920),
    [anon_sym_new] = ACTIONS(2918),
    [anon_sym_return_BANG] = ACTIONS(2920),
    [anon_sym_yield] = ACTIONS(2918),
    [anon_sym_yield_BANG] = ACTIONS(2920),
    [anon_sym_lazy] = ACTIONS(2918),
    [anon_sym_assert] = ACTIONS(2918),
    [anon_sym_upcast] = ACTIONS(2918),
    [anon_sym_downcast] = ACTIONS(2918),
    [anon_sym_for] = ACTIONS(2918),
    [anon_sym_while] = ACTIONS(2918),
    [anon_sym_if] = ACTIONS(2918),
    [anon_sym_fun] = ACTIONS(2918),
    [anon_sym_try] = ACTIONS(2918),
    [anon_sym_match] = ACTIONS(2918),
    [anon_sym_match_BANG] = ACTIONS(2920),
    [anon_sym_function] = ACTIONS(2918),
    [anon_sym_GT] = ACTIONS(2920),
    [anon_sym_use] = ACTIONS(2918),
    [anon_sym_use_BANG] = ACTIONS(2920),
    [anon_sym_do_BANG] = ACTIONS(2920),
    [anon_sym_begin] = ACTIONS(2918),
    [aux_sym_char_token1] = ACTIONS(2920),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2918),
    [anon_sym_DQUOTE] = ACTIONS(2918),
    [anon_sym_AT_DQUOTE] = ACTIONS(2920),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2920),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2920),
    [sym_bool] = ACTIONS(2918),
    [sym_unit] = ACTIONS(2920),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2918),
    [sym_op_identifier] = ACTIONS(2920),
    [anon_sym_PLUS] = ACTIONS(2918),
    [anon_sym_DASH] = ACTIONS(2918),
    [anon_sym_PLUS_DOT] = ACTIONS(2920),
    [anon_sym_DASH_DOT] = ACTIONS(2920),
    [anon_sym_PERCENT] = ACTIONS(2920),
    [anon_sym_AMP_AMP] = ACTIONS(2920),
    [anon_sym_TILDE] = ACTIONS(2920),
    [aux_sym_prefix_op_token1] = ACTIONS(2920),
    [sym_int] = ACTIONS(2918),
    [sym_xint] = ACTIONS(2920),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2920),
  },
  [2801] = {
    [sym_block_comment] = STATE(2801),
    [sym_compiler_directive_decl] = STATE(2801),
    [sym_fsi_directive_decl] = STATE(2801),
    [sym_preproc_line] = STATE(2801),
    [sym_identifier] = ACTIONS(2843),
    [anon_sym_return] = ACTIONS(2843),
    [anon_sym_do] = ACTIONS(2843),
    [anon_sym_let] = ACTIONS(2843),
    [anon_sym_let_BANG] = ACTIONS(2845),
    [anon_sym_LPAREN] = ACTIONS(2843),
    [anon_sym_COMMA] = ACTIONS(2845),
    [anon_sym_null] = ACTIONS(2843),
    [anon_sym_AMP] = ACTIONS(2843),
    [anon_sym_LBRACK] = ACTIONS(2843),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2845),
    [anon_sym_LBRACE] = ACTIONS(2843),
    [anon_sym_LT_AT] = ACTIONS(2843),
    [anon_sym_LT_AT_AT] = ACTIONS(2845),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2845),
    [anon_sym_new] = ACTIONS(2843),
    [anon_sym_return_BANG] = ACTIONS(2845),
    [anon_sym_yield] = ACTIONS(2843),
    [anon_sym_yield_BANG] = ACTIONS(2845),
    [anon_sym_lazy] = ACTIONS(2843),
    [anon_sym_assert] = ACTIONS(2843),
    [anon_sym_upcast] = ACTIONS(2843),
    [anon_sym_downcast] = ACTIONS(2843),
    [anon_sym_for] = ACTIONS(2843),
    [anon_sym_while] = ACTIONS(2843),
    [anon_sym_if] = ACTIONS(2843),
    [anon_sym_fun] = ACTIONS(2843),
    [anon_sym_try] = ACTIONS(2843),
    [anon_sym_match] = ACTIONS(2843),
    [anon_sym_match_BANG] = ACTIONS(2845),
    [anon_sym_function] = ACTIONS(2843),
    [anon_sym_GT] = ACTIONS(2845),
    [anon_sym_use] = ACTIONS(2843),
    [anon_sym_use_BANG] = ACTIONS(2845),
    [anon_sym_do_BANG] = ACTIONS(2845),
    [anon_sym_begin] = ACTIONS(2843),
    [aux_sym_char_token1] = ACTIONS(2845),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2843),
    [anon_sym_DQUOTE] = ACTIONS(2843),
    [anon_sym_AT_DQUOTE] = ACTIONS(2845),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2845),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2845),
    [sym_bool] = ACTIONS(2843),
    [sym_unit] = ACTIONS(2845),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2843),
    [sym_op_identifier] = ACTIONS(2845),
    [anon_sym_PLUS] = ACTIONS(2843),
    [anon_sym_DASH] = ACTIONS(2843),
    [anon_sym_PLUS_DOT] = ACTIONS(2845),
    [anon_sym_DASH_DOT] = ACTIONS(2845),
    [anon_sym_PERCENT] = ACTIONS(2845),
    [anon_sym_AMP_AMP] = ACTIONS(2845),
    [anon_sym_TILDE] = ACTIONS(2845),
    [aux_sym_prefix_op_token1] = ACTIONS(2845),
    [sym_int] = ACTIONS(2843),
    [sym_xint] = ACTIONS(2845),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2845),
  },
  [2802] = {
    [sym_block_comment] = STATE(2802),
    [sym_compiler_directive_decl] = STATE(2802),
    [sym_fsi_directive_decl] = STATE(2802),
    [sym_preproc_line] = STATE(2802),
    [sym_identifier] = ACTIONS(2984),
    [anon_sym_return] = ACTIONS(2984),
    [anon_sym_do] = ACTIONS(2984),
    [anon_sym_let] = ACTIONS(2984),
    [anon_sym_let_BANG] = ACTIONS(2986),
    [anon_sym_LPAREN] = ACTIONS(2984),
    [anon_sym_COMMA] = ACTIONS(2986),
    [anon_sym_null] = ACTIONS(2984),
    [anon_sym_AMP] = ACTIONS(2984),
    [anon_sym_LBRACK] = ACTIONS(2984),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2986),
    [anon_sym_LBRACE] = ACTIONS(2984),
    [anon_sym_LT_AT] = ACTIONS(2984),
    [anon_sym_LT_AT_AT] = ACTIONS(2986),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2986),
    [anon_sym_new] = ACTIONS(2984),
    [anon_sym_return_BANG] = ACTIONS(2986),
    [anon_sym_yield] = ACTIONS(2984),
    [anon_sym_yield_BANG] = ACTIONS(2986),
    [anon_sym_lazy] = ACTIONS(2984),
    [anon_sym_assert] = ACTIONS(2984),
    [anon_sym_upcast] = ACTIONS(2984),
    [anon_sym_downcast] = ACTIONS(2984),
    [anon_sym_for] = ACTIONS(2984),
    [anon_sym_while] = ACTIONS(2984),
    [anon_sym_if] = ACTIONS(2984),
    [anon_sym_fun] = ACTIONS(2984),
    [anon_sym_try] = ACTIONS(2984),
    [anon_sym_match] = ACTIONS(2984),
    [anon_sym_match_BANG] = ACTIONS(2986),
    [anon_sym_function] = ACTIONS(2984),
    [anon_sym_GT] = ACTIONS(2986),
    [anon_sym_use] = ACTIONS(2984),
    [anon_sym_use_BANG] = ACTIONS(2986),
    [anon_sym_do_BANG] = ACTIONS(2986),
    [anon_sym_begin] = ACTIONS(2984),
    [aux_sym_char_token1] = ACTIONS(2986),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2984),
    [anon_sym_DQUOTE] = ACTIONS(2984),
    [anon_sym_AT_DQUOTE] = ACTIONS(2986),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2986),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2986),
    [sym_bool] = ACTIONS(2984),
    [sym_unit] = ACTIONS(2986),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2984),
    [sym_op_identifier] = ACTIONS(2986),
    [anon_sym_PLUS] = ACTIONS(2984),
    [anon_sym_DASH] = ACTIONS(2984),
    [anon_sym_PLUS_DOT] = ACTIONS(2986),
    [anon_sym_DASH_DOT] = ACTIONS(2986),
    [anon_sym_PERCENT] = ACTIONS(2986),
    [anon_sym_AMP_AMP] = ACTIONS(2986),
    [anon_sym_TILDE] = ACTIONS(2986),
    [aux_sym_prefix_op_token1] = ACTIONS(2986),
    [sym_int] = ACTIONS(2984),
    [sym_xint] = ACTIONS(2986),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2986),
  },
  [2803] = {
    [sym_block_comment] = STATE(2803),
    [sym_compiler_directive_decl] = STATE(2803),
    [sym_fsi_directive_decl] = STATE(2803),
    [sym_preproc_line] = STATE(2803),
    [sym_identifier] = ACTIONS(2158),
    [anon_sym_return] = ACTIONS(2158),
    [anon_sym_do] = ACTIONS(2158),
    [anon_sym_let] = ACTIONS(2158),
    [anon_sym_let_BANG] = ACTIONS(2160),
    [anon_sym_LPAREN] = ACTIONS(2158),
    [anon_sym_COMMA] = ACTIONS(2160),
    [anon_sym_null] = ACTIONS(2158),
    [anon_sym_AMP] = ACTIONS(2158),
    [anon_sym_LBRACK] = ACTIONS(2158),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2160),
    [anon_sym_LBRACE] = ACTIONS(2158),
    [anon_sym_LT_AT] = ACTIONS(2158),
    [anon_sym_LT_AT_AT] = ACTIONS(2160),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2160),
    [anon_sym_new] = ACTIONS(2158),
    [anon_sym_return_BANG] = ACTIONS(2160),
    [anon_sym_yield] = ACTIONS(2158),
    [anon_sym_yield_BANG] = ACTIONS(2160),
    [anon_sym_lazy] = ACTIONS(2158),
    [anon_sym_assert] = ACTIONS(2158),
    [anon_sym_upcast] = ACTIONS(2158),
    [anon_sym_downcast] = ACTIONS(2158),
    [anon_sym_for] = ACTIONS(2158),
    [anon_sym_while] = ACTIONS(2158),
    [anon_sym_if] = ACTIONS(2158),
    [anon_sym_fun] = ACTIONS(2158),
    [anon_sym_try] = ACTIONS(2158),
    [anon_sym_match] = ACTIONS(2158),
    [anon_sym_match_BANG] = ACTIONS(2160),
    [anon_sym_function] = ACTIONS(2158),
    [anon_sym_GT] = ACTIONS(2160),
    [anon_sym_use] = ACTIONS(2158),
    [anon_sym_use_BANG] = ACTIONS(2160),
    [anon_sym_do_BANG] = ACTIONS(2160),
    [anon_sym_begin] = ACTIONS(2158),
    [aux_sym_char_token1] = ACTIONS(2160),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2158),
    [anon_sym_DQUOTE] = ACTIONS(2158),
    [anon_sym_AT_DQUOTE] = ACTIONS(2160),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2160),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2160),
    [sym_bool] = ACTIONS(2158),
    [sym_unit] = ACTIONS(2160),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2158),
    [sym_op_identifier] = ACTIONS(2160),
    [anon_sym_PLUS] = ACTIONS(2158),
    [anon_sym_DASH] = ACTIONS(2158),
    [anon_sym_PLUS_DOT] = ACTIONS(2160),
    [anon_sym_DASH_DOT] = ACTIONS(2160),
    [anon_sym_PERCENT] = ACTIONS(2160),
    [anon_sym_AMP_AMP] = ACTIONS(2160),
    [anon_sym_TILDE] = ACTIONS(2160),
    [aux_sym_prefix_op_token1] = ACTIONS(2160),
    [sym_int] = ACTIONS(2158),
    [sym_xint] = ACTIONS(2160),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2160),
  },
  [2804] = {
    [sym_block_comment] = STATE(2804),
    [sym_compiler_directive_decl] = STATE(2804),
    [sym_fsi_directive_decl] = STATE(2804),
    [sym_preproc_line] = STATE(2804),
    [sym_identifier] = ACTIONS(3027),
    [anon_sym_return] = ACTIONS(3027),
    [anon_sym_do] = ACTIONS(3027),
    [anon_sym_let] = ACTIONS(3027),
    [anon_sym_let_BANG] = ACTIONS(3029),
    [anon_sym_LPAREN] = ACTIONS(3027),
    [anon_sym_COMMA] = ACTIONS(3029),
    [anon_sym_null] = ACTIONS(3027),
    [anon_sym_AMP] = ACTIONS(3027),
    [anon_sym_LBRACK] = ACTIONS(3027),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3027),
    [anon_sym_LT_AT] = ACTIONS(3027),
    [anon_sym_LT_AT_AT] = ACTIONS(3029),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3029),
    [anon_sym_new] = ACTIONS(3027),
    [anon_sym_return_BANG] = ACTIONS(3029),
    [anon_sym_yield] = ACTIONS(3027),
    [anon_sym_yield_BANG] = ACTIONS(3029),
    [anon_sym_lazy] = ACTIONS(3027),
    [anon_sym_assert] = ACTIONS(3027),
    [anon_sym_upcast] = ACTIONS(3027),
    [anon_sym_downcast] = ACTIONS(3027),
    [anon_sym_for] = ACTIONS(3027),
    [anon_sym_while] = ACTIONS(3027),
    [anon_sym_if] = ACTIONS(3027),
    [anon_sym_fun] = ACTIONS(3027),
    [anon_sym_try] = ACTIONS(3027),
    [anon_sym_match] = ACTIONS(3027),
    [anon_sym_match_BANG] = ACTIONS(3029),
    [anon_sym_function] = ACTIONS(3027),
    [anon_sym_GT] = ACTIONS(3029),
    [anon_sym_use] = ACTIONS(3027),
    [anon_sym_use_BANG] = ACTIONS(3029),
    [anon_sym_do_BANG] = ACTIONS(3029),
    [anon_sym_begin] = ACTIONS(3027),
    [aux_sym_char_token1] = ACTIONS(3029),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3027),
    [anon_sym_DQUOTE] = ACTIONS(3027),
    [anon_sym_AT_DQUOTE] = ACTIONS(3029),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3029),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3029),
    [sym_bool] = ACTIONS(3027),
    [sym_unit] = ACTIONS(3029),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3027),
    [sym_op_identifier] = ACTIONS(3029),
    [anon_sym_PLUS] = ACTIONS(3027),
    [anon_sym_DASH] = ACTIONS(3027),
    [anon_sym_PLUS_DOT] = ACTIONS(3029),
    [anon_sym_DASH_DOT] = ACTIONS(3029),
    [anon_sym_PERCENT] = ACTIONS(3029),
    [anon_sym_AMP_AMP] = ACTIONS(3029),
    [anon_sym_TILDE] = ACTIONS(3029),
    [aux_sym_prefix_op_token1] = ACTIONS(3029),
    [sym_int] = ACTIONS(3027),
    [sym_xint] = ACTIONS(3029),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3029),
  },
  [2805] = {
    [sym_block_comment] = STATE(2805),
    [sym_compiler_directive_decl] = STATE(2805),
    [sym_fsi_directive_decl] = STATE(2805),
    [sym_preproc_line] = STATE(2805),
    [sym_identifier] = ACTIONS(2855),
    [anon_sym_return] = ACTIONS(2855),
    [anon_sym_do] = ACTIONS(2855),
    [anon_sym_let] = ACTIONS(2855),
    [anon_sym_let_BANG] = ACTIONS(2857),
    [anon_sym_LPAREN] = ACTIONS(2855),
    [anon_sym_COMMA] = ACTIONS(2857),
    [anon_sym_null] = ACTIONS(2855),
    [anon_sym_AMP] = ACTIONS(2855),
    [anon_sym_LBRACK] = ACTIONS(2855),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2857),
    [anon_sym_LBRACE] = ACTIONS(2855),
    [anon_sym_LT_AT] = ACTIONS(2855),
    [anon_sym_LT_AT_AT] = ACTIONS(2857),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2857),
    [anon_sym_new] = ACTIONS(2855),
    [anon_sym_return_BANG] = ACTIONS(2857),
    [anon_sym_yield] = ACTIONS(2855),
    [anon_sym_yield_BANG] = ACTIONS(2857),
    [anon_sym_lazy] = ACTIONS(2855),
    [anon_sym_assert] = ACTIONS(2855),
    [anon_sym_upcast] = ACTIONS(2855),
    [anon_sym_downcast] = ACTIONS(2855),
    [anon_sym_for] = ACTIONS(2855),
    [anon_sym_while] = ACTIONS(2855),
    [anon_sym_if] = ACTIONS(2855),
    [anon_sym_fun] = ACTIONS(2855),
    [anon_sym_try] = ACTIONS(2855),
    [anon_sym_match] = ACTIONS(2855),
    [anon_sym_match_BANG] = ACTIONS(2857),
    [anon_sym_function] = ACTIONS(2855),
    [anon_sym_GT] = ACTIONS(2857),
    [anon_sym_use] = ACTIONS(2855),
    [anon_sym_use_BANG] = ACTIONS(2857),
    [anon_sym_do_BANG] = ACTIONS(2857),
    [anon_sym_begin] = ACTIONS(2855),
    [aux_sym_char_token1] = ACTIONS(2857),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2855),
    [anon_sym_DQUOTE] = ACTIONS(2855),
    [anon_sym_AT_DQUOTE] = ACTIONS(2857),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2857),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2857),
    [sym_bool] = ACTIONS(2855),
    [sym_unit] = ACTIONS(2857),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2855),
    [sym_op_identifier] = ACTIONS(2857),
    [anon_sym_PLUS] = ACTIONS(2855),
    [anon_sym_DASH] = ACTIONS(2855),
    [anon_sym_PLUS_DOT] = ACTIONS(2857),
    [anon_sym_DASH_DOT] = ACTIONS(2857),
    [anon_sym_PERCENT] = ACTIONS(2857),
    [anon_sym_AMP_AMP] = ACTIONS(2857),
    [anon_sym_TILDE] = ACTIONS(2857),
    [aux_sym_prefix_op_token1] = ACTIONS(2857),
    [sym_int] = ACTIONS(2855),
    [sym_xint] = ACTIONS(2857),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2857),
  },
  [2806] = {
    [sym_block_comment] = STATE(2806),
    [sym_compiler_directive_decl] = STATE(2806),
    [sym_fsi_directive_decl] = STATE(2806),
    [sym_preproc_line] = STATE(2806),
    [sym_identifier] = ACTIONS(2922),
    [anon_sym_return] = ACTIONS(2922),
    [anon_sym_do] = ACTIONS(2922),
    [anon_sym_let] = ACTIONS(2922),
    [anon_sym_let_BANG] = ACTIONS(2924),
    [anon_sym_LPAREN] = ACTIONS(2922),
    [anon_sym_COMMA] = ACTIONS(2924),
    [anon_sym_null] = ACTIONS(2922),
    [anon_sym_AMP] = ACTIONS(2922),
    [anon_sym_LBRACK] = ACTIONS(2922),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2924),
    [anon_sym_LBRACE] = ACTIONS(2922),
    [anon_sym_LT_AT] = ACTIONS(2922),
    [anon_sym_LT_AT_AT] = ACTIONS(2924),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2924),
    [anon_sym_new] = ACTIONS(2922),
    [anon_sym_return_BANG] = ACTIONS(2924),
    [anon_sym_yield] = ACTIONS(2922),
    [anon_sym_yield_BANG] = ACTIONS(2924),
    [anon_sym_lazy] = ACTIONS(2922),
    [anon_sym_assert] = ACTIONS(2922),
    [anon_sym_upcast] = ACTIONS(2922),
    [anon_sym_downcast] = ACTIONS(2922),
    [anon_sym_for] = ACTIONS(2922),
    [anon_sym_while] = ACTIONS(2922),
    [anon_sym_if] = ACTIONS(2922),
    [anon_sym_fun] = ACTIONS(2922),
    [anon_sym_try] = ACTIONS(2922),
    [anon_sym_match] = ACTIONS(2922),
    [anon_sym_match_BANG] = ACTIONS(2924),
    [anon_sym_function] = ACTIONS(2922),
    [anon_sym_GT] = ACTIONS(2924),
    [anon_sym_use] = ACTIONS(2922),
    [anon_sym_use_BANG] = ACTIONS(2924),
    [anon_sym_do_BANG] = ACTIONS(2924),
    [anon_sym_begin] = ACTIONS(2922),
    [aux_sym_char_token1] = ACTIONS(2924),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2922),
    [anon_sym_DQUOTE] = ACTIONS(2922),
    [anon_sym_AT_DQUOTE] = ACTIONS(2924),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2924),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2924),
    [sym_bool] = ACTIONS(2922),
    [sym_unit] = ACTIONS(2924),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2922),
    [sym_op_identifier] = ACTIONS(2924),
    [anon_sym_PLUS] = ACTIONS(2922),
    [anon_sym_DASH] = ACTIONS(2922),
    [anon_sym_PLUS_DOT] = ACTIONS(2924),
    [anon_sym_DASH_DOT] = ACTIONS(2924),
    [anon_sym_PERCENT] = ACTIONS(2924),
    [anon_sym_AMP_AMP] = ACTIONS(2924),
    [anon_sym_TILDE] = ACTIONS(2924),
    [aux_sym_prefix_op_token1] = ACTIONS(2924),
    [sym_int] = ACTIONS(2922),
    [sym_xint] = ACTIONS(2924),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2924),
  },
  [2807] = {
    [sym_block_comment] = STATE(2807),
    [sym_compiler_directive_decl] = STATE(2807),
    [sym_fsi_directive_decl] = STATE(2807),
    [sym_preproc_line] = STATE(2807),
    [sym_identifier] = ACTIONS(3031),
    [anon_sym_return] = ACTIONS(3031),
    [anon_sym_do] = ACTIONS(3031),
    [anon_sym_let] = ACTIONS(3031),
    [anon_sym_let_BANG] = ACTIONS(3033),
    [anon_sym_LPAREN] = ACTIONS(3031),
    [anon_sym_COMMA] = ACTIONS(3033),
    [anon_sym_null] = ACTIONS(3031),
    [anon_sym_AMP] = ACTIONS(3031),
    [anon_sym_LBRACK] = ACTIONS(3031),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3033),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [anon_sym_LT_AT] = ACTIONS(3031),
    [anon_sym_LT_AT_AT] = ACTIONS(3033),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3033),
    [anon_sym_new] = ACTIONS(3031),
    [anon_sym_return_BANG] = ACTIONS(3033),
    [anon_sym_yield] = ACTIONS(3031),
    [anon_sym_yield_BANG] = ACTIONS(3033),
    [anon_sym_lazy] = ACTIONS(3031),
    [anon_sym_assert] = ACTIONS(3031),
    [anon_sym_upcast] = ACTIONS(3031),
    [anon_sym_downcast] = ACTIONS(3031),
    [anon_sym_for] = ACTIONS(3031),
    [anon_sym_while] = ACTIONS(3031),
    [anon_sym_if] = ACTIONS(3031),
    [anon_sym_fun] = ACTIONS(3031),
    [anon_sym_try] = ACTIONS(3031),
    [anon_sym_match] = ACTIONS(3031),
    [anon_sym_match_BANG] = ACTIONS(3033),
    [anon_sym_function] = ACTIONS(3031),
    [anon_sym_GT] = ACTIONS(3033),
    [anon_sym_use] = ACTIONS(3031),
    [anon_sym_use_BANG] = ACTIONS(3033),
    [anon_sym_do_BANG] = ACTIONS(3033),
    [anon_sym_begin] = ACTIONS(3031),
    [aux_sym_char_token1] = ACTIONS(3033),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3031),
    [anon_sym_DQUOTE] = ACTIONS(3031),
    [anon_sym_AT_DQUOTE] = ACTIONS(3033),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3033),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3033),
    [sym_bool] = ACTIONS(3031),
    [sym_unit] = ACTIONS(3033),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3031),
    [sym_op_identifier] = ACTIONS(3033),
    [anon_sym_PLUS] = ACTIONS(3031),
    [anon_sym_DASH] = ACTIONS(3031),
    [anon_sym_PLUS_DOT] = ACTIONS(3033),
    [anon_sym_DASH_DOT] = ACTIONS(3033),
    [anon_sym_PERCENT] = ACTIONS(3033),
    [anon_sym_AMP_AMP] = ACTIONS(3033),
    [anon_sym_TILDE] = ACTIONS(3033),
    [aux_sym_prefix_op_token1] = ACTIONS(3033),
    [sym_int] = ACTIONS(3031),
    [sym_xint] = ACTIONS(3033),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3033),
  },
  [2808] = {
    [sym_block_comment] = STATE(2808),
    [sym_compiler_directive_decl] = STATE(2808),
    [sym_fsi_directive_decl] = STATE(2808),
    [sym_preproc_line] = STATE(2808),
    [sym_identifier] = ACTIONS(2926),
    [anon_sym_return] = ACTIONS(2926),
    [anon_sym_do] = ACTIONS(2926),
    [anon_sym_let] = ACTIONS(2926),
    [anon_sym_let_BANG] = ACTIONS(2928),
    [anon_sym_LPAREN] = ACTIONS(2926),
    [anon_sym_COMMA] = ACTIONS(2928),
    [anon_sym_null] = ACTIONS(2926),
    [anon_sym_AMP] = ACTIONS(2926),
    [anon_sym_LBRACK] = ACTIONS(2926),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2928),
    [anon_sym_LBRACE] = ACTIONS(2926),
    [anon_sym_LT_AT] = ACTIONS(2926),
    [anon_sym_LT_AT_AT] = ACTIONS(2928),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2928),
    [anon_sym_new] = ACTIONS(2926),
    [anon_sym_return_BANG] = ACTIONS(2928),
    [anon_sym_yield] = ACTIONS(2926),
    [anon_sym_yield_BANG] = ACTIONS(2928),
    [anon_sym_lazy] = ACTIONS(2926),
    [anon_sym_assert] = ACTIONS(2926),
    [anon_sym_upcast] = ACTIONS(2926),
    [anon_sym_downcast] = ACTIONS(2926),
    [anon_sym_for] = ACTIONS(2926),
    [anon_sym_while] = ACTIONS(2926),
    [anon_sym_if] = ACTIONS(2926),
    [anon_sym_fun] = ACTIONS(2926),
    [anon_sym_try] = ACTIONS(2926),
    [anon_sym_match] = ACTIONS(2926),
    [anon_sym_match_BANG] = ACTIONS(2928),
    [anon_sym_function] = ACTIONS(2926),
    [anon_sym_GT] = ACTIONS(2928),
    [anon_sym_use] = ACTIONS(2926),
    [anon_sym_use_BANG] = ACTIONS(2928),
    [anon_sym_do_BANG] = ACTIONS(2928),
    [anon_sym_begin] = ACTIONS(2926),
    [aux_sym_char_token1] = ACTIONS(2928),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2926),
    [anon_sym_DQUOTE] = ACTIONS(2926),
    [anon_sym_AT_DQUOTE] = ACTIONS(2928),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2928),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2928),
    [sym_bool] = ACTIONS(2926),
    [sym_unit] = ACTIONS(2928),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2926),
    [sym_op_identifier] = ACTIONS(2928),
    [anon_sym_PLUS] = ACTIONS(2926),
    [anon_sym_DASH] = ACTIONS(2926),
    [anon_sym_PLUS_DOT] = ACTIONS(2928),
    [anon_sym_DASH_DOT] = ACTIONS(2928),
    [anon_sym_PERCENT] = ACTIONS(2928),
    [anon_sym_AMP_AMP] = ACTIONS(2928),
    [anon_sym_TILDE] = ACTIONS(2928),
    [aux_sym_prefix_op_token1] = ACTIONS(2928),
    [sym_int] = ACTIONS(2926),
    [sym_xint] = ACTIONS(2928),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2928),
  },
  [2809] = {
    [sym_block_comment] = STATE(2809),
    [sym_compiler_directive_decl] = STATE(2809),
    [sym_fsi_directive_decl] = STATE(2809),
    [sym_preproc_line] = STATE(2809),
    [sym_identifier] = ACTIONS(2859),
    [anon_sym_return] = ACTIONS(2859),
    [anon_sym_do] = ACTIONS(2859),
    [anon_sym_let] = ACTIONS(2859),
    [anon_sym_let_BANG] = ACTIONS(2861),
    [anon_sym_LPAREN] = ACTIONS(2859),
    [anon_sym_COMMA] = ACTIONS(2861),
    [anon_sym_null] = ACTIONS(2859),
    [anon_sym_AMP] = ACTIONS(2859),
    [anon_sym_LBRACK] = ACTIONS(2859),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2861),
    [anon_sym_LBRACE] = ACTIONS(2859),
    [anon_sym_LT_AT] = ACTIONS(2859),
    [anon_sym_LT_AT_AT] = ACTIONS(2861),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2861),
    [anon_sym_new] = ACTIONS(2859),
    [anon_sym_return_BANG] = ACTIONS(2861),
    [anon_sym_yield] = ACTIONS(2859),
    [anon_sym_yield_BANG] = ACTIONS(2861),
    [anon_sym_lazy] = ACTIONS(2859),
    [anon_sym_assert] = ACTIONS(2859),
    [anon_sym_upcast] = ACTIONS(2859),
    [anon_sym_downcast] = ACTIONS(2859),
    [anon_sym_for] = ACTIONS(2859),
    [anon_sym_while] = ACTIONS(2859),
    [anon_sym_if] = ACTIONS(2859),
    [anon_sym_fun] = ACTIONS(2859),
    [anon_sym_try] = ACTIONS(2859),
    [anon_sym_match] = ACTIONS(2859),
    [anon_sym_match_BANG] = ACTIONS(2861),
    [anon_sym_function] = ACTIONS(2859),
    [anon_sym_GT] = ACTIONS(2861),
    [anon_sym_use] = ACTIONS(2859),
    [anon_sym_use_BANG] = ACTIONS(2861),
    [anon_sym_do_BANG] = ACTIONS(2861),
    [anon_sym_begin] = ACTIONS(2859),
    [aux_sym_char_token1] = ACTIONS(2861),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2859),
    [anon_sym_DQUOTE] = ACTIONS(2859),
    [anon_sym_AT_DQUOTE] = ACTIONS(2861),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2861),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2861),
    [sym_bool] = ACTIONS(2859),
    [sym_unit] = ACTIONS(2861),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2859),
    [sym_op_identifier] = ACTIONS(2861),
    [anon_sym_PLUS] = ACTIONS(2859),
    [anon_sym_DASH] = ACTIONS(2859),
    [anon_sym_PLUS_DOT] = ACTIONS(2861),
    [anon_sym_DASH_DOT] = ACTIONS(2861),
    [anon_sym_PERCENT] = ACTIONS(2861),
    [anon_sym_AMP_AMP] = ACTIONS(2861),
    [anon_sym_TILDE] = ACTIONS(2861),
    [aux_sym_prefix_op_token1] = ACTIONS(2861),
    [sym_int] = ACTIONS(2859),
    [sym_xint] = ACTIONS(2861),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2861),
  },
  [2810] = {
    [sym_block_comment] = STATE(2810),
    [sym_compiler_directive_decl] = STATE(2810),
    [sym_fsi_directive_decl] = STATE(2810),
    [sym_preproc_line] = STATE(2810),
    [sym_identifier] = ACTIONS(2938),
    [anon_sym_return] = ACTIONS(2938),
    [anon_sym_do] = ACTIONS(2938),
    [anon_sym_let] = ACTIONS(2938),
    [anon_sym_let_BANG] = ACTIONS(2940),
    [anon_sym_LPAREN] = ACTIONS(2938),
    [anon_sym_COMMA] = ACTIONS(2940),
    [anon_sym_null] = ACTIONS(2938),
    [anon_sym_AMP] = ACTIONS(2938),
    [anon_sym_LBRACK] = ACTIONS(2938),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2940),
    [anon_sym_LBRACE] = ACTIONS(2938),
    [anon_sym_LT_AT] = ACTIONS(2938),
    [anon_sym_LT_AT_AT] = ACTIONS(2940),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2940),
    [anon_sym_new] = ACTIONS(2938),
    [anon_sym_return_BANG] = ACTIONS(2940),
    [anon_sym_yield] = ACTIONS(2938),
    [anon_sym_yield_BANG] = ACTIONS(2940),
    [anon_sym_lazy] = ACTIONS(2938),
    [anon_sym_assert] = ACTIONS(2938),
    [anon_sym_upcast] = ACTIONS(2938),
    [anon_sym_downcast] = ACTIONS(2938),
    [anon_sym_for] = ACTIONS(2938),
    [anon_sym_while] = ACTIONS(2938),
    [anon_sym_if] = ACTIONS(2938),
    [anon_sym_fun] = ACTIONS(2938),
    [anon_sym_try] = ACTIONS(2938),
    [anon_sym_match] = ACTIONS(2938),
    [anon_sym_match_BANG] = ACTIONS(2940),
    [anon_sym_function] = ACTIONS(2938),
    [anon_sym_GT] = ACTIONS(2940),
    [anon_sym_use] = ACTIONS(2938),
    [anon_sym_use_BANG] = ACTIONS(2940),
    [anon_sym_do_BANG] = ACTIONS(2940),
    [anon_sym_begin] = ACTIONS(2938),
    [aux_sym_char_token1] = ACTIONS(2940),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2938),
    [anon_sym_DQUOTE] = ACTIONS(2938),
    [anon_sym_AT_DQUOTE] = ACTIONS(2940),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2940),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2940),
    [sym_bool] = ACTIONS(2938),
    [sym_unit] = ACTIONS(2940),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2938),
    [sym_op_identifier] = ACTIONS(2940),
    [anon_sym_PLUS] = ACTIONS(2938),
    [anon_sym_DASH] = ACTIONS(2938),
    [anon_sym_PLUS_DOT] = ACTIONS(2940),
    [anon_sym_DASH_DOT] = ACTIONS(2940),
    [anon_sym_PERCENT] = ACTIONS(2940),
    [anon_sym_AMP_AMP] = ACTIONS(2940),
    [anon_sym_TILDE] = ACTIONS(2940),
    [aux_sym_prefix_op_token1] = ACTIONS(2940),
    [sym_int] = ACTIONS(2938),
    [sym_xint] = ACTIONS(2940),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2940),
  },
  [2811] = {
    [sym_block_comment] = STATE(2811),
    [sym_compiler_directive_decl] = STATE(2811),
    [sym_fsi_directive_decl] = STATE(2811),
    [sym_preproc_line] = STATE(2811),
    [sym_identifier] = ACTIONS(2946),
    [anon_sym_return] = ACTIONS(2946),
    [anon_sym_do] = ACTIONS(2946),
    [anon_sym_let] = ACTIONS(2946),
    [anon_sym_let_BANG] = ACTIONS(2948),
    [anon_sym_LPAREN] = ACTIONS(2946),
    [anon_sym_COMMA] = ACTIONS(2948),
    [anon_sym_null] = ACTIONS(2946),
    [anon_sym_AMP] = ACTIONS(2946),
    [anon_sym_LBRACK] = ACTIONS(2946),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2948),
    [anon_sym_LBRACE] = ACTIONS(2946),
    [anon_sym_LT_AT] = ACTIONS(2946),
    [anon_sym_LT_AT_AT] = ACTIONS(2948),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2948),
    [anon_sym_new] = ACTIONS(2946),
    [anon_sym_return_BANG] = ACTIONS(2948),
    [anon_sym_yield] = ACTIONS(2946),
    [anon_sym_yield_BANG] = ACTIONS(2948),
    [anon_sym_lazy] = ACTIONS(2946),
    [anon_sym_assert] = ACTIONS(2946),
    [anon_sym_upcast] = ACTIONS(2946),
    [anon_sym_downcast] = ACTIONS(2946),
    [anon_sym_for] = ACTIONS(2946),
    [anon_sym_while] = ACTIONS(2946),
    [anon_sym_if] = ACTIONS(2946),
    [anon_sym_fun] = ACTIONS(2946),
    [anon_sym_try] = ACTIONS(2946),
    [anon_sym_match] = ACTIONS(2946),
    [anon_sym_match_BANG] = ACTIONS(2948),
    [anon_sym_function] = ACTIONS(2946),
    [anon_sym_GT] = ACTIONS(2948),
    [anon_sym_use] = ACTIONS(2946),
    [anon_sym_use_BANG] = ACTIONS(2948),
    [anon_sym_do_BANG] = ACTIONS(2948),
    [anon_sym_begin] = ACTIONS(2946),
    [aux_sym_char_token1] = ACTIONS(2948),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2946),
    [anon_sym_DQUOTE] = ACTIONS(2946),
    [anon_sym_AT_DQUOTE] = ACTIONS(2948),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2948),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2948),
    [sym_bool] = ACTIONS(2946),
    [sym_unit] = ACTIONS(2948),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2946),
    [sym_op_identifier] = ACTIONS(2948),
    [anon_sym_PLUS] = ACTIONS(2946),
    [anon_sym_DASH] = ACTIONS(2946),
    [anon_sym_PLUS_DOT] = ACTIONS(2948),
    [anon_sym_DASH_DOT] = ACTIONS(2948),
    [anon_sym_PERCENT] = ACTIONS(2948),
    [anon_sym_AMP_AMP] = ACTIONS(2948),
    [anon_sym_TILDE] = ACTIONS(2948),
    [aux_sym_prefix_op_token1] = ACTIONS(2948),
    [sym_int] = ACTIONS(2946),
    [sym_xint] = ACTIONS(2948),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2948),
  },
  [2812] = {
    [sym_block_comment] = STATE(2812),
    [sym_compiler_directive_decl] = STATE(2812),
    [sym_fsi_directive_decl] = STATE(2812),
    [sym_preproc_line] = STATE(2812),
    [sym_identifier] = ACTIONS(2910),
    [anon_sym_return] = ACTIONS(2910),
    [anon_sym_do] = ACTIONS(2910),
    [anon_sym_let] = ACTIONS(2910),
    [anon_sym_let_BANG] = ACTIONS(2912),
    [anon_sym_LPAREN] = ACTIONS(2910),
    [anon_sym_COMMA] = ACTIONS(2912),
    [anon_sym_null] = ACTIONS(2910),
    [anon_sym_AMP] = ACTIONS(2910),
    [anon_sym_LBRACK] = ACTIONS(2910),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2912),
    [anon_sym_LBRACE] = ACTIONS(2910),
    [anon_sym_LT_AT] = ACTIONS(2910),
    [anon_sym_LT_AT_AT] = ACTIONS(2912),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2912),
    [anon_sym_new] = ACTIONS(2910),
    [anon_sym_return_BANG] = ACTIONS(2912),
    [anon_sym_yield] = ACTIONS(2910),
    [anon_sym_yield_BANG] = ACTIONS(2912),
    [anon_sym_lazy] = ACTIONS(2910),
    [anon_sym_assert] = ACTIONS(2910),
    [anon_sym_upcast] = ACTIONS(2910),
    [anon_sym_downcast] = ACTIONS(2910),
    [anon_sym_for] = ACTIONS(2910),
    [anon_sym_while] = ACTIONS(2910),
    [anon_sym_if] = ACTIONS(2910),
    [anon_sym_fun] = ACTIONS(2910),
    [anon_sym_try] = ACTIONS(2910),
    [anon_sym_match] = ACTIONS(2910),
    [anon_sym_match_BANG] = ACTIONS(2912),
    [anon_sym_function] = ACTIONS(2910),
    [anon_sym_GT] = ACTIONS(2912),
    [anon_sym_use] = ACTIONS(2910),
    [anon_sym_use_BANG] = ACTIONS(2912),
    [anon_sym_do_BANG] = ACTIONS(2912),
    [anon_sym_begin] = ACTIONS(2910),
    [aux_sym_char_token1] = ACTIONS(2912),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2910),
    [anon_sym_DQUOTE] = ACTIONS(2910),
    [anon_sym_AT_DQUOTE] = ACTIONS(2912),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2912),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2912),
    [sym_bool] = ACTIONS(2910),
    [sym_unit] = ACTIONS(2912),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2910),
    [sym_op_identifier] = ACTIONS(2912),
    [anon_sym_PLUS] = ACTIONS(2910),
    [anon_sym_DASH] = ACTIONS(2910),
    [anon_sym_PLUS_DOT] = ACTIONS(2912),
    [anon_sym_DASH_DOT] = ACTIONS(2912),
    [anon_sym_PERCENT] = ACTIONS(2912),
    [anon_sym_AMP_AMP] = ACTIONS(2912),
    [anon_sym_TILDE] = ACTIONS(2912),
    [aux_sym_prefix_op_token1] = ACTIONS(2912),
    [sym_int] = ACTIONS(2910),
    [sym_xint] = ACTIONS(2912),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2912),
  },
  [2813] = {
    [sym_block_comment] = STATE(2813),
    [sym_compiler_directive_decl] = STATE(2813),
    [sym_fsi_directive_decl] = STATE(2813),
    [sym_preproc_line] = STATE(2813),
    [sym_identifier] = ACTIONS(2950),
    [anon_sym_return] = ACTIONS(2950),
    [anon_sym_do] = ACTIONS(2950),
    [anon_sym_let] = ACTIONS(2950),
    [anon_sym_let_BANG] = ACTIONS(2952),
    [anon_sym_LPAREN] = ACTIONS(2950),
    [anon_sym_COMMA] = ACTIONS(2952),
    [anon_sym_null] = ACTIONS(2950),
    [anon_sym_AMP] = ACTIONS(2950),
    [anon_sym_LBRACK] = ACTIONS(2950),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2952),
    [anon_sym_LBRACE] = ACTIONS(2950),
    [anon_sym_LT_AT] = ACTIONS(2950),
    [anon_sym_LT_AT_AT] = ACTIONS(2952),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2952),
    [anon_sym_new] = ACTIONS(2950),
    [anon_sym_return_BANG] = ACTIONS(2952),
    [anon_sym_yield] = ACTIONS(2950),
    [anon_sym_yield_BANG] = ACTIONS(2952),
    [anon_sym_lazy] = ACTIONS(2950),
    [anon_sym_assert] = ACTIONS(2950),
    [anon_sym_upcast] = ACTIONS(2950),
    [anon_sym_downcast] = ACTIONS(2950),
    [anon_sym_for] = ACTIONS(2950),
    [anon_sym_while] = ACTIONS(2950),
    [anon_sym_if] = ACTIONS(2950),
    [anon_sym_fun] = ACTIONS(2950),
    [anon_sym_try] = ACTIONS(2950),
    [anon_sym_match] = ACTIONS(2950),
    [anon_sym_match_BANG] = ACTIONS(2952),
    [anon_sym_function] = ACTIONS(2950),
    [anon_sym_GT] = ACTIONS(2952),
    [anon_sym_use] = ACTIONS(2950),
    [anon_sym_use_BANG] = ACTIONS(2952),
    [anon_sym_do_BANG] = ACTIONS(2952),
    [anon_sym_begin] = ACTIONS(2950),
    [aux_sym_char_token1] = ACTIONS(2952),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2950),
    [anon_sym_DQUOTE] = ACTIONS(2950),
    [anon_sym_AT_DQUOTE] = ACTIONS(2952),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2952),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2952),
    [sym_bool] = ACTIONS(2950),
    [sym_unit] = ACTIONS(2952),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2950),
    [sym_op_identifier] = ACTIONS(2952),
    [anon_sym_PLUS] = ACTIONS(2950),
    [anon_sym_DASH] = ACTIONS(2950),
    [anon_sym_PLUS_DOT] = ACTIONS(2952),
    [anon_sym_DASH_DOT] = ACTIONS(2952),
    [anon_sym_PERCENT] = ACTIONS(2952),
    [anon_sym_AMP_AMP] = ACTIONS(2952),
    [anon_sym_TILDE] = ACTIONS(2952),
    [aux_sym_prefix_op_token1] = ACTIONS(2952),
    [sym_int] = ACTIONS(2950),
    [sym_xint] = ACTIONS(2952),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2952),
  },
  [2814] = {
    [sym_block_comment] = STATE(2814),
    [sym_compiler_directive_decl] = STATE(2814),
    [sym_fsi_directive_decl] = STATE(2814),
    [sym_preproc_line] = STATE(2814),
    [sym_identifier] = ACTIONS(2891),
    [anon_sym_return] = ACTIONS(2891),
    [anon_sym_do] = ACTIONS(2891),
    [anon_sym_let] = ACTIONS(2891),
    [anon_sym_let_BANG] = ACTIONS(2893),
    [anon_sym_LPAREN] = ACTIONS(2891),
    [anon_sym_COMMA] = ACTIONS(2893),
    [anon_sym_null] = ACTIONS(2891),
    [anon_sym_AMP] = ACTIONS(2891),
    [anon_sym_LBRACK] = ACTIONS(2891),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2893),
    [anon_sym_LBRACE] = ACTIONS(2891),
    [anon_sym_LT_AT] = ACTIONS(2891),
    [anon_sym_LT_AT_AT] = ACTIONS(2893),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2893),
    [anon_sym_new] = ACTIONS(2891),
    [anon_sym_return_BANG] = ACTIONS(2893),
    [anon_sym_yield] = ACTIONS(2891),
    [anon_sym_yield_BANG] = ACTIONS(2893),
    [anon_sym_lazy] = ACTIONS(2891),
    [anon_sym_assert] = ACTIONS(2891),
    [anon_sym_upcast] = ACTIONS(2891),
    [anon_sym_downcast] = ACTIONS(2891),
    [anon_sym_for] = ACTIONS(2891),
    [anon_sym_while] = ACTIONS(2891),
    [anon_sym_if] = ACTIONS(2891),
    [anon_sym_fun] = ACTIONS(2891),
    [anon_sym_try] = ACTIONS(2891),
    [anon_sym_match] = ACTIONS(2891),
    [anon_sym_match_BANG] = ACTIONS(2893),
    [anon_sym_function] = ACTIONS(2891),
    [anon_sym_GT] = ACTIONS(2893),
    [anon_sym_use] = ACTIONS(2891),
    [anon_sym_use_BANG] = ACTIONS(2893),
    [anon_sym_do_BANG] = ACTIONS(2893),
    [anon_sym_begin] = ACTIONS(2891),
    [aux_sym_char_token1] = ACTIONS(2893),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2891),
    [anon_sym_DQUOTE] = ACTIONS(2891),
    [anon_sym_AT_DQUOTE] = ACTIONS(2893),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2893),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2893),
    [sym_bool] = ACTIONS(2891),
    [sym_unit] = ACTIONS(2893),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2891),
    [sym_op_identifier] = ACTIONS(2893),
    [anon_sym_PLUS] = ACTIONS(2891),
    [anon_sym_DASH] = ACTIONS(2891),
    [anon_sym_PLUS_DOT] = ACTIONS(2893),
    [anon_sym_DASH_DOT] = ACTIONS(2893),
    [anon_sym_PERCENT] = ACTIONS(2893),
    [anon_sym_AMP_AMP] = ACTIONS(2893),
    [anon_sym_TILDE] = ACTIONS(2893),
    [aux_sym_prefix_op_token1] = ACTIONS(2893),
    [sym_int] = ACTIONS(2891),
    [sym_xint] = ACTIONS(2893),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2893),
  },
  [2815] = {
    [sym_block_comment] = STATE(2815),
    [sym_compiler_directive_decl] = STATE(2815),
    [sym_fsi_directive_decl] = STATE(2815),
    [sym_preproc_line] = STATE(2815),
    [sym_identifier] = ACTIONS(2877),
    [anon_sym_return] = ACTIONS(2877),
    [anon_sym_do] = ACTIONS(2877),
    [anon_sym_let] = ACTIONS(2877),
    [anon_sym_let_BANG] = ACTIONS(2879),
    [anon_sym_LPAREN] = ACTIONS(2877),
    [anon_sym_COMMA] = ACTIONS(2879),
    [anon_sym_null] = ACTIONS(2877),
    [anon_sym_AMP] = ACTIONS(2877),
    [anon_sym_LBRACK] = ACTIONS(2877),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2879),
    [anon_sym_LBRACE] = ACTIONS(2877),
    [anon_sym_LT_AT] = ACTIONS(2877),
    [anon_sym_LT_AT_AT] = ACTIONS(2879),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2879),
    [anon_sym_new] = ACTIONS(2877),
    [anon_sym_return_BANG] = ACTIONS(2879),
    [anon_sym_yield] = ACTIONS(2877),
    [anon_sym_yield_BANG] = ACTIONS(2879),
    [anon_sym_lazy] = ACTIONS(2877),
    [anon_sym_assert] = ACTIONS(2877),
    [anon_sym_upcast] = ACTIONS(2877),
    [anon_sym_downcast] = ACTIONS(2877),
    [anon_sym_for] = ACTIONS(2877),
    [anon_sym_while] = ACTIONS(2877),
    [anon_sym_if] = ACTIONS(2877),
    [anon_sym_fun] = ACTIONS(2877),
    [anon_sym_try] = ACTIONS(2877),
    [anon_sym_match] = ACTIONS(2877),
    [anon_sym_match_BANG] = ACTIONS(2879),
    [anon_sym_function] = ACTIONS(2877),
    [anon_sym_GT] = ACTIONS(2879),
    [anon_sym_use] = ACTIONS(2877),
    [anon_sym_use_BANG] = ACTIONS(2879),
    [anon_sym_do_BANG] = ACTIONS(2879),
    [anon_sym_begin] = ACTIONS(2877),
    [aux_sym_char_token1] = ACTIONS(2879),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2877),
    [anon_sym_DQUOTE] = ACTIONS(2877),
    [anon_sym_AT_DQUOTE] = ACTIONS(2879),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2879),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2879),
    [sym_bool] = ACTIONS(2877),
    [sym_unit] = ACTIONS(2879),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2877),
    [sym_op_identifier] = ACTIONS(2879),
    [anon_sym_PLUS] = ACTIONS(2877),
    [anon_sym_DASH] = ACTIONS(2877),
    [anon_sym_PLUS_DOT] = ACTIONS(2879),
    [anon_sym_DASH_DOT] = ACTIONS(2879),
    [anon_sym_PERCENT] = ACTIONS(2879),
    [anon_sym_AMP_AMP] = ACTIONS(2879),
    [anon_sym_TILDE] = ACTIONS(2879),
    [aux_sym_prefix_op_token1] = ACTIONS(2879),
    [sym_int] = ACTIONS(2877),
    [sym_xint] = ACTIONS(2879),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2879),
  },
  [2816] = {
    [sym_block_comment] = STATE(2816),
    [sym_compiler_directive_decl] = STATE(2816),
    [sym_fsi_directive_decl] = STATE(2816),
    [sym_preproc_line] = STATE(2816),
    [sym_identifier] = ACTIONS(3035),
    [anon_sym_return] = ACTIONS(3035),
    [anon_sym_do] = ACTIONS(3035),
    [anon_sym_let] = ACTIONS(3035),
    [anon_sym_let_BANG] = ACTIONS(3037),
    [anon_sym_LPAREN] = ACTIONS(3035),
    [anon_sym_COMMA] = ACTIONS(3037),
    [anon_sym_null] = ACTIONS(3035),
    [anon_sym_AMP] = ACTIONS(3035),
    [anon_sym_LBRACK] = ACTIONS(3035),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3037),
    [anon_sym_LBRACE] = ACTIONS(3035),
    [anon_sym_LT_AT] = ACTIONS(3035),
    [anon_sym_LT_AT_AT] = ACTIONS(3037),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3037),
    [anon_sym_new] = ACTIONS(3035),
    [anon_sym_return_BANG] = ACTIONS(3037),
    [anon_sym_yield] = ACTIONS(3035),
    [anon_sym_yield_BANG] = ACTIONS(3037),
    [anon_sym_lazy] = ACTIONS(3035),
    [anon_sym_assert] = ACTIONS(3035),
    [anon_sym_upcast] = ACTIONS(3035),
    [anon_sym_downcast] = ACTIONS(3035),
    [anon_sym_for] = ACTIONS(3035),
    [anon_sym_while] = ACTIONS(3035),
    [anon_sym_if] = ACTIONS(3035),
    [anon_sym_fun] = ACTIONS(3035),
    [anon_sym_try] = ACTIONS(3035),
    [anon_sym_match] = ACTIONS(3035),
    [anon_sym_match_BANG] = ACTIONS(3037),
    [anon_sym_function] = ACTIONS(3035),
    [anon_sym_GT] = ACTIONS(3037),
    [anon_sym_use] = ACTIONS(3035),
    [anon_sym_use_BANG] = ACTIONS(3037),
    [anon_sym_do_BANG] = ACTIONS(3037),
    [anon_sym_begin] = ACTIONS(3035),
    [aux_sym_char_token1] = ACTIONS(3037),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3035),
    [anon_sym_DQUOTE] = ACTIONS(3035),
    [anon_sym_AT_DQUOTE] = ACTIONS(3037),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3037),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3037),
    [sym_bool] = ACTIONS(3035),
    [sym_unit] = ACTIONS(3037),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3035),
    [sym_op_identifier] = ACTIONS(3037),
    [anon_sym_PLUS] = ACTIONS(3035),
    [anon_sym_DASH] = ACTIONS(3035),
    [anon_sym_PLUS_DOT] = ACTIONS(3037),
    [anon_sym_DASH_DOT] = ACTIONS(3037),
    [anon_sym_PERCENT] = ACTIONS(3037),
    [anon_sym_AMP_AMP] = ACTIONS(3037),
    [anon_sym_TILDE] = ACTIONS(3037),
    [aux_sym_prefix_op_token1] = ACTIONS(3037),
    [sym_int] = ACTIONS(3035),
    [sym_xint] = ACTIONS(3037),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3037),
  },
  [2817] = {
    [sym_block_comment] = STATE(2817),
    [sym_compiler_directive_decl] = STATE(2817),
    [sym_fsi_directive_decl] = STATE(2817),
    [sym_preproc_line] = STATE(2817),
    [sym_identifier] = ACTIONS(2914),
    [anon_sym_return] = ACTIONS(2914),
    [anon_sym_do] = ACTIONS(2914),
    [anon_sym_let] = ACTIONS(2914),
    [anon_sym_let_BANG] = ACTIONS(2916),
    [anon_sym_LPAREN] = ACTIONS(2914),
    [anon_sym_COMMA] = ACTIONS(2916),
    [anon_sym_null] = ACTIONS(2914),
    [anon_sym_AMP] = ACTIONS(2914),
    [anon_sym_LBRACK] = ACTIONS(2914),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2916),
    [anon_sym_LBRACE] = ACTIONS(2914),
    [anon_sym_LT_AT] = ACTIONS(2914),
    [anon_sym_LT_AT_AT] = ACTIONS(2916),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2916),
    [anon_sym_new] = ACTIONS(2914),
    [anon_sym_return_BANG] = ACTIONS(2916),
    [anon_sym_yield] = ACTIONS(2914),
    [anon_sym_yield_BANG] = ACTIONS(2916),
    [anon_sym_lazy] = ACTIONS(2914),
    [anon_sym_assert] = ACTIONS(2914),
    [anon_sym_upcast] = ACTIONS(2914),
    [anon_sym_downcast] = ACTIONS(2914),
    [anon_sym_for] = ACTIONS(2914),
    [anon_sym_while] = ACTIONS(2914),
    [anon_sym_if] = ACTIONS(2914),
    [anon_sym_fun] = ACTIONS(2914),
    [anon_sym_try] = ACTIONS(2914),
    [anon_sym_match] = ACTIONS(2914),
    [anon_sym_match_BANG] = ACTIONS(2916),
    [anon_sym_function] = ACTIONS(2914),
    [anon_sym_GT] = ACTIONS(2916),
    [anon_sym_use] = ACTIONS(2914),
    [anon_sym_use_BANG] = ACTIONS(2916),
    [anon_sym_do_BANG] = ACTIONS(2916),
    [anon_sym_begin] = ACTIONS(2914),
    [aux_sym_char_token1] = ACTIONS(2916),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2914),
    [anon_sym_DQUOTE] = ACTIONS(2914),
    [anon_sym_AT_DQUOTE] = ACTIONS(2916),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2916),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2916),
    [sym_bool] = ACTIONS(2914),
    [sym_unit] = ACTIONS(2916),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2914),
    [sym_op_identifier] = ACTIONS(2916),
    [anon_sym_PLUS] = ACTIONS(2914),
    [anon_sym_DASH] = ACTIONS(2914),
    [anon_sym_PLUS_DOT] = ACTIONS(2916),
    [anon_sym_DASH_DOT] = ACTIONS(2916),
    [anon_sym_PERCENT] = ACTIONS(2916),
    [anon_sym_AMP_AMP] = ACTIONS(2916),
    [anon_sym_TILDE] = ACTIONS(2916),
    [aux_sym_prefix_op_token1] = ACTIONS(2916),
    [sym_int] = ACTIONS(2914),
    [sym_xint] = ACTIONS(2916),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2916),
  },
  [2818] = {
    [sym_block_comment] = STATE(2818),
    [sym_compiler_directive_decl] = STATE(2818),
    [sym_fsi_directive_decl] = STATE(2818),
    [sym_preproc_line] = STATE(2818),
    [sym_identifier] = ACTIONS(3095),
    [anon_sym_return] = ACTIONS(3095),
    [anon_sym_do] = ACTIONS(3095),
    [anon_sym_let] = ACTIONS(3095),
    [anon_sym_let_BANG] = ACTIONS(3097),
    [anon_sym_LPAREN] = ACTIONS(3095),
    [anon_sym_COMMA] = ACTIONS(3097),
    [anon_sym_null] = ACTIONS(3095),
    [anon_sym_AMP] = ACTIONS(3095),
    [anon_sym_LBRACK] = ACTIONS(3095),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3097),
    [anon_sym_LBRACE] = ACTIONS(3095),
    [anon_sym_LT_AT] = ACTIONS(3095),
    [anon_sym_LT_AT_AT] = ACTIONS(3097),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3097),
    [anon_sym_new] = ACTIONS(3095),
    [anon_sym_return_BANG] = ACTIONS(3097),
    [anon_sym_yield] = ACTIONS(3095),
    [anon_sym_yield_BANG] = ACTIONS(3097),
    [anon_sym_lazy] = ACTIONS(3095),
    [anon_sym_assert] = ACTIONS(3095),
    [anon_sym_upcast] = ACTIONS(3095),
    [anon_sym_downcast] = ACTIONS(3095),
    [anon_sym_for] = ACTIONS(3095),
    [anon_sym_while] = ACTIONS(3095),
    [anon_sym_if] = ACTIONS(3095),
    [anon_sym_fun] = ACTIONS(3095),
    [anon_sym_try] = ACTIONS(3095),
    [anon_sym_match] = ACTIONS(3095),
    [anon_sym_match_BANG] = ACTIONS(3097),
    [anon_sym_function] = ACTIONS(3095),
    [anon_sym_GT] = ACTIONS(3097),
    [anon_sym_use] = ACTIONS(3095),
    [anon_sym_use_BANG] = ACTIONS(3097),
    [anon_sym_do_BANG] = ACTIONS(3097),
    [anon_sym_begin] = ACTIONS(3095),
    [aux_sym_char_token1] = ACTIONS(3097),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3095),
    [anon_sym_DQUOTE] = ACTIONS(3095),
    [anon_sym_AT_DQUOTE] = ACTIONS(3097),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3097),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3097),
    [sym_bool] = ACTIONS(3095),
    [sym_unit] = ACTIONS(3097),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3095),
    [sym_op_identifier] = ACTIONS(3097),
    [anon_sym_PLUS] = ACTIONS(3095),
    [anon_sym_DASH] = ACTIONS(3095),
    [anon_sym_PLUS_DOT] = ACTIONS(3097),
    [anon_sym_DASH_DOT] = ACTIONS(3097),
    [anon_sym_PERCENT] = ACTIONS(3097),
    [anon_sym_AMP_AMP] = ACTIONS(3097),
    [anon_sym_TILDE] = ACTIONS(3097),
    [aux_sym_prefix_op_token1] = ACTIONS(3097),
    [sym_int] = ACTIONS(3095),
    [sym_xint] = ACTIONS(3097),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3097),
  },
  [2819] = {
    [sym_block_comment] = STATE(2819),
    [sym_compiler_directive_decl] = STATE(2819),
    [sym_fsi_directive_decl] = STATE(2819),
    [sym_preproc_line] = STATE(2819),
    [sym_identifier] = ACTIONS(2962),
    [anon_sym_return] = ACTIONS(2962),
    [anon_sym_do] = ACTIONS(2962),
    [anon_sym_let] = ACTIONS(2962),
    [anon_sym_let_BANG] = ACTIONS(2964),
    [anon_sym_LPAREN] = ACTIONS(2962),
    [anon_sym_COMMA] = ACTIONS(2964),
    [anon_sym_null] = ACTIONS(2962),
    [anon_sym_AMP] = ACTIONS(2962),
    [anon_sym_LBRACK] = ACTIONS(2962),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2964),
    [anon_sym_LBRACE] = ACTIONS(2962),
    [anon_sym_LT_AT] = ACTIONS(2962),
    [anon_sym_LT_AT_AT] = ACTIONS(2964),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2964),
    [anon_sym_new] = ACTIONS(2962),
    [anon_sym_return_BANG] = ACTIONS(2964),
    [anon_sym_yield] = ACTIONS(2962),
    [anon_sym_yield_BANG] = ACTIONS(2964),
    [anon_sym_lazy] = ACTIONS(2962),
    [anon_sym_assert] = ACTIONS(2962),
    [anon_sym_upcast] = ACTIONS(2962),
    [anon_sym_downcast] = ACTIONS(2962),
    [anon_sym_for] = ACTIONS(2962),
    [anon_sym_while] = ACTIONS(2962),
    [anon_sym_if] = ACTIONS(2962),
    [anon_sym_fun] = ACTIONS(2962),
    [anon_sym_try] = ACTIONS(2962),
    [anon_sym_match] = ACTIONS(2962),
    [anon_sym_match_BANG] = ACTIONS(2964),
    [anon_sym_function] = ACTIONS(2962),
    [anon_sym_GT] = ACTIONS(2964),
    [anon_sym_use] = ACTIONS(2962),
    [anon_sym_use_BANG] = ACTIONS(2964),
    [anon_sym_do_BANG] = ACTIONS(2964),
    [anon_sym_begin] = ACTIONS(2962),
    [aux_sym_char_token1] = ACTIONS(2964),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2962),
    [anon_sym_DQUOTE] = ACTIONS(2962),
    [anon_sym_AT_DQUOTE] = ACTIONS(2964),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2964),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2964),
    [sym_bool] = ACTIONS(2962),
    [sym_unit] = ACTIONS(2964),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2962),
    [sym_op_identifier] = ACTIONS(2964),
    [anon_sym_PLUS] = ACTIONS(2962),
    [anon_sym_DASH] = ACTIONS(2962),
    [anon_sym_PLUS_DOT] = ACTIONS(2964),
    [anon_sym_DASH_DOT] = ACTIONS(2964),
    [anon_sym_PERCENT] = ACTIONS(2964),
    [anon_sym_AMP_AMP] = ACTIONS(2964),
    [anon_sym_TILDE] = ACTIONS(2964),
    [aux_sym_prefix_op_token1] = ACTIONS(2964),
    [sym_int] = ACTIONS(2962),
    [sym_xint] = ACTIONS(2964),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2964),
  },
  [2820] = {
    [sym_block_comment] = STATE(2820),
    [sym_compiler_directive_decl] = STATE(2820),
    [sym_fsi_directive_decl] = STATE(2820),
    [sym_preproc_line] = STATE(2820),
    [sym_identifier] = ACTIONS(2934),
    [anon_sym_return] = ACTIONS(2934),
    [anon_sym_do] = ACTIONS(2934),
    [anon_sym_let] = ACTIONS(2934),
    [anon_sym_let_BANG] = ACTIONS(2936),
    [anon_sym_LPAREN] = ACTIONS(2934),
    [anon_sym_COMMA] = ACTIONS(2936),
    [anon_sym_null] = ACTIONS(2934),
    [anon_sym_AMP] = ACTIONS(2934),
    [anon_sym_LBRACK] = ACTIONS(2934),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2936),
    [anon_sym_LBRACE] = ACTIONS(2934),
    [anon_sym_LT_AT] = ACTIONS(2934),
    [anon_sym_LT_AT_AT] = ACTIONS(2936),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2936),
    [anon_sym_new] = ACTIONS(2934),
    [anon_sym_return_BANG] = ACTIONS(2936),
    [anon_sym_yield] = ACTIONS(2934),
    [anon_sym_yield_BANG] = ACTIONS(2936),
    [anon_sym_lazy] = ACTIONS(2934),
    [anon_sym_assert] = ACTIONS(2934),
    [anon_sym_upcast] = ACTIONS(2934),
    [anon_sym_downcast] = ACTIONS(2934),
    [anon_sym_for] = ACTIONS(2934),
    [anon_sym_while] = ACTIONS(2934),
    [anon_sym_if] = ACTIONS(2934),
    [anon_sym_fun] = ACTIONS(2934),
    [anon_sym_try] = ACTIONS(2934),
    [anon_sym_match] = ACTIONS(2934),
    [anon_sym_match_BANG] = ACTIONS(2936),
    [anon_sym_function] = ACTIONS(2934),
    [anon_sym_GT] = ACTIONS(2936),
    [anon_sym_use] = ACTIONS(2934),
    [anon_sym_use_BANG] = ACTIONS(2936),
    [anon_sym_do_BANG] = ACTIONS(2936),
    [anon_sym_begin] = ACTIONS(2934),
    [aux_sym_char_token1] = ACTIONS(2936),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2934),
    [anon_sym_DQUOTE] = ACTIONS(2934),
    [anon_sym_AT_DQUOTE] = ACTIONS(2936),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2936),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2936),
    [sym_bool] = ACTIONS(2934),
    [sym_unit] = ACTIONS(2936),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2934),
    [sym_op_identifier] = ACTIONS(2936),
    [anon_sym_PLUS] = ACTIONS(2934),
    [anon_sym_DASH] = ACTIONS(2934),
    [anon_sym_PLUS_DOT] = ACTIONS(2936),
    [anon_sym_DASH_DOT] = ACTIONS(2936),
    [anon_sym_PERCENT] = ACTIONS(2936),
    [anon_sym_AMP_AMP] = ACTIONS(2936),
    [anon_sym_TILDE] = ACTIONS(2936),
    [aux_sym_prefix_op_token1] = ACTIONS(2936),
    [sym_int] = ACTIONS(2934),
    [sym_xint] = ACTIONS(2936),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2936),
  },
  [2821] = {
    [sym_block_comment] = STATE(2821),
    [sym_compiler_directive_decl] = STATE(2821),
    [sym_fsi_directive_decl] = STATE(2821),
    [sym_preproc_line] = STATE(2821),
    [sym_identifier] = ACTIONS(3115),
    [anon_sym_return] = ACTIONS(3115),
    [anon_sym_do] = ACTIONS(3115),
    [anon_sym_let] = ACTIONS(3115),
    [anon_sym_let_BANG] = ACTIONS(3117),
    [anon_sym_LPAREN] = ACTIONS(3115),
    [anon_sym_COMMA] = ACTIONS(3117),
    [anon_sym_null] = ACTIONS(3115),
    [anon_sym_AMP] = ACTIONS(3115),
    [anon_sym_LBRACK] = ACTIONS(3115),
    [anon_sym_LBRACK_PIPE] = ACTIONS(3117),
    [anon_sym_LBRACE] = ACTIONS(3115),
    [anon_sym_LT_AT] = ACTIONS(3115),
    [anon_sym_LT_AT_AT] = ACTIONS(3117),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3117),
    [anon_sym_new] = ACTIONS(3115),
    [anon_sym_return_BANG] = ACTIONS(3117),
    [anon_sym_yield] = ACTIONS(3115),
    [anon_sym_yield_BANG] = ACTIONS(3117),
    [anon_sym_lazy] = ACTIONS(3115),
    [anon_sym_assert] = ACTIONS(3115),
    [anon_sym_upcast] = ACTIONS(3115),
    [anon_sym_downcast] = ACTIONS(3115),
    [anon_sym_for] = ACTIONS(3115),
    [anon_sym_while] = ACTIONS(3115),
    [anon_sym_if] = ACTIONS(3115),
    [anon_sym_fun] = ACTIONS(3115),
    [anon_sym_try] = ACTIONS(3115),
    [anon_sym_match] = ACTIONS(3115),
    [anon_sym_match_BANG] = ACTIONS(3117),
    [anon_sym_function] = ACTIONS(3115),
    [anon_sym_GT] = ACTIONS(3117),
    [anon_sym_use] = ACTIONS(3115),
    [anon_sym_use_BANG] = ACTIONS(3117),
    [anon_sym_do_BANG] = ACTIONS(3117),
    [anon_sym_begin] = ACTIONS(3115),
    [aux_sym_char_token1] = ACTIONS(3117),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3115),
    [anon_sym_DQUOTE] = ACTIONS(3115),
    [anon_sym_AT_DQUOTE] = ACTIONS(3117),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3117),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3117),
    [sym_bool] = ACTIONS(3115),
    [sym_unit] = ACTIONS(3117),
    [anon_sym_LPAREN_PIPE] = ACTIONS(3115),
    [sym_op_identifier] = ACTIONS(3117),
    [anon_sym_PLUS] = ACTIONS(3115),
    [anon_sym_DASH] = ACTIONS(3115),
    [anon_sym_PLUS_DOT] = ACTIONS(3117),
    [anon_sym_DASH_DOT] = ACTIONS(3117),
    [anon_sym_PERCENT] = ACTIONS(3117),
    [anon_sym_AMP_AMP] = ACTIONS(3117),
    [anon_sym_TILDE] = ACTIONS(3117),
    [aux_sym_prefix_op_token1] = ACTIONS(3117),
    [sym_int] = ACTIONS(3115),
    [sym_xint] = ACTIONS(3117),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(3117),
  },
  [2822] = {
    [sym_block_comment] = STATE(2822),
    [sym_compiler_directive_decl] = STATE(2822),
    [sym_fsi_directive_decl] = STATE(2822),
    [sym_preproc_line] = STATE(2822),
    [sym_identifier] = ACTIONS(2887),
    [anon_sym_return] = ACTIONS(2887),
    [anon_sym_do] = ACTIONS(2887),
    [anon_sym_let] = ACTIONS(2887),
    [anon_sym_let_BANG] = ACTIONS(2889),
    [anon_sym_LPAREN] = ACTIONS(2887),
    [anon_sym_COMMA] = ACTIONS(2889),
    [anon_sym_null] = ACTIONS(2887),
    [anon_sym_AMP] = ACTIONS(2887),
    [anon_sym_LBRACK] = ACTIONS(2887),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2889),
    [anon_sym_LBRACE] = ACTIONS(2887),
    [anon_sym_LT_AT] = ACTIONS(2887),
    [anon_sym_LT_AT_AT] = ACTIONS(2889),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2889),
    [anon_sym_new] = ACTIONS(2887),
    [anon_sym_return_BANG] = ACTIONS(2889),
    [anon_sym_yield] = ACTIONS(2887),
    [anon_sym_yield_BANG] = ACTIONS(2889),
    [anon_sym_lazy] = ACTIONS(2887),
    [anon_sym_assert] = ACTIONS(2887),
    [anon_sym_upcast] = ACTIONS(2887),
    [anon_sym_downcast] = ACTIONS(2887),
    [anon_sym_for] = ACTIONS(2887),
    [anon_sym_while] = ACTIONS(2887),
    [anon_sym_if] = ACTIONS(2887),
    [anon_sym_fun] = ACTIONS(2887),
    [anon_sym_try] = ACTIONS(2887),
    [anon_sym_match] = ACTIONS(2887),
    [anon_sym_match_BANG] = ACTIONS(2889),
    [anon_sym_function] = ACTIONS(2887),
    [anon_sym_GT] = ACTIONS(2889),
    [anon_sym_use] = ACTIONS(2887),
    [anon_sym_use_BANG] = ACTIONS(2889),
    [anon_sym_do_BANG] = ACTIONS(2889),
    [anon_sym_begin] = ACTIONS(2887),
    [aux_sym_char_token1] = ACTIONS(2889),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2887),
    [anon_sym_DQUOTE] = ACTIONS(2887),
    [anon_sym_AT_DQUOTE] = ACTIONS(2889),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2889),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2889),
    [sym_bool] = ACTIONS(2887),
    [sym_unit] = ACTIONS(2889),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2887),
    [sym_op_identifier] = ACTIONS(2889),
    [anon_sym_PLUS] = ACTIONS(2887),
    [anon_sym_DASH] = ACTIONS(2887),
    [anon_sym_PLUS_DOT] = ACTIONS(2889),
    [anon_sym_DASH_DOT] = ACTIONS(2889),
    [anon_sym_PERCENT] = ACTIONS(2889),
    [anon_sym_AMP_AMP] = ACTIONS(2889),
    [anon_sym_TILDE] = ACTIONS(2889),
    [aux_sym_prefix_op_token1] = ACTIONS(2889),
    [sym_int] = ACTIONS(2887),
    [sym_xint] = ACTIONS(2889),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2889),
  },
  [2823] = {
    [sym_block_comment] = STATE(2823),
    [sym_compiler_directive_decl] = STATE(2823),
    [sym_fsi_directive_decl] = STATE(2823),
    [sym_preproc_line] = STATE(2823),
    [sym_identifier] = ACTIONS(2966),
    [anon_sym_return] = ACTIONS(2966),
    [anon_sym_do] = ACTIONS(2966),
    [anon_sym_let] = ACTIONS(2966),
    [anon_sym_let_BANG] = ACTIONS(2968),
    [anon_sym_LPAREN] = ACTIONS(2966),
    [anon_sym_COMMA] = ACTIONS(2968),
    [anon_sym_null] = ACTIONS(2966),
    [anon_sym_AMP] = ACTIONS(2966),
    [anon_sym_LBRACK] = ACTIONS(2966),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2968),
    [anon_sym_LBRACE] = ACTIONS(2966),
    [anon_sym_LT_AT] = ACTIONS(2966),
    [anon_sym_LT_AT_AT] = ACTIONS(2968),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2968),
    [anon_sym_new] = ACTIONS(2966),
    [anon_sym_return_BANG] = ACTIONS(2968),
    [anon_sym_yield] = ACTIONS(2966),
    [anon_sym_yield_BANG] = ACTIONS(2968),
    [anon_sym_lazy] = ACTIONS(2966),
    [anon_sym_assert] = ACTIONS(2966),
    [anon_sym_upcast] = ACTIONS(2966),
    [anon_sym_downcast] = ACTIONS(2966),
    [anon_sym_for] = ACTIONS(2966),
    [anon_sym_while] = ACTIONS(2966),
    [anon_sym_if] = ACTIONS(2966),
    [anon_sym_fun] = ACTIONS(2966),
    [anon_sym_try] = ACTIONS(2966),
    [anon_sym_match] = ACTIONS(2966),
    [anon_sym_match_BANG] = ACTIONS(2968),
    [anon_sym_function] = ACTIONS(2966),
    [anon_sym_GT] = ACTIONS(2968),
    [anon_sym_use] = ACTIONS(2966),
    [anon_sym_use_BANG] = ACTIONS(2968),
    [anon_sym_do_BANG] = ACTIONS(2968),
    [anon_sym_begin] = ACTIONS(2966),
    [aux_sym_char_token1] = ACTIONS(2968),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2966),
    [anon_sym_DQUOTE] = ACTIONS(2966),
    [anon_sym_AT_DQUOTE] = ACTIONS(2968),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2968),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2968),
    [sym_bool] = ACTIONS(2966),
    [sym_unit] = ACTIONS(2968),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2966),
    [sym_op_identifier] = ACTIONS(2968),
    [anon_sym_PLUS] = ACTIONS(2966),
    [anon_sym_DASH] = ACTIONS(2966),
    [anon_sym_PLUS_DOT] = ACTIONS(2968),
    [anon_sym_DASH_DOT] = ACTIONS(2968),
    [anon_sym_PERCENT] = ACTIONS(2968),
    [anon_sym_AMP_AMP] = ACTIONS(2968),
    [anon_sym_TILDE] = ACTIONS(2968),
    [aux_sym_prefix_op_token1] = ACTIONS(2968),
    [sym_int] = ACTIONS(2966),
    [sym_xint] = ACTIONS(2968),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2968),
  },
  [2824] = {
    [sym_block_comment] = STATE(2824),
    [sym_compiler_directive_decl] = STATE(2824),
    [sym_fsi_directive_decl] = STATE(2824),
    [sym_preproc_line] = STATE(2824),
    [sym_identifier] = ACTIONS(2974),
    [anon_sym_return] = ACTIONS(2974),
    [anon_sym_do] = ACTIONS(2974),
    [anon_sym_let] = ACTIONS(2974),
    [anon_sym_let_BANG] = ACTIONS(2976),
    [anon_sym_LPAREN] = ACTIONS(2974),
    [anon_sym_COMMA] = ACTIONS(2976),
    [anon_sym_null] = ACTIONS(2974),
    [anon_sym_AMP] = ACTIONS(2974),
    [anon_sym_LBRACK] = ACTIONS(2974),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2976),
    [anon_sym_LBRACE] = ACTIONS(2974),
    [anon_sym_LT_AT] = ACTIONS(2974),
    [anon_sym_LT_AT_AT] = ACTIONS(2976),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2976),
    [anon_sym_new] = ACTIONS(2974),
    [anon_sym_return_BANG] = ACTIONS(2976),
    [anon_sym_yield] = ACTIONS(2974),
    [anon_sym_yield_BANG] = ACTIONS(2976),
    [anon_sym_lazy] = ACTIONS(2974),
    [anon_sym_assert] = ACTIONS(2974),
    [anon_sym_upcast] = ACTIONS(2974),
    [anon_sym_downcast] = ACTIONS(2974),
    [anon_sym_for] = ACTIONS(2974),
    [anon_sym_while] = ACTIONS(2974),
    [anon_sym_if] = ACTIONS(2974),
    [anon_sym_fun] = ACTIONS(2974),
    [anon_sym_try] = ACTIONS(2974),
    [anon_sym_match] = ACTIONS(2974),
    [anon_sym_match_BANG] = ACTIONS(2976),
    [anon_sym_function] = ACTIONS(2974),
    [anon_sym_GT] = ACTIONS(2976),
    [anon_sym_use] = ACTIONS(2974),
    [anon_sym_use_BANG] = ACTIONS(2976),
    [anon_sym_do_BANG] = ACTIONS(2976),
    [anon_sym_begin] = ACTIONS(2974),
    [aux_sym_char_token1] = ACTIONS(2976),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2974),
    [anon_sym_DQUOTE] = ACTIONS(2974),
    [anon_sym_AT_DQUOTE] = ACTIONS(2976),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2976),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2976),
    [sym_bool] = ACTIONS(2974),
    [sym_unit] = ACTIONS(2976),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2974),
    [sym_op_identifier] = ACTIONS(2976),
    [anon_sym_PLUS] = ACTIONS(2974),
    [anon_sym_DASH] = ACTIONS(2974),
    [anon_sym_PLUS_DOT] = ACTIONS(2976),
    [anon_sym_DASH_DOT] = ACTIONS(2976),
    [anon_sym_PERCENT] = ACTIONS(2976),
    [anon_sym_AMP_AMP] = ACTIONS(2976),
    [anon_sym_TILDE] = ACTIONS(2976),
    [aux_sym_prefix_op_token1] = ACTIONS(2976),
    [sym_int] = ACTIONS(2974),
    [sym_xint] = ACTIONS(2976),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2976),
  },
  [2825] = {
    [sym_block_comment] = STATE(2825),
    [sym_compiler_directive_decl] = STATE(2825),
    [sym_fsi_directive_decl] = STATE(2825),
    [sym_preproc_line] = STATE(2825),
    [aux_sym__function_or_value_defns_repeat1] = STATE(2796),
    [sym_identifier] = ACTIONS(4683),
    [anon_sym_return] = ACTIONS(4683),
    [anon_sym_do] = ACTIONS(4683),
    [anon_sym_and] = ACTIONS(4679),
    [anon_sym_let] = ACTIONS(4683),
    [anon_sym_let_BANG] = ACTIONS(4685),
    [anon_sym_LPAREN] = ACTIONS(4683),
    [anon_sym_null] = ACTIONS(4683),
    [anon_sym_AMP] = ACTIONS(4683),
    [anon_sym_LBRACK] = ACTIONS(4683),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4685),
    [anon_sym_LBRACE] = ACTIONS(4683),
    [anon_sym_LT_AT] = ACTIONS(4683),
    [anon_sym_LT_AT_AT] = ACTIONS(4685),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4685),
    [anon_sym_new] = ACTIONS(4683),
    [anon_sym_return_BANG] = ACTIONS(4685),
    [anon_sym_yield] = ACTIONS(4683),
    [anon_sym_yield_BANG] = ACTIONS(4685),
    [anon_sym_lazy] = ACTIONS(4683),
    [anon_sym_assert] = ACTIONS(4683),
    [anon_sym_upcast] = ACTIONS(4683),
    [anon_sym_downcast] = ACTIONS(4683),
    [anon_sym_for] = ACTIONS(4683),
    [anon_sym_while] = ACTIONS(4683),
    [anon_sym_if] = ACTIONS(4683),
    [anon_sym_fun] = ACTIONS(4683),
    [anon_sym_try] = ACTIONS(4683),
    [anon_sym_match] = ACTIONS(4683),
    [anon_sym_match_BANG] = ACTIONS(4685),
    [anon_sym_function] = ACTIONS(4683),
    [anon_sym_use] = ACTIONS(4683),
    [anon_sym_use_BANG] = ACTIONS(4685),
    [anon_sym_do_BANG] = ACTIONS(4685),
    [anon_sym_begin] = ACTIONS(4683),
    [aux_sym_char_token1] = ACTIONS(4685),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4683),
    [anon_sym_DQUOTE] = ACTIONS(4683),
    [anon_sym_AT_DQUOTE] = ACTIONS(4685),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4685),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4685),
    [sym_bool] = ACTIONS(4683),
    [sym_unit] = ACTIONS(4685),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4683),
    [sym_op_identifier] = ACTIONS(4685),
    [anon_sym_PLUS] = ACTIONS(4683),
    [anon_sym_DASH] = ACTIONS(4683),
    [anon_sym_PLUS_DOT] = ACTIONS(4685),
    [anon_sym_DASH_DOT] = ACTIONS(4685),
    [anon_sym_PERCENT] = ACTIONS(4685),
    [anon_sym_AMP_AMP] = ACTIONS(4685),
    [anon_sym_TILDE] = ACTIONS(4685),
    [aux_sym_prefix_op_token1] = ACTIONS(4685),
    [sym_int] = ACTIONS(4683),
    [sym_xint] = ACTIONS(4685),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4685),
  },
  [2826] = {
    [sym_block_comment] = STATE(2826),
    [sym_compiler_directive_decl] = STATE(2826),
    [sym_fsi_directive_decl] = STATE(2826),
    [sym_preproc_line] = STATE(2826),
    [sym_identifier] = ACTIONS(2873),
    [anon_sym_return] = ACTIONS(2873),
    [anon_sym_do] = ACTIONS(2873),
    [anon_sym_let] = ACTIONS(2873),
    [anon_sym_let_BANG] = ACTIONS(2875),
    [anon_sym_LPAREN] = ACTIONS(2873),
    [anon_sym_COMMA] = ACTIONS(2875),
    [anon_sym_null] = ACTIONS(2873),
    [anon_sym_AMP] = ACTIONS(2873),
    [anon_sym_LBRACK] = ACTIONS(2873),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2875),
    [anon_sym_LBRACE] = ACTIONS(2873),
    [anon_sym_LT_AT] = ACTIONS(2873),
    [anon_sym_LT_AT_AT] = ACTIONS(2875),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2875),
    [anon_sym_new] = ACTIONS(2873),
    [anon_sym_return_BANG] = ACTIONS(2875),
    [anon_sym_yield] = ACTIONS(2873),
    [anon_sym_yield_BANG] = ACTIONS(2875),
    [anon_sym_lazy] = ACTIONS(2873),
    [anon_sym_assert] = ACTIONS(2873),
    [anon_sym_upcast] = ACTIONS(2873),
    [anon_sym_downcast] = ACTIONS(2873),
    [anon_sym_for] = ACTIONS(2873),
    [anon_sym_while] = ACTIONS(2873),
    [anon_sym_if] = ACTIONS(2873),
    [anon_sym_fun] = ACTIONS(2873),
    [anon_sym_try] = ACTIONS(2873),
    [anon_sym_match] = ACTIONS(2873),
    [anon_sym_match_BANG] = ACTIONS(2875),
    [anon_sym_function] = ACTIONS(2873),
    [anon_sym_GT] = ACTIONS(2875),
    [anon_sym_use] = ACTIONS(2873),
    [anon_sym_use_BANG] = ACTIONS(2875),
    [anon_sym_do_BANG] = ACTIONS(2875),
    [anon_sym_begin] = ACTIONS(2873),
    [aux_sym_char_token1] = ACTIONS(2875),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2873),
    [anon_sym_DQUOTE] = ACTIONS(2873),
    [anon_sym_AT_DQUOTE] = ACTIONS(2875),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2875),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2875),
    [sym_bool] = ACTIONS(2873),
    [sym_unit] = ACTIONS(2875),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2873),
    [sym_op_identifier] = ACTIONS(2875),
    [anon_sym_PLUS] = ACTIONS(2873),
    [anon_sym_DASH] = ACTIONS(2873),
    [anon_sym_PLUS_DOT] = ACTIONS(2875),
    [anon_sym_DASH_DOT] = ACTIONS(2875),
    [anon_sym_PERCENT] = ACTIONS(2875),
    [anon_sym_AMP_AMP] = ACTIONS(2875),
    [anon_sym_TILDE] = ACTIONS(2875),
    [aux_sym_prefix_op_token1] = ACTIONS(2875),
    [sym_int] = ACTIONS(2873),
    [sym_xint] = ACTIONS(2875),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2875),
  },
  [2827] = {
    [sym_block_comment] = STATE(2827),
    [sym_compiler_directive_decl] = STATE(2827),
    [sym_fsi_directive_decl] = STATE(2827),
    [sym_preproc_line] = STATE(2827),
    [aux_sym__function_or_value_defns_repeat1] = STATE(2827),
    [sym_identifier] = ACTIONS(4687),
    [anon_sym_return] = ACTIONS(4687),
    [anon_sym_do] = ACTIONS(4687),
    [anon_sym_and] = ACTIONS(4689),
    [anon_sym_let] = ACTIONS(4687),
    [anon_sym_let_BANG] = ACTIONS(4692),
    [anon_sym_LPAREN] = ACTIONS(4687),
    [anon_sym_null] = ACTIONS(4687),
    [anon_sym_AMP] = ACTIONS(4687),
    [anon_sym_LBRACK] = ACTIONS(4687),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4692),
    [anon_sym_LBRACE] = ACTIONS(4687),
    [anon_sym_LT_AT] = ACTIONS(4687),
    [anon_sym_LT_AT_AT] = ACTIONS(4692),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4692),
    [anon_sym_new] = ACTIONS(4687),
    [anon_sym_return_BANG] = ACTIONS(4692),
    [anon_sym_yield] = ACTIONS(4687),
    [anon_sym_yield_BANG] = ACTIONS(4692),
    [anon_sym_lazy] = ACTIONS(4687),
    [anon_sym_assert] = ACTIONS(4687),
    [anon_sym_upcast] = ACTIONS(4687),
    [anon_sym_downcast] = ACTIONS(4687),
    [anon_sym_for] = ACTIONS(4687),
    [anon_sym_while] = ACTIONS(4687),
    [anon_sym_if] = ACTIONS(4687),
    [anon_sym_fun] = ACTIONS(4687),
    [anon_sym_try] = ACTIONS(4687),
    [anon_sym_match] = ACTIONS(4687),
    [anon_sym_match_BANG] = ACTIONS(4692),
    [anon_sym_function] = ACTIONS(4687),
    [anon_sym_use] = ACTIONS(4687),
    [anon_sym_use_BANG] = ACTIONS(4692),
    [anon_sym_do_BANG] = ACTIONS(4692),
    [anon_sym_begin] = ACTIONS(4687),
    [aux_sym_char_token1] = ACTIONS(4692),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4687),
    [anon_sym_DQUOTE] = ACTIONS(4687),
    [anon_sym_AT_DQUOTE] = ACTIONS(4692),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4692),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4692),
    [sym_bool] = ACTIONS(4687),
    [sym_unit] = ACTIONS(4692),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4687),
    [sym_op_identifier] = ACTIONS(4692),
    [anon_sym_PLUS] = ACTIONS(4687),
    [anon_sym_DASH] = ACTIONS(4687),
    [anon_sym_PLUS_DOT] = ACTIONS(4692),
    [anon_sym_DASH_DOT] = ACTIONS(4692),
    [anon_sym_PERCENT] = ACTIONS(4692),
    [anon_sym_AMP_AMP] = ACTIONS(4692),
    [anon_sym_TILDE] = ACTIONS(4692),
    [aux_sym_prefix_op_token1] = ACTIONS(4692),
    [sym_int] = ACTIONS(4687),
    [sym_xint] = ACTIONS(4692),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4692),
  },
  [2828] = {
    [sym_block_comment] = STATE(2828),
    [sym_compiler_directive_decl] = STATE(2828),
    [sym_fsi_directive_decl] = STATE(2828),
    [sym_preproc_line] = STATE(2828),
    [sym_identifier] = ACTIONS(2883),
    [anon_sym_return] = ACTIONS(2883),
    [anon_sym_do] = ACTIONS(2883),
    [anon_sym_let] = ACTIONS(2883),
    [anon_sym_let_BANG] = ACTIONS(2885),
    [anon_sym_LPAREN] = ACTIONS(2883),
    [anon_sym_COMMA] = ACTIONS(2885),
    [anon_sym_null] = ACTIONS(2883),
    [anon_sym_AMP] = ACTIONS(2883),
    [anon_sym_LBRACK] = ACTIONS(2883),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2885),
    [anon_sym_LBRACE] = ACTIONS(2883),
    [anon_sym_LT_AT] = ACTIONS(2883),
    [anon_sym_LT_AT_AT] = ACTIONS(2885),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2885),
    [anon_sym_new] = ACTIONS(2883),
    [anon_sym_return_BANG] = ACTIONS(2885),
    [anon_sym_yield] = ACTIONS(2883),
    [anon_sym_yield_BANG] = ACTIONS(2885),
    [anon_sym_lazy] = ACTIONS(2883),
    [anon_sym_assert] = ACTIONS(2883),
    [anon_sym_upcast] = ACTIONS(2883),
    [anon_sym_downcast] = ACTIONS(2883),
    [anon_sym_for] = ACTIONS(2883),
    [anon_sym_while] = ACTIONS(2883),
    [anon_sym_if] = ACTIONS(2883),
    [anon_sym_fun] = ACTIONS(2883),
    [anon_sym_try] = ACTIONS(2883),
    [anon_sym_match] = ACTIONS(2883),
    [anon_sym_match_BANG] = ACTIONS(2885),
    [anon_sym_function] = ACTIONS(2883),
    [anon_sym_GT] = ACTIONS(2885),
    [anon_sym_use] = ACTIONS(2883),
    [anon_sym_use_BANG] = ACTIONS(2885),
    [anon_sym_do_BANG] = ACTIONS(2885),
    [anon_sym_begin] = ACTIONS(2883),
    [aux_sym_char_token1] = ACTIONS(2885),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2883),
    [anon_sym_DQUOTE] = ACTIONS(2883),
    [anon_sym_AT_DQUOTE] = ACTIONS(2885),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2885),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2885),
    [sym_bool] = ACTIONS(2883),
    [sym_unit] = ACTIONS(2885),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2883),
    [sym_op_identifier] = ACTIONS(2885),
    [anon_sym_PLUS] = ACTIONS(2883),
    [anon_sym_DASH] = ACTIONS(2883),
    [anon_sym_PLUS_DOT] = ACTIONS(2885),
    [anon_sym_DASH_DOT] = ACTIONS(2885),
    [anon_sym_PERCENT] = ACTIONS(2885),
    [anon_sym_AMP_AMP] = ACTIONS(2885),
    [anon_sym_TILDE] = ACTIONS(2885),
    [aux_sym_prefix_op_token1] = ACTIONS(2885),
    [sym_int] = ACTIONS(2883),
    [sym_xint] = ACTIONS(2885),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2885),
  },
  [2829] = {
    [sym_block_comment] = STATE(2829),
    [sym_compiler_directive_decl] = STATE(2829),
    [sym_fsi_directive_decl] = STATE(2829),
    [sym_preproc_line] = STATE(2829),
    [sym_identifier] = ACTIONS(4694),
    [anon_sym_return] = ACTIONS(4694),
    [anon_sym_do] = ACTIONS(4694),
    [anon_sym_and] = ACTIONS(4694),
    [anon_sym_let] = ACTIONS(4694),
    [anon_sym_let_BANG] = ACTIONS(4696),
    [anon_sym_LPAREN] = ACTIONS(4694),
    [anon_sym_null] = ACTIONS(4694),
    [anon_sym_AMP] = ACTIONS(4694),
    [anon_sym_LBRACK] = ACTIONS(4694),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4696),
    [anon_sym_LBRACE] = ACTIONS(4694),
    [anon_sym_LT_AT] = ACTIONS(4694),
    [anon_sym_LT_AT_AT] = ACTIONS(4696),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4696),
    [anon_sym_new] = ACTIONS(4694),
    [anon_sym_return_BANG] = ACTIONS(4696),
    [anon_sym_yield] = ACTIONS(4694),
    [anon_sym_yield_BANG] = ACTIONS(4696),
    [anon_sym_lazy] = ACTIONS(4694),
    [anon_sym_assert] = ACTIONS(4694),
    [anon_sym_upcast] = ACTIONS(4694),
    [anon_sym_downcast] = ACTIONS(4694),
    [anon_sym_for] = ACTIONS(4694),
    [anon_sym_while] = ACTIONS(4694),
    [anon_sym_if] = ACTIONS(4694),
    [anon_sym_fun] = ACTIONS(4694),
    [anon_sym_try] = ACTIONS(4694),
    [anon_sym_match] = ACTIONS(4694),
    [anon_sym_match_BANG] = ACTIONS(4696),
    [anon_sym_function] = ACTIONS(4694),
    [anon_sym_use] = ACTIONS(4694),
    [anon_sym_use_BANG] = ACTIONS(4696),
    [anon_sym_do_BANG] = ACTIONS(4696),
    [anon_sym_begin] = ACTIONS(4694),
    [aux_sym_char_token1] = ACTIONS(4696),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4694),
    [anon_sym_DQUOTE] = ACTIONS(4694),
    [anon_sym_AT_DQUOTE] = ACTIONS(4696),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4696),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4696),
    [sym_bool] = ACTIONS(4694),
    [sym_unit] = ACTIONS(4696),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4694),
    [sym_op_identifier] = ACTIONS(4696),
    [anon_sym_PLUS] = ACTIONS(4694),
    [anon_sym_DASH] = ACTIONS(4694),
    [anon_sym_PLUS_DOT] = ACTIONS(4696),
    [anon_sym_DASH_DOT] = ACTIONS(4696),
    [anon_sym_PERCENT] = ACTIONS(4696),
    [anon_sym_AMP_AMP] = ACTIONS(4696),
    [anon_sym_TILDE] = ACTIONS(4696),
    [aux_sym_prefix_op_token1] = ACTIONS(4696),
    [sym_int] = ACTIONS(4694),
    [sym_xint] = ACTIONS(4696),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4696),
  },
  [2830] = {
    [sym_block_comment] = STATE(2830),
    [sym_compiler_directive_decl] = STATE(2830),
    [sym_fsi_directive_decl] = STATE(2830),
    [sym_preproc_line] = STATE(2830),
    [sym_identifier] = ACTIONS(4698),
    [anon_sym_return] = ACTIONS(4698),
    [anon_sym_do] = ACTIONS(4698),
    [anon_sym_and] = ACTIONS(4698),
    [anon_sym_let] = ACTIONS(4698),
    [anon_sym_let_BANG] = ACTIONS(4700),
    [anon_sym_LPAREN] = ACTIONS(4698),
    [anon_sym_null] = ACTIONS(4698),
    [anon_sym_AMP] = ACTIONS(4698),
    [anon_sym_LBRACK] = ACTIONS(4698),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4700),
    [anon_sym_LBRACE] = ACTIONS(4698),
    [anon_sym_LT_AT] = ACTIONS(4698),
    [anon_sym_LT_AT_AT] = ACTIONS(4700),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4700),
    [anon_sym_new] = ACTIONS(4698),
    [anon_sym_return_BANG] = ACTIONS(4700),
    [anon_sym_yield] = ACTIONS(4698),
    [anon_sym_yield_BANG] = ACTIONS(4700),
    [anon_sym_lazy] = ACTIONS(4698),
    [anon_sym_assert] = ACTIONS(4698),
    [anon_sym_upcast] = ACTIONS(4698),
    [anon_sym_downcast] = ACTIONS(4698),
    [anon_sym_for] = ACTIONS(4698),
    [anon_sym_while] = ACTIONS(4698),
    [anon_sym_if] = ACTIONS(4698),
    [anon_sym_fun] = ACTIONS(4698),
    [anon_sym_try] = ACTIONS(4698),
    [anon_sym_match] = ACTIONS(4698),
    [anon_sym_match_BANG] = ACTIONS(4700),
    [anon_sym_function] = ACTIONS(4698),
    [anon_sym_use] = ACTIONS(4698),
    [anon_sym_use_BANG] = ACTIONS(4700),
    [anon_sym_do_BANG] = ACTIONS(4700),
    [anon_sym_begin] = ACTIONS(4698),
    [aux_sym_char_token1] = ACTIONS(4700),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4698),
    [anon_sym_DQUOTE] = ACTIONS(4698),
    [anon_sym_AT_DQUOTE] = ACTIONS(4700),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4700),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4700),
    [sym_bool] = ACTIONS(4698),
    [sym_unit] = ACTIONS(4700),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4698),
    [sym_op_identifier] = ACTIONS(4700),
    [anon_sym_PLUS] = ACTIONS(4698),
    [anon_sym_DASH] = ACTIONS(4698),
    [anon_sym_PLUS_DOT] = ACTIONS(4700),
    [anon_sym_DASH_DOT] = ACTIONS(4700),
    [anon_sym_PERCENT] = ACTIONS(4700),
    [anon_sym_AMP_AMP] = ACTIONS(4700),
    [anon_sym_TILDE] = ACTIONS(4700),
    [aux_sym_prefix_op_token1] = ACTIONS(4700),
    [sym_int] = ACTIONS(4698),
    [sym_xint] = ACTIONS(4700),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4700),
  },
  [2831] = {
    [sym_block_comment] = STATE(2831),
    [sym_compiler_directive_decl] = STATE(2831),
    [sym_fsi_directive_decl] = STATE(2831),
    [sym_preproc_line] = STATE(2831),
    [aux_sym_prefix_op_repeat1] = STATE(2831),
    [sym_identifier] = ACTIONS(4702),
    [anon_sym_return] = ACTIONS(4702),
    [anon_sym_do] = ACTIONS(4702),
    [anon_sym_let] = ACTIONS(4702),
    [anon_sym_let_BANG] = ACTIONS(4704),
    [anon_sym_LPAREN] = ACTIONS(4702),
    [anon_sym_null] = ACTIONS(4702),
    [anon_sym_AMP] = ACTIONS(4702),
    [anon_sym_LBRACK] = ACTIONS(4702),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4704),
    [anon_sym_LBRACE] = ACTIONS(4702),
    [anon_sym_LT_AT] = ACTIONS(4702),
    [anon_sym_LT_AT_AT] = ACTIONS(4704),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4704),
    [anon_sym_new] = ACTIONS(4702),
    [anon_sym_return_BANG] = ACTIONS(4704),
    [anon_sym_yield] = ACTIONS(4702),
    [anon_sym_yield_BANG] = ACTIONS(4704),
    [anon_sym_lazy] = ACTIONS(4702),
    [anon_sym_assert] = ACTIONS(4702),
    [anon_sym_upcast] = ACTIONS(4702),
    [anon_sym_downcast] = ACTIONS(4702),
    [anon_sym_for] = ACTIONS(4702),
    [anon_sym_while] = ACTIONS(4702),
    [anon_sym_if] = ACTIONS(4702),
    [anon_sym_fun] = ACTIONS(4702),
    [anon_sym_try] = ACTIONS(4702),
    [anon_sym_match] = ACTIONS(4702),
    [anon_sym_match_BANG] = ACTIONS(4704),
    [anon_sym_function] = ACTIONS(4702),
    [anon_sym_use] = ACTIONS(4702),
    [anon_sym_use_BANG] = ACTIONS(4704),
    [anon_sym_do_BANG] = ACTIONS(4704),
    [anon_sym_begin] = ACTIONS(4702),
    [aux_sym_char_token1] = ACTIONS(4704),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4702),
    [anon_sym_DQUOTE] = ACTIONS(4702),
    [anon_sym_AT_DQUOTE] = ACTIONS(4704),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4704),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4704),
    [sym_bool] = ACTIONS(4702),
    [sym_unit] = ACTIONS(4704),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4702),
    [sym_op_identifier] = ACTIONS(4704),
    [anon_sym_PLUS] = ACTIONS(4702),
    [anon_sym_DASH] = ACTIONS(4702),
    [anon_sym_PLUS_DOT] = ACTIONS(4704),
    [anon_sym_DASH_DOT] = ACTIONS(4704),
    [anon_sym_PERCENT] = ACTIONS(4704),
    [anon_sym_AMP_AMP] = ACTIONS(4704),
    [anon_sym_TILDE] = ACTIONS(4706),
    [aux_sym_prefix_op_token1] = ACTIONS(4704),
    [sym_int] = ACTIONS(4702),
    [sym_xint] = ACTIONS(4704),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4704),
  },
  [2832] = {
    [sym_block_comment] = STATE(2832),
    [sym_compiler_directive_decl] = STATE(2832),
    [sym_fsi_directive_decl] = STATE(2832),
    [sym_preproc_line] = STATE(2832),
    [sym_identifier] = ACTIONS(2685),
    [anon_sym_return] = ACTIONS(2685),
    [anon_sym_do] = ACTIONS(2685),
    [anon_sym_and] = ACTIONS(2685),
    [anon_sym_let] = ACTIONS(2685),
    [anon_sym_let_BANG] = ACTIONS(2687),
    [anon_sym_LPAREN] = ACTIONS(2685),
    [anon_sym_null] = ACTIONS(2685),
    [anon_sym_AMP] = ACTIONS(2685),
    [anon_sym_LBRACK] = ACTIONS(2685),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2687),
    [anon_sym_LBRACE] = ACTIONS(2685),
    [anon_sym_LT_AT] = ACTIONS(2685),
    [anon_sym_LT_AT_AT] = ACTIONS(2687),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2687),
    [anon_sym_new] = ACTIONS(2685),
    [anon_sym_return_BANG] = ACTIONS(2687),
    [anon_sym_yield] = ACTIONS(2685),
    [anon_sym_yield_BANG] = ACTIONS(2687),
    [anon_sym_lazy] = ACTIONS(2685),
    [anon_sym_assert] = ACTIONS(2685),
    [anon_sym_upcast] = ACTIONS(2685),
    [anon_sym_downcast] = ACTIONS(2685),
    [anon_sym_for] = ACTIONS(2685),
    [anon_sym_while] = ACTIONS(2685),
    [anon_sym_if] = ACTIONS(2685),
    [anon_sym_fun] = ACTIONS(2685),
    [anon_sym_try] = ACTIONS(2685),
    [anon_sym_match] = ACTIONS(2685),
    [anon_sym_match_BANG] = ACTIONS(2687),
    [anon_sym_function] = ACTIONS(2685),
    [anon_sym_use] = ACTIONS(2685),
    [anon_sym_use_BANG] = ACTIONS(2687),
    [anon_sym_do_BANG] = ACTIONS(2687),
    [anon_sym_begin] = ACTIONS(2685),
    [aux_sym_char_token1] = ACTIONS(2687),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2685),
    [anon_sym_DQUOTE] = ACTIONS(2685),
    [anon_sym_AT_DQUOTE] = ACTIONS(2687),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2687),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2687),
    [sym_bool] = ACTIONS(2685),
    [sym_unit] = ACTIONS(2687),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2685),
    [sym_op_identifier] = ACTIONS(2687),
    [anon_sym_PLUS] = ACTIONS(2685),
    [anon_sym_DASH] = ACTIONS(2685),
    [anon_sym_PLUS_DOT] = ACTIONS(2687),
    [anon_sym_DASH_DOT] = ACTIONS(2687),
    [anon_sym_PERCENT] = ACTIONS(2687),
    [anon_sym_AMP_AMP] = ACTIONS(2687),
    [anon_sym_TILDE] = ACTIONS(2687),
    [aux_sym_prefix_op_token1] = ACTIONS(2687),
    [sym_int] = ACTIONS(2685),
    [sym_xint] = ACTIONS(2687),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2687),
  },
  [2833] = {
    [sym_block_comment] = STATE(2833),
    [sym_compiler_directive_decl] = STATE(2833),
    [sym_fsi_directive_decl] = STATE(2833),
    [sym_preproc_line] = STATE(2833),
    [sym_identifier] = ACTIONS(4709),
    [anon_sym_return] = ACTIONS(4709),
    [anon_sym_do] = ACTIONS(4709),
    [anon_sym_and] = ACTIONS(4709),
    [anon_sym_let] = ACTIONS(4709),
    [anon_sym_let_BANG] = ACTIONS(4711),
    [anon_sym_LPAREN] = ACTIONS(4709),
    [anon_sym_null] = ACTIONS(4709),
    [anon_sym_AMP] = ACTIONS(4709),
    [anon_sym_LBRACK] = ACTIONS(4709),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4711),
    [anon_sym_LBRACE] = ACTIONS(4709),
    [anon_sym_LT_AT] = ACTIONS(4709),
    [anon_sym_LT_AT_AT] = ACTIONS(4711),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4711),
    [anon_sym_new] = ACTIONS(4709),
    [anon_sym_return_BANG] = ACTIONS(4711),
    [anon_sym_yield] = ACTIONS(4709),
    [anon_sym_yield_BANG] = ACTIONS(4711),
    [anon_sym_lazy] = ACTIONS(4709),
    [anon_sym_assert] = ACTIONS(4709),
    [anon_sym_upcast] = ACTIONS(4709),
    [anon_sym_downcast] = ACTIONS(4709),
    [anon_sym_for] = ACTIONS(4709),
    [anon_sym_while] = ACTIONS(4709),
    [anon_sym_if] = ACTIONS(4709),
    [anon_sym_fun] = ACTIONS(4709),
    [anon_sym_try] = ACTIONS(4709),
    [anon_sym_match] = ACTIONS(4709),
    [anon_sym_match_BANG] = ACTIONS(4711),
    [anon_sym_function] = ACTIONS(4709),
    [anon_sym_use] = ACTIONS(4709),
    [anon_sym_use_BANG] = ACTIONS(4711),
    [anon_sym_do_BANG] = ACTIONS(4711),
    [anon_sym_begin] = ACTIONS(4709),
    [aux_sym_char_token1] = ACTIONS(4711),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4709),
    [anon_sym_DQUOTE] = ACTIONS(4709),
    [anon_sym_AT_DQUOTE] = ACTIONS(4711),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4711),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4711),
    [sym_bool] = ACTIONS(4709),
    [sym_unit] = ACTIONS(4711),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4709),
    [sym_op_identifier] = ACTIONS(4711),
    [anon_sym_PLUS] = ACTIONS(4709),
    [anon_sym_DASH] = ACTIONS(4709),
    [anon_sym_PLUS_DOT] = ACTIONS(4711),
    [anon_sym_DASH_DOT] = ACTIONS(4711),
    [anon_sym_PERCENT] = ACTIONS(4711),
    [anon_sym_AMP_AMP] = ACTIONS(4711),
    [anon_sym_TILDE] = ACTIONS(4711),
    [aux_sym_prefix_op_token1] = ACTIONS(4711),
    [sym_int] = ACTIONS(4709),
    [sym_xint] = ACTIONS(4711),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4711),
  },
  [2834] = {
    [sym_block_comment] = STATE(2834),
    [sym_compiler_directive_decl] = STATE(2834),
    [sym_fsi_directive_decl] = STATE(2834),
    [sym_preproc_line] = STATE(2834),
    [aux_sym_prefix_op_repeat1] = STATE(2831),
    [sym_identifier] = ACTIONS(4713),
    [anon_sym_return] = ACTIONS(4713),
    [anon_sym_do] = ACTIONS(4713),
    [anon_sym_let] = ACTIONS(4713),
    [anon_sym_let_BANG] = ACTIONS(4715),
    [anon_sym_LPAREN] = ACTIONS(4713),
    [anon_sym_null] = ACTIONS(4713),
    [anon_sym_AMP] = ACTIONS(4713),
    [anon_sym_LBRACK] = ACTIONS(4713),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4715),
    [anon_sym_LBRACE] = ACTIONS(4713),
    [anon_sym_LT_AT] = ACTIONS(4713),
    [anon_sym_LT_AT_AT] = ACTIONS(4715),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4715),
    [anon_sym_new] = ACTIONS(4713),
    [anon_sym_return_BANG] = ACTIONS(4715),
    [anon_sym_yield] = ACTIONS(4713),
    [anon_sym_yield_BANG] = ACTIONS(4715),
    [anon_sym_lazy] = ACTIONS(4713),
    [anon_sym_assert] = ACTIONS(4713),
    [anon_sym_upcast] = ACTIONS(4713),
    [anon_sym_downcast] = ACTIONS(4713),
    [anon_sym_for] = ACTIONS(4713),
    [anon_sym_while] = ACTIONS(4713),
    [anon_sym_if] = ACTIONS(4713),
    [anon_sym_fun] = ACTIONS(4713),
    [anon_sym_try] = ACTIONS(4713),
    [anon_sym_match] = ACTIONS(4713),
    [anon_sym_match_BANG] = ACTIONS(4715),
    [anon_sym_function] = ACTIONS(4713),
    [anon_sym_use] = ACTIONS(4713),
    [anon_sym_use_BANG] = ACTIONS(4715),
    [anon_sym_do_BANG] = ACTIONS(4715),
    [anon_sym_begin] = ACTIONS(4713),
    [aux_sym_char_token1] = ACTIONS(4715),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4713),
    [anon_sym_DQUOTE] = ACTIONS(4713),
    [anon_sym_AT_DQUOTE] = ACTIONS(4715),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4715),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4715),
    [sym_bool] = ACTIONS(4713),
    [sym_unit] = ACTIONS(4715),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4713),
    [sym_op_identifier] = ACTIONS(4715),
    [anon_sym_PLUS] = ACTIONS(4713),
    [anon_sym_DASH] = ACTIONS(4713),
    [anon_sym_PLUS_DOT] = ACTIONS(4715),
    [anon_sym_DASH_DOT] = ACTIONS(4715),
    [anon_sym_PERCENT] = ACTIONS(4715),
    [anon_sym_AMP_AMP] = ACTIONS(4715),
    [anon_sym_TILDE] = ACTIONS(4715),
    [aux_sym_prefix_op_token1] = ACTIONS(4715),
    [sym_int] = ACTIONS(4713),
    [sym_xint] = ACTIONS(4715),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4715),
  },
  [2835] = {
    [sym_block_comment] = STATE(2835),
    [sym_compiler_directive_decl] = STATE(2835),
    [sym_fsi_directive_decl] = STATE(2835),
    [sym_preproc_line] = STATE(2835),
    [sym_identifier] = ACTIONS(4717),
    [anon_sym_return] = ACTIONS(4717),
    [anon_sym_do] = ACTIONS(4717),
    [anon_sym_let] = ACTIONS(4717),
    [anon_sym_let_BANG] = ACTIONS(4719),
    [anon_sym_LPAREN] = ACTIONS(4717),
    [anon_sym_null] = ACTIONS(4717),
    [anon_sym_AMP] = ACTIONS(4717),
    [anon_sym_LBRACK] = ACTIONS(4717),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4719),
    [anon_sym_LBRACE] = ACTIONS(4717),
    [anon_sym_LT_AT] = ACTIONS(4717),
    [anon_sym_LT_AT_AT] = ACTIONS(4719),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4719),
    [anon_sym_new] = ACTIONS(4717),
    [anon_sym_return_BANG] = ACTIONS(4719),
    [anon_sym_yield] = ACTIONS(4717),
    [anon_sym_yield_BANG] = ACTIONS(4719),
    [anon_sym_lazy] = ACTIONS(4717),
    [anon_sym_assert] = ACTIONS(4717),
    [anon_sym_upcast] = ACTIONS(4717),
    [anon_sym_downcast] = ACTIONS(4717),
    [anon_sym_for] = ACTIONS(4717),
    [anon_sym_while] = ACTIONS(4717),
    [anon_sym_if] = ACTIONS(4717),
    [anon_sym_fun] = ACTIONS(4717),
    [anon_sym_try] = ACTIONS(4717),
    [anon_sym_match] = ACTIONS(4717),
    [anon_sym_match_BANG] = ACTIONS(4719),
    [anon_sym_function] = ACTIONS(4717),
    [anon_sym_use] = ACTIONS(4717),
    [anon_sym_use_BANG] = ACTIONS(4719),
    [anon_sym_do_BANG] = ACTIONS(4719),
    [anon_sym_begin] = ACTIONS(4717),
    [aux_sym_char_token1] = ACTIONS(4719),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4717),
    [anon_sym_DQUOTE] = ACTIONS(4717),
    [anon_sym_AT_DQUOTE] = ACTIONS(4719),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4719),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4719),
    [sym_bool] = ACTIONS(4717),
    [sym_unit] = ACTIONS(4719),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4717),
    [sym_op_identifier] = ACTIONS(4719),
    [anon_sym_PLUS] = ACTIONS(4717),
    [anon_sym_DASH] = ACTIONS(4717),
    [anon_sym_PLUS_DOT] = ACTIONS(4719),
    [anon_sym_DASH_DOT] = ACTIONS(4719),
    [anon_sym_PERCENT] = ACTIONS(4719),
    [anon_sym_AMP_AMP] = ACTIONS(4719),
    [anon_sym_TILDE] = ACTIONS(4719),
    [aux_sym_prefix_op_token1] = ACTIONS(4719),
    [sym_int] = ACTIONS(4717),
    [sym_xint] = ACTIONS(4719),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4719),
  },
  [2836] = {
    [sym_block_comment] = STATE(2836),
    [sym_compiler_directive_decl] = STATE(2836),
    [sym_fsi_directive_decl] = STATE(2836),
    [sym_preproc_line] = STATE(2836),
    [sym_identifier] = ACTIONS(4721),
    [anon_sym_return] = ACTIONS(4721),
    [anon_sym_do] = ACTIONS(4721),
    [anon_sym_let] = ACTIONS(4721),
    [anon_sym_let_BANG] = ACTIONS(4723),
    [anon_sym_LPAREN] = ACTIONS(4721),
    [anon_sym_null] = ACTIONS(4721),
    [anon_sym_AMP] = ACTIONS(4721),
    [anon_sym_LBRACK] = ACTIONS(4721),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4723),
    [anon_sym_LBRACE] = ACTIONS(4721),
    [anon_sym_LT_AT] = ACTIONS(4721),
    [anon_sym_LT_AT_AT] = ACTIONS(4723),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4723),
    [anon_sym_new] = ACTIONS(4721),
    [anon_sym_return_BANG] = ACTIONS(4723),
    [anon_sym_yield] = ACTIONS(4721),
    [anon_sym_yield_BANG] = ACTIONS(4723),
    [anon_sym_lazy] = ACTIONS(4721),
    [anon_sym_assert] = ACTIONS(4721),
    [anon_sym_upcast] = ACTIONS(4721),
    [anon_sym_downcast] = ACTIONS(4721),
    [anon_sym_for] = ACTIONS(4721),
    [anon_sym_while] = ACTIONS(4721),
    [anon_sym_if] = ACTIONS(4721),
    [anon_sym_fun] = ACTIONS(4721),
    [anon_sym_try] = ACTIONS(4721),
    [anon_sym_match] = ACTIONS(4721),
    [anon_sym_match_BANG] = ACTIONS(4723),
    [anon_sym_function] = ACTIONS(4721),
    [anon_sym_use] = ACTIONS(4721),
    [anon_sym_use_BANG] = ACTIONS(4723),
    [anon_sym_do_BANG] = ACTIONS(4723),
    [anon_sym_begin] = ACTIONS(4721),
    [aux_sym_char_token1] = ACTIONS(4723),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4721),
    [anon_sym_DQUOTE] = ACTIONS(4721),
    [anon_sym_AT_DQUOTE] = ACTIONS(4723),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4723),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4723),
    [sym_bool] = ACTIONS(4721),
    [sym_unit] = ACTIONS(4723),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4721),
    [sym_op_identifier] = ACTIONS(4723),
    [anon_sym_PLUS] = ACTIONS(4721),
    [anon_sym_DASH] = ACTIONS(4721),
    [anon_sym_PLUS_DOT] = ACTIONS(4723),
    [anon_sym_DASH_DOT] = ACTIONS(4723),
    [anon_sym_PERCENT] = ACTIONS(4723),
    [anon_sym_AMP_AMP] = ACTIONS(4723),
    [anon_sym_TILDE] = ACTIONS(4723),
    [aux_sym_prefix_op_token1] = ACTIONS(4723),
    [sym_int] = ACTIONS(4721),
    [sym_xint] = ACTIONS(4723),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4723),
  },
  [2837] = {
    [sym_block_comment] = STATE(2837),
    [sym_compiler_directive_decl] = STATE(2837),
    [sym_fsi_directive_decl] = STATE(2837),
    [sym_preproc_line] = STATE(2837),
    [sym_identifier] = ACTIONS(2685),
    [anon_sym_return] = ACTIONS(2685),
    [anon_sym_do] = ACTIONS(2685),
    [anon_sym_let] = ACTIONS(2685),
    [anon_sym_let_BANG] = ACTIONS(2687),
    [anon_sym_LPAREN] = ACTIONS(2685),
    [anon_sym_null] = ACTIONS(2685),
    [anon_sym_AMP] = ACTIONS(2685),
    [anon_sym_LBRACK] = ACTIONS(2685),
    [anon_sym_LBRACK_PIPE] = ACTIONS(2687),
    [anon_sym_LBRACE] = ACTIONS(2685),
    [anon_sym_LT_AT] = ACTIONS(2685),
    [anon_sym_LT_AT_AT] = ACTIONS(2687),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2687),
    [anon_sym_new] = ACTIONS(2685),
    [anon_sym_return_BANG] = ACTIONS(2687),
    [anon_sym_yield] = ACTIONS(2685),
    [anon_sym_yield_BANG] = ACTIONS(2687),
    [anon_sym_lazy] = ACTIONS(2685),
    [anon_sym_assert] = ACTIONS(2685),
    [anon_sym_upcast] = ACTIONS(2685),
    [anon_sym_downcast] = ACTIONS(2685),
    [anon_sym_for] = ACTIONS(2685),
    [anon_sym_while] = ACTIONS(2685),
    [anon_sym_if] = ACTIONS(2685),
    [anon_sym_fun] = ACTIONS(2685),
    [anon_sym_try] = ACTIONS(2685),
    [anon_sym_match] = ACTIONS(2685),
    [anon_sym_match_BANG] = ACTIONS(2687),
    [anon_sym_function] = ACTIONS(2685),
    [anon_sym_use] = ACTIONS(2685),
    [anon_sym_use_BANG] = ACTIONS(2687),
    [anon_sym_do_BANG] = ACTIONS(2687),
    [anon_sym_begin] = ACTIONS(2685),
    [aux_sym_char_token1] = ACTIONS(2687),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2685),
    [anon_sym_DQUOTE] = ACTIONS(2685),
    [anon_sym_AT_DQUOTE] = ACTIONS(2687),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2687),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2687),
    [sym_bool] = ACTIONS(2685),
    [sym_unit] = ACTIONS(2687),
    [anon_sym_LPAREN_PIPE] = ACTIONS(2685),
    [sym_op_identifier] = ACTIONS(2687),
    [anon_sym_PLUS] = ACTIONS(2685),
    [anon_sym_DASH] = ACTIONS(2685),
    [anon_sym_PLUS_DOT] = ACTIONS(2687),
    [anon_sym_DASH_DOT] = ACTIONS(2687),
    [anon_sym_PERCENT] = ACTIONS(2687),
    [anon_sym_AMP_AMP] = ACTIONS(2687),
    [anon_sym_TILDE] = ACTIONS(2687),
    [aux_sym_prefix_op_token1] = ACTIONS(2687),
    [sym_int] = ACTIONS(2685),
    [sym_xint] = ACTIONS(2687),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(2687),
  },
  [2838] = {
    [sym_block_comment] = STATE(2838),
    [sym_compiler_directive_decl] = STATE(2838),
    [sym_fsi_directive_decl] = STATE(2838),
    [sym_preproc_line] = STATE(2838),
    [sym_identifier] = ACTIONS(4713),
    [anon_sym_return] = ACTIONS(4713),
    [anon_sym_do] = ACTIONS(4713),
    [anon_sym_let] = ACTIONS(4713),
    [anon_sym_let_BANG] = ACTIONS(4715),
    [anon_sym_LPAREN] = ACTIONS(4713),
    [anon_sym_null] = ACTIONS(4713),
    [anon_sym_AMP] = ACTIONS(4713),
    [anon_sym_LBRACK] = ACTIONS(4713),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4715),
    [anon_sym_LBRACE] = ACTIONS(4713),
    [anon_sym_LT_AT] = ACTIONS(4713),
    [anon_sym_LT_AT_AT] = ACTIONS(4715),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4715),
    [anon_sym_new] = ACTIONS(4713),
    [anon_sym_return_BANG] = ACTIONS(4715),
    [anon_sym_yield] = ACTIONS(4713),
    [anon_sym_yield_BANG] = ACTIONS(4715),
    [anon_sym_lazy] = ACTIONS(4713),
    [anon_sym_assert] = ACTIONS(4713),
    [anon_sym_upcast] = ACTIONS(4713),
    [anon_sym_downcast] = ACTIONS(4713),
    [anon_sym_for] = ACTIONS(4713),
    [anon_sym_while] = ACTIONS(4713),
    [anon_sym_if] = ACTIONS(4713),
    [anon_sym_fun] = ACTIONS(4713),
    [anon_sym_try] = ACTIONS(4713),
    [anon_sym_match] = ACTIONS(4713),
    [anon_sym_match_BANG] = ACTIONS(4715),
    [anon_sym_function] = ACTIONS(4713),
    [anon_sym_use] = ACTIONS(4713),
    [anon_sym_use_BANG] = ACTIONS(4715),
    [anon_sym_do_BANG] = ACTIONS(4715),
    [anon_sym_begin] = ACTIONS(4713),
    [aux_sym_char_token1] = ACTIONS(4715),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4713),
    [anon_sym_DQUOTE] = ACTIONS(4713),
    [anon_sym_AT_DQUOTE] = ACTIONS(4715),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4715),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4715),
    [sym_bool] = ACTIONS(4713),
    [sym_unit] = ACTIONS(4715),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4713),
    [sym_op_identifier] = ACTIONS(4715),
    [anon_sym_PLUS] = ACTIONS(4713),
    [anon_sym_DASH] = ACTIONS(4713),
    [anon_sym_PLUS_DOT] = ACTIONS(4715),
    [anon_sym_DASH_DOT] = ACTIONS(4715),
    [anon_sym_PERCENT] = ACTIONS(4715),
    [anon_sym_AMP_AMP] = ACTIONS(4715),
    [anon_sym_TILDE] = ACTIONS(4715),
    [aux_sym_prefix_op_token1] = ACTIONS(4715),
    [sym_int] = ACTIONS(4713),
    [sym_xint] = ACTIONS(4715),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4715),
  },
  [2839] = {
    [sym_block_comment] = STATE(2839),
    [sym_compiler_directive_decl] = STATE(2839),
    [sym_fsi_directive_decl] = STATE(2839),
    [sym_preproc_line] = STATE(2839),
    [sym_identifier] = ACTIONS(4725),
    [anon_sym_return] = ACTIONS(4725),
    [anon_sym_do] = ACTIONS(4725),
    [anon_sym_let] = ACTIONS(4725),
    [anon_sym_let_BANG] = ACTIONS(4727),
    [anon_sym_LPAREN] = ACTIONS(4725),
    [anon_sym_null] = ACTIONS(4725),
    [anon_sym_AMP] = ACTIONS(4725),
    [anon_sym_LBRACK] = ACTIONS(4725),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4727),
    [anon_sym_LBRACE] = ACTIONS(4725),
    [anon_sym_LT_AT] = ACTIONS(4725),
    [anon_sym_LT_AT_AT] = ACTIONS(4727),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4727),
    [anon_sym_new] = ACTIONS(4725),
    [anon_sym_return_BANG] = ACTIONS(4727),
    [anon_sym_yield] = ACTIONS(4725),
    [anon_sym_yield_BANG] = ACTIONS(4727),
    [anon_sym_lazy] = ACTIONS(4725),
    [anon_sym_assert] = ACTIONS(4725),
    [anon_sym_upcast] = ACTIONS(4725),
    [anon_sym_downcast] = ACTIONS(4725),
    [anon_sym_for] = ACTIONS(4725),
    [anon_sym_while] = ACTIONS(4725),
    [anon_sym_if] = ACTIONS(4725),
    [anon_sym_fun] = ACTIONS(4725),
    [anon_sym_try] = ACTIONS(4725),
    [anon_sym_match] = ACTIONS(4725),
    [anon_sym_match_BANG] = ACTIONS(4727),
    [anon_sym_function] = ACTIONS(4725),
    [anon_sym_use] = ACTIONS(4725),
    [anon_sym_use_BANG] = ACTIONS(4727),
    [anon_sym_do_BANG] = ACTIONS(4727),
    [anon_sym_begin] = ACTIONS(4725),
    [aux_sym_char_token1] = ACTIONS(4727),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4725),
    [anon_sym_DQUOTE] = ACTIONS(4725),
    [anon_sym_AT_DQUOTE] = ACTIONS(4727),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4727),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4727),
    [sym_bool] = ACTIONS(4725),
    [sym_unit] = ACTIONS(4727),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4725),
    [sym_op_identifier] = ACTIONS(4727),
    [anon_sym_PLUS] = ACTIONS(4725),
    [anon_sym_DASH] = ACTIONS(4725),
    [anon_sym_PLUS_DOT] = ACTIONS(4727),
    [anon_sym_DASH_DOT] = ACTIONS(4727),
    [anon_sym_PERCENT] = ACTIONS(4727),
    [anon_sym_AMP_AMP] = ACTIONS(4727),
    [anon_sym_TILDE] = ACTIONS(4727),
    [aux_sym_prefix_op_token1] = ACTIONS(4727),
    [sym_int] = ACTIONS(4725),
    [sym_xint] = ACTIONS(4727),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4727),
  },
  [2840] = {
    [sym_block_comment] = STATE(2840),
    [sym_compiler_directive_decl] = STATE(2840),
    [sym_fsi_directive_decl] = STATE(2840),
    [sym_preproc_line] = STATE(2840),
    [sym_identifier] = ACTIONS(4729),
    [anon_sym_return] = ACTIONS(4729),
    [anon_sym_do] = ACTIONS(4729),
    [anon_sym_let] = ACTIONS(4729),
    [anon_sym_let_BANG] = ACTIONS(4731),
    [anon_sym_LPAREN] = ACTIONS(4729),
    [anon_sym_null] = ACTIONS(4729),
    [anon_sym_AMP] = ACTIONS(4729),
    [anon_sym_LBRACK] = ACTIONS(4729),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4731),
    [anon_sym_LBRACE] = ACTIONS(4729),
    [anon_sym_LT_AT] = ACTIONS(4729),
    [anon_sym_LT_AT_AT] = ACTIONS(4731),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4731),
    [anon_sym_new] = ACTIONS(4729),
    [anon_sym_return_BANG] = ACTIONS(4731),
    [anon_sym_yield] = ACTIONS(4729),
    [anon_sym_yield_BANG] = ACTIONS(4731),
    [anon_sym_lazy] = ACTIONS(4729),
    [anon_sym_assert] = ACTIONS(4729),
    [anon_sym_upcast] = ACTIONS(4729),
    [anon_sym_downcast] = ACTIONS(4729),
    [anon_sym_for] = ACTIONS(4729),
    [anon_sym_while] = ACTIONS(4729),
    [anon_sym_if] = ACTIONS(4729),
    [anon_sym_fun] = ACTIONS(4729),
    [anon_sym_try] = ACTIONS(4729),
    [anon_sym_match] = ACTIONS(4729),
    [anon_sym_match_BANG] = ACTIONS(4731),
    [anon_sym_function] = ACTIONS(4729),
    [anon_sym_use] = ACTIONS(4729),
    [anon_sym_use_BANG] = ACTIONS(4731),
    [anon_sym_do_BANG] = ACTIONS(4731),
    [anon_sym_begin] = ACTIONS(4729),
    [aux_sym_char_token1] = ACTIONS(4731),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4729),
    [anon_sym_DQUOTE] = ACTIONS(4729),
    [anon_sym_AT_DQUOTE] = ACTIONS(4731),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4731),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4731),
    [sym_bool] = ACTIONS(4729),
    [sym_unit] = ACTIONS(4731),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4729),
    [sym_op_identifier] = ACTIONS(4731),
    [anon_sym_PLUS] = ACTIONS(4729),
    [anon_sym_DASH] = ACTIONS(4729),
    [anon_sym_PLUS_DOT] = ACTIONS(4731),
    [anon_sym_DASH_DOT] = ACTIONS(4731),
    [anon_sym_PERCENT] = ACTIONS(4731),
    [anon_sym_AMP_AMP] = ACTIONS(4731),
    [anon_sym_TILDE] = ACTIONS(4731),
    [aux_sym_prefix_op_token1] = ACTIONS(4731),
    [sym_int] = ACTIONS(4729),
    [sym_xint] = ACTIONS(4731),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4731),
  },
  [2841] = {
    [sym_block_comment] = STATE(2841),
    [sym_compiler_directive_decl] = STATE(2841),
    [sym_fsi_directive_decl] = STATE(2841),
    [sym_preproc_line] = STATE(2841),
    [sym_identifier] = ACTIONS(4733),
    [anon_sym_return] = ACTIONS(4733),
    [anon_sym_do] = ACTIONS(4733),
    [anon_sym_let] = ACTIONS(4733),
    [anon_sym_let_BANG] = ACTIONS(4735),
    [anon_sym_LPAREN] = ACTIONS(4733),
    [anon_sym_null] = ACTIONS(4733),
    [anon_sym_AMP] = ACTIONS(4733),
    [anon_sym_LBRACK] = ACTIONS(4733),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4735),
    [anon_sym_LBRACE] = ACTIONS(4733),
    [anon_sym_LT_AT] = ACTIONS(4733),
    [anon_sym_LT_AT_AT] = ACTIONS(4735),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4735),
    [anon_sym_new] = ACTIONS(4733),
    [anon_sym_return_BANG] = ACTIONS(4735),
    [anon_sym_yield] = ACTIONS(4733),
    [anon_sym_yield_BANG] = ACTIONS(4735),
    [anon_sym_lazy] = ACTIONS(4733),
    [anon_sym_assert] = ACTIONS(4733),
    [anon_sym_upcast] = ACTIONS(4733),
    [anon_sym_downcast] = ACTIONS(4733),
    [anon_sym_for] = ACTIONS(4733),
    [anon_sym_while] = ACTIONS(4733),
    [anon_sym_if] = ACTIONS(4733),
    [anon_sym_fun] = ACTIONS(4733),
    [anon_sym_try] = ACTIONS(4733),
    [anon_sym_match] = ACTIONS(4733),
    [anon_sym_match_BANG] = ACTIONS(4735),
    [anon_sym_function] = ACTIONS(4733),
    [anon_sym_use] = ACTIONS(4733),
    [anon_sym_use_BANG] = ACTIONS(4735),
    [anon_sym_do_BANG] = ACTIONS(4735),
    [anon_sym_begin] = ACTIONS(4733),
    [aux_sym_char_token1] = ACTIONS(4735),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4733),
    [anon_sym_DQUOTE] = ACTIONS(4733),
    [anon_sym_AT_DQUOTE] = ACTIONS(4735),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4735),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4735),
    [sym_bool] = ACTIONS(4733),
    [sym_unit] = ACTIONS(4735),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4733),
    [sym_op_identifier] = ACTIONS(4735),
    [anon_sym_PLUS] = ACTIONS(4733),
    [anon_sym_DASH] = ACTIONS(4733),
    [anon_sym_PLUS_DOT] = ACTIONS(4735),
    [anon_sym_DASH_DOT] = ACTIONS(4735),
    [anon_sym_PERCENT] = ACTIONS(4735),
    [anon_sym_AMP_AMP] = ACTIONS(4735),
    [anon_sym_TILDE] = ACTIONS(4735),
    [aux_sym_prefix_op_token1] = ACTIONS(4735),
    [sym_int] = ACTIONS(4733),
    [sym_xint] = ACTIONS(4735),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4735),
  },
  [2842] = {
    [sym_block_comment] = STATE(2842),
    [sym_compiler_directive_decl] = STATE(2842),
    [sym_fsi_directive_decl] = STATE(2842),
    [sym_preproc_line] = STATE(2842),
    [sym_identifier] = ACTIONS(4709),
    [anon_sym_return] = ACTIONS(4709),
    [anon_sym_do] = ACTIONS(4709),
    [anon_sym_let] = ACTIONS(4709),
    [anon_sym_let_BANG] = ACTIONS(4711),
    [anon_sym_LPAREN] = ACTIONS(4709),
    [anon_sym_null] = ACTIONS(4709),
    [anon_sym_AMP] = ACTIONS(4709),
    [anon_sym_LBRACK] = ACTIONS(4709),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4711),
    [anon_sym_LBRACE] = ACTIONS(4709),
    [anon_sym_LT_AT] = ACTIONS(4709),
    [anon_sym_LT_AT_AT] = ACTIONS(4711),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4711),
    [anon_sym_new] = ACTIONS(4709),
    [anon_sym_return_BANG] = ACTIONS(4711),
    [anon_sym_yield] = ACTIONS(4709),
    [anon_sym_yield_BANG] = ACTIONS(4711),
    [anon_sym_lazy] = ACTIONS(4709),
    [anon_sym_assert] = ACTIONS(4709),
    [anon_sym_upcast] = ACTIONS(4709),
    [anon_sym_downcast] = ACTIONS(4709),
    [anon_sym_for] = ACTIONS(4709),
    [anon_sym_while] = ACTIONS(4709),
    [anon_sym_if] = ACTIONS(4709),
    [anon_sym_fun] = ACTIONS(4709),
    [anon_sym_try] = ACTIONS(4709),
    [anon_sym_match] = ACTIONS(4709),
    [anon_sym_match_BANG] = ACTIONS(4711),
    [anon_sym_function] = ACTIONS(4709),
    [anon_sym_use] = ACTIONS(4709),
    [anon_sym_use_BANG] = ACTIONS(4711),
    [anon_sym_do_BANG] = ACTIONS(4711),
    [anon_sym_begin] = ACTIONS(4709),
    [aux_sym_char_token1] = ACTIONS(4711),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4709),
    [anon_sym_DQUOTE] = ACTIONS(4709),
    [anon_sym_AT_DQUOTE] = ACTIONS(4711),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4711),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4711),
    [sym_bool] = ACTIONS(4709),
    [sym_unit] = ACTIONS(4711),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4709),
    [sym_op_identifier] = ACTIONS(4711),
    [anon_sym_PLUS] = ACTIONS(4709),
    [anon_sym_DASH] = ACTIONS(4709),
    [anon_sym_PLUS_DOT] = ACTIONS(4711),
    [anon_sym_DASH_DOT] = ACTIONS(4711),
    [anon_sym_PERCENT] = ACTIONS(4711),
    [anon_sym_AMP_AMP] = ACTIONS(4711),
    [anon_sym_TILDE] = ACTIONS(4711),
    [aux_sym_prefix_op_token1] = ACTIONS(4711),
    [sym_int] = ACTIONS(4709),
    [sym_xint] = ACTIONS(4711),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4711),
  },
  [2843] = {
    [sym_block_comment] = STATE(2843),
    [sym_compiler_directive_decl] = STATE(2843),
    [sym_fsi_directive_decl] = STATE(2843),
    [sym_preproc_line] = STATE(2843),
    [sym_identifier] = ACTIONS(4694),
    [anon_sym_return] = ACTIONS(4694),
    [anon_sym_do] = ACTIONS(4694),
    [anon_sym_let] = ACTIONS(4694),
    [anon_sym_let_BANG] = ACTIONS(4696),
    [anon_sym_LPAREN] = ACTIONS(4694),
    [anon_sym_null] = ACTIONS(4694),
    [anon_sym_AMP] = ACTIONS(4694),
    [anon_sym_LBRACK] = ACTIONS(4694),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4696),
    [anon_sym_LBRACE] = ACTIONS(4694),
    [anon_sym_LT_AT] = ACTIONS(4694),
    [anon_sym_LT_AT_AT] = ACTIONS(4696),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4696),
    [anon_sym_new] = ACTIONS(4694),
    [anon_sym_return_BANG] = ACTIONS(4696),
    [anon_sym_yield] = ACTIONS(4694),
    [anon_sym_yield_BANG] = ACTIONS(4696),
    [anon_sym_lazy] = ACTIONS(4694),
    [anon_sym_assert] = ACTIONS(4694),
    [anon_sym_upcast] = ACTIONS(4694),
    [anon_sym_downcast] = ACTIONS(4694),
    [anon_sym_for] = ACTIONS(4694),
    [anon_sym_while] = ACTIONS(4694),
    [anon_sym_if] = ACTIONS(4694),
    [anon_sym_fun] = ACTIONS(4694),
    [anon_sym_try] = ACTIONS(4694),
    [anon_sym_match] = ACTIONS(4694),
    [anon_sym_match_BANG] = ACTIONS(4696),
    [anon_sym_function] = ACTIONS(4694),
    [anon_sym_use] = ACTIONS(4694),
    [anon_sym_use_BANG] = ACTIONS(4696),
    [anon_sym_do_BANG] = ACTIONS(4696),
    [anon_sym_begin] = ACTIONS(4694),
    [aux_sym_char_token1] = ACTIONS(4696),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4694),
    [anon_sym_DQUOTE] = ACTIONS(4694),
    [anon_sym_AT_DQUOTE] = ACTIONS(4696),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4696),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4696),
    [sym_bool] = ACTIONS(4694),
    [sym_unit] = ACTIONS(4696),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4694),
    [sym_op_identifier] = ACTIONS(4696),
    [anon_sym_PLUS] = ACTIONS(4694),
    [anon_sym_DASH] = ACTIONS(4694),
    [anon_sym_PLUS_DOT] = ACTIONS(4696),
    [anon_sym_DASH_DOT] = ACTIONS(4696),
    [anon_sym_PERCENT] = ACTIONS(4696),
    [anon_sym_AMP_AMP] = ACTIONS(4696),
    [anon_sym_TILDE] = ACTIONS(4696),
    [aux_sym_prefix_op_token1] = ACTIONS(4696),
    [sym_int] = ACTIONS(4694),
    [sym_xint] = ACTIONS(4696),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4696),
  },
  [2844] = {
    [sym_block_comment] = STATE(2844),
    [sym_compiler_directive_decl] = STATE(2844),
    [sym_fsi_directive_decl] = STATE(2844),
    [sym_preproc_line] = STATE(2844),
    [sym_identifier] = ACTIONS(4725),
    [anon_sym_return] = ACTIONS(4725),
    [anon_sym_do] = ACTIONS(4725),
    [anon_sym_let] = ACTIONS(4725),
    [anon_sym_let_BANG] = ACTIONS(4727),
    [anon_sym_LPAREN] = ACTIONS(4725),
    [anon_sym_null] = ACTIONS(4725),
    [anon_sym_AMP] = ACTIONS(4725),
    [anon_sym_LBRACK] = ACTIONS(4725),
    [anon_sym_LBRACK_PIPE] = ACTIONS(4727),
    [anon_sym_LBRACE] = ACTIONS(4725),
    [anon_sym_LT_AT] = ACTIONS(4725),
    [anon_sym_LT_AT_AT] = ACTIONS(4727),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4727),
    [anon_sym_new] = ACTIONS(4725),
    [anon_sym_return_BANG] = ACTIONS(4727),
    [anon_sym_yield] = ACTIONS(4725),
    [anon_sym_yield_BANG] = ACTIONS(4727),
    [anon_sym_lazy] = ACTIONS(4725),
    [anon_sym_assert] = ACTIONS(4725),
    [anon_sym_upcast] = ACTIONS(4725),
    [anon_sym_downcast] = ACTIONS(4725),
    [anon_sym_for] = ACTIONS(4725),
    [anon_sym_while] = ACTIONS(4725),
    [anon_sym_if] = ACTIONS(4725),
    [anon_sym_fun] = ACTIONS(4725),
    [anon_sym_try] = ACTIONS(4725),
    [anon_sym_match] = ACTIONS(4725),
    [anon_sym_match_BANG] = ACTIONS(4727),
    [anon_sym_function] = ACTIONS(4725),
    [anon_sym_use] = ACTIONS(4725),
    [anon_sym_use_BANG] = ACTIONS(4727),
    [anon_sym_do_BANG] = ACTIONS(4727),
    [anon_sym_begin] = ACTIONS(4725),
    [aux_sym_char_token1] = ACTIONS(4727),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(4725),
    [anon_sym_DQUOTE] = ACTIONS(4725),
    [anon_sym_AT_DQUOTE] = ACTIONS(4727),
    [anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4727),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4727),
    [sym_bool] = ACTIONS(4725),
    [sym_unit] = ACTIONS(4727),
    [anon_sym_LPAREN_PIPE] = ACTIONS(4725),
    [sym_op_identifier] = ACTIONS(4727),
    [anon_sym_PLUS] = ACTIONS(4725),
    [anon_sym_DASH] = ACTIONS(4725),
    [anon_sym_PLUS_DOT] = ACTIONS(4727),
    [anon_sym_DASH_DOT] = ACTIONS(4727),
    [anon_sym_PERCENT] = ACTIONS(4727),
    [anon_sym_AMP_AMP] = ACTIONS(4727),
    [anon_sym_TILDE] = ACTIONS(4727),
    [aux_sym_prefix_op_token1] = ACTIONS(4727),
    [sym_int] = ACTIONS(4725),
    [sym_xint] = ACTIONS(4727),
    [anon_sym_LPAREN_STAR] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_POUNDnowarn] = ACTIONS(7),
    [anon_sym_POUNDlight] = ACTIONS(9),
    [anon_sym_POUNDr] = ACTIONS(11),
    [anon_sym_POUNDload] = ACTIONS(13),
    [aux_sym_preproc_line_token1] = ACTIONS(15),
    [anon_sym_POUNDif] = ACTIONS(4727),
  },
};

static const uint16_t ts_small_parse_table[] = {
  [0] = 34,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4601), 1,
      sym_identifier,
    ACTIONS(4603), 1,
      anon_sym_LPAREN,
    ACTIONS(4607), 1,
      anon_sym_LBRACK,
    ACTIONS(4609), 1,
      anon_sym_LBRACK_PIPE,
    ACTIONS(4611), 1,
      anon_sym_LBRACE,
    ACTIONS(4613), 1,
      anon_sym_LT2,
    ACTIONS(4615), 1,
      aux_sym_char_token1,
    ACTIONS(4617), 1,
      anon_sym_DOLLAR_DQUOTE,
    ACTIONS(4619), 1,
      anon_sym_DQUOTE,
    ACTIONS(4621), 1,
      anon_sym_AT_DQUOTE,
    ACTIONS(4623), 1,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(4625), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(4627), 1,
      sym_bool,
    ACTIONS(4629), 1,
      sym_unit,
    ACTIONS(4631), 1,
      sym_int,
    ACTIONS(4633), 1,
      sym_xint,
    STATE(2846), 1,
      aux_sym_argument_patterns_repeat1,
    STATE(2858), 1,
      sym_type_arguments,
    STATE(3887), 1,
      sym_float,
    STATE(4141), 1,
      sym__atomic_pattern,
    STATE(4166), 1,
      sym_format_triple_quoted_string,
    STATE(6393), 1,
      sym_argument_patterns,
    ACTIONS(4605), 2,
      anon_sym_null,
      anon_sym__,
    STATE(4160), 2,
      sym_format_string,
      sym__string_literal,
    STATE(2845), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4163), 5,
      sym_list_pattern,
      sym_array_pattern,
      sym_record_pattern,
      sym_const,
      sym_long_identifier,
    STATE(4152), 20,
      sym_char,
      sym_string,
      sym_verbatim_string,
      sym_bytearray,
      sym_verbatim_bytearray,
      sym_triple_quoted_string,
      sym_sbyte,
      sym_byte,
      sym_int16,
      sym_uint16,
      sym_int32,
      sym_uint32,
      sym_nativeint,
      sym_unativeint,
      sym_int64,
      sym_uint64,
      sym_ieee32,
      sym_ieee64,
      sym_bignum,
      sym_decimal,
  [131] = 32,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4601), 1,
      sym_identifier,
    ACTIONS(4603), 1,
      anon_sym_LPAREN,
    ACTIONS(4607), 1,
      anon_sym_LBRACK,
    ACTIONS(4609), 1,
      anon_sym_LBRACK_PIPE,
    ACTIONS(4611), 1,
      anon_sym_LBRACE,
    ACTIONS(4615), 1,
      aux_sym_char_token1,
    ACTIONS(4617), 1,
      anon_sym_DOLLAR_DQUOTE,
    ACTIONS(4619), 1,
      anon_sym_DQUOTE,
    ACTIONS(4621), 1,
      anon_sym_AT_DQUOTE,
    ACTIONS(4623), 1,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(4625), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(4627), 1,
      sym_bool,
    ACTIONS(4629), 1,
      sym_unit,
    ACTIONS(4631), 1,
      sym_int,
    ACTIONS(4633), 1,
      sym_xint,
    STATE(2847), 1,
      aux_sym_argument_patterns_repeat1,
    STATE(3887), 1,
      sym_float,
    STATE(4141), 1,
      sym__atomic_pattern,
    STATE(4166), 1,
      sym_format_triple_quoted_string,
    ACTIONS(4605), 2,
      anon_sym_null,
      anon_sym__,
    STATE(4160), 2,
      sym_format_string,
      sym__string_literal,
    ACTIONS(4737), 3,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DASH_GT,
    STATE(2846), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4163), 5,
      sym_list_pattern,
      sym_array_pattern,
      sym_record_pattern,
      sym_const,
      sym_long_identifier,
    STATE(4152), 20,
      sym_char,
      sym_string,
      sym_verbatim_string,
      sym_bytearray,
      sym_verbatim_bytearray,
      sym_triple_quoted_string,
      sym_sbyte,
      sym_byte,
      sym_int16,
      sym_uint16,
      sym_int32,
      sym_uint32,
      sym_nativeint,
      sym_unativeint,
      sym_int64,
      sym_uint64,
      sym_ieee32,
      sym_ieee64,
      sym_bignum,
      sym_decimal,
  [258] = 31,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4739), 1,
      sym_identifier,
    ACTIONS(4744), 1,
      anon_sym_LPAREN,
    ACTIONS(4750), 1,
      anon_sym_LBRACK,
    ACTIONS(4753), 1,
      anon_sym_LBRACK_PIPE,
    ACTIONS(4756), 1,
      anon_sym_LBRACE,
    ACTIONS(4759), 1,
      aux_sym_char_token1,
    ACTIONS(4762), 1,
      anon_sym_DOLLAR_DQUOTE,
    ACTIONS(4765), 1,
      anon_sym_DQUOTE,
    ACTIONS(4768), 1,
      anon_sym_AT_DQUOTE,
    ACTIONS(4771), 1,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(4774), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(4777), 1,
      sym_bool,
    ACTIONS(4780), 1,
      sym_unit,
    ACTIONS(4783), 1,
      sym_int,
    ACTIONS(4786), 1,
      sym_xint,
    STATE(3887), 1,
      sym_float,
    STATE(4141), 1,
      sym__atomic_pattern,
    STATE(4166), 1,
      sym_format_triple_quoted_string,
    ACTIONS(4747), 2,
      anon_sym_null,
      anon_sym__,
    STATE(4160), 2,
      sym_format_string,
      sym__string_literal,
    ACTIONS(4742), 3,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DASH_GT,
    STATE(2847), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_argument_patterns_repeat1,
    STATE(4163), 5,
      sym_list_pattern,
      sym_array_pattern,
      sym_record_pattern,
      sym_const,
      sym_long_identifier,
    STATE(4152), 20,
      sym_char,
      sym_string,
      sym_verbatim_string,
      sym_bytearray,
      sym_verbatim_bytearray,
      sym_triple_quoted_string,
      sym_sbyte,
      sym_byte,
      sym_int16,
      sym_uint16,
      sym_int32,
      sym_uint32,
      sym_nativeint,
      sym_unativeint,
      sym_int64,
      sym_uint64,
      sym_ieee32,
      sym_ieee64,
      sym_bignum,
      sym_decimal,
  [383] = 34,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4601), 1,
      sym_identifier,
    ACTIONS(4603), 1,
      anon_sym_LPAREN,
    ACTIONS(4607), 1,
      anon_sym_LBRACK,
    ACTIONS(4609), 1,
      anon_sym_LBRACK_PIPE,
    ACTIONS(4611), 1,
      anon_sym_LBRACE,
    ACTIONS(4613), 1,
      anon_sym_LT2,
    ACTIONS(4615), 1,
      aux_sym_char_token1,
    ACTIONS(4617), 1,
      anon_sym_DOLLAR_DQUOTE,
    ACTIONS(4619), 1,
      anon_sym_DQUOTE,
    ACTIONS(4621), 1,
      anon_sym_AT_DQUOTE,
    ACTIONS(4623), 1,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(4625), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(4627), 1,
      sym_bool,
    ACTIONS(4629), 1,
      sym_unit,
    ACTIONS(4631), 1,
      sym_int,
    ACTIONS(4633), 1,
      sym_xint,
    STATE(2846), 1,
      aux_sym_argument_patterns_repeat1,
    STATE(2850), 1,
      sym_type_arguments,
    STATE(3887), 1,
      sym_float,
    STATE(4141), 1,
      sym__atomic_pattern,
    STATE(4166), 1,
      sym_format_triple_quoted_string,
    STATE(6284), 1,
      sym_argument_patterns,
    ACTIONS(4605), 2,
      anon_sym_null,
      anon_sym__,
    STATE(4160), 2,
      sym_format_string,
      sym__string_literal,
    STATE(2848), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4163), 5,
      sym_list_pattern,
      sym_array_pattern,
      sym_record_pattern,
      sym_const,
      sym_long_identifier,
    STATE(4152), 20,
      sym_char,
      sym_string,
      sym_verbatim_string,
      sym_bytearray,
      sym_verbatim_bytearray,
      sym_triple_quoted_string,
      sym_sbyte,
      sym_byte,
      sym_int16,
      sym_uint16,
      sym_int32,
      sym_uint32,
      sym_nativeint,
      sym_unativeint,
      sym_int64,
      sym_uint64,
      sym_ieee32,
      sym_ieee64,
      sym_bignum,
      sym_decimal,
  [514] = 33,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4601), 1,
      sym_identifier,
    ACTIONS(4603), 1,
      anon_sym_LPAREN,
    ACTIONS(4607), 1,
      anon_sym_LBRACK,
    ACTIONS(4609), 1,
      anon_sym_LBRACK_PIPE,
    ACTIONS(4611), 1,
      anon_sym_LBRACE,
    ACTIONS(4615), 1,
      aux_sym_char_token1,
    ACTIONS(4617), 1,
      anon_sym_DOLLAR_DQUOTE,
    ACTIONS(4619), 1,
      anon_sym_DQUOTE,
    ACTIONS(4621), 1,
      anon_sym_AT_DQUOTE,
    ACTIONS(4623), 1,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(4625), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(4627), 1,
      sym_bool,
    ACTIONS(4629), 1,
      sym_unit,
    ACTIONS(4631), 1,
      sym_int,
    ACTIONS(4633), 1,
      sym_xint,
    STATE(2846), 1,
      aux_sym_argument_patterns_repeat1,
    STATE(3887), 1,
      sym_float,
    STATE(4141), 1,
      sym__atomic_pattern,
    STATE(4166), 1,
      sym_format_triple_quoted_string,
    STATE(6005), 1,
      sym__property_accessor_body,
    STATE(6118), 1,
      sym_argument_patterns,
    ACTIONS(4605), 2,
      anon_sym_null,
      anon_sym__,
    STATE(4160), 2,
      sym_format_string,
      sym__string_literal,
    STATE(2849), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4163), 5,
      sym_list_pattern,
      sym_array_pattern,
      sym_record_pattern,
      sym_const,
      sym_long_identifier,
    STATE(4152), 20,
      sym_char,
      sym_string,
      sym_verbatim_string,
      sym_bytearray,
      sym_verbatim_bytearray,
      sym_triple_quoted_string,
      sym_sbyte,
      sym_byte,
      sym_int16,
      sym_uint16,
      sym_int32,
      sym_uint32,
      sym_nativeint,
      sym_unativeint,
      sym_int64,
      sym_uint64,
      sym_ieee32,
      sym_ieee64,
      sym_bignum,
      sym_decimal,
  [642] = 32,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4601), 1,
      sym_identifier,
    ACTIONS(4603), 1,
      anon_sym_LPAREN,
    ACTIONS(4607), 1,
      anon_sym_LBRACK,
    ACTIONS(4609), 1,
      anon_sym_LBRACK_PIPE,
    ACTIONS(4611), 1,
      anon_sym_LBRACE,
    ACTIONS(4615), 1,
      aux_sym_char_token1,
    ACTIONS(4617), 1,
      anon_sym_DOLLAR_DQUOTE,
    ACTIONS(4619), 1,
      anon_sym_DQUOTE,
    ACTIONS(4621), 1,
      anon_sym_AT_DQUOTE,
    ACTIONS(4623), 1,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(4625), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(4627), 1,
      sym_bool,
    ACTIONS(4629), 1,
      sym_unit,
    ACTIONS(4631), 1,
      sym_int,
    ACTIONS(4633), 1,
      sym_xint,
    STATE(2846), 1,
      aux_sym_argument_patterns_repeat1,
    STATE(3887), 1,
      sym_float,
    STATE(4141), 1,
      sym__atomic_pattern,
    STATE(4166), 1,
      sym_format_triple_quoted_string,
    STATE(6393), 1,
      sym_argument_patterns,
    ACTIONS(4605), 2,
      anon_sym_null,
      anon_sym__,
    STATE(4160), 2,
      sym_format_string,
      sym__string_literal,
    STATE(2850), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4163), 5,
      sym_list_pattern,
      sym_array_pattern,
      sym_record_pattern,
      sym_const,
      sym_long_identifier,
    STATE(4152), 20,
      sym_char,
      sym_string,
      sym_verbatim_string,
      sym_bytearray,
      sym_verbatim_bytearray,
      sym_triple_quoted_string,
      sym_sbyte,
      sym_byte,
      sym_int16,
      sym_uint16,
      sym_int32,
      sym_uint32,
      sym_nativeint,
      sym_unativeint,
      sym_int64,
      sym_uint64,
      sym_ieee32,
      sym_ieee64,
      sym_bignum,
      sym_decimal,
  [767] = 32,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4601), 1,
      sym_identifier,
    ACTIONS(4603), 1,
      anon_sym_LPAREN,
    ACTIONS(4607), 1,
      anon_sym_LBRACK,
    ACTIONS(4609), 1,
      anon_sym_LBRACK_PIPE,
    ACTIONS(4611), 1,
      anon_sym_LBRACE,
    ACTIONS(4615), 1,
      aux_sym_char_token1,
    ACTIONS(4617), 1,
      anon_sym_DOLLAR_DQUOTE,
    ACTIONS(4619), 1,
      anon_sym_DQUOTE,
    ACTIONS(4621), 1,
      anon_sym_AT_DQUOTE,
    ACTIONS(4623), 1,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(4625), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(4627), 1,
      sym_bool,
    ACTIONS(4629), 1,
      sym_unit,
    ACTIONS(4631), 1,
      sym_int,
    ACTIONS(4633), 1,
      sym_xint,
    STATE(2846), 1,
      aux_sym_argument_patterns_repeat1,
    STATE(3887), 1,
      sym_float,
    STATE(4141), 1,
      sym__atomic_pattern,
    STATE(4166), 1,
      sym_format_triple_quoted_string,
    STATE(6878), 1,
      sym_argument_patterns,
    ACTIONS(4605), 2,
      anon_sym_null,
      anon_sym__,
    STATE(4160), 2,
      sym_format_string,
      sym__string_literal,
    STATE(2851), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4163), 5,
      sym_list_pattern,
      sym_array_pattern,
      sym_record_pattern,
      sym_const,
      sym_long_identifier,
    STATE(4152), 20,
      sym_char,
      sym_string,
      sym_verbatim_string,
      sym_bytearray,
      sym_verbatim_bytearray,
      sym_triple_quoted_string,
      sym_sbyte,
      sym_byte,
      sym_int16,
      sym_uint16,
      sym_int32,
      sym_uint32,
      sym_nativeint,
      sym_unativeint,
      sym_int64,
      sym_uint64,
      sym_ieee32,
      sym_ieee64,
      sym_bignum,
      sym_decimal,
  [892] = 32,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4601), 1,
      sym_identifier,
    ACTIONS(4603), 1,
      anon_sym_LPAREN,
    ACTIONS(4607), 1,
      anon_sym_LBRACK,
    ACTIONS(4609), 1,
      anon_sym_LBRACK_PIPE,
    ACTIONS(4611), 1,
      anon_sym_LBRACE,
    ACTIONS(4615), 1,
      aux_sym_char_token1,
    ACTIONS(4617), 1,
      anon_sym_DOLLAR_DQUOTE,
    ACTIONS(4619), 1,
      anon_sym_DQUOTE,
    ACTIONS(4621), 1,
      anon_sym_AT_DQUOTE,
    ACTIONS(4623), 1,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(4625), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(4627), 1,
      sym_bool,
    ACTIONS(4629), 1,
      sym_unit,
    ACTIONS(4631), 1,
      sym_int,
    ACTIONS(4633), 1,
      sym_xint,
    STATE(2846), 1,
      aux_sym_argument_patterns_repeat1,
    STATE(3887), 1,
      sym_float,
    STATE(4141), 1,
      sym__atomic_pattern,
    STATE(4166), 1,
      sym_format_triple_quoted_string,
    STATE(6402), 1,
      sym_argument_patterns,
    ACTIONS(4605), 2,
      anon_sym_null,
      anon_sym__,
    STATE(4160), 2,
      sym_format_string,
      sym__string_literal,
    STATE(2852), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4163), 5,
      sym_list_pattern,
      sym_array_pattern,
      sym_record_pattern,
      sym_const,
      sym_long_identifier,
    STATE(4152), 20,
      sym_char,
      sym_string,
      sym_verbatim_string,
      sym_bytearray,
      sym_verbatim_bytearray,
      sym_triple_quoted_string,
      sym_sbyte,
      sym_byte,
      sym_int16,
      sym_uint16,
      sym_int32,
      sym_uint32,
      sym_nativeint,
      sym_unativeint,
      sym_int64,
      sym_uint64,
      sym_ieee32,
      sym_ieee64,
      sym_bignum,
      sym_decimal,
  [1017] = 32,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4601), 1,
      sym_identifier,
    ACTIONS(4603), 1,
      anon_sym_LPAREN,
    ACTIONS(4607), 1,
      anon_sym_LBRACK,
    ACTIONS(4609), 1,
      anon_sym_LBRACK_PIPE,
    ACTIONS(4611), 1,
      anon_sym_LBRACE,
    ACTIONS(4615), 1,
      aux_sym_char_token1,
    ACTIONS(4617), 1,
      anon_sym_DOLLAR_DQUOTE,
    ACTIONS(4619), 1,
      anon_sym_DQUOTE,
    ACTIONS(4621), 1,
      anon_sym_AT_DQUOTE,
    ACTIONS(4623), 1,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(4625), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(4627), 1,
      sym_bool,
    ACTIONS(4629), 1,
      sym_unit,
    ACTIONS(4631), 1,
      sym_int,
    ACTIONS(4633), 1,
      sym_xint,
    STATE(2846), 1,
      aux_sym_argument_patterns_repeat1,
    STATE(3887), 1,
      sym_float,
    STATE(4141), 1,
      sym__atomic_pattern,
    STATE(4166), 1,
      sym_format_triple_quoted_string,
    STATE(6838), 1,
      sym_argument_patterns,
    ACTIONS(4605), 2,
      anon_sym_null,
      anon_sym__,
    STATE(4160), 2,
      sym_format_string,
      sym__string_literal,
    STATE(2853), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4163), 5,
      sym_list_pattern,
      sym_array_pattern,
      sym_record_pattern,
      sym_const,
      sym_long_identifier,
    STATE(4152), 20,
      sym_char,
      sym_string,
      sym_verbatim_string,
      sym_bytearray,
      sym_verbatim_bytearray,
      sym_triple_quoted_string,
      sym_sbyte,
      sym_byte,
      sym_int16,
      sym_uint16,
      sym_int32,
      sym_uint32,
      sym_nativeint,
      sym_unativeint,
      sym_int64,
      sym_uint64,
      sym_ieee32,
      sym_ieee64,
      sym_bignum,
      sym_decimal,
  [1142] = 32,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4601), 1,
      sym_identifier,
    ACTIONS(4603), 1,
      anon_sym_LPAREN,
    ACTIONS(4607), 1,
      anon_sym_LBRACK,
    ACTIONS(4609), 1,
      anon_sym_LBRACK_PIPE,
    ACTIONS(4611), 1,
      anon_sym_LBRACE,
    ACTIONS(4615), 1,
      aux_sym_char_token1,
    ACTIONS(4617), 1,
      anon_sym_DOLLAR_DQUOTE,
    ACTIONS(4619), 1,
      anon_sym_DQUOTE,
    ACTIONS(4621), 1,
      anon_sym_AT_DQUOTE,
    ACTIONS(4623), 1,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(4625), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(4627), 1,
      sym_bool,
    ACTIONS(4629), 1,
      sym_unit,
    ACTIONS(4631), 1,
      sym_int,
    ACTIONS(4633), 1,
      sym_xint,
    STATE(2846), 1,
      aux_sym_argument_patterns_repeat1,
    STATE(3887), 1,
      sym_float,
    STATE(4141), 1,
      sym__atomic_pattern,
    STATE(4166), 1,
      sym_format_triple_quoted_string,
    STATE(6712), 1,
      sym_argument_patterns,
    ACTIONS(4605), 2,
      anon_sym_null,
      anon_sym__,
    STATE(4160), 2,
      sym_format_string,
      sym__string_literal,
    STATE(2854), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4163), 5,
      sym_list_pattern,
      sym_array_pattern,
      sym_record_pattern,
      sym_const,
      sym_long_identifier,
    STATE(4152), 20,
      sym_char,
      sym_string,
      sym_verbatim_string,
      sym_bytearray,
      sym_verbatim_bytearray,
      sym_triple_quoted_string,
      sym_sbyte,
      sym_byte,
      sym_int16,
      sym_uint16,
      sym_int32,
      sym_uint32,
      sym_nativeint,
      sym_unativeint,
      sym_int64,
      sym_uint64,
      sym_ieee32,
      sym_ieee64,
      sym_bignum,
      sym_decimal,
  [1267] = 32,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4601), 1,
      sym_identifier,
    ACTIONS(4603), 1,
      anon_sym_LPAREN,
    ACTIONS(4607), 1,
      anon_sym_LBRACK,
    ACTIONS(4609), 1,
      anon_sym_LBRACK_PIPE,
    ACTIONS(4611), 1,
      anon_sym_LBRACE,
    ACTIONS(4615), 1,
      aux_sym_char_token1,
    ACTIONS(4617), 1,
      anon_sym_DOLLAR_DQUOTE,
    ACTIONS(4619), 1,
      anon_sym_DQUOTE,
    ACTIONS(4621), 1,
      anon_sym_AT_DQUOTE,
    ACTIONS(4623), 1,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(4625), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(4627), 1,
      sym_bool,
    ACTIONS(4629), 1,
      sym_unit,
    ACTIONS(4631), 1,
      sym_int,
    ACTIONS(4633), 1,
      sym_xint,
    STATE(2846), 1,
      aux_sym_argument_patterns_repeat1,
    STATE(3887), 1,
      sym_float,
    STATE(4141), 1,
      sym__atomic_pattern,
    STATE(4166), 1,
      sym_format_triple_quoted_string,
    STATE(6517), 1,
      sym_argument_patterns,
    ACTIONS(4605), 2,
      anon_sym_null,
      anon_sym__,
    STATE(4160), 2,
      sym_format_string,
      sym__string_literal,
    STATE(2855), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4163), 5,
      sym_list_pattern,
      sym_array_pattern,
      sym_record_pattern,
      sym_const,
      sym_long_identifier,
    STATE(4152), 20,
      sym_char,
      sym_string,
      sym_verbatim_string,
      sym_bytearray,
      sym_verbatim_bytearray,
      sym_triple_quoted_string,
      sym_sbyte,
      sym_byte,
      sym_int16,
      sym_uint16,
      sym_int32,
      sym_uint32,
      sym_nativeint,
      sym_unativeint,
      sym_int64,
      sym_uint64,
      sym_ieee32,
      sym_ieee64,
      sym_bignum,
      sym_decimal,
  [1392] = 32,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4601), 1,
      sym_identifier,
    ACTIONS(4603), 1,
      anon_sym_LPAREN,
    ACTIONS(4607), 1,
      anon_sym_LBRACK,
    ACTIONS(4609), 1,
      anon_sym_LBRACK_PIPE,
    ACTIONS(4611), 1,
      anon_sym_LBRACE,
    ACTIONS(4615), 1,
      aux_sym_char_token1,
    ACTIONS(4617), 1,
      anon_sym_DOLLAR_DQUOTE,
    ACTIONS(4619), 1,
      anon_sym_DQUOTE,
    ACTIONS(4621), 1,
      anon_sym_AT_DQUOTE,
    ACTIONS(4623), 1,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(4625), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(4627), 1,
      sym_bool,
    ACTIONS(4629), 1,
      sym_unit,
    ACTIONS(4631), 1,
      sym_int,
    ACTIONS(4633), 1,
      sym_xint,
    STATE(2846), 1,
      aux_sym_argument_patterns_repeat1,
    STATE(3887), 1,
      sym_float,
    STATE(4141), 1,
      sym__atomic_pattern,
    STATE(4166), 1,
      sym_format_triple_quoted_string,
    STATE(6664), 1,
      sym_argument_patterns,
    ACTIONS(4605), 2,
      anon_sym_null,
      anon_sym__,
    STATE(4160), 2,
      sym_format_string,
      sym__string_literal,
    STATE(2856), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4163), 5,
      sym_list_pattern,
      sym_array_pattern,
      sym_record_pattern,
      sym_const,
      sym_long_identifier,
    STATE(4152), 20,
      sym_char,
      sym_string,
      sym_verbatim_string,
      sym_bytearray,
      sym_verbatim_bytearray,
      sym_triple_quoted_string,
      sym_sbyte,
      sym_byte,
      sym_int16,
      sym_uint16,
      sym_int32,
      sym_uint32,
      sym_nativeint,
      sym_unativeint,
      sym_int64,
      sym_uint64,
      sym_ieee32,
      sym_ieee64,
      sym_bignum,
      sym_decimal,
  [1517] = 32,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4601), 1,
      sym_identifier,
    ACTIONS(4603), 1,
      anon_sym_LPAREN,
    ACTIONS(4607), 1,
      anon_sym_LBRACK,
    ACTIONS(4609), 1,
      anon_sym_LBRACK_PIPE,
    ACTIONS(4611), 1,
      anon_sym_LBRACE,
    ACTIONS(4615), 1,
      aux_sym_char_token1,
    ACTIONS(4617), 1,
      anon_sym_DOLLAR_DQUOTE,
    ACTIONS(4619), 1,
      anon_sym_DQUOTE,
    ACTIONS(4621), 1,
      anon_sym_AT_DQUOTE,
    ACTIONS(4623), 1,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(4625), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(4627), 1,
      sym_bool,
    ACTIONS(4629), 1,
      sym_unit,
    ACTIONS(4631), 1,
      sym_int,
    ACTIONS(4633), 1,
      sym_xint,
    STATE(2846), 1,
      aux_sym_argument_patterns_repeat1,
    STATE(3887), 1,
      sym_float,
    STATE(4141), 1,
      sym__atomic_pattern,
    STATE(4166), 1,
      sym_format_triple_quoted_string,
    STATE(6462), 1,
      sym_argument_patterns,
    ACTIONS(4605), 2,
      anon_sym_null,
      anon_sym__,
    STATE(4160), 2,
      sym_format_string,
      sym__string_literal,
    STATE(2857), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4163), 5,
      sym_list_pattern,
      sym_array_pattern,
      sym_record_pattern,
      sym_const,
      sym_long_identifier,
    STATE(4152), 20,
      sym_char,
      sym_string,
      sym_verbatim_string,
      sym_bytearray,
      sym_verbatim_bytearray,
      sym_triple_quoted_string,
      sym_sbyte,
      sym_byte,
      sym_int16,
      sym_uint16,
      sym_int32,
      sym_uint32,
      sym_nativeint,
      sym_unativeint,
      sym_int64,
      sym_uint64,
      sym_ieee32,
      sym_ieee64,
      sym_bignum,
      sym_decimal,
  [1642] = 32,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4601), 1,
      sym_identifier,
    ACTIONS(4603), 1,
      anon_sym_LPAREN,
    ACTIONS(4607), 1,
      anon_sym_LBRACK,
    ACTIONS(4609), 1,
      anon_sym_LBRACK_PIPE,
    ACTIONS(4611), 1,
      anon_sym_LBRACE,
    ACTIONS(4615), 1,
      aux_sym_char_token1,
    ACTIONS(4617), 1,
      anon_sym_DOLLAR_DQUOTE,
    ACTIONS(4619), 1,
      anon_sym_DQUOTE,
    ACTIONS(4621), 1,
      anon_sym_AT_DQUOTE,
    ACTIONS(4623), 1,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(4625), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(4627), 1,
      sym_bool,
    ACTIONS(4629), 1,
      sym_unit,
    ACTIONS(4631), 1,
      sym_int,
    ACTIONS(4633), 1,
      sym_xint,
    STATE(2846), 1,
      aux_sym_argument_patterns_repeat1,
    STATE(3887), 1,
      sym_float,
    STATE(4141), 1,
      sym__atomic_pattern,
    STATE(4166), 1,
      sym_format_triple_quoted_string,
    STATE(6149), 1,
      sym_argument_patterns,
    ACTIONS(4605), 2,
      anon_sym_null,
      anon_sym__,
    STATE(4160), 2,
      sym_format_string,
      sym__string_literal,
    STATE(2858), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4163), 5,
      sym_list_pattern,
      sym_array_pattern,
      sym_record_pattern,
      sym_const,
      sym_long_identifier,
    STATE(4152), 20,
      sym_char,
      sym_string,
      sym_verbatim_string,
      sym_bytearray,
      sym_verbatim_bytearray,
      sym_triple_quoted_string,
      sym_sbyte,
      sym_byte,
      sym_int16,
      sym_uint16,
      sym_int32,
      sym_uint32,
      sym_nativeint,
      sym_unativeint,
      sym_int64,
      sym_uint64,
      sym_ieee32,
      sym_ieee64,
      sym_bignum,
      sym_decimal,
  [1767] = 32,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4601), 1,
      sym_identifier,
    ACTIONS(4603), 1,
      anon_sym_LPAREN,
    ACTIONS(4607), 1,
      anon_sym_LBRACK,
    ACTIONS(4609), 1,
      anon_sym_LBRACK_PIPE,
    ACTIONS(4611), 1,
      anon_sym_LBRACE,
    ACTIONS(4615), 1,
      aux_sym_char_token1,
    ACTIONS(4617), 1,
      anon_sym_DOLLAR_DQUOTE,
    ACTIONS(4619), 1,
      anon_sym_DQUOTE,
    ACTIONS(4621), 1,
      anon_sym_AT_DQUOTE,
    ACTIONS(4623), 1,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(4625), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(4627), 1,
      sym_bool,
    ACTIONS(4629), 1,
      sym_unit,
    ACTIONS(4631), 1,
      sym_int,
    ACTIONS(4633), 1,
      sym_xint,
    STATE(2846), 1,
      aux_sym_argument_patterns_repeat1,
    STATE(3887), 1,
      sym_float,
    STATE(4141), 1,
      sym__atomic_pattern,
    STATE(4166), 1,
      sym_format_triple_quoted_string,
    STATE(6758), 1,
      sym_argument_patterns,
    ACTIONS(4605), 2,
      anon_sym_null,
      anon_sym__,
    STATE(4160), 2,
      sym_format_string,
      sym__string_literal,
    STATE(2859), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4163), 5,
      sym_list_pattern,
      sym_array_pattern,
      sym_record_pattern,
      sym_const,
      sym_long_identifier,
    STATE(4152), 20,
      sym_char,
      sym_string,
      sym_verbatim_string,
      sym_bytearray,
      sym_verbatim_bytearray,
      sym_triple_quoted_string,
      sym_sbyte,
      sym_byte,
      sym_int16,
      sym_uint16,
      sym_int32,
      sym_uint32,
      sym_nativeint,
      sym_unativeint,
      sym_int64,
      sym_uint64,
      sym_ieee32,
      sym_ieee64,
      sym_bignum,
      sym_decimal,
  [1892] = 32,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4601), 1,
      sym_identifier,
    ACTIONS(4603), 1,
      anon_sym_LPAREN,
    ACTIONS(4607), 1,
      anon_sym_LBRACK,
    ACTIONS(4609), 1,
      anon_sym_LBRACK_PIPE,
    ACTIONS(4611), 1,
      anon_sym_LBRACE,
    ACTIONS(4615), 1,
      aux_sym_char_token1,
    ACTIONS(4617), 1,
      anon_sym_DOLLAR_DQUOTE,
    ACTIONS(4619), 1,
      anon_sym_DQUOTE,
    ACTIONS(4621), 1,
      anon_sym_AT_DQUOTE,
    ACTIONS(4623), 1,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(4625), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(4627), 1,
      sym_bool,
    ACTIONS(4629), 1,
      sym_unit,
    ACTIONS(4631), 1,
      sym_int,
    ACTIONS(4633), 1,
      sym_xint,
    STATE(2846), 1,
      aux_sym_argument_patterns_repeat1,
    STATE(3887), 1,
      sym_float,
    STATE(4141), 1,
      sym__atomic_pattern,
    STATE(4166), 1,
      sym_format_triple_quoted_string,
    STATE(6798), 1,
      sym_argument_patterns,
    ACTIONS(4605), 2,
      anon_sym_null,
      anon_sym__,
    STATE(4160), 2,
      sym_format_string,
      sym__string_literal,
    STATE(2860), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4163), 5,
      sym_list_pattern,
      sym_array_pattern,
      sym_record_pattern,
      sym_const,
      sym_long_identifier,
    STATE(4152), 20,
      sym_char,
      sym_string,
      sym_verbatim_string,
      sym_bytearray,
      sym_verbatim_bytearray,
      sym_triple_quoted_string,
      sym_sbyte,
      sym_byte,
      sym_int16,
      sym_uint16,
      sym_int32,
      sym_uint32,
      sym_nativeint,
      sym_unativeint,
      sym_int64,
      sym_uint64,
      sym_ieee32,
      sym_ieee64,
      sym_bignum,
      sym_decimal,
  [2017] = 32,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4601), 1,
      sym_identifier,
    ACTIONS(4603), 1,
      anon_sym_LPAREN,
    ACTIONS(4607), 1,
      anon_sym_LBRACK,
    ACTIONS(4609), 1,
      anon_sym_LBRACK_PIPE,
    ACTIONS(4611), 1,
      anon_sym_LBRACE,
    ACTIONS(4615), 1,
      aux_sym_char_token1,
    ACTIONS(4617), 1,
      anon_sym_DOLLAR_DQUOTE,
    ACTIONS(4619), 1,
      anon_sym_DQUOTE,
    ACTIONS(4621), 1,
      anon_sym_AT_DQUOTE,
    ACTIONS(4623), 1,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(4625), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(4627), 1,
      sym_bool,
    ACTIONS(4629), 1,
      sym_unit,
    ACTIONS(4631), 1,
      sym_int,
    ACTIONS(4633), 1,
      sym_xint,
    STATE(2846), 1,
      aux_sym_argument_patterns_repeat1,
    STATE(3887), 1,
      sym_float,
    STATE(4141), 1,
      sym__atomic_pattern,
    STATE(4166), 1,
      sym_format_triple_quoted_string,
    STATE(6567), 1,
      sym_argument_patterns,
    ACTIONS(4605), 2,
      anon_sym_null,
      anon_sym__,
    STATE(4160), 2,
      sym_format_string,
      sym__string_literal,
    STATE(2861), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4163), 5,
      sym_list_pattern,
      sym_array_pattern,
      sym_record_pattern,
      sym_const,
      sym_long_identifier,
    STATE(4152), 20,
      sym_char,
      sym_string,
      sym_verbatim_string,
      sym_bytearray,
      sym_verbatim_bytearray,
      sym_triple_quoted_string,
      sym_sbyte,
      sym_byte,
      sym_int16,
      sym_uint16,
      sym_int32,
      sym_uint32,
      sym_nativeint,
      sym_unativeint,
      sym_int64,
      sym_uint64,
      sym_ieee32,
      sym_ieee64,
      sym_bignum,
      sym_decimal,
  [2142] = 32,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4601), 1,
      sym_identifier,
    ACTIONS(4603), 1,
      anon_sym_LPAREN,
    ACTIONS(4607), 1,
      anon_sym_LBRACK,
    ACTIONS(4609), 1,
      anon_sym_LBRACK_PIPE,
    ACTIONS(4611), 1,
      anon_sym_LBRACE,
    ACTIONS(4615), 1,
      aux_sym_char_token1,
    ACTIONS(4617), 1,
      anon_sym_DOLLAR_DQUOTE,
    ACTIONS(4619), 1,
      anon_sym_DQUOTE,
    ACTIONS(4621), 1,
      anon_sym_AT_DQUOTE,
    ACTIONS(4623), 1,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(4625), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(4627), 1,
      sym_bool,
    ACTIONS(4629), 1,
      sym_unit,
    ACTIONS(4631), 1,
      sym_int,
    ACTIONS(4633), 1,
      sym_xint,
    STATE(2846), 1,
      aux_sym_argument_patterns_repeat1,
    STATE(3887), 1,
      sym_float,
    STATE(4141), 1,
      sym__atomic_pattern,
    STATE(4166), 1,
      sym_format_triple_quoted_string,
    STATE(6616), 1,
      sym_argument_patterns,
    ACTIONS(4605), 2,
      anon_sym_null,
      anon_sym__,
    STATE(4160), 2,
      sym_format_string,
      sym__string_literal,
    STATE(2862), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4163), 5,
      sym_list_pattern,
      sym_array_pattern,
      sym_record_pattern,
      sym_const,
      sym_long_identifier,
    STATE(4152), 20,
      sym_char,
      sym_string,
      sym_verbatim_string,
      sym_bytearray,
      sym_verbatim_bytearray,
      sym_triple_quoted_string,
      sym_sbyte,
      sym_byte,
      sym_int16,
      sym_uint16,
      sym_int32,
      sym_uint32,
      sym_nativeint,
      sym_unativeint,
      sym_int64,
      sym_uint64,
      sym_ieee32,
      sym_ieee64,
      sym_bignum,
      sym_decimal,
  [2267] = 32,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4601), 1,
      sym_identifier,
    ACTIONS(4603), 1,
      anon_sym_LPAREN,
    ACTIONS(4607), 1,
      anon_sym_LBRACK,
    ACTIONS(4609), 1,
      anon_sym_LBRACK_PIPE,
    ACTIONS(4611), 1,
      anon_sym_LBRACE,
    ACTIONS(4615), 1,
      aux_sym_char_token1,
    ACTIONS(4617), 1,
      anon_sym_DOLLAR_DQUOTE,
    ACTIONS(4619), 1,
      anon_sym_DQUOTE,
    ACTIONS(4621), 1,
      anon_sym_AT_DQUOTE,
    ACTIONS(4623), 1,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(4625), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(4627), 1,
      sym_bool,
    ACTIONS(4629), 1,
      sym_unit,
    ACTIONS(4631), 1,
      sym_int,
    ACTIONS(4633), 1,
      sym_xint,
    STATE(2846), 1,
      aux_sym_argument_patterns_repeat1,
    STATE(3887), 1,
      sym_float,
    STATE(4141), 1,
      sym__atomic_pattern,
    STATE(4166), 1,
      sym_format_triple_quoted_string,
    STATE(6284), 1,
      sym_argument_patterns,
    ACTIONS(4605), 2,
      anon_sym_null,
      anon_sym__,
    STATE(4160), 2,
      sym_format_string,
      sym__string_literal,
    STATE(2863), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4163), 5,
      sym_list_pattern,
      sym_array_pattern,
      sym_record_pattern,
      sym_const,
      sym_long_identifier,
    STATE(4152), 20,
      sym_char,
      sym_string,
      sym_verbatim_string,
      sym_bytearray,
      sym_verbatim_bytearray,
      sym_triple_quoted_string,
      sym_sbyte,
      sym_byte,
      sym_int16,
      sym_uint16,
      sym_int32,
      sym_uint32,
      sym_nativeint,
      sym_unativeint,
      sym_int64,
      sym_uint64,
      sym_ieee32,
      sym_ieee64,
      sym_bignum,
      sym_decimal,
  [2392] = 32,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4601), 1,
      sym_identifier,
    ACTIONS(4603), 1,
      anon_sym_LPAREN,
    ACTIONS(4607), 1,
      anon_sym_LBRACK,
    ACTIONS(4609), 1,
      anon_sym_LBRACK_PIPE,
    ACTIONS(4611), 1,
      anon_sym_LBRACE,
    ACTIONS(4615), 1,
      aux_sym_char_token1,
    ACTIONS(4617), 1,
      anon_sym_DOLLAR_DQUOTE,
    ACTIONS(4619), 1,
      anon_sym_DQUOTE,
    ACTIONS(4621), 1,
      anon_sym_AT_DQUOTE,
    ACTIONS(4623), 1,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(4625), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(4627), 1,
      sym_bool,
    ACTIONS(4629), 1,
      sym_unit,
    ACTIONS(4631), 1,
      sym_int,
    ACTIONS(4633), 1,
      sym_xint,
    STATE(2846), 1,
      aux_sym_argument_patterns_repeat1,
    STATE(3887), 1,
      sym_float,
    STATE(4141), 1,
      sym__atomic_pattern,
    STATE(4166), 1,
      sym_format_triple_quoted_string,
    STATE(7045), 1,
      sym_argument_patterns,
    ACTIONS(4605), 2,
      anon_sym_null,
      anon_sym__,
    STATE(4160), 2,
      sym_format_string,
      sym__string_literal,
    STATE(2864), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4163), 5,
      sym_list_pattern,
      sym_array_pattern,
      sym_record_pattern,
      sym_const,
      sym_long_identifier,
    STATE(4152), 20,
      sym_char,
      sym_string,
      sym_verbatim_string,
      sym_bytearray,
      sym_verbatim_bytearray,
      sym_triple_quoted_string,
      sym_sbyte,
      sym_byte,
      sym_int16,
      sym_uint16,
      sym_int32,
      sym_uint32,
      sym_nativeint,
      sym_unativeint,
      sym_int64,
      sym_uint64,
      sym_ieee32,
      sym_ieee64,
      sym_bignum,
      sym_decimal,
  [2517] = 24,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(4789), 1,
      anon_sym_y,
    ACTIONS(4791), 1,
      anon_sym_uy,
    ACTIONS(4793), 1,
      anon_sym_s,
    ACTIONS(4795), 1,
      anon_sym_us,
    ACTIONS(4797), 1,
      anon_sym_l,
    ACTIONS(4799), 1,
      aux_sym_uint32_token1,
    ACTIONS(4801), 1,
      anon_sym_n,
    ACTIONS(4803), 1,
      anon_sym_un,
    ACTIONS(4805), 1,
      anon_sym_L,
    ACTIONS(4807), 1,
      aux_sym_uint64_token1,
    ACTIONS(4809), 1,
      aux_sym_bignum_token1,
    ACTIONS(4811), 1,
      aux_sym_decimal_token1,
    ACTIONS(4813), 1,
      anon_sym_DOT2,
    ACTIONS(4815), 1,
      aux_sym_float_token1,
    STATE(2865), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2158), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2160), 19,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [2622] = 24,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(4817), 1,
      anon_sym_y,
    ACTIONS(4819), 1,
      anon_sym_uy,
    ACTIONS(4821), 1,
      anon_sym_s,
    ACTIONS(4823), 1,
      anon_sym_us,
    ACTIONS(4825), 1,
      anon_sym_l,
    ACTIONS(4827), 1,
      aux_sym_uint32_token1,
    ACTIONS(4829), 1,
      anon_sym_n,
    ACTIONS(4831), 1,
      anon_sym_un,
    ACTIONS(4833), 1,
      anon_sym_L,
    ACTIONS(4835), 1,
      aux_sym_uint64_token1,
    ACTIONS(4837), 1,
      aux_sym_bignum_token1,
    ACTIONS(4839), 1,
      aux_sym_decimal_token1,
    ACTIONS(4841), 1,
      anon_sym_DOT2,
    ACTIONS(4843), 1,
      aux_sym_float_token1,
    STATE(2866), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2158), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2160), 19,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [2727] = 24,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(4845), 1,
      anon_sym_y,
    ACTIONS(4847), 1,
      anon_sym_uy,
    ACTIONS(4849), 1,
      anon_sym_s,
    ACTIONS(4851), 1,
      anon_sym_us,
    ACTIONS(4853), 1,
      anon_sym_l,
    ACTIONS(4855), 1,
      aux_sym_uint32_token1,
    ACTIONS(4857), 1,
      anon_sym_n,
    ACTIONS(4859), 1,
      anon_sym_un,
    ACTIONS(4861), 1,
      anon_sym_L,
    ACTIONS(4863), 1,
      aux_sym_uint64_token1,
    ACTIONS(4865), 1,
      aux_sym_bignum_token1,
    ACTIONS(4867), 1,
      aux_sym_decimal_token1,
    ACTIONS(4869), 1,
      anon_sym_DOT2,
    ACTIONS(4871), 1,
      aux_sym_float_token1,
    STATE(2867), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2158), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2160), 18,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [2831] = 24,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(4873), 1,
      anon_sym_y,
    ACTIONS(4875), 1,
      anon_sym_uy,
    ACTIONS(4877), 1,
      anon_sym_s,
    ACTIONS(4879), 1,
      anon_sym_us,
    ACTIONS(4881), 1,
      anon_sym_l,
    ACTIONS(4883), 1,
      aux_sym_uint32_token1,
    ACTIONS(4885), 1,
      anon_sym_n,
    ACTIONS(4887), 1,
      anon_sym_un,
    ACTIONS(4889), 1,
      anon_sym_L,
    ACTIONS(4891), 1,
      aux_sym_uint64_token1,
    ACTIONS(4893), 1,
      aux_sym_bignum_token1,
    ACTIONS(4895), 1,
      aux_sym_decimal_token1,
    ACTIONS(4897), 1,
      anon_sym_DOT2,
    ACTIONS(4899), 1,
      aux_sym_float_token1,
    STATE(2868), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2158), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2160), 17,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [2935] = 22,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(4817), 1,
      anon_sym_y,
    ACTIONS(4819), 1,
      anon_sym_uy,
    ACTIONS(4821), 1,
      anon_sym_s,
    ACTIONS(4823), 1,
      anon_sym_us,
    ACTIONS(4825), 1,
      anon_sym_l,
    ACTIONS(4827), 1,
      aux_sym_uint32_token1,
    ACTIONS(4829), 1,
      anon_sym_n,
    ACTIONS(4831), 1,
      anon_sym_un,
    ACTIONS(4833), 1,
      anon_sym_L,
    ACTIONS(4835), 1,
      aux_sym_uint64_token1,
    ACTIONS(4901), 1,
      anon_sym_lf,
    ACTIONS(4903), 1,
      anon_sym_LF,
    STATE(2869), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2158), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2160), 19,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [3034] = 24,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(4905), 1,
      anon_sym_y,
    ACTIONS(4907), 1,
      anon_sym_uy,
    ACTIONS(4909), 1,
      anon_sym_s,
    ACTIONS(4911), 1,
      anon_sym_us,
    ACTIONS(4913), 1,
      anon_sym_l,
    ACTIONS(4915), 1,
      aux_sym_uint32_token1,
    ACTIONS(4917), 1,
      anon_sym_n,
    ACTIONS(4919), 1,
      anon_sym_un,
    ACTIONS(4921), 1,
      anon_sym_L,
    ACTIONS(4923), 1,
      aux_sym_uint64_token1,
    ACTIONS(4925), 1,
      aux_sym_bignum_token1,
    ACTIONS(4927), 1,
      aux_sym_decimal_token1,
    ACTIONS(4929), 1,
      anon_sym_DOT2,
    ACTIONS(4931), 1,
      aux_sym_float_token1,
    STATE(2870), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2158), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2160), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [3137] = 22,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(4789), 1,
      anon_sym_y,
    ACTIONS(4791), 1,
      anon_sym_uy,
    ACTIONS(4793), 1,
      anon_sym_s,
    ACTIONS(4795), 1,
      anon_sym_us,
    ACTIONS(4797), 1,
      anon_sym_l,
    ACTIONS(4799), 1,
      aux_sym_uint32_token1,
    ACTIONS(4801), 1,
      anon_sym_n,
    ACTIONS(4803), 1,
      anon_sym_un,
    ACTIONS(4805), 1,
      anon_sym_L,
    ACTIONS(4807), 1,
      aux_sym_uint64_token1,
    ACTIONS(4933), 1,
      anon_sym_lf,
    ACTIONS(4935), 1,
      anon_sym_LF,
    STATE(2871), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2158), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2160), 19,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [3236] = 22,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(4873), 1,
      anon_sym_y,
    ACTIONS(4875), 1,
      anon_sym_uy,
    ACTIONS(4877), 1,
      anon_sym_s,
    ACTIONS(4879), 1,
      anon_sym_us,
    ACTIONS(4881), 1,
      anon_sym_l,
    ACTIONS(4883), 1,
      aux_sym_uint32_token1,
    ACTIONS(4885), 1,
      anon_sym_n,
    ACTIONS(4887), 1,
      anon_sym_un,
    ACTIONS(4889), 1,
      anon_sym_L,
    ACTIONS(4891), 1,
      aux_sym_uint64_token1,
    ACTIONS(4937), 1,
      anon_sym_lf,
    ACTIONS(4939), 1,
      anon_sym_LF,
    STATE(2872), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2158), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2160), 17,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [3334] = 22,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(4845), 1,
      anon_sym_y,
    ACTIONS(4847), 1,
      anon_sym_uy,
    ACTIONS(4849), 1,
      anon_sym_s,
    ACTIONS(4851), 1,
      anon_sym_us,
    ACTIONS(4853), 1,
      anon_sym_l,
    ACTIONS(4855), 1,
      aux_sym_uint32_token1,
    ACTIONS(4857), 1,
      anon_sym_n,
    ACTIONS(4859), 1,
      anon_sym_un,
    ACTIONS(4861), 1,
      anon_sym_L,
    ACTIONS(4863), 1,
      aux_sym_uint64_token1,
    ACTIONS(4941), 1,
      anon_sym_lf,
    ACTIONS(4943), 1,
      anon_sym_LF,
    STATE(2873), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2158), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2160), 18,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [3432] = 22,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(4905), 1,
      anon_sym_y,
    ACTIONS(4907), 1,
      anon_sym_uy,
    ACTIONS(4909), 1,
      anon_sym_s,
    ACTIONS(4911), 1,
      anon_sym_us,
    ACTIONS(4913), 1,
      anon_sym_l,
    ACTIONS(4915), 1,
      aux_sym_uint32_token1,
    ACTIONS(4917), 1,
      anon_sym_n,
    ACTIONS(4919), 1,
      anon_sym_un,
    ACTIONS(4921), 1,
      anon_sym_L,
    ACTIONS(4923), 1,
      aux_sym_uint64_token1,
    ACTIONS(4945), 1,
      anon_sym_lf,
    ACTIONS(4947), 1,
      anon_sym_LF,
    STATE(2874), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2158), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2160), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [3529] = 20,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(4949), 1,
      sym_identifier,
    ACTIONS(4955), 1,
      anon_sym_DASH_GT,
    ACTIONS(4957), 1,
      anon_sym_when,
    ACTIONS(4959), 1,
      anon_sym_STAR,
    ACTIONS(4961), 1,
      anon_sym_LT2,
    ACTIONS(4963), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(2946), 1,
      aux_sym_compound_type_repeat1,
    STATE(3040), 1,
      sym_type_arguments,
    STATE(3087), 1,
      sym_long_identifier,
    STATE(3492), 1,
      sym_type_argument_constraints,
    STATE(2875), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4953), 11,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
    ACTIONS(4951), 19,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [3621] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(4965), 1,
      anon_sym_or,
    STATE(2876), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_type_argument_repeat1,
    ACTIONS(2340), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2342), 24,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [3694] = 18,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(4968), 1,
      sym_identifier,
    ACTIONS(4970), 1,
      anon_sym_DASH_GT,
    ACTIONS(4972), 1,
      anon_sym_STAR,
    ACTIONS(4974), 1,
      anon_sym_LT2,
    ACTIONS(4976), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(3002), 1,
      aux_sym_compound_type_repeat1,
    STATE(3052), 1,
      sym_type_arguments,
    STATE(3061), 1,
      sym_long_identifier,
    STATE(2877), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2250), 12,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
    ACTIONS(2248), 19,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [3781] = 18,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(4968), 1,
      sym_identifier,
    ACTIONS(4970), 1,
      anon_sym_DASH_GT,
    ACTIONS(4972), 1,
      anon_sym_STAR,
    ACTIONS(4974), 1,
      anon_sym_LT2,
    ACTIONS(4976), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(3002), 1,
      aux_sym_compound_type_repeat1,
    STATE(3052), 1,
      sym_type_arguments,
    STATE(3061), 1,
      sym_long_identifier,
    STATE(2878), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2230), 12,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
    ACTIONS(2228), 19,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [3868] = 20,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(4978), 1,
      sym_identifier,
    ACTIONS(4980), 1,
      anon_sym_DASH_GT,
    ACTIONS(4982), 1,
      anon_sym_when,
    ACTIONS(4984), 1,
      anon_sym_STAR,
    ACTIONS(4986), 1,
      anon_sym_LT2,
    ACTIONS(4988), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(3058), 1,
      aux_sym_compound_type_repeat1,
    STATE(3118), 1,
      sym_type_arguments,
    STATE(3124), 1,
      sym_long_identifier,
    STATE(3454), 1,
      sym_type_argument_constraints,
    STATE(2879), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4953), 11,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
    ACTIONS(4951), 18,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [3959] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(4990), 1,
      anon_sym_or,
    STATE(2884), 1,
      aux_sym_type_argument_repeat1,
    STATE(2880), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2321), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2323), 24,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [4034] = 18,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(4968), 1,
      sym_identifier,
    ACTIONS(4970), 1,
      anon_sym_DASH_GT,
    ACTIONS(4972), 1,
      anon_sym_STAR,
    ACTIONS(4974), 1,
      anon_sym_LT2,
    ACTIONS(4976), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(3002), 1,
      aux_sym_compound_type_repeat1,
    STATE(3052), 1,
      sym_type_arguments,
    STATE(3061), 1,
      sym_long_identifier,
    STATE(2881), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2246), 12,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
    ACTIONS(2244), 19,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [4121] = 18,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(4949), 1,
      sym_identifier,
    ACTIONS(4955), 1,
      anon_sym_DASH_GT,
    ACTIONS(4959), 1,
      anon_sym_STAR,
    ACTIONS(4961), 1,
      anon_sym_LT2,
    ACTIONS(4963), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(2946), 1,
      aux_sym_compound_type_repeat1,
    STATE(3040), 1,
      sym_type_arguments,
    STATE(3087), 1,
      sym_long_identifier,
    STATE(2882), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2246), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
    ACTIONS(2244), 19,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [4208] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(4992), 1,
      anon_sym_or,
    STATE(2890), 1,
      aux_sym_type_argument_repeat1,
    STATE(2883), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2321), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2323), 24,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [4283] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(4990), 1,
      anon_sym_or,
    STATE(2886), 1,
      aux_sym_type_argument_repeat1,
    STATE(2884), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2328), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2330), 24,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [4358] = 20,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(4994), 1,
      sym_identifier,
    ACTIONS(4996), 1,
      anon_sym_DASH_GT,
    ACTIONS(4998), 1,
      anon_sym_when,
    ACTIONS(5000), 1,
      anon_sym_STAR,
    ACTIONS(5002), 1,
      anon_sym_LT2,
    ACTIONS(5004), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(3086), 1,
      aux_sym_compound_type_repeat1,
    STATE(3146), 1,
      sym_type_arguments,
    STATE(3148), 1,
      sym_long_identifier,
    STATE(3628), 1,
      sym_type_argument_constraints,
    STATE(2885), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4953), 11,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
    ACTIONS(4951), 18,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [4449] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5006), 1,
      anon_sym_or,
    STATE(2886), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_type_argument_repeat1,
    ACTIONS(2340), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2342), 24,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [4522] = 18,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(4949), 1,
      sym_identifier,
    ACTIONS(4955), 1,
      anon_sym_DASH_GT,
    ACTIONS(4959), 1,
      anon_sym_STAR,
    ACTIONS(4961), 1,
      anon_sym_LT2,
    ACTIONS(4963), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(2946), 1,
      aux_sym_compound_type_repeat1,
    STATE(3040), 1,
      sym_type_arguments,
    STATE(3087), 1,
      sym_long_identifier,
    STATE(2887), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2242), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
    ACTIONS(2240), 19,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [4609] = 18,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(4949), 1,
      sym_identifier,
    ACTIONS(4955), 1,
      anon_sym_DASH_GT,
    ACTIONS(4959), 1,
      anon_sym_STAR,
    ACTIONS(4961), 1,
      anon_sym_LT2,
    ACTIONS(4963), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(2946), 1,
      aux_sym_compound_type_repeat1,
    STATE(3040), 1,
      sym_type_arguments,
    STATE(3087), 1,
      sym_long_identifier,
    STATE(2888), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2250), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
    ACTIONS(2248), 19,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [4696] = 18,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(4949), 1,
      sym_identifier,
    ACTIONS(4955), 1,
      anon_sym_DASH_GT,
    ACTIONS(4959), 1,
      anon_sym_STAR,
    ACTIONS(4961), 1,
      anon_sym_LT2,
    ACTIONS(4963), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(2946), 1,
      aux_sym_compound_type_repeat1,
    STATE(3040), 1,
      sym_type_arguments,
    STATE(3087), 1,
      sym_long_identifier,
    STATE(2889), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2230), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
    ACTIONS(2228), 19,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [4783] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(4992), 1,
      anon_sym_or,
    STATE(2876), 1,
      aux_sym_type_argument_repeat1,
    STATE(2890), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2328), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2330), 24,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [4858] = 18,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(4968), 1,
      sym_identifier,
    ACTIONS(4970), 1,
      anon_sym_DASH_GT,
    ACTIONS(4972), 1,
      anon_sym_STAR,
    ACTIONS(4974), 1,
      anon_sym_LT2,
    ACTIONS(4976), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(3002), 1,
      aux_sym_compound_type_repeat1,
    STATE(3052), 1,
      sym_type_arguments,
    STATE(3061), 1,
      sym_long_identifier,
    STATE(2891), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2242), 12,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
    ACTIONS(2240), 19,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [4945] = 17,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(4970), 1,
      anon_sym_DASH_GT,
    ACTIONS(4972), 1,
      anon_sym_STAR,
    ACTIONS(4974), 1,
      anon_sym_LT2,
    ACTIONS(4976), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(3002), 1,
      aux_sym_compound_type_repeat1,
    STATE(3052), 1,
      sym_type_arguments,
    STATE(3061), 1,
      sym_long_identifier,
    STATE(2892), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5009), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(5011), 19,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [5030] = 17,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(4970), 1,
      anon_sym_DASH_GT,
    ACTIONS(4972), 1,
      anon_sym_STAR,
    ACTIONS(4974), 1,
      anon_sym_LT2,
    ACTIONS(4976), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(3002), 1,
      aux_sym_compound_type_repeat1,
    STATE(3052), 1,
      sym_type_arguments,
    STATE(3061), 1,
      sym_long_identifier,
    STATE(2893), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5013), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(5015), 19,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [5115] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5017), 1,
      anon_sym_or,
    STATE(2944), 1,
      aux_sym_type_argument_repeat1,
    STATE(2894), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2328), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2330), 23,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [5189] = 18,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5019), 1,
      sym_identifier,
    ACTIONS(5021), 1,
      anon_sym_DASH_GT,
    ACTIONS(5023), 1,
      anon_sym_STAR,
    ACTIONS(5025), 1,
      anon_sym_LT2,
    ACTIONS(5027), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(3047), 1,
      aux_sym_compound_type_repeat1,
    STATE(3158), 1,
      sym_long_identifier,
    STATE(3175), 1,
      sym_type_arguments,
    STATE(2895), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2242), 11,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
    ACTIONS(2240), 19,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [5275] = 18,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5029), 1,
      sym_identifier,
    ACTIONS(5031), 1,
      anon_sym_DASH_GT,
    ACTIONS(5033), 1,
      anon_sym_STAR,
    ACTIONS(5035), 1,
      anon_sym_LT2,
    ACTIONS(5037), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(3105), 1,
      aux_sym_compound_type_repeat1,
    STATE(3161), 1,
      sym_long_identifier,
    STATE(3165), 1,
      sym_type_arguments,
    STATE(2896), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2250), 12,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
    ACTIONS(2248), 18,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [5361] = 18,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(4994), 1,
      sym_identifier,
    ACTIONS(4996), 1,
      anon_sym_DASH_GT,
    ACTIONS(5000), 1,
      anon_sym_STAR,
    ACTIONS(5002), 1,
      anon_sym_LT2,
    ACTIONS(5004), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(3086), 1,
      aux_sym_compound_type_repeat1,
    STATE(3146), 1,
      sym_type_arguments,
    STATE(3148), 1,
      sym_long_identifier,
    STATE(2897), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2230), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
    ACTIONS(2228), 18,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [5447] = 18,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5019), 1,
      sym_identifier,
    ACTIONS(5021), 1,
      anon_sym_DASH_GT,
    ACTIONS(5023), 1,
      anon_sym_STAR,
    ACTIONS(5025), 1,
      anon_sym_LT2,
    ACTIONS(5027), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(3047), 1,
      aux_sym_compound_type_repeat1,
    STATE(3158), 1,
      sym_long_identifier,
    STATE(3175), 1,
      sym_type_arguments,
    STATE(2898), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2246), 11,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
    ACTIONS(2244), 19,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [5533] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5039), 1,
      anon_sym_or,
    STATE(2930), 1,
      aux_sym_type_argument_repeat1,
    STATE(2899), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2328), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2330), 23,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [5607] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5041), 1,
      anon_sym_or,
    STATE(2933), 1,
      aux_sym_type_argument_repeat1,
    STATE(2900), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2328), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2330), 24,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [5681] = 17,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5031), 1,
      anon_sym_DASH_GT,
    ACTIONS(5033), 1,
      anon_sym_STAR,
    ACTIONS(5035), 1,
      anon_sym_LT2,
    ACTIONS(5037), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(3105), 1,
      aux_sym_compound_type_repeat1,
    STATE(3161), 1,
      sym_long_identifier,
    STATE(3165), 1,
      sym_type_arguments,
    STATE(2901), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5009), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(5011), 18,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [5765] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5043), 1,
      anon_sym_or,
    STATE(2902), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_type_argument_repeat1,
    ACTIONS(2340), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2342), 23,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [5837] = 18,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5029), 1,
      sym_identifier,
    ACTIONS(5031), 1,
      anon_sym_DASH_GT,
    ACTIONS(5033), 1,
      anon_sym_STAR,
    ACTIONS(5035), 1,
      anon_sym_LT2,
    ACTIONS(5037), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(3105), 1,
      aux_sym_compound_type_repeat1,
    STATE(3161), 1,
      sym_long_identifier,
    STATE(3165), 1,
      sym_type_arguments,
    STATE(2903), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2230), 12,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
    ACTIONS(2228), 18,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [5923] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(2904), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2462), 14,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_or,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2464), 24,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [5993] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5046), 1,
      anon_sym_or,
    STATE(2905), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_type_argument_repeat1,
    ACTIONS(2340), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2342), 23,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [6065] = 18,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(4978), 1,
      sym_identifier,
    ACTIONS(4980), 1,
      anon_sym_DASH_GT,
    ACTIONS(4984), 1,
      anon_sym_STAR,
    ACTIONS(4986), 1,
      anon_sym_LT2,
    ACTIONS(4988), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(3058), 1,
      aux_sym_compound_type_repeat1,
    STATE(3118), 1,
      sym_type_arguments,
    STATE(3124), 1,
      sym_long_identifier,
    STATE(2906), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2242), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
    ACTIONS(2240), 18,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [6151] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5049), 1,
      anon_sym_DOT,
    STATE(2929), 1,
      aux_sym_long_identifier_repeat1,
    STATE(2907), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2312), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2314), 23,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [6225] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5017), 1,
      anon_sym_or,
    STATE(2894), 1,
      aux_sym_type_argument_repeat1,
    STATE(2908), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2321), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2323), 23,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [6299] = 17,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5031), 1,
      anon_sym_DASH_GT,
    ACTIONS(5033), 1,
      anon_sym_STAR,
    ACTIONS(5035), 1,
      anon_sym_LT2,
    ACTIONS(5037), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(3105), 1,
      aux_sym_compound_type_repeat1,
    STATE(3161), 1,
      sym_long_identifier,
    STATE(3165), 1,
      sym_type_arguments,
    STATE(2909), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5013), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(5015), 18,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [6383] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5051), 1,
      anon_sym_or,
    STATE(2905), 1,
      aux_sym_type_argument_repeat1,
    STATE(2910), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2328), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2330), 23,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [6457] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5053), 1,
      anon_sym_or,
    STATE(2914), 1,
      aux_sym_type_argument_repeat1,
    STATE(2911), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2321), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2323), 23,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [6531] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5039), 1,
      anon_sym_or,
    STATE(2899), 1,
      aux_sym_type_argument_repeat1,
    STATE(2912), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2321), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2323), 23,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [6605] = 18,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5019), 1,
      sym_identifier,
    ACTIONS(5021), 1,
      anon_sym_DASH_GT,
    ACTIONS(5023), 1,
      anon_sym_STAR,
    ACTIONS(5025), 1,
      anon_sym_LT2,
    ACTIONS(5027), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(3047), 1,
      aux_sym_compound_type_repeat1,
    STATE(3158), 1,
      sym_long_identifier,
    STATE(3175), 1,
      sym_type_arguments,
    STATE(2913), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5057), 11,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
    ACTIONS(5055), 19,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [6691] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5053), 1,
      anon_sym_or,
    STATE(2902), 1,
      aux_sym_type_argument_repeat1,
    STATE(2914), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2328), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2330), 23,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [6765] = 17,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5059), 1,
      anon_sym_DASH_GT,
    ACTIONS(5061), 1,
      anon_sym_STAR,
    ACTIONS(5063), 1,
      anon_sym_LT2,
    ACTIONS(5065), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(3089), 1,
      aux_sym_compound_type_repeat1,
    STATE(3186), 1,
      sym_long_identifier,
    STATE(3191), 1,
      sym_type_arguments,
    STATE(2915), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5009), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(5011), 18,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [6849] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(2916), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2340), 14,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_or,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2342), 24,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [6919] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(2917), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2462), 14,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_or,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2464), 24,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [6989] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5067), 1,
      anon_sym_DOT,
    STATE(2918), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_long_identifier_repeat1,
    ACTIONS(2411), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2413), 23,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [7061] = 18,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5059), 1,
      anon_sym_DASH_GT,
    ACTIONS(5061), 1,
      anon_sym_STAR,
    ACTIONS(5063), 1,
      anon_sym_LT2,
    ACTIONS(5065), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(5070), 1,
      sym_identifier,
    STATE(3089), 1,
      aux_sym_compound_type_repeat1,
    STATE(3186), 1,
      sym_long_identifier,
    STATE(3191), 1,
      sym_type_arguments,
    STATE(2919), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2230), 12,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
    ACTIONS(2228), 18,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [7147] = 18,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(4994), 1,
      sym_identifier,
    ACTIONS(4996), 1,
      anon_sym_DASH_GT,
    ACTIONS(5000), 1,
      anon_sym_STAR,
    ACTIONS(5002), 1,
      anon_sym_LT2,
    ACTIONS(5004), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(3086), 1,
      aux_sym_compound_type_repeat1,
    STATE(3146), 1,
      sym_type_arguments,
    STATE(3148), 1,
      sym_long_identifier,
    STATE(2920), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2250), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
    ACTIONS(2248), 18,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [7233] = 18,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5029), 1,
      sym_identifier,
    ACTIONS(5031), 1,
      anon_sym_DASH_GT,
    ACTIONS(5033), 1,
      anon_sym_STAR,
    ACTIONS(5035), 1,
      anon_sym_LT2,
    ACTIONS(5037), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(3105), 1,
      aux_sym_compound_type_repeat1,
    STATE(3161), 1,
      sym_long_identifier,
    STATE(3165), 1,
      sym_type_arguments,
    STATE(2921), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2242), 12,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
    ACTIONS(2240), 18,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [7319] = 17,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5059), 1,
      anon_sym_DASH_GT,
    ACTIONS(5061), 1,
      anon_sym_STAR,
    ACTIONS(5063), 1,
      anon_sym_LT2,
    ACTIONS(5065), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(3089), 1,
      aux_sym_compound_type_repeat1,
    STATE(3186), 1,
      sym_long_identifier,
    STATE(3191), 1,
      sym_type_arguments,
    STATE(2922), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5013), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(5015), 18,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [7403] = 18,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5059), 1,
      anon_sym_DASH_GT,
    ACTIONS(5061), 1,
      anon_sym_STAR,
    ACTIONS(5063), 1,
      anon_sym_LT2,
    ACTIONS(5065), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(5070), 1,
      sym_identifier,
    STATE(3089), 1,
      aux_sym_compound_type_repeat1,
    STATE(3186), 1,
      sym_long_identifier,
    STATE(3191), 1,
      sym_type_arguments,
    STATE(2923), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2250), 12,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
    ACTIONS(2248), 18,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [7489] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(2924), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2340), 14,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_or,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2342), 24,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [7559] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5072), 1,
      anon_sym_DOT,
    STATE(2925), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_long_identifier_repeat1,
    ACTIONS(2411), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2413), 23,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [7631] = 18,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5019), 1,
      sym_identifier,
    ACTIONS(5021), 1,
      anon_sym_DASH_GT,
    ACTIONS(5023), 1,
      anon_sym_STAR,
    ACTIONS(5025), 1,
      anon_sym_LT2,
    ACTIONS(5027), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(3047), 1,
      aux_sym_compound_type_repeat1,
    STATE(3158), 1,
      sym_long_identifier,
    STATE(3175), 1,
      sym_type_arguments,
    STATE(2926), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2230), 11,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
    ACTIONS(2228), 19,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [7717] = 18,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5059), 1,
      anon_sym_DASH_GT,
    ACTIONS(5061), 1,
      anon_sym_STAR,
    ACTIONS(5063), 1,
      anon_sym_LT2,
    ACTIONS(5065), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(5070), 1,
      sym_identifier,
    STATE(3089), 1,
      aux_sym_compound_type_repeat1,
    STATE(3186), 1,
      sym_long_identifier,
    STATE(3191), 1,
      sym_type_arguments,
    STATE(2927), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2246), 12,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
    ACTIONS(2244), 18,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [7803] = 18,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5019), 1,
      sym_identifier,
    ACTIONS(5021), 1,
      anon_sym_DASH_GT,
    ACTIONS(5023), 1,
      anon_sym_STAR,
    ACTIONS(5025), 1,
      anon_sym_LT2,
    ACTIONS(5027), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(3047), 1,
      aux_sym_compound_type_repeat1,
    STATE(3158), 1,
      sym_long_identifier,
    STATE(3175), 1,
      sym_type_arguments,
    STATE(2928), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2250), 11,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
    ACTIONS(2248), 19,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [7889] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5049), 1,
      anon_sym_DOT,
    STATE(2925), 1,
      aux_sym_long_identifier_repeat1,
    STATE(2929), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2418), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2420), 23,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [7963] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5075), 1,
      anon_sym_or,
    STATE(2930), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_type_argument_repeat1,
    ACTIONS(2340), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2342), 23,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [8035] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5051), 1,
      anon_sym_or,
    STATE(2910), 1,
      aux_sym_type_argument_repeat1,
    STATE(2931), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2321), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2323), 23,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [8109] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5041), 1,
      anon_sym_or,
    STATE(2900), 1,
      aux_sym_type_argument_repeat1,
    STATE(2932), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2321), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2323), 24,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [8183] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5078), 1,
      anon_sym_or,
    STATE(2933), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_type_argument_repeat1,
    ACTIONS(2340), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2342), 24,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [8255] = 18,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(4994), 1,
      sym_identifier,
    ACTIONS(4996), 1,
      anon_sym_DASH_GT,
    ACTIONS(5000), 1,
      anon_sym_STAR,
    ACTIONS(5002), 1,
      anon_sym_LT2,
    ACTIONS(5004), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(3086), 1,
      aux_sym_compound_type_repeat1,
    STATE(3146), 1,
      sym_type_arguments,
    STATE(3148), 1,
      sym_long_identifier,
    STATE(2934), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2246), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
    ACTIONS(2244), 18,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [8341] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5081), 1,
      anon_sym_DOT,
    STATE(2941), 1,
      aux_sym_long_identifier_repeat1,
    STATE(2935), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2312), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2314), 23,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [8415] = 18,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5059), 1,
      anon_sym_DASH_GT,
    ACTIONS(5061), 1,
      anon_sym_STAR,
    ACTIONS(5063), 1,
      anon_sym_LT2,
    ACTIONS(5065), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(5070), 1,
      sym_identifier,
    STATE(3089), 1,
      aux_sym_compound_type_repeat1,
    STATE(3186), 1,
      sym_long_identifier,
    STATE(3191), 1,
      sym_type_arguments,
    STATE(2936), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2242), 12,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
    ACTIONS(2240), 18,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [8501] = 18,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(4994), 1,
      sym_identifier,
    ACTIONS(4996), 1,
      anon_sym_DASH_GT,
    ACTIONS(5000), 1,
      anon_sym_STAR,
    ACTIONS(5002), 1,
      anon_sym_LT2,
    ACTIONS(5004), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(3086), 1,
      aux_sym_compound_type_repeat1,
    STATE(3146), 1,
      sym_type_arguments,
    STATE(3148), 1,
      sym_long_identifier,
    STATE(2937), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2242), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
    ACTIONS(2240), 18,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [8587] = 18,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(4978), 1,
      sym_identifier,
    ACTIONS(4980), 1,
      anon_sym_DASH_GT,
    ACTIONS(4984), 1,
      anon_sym_STAR,
    ACTIONS(4986), 1,
      anon_sym_LT2,
    ACTIONS(4988), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(3058), 1,
      aux_sym_compound_type_repeat1,
    STATE(3118), 1,
      sym_type_arguments,
    STATE(3124), 1,
      sym_long_identifier,
    STATE(2938), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2230), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
    ACTIONS(2228), 18,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [8673] = 20,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(4978), 1,
      sym_identifier,
    ACTIONS(4980), 1,
      anon_sym_DASH_GT,
    ACTIONS(4984), 1,
      anon_sym_STAR,
    ACTIONS(4986), 1,
      anon_sym_LT2,
    ACTIONS(4988), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(5083), 1,
      anon_sym_when,
    STATE(3058), 1,
      aux_sym_compound_type_repeat1,
    STATE(3118), 1,
      sym_type_arguments,
    STATE(3124), 1,
      sym_long_identifier,
    STATE(3454), 1,
      sym_type_argument_constraints,
    STATE(2939), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4953), 11,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
    ACTIONS(4951), 17,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [8763] = 20,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5085), 1,
      sym_identifier,
    ACTIONS(5087), 1,
      anon_sym_DASH_GT,
    ACTIONS(5089), 1,
      anon_sym_when,
    ACTIONS(5091), 1,
      anon_sym_STAR,
    ACTIONS(5093), 1,
      anon_sym_LT2,
    ACTIONS(5095), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(3133), 1,
      aux_sym_compound_type_repeat1,
    STATE(3257), 1,
      sym_long_identifier,
    STATE(3264), 1,
      sym_type_arguments,
    STATE(3763), 1,
      sym_type_argument_constraints,
    STATE(2940), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4953), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
    ACTIONS(4951), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [8853] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5081), 1,
      anon_sym_DOT,
    STATE(2918), 1,
      aux_sym_long_identifier_repeat1,
    STATE(2941), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2418), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2420), 23,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [8927] = 18,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(4978), 1,
      sym_identifier,
    ACTIONS(4980), 1,
      anon_sym_DASH_GT,
    ACTIONS(4984), 1,
      anon_sym_STAR,
    ACTIONS(4986), 1,
      anon_sym_LT2,
    ACTIONS(4988), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(3058), 1,
      aux_sym_compound_type_repeat1,
    STATE(3118), 1,
      sym_type_arguments,
    STATE(3124), 1,
      sym_long_identifier,
    STATE(2942), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2250), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
    ACTIONS(2248), 18,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [9013] = 18,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(4978), 1,
      sym_identifier,
    ACTIONS(4980), 1,
      anon_sym_DASH_GT,
    ACTIONS(4984), 1,
      anon_sym_STAR,
    ACTIONS(4986), 1,
      anon_sym_LT2,
    ACTIONS(4988), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(3058), 1,
      aux_sym_compound_type_repeat1,
    STATE(3118), 1,
      sym_type_arguments,
    STATE(3124), 1,
      sym_long_identifier,
    STATE(2943), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2246), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
    ACTIONS(2244), 18,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [9099] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5097), 1,
      anon_sym_or,
    STATE(2944), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_type_argument_repeat1,
    ACTIONS(2340), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2342), 23,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [9171] = 18,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5029), 1,
      sym_identifier,
    ACTIONS(5031), 1,
      anon_sym_DASH_GT,
    ACTIONS(5033), 1,
      anon_sym_STAR,
    ACTIONS(5035), 1,
      anon_sym_LT2,
    ACTIONS(5037), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(3105), 1,
      aux_sym_compound_type_repeat1,
    STATE(3161), 1,
      sym_long_identifier,
    STATE(3165), 1,
      sym_type_arguments,
    STATE(2945), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2246), 12,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
    ACTIONS(2244), 18,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [9257] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(4959), 1,
      anon_sym_STAR,
    STATE(2956), 1,
      aux_sym_compound_type_repeat1,
    STATE(2946), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2407), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2409), 22,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [9330] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5100), 1,
      anon_sym_COLON_GT,
    STATE(2947), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2567), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2569), 23,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [9401] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(2948), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2321), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2323), 24,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [9470] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5102), 1,
      anon_sym_or,
    STATE(3016), 1,
      aux_sym_type_argument_repeat1,
    STATE(2949), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2328), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2330), 23,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [9543] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5104), 1,
      anon_sym_or,
    STATE(2955), 1,
      aux_sym_type_argument_repeat1,
    STATE(2950), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2328), 14,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2330), 21,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [9616] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5102), 1,
      anon_sym_or,
    STATE(2949), 1,
      aux_sym_type_argument_repeat1,
    STATE(2951), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2321), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2323), 23,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [9689] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(2952), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2340), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_or,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2342), 24,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [9758] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5104), 1,
      anon_sym_or,
    STATE(2950), 1,
      aux_sym_type_argument_repeat1,
    STATE(2953), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2321), 14,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2323), 21,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [9831] = 18,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5106), 1,
      sym_identifier,
    ACTIONS(5108), 1,
      anon_sym_DASH_GT,
    ACTIONS(5110), 1,
      anon_sym_STAR,
    ACTIONS(5112), 1,
      anon_sym_LT2,
    ACTIONS(5114), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(3144), 1,
      aux_sym_compound_type_repeat1,
    STATE(3221), 1,
      sym_long_identifier,
    STATE(3250), 1,
      sym_type_arguments,
    STATE(2954), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2230), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
    ACTIONS(2228), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [9916] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5116), 1,
      anon_sym_or,
    STATE(2955), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_type_argument_repeat1,
    ACTIONS(2340), 14,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2342), 21,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [9987] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5119), 1,
      anon_sym_STAR,
    STATE(2956), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_compound_type_repeat1,
    ACTIONS(2250), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2248), 22,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [10058] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5122), 1,
      anon_sym_DOT,
    STATE(2991), 1,
      aux_sym_long_identifier_repeat1,
    STATE(2957), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2418), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2420), 22,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [10131] = 18,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5085), 1,
      sym_identifier,
    ACTIONS(5087), 1,
      anon_sym_DASH_GT,
    ACTIONS(5091), 1,
      anon_sym_STAR,
    ACTIONS(5093), 1,
      anon_sym_LT2,
    ACTIONS(5095), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(3133), 1,
      aux_sym_compound_type_repeat1,
    STATE(3257), 1,
      sym_long_identifier,
    STATE(3264), 1,
      sym_type_arguments,
    STATE(2958), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2250), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
    ACTIONS(2248), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [10216] = 18,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5124), 1,
      sym_identifier,
    ACTIONS(5126), 1,
      anon_sym_DASH_GT,
    ACTIONS(5128), 1,
      anon_sym_STAR,
    ACTIONS(5130), 1,
      anon_sym_LT2,
    ACTIONS(5132), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(3137), 1,
      aux_sym_compound_type_repeat1,
    STATE(3220), 1,
      sym_type_arguments,
    STATE(3229), 1,
      sym_long_identifier,
    STATE(2959), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2242), 11,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
    ACTIONS(2240), 18,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [10301] = 18,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5134), 1,
      sym_identifier,
    ACTIONS(5136), 1,
      anon_sym_DASH_GT,
    ACTIONS(5138), 1,
      anon_sym_STAR,
    ACTIONS(5140), 1,
      anon_sym_LT2,
    ACTIONS(5142), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(3184), 1,
      aux_sym_compound_type_repeat1,
    STATE(3201), 1,
      sym_long_identifier,
    STATE(3204), 1,
      sym_type_arguments,
    STATE(2960), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2242), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
    ACTIONS(2240), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [10386] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(2961), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2340), 14,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_or,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2342), 23,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [10455] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5122), 1,
      anon_sym_DOT,
    STATE(2957), 1,
      aux_sym_long_identifier_repeat1,
    STATE(2962), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2312), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2314), 22,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [10528] = 18,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5085), 1,
      sym_identifier,
    ACTIONS(5087), 1,
      anon_sym_DASH_GT,
    ACTIONS(5091), 1,
      anon_sym_STAR,
    ACTIONS(5093), 1,
      anon_sym_LT2,
    ACTIONS(5095), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(3133), 1,
      aux_sym_compound_type_repeat1,
    STATE(3257), 1,
      sym_long_identifier,
    STATE(3264), 1,
      sym_type_arguments,
    STATE(2963), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2230), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
    ACTIONS(2228), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [10613] = 19,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(4978), 1,
      sym_identifier,
    ACTIONS(4980), 1,
      anon_sym_DASH_GT,
    ACTIONS(4984), 1,
      anon_sym_STAR,
    ACTIONS(4986), 1,
      anon_sym_LT2,
    ACTIONS(4988), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(3058), 1,
      aux_sym_compound_type_repeat1,
    STATE(3118), 1,
      sym_type_arguments,
    STATE(3124), 1,
      sym_long_identifier,
    STATE(3612), 1,
      sym_type_argument_constraints,
    STATE(2964), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4953), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
    ACTIONS(4951), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [10700] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(2965), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2340), 14,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_or,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2342), 23,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [10769] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5144), 1,
      anon_sym_COLON_GT,
    STATE(2966), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2567), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2569), 23,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [10840] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5146), 1,
      anon_sym_or,
    STATE(3007), 1,
      aux_sym_type_argument_repeat1,
    STATE(2967), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2321), 14,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2323), 21,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [10913] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5148), 1,
      anon_sym_DOT,
    STATE(2968), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_long_identifier_repeat1,
    ACTIONS(2411), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2413), 22,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [10984] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5151), 1,
      anon_sym_or,
    STATE(2969), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_type_argument_repeat1,
    ACTIONS(2340), 14,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2342), 21,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [11055] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5154), 1,
      anon_sym_or,
    STATE(2974), 1,
      aux_sym_type_argument_repeat1,
    STATE(2970), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2321), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2323), 23,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [11128] = 18,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5085), 1,
      sym_identifier,
    ACTIONS(5087), 1,
      anon_sym_DASH_GT,
    ACTIONS(5091), 1,
      anon_sym_STAR,
    ACTIONS(5093), 1,
      anon_sym_LT2,
    ACTIONS(5095), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(3133), 1,
      aux_sym_compound_type_repeat1,
    STATE(3257), 1,
      sym_long_identifier,
    STATE(3264), 1,
      sym_type_arguments,
    STATE(2971), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2246), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
    ACTIONS(2244), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [11213] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5156), 1,
      anon_sym_or,
    STATE(2972), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_type_argument_repeat1,
    ACTIONS(2340), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2342), 23,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [11284] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(2973), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2411), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2413), 24,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [11353] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5154), 1,
      anon_sym_or,
    STATE(2972), 1,
      aux_sym_type_argument_repeat1,
    STATE(2974), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2328), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2330), 23,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [11426] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5159), 1,
      anon_sym_DOT,
    STATE(3013), 1,
      aux_sym_long_identifier_repeat1,
    STATE(2975), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2312), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2314), 23,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [11499] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(2976), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2411), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2413), 24,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [11568] = 18,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5124), 1,
      sym_identifier,
    ACTIONS(5126), 1,
      anon_sym_DASH_GT,
    ACTIONS(5128), 1,
      anon_sym_STAR,
    ACTIONS(5130), 1,
      anon_sym_LT2,
    ACTIONS(5132), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(3137), 1,
      aux_sym_compound_type_repeat1,
    STATE(3220), 1,
      sym_type_arguments,
    STATE(3229), 1,
      sym_long_identifier,
    STATE(2977), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5057), 11,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
    ACTIONS(5055), 18,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [11653] = 18,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5106), 1,
      sym_identifier,
    ACTIONS(5108), 1,
      anon_sym_DASH_GT,
    ACTIONS(5110), 1,
      anon_sym_STAR,
    ACTIONS(5112), 1,
      anon_sym_LT2,
    ACTIONS(5114), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(3144), 1,
      aux_sym_compound_type_repeat1,
    STATE(3221), 1,
      sym_long_identifier,
    STATE(3250), 1,
      sym_type_arguments,
    STATE(2978), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2250), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
    ACTIONS(2248), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [11738] = 16,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5110), 1,
      anon_sym_STAR,
    ACTIONS(5112), 1,
      anon_sym_LT2,
    ACTIONS(5114), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(3144), 1,
      aux_sym_compound_type_repeat1,
    STATE(3221), 1,
      sym_long_identifier,
    STATE(3250), 1,
      sym_type_arguments,
    STATE(2979), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5009), 14,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(5011), 17,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [11819] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5161), 1,
      anon_sym_DOT,
    STATE(2983), 1,
      aux_sym_long_identifier_repeat1,
    STATE(2980), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2418), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2420), 22,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [11892] = 18,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5163), 1,
      sym_identifier,
    ACTIONS(5165), 1,
      anon_sym_DASH_GT,
    ACTIONS(5167), 1,
      anon_sym_STAR,
    ACTIONS(5169), 1,
      anon_sym_LT2,
    ACTIONS(5171), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(3114), 1,
      aux_sym_compound_type_repeat1,
    STATE(3227), 1,
      sym_long_identifier,
    STATE(3231), 1,
      sym_type_arguments,
    STATE(2981), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5057), 11,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
    ACTIONS(5055), 18,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [11977] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5173), 1,
      anon_sym_or,
    STATE(3023), 1,
      aux_sym_type_argument_repeat1,
    STATE(2982), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2321), 14,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2323), 21,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [12050] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5175), 1,
      anon_sym_DOT,
    STATE(2983), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_long_identifier_repeat1,
    ACTIONS(2411), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2413), 22,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [12121] = 16,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5110), 1,
      anon_sym_STAR,
    ACTIONS(5112), 1,
      anon_sym_LT2,
    ACTIONS(5114), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(3144), 1,
      aux_sym_compound_type_repeat1,
    STATE(3221), 1,
      sym_long_identifier,
    STATE(3250), 1,
      sym_type_arguments,
    STATE(2984), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5013), 14,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(5015), 17,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [12202] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(2985), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2462), 14,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_or,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2464), 23,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [12271] = 17,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5136), 1,
      anon_sym_DASH_GT,
    ACTIONS(5138), 1,
      anon_sym_STAR,
    ACTIONS(5140), 1,
      anon_sym_LT2,
    ACTIONS(5142), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(3184), 1,
      aux_sym_compound_type_repeat1,
    STATE(3201), 1,
      sym_long_identifier,
    STATE(3204), 1,
      sym_type_arguments,
    STATE(2986), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5009), 14,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(5011), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [12354] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5178), 1,
      anon_sym_DOT,
    STATE(2968), 1,
      aux_sym_long_identifier_repeat1,
    STATE(2987), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2418), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2420), 22,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [12427] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5180), 1,
      anon_sym_DOT,
    STATE(2988), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_long_identifier_repeat1,
    ACTIONS(2411), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2413), 23,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [12498] = 18,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5163), 1,
      sym_identifier,
    ACTIONS(5165), 1,
      anon_sym_DASH_GT,
    ACTIONS(5167), 1,
      anon_sym_STAR,
    ACTIONS(5169), 1,
      anon_sym_LT2,
    ACTIONS(5171), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(3114), 1,
      aux_sym_compound_type_repeat1,
    STATE(3227), 1,
      sym_long_identifier,
    STATE(3231), 1,
      sym_type_arguments,
    STATE(2989), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2230), 11,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
    ACTIONS(2228), 18,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [12583] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(2990), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2462), 14,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_or,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2464), 23,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [12652] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5183), 1,
      anon_sym_DOT,
    STATE(2991), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_long_identifier_repeat1,
    ACTIONS(2411), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2413), 22,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [12723] = 17,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5136), 1,
      anon_sym_DASH_GT,
    ACTIONS(5138), 1,
      anon_sym_STAR,
    ACTIONS(5140), 1,
      anon_sym_LT2,
    ACTIONS(5142), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(3184), 1,
      aux_sym_compound_type_repeat1,
    STATE(3201), 1,
      sym_long_identifier,
    STATE(3204), 1,
      sym_type_arguments,
    STATE(2992), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5013), 14,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(5015), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [12806] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(2993), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2340), 14,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_or,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2342), 23,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [12875] = 18,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5106), 1,
      sym_identifier,
    ACTIONS(5108), 1,
      anon_sym_DASH_GT,
    ACTIONS(5110), 1,
      anon_sym_STAR,
    ACTIONS(5112), 1,
      anon_sym_LT2,
    ACTIONS(5114), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(3144), 1,
      aux_sym_compound_type_repeat1,
    STATE(3221), 1,
      sym_long_identifier,
    STATE(3250), 1,
      sym_type_arguments,
    STATE(2994), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2246), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
    ACTIONS(2244), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [12960] = 16,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5059), 1,
      anon_sym_DASH_GT,
    ACTIONS(5061), 1,
      anon_sym_STAR,
    ACTIONS(5065), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(3089), 1,
      aux_sym_compound_type_repeat1,
    STATE(3186), 1,
      sym_long_identifier,
    STATE(3191), 1,
      sym_type_arguments,
    STATE(2995), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5009), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(5011), 18,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [13041] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5178), 1,
      anon_sym_DOT,
    STATE(2987), 1,
      aux_sym_long_identifier_repeat1,
    STATE(2996), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2312), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2314), 22,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [13114] = 18,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5134), 1,
      sym_identifier,
    ACTIONS(5136), 1,
      anon_sym_DASH_GT,
    ACTIONS(5138), 1,
      anon_sym_STAR,
    ACTIONS(5140), 1,
      anon_sym_LT2,
    ACTIONS(5142), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(3184), 1,
      aux_sym_compound_type_repeat1,
    STATE(3201), 1,
      sym_long_identifier,
    STATE(3204), 1,
      sym_type_arguments,
    STATE(2997), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2230), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
    ACTIONS(2228), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [13199] = 18,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5134), 1,
      sym_identifier,
    ACTIONS(5136), 1,
      anon_sym_DASH_GT,
    ACTIONS(5138), 1,
      anon_sym_STAR,
    ACTIONS(5140), 1,
      anon_sym_LT2,
    ACTIONS(5142), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(3184), 1,
      aux_sym_compound_type_repeat1,
    STATE(3201), 1,
      sym_long_identifier,
    STATE(3204), 1,
      sym_type_arguments,
    STATE(2998), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2250), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
    ACTIONS(2248), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [13284] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5186), 1,
      anon_sym_STAR,
    STATE(2999), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_compound_type_repeat1,
    ACTIONS(2250), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2248), 22,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [13355] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3000), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2321), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2323), 24,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [13424] = 18,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5163), 1,
      sym_identifier,
    ACTIONS(5165), 1,
      anon_sym_DASH_GT,
    ACTIONS(5167), 1,
      anon_sym_STAR,
    ACTIONS(5169), 1,
      anon_sym_LT2,
    ACTIONS(5171), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(3114), 1,
      aux_sym_compound_type_repeat1,
    STATE(3227), 1,
      sym_long_identifier,
    STATE(3231), 1,
      sym_type_arguments,
    STATE(3001), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2250), 11,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
    ACTIONS(2248), 18,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [13509] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(4972), 1,
      anon_sym_STAR,
    STATE(2999), 1,
      aux_sym_compound_type_repeat1,
    STATE(3002), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2407), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2409), 22,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [13582] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5161), 1,
      anon_sym_DOT,
    STATE(2980), 1,
      aux_sym_long_identifier_repeat1,
    STATE(3003), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2312), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2314), 22,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [13655] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5189), 1,
      anon_sym_or,
    STATE(3004), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_type_argument_repeat1,
    ACTIONS(2340), 14,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2342), 21,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [13726] = 18,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5163), 1,
      sym_identifier,
    ACTIONS(5165), 1,
      anon_sym_DASH_GT,
    ACTIONS(5167), 1,
      anon_sym_STAR,
    ACTIONS(5169), 1,
      anon_sym_LT2,
    ACTIONS(5171), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(3114), 1,
      aux_sym_compound_type_repeat1,
    STATE(3227), 1,
      sym_long_identifier,
    STATE(3231), 1,
      sym_type_arguments,
    STATE(3005), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2246), 11,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
    ACTIONS(2244), 18,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [13811] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3006), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2462), 14,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_or,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2464), 23,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [13880] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5146), 1,
      anon_sym_or,
    STATE(3004), 1,
      aux_sym_type_argument_repeat1,
    STATE(3007), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2328), 14,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2330), 21,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [13953] = 16,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5059), 1,
      anon_sym_DASH_GT,
    ACTIONS(5061), 1,
      anon_sym_STAR,
    ACTIONS(5065), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(3089), 1,
      aux_sym_compound_type_repeat1,
    STATE(3186), 1,
      sym_long_identifier,
    STATE(3191), 1,
      sym_type_arguments,
    STATE(3008), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5013), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(5015), 18,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [14034] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3009), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2462), 14,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_or,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2464), 23,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [14103] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3010), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2340), 14,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_or,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2342), 23,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [14172] = 18,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5134), 1,
      sym_identifier,
    ACTIONS(5136), 1,
      anon_sym_DASH_GT,
    ACTIONS(5138), 1,
      anon_sym_STAR,
    ACTIONS(5140), 1,
      anon_sym_LT2,
    ACTIONS(5142), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(3184), 1,
      aux_sym_compound_type_repeat1,
    STATE(3201), 1,
      sym_long_identifier,
    STATE(3204), 1,
      sym_type_arguments,
    STATE(3011), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2246), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
    ACTIONS(2244), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [14257] = 18,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5106), 1,
      sym_identifier,
    ACTIONS(5108), 1,
      anon_sym_DASH_GT,
    ACTIONS(5110), 1,
      anon_sym_STAR,
    ACTIONS(5112), 1,
      anon_sym_LT2,
    ACTIONS(5114), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(3144), 1,
      aux_sym_compound_type_repeat1,
    STATE(3221), 1,
      sym_long_identifier,
    STATE(3250), 1,
      sym_type_arguments,
    STATE(3012), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2242), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
    ACTIONS(2240), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [14342] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5159), 1,
      anon_sym_DOT,
    STATE(2988), 1,
      aux_sym_long_identifier_repeat1,
    STATE(3013), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2418), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2420), 23,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [14415] = 18,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5124), 1,
      sym_identifier,
    ACTIONS(5126), 1,
      anon_sym_DASH_GT,
    ACTIONS(5128), 1,
      anon_sym_STAR,
    ACTIONS(5130), 1,
      anon_sym_LT2,
    ACTIONS(5132), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(3137), 1,
      aux_sym_compound_type_repeat1,
    STATE(3220), 1,
      sym_type_arguments,
    STATE(3229), 1,
      sym_long_identifier,
    STATE(3014), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2246), 11,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
    ACTIONS(2244), 18,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [14500] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5192), 1,
      anon_sym_DOT,
    STATE(3022), 1,
      aux_sym_long_identifier_repeat1,
    STATE(3015), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2312), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2314), 22,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [14573] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5194), 1,
      anon_sym_or,
    STATE(3016), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_type_argument_repeat1,
    ACTIONS(2340), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2342), 23,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [14644] = 18,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5124), 1,
      sym_identifier,
    ACTIONS(5126), 1,
      anon_sym_DASH_GT,
    ACTIONS(5128), 1,
      anon_sym_STAR,
    ACTIONS(5130), 1,
      anon_sym_LT2,
    ACTIONS(5132), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(3137), 1,
      aux_sym_compound_type_repeat1,
    STATE(3220), 1,
      sym_type_arguments,
    STATE(3229), 1,
      sym_long_identifier,
    STATE(3017), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2250), 11,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
    ACTIONS(2248), 18,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [14729] = 18,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5163), 1,
      sym_identifier,
    ACTIONS(5165), 1,
      anon_sym_DASH_GT,
    ACTIONS(5167), 1,
      anon_sym_STAR,
    ACTIONS(5169), 1,
      anon_sym_LT2,
    ACTIONS(5171), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(3114), 1,
      aux_sym_compound_type_repeat1,
    STATE(3227), 1,
      sym_long_identifier,
    STATE(3231), 1,
      sym_type_arguments,
    STATE(3018), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2242), 11,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
    ACTIONS(2240), 18,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [14814] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3019), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2462), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_or,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2464), 24,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [14883] = 18,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5085), 1,
      sym_identifier,
    ACTIONS(5087), 1,
      anon_sym_DASH_GT,
    ACTIONS(5091), 1,
      anon_sym_STAR,
    ACTIONS(5093), 1,
      anon_sym_LT2,
    ACTIONS(5095), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(3133), 1,
      aux_sym_compound_type_repeat1,
    STATE(3257), 1,
      sym_long_identifier,
    STATE(3264), 1,
      sym_type_arguments,
    STATE(3020), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2242), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
    ACTIONS(2240), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [14968] = 18,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5124), 1,
      sym_identifier,
    ACTIONS(5126), 1,
      anon_sym_DASH_GT,
    ACTIONS(5128), 1,
      anon_sym_STAR,
    ACTIONS(5130), 1,
      anon_sym_LT2,
    ACTIONS(5132), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(3137), 1,
      aux_sym_compound_type_repeat1,
    STATE(3220), 1,
      sym_type_arguments,
    STATE(3229), 1,
      sym_long_identifier,
    STATE(3021), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2230), 11,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
    ACTIONS(2228), 18,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [15053] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5192), 1,
      anon_sym_DOT,
    STATE(3024), 1,
      aux_sym_long_identifier_repeat1,
    STATE(3022), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2418), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2420), 22,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [15126] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5173), 1,
      anon_sym_or,
    STATE(2969), 1,
      aux_sym_type_argument_repeat1,
    STATE(3023), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2328), 14,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2330), 21,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [15199] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5197), 1,
      anon_sym_DOT,
    STATE(3024), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_long_identifier_repeat1,
    ACTIONS(2411), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2413), 22,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [15270] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3025), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2553), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2555), 23,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [15338] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3026), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2563), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2565), 23,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [15406] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3027), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2462), 15,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_when,
      anon_sym_or,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2464), 21,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [15474] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3028), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2411), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2413), 23,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [15542] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5200), 1,
      anon_sym_COLON_GT,
    STATE(3029), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2567), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2569), 22,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [15612] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3030), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2567), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2569), 23,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [15680] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3031), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2462), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_or,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2464), 23,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [15748] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5202), 1,
      anon_sym_STAR,
    STATE(3032), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_compound_type_repeat1,
    ACTIONS(2250), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2248), 21,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [15818] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3033), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2454), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2456), 23,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [15886] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3034), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2470), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2472), 23,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [15954] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5205), 1,
      anon_sym_DOT,
    STATE(3081), 1,
      aux_sym_long_identifier_repeat1,
    STATE(3035), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2312), 14,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2314), 20,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [16026] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5207), 1,
      anon_sym_COLON_GT,
    STATE(3036), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2567), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2569), 22,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [16096] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5209), 1,
      anon_sym_DOT,
    STATE(3037), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_long_identifier_repeat1,
    ACTIONS(2411), 14,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2413), 20,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [16166] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5212), 1,
      anon_sym_DOT,
    STATE(3038), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_long_identifier_repeat1,
    ACTIONS(2411), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2413), 22,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [16236] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3039), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2321), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2323), 23,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [16304] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3040), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2474), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2476), 23,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [16372] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5215), 1,
      anon_sym_COLON_GT,
    STATE(3041), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2567), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2569), 23,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [16442] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3042), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2510), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2512), 23,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [16510] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3043), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2506), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2508), 23,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [16578] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5217), 1,
      anon_sym_DOT,
    STATE(3038), 1,
      aux_sym_long_identifier_repeat1,
    STATE(3044), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2418), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2420), 22,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [16650] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3045), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2510), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2512), 23,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [16718] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3046), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2462), 15,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_or,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2464), 21,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [16786] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5023), 1,
      anon_sym_STAR,
    STATE(3054), 1,
      aux_sym_compound_type_repeat1,
    STATE(3047), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2407), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2409), 22,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [16858] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3048), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2340), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_or,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2342), 23,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [16926] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5219), 1,
      anon_sym_DOT,
    STATE(3104), 1,
      aux_sym_long_identifier_repeat1,
    STATE(3049), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2312), 14,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2314), 20,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [16998] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5221), 1,
      anon_sym_DOT,
    STATE(3050), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_long_identifier_repeat1,
    ACTIONS(2411), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2413), 22,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [17068] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5224), 1,
      anon_sym_STAR,
    STATE(3051), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_compound_type_repeat1,
    ACTIONS(2250), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2248), 21,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [17138] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3052), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2474), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2476), 23,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [17206] = 23,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4525), 1,
      anon_sym_DOLLAR_DQUOTE,
    ACTIONS(4527), 1,
      anon_sym_DQUOTE,
    ACTIONS(4529), 1,
      anon_sym_AT_DQUOTE,
    ACTIONS(4531), 1,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(4533), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(4539), 1,
      sym_int,
    ACTIONS(4541), 1,
      sym_xint,
    ACTIONS(5227), 1,
      aux_sym_char_token1,
    STATE(432), 1,
      sym_const,
    STATE(2793), 1,
      sym_float,
    STATE(2809), 1,
      sym_format_triple_quoted_string,
    STATE(6356), 1,
      sym_static_parameter_value,
    ACTIONS(4537), 2,
      sym_bool,
      sym_unit,
    STATE(2805), 2,
      sym_format_string,
      sym__string_literal,
    STATE(3053), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(2803), 20,
      sym_char,
      sym_string,
      sym_verbatim_string,
      sym_bytearray,
      sym_verbatim_bytearray,
      sym_triple_quoted_string,
      sym_sbyte,
      sym_byte,
      sym_int16,
      sym_uint16,
      sym_int32,
      sym_uint32,
      sym_nativeint,
      sym_unativeint,
      sym_int64,
      sym_uint64,
      sym_ieee32,
      sym_ieee64,
      sym_bignum,
      sym_decimal,
  [17300] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5229), 1,
      anon_sym_STAR,
    STATE(3054), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_compound_type_repeat1,
    ACTIONS(2250), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2248), 22,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [17370] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3055), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2462), 15,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_or,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2464), 21,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [17438] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5232), 1,
      anon_sym_COLON_GT,
    STATE(3056), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2567), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2569), 22,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [17508] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3057), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2340), 15,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_or,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2342), 21,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [17576] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(4984), 1,
      anon_sym_STAR,
    STATE(3107), 1,
      aux_sym_compound_type_repeat1,
    STATE(3058), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2407), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2409), 21,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [17648] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5234), 1,
      anon_sym_DOT,
    STATE(3050), 1,
      aux_sym_long_identifier_repeat1,
    STATE(3059), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2418), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2420), 22,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [17720] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3060), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2466), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2468), 23,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [17788] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3061), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2627), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2629), 23,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [17856] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3062), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2321), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2323), 23,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [17924] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5236), 1,
      anon_sym_LT2,
    STATE(3063), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2557), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2559), 22,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [17994] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3064), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2553), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2555), 23,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [18062] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5238), 1,
      anon_sym_COLON_GT,
    STATE(3065), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2567), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2569), 22,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [18132] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5240), 1,
      anon_sym_LT2,
    STATE(3066), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2557), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2559), 22,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [18202] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3067), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2514), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2516), 23,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [18270] = 18,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5242), 1,
      sym_identifier,
    ACTIONS(5244), 1,
      anon_sym_DASH_GT,
    ACTIONS(5246), 1,
      anon_sym_STAR,
    ACTIONS(5248), 1,
      anon_sym_LT2,
    ACTIONS(5250), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(3263), 1,
      aux_sym_compound_type_repeat1,
    STATE(3282), 1,
      sym_long_identifier,
    STATE(3287), 1,
      sym_type_arguments,
    STATE(3068), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2242), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
    ACTIONS(2240), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [18354] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5252), 1,
      anon_sym_or,
    STATE(3069), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_type_argument_repeat1,
    ACTIONS(2340), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2342), 21,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [18424] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5255), 1,
      anon_sym_DOT,
    STATE(3070), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_long_identifier_repeat1,
    ACTIONS(2411), 14,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2413), 20,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [18494] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3071), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2321), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2323), 23,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [18562] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3072), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2563), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2565), 23,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [18630] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3073), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2514), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2516), 23,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [18698] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3074), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2567), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2569), 23,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [18766] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5217), 1,
      anon_sym_DOT,
    STATE(3044), 1,
      aux_sym_long_identifier_repeat1,
    STATE(3075), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2312), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2314), 22,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [18838] = 18,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5242), 1,
      sym_identifier,
    ACTIONS(5244), 1,
      anon_sym_DASH_GT,
    ACTIONS(5246), 1,
      anon_sym_STAR,
    ACTIONS(5248), 1,
      anon_sym_LT2,
    ACTIONS(5250), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(3263), 1,
      aux_sym_compound_type_repeat1,
    STATE(3282), 1,
      sym_long_identifier,
    STATE(3287), 1,
      sym_type_arguments,
    STATE(3076), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5057), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
    ACTIONS(5055), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [18922] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5258), 1,
      anon_sym_DOT,
    STATE(3077), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_long_identifier_repeat1,
    ACTIONS(2411), 14,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2413), 20,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [18992] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3078), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2340), 15,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_when,
      anon_sym_or,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2342), 21,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [19060] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3079), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2506), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2508), 23,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [19128] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3080), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2321), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2323), 24,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [19196] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5205), 1,
      anon_sym_DOT,
    STATE(3077), 1,
      aux_sym_long_identifier_repeat1,
    STATE(3081), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2418), 14,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2420), 20,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [19268] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3082), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2462), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_or,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2464), 23,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [19336] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3083), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2411), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2413), 23,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [19404] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5234), 1,
      anon_sym_DOT,
    STATE(3059), 1,
      aux_sym_long_identifier_repeat1,
    STATE(3084), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2312), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2314), 22,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [19476] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3085), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2340), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_or,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2342), 23,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [19544] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5000), 1,
      anon_sym_STAR,
    STATE(3051), 1,
      aux_sym_compound_type_repeat1,
    STATE(3086), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2407), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2409), 21,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [19616] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3087), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2627), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2629), 23,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [19684] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3088), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2411), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2413), 24,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [19752] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5061), 1,
      anon_sym_STAR,
    STATE(3032), 1,
      aux_sym_compound_type_repeat1,
    STATE(3089), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2407), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2409), 21,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [19824] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3090), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2466), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2468), 23,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [19892] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5261), 1,
      anon_sym_STAR,
    STATE(3091), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_compound_type_repeat1,
    ACTIONS(2250), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2248), 21,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [19962] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5264), 1,
      anon_sym_or,
    STATE(3069), 1,
      aux_sym_type_argument_repeat1,
    STATE(3092), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2328), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2330), 21,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [20034] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5264), 1,
      anon_sym_or,
    STATE(3092), 1,
      aux_sym_type_argument_repeat1,
    STATE(3093), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2321), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2323), 21,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [20106] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5266), 1,
      anon_sym_DOT,
    STATE(3070), 1,
      aux_sym_long_identifier_repeat1,
    STATE(3094), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2418), 14,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2420), 20,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [20178] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3095), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2454), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2456), 23,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [20246] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3096), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2321), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2323), 23,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [20314] = 18,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5242), 1,
      sym_identifier,
    ACTIONS(5244), 1,
      anon_sym_DASH_GT,
    ACTIONS(5246), 1,
      anon_sym_STAR,
    ACTIONS(5248), 1,
      anon_sym_LT2,
    ACTIONS(5250), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(3263), 1,
      aux_sym_compound_type_repeat1,
    STATE(3282), 1,
      sym_long_identifier,
    STATE(3287), 1,
      sym_type_arguments,
    STATE(3097), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2246), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
    ACTIONS(2244), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [20398] = 18,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5242), 1,
      sym_identifier,
    ACTIONS(5244), 1,
      anon_sym_DASH_GT,
    ACTIONS(5246), 1,
      anon_sym_STAR,
    ACTIONS(5248), 1,
      anon_sym_LT2,
    ACTIONS(5250), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(3263), 1,
      aux_sym_compound_type_repeat1,
    STATE(3282), 1,
      sym_long_identifier,
    STATE(3287), 1,
      sym_type_arguments,
    STATE(3098), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2250), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
    ACTIONS(2248), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [20482] = 18,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5242), 1,
      sym_identifier,
    ACTIONS(5244), 1,
      anon_sym_DASH_GT,
    ACTIONS(5246), 1,
      anon_sym_STAR,
    ACTIONS(5248), 1,
      anon_sym_LT2,
    ACTIONS(5250), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(3263), 1,
      aux_sym_compound_type_repeat1,
    STATE(3282), 1,
      sym_long_identifier,
    STATE(3287), 1,
      sym_type_arguments,
    STATE(3099), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2230), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
    ACTIONS(2228), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [20566] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3100), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2411), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2413), 23,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [20634] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3101), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2470), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2472), 23,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [20702] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3102), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2340), 15,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_or,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2342), 21,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [20770] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5266), 1,
      anon_sym_DOT,
    STATE(3094), 1,
      aux_sym_long_identifier_repeat1,
    STATE(3103), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2312), 14,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2314), 20,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [20842] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5219), 1,
      anon_sym_DOT,
    STATE(3037), 1,
      aux_sym_long_identifier_repeat1,
    STATE(3104), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2418), 14,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2420), 20,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [20914] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5033), 1,
      anon_sym_STAR,
    STATE(3091), 1,
      aux_sym_compound_type_repeat1,
    STATE(3105), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2407), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2409), 21,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [20986] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3106), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2411), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2413), 23,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [21054] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5268), 1,
      anon_sym_STAR,
    STATE(3107), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_compound_type_repeat1,
    ACTIONS(2250), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2248), 21,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [21124] = 18,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(4978), 1,
      sym_identifier,
    ACTIONS(4980), 1,
      anon_sym_DASH_GT,
    ACTIONS(4984), 1,
      anon_sym_STAR,
    ACTIONS(4986), 1,
      anon_sym_LT2,
    ACTIONS(4988), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(3058), 1,
      aux_sym_compound_type_repeat1,
    STATE(3118), 1,
      sym_type_arguments,
    STATE(3124), 1,
      sym_long_identifier,
    STATE(3108), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5057), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
    ACTIONS(5055), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [21208] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5271), 1,
      anon_sym_COLON_GT,
    STATE(3109), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2567), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2569), 22,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [21277] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3110), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2567), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2569), 23,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [21344] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5273), 1,
      anon_sym_STAR,
    STATE(3111), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_compound_type_repeat1,
    ACTIONS(2250), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2248), 21,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [21413] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3112), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2567), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2569), 22,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [21480] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5276), 1,
      anon_sym_LT2,
    STATE(3113), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2557), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2559), 21,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [21549] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5167), 1,
      anon_sym_STAR,
    STATE(3111), 1,
      aux_sym_compound_type_repeat1,
    STATE(3114), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2407), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2409), 21,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [21620] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3115), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2411), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2413), 23,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [21687] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3116), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2321), 14,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2323), 21,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [21754] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3117), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2510), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2512), 22,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [21821] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3118), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2474), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2476), 22,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [21888] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5278), 1,
      anon_sym_COLON_GT,
    STATE(3119), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2567), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2569), 22,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [21957] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3120), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2506), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2508), 22,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [22024] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3121), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2470), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2472), 22,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [22091] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3122), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2454), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2456), 22,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [22158] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3123), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2466), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2468), 22,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [22225] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3124), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2627), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2629), 22,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [22292] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3125), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2454), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2456), 22,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [22359] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3126), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2514), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2516), 22,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [22426] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3127), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2470), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2472), 22,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [22493] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3128), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2321), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2323), 23,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [22560] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3129), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2506), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2508), 22,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [22627] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3130), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2563), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2565), 22,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [22694] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3131), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2553), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2555), 22,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [22761] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5280), 1,
      anon_sym_COLON_GT,
    STATE(3132), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2567), 14,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2569), 20,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [22830] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5091), 1,
      anon_sym_STAR,
    STATE(3134), 1,
      aux_sym_compound_type_repeat1,
    STATE(3133), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2407), 14,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2409), 19,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [22901] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5282), 1,
      anon_sym_STAR,
    STATE(3134), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_compound_type_repeat1,
    ACTIONS(2250), 14,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2248), 19,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [22970] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3135), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2411), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2413), 23,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [23037] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5285), 1,
      anon_sym_STAR,
    STATE(3136), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_compound_type_repeat1,
    ACTIONS(2250), 14,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2248), 19,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [23106] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5128), 1,
      anon_sym_STAR,
    STATE(3138), 1,
      aux_sym_compound_type_repeat1,
    STATE(3137), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2407), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2409), 21,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [23177] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5288), 1,
      anon_sym_STAR,
    STATE(3138), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_compound_type_repeat1,
    ACTIONS(2250), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2248), 21,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [23246] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3139), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2567), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2569), 22,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [23313] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5291), 1,
      anon_sym_LT2,
    STATE(3140), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2557), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2559), 21,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [23382] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3141), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2553), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2555), 23,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [23449] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3142), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2563), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2565), 23,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [23516] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3143), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2506), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2508), 23,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [23583] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5110), 1,
      anon_sym_STAR,
    STATE(3136), 1,
      aux_sym_compound_type_repeat1,
    STATE(3144), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2407), 14,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2409), 19,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [23654] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3145), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2510), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2512), 22,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [23721] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3146), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2474), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2476), 22,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [23788] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3147), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2466), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2468), 22,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [23855] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3148), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2627), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2629), 22,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [23922] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3149), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2514), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2516), 22,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [23989] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3150), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2563), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2565), 22,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [24056] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5293), 1,
      anon_sym_COLON_GT,
    STATE(3151), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2567), 14,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2569), 20,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [24125] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3152), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2514), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2516), 23,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [24192] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3153), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2470), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2472), 23,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [24259] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3154), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2553), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2555), 22,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [24326] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3155), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2563), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2565), 22,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [24393] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3156), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2514), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2516), 22,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [24460] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3157), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2553), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2555), 22,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [24527] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3158), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2627), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2629), 23,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [24594] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3159), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2466), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2468), 23,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [24661] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5295), 1,
      anon_sym_DOT,
    STATE(3187), 1,
      aux_sym_long_identifier_repeat1,
    STATE(3160), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2312), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2314), 20,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [24732] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3161), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2627), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2629), 22,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [24799] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3162), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2466), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2468), 22,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [24866] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3163), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2462), 14,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_or,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2464), 21,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [24933] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3164), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2340), 14,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_or,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2342), 21,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [25000] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3165), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2474), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2476), 22,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [25067] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3166), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2510), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2512), 22,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [25134] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3167), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2321), 14,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2323), 21,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [25201] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3168), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2506), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2508), 22,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [25268] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3169), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2470), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2472), 22,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [25335] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5297), 1,
      anon_sym_LT2,
    STATE(3170), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2557), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2559), 21,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [25404] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3171), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2567), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2569), 22,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [25471] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3172), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2321), 14,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2323), 21,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [25538] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3173), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2454), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2456), 22,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [25605] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3174), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2411), 14,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2413), 21,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [25672] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3175), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2474), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2476), 23,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [25739] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3176), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2510), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2512), 23,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [25806] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3177), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2321), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2323), 23,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [25873] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3178), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2411), 14,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2413), 21,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [25940] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5299), 1,
      anon_sym_STAR,
    STATE(3179), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_compound_type_repeat1,
    ACTIONS(2250), 14,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2248), 19,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [26009] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3180), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2454), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2456), 22,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [26076] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3181), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2470), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2472), 22,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [26143] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5302), 1,
      anon_sym_DOT,
    STATE(3182), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_long_identifier_repeat1,
    ACTIONS(2411), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2413), 20,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [26212] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3183), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2506), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2508), 22,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [26279] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5138), 1,
      anon_sym_STAR,
    STATE(3179), 1,
      aux_sym_compound_type_repeat1,
    STATE(3184), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2407), 14,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2409), 19,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [26350] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3185), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2514), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2516), 22,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [26417] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3186), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2627), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2629), 22,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [26484] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5295), 1,
      anon_sym_DOT,
    STATE(3182), 1,
      aux_sym_long_identifier_repeat1,
    STATE(3187), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2418), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2420), 20,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [26555] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3188), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2411), 14,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2413), 21,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [26622] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5305), 1,
      anon_sym_COLON_GT,
    STATE(3189), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2567), 14,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2569), 20,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [26691] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3190), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2466), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2468), 22,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [26758] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3191), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2474), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2476), 22,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [26825] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3192), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2510), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2512), 22,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [26892] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5307), 1,
      anon_sym_LT2,
    STATE(3193), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2557), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2559), 21,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [26961] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3194), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2454), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2456), 23,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [27028] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3195), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2567), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2569), 22,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [27095] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5309), 1,
      anon_sym_LT2,
    STATE(3196), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2557), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2559), 22,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [27164] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3197), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2553), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2555), 22,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [27231] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3198), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2563), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2565), 22,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [27298] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3199), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2411), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2413), 21,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [27364] = 24,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5311), 1,
      anon_sym_y,
    ACTIONS(5313), 1,
      anon_sym_uy,
    ACTIONS(5315), 1,
      anon_sym_s,
    ACTIONS(5317), 1,
      anon_sym_us,
    ACTIONS(5319), 1,
      anon_sym_l,
    ACTIONS(5321), 1,
      aux_sym_uint32_token1,
    ACTIONS(5323), 1,
      anon_sym_n,
    ACTIONS(5325), 1,
      anon_sym_un,
    ACTIONS(5327), 1,
      anon_sym_L,
    ACTIONS(5329), 1,
      aux_sym_uint64_token1,
    ACTIONS(5331), 1,
      aux_sym_bignum_token1,
    ACTIONS(5333), 1,
      aux_sym_decimal_token1,
    ACTIONS(5335), 1,
      anon_sym_DOT2,
    ACTIONS(5337), 1,
      aux_sym_float_token1,
    STATE(3200), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2158), 9,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(2160), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [27458] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3201), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2627), 14,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2629), 20,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [27524] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3202), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2466), 14,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2468), 20,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [27590] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3203), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2563), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2565), 22,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [27656] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3204), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2474), 14,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2476), 20,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [27722] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3205), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2510), 14,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2512), 20,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [27788] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5339), 1,
      anon_sym_LT2,
    STATE(3206), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2557), 14,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2559), 19,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [27856] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3207), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2567), 14,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2569), 20,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [27922] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3208), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2454), 14,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2456), 20,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [27988] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5341), 1,
      aux_sym_float_token1,
    STATE(3209), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2723), 14,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      anon_sym_f,
      aux_sym_decimal_token1,
      sym_identifier,
    ACTIONS(2725), 19,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [28056] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3210), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2470), 14,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2472), 20,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [28122] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3211), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2506), 14,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2508), 20,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [28188] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3212), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2470), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2472), 22,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [28254] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3213), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2506), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2508), 22,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [28320] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3214), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2553), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2555), 22,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [28386] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3215), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2567), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2569), 22,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [28452] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5343), 1,
      anon_sym_LT2,
    STATE(3216), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2557), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2559), 21,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [28520] = 23,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4504), 1,
      sym_identifier,
    ACTIONS(5347), 1,
      anon_sym_LPAREN,
    ACTIONS(5349), 1,
      anon_sym__,
    ACTIONS(5351), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(5353), 1,
      anon_sym_POUND,
    STATE(353), 1,
      sym__type,
    STATE(2708), 1,
      sym__static_type_identifier,
    STATE(2770), 1,
      sym_type_argument,
    STATE(2788), 1,
      sym_long_identifier,
    STATE(5784), 1,
      sym_attribute,
    STATE(6349), 1,
      sym__object_construction,
    STATE(7456), 1,
      sym__attribute_target,
    ACTIONS(5355), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3217), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5345), 9,
      anon_sym_module,
      anon_sym_assembly,
      anon_sym_return,
      anon_sym_field,
      anon_sym_property,
      anon_sym_param,
      anon_sym_type,
      anon_sym_constructor,
      anon_sym_event,
    STATE(2778), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [28612] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3218), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2514), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2516), 22,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [28678] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3219), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2510), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2512), 22,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [28744] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3220), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2474), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2476), 22,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [28810] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3221), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2627), 14,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2629), 20,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [28876] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3222), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2454), 14,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2456), 20,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [28942] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3223), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2470), 14,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2472), 20,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [29008] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3224), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2506), 14,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2508), 20,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [29074] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5357), 1,
      aux_sym_float_token1,
    STATE(3225), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2723), 14,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      anon_sym_f,
      aux_sym_decimal_token1,
      sym_identifier,
    ACTIONS(2725), 19,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [29142] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3226), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2466), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2468), 22,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [29208] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3227), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2627), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2629), 22,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [29274] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3228), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2454), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2456), 22,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [29340] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3229), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2627), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2629), 22,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [29406] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3230), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2466), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2468), 22,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [29472] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3231), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2474), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2476), 22,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [29538] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3232), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2514), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2516), 22,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [29604] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3233), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2563), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2565), 22,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [29670] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3234), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2553), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2555), 22,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [29736] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3235), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2510), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2512), 22,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [29802] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3236), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2510), 14,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2512), 20,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [29868] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3237), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2514), 14,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2516), 20,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [29934] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5359), 1,
      anon_sym_LT2,
    STATE(3238), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2557), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2559), 21,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [30002] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3239), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2567), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2569), 22,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [30068] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3240), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2506), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2508), 22,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [30134] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3241), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2466), 14,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2468), 20,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [30200] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3242), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2454), 14,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2456), 20,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [30266] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3243), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2470), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2472), 22,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [30332] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3244), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2470), 14,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2472), 20,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [30398] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3245), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2454), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2456), 22,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [30464] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5361), 1,
      anon_sym_DOT,
    STATE(3246), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_long_identifier_repeat1,
    ACTIONS(2411), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2413), 20,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [30532] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3247), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2553), 14,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2555), 20,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [30598] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3248), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2506), 14,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2508), 20,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [30664] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3249), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2563), 14,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2565), 20,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [30730] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3250), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2474), 14,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2476), 20,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [30796] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3251), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2563), 14,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2565), 20,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [30862] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3252), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2553), 14,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2555), 20,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [30928] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3253), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2514), 14,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2516), 20,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [30994] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3254), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2510), 14,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2512), 20,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [31060] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5364), 1,
      anon_sym_COLON_GT,
    STATE(3255), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2567), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2569), 20,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [31128] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3256), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2514), 14,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2516), 20,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [31194] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3257), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2627), 14,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2629), 20,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [31260] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3258), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2466), 14,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2468), 20,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [31326] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3259), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2563), 14,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2565), 20,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [31392] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5366), 1,
      anon_sym_LT2,
    STATE(3260), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2557), 14,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2559), 19,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [31460] = 23,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4504), 1,
      sym_identifier,
    ACTIONS(5347), 1,
      anon_sym_LPAREN,
    ACTIONS(5349), 1,
      anon_sym__,
    ACTIONS(5351), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(5353), 1,
      anon_sym_POUND,
    STATE(353), 1,
      sym__type,
    STATE(2708), 1,
      sym__static_type_identifier,
    STATE(2770), 1,
      sym_type_argument,
    STATE(2788), 1,
      sym_long_identifier,
    STATE(5769), 1,
      sym_attribute,
    STATE(6349), 1,
      sym__object_construction,
    STATE(7456), 1,
      sym__attribute_target,
    ACTIONS(5355), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3261), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5345), 9,
      anon_sym_module,
      anon_sym_assembly,
      anon_sym_return,
      anon_sym_field,
      anon_sym_property,
      anon_sym_param,
      anon_sym_type,
      anon_sym_constructor,
      anon_sym_event,
    STATE(2778), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [31552] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3262), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2567), 14,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2569), 20,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [31618] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5246), 1,
      anon_sym_STAR,
    STATE(3266), 1,
      aux_sym_compound_type_repeat1,
    STATE(3263), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2407), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2409), 19,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [31688] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3264), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2474), 14,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2476), 20,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [31754] = 23,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4504), 1,
      sym_identifier,
    ACTIONS(5347), 1,
      anon_sym_LPAREN,
    ACTIONS(5349), 1,
      anon_sym__,
    ACTIONS(5351), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(5353), 1,
      anon_sym_POUND,
    STATE(353), 1,
      sym__type,
    STATE(2708), 1,
      sym__static_type_identifier,
    STATE(2770), 1,
      sym_type_argument,
    STATE(2788), 1,
      sym_long_identifier,
    STATE(5829), 1,
      sym_attribute,
    STATE(6349), 1,
      sym__object_construction,
    STATE(7456), 1,
      sym__attribute_target,
    ACTIONS(5355), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3265), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5345), 9,
      anon_sym_module,
      anon_sym_assembly,
      anon_sym_return,
      anon_sym_field,
      anon_sym_property,
      anon_sym_param,
      anon_sym_type,
      anon_sym_constructor,
      anon_sym_event,
    STATE(2778), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [31846] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5368), 1,
      anon_sym_STAR,
    STATE(3266), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_compound_type_repeat1,
    ACTIONS(2250), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2248), 19,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [31914] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3267), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2321), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2323), 21,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [31980] = 23,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4504), 1,
      sym_identifier,
    ACTIONS(5347), 1,
      anon_sym_LPAREN,
    ACTIONS(5349), 1,
      anon_sym__,
    ACTIONS(5351), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(5353), 1,
      anon_sym_POUND,
    STATE(353), 1,
      sym__type,
    STATE(2708), 1,
      sym__static_type_identifier,
    STATE(2770), 1,
      sym_type_argument,
    STATE(2788), 1,
      sym_long_identifier,
    STATE(5924), 1,
      sym_attribute,
    STATE(6349), 1,
      sym__object_construction,
    STATE(7456), 1,
      sym__attribute_target,
    ACTIONS(5355), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3268), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5345), 9,
      anon_sym_module,
      anon_sym_assembly,
      anon_sym_return,
      anon_sym_field,
      anon_sym_property,
      anon_sym_param,
      anon_sym_type,
      anon_sym_constructor,
      anon_sym_event,
    STATE(2778), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [32072] = 23,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4504), 1,
      sym_identifier,
    ACTIONS(5347), 1,
      anon_sym_LPAREN,
    ACTIONS(5349), 1,
      anon_sym__,
    ACTIONS(5351), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(5353), 1,
      anon_sym_POUND,
    STATE(353), 1,
      sym__type,
    STATE(2708), 1,
      sym__static_type_identifier,
    STATE(2770), 1,
      sym_type_argument,
    STATE(2788), 1,
      sym_long_identifier,
    STATE(6079), 1,
      sym_attribute,
    STATE(6349), 1,
      sym__object_construction,
    STATE(7456), 1,
      sym__attribute_target,
    ACTIONS(5355), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3269), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5345), 9,
      anon_sym_module,
      anon_sym_assembly,
      anon_sym_return,
      anon_sym_field,
      anon_sym_property,
      anon_sym_param,
      anon_sym_type,
      anon_sym_constructor,
      anon_sym_event,
    STATE(2778), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [32164] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3270), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2567), 14,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2569), 20,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [32230] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3271), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2553), 14,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2555), 20,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [32296] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5371), 1,
      anon_sym_LT2,
    STATE(3272), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2557), 14,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2559), 19,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [32364] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5373), 1,
      anon_sym_DOT,
    STATE(3274), 1,
      aux_sym_long_identifier_repeat1,
    STATE(3273), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2312), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2314), 20,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [32434] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5373), 1,
      anon_sym_DOT,
    STATE(3246), 1,
      aux_sym_long_identifier_repeat1,
    STATE(3274), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2418), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2420), 20,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [32504] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5375), 1,
      sym_int,
    STATE(3275), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2819), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      anon_sym_f,
      aux_sym_decimal_token1,
      sym_identifier,
    ACTIONS(2821), 19,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [32571] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3276), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2514), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2516), 20,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [32636] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3277), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2563), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2565), 20,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [32701] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3278), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2553), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2555), 20,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [32766] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5377), 1,
      anon_sym_or,
    STATE(3299), 1,
      aux_sym_type_argument_repeat1,
    STATE(3279), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2321), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2323), 19,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [32835] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5373), 1,
      anon_sym_DOT,
    STATE(3274), 1,
      aux_sym_long_identifier_repeat1,
    STATE(3280), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2791), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2794), 19,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [32904] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5379), 1,
      anon_sym_DOT,
    STATE(3286), 1,
      aux_sym_long_identifier_repeat1,
    STATE(3281), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2312), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2314), 19,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [32973] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3282), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2627), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2629), 20,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [33038] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5381), 1,
      anon_sym_DOT,
    STATE(3290), 1,
      aux_sym_long_identifier_repeat1,
    STATE(3283), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2791), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2794), 19,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [33107] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5383), 1,
      anon_sym_DOT,
    STATE(3284), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_long_identifier_repeat1,
    ACTIONS(2411), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2413), 18,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [33174] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3285), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2466), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2468), 20,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [33239] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5379), 1,
      anon_sym_DOT,
    STATE(3297), 1,
      aux_sym_long_identifier_repeat1,
    STATE(3286), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2418), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2420), 19,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [33308] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3287), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2474), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2476), 20,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [33373] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3288), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2510), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2512), 20,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [33438] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5386), 1,
      anon_sym_LT2,
    STATE(3289), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2557), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2559), 19,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [33505] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5381), 1,
      anon_sym_DOT,
    STATE(3311), 1,
      aux_sym_long_identifier_repeat1,
    STATE(3290), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2418), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2420), 19,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [33574] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(4811), 1,
      aux_sym_decimal_token1,
    ACTIONS(4933), 1,
      anon_sym_f,
    STATE(3291), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2158), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2160), 19,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [33643] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5388), 1,
      anon_sym_DOT,
    STATE(3313), 1,
      aux_sym_long_identifier_repeat1,
    STATE(3292), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2312), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2314), 18,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [33712] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5390), 1,
      aux_sym_float_token1,
    STATE(3293), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2723), 15,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      anon_sym_f,
      aux_sym_decimal_token1,
      sym_identifier,
    ACTIONS(2725), 17,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [33779] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3294), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2567), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2569), 20,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [33844] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5381), 1,
      anon_sym_DOT,
    STATE(3290), 1,
      aux_sym_long_identifier_repeat1,
    STATE(3295), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2312), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2314), 19,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [33913] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3296), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2506), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2508), 20,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [33978] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5392), 1,
      anon_sym_DOT,
    STATE(3297), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_long_identifier_repeat1,
    ACTIONS(2411), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2413), 19,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [34045] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3298), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2411), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2413), 21,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [34110] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5377), 1,
      anon_sym_or,
    STATE(3300), 1,
      aux_sym_type_argument_repeat1,
    STATE(3299), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2328), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2330), 19,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [34179] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5395), 1,
      anon_sym_or,
    STATE(3300), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_type_argument_repeat1,
    ACTIONS(2340), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2342), 19,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [34246] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3301), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2470), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2472), 20,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [34311] = 13,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5373), 1,
      anon_sym_DOT,
    ACTIONS(5398), 1,
      anon_sym_EQ,
    STATE(3274), 1,
      aux_sym_long_identifier_repeat1,
    STATE(3302), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2791), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2794), 18,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [34382] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5400), 1,
      anon_sym_or,
    STATE(3314), 1,
      aux_sym_type_argument_repeat1,
    STATE(3303), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2328), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2330), 19,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [34451] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3304), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2454), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2456), 20,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [34516] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(4839), 1,
      aux_sym_decimal_token1,
    ACTIONS(4901), 1,
      anon_sym_f,
    STATE(3305), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2158), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2160), 19,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [34585] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5406), 1,
      anon_sym_and,
    STATE(3306), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_type_argument_constraints_repeat1,
    ACTIONS(5402), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(5404), 19,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [34652] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5413), 1,
      anon_sym_and,
    STATE(3306), 1,
      aux_sym_type_argument_constraints_repeat1,
    STATE(3307), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5409), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(5411), 19,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [34721] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3308), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2812), 14,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      anon_sym_f,
      aux_sym_decimal_token1,
      sym_identifier,
    ACTIONS(2814), 19,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [34786] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5415), 1,
      aux_sym_float_token1,
    STATE(3309), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2723), 14,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      anon_sym_f,
      aux_sym_decimal_token1,
      sym_identifier,
    ACTIONS(2725), 18,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [34853] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5413), 1,
      anon_sym_and,
    STATE(3307), 1,
      aux_sym_type_argument_constraints_repeat1,
    STATE(3310), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5417), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(5419), 19,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [34922] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5421), 1,
      anon_sym_DOT,
    STATE(3311), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_long_identifier_repeat1,
    ACTIONS(2411), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2413), 19,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [34989] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3312), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2723), 14,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      anon_sym_f,
      aux_sym_decimal_token1,
      sym_identifier,
    ACTIONS(2725), 19,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [35054] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5388), 1,
      anon_sym_DOT,
    STATE(3284), 1,
      aux_sym_long_identifier_repeat1,
    STATE(3313), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2418), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2420), 18,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [35123] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5424), 1,
      anon_sym_or,
    STATE(3314), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_type_argument_repeat1,
    ACTIONS(2340), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2342), 19,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [35190] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3315), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2723), 14,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      anon_sym_f,
      aux_sym_decimal_token1,
      sym_identifier,
    ACTIONS(2725), 19,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [35255] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5427), 1,
      sym_int,
    STATE(3316), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2819), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      anon_sym_f,
      aux_sym_decimal_token1,
      sym_identifier,
    ACTIONS(2821), 19,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [35322] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3317), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2812), 14,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      anon_sym_f,
      aux_sym_decimal_token1,
      sym_identifier,
    ACTIONS(2814), 19,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [35387] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5400), 1,
      anon_sym_or,
    STATE(3303), 1,
      aux_sym_type_argument_repeat1,
    STATE(3318), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2321), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2323), 19,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [35456] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3319), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2812), 15,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      anon_sym_f,
      aux_sym_decimal_token1,
      sym_identifier,
    ACTIONS(2814), 17,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [35520] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5429), 1,
      anon_sym_DOT,
    STATE(3320), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2867), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2869), 19,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [35586] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3397), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(3321), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5431), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(5433), 19,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [35652] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5435), 1,
      aux_sym_float_token1,
    STATE(3322), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2723), 15,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      anon_sym_f,
      aux_sym_decimal_token1,
      sym_identifier,
    ACTIONS(2725), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [35718] = 22,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5311), 1,
      anon_sym_y,
    ACTIONS(5313), 1,
      anon_sym_uy,
    ACTIONS(5315), 1,
      anon_sym_s,
    ACTIONS(5317), 1,
      anon_sym_us,
    ACTIONS(5319), 1,
      anon_sym_l,
    ACTIONS(5321), 1,
      aux_sym_uint32_token1,
    ACTIONS(5323), 1,
      anon_sym_n,
    ACTIONS(5325), 1,
      anon_sym_un,
    ACTIONS(5327), 1,
      anon_sym_L,
    ACTIONS(5329), 1,
      aux_sym_uint64_token1,
    ACTIONS(5437), 1,
      anon_sym_lf,
    ACTIONS(5439), 1,
      anon_sym_LF,
    STATE(3323), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2158), 9,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(2160), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [35806] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5379), 1,
      anon_sym_DOT,
    STATE(3286), 1,
      aux_sym_long_identifier_repeat1,
    STATE(3324), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2791), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2794), 18,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [35874] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3325), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2723), 14,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      anon_sym_f,
      aux_sym_decimal_token1,
      sym_identifier,
    ACTIONS(2725), 18,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [35938] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5388), 1,
      anon_sym_DOT,
    STATE(3313), 1,
      aux_sym_long_identifier_repeat1,
    STATE(3326), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2791), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2794), 17,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [36006] = 13,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5441), 1,
      anon_sym_EQ,
    ACTIONS(5443), 1,
      anon_sym_DOT,
    STATE(3393), 1,
      aux_sym_long_identifier_repeat1,
    STATE(3327), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2791), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2794), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [36076] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5445), 1,
      anon_sym_or,
    STATE(3337), 1,
      aux_sym_type_argument_repeat1,
    STATE(3328), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2321), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2323), 18,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [36144] = 13,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5443), 1,
      anon_sym_DOT,
    ACTIONS(5447), 1,
      anon_sym_EQ,
    STATE(3393), 1,
      aux_sym_long_identifier_repeat1,
    STATE(3329), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2791), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2794), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [36214] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3330), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2723), 15,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      anon_sym_f,
      aux_sym_decimal_token1,
      sym_identifier,
    ACTIONS(2725), 17,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [36278] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5449), 1,
      anon_sym_and,
    STATE(3338), 1,
      aux_sym_type_argument_constraints_repeat1,
    STATE(3331), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5409), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(5411), 18,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [36346] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(4867), 1,
      aux_sym_decimal_token1,
    ACTIONS(4941), 1,
      anon_sym_f,
    STATE(3332), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2158), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2160), 18,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [36414] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3333), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2812), 14,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      anon_sym_f,
      aux_sym_decimal_token1,
      sym_identifier,
    ACTIONS(2814), 18,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [36478] = 29,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5451), 1,
      sym_identifier,
    ACTIONS(5453), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(5455), 1,
      anon_sym_LPAREN,
    ACTIONS(5457), 1,
      anon_sym__,
    ACTIONS(5459), 1,
      anon_sym_QMARK,
    ACTIONS(5461), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(5463), 1,
      anon_sym_POUND,
    STATE(3419), 1,
      aux_sym_curried_spec_repeat1,
    STATE(3784), 1,
      sym_attributes,
    STATE(3848), 1,
      sym_argument_name_spec,
    STATE(4162), 1,
      sym__type,
    STATE(4182), 1,
      sym__static_type_identifier,
    STATE(4223), 1,
      sym_type_argument,
    STATE(4259), 1,
      sym_long_identifier,
    STATE(4813), 1,
      sym_curried_spec,
    STATE(4914), 1,
      aux_sym_attributes_repeat1,
    STATE(5352), 1,
      sym__attribute_set,
    STATE(5806), 1,
      sym_argument_spec,
    STATE(6742), 1,
      sym_arguments_spec,
    ACTIONS(5465), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3334), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4263), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [36580] = 13,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5443), 1,
      anon_sym_DOT,
    ACTIONS(5467), 1,
      anon_sym_EQ,
    STATE(3393), 1,
      aux_sym_long_identifier_repeat1,
    STATE(3335), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2791), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2794), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [36650] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3336), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5402), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(5404), 19,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [36714] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5445), 1,
      anon_sym_or,
    STATE(3341), 1,
      aux_sym_type_argument_repeat1,
    STATE(3337), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2328), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2330), 18,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [36782] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5469), 1,
      anon_sym_and,
    STATE(3338), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_type_argument_constraints_repeat1,
    ACTIONS(5402), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(5404), 18,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [36848] = 13,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5443), 1,
      anon_sym_DOT,
    ACTIONS(5472), 1,
      anon_sym_EQ,
    STATE(3393), 1,
      aux_sym_long_identifier_repeat1,
    STATE(3339), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2791), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2794), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [36918] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3397), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(3340), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5474), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(5476), 19,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [36984] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5478), 1,
      anon_sym_or,
    STATE(3341), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_type_argument_repeat1,
    ACTIONS(2340), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2342), 18,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [37050] = 13,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5443), 1,
      anon_sym_DOT,
    ACTIONS(5481), 1,
      anon_sym_EQ,
    STATE(3393), 1,
      aux_sym_long_identifier_repeat1,
    STATE(3342), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2791), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2794), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [37120] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5483), 1,
      sym_int,
    STATE(3343), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2819), 14,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      anon_sym_f,
      aux_sym_decimal_token1,
      sym_identifier,
    ACTIONS(2821), 17,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [37186] = 13,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5443), 1,
      anon_sym_DOT,
    ACTIONS(5485), 1,
      anon_sym_EQ,
    STATE(3393), 1,
      aux_sym_long_identifier_repeat1,
    STATE(3344), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2791), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2794), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [37256] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3345), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5009), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(5011), 19,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [37320] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3346), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5487), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(5489), 19,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [37384] = 16,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(3849), 1,
      anon_sym_as,
    ACTIONS(3851), 1,
      anon_sym_COMMA,
    ACTIONS(3853), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3855), 1,
      anon_sym_PIPE,
    ACTIONS(3857), 1,
      anon_sym_AMP,
    STATE(3362), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(3347), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5491), 11,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(5493), 15,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [37460] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5449), 1,
      anon_sym_and,
    STATE(3331), 1,
      aux_sym_type_argument_constraints_repeat1,
    STATE(3348), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5417), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(5419), 18,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [37528] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5495), 1,
      anon_sym_and,
    STATE(3352), 1,
      aux_sym_type_argument_constraints_repeat1,
    STATE(3349), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5417), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(5419), 18,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [37596] = 13,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5443), 1,
      anon_sym_DOT,
    ACTIONS(5497), 1,
      anon_sym_EQ,
    STATE(3393), 1,
      aux_sym_long_identifier_repeat1,
    STATE(3350), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2791), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2794), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [37666] = 13,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5443), 1,
      anon_sym_DOT,
    ACTIONS(5499), 1,
      anon_sym_EQ,
    STATE(3393), 1,
      aux_sym_long_identifier_repeat1,
    STATE(3351), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2791), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2794), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [37736] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5495), 1,
      anon_sym_and,
    STATE(3360), 1,
      aux_sym_type_argument_constraints_repeat1,
    STATE(3352), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5409), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(5411), 18,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [37804] = 13,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5443), 1,
      anon_sym_DOT,
    ACTIONS(5501), 1,
      anon_sym_EQ,
    STATE(3393), 1,
      aux_sym_long_identifier_repeat1,
    STATE(3353), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2791), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2794), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [37874] = 16,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(3718), 1,
      anon_sym_as,
    ACTIONS(3720), 1,
      anon_sym_COMMA,
    ACTIONS(3722), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3724), 1,
      anon_sym_PIPE,
    ACTIONS(3726), 1,
      anon_sym_AMP,
    STATE(3397), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(3354), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5491), 11,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(5493), 15,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [37950] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5507), 1,
      anon_sym_COMMA,
    STATE(3355), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_repeat_pattern_repeat1,
    ACTIONS(5503), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(5505), 18,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [38016] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5510), 1,
      anon_sym_DOT,
    STATE(3356), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_long_identifier_repeat1,
    ACTIONS(2411), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2413), 17,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [38082] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5513), 1,
      anon_sym_COMMA,
    STATE(3357), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_repeat_pattern_repeat1,
    ACTIONS(5503), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(5505), 18,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [38148] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3358), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5516), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(5518), 19,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [38212] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3359), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5520), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(5522), 19,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [38276] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5524), 1,
      anon_sym_and,
    STATE(3360), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_type_argument_constraints_repeat1,
    ACTIONS(5402), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(5404), 18,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [38342] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3361), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5527), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(5529), 19,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [38406] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(3851), 1,
      anon_sym_COMMA,
    STATE(3357), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(3362), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5531), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(5533), 18,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [38474] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5535), 1,
      anon_sym_DOT,
    STATE(3363), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2867), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2869), 19,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [38540] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5443), 1,
      anon_sym_DOT,
    STATE(3393), 1,
      aux_sym_long_identifier_repeat1,
    STATE(3364), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2312), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2314), 17,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [38608] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3397), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(3365), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5537), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(5539), 19,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [38674] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5541), 1,
      anon_sym_or,
    STATE(3367), 1,
      aux_sym_type_argument_repeat1,
    STATE(3366), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2328), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2330), 17,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [38742] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5543), 1,
      anon_sym_or,
    STATE(3367), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_type_argument_repeat1,
    ACTIONS(2340), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2342), 17,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [38808] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3368), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2411), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2413), 20,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DOT,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [38872] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3369), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2462), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_or,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2464), 19,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [38936] = 13,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5443), 1,
      anon_sym_DOT,
    ACTIONS(5546), 1,
      anon_sym_EQ,
    STATE(3393), 1,
      aux_sym_long_identifier_repeat1,
    STATE(3370), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2791), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2794), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [39006] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5541), 1,
      anon_sym_or,
    STATE(3366), 1,
      aux_sym_type_argument_repeat1,
    STATE(3371), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2321), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2323), 17,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [39074] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3372), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2340), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_or,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2342), 19,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [39138] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5548), 1,
      anon_sym_and,
    STATE(3374), 1,
      aux_sym_type_argument_constraints_repeat1,
    STATE(3373), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5417), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(5419), 18,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [39206] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5548), 1,
      anon_sym_and,
    STATE(3375), 1,
      aux_sym_type_argument_constraints_repeat1,
    STATE(3374), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5409), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(5411), 18,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [39274] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5550), 1,
      anon_sym_and,
    STATE(3375), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_type_argument_constraints_repeat1,
    ACTIONS(5402), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(5404), 18,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [39340] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(4895), 1,
      aux_sym_decimal_token1,
    ACTIONS(4937), 1,
      anon_sym_f,
    STATE(3376), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2158), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2160), 17,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [39408] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5553), 1,
      anon_sym_and,
    STATE(3380), 1,
      aux_sym_type_argument_constraints_repeat1,
    STATE(3377), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5417), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(5419), 17,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [39476] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3378), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5527), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(5529), 19,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [39540] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3379), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2462), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_or,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2464), 19,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [39604] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5553), 1,
      anon_sym_and,
    STATE(3383), 1,
      aux_sym_type_argument_constraints_repeat1,
    STATE(3380), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5409), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(5411), 17,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [39672] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3381), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5520), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(5522), 19,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [39736] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3382), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5516), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(5518), 19,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [39800] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5555), 1,
      anon_sym_and,
    STATE(3383), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_type_argument_constraints_repeat1,
    ACTIONS(5402), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(5404), 17,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [39866] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3384), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5013), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(5015), 19,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [39930] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3397), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(3385), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5558), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(5560), 19,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [39996] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3386), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5487), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(5489), 19,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [40060] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3387), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5009), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(5011), 19,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [40124] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3388), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5013), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(5015), 19,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [40188] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3389), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5402), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(5404), 19,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [40252] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3397), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(3390), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5562), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(5564), 19,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [40318] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3397), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(3391), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5503), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(5505), 19,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [40384] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5566), 1,
      sym_int,
    STATE(3392), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2819), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      anon_sym_f,
      aux_sym_decimal_token1,
      sym_identifier,
    ACTIONS(2821), 18,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [40450] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5443), 1,
      anon_sym_DOT,
    STATE(3356), 1,
      aux_sym_long_identifier_repeat1,
    STATE(3393), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2418), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2420), 17,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [40518] = 13,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5443), 1,
      anon_sym_DOT,
    ACTIONS(5568), 1,
      anon_sym_EQ,
    STATE(3393), 1,
      aux_sym_long_identifier_repeat1,
    STATE(3394), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2791), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2794), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [40588] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3362), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(3395), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5537), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(5539), 19,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [40654] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3396), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2411), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2413), 20,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DOT,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [40718] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(3720), 1,
      anon_sym_COMMA,
    STATE(3355), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(3397), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5531), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(5533), 18,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [40786] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3362), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(3398), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5558), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(5560), 19,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [40852] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3362), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(3399), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5562), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(5564), 19,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [40918] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3362), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(3400), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5503), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(5505), 19,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [40984] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3401), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2340), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_or,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2342), 19,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [41048] = 29,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5451), 1,
      sym_identifier,
    ACTIONS(5453), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(5455), 1,
      anon_sym_LPAREN,
    ACTIONS(5457), 1,
      anon_sym__,
    ACTIONS(5459), 1,
      anon_sym_QMARK,
    ACTIONS(5461), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(5463), 1,
      anon_sym_POUND,
    STATE(3419), 1,
      aux_sym_curried_spec_repeat1,
    STATE(3784), 1,
      sym_attributes,
    STATE(3848), 1,
      sym_argument_name_spec,
    STATE(4162), 1,
      sym__type,
    STATE(4182), 1,
      sym__static_type_identifier,
    STATE(4223), 1,
      sym_type_argument,
    STATE(4259), 1,
      sym_long_identifier,
    STATE(4800), 1,
      sym_curried_spec,
    STATE(4914), 1,
      aux_sym_attributes_repeat1,
    STATE(5352), 1,
      sym__attribute_set,
    STATE(5806), 1,
      sym_argument_spec,
    STATE(6742), 1,
      sym_arguments_spec,
    ACTIONS(5465), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3402), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4263), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [41150] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3362), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(3403), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5474), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(5476), 19,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [41216] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3404), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2411), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2413), 19,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [41280] = 13,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5443), 1,
      anon_sym_DOT,
    ACTIONS(5570), 1,
      anon_sym_EQ,
    STATE(3393), 1,
      aux_sym_long_identifier_repeat1,
    STATE(3405), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2791), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2794), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [41350] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5576), 1,
      anon_sym_LT2,
    STATE(3406), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5572), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(5574), 19,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [41416] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3362), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(3407), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5431), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(5433), 19,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [41482] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3408), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3031), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3033), 19,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [41545] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3409), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5516), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(5518), 18,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [41608] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3410), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2867), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2869), 19,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [41671] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5443), 1,
      anon_sym_DOT,
    STATE(3393), 1,
      aux_sym_long_identifier_repeat1,
    STATE(3411), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2791), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2794), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [41738] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3412), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2934), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2936), 19,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [41801] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3413), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2934), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2936), 19,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [41864] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3414), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2462), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_or,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2464), 18,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [41927] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3415), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2970), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2972), 19,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [41990] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5578), 1,
      anon_sym_and,
    STATE(3420), 1,
      aux_sym_type_argument_constraints_repeat1,
    STATE(3416), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5417), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(5419), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [42057] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3417), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5580), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(5582), 19,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [42120] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3418), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5584), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(5586), 19,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [42183] = 28,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5451), 1,
      sym_identifier,
    ACTIONS(5453), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(5455), 1,
      anon_sym_LPAREN,
    ACTIONS(5457), 1,
      anon_sym__,
    ACTIONS(5459), 1,
      anon_sym_QMARK,
    ACTIONS(5461), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(5463), 1,
      anon_sym_POUND,
    STATE(3532), 1,
      aux_sym_curried_spec_repeat1,
    STATE(3784), 1,
      sym_attributes,
    STATE(3848), 1,
      sym_argument_name_spec,
    STATE(4146), 1,
      sym__type,
    STATE(4182), 1,
      sym__static_type_identifier,
    STATE(4223), 1,
      sym_type_argument,
    STATE(4259), 1,
      sym_long_identifier,
    STATE(4914), 1,
      aux_sym_attributes_repeat1,
    STATE(5352), 1,
      sym__attribute_set,
    STATE(5806), 1,
      sym_argument_spec,
    STATE(6742), 1,
      sym_arguments_spec,
    ACTIONS(5465), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3419), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4263), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [42282] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5578), 1,
      anon_sym_and,
    STATE(3425), 1,
      aux_sym_type_argument_constraints_repeat1,
    STATE(3420), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5409), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(5411), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [42349] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5588), 1,
      anon_sym_or,
    STATE(3523), 1,
      aux_sym_type_argument_repeat1,
    STATE(3421), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2321), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2323), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [42416] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3422), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5590), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(5592), 19,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [42479] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3423), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5594), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(5596), 19,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [42542] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3424), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5598), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(5600), 19,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [42605] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5602), 1,
      anon_sym_and,
    STATE(3425), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_type_argument_constraints_repeat1,
    ACTIONS(5402), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(5404), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [42670] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3426), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5605), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(5607), 19,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [42733] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3427), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2340), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_or,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2342), 18,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [42796] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3428), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5609), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(5611), 19,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [42859] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3429), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2321), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2323), 19,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [42922] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3430), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2984), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2986), 19,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [42985] = 16,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(4125), 1,
      anon_sym_as,
    ACTIONS(4127), 1,
      anon_sym_COMMA,
    ACTIONS(4129), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4131), 1,
      anon_sym_PIPE,
    ACTIONS(4133), 1,
      anon_sym_AMP,
    STATE(3452), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(3431), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5491), 12,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(5493), 13,
      anon_sym_LBRACK_LT,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [43060] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5613), 1,
      anon_sym_COMMA,
    STATE(3432), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_repeat_pattern_repeat1,
    ACTIONS(5503), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(5505), 16,
      anon_sym_LBRACK_LT,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [43125] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3433), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2984), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2986), 19,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [43188] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3434), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2942), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2944), 19,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [43251] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5616), 1,
      anon_sym_LT2,
    STATE(3435), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5572), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(5574), 18,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [43316] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3436), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5618), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(5620), 19,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [43379] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5622), 1,
      anon_sym_DOT,
    STATE(3437), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2867), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2869), 18,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [43444] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3438), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5624), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(5626), 19,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [43507] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3439), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2954), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2956), 19,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [43570] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3440), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5572), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(5574), 19,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [43633] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3441), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5628), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(5630), 19,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [43696] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3442), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3035), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3037), 19,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [43759] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3443), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3031), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3033), 19,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [43822] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3444), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3027), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3029), 19,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [43885] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3445), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3023), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3025), 19,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [43948] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3446), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3019), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3021), 19,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [44011] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3555), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(3447), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5431), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(5433), 18,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [44076] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5632), 1,
      anon_sym_LT2,
    STATE(3448), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5572), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(5574), 18,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [44141] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3449), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2988), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2990), 19,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [44204] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3450), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5634), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(5636), 19,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [44267] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3451), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5638), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(5640), 19,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [44330] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(4127), 1,
      anon_sym_COMMA,
    STATE(3432), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(3452), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5531), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(5533), 16,
      anon_sym_LBRACK_LT,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [44397] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3453), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5624), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(5626), 19,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [44460] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3454), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5642), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(5644), 19,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [44523] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5650), 1,
      anon_sym_as,
    STATE(3455), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5646), 11,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(5648), 19,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [44588] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3456), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2974), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2976), 19,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [44651] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3457), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2966), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2968), 19,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [44714] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3458), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2942), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2944), 19,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [44777] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3459), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3115), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3117), 19,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [44840] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3460), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5598), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(5600), 19,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [44903] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3461), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5594), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(5596), 19,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [44966] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3462), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5590), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(5592), 19,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [45029] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3463), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2462), 14,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_or,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2464), 17,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [45092] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3464), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2962), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2964), 19,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [45155] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3465), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2958), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2960), 19,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [45218] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3466), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2950), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2952), 19,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [45281] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3467), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2946), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2948), 19,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [45344] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3468), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2938), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2940), 19,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [45407] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3469), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2926), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2928), 19,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [45470] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3470), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2922), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2924), 19,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [45533] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3471), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2918), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2920), 19,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [45596] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3472), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2914), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2916), 19,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [45659] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3473), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2910), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2912), 19,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [45722] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3474), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5652), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(5654), 19,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [45785] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3555), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(3475), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5474), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(5476), 18,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [45850] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3476), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2988), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2990), 19,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [45913] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3477), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3095), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3097), 19,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [45976] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3478), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2340), 14,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_or,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2342), 17,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [46039] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3479), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2954), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2956), 19,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [46102] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3480), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2891), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2893), 19,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [46165] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3481), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2887), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2889), 19,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [46228] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3482), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2883), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2885), 19,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [46291] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3483), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2877), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2879), 19,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [46354] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3484), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2873), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2875), 19,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [46417] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3485), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5605), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(5607), 19,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [46480] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3486), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5609), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(5611), 19,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [46543] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3487), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3011), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3013), 19,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [46606] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3488), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2863), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2865), 19,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [46669] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(4927), 1,
      aux_sym_decimal_token1,
    ACTIONS(4945), 1,
      anon_sym_f,
    STATE(3489), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2158), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2160), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [46736] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3490), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5652), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(5654), 19,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [46799] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3555), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(3491), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5503), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(5505), 18,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [46864] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3492), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5642), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(5644), 19,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [46927] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5656), 1,
      anon_sym_DOT,
    STATE(3493), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2867), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2869), 17,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [46992] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3494), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2859), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2861), 19,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [47055] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3495), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2855), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2857), 19,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [47118] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3555), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(3496), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5562), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(5564), 18,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [47183] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3497), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2158), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2160), 19,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [47246] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3498), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2843), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2845), 19,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [47309] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5658), 1,
      anon_sym_or,
    STATE(3499), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_type_argument_repeat1,
    ACTIONS(2340), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2342), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [47374] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3500), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5638), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(5640), 19,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [47437] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3555), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(3501), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5558), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(5560), 18,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [47502] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3555), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(3502), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5537), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(5539), 18,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [47567] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3503), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5634), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(5636), 19,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [47630] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3504), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3115), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3117), 19,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [47693] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3505), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5628), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(5630), 19,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [47756] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3506), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5661), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(5663), 19,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [47819] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3507), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5665), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(5667), 19,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [47882] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3508), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2843), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2845), 19,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [47945] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3509), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2158), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2160), 19,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [48008] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3510), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2867), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2869), 19,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [48071] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3511), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5527), 14,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(5529), 17,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [48134] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3512), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5520), 14,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(5522), 17,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [48197] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3513), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5516), 14,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(5518), 17,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [48260] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3514), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5487), 14,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(5489), 17,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [48323] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3515), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5009), 14,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(5011), 17,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [48386] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3516), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5013), 14,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(5015), 17,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [48449] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3517), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2855), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2857), 19,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [48512] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3518), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5402), 14,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(5404), 17,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [48575] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3519), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2859), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2861), 19,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [48638] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3520), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5618), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(5620), 19,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [48701] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3521), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2863), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2865), 19,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [48764] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3522), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2411), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2413), 18,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DOT,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [48827] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5588), 1,
      anon_sym_or,
    STATE(3499), 1,
      aux_sym_type_argument_repeat1,
    STATE(3523), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2328), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2330), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [48894] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3524), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3035), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3037), 19,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [48957] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3525), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3095), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3097), 19,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [49020] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3526), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2812), 15,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      anon_sym_f,
      aux_sym_decimal_token1,
      sym_identifier,
    ACTIONS(2814), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [49083] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3527), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3027), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3029), 19,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [49146] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3528), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2970), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2972), 19,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [49209] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3529), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3023), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3025), 19,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [49272] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3530), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5402), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(5404), 18,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [49335] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3531), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3019), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3021), 19,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [49398] = 27,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5669), 1,
      sym_identifier,
    ACTIONS(5672), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(5675), 1,
      anon_sym_LPAREN,
    ACTIONS(5678), 1,
      anon_sym__,
    ACTIONS(5681), 1,
      anon_sym_QMARK,
    ACTIONS(5684), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(5687), 1,
      anon_sym_POUND,
    STATE(3784), 1,
      sym_attributes,
    STATE(3848), 1,
      sym_argument_name_spec,
    STATE(4686), 1,
      sym__static_type_identifier,
    STATE(4913), 1,
      sym_type_argument,
    STATE(4914), 1,
      aux_sym_attributes_repeat1,
    STATE(5121), 1,
      sym_long_identifier,
    STATE(5352), 1,
      sym__attribute_set,
    STATE(5470), 1,
      sym__type,
    STATE(5806), 1,
      sym_argument_spec,
    STATE(6742), 1,
      sym_arguments_spec,
    ACTIONS(5690), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3532), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_curried_spec_repeat1,
    STATE(5109), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [49495] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3533), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5013), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(5015), 18,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [49558] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3534), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5584), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(5586), 19,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [49621] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3535), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5009), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(5011), 18,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [49684] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3536), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5487), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(5489), 18,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [49747] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3452), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(3537), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5431), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(5433), 17,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [49812] = 16,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(4075), 1,
      anon_sym_as,
    ACTIONS(4079), 1,
      anon_sym_COMMA,
    ACTIONS(4089), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4091), 1,
      anon_sym_PIPE,
    ACTIONS(4093), 1,
      anon_sym_AMP,
    STATE(3555), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(3538), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5491), 11,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(5493), 14,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [49887] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5693), 1,
      anon_sym_COMMA,
    STATE(3539), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_repeat_pattern_repeat1,
    ACTIONS(5503), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(5505), 17,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [49952] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3452), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(3540), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5537), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(5539), 17,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [50017] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3452), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(3541), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5558), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(5560), 17,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [50082] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3452), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(3542), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5562), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(5564), 17,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [50147] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3452), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(3543), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5503), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(5505), 17,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [50212] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3544), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5665), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(5667), 19,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [50275] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3545), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2723), 15,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      anon_sym_f,
      aux_sym_decimal_token1,
      sym_identifier,
    ACTIONS(2725), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [50338] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3546), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5661), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(5663), 19,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [50401] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5696), 1,
      anon_sym_as,
    STATE(3547), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5646), 11,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(5648), 19,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [50466] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3548), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5572), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(5574), 19,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [50529] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3549), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2873), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2875), 19,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [50592] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3550), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2877), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2879), 19,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [50655] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3551), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2883), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2885), 19,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [50718] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3552), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2887), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2889), 19,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [50781] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3553), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2891), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2893), 19,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [50844] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3554), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2910), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2912), 19,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [50907] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(4079), 1,
      anon_sym_COMMA,
    STATE(3539), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(3555), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5531), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(5533), 17,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [50974] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3452), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(3556), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5474), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(5476), 17,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [51039] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3557), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2914), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2916), 19,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [51102] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3558), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2918), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2920), 19,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [51165] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3559), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2922), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2924), 19,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [51228] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5698), 1,
      anon_sym_LT2,
    STATE(3560), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5572), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(5574), 17,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [51293] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3561), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2926), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2928), 19,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [51356] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3562), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2321), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2323), 19,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [51419] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3563), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2946), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2948), 19,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [51482] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3564), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2950), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2952), 19,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [51545] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3565), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2958), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2960), 19,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [51608] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3566), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2962), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2964), 19,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [51671] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3567), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2966), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2968), 19,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [51734] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3568), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2974), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2976), 19,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [51797] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3569), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3011), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3013), 19,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [51860] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5700), 1,
      sym_int,
    STATE(3570), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2819), 14,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      anon_sym_f,
      aux_sym_decimal_token1,
      sym_identifier,
    ACTIONS(2821), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [51925] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3571), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2938), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2940), 19,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [51988] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3572), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5527), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(5529), 18,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [52051] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3573), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5580), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(5582), 19,
      sym__newline,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [52114] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3574), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5520), 13,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(5522), 18,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [52177] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3575), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2914), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2916), 18,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [52239] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3576), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3095), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3097), 17,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [52301] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3577), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2946), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2948), 18,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [52363] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3578), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5598), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(5600), 18,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [52425] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3579), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5618), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(5620), 17,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [52487] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3580), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5594), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(5596), 18,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [52549] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3581), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5590), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(5592), 18,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [52611] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3687), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(3582), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5503), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(5505), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [52675] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3583), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2984), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2986), 17,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [52737] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3584), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5584), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(5586), 17,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [52799] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3585), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3035), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3037), 17,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [52861] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3586), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5580), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(5582), 17,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [52923] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3587), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5665), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(5667), 17,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [52985] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3588), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5661), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(5663), 17,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [53047] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3589), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2918), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2920), 18,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [53109] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3590), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2950), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2952), 18,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [53171] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3591), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3031), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3033), 17,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [53233] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3687), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(3592), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5562), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(5564), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [53297] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3687), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(3593), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5558), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(5560), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [53361] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3687), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(3594), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5537), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(5539), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [53425] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3595), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5605), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(5607), 18,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [53487] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3596), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3027), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3029), 17,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [53549] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3687), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(3597), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5474), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(5476), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [53613] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3598), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3115), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3117), 17,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [53675] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3599), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3023), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3025), 17,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [53737] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3600), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5609), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(5611), 18,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [53799] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3601), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3019), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3021), 17,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [53861] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3602), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2321), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2323), 18,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [53923] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5702), 1,
      anon_sym_LT2,
    STATE(3603), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5572), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(5574), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [53987] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3604), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2958), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2960), 18,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [54049] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3605), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5572), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(5574), 17,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [54111] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3606), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2158), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2160), 18,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [54173] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3607), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5628), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(5630), 17,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [54235] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3608), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5634), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(5636), 17,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [54297] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3609), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2962), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2964), 18,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [54359] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3610), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5638), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(5640), 17,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [54421] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3611), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5624), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(5626), 18,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [54483] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3612), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5642), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(5644), 17,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [54545] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3613), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2863), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2865), 17,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [54607] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3614), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2462), 14,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_or,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2464), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [54669] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3615), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2966), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2968), 18,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [54731] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3616), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3095), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3097), 18,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [54793] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3617), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5402), 14,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(5404), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [54855] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3618), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5652), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(5654), 17,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [54917] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3619), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3011), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3013), 18,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [54979] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3620), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5013), 14,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(5015), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [55041] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3621), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2934), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2936), 18,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [55103] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3622), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5009), 14,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(5011), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [55165] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3623), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2988), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2990), 18,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [55227] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3624), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5652), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(5654), 18,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [55289] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3625), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5487), 14,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(5489), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [55351] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3626), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5516), 14,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(5518), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [55413] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3627), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5520), 14,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(5522), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [55475] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3628), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5642), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(5644), 18,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [55537] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3629), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2970), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2972), 18,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [55599] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3630), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5527), 14,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(5529), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [55661] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3631), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5638), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(5640), 18,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [55723] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3632), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5634), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(5636), 18,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [55785] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3633), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5628), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(5630), 18,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [55847] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3634), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5624), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(5626), 17,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [55909] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3635), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2954), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2956), 17,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [55971] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3636), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2954), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2956), 18,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [56033] = 16,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(4198), 1,
      anon_sym_as,
    ACTIONS(4200), 1,
      anon_sym_COMMA,
    ACTIONS(4206), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4208), 1,
      anon_sym_PIPE,
    ACTIONS(4210), 1,
      anon_sym_AMP,
    STATE(3687), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(3637), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5491), 12,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(5493), 12,
      anon_sym_LBRACK_LT,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [56107] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5704), 1,
      anon_sym_COMMA,
    STATE(3638), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_repeat_pattern_repeat1,
    ACTIONS(5503), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(5505), 15,
      anon_sym_LBRACK_LT,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [56171] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3687), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(3639), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5431), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(5433), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [56235] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3640), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5661), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(5663), 18,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [56297] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3641), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2926), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2928), 18,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [56359] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3642), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5665), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(5667), 18,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [56421] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3643), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2934), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2936), 17,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [56483] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3644), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2910), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2912), 18,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [56545] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3645), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2891), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2893), 18,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [56607] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3646), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2340), 14,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_or,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2342), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [56669] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3647), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2887), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2889), 18,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [56731] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3648), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2883), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2885), 18,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [56793] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3649), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2877), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2879), 18,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [56855] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3650), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2867), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2869), 17,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [56917] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3651), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5618), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(5620), 18,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [56979] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3652), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2873), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2875), 18,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [57041] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3653), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2863), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2865), 18,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [57103] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3654), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2942), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2944), 18,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [57165] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5707), 1,
      anon_sym_DOT,
    STATE(3655), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2867), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2869), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [57229] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3656), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2974), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2976), 18,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [57291] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3657), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2843), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2845), 17,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [57353] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3658), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2158), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2160), 17,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [57415] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3659), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2942), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2944), 17,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [57477] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3660), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2867), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2869), 18,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [57539] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3661), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2974), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2976), 17,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [57601] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3662), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2966), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2968), 17,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [57663] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3663), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3115), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3117), 18,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [57725] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3664), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5598), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(5600), 17,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [57787] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3665), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2962), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2964), 17,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [57849] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3666), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2958), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2960), 17,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [57911] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3667), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2970), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2972), 17,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [57973] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3668), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2950), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2952), 17,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [58035] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3669), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2988), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2990), 17,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [58097] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3670), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2855), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2857), 17,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [58159] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3671), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5584), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(5586), 18,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [58221] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3672), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5580), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(5582), 18,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [58283] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3673), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2859), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2861), 17,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [58345] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3674), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2984), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2986), 18,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [58407] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3675), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2938), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2940), 18,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [58469] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3676), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2946), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2948), 17,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [58531] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3677), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5594), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(5596), 17,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [58593] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3678), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2843), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2845), 18,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [58655] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3679), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2922), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2924), 18,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [58717] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5709), 1,
      anon_sym_as,
    STATE(3680), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5646), 11,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(5648), 18,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [58781] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3681), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2938), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2940), 17,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [58843] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3682), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3011), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3013), 17,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [58905] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3683), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5609), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(5611), 17,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [58967] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5711), 1,
      anon_sym_as,
    STATE(3684), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5646), 12,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(5648), 17,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [59031] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3685), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5605), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(5607), 17,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [59093] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3686), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2859), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2861), 18,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [59155] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(4200), 1,
      anon_sym_COMMA,
    STATE(3638), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(3687), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5531), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(5533), 15,
      anon_sym_LBRACK_LT,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [59221] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3688), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2855), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2857), 18,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [59283] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3689), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5572), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(5574), 18,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [59345] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3690), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2873), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2875), 17,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [59407] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3691), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5590), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(5592), 17,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [59469] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3692), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3035), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3037), 18,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [59531] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3693), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2877), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2879), 17,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [59593] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3694), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2321), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2323), 17,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [59655] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3695), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2926), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2928), 17,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [59717] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3696), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2883), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2885), 17,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [59779] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3697), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2887), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2889), 17,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [59841] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3698), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2891), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2893), 17,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [59903] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3699), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2910), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2912), 17,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [59965] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3700), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2922), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2924), 17,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [60027] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3701), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2914), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2916), 17,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [60089] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3702), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3031), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3033), 18,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [60151] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3703), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3027), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3029), 18,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [60213] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3704), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3023), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3025), 18,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [60275] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3705), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3019), 12,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3021), 18,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [60337] = 17,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(3718), 1,
      anon_sym_as,
    ACTIONS(3720), 1,
      anon_sym_COMMA,
    ACTIONS(3722), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3724), 1,
      anon_sym_PIPE,
    ACTIONS(3726), 1,
      anon_sym_AMP,
    ACTIONS(5717), 1,
      anon_sym_COLON,
    STATE(3397), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(3706), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5713), 10,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(5715), 13,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [60413] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3707), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2918), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_when,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2920), 17,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [60475] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3708), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2950), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2952), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [60536] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3709), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2158), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2160), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [60597] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3710), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5652), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(5654), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [60658] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3711), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5605), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(5607), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [60719] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3712), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2855), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2857), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [60780] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3713), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5609), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(5611), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [60841] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3714), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3035), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3037), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [60902] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3715), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5584), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(5586), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [60963] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3716), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2859), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2861), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [61024] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3717), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2984), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2986), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [61085] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3718), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5580), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(5582), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [61146] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3719), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5618), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(5620), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [61207] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3720), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2877), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2879), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [61268] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3721), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3031), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3033), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [61329] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3722), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5590), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(5592), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [61390] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3723), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5594), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(5596), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [61451] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3724), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5598), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(5600), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [61512] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3725), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2873), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2875), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [61573] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3726), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3023), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3025), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [61634] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3727), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2883), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2885), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [61695] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3728), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3019), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3021), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [61756] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3729), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3027), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3029), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [61817] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3730), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2934), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2936), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [61878] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3731), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5661), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(5663), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [61939] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3732), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5665), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(5667), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [62000] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3733), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2887), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2889), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [62061] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3734), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2863), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2865), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [62122] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3735), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2891), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2893), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [62183] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3736), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2974), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2976), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [62244] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3737), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2867), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2869), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [62305] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3738), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2966), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2968), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [62366] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3739), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2942), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2944), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [62427] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3740), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2962), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2964), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [62488] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3741), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2938), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2940), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [62549] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3742), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2843), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2845), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [62610] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3743), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2958), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2960), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [62671] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3744), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2910), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2912), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [62732] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3745), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2914), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2916), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [62793] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3746), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2954), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2956), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [62854] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3747), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5624), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(5626), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [62915] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3748), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2918), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2920), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [62976] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3749), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2922), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2924), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [63037] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3750), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2321), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2323), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [63098] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3751), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2926), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2928), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [63159] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3752), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3095), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3097), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [63220] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3753), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5572), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(5574), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [63281] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3754), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5628), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(5630), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [63342] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3755), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5634), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(5636), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [63403] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3756), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3011), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3013), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [63464] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3757), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3115), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3117), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [63525] = 26,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4511), 1,
      anon_sym_LPAREN,
    ACTIONS(4513), 1,
      anon_sym__,
    ACTIONS(4515), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4519), 1,
      anon_sym_POUND,
    ACTIONS(5453), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(5459), 1,
      anon_sym_QMARK,
    ACTIONS(5719), 1,
      sym_identifier,
    STATE(3784), 1,
      sym_attributes,
    STATE(3848), 1,
      sym_argument_name_spec,
    STATE(4686), 1,
      sym__static_type_identifier,
    STATE(4913), 1,
      sym_type_argument,
    STATE(4914), 1,
      aux_sym_attributes_repeat1,
    STATE(5121), 1,
      sym_long_identifier,
    STATE(5352), 1,
      sym__attribute_set,
    STATE(5470), 1,
      sym__type,
    STATE(6059), 1,
      sym_argument_spec,
    ACTIONS(4521), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3758), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5109), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [63618] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3759), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2988), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2990), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [63679] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5721), 1,
      anon_sym_as,
    STATE(3760), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5646), 12,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(5648), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [63742] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3761), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5638), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(5640), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [63803] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3762), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2946), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2948), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [63864] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3763), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5642), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(5644), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [63925] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3764), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2970), 13,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2972), 16,
      anon_sym_LBRACK_LT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [63986] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5723), 1,
      anon_sym_DOT,
    STATE(3765), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2863), 12,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_with,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2865), 14,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [64047] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3766), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2942), 12,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_with,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2944), 14,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [64105] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3767), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3011), 12,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_with,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(3013), 14,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [64163] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3768), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2988), 12,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_with,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2990), 14,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [64221] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3769), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5725), 12,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_with,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(5727), 14,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [64279] = 24,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2158), 1,
      anon_sym_COLON,
    ACTIONS(5729), 1,
      anon_sym_y,
    ACTIONS(5731), 1,
      anon_sym_uy,
    ACTIONS(5733), 1,
      anon_sym_s,
    ACTIONS(5735), 1,
      anon_sym_us,
    ACTIONS(5737), 1,
      anon_sym_l,
    ACTIONS(5739), 1,
      aux_sym_uint32_token1,
    ACTIONS(5741), 1,
      anon_sym_n,
    ACTIONS(5743), 1,
      anon_sym_un,
    ACTIONS(5745), 1,
      anon_sym_L,
    ACTIONS(5747), 1,
      aux_sym_uint64_token1,
    ACTIONS(5749), 1,
      aux_sym_bignum_token1,
    ACTIONS(5751), 1,
      aux_sym_decimal_token1,
    ACTIONS(5753), 1,
      anon_sym_DOT2,
    ACTIONS(5755), 1,
      aux_sym_float_token1,
    STATE(3770), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2160), 11,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_in,
      anon_sym_DASH_GT,
      anon_sym_when,
      anon_sym_LT2,
  [64365] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3771), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2970), 12,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_with,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2972), 14,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [64423] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3772), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5757), 12,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_with,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(5759), 14,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [64481] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3773), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2863), 12,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_with,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2865), 14,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [64539] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(5763), 1,
      anon_sym_LBRACK_LT,
    STATE(4045), 1,
      sym__attribute_set,
    STATE(3774), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_attributes_repeat1,
    ACTIONS(5761), 10,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(5766), 11,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [64599] = 21,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4511), 1,
      anon_sym_LPAREN,
    ACTIONS(4513), 1,
      anon_sym__,
    ACTIONS(4515), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4519), 1,
      anon_sym_POUND,
    ACTIONS(5768), 1,
      sym_identifier,
    ACTIONS(5770), 1,
      anon_sym_GT,
    STATE(4686), 1,
      sym__static_type_identifier,
    STATE(4913), 1,
      sym_type_argument,
    STATE(4921), 1,
      sym__type,
    STATE(5121), 1,
      sym_long_identifier,
    STATE(6583), 1,
      sym_types,
    ACTIONS(4521), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3775), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5109), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [64677] = 21,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4511), 1,
      anon_sym_LPAREN,
    ACTIONS(4513), 1,
      anon_sym__,
    ACTIONS(4515), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4519), 1,
      anon_sym_POUND,
    ACTIONS(5768), 1,
      sym_identifier,
    ACTIONS(5772), 1,
      anon_sym_GT,
    STATE(4686), 1,
      sym__static_type_identifier,
    STATE(4913), 1,
      sym_type_argument,
    STATE(4921), 1,
      sym__type,
    STATE(5121), 1,
      sym_long_identifier,
    STATE(6496), 1,
      sym_types,
    ACTIONS(4521), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3776), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5109), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [64755] = 21,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4511), 1,
      anon_sym_LPAREN,
    ACTIONS(4513), 1,
      anon_sym__,
    ACTIONS(4515), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4519), 1,
      anon_sym_POUND,
    ACTIONS(5768), 1,
      sym_identifier,
    ACTIONS(5774), 1,
      anon_sym_GT,
    STATE(4686), 1,
      sym__static_type_identifier,
    STATE(4913), 1,
      sym_type_argument,
    STATE(4921), 1,
      sym__type,
    STATE(5121), 1,
      sym_long_identifier,
    STATE(7378), 1,
      sym_types,
    ACTIONS(4521), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3777), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5109), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [64833] = 21,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4511), 1,
      anon_sym_LPAREN,
    ACTIONS(4513), 1,
      anon_sym__,
    ACTIONS(4515), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4519), 1,
      anon_sym_POUND,
    ACTIONS(5768), 1,
      sym_identifier,
    ACTIONS(5776), 1,
      anon_sym_GT,
    STATE(4686), 1,
      sym__static_type_identifier,
    STATE(4913), 1,
      sym_type_argument,
    STATE(4921), 1,
      sym__type,
    STATE(5121), 1,
      sym_long_identifier,
    STATE(6684), 1,
      sym_types,
    ACTIONS(4521), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3778), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5109), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [64911] = 21,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4511), 1,
      anon_sym_LPAREN,
    ACTIONS(4513), 1,
      anon_sym__,
    ACTIONS(4515), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4519), 1,
      anon_sym_POUND,
    ACTIONS(5768), 1,
      sym_identifier,
    ACTIONS(5778), 1,
      anon_sym_GT,
    STATE(4686), 1,
      sym__static_type_identifier,
    STATE(4913), 1,
      sym_type_argument,
    STATE(4921), 1,
      sym__type,
    STATE(5121), 1,
      sym_long_identifier,
    STATE(7153), 1,
      sym_types,
    ACTIONS(4521), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3779), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5109), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [64989] = 21,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4511), 1,
      anon_sym_LPAREN,
    ACTIONS(4513), 1,
      anon_sym__,
    ACTIONS(4515), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4519), 1,
      anon_sym_POUND,
    ACTIONS(5768), 1,
      sym_identifier,
    ACTIONS(5780), 1,
      anon_sym_GT,
    STATE(4686), 1,
      sym__static_type_identifier,
    STATE(4913), 1,
      sym_type_argument,
    STATE(4921), 1,
      sym__type,
    STATE(5121), 1,
      sym_long_identifier,
    STATE(7332), 1,
      sym_types,
    ACTIONS(4521), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3780), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5109), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [65067] = 21,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4511), 1,
      anon_sym_LPAREN,
    ACTIONS(4513), 1,
      anon_sym__,
    ACTIONS(4515), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4519), 1,
      anon_sym_POUND,
    ACTIONS(5768), 1,
      sym_identifier,
    ACTIONS(5782), 1,
      anon_sym_GT,
    STATE(4686), 1,
      sym__static_type_identifier,
    STATE(4913), 1,
      sym_type_argument,
    STATE(4921), 1,
      sym__type,
    STATE(5121), 1,
      sym_long_identifier,
    STATE(7102), 1,
      sym_types,
    ACTIONS(4521), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3781), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5109), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [65145] = 21,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4511), 1,
      anon_sym_LPAREN,
    ACTIONS(4513), 1,
      anon_sym__,
    ACTIONS(4515), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4519), 1,
      anon_sym_POUND,
    ACTIONS(5768), 1,
      sym_identifier,
    ACTIONS(5784), 1,
      anon_sym_GT,
    STATE(4686), 1,
      sym__static_type_identifier,
    STATE(4913), 1,
      sym_type_argument,
    STATE(4921), 1,
      sym__type,
    STATE(5121), 1,
      sym_long_identifier,
    STATE(6989), 1,
      sym_types,
    ACTIONS(4521), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3782), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5109), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [65223] = 21,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4511), 1,
      anon_sym_LPAREN,
    ACTIONS(4513), 1,
      anon_sym__,
    ACTIONS(4515), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4519), 1,
      anon_sym_POUND,
    ACTIONS(5768), 1,
      sym_identifier,
    ACTIONS(5786), 1,
      anon_sym_GT,
    STATE(4686), 1,
      sym__static_type_identifier,
    STATE(4913), 1,
      sym_type_argument,
    STATE(4921), 1,
      sym__type,
    STATE(5121), 1,
      sym_long_identifier,
    STATE(6939), 1,
      sym_types,
    ACTIONS(4521), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3783), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5109), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [65301] = 21,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4511), 1,
      anon_sym_LPAREN,
    ACTIONS(4513), 1,
      anon_sym__,
    ACTIONS(4515), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4519), 1,
      anon_sym_POUND,
    ACTIONS(5459), 1,
      anon_sym_QMARK,
    ACTIONS(5719), 1,
      sym_identifier,
    STATE(3850), 1,
      sym_argument_name_spec,
    STATE(4686), 1,
      sym__static_type_identifier,
    STATE(4913), 1,
      sym_type_argument,
    STATE(5121), 1,
      sym_long_identifier,
    STATE(5430), 1,
      sym__type,
    ACTIONS(4521), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3784), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5109), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [65379] = 22,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2158), 1,
      anon_sym_COLON,
    ACTIONS(5729), 1,
      anon_sym_y,
    ACTIONS(5731), 1,
      anon_sym_uy,
    ACTIONS(5733), 1,
      anon_sym_s,
    ACTIONS(5735), 1,
      anon_sym_us,
    ACTIONS(5739), 1,
      aux_sym_uint32_token1,
    ACTIONS(5741), 1,
      anon_sym_n,
    ACTIONS(5743), 1,
      anon_sym_un,
    ACTIONS(5747), 1,
      aux_sym_uint64_token1,
    ACTIONS(5788), 1,
      anon_sym_l,
    ACTIONS(5790), 1,
      anon_sym_L,
    ACTIONS(5792), 1,
      anon_sym_lf,
    ACTIONS(5794), 1,
      anon_sym_LF,
    STATE(3785), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2160), 11,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_in,
      anon_sym_DASH_GT,
      anon_sym_when,
      anon_sym_LT2,
  [65459] = 21,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4511), 1,
      anon_sym_LPAREN,
    ACTIONS(4513), 1,
      anon_sym__,
    ACTIONS(4515), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4519), 1,
      anon_sym_POUND,
    ACTIONS(5768), 1,
      sym_identifier,
    ACTIONS(5796), 1,
      anon_sym_GT,
    STATE(4686), 1,
      sym__static_type_identifier,
    STATE(4913), 1,
      sym_type_argument,
    STATE(4921), 1,
      sym__type,
    STATE(5121), 1,
      sym_long_identifier,
    STATE(7246), 1,
      sym_types,
    ACTIONS(4521), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3786), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5109), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [65537] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3774), 1,
      aux_sym_attributes_repeat1,
    STATE(4045), 1,
      sym__attribute_set,
    STATE(3787), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5798), 10,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(5800), 12,
      anon_sym_LBRACK_LT,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [65597] = 21,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4511), 1,
      anon_sym_LPAREN,
    ACTIONS(4513), 1,
      anon_sym__,
    ACTIONS(4515), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4519), 1,
      anon_sym_POUND,
    ACTIONS(5768), 1,
      sym_identifier,
    ACTIONS(5802), 1,
      anon_sym_GT,
    STATE(4686), 1,
      sym__static_type_identifier,
    STATE(4913), 1,
      sym_type_argument,
    STATE(4921), 1,
      sym__type,
    STATE(5121), 1,
      sym_long_identifier,
    STATE(6975), 1,
      sym_types,
    ACTIONS(4521), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3788), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5109), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [65675] = 21,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4511), 1,
      anon_sym_LPAREN,
    ACTIONS(4513), 1,
      anon_sym__,
    ACTIONS(4515), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4519), 1,
      anon_sym_POUND,
    ACTIONS(5768), 1,
      sym_identifier,
    ACTIONS(5804), 1,
      anon_sym_GT,
    STATE(4686), 1,
      sym__static_type_identifier,
    STATE(4913), 1,
      sym_type_argument,
    STATE(4921), 1,
      sym__type,
    STATE(5121), 1,
      sym_long_identifier,
    STATE(6725), 1,
      sym_types,
    ACTIONS(4521), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3789), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5109), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [65753] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5806), 1,
      aux_sym_float_token1,
    STATE(3790), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2723), 11,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      anon_sym_f,
      aux_sym_decimal_token1,
      sym_identifier,
    ACTIONS(2725), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [65810] = 24,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2158), 1,
      anon_sym_COLON,
    ACTIONS(5808), 1,
      anon_sym_y,
    ACTIONS(5810), 1,
      anon_sym_uy,
    ACTIONS(5812), 1,
      anon_sym_s,
    ACTIONS(5814), 1,
      anon_sym_us,
    ACTIONS(5816), 1,
      anon_sym_l,
    ACTIONS(5818), 1,
      aux_sym_uint32_token1,
    ACTIONS(5820), 1,
      anon_sym_n,
    ACTIONS(5822), 1,
      anon_sym_un,
    ACTIONS(5824), 1,
      anon_sym_L,
    ACTIONS(5826), 1,
      aux_sym_uint64_token1,
    ACTIONS(5828), 1,
      aux_sym_bignum_token1,
    ACTIONS(5830), 1,
      aux_sym_decimal_token1,
    ACTIONS(5832), 1,
      anon_sym_DOT2,
    ACTIONS(5834), 1,
      aux_sym_float_token1,
    STATE(3791), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2160), 8,
      sym__newline,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
  [65893] = 20,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4504), 1,
      sym_identifier,
    ACTIONS(5347), 1,
      anon_sym_LPAREN,
    ACTIONS(5349), 1,
      anon_sym__,
    ACTIONS(5351), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(5353), 1,
      anon_sym_POUND,
    STATE(353), 1,
      sym__type,
    STATE(2708), 1,
      sym__static_type_identifier,
    STATE(2770), 1,
      sym_type_argument,
    STATE(2788), 1,
      sym_long_identifier,
    STATE(6077), 1,
      sym__object_construction,
    ACTIONS(5355), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3792), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(2778), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [65968] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4511), 1,
      anon_sym_LPAREN,
    ACTIONS(4513), 1,
      anon_sym__,
    ACTIONS(4515), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4519), 1,
      anon_sym_POUND,
    ACTIONS(5768), 1,
      sym_identifier,
    STATE(4686), 1,
      sym__static_type_identifier,
    STATE(4913), 1,
      sym_type_argument,
    STATE(5121), 1,
      sym_long_identifier,
    STATE(5249), 1,
      sym__type,
    ACTIONS(4521), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3793), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5109), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [66040] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5836), 1,
      sym_identifier,
    ACTIONS(5838), 1,
      anon_sym_LPAREN,
    ACTIONS(5840), 1,
      anon_sym__,
    ACTIONS(5842), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(5844), 1,
      anon_sym_POUND,
    STATE(4202), 1,
      sym__static_type_identifier,
    STATE(4204), 1,
      sym__type,
    STATE(4346), 1,
      sym_type_argument,
    STATE(4406), 1,
      sym_long_identifier,
    ACTIONS(5846), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3794), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4404), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [66112] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5848), 1,
      sym_identifier,
    ACTIONS(5850), 1,
      anon_sym_LPAREN,
    ACTIONS(5852), 1,
      anon_sym__,
    ACTIONS(5854), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(5856), 1,
      anon_sym_POUND,
    STATE(5003), 1,
      sym__static_type_identifier,
    STATE(5007), 1,
      sym__type,
    STATE(5466), 1,
      sym_type_argument,
    STATE(5569), 1,
      sym_long_identifier,
    ACTIONS(5858), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3795), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5520), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [66184] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4511), 1,
      anon_sym_LPAREN,
    ACTIONS(4513), 1,
      anon_sym__,
    ACTIONS(4515), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4519), 1,
      anon_sym_POUND,
    ACTIONS(5768), 1,
      sym_identifier,
    STATE(4686), 1,
      sym__static_type_identifier,
    STATE(4913), 1,
      sym_type_argument,
    STATE(5121), 1,
      sym_long_identifier,
    STATE(5214), 1,
      sym__type,
    ACTIONS(4521), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3796), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5109), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [66256] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5860), 1,
      sym_identifier,
    ACTIONS(5862), 1,
      anon_sym_LPAREN,
    ACTIONS(5864), 1,
      anon_sym__,
    ACTIONS(5866), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(5868), 1,
      anon_sym_POUND,
    STATE(4517), 1,
      sym__static_type_identifier,
    STATE(4519), 1,
      sym__type,
    STATE(4843), 1,
      sym_type_argument,
    STATE(4907), 1,
      sym_long_identifier,
    ACTIONS(5870), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3797), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4909), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [66328] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5872), 1,
      sym_identifier,
    ACTIONS(5874), 1,
      anon_sym_LPAREN,
    ACTIONS(5876), 1,
      anon_sym__,
    ACTIONS(5878), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(5880), 1,
      anon_sym_POUND,
    STATE(4210), 1,
      sym__type,
    STATE(4217), 1,
      sym__static_type_identifier,
    STATE(4313), 1,
      sym_type_argument,
    STATE(4470), 1,
      sym_long_identifier,
    ACTIONS(5882), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3798), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4465), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [66400] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4511), 1,
      anon_sym_LPAREN,
    ACTIONS(4513), 1,
      anon_sym__,
    ACTIONS(4515), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4519), 1,
      anon_sym_POUND,
    ACTIONS(5768), 1,
      sym_identifier,
    STATE(4686), 1,
      sym__static_type_identifier,
    STATE(4913), 1,
      sym_type_argument,
    STATE(5121), 1,
      sym_long_identifier,
    STATE(5286), 1,
      sym__type,
    ACTIONS(4521), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3799), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5109), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [66472] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3236), 1,
      sym_identifier,
    ACTIONS(5884), 1,
      anon_sym_LPAREN,
    ACTIONS(5886), 1,
      anon_sym__,
    ACTIONS(5888), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(5890), 1,
      anon_sym_POUND,
    STATE(999), 1,
      sym__type,
    STATE(1240), 1,
      sym__static_type_identifier,
    STATE(1314), 1,
      sym_long_identifier,
    STATE(1315), 1,
      sym_type_argument,
    ACTIONS(5892), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3800), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(1332), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [66544] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4949), 1,
      sym_identifier,
    ACTIONS(5894), 1,
      anon_sym_LPAREN,
    ACTIONS(5896), 1,
      anon_sym__,
    ACTIONS(5898), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(5900), 1,
      anon_sym_POUND,
    STATE(2880), 1,
      sym__static_type_identifier,
    STATE(2887), 1,
      sym__type,
    STATE(2966), 1,
      sym_type_argument,
    STATE(3063), 1,
      sym_long_identifier,
    ACTIONS(5902), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3801), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(3074), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [66616] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3281), 1,
      sym_identifier,
    ACTIONS(5904), 1,
      anon_sym_LPAREN,
    ACTIONS(5906), 1,
      anon_sym__,
    ACTIONS(5908), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(5910), 1,
      anon_sym_POUND,
    STATE(1031), 1,
      sym__type,
    STATE(1241), 1,
      sym__static_type_identifier,
    STATE(1324), 1,
      sym_type_argument,
    STATE(1326), 1,
      sym_long_identifier,
    ACTIONS(5912), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3802), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(1321), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [66688] = 24,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2158), 1,
      anon_sym_COLON,
    ACTIONS(5914), 1,
      anon_sym_y,
    ACTIONS(5916), 1,
      anon_sym_uy,
    ACTIONS(5918), 1,
      anon_sym_s,
    ACTIONS(5920), 1,
      anon_sym_us,
    ACTIONS(5922), 1,
      anon_sym_l,
    ACTIONS(5924), 1,
      aux_sym_uint32_token1,
    ACTIONS(5926), 1,
      anon_sym_n,
    ACTIONS(5928), 1,
      anon_sym_un,
    ACTIONS(5930), 1,
      anon_sym_L,
    ACTIONS(5932), 1,
      aux_sym_uint64_token1,
    ACTIONS(5934), 1,
      aux_sym_bignum_token1,
    ACTIONS(5936), 1,
      aux_sym_decimal_token1,
    ACTIONS(5938), 1,
      anon_sym_DOT2,
    ACTIONS(5940), 1,
      aux_sym_float_token1,
    STATE(3803), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2160), 7,
      sym__newline,
      sym__dedent,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
  [66770] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3155), 1,
      sym_identifier,
    ACTIONS(5942), 1,
      anon_sym_LPAREN,
    ACTIONS(5944), 1,
      anon_sym__,
    ACTIONS(5946), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(5948), 1,
      anon_sym_POUND,
    STATE(989), 1,
      sym__type,
    STATE(1110), 1,
      sym__static_type_identifier,
    STATE(1173), 1,
      sym_type_argument,
    STATE(1279), 1,
      sym_long_identifier,
    ACTIONS(5950), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3804), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(1258), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [66842] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5952), 1,
      anon_sym_DOT,
    STATE(3805), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_long_identifier_repeat1,
    ACTIONS(2411), 9,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(2413), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [66898] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5955), 1,
      sym_identifier,
    ACTIONS(5957), 1,
      anon_sym_LPAREN,
    ACTIONS(5959), 1,
      anon_sym__,
    ACTIONS(5961), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(5963), 1,
      anon_sym_POUND,
    STATE(4258), 1,
      sym__static_type_identifier,
    STATE(4275), 1,
      sym__type,
    STATE(4447), 1,
      sym_type_argument,
    STATE(4501), 1,
      sym_long_identifier,
    ACTIONS(5965), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3806), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4503), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [66970] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4511), 1,
      anon_sym_LPAREN,
    ACTIONS(4513), 1,
      anon_sym__,
    ACTIONS(4515), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4519), 1,
      anon_sym_POUND,
    ACTIONS(5768), 1,
      sym_identifier,
    STATE(4686), 1,
      sym__static_type_identifier,
    STATE(4913), 1,
      sym_type_argument,
    STATE(5121), 1,
      sym_long_identifier,
    STATE(5301), 1,
      sym__type,
    ACTIONS(4521), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3807), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5109), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [67042] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5455), 1,
      anon_sym_LPAREN,
    ACTIONS(5457), 1,
      anon_sym__,
    ACTIONS(5461), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(5463), 1,
      anon_sym_POUND,
    ACTIONS(5967), 1,
      sym_identifier,
    STATE(4182), 1,
      sym__static_type_identifier,
    STATE(4223), 1,
      sym_type_argument,
    STATE(4259), 1,
      sym_long_identifier,
    STATE(5170), 1,
      sym__type,
    ACTIONS(5465), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3808), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4263), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [67114] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4511), 1,
      anon_sym_LPAREN,
    ACTIONS(4513), 1,
      anon_sym__,
    ACTIONS(4515), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4519), 1,
      anon_sym_POUND,
    ACTIONS(5768), 1,
      sym_identifier,
    STATE(4686), 1,
      sym__static_type_identifier,
    STATE(4913), 1,
      sym_type_argument,
    STATE(5121), 1,
      sym_long_identifier,
    STATE(5201), 1,
      sym__type,
    ACTIONS(4521), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3809), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5109), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [67186] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4511), 1,
      anon_sym_LPAREN,
    ACTIONS(4513), 1,
      anon_sym__,
    ACTIONS(4515), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4519), 1,
      anon_sym_POUND,
    ACTIONS(5768), 1,
      sym_identifier,
    STATE(4686), 1,
      sym__static_type_identifier,
    STATE(4913), 1,
      sym_type_argument,
    STATE(5121), 1,
      sym_long_identifier,
    STATE(5194), 1,
      sym__type,
    ACTIONS(4521), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3810), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5109), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [67258] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4511), 1,
      anon_sym_LPAREN,
    ACTIONS(4513), 1,
      anon_sym__,
    ACTIONS(4515), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4519), 1,
      anon_sym_POUND,
    ACTIONS(5768), 1,
      sym_identifier,
    STATE(4686), 1,
      sym__static_type_identifier,
    STATE(4913), 1,
      sym_type_argument,
    STATE(5121), 1,
      sym_long_identifier,
    STATE(5255), 1,
      sym__type,
    ACTIONS(4521), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3811), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5109), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [67330] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4978), 1,
      sym_identifier,
    ACTIONS(5969), 1,
      anon_sym_LPAREN,
    ACTIONS(5971), 1,
      anon_sym__,
    ACTIONS(5973), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(5975), 1,
      anon_sym_POUND,
    STATE(2931), 1,
      sym__static_type_identifier,
    STATE(3036), 1,
      sym_type_argument,
    STATE(3108), 1,
      sym__type,
    STATE(3113), 1,
      sym_long_identifier,
    ACTIONS(5977), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3812), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(3112), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [67402] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5860), 1,
      sym_identifier,
    ACTIONS(5862), 1,
      anon_sym_LPAREN,
    ACTIONS(5864), 1,
      anon_sym__,
    ACTIONS(5866), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(5868), 1,
      anon_sym_POUND,
    STATE(4517), 1,
      sym__static_type_identifier,
    STATE(4524), 1,
      sym__type,
    STATE(4843), 1,
      sym_type_argument,
    STATE(4907), 1,
      sym_long_identifier,
    ACTIONS(5870), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3813), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4909), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [67474] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4511), 1,
      anon_sym_LPAREN,
    ACTIONS(4513), 1,
      anon_sym__,
    ACTIONS(4515), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4519), 1,
      anon_sym_POUND,
    ACTIONS(5768), 1,
      sym_identifier,
    STATE(4686), 1,
      sym__static_type_identifier,
    STATE(4913), 1,
      sym_type_argument,
    STATE(5121), 1,
      sym_long_identifier,
    STATE(5247), 1,
      sym__type,
    ACTIONS(4521), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3814), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5109), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [67546] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5848), 1,
      sym_identifier,
    ACTIONS(5850), 1,
      anon_sym_LPAREN,
    ACTIONS(5852), 1,
      anon_sym__,
    ACTIONS(5854), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(5856), 1,
      anon_sym_POUND,
    STATE(5003), 1,
      sym__static_type_identifier,
    STATE(5030), 1,
      sym__type,
    STATE(5466), 1,
      sym_type_argument,
    STATE(5569), 1,
      sym_long_identifier,
    ACTIONS(5858), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3815), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5520), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [67618] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4511), 1,
      anon_sym_LPAREN,
    ACTIONS(4513), 1,
      anon_sym__,
    ACTIONS(4515), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4519), 1,
      anon_sym_POUND,
    ACTIONS(5768), 1,
      sym_identifier,
    STATE(4686), 1,
      sym__static_type_identifier,
    STATE(4913), 1,
      sym_type_argument,
    STATE(5121), 1,
      sym_long_identifier,
    STATE(5205), 1,
      sym__type,
    ACTIONS(4521), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3816), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5109), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [67690] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5848), 1,
      sym_identifier,
    ACTIONS(5850), 1,
      anon_sym_LPAREN,
    ACTIONS(5852), 1,
      anon_sym__,
    ACTIONS(5854), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(5856), 1,
      anon_sym_POUND,
    STATE(5003), 1,
      sym__static_type_identifier,
    STATE(5021), 1,
      sym__type,
    STATE(5466), 1,
      sym_type_argument,
    STATE(5569), 1,
      sym_long_identifier,
    ACTIONS(5858), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3817), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5520), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [67762] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4511), 1,
      anon_sym_LPAREN,
    ACTIONS(4513), 1,
      anon_sym__,
    ACTIONS(4515), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4519), 1,
      anon_sym_POUND,
    ACTIONS(5768), 1,
      sym_identifier,
    STATE(4686), 1,
      sym__static_type_identifier,
    STATE(4913), 1,
      sym_type_argument,
    STATE(5121), 1,
      sym_long_identifier,
    STATE(5304), 1,
      sym__type,
    ACTIONS(4521), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3818), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5109), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [67834] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5955), 1,
      sym_identifier,
    ACTIONS(5957), 1,
      anon_sym_LPAREN,
    ACTIONS(5959), 1,
      anon_sym__,
    ACTIONS(5961), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(5963), 1,
      anon_sym_POUND,
    STATE(4258), 1,
      sym__static_type_identifier,
    STATE(4284), 1,
      sym__type,
    STATE(4447), 1,
      sym_type_argument,
    STATE(4501), 1,
      sym_long_identifier,
    ACTIONS(5965), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3819), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4503), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [67906] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4511), 1,
      anon_sym_LPAREN,
    ACTIONS(4513), 1,
      anon_sym__,
    ACTIONS(4515), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4519), 1,
      anon_sym_POUND,
    ACTIONS(5768), 1,
      sym_identifier,
    STATE(4686), 1,
      sym__static_type_identifier,
    STATE(4688), 1,
      sym__type,
    STATE(4913), 1,
      sym_type_argument,
    STATE(5121), 1,
      sym_long_identifier,
    ACTIONS(4521), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3820), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5109), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [67978] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4511), 1,
      anon_sym_LPAREN,
    ACTIONS(4513), 1,
      anon_sym__,
    ACTIONS(4515), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4519), 1,
      anon_sym_POUND,
    ACTIONS(5768), 1,
      sym_identifier,
    STATE(4686), 1,
      sym__static_type_identifier,
    STATE(4913), 1,
      sym_type_argument,
    STATE(5121), 1,
      sym_long_identifier,
    STATE(5310), 1,
      sym__type,
    ACTIONS(4521), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3821), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5109), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [68050] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3155), 1,
      sym_identifier,
    ACTIONS(5942), 1,
      anon_sym_LPAREN,
    ACTIONS(5944), 1,
      anon_sym__,
    ACTIONS(5946), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(5948), 1,
      anon_sym_POUND,
    STATE(992), 1,
      sym__type,
    STATE(1110), 1,
      sym__static_type_identifier,
    STATE(1173), 1,
      sym_type_argument,
    STATE(1279), 1,
      sym_long_identifier,
    ACTIONS(5950), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3822), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(1258), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [68122] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4949), 1,
      sym_identifier,
    ACTIONS(5894), 1,
      anon_sym_LPAREN,
    ACTIONS(5896), 1,
      anon_sym__,
    ACTIONS(5898), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(5900), 1,
      anon_sym_POUND,
    STATE(2880), 1,
      sym__static_type_identifier,
    STATE(2888), 1,
      sym__type,
    STATE(2966), 1,
      sym_type_argument,
    STATE(3063), 1,
      sym_long_identifier,
    ACTIONS(5902), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3823), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(3074), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [68194] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4511), 1,
      anon_sym_LPAREN,
    ACTIONS(4513), 1,
      anon_sym__,
    ACTIONS(4515), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4519), 1,
      anon_sym_POUND,
    ACTIONS(5768), 1,
      sym_identifier,
    STATE(4686), 1,
      sym__static_type_identifier,
    STATE(4913), 1,
      sym_type_argument,
    STATE(5121), 1,
      sym_long_identifier,
    STATE(5420), 1,
      sym__type,
    ACTIONS(4521), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3824), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5109), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [68266] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5242), 1,
      sym_identifier,
    ACTIONS(5979), 1,
      anon_sym_LPAREN,
    ACTIONS(5981), 1,
      anon_sym__,
    ACTIONS(5983), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(5985), 1,
      anon_sym_POUND,
    STATE(3076), 1,
      sym__type,
    STATE(3093), 1,
      sym__static_type_identifier,
    STATE(3255), 1,
      sym_type_argument,
    STATE(3289), 1,
      sym_long_identifier,
    ACTIONS(5987), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3825), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(3294), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [68338] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5989), 1,
      sym_identifier,
    ACTIONS(5991), 1,
      anon_sym_LPAREN,
    ACTIONS(5993), 1,
      anon_sym__,
    ACTIONS(5995), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(5997), 1,
      anon_sym_POUND,
    STATE(4331), 1,
      sym__type,
    STATE(4335), 1,
      sym__static_type_identifier,
    STATE(4557), 1,
      sym_type_argument,
    STATE(4646), 1,
      sym_long_identifier,
    ACTIONS(5999), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3826), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4664), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [68410] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5455), 1,
      anon_sym_LPAREN,
    ACTIONS(5457), 1,
      anon_sym__,
    ACTIONS(5461), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(5463), 1,
      anon_sym_POUND,
    ACTIONS(5967), 1,
      sym_identifier,
    STATE(4145), 1,
      sym__type,
    STATE(4182), 1,
      sym__static_type_identifier,
    STATE(4223), 1,
      sym_type_argument,
    STATE(4259), 1,
      sym_long_identifier,
    ACTIONS(5465), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3827), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4263), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [68482] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5860), 1,
      sym_identifier,
    ACTIONS(5862), 1,
      anon_sym_LPAREN,
    ACTIONS(5864), 1,
      anon_sym__,
    ACTIONS(5866), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(5868), 1,
      anon_sym_POUND,
    STATE(4517), 1,
      sym__static_type_identifier,
    STATE(4806), 1,
      sym__type,
    STATE(4843), 1,
      sym_type_argument,
    STATE(4907), 1,
      sym_long_identifier,
    ACTIONS(5870), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3828), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4909), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [68554] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6001), 1,
      sym_identifier,
    ACTIONS(6003), 1,
      anon_sym_LPAREN,
    ACTIONS(6005), 1,
      anon_sym__,
    ACTIONS(6007), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6009), 1,
      anon_sym_POUND,
    STATE(4312), 1,
      sym__type,
    STATE(4315), 1,
      sym__static_type_identifier,
    STATE(4575), 1,
      sym_type_argument,
    STATE(4602), 1,
      sym_long_identifier,
    ACTIONS(6011), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3829), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4598), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [68626] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5455), 1,
      anon_sym_LPAREN,
    ACTIONS(5457), 1,
      anon_sym__,
    ACTIONS(5461), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(5463), 1,
      anon_sym_POUND,
    ACTIONS(5967), 1,
      sym_identifier,
    STATE(4140), 1,
      sym__type,
    STATE(4182), 1,
      sym__static_type_identifier,
    STATE(4223), 1,
      sym_type_argument,
    STATE(4259), 1,
      sym_long_identifier,
    ACTIONS(5465), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3830), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4263), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [68698] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5455), 1,
      anon_sym_LPAREN,
    ACTIONS(5457), 1,
      anon_sym__,
    ACTIONS(5461), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(5463), 1,
      anon_sym_POUND,
    ACTIONS(5967), 1,
      sym_identifier,
    STATE(4182), 1,
      sym__static_type_identifier,
    STATE(4223), 1,
      sym_type_argument,
    STATE(4259), 1,
      sym_long_identifier,
    STATE(5132), 1,
      sym__type,
    ACTIONS(5465), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3831), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4263), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [68770] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5989), 1,
      sym_identifier,
    ACTIONS(5991), 1,
      anon_sym_LPAREN,
    ACTIONS(5993), 1,
      anon_sym__,
    ACTIONS(5995), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(5997), 1,
      anon_sym_POUND,
    STATE(4335), 1,
      sym__static_type_identifier,
    STATE(4338), 1,
      sym__type,
    STATE(4557), 1,
      sym_type_argument,
    STATE(4646), 1,
      sym_long_identifier,
    ACTIONS(5999), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3832), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4664), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [68842] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5070), 1,
      sym_identifier,
    ACTIONS(6013), 1,
      anon_sym_LPAREN,
    ACTIONS(6015), 1,
      anon_sym__,
    ACTIONS(6017), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6019), 1,
      anon_sym_POUND,
    STATE(2911), 1,
      sym__static_type_identifier,
    STATE(2922), 1,
      sym__type,
    STATE(3056), 1,
      sym_type_argument,
    STATE(3193), 1,
      sym_long_identifier,
    ACTIONS(6021), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3833), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(3195), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [68914] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6001), 1,
      sym_identifier,
    ACTIONS(6003), 1,
      anon_sym_LPAREN,
    ACTIONS(6005), 1,
      anon_sym__,
    ACTIONS(6007), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6009), 1,
      anon_sym_POUND,
    STATE(4315), 1,
      sym__static_type_identifier,
    STATE(4345), 1,
      sym__type,
    STATE(4575), 1,
      sym_type_argument,
    STATE(4602), 1,
      sym_long_identifier,
    ACTIONS(6011), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3834), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4598), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [68986] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5163), 1,
      sym_identifier,
    ACTIONS(6023), 1,
      anon_sym_LPAREN,
    ACTIONS(6025), 1,
      anon_sym__,
    ACTIONS(6027), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6029), 1,
      anon_sym_POUND,
    STATE(2970), 1,
      sym__static_type_identifier,
    STATE(2981), 1,
      sym__type,
    STATE(3119), 1,
      sym_type_argument,
    STATE(3238), 1,
      sym_long_identifier,
    ACTIONS(6031), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3835), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(3239), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [69058] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4511), 1,
      anon_sym_LPAREN,
    ACTIONS(4513), 1,
      anon_sym__,
    ACTIONS(4515), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4519), 1,
      anon_sym_POUND,
    ACTIONS(5768), 1,
      sym_identifier,
    STATE(4686), 1,
      sym__static_type_identifier,
    STATE(4913), 1,
      sym_type_argument,
    STATE(5121), 1,
      sym_long_identifier,
    STATE(5325), 1,
      sym__type,
    ACTIONS(4521), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3836), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5109), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [69130] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5106), 1,
      sym_identifier,
    ACTIONS(6033), 1,
      anon_sym_LPAREN,
    ACTIONS(6035), 1,
      anon_sym__,
    ACTIONS(6037), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6039), 1,
      anon_sym_POUND,
    STATE(2953), 1,
      sym__static_type_identifier,
    STATE(2979), 1,
      sym__type,
    STATE(3151), 1,
      sym_type_argument,
    STATE(3260), 1,
      sym_long_identifier,
    ACTIONS(6041), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3837), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(3262), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [69202] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4511), 1,
      anon_sym_LPAREN,
    ACTIONS(4513), 1,
      anon_sym__,
    ACTIONS(4515), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4519), 1,
      anon_sym_POUND,
    ACTIONS(5768), 1,
      sym_identifier,
    STATE(4686), 1,
      sym__static_type_identifier,
    STATE(4913), 1,
      sym_type_argument,
    STATE(5121), 1,
      sym_long_identifier,
    STATE(5320), 1,
      sym__type,
    ACTIONS(4521), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3838), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5109), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [69274] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4511), 1,
      anon_sym_LPAREN,
    ACTIONS(4513), 1,
      anon_sym__,
    ACTIONS(4515), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4519), 1,
      anon_sym_POUND,
    ACTIONS(5768), 1,
      sym_identifier,
    STATE(4686), 1,
      sym__static_type_identifier,
    STATE(4913), 1,
      sym_type_argument,
    STATE(5121), 1,
      sym_long_identifier,
    STATE(5233), 1,
      sym__type,
    ACTIONS(4521), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3839), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5109), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [69346] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4511), 1,
      anon_sym_LPAREN,
    ACTIONS(4513), 1,
      anon_sym__,
    ACTIONS(4515), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4519), 1,
      anon_sym_POUND,
    ACTIONS(5768), 1,
      sym_identifier,
    STATE(4686), 1,
      sym__static_type_identifier,
    STATE(4913), 1,
      sym_type_argument,
    STATE(5121), 1,
      sym_long_identifier,
    STATE(5222), 1,
      sym__type,
    ACTIONS(4521), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3840), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5109), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [69418] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3841), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6043), 10,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(6045), 12,
      anon_sym_LBRACK_LT,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [69472] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4511), 1,
      anon_sym_LPAREN,
    ACTIONS(4513), 1,
      anon_sym__,
    ACTIONS(4515), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4519), 1,
      anon_sym_POUND,
    ACTIONS(5768), 1,
      sym_identifier,
    STATE(4656), 1,
      sym__type,
    STATE(4686), 1,
      sym__static_type_identifier,
    STATE(4913), 1,
      sym_type_argument,
    STATE(5121), 1,
      sym_long_identifier,
    ACTIONS(4521), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3842), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5109), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [69544] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5989), 1,
      sym_identifier,
    ACTIONS(5991), 1,
      anon_sym_LPAREN,
    ACTIONS(5993), 1,
      anon_sym__,
    ACTIONS(5995), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(5997), 1,
      anon_sym_POUND,
    STATE(4335), 1,
      sym__static_type_identifier,
    STATE(4340), 1,
      sym__type,
    STATE(4557), 1,
      sym_type_argument,
    STATE(4646), 1,
      sym_long_identifier,
    ACTIONS(5999), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3843), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4664), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [69616] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3214), 1,
      sym_identifier,
    ACTIONS(6047), 1,
      anon_sym_LPAREN,
    ACTIONS(6049), 1,
      anon_sym__,
    ACTIONS(6051), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6053), 1,
      anon_sym_POUND,
    STATE(1040), 1,
      sym__type,
    STATE(1242), 1,
      sym__static_type_identifier,
    STATE(1316), 1,
      sym_long_identifier,
    STATE(1317), 1,
      sym_type_argument,
    ACTIONS(6055), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3844), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(1325), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [69688] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4511), 1,
      anon_sym_LPAREN,
    ACTIONS(4513), 1,
      anon_sym__,
    ACTIONS(4515), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4519), 1,
      anon_sym_POUND,
    ACTIONS(5768), 1,
      sym_identifier,
    STATE(4655), 1,
      sym__type,
    STATE(4686), 1,
      sym__static_type_identifier,
    STATE(4913), 1,
      sym_type_argument,
    STATE(5121), 1,
      sym_long_identifier,
    ACTIONS(4521), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3845), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5109), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [69760] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5989), 1,
      sym_identifier,
    ACTIONS(5991), 1,
      anon_sym_LPAREN,
    ACTIONS(5993), 1,
      anon_sym__,
    ACTIONS(5995), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(5997), 1,
      anon_sym_POUND,
    STATE(4335), 1,
      sym__static_type_identifier,
    STATE(4378), 1,
      sym__type,
    STATE(4557), 1,
      sym_type_argument,
    STATE(4646), 1,
      sym_long_identifier,
    ACTIONS(5999), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3846), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4664), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [69832] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5860), 1,
      sym_identifier,
    ACTIONS(5862), 1,
      anon_sym_LPAREN,
    ACTIONS(5864), 1,
      anon_sym__,
    ACTIONS(5866), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(5868), 1,
      anon_sym_POUND,
    STATE(4517), 1,
      sym__static_type_identifier,
    STATE(4523), 1,
      sym__type,
    STATE(4843), 1,
      sym_type_argument,
    STATE(4907), 1,
      sym_long_identifier,
    ACTIONS(5870), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3847), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4909), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [69904] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4511), 1,
      anon_sym_LPAREN,
    ACTIONS(4513), 1,
      anon_sym__,
    ACTIONS(4515), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4519), 1,
      anon_sym_POUND,
    ACTIONS(5768), 1,
      sym_identifier,
    STATE(4686), 1,
      sym__static_type_identifier,
    STATE(4913), 1,
      sym_type_argument,
    STATE(5121), 1,
      sym_long_identifier,
    STATE(5430), 1,
      sym__type,
    ACTIONS(4521), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3848), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5109), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [69976] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4511), 1,
      anon_sym_LPAREN,
    ACTIONS(4513), 1,
      anon_sym__,
    ACTIONS(4515), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4519), 1,
      anon_sym_POUND,
    ACTIONS(5768), 1,
      sym_identifier,
    STATE(4634), 1,
      sym__type,
    STATE(4686), 1,
      sym__static_type_identifier,
    STATE(4913), 1,
      sym_type_argument,
    STATE(5121), 1,
      sym_long_identifier,
    ACTIONS(4521), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3849), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5109), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [70048] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4511), 1,
      anon_sym_LPAREN,
    ACTIONS(4513), 1,
      anon_sym__,
    ACTIONS(4515), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4519), 1,
      anon_sym_POUND,
    ACTIONS(5768), 1,
      sym_identifier,
    STATE(4686), 1,
      sym__static_type_identifier,
    STATE(4913), 1,
      sym_type_argument,
    STATE(5121), 1,
      sym_long_identifier,
    STATE(5502), 1,
      sym__type,
    ACTIONS(4521), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3850), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5109), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [70120] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6057), 1,
      sym_identifier,
    ACTIONS(6059), 1,
      anon_sym_LPAREN,
    ACTIONS(6061), 1,
      anon_sym__,
    ACTIONS(6063), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6065), 1,
      anon_sym_POUND,
    STATE(4309), 1,
      sym__type,
    STATE(4379), 1,
      sym__static_type_identifier,
    STATE(4482), 1,
      sym_type_argument,
    STATE(4685), 1,
      sym_long_identifier,
    ACTIONS(6067), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3851), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4690), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [70192] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4511), 1,
      anon_sym_LPAREN,
    ACTIONS(4513), 1,
      anon_sym__,
    ACTIONS(4515), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4519), 1,
      anon_sym_POUND,
    ACTIONS(5768), 1,
      sym_identifier,
    STATE(4686), 1,
      sym__static_type_identifier,
    STATE(4913), 1,
      sym_type_argument,
    STATE(5121), 1,
      sym_long_identifier,
    STATE(5388), 1,
      sym__type,
    ACTIONS(4521), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3852), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5109), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [70264] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3281), 1,
      sym_identifier,
    ACTIONS(5904), 1,
      anon_sym_LPAREN,
    ACTIONS(5906), 1,
      anon_sym__,
    ACTIONS(5908), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(5910), 1,
      anon_sym_POUND,
    STATE(1032), 1,
      sym__type,
    STATE(1241), 1,
      sym__static_type_identifier,
    STATE(1324), 1,
      sym_type_argument,
    STATE(1326), 1,
      sym_long_identifier,
    ACTIONS(5912), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3853), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(1321), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [70336] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3236), 1,
      sym_identifier,
    ACTIONS(5884), 1,
      anon_sym_LPAREN,
    ACTIONS(5886), 1,
      anon_sym__,
    ACTIONS(5888), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(5890), 1,
      anon_sym_POUND,
    STATE(1036), 1,
      sym__type,
    STATE(1240), 1,
      sym__static_type_identifier,
    STATE(1314), 1,
      sym_long_identifier,
    STATE(1315), 1,
      sym_type_argument,
    ACTIONS(5892), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3854), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(1332), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [70408] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4511), 1,
      anon_sym_LPAREN,
    ACTIONS(4513), 1,
      anon_sym__,
    ACTIONS(4515), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4519), 1,
      anon_sym_POUND,
    ACTIONS(5768), 1,
      sym_identifier,
    STATE(4686), 1,
      sym__static_type_identifier,
    STATE(4913), 1,
      sym_type_argument,
    STATE(5121), 1,
      sym_long_identifier,
    STATE(5219), 1,
      sym__type,
    ACTIONS(4521), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3855), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5109), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [70480] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4511), 1,
      anon_sym_LPAREN,
    ACTIONS(4513), 1,
      anon_sym__,
    ACTIONS(4515), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4519), 1,
      anon_sym_POUND,
    ACTIONS(5768), 1,
      sym_identifier,
    STATE(4686), 1,
      sym__static_type_identifier,
    STATE(4913), 1,
      sym_type_argument,
    STATE(5121), 1,
      sym_long_identifier,
    STATE(5209), 1,
      sym__type,
    ACTIONS(4521), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3856), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5109), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [70552] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6069), 1,
      sym_identifier,
    ACTIONS(6071), 1,
      anon_sym_LPAREN,
    ACTIONS(6073), 1,
      anon_sym__,
    ACTIONS(6075), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6077), 1,
      anon_sym_POUND,
    STATE(4273), 1,
      sym__static_type_identifier,
    STATE(4279), 1,
      sym__type,
    STATE(4395), 1,
      sym_type_argument,
    STATE(4571), 1,
      sym_long_identifier,
    ACTIONS(6079), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3857), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4573), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [70624] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5455), 1,
      anon_sym_LPAREN,
    ACTIONS(5457), 1,
      anon_sym__,
    ACTIONS(5461), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(5463), 1,
      anon_sym_POUND,
    ACTIONS(5967), 1,
      sym_identifier,
    STATE(4139), 1,
      sym__type,
    STATE(4182), 1,
      sym__static_type_identifier,
    STATE(4223), 1,
      sym_type_argument,
    STATE(4259), 1,
      sym_long_identifier,
    ACTIONS(5465), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3858), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4263), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [70696] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4511), 1,
      anon_sym_LPAREN,
    ACTIONS(4513), 1,
      anon_sym__,
    ACTIONS(4515), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4519), 1,
      anon_sym_POUND,
    ACTIONS(5768), 1,
      sym_identifier,
    STATE(4686), 1,
      sym__static_type_identifier,
    STATE(4913), 1,
      sym_type_argument,
    STATE(5121), 1,
      sym_long_identifier,
    STATE(5360), 1,
      sym__type,
    ACTIONS(4521), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3859), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5109), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [70768] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5455), 1,
      anon_sym_LPAREN,
    ACTIONS(5457), 1,
      anon_sym__,
    ACTIONS(5461), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(5463), 1,
      anon_sym_POUND,
    ACTIONS(5967), 1,
      sym_identifier,
    STATE(4182), 1,
      sym__static_type_identifier,
    STATE(4198), 1,
      sym__type,
    STATE(4223), 1,
      sym_type_argument,
    STATE(4259), 1,
      sym_long_identifier,
    ACTIONS(5465), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3860), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4263), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [70840] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4511), 1,
      anon_sym_LPAREN,
    ACTIONS(4513), 1,
      anon_sym__,
    ACTIONS(4515), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4519), 1,
      anon_sym_POUND,
    ACTIONS(5768), 1,
      sym_identifier,
    STATE(4686), 1,
      sym__static_type_identifier,
    STATE(4913), 1,
      sym_type_argument,
    STATE(5121), 1,
      sym_long_identifier,
    STATE(5403), 1,
      sym__type,
    ACTIONS(4521), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3861), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5109), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [70912] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5872), 1,
      sym_identifier,
    ACTIONS(5874), 1,
      anon_sym_LPAREN,
    ACTIONS(5876), 1,
      anon_sym__,
    ACTIONS(5878), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(5880), 1,
      anon_sym_POUND,
    STATE(4208), 1,
      sym__type,
    STATE(4217), 1,
      sym__static_type_identifier,
    STATE(4313), 1,
      sym_type_argument,
    STATE(4470), 1,
      sym_long_identifier,
    ACTIONS(5882), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3862), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4465), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [70984] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4511), 1,
      anon_sym_LPAREN,
    ACTIONS(4513), 1,
      anon_sym__,
    ACTIONS(4515), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4519), 1,
      anon_sym_POUND,
    ACTIONS(5768), 1,
      sym_identifier,
    STATE(4686), 1,
      sym__static_type_identifier,
    STATE(4913), 1,
      sym_type_argument,
    STATE(5121), 1,
      sym_long_identifier,
    STATE(5291), 1,
      sym__type,
    ACTIONS(4521), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3863), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5109), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [71056] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5455), 1,
      anon_sym_LPAREN,
    ACTIONS(5457), 1,
      anon_sym__,
    ACTIONS(5461), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(5463), 1,
      anon_sym_POUND,
    ACTIONS(5967), 1,
      sym_identifier,
    STATE(4153), 1,
      sym__type,
    STATE(4182), 1,
      sym__static_type_identifier,
    STATE(4223), 1,
      sym_type_argument,
    STATE(4259), 1,
      sym_long_identifier,
    ACTIONS(5465), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3864), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4263), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [71128] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5872), 1,
      sym_identifier,
    ACTIONS(5874), 1,
      anon_sym_LPAREN,
    ACTIONS(5876), 1,
      anon_sym__,
    ACTIONS(5878), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(5880), 1,
      anon_sym_POUND,
    STATE(4216), 1,
      sym__type,
    STATE(4217), 1,
      sym__static_type_identifier,
    STATE(4313), 1,
      sym_type_argument,
    STATE(4470), 1,
      sym_long_identifier,
    ACTIONS(5882), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3865), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4465), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [71200] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4511), 1,
      anon_sym_LPAREN,
    ACTIONS(4513), 1,
      anon_sym__,
    ACTIONS(4515), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4519), 1,
      anon_sym_POUND,
    ACTIONS(5768), 1,
      sym_identifier,
    STATE(4686), 1,
      sym__static_type_identifier,
    STATE(4913), 1,
      sym_type_argument,
    STATE(5121), 1,
      sym_long_identifier,
    STATE(5412), 1,
      sym__type,
    ACTIONS(4521), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3866), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5109), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [71272] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3281), 1,
      sym_identifier,
    ACTIONS(5904), 1,
      anon_sym_LPAREN,
    ACTIONS(5906), 1,
      anon_sym__,
    ACTIONS(5908), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(5910), 1,
      anon_sym_POUND,
    STATE(1010), 1,
      sym__type,
    STATE(1241), 1,
      sym__static_type_identifier,
    STATE(1324), 1,
      sym_type_argument,
    STATE(1326), 1,
      sym_long_identifier,
    ACTIONS(5912), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3867), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(1321), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [71344] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4511), 1,
      anon_sym_LPAREN,
    ACTIONS(4513), 1,
      anon_sym__,
    ACTIONS(4515), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4519), 1,
      anon_sym_POUND,
    ACTIONS(5768), 1,
      sym_identifier,
    STATE(4686), 1,
      sym__static_type_identifier,
    STATE(4913), 1,
      sym_type_argument,
    STATE(5121), 1,
      sym_long_identifier,
    STATE(5185), 1,
      sym__type,
    ACTIONS(4521), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3868), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5109), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [71416] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4511), 1,
      anon_sym_LPAREN,
    ACTIONS(4513), 1,
      anon_sym__,
    ACTIONS(4515), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4519), 1,
      anon_sym_POUND,
    ACTIONS(5768), 1,
      sym_identifier,
    STATE(4686), 1,
      sym__static_type_identifier,
    STATE(4913), 1,
      sym_type_argument,
    STATE(5121), 1,
      sym_long_identifier,
    STATE(5242), 1,
      sym__type,
    ACTIONS(4521), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3869), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5109), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [71488] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4511), 1,
      anon_sym_LPAREN,
    ACTIONS(4513), 1,
      anon_sym__,
    ACTIONS(4515), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4519), 1,
      anon_sym_POUND,
    ACTIONS(5768), 1,
      sym_identifier,
    STATE(4686), 1,
      sym__static_type_identifier,
    STATE(4913), 1,
      sym_type_argument,
    STATE(5121), 1,
      sym_long_identifier,
    STATE(5319), 1,
      sym__type,
    ACTIONS(4521), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3870), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5109), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [71560] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3236), 1,
      sym_identifier,
    ACTIONS(5884), 1,
      anon_sym_LPAREN,
    ACTIONS(5886), 1,
      anon_sym__,
    ACTIONS(5888), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(5890), 1,
      anon_sym_POUND,
    STATE(997), 1,
      sym__type,
    STATE(1240), 1,
      sym__static_type_identifier,
    STATE(1314), 1,
      sym_long_identifier,
    STATE(1315), 1,
      sym_type_argument,
    ACTIONS(5892), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3871), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(1332), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [71632] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5106), 1,
      sym_identifier,
    ACTIONS(6033), 1,
      anon_sym_LPAREN,
    ACTIONS(6035), 1,
      anon_sym__,
    ACTIONS(6037), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6039), 1,
      anon_sym_POUND,
    STATE(2953), 1,
      sym__static_type_identifier,
    STATE(2984), 1,
      sym__type,
    STATE(3151), 1,
      sym_type_argument,
    STATE(3260), 1,
      sym_long_identifier,
    ACTIONS(6041), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3872), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(3262), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [71704] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6081), 1,
      anon_sym_DOT,
    STATE(3805), 1,
      aux_sym_long_identifier_repeat1,
    STATE(3873), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2418), 9,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(2420), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [71762] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4511), 1,
      anon_sym_LPAREN,
    ACTIONS(4513), 1,
      anon_sym__,
    ACTIONS(4515), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4519), 1,
      anon_sym_POUND,
    ACTIONS(5768), 1,
      sym_identifier,
    STATE(4686), 1,
      sym__static_type_identifier,
    STATE(4913), 1,
      sym_type_argument,
    STATE(5121), 1,
      sym_long_identifier,
    STATE(5228), 1,
      sym__type,
    ACTIONS(4521), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3874), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5109), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [71834] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4511), 1,
      anon_sym_LPAREN,
    ACTIONS(4513), 1,
      anon_sym__,
    ACTIONS(4515), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4519), 1,
      anon_sym_POUND,
    ACTIONS(5768), 1,
      sym_identifier,
    STATE(4686), 1,
      sym__static_type_identifier,
    STATE(4913), 1,
      sym_type_argument,
    STATE(5121), 1,
      sym_long_identifier,
    STATE(5395), 1,
      sym__type,
    ACTIONS(4521), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3875), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5109), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [71906] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4511), 1,
      anon_sym_LPAREN,
    ACTIONS(4513), 1,
      anon_sym__,
    ACTIONS(4515), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4519), 1,
      anon_sym_POUND,
    ACTIONS(5768), 1,
      sym_identifier,
    STATE(4686), 1,
      sym__static_type_identifier,
    STATE(4913), 1,
      sym_type_argument,
    STATE(5121), 1,
      sym_long_identifier,
    STATE(5197), 1,
      sym__type,
    ACTIONS(4521), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3876), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5109), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [71978] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6083), 1,
      sym_identifier,
    ACTIONS(6085), 1,
      anon_sym_LPAREN,
    ACTIONS(6087), 1,
      anon_sym__,
    ACTIONS(6089), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6091), 1,
      anon_sym_POUND,
    STATE(4282), 1,
      sym__static_type_identifier,
    STATE(4286), 1,
      sym__type,
    STATE(4430), 1,
      sym_type_argument,
    STATE(4530), 1,
      sym_long_identifier,
    ACTIONS(6093), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3877), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4532), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [72050] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6083), 1,
      sym_identifier,
    ACTIONS(6085), 1,
      anon_sym_LPAREN,
    ACTIONS(6087), 1,
      anon_sym__,
    ACTIONS(6089), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6091), 1,
      anon_sym_POUND,
    STATE(4265), 1,
      sym__type,
    STATE(4282), 1,
      sym__static_type_identifier,
    STATE(4430), 1,
      sym_type_argument,
    STATE(4530), 1,
      sym_long_identifier,
    ACTIONS(6093), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3878), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4532), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [72122] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6083), 1,
      sym_identifier,
    ACTIONS(6085), 1,
      anon_sym_LPAREN,
    ACTIONS(6087), 1,
      anon_sym__,
    ACTIONS(6089), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6091), 1,
      anon_sym_POUND,
    STATE(4264), 1,
      sym__type,
    STATE(4282), 1,
      sym__static_type_identifier,
    STATE(4430), 1,
      sym_type_argument,
    STATE(4530), 1,
      sym_long_identifier,
    ACTIONS(6093), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3879), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4532), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [72194] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6083), 1,
      sym_identifier,
    ACTIONS(6085), 1,
      anon_sym_LPAREN,
    ACTIONS(6087), 1,
      anon_sym__,
    ACTIONS(6089), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6091), 1,
      anon_sym_POUND,
    STATE(4249), 1,
      sym__type,
    STATE(4282), 1,
      sym__static_type_identifier,
    STATE(4430), 1,
      sym_type_argument,
    STATE(4530), 1,
      sym_long_identifier,
    ACTIONS(6093), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3880), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4532), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [72266] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4994), 1,
      sym_identifier,
    ACTIONS(6095), 1,
      anon_sym_LPAREN,
    ACTIONS(6097), 1,
      anon_sym__,
    ACTIONS(6099), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6101), 1,
      anon_sym_POUND,
    STATE(2897), 1,
      sym__type,
    STATE(2912), 1,
      sym__static_type_identifier,
    STATE(3029), 1,
      sym_type_argument,
    STATE(3140), 1,
      sym_long_identifier,
    ACTIONS(6103), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3881), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(3139), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [72338] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3155), 1,
      sym_identifier,
    ACTIONS(5942), 1,
      anon_sym_LPAREN,
    ACTIONS(5944), 1,
      anon_sym__,
    ACTIONS(5946), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(5948), 1,
      anon_sym_POUND,
    STATE(965), 1,
      sym__type,
    STATE(1110), 1,
      sym__static_type_identifier,
    STATE(1173), 1,
      sym_type_argument,
    STATE(1279), 1,
      sym_long_identifier,
    ACTIONS(5950), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3882), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(1258), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [72410] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4511), 1,
      anon_sym_LPAREN,
    ACTIONS(4513), 1,
      anon_sym__,
    ACTIONS(4515), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4519), 1,
      anon_sym_POUND,
    ACTIONS(5768), 1,
      sym_identifier,
    STATE(4686), 1,
      sym__static_type_identifier,
    STATE(4913), 1,
      sym_type_argument,
    STATE(5121), 1,
      sym_long_identifier,
    STATE(5204), 1,
      sym__type,
    ACTIONS(4521), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3883), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5109), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [72482] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4511), 1,
      anon_sym_LPAREN,
    ACTIONS(4513), 1,
      anon_sym__,
    ACTIONS(4515), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4519), 1,
      anon_sym_POUND,
    ACTIONS(5768), 1,
      sym_identifier,
    STATE(4686), 1,
      sym__static_type_identifier,
    STATE(4913), 1,
      sym_type_argument,
    STATE(5121), 1,
      sym_long_identifier,
    STATE(5392), 1,
      sym__type,
    ACTIONS(4521), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3884), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5109), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [72554] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4949), 1,
      sym_identifier,
    ACTIONS(5894), 1,
      anon_sym_LPAREN,
    ACTIONS(5896), 1,
      anon_sym__,
    ACTIONS(5898), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(5900), 1,
      anon_sym_POUND,
    STATE(2880), 1,
      sym__static_type_identifier,
    STATE(2882), 1,
      sym__type,
    STATE(2966), 1,
      sym_type_argument,
    STATE(3063), 1,
      sym_long_identifier,
    ACTIONS(5902), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3885), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(3074), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [72626] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3886), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6105), 10,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(6107), 12,
      anon_sym_LBRACK_LT,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [72680] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5333), 1,
      aux_sym_decimal_token1,
    ACTIONS(5437), 1,
      anon_sym_f,
    STATE(3887), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2158), 9,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(2160), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [72738] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6109), 1,
      sym_identifier,
    ACTIONS(6111), 1,
      anon_sym_LPAREN,
    ACTIONS(6113), 1,
      anon_sym__,
    ACTIONS(6115), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6117), 1,
      anon_sym_POUND,
    STATE(4717), 1,
      sym__type,
    STATE(4779), 1,
      sym__static_type_identifier,
    STATE(5045), 1,
      sym_type_argument,
    STATE(5231), 1,
      sym_long_identifier,
    ACTIONS(6119), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3888), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5238), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [72810] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6109), 1,
      sym_identifier,
    ACTIONS(6111), 1,
      anon_sym_LPAREN,
    ACTIONS(6113), 1,
      anon_sym__,
    ACTIONS(6115), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6117), 1,
      anon_sym_POUND,
    STATE(4779), 1,
      sym__static_type_identifier,
    STATE(4816), 1,
      sym__type,
    STATE(5045), 1,
      sym_type_argument,
    STATE(5231), 1,
      sym_long_identifier,
    ACTIONS(6119), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3889), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5238), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [72882] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6109), 1,
      sym_identifier,
    ACTIONS(6111), 1,
      anon_sym_LPAREN,
    ACTIONS(6113), 1,
      anon_sym__,
    ACTIONS(6115), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6117), 1,
      anon_sym_POUND,
    STATE(4779), 1,
      sym__static_type_identifier,
    STATE(4789), 1,
      sym__type,
    STATE(5045), 1,
      sym_type_argument,
    STATE(5231), 1,
      sym_long_identifier,
    ACTIONS(6119), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3890), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5238), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [72954] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6109), 1,
      sym_identifier,
    ACTIONS(6111), 1,
      anon_sym_LPAREN,
    ACTIONS(6113), 1,
      anon_sym__,
    ACTIONS(6115), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6117), 1,
      anon_sym_POUND,
    STATE(4762), 1,
      sym__type,
    STATE(4779), 1,
      sym__static_type_identifier,
    STATE(5045), 1,
      sym_type_argument,
    STATE(5231), 1,
      sym_long_identifier,
    ACTIONS(6119), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3891), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5238), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [73026] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4511), 1,
      anon_sym_LPAREN,
    ACTIONS(4513), 1,
      anon_sym__,
    ACTIONS(4515), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4519), 1,
      anon_sym_POUND,
    ACTIONS(5768), 1,
      sym_identifier,
    STATE(4686), 1,
      sym__static_type_identifier,
    STATE(4913), 1,
      sym_type_argument,
    STATE(5076), 1,
      sym__type,
    STATE(5121), 1,
      sym_long_identifier,
    ACTIONS(4521), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3892), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5109), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [73098] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4994), 1,
      sym_identifier,
    ACTIONS(6095), 1,
      anon_sym_LPAREN,
    ACTIONS(6097), 1,
      anon_sym__,
    ACTIONS(6099), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6101), 1,
      anon_sym_POUND,
    STATE(2912), 1,
      sym__static_type_identifier,
    STATE(2920), 1,
      sym__type,
    STATE(3029), 1,
      sym_type_argument,
    STATE(3140), 1,
      sym_long_identifier,
    ACTIONS(6103), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3893), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(3139), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [73170] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4949), 1,
      sym_identifier,
    ACTIONS(5894), 1,
      anon_sym_LPAREN,
    ACTIONS(5896), 1,
      anon_sym__,
    ACTIONS(5898), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(5900), 1,
      anon_sym_POUND,
    STATE(2880), 1,
      sym__static_type_identifier,
    STATE(2889), 1,
      sym__type,
    STATE(2966), 1,
      sym_type_argument,
    STATE(3063), 1,
      sym_long_identifier,
    ACTIONS(5902), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3894), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(3074), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [73242] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4511), 1,
      anon_sym_LPAREN,
    ACTIONS(4513), 1,
      anon_sym__,
    ACTIONS(4515), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4519), 1,
      anon_sym_POUND,
    ACTIONS(5768), 1,
      sym_identifier,
    STATE(4686), 1,
      sym__static_type_identifier,
    STATE(4913), 1,
      sym_type_argument,
    STATE(5121), 1,
      sym_long_identifier,
    STATE(5331), 1,
      sym__type,
    ACTIONS(4521), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3895), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5109), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [73314] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5455), 1,
      anon_sym_LPAREN,
    ACTIONS(5457), 1,
      anon_sym__,
    ACTIONS(5461), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(5463), 1,
      anon_sym_POUND,
    ACTIONS(5967), 1,
      sym_identifier,
    STATE(4182), 1,
      sym__static_type_identifier,
    STATE(4197), 1,
      sym__type,
    STATE(4223), 1,
      sym_type_argument,
    STATE(4259), 1,
      sym_long_identifier,
    ACTIONS(5465), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3896), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4263), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [73386] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3265), 1,
      sym_identifier,
    ACTIONS(6121), 1,
      anon_sym_LPAREN,
    ACTIONS(6123), 1,
      anon_sym__,
    ACTIONS(6125), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6127), 1,
      anon_sym_POUND,
    STATE(1027), 1,
      sym__type,
    STATE(1257), 1,
      sym__static_type_identifier,
    STATE(1300), 1,
      sym_type_argument,
    STATE(1301), 1,
      sym_long_identifier,
    ACTIONS(6129), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3897), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(1298), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [73458] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3281), 1,
      sym_identifier,
    ACTIONS(5904), 1,
      anon_sym_LPAREN,
    ACTIONS(5906), 1,
      anon_sym__,
    ACTIONS(5908), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(5910), 1,
      anon_sym_POUND,
    STATE(1034), 1,
      sym__type,
    STATE(1241), 1,
      sym__static_type_identifier,
    STATE(1324), 1,
      sym_type_argument,
    STATE(1326), 1,
      sym_long_identifier,
    ACTIONS(5912), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3898), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(1321), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [73530] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3281), 1,
      sym_identifier,
    ACTIONS(5904), 1,
      anon_sym_LPAREN,
    ACTIONS(5906), 1,
      anon_sym__,
    ACTIONS(5908), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(5910), 1,
      anon_sym_POUND,
    STATE(1035), 1,
      sym__type,
    STATE(1241), 1,
      sym__static_type_identifier,
    STATE(1324), 1,
      sym_type_argument,
    STATE(1326), 1,
      sym_long_identifier,
    ACTIONS(5912), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3899), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(1321), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [73602] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3265), 1,
      sym_identifier,
    ACTIONS(6121), 1,
      anon_sym_LPAREN,
    ACTIONS(6123), 1,
      anon_sym__,
    ACTIONS(6125), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6127), 1,
      anon_sym_POUND,
    STATE(1026), 1,
      sym__type,
    STATE(1257), 1,
      sym__static_type_identifier,
    STATE(1300), 1,
      sym_type_argument,
    STATE(1301), 1,
      sym_long_identifier,
    ACTIONS(6129), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3900), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(1298), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [73674] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3265), 1,
      sym_identifier,
    ACTIONS(6121), 1,
      anon_sym_LPAREN,
    ACTIONS(6123), 1,
      anon_sym__,
    ACTIONS(6125), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6127), 1,
      anon_sym_POUND,
    STATE(1017), 1,
      sym__type,
    STATE(1257), 1,
      sym__static_type_identifier,
    STATE(1300), 1,
      sym_type_argument,
    STATE(1301), 1,
      sym_long_identifier,
    ACTIONS(6129), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3901), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(1298), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [73746] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5029), 1,
      sym_identifier,
    ACTIONS(6131), 1,
      anon_sym_LPAREN,
    ACTIONS(6133), 1,
      anon_sym__,
    ACTIONS(6135), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6137), 1,
      anon_sym_POUND,
    STATE(2901), 1,
      sym__type,
    STATE(2908), 1,
      sym__static_type_identifier,
    STATE(3065), 1,
      sym_type_argument,
    STATE(3170), 1,
      sym_long_identifier,
    ACTIONS(6139), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3902), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(3171), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [73818] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2226), 1,
      sym_identifier,
    ACTIONS(6141), 1,
      anon_sym_LPAREN,
    ACTIONS(6143), 1,
      anon_sym__,
    ACTIONS(6145), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6147), 1,
      anon_sym_POUND,
    STATE(763), 1,
      sym__type,
    STATE(772), 1,
      sym__static_type_identifier,
    STATE(802), 1,
      sym_long_identifier,
    STATE(804), 1,
      sym_type_argument,
    ACTIONS(6149), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3903), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(807), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [73890] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2226), 1,
      sym_identifier,
    ACTIONS(6141), 1,
      anon_sym_LPAREN,
    ACTIONS(6143), 1,
      anon_sym__,
    ACTIONS(6145), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6147), 1,
      anon_sym_POUND,
    STATE(764), 1,
      sym__type,
    STATE(772), 1,
      sym__static_type_identifier,
    STATE(802), 1,
      sym_long_identifier,
    STATE(804), 1,
      sym_type_argument,
    ACTIONS(6149), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3904), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(807), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [73962] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2226), 1,
      sym_identifier,
    ACTIONS(6141), 1,
      anon_sym_LPAREN,
    ACTIONS(6143), 1,
      anon_sym__,
    ACTIONS(6145), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6147), 1,
      anon_sym_POUND,
    STATE(765), 1,
      sym__type,
    STATE(772), 1,
      sym__static_type_identifier,
    STATE(802), 1,
      sym_long_identifier,
    STATE(804), 1,
      sym_type_argument,
    ACTIONS(6149), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3905), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(807), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [74034] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5872), 1,
      sym_identifier,
    ACTIONS(5874), 1,
      anon_sym_LPAREN,
    ACTIONS(5876), 1,
      anon_sym__,
    ACTIONS(5878), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(5880), 1,
      anon_sym_POUND,
    STATE(4212), 1,
      sym__type,
    STATE(4217), 1,
      sym__static_type_identifier,
    STATE(4313), 1,
      sym_type_argument,
    STATE(4470), 1,
      sym_long_identifier,
    ACTIONS(5882), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3906), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4465), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [74106] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5455), 1,
      anon_sym_LPAREN,
    ACTIONS(5457), 1,
      anon_sym__,
    ACTIONS(5461), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(5463), 1,
      anon_sym_POUND,
    ACTIONS(5967), 1,
      sym_identifier,
    STATE(4182), 1,
      sym__static_type_identifier,
    STATE(4192), 1,
      sym__type,
    STATE(4223), 1,
      sym_type_argument,
    STATE(4259), 1,
      sym_long_identifier,
    ACTIONS(5465), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3907), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4263), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [74178] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5029), 1,
      sym_identifier,
    ACTIONS(6131), 1,
      anon_sym_LPAREN,
    ACTIONS(6133), 1,
      anon_sym__,
    ACTIONS(6135), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6137), 1,
      anon_sym_POUND,
    STATE(2908), 1,
      sym__static_type_identifier,
    STATE(2909), 1,
      sym__type,
    STATE(3065), 1,
      sym_type_argument,
    STATE(3170), 1,
      sym_long_identifier,
    ACTIONS(6139), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3908), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(3171), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [74250] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4511), 1,
      anon_sym_LPAREN,
    ACTIONS(4513), 1,
      anon_sym__,
    ACTIONS(4515), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4519), 1,
      anon_sym_POUND,
    ACTIONS(5768), 1,
      sym_identifier,
    STATE(4686), 1,
      sym__static_type_identifier,
    STATE(4913), 1,
      sym_type_argument,
    STATE(5121), 1,
      sym_long_identifier,
    STATE(5188), 1,
      sym__type,
    ACTIONS(4521), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3909), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5109), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [74322] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4511), 1,
      anon_sym_LPAREN,
    ACTIONS(4513), 1,
      anon_sym__,
    ACTIONS(4515), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4519), 1,
      anon_sym_POUND,
    ACTIONS(5768), 1,
      sym_identifier,
    STATE(4686), 1,
      sym__static_type_identifier,
    STATE(4913), 1,
      sym_type_argument,
    STATE(5121), 1,
      sym_long_identifier,
    STATE(5226), 1,
      sym__type,
    ACTIONS(4521), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3910), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5109), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [74394] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4511), 1,
      anon_sym_LPAREN,
    ACTIONS(4513), 1,
      anon_sym__,
    ACTIONS(4515), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4519), 1,
      anon_sym_POUND,
    ACTIONS(5768), 1,
      sym_identifier,
    STATE(4686), 1,
      sym__static_type_identifier,
    STATE(4913), 1,
      sym_type_argument,
    STATE(5121), 1,
      sym_long_identifier,
    STATE(5345), 1,
      sym__type,
    ACTIONS(4521), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3911), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5109), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [74466] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4511), 1,
      anon_sym_LPAREN,
    ACTIONS(4513), 1,
      anon_sym__,
    ACTIONS(4515), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4519), 1,
      anon_sym_POUND,
    ACTIONS(5768), 1,
      sym_identifier,
    STATE(4686), 1,
      sym__static_type_identifier,
    STATE(4913), 1,
      sym_type_argument,
    STATE(5121), 1,
      sym_long_identifier,
    STATE(5240), 1,
      sym__type,
    ACTIONS(4521), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3912), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5109), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [74538] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6069), 1,
      sym_identifier,
    ACTIONS(6071), 1,
      anon_sym_LPAREN,
    ACTIONS(6073), 1,
      anon_sym__,
    ACTIONS(6075), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6077), 1,
      anon_sym_POUND,
    STATE(4273), 1,
      sym__static_type_identifier,
    STATE(4311), 1,
      sym__type,
    STATE(4395), 1,
      sym_type_argument,
    STATE(4571), 1,
      sym_long_identifier,
    ACTIONS(6079), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3913), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4573), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [74610] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4511), 1,
      anon_sym_LPAREN,
    ACTIONS(4513), 1,
      anon_sym__,
    ACTIONS(4515), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4519), 1,
      anon_sym_POUND,
    ACTIONS(5768), 1,
      sym_identifier,
    STATE(4686), 1,
      sym__static_type_identifier,
    STATE(4913), 1,
      sym_type_argument,
    STATE(5121), 1,
      sym_long_identifier,
    STATE(5243), 1,
      sym__type,
    ACTIONS(4521), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3914), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5109), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [74682] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6069), 1,
      sym_identifier,
    ACTIONS(6071), 1,
      anon_sym_LPAREN,
    ACTIONS(6073), 1,
      anon_sym__,
    ACTIONS(6075), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6077), 1,
      anon_sym_POUND,
    STATE(4273), 1,
      sym__static_type_identifier,
    STATE(4281), 1,
      sym__type,
    STATE(4395), 1,
      sym_type_argument,
    STATE(4571), 1,
      sym_long_identifier,
    ACTIONS(6079), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3915), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4573), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [74754] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4511), 1,
      anon_sym_LPAREN,
    ACTIONS(4513), 1,
      anon_sym__,
    ACTIONS(4515), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4519), 1,
      anon_sym_POUND,
    ACTIONS(5768), 1,
      sym_identifier,
    STATE(4686), 1,
      sym__static_type_identifier,
    STATE(4913), 1,
      sym_type_argument,
    STATE(5121), 1,
      sym_long_identifier,
    STATE(5193), 1,
      sym__type,
    ACTIONS(4521), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3916), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5109), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [74826] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5242), 1,
      sym_identifier,
    ACTIONS(5979), 1,
      anon_sym_LPAREN,
    ACTIONS(5981), 1,
      anon_sym__,
    ACTIONS(5983), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(5985), 1,
      anon_sym_POUND,
    STATE(3068), 1,
      sym__type,
    STATE(3093), 1,
      sym__static_type_identifier,
    STATE(3255), 1,
      sym_type_argument,
    STATE(3289), 1,
      sym_long_identifier,
    ACTIONS(5987), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3917), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(3294), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [74898] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4511), 1,
      anon_sym_LPAREN,
    ACTIONS(4513), 1,
      anon_sym__,
    ACTIONS(4515), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4519), 1,
      anon_sym_POUND,
    ACTIONS(5768), 1,
      sym_identifier,
    STATE(4686), 1,
      sym__static_type_identifier,
    STATE(4913), 1,
      sym_type_argument,
    STATE(5121), 1,
      sym_long_identifier,
    STATE(5382), 1,
      sym__type,
    ACTIONS(4521), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3918), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5109), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [74970] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5242), 1,
      sym_identifier,
    ACTIONS(5979), 1,
      anon_sym_LPAREN,
    ACTIONS(5981), 1,
      anon_sym__,
    ACTIONS(5983), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(5985), 1,
      anon_sym_POUND,
    STATE(3093), 1,
      sym__static_type_identifier,
    STATE(3097), 1,
      sym__type,
    STATE(3255), 1,
      sym_type_argument,
    STATE(3289), 1,
      sym_long_identifier,
    ACTIONS(5987), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3919), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(3294), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [75042] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5242), 1,
      sym_identifier,
    ACTIONS(5979), 1,
      anon_sym_LPAREN,
    ACTIONS(5981), 1,
      anon_sym__,
    ACTIONS(5983), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(5985), 1,
      anon_sym_POUND,
    STATE(3093), 1,
      sym__static_type_identifier,
    STATE(3098), 1,
      sym__type,
    STATE(3255), 1,
      sym_type_argument,
    STATE(3289), 1,
      sym_long_identifier,
    ACTIONS(5987), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3920), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(3294), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [75114] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5242), 1,
      sym_identifier,
    ACTIONS(5979), 1,
      anon_sym_LPAREN,
    ACTIONS(5981), 1,
      anon_sym__,
    ACTIONS(5983), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(5985), 1,
      anon_sym_POUND,
    STATE(3093), 1,
      sym__static_type_identifier,
    STATE(3099), 1,
      sym__type,
    STATE(3255), 1,
      sym_type_argument,
    STATE(3289), 1,
      sym_long_identifier,
    ACTIONS(5987), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3921), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(3294), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [75186] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4511), 1,
      anon_sym_LPAREN,
    ACTIONS(4513), 1,
      anon_sym__,
    ACTIONS(4515), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4519), 1,
      anon_sym_POUND,
    ACTIONS(5768), 1,
      sym_identifier,
    STATE(4686), 1,
      sym__static_type_identifier,
    STATE(4913), 1,
      sym_type_argument,
    STATE(5121), 1,
      sym_long_identifier,
    STATE(5245), 1,
      sym__type,
    ACTIONS(4521), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3922), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5109), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [75258] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6151), 1,
      sym_identifier,
    ACTIONS(6153), 1,
      anon_sym_LPAREN,
    ACTIONS(6155), 1,
      anon_sym__,
    ACTIONS(6157), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6159), 1,
      anon_sym_POUND,
    STATE(4269), 1,
      sym__static_type_identifier,
    STATE(4294), 1,
      sym__type,
    STATE(4460), 1,
      sym_type_argument,
    STATE(4481), 1,
      sym_long_identifier,
    ACTIONS(6161), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3923), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4485), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [75330] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5019), 1,
      sym_identifier,
    ACTIONS(6163), 1,
      anon_sym_LPAREN,
    ACTIONS(6165), 1,
      anon_sym__,
    ACTIONS(6167), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6169), 1,
      anon_sym_POUND,
    STATE(2913), 1,
      sym__type,
    STATE(2932), 1,
      sym__static_type_identifier,
    STATE(3041), 1,
      sym_type_argument,
    STATE(3196), 1,
      sym_long_identifier,
    ACTIONS(6171), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3924), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(3110), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [75402] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6069), 1,
      sym_identifier,
    ACTIONS(6071), 1,
      anon_sym_LPAREN,
    ACTIONS(6073), 1,
      anon_sym__,
    ACTIONS(6075), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6077), 1,
      anon_sym_POUND,
    STATE(4273), 1,
      sym__static_type_identifier,
    STATE(4308), 1,
      sym__type,
    STATE(4395), 1,
      sym_type_argument,
    STATE(4571), 1,
      sym_long_identifier,
    ACTIONS(6079), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3925), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4573), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [75474] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6151), 1,
      sym_identifier,
    ACTIONS(6153), 1,
      anon_sym_LPAREN,
    ACTIONS(6155), 1,
      anon_sym__,
    ACTIONS(6157), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6159), 1,
      anon_sym_POUND,
    STATE(4269), 1,
      sym__static_type_identifier,
    STATE(4295), 1,
      sym__type,
    STATE(4460), 1,
      sym_type_argument,
    STATE(4481), 1,
      sym_long_identifier,
    ACTIONS(6161), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3926), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4485), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [75546] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5163), 1,
      sym_identifier,
    ACTIONS(6023), 1,
      anon_sym_LPAREN,
    ACTIONS(6025), 1,
      anon_sym__,
    ACTIONS(6027), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6029), 1,
      anon_sym_POUND,
    STATE(2970), 1,
      sym__static_type_identifier,
    STATE(3018), 1,
      sym__type,
    STATE(3119), 1,
      sym_type_argument,
    STATE(3238), 1,
      sym_long_identifier,
    ACTIONS(6031), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3927), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(3239), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [75618] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5163), 1,
      sym_identifier,
    ACTIONS(6023), 1,
      anon_sym_LPAREN,
    ACTIONS(6025), 1,
      anon_sym__,
    ACTIONS(6027), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6029), 1,
      anon_sym_POUND,
    STATE(2970), 1,
      sym__static_type_identifier,
    STATE(3005), 1,
      sym__type,
    STATE(3119), 1,
      sym_type_argument,
    STATE(3238), 1,
      sym_long_identifier,
    ACTIONS(6031), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3928), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(3239), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [75690] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6001), 1,
      sym_identifier,
    ACTIONS(6003), 1,
      anon_sym_LPAREN,
    ACTIONS(6005), 1,
      anon_sym__,
    ACTIONS(6007), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6009), 1,
      anon_sym_POUND,
    STATE(4315), 1,
      sym__static_type_identifier,
    STATE(4330), 1,
      sym__type,
    STATE(4575), 1,
      sym_type_argument,
    STATE(4602), 1,
      sym_long_identifier,
    ACTIONS(6011), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3929), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4598), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [75762] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5163), 1,
      sym_identifier,
    ACTIONS(6023), 1,
      anon_sym_LPAREN,
    ACTIONS(6025), 1,
      anon_sym__,
    ACTIONS(6027), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6029), 1,
      anon_sym_POUND,
    STATE(2970), 1,
      sym__static_type_identifier,
    STATE(3001), 1,
      sym__type,
    STATE(3119), 1,
      sym_type_argument,
    STATE(3238), 1,
      sym_long_identifier,
    ACTIONS(6031), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3930), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(3239), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [75834] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4968), 1,
      sym_identifier,
    ACTIONS(6173), 1,
      anon_sym_LPAREN,
    ACTIONS(6175), 1,
      anon_sym__,
    ACTIONS(6177), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6179), 1,
      anon_sym_POUND,
    STATE(2883), 1,
      sym__static_type_identifier,
    STATE(2892), 1,
      sym__type,
    STATE(2947), 1,
      sym_type_argument,
    STATE(3066), 1,
      sym_long_identifier,
    ACTIONS(6181), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3931), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(3030), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [75906] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6057), 1,
      sym_identifier,
    ACTIONS(6059), 1,
      anon_sym_LPAREN,
    ACTIONS(6061), 1,
      anon_sym__,
    ACTIONS(6063), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6065), 1,
      anon_sym_POUND,
    STATE(4352), 1,
      sym__type,
    STATE(4379), 1,
      sym__static_type_identifier,
    STATE(4482), 1,
      sym_type_argument,
    STATE(4685), 1,
      sym_long_identifier,
    ACTIONS(6067), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3932), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4690), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [75978] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4994), 1,
      sym_identifier,
    ACTIONS(6095), 1,
      anon_sym_LPAREN,
    ACTIONS(6097), 1,
      anon_sym__,
    ACTIONS(6099), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6101), 1,
      anon_sym_POUND,
    STATE(2912), 1,
      sym__static_type_identifier,
    STATE(2934), 1,
      sym__type,
    STATE(3029), 1,
      sym_type_argument,
    STATE(3140), 1,
      sym_long_identifier,
    ACTIONS(6103), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3933), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(3139), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [76050] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5163), 1,
      sym_identifier,
    ACTIONS(6023), 1,
      anon_sym_LPAREN,
    ACTIONS(6025), 1,
      anon_sym__,
    ACTIONS(6027), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6029), 1,
      anon_sym_POUND,
    STATE(2970), 1,
      sym__static_type_identifier,
    STATE(2989), 1,
      sym__type,
    STATE(3119), 1,
      sym_type_argument,
    STATE(3238), 1,
      sym_long_identifier,
    ACTIONS(6031), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3934), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(3239), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [76122] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3188), 1,
      sym_identifier,
    ACTIONS(6183), 1,
      anon_sym_LPAREN,
    ACTIONS(6185), 1,
      anon_sym__,
    ACTIONS(6187), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6189), 1,
      anon_sym_POUND,
    STATE(982), 1,
      sym__type,
    STATE(1060), 1,
      sym__static_type_identifier,
    STATE(1182), 1,
      sym_long_identifier,
    STATE(1197), 1,
      sym_type_argument,
    ACTIONS(6191), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3935), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(1212), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [76194] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5455), 1,
      anon_sym_LPAREN,
    ACTIONS(5457), 1,
      anon_sym__,
    ACTIONS(5461), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(5463), 1,
      anon_sym_POUND,
    ACTIONS(5967), 1,
      sym_identifier,
    STATE(4182), 1,
      sym__static_type_identifier,
    STATE(4223), 1,
      sym_type_argument,
    STATE(4259), 1,
      sym_long_identifier,
    STATE(5066), 1,
      sym__type,
    ACTIONS(5465), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3936), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4263), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [76266] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4511), 1,
      anon_sym_LPAREN,
    ACTIONS(4513), 1,
      anon_sym__,
    ACTIONS(4515), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4519), 1,
      anon_sym_POUND,
    ACTIONS(5768), 1,
      sym_identifier,
    STATE(4686), 1,
      sym__static_type_identifier,
    STATE(4913), 1,
      sym_type_argument,
    STATE(5121), 1,
      sym_long_identifier,
    STATE(5362), 1,
      sym__type,
    ACTIONS(4521), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3937), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5109), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [76338] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4511), 1,
      anon_sym_LPAREN,
    ACTIONS(4513), 1,
      anon_sym__,
    ACTIONS(4515), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4519), 1,
      anon_sym_POUND,
    ACTIONS(5768), 1,
      sym_identifier,
    STATE(4686), 1,
      sym__static_type_identifier,
    STATE(4913), 1,
      sym_type_argument,
    STATE(5121), 1,
      sym_long_identifier,
    STATE(5410), 1,
      sym__type,
    ACTIONS(4521), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3938), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5109), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [76410] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4511), 1,
      anon_sym_LPAREN,
    ACTIONS(4513), 1,
      anon_sym__,
    ACTIONS(4515), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4519), 1,
      anon_sym_POUND,
    ACTIONS(5768), 1,
      sym_identifier,
    STATE(4686), 1,
      sym__static_type_identifier,
    STATE(4913), 1,
      sym_type_argument,
    STATE(5121), 1,
      sym_long_identifier,
    STATE(5407), 1,
      sym__type,
    ACTIONS(4521), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3939), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5109), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [76482] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4511), 1,
      anon_sym_LPAREN,
    ACTIONS(4513), 1,
      anon_sym__,
    ACTIONS(4515), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4519), 1,
      anon_sym_POUND,
    ACTIONS(5768), 1,
      sym_identifier,
    STATE(4686), 1,
      sym__static_type_identifier,
    STATE(4913), 1,
      sym_type_argument,
    STATE(5121), 1,
      sym_long_identifier,
    STATE(5353), 1,
      sym__type,
    ACTIONS(4521), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3940), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5109), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [76554] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2659), 1,
      sym_identifier,
    ACTIONS(6193), 1,
      anon_sym_LPAREN,
    ACTIONS(6195), 1,
      anon_sym__,
    ACTIONS(6197), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6199), 1,
      anon_sym_POUND,
    STATE(813), 1,
      sym__type,
    STATE(846), 1,
      sym__static_type_identifier,
    STATE(902), 1,
      sym_long_identifier,
    STATE(904), 1,
      sym_type_argument,
    ACTIONS(6201), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3941), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(911), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [76626] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2659), 1,
      sym_identifier,
    ACTIONS(6193), 1,
      anon_sym_LPAREN,
    ACTIONS(6195), 1,
      anon_sym__,
    ACTIONS(6197), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6199), 1,
      anon_sym_POUND,
    STATE(812), 1,
      sym__type,
    STATE(846), 1,
      sym__static_type_identifier,
    STATE(902), 1,
      sym_long_identifier,
    STATE(904), 1,
      sym_type_argument,
    ACTIONS(6201), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3942), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(911), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [76698] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6203), 1,
      sym_identifier,
    ACTIONS(6205), 1,
      anon_sym_LPAREN,
    ACTIONS(6207), 1,
      anon_sym__,
    ACTIONS(6209), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6211), 1,
      anon_sym_POUND,
    STATE(4280), 1,
      sym__static_type_identifier,
    STATE(4392), 1,
      sym_type_argument,
    STATE(4455), 1,
      sym__type,
    STATE(4580), 1,
      sym_long_identifier,
    ACTIONS(6213), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3943), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4577), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [76770] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6203), 1,
      sym_identifier,
    ACTIONS(6205), 1,
      anon_sym_LPAREN,
    ACTIONS(6207), 1,
      anon_sym__,
    ACTIONS(6209), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6211), 1,
      anon_sym_POUND,
    STATE(4280), 1,
      sym__static_type_identifier,
    STATE(4371), 1,
      sym__type,
    STATE(4392), 1,
      sym_type_argument,
    STATE(4580), 1,
      sym_long_identifier,
    ACTIONS(6213), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3944), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4577), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [76842] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5085), 1,
      sym_identifier,
    ACTIONS(6215), 1,
      anon_sym_LPAREN,
    ACTIONS(6217), 1,
      anon_sym__,
    ACTIONS(6219), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6221), 1,
      anon_sym_POUND,
    STATE(2982), 1,
      sym__static_type_identifier,
    STATE(3020), 1,
      sym__type,
    STATE(3132), 1,
      sym_type_argument,
    STATE(3272), 1,
      sym_long_identifier,
    ACTIONS(6223), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3945), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(3270), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [76914] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5085), 1,
      sym_identifier,
    ACTIONS(6215), 1,
      anon_sym_LPAREN,
    ACTIONS(6217), 1,
      anon_sym__,
    ACTIONS(6219), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6221), 1,
      anon_sym_POUND,
    STATE(2971), 1,
      sym__type,
    STATE(2982), 1,
      sym__static_type_identifier,
    STATE(3132), 1,
      sym_type_argument,
    STATE(3272), 1,
      sym_long_identifier,
    ACTIONS(6223), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3946), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(3270), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [76986] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2659), 1,
      sym_identifier,
    ACTIONS(6193), 1,
      anon_sym_LPAREN,
    ACTIONS(6195), 1,
      anon_sym__,
    ACTIONS(6197), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6199), 1,
      anon_sym_POUND,
    STATE(816), 1,
      sym__type,
    STATE(846), 1,
      sym__static_type_identifier,
    STATE(902), 1,
      sym_long_identifier,
    STATE(904), 1,
      sym_type_argument,
    ACTIONS(6201), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3947), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(911), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [77058] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6069), 1,
      sym_identifier,
    ACTIONS(6071), 1,
      anon_sym_LPAREN,
    ACTIONS(6073), 1,
      anon_sym__,
    ACTIONS(6075), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6077), 1,
      anon_sym_POUND,
    STATE(4273), 1,
      sym__static_type_identifier,
    STATE(4278), 1,
      sym__type,
    STATE(4395), 1,
      sym_type_argument,
    STATE(4571), 1,
      sym_long_identifier,
    ACTIONS(6079), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3948), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4573), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [77130] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3173), 1,
      sym_identifier,
    ACTIONS(6225), 1,
      anon_sym_LPAREN,
    ACTIONS(6227), 1,
      anon_sym__,
    ACTIONS(6229), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6231), 1,
      anon_sym_POUND,
    STATE(969), 1,
      sym__type,
    STATE(1112), 1,
      sym__static_type_identifier,
    STATE(1270), 1,
      sym_long_identifier,
    STATE(1271), 1,
      sym_type_argument,
    ACTIONS(6233), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3949), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(1189), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [77202] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3155), 1,
      sym_identifier,
    ACTIONS(5942), 1,
      anon_sym_LPAREN,
    ACTIONS(5944), 1,
      anon_sym__,
    ACTIONS(5946), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(5948), 1,
      anon_sym_POUND,
    STATE(973), 1,
      sym__type,
    STATE(1110), 1,
      sym__static_type_identifier,
    STATE(1173), 1,
      sym_type_argument,
    STATE(1279), 1,
      sym_long_identifier,
    ACTIONS(5950), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3950), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(1258), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [77274] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5070), 1,
      sym_identifier,
    ACTIONS(6013), 1,
      anon_sym_LPAREN,
    ACTIONS(6015), 1,
      anon_sym__,
    ACTIONS(6017), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6019), 1,
      anon_sym_POUND,
    STATE(2911), 1,
      sym__static_type_identifier,
    STATE(2915), 1,
      sym__type,
    STATE(3056), 1,
      sym_type_argument,
    STATE(3193), 1,
      sym_long_identifier,
    ACTIONS(6021), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3951), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(3195), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [77346] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4511), 1,
      anon_sym_LPAREN,
    ACTIONS(4513), 1,
      anon_sym__,
    ACTIONS(4515), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4519), 1,
      anon_sym_POUND,
    ACTIONS(5768), 1,
      sym_identifier,
    STATE(4686), 1,
      sym__static_type_identifier,
    STATE(4913), 1,
      sym_type_argument,
    STATE(5121), 1,
      sym_long_identifier,
    STATE(5211), 1,
      sym__type,
    ACTIONS(4521), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3952), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5109), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [77418] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5085), 1,
      sym_identifier,
    ACTIONS(6215), 1,
      anon_sym_LPAREN,
    ACTIONS(6217), 1,
      anon_sym__,
    ACTIONS(6219), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6221), 1,
      anon_sym_POUND,
    STATE(2958), 1,
      sym__type,
    STATE(2982), 1,
      sym__static_type_identifier,
    STATE(3132), 1,
      sym_type_argument,
    STATE(3272), 1,
      sym_long_identifier,
    ACTIONS(6223), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3953), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(3270), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [77490] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5085), 1,
      sym_identifier,
    ACTIONS(6215), 1,
      anon_sym_LPAREN,
    ACTIONS(6217), 1,
      anon_sym__,
    ACTIONS(6219), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6221), 1,
      anon_sym_POUND,
    STATE(2963), 1,
      sym__type,
    STATE(2982), 1,
      sym__static_type_identifier,
    STATE(3132), 1,
      sym_type_argument,
    STATE(3272), 1,
      sym_long_identifier,
    ACTIONS(6223), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3954), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(3270), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [77562] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3236), 1,
      sym_identifier,
    ACTIONS(5884), 1,
      anon_sym_LPAREN,
    ACTIONS(5886), 1,
      anon_sym__,
    ACTIONS(5888), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(5890), 1,
      anon_sym_POUND,
    STATE(998), 1,
      sym__type,
    STATE(1240), 1,
      sym__static_type_identifier,
    STATE(1314), 1,
      sym_long_identifier,
    STATE(1315), 1,
      sym_type_argument,
    ACTIONS(5892), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3955), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(1332), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [77634] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6057), 1,
      sym_identifier,
    ACTIONS(6059), 1,
      anon_sym_LPAREN,
    ACTIONS(6061), 1,
      anon_sym__,
    ACTIONS(6063), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6065), 1,
      anon_sym_POUND,
    STATE(4365), 1,
      sym__type,
    STATE(4379), 1,
      sym__static_type_identifier,
    STATE(4482), 1,
      sym_type_argument,
    STATE(4685), 1,
      sym_long_identifier,
    ACTIONS(6067), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3956), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4690), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [77706] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3188), 1,
      sym_identifier,
    ACTIONS(6183), 1,
      anon_sym_LPAREN,
    ACTIONS(6185), 1,
      anon_sym__,
    ACTIONS(6187), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6189), 1,
      anon_sym_POUND,
    STATE(986), 1,
      sym__type,
    STATE(1060), 1,
      sym__static_type_identifier,
    STATE(1182), 1,
      sym_long_identifier,
    STATE(1197), 1,
      sym_type_argument,
    ACTIONS(6191), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3957), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(1212), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [77778] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3151), 1,
      sym_identifier,
    ACTIONS(6235), 1,
      anon_sym_LPAREN,
    ACTIONS(6237), 1,
      anon_sym__,
    ACTIONS(6239), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6241), 1,
      anon_sym_POUND,
    STATE(960), 1,
      sym__type,
    STATE(1006), 1,
      sym__static_type_identifier,
    STATE(1168), 1,
      sym_type_argument,
    STATE(1169), 1,
      sym_long_identifier,
    ACTIONS(6243), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3958), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(1145), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [77850] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6081), 1,
      anon_sym_DOT,
    STATE(3873), 1,
      aux_sym_long_identifier_repeat1,
    STATE(3959), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2312), 9,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(2314), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [77908] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3173), 1,
      sym_identifier,
    ACTIONS(6225), 1,
      anon_sym_LPAREN,
    ACTIONS(6227), 1,
      anon_sym__,
    ACTIONS(6229), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6231), 1,
      anon_sym_POUND,
    STATE(970), 1,
      sym__type,
    STATE(1112), 1,
      sym__static_type_identifier,
    STATE(1270), 1,
      sym_long_identifier,
    STATE(1271), 1,
      sym_type_argument,
    ACTIONS(6233), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3960), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(1189), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [77980] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6203), 1,
      sym_identifier,
    ACTIONS(6205), 1,
      anon_sym_LPAREN,
    ACTIONS(6207), 1,
      anon_sym__,
    ACTIONS(6209), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6211), 1,
      anon_sym_POUND,
    STATE(4270), 1,
      sym__type,
    STATE(4280), 1,
      sym__static_type_identifier,
    STATE(4392), 1,
      sym_type_argument,
    STATE(4580), 1,
      sym_long_identifier,
    ACTIONS(6213), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3961), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4577), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [78052] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3173), 1,
      sym_identifier,
    ACTIONS(6225), 1,
      anon_sym_LPAREN,
    ACTIONS(6227), 1,
      anon_sym__,
    ACTIONS(6229), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6231), 1,
      anon_sym_POUND,
    STATE(984), 1,
      sym__type,
    STATE(1112), 1,
      sym__static_type_identifier,
    STATE(1270), 1,
      sym_long_identifier,
    STATE(1271), 1,
      sym_type_argument,
    ACTIONS(6233), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3962), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(1189), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [78124] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5106), 1,
      sym_identifier,
    ACTIONS(6033), 1,
      anon_sym_LPAREN,
    ACTIONS(6035), 1,
      anon_sym__,
    ACTIONS(6037), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6039), 1,
      anon_sym_POUND,
    STATE(2953), 1,
      sym__static_type_identifier,
    STATE(2954), 1,
      sym__type,
    STATE(3151), 1,
      sym_type_argument,
    STATE(3260), 1,
      sym_long_identifier,
    ACTIONS(6041), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3963), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(3262), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [78196] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3188), 1,
      sym_identifier,
    ACTIONS(6183), 1,
      anon_sym_LPAREN,
    ACTIONS(6185), 1,
      anon_sym__,
    ACTIONS(6187), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6189), 1,
      anon_sym_POUND,
    STATE(978), 1,
      sym__type,
    STATE(1060), 1,
      sym__static_type_identifier,
    STATE(1182), 1,
      sym_long_identifier,
    STATE(1197), 1,
      sym_type_argument,
    ACTIONS(6191), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3964), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(1212), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [78268] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6203), 1,
      sym_identifier,
    ACTIONS(6205), 1,
      anon_sym_LPAREN,
    ACTIONS(6207), 1,
      anon_sym__,
    ACTIONS(6209), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6211), 1,
      anon_sym_POUND,
    STATE(4271), 1,
      sym__type,
    STATE(4280), 1,
      sym__static_type_identifier,
    STATE(4392), 1,
      sym_type_argument,
    STATE(4580), 1,
      sym_long_identifier,
    ACTIONS(6213), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3965), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4577), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [78340] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3188), 1,
      sym_identifier,
    ACTIONS(6183), 1,
      anon_sym_LPAREN,
    ACTIONS(6185), 1,
      anon_sym__,
    ACTIONS(6187), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6189), 1,
      anon_sym_POUND,
    STATE(977), 1,
      sym__type,
    STATE(1060), 1,
      sym__static_type_identifier,
    STATE(1182), 1,
      sym_long_identifier,
    STATE(1197), 1,
      sym_type_argument,
    ACTIONS(6191), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3966), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(1212), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [78412] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5106), 1,
      sym_identifier,
    ACTIONS(6033), 1,
      anon_sym_LPAREN,
    ACTIONS(6035), 1,
      anon_sym__,
    ACTIONS(6037), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6039), 1,
      anon_sym_POUND,
    STATE(2953), 1,
      sym__static_type_identifier,
    STATE(2978), 1,
      sym__type,
    STATE(3151), 1,
      sym_type_argument,
    STATE(3260), 1,
      sym_long_identifier,
    ACTIONS(6041), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3967), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(3262), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [78484] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5106), 1,
      sym_identifier,
    ACTIONS(6033), 1,
      anon_sym_LPAREN,
    ACTIONS(6035), 1,
      anon_sym__,
    ACTIONS(6037), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6039), 1,
      anon_sym_POUND,
    STATE(2953), 1,
      sym__static_type_identifier,
    STATE(2994), 1,
      sym__type,
    STATE(3151), 1,
      sym_type_argument,
    STATE(3260), 1,
      sym_long_identifier,
    ACTIONS(6041), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3968), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(3262), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [78556] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4511), 1,
      anon_sym_LPAREN,
    ACTIONS(4513), 1,
      anon_sym__,
    ACTIONS(4515), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4519), 1,
      anon_sym_POUND,
    ACTIONS(5768), 1,
      sym_identifier,
    STATE(4686), 1,
      sym__static_type_identifier,
    STATE(4913), 1,
      sym_type_argument,
    STATE(5121), 1,
      sym_long_identifier,
    STATE(5262), 1,
      sym__type,
    ACTIONS(4521), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3969), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5109), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [78628] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6245), 1,
      sym_int,
    STATE(3970), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2819), 10,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_f,
      aux_sym_decimal_token1,
      sym_identifier,
    ACTIONS(2821), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [78684] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5106), 1,
      sym_identifier,
    ACTIONS(6033), 1,
      anon_sym_LPAREN,
    ACTIONS(6035), 1,
      anon_sym__,
    ACTIONS(6037), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6039), 1,
      anon_sym_POUND,
    STATE(2953), 1,
      sym__static_type_identifier,
    STATE(3012), 1,
      sym__type,
    STATE(3151), 1,
      sym_type_argument,
    STATE(3260), 1,
      sym_long_identifier,
    ACTIONS(6041), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3971), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(3262), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [78756] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4511), 1,
      anon_sym_LPAREN,
    ACTIONS(4513), 1,
      anon_sym__,
    ACTIONS(4515), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4519), 1,
      anon_sym_POUND,
    ACTIONS(5768), 1,
      sym_identifier,
    STATE(4686), 1,
      sym__static_type_identifier,
    STATE(4913), 1,
      sym_type_argument,
    STATE(5121), 1,
      sym_long_identifier,
    STATE(5254), 1,
      sym__type,
    ACTIONS(4521), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3972), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5109), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [78828] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6109), 1,
      sym_identifier,
    ACTIONS(6111), 1,
      anon_sym_LPAREN,
    ACTIONS(6113), 1,
      anon_sym__,
    ACTIONS(6115), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6117), 1,
      anon_sym_POUND,
    STATE(4748), 1,
      sym__type,
    STATE(4779), 1,
      sym__static_type_identifier,
    STATE(5045), 1,
      sym_type_argument,
    STATE(5231), 1,
      sym_long_identifier,
    ACTIONS(6119), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3973), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5238), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [78900] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5029), 1,
      sym_identifier,
    ACTIONS(6131), 1,
      anon_sym_LPAREN,
    ACTIONS(6133), 1,
      anon_sym__,
    ACTIONS(6135), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6137), 1,
      anon_sym_POUND,
    STATE(2903), 1,
      sym__type,
    STATE(2908), 1,
      sym__static_type_identifier,
    STATE(3065), 1,
      sym_type_argument,
    STATE(3170), 1,
      sym_long_identifier,
    ACTIONS(6139), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3974), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(3171), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [78972] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5029), 1,
      sym_identifier,
    ACTIONS(6131), 1,
      anon_sym_LPAREN,
    ACTIONS(6133), 1,
      anon_sym__,
    ACTIONS(6135), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6137), 1,
      anon_sym_POUND,
    STATE(2896), 1,
      sym__type,
    STATE(2908), 1,
      sym__static_type_identifier,
    STATE(3065), 1,
      sym_type_argument,
    STATE(3170), 1,
      sym_long_identifier,
    ACTIONS(6139), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3975), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(3171), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [79044] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6247), 1,
      sym_identifier,
    ACTIONS(6249), 1,
      anon_sym_LPAREN,
    ACTIONS(6251), 1,
      anon_sym__,
    ACTIONS(6253), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6255), 1,
      anon_sym_POUND,
    STATE(4389), 1,
      sym__static_type_identifier,
    STATE(4424), 1,
      sym__type,
    STATE(4596), 1,
      sym_type_argument,
    STATE(4738), 1,
      sym_long_identifier,
    ACTIONS(6257), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3976), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4722), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [79116] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5029), 1,
      sym_identifier,
    ACTIONS(6131), 1,
      anon_sym_LPAREN,
    ACTIONS(6133), 1,
      anon_sym__,
    ACTIONS(6135), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6137), 1,
      anon_sym_POUND,
    STATE(2908), 1,
      sym__static_type_identifier,
    STATE(2945), 1,
      sym__type,
    STATE(3065), 1,
      sym_type_argument,
    STATE(3170), 1,
      sym_long_identifier,
    ACTIONS(6139), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3977), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(3171), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [79188] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4511), 1,
      anon_sym_LPAREN,
    ACTIONS(4513), 1,
      anon_sym__,
    ACTIONS(4515), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4519), 1,
      anon_sym_POUND,
    ACTIONS(5768), 1,
      sym_identifier,
    STATE(4686), 1,
      sym__static_type_identifier,
    STATE(4913), 1,
      sym_type_argument,
    STATE(5121), 1,
      sym_long_identifier,
    STATE(5202), 1,
      sym__type,
    ACTIONS(4521), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3978), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5109), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [79260] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3151), 1,
      sym_identifier,
    ACTIONS(6235), 1,
      anon_sym_LPAREN,
    ACTIONS(6237), 1,
      anon_sym__,
    ACTIONS(6239), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6241), 1,
      anon_sym_POUND,
    STATE(963), 1,
      sym__type,
    STATE(1006), 1,
      sym__static_type_identifier,
    STATE(1168), 1,
      sym_type_argument,
    STATE(1169), 1,
      sym_long_identifier,
    ACTIONS(6243), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3979), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(1145), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [79332] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4511), 1,
      anon_sym_LPAREN,
    ACTIONS(4513), 1,
      anon_sym__,
    ACTIONS(4515), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4519), 1,
      anon_sym_POUND,
    ACTIONS(5768), 1,
      sym_identifier,
    STATE(4686), 1,
      sym__static_type_identifier,
    STATE(4913), 1,
      sym_type_argument,
    STATE(5121), 1,
      sym_long_identifier,
    STATE(5217), 1,
      sym__type,
    ACTIONS(4521), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3980), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5109), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [79404] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5029), 1,
      sym_identifier,
    ACTIONS(6131), 1,
      anon_sym_LPAREN,
    ACTIONS(6133), 1,
      anon_sym__,
    ACTIONS(6135), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6137), 1,
      anon_sym_POUND,
    STATE(2908), 1,
      sym__static_type_identifier,
    STATE(2921), 1,
      sym__type,
    STATE(3065), 1,
      sym_type_argument,
    STATE(3170), 1,
      sym_long_identifier,
    ACTIONS(6139), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3981), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(3171), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [79476] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3982), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2506), 10,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2508), 12,
      anon_sym_LBRACK_LT,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [79530] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4511), 1,
      anon_sym_LPAREN,
    ACTIONS(4513), 1,
      anon_sym__,
    ACTIONS(4515), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4519), 1,
      anon_sym_POUND,
    ACTIONS(5768), 1,
      sym_identifier,
    STATE(4686), 1,
      sym__static_type_identifier,
    STATE(4913), 1,
      sym_type_argument,
    STATE(5121), 1,
      sym_long_identifier,
    STATE(5174), 1,
      sym__type,
    ACTIONS(4521), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3983), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5109), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [79602] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6259), 1,
      sym_identifier,
    ACTIONS(6261), 1,
      anon_sym_LPAREN,
    ACTIONS(6263), 1,
      anon_sym__,
    ACTIONS(6265), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6267), 1,
      anon_sym_POUND,
    STATE(4318), 1,
      sym__type,
    STATE(4358), 1,
      sym__static_type_identifier,
    STATE(4487), 1,
      sym_type_argument,
    STATE(4683), 1,
      sym_long_identifier,
    ACTIONS(6269), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3984), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4684), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [79674] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4994), 1,
      sym_identifier,
    ACTIONS(6095), 1,
      anon_sym_LPAREN,
    ACTIONS(6097), 1,
      anon_sym__,
    ACTIONS(6099), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6101), 1,
      anon_sym_POUND,
    STATE(2912), 1,
      sym__static_type_identifier,
    STATE(2937), 1,
      sym__type,
    STATE(3029), 1,
      sym_type_argument,
    STATE(3140), 1,
      sym_long_identifier,
    ACTIONS(6103), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3985), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(3139), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [79746] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3986), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2470), 10,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2472), 12,
      anon_sym_LBRACK_LT,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [79800] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(3987), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2454), 10,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(2456), 12,
      anon_sym_LBRACK_LT,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [79854] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3265), 1,
      sym_identifier,
    ACTIONS(6121), 1,
      anon_sym_LPAREN,
    ACTIONS(6123), 1,
      anon_sym__,
    ACTIONS(6125), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6127), 1,
      anon_sym_POUND,
    STATE(995), 1,
      sym__type,
    STATE(1257), 1,
      sym__static_type_identifier,
    STATE(1300), 1,
      sym_type_argument,
    STATE(1301), 1,
      sym_long_identifier,
    ACTIONS(6129), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3988), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(1298), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [79926] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6259), 1,
      sym_identifier,
    ACTIONS(6261), 1,
      anon_sym_LPAREN,
    ACTIONS(6263), 1,
      anon_sym__,
    ACTIONS(6265), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6267), 1,
      anon_sym_POUND,
    STATE(4324), 1,
      sym__type,
    STATE(4358), 1,
      sym__static_type_identifier,
    STATE(4487), 1,
      sym_type_argument,
    STATE(4683), 1,
      sym_long_identifier,
    ACTIONS(6269), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3989), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4684), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [79998] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4511), 1,
      anon_sym_LPAREN,
    ACTIONS(4513), 1,
      anon_sym__,
    ACTIONS(4515), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4519), 1,
      anon_sym_POUND,
    ACTIONS(5768), 1,
      sym_identifier,
    STATE(4686), 1,
      sym__static_type_identifier,
    STATE(4913), 1,
      sym_type_argument,
    STATE(5121), 1,
      sym_long_identifier,
    STATE(5317), 1,
      sym__type,
    ACTIONS(4521), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3990), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5109), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [80070] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6259), 1,
      sym_identifier,
    ACTIONS(6261), 1,
      anon_sym_LPAREN,
    ACTIONS(6263), 1,
      anon_sym__,
    ACTIONS(6265), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6267), 1,
      anon_sym_POUND,
    STATE(4325), 1,
      sym__type,
    STATE(4358), 1,
      sym__static_type_identifier,
    STATE(4487), 1,
      sym_type_argument,
    STATE(4683), 1,
      sym_long_identifier,
    ACTIONS(6269), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3991), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4684), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [80142] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4504), 1,
      sym_identifier,
    ACTIONS(5347), 1,
      anon_sym_LPAREN,
    ACTIONS(5349), 1,
      anon_sym__,
    ACTIONS(5351), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(5353), 1,
      anon_sym_POUND,
    STATE(2708), 1,
      sym__static_type_identifier,
    STATE(2712), 1,
      sym__type,
    STATE(2770), 1,
      sym_type_argument,
    STATE(2788), 1,
      sym_long_identifier,
    ACTIONS(5355), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3992), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(2778), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [80214] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3151), 1,
      sym_identifier,
    ACTIONS(6235), 1,
      anon_sym_LPAREN,
    ACTIONS(6237), 1,
      anon_sym__,
    ACTIONS(6239), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6241), 1,
      anon_sym_POUND,
    STATE(959), 1,
      sym__type,
    STATE(1006), 1,
      sym__static_type_identifier,
    STATE(1168), 1,
      sym_type_argument,
    STATE(1169), 1,
      sym_long_identifier,
    ACTIONS(6243), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3993), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(1145), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [80286] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6203), 1,
      sym_identifier,
    ACTIONS(6205), 1,
      anon_sym_LPAREN,
    ACTIONS(6207), 1,
      anon_sym__,
    ACTIONS(6209), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6211), 1,
      anon_sym_POUND,
    STATE(4272), 1,
      sym__type,
    STATE(4280), 1,
      sym__static_type_identifier,
    STATE(4392), 1,
      sym_type_argument,
    STATE(4580), 1,
      sym_long_identifier,
    ACTIONS(6213), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3994), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4577), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [80358] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6259), 1,
      sym_identifier,
    ACTIONS(6261), 1,
      anon_sym_LPAREN,
    ACTIONS(6263), 1,
      anon_sym__,
    ACTIONS(6265), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6267), 1,
      anon_sym_POUND,
    STATE(4356), 1,
      sym__type,
    STATE(4358), 1,
      sym__static_type_identifier,
    STATE(4487), 1,
      sym_type_argument,
    STATE(4683), 1,
      sym_long_identifier,
    ACTIONS(6269), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3995), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4684), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [80430] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5019), 1,
      sym_identifier,
    ACTIONS(6163), 1,
      anon_sym_LPAREN,
    ACTIONS(6165), 1,
      anon_sym__,
    ACTIONS(6167), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6169), 1,
      anon_sym_POUND,
    STATE(2895), 1,
      sym__type,
    STATE(2932), 1,
      sym__static_type_identifier,
    STATE(3041), 1,
      sym_type_argument,
    STATE(3196), 1,
      sym_long_identifier,
    ACTIONS(6171), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3996), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(3110), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [80502] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4511), 1,
      anon_sym_LPAREN,
    ACTIONS(4513), 1,
      anon_sym__,
    ACTIONS(4515), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4519), 1,
      anon_sym_POUND,
    ACTIONS(5768), 1,
      sym_identifier,
    STATE(4686), 1,
      sym__static_type_identifier,
    STATE(4913), 1,
      sym_type_argument,
    STATE(5121), 1,
      sym_long_identifier,
    STATE(5234), 1,
      sym__type,
    ACTIONS(4521), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3997), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5109), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [80574] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5848), 1,
      sym_identifier,
    ACTIONS(5850), 1,
      anon_sym_LPAREN,
    ACTIONS(5852), 1,
      anon_sym__,
    ACTIONS(5854), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(5856), 1,
      anon_sym_POUND,
    STATE(4946), 1,
      sym__type,
    STATE(5003), 1,
      sym__static_type_identifier,
    STATE(5466), 1,
      sym_type_argument,
    STATE(5569), 1,
      sym_long_identifier,
    ACTIONS(5858), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3998), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5520), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [80646] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6203), 1,
      sym_identifier,
    ACTIONS(6205), 1,
      anon_sym_LPAREN,
    ACTIONS(6207), 1,
      anon_sym__,
    ACTIONS(6209), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6211), 1,
      anon_sym_POUND,
    STATE(4276), 1,
      sym__type,
    STATE(4280), 1,
      sym__static_type_identifier,
    STATE(4392), 1,
      sym_type_argument,
    STATE(4580), 1,
      sym_long_identifier,
    ACTIONS(6213), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(3999), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4577), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [80718] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4511), 1,
      anon_sym_LPAREN,
    ACTIONS(4513), 1,
      anon_sym__,
    ACTIONS(4515), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4519), 1,
      anon_sym_POUND,
    ACTIONS(5768), 1,
      sym_identifier,
    STATE(4686), 1,
      sym__static_type_identifier,
    STATE(4913), 1,
      sym_type_argument,
    STATE(5121), 1,
      sym_long_identifier,
    STATE(5369), 1,
      sym__type,
    ACTIONS(4521), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4000), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5109), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [80790] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2659), 1,
      sym_identifier,
    ACTIONS(6193), 1,
      anon_sym_LPAREN,
    ACTIONS(6195), 1,
      anon_sym__,
    ACTIONS(6197), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6199), 1,
      anon_sym_POUND,
    STATE(811), 1,
      sym__type,
    STATE(846), 1,
      sym__static_type_identifier,
    STATE(902), 1,
      sym_long_identifier,
    STATE(904), 1,
      sym_type_argument,
    ACTIONS(6201), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4001), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(911), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [80862] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4511), 1,
      anon_sym_LPAREN,
    ACTIONS(4513), 1,
      anon_sym__,
    ACTIONS(4515), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4519), 1,
      anon_sym_POUND,
    ACTIONS(5768), 1,
      sym_identifier,
    STATE(4686), 1,
      sym__static_type_identifier,
    STATE(4913), 1,
      sym_type_argument,
    STATE(5121), 1,
      sym_long_identifier,
    STATE(5260), 1,
      sym__type,
    ACTIONS(4521), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4002), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5109), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [80934] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3214), 1,
      sym_identifier,
    ACTIONS(6047), 1,
      anon_sym_LPAREN,
    ACTIONS(6049), 1,
      anon_sym__,
    ACTIONS(6051), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6053), 1,
      anon_sym_POUND,
    STATE(994), 1,
      sym__type,
    STATE(1242), 1,
      sym__static_type_identifier,
    STATE(1316), 1,
      sym_long_identifier,
    STATE(1317), 1,
      sym_type_argument,
    ACTIONS(6055), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4003), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(1325), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [81006] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4978), 1,
      sym_identifier,
    ACTIONS(5969), 1,
      anon_sym_LPAREN,
    ACTIONS(5971), 1,
      anon_sym__,
    ACTIONS(5973), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(5975), 1,
      anon_sym_POUND,
    STATE(2879), 1,
      sym__type,
    STATE(2931), 1,
      sym__static_type_identifier,
    STATE(3036), 1,
      sym_type_argument,
    STATE(3113), 1,
      sym_long_identifier,
    ACTIONS(5977), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4004), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(3112), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [81078] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4511), 1,
      anon_sym_LPAREN,
    ACTIONS(4513), 1,
      anon_sym__,
    ACTIONS(4515), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4519), 1,
      anon_sym_POUND,
    ACTIONS(5768), 1,
      sym_identifier,
    STATE(4686), 1,
      sym__static_type_identifier,
    STATE(4913), 1,
      sym_type_argument,
    STATE(5121), 1,
      sym_long_identifier,
    STATE(5391), 1,
      sym__type,
    ACTIONS(4521), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4005), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5109), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [81150] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4511), 1,
      anon_sym_LPAREN,
    ACTIONS(4513), 1,
      anon_sym__,
    ACTIONS(4515), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4519), 1,
      anon_sym_POUND,
    ACTIONS(5768), 1,
      sym_identifier,
    STATE(4686), 1,
      sym__static_type_identifier,
    STATE(4913), 1,
      sym_type_argument,
    STATE(5121), 1,
      sym_long_identifier,
    STATE(5368), 1,
      sym__type,
    ACTIONS(4521), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4006), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5109), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [81222] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4511), 1,
      anon_sym_LPAREN,
    ACTIONS(4513), 1,
      anon_sym__,
    ACTIONS(4515), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4519), 1,
      anon_sym_POUND,
    ACTIONS(5768), 1,
      sym_identifier,
    STATE(4686), 1,
      sym__static_type_identifier,
    STATE(4913), 1,
      sym_type_argument,
    STATE(5121), 1,
      sym_long_identifier,
    STATE(5384), 1,
      sym__type,
    ACTIONS(4521), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4007), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5109), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [81294] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5989), 1,
      sym_identifier,
    ACTIONS(5991), 1,
      anon_sym_LPAREN,
    ACTIONS(5993), 1,
      anon_sym__,
    ACTIONS(5995), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(5997), 1,
      anon_sym_POUND,
    STATE(4335), 1,
      sym__static_type_identifier,
    STATE(4375), 1,
      sym__type,
    STATE(4557), 1,
      sym_type_argument,
    STATE(4646), 1,
      sym_long_identifier,
    ACTIONS(5999), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4008), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4664), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [81366] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4511), 1,
      anon_sym_LPAREN,
    ACTIONS(4513), 1,
      anon_sym__,
    ACTIONS(4515), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4519), 1,
      anon_sym_POUND,
    ACTIONS(5768), 1,
      sym_identifier,
    STATE(4686), 1,
      sym__static_type_identifier,
    STATE(4913), 1,
      sym_type_argument,
    STATE(5121), 1,
      sym_long_identifier,
    STATE(5181), 1,
      sym__type,
    ACTIONS(4521), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4009), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5109), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [81438] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5860), 1,
      sym_identifier,
    ACTIONS(5862), 1,
      anon_sym_LPAREN,
    ACTIONS(5864), 1,
      anon_sym__,
    ACTIONS(5866), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(5868), 1,
      anon_sym_POUND,
    STATE(4517), 1,
      sym__static_type_identifier,
    STATE(4522), 1,
      sym__type,
    STATE(4843), 1,
      sym_type_argument,
    STATE(4907), 1,
      sym_long_identifier,
    ACTIONS(5870), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4010), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4909), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [81510] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5860), 1,
      sym_identifier,
    ACTIONS(5862), 1,
      anon_sym_LPAREN,
    ACTIONS(5864), 1,
      anon_sym__,
    ACTIONS(5866), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(5868), 1,
      anon_sym_POUND,
    STATE(4517), 1,
      sym__static_type_identifier,
    STATE(4749), 1,
      sym__type,
    STATE(4843), 1,
      sym_type_argument,
    STATE(4907), 1,
      sym_long_identifier,
    ACTIONS(5870), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4011), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4909), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [81582] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5134), 1,
      sym_identifier,
    ACTIONS(6271), 1,
      anon_sym_LPAREN,
    ACTIONS(6273), 1,
      anon_sym__,
    ACTIONS(6275), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6277), 1,
      anon_sym_POUND,
    STATE(2967), 1,
      sym__static_type_identifier,
    STATE(2997), 1,
      sym__type,
    STATE(3189), 1,
      sym_type_argument,
    STATE(3206), 1,
      sym_long_identifier,
    ACTIONS(6279), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4012), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(3207), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [81654] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5134), 1,
      sym_identifier,
    ACTIONS(6271), 1,
      anon_sym_LPAREN,
    ACTIONS(6273), 1,
      anon_sym__,
    ACTIONS(6275), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6277), 1,
      anon_sym_POUND,
    STATE(2967), 1,
      sym__static_type_identifier,
    STATE(2998), 1,
      sym__type,
    STATE(3189), 1,
      sym_type_argument,
    STATE(3206), 1,
      sym_long_identifier,
    ACTIONS(6279), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4013), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(3207), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [81726] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4511), 1,
      anon_sym_LPAREN,
    ACTIONS(4513), 1,
      anon_sym__,
    ACTIONS(4515), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4519), 1,
      anon_sym_POUND,
    ACTIONS(5768), 1,
      sym_identifier,
    STATE(4686), 1,
      sym__static_type_identifier,
    STATE(4913), 1,
      sym_type_argument,
    STATE(5121), 1,
      sym_long_identifier,
    STATE(5381), 1,
      sym__type,
    ACTIONS(4521), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4014), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5109), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [81798] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4511), 1,
      anon_sym_LPAREN,
    ACTIONS(4513), 1,
      anon_sym__,
    ACTIONS(4515), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4519), 1,
      anon_sym_POUND,
    ACTIONS(5768), 1,
      sym_identifier,
    STATE(4686), 1,
      sym__static_type_identifier,
    STATE(4913), 1,
      sym_type_argument,
    STATE(5121), 1,
      sym_long_identifier,
    STATE(5297), 1,
      sym__type,
    ACTIONS(4521), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4015), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5109), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [81870] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5134), 1,
      sym_identifier,
    ACTIONS(6271), 1,
      anon_sym_LPAREN,
    ACTIONS(6273), 1,
      anon_sym__,
    ACTIONS(6275), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6277), 1,
      anon_sym_POUND,
    STATE(2967), 1,
      sym__static_type_identifier,
    STATE(3011), 1,
      sym__type,
    STATE(3189), 1,
      sym_type_argument,
    STATE(3206), 1,
      sym_long_identifier,
    ACTIONS(6279), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4016), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(3207), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [81942] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5134), 1,
      sym_identifier,
    ACTIONS(6271), 1,
      anon_sym_LPAREN,
    ACTIONS(6273), 1,
      anon_sym__,
    ACTIONS(6275), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6277), 1,
      anon_sym_POUND,
    STATE(2960), 1,
      sym__type,
    STATE(2967), 1,
      sym__static_type_identifier,
    STATE(3189), 1,
      sym_type_argument,
    STATE(3206), 1,
      sym_long_identifier,
    ACTIONS(6279), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4017), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(3207), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [82014] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6001), 1,
      sym_identifier,
    ACTIONS(6003), 1,
      anon_sym_LPAREN,
    ACTIONS(6005), 1,
      anon_sym__,
    ACTIONS(6007), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6009), 1,
      anon_sym_POUND,
    STATE(4315), 1,
      sym__static_type_identifier,
    STATE(4332), 1,
      sym__type,
    STATE(4575), 1,
      sym_type_argument,
    STATE(4602), 1,
      sym_long_identifier,
    ACTIONS(6011), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4018), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4598), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [82086] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4968), 1,
      sym_identifier,
    ACTIONS(6173), 1,
      anon_sym_LPAREN,
    ACTIONS(6175), 1,
      anon_sym__,
    ACTIONS(6177), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6179), 1,
      anon_sym_POUND,
    STATE(2883), 1,
      sym__static_type_identifier,
    STATE(2893), 1,
      sym__type,
    STATE(2947), 1,
      sym_type_argument,
    STATE(3066), 1,
      sym_long_identifier,
    ACTIONS(6181), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4019), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(3030), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [82158] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4511), 1,
      anon_sym_LPAREN,
    ACTIONS(4513), 1,
      anon_sym__,
    ACTIONS(4515), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4519), 1,
      anon_sym_POUND,
    ACTIONS(5768), 1,
      sym_identifier,
    STATE(4686), 1,
      sym__static_type_identifier,
    STATE(4913), 1,
      sym_type_argument,
    STATE(5110), 1,
      sym__type,
    STATE(5121), 1,
      sym_long_identifier,
    ACTIONS(4521), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4020), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5109), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [82230] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3173), 1,
      sym_identifier,
    ACTIONS(6225), 1,
      anon_sym_LPAREN,
    ACTIONS(6227), 1,
      anon_sym__,
    ACTIONS(6229), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6231), 1,
      anon_sym_POUND,
    STATE(981), 1,
      sym__type,
    STATE(1112), 1,
      sym__static_type_identifier,
    STATE(1270), 1,
      sym_long_identifier,
    STATE(1271), 1,
      sym_type_argument,
    ACTIONS(6233), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4021), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(1189), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [82302] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5455), 1,
      anon_sym_LPAREN,
    ACTIONS(5457), 1,
      anon_sym__,
    ACTIONS(5461), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(5463), 1,
      anon_sym_POUND,
    ACTIONS(5967), 1,
      sym_identifier,
    STATE(4182), 1,
      sym__static_type_identifier,
    STATE(4196), 1,
      sym__type,
    STATE(4223), 1,
      sym_type_argument,
    STATE(4259), 1,
      sym_long_identifier,
    ACTIONS(5465), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4022), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4263), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [82374] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5124), 1,
      sym_identifier,
    ACTIONS(6281), 1,
      anon_sym_LPAREN,
    ACTIONS(6283), 1,
      anon_sym__,
    ACTIONS(6285), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6287), 1,
      anon_sym_POUND,
    STATE(2951), 1,
      sym__static_type_identifier,
    STATE(3021), 1,
      sym__type,
    STATE(3109), 1,
      sym_type_argument,
    STATE(3216), 1,
      sym_long_identifier,
    ACTIONS(6289), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4023), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(3215), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [82446] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4511), 1,
      anon_sym_LPAREN,
    ACTIONS(4513), 1,
      anon_sym__,
    ACTIONS(4515), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4519), 1,
      anon_sym_POUND,
    ACTIONS(5768), 1,
      sym_identifier,
    STATE(4686), 1,
      sym__static_type_identifier,
    STATE(4913), 1,
      sym_type_argument,
    STATE(5121), 1,
      sym_long_identifier,
    STATE(5210), 1,
      sym__type,
    ACTIONS(4521), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4024), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5109), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [82518] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5134), 1,
      sym_identifier,
    ACTIONS(6271), 1,
      anon_sym_LPAREN,
    ACTIONS(6273), 1,
      anon_sym__,
    ACTIONS(6275), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6277), 1,
      anon_sym_POUND,
    STATE(2967), 1,
      sym__static_type_identifier,
    STATE(2992), 1,
      sym__type,
    STATE(3189), 1,
      sym_type_argument,
    STATE(3206), 1,
      sym_long_identifier,
    ACTIONS(6279), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4025), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(3207), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [82590] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4511), 1,
      anon_sym_LPAREN,
    ACTIONS(4513), 1,
      anon_sym__,
    ACTIONS(4515), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4519), 1,
      anon_sym_POUND,
    ACTIONS(5768), 1,
      sym_identifier,
    STATE(4686), 1,
      sym__static_type_identifier,
    STATE(4913), 1,
      sym_type_argument,
    STATE(5121), 1,
      sym_long_identifier,
    STATE(5406), 1,
      sym__type,
    ACTIONS(4521), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4026), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5109), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [82662] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4504), 1,
      sym_identifier,
    ACTIONS(5347), 1,
      anon_sym_LPAREN,
    ACTIONS(5349), 1,
      anon_sym__,
    ACTIONS(5351), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(5353), 1,
      anon_sym_POUND,
    STATE(2708), 1,
      sym__static_type_identifier,
    STATE(2711), 1,
      sym__type,
    STATE(2770), 1,
      sym_type_argument,
    STATE(2788), 1,
      sym_long_identifier,
    ACTIONS(5355), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4027), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(2778), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [82734] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5955), 1,
      sym_identifier,
    ACTIONS(5957), 1,
      anon_sym_LPAREN,
    ACTIONS(5959), 1,
      anon_sym__,
    ACTIONS(5961), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(5963), 1,
      anon_sym_POUND,
    STATE(4258), 1,
      sym__static_type_identifier,
    STATE(4297), 1,
      sym__type,
    STATE(4447), 1,
      sym_type_argument,
    STATE(4501), 1,
      sym_long_identifier,
    ACTIONS(5965), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4028), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4503), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [82806] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4511), 1,
      anon_sym_LPAREN,
    ACTIONS(4513), 1,
      anon_sym__,
    ACTIONS(4515), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4519), 1,
      anon_sym_POUND,
    ACTIONS(5768), 1,
      sym_identifier,
    STATE(4686), 1,
      sym__static_type_identifier,
    STATE(4913), 1,
      sym_type_argument,
    STATE(5121), 1,
      sym_long_identifier,
    STATE(5299), 1,
      sym__type,
    ACTIONS(4521), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4029), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5109), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [82878] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5848), 1,
      sym_identifier,
    ACTIONS(5850), 1,
      anon_sym_LPAREN,
    ACTIONS(5852), 1,
      anon_sym__,
    ACTIONS(5854), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(5856), 1,
      anon_sym_POUND,
    STATE(5003), 1,
      sym__static_type_identifier,
    STATE(5037), 1,
      sym__type,
    STATE(5466), 1,
      sym_type_argument,
    STATE(5569), 1,
      sym_long_identifier,
    ACTIONS(5858), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4030), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5520), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [82950] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5955), 1,
      sym_identifier,
    ACTIONS(5957), 1,
      anon_sym_LPAREN,
    ACTIONS(5959), 1,
      anon_sym__,
    ACTIONS(5961), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(5963), 1,
      anon_sym_POUND,
    STATE(4258), 1,
      sym__static_type_identifier,
    STATE(4260), 1,
      sym__type,
    STATE(4447), 1,
      sym_type_argument,
    STATE(4501), 1,
      sym_long_identifier,
    ACTIONS(5965), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4031), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4503), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [83022] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5134), 1,
      sym_identifier,
    ACTIONS(6271), 1,
      anon_sym_LPAREN,
    ACTIONS(6273), 1,
      anon_sym__,
    ACTIONS(6275), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6277), 1,
      anon_sym_POUND,
    STATE(2967), 1,
      sym__static_type_identifier,
    STATE(2986), 1,
      sym__type,
    STATE(3189), 1,
      sym_type_argument,
    STATE(3206), 1,
      sym_long_identifier,
    ACTIONS(6279), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4032), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(3207), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [83094] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4511), 1,
      anon_sym_LPAREN,
    ACTIONS(4513), 1,
      anon_sym__,
    ACTIONS(4515), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4519), 1,
      anon_sym_POUND,
    ACTIONS(5768), 1,
      sym_identifier,
    STATE(4686), 1,
      sym__static_type_identifier,
    STATE(4913), 1,
      sym_type_argument,
    STATE(5121), 1,
      sym_long_identifier,
    STATE(5327), 1,
      sym__type,
    ACTIONS(4521), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4033), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5109), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [83166] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3214), 1,
      sym_identifier,
    ACTIONS(6047), 1,
      anon_sym_LPAREN,
    ACTIONS(6049), 1,
      anon_sym__,
    ACTIONS(6051), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6053), 1,
      anon_sym_POUND,
    STATE(1005), 1,
      sym__type,
    STATE(1242), 1,
      sym__static_type_identifier,
    STATE(1316), 1,
      sym_long_identifier,
    STATE(1317), 1,
      sym_type_argument,
    ACTIONS(6055), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4034), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(1325), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [83238] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    STATE(4035), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2723), 11,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      anon_sym_f,
      aux_sym_decimal_token1,
      sym_identifier,
    ACTIONS(2725), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [83292] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3151), 1,
      sym_identifier,
    ACTIONS(6235), 1,
      anon_sym_LPAREN,
    ACTIONS(6237), 1,
      anon_sym__,
    ACTIONS(6239), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6241), 1,
      anon_sym_POUND,
    STATE(962), 1,
      sym__type,
    STATE(1006), 1,
      sym__static_type_identifier,
    STATE(1168), 1,
      sym_type_argument,
    STATE(1169), 1,
      sym_long_identifier,
    ACTIONS(6243), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4036), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(1145), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [83364] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5019), 1,
      sym_identifier,
    ACTIONS(6163), 1,
      anon_sym_LPAREN,
    ACTIONS(6165), 1,
      anon_sym__,
    ACTIONS(6167), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6169), 1,
      anon_sym_POUND,
    STATE(2898), 1,
      sym__type,
    STATE(2932), 1,
      sym__static_type_identifier,
    STATE(3041), 1,
      sym_type_argument,
    STATE(3196), 1,
      sym_long_identifier,
    ACTIONS(6171), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4037), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(3110), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [83436] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5019), 1,
      sym_identifier,
    ACTIONS(6163), 1,
      anon_sym_LPAREN,
    ACTIONS(6165), 1,
      anon_sym__,
    ACTIONS(6167), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6169), 1,
      anon_sym_POUND,
    STATE(2928), 1,
      sym__type,
    STATE(2932), 1,
      sym__static_type_identifier,
    STATE(3041), 1,
      sym_type_argument,
    STATE(3196), 1,
      sym_long_identifier,
    ACTIONS(6171), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4038), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(3110), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [83508] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5019), 1,
      sym_identifier,
    ACTIONS(6163), 1,
      anon_sym_LPAREN,
    ACTIONS(6165), 1,
      anon_sym__,
    ACTIONS(6167), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6169), 1,
      anon_sym_POUND,
    STATE(2926), 1,
      sym__type,
    STATE(2932), 1,
      sym__static_type_identifier,
    STATE(3041), 1,
      sym_type_argument,
    STATE(3196), 1,
      sym_long_identifier,
    ACTIONS(6171), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4039), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(3110), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [83580] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5124), 1,
      sym_identifier,
    ACTIONS(6281), 1,
      anon_sym_LPAREN,
    ACTIONS(6283), 1,
      anon_sym__,
    ACTIONS(6285), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6287), 1,
      anon_sym_POUND,
    STATE(2951), 1,
      sym__static_type_identifier,
    STATE(3017), 1,
      sym__type,
    STATE(3109), 1,
      sym_type_argument,
    STATE(3216), 1,
      sym_long_identifier,
    ACTIONS(6289), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4040), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(3215), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [83652] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5836), 1,
      sym_identifier,
    ACTIONS(5838), 1,
      anon_sym_LPAREN,
    ACTIONS(5840), 1,
      anon_sym__,
    ACTIONS(5842), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(5844), 1,
      anon_sym_POUND,
    STATE(4202), 1,
      sym__static_type_identifier,
    STATE(4206), 1,
      sym__type,
    STATE(4346), 1,
      sym_type_argument,
    STATE(4406), 1,
      sym_long_identifier,
    ACTIONS(5846), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4041), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4404), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [83724] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6151), 1,
      sym_identifier,
    ACTIONS(6153), 1,
      anon_sym_LPAREN,
    ACTIONS(6155), 1,
      anon_sym__,
    ACTIONS(6157), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6159), 1,
      anon_sym_POUND,
    STATE(4242), 1,
      sym__type,
    STATE(4269), 1,
      sym__static_type_identifier,
    STATE(4460), 1,
      sym_type_argument,
    STATE(4481), 1,
      sym_long_identifier,
    ACTIONS(6161), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4042), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4485), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [83796] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3214), 1,
      sym_identifier,
    ACTIONS(6047), 1,
      anon_sym_LPAREN,
    ACTIONS(6049), 1,
      anon_sym__,
    ACTIONS(6051), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6053), 1,
      anon_sym_POUND,
    STATE(1009), 1,
      sym__type,
    STATE(1242), 1,
      sym__static_type_identifier,
    STATE(1316), 1,
      sym_long_identifier,
    STATE(1317), 1,
      sym_type_argument,
    ACTIONS(6055), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4043), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(1325), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [83868] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4511), 1,
      anon_sym_LPAREN,
    ACTIONS(4513), 1,
      anon_sym__,
    ACTIONS(4515), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4519), 1,
      anon_sym_POUND,
    ACTIONS(5768), 1,
      sym_identifier,
    STATE(4686), 1,
      sym__static_type_identifier,
    STATE(4913), 1,
      sym_type_argument,
    STATE(5121), 1,
      sym_long_identifier,
    STATE(5367), 1,
      sym__type,
    ACTIONS(4521), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4044), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5109), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [83940] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4045), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6291), 10,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(6293), 12,
      anon_sym_LBRACK_LT,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [83994] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4511), 1,
      anon_sym_LPAREN,
    ACTIONS(4513), 1,
      anon_sym__,
    ACTIONS(4515), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4519), 1,
      anon_sym_POUND,
    ACTIONS(5768), 1,
      sym_identifier,
    STATE(4686), 1,
      sym__static_type_identifier,
    STATE(4913), 1,
      sym_type_argument,
    STATE(5121), 1,
      sym_long_identifier,
    STATE(5264), 1,
      sym__type,
    ACTIONS(4521), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4046), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5109), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [84066] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4511), 1,
      anon_sym_LPAREN,
    ACTIONS(4513), 1,
      anon_sym__,
    ACTIONS(4515), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4519), 1,
      anon_sym_POUND,
    ACTIONS(5768), 1,
      sym_identifier,
    STATE(4686), 1,
      sym__static_type_identifier,
    STATE(4913), 1,
      sym_type_argument,
    STATE(5121), 1,
      sym_long_identifier,
    STATE(5265), 1,
      sym__type,
    ACTIONS(4521), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4047), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5109), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [84138] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2226), 1,
      sym_identifier,
    ACTIONS(6141), 1,
      anon_sym_LPAREN,
    ACTIONS(6143), 1,
      anon_sym__,
    ACTIONS(6145), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6147), 1,
      anon_sym_POUND,
    STATE(766), 1,
      sym__type,
    STATE(772), 1,
      sym__static_type_identifier,
    STATE(802), 1,
      sym_long_identifier,
    STATE(804), 1,
      sym_type_argument,
    ACTIONS(6149), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4048), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(807), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [84210] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4511), 1,
      anon_sym_LPAREN,
    ACTIONS(4513), 1,
      anon_sym__,
    ACTIONS(4515), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4519), 1,
      anon_sym_POUND,
    ACTIONS(5768), 1,
      sym_identifier,
    STATE(4686), 1,
      sym__static_type_identifier,
    STATE(4913), 1,
      sym_type_argument,
    STATE(5121), 1,
      sym_long_identifier,
    STATE(5365), 1,
      sym__type,
    ACTIONS(4521), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4049), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5109), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [84282] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6151), 1,
      sym_identifier,
    ACTIONS(6153), 1,
      anon_sym_LPAREN,
    ACTIONS(6155), 1,
      anon_sym__,
    ACTIONS(6157), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6159), 1,
      anon_sym_POUND,
    STATE(4239), 1,
      sym__type,
    STATE(4269), 1,
      sym__static_type_identifier,
    STATE(4460), 1,
      sym_type_argument,
    STATE(4481), 1,
      sym_long_identifier,
    ACTIONS(6161), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4050), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4485), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [84354] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6259), 1,
      sym_identifier,
    ACTIONS(6261), 1,
      anon_sym_LPAREN,
    ACTIONS(6263), 1,
      anon_sym__,
    ACTIONS(6265), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6267), 1,
      anon_sym_POUND,
    STATE(4327), 1,
      sym__type,
    STATE(4358), 1,
      sym__static_type_identifier,
    STATE(4487), 1,
      sym_type_argument,
    STATE(4683), 1,
      sym_long_identifier,
    ACTIONS(6269), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4051), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4684), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [84426] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6083), 1,
      sym_identifier,
    ACTIONS(6085), 1,
      anon_sym_LPAREN,
    ACTIONS(6087), 1,
      anon_sym__,
    ACTIONS(6089), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6091), 1,
      anon_sym_POUND,
    STATE(4219), 1,
      sym__type,
    STATE(4282), 1,
      sym__static_type_identifier,
    STATE(4430), 1,
      sym_type_argument,
    STATE(4530), 1,
      sym_long_identifier,
    ACTIONS(6093), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4052), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4532), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [84498] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6151), 1,
      sym_identifier,
    ACTIONS(6153), 1,
      anon_sym_LPAREN,
    ACTIONS(6155), 1,
      anon_sym__,
    ACTIONS(6157), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6159), 1,
      anon_sym_POUND,
    STATE(4238), 1,
      sym__type,
    STATE(4269), 1,
      sym__static_type_identifier,
    STATE(4460), 1,
      sym_type_argument,
    STATE(4481), 1,
      sym_long_identifier,
    ACTIONS(6161), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4053), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4485), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [84570] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6247), 1,
      sym_identifier,
    ACTIONS(6249), 1,
      anon_sym_LPAREN,
    ACTIONS(6251), 1,
      anon_sym__,
    ACTIONS(6253), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6255), 1,
      anon_sym_POUND,
    STATE(4386), 1,
      sym__type,
    STATE(4389), 1,
      sym__static_type_identifier,
    STATE(4596), 1,
      sym_type_argument,
    STATE(4738), 1,
      sym_long_identifier,
    ACTIONS(6257), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4054), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4722), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [84642] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5124), 1,
      sym_identifier,
    ACTIONS(6281), 1,
      anon_sym_LPAREN,
    ACTIONS(6283), 1,
      anon_sym__,
    ACTIONS(6285), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6287), 1,
      anon_sym_POUND,
    STATE(2951), 1,
      sym__static_type_identifier,
    STATE(3014), 1,
      sym__type,
    STATE(3109), 1,
      sym_type_argument,
    STATE(3216), 1,
      sym_long_identifier,
    ACTIONS(6289), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4055), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(3215), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [84714] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    STATE(4056), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2812), 11,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      anon_sym_f,
      aux_sym_decimal_token1,
      sym_identifier,
    ACTIONS(2814), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [84768] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3204), 1,
      sym_identifier,
    ACTIONS(6295), 1,
      anon_sym_LPAREN,
    ACTIONS(6297), 1,
      anon_sym__,
    ACTIONS(6299), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6301), 1,
      anon_sym_POUND,
    STATE(1015), 1,
      sym__type,
    STATE(1205), 1,
      sym__static_type_identifier,
    STATE(1365), 1,
      sym_type_argument,
    STATE(1377), 1,
      sym_long_identifier,
    ACTIONS(6303), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4057), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(1341), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [84840] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6151), 1,
      sym_identifier,
    ACTIONS(6153), 1,
      anon_sym_LPAREN,
    ACTIONS(6155), 1,
      anon_sym__,
    ACTIONS(6157), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6159), 1,
      anon_sym_POUND,
    STATE(4266), 1,
      sym__type,
    STATE(4269), 1,
      sym__static_type_identifier,
    STATE(4460), 1,
      sym_type_argument,
    STATE(4481), 1,
      sym_long_identifier,
    ACTIONS(6161), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4058), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4485), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [84912] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5070), 1,
      sym_identifier,
    ACTIONS(6013), 1,
      anon_sym_LPAREN,
    ACTIONS(6015), 1,
      anon_sym__,
    ACTIONS(6017), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6019), 1,
      anon_sym_POUND,
    STATE(2911), 1,
      sym__static_type_identifier,
    STATE(2995), 1,
      sym__type,
    STATE(3056), 1,
      sym_type_argument,
    STATE(3193), 1,
      sym_long_identifier,
    ACTIONS(6021), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4059), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(3195), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [84984] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4511), 1,
      anon_sym_LPAREN,
    ACTIONS(4513), 1,
      anon_sym__,
    ACTIONS(4515), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4519), 1,
      anon_sym_POUND,
    ACTIONS(5768), 1,
      sym_identifier,
    STATE(4686), 1,
      sym__static_type_identifier,
    STATE(4913), 1,
      sym_type_argument,
    STATE(5121), 1,
      sym_long_identifier,
    STATE(5417), 1,
      sym__type,
    ACTIONS(4521), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4060), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5109), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [85056] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5848), 1,
      sym_identifier,
    ACTIONS(5850), 1,
      anon_sym_LPAREN,
    ACTIONS(5852), 1,
      anon_sym__,
    ACTIONS(5854), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(5856), 1,
      anon_sym_POUND,
    STATE(5003), 1,
      sym__static_type_identifier,
    STATE(5016), 1,
      sym__type,
    STATE(5466), 1,
      sym_type_argument,
    STATE(5569), 1,
      sym_long_identifier,
    ACTIONS(5858), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4061), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5520), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [85128] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6109), 1,
      sym_identifier,
    ACTIONS(6111), 1,
      anon_sym_LPAREN,
    ACTIONS(6113), 1,
      anon_sym__,
    ACTIONS(6115), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6117), 1,
      anon_sym_POUND,
    STATE(4779), 1,
      sym__static_type_identifier,
    STATE(4799), 1,
      sym__type,
    STATE(5045), 1,
      sym_type_argument,
    STATE(5231), 1,
      sym_long_identifier,
    ACTIONS(6119), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4062), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5238), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [85200] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4978), 1,
      sym_identifier,
    ACTIONS(5969), 1,
      anon_sym_LPAREN,
    ACTIONS(5971), 1,
      anon_sym__,
    ACTIONS(5973), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(5975), 1,
      anon_sym_POUND,
    STATE(2906), 1,
      sym__type,
    STATE(2931), 1,
      sym__static_type_identifier,
    STATE(3036), 1,
      sym_type_argument,
    STATE(3113), 1,
      sym_long_identifier,
    ACTIONS(5977), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4063), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(3112), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [85272] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4978), 1,
      sym_identifier,
    ACTIONS(5969), 1,
      anon_sym_LPAREN,
    ACTIONS(5971), 1,
      anon_sym__,
    ACTIONS(5973), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(5975), 1,
      anon_sym_POUND,
    STATE(2931), 1,
      sym__static_type_identifier,
    STATE(2943), 1,
      sym__type,
    STATE(3036), 1,
      sym_type_argument,
    STATE(3113), 1,
      sym_long_identifier,
    ACTIONS(5977), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4064), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(3112), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [85344] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4978), 1,
      sym_identifier,
    ACTIONS(5969), 1,
      anon_sym_LPAREN,
    ACTIONS(5971), 1,
      anon_sym__,
    ACTIONS(5973), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(5975), 1,
      anon_sym_POUND,
    STATE(2931), 1,
      sym__static_type_identifier,
    STATE(2942), 1,
      sym__type,
    STATE(3036), 1,
      sym_type_argument,
    STATE(3113), 1,
      sym_long_identifier,
    ACTIONS(5977), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4065), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(3112), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [85416] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4511), 1,
      anon_sym_LPAREN,
    ACTIONS(4513), 1,
      anon_sym__,
    ACTIONS(4515), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4519), 1,
      anon_sym_POUND,
    ACTIONS(5768), 1,
      sym_identifier,
    STATE(4686), 1,
      sym__static_type_identifier,
    STATE(4913), 1,
      sym_type_argument,
    STATE(5121), 1,
      sym_long_identifier,
    STATE(5218), 1,
      sym__type,
    ACTIONS(4521), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4066), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5109), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [85488] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4511), 1,
      anon_sym_LPAREN,
    ACTIONS(4513), 1,
      anon_sym__,
    ACTIONS(4515), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4519), 1,
      anon_sym_POUND,
    ACTIONS(5768), 1,
      sym_identifier,
    STATE(4686), 1,
      sym__static_type_identifier,
    STATE(4913), 1,
      sym_type_argument,
    STATE(5121), 1,
      sym_long_identifier,
    STATE(5361), 1,
      sym__type,
    ACTIONS(4521), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4067), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5109), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [85560] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6305), 1,
      sym_identifier,
    ACTIONS(6307), 1,
      anon_sym_LPAREN,
    ACTIONS(6309), 1,
      anon_sym__,
    ACTIONS(6311), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6313), 1,
      anon_sym_POUND,
    STATE(4298), 1,
      sym__static_type_identifier,
    STATE(4348), 1,
      sym__type,
    STATE(4521), 1,
      sym_type_argument,
    STATE(4642), 1,
      sym_long_identifier,
    ACTIONS(6315), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4068), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4675), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [85632] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4511), 1,
      anon_sym_LPAREN,
    ACTIONS(4513), 1,
      anon_sym__,
    ACTIONS(4515), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4519), 1,
      anon_sym_POUND,
    ACTIONS(5768), 1,
      sym_identifier,
    STATE(4686), 1,
      sym__static_type_identifier,
    STATE(4913), 1,
      sym_type_argument,
    STATE(5121), 1,
      sym_long_identifier,
    STATE(5338), 1,
      sym__type,
    ACTIONS(4521), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4069), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5109), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [85704] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6057), 1,
      sym_identifier,
    ACTIONS(6059), 1,
      anon_sym_LPAREN,
    ACTIONS(6061), 1,
      anon_sym__,
    ACTIONS(6063), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6065), 1,
      anon_sym_POUND,
    STATE(4364), 1,
      sym__type,
    STATE(4379), 1,
      sym__static_type_identifier,
    STATE(4482), 1,
      sym_type_argument,
    STATE(4685), 1,
      sym_long_identifier,
    ACTIONS(6067), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4070), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4690), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [85776] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4511), 1,
      anon_sym_LPAREN,
    ACTIONS(4513), 1,
      anon_sym__,
    ACTIONS(4515), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4519), 1,
      anon_sym_POUND,
    ACTIONS(5768), 1,
      sym_identifier,
    STATE(4686), 1,
      sym__static_type_identifier,
    STATE(4913), 1,
      sym_type_argument,
    STATE(5121), 1,
      sym_long_identifier,
    STATE(5379), 1,
      sym__type,
    ACTIONS(4521), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4071), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5109), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [85848] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4978), 1,
      sym_identifier,
    ACTIONS(5969), 1,
      anon_sym_LPAREN,
    ACTIONS(5971), 1,
      anon_sym__,
    ACTIONS(5973), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(5975), 1,
      anon_sym_POUND,
    STATE(2931), 1,
      sym__static_type_identifier,
    STATE(2938), 1,
      sym__type,
    STATE(3036), 1,
      sym_type_argument,
    STATE(3113), 1,
      sym_long_identifier,
    ACTIONS(5977), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4072), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(3112), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [85920] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4511), 1,
      anon_sym_LPAREN,
    ACTIONS(4513), 1,
      anon_sym__,
    ACTIONS(4515), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4519), 1,
      anon_sym_POUND,
    ACTIONS(5768), 1,
      sym_identifier,
    STATE(4686), 1,
      sym__static_type_identifier,
    STATE(4913), 1,
      sym_type_argument,
    STATE(5121), 1,
      sym_long_identifier,
    STATE(5333), 1,
      sym__type,
    ACTIONS(4521), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4073), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5109), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [85992] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4968), 1,
      sym_identifier,
    ACTIONS(6173), 1,
      anon_sym_LPAREN,
    ACTIONS(6175), 1,
      anon_sym__,
    ACTIONS(6177), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6179), 1,
      anon_sym_POUND,
    STATE(2878), 1,
      sym__type,
    STATE(2883), 1,
      sym__static_type_identifier,
    STATE(2947), 1,
      sym_type_argument,
    STATE(3066), 1,
      sym_long_identifier,
    ACTIONS(6181), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4074), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(3030), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [86064] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4511), 1,
      anon_sym_LPAREN,
    ACTIONS(4513), 1,
      anon_sym__,
    ACTIONS(4515), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4519), 1,
      anon_sym_POUND,
    ACTIONS(5768), 1,
      sym_identifier,
    STATE(4686), 1,
      sym__static_type_identifier,
    STATE(4913), 1,
      sym_type_argument,
    STATE(5121), 1,
      sym_long_identifier,
    STATE(5314), 1,
      sym__type,
    ACTIONS(4521), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4075), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5109), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [86136] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5872), 1,
      sym_identifier,
    ACTIONS(5874), 1,
      anon_sym_LPAREN,
    ACTIONS(5876), 1,
      anon_sym__,
    ACTIONS(5878), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(5880), 1,
      anon_sym_POUND,
    STATE(4201), 1,
      sym__type,
    STATE(4217), 1,
      sym__static_type_identifier,
    STATE(4313), 1,
      sym_type_argument,
    STATE(4470), 1,
      sym_long_identifier,
    ACTIONS(5882), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4076), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4465), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [86208] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5860), 1,
      sym_identifier,
    ACTIONS(5862), 1,
      anon_sym_LPAREN,
    ACTIONS(5864), 1,
      anon_sym__,
    ACTIONS(5866), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(5868), 1,
      anon_sym_POUND,
    STATE(4517), 1,
      sym__static_type_identifier,
    STATE(4773), 1,
      sym__type,
    STATE(4843), 1,
      sym_type_argument,
    STATE(4907), 1,
      sym_long_identifier,
    ACTIONS(5870), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4077), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4909), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [86280] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4968), 1,
      sym_identifier,
    ACTIONS(6173), 1,
      anon_sym_LPAREN,
    ACTIONS(6175), 1,
      anon_sym__,
    ACTIONS(6177), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6179), 1,
      anon_sym_POUND,
    STATE(2877), 1,
      sym__type,
    STATE(2883), 1,
      sym__static_type_identifier,
    STATE(2947), 1,
      sym_type_argument,
    STATE(3066), 1,
      sym_long_identifier,
    ACTIONS(6181), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4078), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(3030), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [86352] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4511), 1,
      anon_sym_LPAREN,
    ACTIONS(4513), 1,
      anon_sym__,
    ACTIONS(4515), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4519), 1,
      anon_sym_POUND,
    ACTIONS(5768), 1,
      sym_identifier,
    STATE(4686), 1,
      sym__static_type_identifier,
    STATE(4913), 1,
      sym_type_argument,
    STATE(5121), 1,
      sym_long_identifier,
    STATE(5321), 1,
      sym__type,
    ACTIONS(4521), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4079), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5109), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [86424] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4511), 1,
      anon_sym_LPAREN,
    ACTIONS(4513), 1,
      anon_sym__,
    ACTIONS(4515), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4519), 1,
      anon_sym_POUND,
    ACTIONS(5768), 1,
      sym_identifier,
    STATE(4686), 1,
      sym__static_type_identifier,
    STATE(4913), 1,
      sym_type_argument,
    STATE(5121), 1,
      sym_long_identifier,
    STATE(5378), 1,
      sym__type,
    ACTIONS(4521), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4080), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5109), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [86496] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4968), 1,
      sym_identifier,
    ACTIONS(6173), 1,
      anon_sym_LPAREN,
    ACTIONS(6175), 1,
      anon_sym__,
    ACTIONS(6177), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6179), 1,
      anon_sym_POUND,
    STATE(2881), 1,
      sym__type,
    STATE(2883), 1,
      sym__static_type_identifier,
    STATE(2947), 1,
      sym_type_argument,
    STATE(3066), 1,
      sym_long_identifier,
    ACTIONS(6181), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4081), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(3030), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [86568] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4511), 1,
      anon_sym_LPAREN,
    ACTIONS(4513), 1,
      anon_sym__,
    ACTIONS(4515), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4519), 1,
      anon_sym_POUND,
    ACTIONS(5768), 1,
      sym_identifier,
    STATE(4686), 1,
      sym__static_type_identifier,
    STATE(4913), 1,
      sym_type_argument,
    STATE(5121), 1,
      sym_long_identifier,
    STATE(5280), 1,
      sym__type,
    ACTIONS(4521), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4082), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5109), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [86640] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4511), 1,
      anon_sym_LPAREN,
    ACTIONS(4513), 1,
      anon_sym__,
    ACTIONS(4515), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4519), 1,
      anon_sym_POUND,
    ACTIONS(5768), 1,
      sym_identifier,
    STATE(4686), 1,
      sym__static_type_identifier,
    STATE(4913), 1,
      sym_type_argument,
    STATE(5121), 1,
      sym_long_identifier,
    STATE(5313), 1,
      sym__type,
    ACTIONS(4521), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4083), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5109), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [86712] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5070), 1,
      sym_identifier,
    ACTIONS(6013), 1,
      anon_sym_LPAREN,
    ACTIONS(6015), 1,
      anon_sym__,
    ACTIONS(6017), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6019), 1,
      anon_sym_POUND,
    STATE(2911), 1,
      sym__static_type_identifier,
    STATE(3008), 1,
      sym__type,
    STATE(3056), 1,
      sym_type_argument,
    STATE(3193), 1,
      sym_long_identifier,
    ACTIONS(6021), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4084), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(3195), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [86784] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4968), 1,
      sym_identifier,
    ACTIONS(6173), 1,
      anon_sym_LPAREN,
    ACTIONS(6175), 1,
      anon_sym__,
    ACTIONS(6177), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6179), 1,
      anon_sym_POUND,
    STATE(2883), 1,
      sym__static_type_identifier,
    STATE(2891), 1,
      sym__type,
    STATE(2947), 1,
      sym_type_argument,
    STATE(3066), 1,
      sym_long_identifier,
    ACTIONS(6181), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4085), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(3030), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [86856] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5124), 1,
      sym_identifier,
    ACTIONS(6281), 1,
      anon_sym_LPAREN,
    ACTIONS(6283), 1,
      anon_sym__,
    ACTIONS(6285), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6287), 1,
      anon_sym_POUND,
    STATE(2951), 1,
      sym__static_type_identifier,
    STATE(2977), 1,
      sym__type,
    STATE(3109), 1,
      sym_type_argument,
    STATE(3216), 1,
      sym_long_identifier,
    ACTIONS(6289), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4086), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(3215), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [86928] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4511), 1,
      anon_sym_LPAREN,
    ACTIONS(4513), 1,
      anon_sym__,
    ACTIONS(4515), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4519), 1,
      anon_sym_POUND,
    ACTIONS(5768), 1,
      sym_identifier,
    STATE(4686), 1,
      sym__static_type_identifier,
    STATE(4913), 1,
      sym_type_argument,
    STATE(5121), 1,
      sym_long_identifier,
    STATE(5227), 1,
      sym__type,
    ACTIONS(4521), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4087), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5109), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [87000] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4511), 1,
      anon_sym_LPAREN,
    ACTIONS(4513), 1,
      anon_sym__,
    ACTIONS(4515), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4519), 1,
      anon_sym_POUND,
    ACTIONS(5768), 1,
      sym_identifier,
    STATE(4686), 1,
      sym__static_type_identifier,
    STATE(4913), 1,
      sym_type_argument,
    STATE(5121), 1,
      sym_long_identifier,
    STATE(5409), 1,
      sym__type,
    ACTIONS(4521), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4088), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5109), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [87072] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4511), 1,
      anon_sym_LPAREN,
    ACTIONS(4513), 1,
      anon_sym__,
    ACTIONS(4515), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4519), 1,
      anon_sym_POUND,
    ACTIONS(5768), 1,
      sym_identifier,
    STATE(4686), 1,
      sym__static_type_identifier,
    STATE(4913), 1,
      sym_type_argument,
    STATE(5121), 1,
      sym_long_identifier,
    STATE(5277), 1,
      sym__type,
    ACTIONS(4521), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4089), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5109), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [87144] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6305), 1,
      sym_identifier,
    ACTIONS(6307), 1,
      anon_sym_LPAREN,
    ACTIONS(6309), 1,
      anon_sym__,
    ACTIONS(6311), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6313), 1,
      anon_sym_POUND,
    STATE(4298), 1,
      sym__static_type_identifier,
    STATE(4329), 1,
      sym__type,
    STATE(4521), 1,
      sym_type_argument,
    STATE(4642), 1,
      sym_long_identifier,
    ACTIONS(6315), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4090), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4675), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [87216] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6305), 1,
      sym_identifier,
    ACTIONS(6307), 1,
      anon_sym_LPAREN,
    ACTIONS(6309), 1,
      anon_sym__,
    ACTIONS(6311), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6313), 1,
      anon_sym_POUND,
    STATE(4298), 1,
      sym__static_type_identifier,
    STATE(4347), 1,
      sym__type,
    STATE(4521), 1,
      sym_type_argument,
    STATE(4642), 1,
      sym_long_identifier,
    ACTIONS(6315), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4091), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4675), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [87288] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5955), 1,
      sym_identifier,
    ACTIONS(5957), 1,
      anon_sym_LPAREN,
    ACTIONS(5959), 1,
      anon_sym__,
    ACTIONS(5961), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(5963), 1,
      anon_sym_POUND,
    STATE(4228), 1,
      sym__type,
    STATE(4258), 1,
      sym__static_type_identifier,
    STATE(4447), 1,
      sym_type_argument,
    STATE(4501), 1,
      sym_long_identifier,
    ACTIONS(5965), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4092), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4503), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [87360] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6001), 1,
      sym_identifier,
    ACTIONS(6003), 1,
      anon_sym_LPAREN,
    ACTIONS(6005), 1,
      anon_sym__,
    ACTIONS(6007), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6009), 1,
      anon_sym_POUND,
    STATE(4289), 1,
      sym__type,
    STATE(4315), 1,
      sym__static_type_identifier,
    STATE(4575), 1,
      sym_type_argument,
    STATE(4602), 1,
      sym_long_identifier,
    ACTIONS(6011), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4093), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4598), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [87432] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6247), 1,
      sym_identifier,
    ACTIONS(6249), 1,
      anon_sym_LPAREN,
    ACTIONS(6251), 1,
      anon_sym__,
    ACTIONS(6253), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6255), 1,
      anon_sym_POUND,
    STATE(4388), 1,
      sym__type,
    STATE(4389), 1,
      sym__static_type_identifier,
    STATE(4596), 1,
      sym_type_argument,
    STATE(4738), 1,
      sym_long_identifier,
    ACTIONS(6257), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4094), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4722), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [87504] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6247), 1,
      sym_identifier,
    ACTIONS(6249), 1,
      anon_sym_LPAREN,
    ACTIONS(6251), 1,
      anon_sym__,
    ACTIONS(6253), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6255), 1,
      anon_sym_POUND,
    STATE(4389), 1,
      sym__static_type_identifier,
    STATE(4393), 1,
      sym__type,
    STATE(4596), 1,
      sym_type_argument,
    STATE(4738), 1,
      sym_long_identifier,
    ACTIONS(6257), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4095), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4722), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [87576] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5124), 1,
      sym_identifier,
    ACTIONS(6281), 1,
      anon_sym_LPAREN,
    ACTIONS(6283), 1,
      anon_sym__,
    ACTIONS(6285), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6287), 1,
      anon_sym_POUND,
    STATE(2951), 1,
      sym__static_type_identifier,
    STATE(2959), 1,
      sym__type,
    STATE(3109), 1,
      sym_type_argument,
    STATE(3216), 1,
      sym_long_identifier,
    ACTIONS(6289), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4096), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(3215), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [87648] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    STATE(4097), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6317), 10,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      anon_sym_LPAREN_PIPE,
      sym_int,
      sym_identifier,
    ACTIONS(6319), 12,
      anon_sym_LBRACK_LT,
      anon_sym_QMARK,
      anon_sym_COLON_QMARK,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_op_identifier,
      sym_xint,
  [87702] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6305), 1,
      sym_identifier,
    ACTIONS(6307), 1,
      anon_sym_LPAREN,
    ACTIONS(6309), 1,
      anon_sym__,
    ACTIONS(6311), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6313), 1,
      anon_sym_POUND,
    STATE(4298), 1,
      sym__static_type_identifier,
    STATE(4328), 1,
      sym__type,
    STATE(4521), 1,
      sym_type_argument,
    STATE(4642), 1,
      sym_long_identifier,
    ACTIONS(6315), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4098), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4675), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [87774] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6305), 1,
      sym_identifier,
    ACTIONS(6307), 1,
      anon_sym_LPAREN,
    ACTIONS(6309), 1,
      anon_sym__,
    ACTIONS(6311), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6313), 1,
      anon_sym_POUND,
    STATE(4298), 1,
      sym__static_type_identifier,
    STATE(4322), 1,
      sym__type,
    STATE(4521), 1,
      sym_type_argument,
    STATE(4642), 1,
      sym_long_identifier,
    ACTIONS(6315), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4099), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4675), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [87846] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6259), 1,
      sym_identifier,
    ACTIONS(6261), 1,
      anon_sym_LPAREN,
    ACTIONS(6263), 1,
      anon_sym__,
    ACTIONS(6265), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6267), 1,
      anon_sym_POUND,
    STATE(4301), 1,
      sym__type,
    STATE(4358), 1,
      sym__static_type_identifier,
    STATE(4487), 1,
      sym_type_argument,
    STATE(4683), 1,
      sym_long_identifier,
    ACTIONS(6269), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4100), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4684), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [87918] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4511), 1,
      anon_sym_LPAREN,
    ACTIONS(4513), 1,
      anon_sym__,
    ACTIONS(4515), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4519), 1,
      anon_sym_POUND,
    ACTIONS(5768), 1,
      sym_identifier,
    STATE(4686), 1,
      sym__static_type_identifier,
    STATE(4913), 1,
      sym_type_argument,
    STATE(5121), 1,
      sym_long_identifier,
    STATE(5235), 1,
      sym__type,
    ACTIONS(4521), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4101), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5109), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [87990] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6247), 1,
      sym_identifier,
    ACTIONS(6249), 1,
      anon_sym_LPAREN,
    ACTIONS(6251), 1,
      anon_sym__,
    ACTIONS(6253), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6255), 1,
      anon_sym_POUND,
    STATE(4385), 1,
      sym__type,
    STATE(4389), 1,
      sym__static_type_identifier,
    STATE(4596), 1,
      sym_type_argument,
    STATE(4738), 1,
      sym_long_identifier,
    ACTIONS(6257), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4102), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4722), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [88062] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4511), 1,
      anon_sym_LPAREN,
    ACTIONS(4513), 1,
      anon_sym__,
    ACTIONS(4515), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4519), 1,
      anon_sym_POUND,
    ACTIONS(5768), 1,
      sym_identifier,
    STATE(4686), 1,
      sym__static_type_identifier,
    STATE(4913), 1,
      sym_type_argument,
    STATE(5121), 1,
      sym_long_identifier,
    STATE(5399), 1,
      sym__type,
    ACTIONS(4521), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4103), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5109), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [88134] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4511), 1,
      anon_sym_LPAREN,
    ACTIONS(4513), 1,
      anon_sym__,
    ACTIONS(4515), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4519), 1,
      anon_sym_POUND,
    ACTIONS(5768), 1,
      sym_identifier,
    STATE(4686), 1,
      sym__static_type_identifier,
    STATE(4913), 1,
      sym_type_argument,
    STATE(5121), 1,
      sym_long_identifier,
    STATE(5175), 1,
      sym__type,
    ACTIONS(4521), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4104), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5109), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [88206] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6305), 1,
      sym_identifier,
    ACTIONS(6307), 1,
      anon_sym_LPAREN,
    ACTIONS(6309), 1,
      anon_sym__,
    ACTIONS(6311), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6313), 1,
      anon_sym_POUND,
    STATE(4298), 1,
      sym__static_type_identifier,
    STATE(4300), 1,
      sym__type,
    STATE(4521), 1,
      sym_type_argument,
    STATE(4642), 1,
      sym_long_identifier,
    ACTIONS(6315), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4105), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4675), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [88278] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4511), 1,
      anon_sym_LPAREN,
    ACTIONS(4513), 1,
      anon_sym__,
    ACTIONS(4515), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4519), 1,
      anon_sym_POUND,
    ACTIONS(5768), 1,
      sym_identifier,
    STATE(4686), 1,
      sym__static_type_identifier,
    STATE(4913), 1,
      sym_type_argument,
    STATE(5121), 1,
      sym_long_identifier,
    STATE(5376), 1,
      sym__type,
    ACTIONS(4521), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4106), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5109), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [88350] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4511), 1,
      anon_sym_LPAREN,
    ACTIONS(4513), 1,
      anon_sym__,
    ACTIONS(4515), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4519), 1,
      anon_sym_POUND,
    ACTIONS(5768), 1,
      sym_identifier,
    STATE(4686), 1,
      sym__static_type_identifier,
    STATE(4913), 1,
      sym_type_argument,
    STATE(5121), 1,
      sym_long_identifier,
    STATE(5390), 1,
      sym__type,
    ACTIONS(4521), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4107), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5109), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [88422] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4504), 1,
      sym_identifier,
    ACTIONS(5347), 1,
      anon_sym_LPAREN,
    ACTIONS(5349), 1,
      anon_sym__,
    ACTIONS(5351), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(5353), 1,
      anon_sym_POUND,
    STATE(2708), 1,
      sym__static_type_identifier,
    STATE(2714), 1,
      sym__type,
    STATE(2770), 1,
      sym_type_argument,
    STATE(2788), 1,
      sym_long_identifier,
    ACTIONS(5355), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4108), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(2778), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [88494] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4504), 1,
      sym_identifier,
    ACTIONS(5347), 1,
      anon_sym_LPAREN,
    ACTIONS(5349), 1,
      anon_sym__,
    ACTIONS(5351), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(5353), 1,
      anon_sym_POUND,
    STATE(2708), 1,
      sym__static_type_identifier,
    STATE(2709), 1,
      sym__type,
    STATE(2770), 1,
      sym_type_argument,
    STATE(2788), 1,
      sym_long_identifier,
    ACTIONS(5355), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4109), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(2778), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [88566] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2659), 1,
      sym_identifier,
    ACTIONS(6193), 1,
      anon_sym_LPAREN,
    ACTIONS(6195), 1,
      anon_sym__,
    ACTIONS(6197), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6199), 1,
      anon_sym_POUND,
    STATE(846), 1,
      sym__static_type_identifier,
    STATE(902), 1,
      sym_long_identifier,
    STATE(904), 1,
      sym_type_argument,
    STATE(1091), 1,
      sym__type,
    ACTIONS(6201), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4110), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(911), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [88638] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5455), 1,
      anon_sym_LPAREN,
    ACTIONS(5457), 1,
      anon_sym__,
    ACTIONS(5461), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(5463), 1,
      anon_sym_POUND,
    ACTIONS(5967), 1,
      sym_identifier,
    STATE(4182), 1,
      sym__static_type_identifier,
    STATE(4223), 1,
      sym_type_argument,
    STATE(4259), 1,
      sym_long_identifier,
    STATE(5005), 1,
      sym__type,
    ACTIONS(5465), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4111), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4263), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [88710] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4511), 1,
      anon_sym_LPAREN,
    ACTIONS(4513), 1,
      anon_sym__,
    ACTIONS(4515), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4519), 1,
      anon_sym_POUND,
    ACTIONS(5768), 1,
      sym_identifier,
    STATE(4686), 1,
      sym__static_type_identifier,
    STATE(4913), 1,
      sym_type_argument,
    STATE(5121), 1,
      sym_long_identifier,
    STATE(5266), 1,
      sym__type,
    ACTIONS(4521), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4112), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5109), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [88782] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5070), 1,
      sym_identifier,
    ACTIONS(6013), 1,
      anon_sym_LPAREN,
    ACTIONS(6015), 1,
      anon_sym__,
    ACTIONS(6017), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6019), 1,
      anon_sym_POUND,
    STATE(2911), 1,
      sym__static_type_identifier,
    STATE(2919), 1,
      sym__type,
    STATE(3056), 1,
      sym_type_argument,
    STATE(3193), 1,
      sym_long_identifier,
    ACTIONS(6021), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4113), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(3195), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [88854] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5070), 1,
      sym_identifier,
    ACTIONS(6013), 1,
      anon_sym_LPAREN,
    ACTIONS(6015), 1,
      anon_sym__,
    ACTIONS(6017), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6019), 1,
      anon_sym_POUND,
    STATE(2911), 1,
      sym__static_type_identifier,
    STATE(2923), 1,
      sym__type,
    STATE(3056), 1,
      sym_type_argument,
    STATE(3193), 1,
      sym_long_identifier,
    ACTIONS(6021), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4114), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(3195), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [88926] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4511), 1,
      anon_sym_LPAREN,
    ACTIONS(4513), 1,
      anon_sym__,
    ACTIONS(4515), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4519), 1,
      anon_sym_POUND,
    ACTIONS(5768), 1,
      sym_identifier,
    STATE(4686), 1,
      sym__static_type_identifier,
    STATE(4913), 1,
      sym_type_argument,
    STATE(5121), 1,
      sym_long_identifier,
    STATE(5402), 1,
      sym__type,
    ACTIONS(4521), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4115), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5109), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [88998] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5070), 1,
      sym_identifier,
    ACTIONS(6013), 1,
      anon_sym_LPAREN,
    ACTIONS(6015), 1,
      anon_sym__,
    ACTIONS(6017), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6019), 1,
      anon_sym_POUND,
    STATE(2911), 1,
      sym__static_type_identifier,
    STATE(2927), 1,
      sym__type,
    STATE(3056), 1,
      sym_type_argument,
    STATE(3193), 1,
      sym_long_identifier,
    ACTIONS(6021), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4116), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(3195), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [89070] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4511), 1,
      anon_sym_LPAREN,
    ACTIONS(4513), 1,
      anon_sym__,
    ACTIONS(4515), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4519), 1,
      anon_sym_POUND,
    ACTIONS(5768), 1,
      sym_identifier,
    STATE(4686), 1,
      sym__static_type_identifier,
    STATE(4913), 1,
      sym_type_argument,
    STATE(5121), 1,
      sym_long_identifier,
    STATE(5300), 1,
      sym__type,
    ACTIONS(4521), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4117), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5109), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [89142] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6203), 1,
      sym_identifier,
    ACTIONS(6205), 1,
      anon_sym_LPAREN,
    ACTIONS(6207), 1,
      anon_sym__,
    ACTIONS(6209), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6211), 1,
      anon_sym_POUND,
    STATE(4215), 1,
      sym__type,
    STATE(4280), 1,
      sym__static_type_identifier,
    STATE(4392), 1,
      sym_type_argument,
    STATE(4580), 1,
      sym_long_identifier,
    ACTIONS(6213), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4118), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4577), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [89214] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5070), 1,
      sym_identifier,
    ACTIONS(6013), 1,
      anon_sym_LPAREN,
    ACTIONS(6015), 1,
      anon_sym__,
    ACTIONS(6017), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6019), 1,
      anon_sym_POUND,
    STATE(2911), 1,
      sym__static_type_identifier,
    STATE(2936), 1,
      sym__type,
    STATE(3056), 1,
      sym_type_argument,
    STATE(3193), 1,
      sym_long_identifier,
    ACTIONS(6021), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4119), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(3195), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [89286] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3204), 1,
      sym_identifier,
    ACTIONS(6295), 1,
      anon_sym_LPAREN,
    ACTIONS(6297), 1,
      anon_sym__,
    ACTIONS(6299), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6301), 1,
      anon_sym_POUND,
    STATE(1023), 1,
      sym__type,
    STATE(1205), 1,
      sym__static_type_identifier,
    STATE(1365), 1,
      sym_type_argument,
    STATE(1377), 1,
      sym_long_identifier,
    ACTIONS(6303), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4120), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(1341), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [89358] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5455), 1,
      anon_sym_LPAREN,
    ACTIONS(5457), 1,
      anon_sym__,
    ACTIONS(5461), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(5463), 1,
      anon_sym_POUND,
    ACTIONS(5967), 1,
      sym_identifier,
    STATE(4182), 1,
      sym__static_type_identifier,
    STATE(4193), 1,
      sym__type,
    STATE(4223), 1,
      sym_type_argument,
    STATE(4259), 1,
      sym_long_identifier,
    ACTIONS(5465), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4121), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4263), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [89430] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6057), 1,
      sym_identifier,
    ACTIONS(6059), 1,
      anon_sym_LPAREN,
    ACTIONS(6061), 1,
      anon_sym__,
    ACTIONS(6063), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6065), 1,
      anon_sym_POUND,
    STATE(4359), 1,
      sym__type,
    STATE(4379), 1,
      sym__static_type_identifier,
    STATE(4482), 1,
      sym_type_argument,
    STATE(4685), 1,
      sym_long_identifier,
    ACTIONS(6067), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4122), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4690), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [89502] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5836), 1,
      sym_identifier,
    ACTIONS(5838), 1,
      anon_sym_LPAREN,
    ACTIONS(5840), 1,
      anon_sym__,
    ACTIONS(5842), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(5844), 1,
      anon_sym_POUND,
    STATE(4202), 1,
      sym__static_type_identifier,
    STATE(4227), 1,
      sym__type,
    STATE(4346), 1,
      sym_type_argument,
    STATE(4406), 1,
      sym_long_identifier,
    ACTIONS(5846), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4123), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4404), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [89574] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4511), 1,
      anon_sym_LPAREN,
    ACTIONS(4513), 1,
      anon_sym__,
    ACTIONS(4515), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4519), 1,
      anon_sym_POUND,
    ACTIONS(5768), 1,
      sym_identifier,
    STATE(4686), 1,
      sym__static_type_identifier,
    STATE(4913), 1,
      sym_type_argument,
    STATE(5121), 1,
      sym_long_identifier,
    STATE(5348), 1,
      sym__type,
    ACTIONS(4521), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4124), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5109), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [89646] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6069), 1,
      sym_identifier,
    ACTIONS(6071), 1,
      anon_sym_LPAREN,
    ACTIONS(6073), 1,
      anon_sym__,
    ACTIONS(6075), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6077), 1,
      anon_sym_POUND,
    STATE(4250), 1,
      sym__type,
    STATE(4273), 1,
      sym__static_type_identifier,
    STATE(4395), 1,
      sym_type_argument,
    STATE(4571), 1,
      sym_long_identifier,
    ACTIONS(6079), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4125), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4573), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [89718] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5836), 1,
      sym_identifier,
    ACTIONS(5838), 1,
      anon_sym_LPAREN,
    ACTIONS(5840), 1,
      anon_sym__,
    ACTIONS(5842), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(5844), 1,
      anon_sym_POUND,
    STATE(4202), 1,
      sym__static_type_identifier,
    STATE(4226), 1,
      sym__type,
    STATE(4346), 1,
      sym_type_argument,
    STATE(4406), 1,
      sym_long_identifier,
    ACTIONS(5846), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4126), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4404), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [89790] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5836), 1,
      sym_identifier,
    ACTIONS(5838), 1,
      anon_sym_LPAREN,
    ACTIONS(5840), 1,
      anon_sym__,
    ACTIONS(5842), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(5844), 1,
      anon_sym_POUND,
    STATE(4202), 1,
      sym__static_type_identifier,
    STATE(4225), 1,
      sym__type,
    STATE(4346), 1,
      sym_type_argument,
    STATE(4406), 1,
      sym_long_identifier,
    ACTIONS(5846), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4127), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4404), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [89862] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3204), 1,
      sym_identifier,
    ACTIONS(6295), 1,
      anon_sym_LPAREN,
    ACTIONS(6297), 1,
      anon_sym__,
    ACTIONS(6299), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6301), 1,
      anon_sym_POUND,
    STATE(1004), 1,
      sym__type,
    STATE(1205), 1,
      sym__static_type_identifier,
    STATE(1365), 1,
      sym_type_argument,
    STATE(1377), 1,
      sym_long_identifier,
    ACTIONS(6303), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4128), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(1341), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [89934] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3204), 1,
      sym_identifier,
    ACTIONS(6295), 1,
      anon_sym_LPAREN,
    ACTIONS(6297), 1,
      anon_sym__,
    ACTIONS(6299), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6301), 1,
      anon_sym_POUND,
    STATE(1037), 1,
      sym__type,
    STATE(1205), 1,
      sym__static_type_identifier,
    STATE(1365), 1,
      sym_type_argument,
    STATE(1377), 1,
      sym_long_identifier,
    ACTIONS(6303), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4129), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(1341), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [90006] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4511), 1,
      anon_sym_LPAREN,
    ACTIONS(4513), 1,
      anon_sym__,
    ACTIONS(4515), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4519), 1,
      anon_sym_POUND,
    ACTIONS(5768), 1,
      sym_identifier,
    STATE(4686), 1,
      sym__static_type_identifier,
    STATE(4913), 1,
      sym_type_argument,
    STATE(5121), 1,
      sym_long_identifier,
    STATE(5416), 1,
      sym__type,
    ACTIONS(4521), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4130), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(5109), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [90078] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5836), 1,
      sym_identifier,
    ACTIONS(5838), 1,
      anon_sym_LPAREN,
    ACTIONS(5840), 1,
      anon_sym__,
    ACTIONS(5842), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(5844), 1,
      anon_sym_POUND,
    STATE(4202), 1,
      sym__static_type_identifier,
    STATE(4203), 1,
      sym__type,
    STATE(4346), 1,
      sym_type_argument,
    STATE(4406), 1,
      sym_long_identifier,
    ACTIONS(5846), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4131), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4404), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [90150] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6069), 1,
      sym_identifier,
    ACTIONS(6071), 1,
      anon_sym_LPAREN,
    ACTIONS(6073), 1,
      anon_sym__,
    ACTIONS(6075), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6077), 1,
      anon_sym_POUND,
    STATE(4273), 1,
      sym__static_type_identifier,
    STATE(4274), 1,
      sym__type,
    STATE(4395), 1,
      sym_type_argument,
    STATE(4571), 1,
      sym_long_identifier,
    ACTIONS(6079), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4132), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4573), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [90222] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6069), 1,
      sym_identifier,
    ACTIONS(6071), 1,
      anon_sym_LPAREN,
    ACTIONS(6073), 1,
      anon_sym__,
    ACTIONS(6075), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(6077), 1,
      anon_sym_POUND,
    STATE(4251), 1,
      sym__type,
    STATE(4273), 1,
      sym__static_type_identifier,
    STATE(4395), 1,
      sym_type_argument,
    STATE(4571), 1,
      sym_long_identifier,
    ACTIONS(6079), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4133), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    STATE(4573), 11,
      sym_simple_type,
      sym_generic_type,
      sym_paren_type,
      sym_function_type,
      sym_compound_type,
      sym_postfix_type,
      sym_list_type,
      sym_static_type,
      sym_constrained_type,
      sym_flexible_type,
      sym_anon_record_type,
  [90294] = 22,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2158), 1,
      anon_sym_COLON,
    ACTIONS(5808), 1,
      anon_sym_y,
    ACTIONS(5810), 1,
      anon_sym_uy,
    ACTIONS(5812), 1,
      anon_sym_s,
    ACTIONS(5814), 1,
      anon_sym_us,
    ACTIONS(5818), 1,
      aux_sym_uint32_token1,
    ACTIONS(5820), 1,
      anon_sym_n,
    ACTIONS(5822), 1,
      anon_sym_un,
    ACTIONS(5826), 1,
      aux_sym_uint64_token1,
    ACTIONS(6321), 1,
      anon_sym_l,
    ACTIONS(6323), 1,
      anon_sym_L,
    ACTIONS(6325), 1,
      anon_sym_lf,
    ACTIONS(6327), 1,
      anon_sym_LF,
    STATE(4134), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2160), 8,
      sym__newline,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
  [90371] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    STATE(4135), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2411), 9,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(2413), 12,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [90424] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    STATE(4136), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5609), 9,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(5611), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [90476] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    STATE(4137), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2966), 9,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(2968), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [90528] = 22,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2158), 1,
      anon_sym_COLON,
    ACTIONS(5914), 1,
      anon_sym_y,
    ACTIONS(5916), 1,
      anon_sym_uy,
    ACTIONS(5918), 1,
      anon_sym_s,
    ACTIONS(5920), 1,
      anon_sym_us,
    ACTIONS(5924), 1,
      aux_sym_uint32_token1,
    ACTIONS(5926), 1,
      anon_sym_n,
    ACTIONS(5928), 1,
      anon_sym_un,
    ACTIONS(5932), 1,
      aux_sym_uint64_token1,
    ACTIONS(6329), 1,
      anon_sym_l,
    ACTIONS(6331), 1,
      anon_sym_L,
    ACTIONS(6333), 1,
      anon_sym_lf,
    ACTIONS(6335), 1,
      anon_sym_LF,
    STATE(4138), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2160), 7,
      sym__newline,
      sym__dedent,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
  [90604] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5967), 1,
      sym_identifier,
    ACTIONS(6337), 1,
      anon_sym_DASH_GT,
    ACTIONS(6339), 1,
      anon_sym_STAR,
    ACTIONS(6341), 1,
      anon_sym_LT2,
    ACTIONS(6343), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4211), 1,
      aux_sym_compound_type_repeat1,
    STATE(4248), 1,
      sym_type_arguments,
    STATE(4268), 1,
      sym_long_identifier,
    ACTIONS(2244), 4,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
    STATE(4139), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2246), 8,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [90672] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5967), 1,
      sym_identifier,
    ACTIONS(6337), 1,
      anon_sym_DASH_GT,
    ACTIONS(6339), 1,
      anon_sym_STAR,
    ACTIONS(6341), 1,
      anon_sym_LT2,
    ACTIONS(6343), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4211), 1,
      aux_sym_compound_type_repeat1,
    STATE(4248), 1,
      sym_type_arguments,
    STATE(4268), 1,
      sym_long_identifier,
    ACTIONS(2248), 4,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
    STATE(4140), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2250), 8,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [90740] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    STATE(4141), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6345), 9,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(6347), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [90792] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    STATE(4142), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5590), 9,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(5592), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [90844] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    STATE(4143), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5594), 9,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(5596), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [90896] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    STATE(4144), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5598), 9,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(5600), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [90948] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5967), 1,
      sym_identifier,
    ACTIONS(6337), 1,
      anon_sym_DASH_GT,
    ACTIONS(6339), 1,
      anon_sym_STAR,
    ACTIONS(6341), 1,
      anon_sym_LT2,
    ACTIONS(6343), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4211), 1,
      aux_sym_compound_type_repeat1,
    STATE(4248), 1,
      sym_type_arguments,
    STATE(4268), 1,
      sym_long_identifier,
    ACTIONS(2228), 4,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
    STATE(4145), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2230), 8,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [91016] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5967), 1,
      sym_identifier,
    ACTIONS(6341), 1,
      anon_sym_LT2,
    ACTIONS(6343), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4211), 1,
      aux_sym_compound_type_repeat1,
    STATE(4248), 1,
      sym_type_arguments,
    STATE(4268), 1,
      sym_long_identifier,
    ACTIONS(6353), 2,
      anon_sym_DASH_GT,
      anon_sym_STAR,
    ACTIONS(6349), 4,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
    STATE(4146), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6351), 8,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [91082] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6355), 1,
      anon_sym_or,
    STATE(4147), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_type_argument_repeat1,
    ACTIONS(2340), 9,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      sym_identifier,
    ACTIONS(2342), 9,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [91136] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    STATE(4148), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3011), 9,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(3013), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [91188] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    STATE(4149), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6358), 9,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(6360), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [91240] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    STATE(4150), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2843), 9,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(2845), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [91292] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    STATE(4151), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5624), 9,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(5626), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [91344] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    STATE(4152), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2158), 9,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(2160), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [91396] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5967), 1,
      sym_identifier,
    ACTIONS(6337), 1,
      anon_sym_DASH_GT,
    ACTIONS(6339), 1,
      anon_sym_STAR,
    ACTIONS(6341), 1,
      anon_sym_LT2,
    ACTIONS(6343), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4211), 1,
      aux_sym_compound_type_repeat1,
    STATE(4248), 1,
      sym_type_arguments,
    STATE(4268), 1,
      sym_long_identifier,
    ACTIONS(2240), 4,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
    STATE(4153), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2242), 8,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [91464] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    STATE(4154), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3035), 9,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(3037), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [91516] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    STATE(4155), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3031), 9,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(3033), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [91568] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    STATE(4156), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2863), 9,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(2865), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [91620] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    STATE(4157), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3027), 9,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(3029), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [91672] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    STATE(4158), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3023), 9,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(3025), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [91724] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    STATE(4159), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3019), 9,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(3021), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [91776] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    STATE(4160), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2855), 9,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(2857), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [91828] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    STATE(4161), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3095), 9,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(3097), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [91880] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5967), 1,
      sym_identifier,
    ACTIONS(6341), 1,
      anon_sym_LT2,
    ACTIONS(6343), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4211), 1,
      aux_sym_compound_type_repeat1,
    STATE(4248), 1,
      sym_type_arguments,
    STATE(4268), 1,
      sym_long_identifier,
    ACTIONS(6353), 2,
      anon_sym_DASH_GT,
      anon_sym_STAR,
    ACTIONS(6362), 4,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
    STATE(4162), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6364), 8,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [91946] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    STATE(4163), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6366), 9,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(6368), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [91998] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    STATE(4164), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2984), 9,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(2986), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [92050] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    STATE(4165), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2873), 9,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(2875), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [92102] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    STATE(4166), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2859), 9,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(2861), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [92154] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    STATE(4167), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2988), 9,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(2990), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [92206] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    STATE(4168), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2934), 9,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(2936), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [92258] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6370), 1,
      anon_sym_COLON,
    ACTIONS(6372), 1,
      anon_sym_DOT,
    STATE(4194), 1,
      aux_sym_long_identifier_repeat1,
    STATE(4169), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2314), 8,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(2312), 9,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      sym_identifier,
  [92316] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6374), 1,
      anon_sym_or,
    STATE(4147), 1,
      aux_sym_type_argument_repeat1,
    STATE(4170), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2328), 9,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      sym_identifier,
    ACTIONS(2330), 9,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [92372] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    STATE(4171), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2974), 9,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(2976), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [92424] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    STATE(4172), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2922), 9,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(2924), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [92476] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    STATE(4173), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2962), 9,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(2964), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [92528] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    STATE(4174), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3115), 9,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(3117), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [92580] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    STATE(4175), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2958), 9,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(2960), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [92632] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    STATE(4176), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5605), 9,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(5607), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [92684] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    STATE(4177), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2950), 9,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(2952), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [92736] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    STATE(4178), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2946), 9,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(2948), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [92788] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    STATE(4179), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2938), 9,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(2940), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [92840] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    STATE(4180), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2970), 9,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(2972), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [92892] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    STATE(4181), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2877), 9,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(2879), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [92944] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6374), 1,
      anon_sym_or,
    STATE(4170), 1,
      aux_sym_type_argument_repeat1,
    STATE(4182), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2321), 9,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      sym_identifier,
    ACTIONS(2323), 9,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [93000] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    STATE(4183), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2918), 9,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(2920), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [93052] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    STATE(4184), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2914), 9,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(2916), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [93104] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    STATE(4185), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2910), 9,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(2912), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [93156] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    STATE(4186), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2942), 9,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(2944), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_LT2,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [93208] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    STATE(4187), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2891), 9,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(2893), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [93260] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    STATE(4188), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2926), 9,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(2928), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [93312] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    STATE(4189), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2887), 9,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(2889), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [93364] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    STATE(4190), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2883), 9,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
    ACTIONS(2885), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
  [93416] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    STATE(4191), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2464), 9,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(2462), 10,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_or,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      sym_identifier,
  [93467] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5967), 1,
      sym_identifier,
    ACTIONS(6337), 1,
      anon_sym_DASH_GT,
    ACTIONS(6339), 1,
      anon_sym_STAR,
    ACTIONS(6341), 1,
      anon_sym_LT2,
    ACTIONS(6343), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4211), 1,
      aux_sym_compound_type_repeat1,
    STATE(4248), 1,
      sym_type_arguments,
    STATE(4268), 1,
      sym_long_identifier,
    ACTIONS(6376), 4,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
    STATE(4192), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6378), 7,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [93534] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5967), 1,
      sym_identifier,
    ACTIONS(6337), 1,
      anon_sym_DASH_GT,
    ACTIONS(6339), 1,
      anon_sym_STAR,
    ACTIONS(6341), 1,
      anon_sym_LT2,
    ACTIONS(6343), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4211), 1,
      aux_sym_compound_type_repeat1,
    STATE(4248), 1,
      sym_type_arguments,
    STATE(4268), 1,
      sym_long_identifier,
    ACTIONS(6380), 4,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
    STATE(4193), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6382), 7,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [93601] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6372), 1,
      anon_sym_DOT,
    STATE(4195), 1,
      aux_sym_long_identifier_repeat1,
    STATE(4194), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2420), 8,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(2418), 9,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      sym_identifier,
  [93656] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6384), 1,
      anon_sym_DOT,
    STATE(4195), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_long_identifier_repeat1,
    ACTIONS(2413), 8,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(2411), 9,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      sym_identifier,
  [93709] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5967), 1,
      sym_identifier,
    ACTIONS(6337), 1,
      anon_sym_DASH_GT,
    ACTIONS(6339), 1,
      anon_sym_STAR,
    ACTIONS(6341), 1,
      anon_sym_LT2,
    ACTIONS(6343), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4211), 1,
      aux_sym_compound_type_repeat1,
    STATE(4248), 1,
      sym_type_arguments,
    STATE(4268), 1,
      sym_long_identifier,
    ACTIONS(6387), 4,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
    STATE(4196), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6389), 7,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [93776] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5967), 1,
      sym_identifier,
    ACTIONS(6337), 1,
      anon_sym_DASH_GT,
    ACTIONS(6339), 1,
      anon_sym_STAR,
    ACTIONS(6341), 1,
      anon_sym_LT2,
    ACTIONS(6343), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4211), 1,
      aux_sym_compound_type_repeat1,
    STATE(4248), 1,
      sym_type_arguments,
    STATE(4268), 1,
      sym_long_identifier,
    ACTIONS(6391), 4,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
    STATE(4197), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6393), 7,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [93843] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5967), 1,
      sym_identifier,
    ACTIONS(6337), 1,
      anon_sym_DASH_GT,
    ACTIONS(6339), 1,
      anon_sym_STAR,
    ACTIONS(6341), 1,
      anon_sym_LT2,
    ACTIONS(6343), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4211), 1,
      aux_sym_compound_type_repeat1,
    STATE(4248), 1,
      sym_type_arguments,
    STATE(4268), 1,
      sym_long_identifier,
    ACTIONS(6395), 4,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
    STATE(4198), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6397), 7,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [93910] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    STATE(4199), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2342), 9,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(2340), 10,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_or,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      sym_identifier,
  [93961] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6372), 1,
      anon_sym_DOT,
    STATE(4194), 1,
      aux_sym_long_identifier_repeat1,
    STATE(4200), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2314), 8,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(2312), 9,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      sym_identifier,
  [94016] = 20,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5872), 1,
      sym_identifier,
    ACTIONS(6399), 1,
      anon_sym_DASH_GT,
    ACTIONS(6401), 1,
      anon_sym_when,
    ACTIONS(6403), 1,
      anon_sym_STAR,
    ACTIONS(6405), 1,
      anon_sym_LT2,
    ACTIONS(6407), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4314), 1,
      aux_sym_compound_type_repeat1,
    STATE(4459), 1,
      sym_long_identifier,
    STATE(4468), 1,
      sym_type_arguments,
    STATE(5373), 1,
      sym_type_argument_constraints,
    ACTIONS(4953), 2,
      anon_sym_COLON,
      anon_sym_as,
    STATE(4201), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4951), 7,
      sym__newline,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
  [94087] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6409), 1,
      anon_sym_or,
    STATE(4221), 1,
      aux_sym_type_argument_repeat1,
    ACTIONS(2321), 4,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      sym_identifier,
    STATE(4202), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2323), 12,
      sym__newline,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [94141] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5836), 1,
      sym_identifier,
    ACTIONS(6411), 1,
      anon_sym_DASH_GT,
    ACTIONS(6413), 1,
      anon_sym_STAR,
    ACTIONS(6415), 1,
      anon_sym_LT2,
    ACTIONS(6417), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4304), 1,
      aux_sym_compound_type_repeat1,
    STATE(4407), 1,
      sym_type_arguments,
    STATE(4410), 1,
      sym_long_identifier,
    ACTIONS(2242), 3,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
    STATE(4203), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2240), 7,
      sym__newline,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
  [94207] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5836), 1,
      sym_identifier,
    ACTIONS(6411), 1,
      anon_sym_DASH_GT,
    ACTIONS(6413), 1,
      anon_sym_STAR,
    ACTIONS(6415), 1,
      anon_sym_LT2,
    ACTIONS(6417), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4304), 1,
      aux_sym_compound_type_repeat1,
    STATE(4407), 1,
      sym_type_arguments,
    STATE(4410), 1,
      sym_long_identifier,
    ACTIONS(5009), 3,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
    STATE(4204), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5011), 7,
      sym__newline,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
  [94273] = 24,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6419), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(6422), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6425), 1,
      anon_sym_new,
    ACTIONS(6431), 1,
      anon_sym_static,
    ACTIONS(6434), 1,
      anon_sym_member,
    ACTIONS(6437), 1,
      anon_sym_abstract,
    ACTIONS(6440), 1,
      anon_sym_val,
    ACTIONS(6443), 1,
      sym__newline,
    ACTIONS(6446), 1,
      sym__dedent,
    STATE(4305), 1,
      aux_sym_attributes_repeat1,
    STATE(4488), 1,
      sym__attribute_set,
    STATE(4898), 1,
      sym_member_defn,
    STATE(4928), 1,
      sym_additional_constr_defn,
    STATE(4996), 1,
      sym_attributes,
    STATE(7292), 1,
      sym_access_modifier,
    ACTIONS(6428), 2,
      anon_sym_default,
      anon_sym_override,
    STATE(4205), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym__member_defns_repeat1,
  [94351] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5836), 1,
      sym_identifier,
    ACTIONS(6411), 1,
      anon_sym_DASH_GT,
    ACTIONS(6413), 1,
      anon_sym_STAR,
    ACTIONS(6415), 1,
      anon_sym_LT2,
    ACTIONS(6417), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4304), 1,
      aux_sym_compound_type_repeat1,
    STATE(4407), 1,
      sym_type_arguments,
    STATE(4410), 1,
      sym_long_identifier,
    ACTIONS(5013), 3,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
    STATE(4206), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5015), 7,
      sym__newline,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
  [94417] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    STATE(4207), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2321), 9,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      sym_identifier,
    ACTIONS(2323), 9,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [94467] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5872), 1,
      sym_identifier,
    ACTIONS(6399), 1,
      anon_sym_DASH_GT,
    ACTIONS(6403), 1,
      anon_sym_STAR,
    ACTIONS(6405), 1,
      anon_sym_LT2,
    ACTIONS(6407), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4314), 1,
      aux_sym_compound_type_repeat1,
    STATE(4459), 1,
      sym_long_identifier,
    STATE(4468), 1,
      sym_type_arguments,
    ACTIONS(2230), 3,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_when,
    STATE(4208), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2228), 7,
      sym__newline,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
  [94533] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6448), 1,
      anon_sym_or,
    ACTIONS(2340), 4,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      sym_identifier,
    STATE(4209), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_type_argument_repeat1,
    ACTIONS(2342), 12,
      sym__newline,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [94585] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5872), 1,
      sym_identifier,
    ACTIONS(6399), 1,
      anon_sym_DASH_GT,
    ACTIONS(6403), 1,
      anon_sym_STAR,
    ACTIONS(6405), 1,
      anon_sym_LT2,
    ACTIONS(6407), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4314), 1,
      aux_sym_compound_type_repeat1,
    STATE(4459), 1,
      sym_long_identifier,
    STATE(4468), 1,
      sym_type_arguments,
    ACTIONS(2246), 3,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_when,
    STATE(4210), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2244), 7,
      sym__newline,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
  [94651] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6339), 1,
      anon_sym_STAR,
    STATE(4224), 1,
      aux_sym_compound_type_repeat1,
    STATE(4211), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2409), 7,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(2407), 9,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      sym_identifier,
  [94705] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5872), 1,
      sym_identifier,
    ACTIONS(6399), 1,
      anon_sym_DASH_GT,
    ACTIONS(6403), 1,
      anon_sym_STAR,
    ACTIONS(6405), 1,
      anon_sym_LT2,
    ACTIONS(6407), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4314), 1,
      aux_sym_compound_type_repeat1,
    STATE(4459), 1,
      sym_long_identifier,
    STATE(4468), 1,
      sym_type_arguments,
    ACTIONS(2242), 3,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_when,
    STATE(4212), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2240), 7,
      sym__newline,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
  [94771] = 25,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(23), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6451), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6453), 1,
      anon_sym_new,
    ACTIONS(6457), 1,
      anon_sym_static,
    ACTIONS(6459), 1,
      anon_sym_member,
    ACTIONS(6461), 1,
      anon_sym_abstract,
    ACTIONS(6463), 1,
      anon_sym_val,
    ACTIONS(6465), 1,
      sym__newline,
    ACTIONS(6467), 1,
      sym__dedent,
    STATE(4220), 1,
      aux_sym__member_defns_repeat1,
    STATE(4305), 1,
      aux_sym_attributes_repeat1,
    STATE(4488), 1,
      sym__attribute_set,
    STATE(4898), 1,
      sym_member_defn,
    STATE(4928), 1,
      sym_additional_constr_defn,
    STATE(4996), 1,
      sym_attributes,
    STATE(7292), 1,
      sym_access_modifier,
    ACTIONS(6455), 2,
      anon_sym_default,
      anon_sym_override,
    STATE(4213), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [94851] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6469), 1,
      anon_sym_or,
    STATE(4222), 1,
      aux_sym_type_argument_repeat1,
    ACTIONS(2328), 4,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_when,
      sym_identifier,
    STATE(4214), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2330), 12,
      sym__newline,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [94905] = 20,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6203), 1,
      sym_identifier,
    ACTIONS(6471), 1,
      anon_sym_DASH_GT,
    ACTIONS(6473), 1,
      anon_sym_when,
    ACTIONS(6475), 1,
      anon_sym_STAR,
    ACTIONS(6477), 1,
      anon_sym_LT2,
    ACTIONS(6479), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4429), 1,
      aux_sym_compound_type_repeat1,
    STATE(4531), 1,
      sym_type_arguments,
    STATE(4578), 1,
      sym_long_identifier,
    STATE(4737), 1,
      sym_type_argument_constraints,
    ACTIONS(4953), 2,
      anon_sym_COLON,
      anon_sym_as,
    STATE(4215), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4951), 6,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
  [94975] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5872), 1,
      sym_identifier,
    ACTIONS(6399), 1,
      anon_sym_DASH_GT,
    ACTIONS(6403), 1,
      anon_sym_STAR,
    ACTIONS(6405), 1,
      anon_sym_LT2,
    ACTIONS(6407), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4314), 1,
      aux_sym_compound_type_repeat1,
    STATE(4459), 1,
      sym_long_identifier,
    STATE(4468), 1,
      sym_type_arguments,
    ACTIONS(2250), 3,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_when,
    STATE(4216), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2248), 7,
      sym__newline,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
  [95041] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6469), 1,
      anon_sym_or,
    STATE(4214), 1,
      aux_sym_type_argument_repeat1,
    ACTIONS(2321), 4,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_when,
      sym_identifier,
    STATE(4217), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2323), 12,
      sym__newline,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [95095] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    STATE(4218), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2411), 9,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      sym_identifier,
    ACTIONS(2413), 9,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [95145] = 20,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6083), 1,
      sym_identifier,
    ACTIONS(6481), 1,
      anon_sym_DASH_GT,
    ACTIONS(6483), 1,
      anon_sym_when,
    ACTIONS(6485), 1,
      anon_sym_STAR,
    ACTIONS(6487), 1,
      anon_sym_LT2,
    ACTIONS(6489), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4436), 1,
      aux_sym_compound_type_repeat1,
    STATE(4508), 1,
      sym_long_identifier,
    STATE(4518), 1,
      sym_type_arguments,
    STATE(5452), 1,
      sym_type_argument_constraints,
    ACTIONS(4953), 2,
      anon_sym_COLON,
      anon_sym_as,
    STATE(4219), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4951), 6,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
  [95215] = 25,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(23), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6451), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6453), 1,
      anon_sym_new,
    ACTIONS(6457), 1,
      anon_sym_static,
    ACTIONS(6459), 1,
      anon_sym_member,
    ACTIONS(6461), 1,
      anon_sym_abstract,
    ACTIONS(6463), 1,
      anon_sym_val,
    ACTIONS(6465), 1,
      sym__newline,
    ACTIONS(6491), 1,
      sym__dedent,
    STATE(4205), 1,
      aux_sym__member_defns_repeat1,
    STATE(4305), 1,
      aux_sym_attributes_repeat1,
    STATE(4488), 1,
      sym__attribute_set,
    STATE(4898), 1,
      sym_member_defn,
    STATE(4928), 1,
      sym_additional_constr_defn,
    STATE(4996), 1,
      sym_attributes,
    STATE(7292), 1,
      sym_access_modifier,
    ACTIONS(6455), 2,
      anon_sym_default,
      anon_sym_override,
    STATE(4220), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [95295] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6409), 1,
      anon_sym_or,
    STATE(4209), 1,
      aux_sym_type_argument_repeat1,
    ACTIONS(2328), 4,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      sym_identifier,
    STATE(4221), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2330), 12,
      sym__newline,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [95349] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6493), 1,
      anon_sym_or,
    ACTIONS(2340), 4,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_when,
      sym_identifier,
    STATE(4222), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_type_argument_repeat1,
    ACTIONS(2342), 12,
      sym__newline,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [95401] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6496), 1,
      anon_sym_COLON_GT,
    STATE(4223), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2569), 8,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(2567), 9,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      sym_identifier,
  [95453] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6498), 1,
      anon_sym_STAR,
    STATE(4224), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_compound_type_repeat1,
    ACTIONS(2248), 7,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(2250), 9,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      sym_identifier,
  [95505] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5836), 1,
      sym_identifier,
    ACTIONS(6411), 1,
      anon_sym_DASH_GT,
    ACTIONS(6413), 1,
      anon_sym_STAR,
    ACTIONS(6415), 1,
      anon_sym_LT2,
    ACTIONS(6417), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4304), 1,
      aux_sym_compound_type_repeat1,
    STATE(4407), 1,
      sym_type_arguments,
    STATE(4410), 1,
      sym_long_identifier,
    ACTIONS(2246), 3,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
    STATE(4225), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2244), 7,
      sym__newline,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
  [95571] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5836), 1,
      sym_identifier,
    ACTIONS(6411), 1,
      anon_sym_DASH_GT,
    ACTIONS(6413), 1,
      anon_sym_STAR,
    ACTIONS(6415), 1,
      anon_sym_LT2,
    ACTIONS(6417), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4304), 1,
      aux_sym_compound_type_repeat1,
    STATE(4407), 1,
      sym_type_arguments,
    STATE(4410), 1,
      sym_long_identifier,
    ACTIONS(2250), 3,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
    STATE(4226), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2248), 7,
      sym__newline,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
  [95637] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5836), 1,
      sym_identifier,
    ACTIONS(6411), 1,
      anon_sym_DASH_GT,
    ACTIONS(6413), 1,
      anon_sym_STAR,
    ACTIONS(6415), 1,
      anon_sym_LT2,
    ACTIONS(6417), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4304), 1,
      aux_sym_compound_type_repeat1,
    STATE(4407), 1,
      sym_type_arguments,
    STATE(4410), 1,
      sym_long_identifier,
    ACTIONS(2230), 3,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
    STATE(4227), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2228), 7,
      sym__newline,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
  [95703] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5955), 1,
      sym_identifier,
    ACTIONS(6501), 1,
      anon_sym_DASH_GT,
    ACTIONS(6503), 1,
      anon_sym_STAR,
    ACTIONS(6505), 1,
      anon_sym_LT2,
    ACTIONS(6507), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4449), 1,
      aux_sym_compound_type_repeat1,
    STATE(4495), 1,
      sym_long_identifier,
    STATE(4499), 1,
      sym_type_arguments,
    ACTIONS(5057), 2,
      anon_sym_COLON,
      anon_sym_as,
    STATE(4228), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5055), 7,
      sym__newline,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
  [95768] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6509), 1,
      anon_sym_DOT,
    STATE(4293), 1,
      aux_sym_long_identifier_repeat1,
    ACTIONS(2312), 4,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_when,
      sym_identifier,
    STATE(4229), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2314), 11,
      sym__newline,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [95821] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6511), 1,
      anon_sym_DOT,
    STATE(4255), 1,
      aux_sym_long_identifier_repeat1,
    ACTIONS(2418), 4,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      sym_identifier,
    STATE(4230), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2420), 11,
      sym__newline,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [95874] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    STATE(4231), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2340), 5,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_when,
      anon_sym_or,
      sym_identifier,
    ACTIONS(2342), 12,
      sym__newline,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [95923] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6513), 1,
      anon_sym_or,
    ACTIONS(2340), 4,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      sym_identifier,
    STATE(4232), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_type_argument_repeat1,
    ACTIONS(2342), 11,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [95974] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    STATE(4233), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2468), 8,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(2466), 9,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      sym_identifier,
  [96023] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    STATE(4234), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2516), 8,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(2514), 9,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      sym_identifier,
  [96072] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    STATE(4235), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2565), 8,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(2563), 9,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      sym_identifier,
  [96121] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6516), 1,
      anon_sym_or,
    STATE(4232), 1,
      aux_sym_type_argument_repeat1,
    ACTIONS(2328), 4,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      sym_identifier,
    STATE(4236), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2330), 11,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [96174] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6518), 1,
      anon_sym_or,
    STATE(4241), 1,
      aux_sym_type_argument_repeat1,
    ACTIONS(2328), 4,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      sym_identifier,
    STATE(4237), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2330), 11,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [96227] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6151), 1,
      sym_identifier,
    ACTIONS(6520), 1,
      anon_sym_DASH_GT,
    ACTIONS(6522), 1,
      anon_sym_STAR,
    ACTIONS(6524), 1,
      anon_sym_LT2,
    ACTIONS(6526), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4463), 1,
      aux_sym_compound_type_repeat1,
    STATE(4474), 1,
      sym_long_identifier,
    STATE(4479), 1,
      sym_type_arguments,
    ACTIONS(2246), 3,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
    STATE(4238), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2244), 6,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
  [96292] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6151), 1,
      sym_identifier,
    ACTIONS(6520), 1,
      anon_sym_DASH_GT,
    ACTIONS(6522), 1,
      anon_sym_STAR,
    ACTIONS(6524), 1,
      anon_sym_LT2,
    ACTIONS(6526), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4463), 1,
      aux_sym_compound_type_repeat1,
    STATE(4474), 1,
      sym_long_identifier,
    STATE(4479), 1,
      sym_type_arguments,
    ACTIONS(2250), 3,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
    STATE(4239), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2248), 6,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
  [96357] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6528), 1,
      anon_sym_or,
    STATE(4244), 1,
      aux_sym_type_argument_repeat1,
    ACTIONS(2328), 4,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_when,
      sym_identifier,
    STATE(4240), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2330), 11,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [96410] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6530), 1,
      anon_sym_or,
    ACTIONS(2340), 4,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      sym_identifier,
    STATE(4241), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_type_argument_repeat1,
    ACTIONS(2342), 11,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [96461] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6151), 1,
      sym_identifier,
    ACTIONS(6520), 1,
      anon_sym_DASH_GT,
    ACTIONS(6522), 1,
      anon_sym_STAR,
    ACTIONS(6524), 1,
      anon_sym_LT2,
    ACTIONS(6526), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4463), 1,
      aux_sym_compound_type_repeat1,
    STATE(4474), 1,
      sym_long_identifier,
    STATE(4479), 1,
      sym_type_arguments,
    ACTIONS(2230), 3,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
    STATE(4242), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2228), 6,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
  [96526] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    STATE(4243), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2472), 8,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(2470), 9,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      sym_identifier,
  [96575] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6533), 1,
      anon_sym_or,
    ACTIONS(2340), 4,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_when,
      sym_identifier,
    STATE(4244), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_type_argument_repeat1,
    ACTIONS(2342), 11,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [96626] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    STATE(4245), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2555), 8,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(2553), 9,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      sym_identifier,
  [96675] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    STATE(4246), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2462), 5,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_when,
      anon_sym_or,
      sym_identifier,
    ACTIONS(2464), 12,
      sym__newline,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [96724] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    STATE(4247), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2456), 8,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(2454), 9,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      sym_identifier,
  [96773] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    STATE(4248), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2476), 8,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(2474), 9,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      sym_identifier,
  [96822] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6083), 1,
      sym_identifier,
    ACTIONS(6481), 1,
      anon_sym_DASH_GT,
    ACTIONS(6485), 1,
      anon_sym_STAR,
    ACTIONS(6487), 1,
      anon_sym_LT2,
    ACTIONS(6489), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4436), 1,
      aux_sym_compound_type_repeat1,
    STATE(4508), 1,
      sym_long_identifier,
    STATE(4518), 1,
      sym_type_arguments,
    ACTIONS(2230), 3,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_when,
    STATE(4249), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2228), 6,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
  [96887] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6069), 1,
      sym_identifier,
    ACTIONS(6536), 1,
      anon_sym_DASH_GT,
    ACTIONS(6538), 1,
      anon_sym_STAR,
    ACTIONS(6540), 1,
      anon_sym_LT2,
    ACTIONS(6542), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4403), 1,
      aux_sym_compound_type_repeat1,
    STATE(4544), 1,
      sym_long_identifier,
    STATE(4563), 1,
      sym_type_arguments,
    ACTIONS(5009), 3,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
    STATE(4250), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5011), 6,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
  [96952] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6069), 1,
      sym_identifier,
    ACTIONS(6536), 1,
      anon_sym_DASH_GT,
    ACTIONS(6538), 1,
      anon_sym_STAR,
    ACTIONS(6540), 1,
      anon_sym_LT2,
    ACTIONS(6542), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4403), 1,
      aux_sym_compound_type_repeat1,
    STATE(4544), 1,
      sym_long_identifier,
    STATE(4563), 1,
      sym_type_arguments,
    ACTIONS(5013), 3,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
    STATE(4251), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5015), 6,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
  [97017] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    STATE(4252), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2508), 8,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
    ACTIONS(2506), 9,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
  [97066] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    STATE(4253), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2512), 8,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(2510), 9,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      sym_identifier,
  [97115] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2411), 1,
      anon_sym_COLON,
    ACTIONS(6544), 1,
      anon_sym_DOT,
    STATE(4254), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_long_identifier_repeat1,
    ACTIONS(2413), 14,
      ts_builtin_sym_end,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_in,
      anon_sym_DASH_GT,
      anon_sym_when,
      anon_sym_LT2,
      anon_sym_val,
  [97166] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6547), 1,
      anon_sym_DOT,
    ACTIONS(2411), 4,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      sym_identifier,
    STATE(4255), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_long_identifier_repeat1,
    ACTIONS(2413), 11,
      sym__newline,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [97217] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    STATE(4256), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2472), 8,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
    ACTIONS(2470), 9,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
  [97266] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    STATE(4257), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2456), 8,
      anon_sym_LBRACK_PIPE,
      anon_sym_LBRACE,
      aux_sym_char_token1,
      anon_sym_AT_DQUOTE,
      anon_sym_DOLLAR_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      sym_unit,
      sym_xint,
    ACTIONS(2454), 9,
      anon_sym_LPAREN,
      anon_sym_null,
      anon_sym__,
      anon_sym_LBRACK,
      anon_sym_DOLLAR_DQUOTE,
      anon_sym_DQUOTE,
      sym_bool,
      sym_int,
      sym_identifier,
  [97315] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6550), 1,
      anon_sym_or,
    STATE(4267), 1,
      aux_sym_type_argument_repeat1,
    ACTIONS(2321), 3,
      anon_sym_COLON,
      anon_sym_as,
      sym_identifier,
    STATE(4258), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2323), 12,
      sym__newline,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [97368] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6552), 1,
      anon_sym_LT2,
    STATE(4259), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2559), 7,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(2557), 9,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      sym_identifier,
  [97419] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5955), 1,
      sym_identifier,
    ACTIONS(6501), 1,
      anon_sym_DASH_GT,
    ACTIONS(6503), 1,
      anon_sym_STAR,
    ACTIONS(6505), 1,
      anon_sym_LT2,
    ACTIONS(6507), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4449), 1,
      aux_sym_compound_type_repeat1,
    STATE(4495), 1,
      sym_long_identifier,
    STATE(4499), 1,
      sym_type_arguments,
    ACTIONS(2242), 2,
      anon_sym_COLON,
      anon_sym_as,
    STATE(4260), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2240), 7,
      sym__newline,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
  [97484] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2418), 1,
      anon_sym_COLON,
    ACTIONS(6554), 1,
      anon_sym_DOT,
    STATE(4254), 1,
      aux_sym_long_identifier_repeat1,
    STATE(4261), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2420), 14,
      ts_builtin_sym_end,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_in,
      anon_sym_DASH_GT,
      anon_sym_when,
      anon_sym_LT2,
      anon_sym_val,
  [97537] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6556), 1,
      anon_sym_or,
    STATE(4283), 1,
      aux_sym_type_argument_repeat1,
    ACTIONS(2328), 4,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_when,
      sym_identifier,
    STATE(4262), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2330), 11,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [97590] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    STATE(4263), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2569), 8,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(2567), 9,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      sym_identifier,
  [97639] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6083), 1,
      sym_identifier,
    ACTIONS(6481), 1,
      anon_sym_DASH_GT,
    ACTIONS(6485), 1,
      anon_sym_STAR,
    ACTIONS(6487), 1,
      anon_sym_LT2,
    ACTIONS(6489), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4436), 1,
      aux_sym_compound_type_repeat1,
    STATE(4508), 1,
      sym_long_identifier,
    STATE(4518), 1,
      sym_type_arguments,
    ACTIONS(2250), 3,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_when,
    STATE(4264), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2248), 6,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
  [97704] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6083), 1,
      sym_identifier,
    ACTIONS(6481), 1,
      anon_sym_DASH_GT,
    ACTIONS(6485), 1,
      anon_sym_STAR,
    ACTIONS(6487), 1,
      anon_sym_LT2,
    ACTIONS(6489), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4436), 1,
      aux_sym_compound_type_repeat1,
    STATE(4508), 1,
      sym_long_identifier,
    STATE(4518), 1,
      sym_type_arguments,
    ACTIONS(2246), 3,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_when,
    STATE(4265), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2244), 6,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
  [97769] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6151), 1,
      sym_identifier,
    ACTIONS(6520), 1,
      anon_sym_DASH_GT,
    ACTIONS(6522), 1,
      anon_sym_STAR,
    ACTIONS(6524), 1,
      anon_sym_LT2,
    ACTIONS(6526), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4463), 1,
      aux_sym_compound_type_repeat1,
    STATE(4474), 1,
      sym_long_identifier,
    STATE(4479), 1,
      sym_type_arguments,
    ACTIONS(2242), 3,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
    STATE(4266), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2240), 6,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
  [97834] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6550), 1,
      anon_sym_or,
    STATE(4291), 1,
      aux_sym_type_argument_repeat1,
    ACTIONS(2328), 3,
      anon_sym_COLON,
      anon_sym_as,
      sym_identifier,
    STATE(4267), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2330), 12,
      sym__newline,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [97887] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    STATE(4268), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2629), 8,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(2627), 9,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      sym_identifier,
  [97936] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6516), 1,
      anon_sym_or,
    STATE(4236), 1,
      aux_sym_type_argument_repeat1,
    ACTIONS(2321), 4,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      sym_identifier,
    STATE(4269), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2323), 11,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [97989] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6203), 1,
      sym_identifier,
    ACTIONS(6471), 1,
      anon_sym_DASH_GT,
    ACTIONS(6475), 1,
      anon_sym_STAR,
    ACTIONS(6477), 1,
      anon_sym_LT2,
    ACTIONS(6479), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4429), 1,
      aux_sym_compound_type_repeat1,
    STATE(4531), 1,
      sym_type_arguments,
    STATE(4578), 1,
      sym_long_identifier,
    ACTIONS(2230), 3,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_when,
    STATE(4270), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2228), 6,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
  [98054] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6203), 1,
      sym_identifier,
    ACTIONS(6471), 1,
      anon_sym_DASH_GT,
    ACTIONS(6475), 1,
      anon_sym_STAR,
    ACTIONS(6477), 1,
      anon_sym_LT2,
    ACTIONS(6479), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4429), 1,
      aux_sym_compound_type_repeat1,
    STATE(4531), 1,
      sym_type_arguments,
    STATE(4578), 1,
      sym_long_identifier,
    ACTIONS(2250), 3,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_when,
    STATE(4271), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2248), 6,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
  [98119] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6203), 1,
      sym_identifier,
    ACTIONS(6471), 1,
      anon_sym_DASH_GT,
    ACTIONS(6475), 1,
      anon_sym_STAR,
    ACTIONS(6477), 1,
      anon_sym_LT2,
    ACTIONS(6479), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4429), 1,
      aux_sym_compound_type_repeat1,
    STATE(4531), 1,
      sym_type_arguments,
    STATE(4578), 1,
      sym_long_identifier,
    ACTIONS(2246), 3,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_when,
    STATE(4272), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2244), 6,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
  [98184] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6518), 1,
      anon_sym_or,
    STATE(4237), 1,
      aux_sym_type_argument_repeat1,
    ACTIONS(2321), 4,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      sym_identifier,
    STATE(4273), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2323), 11,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [98237] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6069), 1,
      sym_identifier,
    ACTIONS(6536), 1,
      anon_sym_DASH_GT,
    ACTIONS(6538), 1,
      anon_sym_STAR,
    ACTIONS(6540), 1,
      anon_sym_LT2,
    ACTIONS(6542), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4403), 1,
      aux_sym_compound_type_repeat1,
    STATE(4544), 1,
      sym_long_identifier,
    STATE(4563), 1,
      sym_type_arguments,
    ACTIONS(2242), 3,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
    STATE(4274), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2240), 6,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
  [98302] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5955), 1,
      sym_identifier,
    ACTIONS(6501), 1,
      anon_sym_DASH_GT,
    ACTIONS(6503), 1,
      anon_sym_STAR,
    ACTIONS(6505), 1,
      anon_sym_LT2,
    ACTIONS(6507), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4449), 1,
      aux_sym_compound_type_repeat1,
    STATE(4495), 1,
      sym_long_identifier,
    STATE(4499), 1,
      sym_type_arguments,
    ACTIONS(2250), 2,
      anon_sym_COLON,
      anon_sym_as,
    STATE(4275), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2248), 7,
      sym__newline,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
  [98367] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6203), 1,
      sym_identifier,
    ACTIONS(6471), 1,
      anon_sym_DASH_GT,
    ACTIONS(6475), 1,
      anon_sym_STAR,
    ACTIONS(6477), 1,
      anon_sym_LT2,
    ACTIONS(6479), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4429), 1,
      aux_sym_compound_type_repeat1,
    STATE(4531), 1,
      sym_type_arguments,
    STATE(4578), 1,
      sym_long_identifier,
    ACTIONS(2242), 3,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_when,
    STATE(4276), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2240), 6,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
  [98432] = 20,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6203), 1,
      sym_identifier,
    ACTIONS(6471), 1,
      anon_sym_DASH_GT,
    ACTIONS(6475), 1,
      anon_sym_STAR,
    ACTIONS(6477), 1,
      anon_sym_LT2,
    ACTIONS(6479), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(6558), 1,
      anon_sym_when,
    STATE(4429), 1,
      aux_sym_compound_type_repeat1,
    STATE(4531), 1,
      sym_type_arguments,
    STATE(4578), 1,
      sym_long_identifier,
    STATE(4737), 1,
      sym_type_argument_constraints,
    ACTIONS(4953), 2,
      anon_sym_COLON,
      anon_sym_as,
    STATE(4277), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4951), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
  [98501] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6069), 1,
      sym_identifier,
    ACTIONS(6536), 1,
      anon_sym_DASH_GT,
    ACTIONS(6538), 1,
      anon_sym_STAR,
    ACTIONS(6540), 1,
      anon_sym_LT2,
    ACTIONS(6542), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4403), 1,
      aux_sym_compound_type_repeat1,
    STATE(4544), 1,
      sym_long_identifier,
    STATE(4563), 1,
      sym_type_arguments,
    ACTIONS(2246), 3,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
    STATE(4278), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2244), 6,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
  [98566] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6069), 1,
      sym_identifier,
    ACTIONS(6536), 1,
      anon_sym_DASH_GT,
    ACTIONS(6538), 1,
      anon_sym_STAR,
    ACTIONS(6540), 1,
      anon_sym_LT2,
    ACTIONS(6542), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4403), 1,
      aux_sym_compound_type_repeat1,
    STATE(4544), 1,
      sym_long_identifier,
    STATE(4563), 1,
      sym_type_arguments,
    ACTIONS(2250), 3,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
    STATE(4279), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2248), 6,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
  [98631] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6556), 1,
      anon_sym_or,
    STATE(4262), 1,
      aux_sym_type_argument_repeat1,
    ACTIONS(2321), 4,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_when,
      sym_identifier,
    STATE(4280), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2323), 11,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [98684] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6069), 1,
      sym_identifier,
    ACTIONS(6536), 1,
      anon_sym_DASH_GT,
    ACTIONS(6538), 1,
      anon_sym_STAR,
    ACTIONS(6540), 1,
      anon_sym_LT2,
    ACTIONS(6542), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4403), 1,
      aux_sym_compound_type_repeat1,
    STATE(4544), 1,
      sym_long_identifier,
    STATE(4563), 1,
      sym_type_arguments,
    ACTIONS(2230), 3,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
    STATE(4281), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2228), 6,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
  [98749] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6528), 1,
      anon_sym_or,
    STATE(4240), 1,
      aux_sym_type_argument_repeat1,
    ACTIONS(2321), 4,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_when,
      sym_identifier,
    STATE(4282), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2323), 11,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [98802] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6560), 1,
      anon_sym_or,
    ACTIONS(2340), 4,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_when,
      sym_identifier,
    STATE(4283), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_type_argument_repeat1,
    ACTIONS(2342), 11,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [98853] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5955), 1,
      sym_identifier,
    ACTIONS(6501), 1,
      anon_sym_DASH_GT,
    ACTIONS(6503), 1,
      anon_sym_STAR,
    ACTIONS(6505), 1,
      anon_sym_LT2,
    ACTIONS(6507), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4449), 1,
      aux_sym_compound_type_repeat1,
    STATE(4495), 1,
      sym_long_identifier,
    STATE(4499), 1,
      sym_type_arguments,
    ACTIONS(2230), 2,
      anon_sym_COLON,
      anon_sym_as,
    STATE(4284), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2228), 7,
      sym__newline,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
  [98918] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6563), 1,
      anon_sym_DOT,
    ACTIONS(2411), 4,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_when,
      sym_identifier,
    STATE(4285), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_long_identifier_repeat1,
    ACTIONS(2413), 11,
      sym__newline,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [98969] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6083), 1,
      sym_identifier,
    ACTIONS(6481), 1,
      anon_sym_DASH_GT,
    ACTIONS(6485), 1,
      anon_sym_STAR,
    ACTIONS(6487), 1,
      anon_sym_LT2,
    ACTIONS(6489), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4436), 1,
      aux_sym_compound_type_repeat1,
    STATE(4508), 1,
      sym_long_identifier,
    STATE(4518), 1,
      sym_type_arguments,
    ACTIONS(2242), 3,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_when,
    STATE(4286), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2240), 6,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
  [99034] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    STATE(4287), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2340), 5,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_or,
      sym_identifier,
    ACTIONS(2342), 12,
      sym__newline,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [99083] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6511), 1,
      anon_sym_DOT,
    STATE(4230), 1,
      aux_sym_long_identifier_repeat1,
    ACTIONS(2312), 4,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      sym_identifier,
    STATE(4288), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2314), 11,
      sym__newline,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [99136] = 20,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6001), 1,
      sym_identifier,
    ACTIONS(6566), 1,
      anon_sym_DASH_GT,
    ACTIONS(6568), 1,
      anon_sym_when,
    ACTIONS(6570), 1,
      anon_sym_STAR,
    ACTIONS(6572), 1,
      anon_sym_LT2,
    ACTIONS(6574), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4572), 1,
      aux_sym_compound_type_repeat1,
    STATE(4608), 1,
      sym_type_arguments,
    STATE(4623), 1,
      sym_long_identifier,
    STATE(4737), 1,
      sym_type_argument_constraints,
    ACTIONS(4953), 3,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_in,
    ACTIONS(4951), 4,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(4289), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [99205] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    STATE(4290), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2508), 8,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(2506), 9,
      anon_sym_new,
      anon_sym_with,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      sym_identifier,
  [99254] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6576), 1,
      anon_sym_or,
    ACTIONS(2340), 3,
      anon_sym_COLON,
      anon_sym_as,
      sym_identifier,
    STATE(4291), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_type_argument_repeat1,
    ACTIONS(2342), 12,
      sym__newline,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [99305] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2312), 1,
      anon_sym_COLON,
    ACTIONS(6554), 1,
      anon_sym_DOT,
    STATE(4261), 1,
      aux_sym_long_identifier_repeat1,
    STATE(4292), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2314), 14,
      ts_builtin_sym_end,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_in,
      anon_sym_DASH_GT,
      anon_sym_when,
      anon_sym_LT2,
      anon_sym_val,
  [99358] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6509), 1,
      anon_sym_DOT,
    STATE(4285), 1,
      aux_sym_long_identifier_repeat1,
    ACTIONS(2418), 4,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_when,
      sym_identifier,
    STATE(4293), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2420), 11,
      sym__newline,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [99411] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6151), 1,
      sym_identifier,
    ACTIONS(6520), 1,
      anon_sym_DASH_GT,
    ACTIONS(6522), 1,
      anon_sym_STAR,
    ACTIONS(6524), 1,
      anon_sym_LT2,
    ACTIONS(6526), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4463), 1,
      aux_sym_compound_type_repeat1,
    STATE(4474), 1,
      sym_long_identifier,
    STATE(4479), 1,
      sym_type_arguments,
    ACTIONS(5013), 3,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
    STATE(4294), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5015), 6,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
  [99476] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6151), 1,
      sym_identifier,
    ACTIONS(6520), 1,
      anon_sym_DASH_GT,
    ACTIONS(6522), 1,
      anon_sym_STAR,
    ACTIONS(6524), 1,
      anon_sym_LT2,
    ACTIONS(6526), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4463), 1,
      aux_sym_compound_type_repeat1,
    STATE(4474), 1,
      sym_long_identifier,
    STATE(4479), 1,
      sym_type_arguments,
    ACTIONS(5009), 3,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
    STATE(4295), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5011), 6,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
  [99541] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    STATE(4296), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2462), 5,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_or,
      sym_identifier,
    ACTIONS(2464), 12,
      sym__newline,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [99590] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5955), 1,
      sym_identifier,
    ACTIONS(6501), 1,
      anon_sym_DASH_GT,
    ACTIONS(6503), 1,
      anon_sym_STAR,
    ACTIONS(6505), 1,
      anon_sym_LT2,
    ACTIONS(6507), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4449), 1,
      aux_sym_compound_type_repeat1,
    STATE(4495), 1,
      sym_long_identifier,
    STATE(4499), 1,
      sym_type_arguments,
    ACTIONS(2246), 2,
      anon_sym_COLON,
      anon_sym_as,
    STATE(4297), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2244), 7,
      sym__newline,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
  [99655] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6579), 1,
      anon_sym_or,
    STATE(4360), 1,
      aux_sym_type_argument_repeat1,
    STATE(4298), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2321), 5,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_in,
      sym_identifier,
    ACTIONS(2323), 9,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [99707] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2462), 4,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_or,
      sym_identifier,
    STATE(4299), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2464), 12,
      sym__newline,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [99755] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6305), 1,
      sym_identifier,
    ACTIONS(6581), 1,
      anon_sym_DASH_GT,
    ACTIONS(6583), 1,
      anon_sym_STAR,
    ACTIONS(6585), 1,
      anon_sym_LT2,
    ACTIONS(6587), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4511), 1,
      aux_sym_compound_type_repeat1,
    STATE(4586), 1,
      sym_long_identifier,
    STATE(4706), 1,
      sym_type_arguments,
    ACTIONS(2240), 4,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(2242), 4,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_in,
    STATE(4300), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [99819] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6259), 1,
      sym_identifier,
    ACTIONS(6589), 1,
      anon_sym_STAR,
    ACTIONS(6591), 1,
      anon_sym_LT2,
    ACTIONS(6593), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4502), 1,
      aux_sym_compound_type_repeat1,
    STATE(4679), 1,
      sym_long_identifier,
    STATE(4681), 1,
      sym_type_arguments,
    ACTIONS(5009), 4,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_when,
    STATE(4301), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5011), 5,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
  [99881] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6595), 1,
      anon_sym_STAR,
    ACTIONS(2250), 4,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      sym_identifier,
    STATE(4302), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_compound_type_repeat1,
    ACTIONS(2248), 10,
      sym__newline,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [99931] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2340), 4,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_or,
      sym_identifier,
    STATE(4303), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2342), 12,
      sym__newline,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [99979] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6413), 1,
      anon_sym_STAR,
    STATE(4302), 1,
      aux_sym_compound_type_repeat1,
    ACTIONS(2407), 4,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      sym_identifier,
    STATE(4304), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2409), 10,
      sym__newline,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [100031] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(23), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    STATE(4333), 1,
      aux_sym_attributes_repeat1,
    STATE(4488), 1,
      sym__attribute_set,
    ACTIONS(5800), 3,
      aux_sym_access_modifier_token1,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4305), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5798), 10,
      anon_sym_mutable,
      anon_sym__,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      sym_identifier,
  [100085] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2411), 4,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      sym_identifier,
    STATE(4306), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2413), 12,
      sym__newline,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [100133] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2321), 4,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      sym_identifier,
    STATE(4307), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2323), 12,
      sym__newline,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [100181] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6069), 1,
      sym_identifier,
    ACTIONS(6536), 1,
      anon_sym_DASH_GT,
    ACTIONS(6538), 1,
      anon_sym_STAR,
    ACTIONS(6542), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4403), 1,
      aux_sym_compound_type_repeat1,
    STATE(4544), 1,
      sym_long_identifier,
    STATE(4563), 1,
      sym_type_arguments,
    ACTIONS(5013), 3,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
    STATE(4308), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5015), 6,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT2,
  [100243] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6057), 1,
      sym_identifier,
    ACTIONS(6598), 1,
      anon_sym_DASH_GT,
    ACTIONS(6600), 1,
      anon_sym_STAR,
    ACTIONS(6602), 1,
      anon_sym_LT2,
    ACTIONS(6604), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4534), 1,
      aux_sym_compound_type_repeat1,
    STATE(4589), 1,
      sym_long_identifier,
    STATE(4669), 1,
      sym_type_arguments,
    ACTIONS(5057), 2,
      anon_sym_COLON,
      anon_sym_as,
    STATE(4309), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5055), 6,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
  [100307] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2411), 4,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_when,
      sym_identifier,
    STATE(4310), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2413), 12,
      sym__newline,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [100355] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6069), 1,
      sym_identifier,
    ACTIONS(6536), 1,
      anon_sym_DASH_GT,
    ACTIONS(6538), 1,
      anon_sym_STAR,
    ACTIONS(6542), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4403), 1,
      aux_sym_compound_type_repeat1,
    STATE(4544), 1,
      sym_long_identifier,
    STATE(4563), 1,
      sym_type_arguments,
    ACTIONS(5009), 3,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
    STATE(4311), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5011), 6,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT2,
  [100417] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6001), 1,
      sym_identifier,
    ACTIONS(6566), 1,
      anon_sym_DASH_GT,
    ACTIONS(6570), 1,
      anon_sym_STAR,
    ACTIONS(6572), 1,
      anon_sym_LT2,
    ACTIONS(6574), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4572), 1,
      aux_sym_compound_type_repeat1,
    STATE(4608), 1,
      sym_type_arguments,
    STATE(4623), 1,
      sym_long_identifier,
    ACTIONS(2228), 4,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(2230), 4,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_in,
      anon_sym_when,
    STATE(4312), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [100481] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6606), 1,
      anon_sym_COLON_GT,
    ACTIONS(2567), 4,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_when,
      sym_identifier,
    STATE(4313), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2569), 11,
      sym__newline,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [100531] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6403), 1,
      anon_sym_STAR,
    STATE(4349), 1,
      aux_sym_compound_type_repeat1,
    ACTIONS(2407), 4,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_when,
      sym_identifier,
    STATE(4314), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2409), 10,
      sym__newline,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [100583] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6608), 1,
      anon_sym_or,
    STATE(4377), 1,
      aux_sym_type_argument_repeat1,
    STATE(4315), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2321), 5,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_in,
      anon_sym_when,
      sym_identifier,
    ACTIONS(2323), 9,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [100635] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6610), 1,
      anon_sym_DOT,
    STATE(4320), 1,
      aux_sym_long_identifier_repeat1,
    ACTIONS(2418), 4,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_when,
      sym_identifier,
    STATE(4316), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2420), 10,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [100687] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6612), 1,
      anon_sym_or,
    ACTIONS(2340), 5,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_in,
      anon_sym_when,
      sym_identifier,
    STATE(4317), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_type_argument_repeat1,
    ACTIONS(2342), 9,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [100737] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6259), 1,
      sym_identifier,
    ACTIONS(6589), 1,
      anon_sym_STAR,
    ACTIONS(6591), 1,
      anon_sym_LT2,
    ACTIONS(6593), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(6615), 1,
      anon_sym_DASH_GT,
    STATE(4502), 1,
      aux_sym_compound_type_repeat1,
    STATE(4679), 1,
      sym_long_identifier,
    STATE(4681), 1,
      sym_type_arguments,
    ACTIONS(2228), 4,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(2230), 4,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_when,
    STATE(4318), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [100801] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6617), 1,
      anon_sym_or,
    ACTIONS(2340), 5,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_when,
      sym_identifier,
    STATE(4319), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_type_argument_repeat1,
    ACTIONS(2342), 9,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [100851] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6620), 1,
      anon_sym_DOT,
    ACTIONS(2411), 4,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_when,
      sym_identifier,
    STATE(4320), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_long_identifier_repeat1,
    ACTIONS(2413), 10,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [100901] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6623), 1,
      anon_sym_DOT,
    ACTIONS(2411), 3,
      anon_sym_COLON,
      anon_sym_as,
      sym_identifier,
    STATE(4321), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_long_identifier_repeat1,
    ACTIONS(2413), 11,
      sym__newline,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [100951] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6305), 1,
      sym_identifier,
    ACTIONS(6581), 1,
      anon_sym_DASH_GT,
    ACTIONS(6583), 1,
      anon_sym_STAR,
    ACTIONS(6585), 1,
      anon_sym_LT2,
    ACTIONS(6587), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4511), 1,
      aux_sym_compound_type_repeat1,
    STATE(4586), 1,
      sym_long_identifier,
    STATE(4706), 1,
      sym_type_arguments,
    ACTIONS(2244), 4,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(2246), 4,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_in,
    STATE(4322), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [101015] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    STATE(4323), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2340), 5,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_when,
      anon_sym_or,
      sym_identifier,
    ACTIONS(2342), 11,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [101063] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6259), 1,
      sym_identifier,
    ACTIONS(6589), 1,
      anon_sym_STAR,
    ACTIONS(6591), 1,
      anon_sym_LT2,
    ACTIONS(6593), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(6615), 1,
      anon_sym_DASH_GT,
    STATE(4502), 1,
      aux_sym_compound_type_repeat1,
    STATE(4679), 1,
      sym_long_identifier,
    STATE(4681), 1,
      sym_type_arguments,
    ACTIONS(2248), 4,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(2250), 4,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_when,
    STATE(4324), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [101127] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6259), 1,
      sym_identifier,
    ACTIONS(6589), 1,
      anon_sym_STAR,
    ACTIONS(6591), 1,
      anon_sym_LT2,
    ACTIONS(6593), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(6615), 1,
      anon_sym_DASH_GT,
    STATE(4502), 1,
      aux_sym_compound_type_repeat1,
    STATE(4679), 1,
      sym_long_identifier,
    STATE(4681), 1,
      sym_type_arguments,
    ACTIONS(2244), 4,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(2246), 4,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_when,
    STATE(4325), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [101191] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6626), 1,
      anon_sym_or,
    STATE(4334), 1,
      aux_sym_type_argument_repeat1,
    ACTIONS(2328), 3,
      anon_sym_COLON,
      anon_sym_as,
      sym_identifier,
    STATE(4326), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2330), 11,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [101243] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6259), 1,
      sym_identifier,
    ACTIONS(6589), 1,
      anon_sym_STAR,
    ACTIONS(6591), 1,
      anon_sym_LT2,
    ACTIONS(6593), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4502), 1,
      aux_sym_compound_type_repeat1,
    STATE(4679), 1,
      sym_long_identifier,
    STATE(4681), 1,
      sym_type_arguments,
    ACTIONS(5013), 4,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_when,
    STATE(4327), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5015), 5,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
  [101305] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6305), 1,
      sym_identifier,
    ACTIONS(6581), 1,
      anon_sym_DASH_GT,
    ACTIONS(6583), 1,
      anon_sym_STAR,
    ACTIONS(6585), 1,
      anon_sym_LT2,
    ACTIONS(6587), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4511), 1,
      aux_sym_compound_type_repeat1,
    STATE(4586), 1,
      sym_long_identifier,
    STATE(4706), 1,
      sym_type_arguments,
    ACTIONS(2248), 4,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(2250), 4,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_in,
    STATE(4328), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [101369] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6305), 1,
      sym_identifier,
    ACTIONS(6581), 1,
      anon_sym_DASH_GT,
    ACTIONS(6583), 1,
      anon_sym_STAR,
    ACTIONS(6585), 1,
      anon_sym_LT2,
    ACTIONS(6587), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4511), 1,
      aux_sym_compound_type_repeat1,
    STATE(4586), 1,
      sym_long_identifier,
    STATE(4706), 1,
      sym_type_arguments,
    ACTIONS(2228), 4,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(2230), 4,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_in,
    STATE(4329), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [101433] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6001), 1,
      sym_identifier,
    ACTIONS(6566), 1,
      anon_sym_DASH_GT,
    ACTIONS(6570), 1,
      anon_sym_STAR,
    ACTIONS(6572), 1,
      anon_sym_LT2,
    ACTIONS(6574), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4572), 1,
      aux_sym_compound_type_repeat1,
    STATE(4608), 1,
      sym_type_arguments,
    STATE(4623), 1,
      sym_long_identifier,
    ACTIONS(2248), 4,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(2250), 4,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_in,
      anon_sym_when,
    STATE(4330), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [101497] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5989), 1,
      sym_identifier,
    ACTIONS(6628), 1,
      anon_sym_DASH_GT,
    ACTIONS(6630), 1,
      anon_sym_STAR,
    ACTIONS(6632), 1,
      anon_sym_LT2,
    ACTIONS(6634), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4555), 1,
      aux_sym_compound_type_repeat1,
    STATE(4652), 1,
      sym_type_arguments,
    STATE(4660), 1,
      sym_long_identifier,
    ACTIONS(2230), 2,
      anon_sym_COLON,
      anon_sym_as,
    STATE(4331), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2228), 6,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
  [101561] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6001), 1,
      sym_identifier,
    ACTIONS(6566), 1,
      anon_sym_DASH_GT,
    ACTIONS(6570), 1,
      anon_sym_STAR,
    ACTIONS(6572), 1,
      anon_sym_LT2,
    ACTIONS(6574), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4572), 1,
      aux_sym_compound_type_repeat1,
    STATE(4608), 1,
      sym_type_arguments,
    STATE(4623), 1,
      sym_long_identifier,
    ACTIONS(2244), 4,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(2246), 4,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_in,
      anon_sym_when,
    STATE(4332), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [101625] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6636), 1,
      anon_sym_LBRACK_LT,
    STATE(4488), 1,
      sym__attribute_set,
    ACTIONS(5766), 3,
      aux_sym_access_modifier_token1,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4333), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_attributes_repeat1,
    ACTIONS(5761), 10,
      anon_sym_mutable,
      anon_sym__,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      sym_identifier,
  [101677] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6639), 1,
      anon_sym_or,
    ACTIONS(2340), 3,
      anon_sym_COLON,
      anon_sym_as,
      sym_identifier,
    STATE(4334), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_type_argument_repeat1,
    ACTIONS(2342), 11,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [101727] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6642), 1,
      anon_sym_or,
    STATE(4362), 1,
      aux_sym_type_argument_repeat1,
    ACTIONS(2321), 3,
      anon_sym_COLON,
      anon_sym_as,
      sym_identifier,
    STATE(4335), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2323), 11,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [101779] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2411), 1,
      anon_sym_COLON,
    STATE(4336), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2413), 15,
      ts_builtin_sym_end,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DOT,
      anon_sym_in,
      anon_sym_DASH_GT,
      anon_sym_when,
      anon_sym_LT2,
      anon_sym_val,
  [101827] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2321), 4,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_when,
      sym_identifier,
    STATE(4337), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2323), 12,
      sym__newline,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [101875] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5989), 1,
      sym_identifier,
    ACTIONS(6628), 1,
      anon_sym_DASH_GT,
    ACTIONS(6630), 1,
      anon_sym_STAR,
    ACTIONS(6632), 1,
      anon_sym_LT2,
    ACTIONS(6634), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4555), 1,
      aux_sym_compound_type_repeat1,
    STATE(4652), 1,
      sym_type_arguments,
    STATE(4660), 1,
      sym_long_identifier,
    ACTIONS(2250), 2,
      anon_sym_COLON,
      anon_sym_as,
    STATE(4338), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2248), 6,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
  [101939] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6644), 1,
      anon_sym_or,
    STATE(4319), 1,
      aux_sym_type_argument_repeat1,
    STATE(4339), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2328), 5,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_when,
      sym_identifier,
    ACTIONS(2330), 9,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [101991] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5989), 1,
      sym_identifier,
    ACTIONS(6628), 1,
      anon_sym_DASH_GT,
    ACTIONS(6630), 1,
      anon_sym_STAR,
    ACTIONS(6632), 1,
      anon_sym_LT2,
    ACTIONS(6634), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4555), 1,
      aux_sym_compound_type_repeat1,
    STATE(4652), 1,
      sym_type_arguments,
    STATE(4660), 1,
      sym_long_identifier,
    ACTIONS(2246), 2,
      anon_sym_COLON,
      anon_sym_as,
    STATE(4340), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2244), 6,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
  [102055] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6646), 1,
      anon_sym_DOT,
    STATE(4351), 1,
      aux_sym_long_identifier_repeat1,
    ACTIONS(2418), 4,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_when,
      sym_identifier,
    STATE(4341), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2420), 10,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [102107] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6648), 1,
      anon_sym_DOT,
    ACTIONS(2411), 4,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      sym_identifier,
    STATE(4342), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_long_identifier_repeat1,
    ACTIONS(2413), 10,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [102157] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6651), 1,
      anon_sym_DOT,
    STATE(4342), 1,
      aux_sym_long_identifier_repeat1,
    ACTIONS(2418), 4,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      sym_identifier,
    STATE(4343), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2420), 10,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [102209] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    STATE(4344), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2462), 5,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_when,
      anon_sym_or,
      sym_identifier,
    ACTIONS(2464), 11,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [102257] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6001), 1,
      sym_identifier,
    ACTIONS(6566), 1,
      anon_sym_DASH_GT,
    ACTIONS(6570), 1,
      anon_sym_STAR,
    ACTIONS(6572), 1,
      anon_sym_LT2,
    ACTIONS(6574), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4572), 1,
      aux_sym_compound_type_repeat1,
    STATE(4608), 1,
      sym_type_arguments,
    STATE(4623), 1,
      sym_long_identifier,
    ACTIONS(2240), 4,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(2242), 4,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_in,
      anon_sym_when,
    STATE(4345), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [102321] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6653), 1,
      anon_sym_COLON_GT,
    ACTIONS(2567), 4,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      sym_identifier,
    STATE(4346), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2569), 11,
      sym__newline,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [102371] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6305), 1,
      sym_identifier,
    ACTIONS(6581), 1,
      anon_sym_DASH_GT,
    ACTIONS(6583), 1,
      anon_sym_STAR,
    ACTIONS(6585), 1,
      anon_sym_LT2,
    ACTIONS(6587), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4511), 1,
      aux_sym_compound_type_repeat1,
    STATE(4586), 1,
      sym_long_identifier,
    STATE(4706), 1,
      sym_type_arguments,
    ACTIONS(5013), 4,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_in,
    ACTIONS(5015), 4,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(4347), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [102435] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6305), 1,
      sym_identifier,
    ACTIONS(6581), 1,
      anon_sym_DASH_GT,
    ACTIONS(6583), 1,
      anon_sym_STAR,
    ACTIONS(6585), 1,
      anon_sym_LT2,
    ACTIONS(6587), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4511), 1,
      aux_sym_compound_type_repeat1,
    STATE(4586), 1,
      sym_long_identifier,
    STATE(4706), 1,
      sym_type_arguments,
    ACTIONS(5009), 4,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_in,
    ACTIONS(5011), 4,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(4348), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [102499] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6655), 1,
      anon_sym_STAR,
    ACTIONS(2250), 4,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_when,
      sym_identifier,
    STATE(4349), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_compound_type_repeat1,
    ACTIONS(2248), 10,
      sym__newline,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [102549] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6646), 1,
      anon_sym_DOT,
    STATE(4341), 1,
      aux_sym_long_identifier_repeat1,
    ACTIONS(2312), 4,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_when,
      sym_identifier,
    STATE(4350), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2314), 10,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [102601] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6658), 1,
      anon_sym_DOT,
    ACTIONS(2411), 4,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_when,
      sym_identifier,
    STATE(4351), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_long_identifier_repeat1,
    ACTIONS(2413), 10,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [102651] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6057), 1,
      sym_identifier,
    ACTIONS(6598), 1,
      anon_sym_DASH_GT,
    ACTIONS(6600), 1,
      anon_sym_STAR,
    ACTIONS(6602), 1,
      anon_sym_LT2,
    ACTIONS(6604), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4534), 1,
      aux_sym_compound_type_repeat1,
    STATE(4589), 1,
      sym_long_identifier,
    STATE(4669), 1,
      sym_type_arguments,
    ACTIONS(2242), 2,
      anon_sym_COLON,
      anon_sym_as,
    STATE(4352), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2240), 6,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
  [102715] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6661), 1,
      anon_sym_DOT,
    STATE(4355), 1,
      aux_sym_long_identifier_repeat1,
    ACTIONS(2418), 4,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      sym_identifier,
    STATE(4353), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2420), 10,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [102767] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6663), 1,
      anon_sym_DOT,
    STATE(4367), 1,
      aux_sym_long_identifier_repeat1,
    ACTIONS(2312), 3,
      anon_sym_COLON,
      anon_sym_as,
      sym_identifier,
    STATE(4354), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2314), 11,
      sym__newline,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [102819] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6665), 1,
      anon_sym_DOT,
    ACTIONS(2411), 4,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      sym_identifier,
    STATE(4355), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_long_identifier_repeat1,
    ACTIONS(2413), 10,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [102869] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6259), 1,
      sym_identifier,
    ACTIONS(6589), 1,
      anon_sym_STAR,
    ACTIONS(6591), 1,
      anon_sym_LT2,
    ACTIONS(6593), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(6615), 1,
      anon_sym_DASH_GT,
    STATE(4502), 1,
      aux_sym_compound_type_repeat1,
    STATE(4679), 1,
      sym_long_identifier,
    STATE(4681), 1,
      sym_type_arguments,
    ACTIONS(2240), 4,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(2242), 4,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_when,
    STATE(4356), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [102933] = 23,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(23), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6451), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6453), 1,
      anon_sym_new,
    ACTIONS(6457), 1,
      anon_sym_static,
    ACTIONS(6459), 1,
      anon_sym_member,
    ACTIONS(6461), 1,
      anon_sym_abstract,
    ACTIONS(6463), 1,
      anon_sym_val,
    STATE(4213), 1,
      sym_member_defn,
    STATE(4305), 1,
      aux_sym_attributes_repeat1,
    STATE(4488), 1,
      sym__attribute_set,
    STATE(4928), 1,
      sym_additional_constr_defn,
    STATE(4996), 1,
      sym_attributes,
    STATE(7292), 1,
      sym_access_modifier,
    STATE(7324), 1,
      sym__member_defns,
    ACTIONS(6455), 2,
      anon_sym_default,
      anon_sym_override,
    STATE(4357), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [103007] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6644), 1,
      anon_sym_or,
    STATE(4339), 1,
      aux_sym_type_argument_repeat1,
    STATE(4358), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2321), 5,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_when,
      sym_identifier,
    ACTIONS(2323), 9,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [103059] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6057), 1,
      sym_identifier,
    ACTIONS(6598), 1,
      anon_sym_DASH_GT,
    ACTIONS(6600), 1,
      anon_sym_STAR,
    ACTIONS(6602), 1,
      anon_sym_LT2,
    ACTIONS(6604), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4534), 1,
      aux_sym_compound_type_repeat1,
    STATE(4589), 1,
      sym_long_identifier,
    STATE(4669), 1,
      sym_type_arguments,
    ACTIONS(2230), 2,
      anon_sym_COLON,
      anon_sym_as,
    STATE(4359), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2228), 6,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
  [103123] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6579), 1,
      anon_sym_or,
    STATE(4369), 1,
      aux_sym_type_argument_repeat1,
    STATE(4360), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2328), 5,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_in,
      sym_identifier,
    ACTIONS(2330), 9,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [103175] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    STATE(4361), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2340), 5,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_when,
      anon_sym_or,
      sym_identifier,
    ACTIONS(2342), 11,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [103223] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6642), 1,
      anon_sym_or,
    STATE(4380), 1,
      aux_sym_type_argument_repeat1,
    ACTIONS(2328), 3,
      anon_sym_COLON,
      anon_sym_as,
      sym_identifier,
    STATE(4362), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2330), 11,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [103275] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    STATE(4363), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2340), 5,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_or,
      sym_identifier,
    ACTIONS(2342), 11,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [103323] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6057), 1,
      sym_identifier,
    ACTIONS(6598), 1,
      anon_sym_DASH_GT,
    ACTIONS(6600), 1,
      anon_sym_STAR,
    ACTIONS(6602), 1,
      anon_sym_LT2,
    ACTIONS(6604), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4534), 1,
      aux_sym_compound_type_repeat1,
    STATE(4589), 1,
      sym_long_identifier,
    STATE(4669), 1,
      sym_type_arguments,
    ACTIONS(2250), 2,
      anon_sym_COLON,
      anon_sym_as,
    STATE(4364), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2248), 6,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
  [103387] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6057), 1,
      sym_identifier,
    ACTIONS(6598), 1,
      anon_sym_DASH_GT,
    ACTIONS(6600), 1,
      anon_sym_STAR,
    ACTIONS(6602), 1,
      anon_sym_LT2,
    ACTIONS(6604), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4534), 1,
      aux_sym_compound_type_repeat1,
    STATE(4589), 1,
      sym_long_identifier,
    STATE(4669), 1,
      sym_type_arguments,
    ACTIONS(2246), 2,
      anon_sym_COLON,
      anon_sym_as,
    STATE(4365), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2244), 6,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
  [103451] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    STATE(4366), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2462), 5,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_or,
      sym_identifier,
    ACTIONS(2464), 11,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [103499] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6663), 1,
      anon_sym_DOT,
    STATE(4321), 1,
      aux_sym_long_identifier_repeat1,
    ACTIONS(2418), 3,
      anon_sym_COLON,
      anon_sym_as,
      sym_identifier,
    STATE(4367), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2420), 11,
      sym__newline,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [103551] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    STATE(4368), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2462), 5,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_or,
      sym_identifier,
    ACTIONS(2464), 11,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [103599] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6668), 1,
      anon_sym_or,
    ACTIONS(2340), 5,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_in,
      sym_identifier,
    STATE(4369), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_type_argument_repeat1,
    ACTIONS(2342), 9,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [103649] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    STATE(4370), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2462), 5,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_when,
      anon_sym_or,
      sym_identifier,
    ACTIONS(2464), 11,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [103697] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6203), 1,
      sym_identifier,
    ACTIONS(6471), 1,
      anon_sym_DASH_GT,
    ACTIONS(6475), 1,
      anon_sym_STAR,
    ACTIONS(6477), 1,
      anon_sym_LT2,
    ACTIONS(6479), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4429), 1,
      aux_sym_compound_type_repeat1,
    STATE(4531), 1,
      sym_type_arguments,
    STATE(4578), 1,
      sym_long_identifier,
    STATE(4737), 1,
      sym_type_argument_constraints,
    ACTIONS(4953), 3,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_when,
    ACTIONS(4951), 4,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(4371), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [103763] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6610), 1,
      anon_sym_DOT,
    STATE(4316), 1,
      aux_sym_long_identifier_repeat1,
    ACTIONS(2312), 4,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_when,
      sym_identifier,
    STATE(4372), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2314), 10,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [103815] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6661), 1,
      anon_sym_DOT,
    STATE(4353), 1,
      aux_sym_long_identifier_repeat1,
    ACTIONS(2312), 4,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      sym_identifier,
    STATE(4373), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2314), 10,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [103867] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    STATE(4374), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2340), 5,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_or,
      sym_identifier,
    ACTIONS(2342), 11,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [103915] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5989), 1,
      sym_identifier,
    ACTIONS(6628), 1,
      anon_sym_DASH_GT,
    ACTIONS(6630), 1,
      anon_sym_STAR,
    ACTIONS(6632), 1,
      anon_sym_LT2,
    ACTIONS(6634), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4555), 1,
      aux_sym_compound_type_repeat1,
    STATE(4652), 1,
      sym_type_arguments,
    STATE(4660), 1,
      sym_long_identifier,
    ACTIONS(5057), 2,
      anon_sym_COLON,
      anon_sym_as,
    STATE(4375), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5055), 6,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
  [103979] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6651), 1,
      anon_sym_DOT,
    STATE(4343), 1,
      aux_sym_long_identifier_repeat1,
    ACTIONS(2312), 4,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      sym_identifier,
    STATE(4376), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2314), 10,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [104031] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6608), 1,
      anon_sym_or,
    STATE(4317), 1,
      aux_sym_type_argument_repeat1,
    STATE(4377), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2328), 5,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_in,
      anon_sym_when,
      sym_identifier,
    ACTIONS(2330), 9,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [104083] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5989), 1,
      sym_identifier,
    ACTIONS(6628), 1,
      anon_sym_DASH_GT,
    ACTIONS(6630), 1,
      anon_sym_STAR,
    ACTIONS(6632), 1,
      anon_sym_LT2,
    ACTIONS(6634), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4555), 1,
      aux_sym_compound_type_repeat1,
    STATE(4652), 1,
      sym_type_arguments,
    STATE(4660), 1,
      sym_long_identifier,
    ACTIONS(2242), 2,
      anon_sym_COLON,
      anon_sym_as,
    STATE(4378), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2240), 6,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
  [104147] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6626), 1,
      anon_sym_or,
    STATE(4326), 1,
      aux_sym_type_argument_repeat1,
    ACTIONS(2321), 3,
      anon_sym_COLON,
      anon_sym_as,
      sym_identifier,
    STATE(4379), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2323), 11,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [104199] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6671), 1,
      anon_sym_or,
    ACTIONS(2340), 3,
      anon_sym_COLON,
      anon_sym_as,
      sym_identifier,
    STATE(4380), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_type_argument_repeat1,
    ACTIONS(2342), 11,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [104249] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6674), 1,
      anon_sym_DOT,
    ACTIONS(2411), 5,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_when,
      sym_identifier,
    STATE(4381), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_long_identifier_repeat1,
    ACTIONS(2413), 8,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [104298] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2340), 4,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_or,
      sym_identifier,
    STATE(4382), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2342), 11,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [104345] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6677), 1,
      anon_sym_STAR,
    ACTIONS(2250), 4,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_when,
      sym_identifier,
    STATE(4383), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_compound_type_repeat1,
    ACTIONS(2248), 9,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [104394] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2462), 4,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_or,
      sym_identifier,
    STATE(4384), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2464), 11,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [104441] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6247), 1,
      sym_identifier,
    ACTIONS(6680), 1,
      anon_sym_DASH_GT,
    ACTIONS(6682), 1,
      anon_sym_STAR,
    ACTIONS(6684), 1,
      anon_sym_LT2,
    ACTIONS(6686), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4604), 1,
      aux_sym_compound_type_repeat1,
    STATE(4713), 1,
      sym_long_identifier,
    STATE(4754), 1,
      sym_type_arguments,
    ACTIONS(2246), 3,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_in,
    ACTIONS(2244), 4,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(4385), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [104504] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6247), 1,
      sym_identifier,
    ACTIONS(6680), 1,
      anon_sym_DASH_GT,
    ACTIONS(6682), 1,
      anon_sym_STAR,
    ACTIONS(6684), 1,
      anon_sym_LT2,
    ACTIONS(6686), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4604), 1,
      aux_sym_compound_type_repeat1,
    STATE(4713), 1,
      sym_long_identifier,
    STATE(4754), 1,
      sym_type_arguments,
    ACTIONS(2250), 3,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_in,
    ACTIONS(2248), 4,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(4386), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [104567] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    STATE(4387), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2340), 6,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_in,
      anon_sym_or,
      sym_identifier,
    ACTIONS(2342), 9,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [104614] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6247), 1,
      sym_identifier,
    ACTIONS(6680), 1,
      anon_sym_DASH_GT,
    ACTIONS(6682), 1,
      anon_sym_STAR,
    ACTIONS(6684), 1,
      anon_sym_LT2,
    ACTIONS(6686), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4604), 1,
      aux_sym_compound_type_repeat1,
    STATE(4713), 1,
      sym_long_identifier,
    STATE(4754), 1,
      sym_type_arguments,
    ACTIONS(2230), 3,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_in,
    ACTIONS(2228), 4,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(4388), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [104677] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6688), 1,
      anon_sym_or,
    STATE(4438), 1,
      aux_sym_type_argument_repeat1,
    ACTIONS(2321), 4,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_in,
      sym_identifier,
    STATE(4389), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2323), 9,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [104728] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6690), 1,
      anon_sym_DOT,
    STATE(4428), 1,
      aux_sym_long_identifier_repeat1,
    ACTIONS(2418), 4,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_in,
      sym_identifier,
    STATE(4390), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2420), 9,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_EQ2,
  [104779] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2506), 4,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      sym_identifier,
    STATE(4391), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2508), 11,
      sym__newline,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [104826] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6692), 1,
      anon_sym_COLON_GT,
    ACTIONS(2567), 4,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_when,
      sym_identifier,
    STATE(4392), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2569), 10,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [104875] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6247), 1,
      sym_identifier,
    ACTIONS(6680), 1,
      anon_sym_DASH_GT,
    ACTIONS(6682), 1,
      anon_sym_STAR,
    ACTIONS(6684), 1,
      anon_sym_LT2,
    ACTIONS(6686), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4604), 1,
      aux_sym_compound_type_repeat1,
    STATE(4713), 1,
      sym_long_identifier,
    STATE(4754), 1,
      sym_type_arguments,
    ACTIONS(2242), 3,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_in,
    ACTIONS(2240), 4,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(4393), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [104938] = 22,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(23), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6451), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6453), 1,
      anon_sym_new,
    ACTIONS(6457), 1,
      anon_sym_static,
    ACTIONS(6459), 1,
      anon_sym_member,
    ACTIONS(6461), 1,
      anon_sym_abstract,
    ACTIONS(6463), 1,
      anon_sym_val,
    STATE(4305), 1,
      aux_sym_attributes_repeat1,
    STATE(4488), 1,
      sym__attribute_set,
    STATE(4908), 1,
      sym_member_defn,
    STATE(4928), 1,
      sym_additional_constr_defn,
    STATE(4996), 1,
      sym_attributes,
    STATE(7292), 1,
      sym_access_modifier,
    ACTIONS(6455), 2,
      anon_sym_default,
      anon_sym_override,
    STATE(4394), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [105009] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6694), 1,
      anon_sym_COLON_GT,
    ACTIONS(2567), 4,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      sym_identifier,
    STATE(4395), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2569), 10,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [105058] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6696), 1,
      anon_sym_DOT,
    ACTIONS(2411), 3,
      anon_sym_COLON,
      anon_sym_as,
      sym_identifier,
    STATE(4396), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_long_identifier_repeat1,
    ACTIONS(2413), 10,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [105107] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2470), 4,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_when,
      sym_identifier,
    STATE(4397), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2472), 11,
      sym__newline,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [105154] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6699), 1,
      anon_sym_DOT,
    STATE(4412), 1,
      aux_sym_long_identifier_repeat1,
    STATE(4398), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2418), 5,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_in,
      anon_sym_when,
      sym_identifier,
    ACTIONS(2420), 8,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [105205] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2321), 4,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      sym_identifier,
    STATE(4399), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2323), 11,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [105252] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6701), 1,
      anon_sym_DOT,
    STATE(4396), 1,
      aux_sym_long_identifier_repeat1,
    ACTIONS(2418), 3,
      anon_sym_COLON,
      anon_sym_as,
      sym_identifier,
    STATE(4400), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2420), 10,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [105303] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2411), 4,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_when,
      sym_identifier,
    STATE(4401), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2413), 11,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [105350] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2470), 4,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      sym_identifier,
    STATE(4402), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2472), 11,
      sym__newline,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [105397] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6538), 1,
      anon_sym_STAR,
    STATE(4426), 1,
      aux_sym_compound_type_repeat1,
    ACTIONS(2407), 4,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      sym_identifier,
    STATE(4403), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2409), 9,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [105448] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2567), 4,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      sym_identifier,
    STATE(4404), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2569), 11,
      sym__newline,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [105495] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    STATE(4405), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2462), 6,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_in,
      anon_sym_or,
      sym_identifier,
    ACTIONS(2464), 9,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [105542] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6703), 1,
      anon_sym_LT2,
    ACTIONS(2557), 4,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      sym_identifier,
    STATE(4406), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2559), 10,
      sym__newline,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LBRACK_RBRACK,
  [105591] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2474), 4,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      sym_identifier,
    STATE(4407), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2476), 11,
      sym__newline,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [105638] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2466), 4,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      sym_identifier,
    STATE(4408), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2468), 11,
      sym__newline,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [105685] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2819), 1,
      anon_sym_COLON,
    ACTIONS(6705), 1,
      sym_int,
    STATE(4409), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2821), 13,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_in,
      anon_sym_DASH_GT,
      anon_sym_when,
      anon_sym_LT2,
      anon_sym_f,
      aux_sym_decimal_token1,
  [105734] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2627), 4,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      sym_identifier,
    STATE(4410), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2629), 11,
      sym__newline,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [105781] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6707), 1,
      anon_sym_DOT,
    STATE(4471), 1,
      aux_sym_long_identifier_repeat1,
    STATE(4411), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2312), 5,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_in,
      sym_identifier,
    ACTIONS(2314), 8,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [105832] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6709), 1,
      anon_sym_DOT,
    ACTIONS(2411), 5,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_in,
      anon_sym_when,
      sym_identifier,
    STATE(4412), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_long_identifier_repeat1,
    ACTIONS(2413), 8,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [105881] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2514), 4,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      sym_identifier,
    STATE(4413), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2516), 11,
      sym__newline,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [105928] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6712), 1,
      anon_sym_DOT,
    STATE(4457), 1,
      aux_sym_long_identifier_repeat1,
    STATE(4414), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2312), 5,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_when,
      sym_identifier,
    ACTIONS(2314), 8,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [105979] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2454), 4,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      sym_identifier,
    STATE(4415), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2456), 11,
      sym__newline,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [106026] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2563), 4,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      sym_identifier,
    STATE(4416), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2565), 11,
      sym__newline,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [106073] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    STATE(4417), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2462), 6,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_when,
      anon_sym_or,
      sym_identifier,
    ACTIONS(2464), 9,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [106120] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2321), 3,
      anon_sym_COLON,
      anon_sym_as,
      sym_identifier,
    STATE(4418), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2323), 12,
      sym__newline,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [106167] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2553), 4,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      sym_identifier,
    STATE(4419), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2555), 11,
      sym__newline,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [106214] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2563), 4,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_when,
      sym_identifier,
    STATE(4420), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2565), 11,
      sym__newline,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [106261] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    STATE(4421), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2340), 6,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_when,
      anon_sym_or,
      sym_identifier,
    ACTIONS(2342), 9,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [106308] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6690), 1,
      anon_sym_DOT,
    STATE(4390), 1,
      aux_sym_long_identifier_repeat1,
    ACTIONS(2312), 4,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_in,
      sym_identifier,
    STATE(4422), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2314), 9,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_EQ2,
  [106359] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2340), 1,
      anon_sym_COLON,
    ACTIONS(6714), 1,
      anon_sym_or,
    STATE(4423), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_type_argument_repeat1,
    ACTIONS(2342), 12,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_in,
      anon_sym_DASH_GT,
      anon_sym_GT,
      anon_sym_when,
      anon_sym_LT2,
  [106408] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6247), 1,
      sym_identifier,
    ACTIONS(6680), 1,
      anon_sym_DASH_GT,
    ACTIONS(6682), 1,
      anon_sym_STAR,
    ACTIONS(6684), 1,
      anon_sym_LT2,
    ACTIONS(6686), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4604), 1,
      aux_sym_compound_type_repeat1,
    STATE(4713), 1,
      sym_long_identifier,
    STATE(4754), 1,
      sym_type_arguments,
    ACTIONS(5057), 3,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_in,
    ACTIONS(5055), 4,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(4424), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [106471] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2723), 1,
      anon_sym_COLON,
    ACTIONS(6717), 1,
      aux_sym_float_token1,
    STATE(4425), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2725), 13,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_in,
      anon_sym_DASH_GT,
      anon_sym_when,
      anon_sym_LT2,
      anon_sym_f,
      aux_sym_decimal_token1,
  [106520] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6719), 1,
      anon_sym_STAR,
    ACTIONS(2250), 4,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      sym_identifier,
    STATE(4426), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_compound_type_repeat1,
    ACTIONS(2248), 9,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [106569] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2328), 1,
      anon_sym_COLON,
    ACTIONS(6722), 1,
      anon_sym_or,
    STATE(4423), 1,
      aux_sym_type_argument_repeat1,
    STATE(4427), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2330), 12,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_in,
      anon_sym_DASH_GT,
      anon_sym_GT,
      anon_sym_when,
      anon_sym_LT2,
  [106620] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6724), 1,
      anon_sym_DOT,
    ACTIONS(2411), 4,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_in,
      sym_identifier,
    STATE(4428), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_long_identifier_repeat1,
    ACTIONS(2413), 9,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_EQ2,
  [106669] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6475), 1,
      anon_sym_STAR,
    STATE(4383), 1,
      aux_sym_compound_type_repeat1,
    ACTIONS(2407), 4,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_when,
      sym_identifier,
    STATE(4429), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2409), 9,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [106720] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6727), 1,
      anon_sym_COLON_GT,
    ACTIONS(2567), 4,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_when,
      sym_identifier,
    STATE(4430), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2569), 10,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [106769] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2506), 4,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_when,
      sym_identifier,
    STATE(4431), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2508), 11,
      sym__newline,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [106816] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2454), 4,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_when,
      sym_identifier,
    STATE(4432), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2456), 11,
      sym__newline,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [106863] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6701), 1,
      anon_sym_DOT,
    STATE(4400), 1,
      aux_sym_long_identifier_repeat1,
    ACTIONS(2312), 3,
      anon_sym_COLON,
      anon_sym_as,
      sym_identifier,
    STATE(4433), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2314), 10,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [106914] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2411), 4,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_when,
      sym_identifier,
    STATE(4434), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2413), 11,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [106961] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6729), 1,
      anon_sym_DOT,
    STATE(4439), 1,
      aux_sym_long_identifier_repeat1,
    ACTIONS(2418), 3,
      anon_sym_COLON,
      anon_sym_as,
      sym_identifier,
    STATE(4435), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2420), 10,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [107012] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6485), 1,
      anon_sym_STAR,
    STATE(4443), 1,
      aux_sym_compound_type_repeat1,
    ACTIONS(2407), 4,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_when,
      sym_identifier,
    STATE(4436), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2409), 9,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [107063] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2321), 4,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_when,
      sym_identifier,
    STATE(4437), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2323), 11,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [107110] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6688), 1,
      anon_sym_or,
    STATE(4444), 1,
      aux_sym_type_argument_repeat1,
    ACTIONS(2328), 4,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_in,
      sym_identifier,
    STATE(4438), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2330), 9,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [107161] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6731), 1,
      anon_sym_DOT,
    ACTIONS(2411), 3,
      anon_sym_COLON,
      anon_sym_as,
      sym_identifier,
    STATE(4439), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_long_identifier_repeat1,
    ACTIONS(2413), 10,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [107210] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2340), 4,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_or,
      sym_identifier,
    STATE(4440), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2342), 11,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [107257] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2321), 1,
      anon_sym_COLON,
    ACTIONS(6722), 1,
      anon_sym_or,
    STATE(4427), 1,
      aux_sym_type_argument_repeat1,
    STATE(4441), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2323), 12,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_in,
      anon_sym_DASH_GT,
      anon_sym_GT,
      anon_sym_when,
      anon_sym_LT2,
  [107308] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2462), 4,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_or,
      sym_identifier,
    STATE(4442), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2464), 11,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [107355] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6734), 1,
      anon_sym_STAR,
    ACTIONS(2250), 4,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_when,
      sym_identifier,
    STATE(4443), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_compound_type_repeat1,
    ACTIONS(2248), 9,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [107404] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6737), 1,
      anon_sym_or,
    ACTIONS(2340), 4,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_in,
      sym_identifier,
    STATE(4444), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_type_argument_repeat1,
    ACTIONS(2342), 9,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [107453] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6729), 1,
      anon_sym_DOT,
    STATE(4435), 1,
      aux_sym_long_identifier_repeat1,
    ACTIONS(2312), 3,
      anon_sym_COLON,
      anon_sym_as,
      sym_identifier,
    STATE(4445), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2314), 10,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [107504] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2321), 4,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_when,
      sym_identifier,
    STATE(4446), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2323), 11,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [107551] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6740), 1,
      anon_sym_COLON_GT,
    ACTIONS(2567), 3,
      anon_sym_COLON,
      anon_sym_as,
      sym_identifier,
    STATE(4447), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2569), 11,
      sym__newline,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [107600] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2411), 4,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      sym_identifier,
    STATE(4448), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2413), 11,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [107647] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6503), 1,
      anon_sym_STAR,
    STATE(4452), 1,
      aux_sym_compound_type_repeat1,
    ACTIONS(2407), 3,
      anon_sym_COLON,
      anon_sym_as,
      sym_identifier,
    STATE(4449), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2409), 10,
      sym__newline,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [107698] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2553), 4,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_when,
      sym_identifier,
    STATE(4450), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2555), 11,
      sym__newline,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [107745] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6699), 1,
      anon_sym_DOT,
    STATE(4398), 1,
      aux_sym_long_identifier_repeat1,
    STATE(4451), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2312), 5,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_in,
      anon_sym_when,
      sym_identifier,
    ACTIONS(2314), 8,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [107796] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6742), 1,
      anon_sym_STAR,
    ACTIONS(2250), 3,
      anon_sym_COLON,
      anon_sym_as,
      sym_identifier,
    STATE(4452), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_compound_type_repeat1,
    ACTIONS(2248), 10,
      sym__newline,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [107845] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2510), 4,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      sym_identifier,
    STATE(4453), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2512), 11,
      sym__newline,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [107892] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    STATE(4454), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2462), 6,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_in,
      anon_sym_when,
      anon_sym_or,
      sym_identifier,
    ACTIONS(2464), 9,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [107939] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6203), 1,
      sym_identifier,
    ACTIONS(6471), 1,
      anon_sym_DASH_GT,
    ACTIONS(6475), 1,
      anon_sym_STAR,
    ACTIONS(6477), 1,
      anon_sym_LT2,
    ACTIONS(6479), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4429), 1,
      aux_sym_compound_type_repeat1,
    STATE(4531), 1,
      sym_type_arguments,
    STATE(4578), 1,
      sym_long_identifier,
    ACTIONS(5057), 3,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_when,
    ACTIONS(5055), 4,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(4455), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [108002] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2514), 4,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_when,
      sym_identifier,
    STATE(4456), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2516), 11,
      sym__newline,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [108049] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6712), 1,
      anon_sym_DOT,
    STATE(4381), 1,
      aux_sym_long_identifier_repeat1,
    STATE(4457), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2418), 5,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_when,
      sym_identifier,
    ACTIONS(2420), 8,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [108100] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2321), 4,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      sym_identifier,
    STATE(4458), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2323), 11,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [108147] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2627), 4,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_when,
      sym_identifier,
    STATE(4459), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2629), 11,
      sym__newline,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [108194] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6745), 1,
      anon_sym_COLON_GT,
    ACTIONS(2567), 4,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      sym_identifier,
    STATE(4460), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2569), 10,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [108243] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2411), 4,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      sym_identifier,
    STATE(4461), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2413), 11,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [108290] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2466), 4,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_when,
      sym_identifier,
    STATE(4462), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2468), 11,
      sym__newline,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [108337] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6522), 1,
      anon_sym_STAR,
    STATE(4467), 1,
      aux_sym_compound_type_repeat1,
    ACTIONS(2407), 4,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      sym_identifier,
    STATE(4463), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2409), 9,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [108388] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2411), 3,
      anon_sym_COLON,
      anon_sym_as,
      sym_identifier,
    STATE(4464), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2413), 12,
      sym__newline,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [108435] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2567), 4,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_when,
      sym_identifier,
    STATE(4465), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2569), 11,
      sym__newline,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [108482] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    STATE(4466), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2340), 6,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_in,
      anon_sym_when,
      anon_sym_or,
      sym_identifier,
    ACTIONS(2342), 9,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [108529] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6747), 1,
      anon_sym_STAR,
    ACTIONS(2250), 4,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      sym_identifier,
    STATE(4467), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_compound_type_repeat1,
    ACTIONS(2248), 9,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [108578] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2474), 4,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_when,
      sym_identifier,
    STATE(4468), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2476), 11,
      sym__newline,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [108625] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2510), 4,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_when,
      sym_identifier,
    STATE(4469), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2512), 11,
      sym__newline,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [108672] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6750), 1,
      anon_sym_LT2,
    ACTIONS(2557), 4,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_when,
      sym_identifier,
    STATE(4470), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2559), 10,
      sym__newline,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LBRACK_RBRACK,
  [108721] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6707), 1,
      anon_sym_DOT,
    STATE(4472), 1,
      aux_sym_long_identifier_repeat1,
    STATE(4471), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2418), 5,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_in,
      sym_identifier,
    ACTIONS(2420), 8,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [108772] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6752), 1,
      anon_sym_DOT,
    ACTIONS(2411), 5,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_in,
      sym_identifier,
    STATE(4472), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_long_identifier_repeat1,
    ACTIONS(2413), 8,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [108821] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    STATE(4473), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2411), 5,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_in,
      sym_identifier,
    ACTIONS(2413), 9,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [108867] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2627), 4,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      sym_identifier,
    STATE(4474), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2629), 10,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [108913] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2514), 4,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      sym_identifier,
    STATE(4475), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2516), 10,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [108959] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2466), 4,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      sym_identifier,
    STATE(4476), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2468), 10,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [109005] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2563), 4,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      sym_identifier,
    STATE(4477), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2565), 10,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [109051] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2553), 4,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      sym_identifier,
    STATE(4478), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2555), 10,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [109097] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2474), 4,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      sym_identifier,
    STATE(4479), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2476), 10,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [109143] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2510), 4,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      sym_identifier,
    STATE(4480), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2512), 10,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [109189] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6755), 1,
      anon_sym_LT2,
    ACTIONS(2557), 4,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      sym_identifier,
    STATE(4481), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2559), 9,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LBRACK_RBRACK,
  [109237] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6757), 1,
      anon_sym_COLON_GT,
    ACTIONS(2567), 3,
      anon_sym_COLON,
      anon_sym_as,
      sym_identifier,
    STATE(4482), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2569), 10,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [109285] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5013), 1,
      anon_sym_COLON,
    STATE(4483), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5015), 13,
      anon_sym_EQ,
      anon_sym_and,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_in,
      anon_sym_DASH_GT,
      anon_sym_GT,
      anon_sym_when,
      anon_sym_LT2,
  [109331] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    STATE(4484), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2411), 5,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_when,
      sym_identifier,
    ACTIONS(2413), 9,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [109377] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2567), 4,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      sym_identifier,
    STATE(4485), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2569), 10,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [109423] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5487), 1,
      anon_sym_COLON,
    STATE(4486), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5489), 13,
      anon_sym_EQ,
      anon_sym_and,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_in,
      anon_sym_DASH_GT,
      anon_sym_GT,
      anon_sym_when,
      anon_sym_LT2,
  [109469] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6759), 1,
      anon_sym_COLON_GT,
    STATE(4487), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2567), 5,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_when,
      sym_identifier,
    ACTIONS(2569), 8,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [109517] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6293), 4,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4488), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6291), 10,
      anon_sym_mutable,
      anon_sym__,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      sym_identifier,
  [109563] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2553), 3,
      anon_sym_COLON,
      anon_sym_as,
      sym_identifier,
    STATE(4489), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2555), 11,
      sym__newline,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [109609] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2563), 3,
      anon_sym_COLON,
      anon_sym_as,
      sym_identifier,
    STATE(4490), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2565), 11,
      sym__newline,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [109655] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    STATE(4491), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2340), 5,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_in,
      anon_sym_or,
      sym_identifier,
    ACTIONS(2342), 9,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [109701] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6045), 4,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4492), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6043), 10,
      anon_sym_mutable,
      anon_sym__,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      sym_identifier,
  [109747] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2514), 3,
      anon_sym_COLON,
      anon_sym_as,
      sym_identifier,
    STATE(4493), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2516), 11,
      sym__newline,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [109793] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    STATE(4494), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2321), 5,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_in,
      anon_sym_when,
      sym_identifier,
    ACTIONS(2323), 9,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [109839] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2627), 3,
      anon_sym_COLON,
      anon_sym_as,
      sym_identifier,
    STATE(4495), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2629), 11,
      sym__newline,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [109885] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6761), 1,
      anon_sym_STAR,
    ACTIONS(2250), 5,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_in,
      sym_identifier,
    STATE(4496), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_compound_type_repeat1,
    ACTIONS(2248), 7,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [109933] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2466), 3,
      anon_sym_COLON,
      anon_sym_as,
      sym_identifier,
    STATE(4497), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2468), 11,
      sym__newline,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [109979] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2553), 4,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_when,
      sym_identifier,
    STATE(4498), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2555), 10,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [110025] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2474), 3,
      anon_sym_COLON,
      anon_sym_as,
      sym_identifier,
    STATE(4499), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2476), 11,
      sym__newline,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [110071] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2510), 3,
      anon_sym_COLON,
      anon_sym_as,
      sym_identifier,
    STATE(4500), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2512), 11,
      sym__newline,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [110117] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6764), 1,
      anon_sym_LT2,
    ACTIONS(2557), 3,
      anon_sym_COLON,
      anon_sym_as,
      sym_identifier,
    STATE(4501), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2559), 10,
      sym__newline,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LBRACK_RBRACK,
  [110165] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6589), 1,
      anon_sym_STAR,
    STATE(4507), 1,
      aux_sym_compound_type_repeat1,
    STATE(4502), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2407), 5,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_when,
      sym_identifier,
    ACTIONS(2409), 7,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [110215] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2567), 3,
      anon_sym_COLON,
      anon_sym_as,
      sym_identifier,
    STATE(4503), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2569), 11,
      sym__newline,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [110261] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2563), 4,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_when,
      sym_identifier,
    STATE(4504), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2565), 10,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [110307] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2514), 4,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_when,
      sym_identifier,
    STATE(4505), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2516), 10,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [110353] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2321), 3,
      anon_sym_COLON,
      anon_sym_as,
      sym_identifier,
    STATE(4506), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2323), 11,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [110399] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6766), 1,
      anon_sym_STAR,
    ACTIONS(2250), 5,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_when,
      sym_identifier,
    STATE(4507), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_compound_type_repeat1,
    ACTIONS(2248), 7,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [110447] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2627), 4,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_when,
      sym_identifier,
    STATE(4508), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2629), 10,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [110493] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2466), 4,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_when,
      sym_identifier,
    STATE(4509), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2468), 10,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [110539] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2411), 3,
      anon_sym_COLON,
      anon_sym_as,
      sym_identifier,
    STATE(4510), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2413), 11,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [110585] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6583), 1,
      anon_sym_STAR,
    STATE(4496), 1,
      aux_sym_compound_type_repeat1,
    STATE(4511), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2407), 5,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_in,
      sym_identifier,
    ACTIONS(2409), 7,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [110635] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2158), 1,
      anon_sym_COLON,
    ACTIONS(5751), 1,
      aux_sym_decimal_token1,
    ACTIONS(5792), 1,
      anon_sym_f,
    STATE(4512), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2160), 11,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_in,
      anon_sym_DASH_GT,
      anon_sym_when,
      anon_sym_LT2,
  [110685] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2462), 1,
      anon_sym_COLON,
    STATE(4513), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2464), 13,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_in,
      anon_sym_DASH_GT,
      anon_sym_GT,
      anon_sym_when,
      anon_sym_LT2,
      anon_sym_or,
  [110731] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2506), 4,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      sym_identifier,
    STATE(4514), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2508), 10,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [110777] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2470), 4,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      sym_identifier,
    STATE(4515), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2472), 10,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [110823] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2454), 4,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      sym_identifier,
    STATE(4516), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2456), 10,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [110869] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6769), 1,
      anon_sym_or,
    STATE(4535), 1,
      aux_sym_type_argument_repeat1,
    ACTIONS(2321), 4,
      anon_sym_with,
      anon_sym_interface,
      anon_sym_val,
      sym_identifier,
    STATE(4517), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2323), 8,
      sym__dedent,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [110919] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2474), 4,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_when,
      sym_identifier,
    STATE(4518), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2476), 10,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [110965] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5860), 1,
      sym_identifier,
    ACTIONS(6771), 1,
      anon_sym_DASH_GT,
    ACTIONS(6773), 1,
      anon_sym_STAR,
    ACTIONS(6775), 1,
      anon_sym_LT2,
    ACTIONS(6777), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4769), 1,
      aux_sym_compound_type_repeat1,
    STATE(4860), 1,
      sym_type_arguments,
    STATE(4885), 1,
      sym_long_identifier,
    ACTIONS(2240), 3,
      sym__dedent,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
    ACTIONS(2242), 3,
      anon_sym_with,
      anon_sym_interface,
      anon_sym_val,
    STATE(4519), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [111027] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6779), 1,
      anon_sym_or,
    STATE(4566), 1,
      aux_sym_type_argument_repeat1,
    ACTIONS(2328), 3,
      anon_sym_COLON,
      anon_sym_with,
      sym_identifier,
    STATE(4520), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2330), 9,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [111077] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6781), 1,
      anon_sym_COLON_GT,
    STATE(4521), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2567), 5,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_in,
      sym_identifier,
    ACTIONS(2569), 8,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [111125] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5860), 1,
      sym_identifier,
    ACTIONS(6771), 1,
      anon_sym_DASH_GT,
    ACTIONS(6773), 1,
      anon_sym_STAR,
    ACTIONS(6775), 1,
      anon_sym_LT2,
    ACTIONS(6777), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4769), 1,
      aux_sym_compound_type_repeat1,
    STATE(4860), 1,
      sym_type_arguments,
    STATE(4885), 1,
      sym_long_identifier,
    ACTIONS(2244), 3,
      sym__dedent,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
    ACTIONS(2246), 3,
      anon_sym_with,
      anon_sym_interface,
      anon_sym_val,
    STATE(4522), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [111187] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5860), 1,
      sym_identifier,
    ACTIONS(6771), 1,
      anon_sym_DASH_GT,
    ACTIONS(6773), 1,
      anon_sym_STAR,
    ACTIONS(6775), 1,
      anon_sym_LT2,
    ACTIONS(6777), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4769), 1,
      aux_sym_compound_type_repeat1,
    STATE(4860), 1,
      sym_type_arguments,
    STATE(4885), 1,
      sym_long_identifier,
    ACTIONS(2248), 3,
      sym__dedent,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
    ACTIONS(2250), 3,
      anon_sym_with,
      anon_sym_interface,
      anon_sym_val,
    STATE(4523), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [111249] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5860), 1,
      sym_identifier,
    ACTIONS(6771), 1,
      anon_sym_DASH_GT,
    ACTIONS(6773), 1,
      anon_sym_STAR,
    ACTIONS(6775), 1,
      anon_sym_LT2,
    ACTIONS(6777), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4769), 1,
      aux_sym_compound_type_repeat1,
    STATE(4860), 1,
      sym_type_arguments,
    STATE(4885), 1,
      sym_long_identifier,
    ACTIONS(2228), 3,
      sym__dedent,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
    ACTIONS(2230), 3,
      anon_sym_with,
      anon_sym_interface,
      anon_sym_val,
    STATE(4524), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [111311] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2510), 4,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_when,
      sym_identifier,
    STATE(4525), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2512), 10,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [111357] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    STATE(4526), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2462), 5,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_in,
      anon_sym_or,
      sym_identifier,
    ACTIONS(2464), 9,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [111403] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2553), 4,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_when,
      sym_identifier,
    STATE(4527), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2555), 10,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [111449] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6783), 1,
      anon_sym_or,
    ACTIONS(2340), 4,
      anon_sym_with,
      anon_sym_interface,
      anon_sym_val,
      sym_identifier,
    STATE(4528), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_type_argument_repeat1,
    ACTIONS(2342), 8,
      sym__dedent,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [111497] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2563), 4,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_when,
      sym_identifier,
    STATE(4529), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2565), 10,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [111543] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6786), 1,
      anon_sym_LT2,
    ACTIONS(2557), 4,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_when,
      sym_identifier,
    STATE(4530), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2559), 9,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LBRACK_RBRACK,
  [111591] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2474), 4,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_when,
      sym_identifier,
    STATE(4531), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2476), 10,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [111637] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2567), 4,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_when,
      sym_identifier,
    STATE(4532), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2569), 10,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [111683] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2510), 4,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_when,
      sym_identifier,
    STATE(4533), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2512), 10,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [111729] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6600), 1,
      anon_sym_STAR,
    STATE(4583), 1,
      aux_sym_compound_type_repeat1,
    ACTIONS(2407), 3,
      anon_sym_COLON,
      anon_sym_as,
      sym_identifier,
    STATE(4534), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2409), 9,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [111779] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6769), 1,
      anon_sym_or,
    STATE(4528), 1,
      aux_sym_type_argument_repeat1,
    ACTIONS(2328), 4,
      anon_sym_with,
      anon_sym_interface,
      anon_sym_val,
      sym_identifier,
    STATE(4535), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2330), 8,
      sym__dedent,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [111829] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2411), 4,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_in,
      sym_identifier,
    STATE(4536), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2413), 10,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      anon_sym_EQ2,
  [111875] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2812), 1,
      anon_sym_COLON,
    STATE(4537), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2814), 13,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_in,
      anon_sym_DASH_GT,
      anon_sym_when,
      anon_sym_LT2,
      anon_sym_f,
      aux_sym_decimal_token1,
  [111921] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2553), 4,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      sym_identifier,
    STATE(4538), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2555), 10,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [111967] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2563), 4,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      sym_identifier,
    STATE(4539), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2565), 10,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [112013] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2514), 4,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      sym_identifier,
    STATE(4540), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2516), 10,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [112059] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2723), 1,
      anon_sym_COLON,
    STATE(4541), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2725), 13,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_in,
      anon_sym_DASH_GT,
      anon_sym_when,
      anon_sym_LT2,
      anon_sym_f,
      aux_sym_decimal_token1,
  [112105] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5402), 1,
      anon_sym_COLON,
    STATE(4542), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5404), 13,
      anon_sym_EQ,
      anon_sym_and,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_in,
      anon_sym_DASH_GT,
      anon_sym_GT,
      anon_sym_when,
      anon_sym_LT2,
  [112151] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2514), 4,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_when,
      sym_identifier,
    STATE(4543), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2516), 10,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [112197] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2627), 4,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      sym_identifier,
    STATE(4544), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2629), 10,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [112243] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2454), 4,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      sym_identifier,
    STATE(4545), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2456), 10,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [112289] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2470), 4,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      sym_identifier,
    STATE(4546), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2472), 10,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [112335] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5516), 1,
      anon_sym_COLON,
    STATE(4547), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5518), 13,
      anon_sym_EQ,
      anon_sym_and,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_in,
      anon_sym_DASH_GT,
      anon_sym_GT,
      anon_sym_when,
      anon_sym_LT2,
  [112381] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2466), 4,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      sym_identifier,
    STATE(4548), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2468), 10,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [112427] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6788), 1,
      anon_sym_STAR,
    ACTIONS(2250), 3,
      anon_sym_COLON,
      anon_sym_as,
      sym_identifier,
    STATE(4549), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_compound_type_repeat1,
    ACTIONS(2248), 9,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [112475] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2506), 4,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_when,
      sym_identifier,
    STATE(4550), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2508), 10,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [112521] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2506), 4,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      sym_identifier,
    STATE(4551), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2508), 10,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [112567] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    STATE(4552), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2321), 5,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_when,
      sym_identifier,
    ACTIONS(2323), 9,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [112613] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2470), 4,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_when,
      sym_identifier,
    STATE(4553), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2472), 10,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [112659] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2454), 4,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_when,
      sym_identifier,
    STATE(4554), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2456), 10,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [112705] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6630), 1,
      anon_sym_STAR,
    STATE(4549), 1,
      aux_sym_compound_type_repeat1,
    ACTIONS(2407), 3,
      anon_sym_COLON,
      anon_sym_as,
      sym_identifier,
    STATE(4555), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2409), 9,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [112755] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    STATE(4556), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2321), 5,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_in,
      sym_identifier,
    ACTIONS(2323), 9,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [112801] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6791), 1,
      anon_sym_COLON_GT,
    ACTIONS(2567), 3,
      anon_sym_COLON,
      anon_sym_as,
      sym_identifier,
    STATE(4557), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2569), 10,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [112849] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    STATE(4558), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2411), 5,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_in,
      anon_sym_when,
      sym_identifier,
    ACTIONS(2413), 9,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [112895] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5009), 1,
      anon_sym_COLON,
    STATE(4559), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5011), 13,
      anon_sym_EQ,
      anon_sym_and,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_in,
      anon_sym_DASH_GT,
      anon_sym_GT,
      anon_sym_when,
      anon_sym_LT2,
  [112941] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5520), 1,
      anon_sym_COLON,
    STATE(4560), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5522), 13,
      anon_sym_EQ,
      anon_sym_and,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_in,
      anon_sym_DASH_GT,
      anon_sym_GT,
      anon_sym_when,
      anon_sym_LT2,
  [112987] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5527), 1,
      anon_sym_COLON,
    STATE(4561), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5529), 13,
      anon_sym_EQ,
      anon_sym_and,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_in,
      anon_sym_DASH_GT,
      anon_sym_GT,
      anon_sym_when,
      anon_sym_LT2,
  [113033] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2506), 3,
      anon_sym_COLON,
      anon_sym_as,
      sym_identifier,
    STATE(4562), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2508), 11,
      sym__newline,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [113079] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2474), 4,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      sym_identifier,
    STATE(4563), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2476), 10,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [113125] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2510), 4,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      sym_identifier,
    STATE(4564), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2512), 10,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [113171] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6793), 1,
      anon_sym_STAR,
    ACTIONS(2250), 5,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_in,
      anon_sym_when,
      sym_identifier,
    STATE(4565), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_compound_type_repeat1,
    ACTIONS(2248), 7,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [113219] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6796), 1,
      anon_sym_or,
    ACTIONS(2340), 3,
      anon_sym_COLON,
      anon_sym_with,
      sym_identifier,
    STATE(4566), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_type_argument_repeat1,
    ACTIONS(2342), 9,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [113267] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6107), 4,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4567), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6105), 10,
      anon_sym_mutable,
      anon_sym__,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
      sym_identifier,
  [113313] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2470), 3,
      anon_sym_COLON,
      anon_sym_as,
      sym_identifier,
    STATE(4568), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2472), 11,
      sym__newline,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [113359] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2454), 3,
      anon_sym_COLON,
      anon_sym_as,
      sym_identifier,
    STATE(4569), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2456), 11,
      sym__newline,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [113405] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2411), 3,
      anon_sym_COLON,
      anon_sym_as,
      sym_identifier,
    STATE(4570), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2413), 11,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [113451] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6799), 1,
      anon_sym_LT2,
    ACTIONS(2557), 4,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      sym_identifier,
    STATE(4571), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2559), 9,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LBRACK_RBRACK,
  [113499] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6570), 1,
      anon_sym_STAR,
    STATE(4565), 1,
      aux_sym_compound_type_repeat1,
    STATE(4572), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2407), 5,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_in,
      anon_sym_when,
      sym_identifier,
    ACTIONS(2409), 7,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [113549] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2567), 4,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      sym_identifier,
    STATE(4573), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2569), 10,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [113595] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2466), 4,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_when,
      sym_identifier,
    STATE(4574), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2468), 10,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [113641] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6801), 1,
      anon_sym_COLON_GT,
    STATE(4575), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2567), 5,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_in,
      anon_sym_when,
      sym_identifier,
    ACTIONS(2569), 8,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [113689] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2321), 3,
      anon_sym_COLON,
      anon_sym_as,
      sym_identifier,
    STATE(4576), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2323), 11,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [113735] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2567), 4,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_when,
      sym_identifier,
    STATE(4577), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2569), 10,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [113781] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2627), 4,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_when,
      sym_identifier,
    STATE(4578), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2629), 10,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [113827] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2454), 4,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_when,
      sym_identifier,
    STATE(4579), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2456), 10,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [113873] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6803), 1,
      anon_sym_LT2,
    ACTIONS(2557), 4,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_when,
      sym_identifier,
    STATE(4580), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2559), 9,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LBRACK_RBRACK,
  [113921] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2470), 4,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_when,
      sym_identifier,
    STATE(4581), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2472), 10,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [113967] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2506), 4,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_when,
      sym_identifier,
    STATE(4582), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2508), 10,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [114013] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6805), 1,
      anon_sym_STAR,
    ACTIONS(2250), 3,
      anon_sym_COLON,
      anon_sym_as,
      sym_identifier,
    STATE(4583), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_compound_type_repeat1,
    ACTIONS(2248), 9,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [114061] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2340), 1,
      anon_sym_COLON,
    STATE(4584), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2342), 13,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_in,
      anon_sym_DASH_GT,
      anon_sym_GT,
      anon_sym_when,
      anon_sym_LT2,
      anon_sym_or,
  [114107] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2321), 4,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_in,
      sym_identifier,
    STATE(4585), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2323), 9,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [114152] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    STATE(4586), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2627), 5,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_in,
      sym_identifier,
    ACTIONS(2629), 8,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [114197] = 16,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(133), 1,
      sym_line_comment,
    ACTIONS(6812), 1,
      aux_sym__simple_string_char_token1,
    ACTIONS(6814), 1,
      anon_sym_LBRACE2,
    ACTIONS(6816), 1,
      anon_sym_DQUOTE,
    ACTIONS(6818), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(6820), 1,
      anon_sym_POUNDlight,
    ACTIONS(6822), 1,
      anon_sym_POUNDr,
    ACTIONS(6824), 1,
      sym__inside_string_marker,
    STATE(4643), 1,
      aux_sym_format_string_repeat1,
    STATE(5198), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6808), 2,
      sym__escape_char,
      sym__non_escape_char,
    STATE(5339), 2,
      sym__string_char,
      sym_format_string_eval,
    ACTIONS(6810), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(4587), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [114254] = 16,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(133), 1,
      sym_line_comment,
    ACTIONS(6812), 1,
      aux_sym__simple_string_char_token1,
    ACTIONS(6814), 1,
      anon_sym_LBRACE2,
    ACTIONS(6818), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(6820), 1,
      anon_sym_POUNDlight,
    ACTIONS(6822), 1,
      anon_sym_POUNDr,
    ACTIONS(6824), 1,
      sym__inside_string_marker,
    ACTIONS(6826), 1,
      anon_sym_DQUOTE,
    STATE(4643), 1,
      aux_sym_format_string_repeat1,
    STATE(5198), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6808), 2,
      sym__escape_char,
      sym__non_escape_char,
    STATE(5339), 2,
      sym__string_char,
      sym_format_string_eval,
    ACTIONS(6810), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(4588), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [114311] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2627), 3,
      anon_sym_COLON,
      anon_sym_as,
      sym_identifier,
    STATE(4589), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2629), 10,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [114356] = 16,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(133), 1,
      sym_line_comment,
    ACTIONS(6812), 1,
      aux_sym__simple_string_char_token1,
    ACTIONS(6814), 1,
      anon_sym_LBRACE2,
    ACTIONS(6818), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(6820), 1,
      anon_sym_POUNDlight,
    ACTIONS(6822), 1,
      anon_sym_POUNDr,
    ACTIONS(6824), 1,
      sym__inside_string_marker,
    ACTIONS(6828), 1,
      anon_sym_DQUOTE,
    STATE(4643), 1,
      aux_sym_format_string_repeat1,
    STATE(5198), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6808), 2,
      sym__escape_char,
      sym__non_escape_char,
    STATE(5339), 2,
      sym__string_char,
      sym_format_string_eval,
    ACTIONS(6810), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(4590), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [114413] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2466), 3,
      anon_sym_COLON,
      anon_sym_as,
      sym_identifier,
    STATE(4591), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2468), 10,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [114458] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6830), 1,
      anon_sym_STAR,
    ACTIONS(2250), 4,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_in,
      sym_identifier,
    STATE(4592), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_compound_type_repeat1,
    ACTIONS(2248), 7,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [114505] = 16,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(133), 1,
      sym_line_comment,
    ACTIONS(6812), 1,
      aux_sym__simple_string_char_token1,
    ACTIONS(6814), 1,
      anon_sym_LBRACE2,
    ACTIONS(6818), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(6820), 1,
      anon_sym_POUNDlight,
    ACTIONS(6822), 1,
      anon_sym_POUNDr,
    ACTIONS(6824), 1,
      sym__inside_string_marker,
    ACTIONS(6833), 1,
      anon_sym_DQUOTE,
    STATE(4643), 1,
      aux_sym_format_string_repeat1,
    STATE(5198), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6808), 2,
      sym__escape_char,
      sym__non_escape_char,
    STATE(5339), 2,
      sym__string_char,
      sym_format_string_eval,
    ACTIONS(6810), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(4593), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [114562] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    STATE(4594), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2462), 5,
      anon_sym_with,
      anon_sym_or,
      anon_sym_interface,
      anon_sym_val,
      sym_identifier,
    ACTIONS(2464), 8,
      sym__dedent,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [114607] = 16,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(133), 1,
      sym_line_comment,
    ACTIONS(6812), 1,
      aux_sym__simple_string_char_token1,
    ACTIONS(6814), 1,
      anon_sym_LBRACE2,
    ACTIONS(6818), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(6820), 1,
      anon_sym_POUNDlight,
    ACTIONS(6822), 1,
      anon_sym_POUNDr,
    ACTIONS(6824), 1,
      sym__inside_string_marker,
    ACTIONS(6835), 1,
      anon_sym_DQUOTE,
    STATE(4593), 1,
      aux_sym_format_string_repeat1,
    STATE(5198), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6808), 2,
      sym__escape_char,
      sym__non_escape_char,
    STATE(5339), 2,
      sym__string_char,
      sym_format_string_eval,
    ACTIONS(6810), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(4595), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [114664] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6837), 1,
      anon_sym_COLON_GT,
    ACTIONS(2567), 4,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_in,
      sym_identifier,
    STATE(4596), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2569), 8,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [114711] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6839), 1,
      anon_sym_DOT,
    STATE(4628), 1,
      aux_sym_long_identifier_repeat1,
    ACTIONS(2312), 4,
      anon_sym_with,
      anon_sym_interface,
      anon_sym_val,
      sym_identifier,
    STATE(4597), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2314), 7,
      sym__dedent,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [114760] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    STATE(4598), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2567), 5,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_in,
      anon_sym_when,
      sym_identifier,
    ACTIONS(2569), 8,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [114805] = 16,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(133), 1,
      sym_line_comment,
    ACTIONS(6812), 1,
      aux_sym__simple_string_char_token1,
    ACTIONS(6814), 1,
      anon_sym_LBRACE2,
    ACTIONS(6818), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(6820), 1,
      anon_sym_POUNDlight,
    ACTIONS(6822), 1,
      anon_sym_POUNDr,
    ACTIONS(6824), 1,
      sym__inside_string_marker,
    ACTIONS(6841), 1,
      anon_sym_DQUOTE,
    STATE(4587), 1,
      aux_sym_format_string_repeat1,
    STATE(5198), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6808), 2,
      sym__escape_char,
      sym__non_escape_char,
    STATE(5339), 2,
      sym__string_char,
      sym_format_string_eval,
    ACTIONS(6810), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(4599), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [114862] = 16,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(133), 1,
      sym_line_comment,
    ACTIONS(6812), 1,
      aux_sym__simple_string_char_token1,
    ACTIONS(6814), 1,
      anon_sym_LBRACE2,
    ACTIONS(6818), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(6820), 1,
      anon_sym_POUNDlight,
    ACTIONS(6822), 1,
      anon_sym_POUNDr,
    ACTIONS(6824), 1,
      sym__inside_string_marker,
    ACTIONS(6843), 1,
      anon_sym_DQUOTE,
    STATE(4643), 1,
      aux_sym_format_string_repeat1,
    STATE(5198), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6808), 2,
      sym__escape_char,
      sym__non_escape_char,
    STATE(5339), 2,
      sym__string_char,
      sym_format_string_eval,
    ACTIONS(6810), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(4600), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [114919] = 16,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(133), 1,
      sym_line_comment,
    ACTIONS(6812), 1,
      aux_sym__simple_string_char_token1,
    ACTIONS(6814), 1,
      anon_sym_LBRACE2,
    ACTIONS(6818), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(6820), 1,
      anon_sym_POUNDlight,
    ACTIONS(6822), 1,
      anon_sym_POUNDr,
    ACTIONS(6824), 1,
      sym__inside_string_marker,
    ACTIONS(6845), 1,
      anon_sym_DQUOTE,
    STATE(4588), 1,
      aux_sym_format_string_repeat1,
    STATE(5198), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6808), 2,
      sym__escape_char,
      sym__non_escape_char,
    STATE(5339), 2,
      sym__string_char,
      sym_format_string_eval,
    ACTIONS(6810), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(4601), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [114976] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6847), 1,
      anon_sym_LT2,
    STATE(4602), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2557), 5,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_in,
      anon_sym_when,
      sym_identifier,
    ACTIONS(2559), 7,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LBRACK_RBRACK,
  [115023] = 16,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(133), 1,
      sym_line_comment,
    ACTIONS(6812), 1,
      aux_sym__simple_string_char_token1,
    ACTIONS(6814), 1,
      anon_sym_LBRACE2,
    ACTIONS(6818), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(6820), 1,
      anon_sym_POUNDlight,
    ACTIONS(6822), 1,
      anon_sym_POUNDr,
    ACTIONS(6824), 1,
      sym__inside_string_marker,
    ACTIONS(6849), 1,
      anon_sym_DQUOTE,
    STATE(4643), 1,
      aux_sym_format_string_repeat1,
    STATE(5198), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6808), 2,
      sym__escape_char,
      sym__non_escape_char,
    STATE(5339), 2,
      sym__string_char,
      sym_format_string_eval,
    ACTIONS(6810), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(4603), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [115080] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6682), 1,
      anon_sym_STAR,
    STATE(4592), 1,
      aux_sym_compound_type_repeat1,
    ACTIONS(2407), 4,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_in,
      sym_identifier,
    STATE(4604), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2409), 7,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [115129] = 16,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(133), 1,
      sym_line_comment,
    ACTIONS(6812), 1,
      aux_sym__simple_string_char_token1,
    ACTIONS(6814), 1,
      anon_sym_LBRACE2,
    ACTIONS(6818), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(6820), 1,
      anon_sym_POUNDlight,
    ACTIONS(6822), 1,
      anon_sym_POUNDr,
    ACTIONS(6824), 1,
      sym__inside_string_marker,
    ACTIONS(6851), 1,
      anon_sym_DQUOTE,
    STATE(4672), 1,
      aux_sym_format_string_repeat1,
    STATE(5198), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6808), 2,
      sym__escape_char,
      sym__non_escape_char,
    STATE(5339), 2,
      sym__string_char,
      sym_format_string_eval,
    ACTIONS(6810), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(4605), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [115186] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2454), 3,
      anon_sym_COLON,
      anon_sym_as,
      sym_identifier,
    STATE(4606), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2456), 10,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [115231] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    STATE(4607), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2510), 5,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_in,
      anon_sym_when,
      sym_identifier,
    ACTIONS(2512), 8,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [115276] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    STATE(4608), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2474), 5,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_in,
      anon_sym_when,
      sym_identifier,
    ACTIONS(2476), 8,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [115321] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    STATE(4609), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2506), 5,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_in,
      anon_sym_when,
      sym_identifier,
    ACTIONS(2508), 8,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [115366] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    STATE(4610), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2454), 5,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_in,
      sym_identifier,
    ACTIONS(2456), 8,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [115411] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    STATE(4611), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2470), 5,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_in,
      sym_identifier,
    ACTIONS(2472), 8,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [115456] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2470), 3,
      anon_sym_COLON,
      anon_sym_as,
      sym_identifier,
    STATE(4612), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2472), 10,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [115501] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    STATE(4613), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2506), 5,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_in,
      sym_identifier,
    ACTIONS(2508), 8,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [115546] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2506), 3,
      anon_sym_COLON,
      anon_sym_as,
      sym_identifier,
    STATE(4614), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2508), 10,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [115591] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    STATE(4615), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2470), 5,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_in,
      anon_sym_when,
      sym_identifier,
    ACTIONS(2472), 8,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [115636] = 16,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(133), 1,
      sym_line_comment,
    ACTIONS(6812), 1,
      aux_sym__simple_string_char_token1,
    ACTIONS(6814), 1,
      anon_sym_LBRACE2,
    ACTIONS(6818), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(6820), 1,
      anon_sym_POUNDlight,
    ACTIONS(6822), 1,
      anon_sym_POUNDr,
    ACTIONS(6824), 1,
      sym__inside_string_marker,
    ACTIONS(6853), 1,
      anon_sym_DQUOTE,
    STATE(4643), 1,
      aux_sym_format_string_repeat1,
    STATE(5198), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6808), 2,
      sym__escape_char,
      sym__non_escape_char,
    STATE(5339), 2,
      sym__string_char,
      sym_format_string_eval,
    ACTIONS(6810), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(4616), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [115693] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6855), 1,
      anon_sym_and,
    STATE(4658), 1,
      aux_sym__function_or_value_defns_repeat1,
    STATE(4617), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4685), 11,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [115740] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    STATE(4618), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2454), 5,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_in,
      anon_sym_when,
      sym_identifier,
    ACTIONS(2456), 8,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [115785] = 16,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(133), 1,
      sym_line_comment,
    ACTIONS(6812), 1,
      aux_sym__simple_string_char_token1,
    ACTIONS(6814), 1,
      anon_sym_LBRACE2,
    ACTIONS(6818), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(6820), 1,
      anon_sym_POUNDlight,
    ACTIONS(6822), 1,
      anon_sym_POUNDr,
    ACTIONS(6824), 1,
      sym__inside_string_marker,
    ACTIONS(6857), 1,
      anon_sym_DQUOTE,
    STATE(4616), 1,
      aux_sym_format_string_repeat1,
    STATE(5198), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6808), 2,
      sym__escape_char,
      sym__non_escape_char,
    STATE(5339), 2,
      sym__string_char,
      sym_format_string_eval,
    ACTIONS(6810), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(4619), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [115842] = 16,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(133), 1,
      sym_line_comment,
    ACTIONS(6812), 1,
      aux_sym__simple_string_char_token1,
    ACTIONS(6814), 1,
      anon_sym_LBRACE2,
    ACTIONS(6818), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(6820), 1,
      anon_sym_POUNDlight,
    ACTIONS(6822), 1,
      anon_sym_POUNDr,
    ACTIONS(6824), 1,
      sym__inside_string_marker,
    ACTIONS(6859), 1,
      anon_sym_DQUOTE,
    STATE(4643), 1,
      aux_sym_format_string_repeat1,
    STATE(5198), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6808), 2,
      sym__escape_char,
      sym__non_escape_char,
    STATE(5339), 2,
      sym__string_char,
      sym_format_string_eval,
    ACTIONS(6810), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(4620), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [115899] = 16,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(133), 1,
      sym_line_comment,
    ACTIONS(6812), 1,
      aux_sym__simple_string_char_token1,
    ACTIONS(6814), 1,
      anon_sym_LBRACE2,
    ACTIONS(6818), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(6820), 1,
      anon_sym_POUNDlight,
    ACTIONS(6822), 1,
      anon_sym_POUNDr,
    ACTIONS(6824), 1,
      sym__inside_string_marker,
    ACTIONS(6861), 1,
      anon_sym_DQUOTE,
    STATE(4600), 1,
      aux_sym_format_string_repeat1,
    STATE(5198), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6808), 2,
      sym__escape_char,
      sym__non_escape_char,
    STATE(5339), 2,
      sym__string_char,
      sym_format_string_eval,
    ACTIONS(6810), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(4621), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [115956] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    STATE(4622), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2466), 5,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_in,
      anon_sym_when,
      sym_identifier,
    ACTIONS(2468), 8,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [116001] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    STATE(4623), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2627), 5,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_in,
      anon_sym_when,
      sym_identifier,
    ACTIONS(2629), 8,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [116046] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2470), 3,
      anon_sym_COLON,
      anon_sym_as,
      sym_identifier,
    STATE(4624), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2472), 10,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [116091] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    STATE(4625), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2514), 5,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_in,
      anon_sym_when,
      sym_identifier,
    ACTIONS(2516), 8,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [116136] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2514), 3,
      anon_sym_COLON,
      anon_sym_as,
      sym_identifier,
    STATE(4626), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2516), 10,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [116181] = 16,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(133), 1,
      sym_line_comment,
    ACTIONS(6812), 1,
      aux_sym__simple_string_char_token1,
    ACTIONS(6814), 1,
      anon_sym_LBRACE2,
    ACTIONS(6818), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(6820), 1,
      anon_sym_POUNDlight,
    ACTIONS(6822), 1,
      anon_sym_POUNDr,
    ACTIONS(6824), 1,
      sym__inside_string_marker,
    ACTIONS(6863), 1,
      anon_sym_DQUOTE,
    STATE(4643), 1,
      aux_sym_format_string_repeat1,
    STATE(5198), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6808), 2,
      sym__escape_char,
      sym__non_escape_char,
    STATE(5339), 2,
      sym__string_char,
      sym_format_string_eval,
    ACTIONS(6810), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(4627), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [116238] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6839), 1,
      anon_sym_DOT,
    STATE(4645), 1,
      aux_sym_long_identifier_repeat1,
    ACTIONS(2418), 4,
      anon_sym_with,
      anon_sym_interface,
      anon_sym_val,
      sym_identifier,
    STATE(4628), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2420), 7,
      sym__dedent,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [116287] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    STATE(4629), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2563), 5,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_in,
      anon_sym_when,
      sym_identifier,
    ACTIONS(2565), 8,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [116332] = 16,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(133), 1,
      sym_line_comment,
    ACTIONS(6812), 1,
      aux_sym__simple_string_char_token1,
    ACTIONS(6814), 1,
      anon_sym_LBRACE2,
    ACTIONS(6818), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(6820), 1,
      anon_sym_POUNDlight,
    ACTIONS(6822), 1,
      anon_sym_POUNDr,
    ACTIONS(6824), 1,
      sym__inside_string_marker,
    ACTIONS(6865), 1,
      anon_sym_DQUOTE,
    STATE(4627), 1,
      aux_sym_format_string_repeat1,
    STATE(5198), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6808), 2,
      sym__escape_char,
      sym__non_escape_char,
    STATE(5339), 2,
      sym__string_char,
      sym_format_string_eval,
    ACTIONS(6810), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(4630), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [116389] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    STATE(4631), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2553), 5,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_in,
      anon_sym_when,
      sym_identifier,
    ACTIONS(2555), 8,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [116434] = 16,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(133), 1,
      sym_line_comment,
    ACTIONS(6812), 1,
      aux_sym__simple_string_char_token1,
    ACTIONS(6814), 1,
      anon_sym_LBRACE2,
    ACTIONS(6818), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(6820), 1,
      anon_sym_POUNDlight,
    ACTIONS(6822), 1,
      anon_sym_POUNDr,
    ACTIONS(6824), 1,
      sym__inside_string_marker,
    ACTIONS(6867), 1,
      anon_sym_DQUOTE,
    STATE(4620), 1,
      aux_sym_format_string_repeat1,
    STATE(5198), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6808), 2,
      sym__escape_char,
      sym__non_escape_char,
    STATE(5339), 2,
      sym__string_char,
      sym_format_string_eval,
    ACTIONS(6810), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(4632), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [116491] = 16,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(133), 1,
      sym_line_comment,
    ACTIONS(6812), 1,
      aux_sym__simple_string_char_token1,
    ACTIONS(6814), 1,
      anon_sym_LBRACE2,
    ACTIONS(6818), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(6820), 1,
      anon_sym_POUNDlight,
    ACTIONS(6822), 1,
      anon_sym_POUNDr,
    ACTIONS(6824), 1,
      sym__inside_string_marker,
    ACTIONS(6869), 1,
      anon_sym_DQUOTE,
    STATE(4643), 1,
      aux_sym_format_string_repeat1,
    STATE(5198), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6808), 2,
      sym__escape_char,
      sym__non_escape_char,
    STATE(5339), 2,
      sym__string_char,
      sym_format_string_eval,
    ACTIONS(6810), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(4633), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [116548] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2230), 1,
      anon_sym_with,
    ACTIONS(5768), 1,
      sym_identifier,
    ACTIONS(6871), 1,
      anon_sym_DASH_GT,
    ACTIONS(6873), 1,
      anon_sym_STAR,
    ACTIONS(6875), 1,
      anon_sym_LT2,
    ACTIONS(6877), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4859), 1,
      aux_sym_compound_type_repeat1,
    STATE(4991), 1,
      sym_long_identifier,
    STATE(5160), 1,
      sym_type_arguments,
    ACTIONS(2228), 4,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT,
    STATE(4634), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [116609] = 16,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(133), 1,
      sym_line_comment,
    ACTIONS(6812), 1,
      aux_sym__simple_string_char_token1,
    ACTIONS(6814), 1,
      anon_sym_LBRACE2,
    ACTIONS(6818), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(6820), 1,
      anon_sym_POUNDlight,
    ACTIONS(6822), 1,
      anon_sym_POUNDr,
    ACTIONS(6824), 1,
      sym__inside_string_marker,
    ACTIONS(6879), 1,
      anon_sym_DQUOTE,
    STATE(4640), 1,
      aux_sym_format_string_repeat1,
    STATE(5198), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6808), 2,
      sym__escape_char,
      sym__non_escape_char,
    STATE(5339), 2,
      sym__string_char,
      sym_format_string_eval,
    ACTIONS(6810), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(4635), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [116666] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2340), 4,
      anon_sym_COLON,
      anon_sym_with,
      anon_sym_or,
      sym_identifier,
    STATE(4636), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2342), 9,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [116711] = 16,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(133), 1,
      sym_line_comment,
    ACTIONS(6812), 1,
      aux_sym__simple_string_char_token1,
    ACTIONS(6814), 1,
      anon_sym_LBRACE2,
    ACTIONS(6818), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(6820), 1,
      anon_sym_POUNDlight,
    ACTIONS(6822), 1,
      anon_sym_POUNDr,
    ACTIONS(6824), 1,
      sym__inside_string_marker,
    ACTIONS(6881), 1,
      anon_sym_DQUOTE,
    STATE(4643), 1,
      aux_sym_format_string_repeat1,
    STATE(5198), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6808), 2,
      sym__escape_char,
      sym__non_escape_char,
    STATE(5339), 2,
      sym__string_char,
      sym_format_string_eval,
    ACTIONS(6810), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(4637), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [116768] = 16,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(133), 1,
      sym_line_comment,
    ACTIONS(6812), 1,
      aux_sym__simple_string_char_token1,
    ACTIONS(6814), 1,
      anon_sym_LBRACE2,
    ACTIONS(6818), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(6820), 1,
      anon_sym_POUNDlight,
    ACTIONS(6822), 1,
      anon_sym_POUNDr,
    ACTIONS(6824), 1,
      sym__inside_string_marker,
    ACTIONS(6883), 1,
      anon_sym_DQUOTE,
    STATE(4637), 1,
      aux_sym_format_string_repeat1,
    STATE(5198), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6808), 2,
      sym__escape_char,
      sym__non_escape_char,
    STATE(5339), 2,
      sym__string_char,
      sym_format_string_eval,
    ACTIONS(6810), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(4638), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [116825] = 16,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(133), 1,
      sym_line_comment,
    ACTIONS(6812), 1,
      aux_sym__simple_string_char_token1,
    ACTIONS(6814), 1,
      anon_sym_LBRACE2,
    ACTIONS(6818), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(6820), 1,
      anon_sym_POUNDlight,
    ACTIONS(6822), 1,
      anon_sym_POUNDr,
    ACTIONS(6824), 1,
      sym__inside_string_marker,
    ACTIONS(6885), 1,
      anon_sym_DQUOTE,
    STATE(4633), 1,
      aux_sym_format_string_repeat1,
    STATE(5198), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6808), 2,
      sym__escape_char,
      sym__non_escape_char,
    STATE(5339), 2,
      sym__string_char,
      sym_format_string_eval,
    ACTIONS(6810), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(4639), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [116882] = 16,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(133), 1,
      sym_line_comment,
    ACTIONS(6812), 1,
      aux_sym__simple_string_char_token1,
    ACTIONS(6814), 1,
      anon_sym_LBRACE2,
    ACTIONS(6818), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(6820), 1,
      anon_sym_POUNDlight,
    ACTIONS(6822), 1,
      anon_sym_POUNDr,
    ACTIONS(6824), 1,
      sym__inside_string_marker,
    ACTIONS(6887), 1,
      anon_sym_DQUOTE,
    STATE(4643), 1,
      aux_sym_format_string_repeat1,
    STATE(5198), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6808), 2,
      sym__escape_char,
      sym__non_escape_char,
    STATE(5339), 2,
      sym__string_char,
      sym_format_string_eval,
    ACTIONS(6810), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(4640), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [116939] = 16,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(133), 1,
      sym_line_comment,
    ACTIONS(6812), 1,
      aux_sym__simple_string_char_token1,
    ACTIONS(6814), 1,
      anon_sym_LBRACE2,
    ACTIONS(6818), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(6820), 1,
      anon_sym_POUNDlight,
    ACTIONS(6822), 1,
      anon_sym_POUNDr,
    ACTIONS(6824), 1,
      sym__inside_string_marker,
    ACTIONS(6889), 1,
      anon_sym_DQUOTE,
    STATE(4643), 1,
      aux_sym_format_string_repeat1,
    STATE(5198), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6808), 2,
      sym__escape_char,
      sym__non_escape_char,
    STATE(5339), 2,
      sym__string_char,
      sym_format_string_eval,
    ACTIONS(6810), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(4641), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [116996] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6891), 1,
      anon_sym_LT2,
    STATE(4642), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2557), 5,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_in,
      sym_identifier,
    ACTIONS(2559), 7,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LBRACK_RBRACK,
  [117043] = 15,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(133), 1,
      sym_line_comment,
    ACTIONS(6818), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(6820), 1,
      anon_sym_POUNDlight,
    ACTIONS(6822), 1,
      anon_sym_POUNDr,
    ACTIONS(6899), 1,
      aux_sym__simple_string_char_token1,
    ACTIONS(6902), 1,
      anon_sym_LBRACE2,
    ACTIONS(6905), 1,
      anon_sym_DQUOTE,
    ACTIONS(6907), 1,
      sym__inside_string_marker,
    STATE(5198), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6893), 2,
      sym__escape_char,
      sym__non_escape_char,
    STATE(5339), 2,
      sym__string_char,
      sym_format_string_eval,
    ACTIONS(6896), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(4643), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_format_string_repeat1,
  [117098] = 16,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(133), 1,
      sym_line_comment,
    ACTIONS(6812), 1,
      aux_sym__simple_string_char_token1,
    ACTIONS(6814), 1,
      anon_sym_LBRACE2,
    ACTIONS(6818), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(6820), 1,
      anon_sym_POUNDlight,
    ACTIONS(6822), 1,
      anon_sym_POUNDr,
    ACTIONS(6824), 1,
      sym__inside_string_marker,
    ACTIONS(6910), 1,
      anon_sym_DQUOTE,
    STATE(4643), 1,
      aux_sym_format_string_repeat1,
    STATE(5198), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6808), 2,
      sym__escape_char,
      sym__non_escape_char,
    STATE(5339), 2,
      sym__string_char,
      sym_format_string_eval,
    ACTIONS(6810), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(4644), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [117155] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6912), 1,
      anon_sym_DOT,
    ACTIONS(2411), 4,
      anon_sym_with,
      anon_sym_interface,
      anon_sym_val,
      sym_identifier,
    STATE(4645), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_long_identifier_repeat1,
    ACTIONS(2413), 7,
      sym__dedent,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [117202] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6915), 1,
      anon_sym_LT2,
    ACTIONS(2557), 3,
      anon_sym_COLON,
      anon_sym_as,
      sym_identifier,
    STATE(4646), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2559), 9,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LBRACK_RBRACK,
  [117249] = 16,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(133), 1,
      sym_line_comment,
    ACTIONS(6812), 1,
      aux_sym__simple_string_char_token1,
    ACTIONS(6814), 1,
      anon_sym_LBRACE2,
    ACTIONS(6818), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(6820), 1,
      anon_sym_POUNDlight,
    ACTIONS(6822), 1,
      anon_sym_POUNDr,
    ACTIONS(6824), 1,
      sym__inside_string_marker,
    ACTIONS(6917), 1,
      anon_sym_DQUOTE,
    STATE(4644), 1,
      aux_sym_format_string_repeat1,
    STATE(5198), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6808), 2,
      sym__escape_char,
      sym__non_escape_char,
    STATE(5339), 2,
      sym__string_char,
      sym_format_string_eval,
    ACTIONS(6810), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(4647), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [117306] = 16,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(133), 1,
      sym_line_comment,
    ACTIONS(6812), 1,
      aux_sym__simple_string_char_token1,
    ACTIONS(6814), 1,
      anon_sym_LBRACE2,
    ACTIONS(6818), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(6820), 1,
      anon_sym_POUNDlight,
    ACTIONS(6822), 1,
      anon_sym_POUNDr,
    ACTIONS(6824), 1,
      sym__inside_string_marker,
    ACTIONS(6919), 1,
      anon_sym_DQUOTE,
    STATE(4659), 1,
      aux_sym_format_string_repeat1,
    STATE(5198), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6808), 2,
      sym__escape_char,
      sym__non_escape_char,
    STATE(5339), 2,
      sym__string_char,
      sym_format_string_eval,
    ACTIONS(6810), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(4648), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [117363] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    STATE(4649), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2340), 5,
      anon_sym_with,
      anon_sym_or,
      anon_sym_interface,
      anon_sym_val,
      sym_identifier,
    ACTIONS(2342), 8,
      sym__dedent,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [117408] = 16,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(133), 1,
      sym_line_comment,
    ACTIONS(6812), 1,
      aux_sym__simple_string_char_token1,
    ACTIONS(6814), 1,
      anon_sym_LBRACE2,
    ACTIONS(6818), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(6820), 1,
      anon_sym_POUNDlight,
    ACTIONS(6822), 1,
      anon_sym_POUNDr,
    ACTIONS(6824), 1,
      sym__inside_string_marker,
    ACTIONS(6921), 1,
      anon_sym_DQUOTE,
    STATE(4703), 1,
      aux_sym_format_string_repeat1,
    STATE(5198), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6808), 2,
      sym__escape_char,
      sym__non_escape_char,
    STATE(5339), 2,
      sym__string_char,
      sym_format_string_eval,
    ACTIONS(6810), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(4650), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [117465] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2510), 3,
      anon_sym_COLON,
      anon_sym_as,
      sym_identifier,
    STATE(4651), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2512), 10,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [117510] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2474), 3,
      anon_sym_COLON,
      anon_sym_as,
      sym_identifier,
    STATE(4652), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2476), 10,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [117555] = 16,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(133), 1,
      sym_line_comment,
    ACTIONS(6812), 1,
      aux_sym__simple_string_char_token1,
    ACTIONS(6814), 1,
      anon_sym_LBRACE2,
    ACTIONS(6818), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(6820), 1,
      anon_sym_POUNDlight,
    ACTIONS(6822), 1,
      anon_sym_POUNDr,
    ACTIONS(6824), 1,
      sym__inside_string_marker,
    ACTIONS(6923), 1,
      anon_sym_DQUOTE,
    STATE(4643), 1,
      aux_sym_format_string_repeat1,
    STATE(5198), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6808), 2,
      sym__escape_char,
      sym__non_escape_char,
    STATE(5339), 2,
      sym__string_char,
      sym_format_string_eval,
    ACTIONS(6810), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(4653), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [117612] = 16,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(133), 1,
      sym_line_comment,
    ACTIONS(6812), 1,
      aux_sym__simple_string_char_token1,
    ACTIONS(6814), 1,
      anon_sym_LBRACE2,
    ACTIONS(6818), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(6820), 1,
      anon_sym_POUNDlight,
    ACTIONS(6822), 1,
      anon_sym_POUNDr,
    ACTIONS(6824), 1,
      sym__inside_string_marker,
    ACTIONS(6925), 1,
      anon_sym_DQUOTE,
    STATE(4641), 1,
      aux_sym_format_string_repeat1,
    STATE(5198), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6808), 2,
      sym__escape_char,
      sym__non_escape_char,
    STATE(5339), 2,
      sym__string_char,
      sym_format_string_eval,
    ACTIONS(6810), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(4654), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [117669] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2250), 1,
      anon_sym_with,
    ACTIONS(5768), 1,
      sym_identifier,
    ACTIONS(6871), 1,
      anon_sym_DASH_GT,
    ACTIONS(6873), 1,
      anon_sym_STAR,
    ACTIONS(6875), 1,
      anon_sym_LT2,
    ACTIONS(6877), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4859), 1,
      aux_sym_compound_type_repeat1,
    STATE(4991), 1,
      sym_long_identifier,
    STATE(5160), 1,
      sym_type_arguments,
    ACTIONS(2248), 4,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT,
    STATE(4655), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [117730] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2246), 1,
      anon_sym_with,
    ACTIONS(5768), 1,
      sym_identifier,
    ACTIONS(6871), 1,
      anon_sym_DASH_GT,
    ACTIONS(6873), 1,
      anon_sym_STAR,
    ACTIONS(6875), 1,
      anon_sym_LT2,
    ACTIONS(6877), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4859), 1,
      aux_sym_compound_type_repeat1,
    STATE(4991), 1,
      sym_long_identifier,
    STATE(5160), 1,
      sym_type_arguments,
    ACTIONS(2244), 4,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT,
    STATE(4656), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [117791] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2466), 3,
      anon_sym_COLON,
      anon_sym_as,
      sym_identifier,
    STATE(4657), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2468), 10,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [117836] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6855), 1,
      anon_sym_and,
    STATE(4701), 1,
      aux_sym__function_or_value_defns_repeat1,
    STATE(4658), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4681), 11,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [117883] = 16,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(133), 1,
      sym_line_comment,
    ACTIONS(6812), 1,
      aux_sym__simple_string_char_token1,
    ACTIONS(6814), 1,
      anon_sym_LBRACE2,
    ACTIONS(6818), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(6820), 1,
      anon_sym_POUNDlight,
    ACTIONS(6822), 1,
      anon_sym_POUNDr,
    ACTIONS(6824), 1,
      sym__inside_string_marker,
    ACTIONS(6927), 1,
      anon_sym_DQUOTE,
    STATE(4643), 1,
      aux_sym_format_string_repeat1,
    STATE(5198), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6808), 2,
      sym__escape_char,
      sym__non_escape_char,
    STATE(5339), 2,
      sym__string_char,
      sym_format_string_eval,
    ACTIONS(6810), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(4659), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [117940] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2627), 3,
      anon_sym_COLON,
      anon_sym_as,
      sym_identifier,
    STATE(4660), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2629), 10,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [117985] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2514), 3,
      anon_sym_COLON,
      anon_sym_as,
      sym_identifier,
    STATE(4661), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2516), 10,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [118030] = 16,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(133), 1,
      sym_line_comment,
    ACTIONS(6812), 1,
      aux_sym__simple_string_char_token1,
    ACTIONS(6814), 1,
      anon_sym_LBRACE2,
    ACTIONS(6818), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(6820), 1,
      anon_sym_POUNDlight,
    ACTIONS(6822), 1,
      anon_sym_POUNDr,
    ACTIONS(6824), 1,
      sym__inside_string_marker,
    ACTIONS(6929), 1,
      anon_sym_DQUOTE,
    STATE(4671), 1,
      aux_sym_format_string_repeat1,
    STATE(5198), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6808), 2,
      sym__escape_char,
      sym__non_escape_char,
    STATE(5339), 2,
      sym__string_char,
      sym_format_string_eval,
    ACTIONS(6810), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(4662), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [118087] = 16,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(133), 1,
      sym_line_comment,
    ACTIONS(6812), 1,
      aux_sym__simple_string_char_token1,
    ACTIONS(6814), 1,
      anon_sym_LBRACE2,
    ACTIONS(6818), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(6820), 1,
      anon_sym_POUNDlight,
    ACTIONS(6822), 1,
      anon_sym_POUNDr,
    ACTIONS(6824), 1,
      sym__inside_string_marker,
    ACTIONS(6931), 1,
      anon_sym_DQUOTE,
    STATE(4653), 1,
      aux_sym_format_string_repeat1,
    STATE(5198), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6808), 2,
      sym__escape_char,
      sym__non_escape_char,
    STATE(5339), 2,
      sym__string_char,
      sym_format_string_eval,
    ACTIONS(6810), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(4663), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [118144] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2567), 3,
      anon_sym_COLON,
      anon_sym_as,
      sym_identifier,
    STATE(4664), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2569), 10,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [118189] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2553), 3,
      anon_sym_COLON,
      anon_sym_as,
      sym_identifier,
    STATE(4665), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2555), 10,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [118234] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2553), 3,
      anon_sym_COLON,
      anon_sym_as,
      sym_identifier,
    STATE(4666), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2555), 10,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [118279] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2454), 3,
      anon_sym_COLON,
      anon_sym_as,
      sym_identifier,
    STATE(4667), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2456), 10,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [118324] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2506), 3,
      anon_sym_COLON,
      anon_sym_as,
      sym_identifier,
    STATE(4668), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2508), 10,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [118369] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2474), 3,
      anon_sym_COLON,
      anon_sym_as,
      sym_identifier,
    STATE(4669), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2476), 10,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [118414] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2510), 3,
      anon_sym_COLON,
      anon_sym_as,
      sym_identifier,
    STATE(4670), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2512), 10,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [118459] = 16,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(133), 1,
      sym_line_comment,
    ACTIONS(6812), 1,
      aux_sym__simple_string_char_token1,
    ACTIONS(6814), 1,
      anon_sym_LBRACE2,
    ACTIONS(6818), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(6820), 1,
      anon_sym_POUNDlight,
    ACTIONS(6822), 1,
      anon_sym_POUNDr,
    ACTIONS(6824), 1,
      sym__inside_string_marker,
    ACTIONS(6933), 1,
      anon_sym_DQUOTE,
    STATE(4643), 1,
      aux_sym_format_string_repeat1,
    STATE(5198), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6808), 2,
      sym__escape_char,
      sym__non_escape_char,
    STATE(5339), 2,
      sym__string_char,
      sym_format_string_eval,
    ACTIONS(6810), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(4671), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [118516] = 16,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(133), 1,
      sym_line_comment,
    ACTIONS(6812), 1,
      aux_sym__simple_string_char_token1,
    ACTIONS(6814), 1,
      anon_sym_LBRACE2,
    ACTIONS(6818), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(6820), 1,
      anon_sym_POUNDlight,
    ACTIONS(6822), 1,
      anon_sym_POUNDr,
    ACTIONS(6824), 1,
      sym__inside_string_marker,
    ACTIONS(6935), 1,
      anon_sym_DQUOTE,
    STATE(4643), 1,
      aux_sym_format_string_repeat1,
    STATE(5198), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6808), 2,
      sym__escape_char,
      sym__non_escape_char,
    STATE(5339), 2,
      sym__string_char,
      sym_format_string_eval,
    ACTIONS(6810), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(4672), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [118573] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    STATE(4673), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2553), 5,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_when,
      sym_identifier,
    ACTIONS(2555), 8,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [118618] = 16,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(133), 1,
      sym_line_comment,
    ACTIONS(6812), 1,
      aux_sym__simple_string_char_token1,
    ACTIONS(6814), 1,
      anon_sym_LBRACE2,
    ACTIONS(6818), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(6820), 1,
      anon_sym_POUNDlight,
    ACTIONS(6822), 1,
      anon_sym_POUNDr,
    ACTIONS(6824), 1,
      sym__inside_string_marker,
    ACTIONS(6937), 1,
      anon_sym_DQUOTE,
    STATE(4603), 1,
      aux_sym_format_string_repeat1,
    STATE(5198), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6808), 2,
      sym__escape_char,
      sym__non_escape_char,
    STATE(5339), 2,
      sym__string_char,
      sym_format_string_eval,
    ACTIONS(6810), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(4674), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [118675] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    STATE(4675), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2567), 5,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_in,
      sym_identifier,
    ACTIONS(2569), 8,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [118720] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    STATE(4676), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2563), 5,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_when,
      sym_identifier,
    ACTIONS(2565), 8,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [118765] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    STATE(4677), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2514), 5,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_when,
      sym_identifier,
    ACTIONS(2516), 8,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [118810] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2563), 3,
      anon_sym_COLON,
      anon_sym_as,
      sym_identifier,
    STATE(4678), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2565), 10,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [118855] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    STATE(4679), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2627), 5,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_when,
      sym_identifier,
    ACTIONS(2629), 8,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [118900] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    STATE(4680), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2466), 5,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_when,
      sym_identifier,
    ACTIONS(2468), 8,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [118945] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    STATE(4681), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2474), 5,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_when,
      sym_identifier,
    ACTIONS(2476), 8,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [118990] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    STATE(4682), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2510), 5,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_when,
      sym_identifier,
    ACTIONS(2512), 8,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [119035] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6939), 1,
      anon_sym_LT2,
    STATE(4683), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2557), 5,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_when,
      sym_identifier,
    ACTIONS(2559), 7,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LBRACK_RBRACK,
  [119082] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    STATE(4684), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2567), 5,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_when,
      sym_identifier,
    ACTIONS(2569), 8,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [119127] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6941), 1,
      anon_sym_LT2,
    ACTIONS(2557), 3,
      anon_sym_COLON,
      anon_sym_as,
      sym_identifier,
    STATE(4685), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2559), 9,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LBRACK_RBRACK,
  [119174] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6779), 1,
      anon_sym_or,
    STATE(4520), 1,
      aux_sym_type_argument_repeat1,
    ACTIONS(2321), 2,
      anon_sym_with,
      sym_identifier,
    STATE(4686), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2323), 9,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [119223] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2462), 4,
      anon_sym_COLON,
      anon_sym_with,
      anon_sym_or,
      sym_identifier,
    STATE(4687), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2464), 9,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [119268] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2242), 1,
      anon_sym_with,
    ACTIONS(5768), 1,
      sym_identifier,
    ACTIONS(6871), 1,
      anon_sym_DASH_GT,
    ACTIONS(6873), 1,
      anon_sym_STAR,
    ACTIONS(6875), 1,
      anon_sym_LT2,
    ACTIONS(6877), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(4859), 1,
      aux_sym_compound_type_repeat1,
    STATE(4991), 1,
      sym_long_identifier,
    STATE(5160), 1,
      sym_type_arguments,
    ACTIONS(2240), 4,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT,
    STATE(4688), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [119329] = 16,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(133), 1,
      sym_line_comment,
    ACTIONS(6812), 1,
      aux_sym__simple_string_char_token1,
    ACTIONS(6814), 1,
      anon_sym_LBRACE2,
    ACTIONS(6818), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(6820), 1,
      anon_sym_POUNDlight,
    ACTIONS(6822), 1,
      anon_sym_POUNDr,
    ACTIONS(6824), 1,
      sym__inside_string_marker,
    ACTIONS(6943), 1,
      anon_sym_DQUOTE,
    STATE(4590), 1,
      aux_sym_format_string_repeat1,
    STATE(5198), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6808), 2,
      sym__escape_char,
      sym__non_escape_char,
    STATE(5339), 2,
      sym__string_char,
      sym_format_string_eval,
    ACTIONS(6810), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(4689), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [119386] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2567), 3,
      anon_sym_COLON,
      anon_sym_as,
      sym_identifier,
    STATE(4690), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2569), 10,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [119431] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2321), 1,
      anon_sym_COLON,
    STATE(4691), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2323), 12,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_in,
      anon_sym_DASH_GT,
      anon_sym_GT,
      anon_sym_when,
      anon_sym_LT2,
  [119476] = 16,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(133), 1,
      sym_line_comment,
    ACTIONS(6812), 1,
      aux_sym__simple_string_char_token1,
    ACTIONS(6814), 1,
      anon_sym_LBRACE2,
    ACTIONS(6818), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(6820), 1,
      anon_sym_POUNDlight,
    ACTIONS(6822), 1,
      anon_sym_POUNDr,
    ACTIONS(6824), 1,
      sym__inside_string_marker,
    ACTIONS(6945), 1,
      anon_sym_DQUOTE,
    STATE(4643), 1,
      aux_sym_format_string_repeat1,
    STATE(5198), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6808), 2,
      sym__escape_char,
      sym__non_escape_char,
    STATE(5339), 2,
      sym__string_char,
      sym_format_string_eval,
    ACTIONS(6810), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(4692), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [119533] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    STATE(4693), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2454), 5,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_when,
      sym_identifier,
    ACTIONS(2456), 8,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [119578] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    STATE(4694), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2470), 5,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_when,
      sym_identifier,
    ACTIONS(2472), 8,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [119623] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    STATE(4695), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2510), 5,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_in,
      sym_identifier,
    ACTIONS(2512), 8,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [119668] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    STATE(4696), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2553), 5,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_in,
      sym_identifier,
    ACTIONS(2555), 8,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [119713] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    STATE(4697), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2563), 5,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_in,
      sym_identifier,
    ACTIONS(2565), 8,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [119758] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    STATE(4698), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2506), 5,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_when,
      sym_identifier,
    ACTIONS(2508), 8,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [119803] = 16,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(133), 1,
      sym_line_comment,
    ACTIONS(6812), 1,
      aux_sym__simple_string_char_token1,
    ACTIONS(6814), 1,
      anon_sym_LBRACE2,
    ACTIONS(6818), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(6820), 1,
      anon_sym_POUNDlight,
    ACTIONS(6822), 1,
      anon_sym_POUNDr,
    ACTIONS(6824), 1,
      sym__inside_string_marker,
    ACTIONS(6947), 1,
      anon_sym_DQUOTE,
    STATE(4704), 1,
      aux_sym_format_string_repeat1,
    STATE(5198), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6808), 2,
      sym__escape_char,
      sym__non_escape_char,
    STATE(5339), 2,
      sym__string_char,
      sym_format_string_eval,
    ACTIONS(6810), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(4699), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [119860] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    STATE(4700), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2514), 5,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_in,
      sym_identifier,
    ACTIONS(2516), 8,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [119905] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6949), 1,
      anon_sym_and,
    STATE(4701), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym__function_or_value_defns_repeat1,
    ACTIONS(4692), 11,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [119950] = 16,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(133), 1,
      sym_line_comment,
    ACTIONS(6812), 1,
      aux_sym__simple_string_char_token1,
    ACTIONS(6814), 1,
      anon_sym_LBRACE2,
    ACTIONS(6818), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(6820), 1,
      anon_sym_POUNDlight,
    ACTIONS(6822), 1,
      anon_sym_POUNDr,
    ACTIONS(6824), 1,
      sym__inside_string_marker,
    ACTIONS(6952), 1,
      anon_sym_DQUOTE,
    STATE(4643), 1,
      aux_sym_format_string_repeat1,
    STATE(5198), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6808), 2,
      sym__escape_char,
      sym__non_escape_char,
    STATE(5339), 2,
      sym__string_char,
      sym_format_string_eval,
    ACTIONS(6810), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(4702), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [120007] = 16,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(133), 1,
      sym_line_comment,
    ACTIONS(6812), 1,
      aux_sym__simple_string_char_token1,
    ACTIONS(6814), 1,
      anon_sym_LBRACE2,
    ACTIONS(6818), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(6820), 1,
      anon_sym_POUNDlight,
    ACTIONS(6822), 1,
      anon_sym_POUNDr,
    ACTIONS(6824), 1,
      sym__inside_string_marker,
    ACTIONS(6954), 1,
      anon_sym_DQUOTE,
    STATE(4643), 1,
      aux_sym_format_string_repeat1,
    STATE(5198), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6808), 2,
      sym__escape_char,
      sym__non_escape_char,
    STATE(5339), 2,
      sym__string_char,
      sym_format_string_eval,
    ACTIONS(6810), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(4703), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [120064] = 16,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(133), 1,
      sym_line_comment,
    ACTIONS(6812), 1,
      aux_sym__simple_string_char_token1,
    ACTIONS(6814), 1,
      anon_sym_LBRACE2,
    ACTIONS(6818), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(6820), 1,
      anon_sym_POUNDlight,
    ACTIONS(6822), 1,
      anon_sym_POUNDr,
    ACTIONS(6824), 1,
      sym__inside_string_marker,
    ACTIONS(6956), 1,
      anon_sym_DQUOTE,
    STATE(4643), 1,
      aux_sym_format_string_repeat1,
    STATE(5198), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6808), 2,
      sym__escape_char,
      sym__non_escape_char,
    STATE(5339), 2,
      sym__string_char,
      sym_format_string_eval,
    ACTIONS(6810), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(4704), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [120121] = 16,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(133), 1,
      sym_line_comment,
    ACTIONS(6812), 1,
      aux_sym__simple_string_char_token1,
    ACTIONS(6814), 1,
      anon_sym_LBRACE2,
    ACTIONS(6818), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(6820), 1,
      anon_sym_POUNDlight,
    ACTIONS(6822), 1,
      anon_sym_POUNDr,
    ACTIONS(6824), 1,
      sym__inside_string_marker,
    ACTIONS(6958), 1,
      anon_sym_DQUOTE,
    STATE(4692), 1,
      aux_sym_format_string_repeat1,
    STATE(5198), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6808), 2,
      sym__escape_char,
      sym__non_escape_char,
    STATE(5339), 2,
      sym__string_char,
      sym_format_string_eval,
    ACTIONS(6810), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(4705), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [120178] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    STATE(4706), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2474), 5,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_in,
      sym_identifier,
    ACTIONS(2476), 8,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [120223] = 16,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(133), 1,
      sym_line_comment,
    ACTIONS(6812), 1,
      aux_sym__simple_string_char_token1,
    ACTIONS(6814), 1,
      anon_sym_LBRACE2,
    ACTIONS(6818), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(6820), 1,
      anon_sym_POUNDlight,
    ACTIONS(6822), 1,
      anon_sym_POUNDr,
    ACTIONS(6824), 1,
      sym__inside_string_marker,
    ACTIONS(6960), 1,
      anon_sym_DQUOTE,
    STATE(4702), 1,
      aux_sym_format_string_repeat1,
    STATE(5198), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6808), 2,
      sym__escape_char,
      sym__non_escape_char,
    STATE(5339), 2,
      sym__string_char,
      sym_format_string_eval,
    ACTIONS(6810), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(4707), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [120280] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2563), 3,
      anon_sym_COLON,
      anon_sym_as,
      sym_identifier,
    STATE(4708), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2565), 10,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [120325] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    STATE(4709), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2466), 5,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_as,
      anon_sym_in,
      sym_identifier,
    ACTIONS(2468), 8,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [120370] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6962), 1,
      anon_sym_DOT,
    STATE(4725), 1,
      aux_sym_long_identifier_repeat1,
    ACTIONS(2418), 2,
      anon_sym_with,
      sym_identifier,
    STATE(4710), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2420), 8,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [120418] = 15,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(133), 1,
      sym_line_comment,
    ACTIONS(6818), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(6820), 1,
      anon_sym_POUNDlight,
    ACTIONS(6822), 1,
      anon_sym_POUNDr,
    ACTIONS(6970), 1,
      anon_sym_DQUOTE,
    ACTIONS(6972), 1,
      anon_sym_DQUOTEB,
    STATE(4768), 1,
      aux_sym__string_literal_repeat1,
    STATE(5200), 1,
      sym__string_char,
    STATE(5374), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6964), 2,
      sym__escape_char,
      sym__non_escape_char,
    ACTIONS(6968), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(6966), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(4711), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [120472] = 15,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(133), 1,
      sym_line_comment,
    ACTIONS(6818), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(6820), 1,
      anon_sym_POUNDlight,
    ACTIONS(6822), 1,
      anon_sym_POUNDr,
    ACTIONS(6974), 1,
      anon_sym_DQUOTE,
    ACTIONS(6976), 1,
      anon_sym_DQUOTEB,
    STATE(4716), 1,
      aux_sym__string_literal_repeat1,
    STATE(5200), 1,
      sym__string_char,
    STATE(5374), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6964), 2,
      sym__escape_char,
      sym__non_escape_char,
    ACTIONS(6968), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(6966), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(4712), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [120526] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2627), 4,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_in,
      sym_identifier,
    STATE(4713), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2629), 8,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [120570] = 15,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(133), 1,
      sym_line_comment,
    ACTIONS(6818), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(6820), 1,
      anon_sym_POUNDlight,
    ACTIONS(6822), 1,
      anon_sym_POUNDr,
    ACTIONS(6978), 1,
      anon_sym_DQUOTE,
    ACTIONS(6980), 1,
      anon_sym_DQUOTEB,
    STATE(4747), 1,
      aux_sym__string_literal_repeat1,
    STATE(5200), 1,
      sym__string_char,
    STATE(5374), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6964), 2,
      sym__escape_char,
      sym__non_escape_char,
    ACTIONS(6968), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(6966), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(4714), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [120624] = 15,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(133), 1,
      sym_line_comment,
    ACTIONS(6818), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(6820), 1,
      anon_sym_POUNDlight,
    ACTIONS(6822), 1,
      anon_sym_POUNDr,
    ACTIONS(6982), 1,
      anon_sym_DQUOTE,
    ACTIONS(6984), 1,
      anon_sym_DQUOTEB,
    STATE(4759), 1,
      aux_sym__string_literal_repeat1,
    STATE(5200), 1,
      sym__string_char,
    STATE(5374), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6964), 2,
      sym__escape_char,
      sym__non_escape_char,
    ACTIONS(6968), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(6966), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(4715), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [120678] = 15,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(133), 1,
      sym_line_comment,
    ACTIONS(6818), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(6820), 1,
      anon_sym_POUNDlight,
    ACTIONS(6822), 1,
      anon_sym_POUNDr,
    ACTIONS(6986), 1,
      anon_sym_DQUOTE,
    ACTIONS(6988), 1,
      anon_sym_DQUOTEB,
    STATE(4825), 1,
      aux_sym__string_literal_repeat1,
    STATE(5200), 1,
      sym__string_char,
    STATE(5374), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6964), 2,
      sym__escape_char,
      sym__non_escape_char,
    ACTIONS(6968), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(6966), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(4716), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [120732] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2230), 1,
      anon_sym_val,
    ACTIONS(6109), 1,
      sym_identifier,
    ACTIONS(6990), 1,
      anon_sym_DASH_GT,
    ACTIONS(6992), 1,
      anon_sym_STAR,
    ACTIONS(6994), 1,
      anon_sym_LT2,
    ACTIONS(6996), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(5044), 1,
      aux_sym_compound_type_repeat1,
    STATE(5223), 1,
      sym_type_arguments,
    STATE(5355), 1,
      sym_long_identifier,
    ACTIONS(2228), 3,
      ts_builtin_sym_end,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
    STATE(4717), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [120792] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5665), 1,
      anon_sym_COLON,
    STATE(4718), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5667), 11,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_in,
      anon_sym_DASH_GT,
      anon_sym_when,
      anon_sym_LT2,
  [120836] = 15,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(133), 1,
      sym_line_comment,
    ACTIONS(6818), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(6820), 1,
      anon_sym_POUNDlight,
    ACTIONS(6822), 1,
      anon_sym_POUNDr,
    ACTIONS(6998), 1,
      anon_sym_DQUOTE,
    ACTIONS(7000), 1,
      anon_sym_DQUOTEB,
    STATE(4825), 1,
      aux_sym__string_literal_repeat1,
    STATE(5200), 1,
      sym__string_char,
    STATE(5374), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6964), 2,
      sym__escape_char,
      sym__non_escape_char,
    ACTIONS(6968), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(6966), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(4719), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [120890] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2859), 1,
      anon_sym_COLON,
    STATE(4720), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2861), 11,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_in,
      anon_sym_DASH_GT,
      anon_sym_when,
      anon_sym_LT2,
  [120934] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    STATE(4721), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4700), 12,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_and,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [120976] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2567), 4,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_in,
      sym_identifier,
    STATE(4722), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2569), 8,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [121020] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2506), 4,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_in,
      sym_identifier,
    STATE(4723), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2508), 8,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [121064] = 15,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(133), 1,
      sym_line_comment,
    ACTIONS(6818), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(6820), 1,
      anon_sym_POUNDlight,
    ACTIONS(6822), 1,
      anon_sym_POUNDr,
    ACTIONS(7002), 1,
      anon_sym_DQUOTE,
    ACTIONS(7004), 1,
      anon_sym_DQUOTEB,
    STATE(4758), 1,
      aux_sym__string_literal_repeat1,
    STATE(5200), 1,
      sym__string_char,
    STATE(5374), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6964), 2,
      sym__escape_char,
      sym__non_escape_char,
    ACTIONS(6968), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(6966), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(4724), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [121118] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7006), 1,
      anon_sym_DOT,
    ACTIONS(2411), 2,
      anon_sym_with,
      sym_identifier,
    STATE(4725), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_long_identifier_repeat1,
    ACTIONS(2413), 8,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [121164] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5624), 1,
      anon_sym_COLON,
    STATE(4726), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5626), 11,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_in,
      anon_sym_DASH_GT,
      anon_sym_when,
      anon_sym_LT2,
  [121208] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2926), 1,
      anon_sym_COLON,
    STATE(4727), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2928), 11,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_in,
      anon_sym_DASH_GT,
      anon_sym_when,
      anon_sym_LT2,
  [121252] = 15,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(133), 1,
      sym_line_comment,
    ACTIONS(6818), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(6820), 1,
      anon_sym_POUNDlight,
    ACTIONS(6822), 1,
      anon_sym_POUNDr,
    ACTIONS(7009), 1,
      anon_sym_DQUOTE,
    ACTIONS(7011), 1,
      anon_sym_DQUOTEB,
    STATE(4756), 1,
      aux_sym__string_literal_repeat1,
    STATE(5200), 1,
      sym__string_char,
    STATE(5374), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6964), 2,
      sym__escape_char,
      sym__non_escape_char,
    ACTIONS(6968), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(6966), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(4728), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [121306] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2514), 4,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_in,
      sym_identifier,
    STATE(4729), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2516), 8,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [121350] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2321), 4,
      anon_sym_with,
      anon_sym_interface,
      anon_sym_val,
      sym_identifier,
    STATE(4730), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2323), 8,
      sym__dedent,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [121394] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2934), 1,
      anon_sym_COLON,
    STATE(4731), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2936), 11,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_in,
      anon_sym_DASH_GT,
      anon_sym_when,
      anon_sym_LT2,
  [121438] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2470), 4,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_in,
      sym_identifier,
    STATE(4732), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2472), 8,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [121482] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2563), 4,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_in,
      sym_identifier,
    STATE(4733), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2565), 8,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [121526] = 15,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(133), 1,
      sym_line_comment,
    ACTIONS(6818), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(6820), 1,
      anon_sym_POUNDlight,
    ACTIONS(6822), 1,
      anon_sym_POUNDr,
    ACTIONS(7013), 1,
      anon_sym_DQUOTE,
    ACTIONS(7015), 1,
      anon_sym_DQUOTEB,
    STATE(4855), 1,
      aux_sym__string_literal_repeat1,
    STATE(5200), 1,
      sym__string_char,
    STATE(5374), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6964), 2,
      sym__escape_char,
      sym__non_escape_char,
    ACTIONS(6968), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(6966), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(4734), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [121580] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2553), 4,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_in,
      sym_identifier,
    STATE(4735), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2555), 8,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [121624] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2843), 1,
      anon_sym_COLON,
    STATE(4736), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2845), 11,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_in,
      anon_sym_DASH_GT,
      anon_sym_when,
      anon_sym_LT2,
  [121668] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5642), 1,
      anon_sym_COLON,
    STATE(4737), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5644), 11,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_in,
      anon_sym_DASH_GT,
      anon_sym_when,
      anon_sym_LT2,
  [121712] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7017), 1,
      anon_sym_LT2,
    ACTIONS(2557), 4,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_in,
      sym_identifier,
    STATE(4738), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2559), 7,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LBRACK_RBRACK,
  [121758] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5638), 1,
      anon_sym_COLON,
    STATE(4739), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5640), 11,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_in,
      anon_sym_DASH_GT,
      anon_sym_when,
      anon_sym_LT2,
  [121802] = 15,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(133), 1,
      sym_line_comment,
    ACTIONS(6818), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(6820), 1,
      anon_sym_POUNDlight,
    ACTIONS(6822), 1,
      anon_sym_POUNDr,
    ACTIONS(7019), 1,
      anon_sym_DQUOTE,
    ACTIONS(7021), 1,
      anon_sym_DQUOTEB,
    STATE(4719), 1,
      aux_sym__string_literal_repeat1,
    STATE(5200), 1,
      sym__string_char,
    STATE(5374), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6964), 2,
      sym__escape_char,
      sym__non_escape_char,
    ACTIONS(6968), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(6966), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(4740), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [121856] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2454), 4,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_in,
      sym_identifier,
    STATE(4741), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2456), 8,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [121900] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5634), 1,
      anon_sym_COLON,
    STATE(4742), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5636), 11,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_in,
      anon_sym_DASH_GT,
      anon_sym_when,
      anon_sym_LT2,
  [121944] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2819), 1,
      anon_sym_COLON,
    ACTIONS(7023), 1,
      sym_int,
    STATE(4743), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2821), 10,
      sym__newline,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
      anon_sym_f,
      aux_sym_decimal_token1,
  [121990] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5628), 1,
      anon_sym_COLON,
    STATE(4744), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5630), 11,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_in,
      anon_sym_DASH_GT,
      anon_sym_when,
      anon_sym_LT2,
  [122034] = 15,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(133), 1,
      sym_line_comment,
    ACTIONS(6818), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(6820), 1,
      anon_sym_POUNDlight,
    ACTIONS(6822), 1,
      anon_sym_POUNDr,
    ACTIONS(7025), 1,
      anon_sym_DQUOTE,
    ACTIONS(7027), 1,
      anon_sym_DQUOTEB,
    STATE(4825), 1,
      aux_sym__string_literal_repeat1,
    STATE(5200), 1,
      sym__string_char,
    STATE(5374), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6964), 2,
      sym__escape_char,
      sym__non_escape_char,
    ACTIONS(6968), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(6966), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(4745), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [122088] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2855), 1,
      anon_sym_COLON,
    STATE(4746), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2857), 11,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_in,
      anon_sym_DASH_GT,
      anon_sym_when,
      anon_sym_LT2,
  [122132] = 15,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(133), 1,
      sym_line_comment,
    ACTIONS(6818), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(6820), 1,
      anon_sym_POUNDlight,
    ACTIONS(6822), 1,
      anon_sym_POUNDr,
    ACTIONS(7029), 1,
      anon_sym_DQUOTE,
    ACTIONS(7031), 1,
      anon_sym_DQUOTEB,
    STATE(4825), 1,
      aux_sym__string_literal_repeat1,
    STATE(5200), 1,
      sym__string_char,
    STATE(5374), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6964), 2,
      sym__escape_char,
      sym__non_escape_char,
    ACTIONS(6968), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(6966), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(4747), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [122186] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6109), 1,
      sym_identifier,
    ACTIONS(6990), 1,
      anon_sym_DASH_GT,
    ACTIONS(6992), 1,
      anon_sym_STAR,
    ACTIONS(6994), 1,
      anon_sym_LT2,
    ACTIONS(6996), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(7035), 1,
      anon_sym_EQ,
    ACTIONS(7037), 1,
      anon_sym_val,
    STATE(5044), 1,
      aux_sym_compound_type_repeat1,
    STATE(5223), 1,
      sym_type_arguments,
    STATE(5355), 1,
      sym_long_identifier,
    ACTIONS(7033), 2,
      ts_builtin_sym_end,
      anon_sym_LBRACK_LT,
    STATE(4748), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [122248] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5860), 1,
      sym_identifier,
    ACTIONS(6771), 1,
      anon_sym_DASH_GT,
    ACTIONS(6773), 1,
      anon_sym_STAR,
    ACTIONS(6775), 1,
      anon_sym_LT2,
    ACTIONS(6777), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(7037), 1,
      anon_sym_val,
    ACTIONS(7039), 1,
      anon_sym_EQ,
    STATE(4769), 1,
      aux_sym_compound_type_repeat1,
    STATE(4860), 1,
      sym_type_arguments,
    STATE(4885), 1,
      sym_long_identifier,
    ACTIONS(7033), 2,
      sym__dedent,
      anon_sym_LBRACK_LT,
    STATE(4749), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [122310] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7043), 1,
      anon_sym_COMMA,
    STATE(4750), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7041), 11,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [122354] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7045), 1,
      anon_sym_COMMA,
    STATE(4751), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7041), 11,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [122398] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2510), 4,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_in,
      sym_identifier,
    STATE(4752), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2512), 8,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [122442] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6962), 1,
      anon_sym_DOT,
    STATE(4710), 1,
      aux_sym_long_identifier_repeat1,
    ACTIONS(2312), 2,
      anon_sym_with,
      sym_identifier,
    STATE(4753), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2314), 8,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [122490] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2474), 4,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_in,
      sym_identifier,
    STATE(4754), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2476), 8,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [122534] = 15,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(133), 1,
      sym_line_comment,
    ACTIONS(6818), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(6820), 1,
      anon_sym_POUNDlight,
    ACTIONS(6822), 1,
      anon_sym_POUNDr,
    ACTIONS(7047), 1,
      anon_sym_DQUOTE,
    ACTIONS(7049), 1,
      anon_sym_DQUOTEB,
    STATE(4825), 1,
      aux_sym__string_literal_repeat1,
    STATE(5200), 1,
      sym__string_char,
    STATE(5374), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6964), 2,
      sym__escape_char,
      sym__non_escape_char,
    ACTIONS(6968), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(6966), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(4755), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [122588] = 15,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(133), 1,
      sym_line_comment,
    ACTIONS(6818), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(6820), 1,
      anon_sym_POUNDlight,
    ACTIONS(6822), 1,
      anon_sym_POUNDr,
    ACTIONS(7051), 1,
      anon_sym_DQUOTE,
    ACTIONS(7053), 1,
      anon_sym_DQUOTEB,
    STATE(4825), 1,
      aux_sym__string_literal_repeat1,
    STATE(5200), 1,
      sym__string_char,
    STATE(5374), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6964), 2,
      sym__escape_char,
      sym__non_escape_char,
    ACTIONS(6968), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(6966), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(4756), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [122642] = 15,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(133), 1,
      sym_line_comment,
    ACTIONS(6818), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(6820), 1,
      anon_sym_POUNDlight,
    ACTIONS(6822), 1,
      anon_sym_POUNDr,
    ACTIONS(7055), 1,
      anon_sym_DQUOTE,
    ACTIONS(7057), 1,
      anon_sym_DQUOTEB,
    STATE(4792), 1,
      aux_sym__string_literal_repeat1,
    STATE(5200), 1,
      sym__string_char,
    STATE(5374), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6964), 2,
      sym__escape_char,
      sym__non_escape_char,
    ACTIONS(6968), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(6966), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(4757), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [122696] = 15,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(133), 1,
      sym_line_comment,
    ACTIONS(6818), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(6820), 1,
      anon_sym_POUNDlight,
    ACTIONS(6822), 1,
      anon_sym_POUNDr,
    ACTIONS(7059), 1,
      anon_sym_DQUOTE,
    ACTIONS(7061), 1,
      anon_sym_DQUOTEB,
    STATE(4825), 1,
      aux_sym__string_literal_repeat1,
    STATE(5200), 1,
      sym__string_char,
    STATE(5374), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6964), 2,
      sym__escape_char,
      sym__non_escape_char,
    ACTIONS(6968), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(6966), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(4758), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [122750] = 15,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(133), 1,
      sym_line_comment,
    ACTIONS(6818), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(6820), 1,
      anon_sym_POUNDlight,
    ACTIONS(6822), 1,
      anon_sym_POUNDr,
    ACTIONS(7063), 1,
      anon_sym_DQUOTE,
    ACTIONS(7065), 1,
      anon_sym_DQUOTEB,
    STATE(4825), 1,
      aux_sym__string_literal_repeat1,
    STATE(5200), 1,
      sym__string_char,
    STATE(5374), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6964), 2,
      sym__escape_char,
      sym__non_escape_char,
    ACTIONS(6968), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(6966), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(4759), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [122804] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    STATE(4760), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4696), 12,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_and,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [122846] = 15,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(133), 1,
      sym_line_comment,
    ACTIONS(6818), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(6820), 1,
      anon_sym_POUNDlight,
    ACTIONS(6822), 1,
      anon_sym_POUNDr,
    ACTIONS(7067), 1,
      anon_sym_DQUOTE,
    ACTIONS(7069), 1,
      anon_sym_DQUOTEB,
    STATE(4825), 1,
      aux_sym__string_literal_repeat1,
    STATE(5200), 1,
      sym__string_char,
    STATE(5374), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6964), 2,
      sym__escape_char,
      sym__non_escape_char,
    ACTIONS(6968), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(6966), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(4761), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [122900] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2242), 1,
      anon_sym_val,
    ACTIONS(6109), 1,
      sym_identifier,
    ACTIONS(6990), 1,
      anon_sym_DASH_GT,
    ACTIONS(6992), 1,
      anon_sym_STAR,
    ACTIONS(6994), 1,
      anon_sym_LT2,
    ACTIONS(6996), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(5044), 1,
      aux_sym_compound_type_repeat1,
    STATE(5223), 1,
      sym_type_arguments,
    STATE(5355), 1,
      sym_long_identifier,
    ACTIONS(2240), 3,
      ts_builtin_sym_end,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
    STATE(4762), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [122960] = 15,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(133), 1,
      sym_line_comment,
    ACTIONS(6818), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(6820), 1,
      anon_sym_POUNDlight,
    ACTIONS(6822), 1,
      anon_sym_POUNDr,
    ACTIONS(7071), 1,
      anon_sym_DQUOTE,
    ACTIONS(7073), 1,
      anon_sym_DQUOTEB,
    STATE(4755), 1,
      aux_sym__string_literal_repeat1,
    STATE(5200), 1,
      sym__string_char,
    STATE(5374), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6964), 2,
      sym__escape_char,
      sym__non_escape_char,
    ACTIONS(6968), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(6966), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(4763), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [123014] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2312), 1,
      anon_sym_COLON,
    ACTIONS(7075), 1,
      anon_sym_DOT,
    STATE(4790), 1,
      aux_sym_long_identifier_repeat1,
    STATE(4764), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2314), 9,
      sym__newline,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
      anon_sym_LT2,
  [123062] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2158), 1,
      anon_sym_COLON,
    STATE(4765), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2160), 11,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_in,
      anon_sym_DASH_GT,
      anon_sym_when,
      anon_sym_LT2,
  [123106] = 15,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(133), 1,
      sym_line_comment,
    ACTIONS(6818), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(6820), 1,
      anon_sym_POUNDlight,
    ACTIONS(6822), 1,
      anon_sym_POUNDr,
    ACTIONS(7077), 1,
      anon_sym_DQUOTE,
    ACTIONS(7079), 1,
      anon_sym_DQUOTEB,
    STATE(4825), 1,
      aux_sym__string_literal_repeat1,
    STATE(5200), 1,
      sym__string_char,
    STATE(5374), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6964), 2,
      sym__escape_char,
      sym__non_escape_char,
    ACTIONS(6968), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(6966), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(4766), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [123160] = 15,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(133), 1,
      sym_line_comment,
    ACTIONS(6818), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(6820), 1,
      anon_sym_POUNDlight,
    ACTIONS(6822), 1,
      anon_sym_POUNDr,
    ACTIONS(7081), 1,
      anon_sym_DQUOTE,
    ACTIONS(7083), 1,
      anon_sym_DQUOTEB,
    STATE(4766), 1,
      aux_sym__string_literal_repeat1,
    STATE(5200), 1,
      sym__string_char,
    STATE(5374), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6964), 2,
      sym__escape_char,
      sym__non_escape_char,
    ACTIONS(6968), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(6966), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(4767), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [123214] = 15,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(133), 1,
      sym_line_comment,
    ACTIONS(6818), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(6820), 1,
      anon_sym_POUNDlight,
    ACTIONS(6822), 1,
      anon_sym_POUNDr,
    ACTIONS(7085), 1,
      anon_sym_DQUOTE,
    ACTIONS(7087), 1,
      anon_sym_DQUOTEB,
    STATE(4825), 1,
      aux_sym__string_literal_repeat1,
    STATE(5200), 1,
      sym__string_char,
    STATE(5374), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6964), 2,
      sym__escape_char,
      sym__non_escape_char,
    ACTIONS(6968), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(6966), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(4768), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [123268] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6773), 1,
      anon_sym_STAR,
    STATE(4786), 1,
      aux_sym_compound_type_repeat1,
    ACTIONS(2407), 4,
      anon_sym_with,
      anon_sym_interface,
      anon_sym_val,
      sym_identifier,
    STATE(4769), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2409), 6,
      sym__dedent,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_DASH_GT,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [123316] = 15,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(133), 1,
      sym_line_comment,
    ACTIONS(6818), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(6820), 1,
      anon_sym_POUNDlight,
    ACTIONS(6822), 1,
      anon_sym_POUNDr,
    ACTIONS(7089), 1,
      anon_sym_DQUOTE,
    ACTIONS(7091), 1,
      anon_sym_DQUOTEB,
    STATE(4745), 1,
      aux_sym__string_literal_repeat1,
    STATE(5200), 1,
      sym__string_char,
    STATE(5374), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6964), 2,
      sym__escape_char,
      sym__non_escape_char,
    ACTIONS(6968), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(6966), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(4770), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [123370] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2321), 3,
      anon_sym_COLON,
      anon_sym_with,
      sym_identifier,
    STATE(4771), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2323), 9,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [123414] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    STATE(4772), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4711), 12,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_and,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [123456] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5860), 1,
      sym_identifier,
    ACTIONS(6771), 1,
      anon_sym_DASH_GT,
    ACTIONS(6773), 1,
      anon_sym_STAR,
    ACTIONS(6775), 1,
      anon_sym_LT2,
    ACTIONS(6777), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(7093), 1,
      anon_sym_EQ,
    ACTIONS(7097), 1,
      anon_sym_val,
    STATE(4769), 1,
      aux_sym_compound_type_repeat1,
    STATE(4860), 1,
      sym_type_arguments,
    STATE(4885), 1,
      sym_long_identifier,
    ACTIONS(7095), 2,
      sym__dedent,
      anon_sym_LBRACK_LT,
    STATE(4773), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [123518] = 15,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(133), 1,
      sym_line_comment,
    ACTIONS(6818), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(6820), 1,
      anon_sym_POUNDlight,
    ACTIONS(6822), 1,
      anon_sym_POUNDr,
    ACTIONS(7099), 1,
      anon_sym_DQUOTE,
    ACTIONS(7101), 1,
      anon_sym_DQUOTEB,
    STATE(4825), 1,
      aux_sym__string_literal_repeat1,
    STATE(5200), 1,
      sym__string_char,
    STATE(5374), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6964), 2,
      sym__escape_char,
      sym__non_escape_char,
    ACTIONS(6968), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(6966), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(4774), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [123572] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5646), 1,
      anon_sym_COLON,
    ACTIONS(7103), 1,
      anon_sym_as,
    STATE(4775), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5648), 10,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_in,
      anon_sym_DASH_GT,
      anon_sym_when,
      anon_sym_LT2,
  [123618] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5572), 1,
      anon_sym_COLON,
    STATE(4776), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5574), 11,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_in,
      anon_sym_DASH_GT,
      anon_sym_when,
      anon_sym_LT2,
  [123662] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5572), 1,
      anon_sym_COLON,
    ACTIONS(7105), 1,
      anon_sym_LT2,
    STATE(4777), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5574), 10,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_in,
      anon_sym_DASH_GT,
      anon_sym_when,
  [123708] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5609), 1,
      anon_sym_COLON,
    STATE(4778), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5611), 11,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_in,
      anon_sym_DASH_GT,
      anon_sym_when,
      anon_sym_LT2,
  [123752] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7107), 1,
      anon_sym_or,
    STATE(4805), 1,
      aux_sym_type_argument_repeat1,
    ACTIONS(2321), 2,
      anon_sym_val,
      sym_identifier,
    STATE(4779), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2323), 8,
      ts_builtin_sym_end,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [123800] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2984), 1,
      anon_sym_COLON,
    STATE(4780), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2986), 11,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_in,
      anon_sym_DASH_GT,
      anon_sym_when,
      anon_sym_LT2,
  [123844] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5605), 1,
      anon_sym_COLON,
    STATE(4781), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5607), 11,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_in,
      anon_sym_DASH_GT,
      anon_sym_when,
      anon_sym_LT2,
  [123888] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2411), 1,
      anon_sym_COLON,
    ACTIONS(7109), 1,
      anon_sym_DOT,
    STATE(4782), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_long_identifier_repeat1,
    ACTIONS(2413), 9,
      sym__newline,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
      anon_sym_LT2,
  [123934] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2873), 1,
      anon_sym_COLON,
    STATE(4783), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2875), 11,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_in,
      anon_sym_DASH_GT,
      anon_sym_when,
      anon_sym_LT2,
  [123978] = 15,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(133), 1,
      sym_line_comment,
    ACTIONS(6818), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(6820), 1,
      anon_sym_POUNDlight,
    ACTIONS(6822), 1,
      anon_sym_POUNDr,
    ACTIONS(7112), 1,
      anon_sym_DQUOTE,
    ACTIONS(7114), 1,
      anon_sym_DQUOTEB,
    STATE(4774), 1,
      aux_sym__string_literal_repeat1,
    STATE(5200), 1,
      sym__string_char,
    STATE(5374), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6964), 2,
      sym__escape_char,
      sym__non_escape_char,
    ACTIONS(6968), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(6966), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(4784), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [124032] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7116), 1,
      anon_sym_or,
    ACTIONS(2340), 2,
      anon_sym_val,
      sym_identifier,
    STATE(4785), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_type_argument_repeat1,
    ACTIONS(2342), 8,
      ts_builtin_sym_end,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [124078] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7119), 1,
      anon_sym_STAR,
    ACTIONS(2250), 4,
      anon_sym_with,
      anon_sym_interface,
      anon_sym_val,
      sym_identifier,
    STATE(4786), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_compound_type_repeat1,
    ACTIONS(2248), 6,
      sym__dedent,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_DASH_GT,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [124124] = 15,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(133), 1,
      sym_line_comment,
    ACTIONS(6818), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(6820), 1,
      anon_sym_POUNDlight,
    ACTIONS(6822), 1,
      anon_sym_POUNDr,
    ACTIONS(7122), 1,
      anon_sym_DQUOTE,
    ACTIONS(7124), 1,
      anon_sym_DQUOTEB,
    STATE(4825), 1,
      aux_sym__string_literal_repeat1,
    STATE(5200), 1,
      sym__string_char,
    STATE(5374), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6964), 2,
      sym__escape_char,
      sym__non_escape_char,
    ACTIONS(6968), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(6966), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(4787), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [124178] = 15,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(133), 1,
      sym_line_comment,
    ACTIONS(6818), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(6820), 1,
      anon_sym_POUNDlight,
    ACTIONS(6822), 1,
      anon_sym_POUNDr,
    ACTIONS(7126), 1,
      anon_sym_DQUOTE,
    ACTIONS(7128), 1,
      anon_sym_DQUOTEB,
    STATE(4825), 1,
      aux_sym__string_literal_repeat1,
    STATE(5200), 1,
      sym__string_char,
    STATE(5374), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6964), 2,
      sym__escape_char,
      sym__non_escape_char,
    ACTIONS(6968), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(6966), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(4788), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [124232] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2246), 1,
      anon_sym_val,
    ACTIONS(6109), 1,
      sym_identifier,
    ACTIONS(6990), 1,
      anon_sym_DASH_GT,
    ACTIONS(6992), 1,
      anon_sym_STAR,
    ACTIONS(6994), 1,
      anon_sym_LT2,
    ACTIONS(6996), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(5044), 1,
      aux_sym_compound_type_repeat1,
    STATE(5223), 1,
      sym_type_arguments,
    STATE(5355), 1,
      sym_long_identifier,
    ACTIONS(2244), 3,
      ts_builtin_sym_end,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
    STATE(4789), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [124292] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2418), 1,
      anon_sym_COLON,
    ACTIONS(7075), 1,
      anon_sym_DOT,
    STATE(4782), 1,
      aux_sym_long_identifier_repeat1,
    STATE(4790), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2420), 9,
      sym__newline,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
      anon_sym_LT2,
  [124340] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2877), 1,
      anon_sym_COLON,
    STATE(4791), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2879), 11,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_in,
      anon_sym_DASH_GT,
      anon_sym_when,
      anon_sym_LT2,
  [124384] = 15,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(133), 1,
      sym_line_comment,
    ACTIONS(6818), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(6820), 1,
      anon_sym_POUNDlight,
    ACTIONS(6822), 1,
      anon_sym_POUNDr,
    ACTIONS(7130), 1,
      anon_sym_DQUOTE,
    ACTIONS(7132), 1,
      anon_sym_DQUOTEB,
    STATE(4825), 1,
      aux_sym__string_literal_repeat1,
    STATE(5200), 1,
      sym__string_char,
    STATE(5374), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6964), 2,
      sym__escape_char,
      sym__non_escape_char,
    ACTIONS(6968), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(6966), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(4792), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [124438] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    STATE(4793), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2687), 12,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_and,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [124480] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5618), 1,
      anon_sym_COLON,
    STATE(4794), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5620), 11,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_in,
      anon_sym_DASH_GT,
      anon_sym_when,
      anon_sym_LT2,
  [124524] = 20,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7134), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(7136), 1,
      anon_sym_do,
    ACTIONS(7138), 1,
      anon_sym_let,
    ACTIONS(7140), 1,
      anon_sym_let_BANG,
    ACTIONS(7142), 1,
      anon_sym_member,
    ACTIONS(7144), 1,
      anon_sym_val,
    STATE(4911), 1,
      sym_value_declaration,
    STATE(4938), 1,
      sym_function_or_value_defn,
    STATE(4941), 1,
      sym_do,
    STATE(5573), 1,
      aux_sym_attributes_repeat1,
    STATE(5654), 1,
      sym_attributes,
    STATE(5710), 1,
      sym__attribute_set,
    STATE(4795), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [124588] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2466), 4,
      anon_sym_COLON,
      anon_sym_as,
      anon_sym_in,
      sym_identifier,
    STATE(4796), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2468), 8,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [124632] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3095), 1,
      anon_sym_COLON,
    STATE(4797), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3097), 11,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_in,
      anon_sym_DASH_GT,
      anon_sym_when,
      anon_sym_LT2,
  [124676] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5580), 1,
      anon_sym_COLON,
    STATE(4798), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5582), 11,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_in,
      anon_sym_DASH_GT,
      anon_sym_when,
      anon_sym_LT2,
  [124720] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6109), 1,
      sym_identifier,
    ACTIONS(6990), 1,
      anon_sym_DASH_GT,
    ACTIONS(6992), 1,
      anon_sym_STAR,
    ACTIONS(6994), 1,
      anon_sym_LT2,
    ACTIONS(6996), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(7097), 1,
      anon_sym_val,
    ACTIONS(7146), 1,
      anon_sym_EQ,
    STATE(5044), 1,
      aux_sym_compound_type_repeat1,
    STATE(5223), 1,
      sym_type_arguments,
    STATE(5355), 1,
      sym_long_identifier,
    ACTIONS(7095), 2,
      ts_builtin_sym_end,
      anon_sym_LBRACK_LT,
    STATE(4799), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [124782] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7150), 1,
      anon_sym_with,
    STATE(4800), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7148), 11,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [124826] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    STATE(4801), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2687), 12,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_PIPE,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [124868] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5584), 1,
      anon_sym_COLON,
    STATE(4802), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5586), 11,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_in,
      anon_sym_DASH_GT,
      anon_sym_when,
      anon_sym_LT2,
  [124912] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3035), 1,
      anon_sym_COLON,
    STATE(4803), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3037), 11,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_in,
      anon_sym_DASH_GT,
      anon_sym_when,
      anon_sym_LT2,
  [124956] = 15,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(133), 1,
      sym_line_comment,
    ACTIONS(6818), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(6820), 1,
      anon_sym_POUNDlight,
    ACTIONS(6822), 1,
      anon_sym_POUNDr,
    ACTIONS(7152), 1,
      anon_sym_DQUOTE,
    ACTIONS(7154), 1,
      anon_sym_DQUOTEB,
    STATE(4787), 1,
      aux_sym__string_literal_repeat1,
    STATE(5200), 1,
      sym__string_char,
    STATE(5374), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6964), 2,
      sym__escape_char,
      sym__non_escape_char,
    ACTIONS(6968), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(6966), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(4804), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [125010] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7107), 1,
      anon_sym_or,
    STATE(4785), 1,
      aux_sym_type_argument_repeat1,
    ACTIONS(2328), 2,
      anon_sym_val,
      sym_identifier,
    STATE(4805), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2330), 8,
      ts_builtin_sym_end,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [125058] = 20,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(305), 1,
      anon_sym_with,
    ACTIONS(5860), 1,
      sym_identifier,
    ACTIONS(6771), 1,
      anon_sym_DASH_GT,
    ACTIONS(6773), 1,
      anon_sym_STAR,
    ACTIONS(6775), 1,
      anon_sym_LT2,
    ACTIONS(6777), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(7156), 1,
      anon_sym_interface,
    ACTIONS(7158), 1,
      sym__dedent,
    STATE(4769), 1,
      aux_sym_compound_type_repeat1,
    STATE(4860), 1,
      sym_type_arguments,
    STATE(4885), 1,
      sym_long_identifier,
    STATE(6087), 1,
      sym__object_members,
    STATE(4806), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [125122] = 15,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(133), 1,
      sym_line_comment,
    ACTIONS(6818), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(6820), 1,
      anon_sym_POUNDlight,
    ACTIONS(6822), 1,
      anon_sym_POUNDr,
    ACTIONS(7160), 1,
      anon_sym_DQUOTE,
    ACTIONS(7162), 1,
      anon_sym_DQUOTEB,
    STATE(4825), 1,
      aux_sym__string_literal_repeat1,
    STATE(5200), 1,
      sym__string_char,
    STATE(5374), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6964), 2,
      sym__escape_char,
      sym__non_escape_char,
    ACTIONS(6968), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(6966), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(4807), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [125176] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2883), 1,
      anon_sym_COLON,
    STATE(4808), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2885), 11,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_in,
      anon_sym_DASH_GT,
      anon_sym_when,
      anon_sym_LT2,
  [125220] = 15,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(133), 1,
      sym_line_comment,
    ACTIONS(6818), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(6820), 1,
      anon_sym_POUNDlight,
    ACTIONS(6822), 1,
      anon_sym_POUNDr,
    ACTIONS(7164), 1,
      anon_sym_DQUOTE,
    ACTIONS(7166), 1,
      anon_sym_DQUOTEB,
    STATE(4788), 1,
      aux_sym__string_literal_repeat1,
    STATE(5200), 1,
      sym__string_char,
    STATE(5374), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6964), 2,
      sym__escape_char,
      sym__non_escape_char,
    ACTIONS(6968), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(6966), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(4809), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [125274] = 20,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7134), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(7136), 1,
      anon_sym_do,
    ACTIONS(7138), 1,
      anon_sym_let,
    ACTIONS(7140), 1,
      anon_sym_let_BANG,
    ACTIONS(7168), 1,
      anon_sym_member,
    ACTIONS(7170), 1,
      anon_sym_val,
    STATE(4880), 1,
      sym_value_declaration,
    STATE(4938), 1,
      sym_function_or_value_defn,
    STATE(4941), 1,
      sym_do,
    STATE(5573), 1,
      aux_sym_attributes_repeat1,
    STATE(5654), 1,
      sym_attributes,
    STATE(5710), 1,
      sym__attribute_set,
    STATE(4810), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [125338] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7174), 1,
      anon_sym_COMMA,
    STATE(4811), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7172), 11,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [125382] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7176), 1,
      anon_sym_COMMA,
    STATE(4812), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7172), 11,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [125426] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7180), 1,
      anon_sym_with,
    STATE(4813), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7178), 11,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [125470] = 15,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(133), 1,
      sym_line_comment,
    ACTIONS(6818), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(6820), 1,
      anon_sym_POUNDlight,
    ACTIONS(6822), 1,
      anon_sym_POUNDr,
    ACTIONS(7182), 1,
      anon_sym_DQUOTE,
    ACTIONS(7184), 1,
      anon_sym_DQUOTEB,
    STATE(4858), 1,
      aux_sym__string_literal_repeat1,
    STATE(5200), 1,
      sym__string_char,
    STATE(5374), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6964), 2,
      sym__escape_char,
      sym__non_escape_char,
    ACTIONS(6968), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(6966), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(4814), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [125524] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5661), 1,
      anon_sym_COLON,
    STATE(4815), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5663), 11,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_in,
      anon_sym_DASH_GT,
      anon_sym_when,
      anon_sym_LT2,
  [125568] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2250), 1,
      anon_sym_val,
    ACTIONS(6109), 1,
      sym_identifier,
    ACTIONS(6990), 1,
      anon_sym_DASH_GT,
    ACTIONS(6992), 1,
      anon_sym_STAR,
    ACTIONS(6994), 1,
      anon_sym_LT2,
    ACTIONS(6996), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(5044), 1,
      aux_sym_compound_type_repeat1,
    STATE(5223), 1,
      sym_type_arguments,
    STATE(5355), 1,
      sym_long_identifier,
    ACTIONS(2248), 3,
      ts_builtin_sym_end,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
    STATE(4816), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [125628] = 15,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(133), 1,
      sym_line_comment,
    ACTIONS(6818), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(6820), 1,
      anon_sym_POUNDlight,
    ACTIONS(6822), 1,
      anon_sym_POUNDr,
    ACTIONS(7186), 1,
      anon_sym_DQUOTE,
    ACTIONS(7188), 1,
      anon_sym_DQUOTEB,
    STATE(4842), 1,
      aux_sym__string_literal_repeat1,
    STATE(5200), 1,
      sym__string_char,
    STATE(5374), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6964), 2,
      sym__escape_char,
      sym__non_escape_char,
    ACTIONS(6968), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(6966), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(4817), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [125682] = 15,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(133), 1,
      sym_line_comment,
    ACTIONS(6818), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(6820), 1,
      anon_sym_POUNDlight,
    ACTIONS(6822), 1,
      anon_sym_POUNDr,
    ACTIONS(7190), 1,
      anon_sym_DQUOTE,
    ACTIONS(7192), 1,
      anon_sym_DQUOTEB,
    STATE(4807), 1,
      aux_sym__string_literal_repeat1,
    STATE(5200), 1,
      sym__string_char,
    STATE(5374), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6964), 2,
      sym__escape_char,
      sym__non_escape_char,
    ACTIONS(6968), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(6966), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(4818), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [125736] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2887), 1,
      anon_sym_COLON,
    STATE(4819), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2889), 11,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_in,
      anon_sym_DASH_GT,
      anon_sym_when,
      anon_sym_LT2,
  [125780] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2891), 1,
      anon_sym_COLON,
    STATE(4820), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2893), 11,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_in,
      anon_sym_DASH_GT,
      anon_sym_when,
      anon_sym_LT2,
  [125824] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2910), 1,
      anon_sym_COLON,
    STATE(4821), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2912), 11,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_in,
      anon_sym_DASH_GT,
      anon_sym_when,
      anon_sym_LT2,
  [125868] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3031), 1,
      anon_sym_COLON,
    STATE(4822), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3033), 11,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_in,
      anon_sym_DASH_GT,
      anon_sym_when,
      anon_sym_LT2,
  [125912] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2974), 1,
      anon_sym_COLON,
    STATE(4823), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2976), 11,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_in,
      anon_sym_DASH_GT,
      anon_sym_when,
      anon_sym_LT2,
  [125956] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2966), 1,
      anon_sym_COLON,
    STATE(4824), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2968), 11,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_in,
      anon_sym_DASH_GT,
      anon_sym_when,
      anon_sym_LT2,
  [126000] = 14,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(133), 1,
      sym_line_comment,
    ACTIONS(6818), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(6820), 1,
      anon_sym_POUNDlight,
    ACTIONS(6822), 1,
      anon_sym_POUNDr,
    ACTIONS(7203), 1,
      anon_sym_DQUOTE,
    ACTIONS(7205), 1,
      anon_sym_DQUOTEB,
    STATE(5200), 1,
      sym__string_char,
    STATE(5374), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7194), 2,
      sym__escape_char,
      sym__non_escape_char,
    ACTIONS(7200), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(7197), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(4825), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym__string_literal_repeat1,
  [126052] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7209), 1,
      anon_sym_COMMA,
    STATE(4826), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7207), 11,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [126096] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7211), 1,
      anon_sym_COMMA,
    STATE(4827), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7207), 11,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [126140] = 15,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(133), 1,
      sym_line_comment,
    ACTIONS(6818), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(6820), 1,
      anon_sym_POUNDlight,
    ACTIONS(6822), 1,
      anon_sym_POUNDr,
    ACTIONS(7213), 1,
      anon_sym_DQUOTE,
    ACTIONS(7215), 1,
      anon_sym_DQUOTEB,
    STATE(4825), 1,
      aux_sym__string_literal_repeat1,
    STATE(5200), 1,
      sym__string_char,
    STATE(5374), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6964), 2,
      sym__escape_char,
      sym__non_escape_char,
    ACTIONS(6968), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(6966), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(4828), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [126194] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2914), 1,
      anon_sym_COLON,
    STATE(4829), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2916), 11,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_in,
      anon_sym_DASH_GT,
      anon_sym_when,
      anon_sym_LT2,
  [126238] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7217), 1,
      anon_sym_COMMA,
    STATE(4830), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(137), 11,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [126282] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7219), 1,
      anon_sym_COMMA,
    STATE(4831), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(137), 11,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [126326] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3027), 1,
      anon_sym_COLON,
    STATE(4832), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3029), 11,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_in,
      anon_sym_DASH_GT,
      anon_sym_when,
      anon_sym_LT2,
  [126370] = 15,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(133), 1,
      sym_line_comment,
    ACTIONS(6818), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(6820), 1,
      anon_sym_POUNDlight,
    ACTIONS(6822), 1,
      anon_sym_POUNDr,
    ACTIONS(7221), 1,
      anon_sym_DQUOTE,
    ACTIONS(7223), 1,
      anon_sym_DQUOTEB,
    STATE(4825), 1,
      aux_sym__string_literal_repeat1,
    STATE(5200), 1,
      sym__string_char,
    STATE(5374), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6964), 2,
      sym__escape_char,
      sym__non_escape_char,
    ACTIONS(6968), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(6966), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(4833), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [126424] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3115), 1,
      anon_sym_COLON,
    STATE(4834), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3117), 11,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_in,
      anon_sym_DASH_GT,
      anon_sym_when,
      anon_sym_LT2,
  [126468] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2918), 1,
      anon_sym_COLON,
    STATE(4835), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2920), 11,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_in,
      anon_sym_DASH_GT,
      anon_sym_when,
      anon_sym_LT2,
  [126512] = 15,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(133), 1,
      sym_line_comment,
    ACTIONS(6818), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(6820), 1,
      anon_sym_POUNDlight,
    ACTIONS(6822), 1,
      anon_sym_POUNDr,
    ACTIONS(7225), 1,
      anon_sym_DQUOTE,
    ACTIONS(7227), 1,
      anon_sym_DQUOTEB,
    STATE(4761), 1,
      aux_sym__string_literal_repeat1,
    STATE(5200), 1,
      sym__string_char,
    STATE(5374), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6964), 2,
      sym__escape_char,
      sym__non_escape_char,
    ACTIONS(6968), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(6966), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(4836), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [126566] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5590), 1,
      anon_sym_COLON,
    STATE(4837), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5592), 11,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_in,
      anon_sym_DASH_GT,
      anon_sym_when,
      anon_sym_LT2,
  [126610] = 15,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(133), 1,
      sym_line_comment,
    ACTIONS(6818), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(6820), 1,
      anon_sym_POUNDlight,
    ACTIONS(6822), 1,
      anon_sym_POUNDr,
    ACTIONS(7229), 1,
      anon_sym_DQUOTE,
    ACTIONS(7231), 1,
      anon_sym_DQUOTEB,
    STATE(4856), 1,
      aux_sym__string_literal_repeat1,
    STATE(5200), 1,
      sym__string_char,
    STATE(5374), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6964), 2,
      sym__escape_char,
      sym__non_escape_char,
    ACTIONS(6968), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(6966), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(4838), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [126664] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2723), 1,
      anon_sym_COLON,
    ACTIONS(7233), 1,
      aux_sym_float_token1,
    STATE(4839), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2725), 10,
      sym__newline,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
      anon_sym_f,
      aux_sym_decimal_token1,
  [126710] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2922), 1,
      anon_sym_COLON,
    STATE(4840), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2924), 11,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_in,
      anon_sym_DASH_GT,
      anon_sym_when,
      anon_sym_LT2,
  [126754] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5594), 1,
      anon_sym_COLON,
    STATE(4841), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5596), 11,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_in,
      anon_sym_DASH_GT,
      anon_sym_when,
      anon_sym_LT2,
  [126798] = 15,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(133), 1,
      sym_line_comment,
    ACTIONS(6818), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(6820), 1,
      anon_sym_POUNDlight,
    ACTIONS(6822), 1,
      anon_sym_POUNDr,
    ACTIONS(7235), 1,
      anon_sym_DQUOTE,
    ACTIONS(7237), 1,
      anon_sym_DQUOTEB,
    STATE(4825), 1,
      aux_sym__string_literal_repeat1,
    STATE(5200), 1,
      sym__string_char,
    STATE(5374), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6964), 2,
      sym__escape_char,
      sym__non_escape_char,
    ACTIONS(6968), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(6966), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(4842), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [126852] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7239), 1,
      anon_sym_COLON_GT,
    ACTIONS(2567), 4,
      anon_sym_with,
      anon_sym_interface,
      anon_sym_val,
      sym_identifier,
    STATE(4843), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2569), 7,
      sym__dedent,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [126898] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2938), 1,
      anon_sym_COLON,
    STATE(4844), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2940), 11,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_in,
      anon_sym_DASH_GT,
      anon_sym_when,
      anon_sym_LT2,
  [126942] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2946), 1,
      anon_sym_COLON,
    STATE(4845), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2948), 11,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_in,
      anon_sym_DASH_GT,
      anon_sym_when,
      anon_sym_LT2,
  [126986] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2950), 1,
      anon_sym_COLON,
    STATE(4846), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2952), 11,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_in,
      anon_sym_DASH_GT,
      anon_sym_when,
      anon_sym_LT2,
  [127030] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2958), 1,
      anon_sym_COLON,
    STATE(4847), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2960), 11,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_in,
      anon_sym_DASH_GT,
      anon_sym_when,
      anon_sym_LT2,
  [127074] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2962), 1,
      anon_sym_COLON,
    STATE(4848), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2964), 11,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_in,
      anon_sym_DASH_GT,
      anon_sym_when,
      anon_sym_LT2,
  [127118] = 15,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(133), 1,
      sym_line_comment,
    ACTIONS(6818), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(6820), 1,
      anon_sym_POUNDlight,
    ACTIONS(6822), 1,
      anon_sym_POUNDr,
    ACTIONS(7241), 1,
      anon_sym_DQUOTE,
    ACTIONS(7243), 1,
      anon_sym_DQUOTEB,
    STATE(4828), 1,
      aux_sym__string_literal_repeat1,
    STATE(5200), 1,
      sym__string_char,
    STATE(5374), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6964), 2,
      sym__escape_char,
      sym__non_escape_char,
    ACTIONS(6968), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(6966), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(4849), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [127172] = 15,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(133), 1,
      sym_line_comment,
    ACTIONS(6818), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(6820), 1,
      anon_sym_POUNDlight,
    ACTIONS(6822), 1,
      anon_sym_POUNDr,
    ACTIONS(7245), 1,
      anon_sym_DQUOTE,
    ACTIONS(7247), 1,
      anon_sym_DQUOTEB,
    STATE(4833), 1,
      aux_sym__string_literal_repeat1,
    STATE(5200), 1,
      sym__string_char,
    STATE(5374), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6964), 2,
      sym__escape_char,
      sym__non_escape_char,
    ACTIONS(6968), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(6966), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(4850), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [127226] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2411), 4,
      anon_sym_with,
      anon_sym_interface,
      anon_sym_val,
      sym_identifier,
    STATE(4851), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2413), 8,
      sym__dedent,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [127270] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5598), 1,
      anon_sym_COLON,
    STATE(4852), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5600), 11,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_in,
      anon_sym_DASH_GT,
      anon_sym_when,
      anon_sym_LT2,
  [127314] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3023), 1,
      anon_sym_COLON,
    STATE(4853), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3025), 11,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_in,
      anon_sym_DASH_GT,
      anon_sym_when,
      anon_sym_LT2,
  [127358] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5652), 1,
      anon_sym_COLON,
    STATE(4854), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5654), 11,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_in,
      anon_sym_DASH_GT,
      anon_sym_when,
      anon_sym_LT2,
  [127402] = 15,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(133), 1,
      sym_line_comment,
    ACTIONS(6818), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(6820), 1,
      anon_sym_POUNDlight,
    ACTIONS(6822), 1,
      anon_sym_POUNDr,
    ACTIONS(7249), 1,
      anon_sym_DQUOTE,
    ACTIONS(7251), 1,
      anon_sym_DQUOTEB,
    STATE(4825), 1,
      aux_sym__string_literal_repeat1,
    STATE(5200), 1,
      sym__string_char,
    STATE(5374), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6964), 2,
      sym__escape_char,
      sym__non_escape_char,
    ACTIONS(6968), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(6966), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(4855), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [127456] = 15,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(133), 1,
      sym_line_comment,
    ACTIONS(6818), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(6820), 1,
      anon_sym_POUNDlight,
    ACTIONS(6822), 1,
      anon_sym_POUNDr,
    ACTIONS(7253), 1,
      anon_sym_DQUOTE,
    ACTIONS(7255), 1,
      anon_sym_DQUOTEB,
    STATE(4825), 1,
      aux_sym__string_literal_repeat1,
    STATE(5200), 1,
      sym__string_char,
    STATE(5374), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6964), 2,
      sym__escape_char,
      sym__non_escape_char,
    ACTIONS(6968), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(6966), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(4856), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [127510] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3019), 1,
      anon_sym_COLON,
    STATE(4857), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3021), 11,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_in,
      anon_sym_DASH_GT,
      anon_sym_when,
      anon_sym_LT2,
  [127554] = 15,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(133), 1,
      sym_line_comment,
    ACTIONS(6818), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(6820), 1,
      anon_sym_POUNDlight,
    ACTIONS(6822), 1,
      anon_sym_POUNDr,
    ACTIONS(7257), 1,
      anon_sym_DQUOTE,
    ACTIONS(7259), 1,
      anon_sym_DQUOTEB,
    STATE(4825), 1,
      aux_sym__string_literal_repeat1,
    STATE(5200), 1,
      sym__string_char,
    STATE(5374), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(6964), 2,
      sym__escape_char,
      sym__non_escape_char,
    ACTIONS(6968), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(6966), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(4858), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [127608] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6873), 1,
      anon_sym_STAR,
    STATE(4899), 1,
      aux_sym_compound_type_repeat1,
    ACTIONS(2407), 2,
      anon_sym_with,
      sym_identifier,
    STATE(4859), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2409), 7,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_GT,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [127655] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2474), 4,
      anon_sym_with,
      anon_sym_interface,
      anon_sym_val,
      sym_identifier,
    STATE(4860), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2476), 7,
      sym__dedent,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [127698] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    STATE(4861), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4735), 11,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [127739] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2723), 1,
      anon_sym_COLON,
    STATE(4862), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2725), 10,
      sym__newline,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
      anon_sym_f,
      aux_sym_decimal_token1,
  [127782] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    STATE(4863), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7261), 11,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [127823] = 19,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(3570), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(7263), 1,
      sym_identifier,
    ACTIONS(7265), 1,
      anon_sym_inline,
    ACTIONS(7267), 1,
      anon_sym_val,
    ACTIONS(7269), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(7271), 1,
      sym_op_identifier,
    STATE(2288), 1,
      sym_property_or_ident,
    STATE(3772), 1,
      sym__identifier_or_op,
    STATE(3773), 1,
      sym_active_pattern,
    STATE(4911), 1,
      sym_method_or_prop_defn,
    STATE(5532), 1,
      sym_access_modifier,
    STATE(4864), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [127884] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    STATE(4865), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7273), 11,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [127925] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    STATE(4866), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7275), 11,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [127966] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    STATE(4867), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7277), 11,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [128007] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2819), 1,
      anon_sym_COLON,
    ACTIONS(7279), 1,
      sym_int,
    STATE(4868), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2821), 9,
      sym__newline,
      sym__dedent,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_f,
      aux_sym_decimal_token1,
  [128052] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    STATE(4869), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7172), 11,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [128093] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    STATE(4870), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7281), 11,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [128134] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2462), 3,
      anon_sym_or,
      anon_sym_val,
      sym_identifier,
    STATE(4871), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2464), 8,
      ts_builtin_sym_end,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [128177] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    STATE(4872), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4696), 11,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [128218] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2723), 1,
      anon_sym_COLON,
    ACTIONS(7283), 1,
      aux_sym_float_token1,
    STATE(4873), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2725), 9,
      sym__newline,
      sym__dedent,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_f,
      aux_sym_decimal_token1,
  [128263] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2812), 1,
      anon_sym_COLON,
    STATE(4874), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2814), 10,
      sym__newline,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
      anon_sym_f,
      aux_sym_decimal_token1,
  [128306] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    STATE(4875), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4711), 11,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [128347] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2553), 4,
      anon_sym_with,
      anon_sym_interface,
      anon_sym_val,
      sym_identifier,
    STATE(4876), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2555), 7,
      sym__dedent,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [128390] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2563), 4,
      anon_sym_with,
      anon_sym_interface,
      anon_sym_val,
      sym_identifier,
    STATE(4877), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2565), 7,
      sym__dedent,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [128433] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    STATE(4878), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7285), 11,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [128474] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2514), 4,
      anon_sym_with,
      anon_sym_interface,
      anon_sym_val,
      sym_identifier,
    STATE(4879), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2516), 7,
      sym__dedent,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [128517] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    STATE(4880), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7287), 11,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [128558] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    STATE(4881), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7289), 11,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [128599] = 19,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(3570), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(7263), 1,
      sym_identifier,
    ACTIONS(7269), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(7271), 1,
      sym_op_identifier,
    ACTIONS(7291), 1,
      anon_sym_inline,
    ACTIONS(7293), 1,
      anon_sym_val,
    STATE(2288), 1,
      sym_property_or_ident,
    STATE(3772), 1,
      sym__identifier_or_op,
    STATE(3773), 1,
      sym_active_pattern,
    STATE(4880), 1,
      sym_method_or_prop_defn,
    STATE(5548), 1,
      sym_access_modifier,
    STATE(4882), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [128660] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2321), 1,
      anon_sym_COLON,
    ACTIONS(7295), 1,
      anon_sym_or,
    STATE(4912), 1,
      aux_sym_type_argument_repeat1,
    STATE(4883), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2323), 8,
      sym__newline,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
  [128707] = 13,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(133), 1,
      sym_line_comment,
    ACTIONS(6818), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(6820), 1,
      anon_sym_POUNDlight,
    ACTIONS(6822), 1,
      anon_sym_POUNDr,
    ACTIONS(7203), 1,
      anon_sym_DQUOTE,
    STATE(5505), 1,
      sym__string_char,
    STATE(5511), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7297), 2,
      sym__escape_char,
      sym__non_escape_char,
    ACTIONS(7303), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(7300), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(4884), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym__string_literal_repeat1,
  [128756] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2627), 4,
      anon_sym_with,
      anon_sym_interface,
      anon_sym_val,
      sym_identifier,
    STATE(4885), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2629), 7,
      sym__dedent,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [128799] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2411), 1,
      anon_sym_COLON,
    STATE(4886), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2413), 10,
      sym__newline,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LT2,
  [128842] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    STATE(4887), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6380), 11,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [128883] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    STATE(4888), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7306), 11,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [128924] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2466), 4,
      anon_sym_with,
      anon_sym_interface,
      anon_sym_val,
      sym_identifier,
    STATE(4889), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2468), 7,
      sym__dedent,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [128967] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7308), 1,
      anon_sym_LBRACK_LT,
    STATE(5352), 1,
      sym__attribute_set,
    ACTIONS(5761), 4,
      anon_sym_LPAREN,
      anon_sym__,
      anon_sym_POUND,
      sym_identifier,
    ACTIONS(5766), 4,
      anon_sym_QMARK,
      anon_sym_LBRACE_PIPE,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4890), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_attributes_repeat1,
  [129014] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    STATE(4891), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7311), 11,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [129055] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    STATE(4892), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7313), 11,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [129096] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2158), 1,
      anon_sym_COLON,
    ACTIONS(5830), 1,
      aux_sym_decimal_token1,
    ACTIONS(6325), 1,
      anon_sym_f,
    STATE(4893), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2160), 8,
      sym__newline,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
  [129143] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    STATE(4894), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6391), 11,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [129184] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    STATE(4895), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7315), 11,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [129225] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5417), 1,
      anon_sym_COLON,
    ACTIONS(7317), 1,
      anon_sym_and,
    STATE(4934), 1,
      aux_sym_type_argument_constraints_repeat1,
    STATE(4896), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5419), 8,
      sym__newline,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
  [129272] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2312), 1,
      anon_sym_COLON,
    ACTIONS(7319), 1,
      anon_sym_DOT,
    STATE(4925), 1,
      aux_sym_long_identifier_repeat1,
    STATE(4897), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2314), 8,
      sym__newline,
      sym__dedent,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT2,
  [129319] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    STATE(4898), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7321), 11,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [129360] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7323), 1,
      anon_sym_STAR,
    ACTIONS(2250), 2,
      anon_sym_with,
      sym_identifier,
    STATE(4899), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_compound_type_repeat1,
    ACTIONS(2248), 7,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_GT,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [129405] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    STATE(4900), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7326), 11,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [129446] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2454), 2,
      anon_sym_with,
      sym_identifier,
    STATE(4901), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2456), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [129489] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    STATE(4902), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(4723), 11,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [129530] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    STATE(4903), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7328), 11,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [129571] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2510), 4,
      anon_sym_with,
      anon_sym_interface,
      anon_sym_val,
      sym_identifier,
    STATE(4904), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2512), 7,
      sym__dedent,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [129614] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2470), 2,
      anon_sym_with,
      sym_identifier,
    STATE(4905), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2472), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [129657] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7330), 1,
      anon_sym_DOT,
    STATE(4927), 1,
      aux_sym_long_identifier_repeat1,
    ACTIONS(2312), 2,
      anon_sym_val,
      sym_identifier,
    STATE(4906), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2314), 7,
      ts_builtin_sym_end,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [129704] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7332), 1,
      anon_sym_LT2,
    ACTIONS(2557), 4,
      anon_sym_with,
      anon_sym_interface,
      anon_sym_val,
      sym_identifier,
    STATE(4907), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2559), 6,
      sym__dedent,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LBRACK_RBRACK,
  [129749] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    STATE(4908), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6446), 11,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [129790] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2567), 4,
      anon_sym_with,
      anon_sym_interface,
      anon_sym_val,
      sym_identifier,
    STATE(4909), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2569), 7,
      sym__dedent,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [129833] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    STATE(4910), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6395), 11,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [129874] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    STATE(4911), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7334), 11,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [129915] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2328), 1,
      anon_sym_COLON,
    ACTIONS(7295), 1,
      anon_sym_or,
    STATE(4918), 1,
      aux_sym_type_argument_repeat1,
    STATE(4912), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2330), 8,
      sym__newline,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
  [129962] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7336), 1,
      anon_sym_COLON_GT,
    ACTIONS(2567), 2,
      anon_sym_with,
      sym_identifier,
    STATE(4913), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2569), 8,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [130007] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5453), 1,
      anon_sym_LBRACK_LT,
    STATE(4890), 1,
      aux_sym_attributes_repeat1,
    STATE(5352), 1,
      sym__attribute_set,
    ACTIONS(5798), 4,
      anon_sym_LPAREN,
      anon_sym__,
      anon_sym_POUND,
      sym_identifier,
    ACTIONS(5800), 4,
      anon_sym_QMARK,
      anon_sym_LBRACE_PIPE,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4914), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [130056] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2506), 2,
      anon_sym_with,
      sym_identifier,
    STATE(4915), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2508), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [130099] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    STATE(4916), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7338), 11,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [130140] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    STATE(4917), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7340), 11,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [130181] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2340), 1,
      anon_sym_COLON,
    ACTIONS(7342), 1,
      anon_sym_or,
    STATE(4918), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_type_argument_repeat1,
    ACTIONS(2342), 8,
      sym__newline,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
  [130226] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    STATE(4919), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7340), 11,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [130267] = 14,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(133), 1,
      sym_line_comment,
    ACTIONS(6818), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(6820), 1,
      anon_sym_POUNDlight,
    ACTIONS(6822), 1,
      anon_sym_POUNDr,
    ACTIONS(7351), 1,
      anon_sym_DQUOTE,
    STATE(4884), 1,
      aux_sym__string_literal_repeat1,
    STATE(5505), 1,
      sym__string_char,
    STATE(5511), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7345), 2,
      sym__escape_char,
      sym__non_escape_char,
    ACTIONS(7349), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(7347), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(4920), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [130318] = 19,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6871), 1,
      anon_sym_DASH_GT,
    ACTIONS(6873), 1,
      anon_sym_STAR,
    ACTIONS(6875), 1,
      anon_sym_LT2,
    ACTIONS(6877), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(7353), 1,
      sym_identifier,
    ACTIONS(7355), 1,
      anon_sym_COMMA,
    ACTIONS(7357), 1,
      anon_sym_GT,
    STATE(4859), 1,
      aux_sym_compound_type_repeat1,
    STATE(4991), 1,
      sym_long_identifier,
    STATE(5160), 1,
      sym_type_arguments,
    STATE(5785), 1,
      aux_sym_types_repeat1,
    STATE(4921), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [130379] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2470), 4,
      anon_sym_with,
      anon_sym_interface,
      anon_sym_val,
      sym_identifier,
    STATE(4922), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2472), 7,
      sym__dedent,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [130422] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2454), 4,
      anon_sym_with,
      anon_sym_interface,
      anon_sym_val,
      sym_identifier,
    STATE(4923), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2456), 7,
      sym__dedent,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [130465] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5402), 1,
      anon_sym_COLON,
    ACTIONS(7359), 1,
      anon_sym_and,
    STATE(4924), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_type_argument_constraints_repeat1,
    ACTIONS(5404), 8,
      sym__newline,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
  [130510] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2418), 1,
      anon_sym_COLON,
    ACTIONS(7319), 1,
      anon_sym_DOT,
    STATE(4929), 1,
      aux_sym_long_identifier_repeat1,
    STATE(4925), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2420), 8,
      sym__newline,
      sym__dedent,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT2,
  [130557] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    STATE(4926), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7362), 11,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [130598] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7330), 1,
      anon_sym_DOT,
    STATE(4932), 1,
      aux_sym_long_identifier_repeat1,
    ACTIONS(2418), 2,
      anon_sym_val,
      sym_identifier,
    STATE(4927), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2420), 7,
      ts_builtin_sym_end,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [130645] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    STATE(4928), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7364), 11,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [130686] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2411), 1,
      anon_sym_COLON,
    ACTIONS(7366), 1,
      anon_sym_DOT,
    STATE(4929), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_long_identifier_repeat1,
    ACTIONS(2413), 8,
      sym__newline,
      sym__dedent,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT2,
  [130731] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    STATE(4930), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7369), 11,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [130772] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2411), 2,
      anon_sym_with,
      sym_identifier,
    STATE(4931), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2413), 9,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [130815] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7371), 1,
      anon_sym_DOT,
    ACTIONS(2411), 2,
      anon_sym_val,
      sym_identifier,
    STATE(4932), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_long_identifier_repeat1,
    ACTIONS(2413), 7,
      ts_builtin_sym_end,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [130860] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    STATE(4933), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7374), 11,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [130901] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5409), 1,
      anon_sym_COLON,
    ACTIONS(7317), 1,
      anon_sym_and,
    STATE(4924), 1,
      aux_sym_type_argument_constraints_repeat1,
    STATE(4934), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5411), 8,
      sym__newline,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
  [130948] = 14,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(133), 1,
      sym_line_comment,
    ACTIONS(6818), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(6820), 1,
      anon_sym_POUNDlight,
    ACTIONS(6822), 1,
      anon_sym_POUNDr,
    ACTIONS(7376), 1,
      anon_sym_DQUOTE,
    STATE(4936), 1,
      aux_sym__string_literal_repeat1,
    STATE(5505), 1,
      sym__string_char,
    STATE(5511), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7345), 2,
      sym__escape_char,
      sym__non_escape_char,
    ACTIONS(7349), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(7347), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(4935), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [130999] = 14,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(133), 1,
      sym_line_comment,
    ACTIONS(6818), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(6820), 1,
      anon_sym_POUNDlight,
    ACTIONS(6822), 1,
      anon_sym_POUNDr,
    ACTIONS(7378), 1,
      anon_sym_DQUOTE,
    STATE(4884), 1,
      aux_sym__string_literal_repeat1,
    STATE(5505), 1,
      sym__string_char,
    STATE(5511), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7345), 2,
      sym__escape_char,
      sym__non_escape_char,
    ACTIONS(7349), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(7347), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(4936), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [131050] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2340), 3,
      anon_sym_or,
      anon_sym_val,
      sym_identifier,
    STATE(4937), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2342), 8,
      ts_builtin_sym_end,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [131093] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    STATE(4938), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7380), 11,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [131134] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2506), 4,
      anon_sym_with,
      anon_sym_interface,
      anon_sym_val,
      sym_identifier,
    STATE(4939), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2508), 7,
      sym__dedent,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [131177] = 14,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(133), 1,
      sym_line_comment,
    ACTIONS(6818), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(6820), 1,
      anon_sym_POUNDlight,
    ACTIONS(6822), 1,
      anon_sym_POUNDr,
    ACTIONS(7382), 1,
      anon_sym_DQUOTE,
    STATE(4920), 1,
      aux_sym__string_literal_repeat1,
    STATE(5505), 1,
      sym__string_char,
    STATE(5511), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7345), 2,
      sym__escape_char,
      sym__non_escape_char,
    ACTIONS(7349), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(7347), 3,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
    STATE(4940), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [131228] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    STATE(4941), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7380), 11,
      sym__newline,
      sym__dedent,
      anon_sym_LBRACK_LT,
      aux_sym_access_modifier_token1,
      anon_sym_new,
      anon_sym_default,
      anon_sym_static,
      anon_sym_member,
      anon_sym_abstract,
      anon_sym_val,
      anon_sym_override,
  [131269] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(23), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7384), 1,
      anon_sym__,
    STATE(4305), 1,
      aux_sym_attributes_repeat1,
    STATE(4441), 1,
      sym__static_type_identifier,
    STATE(4488), 1,
      sym__attribute_set,
    STATE(5587), 1,
      sym_type_argument_defn,
    STATE(5702), 1,
      sym_attributes,
    STATE(5976), 1,
      sym_type_argument,
    ACTIONS(7386), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4942), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [131325] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(23), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7384), 1,
      anon_sym__,
    STATE(4305), 1,
      aux_sym_attributes_repeat1,
    STATE(4441), 1,
      sym__static_type_identifier,
    STATE(4488), 1,
      sym__attribute_set,
    STATE(5661), 1,
      sym_type_argument_defn,
    STATE(5702), 1,
      sym_attributes,
    STATE(5976), 1,
      sym_type_argument,
    ACTIONS(7386), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4943), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [131381] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(23), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7384), 1,
      anon_sym__,
    STATE(4305), 1,
      aux_sym_attributes_repeat1,
    STATE(4441), 1,
      sym__static_type_identifier,
    STATE(4488), 1,
      sym__attribute_set,
    STATE(5627), 1,
      sym_type_argument_defn,
    STATE(5702), 1,
      sym_attributes,
    STATE(5976), 1,
      sym_type_argument,
    ACTIONS(7386), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4944), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [131437] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2328), 1,
      anon_sym_COLON,
    ACTIONS(7388), 1,
      anon_sym_or,
    STATE(4952), 1,
      aux_sym_type_argument_repeat1,
    STATE(4945), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2330), 7,
      sym__newline,
      sym__dedent,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
  [131483] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5009), 1,
      anon_sym_and,
    ACTIONS(5011), 1,
      anon_sym_GT,
    ACTIONS(5848), 1,
      sym_identifier,
    ACTIONS(7390), 1,
      anon_sym_DASH_GT,
    ACTIONS(7392), 1,
      anon_sym_STAR,
    ACTIONS(7394), 1,
      anon_sym_LT2,
    ACTIONS(7396), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(5427), 1,
      aux_sym_compound_type_repeat1,
    STATE(5557), 1,
      sym_type_arguments,
    STATE(5565), 1,
      sym_long_identifier,
    STATE(4946), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [131541] = 14,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(133), 1,
      sym_line_comment,
    ACTIONS(6818), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(6820), 1,
      anon_sym_POUNDlight,
    ACTIONS(6822), 1,
      anon_sym_POUNDr,
    ACTIONS(7402), 1,
      anon_sym_DQUOTE2,
    ACTIONS(7404), 1,
      anon_sym_DQUOTEB,
    STATE(4951), 1,
      aux_sym_verbatim_string_repeat1,
    STATE(5564), 1,
      sym__verbatim_string_char,
    STATE(5568), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7400), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(7398), 3,
      sym__non_escape_char,
      anon_sym_BSLASH,
      aux_sym__verbatim_string_char_token1,
    STATE(4947), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [131591] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(23), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7384), 1,
      anon_sym__,
    STATE(4305), 1,
      aux_sym_attributes_repeat1,
    STATE(4441), 1,
      sym__static_type_identifier,
    STATE(4488), 1,
      sym__attribute_set,
    STATE(5620), 1,
      sym_type_argument_defn,
    STATE(5702), 1,
      sym_attributes,
    STATE(5976), 1,
      sym_type_argument,
    ACTIONS(7386), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4948), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [131647] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(23), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7384), 1,
      anon_sym__,
    STATE(4305), 1,
      aux_sym_attributes_repeat1,
    STATE(4441), 1,
      sym__static_type_identifier,
    STATE(4488), 1,
      sym__attribute_set,
    STATE(5614), 1,
      sym_type_argument_defn,
    STATE(5702), 1,
      sym_attributes,
    STATE(5976), 1,
      sym_type_argument,
    ACTIONS(7386), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4949), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [131703] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(23), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7384), 1,
      anon_sym__,
    STATE(4305), 1,
      aux_sym_attributes_repeat1,
    STATE(4441), 1,
      sym__static_type_identifier,
    STATE(4488), 1,
      sym__attribute_set,
    STATE(5605), 1,
      sym_type_argument_defn,
    STATE(5702), 1,
      sym_attributes,
    STATE(5976), 1,
      sym_type_argument,
    ACTIONS(7386), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4950), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [131759] = 14,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(133), 1,
      sym_line_comment,
    ACTIONS(6818), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(6820), 1,
      anon_sym_POUNDlight,
    ACTIONS(6822), 1,
      anon_sym_POUNDr,
    ACTIONS(7406), 1,
      anon_sym_DQUOTE2,
    ACTIONS(7408), 1,
      anon_sym_DQUOTEB,
    STATE(5060), 1,
      aux_sym_verbatim_string_repeat1,
    STATE(5564), 1,
      sym__verbatim_string_char,
    STATE(5568), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7400), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(7398), 3,
      sym__non_escape_char,
      anon_sym_BSLASH,
      aux_sym__verbatim_string_char_token1,
    STATE(4951), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [131809] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2340), 1,
      anon_sym_COLON,
    ACTIONS(7410), 1,
      anon_sym_or,
    STATE(4952), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_type_argument_repeat1,
    ACTIONS(2342), 7,
      sym__newline,
      sym__dedent,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
  [131853] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2158), 1,
      anon_sym_COLON,
    ACTIONS(5936), 1,
      aux_sym_decimal_token1,
    ACTIONS(6333), 1,
      anon_sym_f,
    STATE(4953), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2160), 7,
      sym__newline,
      sym__dedent,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
  [131899] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7413), 1,
      sym_identifier,
    ACTIONS(7415), 1,
      anon_sym_LPAREN,
    ACTIONS(7417), 1,
      anon_sym__,
    ACTIONS(7419), 1,
      anon_sym_POUND,
    STATE(5022), 1,
      sym__static_type_identifier,
    STATE(5415), 1,
      sym_long_identifier,
    STATE(5448), 1,
      sym_atomic_type,
    STATE(5467), 1,
      sym_type_argument,
    ACTIONS(7421), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4954), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [131955] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2812), 1,
      anon_sym_COLON,
    STATE(4955), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2814), 9,
      sym__newline,
      sym__dedent,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_f,
      aux_sym_decimal_token1,
  [131997] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2723), 1,
      anon_sym_COLON,
    STATE(4956), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2725), 9,
      sym__newline,
      sym__dedent,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_f,
      aux_sym_decimal_token1,
  [132039] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(23), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7384), 1,
      anon_sym__,
    STATE(4305), 1,
      aux_sym_attributes_repeat1,
    STATE(4441), 1,
      sym__static_type_identifier,
    STATE(4488), 1,
      sym__attribute_set,
    STATE(5602), 1,
      sym_type_argument_defn,
    STATE(5702), 1,
      sym_attributes,
    STATE(5976), 1,
      sym_type_argument,
    ACTIONS(7386), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4957), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [132095] = 14,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(133), 1,
      sym_line_comment,
    ACTIONS(6818), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(6820), 1,
      anon_sym_POUNDlight,
    ACTIONS(6822), 1,
      anon_sym_POUNDr,
    ACTIONS(7423), 1,
      anon_sym_DQUOTE2,
    ACTIONS(7425), 1,
      anon_sym_DQUOTEB,
    STATE(5060), 1,
      aux_sym_verbatim_string_repeat1,
    STATE(5564), 1,
      sym__verbatim_string_char,
    STATE(5568), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7400), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(7398), 3,
      sym__non_escape_char,
      anon_sym_BSLASH,
      aux_sym__verbatim_string_char_token1,
    STATE(4958), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [132145] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(23), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7384), 1,
      anon_sym__,
    STATE(4305), 1,
      aux_sym_attributes_repeat1,
    STATE(4441), 1,
      sym__static_type_identifier,
    STATE(4488), 1,
      sym__attribute_set,
    STATE(5594), 1,
      sym_type_argument_defn,
    STATE(5702), 1,
      sym_attributes,
    STATE(5976), 1,
      sym_type_argument,
    ACTIONS(7386), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4959), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [132201] = 14,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(133), 1,
      sym_line_comment,
    ACTIONS(6818), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(6820), 1,
      anon_sym_POUNDlight,
    ACTIONS(6822), 1,
      anon_sym_POUNDr,
    ACTIONS(7427), 1,
      anon_sym_DQUOTE2,
    ACTIONS(7429), 1,
      anon_sym_DQUOTEB,
    STATE(4969), 1,
      aux_sym_verbatim_string_repeat1,
    STATE(5564), 1,
      sym__verbatim_string_char,
    STATE(5568), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7400), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(7398), 3,
      sym__non_escape_char,
      anon_sym_BSLASH,
      aux_sym__verbatim_string_char_token1,
    STATE(4960), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [132251] = 14,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(133), 1,
      sym_line_comment,
    ACTIONS(6818), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(6820), 1,
      anon_sym_POUNDlight,
    ACTIONS(6822), 1,
      anon_sym_POUNDr,
    ACTIONS(7431), 1,
      anon_sym_DQUOTE2,
    ACTIONS(7433), 1,
      anon_sym_DQUOTEB,
    STATE(4965), 1,
      aux_sym_verbatim_string_repeat1,
    STATE(5564), 1,
      sym__verbatim_string_char,
    STATE(5568), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7400), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(7398), 3,
      sym__non_escape_char,
      anon_sym_BSLASH,
      aux_sym__verbatim_string_char_token1,
    STATE(4961), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [132301] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(23), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7384), 1,
      anon_sym__,
    STATE(4305), 1,
      aux_sym_attributes_repeat1,
    STATE(4441), 1,
      sym__static_type_identifier,
    STATE(4488), 1,
      sym__attribute_set,
    STATE(5577), 1,
      sym_type_argument_defn,
    STATE(5702), 1,
      sym_attributes,
    STATE(5976), 1,
      sym_type_argument,
    ACTIONS(7386), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4962), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [132357] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(23), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7384), 1,
      anon_sym__,
    STATE(4305), 1,
      aux_sym_attributes_repeat1,
    STATE(4441), 1,
      sym__static_type_identifier,
    STATE(4488), 1,
      sym__attribute_set,
    STATE(5581), 1,
      sym_type_argument_defn,
    STATE(5702), 1,
      sym_attributes,
    STATE(5976), 1,
      sym_type_argument,
    ACTIONS(7386), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4963), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [132413] = 14,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(133), 1,
      sym_line_comment,
    ACTIONS(6818), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(6820), 1,
      anon_sym_POUNDlight,
    ACTIONS(6822), 1,
      anon_sym_POUNDr,
    ACTIONS(7435), 1,
      anon_sym_DQUOTE2,
    ACTIONS(7437), 1,
      anon_sym_DQUOTEB,
    STATE(4958), 1,
      aux_sym_verbatim_string_repeat1,
    STATE(5564), 1,
      sym__verbatim_string_char,
    STATE(5568), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7400), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(7398), 3,
      sym__non_escape_char,
      anon_sym_BSLASH,
      aux_sym__verbatim_string_char_token1,
    STATE(4964), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [132463] = 14,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(133), 1,
      sym_line_comment,
    ACTIONS(6818), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(6820), 1,
      anon_sym_POUNDlight,
    ACTIONS(6822), 1,
      anon_sym_POUNDr,
    ACTIONS(7439), 1,
      anon_sym_DQUOTE2,
    ACTIONS(7441), 1,
      anon_sym_DQUOTEB,
    STATE(5060), 1,
      aux_sym_verbatim_string_repeat1,
    STATE(5564), 1,
      sym__verbatim_string_char,
    STATE(5568), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7400), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(7398), 3,
      sym__non_escape_char,
      anon_sym_BSLASH,
      aux_sym__verbatim_string_char_token1,
    STATE(4965), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [132513] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(23), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7384), 1,
      anon_sym__,
    STATE(4305), 1,
      aux_sym_attributes_repeat1,
    STATE(4441), 1,
      sym__static_type_identifier,
    STATE(4488), 1,
      sym__attribute_set,
    STATE(5628), 1,
      sym_type_argument_defn,
    STATE(5702), 1,
      sym_attributes,
    STATE(5976), 1,
      sym_type_argument,
    ACTIONS(7386), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4966), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [132569] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(23), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7384), 1,
      anon_sym__,
    STATE(4305), 1,
      aux_sym_attributes_repeat1,
    STATE(4441), 1,
      sym__static_type_identifier,
    STATE(4488), 1,
      sym__attribute_set,
    STATE(5636), 1,
      sym_type_argument_defn,
    STATE(5702), 1,
      sym_attributes,
    STATE(5976), 1,
      sym_type_argument,
    ACTIONS(7386), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4967), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [132625] = 14,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(133), 1,
      sym_line_comment,
    ACTIONS(6818), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(6820), 1,
      anon_sym_POUNDlight,
    ACTIONS(6822), 1,
      anon_sym_POUNDr,
    ACTIONS(7443), 1,
      anon_sym_DQUOTE2,
    ACTIONS(7445), 1,
      anon_sym_DQUOTEB,
    STATE(4970), 1,
      aux_sym_verbatim_string_repeat1,
    STATE(5564), 1,
      sym__verbatim_string_char,
    STATE(5568), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7400), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(7398), 3,
      sym__non_escape_char,
      anon_sym_BSLASH,
      aux_sym__verbatim_string_char_token1,
    STATE(4968), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [132675] = 14,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(133), 1,
      sym_line_comment,
    ACTIONS(6818), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(6820), 1,
      anon_sym_POUNDlight,
    ACTIONS(6822), 1,
      anon_sym_POUNDr,
    ACTIONS(7447), 1,
      anon_sym_DQUOTE2,
    ACTIONS(7449), 1,
      anon_sym_DQUOTEB,
    STATE(5060), 1,
      aux_sym_verbatim_string_repeat1,
    STATE(5564), 1,
      sym__verbatim_string_char,
    STATE(5568), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7400), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(7398), 3,
      sym__non_escape_char,
      anon_sym_BSLASH,
      aux_sym__verbatim_string_char_token1,
    STATE(4969), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [132725] = 14,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(133), 1,
      sym_line_comment,
    ACTIONS(6818), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(6820), 1,
      anon_sym_POUNDlight,
    ACTIONS(6822), 1,
      anon_sym_POUNDr,
    ACTIONS(7451), 1,
      anon_sym_DQUOTE2,
    ACTIONS(7453), 1,
      anon_sym_DQUOTEB,
    STATE(5060), 1,
      aux_sym_verbatim_string_repeat1,
    STATE(5564), 1,
      sym__verbatim_string_char,
    STATE(5568), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7400), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(7398), 3,
      sym__non_escape_char,
      anon_sym_BSLASH,
      aux_sym__verbatim_string_char_token1,
    STATE(4970), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [132775] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(23), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7384), 1,
      anon_sym__,
    STATE(4305), 1,
      aux_sym_attributes_repeat1,
    STATE(4441), 1,
      sym__static_type_identifier,
    STATE(4488), 1,
      sym__attribute_set,
    STATE(5662), 1,
      sym_type_argument_defn,
    STATE(5702), 1,
      sym_attributes,
    STATE(5976), 1,
      sym_type_argument,
    ACTIONS(7386), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4971), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [132831] = 18,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(3570), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(7263), 1,
      sym_identifier,
    ACTIONS(7269), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(7271), 1,
      sym_op_identifier,
    ACTIONS(7291), 1,
      anon_sym_inline,
    STATE(2288), 1,
      sym_property_or_ident,
    STATE(3772), 1,
      sym__identifier_or_op,
    STATE(3773), 1,
      sym_active_pattern,
    STATE(4880), 1,
      sym_method_or_prop_defn,
    STATE(5548), 1,
      sym_access_modifier,
    STATE(4972), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [132889] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(23), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7384), 1,
      anon_sym__,
    STATE(4305), 1,
      aux_sym_attributes_repeat1,
    STATE(4441), 1,
      sym__static_type_identifier,
    STATE(4488), 1,
      sym__attribute_set,
    STATE(5679), 1,
      sym_type_argument_defn,
    STATE(5702), 1,
      sym_attributes,
    STATE(5976), 1,
      sym_type_argument,
    ACTIONS(7386), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4973), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [132945] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(23), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7384), 1,
      anon_sym__,
    STATE(4305), 1,
      aux_sym_attributes_repeat1,
    STATE(4441), 1,
      sym__static_type_identifier,
    STATE(4488), 1,
      sym__attribute_set,
    STATE(5644), 1,
      sym_type_argument_defn,
    STATE(5702), 1,
      sym_attributes,
    STATE(5976), 1,
      sym_type_argument,
    ACTIONS(7386), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4974), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [133001] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(23), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7384), 1,
      anon_sym__,
    STATE(4305), 1,
      aux_sym_attributes_repeat1,
    STATE(4441), 1,
      sym__static_type_identifier,
    STATE(4488), 1,
      sym__attribute_set,
    STATE(5650), 1,
      sym_type_argument_defn,
    STATE(5702), 1,
      sym_attributes,
    STATE(5976), 1,
      sym_type_argument,
    ACTIONS(7386), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4975), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [133057] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(23), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7384), 1,
      anon_sym__,
    STATE(4305), 1,
      aux_sym_attributes_repeat1,
    STATE(4441), 1,
      sym__static_type_identifier,
    STATE(4488), 1,
      sym__attribute_set,
    STATE(5668), 1,
      sym_type_argument_defn,
    STATE(5702), 1,
      sym_attributes,
    STATE(5976), 1,
      sym_type_argument,
    ACTIONS(7386), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4976), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [133113] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(23), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7384), 1,
      anon_sym__,
    STATE(4305), 1,
      aux_sym_attributes_repeat1,
    STATE(4441), 1,
      sym__static_type_identifier,
    STATE(4488), 1,
      sym__attribute_set,
    STATE(5667), 1,
      sym_type_argument_defn,
    STATE(5702), 1,
      sym_attributes,
    STATE(5976), 1,
      sym_type_argument,
    ACTIONS(7386), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4977), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [133169] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(23), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7384), 1,
      anon_sym__,
    STATE(4305), 1,
      aux_sym_attributes_repeat1,
    STATE(4441), 1,
      sym__static_type_identifier,
    STATE(4488), 1,
      sym__attribute_set,
    STATE(5670), 1,
      sym_type_argument_defn,
    STATE(5702), 1,
      sym_attributes,
    STATE(5976), 1,
      sym_type_argument,
    ACTIONS(7386), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4978), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [133225] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(23), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7384), 1,
      anon_sym__,
    STATE(4305), 1,
      aux_sym_attributes_repeat1,
    STATE(4441), 1,
      sym__static_type_identifier,
    STATE(4488), 1,
      sym__attribute_set,
    STATE(5692), 1,
      sym_type_argument_defn,
    STATE(5702), 1,
      sym_attributes,
    STATE(5976), 1,
      sym_type_argument,
    ACTIONS(7386), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4979), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [133281] = 14,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(133), 1,
      sym_line_comment,
    ACTIONS(6818), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(6820), 1,
      anon_sym_POUNDlight,
    ACTIONS(6822), 1,
      anon_sym_POUNDr,
    ACTIONS(7455), 1,
      anon_sym_DQUOTE2,
    ACTIONS(7457), 1,
      anon_sym_DQUOTEB,
    STATE(4982), 1,
      aux_sym_verbatim_string_repeat1,
    STATE(5564), 1,
      sym__verbatim_string_char,
    STATE(5568), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7400), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(7398), 3,
      sym__non_escape_char,
      anon_sym_BSLASH,
      aux_sym__verbatim_string_char_token1,
    STATE(4980), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [133331] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2411), 1,
      anon_sym_COLON,
    STATE(4981), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2413), 9,
      sym__newline,
      sym__dedent,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DOT,
      anon_sym_LT2,
  [133373] = 14,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(133), 1,
      sym_line_comment,
    ACTIONS(6818), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(6820), 1,
      anon_sym_POUNDlight,
    ACTIONS(6822), 1,
      anon_sym_POUNDr,
    ACTIONS(7459), 1,
      anon_sym_DQUOTE2,
    ACTIONS(7461), 1,
      anon_sym_DQUOTEB,
    STATE(5060), 1,
      aux_sym_verbatim_string_repeat1,
    STATE(5564), 1,
      sym__verbatim_string_char,
    STATE(5568), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7400), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(7398), 3,
      sym__non_escape_char,
      anon_sym_BSLASH,
      aux_sym__verbatim_string_char_token1,
    STATE(4982), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [133423] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(23), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7384), 1,
      anon_sym__,
    STATE(4305), 1,
      aux_sym_attributes_repeat1,
    STATE(4441), 1,
      sym__static_type_identifier,
    STATE(4488), 1,
      sym__attribute_set,
    STATE(5677), 1,
      sym_type_argument_defn,
    STATE(5702), 1,
      sym_attributes,
    STATE(5976), 1,
      sym_type_argument,
    ACTIONS(7386), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4983), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [133479] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(23), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7384), 1,
      anon_sym__,
    STATE(4305), 1,
      aux_sym_attributes_repeat1,
    STATE(4441), 1,
      sym__static_type_identifier,
    STATE(4488), 1,
      sym__attribute_set,
    STATE(5681), 1,
      sym_type_argument_defn,
    STATE(5702), 1,
      sym_attributes,
    STATE(5976), 1,
      sym_type_argument,
    ACTIONS(7386), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4984), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [133535] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2321), 2,
      anon_sym_val,
      sym_identifier,
    STATE(4985), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2323), 8,
      ts_builtin_sym_end,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [133577] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(23), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7384), 1,
      anon_sym__,
    STATE(4305), 1,
      aux_sym_attributes_repeat1,
    STATE(4441), 1,
      sym__static_type_identifier,
    STATE(4488), 1,
      sym__attribute_set,
    STATE(5609), 1,
      sym_type_argument_defn,
    STATE(5702), 1,
      sym_attributes,
    STATE(5976), 1,
      sym_type_argument,
    ACTIONS(7386), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4986), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [133633] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5402), 1,
      anon_sym_COLON,
    ACTIONS(7463), 1,
      anon_sym_and,
    STATE(4987), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_type_argument_constraints_repeat1,
    ACTIONS(5404), 7,
      sym__newline,
      sym__dedent,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
  [133677] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(23), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6451), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(7466), 1,
      sym_identifier,
    ACTIONS(7468), 1,
      anon_sym_mutable,
    STATE(4305), 1,
      aux_sym_attributes_repeat1,
    STATE(4488), 1,
      sym__attribute_set,
    STATE(5728), 1,
      sym_attributes,
    STATE(5967), 1,
      sym_record_field,
    STATE(6400), 1,
      sym_record_fields,
    STATE(7090), 1,
      sym_access_modifier,
    STATE(4988), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [133735] = 14,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(133), 1,
      sym_line_comment,
    ACTIONS(6818), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(6820), 1,
      anon_sym_POUNDlight,
    ACTIONS(6822), 1,
      anon_sym_POUNDr,
    ACTIONS(7470), 1,
      anon_sym_DQUOTE2,
    ACTIONS(7472), 1,
      anon_sym_DQUOTEB,
    STATE(5060), 1,
      aux_sym_verbatim_string_repeat1,
    STATE(5564), 1,
      sym__verbatim_string_char,
    STATE(5568), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7400), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(7398), 3,
      sym__non_escape_char,
      anon_sym_BSLASH,
      aux_sym__verbatim_string_char_token1,
    STATE(4989), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [133785] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(23), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7384), 1,
      anon_sym__,
    STATE(4305), 1,
      aux_sym_attributes_repeat1,
    STATE(4441), 1,
      sym__static_type_identifier,
    STATE(4488), 1,
      sym__attribute_set,
    STATE(5701), 1,
      sym_type_argument_defn,
    STATE(5702), 1,
      sym_attributes,
    STATE(5976), 1,
      sym_type_argument,
    ACTIONS(7386), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4990), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [133841] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2627), 2,
      anon_sym_with,
      sym_identifier,
    STATE(4991), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2629), 8,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [133883] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5409), 1,
      anon_sym_COLON,
    ACTIONS(7474), 1,
      anon_sym_and,
    STATE(4987), 1,
      aux_sym_type_argument_constraints_repeat1,
    STATE(4992), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5411), 7,
      sym__newline,
      sym__dedent,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
  [133929] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(23), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7384), 1,
      anon_sym__,
    STATE(4305), 1,
      aux_sym_attributes_repeat1,
    STATE(4441), 1,
      sym__static_type_identifier,
    STATE(4488), 1,
      sym__attribute_set,
    STATE(5665), 1,
      sym_type_argument_defn,
    STATE(5702), 1,
      sym_attributes,
    STATE(5976), 1,
      sym_type_argument,
    ACTIONS(7386), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4993), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [133985] = 14,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(133), 1,
      sym_line_comment,
    ACTIONS(6818), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(6820), 1,
      anon_sym_POUNDlight,
    ACTIONS(6822), 1,
      anon_sym_POUNDr,
    ACTIONS(7476), 1,
      anon_sym_DQUOTE2,
    ACTIONS(7478), 1,
      anon_sym_DQUOTEB,
    STATE(5000), 1,
      aux_sym_verbatim_string_repeat1,
    STATE(5564), 1,
      sym__verbatim_string_char,
    STATE(5568), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7400), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(7398), 3,
      sym__non_escape_char,
      anon_sym_BSLASH,
      aux_sym__verbatim_string_char_token1,
    STATE(4994), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [134035] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(23), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7384), 1,
      anon_sym__,
    STATE(4305), 1,
      aux_sym_attributes_repeat1,
    STATE(4441), 1,
      sym__static_type_identifier,
    STATE(4488), 1,
      sym__attribute_set,
    STATE(5583), 1,
      sym_type_argument_defn,
    STATE(5702), 1,
      sym_attributes,
    STATE(5976), 1,
      sym_type_argument,
    ACTIONS(7386), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4995), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [134091] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6451), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(6453), 1,
      anon_sym_new,
    ACTIONS(7144), 1,
      anon_sym_val,
    ACTIONS(7482), 1,
      anon_sym_static,
    ACTIONS(7484), 1,
      anon_sym_member,
    ACTIONS(7486), 1,
      anon_sym_abstract,
    STATE(4911), 1,
      sym_additional_constr_defn,
    STATE(7292), 1,
      sym_access_modifier,
    ACTIONS(7480), 2,
      anon_sym_default,
      anon_sym_override,
    STATE(4996), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [134147] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6962), 1,
      anon_sym_DOT,
    ACTIONS(7488), 1,
      anon_sym_EQ,
    STATE(4710), 1,
      aux_sym_long_identifier_repeat1,
    STATE(4997), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2314), 7,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      sym_identifier,
  [134193] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5417), 1,
      anon_sym_COLON,
    ACTIONS(7474), 1,
      anon_sym_and,
    STATE(4992), 1,
      aux_sym_type_argument_constraints_repeat1,
    STATE(4998), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5419), 7,
      sym__newline,
      sym__dedent,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
  [134239] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(23), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7384), 1,
      anon_sym__,
    STATE(4305), 1,
      aux_sym_attributes_repeat1,
    STATE(4441), 1,
      sym__static_type_identifier,
    STATE(4488), 1,
      sym__attribute_set,
    STATE(5597), 1,
      sym_type_argument_defn,
    STATE(5702), 1,
      sym_attributes,
    STATE(5976), 1,
      sym_type_argument,
    ACTIONS(7386), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(4999), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [134295] = 14,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(133), 1,
      sym_line_comment,
    ACTIONS(6818), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(6820), 1,
      anon_sym_POUNDlight,
    ACTIONS(6822), 1,
      anon_sym_POUNDr,
    ACTIONS(7490), 1,
      anon_sym_DQUOTE2,
    ACTIONS(7492), 1,
      anon_sym_DQUOTEB,
    STATE(5060), 1,
      aux_sym_verbatim_string_repeat1,
    STATE(5564), 1,
      sym__verbatim_string_char,
    STATE(5568), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7400), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(7398), 3,
      sym__non_escape_char,
      anon_sym_BSLASH,
      aux_sym__verbatim_string_char_token1,
    STATE(5000), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [134345] = 14,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(133), 1,
      sym_line_comment,
    ACTIONS(6818), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(6820), 1,
      anon_sym_POUNDlight,
    ACTIONS(6822), 1,
      anon_sym_POUNDr,
    ACTIONS(7494), 1,
      anon_sym_DQUOTE2,
    ACTIONS(7496), 1,
      anon_sym_DQUOTEB,
    STATE(4989), 1,
      aux_sym_verbatim_string_repeat1,
    STATE(5564), 1,
      sym__verbatim_string_char,
    STATE(5568), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7400), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(7398), 3,
      sym__non_escape_char,
      anon_sym_BSLASH,
      aux_sym__verbatim_string_char_token1,
    STATE(5001), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [134395] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6871), 1,
      anon_sym_DASH_GT,
    ACTIONS(6873), 1,
      anon_sym_STAR,
    ACTIONS(6875), 1,
      anon_sym_LT2,
    ACTIONS(6877), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(7353), 1,
      sym_identifier,
    STATE(4859), 1,
      aux_sym_compound_type_repeat1,
    STATE(4991), 1,
      sym_long_identifier,
    STATE(5160), 1,
      sym_type_arguments,
    ACTIONS(7498), 2,
      anon_sym_COMMA,
      anon_sym_GT,
    STATE(5002), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [134451] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7500), 1,
      anon_sym_or,
    STATE(5039), 1,
      aux_sym_type_argument_repeat1,
    ACTIONS(2321), 2,
      anon_sym_and,
      sym_identifier,
    STATE(5003), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2323), 6,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [134497] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5417), 1,
      anon_sym_COLON,
    ACTIONS(7502), 1,
      anon_sym_and,
    STATE(5134), 1,
      aux_sym_type_argument_constraints_repeat1,
    STATE(5004), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5419), 7,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT2,
  [134543] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6337), 1,
      anon_sym_DASH_GT,
    ACTIONS(6339), 1,
      anon_sym_STAR,
    ACTIONS(6341), 1,
      anon_sym_LT2,
    ACTIONS(6343), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(7504), 1,
      sym_identifier,
    STATE(4211), 1,
      aux_sym_compound_type_repeat1,
    STATE(4248), 1,
      sym_type_arguments,
    STATE(4268), 1,
      sym_long_identifier,
    ACTIONS(7506), 2,
      sym__newline,
      sym__dedent,
    STATE(5005), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [134599] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(23), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7384), 1,
      anon_sym__,
    STATE(4305), 1,
      aux_sym_attributes_repeat1,
    STATE(4441), 1,
      sym__static_type_identifier,
    STATE(4488), 1,
      sym__attribute_set,
    STATE(5612), 1,
      sym_type_argument_defn,
    STATE(5702), 1,
      sym_attributes,
    STATE(5976), 1,
      sym_type_argument,
    ACTIONS(7386), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5006), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [134655] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2240), 1,
      anon_sym_GT,
    ACTIONS(2242), 1,
      anon_sym_and,
    ACTIONS(5848), 1,
      sym_identifier,
    ACTIONS(7390), 1,
      anon_sym_DASH_GT,
    ACTIONS(7392), 1,
      anon_sym_STAR,
    ACTIONS(7394), 1,
      anon_sym_LT2,
    ACTIONS(7396), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(5427), 1,
      aux_sym_compound_type_repeat1,
    STATE(5557), 1,
      sym_type_arguments,
    STATE(5565), 1,
      sym_long_identifier,
    STATE(5007), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [134713] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(23), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7384), 1,
      anon_sym__,
    STATE(4305), 1,
      aux_sym_attributes_repeat1,
    STATE(4441), 1,
      sym__static_type_identifier,
    STATE(4488), 1,
      sym__attribute_set,
    STATE(5619), 1,
      sym_type_argument_defn,
    STATE(5702), 1,
      sym_attributes,
    STATE(5976), 1,
      sym_type_argument,
    ACTIONS(7386), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5008), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [134769] = 14,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(133), 1,
      sym_line_comment,
    ACTIONS(6818), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(6820), 1,
      anon_sym_POUNDlight,
    ACTIONS(6822), 1,
      anon_sym_POUNDr,
    ACTIONS(7508), 1,
      anon_sym_DQUOTE2,
    ACTIONS(7510), 1,
      anon_sym_DQUOTEB,
    STATE(5011), 1,
      aux_sym_verbatim_string_repeat1,
    STATE(5564), 1,
      sym__verbatim_string_char,
    STATE(5568), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7400), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(7398), 3,
      sym__non_escape_char,
      anon_sym_BSLASH,
      aux_sym__verbatim_string_char_token1,
    STATE(5009), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [134819] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(23), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7384), 1,
      anon_sym__,
    STATE(4305), 1,
      aux_sym_attributes_repeat1,
    STATE(4441), 1,
      sym__static_type_identifier,
    STATE(4488), 1,
      sym__attribute_set,
    STATE(5647), 1,
      sym_type_argument_defn,
    STATE(5702), 1,
      sym_attributes,
    STATE(5976), 1,
      sym_type_argument,
    ACTIONS(7386), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5010), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [134875] = 14,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(133), 1,
      sym_line_comment,
    ACTIONS(6818), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(6820), 1,
      anon_sym_POUNDlight,
    ACTIONS(6822), 1,
      anon_sym_POUNDr,
    ACTIONS(7512), 1,
      anon_sym_DQUOTE2,
    ACTIONS(7514), 1,
      anon_sym_DQUOTEB,
    STATE(5060), 1,
      aux_sym_verbatim_string_repeat1,
    STATE(5564), 1,
      sym__verbatim_string_char,
    STATE(5568), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7400), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(7398), 3,
      sym__non_escape_char,
      anon_sym_BSLASH,
      aux_sym__verbatim_string_char_token1,
    STATE(5011), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [134925] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(23), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7384), 1,
      anon_sym__,
    STATE(4305), 1,
      aux_sym_attributes_repeat1,
    STATE(4441), 1,
      sym__static_type_identifier,
    STATE(4488), 1,
      sym__attribute_set,
    STATE(5666), 1,
      sym_type_argument_defn,
    STATE(5702), 1,
      sym_attributes,
    STATE(5976), 1,
      sym_type_argument,
    ACTIONS(7386), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5012), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [134981] = 14,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(133), 1,
      sym_line_comment,
    ACTIONS(6818), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(6820), 1,
      anon_sym_POUNDlight,
    ACTIONS(6822), 1,
      anon_sym_POUNDr,
    ACTIONS(7516), 1,
      anon_sym_DQUOTE2,
    ACTIONS(7518), 1,
      anon_sym_DQUOTEB,
    STATE(5014), 1,
      aux_sym_verbatim_string_repeat1,
    STATE(5564), 1,
      sym__verbatim_string_char,
    STATE(5568), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7400), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(7398), 3,
      sym__non_escape_char,
      anon_sym_BSLASH,
      aux_sym__verbatim_string_char_token1,
    STATE(5013), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [135031] = 14,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(133), 1,
      sym_line_comment,
    ACTIONS(6818), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(6820), 1,
      anon_sym_POUNDlight,
    ACTIONS(6822), 1,
      anon_sym_POUNDr,
    ACTIONS(7520), 1,
      anon_sym_DQUOTE2,
    ACTIONS(7522), 1,
      anon_sym_DQUOTEB,
    STATE(5060), 1,
      aux_sym_verbatim_string_repeat1,
    STATE(5564), 1,
      sym__verbatim_string_char,
    STATE(5568), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7400), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(7398), 3,
      sym__non_escape_char,
      anon_sym_BSLASH,
      aux_sym__verbatim_string_char_token1,
    STATE(5014), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [135081] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6875), 1,
      anon_sym_LT2,
    ACTIONS(7524), 1,
      anon_sym_EQ,
    ACTIONS(7526), 1,
      anon_sym_COLON,
    ACTIONS(7528), 1,
      anon_sym_as,
    ACTIONS(7530), 1,
      anon_sym_COMMA,
    ACTIONS(7532), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7534), 1,
      anon_sym_PIPE,
    ACTIONS(7536), 1,
      anon_sym_AMP,
    STATE(5027), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(6203), 1,
      sym_type_arguments,
    STATE(5015), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [135139] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2244), 1,
      anon_sym_GT,
    ACTIONS(2246), 1,
      anon_sym_and,
    ACTIONS(5848), 1,
      sym_identifier,
    ACTIONS(7390), 1,
      anon_sym_DASH_GT,
    ACTIONS(7392), 1,
      anon_sym_STAR,
    ACTIONS(7394), 1,
      anon_sym_LT2,
    ACTIONS(7396), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(5427), 1,
      aux_sym_compound_type_repeat1,
    STATE(5557), 1,
      sym_type_arguments,
    STATE(5565), 1,
      sym_long_identifier,
    STATE(5016), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [135197] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(23), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7384), 1,
      anon_sym__,
    STATE(4305), 1,
      aux_sym_attributes_repeat1,
    STATE(4441), 1,
      sym__static_type_identifier,
    STATE(4488), 1,
      sym__attribute_set,
    STATE(5689), 1,
      sym_type_argument_defn,
    STATE(5702), 1,
      sym_attributes,
    STATE(5976), 1,
      sym_type_argument,
    ACTIONS(7386), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5017), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [135253] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5409), 1,
      anon_sym_COLON,
    ACTIONS(7538), 1,
      anon_sym_and,
    STATE(5019), 1,
      aux_sym_type_argument_constraints_repeat1,
    STATE(5018), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5411), 7,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
  [135299] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5402), 1,
      anon_sym_COLON,
    ACTIONS(7540), 1,
      anon_sym_and,
    STATE(5019), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_type_argument_constraints_repeat1,
    ACTIONS(5404), 7,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
  [135343] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(23), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7384), 1,
      anon_sym__,
    STATE(4305), 1,
      aux_sym_attributes_repeat1,
    STATE(4441), 1,
      sym__static_type_identifier,
    STATE(4488), 1,
      sym__attribute_set,
    STATE(5634), 1,
      sym_type_argument_defn,
    STATE(5702), 1,
      sym_attributes,
    STATE(5976), 1,
      sym_type_argument,
    ACTIONS(7386), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5020), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [135399] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2248), 1,
      anon_sym_GT,
    ACTIONS(2250), 1,
      anon_sym_and,
    ACTIONS(5848), 1,
      sym_identifier,
    ACTIONS(7390), 1,
      anon_sym_DASH_GT,
    ACTIONS(7392), 1,
      anon_sym_STAR,
    ACTIONS(7394), 1,
      anon_sym_LT2,
    ACTIONS(7396), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(5427), 1,
      aux_sym_compound_type_repeat1,
    STATE(5557), 1,
      sym_type_arguments,
    STATE(5565), 1,
      sym_long_identifier,
    STATE(5021), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [135457] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2321), 1,
      anon_sym_COLON,
    ACTIONS(7388), 1,
      anon_sym_or,
    STATE(4945), 1,
      aux_sym_type_argument_repeat1,
    STATE(5022), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2323), 7,
      sym__newline,
      sym__dedent,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
  [135503] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(23), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6451), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(7466), 1,
      sym_identifier,
    ACTIONS(7468), 1,
      anon_sym_mutable,
    STATE(4305), 1,
      aux_sym_attributes_repeat1,
    STATE(4488), 1,
      sym__attribute_set,
    STATE(5728), 1,
      sym_attributes,
    STATE(5967), 1,
      sym_record_field,
    STATE(6458), 1,
      sym_record_fields,
    STATE(7090), 1,
      sym_access_modifier,
    STATE(5023), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [135561] = 14,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(133), 1,
      sym_line_comment,
    ACTIONS(6818), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(6820), 1,
      anon_sym_POUNDlight,
    ACTIONS(6822), 1,
      anon_sym_POUNDr,
    ACTIONS(7543), 1,
      anon_sym_DQUOTE2,
    ACTIONS(7545), 1,
      anon_sym_DQUOTEB,
    STATE(5026), 1,
      aux_sym_verbatim_string_repeat1,
    STATE(5564), 1,
      sym__verbatim_string_char,
    STATE(5568), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7400), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(7398), 3,
      sym__non_escape_char,
      anon_sym_BSLASH,
      aux_sym__verbatim_string_char_token1,
    STATE(5024), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [135611] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(23), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7384), 1,
      anon_sym__,
    STATE(4305), 1,
      aux_sym_attributes_repeat1,
    STATE(4441), 1,
      sym__static_type_identifier,
    STATE(4488), 1,
      sym__attribute_set,
    STATE(5688), 1,
      sym_type_argument_defn,
    STATE(5702), 1,
      sym_attributes,
    STATE(5976), 1,
      sym_type_argument,
    ACTIONS(7386), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5025), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [135667] = 14,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(133), 1,
      sym_line_comment,
    ACTIONS(6818), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(6820), 1,
      anon_sym_POUNDlight,
    ACTIONS(6822), 1,
      anon_sym_POUNDr,
    ACTIONS(7547), 1,
      anon_sym_DQUOTE2,
    ACTIONS(7549), 1,
      anon_sym_DQUOTEB,
    STATE(5060), 1,
      aux_sym_verbatim_string_repeat1,
    STATE(5564), 1,
      sym__verbatim_string_char,
    STATE(5568), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7400), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(7398), 3,
      sym__non_escape_char,
      anon_sym_BSLASH,
      aux_sym__verbatim_string_char_token1,
    STATE(5026), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [135717] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5531), 1,
      anon_sym_COLON,
    ACTIONS(7530), 1,
      anon_sym_COMMA,
    STATE(5087), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(5027), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5533), 7,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT2,
  [135763] = 14,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(133), 1,
      sym_line_comment,
    ACTIONS(6818), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(6820), 1,
      anon_sym_POUNDlight,
    ACTIONS(6822), 1,
      anon_sym_POUNDr,
    ACTIONS(7551), 1,
      anon_sym_DQUOTE2,
    ACTIONS(7553), 1,
      anon_sym_DQUOTEB,
    STATE(5060), 1,
      aux_sym_verbatim_string_repeat1,
    STATE(5564), 1,
      sym__verbatim_string_char,
    STATE(5568), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7400), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(7398), 3,
      sym__non_escape_char,
      anon_sym_BSLASH,
      aux_sym__verbatim_string_char_token1,
    STATE(5028), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [135813] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7555), 1,
      anon_sym_COLON,
    ACTIONS(7557), 1,
      anon_sym_as,
    ACTIONS(7559), 1,
      anon_sym_COMMA,
    ACTIONS(7561), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7563), 1,
      anon_sym_PIPE,
    ACTIONS(7565), 1,
      anon_sym_AMP,
    ACTIONS(7567), 1,
      sym__newline,
    ACTIONS(7569), 1,
      sym__dedent,
    STATE(5315), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(5866), 1,
      aux_sym__list_pattern_content_repeat1,
    STATE(5029), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [135871] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2228), 1,
      anon_sym_GT,
    ACTIONS(2230), 1,
      anon_sym_and,
    ACTIONS(5848), 1,
      sym_identifier,
    ACTIONS(7390), 1,
      anon_sym_DASH_GT,
    ACTIONS(7392), 1,
      anon_sym_STAR,
    ACTIONS(7394), 1,
      anon_sym_LT2,
    ACTIONS(7396), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(5427), 1,
      aux_sym_compound_type_repeat1,
    STATE(5557), 1,
      sym_type_arguments,
    STATE(5565), 1,
      sym_long_identifier,
    STATE(5030), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [135929] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2340), 1,
      anon_sym_COLON,
    STATE(5031), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2342), 9,
      sym__newline,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
      anon_sym_or,
  [135971] = 14,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(133), 1,
      sym_line_comment,
    ACTIONS(6818), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(6820), 1,
      anon_sym_POUNDlight,
    ACTIONS(6822), 1,
      anon_sym_POUNDr,
    ACTIONS(7571), 1,
      anon_sym_DQUOTE2,
    ACTIONS(7573), 1,
      anon_sym_DQUOTEB,
    STATE(5036), 1,
      aux_sym_verbatim_string_repeat1,
    STATE(5564), 1,
      sym__verbatim_string_char,
    STATE(5568), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7400), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(7398), 3,
      sym__non_escape_char,
      anon_sym_BSLASH,
      aux_sym__verbatim_string_char_token1,
    STATE(5032), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [136021] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5474), 1,
      anon_sym_COLON,
    STATE(5027), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(5033), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5476), 8,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT2,
  [136065] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7575), 1,
      anon_sym_STAR,
    ACTIONS(2250), 2,
      anon_sym_val,
      sym_identifier,
    STATE(5034), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_compound_type_repeat1,
    ACTIONS(2248), 6,
      ts_builtin_sym_end,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_DASH_GT,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [136109] = 14,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(133), 1,
      sym_line_comment,
    ACTIONS(6818), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(6820), 1,
      anon_sym_POUNDlight,
    ACTIONS(6822), 1,
      anon_sym_POUNDr,
    ACTIONS(7578), 1,
      anon_sym_DQUOTE2,
    ACTIONS(7580), 1,
      anon_sym_DQUOTEB,
    STATE(5028), 1,
      aux_sym_verbatim_string_repeat1,
    STATE(5564), 1,
      sym__verbatim_string_char,
    STATE(5568), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7400), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(7398), 3,
      sym__non_escape_char,
      anon_sym_BSLASH,
      aux_sym__verbatim_string_char_token1,
    STATE(5035), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [136159] = 14,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(133), 1,
      sym_line_comment,
    ACTIONS(6818), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(6820), 1,
      anon_sym_POUNDlight,
    ACTIONS(6822), 1,
      anon_sym_POUNDr,
    ACTIONS(7582), 1,
      anon_sym_DQUOTE2,
    ACTIONS(7584), 1,
      anon_sym_DQUOTEB,
    STATE(5060), 1,
      aux_sym_verbatim_string_repeat1,
    STATE(5564), 1,
      sym__verbatim_string_char,
    STATE(5568), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7400), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(7398), 3,
      sym__non_escape_char,
      anon_sym_BSLASH,
      aux_sym__verbatim_string_char_token1,
    STATE(5036), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [136209] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5013), 1,
      anon_sym_and,
    ACTIONS(5015), 1,
      anon_sym_GT,
    ACTIONS(5848), 1,
      sym_identifier,
    ACTIONS(7390), 1,
      anon_sym_DASH_GT,
    ACTIONS(7392), 1,
      anon_sym_STAR,
    ACTIONS(7394), 1,
      anon_sym_LT2,
    ACTIONS(7396), 1,
      anon_sym_LBRACK_RBRACK,
    STATE(5427), 1,
      aux_sym_compound_type_repeat1,
    STATE(5557), 1,
      sym_type_arguments,
    STATE(5565), 1,
      sym_long_identifier,
    STATE(5037), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [136267] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2462), 1,
      anon_sym_COLON,
    STATE(5038), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2464), 9,
      sym__newline,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
      anon_sym_or,
  [136309] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7500), 1,
      anon_sym_or,
    STATE(5043), 1,
      aux_sym_type_argument_repeat1,
    ACTIONS(2328), 2,
      anon_sym_and,
      sym_identifier,
    STATE(5039), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2330), 6,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [136355] = 14,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(133), 1,
      sym_line_comment,
    ACTIONS(6818), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(6820), 1,
      anon_sym_POUNDlight,
    ACTIONS(6822), 1,
      anon_sym_POUNDr,
    ACTIONS(7586), 1,
      anon_sym_DQUOTE2,
    ACTIONS(7588), 1,
      anon_sym_DQUOTEB,
    STATE(5060), 1,
      aux_sym_verbatim_string_repeat1,
    STATE(5564), 1,
      sym__verbatim_string_char,
    STATE(5568), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7400), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(7398), 3,
      sym__non_escape_char,
      anon_sym_BSLASH,
      aux_sym__verbatim_string_char_token1,
    STATE(5040), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [136405] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5409), 1,
      anon_sym_COLON,
    ACTIONS(7590), 1,
      anon_sym_and,
    STATE(5047), 1,
      aux_sym_type_argument_constraints_repeat1,
    STATE(5041), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5411), 7,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_when,
  [136451] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(23), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7384), 1,
      anon_sym__,
    STATE(4305), 1,
      aux_sym_attributes_repeat1,
    STATE(4441), 1,
      sym__static_type_identifier,
    STATE(4488), 1,
      sym__attribute_set,
    STATE(5643), 1,
      sym_type_argument_defn,
    STATE(5702), 1,
      sym_attributes,
    STATE(5976), 1,
      sym_type_argument,
    ACTIONS(7386), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5042), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [136507] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7592), 1,
      anon_sym_or,
    ACTIONS(2340), 2,
      anon_sym_and,
      sym_identifier,
    STATE(5043), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_type_argument_repeat1,
    ACTIONS(2342), 6,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [136551] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6992), 1,
      anon_sym_STAR,
    STATE(5034), 1,
      aux_sym_compound_type_repeat1,
    ACTIONS(2407), 2,
      anon_sym_val,
      sym_identifier,
    STATE(5044), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2409), 6,
      ts_builtin_sym_end,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_DASH_GT,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [136597] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7595), 1,
      anon_sym_COLON_GT,
    ACTIONS(2567), 2,
      anon_sym_val,
      sym_identifier,
    STATE(5045), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2569), 7,
      ts_builtin_sym_end,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [136641] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7597), 1,
      sym_identifier,
    ACTIONS(7599), 1,
      anon_sym_LPAREN,
    ACTIONS(7601), 1,
      anon_sym__,
    ACTIONS(7603), 1,
      anon_sym_POUND,
    STATE(3421), 1,
      sym__static_type_identifier,
    STATE(3603), 1,
      sym_long_identifier,
    STATE(3753), 1,
      sym_type_argument,
    STATE(3760), 1,
      sym_atomic_type,
    ACTIONS(7605), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5046), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [136697] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5402), 1,
      anon_sym_COLON,
    ACTIONS(7607), 1,
      anon_sym_and,
    STATE(5047), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_type_argument_constraints_repeat1,
    ACTIONS(5404), 7,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_when,
  [136741] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(23), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6451), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(7466), 1,
      sym_identifier,
    ACTIONS(7468), 1,
      anon_sym_mutable,
    STATE(4305), 1,
      aux_sym_attributes_repeat1,
    STATE(4488), 1,
      sym__attribute_set,
    STATE(5728), 1,
      sym_attributes,
    STATE(5967), 1,
      sym_record_field,
    STATE(6513), 1,
      sym_record_fields,
    STATE(7090), 1,
      sym_access_modifier,
    STATE(5048), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [136799] = 14,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(133), 1,
      sym_line_comment,
    ACTIONS(6818), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(6820), 1,
      anon_sym_POUNDlight,
    ACTIONS(6822), 1,
      anon_sym_POUNDr,
    ACTIONS(7610), 1,
      anon_sym_DQUOTE2,
    ACTIONS(7612), 1,
      anon_sym_DQUOTEB,
    STATE(5060), 1,
      aux_sym_verbatim_string_repeat1,
    STATE(5564), 1,
      sym__verbatim_string_char,
    STATE(5568), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7400), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(7398), 3,
      sym__non_escape_char,
      anon_sym_BSLASH,
      aux_sym__verbatim_string_char_token1,
    STATE(5049), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [136849] = 14,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(133), 1,
      sym_line_comment,
    ACTIONS(6818), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(6820), 1,
      anon_sym_POUNDlight,
    ACTIONS(6822), 1,
      anon_sym_POUNDr,
    ACTIONS(7614), 1,
      anon_sym_DQUOTE2,
    ACTIONS(7616), 1,
      anon_sym_DQUOTEB,
    STATE(5049), 1,
      aux_sym_verbatim_string_repeat1,
    STATE(5564), 1,
      sym__verbatim_string_char,
    STATE(5568), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7400), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(7398), 3,
      sym__non_escape_char,
      anon_sym_BSLASH,
      aux_sym__verbatim_string_char_token1,
    STATE(5050), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [136899] = 14,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(133), 1,
      sym_line_comment,
    ACTIONS(6818), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(6820), 1,
      anon_sym_POUNDlight,
    ACTIONS(6822), 1,
      anon_sym_POUNDr,
    ACTIONS(7618), 1,
      anon_sym_DQUOTE2,
    ACTIONS(7620), 1,
      anon_sym_DQUOTEB,
    STATE(5040), 1,
      aux_sym_verbatim_string_repeat1,
    STATE(5564), 1,
      sym__verbatim_string_char,
    STATE(5568), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7400), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(7398), 3,
      sym__non_escape_char,
      anon_sym_BSLASH,
      aux_sym__verbatim_string_char_token1,
    STATE(5051), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [136949] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5527), 1,
      anon_sym_COLON,
    STATE(5052), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5529), 9,
      sym__newline,
      anon_sym_and,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
  [136991] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2563), 2,
      anon_sym_with,
      sym_identifier,
    STATE(5053), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2565), 8,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [137033] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5520), 1,
      anon_sym_COLON,
    STATE(5054), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5522), 9,
      sym__newline,
      anon_sym_and,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
  [137075] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5417), 1,
      anon_sym_COLON,
    ACTIONS(7538), 1,
      anon_sym_and,
    STATE(5018), 1,
      aux_sym_type_argument_constraints_repeat1,
    STATE(5055), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5419), 7,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
  [137121] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5516), 1,
      anon_sym_COLON,
    STATE(5056), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5518), 9,
      sym__newline,
      anon_sym_and,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
  [137163] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5487), 1,
      anon_sym_COLON,
    STATE(5057), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5489), 9,
      sym__newline,
      anon_sym_and,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
  [137205] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5009), 1,
      anon_sym_COLON,
    STATE(5058), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5011), 9,
      sym__newline,
      anon_sym_and,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
  [137247] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5013), 1,
      anon_sym_COLON,
    STATE(5059), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5015), 9,
      sym__newline,
      anon_sym_and,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
  [137289] = 13,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(133), 1,
      sym_line_comment,
    ACTIONS(6818), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(6820), 1,
      anon_sym_POUNDlight,
    ACTIONS(6822), 1,
      anon_sym_POUNDr,
    ACTIONS(7628), 1,
      anon_sym_DQUOTE2,
    ACTIONS(7630), 1,
      anon_sym_DQUOTEB,
    STATE(5564), 1,
      sym__verbatim_string_char,
    STATE(5568), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7625), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(7622), 3,
      sym__non_escape_char,
      anon_sym_BSLASH,
      aux_sym__verbatim_string_char_token1,
    STATE(5060), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_verbatim_string_repeat1,
  [137337] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(23), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6451), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(7466), 1,
      sym_identifier,
    ACTIONS(7468), 1,
      anon_sym_mutable,
    STATE(4305), 1,
      aux_sym_attributes_repeat1,
    STATE(4488), 1,
      sym__attribute_set,
    STATE(5728), 1,
      sym_attributes,
    STATE(5967), 1,
      sym_record_field,
    STATE(6563), 1,
      sym_record_fields,
    STATE(7090), 1,
      sym_access_modifier,
    STATE(5061), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [137395] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5402), 1,
      anon_sym_COLON,
    STATE(5062), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5404), 9,
      sym__newline,
      anon_sym_and,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
  [137437] = 14,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(133), 1,
      sym_line_comment,
    ACTIONS(6818), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(6820), 1,
      anon_sym_POUNDlight,
    ACTIONS(6822), 1,
      anon_sym_POUNDr,
    ACTIONS(7632), 1,
      anon_sym_DQUOTE2,
    ACTIONS(7634), 1,
      anon_sym_DQUOTEB,
    STATE(5060), 1,
      aux_sym_verbatim_string_repeat1,
    STATE(5564), 1,
      sym__verbatim_string_char,
    STATE(5568), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7400), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(7398), 3,
      sym__non_escape_char,
      anon_sym_BSLASH,
      aux_sym__verbatim_string_char_token1,
    STATE(5063), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [137487] = 14,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(133), 1,
      sym_line_comment,
    ACTIONS(6818), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(6820), 1,
      anon_sym_POUNDlight,
    ACTIONS(6822), 1,
      anon_sym_POUNDr,
    ACTIONS(7636), 1,
      anon_sym_DQUOTE2,
    ACTIONS(7638), 1,
      anon_sym_DQUOTEB,
    STATE(5081), 1,
      aux_sym_verbatim_string_repeat1,
    STATE(5564), 1,
      sym__verbatim_string_char,
    STATE(5568), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7400), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(7398), 3,
      sym__non_escape_char,
      anon_sym_BSLASH,
      aux_sym__verbatim_string_char_token1,
    STATE(5064), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [137537] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2411), 2,
      anon_sym_val,
      sym_identifier,
    STATE(5065), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2413), 8,
      ts_builtin_sym_end,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [137579] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6337), 1,
      anon_sym_DASH_GT,
    ACTIONS(6339), 1,
      anon_sym_STAR,
    ACTIONS(6341), 1,
      anon_sym_LT2,
    ACTIONS(6343), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(7504), 1,
      sym_identifier,
    STATE(4211), 1,
      aux_sym_compound_type_repeat1,
    STATE(4248), 1,
      sym_type_arguments,
    STATE(4268), 1,
      sym_long_identifier,
    ACTIONS(7640), 2,
      sym__newline,
      sym__dedent,
    STATE(5066), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [137635] = 14,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(133), 1,
      sym_line_comment,
    ACTIONS(6818), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(6820), 1,
      anon_sym_POUNDlight,
    ACTIONS(6822), 1,
      anon_sym_POUNDr,
    ACTIONS(7642), 1,
      anon_sym_DQUOTE2,
    ACTIONS(7644), 1,
      anon_sym_DQUOTEB,
    STATE(5071), 1,
      aux_sym_verbatim_string_repeat1,
    STATE(5564), 1,
      sym__verbatim_string_char,
    STATE(5568), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7400), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(7398), 3,
      sym__non_escape_char,
      anon_sym_BSLASH,
      aux_sym__verbatim_string_char_token1,
    STATE(5067), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [137685] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7646), 1,
      sym_identifier,
    ACTIONS(7648), 1,
      anon_sym_LPAREN,
    ACTIONS(7650), 1,
      anon_sym__,
    ACTIONS(7652), 1,
      anon_sym_POUND,
    STATE(3318), 1,
      sym__static_type_identifier,
    STATE(3406), 1,
      sym_long_identifier,
    STATE(3547), 1,
      sym_atomic_type,
    STATE(3548), 1,
      sym_type_argument,
    ACTIONS(7654), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5068), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [137741] = 18,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(3570), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(7263), 1,
      sym_identifier,
    ACTIONS(7269), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(7271), 1,
      sym_op_identifier,
    ACTIONS(7656), 1,
      anon_sym_inline,
    STATE(2288), 1,
      sym_property_or_ident,
    STATE(3772), 1,
      sym__identifier_or_op,
    STATE(3773), 1,
      sym_active_pattern,
    STATE(4887), 1,
      sym_method_or_prop_defn,
    STATE(5528), 1,
      sym_access_modifier,
    STATE(5069), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [137799] = 14,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(133), 1,
      sym_line_comment,
    ACTIONS(6818), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(6820), 1,
      anon_sym_POUNDlight,
    ACTIONS(6822), 1,
      anon_sym_POUNDr,
    ACTIONS(7658), 1,
      anon_sym_DQUOTE2,
    ACTIONS(7660), 1,
      anon_sym_DQUOTEB,
    STATE(5060), 1,
      aux_sym_verbatim_string_repeat1,
    STATE(5564), 1,
      sym__verbatim_string_char,
    STATE(5568), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7400), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(7398), 3,
      sym__non_escape_char,
      anon_sym_BSLASH,
      aux_sym__verbatim_string_char_token1,
    STATE(5070), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [137849] = 14,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(133), 1,
      sym_line_comment,
    ACTIONS(6818), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(6820), 1,
      anon_sym_POUNDlight,
    ACTIONS(6822), 1,
      anon_sym_POUNDr,
    ACTIONS(7662), 1,
      anon_sym_DQUOTE2,
    ACTIONS(7664), 1,
      anon_sym_DQUOTEB,
    STATE(5060), 1,
      aux_sym_verbatim_string_repeat1,
    STATE(5564), 1,
      sym__verbatim_string_char,
    STATE(5568), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7400), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(7398), 3,
      sym__non_escape_char,
      anon_sym_BSLASH,
      aux_sym__verbatim_string_char_token1,
    STATE(5071), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [137899] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7666), 1,
      sym_identifier,
    ACTIONS(7668), 1,
      anon_sym_LPAREN,
    ACTIONS(7670), 1,
      anon_sym__,
    ACTIONS(7672), 1,
      anon_sym_POUND,
    STATE(4441), 1,
      sym__static_type_identifier,
    STATE(4775), 1,
      sym_atomic_type,
    STATE(4776), 1,
      sym_type_argument,
    STATE(4777), 1,
      sym_long_identifier,
    ACTIONS(7386), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5072), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [137955] = 14,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(133), 1,
      sym_line_comment,
    ACTIONS(6818), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(6820), 1,
      anon_sym_POUNDlight,
    ACTIONS(6822), 1,
      anon_sym_POUNDr,
    ACTIONS(7674), 1,
      anon_sym_DQUOTE2,
    ACTIONS(7676), 1,
      anon_sym_DQUOTEB,
    STATE(5070), 1,
      aux_sym_verbatim_string_repeat1,
    STATE(5564), 1,
      sym__verbatim_string_char,
    STATE(5568), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7400), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(7398), 3,
      sym__non_escape_char,
      anon_sym_BSLASH,
      aux_sym__verbatim_string_char_token1,
    STATE(5073), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [138005] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2553), 2,
      anon_sym_with,
      sym_identifier,
    STATE(5074), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2555), 8,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [138047] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5417), 1,
      anon_sym_COLON,
    ACTIONS(7590), 1,
      anon_sym_and,
    STATE(5041), 1,
      aux_sym_type_argument_constraints_repeat1,
    STATE(5075), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5419), 7,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_when,
  [138093] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6871), 1,
      anon_sym_DASH_GT,
    ACTIONS(6873), 1,
      anon_sym_STAR,
    ACTIONS(6875), 1,
      anon_sym_LT2,
    ACTIONS(6877), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(7353), 1,
      sym_identifier,
    STATE(4859), 1,
      aux_sym_compound_type_repeat1,
    STATE(4991), 1,
      sym_long_identifier,
    STATE(5160), 1,
      sym_type_arguments,
    ACTIONS(7678), 2,
      anon_sym_COMMA,
      anon_sym_GT,
    STATE(5076), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [138149] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(23), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6451), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(7466), 1,
      sym_identifier,
    ACTIONS(7468), 1,
      anon_sym_mutable,
    STATE(4305), 1,
      aux_sym_attributes_repeat1,
    STATE(4488), 1,
      sym__attribute_set,
    STATE(5728), 1,
      sym_attributes,
    STATE(5967), 1,
      sym_record_field,
    STATE(6613), 1,
      sym_record_fields,
    STATE(7090), 1,
      sym_access_modifier,
    STATE(5077), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [138207] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5503), 1,
      anon_sym_COLON,
    STATE(5027), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(5078), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5505), 8,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT2,
  [138251] = 14,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(133), 1,
      sym_line_comment,
    ACTIONS(6818), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(6820), 1,
      anon_sym_POUNDlight,
    ACTIONS(6822), 1,
      anon_sym_POUNDr,
    ACTIONS(7680), 1,
      anon_sym_DQUOTE2,
    ACTIONS(7682), 1,
      anon_sym_DQUOTEB,
    STATE(5063), 1,
      aux_sym_verbatim_string_repeat1,
    STATE(5564), 1,
      sym__verbatim_string_char,
    STATE(5568), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7400), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(7398), 3,
      sym__non_escape_char,
      anon_sym_BSLASH,
      aux_sym__verbatim_string_char_token1,
    STATE(5079), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [138301] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5503), 1,
      anon_sym_COLON,
    ACTIONS(7684), 1,
      anon_sym_COMMA,
    STATE(5080), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_repeat_pattern_repeat1,
    ACTIONS(5505), 7,
      sym__newline,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
  [138345] = 14,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(133), 1,
      sym_line_comment,
    ACTIONS(6818), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(6820), 1,
      anon_sym_POUNDlight,
    ACTIONS(6822), 1,
      anon_sym_POUNDr,
    ACTIONS(7687), 1,
      anon_sym_DQUOTE2,
    ACTIONS(7689), 1,
      anon_sym_DQUOTEB,
    STATE(5060), 1,
      aux_sym_verbatim_string_repeat1,
    STATE(5564), 1,
      sym__verbatim_string_char,
    STATE(5568), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7400), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(7398), 3,
      sym__non_escape_char,
      anon_sym_BSLASH,
      aux_sym__verbatim_string_char_token1,
    STATE(5081), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [138395] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5562), 1,
      anon_sym_COLON,
    STATE(5027), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(5082), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5564), 8,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT2,
  [138439] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5537), 1,
      anon_sym_COLON,
    STATE(5153), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(5083), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5539), 8,
      sym__newline,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
  [138483] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5558), 1,
      anon_sym_COLON,
    STATE(5027), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(5084), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5560), 8,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT2,
  [138527] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5537), 1,
      anon_sym_COLON,
    STATE(5027), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(5085), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5539), 8,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT2,
  [138571] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5558), 1,
      anon_sym_COLON,
    STATE(5153), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(5086), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5560), 8,
      sym__newline,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
  [138615] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5503), 1,
      anon_sym_COLON,
    ACTIONS(7691), 1,
      anon_sym_COMMA,
    STATE(5087), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_repeat_pattern_repeat1,
    ACTIONS(5505), 7,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT2,
  [138659] = 16,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5491), 1,
      anon_sym_COLON,
    ACTIONS(7528), 1,
      anon_sym_as,
    ACTIONS(7530), 1,
      anon_sym_COMMA,
    ACTIONS(7532), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7534), 1,
      anon_sym_PIPE,
    ACTIONS(7536), 1,
      anon_sym_AMP,
    STATE(5027), 1,
      aux_sym_repeat_pattern_repeat1,
    ACTIONS(5493), 3,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_LT2,
    STATE(5088), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [138713] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5562), 1,
      anon_sym_COLON,
    STATE(5153), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(5089), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5564), 8,
      sym__newline,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
  [138757] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(23), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6451), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(7466), 1,
      sym_identifier,
    ACTIONS(7468), 1,
      anon_sym_mutable,
    STATE(4305), 1,
      aux_sym_attributes_repeat1,
    STATE(4488), 1,
      sym__attribute_set,
    STATE(5728), 1,
      sym_attributes,
    STATE(5967), 1,
      sym_record_field,
    STATE(7080), 1,
      sym_record_fields,
    STATE(7090), 1,
      sym_access_modifier,
    STATE(5090), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [138815] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5503), 1,
      anon_sym_COLON,
    STATE(5153), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(5091), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5505), 8,
      sym__newline,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
  [138859] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(23), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6451), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(7466), 1,
      sym_identifier,
    ACTIONS(7468), 1,
      anon_sym_mutable,
    STATE(4305), 1,
      aux_sym_attributes_repeat1,
    STATE(4488), 1,
      sym__attribute_set,
    STATE(5728), 1,
      sym_attributes,
    STATE(5967), 1,
      sym_record_field,
    STATE(6661), 1,
      sym_record_fields,
    STATE(7090), 1,
      sym_access_modifier,
    STATE(5092), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [138917] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(23), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6451), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(7466), 1,
      sym_identifier,
    ACTIONS(7468), 1,
      anon_sym_mutable,
    STATE(4305), 1,
      aux_sym_attributes_repeat1,
    STATE(4488), 1,
      sym__attribute_set,
    STATE(5728), 1,
      sym_attributes,
    STATE(5967), 1,
      sym_record_field,
    STATE(7076), 1,
      sym_record_fields,
    STATE(7090), 1,
      sym_access_modifier,
    STATE(5093), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [138975] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5431), 1,
      anon_sym_COLON,
    STATE(5027), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(5094), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5433), 8,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT2,
  [139019] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(23), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6451), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(7466), 1,
      sym_identifier,
    ACTIONS(7468), 1,
      anon_sym_mutable,
    STATE(4305), 1,
      aux_sym_attributes_repeat1,
    STATE(4488), 1,
      sym__attribute_set,
    STATE(5728), 1,
      sym_attributes,
    STATE(5967), 1,
      sym_record_field,
    STATE(7072), 1,
      sym_record_fields,
    STATE(7090), 1,
      sym_access_modifier,
    STATE(5095), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [139077] = 14,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(133), 1,
      sym_line_comment,
    ACTIONS(6818), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(6820), 1,
      anon_sym_POUNDlight,
    ACTIONS(6822), 1,
      anon_sym_POUNDr,
    ACTIONS(7694), 1,
      anon_sym_DQUOTE2,
    ACTIONS(7696), 1,
      anon_sym_DQUOTEB,
    STATE(5060), 1,
      aux_sym_verbatim_string_repeat1,
    STATE(5564), 1,
      sym__verbatim_string_char,
    STATE(5568), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7400), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(7398), 3,
      sym__non_escape_char,
      anon_sym_BSLASH,
      aux_sym__verbatim_string_char_token1,
    STATE(5096), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [139127] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(23), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6451), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(7466), 1,
      sym_identifier,
    ACTIONS(7468), 1,
      anon_sym_mutable,
    STATE(4305), 1,
      aux_sym_attributes_repeat1,
    STATE(4488), 1,
      sym__attribute_set,
    STATE(5728), 1,
      sym_attributes,
    STATE(5967), 1,
      sym_record_field,
    STATE(7068), 1,
      sym_record_fields,
    STATE(7090), 1,
      sym_access_modifier,
    STATE(5097), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [139185] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(23), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6451), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(7466), 1,
      sym_identifier,
    ACTIONS(7468), 1,
      anon_sym_mutable,
    STATE(4305), 1,
      aux_sym_attributes_repeat1,
    STATE(4488), 1,
      sym__attribute_set,
    STATE(5728), 1,
      sym_attributes,
    STATE(5967), 1,
      sym_record_field,
    STATE(7064), 1,
      sym_record_fields,
    STATE(7090), 1,
      sym_access_modifier,
    STATE(5098), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [139243] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(23), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6451), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(7466), 1,
      sym_identifier,
    ACTIONS(7468), 1,
      anon_sym_mutable,
    STATE(4305), 1,
      aux_sym_attributes_repeat1,
    STATE(4488), 1,
      sym__attribute_set,
    STATE(5728), 1,
      sym_attributes,
    STATE(5967), 1,
      sym_record_field,
    STATE(7060), 1,
      sym_record_fields,
    STATE(7090), 1,
      sym_access_modifier,
    STATE(5099), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [139301] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(23), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6451), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(7466), 1,
      sym_identifier,
    ACTIONS(7468), 1,
      anon_sym_mutable,
    STATE(4305), 1,
      aux_sym_attributes_repeat1,
    STATE(4488), 1,
      sym__attribute_set,
    STATE(5728), 1,
      sym_attributes,
    STATE(5967), 1,
      sym_record_field,
    STATE(7056), 1,
      sym_record_fields,
    STATE(7090), 1,
      sym_access_modifier,
    STATE(5100), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [139359] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(23), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7384), 1,
      anon_sym__,
    STATE(4305), 1,
      aux_sym_attributes_repeat1,
    STATE(4441), 1,
      sym__static_type_identifier,
    STATE(4488), 1,
      sym__attribute_set,
    STATE(5684), 1,
      sym_type_argument_defn,
    STATE(5702), 1,
      sym_attributes,
    STATE(5976), 1,
      sym_type_argument,
    ACTIONS(7386), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5101), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [139415] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(23), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6451), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(7466), 1,
      sym_identifier,
    ACTIONS(7468), 1,
      anon_sym_mutable,
    STATE(4305), 1,
      aux_sym_attributes_repeat1,
    STATE(4488), 1,
      sym__attribute_set,
    STATE(5728), 1,
      sym_attributes,
    STATE(5967), 1,
      sym_record_field,
    STATE(6709), 1,
      sym_record_fields,
    STATE(7090), 1,
      sym_access_modifier,
    STATE(5102), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [139473] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(23), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6451), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(7466), 1,
      sym_identifier,
    ACTIONS(7468), 1,
      anon_sym_mutable,
    ACTIONS(7698), 1,
      sym__dedent,
    STATE(4305), 1,
      aux_sym_attributes_repeat1,
    STATE(4488), 1,
      sym__attribute_set,
    STATE(5728), 1,
      sym_attributes,
    STATE(6275), 1,
      sym_record_field,
    STATE(7090), 1,
      sym_access_modifier,
    STATE(5103), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [139531] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(23), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6451), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(7466), 1,
      sym_identifier,
    ACTIONS(7468), 1,
      anon_sym_mutable,
    STATE(4305), 1,
      aux_sym_attributes_repeat1,
    STATE(4488), 1,
      sym__attribute_set,
    STATE(5728), 1,
      sym_attributes,
    STATE(5967), 1,
      sym_record_field,
    STATE(7052), 1,
      sym_record_fields,
    STATE(7090), 1,
      sym_access_modifier,
    STATE(5104), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [139589] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(23), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6451), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(7466), 1,
      sym_identifier,
    ACTIONS(7468), 1,
      anon_sym_mutable,
    STATE(4305), 1,
      aux_sym_attributes_repeat1,
    STATE(4488), 1,
      sym__attribute_set,
    STATE(5728), 1,
      sym_attributes,
    STATE(5967), 1,
      sym_record_field,
    STATE(7048), 1,
      sym_record_fields,
    STATE(7090), 1,
      sym_access_modifier,
    STATE(5105), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [139647] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(23), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6451), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(7466), 1,
      sym_identifier,
    ACTIONS(7468), 1,
      anon_sym_mutable,
    STATE(4305), 1,
      aux_sym_attributes_repeat1,
    STATE(4488), 1,
      sym__attribute_set,
    STATE(5728), 1,
      sym_attributes,
    STATE(5967), 1,
      sym_record_field,
    STATE(7044), 1,
      sym_record_fields,
    STATE(7090), 1,
      sym_access_modifier,
    STATE(5106), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [139705] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(23), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7384), 1,
      anon_sym__,
    STATE(4305), 1,
      aux_sym_attributes_repeat1,
    STATE(4441), 1,
      sym__static_type_identifier,
    STATE(4488), 1,
      sym__attribute_set,
    STATE(5600), 1,
      sym_type_argument_defn,
    STATE(5702), 1,
      sym_attributes,
    STATE(5976), 1,
      sym_type_argument,
    ACTIONS(7386), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5107), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [139761] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6875), 1,
      anon_sym_LT2,
    ACTIONS(7528), 1,
      anon_sym_as,
    ACTIONS(7530), 1,
      anon_sym_COMMA,
    ACTIONS(7532), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7534), 1,
      anon_sym_PIPE,
    ACTIONS(7536), 1,
      anon_sym_AMP,
    ACTIONS(7700), 1,
      anon_sym_EQ,
    ACTIONS(7702), 1,
      anon_sym_COLON,
    STATE(5027), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(6043), 1,
      sym_type_arguments,
    STATE(5108), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [139819] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2567), 2,
      anon_sym_with,
      sym_identifier,
    STATE(5109), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2569), 8,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [139861] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5768), 1,
      sym_identifier,
    ACTIONS(6871), 1,
      anon_sym_DASH_GT,
    ACTIONS(6873), 1,
      anon_sym_STAR,
    ACTIONS(6875), 1,
      anon_sym_LT2,
    ACTIONS(6877), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(7704), 1,
      anon_sym_EQ,
    ACTIONS(7706), 1,
      anon_sym_with,
    STATE(4859), 1,
      aux_sym_compound_type_repeat1,
    STATE(4991), 1,
      sym_long_identifier,
    STATE(5160), 1,
      sym_type_arguments,
    STATE(5110), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [139919] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(23), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6451), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(7466), 1,
      sym_identifier,
    ACTIONS(7468), 1,
      anon_sym_mutable,
    STATE(4305), 1,
      aux_sym_attributes_repeat1,
    STATE(4488), 1,
      sym__attribute_set,
    STATE(5728), 1,
      sym_attributes,
    STATE(5967), 1,
      sym_record_field,
    STATE(7040), 1,
      sym_record_fields,
    STATE(7090), 1,
      sym_access_modifier,
    STATE(5111), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [139977] = 14,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(133), 1,
      sym_line_comment,
    ACTIONS(6818), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(6820), 1,
      anon_sym_POUNDlight,
    ACTIONS(6822), 1,
      anon_sym_POUNDr,
    ACTIONS(7708), 1,
      anon_sym_DQUOTE2,
    ACTIONS(7710), 1,
      anon_sym_DQUOTEB,
    STATE(5060), 1,
      aux_sym_verbatim_string_repeat1,
    STATE(5564), 1,
      sym__verbatim_string_char,
    STATE(5568), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7400), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(7398), 3,
      sym__non_escape_char,
      anon_sym_BSLASH,
      aux_sym__verbatim_string_char_token1,
    STATE(5112), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [140027] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(23), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6451), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(7466), 1,
      sym_identifier,
    ACTIONS(7468), 1,
      anon_sym_mutable,
    STATE(4305), 1,
      aux_sym_attributes_repeat1,
    STATE(4488), 1,
      sym__attribute_set,
    STATE(5728), 1,
      sym_attributes,
    STATE(5967), 1,
      sym_record_field,
    STATE(7036), 1,
      sym_record_fields,
    STATE(7090), 1,
      sym_access_modifier,
    STATE(5113), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [140085] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(23), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7384), 1,
      anon_sym__,
    STATE(4305), 1,
      aux_sym_attributes_repeat1,
    STATE(4441), 1,
      sym__static_type_identifier,
    STATE(4488), 1,
      sym__attribute_set,
    STATE(5676), 1,
      sym_type_argument_defn,
    STATE(5702), 1,
      sym_attributes,
    STATE(5976), 1,
      sym_type_argument,
    ACTIONS(7386), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5114), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [140141] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(23), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6451), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(7466), 1,
      sym_identifier,
    ACTIONS(7468), 1,
      anon_sym_mutable,
    STATE(4305), 1,
      aux_sym_attributes_repeat1,
    STATE(4488), 1,
      sym__attribute_set,
    STATE(5728), 1,
      sym_attributes,
    STATE(5967), 1,
      sym_record_field,
    STATE(7032), 1,
      sym_record_fields,
    STATE(7090), 1,
      sym_access_modifier,
    STATE(5115), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [140199] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(23), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6451), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(7466), 1,
      sym_identifier,
    ACTIONS(7468), 1,
      anon_sym_mutable,
    STATE(4305), 1,
      aux_sym_attributes_repeat1,
    STATE(4488), 1,
      sym__attribute_set,
    STATE(5728), 1,
      sym_attributes,
    STATE(5967), 1,
      sym_record_field,
    STATE(7028), 1,
      sym_record_fields,
    STATE(7090), 1,
      sym_access_modifier,
    STATE(5116), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [140257] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7666), 1,
      sym_identifier,
    ACTIONS(7668), 1,
      anon_sym_LPAREN,
    ACTIONS(7670), 1,
      anon_sym__,
    ACTIONS(7712), 1,
      anon_sym_POUND,
    STATE(4441), 1,
      sym__static_type_identifier,
    STATE(4775), 1,
      sym_atomic_type,
    STATE(4776), 1,
      sym_type_argument,
    STATE(4777), 1,
      sym_long_identifier,
    ACTIONS(7386), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5117), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [140313] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(23), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7384), 1,
      anon_sym__,
    STATE(4305), 1,
      aux_sym_attributes_repeat1,
    STATE(4441), 1,
      sym__static_type_identifier,
    STATE(4488), 1,
      sym__attribute_set,
    STATE(5618), 1,
      sym_type_argument_defn,
    STATE(5702), 1,
      sym_attributes,
    STATE(5976), 1,
      sym_type_argument,
    ACTIONS(7386), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5118), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [140369] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(23), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6451), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(7466), 1,
      sym_identifier,
    ACTIONS(7468), 1,
      anon_sym_mutable,
    STATE(4305), 1,
      aux_sym_attributes_repeat1,
    STATE(4488), 1,
      sym__attribute_set,
    STATE(5728), 1,
      sym_attributes,
    STATE(5967), 1,
      sym_record_field,
    STATE(7024), 1,
      sym_record_fields,
    STATE(7090), 1,
      sym_access_modifier,
    STATE(5119), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [140427] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(23), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6451), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(7466), 1,
      sym_identifier,
    ACTIONS(7468), 1,
      anon_sym_mutable,
    STATE(4305), 1,
      aux_sym_attributes_repeat1,
    STATE(4488), 1,
      sym__attribute_set,
    STATE(5728), 1,
      sym_attributes,
    STATE(5967), 1,
      sym_record_field,
    STATE(7020), 1,
      sym_record_fields,
    STATE(7090), 1,
      sym_access_modifier,
    STATE(5120), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [140485] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7714), 1,
      anon_sym_LT2,
    ACTIONS(2557), 2,
      anon_sym_with,
      sym_identifier,
    STATE(5121), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2559), 7,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_LBRACK_RBRACK,
  [140529] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(23), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7384), 1,
      anon_sym__,
    STATE(4305), 1,
      aux_sym_attributes_repeat1,
    STATE(4441), 1,
      sym__static_type_identifier,
    STATE(4488), 1,
      sym__attribute_set,
    STATE(5659), 1,
      sym_type_argument_defn,
    STATE(5702), 1,
      sym_attributes,
    STATE(5976), 1,
      sym_type_argument,
    ACTIONS(7386), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5122), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [140585] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(23), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7384), 1,
      anon_sym__,
    STATE(4305), 1,
      aux_sym_attributes_repeat1,
    STATE(4441), 1,
      sym__static_type_identifier,
    STATE(4488), 1,
      sym__attribute_set,
    STATE(5702), 1,
      sym_attributes,
    STATE(5800), 1,
      sym_type_argument_defn,
    STATE(5976), 1,
      sym_type_argument,
    ACTIONS(7386), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5123), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [140641] = 14,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(133), 1,
      sym_line_comment,
    ACTIONS(6818), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(6820), 1,
      anon_sym_POUNDlight,
    ACTIONS(6822), 1,
      anon_sym_POUNDr,
    ACTIONS(7716), 1,
      anon_sym_DQUOTE2,
    ACTIONS(7718), 1,
      anon_sym_DQUOTEB,
    STATE(5112), 1,
      aux_sym_verbatim_string_repeat1,
    STATE(5564), 1,
      sym__verbatim_string_char,
    STATE(5568), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7400), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(7398), 3,
      sym__non_escape_char,
      anon_sym_BSLASH,
      aux_sym__verbatim_string_char_token1,
    STATE(5124), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [140691] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(23), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6451), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(7466), 1,
      sym_identifier,
    ACTIONS(7468), 1,
      anon_sym_mutable,
    STATE(4305), 1,
      aux_sym_attributes_repeat1,
    STATE(4488), 1,
      sym__attribute_set,
    STATE(5728), 1,
      sym_attributes,
    STATE(5967), 1,
      sym_record_field,
    STATE(7016), 1,
      sym_record_fields,
    STATE(7090), 1,
      sym_access_modifier,
    STATE(5125), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [140749] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(23), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6451), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(7466), 1,
      sym_identifier,
    ACTIONS(7468), 1,
      anon_sym_mutable,
    STATE(4305), 1,
      aux_sym_attributes_repeat1,
    STATE(4488), 1,
      sym__attribute_set,
    STATE(5728), 1,
      sym_attributes,
    STATE(5967), 1,
      sym_record_field,
    STATE(7012), 1,
      sym_record_fields,
    STATE(7090), 1,
      sym_access_modifier,
    STATE(5126), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [140807] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(23), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6451), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(7466), 1,
      sym_identifier,
    ACTIONS(7468), 1,
      anon_sym_mutable,
    STATE(4305), 1,
      aux_sym_attributes_repeat1,
    STATE(4488), 1,
      sym__attribute_set,
    STATE(5728), 1,
      sym_attributes,
    STATE(5967), 1,
      sym_record_field,
    STATE(6755), 1,
      sym_record_fields,
    STATE(7090), 1,
      sym_access_modifier,
    STATE(5127), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [140865] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2514), 2,
      anon_sym_with,
      sym_identifier,
    STATE(5128), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2516), 8,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [140907] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(23), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6451), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(7466), 1,
      sym_identifier,
    ACTIONS(7468), 1,
      anon_sym_mutable,
    STATE(4305), 1,
      aux_sym_attributes_repeat1,
    STATE(4488), 1,
      sym__attribute_set,
    STATE(5728), 1,
      sym_attributes,
    STATE(5967), 1,
      sym_record_field,
    STATE(7008), 1,
      sym_record_fields,
    STATE(7090), 1,
      sym_access_modifier,
    STATE(5129), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [140965] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(23), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6451), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(7466), 1,
      sym_identifier,
    ACTIONS(7468), 1,
      anon_sym_mutable,
    STATE(4305), 1,
      aux_sym_attributes_repeat1,
    STATE(4488), 1,
      sym__attribute_set,
    STATE(5728), 1,
      sym_attributes,
    STATE(5967), 1,
      sym_record_field,
    STATE(7004), 1,
      sym_record_fields,
    STATE(7090), 1,
      sym_access_modifier,
    STATE(5130), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [141023] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7720), 1,
      sym_identifier,
    ACTIONS(7722), 1,
      anon_sym_LPAREN,
    ACTIONS(7724), 1,
      anon_sym__,
    ACTIONS(7726), 1,
      anon_sym_POUND,
    STATE(3371), 1,
      sym__static_type_identifier,
    STATE(3560), 1,
      sym_long_identifier,
    STATE(3605), 1,
      sym_type_argument,
    STATE(3684), 1,
      sym_atomic_type,
    ACTIONS(7728), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5131), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [141079] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6337), 1,
      anon_sym_DASH_GT,
    ACTIONS(6339), 1,
      anon_sym_STAR,
    ACTIONS(6341), 1,
      anon_sym_LT2,
    ACTIONS(6343), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(7504), 1,
      sym_identifier,
    STATE(4211), 1,
      aux_sym_compound_type_repeat1,
    STATE(4248), 1,
      sym_type_arguments,
    STATE(4268), 1,
      sym_long_identifier,
    ACTIONS(7730), 2,
      sym__newline,
      sym__dedent,
    STATE(5132), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [141135] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(23), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6451), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(7466), 1,
      sym_identifier,
    ACTIONS(7468), 1,
      anon_sym_mutable,
    STATE(4305), 1,
      aux_sym_attributes_repeat1,
    STATE(4488), 1,
      sym__attribute_set,
    STATE(5728), 1,
      sym_attributes,
    STATE(5967), 1,
      sym_record_field,
    STATE(7000), 1,
      sym_record_fields,
    STATE(7090), 1,
      sym_access_modifier,
    STATE(5133), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [141193] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5409), 1,
      anon_sym_COLON,
    ACTIONS(7502), 1,
      anon_sym_and,
    STATE(5136), 1,
      aux_sym_type_argument_constraints_repeat1,
    STATE(5134), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5411), 7,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT2,
  [141239] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(23), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6451), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(7466), 1,
      sym_identifier,
    ACTIONS(7468), 1,
      anon_sym_mutable,
    STATE(4305), 1,
      aux_sym_attributes_repeat1,
    STATE(4488), 1,
      sym__attribute_set,
    STATE(5728), 1,
      sym_attributes,
    STATE(5967), 1,
      sym_record_field,
    STATE(6996), 1,
      sym_record_fields,
    STATE(7090), 1,
      sym_access_modifier,
    STATE(5135), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [141297] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5402), 1,
      anon_sym_COLON,
    ACTIONS(7732), 1,
      anon_sym_and,
    STATE(5136), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_type_argument_constraints_repeat1,
    ACTIONS(5404), 7,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT2,
  [141341] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(23), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7384), 1,
      anon_sym__,
    STATE(4305), 1,
      aux_sym_attributes_repeat1,
    STATE(4441), 1,
      sym__static_type_identifier,
    STATE(4488), 1,
      sym__attribute_set,
    STATE(5604), 1,
      sym_type_argument_defn,
    STATE(5702), 1,
      sym_attributes,
    STATE(5976), 1,
      sym_type_argument,
    ACTIONS(7386), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5137), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [141397] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(23), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6451), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(7466), 1,
      sym_identifier,
    ACTIONS(7468), 1,
      anon_sym_mutable,
    STATE(4305), 1,
      aux_sym_attributes_repeat1,
    STATE(4488), 1,
      sym__attribute_set,
    STATE(5728), 1,
      sym_attributes,
    STATE(5967), 1,
      sym_record_field,
    STATE(6990), 1,
      sym_record_fields,
    STATE(7090), 1,
      sym_access_modifier,
    STATE(5138), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [141455] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(23), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6451), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(7466), 1,
      sym_identifier,
    ACTIONS(7468), 1,
      anon_sym_mutable,
    STATE(4305), 1,
      aux_sym_attributes_repeat1,
    STATE(4488), 1,
      sym__attribute_set,
    STATE(5728), 1,
      sym_attributes,
    STATE(5967), 1,
      sym_record_field,
    STATE(6984), 1,
      sym_record_fields,
    STATE(7090), 1,
      sym_access_modifier,
    STATE(5139), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [141513] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(23), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6451), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(7466), 1,
      sym_identifier,
    ACTIONS(7468), 1,
      anon_sym_mutable,
    STATE(4305), 1,
      aux_sym_attributes_repeat1,
    STATE(4488), 1,
      sym__attribute_set,
    STATE(5728), 1,
      sym_attributes,
    STATE(5967), 1,
      sym_record_field,
    STATE(6795), 1,
      sym_record_fields,
    STATE(7090), 1,
      sym_access_modifier,
    STATE(5140), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [141571] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(23), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7384), 1,
      anon_sym__,
    STATE(4305), 1,
      aux_sym_attributes_repeat1,
    STATE(4441), 1,
      sym__static_type_identifier,
    STATE(4488), 1,
      sym__attribute_set,
    STATE(5637), 1,
      sym_type_argument_defn,
    STATE(5702), 1,
      sym_attributes,
    STATE(5976), 1,
      sym_type_argument,
    ACTIONS(7386), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5141), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [141627] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(23), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6451), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(7466), 1,
      sym_identifier,
    ACTIONS(7468), 1,
      anon_sym_mutable,
    STATE(4305), 1,
      aux_sym_attributes_repeat1,
    STATE(4488), 1,
      sym__attribute_set,
    STATE(5728), 1,
      sym_attributes,
    STATE(5967), 1,
      sym_record_field,
    STATE(6976), 1,
      sym_record_fields,
    STATE(7090), 1,
      sym_access_modifier,
    STATE(5142), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [141685] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(23), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6451), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(7466), 1,
      sym_identifier,
    ACTIONS(7468), 1,
      anon_sym_mutable,
    STATE(4305), 1,
      aux_sym_attributes_repeat1,
    STATE(4488), 1,
      sym__attribute_set,
    STATE(5728), 1,
      sym_attributes,
    STATE(5967), 1,
      sym_record_field,
    STATE(6967), 1,
      sym_record_fields,
    STATE(7090), 1,
      sym_access_modifier,
    STATE(5143), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [141743] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(23), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6451), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(7466), 1,
      sym_identifier,
    ACTIONS(7468), 1,
      anon_sym_mutable,
    STATE(4305), 1,
      aux_sym_attributes_repeat1,
    STATE(4488), 1,
      sym__attribute_set,
    STATE(5728), 1,
      sym_attributes,
    STATE(5967), 1,
      sym_record_field,
    STATE(6958), 1,
      sym_record_fields,
    STATE(7090), 1,
      sym_access_modifier,
    STATE(5144), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [141801] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(23), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6451), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(7466), 1,
      sym_identifier,
    ACTIONS(7468), 1,
      anon_sym_mutable,
    STATE(4305), 1,
      aux_sym_attributes_repeat1,
    STATE(4488), 1,
      sym__attribute_set,
    STATE(5728), 1,
      sym_attributes,
    STATE(5967), 1,
      sym_record_field,
    STATE(6949), 1,
      sym_record_fields,
    STATE(7090), 1,
      sym_access_modifier,
    STATE(5145), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [141859] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(23), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6451), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(7466), 1,
      sym_identifier,
    ACTIONS(7468), 1,
      anon_sym_mutable,
    STATE(4305), 1,
      aux_sym_attributes_repeat1,
    STATE(4488), 1,
      sym__attribute_set,
    STATE(5728), 1,
      sym_attributes,
    STATE(5967), 1,
      sym_record_field,
    STATE(7089), 1,
      sym_record_fields,
    STATE(7090), 1,
      sym_access_modifier,
    STATE(5146), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [141917] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7666), 1,
      sym_identifier,
    ACTIONS(7668), 1,
      anon_sym_LPAREN,
    ACTIONS(7670), 1,
      anon_sym__,
    ACTIONS(7735), 1,
      anon_sym_POUND,
    STATE(4441), 1,
      sym__static_type_identifier,
    STATE(4775), 1,
      sym_atomic_type,
    STATE(4776), 1,
      sym_type_argument,
    STATE(4777), 1,
      sym_long_identifier,
    ACTIONS(7386), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5147), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [141973] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(23), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7384), 1,
      anon_sym__,
    STATE(4305), 1,
      aux_sym_attributes_repeat1,
    STATE(4441), 1,
      sym__static_type_identifier,
    STATE(4488), 1,
      sym__attribute_set,
    STATE(5700), 1,
      sym_type_argument_defn,
    STATE(5702), 1,
      sym_attributes,
    STATE(5976), 1,
      sym_type_argument,
    ACTIONS(7386), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5148), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [142029] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7737), 1,
      sym_identifier,
    ACTIONS(7739), 1,
      anon_sym_LPAREN,
    ACTIONS(7741), 1,
      anon_sym__,
    ACTIONS(7743), 1,
      anon_sym_POUND,
    STATE(3279), 1,
      sym__static_type_identifier,
    STATE(3435), 1,
      sym_long_identifier,
    STATE(3440), 1,
      sym_type_argument,
    STATE(3455), 1,
      sym_atomic_type,
    ACTIONS(7745), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5149), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [142085] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2466), 2,
      anon_sym_with,
      sym_identifier,
    STATE(5150), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2468), 8,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [142127] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(23), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6451), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(7466), 1,
      sym_identifier,
    ACTIONS(7468), 1,
      anon_sym_mutable,
    STATE(4305), 1,
      aux_sym_attributes_repeat1,
    STATE(4488), 1,
      sym__attribute_set,
    STATE(5728), 1,
      sym_attributes,
    STATE(5967), 1,
      sym_record_field,
    STATE(6938), 1,
      sym_record_fields,
    STATE(7090), 1,
      sym_access_modifier,
    STATE(5151), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [142185] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7555), 1,
      anon_sym_COLON,
    ACTIONS(7557), 1,
      anon_sym_as,
    ACTIONS(7559), 1,
      anon_sym_COMMA,
    ACTIONS(7561), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7563), 1,
      anon_sym_PIPE,
    ACTIONS(7565), 1,
      anon_sym_AMP,
    ACTIONS(7567), 1,
      sym__newline,
    ACTIONS(7747), 1,
      sym__dedent,
    STATE(5315), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(5736), 1,
      aux_sym__list_pattern_content_repeat1,
    STATE(5152), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [142243] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5531), 1,
      anon_sym_COLON,
    ACTIONS(7749), 1,
      anon_sym_COMMA,
    STATE(5080), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(5153), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5533), 7,
      sym__newline,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
  [142289] = 16,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5491), 1,
      anon_sym_COLON,
    ACTIONS(7749), 1,
      anon_sym_COMMA,
    ACTIONS(7751), 1,
      anon_sym_as,
    ACTIONS(7753), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7755), 1,
      anon_sym_PIPE,
    ACTIONS(7757), 1,
      anon_sym_AMP,
    STATE(5153), 1,
      aux_sym_repeat_pattern_repeat1,
    ACTIONS(5493), 3,
      sym__newline,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
    STATE(5154), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [142343] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(23), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7384), 1,
      anon_sym__,
    STATE(4305), 1,
      aux_sym_attributes_repeat1,
    STATE(4441), 1,
      sym__static_type_identifier,
    STATE(4488), 1,
      sym__attribute_set,
    STATE(5579), 1,
      sym_type_argument_defn,
    STATE(5702), 1,
      sym_attributes,
    STATE(5976), 1,
      sym_type_argument,
    ACTIONS(7386), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5155), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [142399] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5572), 1,
      anon_sym_COLON,
    ACTIONS(7759), 1,
      anon_sym_LT2,
    STATE(5156), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5574), 8,
      sym__newline,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
  [142443] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7761), 1,
      sym_identifier,
    ACTIONS(7763), 1,
      anon_sym_LPAREN,
    ACTIONS(7765), 1,
      anon_sym__,
    ACTIONS(7767), 1,
      anon_sym_POUND,
    STATE(3328), 1,
      sym__static_type_identifier,
    STATE(3448), 1,
      sym_long_identifier,
    STATE(3680), 1,
      sym_atomic_type,
    STATE(3689), 1,
      sym_type_argument,
    ACTIONS(7769), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5157), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [142499] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(23), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6451), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(7466), 1,
      sym_identifier,
    ACTIONS(7468), 1,
      anon_sym_mutable,
    STATE(4305), 1,
      aux_sym_attributes_repeat1,
    STATE(4488), 1,
      sym__attribute_set,
    STATE(5728), 1,
      sym_attributes,
    STATE(5967), 1,
      sym_record_field,
    STATE(6835), 1,
      sym_record_fields,
    STATE(7090), 1,
      sym_access_modifier,
    STATE(5158), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [142557] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5431), 1,
      anon_sym_COLON,
    STATE(5153), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(5159), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5433), 8,
      sym__newline,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
  [142601] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2474), 2,
      anon_sym_with,
      sym_identifier,
    STATE(5160), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2476), 8,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [142643] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2510), 2,
      anon_sym_with,
      sym_identifier,
    STATE(5161), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2512), 8,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [142685] = 14,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(133), 1,
      sym_line_comment,
    ACTIONS(6818), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(6820), 1,
      anon_sym_POUNDlight,
    ACTIONS(6822), 1,
      anon_sym_POUNDr,
    ACTIONS(7771), 1,
      anon_sym_DQUOTE2,
    ACTIONS(7773), 1,
      anon_sym_DQUOTEB,
    STATE(5166), 1,
      aux_sym_verbatim_string_repeat1,
    STATE(5564), 1,
      sym__verbatim_string_char,
    STATE(5568), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7400), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(7398), 3,
      sym__non_escape_char,
      anon_sym_BSLASH,
      aux_sym__verbatim_string_char_token1,
    STATE(5162), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [142735] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5474), 1,
      anon_sym_COLON,
    STATE(5153), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(5163), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5476), 8,
      sym__newline,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
  [142779] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7775), 1,
      sym_identifier,
    ACTIONS(7777), 1,
      anon_sym_LPAREN,
    ACTIONS(7779), 1,
      anon_sym__,
    ACTIONS(7781), 1,
      anon_sym_POUND,
    STATE(4883), 1,
      sym__static_type_identifier,
    STATE(5156), 1,
      sym_long_identifier,
    STATE(5207), 1,
      sym_atomic_type,
    STATE(5208), 1,
      sym_type_argument,
    ACTIONS(7783), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5164), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [142835] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(23), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6451), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(7466), 1,
      sym_identifier,
    ACTIONS(7468), 1,
      anon_sym_mutable,
    STATE(4305), 1,
      aux_sym_attributes_repeat1,
    STATE(4488), 1,
      sym__attribute_set,
    STATE(5728), 1,
      sym_attributes,
    STATE(5967), 1,
      sym_record_field,
    STATE(6911), 1,
      sym_record_fields,
    STATE(7090), 1,
      sym_access_modifier,
    STATE(5165), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [142893] = 14,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(133), 1,
      sym_line_comment,
    ACTIONS(6818), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(6820), 1,
      anon_sym_POUNDlight,
    ACTIONS(6822), 1,
      anon_sym_POUNDr,
    ACTIONS(7785), 1,
      anon_sym_DQUOTE2,
    ACTIONS(7787), 1,
      anon_sym_DQUOTEB,
    STATE(5060), 1,
      aux_sym_verbatim_string_repeat1,
    STATE(5564), 1,
      sym__verbatim_string_char,
    STATE(5568), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7400), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(7398), 3,
      sym__non_escape_char,
      anon_sym_BSLASH,
      aux_sym__verbatim_string_char_token1,
    STATE(5166), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [142943] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(23), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6451), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(7466), 1,
      sym_identifier,
    ACTIONS(7468), 1,
      anon_sym_mutable,
    STATE(4305), 1,
      aux_sym_attributes_repeat1,
    STATE(4488), 1,
      sym__attribute_set,
    STATE(5728), 1,
      sym_attributes,
    STATE(5967), 1,
      sym_record_field,
    STATE(6875), 1,
      sym_record_fields,
    STATE(7090), 1,
      sym_access_modifier,
    STATE(5167), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [143001] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6875), 1,
      anon_sym_LT2,
    ACTIONS(7528), 1,
      anon_sym_as,
    ACTIONS(7530), 1,
      anon_sym_COMMA,
    ACTIONS(7532), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7534), 1,
      anon_sym_PIPE,
    ACTIONS(7536), 1,
      anon_sym_AMP,
    ACTIONS(7789), 1,
      anon_sym_EQ,
    ACTIONS(7791), 1,
      anon_sym_COLON,
    STATE(5027), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(6112), 1,
      sym_type_arguments,
    STATE(5168), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [143059] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(23), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6451), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(7466), 1,
      sym_identifier,
    ACTIONS(7468), 1,
      anon_sym_mutable,
    STATE(4305), 1,
      aux_sym_attributes_repeat1,
    STATE(4488), 1,
      sym__attribute_set,
    STATE(5728), 1,
      sym_attributes,
    STATE(5967), 1,
      sym_record_field,
    STATE(6927), 1,
      sym_record_fields,
    STATE(7090), 1,
      sym_access_modifier,
    STATE(5169), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [143117] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6337), 1,
      anon_sym_DASH_GT,
    ACTIONS(6339), 1,
      anon_sym_STAR,
    ACTIONS(6341), 1,
      anon_sym_LT2,
    ACTIONS(6343), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(7504), 1,
      sym_identifier,
    STATE(4211), 1,
      aux_sym_compound_type_repeat1,
    STATE(4248), 1,
      sym_type_arguments,
    STATE(4268), 1,
      sym_long_identifier,
    ACTIONS(7793), 2,
      sym__newline,
      sym__dedent,
    STATE(5170), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [143173] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(23), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7384), 1,
      anon_sym__,
    STATE(4305), 1,
      aux_sym_attributes_repeat1,
    STATE(4441), 1,
      sym__static_type_identifier,
    STATE(4488), 1,
      sym__attribute_set,
    STATE(5641), 1,
      sym_type_argument_defn,
    STATE(5702), 1,
      sym_attributes,
    STATE(5976), 1,
      sym_type_argument,
    ACTIONS(7386), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5171), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [143229] = 18,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(23), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6451), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(7466), 1,
      sym_identifier,
    ACTIONS(7468), 1,
      anon_sym_mutable,
    ACTIONS(7795), 1,
      sym__dedent,
    STATE(4305), 1,
      aux_sym_attributes_repeat1,
    STATE(4488), 1,
      sym__attribute_set,
    STATE(5728), 1,
      sym_attributes,
    STATE(6275), 1,
      sym_record_field,
    STATE(7090), 1,
      sym_access_modifier,
    STATE(5172), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [143287] = 14,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(133), 1,
      sym_line_comment,
    ACTIONS(6818), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(6820), 1,
      anon_sym_POUNDlight,
    ACTIONS(6822), 1,
      anon_sym_POUNDr,
    ACTIONS(7797), 1,
      anon_sym_DQUOTE2,
    ACTIONS(7799), 1,
      anon_sym_DQUOTEB,
    STATE(5096), 1,
      aux_sym_verbatim_string_repeat1,
    STATE(5564), 1,
      sym__verbatim_string_char,
    STATE(5568), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7400), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(7398), 3,
      sym__non_escape_char,
      anon_sym_BSLASH,
      aux_sym__verbatim_string_char_token1,
    STATE(5173), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [143337] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6871), 1,
      anon_sym_DASH_GT,
    ACTIONS(6873), 1,
      anon_sym_STAR,
    ACTIONS(6875), 1,
      anon_sym_LT2,
    ACTIONS(6877), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(7353), 1,
      sym_identifier,
    ACTIONS(7801), 1,
      anon_sym_RPAREN,
    STATE(4859), 1,
      aux_sym_compound_type_repeat1,
    STATE(4991), 1,
      sym_long_identifier,
    STATE(5160), 1,
      sym_type_arguments,
    STATE(5174), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [143392] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6871), 1,
      anon_sym_DASH_GT,
    ACTIONS(6873), 1,
      anon_sym_STAR,
    ACTIONS(6875), 1,
      anon_sym_LT2,
    ACTIONS(6877), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(7353), 1,
      sym_identifier,
    ACTIONS(7803), 1,
      anon_sym_RPAREN,
    STATE(4859), 1,
      aux_sym_compound_type_repeat1,
    STATE(4991), 1,
      sym_long_identifier,
    STATE(5160), 1,
      sym_type_arguments,
    STATE(5175), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [143447] = 16,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7749), 1,
      anon_sym_COMMA,
    ACTIONS(7751), 1,
      anon_sym_as,
    ACTIONS(7753), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7755), 1,
      anon_sym_PIPE,
    ACTIONS(7757), 1,
      anon_sym_AMP,
    ACTIONS(7805), 1,
      anon_sym_COLON,
    STATE(5153), 1,
      aux_sym_repeat_pattern_repeat1,
    ACTIONS(7807), 2,
      sym__newline,
      anon_sym_RBRACE,
    STATE(5176), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [143500] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7528), 1,
      anon_sym_as,
    ACTIONS(7809), 1,
      anon_sym_COLON,
    ACTIONS(7811), 1,
      anon_sym_COMMA,
    ACTIONS(7813), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7815), 1,
      anon_sym_PIPE,
    ACTIONS(7817), 1,
      anon_sym_AMP,
    ACTIONS(7819), 1,
      anon_sym_DASH_GT,
    ACTIONS(7821), 1,
      anon_sym_when,
    STATE(5236), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(5177), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [143555] = 9,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(133), 1,
      sym_line_comment,
    ACTIONS(6818), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(6820), 1,
      anon_sym_POUNDlight,
    ACTIONS(6822), 1,
      anon_sym_POUNDr,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7823), 4,
      sym__inside_string_marker,
      sym__escape_char,
      sym__non_escape_char,
      anon_sym_LBRACE2,
    STATE(5178), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7825), 5,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
      aux_sym__simple_string_char_token1,
      anon_sym_DQUOTE,
  [143594] = 17,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(3570), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(7263), 1,
      sym_identifier,
    ACTIONS(7269), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(7271), 1,
      sym_op_identifier,
    STATE(2288), 1,
      sym_property_or_ident,
    STATE(3772), 1,
      sym__identifier_or_op,
    STATE(3773), 1,
      sym_active_pattern,
    STATE(4910), 1,
      sym_method_or_prop_defn,
    STATE(5554), 1,
      sym_access_modifier,
    STATE(5179), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [143649] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2340), 1,
      anon_sym_COLON,
    STATE(5180), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2342), 8,
      sym__newline,
      sym__dedent,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_or,
  [143690] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6871), 1,
      anon_sym_DASH_GT,
    ACTIONS(6873), 1,
      anon_sym_STAR,
    ACTIONS(6875), 1,
      anon_sym_LT2,
    ACTIONS(6877), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(7353), 1,
      sym_identifier,
    ACTIONS(7827), 1,
      anon_sym_COMMA,
    STATE(4859), 1,
      aux_sym_compound_type_repeat1,
    STATE(4991), 1,
      sym_long_identifier,
    STATE(5160), 1,
      sym_type_arguments,
    STATE(5181), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [143745] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2462), 3,
      anon_sym_and,
      anon_sym_or,
      sym_identifier,
    STATE(5182), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2464), 6,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [143786] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5431), 1,
      anon_sym_COLON,
    STATE(5236), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(5183), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5433), 7,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_when,
  [143829] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7749), 1,
      anon_sym_COMMA,
    ACTIONS(7751), 1,
      anon_sym_as,
    ACTIONS(7753), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7755), 1,
      anon_sym_PIPE,
    ACTIONS(7757), 1,
      anon_sym_AMP,
    ACTIONS(7805), 1,
      anon_sym_COLON,
    ACTIONS(7829), 1,
      anon_sym_RPAREN,
    ACTIONS(7831), 1,
      sym__newline,
    STATE(5153), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(5184), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [143884] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6871), 1,
      anon_sym_DASH_GT,
    ACTIONS(6873), 1,
      anon_sym_STAR,
    ACTIONS(6875), 1,
      anon_sym_LT2,
    ACTIONS(6877), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(7353), 1,
      sym_identifier,
    ACTIONS(7833), 1,
      anon_sym_RPAREN,
    STATE(4859), 1,
      aux_sym_compound_type_repeat1,
    STATE(4991), 1,
      sym_long_identifier,
    STATE(5160), 1,
      sym_type_arguments,
    STATE(5185), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [143939] = 16,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7835), 1,
      ts_builtin_sym_end,
    ACTIONS(7837), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(7840), 1,
      anon_sym_val,
    STATE(4305), 1,
      aux_sym_attributes_repeat1,
    STATE(4488), 1,
      sym__attribute_set,
    STATE(5762), 1,
      sym__module_signature_elements,
    STATE(5763), 1,
      sym_value_definition,
    STATE(7536), 1,
      sym_attributes,
    STATE(5186), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_file_repeat1,
  [143992] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5665), 1,
      anon_sym_COLON,
    STATE(5187), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5667), 8,
      sym__newline,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
  [144033] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6871), 1,
      anon_sym_DASH_GT,
    ACTIONS(6873), 1,
      anon_sym_STAR,
    ACTIONS(6875), 1,
      anon_sym_LT2,
    ACTIONS(6877), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(7353), 1,
      sym_identifier,
    ACTIONS(7843), 1,
      anon_sym_RPAREN,
    STATE(4859), 1,
      aux_sym_compound_type_repeat1,
    STATE(4991), 1,
      sym_long_identifier,
    STATE(5160), 1,
      sym_type_arguments,
    STATE(5188), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [144088] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7845), 1,
      anon_sym_LPAREN,
    ACTIONS(7849), 1,
      anon_sym_not,
    ACTIONS(7851), 1,
      anon_sym_enum,
    ACTIONS(7853), 1,
      anon_sym_delegate,
    STATE(5189), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7847), 5,
      anon_sym_null,
      anon_sym_struct,
      anon_sym_unmanaged,
      anon_sym_equality,
      anon_sym_comparison,
  [144135] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2462), 1,
      anon_sym_COLON,
    STATE(5190), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2464), 8,
      sym__newline,
      sym__dedent,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_or,
  [144176] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7749), 1,
      anon_sym_COMMA,
    ACTIONS(7751), 1,
      anon_sym_as,
    ACTIONS(7753), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7755), 1,
      anon_sym_PIPE,
    ACTIONS(7757), 1,
      anon_sym_AMP,
    ACTIONS(7805), 1,
      anon_sym_COLON,
    ACTIONS(7831), 1,
      sym__newline,
    ACTIONS(7855), 1,
      anon_sym_RPAREN,
    STATE(5153), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(5191), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [144231] = 16,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7835), 1,
      sym__dedent,
    ACTIONS(7837), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(7857), 1,
      anon_sym_val,
    STATE(4305), 1,
      aux_sym_attributes_repeat1,
    STATE(4488), 1,
      sym__attribute_set,
    STATE(5896), 1,
      sym_value_definition,
    STATE(5898), 1,
      sym__module_signature_elements,
    STATE(7371), 1,
      sym_attributes,
    STATE(5192), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_file_repeat1,
  [144284] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6871), 1,
      anon_sym_DASH_GT,
    ACTIONS(6873), 1,
      anon_sym_STAR,
    ACTIONS(6875), 1,
      anon_sym_LT2,
    ACTIONS(6877), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(7353), 1,
      sym_identifier,
    ACTIONS(7860), 1,
      anon_sym_EQ,
    STATE(4859), 1,
      aux_sym_compound_type_repeat1,
    STATE(4991), 1,
      sym_long_identifier,
    STATE(5160), 1,
      sym_type_arguments,
    STATE(5193), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [144339] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6871), 1,
      anon_sym_DASH_GT,
    ACTIONS(6873), 1,
      anon_sym_STAR,
    ACTIONS(6875), 1,
      anon_sym_LT2,
    ACTIONS(6877), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(7353), 1,
      sym_identifier,
    ACTIONS(7862), 1,
      anon_sym_GT,
    STATE(4859), 1,
      aux_sym_compound_type_repeat1,
    STATE(4991), 1,
      sym_long_identifier,
    STATE(5160), 1,
      sym_type_arguments,
    STATE(5194), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [144394] = 9,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(133), 1,
      sym_line_comment,
    ACTIONS(6818), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(6820), 1,
      anon_sym_POUNDlight,
    ACTIONS(6822), 1,
      anon_sym_POUNDr,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7864), 4,
      sym__inside_string_marker,
      sym__escape_char,
      sym__non_escape_char,
      anon_sym_LBRACE2,
    STATE(5195), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7866), 5,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
      aux_sym__simple_string_char_token1,
      anon_sym_DQUOTE,
  [144433] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7528), 1,
      anon_sym_as,
    ACTIONS(7809), 1,
      anon_sym_COLON,
    ACTIONS(7811), 1,
      anon_sym_COMMA,
    ACTIONS(7813), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7815), 1,
      anon_sym_PIPE,
    ACTIONS(7817), 1,
      anon_sym_AMP,
    ACTIONS(7868), 1,
      anon_sym_DASH_GT,
    ACTIONS(7870), 1,
      anon_sym_when,
    STATE(5236), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(5196), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [144488] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6871), 1,
      anon_sym_DASH_GT,
    ACTIONS(6873), 1,
      anon_sym_STAR,
    ACTIONS(6875), 1,
      anon_sym_LT2,
    ACTIONS(6877), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(7353), 1,
      sym_identifier,
    ACTIONS(7872), 1,
      anon_sym_EQ,
    STATE(4859), 1,
      aux_sym_compound_type_repeat1,
    STATE(4991), 1,
      sym_long_identifier,
    STATE(5160), 1,
      sym_type_arguments,
    STATE(5197), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [144543] = 9,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(133), 1,
      sym_line_comment,
    ACTIONS(6818), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(6820), 1,
      anon_sym_POUNDlight,
    ACTIONS(6822), 1,
      anon_sym_POUNDr,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7874), 4,
      sym__inside_string_marker,
      sym__escape_char,
      sym__non_escape_char,
      anon_sym_LBRACE2,
    STATE(5198), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7876), 5,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
      aux_sym__simple_string_char_token1,
      anon_sym_DQUOTE,
  [144582] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2340), 3,
      anon_sym_and,
      anon_sym_or,
      sym_identifier,
    STATE(5199), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2342), 6,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [144623] = 9,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(133), 1,
      sym_line_comment,
    ACTIONS(6818), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(6820), 1,
      anon_sym_POUNDlight,
    ACTIONS(6822), 1,
      anon_sym_POUNDr,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7880), 4,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
      anon_sym_DQUOTE,
    STATE(5200), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7878), 5,
      sym__inside_string_marker,
      sym__escape_char,
      sym__non_escape_char,
      aux_sym__simple_string_char_token1,
      anon_sym_DQUOTEB,
  [144662] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6871), 1,
      anon_sym_DASH_GT,
    ACTIONS(6873), 1,
      anon_sym_STAR,
    ACTIONS(6875), 1,
      anon_sym_LT2,
    ACTIONS(6877), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(7353), 1,
      sym_identifier,
    ACTIONS(7882), 1,
      anon_sym_GT,
    STATE(4859), 1,
      aux_sym_compound_type_repeat1,
    STATE(4991), 1,
      sym_long_identifier,
    STATE(5160), 1,
      sym_type_arguments,
    STATE(5201), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [144717] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6871), 1,
      anon_sym_DASH_GT,
    ACTIONS(6873), 1,
      anon_sym_STAR,
    ACTIONS(6875), 1,
      anon_sym_LT2,
    ACTIONS(6877), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(7353), 1,
      sym_identifier,
    ACTIONS(7884), 1,
      anon_sym_GT,
    STATE(4859), 1,
      aux_sym_compound_type_repeat1,
    STATE(4991), 1,
      sym_long_identifier,
    STATE(5160), 1,
      sym_type_arguments,
    STATE(5202), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [144772] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3095), 1,
      anon_sym_COLON,
    STATE(5203), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3097), 8,
      sym__newline,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
  [144813] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6871), 1,
      anon_sym_DASH_GT,
    ACTIONS(6873), 1,
      anon_sym_STAR,
    ACTIONS(6875), 1,
      anon_sym_LT2,
    ACTIONS(6877), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(7353), 1,
      sym_identifier,
    ACTIONS(7886), 1,
      anon_sym_RPAREN,
    STATE(4859), 1,
      aux_sym_compound_type_repeat1,
    STATE(4991), 1,
      sym_long_identifier,
    STATE(5160), 1,
      sym_type_arguments,
    STATE(5204), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [144868] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6871), 1,
      anon_sym_DASH_GT,
    ACTIONS(6873), 1,
      anon_sym_STAR,
    ACTIONS(6875), 1,
      anon_sym_LT2,
    ACTIONS(6877), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(7353), 1,
      sym_identifier,
    ACTIONS(7888), 1,
      anon_sym_RPAREN,
    STATE(4859), 1,
      aux_sym_compound_type_repeat1,
    STATE(4991), 1,
      sym_long_identifier,
    STATE(5160), 1,
      sym_type_arguments,
    STATE(5205), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [144923] = 13,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(133), 1,
      sym_line_comment,
    ACTIONS(6818), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(6820), 1,
      anon_sym_POUNDlight,
    ACTIONS(6822), 1,
      anon_sym_POUNDr,
    ACTIONS(7894), 1,
      anon_sym_DQUOTE2,
    STATE(5372), 1,
      aux_sym_verbatim_string_repeat1,
    STATE(5574), 1,
      sym__verbatim_string_char,
    STATE(5575), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7892), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(7890), 3,
      sym__non_escape_char,
      anon_sym_BSLASH,
      aux_sym__verbatim_string_char_token1,
    STATE(5206), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [144970] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5646), 1,
      anon_sym_COLON,
    ACTIONS(7896), 1,
      anon_sym_as,
    STATE(5207), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5648), 7,
      sym__newline,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
  [145013] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5572), 1,
      anon_sym_COLON,
    STATE(5208), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5574), 8,
      sym__newline,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
  [145054] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6871), 1,
      anon_sym_DASH_GT,
    ACTIONS(6873), 1,
      anon_sym_STAR,
    ACTIONS(6875), 1,
      anon_sym_LT2,
    ACTIONS(6877), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(7353), 1,
      sym_identifier,
    ACTIONS(7898), 1,
      anon_sym_GT,
    STATE(4859), 1,
      aux_sym_compound_type_repeat1,
    STATE(4991), 1,
      sym_long_identifier,
    STATE(5160), 1,
      sym_type_arguments,
    STATE(5209), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [145109] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6871), 1,
      anon_sym_DASH_GT,
    ACTIONS(6873), 1,
      anon_sym_STAR,
    ACTIONS(6875), 1,
      anon_sym_LT2,
    ACTIONS(6877), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(7353), 1,
      sym_identifier,
    ACTIONS(7900), 1,
      anon_sym_RPAREN,
    STATE(4859), 1,
      aux_sym_compound_type_repeat1,
    STATE(4991), 1,
      sym_long_identifier,
    STATE(5160), 1,
      sym_type_arguments,
    STATE(5210), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [145164] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6871), 1,
      anon_sym_DASH_GT,
    ACTIONS(6873), 1,
      anon_sym_STAR,
    ACTIONS(6875), 1,
      anon_sym_LT2,
    ACTIONS(6877), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(7353), 1,
      sym_identifier,
    ACTIONS(7902), 1,
      anon_sym_EQ,
    STATE(4859), 1,
      aux_sym_compound_type_repeat1,
    STATE(4991), 1,
      sym_long_identifier,
    STATE(5160), 1,
      sym_type_arguments,
    STATE(5211), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [145219] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7528), 1,
      anon_sym_as,
    ACTIONS(7809), 1,
      anon_sym_COLON,
    ACTIONS(7811), 1,
      anon_sym_COMMA,
    ACTIONS(7813), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7815), 1,
      anon_sym_PIPE,
    ACTIONS(7817), 1,
      anon_sym_AMP,
    ACTIONS(7904), 1,
      anon_sym_DASH_GT,
    ACTIONS(7906), 1,
      anon_sym_when,
    STATE(5236), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(5212), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [145274] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5474), 1,
      anon_sym_COLON,
    STATE(5236), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(5213), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5476), 7,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_when,
  [145317] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6871), 1,
      anon_sym_DASH_GT,
    ACTIONS(6873), 1,
      anon_sym_STAR,
    ACTIONS(6875), 1,
      anon_sym_LT2,
    ACTIONS(6877), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(7353), 1,
      sym_identifier,
    ACTIONS(7908), 1,
      anon_sym_RPAREN,
    STATE(4859), 1,
      aux_sym_compound_type_repeat1,
    STATE(4991), 1,
      sym_long_identifier,
    STATE(5160), 1,
      sym_type_arguments,
    STATE(5214), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [145372] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5609), 1,
      anon_sym_COLON,
    STATE(5215), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5611), 8,
      sym__newline,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
  [145413] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5605), 1,
      anon_sym_COLON,
    STATE(5216), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5607), 8,
      sym__newline,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
  [145454] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6871), 1,
      anon_sym_DASH_GT,
    ACTIONS(6873), 1,
      anon_sym_STAR,
    ACTIONS(6875), 1,
      anon_sym_LT2,
    ACTIONS(6877), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(7353), 1,
      sym_identifier,
    ACTIONS(7910), 1,
      anon_sym_RPAREN,
    STATE(4859), 1,
      aux_sym_compound_type_repeat1,
    STATE(4991), 1,
      sym_long_identifier,
    STATE(5160), 1,
      sym_type_arguments,
    STATE(5217), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [145509] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6871), 1,
      anon_sym_DASH_GT,
    ACTIONS(6873), 1,
      anon_sym_STAR,
    ACTIONS(6875), 1,
      anon_sym_LT2,
    ACTIONS(6877), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(7353), 1,
      sym_identifier,
    ACTIONS(7912), 1,
      anon_sym_GT,
    STATE(4859), 1,
      aux_sym_compound_type_repeat1,
    STATE(4991), 1,
      sym_long_identifier,
    STATE(5160), 1,
      sym_type_arguments,
    STATE(5218), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [145564] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6871), 1,
      anon_sym_DASH_GT,
    ACTIONS(6873), 1,
      anon_sym_STAR,
    ACTIONS(6875), 1,
      anon_sym_LT2,
    ACTIONS(6877), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(7353), 1,
      sym_identifier,
    ACTIONS(7914), 1,
      anon_sym_GT,
    STATE(4859), 1,
      aux_sym_compound_type_repeat1,
    STATE(4991), 1,
      sym_long_identifier,
    STATE(5160), 1,
      sym_type_arguments,
    STATE(5219), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [145619] = 16,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5491), 1,
      anon_sym_COLON,
    ACTIONS(7528), 1,
      anon_sym_as,
    ACTIONS(7811), 1,
      anon_sym_COMMA,
    ACTIONS(7813), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7815), 1,
      anon_sym_PIPE,
    ACTIONS(7817), 1,
      anon_sym_AMP,
    STATE(5236), 1,
      aux_sym_repeat_pattern_repeat1,
    ACTIONS(5493), 2,
      anon_sym_DASH_GT,
      anon_sym_when,
    STATE(5220), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [145672] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5503), 1,
      anon_sym_COLON,
    ACTIONS(7916), 1,
      anon_sym_COMMA,
    STATE(5221), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_repeat_pattern_repeat1,
    ACTIONS(5505), 6,
      anon_sym_as,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_when,
  [145715] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6871), 1,
      anon_sym_DASH_GT,
    ACTIONS(6873), 1,
      anon_sym_STAR,
    ACTIONS(6875), 1,
      anon_sym_LT2,
    ACTIONS(6877), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(7353), 1,
      sym_identifier,
    ACTIONS(7919), 1,
      anon_sym_RPAREN,
    STATE(4859), 1,
      aux_sym_compound_type_repeat1,
    STATE(4991), 1,
      sym_long_identifier,
    STATE(5160), 1,
      sym_type_arguments,
    STATE(5222), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [145770] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2474), 2,
      anon_sym_val,
      sym_identifier,
    STATE(5223), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2476), 7,
      ts_builtin_sym_end,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [145811] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7921), 1,
      anon_sym_LPAREN,
    ACTIONS(7925), 1,
      anon_sym_not,
    ACTIONS(7927), 1,
      anon_sym_enum,
    ACTIONS(7929), 1,
      anon_sym_delegate,
    STATE(5224), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7923), 5,
      anon_sym_null,
      anon_sym_struct,
      anon_sym_unmanaged,
      anon_sym_equality,
      anon_sym_comparison,
  [145858] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2510), 2,
      anon_sym_val,
      sym_identifier,
    STATE(5225), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2512), 7,
      ts_builtin_sym_end,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [145899] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6871), 1,
      anon_sym_DASH_GT,
    ACTIONS(6873), 1,
      anon_sym_STAR,
    ACTIONS(6875), 1,
      anon_sym_LT2,
    ACTIONS(6877), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(7353), 1,
      sym_identifier,
    ACTIONS(7931), 1,
      anon_sym_GT,
    STATE(4859), 1,
      aux_sym_compound_type_repeat1,
    STATE(4991), 1,
      sym_long_identifier,
    STATE(5160), 1,
      sym_type_arguments,
    STATE(5226), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [145954] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6871), 1,
      anon_sym_DASH_GT,
    ACTIONS(6873), 1,
      anon_sym_STAR,
    ACTIONS(6875), 1,
      anon_sym_LT2,
    ACTIONS(6877), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(7353), 1,
      sym_identifier,
    ACTIONS(7933), 1,
      anon_sym_COMMA,
    STATE(4859), 1,
      aux_sym_compound_type_repeat1,
    STATE(4991), 1,
      sym_long_identifier,
    STATE(5160), 1,
      sym_type_arguments,
    STATE(5227), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [146009] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6871), 1,
      anon_sym_DASH_GT,
    ACTIONS(6873), 1,
      anon_sym_STAR,
    ACTIONS(6875), 1,
      anon_sym_LT2,
    ACTIONS(6877), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(7353), 1,
      sym_identifier,
    ACTIONS(7935), 1,
      anon_sym_RPAREN,
    STATE(4859), 1,
      aux_sym_compound_type_repeat1,
    STATE(4991), 1,
      sym_long_identifier,
    STATE(5160), 1,
      sym_type_arguments,
    STATE(5228), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [146064] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2514), 2,
      anon_sym_val,
      sym_identifier,
    STATE(5229), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2516), 7,
      ts_builtin_sym_end,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [146105] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5402), 1,
      anon_sym_COLON,
    ACTIONS(7937), 1,
      anon_sym_and,
    STATE(5230), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_type_argument_constraints_repeat1,
    ACTIONS(5404), 6,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_in,
  [146148] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7940), 1,
      anon_sym_LT2,
    ACTIONS(2557), 2,
      anon_sym_val,
      sym_identifier,
    STATE(5231), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2559), 6,
      ts_builtin_sym_end,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LBRACK_RBRACK,
  [146191] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5409), 1,
      anon_sym_COLON,
    ACTIONS(7942), 1,
      anon_sym_and,
    STATE(5230), 1,
      aux_sym_type_argument_constraints_repeat1,
    STATE(5232), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5411), 6,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_in,
  [146236] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6871), 1,
      anon_sym_DASH_GT,
    ACTIONS(6873), 1,
      anon_sym_STAR,
    ACTIONS(6875), 1,
      anon_sym_LT2,
    ACTIONS(6877), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(7353), 1,
      sym_identifier,
    ACTIONS(7944), 1,
      anon_sym_RPAREN,
    STATE(4859), 1,
      aux_sym_compound_type_repeat1,
    STATE(4991), 1,
      sym_long_identifier,
    STATE(5160), 1,
      sym_type_arguments,
    STATE(5233), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [146291] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6871), 1,
      anon_sym_DASH_GT,
    ACTIONS(6873), 1,
      anon_sym_STAR,
    ACTIONS(6875), 1,
      anon_sym_LT2,
    ACTIONS(6877), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(7353), 1,
      sym_identifier,
    ACTIONS(7946), 1,
      anon_sym_COMMA,
    STATE(4859), 1,
      aux_sym_compound_type_repeat1,
    STATE(4991), 1,
      sym_long_identifier,
    STATE(5160), 1,
      sym_type_arguments,
    STATE(5234), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [146346] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6871), 1,
      anon_sym_DASH_GT,
    ACTIONS(6873), 1,
      anon_sym_STAR,
    ACTIONS(6875), 1,
      anon_sym_LT2,
    ACTIONS(6877), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(7353), 1,
      sym_identifier,
    ACTIONS(7948), 1,
      anon_sym_EQ,
    STATE(4859), 1,
      aux_sym_compound_type_repeat1,
    STATE(4991), 1,
      sym_long_identifier,
    STATE(5160), 1,
      sym_type_arguments,
    STATE(5235), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [146401] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5531), 1,
      anon_sym_COLON,
    ACTIONS(7811), 1,
      anon_sym_COMMA,
    STATE(5221), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(5236), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5533), 6,
      anon_sym_as,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_when,
  [146446] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7528), 1,
      anon_sym_as,
    ACTIONS(7809), 1,
      anon_sym_COLON,
    ACTIONS(7811), 1,
      anon_sym_COMMA,
    ACTIONS(7813), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7815), 1,
      anon_sym_PIPE,
    ACTIONS(7817), 1,
      anon_sym_AMP,
    ACTIONS(7950), 1,
      anon_sym_DASH_GT,
    ACTIONS(7952), 1,
      anon_sym_when,
    STATE(5236), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(5237), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [146501] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2567), 2,
      anon_sym_val,
      sym_identifier,
    STATE(5238), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2569), 7,
      ts_builtin_sym_end,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [146542] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(23), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(25), 1,
      anon_sym_val,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7954), 1,
      ts_builtin_sym_end,
    STATE(4305), 1,
      aux_sym_attributes_repeat1,
    STATE(4488), 1,
      sym__attribute_set,
    STATE(5186), 1,
      aux_sym_file_repeat1,
    STATE(5762), 1,
      sym__module_signature_elements,
    STATE(5763), 1,
      sym_value_definition,
    STATE(7536), 1,
      sym_attributes,
    STATE(5239), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [146597] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6871), 1,
      anon_sym_DASH_GT,
    ACTIONS(6873), 1,
      anon_sym_STAR,
    ACTIONS(6875), 1,
      anon_sym_LT2,
    ACTIONS(6877), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(7353), 1,
      sym_identifier,
    ACTIONS(7956), 1,
      anon_sym_RPAREN,
    STATE(4859), 1,
      aux_sym_compound_type_repeat1,
    STATE(4991), 1,
      sym_long_identifier,
    STATE(5160), 1,
      sym_type_arguments,
    STATE(5240), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [146652] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5661), 1,
      anon_sym_COLON,
    STATE(5241), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5663), 8,
      sym__newline,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
  [146693] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6871), 1,
      anon_sym_DASH_GT,
    ACTIONS(6873), 1,
      anon_sym_STAR,
    ACTIONS(6875), 1,
      anon_sym_LT2,
    ACTIONS(6877), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(7353), 1,
      sym_identifier,
    ACTIONS(7958), 1,
      anon_sym_RPAREN,
    STATE(4859), 1,
      aux_sym_compound_type_repeat1,
    STATE(4991), 1,
      sym_long_identifier,
    STATE(5160), 1,
      sym_type_arguments,
    STATE(5242), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [146748] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6871), 1,
      anon_sym_DASH_GT,
    ACTIONS(6873), 1,
      anon_sym_STAR,
    ACTIONS(6875), 1,
      anon_sym_LT2,
    ACTIONS(6877), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(7353), 1,
      sym_identifier,
    ACTIONS(7960), 1,
      anon_sym_GT,
    STATE(4859), 1,
      aux_sym_compound_type_repeat1,
    STATE(4991), 1,
      sym_long_identifier,
    STATE(5160), 1,
      sym_type_arguments,
    STATE(5243), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [146803] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2321), 1,
      anon_sym_COLON,
    STATE(5244), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2323), 8,
      sym__newline,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
  [146844] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6871), 1,
      anon_sym_DASH_GT,
    ACTIONS(6873), 1,
      anon_sym_STAR,
    ACTIONS(6875), 1,
      anon_sym_LT2,
    ACTIONS(6877), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(7353), 1,
      sym_identifier,
    ACTIONS(7962), 1,
      anon_sym_GT,
    STATE(4859), 1,
      aux_sym_compound_type_repeat1,
    STATE(4991), 1,
      sym_long_identifier,
    STATE(5160), 1,
      sym_type_arguments,
    STATE(5245), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [146899] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2506), 2,
      anon_sym_val,
      sym_identifier,
    STATE(5246), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2508), 7,
      ts_builtin_sym_end,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [146940] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6871), 1,
      anon_sym_DASH_GT,
    ACTIONS(6873), 1,
      anon_sym_STAR,
    ACTIONS(6875), 1,
      anon_sym_LT2,
    ACTIONS(6877), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(7353), 1,
      sym_identifier,
    ACTIONS(7964), 1,
      anon_sym_RPAREN,
    STATE(4859), 1,
      aux_sym_compound_type_repeat1,
    STATE(4991), 1,
      sym_long_identifier,
    STATE(5160), 1,
      sym_type_arguments,
    STATE(5247), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [146995] = 16,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7555), 1,
      anon_sym_COLON,
    ACTIONS(7557), 1,
      anon_sym_as,
    ACTIONS(7559), 1,
      anon_sym_COMMA,
    ACTIONS(7561), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7563), 1,
      anon_sym_PIPE,
    ACTIONS(7565), 1,
      anon_sym_AMP,
    STATE(5315), 1,
      aux_sym_repeat_pattern_repeat1,
    ACTIONS(7966), 2,
      sym__newline,
      sym__dedent,
    STATE(5248), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [147048] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6871), 1,
      anon_sym_DASH_GT,
    ACTIONS(6873), 1,
      anon_sym_STAR,
    ACTIONS(6875), 1,
      anon_sym_LT2,
    ACTIONS(6877), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(7353), 1,
      sym_identifier,
    ACTIONS(7968), 1,
      anon_sym_RPAREN,
    STATE(4859), 1,
      aux_sym_compound_type_repeat1,
    STATE(4991), 1,
      sym_long_identifier,
    STATE(5160), 1,
      sym_type_arguments,
    STATE(5249), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [147103] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7970), 1,
      anon_sym_LPAREN,
    ACTIONS(7974), 1,
      anon_sym_not,
    ACTIONS(7976), 1,
      anon_sym_enum,
    ACTIONS(7978), 1,
      anon_sym_delegate,
    STATE(5250), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7972), 5,
      anon_sym_null,
      anon_sym_struct,
      anon_sym_unmanaged,
      anon_sym_equality,
      anon_sym_comparison,
  [147150] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7749), 1,
      anon_sym_COMMA,
    ACTIONS(7751), 1,
      anon_sym_as,
    ACTIONS(7753), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7755), 1,
      anon_sym_PIPE,
    ACTIONS(7757), 1,
      anon_sym_AMP,
    ACTIONS(7805), 1,
      anon_sym_COLON,
    ACTIONS(7831), 1,
      sym__newline,
    ACTIONS(7980), 1,
      anon_sym_RPAREN,
    STATE(5153), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(5251), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [147205] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2470), 2,
      anon_sym_val,
      sym_identifier,
    STATE(5252), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2472), 7,
      ts_builtin_sym_end,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [147246] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7982), 1,
      anon_sym_LPAREN,
    ACTIONS(7986), 1,
      anon_sym_not,
    ACTIONS(7988), 1,
      anon_sym_enum,
    ACTIONS(7990), 1,
      anon_sym_delegate,
    STATE(5253), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7984), 5,
      anon_sym_null,
      anon_sym_struct,
      anon_sym_unmanaged,
      anon_sym_equality,
      anon_sym_comparison,
  [147293] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6871), 1,
      anon_sym_DASH_GT,
    ACTIONS(6873), 1,
      anon_sym_STAR,
    ACTIONS(6875), 1,
      anon_sym_LT2,
    ACTIONS(6877), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(7353), 1,
      sym_identifier,
    ACTIONS(7992), 1,
      anon_sym_GT,
    STATE(4859), 1,
      aux_sym_compound_type_repeat1,
    STATE(4991), 1,
      sym_long_identifier,
    STATE(5160), 1,
      sym_type_arguments,
    STATE(5254), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [147348] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6871), 1,
      anon_sym_DASH_GT,
    ACTIONS(6873), 1,
      anon_sym_STAR,
    ACTIONS(6875), 1,
      anon_sym_LT2,
    ACTIONS(6877), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(7353), 1,
      sym_identifier,
    ACTIONS(7994), 1,
      anon_sym_RPAREN,
    STATE(4859), 1,
      aux_sym_compound_type_repeat1,
    STATE(4991), 1,
      sym_long_identifier,
    STATE(5160), 1,
      sym_type_arguments,
    STATE(5255), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [147403] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5503), 1,
      anon_sym_COLON,
    STATE(5236), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(5256), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5505), 7,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_when,
  [147446] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5562), 1,
      anon_sym_COLON,
    STATE(5236), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(5257), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5564), 7,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_when,
  [147489] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5558), 1,
      anon_sym_COLON,
    STATE(5236), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(5258), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5560), 7,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_when,
  [147532] = 16,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7749), 1,
      anon_sym_COMMA,
    ACTIONS(7751), 1,
      anon_sym_as,
    ACTIONS(7753), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7755), 1,
      anon_sym_PIPE,
    ACTIONS(7757), 1,
      anon_sym_AMP,
    ACTIONS(7805), 1,
      anon_sym_COLON,
    STATE(5153), 1,
      aux_sym_repeat_pattern_repeat1,
    ACTIONS(7831), 2,
      sym__newline,
      anon_sym_RPAREN,
    STATE(5259), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [147585] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6871), 1,
      anon_sym_DASH_GT,
    ACTIONS(6873), 1,
      anon_sym_STAR,
    ACTIONS(6875), 1,
      anon_sym_LT2,
    ACTIONS(6877), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(7353), 1,
      sym_identifier,
    ACTIONS(7996), 1,
      anon_sym_RPAREN,
    STATE(4859), 1,
      aux_sym_compound_type_repeat1,
    STATE(4991), 1,
      sym_long_identifier,
    STATE(5160), 1,
      sym_type_arguments,
    STATE(5260), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [147640] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7998), 1,
      anon_sym_LPAREN,
    ACTIONS(8002), 1,
      anon_sym_not,
    ACTIONS(8004), 1,
      anon_sym_enum,
    ACTIONS(8006), 1,
      anon_sym_delegate,
    STATE(5261), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8000), 5,
      anon_sym_null,
      anon_sym_struct,
      anon_sym_unmanaged,
      anon_sym_equality,
      anon_sym_comparison,
  [147687] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6871), 1,
      anon_sym_DASH_GT,
    ACTIONS(6873), 1,
      anon_sym_STAR,
    ACTIONS(6875), 1,
      anon_sym_LT2,
    ACTIONS(6877), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(7353), 1,
      sym_identifier,
    ACTIONS(8008), 1,
      anon_sym_EQ,
    STATE(4859), 1,
      aux_sym_compound_type_repeat1,
    STATE(4991), 1,
      sym_long_identifier,
    STATE(5160), 1,
      sym_type_arguments,
    STATE(5262), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [147742] = 16,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7749), 1,
      anon_sym_COMMA,
    ACTIONS(7751), 1,
      anon_sym_as,
    ACTIONS(7753), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7755), 1,
      anon_sym_PIPE,
    ACTIONS(7757), 1,
      anon_sym_AMP,
    ACTIONS(7805), 1,
      anon_sym_COLON,
    STATE(5153), 1,
      aux_sym_repeat_pattern_repeat1,
    ACTIONS(8010), 2,
      sym__newline,
      anon_sym_RPAREN,
    STATE(5263), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [147795] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6871), 1,
      anon_sym_DASH_GT,
    ACTIONS(6873), 1,
      anon_sym_STAR,
    ACTIONS(6875), 1,
      anon_sym_LT2,
    ACTIONS(6877), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(7353), 1,
      sym_identifier,
    ACTIONS(8012), 1,
      anon_sym_GT,
    STATE(4859), 1,
      aux_sym_compound_type_repeat1,
    STATE(4991), 1,
      sym_long_identifier,
    STATE(5160), 1,
      sym_type_arguments,
    STATE(5264), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [147850] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6871), 1,
      anon_sym_DASH_GT,
    ACTIONS(6873), 1,
      anon_sym_STAR,
    ACTIONS(6875), 1,
      anon_sym_LT2,
    ACTIONS(6877), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(7353), 1,
      sym_identifier,
    ACTIONS(8014), 1,
      anon_sym_GT,
    STATE(4859), 1,
      aux_sym_compound_type_repeat1,
    STATE(4991), 1,
      sym_long_identifier,
    STATE(5160), 1,
      sym_type_arguments,
    STATE(5265), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [147905] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6871), 1,
      anon_sym_DASH_GT,
    ACTIONS(6873), 1,
      anon_sym_STAR,
    ACTIONS(6875), 1,
      anon_sym_LT2,
    ACTIONS(6877), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(7353), 1,
      sym_identifier,
    ACTIONS(8016), 1,
      anon_sym_RPAREN,
    STATE(4859), 1,
      aux_sym_compound_type_repeat1,
    STATE(4991), 1,
      sym_long_identifier,
    STATE(5160), 1,
      sym_type_arguments,
    STATE(5266), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [147960] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7528), 1,
      anon_sym_as,
    ACTIONS(7809), 1,
      anon_sym_COLON,
    ACTIONS(7811), 1,
      anon_sym_COMMA,
    ACTIONS(7813), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7815), 1,
      anon_sym_PIPE,
    ACTIONS(7817), 1,
      anon_sym_AMP,
    ACTIONS(8018), 1,
      anon_sym_DASH_GT,
    ACTIONS(8020), 1,
      anon_sym_when,
    STATE(5236), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(5267), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [148015] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2454), 2,
      anon_sym_val,
      sym_identifier,
    STATE(5268), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2456), 7,
      ts_builtin_sym_end,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [148056] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5537), 1,
      anon_sym_COLON,
    STATE(5236), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(5269), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5539), 7,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_DASH_GT,
      anon_sym_when,
  [148099] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3023), 1,
      anon_sym_COLON,
    STATE(5270), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3025), 8,
      sym__newline,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
  [148140] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3031), 1,
      anon_sym_COLON,
    STATE(5271), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3033), 8,
      sym__newline,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
  [148181] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3027), 1,
      anon_sym_COLON,
    STATE(5272), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3029), 8,
      sym__newline,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
  [148222] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2855), 1,
      anon_sym_COLON,
    STATE(5273), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2857), 8,
      sym__newline,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
  [148263] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7528), 1,
      anon_sym_as,
    ACTIONS(7809), 1,
      anon_sym_COLON,
    ACTIONS(7811), 1,
      anon_sym_COMMA,
    ACTIONS(7813), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7815), 1,
      anon_sym_PIPE,
    ACTIONS(7817), 1,
      anon_sym_AMP,
    ACTIONS(8022), 1,
      anon_sym_DASH_GT,
    ACTIONS(8024), 1,
      anon_sym_when,
    STATE(5236), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(5274), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [148318] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(23), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6451), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(7466), 1,
      sym_identifier,
    ACTIONS(7468), 1,
      anon_sym_mutable,
    STATE(4305), 1,
      aux_sym_attributes_repeat1,
    STATE(4488), 1,
      sym__attribute_set,
    STATE(5728), 1,
      sym_attributes,
    STATE(6275), 1,
      sym_record_field,
    STATE(7090), 1,
      sym_access_modifier,
    STATE(5275), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [148373] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5580), 1,
      anon_sym_COLON,
    STATE(5276), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5582), 8,
      sym__newline,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
  [148414] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6871), 1,
      anon_sym_DASH_GT,
    ACTIONS(6873), 1,
      anon_sym_STAR,
    ACTIONS(6875), 1,
      anon_sym_LT2,
    ACTIONS(6877), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(7353), 1,
      sym_identifier,
    ACTIONS(8026), 1,
      anon_sym_COMMA,
    STATE(4859), 1,
      aux_sym_compound_type_repeat1,
    STATE(4991), 1,
      sym_long_identifier,
    STATE(5160), 1,
      sym_type_arguments,
    STATE(5277), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [148469] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3019), 1,
      anon_sym_COLON,
    STATE(5278), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3021), 8,
      sym__newline,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
  [148510] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6105), 4,
      anon_sym_LPAREN,
      anon_sym__,
      anon_sym_POUND,
      sym_identifier,
    STATE(5279), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6107), 5,
      anon_sym_LBRACK_LT,
      anon_sym_QMARK,
      anon_sym_LBRACE_PIPE,
      anon_sym_CARET,
      anon_sym_SQUOTE,
  [148551] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6871), 1,
      anon_sym_DASH_GT,
    ACTIONS(6873), 1,
      anon_sym_STAR,
    ACTIONS(6875), 1,
      anon_sym_LT2,
    ACTIONS(6877), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(7353), 1,
      sym_identifier,
    ACTIONS(8028), 1,
      anon_sym_RPAREN,
    STATE(4859), 1,
      aux_sym_compound_type_repeat1,
    STATE(4991), 1,
      sym_long_identifier,
    STATE(5160), 1,
      sym_type_arguments,
    STATE(5280), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [148606] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7749), 1,
      anon_sym_COMMA,
    ACTIONS(7751), 1,
      anon_sym_as,
    ACTIONS(7753), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7755), 1,
      anon_sym_PIPE,
    ACTIONS(7757), 1,
      anon_sym_AMP,
    ACTIONS(7805), 1,
      anon_sym_COLON,
    ACTIONS(7831), 1,
      sym__newline,
    ACTIONS(8030), 1,
      anon_sym_RPAREN,
    STATE(5153), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(5281), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [148661] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7528), 1,
      anon_sym_as,
    ACTIONS(7809), 1,
      anon_sym_COLON,
    ACTIONS(7811), 1,
      anon_sym_COMMA,
    ACTIONS(7813), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7815), 1,
      anon_sym_PIPE,
    ACTIONS(7817), 1,
      anon_sym_AMP,
    ACTIONS(8032), 1,
      anon_sym_DASH_GT,
    ACTIONS(8034), 1,
      anon_sym_when,
    STATE(5236), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(5282), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [148716] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7528), 1,
      anon_sym_as,
    ACTIONS(7809), 1,
      anon_sym_COLON,
    ACTIONS(7811), 1,
      anon_sym_COMMA,
    ACTIONS(7813), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7815), 1,
      anon_sym_PIPE,
    ACTIONS(7817), 1,
      anon_sym_AMP,
    ACTIONS(8036), 1,
      anon_sym_DASH_GT,
    ACTIONS(8038), 1,
      anon_sym_when,
    STATE(5236), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(5283), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [148771] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2974), 1,
      anon_sym_COLON,
    STATE(5284), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2976), 8,
      sym__newline,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
  [148812] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5584), 1,
      anon_sym_COLON,
    STATE(5285), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5586), 8,
      sym__newline,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
  [148853] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6871), 1,
      anon_sym_DASH_GT,
    ACTIONS(6873), 1,
      anon_sym_STAR,
    ACTIONS(6875), 1,
      anon_sym_LT2,
    ACTIONS(6877), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(7353), 1,
      sym_identifier,
    ACTIONS(8040), 1,
      anon_sym_RPAREN,
    STATE(4859), 1,
      aux_sym_compound_type_repeat1,
    STATE(4991), 1,
      sym_long_identifier,
    STATE(5160), 1,
      sym_type_arguments,
    STATE(5286), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [148908] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7749), 1,
      anon_sym_COMMA,
    ACTIONS(7751), 1,
      anon_sym_as,
    ACTIONS(7753), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7755), 1,
      anon_sym_PIPE,
    ACTIONS(7757), 1,
      anon_sym_AMP,
    ACTIONS(7805), 1,
      anon_sym_COLON,
    ACTIONS(7831), 1,
      sym__newline,
    ACTIONS(8042), 1,
      anon_sym_RPAREN,
    STATE(5153), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(5287), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [148963] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3035), 1,
      anon_sym_COLON,
    STATE(5288), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3037), 8,
      sym__newline,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
  [149004] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2962), 1,
      anon_sym_COLON,
    STATE(5289), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2964), 8,
      sym__newline,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
  [149045] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2958), 1,
      anon_sym_COLON,
    STATE(5290), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2960), 8,
      sym__newline,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
  [149086] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6871), 1,
      anon_sym_DASH_GT,
    ACTIONS(6873), 1,
      anon_sym_STAR,
    ACTIONS(6875), 1,
      anon_sym_LT2,
    ACTIONS(6877), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(7353), 1,
      sym_identifier,
    ACTIONS(8044), 1,
      anon_sym_RPAREN,
    STATE(4859), 1,
      aux_sym_compound_type_repeat1,
    STATE(4991), 1,
      sym_long_identifier,
    STATE(5160), 1,
      sym_type_arguments,
    STATE(5291), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [149141] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2950), 1,
      anon_sym_COLON,
    STATE(5292), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2952), 8,
      sym__newline,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
  [149182] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5590), 1,
      anon_sym_COLON,
    STATE(5293), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5592), 8,
      sym__newline,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
  [149223] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2946), 1,
      anon_sym_COLON,
    STATE(5294), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2948), 8,
      sym__newline,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
  [149264] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2938), 1,
      anon_sym_COLON,
    STATE(5295), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2940), 8,
      sym__newline,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
  [149305] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2926), 1,
      anon_sym_COLON,
    STATE(5296), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2928), 8,
      sym__newline,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
  [149346] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6871), 1,
      anon_sym_DASH_GT,
    ACTIONS(6873), 1,
      anon_sym_STAR,
    ACTIONS(6875), 1,
      anon_sym_LT2,
    ACTIONS(6877), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(7353), 1,
      sym_identifier,
    ACTIONS(8046), 1,
      anon_sym_RPAREN,
    STATE(4859), 1,
      aux_sym_compound_type_repeat1,
    STATE(4991), 1,
      sym_long_identifier,
    STATE(5160), 1,
      sym_type_arguments,
    STATE(5297), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [149401] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2922), 1,
      anon_sym_COLON,
    STATE(5298), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2924), 8,
      sym__newline,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
  [149442] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6871), 1,
      anon_sym_DASH_GT,
    ACTIONS(6873), 1,
      anon_sym_STAR,
    ACTIONS(6875), 1,
      anon_sym_LT2,
    ACTIONS(6877), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(7353), 1,
      sym_identifier,
    ACTIONS(8048), 1,
      anon_sym_RPAREN,
    STATE(4859), 1,
      aux_sym_compound_type_repeat1,
    STATE(4991), 1,
      sym_long_identifier,
    STATE(5160), 1,
      sym_type_arguments,
    STATE(5299), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [149497] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6871), 1,
      anon_sym_DASH_GT,
    ACTIONS(6873), 1,
      anon_sym_STAR,
    ACTIONS(6875), 1,
      anon_sym_LT2,
    ACTIONS(6877), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(7353), 1,
      sym_identifier,
    ACTIONS(8050), 1,
      anon_sym_RPAREN,
    STATE(4859), 1,
      aux_sym_compound_type_repeat1,
    STATE(4991), 1,
      sym_long_identifier,
    STATE(5160), 1,
      sym_type_arguments,
    STATE(5300), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [149552] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6871), 1,
      anon_sym_DASH_GT,
    ACTIONS(6873), 1,
      anon_sym_STAR,
    ACTIONS(6875), 1,
      anon_sym_LT2,
    ACTIONS(6877), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(7353), 1,
      sym_identifier,
    ACTIONS(8052), 1,
      anon_sym_RPAREN,
    STATE(4859), 1,
      aux_sym_compound_type_repeat1,
    STATE(4991), 1,
      sym_long_identifier,
    STATE(5160), 1,
      sym_type_arguments,
    STATE(5301), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [149607] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7528), 1,
      anon_sym_as,
    ACTIONS(7809), 1,
      anon_sym_COLON,
    ACTIONS(7811), 1,
      anon_sym_COMMA,
    ACTIONS(7813), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7815), 1,
      anon_sym_PIPE,
    ACTIONS(7817), 1,
      anon_sym_AMP,
    ACTIONS(8054), 1,
      anon_sym_DASH_GT,
    ACTIONS(8056), 1,
      anon_sym_when,
    STATE(5236), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(5302), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [149662] = 16,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5491), 1,
      anon_sym_COLON,
    ACTIONS(7557), 1,
      anon_sym_as,
    ACTIONS(7559), 1,
      anon_sym_COMMA,
    ACTIONS(7561), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7563), 1,
      anon_sym_PIPE,
    ACTIONS(7565), 1,
      anon_sym_AMP,
    STATE(5315), 1,
      aux_sym_repeat_pattern_repeat1,
    ACTIONS(5493), 2,
      sym__newline,
      sym__dedent,
    STATE(5303), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [149715] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6871), 1,
      anon_sym_DASH_GT,
    ACTIONS(6873), 1,
      anon_sym_STAR,
    ACTIONS(6875), 1,
      anon_sym_LT2,
    ACTIONS(6877), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(7353), 1,
      sym_identifier,
    ACTIONS(8058), 1,
      anon_sym_RPAREN,
    STATE(4859), 1,
      aux_sym_compound_type_repeat1,
    STATE(4991), 1,
      sym_long_identifier,
    STATE(5160), 1,
      sym_type_arguments,
    STATE(5304), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [149770] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5594), 1,
      anon_sym_COLON,
    STATE(5305), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5596), 8,
      sym__newline,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
  [149811] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5503), 1,
      anon_sym_COLON,
    ACTIONS(8060), 1,
      anon_sym_COMMA,
    STATE(5306), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_repeat_pattern_repeat1,
    ACTIONS(5505), 6,
      sym__newline,
      sym__dedent,
      anon_sym_as,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
  [149854] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8063), 1,
      anon_sym_DOT,
    STATE(5351), 1,
      aux_sym_long_identifier_repeat1,
    ACTIONS(2312), 2,
      anon_sym_and,
      sym_identifier,
    STATE(5307), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2314), 5,
      anon_sym_DASH_GT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [149899] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5598), 1,
      anon_sym_COLON,
    STATE(5308), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5600), 8,
      sym__newline,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
  [149940] = 17,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(3570), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(7263), 1,
      sym_identifier,
    ACTIONS(7269), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(7271), 1,
      sym_op_identifier,
    STATE(2288), 1,
      sym_property_or_ident,
    STATE(3772), 1,
      sym__identifier_or_op,
    STATE(3773), 1,
      sym_active_pattern,
    STATE(4887), 1,
      sym_method_or_prop_defn,
    STATE(5528), 1,
      sym_access_modifier,
    STATE(5309), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [149995] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6871), 1,
      anon_sym_DASH_GT,
    ACTIONS(6873), 1,
      anon_sym_STAR,
    ACTIONS(6875), 1,
      anon_sym_LT2,
    ACTIONS(6877), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(7353), 1,
      sym_identifier,
    ACTIONS(8065), 1,
      anon_sym_RPAREN,
    STATE(4859), 1,
      aux_sym_compound_type_repeat1,
    STATE(4991), 1,
      sym_long_identifier,
    STATE(5160), 1,
      sym_type_arguments,
    STATE(5310), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [150050] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7528), 1,
      anon_sym_as,
    ACTIONS(7809), 1,
      anon_sym_COLON,
    ACTIONS(7811), 1,
      anon_sym_COMMA,
    ACTIONS(7813), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7815), 1,
      anon_sym_PIPE,
    ACTIONS(7817), 1,
      anon_sym_AMP,
    ACTIONS(8067), 1,
      anon_sym_DASH_GT,
    ACTIONS(8069), 1,
      anon_sym_when,
    STATE(5236), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(5311), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [150105] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7749), 1,
      anon_sym_COMMA,
    ACTIONS(7751), 1,
      anon_sym_as,
    ACTIONS(7753), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7755), 1,
      anon_sym_PIPE,
    ACTIONS(7757), 1,
      anon_sym_AMP,
    ACTIONS(7805), 1,
      anon_sym_COLON,
    ACTIONS(7831), 1,
      sym__newline,
    ACTIONS(8071), 1,
      anon_sym_RPAREN,
    STATE(5153), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(5312), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [150160] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6871), 1,
      anon_sym_DASH_GT,
    ACTIONS(6873), 1,
      anon_sym_STAR,
    ACTIONS(6875), 1,
      anon_sym_LT2,
    ACTIONS(6877), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(7353), 1,
      sym_identifier,
    ACTIONS(8073), 1,
      anon_sym_RPAREN,
    STATE(4859), 1,
      aux_sym_compound_type_repeat1,
    STATE(4991), 1,
      sym_long_identifier,
    STATE(5160), 1,
      sym_type_arguments,
    STATE(5313), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [150215] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6871), 1,
      anon_sym_DASH_GT,
    ACTIONS(6873), 1,
      anon_sym_STAR,
    ACTIONS(6875), 1,
      anon_sym_LT2,
    ACTIONS(6877), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(7353), 1,
      sym_identifier,
    ACTIONS(8075), 1,
      anon_sym_RPAREN,
    STATE(4859), 1,
      aux_sym_compound_type_repeat1,
    STATE(4991), 1,
      sym_long_identifier,
    STATE(5160), 1,
      sym_type_arguments,
    STATE(5314), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [150270] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5531), 1,
      anon_sym_COLON,
    ACTIONS(7559), 1,
      anon_sym_COMMA,
    STATE(5306), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(5315), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5533), 6,
      sym__newline,
      sym__dedent,
      anon_sym_as,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
  [150315] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2918), 1,
      anon_sym_COLON,
    STATE(5316), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2920), 8,
      sym__newline,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
  [150356] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6871), 1,
      anon_sym_DASH_GT,
    ACTIONS(6873), 1,
      anon_sym_STAR,
    ACTIONS(6875), 1,
      anon_sym_LT2,
    ACTIONS(6877), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(7353), 1,
      sym_identifier,
    ACTIONS(8077), 1,
      anon_sym_RPAREN,
    STATE(4859), 1,
      aux_sym_compound_type_repeat1,
    STATE(4991), 1,
      sym_long_identifier,
    STATE(5160), 1,
      sym_type_arguments,
    STATE(5317), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [150411] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(133), 1,
      sym_line_comment,
    ACTIONS(6818), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(6820), 1,
      anon_sym_POUNDlight,
    ACTIONS(6822), 1,
      anon_sym_POUNDr,
    ACTIONS(7628), 1,
      anon_sym_DQUOTE2,
    STATE(5574), 1,
      sym__verbatim_string_char,
    STATE(5575), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(8082), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(8079), 3,
      sym__non_escape_char,
      anon_sym_BSLASH,
      aux_sym__verbatim_string_char_token1,
    STATE(5318), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_verbatim_string_repeat1,
  [150456] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6871), 1,
      anon_sym_DASH_GT,
    ACTIONS(6873), 1,
      anon_sym_STAR,
    ACTIONS(6875), 1,
      anon_sym_LT2,
    ACTIONS(6877), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(7353), 1,
      sym_identifier,
    ACTIONS(8085), 1,
      anon_sym_RPAREN,
    STATE(4859), 1,
      aux_sym_compound_type_repeat1,
    STATE(4991), 1,
      sym_long_identifier,
    STATE(5160), 1,
      sym_type_arguments,
    STATE(5319), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [150511] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6871), 1,
      anon_sym_DASH_GT,
    ACTIONS(6873), 1,
      anon_sym_STAR,
    ACTIONS(6875), 1,
      anon_sym_LT2,
    ACTIONS(6877), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(7353), 1,
      sym_identifier,
    ACTIONS(8087), 1,
      anon_sym_RPAREN,
    STATE(4859), 1,
      aux_sym_compound_type_repeat1,
    STATE(4991), 1,
      sym_long_identifier,
    STATE(5160), 1,
      sym_type_arguments,
    STATE(5320), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [150566] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6871), 1,
      anon_sym_DASH_GT,
    ACTIONS(6873), 1,
      anon_sym_STAR,
    ACTIONS(6875), 1,
      anon_sym_LT2,
    ACTIONS(6877), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(7353), 1,
      sym_identifier,
    ACTIONS(8089), 1,
      anon_sym_COMMA,
    STATE(4859), 1,
      aux_sym_compound_type_repeat1,
    STATE(4991), 1,
      sym_long_identifier,
    STATE(5160), 1,
      sym_type_arguments,
    STATE(5321), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [150621] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(23), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8091), 1,
      anon_sym_val,
    ACTIONS(8093), 1,
      sym__dedent,
    STATE(4305), 1,
      aux_sym_attributes_repeat1,
    STATE(4488), 1,
      sym__attribute_set,
    STATE(5192), 1,
      aux_sym_file_repeat1,
    STATE(5896), 1,
      sym_value_definition,
    STATE(5898), 1,
      sym__module_signature_elements,
    STATE(7371), 1,
      sym_attributes,
    STATE(5322), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [150676] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7528), 1,
      anon_sym_as,
    ACTIONS(7809), 1,
      anon_sym_COLON,
    ACTIONS(7811), 1,
      anon_sym_COMMA,
    ACTIONS(7813), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7815), 1,
      anon_sym_PIPE,
    ACTIONS(7817), 1,
      anon_sym_AMP,
    ACTIONS(8095), 1,
      anon_sym_DASH_GT,
    ACTIONS(8097), 1,
      anon_sym_when,
    STATE(5236), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(5323), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [150731] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8099), 4,
      anon_sym_LPAREN,
      anon_sym__,
      anon_sym_POUND,
      sym_identifier,
    STATE(5324), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8101), 5,
      anon_sym_LBRACK_LT,
      anon_sym_QMARK,
      anon_sym_LBRACE_PIPE,
      anon_sym_CARET,
      anon_sym_SQUOTE,
  [150772] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6871), 1,
      anon_sym_DASH_GT,
    ACTIONS(6873), 1,
      anon_sym_STAR,
    ACTIONS(6875), 1,
      anon_sym_LT2,
    ACTIONS(6877), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(7353), 1,
      sym_identifier,
    ACTIONS(8103), 1,
      anon_sym_RPAREN,
    STATE(4859), 1,
      aux_sym_compound_type_repeat1,
    STATE(4991), 1,
      sym_long_identifier,
    STATE(5160), 1,
      sym_type_arguments,
    STATE(5325), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [150827] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5527), 1,
      anon_sym_COLON,
    STATE(5326), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5529), 8,
      sym__newline,
      sym__dedent,
      anon_sym_and,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
  [150868] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6871), 1,
      anon_sym_DASH_GT,
    ACTIONS(6873), 1,
      anon_sym_STAR,
    ACTIONS(6875), 1,
      anon_sym_LT2,
    ACTIONS(6877), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(7353), 1,
      sym_identifier,
    ACTIONS(8105), 1,
      anon_sym_RPAREN,
    STATE(4859), 1,
      aux_sym_compound_type_repeat1,
    STATE(4991), 1,
      sym_long_identifier,
    STATE(5160), 1,
      sym_type_arguments,
    STATE(5327), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [150923] = 17,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(3570), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(7263), 1,
      sym_identifier,
    ACTIONS(7269), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(7271), 1,
      sym_op_identifier,
    STATE(2288), 1,
      sym_property_or_ident,
    STATE(3772), 1,
      sym__identifier_or_op,
    STATE(3773), 1,
      sym_active_pattern,
    STATE(4880), 1,
      sym_method_or_prop_defn,
    STATE(5548), 1,
      sym_access_modifier,
    STATE(5328), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [150978] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5618), 1,
      anon_sym_COLON,
    STATE(5329), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5620), 8,
      sym__newline,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
  [151019] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5520), 1,
      anon_sym_COLON,
    STATE(5330), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5522), 8,
      sym__newline,
      sym__dedent,
      anon_sym_and,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
  [151060] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6871), 1,
      anon_sym_DASH_GT,
    ACTIONS(6873), 1,
      anon_sym_STAR,
    ACTIONS(6875), 1,
      anon_sym_LT2,
    ACTIONS(6877), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(7353), 1,
      sym_identifier,
    ACTIONS(8107), 1,
      anon_sym_EQ,
    STATE(4859), 1,
      aux_sym_compound_type_repeat1,
    STATE(4991), 1,
      sym_long_identifier,
    STATE(5160), 1,
      sym_type_arguments,
    STATE(5331), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [151115] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2914), 1,
      anon_sym_COLON,
    STATE(5332), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2916), 8,
      sym__newline,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
  [151156] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6871), 1,
      anon_sym_DASH_GT,
    ACTIONS(6873), 1,
      anon_sym_STAR,
    ACTIONS(6875), 1,
      anon_sym_LT2,
    ACTIONS(6877), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(7353), 1,
      sym_identifier,
    ACTIONS(8109), 1,
      anon_sym_COMMA,
    STATE(4859), 1,
      aux_sym_compound_type_repeat1,
    STATE(4991), 1,
      sym_long_identifier,
    STATE(5160), 1,
      sym_type_arguments,
    STATE(5333), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [151211] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5516), 1,
      anon_sym_COLON,
    STATE(5334), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5518), 8,
      sym__newline,
      sym__dedent,
      anon_sym_and,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
  [151252] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5487), 1,
      anon_sym_COLON,
    STATE(5335), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5489), 8,
      sym__newline,
      sym__dedent,
      anon_sym_and,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
  [151293] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5009), 1,
      anon_sym_COLON,
    STATE(5336), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5011), 8,
      sym__newline,
      sym__dedent,
      anon_sym_and,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
  [151334] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5013), 1,
      anon_sym_COLON,
    STATE(5337), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5015), 8,
      sym__newline,
      sym__dedent,
      anon_sym_and,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
  [151375] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6871), 1,
      anon_sym_DASH_GT,
    ACTIONS(6873), 1,
      anon_sym_STAR,
    ACTIONS(6875), 1,
      anon_sym_LT2,
    ACTIONS(6877), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(7353), 1,
      sym_identifier,
    ACTIONS(8111), 1,
      anon_sym_RPAREN,
    STATE(4859), 1,
      aux_sym_compound_type_repeat1,
    STATE(4991), 1,
      sym_long_identifier,
    STATE(5160), 1,
      sym_type_arguments,
    STATE(5338), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [151430] = 9,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(133), 1,
      sym_line_comment,
    ACTIONS(6818), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(6820), 1,
      anon_sym_POUNDlight,
    ACTIONS(6822), 1,
      anon_sym_POUNDr,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(8113), 4,
      sym__inside_string_marker,
      sym__escape_char,
      sym__non_escape_char,
      anon_sym_LBRACE2,
    STATE(5339), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8115), 5,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
      aux_sym__simple_string_char_token1,
      anon_sym_DQUOTE,
  [151469] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(23), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8091), 1,
      anon_sym_val,
    ACTIONS(8117), 1,
      sym__dedent,
    STATE(4305), 1,
      aux_sym_attributes_repeat1,
    STATE(4488), 1,
      sym__attribute_set,
    STATE(5322), 1,
      aux_sym_file_repeat1,
    STATE(5896), 1,
      sym_value_definition,
    STATE(5898), 1,
      sym__module_signature_elements,
    STATE(7371), 1,
      sym_attributes,
    STATE(5340), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [151524] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2910), 1,
      anon_sym_COLON,
    STATE(5341), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2912), 8,
      sym__newline,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
  [151565] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5402), 1,
      anon_sym_COLON,
    STATE(5342), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5404), 8,
      sym__newline,
      sym__dedent,
      anon_sym_and,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
  [151606] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2891), 1,
      anon_sym_COLON,
    STATE(5343), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2893), 8,
      sym__newline,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
  [151647] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2887), 1,
      anon_sym_COLON,
    STATE(5344), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2889), 8,
      sym__newline,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
  [151688] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6871), 1,
      anon_sym_DASH_GT,
    ACTIONS(6873), 1,
      anon_sym_STAR,
    ACTIONS(6875), 1,
      anon_sym_LT2,
    ACTIONS(6877), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(7353), 1,
      sym_identifier,
    ACTIONS(8119), 1,
      anon_sym_RPAREN,
    STATE(4859), 1,
      aux_sym_compound_type_repeat1,
    STATE(4991), 1,
      sym_long_identifier,
    STATE(5160), 1,
      sym_type_arguments,
    STATE(5345), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [151743] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8121), 1,
      anon_sym_LPAREN,
    ACTIONS(8125), 1,
      anon_sym_not,
    ACTIONS(8127), 1,
      anon_sym_enum,
    ACTIONS(8129), 1,
      anon_sym_delegate,
    STATE(5346), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8123), 5,
      anon_sym_null,
      anon_sym_struct,
      anon_sym_unmanaged,
      anon_sym_equality,
      anon_sym_comparison,
  [151790] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2883), 1,
      anon_sym_COLON,
    STATE(5347), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2885), 8,
      sym__newline,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
  [151831] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6871), 1,
      anon_sym_DASH_GT,
    ACTIONS(6873), 1,
      anon_sym_STAR,
    ACTIONS(6875), 1,
      anon_sym_LT2,
    ACTIONS(6877), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(7353), 1,
      sym_identifier,
    ACTIONS(8131), 1,
      anon_sym_RPAREN,
    STATE(4859), 1,
      aux_sym_compound_type_repeat1,
    STATE(4991), 1,
      sym_long_identifier,
    STATE(5160), 1,
      sym_type_arguments,
    STATE(5348), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [151886] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2877), 1,
      anon_sym_COLON,
    STATE(5349), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2879), 8,
      sym__newline,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
  [151927] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2873), 1,
      anon_sym_COLON,
    STATE(5350), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2875), 8,
      sym__newline,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
  [151968] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8063), 1,
      anon_sym_DOT,
    STATE(5358), 1,
      aux_sym_long_identifier_repeat1,
    ACTIONS(2418), 2,
      anon_sym_and,
      sym_identifier,
    STATE(5351), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2420), 5,
      anon_sym_DASH_GT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [152013] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6291), 4,
      anon_sym_LPAREN,
      anon_sym__,
      anon_sym_POUND,
      sym_identifier,
    STATE(5352), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6293), 5,
      anon_sym_LBRACK_LT,
      anon_sym_QMARK,
      anon_sym_LBRACE_PIPE,
      anon_sym_CARET,
      anon_sym_SQUOTE,
  [152054] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6871), 1,
      anon_sym_DASH_GT,
    ACTIONS(6873), 1,
      anon_sym_STAR,
    ACTIONS(6875), 1,
      anon_sym_LT2,
    ACTIONS(6877), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(7353), 1,
      sym_identifier,
    ACTIONS(8133), 1,
      anon_sym_RPAREN,
    STATE(4859), 1,
      aux_sym_compound_type_repeat1,
    STATE(4991), 1,
      sym_long_identifier,
    STATE(5160), 1,
      sym_type_arguments,
    STATE(5353), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [152109] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2466), 2,
      anon_sym_val,
      sym_identifier,
    STATE(5354), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2468), 7,
      ts_builtin_sym_end,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [152150] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2627), 2,
      anon_sym_val,
      sym_identifier,
    STATE(5355), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2629), 7,
      ts_builtin_sym_end,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [152191] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8135), 1,
      anon_sym_LPAREN,
    ACTIONS(8139), 1,
      anon_sym_not,
    ACTIONS(8141), 1,
      anon_sym_enum,
    ACTIONS(8143), 1,
      anon_sym_delegate,
    STATE(5356), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8137), 5,
      anon_sym_null,
      anon_sym_struct,
      anon_sym_unmanaged,
      anon_sym_equality,
      anon_sym_comparison,
  [152238] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5417), 1,
      anon_sym_COLON,
    ACTIONS(7942), 1,
      anon_sym_and,
    STATE(5232), 1,
      aux_sym_type_argument_constraints_repeat1,
    STATE(5357), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5419), 6,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_in,
  [152283] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8145), 1,
      anon_sym_DOT,
    ACTIONS(2411), 2,
      anon_sym_and,
      sym_identifier,
    ACTIONS(2413), 5,
      anon_sym_DASH_GT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
    STATE(5358), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_long_identifier_repeat1,
  [152326] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7749), 1,
      anon_sym_COMMA,
    ACTIONS(7751), 1,
      anon_sym_as,
    ACTIONS(7753), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7755), 1,
      anon_sym_PIPE,
    ACTIONS(7757), 1,
      anon_sym_AMP,
    ACTIONS(7805), 1,
      anon_sym_COLON,
    ACTIONS(7831), 1,
      sym__newline,
    ACTIONS(8148), 1,
      anon_sym_RPAREN,
    STATE(5153), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(5359), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [152381] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6871), 1,
      anon_sym_DASH_GT,
    ACTIONS(6873), 1,
      anon_sym_STAR,
    ACTIONS(6875), 1,
      anon_sym_LT2,
    ACTIONS(6877), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(7353), 1,
      sym_identifier,
    ACTIONS(8150), 1,
      anon_sym_RPAREN,
    STATE(4859), 1,
      aux_sym_compound_type_repeat1,
    STATE(4991), 1,
      sym_long_identifier,
    STATE(5160), 1,
      sym_type_arguments,
    STATE(5360), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [152436] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6871), 1,
      anon_sym_DASH_GT,
    ACTIONS(6873), 1,
      anon_sym_STAR,
    ACTIONS(6875), 1,
      anon_sym_LT2,
    ACTIONS(6877), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(7353), 1,
      sym_identifier,
    ACTIONS(8152), 1,
      anon_sym_RPAREN,
    STATE(4859), 1,
      aux_sym_compound_type_repeat1,
    STATE(4991), 1,
      sym_long_identifier,
    STATE(5160), 1,
      sym_type_arguments,
    STATE(5361), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [152491] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6871), 1,
      anon_sym_DASH_GT,
    ACTIONS(6873), 1,
      anon_sym_STAR,
    ACTIONS(6875), 1,
      anon_sym_LT2,
    ACTIONS(6877), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(7353), 1,
      sym_identifier,
    ACTIONS(8154), 1,
      anon_sym_RPAREN,
    STATE(4859), 1,
      aux_sym_compound_type_repeat1,
    STATE(4991), 1,
      sym_long_identifier,
    STATE(5160), 1,
      sym_type_arguments,
    STATE(5362), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [152546] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6043), 4,
      anon_sym_LPAREN,
      anon_sym__,
      anon_sym_POUND,
      sym_identifier,
    STATE(5363), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(6045), 5,
      anon_sym_LBRACK_LT,
      anon_sym_QMARK,
      anon_sym_LBRACE_PIPE,
      anon_sym_CARET,
      anon_sym_SQUOTE,
  [152587] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5628), 1,
      anon_sym_COLON,
    STATE(5364), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5630), 8,
      sym__newline,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
  [152628] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6871), 1,
      anon_sym_DASH_GT,
    ACTIONS(6873), 1,
      anon_sym_STAR,
    ACTIONS(6875), 1,
      anon_sym_LT2,
    ACTIONS(6877), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(7353), 1,
      sym_identifier,
    ACTIONS(8156), 1,
      anon_sym_RPAREN,
    STATE(4859), 1,
      aux_sym_compound_type_repeat1,
    STATE(4991), 1,
      sym_long_identifier,
    STATE(5160), 1,
      sym_type_arguments,
    STATE(5365), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [152683] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5634), 1,
      anon_sym_COLON,
    STATE(5366), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5636), 8,
      sym__newline,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
  [152724] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6871), 1,
      anon_sym_DASH_GT,
    ACTIONS(6873), 1,
      anon_sym_STAR,
    ACTIONS(6875), 1,
      anon_sym_LT2,
    ACTIONS(6877), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(7353), 1,
      sym_identifier,
    ACTIONS(8158), 1,
      anon_sym_GT,
    STATE(4859), 1,
      aux_sym_compound_type_repeat1,
    STATE(4991), 1,
      sym_long_identifier,
    STATE(5160), 1,
      sym_type_arguments,
    STATE(5367), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [152779] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6871), 1,
      anon_sym_DASH_GT,
    ACTIONS(6873), 1,
      anon_sym_STAR,
    ACTIONS(6875), 1,
      anon_sym_LT2,
    ACTIONS(6877), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(7353), 1,
      sym_identifier,
    ACTIONS(8160), 1,
      anon_sym_GT,
    STATE(4859), 1,
      aux_sym_compound_type_repeat1,
    STATE(4991), 1,
      sym_long_identifier,
    STATE(5160), 1,
      sym_type_arguments,
    STATE(5368), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [152834] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6871), 1,
      anon_sym_DASH_GT,
    ACTIONS(6873), 1,
      anon_sym_STAR,
    ACTIONS(6875), 1,
      anon_sym_LT2,
    ACTIONS(6877), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(7353), 1,
      sym_identifier,
    ACTIONS(8162), 1,
      anon_sym_RPAREN,
    STATE(4859), 1,
      aux_sym_compound_type_repeat1,
    STATE(4991), 1,
      sym_long_identifier,
    STATE(5160), 1,
      sym_type_arguments,
    STATE(5369), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [152889] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5638), 1,
      anon_sym_COLON,
    STATE(5370), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5640), 8,
      sym__newline,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
  [152930] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5624), 1,
      anon_sym_COLON,
    STATE(5371), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5626), 8,
      sym__newline,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
  [152971] = 13,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(133), 1,
      sym_line_comment,
    ACTIONS(6818), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(6820), 1,
      anon_sym_POUNDlight,
    ACTIONS(6822), 1,
      anon_sym_POUNDr,
    ACTIONS(8164), 1,
      anon_sym_DQUOTE2,
    STATE(5318), 1,
      aux_sym_verbatim_string_repeat1,
    STATE(5574), 1,
      sym__verbatim_string_char,
    STATE(5575), 1,
      sym__simple_string_char,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7892), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(7890), 3,
      sym__non_escape_char,
      anon_sym_BSLASH,
      aux_sym__verbatim_string_char_token1,
    STATE(5372), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [153018] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5642), 1,
      anon_sym_COLON,
    STATE(5373), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5644), 8,
      sym__newline,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
  [153059] = 9,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(133), 1,
      sym_line_comment,
    ACTIONS(6818), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(6820), 1,
      anon_sym_POUNDlight,
    ACTIONS(6822), 1,
      anon_sym_POUNDr,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7876), 4,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
      anon_sym_DQUOTE,
    STATE(5374), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7874), 5,
      sym__inside_string_marker,
      sym__escape_char,
      sym__non_escape_char,
      aux_sym__simple_string_char_token1,
      anon_sym_DQUOTEB,
  [153098] = 9,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(133), 1,
      sym_line_comment,
    ACTIONS(6818), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(6820), 1,
      anon_sym_POUNDlight,
    ACTIONS(6822), 1,
      anon_sym_POUNDr,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7866), 4,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
      anon_sym_DQUOTE,
    STATE(5375), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(7864), 5,
      sym__inside_string_marker,
      sym__escape_char,
      sym__non_escape_char,
      aux_sym__simple_string_char_token1,
      anon_sym_DQUOTEB,
  [153137] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6871), 1,
      anon_sym_DASH_GT,
    ACTIONS(6873), 1,
      anon_sym_STAR,
    ACTIONS(6875), 1,
      anon_sym_LT2,
    ACTIONS(6877), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(7353), 1,
      sym_identifier,
    ACTIONS(8166), 1,
      anon_sym_RPAREN,
    STATE(4859), 1,
      aux_sym_compound_type_repeat1,
    STATE(4991), 1,
      sym_long_identifier,
    STATE(5160), 1,
      sym_type_arguments,
    STATE(5376), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [153192] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2859), 1,
      anon_sym_COLON,
    STATE(5377), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2861), 8,
      sym__newline,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
  [153233] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6871), 1,
      anon_sym_DASH_GT,
    ACTIONS(6873), 1,
      anon_sym_STAR,
    ACTIONS(6875), 1,
      anon_sym_LT2,
    ACTIONS(6877), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(7353), 1,
      sym_identifier,
    ACTIONS(8168), 1,
      anon_sym_RPAREN,
    STATE(4859), 1,
      aux_sym_compound_type_repeat1,
    STATE(4991), 1,
      sym_long_identifier,
    STATE(5160), 1,
      sym_type_arguments,
    STATE(5378), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [153288] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6871), 1,
      anon_sym_DASH_GT,
    ACTIONS(6873), 1,
      anon_sym_STAR,
    ACTIONS(6875), 1,
      anon_sym_LT2,
    ACTIONS(6877), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(7353), 1,
      sym_identifier,
    ACTIONS(8170), 1,
      anon_sym_COMMA,
    STATE(4859), 1,
      aux_sym_compound_type_repeat1,
    STATE(4991), 1,
      sym_long_identifier,
    STATE(5160), 1,
      sym_type_arguments,
    STATE(5379), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [153343] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5537), 1,
      anon_sym_COLON,
    STATE(5315), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(5380), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5539), 7,
      sym__newline,
      sym__dedent,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
  [153386] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6871), 1,
      anon_sym_DASH_GT,
    ACTIONS(6873), 1,
      anon_sym_STAR,
    ACTIONS(6875), 1,
      anon_sym_LT2,
    ACTIONS(6877), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(7353), 1,
      sym_identifier,
    ACTIONS(8172), 1,
      anon_sym_RPAREN,
    STATE(4859), 1,
      aux_sym_compound_type_repeat1,
    STATE(4991), 1,
      sym_long_identifier,
    STATE(5160), 1,
      sym_type_arguments,
    STATE(5381), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [153441] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6871), 1,
      anon_sym_DASH_GT,
    ACTIONS(6873), 1,
      anon_sym_STAR,
    ACTIONS(6875), 1,
      anon_sym_LT2,
    ACTIONS(6877), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(7353), 1,
      sym_identifier,
    ACTIONS(8174), 1,
      anon_sym_RPAREN,
    STATE(4859), 1,
      aux_sym_compound_type_repeat1,
    STATE(4991), 1,
      sym_long_identifier,
    STATE(5160), 1,
      sym_type_arguments,
    STATE(5382), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [153496] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5558), 1,
      anon_sym_COLON,
    STATE(5315), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(5383), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5560), 7,
      sym__newline,
      sym__dedent,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
  [153539] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6871), 1,
      anon_sym_DASH_GT,
    ACTIONS(6873), 1,
      anon_sym_STAR,
    ACTIONS(6875), 1,
      anon_sym_LT2,
    ACTIONS(6877), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(7353), 1,
      sym_identifier,
    ACTIONS(8176), 1,
      anon_sym_RPAREN,
    STATE(4859), 1,
      aux_sym_compound_type_repeat1,
    STATE(4991), 1,
      sym_long_identifier,
    STATE(5160), 1,
      sym_type_arguments,
    STATE(5384), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [153594] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8178), 1,
      anon_sym_LPAREN,
    ACTIONS(8182), 1,
      anon_sym_not,
    ACTIONS(8184), 1,
      anon_sym_enum,
    ACTIONS(8186), 1,
      anon_sym_delegate,
    STATE(5385), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(8180), 5,
      anon_sym_null,
      anon_sym_struct,
      anon_sym_unmanaged,
      anon_sym_equality,
      anon_sym_comparison,
  [153641] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5562), 1,
      anon_sym_COLON,
    STATE(5315), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(5386), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5564), 7,
      sym__newline,
      sym__dedent,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
  [153684] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5503), 1,
      anon_sym_COLON,
    STATE(5315), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(5387), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5505), 7,
      sym__newline,
      sym__dedent,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
  [153727] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6871), 1,
      anon_sym_DASH_GT,
    ACTIONS(6873), 1,
      anon_sym_STAR,
    ACTIONS(6875), 1,
      anon_sym_LT2,
    ACTIONS(6877), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(7353), 1,
      sym_identifier,
    ACTIONS(8188), 1,
      anon_sym_RPAREN,
    STATE(4859), 1,
      aux_sym_compound_type_repeat1,
    STATE(4991), 1,
      sym_long_identifier,
    STATE(5160), 1,
      sym_type_arguments,
    STATE(5388), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [153782] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2158), 1,
      anon_sym_COLON,
    STATE(5389), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2160), 8,
      sym__newline,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
  [153823] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6871), 1,
      anon_sym_DASH_GT,
    ACTIONS(6873), 1,
      anon_sym_STAR,
    ACTIONS(6875), 1,
      anon_sym_LT2,
    ACTIONS(6877), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(7353), 1,
      sym_identifier,
    ACTIONS(8190), 1,
      anon_sym_RPAREN,
    STATE(4859), 1,
      aux_sym_compound_type_repeat1,
    STATE(4991), 1,
      sym_long_identifier,
    STATE(5160), 1,
      sym_type_arguments,
    STATE(5390), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [153878] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6871), 1,
      anon_sym_DASH_GT,
    ACTIONS(6873), 1,
      anon_sym_STAR,
    ACTIONS(6875), 1,
      anon_sym_LT2,
    ACTIONS(6877), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(7353), 1,
      sym_identifier,
    ACTIONS(8192), 1,
      anon_sym_RPAREN,
    STATE(4859), 1,
      aux_sym_compound_type_repeat1,
    STATE(4991), 1,
      sym_long_identifier,
    STATE(5160), 1,
      sym_type_arguments,
    STATE(5391), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [153933] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6871), 1,
      anon_sym_DASH_GT,
    ACTIONS(6873), 1,
      anon_sym_STAR,
    ACTIONS(6875), 1,
      anon_sym_LT2,
    ACTIONS(6877), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(7353), 1,
      sym_identifier,
    ACTIONS(8194), 1,
      anon_sym_GT,
    STATE(4859), 1,
      aux_sym_compound_type_repeat1,
    STATE(4991), 1,
      sym_long_identifier,
    STATE(5160), 1,
      sym_type_arguments,
    STATE(5392), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [153988] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3115), 1,
      anon_sym_COLON,
    STATE(5393), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3117), 8,
      sym__newline,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
  [154029] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5474), 1,
      anon_sym_COLON,
    STATE(5315), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(5394), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5476), 7,
      sym__newline,
      sym__dedent,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
  [154072] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6871), 1,
      anon_sym_DASH_GT,
    ACTIONS(6873), 1,
      anon_sym_STAR,
    ACTIONS(6875), 1,
      anon_sym_LT2,
    ACTIONS(6877), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(7353), 1,
      sym_identifier,
    ACTIONS(8196), 1,
      anon_sym_GT,
    STATE(4859), 1,
      aux_sym_compound_type_repeat1,
    STATE(4991), 1,
      sym_long_identifier,
    STATE(5160), 1,
      sym_type_arguments,
    STATE(5395), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [154127] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2843), 1,
      anon_sym_COLON,
    STATE(5396), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2845), 8,
      sym__newline,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
  [154168] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7749), 1,
      anon_sym_COMMA,
    ACTIONS(7751), 1,
      anon_sym_as,
    ACTIONS(7753), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7755), 1,
      anon_sym_PIPE,
    ACTIONS(7757), 1,
      anon_sym_AMP,
    ACTIONS(7805), 1,
      anon_sym_COLON,
    ACTIONS(7831), 1,
      sym__newline,
    ACTIONS(8198), 1,
      anon_sym_RPAREN,
    STATE(5153), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(5397), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [154223] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2966), 1,
      anon_sym_COLON,
    STATE(5398), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2968), 8,
      sym__newline,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
  [154264] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6871), 1,
      anon_sym_DASH_GT,
    ACTIONS(6873), 1,
      anon_sym_STAR,
    ACTIONS(6875), 1,
      anon_sym_LT2,
    ACTIONS(6877), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(7353), 1,
      sym_identifier,
    ACTIONS(8200), 1,
      anon_sym_RPAREN,
    STATE(4859), 1,
      aux_sym_compound_type_repeat1,
    STATE(4991), 1,
      sym_long_identifier,
    STATE(5160), 1,
      sym_type_arguments,
    STATE(5399), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [154319] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2563), 2,
      anon_sym_val,
      sym_identifier,
    STATE(5400), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2565), 7,
      ts_builtin_sym_end,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [154360] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2553), 2,
      anon_sym_val,
      sym_identifier,
    STATE(5401), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2555), 7,
      ts_builtin_sym_end,
      anon_sym_EQ,
      anon_sym_LBRACK_LT,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [154401] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6871), 1,
      anon_sym_DASH_GT,
    ACTIONS(6873), 1,
      anon_sym_STAR,
    ACTIONS(6875), 1,
      anon_sym_LT2,
    ACTIONS(6877), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(7353), 1,
      sym_identifier,
    ACTIONS(8202), 1,
      anon_sym_RPAREN,
    STATE(4859), 1,
      aux_sym_compound_type_repeat1,
    STATE(4991), 1,
      sym_long_identifier,
    STATE(5160), 1,
      sym_type_arguments,
    STATE(5402), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [154456] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6871), 1,
      anon_sym_DASH_GT,
    ACTIONS(6873), 1,
      anon_sym_STAR,
    ACTIONS(6875), 1,
      anon_sym_LT2,
    ACTIONS(6877), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(7353), 1,
      sym_identifier,
    ACTIONS(8204), 1,
      anon_sym_RPAREN,
    STATE(4859), 1,
      aux_sym_compound_type_repeat1,
    STATE(4991), 1,
      sym_long_identifier,
    STATE(5160), 1,
      sym_type_arguments,
    STATE(5403), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [154511] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7528), 1,
      anon_sym_as,
    ACTIONS(7809), 1,
      anon_sym_COLON,
    ACTIONS(7811), 1,
      anon_sym_COMMA,
    ACTIONS(7813), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7815), 1,
      anon_sym_PIPE,
    ACTIONS(7817), 1,
      anon_sym_AMP,
    ACTIONS(8206), 1,
      anon_sym_DASH_GT,
    ACTIONS(8208), 1,
      anon_sym_when,
    STATE(5236), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(5404), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [154566] = 17,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(3570), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(7263), 1,
      sym_identifier,
    ACTIONS(7269), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(7271), 1,
      sym_op_identifier,
    STATE(2288), 1,
      sym_property_or_ident,
    STATE(3772), 1,
      sym__identifier_or_op,
    STATE(3773), 1,
      sym_active_pattern,
    STATE(4911), 1,
      sym_method_or_prop_defn,
    STATE(5532), 1,
      sym_access_modifier,
    STATE(5405), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [154621] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6871), 1,
      anon_sym_DASH_GT,
    ACTIONS(6873), 1,
      anon_sym_STAR,
    ACTIONS(6875), 1,
      anon_sym_LT2,
    ACTIONS(6877), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(7353), 1,
      sym_identifier,
    ACTIONS(8210), 1,
      anon_sym_COMMA,
    STATE(4859), 1,
      aux_sym_compound_type_repeat1,
    STATE(4991), 1,
      sym_long_identifier,
    STATE(5160), 1,
      sym_type_arguments,
    STATE(5406), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [154676] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6871), 1,
      anon_sym_DASH_GT,
    ACTIONS(6873), 1,
      anon_sym_STAR,
    ACTIONS(6875), 1,
      anon_sym_LT2,
    ACTIONS(6877), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(7353), 1,
      sym_identifier,
    ACTIONS(8212), 1,
      anon_sym_RPAREN,
    STATE(4859), 1,
      aux_sym_compound_type_repeat1,
    STATE(4991), 1,
      sym_long_identifier,
    STATE(5160), 1,
      sym_type_arguments,
    STATE(5407), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [154731] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2984), 1,
      anon_sym_COLON,
    STATE(5408), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2986), 8,
      sym__newline,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
  [154772] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6871), 1,
      anon_sym_DASH_GT,
    ACTIONS(6873), 1,
      anon_sym_STAR,
    ACTIONS(6875), 1,
      anon_sym_LT2,
    ACTIONS(6877), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(7353), 1,
      sym_identifier,
    ACTIONS(8214), 1,
      anon_sym_EQ,
    STATE(4859), 1,
      aux_sym_compound_type_repeat1,
    STATE(4991), 1,
      sym_long_identifier,
    STATE(5160), 1,
      sym_type_arguments,
    STATE(5409), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [154827] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6871), 1,
      anon_sym_DASH_GT,
    ACTIONS(6873), 1,
      anon_sym_STAR,
    ACTIONS(6875), 1,
      anon_sym_LT2,
    ACTIONS(6877), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(7353), 1,
      sym_identifier,
    ACTIONS(8216), 1,
      anon_sym_RPAREN,
    STATE(4859), 1,
      aux_sym_compound_type_repeat1,
    STATE(4991), 1,
      sym_long_identifier,
    STATE(5160), 1,
      sym_type_arguments,
    STATE(5410), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [154882] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5431), 1,
      anon_sym_COLON,
    STATE(5315), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(5411), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5433), 7,
      sym__newline,
      sym__dedent,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
  [154925] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6871), 1,
      anon_sym_DASH_GT,
    ACTIONS(6873), 1,
      anon_sym_STAR,
    ACTIONS(6875), 1,
      anon_sym_LT2,
    ACTIONS(6877), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(7353), 1,
      sym_identifier,
    ACTIONS(8218), 1,
      anon_sym_RPAREN,
    STATE(4859), 1,
      aux_sym_compound_type_repeat1,
    STATE(4991), 1,
      sym_long_identifier,
    STATE(5160), 1,
      sym_type_arguments,
    STATE(5412), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [154980] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2934), 1,
      anon_sym_COLON,
    STATE(5413), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2936), 8,
      sym__newline,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
  [155021] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5652), 1,
      anon_sym_COLON,
    STATE(5414), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5654), 8,
      sym__newline,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_RBRACE,
  [155062] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5572), 1,
      anon_sym_COLON,
    ACTIONS(8220), 1,
      anon_sym_LT2,
    STATE(5415), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5574), 7,
      sym__newline,
      sym__dedent,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
  [155105] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6871), 1,
      anon_sym_DASH_GT,
    ACTIONS(6873), 1,
      anon_sym_STAR,
    ACTIONS(6875), 1,
      anon_sym_LT2,
    ACTIONS(6877), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(7353), 1,
      sym_identifier,
    ACTIONS(8222), 1,
      anon_sym_RPAREN,
    STATE(4859), 1,
      aux_sym_compound_type_repeat1,
    STATE(4991), 1,
      sym_long_identifier,
    STATE(5160), 1,
      sym_type_arguments,
    STATE(5416), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [155160] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6871), 1,
      anon_sym_DASH_GT,
    ACTIONS(6873), 1,
      anon_sym_STAR,
    ACTIONS(6875), 1,
      anon_sym_LT2,
    ACTIONS(6877), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(7353), 1,
      sym_identifier,
    ACTIONS(8224), 1,
      anon_sym_RPAREN,
    STATE(4859), 1,
      aux_sym_compound_type_repeat1,
    STATE(4991), 1,
      sym_long_identifier,
    STATE(5160), 1,
      sym_type_arguments,
    STATE(5417), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [155215] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(23), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(25), 1,
      anon_sym_val,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8226), 1,
      ts_builtin_sym_end,
    STATE(4305), 1,
      aux_sym_attributes_repeat1,
    STATE(4488), 1,
      sym__attribute_set,
    STATE(5239), 1,
      aux_sym_file_repeat1,
    STATE(5762), 1,
      sym__module_signature_elements,
    STATE(5763), 1,
      sym_value_definition,
    STATE(7536), 1,
      sym_attributes,
    STATE(5418), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [155270] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7528), 1,
      anon_sym_as,
    ACTIONS(7809), 1,
      anon_sym_COLON,
    ACTIONS(7811), 1,
      anon_sym_COMMA,
    ACTIONS(7813), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7815), 1,
      anon_sym_PIPE,
    ACTIONS(7817), 1,
      anon_sym_AMP,
    ACTIONS(8228), 1,
      anon_sym_DASH_GT,
    ACTIONS(8230), 1,
      anon_sym_when,
    STATE(5236), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(5419), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [155325] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6871), 1,
      anon_sym_DASH_GT,
    ACTIONS(6873), 1,
      anon_sym_STAR,
    ACTIONS(6875), 1,
      anon_sym_LT2,
    ACTIONS(6877), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(7353), 1,
      sym_identifier,
    ACTIONS(8232), 1,
      anon_sym_RPAREN,
    STATE(4859), 1,
      aux_sym_compound_type_repeat1,
    STATE(4991), 1,
      sym_long_identifier,
    STATE(5160), 1,
      sym_type_arguments,
    STATE(5420), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [155380] = 17,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(23), 1,
      anon_sym_LBRACK_LT,
    ACTIONS(25), 1,
      anon_sym_val,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8234), 1,
      ts_builtin_sym_end,
    STATE(4305), 1,
      aux_sym_attributes_repeat1,
    STATE(4488), 1,
      sym__attribute_set,
    STATE(5186), 1,
      aux_sym_file_repeat1,
    STATE(5762), 1,
      sym__module_signature_elements,
    STATE(5763), 1,
      sym_value_definition,
    STATE(7536), 1,
      sym_attributes,
    STATE(5421), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [155435] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5605), 1,
      anon_sym_COLON,
    STATE(5422), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5607), 7,
      sym__newline,
      sym__dedent,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
  [155475] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2855), 1,
      anon_sym_COLON,
    STATE(5423), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2857), 7,
      sym__newline,
      sym__dedent,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
  [155515] = 16,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7528), 1,
      anon_sym_as,
    ACTIONS(8236), 1,
      anon_sym_COLON,
    ACTIONS(8238), 1,
      anon_sym_COMMA,
    ACTIONS(8240), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8242), 1,
      anon_sym_PIPE,
    ACTIONS(8244), 1,
      anon_sym_AMP,
    ACTIONS(8246), 1,
      anon_sym_in,
    STATE(5461), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(5424), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [155567] = 16,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7528), 1,
      anon_sym_as,
    ACTIONS(8236), 1,
      anon_sym_COLON,
    ACTIONS(8238), 1,
      anon_sym_COMMA,
    ACTIONS(8240), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8242), 1,
      anon_sym_PIPE,
    ACTIONS(8244), 1,
      anon_sym_AMP,
    ACTIONS(8248), 1,
      anon_sym_in,
    STATE(5461), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(5425), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [155619] = 16,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7528), 1,
      anon_sym_as,
    ACTIONS(8236), 1,
      anon_sym_COLON,
    ACTIONS(8238), 1,
      anon_sym_COMMA,
    ACTIONS(8240), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8242), 1,
      anon_sym_PIPE,
    ACTIONS(8244), 1,
      anon_sym_AMP,
    ACTIONS(8250), 1,
      anon_sym_in,
    STATE(5461), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(5426), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [155671] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7392), 1,
      anon_sym_STAR,
    STATE(5445), 1,
      aux_sym_compound_type_repeat1,
    ACTIONS(2407), 2,
      anon_sym_and,
      sym_identifier,
    ACTIONS(2409), 4,
      anon_sym_DASH_GT,
      anon_sym_GT,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
    STATE(5427), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [155715] = 16,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7528), 1,
      anon_sym_as,
    ACTIONS(8236), 1,
      anon_sym_COLON,
    ACTIONS(8238), 1,
      anon_sym_COMMA,
    ACTIONS(8240), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8242), 1,
      anon_sym_PIPE,
    ACTIONS(8244), 1,
      anon_sym_AMP,
    ACTIONS(8252), 1,
      anon_sym_in,
    STATE(5461), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(5428), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [155767] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5665), 1,
      anon_sym_COLON,
    STATE(5429), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5667), 7,
      sym__newline,
      sym__dedent,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
  [155807] = 15,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6875), 1,
      anon_sym_LT2,
    ACTIONS(6877), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(7353), 1,
      sym_identifier,
    STATE(4859), 1,
      aux_sym_compound_type_repeat1,
    STATE(4991), 1,
      sym_long_identifier,
    STATE(5160), 1,
      sym_type_arguments,
    ACTIONS(8254), 2,
      anon_sym_DASH_GT,
      anon_sym_STAR,
    STATE(5430), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [155857] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5661), 1,
      anon_sym_COLON,
    STATE(5431), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5663), 7,
      sym__newline,
      sym__dedent,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
  [155897] = 16,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7528), 1,
      anon_sym_as,
    ACTIONS(8236), 1,
      anon_sym_COLON,
    ACTIONS(8238), 1,
      anon_sym_COMMA,
    ACTIONS(8240), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8242), 1,
      anon_sym_PIPE,
    ACTIONS(8244), 1,
      anon_sym_AMP,
    ACTIONS(8256), 1,
      anon_sym_in,
    STATE(5461), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(5432), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [155949] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6370), 1,
      anon_sym_COLON,
    ACTIONS(6962), 1,
      anon_sym_DOT,
    STATE(4710), 1,
      aux_sym_long_identifier_repeat1,
    STATE(5433), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2314), 5,
      anon_sym_DASH_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
      sym_identifier,
  [155993] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5580), 1,
      anon_sym_COLON,
    STATE(5434), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5582), 7,
      sym__newline,
      sym__dedent,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
  [156033] = 16,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5491), 1,
      anon_sym_COLON,
    ACTIONS(5493), 1,
      anon_sym_in,
    ACTIONS(7528), 1,
      anon_sym_as,
    ACTIONS(8238), 1,
      anon_sym_COMMA,
    ACTIONS(8240), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8242), 1,
      anon_sym_PIPE,
    ACTIONS(8244), 1,
      anon_sym_AMP,
    STATE(5461), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(5435), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [156085] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5584), 1,
      anon_sym_COLON,
    STATE(5436), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5586), 7,
      sym__newline,
      sym__dedent,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
  [156125] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5503), 1,
      anon_sym_COLON,
    ACTIONS(8258), 1,
      anon_sym_COMMA,
    ACTIONS(5505), 5,
      anon_sym_as,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_in,
    STATE(5437), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_repeat_pattern_repeat1,
  [156167] = 16,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7528), 1,
      anon_sym_as,
    ACTIONS(8236), 1,
      anon_sym_COLON,
    ACTIONS(8238), 1,
      anon_sym_COMMA,
    ACTIONS(8240), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8242), 1,
      anon_sym_PIPE,
    ACTIONS(8244), 1,
      anon_sym_AMP,
    ACTIONS(8261), 1,
      anon_sym_in,
    STATE(5461), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(5438), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [156219] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5431), 1,
      anon_sym_COLON,
    STATE(5461), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(5439), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5433), 6,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_in,
  [156261] = 16,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7528), 1,
      anon_sym_as,
    ACTIONS(8236), 1,
      anon_sym_COLON,
    ACTIONS(8238), 1,
      anon_sym_COMMA,
    ACTIONS(8240), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8242), 1,
      anon_sym_PIPE,
    ACTIONS(8244), 1,
      anon_sym_AMP,
    ACTIONS(8263), 1,
      anon_sym_in,
    STATE(5461), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(5440), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [156313] = 16,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7528), 1,
      anon_sym_as,
    ACTIONS(8236), 1,
      anon_sym_COLON,
    ACTIONS(8238), 1,
      anon_sym_COMMA,
    ACTIONS(8240), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8242), 1,
      anon_sym_PIPE,
    ACTIONS(8244), 1,
      anon_sym_AMP,
    ACTIONS(8265), 1,
      anon_sym_in,
    STATE(5461), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(5441), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [156365] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5474), 1,
      anon_sym_COLON,
    STATE(5461), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(5442), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5476), 6,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_in,
  [156407] = 16,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7528), 1,
      anon_sym_as,
    ACTIONS(8236), 1,
      anon_sym_COLON,
    ACTIONS(8238), 1,
      anon_sym_COMMA,
    ACTIONS(8240), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8242), 1,
      anon_sym_PIPE,
    ACTIONS(8244), 1,
      anon_sym_AMP,
    ACTIONS(8267), 1,
      anon_sym_in,
    STATE(5461), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(5443), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [156459] = 16,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7528), 1,
      anon_sym_as,
    ACTIONS(8236), 1,
      anon_sym_COLON,
    ACTIONS(8238), 1,
      anon_sym_COMMA,
    ACTIONS(8240), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8242), 1,
      anon_sym_PIPE,
    ACTIONS(8244), 1,
      anon_sym_AMP,
    ACTIONS(8269), 1,
      anon_sym_in,
    STATE(5461), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(5444), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [156511] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8271), 1,
      anon_sym_STAR,
    ACTIONS(2250), 2,
      anon_sym_and,
      sym_identifier,
    ACTIONS(2248), 4,
      anon_sym_DASH_GT,
      anon_sym_GT,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
    STATE(5445), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_compound_type_repeat1,
  [156553] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5628), 1,
      anon_sym_COLON,
    STATE(5446), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5630), 7,
      sym__newline,
      sym__dedent,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
  [156593] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5634), 1,
      anon_sym_COLON,
    STATE(5447), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5636), 7,
      sym__newline,
      sym__dedent,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
  [156633] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5646), 1,
      anon_sym_COLON,
    ACTIONS(8274), 1,
      anon_sym_as,
    STATE(5448), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5648), 6,
      sym__newline,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
  [156675] = 16,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7528), 1,
      anon_sym_as,
    ACTIONS(8236), 1,
      anon_sym_COLON,
    ACTIONS(8238), 1,
      anon_sym_COMMA,
    ACTIONS(8240), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8242), 1,
      anon_sym_PIPE,
    ACTIONS(8244), 1,
      anon_sym_AMP,
    ACTIONS(8276), 1,
      anon_sym_in,
    STATE(5461), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(5449), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [156727] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5638), 1,
      anon_sym_COLON,
    STATE(5450), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5640), 7,
      sym__newline,
      sym__dedent,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
  [156767] = 16,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7528), 1,
      anon_sym_as,
    ACTIONS(8236), 1,
      anon_sym_COLON,
    ACTIONS(8238), 1,
      anon_sym_COMMA,
    ACTIONS(8240), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8242), 1,
      anon_sym_PIPE,
    ACTIONS(8244), 1,
      anon_sym_AMP,
    ACTIONS(8278), 1,
      anon_sym_in,
    STATE(5461), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(5451), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [156819] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5642), 1,
      anon_sym_COLON,
    STATE(5452), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5644), 7,
      sym__newline,
      sym__dedent,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
  [156859] = 16,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7528), 1,
      anon_sym_as,
    ACTIONS(7530), 1,
      anon_sym_COMMA,
    ACTIONS(7532), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7534), 1,
      anon_sym_PIPE,
    ACTIONS(7536), 1,
      anon_sym_AMP,
    ACTIONS(8280), 1,
      anon_sym_EQ,
    ACTIONS(8282), 1,
      anon_sym_COLON,
    STATE(5027), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(5453), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [156911] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2411), 2,
      anon_sym_and,
      sym_identifier,
    STATE(5454), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2413), 6,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [156951] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5503), 1,
      anon_sym_COLON,
    STATE(5461), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(5455), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5505), 6,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_in,
  [156993] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5558), 1,
      anon_sym_COLON,
    STATE(5461), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(5456), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5560), 6,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_in,
  [157035] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5537), 1,
      anon_sym_COLON,
    STATE(5461), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(5457), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5539), 6,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_in,
  [157077] = 16,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7528), 1,
      anon_sym_as,
    ACTIONS(8236), 1,
      anon_sym_COLON,
    ACTIONS(8238), 1,
      anon_sym_COMMA,
    ACTIONS(8240), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8242), 1,
      anon_sym_PIPE,
    ACTIONS(8244), 1,
      anon_sym_AMP,
    ACTIONS(8284), 1,
      anon_sym_in,
    STATE(5461), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(5458), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [157129] = 16,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7528), 1,
      anon_sym_as,
    ACTIONS(8236), 1,
      anon_sym_COLON,
    ACTIONS(8238), 1,
      anon_sym_COMMA,
    ACTIONS(8240), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8242), 1,
      anon_sym_PIPE,
    ACTIONS(8244), 1,
      anon_sym_AMP,
    ACTIONS(8286), 1,
      anon_sym_in,
    STATE(5461), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(5459), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [157181] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5652), 1,
      anon_sym_COLON,
    STATE(5460), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5654), 7,
      sym__newline,
      sym__dedent,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
  [157221] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5531), 1,
      anon_sym_COLON,
    ACTIONS(8238), 1,
      anon_sym_COMMA,
    STATE(5437), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(5461), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5533), 5,
      anon_sym_as,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_in,
  [157265] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2321), 2,
      anon_sym_and,
      sym_identifier,
    STATE(5462), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2323), 6,
      anon_sym_COLON_GT,
      anon_sym_DASH_GT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [157305] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5562), 1,
      anon_sym_COLON,
    STATE(5461), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(5463), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5564), 6,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_in,
  [157347] = 16,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7528), 1,
      anon_sym_as,
    ACTIONS(8236), 1,
      anon_sym_COLON,
    ACTIONS(8238), 1,
      anon_sym_COMMA,
    ACTIONS(8240), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8242), 1,
      anon_sym_PIPE,
    ACTIONS(8244), 1,
      anon_sym_AMP,
    ACTIONS(8288), 1,
      anon_sym_in,
    STATE(5461), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(5464), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [157399] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5618), 1,
      anon_sym_COLON,
    STATE(5465), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5620), 7,
      sym__newline,
      sym__dedent,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
  [157439] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8290), 1,
      anon_sym_COLON_GT,
    ACTIONS(2567), 2,
      anon_sym_and,
      sym_identifier,
    STATE(5466), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2569), 5,
      anon_sym_DASH_GT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [157481] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5572), 1,
      anon_sym_COLON,
    STATE(5467), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5574), 7,
      sym__newline,
      sym__dedent,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
  [157521] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5609), 1,
      anon_sym_COLON,
    STATE(5468), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5611), 7,
      sym__newline,
      sym__dedent,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
  [157561] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5598), 1,
      anon_sym_COLON,
    STATE(5469), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5600), 7,
      sym__newline,
      sym__dedent,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
  [157601] = 15,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6875), 1,
      anon_sym_LT2,
    ACTIONS(6877), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(7353), 1,
      sym_identifier,
    STATE(4859), 1,
      aux_sym_compound_type_repeat1,
    STATE(4991), 1,
      sym_long_identifier,
    STATE(5160), 1,
      sym_type_arguments,
    ACTIONS(6353), 2,
      anon_sym_DASH_GT,
      anon_sym_STAR,
    STATE(5470), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [157651] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5624), 1,
      anon_sym_COLON,
    STATE(5471), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5626), 7,
      sym__newline,
      sym__dedent,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
  [157691] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5594), 1,
      anon_sym_COLON,
    STATE(5472), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5596), 7,
      sym__newline,
      sym__dedent,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
  [157731] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3095), 1,
      anon_sym_COLON,
    STATE(5473), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3097), 7,
      sym__newline,
      sym__dedent,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
  [157771] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2843), 1,
      anon_sym_COLON,
    STATE(5474), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2845), 7,
      sym__newline,
      sym__dedent,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
  [157811] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2158), 1,
      anon_sym_COLON,
    STATE(5475), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2160), 7,
      sym__newline,
      sym__dedent,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
  [157851] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5590), 1,
      anon_sym_COLON,
    STATE(5476), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(5592), 7,
      sym__newline,
      sym__dedent,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
  [157891] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2859), 1,
      anon_sym_COLON,
    STATE(5477), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2861), 7,
      sym__newline,
      sym__dedent,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
  [157931] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2873), 1,
      anon_sym_COLON,
    STATE(5478), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2875), 7,
      sym__newline,
      sym__dedent,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
  [157971] = 16,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7528), 1,
      anon_sym_as,
    ACTIONS(7530), 1,
      anon_sym_COMMA,
    ACTIONS(7532), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7534), 1,
      anon_sym_PIPE,
    ACTIONS(7536), 1,
      anon_sym_AMP,
    ACTIONS(8282), 1,
      anon_sym_COLON,
    ACTIONS(8292), 1,
      anon_sym_EQ,
    STATE(5027), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(5479), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [158023] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2877), 1,
      anon_sym_COLON,
    STATE(5480), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2879), 7,
      sym__newline,
      sym__dedent,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
  [158063] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2883), 1,
      anon_sym_COLON,
    STATE(5481), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2885), 7,
      sym__newline,
      sym__dedent,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
  [158103] = 16,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7528), 1,
      anon_sym_as,
    ACTIONS(7530), 1,
      anon_sym_COMMA,
    ACTIONS(7532), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7534), 1,
      anon_sym_PIPE,
    ACTIONS(7536), 1,
      anon_sym_AMP,
    ACTIONS(8282), 1,
      anon_sym_COLON,
    ACTIONS(8294), 1,
      anon_sym_RPAREN,
    STATE(5027), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(5482), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [158155] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2887), 1,
      anon_sym_COLON,
    STATE(5483), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2889), 7,
      sym__newline,
      sym__dedent,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
  [158195] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2891), 1,
      anon_sym_COLON,
    STATE(5484), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2893), 7,
      sym__newline,
      sym__dedent,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
  [158235] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2910), 1,
      anon_sym_COLON,
    STATE(5485), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2912), 7,
      sym__newline,
      sym__dedent,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
  [158275] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2914), 1,
      anon_sym_COLON,
    STATE(5486), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2916), 7,
      sym__newline,
      sym__dedent,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
  [158315] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2918), 1,
      anon_sym_COLON,
    STATE(5487), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2920), 7,
      sym__newline,
      sym__dedent,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
  [158355] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2922), 1,
      anon_sym_COLON,
    STATE(5488), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2924), 7,
      sym__newline,
      sym__dedent,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
  [158395] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2926), 1,
      anon_sym_COLON,
    STATE(5489), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2928), 7,
      sym__newline,
      sym__dedent,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
  [158435] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2938), 1,
      anon_sym_COLON,
    STATE(5490), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2940), 7,
      sym__newline,
      sym__dedent,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
  [158475] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2946), 1,
      anon_sym_COLON,
    STATE(5491), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2948), 7,
      sym__newline,
      sym__dedent,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
  [158515] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2950), 1,
      anon_sym_COLON,
    STATE(5492), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2952), 7,
      sym__newline,
      sym__dedent,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
  [158555] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2958), 1,
      anon_sym_COLON,
    STATE(5493), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2960), 7,
      sym__newline,
      sym__dedent,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
  [158595] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2962), 1,
      anon_sym_COLON,
    STATE(5494), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2964), 7,
      sym__newline,
      sym__dedent,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
  [158635] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2966), 1,
      anon_sym_COLON,
    STATE(5495), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2968), 7,
      sym__newline,
      sym__dedent,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
  [158675] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2974), 1,
      anon_sym_COLON,
    STATE(5496), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2976), 7,
      sym__newline,
      sym__dedent,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
  [158715] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3019), 1,
      anon_sym_COLON,
    STATE(5497), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3021), 7,
      sym__newline,
      sym__dedent,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
  [158755] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3023), 1,
      anon_sym_COLON,
    STATE(5498), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3025), 7,
      sym__newline,
      sym__dedent,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
  [158795] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3027), 1,
      anon_sym_COLON,
    STATE(5499), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3029), 7,
      sym__newline,
      sym__dedent,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
  [158835] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3031), 1,
      anon_sym_COLON,
    STATE(5500), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3033), 7,
      sym__newline,
      sym__dedent,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
  [158875] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3035), 1,
      anon_sym_COLON,
    STATE(5501), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3037), 7,
      sym__newline,
      sym__dedent,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
  [158915] = 15,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6875), 1,
      anon_sym_LT2,
    ACTIONS(6877), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(7353), 1,
      sym_identifier,
    STATE(4859), 1,
      aux_sym_compound_type_repeat1,
    STATE(4991), 1,
      sym_long_identifier,
    STATE(5160), 1,
      sym_type_arguments,
    ACTIONS(8296), 2,
      anon_sym_DASH_GT,
      anon_sym_STAR,
    STATE(5502), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [158965] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3115), 1,
      anon_sym_COLON,
    STATE(5503), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(3117), 7,
      sym__newline,
      sym__dedent,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
  [159005] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2984), 1,
      anon_sym_COLON,
    STATE(5504), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2986), 7,
      sym__newline,
      sym__dedent,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
  [159045] = 9,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(133), 1,
      sym_line_comment,
    ACTIONS(6818), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(6820), 1,
      anon_sym_POUNDlight,
    ACTIONS(6822), 1,
      anon_sym_POUNDr,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7878), 4,
      sym__inside_string_marker,
      sym__escape_char,
      sym__non_escape_char,
      aux_sym__simple_string_char_token1,
    ACTIONS(7880), 4,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
      anon_sym_DQUOTE,
    STATE(5505), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [159083] = 16,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7528), 1,
      anon_sym_as,
    ACTIONS(8236), 1,
      anon_sym_COLON,
    ACTIONS(8238), 1,
      anon_sym_COMMA,
    ACTIONS(8240), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8242), 1,
      anon_sym_PIPE,
    ACTIONS(8244), 1,
      anon_sym_AMP,
    ACTIONS(8298), 1,
      anon_sym_in,
    STATE(5461), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(5506), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [159135] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2934), 1,
      anon_sym_COLON,
    STATE(5507), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2936), 7,
      sym__newline,
      sym__dedent,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
  [159175] = 16,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7528), 1,
      anon_sym_as,
    ACTIONS(8236), 1,
      anon_sym_COLON,
    ACTIONS(8238), 1,
      anon_sym_COMMA,
    ACTIONS(8240), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8242), 1,
      anon_sym_PIPE,
    ACTIONS(8244), 1,
      anon_sym_AMP,
    ACTIONS(8300), 1,
      anon_sym_in,
    STATE(5461), 1,
      aux_sym_repeat_pattern_repeat1,
    STATE(5508), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [159227] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2321), 1,
      anon_sym_COLON,
    STATE(5509), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2323), 7,
      sym__newline,
      sym__dedent,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_AMP,
  [159267] = 9,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(133), 1,
      sym_line_comment,
    ACTIONS(6818), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(6820), 1,
      anon_sym_POUNDlight,
    ACTIONS(6822), 1,
      anon_sym_POUNDr,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7864), 4,
      sym__inside_string_marker,
      sym__escape_char,
      sym__non_escape_char,
      aux_sym__simple_string_char_token1,
    ACTIONS(7866), 4,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
      anon_sym_DQUOTE,
    STATE(5510), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [159305] = 9,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(133), 1,
      sym_line_comment,
    ACTIONS(6818), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(6820), 1,
      anon_sym_POUNDlight,
    ACTIONS(6822), 1,
      anon_sym_POUNDr,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7874), 4,
      sym__inside_string_marker,
      sym__escape_char,
      sym__non_escape_char,
      aux_sym__simple_string_char_token1,
    ACTIONS(7876), 4,
      sym__unicodegraph_short,
      sym__unicodegraph_long,
      sym__trigraph,
      anon_sym_DQUOTE,
    STATE(5511), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [159343] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2563), 2,
      anon_sym_and,
      sym_identifier,
    STATE(5512), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2565), 5,
      anon_sym_DASH_GT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [159382] = 14,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8302), 1,
      anon_sym__,
    ACTIONS(8304), 1,
      anon_sym_default,
    STATE(4896), 1,
      sym_constraint,
    STATE(5731), 1,
      sym__static_type_identifier,
    STATE(6335), 1,
      sym_type_argument,
    ACTIONS(4521), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5513), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [159429] = 15,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(957), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2054), 1,
      sym_op_identifier,
    ACTIONS(8306), 1,
      sym_identifier,
    STATE(2203), 1,
      sym_long_identifier_or_op,
    STATE(2232), 1,
      sym_long_identifier,
    STATE(2305), 1,
      sym__identifier_or_op,
    STATE(2424), 1,
      sym_active_pattern,
    STATE(5514), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [159478] = 14,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8302), 1,
      anon_sym__,
    ACTIONS(8308), 1,
      anon_sym_default,
    STATE(3349), 1,
      sym_constraint,
    STATE(5731), 1,
      sym__static_type_identifier,
    STATE(6091), 1,
      sym_type_argument,
    ACTIONS(4521), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5515), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [159525] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8312), 3,
      anon_sym_LBRACE_PIPE,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    ACTIONS(8310), 4,
      anon_sym_LPAREN,
      anon_sym__,
      anon_sym_POUND,
      sym_identifier,
    STATE(5516), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [159564] = 14,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8302), 1,
      anon_sym__,
    ACTIONS(8314), 1,
      anon_sym_default,
    STATE(4542), 1,
      sym_constraint,
    STATE(5731), 1,
      sym__static_type_identifier,
    STATE(6268), 1,
      sym_type_argument,
    ACTIONS(4521), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5517), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [159611] = 15,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(1159), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2106), 1,
      sym_op_identifier,
    ACTIONS(8316), 1,
      sym_identifier,
    STATE(2390), 1,
      sym__identifier_or_op,
    STATE(2391), 1,
      sym_long_identifier,
    STATE(2402), 1,
      sym_long_identifier_or_op,
    STATE(2470), 1,
      sym_active_pattern,
    STATE(5518), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [159660] = 14,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8302), 1,
      anon_sym__,
    ACTIONS(8318), 1,
      anon_sym_default,
    STATE(3617), 1,
      sym_constraint,
    STATE(5731), 1,
      sym__static_type_identifier,
    STATE(6168), 1,
      sym_type_argument,
    ACTIONS(4521), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5519), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [159707] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2567), 2,
      anon_sym_and,
      sym_identifier,
    STATE(5520), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2569), 5,
      anon_sym_DASH_GT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [159746] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2553), 2,
      anon_sym_and,
      sym_identifier,
    STATE(5521), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2555), 5,
      anon_sym_DASH_GT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [159785] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8322), 3,
      anon_sym_LBRACE_PIPE,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    ACTIONS(8320), 4,
      anon_sym_LPAREN,
      anon_sym__,
      anon_sym_POUND,
      sym_identifier,
    STATE(5522), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [159824] = 14,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8302), 1,
      anon_sym__,
    ACTIONS(8324), 1,
      anon_sym_default,
    STATE(3373), 1,
      sym_constraint,
    STATE(5731), 1,
      sym__static_type_identifier,
    STATE(6063), 1,
      sym_type_argument,
    ACTIONS(4521), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5523), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [159871] = 14,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8302), 1,
      anon_sym__,
    ACTIONS(8308), 1,
      anon_sym_default,
    STATE(3530), 1,
      sym_constraint,
    STATE(5731), 1,
      sym__static_type_identifier,
    STATE(6091), 1,
      sym_type_argument,
    ACTIONS(4521), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5524), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [159918] = 14,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8302), 1,
      anon_sym__,
    ACTIONS(8326), 1,
      anon_sym_default,
    STATE(4542), 1,
      sym_constraint,
    STATE(5731), 1,
      sym__static_type_identifier,
    STATE(6372), 1,
      sym_type_argument,
    ACTIONS(4521), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5525), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [159965] = 14,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8302), 1,
      anon_sym__,
    ACTIONS(8304), 1,
      anon_sym_default,
    STATE(5062), 1,
      sym_constraint,
    STATE(5731), 1,
      sym__static_type_identifier,
    STATE(6335), 1,
      sym_type_argument,
    ACTIONS(4521), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5526), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [160012] = 14,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8302), 1,
      anon_sym__,
    ACTIONS(8328), 1,
      anon_sym_default,
    STATE(5731), 1,
      sym__static_type_identifier,
    STATE(5797), 1,
      sym_constraint,
    STATE(6334), 1,
      sym_type_argument,
    ACTIONS(4521), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5527), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [160059] = 15,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7269), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(7271), 1,
      sym_op_identifier,
    ACTIONS(8330), 1,
      sym_identifier,
    STATE(2288), 1,
      sym_property_or_ident,
    STATE(3772), 1,
      sym__identifier_or_op,
    STATE(3773), 1,
      sym_active_pattern,
    STATE(4910), 1,
      sym_method_or_prop_defn,
    STATE(5528), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [160108] = 14,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8302), 1,
      anon_sym__,
    ACTIONS(8318), 1,
      anon_sym_default,
    STATE(3416), 1,
      sym_constraint,
    STATE(5731), 1,
      sym__static_type_identifier,
    STATE(6168), 1,
      sym_type_argument,
    ACTIONS(4521), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5529), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [160155] = 9,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(133), 1,
      sym_line_comment,
    ACTIONS(6818), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(6820), 1,
      anon_sym_POUNDlight,
    ACTIONS(6822), 1,
      anon_sym_POUNDr,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7864), 3,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
      anon_sym_DQUOTEB,
    ACTIONS(7866), 4,
      sym__non_escape_char,
      anon_sym_BSLASH,
      aux_sym__verbatim_string_char_token1,
      anon_sym_DQUOTE2,
    STATE(5530), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [160192] = 14,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8302), 1,
      anon_sym__,
    ACTIONS(8332), 1,
      anon_sym_default,
    STATE(4542), 1,
      sym_constraint,
    STATE(5731), 1,
      sym__static_type_identifier,
    STATE(6116), 1,
      sym_type_argument,
    ACTIONS(4521), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5531), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [160239] = 15,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7269), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(7271), 1,
      sym_op_identifier,
    ACTIONS(8330), 1,
      sym_identifier,
    STATE(2288), 1,
      sym_property_or_ident,
    STATE(3772), 1,
      sym__identifier_or_op,
    STATE(3773), 1,
      sym_active_pattern,
    STATE(4880), 1,
      sym_method_or_prop_defn,
    STATE(5532), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [160288] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2506), 2,
      anon_sym_and,
      sym_identifier,
    STATE(5533), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2508), 5,
      anon_sym_DASH_GT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [160327] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2470), 2,
      anon_sym_and,
      sym_identifier,
    STATE(5534), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2472), 5,
      anon_sym_DASH_GT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [160366] = 15,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(1339), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1915), 1,
      sym_op_identifier,
    ACTIONS(8334), 1,
      sym_identifier,
    STATE(2079), 1,
      sym_long_identifier,
    STATE(2080), 1,
      sym_active_pattern,
    STATE(2089), 1,
      sym__identifier_or_op,
    STATE(2188), 1,
      sym_long_identifier_or_op,
    STATE(5535), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [160415] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2454), 2,
      anon_sym_and,
      sym_identifier,
    STATE(5536), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2456), 5,
      anon_sym_DASH_GT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [160454] = 14,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8302), 1,
      anon_sym__,
    ACTIONS(8336), 1,
      anon_sym_default,
    STATE(3348), 1,
      sym_constraint,
    STATE(5731), 1,
      sym__static_type_identifier,
    STATE(6300), 1,
      sym_type_argument,
    ACTIONS(4521), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5537), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [160501] = 15,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(3570), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(8338), 1,
      sym_identifier,
    ACTIONS(8340), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(8342), 1,
      sym_op_identifier,
    STATE(2848), 1,
      sym__identifier_or_op,
    STATE(4156), 1,
      sym_active_pattern,
    STATE(5691), 1,
      sym_access_modifier,
    STATE(5538), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [160550] = 15,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(1517), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2042), 1,
      sym_op_identifier,
    ACTIONS(8344), 1,
      sym_identifier,
    STATE(2082), 1,
      sym_long_identifier_or_op,
    STATE(2317), 1,
      sym_active_pattern,
    STATE(2392), 1,
      sym__identifier_or_op,
    STATE(2400), 1,
      sym_long_identifier,
    STATE(5539), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [160599] = 15,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(471), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2152), 1,
      sym_op_identifier,
    ACTIONS(8346), 1,
      sym_identifier,
    STATE(1753), 1,
      sym_active_pattern,
    STATE(1812), 1,
      sym__identifier_or_op,
    STATE(1813), 1,
      sym_long_identifier,
    STATE(1896), 1,
      sym_long_identifier_or_op,
    STATE(5540), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [160648] = 15,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(261), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1701), 1,
      sym_op_identifier,
    ACTIONS(8348), 1,
      sym_identifier,
    STATE(1085), 1,
      sym_active_pattern,
    STATE(1099), 1,
      sym__identifier_or_op,
    STATE(1135), 1,
      sym_long_identifier_or_op,
    STATE(1156), 1,
      sym_long_identifier,
    STATE(5541), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [160697] = 15,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(801), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2118), 1,
      sym_op_identifier,
    ACTIONS(8350), 1,
      sym_identifier,
    STATE(1750), 1,
      sym__identifier_or_op,
    STATE(1785), 1,
      sym_long_identifier_or_op,
    STATE(1810), 1,
      sym_long_identifier,
    STATE(1860), 1,
      sym_active_pattern,
    STATE(5542), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [160746] = 14,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8302), 1,
      anon_sym__,
    ACTIONS(8328), 1,
      anon_sym_default,
    STATE(4542), 1,
      sym_constraint,
    STATE(5731), 1,
      sym__static_type_identifier,
    STATE(6334), 1,
      sym_type_argument,
    ACTIONS(4521), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5543), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [160793] = 14,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8302), 1,
      anon_sym__,
    ACTIONS(8336), 1,
      anon_sym_default,
    STATE(3336), 1,
      sym_constraint,
    STATE(5731), 1,
      sym__static_type_identifier,
    STATE(6300), 1,
      sym_type_argument,
    ACTIONS(4521), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5544), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [160840] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2514), 2,
      anon_sym_and,
      sym_identifier,
    STATE(5545), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2516), 5,
      anon_sym_DASH_GT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [160879] = 14,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8302), 1,
      anon_sym__,
    ACTIONS(8352), 1,
      anon_sym_default,
    STATE(3310), 1,
      sym_constraint,
    STATE(5731), 1,
      sym__static_type_identifier,
    STATE(6234), 1,
      sym_type_argument,
    ACTIONS(4521), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5546), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [160926] = 14,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8302), 1,
      anon_sym__,
    ACTIONS(8326), 1,
      anon_sym_default,
    STATE(5004), 1,
      sym_constraint,
    STATE(5731), 1,
      sym__static_type_identifier,
    STATE(6372), 1,
      sym_type_argument,
    ACTIONS(4521), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5547), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [160973] = 15,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7269), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(7271), 1,
      sym_op_identifier,
    ACTIONS(8330), 1,
      sym_identifier,
    STATE(2288), 1,
      sym_property_or_ident,
    STATE(3772), 1,
      sym__identifier_or_op,
    STATE(3773), 1,
      sym_active_pattern,
    STATE(4887), 1,
      sym_method_or_prop_defn,
    STATE(5548), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [161022] = 14,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8302), 1,
      anon_sym__,
    ACTIONS(8314), 1,
      anon_sym_default,
    STATE(5357), 1,
      sym_constraint,
    STATE(5731), 1,
      sym__static_type_identifier,
    STATE(6268), 1,
      sym_type_argument,
    ACTIONS(4521), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5549), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [161069] = 14,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8302), 1,
      anon_sym__,
    ACTIONS(8354), 1,
      anon_sym_default,
    STATE(5055), 1,
      sym_constraint,
    STATE(5731), 1,
      sym__static_type_identifier,
    STATE(6137), 1,
      sym_type_argument,
    ACTIONS(4521), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5550), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [161116] = 14,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8302), 1,
      anon_sym__,
    ACTIONS(8356), 1,
      anon_sym_default,
    STATE(5342), 1,
      sym_constraint,
    STATE(5731), 1,
      sym__static_type_identifier,
    STATE(6198), 1,
      sym_type_argument,
    ACTIONS(4521), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5551), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [161163] = 14,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8302), 1,
      anon_sym__,
    ACTIONS(8358), 1,
      anon_sym_default,
    STATE(3518), 1,
      sym_constraint,
    STATE(5731), 1,
      sym__static_type_identifier,
    STATE(6049), 1,
      sym_type_argument,
    ACTIONS(4521), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5552), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [161210] = 14,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8302), 1,
      anon_sym__,
    ACTIONS(8356), 1,
      anon_sym_default,
    STATE(4998), 1,
      sym_constraint,
    STATE(5731), 1,
      sym__static_type_identifier,
    STATE(6198), 1,
      sym_type_argument,
    ACTIONS(4521), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5553), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [161257] = 15,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(7269), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(7271), 1,
      sym_op_identifier,
    ACTIONS(8330), 1,
      sym_identifier,
    STATE(2288), 1,
      sym_property_or_ident,
    STATE(3772), 1,
      sym__identifier_or_op,
    STATE(3773), 1,
      sym_active_pattern,
    STATE(4894), 1,
      sym_method_or_prop_defn,
    STATE(5554), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [161306] = 15,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(1069), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2076), 1,
      sym_op_identifier,
    ACTIONS(8360), 1,
      sym_identifier,
    STATE(2093), 1,
      sym__identifier_or_op,
    STATE(2182), 1,
      sym_active_pattern,
    STATE(2183), 1,
      sym_long_identifier,
    STATE(2285), 1,
      sym_long_identifier_or_op,
    STATE(5555), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [161355] = 15,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(585), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2066), 1,
      sym_op_identifier,
    ACTIONS(8362), 1,
      sym_identifier,
    STATE(1701), 1,
      sym_long_identifier,
    STATE(1702), 1,
      sym_active_pattern,
    STATE(1724), 1,
      sym__identifier_or_op,
    STATE(1982), 1,
      sym_long_identifier_or_op,
    STATE(5556), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [161404] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2474), 2,
      anon_sym_and,
      sym_identifier,
    STATE(5557), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2476), 5,
      anon_sym_DASH_GT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [161443] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2510), 2,
      anon_sym_and,
      sym_identifier,
    STATE(5558), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2512), 5,
      anon_sym_DASH_GT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [161482] = 14,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8302), 1,
      anon_sym__,
    ACTIONS(8352), 1,
      anon_sym_default,
    STATE(3389), 1,
      sym_constraint,
    STATE(5731), 1,
      sym__static_type_identifier,
    STATE(6234), 1,
      sym_type_argument,
    ACTIONS(4521), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5559), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [161529] = 15,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(121), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1675), 1,
      sym_op_identifier,
    ACTIONS(8364), 1,
      sym_identifier,
    STATE(871), 1,
      sym_active_pattern,
    STATE(872), 1,
      sym_long_identifier,
    STATE(873), 1,
      sym__identifier_or_op,
    STATE(912), 1,
      sym_long_identifier_or_op,
    STATE(5560), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [161578] = 15,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(705), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(1719), 1,
      sym_op_identifier,
    ACTIONS(8366), 1,
      sym_identifier,
    STATE(1725), 1,
      sym_long_identifier,
    STATE(1726), 1,
      sym_active_pattern,
    STATE(1751), 1,
      sym__identifier_or_op,
    STATE(2064), 1,
      sym_long_identifier_or_op,
    STATE(5561), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [161627] = 14,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8302), 1,
      anon_sym__,
    ACTIONS(8354), 1,
      anon_sym_default,
    STATE(4542), 1,
      sym_constraint,
    STATE(5731), 1,
      sym__static_type_identifier,
    STATE(6137), 1,
      sym_type_argument,
    ACTIONS(4521), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5562), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [161674] = 14,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8302), 1,
      anon_sym__,
    ACTIONS(8324), 1,
      anon_sym_default,
    STATE(3336), 1,
      sym_constraint,
    STATE(5731), 1,
      sym__static_type_identifier,
    STATE(6063), 1,
      sym_type_argument,
    ACTIONS(4521), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5563), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [161721] = 9,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(133), 1,
      sym_line_comment,
    ACTIONS(6818), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(6820), 1,
      anon_sym_POUNDlight,
    ACTIONS(6822), 1,
      anon_sym_POUNDr,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(8370), 3,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
      anon_sym_DQUOTEB,
    ACTIONS(8368), 4,
      sym__non_escape_char,
      anon_sym_BSLASH,
      aux_sym__verbatim_string_char_token1,
      anon_sym_DQUOTE2,
    STATE(5564), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [161758] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2627), 2,
      anon_sym_and,
      sym_identifier,
    STATE(5565), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2629), 5,
      anon_sym_DASH_GT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [161797] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2466), 2,
      anon_sym_and,
      sym_identifier,
    STATE(5566), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
    ACTIONS(2468), 5,
      anon_sym_DASH_GT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_LT2,
      anon_sym_LBRACK_RBRACK,
  [161836] = 15,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(357), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(2134), 1,
      sym_op_identifier,
    ACTIONS(8372), 1,
      sym_identifier,
    STATE(1521), 1,
      sym_long_identifier_or_op,
    STATE(1643), 1,
      sym_long_identifier,
    STATE(1645), 1,
      sym_active_pattern,
    STATE(1689), 1,
      sym__identifier_or_op,
    STATE(5567), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [161885] = 9,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(133), 1,
      sym_line_comment,
    ACTIONS(6818), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(6820), 1,
      anon_sym_POUNDlight,
    ACTIONS(6822), 1,
      anon_sym_POUNDr,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(8376), 3,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
      anon_sym_DQUOTEB,
    ACTIONS(8374), 4,
      sym__non_escape_char,
      anon_sym_BSLASH,
      aux_sym__verbatim_string_char_token1,
      anon_sym_DQUOTE2,
    STATE(5568), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [161922] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8378), 1,
      anon_sym_LT2,
    ACTIONS(2557), 2,
      anon_sym_and,
      sym_identifier,
    ACTIONS(2559), 4,
      anon_sym_DASH_GT,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_LBRACK_RBRACK,
    STATE(5569), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [161963] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5761), 1,
      anon_sym_let,
    ACTIONS(8380), 1,
      anon_sym_LBRACK_LT,
    STATE(5710), 1,
      sym__attribute_set,
    ACTIONS(5766), 2,
      anon_sym_do,
      anon_sym_let_BANG,
    STATE(5570), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_attributes_repeat1,
  [162005] = 14,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(8340), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(8342), 1,
      sym_op_identifier,
    ACTIONS(8383), 1,
      sym_identifier,
    STATE(4156), 1,
      sym_active_pattern,
    STATE(5864), 1,
      sym_property_or_ident,
    STATE(6381), 1,
      sym__identifier_or_op,
    STATE(5571), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [162051] = 9,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(133), 1,
      sym_line_comment,
    ACTIONS(6818), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(6820), 1,
      anon_sym_POUNDlight,
    ACTIONS(6822), 1,
      anon_sym_POUNDr,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(7864), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(7866), 4,
      sym__non_escape_char,
      anon_sym_BSLASH,
      aux_sym__verbatim_string_char_token1,
      anon_sym_DQUOTE2,
    STATE(5572), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [162087] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5798), 1,
      anon_sym_let,
    ACTIONS(7134), 1,
      anon_sym_LBRACK_LT,
    STATE(5570), 1,
      aux_sym_attributes_repeat1,
    STATE(5710), 1,
      sym__attribute_set,
    ACTIONS(5800), 2,
      anon_sym_do,
      anon_sym_let_BANG,
    STATE(5573), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [162131] = 9,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(133), 1,
      sym_line_comment,
    ACTIONS(6818), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(6820), 1,
      anon_sym_POUNDlight,
    ACTIONS(6822), 1,
      anon_sym_POUNDr,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(8370), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(8368), 4,
      sym__non_escape_char,
      anon_sym_BSLASH,
      aux_sym__verbatim_string_char_token1,
      anon_sym_DQUOTE2,
    STATE(5574), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [162167] = 9,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(133), 1,
      sym_line_comment,
    ACTIONS(6818), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(6820), 1,
      anon_sym_POUNDlight,
    ACTIONS(6822), 1,
      anon_sym_POUNDr,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    ACTIONS(8376), 2,
      sym__inside_string_marker,
      aux_sym__simple_string_char_token1,
    ACTIONS(8374), 4,
      sym__non_escape_char,
      anon_sym_BSLASH,
      aux_sym__verbatim_string_char_token1,
      anon_sym_DQUOTE2,
    STATE(5575), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [162203] = 14,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(8340), 1,
      anon_sym_LPAREN_PIPE,
    ACTIONS(8342), 1,
      sym_op_identifier,
    ACTIONS(8383), 1,
      sym_identifier,
    STATE(4156), 1,
      sym_active_pattern,
    STATE(5917), 1,
      sym_property_or_ident,
    STATE(6381), 1,
      sym__identifier_or_op,
    STATE(5576), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [162249] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8385), 1,
      anon_sym_COMMA,
    ACTIONS(8387), 1,
      anon_sym_GT,
    ACTIONS(8389), 1,
      anon_sym_when,
    STATE(5589), 1,
      aux_sym_type_arguments_repeat1,
    STATE(6759), 1,
      sym_type_argument_constraints,
    STATE(5577), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [162292] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8385), 1,
      anon_sym_COMMA,
    ACTIONS(8389), 1,
      anon_sym_when,
    ACTIONS(8391), 1,
      anon_sym_GT,
    STATE(5709), 1,
      aux_sym_type_arguments_repeat1,
    STATE(7226), 1,
      sym_type_argument_constraints,
    STATE(5578), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [162335] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8385), 1,
      anon_sym_COMMA,
    ACTIONS(8389), 1,
      anon_sym_when,
    ACTIONS(8393), 1,
      anon_sym_GT,
    STATE(5631), 1,
      aux_sym_type_arguments_repeat1,
    STATE(7107), 1,
      sym_type_argument_constraints,
    STATE(5579), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [162378] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(471), 1,
      anon_sym_LPAREN_PIPE,
    STATE(1753), 1,
      sym_active_pattern,
    STATE(1790), 1,
      sym__identifier_or_op,
    ACTIONS(2152), 2,
      sym_op_identifier,
      sym_identifier,
    STATE(5580), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [162419] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8385), 1,
      anon_sym_COMMA,
    ACTIONS(8389), 1,
      anon_sym_when,
    ACTIONS(8395), 1,
      anon_sym_GT,
    STATE(5585), 1,
      aux_sym_type_arguments_repeat1,
    STATE(6779), 1,
      sym_type_argument_constraints,
    STATE(5581), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [162462] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8385), 1,
      anon_sym_COMMA,
    ACTIONS(8389), 1,
      anon_sym_when,
    ACTIONS(8397), 1,
      anon_sym_GT,
    STATE(5709), 1,
      aux_sym_type_arguments_repeat1,
    STATE(7079), 1,
      sym_type_argument_constraints,
    STATE(5582), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [162505] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8385), 1,
      anon_sym_COMMA,
    ACTIONS(8389), 1,
      anon_sym_when,
    ACTIONS(8399), 1,
      anon_sym_GT,
    STATE(5582), 1,
      aux_sym_type_arguments_repeat1,
    STATE(7083), 1,
      sym_type_argument_constraints,
    STATE(5583), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [162548] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8302), 1,
      anon_sym__,
    STATE(5731), 1,
      sym__static_type_identifier,
    STATE(6903), 1,
      sym_type_argument,
    ACTIONS(4521), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5584), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [162589] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8385), 1,
      anon_sym_COMMA,
    ACTIONS(8389), 1,
      anon_sym_when,
    ACTIONS(8401), 1,
      anon_sym_GT,
    STATE(5709), 1,
      aux_sym_type_arguments_repeat1,
    STATE(6776), 1,
      sym_type_argument_constraints,
    STATE(5585), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [162632] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8302), 1,
      anon_sym__,
    STATE(5731), 1,
      sym__static_type_identifier,
    STATE(6921), 1,
      sym_type_argument,
    ACTIONS(4521), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5586), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [162673] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8385), 1,
      anon_sym_COMMA,
    ACTIONS(8389), 1,
      anon_sym_when,
    ACTIONS(8403), 1,
      anon_sym_GT,
    STATE(5598), 1,
      aux_sym_type_arguments_repeat1,
    STATE(7133), 1,
      sym_type_argument_constraints,
    STATE(5587), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [162716] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(705), 1,
      anon_sym_LPAREN_PIPE,
    STATE(1726), 1,
      sym_active_pattern,
    STATE(1736), 1,
      sym__identifier_or_op,
    ACTIONS(1719), 2,
      sym_op_identifier,
      sym_identifier,
    STATE(5588), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [162757] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8385), 1,
      anon_sym_COMMA,
    ACTIONS(8389), 1,
      anon_sym_when,
    ACTIONS(8405), 1,
      anon_sym_GT,
    STATE(5709), 1,
      aux_sym_type_arguments_repeat1,
    STATE(6757), 1,
      sym_type_argument_constraints,
    STATE(5589), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [162800] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(3606), 1,
      anon_sym_LPAREN_PIPE,
    STATE(3479), 1,
      sym__identifier_or_op,
    STATE(3488), 1,
      sym_active_pattern,
    ACTIONS(3608), 2,
      sym_op_identifier,
      sym_identifier,
    STATE(5590), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [162841] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8385), 1,
      anon_sym_COMMA,
    ACTIONS(8389), 1,
      anon_sym_when,
    ACTIONS(8407), 1,
      anon_sym_GT,
    STATE(5709), 1,
      aux_sym_type_arguments_repeat1,
    STATE(6804), 1,
      sym_type_argument_constraints,
    STATE(5591), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [162884] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8409), 1,
      anon_sym_DQUOTE,
    ACTIONS(8411), 1,
      anon_sym_AT_DQUOTE,
    ACTIONS(8413), 1,
      sym__newline_not_aligned,
    STATE(7298), 1,
      sym_verbatim_string,
    STATE(7303), 1,
      sym__string_literal,
    STATE(5592), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [162927] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(1159), 1,
      anon_sym_LPAREN_PIPE,
    STATE(2094), 1,
      sym__identifier_or_op,
    STATE(2470), 1,
      sym_active_pattern,
    ACTIONS(2106), 2,
      sym_op_identifier,
      sym_identifier,
    STATE(5593), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [162968] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8385), 1,
      anon_sym_COMMA,
    ACTIONS(8389), 1,
      anon_sym_when,
    ACTIONS(8415), 1,
      anon_sym_GT,
    STATE(5595), 1,
      aux_sym_type_arguments_repeat1,
    STATE(6734), 1,
      sym_type_argument_constraints,
    STATE(5594), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [163011] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8385), 1,
      anon_sym_COMMA,
    ACTIONS(8389), 1,
      anon_sym_when,
    ACTIONS(8417), 1,
      anon_sym_GT,
    STATE(5709), 1,
      aux_sym_type_arguments_repeat1,
    STATE(6732), 1,
      sym_type_argument_constraints,
    STATE(5595), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [163054] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8385), 1,
      anon_sym_COMMA,
    ACTIONS(8389), 1,
      anon_sym_when,
    ACTIONS(8419), 1,
      anon_sym_GT,
    STATE(5709), 1,
      aux_sym_type_arguments_repeat1,
    STATE(7125), 1,
      sym_type_argument_constraints,
    STATE(5596), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [163097] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8385), 1,
      anon_sym_COMMA,
    ACTIONS(8389), 1,
      anon_sym_when,
    ACTIONS(8421), 1,
      anon_sym_GT,
    STATE(5596), 1,
      aux_sym_type_arguments_repeat1,
    STATE(7131), 1,
      sym_type_argument_constraints,
    STATE(5597), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [163140] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8385), 1,
      anon_sym_COMMA,
    ACTIONS(8389), 1,
      anon_sym_when,
    ACTIONS(8423), 1,
      anon_sym_GT,
    STATE(5709), 1,
      aux_sym_type_arguments_repeat1,
    STATE(7046), 1,
      sym_type_argument_constraints,
    STATE(5598), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [163183] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6451), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(8425), 1,
      sym_identifier,
    ACTIONS(8427), 1,
      anon_sym_member,
    STATE(4880), 1,
      sym_member_signature,
    STATE(6150), 1,
      sym_access_modifier,
    STATE(5599), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [163226] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8385), 1,
      anon_sym_COMMA,
    ACTIONS(8389), 1,
      anon_sym_when,
    ACTIONS(8429), 1,
      anon_sym_GT,
    STATE(5591), 1,
      aux_sym_type_arguments_repeat1,
    STATE(6753), 1,
      sym_type_argument_constraints,
    STATE(5600), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [163269] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(1517), 1,
      anon_sym_LPAREN_PIPE,
    STATE(2317), 1,
      sym_active_pattern,
    STATE(2379), 1,
      sym__identifier_or_op,
    ACTIONS(2042), 2,
      sym_op_identifier,
      sym_identifier,
    STATE(5601), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [163310] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8385), 1,
      anon_sym_COMMA,
    ACTIONS(8389), 1,
      anon_sym_when,
    ACTIONS(8431), 1,
      anon_sym_GT,
    STATE(5603), 1,
      aux_sym_type_arguments_repeat1,
    STATE(6718), 1,
      sym_type_argument_constraints,
    STATE(5602), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [163353] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8385), 1,
      anon_sym_COMMA,
    ACTIONS(8389), 1,
      anon_sym_when,
    ACTIONS(8433), 1,
      anon_sym_GT,
    STATE(5709), 1,
      aux_sym_type_arguments_repeat1,
    STATE(6711), 1,
      sym_type_argument_constraints,
    STATE(5603), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [163396] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8385), 1,
      anon_sym_COMMA,
    ACTIONS(8389), 1,
      anon_sym_when,
    ACTIONS(8435), 1,
      anon_sym_GT,
    STATE(5683), 1,
      aux_sym_type_arguments_repeat1,
    STATE(6498), 1,
      sym_type_argument_constraints,
    STATE(5604), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [163439] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8385), 1,
      anon_sym_COMMA,
    ACTIONS(8389), 1,
      anon_sym_when,
    ACTIONS(8437), 1,
      anon_sym_GT,
    STATE(5606), 1,
      aux_sym_type_arguments_repeat1,
    STATE(6680), 1,
      sym_type_argument_constraints,
    STATE(5605), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [163482] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8385), 1,
      anon_sym_COMMA,
    ACTIONS(8389), 1,
      anon_sym_when,
    ACTIONS(8439), 1,
      anon_sym_GT,
    STATE(5709), 1,
      aux_sym_type_arguments_repeat1,
    STATE(6678), 1,
      sym_type_argument_constraints,
    STATE(5606), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [163525] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8302), 1,
      anon_sym__,
    STATE(5731), 1,
      sym__static_type_identifier,
    STATE(6863), 1,
      sym_type_argument,
    ACTIONS(4521), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5607), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [163566] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8302), 1,
      anon_sym__,
    STATE(5731), 1,
      sym__static_type_identifier,
    STATE(6690), 1,
      sym_type_argument,
    ACTIONS(4521), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5608), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [163607] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8385), 1,
      anon_sym_COMMA,
    ACTIONS(8389), 1,
      anon_sym_when,
    ACTIONS(8441), 1,
      anon_sym_GT,
    STATE(5623), 1,
      aux_sym_type_arguments_repeat1,
    STATE(6968), 1,
      sym_type_argument_constraints,
    STATE(5609), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [163650] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8385), 1,
      anon_sym_COMMA,
    ACTIONS(8389), 1,
      anon_sym_when,
    ACTIONS(8443), 1,
      anon_sym_GT,
    STATE(5709), 1,
      aux_sym_type_arguments_repeat1,
    STATE(7177), 1,
      sym_type_argument_constraints,
    STATE(5610), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [163693] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8302), 1,
      anon_sym__,
    STATE(5731), 1,
      sym__static_type_identifier,
    STATE(6594), 1,
      sym_type_argument,
    ACTIONS(4521), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5611), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [163734] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8385), 1,
      anon_sym_COMMA,
    ACTIONS(8389), 1,
      anon_sym_when,
    ACTIONS(8445), 1,
      anon_sym_GT,
    STATE(5610), 1,
      aux_sym_type_arguments_repeat1,
    STATE(7193), 1,
      sym_type_argument_constraints,
    STATE(5612), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [163777] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6451), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(8425), 1,
      sym_identifier,
    ACTIONS(8447), 1,
      anon_sym_member,
    STATE(4911), 1,
      sym_member_signature,
    STATE(6188), 1,
      sym_access_modifier,
    STATE(5613), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [163820] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8385), 1,
      anon_sym_COMMA,
    ACTIONS(8389), 1,
      anon_sym_when,
    ACTIONS(8449), 1,
      anon_sym_GT,
    STATE(5657), 1,
      aux_sym_type_arguments_repeat1,
    STATE(6665), 1,
      sym_type_argument_constraints,
    STATE(5614), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [163863] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(4212), 1,
      anon_sym_LPAREN_PIPE,
    STATE(3734), 1,
      sym_active_pattern,
    STATE(3746), 1,
      sym__identifier_or_op,
    ACTIONS(4214), 2,
      sym_op_identifier,
      sym_identifier,
    STATE(5615), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [163904] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8385), 1,
      anon_sym_COMMA,
    ACTIONS(8389), 1,
      anon_sym_when,
    ACTIONS(8451), 1,
      anon_sym_GT,
    STATE(5709), 1,
      aux_sym_type_arguments_repeat1,
    STATE(7234), 1,
      sym_type_argument_constraints,
    STATE(5616), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [163947] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(357), 1,
      anon_sym_LPAREN_PIPE,
    STATE(1645), 1,
      sym_active_pattern,
    STATE(1648), 1,
      sym__identifier_or_op,
    ACTIONS(2134), 2,
      sym_op_identifier,
      sym_identifier,
    STATE(5617), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [163988] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8385), 1,
      anon_sym_COMMA,
    ACTIONS(8389), 1,
      anon_sym_when,
    ACTIONS(8453), 1,
      anon_sym_GT,
    STATE(5633), 1,
      aux_sym_type_arguments_repeat1,
    STATE(7380), 1,
      sym_type_argument_constraints,
    STATE(5618), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [164031] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8385), 1,
      anon_sym_COMMA,
    ACTIONS(8389), 1,
      anon_sym_when,
    ACTIONS(8455), 1,
      anon_sym_GT,
    STATE(5616), 1,
      aux_sym_type_arguments_repeat1,
    STATE(7248), 1,
      sym_type_argument_constraints,
    STATE(5619), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [164074] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8385), 1,
      anon_sym_COMMA,
    ACTIONS(8389), 1,
      anon_sym_when,
    ACTIONS(8457), 1,
      anon_sym_GT,
    STATE(5621), 1,
      aux_sym_type_arguments_repeat1,
    STATE(6640), 1,
      sym_type_argument_constraints,
    STATE(5620), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [164117] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8385), 1,
      anon_sym_COMMA,
    ACTIONS(8389), 1,
      anon_sym_when,
    ACTIONS(8459), 1,
      anon_sym_GT,
    STATE(5709), 1,
      aux_sym_type_arguments_repeat1,
    STATE(6636), 1,
      sym_type_argument_constraints,
    STATE(5621), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [164160] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8385), 1,
      anon_sym_COMMA,
    ACTIONS(8389), 1,
      anon_sym_when,
    ACTIONS(8461), 1,
      anon_sym_GT,
    STATE(5709), 1,
      aux_sym_type_arguments_repeat1,
    STATE(6928), 1,
      sym_type_argument_constraints,
    STATE(5622), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [164203] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8385), 1,
      anon_sym_COMMA,
    ACTIONS(8389), 1,
      anon_sym_when,
    ACTIONS(8463), 1,
      anon_sym_GT,
    STATE(5709), 1,
      aux_sym_type_arguments_repeat1,
    STATE(6961), 1,
      sym_type_argument_constraints,
    STATE(5623), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [164246] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8385), 1,
      anon_sym_COMMA,
    ACTIONS(8389), 1,
      anon_sym_when,
    ACTIONS(8465), 1,
      anon_sym_GT,
    STATE(5709), 1,
      aux_sym_type_arguments_repeat1,
    STATE(6808), 1,
      sym_type_argument_constraints,
    STATE(5624), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [164289] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8385), 1,
      anon_sym_COMMA,
    ACTIONS(8389), 1,
      anon_sym_when,
    ACTIONS(8467), 1,
      anon_sym_GT,
    STATE(5709), 1,
      aux_sym_type_arguments_repeat1,
    STATE(7528), 1,
      sym_type_argument_constraints,
    STATE(5625), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [164332] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8302), 1,
      anon_sym__,
    STATE(5731), 1,
      sym__static_type_identifier,
    STATE(6429), 1,
      sym_type_argument,
    ACTIONS(4521), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5626), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [164373] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8385), 1,
      anon_sym_COMMA,
    ACTIONS(8389), 1,
      anon_sym_when,
    ACTIONS(8469), 1,
      anon_sym_GT,
    STATE(5629), 1,
      aux_sym_type_arguments_repeat1,
    STATE(6533), 1,
      sym_type_argument_constraints,
    STATE(5627), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [164416] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8385), 1,
      anon_sym_COMMA,
    ACTIONS(8389), 1,
      anon_sym_when,
    ACTIONS(8471), 1,
      anon_sym_GT,
    STATE(5624), 1,
      aux_sym_type_arguments_repeat1,
    STATE(6812), 1,
      sym_type_argument_constraints,
    STATE(5628), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [164459] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8385), 1,
      anon_sym_COMMA,
    ACTIONS(8389), 1,
      anon_sym_when,
    ACTIONS(8473), 1,
      anon_sym_GT,
    STATE(5709), 1,
      aux_sym_type_arguments_repeat1,
    STATE(6618), 1,
      sym_type_argument_constraints,
    STATE(5629), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [164502] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(8340), 1,
      anon_sym_LPAREN_PIPE,
    STATE(4156), 1,
      sym_active_pattern,
    STATE(6612), 1,
      sym__identifier_or_op,
    ACTIONS(8342), 2,
      sym_op_identifier,
      sym_identifier,
    STATE(5630), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [164543] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8385), 1,
      anon_sym_COMMA,
    ACTIONS(8389), 1,
      anon_sym_when,
    ACTIONS(8475), 1,
      anon_sym_GT,
    STATE(5709), 1,
      aux_sym_type_arguments_repeat1,
    STATE(7071), 1,
      sym_type_argument_constraints,
    STATE(5631), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [164586] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8385), 1,
      anon_sym_COMMA,
    ACTIONS(8389), 1,
      anon_sym_when,
    ACTIONS(8477), 1,
      anon_sym_GT,
    STATE(5709), 1,
      aux_sym_type_arguments_repeat1,
    STATE(6844), 1,
      sym_type_argument_constraints,
    STATE(5632), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [164629] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8385), 1,
      anon_sym_COMMA,
    ACTIONS(8389), 1,
      anon_sym_when,
    ACTIONS(8479), 1,
      anon_sym_GT,
    STATE(5709), 1,
      aux_sym_type_arguments_repeat1,
    STATE(7360), 1,
      sym_type_argument_constraints,
    STATE(5633), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [164672] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8385), 1,
      anon_sym_COMMA,
    ACTIONS(8389), 1,
      anon_sym_when,
    ACTIONS(8481), 1,
      anon_sym_GT,
    STATE(5625), 1,
      aux_sym_type_arguments_repeat1,
    STATE(7535), 1,
      sym_type_argument_constraints,
    STATE(5634), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [164715] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8302), 1,
      anon_sym__,
    STATE(5731), 1,
      sym__static_type_identifier,
    STATE(6489), 1,
      sym_type_argument,
    ACTIONS(4521), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5635), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [164756] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8385), 1,
      anon_sym_COMMA,
    ACTIONS(8389), 1,
      anon_sym_when,
    ACTIONS(8483), 1,
      anon_sym_GT,
    STATE(5632), 1,
      aux_sym_type_arguments_repeat1,
    STATE(6848), 1,
      sym_type_argument_constraints,
    STATE(5636), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [164799] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8385), 1,
      anon_sym_COMMA,
    ACTIONS(8389), 1,
      anon_sym_when,
    ACTIONS(8485), 1,
      anon_sym_GT,
    STATE(5638), 1,
      aux_sym_type_arguments_repeat1,
    STATE(6598), 1,
      sym_type_argument_constraints,
    STATE(5637), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [164842] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8385), 1,
      anon_sym_COMMA,
    ACTIONS(8389), 1,
      anon_sym_when,
    ACTIONS(8487), 1,
      anon_sym_GT,
    STATE(5709), 1,
      aux_sym_type_arguments_repeat1,
    STATE(6596), 1,
      sym_type_argument_constraints,
    STATE(5638), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [164885] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8302), 1,
      anon_sym__,
    STATE(5731), 1,
      sym__static_type_identifier,
    STATE(6642), 1,
      sym_type_argument,
    ACTIONS(4521), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5639), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [164926] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8385), 1,
      anon_sym_COMMA,
    ACTIONS(8389), 1,
      anon_sym_when,
    ACTIONS(8489), 1,
      anon_sym_GT,
    STATE(5709), 1,
      aux_sym_type_arguments_repeat1,
    STATE(7281), 1,
      sym_type_argument_constraints,
    STATE(5640), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [164969] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8385), 1,
      anon_sym_COMMA,
    ACTIONS(8389), 1,
      anon_sym_when,
    ACTIONS(8491), 1,
      anon_sym_GT,
    STATE(5680), 1,
      aux_sym_type_arguments_repeat1,
    STATE(6743), 1,
      sym_type_argument_constraints,
    STATE(5641), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [165012] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8385), 1,
      anon_sym_COMMA,
    ACTIONS(8389), 1,
      anon_sym_when,
    ACTIONS(8493), 1,
      anon_sym_GT,
    STATE(5709), 1,
      aux_sym_type_arguments_repeat1,
    STATE(6622), 1,
      sym_type_argument_constraints,
    STATE(5642), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [165055] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8385), 1,
      anon_sym_COMMA,
    ACTIONS(8389), 1,
      anon_sym_when,
    ACTIONS(8495), 1,
      anon_sym_GT,
    STATE(5660), 1,
      aux_sym_type_arguments_repeat1,
    STATE(7329), 1,
      sym_type_argument_constraints,
    STATE(5643), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [165098] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8385), 1,
      anon_sym_COMMA,
    ACTIONS(8389), 1,
      anon_sym_when,
    ACTIONS(8497), 1,
      anon_sym_GT,
    STATE(5646), 1,
      aux_sym_type_arguments_repeat1,
    STATE(6569), 1,
      sym_type_argument_constraints,
    STATE(5644), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [165141] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(8340), 1,
      anon_sym_LPAREN_PIPE,
    STATE(4156), 1,
      sym_active_pattern,
    STATE(7025), 1,
      sym__identifier_or_op,
    ACTIONS(8342), 2,
      sym_op_identifier,
      sym_identifier,
    STATE(5645), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [165182] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8385), 1,
      anon_sym_COMMA,
    ACTIONS(8389), 1,
      anon_sym_when,
    ACTIONS(8499), 1,
      anon_sym_GT,
    STATE(5709), 1,
      aux_sym_type_arguments_repeat1,
    STATE(6568), 1,
      sym_type_argument_constraints,
    STATE(5646), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [165225] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8385), 1,
      anon_sym_COMMA,
    ACTIONS(8389), 1,
      anon_sym_when,
    ACTIONS(8501), 1,
      anon_sym_GT,
    STATE(5640), 1,
      aux_sym_type_arguments_repeat1,
    STATE(7288), 1,
      sym_type_argument_constraints,
    STATE(5647), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [165268] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8385), 1,
      anon_sym_COMMA,
    ACTIONS(8389), 1,
      anon_sym_when,
    ACTIONS(8503), 1,
      anon_sym_GT,
    STATE(5709), 1,
      aux_sym_type_arguments_repeat1,
    STATE(7308), 1,
      sym_type_argument_constraints,
    STATE(5648), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [165311] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(801), 1,
      anon_sym_LPAREN_PIPE,
    STATE(1791), 1,
      sym__identifier_or_op,
    STATE(1860), 1,
      sym_active_pattern,
    ACTIONS(2118), 2,
      sym_op_identifier,
      sym_identifier,
    STATE(5649), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [165352] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8385), 1,
      anon_sym_COMMA,
    ACTIONS(8389), 1,
      anon_sym_when,
    ACTIONS(8505), 1,
      anon_sym_GT,
    STATE(5655), 1,
      aux_sym_type_arguments_repeat1,
    STATE(6550), 1,
      sym_type_argument_constraints,
    STATE(5650), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [165395] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(1069), 1,
      anon_sym_LPAREN_PIPE,
    STATE(2182), 1,
      sym_active_pattern,
    STATE(2339), 1,
      sym__identifier_or_op,
    ACTIONS(2076), 2,
      sym_op_identifier,
      sym_identifier,
    STATE(5651), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [165436] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(3904), 1,
      anon_sym_LPAREN_PIPE,
    STATE(3439), 1,
      sym__identifier_or_op,
    STATE(3521), 1,
      sym_active_pattern,
    ACTIONS(3906), 2,
      sym_op_identifier,
      sym_identifier,
    STATE(5652), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [165477] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8385), 1,
      anon_sym_COMMA,
    ACTIONS(8389), 1,
      anon_sym_when,
    ACTIONS(8507), 1,
      anon_sym_GT,
    STATE(5709), 1,
      aux_sym_type_arguments_repeat1,
    STATE(6856), 1,
      sym_type_argument_constraints,
    STATE(5653), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [165520] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7136), 1,
      anon_sym_do,
    ACTIONS(7138), 1,
      anon_sym_let,
    ACTIONS(7140), 1,
      anon_sym_let_BANG,
    STATE(4917), 1,
      sym_do,
    STATE(4919), 1,
      sym_function_or_value_defn,
    STATE(5654), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [165563] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8385), 1,
      anon_sym_COMMA,
    ACTIONS(8389), 1,
      anon_sym_when,
    ACTIONS(8509), 1,
      anon_sym_GT,
    STATE(5709), 1,
      aux_sym_type_arguments_repeat1,
    STATE(6546), 1,
      sym_type_argument_constraints,
    STATE(5655), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [165606] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8385), 1,
      anon_sym_COMMA,
    ACTIONS(8389), 1,
      anon_sym_when,
    ACTIONS(8511), 1,
      anon_sym_GT,
    STATE(5709), 1,
      aux_sym_type_arguments_repeat1,
    STATE(6880), 1,
      sym_type_argument_constraints,
    STATE(5656), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [165649] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8385), 1,
      anon_sym_COMMA,
    ACTIONS(8389), 1,
      anon_sym_when,
    ACTIONS(8513), 1,
      anon_sym_GT,
    STATE(5709), 1,
      aux_sym_type_arguments_repeat1,
    STATE(6663), 1,
      sym_type_argument_constraints,
    STATE(5657), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [165692] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(585), 1,
      anon_sym_LPAREN_PIPE,
    STATE(1702), 1,
      sym_active_pattern,
    STATE(1712), 1,
      sym__identifier_or_op,
    ACTIONS(2066), 2,
      sym_op_identifier,
      sym_identifier,
    STATE(5658), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [165733] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8385), 1,
      anon_sym_COMMA,
    ACTIONS(8389), 1,
      anon_sym_when,
    ACTIONS(8515), 1,
      anon_sym_GT,
    STATE(5642), 1,
      aux_sym_type_arguments_repeat1,
    STATE(6756), 1,
      sym_type_argument_constraints,
    STATE(5659), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [165776] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8385), 1,
      anon_sym_COMMA,
    ACTIONS(8389), 1,
      anon_sym_when,
    ACTIONS(8517), 1,
      anon_sym_GT,
    STATE(5709), 1,
      aux_sym_type_arguments_repeat1,
    STATE(7387), 1,
      sym_type_argument_constraints,
    STATE(5660), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [165819] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8385), 1,
      anon_sym_COMMA,
    ACTIONS(8389), 1,
      anon_sym_when,
    ACTIONS(8519), 1,
      anon_sym_GT,
    STATE(5622), 1,
      aux_sym_type_arguments_repeat1,
    STATE(6980), 1,
      sym_type_argument_constraints,
    STATE(5661), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [165862] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8385), 1,
      anon_sym_COMMA,
    ACTIONS(8389), 1,
      anon_sym_when,
    ACTIONS(8521), 1,
      anon_sym_GT,
    STATE(5653), 1,
      aux_sym_type_arguments_repeat1,
    STATE(6857), 1,
      sym_type_argument_constraints,
    STATE(5662), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [165905] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8302), 1,
      anon_sym__,
    STATE(5731), 1,
      sym__static_type_identifier,
    STATE(6544), 1,
      sym_type_argument,
    ACTIONS(4521), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5663), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [165946] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8385), 1,
      anon_sym_COMMA,
    ACTIONS(8389), 1,
      anon_sym_when,
    ACTIONS(8523), 1,
      anon_sym_GT,
    STATE(5709), 1,
      aux_sym_type_arguments_repeat1,
    STATE(7336), 1,
      sym_type_argument_constraints,
    STATE(5664), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [165989] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8385), 1,
      anon_sym_COMMA,
    ACTIONS(8389), 1,
      anon_sym_when,
    ACTIONS(8525), 1,
      anon_sym_GT,
    STATE(5674), 1,
      aux_sym_type_arguments_repeat1,
    STATE(7037), 1,
      sym_type_argument_constraints,
    STATE(5665), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [166032] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8385), 1,
      anon_sym_COMMA,
    ACTIONS(8389), 1,
      anon_sym_when,
    ACTIONS(8527), 1,
      anon_sym_GT,
    STATE(5664), 1,
      aux_sym_type_arguments_repeat1,
    STATE(7353), 1,
      sym_type_argument_constraints,
    STATE(5666), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [166075] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8385), 1,
      anon_sym_COMMA,
    ACTIONS(8389), 1,
      anon_sym_when,
    ACTIONS(8529), 1,
      anon_sym_GT,
    STATE(5669), 1,
      aux_sym_type_arguments_repeat1,
    STATE(6529), 1,
      sym_type_argument_constraints,
    STATE(5667), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [166118] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8385), 1,
      anon_sym_COMMA,
    ACTIONS(8389), 1,
      anon_sym_when,
    ACTIONS(8531), 1,
      anon_sym_GT,
    STATE(5698), 1,
      aux_sym_type_arguments_repeat1,
    STATE(6910), 1,
      sym_type_argument_constraints,
    STATE(5668), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [166161] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8385), 1,
      anon_sym_COMMA,
    ACTIONS(8389), 1,
      anon_sym_when,
    ACTIONS(8533), 1,
      anon_sym_GT,
    STATE(5709), 1,
      aux_sym_type_arguments_repeat1,
    STATE(6525), 1,
      sym_type_argument_constraints,
    STATE(5669), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [166204] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8385), 1,
      anon_sym_COMMA,
    ACTIONS(8389), 1,
      anon_sym_when,
    ACTIONS(8535), 1,
      anon_sym_GT,
    STATE(5675), 1,
      aux_sym_type_arguments_repeat1,
    STATE(6512), 1,
      sym_type_argument_constraints,
    STATE(5670), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [166247] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(121), 1,
      anon_sym_LPAREN_PIPE,
    STATE(871), 1,
      sym_active_pattern,
    STATE(894), 1,
      sym__identifier_or_op,
    ACTIONS(1675), 2,
      sym_op_identifier,
      sym_identifier,
    STATE(5671), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [166288] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(4117), 1,
      anon_sym_LPAREN_PIPE,
    STATE(3636), 1,
      sym__identifier_or_op,
    STATE(3653), 1,
      sym_active_pattern,
    ACTIONS(4119), 2,
      sym_op_identifier,
      sym_identifier,
    STATE(5672), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [166329] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(4181), 1,
      anon_sym_LPAREN_PIPE,
    STATE(3613), 1,
      sym_active_pattern,
    STATE(3635), 1,
      sym__identifier_or_op,
    ACTIONS(4183), 2,
      sym_op_identifier,
      sym_identifier,
    STATE(5673), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [166370] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8385), 1,
      anon_sym_COMMA,
    ACTIONS(8389), 1,
      anon_sym_when,
    ACTIONS(8537), 1,
      anon_sym_GT,
    STATE(5709), 1,
      aux_sym_type_arguments_repeat1,
    STATE(7034), 1,
      sym_type_argument_constraints,
    STATE(5674), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [166413] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8385), 1,
      anon_sym_COMMA,
    ACTIONS(8389), 1,
      anon_sym_when,
    ACTIONS(8539), 1,
      anon_sym_GT,
    STATE(5709), 1,
      aux_sym_type_arguments_repeat1,
    STATE(6508), 1,
      sym_type_argument_constraints,
    STATE(5675), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [166456] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8385), 1,
      anon_sym_COMMA,
    ACTIONS(8389), 1,
      anon_sym_when,
    ACTIONS(8541), 1,
      anon_sym_GT,
    STATE(5697), 1,
      aux_sym_type_arguments_repeat1,
    STATE(6698), 1,
      sym_type_argument_constraints,
    STATE(5676), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [166499] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8385), 1,
      anon_sym_COMMA,
    ACTIONS(8389), 1,
      anon_sym_when,
    ACTIONS(8543), 1,
      anon_sym_GT,
    STATE(5678), 1,
      aux_sym_type_arguments_repeat1,
    STATE(6499), 1,
      sym_type_argument_constraints,
    STATE(5677), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [166542] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8385), 1,
      anon_sym_COMMA,
    ACTIONS(8389), 1,
      anon_sym_when,
    ACTIONS(8545), 1,
      anon_sym_GT,
    STATE(5709), 1,
      aux_sym_type_arguments_repeat1,
    STATE(6487), 1,
      sym_type_argument_constraints,
    STATE(5678), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [166585] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8385), 1,
      anon_sym_COMMA,
    ACTIONS(8389), 1,
      anon_sym_when,
    ACTIONS(8547), 1,
      anon_sym_GT,
    STATE(5656), 1,
      aux_sym_type_arguments_repeat1,
    STATE(6884), 1,
      sym_type_argument_constraints,
    STATE(5679), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [166628] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8385), 1,
      anon_sym_COMMA,
    ACTIONS(8389), 1,
      anon_sym_when,
    ACTIONS(8549), 1,
      anon_sym_GT,
    STATE(5709), 1,
      aux_sym_type_arguments_repeat1,
    STATE(6688), 1,
      sym_type_argument_constraints,
    STATE(5680), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [166671] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8385), 1,
      anon_sym_COMMA,
    ACTIONS(8389), 1,
      anon_sym_when,
    ACTIONS(8551), 1,
      anon_sym_GT,
    STATE(5682), 1,
      aux_sym_type_arguments_repeat1,
    STATE(6478), 1,
      sym_type_argument_constraints,
    STATE(5681), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [166714] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8385), 1,
      anon_sym_COMMA,
    ACTIONS(8389), 1,
      anon_sym_when,
    ACTIONS(8553), 1,
      anon_sym_GT,
    STATE(5709), 1,
      aux_sym_type_arguments_repeat1,
    STATE(6476), 1,
      sym_type_argument_constraints,
    STATE(5682), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [166757] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8385), 1,
      anon_sym_COMMA,
    ACTIONS(8389), 1,
      anon_sym_when,
    ACTIONS(8555), 1,
      anon_sym_GT,
    STATE(5709), 1,
      aux_sym_type_arguments_repeat1,
    STATE(6455), 1,
      sym_type_argument_constraints,
    STATE(5683), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [166800] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8385), 1,
      anon_sym_COMMA,
    ACTIONS(8389), 1,
      anon_sym_when,
    ACTIONS(8557), 1,
      anon_sym_GT,
    STATE(5704), 1,
      aux_sym_type_arguments_repeat1,
    STATE(6919), 1,
      sym_type_argument_constraints,
    STATE(5684), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [166843] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(957), 1,
      anon_sym_LPAREN_PIPE,
    STATE(2389), 1,
      sym__identifier_or_op,
    STATE(2424), 1,
      sym_active_pattern,
    ACTIONS(2054), 2,
      sym_op_identifier,
      sym_identifier,
    STATE(5685), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [166884] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(261), 1,
      anon_sym_LPAREN_PIPE,
    STATE(1056), 1,
      sym__identifier_or_op,
    STATE(1085), 1,
      sym_active_pattern,
    ACTIONS(1701), 2,
      sym_op_identifier,
      sym_identifier,
    STATE(5686), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [166925] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8385), 1,
      anon_sym_COMMA,
    ACTIONS(8389), 1,
      anon_sym_when,
    ACTIONS(8559), 1,
      anon_sym_GT,
    STATE(5709), 1,
      aux_sym_type_arguments_repeat1,
    STATE(7414), 1,
      sym_type_argument_constraints,
    STATE(5687), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [166968] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8385), 1,
      anon_sym_COMMA,
    ACTIONS(8389), 1,
      anon_sym_when,
    ACTIONS(8561), 1,
      anon_sym_GT,
    STATE(5648), 1,
      aux_sym_type_arguments_repeat1,
    STATE(7108), 1,
      sym_type_argument_constraints,
    STATE(5688), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [167011] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8385), 1,
      anon_sym_COMMA,
    ACTIONS(8389), 1,
      anon_sym_when,
    ACTIONS(8563), 1,
      anon_sym_GT,
    STATE(5687), 1,
      aux_sym_type_arguments_repeat1,
    STATE(7431), 1,
      sym_type_argument_constraints,
    STATE(5689), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [167054] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8302), 1,
      anon_sym__,
    STATE(5731), 1,
      sym__static_type_identifier,
    STATE(6823), 1,
      sym_type_argument,
    ACTIONS(4521), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5690), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [167095] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(8340), 1,
      anon_sym_LPAREN_PIPE,
    STATE(2845), 1,
      sym__identifier_or_op,
    STATE(4156), 1,
      sym_active_pattern,
    ACTIONS(8342), 2,
      sym_op_identifier,
      sym_identifier,
    STATE(5691), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [167136] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8385), 1,
      anon_sym_COMMA,
    ACTIONS(8389), 1,
      anon_sym_when,
    ACTIONS(8565), 1,
      anon_sym_GT,
    STATE(5699), 1,
      aux_sym_type_arguments_repeat1,
    STATE(6930), 1,
      sym_type_argument_constraints,
    STATE(5692), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [167179] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8302), 1,
      anon_sym__,
    STATE(5731), 1,
      sym__static_type_identifier,
    STATE(6738), 1,
      sym_type_argument,
    ACTIONS(4521), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5693), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [167220] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8302), 1,
      anon_sym__,
    STATE(5731), 1,
      sym__static_type_identifier,
    STATE(6783), 1,
      sym_type_argument,
    ACTIONS(4521), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5694), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [167261] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(1339), 1,
      anon_sym_LPAREN_PIPE,
    STATE(2080), 1,
      sym_active_pattern,
    STATE(2084), 1,
      sym__identifier_or_op,
    ACTIONS(1915), 2,
      sym_op_identifier,
      sym_identifier,
    STATE(5695), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [167302] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8302), 1,
      anon_sym__,
    STATE(5731), 1,
      sym__static_type_identifier,
    STATE(6599), 1,
      sym_type_argument,
    ACTIONS(4521), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5696), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [167343] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8385), 1,
      anon_sym_COMMA,
    ACTIONS(8389), 1,
      anon_sym_when,
    ACTIONS(8567), 1,
      anon_sym_GT,
    STATE(5709), 1,
      aux_sym_type_arguments_repeat1,
    STATE(6483), 1,
      sym_type_argument_constraints,
    STATE(5697), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [167386] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8385), 1,
      anon_sym_COMMA,
    ACTIONS(8389), 1,
      anon_sym_when,
    ACTIONS(8569), 1,
      anon_sym_GT,
    STATE(5709), 1,
      aux_sym_type_arguments_repeat1,
    STATE(6899), 1,
      sym_type_argument_constraints,
    STATE(5698), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [167429] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8385), 1,
      anon_sym_COMMA,
    ACTIONS(8389), 1,
      anon_sym_when,
    ACTIONS(8571), 1,
      anon_sym_GT,
    STATE(5709), 1,
      aux_sym_type_arguments_repeat1,
    STATE(6920), 1,
      sym_type_argument_constraints,
    STATE(5699), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [167472] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8385), 1,
      anon_sym_COMMA,
    ACTIONS(8389), 1,
      anon_sym_when,
    ACTIONS(8573), 1,
      anon_sym_GT,
    STATE(5578), 1,
      aux_sym_type_arguments_repeat1,
    STATE(7249), 1,
      sym_type_argument_constraints,
    STATE(5700), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [167515] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8385), 1,
      anon_sym_COMMA,
    ACTIONS(8389), 1,
      anon_sym_when,
    ACTIONS(8575), 1,
      anon_sym_GT,
    STATE(5703), 1,
      aux_sym_type_arguments_repeat1,
    STATE(6998), 1,
      sym_type_argument_constraints,
    STATE(5701), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [167558] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7384), 1,
      anon_sym__,
    STATE(4441), 1,
      sym__static_type_identifier,
    STATE(5902), 1,
      sym_type_argument,
    ACTIONS(7386), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5702), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [167599] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8385), 1,
      anon_sym_COMMA,
    ACTIONS(8389), 1,
      anon_sym_when,
    ACTIONS(8577), 1,
      anon_sym_GT,
    STATE(5709), 1,
      aux_sym_type_arguments_repeat1,
    STATE(6995), 1,
      sym_type_argument_constraints,
    STATE(5703), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [167642] = 13,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8385), 1,
      anon_sym_COMMA,
    ACTIONS(8389), 1,
      anon_sym_when,
    ACTIONS(8579), 1,
      anon_sym_GT,
    STATE(5709), 1,
      aux_sym_type_arguments_repeat1,
    STATE(7062), 1,
      sym_type_argument_constraints,
    STATE(5704), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [167685] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6043), 1,
      anon_sym_let,
    ACTIONS(6045), 3,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
    STATE(5705), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [167721] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2739), 1,
      sym__dedent,
    ACTIONS(8581), 1,
      anon_sym_PIPE,
    ACTIONS(8583), 1,
      sym__newline,
    STATE(5734), 1,
      aux_sym_rules_repeat1,
    STATE(5706), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [167761] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8585), 1,
      anon_sym_new,
    ACTIONS(8587), 1,
      anon_sym_static,
    ACTIONS(8589), 1,
      anon_sym_member,
    STATE(7344), 1,
      sym_trait_member_constraint,
    STATE(5707), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [167801] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8587), 1,
      anon_sym_static,
    ACTIONS(8589), 1,
      anon_sym_member,
    ACTIONS(8591), 1,
      anon_sym_new,
    STATE(6644), 1,
      sym_trait_member_constraint,
    STATE(5708), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [167841] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8593), 1,
      anon_sym_COMMA,
    ACTIONS(8596), 2,
      anon_sym_GT,
      anon_sym_when,
    STATE(5709), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_type_arguments_repeat1,
  [167877] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6291), 1,
      anon_sym_let,
    ACTIONS(6293), 3,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
    STATE(5710), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [167913] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8587), 1,
      anon_sym_static,
    ACTIONS(8589), 1,
      anon_sym_member,
    ACTIONS(8598), 1,
      anon_sym_new,
    STATE(6419), 1,
      sym_trait_member_constraint,
    STATE(5711), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [167953] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8587), 1,
      anon_sym_static,
    ACTIONS(8589), 1,
      anon_sym_member,
    ACTIONS(8600), 1,
      anon_sym_new,
    STATE(7191), 1,
      sym_trait_member_constraint,
    STATE(5712), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [167993] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8587), 1,
      anon_sym_static,
    ACTIONS(8589), 1,
      anon_sym_member,
    ACTIONS(8602), 1,
      anon_sym_new,
    STATE(7106), 1,
      sym_trait_member_constraint,
    STATE(5713), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [168033] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8604), 1,
      anon_sym_interface,
    ACTIONS(8607), 1,
      sym__dedent,
    STATE(6107), 1,
      sym_interface_implementation,
    STATE(5714), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym__object_expression_inner_repeat1,
  [168071] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8609), 1,
      anon_sym_interface,
    ACTIONS(8611), 1,
      sym__dedent,
    STATE(5721), 1,
      aux_sym__object_expression_inner_repeat1,
    STATE(6107), 1,
      sym_interface_implementation,
    STATE(5715), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [168111] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8609), 1,
      anon_sym_interface,
    ACTIONS(8613), 1,
      sym__dedent,
    STATE(5714), 1,
      aux_sym__object_expression_inner_repeat1,
    STATE(6107), 1,
      sym_interface_implementation,
    STATE(5716), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [168151] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8587), 1,
      anon_sym_static,
    ACTIONS(8589), 1,
      anon_sym_member,
    ACTIONS(8615), 1,
      anon_sym_new,
    STATE(6660), 1,
      sym_trait_member_constraint,
    STATE(5717), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [168191] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8617), 1,
      sym_identifier,
    STATE(5913), 1,
      sym_field_initializer,
    STATE(6500), 1,
      sym_long_identifier,
    STATE(6859), 1,
      sym_field_initializers,
    STATE(5718), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [168231] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6451), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(8425), 1,
      sym_identifier,
    STATE(4887), 1,
      sym_member_signature,
    STATE(6242), 1,
      sym_access_modifier,
    STATE(5719), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [168271] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2691), 1,
      sym__dedent,
    ACTIONS(8581), 1,
      anon_sym_PIPE,
    ACTIONS(8583), 1,
      sym__newline,
    STATE(5722), 1,
      aux_sym_rules_repeat1,
    STATE(5720), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [168311] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8609), 1,
      anon_sym_interface,
    ACTIONS(8619), 1,
      sym__dedent,
    STATE(5714), 1,
      aux_sym__object_expression_inner_repeat1,
    STATE(6107), 1,
      sym_interface_implementation,
    STATE(5721), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [168351] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2700), 1,
      sym__dedent,
    ACTIONS(8581), 1,
      anon_sym_PIPE,
    ACTIONS(8583), 1,
      sym__newline,
    STATE(5734), 1,
      aux_sym_rules_repeat1,
    STATE(5722), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [168391] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6451), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(8621), 1,
      sym_identifier,
    ACTIONS(8623), 1,
      anon_sym_mutable,
    STATE(6662), 1,
      sym_access_modifier,
    STATE(5723), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [168431] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2700), 1,
      sym__dedent,
    ACTIONS(8581), 1,
      anon_sym_PIPE,
    ACTIONS(8583), 1,
      sym__newline,
    STATE(5706), 1,
      aux_sym_rules_repeat1,
    STATE(5724), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [168471] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6451), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(8625), 1,
      sym_identifier,
    ACTIONS(8627), 1,
      anon_sym_mutable,
    STATE(7166), 1,
      sym_access_modifier,
    STATE(5725), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [168511] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8587), 1,
      anon_sym_static,
    ACTIONS(8589), 1,
      anon_sym_member,
    ACTIONS(8629), 1,
      anon_sym_new,
    STATE(7047), 1,
      sym_trait_member_constraint,
    STATE(5726), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [168551] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6105), 1,
      anon_sym_let,
    ACTIONS(6107), 3,
      anon_sym_LBRACK_LT,
      anon_sym_do,
      anon_sym_let_BANG,
    STATE(5727), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [168587] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6451), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(8631), 1,
      sym_identifier,
    ACTIONS(8633), 1,
      anon_sym_mutable,
    STATE(6797), 1,
      sym_access_modifier,
    STATE(5728), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [168627] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6451), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(8425), 1,
      sym_identifier,
    STATE(4880), 1,
      sym_member_signature,
    STATE(6150), 1,
      sym_access_modifier,
    STATE(5729), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [168667] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2687), 4,
      ts_builtin_sym_end,
      anon_sym_LBRACK_LT,
      anon_sym_RPAREN,
      anon_sym_val,
    STATE(5730), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [168701] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2321), 1,
      anon_sym_COLON,
    ACTIONS(2323), 1,
      anon_sym_COLON_GT,
    ACTIONS(8635), 1,
      anon_sym_or,
    STATE(4520), 1,
      aux_sym_type_argument_repeat1,
    STATE(5731), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [168741] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6451), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(8637), 1,
      sym_identifier,
    ACTIONS(8639), 1,
      anon_sym_mutable,
    STATE(6441), 1,
      sym_access_modifier,
    STATE(5732), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [168781] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8609), 1,
      anon_sym_interface,
    ACTIONS(8641), 1,
      sym__dedent,
    STATE(5716), 1,
      aux_sym__object_expression_inner_repeat1,
    STATE(6107), 1,
      sym_interface_implementation,
    STATE(5733), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [168821] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2715), 1,
      sym__dedent,
    ACTIONS(8643), 1,
      anon_sym_PIPE,
    ACTIONS(8646), 1,
      sym__newline,
    STATE(5734), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_rules_repeat1,
  [168859] = 12,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8587), 1,
      anon_sym_static,
    ACTIONS(8589), 1,
      anon_sym_member,
    ACTIONS(8649), 1,
      anon_sym_new,
    STATE(6876), 1,
      sym_trait_member_constraint,
    STATE(5735), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [168899] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7567), 1,
      sym__newline,
    ACTIONS(8651), 1,
      sym__dedent,
    STATE(5757), 1,
      aux_sym__list_pattern_content_repeat1,
    STATE(5736), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [168936] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8653), 1,
      anon_sym_PIPE,
    ACTIONS(8655), 1,
      anon_sym_PIPE_RPAREN,
    STATE(5987), 1,
      aux_sym_active_pattern_repeat1,
    STATE(5737), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [168973] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8657), 1,
      anon_sym_with,
    ACTIONS(8659), 1,
      anon_sym_finally,
    ACTIONS(8661), 1,
      sym__newline,
    STATE(5738), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [169010] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2687), 3,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_val,
    STATE(5739), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [169043] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8663), 1,
      sym__newline,
    ACTIONS(8665), 1,
      sym__dedent,
    STATE(5835), 1,
      aux_sym__list_elements_repeat1,
    STATE(5740), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [169080] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8667), 1,
      anon_sym_RBRACK,
    ACTIONS(8669), 1,
      sym__indent,
    STATE(6528), 1,
      sym__list_element,
    STATE(5741), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [169117] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2687), 3,
      sym__newline,
      anon_sym_with,
      anon_sym_finally,
    STATE(5742), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [169150] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8671), 1,
      anon_sym_COMMA,
    ACTIONS(8674), 1,
      sym__dedent,
    STATE(5743), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_slice_ranges_repeat1,
  [169185] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8676), 1,
      anon_sym_RBRACE,
    ACTIONS(8678), 1,
      sym__newline,
    STATE(5865), 1,
      aux_sym_record_pattern_repeat1,
    STATE(5744), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [169222] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8680), 1,
      sym_identifier,
    STATE(5789), 1,
      sym_field_pattern,
    STATE(7209), 1,
      sym_long_identifier,
    STATE(5745), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [169259] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4681), 1,
      sym__dedent,
    ACTIONS(8682), 1,
      anon_sym_and,
    STATE(5750), 1,
      aux_sym__function_or_value_defns_repeat1,
    STATE(5746), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [169296] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8669), 1,
      sym__indent,
    ACTIONS(8684), 1,
      anon_sym_PIPE_RBRACK,
    STATE(6534), 1,
      sym__list_element,
    STATE(5747), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [169333] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4685), 1,
      sym__dedent,
    ACTIONS(8682), 1,
      anon_sym_and,
    STATE(5746), 1,
      aux_sym__function_or_value_defns_repeat1,
    STATE(5748), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [169370] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    STATE(3372), 1,
      sym__static_type_identifier,
    ACTIONS(7745), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5749), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [169405] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4692), 1,
      sym__dedent,
    ACTIONS(8686), 1,
      anon_sym_and,
    STATE(5750), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym__function_or_value_defns_repeat1,
  [169440] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8689), 1,
      anon_sym_RPAREN,
    ACTIONS(8691), 1,
      sym__newline,
    STATE(5816), 1,
      aux_sym_named_field_pattern_repeat1,
    STATE(5751), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [169477] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8693), 1,
      anon_sym_PIPE_RBRACK,
    ACTIONS(8695), 1,
      sym__indent,
    STATE(6470), 1,
      sym__list_pattern_content,
    STATE(5752), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [169514] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    STATE(3085), 1,
      sym__static_type_identifier,
    ACTIONS(6031), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5753), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [169549] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8695), 1,
      sym__indent,
    ACTIONS(8697), 1,
      anon_sym_RBRACK,
    STATE(6467), 1,
      sym__list_pattern_content,
    STATE(5754), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [169586] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8699), 3,
      ts_builtin_sym_end,
      anon_sym_LBRACK_LT,
      anon_sym_val,
    STATE(5755), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [169619] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8701), 1,
      anon_sym_PIPE,
    ACTIONS(8703), 1,
      anon_sym_PIPE_RPAREN,
    STATE(5759), 1,
      aux_sym_active_pattern_repeat1,
    STATE(5756), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [169656] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7966), 1,
      sym__dedent,
    ACTIONS(8705), 1,
      sym__newline,
    STATE(5757), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym__list_pattern_content_repeat1,
  [169691] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8708), 1,
      anon_sym_DOT,
    ACTIONS(2865), 2,
      anon_sym_EQ,
      anon_sym_COLON,
    STATE(5758), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [169726] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8710), 1,
      anon_sym_PIPE,
    ACTIONS(8712), 1,
      anon_sym_PIPE_RPAREN,
    STATE(5853), 1,
      aux_sym_active_pattern_repeat1,
    STATE(5759), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [169763] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8714), 3,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_val,
    STATE(5760), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [169796] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    STATE(1207), 1,
      sym__static_type_identifier,
    ACTIONS(6233), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5761), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [169831] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8716), 3,
      ts_builtin_sym_end,
      anon_sym_LBRACK_LT,
      anon_sym_val,
    STATE(5762), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [169864] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8718), 3,
      ts_builtin_sym_end,
      anon_sym_LBRACK_LT,
      anon_sym_val,
    STATE(5763), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [169897] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8674), 1,
      anon_sym_RBRACK,
    ACTIONS(8720), 1,
      anon_sym_COMMA,
    STATE(5764), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_slice_ranges_repeat1,
  [169932] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8680), 1,
      sym_identifier,
    STATE(5848), 1,
      sym_field_pattern,
    STATE(7209), 1,
      sym_long_identifier,
    STATE(5765), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [169969] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8699), 3,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_val,
    STATE(5766), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [170002] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    STATE(3102), 1,
      sym__static_type_identifier,
    ACTIONS(6041), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5767), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [170037] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8723), 1,
      anon_sym_COMMA,
    ACTIONS(8726), 1,
      anon_sym_GT,
    STATE(5768), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_type_attributes_repeat1,
  [170072] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8728), 1,
      anon_sym_GT_RBRACK,
    ACTIONS(8730), 1,
      sym__newline,
    STATE(5773), 1,
      aux_sym__attribute_set_repeat1,
    STATE(5769), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [170109] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8695), 1,
      sym__indent,
    ACTIONS(8732), 1,
      anon_sym_RBRACK,
    STATE(7449), 1,
      sym__list_pattern_content,
    STATE(5770), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [170146] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8734), 1,
      anon_sym_PIPE,
    ACTIONS(8736), 1,
      anon_sym_PIPE_RPAREN,
    STATE(5897), 1,
      aux_sym_active_pattern_repeat1,
    STATE(5771), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [170183] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8695), 1,
      sym__indent,
    ACTIONS(8738), 1,
      anon_sym_PIPE_RBRACK,
    STATE(7448), 1,
      sym__list_pattern_content,
    STATE(5772), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [170220] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8730), 1,
      sym__newline,
    ACTIONS(8740), 1,
      anon_sym_GT_RBRACK,
    STATE(5969), 1,
      aux_sym__attribute_set_repeat1,
    STATE(5773), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [170257] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    STATE(2993), 1,
      sym__static_type_identifier,
    ACTIONS(6139), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5774), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [170292] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    STATE(5180), 1,
      sym__static_type_identifier,
    ACTIONS(7421), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5775), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [170327] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8669), 1,
      sym__indent,
    ACTIONS(8742), 1,
      anon_sym_RBRACK,
    STATE(7423), 1,
      sym__list_element,
    STATE(5776), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [170364] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8669), 1,
      sym__indent,
    ACTIONS(8744), 1,
      anon_sym_PIPE_RBRACK,
    STATE(7421), 1,
      sym__list_element,
    STATE(5777), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [170401] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    STATE(4421), 1,
      sym__static_type_identifier,
    ACTIONS(6269), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5778), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [170436] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    STATE(3010), 1,
      sym__static_type_identifier,
    ACTIONS(5977), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5779), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [170471] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8746), 1,
      anon_sym_COMMA,
    ACTIONS(8748), 1,
      anon_sym_RBRACK,
    STATE(5764), 1,
      aux_sym_slice_ranges_repeat1,
    STATE(5780), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [170508] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    STATE(4636), 1,
      sym__static_type_identifier,
    ACTIONS(4521), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5781), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [170543] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8750), 1,
      anon_sym_with,
    ACTIONS(8752), 1,
      anon_sym_finally,
    ACTIONS(8754), 1,
      sym__newline,
    STATE(5782), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [170580] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    STATE(3057), 1,
      sym__static_type_identifier,
    ACTIONS(6279), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5783), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [170615] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8730), 1,
      sym__newline,
    ACTIONS(8756), 1,
      anon_sym_GT_RBRACK,
    STATE(5859), 1,
      aux_sym__attribute_set_repeat1,
    STATE(5784), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [170652] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7355), 1,
      anon_sym_COMMA,
    ACTIONS(8758), 1,
      anon_sym_GT,
    STATE(5891), 1,
      aux_sym_types_repeat1,
    STATE(5785), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [170689] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8760), 1,
      anon_sym_PIPE,
    ACTIONS(8762), 1,
      anon_sym_PIPE_RPAREN,
    STATE(5790), 1,
      aux_sym_active_pattern_repeat1,
    STATE(5786), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [170726] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    STATE(4374), 1,
      sym__static_type_identifier,
    ACTIONS(6161), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5787), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [170761] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8678), 1,
      sym__newline,
    ACTIONS(8764), 1,
      anon_sym_RBRACE,
    STATE(5820), 1,
      aux_sym_record_pattern_repeat1,
    STATE(5788), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [170798] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8678), 1,
      sym__newline,
    ACTIONS(8766), 1,
      anon_sym_RBRACE,
    STATE(5799), 1,
      aux_sym_record_pattern_repeat1,
    STATE(5789), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [170835] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8768), 1,
      anon_sym_PIPE,
    ACTIONS(8770), 1,
      anon_sym_PIPE_RPAREN,
    STATE(5853), 1,
      aux_sym_active_pattern_repeat1,
    STATE(5790), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [170872] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8772), 1,
      anon_sym_PIPE,
    ACTIONS(8774), 1,
      anon_sym_PIPE_RPAREN,
    STATE(5801), 1,
      aux_sym_active_pattern_repeat1,
    STATE(5791), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [170909] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8695), 1,
      sym__indent,
    ACTIONS(8776), 1,
      anon_sym_RBRACK,
    STATE(7219), 1,
      sym__list_pattern_content,
    STATE(5792), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [170946] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    STATE(2924), 1,
      sym__static_type_identifier,
    ACTIONS(6181), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5793), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [170981] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8691), 1,
      sym__newline,
    ACTIONS(8778), 1,
      anon_sym_RPAREN,
    STATE(5798), 1,
      aux_sym_named_field_pattern_repeat1,
    STATE(5794), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [171018] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8695), 1,
      sym__indent,
    ACTIONS(8780), 1,
      anon_sym_PIPE_RBRACK,
    STATE(7211), 1,
      sym__list_pattern_content,
    STATE(5795), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [171055] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8680), 1,
      sym_identifier,
    STATE(5907), 1,
      sym_field_pattern,
    STATE(7209), 1,
      sym_long_identifier,
    STATE(5796), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [171092] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5419), 1,
      anon_sym_GT,
    ACTIONS(8782), 1,
      anon_sym_and,
    STATE(5862), 1,
      aux_sym_type_argument_constraints_repeat1,
    STATE(5797), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [171129] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8691), 1,
      sym__newline,
    ACTIONS(8784), 1,
      anon_sym_RPAREN,
    STATE(5872), 1,
      aux_sym_named_field_pattern_repeat1,
    STATE(5798), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [171166] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8678), 1,
      sym__newline,
    ACTIONS(8786), 1,
      anon_sym_RBRACE,
    STATE(5865), 1,
      aux_sym_record_pattern_repeat1,
    STATE(5799), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [171203] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8596), 3,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_when,
    STATE(5800), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [171236] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8788), 1,
      anon_sym_PIPE,
    ACTIONS(8790), 1,
      anon_sym_PIPE_RPAREN,
    STATE(5853), 1,
      aux_sym_active_pattern_repeat1,
    STATE(5801), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [171273] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8746), 1,
      anon_sym_COMMA,
    ACTIONS(8792), 1,
      anon_sym_RBRACK,
    STATE(5780), 1,
      aux_sym_slice_ranges_repeat1,
    STATE(5802), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [171310] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8794), 1,
      anon_sym_PIPE,
    ACTIONS(8796), 1,
      anon_sym_PIPE_RPAREN,
    STATE(5821), 1,
      aux_sym_active_pattern_repeat1,
    STATE(5803), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [171347] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    STATE(4387), 1,
      sym__static_type_identifier,
    ACTIONS(6315), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5804), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [171382] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8680), 1,
      sym_identifier,
    STATE(5938), 1,
      sym_field_pattern,
    STATE(7209), 1,
      sym_long_identifier,
    STATE(5805), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [171419] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8798), 1,
      anon_sym_DASH_GT,
    ACTIONS(8800), 1,
      anon_sym_STAR,
    STATE(5963), 1,
      aux_sym_arguments_spec_repeat1,
    STATE(5806), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [171456] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8802), 1,
      sym__newline,
    ACTIONS(8805), 1,
      sym__dedent,
    STATE(5807), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_field_initializers_repeat1,
  [171491] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    STATE(2965), 1,
      sym__static_type_identifier,
    ACTIONS(6021), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5808), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [171526] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8807), 1,
      anon_sym_with,
    ACTIONS(8809), 1,
      anon_sym_finally,
    ACTIONS(8811), 1,
      sym__newline,
    STATE(5809), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [171563] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8813), 1,
      anon_sym_PIPE,
    ACTIONS(8815), 1,
      anon_sym_PIPE_RPAREN,
    STATE(5853), 1,
      aux_sym_active_pattern_repeat1,
    STATE(5810), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [171600] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6451), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(8817), 1,
      sym_identifier,
    STATE(6937), 1,
      sym_access_modifier,
    STATE(5811), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [171637] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    STATE(4199), 1,
      sym__static_type_identifier,
    ACTIONS(5465), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5812), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [171672] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    STATE(4287), 1,
      sym__static_type_identifier,
    ACTIONS(5846), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5813), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [171707] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8819), 1,
      sym__newline,
    ACTIONS(8821), 1,
      sym__dedent,
    STATE(5807), 1,
      aux_sym_field_initializers_repeat1,
    STATE(5814), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [171744] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8617), 1,
      sym_identifier,
    STATE(6340), 1,
      sym_field_initializer,
    STATE(6500), 1,
      sym_long_identifier,
    STATE(5815), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [171781] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8691), 1,
      sym__newline,
    ACTIONS(8823), 1,
      anon_sym_RPAREN,
    STATE(5872), 1,
      aux_sym_named_field_pattern_repeat1,
    STATE(5816), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [171818] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8748), 1,
      sym__dedent,
    ACTIONS(8825), 1,
      anon_sym_COMMA,
    STATE(5743), 1,
      aux_sym_slice_ranges_repeat1,
    STATE(5817), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [171855] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8691), 1,
      sym__newline,
    ACTIONS(8827), 1,
      anon_sym_RPAREN,
    STATE(5872), 1,
      aux_sym_named_field_pattern_repeat1,
    STATE(5818), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [171892] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8829), 1,
      anon_sym_PIPE,
    ACTIONS(8831), 1,
      anon_sym_PIPE_RPAREN,
    STATE(5823), 1,
      aux_sym_active_pattern_repeat1,
    STATE(5819), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [171929] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8678), 1,
      sym__newline,
    ACTIONS(8833), 1,
      anon_sym_RBRACE,
    STATE(5865), 1,
      aux_sym_record_pattern_repeat1,
    STATE(5820), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [171966] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8835), 1,
      anon_sym_PIPE,
    ACTIONS(8837), 1,
      anon_sym_PIPE_RPAREN,
    STATE(5853), 1,
      aux_sym_active_pattern_repeat1,
    STATE(5821), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [172003] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2768), 3,
      sym__newline,
      sym__dedent,
      anon_sym_PIPE,
    STATE(5822), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [172036] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8839), 1,
      anon_sym_PIPE,
    ACTIONS(8841), 1,
      anon_sym_PIPE_RPAREN,
    STATE(5853), 1,
      aux_sym_active_pattern_repeat1,
    STATE(5823), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [172073] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    STATE(1083), 1,
      sym__static_type_identifier,
    ACTIONS(6243), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5824), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [172108] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8680), 1,
      sym_identifier,
    STATE(6000), 1,
      sym_field_pattern,
    STATE(7209), 1,
      sym_long_identifier,
    STATE(5825), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [172145] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(861), 1,
      sym__dedent,
    ACTIONS(8663), 1,
      sym__newline,
    STATE(5835), 1,
      aux_sym__list_elements_repeat1,
    STATE(5826), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [172182] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8843), 1,
      anon_sym_with,
    ACTIONS(8845), 1,
      anon_sym_finally,
    ACTIONS(8847), 1,
      sym__newline,
    STATE(5827), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [172219] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2715), 3,
      sym__newline,
      sym__dedent,
      anon_sym_PIPE,
    STATE(5828), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [172252] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8730), 1,
      sym__newline,
    ACTIONS(8849), 1,
      anon_sym_GT_RBRACK,
    STATE(5834), 1,
      aux_sym__attribute_set_repeat1,
    STATE(5829), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [172289] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8695), 1,
      sym__indent,
    ACTIONS(8851), 1,
      anon_sym_RBRACK,
    STATE(7322), 1,
      sym__list_pattern_content,
    STATE(5830), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [172326] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8695), 1,
      sym__indent,
    ACTIONS(8853), 1,
      anon_sym_PIPE_RBRACK,
    STATE(7316), 1,
      sym__list_pattern_content,
    STATE(5831), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [172363] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8855), 1,
      sym__newline,
    ACTIONS(8858), 1,
      sym__dedent,
    STATE(5832), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_record_fields_repeat1,
  [172398] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8860), 1,
      anon_sym_PIPE,
    ACTIONS(8862), 1,
      anon_sym_PIPE_RPAREN,
    STATE(5810), 1,
      aux_sym_active_pattern_repeat1,
    STATE(5833), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [172435] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8730), 1,
      sym__newline,
    ACTIONS(8864), 1,
      anon_sym_GT_RBRACK,
    STATE(5969), 1,
      aux_sym__attribute_set_repeat1,
    STATE(5834), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [172472] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8866), 1,
      sym__newline,
    ACTIONS(8869), 1,
      sym__dedent,
    STATE(5835), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym__list_elements_repeat1,
  [172507] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    STATE(1360), 1,
      sym__static_type_identifier,
    ACTIONS(5892), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5836), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [172542] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8669), 1,
      sym__indent,
    ACTIONS(8871), 1,
      anon_sym_RBRACK,
    STATE(7295), 1,
      sym__list_element,
    STATE(5837), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [172579] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8678), 1,
      sym__newline,
    ACTIONS(8873), 1,
      anon_sym_RBRACE,
    STATE(5744), 1,
      aux_sym_record_pattern_repeat1,
    STATE(5838), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [172616] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8669), 1,
      sym__indent,
    ACTIONS(8875), 1,
      anon_sym_PIPE_RBRACK,
    STATE(7293), 1,
      sym__list_element,
    STATE(5839), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [172653] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8691), 1,
      sym__newline,
    ACTIONS(8877), 1,
      anon_sym_RPAREN,
    STATE(5818), 1,
      aux_sym_named_field_pattern_repeat1,
    STATE(5840), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [172690] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    STATE(4584), 1,
      sym__static_type_identifier,
    ACTIONS(7386), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5841), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [172725] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    STATE(4323), 1,
      sym__static_type_identifier,
    ACTIONS(6213), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5842), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [172760] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    STATE(1394), 1,
      sym__static_type_identifier,
    ACTIONS(6303), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5843), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [172795] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8691), 1,
      sym__newline,
    ACTIONS(8879), 1,
      anon_sym_RPAREN,
    STATE(5856), 1,
      aux_sym_named_field_pattern_repeat1,
    STATE(5844), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [172832] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8669), 1,
      sym__indent,
    ACTIONS(8881), 1,
      anon_sym_PIPE_RBRACK,
    STATE(6551), 1,
      sym__list_element,
    STATE(5845), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [172869] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8669), 1,
      sym__indent,
    ACTIONS(8883), 1,
      anon_sym_RBRACK,
    STATE(6559), 1,
      sym__list_element,
    STATE(5846), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [172906] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8885), 1,
      anon_sym_PIPE,
    ACTIONS(8887), 1,
      anon_sym_PIPE_RPAREN,
    STATE(5853), 1,
      aux_sym_active_pattern_repeat1,
    STATE(5847), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [172943] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8678), 1,
      sym__newline,
    ACTIONS(8889), 1,
      anon_sym_RBRACE,
    STATE(5857), 1,
      aux_sym_record_pattern_repeat1,
    STATE(5848), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [172980] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8680), 1,
      sym_identifier,
    STATE(5943), 1,
      sym_field_pattern,
    STATE(7209), 1,
      sym_long_identifier,
    STATE(5849), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [173017] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8891), 1,
      anon_sym_PIPE,
    ACTIONS(8893), 1,
      anon_sym_PIPE_RPAREN,
    STATE(5854), 1,
      aux_sym_active_pattern_repeat1,
    STATE(5850), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [173054] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8895), 1,
      anon_sym_PIPE,
    ACTIONS(8897), 1,
      anon_sym_PIPE_RPAREN,
    STATE(5861), 1,
      aux_sym_active_pattern_repeat1,
    STATE(5851), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [173091] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    STATE(4363), 1,
      sym__static_type_identifier,
    ACTIONS(6079), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5852), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [173126] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8899), 1,
      anon_sym_PIPE,
    ACTIONS(8902), 1,
      anon_sym_PIPE_RPAREN,
    STATE(5853), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_active_pattern_repeat1,
  [173161] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8904), 1,
      anon_sym_PIPE,
    ACTIONS(8906), 1,
      anon_sym_PIPE_RPAREN,
    STATE(5853), 1,
      aux_sym_active_pattern_repeat1,
    STATE(5854), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [173198] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8695), 1,
      sym__indent,
    ACTIONS(8908), 1,
      anon_sym_PIPE_RBRACK,
    STATE(6588), 1,
      sym__list_pattern_content,
    STATE(5855), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [173235] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8691), 1,
      sym__newline,
    ACTIONS(8910), 1,
      anon_sym_RPAREN,
    STATE(5872), 1,
      aux_sym_named_field_pattern_repeat1,
    STATE(5856), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [173272] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8678), 1,
      sym__newline,
    ACTIONS(8912), 1,
      anon_sym_RBRACE,
    STATE(5865), 1,
      aux_sym_record_pattern_repeat1,
    STATE(5857), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [173309] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8695), 1,
      sym__indent,
    ACTIONS(8914), 1,
      anon_sym_RBRACK,
    STATE(6593), 1,
      sym__list_pattern_content,
    STATE(5858), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [173346] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8730), 1,
      sym__newline,
    ACTIONS(8916), 1,
      anon_sym_GT_RBRACK,
    STATE(5969), 1,
      aux_sym__attribute_set_repeat1,
    STATE(5859), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [173383] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8918), 1,
      anon_sym_with,
    ACTIONS(8920), 1,
      anon_sym_finally,
    ACTIONS(8922), 1,
      sym__newline,
    STATE(5860), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [173420] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8924), 1,
      anon_sym_PIPE,
    ACTIONS(8926), 1,
      anon_sym_PIPE_RPAREN,
    STATE(5853), 1,
      aux_sym_active_pattern_repeat1,
    STATE(5861), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [173457] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5411), 1,
      anon_sym_GT,
    ACTIONS(8782), 1,
      anon_sym_and,
    STATE(5979), 1,
      aux_sym_type_argument_constraints_repeat1,
    STATE(5862), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [173494] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    STATE(1183), 1,
      sym__static_type_identifier,
    ACTIONS(5950), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5863), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [173529] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8928), 1,
      anon_sym_EQ,
    ACTIONS(8930), 1,
      anon_sym_COLON,
    STATE(4910), 1,
      sym__val_property_defn,
    STATE(5864), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [173566] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8932), 1,
      anon_sym_RBRACE,
    ACTIONS(8934), 1,
      sym__newline,
    STATE(5865), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_record_pattern_repeat1,
  [173601] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7567), 1,
      sym__newline,
    ACTIONS(7747), 1,
      sym__dedent,
    STATE(5757), 1,
      aux_sym__list_pattern_content_repeat1,
    STATE(5866), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [173638] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8669), 1,
      sym__indent,
    ACTIONS(8937), 1,
      anon_sym_RBRACK,
    STATE(7069), 1,
      sym__list_element,
    STATE(5867), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [173675] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8669), 1,
      sym__indent,
    ACTIONS(8939), 1,
      anon_sym_PIPE_RBRACK,
    STATE(7065), 1,
      sym__list_element,
    STATE(5868), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [173712] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8941), 1,
      anon_sym_PIPE,
    ACTIONS(8943), 1,
      anon_sym_PIPE_RPAREN,
    STATE(5847), 1,
      aux_sym_active_pattern_repeat1,
    STATE(5869), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [173749] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    STATE(5199), 1,
      sym__static_type_identifier,
    ACTIONS(5858), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5870), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [173784] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8680), 1,
      sym_identifier,
    STATE(5838), 1,
      sym_field_pattern,
    STATE(7209), 1,
      sym_long_identifier,
    STATE(5871), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [173821] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8945), 1,
      anon_sym_RPAREN,
    ACTIONS(8947), 1,
      sym__newline,
    STATE(5872), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_named_field_pattern_repeat1,
  [173856] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2762), 3,
      sym__newline,
      sym__dedent,
      anon_sym_PIPE,
    STATE(5873), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [173889] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    STATE(1311), 1,
      sym__static_type_identifier,
    ACTIONS(6129), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5874), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [173924] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    STATE(3401), 1,
      sym__static_type_identifier,
    ACTIONS(7654), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5875), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [173959] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8669), 1,
      sym__indent,
    ACTIONS(8950), 1,
      anon_sym_PIPE_RBRACK,
    STATE(7279), 1,
      sym__list_element,
    STATE(5876), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [173996] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8669), 1,
      sym__indent,
    ACTIONS(8952), 1,
      anon_sym_RBRACK,
    STATE(7277), 1,
      sym__list_element,
    STATE(5877), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [174033] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8695), 1,
      sym__indent,
    ACTIONS(8954), 1,
      anon_sym_RBRACK,
    STATE(6679), 1,
      sym__list_pattern_content,
    STATE(5878), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [174070] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8678), 1,
      sym__newline,
    ACTIONS(8956), 1,
      anon_sym_RBRACE,
    STATE(5865), 1,
      aux_sym_record_pattern_repeat1,
    STATE(5879), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [174107] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8958), 1,
      anon_sym_with,
    ACTIONS(8960), 1,
      anon_sym_finally,
    ACTIONS(8962), 1,
      sym__newline,
    STATE(5880), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [174144] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8964), 1,
      anon_sym_PIPE,
    ACTIONS(8966), 1,
      anon_sym_PIPE_RPAREN,
    STATE(5885), 1,
      aux_sym_active_pattern_repeat1,
    STATE(5881), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [174181] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8695), 1,
      sym__indent,
    ACTIONS(8968), 1,
      anon_sym_PIPE_RBRACK,
    STATE(6694), 1,
      sym__list_pattern_content,
    STATE(5882), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [174218] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    STATE(1349), 1,
      sym__static_type_identifier,
    ACTIONS(5912), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5883), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [174253] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8669), 1,
      sym__indent,
    ACTIONS(8970), 1,
      anon_sym_RBRACK,
    STATE(6724), 1,
      sym__list_element,
    STATE(5884), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [174290] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8972), 1,
      anon_sym_PIPE,
    ACTIONS(8974), 1,
      anon_sym_PIPE_RPAREN,
    STATE(5853), 1,
      aux_sym_active_pattern_repeat1,
    STATE(5885), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [174327] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8669), 1,
      sym__indent,
    ACTIONS(8976), 1,
      anon_sym_PIPE_RBRACK,
    STATE(6726), 1,
      sym__list_element,
    STATE(5886), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [174364] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    STATE(2748), 1,
      sym__static_type_identifier,
    ACTIONS(5355), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5887), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [174399] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    STATE(934), 1,
      sym__static_type_identifier,
    ACTIONS(6201), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5888), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [174434] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8978), 1,
      anon_sym_COMMA,
    ACTIONS(8980), 1,
      anon_sym_GT,
    STATE(5768), 1,
      aux_sym_type_attributes_repeat1,
    STATE(5889), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [174471] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8691), 1,
      sym__newline,
    ACTIONS(8982), 1,
      anon_sym_RPAREN,
    STATE(5978), 1,
      aux_sym_named_field_pattern_repeat1,
    STATE(5890), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [174508] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7678), 1,
      anon_sym_GT,
    ACTIONS(8984), 1,
      anon_sym_COMMA,
    STATE(5891), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_types_repeat1,
  [174543] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    STATE(1204), 1,
      sym__static_type_identifier,
    ACTIONS(6191), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5892), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [174578] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8678), 1,
      sym__newline,
    ACTIONS(8987), 1,
      anon_sym_RBRACE,
    STATE(5906), 1,
      aux_sym_record_pattern_repeat1,
    STATE(5893), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [174615] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    STATE(4231), 1,
      sym__static_type_identifier,
    ACTIONS(5882), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5894), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [174650] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8989), 1,
      anon_sym_and,
    ACTIONS(8991), 1,
      sym__dedent,
    STATE(5990), 1,
      aux_sym__property_defn_repeat1,
    STATE(5895), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [174687] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8718), 3,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_val,
    STATE(5896), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [174720] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8993), 1,
      anon_sym_PIPE,
    ACTIONS(8995), 1,
      anon_sym_PIPE_RPAREN,
    STATE(5853), 1,
      aux_sym_active_pattern_repeat1,
    STATE(5897), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [174757] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8716), 3,
      sym__dedent,
      anon_sym_LBRACK_LT,
      anon_sym_val,
    STATE(5898), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [174790] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8680), 1,
      sym_identifier,
    STATE(5788), 1,
      sym_field_pattern,
    STATE(7209), 1,
      sym_long_identifier,
    STATE(5899), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [174827] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6875), 1,
      anon_sym_LT2,
    ACTIONS(8997), 1,
      anon_sym_COLON,
    STATE(6744), 1,
      sym_type_arguments,
    STATE(5900), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [174864] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8999), 1,
      anon_sym_PIPE,
    ACTIONS(9001), 1,
      anon_sym_PIPE_RPAREN,
    STATE(5908), 1,
      aux_sym_active_pattern_repeat1,
    STATE(5901), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [174901] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9003), 3,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_when,
    STATE(5902), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [174934] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    STATE(4491), 1,
      sym__static_type_identifier,
    ACTIONS(6257), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5903), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [174969] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9005), 1,
      anon_sym_with,
    ACTIONS(9007), 1,
      anon_sym_finally,
    ACTIONS(9009), 1,
      sym__newline,
    STATE(5904), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [175006] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    STATE(4649), 1,
      sym__static_type_identifier,
    ACTIONS(5870), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5905), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [175041] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8678), 1,
      sym__newline,
    ACTIONS(9011), 1,
      anon_sym_RBRACE,
    STATE(5865), 1,
      aux_sym_record_pattern_repeat1,
    STATE(5906), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [175078] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8678), 1,
      sym__newline,
    ACTIONS(9013), 1,
      anon_sym_RBRACE,
    STATE(5968), 1,
      aux_sym_record_pattern_repeat1,
    STATE(5907), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [175115] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9015), 1,
      anon_sym_PIPE,
    ACTIONS(9017), 1,
      anon_sym_PIPE_RPAREN,
    STATE(5853), 1,
      aux_sym_active_pattern_repeat1,
    STATE(5908), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [175152] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8714), 3,
      ts_builtin_sym_end,
      anon_sym_LBRACK_LT,
      anon_sym_val,
    STATE(5909), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [175185] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9019), 1,
      anon_sym_PIPE,
    ACTIONS(9021), 1,
      anon_sym_PIPE_RPAREN,
    STATE(5914), 1,
      aux_sym_active_pattern_repeat1,
    STATE(5910), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [175222] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    STATE(2961), 1,
      sym__static_type_identifier,
    ACTIONS(6103), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5911), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [175257] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8680), 1,
      sym_identifier,
    STATE(5893), 1,
      sym_field_pattern,
    STATE(7209), 1,
      sym_long_identifier,
    STATE(5912), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [175294] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8819), 1,
      sym__newline,
    ACTIONS(9023), 1,
      sym__dedent,
    STATE(5814), 1,
      aux_sym_field_initializers_repeat1,
    STATE(5913), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [175331] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9025), 1,
      anon_sym_PIPE,
    ACTIONS(9027), 1,
      anon_sym_PIPE_RPAREN,
    STATE(5853), 1,
      aux_sym_active_pattern_repeat1,
    STATE(5914), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [175368] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8792), 1,
      sym__dedent,
    ACTIONS(8825), 1,
      anon_sym_COMMA,
    STATE(5817), 1,
      aux_sym_slice_ranges_repeat1,
    STATE(5915), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [175405] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6451), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(8621), 1,
      sym_identifier,
    STATE(6662), 1,
      sym_access_modifier,
    STATE(5916), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [175442] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8928), 1,
      anon_sym_EQ,
    ACTIONS(8930), 1,
      anon_sym_COLON,
    STATE(4887), 1,
      sym__val_property_defn,
    STATE(5917), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [175479] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9029), 1,
      anon_sym_with,
    ACTIONS(9031), 1,
      anon_sym_finally,
    ACTIONS(9033), 1,
      sym__newline,
    STATE(5918), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [175516] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9035), 1,
      anon_sym_PIPE,
    ACTIONS(9037), 1,
      anon_sym_PIPE_RPAREN,
    STATE(5952), 1,
      aux_sym_active_pattern_repeat1,
    STATE(5919), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [175553] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    STATE(3048), 1,
      sym__static_type_identifier,
    ACTIONS(6289), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5920), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [175588] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8989), 1,
      anon_sym_and,
    ACTIONS(9039), 1,
      sym__dedent,
    STATE(5935), 1,
      aux_sym__property_defn_repeat1,
    STATE(5921), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [175625] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7698), 1,
      sym__dedent,
    ACTIONS(9041), 1,
      sym__newline,
    STATE(5832), 1,
      aux_sym_record_fields_repeat1,
    STATE(5922), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [175662] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    STATE(1305), 1,
      sym__static_type_identifier,
    ACTIONS(6055), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5923), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [175697] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8730), 1,
      sym__newline,
    ACTIONS(9043), 1,
      anon_sym_GT_RBRACK,
    STATE(5928), 1,
      aux_sym__attribute_set_repeat1,
    STATE(5924), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [175734] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8695), 1,
      sym__indent,
    ACTIONS(9045), 1,
      anon_sym_RBRACK,
    STATE(7151), 1,
      sym__list_pattern_content,
    STATE(5925), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [175771] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9047), 1,
      anon_sym_PIPE,
    ACTIONS(9049), 1,
      anon_sym_PIPE_RPAREN,
    STATE(5853), 1,
      aux_sym_active_pattern_repeat1,
    STATE(5926), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [175808] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8695), 1,
      sym__indent,
    ACTIONS(9051), 1,
      anon_sym_PIPE_RBRACK,
    STATE(7150), 1,
      sym__list_pattern_content,
    STATE(5927), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [175845] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8730), 1,
      sym__newline,
    ACTIONS(9053), 1,
      anon_sym_GT_RBRACK,
    STATE(5969), 1,
      aux_sym__attribute_set_repeat1,
    STATE(5928), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [175882] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6451), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(9055), 1,
      sym_identifier,
    STATE(6581), 1,
      sym_access_modifier,
    STATE(5929), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [175919] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9057), 1,
      anon_sym_with,
    ACTIONS(9059), 1,
      anon_sym_finally,
    ACTIONS(9061), 1,
      sym__newline,
    STATE(5930), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [175956] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8669), 1,
      sym__indent,
    ACTIONS(9063), 1,
      anon_sym_RBRACK,
    STATE(7138), 1,
      sym__list_element,
    STATE(5931), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [175993] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8669), 1,
      sym__indent,
    ACTIONS(9065), 1,
      anon_sym_PIPE_RBRACK,
    STATE(7137), 1,
      sym__list_element,
    STATE(5932), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [176030] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    STATE(4466), 1,
      sym__static_type_identifier,
    ACTIONS(6011), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5933), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [176065] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    STATE(5031), 1,
      sym__static_type_identifier,
    ACTIONS(7783), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5934), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [176100] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9067), 1,
      anon_sym_and,
    ACTIONS(9070), 1,
      sym__dedent,
    STATE(5935), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym__property_defn_repeat1,
  [176135] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8691), 1,
      sym__newline,
    ACTIONS(9072), 1,
      anon_sym_RPAREN,
    STATE(5872), 1,
      aux_sym_named_field_pattern_repeat1,
    STATE(5936), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [176172] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8691), 1,
      sym__newline,
    ACTIONS(9074), 1,
      anon_sym_RPAREN,
    STATE(5947), 1,
      aux_sym_named_field_pattern_repeat1,
    STATE(5937), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [176209] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8678), 1,
      sym__newline,
    ACTIONS(9076), 1,
      anon_sym_RBRACE,
    STATE(5948), 1,
      aux_sym_record_pattern_repeat1,
    STATE(5938), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [176246] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9078), 1,
      anon_sym_PIPE,
    ACTIONS(9080), 1,
      anon_sym_PIPE_RPAREN,
    STATE(5949), 1,
      aux_sym_active_pattern_repeat1,
    STATE(5939), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [176283] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    STATE(3478), 1,
      sym__static_type_identifier,
    ACTIONS(7728), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5940), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [176318] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9082), 1,
      anon_sym_PIPE,
    ACTIONS(9084), 1,
      anon_sym_PIPE_RPAREN,
    STATE(5926), 1,
      aux_sym_active_pattern_repeat1,
    STATE(5941), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [176355] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6451), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(8637), 1,
      sym_identifier,
    STATE(6441), 1,
      sym_access_modifier,
    STATE(5942), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [176392] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8678), 1,
      sym__newline,
    ACTIONS(9086), 1,
      anon_sym_RBRACE,
    STATE(5879), 1,
      aux_sym_record_pattern_repeat1,
    STATE(5943), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [176429] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9088), 1,
      anon_sym_with,
    ACTIONS(9090), 1,
      anon_sym_finally,
    ACTIONS(9092), 1,
      sym__newline,
    STATE(5944), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [176466] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8691), 1,
      sym__newline,
    ACTIONS(9094), 1,
      anon_sym_RPAREN,
    STATE(5936), 1,
      aux_sym_named_field_pattern_repeat1,
    STATE(5945), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [176503] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    STATE(3078), 1,
      sym__static_type_identifier,
    ACTIONS(6223), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5946), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [176538] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8691), 1,
      sym__newline,
    ACTIONS(9096), 1,
      anon_sym_RPAREN,
    STATE(5872), 1,
      aux_sym_named_field_pattern_repeat1,
    STATE(5947), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [176575] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8678), 1,
      sym__newline,
    ACTIONS(9098), 1,
      anon_sym_RBRACE,
    STATE(5865), 1,
      aux_sym_record_pattern_repeat1,
    STATE(5948), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [176612] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9100), 1,
      anon_sym_PIPE,
    ACTIONS(9102), 1,
      anon_sym_PIPE_RPAREN,
    STATE(5853), 1,
      aux_sym_active_pattern_repeat1,
    STATE(5949), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [176649] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    STATE(4937), 1,
      sym__static_type_identifier,
    ACTIONS(6119), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5950), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [176684] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8669), 1,
      sym__indent,
    ACTIONS(9104), 1,
      anon_sym_PIPE_RBRACK,
    STATE(6814), 1,
      sym__list_element,
    STATE(5951), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [176721] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9106), 1,
      anon_sym_PIPE,
    ACTIONS(9108), 1,
      anon_sym_PIPE_RPAREN,
    STATE(5853), 1,
      aux_sym_active_pattern_repeat1,
    STATE(5952), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [176758] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8669), 1,
      sym__indent,
    ACTIONS(9110), 1,
      anon_sym_RBRACK,
    STATE(6817), 1,
      sym__list_element,
    STATE(5953), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [176795] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8669), 1,
      sym__indent,
    ACTIONS(9112), 1,
      anon_sym_RBRACK,
    STATE(6889), 1,
      sym__list_element,
    STATE(5954), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [176832] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8669), 1,
      sym__indent,
    ACTIONS(9114), 1,
      anon_sym_PIPE_RBRACK,
    STATE(6891), 1,
      sym__list_element,
    STATE(5955), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [176869] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9116), 1,
      anon_sym_PIPE,
    ACTIONS(9118), 1,
      anon_sym_PIPE_RPAREN,
    STATE(5853), 1,
      aux_sym_active_pattern_repeat1,
    STATE(5956), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [176906] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8695), 1,
      sym__indent,
    ACTIONS(9120), 1,
      anon_sym_PIPE_RBRACK,
    STATE(6836), 1,
      sym__list_pattern_content,
    STATE(5957), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [176943] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8989), 1,
      anon_sym_and,
    ACTIONS(9122), 1,
      sym__dedent,
    STATE(5921), 1,
      aux_sym__property_defn_repeat1,
    STATE(5958), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [176980] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    STATE(3646), 1,
      sym__static_type_identifier,
    ACTIONS(7605), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5959), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [177015] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    STATE(3164), 1,
      sym__static_type_identifier,
    ACTIONS(5987), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5960), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [177050] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    STATE(4303), 1,
      sym__static_type_identifier,
    ACTIONS(5965), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5961), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [177085] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8695), 1,
      sym__indent,
    ACTIONS(9124), 1,
      anon_sym_RBRACK,
    STATE(6837), 1,
      sym__list_pattern_content,
    STATE(5962), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [177122] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8800), 1,
      anon_sym_STAR,
    ACTIONS(9126), 1,
      anon_sym_DASH_GT,
    STATE(5973), 1,
      aux_sym_arguments_spec_repeat1,
    STATE(5963), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [177159] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9128), 1,
      anon_sym_PIPE,
    ACTIONS(9130), 1,
      anon_sym_PIPE_RPAREN,
    STATE(5974), 1,
      aux_sym_active_pattern_repeat1,
    STATE(5964), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [177196] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6451), 1,
      aux_sym_access_modifier_token1,
    ACTIONS(8631), 1,
      sym_identifier,
    STATE(6797), 1,
      sym_access_modifier,
    STATE(5965), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [177233] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9132), 1,
      anon_sym_with,
    ACTIONS(9134), 1,
      anon_sym_finally,
    ACTIONS(9136), 1,
      sym__newline,
    STATE(5966), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [177270] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9138), 1,
      sym__newline,
    ACTIONS(9140), 1,
      sym__dedent,
    STATE(5922), 1,
      aux_sym_record_fields_repeat1,
    STATE(5967), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [177307] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8678), 1,
      sym__newline,
    ACTIONS(9142), 1,
      anon_sym_RBRACE,
    STATE(5865), 1,
      aux_sym_record_pattern_repeat1,
    STATE(5968), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [177344] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9144), 1,
      anon_sym_GT_RBRACK,
    ACTIONS(9146), 1,
      sym__newline,
    STATE(5969), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym__attribute_set_repeat1,
  [177379] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2758), 3,
      sym__newline,
      sym__dedent,
      anon_sym_PIPE,
    STATE(5970), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [177412] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    STATE(808), 1,
      sym__static_type_identifier,
    ACTIONS(6149), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5971), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [177447] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8680), 1,
      sym_identifier,
    STATE(6235), 1,
      sym_field_pattern,
    STATE(7209), 1,
      sym_long_identifier,
    STATE(5972), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [177484] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9149), 1,
      anon_sym_DASH_GT,
    ACTIONS(9151), 1,
      anon_sym_STAR,
    STATE(5973), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_arguments_spec_repeat1,
  [177519] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9154), 1,
      anon_sym_PIPE,
    ACTIONS(9156), 1,
      anon_sym_PIPE_RPAREN,
    STATE(5853), 1,
      aux_sym_active_pattern_repeat1,
    STATE(5974), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [177556] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9158), 1,
      anon_sym_PIPE,
    ACTIONS(9160), 1,
      anon_sym_PIPE_RPAREN,
    STATE(5956), 1,
      aux_sym_active_pattern_repeat1,
    STATE(5975), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [177593] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9162), 3,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_when,
    STATE(5976), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [177626] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    STATE(3427), 1,
      sym__static_type_identifier,
    ACTIONS(7769), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5977), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [177661] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8691), 1,
      sym__newline,
    ACTIONS(9164), 1,
      anon_sym_RPAREN,
    STATE(5872), 1,
      aux_sym_named_field_pattern_repeat1,
    STATE(5978), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [177698] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5404), 1,
      anon_sym_GT,
    ACTIONS(9166), 1,
      anon_sym_and,
    STATE(5979), 5,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
      aux_sym_type_argument_constraints_repeat1,
  [177733] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    STATE(4361), 1,
      sym__static_type_identifier,
    ACTIONS(6093), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5980), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [177768] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8669), 1,
      sym__indent,
    ACTIONS(9169), 1,
      anon_sym_PIPE_RBRACK,
    STATE(7113), 1,
      sym__list_element,
    STATE(5981), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [177805] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8978), 1,
      anon_sym_COMMA,
    ACTIONS(9171), 1,
      anon_sym_GT,
    STATE(5889), 1,
      aux_sym_type_attributes_repeat1,
    STATE(5982), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [177842] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8669), 1,
      sym__indent,
    ACTIONS(9173), 1,
      anon_sym_RBRACK,
    STATE(7112), 1,
      sym__list_element,
    STATE(5983), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [177879] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    STATE(2952), 1,
      sym__static_type_identifier,
    ACTIONS(6171), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5984), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [177914] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    STATE(4440), 1,
      sym__static_type_identifier,
    ACTIONS(5999), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5985), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [177949] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    STATE(5958), 1,
      sym_property_accessor,
    ACTIONS(9175), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(5986), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [177984] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9177), 1,
      anon_sym_PIPE,
    ACTIONS(9179), 1,
      anon_sym_PIPE_RPAREN,
    STATE(5853), 1,
      aux_sym_active_pattern_repeat1,
    STATE(5987), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [178021] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8678), 1,
      sym__newline,
    ACTIONS(9181), 1,
      anon_sym_RBRACE,
    STATE(5865), 1,
      aux_sym_record_pattern_repeat1,
    STATE(5988), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [178058] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8691), 1,
      sym__newline,
    ACTIONS(9183), 1,
      anon_sym_RPAREN,
    STATE(5872), 1,
      aux_sym_named_field_pattern_repeat1,
    STATE(5989), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [178095] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8989), 1,
      anon_sym_and,
    ACTIONS(9185), 1,
      sym__dedent,
    STATE(5935), 1,
      aux_sym__property_defn_repeat1,
    STATE(5990), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [178132] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8695), 1,
      sym__indent,
    ACTIONS(9187), 1,
      anon_sym_RBRACK,
    STATE(7027), 1,
      sym__list_pattern_content,
    STATE(5991), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [178169] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    STATE(2916), 1,
      sym__static_type_identifier,
    ACTIONS(5902), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5992), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [178204] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8695), 1,
      sym__indent,
    ACTIONS(9189), 1,
      anon_sym_PIPE_RBRACK,
    STATE(7026), 1,
      sym__list_pattern_content,
    STATE(5993), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [178241] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    STATE(6115), 1,
      sym_property_accessor,
    ACTIONS(9175), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(5994), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [178276] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8669), 1,
      sym__indent,
    ACTIONS(9191), 1,
      anon_sym_RBRACK,
    STATE(7013), 1,
      sym__list_element,
    STATE(5995), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [178313] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8669), 1,
      sym__indent,
    ACTIONS(9193), 1,
      anon_sym_PIPE_RBRACK,
    STATE(7011), 1,
      sym__list_element,
    STATE(5996), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [178350] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    STATE(4382), 1,
      sym__static_type_identifier,
    ACTIONS(6067), 2,
      anon_sym_CARET,
      anon_sym_SQUOTE,
    STATE(5997), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [178385] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8691), 1,
      sym__newline,
    ACTIONS(9195), 1,
      anon_sym_RPAREN,
    STATE(5989), 1,
      aux_sym_named_field_pattern_repeat1,
    STATE(5998), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [178422] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9197), 1,
      anon_sym_with,
    ACTIONS(9199), 1,
      anon_sym_finally,
    ACTIONS(9201), 1,
      sym__newline,
    STATE(5999), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [178459] = 11,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8678), 1,
      sym__newline,
    ACTIONS(9203), 1,
      anon_sym_RBRACE,
    STATE(5988), 1,
      aux_sym_record_pattern_repeat1,
    STATE(6000), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [178496] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9205), 1,
      sym_identifier,
    ACTIONS(9207), 1,
      anon_sym__,
    STATE(6001), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [178530] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9205), 1,
      sym_identifier,
    ACTIONS(9209), 1,
      anon_sym__,
    STATE(6002), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [178564] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9211), 1,
      sym__indent,
    STATE(1528), 1,
      sym__expression_block,
    STATE(6003), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [178598] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9213), 1,
      sym__indent,
    STATE(1534), 1,
      sym__expression_block,
    STATE(6004), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [178632] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9215), 2,
      sym__dedent,
      anon_sym_and,
    STATE(6005), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [178664] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9217), 1,
      sym__indent,
    STATE(1261), 1,
      sym__expression_block,
    STATE(6006), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [178698] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9219), 1,
      sym__indent,
    STATE(828), 1,
      sym__expression_block,
    STATE(6007), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [178732] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9221), 1,
      sym__indent,
    STATE(1868), 1,
      sym__expression_block,
    STATE(6008), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [178766] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9223), 1,
      sym__indent,
    STATE(955), 1,
      sym__expression_block,
    STATE(6009), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [178800] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9221), 1,
      sym__indent,
    STATE(1871), 1,
      sym__expression_block,
    STATE(6010), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [178834] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9223), 1,
      sym__indent,
    STATE(847), 1,
      sym__expression_block,
    STATE(6011), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [178868] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9225), 1,
      sym__indent,
    STATE(6270), 1,
      sym__expression_block,
    STATE(6012), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [178902] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9227), 1,
      anon_sym_do,
    ACTIONS(9229), 1,
      anon_sym_DASH_GT,
    STATE(6013), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [178936] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9231), 1,
      sym__indent,
    STATE(6681), 1,
      sym__expression_block,
    STATE(6014), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [178970] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9233), 1,
      sym__indent,
    STATE(1820), 1,
      sym__expression_block,
    STATE(6015), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [179004] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9235), 1,
      sym__indent,
    STATE(1707), 1,
      sym__expression_block,
    STATE(6016), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [179038] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9235), 1,
      sym__indent,
    STATE(2095), 1,
      sym__expression_block,
    STATE(6017), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [179072] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9237), 1,
      sym__indent,
    STATE(841), 1,
      sym__expression_block,
    STATE(6018), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [179106] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9221), 1,
      sym__indent,
    STATE(2440), 1,
      sym__expression_block,
    STATE(6019), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [179140] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9239), 1,
      sym__indent,
    STATE(1481), 1,
      sym__expression_block,
    STATE(6020), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [179174] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9235), 1,
      sym__indent,
    STATE(2096), 1,
      sym__expression_block,
    STATE(6021), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [179208] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9241), 1,
      sym__indent,
    STATE(754), 1,
      sym__expression_block,
    STATE(6022), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [179242] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9205), 1,
      sym_identifier,
    ACTIONS(9243), 1,
      anon_sym__,
    STATE(6023), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [179276] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9205), 1,
      sym_identifier,
    ACTIONS(9245), 1,
      anon_sym__,
    STATE(6024), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [179310] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9247), 1,
      sym__indent,
    STATE(1549), 1,
      sym__expression_block,
    STATE(6025), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [179344] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9205), 1,
      sym_identifier,
    ACTIONS(9249), 1,
      anon_sym__,
    STATE(6026), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [179378] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9211), 1,
      sym__indent,
    STATE(1524), 1,
      sym__expression_block,
    STATE(6027), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [179412] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9205), 1,
      sym_identifier,
    ACTIONS(9251), 1,
      anon_sym__,
    STATE(6028), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [179446] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7498), 2,
      anon_sym_COMMA,
      anon_sym_GT,
    STATE(6029), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [179478] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9253), 1,
      sym__indent,
    STATE(4895), 1,
      sym__expression_block,
    STATE(6030), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [179512] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9205), 1,
      sym_identifier,
    ACTIONS(9255), 1,
      anon_sym__,
    STATE(6031), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [179546] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9221), 1,
      sym__indent,
    STATE(2450), 1,
      sym__expression_block,
    STATE(6032), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [179580] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9205), 1,
      sym_identifier,
    ACTIONS(9257), 1,
      anon_sym__,
    STATE(6033), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [179614] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9259), 2,
      anon_sym_COMMA,
      anon_sym_GT,
    STATE(6034), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [179646] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9205), 1,
      sym_identifier,
    ACTIONS(9261), 1,
      anon_sym__,
    STATE(6035), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [179680] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9205), 1,
      sym_identifier,
    ACTIONS(9263), 1,
      anon_sym__,
    STATE(6036), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [179714] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9237), 1,
      sym__indent,
    STATE(976), 1,
      sym__expression_block,
    STATE(6037), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [179748] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9235), 1,
      sym__indent,
    STATE(2171), 1,
      sym__expression_block,
    STATE(6038), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [179782] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9205), 1,
      sym_identifier,
    ACTIONS(9265), 1,
      anon_sym__,
    STATE(6039), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [179816] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9205), 1,
      sym_identifier,
    ACTIONS(9267), 1,
      anon_sym__,
    STATE(6040), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [179850] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9269), 1,
      sym__indent,
    STATE(1903), 1,
      sym__expression_block,
    STATE(6041), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [179884] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9271), 1,
      sym__indent,
    STATE(838), 1,
      sym__expression_block,
    STATE(6042), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [179918] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7524), 2,
      anon_sym_EQ,
      anon_sym_COLON,
    STATE(6043), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [179950] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9205), 1,
      sym_identifier,
    ACTIONS(9273), 1,
      anon_sym__,
    STATE(6044), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [179984] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9205), 1,
      sym_identifier,
    ACTIONS(9275), 1,
      anon_sym__,
    STATE(6045), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [180018] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9223), 1,
      sym__indent,
    STATE(844), 1,
      sym__expression_block,
    STATE(6046), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [180052] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9235), 1,
      sym__indent,
    STATE(2213), 1,
      sym__expression_block,
    STATE(6047), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [180086] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9277), 1,
      anon_sym_get,
    ACTIONS(9279), 1,
      anon_sym_set,
    STATE(6048), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [180120] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9281), 1,
      anon_sym_COLON,
    ACTIONS(9283), 1,
      anon_sym_COLON_GT,
    STATE(6049), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [180154] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9253), 1,
      sym__indent,
    STATE(4891), 1,
      sym__expression_block,
    STATE(6050), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [180188] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9285), 1,
      sym__indent,
    STATE(842), 1,
      sym__expression_block,
    STATE(6051), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [180222] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9241), 1,
      sym__indent,
    STATE(595), 1,
      sym__expression_block,
    STATE(6052), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [180256] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9205), 1,
      sym_identifier,
    ACTIONS(9287), 1,
      anon_sym__,
    STATE(6053), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [180290] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9225), 1,
      sym__indent,
    STATE(6395), 1,
      sym__expression_block,
    STATE(6054), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [180324] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9205), 1,
      sym_identifier,
    ACTIONS(9289), 1,
      anon_sym__,
    STATE(6055), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [180358] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9291), 1,
      sym__indent,
    STATE(4772), 1,
      sym__expression_block,
    STATE(6056), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [180392] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9221), 1,
      sym__indent,
    STATE(2465), 1,
      sym__expression_block,
    STATE(6057), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [180426] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9221), 1,
      sym__indent,
    STATE(2466), 1,
      sym__expression_block,
    STATE(6058), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [180460] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9149), 2,
      anon_sym_DASH_GT,
      anon_sym_STAR,
    STATE(6059), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [180492] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9293), 1,
      sym__indent,
    STATE(1389), 1,
      sym__expression_block,
    STATE(6060), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [180526] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9221), 1,
      sym__indent,
    STATE(1875), 1,
      sym__expression_block,
    STATE(6061), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [180560] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9235), 1,
      sym__indent,
    STATE(1749), 1,
      sym__expression_block,
    STATE(6062), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [180594] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9295), 1,
      anon_sym_COLON,
    ACTIONS(9297), 1,
      anon_sym_COLON_GT,
    STATE(6063), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [180628] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9299), 1,
      sym__newline,
    ACTIONS(9301), 1,
      sym__indent,
    STATE(6064), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [180662] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9303), 1,
      anon_sym_EQ,
    ACTIONS(9305), 1,
      anon_sym_COLON,
    STATE(6065), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [180696] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9307), 1,
      anon_sym_EQ,
    ACTIONS(9309), 1,
      anon_sym_COLON,
    STATE(6066), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [180730] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9213), 1,
      sym__indent,
    STATE(1227), 1,
      sym__expression_block,
    STATE(6067), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [180764] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9269), 1,
      sym__indent,
    STATE(1927), 1,
      sym__expression_block,
    STATE(6068), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [180798] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9271), 1,
      sym__indent,
    STATE(836), 1,
      sym__expression_block,
    STATE(6069), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [180832] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9311), 1,
      sym__newline,
    ACTIONS(9313), 1,
      sym__indent,
    STATE(6070), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [180866] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9223), 1,
      sym__indent,
    STATE(863), 1,
      sym__expression_block,
    STATE(6071), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [180900] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9315), 1,
      anon_sym_get,
    ACTIONS(9317), 1,
      anon_sym_set,
    STATE(6072), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [180934] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9319), 1,
      anon_sym_with,
    ACTIONS(9321), 1,
      anon_sym_finally,
    STATE(6073), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [180968] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9205), 1,
      sym_identifier,
    ACTIONS(9323), 1,
      anon_sym__,
    STATE(6074), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [181002] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9231), 1,
      sym__indent,
    STATE(7348), 1,
      sym__expression_block,
    STATE(6075), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [181036] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9253), 1,
      sym__indent,
    STATE(5873), 1,
      sym__expression_block,
    STATE(6076), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [181070] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9325), 2,
      sym__newline,
      anon_sym_GT_RBRACK,
    STATE(6077), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [181102] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9217), 1,
      sym__indent,
    STATE(1636), 1,
      sym__expression_block,
    STATE(6078), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [181136] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9144), 2,
      sym__newline,
      anon_sym_GT_RBRACK,
    STATE(6079), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [181168] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9235), 1,
      sym__indent,
    STATE(1765), 1,
      sym__expression_block,
    STATE(6080), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [181202] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9327), 1,
      sym__indent,
    STATE(5738), 1,
      sym__expression_block,
    STATE(6081), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [181236] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9241), 1,
      sym__indent,
    STATE(565), 1,
      sym__expression_block,
    STATE(6082), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [181270] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9329), 1,
      anon_sym_get,
    ACTIONS(9331), 1,
      anon_sym_set,
    STATE(6083), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [181304] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9231), 1,
      sym__indent,
    STATE(7174), 1,
      sym__expression_block,
    STATE(6084), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [181338] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9333), 1,
      sym__indent,
    STATE(6432), 1,
      sym__expression_block,
    STATE(6085), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [181372] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9223), 1,
      sym__indent,
    STATE(928), 1,
      sym__expression_block,
    STATE(6086), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [181406] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9335), 2,
      sym__dedent,
      anon_sym_interface,
    STATE(6087), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [181438] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9337), 1,
      sym__indent,
    STATE(1014), 1,
      sym__expression_block,
    STATE(6088), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [181472] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9223), 1,
      sym__indent,
    STATE(927), 1,
      sym__expression_block,
    STATE(6089), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [181506] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9339), 1,
      sym__indent,
    STATE(1844), 1,
      sym__expression_block,
    STATE(6090), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [181540] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9341), 1,
      anon_sym_COLON,
    ACTIONS(9343), 1,
      anon_sym_COLON_GT,
    STATE(6091), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [181574] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9205), 1,
      sym_identifier,
    ACTIONS(9345), 1,
      anon_sym__,
    STATE(6092), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [181608] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9347), 1,
      sym__newline,
    ACTIONS(9349), 1,
      sym__indent,
    STATE(6093), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [181642] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9223), 1,
      sym__indent,
    STATE(839), 1,
      sym__expression_block,
    STATE(6094), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [181676] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9247), 1,
      sym__indent,
    STATE(1435), 1,
      sym__expression_block,
    STATE(6095), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [181710] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9221), 1,
      sym__indent,
    STATE(2443), 1,
      sym__expression_block,
    STATE(6096), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [181744] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9205), 1,
      sym_identifier,
    ACTIONS(9351), 1,
      anon_sym__,
    STATE(6097), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [181778] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9291), 1,
      sym__indent,
    STATE(4760), 1,
      sym__expression_block,
    STATE(6098), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [181812] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9247), 1,
      sym__indent,
    STATE(1566), 1,
      sym__expression_block,
    STATE(6099), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [181846] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9247), 1,
      sym__indent,
    STATE(1567), 1,
      sym__expression_block,
    STATE(6100), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [181880] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9353), 1,
      sym__indent,
    STATE(1507), 1,
      sym__expression_block,
    STATE(6101), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [181914] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9355), 2,
      sym__dedent,
      anon_sym_interface,
    STATE(6102), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [181946] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9357), 1,
      sym__indent,
    STATE(1469), 1,
      sym__expression_block,
    STATE(6103), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [181980] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9359), 1,
      sym__indent,
    STATE(1506), 1,
      sym__expression_block,
    STATE(6104), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [182014] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9361), 1,
      sym__newline,
    ACTIONS(9363), 1,
      sym__indent,
    STATE(6105), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [182048] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9365), 1,
      anon_sym_with,
    ACTIONS(9367), 1,
      anon_sym_finally,
    STATE(6106), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [182082] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9369), 2,
      sym__dedent,
      anon_sym_interface,
    STATE(6107), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [182114] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9205), 1,
      sym_identifier,
    ACTIONS(9371), 1,
      anon_sym__,
    STATE(6108), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [182148] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9231), 1,
      sym__indent,
    STATE(7157), 1,
      sym__expression_block,
    STATE(6109), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [182182] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9241), 1,
      sym__indent,
    STATE(662), 1,
      sym__expression_block,
    STATE(6110), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [182216] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9327), 1,
      sym__indent,
    STATE(5782), 1,
      sym__expression_block,
    STATE(6111), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [182250] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(7700), 2,
      anon_sym_EQ,
      anon_sym_COLON,
    STATE(6112), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [182282] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9231), 1,
      sym__indent,
    STATE(7094), 1,
      sym__expression_block,
    STATE(6113), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [182316] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9219), 1,
      sym__indent,
    STATE(783), 1,
      sym__expression_block,
    STATE(6114), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [182350] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9070), 2,
      sym__dedent,
      anon_sym_and,
    STATE(6115), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [182382] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9373), 1,
      anon_sym_COLON,
    ACTIONS(9375), 1,
      anon_sym_COLON_GT,
    STATE(6116), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [182416] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9353), 1,
      sym__indent,
    STATE(1503), 1,
      sym__expression_block,
    STATE(6117), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [182450] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9377), 1,
      anon_sym_EQ,
    ACTIONS(9379), 1,
      anon_sym_COLON,
    STATE(6118), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [182484] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9339), 1,
      sym__indent,
    STATE(1398), 1,
      sym__expression_block,
    STATE(6119), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [182518] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9381), 1,
      sym__newline,
    ACTIONS(9383), 1,
      sym__indent,
    STATE(6120), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [182552] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9205), 1,
      sym_identifier,
    ACTIONS(9385), 1,
      anon_sym__,
    STATE(6121), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [182586] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9387), 1,
      sym__indent,
    STATE(1152), 1,
      sym__expression_block,
    STATE(6122), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [182620] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9353), 1,
      sym__indent,
    STATE(1949), 1,
      sym__expression_block,
    STATE(6123), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [182654] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9389), 1,
      sym__newline,
    ACTIONS(9391), 1,
      sym__indent,
    STATE(6124), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [182688] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9393), 1,
      anon_sym_with,
    ACTIONS(9395), 1,
      anon_sym_finally,
    STATE(6125), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [182722] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9205), 1,
      sym_identifier,
    ACTIONS(9397), 1,
      anon_sym__,
    STATE(6126), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [182756] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9231), 1,
      sym__indent,
    STATE(6941), 1,
      sym__expression_block,
    STATE(6127), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [182790] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9333), 1,
      sym__indent,
    STATE(6492), 1,
      sym__expression_block,
    STATE(6128), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [182824] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9327), 1,
      sym__indent,
    STATE(5809), 1,
      sym__expression_block,
    STATE(6129), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [182858] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9223), 1,
      sym__indent,
    STATE(876), 1,
      sym__expression_block,
    STATE(6130), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [182892] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9231), 1,
      sym__indent,
    STATE(6883), 1,
      sym__expression_block,
    STATE(6131), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [182926] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9247), 1,
      sym__indent,
    STATE(1594), 1,
      sym__expression_block,
    STATE(6132), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [182960] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9399), 1,
      sym__indent,
    STATE(1823), 1,
      sym__expression_block,
    STATE(6133), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [182994] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9401), 1,
      anon_sym_with,
    STATE(5733), 1,
      sym__object_members,
    STATE(6134), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [183028] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9359), 1,
      sym__indent,
    STATE(1496), 1,
      sym__expression_block,
    STATE(6135), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [183062] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9333), 1,
      sym__indent,
    STATE(6545), 1,
      sym__expression_block,
    STATE(6136), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [183096] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9373), 1,
      anon_sym_COLON,
    ACTIONS(9403), 1,
      anon_sym_COLON_GT,
    STATE(6137), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [183130] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9353), 1,
      sym__indent,
    STATE(1957), 1,
      sym__expression_block,
    STATE(6138), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [183164] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9241), 1,
      sym__indent,
    STATE(2843), 1,
      sym__expression_block,
    STATE(6139), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [183198] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9405), 1,
      sym__newline,
    ACTIONS(9407), 1,
      sym__indent,
    STATE(6140), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [183232] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9339), 1,
      sym__indent,
    STATE(1533), 1,
      sym__expression_block,
    STATE(6141), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [183266] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9205), 1,
      sym_identifier,
    ACTIONS(9409), 1,
      anon_sym__,
    STATE(6142), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [183300] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9411), 2,
      anon_sym_EQ,
      anon_sym_COLON,
    STATE(6143), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [183332] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(811), 2,
      sym__dedent,
      anon_sym_COMMA,
    STATE(6144), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [183364] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9339), 1,
      sym__indent,
    STATE(1912), 1,
      sym__expression_block,
    STATE(6145), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [183398] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9413), 1,
      sym__newline,
    ACTIONS(9415), 1,
      sym__indent,
    STATE(6146), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [183432] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9417), 1,
      anon_sym_with,
    ACTIONS(9419), 1,
      anon_sym_finally,
    STATE(6147), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [183466] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(6317), 2,
      anon_sym_new,
      sym_identifier,
    STATE(6148), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [183498] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9421), 2,
      anon_sym_EQ,
      anon_sym_COLON,
    STATE(6149), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [183530] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9423), 1,
      sym_identifier,
    STATE(4887), 1,
      sym_member_signature,
    STATE(6150), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [183564] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9205), 1,
      sym_identifier,
    ACTIONS(9425), 1,
      anon_sym__,
    STATE(6151), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [183598] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9231), 1,
      sym__indent,
    STATE(6769), 1,
      sym__expression_block,
    STATE(6152), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [183632] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9327), 1,
      sym__indent,
    STATE(5827), 1,
      sym__expression_block,
    STATE(6153), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [183666] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9427), 2,
      sym__dedent,
      anon_sym_COMMA,
    STATE(6154), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [183698] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9429), 1,
      anon_sym_get,
    ACTIONS(9431), 1,
      anon_sym_set,
    STATE(6155), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [183732] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9333), 1,
      sym__indent,
    STATE(6595), 1,
      sym__expression_block,
    STATE(6156), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [183766] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9339), 1,
      sym__indent,
    STATE(1913), 1,
      sym__expression_block,
    STATE(6157), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [183800] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9239), 1,
      sym__indent,
    STATE(1997), 1,
      sym__expression_block,
    STATE(6158), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [183834] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9241), 1,
      sym__indent,
    STATE(659), 1,
      sym__expression_block,
    STATE(6159), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [183868] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9231), 1,
      sym__indent,
    STATE(6713), 1,
      sym__expression_block,
    STATE(6160), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [183902] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9433), 1,
      sym__indent,
    STATE(1573), 1,
      sym__expression_block,
    STATE(6161), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [183936] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9241), 1,
      sym__indent,
    STATE(493), 1,
      sym__expression_block,
    STATE(6162), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [183970] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9353), 1,
      sym__indent,
    STATE(1976), 1,
      sym__expression_block,
    STATE(6163), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [184004] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9247), 1,
      sym__indent,
    STATE(1603), 1,
      sym__expression_block,
    STATE(6164), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [184038] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9253), 1,
      sym__indent,
    STATE(4916), 1,
      sym__expression_block,
    STATE(6165), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [184072] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9353), 1,
      sym__indent,
    STATE(1977), 1,
      sym__expression_block,
    STATE(6166), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [184106] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9435), 1,
      sym__indent,
    STATE(1008), 1,
      sym__expression_block,
    STATE(6167), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [184140] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9437), 1,
      anon_sym_COLON,
    ACTIONS(9439), 1,
      anon_sym_COLON_GT,
    STATE(6168), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [184174] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9441), 1,
      sym__indent,
    STATE(1994), 1,
      sym__expression_block,
    STATE(6169), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [184208] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9435), 1,
      sym__indent,
    STATE(1107), 1,
      sym__expression_block,
    STATE(6170), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [184242] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9353), 1,
      sym__indent,
    STATE(1475), 1,
      sym__expression_block,
    STATE(6171), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [184276] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9443), 1,
      sym__newline,
    ACTIONS(9445), 1,
      sym__indent,
    STATE(6172), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [184310] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9447), 1,
      anon_sym_with,
    ACTIONS(9449), 1,
      anon_sym_finally,
    STATE(6173), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [184344] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9327), 1,
      sym__indent,
    STATE(5860), 1,
      sym__expression_block,
    STATE(6174), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [184378] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9239), 1,
      sym__indent,
    STATE(1990), 1,
      sym__expression_block,
    STATE(6175), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [184412] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9205), 1,
      sym_identifier,
    ACTIONS(9451), 1,
      anon_sym__,
    STATE(6176), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [184446] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9435), 1,
      sym__indent,
    STATE(1106), 1,
      sym__expression_block,
    STATE(6177), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [184480] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9453), 1,
      sym__newline,
    ACTIONS(9455), 1,
      sym__indent,
    STATE(6178), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [184514] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9357), 1,
      sym__indent,
    STATE(1095), 1,
      sym__expression_block,
    STATE(6179), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [184548] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9457), 1,
      sym__indent,
    STATE(1422), 1,
      sym__expression_block,
    STATE(6180), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [184582] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9459), 1,
      sym__newline,
    ACTIONS(9461), 1,
      sym__indent,
    STATE(6181), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [184616] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9463), 1,
      anon_sym_with,
    ACTIONS(9465), 1,
      anon_sym_finally,
    STATE(6182), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [184650] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9205), 1,
      sym_identifier,
    ACTIONS(9467), 1,
      anon_sym__,
    STATE(6183), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [184684] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9231), 1,
      sym__indent,
    STATE(6584), 1,
      sym__expression_block,
    STATE(6184), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [184718] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9469), 2,
      anon_sym_RBRACK,
      anon_sym_PIPE_RBRACK,
    STATE(6185), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [184750] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9247), 1,
      sym__indent,
    STATE(1430), 1,
      sym__expression_block,
    STATE(6186), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [184784] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9241), 1,
      sym__indent,
    STATE(502), 1,
      sym__expression_block,
    STATE(6187), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [184818] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9423), 1,
      sym_identifier,
    STATE(4880), 1,
      sym_member_signature,
    STATE(6188), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [184852] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9231), 1,
      sym__indent,
    STATE(6518), 1,
      sym__expression_block,
    STATE(6189), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [184886] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9333), 1,
      sym__indent,
    STATE(6643), 1,
      sym__expression_block,
    STATE(6190), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [184920] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9253), 1,
      sym__indent,
    STATE(4875), 1,
      sym__expression_block,
    STATE(6191), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [184954] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9239), 1,
      sym__indent,
    STATE(2287), 1,
      sym__expression_block,
    STATE(6192), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [184988] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9327), 1,
      sym__indent,
    STATE(5880), 1,
      sym__expression_block,
    STATE(6193), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [185022] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9339), 1,
      sym__indent,
    STATE(1935), 1,
      sym__expression_block,
    STATE(6194), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [185056] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9399), 1,
      sym__indent,
    STATE(1815), 1,
      sym__expression_block,
    STATE(6195), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [185090] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9441), 1,
      sym__indent,
    STATE(1979), 1,
      sym__expression_block,
    STATE(6196), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [185124] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9471), 1,
      sym__indent,
    STATE(1938), 1,
      sym__expression_block,
    STATE(6197), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [185158] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9473), 1,
      anon_sym_COLON,
    ACTIONS(9475), 1,
      anon_sym_COLON_GT,
    STATE(6198), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [185192] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9477), 1,
      sym__newline,
    ACTIONS(9479), 1,
      sym__indent,
    STATE(6199), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [185226] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9235), 1,
      sym__indent,
    STATE(2247), 1,
      sym__expression_block,
    STATE(6200), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [185260] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9239), 1,
      sym__indent,
    STATE(2311), 1,
      sym__expression_block,
    STATE(6201), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [185294] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9333), 1,
      sym__indent,
    STATE(6691), 1,
      sym__expression_block,
    STATE(6202), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [185328] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9481), 2,
      anon_sym_EQ,
      anon_sym_COLON,
    STATE(6203), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [185360] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9483), 1,
      sym__newline,
    ACTIONS(9485), 1,
      sym__indent,
    STATE(6204), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [185394] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9247), 1,
      sym__indent,
    STATE(1428), 1,
      sym__expression_block,
    STATE(6205), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [185428] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9327), 1,
      sym__indent,
    STATE(5904), 1,
      sym__expression_block,
    STATE(6206), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [185462] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9241), 1,
      sym__indent,
    STATE(604), 1,
      sym__expression_block,
    STATE(6207), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [185496] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9353), 1,
      sym__indent,
    STATE(2001), 1,
      sym__expression_block,
    STATE(6208), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [185530] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9487), 1,
      anon_sym_with,
    ACTIONS(9489), 1,
      anon_sym_finally,
    STATE(6209), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [185564] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9205), 1,
      sym_identifier,
    ACTIONS(9491), 1,
      anon_sym__,
    STATE(6210), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [185598] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9253), 1,
      sym__indent,
    STATE(4888), 1,
      sym__expression_block,
    STATE(6211), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [185632] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9239), 1,
      sym__indent,
    STATE(2356), 1,
      sym__expression_block,
    STATE(6212), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [185666] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9231), 1,
      sym__indent,
    STATE(6495), 1,
      sym__expression_block,
    STATE(6213), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [185700] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9333), 1,
      sym__indent,
    STATE(6739), 1,
      sym__expression_block,
    STATE(6214), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [185734] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9339), 1,
      sym__indent,
    STATE(1947), 1,
      sym__expression_block,
    STATE(6215), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [185768] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8945), 2,
      sym__newline,
      anon_sym_RPAREN,
    STATE(6216), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [185800] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9239), 1,
      sym__indent,
    STATE(2357), 1,
      sym__expression_block,
    STATE(6217), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [185834] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9239), 1,
      sym__indent,
    STATE(1943), 1,
      sym__expression_block,
    STATE(6218), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [185868] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9327), 1,
      sym__indent,
    STATE(5918), 1,
      sym__expression_block,
    STATE(6219), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [185902] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9493), 1,
      sym__indent,
    STATE(1798), 1,
      sym__expression_block,
    STATE(6220), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [185936] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9435), 1,
      sym__indent,
    STATE(1397), 1,
      sym__expression_block,
    STATE(6221), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [185970] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9339), 1,
      sym__indent,
    STATE(1499), 1,
      sym__expression_block,
    STATE(6222), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [186004] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9457), 1,
      sym__indent,
    STATE(1657), 1,
      sym__expression_block,
    STATE(6223), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [186038] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9495), 1,
      sym__indent,
    STATE(1470), 1,
      sym__expression_block,
    STATE(6224), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [186072] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9231), 1,
      sym__indent,
    STATE(6560), 1,
      sym__expression_block,
    STATE(6225), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [186106] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9327), 1,
      sym__indent,
    STATE(5999), 1,
      sym__expression_block,
    STATE(6226), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [186140] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9471), 1,
      sym__indent,
    STATE(1964), 1,
      sym__expression_block,
    STATE(6227), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [186174] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9253), 1,
      sym__indent,
    STATE(4872), 1,
      sym__expression_block,
    STATE(6228), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [186208] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9387), 1,
      sym__indent,
    STATE(1468), 1,
      sym__expression_block,
    STATE(6229), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [186242] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9497), 1,
      sym__indent,
    STATE(1703), 1,
      sym__expression_block,
    STATE(6230), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [186276] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9339), 1,
      sym__indent,
    STATE(1492), 1,
      sym__expression_block,
    STATE(6231), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [186310] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9499), 2,
      anon_sym_RBRACK,
      anon_sym_PIPE_RBRACK,
    STATE(6232), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [186342] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9333), 1,
      sym__indent,
    STATE(7053), 1,
      sym__expression_block,
    STATE(6233), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [186376] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9501), 1,
      anon_sym_COLON,
    ACTIONS(9503), 1,
      anon_sym_COLON_GT,
    STATE(6234), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [186410] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8932), 2,
      sym__newline,
      anon_sym_RBRACE,
    STATE(6235), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [186442] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9505), 1,
      sym__newline,
    ACTIONS(9507), 1,
      sym__indent,
    STATE(6236), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [186476] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9253), 1,
      sym__indent,
    STATE(4878), 1,
      sym__expression_block,
    STATE(6237), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [186510] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9205), 1,
      sym_identifier,
    ACTIONS(9509), 1,
      anon_sym__,
    STATE(6238), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [186544] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9457), 1,
      sym__indent,
    STATE(1682), 1,
      sym__expression_block,
    STATE(6239), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [186578] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9223), 1,
      sym__indent,
    STATE(1462), 1,
      sym__expression_block,
    STATE(6240), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [186612] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9493), 1,
      sym__indent,
    STATE(1781), 1,
      sym__expression_block,
    STATE(6241), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [186646] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9423), 1,
      sym_identifier,
    STATE(4910), 1,
      sym_member_signature,
    STATE(6242), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [186680] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9333), 1,
      sym__indent,
    STATE(6784), 1,
      sym__expression_block,
    STATE(6243), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [186714] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9231), 1,
      sym__indent,
    STATE(7073), 1,
      sym__expression_block,
    STATE(6244), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [186748] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9457), 1,
      sym__indent,
    STATE(2024), 1,
      sym__expression_block,
    STATE(6245), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [186782] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9511), 1,
      sym__newline,
    ACTIONS(9513), 1,
      sym__indent,
    STATE(6246), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [186816] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9515), 1,
      anon_sym_with,
    ACTIONS(9517), 1,
      anon_sym_finally,
    STATE(6247), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [186850] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9205), 1,
      sym_identifier,
    ACTIONS(9519), 1,
      anon_sym__,
    STATE(6248), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [186884] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9493), 1,
      sym__indent,
    STATE(1443), 1,
      sym__expression_block,
    STATE(6249), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [186918] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9231), 1,
      sym__indent,
    STATE(6719), 1,
      sym__expression_block,
    STATE(6250), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [186952] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9521), 1,
      anon_sym_PIPE,
    ACTIONS(9523), 1,
      anon_sym_PIPE_RPAREN,
    STATE(6251), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [186986] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9435), 1,
      sym__indent,
    STATE(1093), 1,
      sym__expression_block,
    STATE(6252), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [187020] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9205), 1,
      sym_identifier,
    ACTIONS(9525), 1,
      anon_sym__,
    STATE(6253), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [187054] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9327), 1,
      sym__indent,
    STATE(5930), 1,
      sym__expression_block,
    STATE(6254), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [187088] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9497), 1,
      sym__indent,
    STATE(1708), 1,
      sym__expression_block,
    STATE(6255), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [187122] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9527), 1,
      sym__indent,
    STATE(1050), 1,
      sym__expression_block,
    STATE(6256), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [187156] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9433), 1,
      sym__indent,
    STATE(1276), 1,
      sym__expression_block,
    STATE(6257), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [187190] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9231), 1,
      sym__indent,
    STATE(6821), 1,
      sym__expression_block,
    STATE(6258), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [187224] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9457), 1,
      sym__indent,
    STATE(2031), 1,
      sym__expression_block,
    STATE(6259), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [187258] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9333), 1,
      sym__indent,
    STATE(6824), 1,
      sym__expression_block,
    STATE(6260), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [187292] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9327), 1,
      sym__indent,
    STATE(5944), 1,
      sym__expression_block,
    STATE(6261), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [187326] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9231), 1,
      sym__indent,
    STATE(5755), 1,
      sym__expression_block,
    STATE(6262), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [187360] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9233), 1,
      sym__indent,
    STATE(2219), 1,
      sym__expression_block,
    STATE(6263), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [187394] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9333), 1,
      sym__indent,
    STATE(6864), 1,
      sym__expression_block,
    STATE(6264), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [187428] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9327), 1,
      sym__indent,
    STATE(5966), 1,
      sym__expression_block,
    STATE(6265), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [187462] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9493), 1,
      sym__indent,
    STATE(1630), 1,
      sym__expression_block,
    STATE(6266), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [187496] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9493), 1,
      sym__indent,
    STATE(1782), 1,
      sym__expression_block,
    STATE(6267), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [187530] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9373), 1,
      anon_sym_COLON,
    ACTIONS(9529), 1,
      anon_sym_COLON_GT,
    STATE(6268), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [187564] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9531), 1,
      sym__newline,
    ACTIONS(9533), 1,
      sym__indent,
    STATE(6269), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [187598] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4696), 2,
      sym__dedent,
      anon_sym_and,
    STATE(6270), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [187630] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9205), 1,
      sym_identifier,
    ACTIONS(9535), 1,
      anon_sym__,
    STATE(6271), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [187664] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9537), 1,
      sym__newline,
    ACTIONS(9539), 1,
      sym__indent,
    STATE(6272), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [187698] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9541), 1,
      anon_sym_with,
    ACTIONS(9543), 1,
      anon_sym_finally,
    STATE(6273), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [187732] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9205), 1,
      sym_identifier,
    ACTIONS(9545), 1,
      anon_sym__,
    STATE(6274), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [187766] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8858), 2,
      sym__newline,
      sym__dedent,
    STATE(6275), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [187798] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9241), 1,
      sym__indent,
    STATE(494), 1,
      sym__expression_block,
    STATE(6276), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [187832] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9239), 1,
      sym__indent,
    STATE(2454), 1,
      sym__expression_block,
    STATE(6277), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [187866] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9231), 1,
      sym__indent,
    STATE(6971), 1,
      sym__expression_block,
    STATE(6278), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [187900] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9253), 1,
      sym__indent,
    STATE(4926), 1,
      sym__expression_block,
    STATE(6279), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [187934] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9333), 1,
      sym__indent,
    STATE(6904), 1,
      sym__expression_block,
    STATE(6280), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [187968] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9353), 1,
      sym__indent,
    STATE(1621), 1,
      sym__expression_block,
    STATE(6281), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [188002] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9547), 1,
      sym__indent,
    STATE(1829), 1,
      sym__expression_block,
    STATE(6282), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [188036] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9241), 1,
      sym__indent,
    STATE(734), 1,
      sym__expression_block,
    STATE(6283), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [188070] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9549), 2,
      anon_sym_EQ,
      anon_sym_COLON,
    STATE(6284), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [188102] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9551), 1,
      anon_sym_EQ,
    ACTIONS(9553), 1,
      anon_sym_COLON,
    STATE(6285), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [188136] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9457), 1,
      sym__indent,
    STATE(2050), 1,
      sym__expression_block,
    STATE(6286), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [188170] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9457), 1,
      sym__indent,
    STATE(2051), 1,
      sym__expression_block,
    STATE(6287), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [188204] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9457), 1,
      sym__indent,
    STATE(1654), 1,
      sym__expression_block,
    STATE(6288), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [188238] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9555), 1,
      sym__indent,
    STATE(1572), 1,
      sym__expression_block,
    STATE(6289), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [188272] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9231), 1,
      sym__indent,
    STATE(7014), 1,
      sym__expression_block,
    STATE(6290), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [188306] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9557), 1,
      sym__indent,
    STATE(1012), 1,
      sym__expression_block,
    STATE(6291), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [188340] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9547), 1,
      sym__indent,
    STATE(1824), 1,
      sym__expression_block,
    STATE(6292), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [188374] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9547), 1,
      sym__indent,
    STATE(1593), 1,
      sym__expression_block,
    STATE(6293), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [188408] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9559), 1,
      sym__indent,
    STATE(2833), 1,
      sym__expression_block,
    STATE(6294), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [188442] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9561), 2,
      anon_sym_RBRACK,
      anon_sym_PIPE_RBRACK,
    STATE(6295), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [188474] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9563), 1,
      sym__indent,
    STATE(1265), 1,
      sym__expression_block,
    STATE(6296), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [188508] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9565), 1,
      sym__indent,
    STATE(5760), 1,
      sym__expression_block,
    STATE(6297), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [188542] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9547), 1,
      sym__indent,
    STATE(2352), 1,
      sym__expression_block,
    STATE(6298), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [188576] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9557), 1,
      sym__indent,
    STATE(1001), 1,
      sym__expression_block,
    STATE(6299), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [188610] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9295), 1,
      anon_sym_COLON,
    ACTIONS(9567), 1,
      anon_sym_COLON_GT,
    STATE(6300), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [188644] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9547), 1,
      sym__indent,
    STATE(2343), 1,
      sym__expression_block,
    STATE(6301), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [188678] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9565), 1,
      sym__indent,
    STATE(5766), 1,
      sym__expression_block,
    STATE(6302), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [188712] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9495), 1,
      sym__indent,
    STATE(1055), 1,
      sym__expression_block,
    STATE(6303), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [188746] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9569), 1,
      sym__newline,
    ACTIONS(9571), 1,
      sym__indent,
    STATE(6304), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [188780] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9241), 1,
      sym__indent,
    STATE(652), 1,
      sym__expression_block,
    STATE(6305), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [188814] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9253), 1,
      sym__indent,
    STATE(4892), 1,
      sym__expression_block,
    STATE(6306), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [188848] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9493), 1,
      sym__indent,
    STATE(1770), 1,
      sym__expression_block,
    STATE(6307), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [188882] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9573), 1,
      sym__indent,
    STATE(1424), 1,
      sym__expression_block,
    STATE(6308), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [188916] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9205), 1,
      sym_identifier,
    ACTIONS(9575), 1,
      anon_sym__,
    STATE(6309), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [188950] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9547), 1,
      sym__indent,
    STATE(2301), 1,
      sym__expression_block,
    STATE(6310), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [188984] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9577), 1,
      sym__newline,
    ACTIONS(9579), 1,
      sym__indent,
    STATE(6311), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [189018] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9435), 1,
      sym__indent,
    STATE(1041), 1,
      sym__expression_block,
    STATE(6312), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [189052] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9581), 1,
      anon_sym_with,
    ACTIONS(9583), 1,
      anon_sym_finally,
    STATE(6313), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [189086] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9205), 1,
      sym_identifier,
    ACTIONS(9585), 1,
      anon_sym__,
    STATE(6314), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [189120] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9231), 1,
      sym__indent,
    STATE(7100), 1,
      sym__expression_block,
    STATE(6315), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [189154] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9587), 1,
      sym__newline,
    ACTIONS(9589), 1,
      sym__indent,
    STATE(6316), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [189188] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(811), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    STATE(6317), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [189220] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9233), 1,
      sym__indent,
    STATE(1734), 1,
      sym__expression_block,
    STATE(6318), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [189254] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9547), 1,
      sym__indent,
    STATE(2298), 1,
      sym__expression_block,
    STATE(6319), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [189288] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9233), 1,
      sym__indent,
    STATE(1038), 1,
      sym__expression_block,
    STATE(6320), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [189322] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9591), 1,
      anon_sym_EQ,
    ACTIONS(9593), 1,
      anon_sym_COLON,
    STATE(6321), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [189356] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9253), 1,
      sym__indent,
    STATE(5822), 1,
      sym__expression_block,
    STATE(6322), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [189390] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9233), 1,
      sym__indent,
    STATE(2197), 1,
      sym__expression_block,
    STATE(6323), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [189424] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9547), 1,
      sym__indent,
    STATE(1828), 1,
      sym__expression_block,
    STATE(6324), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [189458] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9337), 1,
      sym__indent,
    STATE(1352), 1,
      sym__expression_block,
    STATE(6325), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [189492] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9233), 1,
      sym__indent,
    STATE(2196), 1,
      sym__expression_block,
    STATE(6326), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [189526] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9231), 1,
      sym__indent,
    STATE(7139), 1,
      sym__expression_block,
    STATE(6327), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [189560] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9427), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    STATE(6328), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [189592] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9241), 1,
      sym__indent,
    STATE(592), 1,
      sym__expression_block,
    STATE(6329), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [189626] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9559), 1,
      sym__indent,
    STATE(2829), 1,
      sym__expression_block,
    STATE(6330), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [189660] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9595), 1,
      sym__indent,
    STATE(1291), 1,
      sym__expression_block,
    STATE(6331), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [189694] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9493), 1,
      sym__indent,
    STATE(1638), 1,
      sym__expression_block,
    STATE(6332), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [189728] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9247), 1,
      sym__indent,
    STATE(1392), 1,
      sym__expression_block,
    STATE(6333), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [189762] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9373), 1,
      anon_sym_COLON,
    ACTIONS(9597), 1,
      anon_sym_COLON_GT,
    STATE(6334), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [189796] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9599), 1,
      anon_sym_COLON,
    ACTIONS(9601), 1,
      anon_sym_COLON_GT,
    STATE(6335), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [189830] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9603), 1,
      sym__newline,
    ACTIONS(9605), 1,
      sym__indent,
    STATE(6336), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [189864] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9233), 1,
      sym__indent,
    STATE(2181), 1,
      sym__expression_block,
    STATE(6337), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [189898] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9555), 1,
      sym__indent,
    STATE(1190), 1,
      sym__expression_block,
    STATE(6338), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [189932] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9205), 1,
      sym_identifier,
    ACTIONS(9607), 1,
      anon_sym__,
    STATE(6339), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [189966] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8805), 2,
      sym__newline,
      sym__dedent,
    STATE(6340), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [189998] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9435), 1,
      sym__indent,
    STATE(1111), 1,
      sym__expression_block,
    STATE(6341), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [190032] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9241), 1,
      sym__indent,
    STATE(631), 1,
      sym__expression_block,
    STATE(6342), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [190066] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9609), 1,
      sym__newline,
    ACTIONS(9611), 1,
      sym__indent,
    STATE(6343), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [190100] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9613), 1,
      anon_sym_with,
    ACTIONS(9615), 1,
      anon_sym_finally,
    STATE(6344), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [190134] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9205), 1,
      sym_identifier,
    ACTIONS(9617), 1,
      anon_sym__,
    STATE(6345), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [190168] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9573), 1,
      sym__indent,
    STATE(1420), 1,
      sym__expression_block,
    STATE(6346), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [190202] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9619), 1,
      sym__indent,
    STATE(1660), 1,
      sym__expression_block,
    STATE(6347), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [190236] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9231), 1,
      sym__indent,
    STATE(7241), 1,
      sym__expression_block,
    STATE(6348), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [190270] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9621), 2,
      sym__newline,
      anon_sym_GT_RBRACK,
    STATE(6349), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [190302] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5727), 2,
      anon_sym_EQ,
      anon_sym_COLON,
    STATE(6350), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [190334] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9435), 1,
      sym__indent,
    STATE(1051), 1,
      sym__expression_block,
    STATE(6351), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [190368] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9527), 1,
      sym__indent,
    STATE(1418), 1,
      sym__expression_block,
    STATE(6352), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [190402] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9333), 1,
      sym__indent,
    STATE(6696), 1,
      sym__expression_block,
    STATE(6353), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [190436] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9493), 1,
      sym__indent,
    STATE(1642), 1,
      sym__expression_block,
    STATE(6354), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [190470] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9623), 1,
      anon_sym_EQ,
    ACTIONS(9625), 1,
      anon_sym_COLON,
    STATE(6355), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [190504] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9627), 2,
      anon_sym_COMMA,
      anon_sym_GT,
    STATE(6356), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [190536] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8726), 2,
      anon_sym_COMMA,
      anon_sym_GT,
    STATE(6357), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [190568] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9435), 1,
      sym__indent,
    STATE(1002), 1,
      sym__expression_block,
    STATE(6358), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [190602] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9547), 1,
      sym__indent,
    STATE(2226), 1,
      sym__expression_block,
    STATE(6359), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [190636] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9231), 1,
      sym__indent,
    STATE(7296), 1,
      sym__expression_block,
    STATE(6360), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [190670] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9493), 1,
      sym__indent,
    STATE(1764), 1,
      sym__expression_block,
    STATE(6361), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [190704] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9221), 1,
      sym__indent,
    STATE(1687), 1,
      sym__expression_block,
    STATE(6362), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [190738] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9233), 1,
      sym__indent,
    STATE(2175), 1,
      sym__expression_block,
    STATE(6363), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [190772] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8674), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    STATE(6364), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [190804] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9235), 1,
      sym__indent,
    STATE(1675), 1,
      sym__expression_block,
    STATE(6365), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [190838] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9629), 2,
      anon_sym_RBRACK,
      anon_sym_PIPE_RBRACK,
    STATE(6366), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [190870] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9233), 1,
      sym__indent,
    STATE(1730), 1,
      sym__expression_block,
    STATE(6367), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [190904] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9241), 1,
      sym__indent,
    STATE(598), 1,
      sym__expression_block,
    STATE(6368), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [190938] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9619), 1,
      sym__indent,
    STATE(1565), 1,
      sym__expression_block,
    STATE(6369), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [190972] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9563), 1,
      sym__indent,
    STATE(1667), 1,
      sym__expression_block,
    STATE(6370), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [191006] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9233), 1,
      sym__indent,
    STATE(1729), 1,
      sym__expression_block,
    STATE(6371), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [191040] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9373), 1,
      anon_sym_COLON,
    ACTIONS(9631), 1,
      anon_sym_COLON_GT,
    STATE(6372), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [191074] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8680), 1,
      sym_identifier,
    STATE(7508), 1,
      sym_long_identifier,
    STATE(6373), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [191108] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9633), 1,
      sym__newline,
    ACTIONS(9635), 1,
      sym__indent,
    STATE(6374), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [191142] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9231), 1,
      sym__indent,
    STATE(5909), 1,
      sym__expression_block,
    STATE(6375), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [191176] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9205), 1,
      sym_identifier,
    ACTIONS(9637), 1,
      anon_sym__,
    STATE(6376), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [191210] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8680), 1,
      sym_identifier,
    STATE(5418), 1,
      sym_long_identifier,
    STATE(6377), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [191244] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9241), 1,
      sym__indent,
    STATE(708), 1,
      sym__expression_block,
    STATE(6378), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [191278] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9639), 1,
      anon_sym_DQUOTE,
    STATE(7516), 1,
      sym__string_literal,
    STATE(6379), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [191312] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8409), 1,
      anon_sym_DQUOTE,
    STATE(7520), 1,
      sym__string_literal,
    STATE(6380), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [191346] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(5759), 2,
      anon_sym_EQ,
      anon_sym_COLON,
    STATE(6381), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [191378] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9641), 1,
      sym__newline,
    ACTIONS(9643), 1,
      sym__indent,
    STATE(6382), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [191412] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9645), 1,
      sym__indent,
    STATE(1666), 1,
      sym__expression_block,
    STATE(6383), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [191446] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9353), 1,
      sym__indent,
    STATE(1685), 1,
      sym__expression_block,
    STATE(6384), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [191480] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9647), 1,
      anon_sym_with,
    ACTIONS(9649), 1,
      anon_sym_finally,
    STATE(6385), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [191514] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9205), 1,
      sym_identifier,
    ACTIONS(9651), 1,
      anon_sym__,
    STATE(6386), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [191548] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2687), 2,
      sym__dedent,
      anon_sym_and,
    STATE(6387), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [191580] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9231), 1,
      sym__indent,
    STATE(7375), 1,
      sym__expression_block,
    STATE(6388), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [191614] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9231), 1,
      sym__indent,
    STATE(7342), 1,
      sym__expression_block,
    STATE(6389), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [191648] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9645), 1,
      sym__indent,
    STATE(1661), 1,
      sym__expression_block,
    STATE(6390), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [191682] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8674), 2,
      sym__dedent,
      anon_sym_COMMA,
    STATE(6391), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [191714] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4700), 2,
      sym__dedent,
      anon_sym_and,
    STATE(6392), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [191746] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9653), 2,
      anon_sym_EQ,
      anon_sym_COLON,
    STATE(6393), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [191778] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9457), 1,
      sym__indent,
    STATE(2047), 1,
      sym__expression_block,
    STATE(6394), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [191812] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(4711), 2,
      sym__dedent,
      anon_sym_and,
    STATE(6395), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [191844] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9241), 1,
      sym__indent,
    STATE(2842), 1,
      sym__expression_block,
    STATE(6396), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [191878] = 10,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9241), 1,
      sym__indent,
    STATE(546), 1,
      sym__expression_block,
    STATE(6397), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [191912] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9655), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(6398), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [191943] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9657), 1,
      anon_sym_RBRACK,
    STATE(6399), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [191974] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9659), 1,
      sym__dedent,
    STATE(6400), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [192005] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9661), 1,
      sym__dedent,
    STATE(6401), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [192036] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9663), 1,
      anon_sym_DASH_GT,
    STATE(6402), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [192067] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9665), 1,
      anon_sym_EQ,
    STATE(6403), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [192098] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9667), 1,
      sym__newline_not_aligned,
    STATE(6404), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [192129] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9669), 1,
      sym_identifier,
    STATE(6405), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [192160] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9671), 1,
      anon_sym_then,
    STATE(6406), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [192191] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9673), 1,
      anon_sym_COLON,
    STATE(6407), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [192222] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9675), 1,
      anon_sym_COLON,
    STATE(6408), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [192253] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9677), 1,
      sym_identifier,
    STATE(6409), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [192284] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9679), 1,
      sym__dedent,
    STATE(6410), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [192315] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9681), 1,
      sym__dedent,
    STATE(6411), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [192346] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9683), 1,
      sym__triple_quoted_content,
    STATE(6412), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [192377] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9685), 1,
      sym__triple_quoted_content,
    STATE(6413), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [192408] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9687), 1,
      sym_identifier,
    STATE(6414), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [192439] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9689), 1,
      sym_identifier,
    STATE(6415), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [192470] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9691), 1,
      anon_sym_GT,
    STATE(6416), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [192501] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9693), 1,
      sym_identifier,
    STATE(6417), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [192532] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9695), 1,
      sym_identifier,
    STATE(6418), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [192563] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9697), 1,
      anon_sym_RPAREN,
    STATE(6419), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [192594] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9699), 1,
      sym_identifier,
    STATE(6420), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [192625] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9701), 1,
      anon_sym_do,
    STATE(6421), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [192656] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9703), 1,
      sym_identifier,
    STATE(6422), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [192687] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9705), 1,
      sym_identifier,
    STATE(6423), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [192718] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9707), 1,
      anon_sym_PIPE,
    STATE(6424), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [192749] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9709), 1,
      sym_identifier,
    STATE(6425), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [192780] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9711), 1,
      sym__dedent,
    STATE(6426), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [192811] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9713), 1,
      sym_identifier,
    STATE(6427), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [192842] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9715), 1,
      sym_identifier,
    STATE(6428), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [192873] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9717), 1,
      anon_sym_COLON,
    STATE(6429), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [192904] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9719), 1,
      sym_identifier,
    STATE(6430), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [192935] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9721), 1,
      anon_sym_struct,
    STATE(6431), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [192966] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9723), 1,
      anon_sym_then,
    STATE(6432), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [192997] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9725), 1,
      anon_sym_PIPE_RPAREN,
    STATE(6433), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [193028] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9727), 1,
      sym_identifier,
    STATE(6434), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [193059] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9729), 1,
      sym__dedent,
    STATE(6435), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [193090] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9731), 1,
      anon_sym_RBRACE,
    STATE(6436), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [193121] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9733), 1,
      anon_sym_POUNDendif,
    STATE(6437), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [193152] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9735), 1,
      anon_sym_COLON,
    STATE(6438), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [193183] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9737), 1,
      sym__dedent,
    STATE(6439), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [193214] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9739), 1,
      sym_identifier,
    STATE(6440), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [193245] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9741), 1,
      sym_identifier,
    STATE(6441), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [193276] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9743), 1,
      sym_identifier,
    STATE(6442), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [193307] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9745), 1,
      sym_identifier,
    STATE(6443), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [193338] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9747), 1,
      sym_identifier,
    STATE(6444), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [193369] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9749), 1,
      anon_sym_PIPE_RPAREN,
    STATE(6445), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [193400] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9751), 1,
      sym_identifier,
    STATE(6446), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [193431] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9753), 1,
      anon_sym_POUNDendif,
    STATE(6447), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [193462] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9755), 1,
      sym_identifier,
    STATE(6448), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [193493] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9757), 1,
      sym__triple_quoted_content,
    STATE(6449), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [193524] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9759), 1,
      sym__triple_quoted_content,
    STATE(6450), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [193555] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9761), 1,
      sym_identifier,
    STATE(6451), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [193586] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9763), 1,
      sym_identifier,
    STATE(6452), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [193617] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9765), 1,
      sym_identifier,
    STATE(6453), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [193648] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9767), 1,
      sym_identifier,
    STATE(6454), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [193679] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9769), 1,
      anon_sym_GT,
    STATE(6455), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [193710] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9771), 1,
      anon_sym_then,
    STATE(6456), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [193741] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9773), 1,
      anon_sym_end,
    STATE(6457), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [193772] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9775), 1,
      sym__dedent,
    STATE(6458), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [193803] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9777), 1,
      sym_identifier,
    STATE(6459), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [193834] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9779), 1,
      sym_identifier,
    STATE(6460), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [193865] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9781), 1,
      sym__indent,
    STATE(6461), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [193896] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9783), 1,
      anon_sym_DASH_GT,
    STATE(6462), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [193927] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9785), 1,
      sym_identifier,
    STATE(6463), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [193958] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9787), 1,
      sym_identifier,
    STATE(6464), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [193989] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9789), 1,
      anon_sym_EQ,
    STATE(6465), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [194020] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9791), 1,
      sym__newline_not_aligned,
    STATE(6466), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [194051] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9793), 1,
      anon_sym_RBRACK,
    STATE(6467), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [194082] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9795), 1,
      sym_identifier,
    STATE(6468), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [194113] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9797), 1,
      sym_identifier,
    STATE(6469), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [194144] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9799), 1,
      anon_sym_PIPE_RBRACK,
    STATE(6470), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [194175] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9801), 1,
      sym__dedent,
    STATE(6471), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [194206] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9803), 1,
      sym__dedent,
    STATE(6472), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [194237] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9805), 1,
      sym_identifier,
    STATE(6473), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [194268] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9807), 1,
      sym_identifier,
    STATE(6474), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [194299] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9809), 1,
      sym_identifier,
    STATE(6475), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [194330] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9811), 1,
      anon_sym_GT,
    STATE(6476), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [194361] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9813), 1,
      anon_sym_POUNDendif,
    STATE(6477), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [194392] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8553), 1,
      anon_sym_GT,
    STATE(6478), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [194423] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9815), 1,
      sym_identifier,
    STATE(6479), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [194454] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9817), 1,
      anon_sym_PIPE_RBRACE,
    STATE(6480), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [194485] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9819), 1,
      anon_sym_do,
    STATE(6481), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [194516] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9821), 1,
      sym_identifier,
    STATE(6482), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [194547] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9823), 1,
      anon_sym_GT,
    STATE(6483), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [194578] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9825), 1,
      anon_sym_PIPE,
    STATE(6484), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [194609] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9827), 1,
      sym_identifier,
    STATE(6485), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [194640] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9829), 1,
      sym__dedent,
    STATE(6486), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [194671] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9831), 1,
      anon_sym_GT,
    STATE(6487), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [194702] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9833), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(6488), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [194733] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9835), 1,
      anon_sym_COLON,
    STATE(6489), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [194764] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9837), 1,
      anon_sym_RBRACE,
    STATE(6490), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [194795] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9839), 1,
      sym_int,
    STATE(6491), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [194826] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9841), 1,
      anon_sym_then,
    STATE(6492), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [194857] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9843), 1,
      anon_sym_PIPE_RPAREN,
    STATE(6493), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [194888] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9845), 1,
      anon_sym_GT,
    STATE(6494), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [194919] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9847), 1,
      anon_sym_RPAREN,
    STATE(6495), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [194950] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9849), 1,
      anon_sym_GT,
    STATE(6496), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [194981] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9851), 1,
      anon_sym_RBRACK,
    STATE(6497), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [195012] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8555), 1,
      anon_sym_GT,
    STATE(6498), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [195043] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8545), 1,
      anon_sym_GT,
    STATE(6499), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [195074] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3845), 1,
      anon_sym_EQ2,
    STATE(6500), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [195105] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9853), 1,
      sym__dedent,
    STATE(6501), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [195136] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9855), 1,
      anon_sym_end,
    STATE(6502), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [195167] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9857), 1,
      sym_identifier,
    STATE(6503), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [195198] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9859), 1,
      sym__triple_quoted_content,
    STATE(6504), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [195229] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9861), 1,
      sym__triple_quoted_content,
    STATE(6505), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [195260] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9863), 1,
      sym_identifier,
    STATE(6506), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [195291] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9865), 1,
      sym_identifier,
    STATE(6507), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [195322] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9867), 1,
      anon_sym_GT,
    STATE(6508), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [195353] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9869), 1,
      anon_sym_PIPE,
    STATE(6509), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [195384] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9871), 1,
      sym_int,
    STATE(6510), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [195415] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9873), 1,
      anon_sym_then,
    STATE(6511), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [195446] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8539), 1,
      anon_sym_GT,
    STATE(6512), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [195477] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9875), 1,
      sym__dedent,
    STATE(6513), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [195508] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9877), 1,
      anon_sym_PIPE_RBRACE,
    STATE(6514), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [195539] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9879), 1,
      anon_sym_GT,
    STATE(6515), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [195570] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9881), 1,
      sym_identifier,
    STATE(6516), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [195601] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9883), 1,
      anon_sym_DASH_GT,
    STATE(6517), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [195632] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9885), 1,
      anon_sym_RPAREN,
    STATE(6518), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [195663] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9887), 1,
      sym_identifier,
    STATE(6519), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [195694] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9889), 1,
      anon_sym_EQ,
    STATE(6520), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [195725] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9891), 1,
      sym__newline_not_aligned,
    STATE(6521), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [195756] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9893), 1,
      anon_sym_GT,
    STATE(6522), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [195787] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9895), 1,
      sym_identifier,
    STATE(6523), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [195818] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9897), 1,
      anon_sym_PIPE_RBRACE,
    STATE(6524), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [195849] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9899), 1,
      anon_sym_GT,
    STATE(6525), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [195880] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9901), 1,
      sym__dedent,
    STATE(6526), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [195911] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9903), 1,
      sym__dedent,
    STATE(6527), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [195942] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9905), 1,
      anon_sym_RBRACK,
    STATE(6528), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [195973] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8533), 1,
      anon_sym_GT,
    STATE(6529), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [196004] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9907), 1,
      anon_sym_PIPE_RBRACE,
    STATE(6530), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [196035] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9909), 1,
      anon_sym_do,
    STATE(6531), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [196066] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9911), 1,
      anon_sym_PIPE_RBRACE,
    STATE(6532), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [196097] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8473), 1,
      anon_sym_GT,
    STATE(6533), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [196128] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9913), 1,
      anon_sym_PIPE_RBRACK,
    STATE(6534), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [196159] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9915), 1,
      sym__dedent,
    STATE(6535), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [196190] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9227), 1,
      anon_sym_do,
    STATE(6536), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [196221] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9917), 1,
      sym_identifier,
    STATE(6537), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [196252] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9919), 1,
      sym_identifier,
    STATE(6538), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [196283] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9921), 1,
      anon_sym_PIPE,
    STATE(6539), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [196314] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9923), 1,
      anon_sym_GT,
    STATE(6540), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [196345] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9925), 1,
      sym__dedent,
    STATE(6541), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [196376] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9927), 1,
      anon_sym_RBRACE,
    STATE(6542), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [196407] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9929), 1,
      sym__indent,
    STATE(6543), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [196438] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9931), 1,
      anon_sym_COLON,
    STATE(6544), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [196469] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9933), 1,
      anon_sym_then,
    STATE(6545), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [196500] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9935), 1,
      anon_sym_GT,
    STATE(6546), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [196531] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9937), 1,
      sym_identifier,
    STATE(6547), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [196562] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9939), 1,
      sym_identifier,
    STATE(6548), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [196593] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9941), 1,
      anon_sym_GT,
    STATE(6549), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [196624] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8509), 1,
      anon_sym_GT,
    STATE(6550), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [196655] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9943), 1,
      anon_sym_PIPE_RBRACK,
    STATE(6551), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [196686] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9945), 1,
      anon_sym_PIPE_RBRACE,
    STATE(6552), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [196717] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9947), 1,
      anon_sym_GT,
    STATE(6553), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [196748] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9949), 1,
      sym__triple_quoted_content,
    STATE(6554), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [196779] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9951), 1,
      sym__triple_quoted_content,
    STATE(6555), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [196810] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9953), 1,
      sym_identifier,
    STATE(6556), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [196841] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9955), 1,
      anon_sym_PIPE_RBRACE,
    STATE(6557), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [196872] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9957), 1,
      sym_identifier,
    STATE(6558), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [196903] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9959), 1,
      anon_sym_RBRACK,
    STATE(6559), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [196934] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9961), 1,
      anon_sym_RPAREN,
    STATE(6560), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [196965] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9963), 1,
      anon_sym_then,
    STATE(6561), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [196996] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9965), 1,
      sym_identifier,
    STATE(6562), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [197027] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9967), 1,
      sym__dedent,
    STATE(6563), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [197058] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9969), 1,
      sym_int,
    STATE(6564), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [197089] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9971), 1,
      sym_identifier,
    STATE(6565), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [197120] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9973), 1,
      sym__dedent,
    STATE(6566), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [197151] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9975), 1,
      anon_sym_DASH_GT,
    STATE(6567), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [197182] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9977), 1,
      anon_sym_GT,
    STATE(6568), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [197213] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8499), 1,
      anon_sym_GT,
    STATE(6569), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [197244] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9979), 1,
      anon_sym_EQ,
    STATE(6570), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [197275] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9981), 1,
      sym__newline_not_aligned,
    STATE(6571), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [197306] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9983), 1,
      anon_sym_PIPE_RBRACE,
    STATE(6572), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [197337] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9985), 1,
      anon_sym_GT,
    STATE(6573), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [197368] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9987), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(6574), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [197399] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9989), 1,
      anon_sym_RBRACK,
    STATE(6575), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [197430] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9991), 1,
      sym__dedent,
    STATE(6576), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [197461] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9993), 1,
      sym__dedent,
    STATE(6577), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [197492] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9995), 1,
      sym_identifier,
    STATE(6578), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [197523] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9997), 1,
      sym_identifier,
    STATE(6579), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [197554] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(9999), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(6580), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [197585] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10001), 1,
      sym_identifier,
    STATE(6581), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [197616] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10003), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(6582), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [197647] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10005), 1,
      anon_sym_GT,
    STATE(6583), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [197678] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10007), 1,
      anon_sym_RPAREN,
    STATE(6584), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [197709] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10009), 1,
      anon_sym_COLON,
    STATE(6585), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [197740] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10011), 1,
      anon_sym_do,
    STATE(6586), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [197771] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10013), 1,
      anon_sym_GT,
    STATE(6587), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [197802] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10015), 1,
      anon_sym_PIPE_RBRACK,
    STATE(6588), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [197833] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10017), 1,
      anon_sym_PIPE,
    STATE(6589), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [197864] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10019), 1,
      anon_sym_PIPE_RPAREN,
    STATE(6590), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [197895] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10021), 1,
      sym__dedent,
    STATE(6591), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [197926] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10023), 1,
      ts_builtin_sym_end,
    STATE(6592), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [197957] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10025), 1,
      anon_sym_RBRACK,
    STATE(6593), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [197988] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10027), 1,
      anon_sym_COLON,
    STATE(6594), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [198019] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10029), 1,
      anon_sym_then,
    STATE(6595), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [198050] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10031), 1,
      anon_sym_GT,
    STATE(6596), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [198081] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10033), 1,
      sym_int,
    STATE(6597), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [198112] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8487), 1,
      anon_sym_GT,
    STATE(6598), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [198143] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10035), 1,
      anon_sym_COLON,
    STATE(6599), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [198174] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10037), 1,
      anon_sym_PIPE_RBRACE,
    STATE(6600), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [198205] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10039), 1,
      sym_identifier,
    STATE(6601), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [198236] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10041), 1,
      anon_sym_GT,
    STATE(6602), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [198267] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10043), 1,
      anon_sym_RBRACE,
    STATE(6603), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [198298] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10045), 1,
      sym__triple_quoted_content,
    STATE(6604), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [198329] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10047), 1,
      sym__triple_quoted_content,
    STATE(6605), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [198360] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10049), 1,
      sym_identifier,
    STATE(6606), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [198391] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10051), 1,
      anon_sym_PIPE_RBRACE,
    STATE(6607), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [198422] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10053), 1,
      sym_int,
    STATE(6608), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [198453] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10055), 1,
      sym_identifier,
    STATE(6609), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [198484] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10057), 1,
      sym_identifier,
    STATE(6610), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [198515] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10059), 1,
      anon_sym_then,
    STATE(6611), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [198546] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10061), 1,
      anon_sym_COLON,
    STATE(6612), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [198577] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10063), 1,
      sym__dedent,
    STATE(6613), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [198608] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10065), 1,
      sym_identifier,
    STATE(6614), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [198639] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10067), 1,
      anon_sym_DASH_GT,
    STATE(6615), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [198670] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10069), 1,
      anon_sym_DASH_GT,
    STATE(6616), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [198701] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10071), 1,
      anon_sym_end,
    STATE(6617), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [198732] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10073), 1,
      anon_sym_GT,
    STATE(6618), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [198763] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10075), 1,
      anon_sym_EQ,
    STATE(6619), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [198794] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10077), 1,
      sym__newline_not_aligned,
    STATE(6620), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [198825] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10079), 1,
      anon_sym_PIPE_RPAREN,
    STATE(6621), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [198856] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10081), 1,
      anon_sym_GT,
    STATE(6622), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [198887] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10083), 1,
      anon_sym_PIPE_RPAREN,
    STATE(6623), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [198918] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10085), 1,
      sym_identifier,
    STATE(6624), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [198949] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10087), 1,
      sym__dedent,
    STATE(6625), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [198980] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10089), 1,
      sym__dedent,
    STATE(6626), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [199011] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10091), 1,
      anon_sym_PIPE_RBRACE,
    STATE(6627), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [199042] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10093), 1,
      anon_sym_GT,
    STATE(6628), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [199073] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10095), 1,
      anon_sym_POUNDendif,
    STATE(6629), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [199104] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10097), 1,
      anon_sym_PIPE_RPAREN,
    STATE(6630), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [199135] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10099), 1,
      sym_identifier,
    STATE(6631), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [199166] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10101), 1,
      sym_identifier,
    STATE(6632), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [199197] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10103), 1,
      sym__dedent,
    STATE(6633), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [199228] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10105), 1,
      anon_sym_do,
    STATE(6634), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [199259] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10107), 1,
      anon_sym_POUNDendif,
    STATE(6635), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [199290] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10109), 1,
      anon_sym_GT,
    STATE(6636), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [199321] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10111), 1,
      anon_sym_PIPE,
    STATE(6637), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [199352] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10113), 1,
      anon_sym_RBRACE,
    STATE(6638), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [199383] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10115), 1,
      sym__dedent,
    STATE(6639), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [199414] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8459), 1,
      anon_sym_GT,
    STATE(6640), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [199445] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10117), 1,
      sym__dedent,
    STATE(6641), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [199476] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10119), 1,
      anon_sym_COLON,
    STATE(6642), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [199507] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10121), 1,
      anon_sym_then,
    STATE(6643), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [199538] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10123), 1,
      anon_sym_RPAREN,
    STATE(6644), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [199569] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10125), 1,
      anon_sym_PIPE_RBRACE,
    STATE(6645), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [199600] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10127), 1,
      anon_sym_GT,
    STATE(6646), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [199631] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10129), 1,
      anon_sym_struct,
    STATE(6647), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [199662] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10131), 1,
      anon_sym_POUNDendif,
    STATE(6648), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [199693] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10133), 1,
      sym__dedent,
    STATE(6649), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [199724] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10135), 1,
      anon_sym_RBRACE,
    STATE(6650), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [199755] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10137), 1,
      anon_sym_struct,
    STATE(6651), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [199786] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10139), 1,
      sym__triple_quoted_content,
    STATE(6652), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [199817] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10141), 1,
      sym__triple_quoted_content,
    STATE(6653), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [199848] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10143), 1,
      sym_identifier,
    STATE(6654), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [199879] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10145), 1,
      sym_identifier,
    STATE(6655), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [199910] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10147), 1,
      anon_sym_POUNDendif,
    STATE(6656), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [199941] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10149), 1,
      sym__dedent,
    STATE(6657), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [199972] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10151), 1,
      sym_identifier,
    STATE(6658), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [200003] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10153), 1,
      anon_sym_then,
    STATE(6659), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [200034] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10155), 1,
      anon_sym_RPAREN,
    STATE(6660), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [200065] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10157), 1,
      sym__dedent,
    STATE(6661), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [200096] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10159), 1,
      sym_identifier,
    STATE(6662), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [200127] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10161), 1,
      anon_sym_GT,
    STATE(6663), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [200158] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10163), 1,
      anon_sym_DASH_GT,
    STATE(6664), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [200189] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8513), 1,
      anon_sym_GT,
    STATE(6665), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [200220] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10165), 1,
      anon_sym_RBRACE,
    STATE(6666), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [200251] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10167), 1,
      anon_sym_EQ,
    STATE(6667), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [200282] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10169), 1,
      sym__newline_not_aligned,
    STATE(6668), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [200313] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10171), 1,
      anon_sym_PIPE_RBRACE,
    STATE(6669), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [200344] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10173), 1,
      anon_sym_GT,
    STATE(6670), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [200375] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10175), 1,
      sym_identifier,
    STATE(6671), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [200406] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10177), 1,
      sym__indent,
    STATE(6672), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [200437] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10179), 1,
      sym__dedent,
    STATE(6673), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [200468] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10181), 1,
      sym__dedent,
    STATE(6674), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [200499] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10183), 1,
      sym_identifier,
    STATE(6675), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [200530] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10185), 1,
      sym_identifier,
    STATE(6676), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [200561] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10187), 1,
      anon_sym_POUNDendif,
    STATE(6677), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [200592] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10189), 1,
      anon_sym_GT,
    STATE(6678), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [200623] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10191), 1,
      anon_sym_RBRACK,
    STATE(6679), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [200654] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8439), 1,
      anon_sym_GT,
    STATE(6680), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [200685] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10193), 1,
      anon_sym_RPAREN,
    STATE(6681), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [200716] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10195), 1,
      anon_sym_do,
    STATE(6682), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [200747] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10197), 1,
      anon_sym_PIPE_RBRACE,
    STATE(6683), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [200778] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10199), 1,
      anon_sym_GT,
    STATE(6684), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [200809] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10201), 1,
      anon_sym_PIPE,
    STATE(6685), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [200840] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10203), 1,
      anon_sym_GT,
    STATE(6686), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [200871] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10205), 1,
      sym__dedent,
    STATE(6687), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [200902] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10207), 1,
      anon_sym_GT,
    STATE(6688), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [200933] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10209), 1,
      anon_sym_RBRACK,
    STATE(6689), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [200964] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10211), 1,
      anon_sym_COLON,
    STATE(6690), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [200995] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10213), 1,
      anon_sym_then,
    STATE(6691), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [201026] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10215), 1,
      anon_sym_end,
    STATE(6692), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [201057] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10217), 1,
      sym__indent,
    STATE(6693), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [201088] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10219), 1,
      anon_sym_PIPE_RBRACK,
    STATE(6694), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [201119] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10221), 1,
      sym__dedent,
    STATE(6695), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [201150] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10223), 1,
      anon_sym_then,
    STATE(6696), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [201181] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10225), 1,
      sym_identifier,
    STATE(6697), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [201212] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8567), 1,
      anon_sym_GT,
    STATE(6698), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [201243] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10227), 1,
      sym_identifier,
    STATE(6699), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [201274] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10229), 1,
      sym__triple_quoted_content,
    STATE(6700), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [201305] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10231), 1,
      sym__triple_quoted_content,
    STATE(6701), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [201336] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10233), 1,
      sym_identifier,
    STATE(6702), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [201367] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10235), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(6703), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [201398] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10237), 1,
      anon_sym_PIPE_RBRACE,
    STATE(6704), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [201429] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10239), 1,
      anon_sym_RBRACE,
    STATE(6705), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [201460] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10241), 1,
      sym_int,
    STATE(6706), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [201491] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10243), 1,
      anon_sym_then,
    STATE(6707), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [201522] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10245), 1,
      anon_sym_PIPE_RPAREN,
    STATE(6708), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [201553] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10247), 1,
      sym__dedent,
    STATE(6709), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [201584] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10249), 1,
      sym_int,
    STATE(6710), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [201615] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10251), 1,
      anon_sym_GT,
    STATE(6711), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [201646] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10253), 1,
      anon_sym_DASH_GT,
    STATE(6712), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [201677] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10255), 1,
      anon_sym_RPAREN,
    STATE(6713), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [201708] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10257), 1,
      sym__dedent,
    STATE(6714), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [201739] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10259), 1,
      anon_sym_EQ,
    STATE(6715), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [201770] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10261), 1,
      sym__newline_not_aligned,
    STATE(6716), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [201801] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10263), 1,
      anon_sym_GT,
    STATE(6717), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [201832] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8433), 1,
      anon_sym_GT,
    STATE(6718), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [201863] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10265), 1,
      anon_sym_RPAREN,
    STATE(6719), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [201894] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10267), 1,
      anon_sym_PIPE_RBRACE,
    STATE(6720), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [201925] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10269), 1,
      sym__dedent,
    STATE(6721), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [201956] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10271), 1,
      sym__dedent,
    STATE(6722), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [201987] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10273), 1,
      anon_sym_GT,
    STATE(6723), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [202018] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10275), 1,
      anon_sym_RBRACK,
    STATE(6724), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [202049] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10277), 1,
      anon_sym_GT,
    STATE(6725), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [202080] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10279), 1,
      anon_sym_PIPE_RBRACK,
    STATE(6726), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [202111] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10281), 1,
      sym_identifier,
    STATE(6727), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [202142] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10283), 1,
      sym_identifier,
    STATE(6728), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [202173] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10285), 1,
      anon_sym_GT,
    STATE(6729), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [202204] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10287), 1,
      anon_sym_do,
    STATE(6730), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [202235] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10289), 1,
      anon_sym_PIPE_RBRACE,
    STATE(6731), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [202266] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10291), 1,
      anon_sym_GT,
    STATE(6732), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [202297] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10293), 1,
      anon_sym_PIPE,
    STATE(6733), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [202328] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8417), 1,
      anon_sym_GT,
    STATE(6734), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [202359] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10295), 1,
      sym__dedent,
    STATE(6735), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [202390] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10297), 1,
      anon_sym_RBRACK,
    STATE(6736), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [202421] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10299), 1,
      anon_sym_PIPE_RBRACE,
    STATE(6737), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [202452] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10301), 1,
      anon_sym_COLON,
    STATE(6738), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [202483] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10303), 1,
      anon_sym_then,
    STATE(6739), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [202514] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10305), 1,
      sym__dedent,
    STATE(6740), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [202545] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10307), 1,
      anon_sym_GT,
    STATE(6741), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [202576] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10309), 1,
      anon_sym_DASH_GT,
    STATE(6742), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [202607] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8549), 1,
      anon_sym_GT,
    STATE(6743), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [202638] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10311), 1,
      anon_sym_COLON,
    STATE(6744), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [202669] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10313), 1,
      sym__dedent,
    STATE(6745), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [202700] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10315), 1,
      sym_identifier,
    STATE(6746), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [202731] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10317), 1,
      sym__triple_quoted_content,
    STATE(6747), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [202762] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10319), 1,
      sym__triple_quoted_content,
    STATE(6748), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [202793] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10321), 1,
      sym_identifier,
    STATE(6749), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [202824] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10323), 1,
      sym_identifier,
    STATE(6750), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [202855] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10325), 1,
      sym__dedent,
    STATE(6751), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [202886] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10327), 1,
      sym__dedent,
    STATE(6752), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [202917] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8407), 1,
      anon_sym_GT,
    STATE(6753), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [202948] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10329), 1,
      anon_sym_then,
    STATE(6754), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [202979] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10331), 1,
      sym__dedent,
    STATE(6755), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [203010] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8493), 1,
      anon_sym_GT,
    STATE(6756), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [203041] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10333), 1,
      anon_sym_GT,
    STATE(6757), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [203072] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10335), 1,
      anon_sym_DASH_GT,
    STATE(6758), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [203103] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8405), 1,
      anon_sym_GT,
    STATE(6759), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [203134] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(849), 1,
      sym__dedent,
    STATE(6760), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [203165] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10337), 1,
      anon_sym_EQ,
    STATE(6761), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [203196] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10339), 1,
      sym__newline_not_aligned,
    STATE(6762), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [203227] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10341), 1,
      sym__dedent,
    STATE(6763), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [203258] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10343), 1,
      anon_sym_RBRACK,
    STATE(6764), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [203289] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10345), 1,
      anon_sym_PIPE_RBRACE,
    STATE(6765), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [203320] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10347), 1,
      sym__dedent,
    STATE(6766), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [203351] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10349), 1,
      sym__dedent,
    STATE(6767), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [203382] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10351), 1,
      anon_sym_GT,
    STATE(6768), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [203413] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10353), 1,
      anon_sym_RPAREN,
    STATE(6769), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [203444] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10355), 1,
      sym_identifier,
    STATE(6770), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [203475] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10357), 1,
      sym_identifier,
    STATE(6771), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [203506] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10359), 1,
      anon_sym_PIPE_RPAREN,
    STATE(6772), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [203537] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10361), 1,
      sym_int,
    STATE(6773), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [203568] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10363), 1,
      anon_sym_RBRACE,
    STATE(6774), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [203599] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10365), 1,
      anon_sym_do,
    STATE(6775), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [203630] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10367), 1,
      anon_sym_GT,
    STATE(6776), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [203661] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10369), 1,
      anon_sym_PIPE_RBRACE,
    STATE(6777), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [203692] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10371), 1,
      anon_sym_PIPE,
    STATE(6778), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [203723] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8401), 1,
      anon_sym_GT,
    STATE(6779), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [203754] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10373), 1,
      sym__dedent,
    STATE(6780), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [203785] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10375), 1,
      anon_sym_COLON,
    STATE(6781), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [203816] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10377), 1,
      anon_sym_PIPE_RBRACE,
    STATE(6782), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [203847] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10379), 1,
      anon_sym_COLON,
    STATE(6783), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [203878] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10381), 1,
      anon_sym_then,
    STATE(6784), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [203909] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10383), 1,
      anon_sym_PIPE_RBRACE,
    STATE(6785), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [203940] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10385), 1,
      anon_sym_GT,
    STATE(6786), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [203971] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10387), 1,
      sym__triple_quoted_content,
    STATE(6787), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [204002] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10389), 1,
      sym__triple_quoted_content,
    STATE(6788), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [204033] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10391), 1,
      sym_identifier,
    STATE(6789), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [204064] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10393), 1,
      anon_sym_PIPE_RBRACE,
    STATE(6790), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [204095] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10395), 1,
      anon_sym_PIPE_RBRACE,
    STATE(6791), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [204126] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10397), 1,
      sym_identifier,
    STATE(6792), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [204157] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10399), 1,
      anon_sym_struct,
    STATE(6793), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [204188] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10401), 1,
      anon_sym_then,
    STATE(6794), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [204219] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10403), 1,
      sym__dedent,
    STATE(6795), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [204250] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10405), 1,
      sym_identifier,
    STATE(6796), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [204281] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10407), 1,
      sym_identifier,
    STATE(6797), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [204312] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10409), 1,
      anon_sym_DASH_GT,
    STATE(6798), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [204343] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10411), 1,
      sym_identifier,
    STATE(6799), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [204374] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10413), 1,
      anon_sym_COLON,
    STATE(6800), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [204405] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10415), 1,
      anon_sym_EQ,
    STATE(6801), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [204436] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10417), 1,
      sym__newline_not_aligned,
    STATE(6802), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [204467] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10419), 1,
      anon_sym_end,
    STATE(6803), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [204498] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10421), 1,
      anon_sym_GT,
    STATE(6804), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [204529] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10423), 1,
      anon_sym_POUNDendif,
    STATE(6805), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [204560] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10425), 1,
      sym__dedent,
    STATE(6806), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [204591] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10427), 1,
      sym__dedent,
    STATE(6807), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [204622] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10429), 1,
      anon_sym_GT,
    STATE(6808), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [204653] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10431), 1,
      anon_sym_COLON,
    STATE(6809), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [204684] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10433), 1,
      anon_sym_GT,
    STATE(6810), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [204715] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10435), 1,
      ts_builtin_sym_end,
    STATE(6811), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [204746] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8465), 1,
      anon_sym_GT,
    STATE(6812), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [204777] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10437), 1,
      sym_identifier,
    STATE(6813), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [204808] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10439), 1,
      anon_sym_PIPE_RBRACK,
    STATE(6814), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [204839] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10441), 1,
      anon_sym_do,
    STATE(6815), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [204870] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10443), 1,
      anon_sym_GT,
    STATE(6816), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [204901] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10445), 1,
      anon_sym_RBRACK,
    STATE(6817), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [204932] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10447), 1,
      anon_sym_PIPE,
    STATE(6818), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [204963] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10449), 1,
      anon_sym_PIPE_RPAREN,
    STATE(6819), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [204994] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10451), 1,
      sym__dedent,
    STATE(6820), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [205025] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10453), 1,
      anon_sym_RPAREN,
    STATE(6821), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [205056] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10455), 1,
      sym_identifier,
    STATE(6822), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [205087] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10457), 1,
      anon_sym_COLON,
    STATE(6823), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [205118] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10459), 1,
      anon_sym_then,
    STATE(6824), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [205149] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10461), 1,
      sym_int,
    STATE(6825), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [205180] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10463), 1,
      sym_identifier,
    STATE(6826), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [205211] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10465), 1,
      sym__triple_quoted_content,
    STATE(6827), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [205242] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10467), 1,
      sym__triple_quoted_content,
    STATE(6828), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [205273] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10469), 1,
      sym_identifier,
    STATE(6829), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [205304] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10471), 1,
      sym_identifier,
    STATE(6830), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [205335] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10473), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(6831), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [205366] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10475), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(6832), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [205397] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10477), 1,
      sym__dedent,
    STATE(6833), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [205428] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10479), 1,
      anon_sym_then,
    STATE(6834), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [205459] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10481), 1,
      sym__dedent,
    STATE(6835), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [205490] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10483), 1,
      anon_sym_PIPE_RBRACK,
    STATE(6836), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [205521] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10485), 1,
      anon_sym_RBRACK,
    STATE(6837), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [205552] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10487), 1,
      anon_sym_DASH_GT,
    STATE(6838), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [205583] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10489), 1,
      anon_sym_POUNDendif,
    STATE(6839), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [205614] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10491), 1,
      anon_sym_RBRACE,
    STATE(6840), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [205645] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10493), 1,
      anon_sym_EQ,
    STATE(6841), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [205676] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10495), 1,
      sym__newline_not_aligned,
    STATE(6842), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [205707] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10497), 1,
      anon_sym_COLON,
    STATE(6843), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [205738] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10499), 1,
      anon_sym_GT,
    STATE(6844), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [205769] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10501), 1,
      sym__dedent,
    STATE(6845), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [205800] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10503), 1,
      sym__dedent,
    STATE(6846), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [205831] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10505), 1,
      sym__dedent,
    STATE(6847), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [205862] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8477), 1,
      anon_sym_GT,
    STATE(6848), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [205893] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10507), 1,
      anon_sym_PIPE_RBRACE,
    STATE(6849), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [205924] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10509), 1,
      anon_sym_GT,
    STATE(6850), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [205955] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10511), 1,
      sym_identifier,
    STATE(6851), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [205986] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10513), 1,
      sym_identifier,
    STATE(6852), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [206017] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10515), 1,
      sym_identifier,
    STATE(6853), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [206048] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10517), 1,
      sym_identifier,
    STATE(6854), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [206079] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10519), 1,
      anon_sym_do,
    STATE(6855), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [206110] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10521), 1,
      anon_sym_GT,
    STATE(6856), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [206141] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8507), 1,
      anon_sym_GT,
    STATE(6857), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [206172] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10523), 1,
      anon_sym_PIPE,
    STATE(6858), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [206203] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10525), 1,
      sym__dedent,
    STATE(6859), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [206234] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10527), 1,
      sym__dedent,
    STATE(6860), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [206265] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10529), 1,
      anon_sym_PIPE_RBRACE,
    STATE(6861), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [206296] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10531), 1,
      sym_identifier,
    STATE(6862), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [206327] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10533), 1,
      anon_sym_COLON,
    STATE(6863), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [206358] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10535), 1,
      anon_sym_then,
    STATE(6864), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [206389] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10537), 1,
      anon_sym_GT,
    STATE(6865), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [206420] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10539), 1,
      sym__dedent,
    STATE(6866), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [206451] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10541), 1,
      sym__triple_quoted_content,
    STATE(6867), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [206482] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10543), 1,
      sym__triple_quoted_content,
    STATE(6868), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [206513] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10545), 1,
      sym_identifier,
    STATE(6869), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [206544] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10547), 1,
      sym_identifier,
    STATE(6870), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [206575] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10549), 1,
      sym_identifier,
    STATE(6871), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [206606] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10551), 1,
      sym_identifier,
    STATE(6872), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [206637] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10553), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(6873), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [206668] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10555), 1,
      anon_sym_then,
    STATE(6874), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [206699] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10557), 1,
      sym__dedent,
    STATE(6875), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [206730] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10559), 1,
      anon_sym_RPAREN,
    STATE(6876), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [206761] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10561), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(6877), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [206792] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10563), 1,
      anon_sym_DASH_GT,
    STATE(6878), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [206823] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10565), 1,
      sym_int,
    STATE(6879), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [206854] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10567), 1,
      anon_sym_GT,
    STATE(6880), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [206885] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10569), 1,
      anon_sym_EQ,
    STATE(6881), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [206916] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10571), 1,
      sym__newline_not_aligned,
    STATE(6882), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [206947] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10573), 1,
      anon_sym_RPAREN,
    STATE(6883), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [206978] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8511), 1,
      anon_sym_GT,
    STATE(6884), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [207009] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10575), 1,
      anon_sym_PIPE_RBRACE,
    STATE(6885), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [207040] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10577), 1,
      sym__dedent,
    STATE(6886), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [207071] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10579), 1,
      sym__dedent,
    STATE(6887), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [207102] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10581), 1,
      anon_sym_GT,
    STATE(6888), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [207133] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10583), 1,
      anon_sym_RBRACK,
    STATE(6889), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [207164] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10585), 1,
      anon_sym_PIPE_RPAREN,
    STATE(6890), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [207195] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10587), 1,
      anon_sym_PIPE_RBRACK,
    STATE(6891), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [207226] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10589), 1,
      sym_identifier,
    STATE(6892), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [207257] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10591), 1,
      sym_identifier,
    STATE(6893), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [207288] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10593), 1,
      sym__dedent,
    STATE(6894), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [207319] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10595), 1,
      anon_sym_do,
    STATE(6895), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [207350] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10597), 1,
      anon_sym_GT,
    STATE(6896), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [207381] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10599), 1,
      anon_sym_RBRACE,
    STATE(6897), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [207412] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10601), 1,
      anon_sym_PIPE,
    STATE(6898), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [207443] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10603), 1,
      anon_sym_GT,
    STATE(6899), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [207474] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10605), 1,
      sym__dedent,
    STATE(6900), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [207505] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10607), 1,
      anon_sym_POUNDendif,
    STATE(6901), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [207536] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10609), 1,
      sym_identifier,
    STATE(6902), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [207567] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10611), 1,
      anon_sym_COLON,
    STATE(6903), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [207598] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10613), 1,
      anon_sym_then,
    STATE(6904), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [207629] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10615), 1,
      sym__dedent,
    STATE(6905), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [207660] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10617), 1,
      anon_sym_PIPE_RBRACE,
    STATE(6906), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [207691] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10619), 1,
      sym__triple_quoted_content,
    STATE(6907), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [207722] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10621), 1,
      sym__triple_quoted_content,
    STATE(6908), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [207753] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10623), 1,
      sym_identifier,
    STATE(6909), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [207784] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8569), 1,
      anon_sym_GT,
    STATE(6910), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [207815] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10625), 1,
      sym__dedent,
    STATE(6911), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [207846] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10627), 1,
      anon_sym_PIPE_RBRACE,
    STATE(6912), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [207877] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10629), 1,
      anon_sym_EQ,
    STATE(6913), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [207908] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10631), 1,
      anon_sym_GT,
    STATE(6914), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [207939] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10633), 1,
      sym__dedent,
    STATE(6915), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [207970] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10635), 1,
      sym_identifier,
    STATE(6916), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [208001] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10637), 1,
      anon_sym_PIPE_RBRACE,
    STATE(6917), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [208032] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10639), 1,
      anon_sym_PIPE,
    STATE(6918), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [208063] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8579), 1,
      anon_sym_GT,
    STATE(6919), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [208094] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10641), 1,
      anon_sym_GT,
    STATE(6920), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [208125] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10643), 1,
      anon_sym_COLON,
    STATE(6921), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [208156] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10645), 1,
      anon_sym_RBRACK,
    STATE(6922), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [208187] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10647), 1,
      sym__triple_quoted_content,
    STATE(6923), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [208218] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10649), 1,
      sym__triple_quoted_content,
    STATE(6924), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [208249] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10651), 1,
      sym_identifier,
    STATE(6925), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [208280] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10653), 1,
      anon_sym_POUNDendif,
    STATE(6926), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [208311] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10655), 1,
      sym__dedent,
    STATE(6927), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [208342] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10657), 1,
      anon_sym_GT,
    STATE(6928), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [208373] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10659), 1,
      anon_sym_EQ,
    STATE(6929), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [208404] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8571), 1,
      anon_sym_GT,
    STATE(6930), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [208435] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10661), 1,
      anon_sym_PIPE_RBRACE,
    STATE(6931), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [208466] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10663), 1,
      anon_sym_GT,
    STATE(6932), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [208497] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10665), 1,
      anon_sym_end,
    STATE(6933), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [208528] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10667), 1,
      sym__triple_quoted_content,
    STATE(6934), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [208559] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10669), 1,
      sym__triple_quoted_content,
    STATE(6935), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [208590] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10671), 1,
      sym_identifier,
    STATE(6936), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [208621] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10673), 1,
      sym_identifier,
    STATE(6937), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [208652] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10675), 1,
      sym__dedent,
    STATE(6938), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [208683] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10677), 1,
      anon_sym_GT,
    STATE(6939), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [208714] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10679), 1,
      anon_sym_EQ,
    STATE(6940), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [208745] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10681), 1,
      anon_sym_RPAREN,
    STATE(6941), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [208776] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10683), 1,
      anon_sym_PIPE_RPAREN,
    STATE(6942), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [208807] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10685), 1,
      anon_sym_GT,
    STATE(6943), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [208838] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10687), 1,
      sym_identifier,
    STATE(6944), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [208869] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10689), 1,
      sym__triple_quoted_content,
    STATE(6945), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [208900] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10691), 1,
      sym__triple_quoted_content,
    STATE(6946), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [208931] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10693), 1,
      sym_identifier,
    STATE(6947), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [208962] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10695), 1,
      anon_sym_PIPE_RBRACE,
    STATE(6948), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [208993] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10697), 1,
      sym__dedent,
    STATE(6949), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [209024] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10699), 1,
      sym_identifier,
    STATE(6950), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [209055] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10701), 1,
      sym_int,
    STATE(6951), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [209086] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10703), 1,
      anon_sym_RBRACE,
    STATE(6952), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [209117] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10705), 1,
      anon_sym_RBRACE,
    STATE(6953), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [209148] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10707), 1,
      sym__triple_quoted_content,
    STATE(6954), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [209179] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10709), 1,
      sym__triple_quoted_content,
    STATE(6955), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [209210] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10711), 1,
      sym_identifier,
    STATE(6956), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [209241] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10713), 1,
      sym_int,
    STATE(6957), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [209272] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10715), 1,
      sym__dedent,
    STATE(6958), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [209303] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10717), 1,
      anon_sym_PIPE_RBRACE,
    STATE(6959), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [209334] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10719), 1,
      sym_identifier,
    STATE(6960), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [209365] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10721), 1,
      anon_sym_GT,
    STATE(6961), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [209396] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10723), 1,
      anon_sym_PIPE_RPAREN,
    STATE(6962), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [209427] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10725), 1,
      sym__triple_quoted_content,
    STATE(6963), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [209458] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10727), 1,
      sym__triple_quoted_content,
    STATE(6964), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [209489] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10729), 1,
      sym_identifier,
    STATE(6965), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [209520] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10731), 1,
      anon_sym_GT,
    STATE(6966), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [209551] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10733), 1,
      sym__dedent,
    STATE(6967), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [209582] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8463), 1,
      anon_sym_GT,
    STATE(6968), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [209613] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10735), 1,
      anon_sym_PIPE_RBRACE,
    STATE(6969), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [209644] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10737), 1,
      anon_sym_GT,
    STATE(6970), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [209675] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10739), 1,
      anon_sym_RPAREN,
    STATE(6971), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [209706] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10741), 1,
      sym__triple_quoted_content,
    STATE(6972), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [209737] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10743), 1,
      sym__triple_quoted_content,
    STATE(6973), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [209768] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10745), 1,
      sym_identifier,
    STATE(6974), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [209799] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10747), 1,
      anon_sym_GT,
    STATE(6975), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [209830] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10749), 1,
      sym__dedent,
    STATE(6976), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [209861] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10751), 1,
      anon_sym_COLON,
    STATE(6977), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [209892] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10753), 1,
      anon_sym_struct,
    STATE(6978), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [209923] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10755), 1,
      anon_sym_end,
    STATE(6979), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [209954] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8461), 1,
      anon_sym_GT,
    STATE(6980), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [209985] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10757), 1,
      sym__triple_quoted_content,
    STATE(6981), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [210016] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10759), 1,
      sym__triple_quoted_content,
    STATE(6982), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [210047] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10761), 1,
      sym_identifier,
    STATE(6983), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [210078] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10763), 1,
      sym__dedent,
    STATE(6984), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [210109] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10765), 1,
      sym__dedent,
    STATE(6985), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [210140] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10767), 1,
      sym_identifier,
    STATE(6986), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [210171] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10769), 1,
      sym__triple_quoted_content,
    STATE(6987), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [210202] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10771), 1,
      sym__triple_quoted_content,
    STATE(6988), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [210233] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10773), 1,
      anon_sym_GT,
    STATE(6989), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [210264] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10775), 1,
      sym__dedent,
    STATE(6990), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [210295] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10777), 1,
      anon_sym_POUNDendif,
    STATE(6991), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [210326] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10779), 1,
      anon_sym_PIPE_RPAREN,
    STATE(6992), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [210357] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10781), 1,
      sym__triple_quoted_content,
    STATE(6993), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [210388] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10783), 1,
      sym__triple_quoted_content,
    STATE(6994), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [210419] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10785), 1,
      anon_sym_GT,
    STATE(6995), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [210450] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10787), 1,
      sym__dedent,
    STATE(6996), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [210481] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10789), 1,
      sym_int,
    STATE(6997), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [210512] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8577), 1,
      anon_sym_GT,
    STATE(6998), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [210543] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10791), 1,
      anon_sym_PIPE_RBRACE,
    STATE(6999), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [210574] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10793), 1,
      sym__dedent,
    STATE(7000), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [210605] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10795), 1,
      anon_sym_PIPE_RBRACE,
    STATE(7001), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [210636] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10797), 1,
      anon_sym_GT,
    STATE(7002), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [210667] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10799), 1,
      sym_identifier,
    STATE(7003), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [210698] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10801), 1,
      sym__dedent,
    STATE(7004), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [210729] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10803), 1,
      sym_int,
    STATE(7005), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [210760] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10805), 1,
      anon_sym_GT,
    STATE(7006), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [210791] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10807), 1,
      anon_sym_LT2,
    STATE(7007), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [210822] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10809), 1,
      sym__dedent,
    STATE(7008), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [210853] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10811), 1,
      sym__indent,
    STATE(7009), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [210884] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10813), 1,
      sym__dedent,
    STATE(7010), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [210915] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10815), 1,
      anon_sym_PIPE_RBRACK,
    STATE(7011), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [210946] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10817), 1,
      sym__dedent,
    STATE(7012), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [210977] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10819), 1,
      anon_sym_RBRACK,
    STATE(7013), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [211008] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10821), 1,
      anon_sym_RPAREN,
    STATE(7014), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [211039] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10823), 1,
      sym_identifier,
    STATE(7015), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [211070] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10825), 1,
      sym__dedent,
    STATE(7016), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [211101] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10827), 1,
      sym__newline_not_aligned,
    STATE(7017), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [211132] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10829), 1,
      sym_int,
    STATE(7018), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [211163] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10831), 1,
      sym_identifier,
    STATE(7019), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [211194] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10833), 1,
      sym__dedent,
    STATE(7020), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [211225] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10835), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(7021), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [211256] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10837), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(7022), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [211287] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10839), 1,
      sym_identifier,
    STATE(7023), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [211318] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10841), 1,
      sym__dedent,
    STATE(7024), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [211349] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10843), 1,
      anon_sym_COLON,
    STATE(7025), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [211380] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10845), 1,
      anon_sym_PIPE_RBRACK,
    STATE(7026), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [211411] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10847), 1,
      anon_sym_RBRACK,
    STATE(7027), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [211442] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10849), 1,
      sym__dedent,
    STATE(7028), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [211473] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10851), 1,
      anon_sym_POUNDendif,
    STATE(7029), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [211504] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10853), 1,
      anon_sym_RBRACE,
    STATE(7030), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [211535] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10855), 1,
      sym__dedent,
    STATE(7031), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [211566] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10857), 1,
      sym__dedent,
    STATE(7032), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [211597] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10859), 1,
      anon_sym_EQ,
    STATE(7033), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [211628] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10861), 1,
      anon_sym_GT,
    STATE(7034), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [211659] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10863), 1,
      sym_int,
    STATE(7035), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [211690] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10865), 1,
      sym__dedent,
    STATE(7036), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [211721] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8537), 1,
      anon_sym_GT,
    STATE(7037), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [211752] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10867), 1,
      sym_identifier,
    STATE(7038), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [211783] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10869), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(7039), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [211814] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10871), 1,
      sym__dedent,
    STATE(7040), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [211845] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10873), 1,
      anon_sym_GT,
    STATE(7041), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [211876] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10875), 1,
      sym_identifier,
    STATE(7042), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [211907] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10877), 1,
      sym_int,
    STATE(7043), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [211938] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10879), 1,
      sym__dedent,
    STATE(7044), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [211969] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10881), 1,
      anon_sym_DASH_GT,
    STATE(7045), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [212000] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10883), 1,
      anon_sym_GT,
    STATE(7046), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [212031] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10885), 1,
      anon_sym_RPAREN,
    STATE(7047), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [212062] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10887), 1,
      sym__dedent,
    STATE(7048), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [212093] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10889), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(7049), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [212124] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10891), 1,
      sym_identifier,
    STATE(7050), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [212155] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10893), 1,
      anon_sym_struct,
    STATE(7051), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [212186] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10895), 1,
      sym__dedent,
    STATE(7052), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [212217] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10897), 1,
      anon_sym_then,
    STATE(7053), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [212248] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10899), 1,
      sym_identifier,
    STATE(7054), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [212279] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10901), 1,
      sym__dedent,
    STATE(7055), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [212310] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10903), 1,
      sym__dedent,
    STATE(7056), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [212341] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10905), 1,
      anon_sym_RBRACE,
    STATE(7057), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [212372] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10907), 1,
      anon_sym_POUNDendif,
    STATE(7058), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [212403] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10909), 1,
      sym__dedent,
    STATE(7059), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [212434] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10911), 1,
      sym__dedent,
    STATE(7060), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [212465] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10913), 1,
      sym_identifier,
    STATE(7061), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [212496] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10915), 1,
      anon_sym_GT,
    STATE(7062), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [212527] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10917), 1,
      anon_sym_unit,
    STATE(7063), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [212558] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10919), 1,
      sym__dedent,
    STATE(7064), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [212589] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10921), 1,
      anon_sym_PIPE_RBRACK,
    STATE(7065), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [212620] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10923), 1,
      anon_sym_PIPE_RPAREN,
    STATE(7066), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [212651] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10925), 1,
      anon_sym_get,
    STATE(7067), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [212682] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10927), 1,
      sym__dedent,
    STATE(7068), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [212713] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10929), 1,
      anon_sym_RBRACK,
    STATE(7069), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [212744] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10931), 1,
      anon_sym_POUNDendif,
    STATE(7070), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [212775] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10933), 1,
      anon_sym_GT,
    STATE(7071), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [212806] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10935), 1,
      sym__dedent,
    STATE(7072), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [212837] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10937), 1,
      anon_sym_RPAREN,
    STATE(7073), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [212868] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10939), 1,
      anon_sym_end,
    STATE(7074), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [212899] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10941), 1,
      sym_identifier,
    STATE(7075), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [212930] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10943), 1,
      sym__dedent,
    STATE(7076), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [212961] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10945), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(7077), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [212992] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10947), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(7078), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [213023] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10949), 1,
      anon_sym_GT,
    STATE(7079), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [213054] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10951), 1,
      sym__dedent,
    STATE(7080), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [213085] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10953), 1,
      sym_int,
    STATE(7081), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [213116] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10955), 1,
      sym_int,
    STATE(7082), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [213147] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8397), 1,
      anon_sym_GT,
    STATE(7083), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [213178] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10957), 1,
      anon_sym_PIPE_RBRACE,
    STATE(7084), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [213209] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10959), 1,
      anon_sym_LT2,
    STATE(7085), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [213240] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10961), 1,
      anon_sym_RBRACE,
    STATE(7086), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [213271] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10963), 1,
      anon_sym_PIPE_RBRACE,
    STATE(7087), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [213302] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10965), 1,
      anon_sym_GT,
    STATE(7088), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [213333] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10967), 1,
      sym__dedent,
    STATE(7089), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [213364] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10969), 1,
      sym_identifier,
    STATE(7090), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [213395] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10971), 1,
      sym_int,
    STATE(7091), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [213426] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10973), 1,
      anon_sym_PIPE_RPAREN,
    STATE(7092), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [213457] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10975), 1,
      anon_sym_COLON,
    STATE(7093), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [213488] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10977), 1,
      anon_sym_RPAREN,
    STATE(7094), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [213519] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10979), 1,
      sym__indent,
    STATE(7095), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [213550] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10981), 1,
      sym_identifier,
    STATE(7096), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [213581] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10983), 1,
      sym_identifier,
    STATE(7097), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [213612] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10985), 1,
      sym_int,
    STATE(7098), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [213643] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10987), 1,
      anon_sym_GT,
    STATE(7099), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [213674] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10989), 1,
      anon_sym_RPAREN,
    STATE(7100), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [213705] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10991), 1,
      anon_sym_EQ,
    STATE(7101), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [213736] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10993), 1,
      anon_sym_GT,
    STATE(7102), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [213767] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10995), 1,
      sym__indent,
    STATE(7103), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [213798] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10997), 1,
      anon_sym_RBRACK,
    STATE(7104), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [213829] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10999), 1,
      anon_sym_COLON,
    STATE(7105), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [213860] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11001), 1,
      anon_sym_RPAREN,
    STATE(7106), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [213891] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8475), 1,
      anon_sym_GT,
    STATE(7107), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [213922] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8503), 1,
      anon_sym_GT,
    STATE(7108), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [213953] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11003), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(7109), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [213984] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11005), 1,
      sym__dedent,
    STATE(7110), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [214015] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11007), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(7111), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [214046] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11009), 1,
      anon_sym_RBRACK,
    STATE(7112), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [214077] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11011), 1,
      anon_sym_PIPE_RBRACK,
    STATE(7113), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [214108] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11013), 1,
      anon_sym_LT2,
    STATE(7114), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [214139] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11015), 1,
      anon_sym_GT,
    STATE(7115), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [214170] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11017), 1,
      anon_sym_DASH_GT,
    STATE(7116), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [214201] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2936), 1,
      sym__newline_not_aligned,
    STATE(7117), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [214232] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11019), 1,
      sym_identifier,
    STATE(7118), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [214263] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11021), 1,
      anon_sym_PIPE_RBRACE,
    STATE(7119), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [214294] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11023), 1,
      anon_sym_PIPE_RBRACE,
    STATE(7120), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [214325] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11025), 1,
      sym_identifier,
    STATE(7121), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [214356] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11027), 1,
      sym__dedent,
    STATE(7122), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [214387] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11029), 1,
      sym_identifier,
    STATE(7123), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [214418] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11031), 1,
      anon_sym_COLON,
    STATE(7124), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [214449] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11033), 1,
      anon_sym_GT,
    STATE(7125), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [214480] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11035), 1,
      sym_int,
    STATE(7126), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [214511] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11037), 1,
      sym__indent,
    STATE(7127), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [214542] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11039), 1,
      sym_identifier,
    STATE(7128), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [214573] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11041), 1,
      sym_identifier,
    STATE(7129), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [214604] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11043), 1,
      anon_sym_GT,
    STATE(7130), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [214635] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8419), 1,
      anon_sym_GT,
    STATE(7131), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [214666] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11045), 1,
      sym_identifier,
    STATE(7132), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [214697] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8423), 1,
      anon_sym_GT,
    STATE(7133), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [214728] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11047), 1,
      sym__indent,
    STATE(7134), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [214759] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11049), 1,
      anon_sym_PIPE_RBRACE,
    STATE(7135), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [214790] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11051), 1,
      anon_sym_GT,
    STATE(7136), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [214821] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11053), 1,
      anon_sym_PIPE_RBRACK,
    STATE(7137), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [214852] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11055), 1,
      anon_sym_RBRACK,
    STATE(7138), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [214883] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11057), 1,
      anon_sym_RPAREN,
    STATE(7139), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [214914] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11059), 1,
      sym_identifier,
    STATE(7140), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [214945] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11061), 1,
      sym_int,
    STATE(7141), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [214976] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11063), 1,
      anon_sym_RBRACK,
    STATE(7142), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [215007] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11065), 1,
      sym_int,
    STATE(7143), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [215038] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11067), 1,
      anon_sym_LT2,
    STATE(7144), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [215069] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11069), 1,
      sym_int,
    STATE(7145), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [215100] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11071), 1,
      anon_sym_DASH_GT,
    STATE(7146), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [215131] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11073), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(7147), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [215162] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11075), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(7148), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [215193] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11077), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(7149), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [215224] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11079), 1,
      anon_sym_PIPE_RBRACK,
    STATE(7150), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [215255] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11081), 1,
      anon_sym_RBRACK,
    STATE(7151), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [215286] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11083), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(7152), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [215317] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11085), 1,
      anon_sym_GT,
    STATE(7153), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [215348] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11087), 1,
      sym__indent,
    STATE(7154), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [215379] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11089), 1,
      sym_identifier,
    STATE(7155), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [215410] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11091), 1,
      sym_identifier,
    STATE(7156), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [215441] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11093), 1,
      anon_sym_RPAREN,
    STATE(7157), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [215472] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11095), 1,
      anon_sym_PIPE_RPAREN,
    STATE(7158), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [215503] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11097), 1,
      sym_int,
    STATE(7159), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [215534] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11099), 1,
      anon_sym_RBRACE,
    STATE(7160), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [215565] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11101), 1,
      sym__indent,
    STATE(7161), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [215596] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11103), 1,
      sym_identifier,
    STATE(7162), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [215627] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11105), 1,
      anon_sym_then,
    STATE(7163), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [215658] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11107), 1,
      anon_sym_PIPE_RBRACE,
    STATE(7164), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [215689] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11109), 1,
      sym_identifier,
    STATE(7165), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [215720] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11111), 1,
      sym_identifier,
    STATE(7166), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [215751] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11113), 1,
      sym_identifier,
    STATE(7167), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [215782] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11115), 1,
      anon_sym_COLON,
    STATE(7168), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [215813] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11117), 1,
      anon_sym_end,
    STATE(7169), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [215844] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11119), 1,
      sym_identifier,
    STATE(7170), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [215875] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11121), 1,
      anon_sym_LT2,
    STATE(7171), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [215906] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(10925), 1,
      anon_sym_set,
    STATE(7172), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [215937] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11123), 1,
      anon_sym_DASH_GT,
    STATE(7173), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [215968] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11125), 1,
      anon_sym_RPAREN,
    STATE(7174), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [215999] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11127), 1,
      anon_sym_PIPE_RPAREN,
    STATE(7175), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [216030] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11129), 1,
      anon_sym_set,
    STATE(7176), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [216061] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11131), 1,
      anon_sym_GT,
    STATE(7177), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [216092] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11133), 1,
      sym__indent,
    STATE(7178), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [216123] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11135), 1,
      sym_identifier,
    STATE(7179), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [216154] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11137), 1,
      sym_identifier,
    STATE(7180), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [216185] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11129), 1,
      anon_sym_get,
    STATE(7181), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [216216] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11139), 1,
      sym_int,
    STATE(7182), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [216247] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11141), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(7183), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [216278] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11143), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(7184), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [216309] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11145), 1,
      sym__indent,
    STATE(7185), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [216340] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11147), 1,
      anon_sym_PIPE_RPAREN,
    STATE(7186), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [216371] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11149), 1,
      anon_sym_set,
    STATE(7187), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [216402] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11149), 1,
      anon_sym_get,
    STATE(7188), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [216433] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11151), 1,
      anon_sym_set,
    STATE(7189), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [216464] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11151), 1,
      anon_sym_get,
    STATE(7190), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [216495] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11153), 1,
      anon_sym_RPAREN,
    STATE(7191), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [216526] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11155), 1,
      anon_sym_POUNDendif,
    STATE(7192), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [216557] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8443), 1,
      anon_sym_GT,
    STATE(7193), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [216588] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11157), 1,
      anon_sym_LT2,
    STATE(7194), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [216619] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11159), 1,
      anon_sym_PIPE_RBRACE,
    STATE(7195), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [216650] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11161), 1,
      anon_sym_DASH_GT,
    STATE(7196), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [216681] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11163), 1,
      anon_sym_struct,
    STATE(7197), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [216712] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11165), 1,
      anon_sym_GT,
    STATE(7198), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [216743] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11167), 1,
      sym__dedent,
    STATE(7199), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [216774] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11169), 1,
      sym_int,
    STATE(7200), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [216805] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11171), 1,
      sym__indent,
    STATE(7201), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [216836] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11173), 1,
      sym_identifier,
    STATE(7202), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [216867] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11175), 1,
      sym_identifier,
    STATE(7203), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [216898] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11177), 1,
      anon_sym_RBRACE,
    STATE(7204), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [216929] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11179), 1,
      anon_sym_POUNDendif,
    STATE(7205), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [216960] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11181), 1,
      sym__dedent,
    STATE(7206), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [216991] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11183), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(7207), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [217022] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11185), 1,
      sym__indent,
    STATE(7208), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [217053] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11187), 1,
      anon_sym_EQ,
    STATE(7209), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [217084] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11189), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(7210), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [217115] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11191), 1,
      anon_sym_PIPE_RBRACK,
    STATE(7211), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [217146] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11193), 1,
      sym_identifier,
    STATE(7212), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [217177] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11195), 1,
      anon_sym_PIPE_RPAREN,
    STATE(7213), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [217208] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11197), 1,
      sym__dedent,
    STATE(7214), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [217239] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11199), 1,
      anon_sym_LT2,
    STATE(7215), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [217270] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11201), 1,
      anon_sym_PIPE_RPAREN,
    STATE(7216), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [217301] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11203), 1,
      anon_sym_DASH_GT,
    STATE(7217), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [217332] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11205), 1,
      sym_identifier,
    STATE(7218), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [217363] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11207), 1,
      anon_sym_RBRACK,
    STATE(7219), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [217394] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11209), 1,
      anon_sym_POUNDendif,
    STATE(7220), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [217425] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11211), 1,
      anon_sym_RBRACE,
    STATE(7221), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [217456] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11213), 1,
      sym__indent,
    STATE(7222), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [217487] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11215), 1,
      sym_identifier,
    STATE(7223), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [217518] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11217), 1,
      sym_identifier,
    STATE(7224), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [217549] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11219), 1,
      anon_sym_POUNDendif,
    STATE(7225), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [217580] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11221), 1,
      anon_sym_GT,
    STATE(7226), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [217611] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11223), 1,
      anon_sym_end,
    STATE(7227), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [217642] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11225), 1,
      sym_identifier,
    STATE(7228), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [217673] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11227), 1,
      sym__indent,
    STATE(7229), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [217704] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11229), 1,
      sym__dedent,
    STATE(7230), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [217735] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11231), 1,
      anon_sym_PIPE_RPAREN,
    STATE(7231), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [217766] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11233), 1,
      anon_sym_PIPE_RBRACE,
    STATE(7232), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [217797] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11235), 1,
      anon_sym_RBRACE,
    STATE(7233), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [217828] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11237), 1,
      anon_sym_GT,
    STATE(7234), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [217859] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11239), 1,
      sym_int,
    STATE(7235), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [217890] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11241), 1,
      anon_sym_LT2,
    STATE(7236), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [217921] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11243), 1,
      sym_int,
    STATE(7237), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [217952] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11245), 1,
      anon_sym_DASH_GT,
    STATE(7238), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [217983] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11247), 1,
      anon_sym_PIPE_RPAREN,
    STATE(7239), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [218014] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11249), 1,
      anon_sym_GT,
    STATE(7240), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [218045] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11251), 1,
      anon_sym_RPAREN,
    STATE(7241), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [218076] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11253), 1,
      anon_sym_PIPE_RPAREN,
    STATE(7242), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [218107] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11255), 1,
      sym__indent,
    STATE(7243), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [218138] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11257), 1,
      sym_identifier,
    STATE(7244), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [218169] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11259), 1,
      sym_identifier,
    STATE(7245), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [218200] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11261), 1,
      anon_sym_GT,
    STATE(7246), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [218231] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11263), 1,
      anon_sym_RBRACK,
    STATE(7247), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [218262] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8451), 1,
      anon_sym_GT,
    STATE(7248), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [218293] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8391), 1,
      anon_sym_GT,
    STATE(7249), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [218324] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11265), 1,
      sym__indent,
    STATE(7250), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [218355] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11267), 1,
      sym_identifier,
    STATE(7251), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [218386] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11269), 1,
      sym_identifier,
    STATE(7252), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [218417] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11271), 1,
      sym__dedent,
    STATE(7253), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [218448] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11273), 1,
      anon_sym_PIPE_RBRACE,
    STATE(7254), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [218479] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11275), 1,
      anon_sym_GT,
    STATE(7255), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [218510] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11277), 1,
      sym__indent,
    STATE(7256), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [218541] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11279), 1,
      anon_sym_LT2,
    STATE(7257), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [218572] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11281), 1,
      sym_identifier,
    STATE(7258), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [218603] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11283), 1,
      anon_sym_DASH_GT,
    STATE(7259), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [218634] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11285), 1,
      sym_int,
    STATE(7260), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [218665] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11287), 1,
      sym_identifier,
    STATE(7261), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [218696] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11289), 1,
      sym__indent,
    STATE(7262), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [218727] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11291), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(7263), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [218758] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11293), 1,
      sym__indent,
    STATE(7264), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [218789] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11295), 1,
      sym_identifier,
    STATE(7265), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [218820] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11297), 1,
      sym_identifier,
    STATE(7266), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [218851] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11299), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(7267), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [218882] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11301), 1,
      sym_identifier,
    STATE(7268), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [218913] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11303), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(7269), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [218944] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11305), 1,
      sym__indent,
    STATE(7270), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [218975] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11307), 1,
      sym__indent,
    STATE(7271), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [219006] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11309), 1,
      sym__indent,
    STATE(7272), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [219037] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11311), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(7273), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [219068] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11313), 1,
      sym_identifier,
    STATE(7274), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [219099] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11315), 1,
      sym_int,
    STATE(7275), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [219130] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11317), 1,
      anon_sym_GT,
    STATE(7276), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [219161] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11319), 1,
      anon_sym_RBRACK,
    STATE(7277), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [219192] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11321), 1,
      anon_sym_PIPE_RBRACE,
    STATE(7278), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [219223] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11323), 1,
      anon_sym_PIPE_RBRACK,
    STATE(7279), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [219254] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11325), 1,
      anon_sym_PIPE_RPAREN,
    STATE(7280), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [219285] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11327), 1,
      anon_sym_GT,
    STATE(7281), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [219316] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11329), 1,
      sym__indent,
    STATE(7282), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [219347] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11331), 1,
      sym_identifier,
    STATE(7283), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [219378] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11333), 1,
      sym_identifier,
    STATE(7284), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [219409] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11335), 1,
      sym_int,
    STATE(7285), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [219440] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11337), 1,
      anon_sym_PIPE_RPAREN,
    STATE(7286), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [219471] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11339), 1,
      sym_identifier,
    STATE(7287), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [219502] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8489), 1,
      anon_sym_GT,
    STATE(7288), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [219533] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11341), 1,
      sym__indent,
    STATE(7289), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [219564] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11343), 1,
      anon_sym_GT,
    STATE(7290), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [219595] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11345), 1,
      sym__indent,
    STATE(7291), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [219626] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11347), 1,
      anon_sym_new,
    STATE(7292), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [219657] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11349), 1,
      anon_sym_PIPE_RBRACK,
    STATE(7293), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [219688] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11351), 1,
      anon_sym_PIPE_RBRACE,
    STATE(7294), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [219719] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11353), 1,
      anon_sym_RBRACK,
    STATE(7295), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [219750] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11355), 1,
      anon_sym_RPAREN,
    STATE(7296), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [219781] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11357), 1,
      sym_identifier,
    STATE(7297), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [219812] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11359), 1,
      sym__newline_not_aligned,
    STATE(7298), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [219843] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11361), 1,
      anon_sym_GT,
    STATE(7299), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [219874] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11363), 1,
      sym__indent,
    STATE(7300), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [219905] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11365), 1,
      sym_identifier,
    STATE(7301), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [219936] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11367), 1,
      sym_identifier,
    STATE(7302), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [219967] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11369), 1,
      sym__newline_not_aligned,
    STATE(7303), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [219998] = 8,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(133), 1,
      sym_line_comment,
    ACTIONS(2936), 1,
      aux_sym_fsi_directive_decl_token1,
    ACTIONS(6818), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(6820), 1,
      anon_sym_POUNDlight,
    ACTIONS(6822), 1,
      anon_sym_POUNDr,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7304), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [220027] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11371), 1,
      anon_sym_PIPE_RPAREN,
    STATE(7305), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [220058] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11373), 1,
      sym_int,
    STATE(7306), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [220089] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11375), 1,
      sym__indent,
    STATE(7307), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [220120] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11377), 1,
      anon_sym_GT,
    STATE(7308), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [220151] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11379), 1,
      sym_int,
    STATE(7309), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [220182] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11381), 1,
      anon_sym_RBRACE,
    STATE(7310), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [220213] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11383), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(7311), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [220244] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11385), 1,
      sym_int,
    STATE(7312), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [220275] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2986), 1,
      sym__newline_not_aligned,
    STATE(7313), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [220306] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11387), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(7314), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [220337] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11389), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(7315), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [220368] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11391), 1,
      anon_sym_PIPE_RBRACK,
    STATE(7316), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [220399] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11393), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(7317), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [220430] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11395), 1,
      sym__indent,
    STATE(7318), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [220461] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11397), 1,
      sym_identifier,
    STATE(7319), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [220492] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11399), 1,
      sym_identifier,
    STATE(7320), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [220523] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11401), 1,
      anon_sym_PIPE_RPAREN,
    STATE(7321), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [220554] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11403), 1,
      anon_sym_RBRACK,
    STATE(7322), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [220585] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11405), 1,
      anon_sym_PIPE_RBRACE,
    STATE(7323), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [220616] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11407), 1,
      sym__dedent,
    STATE(7324), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [220647] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11409), 1,
      sym__indent,
    STATE(7325), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [220678] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11411), 1,
      sym_identifier,
    STATE(7326), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [220709] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11413), 1,
      sym__dedent,
    STATE(7327), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [220740] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11415), 1,
      sym_identifier,
    STATE(7328), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [220771] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8517), 1,
      anon_sym_GT,
    STATE(7329), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [220802] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11417), 1,
      anon_sym_RBRACK,
    STATE(7330), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [220833] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11419), 1,
      sym_identifier,
    STATE(7331), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [220864] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11421), 1,
      anon_sym_GT,
    STATE(7332), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [220895] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11423), 1,
      sym_identifier,
    STATE(7333), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [220926] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11425), 1,
      anon_sym_PIPE_RPAREN,
    STATE(7334), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [220957] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11427), 1,
      anon_sym_COLON,
    STATE(7335), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [220988] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11429), 1,
      anon_sym_GT,
    STATE(7336), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [221019] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11431), 1,
      sym_identifier,
    STATE(7337), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [221050] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11433), 1,
      sym_identifier,
    STATE(7338), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [221081] = 8,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(133), 1,
      sym_line_comment,
    ACTIONS(2986), 1,
      aux_sym_fsi_directive_decl_token1,
    ACTIONS(6818), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(6820), 1,
      anon_sym_POUNDlight,
    ACTIONS(6822), 1,
      anon_sym_POUNDr,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7339), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [221110] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3097), 1,
      sym__newline_not_aligned,
    STATE(7340), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [221141] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11435), 1,
      sym_identifier,
    STATE(7341), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [221172] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11437), 1,
      anon_sym_RPAREN,
    STATE(7342), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [221203] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11439), 1,
      sym_identifier,
    STATE(7343), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [221234] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11441), 1,
      anon_sym_RPAREN,
    STATE(7344), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [221265] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11443), 1,
      sym_int,
    STATE(7345), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [221296] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11445), 1,
      anon_sym_PIPE_RPAREN,
    STATE(7346), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [221327] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11447), 1,
      anon_sym_struct,
    STATE(7347), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [221358] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11449), 1,
      anon_sym_RPAREN,
    STATE(7348), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [221389] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11451), 1,
      sym__dedent,
    STATE(7349), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [221420] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11453), 1,
      anon_sym_RBRACE,
    STATE(7350), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [221451] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11455), 1,
      anon_sym_POUNDendif,
    STATE(7351), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [221482] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11457), 1,
      sym__dedent,
    STATE(7352), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [221513] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8523), 1,
      anon_sym_GT,
    STATE(7353), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [221544] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11459), 1,
      anon_sym_PIPE_RPAREN,
    STATE(7354), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [221575] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11461), 1,
      anon_sym_PIPE_RBRACE,
    STATE(7355), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [221606] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11463), 1,
      anon_sym_GT,
    STATE(7356), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [221637] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11465), 1,
      anon_sym_PIPE_RPAREN,
    STATE(7357), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [221668] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11467), 1,
      sym_int,
    STATE(7358), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [221699] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11469), 1,
      anon_sym_POUNDendif,
    STATE(7359), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [221730] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11471), 1,
      anon_sym_GT,
    STATE(7360), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [221761] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11473), 1,
      anon_sym_end,
    STATE(7361), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [221792] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11475), 1,
      sym_int,
    STATE(7362), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [221823] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(3117), 1,
      sym__newline_not_aligned,
    STATE(7363), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [221854] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11477), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(7364), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [221885] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11479), 1,
      anon_sym_PIPE_RBRACE,
    STATE(7365), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [221916] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11481), 1,
      anon_sym_RBRACE,
    STATE(7366), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [221947] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11483), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(7367), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [221978] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11485), 1,
      sym_int,
    STATE(7368), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [222009] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11487), 1,
      anon_sym_PIPE_RPAREN,
    STATE(7369), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [222040] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11489), 1,
      anon_sym_GT,
    STATE(7370), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [222071] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11491), 1,
      anon_sym_val,
    STATE(7371), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [222102] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11493), 1,
      sym__indent,
    STATE(7372), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [222133] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11495), 1,
      sym__indent,
    STATE(7373), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [222164] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11497), 1,
      sym__indent,
    STATE(7374), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [222195] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11499), 1,
      anon_sym_RPAREN,
    STATE(7375), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [222226] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11501), 1,
      sym_identifier,
    STATE(7376), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [222257] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11503), 1,
      sym__indent,
    STATE(7377), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [222288] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11505), 1,
      anon_sym_GT,
    STATE(7378), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [222319] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11507), 1,
      anon_sym_RBRACK,
    STATE(7379), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [222350] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8479), 1,
      anon_sym_GT,
    STATE(7380), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [222381] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11509), 1,
      anon_sym_RBRACE,
    STATE(7381), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [222412] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11511), 1,
      sym__dedent,
    STATE(7382), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [222443] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11513), 1,
      anon_sym_unit,
    STATE(7383), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [222474] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11515), 1,
      sym_identifier,
    STATE(7384), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [222505] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11517), 1,
      anon_sym_PIPE_RBRACE,
    STATE(7385), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [222536] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11519), 1,
      anon_sym_end,
    STATE(7386), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [222567] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11521), 1,
      anon_sym_GT,
    STATE(7387), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [222598] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11523), 1,
      sym_identifier,
    STATE(7388), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [222629] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11525), 1,
      sym__indent,
    STATE(7389), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [222660] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11527), 1,
      sym__indent,
    STATE(7390), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [222691] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11529), 1,
      sym__indent,
    STATE(7391), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [222722] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11531), 1,
      anon_sym_POUNDendif,
    STATE(7392), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [222753] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11533), 1,
      sym__indent,
    STATE(7393), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [222784] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11535), 1,
      anon_sym_PIPE_RPAREN,
    STATE(7394), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [222815] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11537), 1,
      sym__triple_quoted_content,
    STATE(7395), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [222846] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11539), 1,
      sym_identifier,
    STATE(7396), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [222877] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11541), 1,
      anon_sym_unit,
    STATE(7397), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [222908] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11543), 1,
      sym__indent,
    STATE(7398), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [222939] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11545), 1,
      sym__indent,
    STATE(7399), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [222970] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11547), 1,
      sym__indent,
    STATE(7400), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [223001] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11549), 1,
      sym__triple_quoted_content,
    STATE(7401), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [223032] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11551), 1,
      sym__indent,
    STATE(7402), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [223063] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11553), 1,
      anon_sym_PIPE_RBRACE,
    STATE(7403), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [223094] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11555), 1,
      sym__dedent,
    STATE(7404), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [223125] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11557), 1,
      anon_sym_POUNDendif,
    STATE(7405), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [223156] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11559), 1,
      anon_sym_unit,
    STATE(7406), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [223187] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11561), 1,
      sym__indent,
    STATE(7407), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [223218] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11563), 1,
      sym__indent,
    STATE(7408), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [223249] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11565), 1,
      sym__indent,
    STATE(7409), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [223280] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11567), 1,
      sym_identifier,
    STATE(7410), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [223311] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11569), 1,
      sym__indent,
    STATE(7411), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [223342] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11571), 1,
      anon_sym_PIPE_RPAREN,
    STATE(7412), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [223373] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11573), 1,
      anon_sym_GT,
    STATE(7413), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [223404] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11575), 1,
      anon_sym_GT,
    STATE(7414), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [223435] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11577), 1,
      anon_sym_unit,
    STATE(7415), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [223466] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11579), 1,
      sym__indent,
    STATE(7416), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [223497] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11581), 1,
      sym__indent,
    STATE(7417), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [223528] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11583), 1,
      sym__indent,
    STATE(7418), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [223559] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11585), 1,
      sym_block_comment_content,
    STATE(7419), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [223590] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11587), 1,
      sym__indent,
    STATE(7420), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [223621] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11589), 1,
      anon_sym_PIPE_RBRACK,
    STATE(7421), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [223652] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11591), 1,
      sym_int,
    STATE(7422), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [223683] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11593), 1,
      anon_sym_RBRACK,
    STATE(7423), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [223714] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11595), 1,
      anon_sym_unit,
    STATE(7424), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [223745] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11597), 1,
      sym__indent,
    STATE(7425), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [223776] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11599), 1,
      sym__indent,
    STATE(7426), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [223807] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11601), 1,
      sym__indent,
    STATE(7427), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [223838] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11603), 1,
      anon_sym_PIPE_RPAREN,
    STATE(7428), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [223869] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11605), 1,
      sym__indent,
    STATE(7429), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [223900] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11607), 1,
      anon_sym_PIPE_RBRACE,
    STATE(7430), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [223931] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8559), 1,
      anon_sym_GT,
    STATE(7431), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [223962] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11609), 1,
      sym_identifier,
    STATE(7432), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [223993] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11611), 1,
      anon_sym_unit,
    STATE(7433), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [224024] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11613), 1,
      sym__indent,
    STATE(7434), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [224055] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11615), 1,
      sym__indent,
    STATE(7435), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [224086] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11617), 1,
      sym__indent,
    STATE(7436), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [224117] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11619), 1,
      sym_int,
    STATE(7437), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [224148] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11621), 1,
      sym__indent,
    STATE(7438), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [224179] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11623), 1,
      sym__dedent,
    STATE(7439), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [224210] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11625), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(7440), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [224241] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11627), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(7441), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [224272] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11629), 1,
      anon_sym_unit,
    STATE(7442), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [224303] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11631), 1,
      sym__indent,
    STATE(7443), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [224334] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11633), 1,
      sym__indent,
    STATE(7444), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [224365] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11635), 1,
      sym__indent,
    STATE(7445), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [224396] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11637), 1,
      anon_sym_PIPE_RBRACE,
    STATE(7446), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [224427] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11639), 1,
      sym__indent,
    STATE(7447), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [224458] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11641), 1,
      anon_sym_PIPE_RBRACK,
    STATE(7448), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [224489] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11643), 1,
      anon_sym_RBRACK,
    STATE(7449), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [224520] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11645), 1,
      sym__indent,
    STATE(7450), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [224551] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11647), 1,
      sym__indent,
    STATE(7451), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [224582] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11649), 1,
      sym__indent,
    STATE(7452), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [224613] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11651), 1,
      anon_sym_GT,
    STATE(7453), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [224644] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11653), 1,
      sym__indent,
    STATE(7454), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [224675] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11655), 1,
      sym_int,
    STATE(7455), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [224706] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11657), 1,
      anon_sym_COLON,
    STATE(7456), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [224737] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11659), 1,
      sym__indent,
    STATE(7457), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [224768] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11661), 1,
      sym__indent,
    STATE(7458), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [224799] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11663), 1,
      sym__indent,
    STATE(7459), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [224830] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11665), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(7460), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [224861] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11667), 1,
      sym__indent,
    STATE(7461), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [224892] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11669), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(7462), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [224923] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11671), 1,
      sym_identifier,
    STATE(7463), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [224954] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11673), 1,
      sym__indent,
    STATE(7464), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [224985] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11675), 1,
      sym__indent,
    STATE(7465), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [225016] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11677), 1,
      sym__indent,
    STATE(7466), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [225047] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11679), 1,
      sym_identifier,
    STATE(7467), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [225078] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11681), 1,
      sym__indent,
    STATE(7468), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [225109] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11683), 1,
      sym__dedent,
    STATE(7469), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [225140] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11685), 1,
      sym__indent,
    STATE(7470), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [225171] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11687), 1,
      sym__indent,
    STATE(7471), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [225202] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11689), 1,
      sym_identifier,
    STATE(7472), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [225233] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11691), 1,
      sym__indent,
    STATE(7473), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [225264] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11693), 1,
      sym_identifier,
    STATE(7474), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [225295] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11695), 1,
      sym__indent,
    STATE(7475), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [225326] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11697), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(7476), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [225357] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11699), 1,
      sym__indent,
    STATE(7477), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [225388] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11701), 1,
      sym__indent,
    STATE(7478), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [225419] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11703), 1,
      sym__indent,
    STATE(7479), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [225450] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11705), 1,
      sym__indent,
    STATE(7480), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [225481] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11707), 1,
      sym__indent,
    STATE(7481), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [225512] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11709), 1,
      sym__indent,
    STATE(7482), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [225543] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11711), 1,
      sym__indent,
    STATE(7483), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [225574] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11713), 1,
      sym__indent,
    STATE(7484), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [225605] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11715), 1,
      sym__indent,
    STATE(7485), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [225636] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11717), 1,
      sym__indent,
    STATE(7486), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [225667] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11719), 1,
      sym__indent,
    STATE(7487), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [225698] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11721), 1,
      sym__indent,
    STATE(7488), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [225729] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11723), 1,
      sym__indent,
    STATE(7489), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [225760] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11725), 1,
      sym__indent,
    STATE(7490), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [225791] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11727), 1,
      sym__indent,
    STATE(7491), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [225822] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11729), 1,
      sym__indent,
    STATE(7492), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [225853] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11731), 1,
      sym__indent,
    STATE(7493), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [225884] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11733), 1,
      sym__indent,
    STATE(7494), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [225915] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11735), 1,
      sym__indent,
    STATE(7495), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [225946] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11737), 1,
      sym__indent,
    STATE(7496), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [225977] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11739), 1,
      sym__indent,
    STATE(7497), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [226008] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11741), 1,
      sym__indent,
    STATE(7498), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [226039] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11743), 1,
      sym__indent,
    STATE(7499), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [226070] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11745), 1,
      sym__indent,
    STATE(7500), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [226101] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11747), 1,
      sym__indent,
    STATE(7501), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [226132] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11749), 1,
      sym__indent,
    STATE(7502), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [226163] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11751), 1,
      sym__indent,
    STATE(7503), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [226194] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11753), 1,
      sym__indent,
    STATE(7504), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [226225] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11755), 1,
      sym_identifier,
    STATE(7505), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [226256] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11757), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(7506), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [226287] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11759), 1,
      anon_sym_COLON,
    STATE(7507), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [226318] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11761), 1,
      anon_sym_EQ,
    STATE(7508), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [226349] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11763), 1,
      anon_sym_LT2,
    STATE(7509), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [226380] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11765), 1,
      anon_sym_COLON,
    STATE(7510), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [226411] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11767), 1,
      sym_identifier,
    STATE(7511), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [226442] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11769), 1,
      sym_int,
    STATE(7512), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [226473] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11771), 1,
      anon_sym_LT2,
    STATE(7513), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [226504] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11773), 1,
      anon_sym_COLON,
    STATE(7514), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [226535] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11775), 1,
      sym_identifier,
    STATE(7515), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [226566] = 8,
    ACTIONS(3), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(133), 1,
      sym_line_comment,
    ACTIONS(6818), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(6820), 1,
      anon_sym_POUNDlight,
    ACTIONS(6822), 1,
      anon_sym_POUNDr,
    ACTIONS(11777), 1,
      aux_sym_fsi_directive_decl_token1,
    ACTIONS(15), 2,
      anon_sym_POUNDload,
      aux_sym_preproc_line_token1,
    STATE(7516), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [226595] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11779), 1,
      anon_sym_LT2,
    STATE(7517), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [226626] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11781), 1,
      anon_sym_COLON,
    STATE(7518), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [226657] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11783), 1,
      anon_sym_member,
    STATE(7519), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [226688] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11785), 1,
      sym__newline_not_aligned,
    STATE(7520), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [226719] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11787), 1,
      anon_sym_LT2,
    STATE(7521), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [226750] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11789), 1,
      anon_sym_COLON,
    STATE(7522), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [226781] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11791), 1,
      anon_sym_GT,
    STATE(7523), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [226812] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11793), 1,
      anon_sym_STAR_RPAREN,
    STATE(7524), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [226843] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11795), 1,
      anon_sym_LT2,
    STATE(7525), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [226874] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11797), 1,
      anon_sym_COLON,
    STATE(7526), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [226905] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11799), 1,
      anon_sym_PIPE_RPAREN,
    STATE(7527), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [226936] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11801), 1,
      anon_sym_GT,
    STATE(7528), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [226967] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11803), 1,
      anon_sym_LT2,
    STATE(7529), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [226998] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11805), 1,
      anon_sym_COLON,
    STATE(7530), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [227029] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11807), 1,
      sym_int,
    STATE(7531), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [227060] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11809), 1,
      anon_sym_PIPE_RPAREN,
    STATE(7532), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [227091] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11811), 1,
      anon_sym_LT2,
    STATE(7533), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [227122] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11813), 1,
      anon_sym_COLON,
    STATE(7534), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [227153] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8467), 1,
      anon_sym_GT,
    STATE(7535), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [227184] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11815), 1,
      anon_sym_val,
    STATE(7536), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [227215] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(8234), 1,
      ts_builtin_sym_end,
    STATE(7537), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [227246] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11817), 1,
      ts_builtin_sym_end,
    STATE(7538), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [227277] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11819), 1,
      anon_sym_PIPE_RBRACE,
    STATE(7539), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [227308] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11821), 1,
      anon_sym_GT,
    STATE(7540), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [227339] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11823), 1,
      sym_int,
    STATE(7541), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [227370] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11825), 1,
      sym_int,
    STATE(7542), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [227401] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11827), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(7543), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [227432] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11829), 1,
      sym__newline_not_aligned,
    STATE(7544), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [227463] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11831), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(7545), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [227494] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11833), 1,
      anon_sym_COLON,
    STATE(7546), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [227525] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11835), 1,
      sym_identifier,
    STATE(7547), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [227556] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(11837), 1,
      sym_identifier,
    STATE(7548), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [227587] = 9,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_POUNDnowarn,
    ACTIONS(9), 1,
      anon_sym_POUNDlight,
    ACTIONS(11), 1,
      anon_sym_POUNDr,
    ACTIONS(13), 1,
      anon_sym_POUNDload,
    ACTIONS(15), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(27), 1,
      anon_sym_LPAREN_STAR,
    ACTIONS(2687), 1,
      anon_sym_then,
    STATE(7549), 4,
      sym_block_comment,
      sym_compiler_directive_decl,
      sym_fsi_directive_decl,
      sym_preproc_line,
  [227618] = 1,
    ACTIONS(11839), 1,
      ts_builtin_sym_end,
  [227622] = 1,
    ACTIONS(11841), 1,
      ts_builtin_sym_end,
  [227626] = 1,
    ACTIONS(11843), 1,
      ts_builtin_sym_end,
  [227630] = 1,
    ACTIONS(11845), 1,
      ts_builtin_sym_end,
  [227634] = 1,
    ACTIONS(11847), 1,
      ts_builtin_sym_end,
  [227638] = 1,
    ACTIONS(11849), 1,
      ts_builtin_sym_end,
  [227642] = 1,
    ACTIONS(11851), 1,
      ts_builtin_sym_end,
};

static const uint32_t ts_small_parse_table_map[] = {
  [SMALL_STATE(2845)] = 0,
  [SMALL_STATE(2846)] = 131,
  [SMALL_STATE(2847)] = 258,
  [SMALL_STATE(2848)] = 383,
  [SMALL_STATE(2849)] = 514,
  [SMALL_STATE(2850)] = 642,
  [SMALL_STATE(2851)] = 767,
  [SMALL_STATE(2852)] = 892,
  [SMALL_STATE(2853)] = 1017,
  [SMALL_STATE(2854)] = 1142,
  [SMALL_STATE(2855)] = 1267,
  [SMALL_STATE(2856)] = 1392,
  [SMALL_STATE(2857)] = 1517,
  [SMALL_STATE(2858)] = 1642,
  [SMALL_STATE(2859)] = 1767,
  [SMALL_STATE(2860)] = 1892,
  [SMALL_STATE(2861)] = 2017,
  [SMALL_STATE(2862)] = 2142,
  [SMALL_STATE(2863)] = 2267,
  [SMALL_STATE(2864)] = 2392,
  [SMALL_STATE(2865)] = 2517,
  [SMALL_STATE(2866)] = 2622,
  [SMALL_STATE(2867)] = 2727,
  [SMALL_STATE(2868)] = 2831,
  [SMALL_STATE(2869)] = 2935,
  [SMALL_STATE(2870)] = 3034,
  [SMALL_STATE(2871)] = 3137,
  [SMALL_STATE(2872)] = 3236,
  [SMALL_STATE(2873)] = 3334,
  [SMALL_STATE(2874)] = 3432,
  [SMALL_STATE(2875)] = 3529,
  [SMALL_STATE(2876)] = 3621,
  [SMALL_STATE(2877)] = 3694,
  [SMALL_STATE(2878)] = 3781,
  [SMALL_STATE(2879)] = 3868,
  [SMALL_STATE(2880)] = 3959,
  [SMALL_STATE(2881)] = 4034,
  [SMALL_STATE(2882)] = 4121,
  [SMALL_STATE(2883)] = 4208,
  [SMALL_STATE(2884)] = 4283,
  [SMALL_STATE(2885)] = 4358,
  [SMALL_STATE(2886)] = 4449,
  [SMALL_STATE(2887)] = 4522,
  [SMALL_STATE(2888)] = 4609,
  [SMALL_STATE(2889)] = 4696,
  [SMALL_STATE(2890)] = 4783,
  [SMALL_STATE(2891)] = 4858,
  [SMALL_STATE(2892)] = 4945,
  [SMALL_STATE(2893)] = 5030,
  [SMALL_STATE(2894)] = 5115,
  [SMALL_STATE(2895)] = 5189,
  [SMALL_STATE(2896)] = 5275,
  [SMALL_STATE(2897)] = 5361,
  [SMALL_STATE(2898)] = 5447,
  [SMALL_STATE(2899)] = 5533,
  [SMALL_STATE(2900)] = 5607,
  [SMALL_STATE(2901)] = 5681,
  [SMALL_STATE(2902)] = 5765,
  [SMALL_STATE(2903)] = 5837,
  [SMALL_STATE(2904)] = 5923,
  [SMALL_STATE(2905)] = 5993,
  [SMALL_STATE(2906)] = 6065,
  [SMALL_STATE(2907)] = 6151,
  [SMALL_STATE(2908)] = 6225,
  [SMALL_STATE(2909)] = 6299,
  [SMALL_STATE(2910)] = 6383,
  [SMALL_STATE(2911)] = 6457,
  [SMALL_STATE(2912)] = 6531,
  [SMALL_STATE(2913)] = 6605,
  [SMALL_STATE(2914)] = 6691,
  [SMALL_STATE(2915)] = 6765,
  [SMALL_STATE(2916)] = 6849,
  [SMALL_STATE(2917)] = 6919,
  [SMALL_STATE(2918)] = 6989,
  [SMALL_STATE(2919)] = 7061,
  [SMALL_STATE(2920)] = 7147,
  [SMALL_STATE(2921)] = 7233,
  [SMALL_STATE(2922)] = 7319,
  [SMALL_STATE(2923)] = 7403,
  [SMALL_STATE(2924)] = 7489,
  [SMALL_STATE(2925)] = 7559,
  [SMALL_STATE(2926)] = 7631,
  [SMALL_STATE(2927)] = 7717,
  [SMALL_STATE(2928)] = 7803,
  [SMALL_STATE(2929)] = 7889,
  [SMALL_STATE(2930)] = 7963,
  [SMALL_STATE(2931)] = 8035,
  [SMALL_STATE(2932)] = 8109,
  [SMALL_STATE(2933)] = 8183,
  [SMALL_STATE(2934)] = 8255,
  [SMALL_STATE(2935)] = 8341,
  [SMALL_STATE(2936)] = 8415,
  [SMALL_STATE(2937)] = 8501,
  [SMALL_STATE(2938)] = 8587,
  [SMALL_STATE(2939)] = 8673,
  [SMALL_STATE(2940)] = 8763,
  [SMALL_STATE(2941)] = 8853,
  [SMALL_STATE(2942)] = 8927,
  [SMALL_STATE(2943)] = 9013,
  [SMALL_STATE(2944)] = 9099,
  [SMALL_STATE(2945)] = 9171,
  [SMALL_STATE(2946)] = 9257,
  [SMALL_STATE(2947)] = 9330,
  [SMALL_STATE(2948)] = 9401,
  [SMALL_STATE(2949)] = 9470,
  [SMALL_STATE(2950)] = 9543,
  [SMALL_STATE(2951)] = 9616,
  [SMALL_STATE(2952)] = 9689,
  [SMALL_STATE(2953)] = 9758,
  [SMALL_STATE(2954)] = 9831,
  [SMALL_STATE(2955)] = 9916,
  [SMALL_STATE(2956)] = 9987,
  [SMALL_STATE(2957)] = 10058,
  [SMALL_STATE(2958)] = 10131,
  [SMALL_STATE(2959)] = 10216,
  [SMALL_STATE(2960)] = 10301,
  [SMALL_STATE(2961)] = 10386,
  [SMALL_STATE(2962)] = 10455,
  [SMALL_STATE(2963)] = 10528,
  [SMALL_STATE(2964)] = 10613,
  [SMALL_STATE(2965)] = 10700,
  [SMALL_STATE(2966)] = 10769,
  [SMALL_STATE(2967)] = 10840,
  [SMALL_STATE(2968)] = 10913,
  [SMALL_STATE(2969)] = 10984,
  [SMALL_STATE(2970)] = 11055,
  [SMALL_STATE(2971)] = 11128,
  [SMALL_STATE(2972)] = 11213,
  [SMALL_STATE(2973)] = 11284,
  [SMALL_STATE(2974)] = 11353,
  [SMALL_STATE(2975)] = 11426,
  [SMALL_STATE(2976)] = 11499,
  [SMALL_STATE(2977)] = 11568,
  [SMALL_STATE(2978)] = 11653,
  [SMALL_STATE(2979)] = 11738,
  [SMALL_STATE(2980)] = 11819,
  [SMALL_STATE(2981)] = 11892,
  [SMALL_STATE(2982)] = 11977,
  [SMALL_STATE(2983)] = 12050,
  [SMALL_STATE(2984)] = 12121,
  [SMALL_STATE(2985)] = 12202,
  [SMALL_STATE(2986)] = 12271,
  [SMALL_STATE(2987)] = 12354,
  [SMALL_STATE(2988)] = 12427,
  [SMALL_STATE(2989)] = 12498,
  [SMALL_STATE(2990)] = 12583,
  [SMALL_STATE(2991)] = 12652,
  [SMALL_STATE(2992)] = 12723,
  [SMALL_STATE(2993)] = 12806,
  [SMALL_STATE(2994)] = 12875,
  [SMALL_STATE(2995)] = 12960,
  [SMALL_STATE(2996)] = 13041,
  [SMALL_STATE(2997)] = 13114,
  [SMALL_STATE(2998)] = 13199,
  [SMALL_STATE(2999)] = 13284,
  [SMALL_STATE(3000)] = 13355,
  [SMALL_STATE(3001)] = 13424,
  [SMALL_STATE(3002)] = 13509,
  [SMALL_STATE(3003)] = 13582,
  [SMALL_STATE(3004)] = 13655,
  [SMALL_STATE(3005)] = 13726,
  [SMALL_STATE(3006)] = 13811,
  [SMALL_STATE(3007)] = 13880,
  [SMALL_STATE(3008)] = 13953,
  [SMALL_STATE(3009)] = 14034,
  [SMALL_STATE(3010)] = 14103,
  [SMALL_STATE(3011)] = 14172,
  [SMALL_STATE(3012)] = 14257,
  [SMALL_STATE(3013)] = 14342,
  [SMALL_STATE(3014)] = 14415,
  [SMALL_STATE(3015)] = 14500,
  [SMALL_STATE(3016)] = 14573,
  [SMALL_STATE(3017)] = 14644,
  [SMALL_STATE(3018)] = 14729,
  [SMALL_STATE(3019)] = 14814,
  [SMALL_STATE(3020)] = 14883,
  [SMALL_STATE(3021)] = 14968,
  [SMALL_STATE(3022)] = 15053,
  [SMALL_STATE(3023)] = 15126,
  [SMALL_STATE(3024)] = 15199,
  [SMALL_STATE(3025)] = 15270,
  [SMALL_STATE(3026)] = 15338,
  [SMALL_STATE(3027)] = 15406,
  [SMALL_STATE(3028)] = 15474,
  [SMALL_STATE(3029)] = 15542,
  [SMALL_STATE(3030)] = 15612,
  [SMALL_STATE(3031)] = 15680,
  [SMALL_STATE(3032)] = 15748,
  [SMALL_STATE(3033)] = 15818,
  [SMALL_STATE(3034)] = 15886,
  [SMALL_STATE(3035)] = 15954,
  [SMALL_STATE(3036)] = 16026,
  [SMALL_STATE(3037)] = 16096,
  [SMALL_STATE(3038)] = 16166,
  [SMALL_STATE(3039)] = 16236,
  [SMALL_STATE(3040)] = 16304,
  [SMALL_STATE(3041)] = 16372,
  [SMALL_STATE(3042)] = 16442,
  [SMALL_STATE(3043)] = 16510,
  [SMALL_STATE(3044)] = 16578,
  [SMALL_STATE(3045)] = 16650,
  [SMALL_STATE(3046)] = 16718,
  [SMALL_STATE(3047)] = 16786,
  [SMALL_STATE(3048)] = 16858,
  [SMALL_STATE(3049)] = 16926,
  [SMALL_STATE(3050)] = 16998,
  [SMALL_STATE(3051)] = 17068,
  [SMALL_STATE(3052)] = 17138,
  [SMALL_STATE(3053)] = 17206,
  [SMALL_STATE(3054)] = 17300,
  [SMALL_STATE(3055)] = 17370,
  [SMALL_STATE(3056)] = 17438,
  [SMALL_STATE(3057)] = 17508,
  [SMALL_STATE(3058)] = 17576,
  [SMALL_STATE(3059)] = 17648,
  [SMALL_STATE(3060)] = 17720,
  [SMALL_STATE(3061)] = 17788,
  [SMALL_STATE(3062)] = 17856,
  [SMALL_STATE(3063)] = 17924,
  [SMALL_STATE(3064)] = 17994,
  [SMALL_STATE(3065)] = 18062,
  [SMALL_STATE(3066)] = 18132,
  [SMALL_STATE(3067)] = 18202,
  [SMALL_STATE(3068)] = 18270,
  [SMALL_STATE(3069)] = 18354,
  [SMALL_STATE(3070)] = 18424,
  [SMALL_STATE(3071)] = 18494,
  [SMALL_STATE(3072)] = 18562,
  [SMALL_STATE(3073)] = 18630,
  [SMALL_STATE(3074)] = 18698,
  [SMALL_STATE(3075)] = 18766,
  [SMALL_STATE(3076)] = 18838,
  [SMALL_STATE(3077)] = 18922,
  [SMALL_STATE(3078)] = 18992,
  [SMALL_STATE(3079)] = 19060,
  [SMALL_STATE(3080)] = 19128,
  [SMALL_STATE(3081)] = 19196,
  [SMALL_STATE(3082)] = 19268,
  [SMALL_STATE(3083)] = 19336,
  [SMALL_STATE(3084)] = 19404,
  [SMALL_STATE(3085)] = 19476,
  [SMALL_STATE(3086)] = 19544,
  [SMALL_STATE(3087)] = 19616,
  [SMALL_STATE(3088)] = 19684,
  [SMALL_STATE(3089)] = 19752,
  [SMALL_STATE(3090)] = 19824,
  [SMALL_STATE(3091)] = 19892,
  [SMALL_STATE(3092)] = 19962,
  [SMALL_STATE(3093)] = 20034,
  [SMALL_STATE(3094)] = 20106,
  [SMALL_STATE(3095)] = 20178,
  [SMALL_STATE(3096)] = 20246,
  [SMALL_STATE(3097)] = 20314,
  [SMALL_STATE(3098)] = 20398,
  [SMALL_STATE(3099)] = 20482,
  [SMALL_STATE(3100)] = 20566,
  [SMALL_STATE(3101)] = 20634,
  [SMALL_STATE(3102)] = 20702,
  [SMALL_STATE(3103)] = 20770,
  [SMALL_STATE(3104)] = 20842,
  [SMALL_STATE(3105)] = 20914,
  [SMALL_STATE(3106)] = 20986,
  [SMALL_STATE(3107)] = 21054,
  [SMALL_STATE(3108)] = 21124,
  [SMALL_STATE(3109)] = 21208,
  [SMALL_STATE(3110)] = 21277,
  [SMALL_STATE(3111)] = 21344,
  [SMALL_STATE(3112)] = 21413,
  [SMALL_STATE(3113)] = 21480,
  [SMALL_STATE(3114)] = 21549,
  [SMALL_STATE(3115)] = 21620,
  [SMALL_STATE(3116)] = 21687,
  [SMALL_STATE(3117)] = 21754,
  [SMALL_STATE(3118)] = 21821,
  [SMALL_STATE(3119)] = 21888,
  [SMALL_STATE(3120)] = 21957,
  [SMALL_STATE(3121)] = 22024,
  [SMALL_STATE(3122)] = 22091,
  [SMALL_STATE(3123)] = 22158,
  [SMALL_STATE(3124)] = 22225,
  [SMALL_STATE(3125)] = 22292,
  [SMALL_STATE(3126)] = 22359,
  [SMALL_STATE(3127)] = 22426,
  [SMALL_STATE(3128)] = 22493,
  [SMALL_STATE(3129)] = 22560,
  [SMALL_STATE(3130)] = 22627,
  [SMALL_STATE(3131)] = 22694,
  [SMALL_STATE(3132)] = 22761,
  [SMALL_STATE(3133)] = 22830,
  [SMALL_STATE(3134)] = 22901,
  [SMALL_STATE(3135)] = 22970,
  [SMALL_STATE(3136)] = 23037,
  [SMALL_STATE(3137)] = 23106,
  [SMALL_STATE(3138)] = 23177,
  [SMALL_STATE(3139)] = 23246,
  [SMALL_STATE(3140)] = 23313,
  [SMALL_STATE(3141)] = 23382,
  [SMALL_STATE(3142)] = 23449,
  [SMALL_STATE(3143)] = 23516,
  [SMALL_STATE(3144)] = 23583,
  [SMALL_STATE(3145)] = 23654,
  [SMALL_STATE(3146)] = 23721,
  [SMALL_STATE(3147)] = 23788,
  [SMALL_STATE(3148)] = 23855,
  [SMALL_STATE(3149)] = 23922,
  [SMALL_STATE(3150)] = 23989,
  [SMALL_STATE(3151)] = 24056,
  [SMALL_STATE(3152)] = 24125,
  [SMALL_STATE(3153)] = 24192,
  [SMALL_STATE(3154)] = 24259,
  [SMALL_STATE(3155)] = 24326,
  [SMALL_STATE(3156)] = 24393,
  [SMALL_STATE(3157)] = 24460,
  [SMALL_STATE(3158)] = 24527,
  [SMALL_STATE(3159)] = 24594,
  [SMALL_STATE(3160)] = 24661,
  [SMALL_STATE(3161)] = 24732,
  [SMALL_STATE(3162)] = 24799,
  [SMALL_STATE(3163)] = 24866,
  [SMALL_STATE(3164)] = 24933,
  [SMALL_STATE(3165)] = 25000,
  [SMALL_STATE(3166)] = 25067,
  [SMALL_STATE(3167)] = 25134,
  [SMALL_STATE(3168)] = 25201,
  [SMALL_STATE(3169)] = 25268,
  [SMALL_STATE(3170)] = 25335,
  [SMALL_STATE(3171)] = 25404,
  [SMALL_STATE(3172)] = 25471,
  [SMALL_STATE(3173)] = 25538,
  [SMALL_STATE(3174)] = 25605,
  [SMALL_STATE(3175)] = 25672,
  [SMALL_STATE(3176)] = 25739,
  [SMALL_STATE(3177)] = 25806,
  [SMALL_STATE(3178)] = 25873,
  [SMALL_STATE(3179)] = 25940,
  [SMALL_STATE(3180)] = 26009,
  [SMALL_STATE(3181)] = 26076,
  [SMALL_STATE(3182)] = 26143,
  [SMALL_STATE(3183)] = 26212,
  [SMALL_STATE(3184)] = 26279,
  [SMALL_STATE(3185)] = 26350,
  [SMALL_STATE(3186)] = 26417,
  [SMALL_STATE(3187)] = 26484,
  [SMALL_STATE(3188)] = 26555,
  [SMALL_STATE(3189)] = 26622,
  [SMALL_STATE(3190)] = 26691,
  [SMALL_STATE(3191)] = 26758,
  [SMALL_STATE(3192)] = 26825,
  [SMALL_STATE(3193)] = 26892,
  [SMALL_STATE(3194)] = 26961,
  [SMALL_STATE(3195)] = 27028,
  [SMALL_STATE(3196)] = 27095,
  [SMALL_STATE(3197)] = 27164,
  [SMALL_STATE(3198)] = 27231,
  [SMALL_STATE(3199)] = 27298,
  [SMALL_STATE(3200)] = 27364,
  [SMALL_STATE(3201)] = 27458,
  [SMALL_STATE(3202)] = 27524,
  [SMALL_STATE(3203)] = 27590,
  [SMALL_STATE(3204)] = 27656,
  [SMALL_STATE(3205)] = 27722,
  [SMALL_STATE(3206)] = 27788,
  [SMALL_STATE(3207)] = 27856,
  [SMALL_STATE(3208)] = 27922,
  [SMALL_STATE(3209)] = 27988,
  [SMALL_STATE(3210)] = 28056,
  [SMALL_STATE(3211)] = 28122,
  [SMALL_STATE(3212)] = 28188,
  [SMALL_STATE(3213)] = 28254,
  [SMALL_STATE(3214)] = 28320,
  [SMALL_STATE(3215)] = 28386,
  [SMALL_STATE(3216)] = 28452,
  [SMALL_STATE(3217)] = 28520,
  [SMALL_STATE(3218)] = 28612,
  [SMALL_STATE(3219)] = 28678,
  [SMALL_STATE(3220)] = 28744,
  [SMALL_STATE(3221)] = 28810,
  [SMALL_STATE(3222)] = 28876,
  [SMALL_STATE(3223)] = 28942,
  [SMALL_STATE(3224)] = 29008,
  [SMALL_STATE(3225)] = 29074,
  [SMALL_STATE(3226)] = 29142,
  [SMALL_STATE(3227)] = 29208,
  [SMALL_STATE(3228)] = 29274,
  [SMALL_STATE(3229)] = 29340,
  [SMALL_STATE(3230)] = 29406,
  [SMALL_STATE(3231)] = 29472,
  [SMALL_STATE(3232)] = 29538,
  [SMALL_STATE(3233)] = 29604,
  [SMALL_STATE(3234)] = 29670,
  [SMALL_STATE(3235)] = 29736,
  [SMALL_STATE(3236)] = 29802,
  [SMALL_STATE(3237)] = 29868,
  [SMALL_STATE(3238)] = 29934,
  [SMALL_STATE(3239)] = 30002,
  [SMALL_STATE(3240)] = 30068,
  [SMALL_STATE(3241)] = 30134,
  [SMALL_STATE(3242)] = 30200,
  [SMALL_STATE(3243)] = 30266,
  [SMALL_STATE(3244)] = 30332,
  [SMALL_STATE(3245)] = 30398,
  [SMALL_STATE(3246)] = 30464,
  [SMALL_STATE(3247)] = 30532,
  [SMALL_STATE(3248)] = 30598,
  [SMALL_STATE(3249)] = 30664,
  [SMALL_STATE(3250)] = 30730,
  [SMALL_STATE(3251)] = 30796,
  [SMALL_STATE(3252)] = 30862,
  [SMALL_STATE(3253)] = 30928,
  [SMALL_STATE(3254)] = 30994,
  [SMALL_STATE(3255)] = 31060,
  [SMALL_STATE(3256)] = 31128,
  [SMALL_STATE(3257)] = 31194,
  [SMALL_STATE(3258)] = 31260,
  [SMALL_STATE(3259)] = 31326,
  [SMALL_STATE(3260)] = 31392,
  [SMALL_STATE(3261)] = 31460,
  [SMALL_STATE(3262)] = 31552,
  [SMALL_STATE(3263)] = 31618,
  [SMALL_STATE(3264)] = 31688,
  [SMALL_STATE(3265)] = 31754,
  [SMALL_STATE(3266)] = 31846,
  [SMALL_STATE(3267)] = 31914,
  [SMALL_STATE(3268)] = 31980,
  [SMALL_STATE(3269)] = 32072,
  [SMALL_STATE(3270)] = 32164,
  [SMALL_STATE(3271)] = 32230,
  [SMALL_STATE(3272)] = 32296,
  [SMALL_STATE(3273)] = 32364,
  [SMALL_STATE(3274)] = 32434,
  [SMALL_STATE(3275)] = 32504,
  [SMALL_STATE(3276)] = 32571,
  [SMALL_STATE(3277)] = 32636,
  [SMALL_STATE(3278)] = 32701,
  [SMALL_STATE(3279)] = 32766,
  [SMALL_STATE(3280)] = 32835,
  [SMALL_STATE(3281)] = 32904,
  [SMALL_STATE(3282)] = 32973,
  [SMALL_STATE(3283)] = 33038,
  [SMALL_STATE(3284)] = 33107,
  [SMALL_STATE(3285)] = 33174,
  [SMALL_STATE(3286)] = 33239,
  [SMALL_STATE(3287)] = 33308,
  [SMALL_STATE(3288)] = 33373,
  [SMALL_STATE(3289)] = 33438,
  [SMALL_STATE(3290)] = 33505,
  [SMALL_STATE(3291)] = 33574,
  [SMALL_STATE(3292)] = 33643,
  [SMALL_STATE(3293)] = 33712,
  [SMALL_STATE(3294)] = 33779,
  [SMALL_STATE(3295)] = 33844,
  [SMALL_STATE(3296)] = 33913,
  [SMALL_STATE(3297)] = 33978,
  [SMALL_STATE(3298)] = 34045,
  [SMALL_STATE(3299)] = 34110,
  [SMALL_STATE(3300)] = 34179,
  [SMALL_STATE(3301)] = 34246,
  [SMALL_STATE(3302)] = 34311,
  [SMALL_STATE(3303)] = 34382,
  [SMALL_STATE(3304)] = 34451,
  [SMALL_STATE(3305)] = 34516,
  [SMALL_STATE(3306)] = 34585,
  [SMALL_STATE(3307)] = 34652,
  [SMALL_STATE(3308)] = 34721,
  [SMALL_STATE(3309)] = 34786,
  [SMALL_STATE(3310)] = 34853,
  [SMALL_STATE(3311)] = 34922,
  [SMALL_STATE(3312)] = 34989,
  [SMALL_STATE(3313)] = 35054,
  [SMALL_STATE(3314)] = 35123,
  [SMALL_STATE(3315)] = 35190,
  [SMALL_STATE(3316)] = 35255,
  [SMALL_STATE(3317)] = 35322,
  [SMALL_STATE(3318)] = 35387,
  [SMALL_STATE(3319)] = 35456,
  [SMALL_STATE(3320)] = 35520,
  [SMALL_STATE(3321)] = 35586,
  [SMALL_STATE(3322)] = 35652,
  [SMALL_STATE(3323)] = 35718,
  [SMALL_STATE(3324)] = 35806,
  [SMALL_STATE(3325)] = 35874,
  [SMALL_STATE(3326)] = 35938,
  [SMALL_STATE(3327)] = 36006,
  [SMALL_STATE(3328)] = 36076,
  [SMALL_STATE(3329)] = 36144,
  [SMALL_STATE(3330)] = 36214,
  [SMALL_STATE(3331)] = 36278,
  [SMALL_STATE(3332)] = 36346,
  [SMALL_STATE(3333)] = 36414,
  [SMALL_STATE(3334)] = 36478,
  [SMALL_STATE(3335)] = 36580,
  [SMALL_STATE(3336)] = 36650,
  [SMALL_STATE(3337)] = 36714,
  [SMALL_STATE(3338)] = 36782,
  [SMALL_STATE(3339)] = 36848,
  [SMALL_STATE(3340)] = 36918,
  [SMALL_STATE(3341)] = 36984,
  [SMALL_STATE(3342)] = 37050,
  [SMALL_STATE(3343)] = 37120,
  [SMALL_STATE(3344)] = 37186,
  [SMALL_STATE(3345)] = 37256,
  [SMALL_STATE(3346)] = 37320,
  [SMALL_STATE(3347)] = 37384,
  [SMALL_STATE(3348)] = 37460,
  [SMALL_STATE(3349)] = 37528,
  [SMALL_STATE(3350)] = 37596,
  [SMALL_STATE(3351)] = 37666,
  [SMALL_STATE(3352)] = 37736,
  [SMALL_STATE(3353)] = 37804,
  [SMALL_STATE(3354)] = 37874,
  [SMALL_STATE(3355)] = 37950,
  [SMALL_STATE(3356)] = 38016,
  [SMALL_STATE(3357)] = 38082,
  [SMALL_STATE(3358)] = 38148,
  [SMALL_STATE(3359)] = 38212,
  [SMALL_STATE(3360)] = 38276,
  [SMALL_STATE(3361)] = 38342,
  [SMALL_STATE(3362)] = 38406,
  [SMALL_STATE(3363)] = 38474,
  [SMALL_STATE(3364)] = 38540,
  [SMALL_STATE(3365)] = 38608,
  [SMALL_STATE(3366)] = 38674,
  [SMALL_STATE(3367)] = 38742,
  [SMALL_STATE(3368)] = 38808,
  [SMALL_STATE(3369)] = 38872,
  [SMALL_STATE(3370)] = 38936,
  [SMALL_STATE(3371)] = 39006,
  [SMALL_STATE(3372)] = 39074,
  [SMALL_STATE(3373)] = 39138,
  [SMALL_STATE(3374)] = 39206,
  [SMALL_STATE(3375)] = 39274,
  [SMALL_STATE(3376)] = 39340,
  [SMALL_STATE(3377)] = 39408,
  [SMALL_STATE(3378)] = 39476,
  [SMALL_STATE(3379)] = 39540,
  [SMALL_STATE(3380)] = 39604,
  [SMALL_STATE(3381)] = 39672,
  [SMALL_STATE(3382)] = 39736,
  [SMALL_STATE(3383)] = 39800,
  [SMALL_STATE(3384)] = 39866,
  [SMALL_STATE(3385)] = 39930,
  [SMALL_STATE(3386)] = 39996,
  [SMALL_STATE(3387)] = 40060,
  [SMALL_STATE(3388)] = 40124,
  [SMALL_STATE(3389)] = 40188,
  [SMALL_STATE(3390)] = 40252,
  [SMALL_STATE(3391)] = 40318,
  [SMALL_STATE(3392)] = 40384,
  [SMALL_STATE(3393)] = 40450,
  [SMALL_STATE(3394)] = 40518,
  [SMALL_STATE(3395)] = 40588,
  [SMALL_STATE(3396)] = 40654,
  [SMALL_STATE(3397)] = 40718,
  [SMALL_STATE(3398)] = 40786,
  [SMALL_STATE(3399)] = 40852,
  [SMALL_STATE(3400)] = 40918,
  [SMALL_STATE(3401)] = 40984,
  [SMALL_STATE(3402)] = 41048,
  [SMALL_STATE(3403)] = 41150,
  [SMALL_STATE(3404)] = 41216,
  [SMALL_STATE(3405)] = 41280,
  [SMALL_STATE(3406)] = 41350,
  [SMALL_STATE(3407)] = 41416,
  [SMALL_STATE(3408)] = 41482,
  [SMALL_STATE(3409)] = 41545,
  [SMALL_STATE(3410)] = 41608,
  [SMALL_STATE(3411)] = 41671,
  [SMALL_STATE(3412)] = 41738,
  [SMALL_STATE(3413)] = 41801,
  [SMALL_STATE(3414)] = 41864,
  [SMALL_STATE(3415)] = 41927,
  [SMALL_STATE(3416)] = 41990,
  [SMALL_STATE(3417)] = 42057,
  [SMALL_STATE(3418)] = 42120,
  [SMALL_STATE(3419)] = 42183,
  [SMALL_STATE(3420)] = 42282,
  [SMALL_STATE(3421)] = 42349,
  [SMALL_STATE(3422)] = 42416,
  [SMALL_STATE(3423)] = 42479,
  [SMALL_STATE(3424)] = 42542,
  [SMALL_STATE(3425)] = 42605,
  [SMALL_STATE(3426)] = 42670,
  [SMALL_STATE(3427)] = 42733,
  [SMALL_STATE(3428)] = 42796,
  [SMALL_STATE(3429)] = 42859,
  [SMALL_STATE(3430)] = 42922,
  [SMALL_STATE(3431)] = 42985,
  [SMALL_STATE(3432)] = 43060,
  [SMALL_STATE(3433)] = 43125,
  [SMALL_STATE(3434)] = 43188,
  [SMALL_STATE(3435)] = 43251,
  [SMALL_STATE(3436)] = 43316,
  [SMALL_STATE(3437)] = 43379,
  [SMALL_STATE(3438)] = 43444,
  [SMALL_STATE(3439)] = 43507,
  [SMALL_STATE(3440)] = 43570,
  [SMALL_STATE(3441)] = 43633,
  [SMALL_STATE(3442)] = 43696,
  [SMALL_STATE(3443)] = 43759,
  [SMALL_STATE(3444)] = 43822,
  [SMALL_STATE(3445)] = 43885,
  [SMALL_STATE(3446)] = 43948,
  [SMALL_STATE(3447)] = 44011,
  [SMALL_STATE(3448)] = 44076,
  [SMALL_STATE(3449)] = 44141,
  [SMALL_STATE(3450)] = 44204,
  [SMALL_STATE(3451)] = 44267,
  [SMALL_STATE(3452)] = 44330,
  [SMALL_STATE(3453)] = 44397,
  [SMALL_STATE(3454)] = 44460,
  [SMALL_STATE(3455)] = 44523,
  [SMALL_STATE(3456)] = 44588,
  [SMALL_STATE(3457)] = 44651,
  [SMALL_STATE(3458)] = 44714,
  [SMALL_STATE(3459)] = 44777,
  [SMALL_STATE(3460)] = 44840,
  [SMALL_STATE(3461)] = 44903,
  [SMALL_STATE(3462)] = 44966,
  [SMALL_STATE(3463)] = 45029,
  [SMALL_STATE(3464)] = 45092,
  [SMALL_STATE(3465)] = 45155,
  [SMALL_STATE(3466)] = 45218,
  [SMALL_STATE(3467)] = 45281,
  [SMALL_STATE(3468)] = 45344,
  [SMALL_STATE(3469)] = 45407,
  [SMALL_STATE(3470)] = 45470,
  [SMALL_STATE(3471)] = 45533,
  [SMALL_STATE(3472)] = 45596,
  [SMALL_STATE(3473)] = 45659,
  [SMALL_STATE(3474)] = 45722,
  [SMALL_STATE(3475)] = 45785,
  [SMALL_STATE(3476)] = 45850,
  [SMALL_STATE(3477)] = 45913,
  [SMALL_STATE(3478)] = 45976,
  [SMALL_STATE(3479)] = 46039,
  [SMALL_STATE(3480)] = 46102,
  [SMALL_STATE(3481)] = 46165,
  [SMALL_STATE(3482)] = 46228,
  [SMALL_STATE(3483)] = 46291,
  [SMALL_STATE(3484)] = 46354,
  [SMALL_STATE(3485)] = 46417,
  [SMALL_STATE(3486)] = 46480,
  [SMALL_STATE(3487)] = 46543,
  [SMALL_STATE(3488)] = 46606,
  [SMALL_STATE(3489)] = 46669,
  [SMALL_STATE(3490)] = 46736,
  [SMALL_STATE(3491)] = 46799,
  [SMALL_STATE(3492)] = 46864,
  [SMALL_STATE(3493)] = 46927,
  [SMALL_STATE(3494)] = 46992,
  [SMALL_STATE(3495)] = 47055,
  [SMALL_STATE(3496)] = 47118,
  [SMALL_STATE(3497)] = 47183,
  [SMALL_STATE(3498)] = 47246,
  [SMALL_STATE(3499)] = 47309,
  [SMALL_STATE(3500)] = 47374,
  [SMALL_STATE(3501)] = 47437,
  [SMALL_STATE(3502)] = 47502,
  [SMALL_STATE(3503)] = 47567,
  [SMALL_STATE(3504)] = 47630,
  [SMALL_STATE(3505)] = 47693,
  [SMALL_STATE(3506)] = 47756,
  [SMALL_STATE(3507)] = 47819,
  [SMALL_STATE(3508)] = 47882,
  [SMALL_STATE(3509)] = 47945,
  [SMALL_STATE(3510)] = 48008,
  [SMALL_STATE(3511)] = 48071,
  [SMALL_STATE(3512)] = 48134,
  [SMALL_STATE(3513)] = 48197,
  [SMALL_STATE(3514)] = 48260,
  [SMALL_STATE(3515)] = 48323,
  [SMALL_STATE(3516)] = 48386,
  [SMALL_STATE(3517)] = 48449,
  [SMALL_STATE(3518)] = 48512,
  [SMALL_STATE(3519)] = 48575,
  [SMALL_STATE(3520)] = 48638,
  [SMALL_STATE(3521)] = 48701,
  [SMALL_STATE(3522)] = 48764,
  [SMALL_STATE(3523)] = 48827,
  [SMALL_STATE(3524)] = 48894,
  [SMALL_STATE(3525)] = 48957,
  [SMALL_STATE(3526)] = 49020,
  [SMALL_STATE(3527)] = 49083,
  [SMALL_STATE(3528)] = 49146,
  [SMALL_STATE(3529)] = 49209,
  [SMALL_STATE(3530)] = 49272,
  [SMALL_STATE(3531)] = 49335,
  [SMALL_STATE(3532)] = 49398,
  [SMALL_STATE(3533)] = 49495,
  [SMALL_STATE(3534)] = 49558,
  [SMALL_STATE(3535)] = 49621,
  [SMALL_STATE(3536)] = 49684,
  [SMALL_STATE(3537)] = 49747,
  [SMALL_STATE(3538)] = 49812,
  [SMALL_STATE(3539)] = 49887,
  [SMALL_STATE(3540)] = 49952,
  [SMALL_STATE(3541)] = 50017,
  [SMALL_STATE(3542)] = 50082,
  [SMALL_STATE(3543)] = 50147,
  [SMALL_STATE(3544)] = 50212,
  [SMALL_STATE(3545)] = 50275,
  [SMALL_STATE(3546)] = 50338,
  [SMALL_STATE(3547)] = 50401,
  [SMALL_STATE(3548)] = 50466,
  [SMALL_STATE(3549)] = 50529,
  [SMALL_STATE(3550)] = 50592,
  [SMALL_STATE(3551)] = 50655,
  [SMALL_STATE(3552)] = 50718,
  [SMALL_STATE(3553)] = 50781,
  [SMALL_STATE(3554)] = 50844,
  [SMALL_STATE(3555)] = 50907,
  [SMALL_STATE(3556)] = 50974,
  [SMALL_STATE(3557)] = 51039,
  [SMALL_STATE(3558)] = 51102,
  [SMALL_STATE(3559)] = 51165,
  [SMALL_STATE(3560)] = 51228,
  [SMALL_STATE(3561)] = 51293,
  [SMALL_STATE(3562)] = 51356,
  [SMALL_STATE(3563)] = 51419,
  [SMALL_STATE(3564)] = 51482,
  [SMALL_STATE(3565)] = 51545,
  [SMALL_STATE(3566)] = 51608,
  [SMALL_STATE(3567)] = 51671,
  [SMALL_STATE(3568)] = 51734,
  [SMALL_STATE(3569)] = 51797,
  [SMALL_STATE(3570)] = 51860,
  [SMALL_STATE(3571)] = 51925,
  [SMALL_STATE(3572)] = 51988,
  [SMALL_STATE(3573)] = 52051,
  [SMALL_STATE(3574)] = 52114,
  [SMALL_STATE(3575)] = 52177,
  [SMALL_STATE(3576)] = 52239,
  [SMALL_STATE(3577)] = 52301,
  [SMALL_STATE(3578)] = 52363,
  [SMALL_STATE(3579)] = 52425,
  [SMALL_STATE(3580)] = 52487,
  [SMALL_STATE(3581)] = 52549,
  [SMALL_STATE(3582)] = 52611,
  [SMALL_STATE(3583)] = 52675,
  [SMALL_STATE(3584)] = 52737,
  [SMALL_STATE(3585)] = 52799,
  [SMALL_STATE(3586)] = 52861,
  [SMALL_STATE(3587)] = 52923,
  [SMALL_STATE(3588)] = 52985,
  [SMALL_STATE(3589)] = 53047,
  [SMALL_STATE(3590)] = 53109,
  [SMALL_STATE(3591)] = 53171,
  [SMALL_STATE(3592)] = 53233,
  [SMALL_STATE(3593)] = 53297,
  [SMALL_STATE(3594)] = 53361,
  [SMALL_STATE(3595)] = 53425,
  [SMALL_STATE(3596)] = 53487,
  [SMALL_STATE(3597)] = 53549,
  [SMALL_STATE(3598)] = 53613,
  [SMALL_STATE(3599)] = 53675,
  [SMALL_STATE(3600)] = 53737,
  [SMALL_STATE(3601)] = 53799,
  [SMALL_STATE(3602)] = 53861,
  [SMALL_STATE(3603)] = 53923,
  [SMALL_STATE(3604)] = 53987,
  [SMALL_STATE(3605)] = 54049,
  [SMALL_STATE(3606)] = 54111,
  [SMALL_STATE(3607)] = 54173,
  [SMALL_STATE(3608)] = 54235,
  [SMALL_STATE(3609)] = 54297,
  [SMALL_STATE(3610)] = 54359,
  [SMALL_STATE(3611)] = 54421,
  [SMALL_STATE(3612)] = 54483,
  [SMALL_STATE(3613)] = 54545,
  [SMALL_STATE(3614)] = 54607,
  [SMALL_STATE(3615)] = 54669,
  [SMALL_STATE(3616)] = 54731,
  [SMALL_STATE(3617)] = 54793,
  [SMALL_STATE(3618)] = 54855,
  [SMALL_STATE(3619)] = 54917,
  [SMALL_STATE(3620)] = 54979,
  [SMALL_STATE(3621)] = 55041,
  [SMALL_STATE(3622)] = 55103,
  [SMALL_STATE(3623)] = 55165,
  [SMALL_STATE(3624)] = 55227,
  [SMALL_STATE(3625)] = 55289,
  [SMALL_STATE(3626)] = 55351,
  [SMALL_STATE(3627)] = 55413,
  [SMALL_STATE(3628)] = 55475,
  [SMALL_STATE(3629)] = 55537,
  [SMALL_STATE(3630)] = 55599,
  [SMALL_STATE(3631)] = 55661,
  [SMALL_STATE(3632)] = 55723,
  [SMALL_STATE(3633)] = 55785,
  [SMALL_STATE(3634)] = 55847,
  [SMALL_STATE(3635)] = 55909,
  [SMALL_STATE(3636)] = 55971,
  [SMALL_STATE(3637)] = 56033,
  [SMALL_STATE(3638)] = 56107,
  [SMALL_STATE(3639)] = 56171,
  [SMALL_STATE(3640)] = 56235,
  [SMALL_STATE(3641)] = 56297,
  [SMALL_STATE(3642)] = 56359,
  [SMALL_STATE(3643)] = 56421,
  [SMALL_STATE(3644)] = 56483,
  [SMALL_STATE(3645)] = 56545,
  [SMALL_STATE(3646)] = 56607,
  [SMALL_STATE(3647)] = 56669,
  [SMALL_STATE(3648)] = 56731,
  [SMALL_STATE(3649)] = 56793,
  [SMALL_STATE(3650)] = 56855,
  [SMALL_STATE(3651)] = 56917,
  [SMALL_STATE(3652)] = 56979,
  [SMALL_STATE(3653)] = 57041,
  [SMALL_STATE(3654)] = 57103,
  [SMALL_STATE(3655)] = 57165,
  [SMALL_STATE(3656)] = 57229,
  [SMALL_STATE(3657)] = 57291,
  [SMALL_STATE(3658)] = 57353,
  [SMALL_STATE(3659)] = 57415,
  [SMALL_STATE(3660)] = 57477,
  [SMALL_STATE(3661)] = 57539,
  [SMALL_STATE(3662)] = 57601,
  [SMALL_STATE(3663)] = 57663,
  [SMALL_STATE(3664)] = 57725,
  [SMALL_STATE(3665)] = 57787,
  [SMALL_STATE(3666)] = 57849,
  [SMALL_STATE(3667)] = 57911,
  [SMALL_STATE(3668)] = 57973,
  [SMALL_STATE(3669)] = 58035,
  [SMALL_STATE(3670)] = 58097,
  [SMALL_STATE(3671)] = 58159,
  [SMALL_STATE(3672)] = 58221,
  [SMALL_STATE(3673)] = 58283,
  [SMALL_STATE(3674)] = 58345,
  [SMALL_STATE(3675)] = 58407,
  [SMALL_STATE(3676)] = 58469,
  [SMALL_STATE(3677)] = 58531,
  [SMALL_STATE(3678)] = 58593,
  [SMALL_STATE(3679)] = 58655,
  [SMALL_STATE(3680)] = 58717,
  [SMALL_STATE(3681)] = 58781,
  [SMALL_STATE(3682)] = 58843,
  [SMALL_STATE(3683)] = 58905,
  [SMALL_STATE(3684)] = 58967,
  [SMALL_STATE(3685)] = 59031,
  [SMALL_STATE(3686)] = 59093,
  [SMALL_STATE(3687)] = 59155,
  [SMALL_STATE(3688)] = 59221,
  [SMALL_STATE(3689)] = 59283,
  [SMALL_STATE(3690)] = 59345,
  [SMALL_STATE(3691)] = 59407,
  [SMALL_STATE(3692)] = 59469,
  [SMALL_STATE(3693)] = 59531,
  [SMALL_STATE(3694)] = 59593,
  [SMALL_STATE(3695)] = 59655,
  [SMALL_STATE(3696)] = 59717,
  [SMALL_STATE(3697)] = 59779,
  [SMALL_STATE(3698)] = 59841,
  [SMALL_STATE(3699)] = 59903,
  [SMALL_STATE(3700)] = 59965,
  [SMALL_STATE(3701)] = 60027,
  [SMALL_STATE(3702)] = 60089,
  [SMALL_STATE(3703)] = 60151,
  [SMALL_STATE(3704)] = 60213,
  [SMALL_STATE(3705)] = 60275,
  [SMALL_STATE(3706)] = 60337,
  [SMALL_STATE(3707)] = 60413,
  [SMALL_STATE(3708)] = 60475,
  [SMALL_STATE(3709)] = 60536,
  [SMALL_STATE(3710)] = 60597,
  [SMALL_STATE(3711)] = 60658,
  [SMALL_STATE(3712)] = 60719,
  [SMALL_STATE(3713)] = 60780,
  [SMALL_STATE(3714)] = 60841,
  [SMALL_STATE(3715)] = 60902,
  [SMALL_STATE(3716)] = 60963,
  [SMALL_STATE(3717)] = 61024,
  [SMALL_STATE(3718)] = 61085,
  [SMALL_STATE(3719)] = 61146,
  [SMALL_STATE(3720)] = 61207,
  [SMALL_STATE(3721)] = 61268,
  [SMALL_STATE(3722)] = 61329,
  [SMALL_STATE(3723)] = 61390,
  [SMALL_STATE(3724)] = 61451,
  [SMALL_STATE(3725)] = 61512,
  [SMALL_STATE(3726)] = 61573,
  [SMALL_STATE(3727)] = 61634,
  [SMALL_STATE(3728)] = 61695,
  [SMALL_STATE(3729)] = 61756,
  [SMALL_STATE(3730)] = 61817,
  [SMALL_STATE(3731)] = 61878,
  [SMALL_STATE(3732)] = 61939,
  [SMALL_STATE(3733)] = 62000,
  [SMALL_STATE(3734)] = 62061,
  [SMALL_STATE(3735)] = 62122,
  [SMALL_STATE(3736)] = 62183,
  [SMALL_STATE(3737)] = 62244,
  [SMALL_STATE(3738)] = 62305,
  [SMALL_STATE(3739)] = 62366,
  [SMALL_STATE(3740)] = 62427,
  [SMALL_STATE(3741)] = 62488,
  [SMALL_STATE(3742)] = 62549,
  [SMALL_STATE(3743)] = 62610,
  [SMALL_STATE(3744)] = 62671,
  [SMALL_STATE(3745)] = 62732,
  [SMALL_STATE(3746)] = 62793,
  [SMALL_STATE(3747)] = 62854,
  [SMALL_STATE(3748)] = 62915,
  [SMALL_STATE(3749)] = 62976,
  [SMALL_STATE(3750)] = 63037,
  [SMALL_STATE(3751)] = 63098,
  [SMALL_STATE(3752)] = 63159,
  [SMALL_STATE(3753)] = 63220,
  [SMALL_STATE(3754)] = 63281,
  [SMALL_STATE(3755)] = 63342,
  [SMALL_STATE(3756)] = 63403,
  [SMALL_STATE(3757)] = 63464,
  [SMALL_STATE(3758)] = 63525,
  [SMALL_STATE(3759)] = 63618,
  [SMALL_STATE(3760)] = 63679,
  [SMALL_STATE(3761)] = 63742,
  [SMALL_STATE(3762)] = 63803,
  [SMALL_STATE(3763)] = 63864,
  [SMALL_STATE(3764)] = 63925,
  [SMALL_STATE(3765)] = 63986,
  [SMALL_STATE(3766)] = 64047,
  [SMALL_STATE(3767)] = 64105,
  [SMALL_STATE(3768)] = 64163,
  [SMALL_STATE(3769)] = 64221,
  [SMALL_STATE(3770)] = 64279,
  [SMALL_STATE(3771)] = 64365,
  [SMALL_STATE(3772)] = 64423,
  [SMALL_STATE(3773)] = 64481,
  [SMALL_STATE(3774)] = 64539,
  [SMALL_STATE(3775)] = 64599,
  [SMALL_STATE(3776)] = 64677,
  [SMALL_STATE(3777)] = 64755,
  [SMALL_STATE(3778)] = 64833,
  [SMALL_STATE(3779)] = 64911,
  [SMALL_STATE(3780)] = 64989,
  [SMALL_STATE(3781)] = 65067,
  [SMALL_STATE(3782)] = 65145,
  [SMALL_STATE(3783)] = 65223,
  [SMALL_STATE(3784)] = 65301,
  [SMALL_STATE(3785)] = 65379,
  [SMALL_STATE(3786)] = 65459,
  [SMALL_STATE(3787)] = 65537,
  [SMALL_STATE(3788)] = 65597,
  [SMALL_STATE(3789)] = 65675,
  [SMALL_STATE(3790)] = 65753,
  [SMALL_STATE(3791)] = 65810,
  [SMALL_STATE(3792)] = 65893,
  [SMALL_STATE(3793)] = 65968,
  [SMALL_STATE(3794)] = 66040,
  [SMALL_STATE(3795)] = 66112,
  [SMALL_STATE(3796)] = 66184,
  [SMALL_STATE(3797)] = 66256,
  [SMALL_STATE(3798)] = 66328,
  [SMALL_STATE(3799)] = 66400,
  [SMALL_STATE(3800)] = 66472,
  [SMALL_STATE(3801)] = 66544,
  [SMALL_STATE(3802)] = 66616,
  [SMALL_STATE(3803)] = 66688,
  [SMALL_STATE(3804)] = 66770,
  [SMALL_STATE(3805)] = 66842,
  [SMALL_STATE(3806)] = 66898,
  [SMALL_STATE(3807)] = 66970,
  [SMALL_STATE(3808)] = 67042,
  [SMALL_STATE(3809)] = 67114,
  [SMALL_STATE(3810)] = 67186,
  [SMALL_STATE(3811)] = 67258,
  [SMALL_STATE(3812)] = 67330,
  [SMALL_STATE(3813)] = 67402,
  [SMALL_STATE(3814)] = 67474,
  [SMALL_STATE(3815)] = 67546,
  [SMALL_STATE(3816)] = 67618,
  [SMALL_STATE(3817)] = 67690,
  [SMALL_STATE(3818)] = 67762,
  [SMALL_STATE(3819)] = 67834,
  [SMALL_STATE(3820)] = 67906,
  [SMALL_STATE(3821)] = 67978,
  [SMALL_STATE(3822)] = 68050,
  [SMALL_STATE(3823)] = 68122,
  [SMALL_STATE(3824)] = 68194,
  [SMALL_STATE(3825)] = 68266,
  [SMALL_STATE(3826)] = 68338,
  [SMALL_STATE(3827)] = 68410,
  [SMALL_STATE(3828)] = 68482,
  [SMALL_STATE(3829)] = 68554,
  [SMALL_STATE(3830)] = 68626,
  [SMALL_STATE(3831)] = 68698,
  [SMALL_STATE(3832)] = 68770,
  [SMALL_STATE(3833)] = 68842,
  [SMALL_STATE(3834)] = 68914,
  [SMALL_STATE(3835)] = 68986,
  [SMALL_STATE(3836)] = 69058,
  [SMALL_STATE(3837)] = 69130,
  [SMALL_STATE(3838)] = 69202,
  [SMALL_STATE(3839)] = 69274,
  [SMALL_STATE(3840)] = 69346,
  [SMALL_STATE(3841)] = 69418,
  [SMALL_STATE(3842)] = 69472,
  [SMALL_STATE(3843)] = 69544,
  [SMALL_STATE(3844)] = 69616,
  [SMALL_STATE(3845)] = 69688,
  [SMALL_STATE(3846)] = 69760,
  [SMALL_STATE(3847)] = 69832,
  [SMALL_STATE(3848)] = 69904,
  [SMALL_STATE(3849)] = 69976,
  [SMALL_STATE(3850)] = 70048,
  [SMALL_STATE(3851)] = 70120,
  [SMALL_STATE(3852)] = 70192,
  [SMALL_STATE(3853)] = 70264,
  [SMALL_STATE(3854)] = 70336,
  [SMALL_STATE(3855)] = 70408,
  [SMALL_STATE(3856)] = 70480,
  [SMALL_STATE(3857)] = 70552,
  [SMALL_STATE(3858)] = 70624,
  [SMALL_STATE(3859)] = 70696,
  [SMALL_STATE(3860)] = 70768,
  [SMALL_STATE(3861)] = 70840,
  [SMALL_STATE(3862)] = 70912,
  [SMALL_STATE(3863)] = 70984,
  [SMALL_STATE(3864)] = 71056,
  [SMALL_STATE(3865)] = 71128,
  [SMALL_STATE(3866)] = 71200,
  [SMALL_STATE(3867)] = 71272,
  [SMALL_STATE(3868)] = 71344,
  [SMALL_STATE(3869)] = 71416,
  [SMALL_STATE(3870)] = 71488,
  [SMALL_STATE(3871)] = 71560,
  [SMALL_STATE(3872)] = 71632,
  [SMALL_STATE(3873)] = 71704,
  [SMALL_STATE(3874)] = 71762,
  [SMALL_STATE(3875)] = 71834,
  [SMALL_STATE(3876)] = 71906,
  [SMALL_STATE(3877)] = 71978,
  [SMALL_STATE(3878)] = 72050,
  [SMALL_STATE(3879)] = 72122,
  [SMALL_STATE(3880)] = 72194,
  [SMALL_STATE(3881)] = 72266,
  [SMALL_STATE(3882)] = 72338,
  [SMALL_STATE(3883)] = 72410,
  [SMALL_STATE(3884)] = 72482,
  [SMALL_STATE(3885)] = 72554,
  [SMALL_STATE(3886)] = 72626,
  [SMALL_STATE(3887)] = 72680,
  [SMALL_STATE(3888)] = 72738,
  [SMALL_STATE(3889)] = 72810,
  [SMALL_STATE(3890)] = 72882,
  [SMALL_STATE(3891)] = 72954,
  [SMALL_STATE(3892)] = 73026,
  [SMALL_STATE(3893)] = 73098,
  [SMALL_STATE(3894)] = 73170,
  [SMALL_STATE(3895)] = 73242,
  [SMALL_STATE(3896)] = 73314,
  [SMALL_STATE(3897)] = 73386,
  [SMALL_STATE(3898)] = 73458,
  [SMALL_STATE(3899)] = 73530,
  [SMALL_STATE(3900)] = 73602,
  [SMALL_STATE(3901)] = 73674,
  [SMALL_STATE(3902)] = 73746,
  [SMALL_STATE(3903)] = 73818,
  [SMALL_STATE(3904)] = 73890,
  [SMALL_STATE(3905)] = 73962,
  [SMALL_STATE(3906)] = 74034,
  [SMALL_STATE(3907)] = 74106,
  [SMALL_STATE(3908)] = 74178,
  [SMALL_STATE(3909)] = 74250,
  [SMALL_STATE(3910)] = 74322,
  [SMALL_STATE(3911)] = 74394,
  [SMALL_STATE(3912)] = 74466,
  [SMALL_STATE(3913)] = 74538,
  [SMALL_STATE(3914)] = 74610,
  [SMALL_STATE(3915)] = 74682,
  [SMALL_STATE(3916)] = 74754,
  [SMALL_STATE(3917)] = 74826,
  [SMALL_STATE(3918)] = 74898,
  [SMALL_STATE(3919)] = 74970,
  [SMALL_STATE(3920)] = 75042,
  [SMALL_STATE(3921)] = 75114,
  [SMALL_STATE(3922)] = 75186,
  [SMALL_STATE(3923)] = 75258,
  [SMALL_STATE(3924)] = 75330,
  [SMALL_STATE(3925)] = 75402,
  [SMALL_STATE(3926)] = 75474,
  [SMALL_STATE(3927)] = 75546,
  [SMALL_STATE(3928)] = 75618,
  [SMALL_STATE(3929)] = 75690,
  [SMALL_STATE(3930)] = 75762,
  [SMALL_STATE(3931)] = 75834,
  [SMALL_STATE(3932)] = 75906,
  [SMALL_STATE(3933)] = 75978,
  [SMALL_STATE(3934)] = 76050,
  [SMALL_STATE(3935)] = 76122,
  [SMALL_STATE(3936)] = 76194,
  [SMALL_STATE(3937)] = 76266,
  [SMALL_STATE(3938)] = 76338,
  [SMALL_STATE(3939)] = 76410,
  [SMALL_STATE(3940)] = 76482,
  [SMALL_STATE(3941)] = 76554,
  [SMALL_STATE(3942)] = 76626,
  [SMALL_STATE(3943)] = 76698,
  [SMALL_STATE(3944)] = 76770,
  [SMALL_STATE(3945)] = 76842,
  [SMALL_STATE(3946)] = 76914,
  [SMALL_STATE(3947)] = 76986,
  [SMALL_STATE(3948)] = 77058,
  [SMALL_STATE(3949)] = 77130,
  [SMALL_STATE(3950)] = 77202,
  [SMALL_STATE(3951)] = 77274,
  [SMALL_STATE(3952)] = 77346,
  [SMALL_STATE(3953)] = 77418,
  [SMALL_STATE(3954)] = 77490,
  [SMALL_STATE(3955)] = 77562,
  [SMALL_STATE(3956)] = 77634,
  [SMALL_STATE(3957)] = 77706,
  [SMALL_STATE(3958)] = 77778,
  [SMALL_STATE(3959)] = 77850,
  [SMALL_STATE(3960)] = 77908,
  [SMALL_STATE(3961)] = 77980,
  [SMALL_STATE(3962)] = 78052,
  [SMALL_STATE(3963)] = 78124,
  [SMALL_STATE(3964)] = 78196,
  [SMALL_STATE(3965)] = 78268,
  [SMALL_STATE(3966)] = 78340,
  [SMALL_STATE(3967)] = 78412,
  [SMALL_STATE(3968)] = 78484,
  [SMALL_STATE(3969)] = 78556,
  [SMALL_STATE(3970)] = 78628,
  [SMALL_STATE(3971)] = 78684,
  [SMALL_STATE(3972)] = 78756,
  [SMALL_STATE(3973)] = 78828,
  [SMALL_STATE(3974)] = 78900,
  [SMALL_STATE(3975)] = 78972,
  [SMALL_STATE(3976)] = 79044,
  [SMALL_STATE(3977)] = 79116,
  [SMALL_STATE(3978)] = 79188,
  [SMALL_STATE(3979)] = 79260,
  [SMALL_STATE(3980)] = 79332,
  [SMALL_STATE(3981)] = 79404,
  [SMALL_STATE(3982)] = 79476,
  [SMALL_STATE(3983)] = 79530,
  [SMALL_STATE(3984)] = 79602,
  [SMALL_STATE(3985)] = 79674,
  [SMALL_STATE(3986)] = 79746,
  [SMALL_STATE(3987)] = 79800,
  [SMALL_STATE(3988)] = 79854,
  [SMALL_STATE(3989)] = 79926,
  [SMALL_STATE(3990)] = 79998,
  [SMALL_STATE(3991)] = 80070,
  [SMALL_STATE(3992)] = 80142,
  [SMALL_STATE(3993)] = 80214,
  [SMALL_STATE(3994)] = 80286,
  [SMALL_STATE(3995)] = 80358,
  [SMALL_STATE(3996)] = 80430,
  [SMALL_STATE(3997)] = 80502,
  [SMALL_STATE(3998)] = 80574,
  [SMALL_STATE(3999)] = 80646,
  [SMALL_STATE(4000)] = 80718,
  [SMALL_STATE(4001)] = 80790,
  [SMALL_STATE(4002)] = 80862,
  [SMALL_STATE(4003)] = 80934,
  [SMALL_STATE(4004)] = 81006,
  [SMALL_STATE(4005)] = 81078,
  [SMALL_STATE(4006)] = 81150,
  [SMALL_STATE(4007)] = 81222,
  [SMALL_STATE(4008)] = 81294,
  [SMALL_STATE(4009)] = 81366,
  [SMALL_STATE(4010)] = 81438,
  [SMALL_STATE(4011)] = 81510,
  [SMALL_STATE(4012)] = 81582,
  [SMALL_STATE(4013)] = 81654,
  [SMALL_STATE(4014)] = 81726,
  [SMALL_STATE(4015)] = 81798,
  [SMALL_STATE(4016)] = 81870,
  [SMALL_STATE(4017)] = 81942,
  [SMALL_STATE(4018)] = 82014,
  [SMALL_STATE(4019)] = 82086,
  [SMALL_STATE(4020)] = 82158,
  [SMALL_STATE(4021)] = 82230,
  [SMALL_STATE(4022)] = 82302,
  [SMALL_STATE(4023)] = 82374,
  [SMALL_STATE(4024)] = 82446,
  [SMALL_STATE(4025)] = 82518,
  [SMALL_STATE(4026)] = 82590,
  [SMALL_STATE(4027)] = 82662,
  [SMALL_STATE(4028)] = 82734,
  [SMALL_STATE(4029)] = 82806,
  [SMALL_STATE(4030)] = 82878,
  [SMALL_STATE(4031)] = 82950,
  [SMALL_STATE(4032)] = 83022,
  [SMALL_STATE(4033)] = 83094,
  [SMALL_STATE(4034)] = 83166,
  [SMALL_STATE(4035)] = 83238,
  [SMALL_STATE(4036)] = 83292,
  [SMALL_STATE(4037)] = 83364,
  [SMALL_STATE(4038)] = 83436,
  [SMALL_STATE(4039)] = 83508,
  [SMALL_STATE(4040)] = 83580,
  [SMALL_STATE(4041)] = 83652,
  [SMALL_STATE(4042)] = 83724,
  [SMALL_STATE(4043)] = 83796,
  [SMALL_STATE(4044)] = 83868,
  [SMALL_STATE(4045)] = 83940,
  [SMALL_STATE(4046)] = 83994,
  [SMALL_STATE(4047)] = 84066,
  [SMALL_STATE(4048)] = 84138,
  [SMALL_STATE(4049)] = 84210,
  [SMALL_STATE(4050)] = 84282,
  [SMALL_STATE(4051)] = 84354,
  [SMALL_STATE(4052)] = 84426,
  [SMALL_STATE(4053)] = 84498,
  [SMALL_STATE(4054)] = 84570,
  [SMALL_STATE(4055)] = 84642,
  [SMALL_STATE(4056)] = 84714,
  [SMALL_STATE(4057)] = 84768,
  [SMALL_STATE(4058)] = 84840,
  [SMALL_STATE(4059)] = 84912,
  [SMALL_STATE(4060)] = 84984,
  [SMALL_STATE(4061)] = 85056,
  [SMALL_STATE(4062)] = 85128,
  [SMALL_STATE(4063)] = 85200,
  [SMALL_STATE(4064)] = 85272,
  [SMALL_STATE(4065)] = 85344,
  [SMALL_STATE(4066)] = 85416,
  [SMALL_STATE(4067)] = 85488,
  [SMALL_STATE(4068)] = 85560,
  [SMALL_STATE(4069)] = 85632,
  [SMALL_STATE(4070)] = 85704,
  [SMALL_STATE(4071)] = 85776,
  [SMALL_STATE(4072)] = 85848,
  [SMALL_STATE(4073)] = 85920,
  [SMALL_STATE(4074)] = 85992,
  [SMALL_STATE(4075)] = 86064,
  [SMALL_STATE(4076)] = 86136,
  [SMALL_STATE(4077)] = 86208,
  [SMALL_STATE(4078)] = 86280,
  [SMALL_STATE(4079)] = 86352,
  [SMALL_STATE(4080)] = 86424,
  [SMALL_STATE(4081)] = 86496,
  [SMALL_STATE(4082)] = 86568,
  [SMALL_STATE(4083)] = 86640,
  [SMALL_STATE(4084)] = 86712,
  [SMALL_STATE(4085)] = 86784,
  [SMALL_STATE(4086)] = 86856,
  [SMALL_STATE(4087)] = 86928,
  [SMALL_STATE(4088)] = 87000,
  [SMALL_STATE(4089)] = 87072,
  [SMALL_STATE(4090)] = 87144,
  [SMALL_STATE(4091)] = 87216,
  [SMALL_STATE(4092)] = 87288,
  [SMALL_STATE(4093)] = 87360,
  [SMALL_STATE(4094)] = 87432,
  [SMALL_STATE(4095)] = 87504,
  [SMALL_STATE(4096)] = 87576,
  [SMALL_STATE(4097)] = 87648,
  [SMALL_STATE(4098)] = 87702,
  [SMALL_STATE(4099)] = 87774,
  [SMALL_STATE(4100)] = 87846,
  [SMALL_STATE(4101)] = 87918,
  [SMALL_STATE(4102)] = 87990,
  [SMALL_STATE(4103)] = 88062,
  [SMALL_STATE(4104)] = 88134,
  [SMALL_STATE(4105)] = 88206,
  [SMALL_STATE(4106)] = 88278,
  [SMALL_STATE(4107)] = 88350,
  [SMALL_STATE(4108)] = 88422,
  [SMALL_STATE(4109)] = 88494,
  [SMALL_STATE(4110)] = 88566,
  [SMALL_STATE(4111)] = 88638,
  [SMALL_STATE(4112)] = 88710,
  [SMALL_STATE(4113)] = 88782,
  [SMALL_STATE(4114)] = 88854,
  [SMALL_STATE(4115)] = 88926,
  [SMALL_STATE(4116)] = 88998,
  [SMALL_STATE(4117)] = 89070,
  [SMALL_STATE(4118)] = 89142,
  [SMALL_STATE(4119)] = 89214,
  [SMALL_STATE(4120)] = 89286,
  [SMALL_STATE(4121)] = 89358,
  [SMALL_STATE(4122)] = 89430,
  [SMALL_STATE(4123)] = 89502,
  [SMALL_STATE(4124)] = 89574,
  [SMALL_STATE(4125)] = 89646,
  [SMALL_STATE(4126)] = 89718,
  [SMALL_STATE(4127)] = 89790,
  [SMALL_STATE(4128)] = 89862,
  [SMALL_STATE(4129)] = 89934,
  [SMALL_STATE(4130)] = 90006,
  [SMALL_STATE(4131)] = 90078,
  [SMALL_STATE(4132)] = 90150,
  [SMALL_STATE(4133)] = 90222,
  [SMALL_STATE(4134)] = 90294,
  [SMALL_STATE(4135)] = 90371,
  [SMALL_STATE(4136)] = 90424,
  [SMALL_STATE(4137)] = 90476,
  [SMALL_STATE(4138)] = 90528,
  [SMALL_STATE(4139)] = 90604,
  [SMALL_STATE(4140)] = 90672,
  [SMALL_STATE(4141)] = 90740,
  [SMALL_STATE(4142)] = 90792,
  [SMALL_STATE(4143)] = 90844,
  [SMALL_STATE(4144)] = 90896,
  [SMALL_STATE(4145)] = 90948,
  [SMALL_STATE(4146)] = 91016,
  [SMALL_STATE(4147)] = 91082,
  [SMALL_STATE(4148)] = 91136,
  [SMALL_STATE(4149)] = 91188,
  [SMALL_STATE(4150)] = 91240,
  [SMALL_STATE(4151)] = 91292,
  [SMALL_STATE(4152)] = 91344,
  [SMALL_STATE(4153)] = 91396,
  [SMALL_STATE(4154)] = 91464,
  [SMALL_STATE(4155)] = 91516,
  [SMALL_STATE(4156)] = 91568,
  [SMALL_STATE(4157)] = 91620,
  [SMALL_STATE(4158)] = 91672,
  [SMALL_STATE(4159)] = 91724,
  [SMALL_STATE(4160)] = 91776,
  [SMALL_STATE(4161)] = 91828,
  [SMALL_STATE(4162)] = 91880,
  [SMALL_STATE(4163)] = 91946,
  [SMALL_STATE(4164)] = 91998,
  [SMALL_STATE(4165)] = 92050,
  [SMALL_STATE(4166)] = 92102,
  [SMALL_STATE(4167)] = 92154,
  [SMALL_STATE(4168)] = 92206,
  [SMALL_STATE(4169)] = 92258,
  [SMALL_STATE(4170)] = 92316,
  [SMALL_STATE(4171)] = 92372,
  [SMALL_STATE(4172)] = 92424,
  [SMALL_STATE(4173)] = 92476,
  [SMALL_STATE(4174)] = 92528,
  [SMALL_STATE(4175)] = 92580,
  [SMALL_STATE(4176)] = 92632,
  [SMALL_STATE(4177)] = 92684,
  [SMALL_STATE(4178)] = 92736,
  [SMALL_STATE(4179)] = 92788,
  [SMALL_STATE(4180)] = 92840,
  [SMALL_STATE(4181)] = 92892,
  [SMALL_STATE(4182)] = 92944,
  [SMALL_STATE(4183)] = 93000,
  [SMALL_STATE(4184)] = 93052,
  [SMALL_STATE(4185)] = 93104,
  [SMALL_STATE(4186)] = 93156,
  [SMALL_STATE(4187)] = 93208,
  [SMALL_STATE(4188)] = 93260,
  [SMALL_STATE(4189)] = 93312,
  [SMALL_STATE(4190)] = 93364,
  [SMALL_STATE(4191)] = 93416,
  [SMALL_STATE(4192)] = 93467,
  [SMALL_STATE(4193)] = 93534,
  [SMALL_STATE(4194)] = 93601,
  [SMALL_STATE(4195)] = 93656,
  [SMALL_STATE(4196)] = 93709,
  [SMALL_STATE(4197)] = 93776,
  [SMALL_STATE(4198)] = 93843,
  [SMALL_STATE(4199)] = 93910,
  [SMALL_STATE(4200)] = 93961,
  [SMALL_STATE(4201)] = 94016,
  [SMALL_STATE(4202)] = 94087,
  [SMALL_STATE(4203)] = 94141,
  [SMALL_STATE(4204)] = 94207,
  [SMALL_STATE(4205)] = 94273,
  [SMALL_STATE(4206)] = 94351,
  [SMALL_STATE(4207)] = 94417,
  [SMALL_STATE(4208)] = 94467,
  [SMALL_STATE(4209)] = 94533,
  [SMALL_STATE(4210)] = 94585,
  [SMALL_STATE(4211)] = 94651,
  [SMALL_STATE(4212)] = 94705,
  [SMALL_STATE(4213)] = 94771,
  [SMALL_STATE(4214)] = 94851,
  [SMALL_STATE(4215)] = 94905,
  [SMALL_STATE(4216)] = 94975,
  [SMALL_STATE(4217)] = 95041,
  [SMALL_STATE(4218)] = 95095,
  [SMALL_STATE(4219)] = 95145,
  [SMALL_STATE(4220)] = 95215,
  [SMALL_STATE(4221)] = 95295,
  [SMALL_STATE(4222)] = 95349,
  [SMALL_STATE(4223)] = 95401,
  [SMALL_STATE(4224)] = 95453,
  [SMALL_STATE(4225)] = 95505,
  [SMALL_STATE(4226)] = 95571,
  [SMALL_STATE(4227)] = 95637,
  [SMALL_STATE(4228)] = 95703,
  [SMALL_STATE(4229)] = 95768,
  [SMALL_STATE(4230)] = 95821,
  [SMALL_STATE(4231)] = 95874,
  [SMALL_STATE(4232)] = 95923,
  [SMALL_STATE(4233)] = 95974,
  [SMALL_STATE(4234)] = 96023,
  [SMALL_STATE(4235)] = 96072,
  [SMALL_STATE(4236)] = 96121,
  [SMALL_STATE(4237)] = 96174,
  [SMALL_STATE(4238)] = 96227,
  [SMALL_STATE(4239)] = 96292,
  [SMALL_STATE(4240)] = 96357,
  [SMALL_STATE(4241)] = 96410,
  [SMALL_STATE(4242)] = 96461,
  [SMALL_STATE(4243)] = 96526,
  [SMALL_STATE(4244)] = 96575,
  [SMALL_STATE(4245)] = 96626,
  [SMALL_STATE(4246)] = 96675,
  [SMALL_STATE(4247)] = 96724,
  [SMALL_STATE(4248)] = 96773,
  [SMALL_STATE(4249)] = 96822,
  [SMALL_STATE(4250)] = 96887,
  [SMALL_STATE(4251)] = 96952,
  [SMALL_STATE(4252)] = 97017,
  [SMALL_STATE(4253)] = 97066,
  [SMALL_STATE(4254)] = 97115,
  [SMALL_STATE(4255)] = 97166,
  [SMALL_STATE(4256)] = 97217,
  [SMALL_STATE(4257)] = 97266,
  [SMALL_STATE(4258)] = 97315,
  [SMALL_STATE(4259)] = 97368,
  [SMALL_STATE(4260)] = 97419,
  [SMALL_STATE(4261)] = 97484,
  [SMALL_STATE(4262)] = 97537,
  [SMALL_STATE(4263)] = 97590,
  [SMALL_STATE(4264)] = 97639,
  [SMALL_STATE(4265)] = 97704,
  [SMALL_STATE(4266)] = 97769,
  [SMALL_STATE(4267)] = 97834,
  [SMALL_STATE(4268)] = 97887,
  [SMALL_STATE(4269)] = 97936,
  [SMALL_STATE(4270)] = 97989,
  [SMALL_STATE(4271)] = 98054,
  [SMALL_STATE(4272)] = 98119,
  [SMALL_STATE(4273)] = 98184,
  [SMALL_STATE(4274)] = 98237,
  [SMALL_STATE(4275)] = 98302,
  [SMALL_STATE(4276)] = 98367,
  [SMALL_STATE(4277)] = 98432,
  [SMALL_STATE(4278)] = 98501,
  [SMALL_STATE(4279)] = 98566,
  [SMALL_STATE(4280)] = 98631,
  [SMALL_STATE(4281)] = 98684,
  [SMALL_STATE(4282)] = 98749,
  [SMALL_STATE(4283)] = 98802,
  [SMALL_STATE(4284)] = 98853,
  [SMALL_STATE(4285)] = 98918,
  [SMALL_STATE(4286)] = 98969,
  [SMALL_STATE(4287)] = 99034,
  [SMALL_STATE(4288)] = 99083,
  [SMALL_STATE(4289)] = 99136,
  [SMALL_STATE(4290)] = 99205,
  [SMALL_STATE(4291)] = 99254,
  [SMALL_STATE(4292)] = 99305,
  [SMALL_STATE(4293)] = 99358,
  [SMALL_STATE(4294)] = 99411,
  [SMALL_STATE(4295)] = 99476,
  [SMALL_STATE(4296)] = 99541,
  [SMALL_STATE(4297)] = 99590,
  [SMALL_STATE(4298)] = 99655,
  [SMALL_STATE(4299)] = 99707,
  [SMALL_STATE(4300)] = 99755,
  [SMALL_STATE(4301)] = 99819,
  [SMALL_STATE(4302)] = 99881,
  [SMALL_STATE(4303)] = 99931,
  [SMALL_STATE(4304)] = 99979,
  [SMALL_STATE(4305)] = 100031,
  [SMALL_STATE(4306)] = 100085,
  [SMALL_STATE(4307)] = 100133,
  [SMALL_STATE(4308)] = 100181,
  [SMALL_STATE(4309)] = 100243,
  [SMALL_STATE(4310)] = 100307,
  [SMALL_STATE(4311)] = 100355,
  [SMALL_STATE(4312)] = 100417,
  [SMALL_STATE(4313)] = 100481,
  [SMALL_STATE(4314)] = 100531,
  [SMALL_STATE(4315)] = 100583,
  [SMALL_STATE(4316)] = 100635,
  [SMALL_STATE(4317)] = 100687,
  [SMALL_STATE(4318)] = 100737,
  [SMALL_STATE(4319)] = 100801,
  [SMALL_STATE(4320)] = 100851,
  [SMALL_STATE(4321)] = 100901,
  [SMALL_STATE(4322)] = 100951,
  [SMALL_STATE(4323)] = 101015,
  [SMALL_STATE(4324)] = 101063,
  [SMALL_STATE(4325)] = 101127,
  [SMALL_STATE(4326)] = 101191,
  [SMALL_STATE(4327)] = 101243,
  [SMALL_STATE(4328)] = 101305,
  [SMALL_STATE(4329)] = 101369,
  [SMALL_STATE(4330)] = 101433,
  [SMALL_STATE(4331)] = 101497,
  [SMALL_STATE(4332)] = 101561,
  [SMALL_STATE(4333)] = 101625,
  [SMALL_STATE(4334)] = 101677,
  [SMALL_STATE(4335)] = 101727,
  [SMALL_STATE(4336)] = 101779,
  [SMALL_STATE(4337)] = 101827,
  [SMALL_STATE(4338)] = 101875,
  [SMALL_STATE(4339)] = 101939,
  [SMALL_STATE(4340)] = 101991,
  [SMALL_STATE(4341)] = 102055,
  [SMALL_STATE(4342)] = 102107,
  [SMALL_STATE(4343)] = 102157,
  [SMALL_STATE(4344)] = 102209,
  [SMALL_STATE(4345)] = 102257,
  [SMALL_STATE(4346)] = 102321,
  [SMALL_STATE(4347)] = 102371,
  [SMALL_STATE(4348)] = 102435,
  [SMALL_STATE(4349)] = 102499,
  [SMALL_STATE(4350)] = 102549,
  [SMALL_STATE(4351)] = 102601,
  [SMALL_STATE(4352)] = 102651,
  [SMALL_STATE(4353)] = 102715,
  [SMALL_STATE(4354)] = 102767,
  [SMALL_STATE(4355)] = 102819,
  [SMALL_STATE(4356)] = 102869,
  [SMALL_STATE(4357)] = 102933,
  [SMALL_STATE(4358)] = 103007,
  [SMALL_STATE(4359)] = 103059,
  [SMALL_STATE(4360)] = 103123,
  [SMALL_STATE(4361)] = 103175,
  [SMALL_STATE(4362)] = 103223,
  [SMALL_STATE(4363)] = 103275,
  [SMALL_STATE(4364)] = 103323,
  [SMALL_STATE(4365)] = 103387,
  [SMALL_STATE(4366)] = 103451,
  [SMALL_STATE(4367)] = 103499,
  [SMALL_STATE(4368)] = 103551,
  [SMALL_STATE(4369)] = 103599,
  [SMALL_STATE(4370)] = 103649,
  [SMALL_STATE(4371)] = 103697,
  [SMALL_STATE(4372)] = 103763,
  [SMALL_STATE(4373)] = 103815,
  [SMALL_STATE(4374)] = 103867,
  [SMALL_STATE(4375)] = 103915,
  [SMALL_STATE(4376)] = 103979,
  [SMALL_STATE(4377)] = 104031,
  [SMALL_STATE(4378)] = 104083,
  [SMALL_STATE(4379)] = 104147,
  [SMALL_STATE(4380)] = 104199,
  [SMALL_STATE(4381)] = 104249,
  [SMALL_STATE(4382)] = 104298,
  [SMALL_STATE(4383)] = 104345,
  [SMALL_STATE(4384)] = 104394,
  [SMALL_STATE(4385)] = 104441,
  [SMALL_STATE(4386)] = 104504,
  [SMALL_STATE(4387)] = 104567,
  [SMALL_STATE(4388)] = 104614,
  [SMALL_STATE(4389)] = 104677,
  [SMALL_STATE(4390)] = 104728,
  [SMALL_STATE(4391)] = 104779,
  [SMALL_STATE(4392)] = 104826,
  [SMALL_STATE(4393)] = 104875,
  [SMALL_STATE(4394)] = 104938,
  [SMALL_STATE(4395)] = 105009,
  [SMALL_STATE(4396)] = 105058,
  [SMALL_STATE(4397)] = 105107,
  [SMALL_STATE(4398)] = 105154,
  [SMALL_STATE(4399)] = 105205,
  [SMALL_STATE(4400)] = 105252,
  [SMALL_STATE(4401)] = 105303,
  [SMALL_STATE(4402)] = 105350,
  [SMALL_STATE(4403)] = 105397,
  [SMALL_STATE(4404)] = 105448,
  [SMALL_STATE(4405)] = 105495,
  [SMALL_STATE(4406)] = 105542,
  [SMALL_STATE(4407)] = 105591,
  [SMALL_STATE(4408)] = 105638,
  [SMALL_STATE(4409)] = 105685,
  [SMALL_STATE(4410)] = 105734,
  [SMALL_STATE(4411)] = 105781,
  [SMALL_STATE(4412)] = 105832,
  [SMALL_STATE(4413)] = 105881,
  [SMALL_STATE(4414)] = 105928,
  [SMALL_STATE(4415)] = 105979,
  [SMALL_STATE(4416)] = 106026,
  [SMALL_STATE(4417)] = 106073,
  [SMALL_STATE(4418)] = 106120,
  [SMALL_STATE(4419)] = 106167,
  [SMALL_STATE(4420)] = 106214,
  [SMALL_STATE(4421)] = 106261,
  [SMALL_STATE(4422)] = 106308,
  [SMALL_STATE(4423)] = 106359,
  [SMALL_STATE(4424)] = 106408,
  [SMALL_STATE(4425)] = 106471,
  [SMALL_STATE(4426)] = 106520,
  [SMALL_STATE(4427)] = 106569,
  [SMALL_STATE(4428)] = 106620,
  [SMALL_STATE(4429)] = 106669,
  [SMALL_STATE(4430)] = 106720,
  [SMALL_STATE(4431)] = 106769,
  [SMALL_STATE(4432)] = 106816,
  [SMALL_STATE(4433)] = 106863,
  [SMALL_STATE(4434)] = 106914,
  [SMALL_STATE(4435)] = 106961,
  [SMALL_STATE(4436)] = 107012,
  [SMALL_STATE(4437)] = 107063,
  [SMALL_STATE(4438)] = 107110,
  [SMALL_STATE(4439)] = 107161,
  [SMALL_STATE(4440)] = 107210,
  [SMALL_STATE(4441)] = 107257,
  [SMALL_STATE(4442)] = 107308,
  [SMALL_STATE(4443)] = 107355,
  [SMALL_STATE(4444)] = 107404,
  [SMALL_STATE(4445)] = 107453,
  [SMALL_STATE(4446)] = 107504,
  [SMALL_STATE(4447)] = 107551,
  [SMALL_STATE(4448)] = 107600,
  [SMALL_STATE(4449)] = 107647,
  [SMALL_STATE(4450)] = 107698,
  [SMALL_STATE(4451)] = 107745,
  [SMALL_STATE(4452)] = 107796,
  [SMALL_STATE(4453)] = 107845,
  [SMALL_STATE(4454)] = 107892,
  [SMALL_STATE(4455)] = 107939,
  [SMALL_STATE(4456)] = 108002,
  [SMALL_STATE(4457)] = 108049,
  [SMALL_STATE(4458)] = 108100,
  [SMALL_STATE(4459)] = 108147,
  [SMALL_STATE(4460)] = 108194,
  [SMALL_STATE(4461)] = 108243,
  [SMALL_STATE(4462)] = 108290,
  [SMALL_STATE(4463)] = 108337,
  [SMALL_STATE(4464)] = 108388,
  [SMALL_STATE(4465)] = 108435,
  [SMALL_STATE(4466)] = 108482,
  [SMALL_STATE(4467)] = 108529,
  [SMALL_STATE(4468)] = 108578,
  [SMALL_STATE(4469)] = 108625,
  [SMALL_STATE(4470)] = 108672,
  [SMALL_STATE(4471)] = 108721,
  [SMALL_STATE(4472)] = 108772,
  [SMALL_STATE(4473)] = 108821,
  [SMALL_STATE(4474)] = 108867,
  [SMALL_STATE(4475)] = 108913,
  [SMALL_STATE(4476)] = 108959,
  [SMALL_STATE(4477)] = 109005,
  [SMALL_STATE(4478)] = 109051,
  [SMALL_STATE(4479)] = 109097,
  [SMALL_STATE(4480)] = 109143,
  [SMALL_STATE(4481)] = 109189,
  [SMALL_STATE(4482)] = 109237,
  [SMALL_STATE(4483)] = 109285,
  [SMALL_STATE(4484)] = 109331,
  [SMALL_STATE(4485)] = 109377,
  [SMALL_STATE(4486)] = 109423,
  [SMALL_STATE(4487)] = 109469,
  [SMALL_STATE(4488)] = 109517,
  [SMALL_STATE(4489)] = 109563,
  [SMALL_STATE(4490)] = 109609,
  [SMALL_STATE(4491)] = 109655,
  [SMALL_STATE(4492)] = 109701,
  [SMALL_STATE(4493)] = 109747,
  [SMALL_STATE(4494)] = 109793,
  [SMALL_STATE(4495)] = 109839,
  [SMALL_STATE(4496)] = 109885,
  [SMALL_STATE(4497)] = 109933,
  [SMALL_STATE(4498)] = 109979,
  [SMALL_STATE(4499)] = 110025,
  [SMALL_STATE(4500)] = 110071,
  [SMALL_STATE(4501)] = 110117,
  [SMALL_STATE(4502)] = 110165,
  [SMALL_STATE(4503)] = 110215,
  [SMALL_STATE(4504)] = 110261,
  [SMALL_STATE(4505)] = 110307,
  [SMALL_STATE(4506)] = 110353,
  [SMALL_STATE(4507)] = 110399,
  [SMALL_STATE(4508)] = 110447,
  [SMALL_STATE(4509)] = 110493,
  [SMALL_STATE(4510)] = 110539,
  [SMALL_STATE(4511)] = 110585,
  [SMALL_STATE(4512)] = 110635,
  [SMALL_STATE(4513)] = 110685,
  [SMALL_STATE(4514)] = 110731,
  [SMALL_STATE(4515)] = 110777,
  [SMALL_STATE(4516)] = 110823,
  [SMALL_STATE(4517)] = 110869,
  [SMALL_STATE(4518)] = 110919,
  [SMALL_STATE(4519)] = 110965,
  [SMALL_STATE(4520)] = 111027,
  [SMALL_STATE(4521)] = 111077,
  [SMALL_STATE(4522)] = 111125,
  [SMALL_STATE(4523)] = 111187,
  [SMALL_STATE(4524)] = 111249,
  [SMALL_STATE(4525)] = 111311,
  [SMALL_STATE(4526)] = 111357,
  [SMALL_STATE(4527)] = 111403,
  [SMALL_STATE(4528)] = 111449,
  [SMALL_STATE(4529)] = 111497,
  [SMALL_STATE(4530)] = 111543,
  [SMALL_STATE(4531)] = 111591,
  [SMALL_STATE(4532)] = 111637,
  [SMALL_STATE(4533)] = 111683,
  [SMALL_STATE(4534)] = 111729,
  [SMALL_STATE(4535)] = 111779,
  [SMALL_STATE(4536)] = 111829,
  [SMALL_STATE(4537)] = 111875,
  [SMALL_STATE(4538)] = 111921,
  [SMALL_STATE(4539)] = 111967,
  [SMALL_STATE(4540)] = 112013,
  [SMALL_STATE(4541)] = 112059,
  [SMALL_STATE(4542)] = 112105,
  [SMALL_STATE(4543)] = 112151,
  [SMALL_STATE(4544)] = 112197,
  [SMALL_STATE(4545)] = 112243,
  [SMALL_STATE(4546)] = 112289,
  [SMALL_STATE(4547)] = 112335,
  [SMALL_STATE(4548)] = 112381,
  [SMALL_STATE(4549)] = 112427,
  [SMALL_STATE(4550)] = 112475,
  [SMALL_STATE(4551)] = 112521,
  [SMALL_STATE(4552)] = 112567,
  [SMALL_STATE(4553)] = 112613,
  [SMALL_STATE(4554)] = 112659,
  [SMALL_STATE(4555)] = 112705,
  [SMALL_STATE(4556)] = 112755,
  [SMALL_STATE(4557)] = 112801,
  [SMALL_STATE(4558)] = 112849,
  [SMALL_STATE(4559)] = 112895,
  [SMALL_STATE(4560)] = 112941,
  [SMALL_STATE(4561)] = 112987,
  [SMALL_STATE(4562)] = 113033,
  [SMALL_STATE(4563)] = 113079,
  [SMALL_STATE(4564)] = 113125,
  [SMALL_STATE(4565)] = 113171,
  [SMALL_STATE(4566)] = 113219,
  [SMALL_STATE(4567)] = 113267,
  [SMALL_STATE(4568)] = 113313,
  [SMALL_STATE(4569)] = 113359,
  [SMALL_STATE(4570)] = 113405,
  [SMALL_STATE(4571)] = 113451,
  [SMALL_STATE(4572)] = 113499,
  [SMALL_STATE(4573)] = 113549,
  [SMALL_STATE(4574)] = 113595,
  [SMALL_STATE(4575)] = 113641,
  [SMALL_STATE(4576)] = 113689,
  [SMALL_STATE(4577)] = 113735,
  [SMALL_STATE(4578)] = 113781,
  [SMALL_STATE(4579)] = 113827,
  [SMALL_STATE(4580)] = 113873,
  [SMALL_STATE(4581)] = 113921,
  [SMALL_STATE(4582)] = 113967,
  [SMALL_STATE(4583)] = 114013,
  [SMALL_STATE(4584)] = 114061,
  [SMALL_STATE(4585)] = 114107,
  [SMALL_STATE(4586)] = 114152,
  [SMALL_STATE(4587)] = 114197,
  [SMALL_STATE(4588)] = 114254,
  [SMALL_STATE(4589)] = 114311,
  [SMALL_STATE(4590)] = 114356,
  [SMALL_STATE(4591)] = 114413,
  [SMALL_STATE(4592)] = 114458,
  [SMALL_STATE(4593)] = 114505,
  [SMALL_STATE(4594)] = 114562,
  [SMALL_STATE(4595)] = 114607,
  [SMALL_STATE(4596)] = 114664,
  [SMALL_STATE(4597)] = 114711,
  [SMALL_STATE(4598)] = 114760,
  [SMALL_STATE(4599)] = 114805,
  [SMALL_STATE(4600)] = 114862,
  [SMALL_STATE(4601)] = 114919,
  [SMALL_STATE(4602)] = 114976,
  [SMALL_STATE(4603)] = 115023,
  [SMALL_STATE(4604)] = 115080,
  [SMALL_STATE(4605)] = 115129,
  [SMALL_STATE(4606)] = 115186,
  [SMALL_STATE(4607)] = 115231,
  [SMALL_STATE(4608)] = 115276,
  [SMALL_STATE(4609)] = 115321,
  [SMALL_STATE(4610)] = 115366,
  [SMALL_STATE(4611)] = 115411,
  [SMALL_STATE(4612)] = 115456,
  [SMALL_STATE(4613)] = 115501,
  [SMALL_STATE(4614)] = 115546,
  [SMALL_STATE(4615)] = 115591,
  [SMALL_STATE(4616)] = 115636,
  [SMALL_STATE(4617)] = 115693,
  [SMALL_STATE(4618)] = 115740,
  [SMALL_STATE(4619)] = 115785,
  [SMALL_STATE(4620)] = 115842,
  [SMALL_STATE(4621)] = 115899,
  [SMALL_STATE(4622)] = 115956,
  [SMALL_STATE(4623)] = 116001,
  [SMALL_STATE(4624)] = 116046,
  [SMALL_STATE(4625)] = 116091,
  [SMALL_STATE(4626)] = 116136,
  [SMALL_STATE(4627)] = 116181,
  [SMALL_STATE(4628)] = 116238,
  [SMALL_STATE(4629)] = 116287,
  [SMALL_STATE(4630)] = 116332,
  [SMALL_STATE(4631)] = 116389,
  [SMALL_STATE(4632)] = 116434,
  [SMALL_STATE(4633)] = 116491,
  [SMALL_STATE(4634)] = 116548,
  [SMALL_STATE(4635)] = 116609,
  [SMALL_STATE(4636)] = 116666,
  [SMALL_STATE(4637)] = 116711,
  [SMALL_STATE(4638)] = 116768,
  [SMALL_STATE(4639)] = 116825,
  [SMALL_STATE(4640)] = 116882,
  [SMALL_STATE(4641)] = 116939,
  [SMALL_STATE(4642)] = 116996,
  [SMALL_STATE(4643)] = 117043,
  [SMALL_STATE(4644)] = 117098,
  [SMALL_STATE(4645)] = 117155,
  [SMALL_STATE(4646)] = 117202,
  [SMALL_STATE(4647)] = 117249,
  [SMALL_STATE(4648)] = 117306,
  [SMALL_STATE(4649)] = 117363,
  [SMALL_STATE(4650)] = 117408,
  [SMALL_STATE(4651)] = 117465,
  [SMALL_STATE(4652)] = 117510,
  [SMALL_STATE(4653)] = 117555,
  [SMALL_STATE(4654)] = 117612,
  [SMALL_STATE(4655)] = 117669,
  [SMALL_STATE(4656)] = 117730,
  [SMALL_STATE(4657)] = 117791,
  [SMALL_STATE(4658)] = 117836,
  [SMALL_STATE(4659)] = 117883,
  [SMALL_STATE(4660)] = 117940,
  [SMALL_STATE(4661)] = 117985,
  [SMALL_STATE(4662)] = 118030,
  [SMALL_STATE(4663)] = 118087,
  [SMALL_STATE(4664)] = 118144,
  [SMALL_STATE(4665)] = 118189,
  [SMALL_STATE(4666)] = 118234,
  [SMALL_STATE(4667)] = 118279,
  [SMALL_STATE(4668)] = 118324,
  [SMALL_STATE(4669)] = 118369,
  [SMALL_STATE(4670)] = 118414,
  [SMALL_STATE(4671)] = 118459,
  [SMALL_STATE(4672)] = 118516,
  [SMALL_STATE(4673)] = 118573,
  [SMALL_STATE(4674)] = 118618,
  [SMALL_STATE(4675)] = 118675,
  [SMALL_STATE(4676)] = 118720,
  [SMALL_STATE(4677)] = 118765,
  [SMALL_STATE(4678)] = 118810,
  [SMALL_STATE(4679)] = 118855,
  [SMALL_STATE(4680)] = 118900,
  [SMALL_STATE(4681)] = 118945,
  [SMALL_STATE(4682)] = 118990,
  [SMALL_STATE(4683)] = 119035,
  [SMALL_STATE(4684)] = 119082,
  [SMALL_STATE(4685)] = 119127,
  [SMALL_STATE(4686)] = 119174,
  [SMALL_STATE(4687)] = 119223,
  [SMALL_STATE(4688)] = 119268,
  [SMALL_STATE(4689)] = 119329,
  [SMALL_STATE(4690)] = 119386,
  [SMALL_STATE(4691)] = 119431,
  [SMALL_STATE(4692)] = 119476,
  [SMALL_STATE(4693)] = 119533,
  [SMALL_STATE(4694)] = 119578,
  [SMALL_STATE(4695)] = 119623,
  [SMALL_STATE(4696)] = 119668,
  [SMALL_STATE(4697)] = 119713,
  [SMALL_STATE(4698)] = 119758,
  [SMALL_STATE(4699)] = 119803,
  [SMALL_STATE(4700)] = 119860,
  [SMALL_STATE(4701)] = 119905,
  [SMALL_STATE(4702)] = 119950,
  [SMALL_STATE(4703)] = 120007,
  [SMALL_STATE(4704)] = 120064,
  [SMALL_STATE(4705)] = 120121,
  [SMALL_STATE(4706)] = 120178,
  [SMALL_STATE(4707)] = 120223,
  [SMALL_STATE(4708)] = 120280,
  [SMALL_STATE(4709)] = 120325,
  [SMALL_STATE(4710)] = 120370,
  [SMALL_STATE(4711)] = 120418,
  [SMALL_STATE(4712)] = 120472,
  [SMALL_STATE(4713)] = 120526,
  [SMALL_STATE(4714)] = 120570,
  [SMALL_STATE(4715)] = 120624,
  [SMALL_STATE(4716)] = 120678,
  [SMALL_STATE(4717)] = 120732,
  [SMALL_STATE(4718)] = 120792,
  [SMALL_STATE(4719)] = 120836,
  [SMALL_STATE(4720)] = 120890,
  [SMALL_STATE(4721)] = 120934,
  [SMALL_STATE(4722)] = 120976,
  [SMALL_STATE(4723)] = 121020,
  [SMALL_STATE(4724)] = 121064,
  [SMALL_STATE(4725)] = 121118,
  [SMALL_STATE(4726)] = 121164,
  [SMALL_STATE(4727)] = 121208,
  [SMALL_STATE(4728)] = 121252,
  [SMALL_STATE(4729)] = 121306,
  [SMALL_STATE(4730)] = 121350,
  [SMALL_STATE(4731)] = 121394,
  [SMALL_STATE(4732)] = 121438,
  [SMALL_STATE(4733)] = 121482,
  [SMALL_STATE(4734)] = 121526,
  [SMALL_STATE(4735)] = 121580,
  [SMALL_STATE(4736)] = 121624,
  [SMALL_STATE(4737)] = 121668,
  [SMALL_STATE(4738)] = 121712,
  [SMALL_STATE(4739)] = 121758,
  [SMALL_STATE(4740)] = 121802,
  [SMALL_STATE(4741)] = 121856,
  [SMALL_STATE(4742)] = 121900,
  [SMALL_STATE(4743)] = 121944,
  [SMALL_STATE(4744)] = 121990,
  [SMALL_STATE(4745)] = 122034,
  [SMALL_STATE(4746)] = 122088,
  [SMALL_STATE(4747)] = 122132,
  [SMALL_STATE(4748)] = 122186,
  [SMALL_STATE(4749)] = 122248,
  [SMALL_STATE(4750)] = 122310,
  [SMALL_STATE(4751)] = 122354,
  [SMALL_STATE(4752)] = 122398,
  [SMALL_STATE(4753)] = 122442,
  [SMALL_STATE(4754)] = 122490,
  [SMALL_STATE(4755)] = 122534,
  [SMALL_STATE(4756)] = 122588,
  [SMALL_STATE(4757)] = 122642,
  [SMALL_STATE(4758)] = 122696,
  [SMALL_STATE(4759)] = 122750,
  [SMALL_STATE(4760)] = 122804,
  [SMALL_STATE(4761)] = 122846,
  [SMALL_STATE(4762)] = 122900,
  [SMALL_STATE(4763)] = 122960,
  [SMALL_STATE(4764)] = 123014,
  [SMALL_STATE(4765)] = 123062,
  [SMALL_STATE(4766)] = 123106,
  [SMALL_STATE(4767)] = 123160,
  [SMALL_STATE(4768)] = 123214,
  [SMALL_STATE(4769)] = 123268,
  [SMALL_STATE(4770)] = 123316,
  [SMALL_STATE(4771)] = 123370,
  [SMALL_STATE(4772)] = 123414,
  [SMALL_STATE(4773)] = 123456,
  [SMALL_STATE(4774)] = 123518,
  [SMALL_STATE(4775)] = 123572,
  [SMALL_STATE(4776)] = 123618,
  [SMALL_STATE(4777)] = 123662,
  [SMALL_STATE(4778)] = 123708,
  [SMALL_STATE(4779)] = 123752,
  [SMALL_STATE(4780)] = 123800,
  [SMALL_STATE(4781)] = 123844,
  [SMALL_STATE(4782)] = 123888,
  [SMALL_STATE(4783)] = 123934,
  [SMALL_STATE(4784)] = 123978,
  [SMALL_STATE(4785)] = 124032,
  [SMALL_STATE(4786)] = 124078,
  [SMALL_STATE(4787)] = 124124,
  [SMALL_STATE(4788)] = 124178,
  [SMALL_STATE(4789)] = 124232,
  [SMALL_STATE(4790)] = 124292,
  [SMALL_STATE(4791)] = 124340,
  [SMALL_STATE(4792)] = 124384,
  [SMALL_STATE(4793)] = 124438,
  [SMALL_STATE(4794)] = 124480,
  [SMALL_STATE(4795)] = 124524,
  [SMALL_STATE(4796)] = 124588,
  [SMALL_STATE(4797)] = 124632,
  [SMALL_STATE(4798)] = 124676,
  [SMALL_STATE(4799)] = 124720,
  [SMALL_STATE(4800)] = 124782,
  [SMALL_STATE(4801)] = 124826,
  [SMALL_STATE(4802)] = 124868,
  [SMALL_STATE(4803)] = 124912,
  [SMALL_STATE(4804)] = 124956,
  [SMALL_STATE(4805)] = 125010,
  [SMALL_STATE(4806)] = 125058,
  [SMALL_STATE(4807)] = 125122,
  [SMALL_STATE(4808)] = 125176,
  [SMALL_STATE(4809)] = 125220,
  [SMALL_STATE(4810)] = 125274,
  [SMALL_STATE(4811)] = 125338,
  [SMALL_STATE(4812)] = 125382,
  [SMALL_STATE(4813)] = 125426,
  [SMALL_STATE(4814)] = 125470,
  [SMALL_STATE(4815)] = 125524,
  [SMALL_STATE(4816)] = 125568,
  [SMALL_STATE(4817)] = 125628,
  [SMALL_STATE(4818)] = 125682,
  [SMALL_STATE(4819)] = 125736,
  [SMALL_STATE(4820)] = 125780,
  [SMALL_STATE(4821)] = 125824,
  [SMALL_STATE(4822)] = 125868,
  [SMALL_STATE(4823)] = 125912,
  [SMALL_STATE(4824)] = 125956,
  [SMALL_STATE(4825)] = 126000,
  [SMALL_STATE(4826)] = 126052,
  [SMALL_STATE(4827)] = 126096,
  [SMALL_STATE(4828)] = 126140,
  [SMALL_STATE(4829)] = 126194,
  [SMALL_STATE(4830)] = 126238,
  [SMALL_STATE(4831)] = 126282,
  [SMALL_STATE(4832)] = 126326,
  [SMALL_STATE(4833)] = 126370,
  [SMALL_STATE(4834)] = 126424,
  [SMALL_STATE(4835)] = 126468,
  [SMALL_STATE(4836)] = 126512,
  [SMALL_STATE(4837)] = 126566,
  [SMALL_STATE(4838)] = 126610,
  [SMALL_STATE(4839)] = 126664,
  [SMALL_STATE(4840)] = 126710,
  [SMALL_STATE(4841)] = 126754,
  [SMALL_STATE(4842)] = 126798,
  [SMALL_STATE(4843)] = 126852,
  [SMALL_STATE(4844)] = 126898,
  [SMALL_STATE(4845)] = 126942,
  [SMALL_STATE(4846)] = 126986,
  [SMALL_STATE(4847)] = 127030,
  [SMALL_STATE(4848)] = 127074,
  [SMALL_STATE(4849)] = 127118,
  [SMALL_STATE(4850)] = 127172,
  [SMALL_STATE(4851)] = 127226,
  [SMALL_STATE(4852)] = 127270,
  [SMALL_STATE(4853)] = 127314,
  [SMALL_STATE(4854)] = 127358,
  [SMALL_STATE(4855)] = 127402,
  [SMALL_STATE(4856)] = 127456,
  [SMALL_STATE(4857)] = 127510,
  [SMALL_STATE(4858)] = 127554,
  [SMALL_STATE(4859)] = 127608,
  [SMALL_STATE(4860)] = 127655,
  [SMALL_STATE(4861)] = 127698,
  [SMALL_STATE(4862)] = 127739,
  [SMALL_STATE(4863)] = 127782,
  [SMALL_STATE(4864)] = 127823,
  [SMALL_STATE(4865)] = 127884,
  [SMALL_STATE(4866)] = 127925,
  [SMALL_STATE(4867)] = 127966,
  [SMALL_STATE(4868)] = 128007,
  [SMALL_STATE(4869)] = 128052,
  [SMALL_STATE(4870)] = 128093,
  [SMALL_STATE(4871)] = 128134,
  [SMALL_STATE(4872)] = 128177,
  [SMALL_STATE(4873)] = 128218,
  [SMALL_STATE(4874)] = 128263,
  [SMALL_STATE(4875)] = 128306,
  [SMALL_STATE(4876)] = 128347,
  [SMALL_STATE(4877)] = 128390,
  [SMALL_STATE(4878)] = 128433,
  [SMALL_STATE(4879)] = 128474,
  [SMALL_STATE(4880)] = 128517,
  [SMALL_STATE(4881)] = 128558,
  [SMALL_STATE(4882)] = 128599,
  [SMALL_STATE(4883)] = 128660,
  [SMALL_STATE(4884)] = 128707,
  [SMALL_STATE(4885)] = 128756,
  [SMALL_STATE(4886)] = 128799,
  [SMALL_STATE(4887)] = 128842,
  [SMALL_STATE(4888)] = 128883,
  [SMALL_STATE(4889)] = 128924,
  [SMALL_STATE(4890)] = 128967,
  [SMALL_STATE(4891)] = 129014,
  [SMALL_STATE(4892)] = 129055,
  [SMALL_STATE(4893)] = 129096,
  [SMALL_STATE(4894)] = 129143,
  [SMALL_STATE(4895)] = 129184,
  [SMALL_STATE(4896)] = 129225,
  [SMALL_STATE(4897)] = 129272,
  [SMALL_STATE(4898)] = 129319,
  [SMALL_STATE(4899)] = 129360,
  [SMALL_STATE(4900)] = 129405,
  [SMALL_STATE(4901)] = 129446,
  [SMALL_STATE(4902)] = 129489,
  [SMALL_STATE(4903)] = 129530,
  [SMALL_STATE(4904)] = 129571,
  [SMALL_STATE(4905)] = 129614,
  [SMALL_STATE(4906)] = 129657,
  [SMALL_STATE(4907)] = 129704,
  [SMALL_STATE(4908)] = 129749,
  [SMALL_STATE(4909)] = 129790,
  [SMALL_STATE(4910)] = 129833,
  [SMALL_STATE(4911)] = 129874,
  [SMALL_STATE(4912)] = 129915,
  [SMALL_STATE(4913)] = 129962,
  [SMALL_STATE(4914)] = 130007,
  [SMALL_STATE(4915)] = 130056,
  [SMALL_STATE(4916)] = 130099,
  [SMALL_STATE(4917)] = 130140,
  [SMALL_STATE(4918)] = 130181,
  [SMALL_STATE(4919)] = 130226,
  [SMALL_STATE(4920)] = 130267,
  [SMALL_STATE(4921)] = 130318,
  [SMALL_STATE(4922)] = 130379,
  [SMALL_STATE(4923)] = 130422,
  [SMALL_STATE(4924)] = 130465,
  [SMALL_STATE(4925)] = 130510,
  [SMALL_STATE(4926)] = 130557,
  [SMALL_STATE(4927)] = 130598,
  [SMALL_STATE(4928)] = 130645,
  [SMALL_STATE(4929)] = 130686,
  [SMALL_STATE(4930)] = 130731,
  [SMALL_STATE(4931)] = 130772,
  [SMALL_STATE(4932)] = 130815,
  [SMALL_STATE(4933)] = 130860,
  [SMALL_STATE(4934)] = 130901,
  [SMALL_STATE(4935)] = 130948,
  [SMALL_STATE(4936)] = 130999,
  [SMALL_STATE(4937)] = 131050,
  [SMALL_STATE(4938)] = 131093,
  [SMALL_STATE(4939)] = 131134,
  [SMALL_STATE(4940)] = 131177,
  [SMALL_STATE(4941)] = 131228,
  [SMALL_STATE(4942)] = 131269,
  [SMALL_STATE(4943)] = 131325,
  [SMALL_STATE(4944)] = 131381,
  [SMALL_STATE(4945)] = 131437,
  [SMALL_STATE(4946)] = 131483,
  [SMALL_STATE(4947)] = 131541,
  [SMALL_STATE(4948)] = 131591,
  [SMALL_STATE(4949)] = 131647,
  [SMALL_STATE(4950)] = 131703,
  [SMALL_STATE(4951)] = 131759,
  [SMALL_STATE(4952)] = 131809,
  [SMALL_STATE(4953)] = 131853,
  [SMALL_STATE(4954)] = 131899,
  [SMALL_STATE(4955)] = 131955,
  [SMALL_STATE(4956)] = 131997,
  [SMALL_STATE(4957)] = 132039,
  [SMALL_STATE(4958)] = 132095,
  [SMALL_STATE(4959)] = 132145,
  [SMALL_STATE(4960)] = 132201,
  [SMALL_STATE(4961)] = 132251,
  [SMALL_STATE(4962)] = 132301,
  [SMALL_STATE(4963)] = 132357,
  [SMALL_STATE(4964)] = 132413,
  [SMALL_STATE(4965)] = 132463,
  [SMALL_STATE(4966)] = 132513,
  [SMALL_STATE(4967)] = 132569,
  [SMALL_STATE(4968)] = 132625,
  [SMALL_STATE(4969)] = 132675,
  [SMALL_STATE(4970)] = 132725,
  [SMALL_STATE(4971)] = 132775,
  [SMALL_STATE(4972)] = 132831,
  [SMALL_STATE(4973)] = 132889,
  [SMALL_STATE(4974)] = 132945,
  [SMALL_STATE(4975)] = 133001,
  [SMALL_STATE(4976)] = 133057,
  [SMALL_STATE(4977)] = 133113,
  [SMALL_STATE(4978)] = 133169,
  [SMALL_STATE(4979)] = 133225,
  [SMALL_STATE(4980)] = 133281,
  [SMALL_STATE(4981)] = 133331,
  [SMALL_STATE(4982)] = 133373,
  [SMALL_STATE(4983)] = 133423,
  [SMALL_STATE(4984)] = 133479,
  [SMALL_STATE(4985)] = 133535,
  [SMALL_STATE(4986)] = 133577,
  [SMALL_STATE(4987)] = 133633,
  [SMALL_STATE(4988)] = 133677,
  [SMALL_STATE(4989)] = 133735,
  [SMALL_STATE(4990)] = 133785,
  [SMALL_STATE(4991)] = 133841,
  [SMALL_STATE(4992)] = 133883,
  [SMALL_STATE(4993)] = 133929,
  [SMALL_STATE(4994)] = 133985,
  [SMALL_STATE(4995)] = 134035,
  [SMALL_STATE(4996)] = 134091,
  [SMALL_STATE(4997)] = 134147,
  [SMALL_STATE(4998)] = 134193,
  [SMALL_STATE(4999)] = 134239,
  [SMALL_STATE(5000)] = 134295,
  [SMALL_STATE(5001)] = 134345,
  [SMALL_STATE(5002)] = 134395,
  [SMALL_STATE(5003)] = 134451,
  [SMALL_STATE(5004)] = 134497,
  [SMALL_STATE(5005)] = 134543,
  [SMALL_STATE(5006)] = 134599,
  [SMALL_STATE(5007)] = 134655,
  [SMALL_STATE(5008)] = 134713,
  [SMALL_STATE(5009)] = 134769,
  [SMALL_STATE(5010)] = 134819,
  [SMALL_STATE(5011)] = 134875,
  [SMALL_STATE(5012)] = 134925,
  [SMALL_STATE(5013)] = 134981,
  [SMALL_STATE(5014)] = 135031,
  [SMALL_STATE(5015)] = 135081,
  [SMALL_STATE(5016)] = 135139,
  [SMALL_STATE(5017)] = 135197,
  [SMALL_STATE(5018)] = 135253,
  [SMALL_STATE(5019)] = 135299,
  [SMALL_STATE(5020)] = 135343,
  [SMALL_STATE(5021)] = 135399,
  [SMALL_STATE(5022)] = 135457,
  [SMALL_STATE(5023)] = 135503,
  [SMALL_STATE(5024)] = 135561,
  [SMALL_STATE(5025)] = 135611,
  [SMALL_STATE(5026)] = 135667,
  [SMALL_STATE(5027)] = 135717,
  [SMALL_STATE(5028)] = 135763,
  [SMALL_STATE(5029)] = 135813,
  [SMALL_STATE(5030)] = 135871,
  [SMALL_STATE(5031)] = 135929,
  [SMALL_STATE(5032)] = 135971,
  [SMALL_STATE(5033)] = 136021,
  [SMALL_STATE(5034)] = 136065,
  [SMALL_STATE(5035)] = 136109,
  [SMALL_STATE(5036)] = 136159,
  [SMALL_STATE(5037)] = 136209,
  [SMALL_STATE(5038)] = 136267,
  [SMALL_STATE(5039)] = 136309,
  [SMALL_STATE(5040)] = 136355,
  [SMALL_STATE(5041)] = 136405,
  [SMALL_STATE(5042)] = 136451,
  [SMALL_STATE(5043)] = 136507,
  [SMALL_STATE(5044)] = 136551,
  [SMALL_STATE(5045)] = 136597,
  [SMALL_STATE(5046)] = 136641,
  [SMALL_STATE(5047)] = 136697,
  [SMALL_STATE(5048)] = 136741,
  [SMALL_STATE(5049)] = 136799,
  [SMALL_STATE(5050)] = 136849,
  [SMALL_STATE(5051)] = 136899,
  [SMALL_STATE(5052)] = 136949,
  [SMALL_STATE(5053)] = 136991,
  [SMALL_STATE(5054)] = 137033,
  [SMALL_STATE(5055)] = 137075,
  [SMALL_STATE(5056)] = 137121,
  [SMALL_STATE(5057)] = 137163,
  [SMALL_STATE(5058)] = 137205,
  [SMALL_STATE(5059)] = 137247,
  [SMALL_STATE(5060)] = 137289,
  [SMALL_STATE(5061)] = 137337,
  [SMALL_STATE(5062)] = 137395,
  [SMALL_STATE(5063)] = 137437,
  [SMALL_STATE(5064)] = 137487,
  [SMALL_STATE(5065)] = 137537,
  [SMALL_STATE(5066)] = 137579,
  [SMALL_STATE(5067)] = 137635,
  [SMALL_STATE(5068)] = 137685,
  [SMALL_STATE(5069)] = 137741,
  [SMALL_STATE(5070)] = 137799,
  [SMALL_STATE(5071)] = 137849,
  [SMALL_STATE(5072)] = 137899,
  [SMALL_STATE(5073)] = 137955,
  [SMALL_STATE(5074)] = 138005,
  [SMALL_STATE(5075)] = 138047,
  [SMALL_STATE(5076)] = 138093,
  [SMALL_STATE(5077)] = 138149,
  [SMALL_STATE(5078)] = 138207,
  [SMALL_STATE(5079)] = 138251,
  [SMALL_STATE(5080)] = 138301,
  [SMALL_STATE(5081)] = 138345,
  [SMALL_STATE(5082)] = 138395,
  [SMALL_STATE(5083)] = 138439,
  [SMALL_STATE(5084)] = 138483,
  [SMALL_STATE(5085)] = 138527,
  [SMALL_STATE(5086)] = 138571,
  [SMALL_STATE(5087)] = 138615,
  [SMALL_STATE(5088)] = 138659,
  [SMALL_STATE(5089)] = 138713,
  [SMALL_STATE(5090)] = 138757,
  [SMALL_STATE(5091)] = 138815,
  [SMALL_STATE(5092)] = 138859,
  [SMALL_STATE(5093)] = 138917,
  [SMALL_STATE(5094)] = 138975,
  [SMALL_STATE(5095)] = 139019,
  [SMALL_STATE(5096)] = 139077,
  [SMALL_STATE(5097)] = 139127,
  [SMALL_STATE(5098)] = 139185,
  [SMALL_STATE(5099)] = 139243,
  [SMALL_STATE(5100)] = 139301,
  [SMALL_STATE(5101)] = 139359,
  [SMALL_STATE(5102)] = 139415,
  [SMALL_STATE(5103)] = 139473,
  [SMALL_STATE(5104)] = 139531,
  [SMALL_STATE(5105)] = 139589,
  [SMALL_STATE(5106)] = 139647,
  [SMALL_STATE(5107)] = 139705,
  [SMALL_STATE(5108)] = 139761,
  [SMALL_STATE(5109)] = 139819,
  [SMALL_STATE(5110)] = 139861,
  [SMALL_STATE(5111)] = 139919,
  [SMALL_STATE(5112)] = 139977,
  [SMALL_STATE(5113)] = 140027,
  [SMALL_STATE(5114)] = 140085,
  [SMALL_STATE(5115)] = 140141,
  [SMALL_STATE(5116)] = 140199,
  [SMALL_STATE(5117)] = 140257,
  [SMALL_STATE(5118)] = 140313,
  [SMALL_STATE(5119)] = 140369,
  [SMALL_STATE(5120)] = 140427,
  [SMALL_STATE(5121)] = 140485,
  [SMALL_STATE(5122)] = 140529,
  [SMALL_STATE(5123)] = 140585,
  [SMALL_STATE(5124)] = 140641,
  [SMALL_STATE(5125)] = 140691,
  [SMALL_STATE(5126)] = 140749,
  [SMALL_STATE(5127)] = 140807,
  [SMALL_STATE(5128)] = 140865,
  [SMALL_STATE(5129)] = 140907,
  [SMALL_STATE(5130)] = 140965,
  [SMALL_STATE(5131)] = 141023,
  [SMALL_STATE(5132)] = 141079,
  [SMALL_STATE(5133)] = 141135,
  [SMALL_STATE(5134)] = 141193,
  [SMALL_STATE(5135)] = 141239,
  [SMALL_STATE(5136)] = 141297,
  [SMALL_STATE(5137)] = 141341,
  [SMALL_STATE(5138)] = 141397,
  [SMALL_STATE(5139)] = 141455,
  [SMALL_STATE(5140)] = 141513,
  [SMALL_STATE(5141)] = 141571,
  [SMALL_STATE(5142)] = 141627,
  [SMALL_STATE(5143)] = 141685,
  [SMALL_STATE(5144)] = 141743,
  [SMALL_STATE(5145)] = 141801,
  [SMALL_STATE(5146)] = 141859,
  [SMALL_STATE(5147)] = 141917,
  [SMALL_STATE(5148)] = 141973,
  [SMALL_STATE(5149)] = 142029,
  [SMALL_STATE(5150)] = 142085,
  [SMALL_STATE(5151)] = 142127,
  [SMALL_STATE(5152)] = 142185,
  [SMALL_STATE(5153)] = 142243,
  [SMALL_STATE(5154)] = 142289,
  [SMALL_STATE(5155)] = 142343,
  [SMALL_STATE(5156)] = 142399,
  [SMALL_STATE(5157)] = 142443,
  [SMALL_STATE(5158)] = 142499,
  [SMALL_STATE(5159)] = 142557,
  [SMALL_STATE(5160)] = 142601,
  [SMALL_STATE(5161)] = 142643,
  [SMALL_STATE(5162)] = 142685,
  [SMALL_STATE(5163)] = 142735,
  [SMALL_STATE(5164)] = 142779,
  [SMALL_STATE(5165)] = 142835,
  [SMALL_STATE(5166)] = 142893,
  [SMALL_STATE(5167)] = 142943,
  [SMALL_STATE(5168)] = 143001,
  [SMALL_STATE(5169)] = 143059,
  [SMALL_STATE(5170)] = 143117,
  [SMALL_STATE(5171)] = 143173,
  [SMALL_STATE(5172)] = 143229,
  [SMALL_STATE(5173)] = 143287,
  [SMALL_STATE(5174)] = 143337,
  [SMALL_STATE(5175)] = 143392,
  [SMALL_STATE(5176)] = 143447,
  [SMALL_STATE(5177)] = 143500,
  [SMALL_STATE(5178)] = 143555,
  [SMALL_STATE(5179)] = 143594,
  [SMALL_STATE(5180)] = 143649,
  [SMALL_STATE(5181)] = 143690,
  [SMALL_STATE(5182)] = 143745,
  [SMALL_STATE(5183)] = 143786,
  [SMALL_STATE(5184)] = 143829,
  [SMALL_STATE(5185)] = 143884,
  [SMALL_STATE(5186)] = 143939,
  [SMALL_STATE(5187)] = 143992,
  [SMALL_STATE(5188)] = 144033,
  [SMALL_STATE(5189)] = 144088,
  [SMALL_STATE(5190)] = 144135,
  [SMALL_STATE(5191)] = 144176,
  [SMALL_STATE(5192)] = 144231,
  [SMALL_STATE(5193)] = 144284,
  [SMALL_STATE(5194)] = 144339,
  [SMALL_STATE(5195)] = 144394,
  [SMALL_STATE(5196)] = 144433,
  [SMALL_STATE(5197)] = 144488,
  [SMALL_STATE(5198)] = 144543,
  [SMALL_STATE(5199)] = 144582,
  [SMALL_STATE(5200)] = 144623,
  [SMALL_STATE(5201)] = 144662,
  [SMALL_STATE(5202)] = 144717,
  [SMALL_STATE(5203)] = 144772,
  [SMALL_STATE(5204)] = 144813,
  [SMALL_STATE(5205)] = 144868,
  [SMALL_STATE(5206)] = 144923,
  [SMALL_STATE(5207)] = 144970,
  [SMALL_STATE(5208)] = 145013,
  [SMALL_STATE(5209)] = 145054,
  [SMALL_STATE(5210)] = 145109,
  [SMALL_STATE(5211)] = 145164,
  [SMALL_STATE(5212)] = 145219,
  [SMALL_STATE(5213)] = 145274,
  [SMALL_STATE(5214)] = 145317,
  [SMALL_STATE(5215)] = 145372,
  [SMALL_STATE(5216)] = 145413,
  [SMALL_STATE(5217)] = 145454,
  [SMALL_STATE(5218)] = 145509,
  [SMALL_STATE(5219)] = 145564,
  [SMALL_STATE(5220)] = 145619,
  [SMALL_STATE(5221)] = 145672,
  [SMALL_STATE(5222)] = 145715,
  [SMALL_STATE(5223)] = 145770,
  [SMALL_STATE(5224)] = 145811,
  [SMALL_STATE(5225)] = 145858,
  [SMALL_STATE(5226)] = 145899,
  [SMALL_STATE(5227)] = 145954,
  [SMALL_STATE(5228)] = 146009,
  [SMALL_STATE(5229)] = 146064,
  [SMALL_STATE(5230)] = 146105,
  [SMALL_STATE(5231)] = 146148,
  [SMALL_STATE(5232)] = 146191,
  [SMALL_STATE(5233)] = 146236,
  [SMALL_STATE(5234)] = 146291,
  [SMALL_STATE(5235)] = 146346,
  [SMALL_STATE(5236)] = 146401,
  [SMALL_STATE(5237)] = 146446,
  [SMALL_STATE(5238)] = 146501,
  [SMALL_STATE(5239)] = 146542,
  [SMALL_STATE(5240)] = 146597,
  [SMALL_STATE(5241)] = 146652,
  [SMALL_STATE(5242)] = 146693,
  [SMALL_STATE(5243)] = 146748,
  [SMALL_STATE(5244)] = 146803,
  [SMALL_STATE(5245)] = 146844,
  [SMALL_STATE(5246)] = 146899,
  [SMALL_STATE(5247)] = 146940,
  [SMALL_STATE(5248)] = 146995,
  [SMALL_STATE(5249)] = 147048,
  [SMALL_STATE(5250)] = 147103,
  [SMALL_STATE(5251)] = 147150,
  [SMALL_STATE(5252)] = 147205,
  [SMALL_STATE(5253)] = 147246,
  [SMALL_STATE(5254)] = 147293,
  [SMALL_STATE(5255)] = 147348,
  [SMALL_STATE(5256)] = 147403,
  [SMALL_STATE(5257)] = 147446,
  [SMALL_STATE(5258)] = 147489,
  [SMALL_STATE(5259)] = 147532,
  [SMALL_STATE(5260)] = 147585,
  [SMALL_STATE(5261)] = 147640,
  [SMALL_STATE(5262)] = 147687,
  [SMALL_STATE(5263)] = 147742,
  [SMALL_STATE(5264)] = 147795,
  [SMALL_STATE(5265)] = 147850,
  [SMALL_STATE(5266)] = 147905,
  [SMALL_STATE(5267)] = 147960,
  [SMALL_STATE(5268)] = 148015,
  [SMALL_STATE(5269)] = 148056,
  [SMALL_STATE(5270)] = 148099,
  [SMALL_STATE(5271)] = 148140,
  [SMALL_STATE(5272)] = 148181,
  [SMALL_STATE(5273)] = 148222,
  [SMALL_STATE(5274)] = 148263,
  [SMALL_STATE(5275)] = 148318,
  [SMALL_STATE(5276)] = 148373,
  [SMALL_STATE(5277)] = 148414,
  [SMALL_STATE(5278)] = 148469,
  [SMALL_STATE(5279)] = 148510,
  [SMALL_STATE(5280)] = 148551,
  [SMALL_STATE(5281)] = 148606,
  [SMALL_STATE(5282)] = 148661,
  [SMALL_STATE(5283)] = 148716,
  [SMALL_STATE(5284)] = 148771,
  [SMALL_STATE(5285)] = 148812,
  [SMALL_STATE(5286)] = 148853,
  [SMALL_STATE(5287)] = 148908,
  [SMALL_STATE(5288)] = 148963,
  [SMALL_STATE(5289)] = 149004,
  [SMALL_STATE(5290)] = 149045,
  [SMALL_STATE(5291)] = 149086,
  [SMALL_STATE(5292)] = 149141,
  [SMALL_STATE(5293)] = 149182,
  [SMALL_STATE(5294)] = 149223,
  [SMALL_STATE(5295)] = 149264,
  [SMALL_STATE(5296)] = 149305,
  [SMALL_STATE(5297)] = 149346,
  [SMALL_STATE(5298)] = 149401,
  [SMALL_STATE(5299)] = 149442,
  [SMALL_STATE(5300)] = 149497,
  [SMALL_STATE(5301)] = 149552,
  [SMALL_STATE(5302)] = 149607,
  [SMALL_STATE(5303)] = 149662,
  [SMALL_STATE(5304)] = 149715,
  [SMALL_STATE(5305)] = 149770,
  [SMALL_STATE(5306)] = 149811,
  [SMALL_STATE(5307)] = 149854,
  [SMALL_STATE(5308)] = 149899,
  [SMALL_STATE(5309)] = 149940,
  [SMALL_STATE(5310)] = 149995,
  [SMALL_STATE(5311)] = 150050,
  [SMALL_STATE(5312)] = 150105,
  [SMALL_STATE(5313)] = 150160,
  [SMALL_STATE(5314)] = 150215,
  [SMALL_STATE(5315)] = 150270,
  [SMALL_STATE(5316)] = 150315,
  [SMALL_STATE(5317)] = 150356,
  [SMALL_STATE(5318)] = 150411,
  [SMALL_STATE(5319)] = 150456,
  [SMALL_STATE(5320)] = 150511,
  [SMALL_STATE(5321)] = 150566,
  [SMALL_STATE(5322)] = 150621,
  [SMALL_STATE(5323)] = 150676,
  [SMALL_STATE(5324)] = 150731,
  [SMALL_STATE(5325)] = 150772,
  [SMALL_STATE(5326)] = 150827,
  [SMALL_STATE(5327)] = 150868,
  [SMALL_STATE(5328)] = 150923,
  [SMALL_STATE(5329)] = 150978,
  [SMALL_STATE(5330)] = 151019,
  [SMALL_STATE(5331)] = 151060,
  [SMALL_STATE(5332)] = 151115,
  [SMALL_STATE(5333)] = 151156,
  [SMALL_STATE(5334)] = 151211,
  [SMALL_STATE(5335)] = 151252,
  [SMALL_STATE(5336)] = 151293,
  [SMALL_STATE(5337)] = 151334,
  [SMALL_STATE(5338)] = 151375,
  [SMALL_STATE(5339)] = 151430,
  [SMALL_STATE(5340)] = 151469,
  [SMALL_STATE(5341)] = 151524,
  [SMALL_STATE(5342)] = 151565,
  [SMALL_STATE(5343)] = 151606,
  [SMALL_STATE(5344)] = 151647,
  [SMALL_STATE(5345)] = 151688,
  [SMALL_STATE(5346)] = 151743,
  [SMALL_STATE(5347)] = 151790,
  [SMALL_STATE(5348)] = 151831,
  [SMALL_STATE(5349)] = 151886,
  [SMALL_STATE(5350)] = 151927,
  [SMALL_STATE(5351)] = 151968,
  [SMALL_STATE(5352)] = 152013,
  [SMALL_STATE(5353)] = 152054,
  [SMALL_STATE(5354)] = 152109,
  [SMALL_STATE(5355)] = 152150,
  [SMALL_STATE(5356)] = 152191,
  [SMALL_STATE(5357)] = 152238,
  [SMALL_STATE(5358)] = 152283,
  [SMALL_STATE(5359)] = 152326,
  [SMALL_STATE(5360)] = 152381,
  [SMALL_STATE(5361)] = 152436,
  [SMALL_STATE(5362)] = 152491,
  [SMALL_STATE(5363)] = 152546,
  [SMALL_STATE(5364)] = 152587,
  [SMALL_STATE(5365)] = 152628,
  [SMALL_STATE(5366)] = 152683,
  [SMALL_STATE(5367)] = 152724,
  [SMALL_STATE(5368)] = 152779,
  [SMALL_STATE(5369)] = 152834,
  [SMALL_STATE(5370)] = 152889,
  [SMALL_STATE(5371)] = 152930,
  [SMALL_STATE(5372)] = 152971,
  [SMALL_STATE(5373)] = 153018,
  [SMALL_STATE(5374)] = 153059,
  [SMALL_STATE(5375)] = 153098,
  [SMALL_STATE(5376)] = 153137,
  [SMALL_STATE(5377)] = 153192,
  [SMALL_STATE(5378)] = 153233,
  [SMALL_STATE(5379)] = 153288,
  [SMALL_STATE(5380)] = 153343,
  [SMALL_STATE(5381)] = 153386,
  [SMALL_STATE(5382)] = 153441,
  [SMALL_STATE(5383)] = 153496,
  [SMALL_STATE(5384)] = 153539,
  [SMALL_STATE(5385)] = 153594,
  [SMALL_STATE(5386)] = 153641,
  [SMALL_STATE(5387)] = 153684,
  [SMALL_STATE(5388)] = 153727,
  [SMALL_STATE(5389)] = 153782,
  [SMALL_STATE(5390)] = 153823,
  [SMALL_STATE(5391)] = 153878,
  [SMALL_STATE(5392)] = 153933,
  [SMALL_STATE(5393)] = 153988,
  [SMALL_STATE(5394)] = 154029,
  [SMALL_STATE(5395)] = 154072,
  [SMALL_STATE(5396)] = 154127,
  [SMALL_STATE(5397)] = 154168,
  [SMALL_STATE(5398)] = 154223,
  [SMALL_STATE(5399)] = 154264,
  [SMALL_STATE(5400)] = 154319,
  [SMALL_STATE(5401)] = 154360,
  [SMALL_STATE(5402)] = 154401,
  [SMALL_STATE(5403)] = 154456,
  [SMALL_STATE(5404)] = 154511,
  [SMALL_STATE(5405)] = 154566,
  [SMALL_STATE(5406)] = 154621,
  [SMALL_STATE(5407)] = 154676,
  [SMALL_STATE(5408)] = 154731,
  [SMALL_STATE(5409)] = 154772,
  [SMALL_STATE(5410)] = 154827,
  [SMALL_STATE(5411)] = 154882,
  [SMALL_STATE(5412)] = 154925,
  [SMALL_STATE(5413)] = 154980,
  [SMALL_STATE(5414)] = 155021,
  [SMALL_STATE(5415)] = 155062,
  [SMALL_STATE(5416)] = 155105,
  [SMALL_STATE(5417)] = 155160,
  [SMALL_STATE(5418)] = 155215,
  [SMALL_STATE(5419)] = 155270,
  [SMALL_STATE(5420)] = 155325,
  [SMALL_STATE(5421)] = 155380,
  [SMALL_STATE(5422)] = 155435,
  [SMALL_STATE(5423)] = 155475,
  [SMALL_STATE(5424)] = 155515,
  [SMALL_STATE(5425)] = 155567,
  [SMALL_STATE(5426)] = 155619,
  [SMALL_STATE(5427)] = 155671,
  [SMALL_STATE(5428)] = 155715,
  [SMALL_STATE(5429)] = 155767,
  [SMALL_STATE(5430)] = 155807,
  [SMALL_STATE(5431)] = 155857,
  [SMALL_STATE(5432)] = 155897,
  [SMALL_STATE(5433)] = 155949,
  [SMALL_STATE(5434)] = 155993,
  [SMALL_STATE(5435)] = 156033,
  [SMALL_STATE(5436)] = 156085,
  [SMALL_STATE(5437)] = 156125,
  [SMALL_STATE(5438)] = 156167,
  [SMALL_STATE(5439)] = 156219,
  [SMALL_STATE(5440)] = 156261,
  [SMALL_STATE(5441)] = 156313,
  [SMALL_STATE(5442)] = 156365,
  [SMALL_STATE(5443)] = 156407,
  [SMALL_STATE(5444)] = 156459,
  [SMALL_STATE(5445)] = 156511,
  [SMALL_STATE(5446)] = 156553,
  [SMALL_STATE(5447)] = 156593,
  [SMALL_STATE(5448)] = 156633,
  [SMALL_STATE(5449)] = 156675,
  [SMALL_STATE(5450)] = 156727,
  [SMALL_STATE(5451)] = 156767,
  [SMALL_STATE(5452)] = 156819,
  [SMALL_STATE(5453)] = 156859,
  [SMALL_STATE(5454)] = 156911,
  [SMALL_STATE(5455)] = 156951,
  [SMALL_STATE(5456)] = 156993,
  [SMALL_STATE(5457)] = 157035,
  [SMALL_STATE(5458)] = 157077,
  [SMALL_STATE(5459)] = 157129,
  [SMALL_STATE(5460)] = 157181,
  [SMALL_STATE(5461)] = 157221,
  [SMALL_STATE(5462)] = 157265,
  [SMALL_STATE(5463)] = 157305,
  [SMALL_STATE(5464)] = 157347,
  [SMALL_STATE(5465)] = 157399,
  [SMALL_STATE(5466)] = 157439,
  [SMALL_STATE(5467)] = 157481,
  [SMALL_STATE(5468)] = 157521,
  [SMALL_STATE(5469)] = 157561,
  [SMALL_STATE(5470)] = 157601,
  [SMALL_STATE(5471)] = 157651,
  [SMALL_STATE(5472)] = 157691,
  [SMALL_STATE(5473)] = 157731,
  [SMALL_STATE(5474)] = 157771,
  [SMALL_STATE(5475)] = 157811,
  [SMALL_STATE(5476)] = 157851,
  [SMALL_STATE(5477)] = 157891,
  [SMALL_STATE(5478)] = 157931,
  [SMALL_STATE(5479)] = 157971,
  [SMALL_STATE(5480)] = 158023,
  [SMALL_STATE(5481)] = 158063,
  [SMALL_STATE(5482)] = 158103,
  [SMALL_STATE(5483)] = 158155,
  [SMALL_STATE(5484)] = 158195,
  [SMALL_STATE(5485)] = 158235,
  [SMALL_STATE(5486)] = 158275,
  [SMALL_STATE(5487)] = 158315,
  [SMALL_STATE(5488)] = 158355,
  [SMALL_STATE(5489)] = 158395,
  [SMALL_STATE(5490)] = 158435,
  [SMALL_STATE(5491)] = 158475,
  [SMALL_STATE(5492)] = 158515,
  [SMALL_STATE(5493)] = 158555,
  [SMALL_STATE(5494)] = 158595,
  [SMALL_STATE(5495)] = 158635,
  [SMALL_STATE(5496)] = 158675,
  [SMALL_STATE(5497)] = 158715,
  [SMALL_STATE(5498)] = 158755,
  [SMALL_STATE(5499)] = 158795,
  [SMALL_STATE(5500)] = 158835,
  [SMALL_STATE(5501)] = 158875,
  [SMALL_STATE(5502)] = 158915,
  [SMALL_STATE(5503)] = 158965,
  [SMALL_STATE(5504)] = 159005,
  [SMALL_STATE(5505)] = 159045,
  [SMALL_STATE(5506)] = 159083,
  [SMALL_STATE(5507)] = 159135,
  [SMALL_STATE(5508)] = 159175,
  [SMALL_STATE(5509)] = 159227,
  [SMALL_STATE(5510)] = 159267,
  [SMALL_STATE(5511)] = 159305,
  [SMALL_STATE(5512)] = 159343,
  [SMALL_STATE(5513)] = 159382,
  [SMALL_STATE(5514)] = 159429,
  [SMALL_STATE(5515)] = 159478,
  [SMALL_STATE(5516)] = 159525,
  [SMALL_STATE(5517)] = 159564,
  [SMALL_STATE(5518)] = 159611,
  [SMALL_STATE(5519)] = 159660,
  [SMALL_STATE(5520)] = 159707,
  [SMALL_STATE(5521)] = 159746,
  [SMALL_STATE(5522)] = 159785,
  [SMALL_STATE(5523)] = 159824,
  [SMALL_STATE(5524)] = 159871,
  [SMALL_STATE(5525)] = 159918,
  [SMALL_STATE(5526)] = 159965,
  [SMALL_STATE(5527)] = 160012,
  [SMALL_STATE(5528)] = 160059,
  [SMALL_STATE(5529)] = 160108,
  [SMALL_STATE(5530)] = 160155,
  [SMALL_STATE(5531)] = 160192,
  [SMALL_STATE(5532)] = 160239,
  [SMALL_STATE(5533)] = 160288,
  [SMALL_STATE(5534)] = 160327,
  [SMALL_STATE(5535)] = 160366,
  [SMALL_STATE(5536)] = 160415,
  [SMALL_STATE(5537)] = 160454,
  [SMALL_STATE(5538)] = 160501,
  [SMALL_STATE(5539)] = 160550,
  [SMALL_STATE(5540)] = 160599,
  [SMALL_STATE(5541)] = 160648,
  [SMALL_STATE(5542)] = 160697,
  [SMALL_STATE(5543)] = 160746,
  [SMALL_STATE(5544)] = 160793,
  [SMALL_STATE(5545)] = 160840,
  [SMALL_STATE(5546)] = 160879,
  [SMALL_STATE(5547)] = 160926,
  [SMALL_STATE(5548)] = 160973,
  [SMALL_STATE(5549)] = 161022,
  [SMALL_STATE(5550)] = 161069,
  [SMALL_STATE(5551)] = 161116,
  [SMALL_STATE(5552)] = 161163,
  [SMALL_STATE(5553)] = 161210,
  [SMALL_STATE(5554)] = 161257,
  [SMALL_STATE(5555)] = 161306,
  [SMALL_STATE(5556)] = 161355,
  [SMALL_STATE(5557)] = 161404,
  [SMALL_STATE(5558)] = 161443,
  [SMALL_STATE(5559)] = 161482,
  [SMALL_STATE(5560)] = 161529,
  [SMALL_STATE(5561)] = 161578,
  [SMALL_STATE(5562)] = 161627,
  [SMALL_STATE(5563)] = 161674,
  [SMALL_STATE(5564)] = 161721,
  [SMALL_STATE(5565)] = 161758,
  [SMALL_STATE(5566)] = 161797,
  [SMALL_STATE(5567)] = 161836,
  [SMALL_STATE(5568)] = 161885,
  [SMALL_STATE(5569)] = 161922,
  [SMALL_STATE(5570)] = 161963,
  [SMALL_STATE(5571)] = 162005,
  [SMALL_STATE(5572)] = 162051,
  [SMALL_STATE(5573)] = 162087,
  [SMALL_STATE(5574)] = 162131,
  [SMALL_STATE(5575)] = 162167,
  [SMALL_STATE(5576)] = 162203,
  [SMALL_STATE(5577)] = 162249,
  [SMALL_STATE(5578)] = 162292,
  [SMALL_STATE(5579)] = 162335,
  [SMALL_STATE(5580)] = 162378,
  [SMALL_STATE(5581)] = 162419,
  [SMALL_STATE(5582)] = 162462,
  [SMALL_STATE(5583)] = 162505,
  [SMALL_STATE(5584)] = 162548,
  [SMALL_STATE(5585)] = 162589,
  [SMALL_STATE(5586)] = 162632,
  [SMALL_STATE(5587)] = 162673,
  [SMALL_STATE(5588)] = 162716,
  [SMALL_STATE(5589)] = 162757,
  [SMALL_STATE(5590)] = 162800,
  [SMALL_STATE(5591)] = 162841,
  [SMALL_STATE(5592)] = 162884,
  [SMALL_STATE(5593)] = 162927,
  [SMALL_STATE(5594)] = 162968,
  [SMALL_STATE(5595)] = 163011,
  [SMALL_STATE(5596)] = 163054,
  [SMALL_STATE(5597)] = 163097,
  [SMALL_STATE(5598)] = 163140,
  [SMALL_STATE(5599)] = 163183,
  [SMALL_STATE(5600)] = 163226,
  [SMALL_STATE(5601)] = 163269,
  [SMALL_STATE(5602)] = 163310,
  [SMALL_STATE(5603)] = 163353,
  [SMALL_STATE(5604)] = 163396,
  [SMALL_STATE(5605)] = 163439,
  [SMALL_STATE(5606)] = 163482,
  [SMALL_STATE(5607)] = 163525,
  [SMALL_STATE(5608)] = 163566,
  [SMALL_STATE(5609)] = 163607,
  [SMALL_STATE(5610)] = 163650,
  [SMALL_STATE(5611)] = 163693,
  [SMALL_STATE(5612)] = 163734,
  [SMALL_STATE(5613)] = 163777,
  [SMALL_STATE(5614)] = 163820,
  [SMALL_STATE(5615)] = 163863,
  [SMALL_STATE(5616)] = 163904,
  [SMALL_STATE(5617)] = 163947,
  [SMALL_STATE(5618)] = 163988,
  [SMALL_STATE(5619)] = 164031,
  [SMALL_STATE(5620)] = 164074,
  [SMALL_STATE(5621)] = 164117,
  [SMALL_STATE(5622)] = 164160,
  [SMALL_STATE(5623)] = 164203,
  [SMALL_STATE(5624)] = 164246,
  [SMALL_STATE(5625)] = 164289,
  [SMALL_STATE(5626)] = 164332,
  [SMALL_STATE(5627)] = 164373,
  [SMALL_STATE(5628)] = 164416,
  [SMALL_STATE(5629)] = 164459,
  [SMALL_STATE(5630)] = 164502,
  [SMALL_STATE(5631)] = 164543,
  [SMALL_STATE(5632)] = 164586,
  [SMALL_STATE(5633)] = 164629,
  [SMALL_STATE(5634)] = 164672,
  [SMALL_STATE(5635)] = 164715,
  [SMALL_STATE(5636)] = 164756,
  [SMALL_STATE(5637)] = 164799,
  [SMALL_STATE(5638)] = 164842,
  [SMALL_STATE(5639)] = 164885,
  [SMALL_STATE(5640)] = 164926,
  [SMALL_STATE(5641)] = 164969,
  [SMALL_STATE(5642)] = 165012,
  [SMALL_STATE(5643)] = 165055,
  [SMALL_STATE(5644)] = 165098,
  [SMALL_STATE(5645)] = 165141,
  [SMALL_STATE(5646)] = 165182,
  [SMALL_STATE(5647)] = 165225,
  [SMALL_STATE(5648)] = 165268,
  [SMALL_STATE(5649)] = 165311,
  [SMALL_STATE(5650)] = 165352,
  [SMALL_STATE(5651)] = 165395,
  [SMALL_STATE(5652)] = 165436,
  [SMALL_STATE(5653)] = 165477,
  [SMALL_STATE(5654)] = 165520,
  [SMALL_STATE(5655)] = 165563,
  [SMALL_STATE(5656)] = 165606,
  [SMALL_STATE(5657)] = 165649,
  [SMALL_STATE(5658)] = 165692,
  [SMALL_STATE(5659)] = 165733,
  [SMALL_STATE(5660)] = 165776,
  [SMALL_STATE(5661)] = 165819,
  [SMALL_STATE(5662)] = 165862,
  [SMALL_STATE(5663)] = 165905,
  [SMALL_STATE(5664)] = 165946,
  [SMALL_STATE(5665)] = 165989,
  [SMALL_STATE(5666)] = 166032,
  [SMALL_STATE(5667)] = 166075,
  [SMALL_STATE(5668)] = 166118,
  [SMALL_STATE(5669)] = 166161,
  [SMALL_STATE(5670)] = 166204,
  [SMALL_STATE(5671)] = 166247,
  [SMALL_STATE(5672)] = 166288,
  [SMALL_STATE(5673)] = 166329,
  [SMALL_STATE(5674)] = 166370,
  [SMALL_STATE(5675)] = 166413,
  [SMALL_STATE(5676)] = 166456,
  [SMALL_STATE(5677)] = 166499,
  [SMALL_STATE(5678)] = 166542,
  [SMALL_STATE(5679)] = 166585,
  [SMALL_STATE(5680)] = 166628,
  [SMALL_STATE(5681)] = 166671,
  [SMALL_STATE(5682)] = 166714,
  [SMALL_STATE(5683)] = 166757,
  [SMALL_STATE(5684)] = 166800,
  [SMALL_STATE(5685)] = 166843,
  [SMALL_STATE(5686)] = 166884,
  [SMALL_STATE(5687)] = 166925,
  [SMALL_STATE(5688)] = 166968,
  [SMALL_STATE(5689)] = 167011,
  [SMALL_STATE(5690)] = 167054,
  [SMALL_STATE(5691)] = 167095,
  [SMALL_STATE(5692)] = 167136,
  [SMALL_STATE(5693)] = 167179,
  [SMALL_STATE(5694)] = 167220,
  [SMALL_STATE(5695)] = 167261,
  [SMALL_STATE(5696)] = 167302,
  [SMALL_STATE(5697)] = 167343,
  [SMALL_STATE(5698)] = 167386,
  [SMALL_STATE(5699)] = 167429,
  [SMALL_STATE(5700)] = 167472,
  [SMALL_STATE(5701)] = 167515,
  [SMALL_STATE(5702)] = 167558,
  [SMALL_STATE(5703)] = 167599,
  [SMALL_STATE(5704)] = 167642,
  [SMALL_STATE(5705)] = 167685,
  [SMALL_STATE(5706)] = 167721,
  [SMALL_STATE(5707)] = 167761,
  [SMALL_STATE(5708)] = 167801,
  [SMALL_STATE(5709)] = 167841,
  [SMALL_STATE(5710)] = 167877,
  [SMALL_STATE(5711)] = 167913,
  [SMALL_STATE(5712)] = 167953,
  [SMALL_STATE(5713)] = 167993,
  [SMALL_STATE(5714)] = 168033,
  [SMALL_STATE(5715)] = 168071,
  [SMALL_STATE(5716)] = 168111,
  [SMALL_STATE(5717)] = 168151,
  [SMALL_STATE(5718)] = 168191,
  [SMALL_STATE(5719)] = 168231,
  [SMALL_STATE(5720)] = 168271,
  [SMALL_STATE(5721)] = 168311,
  [SMALL_STATE(5722)] = 168351,
  [SMALL_STATE(5723)] = 168391,
  [SMALL_STATE(5724)] = 168431,
  [SMALL_STATE(5725)] = 168471,
  [SMALL_STATE(5726)] = 168511,
  [SMALL_STATE(5727)] = 168551,
  [SMALL_STATE(5728)] = 168587,
  [SMALL_STATE(5729)] = 168627,
  [SMALL_STATE(5730)] = 168667,
  [SMALL_STATE(5731)] = 168701,
  [SMALL_STATE(5732)] = 168741,
  [SMALL_STATE(5733)] = 168781,
  [SMALL_STATE(5734)] = 168821,
  [SMALL_STATE(5735)] = 168859,
  [SMALL_STATE(5736)] = 168899,
  [SMALL_STATE(5737)] = 168936,
  [SMALL_STATE(5738)] = 168973,
  [SMALL_STATE(5739)] = 169010,
  [SMALL_STATE(5740)] = 169043,
  [SMALL_STATE(5741)] = 169080,
  [SMALL_STATE(5742)] = 169117,
  [SMALL_STATE(5743)] = 169150,
  [SMALL_STATE(5744)] = 169185,
  [SMALL_STATE(5745)] = 169222,
  [SMALL_STATE(5746)] = 169259,
  [SMALL_STATE(5747)] = 169296,
  [SMALL_STATE(5748)] = 169333,
  [SMALL_STATE(5749)] = 169370,
  [SMALL_STATE(5750)] = 169405,
  [SMALL_STATE(5751)] = 169440,
  [SMALL_STATE(5752)] = 169477,
  [SMALL_STATE(5753)] = 169514,
  [SMALL_STATE(5754)] = 169549,
  [SMALL_STATE(5755)] = 169586,
  [SMALL_STATE(5756)] = 169619,
  [SMALL_STATE(5757)] = 169656,
  [SMALL_STATE(5758)] = 169691,
  [SMALL_STATE(5759)] = 169726,
  [SMALL_STATE(5760)] = 169763,
  [SMALL_STATE(5761)] = 169796,
  [SMALL_STATE(5762)] = 169831,
  [SMALL_STATE(5763)] = 169864,
  [SMALL_STATE(5764)] = 169897,
  [SMALL_STATE(5765)] = 169932,
  [SMALL_STATE(5766)] = 169969,
  [SMALL_STATE(5767)] = 170002,
  [SMALL_STATE(5768)] = 170037,
  [SMALL_STATE(5769)] = 170072,
  [SMALL_STATE(5770)] = 170109,
  [SMALL_STATE(5771)] = 170146,
  [SMALL_STATE(5772)] = 170183,
  [SMALL_STATE(5773)] = 170220,
  [SMALL_STATE(5774)] = 170257,
  [SMALL_STATE(5775)] = 170292,
  [SMALL_STATE(5776)] = 170327,
  [SMALL_STATE(5777)] = 170364,
  [SMALL_STATE(5778)] = 170401,
  [SMALL_STATE(5779)] = 170436,
  [SMALL_STATE(5780)] = 170471,
  [SMALL_STATE(5781)] = 170508,
  [SMALL_STATE(5782)] = 170543,
  [SMALL_STATE(5783)] = 170580,
  [SMALL_STATE(5784)] = 170615,
  [SMALL_STATE(5785)] = 170652,
  [SMALL_STATE(5786)] = 170689,
  [SMALL_STATE(5787)] = 170726,
  [SMALL_STATE(5788)] = 170761,
  [SMALL_STATE(5789)] = 170798,
  [SMALL_STATE(5790)] = 170835,
  [SMALL_STATE(5791)] = 170872,
  [SMALL_STATE(5792)] = 170909,
  [SMALL_STATE(5793)] = 170946,
  [SMALL_STATE(5794)] = 170981,
  [SMALL_STATE(5795)] = 171018,
  [SMALL_STATE(5796)] = 171055,
  [SMALL_STATE(5797)] = 171092,
  [SMALL_STATE(5798)] = 171129,
  [SMALL_STATE(5799)] = 171166,
  [SMALL_STATE(5800)] = 171203,
  [SMALL_STATE(5801)] = 171236,
  [SMALL_STATE(5802)] = 171273,
  [SMALL_STATE(5803)] = 171310,
  [SMALL_STATE(5804)] = 171347,
  [SMALL_STATE(5805)] = 171382,
  [SMALL_STATE(5806)] = 171419,
  [SMALL_STATE(5807)] = 171456,
  [SMALL_STATE(5808)] = 171491,
  [SMALL_STATE(5809)] = 171526,
  [SMALL_STATE(5810)] = 171563,
  [SMALL_STATE(5811)] = 171600,
  [SMALL_STATE(5812)] = 171637,
  [SMALL_STATE(5813)] = 171672,
  [SMALL_STATE(5814)] = 171707,
  [SMALL_STATE(5815)] = 171744,
  [SMALL_STATE(5816)] = 171781,
  [SMALL_STATE(5817)] = 171818,
  [SMALL_STATE(5818)] = 171855,
  [SMALL_STATE(5819)] = 171892,
  [SMALL_STATE(5820)] = 171929,
  [SMALL_STATE(5821)] = 171966,
  [SMALL_STATE(5822)] = 172003,
  [SMALL_STATE(5823)] = 172036,
  [SMALL_STATE(5824)] = 172073,
  [SMALL_STATE(5825)] = 172108,
  [SMALL_STATE(5826)] = 172145,
  [SMALL_STATE(5827)] = 172182,
  [SMALL_STATE(5828)] = 172219,
  [SMALL_STATE(5829)] = 172252,
  [SMALL_STATE(5830)] = 172289,
  [SMALL_STATE(5831)] = 172326,
  [SMALL_STATE(5832)] = 172363,
  [SMALL_STATE(5833)] = 172398,
  [SMALL_STATE(5834)] = 172435,
  [SMALL_STATE(5835)] = 172472,
  [SMALL_STATE(5836)] = 172507,
  [SMALL_STATE(5837)] = 172542,
  [SMALL_STATE(5838)] = 172579,
  [SMALL_STATE(5839)] = 172616,
  [SMALL_STATE(5840)] = 172653,
  [SMALL_STATE(5841)] = 172690,
  [SMALL_STATE(5842)] = 172725,
  [SMALL_STATE(5843)] = 172760,
  [SMALL_STATE(5844)] = 172795,
  [SMALL_STATE(5845)] = 172832,
  [SMALL_STATE(5846)] = 172869,
  [SMALL_STATE(5847)] = 172906,
  [SMALL_STATE(5848)] = 172943,
  [SMALL_STATE(5849)] = 172980,
  [SMALL_STATE(5850)] = 173017,
  [SMALL_STATE(5851)] = 173054,
  [SMALL_STATE(5852)] = 173091,
  [SMALL_STATE(5853)] = 173126,
  [SMALL_STATE(5854)] = 173161,
  [SMALL_STATE(5855)] = 173198,
  [SMALL_STATE(5856)] = 173235,
  [SMALL_STATE(5857)] = 173272,
  [SMALL_STATE(5858)] = 173309,
  [SMALL_STATE(5859)] = 173346,
  [SMALL_STATE(5860)] = 173383,
  [SMALL_STATE(5861)] = 173420,
  [SMALL_STATE(5862)] = 173457,
  [SMALL_STATE(5863)] = 173494,
  [SMALL_STATE(5864)] = 173529,
  [SMALL_STATE(5865)] = 173566,
  [SMALL_STATE(5866)] = 173601,
  [SMALL_STATE(5867)] = 173638,
  [SMALL_STATE(5868)] = 173675,
  [SMALL_STATE(5869)] = 173712,
  [SMALL_STATE(5870)] = 173749,
  [SMALL_STATE(5871)] = 173784,
  [SMALL_STATE(5872)] = 173821,
  [SMALL_STATE(5873)] = 173856,
  [SMALL_STATE(5874)] = 173889,
  [SMALL_STATE(5875)] = 173924,
  [SMALL_STATE(5876)] = 173959,
  [SMALL_STATE(5877)] = 173996,
  [SMALL_STATE(5878)] = 174033,
  [SMALL_STATE(5879)] = 174070,
  [SMALL_STATE(5880)] = 174107,
  [SMALL_STATE(5881)] = 174144,
  [SMALL_STATE(5882)] = 174181,
  [SMALL_STATE(5883)] = 174218,
  [SMALL_STATE(5884)] = 174253,
  [SMALL_STATE(5885)] = 174290,
  [SMALL_STATE(5886)] = 174327,
  [SMALL_STATE(5887)] = 174364,
  [SMALL_STATE(5888)] = 174399,
  [SMALL_STATE(5889)] = 174434,
  [SMALL_STATE(5890)] = 174471,
  [SMALL_STATE(5891)] = 174508,
  [SMALL_STATE(5892)] = 174543,
  [SMALL_STATE(5893)] = 174578,
  [SMALL_STATE(5894)] = 174615,
  [SMALL_STATE(5895)] = 174650,
  [SMALL_STATE(5896)] = 174687,
  [SMALL_STATE(5897)] = 174720,
  [SMALL_STATE(5898)] = 174757,
  [SMALL_STATE(5899)] = 174790,
  [SMALL_STATE(5900)] = 174827,
  [SMALL_STATE(5901)] = 174864,
  [SMALL_STATE(5902)] = 174901,
  [SMALL_STATE(5903)] = 174934,
  [SMALL_STATE(5904)] = 174969,
  [SMALL_STATE(5905)] = 175006,
  [SMALL_STATE(5906)] = 175041,
  [SMALL_STATE(5907)] = 175078,
  [SMALL_STATE(5908)] = 175115,
  [SMALL_STATE(5909)] = 175152,
  [SMALL_STATE(5910)] = 175185,
  [SMALL_STATE(5911)] = 175222,
  [SMALL_STATE(5912)] = 175257,
  [SMALL_STATE(5913)] = 175294,
  [SMALL_STATE(5914)] = 175331,
  [SMALL_STATE(5915)] = 175368,
  [SMALL_STATE(5916)] = 175405,
  [SMALL_STATE(5917)] = 175442,
  [SMALL_STATE(5918)] = 175479,
  [SMALL_STATE(5919)] = 175516,
  [SMALL_STATE(5920)] = 175553,
  [SMALL_STATE(5921)] = 175588,
  [SMALL_STATE(5922)] = 175625,
  [SMALL_STATE(5923)] = 175662,
  [SMALL_STATE(5924)] = 175697,
  [SMALL_STATE(5925)] = 175734,
  [SMALL_STATE(5926)] = 175771,
  [SMALL_STATE(5927)] = 175808,
  [SMALL_STATE(5928)] = 175845,
  [SMALL_STATE(5929)] = 175882,
  [SMALL_STATE(5930)] = 175919,
  [SMALL_STATE(5931)] = 175956,
  [SMALL_STATE(5932)] = 175993,
  [SMALL_STATE(5933)] = 176030,
  [SMALL_STATE(5934)] = 176065,
  [SMALL_STATE(5935)] = 176100,
  [SMALL_STATE(5936)] = 176135,
  [SMALL_STATE(5937)] = 176172,
  [SMALL_STATE(5938)] = 176209,
  [SMALL_STATE(5939)] = 176246,
  [SMALL_STATE(5940)] = 176283,
  [SMALL_STATE(5941)] = 176318,
  [SMALL_STATE(5942)] = 176355,
  [SMALL_STATE(5943)] = 176392,
  [SMALL_STATE(5944)] = 176429,
  [SMALL_STATE(5945)] = 176466,
  [SMALL_STATE(5946)] = 176503,
  [SMALL_STATE(5947)] = 176538,
  [SMALL_STATE(5948)] = 176575,
  [SMALL_STATE(5949)] = 176612,
  [SMALL_STATE(5950)] = 176649,
  [SMALL_STATE(5951)] = 176684,
  [SMALL_STATE(5952)] = 176721,
  [SMALL_STATE(5953)] = 176758,
  [SMALL_STATE(5954)] = 176795,
  [SMALL_STATE(5955)] = 176832,
  [SMALL_STATE(5956)] = 176869,
  [SMALL_STATE(5957)] = 176906,
  [SMALL_STATE(5958)] = 176943,
  [SMALL_STATE(5959)] = 176980,
  [SMALL_STATE(5960)] = 177015,
  [SMALL_STATE(5961)] = 177050,
  [SMALL_STATE(5962)] = 177085,
  [SMALL_STATE(5963)] = 177122,
  [SMALL_STATE(5964)] = 177159,
  [SMALL_STATE(5965)] = 177196,
  [SMALL_STATE(5966)] = 177233,
  [SMALL_STATE(5967)] = 177270,
  [SMALL_STATE(5968)] = 177307,
  [SMALL_STATE(5969)] = 177344,
  [SMALL_STATE(5970)] = 177379,
  [SMALL_STATE(5971)] = 177412,
  [SMALL_STATE(5972)] = 177447,
  [SMALL_STATE(5973)] = 177484,
  [SMALL_STATE(5974)] = 177519,
  [SMALL_STATE(5975)] = 177556,
  [SMALL_STATE(5976)] = 177593,
  [SMALL_STATE(5977)] = 177626,
  [SMALL_STATE(5978)] = 177661,
  [SMALL_STATE(5979)] = 177698,
  [SMALL_STATE(5980)] = 177733,
  [SMALL_STATE(5981)] = 177768,
  [SMALL_STATE(5982)] = 177805,
  [SMALL_STATE(5983)] = 177842,
  [SMALL_STATE(5984)] = 177879,
  [SMALL_STATE(5985)] = 177914,
  [SMALL_STATE(5986)] = 177949,
  [SMALL_STATE(5987)] = 177984,
  [SMALL_STATE(5988)] = 178021,
  [SMALL_STATE(5989)] = 178058,
  [SMALL_STATE(5990)] = 178095,
  [SMALL_STATE(5991)] = 178132,
  [SMALL_STATE(5992)] = 178169,
  [SMALL_STATE(5993)] = 178204,
  [SMALL_STATE(5994)] = 178241,
  [SMALL_STATE(5995)] = 178276,
  [SMALL_STATE(5996)] = 178313,
  [SMALL_STATE(5997)] = 178350,
  [SMALL_STATE(5998)] = 178385,
  [SMALL_STATE(5999)] = 178422,
  [SMALL_STATE(6000)] = 178459,
  [SMALL_STATE(6001)] = 178496,
  [SMALL_STATE(6002)] = 178530,
  [SMALL_STATE(6003)] = 178564,
  [SMALL_STATE(6004)] = 178598,
  [SMALL_STATE(6005)] = 178632,
  [SMALL_STATE(6006)] = 178664,
  [SMALL_STATE(6007)] = 178698,
  [SMALL_STATE(6008)] = 178732,
  [SMALL_STATE(6009)] = 178766,
  [SMALL_STATE(6010)] = 178800,
  [SMALL_STATE(6011)] = 178834,
  [SMALL_STATE(6012)] = 178868,
  [SMALL_STATE(6013)] = 178902,
  [SMALL_STATE(6014)] = 178936,
  [SMALL_STATE(6015)] = 178970,
  [SMALL_STATE(6016)] = 179004,
  [SMALL_STATE(6017)] = 179038,
  [SMALL_STATE(6018)] = 179072,
  [SMALL_STATE(6019)] = 179106,
  [SMALL_STATE(6020)] = 179140,
  [SMALL_STATE(6021)] = 179174,
  [SMALL_STATE(6022)] = 179208,
  [SMALL_STATE(6023)] = 179242,
  [SMALL_STATE(6024)] = 179276,
  [SMALL_STATE(6025)] = 179310,
  [SMALL_STATE(6026)] = 179344,
  [SMALL_STATE(6027)] = 179378,
  [SMALL_STATE(6028)] = 179412,
  [SMALL_STATE(6029)] = 179446,
  [SMALL_STATE(6030)] = 179478,
  [SMALL_STATE(6031)] = 179512,
  [SMALL_STATE(6032)] = 179546,
  [SMALL_STATE(6033)] = 179580,
  [SMALL_STATE(6034)] = 179614,
  [SMALL_STATE(6035)] = 179646,
  [SMALL_STATE(6036)] = 179680,
  [SMALL_STATE(6037)] = 179714,
  [SMALL_STATE(6038)] = 179748,
  [SMALL_STATE(6039)] = 179782,
  [SMALL_STATE(6040)] = 179816,
  [SMALL_STATE(6041)] = 179850,
  [SMALL_STATE(6042)] = 179884,
  [SMALL_STATE(6043)] = 179918,
  [SMALL_STATE(6044)] = 179950,
  [SMALL_STATE(6045)] = 179984,
  [SMALL_STATE(6046)] = 180018,
  [SMALL_STATE(6047)] = 180052,
  [SMALL_STATE(6048)] = 180086,
  [SMALL_STATE(6049)] = 180120,
  [SMALL_STATE(6050)] = 180154,
  [SMALL_STATE(6051)] = 180188,
  [SMALL_STATE(6052)] = 180222,
  [SMALL_STATE(6053)] = 180256,
  [SMALL_STATE(6054)] = 180290,
  [SMALL_STATE(6055)] = 180324,
  [SMALL_STATE(6056)] = 180358,
  [SMALL_STATE(6057)] = 180392,
  [SMALL_STATE(6058)] = 180426,
  [SMALL_STATE(6059)] = 180460,
  [SMALL_STATE(6060)] = 180492,
  [SMALL_STATE(6061)] = 180526,
  [SMALL_STATE(6062)] = 180560,
  [SMALL_STATE(6063)] = 180594,
  [SMALL_STATE(6064)] = 180628,
  [SMALL_STATE(6065)] = 180662,
  [SMALL_STATE(6066)] = 180696,
  [SMALL_STATE(6067)] = 180730,
  [SMALL_STATE(6068)] = 180764,
  [SMALL_STATE(6069)] = 180798,
  [SMALL_STATE(6070)] = 180832,
  [SMALL_STATE(6071)] = 180866,
  [SMALL_STATE(6072)] = 180900,
  [SMALL_STATE(6073)] = 180934,
  [SMALL_STATE(6074)] = 180968,
  [SMALL_STATE(6075)] = 181002,
  [SMALL_STATE(6076)] = 181036,
  [SMALL_STATE(6077)] = 181070,
  [SMALL_STATE(6078)] = 181102,
  [SMALL_STATE(6079)] = 181136,
  [SMALL_STATE(6080)] = 181168,
  [SMALL_STATE(6081)] = 181202,
  [SMALL_STATE(6082)] = 181236,
  [SMALL_STATE(6083)] = 181270,
  [SMALL_STATE(6084)] = 181304,
  [SMALL_STATE(6085)] = 181338,
  [SMALL_STATE(6086)] = 181372,
  [SMALL_STATE(6087)] = 181406,
  [SMALL_STATE(6088)] = 181438,
  [SMALL_STATE(6089)] = 181472,
  [SMALL_STATE(6090)] = 181506,
  [SMALL_STATE(6091)] = 181540,
  [SMALL_STATE(6092)] = 181574,
  [SMALL_STATE(6093)] = 181608,
  [SMALL_STATE(6094)] = 181642,
  [SMALL_STATE(6095)] = 181676,
  [SMALL_STATE(6096)] = 181710,
  [SMALL_STATE(6097)] = 181744,
  [SMALL_STATE(6098)] = 181778,
  [SMALL_STATE(6099)] = 181812,
  [SMALL_STATE(6100)] = 181846,
  [SMALL_STATE(6101)] = 181880,
  [SMALL_STATE(6102)] = 181914,
  [SMALL_STATE(6103)] = 181946,
  [SMALL_STATE(6104)] = 181980,
  [SMALL_STATE(6105)] = 182014,
  [SMALL_STATE(6106)] = 182048,
  [SMALL_STATE(6107)] = 182082,
  [SMALL_STATE(6108)] = 182114,
  [SMALL_STATE(6109)] = 182148,
  [SMALL_STATE(6110)] = 182182,
  [SMALL_STATE(6111)] = 182216,
  [SMALL_STATE(6112)] = 182250,
  [SMALL_STATE(6113)] = 182282,
  [SMALL_STATE(6114)] = 182316,
  [SMALL_STATE(6115)] = 182350,
  [SMALL_STATE(6116)] = 182382,
  [SMALL_STATE(6117)] = 182416,
  [SMALL_STATE(6118)] = 182450,
  [SMALL_STATE(6119)] = 182484,
  [SMALL_STATE(6120)] = 182518,
  [SMALL_STATE(6121)] = 182552,
  [SMALL_STATE(6122)] = 182586,
  [SMALL_STATE(6123)] = 182620,
  [SMALL_STATE(6124)] = 182654,
  [SMALL_STATE(6125)] = 182688,
  [SMALL_STATE(6126)] = 182722,
  [SMALL_STATE(6127)] = 182756,
  [SMALL_STATE(6128)] = 182790,
  [SMALL_STATE(6129)] = 182824,
  [SMALL_STATE(6130)] = 182858,
  [SMALL_STATE(6131)] = 182892,
  [SMALL_STATE(6132)] = 182926,
  [SMALL_STATE(6133)] = 182960,
  [SMALL_STATE(6134)] = 182994,
  [SMALL_STATE(6135)] = 183028,
  [SMALL_STATE(6136)] = 183062,
  [SMALL_STATE(6137)] = 183096,
  [SMALL_STATE(6138)] = 183130,
  [SMALL_STATE(6139)] = 183164,
  [SMALL_STATE(6140)] = 183198,
  [SMALL_STATE(6141)] = 183232,
  [SMALL_STATE(6142)] = 183266,
  [SMALL_STATE(6143)] = 183300,
  [SMALL_STATE(6144)] = 183332,
  [SMALL_STATE(6145)] = 183364,
  [SMALL_STATE(6146)] = 183398,
  [SMALL_STATE(6147)] = 183432,
  [SMALL_STATE(6148)] = 183466,
  [SMALL_STATE(6149)] = 183498,
  [SMALL_STATE(6150)] = 183530,
  [SMALL_STATE(6151)] = 183564,
  [SMALL_STATE(6152)] = 183598,
  [SMALL_STATE(6153)] = 183632,
  [SMALL_STATE(6154)] = 183666,
  [SMALL_STATE(6155)] = 183698,
  [SMALL_STATE(6156)] = 183732,
  [SMALL_STATE(6157)] = 183766,
  [SMALL_STATE(6158)] = 183800,
  [SMALL_STATE(6159)] = 183834,
  [SMALL_STATE(6160)] = 183868,
  [SMALL_STATE(6161)] = 183902,
  [SMALL_STATE(6162)] = 183936,
  [SMALL_STATE(6163)] = 183970,
  [SMALL_STATE(6164)] = 184004,
  [SMALL_STATE(6165)] = 184038,
  [SMALL_STATE(6166)] = 184072,
  [SMALL_STATE(6167)] = 184106,
  [SMALL_STATE(6168)] = 184140,
  [SMALL_STATE(6169)] = 184174,
  [SMALL_STATE(6170)] = 184208,
  [SMALL_STATE(6171)] = 184242,
  [SMALL_STATE(6172)] = 184276,
  [SMALL_STATE(6173)] = 184310,
  [SMALL_STATE(6174)] = 184344,
  [SMALL_STATE(6175)] = 184378,
  [SMALL_STATE(6176)] = 184412,
  [SMALL_STATE(6177)] = 184446,
  [SMALL_STATE(6178)] = 184480,
  [SMALL_STATE(6179)] = 184514,
  [SMALL_STATE(6180)] = 184548,
  [SMALL_STATE(6181)] = 184582,
  [SMALL_STATE(6182)] = 184616,
  [SMALL_STATE(6183)] = 184650,
  [SMALL_STATE(6184)] = 184684,
  [SMALL_STATE(6185)] = 184718,
  [SMALL_STATE(6186)] = 184750,
  [SMALL_STATE(6187)] = 184784,
  [SMALL_STATE(6188)] = 184818,
  [SMALL_STATE(6189)] = 184852,
  [SMALL_STATE(6190)] = 184886,
  [SMALL_STATE(6191)] = 184920,
  [SMALL_STATE(6192)] = 184954,
  [SMALL_STATE(6193)] = 184988,
  [SMALL_STATE(6194)] = 185022,
  [SMALL_STATE(6195)] = 185056,
  [SMALL_STATE(6196)] = 185090,
  [SMALL_STATE(6197)] = 185124,
  [SMALL_STATE(6198)] = 185158,
  [SMALL_STATE(6199)] = 185192,
  [SMALL_STATE(6200)] = 185226,
  [SMALL_STATE(6201)] = 185260,
  [SMALL_STATE(6202)] = 185294,
  [SMALL_STATE(6203)] = 185328,
  [SMALL_STATE(6204)] = 185360,
  [SMALL_STATE(6205)] = 185394,
  [SMALL_STATE(6206)] = 185428,
  [SMALL_STATE(6207)] = 185462,
  [SMALL_STATE(6208)] = 185496,
  [SMALL_STATE(6209)] = 185530,
  [SMALL_STATE(6210)] = 185564,
  [SMALL_STATE(6211)] = 185598,
  [SMALL_STATE(6212)] = 185632,
  [SMALL_STATE(6213)] = 185666,
  [SMALL_STATE(6214)] = 185700,
  [SMALL_STATE(6215)] = 185734,
  [SMALL_STATE(6216)] = 185768,
  [SMALL_STATE(6217)] = 185800,
  [SMALL_STATE(6218)] = 185834,
  [SMALL_STATE(6219)] = 185868,
  [SMALL_STATE(6220)] = 185902,
  [SMALL_STATE(6221)] = 185936,
  [SMALL_STATE(6222)] = 185970,
  [SMALL_STATE(6223)] = 186004,
  [SMALL_STATE(6224)] = 186038,
  [SMALL_STATE(6225)] = 186072,
  [SMALL_STATE(6226)] = 186106,
  [SMALL_STATE(6227)] = 186140,
  [SMALL_STATE(6228)] = 186174,
  [SMALL_STATE(6229)] = 186208,
  [SMALL_STATE(6230)] = 186242,
  [SMALL_STATE(6231)] = 186276,
  [SMALL_STATE(6232)] = 186310,
  [SMALL_STATE(6233)] = 186342,
  [SMALL_STATE(6234)] = 186376,
  [SMALL_STATE(6235)] = 186410,
  [SMALL_STATE(6236)] = 186442,
  [SMALL_STATE(6237)] = 186476,
  [SMALL_STATE(6238)] = 186510,
  [SMALL_STATE(6239)] = 186544,
  [SMALL_STATE(6240)] = 186578,
  [SMALL_STATE(6241)] = 186612,
  [SMALL_STATE(6242)] = 186646,
  [SMALL_STATE(6243)] = 186680,
  [SMALL_STATE(6244)] = 186714,
  [SMALL_STATE(6245)] = 186748,
  [SMALL_STATE(6246)] = 186782,
  [SMALL_STATE(6247)] = 186816,
  [SMALL_STATE(6248)] = 186850,
  [SMALL_STATE(6249)] = 186884,
  [SMALL_STATE(6250)] = 186918,
  [SMALL_STATE(6251)] = 186952,
  [SMALL_STATE(6252)] = 186986,
  [SMALL_STATE(6253)] = 187020,
  [SMALL_STATE(6254)] = 187054,
  [SMALL_STATE(6255)] = 187088,
  [SMALL_STATE(6256)] = 187122,
  [SMALL_STATE(6257)] = 187156,
  [SMALL_STATE(6258)] = 187190,
  [SMALL_STATE(6259)] = 187224,
  [SMALL_STATE(6260)] = 187258,
  [SMALL_STATE(6261)] = 187292,
  [SMALL_STATE(6262)] = 187326,
  [SMALL_STATE(6263)] = 187360,
  [SMALL_STATE(6264)] = 187394,
  [SMALL_STATE(6265)] = 187428,
  [SMALL_STATE(6266)] = 187462,
  [SMALL_STATE(6267)] = 187496,
  [SMALL_STATE(6268)] = 187530,
  [SMALL_STATE(6269)] = 187564,
  [SMALL_STATE(6270)] = 187598,
  [SMALL_STATE(6271)] = 187630,
  [SMALL_STATE(6272)] = 187664,
  [SMALL_STATE(6273)] = 187698,
  [SMALL_STATE(6274)] = 187732,
  [SMALL_STATE(6275)] = 187766,
  [SMALL_STATE(6276)] = 187798,
  [SMALL_STATE(6277)] = 187832,
  [SMALL_STATE(6278)] = 187866,
  [SMALL_STATE(6279)] = 187900,
  [SMALL_STATE(6280)] = 187934,
  [SMALL_STATE(6281)] = 187968,
  [SMALL_STATE(6282)] = 188002,
  [SMALL_STATE(6283)] = 188036,
  [SMALL_STATE(6284)] = 188070,
  [SMALL_STATE(6285)] = 188102,
  [SMALL_STATE(6286)] = 188136,
  [SMALL_STATE(6287)] = 188170,
  [SMALL_STATE(6288)] = 188204,
  [SMALL_STATE(6289)] = 188238,
  [SMALL_STATE(6290)] = 188272,
  [SMALL_STATE(6291)] = 188306,
  [SMALL_STATE(6292)] = 188340,
  [SMALL_STATE(6293)] = 188374,
  [SMALL_STATE(6294)] = 188408,
  [SMALL_STATE(6295)] = 188442,
  [SMALL_STATE(6296)] = 188474,
  [SMALL_STATE(6297)] = 188508,
  [SMALL_STATE(6298)] = 188542,
  [SMALL_STATE(6299)] = 188576,
  [SMALL_STATE(6300)] = 188610,
  [SMALL_STATE(6301)] = 188644,
  [SMALL_STATE(6302)] = 188678,
  [SMALL_STATE(6303)] = 188712,
  [SMALL_STATE(6304)] = 188746,
  [SMALL_STATE(6305)] = 188780,
  [SMALL_STATE(6306)] = 188814,
  [SMALL_STATE(6307)] = 188848,
  [SMALL_STATE(6308)] = 188882,
  [SMALL_STATE(6309)] = 188916,
  [SMALL_STATE(6310)] = 188950,
  [SMALL_STATE(6311)] = 188984,
  [SMALL_STATE(6312)] = 189018,
  [SMALL_STATE(6313)] = 189052,
  [SMALL_STATE(6314)] = 189086,
  [SMALL_STATE(6315)] = 189120,
  [SMALL_STATE(6316)] = 189154,
  [SMALL_STATE(6317)] = 189188,
  [SMALL_STATE(6318)] = 189220,
  [SMALL_STATE(6319)] = 189254,
  [SMALL_STATE(6320)] = 189288,
  [SMALL_STATE(6321)] = 189322,
  [SMALL_STATE(6322)] = 189356,
  [SMALL_STATE(6323)] = 189390,
  [SMALL_STATE(6324)] = 189424,
  [SMALL_STATE(6325)] = 189458,
  [SMALL_STATE(6326)] = 189492,
  [SMALL_STATE(6327)] = 189526,
  [SMALL_STATE(6328)] = 189560,
  [SMALL_STATE(6329)] = 189592,
  [SMALL_STATE(6330)] = 189626,
  [SMALL_STATE(6331)] = 189660,
  [SMALL_STATE(6332)] = 189694,
  [SMALL_STATE(6333)] = 189728,
  [SMALL_STATE(6334)] = 189762,
  [SMALL_STATE(6335)] = 189796,
  [SMALL_STATE(6336)] = 189830,
  [SMALL_STATE(6337)] = 189864,
  [SMALL_STATE(6338)] = 189898,
  [SMALL_STATE(6339)] = 189932,
  [SMALL_STATE(6340)] = 189966,
  [SMALL_STATE(6341)] = 189998,
  [SMALL_STATE(6342)] = 190032,
  [SMALL_STATE(6343)] = 190066,
  [SMALL_STATE(6344)] = 190100,
  [SMALL_STATE(6345)] = 190134,
  [SMALL_STATE(6346)] = 190168,
  [SMALL_STATE(6347)] = 190202,
  [SMALL_STATE(6348)] = 190236,
  [SMALL_STATE(6349)] = 190270,
  [SMALL_STATE(6350)] = 190302,
  [SMALL_STATE(6351)] = 190334,
  [SMALL_STATE(6352)] = 190368,
  [SMALL_STATE(6353)] = 190402,
  [SMALL_STATE(6354)] = 190436,
  [SMALL_STATE(6355)] = 190470,
  [SMALL_STATE(6356)] = 190504,
  [SMALL_STATE(6357)] = 190536,
  [SMALL_STATE(6358)] = 190568,
  [SMALL_STATE(6359)] = 190602,
  [SMALL_STATE(6360)] = 190636,
  [SMALL_STATE(6361)] = 190670,
  [SMALL_STATE(6362)] = 190704,
  [SMALL_STATE(6363)] = 190738,
  [SMALL_STATE(6364)] = 190772,
  [SMALL_STATE(6365)] = 190804,
  [SMALL_STATE(6366)] = 190838,
  [SMALL_STATE(6367)] = 190870,
  [SMALL_STATE(6368)] = 190904,
  [SMALL_STATE(6369)] = 190938,
  [SMALL_STATE(6370)] = 190972,
  [SMALL_STATE(6371)] = 191006,
  [SMALL_STATE(6372)] = 191040,
  [SMALL_STATE(6373)] = 191074,
  [SMALL_STATE(6374)] = 191108,
  [SMALL_STATE(6375)] = 191142,
  [SMALL_STATE(6376)] = 191176,
  [SMALL_STATE(6377)] = 191210,
  [SMALL_STATE(6378)] = 191244,
  [SMALL_STATE(6379)] = 191278,
  [SMALL_STATE(6380)] = 191312,
  [SMALL_STATE(6381)] = 191346,
  [SMALL_STATE(6382)] = 191378,
  [SMALL_STATE(6383)] = 191412,
  [SMALL_STATE(6384)] = 191446,
  [SMALL_STATE(6385)] = 191480,
  [SMALL_STATE(6386)] = 191514,
  [SMALL_STATE(6387)] = 191548,
  [SMALL_STATE(6388)] = 191580,
  [SMALL_STATE(6389)] = 191614,
  [SMALL_STATE(6390)] = 191648,
  [SMALL_STATE(6391)] = 191682,
  [SMALL_STATE(6392)] = 191714,
  [SMALL_STATE(6393)] = 191746,
  [SMALL_STATE(6394)] = 191778,
  [SMALL_STATE(6395)] = 191812,
  [SMALL_STATE(6396)] = 191844,
  [SMALL_STATE(6397)] = 191878,
  [SMALL_STATE(6398)] = 191912,
  [SMALL_STATE(6399)] = 191943,
  [SMALL_STATE(6400)] = 191974,
  [SMALL_STATE(6401)] = 192005,
  [SMALL_STATE(6402)] = 192036,
  [SMALL_STATE(6403)] = 192067,
  [SMALL_STATE(6404)] = 192098,
  [SMALL_STATE(6405)] = 192129,
  [SMALL_STATE(6406)] = 192160,
  [SMALL_STATE(6407)] = 192191,
  [SMALL_STATE(6408)] = 192222,
  [SMALL_STATE(6409)] = 192253,
  [SMALL_STATE(6410)] = 192284,
  [SMALL_STATE(6411)] = 192315,
  [SMALL_STATE(6412)] = 192346,
  [SMALL_STATE(6413)] = 192377,
  [SMALL_STATE(6414)] = 192408,
  [SMALL_STATE(6415)] = 192439,
  [SMALL_STATE(6416)] = 192470,
  [SMALL_STATE(6417)] = 192501,
  [SMALL_STATE(6418)] = 192532,
  [SMALL_STATE(6419)] = 192563,
  [SMALL_STATE(6420)] = 192594,
  [SMALL_STATE(6421)] = 192625,
  [SMALL_STATE(6422)] = 192656,
  [SMALL_STATE(6423)] = 192687,
  [SMALL_STATE(6424)] = 192718,
  [SMALL_STATE(6425)] = 192749,
  [SMALL_STATE(6426)] = 192780,
  [SMALL_STATE(6427)] = 192811,
  [SMALL_STATE(6428)] = 192842,
  [SMALL_STATE(6429)] = 192873,
  [SMALL_STATE(6430)] = 192904,
  [SMALL_STATE(6431)] = 192935,
  [SMALL_STATE(6432)] = 192966,
  [SMALL_STATE(6433)] = 192997,
  [SMALL_STATE(6434)] = 193028,
  [SMALL_STATE(6435)] = 193059,
  [SMALL_STATE(6436)] = 193090,
  [SMALL_STATE(6437)] = 193121,
  [SMALL_STATE(6438)] = 193152,
  [SMALL_STATE(6439)] = 193183,
  [SMALL_STATE(6440)] = 193214,
  [SMALL_STATE(6441)] = 193245,
  [SMALL_STATE(6442)] = 193276,
  [SMALL_STATE(6443)] = 193307,
  [SMALL_STATE(6444)] = 193338,
  [SMALL_STATE(6445)] = 193369,
  [SMALL_STATE(6446)] = 193400,
  [SMALL_STATE(6447)] = 193431,
  [SMALL_STATE(6448)] = 193462,
  [SMALL_STATE(6449)] = 193493,
  [SMALL_STATE(6450)] = 193524,
  [SMALL_STATE(6451)] = 193555,
  [SMALL_STATE(6452)] = 193586,
  [SMALL_STATE(6453)] = 193617,
  [SMALL_STATE(6454)] = 193648,
  [SMALL_STATE(6455)] = 193679,
  [SMALL_STATE(6456)] = 193710,
  [SMALL_STATE(6457)] = 193741,
  [SMALL_STATE(6458)] = 193772,
  [SMALL_STATE(6459)] = 193803,
  [SMALL_STATE(6460)] = 193834,
  [SMALL_STATE(6461)] = 193865,
  [SMALL_STATE(6462)] = 193896,
  [SMALL_STATE(6463)] = 193927,
  [SMALL_STATE(6464)] = 193958,
  [SMALL_STATE(6465)] = 193989,
  [SMALL_STATE(6466)] = 194020,
  [SMALL_STATE(6467)] = 194051,
  [SMALL_STATE(6468)] = 194082,
  [SMALL_STATE(6469)] = 194113,
  [SMALL_STATE(6470)] = 194144,
  [SMALL_STATE(6471)] = 194175,
  [SMALL_STATE(6472)] = 194206,
  [SMALL_STATE(6473)] = 194237,
  [SMALL_STATE(6474)] = 194268,
  [SMALL_STATE(6475)] = 194299,
  [SMALL_STATE(6476)] = 194330,
  [SMALL_STATE(6477)] = 194361,
  [SMALL_STATE(6478)] = 194392,
  [SMALL_STATE(6479)] = 194423,
  [SMALL_STATE(6480)] = 194454,
  [SMALL_STATE(6481)] = 194485,
  [SMALL_STATE(6482)] = 194516,
  [SMALL_STATE(6483)] = 194547,
  [SMALL_STATE(6484)] = 194578,
  [SMALL_STATE(6485)] = 194609,
  [SMALL_STATE(6486)] = 194640,
  [SMALL_STATE(6487)] = 194671,
  [SMALL_STATE(6488)] = 194702,
  [SMALL_STATE(6489)] = 194733,
  [SMALL_STATE(6490)] = 194764,
  [SMALL_STATE(6491)] = 194795,
  [SMALL_STATE(6492)] = 194826,
  [SMALL_STATE(6493)] = 194857,
  [SMALL_STATE(6494)] = 194888,
  [SMALL_STATE(6495)] = 194919,
  [SMALL_STATE(6496)] = 194950,
  [SMALL_STATE(6497)] = 194981,
  [SMALL_STATE(6498)] = 195012,
  [SMALL_STATE(6499)] = 195043,
  [SMALL_STATE(6500)] = 195074,
  [SMALL_STATE(6501)] = 195105,
  [SMALL_STATE(6502)] = 195136,
  [SMALL_STATE(6503)] = 195167,
  [SMALL_STATE(6504)] = 195198,
  [SMALL_STATE(6505)] = 195229,
  [SMALL_STATE(6506)] = 195260,
  [SMALL_STATE(6507)] = 195291,
  [SMALL_STATE(6508)] = 195322,
  [SMALL_STATE(6509)] = 195353,
  [SMALL_STATE(6510)] = 195384,
  [SMALL_STATE(6511)] = 195415,
  [SMALL_STATE(6512)] = 195446,
  [SMALL_STATE(6513)] = 195477,
  [SMALL_STATE(6514)] = 195508,
  [SMALL_STATE(6515)] = 195539,
  [SMALL_STATE(6516)] = 195570,
  [SMALL_STATE(6517)] = 195601,
  [SMALL_STATE(6518)] = 195632,
  [SMALL_STATE(6519)] = 195663,
  [SMALL_STATE(6520)] = 195694,
  [SMALL_STATE(6521)] = 195725,
  [SMALL_STATE(6522)] = 195756,
  [SMALL_STATE(6523)] = 195787,
  [SMALL_STATE(6524)] = 195818,
  [SMALL_STATE(6525)] = 195849,
  [SMALL_STATE(6526)] = 195880,
  [SMALL_STATE(6527)] = 195911,
  [SMALL_STATE(6528)] = 195942,
  [SMALL_STATE(6529)] = 195973,
  [SMALL_STATE(6530)] = 196004,
  [SMALL_STATE(6531)] = 196035,
  [SMALL_STATE(6532)] = 196066,
  [SMALL_STATE(6533)] = 196097,
  [SMALL_STATE(6534)] = 196128,
  [SMALL_STATE(6535)] = 196159,
  [SMALL_STATE(6536)] = 196190,
  [SMALL_STATE(6537)] = 196221,
  [SMALL_STATE(6538)] = 196252,
  [SMALL_STATE(6539)] = 196283,
  [SMALL_STATE(6540)] = 196314,
  [SMALL_STATE(6541)] = 196345,
  [SMALL_STATE(6542)] = 196376,
  [SMALL_STATE(6543)] = 196407,
  [SMALL_STATE(6544)] = 196438,
  [SMALL_STATE(6545)] = 196469,
  [SMALL_STATE(6546)] = 196500,
  [SMALL_STATE(6547)] = 196531,
  [SMALL_STATE(6548)] = 196562,
  [SMALL_STATE(6549)] = 196593,
  [SMALL_STATE(6550)] = 196624,
  [SMALL_STATE(6551)] = 196655,
  [SMALL_STATE(6552)] = 196686,
  [SMALL_STATE(6553)] = 196717,
  [SMALL_STATE(6554)] = 196748,
  [SMALL_STATE(6555)] = 196779,
  [SMALL_STATE(6556)] = 196810,
  [SMALL_STATE(6557)] = 196841,
  [SMALL_STATE(6558)] = 196872,
  [SMALL_STATE(6559)] = 196903,
  [SMALL_STATE(6560)] = 196934,
  [SMALL_STATE(6561)] = 196965,
  [SMALL_STATE(6562)] = 196996,
  [SMALL_STATE(6563)] = 197027,
  [SMALL_STATE(6564)] = 197058,
  [SMALL_STATE(6565)] = 197089,
  [SMALL_STATE(6566)] = 197120,
  [SMALL_STATE(6567)] = 197151,
  [SMALL_STATE(6568)] = 197182,
  [SMALL_STATE(6569)] = 197213,
  [SMALL_STATE(6570)] = 197244,
  [SMALL_STATE(6571)] = 197275,
  [SMALL_STATE(6572)] = 197306,
  [SMALL_STATE(6573)] = 197337,
  [SMALL_STATE(6574)] = 197368,
  [SMALL_STATE(6575)] = 197399,
  [SMALL_STATE(6576)] = 197430,
  [SMALL_STATE(6577)] = 197461,
  [SMALL_STATE(6578)] = 197492,
  [SMALL_STATE(6579)] = 197523,
  [SMALL_STATE(6580)] = 197554,
  [SMALL_STATE(6581)] = 197585,
  [SMALL_STATE(6582)] = 197616,
  [SMALL_STATE(6583)] = 197647,
  [SMALL_STATE(6584)] = 197678,
  [SMALL_STATE(6585)] = 197709,
  [SMALL_STATE(6586)] = 197740,
  [SMALL_STATE(6587)] = 197771,
  [SMALL_STATE(6588)] = 197802,
  [SMALL_STATE(6589)] = 197833,
  [SMALL_STATE(6590)] = 197864,
  [SMALL_STATE(6591)] = 197895,
  [SMALL_STATE(6592)] = 197926,
  [SMALL_STATE(6593)] = 197957,
  [SMALL_STATE(6594)] = 197988,
  [SMALL_STATE(6595)] = 198019,
  [SMALL_STATE(6596)] = 198050,
  [SMALL_STATE(6597)] = 198081,
  [SMALL_STATE(6598)] = 198112,
  [SMALL_STATE(6599)] = 198143,
  [SMALL_STATE(6600)] = 198174,
  [SMALL_STATE(6601)] = 198205,
  [SMALL_STATE(6602)] = 198236,
  [SMALL_STATE(6603)] = 198267,
  [SMALL_STATE(6604)] = 198298,
  [SMALL_STATE(6605)] = 198329,
  [SMALL_STATE(6606)] = 198360,
  [SMALL_STATE(6607)] = 198391,
  [SMALL_STATE(6608)] = 198422,
  [SMALL_STATE(6609)] = 198453,
  [SMALL_STATE(6610)] = 198484,
  [SMALL_STATE(6611)] = 198515,
  [SMALL_STATE(6612)] = 198546,
  [SMALL_STATE(6613)] = 198577,
  [SMALL_STATE(6614)] = 198608,
  [SMALL_STATE(6615)] = 198639,
  [SMALL_STATE(6616)] = 198670,
  [SMALL_STATE(6617)] = 198701,
  [SMALL_STATE(6618)] = 198732,
  [SMALL_STATE(6619)] = 198763,
  [SMALL_STATE(6620)] = 198794,
  [SMALL_STATE(6621)] = 198825,
  [SMALL_STATE(6622)] = 198856,
  [SMALL_STATE(6623)] = 198887,
  [SMALL_STATE(6624)] = 198918,
  [SMALL_STATE(6625)] = 198949,
  [SMALL_STATE(6626)] = 198980,
  [SMALL_STATE(6627)] = 199011,
  [SMALL_STATE(6628)] = 199042,
  [SMALL_STATE(6629)] = 199073,
  [SMALL_STATE(6630)] = 199104,
  [SMALL_STATE(6631)] = 199135,
  [SMALL_STATE(6632)] = 199166,
  [SMALL_STATE(6633)] = 199197,
  [SMALL_STATE(6634)] = 199228,
  [SMALL_STATE(6635)] = 199259,
  [SMALL_STATE(6636)] = 199290,
  [SMALL_STATE(6637)] = 199321,
  [SMALL_STATE(6638)] = 199352,
  [SMALL_STATE(6639)] = 199383,
  [SMALL_STATE(6640)] = 199414,
  [SMALL_STATE(6641)] = 199445,
  [SMALL_STATE(6642)] = 199476,
  [SMALL_STATE(6643)] = 199507,
  [SMALL_STATE(6644)] = 199538,
  [SMALL_STATE(6645)] = 199569,
  [SMALL_STATE(6646)] = 199600,
  [SMALL_STATE(6647)] = 199631,
  [SMALL_STATE(6648)] = 199662,
  [SMALL_STATE(6649)] = 199693,
  [SMALL_STATE(6650)] = 199724,
  [SMALL_STATE(6651)] = 199755,
  [SMALL_STATE(6652)] = 199786,
  [SMALL_STATE(6653)] = 199817,
  [SMALL_STATE(6654)] = 199848,
  [SMALL_STATE(6655)] = 199879,
  [SMALL_STATE(6656)] = 199910,
  [SMALL_STATE(6657)] = 199941,
  [SMALL_STATE(6658)] = 199972,
  [SMALL_STATE(6659)] = 200003,
  [SMALL_STATE(6660)] = 200034,
  [SMALL_STATE(6661)] = 200065,
  [SMALL_STATE(6662)] = 200096,
  [SMALL_STATE(6663)] = 200127,
  [SMALL_STATE(6664)] = 200158,
  [SMALL_STATE(6665)] = 200189,
  [SMALL_STATE(6666)] = 200220,
  [SMALL_STATE(6667)] = 200251,
  [SMALL_STATE(6668)] = 200282,
  [SMALL_STATE(6669)] = 200313,
  [SMALL_STATE(6670)] = 200344,
  [SMALL_STATE(6671)] = 200375,
  [SMALL_STATE(6672)] = 200406,
  [SMALL_STATE(6673)] = 200437,
  [SMALL_STATE(6674)] = 200468,
  [SMALL_STATE(6675)] = 200499,
  [SMALL_STATE(6676)] = 200530,
  [SMALL_STATE(6677)] = 200561,
  [SMALL_STATE(6678)] = 200592,
  [SMALL_STATE(6679)] = 200623,
  [SMALL_STATE(6680)] = 200654,
  [SMALL_STATE(6681)] = 200685,
  [SMALL_STATE(6682)] = 200716,
  [SMALL_STATE(6683)] = 200747,
  [SMALL_STATE(6684)] = 200778,
  [SMALL_STATE(6685)] = 200809,
  [SMALL_STATE(6686)] = 200840,
  [SMALL_STATE(6687)] = 200871,
  [SMALL_STATE(6688)] = 200902,
  [SMALL_STATE(6689)] = 200933,
  [SMALL_STATE(6690)] = 200964,
  [SMALL_STATE(6691)] = 200995,
  [SMALL_STATE(6692)] = 201026,
  [SMALL_STATE(6693)] = 201057,
  [SMALL_STATE(6694)] = 201088,
  [SMALL_STATE(6695)] = 201119,
  [SMALL_STATE(6696)] = 201150,
  [SMALL_STATE(6697)] = 201181,
  [SMALL_STATE(6698)] = 201212,
  [SMALL_STATE(6699)] = 201243,
  [SMALL_STATE(6700)] = 201274,
  [SMALL_STATE(6701)] = 201305,
  [SMALL_STATE(6702)] = 201336,
  [SMALL_STATE(6703)] = 201367,
  [SMALL_STATE(6704)] = 201398,
  [SMALL_STATE(6705)] = 201429,
  [SMALL_STATE(6706)] = 201460,
  [SMALL_STATE(6707)] = 201491,
  [SMALL_STATE(6708)] = 201522,
  [SMALL_STATE(6709)] = 201553,
  [SMALL_STATE(6710)] = 201584,
  [SMALL_STATE(6711)] = 201615,
  [SMALL_STATE(6712)] = 201646,
  [SMALL_STATE(6713)] = 201677,
  [SMALL_STATE(6714)] = 201708,
  [SMALL_STATE(6715)] = 201739,
  [SMALL_STATE(6716)] = 201770,
  [SMALL_STATE(6717)] = 201801,
  [SMALL_STATE(6718)] = 201832,
  [SMALL_STATE(6719)] = 201863,
  [SMALL_STATE(6720)] = 201894,
  [SMALL_STATE(6721)] = 201925,
  [SMALL_STATE(6722)] = 201956,
  [SMALL_STATE(6723)] = 201987,
  [SMALL_STATE(6724)] = 202018,
  [SMALL_STATE(6725)] = 202049,
  [SMALL_STATE(6726)] = 202080,
  [SMALL_STATE(6727)] = 202111,
  [SMALL_STATE(6728)] = 202142,
  [SMALL_STATE(6729)] = 202173,
  [SMALL_STATE(6730)] = 202204,
  [SMALL_STATE(6731)] = 202235,
  [SMALL_STATE(6732)] = 202266,
  [SMALL_STATE(6733)] = 202297,
  [SMALL_STATE(6734)] = 202328,
  [SMALL_STATE(6735)] = 202359,
  [SMALL_STATE(6736)] = 202390,
  [SMALL_STATE(6737)] = 202421,
  [SMALL_STATE(6738)] = 202452,
  [SMALL_STATE(6739)] = 202483,
  [SMALL_STATE(6740)] = 202514,
  [SMALL_STATE(6741)] = 202545,
  [SMALL_STATE(6742)] = 202576,
  [SMALL_STATE(6743)] = 202607,
  [SMALL_STATE(6744)] = 202638,
  [SMALL_STATE(6745)] = 202669,
  [SMALL_STATE(6746)] = 202700,
  [SMALL_STATE(6747)] = 202731,
  [SMALL_STATE(6748)] = 202762,
  [SMALL_STATE(6749)] = 202793,
  [SMALL_STATE(6750)] = 202824,
  [SMALL_STATE(6751)] = 202855,
  [SMALL_STATE(6752)] = 202886,
  [SMALL_STATE(6753)] = 202917,
  [SMALL_STATE(6754)] = 202948,
  [SMALL_STATE(6755)] = 202979,
  [SMALL_STATE(6756)] = 203010,
  [SMALL_STATE(6757)] = 203041,
  [SMALL_STATE(6758)] = 203072,
  [SMALL_STATE(6759)] = 203103,
  [SMALL_STATE(6760)] = 203134,
  [SMALL_STATE(6761)] = 203165,
  [SMALL_STATE(6762)] = 203196,
  [SMALL_STATE(6763)] = 203227,
  [SMALL_STATE(6764)] = 203258,
  [SMALL_STATE(6765)] = 203289,
  [SMALL_STATE(6766)] = 203320,
  [SMALL_STATE(6767)] = 203351,
  [SMALL_STATE(6768)] = 203382,
  [SMALL_STATE(6769)] = 203413,
  [SMALL_STATE(6770)] = 203444,
  [SMALL_STATE(6771)] = 203475,
  [SMALL_STATE(6772)] = 203506,
  [SMALL_STATE(6773)] = 203537,
  [SMALL_STATE(6774)] = 203568,
  [SMALL_STATE(6775)] = 203599,
  [SMALL_STATE(6776)] = 203630,
  [SMALL_STATE(6777)] = 203661,
  [SMALL_STATE(6778)] = 203692,
  [SMALL_STATE(6779)] = 203723,
  [SMALL_STATE(6780)] = 203754,
  [SMALL_STATE(6781)] = 203785,
  [SMALL_STATE(6782)] = 203816,
  [SMALL_STATE(6783)] = 203847,
  [SMALL_STATE(6784)] = 203878,
  [SMALL_STATE(6785)] = 203909,
  [SMALL_STATE(6786)] = 203940,
  [SMALL_STATE(6787)] = 203971,
  [SMALL_STATE(6788)] = 204002,
  [SMALL_STATE(6789)] = 204033,
  [SMALL_STATE(6790)] = 204064,
  [SMALL_STATE(6791)] = 204095,
  [SMALL_STATE(6792)] = 204126,
  [SMALL_STATE(6793)] = 204157,
  [SMALL_STATE(6794)] = 204188,
  [SMALL_STATE(6795)] = 204219,
  [SMALL_STATE(6796)] = 204250,
  [SMALL_STATE(6797)] = 204281,
  [SMALL_STATE(6798)] = 204312,
  [SMALL_STATE(6799)] = 204343,
  [SMALL_STATE(6800)] = 204374,
  [SMALL_STATE(6801)] = 204405,
  [SMALL_STATE(6802)] = 204436,
  [SMALL_STATE(6803)] = 204467,
  [SMALL_STATE(6804)] = 204498,
  [SMALL_STATE(6805)] = 204529,
  [SMALL_STATE(6806)] = 204560,
  [SMALL_STATE(6807)] = 204591,
  [SMALL_STATE(6808)] = 204622,
  [SMALL_STATE(6809)] = 204653,
  [SMALL_STATE(6810)] = 204684,
  [SMALL_STATE(6811)] = 204715,
  [SMALL_STATE(6812)] = 204746,
  [SMALL_STATE(6813)] = 204777,
  [SMALL_STATE(6814)] = 204808,
  [SMALL_STATE(6815)] = 204839,
  [SMALL_STATE(6816)] = 204870,
  [SMALL_STATE(6817)] = 204901,
  [SMALL_STATE(6818)] = 204932,
  [SMALL_STATE(6819)] = 204963,
  [SMALL_STATE(6820)] = 204994,
  [SMALL_STATE(6821)] = 205025,
  [SMALL_STATE(6822)] = 205056,
  [SMALL_STATE(6823)] = 205087,
  [SMALL_STATE(6824)] = 205118,
  [SMALL_STATE(6825)] = 205149,
  [SMALL_STATE(6826)] = 205180,
  [SMALL_STATE(6827)] = 205211,
  [SMALL_STATE(6828)] = 205242,
  [SMALL_STATE(6829)] = 205273,
  [SMALL_STATE(6830)] = 205304,
  [SMALL_STATE(6831)] = 205335,
  [SMALL_STATE(6832)] = 205366,
  [SMALL_STATE(6833)] = 205397,
  [SMALL_STATE(6834)] = 205428,
  [SMALL_STATE(6835)] = 205459,
  [SMALL_STATE(6836)] = 205490,
  [SMALL_STATE(6837)] = 205521,
  [SMALL_STATE(6838)] = 205552,
  [SMALL_STATE(6839)] = 205583,
  [SMALL_STATE(6840)] = 205614,
  [SMALL_STATE(6841)] = 205645,
  [SMALL_STATE(6842)] = 205676,
  [SMALL_STATE(6843)] = 205707,
  [SMALL_STATE(6844)] = 205738,
  [SMALL_STATE(6845)] = 205769,
  [SMALL_STATE(6846)] = 205800,
  [SMALL_STATE(6847)] = 205831,
  [SMALL_STATE(6848)] = 205862,
  [SMALL_STATE(6849)] = 205893,
  [SMALL_STATE(6850)] = 205924,
  [SMALL_STATE(6851)] = 205955,
  [SMALL_STATE(6852)] = 205986,
  [SMALL_STATE(6853)] = 206017,
  [SMALL_STATE(6854)] = 206048,
  [SMALL_STATE(6855)] = 206079,
  [SMALL_STATE(6856)] = 206110,
  [SMALL_STATE(6857)] = 206141,
  [SMALL_STATE(6858)] = 206172,
  [SMALL_STATE(6859)] = 206203,
  [SMALL_STATE(6860)] = 206234,
  [SMALL_STATE(6861)] = 206265,
  [SMALL_STATE(6862)] = 206296,
  [SMALL_STATE(6863)] = 206327,
  [SMALL_STATE(6864)] = 206358,
  [SMALL_STATE(6865)] = 206389,
  [SMALL_STATE(6866)] = 206420,
  [SMALL_STATE(6867)] = 206451,
  [SMALL_STATE(6868)] = 206482,
  [SMALL_STATE(6869)] = 206513,
  [SMALL_STATE(6870)] = 206544,
  [SMALL_STATE(6871)] = 206575,
  [SMALL_STATE(6872)] = 206606,
  [SMALL_STATE(6873)] = 206637,
  [SMALL_STATE(6874)] = 206668,
  [SMALL_STATE(6875)] = 206699,
  [SMALL_STATE(6876)] = 206730,
  [SMALL_STATE(6877)] = 206761,
  [SMALL_STATE(6878)] = 206792,
  [SMALL_STATE(6879)] = 206823,
  [SMALL_STATE(6880)] = 206854,
  [SMALL_STATE(6881)] = 206885,
  [SMALL_STATE(6882)] = 206916,
  [SMALL_STATE(6883)] = 206947,
  [SMALL_STATE(6884)] = 206978,
  [SMALL_STATE(6885)] = 207009,
  [SMALL_STATE(6886)] = 207040,
  [SMALL_STATE(6887)] = 207071,
  [SMALL_STATE(6888)] = 207102,
  [SMALL_STATE(6889)] = 207133,
  [SMALL_STATE(6890)] = 207164,
  [SMALL_STATE(6891)] = 207195,
  [SMALL_STATE(6892)] = 207226,
  [SMALL_STATE(6893)] = 207257,
  [SMALL_STATE(6894)] = 207288,
  [SMALL_STATE(6895)] = 207319,
  [SMALL_STATE(6896)] = 207350,
  [SMALL_STATE(6897)] = 207381,
  [SMALL_STATE(6898)] = 207412,
  [SMALL_STATE(6899)] = 207443,
  [SMALL_STATE(6900)] = 207474,
  [SMALL_STATE(6901)] = 207505,
  [SMALL_STATE(6902)] = 207536,
  [SMALL_STATE(6903)] = 207567,
  [SMALL_STATE(6904)] = 207598,
  [SMALL_STATE(6905)] = 207629,
  [SMALL_STATE(6906)] = 207660,
  [SMALL_STATE(6907)] = 207691,
  [SMALL_STATE(6908)] = 207722,
  [SMALL_STATE(6909)] = 207753,
  [SMALL_STATE(6910)] = 207784,
  [SMALL_STATE(6911)] = 207815,
  [SMALL_STATE(6912)] = 207846,
  [SMALL_STATE(6913)] = 207877,
  [SMALL_STATE(6914)] = 207908,
  [SMALL_STATE(6915)] = 207939,
  [SMALL_STATE(6916)] = 207970,
  [SMALL_STATE(6917)] = 208001,
  [SMALL_STATE(6918)] = 208032,
  [SMALL_STATE(6919)] = 208063,
  [SMALL_STATE(6920)] = 208094,
  [SMALL_STATE(6921)] = 208125,
  [SMALL_STATE(6922)] = 208156,
  [SMALL_STATE(6923)] = 208187,
  [SMALL_STATE(6924)] = 208218,
  [SMALL_STATE(6925)] = 208249,
  [SMALL_STATE(6926)] = 208280,
  [SMALL_STATE(6927)] = 208311,
  [SMALL_STATE(6928)] = 208342,
  [SMALL_STATE(6929)] = 208373,
  [SMALL_STATE(6930)] = 208404,
  [SMALL_STATE(6931)] = 208435,
  [SMALL_STATE(6932)] = 208466,
  [SMALL_STATE(6933)] = 208497,
  [SMALL_STATE(6934)] = 208528,
  [SMALL_STATE(6935)] = 208559,
  [SMALL_STATE(6936)] = 208590,
  [SMALL_STATE(6937)] = 208621,
  [SMALL_STATE(6938)] = 208652,
  [SMALL_STATE(6939)] = 208683,
  [SMALL_STATE(6940)] = 208714,
  [SMALL_STATE(6941)] = 208745,
  [SMALL_STATE(6942)] = 208776,
  [SMALL_STATE(6943)] = 208807,
  [SMALL_STATE(6944)] = 208838,
  [SMALL_STATE(6945)] = 208869,
  [SMALL_STATE(6946)] = 208900,
  [SMALL_STATE(6947)] = 208931,
  [SMALL_STATE(6948)] = 208962,
  [SMALL_STATE(6949)] = 208993,
  [SMALL_STATE(6950)] = 209024,
  [SMALL_STATE(6951)] = 209055,
  [SMALL_STATE(6952)] = 209086,
  [SMALL_STATE(6953)] = 209117,
  [SMALL_STATE(6954)] = 209148,
  [SMALL_STATE(6955)] = 209179,
  [SMALL_STATE(6956)] = 209210,
  [SMALL_STATE(6957)] = 209241,
  [SMALL_STATE(6958)] = 209272,
  [SMALL_STATE(6959)] = 209303,
  [SMALL_STATE(6960)] = 209334,
  [SMALL_STATE(6961)] = 209365,
  [SMALL_STATE(6962)] = 209396,
  [SMALL_STATE(6963)] = 209427,
  [SMALL_STATE(6964)] = 209458,
  [SMALL_STATE(6965)] = 209489,
  [SMALL_STATE(6966)] = 209520,
  [SMALL_STATE(6967)] = 209551,
  [SMALL_STATE(6968)] = 209582,
  [SMALL_STATE(6969)] = 209613,
  [SMALL_STATE(6970)] = 209644,
  [SMALL_STATE(6971)] = 209675,
  [SMALL_STATE(6972)] = 209706,
  [SMALL_STATE(6973)] = 209737,
  [SMALL_STATE(6974)] = 209768,
  [SMALL_STATE(6975)] = 209799,
  [SMALL_STATE(6976)] = 209830,
  [SMALL_STATE(6977)] = 209861,
  [SMALL_STATE(6978)] = 209892,
  [SMALL_STATE(6979)] = 209923,
  [SMALL_STATE(6980)] = 209954,
  [SMALL_STATE(6981)] = 209985,
  [SMALL_STATE(6982)] = 210016,
  [SMALL_STATE(6983)] = 210047,
  [SMALL_STATE(6984)] = 210078,
  [SMALL_STATE(6985)] = 210109,
  [SMALL_STATE(6986)] = 210140,
  [SMALL_STATE(6987)] = 210171,
  [SMALL_STATE(6988)] = 210202,
  [SMALL_STATE(6989)] = 210233,
  [SMALL_STATE(6990)] = 210264,
  [SMALL_STATE(6991)] = 210295,
  [SMALL_STATE(6992)] = 210326,
  [SMALL_STATE(6993)] = 210357,
  [SMALL_STATE(6994)] = 210388,
  [SMALL_STATE(6995)] = 210419,
  [SMALL_STATE(6996)] = 210450,
  [SMALL_STATE(6997)] = 210481,
  [SMALL_STATE(6998)] = 210512,
  [SMALL_STATE(6999)] = 210543,
  [SMALL_STATE(7000)] = 210574,
  [SMALL_STATE(7001)] = 210605,
  [SMALL_STATE(7002)] = 210636,
  [SMALL_STATE(7003)] = 210667,
  [SMALL_STATE(7004)] = 210698,
  [SMALL_STATE(7005)] = 210729,
  [SMALL_STATE(7006)] = 210760,
  [SMALL_STATE(7007)] = 210791,
  [SMALL_STATE(7008)] = 210822,
  [SMALL_STATE(7009)] = 210853,
  [SMALL_STATE(7010)] = 210884,
  [SMALL_STATE(7011)] = 210915,
  [SMALL_STATE(7012)] = 210946,
  [SMALL_STATE(7013)] = 210977,
  [SMALL_STATE(7014)] = 211008,
  [SMALL_STATE(7015)] = 211039,
  [SMALL_STATE(7016)] = 211070,
  [SMALL_STATE(7017)] = 211101,
  [SMALL_STATE(7018)] = 211132,
  [SMALL_STATE(7019)] = 211163,
  [SMALL_STATE(7020)] = 211194,
  [SMALL_STATE(7021)] = 211225,
  [SMALL_STATE(7022)] = 211256,
  [SMALL_STATE(7023)] = 211287,
  [SMALL_STATE(7024)] = 211318,
  [SMALL_STATE(7025)] = 211349,
  [SMALL_STATE(7026)] = 211380,
  [SMALL_STATE(7027)] = 211411,
  [SMALL_STATE(7028)] = 211442,
  [SMALL_STATE(7029)] = 211473,
  [SMALL_STATE(7030)] = 211504,
  [SMALL_STATE(7031)] = 211535,
  [SMALL_STATE(7032)] = 211566,
  [SMALL_STATE(7033)] = 211597,
  [SMALL_STATE(7034)] = 211628,
  [SMALL_STATE(7035)] = 211659,
  [SMALL_STATE(7036)] = 211690,
  [SMALL_STATE(7037)] = 211721,
  [SMALL_STATE(7038)] = 211752,
  [SMALL_STATE(7039)] = 211783,
  [SMALL_STATE(7040)] = 211814,
  [SMALL_STATE(7041)] = 211845,
  [SMALL_STATE(7042)] = 211876,
  [SMALL_STATE(7043)] = 211907,
  [SMALL_STATE(7044)] = 211938,
  [SMALL_STATE(7045)] = 211969,
  [SMALL_STATE(7046)] = 212000,
  [SMALL_STATE(7047)] = 212031,
  [SMALL_STATE(7048)] = 212062,
  [SMALL_STATE(7049)] = 212093,
  [SMALL_STATE(7050)] = 212124,
  [SMALL_STATE(7051)] = 212155,
  [SMALL_STATE(7052)] = 212186,
  [SMALL_STATE(7053)] = 212217,
  [SMALL_STATE(7054)] = 212248,
  [SMALL_STATE(7055)] = 212279,
  [SMALL_STATE(7056)] = 212310,
  [SMALL_STATE(7057)] = 212341,
  [SMALL_STATE(7058)] = 212372,
  [SMALL_STATE(7059)] = 212403,
  [SMALL_STATE(7060)] = 212434,
  [SMALL_STATE(7061)] = 212465,
  [SMALL_STATE(7062)] = 212496,
  [SMALL_STATE(7063)] = 212527,
  [SMALL_STATE(7064)] = 212558,
  [SMALL_STATE(7065)] = 212589,
  [SMALL_STATE(7066)] = 212620,
  [SMALL_STATE(7067)] = 212651,
  [SMALL_STATE(7068)] = 212682,
  [SMALL_STATE(7069)] = 212713,
  [SMALL_STATE(7070)] = 212744,
  [SMALL_STATE(7071)] = 212775,
  [SMALL_STATE(7072)] = 212806,
  [SMALL_STATE(7073)] = 212837,
  [SMALL_STATE(7074)] = 212868,
  [SMALL_STATE(7075)] = 212899,
  [SMALL_STATE(7076)] = 212930,
  [SMALL_STATE(7077)] = 212961,
  [SMALL_STATE(7078)] = 212992,
  [SMALL_STATE(7079)] = 213023,
  [SMALL_STATE(7080)] = 213054,
  [SMALL_STATE(7081)] = 213085,
  [SMALL_STATE(7082)] = 213116,
  [SMALL_STATE(7083)] = 213147,
  [SMALL_STATE(7084)] = 213178,
  [SMALL_STATE(7085)] = 213209,
  [SMALL_STATE(7086)] = 213240,
  [SMALL_STATE(7087)] = 213271,
  [SMALL_STATE(7088)] = 213302,
  [SMALL_STATE(7089)] = 213333,
  [SMALL_STATE(7090)] = 213364,
  [SMALL_STATE(7091)] = 213395,
  [SMALL_STATE(7092)] = 213426,
  [SMALL_STATE(7093)] = 213457,
  [SMALL_STATE(7094)] = 213488,
  [SMALL_STATE(7095)] = 213519,
  [SMALL_STATE(7096)] = 213550,
  [SMALL_STATE(7097)] = 213581,
  [SMALL_STATE(7098)] = 213612,
  [SMALL_STATE(7099)] = 213643,
  [SMALL_STATE(7100)] = 213674,
  [SMALL_STATE(7101)] = 213705,
  [SMALL_STATE(7102)] = 213736,
  [SMALL_STATE(7103)] = 213767,
  [SMALL_STATE(7104)] = 213798,
  [SMALL_STATE(7105)] = 213829,
  [SMALL_STATE(7106)] = 213860,
  [SMALL_STATE(7107)] = 213891,
  [SMALL_STATE(7108)] = 213922,
  [SMALL_STATE(7109)] = 213953,
  [SMALL_STATE(7110)] = 213984,
  [SMALL_STATE(7111)] = 214015,
  [SMALL_STATE(7112)] = 214046,
  [SMALL_STATE(7113)] = 214077,
  [SMALL_STATE(7114)] = 214108,
  [SMALL_STATE(7115)] = 214139,
  [SMALL_STATE(7116)] = 214170,
  [SMALL_STATE(7117)] = 214201,
  [SMALL_STATE(7118)] = 214232,
  [SMALL_STATE(7119)] = 214263,
  [SMALL_STATE(7120)] = 214294,
  [SMALL_STATE(7121)] = 214325,
  [SMALL_STATE(7122)] = 214356,
  [SMALL_STATE(7123)] = 214387,
  [SMALL_STATE(7124)] = 214418,
  [SMALL_STATE(7125)] = 214449,
  [SMALL_STATE(7126)] = 214480,
  [SMALL_STATE(7127)] = 214511,
  [SMALL_STATE(7128)] = 214542,
  [SMALL_STATE(7129)] = 214573,
  [SMALL_STATE(7130)] = 214604,
  [SMALL_STATE(7131)] = 214635,
  [SMALL_STATE(7132)] = 214666,
  [SMALL_STATE(7133)] = 214697,
  [SMALL_STATE(7134)] = 214728,
  [SMALL_STATE(7135)] = 214759,
  [SMALL_STATE(7136)] = 214790,
  [SMALL_STATE(7137)] = 214821,
  [SMALL_STATE(7138)] = 214852,
  [SMALL_STATE(7139)] = 214883,
  [SMALL_STATE(7140)] = 214914,
  [SMALL_STATE(7141)] = 214945,
  [SMALL_STATE(7142)] = 214976,
  [SMALL_STATE(7143)] = 215007,
  [SMALL_STATE(7144)] = 215038,
  [SMALL_STATE(7145)] = 215069,
  [SMALL_STATE(7146)] = 215100,
  [SMALL_STATE(7147)] = 215131,
  [SMALL_STATE(7148)] = 215162,
  [SMALL_STATE(7149)] = 215193,
  [SMALL_STATE(7150)] = 215224,
  [SMALL_STATE(7151)] = 215255,
  [SMALL_STATE(7152)] = 215286,
  [SMALL_STATE(7153)] = 215317,
  [SMALL_STATE(7154)] = 215348,
  [SMALL_STATE(7155)] = 215379,
  [SMALL_STATE(7156)] = 215410,
  [SMALL_STATE(7157)] = 215441,
  [SMALL_STATE(7158)] = 215472,
  [SMALL_STATE(7159)] = 215503,
  [SMALL_STATE(7160)] = 215534,
  [SMALL_STATE(7161)] = 215565,
  [SMALL_STATE(7162)] = 215596,
  [SMALL_STATE(7163)] = 215627,
  [SMALL_STATE(7164)] = 215658,
  [SMALL_STATE(7165)] = 215689,
  [SMALL_STATE(7166)] = 215720,
  [SMALL_STATE(7167)] = 215751,
  [SMALL_STATE(7168)] = 215782,
  [SMALL_STATE(7169)] = 215813,
  [SMALL_STATE(7170)] = 215844,
  [SMALL_STATE(7171)] = 215875,
  [SMALL_STATE(7172)] = 215906,
  [SMALL_STATE(7173)] = 215937,
  [SMALL_STATE(7174)] = 215968,
  [SMALL_STATE(7175)] = 215999,
  [SMALL_STATE(7176)] = 216030,
  [SMALL_STATE(7177)] = 216061,
  [SMALL_STATE(7178)] = 216092,
  [SMALL_STATE(7179)] = 216123,
  [SMALL_STATE(7180)] = 216154,
  [SMALL_STATE(7181)] = 216185,
  [SMALL_STATE(7182)] = 216216,
  [SMALL_STATE(7183)] = 216247,
  [SMALL_STATE(7184)] = 216278,
  [SMALL_STATE(7185)] = 216309,
  [SMALL_STATE(7186)] = 216340,
  [SMALL_STATE(7187)] = 216371,
  [SMALL_STATE(7188)] = 216402,
  [SMALL_STATE(7189)] = 216433,
  [SMALL_STATE(7190)] = 216464,
  [SMALL_STATE(7191)] = 216495,
  [SMALL_STATE(7192)] = 216526,
  [SMALL_STATE(7193)] = 216557,
  [SMALL_STATE(7194)] = 216588,
  [SMALL_STATE(7195)] = 216619,
  [SMALL_STATE(7196)] = 216650,
  [SMALL_STATE(7197)] = 216681,
  [SMALL_STATE(7198)] = 216712,
  [SMALL_STATE(7199)] = 216743,
  [SMALL_STATE(7200)] = 216774,
  [SMALL_STATE(7201)] = 216805,
  [SMALL_STATE(7202)] = 216836,
  [SMALL_STATE(7203)] = 216867,
  [SMALL_STATE(7204)] = 216898,
  [SMALL_STATE(7205)] = 216929,
  [SMALL_STATE(7206)] = 216960,
  [SMALL_STATE(7207)] = 216991,
  [SMALL_STATE(7208)] = 217022,
  [SMALL_STATE(7209)] = 217053,
  [SMALL_STATE(7210)] = 217084,
  [SMALL_STATE(7211)] = 217115,
  [SMALL_STATE(7212)] = 217146,
  [SMALL_STATE(7213)] = 217177,
  [SMALL_STATE(7214)] = 217208,
  [SMALL_STATE(7215)] = 217239,
  [SMALL_STATE(7216)] = 217270,
  [SMALL_STATE(7217)] = 217301,
  [SMALL_STATE(7218)] = 217332,
  [SMALL_STATE(7219)] = 217363,
  [SMALL_STATE(7220)] = 217394,
  [SMALL_STATE(7221)] = 217425,
  [SMALL_STATE(7222)] = 217456,
  [SMALL_STATE(7223)] = 217487,
  [SMALL_STATE(7224)] = 217518,
  [SMALL_STATE(7225)] = 217549,
  [SMALL_STATE(7226)] = 217580,
  [SMALL_STATE(7227)] = 217611,
  [SMALL_STATE(7228)] = 217642,
  [SMALL_STATE(7229)] = 217673,
  [SMALL_STATE(7230)] = 217704,
  [SMALL_STATE(7231)] = 217735,
  [SMALL_STATE(7232)] = 217766,
  [SMALL_STATE(7233)] = 217797,
  [SMALL_STATE(7234)] = 217828,
  [SMALL_STATE(7235)] = 217859,
  [SMALL_STATE(7236)] = 217890,
  [SMALL_STATE(7237)] = 217921,
  [SMALL_STATE(7238)] = 217952,
  [SMALL_STATE(7239)] = 217983,
  [SMALL_STATE(7240)] = 218014,
  [SMALL_STATE(7241)] = 218045,
  [SMALL_STATE(7242)] = 218076,
  [SMALL_STATE(7243)] = 218107,
  [SMALL_STATE(7244)] = 218138,
  [SMALL_STATE(7245)] = 218169,
  [SMALL_STATE(7246)] = 218200,
  [SMALL_STATE(7247)] = 218231,
  [SMALL_STATE(7248)] = 218262,
  [SMALL_STATE(7249)] = 218293,
  [SMALL_STATE(7250)] = 218324,
  [SMALL_STATE(7251)] = 218355,
  [SMALL_STATE(7252)] = 218386,
  [SMALL_STATE(7253)] = 218417,
  [SMALL_STATE(7254)] = 218448,
  [SMALL_STATE(7255)] = 218479,
  [SMALL_STATE(7256)] = 218510,
  [SMALL_STATE(7257)] = 218541,
  [SMALL_STATE(7258)] = 218572,
  [SMALL_STATE(7259)] = 218603,
  [SMALL_STATE(7260)] = 218634,
  [SMALL_STATE(7261)] = 218665,
  [SMALL_STATE(7262)] = 218696,
  [SMALL_STATE(7263)] = 218727,
  [SMALL_STATE(7264)] = 218758,
  [SMALL_STATE(7265)] = 218789,
  [SMALL_STATE(7266)] = 218820,
  [SMALL_STATE(7267)] = 218851,
  [SMALL_STATE(7268)] = 218882,
  [SMALL_STATE(7269)] = 218913,
  [SMALL_STATE(7270)] = 218944,
  [SMALL_STATE(7271)] = 218975,
  [SMALL_STATE(7272)] = 219006,
  [SMALL_STATE(7273)] = 219037,
  [SMALL_STATE(7274)] = 219068,
  [SMALL_STATE(7275)] = 219099,
  [SMALL_STATE(7276)] = 219130,
  [SMALL_STATE(7277)] = 219161,
  [SMALL_STATE(7278)] = 219192,
  [SMALL_STATE(7279)] = 219223,
  [SMALL_STATE(7280)] = 219254,
  [SMALL_STATE(7281)] = 219285,
  [SMALL_STATE(7282)] = 219316,
  [SMALL_STATE(7283)] = 219347,
  [SMALL_STATE(7284)] = 219378,
  [SMALL_STATE(7285)] = 219409,
  [SMALL_STATE(7286)] = 219440,
  [SMALL_STATE(7287)] = 219471,
  [SMALL_STATE(7288)] = 219502,
  [SMALL_STATE(7289)] = 219533,
  [SMALL_STATE(7290)] = 219564,
  [SMALL_STATE(7291)] = 219595,
  [SMALL_STATE(7292)] = 219626,
  [SMALL_STATE(7293)] = 219657,
  [SMALL_STATE(7294)] = 219688,
  [SMALL_STATE(7295)] = 219719,
  [SMALL_STATE(7296)] = 219750,
  [SMALL_STATE(7297)] = 219781,
  [SMALL_STATE(7298)] = 219812,
  [SMALL_STATE(7299)] = 219843,
  [SMALL_STATE(7300)] = 219874,
  [SMALL_STATE(7301)] = 219905,
  [SMALL_STATE(7302)] = 219936,
  [SMALL_STATE(7303)] = 219967,
  [SMALL_STATE(7304)] = 219998,
  [SMALL_STATE(7305)] = 220027,
  [SMALL_STATE(7306)] = 220058,
  [SMALL_STATE(7307)] = 220089,
  [SMALL_STATE(7308)] = 220120,
  [SMALL_STATE(7309)] = 220151,
  [SMALL_STATE(7310)] = 220182,
  [SMALL_STATE(7311)] = 220213,
  [SMALL_STATE(7312)] = 220244,
  [SMALL_STATE(7313)] = 220275,
  [SMALL_STATE(7314)] = 220306,
  [SMALL_STATE(7315)] = 220337,
  [SMALL_STATE(7316)] = 220368,
  [SMALL_STATE(7317)] = 220399,
  [SMALL_STATE(7318)] = 220430,
  [SMALL_STATE(7319)] = 220461,
  [SMALL_STATE(7320)] = 220492,
  [SMALL_STATE(7321)] = 220523,
  [SMALL_STATE(7322)] = 220554,
  [SMALL_STATE(7323)] = 220585,
  [SMALL_STATE(7324)] = 220616,
  [SMALL_STATE(7325)] = 220647,
  [SMALL_STATE(7326)] = 220678,
  [SMALL_STATE(7327)] = 220709,
  [SMALL_STATE(7328)] = 220740,
  [SMALL_STATE(7329)] = 220771,
  [SMALL_STATE(7330)] = 220802,
  [SMALL_STATE(7331)] = 220833,
  [SMALL_STATE(7332)] = 220864,
  [SMALL_STATE(7333)] = 220895,
  [SMALL_STATE(7334)] = 220926,
  [SMALL_STATE(7335)] = 220957,
  [SMALL_STATE(7336)] = 220988,
  [SMALL_STATE(7337)] = 221019,
  [SMALL_STATE(7338)] = 221050,
  [SMALL_STATE(7339)] = 221081,
  [SMALL_STATE(7340)] = 221110,
  [SMALL_STATE(7341)] = 221141,
  [SMALL_STATE(7342)] = 221172,
  [SMALL_STATE(7343)] = 221203,
  [SMALL_STATE(7344)] = 221234,
  [SMALL_STATE(7345)] = 221265,
  [SMALL_STATE(7346)] = 221296,
  [SMALL_STATE(7347)] = 221327,
  [SMALL_STATE(7348)] = 221358,
  [SMALL_STATE(7349)] = 221389,
  [SMALL_STATE(7350)] = 221420,
  [SMALL_STATE(7351)] = 221451,
  [SMALL_STATE(7352)] = 221482,
  [SMALL_STATE(7353)] = 221513,
  [SMALL_STATE(7354)] = 221544,
  [SMALL_STATE(7355)] = 221575,
  [SMALL_STATE(7356)] = 221606,
  [SMALL_STATE(7357)] = 221637,
  [SMALL_STATE(7358)] = 221668,
  [SMALL_STATE(7359)] = 221699,
  [SMALL_STATE(7360)] = 221730,
  [SMALL_STATE(7361)] = 221761,
  [SMALL_STATE(7362)] = 221792,
  [SMALL_STATE(7363)] = 221823,
  [SMALL_STATE(7364)] = 221854,
  [SMALL_STATE(7365)] = 221885,
  [SMALL_STATE(7366)] = 221916,
  [SMALL_STATE(7367)] = 221947,
  [SMALL_STATE(7368)] = 221978,
  [SMALL_STATE(7369)] = 222009,
  [SMALL_STATE(7370)] = 222040,
  [SMALL_STATE(7371)] = 222071,
  [SMALL_STATE(7372)] = 222102,
  [SMALL_STATE(7373)] = 222133,
  [SMALL_STATE(7374)] = 222164,
  [SMALL_STATE(7375)] = 222195,
  [SMALL_STATE(7376)] = 222226,
  [SMALL_STATE(7377)] = 222257,
  [SMALL_STATE(7378)] = 222288,
  [SMALL_STATE(7379)] = 222319,
  [SMALL_STATE(7380)] = 222350,
  [SMALL_STATE(7381)] = 222381,
  [SMALL_STATE(7382)] = 222412,
  [SMALL_STATE(7383)] = 222443,
  [SMALL_STATE(7384)] = 222474,
  [SMALL_STATE(7385)] = 222505,
  [SMALL_STATE(7386)] = 222536,
  [SMALL_STATE(7387)] = 222567,
  [SMALL_STATE(7388)] = 222598,
  [SMALL_STATE(7389)] = 222629,
  [SMALL_STATE(7390)] = 222660,
  [SMALL_STATE(7391)] = 222691,
  [SMALL_STATE(7392)] = 222722,
  [SMALL_STATE(7393)] = 222753,
  [SMALL_STATE(7394)] = 222784,
  [SMALL_STATE(7395)] = 222815,
  [SMALL_STATE(7396)] = 222846,
  [SMALL_STATE(7397)] = 222877,
  [SMALL_STATE(7398)] = 222908,
  [SMALL_STATE(7399)] = 222939,
  [SMALL_STATE(7400)] = 222970,
  [SMALL_STATE(7401)] = 223001,
  [SMALL_STATE(7402)] = 223032,
  [SMALL_STATE(7403)] = 223063,
  [SMALL_STATE(7404)] = 223094,
  [SMALL_STATE(7405)] = 223125,
  [SMALL_STATE(7406)] = 223156,
  [SMALL_STATE(7407)] = 223187,
  [SMALL_STATE(7408)] = 223218,
  [SMALL_STATE(7409)] = 223249,
  [SMALL_STATE(7410)] = 223280,
  [SMALL_STATE(7411)] = 223311,
  [SMALL_STATE(7412)] = 223342,
  [SMALL_STATE(7413)] = 223373,
  [SMALL_STATE(7414)] = 223404,
  [SMALL_STATE(7415)] = 223435,
  [SMALL_STATE(7416)] = 223466,
  [SMALL_STATE(7417)] = 223497,
  [SMALL_STATE(7418)] = 223528,
  [SMALL_STATE(7419)] = 223559,
  [SMALL_STATE(7420)] = 223590,
  [SMALL_STATE(7421)] = 223621,
  [SMALL_STATE(7422)] = 223652,
  [SMALL_STATE(7423)] = 223683,
  [SMALL_STATE(7424)] = 223714,
  [SMALL_STATE(7425)] = 223745,
  [SMALL_STATE(7426)] = 223776,
  [SMALL_STATE(7427)] = 223807,
  [SMALL_STATE(7428)] = 223838,
  [SMALL_STATE(7429)] = 223869,
  [SMALL_STATE(7430)] = 223900,
  [SMALL_STATE(7431)] = 223931,
  [SMALL_STATE(7432)] = 223962,
  [SMALL_STATE(7433)] = 223993,
  [SMALL_STATE(7434)] = 224024,
  [SMALL_STATE(7435)] = 224055,
  [SMALL_STATE(7436)] = 224086,
  [SMALL_STATE(7437)] = 224117,
  [SMALL_STATE(7438)] = 224148,
  [SMALL_STATE(7439)] = 224179,
  [SMALL_STATE(7440)] = 224210,
  [SMALL_STATE(7441)] = 224241,
  [SMALL_STATE(7442)] = 224272,
  [SMALL_STATE(7443)] = 224303,
  [SMALL_STATE(7444)] = 224334,
  [SMALL_STATE(7445)] = 224365,
  [SMALL_STATE(7446)] = 224396,
  [SMALL_STATE(7447)] = 224427,
  [SMALL_STATE(7448)] = 224458,
  [SMALL_STATE(7449)] = 224489,
  [SMALL_STATE(7450)] = 224520,
  [SMALL_STATE(7451)] = 224551,
  [SMALL_STATE(7452)] = 224582,
  [SMALL_STATE(7453)] = 224613,
  [SMALL_STATE(7454)] = 224644,
  [SMALL_STATE(7455)] = 224675,
  [SMALL_STATE(7456)] = 224706,
  [SMALL_STATE(7457)] = 224737,
  [SMALL_STATE(7458)] = 224768,
  [SMALL_STATE(7459)] = 224799,
  [SMALL_STATE(7460)] = 224830,
  [SMALL_STATE(7461)] = 224861,
  [SMALL_STATE(7462)] = 224892,
  [SMALL_STATE(7463)] = 224923,
  [SMALL_STATE(7464)] = 224954,
  [SMALL_STATE(7465)] = 224985,
  [SMALL_STATE(7466)] = 225016,
  [SMALL_STATE(7467)] = 225047,
  [SMALL_STATE(7468)] = 225078,
  [SMALL_STATE(7469)] = 225109,
  [SMALL_STATE(7470)] = 225140,
  [SMALL_STATE(7471)] = 225171,
  [SMALL_STATE(7472)] = 225202,
  [SMALL_STATE(7473)] = 225233,
  [SMALL_STATE(7474)] = 225264,
  [SMALL_STATE(7475)] = 225295,
  [SMALL_STATE(7476)] = 225326,
  [SMALL_STATE(7477)] = 225357,
  [SMALL_STATE(7478)] = 225388,
  [SMALL_STATE(7479)] = 225419,
  [SMALL_STATE(7480)] = 225450,
  [SMALL_STATE(7481)] = 225481,
  [SMALL_STATE(7482)] = 225512,
  [SMALL_STATE(7483)] = 225543,
  [SMALL_STATE(7484)] = 225574,
  [SMALL_STATE(7485)] = 225605,
  [SMALL_STATE(7486)] = 225636,
  [SMALL_STATE(7487)] = 225667,
  [SMALL_STATE(7488)] = 225698,
  [SMALL_STATE(7489)] = 225729,
  [SMALL_STATE(7490)] = 225760,
  [SMALL_STATE(7491)] = 225791,
  [SMALL_STATE(7492)] = 225822,
  [SMALL_STATE(7493)] = 225853,
  [SMALL_STATE(7494)] = 225884,
  [SMALL_STATE(7495)] = 225915,
  [SMALL_STATE(7496)] = 225946,
  [SMALL_STATE(7497)] = 225977,
  [SMALL_STATE(7498)] = 226008,
  [SMALL_STATE(7499)] = 226039,
  [SMALL_STATE(7500)] = 226070,
  [SMALL_STATE(7501)] = 226101,
  [SMALL_STATE(7502)] = 226132,
  [SMALL_STATE(7503)] = 226163,
  [SMALL_STATE(7504)] = 226194,
  [SMALL_STATE(7505)] = 226225,
  [SMALL_STATE(7506)] = 226256,
  [SMALL_STATE(7507)] = 226287,
  [SMALL_STATE(7508)] = 226318,
  [SMALL_STATE(7509)] = 226349,
  [SMALL_STATE(7510)] = 226380,
  [SMALL_STATE(7511)] = 226411,
  [SMALL_STATE(7512)] = 226442,
  [SMALL_STATE(7513)] = 226473,
  [SMALL_STATE(7514)] = 226504,
  [SMALL_STATE(7515)] = 226535,
  [SMALL_STATE(7516)] = 226566,
  [SMALL_STATE(7517)] = 226595,
  [SMALL_STATE(7518)] = 226626,
  [SMALL_STATE(7519)] = 226657,
  [SMALL_STATE(7520)] = 226688,
  [SMALL_STATE(7521)] = 226719,
  [SMALL_STATE(7522)] = 226750,
  [SMALL_STATE(7523)] = 226781,
  [SMALL_STATE(7524)] = 226812,
  [SMALL_STATE(7525)] = 226843,
  [SMALL_STATE(7526)] = 226874,
  [SMALL_STATE(7527)] = 226905,
  [SMALL_STATE(7528)] = 226936,
  [SMALL_STATE(7529)] = 226967,
  [SMALL_STATE(7530)] = 226998,
  [SMALL_STATE(7531)] = 227029,
  [SMALL_STATE(7532)] = 227060,
  [SMALL_STATE(7533)] = 227091,
  [SMALL_STATE(7534)] = 227122,
  [SMALL_STATE(7535)] = 227153,
  [SMALL_STATE(7536)] = 227184,
  [SMALL_STATE(7537)] = 227215,
  [SMALL_STATE(7538)] = 227246,
  [SMALL_STATE(7539)] = 227277,
  [SMALL_STATE(7540)] = 227308,
  [SMALL_STATE(7541)] = 227339,
  [SMALL_STATE(7542)] = 227370,
  [SMALL_STATE(7543)] = 227401,
  [SMALL_STATE(7544)] = 227432,
  [SMALL_STATE(7545)] = 227463,
  [SMALL_STATE(7546)] = 227494,
  [SMALL_STATE(7547)] = 227525,
  [SMALL_STATE(7548)] = 227556,
  [SMALL_STATE(7549)] = 227587,
  [SMALL_STATE(7550)] = 227618,
  [SMALL_STATE(7551)] = 227622,
  [SMALL_STATE(7552)] = 227626,
  [SMALL_STATE(7553)] = 227630,
  [SMALL_STATE(7554)] = 227634,
  [SMALL_STATE(7555)] = 227638,
  [SMALL_STATE(7556)] = 227642,
};

static const TSParseActionEntry ts_parse_actions[] = {
  [0] = {.entry = {.count = 0, .reusable = false}},
  [1] = {.entry = {.count = 1, .reusable = false}}, RECOVER(),
  [3] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7419),
  [5] = {.entry = {.count = 1, .reusable = true}}, SHIFT_EXTRA(),
  [7] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6380),
  [9] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7544),
  [11] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6379),
  [13] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7542),
  [15] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7542),
  [17] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_file, 0, 0, 0),
  [19] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6377),
  [21] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6373),
  [23] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3217),
  [25] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2477),
  [27] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7419),
  [29] = {.entry = {.count = 1, .reusable = false}}, SHIFT(845),
  [31] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2844),
  [33] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_expression, 4, 0, 0),
  [35] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4048),
  [37] = {.entry = {.count = 1, .reusable = false}}, SHIFT(658),
  [39] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6130),
  [41] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2351),
  [43] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2351),
  [45] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6327),
  [47] = {.entry = {.count = 1, .reusable = true}}, SHIFT(448),
  [49] = {.entry = {.count = 1, .reusable = false}}, SHIFT(867),
  [51] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2844),
  [53] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2835),
  [55] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5931),
  [57] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5932),
  [59] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple_expression, 4, 0, 0),
  [61] = {.entry = {.count = 1, .reusable = false}}, SHIFT(498),
  [63] = {.entry = {.count = 1, .reusable = false}}, SHIFT(496),
  [65] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5560),
  [67] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7400),
  [69] = {.entry = {.count = 1, .reusable = true}}, SHIFT(658),
  [71] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4048),
  [73] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2679),
  [75] = {.entry = {.count = 1, .reusable = false}}, SHIFT(677),
  [77] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6233),
  [79] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2855),
  [81] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6129),
  [83] = {.entry = {.count = 1, .reusable = false}}, SHIFT(745),
  [85] = {.entry = {.count = 1, .reusable = true}}, SHIFT(745),
  [87] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7154),
  [89] = {.entry = {.count = 1, .reusable = false}}, SHIFT(602),
  [91] = {.entry = {.count = 1, .reusable = true}}, SHIFT(379),
  [93] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3781),
  [95] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7338),
  [97] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7338),
  [99] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6130),
  [101] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7402),
  [103] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6315),
  [105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(865),
  [107] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4674),
  [109] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4763),
  [111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5035),
  [113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6827),
  [115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6828),
  [117] = {.entry = {.count = 1, .reusable = false}}, SHIFT(868),
  [119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(888),
  [121] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6702),
  [123] = {.entry = {.count = 1, .reusable = false}}, SHIFT(871),
  [125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2840),
  [127] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2838),
  [129] = {.entry = {.count = 1, .reusable = false}}, SHIFT(758),
  [131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(759),
  [133] = {.entry = {.count = 1, .reusable = false}}, SHIFT_EXTRA(),
  [135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7156),
  [137] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__val_property_defn, 4, 0, 0),
  [139] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7161),
  [141] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__val_property_defn, 4, 0, 0),
  [143] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6155),
  [145] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_prefixed_expression, 2, 0, 0),
  [147] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_prefixed_expression, 2, 0, 0),
  [149] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declaration_expression, 2, 0, 7),
  [151] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declaration_expression, 2, 0, 7),
  [153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(696),
  [155] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__low_prec_app, 2, 0, 0),
  [157] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__low_prec_app, 2, 0, 0),
  [159] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_sequential_expression_repeat1, 2, 0, 15),
  [161] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_sequential_expression_repeat1, 2, 0, 15),
  [163] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_expression, 3, 0, 0),
  [165] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple_expression, 3, 0, 0),
  [167] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_mutate_expression, 3, 0, 17),
  [169] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_mutate_expression, 3, 0, 17),
  [171] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declaration_expression, 5, 0, 38),
  [173] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declaration_expression, 5, 0, 38),
  [175] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__val_property_defn, 2, 0, 0),
  [177] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__val_property_defn, 2, 0, 0),
  [179] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6048),
  [181] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_infix_expression, 3, 0, 0),
  [183] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_infix_expression, 3, 0, 0),
  [185] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5541),
  [187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(384),
  [189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3778),
  [191] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6014),
  [193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1074),
  [195] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1021),
  [197] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3942),
  [199] = {.entry = {.count = 1, .reusable = false}}, SHIFT(517),
  [201] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6252),
  [203] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6244),
  [205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(477),
  [207] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1118),
  [209] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5867),
  [211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5868),
  [213] = {.entry = {.count = 1, .reusable = false}}, SHIFT(528),
  [215] = {.entry = {.count = 1, .reusable = false}}, SHIFT(537),
  [217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7270),
  [219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(517),
  [221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3942),
  [223] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2642),
  [225] = {.entry = {.count = 1, .reusable = false}}, SHIFT(547),
  [227] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2864),
  [229] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6226),
  [231] = {.entry = {.count = 1, .reusable = false}}, SHIFT(591),
  [233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(591),
  [235] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7262),
  [237] = {.entry = {.count = 1, .reusable = false}}, SHIFT(504),
  [239] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7261),
  [241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7261),
  [243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6252),
  [245] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7256),
  [247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1077),
  [249] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4689),
  [251] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4712),
  [253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5067),
  [255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6413),
  [257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6412),
  [259] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1080),
  [261] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6409),
  [263] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1085),
  [265] = {.entry = {.count = 1, .reusable = false}}, SHIFT(760),
  [267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(761),
  [269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7251),
  [271] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7009),
  [273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(518),
  [275] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1446),
  [277] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3993),
  [279] = {.entry = {.count = 1, .reusable = false}}, SHIFT(670),
  [281] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6025),
  [283] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6414),
  [285] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6113),
  [287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(471),
  [289] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1537),
  [291] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5983),
  [293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5981),
  [295] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7307),
  [297] = {.entry = {.count = 1, .reusable = false}}, SHIFT(717),
  [299] = {.entry = {.count = 1, .reusable = false}}, SHIFT(726),
  [301] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5567),
  [303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7459),
  [305] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6461),
  [307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(670),
  [309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3993),
  [311] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2635),
  [313] = {.entry = {.count = 1, .reusable = false}}, SHIFT(584),
  [315] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2853),
  [317] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6261),
  [319] = {.entry = {.count = 1, .reusable = false}}, SHIFT(571),
  [321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(571),
  [323] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7300),
  [325] = {.entry = {.count = 1, .reusable = false}}, SHIFT(490),
  [327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(397),
  [329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3779),
  [331] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7319),
  [333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7319),
  [335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6025),
  [337] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7461),
  [339] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6109),
  [341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1489),
  [343] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4619),
  [345] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4767),
  [347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5024),
  [349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6987),
  [351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6988),
  [353] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1484),
  [355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1552),
  [357] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6956),
  [359] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1645),
  [361] = {.entry = {.count = 1, .reusable = false}}, SHIFT(767),
  [363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(786),
  [365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7302),
  [367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(488),
  [369] = {.entry = {.count = 1, .reusable = false}}, SHIFT(499),
  [371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(437),
  [373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(499),
  [375] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2644),
  [377] = {.entry = {.count = 1, .reusable = false}}, SHIFT(741),
  [379] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7179),
  [381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7179),
  [383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(434),
  [385] = {.entry = {.count = 1, .reusable = false}}, SHIFT(782),
  [387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(796),
  [389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(573),
  [391] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__list_elements, 1, 0, 0),
  [393] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1669),
  [395] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3935),
  [397] = {.entry = {.count = 1, .reusable = false}}, SHIFT(756),
  [399] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6090),
  [401] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6258),
  [403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(478),
  [405] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1797),
  [407] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5953),
  [409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5951),
  [411] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7208),
  [413] = {.entry = {.count = 1, .reusable = false}}, SHIFT(722),
  [415] = {.entry = {.count = 1, .reusable = false}}, SHIFT(725),
  [417] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5540),
  [419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7418),
  [421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(756),
  [423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3935),
  [425] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2643),
  [427] = {.entry = {.count = 1, .reusable = false}}, SHIFT(605),
  [429] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2862),
  [431] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6174),
  [433] = {.entry = {.count = 1, .reusable = false}}, SHIFT(752),
  [435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(752),
  [437] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7201),
  [439] = {.entry = {.count = 1, .reusable = false}}, SHIFT(503),
  [441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(380),
  [443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3789),
  [445] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7223),
  [447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7223),
  [449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6090),
  [451] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7420),
  [453] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6250),
  [455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1695),
  [457] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4635),
  [459] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4814),
  [461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4961),
  [463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6934),
  [465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6935),
  [467] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1694),
  [469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1853),
  [471] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6869),
  [473] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1753),
  [475] = {.entry = {.count = 1, .reusable = false}}, SHIFT(784),
  [477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(814),
  [479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7203),
  [481] = {.entry = {.count = 1, .reusable = false}}, SHIFT(548),
  [483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(452),
  [485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2459),
  [487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(548),
  [489] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2651),
  [491] = {.entry = {.count = 1, .reusable = false}}, SHIFT(674),
  [493] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7376),
  [495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7376),
  [497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(433),
  [499] = {.entry = {.count = 1, .reusable = false}}, SHIFT(770),
  [501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(671),
  [503] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1644),
  [505] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3867),
  [507] = {.entry = {.count = 1, .reusable = false}}, SHIFT(664),
  [509] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6060),
  [511] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6160),
  [513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(475),
  [515] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2008),
  [517] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5884),
  [519] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5886),
  [521] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7271),
  [523] = {.entry = {.count = 1, .reusable = false}}, SHIFT(653),
  [525] = {.entry = {.count = 1, .reusable = false}}, SHIFT(675),
  [527] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5556),
  [529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7445),
  [531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(664),
  [533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3867),
  [535] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2629),
  [537] = {.entry = {.count = 1, .reusable = false}}, SHIFT(593),
  [539] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2859),
  [541] = {.entry = {.count = 1, .reusable = false}}, SHIFT(643),
  [543] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6219),
  [545] = {.entry = {.count = 1, .reusable = false}}, SHIFT(757),
  [547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(757),
  [549] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7264),
  [551] = {.entry = {.count = 1, .reusable = false}}, SHIFT(542),
  [553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(371),
  [555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3782),
  [557] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7333),
  [559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7333),
  [561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6208),
  [563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(716),
  [565] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7447),
  [567] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6152),
  [569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1858),
  [571] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4647),
  [573] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4850),
  [575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5009),
  [577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6972),
  [579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6973),
  [581] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1859),
  [583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1996),
  [585] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6936),
  [587] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1702),
  [589] = {.entry = {.count = 1, .reusable = false}}, SHIFT(768),
  [591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(818),
  [593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7266),
  [595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(539),
  [597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1922),
  [599] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6208),
  [601] = {.entry = {.count = 1, .reusable = false}}, SHIFT(669),
  [603] = {.entry = {.count = 1, .reusable = false}}, SHIFT(582),
  [605] = {.entry = {.count = 1, .reusable = false}}, SHIFT(516),
  [607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2192),
  [609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(738),
  [611] = {.entry = {.count = 1, .reusable = false}}, SHIFT(597),
  [613] = {.entry = {.count = 1, .reusable = false}}, SHIFT(644),
  [615] = {.entry = {.count = 1, .reusable = false}}, SHIFT(560),
  [617] = {.entry = {.count = 1, .reusable = false}}, SHIFT(732),
  [619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2042),
  [621] = {.entry = {.count = 1, .reusable = false}}, SHIFT(700),
  [623] = {.entry = {.count = 1, .reusable = false}}, SHIFT(676),
  [625] = {.entry = {.count = 1, .reusable = false}}, SHIFT(646),
  [627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1972),
  [629] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1686),
  [631] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3950),
  [633] = {.entry = {.count = 1, .reusable = false}}, SHIFT(723),
  [635] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6394),
  [637] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6189),
  [639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(473),
  [641] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2000),
  [643] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5741),
  [645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5747),
  [647] = {.entry = {.count = 1, .reusable = false}}, SHIFT(583),
  [649] = {.entry = {.count = 1, .reusable = false}}, SHIFT(587),
  [651] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5561),
  [653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7436),
  [655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(723),
  [657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3950),
  [659] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2655),
  [661] = {.entry = {.count = 1, .reusable = false}}, SHIFT(749),
  [663] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2854),
  [665] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6206),
  [667] = {.entry = {.count = 1, .reusable = false}}, SHIFT(755),
  [669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(755),
  [671] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7243),
  [673] = {.entry = {.count = 1, .reusable = false}}, SHIFT(558),
  [675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(387),
  [677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3775),
  [679] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7265),
  [681] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7265),
  [683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6394),
  [685] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7438),
  [687] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6184),
  [689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1799),
  [691] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4663),
  [693] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4817),
  [695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4994),
  [697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6963),
  [699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6964),
  [701] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1801),
  [703] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2056),
  [705] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6925),
  [707] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1726),
  [709] = {.entry = {.count = 1, .reusable = false}}, SHIFT(777),
  [711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(817),
  [713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7245),
  [715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2345),
  [717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2319),
  [719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1580),
  [721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1778),
  [723] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1514),
  [725] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4021),
  [727] = {.entry = {.count = 1, .reusable = false}}, SHIFT(655),
  [729] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6220),
  [731] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6084),
  [733] = {.entry = {.count = 1, .reusable = true}}, SHIFT(465),
  [735] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1809),
  [737] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5877),
  [739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5876),
  [741] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7325),
  [743] = {.entry = {.count = 1, .reusable = false}}, SHIFT(735),
  [745] = {.entry = {.count = 1, .reusable = false}}, SHIFT(740),
  [747] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5542),
  [749] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7466),
  [751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(655),
  [753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4021),
  [755] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2687),
  [757] = {.entry = {.count = 1, .reusable = false}}, SHIFT(680),
  [759] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2851),
  [761] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6265),
  [763] = {.entry = {.count = 1, .reusable = false}}, SHIFT(567),
  [765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(567),
  [767] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7318),
  [769] = {.entry = {.count = 1, .reusable = false}}, SHIFT(606),
  [771] = {.entry = {.count = 1, .reusable = true}}, SHIFT(375),
  [773] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3780),
  [775] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7341),
  [777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7341),
  [779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6220),
  [781] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7468),
  [783] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6075),
  [785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2012),
  [787] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4601),
  [789] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4724),
  [791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5032),
  [793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6993),
  [795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6994),
  [797] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2014),
  [799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1793),
  [801] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6974),
  [803] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1860),
  [805] = {.entry = {.count = 1, .reusable = false}}, SHIFT(776),
  [807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(819),
  [809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7320),
  [811] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_slice_range, 1, 0, 0),
  [813] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_range_expression, 3, 0, 0),
  [815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(634),
  [817] = {.entry = {.count = 1, .reusable = false}}, SHIFT(713),
  [819] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7250),
  [821] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2, 0, 0),
  [823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(514),
  [825] = {.entry = {.count = 1, .reusable = false}}, SHIFT(656),
  [827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(468),
  [829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(656),
  [831] = {.entry = {.count = 1, .reusable = false}}, SHIFT(585),
  [833] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7155),
  [835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7155),
  [837] = {.entry = {.count = 1, .reusable = false}}, SHIFT(778),
  [839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(588),
  [841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2110),
  [843] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__list_elements_repeat1, 2, 0, 15),
  [845] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6331),
  [847] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6543),
  [849] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__comp_or_range_expression, 1, 0, 0),
  [851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(480),
  [853] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 1, 0, 0),
  [855] = {.entry = {.count = 1, .reusable = false}}, SHIFT(568),
  [857] = {.entry = {.count = 1, .reusable = true}}, SHIFT(935),
  [859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(707),
  [861] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__list_elements, 2, 0, 0),
  [863] = {.entry = {.count = 1, .reusable = true}}, SHIFT(586),
  [865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1160),
  [867] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__property_accessor_body, 3, 0, 0),
  [869] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__property_accessor_body, 3, 0, 0),
  [871] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__property_accessor_body, 5, 0, 0),
  [873] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__property_accessor_body, 5, 0, 0),
  [875] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__slice_range_special, 3, 0, 34),
  [877] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1988),
  [879] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3853),
  [881] = {.entry = {.count = 1, .reusable = false}}, SHIFT(737),
  [883] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6119),
  [885] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6225),
  [887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(455),
  [889] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2230),
  [891] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5846),
  [893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5845),
  [895] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7229),
  [897] = {.entry = {.count = 1, .reusable = false}}, SHIFT(621),
  [899] = {.entry = {.count = 1, .reusable = false}}, SHIFT(485),
  [901] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5514),
  [903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7427),
  [905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(737),
  [907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3853),
  [909] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2631),
  [911] = {.entry = {.count = 1, .reusable = false}}, SHIFT(557),
  [913] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2856),
  [915] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6193),
  [917] = {.entry = {.count = 1, .reusable = false}}, SHIFT(753),
  [919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(753),
  [921] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7222),
  [923] = {.entry = {.count = 1, .reusable = false}}, SHIFT(682),
  [925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(381),
  [927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3776),
  [929] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7244),
  [931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7244),
  [933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6263),
  [935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(570),
  [937] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7429),
  [939] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6213),
  [941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2098),
  [943] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4650),
  [945] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4836),
  [947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4968),
  [949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6945),
  [951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6946),
  [953] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2100),
  [955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2216),
  [957] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6909),
  [959] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2424),
  [961] = {.entry = {.count = 1, .reusable = false}}, SHIFT(793),
  [963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(825),
  [965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7224),
  [967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(660),
  [969] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4110),
  [971] = {.entry = {.count = 1, .reusable = false}}, SHIFT(706),
  [973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(441),
  [975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(706),
  [977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4110),
  [979] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2657),
  [981] = {.entry = {.count = 1, .reusable = false}}, SHIFT(683),
  [983] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7283),
  [985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7283),
  [987] = {.entry = {.count = 1, .reusable = false}}, SHIFT(788),
  [989] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2010),
  [991] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4057),
  [993] = {.entry = {.count = 1, .reusable = false}}, SHIFT(650),
  [995] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6359),
  [997] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6389),
  [999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(442),
  [1001] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2168),
  [1003] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5776),
  [1005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5777),
  [1007] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7103),
  [1009] = {.entry = {.count = 1, .reusable = false}}, SHIFT(556),
  [1011] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2429),
  [1013] = {.entry = {.count = 1, .reusable = false}}, SHIFT(554),
  [1015] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5555),
  [1017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7374),
  [1019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(650),
  [1021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4057),
  [1023] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2690),
  [1025] = {.entry = {.count = 1, .reusable = false}}, SHIFT(629),
  [1027] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2852),
  [1029] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6081),
  [1031] = {.entry = {.count = 1, .reusable = false}}, SHIFT(742),
  [1033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(742),
  [1035] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7095),
  [1037] = {.entry = {.count = 1, .reusable = false}}, SHIFT(724),
  [1039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(401),
  [1041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3777),
  [1043] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7096),
  [1045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7096),
  [1047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6359),
  [1049] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7377),
  [1051] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6388),
  [1053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2468),
  [1055] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4595),
  [1057] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4728),
  [1059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4960),
  [1061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6554),
  [1063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6555),
  [1065] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2469),
  [1067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2237),
  [1069] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6506),
  [1071] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2182),
  [1073] = {.entry = {.count = 1, .reusable = false}}, SHIFT(805),
  [1075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(824),
  [1077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7097),
  [1079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(727),
  [1081] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1876),
  [1083] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3988),
  [1085] = {.entry = {.count = 1, .reusable = false}}, SHIFT(632),
  [1087] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6277),
  [1089] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6360),
  [1091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(463),
  [1093] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2380),
  [1095] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5837),
  [1097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5839),
  [1099] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7134),
  [1101] = {.entry = {.count = 1, .reusable = false}}, SHIFT(530),
  [1103] = {.entry = {.count = 1, .reusable = false}}, SHIFT(529),
  [1105] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5518),
  [1107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7391),
  [1109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(632),
  [1111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3988),
  [1113] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2680),
  [1115] = {.entry = {.count = 1, .reusable = false}}, SHIFT(648),
  [1117] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2857),
  [1119] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6111),
  [1121] = {.entry = {.count = 1, .reusable = false}}, SHIFT(744),
  [1123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(744),
  [1125] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7127),
  [1127] = {.entry = {.count = 1, .reusable = false}}, SHIFT(620),
  [1129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(390),
  [1131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3786),
  [1133] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7128),
  [1135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7128),
  [1137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6277),
  [1139] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7393),
  [1141] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6348),
  [1143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2260),
  [1145] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4662),
  [1147] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4809),
  [1149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5064),
  [1151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6604),
  [1153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6605),
  [1155] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2261),
  [1157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2464),
  [1159] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6556),
  [1161] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2470),
  [1163] = {.entry = {.count = 1, .reusable = false}}, SHIFT(800),
  [1165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(831),
  [1167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7129),
  [1169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(624),
  [1171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(645),
  [1173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7549),
  [1175] = {.entry = {.count = 1, .reusable = false}}, SHIFT(909),
  [1177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5742),
  [1179] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2398),
  [1181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1676),
  [1183] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6204),
  [1185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(464),
  [1187] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1889),
  [1189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1539),
  [1191] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2204),
  [1193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(972),
  [1195] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2066),
  [1197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(822),
  [1199] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6246),
  [1201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(435),
  [1203] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1984),
  [1205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2837),
  [1207] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2255),
  [1209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1564),
  [1211] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6272),
  [1213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(443),
  [1215] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1560),
  [1217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1629),
  [1219] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6070),
  [1221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(446),
  [1223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5730),
  [1225] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1786),
  [1227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1656),
  [1229] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6311),
  [1231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(449),
  [1233] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_short_comp_expression, 6, 0, 0),
  [1235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(820),
  [1237] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2283),
  [1239] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__slice_range_special, 2, 0, 25),
  [1241] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6343),
  [1243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(453),
  [1245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2832),
  [1247] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__object_construction, 2, 0, 0),
  [1249] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6181),
  [1251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(479),
  [1253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1416),
  [1255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1003),
  [1257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4801),
  [1259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1440),
  [1261] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1803),
  [1263] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3854),
  [1265] = {.entry = {.count = 1, .reusable = false}}, SHIFT(688),
  [1267] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6096),
  [1269] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6131),
  [1271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(451),
  [1273] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2403),
  [1275] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5954),
  [1277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5955),
  [1279] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7289),
  [1281] = {.entry = {.count = 1, .reusable = false}}, SHIFT(709),
  [1283] = {.entry = {.count = 1, .reusable = false}}, SHIFT(711),
  [1285] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5535),
  [1287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7452),
  [1289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(688),
  [1291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3854),
  [1293] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2695),
  [1295] = {.entry = {.count = 1, .reusable = false}}, SHIFT(533),
  [1297] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2860),
  [1299] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6254),
  [1301] = {.entry = {.count = 1, .reusable = false}}, SHIFT(576),
  [1303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(576),
  [1305] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7282),
  [1307] = {.entry = {.count = 1, .reusable = false}}, SHIFT(686),
  [1309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(382),
  [1311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3783),
  [1313] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7301),
  [1315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7301),
  [1317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6096),
  [1319] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7454),
  [1321] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6127),
  [1323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2426),
  [1325] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4639),
  [1327] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4804),
  [1329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5013),
  [1331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6981),
  [1333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6982),
  [1335] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2425),
  [1337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2449),
  [1339] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6947),
  [1341] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2080),
  [1343] = {.entry = {.count = 1, .reusable = false}}, SHIFT(806),
  [1345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(834),
  [1347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7284),
  [1349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(689),
  [1351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1518),
  [1353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1474),
  [1355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1540),
  [1357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1039),
  [1359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1640),
  [1361] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6382),
  [1363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(460),
  [1365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1478),
  [1367] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_range_expression, 5, 0, 0),
  [1369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1433),
  [1371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1283),
  [1373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1808),
  [1375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(661),
  [1377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1796),
  [1379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1400),
  [1381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1674),
  [1383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1367),
  [1385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5739),
  [1387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(843),
  [1389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(849),
  [1391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1309),
  [1393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1993),
  [1395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1535),
  [1397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1850),
  [1399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1649),
  [1401] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1075),
  [1403] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6076),
  [1405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1395),
  [1407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1670),
  [1409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2011),
  [1411] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_initializer, 3, 0, 36),
  [1413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1429),
  [1415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4793),
  [1417] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6124),
  [1419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(469),
  [1421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6387),
  [1423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1460),
  [1425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1472),
  [1427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1532),
  [1429] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6178),
  [1431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(466),
  [1433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7361),
  [1435] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6293),
  [1437] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6291),
  [1439] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1752),
  [1441] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3844),
  [1443] = {.entry = {.count = 1, .reusable = false}}, SHIFT(633),
  [1445] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6200),
  [1447] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6290),
  [1449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(472),
  [1451] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2384),
  [1453] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5995),
  [1455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5996),
  [1457] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7185),
  [1459] = {.entry = {.count = 1, .reusable = false}}, SHIFT(635),
  [1461] = {.entry = {.count = 1, .reusable = false}}, SHIFT(640),
  [1463] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5539),
  [1465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7409),
  [1467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(633),
  [1469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3844),
  [1471] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2646),
  [1473] = {.entry = {.count = 1, .reusable = false}}, SHIFT(701),
  [1475] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2861),
  [1477] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6153),
  [1479] = {.entry = {.count = 1, .reusable = false}}, SHIFT(748),
  [1481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(748),
  [1483] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7178),
  [1485] = {.entry = {.count = 1, .reusable = false}}, SHIFT(519),
  [1487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(366),
  [1489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3788),
  [1491] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7202),
  [1493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7202),
  [1495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6200),
  [1497] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7411),
  [1499] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6278),
  [1501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2152),
  [1503] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4638),
  [1505] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4818),
  [1507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4964),
  [1509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6907),
  [1511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6908),
  [1513] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2144),
  [1515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2233),
  [1517] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6829),
  [1519] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2317),
  [1521] = {.entry = {.count = 1, .reusable = false}}, SHIFT(810),
  [1523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(829),
  [1525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7180),
  [1527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(521),
  [1529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7227),
  [1531] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6020),
  [1533] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6169),
  [1535] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6320),
  [1537] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6105),
  [1539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(457),
  [1541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7074),
  [1543] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6051),
  [1545] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6041),
  [1547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6933),
  [1549] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6221),
  [1551] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6069),
  [1553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6692),
  [1555] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6365),
  [1557] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6227),
  [1559] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6249),
  [1561] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_static_parameter_value, 2, 0, 0),
  [1563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6457),
  [1565] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6281),
  [1567] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6240),
  [1569] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6146),
  [1571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(440),
  [1573] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6383),
  [1575] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6333),
  [1577] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6369),
  [1579] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6346),
  [1581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6617),
  [1583] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6003),
  [1585] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6263),
  [1587] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6362),
  [1589] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6180),
  [1591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7386),
  [1593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6979),
  [1595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5178),
  [1597] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6015),
  [1599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6502),
  [1601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6803),
  [1603] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6195),
  [1605] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6384),
  [1607] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6230),
  [1609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7169),
  [1611] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6104),
  [1613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(971),
  [1615] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6158),
  [1617] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6171),
  [1619] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6080),
  [1621] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6141),
  [1623] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6016),
  [1625] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6231),
  [1627] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6011),
  [1629] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6318),
  [1631] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6266),
  [1633] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6094),
  [1635] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6218),
  [1637] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6282),
  [1639] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6205),
  [1641] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6324),
  [1643] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6354),
  [1645] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6371),
  [1647] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6095),
  [1649] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6167),
  [1651] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6288),
  [1653] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6223),
  [1655] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6008),
  [1657] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6101),
  [1659] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6358),
  [1661] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6061),
  [1663] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7399),
  [1665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(496),
  [1667] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2640),
  [1669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(691),
  [1671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6144),
  [1673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(868),
  [1675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(871),
  [1677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2835),
  [1679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2838),
  [1681] = {.entry = {.count = 1, .reusable = true}}, SHIFT(693),
  [1683] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1239),
  [1685] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__object_construction, 1, 0, 0),
  [1687] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7272),
  [1689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(537),
  [1691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4109),
  [1693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4027),
  [1695] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5114),
  [1697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2787),
  [1699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1080),
  [1701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1085),
  [1703] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1399),
  [1705] = {.entry = {.count = 1, .reusable = false}}, SHIFT(690),
  [1707] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2682),
  [1709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(692),
  [1711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6317),
  [1713] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7435),
  [1715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(587),
  [1717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1801),
  [1719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1726),
  [1721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1946),
  [1723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(423),
  [1725] = {.entry = {.count = 1, .reusable = true}}, SHIFT(510),
  [1727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1562),
  [1729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2316),
  [1731] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1602),
  [1733] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1779),
  [1735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1766),
  [1737] = {.entry = {.count = 1, .reusable = true}}, SHIFT(931),
  [1739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2043),
  [1741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(956),
  [1743] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2025),
  [1745] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2194),
  [1747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2291),
  [1749] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1045),
  [1751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2346),
  [1753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2176),
  [1755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2442),
  [1757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2109),
  [1759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2211),
  [1761] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1950),
  [1763] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1920),
  [1765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1052),
  [1767] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1973),
  [1769] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2350),
  [1771] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2460),
  [1773] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1510),
  [1775] = {.entry = {.count = 1, .reusable = false}}, SHIFT(657),
  [1777] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(1686),
  [1780] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(723),
  [1783] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(6394),
  [1786] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(2351),
  [1789] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(2351),
  [1792] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(6189),
  [1795] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(2000),
  [1798] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(2835),
  [1801] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(5741),
  [1804] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(5747),
  [1807] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(7435),
  [1810] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(583),
  [1813] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(587),
  [1816] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(7436),
  [1819] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(723),
  [1822] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(2655),
  [1825] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(749),
  [1828] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(6233),
  [1831] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(2854),
  [1834] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(6206),
  [1837] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(755),
  [1840] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(755),
  [1843] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(7243),
  [1846] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(7265),
  [1849] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(7265),
  [1852] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(6394),
  [1855] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(7438),
  [1858] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(1799),
  [1861] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(4663),
  [1864] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(4817),
  [1867] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(4994),
  [1870] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(6963),
  [1873] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(6964),
  [1876] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(1801),
  [1879] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(1801),
  [1882] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(6925),
  [1885] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(1726),
  [1888] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(2835),
  [1891] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(2840),
  [1894] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(2838),
  [1897] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(777),
  [1900] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(817),
  [1903] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(7245),
  [1906] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(510),
  [1909] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7451),
  [1911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(711),
  [1913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2425),
  [1915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2080),
  [1917] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_else_in_expression, 2, 0, 0),
  [1919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(710),
  [1921] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(1803),
  [1924] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(688),
  [1927] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(6096),
  [1930] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(6131),
  [1933] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(2403),
  [1936] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(5954),
  [1939] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(5955),
  [1942] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(7451),
  [1945] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(709),
  [1948] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(711),
  [1951] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(7452),
  [1954] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(688),
  [1957] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(2695),
  [1960] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(533),
  [1963] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(2860),
  [1966] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(6254),
  [1969] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(576),
  [1972] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(576),
  [1975] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(7282),
  [1978] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(7301),
  [1981] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(7301),
  [1984] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(6096),
  [1987] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(7454),
  [1990] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(2426),
  [1993] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(4639),
  [1996] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(4804),
  [1999] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(5013),
  [2002] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(6981),
  [2005] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(6982),
  [2008] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(2425),
  [2011] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(2425),
  [2014] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(6947),
  [2017] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(2080),
  [2020] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(806),
  [2023] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(834),
  [2026] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(7284),
  [2029] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(710),
  [2032] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_else_in_expression, 1, 0, 0),
  [2034] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_static_parameter_value, 1, 0, 0),
  [2036] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7408),
  [2038] = {.entry = {.count = 1, .reusable = true}}, SHIFT(640),
  [2040] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2144),
  [2042] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2317),
  [2044] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__slice_range_special, 2, 0, 26),
  [2046] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6236),
  [2048] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7426),
  [2050] = {.entry = {.count = 1, .reusable = true}}, SHIFT(485),
  [2052] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2100),
  [2054] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2424),
  [2056] = {.entry = {.count = 1, .reusable = true}}, SHIFT(747),
  [2058] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6140),
  [2060] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7444),
  [2062] = {.entry = {.count = 1, .reusable = true}}, SHIFT(675),
  [2064] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1859),
  [2066] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1702),
  [2068] = {.entry = {.count = 1, .reusable = true}}, SHIFT(647),
  [2070] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7373),
  [2072] = {.entry = {.count = 1, .reusable = true}}, SHIFT(554),
  [2074] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2469),
  [2076] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2182),
  [2078] = {.entry = {.count = 1, .reusable = true}}, SHIFT(679),
  [2080] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6269),
  [2082] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6064),
  [2084] = {.entry = {.count = 1, .reusable = true}}, SHIFT(540),
  [2086] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6304),
  [2088] = {.entry = {.count = 1, .reusable = true}}, SHIFT(667),
  [2090] = {.entry = {.count = 1, .reusable = true}}, SHIFT(697),
  [2092] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6336),
  [2094] = {.entry = {.count = 1, .reusable = true}}, SHIFT(715),
  [2096] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6093),
  [2098] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6374),
  [2100] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7390),
  [2102] = {.entry = {.count = 1, .reusable = true}}, SHIFT(529),
  [2104] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2261),
  [2106] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2470),
  [2108] = {.entry = {.count = 1, .reusable = true}}, SHIFT(611),
  [2110] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6199),
  [2112] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7465),
  [2114] = {.entry = {.count = 1, .reusable = true}}, SHIFT(740),
  [2116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2014),
  [2118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1860),
  [2120] = {.entry = {.count = 1, .reusable = true}}, SHIFT(628),
  [2122] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6316),
  [2124] = {.entry = {.count = 1, .reusable = true}}, SHIFT(575),
  [2126] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6120),
  [2128] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7458),
  [2130] = {.entry = {.count = 1, .reusable = true}}, SHIFT(726),
  [2132] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1484),
  [2134] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1645),
  [2136] = {.entry = {.count = 1, .reusable = true}}, SHIFT(492),
  [2138] = {.entry = {.count = 1, .reusable = true}}, SHIFT(506),
  [2140] = {.entry = {.count = 1, .reusable = true}}, SHIFT(613),
  [2142] = {.entry = {.count = 1, .reusable = true}}, SHIFT(545),
  [2144] = {.entry = {.count = 1, .reusable = true}}, SHIFT(555),
  [2146] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7417),
  [2148] = {.entry = {.count = 1, .reusable = true}}, SHIFT(725),
  [2150] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1694),
  [2152] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1753),
  [2154] = {.entry = {.count = 1, .reusable = true}}, SHIFT(549),
  [2156] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6172),
  [2158] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_const, 1, 0, 0),
  [2160] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_const, 1, 0, 0),
  [2162] = {.entry = {.count = 1, .reusable = false}}, SHIFT(878),
  [2164] = {.entry = {.count = 1, .reusable = false}}, SHIFT(879),
  [2166] = {.entry = {.count = 1, .reusable = false}}, SHIFT(883),
  [2168] = {.entry = {.count = 1, .reusable = false}}, SHIFT(884),
  [2170] = {.entry = {.count = 1, .reusable = false}}, SHIFT(885),
  [2172] = {.entry = {.count = 1, .reusable = false}}, SHIFT(886),
  [2174] = {.entry = {.count = 1, .reusable = false}}, SHIFT(887),
  [2176] = {.entry = {.count = 1, .reusable = false}}, SHIFT(890),
  [2178] = {.entry = {.count = 1, .reusable = false}}, SHIFT(892),
  [2180] = {.entry = {.count = 1, .reusable = false}}, SHIFT(893),
  [2182] = {.entry = {.count = 1, .reusable = false}}, SHIFT(896),
  [2184] = {.entry = {.count = 1, .reusable = false}}, SHIFT(897),
  [2186] = {.entry = {.count = 1, .reusable = false}}, SHIFT(858),
  [2188] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7043),
  [2190] = {.entry = {.count = 1, .reusable = false}}, SHIFT(898),
  [2192] = {.entry = {.count = 1, .reusable = false}}, SHIFT(900),
  [2194] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1128),
  [2196] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1129),
  [2198] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1130),
  [2200] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1134),
  [2202] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1136),
  [2204] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1138),
  [2206] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1043),
  [2208] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1141),
  [2210] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1143),
  [2212] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1144),
  [2214] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1146),
  [2216] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1147),
  [2218] = {.entry = {.count = 1, .reusable = false}}, SHIFT(967),
  [2220] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7437),
  [2222] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1155),
  [2224] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1157),
  [2226] = {.entry = {.count = 1, .reusable = false}}, SHIFT(769),
  [2228] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constrained_type, 3, 0, 0),
  [2230] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constrained_type, 3, 0, 0),
  [2232] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3904),
  [2234] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3905),
  [2236] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4995),
  [2238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(797),
  [2240] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_flexible_type, 2, 0, 0),
  [2242] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_flexible_type, 2, 0, 0),
  [2244] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_type, 3, 0, 0),
  [2246] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_type, 3, 0, 0),
  [2248] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_compound_type_repeat1, 2, 0, 0),
  [2250] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_compound_type_repeat1, 2, 0, 0),
  [2252] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_typecast_expression, 3, 0, 0),
  [2254] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_typecast_expression, 3, 0, 0),
  [2256] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1536),
  [2258] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1543),
  [2260] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1544),
  [2262] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1545),
  [2264] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1547),
  [2266] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1554),
  [2268] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1652),
  [2270] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1576),
  [2272] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1605),
  [2274] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1616),
  [2276] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1619),
  [2278] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1628),
  [2280] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1362),
  [2282] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7098),
  [2284] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1867),
  [2286] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1869),
  [2288] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1870),
  [2290] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1872),
  [2292] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1873),
  [2294] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1874),
  [2296] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1877),
  [2298] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1878),
  [2300] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1879),
  [2302] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1880),
  [2304] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1883),
  [2306] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1884),
  [2308] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1434),
  [2310] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7200),
  [2312] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_long_identifier, 1, 0, 0),
  [2314] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_long_identifier, 1, 0, 0),
  [2316] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6609),
  [2318] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compound_type_repeat1, 2, 0, 0), SHIFT_REPEAT(3905),
  [2321] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_argument, 1, 0, 0),
  [2323] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_argument, 1, 0, 0),
  [2325] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_argument, 1, 0, 0), SHIFT(5971),
  [2328] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_argument, 2, 0, 0),
  [2330] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_argument, 2, 0, 0),
  [2332] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_expression, 4, 0, 18),
  [2334] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_expression, 4, 0, 18),
  [2336] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6009),
  [2338] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6136),
  [2340] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_type_argument_repeat1, 2, 0, 0),
  [2342] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_type_argument_repeat1, 2, 0, 0),
  [2344] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_argument_repeat1, 2, 0, 0), SHIFT_REPEAT(5971),
  [2347] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2037),
  [2349] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2044),
  [2351] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2045),
  [2353] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2052),
  [2355] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2054),
  [2357] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2055),
  [2359] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2057),
  [2361] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2058),
  [2363] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2059),
  [2365] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2060),
  [2367] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2061),
  [2369] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2065),
  [2371] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1444),
  [2373] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7005),
  [2375] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1825),
  [2377] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1826),
  [2379] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1830),
  [2381] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1831),
  [2383] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1832),
  [2385] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1835),
  [2387] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1837),
  [2389] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1838),
  [2391] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1839),
  [2393] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1840),
  [2395] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1841),
  [2397] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1842),
  [2399] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1436),
  [2401] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7260),
  [2403] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1385),
  [2405] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7082),
  [2407] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_compound_type, 2, 0, 0),
  [2409] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_compound_type, 2, 0, 0),
  [2411] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_long_identifier_repeat1, 2, 0, 0),
  [2413] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_long_identifier_repeat1, 2, 0, 0),
  [2415] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_long_identifier_repeat1, 2, 0, 0), SHIFT_REPEAT(6609),
  [2418] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_long_identifier, 2, 0, 0),
  [2420] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_long_identifier, 2, 0, 0),
  [2422] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_expression, 3, 0, 18),
  [2424] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_expression, 3, 0, 18),
  [2426] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1716),
  [2428] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1717),
  [2430] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1718),
  [2432] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1719),
  [2434] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1720),
  [2436] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1722),
  [2438] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1723),
  [2440] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1727),
  [2442] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1728),
  [2444] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1732),
  [2446] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1737),
  [2448] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1738),
  [2450] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1414),
  [2452] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7455),
  [2454] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_arguments, 5, 0, 0),
  [2456] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_arguments, 5, 0, 0),
  [2458] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1633),
  [2460] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1634),
  [2462] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__static_type_identifier, 2, 0, 0),
  [2464] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__static_type_identifier, 2, 0, 0),
  [2466] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_paren_type, 3, 0, 0),
  [2468] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_paren_type, 3, 0, 0),
  [2470] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_arguments, 4, 0, 0),
  [2472] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_arguments, 4, 0, 0),
  [2474] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_static_type, 2, 0, 0),
  [2476] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_static_type, 2, 0, 0),
  [2478] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2145),
  [2480] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2146),
  [2482] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2147),
  [2484] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2148),
  [2486] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2149),
  [2488] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2150),
  [2490] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2151),
  [2492] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2156),
  [2494] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2157),
  [2496] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2161),
  [2498] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2162),
  [2500] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2163),
  [2502] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1494),
  [2504] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7362),
  [2506] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_arguments, 3, 0, 0),
  [2508] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_arguments, 3, 0, 0),
  [2510] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_list_type, 2, 0, 0),
  [2512] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_list_type, 2, 0, 0),
  [2514] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generic_type, 3, 0, 0),
  [2516] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generic_type, 3, 0, 0),
  [2518] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_if_expression_repeat1, 2, 0, 0),
  [2520] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_if_expression_repeat1, 2, 0, 0),
  [2522] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_if_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(6136),
  [2525] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2326),
  [2527] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2327),
  [2529] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2328),
  [2531] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2330),
  [2533] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2332),
  [2535] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2381),
  [2537] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2340),
  [2539] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2341),
  [2541] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2353),
  [2543] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2354),
  [2545] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2360),
  [2547] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2366),
  [2549] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1595),
  [2551] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6825),
  [2553] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_anon_record_type, 5, 0, 22),
  [2555] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anon_record_type, 5, 0, 22),
  [2557] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_simple_type, 1, 0, 0),
  [2559] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_simple_type, 1, 0, 0),
  [2561] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2759),
  [2563] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generic_type, 4, 0, 0),
  [2565] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generic_type, 4, 0, 0),
  [2567] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type, 1, 0, 0),
  [2569] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type, 1, 0, 0),
  [2571] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2333),
  [2573] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2294),
  [2575] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2293),
  [2577] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2290),
  [2579] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2289),
  [2581] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2281),
  [2583] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2077),
  [2585] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2271),
  [2587] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2263),
  [2589] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2259),
  [2591] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2258),
  [2593] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2257),
  [2595] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1622),
  [2597] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7018),
  [2599] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2410),
  [2601] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2409),
  [2603] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2407),
  [2605] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2406),
  [2607] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2404),
  [2609] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2399),
  [2611] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2076),
  [2613] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2397),
  [2615] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2396),
  [2617] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2395),
  [2619] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2394),
  [2621] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2388),
  [2623] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1508),
  [2625] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7145),
  [2627] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_postfix_type, 2, 0, 0),
  [2629] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_postfix_type, 2, 0, 0),
  [2631] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2125),
  [2633] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2124),
  [2635] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2123),
  [2637] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2122),
  [2639] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2121),
  [2641] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2120),
  [2643] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2119),
  [2645] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2118),
  [2647] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2117),
  [2649] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2116),
  [2651] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2115),
  [2653] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2114),
  [2655] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1673),
  [2657] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7512),
  [2659] = {.entry = {.count = 1, .reusable = false}}, SHIFT(852),
  [2661] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3947),
  [2663] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3941),
  [2665] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5137),
  [2667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(951),
  [2669] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1740),
  [2671] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1741),
  [2673] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1843),
  [2675] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1847),
  [2677] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1885),
  [2679] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1890),
  [2681] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2070),
  [2683] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2071),
  [2685] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__expression_block, 3, 0, 0),
  [2687] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__expression_block, 3, 0, 0),
  [2689] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_rules, 1, 0, 0),
  [2691] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_rules, 1, 0, 0),
  [2693] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2591),
  [2695] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_rules, 1, 0, 0), SHIFT(6589),
  [2698] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_rules, 2, 0, 0),
  [2700] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_rules, 2, 0, 0),
  [2702] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_rules, 2, 0, 0), SHIFT(6589),
  [2705] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2256),
  [2707] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2252),
  [2709] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2165),
  [2711] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2172),
  [2713] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_rules_repeat1, 2, 0, 0),
  [2715] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_rules_repeat1, 2, 0, 0),
  [2717] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_rules_repeat1, 2, 0, 0), SHIFT_REPEAT(2591),
  [2720] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_rules_repeat1, 2, 0, 0), SHIFT_REPEAT(6589),
  [2723] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_float, 3, 0, 10),
  [2725] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_float, 3, 0, 10),
  [2727] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7035),
  [2729] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_elif_expression, 4, 0, 51),
  [2731] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_elif_expression, 4, 0, 51),
  [2733] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2113),
  [2735] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2112),
  [2737] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_rules, 3, 0, 0),
  [2739] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_rules, 3, 0, 0),
  [2741] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_rules, 3, 0, 0), SHIFT(6589),
  [2744] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2368),
  [2746] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2374),
  [2748] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_if_expression_repeat1, 1, 0, 0),
  [2750] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_if_expression_repeat1, 1, 0, 0),
  [2752] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2386),
  [2754] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2385),
  [2756] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_rules_repeat1, 3, 0, 0),
  [2758] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_rules_repeat1, 3, 0, 0),
  [2760] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_rule, 5, 0, 50),
  [2762] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_rule, 5, 0, 50),
  [2764] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7326),
  [2766] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_rule, 3, 0, 37),
  [2768] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_rule, 3, 0, 37),
  [2770] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_while_expression, 4, 0, 0),
  [2772] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_while_expression, 4, 0, 0),
  [2774] = {.entry = {.count = 1, .reusable = false}}, SHIFT(950),
  [2776] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compound_type_repeat1, 2, 0, 0), SHIFT_REPEAT(3941),
  [2779] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6351),
  [2781] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6353),
  [2783] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_expression, 6, 0, 0),
  [2785] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_expression, 6, 0, 0),
  [2787] = {.entry = {.count = 1, .reusable = false}}, SHIFT(938),
  [2789] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_do_expression, 2, 0, 0),
  [2791] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_long_identifier, 1, 0, 0), REDUCE(sym__identifier_or_op, 1, 0, 0),
  [2794] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_long_identifier, 1, 0, 0), REDUCE(sym__identifier_or_op, 1, 0, 0),
  [2797] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_long_identifier, 1, 0, 0), REDUCE(sym__identifier_or_op, 1, 0, 0), SHIFT(7326),
  [2801] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_argument, 1, 0, 0), SHIFT(5888),
  [2804] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_expression, 8, 0, 0),
  [2806] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_expression, 8, 0, 0),
  [2808] = {.entry = {.count = 1, .reusable = false}}, SHIFT(932),
  [2810] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7038),
  [2812] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_float, 5, 0, 32),
  [2814] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_float, 5, 0, 32),
  [2816] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_long_identifier_repeat1, 2, 0, 0), SHIFT_REPEAT(7038),
  [2819] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_float, 2, 0, 3),
  [2821] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_float, 2, 0, 3),
  [2823] = {.entry = {.count = 1, .reusable = false}}, SHIFT(827),
  [2825] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_argument_repeat1, 2, 0, 0), SHIFT_REPEAT(5888),
  [2828] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_long_identifier_repeat1, 2, 0, 0), SHIFT_REPEAT(7326),
  [2831] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_match_expression, 7, 0, 49),
  [2833] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_match_expression, 7, 0, 49),
  [2835] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try_expression, 5, 0, 0),
  [2837] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try_expression, 5, 0, 0),
  [2839] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_application_expression, 1, 0, 0),
  [2841] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_application_expression, 1, 0, 0),
  [2843] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_char, 1, 0, 0),
  [2845] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_char, 1, 0, 0),
  [2847] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sequential_expression, 2, 0, 0),
  [2849] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sequential_expression, 2, 0, 0),
  [2851] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__expression, 1, 0, 0),
  [2853] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__expression, 1, 0, 0),
  [2855] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string, 1, 0, 0),
  [2857] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string, 1, 0, 0),
  [2859] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_triple_quoted_string, 1, 0, 0),
  [2861] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_triple_quoted_string, 1, 0, 0),
  [2863] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__identifier_or_op, 1, 0, 0),
  [2865] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__identifier_or_op, 1, 0, 0),
  [2867] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_long_identifier_or_op, 1, 0, 0),
  [2869] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_long_identifier_or_op, 1, 0, 0),
  [2871] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5671),
  [2873] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_format_string, 2, 0, 0),
  [2875] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_format_string, 2, 0, 0),
  [2877] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_bytearray, 2, 0, 0),
  [2879] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_bytearray, 2, 0, 0),
  [2881] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_do_expression, 2, 0, 0),
  [2883] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_verbatim_bytearray, 2, 0, 0),
  [2885] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_verbatim_bytearray, 2, 0, 0),
  [2887] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sbyte, 2, 0, 0),
  [2889] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sbyte, 2, 0, 0),
  [2891] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_byte, 2, 0, 0),
  [2893] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_byte, 2, 0, 0),
  [2895] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_sequential_expression_repeat1, 2, 0, 0),
  [2897] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_sequential_expression_repeat1, 2, 0, 0),
  [2899] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_sequential_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(696),
  [2902] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_list_expression, 2, 0, 0),
  [2904] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_list_expression, 2, 0, 0),
  [2906] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_expression, 2, 0, 0),
  [2908] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_expression, 2, 0, 0),
  [2910] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_int16, 2, 0, 0),
  [2912] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_int16, 2, 0, 0),
  [2914] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_uint16, 2, 0, 0),
  [2916] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_uint16, 2, 0, 0),
  [2918] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_int32, 2, 0, 0),
  [2920] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_int32, 2, 0, 0),
  [2922] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_uint32, 2, 0, 0),
  [2924] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_uint32, 2, 0, 0),
  [2926] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_nativeint, 2, 0, 0),
  [2928] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_nativeint, 2, 0, 0),
  [2930] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__high_prec_app, 2, 0, 0),
  [2932] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__high_prec_app, 2, 0, 0),
  [2934] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__string_literal, 3, 0, 0),
  [2936] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__string_literal, 3, 0, 0),
  [2938] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_unativeint, 2, 0, 0),
  [2940] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unativeint, 2, 0, 0),
  [2942] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_active_pattern, 3, 0, 9),
  [2944] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_active_pattern, 3, 0, 9),
  [2946] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_int64, 2, 0, 0),
  [2948] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_int64, 2, 0, 0),
  [2950] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_uint64, 2, 0, 0),
  [2952] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_uint64, 2, 0, 0),
  [2954] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_long_identifier_or_op, 3, 0, 0),
  [2956] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_long_identifier_or_op, 3, 0, 0),
  [2958] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_bignum, 2, 0, 0),
  [2960] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_bignum, 2, 0, 0),
  [2962] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_decimal, 2, 0, 0),
  [2964] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decimal, 2, 0, 0),
  [2966] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ieee32, 2, 0, 0),
  [2968] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ieee32, 2, 0, 0),
  [2970] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_active_pattern, 4, 0, 9),
  [2972] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_active_pattern, 4, 0, 9),
  [2974] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ieee64, 2, 0, 0),
  [2976] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ieee64, 2, 0, 0),
  [2978] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_paren_expression, 3, 0, 0),
  [2980] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_paren_expression, 3, 0, 0),
  [2982] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2761),
  [2984] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__string_literal, 2, 0, 0),
  [2986] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__string_literal, 2, 0, 0),
  [2988] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_active_pattern, 5, 0, 31),
  [2990] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_active_pattern, 5, 0, 31),
  [2992] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_list_expression, 3, 0, 0),
  [2994] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_list_expression, 3, 0, 0),
  [2996] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_expression, 3, 0, 0),
  [2998] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_expression, 3, 0, 0),
  [3000] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_if_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(6353),
  [3003] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_literal_expression, 3, 0, 0),
  [3005] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_literal_expression, 3, 0, 0),
  [3007] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_dot_expression, 3, 0, 16),
  [3009] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dot_expression, 3, 0, 16),
  [3011] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_active_pattern, 6, 0, 43),
  [3013] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_active_pattern, 6, 0, 43),
  [3015] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_typed_expression, 3, 0, 0),
  [3017] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_typed_expression, 3, 0, 0),
  [3019] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_format_string, 3, 0, 0),
  [3021] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_format_string, 3, 0, 0),
  [3023] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_bytearray, 3, 0, 0),
  [3025] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_bytearray, 3, 0, 0),
  [3027] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_verbatim_bytearray, 3, 0, 0),
  [3029] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_verbatim_bytearray, 3, 0, 0),
  [3031] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_format_triple_quoted_string, 3, 0, 0),
  [3033] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_format_triple_quoted_string, 3, 0, 0),
  [3035] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_triple_quoted_string, 3, 0, 0),
  [3037] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_triple_quoted_string, 3, 0, 0),
  [3039] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_fun_expression, 4, 0, 0),
  [3041] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_fun_expression, 4, 0, 0),
  [3043] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try_expression, 4, 0, 0),
  [3045] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try_expression, 4, 0, 0),
  [3047] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_expression, 4, 0, 22),
  [3049] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_expression, 4, 0, 22),
  [3051] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_if_in_expression, 4, 0, 27),
  [3053] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if_in_expression, 4, 0, 27),
  [3055] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_expression, 9, 0, 0),
  [3057] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_expression, 9, 0, 0),
  [3059] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_index_expression, 4, 0, 28),
  [3061] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_index_expression, 4, 0, 28),
  [3063] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_index_expression, 4, 0, 0),
  [3065] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_index_expression, 4, 0, 0),
  [3067] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_expression, 7, 0, 0),
  [3069] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_expression, 7, 0, 0),
  [3071] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ce_expression, 6, 0, 47),
  [3073] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ce_expression, 6, 0, 47),
  [3075] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_if_in_expression, 6, 0, 46),
  [3077] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if_in_expression, 6, 0, 46),
  [3079] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_typed_expression, 4, 0, 0),
  [3081] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_typed_expression, 4, 0, 0),
  [3083] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__high_prec_app, 4, 0, 0),
  [3085] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__high_prec_app, 4, 0, 0),
  [3087] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_match_expression, 6, 0, 21),
  [3089] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_match_expression, 6, 0, 21),
  [3091] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_match_expression, 6, 0, 0),
  [3093] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_match_expression, 6, 0, 0),
  [3095] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_verbatim_string, 2, 0, 0),
  [3097] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_verbatim_string, 2, 0, 0),
  [3099] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_expression, 4, 0, 29),
  [3101] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_expression, 4, 0, 29),
  [3103] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_brace_expression, 5, 0, 22),
  [3105] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_brace_expression, 5, 0, 22),
  [3107] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_anon_record_expression, 5, 0, 22),
  [3109] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anon_record_expression, 5, 0, 22),
  [3111] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_while_expression, 5, 0, 0),
  [3113] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_while_expression, 5, 0, 0),
  [3115] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_verbatim_string, 3, 0, 0),
  [3117] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_verbatim_string, 3, 0, 0),
  [3119] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_match_expression, 5, 0, 0),
  [3121] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_match_expression, 5, 0, 0),
  [3123] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_expression, 5, 0, 41),
  [3125] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_expression, 5, 0, 41),
  [3127] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__else_expression, 2, 0, 40),
  [3129] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__else_expression, 2, 0, 40),
  [3131] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_if_in_expression, 5, 0, 27),
  [3133] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if_in_expression, 5, 0, 27),
  [3135] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_begin_end_expression, 5, 0, 22),
  [3137] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_begin_end_expression, 5, 0, 22),
  [3139] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_if_in_expression, 5, 0, 39),
  [3141] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if_in_expression, 5, 0, 39),
  [3143] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3979),
  [3145] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4036),
  [3147] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4957),
  [3149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1153),
  [3151] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1033),
  [3153] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7368),
  [3155] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1044),
  [3157] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3822),
  [3159] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3882),
  [3161] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4963),
  [3163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1273),
  [3165] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_rules_repeat1, 2, 0, 0), SHIFT_REPEAT(2576),
  [3168] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_rules_repeat1, 2, 0, 0), SHIFT_REPEAT(6424),
  [3171] = {.entry = {.count = 1, .reusable = false}}, SHIFT(964),
  [3173] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1158),
  [3175] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3960),
  [3177] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3949),
  [3179] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4984),
  [3181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1278),
  [3183] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2576),
  [3185] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_rules, 2, 0, 0), SHIFT(6424),
  [3188] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1067),
  [3190] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3964),
  [3192] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3966),
  [3194] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4971),
  [3196] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1185),
  [3198] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_rules, 1, 0, 0), SHIFT(6424),
  [3201] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_rules, 3, 0, 0), SHIFT(6424),
  [3204] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1180),
  [3206] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4128),
  [3208] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4120),
  [3210] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5025),
  [3212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1393),
  [3214] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1228),
  [3216] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4034),
  [3218] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4043),
  [3220] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4986),
  [3222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1313),
  [3224] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3900),
  [3226] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3897),
  [3228] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5020),
  [3230] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1322),
  [3232] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6164),
  [3234] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6264),
  [3236] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1194),
  [3238] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3871),
  [3240] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3955),
  [3242] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4959),
  [3244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1302),
  [3246] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1125),
  [3248] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_argument, 1, 0, 0), SHIFT(5824),
  [3251] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compound_type_repeat1, 2, 0, 0), SHIFT_REPEAT(4036),
  [3254] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1113),
  [3256] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3802),
  [3258] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4967),
  [3260] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1331),
  [3262] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_long_identifier_repeat1, 2, 0, 0), SHIFT_REPEAT(6442),
  [3265] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1177),
  [3267] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6442),
  [3269] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_long_identifier, 1, 0, 0), REDUCE(sym__identifier_or_op, 1, 0, 0), SHIFT(6601),
  [3273] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_argument_repeat1, 2, 0, 0), SHIFT_REPEAT(5824),
  [3276] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6601),
  [3278] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_long_identifier_repeat1, 2, 0, 0), SHIFT_REPEAT(6601),
  [3281] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1224),
  [3283] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3898),
  [3285] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1049),
  [3287] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6446),
  [3289] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_argument_repeat1, 2, 0, 0), SHIFT_REPEAT(5863),
  [3292] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6361),
  [3294] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6280),
  [3296] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6245),
  [3298] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6214),
  [3300] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_argument_repeat1, 2, 0, 0), SHIFT_REPEAT(5892),
  [3303] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_argument, 1, 0, 0), SHIFT(5892),
  [3306] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6459),
  [3308] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_if_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(6264),
  [3311] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_long_identifier_repeat1, 2, 0, 0), SHIFT_REPEAT(6415),
  [3314] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6123),
  [3316] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6243),
  [3318] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6415),
  [3320] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_argument, 1, 0, 0), SHIFT(5863),
  [3323] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_argument, 1, 0, 0), SHIFT(5761),
  [3326] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compound_type_repeat1, 2, 0, 0), SHIFT_REPEAT(3966),
  [3329] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_sequential_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(518),
  [3332] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compound_type_repeat1, 2, 0, 0), SHIFT_REPEAT(3949),
  [3335] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_argument_repeat1, 2, 0, 0), SHIFT_REPEAT(5761),
  [3338] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6215),
  [3340] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6190),
  [3342] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5686),
  [3344] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_long_identifier_repeat1, 2, 0, 0), SHIFT_REPEAT(6446),
  [3347] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compound_type_repeat1, 2, 0, 0), SHIFT_REPEAT(3882),
  [3350] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2729),
  [3352] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_long_identifier_repeat1, 2, 0, 0), SHIFT_REPEAT(6459),
  [3355] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_if_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(6214),
  [3358] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_argument_repeat1, 2, 0, 0), SHIFT_REPEAT(5843),
  [3361] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6851),
  [3363] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6870),
  [3365] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2763),
  [3367] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6298),
  [3369] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6085),
  [3371] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6443),
  [3373] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7081),
  [3375] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compound_type_repeat1, 2, 0, 0), SHIFT_REPEAT(4120),
  [3378] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_long_identifier_repeat1, 2, 0, 0), SHIFT_REPEAT(6851),
  [3381] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_argument, 1, 0, 0), SHIFT(5843),
  [3384] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6019),
  [3386] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6260),
  [3388] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_argument_repeat1, 2, 0, 0), SHIFT_REPEAT(5836),
  [3391] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compound_type_repeat1, 2, 0, 0), SHIFT_REPEAT(3802),
  [3394] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_long_identifier_repeat1, 2, 0, 0), SHIFT_REPEAT(6443),
  [3397] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compound_type_repeat1, 2, 0, 0), SHIFT_REPEAT(3897),
  [3400] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7159),
  [3402] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_long_identifier_repeat1, 2, 0, 0), SHIFT_REPEAT(6453),
  [3405] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_argument_repeat1, 2, 0, 0), SHIFT_REPEAT(5883),
  [3408] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6453),
  [3410] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6482),
  [3412] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_long_identifier_repeat1, 2, 0, 0), SHIFT_REPEAT(6482),
  [3415] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_long_identifier, 1, 0, 0), REDUCE(sym__identifier_or_op, 1, 0, 0), SHIFT(7038),
  [3419] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_argument, 1, 0, 0), SHIFT(5836),
  [3422] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_argument, 1, 0, 0), SHIFT(5883),
  [3425] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_argument, 1, 0, 0), SHIFT(5923),
  [3428] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_long_identifier_repeat1, 2, 0, 0), SHIFT_REPEAT(6870),
  [3431] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compound_type_repeat1, 2, 0, 0), SHIFT_REPEAT(4043),
  [3434] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_argument_repeat1, 2, 0, 0), SHIFT_REPEAT(5874),
  [3437] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6192),
  [3439] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6128),
  [3441] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_argument_repeat1, 2, 0, 0), SHIFT_REPEAT(5923),
  [3444] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6047),
  [3446] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6156),
  [3448] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compound_type_repeat1, 2, 0, 0), SHIFT_REPEAT(3955),
  [3451] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_argument, 1, 0, 0), SHIFT(5874),
  [3454] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_if_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(6243),
  [3457] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_if_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(6190),
  [3460] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6363),
  [3462] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6202),
  [3464] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_if_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(6280),
  [3467] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2752),
  [3469] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2743),
  [3471] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_rules_repeat1, 2, 0, 0), SHIFT_REPEAT(2592),
  [3474] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_rules_repeat1, 2, 0, 0), SHIFT_REPEAT(6898),
  [3477] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7235),
  [3479] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_if_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(6156),
  [3482] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_if_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(6202),
  [3485] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2592),
  [3487] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_rules, 3, 0, 0), SHIFT(6898),
  [3490] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2735),
  [3492] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_if_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(6085),
  [3495] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7182),
  [3497] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2757),
  [3499] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2747),
  [3501] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2724),
  [3503] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_if_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(6128),
  [3506] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6997),
  [3508] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_rules, 2, 0, 0), SHIFT(6898),
  [3511] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_rules, 1, 0, 0), SHIFT(6898),
  [3514] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1195),
  [3516] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_if_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(6260),
  [3519] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2751),
  [3521] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1220),
  [3523] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7422),
  [3525] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1612),
  [3527] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1962),
  [3529] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_long_identifier, 1, 0, 0), REDUCE(sym__identifier_or_op, 1, 0, 0), SHIFT(6727),
  [3533] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7306),
  [3535] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6957),
  [3537] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_rules_repeat1, 2, 0, 0), SHIFT_REPEAT(2597),
  [3540] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_rules_repeat1, 2, 0, 0), SHIFT_REPEAT(6918),
  [3543] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_rules_repeat1, 2, 0, 0), SHIFT_REPEAT(2611),
  [3546] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_rules_repeat1, 2, 0, 0), SHIFT_REPEAT(6685),
  [3549] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2597),
  [3551] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_rules, 3, 0, 0), SHIFT(6918),
  [3554] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_rules, 2, 0, 0), SHIFT(6918),
  [3557] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2611),
  [3559] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_rules, 3, 0, 0), SHIFT(6685),
  [3562] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3283),
  [3564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3261),
  [3566] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5538),
  [3568] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2567),
  [3570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4097),
  [3572] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2579),
  [3574] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4815),
  [3576] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4718),
  [3578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2673),
  [3580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5072),
  [3582] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5792),
  [3584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5795),
  [3586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5796),
  [3588] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2849),
  [3590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4736),
  [3592] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4605),
  [3594] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4757),
  [3596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5079),
  [3598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7401),
  [3600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7395),
  [3602] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4765),
  [3604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4765),
  [3606] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7384),
  [3608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3488),
  [3610] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3770),
  [3612] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3785),
  [3614] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_rules, 2, 0, 0), SHIFT(6685),
  [3617] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_rules, 1, 0, 0), SHIFT(6918),
  [3620] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1386),
  [3622] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_rules, 1, 0, 0), SHIFT(6685),
  [3625] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2016),
  [3627] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_sequential_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(488),
  [3630] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1617),
  [3632] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6706),
  [3634] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1310),
  [3636] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1592),
  [3638] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1287),
  [3640] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7345),
  [3642] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1758),
  [3644] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1338),
  [3646] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6727),
  [3648] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_long_identifier, 1, 0, 0), REDUCE(sym__identifier_or_op, 1, 0, 0), SHIFT(6503),
  [3652] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2577),
  [3654] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_rules, 3, 0, 0), SHIFT(6778),
  [3657] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_long_identifier_repeat1, 2, 0, 0), SHIFT_REPEAT(6503),
  [3660] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_long_identifier_repeat1, 2, 0, 0), SHIFT_REPEAT(6727),
  [3663] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_rules_repeat1, 2, 0, 0), SHIFT_REPEAT(2577),
  [3666] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_rules_repeat1, 2, 0, 0), SHIFT_REPEAT(6778),
  [3669] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2575),
  [3671] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_rules, 3, 0, 0), SHIFT(6818),
  [3674] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_rules, 1, 0, 0), SHIFT(6778),
  [3677] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7126),
  [3679] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_rules, 1, 0, 0), SHIFT(6818),
  [3682] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_rules, 2, 0, 0), SHIFT(6818),
  [3685] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_rules_repeat1, 2, 0, 0), SHIFT_REPEAT(2575),
  [3688] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_rules_repeat1, 2, 0, 0), SHIFT_REPEAT(6818),
  [3691] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6503),
  [3693] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_rules, 2, 0, 0), SHIFT(6778),
  [3696] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1959),
  [3698] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2265),
  [3700] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_rules_repeat1, 2, 0, 0), SHIFT_REPEAT(2602),
  [3703] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_rules_repeat1, 2, 0, 0), SHIFT_REPEAT(6484),
  [3706] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_sequential_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(514),
  [3709] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2602),
  [3711] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_rules, 3, 0, 0), SHIFT(6484),
  [3714] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_identifier_pattern, 2, 0, 0),
  [3716] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_identifier_pattern, 2, 0, 0),
  [3718] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7212),
  [3720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2625),
  [3722] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2667),
  [3724] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2664),
  [3726] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2696),
  [3728] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1970),
  [3730] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1442),
  [3732] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2596),
  [3734] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_rules, 1, 0, 0), SHIFT(6539),
  [3737] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_rules, 2, 0, 0), SHIFT(6484),
  [3740] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1930),
  [3742] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_sequential_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(588),
  [3745] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1919),
  [3747] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1459),
  [3749] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_rules_repeat1, 2, 0, 0), SHIFT_REPEAT(2590),
  [3752] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_rules_repeat1, 2, 0, 0), SHIFT_REPEAT(6637),
  [3755] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_long_identifier, 1, 0, 0), REDUCE(sym__identifier_or_op, 1, 0, 0), SHIFT(7268),
  [3759] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2590),
  [3761] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_rules, 3, 0, 0), SHIFT(6637),
  [3764] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_long_identifier, 1, 0, 0), REDUCE(sym__identifier_or_op, 1, 0, 0), SHIFT(6405),
  [3768] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_rules, 1, 0, 0), SHIFT(6484),
  [3771] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_rules, 2, 0, 0), SHIFT(6539),
  [3774] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_rules, 3, 0, 0), SHIFT(6539),
  [3777] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_rules, 2, 0, 0), SHIFT(6637),
  [3780] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_rules_repeat1, 2, 0, 0), SHIFT_REPEAT(2596),
  [3783] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_rules_repeat1, 2, 0, 0), SHIFT_REPEAT(6539),
  [3786] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1934),
  [3788] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_long_identifier_repeat1, 2, 0, 0), SHIFT_REPEAT(7268),
  [3791] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_sequential_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(586),
  [3794] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2585),
  [3796] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_rules, 1, 0, 0), SHIFT(6858),
  [3799] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_rules, 2, 0, 0), SHIFT(6858),
  [3802] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_long_identifier_repeat1, 2, 0, 0), SHIFT_REPEAT(6746),
  [3805] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_rules, 1, 0, 0), SHIFT(6637),
  [3808] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6537),
  [3810] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_long_identifier_repeat1, 2, 0, 0), SHIFT_REPEAT(6537),
  [3813] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6405),
  [3815] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_long_identifier_repeat1, 2, 0, 0), SHIFT_REPEAT(6405),
  [3818] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_sequential_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(539),
  [3821] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2371),
  [3823] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1431),
  [3825] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6746),
  [3827] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_rules, 3, 0, 0), SHIFT(6858),
  [3830] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_rules_repeat1, 2, 0, 0), SHIFT_REPEAT(2585),
  [3833] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_rules_repeat1, 2, 0, 0), SHIFT_REPEAT(6858),
  [3836] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6892),
  [3838] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_long_identifier_repeat1, 2, 0, 0), SHIFT_REPEAT(6892),
  [3841] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7268),
  [3843] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1402),
  [3845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(486),
  [3847] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1771),
  [3849] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7140),
  [3851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2639),
  [3853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2638),
  [3855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2628),
  [3857] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2626),
  [3859] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_sequential_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(671),
  [3862] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1756),
  [3864] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5617),
  [3866] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_long_identifier, 1, 0, 0), REDUCE(sym__identifier_or_op, 1, 0, 0), SHIFT(6537),
  [3870] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3280),
  [3872] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2619),
  [3874] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5241),
  [3876] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5187),
  [3878] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2624),
  [3880] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5164),
  [3882] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5770),
  [3884] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5772),
  [3886] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5745),
  [3888] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5396),
  [3890] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4699),
  [3892] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4740),
  [3894] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5173),
  [3896] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6449),
  [3898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6450),
  [3900] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5389),
  [3902] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5389),
  [3904] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6451),
  [3906] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3521),
  [3908] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3791),
  [3910] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4134),
  [3912] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_sequential_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(480),
  [3915] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2033),
  [3917] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_sequential_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(738),
  [3920] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2013),
  [3922] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_long_identifier, 1, 0, 0), REDUCE(sym__identifier_or_op, 1, 0, 0), SHIFT(6892),
  [3926] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1401),
  [3928] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2241),
  [3930] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2608),
  [3932] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_rules, 1, 0, 0), SHIFT(6733),
  [3935] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_rules, 2, 0, 0), SHIFT(6733),
  [3938] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_rules, 3, 0, 0), SHIFT(6733),
  [3941] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_rules_repeat1, 2, 0, 0), SHIFT_REPEAT(2608),
  [3944] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_rules_repeat1, 2, 0, 0), SHIFT_REPEAT(6733),
  [3947] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_long_identifier, 1, 0, 0), REDUCE(sym__identifier_or_op, 1, 0, 0), SHIFT(6746),
  [3951] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2423),
  [3953] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_sequential_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(521),
  [3956] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5658),
  [3958] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2235),
  [3960] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_identifier_pattern, 1, 0, 0),
  [3962] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2600),
  [3964] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_identifier_pattern, 1, 0, 0),
  [3966] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3506),
  [3968] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3507),
  [3970] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2675),
  [3972] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5068),
  [3974] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5991),
  [3976] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5993),
  [3978] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5825),
  [3980] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3498),
  [3982] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4599),
  [3984] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4734),
  [3986] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5073),
  [3988] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6747),
  [3990] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6748),
  [3992] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3497),
  [3994] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3497),
  [3996] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2866),
  [3998] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2869),
  [4000] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5588),
  [4002] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2155),
  [4004] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2160),
  [4006] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2184),
  [4008] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_long_identifier, 1, 0, 0), REDUCE(sym__identifier_or_op, 1, 0, 0), SHIFT(7162),
  [4012] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2250),
  [4014] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2617),
  [4016] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3546),
  [4018] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3544),
  [4020] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2637),
  [4022] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5149),
  [4024] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5830),
  [4026] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5831),
  [4028] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5765),
  [4030] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3508),
  [4032] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4654),
  [4034] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4838),
  [4036] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5051),
  [4038] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6504),
  [4040] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6505),
  [4042] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3509),
  [4044] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3509),
  [4046] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2865),
  [4048] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2871),
  [4050] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_sequential_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(727),
  [4053] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_long_identifier, 1, 0, 0), REDUCE(sym__identifier_or_op, 1, 0, 0), SHIFT(6519),
  [4057] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5649),
  [4059] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5580),
  [4061] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_long_identifier_repeat1, 2, 0, 0), SHIFT_REPEAT(6770),
  [4064] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6770),
  [4066] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2342),
  [4068] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2376),
  [4070] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_sequential_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(689),
  [4073] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3324),
  [4075] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6562),
  [4077] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2571),
  [4079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2656),
  [4081] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5431),
  [4083] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5429),
  [4085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2671),
  [4087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4954),
  [4089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2627),
  [4091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2704),
  [4093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2702),
  [4095] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5962),
  [4097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5957),
  [4099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5849),
  [4101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5474),
  [4103] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4621),
  [4105] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4770),
  [4107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5050),
  [4109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6787),
  [4111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6788),
  [4113] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5475),
  [4115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5475),
  [4117] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6654),
  [4119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3653),
  [4121] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3803),
  [4123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4138),
  [4125] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6516),
  [4127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2650),
  [4129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2659),
  [4131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2623),
  [4133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2672),
  [4135] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2416),
  [4137] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2451),
  [4139] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_long_identifier, 1, 0, 0), REDUCE(sym__identifier_or_op, 1, 0, 0), SHIFT(6671),
  [4143] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_sequential_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(645),
  [4146] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_long_identifier_repeat1, 2, 0, 0), SHIFT_REPEAT(6671),
  [4149] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7162),
  [4151] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6671),
  [4153] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_long_identifier_repeat1, 2, 0, 0), SHIFT_REPEAT(7162),
  [4156] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_sequential_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(624),
  [4159] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2312),
  [4161] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_long_identifier_repeat1, 2, 0, 0), SHIFT_REPEAT(6519),
  [4164] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6519),
  [4166] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_long_identifier, 1, 0, 0), REDUCE(sym__identifier_or_op, 1, 0, 0), SHIFT(6770),
  [4170] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2253),
  [4172] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_long_identifier_repeat1, 2, 0, 0), SHIFT_REPEAT(6479),
  [4175] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3326),
  [4177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2665),
  [4179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5147),
  [4181] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6789),
  [4183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3613),
  [4185] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6479),
  [4187] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_long_identifier, 1, 0, 0), REDUCE(sym__identifier_or_op, 1, 0, 0), SHIFT(6479),
  [4191] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_sequential_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(660),
  [4194] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5695),
  [4196] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3411),
  [4198] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6822),
  [4200] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2686),
  [4202] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2706),
  [4204] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5117),
  [4206] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2621),
  [4208] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2663),
  [4210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2634),
  [4212] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6606),
  [4214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3734),
  [4216] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5651),
  [4218] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2584),
  [4220] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3588),
  [4222] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3587),
  [4224] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2700),
  [4226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5131),
  [4228] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5878),
  [4230] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5882),
  [4232] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5912),
  [4234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3657),
  [4236] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4707),
  [4238] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4714),
  [4240] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4980),
  [4242] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6954),
  [4244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6955),
  [4246] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3658),
  [4248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3658),
  [4250] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2868),
  [4252] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2872),
  [4254] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5685),
  [4256] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2581),
  [4258] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3640),
  [4260] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3642),
  [4262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2705),
  [4264] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5157),
  [4266] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5754),
  [4268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5752),
  [4270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5899),
  [4272] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3678),
  [4274] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4632),
  [4276] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4711),
  [4278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4947),
  [4280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6923),
  [4282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6924),
  [4284] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3606),
  [4286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3606),
  [4288] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2867),
  [4290] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2873),
  [4292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6050),
  [4294] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4020),
  [4296] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6672),
  [4298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4948),
  [4300] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2295),
  [4302] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2300),
  [4304] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5593),
  [4306] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5601),
  [4308] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2578),
  [4310] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3731),
  [4312] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3732),
  [4314] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2661),
  [4316] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5046),
  [4318] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5858),
  [4320] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5855),
  [4322] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5871),
  [4324] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3742),
  [4326] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4648),
  [4328] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4849),
  [4330] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5001),
  [4332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6867),
  [4334] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6868),
  [4336] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3709),
  [4338] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3709),
  [4340] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2870),
  [4342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2874),
  [4344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2573),
  [4346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2583),
  [4348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2606),
  [4350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2582),
  [4352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2574),
  [4354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2610),
  [4356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2570),
  [4358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2586),
  [4360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2589),
  [4362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2595),
  [4364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2588),
  [4366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2607),
  [4368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2612),
  [4370] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__method_defn_repeat1, 2, 0, 0), SHIFT_REPEAT(3283),
  [4373] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__method_defn_repeat1, 2, 0, 0),
  [4375] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__method_defn_repeat1, 2, 0, 0), SHIFT_REPEAT(3261),
  [4378] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__method_defn_repeat1, 2, 0, 0), SHIFT_REPEAT(2617),
  [4381] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__method_defn_repeat1, 2, 0, 0), SHIFT_REPEAT(3546),
  [4384] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__method_defn_repeat1, 2, 0, 0), SHIFT_REPEAT(3544),
  [4387] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__method_defn_repeat1, 2, 0, 0), SHIFT_REPEAT(2637),
  [4390] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__method_defn_repeat1, 2, 0, 0), SHIFT_REPEAT(5149),
  [4393] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__method_defn_repeat1, 2, 0, 0), SHIFT_REPEAT(5830),
  [4396] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__method_defn_repeat1, 2, 0, 0), SHIFT_REPEAT(5831),
  [4399] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__method_defn_repeat1, 2, 0, 0), SHIFT_REPEAT(5765),
  [4402] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__method_defn_repeat1, 2, 0, 0), SHIFT_REPEAT(3508),
  [4405] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__method_defn_repeat1, 2, 0, 0), SHIFT_REPEAT(4654),
  [4408] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__method_defn_repeat1, 2, 0, 0), SHIFT_REPEAT(4838),
  [4411] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__method_defn_repeat1, 2, 0, 0), SHIFT_REPEAT(5051),
  [4414] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__method_defn_repeat1, 2, 0, 0), SHIFT_REPEAT(6504),
  [4417] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__method_defn_repeat1, 2, 0, 0), SHIFT_REPEAT(6505),
  [4420] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__method_defn_repeat1, 2, 0, 0), SHIFT_REPEAT(3509),
  [4423] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__method_defn_repeat1, 2, 0, 0), SHIFT_REPEAT(3509),
  [4426] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__method_defn_repeat1, 2, 0, 0), SHIFT_REPEAT(7384),
  [4429] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__method_defn_repeat1, 2, 0, 0), SHIFT_REPEAT(3488),
  [4432] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__method_defn_repeat1, 2, 0, 0), SHIFT_REPEAT(2865),
  [4435] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__method_defn_repeat1, 2, 0, 0), SHIFT_REPEAT(2871),
  [4438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6306),
  [4440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6165),
  [4442] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3302),
  [4444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2703),
  [4446] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2822),
  [4448] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2814),
  [4450] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2812),
  [4452] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2817),
  [4454] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2800),
  [4456] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2806),
  [4458] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2808),
  [4460] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2810),
  [4462] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2811),
  [4464] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2813),
  [4466] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2797),
  [4468] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2819),
  [4470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2794),
  [4472] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6510),
  [4474] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3394),
  [4476] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3327),
  [4478] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3344),
  [4480] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3351),
  [4482] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3335),
  [4484] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3339),
  [4486] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3350),
  [4488] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3329),
  [4490] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3353),
  [4492] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3342),
  [4494] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3405),
  [4496] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3370),
  [4498] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2823),
  [4500] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2824),
  [4502] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5887),
  [4504] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2745),
  [4506] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_argument_repeat1, 2, 0, 0), SHIFT_REPEAT(5887),
  [4509] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4997),
  [4511] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3938),
  [4513] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4771),
  [4515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7372),
  [4517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3256),
  [4519] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3820),
  [4521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7515),
  [4523] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2801),
  [4525] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4630),
  [4527] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4784),
  [4529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5124),
  [4531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6700),
  [4533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6701),
  [4535] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2803),
  [4537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2803),
  [4539] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2615),
  [4541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2707),
  [4543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4493),
  [4545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3276),
  [4547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4626),
  [4549] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3073),
  [4551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2779),
  [4553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3067),
  [4555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4475),
  [4557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1358),
  [4559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5229),
  [4561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4625),
  [4563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4540),
  [4565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4729),
  [4567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1104),
  [4569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3185),
  [4571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5128),
  [4573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3149),
  [4575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3126),
  [4577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4661),
  [4579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1347),
  [4581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3237),
  [4583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4543),
  [4585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4677),
  [4587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4505),
  [4589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3156),
  [4591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4456),
  [4593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3152),
  [4595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1260),
  [4597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3232),
  [4599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7505),
  [4601] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3959),
  [4603] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2685),
  [4605] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4163),
  [4607] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5925),
  [4609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5927),
  [4611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5805),
  [4613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5148),
  [4615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4150),
  [4617] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4705),
  [4619] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4715),
  [4621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5162),
  [4623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6652),
  [4625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6653),
  [4627] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4152),
  [4629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4152),
  [4631] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3200),
  [4633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3323),
  [4635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1396),
  [4637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4700),
  [4639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1376),
  [4641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1247),
  [4643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3253),
  [4645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4234),
  [4647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5545),
  [4649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4879),
  [4651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1318),
  [4653] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_long_identifier_repeat1, 2, 0, 0), SHIFT_REPEAT(7505),
  [4656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(798),
  [4658] = {.entry = {.count = 1, .reusable = true}}, SHIFT(930),
  [4660] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3218),
  [4662] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1234),
  [4664] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4413),
  [4666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3992),
  [4668] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_compound_type_repeat1, 2, 0, 0), SHIFT_REPEAT(4027),
  [4671] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2720),
  [4673] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6597),
  [4675] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2791),
  [4677] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__function_or_value_defns, 2, 0, 23),
  [4679] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2473),
  [4681] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_or_value_defns, 2, 0, 23),
  [4683] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__function_or_value_defns, 1, 0, 13),
  [4685] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_or_value_defns, 1, 0, 13),
  [4687] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__function_or_value_defns_repeat1, 2, 0, 23),
  [4689] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__function_or_value_defns_repeat1, 2, 0, 23), SHIFT_REPEAT(2473),
  [4692] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__function_or_value_defns_repeat1, 2, 0, 23),
  [4694] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__function_or_value_defn_body, 3, 0, 24),
  [4696] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_or_value_defn_body, 3, 0, 24),
  [4698] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__function_or_value_defns_repeat1, 2, 0, 5),
  [4700] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__function_or_value_defns_repeat1, 2, 0, 5),
  [4702] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_prefix_op_repeat1, 2, 0, 0),
  [4704] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_prefix_op_repeat1, 2, 0, 0),
  [4706] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_prefix_op_repeat1, 2, 0, 0), SHIFT_REPEAT(2840),
  [4709] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__function_or_value_defn_body, 5, 0, 45),
  [4711] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_or_value_defn_body, 5, 0, 45),
  [4713] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_prefix_op, 1, 0, 0),
  [4715] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_prefix_op, 1, 0, 0),
  [4717] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__infix_or_prefix_op, 1, 0, 0),
  [4719] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__infix_or_prefix_op, 1, 0, 0),
  [4721] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_or_value_defn, 3, 0, 12),
  [4723] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_or_value_defn, 3, 0, 12),
  [4725] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_infix_op, 1, 0, 0),
  [4727] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_infix_op, 1, 0, 0),
  [4729] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_prefix_op_repeat1, 1, 0, 0),
  [4731] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_prefix_op_repeat1, 1, 0, 0),
  [4733] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_or_value_defn, 2, 0, 5),
  [4735] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_or_value_defn, 2, 0, 5),
  [4737] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_patterns, 1, 0, 0),
  [4739] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_argument_patterns_repeat1, 2, 0, 0), SHIFT_REPEAT(3959),
  [4742] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_argument_patterns_repeat1, 2, 0, 0),
  [4744] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_argument_patterns_repeat1, 2, 0, 0), SHIFT_REPEAT(2685),
  [4747] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_argument_patterns_repeat1, 2, 0, 0), SHIFT_REPEAT(4163),
  [4750] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_argument_patterns_repeat1, 2, 0, 0), SHIFT_REPEAT(5925),
  [4753] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_argument_patterns_repeat1, 2, 0, 0), SHIFT_REPEAT(5927),
  [4756] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_argument_patterns_repeat1, 2, 0, 0), SHIFT_REPEAT(5805),
  [4759] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_argument_patterns_repeat1, 2, 0, 0), SHIFT_REPEAT(4150),
  [4762] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_argument_patterns_repeat1, 2, 0, 0), SHIFT_REPEAT(4705),
  [4765] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_argument_patterns_repeat1, 2, 0, 0), SHIFT_REPEAT(4715),
  [4768] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_argument_patterns_repeat1, 2, 0, 0), SHIFT_REPEAT(5162),
  [4771] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_argument_patterns_repeat1, 2, 0, 0), SHIFT_REPEAT(6652),
  [4774] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_argument_patterns_repeat1, 2, 0, 0), SHIFT_REPEAT(6653),
  [4777] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_argument_patterns_repeat1, 2, 0, 0), SHIFT_REPEAT(4152),
  [4780] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_argument_patterns_repeat1, 2, 0, 0), SHIFT_REPEAT(4152),
  [4783] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_argument_patterns_repeat1, 2, 0, 0), SHIFT_REPEAT(3200),
  [4786] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_argument_patterns_repeat1, 2, 0, 0), SHIFT_REPEAT(3323),
  [4789] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3552),
  [4791] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3553),
  [4793] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3554),
  [4795] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3557),
  [4797] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3558),
  [4799] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3559),
  [4801] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3561),
  [4803] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3571),
  [4805] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3563),
  [4807] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3564),
  [4809] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3565),
  [4811] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3566),
  [4813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3316),
  [4815] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7141),
  [4817] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3481),
  [4819] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3480),
  [4821] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3473),
  [4823] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3472),
  [4825] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3471),
  [4827] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3470),
  [4829] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3469),
  [4831] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3468),
  [4833] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3467),
  [4835] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3466),
  [4837] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3465),
  [4839] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3464),
  [4841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3275),
  [4843] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6710),
  [4845] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3647),
  [4847] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3645),
  [4849] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3644),
  [4851] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3575),
  [4853] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3589),
  [4855] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3679),
  [4857] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3641),
  [4859] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3675),
  [4861] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3577),
  [4863] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3590),
  [4865] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3604),
  [4867] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3609),
  [4869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3392),
  [4871] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7541),
  [4873] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3697),
  [4875] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3698),
  [4877] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3699),
  [4879] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3701),
  [4881] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3707),
  [4883] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3700),
  [4885] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3695),
  [4887] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3681),
  [4889] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3676),
  [4891] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3668),
  [4893] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3666),
  [4895] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3665),
  [4897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3343),
  [4899] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7312),
  [4901] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3457),
  [4903] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3456),
  [4905] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3733),
  [4907] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3735),
  [4909] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3744),
  [4911] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3745),
  [4913] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3748),
  [4915] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3749),
  [4917] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3751),
  [4919] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3741),
  [4921] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3762),
  [4923] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3708),
  [4925] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3743),
  [4927] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3740),
  [4929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3570),
  [4931] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7275),
  [4933] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3567),
  [4935] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3568),
  [4937] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3662),
  [4939] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3661),
  [4941] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3615),
  [4943] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3656),
  [4945] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3738),
  [4947] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3736),
  [4949] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2935),
  [4951] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_typed_pattern, 3, 0, 0),
  [4953] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_typed_pattern, 3, 0, 0),
  [4955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3885),
  [4957] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5546),
  [4959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3823),
  [4961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5008),
  [4963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3042),
  [4965] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_argument_repeat1, 2, 0, 0), SHIFT_REPEAT(5793),
  [4968] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2907),
  [4970] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4081),
  [4972] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4078),
  [4974] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5141),
  [4976] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3045),
  [4978] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2962),
  [4980] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4064),
  [4982] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5523),
  [4984] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4065),
  [4986] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4942),
  [4988] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3117),
  [4990] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5992),
  [4992] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5793),
  [4994] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3015),
  [4996] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3933),
  [4998] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5515),
  [5000] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3893),
  [5002] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4976),
  [5004] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3145),
  [5006] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_argument_repeat1, 2, 0, 0), SHIFT_REPEAT(5992),
  [5009] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constraint, 4, 0, 0),
  [5011] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constraint, 4, 0, 0),
  [5013] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constraint, 3, 0, 0),
  [5015] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constraint, 3, 0, 0),
  [5017] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5774),
  [5019] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2975),
  [5021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4037),
  [5023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4038),
  [5025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5010),
  [5027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3176),
  [5029] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3003),
  [5031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3977),
  [5033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3975),
  [5035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4978),
  [5037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3166),
  [5039] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5911),
  [5041] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5984),
  [5043] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_argument_repeat1, 2, 0, 0), SHIFT_REPEAT(5808),
  [5046] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_argument_repeat1, 2, 0, 0), SHIFT_REPEAT(5779),
  [5049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6427),
  [5051] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5779),
  [5053] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5808),
  [5055] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_atomic_type, 2, 0, 0),
  [5057] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_atomic_type, 2, 0, 0),
  [5059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4116),
  [5061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4114),
  [5063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4949),
  [5065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3192),
  [5067] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_long_identifier_repeat1, 2, 0, 0), SHIFT_REPEAT(6675),
  [5070] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2996),
  [5072] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_long_identifier_repeat1, 2, 0, 0), SHIFT_REPEAT(6427),
  [5075] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_argument_repeat1, 2, 0, 0), SHIFT_REPEAT(5911),
  [5078] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_argument_repeat1, 2, 0, 0), SHIFT_REPEAT(5984),
  [5081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6675),
  [5083] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5537),
  [5085] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3049),
  [5087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3946),
  [5089] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5529),
  [5091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3953),
  [5093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4990),
  [5095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3236),
  [5097] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_argument_repeat1, 2, 0, 0), SHIFT_REPEAT(5774),
  [5100] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4074),
  [5102] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5920),
  [5104] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5767),
  [5106] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3103),
  [5108] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3968),
  [5110] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3967),
  [5112] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4983),
  [5114] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3254),
  [5116] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_argument_repeat1, 2, 0, 0), SHIFT_REPEAT(5767),
  [5119] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_compound_type_repeat1, 2, 0, 0), SHIFT_REPEAT(3823),
  [5122] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6944),
  [5124] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3084),
  [5126] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4055),
  [5128] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4040),
  [5130] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4979),
  [5132] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3219),
  [5134] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3035),
  [5136] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4016),
  [5138] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4013),
  [5140] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4975),
  [5142] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3205),
  [5144] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3894),
  [5146] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5783),
  [5148] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_long_identifier_repeat1, 2, 0, 0), SHIFT_REPEAT(6434),
  [5151] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_argument_repeat1, 2, 0, 0), SHIFT_REPEAT(5946),
  [5154] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5753),
  [5156] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_argument_repeat1, 2, 0, 0), SHIFT_REPEAT(5753),
  [5159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6697),
  [5161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6420),
  [5163] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3075),
  [5165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3928),
  [5167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3930),
  [5169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5101),
  [5171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3235),
  [5173] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5946),
  [5175] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_long_identifier_repeat1, 2, 0, 0), SHIFT_REPEAT(6420),
  [5178] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6434),
  [5180] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_long_identifier_repeat1, 2, 0, 0), SHIFT_REPEAT(6697),
  [5183] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_long_identifier_repeat1, 2, 0, 0), SHIFT_REPEAT(6944),
  [5186] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_compound_type_repeat1, 2, 0, 0), SHIFT_REPEAT(4078),
  [5189] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_argument_repeat1, 2, 0, 0), SHIFT_REPEAT(5783),
  [5192] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6468),
  [5194] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_argument_repeat1, 2, 0, 0), SHIFT_REPEAT(5920),
  [5197] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_long_identifier_repeat1, 2, 0, 0), SHIFT_REPEAT(6468),
  [5200] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3881),
  [5202] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_compound_type_repeat1, 2, 0, 0), SHIFT_REPEAT(4114),
  [5205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6423),
  [5207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4072),
  [5209] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_long_identifier_repeat1, 2, 0, 0), SHIFT_REPEAT(6558),
  [5212] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_long_identifier_repeat1, 2, 0, 0), SHIFT_REPEAT(6983),
  [5215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4039),
  [5217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6983),
  [5219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6558),
  [5221] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_long_identifier_repeat1, 2, 0, 0), SHIFT_REPEAT(6473),
  [5224] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_compound_type_repeat1, 2, 0, 0), SHIFT_REPEAT(3893),
  [5227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2801),
  [5229] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_compound_type_repeat1, 2, 0, 0), SHIFT_REPEAT(4038),
  [5232] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4113),
  [5234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6473),
  [5236] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2719),
  [5238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3974),
  [5240] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2721),
  [5242] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3160),
  [5244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3919),
  [5246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3920),
  [5248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4993),
  [5250] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3288),
  [5252] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_argument_repeat1, 2, 0, 0), SHIFT_REPEAT(5960),
  [5255] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_long_identifier_repeat1, 2, 0, 0), SHIFT_REPEAT(6418),
  [5258] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_long_identifier_repeat1, 2, 0, 0), SHIFT_REPEAT(6423),
  [5261] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_compound_type_repeat1, 2, 0, 0), SHIFT_REPEAT(3975),
  [5264] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5960),
  [5266] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6418),
  [5268] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_compound_type_repeat1, 2, 0, 0), SHIFT_REPEAT(4065),
  [5271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4023),
  [5273] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_compound_type_repeat1, 2, 0, 0), SHIFT_REPEAT(3930),
  [5276] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2733),
  [5278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3934),
  [5280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3954),
  [5282] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_compound_type_repeat1, 2, 0, 0), SHIFT_REPEAT(3953),
  [5285] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_compound_type_repeat1, 2, 0, 0), SHIFT_REPEAT(3967),
  [5288] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_compound_type_repeat1, 2, 0, 0), SHIFT_REPEAT(4040),
  [5291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2732),
  [5293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3963),
  [5295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6578),
  [5297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2740),
  [5299] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_compound_type_repeat1, 2, 0, 0), SHIFT_REPEAT(4013),
  [5302] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_long_identifier_repeat1, 2, 0, 0), SHIFT_REPEAT(6578),
  [5305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4012),
  [5307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2730),
  [5309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2742),
  [5311] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4189),
  [5313] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4187),
  [5315] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4185),
  [5317] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4184),
  [5319] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4183),
  [5321] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4172),
  [5323] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4188),
  [5325] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4179),
  [5327] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4178),
  [5329] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4177),
  [5331] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4175),
  [5333] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4173),
  [5335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3970),
  [5337] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6564),
  [5339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2736),
  [5341] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6773),
  [5343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2744),
  [5345] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7507),
  [5347] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4117),
  [5349] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2774),
  [5351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7470),
  [5353] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4108),
  [5355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7463),
  [5357] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7091),
  [5359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2762),
  [5361] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_long_identifier_repeat1, 2, 0, 0), SHIFT_REPEAT(6862),
  [5364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3921),
  [5366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2715),
  [5368] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_compound_type_repeat1, 2, 0, 0), SHIFT_REPEAT(3920),
  [5371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2753),
  [5373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6862),
  [5375] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3209),
  [5377] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5749),
  [5379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7547),
  [5381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7331),
  [5383] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_long_identifier_repeat1, 2, 0, 0), SHIFT_REPEAT(7218),
  [5386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2717),
  [5388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7218),
  [5390] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7285),
  [5392] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_long_identifier_repeat1, 2, 0, 0), SHIFT_REPEAT(7547),
  [5395] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_argument_repeat1, 2, 0, 0), SHIFT_REPEAT(5749),
  [5398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2670),
  [5400] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5875),
  [5402] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_type_argument_constraints_repeat1, 2, 0, 0),
  [5404] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_type_argument_constraints_repeat1, 2, 0, 0),
  [5406] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_argument_constraints_repeat1, 2, 0, 0), SHIFT_REPEAT(5559),
  [5409] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_argument_constraints, 3, 0, 0),
  [5411] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_argument_constraints, 3, 0, 0),
  [5413] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5559),
  [5415] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7531),
  [5417] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_argument_constraints, 2, 0, 0),
  [5419] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_argument_constraints, 2, 0, 0),
  [5421] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_long_identifier_repeat1, 2, 0, 0), SHIFT_REPEAT(7331),
  [5424] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_argument_repeat1, 2, 0, 0), SHIFT_REPEAT(5875),
  [5427] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3225),
  [5429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5590),
  [5431] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_optional_pattern, 2, 0, 0),
  [5433] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_optional_pattern, 2, 0, 0),
  [5435] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7358),
  [5437] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4137),
  [5439] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4171),
  [5441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(520),
  [5443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6854),
  [5445] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5977),
  [5447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(524),
  [5449] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5544),
  [5451] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4169),
  [5453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3268),
  [5455] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4049),
  [5457] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4207),
  [5459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6475),
  [5461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7457),
  [5463] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3864),
  [5465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7396),
  [5467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(638),
  [5469] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_argument_constraints_repeat1, 2, 0, 0), SHIFT_REPEAT(5544),
  [5472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(622),
  [5474] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_attribute_pattern, 2, 0, 0),
  [5476] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute_pattern, 2, 0, 0),
  [5478] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_argument_repeat1, 2, 0, 0), SHIFT_REPEAT(5977),
  [5481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(702),
  [5483] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3293),
  [5485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(577),
  [5487] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constraint, 5, 0, 0),
  [5489] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constraint, 5, 0, 0),
  [5491] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_identifier_pattern, 3, 0, 0),
  [5493] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_identifier_pattern, 3, 0, 0),
  [5495] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5524),
  [5497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(720),
  [5499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(672),
  [5501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(574),
  [5503] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_repeat_pattern_repeat1, 2, 0, 0),
  [5505] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_repeat_pattern_repeat1, 2, 0, 0),
  [5507] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_repeat_pattern_repeat1, 2, 0, 0), SHIFT_REPEAT(2625),
  [5510] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_long_identifier_repeat1, 2, 0, 0), SHIFT_REPEAT(6854),
  [5513] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_repeat_pattern_repeat1, 2, 0, 0), SHIFT_REPEAT(2639),
  [5516] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constraint, 6, 0, 0),
  [5518] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constraint, 6, 0, 0),
  [5520] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constraint, 8, 0, 0),
  [5522] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constraint, 8, 0, 0),
  [5524] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_argument_constraints_repeat1, 2, 0, 0), SHIFT_REPEAT(5524),
  [5527] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constraint, 9, 0, 0),
  [5529] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constraint, 9, 0, 0),
  [5531] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_repeat_pattern, 2, 0, 0),
  [5533] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_repeat_pattern, 2, 0, 0),
  [5535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5652),
  [5537] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_conjunct_pattern, 3, 0, 0),
  [5539] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_conjunct_pattern, 3, 0, 0),
  [5541] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5940),
  [5543] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_argument_repeat1, 2, 0, 0), SHIFT_REPEAT(5940),
  [5546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(536),
  [5548] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5563),
  [5550] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_argument_constraints_repeat1, 2, 0, 0), SHIFT_REPEAT(5563),
  [5553] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5552),
  [5555] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_argument_constraints_repeat1, 2, 0, 0), SHIFT_REPEAT(5552),
  [5558] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_disjunct_pattern, 3, 0, 0),
  [5560] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_disjunct_pattern, 3, 0, 0),
  [5562] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_cons_pattern, 3, 0, 0),
  [5564] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_cons_pattern, 3, 0, 0),
  [5566] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3309),
  [5568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(526),
  [5570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(531),
  [5572] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_atomic_type, 1, 0, 0),
  [5574] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_atomic_type, 1, 0, 0),
  [5576] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2777),
  [5578] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5519),
  [5580] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_paren_pattern, 3, 0, 0),
  [5582] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_paren_pattern, 3, 0, 0),
  [5584] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_named_field_pattern, 3, 0, 0),
  [5586] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_named_field_pattern, 3, 0, 0),
  [5588] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5959),
  [5590] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_list_pattern, 3, 0, 8),
  [5592] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_list_pattern, 3, 0, 8),
  [5594] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_pattern, 3, 0, 8),
  [5596] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_pattern, 3, 0, 8),
  [5598] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_pattern, 3, 0, 0),
  [5600] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_pattern, 3, 0, 0),
  [5602] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_argument_constraints_repeat1, 2, 0, 0), SHIFT_REPEAT(5519),
  [5605] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_pattern, 2, 0, 0),
  [5607] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_pattern, 2, 0, 0),
  [5609] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_list_pattern, 2, 0, 0),
  [5611] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_list_pattern, 2, 0, 0),
  [5613] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_repeat_pattern_repeat1, 2, 0, 0), SHIFT_REPEAT(2650),
  [5616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2773),
  [5618] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_as_pattern, 3, 0, 0),
  [5620] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_as_pattern, 3, 0, 0),
  [5622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5672),
  [5624] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_pattern, 4, 0, 0),
  [5626] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_pattern, 4, 0, 0),
  [5628] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_named_field_pattern, 4, 0, 0),
  [5630] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_named_field_pattern, 4, 0, 0),
  [5632] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2765),
  [5634] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_atomic_type, 3, 0, 0),
  [5636] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_atomic_type, 3, 0, 0),
  [5638] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_check_pattern, 4, 0, 0),
  [5640] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_check_pattern, 4, 0, 0),
  [5642] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_typed_pattern, 4, 0, 20),
  [5644] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_typed_pattern, 4, 0, 20),
  [5646] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_check_pattern, 2, 0, 0),
  [5648] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_check_pattern, 2, 0, 0),
  [5650] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7287),
  [5652] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_atomic_type, 4, 0, 0),
  [5654] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_atomic_type, 4, 0, 0),
  [5656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5673),
  [5658] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_argument_repeat1, 2, 0, 0), SHIFT_REPEAT(5959),
  [5661] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__pattern, 1, 0, 0),
  [5663] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pattern, 1, 0, 0),
  [5665] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__pattern, 1, 0, 1),
  [5667] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pattern, 1, 0, 1),
  [5669] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_curried_spec_repeat1, 2, 0, 0), SHIFT_REPEAT(5433),
  [5672] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_curried_spec_repeat1, 2, 0, 0), SHIFT_REPEAT(3268),
  [5675] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_curried_spec_repeat1, 2, 0, 0), SHIFT_REPEAT(3938),
  [5678] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_curried_spec_repeat1, 2, 0, 0), SHIFT_REPEAT(4771),
  [5681] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_curried_spec_repeat1, 2, 0, 0), SHIFT_REPEAT(6475),
  [5684] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_curried_spec_repeat1, 2, 0, 0), SHIFT_REPEAT(7372),
  [5687] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_curried_spec_repeat1, 2, 0, 0), SHIFT_REPEAT(3820),
  [5690] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_curried_spec_repeat1, 2, 0, 0), SHIFT_REPEAT(7515),
  [5693] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_repeat_pattern_repeat1, 2, 0, 0), SHIFT_REPEAT(2656),
  [5696] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7123),
  [5698] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2769),
  [5700] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3322),
  [5702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2771),
  [5704] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_repeat_pattern_repeat1, 2, 0, 0), SHIFT_REPEAT(2686),
  [5707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5615),
  [5709] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6547),
  [5711] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6548),
  [5713] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__method_defn_repeat1, 1, 0, 0),
  [5715] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__method_defn_repeat1, 1, 0, 0),
  [5717] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4004),
  [5719] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5433),
  [5721] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6796),
  [5723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6960),
  [5725] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_property_or_ident, 3, 0, 54),
  [5727] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_or_ident, 3, 0, 54),
  [5729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4819),
  [5731] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4820),
  [5733] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4821),
  [5735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4829),
  [5737] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4835),
  [5739] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4840),
  [5741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4727),
  [5743] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4844),
  [5745] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4845),
  [5747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4846),
  [5749] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4847),
  [5751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4848),
  [5753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4409),
  [5755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7143),
  [5757] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_property_or_ident, 1, 0, 0),
  [5759] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_or_ident, 1, 0, 0),
  [5761] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_attributes_repeat1, 2, 0, 0),
  [5763] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributes_repeat1, 2, 0, 0), SHIFT_REPEAT(3261),
  [5766] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_attributes_repeat1, 2, 0, 0),
  [5768] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4753),
  [5770] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2063),
  [5772] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2202),
  [5774] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2292),
  [5776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1120),
  [5778] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1563),
  [5780] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1784),
  [5782] = {.entry = {.count = 1, .reusable = true}}, SHIFT(914),
  [5784] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1981),
  [5786] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2103),
  [5788] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4835),
  [5790] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4845),
  [5792] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4824),
  [5794] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4823),
  [5796] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2387),
  [5798] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_attributes, 1, 0, 0),
  [5800] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attributes, 1, 0, 0),
  [5802] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2083),
  [5804] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1898),
  [5806] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6491),
  [5808] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5344),
  [5810] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5343),
  [5812] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5341),
  [5814] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5332),
  [5816] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5316),
  [5818] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5298),
  [5820] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5296),
  [5822] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5295),
  [5824] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5294),
  [5826] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5292),
  [5828] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5290),
  [5830] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5289),
  [5832] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4743),
  [5834] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7309),
  [5836] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4288),
  [5838] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4115),
  [5840] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4307),
  [5842] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7495),
  [5844] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4131),
  [5846] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6538),
  [5848] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5307),
  [5850] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3940),
  [5852] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5462),
  [5854] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7490),
  [5856] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3795),
  [5858] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6658),
  [5860] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4597),
  [5862] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3811),
  [5864] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4730),
  [5866] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7487),
  [5868] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3797),
  [5870] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6728),
  [5872] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4229),
  [5874] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4082),
  [5876] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4337),
  [5878] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7434),
  [5880] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3906),
  [5882] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7050),
  [5884] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3939),
  [5886] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1374),
  [5888] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7493),
  [5890] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3800),
  [5892] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6579),
  [5894] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4083),
  [5896] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2948),
  [5898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7478),
  [5900] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3801),
  [5902] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7023),
  [5904] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4029),
  [5906] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1364),
  [5908] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7489),
  [5910] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3899),
  [5912] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6676),
  [5914] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5483),
  [5916] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5484),
  [5918] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5485),
  [5920] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5486),
  [5922] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5487),
  [5924] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5488),
  [5926] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5489),
  [5928] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5490),
  [5930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5491),
  [5932] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5492),
  [5934] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5493),
  [5936] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5494),
  [5938] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4868),
  [5940] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6879),
  [5942] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4080),
  [5944] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1178),
  [5946] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7491),
  [5948] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3804),
  [5950] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6632),
  [5952] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_long_identifier_repeat1, 2, 0, 0), SHIFT_REPEAT(7054),
  [5955] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4354),
  [5957] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3868),
  [5959] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4418),
  [5961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7425),
  [5963] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4031),
  [5965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6853),
  [5967] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4200),
  [5969] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3821),
  [5971] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3096),
  [5973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7450),
  [5975] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4063),
  [5977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7511),
  [5979] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4130),
  [5981] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3267),
  [5983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7482),
  [5985] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3917),
  [5987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6872),
  [5989] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4445),
  [5991] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4104),
  [5993] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4506),
  [5995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7479),
  [5997] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3846),
  [5999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6986),
  [6001] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4451),
  [6003] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4002),
  [6005] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4494),
  [6007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7475),
  [6009] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3834),
  [6011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7167),
  [6013] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4005),
  [6015] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3071),
  [6017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7496),
  [6019] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4119),
  [6021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6523),
  [6023] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3918),
  [6025] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3128),
  [6027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7443),
  [6029] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3927),
  [6031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7548),
  [6033] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3818),
  [6035] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3172),
  [6037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7503),
  [6039] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3971),
  [6041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6454),
  [6043] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__attribute_set, 3, 0, 0),
  [6045] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__attribute_set, 3, 0, 0),
  [6047] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3883),
  [6049] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1333),
  [6051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7484),
  [6053] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4003),
  [6055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6799),
  [6057] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4433),
  [6059] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3909),
  [6061] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4576),
  [6063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7389),
  [6065] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3932),
  [6067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7042),
  [6069] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4373),
  [6071] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4103),
  [6073] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4458),
  [6075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7492),
  [6077] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4132),
  [6079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6610),
  [6081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7054),
  [6083] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4372),
  [6085] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4106),
  [6087] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4437),
  [6089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7480),
  [6091] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3877),
  [6093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6950),
  [6095] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3869),
  [6097] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3039),
  [6099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7486),
  [6101] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3985),
  [6103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6750),
  [6105] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__attribute_set, 4, 0, 0),
  [6107] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__attribute_set, 4, 0, 0),
  [6109] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4906),
  [6111] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3863),
  [6113] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4985),
  [6115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7398),
  [6117] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3891),
  [6119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6871),
  [6121] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3814),
  [6123] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1286),
  [6125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7471),
  [6127] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3901),
  [6129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7274),
  [6131] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3990),
  [6133] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3062),
  [6135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7502),
  [6137] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3981),
  [6139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6460),
  [6141] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4107),
  [6143] = {.entry = {.count = 1, .reusable = false}}, SHIFT(794),
  [6145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7481),
  [6147] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3903),
  [6149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6893),
  [6151] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4376),
  [6153] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4124),
  [6155] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4399),
  [6157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7499),
  [6159] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4058),
  [6161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6474),
  [6163] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4015),
  [6165] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3080),
  [6167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7477),
  [6169] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3996),
  [6171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7075),
  [6173] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4067),
  [6175] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3000),
  [6177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7498),
  [6179] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4085),
  [6181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6485),
  [6183] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3799),
  [6185] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1216),
  [6187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7488),
  [6189] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3957),
  [6191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6699),
  [6193] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3824),
  [6195] = {.entry = {.count = 1, .reusable = false}}, SHIFT(921),
  [6197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7416),
  [6199] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4001),
  [6201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6624),
  [6203] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4350),
  [6205] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3839),
  [6207] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4446),
  [6209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7407),
  [6211] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3999),
  [6213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6614),
  [6215] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4007),
  [6217] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3167),
  [6219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7483),
  [6221] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3945),
  [6223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6852),
  [6225] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3807),
  [6227] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1202),
  [6229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7504),
  [6231] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3962),
  [6233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6452),
  [6235] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4060),
  [6237] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1066),
  [6239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7494),
  [6241] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3958),
  [6243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6565),
  [6245] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3790),
  [6247] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4422),
  [6249] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3816),
  [6251] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4585),
  [6253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7473),
  [6255] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4095),
  [6257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7228),
  [6259] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4414),
  [6261] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4033),
  [6263] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4552),
  [6265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7501),
  [6267] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3995),
  [6269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6464),
  [6271] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4069),
  [6273] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3116),
  [6275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7500),
  [6277] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4017),
  [6279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6469),
  [6281] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3874),
  [6283] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3177),
  [6285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7485),
  [6287] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4096),
  [6289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6771),
  [6291] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_attributes_repeat1, 1, 0, 0),
  [6293] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_attributes_repeat1, 1, 0, 0),
  [6295] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3911),
  [6297] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1388),
  [6299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7464),
  [6301] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4129),
  [6303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7328),
  [6305] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4411),
  [6307] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4014),
  [6309] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4556),
  [6311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7497),
  [6313] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4105),
  [6315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6507),
  [6317] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_access_modifier, 1, 0, 0),
  [6319] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_access_modifier, 1, 0, 0),
  [6321] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5316),
  [6323] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5294),
  [6325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5398),
  [6327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5284),
  [6329] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5487),
  [6331] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5491),
  [6333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5495),
  [6335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5496),
  [6337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3858),
  [6339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3830),
  [6341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5042),
  [6343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4253),
  [6345] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_argument_patterns_repeat1, 1, 0, 0),
  [6347] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_argument_patterns_repeat1, 1, 0, 0),
  [6349] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_curried_spec, 2, 0, 0),
  [6351] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_curried_spec, 2, 0, 0),
  [6353] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_spec, 1, 0, 0),
  [6355] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_argument_repeat1, 2, 0, 0), SHIFT_REPEAT(5812),
  [6358] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__atomic_pattern, 3, 0, 0),
  [6360] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__atomic_pattern, 3, 0, 0),
  [6362] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_curried_spec, 1, 0, 0),
  [6364] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_curried_spec, 1, 0, 0),
  [6366] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__atomic_pattern, 1, 0, 0),
  [6368] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__atomic_pattern, 1, 0, 0),
  [6370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5522),
  [6372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6916),
  [6374] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5812),
  [6376] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_member_defn, 8, 0, 0),
  [6378] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_member_defn, 8, 0, 0),
  [6380] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_member_defn, 4, 0, 0),
  [6382] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_member_defn, 4, 0, 0),
  [6384] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_long_identifier_repeat1, 2, 0, 0), SHIFT_REPEAT(6916),
  [6387] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_member_defn, 7, 0, 0),
  [6389] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_member_defn, 7, 0, 0),
  [6391] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_member_defn, 6, 0, 0),
  [6393] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_member_defn, 6, 0, 0),
  [6395] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_member_defn, 5, 0, 0),
  [6397] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_member_defn, 5, 0, 0),
  [6399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3798),
  [6401] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5513),
  [6403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3865),
  [6405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5107),
  [6407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4469),
  [6409] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5813),
  [6411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4127),
  [6413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4126),
  [6415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4950),
  [6417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4453),
  [6419] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__member_defns_repeat1, 2, 0, 0), SHIFT_REPEAT(3217),
  [6422] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__member_defns_repeat1, 2, 0, 0), SHIFT_REPEAT(6148),
  [6425] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__member_defns_repeat1, 2, 0, 0), SHIFT_REPEAT(2683),
  [6428] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__member_defns_repeat1, 2, 0, 0), SHIFT_REPEAT(5405),
  [6431] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__member_defns_repeat1, 2, 0, 0), SHIFT_REPEAT(4795),
  [6434] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__member_defns_repeat1, 2, 0, 0), SHIFT_REPEAT(4864),
  [6437] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__member_defns_repeat1, 2, 0, 0), SHIFT_REPEAT(5613),
  [6440] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__member_defns_repeat1, 2, 0, 0), SHIFT_REPEAT(5725),
  [6443] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__member_defns_repeat1, 2, 0, 0), SHIFT_REPEAT(4394),
  [6446] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__member_defns_repeat1, 2, 0, 0),
  [6448] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_argument_repeat1, 2, 0, 0), SHIFT_REPEAT(5813),
  [6451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6148),
  [6453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2683),
  [6455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5405),
  [6457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4795),
  [6459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4864),
  [6461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5613),
  [6463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5725),
  [6465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4394),
  [6467] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__member_defns, 1, 0, 0),
  [6469] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5894),
  [6471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3994),
  [6473] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5550),
  [6475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3965),
  [6477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5171),
  [6479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4533),
  [6481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3878),
  [6483] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5553),
  [6485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3879),
  [6487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4999),
  [6489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4525),
  [6491] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__member_defns, 2, 0, 0),
  [6493] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_argument_repeat1, 2, 0, 0), SHIFT_REPEAT(5894),
  [6496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3827),
  [6498] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_compound_type_repeat1, 2, 0, 0), SHIFT_REPEAT(3830),
  [6501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4028),
  [6503] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3806),
  [6505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5122),
  [6507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4500),
  [6509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7061),
  [6511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6440),
  [6513] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_argument_repeat1, 2, 0, 0), SHIFT_REPEAT(5787),
  [6516] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5787),
  [6518] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5852),
  [6520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4053),
  [6522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4050),
  [6524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4974),
  [6526] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4480),
  [6528] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5980),
  [6530] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_argument_repeat1, 2, 0, 0), SHIFT_REPEAT(5852),
  [6533] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_argument_repeat1, 2, 0, 0), SHIFT_REPEAT(5980),
  [6536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3948),
  [6538] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3857),
  [6540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4962),
  [6542] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4564),
  [6544] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_long_identifier_repeat1, 2, 0, 0), SHIFT_REPEAT(7297),
  [6547] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_long_identifier_repeat1, 2, 0, 0), SHIFT_REPEAT(6440),
  [6550] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5961),
  [6552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2754),
  [6554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7297),
  [6556] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5842),
  [6558] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5547),
  [6560] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_argument_repeat1, 2, 0, 0), SHIFT_REPEAT(5842),
  [6563] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_long_identifier_repeat1, 2, 0, 0), SHIFT_REPEAT(7061),
  [6566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4018),
  [6568] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5549),
  [6570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3929),
  [6572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5012),
  [6574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4607),
  [6576] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_argument_repeat1, 2, 0, 0), SHIFT_REPEAT(5961),
  [6579] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5804),
  [6581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4099),
  [6583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4098),
  [6585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4944),
  [6587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4695),
  [6589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3989),
  [6591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4977),
  [6593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4682),
  [6595] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_compound_type_repeat1, 2, 0, 0), SHIFT_REPEAT(4126),
  [6598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3956),
  [6600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4070),
  [6602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5155),
  [6604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4670),
  [6606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3862),
  [6608] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5933),
  [6610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6631),
  [6612] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_argument_repeat1, 2, 0, 0), SHIFT_REPEAT(5933),
  [6615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3991),
  [6617] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_argument_repeat1, 2, 0, 0), SHIFT_REPEAT(5778),
  [6620] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_long_identifier_repeat1, 2, 0, 0), SHIFT_REPEAT(6631),
  [6623] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_long_identifier_repeat1, 2, 0, 0), SHIFT_REPEAT(7118),
  [6626] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5997),
  [6628] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3843),
  [6630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3832),
  [6632] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5006),
  [6634] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4651),
  [6636] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributes_repeat1, 2, 0, 0), SHIFT_REPEAT(3217),
  [6639] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_argument_repeat1, 2, 0, 0), SHIFT_REPEAT(5997),
  [6642] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5985),
  [6644] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5778),
  [6646] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7388),
  [6648] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_long_identifier_repeat1, 2, 0, 0), SHIFT_REPEAT(6425),
  [6651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6425),
  [6653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4123),
  [6655] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_compound_type_repeat1, 2, 0, 0), SHIFT_REPEAT(3865),
  [6658] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_long_identifier_repeat1, 2, 0, 0), SHIFT_REPEAT(7388),
  [6661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6444),
  [6663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7118),
  [6665] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_long_identifier_repeat1, 2, 0, 0), SHIFT_REPEAT(6444),
  [6668] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_argument_repeat1, 2, 0, 0), SHIFT_REPEAT(5804),
  [6671] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_argument_repeat1, 2, 0, 0), SHIFT_REPEAT(5985),
  [6674] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_long_identifier_repeat1, 2, 0, 0), SHIFT_REPEAT(6422),
  [6677] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_compound_type_repeat1, 2, 0, 0), SHIFT_REPEAT(3965),
  [6680] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4102),
  [6682] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4054),
  [6684] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5017),
  [6686] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4752),
  [6688] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5903),
  [6690] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6826),
  [6692] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3961),
  [6694] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3915),
  [6696] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_long_identifier_repeat1, 2, 0, 0), SHIFT_REPEAT(7472),
  [6699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6792),
  [6701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7472),
  [6703] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2764),
  [6705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4425),
  [6707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6430),
  [6709] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_long_identifier_repeat1, 2, 0, 0), SHIFT_REPEAT(6792),
  [6712] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6422),
  [6714] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_argument_repeat1, 2, 0, 0), SHIFT_REPEAT(5841),
  [6717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6608),
  [6719] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_compound_type_repeat1, 2, 0, 0), SHIFT_REPEAT(3857),
  [6722] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5841),
  [6724] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_long_identifier_repeat1, 2, 0, 0), SHIFT_REPEAT(6826),
  [6727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3880),
  [6729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6655),
  [6731] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_long_identifier_repeat1, 2, 0, 0), SHIFT_REPEAT(6655),
  [6734] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_compound_type_repeat1, 2, 0, 0), SHIFT_REPEAT(3879),
  [6737] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_argument_repeat1, 2, 0, 0), SHIFT_REPEAT(5903),
  [6740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3819),
  [6742] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_compound_type_repeat1, 2, 0, 0), SHIFT_REPEAT(3806),
  [6745] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4042),
  [6747] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_compound_type_repeat1, 2, 0, 0), SHIFT_REPEAT(4050),
  [6750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2741),
  [6752] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_long_identifier_repeat1, 2, 0, 0), SHIFT_REPEAT(6430),
  [6755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2723),
  [6757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4122),
  [6759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3984),
  [6761] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_compound_type_repeat1, 2, 0, 0), SHIFT_REPEAT(4098),
  [6764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2716),
  [6766] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_compound_type_repeat1, 2, 0, 0), SHIFT_REPEAT(3989),
  [6769] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5905),
  [6771] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4010),
  [6773] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3847),
  [6775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4973),
  [6777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4904),
  [6779] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5781),
  [6781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4090),
  [6783] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_argument_repeat1, 2, 0, 0), SHIFT_REPEAT(5905),
  [6786] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2739),
  [6788] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_compound_type_repeat1, 2, 0, 0), SHIFT_REPEAT(3832),
  [6791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3826),
  [6793] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_compound_type_repeat1, 2, 0, 0), SHIFT_REPEAT(3929),
  [6796] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_argument_repeat1, 2, 0, 0), SHIFT_REPEAT(5781),
  [6799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2727),
  [6801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3829),
  [6803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2737),
  [6805] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_compound_type_repeat1, 2, 0, 0), SHIFT_REPEAT(4070),
  [6808] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5198),
  [6810] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5198),
  [6812] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5195),
  [6814] = {.entry = {.count = 1, .reusable = true}}, SHIFT(750),
  [6816] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3446),
  [6818] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6380),
  [6820] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7544),
  [6822] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6379),
  [6824] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5195),
  [6826] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2072),
  [6828] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1073),
  [6830] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_compound_type_repeat1, 2, 0, 0), SHIFT_REPEAT(4054),
  [6833] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2200),
  [6835] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2367),
  [6837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4094),
  [6839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6463),
  [6841] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3484),
  [6843] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5497),
  [6845] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2027),
  [6847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2726),
  [6849] = {.entry = {.count = 1, .reusable = false}}, SHIFT(915),
  [6851] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4783),
  [6853] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1637),
  [6855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2474),
  [6857] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1480),
  [6859] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3705),
  [6861] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5478),
  [6863] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2799),
  [6865] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2826),
  [6867] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3652),
  [6869] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2378),
  [6871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3842),
  [6873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3845),
  [6875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5118),
  [6877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5161),
  [6879] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1711),
  [6881] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2108),
  [6883] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2131),
  [6885] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2415),
  [6887] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1742),
  [6889] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3531),
  [6891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2749),
  [6893] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_format_string_repeat1, 2, 0, 0), SHIFT_REPEAT(5198),
  [6896] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_format_string_repeat1, 2, 0, 0), SHIFT_REPEAT(5198),
  [6899] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_format_string_repeat1, 2, 0, 0), SHIFT_REPEAT(5195),
  [6902] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_format_string_repeat1, 2, 0, 0), SHIFT_REPEAT(750),
  [6905] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_format_string_repeat1, 2, 0, 0),
  [6907] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_format_string_repeat1, 2, 0, 0), SHIFT_REPEAT(5195),
  [6910] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1891),
  [6912] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_long_identifier_repeat1, 2, 0, 0), SHIFT_REPEAT(6463),
  [6915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2734),
  [6917] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1863),
  [6919] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3725),
  [6921] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2132),
  [6923] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1852),
  [6925] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3549),
  [6927] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3728),
  [6929] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2304),
  [6931] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1814),
  [6933] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2413),
  [6935] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4857),
  [6937] = {.entry = {.count = 1, .reusable = false}}, SHIFT(874),
  [6939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2738),
  [6941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2718),
  [6943] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1132),
  [6945] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4159),
  [6947] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5350),
  [6949] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__function_or_value_defns_repeat1, 2, 0, 23), SHIFT_REPEAT(2474),
  [6952] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3601),
  [6954] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2206),
  [6956] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5278),
  [6958] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4165),
  [6960] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3690),
  [6962] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7165),
  [6964] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5374),
  [6966] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5374),
  [6968] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5375),
  [6970] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3674),
  [6972] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3649),
  [6974] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1053),
  [6976] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1123),
  [6978] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3583),
  [6980] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3693),
  [6982] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4164),
  [6984] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4181),
  [6986] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1063),
  [6988] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1098),
  [6990] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3890),
  [6992] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3889),
  [6994] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4943),
  [6996] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5225),
  [6998] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5413),
  [7000] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5270),
  [7002] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1978),
  [7004] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2028),
  [7006] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_long_identifier_repeat1, 2, 0, 0), SHIFT_REPEAT(7165),
  [7009] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2262),
  [7011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2303),
  [7013] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3433),
  [7015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3483),
  [7017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2728),
  [7019] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5408),
  [7021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5349),
  [7023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4839),
  [7025] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5507),
  [7027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5498),
  [7029] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3643),
  [7031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3599),
  [7033] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_value_definition, 5, 0, 0),
  [7035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6375),
  [7037] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_value_definition, 5, 0, 0),
  [7039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6297),
  [7041] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_member_signature, 5, 0, 0),
  [7043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7172),
  [7045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7067),
  [7047] = {.entry = {.count = 1, .reusable = false}}, SHIFT(889),
  [7049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(916),
  [7051] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2127),
  [7053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2198),
  [7055] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4780),
  [7057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4791),
  [7059] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1958),
  [7061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2073),
  [7063] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4168),
  [7065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4158),
  [7067] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2467),
  [7069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2081),
  [7071] = {.entry = {.count = 1, .reusable = false}}, SHIFT(903),
  [7073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(875),
  [7075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7258),
  [7077] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1541),
  [7079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1639),
  [7081] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1553),
  [7083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1479),
  [7085] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3621),
  [7087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3704),
  [7089] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5504),
  [7091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5480),
  [7093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6302),
  [7095] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_value_definition, 4, 0, 0),
  [7097] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_value_definition, 4, 0, 0),
  [7099] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2820),
  [7101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2798),
  [7103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6902),
  [7105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2767),
  [7107] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5950),
  [7109] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_long_identifier_repeat1, 2, 0, 0), SHIFT_REPEAT(7258),
  [7112] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2802),
  [7114] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2815),
  [7116] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_argument_repeat1, 2, 0, 0), SHIFT_REPEAT(5950),
  [7119] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_compound_type_repeat1, 2, 0, 0), SHIFT_REPEAT(3847),
  [7122] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2085),
  [7124] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2377),
  [7126] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2244),
  [7128] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2418),
  [7130] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4731),
  [7132] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4853),
  [7134] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3265),
  [7136] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6279),
  [7138] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2297),
  [7140] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2297),
  [7142] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4972),
  [7144] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5723),
  [7146] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6262),
  [7148] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_member_signature, 3, 0, 0),
  [7150] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6083),
  [7152] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2159),
  [7154] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2414),
  [7156] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_implementation, 2, 0, 0),
  [7158] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_implementation, 2, 0, 0),
  [7160] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2212),
  [7162] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2104),
  [7164] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2199),
  [7166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2307),
  [7168] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5069),
  [7170] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5732),
  [7172] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__val_property_defn, 6, 0, 0),
  [7174] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7190),
  [7176] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7189),
  [7178] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_member_signature, 4, 0, 0),
  [7180] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6072),
  [7182] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1811),
  [7184] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1714),
  [7186] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1909),
  [7188] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1818),
  [7190] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2078),
  [7192] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2130),
  [7194] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__string_literal_repeat1, 2, 0, 0), SHIFT_REPEAT(5374),
  [7197] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__string_literal_repeat1, 2, 0, 0), SHIFT_REPEAT(5374),
  [7200] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__string_literal_repeat1, 2, 0, 0), SHIFT_REPEAT(5375),
  [7203] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__string_literal_repeat1, 2, 0, 0),
  [7205] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__string_literal_repeat1, 2, 0, 0),
  [7207] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_member_signature, 6, 0, 0),
  [7209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7188),
  [7211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7187),
  [7213] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3730),
  [7215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3726),
  [7217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7181),
  [7219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7176),
  [7221] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2005),
  [7223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1892),
  [7225] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2277),
  [7227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2138),
  [7229] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3430),
  [7231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3550),
  [7233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7237),
  [7235] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1915),
  [7237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1854),
  [7239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3813),
  [7241] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3717),
  [7243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3720),
  [7245] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1989),
  [7247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1865),
  [7249] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3413),
  [7251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3445),
  [7253] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3412),
  [7255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3529),
  [7257] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1848),
  [7259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1744),
  [7261] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__property_defn, 6, 0, 21),
  [7263] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3765),
  [7265] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5328),
  [7267] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5576),
  [7269] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6965),
  [7271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3773),
  [7273] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_or_prop_defn, 2, 0, 53),
  [7275] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_member_signature, 7, 0, 0),
  [7277] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__property_defn, 7, 0, 61),
  [7279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4873),
  [7281] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_member_signature, 8, 0, 0),
  [7283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6951),
  [7285] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_additional_constr_defn, 5, 0, 0),
  [7287] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_member_defn, 3, 0, 0),
  [7289] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__val_property_defn, 8, 0, 0),
  [7291] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5309),
  [7293] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5571),
  [7295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5934),
  [7297] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__string_literal_repeat1, 2, 0, 0), SHIFT_REPEAT(5511),
  [7300] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__string_literal_repeat1, 2, 0, 0), SHIFT_REPEAT(5511),
  [7303] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__string_literal_repeat1, 2, 0, 0), SHIFT_REPEAT(5510),
  [7306] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__property_defn, 4, 0, 0),
  [7308] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributes_repeat1, 2, 0, 0), SHIFT_REPEAT(3268),
  [7311] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__property_defn, 2, 0, 0),
  [7313] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__method_defn, 3, 0, 55),
  [7315] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_additional_constr_defn, 4, 0, 0),
  [7317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5526),
  [7319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7019),
  [7321] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__member_defns_repeat1, 1, 0, 0),
  [7323] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_compound_type_repeat1, 2, 0, 0), SHIFT_REPEAT(3845),
  [7326] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_or_prop_defn, 2, 0, 52),
  [7328] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_or_prop_defn, 5, 0, 57),
  [7330] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7474),
  [7332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2756),
  [7334] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_member_defn, 2, 0, 0),
  [7336] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3849),
  [7338] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__method_defn, 4, 0, 58),
  [7340] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_value_declaration, 2, 0, 0),
  [7342] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_argument_repeat1, 2, 0, 0), SHIFT_REPEAT(5934),
  [7345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5511),
  [7347] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5511),
  [7349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5510),
  [7351] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7304),
  [7353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4753),
  [7355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3892),
  [7357] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_types, 1, 0, 0),
  [7359] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_argument_constraints_repeat1, 2, 0, 0), SHIFT_REPEAT(5526),
  [7362] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_do, 2, 0, 0),
  [7364] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_member_defn, 1, 0, 0),
  [7366] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_long_identifier_repeat1, 2, 0, 0), SHIFT_REPEAT(7019),
  [7369] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__property_defn, 5, 0, 60),
  [7371] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_long_identifier_repeat1, 2, 0, 0), SHIFT_REPEAT(7474),
  [7374] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__property_defn, 4, 0, 22),
  [7376] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7313),
  [7378] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7117),
  [7380] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_value_declaration, 1, 0, 0),
  [7382] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7339),
  [7384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4691),
  [7386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7337),
  [7388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5775),
  [7390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4061),
  [7392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3817),
  [7394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4966),
  [7396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5558),
  [7398] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5568),
  [7400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5530),
  [7402] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3616),
  [7404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3648),
  [7406] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3663),
  [7408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3703),
  [7410] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_argument_repeat1, 2, 0, 0), SHIFT_REPEAT(5775),
  [7413] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4897),
  [7415] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3836),
  [7417] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5509),
  [7419] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4008),
  [7421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7467),
  [7423] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2087),
  [7425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2102),
  [7427] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2309),
  [7429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2302),
  [7431] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1754),
  [7433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1715),
  [7435] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2088),
  [7437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2126),
  [7439] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1783),
  [7441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1745),
  [7443] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2331),
  [7445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2139),
  [7447] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2421),
  [7449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2143),
  [7451] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2435),
  [7453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2242),
  [7455] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3576),
  [7457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3696),
  [7459] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3598),
  [7461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3596),
  [7463] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_argument_constraints_repeat1, 2, 0, 0), SHIFT_REPEAT(5551),
  [7466] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7093),
  [7468] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5965),
  [7470] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3757),
  [7472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3729),
  [7474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5551),
  [7476] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1866),
  [7478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1821),
  [7480] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5328),
  [7482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4810),
  [7484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4882),
  [7486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5599),
  [7488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3053),
  [7490] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1894),
  [7492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1855),
  [7494] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3752),
  [7496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3727),
  [7498] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_attribute, 1, 0, 0),
  [7500] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5870),
  [7502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5525),
  [7504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4200),
  [7506] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_field, 6, 0, 0),
  [7508] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1911),
  [7510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1690),
  [7512] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1921),
  [7514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1895),
  [7516] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2269),
  [7518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2411),
  [7520] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2201),
  [7522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2372),
  [7524] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_value_declaration_left, 3, 0, 0),
  [7526] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_value_declaration_left, 3, 0, 0),
  [7528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7132),
  [7530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2633),
  [7532] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2654),
  [7534] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2691),
  [7536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2694),
  [7538] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5562),
  [7540] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_argument_constraints_repeat1, 2, 0, 0), SHIFT_REPEAT(5562),
  [7543] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1658),
  [7545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1477),
  [7547] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1641),
  [7549] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1646),
  [7551] = {.entry = {.count = 1, .reusable = false}}, SHIFT(952),
  [7553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(917),
  [7555] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4052),
  [7557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7015),
  [7559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2649),
  [7561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2648),
  [7563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2647),
  [7565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2645),
  [7567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2622),
  [7569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6232),
  [7571] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2032),
  [7573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2036),
  [7575] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_compound_type_repeat1, 2, 0, 0), SHIFT_REPEAT(3889),
  [7578] = {.entry = {.count = 1, .reusable = false}}, SHIFT(945),
  [7580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(877),
  [7582] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2006),
  [7584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2074),
  [7586] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3459),
  [7588] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3527),
  [7590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5531),
  [7592] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_argument_repeat1, 2, 0, 0), SHIFT_REPEAT(5870),
  [7595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3888),
  [7597] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3364),
  [7599] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3838),
  [7601] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3750),
  [7603] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3825),
  [7605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7121),
  [7607] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_argument_constraints_repeat1, 2, 0, 0), SHIFT_REPEAT(5531),
  [7610] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5503),
  [7612] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5499),
  [7614] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5473),
  [7616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5481),
  [7618] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3477),
  [7620] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3551),
  [7622] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_verbatim_string_repeat1, 2, 0, 0), SHIFT_REPEAT(5568),
  [7625] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_verbatim_string_repeat1, 2, 0, 0), SHIFT_REPEAT(5530),
  [7628] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_verbatim_string_repeat1, 2, 0, 0),
  [7630] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_verbatim_string_repeat1, 2, 0, 0),
  [7632] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4834),
  [7634] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4832),
  [7636] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2166),
  [7638] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2310),
  [7640] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_field, 5, 0, 0),
  [7642] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1162),
  [7644] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1124),
  [7646] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3273),
  [7648] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3861),
  [7650] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3429),
  [7652] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3924),
  [7654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7252),
  [7656] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5179),
  [7658] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3504),
  [7660] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3444),
  [7662] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1127),
  [7664] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1088),
  [7666] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4292),
  [7668] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3870),
  [7670] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4691),
  [7672] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3851),
  [7674] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3525),
  [7676] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3482),
  [7678] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_types_repeat1, 2, 0, 0),
  [7680] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4797),
  [7682] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4808),
  [7684] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_repeat_pattern_repeat1, 2, 0, 0), SHIFT_REPEAT(2660),
  [7687] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2234),
  [7689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2430),
  [7691] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_repeat_pattern_repeat1, 2, 0, 0), SHIFT_REPEAT(2633),
  [7694] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5393),
  [7696] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5272),
  [7698] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_fields, 2, 0, 0),
  [7700] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_value_declaration_left, 2, 0, 0),
  [7702] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_value_declaration_left, 2, 0, 0),
  [7704] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6211),
  [7706] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6693),
  [7708] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2821),
  [7710] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2804),
  [7712] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3976),
  [7714] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2731),
  [7716] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2818),
  [7718] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2828),
  [7720] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3292),
  [7722] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4075),
  [7724] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3694),
  [7726] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3812),
  [7728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6830),
  [7730] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_field, 4, 0, 0),
  [7732] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_argument_constraints_repeat1, 2, 0, 0), SHIFT_REPEAT(5525),
  [7735] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3943),
  [7737] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3295),
  [7739] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3793),
  [7741] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3562),
  [7743] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3835),
  [7745] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6417),
  [7747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6366),
  [7749] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2660),
  [7751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7432),
  [7753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2662),
  [7755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2666),
  [7757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2668),
  [7759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2776),
  [7761] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3281),
  [7763] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4024),
  [7765] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3602),
  [7767] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4086),
  [7769] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6813),
  [7771] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4161),
  [7773] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4190),
  [7775] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4764),
  [7777] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3937),
  [7779] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5244),
  [7781] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4092),
  [7783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7170),
  [7785] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4174),
  [7787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4157),
  [7789] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_value_declaration_left, 1, 0, 0),
  [7791] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_value_declaration_left, 1, 0, 0),
  [7793] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_field, 3, 0, 0),
  [7795] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_fields, 3, 0, 0),
  [7797] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5203),
  [7799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5347),
  [7801] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_trait_member_constraint, 4, 0, 0),
  [7803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4657),
  [7805] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4076),
  [7807] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_pattern, 3, 0, 0),
  [7809] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3944),
  [7811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2697),
  [7813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2692),
  [7815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2688),
  [7817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2684),
  [7819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6197),
  [7821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(649),
  [7823] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_format_string_eval, 3, 0, 0),
  [7825] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_format_string_eval, 3, 0, 0),
  [7827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3875),
  [7829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3417),
  [7831] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_named_field, 1, 0, 0),
  [7833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4497),
  [7835] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_file_repeat1, 2, 0, 0),
  [7837] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_file_repeat1, 2, 0, 0), SHIFT_REPEAT(3217),
  [7840] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_file_repeat1, 2, 0, 0), SHIFT_REPEAT(2477),
  [7843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4591),
  [7845] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5726),
  [7847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3388),
  [7849] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7051),
  [7851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7171),
  [7853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7517),
  [7855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3672),
  [7857] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_file_repeat1, 2, 0, 0), SHIFT_REPEAT(2480),
  [7860] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6054),
  [7862] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5334),
  [7864] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__simple_string_char, 1, 0, 0),
  [7866] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__simple_string_char, 1, 0, 0),
  [7868] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6042),
  [7870] = {.entry = {.count = 1, .reusable = true}}, SHIFT(728),
  [7872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6396),
  [7874] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__string_char, 1, 0, 0),
  [7876] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__string_char, 1, 0, 0),
  [7878] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__string_literal_repeat1, 1, 0, 0),
  [7880] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__string_literal_repeat1, 1, 0, 0),
  [7882] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5330),
  [7884] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3627),
  [7886] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1304),
  [7888] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4796),
  [7890] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5575),
  [7892] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5572),
  [7894] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7340),
  [7896] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7410),
  [7898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3382),
  [7900] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3632),
  [7902] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6056),
  [7904] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6068),
  [7906] = {.entry = {.count = 1, .reusable = true}}, SHIFT(698),
  [7908] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5326),
  [7910] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3630),
  [7912] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4547),
  [7914] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3381),
  [7916] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_repeat_pattern_repeat1, 2, 0, 0), SHIFT_REPEAT(2697),
  [7919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3378),
  [7921] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5712),
  [7923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3384),
  [7925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7197),
  [7927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7144),
  [7929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7513),
  [7931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3626),
  [7933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3972),
  [7935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3226),
  [7937] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_argument_constraints_repeat1, 2, 0, 0), SHIFT_REPEAT(5517),
  [7940] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2725),
  [7942] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5517),
  [7944] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4574),
  [7946] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3914),
  [7948] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6191),
  [7950] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6196),
  [7952] = {.entry = {.count = 1, .reusable = true}}, SHIFT(673),
  [7954] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_namespace, 3, 0, 0),
  [7956] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5052),
  [7958] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3147),
  [7960] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5054),
  [7962] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5056),
  [7964] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1342),
  [7966] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__list_pattern_content_repeat1, 2, 0, 0),
  [7968] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3450),
  [7970] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5708),
  [7972] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3620),
  [7974] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6647),
  [7976] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7215),
  [7978] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7525),
  [7980] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5434),
  [7982] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5711),
  [7984] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3533),
  [7986] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6431),
  [7988] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7236),
  [7990] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7529),
  [7992] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4560),
  [7994] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4889),
  [7996] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4622),
  [7998] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5707),
  [8000] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5059),
  [8002] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7347),
  [8004] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7114),
  [8006] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7509),
  [8008] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6294),
  [8010] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_named_field, 3, 0, 0),
  [8012] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3409),
  [8014] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3574),
  [8016] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3572),
  [8018] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6347),
  [8020] = {.entry = {.count = 1, .reusable = true}}, SHIFT(642),
  [8022] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6299),
  [8024] = {.entry = {.count = 1, .reusable = true}}, SHIFT(641),
  [8026] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4006),
  [8028] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4462),
  [8030] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3573),
  [8032] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6322),
  [8034] = {.entry = {.count = 1, .reusable = true}}, SHIFT(497),
  [8036] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6255),
  [8038] = {.entry = {.count = 1, .reusable = true}}, SHIFT(615),
  [8040] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1229),
  [8042] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3586),
  [8044] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5354),
  [8046] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3159),
  [8048] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1344),
  [8050] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2784),
  [8052] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1256),
  [8054] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6308),
  [8056] = {.entry = {.count = 1, .reusable = true}}, SHIFT(712),
  [8058] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3241),
  [8060] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_repeat_pattern_repeat1, 2, 0, 0), SHIFT_REPEAT(2649),
  [8063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6448),
  [8065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3123),
  [8067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6135),
  [8069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(684),
  [8071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4798),
  [8073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3090),
  [8075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3608),
  [8077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3162),
  [8079] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_verbatim_string_repeat1, 2, 0, 0), SHIFT_REPEAT(5575),
  [8082] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_verbatim_string_repeat1, 2, 0, 0), SHIFT_REPEAT(5572),
  [8085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4742),
  [8087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3755),
  [8089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4047),
  [8091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2480),
  [8093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6592),
  [8095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6027),
  [8097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(578),
  [8099] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_curried_spec_repeat1, 2, 0, 0),
  [8101] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_curried_spec_repeat1, 2, 0, 0),
  [8103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5447),
  [8105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4680),
  [8107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(483),
  [8109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3978),
  [8111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3202),
  [8113] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_format_string_repeat1, 1, 0, 0),
  [8115] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_format_string_repeat1, 1, 0, 0),
  [8117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6811),
  [8119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1381),
  [8121] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5713),
  [8123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4483),
  [8125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6978),
  [8127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7085),
  [8129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7007),
  [8131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4476),
  [8133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5566),
  [8135] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5717),
  [8137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3516),
  [8139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6651),
  [8141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7257),
  [8143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7533),
  [8145] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_long_identifier_repeat1, 2, 0, 0), SHIFT_REPEAT(6448),
  [8148] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3718),
  [8150] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_trait_member_constraint, 5, 0, 0),
  [8152] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3060),
  [8154] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5366),
  [8156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4233),
  [8158] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3513),
  [8160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3512),
  [8162] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3511),
  [8164] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7363),
  [8166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4509),
  [8168] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1263),
  [8170] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3809),
  [8172] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4709),
  [8174] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3230),
  [8176] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3258),
  [8178] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5735),
  [8180] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5337),
  [8182] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6793),
  [8184] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7194),
  [8186] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7521),
  [8188] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4561),
  [8190] = {.entry = {.count = 1, .reusable = true}}, SHIFT(789),
  [8192] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3190),
  [8194] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3358),
  [8196] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3359),
  [8198] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5276),
  [8200] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4548),
  [8202] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4408),
  [8204] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3503),
  [8206] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6133),
  [8208] = {.entry = {.count = 1, .reusable = true}}, SHIFT(665),
  [8210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3855),
  [8212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1299),
  [8214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(481),
  [8216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5150),
  [8218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3361),
  [8220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2766),
  [8222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3285),
  [8224] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1119),
  [8226] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_namespace, 2, 0, 0),
  [8228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6390),
  [8230] = {.entry = {.count = 1, .reusable = true}}, SHIFT(612),
  [8232] = {.entry = {.count = 1, .reusable = true}}, SHIFT(922),
  [8234] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_file, 1, 0, 0),
  [8236] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4093),
  [8238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2620),
  [8240] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2677),
  [8242] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2701),
  [8244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2658),
  [8246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(438),
  [8248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(439),
  [8250] = {.entry = {.count = 1, .reusable = true}}, SHIFT(445),
  [8252] = {.entry = {.count = 1, .reusable = true}}, SHIFT(447),
  [8254] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_spec, 2, 0, 0),
  [8256] = {.entry = {.count = 1, .reusable = true}}, SHIFT(459),
  [8258] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_repeat_pattern_repeat1, 2, 0, 0), SHIFT_REPEAT(2620),
  [8261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(470),
  [8263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(467),
  [8265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(476),
  [8267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(436),
  [8269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(456),
  [8271] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_compound_type_repeat1, 2, 0, 0), SHIFT_REPEAT(3817),
  [8274] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7003),
  [8276] = {.entry = {.count = 1, .reusable = true}}, SHIFT(444),
  [8278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(450),
  [8280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6237),
  [8282] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4118),
  [8284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(454),
  [8286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(458),
  [8288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(461),
  [8290] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3815),
  [8292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6030),
  [8294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4149),
  [8296] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_spec, 3, 0, 0),
  [8298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(462),
  [8300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(474),
  [8302] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4771),
  [8304] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5635),
  [8306] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1988),
  [8308] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5607),
  [8310] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument_name_spec, 3, 0, 59),
  [8312] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_name_spec, 3, 0, 59),
  [8314] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5611),
  [8316] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1876),
  [8318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5693),
  [8320] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument_name_spec, 2, 0, 56),
  [8322] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_name_spec, 2, 0, 56),
  [8324] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5584),
  [8326] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5626),
  [8328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5696),
  [8330] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3765),
  [8332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5690),
  [8334] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1803),
  [8336] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5663),
  [8338] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4156),
  [8340] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6749),
  [8342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4156),
  [8344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1752),
  [8346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1669),
  [8348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1021),
  [8350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1514),
  [8352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5639),
  [8354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5694),
  [8356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5608),
  [8358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5586),
  [8360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2010),
  [8362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1644),
  [8364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(845),
  [8366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1686),
  [8368] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_verbatim_string_repeat1, 1, 0, 0),
  [8370] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_verbatim_string_repeat1, 1, 0, 0),
  [8372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1446),
  [8374] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__verbatim_string_char, 1, 0, 0),
  [8376] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__verbatim_string_char, 1, 0, 0),
  [8378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2755),
  [8380] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributes_repeat1, 2, 0, 0), SHIFT_REPEAT(3265),
  [8383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5758),
  [8385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5123),
  [8387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4514),
  [8389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5527),
  [8391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4256),
  [8393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4668),
  [8395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1269),
  [8397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(791),
  [8399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(795),
  [8401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1274),
  [8403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3129),
  [8405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4515),
  [8407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4397),
  [8409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4935),
  [8411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5206),
  [8413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7554),
  [8415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1343),
  [8417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1350),
  [8419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4581),
  [8421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4582),
  [8423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3127),
  [8425] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5900),
  [8427] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5719),
  [8429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4431),
  [8431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1071),
  [8433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1054),
  [8435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(926),
  [8437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4391),
  [8439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4402),
  [8441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1296),
  [8443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4612),
  [8445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4614),
  [8447] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5729),
  [8449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3168),
  [8451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3101),
  [8453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4915),
  [8455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3079),
  [8457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3982),
  [8459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3986),
  [8461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5252),
  [8463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1293),
  [8465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5534),
  [8467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1295),
  [8469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4613),
  [8471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5533),
  [8473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4611),
  [8475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4624),
  [8477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1382),
  [8479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4905),
  [8481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1337),
  [8483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1380),
  [8485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3043),
  [8487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3034),
  [8489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3153),
  [8491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4550),
  [8493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4568),
  [8495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4290),
  [8497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4551),
  [8499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4546),
  [8501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3143),
  [8503] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1353),
  [8505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3224),
  [8507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1232),
  [8509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3223),
  [8511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4922),
  [8513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3169),
  [8515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4562),
  [8517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4243),
  [8519] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5246),
  [8521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1230),
  [8523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4615),
  [8525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3296),
  [8527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4609),
  [8529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4698),
  [8531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3120),
  [8533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4694),
  [8535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3183),
  [8537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3301),
  [8539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3181),
  [8541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2785),
  [8543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3211),
  [8545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3210),
  [8547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4939),
  [8549] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4553),
  [8551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1188),
  [8553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1191),
  [8555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(910),
  [8557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3213),
  [8559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4732),
  [8561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1336),
  [8563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4723),
  [8565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3240),
  [8567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2781),
  [8569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3121),
  [8571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3243),
  [8573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4252),
  [8575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3248),
  [8577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3244),
  [8579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3212),
  [8581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2605),
  [8583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6509),
  [8585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7510),
  [8587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7519),
  [8589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5645),
  [8591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7526),
  [8593] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_arguments_repeat1, 2, 0, 0), SHIFT_REPEAT(5123),
  [8596] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_type_arguments_repeat1, 2, 0, 0),
  [8598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7530),
  [8600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7514),
  [8602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7546),
  [8604] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__object_expression_inner_repeat1, 2, 0, 0), SHIFT_REPEAT(3828),
  [8607] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__object_expression_inner_repeat1, 2, 0, 0),
  [8609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3828),
  [8611] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_expression, 3, 0, 35),
  [8613] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_expression, 6, 0, 48),
  [8615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7534),
  [8617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4422),
  [8619] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_expression, 4, 0, 35),
  [8621] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6809),
  [8623] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5942),
  [8625] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7168),
  [8627] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5916),
  [8629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7518),
  [8631] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6800),
  [8633] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5929),
  [8635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5781),
  [8637] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6438),
  [8639] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5811),
  [8641] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_expression, 5, 0, 48),
  [8643] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_rules_repeat1, 2, 0, 0), SHIFT_REPEAT(2605),
  [8646] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_rules_repeat1, 2, 0, 0), SHIFT_REPEAT(6509),
  [8649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7522),
  [8651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6185),
  [8653] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6274),
  [8655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2135),
  [8657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2499),
  [8659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6310),
  [8661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6385),
  [8663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(553),
  [8665] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__list_elements, 3, 0, 0),
  [8667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2048),
  [8669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(352),
  [8671] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_slice_ranges_repeat1, 2, 0, 0), SHIFT_REPEAT(412),
  [8674] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_slice_ranges_repeat1, 2, 0, 0),
  [8676] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3747),
  [8678] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5972),
  [8680] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4292),
  [8682] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2476),
  [8684] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2049),
  [8686] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__function_or_value_defns_repeat1, 2, 0, 23), SHIFT_REPEAT(2476),
  [8689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3584),
  [8691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2609),
  [8693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3595),
  [8695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2604),
  [8697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3600),
  [8699] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_value_definition, 6, 0, 33),
  [8701] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6045),
  [8703] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1713),
  [8705] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__list_pattern_content_repeat1, 2, 0, 0), SHIFT_REPEAT(2622),
  [8708] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7343),
  [8710] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6044),
  [8712] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1710),
  [8714] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_value_definition, 7, 0, 44),
  [8716] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_file_repeat1, 1, 0, 0),
  [8718] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__module_signature_elements, 1, 0, 0),
  [8720] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_slice_ranges_repeat1, 2, 0, 0), SHIFT_REPEAT(410),
  [8723] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_attributes_repeat1, 2, 0, 0), SHIFT_REPEAT(2782),
  [8726] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_type_attributes_repeat1, 2, 0, 0),
  [8728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3841),
  [8730] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3269),
  [8732] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5215),
  [8734] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6055),
  [8736] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2362),
  [8738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5216),
  [8740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3886),
  [8742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2227),
  [8744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2228),
  [8746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(410),
  [8748] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_slice_ranges, 2, 0, 0),
  [8750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2539),
  [8752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6212),
  [8754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6344),
  [8756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4492),
  [8758] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_types, 2, 0, 0),
  [8760] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6040),
  [8762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1700),
  [8764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3578),
  [8766] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5308),
  [8768] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6039),
  [8770] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1699),
  [8772] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6386),
  [8774] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1078),
  [8776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4778),
  [8778] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5285),
  [8780] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4781),
  [8782] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5543),
  [8784] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5364),
  [8786] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5371),
  [8788] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6376),
  [8790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1062),
  [8792] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_slice_ranges, 1, 0, 0),
  [8794] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6183),
  [8796] = {.entry = {.count = 1, .reusable = true}}, SHIFT(891),
  [8798] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arguments_spec, 1, 0, 0),
  [8800] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3758),
  [8802] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_field_initializers_repeat1, 2, 0, 0), SHIFT_REPEAT(5815),
  [8805] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_field_initializers_repeat1, 2, 0, 0),
  [8807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2507),
  [8809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6086),
  [8811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6313),
  [8813] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6002),
  [8815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3629),
  [8817] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6781),
  [8819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5815),
  [8821] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_initializers, 2, 0, 0),
  [8823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3607),
  [8825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(412),
  [8827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3633),
  [8829] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6036),
  [8831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2222),
  [8833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3611),
  [8835] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6176),
  [8837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(899),
  [8839] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6035),
  [8841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2223),
  [8843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2494),
  [8845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6021),
  [8847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6273),
  [8849] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5705),
  [8851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3428),
  [8853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3426),
  [8855] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_record_fields_repeat1, 2, 0, 0), SHIFT_REPEAT(5275),
  [8858] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_record_fields_repeat1, 2, 0, 0),
  [8860] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6210),
  [8862] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3654),
  [8864] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5727),
  [8866] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__list_elements_repeat1, 2, 0, 0), SHIFT_REPEAT(553),
  [8869] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__list_elements_repeat1, 2, 0, 0),
  [8871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2461),
  [8873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3724),
  [8875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2463),
  [8877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3671),
  [8879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3418),
  [8881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2217),
  [8883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2218),
  [8885] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6001),
  [8887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1735),
  [8889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3424),
  [8891] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6033),
  [8893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1627),
  [8895] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6345),
  [8897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3434),
  [8899] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_active_pattern_repeat1, 2, 0, 0), SHIFT_REPEAT(6428),
  [8902] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_active_pattern_repeat1, 2, 0, 0),
  [8904] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6031),
  [8906] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1625),
  [8908] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3711),
  [8910] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3441),
  [8912] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3453),
  [8914] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3713),
  [8916] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4567),
  [8918] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2552),
  [8920] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6157),
  [8922] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6247),
  [8924] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6339),
  [8926] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3528),
  [8928] = {.entry = {.count = 1, .reusable = true}}, SHIFT(551),
  [8930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3895),
  [8932] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_record_pattern_repeat1, 2, 0, 0),
  [8934] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_record_pattern_repeat1, 2, 0, 0), SHIFT_REPEAT(5972),
  [8937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1087),
  [8939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1084),
  [8941] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6074),
  [8943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1739),
  [8945] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_named_field_pattern_repeat1, 2, 0, 0),
  [8947] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_named_field_pattern_repeat1, 2, 0, 0), SHIFT_REPEAT(2609),
  [8950] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1794),
  [8952] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1795),
  [8954] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3683),
  [8956] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5471),
  [8958] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2550),
  [8960] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6326),
  [8962] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6209),
  [8964] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6028),
  [8966] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3766),
  [8968] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3685),
  [8970] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1999),
  [8972] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6026),
  [8974] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3771),
  [8976] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1998),
  [8978] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2782),
  [8980] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_attributes, 2, 0, 0),
  [8982] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4802),
  [8984] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_types_repeat1, 2, 0, 0), SHIFT_REPEAT(3892),
  [8987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3664),
  [8989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5994),
  [8991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4933),
  [8993] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6053),
  [8995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2335),
  [8997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3402),
  [8999] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6151),
  [9001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4186),
  [9003] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_argument_defn, 2, 0, 0),
  [9005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2537),
  [9007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6286),
  [9009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6182),
  [9011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3634),
  [9013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4852),
  [9015] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6142),
  [9017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4180),
  [9019] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6024),
  [9021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1900),
  [9023] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_initializers, 1, 0, 0),
  [9025] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6023),
  [9027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1902),
  [9029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2542),
  [9031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6163),
  [9033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6147),
  [9035] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6092),
  [9037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3458),
  [9039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4867),
  [9041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5172),
  [9043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5363),
  [9045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4136),
  [9047] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6238),
  [9049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3764),
  [9051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4176),
  [9053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5279),
  [9055] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6585),
  [9057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2513),
  [9059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6057),
  [9061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6125),
  [9063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(881),
  [9065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(882),
  [9067] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__property_defn_repeat1, 2, 0, 0), SHIFT_REPEAT(5994),
  [9070] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__property_defn_repeat1, 2, 0, 0),
  [9072] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3754),
  [9074] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3534),
  [9076] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4144),
  [9078] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6314),
  [9080] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2318),
  [9082] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6248),
  [9084] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3739),
  [9086] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5469),
  [9088] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2496),
  [9090] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6100),
  [9092] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6106),
  [9094] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3715),
  [9096] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3505),
  [9098] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4151),
  [9100] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6309),
  [9102] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2359),
  [9104] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1846),
  [9106] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6253),
  [9108] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3415),
  [9110] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1845),
  [9112] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2444),
  [9114] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2445),
  [9116] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6097),
  [9118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2268),
  [9120] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5422),
  [9122] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4863),
  [9124] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5468),
  [9126] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arguments_spec, 2, 0, 0),
  [9128] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6126),
  [9130] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3659),
  [9132] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2503),
  [9134] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6241),
  [9136] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6073),
  [9138] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5103),
  [9140] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_fields, 1, 0, 0),
  [9142] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4726),
  [9144] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__attribute_set_repeat1, 2, 0, 0),
  [9146] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__attribute_set_repeat1, 2, 0, 0), SHIFT_REPEAT(3269),
  [9149] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_arguments_spec_repeat1, 2, 0, 0),
  [9151] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_arguments_spec_repeat1, 2, 0, 0), SHIFT_REPEAT(3758),
  [9154] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6121),
  [9156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3667),
  [9158] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6108),
  [9160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2278),
  [9162] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_argument_defn, 1, 0, 0),
  [9164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4744),
  [9166] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_argument_constraints_repeat1, 2, 0, 0), SHIFT_REPEAT(5543),
  [9169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1551),
  [9171] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_attributes, 1, 0, 0),
  [9173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1550),
  [9175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2849),
  [9177] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6271),
  [9179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2090),
  [9181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3438),
  [9183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5446),
  [9185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4930),
  [9187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3486),
  [9189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3485),
  [9191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2238),
  [9193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2236),
  [9195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5436),
  [9197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2560),
  [9199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6177),
  [9201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6173),
  [9203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3460),
  [9205] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6251),
  [9207] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7394),
  [9209] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6445),
  [9211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(607),
  [9213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(552),
  [9215] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_accessor, 2, 0, 0),
  [9217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(695),
  [9219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(544),
  [9221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(507),
  [9223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(590),
  [9225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(619),
  [9227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6046),
  [9229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(643),
  [9231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(550),
  [9233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(739),
  [9235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(746),
  [9237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(489),
  [9239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(730),
  [9241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(681),
  [9243] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7175),
  [9245] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7186),
  [9247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(522),
  [9249] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7231),
  [9251] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7242),
  [9253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(736),
  [9255] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7280),
  [9257] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7286),
  [9259] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__static_parameter, 1, 0, 0),
  [9261] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7334),
  [9263] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7346),
  [9265] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7412),
  [9267] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7428),
  [9269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(534),
  [9271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(564),
  [9273] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7527),
  [9275] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7532),
  [9277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4831),
  [9279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4830),
  [9281] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5356),
  [9283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3872),
  [9285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(563),
  [9287] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7321),
  [9289] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7305),
  [9291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(618),
  [9293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(569),
  [9295] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5224),
  [9297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3833),
  [9299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2510),
  [9301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2543),
  [9303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6139),
  [9305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3876),
  [9307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6330),
  [9309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3969),
  [9311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2508),
  [9313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2488),
  [9315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4827),
  [9317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4826),
  [9319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2504),
  [9321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6307),
  [9323] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7354),
  [9325] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute, 3, 0, 0),
  [9327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(495),
  [9329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4750),
  [9331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4751),
  [9333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(525),
  [9335] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_implementation, 3, 0, 35),
  [9337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(559),
  [9339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(594),
  [9341] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5253),
  [9343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3908),
  [9345] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6621),
  [9347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2502),
  [9349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2525),
  [9351] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7213),
  [9353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(505),
  [9355] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__object_members, 4, 0, 22),
  [9357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(538),
  [9359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(599),
  [9361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2501),
  [9363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2558),
  [9365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2497),
  [9367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6132),
  [9369] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__object_expression_inner_repeat1, 1, 0, 0),
  [9371] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7158),
  [9373] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5346),
  [9375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4051),
  [9377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(639),
  [9379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4088),
  [9381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2493),
  [9383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2534),
  [9385] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6992),
  [9387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(484),
  [9389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2490),
  [9391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2528),
  [9393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2484),
  [9395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6032),
  [9397] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6942),
  [9399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(609),
  [9401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6461),
  [9403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4133),
  [9405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2519),
  [9407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2512),
  [9409] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6819),
  [9411] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration_left, 2, 0, 0),
  [9413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2521),
  [9415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2522),
  [9417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2481),
  [9419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6138),
  [9421] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration_left, 5, 0, 0),
  [9423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5900),
  [9425] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6772),
  [9427] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_slice_range, 1, 0, 14),
  [9429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4812),
  [9431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4811),
  [9433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(731),
  [9435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(614),
  [9437] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5250),
  [9439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4025),
  [9441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(523),
  [9443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2532),
  [9445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2557),
  [9447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2563),
  [9449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6341),
  [9451] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6630),
  [9453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2482),
  [9455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2529),
  [9457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(719),
  [9459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2535),
  [9461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2487),
  [9463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2536),
  [9465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6259),
  [9467] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6590),
  [9469] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__list_pattern_content, 5, 0, 42),
  [9471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(579),
  [9473] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5385),
  [9475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3923),
  [9477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2546),
  [9479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2498),
  [9481] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_value_declaration_left, 4, 0, 0),
  [9483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2554),
  [9485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2523),
  [9487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2564),
  [9489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6337),
  [9491] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6493),
  [9493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(623),
  [9495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(513),
  [9497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(589),
  [9499] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__list_pattern_content, 3, 0, 19),
  [9501] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5189),
  [9503] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4019),
  [9505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2483),
  [9507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2549),
  [9509] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6623),
  [9511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2562),
  [9513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2548),
  [9515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2559),
  [9517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6194),
  [9519] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6708),
  [9521] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_active_pattern_repeat1, 2, 0, 9),
  [9523] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_active_pattern_repeat1, 2, 0, 9),
  [9525] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6433),
  [9527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(625),
  [9529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4091),
  [9531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2547),
  [9533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2515),
  [9535] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6890),
  [9537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2516),
  [9539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2506),
  [9541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2530),
  [9543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6038),
  [9545] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6962),
  [9547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(654),
  [9549] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration_left, 3, 0, 0),
  [9551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6012),
  [9553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3916),
  [9555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(714),
  [9557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(501),
  [9559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(512),
  [9561] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__list_element, 3, 0, 0),
  [9563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(500),
  [9565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(562),
  [9567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4084),
  [9569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2551),
  [9571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2520),
  [9573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(617),
  [9575] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7066),
  [9577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2524),
  [9579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2533),
  [9581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2485),
  [9583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6071),
  [9585] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7092),
  [9587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2531),
  [9589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2526),
  [9591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6098),
  [9593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3952),
  [9595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(603),
  [9597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4030),
  [9599] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5261),
  [9601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4041),
  [9603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2514),
  [9605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2489),
  [9607] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7216),
  [9609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2505),
  [9611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2486),
  [9613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2561),
  [9615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6201),
  [9617] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7239),
  [9619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(580),
  [9621] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute, 1, 0, 0),
  [9623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6228),
  [9625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4101),
  [9627] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_named_static_parameter, 3, 0, 0),
  [9629] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__list_pattern_content, 4, 0, 30),
  [9631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3925),
  [9633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2518),
  [9635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2553),
  [9637] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7357),
  [9639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4940),
  [9641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2491),
  [9643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2492),
  [9645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(626),
  [9647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2511),
  [9649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6301),
  [9651] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7369),
  [9653] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration_left, 4, 0, 0),
  [9655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3443),
  [9657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2111),
  [9659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7403),
  [9661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6666),
  [9663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6319),
  [9665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6305),
  [9667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(369),
  [9669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1827),
  [9671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6338),
  [9673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4077),
  [9675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4111),
  [9677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5791),
  [9679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7366),
  [9681] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7365),
  [9683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7440),
  [9685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7441),
  [9687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6134),
  [9689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1243),
  [9691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3259),
  [9693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3369),
  [9695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3188),
  [9697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3536),
  [9699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3083),
  [9701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6292),
  [9703] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4484),
  [9705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3178),
  [9707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2601),
  [9709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4461),
  [9711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7350),
  [9713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2976),
  [9715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6251),
  [9717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3913),
  [9719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4473),
  [9721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3535),
  [9723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6289),
  [9725] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3569),
  [9727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3106),
  [9729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2158),
  [9731] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2164),
  [9733] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2167),
  [9735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3896),
  [9737] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2169),
  [9739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4306),
  [9741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6781),
  [9743] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1137),
  [9745] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1354),
  [9747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4448),
  [9749] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3619),
  [9751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1186),
  [9753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2177),
  [9755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5454),
  [9757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7314),
  [9759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7311),
  [9761] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5851),
  [9763] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1203),
  [9765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1281),
  [9767] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3046),
  [9769] = {.entry = {.count = 1, .reusable = true}}, SHIFT(895),
  [9771] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6257),
  [9773] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2178),
  [9775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7278),
  [9777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1179),
  [9779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2990),
  [9781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4357),
  [9783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6217),
  [9785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4851),
  [9787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4417),
  [9789] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6207),
  [9791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(388),
  [9793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3581),
  [9795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3028),
  [9797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3055),
  [9799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3580),
  [9801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7233),
  [9803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7232),
  [9805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3115),
  [9807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4366),
  [9809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6843),
  [9811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1192),
  [9813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1068),
  [9815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2245),
  [9817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2185),
  [9819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6175),
  [9821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1335),
  [9823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2789),
  [9825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2599),
  [9827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2904),
  [9829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7204),
  [9831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3208),
  [9833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2816),
  [9835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3794),
  [9837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2186),
  [9839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4056),
  [9841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6161),
  [9843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3623),
  [9845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3624),
  [9847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2189),
  [9849] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2190),
  [9851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2191),
  [9853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2195),
  [9855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1079),
  [9857] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1520),
  [9859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7148),
  [9861] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7147),
  [9863] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5939),
  [9865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4405),
  [9867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3180),
  [9869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2614),
  [9871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2792),
  [9873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6114),
  [9875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7120),
  [9877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1245),
  [9879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1246),
  [9881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3579),
  [9883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6089),
  [9885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2069),
  [9887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2320),
  [9889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6082),
  [9891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(374),
  [9893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4854),
  [9895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2985),
  [9897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4489),
  [9899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4693),
  [9901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7086),
  [9903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7084),
  [9905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2068),
  [9907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3271),
  [9909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6312),
  [9911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1122),
  [9913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2067),
  [9915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1140),
  [9917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1992),
  [9919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4296),
  [9921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2593),
  [9923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4420),
  [9925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7057),
  [9927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1148),
  [9929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5718),
  [9931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4059),
  [9933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6007),
  [9935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3222),
  [9937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3631),
  [9939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3610),
  [9941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4490),
  [9943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2205),
  [9945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3154),
  [9947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3155),
  [9949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7022),
  [9951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7021),
  [9953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5737),
  [9955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4450),
  [9957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3174),
  [9959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2207),
  [9961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2208),
  [9963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6006),
  [9965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3651),
  [9967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6999),
  [9969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4035),
  [9971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1070),
  [9973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2046),
  [9975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6017),
  [9977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4545),
  [9979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6022),
  [9981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(392),
  [9983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4673),
  [9985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4676),
  [9987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2807),
  [9989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2041),
  [9991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6953),
  [9993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6948),
  [9995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3199),
  [9997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1366),
  [9999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4154),
  [10001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6408),
  [10003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4155),
  [10005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2040),
  [10007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2039),
  [10009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3936),
  [10011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6062),
  [10013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3618),
  [10015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3723),
  [10017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2616),
  [10019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(905),
  [10021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6897),
  [10023] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module, 6, 0, 21),
  [10025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3722),
  [10027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4068),
  [10029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6078),
  [10031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3033),
  [10033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2795),
  [10035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3998),
  [10037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3252),
  [10039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1076),
  [10041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3251),
  [10043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2035),
  [10045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6832),
  [10047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6831),
  [10049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5941),
  [10051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2034),
  [10053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4537),
  [10055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(790),
  [10057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4368),
  [10059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6122),
  [10061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3859),
  [10063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6785),
  [10065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4344),
  [10067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3852),
  [10069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6145),
  [10071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2029),
  [10073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4610),
  [10075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6162),
  [10077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(395),
  [10079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3449),
  [10081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4569),
  [10083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3756),
  [10085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(924),
  [10087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6705),
  [10089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6704),
  [10091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4478),
  [10093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4477),
  [10095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2026),
  [10097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(913),
  [10099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4434),
  [10101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1181),
  [10103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2021),
  [10105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6222),
  [10107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2018),
  [10109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3987),
  [10111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2603),
  [10113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2017),
  [10115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6650),
  [10117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2015),
  [10119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3931),
  [10121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6229),
  [10123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3625),
  [10125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3025),
  [10127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3072),
  [10129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3622),
  [10131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1097),
  [10133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1963),
  [10135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1961),
  [10137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3515),
  [10139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6582),
  [10141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6580),
  [10143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5833),
  [10145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4510),
  [10147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1960),
  [10149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1954),
  [10151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5182),
  [10153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6296),
  [10155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3514),
  [10157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6524),
  [10159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6438),
  [10161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3173),
  [10163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6323),
  [10165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1094),
  [10167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6329),
  [10169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(383),
  [10171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4696),
  [10173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4697),
  [10175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2438),
  [10177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1409),
  [10179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6490),
  [10181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6480),
  [10183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2973),
  [10185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1357),
  [10187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1945),
  [10189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4415),
  [10191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3691),
  [10193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1171),
  [10195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6367),
  [10197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3197),
  [10199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1166),
  [10201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2613),
  [10203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3198),
  [10205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6436),
  [10207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4554),
  [10209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1164),
  [10211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3926),
  [10213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6370),
  [10215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1942),
  [10217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5986),
  [10219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3677),
  [10221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4903),
  [10223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6037),
  [10225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3088),
  [10227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1213),
  [10229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6574),
  [10231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6488),
  [10233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5803),
  [10235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3442),
  [10237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1933),
  [10239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1932),
  [10241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1519),
  [10243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6303),
  [10245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3759),
  [10247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6557),
  [10249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3315),
  [10251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1108),
  [10253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6287),
  [10255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1987),
  [10257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1159),
  [10259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6283),
  [10261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(376),
  [10263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3710),
  [10265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1925),
  [10267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4419),
  [10269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6603),
  [10271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6607),
  [10273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4416),
  [10275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1986),
  [10277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1924),
  [10279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1985),
  [10281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1512),
  [10283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4594),
  [10285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3203),
  [10287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6239),
  [10289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3214),
  [10291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1351),
  [10293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2618),
  [10295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6638),
  [10297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1923),
  [10299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1100),
  [10301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4032),
  [10303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6224),
  [10305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6532),
  [10307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1103),
  [10309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5324),
  [10311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3334),
  [10313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1916),
  [10315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1893),
  [10317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6398),
  [10319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6703),
  [10321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5901),
  [10323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3009),
  [10325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1974),
  [10327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6542),
  [10329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6179),
  [10331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6731),
  [10333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4516),
  [10335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6166),
  [10337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6159),
  [10339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(398),
  [10341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6295),
  [10343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1971),
  [10345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1329),
  [10347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6774),
  [10349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6777),
  [10351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1319),
  [10353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1968),
  [10355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2329),
  [10357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3031),
  [10359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4167),
  [10361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3317),
  [10363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1966),
  [10365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6117),
  [10367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1172),
  [10369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1965),
  [10371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2569),
  [10373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6840),
  [10375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4022),
  [10377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4538),
  [10379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4125),
  [10381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6103),
  [10383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(948),
  [10385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4539),
  [10387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6873),
  [10389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6877),
  [10391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5964),
  [10393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1221),
  [10395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2780),
  [10397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4558),
  [10399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5336),
  [10401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6067),
  [10403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6906),
  [10405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3761),
  [10407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6585),
  [10409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6058),
  [10411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1307),
  [10413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3831),
  [10415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6052),
  [10417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(400),
  [10419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1952),
  [10421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4432),
  [10423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1951),
  [10425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6952),
  [10427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6959),
  [10429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5536),
  [10431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3860),
  [10433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(933),
  [10435] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module, 5, 0, 11),
  [10437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3414),
  [10439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1888),
  [10441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6010),
  [10443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1236),
  [10445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1887),
  [10447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2580),
  [10449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4148),
  [10451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7030),
  [10453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1886),
  [10455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3719),
  [10457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4100),
  [10459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6004),
  [10461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1577),
  [10463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4536),
  [10465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7077),
  [10467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7078),
  [10469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5975),
  [10471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3463),
  [10473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2434),
  [10475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2433),
  [10477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1940),
  [10479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6088),
  [10481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7119),
  [10483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5472),
  [10485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5476),
  [10487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6099),
  [10489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1937),
  [10491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1931),
  [10493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6110),
  [10495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(368),
  [10497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5516),
  [10499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1383),
  [10501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1929),
  [10503] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7160),
  [10505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7164),
  [10507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5521),
  [10509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5512),
  [10511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1387),
  [10513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3027),
  [10515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4299),
  [10517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3522),
  [10519] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6186),
  [10521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1238),
  [10523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2587),
  [10525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7469),
  [10527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7221),
  [10529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1363),
  [10531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3298),
  [10533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3902),
  [10535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6325),
  [10537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1359),
  [10539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1048),
  [10541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7269),
  [10543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7273),
  [10545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5869),
  [10547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1330),
  [10549] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4871),
  [10551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3163),
  [10553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5500),
  [10555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6256),
  [10557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7323),
  [10559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5335),
  [10561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5501),
  [10563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6267),
  [10565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4956),
  [10567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4923),
  [10569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6276),
  [10571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(372),
  [10573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2471),
  [10575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1198),
  [10577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7381),
  [10579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7385),
  [10581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1199),
  [10583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2284),
  [10585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2220),
  [10587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2270),
  [10589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1805),
  [10591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(787),
  [10593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2243),
  [10595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6332),
  [10597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3130),
  [10599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2240),
  [10601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2594),
  [10603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3122),
  [10605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7310),
  [10607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2239),
  [10609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4739),
  [10611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3951),
  [10613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6352),
  [10615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2231),
  [10617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3131),
  [10619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7476),
  [10621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7506),
  [10623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5771),
  [10625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7430),
  [10627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4876),
  [10629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6397),
  [10631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4877),
  [10633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2462),
  [10635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4218),
  [10637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3247),
  [10639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2598),
  [10641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3245),
  [10643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3837),
  [10645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2458),
  [10647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7545),
  [10649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7543),
  [10651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5756),
  [10653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2210),
  [10655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7539),
  [10657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5268),
  [10659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6368),
  [10661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3157),
  [10663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3150),
  [10665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2209),
  [10667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7462),
  [10669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7460),
  [10671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5786),
  [10673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7105),
  [10675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7446),
  [10677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2457),
  [10679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6342),
  [10681] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2456),
  [10683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3669),
  [10685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2783),
  [10687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3100),
  [10689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7367),
  [10691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7364),
  [10693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5819),
  [10695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2154),
  [10697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7355),
  [10699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4370),
  [10701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4955),
  [10703] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2453),
  [10705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2153),
  [10707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7317),
  [10709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7315),
  [10711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5850),
  [10713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1664),
  [10715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7294),
  [10717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2452),
  [10719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3769),
  [10721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1290),
  [10723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2140),
  [10725] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7267),
  [10727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7263),
  [10729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5881),
  [10731] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5460),
  [10733] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7254),
  [10735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3234),
  [10737] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3233),
  [10739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2133),
  [10741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7210),
  [10743] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7207),
  [10745] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5910),
  [10747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2128),
  [10749] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7195),
  [10751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4011),
  [10753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4559),
  [10755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2447),
  [10757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7152),
  [10759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7149),
  [10761] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3135),
  [10763] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7135),
  [10765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2097),
  [10767] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4442),
  [10769] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7111),
  [10771] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7109),
  [10773] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1969),
  [10775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7087),
  [10777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2446),
  [10779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3682),
  [10781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7049),
  [10783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7039),
  [10785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3242),
  [10787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6917),
  [10789] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1453),
  [10791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4527),
  [10793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7001),
  [10795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1375),
  [10797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1390),
  [10799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5450),
  [10801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6969),
  [10803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1448),
  [10805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4529),
  [10807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4087),
  [10809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6931),
  [10811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(356),
  [10813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2431),
  [10815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2086),
  [10817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6912),
  [10819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2091),
  [10821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2092),
  [10823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5465),
  [10825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6885),
  [10827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(396),
  [10829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1671),
  [10831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4981),
  [10833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6861),
  [10835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2136),
  [10837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2137),
  [10839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2917),
  [10841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6849),
  [10843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3983),
  [10845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3461),
  [10847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3462),
  [10849] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6790),
  [10851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2428),
  [10853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2427),
  [10855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2422),
  [10857] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6782),
  [10859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6187),
  [10861] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3304),
  [10863] = {.entry = {.count = 1, .reusable = true}}, SHIFT(854),
  [10865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6765),
  [10867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(925),
  [10869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2075),
  [10871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6737),
  [10873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3249),
  [10875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4384),
  [10877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(855),
  [10879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6720),
  [10881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6170),
  [10883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3125),
  [10885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3386),
  [10887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6683),
  [10889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1691),
  [10891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4246),
  [10893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3387),
  [10895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6669),
  [10897] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__if_branch, 2, 0, 6),
  [10899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4135),
  [10901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(862),
  [10903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6645),
  [10905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(939),
  [10907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(940),
  [10909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(943),
  [10911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6627),
  [10913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4310),
  [10915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3228),
  [10917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6615),
  [10919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6600),
  [10921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1064),
  [10923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2417),
  [10925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4866),
  [10927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6572),
  [10929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1059),
  [10931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(958),
  [10933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4667),
  [10935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6552),
  [10937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1058),
  [10939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(957),
  [10941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3019),
  [10943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6530),
  [10945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(918),
  [10947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(919),
  [10949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(785),
  [10951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6514),
  [10953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1384),
  [10955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1348),
  [10957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(949),
  [10959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4066),
  [10961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(947),
  [10963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3278),
  [10965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3277),
  [10967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6791),
  [10969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6800),
  [10971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3308),
  [10973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2375),
  [10975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3808),
  [10977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1555),
  [10979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2545),
  [10981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6403),
  [10983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6404),
  [10985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1280),
  [10987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3490),
  [10989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(942),
  [10991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6378),
  [10993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(941),
  [10995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(365),
  [10997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(936),
  [10999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3907),
  [11001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4486),
  [11003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1651),
  [11005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(929),
  [11007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1647),
  [11009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1556),
  [11011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1557),
  [11013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3922),
  [11015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4235),
  [11017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3912),
  [11019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4464),
  [11021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4245),
  [11023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5401),
  [11025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3614),
  [11027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1570),
  [11029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3500),
  [11031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3973),
  [11033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4579),
  [11035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1493),
  [11037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2509),
  [11039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6465),
  [11041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6466),
  [11043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5400),
  [11045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4794),
  [11047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(359),
  [11049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(801),
  [11051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(803),
  [11053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(907),
  [11055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(906),
  [11057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(901),
  [11059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3520),
  [11061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3312),
  [11063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1581),
  [11065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4541),
  [11067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3884),
  [11069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1500),
  [11071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3866),
  [11073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3524),
  [11075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3408),
  [11077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2363),
  [11079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4143),
  [11081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4142),
  [11083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2364),
  [11085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1476),
  [11087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2555),
  [11089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6520),
  [11091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6521),
  [11093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1583),
  [11095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2254),
  [11097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1306),
  [11099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1590),
  [11101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(354),
  [11103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2382),
  [11105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6018),
  [11107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1591),
  [11109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4931),
  [11111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6809),
  [11113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4454),
  [11115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4121),
  [11117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1600),
  [11119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5038),
  [11121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3856),
  [11123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3840),
  [11125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1789),
  [11127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1908),
  [11129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4869),
  [11131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4606),
  [11133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2500),
  [11135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6570),
  [11137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6571),
  [11139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1467),
  [11141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4803),
  [11143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4822),
  [11145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(364),
  [11147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1907),
  [11149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4870),
  [11151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4881),
  [11153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3346),
  [11155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1601),
  [11157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3810),
  [11159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4498),
  [11161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3796),
  [11163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3345),
  [11165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4504),
  [11167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2264),
  [11169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1454),
  [11171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2544),
  [11173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6619),
  [11175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6620),
  [11177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2266),
  [11179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2267),
  [11181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2276),
  [11183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1899),
  [11185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(362),
  [11187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2653),
  [11189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1897),
  [11191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4841),
  [11193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3436),
  [11195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2248),
  [11197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1609),
  [11199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3910),
  [11201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3487),
  [11203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3980),
  [11205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3404),
  [11207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4837),
  [11209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1610),
  [11211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1611),
  [11213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2517),
  [11215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6667),
  [11217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6668),
  [11219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2296),
  [11221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4257),
  [11223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2299),
  [11225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4526),
  [11227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(358),
  [11229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1615),
  [11231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3767),
  [11233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2313),
  [11235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2315),
  [11237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3095),
  [11239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1441),
  [11241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4046),
  [11243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4874),
  [11245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4112),
  [11247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3476),
  [11249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3474),
  [11251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2336),
  [11253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3768),
  [11255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2540),
  [11257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6715),
  [11259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6716),
  [11261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2215),
  [11263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2344),
  [11265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(360),
  [11267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7017),
  [11269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3379),
  [11271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2355),
  [11273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4665),
  [11275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4678),
  [11277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(541),
  [11279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4044),
  [11281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4886),
  [11283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4000),
  [11285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1439),
  [11287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7033),
  [11289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2495),
  [11291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1857),
  [11293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2541),
  [11295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6761),
  [11297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6762),
  [11299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1856),
  [11301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1849),
  [11303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3721),
  [11305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(424),
  [11307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(363),
  [11309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(413),
  [11311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3714),
  [11313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1379),
  [11315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3545),
  [11317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1339),
  [11319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1788),
  [11321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4666),
  [11323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1787),
  [11325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1623),
  [11327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3194),
  [11329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2527),
  [11331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6801),
  [11333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6802),
  [11335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3319),
  [11337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1624),
  [11339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3451),
  [11341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(355),
  [11343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4708),
  [11345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5340),
  [11347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2669),
  [11349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2436),
  [11351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3064),
  [11353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2437),
  [11355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2441),
  [11357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4336),
  [11359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7556),
  [11361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3026),
  [11363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2556),
  [11365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6841),
  [11367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6842),
  [11369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7555),
  [11371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2324),
  [11373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1681),
  [11375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(357),
  [11377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1371),
  [11379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4862),
  [11381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1759),
  [11383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5288),
  [11385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3330),
  [11387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5271),
  [11389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3585),
  [11391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3423),
  [11393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3591),
  [11395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2538),
  [11397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6881),
  [11399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6882),
  [11401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2314),
  [11403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3422),
  [11405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1282),
  [11407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6102),
  [11409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(361),
  [11411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(937),
  [11413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1780),
  [11415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1361),
  [11417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1777),
  [11419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3396),
  [11421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1776),
  [11423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6913),
  [11425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2225),
  [11427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4062),
  [11429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4618),
  [11431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4513),
  [11433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6929),
  [11435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6940),
  [11437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2272),
  [11439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6350),
  [11441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5057),
  [11443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1575),
  [11445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2224),
  [11447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5058),
  [11449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1775),
  [11451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2373),
  [11453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2370),
  [11455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2369),
  [11457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2365),
  [11459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1733),
  [11461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3141),
  [11463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3142),
  [11465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1101),
  [11467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3526),
  [11469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2349),
  [11471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4901),
  [11473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2348),
  [11475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1546),
  [11477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2251),
  [11479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2338),
  [11481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2337),
  [11483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2246),
  [11485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(991),
  [11487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1072),
  [11489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5414),
  [11491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2479),
  [11493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4988),
  [11495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(414),
  [11497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(421),
  [11499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2323),
  [11501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7101),
  [11503] = {.entry = {.count = 1, .reusable = true}}, SHIFT(637),
  [11505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2322),
  [11507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2321),
  [11509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1773),
  [11511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2306),
  [11513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7116),
  [11515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5919),
  [11517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1772),
  [11519] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1768),
  [11521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4247),
  [11523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4401),
  [11525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5023),
  [11527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(411),
  [11529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(426),
  [11531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1767),
  [11533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(666),
  [11535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1731),
  [11537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7183),
  [11539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4191),
  [11541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7146),
  [11543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5048),
  [11545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(406),
  [11547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(430),
  [11549] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7184),
  [11551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(685),
  [11553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5074),
  [11555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1761),
  [11557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1760),
  [11559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7173),
  [11561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5061),
  [11563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(408),
  [11565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(429),
  [11567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5370),
  [11569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(718),
  [11571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1696),
  [11573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5053),
  [11575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4741),
  [11577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7196),
  [11579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5077),
  [11581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(403),
  [11583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(427),
  [11585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7524),
  [11587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(751),
  [11589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2282),
  [11591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1417),
  [11593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2279),
  [11595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7217),
  [11597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5092),
  [11599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(407),
  [11601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(428),
  [11603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1697),
  [11605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(508),
  [11607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1369),
  [11609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5329),
  [11611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7238),
  [11613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5102),
  [11615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(409),
  [11617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(425),
  [11619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(988),
  [11621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(610),
  [11623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1757),
  [11625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1081),
  [11627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1042),
  [11629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7259),
  [11631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5127),
  [11633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(402),
  [11635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(418),
  [11637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4631),
  [11639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(601),
  [11641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5305),
  [11643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5293),
  [11645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5140),
  [11647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(405),
  [11649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(419),
  [11651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4629),
  [11653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(572),
  [11655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1415),
  [11657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3792),
  [11659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5158),
  [11661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(415),
  [11663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(420),
  [11665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1747),
  [11667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(636),
  [11669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1746),
  [11671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2722),
  [11673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5167),
  [11675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(404),
  [11677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(431),
  [11679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5190),
  [11681] = {.entry = {.count = 1, .reusable = true}}, SHIFT(699),
  [11683] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_field_expression, 5, 0, 47),
  [11685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5146),
  [11687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5165),
  [11689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4570),
  [11691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5169),
  [11693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5065),
  [11695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5151),
  [11697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2101),
  [11699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5145),
  [11701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5144),
  [11703] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5143),
  [11705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5142),
  [11707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5139),
  [11709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5138),
  [11711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5135),
  [11713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5133),
  [11715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5130),
  [11717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5129),
  [11719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5126),
  [11721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5125),
  [11723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5120),
  [11725] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5119),
  [11727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5116),
  [11729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5115),
  [11731] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5113),
  [11733] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5111),
  [11735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5106),
  [11737] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5105),
  [11739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5104),
  [11741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5100),
  [11743] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5099),
  [11745] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5098),
  [11747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5097),
  [11749] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5095),
  [11751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5093),
  [11753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5090),
  [11755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2775),
  [11757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2099),
  [11759] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__attribute_target, 1, 0, 0),
  [11761] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7291),
  [11763] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3997),
  [11765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7383),
  [11767] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3006),
  [11769] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1677),
  [11771] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4009),
  [11773] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7397),
  [11775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4687),
  [11777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7553),
  [11779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4026),
  [11781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7406),
  [11783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5630),
  [11785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7552),
  [11787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4071),
  [11789] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7415),
  [11791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1356),
  [11793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7551),
  [11795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4073),
  [11797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7424),
  [11799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1705),
  [11801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1320),
  [11803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4079),
  [11805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7433),
  [11807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3333),
  [11809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1709),
  [11811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4089),
  [11813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7442),
  [11815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2478),
  [11817] = {.entry = {.count = 1, .reusable = true}},  ACCEPT_INPUT(),
  [11819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4735),
  [11821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4733),
  [11823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3325),
  [11825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5592),
  [11827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3692),
  [11829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7550),
  [11831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3702),
  [11833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7063),
  [11835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3368),
  [11837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3082),
  [11839] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_compiler_directive_decl, 2, 0, 0),
  [11841] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block_comment, 3, 0, 0),
  [11843] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_compiler_directive_decl, 3, 0, 2),
  [11845] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_fsi_directive_decl, 3, 0, 2),
  [11847] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_line, 3, 0, 0),
  [11849] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_line, 4, 0, 4),
  [11851] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_line, 4, 0, 0),
};

enum ts_external_scanner_symbol_identifiers {
  ts_external_token__newline = 0,
  ts_external_token__indent = 1,
  ts_external_token__dedent = 2,
  ts_external_token_then = 3,
  ts_external_token_else = 4,
  ts_external_token_elif = 5,
  ts_external_token_POUNDif = 6,
  ts_external_token_POUNDelse = 7,
  ts_external_token_POUNDendif = 8,
  ts_external_token_class = 9,
  ts_external_token__struct_begin = 10,
  ts_external_token__interface_begin = 11,
  ts_external_token_end = 12,
  ts_external_token_and = 13,
  ts_external_token__triple_quoted_content = 14,
  ts_external_token_block_comment_content = 15,
  ts_external_token__inside_string_marker = 16,
  ts_external_token__newline_not_aligned = 17,
  ts_external_token__tuple_marker = 18,
  ts_external_token__error_sentinel = 19,
};

static const TSSymbol ts_external_scanner_symbol_map[EXTERNAL_TOKEN_COUNT] = {
  [ts_external_token__newline] = sym__newline,
  [ts_external_token__indent] = sym__indent,
  [ts_external_token__dedent] = sym__dedent,
  [ts_external_token_then] = anon_sym_then,
  [ts_external_token_else] = anon_sym_else,
  [ts_external_token_elif] = anon_sym_elif,
  [ts_external_token_POUNDif] = anon_sym_POUNDif,
  [ts_external_token_POUNDelse] = anon_sym_POUNDelse,
  [ts_external_token_POUNDendif] = anon_sym_POUNDendif,
  [ts_external_token_class] = anon_sym_class,
  [ts_external_token__struct_begin] = sym__struct_begin,
  [ts_external_token__interface_begin] = sym__interface_begin,
  [ts_external_token_end] = anon_sym_end,
  [ts_external_token_and] = anon_sym_and,
  [ts_external_token__triple_quoted_content] = sym__triple_quoted_content,
  [ts_external_token_block_comment_content] = sym_block_comment_content,
  [ts_external_token__inside_string_marker] = sym__inside_string_marker,
  [ts_external_token__newline_not_aligned] = sym__newline_not_aligned,
  [ts_external_token__tuple_marker] = sym__tuple_marker,
  [ts_external_token__error_sentinel] = sym__error_sentinel,
};

static const bool ts_external_scanner_states[32][EXTERNAL_TOKEN_COUNT] = {
  [1] = {
    [ts_external_token__newline] = true,
    [ts_external_token__indent] = true,
    [ts_external_token__dedent] = true,
    [ts_external_token_then] = true,
    [ts_external_token_else] = true,
    [ts_external_token_elif] = true,
    [ts_external_token_class] = true,
    [ts_external_token__struct_begin] = true,
    [ts_external_token__interface_begin] = true,
    [ts_external_token_end] = true,
    [ts_external_token_and] = true,
    [ts_external_token__triple_quoted_content] = true,
    [ts_external_token_block_comment_content] = true,
    [ts_external_token__inside_string_marker] = true,
    [ts_external_token__newline_not_aligned] = true,
    [ts_external_token__tuple_marker] = true,
    [ts_external_token__error_sentinel] = true,
  },
  [2] = {
    [ts_external_token__newline] = true,
    [ts_external_token__dedent] = true,
    [ts_external_token_POUNDif] = true,
  },
  [3] = {
    [ts_external_token__newline] = true,
    [ts_external_token_POUNDif] = true,
  },
  [4] = {
    [ts_external_token__newline] = true,
    [ts_external_token_POUNDif] = true,
    [ts_external_token_POUNDelse] = true,
    [ts_external_token_POUNDendif] = true,
  },
  [5] = {
    [ts_external_token__newline] = true,
    [ts_external_token__dedent] = true,
    [ts_external_token_POUNDif] = true,
    [ts_external_token_and] = true,
  },
  [6] = {
    [ts_external_token__newline] = true,
    [ts_external_token_POUNDif] = true,
    [ts_external_token_POUNDendif] = true,
  },
  [7] = {
    [ts_external_token_POUNDif] = true,
  },
  [8] = {
    [ts_external_token__dedent] = true,
    [ts_external_token_POUNDif] = true,
  },
  [9] = {
    [ts_external_token_POUNDif] = true,
    [ts_external_token__tuple_marker] = true,
  },
  [10] = {
    [ts_external_token__newline] = true,
    [ts_external_token__dedent] = true,
    [ts_external_token_else] = true,
    [ts_external_token_elif] = true,
    [ts_external_token_POUNDif] = true,
  },
  [11] = {
    [ts_external_token__newline] = true,
    [ts_external_token_else] = true,
    [ts_external_token_elif] = true,
    [ts_external_token_POUNDif] = true,
  },
  [12] = {
    [ts_external_token__newline] = true,
    [ts_external_token__dedent] = true,
    [ts_external_token_else] = true,
    [ts_external_token_elif] = true,
    [ts_external_token_POUNDif] = true,
    [ts_external_token_and] = true,
  },
  [13] = {
    [ts_external_token__newline] = true,
    [ts_external_token_else] = true,
    [ts_external_token_elif] = true,
    [ts_external_token_POUNDif] = true,
    [ts_external_token_POUNDelse] = true,
    [ts_external_token_POUNDendif] = true,
  },
  [14] = {
    [ts_external_token__newline] = true,
    [ts_external_token_else] = true,
    [ts_external_token_elif] = true,
    [ts_external_token_POUNDif] = true,
    [ts_external_token_POUNDendif] = true,
  },
  [15] = {
    [ts_external_token__newline] = true,
  },
  [16] = {
    [ts_external_token__newline] = true,
    [ts_external_token__dedent] = true,
  },
  [17] = {
    [ts_external_token_POUNDif] = true,
    [ts_external_token_and] = true,
  },
  [18] = {
    [ts_external_token__newline] = true,
    [ts_external_token_and] = true,
  },
  [19] = {
    [ts_external_token__newline] = true,
    [ts_external_token__dedent] = true,
    [ts_external_token_and] = true,
  },
  [20] = {
    [ts_external_token_and] = true,
  },
  [21] = {
    [ts_external_token__dedent] = true,
  },
  [22] = {
    [ts_external_token__inside_string_marker] = true,
  },
  [23] = {
    [ts_external_token__newline_not_aligned] = true,
  },
  [24] = {
    [ts_external_token__indent] = true,
  },
  [25] = {
    [ts_external_token__dedent] = true,
    [ts_external_token_and] = true,
  },
  [26] = {
    [ts_external_token__newline] = true,
    [ts_external_token__indent] = true,
  },
  [27] = {
    [ts_external_token_then] = true,
  },
  [28] = {
    [ts_external_token__triple_quoted_content] = true,
  },
  [29] = {
    [ts_external_token_POUNDendif] = true,
  },
  [30] = {
    [ts_external_token_end] = true,
  },
  [31] = {
    [ts_external_token_block_comment_content] = true,
  },
};

#ifdef __cplusplus
extern "C" {
#endif
void *tree_sitter_fsharp_signature_external_scanner_create(void);
void tree_sitter_fsharp_signature_external_scanner_destroy(void *);
bool tree_sitter_fsharp_signature_external_scanner_scan(void *, TSLexer *, const bool *);
unsigned tree_sitter_fsharp_signature_external_scanner_serialize(void *, char *);
void tree_sitter_fsharp_signature_external_scanner_deserialize(void *, const char *, unsigned);

#ifdef TREE_SITTER_HIDE_SYMBOLS
#define TS_PUBLIC
#elif defined(_WIN32)
#define TS_PUBLIC __declspec(dllexport)
#else
#define TS_PUBLIC __attribute__((visibility("default")))
#endif

TS_PUBLIC const TSLanguage *tree_sitter_fsharp_signature(void) {
  static const TSLanguage language = {
    .version = LANGUAGE_VERSION,
    .symbol_count = SYMBOL_COUNT,
    .alias_count = ALIAS_COUNT,
    .token_count = TOKEN_COUNT,
    .external_token_count = EXTERNAL_TOKEN_COUNT,
    .state_count = STATE_COUNT,
    .large_state_count = LARGE_STATE_COUNT,
    .production_id_count = PRODUCTION_ID_COUNT,
    .field_count = FIELD_COUNT,
    .max_alias_sequence_length = MAX_ALIAS_SEQUENCE_LENGTH,
    .parse_table = &ts_parse_table[0][0],
    .small_parse_table = ts_small_parse_table,
    .small_parse_table_map = ts_small_parse_table_map,
    .parse_actions = ts_parse_actions,
    .symbol_names = ts_symbol_names,
    .field_names = ts_field_names,
    .field_map_slices = ts_field_map_slices,
    .field_map_entries = ts_field_map_entries,
    .symbol_metadata = ts_symbol_metadata,
    .public_symbol_map = ts_symbol_map,
    .alias_map = ts_non_terminal_alias_map,
    .alias_sequences = &ts_alias_sequences[0][0],
    .lex_modes = ts_lex_modes,
    .lex_fn = ts_lex,
    .keyword_lex_fn = ts_lex_keywords,
    .keyword_capture_token = sym_identifier,
    .external_scanner = {
      &ts_external_scanner_states[0][0],
      ts_external_scanner_symbol_map,
      tree_sitter_fsharp_signature_external_scanner_create,
      tree_sitter_fsharp_signature_external_scanner_destroy,
      tree_sitter_fsharp_signature_external_scanner_scan,
      tree_sitter_fsharp_signature_external_scanner_serialize,
      tree_sitter_fsharp_signature_external_scanner_deserialize,
    },
    .primary_state_ids = ts_primary_state_ids,
  };
  return &language;
}
#ifdef __cplusplus
}
#endif
